diff --git a/Documentation/dontdiff b/Documentation/dontdiff
index afbf541de..1343357a2 100644
--- a/Documentation/dontdiff
+++ b/Documentation/dontdiff
@@ -7,6 +7,7 @@
 *.cis
 *.cpio
 *.csp
+*.dbg
 *.dsp
 *.dvi
 *.elf
@@ -16,6 +17,7 @@
 *.gcov
 *.gen.S
 *.gif
+*.gmo
 *.grep
 *.grp
 *.gz
@@ -52,14 +54,17 @@
 *.tab.h
 *.tex
 *.ver
+*.vim
 *.xml
 *.xz
 *_MODULES
+*_reg_safe.h
 *_vga16.c
 *~
 \#*#
 *.9
-.*
+.[^g]*
+.gen*
 .*.d
 .mm
 53c700_d.h
@@ -73,9 +78,11 @@ Image
 Module.markers
 Module.symvers
 PENDING
+PERF*
 SCCS
 System.map*
 TAGS
+TRACEEVENT-CFLAGS
 aconf
 af_names.h
 aic7*reg.h*
@@ -84,6 +91,7 @@ aic7*seq.h*
 aicasm
 aicdb.h*
 altivec*.c
+ashldi3.S
 asm-offsets.h
 asm_offsets.h
 autoconf.h*
@@ -96,11 +104,14 @@ bounds.h
 bsetup
 btfixupprep
 build
+builtin-policy.h
 bvmlinux
 bzImage*
 capability_names.h
 capflags.c
 classlist.h*
+clut_vga16.c
+common-cmds.h
 comp*.log
 compile.h*
 conf
@@ -109,19 +120,23 @@ config-*
 config_data.h*
 config.mak
 config.mak.autogen
+config.tmp
 conmakehash
 consolemap_deftbl.c*
 cpustr.h
 crc32table.h*
 cscope.*
 defkeymap.c
+devicetable-offsets.h
 devlist.h*
 dnotify_test
 docproc
 dslm
+dtc-lexer.lex.c
 elf2ecoff
 elfconfig.h*
 evergreen_reg_safe.h
+exception_policy.conf
 fixdep
 flask.h
 fore200e_mkfirm
@@ -129,12 +144,15 @@ fore200e_pca_fw.c*
 gconf
 gconf.glade.h
 gen-devlist
+gen-kdb_cmds.c
 gen_crc32table
 gen_init_cpio
 generated
 genheaders
 genksyms
 *_gray256.c
+hash
+hid-example
 hpet_example
 hugepage-mmap
 hugepage-shm
@@ -149,14 +167,14 @@ int32.c
 int4.c
 int8.c
 kallsyms
-kconfig
+kern_constants.h
 keywords.c
 ksym.c*
 ksym.h*
 kxgettext
 lex.c
 lex.*.c
-linux
+lib1funcs.S
 logo_*.c
 logo_*_clut224.c
 logo_*_mono.c
@@ -167,12 +185,14 @@ machtypes.h
 map
 map_hugetlb
 mconf
+mdp
 miboot*
 mk_elfconfig
 mkboot
 mkbugboot
 mkcpustr
 mkdep
+mkpiggy
 mkprep
 mkregtable
 mktables
@@ -188,6 +208,8 @@ oui.c*
 page-types
 parse.c
 parse.h
+parse-events*
+pasyms.h
 patches*
 /*(DEBLOBBED)*/
 /*(DEBLOBBED)*/
@@ -197,6 +219,7 @@ perf-archive
 piggyback
 piggy.gzip
 piggy.S
+pmu-*
 pnmtologo
 ppc_defs.h*
 pss_boot.h
@@ -206,7 +229,12 @@ r200_reg_safe.h
 r300_reg_safe.h
 r420_reg_safe.h
 r600_reg_safe.h
+randomize_layout_hash.h
+randomize_layout_seed.h
+realmode.lds
+realmode.relocs
 recordmcount
+regdb.c
 relocs
 rlim_names.h
 rn50_reg_safe.h
@@ -216,8 +244,17 @@ series
 setup
 setup.bin
 setup.elf
+signing_key*
+aux.h
+disable.h
+e_fields.h
+e_fns.h
+e_fptrs.h
+e_vars.h
 sImage
+slabinfo
 sm_tbl*
+sortextable
 split-include
 syscalltab.h
 tables.c
@@ -227,6 +264,7 @@ tftpboot.img
 timeconst.h
 times.h*
 trix_boot.h
+user_constants.h
 utsrelease.h*
 vdso-syms.lds
 vdso.lds
@@ -238,13 +276,17 @@ vdso32.lds
 vdso32.so.dbg
 vdso64.lds
 vdso64.so.dbg
+vdsox32.lds
+vdsox32-syms.lds
 version.h*
 vmImage
 vmlinux
 vmlinux-*
 vmlinux.aout
 vmlinux.bin.all
+vmlinux.bin.bz2
 vmlinux.lds
+vmlinux.relocs
 vmlinuz
 voffset.h
 vsyscall.lds
@@ -252,9 +294,12 @@ vsyscall_32.lds
 wanxlfw.inc
 uImage
 unifdef
+utsrelease.h
 wakeup.bin
 wakeup.elf
 wakeup.lds
+x509*
 zImage*
 zconf.hash.c
+zconf.lex.c
 zoffset.h
diff --git a/Documentation/kbuild/makefiles.txt b/Documentation/kbuild/makefiles.txt
index 385a5ef41..51d7fba37 100644
--- a/Documentation/kbuild/makefiles.txt
+++ b/Documentation/kbuild/makefiles.txt
@@ -23,10 +23,11 @@ This document describes the Linux kernel Makefiles.
 	=== 4 Host Program support
 	   --- 4.1 Simple Host Program
 	   --- 4.2 Composite Host Programs
-	   --- 4.3 Using C++ for host programs
-	   --- 4.4 Controlling compiler options for host programs
-	   --- 4.5 When host programs are actually built
-	   --- 4.6 Using hostprogs-$(CONFIG_FOO)
+	   --- 4.3 Defining shared libraries
+	   --- 4.4 Using C++ for host programs
+	   --- 4.5 Controlling compiler options for host programs
+	   --- 4.6 When host programs are actually built
+	   --- 4.7 Using hostprogs-$(CONFIG_FOO)
 
 	=== 5 Kbuild clean infrastructure
 
@@ -644,7 +645,29 @@ Both possibilities are described in the following.
 	Finally, the two .o files are linked to the executable, lxdialog.
 	Note: The syntax <executable>-y is not permitted for host-programs.
 
---- 4.3 Using C++ for host programs
+--- 4.3 Defining shared libraries
+
+	Objects with extension .so are considered shared libraries, and
+	will be compiled as position independent objects.
+	Kbuild provides support for shared libraries, but the usage
+	shall be restricted.
+	In the following example the libkconfig.so shared library is used
+	to link the executable conf.
+
+	Example:
+		#scripts/kconfig/Makefile
+		hostprogs-y     := conf
+		conf-objs       := conf.o libkconfig.so
+		libkconfig-objs := expr.o type.o
+
+	Shared libraries always require a corresponding -objs line, and
+	in the example above the shared library libkconfig is composed by
+	the two objects expr.o and type.o.
+	expr.o and type.o will be built as position independent code and
+	linked as a shared library libkconfig.so. C++ is not supported for
+	shared libraries.
+
+--- 4.4 Using C++ for host programs
 
 	kbuild offers support for host programs written in C++. This was
 	introduced solely to support kconfig, and is not recommended
@@ -667,7 +690,7 @@ Both possibilities are described in the following.
 		qconf-cxxobjs := qconf.o
 		qconf-objs    := check.o
 
---- 4.4 Controlling compiler options for host programs
+--- 4.5 Controlling compiler options for host programs
 
 	When compiling host programs, it is possible to set specific flags.
 	The programs will always be compiled utilising $(HOSTCC) passed
@@ -695,7 +718,7 @@ Both possibilities are described in the following.
 	When linking qconf, it will be passed the extra option
 	"-L$(QTDIR)/lib".
 
---- 4.5 When host programs are actually built
+--- 4.6 When host programs are actually built
 
 	Kbuild will only build host-programs when they are referenced
 	as a prerequisite.
@@ -726,7 +749,7 @@ Both possibilities are described in the following.
 	This will tell kbuild to build lxdialog even if not referenced in
 	any rule.
 
---- 4.6 Using hostprogs-$(CONFIG_FOO)
+--- 4.7 Using hostprogs-$(CONFIG_FOO)
 
 	A typical pattern in a Kbuild file looks like this:
 
diff --git a/Documentation/kernel-parameters.txt b/Documentation/kernel-parameters.txt
index 46726d489..36138ff07 100644
--- a/Documentation/kernel-parameters.txt
+++ b/Documentation/kernel-parameters.txt
@@ -1368,6 +1368,12 @@ bytes respectively. Such letter suffixes can also be entirely omitted.
 			[KNL] Should the hard-lockup detector generate
 			backtraces on all cpus.
 			Format: <integer>
+	grsec_proc_gid= [GRKERNSEC_PROC_USERGROUP] Chooses GID to
+			ignore grsecurity's /proc restrictions
+
+	grsec_sysfs_restrict= Format: 0 | 1
+			Default: 1
+			Disables GRKERNSEC_SYSFS_RESTRICT if enabled in config
 
 	hashdist=	[KNL,NUMA] Large hashes allocated during boot
 			are distributed across NUMA nodes.  Defaults on
@@ -2591,6 +2597,10 @@ bytes respectively. Such letter suffixes can also be entirely omitted.
 			noexec=on: enable non-executable mappings (default)
 			noexec=off: disable non-executable mappings
 
+	nopcid		[X86-64]
+			Disable PCID (Process-Context IDentifier) even if it
+			is supported by the processor.
+
 	nosmap		[X86]
 			Disable SMAP (Supervisor Mode Access Prevention)
 			even if it is supported by processor.
@@ -2895,6 +2905,35 @@ bytes respectively. Such letter suffixes can also be entirely omitted.
 			the specified number of seconds.  This is to be used if
 			your oopses keep scrolling off the screen.
 
+	pax_nouderef	[X86] disables UDEREF.  Most likely needed under certain
+			virtualization environments that don't cope well with the
+			expand down segment used by UDEREF on X86-32 or the frequent
+			page table updates on X86-64.
+
+	pax_sanitize_slab=
+			Format: { 0 | 1 | off | fast | full }
+			Options '0' and '1' are only provided for backward
+			compatibility, 'off' or 'fast' should be used instead.
+			0|off : disable slab object sanitization
+			1|fast: enable slab object sanitization excluding
+				whitelisted slabs (default)
+			full  : sanitize all slabs, even the whitelisted ones
+
+	pax_softmode=	0/1 to disable/enable PaX softmode on boot already.
+
+	pax_extra_latent_entropy
+			Enable a very simple form of latent entropy extraction
+			from the first 4GB of memory as the bootmem allocator
+			passes the memory pages to the buddy allocator.
+
+	pax_size_overflow_report_only
+			Enables rate-limited logging of size_overflow plugin
+			violations while disabling killing of the violating
+			task.
+
+	pax_weakuderef	[X86-64] enables the weaker but faster form of UDEREF
+			when the processor supports PCID.
+
 	pcbit=		[HW,ISDN]
 
 	pcd.		[PARIDE]
diff --git a/Documentation/sysctl/kernel.txt b/Documentation/sysctl/kernel.txt
index ffab8b5ca..b8fcd6113 100644
--- a/Documentation/sysctl/kernel.txt
+++ b/Documentation/sysctl/kernel.txt
@@ -42,6 +42,7 @@ show up in /proc/sys/kernel:
 - kptr_restrict
 - kstack_depth_to_print       [ X86 only ]
 - l2cr                        [ PPC only ]
+- modify_ldt                  [ X86 only ]
 - modprobe                    ==> Documentation/debugging-modules.txt
 - modules_disabled
 - msg_next_id		      [ sysv ipc ]
@@ -409,6 +410,20 @@ This flag controls the L2 cache of G3 processor boards. If
 
 ==============================================================
 
+modify_ldt: (X86 only)
+
+Enables (1) or disables (0) the modify_ldt syscall. Modifying the LDT
+(Local Descriptor Table) may be needed to run a 16-bit or segmented code
+such as Dosemu or Wine. This is done via a system call which is not needed
+to run portable applications, and which can sometimes be abused to exploit
+some weaknesses of the architecture, opening new vulnerabilities.
+
+This sysctl allows one to increase the system's security by disabling the
+system call, or to restore compatibility with specific applications when it
+was already disabled.
+
+==============================================================
+
 modules_disabled:
 
 A toggle value indicating if modules are allowed to be loaded
diff --git a/Makefile b/Makefile
index 36e7a8315..f9d369dc7 100644
--- a/Makefile
+++ b/Makefile
@@ -302,7 +302,9 @@ CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
 HOSTCC       = gcc
 HOSTCXX      = g++
 HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer -std=gnu89
-HOSTCXXFLAGS = -O2
+HOSTCFLAGS   = -W -Wno-unused-parameter -Wno-missing-field-initializers -fno-delete-null-pointer-checks
+HOSTCFLAGS  += $(call cc-option, -Wno-empty-body)
+HOSTCXXFLAGS = -O2 -Wall -W -Wno-array-bounds
 
 ifeq ($(shell $(HOSTCC) -v 2>&1 | grep -c "clang version"), 1)
 HOSTCFLAGS  += -Wno-unused-value -Wno-unused-parameter \
@@ -717,7 +719,7 @@ KBUILD_CFLAGS   += $(call cc-option, -gsplit-dwarf, -g)
 else
 KBUILD_CFLAGS	+= -g
 endif
-KBUILD_AFLAGS	+= -Wa,-gdwarf-2
+KBUILD_AFLAGS	+= -Wa,--gdwarf-2
 endif
 ifdef CONFIG_DEBUG_INFO_DWARF4
 KBUILD_CFLAGS	+= $(call cc-option, -gdwarf-4,)
@@ -892,7 +894,7 @@ export mod_sign_cmd
 
 
 ifeq ($(KBUILD_EXTMOD),)
-core-y		+= kernel/ certs/ mm/ fs/ ipc/ security/ crypto/ block/
+core-y		+= kernel/ certs/ mm/ fs/ ipc/ security/ crypto/ block/ grsecurity/
 
 vmlinux-dirs	:= $(patsubst %/,%,$(filter %/, $(init-y) $(init-m) \
 		     $(core-y) $(core-m) $(drivers-y) $(drivers-m) \
@@ -1258,7 +1260,10 @@ MRPROPER_FILES += .config .config.old .version .old_version \
 		  Module.symvers tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
 		  signing_key.pem signing_key.priv signing_key.x509	\
 		  x509.genkey extra_certificates signing_key.x509.keyid	\
-		  signing_key.x509.signer vmlinux-gdb.py
+		  signing_key.x509.signer vmlinux-gdb.py \
+		  scripts/gcc-plugins/size_overflow_plugin/e_*.h \
+		  scripts/gcc-plugins/size_overflow_plugin/disable.h \
+		  scripts/gcc-plugins/randomize_layout_seed.h
 
 # clean - Delete most, but leave enough to build external modules
 #
@@ -1297,7 +1302,7 @@ distclean: mrproper
 	@find $(srctree) $(RCS_FIND_IGNORE) \
 		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \
 		-o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
-		-o -name '.*.rej' -o -name '*%'  -o -name 'core' \) \
+		-o -name '.*.rej' -o -name '*.so' -o -name '*%' -o -name 'core' \) \
 		-type f -print | xargs rm -f
 
 
diff --git a/arch/Kconfig b/arch/Kconfig
index fd6e9712a..35d7bbfdd 100644
--- a/arch/Kconfig
+++ b/arch/Kconfig
@@ -355,7 +355,7 @@ config HAVE_GCC_PLUGINS
 menuconfig GCC_PLUGINS
 	bool "GCC plugins"
 	depends on HAVE_GCC_PLUGINS
-	depends on !COMPILE_TEST
+	default y
 	help
 	  GCC plugins are loadable modules that provide extra features to the
 	  compiler. They are useful for runtime instrumentation and static analysis.
diff --git a/arch/alpha/include/asm/atomic.h b/arch/alpha/include/asm/atomic.h
index 498933a7d..78d2b22fa 100644
--- a/arch/alpha/include/asm/atomic.h
+++ b/arch/alpha/include/asm/atomic.h
@@ -308,4 +308,14 @@ static inline long atomic64_dec_if_positive(atomic64_t *v)
 #define atomic_dec(v) atomic_sub(1,(v))
 #define atomic64_dec(v) atomic64_sub(1,(v))
 
+#define atomic64_read_unchecked(v)		atomic64_read(v)
+#define atomic64_set_unchecked(v, i)		atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v)		atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v)	atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v)		atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v)		atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v)	atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v)		atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n)	atomic64_cmpxchg((v), (o), (n))
+
 #endif /* _ALPHA_ATOMIC_H */
diff --git a/arch/alpha/include/asm/cache.h b/arch/alpha/include/asm/cache.h
index ad368a93a..fbe0f2514 100644
--- a/arch/alpha/include/asm/cache.h
+++ b/arch/alpha/include/asm/cache.h
@@ -4,19 +4,19 @@
 #ifndef __ARCH_ALPHA_CACHE_H
 #define __ARCH_ALPHA_CACHE_H
 
+#include <linux/const.h>
 
 /* Bytes per L1 (data) cache line. */
 #if defined(CONFIG_ALPHA_GENERIC) || defined(CONFIG_ALPHA_EV6)
-# define L1_CACHE_BYTES     64
 # define L1_CACHE_SHIFT     6
 #else
 /* Both EV4 and EV5 are write-through, read-allocate,
    direct-mapped, physical.
 */
-# define L1_CACHE_BYTES     32
 # define L1_CACHE_SHIFT     5
 #endif
 
+#define L1_CACHE_BYTES     (_AC(1,UL) << L1_CACHE_SHIFT)
 #define SMP_CACHE_BYTES    L1_CACHE_BYTES
 
 #endif
diff --git a/arch/alpha/include/asm/elf.h b/arch/alpha/include/asm/elf.h
index 968d9991f..d36b2df54 100644
--- a/arch/alpha/include/asm/elf.h
+++ b/arch/alpha/include/asm/elf.h
@@ -91,6 +91,13 @@ typedef elf_fpreg_t elf_fpregset_t[ELF_NFPREG];
 
 #define ELF_ET_DYN_BASE		(TASK_UNMAPPED_BASE + 0x1000000)
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(current->personality & ADDR_LIMIT_32BIT ? 0x10000 : 0x120000000UL)
+
+#define PAX_DELTA_MMAP_LEN	(current->personality & ADDR_LIMIT_32BIT ? 14 : 28)
+#define PAX_DELTA_STACK_LEN	(current->personality & ADDR_LIMIT_32BIT ? 14 : 19)
+#endif
+
 /* $0 is set by ld.so to a pointer to a function which might be 
    registered using atexit.  This provides a mean for the dynamic
    linker to call DT_FINI functions for shared libraries that have
diff --git a/arch/alpha/include/asm/pgalloc.h b/arch/alpha/include/asm/pgalloc.h
index c2ebb6f36..93a0613a2 100644
--- a/arch/alpha/include/asm/pgalloc.h
+++ b/arch/alpha/include/asm/pgalloc.h
@@ -29,6 +29,12 @@ pgd_populate(struct mm_struct *mm, pgd_t *pgd, pmd_t *pmd)
 	pgd_set(pgd, pmd);
 }
 
+static inline void
+pgd_populate_kernel(struct mm_struct *mm, pgd_t *pgd, pmd_t *pmd)
+{
+	pgd_populate(mm, pgd, pmd);
+}
+
 extern pgd_t *pgd_alloc(struct mm_struct *mm);
 
 static inline void
diff --git a/arch/alpha/include/asm/pgtable.h b/arch/alpha/include/asm/pgtable.h
index a9a119592..e9b84174e 100644
--- a/arch/alpha/include/asm/pgtable.h
+++ b/arch/alpha/include/asm/pgtable.h
@@ -101,6 +101,17 @@ struct vm_area_struct;
 #define PAGE_SHARED	__pgprot(_PAGE_VALID | __ACCESS_BITS)
 #define PAGE_COPY	__pgprot(_PAGE_VALID | __ACCESS_BITS | _PAGE_FOW)
 #define PAGE_READONLY	__pgprot(_PAGE_VALID | __ACCESS_BITS | _PAGE_FOW)
+
+#ifdef CONFIG_PAX_PAGEEXEC
+# define PAGE_SHARED_NOEXEC	__pgprot(_PAGE_VALID | __ACCESS_BITS | _PAGE_FOE)
+# define PAGE_COPY_NOEXEC	__pgprot(_PAGE_VALID | __ACCESS_BITS | _PAGE_FOW | _PAGE_FOE)
+# define PAGE_READONLY_NOEXEC	__pgprot(_PAGE_VALID | __ACCESS_BITS | _PAGE_FOW | _PAGE_FOE)
+#else
+# define PAGE_SHARED_NOEXEC	PAGE_SHARED
+# define PAGE_COPY_NOEXEC	PAGE_COPY
+# define PAGE_READONLY_NOEXEC	PAGE_READONLY
+#endif
+
 #define PAGE_KERNEL	__pgprot(_PAGE_VALID | _PAGE_ASM | _PAGE_KRE | _PAGE_KWE)
 
 #define _PAGE_NORMAL(x) __pgprot(_PAGE_VALID | __ACCESS_BITS | (x))
diff --git a/arch/alpha/kernel/module.c b/arch/alpha/kernel/module.c
index 936bc8f89..bb1859fb6 100644
--- a/arch/alpha/kernel/module.c
+++ b/arch/alpha/kernel/module.c
@@ -160,7 +160,7 @@ apply_relocate_add(Elf64_Shdr *sechdrs, const char *strtab,
 
 	/* The small sections were sorted to the end of the segment.
 	   The following should definitely cover them.  */
-	gp = (u64)me->core_layout.base + me->core_layout.size - 0x8000;
+	gp = (u64)me->core_layout.base_rw + me->core_layout.size_rw - 0x8000;
 	got = sechdrs[me->arch.gotsecindex].sh_addr;
 
 	for (i = 0; i < n; i++) {
diff --git a/arch/alpha/kernel/osf_sys.c b/arch/alpha/kernel/osf_sys.c
index ffb93f499..ced8233e7 100644
--- a/arch/alpha/kernel/osf_sys.c
+++ b/arch/alpha/kernel/osf_sys.c
@@ -1300,10 +1300,11 @@ SYSCALL_DEFINE1(old_adjtimex, struct timex32 __user *, txc_p)
    generic version except that we know how to honor ADDR_LIMIT_32BIT.  */
 
 static unsigned long
-arch_get_unmapped_area_1(unsigned long addr, unsigned long len,
-		         unsigned long limit)
+arch_get_unmapped_area_1(struct file *filp, unsigned long addr, unsigned long len,
+		         unsigned long limit, unsigned long flags)
 {
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(current->mm, filp, flags);
 
 	info.flags = 0;
 	info.length = len;
@@ -1311,6 +1312,7 @@ arch_get_unmapped_area_1(unsigned long addr, unsigned long len,
 	info.high_limit = limit;
 	info.align_mask = 0;
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	return vm_unmapped_area(&info);
 }
 
@@ -1343,20 +1345,24 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	   merely specific addresses, but regions of memory -- perhaps
 	   this feature should be incorporated into all ports?  */
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(current->mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
-		addr = arch_get_unmapped_area_1 (PAGE_ALIGN(addr), len, limit);
+		addr = arch_get_unmapped_area_1 (filp, PAGE_ALIGN(addr), len, limit, flags);
 		if (addr != (unsigned long) -ENOMEM)
 			return addr;
 	}
 
 	/* Next, try allocating at TASK_UNMAPPED_BASE.  */
-	addr = arch_get_unmapped_area_1 (PAGE_ALIGN(TASK_UNMAPPED_BASE),
-					 len, limit);
+	addr = arch_get_unmapped_area_1 (filp, PAGE_ALIGN(current->mm->mmap_base), len, limit, flags);
+
 	if (addr != (unsigned long) -ENOMEM)
 		return addr;
 
 	/* Finally, try allocating in low memory.  */
-	addr = arch_get_unmapped_area_1 (PAGE_SIZE, len, limit);
+	addr = arch_get_unmapped_area_1 (filp, PAGE_SIZE, len, limit, flags);
 
 	return addr;
 }
diff --git a/arch/alpha/mm/fault.c b/arch/alpha/mm/fault.c
index 83e9eee57..db02682e0 100644
--- a/arch/alpha/mm/fault.c
+++ b/arch/alpha/mm/fault.c
@@ -52,6 +52,124 @@ __load_new_mm_context(struct mm_struct *next_mm)
 	__reload_thread(pcb);
 }
 
+#ifdef CONFIG_PAX_PAGEEXEC
+/*
+ * PaX: decide what to do with offenders (regs->pc = fault address)
+ *
+ * returns 1 when task should be killed
+ *         2 when patched PLT trampoline was detected
+ *         3 when unpatched PLT trampoline was detected
+ */
+static int pax_handle_fetch_fault(struct pt_regs *regs)
+{
+
+#ifdef CONFIG_PAX_EMUPLT
+	int err;
+
+	do { /* PaX: patched PLT emulation #1 */
+		unsigned int ldah, ldq, jmp;
+
+		err = get_user(ldah, (unsigned int *)regs->pc);
+		err |= get_user(ldq, (unsigned int *)(regs->pc+4));
+		err |= get_user(jmp, (unsigned int *)(regs->pc+8));
+
+		if (err)
+			break;
+
+		if ((ldah & 0xFFFF0000U) == 0x277B0000U &&
+		    (ldq & 0xFFFF0000U) == 0xA77B0000U &&
+		    jmp == 0x6BFB0000U)
+		{
+			unsigned long r27, addr;
+			unsigned long addrh = (ldah | 0xFFFFFFFFFFFF0000UL) << 16;
+			unsigned long addrl = ldq | 0xFFFFFFFFFFFF0000UL;
+
+			addr = regs->r27 + ((addrh ^ 0x80000000UL) + 0x80000000UL) + ((addrl ^ 0x8000UL) + 0x8000UL);
+			err = get_user(r27, (unsigned long *)addr);
+			if (err)
+				break;
+
+			regs->r27 = r27;
+			regs->pc = r27;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #2 */
+		unsigned int ldah, lda, br;
+
+		err = get_user(ldah, (unsigned int *)regs->pc);
+		err |= get_user(lda, (unsigned int *)(regs->pc+4));
+		err |= get_user(br, (unsigned int *)(regs->pc+8));
+
+		if (err)
+			break;
+
+		if ((ldah & 0xFFFF0000U) == 0x277B0000U &&
+		    (lda & 0xFFFF0000U) == 0xA77B0000U &&
+		    (br & 0xFFE00000U) == 0xC3E00000U)
+		{
+			unsigned long addr = br | 0xFFFFFFFFFFE00000UL;
+			unsigned long addrh = (ldah | 0xFFFFFFFFFFFF0000UL) << 16;
+			unsigned long addrl = lda | 0xFFFFFFFFFFFF0000UL;
+
+			regs->r27 += ((addrh ^ 0x80000000UL) + 0x80000000UL) + ((addrl ^ 0x8000UL) + 0x8000UL);
+			regs->pc += 12 + (((addr ^ 0x00100000UL) + 0x00100000UL) << 2);
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: unpatched PLT emulation */
+		unsigned int br;
+
+		err = get_user(br, (unsigned int *)regs->pc);
+
+		if (!err && (br & 0xFFE00000U) == 0xC3800000U) {
+			unsigned int br2, ldq, nop, jmp;
+			unsigned long addr = br | 0xFFFFFFFFFFE00000UL, resolver;
+
+			addr = regs->pc + 4 + (((addr ^ 0x00100000UL) + 0x00100000UL) << 2);
+			err = get_user(br2, (unsigned int *)addr);
+			err |= get_user(ldq, (unsigned int *)(addr+4));
+			err |= get_user(nop, (unsigned int *)(addr+8));
+			err |= get_user(jmp, (unsigned int *)(addr+12));
+			err |= get_user(resolver, (unsigned long *)(addr+16));
+
+			if (err)
+				break;
+
+			if (br2 == 0xC3600000U &&
+			    ldq == 0xA77B000CU &&
+			    nop == 0x47FF041FU &&
+			    jmp == 0x6B7B0000U)
+			{
+				regs->r28 = regs->pc+4;
+				regs->r27 = addr+16;
+				regs->pc = resolver;
+				return 3;
+			}
+		}
+	} while (0);
+#endif
+
+	return 1;
+}
+
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 5; i++) {
+		unsigned int c;
+		if (get_user(c, (unsigned int *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08x ", c);
+	}
+	printk("\n");
+}
+#endif
 
 /*
  * This routine handles page faults.  It determines the address,
@@ -132,8 +250,29 @@ retry:
  good_area:
 	si_code = SEGV_ACCERR;
 	if (cause < 0) {
-		if (!(vma->vm_flags & VM_EXEC))
+		if (!(vma->vm_flags & VM_EXEC)) {
+
+#ifdef CONFIG_PAX_PAGEEXEC
+			if (!(mm->pax_flags & MF_PAX_PAGEEXEC) || address != regs->pc)
+				goto bad_area;
+
+			up_read(&mm->mmap_sem);
+			switch (pax_handle_fetch_fault(regs)) {
+
+#ifdef CONFIG_PAX_EMUPLT
+			case 2:
+			case 3:
+				return;
+#endif
+
+			}
+			pax_report_fault(regs, (void *)regs->pc, (void *)rdusp());
+			do_group_exit(SIGKILL);
+#else
 			goto bad_area;
+#endif
+
+		}
 	} else if (!cause) {
 		/* Allow reads even for write-only mappings */
 		if (!(vma->vm_flags & (VM_READ | VM_WRITE)))
diff --git a/arch/arc/Kconfig b/arch/arc/Kconfig
index 0d3e59f56..4418d65a6 100644
--- a/arch/arc/Kconfig
+++ b/arch/arc/Kconfig
@@ -541,6 +541,7 @@ config ARC_DBG_TLB_MISS_COUNT
 	bool "Profile TLB Misses"
 	default n
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	help
 	  Counts number of I and D TLB Misses and exports them via Debugfs
 	  The counters can be cleared via Debugfs as well
diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index a9c4e48bb..75bc9c9a1 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -1621,6 +1621,7 @@ config AEABI
 config OABI_COMPAT
 	bool "Allow old ABI binaries to run with this kernel (EXPERIMENTAL)"
 	depends on AEABI && !THUMB2_KERNEL
+	depends on !GRKERNSEC
 	help
 	  This option preserves the old syscall interface along with the
 	  new (ARM EABI) one. It also provides a compatibility layer to
@@ -1689,6 +1690,7 @@ config HIGHPTE
 config CPU_SW_DOMAIN_PAN
 	bool "Enable use of CPU domains to implement privileged no-access"
 	depends on MMU && !ARM_LPAE
+	depends on !PAX_KERNEXEC && !PAX_MEMORY_UDEREF
 	default y
 	help
 	  Increase kernel security by ensuring that normal kernel accesses
@@ -1765,7 +1767,7 @@ config ALIGNMENT_TRAP
 
 config UACCESS_WITH_MEMCPY
 	bool "Use kernel mem{cpy,set}() for {copy_to,clear}_user()"
-	depends on MMU
+	depends on MMU && !PAX_MEMORY_UDEREF
 	default y if CPU_FEROCEON
 	help
 	  Implement faster copy_to_user and clear_user methods for CPU
@@ -2020,6 +2022,7 @@ config KEXEC
 	depends on (!SMP || PM_SLEEP_SMP)
 	depends on !CPU_V7M
 	select KEXEC_CORE
+	depends on !GRKERNSEC_KMEM
 	help
 	  kexec is a system call that implements the ability to shutdown your
 	  current kernel, and to start another kernel.  It is like a reboot
@@ -2064,7 +2067,7 @@ config EFI_STUB
 
 config EFI
 	bool "UEFI runtime support"
-	depends on OF && !CPU_BIG_ENDIAN && MMU && AUTO_ZRELADDR && !XIP_KERNEL
+	depends on OF && !CPU_BIG_ENDIAN && MMU && AUTO_ZRELADDR && !XIP_KERNEL && !PAX_KERNEXEC
 	select UCS2_STRING
 	select EFI_PARAMS_FROM_FDT
 	select EFI_STUB
diff --git a/arch/arm/Kconfig.debug b/arch/arm/Kconfig.debug
index a9693b698..87d893694 100644
--- a/arch/arm/Kconfig.debug
+++ b/arch/arm/Kconfig.debug
@@ -7,6 +7,7 @@ config ARM_PTDUMP
 	depends on DEBUG_KERNEL
 	depends on MMU
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	---help---
 	  Say Y here if you want to show the kernel pagetable layout in a
 	  debugfs file. This information is only useful for kernel developers
diff --git a/arch/arm/boot/compressed/Makefile b/arch/arm/boot/compressed/Makefile
index d50430c40..01cc53bb3 100644
--- a/arch/arm/boot/compressed/Makefile
+++ b/arch/arm/boot/compressed/Makefile
@@ -103,6 +103,8 @@ ORIG_CFLAGS := $(KBUILD_CFLAGS)
 KBUILD_CFLAGS = $(subst -pg, , $(ORIG_CFLAGS))
 endif
 
+KBUILD_CFLAGS := $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
+
 # -fstack-protector-strong triggers protection checks in this code,
 # but it is being used too early to link to meaningful stack_chk logic.
 nossp_flags := $(call cc-option, -fno-stack-protector)
diff --git a/arch/arm/crypto/sha1_glue.c b/arch/arm/crypto/sha1_glue.c
index 6fc73bf87..d0af3c7b6 100644
--- a/arch/arm/crypto/sha1_glue.c
+++ b/arch/arm/crypto/sha1_glue.c
@@ -27,8 +27,8 @@
 
 #include "sha1.h"
 
-asmlinkage void sha1_block_data_order(u32 *digest,
-		const unsigned char *data, unsigned int rounds);
+asmlinkage void sha1_block_data_order(struct sha1_state *digest,
+		const u8 *data, int rounds);
 
 int sha1_update_arm(struct shash_desc *desc, const u8 *data,
 		    unsigned int len)
@@ -36,22 +36,20 @@ int sha1_update_arm(struct shash_desc *desc, const u8 *data,
 	/* make sure casting to sha1_block_fn() is safe */
 	BUILD_BUG_ON(offsetof(struct sha1_state, state) != 0);
 
-	return sha1_base_do_update(desc, data, len,
-				   (sha1_block_fn *)sha1_block_data_order);
+	return sha1_base_do_update(desc, data, len, sha1_block_data_order);
 }
 EXPORT_SYMBOL_GPL(sha1_update_arm);
 
 static int sha1_final(struct shash_desc *desc, u8 *out)
 {
-	sha1_base_do_finalize(desc, (sha1_block_fn *)sha1_block_data_order);
+	sha1_base_do_finalize(desc, sha1_block_data_order);
 	return sha1_base_finish(desc, out);
 }
 
 int sha1_finup_arm(struct shash_desc *desc, const u8 *data,
 		   unsigned int len, u8 *out)
 {
-	sha1_base_do_update(desc, data, len,
-			    (sha1_block_fn *)sha1_block_data_order);
+	sha1_base_do_update(desc, data, len, sha1_block_data_order);
 	return sha1_final(desc, out);
 }
 EXPORT_SYMBOL_GPL(sha1_finup_arm);
diff --git a/arch/arm/crypto/sha1_neon_glue.c b/arch/arm/crypto/sha1_neon_glue.c
index 4e22f122f..49902aa8d 100644
--- a/arch/arm/crypto/sha1_neon_glue.c
+++ b/arch/arm/crypto/sha1_neon_glue.c
@@ -31,8 +31,8 @@
 
 #include "sha1.h"
 
-asmlinkage void sha1_transform_neon(void *state_h, const char *data,
-				    unsigned int rounds);
+asmlinkage void sha1_transform_neon(struct sha1_state *state_h, const u8 *data,
+				    int rounds);
 
 static int sha1_neon_update(struct shash_desc *desc, const u8 *data,
 			  unsigned int len)
@@ -45,7 +45,7 @@ static int sha1_neon_update(struct shash_desc *desc, const u8 *data,
 
 	kernel_neon_begin();
 	sha1_base_do_update(desc, data, len,
-			    (sha1_block_fn *)sha1_transform_neon);
+			    sha1_transform_neon);
 	kernel_neon_end();
 
 	return 0;
@@ -60,8 +60,8 @@ static int sha1_neon_finup(struct shash_desc *desc, const u8 *data,
 	kernel_neon_begin();
 	if (len)
 		sha1_base_do_update(desc, data, len,
-				    (sha1_block_fn *)sha1_transform_neon);
-	sha1_base_do_finalize(desc, (sha1_block_fn *)sha1_transform_neon);
+				    sha1_transform_neon);
+	sha1_base_do_finalize(desc, sha1_transform_neon);
 	kernel_neon_end();
 
 	return sha1_base_finish(desc, out);
diff --git a/arch/arm/crypto/sha256_glue.c b/arch/arm/crypto/sha256_glue.c
index a84e869ef..53a0c6107 100644
--- a/arch/arm/crypto/sha256_glue.c
+++ b/arch/arm/crypto/sha256_glue.c
@@ -30,8 +30,8 @@
 
 #include "sha256_glue.h"
 
-asmlinkage void sha256_block_data_order(u32 *digest, const void *data,
-					unsigned int num_blks);
+asmlinkage void sha256_block_data_order(struct sha256_state *digest, const u8 *data,
+					int num_blks);
 
 int crypto_sha256_arm_update(struct shash_desc *desc, const u8 *data,
 			     unsigned int len)
@@ -39,23 +39,20 @@ int crypto_sha256_arm_update(struct shash_desc *desc, const u8 *data,
 	/* make sure casting to sha256_block_fn() is safe */
 	BUILD_BUG_ON(offsetof(struct sha256_state, state) != 0);
 
-	return sha256_base_do_update(desc, data, len,
-				(sha256_block_fn *)sha256_block_data_order);
+	return sha256_base_do_update(desc, data, len, sha256_block_data_order);
 }
 EXPORT_SYMBOL(crypto_sha256_arm_update);
 
 static int sha256_final(struct shash_desc *desc, u8 *out)
 {
-	sha256_base_do_finalize(desc,
-				(sha256_block_fn *)sha256_block_data_order);
+	sha256_base_do_finalize(desc, sha256_block_data_order);
 	return sha256_base_finish(desc, out);
 }
 
 int crypto_sha256_arm_finup(struct shash_desc *desc, const u8 *data,
 			    unsigned int len, u8 *out)
 {
-	sha256_base_do_update(desc, data, len,
-			      (sha256_block_fn *)sha256_block_data_order);
+	sha256_base_do_update(desc, data, len, sha256_block_data_order);
 	return sha256_final(desc, out);
 }
 EXPORT_SYMBOL(crypto_sha256_arm_finup);
diff --git a/arch/arm/crypto/sha256_neon_glue.c b/arch/arm/crypto/sha256_neon_glue.c
index 39ccd6588..f9511cbdf 100644
--- a/arch/arm/crypto/sha256_neon_glue.c
+++ b/arch/arm/crypto/sha256_neon_glue.c
@@ -26,8 +26,8 @@
 
 #include "sha256_glue.h"
 
-asmlinkage void sha256_block_data_order_neon(u32 *digest, const void *data,
-					     unsigned int num_blks);
+asmlinkage void sha256_block_data_order_neon(struct sha256_state *digest, const u8 *data,
+					     int num_blks);
 
 static int sha256_update(struct shash_desc *desc, const u8 *data,
 			 unsigned int len)
@@ -39,8 +39,7 @@ static int sha256_update(struct shash_desc *desc, const u8 *data,
 		return crypto_sha256_arm_update(desc, data, len);
 
 	kernel_neon_begin();
-	sha256_base_do_update(desc, data, len,
-			(sha256_block_fn *)sha256_block_data_order_neon);
+	sha256_base_do_update(desc, data, len, sha256_block_data_order_neon);
 	kernel_neon_end();
 
 	return 0;
@@ -54,10 +53,8 @@ static int sha256_finup(struct shash_desc *desc, const u8 *data,
 
 	kernel_neon_begin();
 	if (len)
-		sha256_base_do_update(desc, data, len,
-			(sha256_block_fn *)sha256_block_data_order_neon);
-	sha256_base_do_finalize(desc,
-			(sha256_block_fn *)sha256_block_data_order_neon);
+		sha256_base_do_update(desc, data, len, sha256_block_data_order_neon);
+	sha256_base_do_finalize(desc, sha256_block_data_order_neon);
 	kernel_neon_end();
 
 	return sha256_base_finish(desc, out);
diff --git a/arch/arm/crypto/sha512-glue.c b/arch/arm/crypto/sha512-glue.c
index 269a394e4..c7a91f1be 100644
--- a/arch/arm/crypto/sha512-glue.c
+++ b/arch/arm/crypto/sha512-glue.c
@@ -28,27 +28,24 @@ MODULE_ALIAS_CRYPTO("sha512");
 MODULE_ALIAS_CRYPTO("sha384-arm");
 MODULE_ALIAS_CRYPTO("sha512-arm");
 
-asmlinkage void sha512_block_data_order(u64 *state, u8 const *src, int blocks);
+asmlinkage void sha512_block_data_order(struct sha512_state *state, u8 const *src, int blocks);
 
 int sha512_arm_update(struct shash_desc *desc, const u8 *data,
 		      unsigned int len)
 {
-	return sha512_base_do_update(desc, data, len,
-		(sha512_block_fn *)sha512_block_data_order);
+	return sha512_base_do_update(desc, data, len, sha512_block_data_order);
 }
 
 int sha512_arm_final(struct shash_desc *desc, u8 *out)
 {
-	sha512_base_do_finalize(desc,
-		(sha512_block_fn *)sha512_block_data_order);
+	sha512_base_do_finalize(desc, sha512_block_data_order);
 	return sha512_base_finish(desc, out);
 }
 
 int sha512_arm_finup(struct shash_desc *desc, const u8 *data,
 		     unsigned int len, u8 *out)
 {
-	sha512_base_do_update(desc, data, len,
-		(sha512_block_fn *)sha512_block_data_order);
+	sha512_base_do_update(desc, data, len, sha512_block_data_order);
 	return sha512_arm_final(desc, out);
 }
 
diff --git a/arch/arm/crypto/sha512-neon-glue.c b/arch/arm/crypto/sha512-neon-glue.c
index 32693684a..9fcbc0079 100644
--- a/arch/arm/crypto/sha512-neon-glue.c
+++ b/arch/arm/crypto/sha512-neon-glue.c
@@ -22,7 +22,7 @@
 MODULE_ALIAS_CRYPTO("sha384-neon");
 MODULE_ALIAS_CRYPTO("sha512-neon");
 
-asmlinkage void sha512_block_data_order_neon(u64 *state, u8 const *src,
+asmlinkage void sha512_block_data_order_neon(struct sha512_state *state, u8 const *src,
 					     int blocks);
 
 static int sha512_neon_update(struct shash_desc *desc, const u8 *data,
@@ -35,8 +35,7 @@ static int sha512_neon_update(struct shash_desc *desc, const u8 *data,
 		return sha512_arm_update(desc, data, len);
 
 	kernel_neon_begin();
-	sha512_base_do_update(desc, data, len,
-		(sha512_block_fn *)sha512_block_data_order_neon);
+	sha512_base_do_update(desc, data, len, sha512_block_data_order_neon);
 	kernel_neon_end();
 
 	return 0;
@@ -50,10 +49,8 @@ static int sha512_neon_finup(struct shash_desc *desc, const u8 *data,
 
 	kernel_neon_begin();
 	if (len)
-		sha512_base_do_update(desc, data, len,
-			(sha512_block_fn *)sha512_block_data_order_neon);
-	sha512_base_do_finalize(desc,
-		(sha512_block_fn *)sha512_block_data_order_neon);
+		sha512_base_do_update(desc, data, len, sha512_block_data_order_neon);
+	sha512_base_do_finalize(desc, sha512_block_data_order_neon);
 	kernel_neon_end();
 
 	return sha512_base_finish(desc, out);
diff --git a/arch/arm/include/asm/atomic.h b/arch/arm/include/asm/atomic.h
index 66d0e215a..8fa3237d4 100644
--- a/arch/arm/include/asm/atomic.h
+++ b/arch/arm/include/asm/atomic.h
@@ -18,17 +18,41 @@
 #include <asm/barrier.h>
 #include <asm/cmpxchg.h>
 
+#ifdef CONFIG_GENERIC_ATOMIC64
+#include <asm-generic/atomic64.h>
+#endif
+
 #define ATOMIC_INIT(i)	{ (i) }
 
 #ifdef __KERNEL__
 
+#ifdef CONFIG_THUMB2_KERNEL
+#define REFCOUNT_TRAP_INSN "bkpt	0xf1"
+#else
+#define REFCOUNT_TRAP_INSN "bkpt	0xf103"
+#endif
+
+#define _ASM_EXTABLE(from, to)		\
+"	.pushsection __ex_table,\"a\"\n"\
+"	.align	3\n"			\
+"	.long	" #from ", " #to"\n"	\
+"	.popsection"
+
 /*
  * On ARM, ordinary assignment (str instruction) doesn't clear the local
  * strex/ldrex monitor on some implementations. The reason we can use it for
  * atomic_set() is the clrex or dummy strex done on every exception return.
  */
 #define atomic_read(v)	READ_ONCE((v)->counter)
+static inline int atomic_read_unchecked(const atomic_unchecked_t *v)
+{
+	return READ_ONCE(v->counter);
+}
 #define atomic_set(v,i)	WRITE_ONCE(((v)->counter), (i))
+static inline void atomic_set_unchecked(atomic_unchecked_t *v, int i)
+{
+	WRITE_ONCE(v->counter, i);
+}
 
 #if __LINUX_ARM_ARCH__ >= 6
 
@@ -38,45 +62,74 @@
  * to ensure that the update happens.
  */
 
-#define ATOMIC_OP(op, c_op, asm_op)					\
-static inline void atomic_##op(int i, atomic_t *v)			\
+#ifdef CONFIG_PAX_REFCOUNT
+#define __OVERFLOW_POST			\
+	"	bvc	3f\n"		\
+	"2:	" REFCOUNT_TRAP_INSN "\n"\
+	"3:\n"
+#define __OVERFLOW_POST_RETURN		\
+	"	bvc	3f\n"		\
+	"	mov	%1, %0\n"	\
+	"2:	" REFCOUNT_TRAP_INSN "\n"\
+	"3:\n"
+#define __OVERFLOW_EXTABLE		\
+	"4:\n"				\
+	_ASM_EXTABLE(2b, 4b)
+#else
+#define __OVERFLOW_POST
+#define __OVERFLOW_POST_RETURN
+#define __OVERFLOW_EXTABLE
+#endif
+
+#define __ATOMIC_OP(op, suffix, c_op, asm_op)				\
+static inline void atomic_##op##suffix(int i, atomic##suffix##_t *v)	\
 {									\
 	unsigned long tmp;						\
 	int result;							\
 									\
 	prefetchw(&v->counter);						\
-	__asm__ __volatile__("@ atomic_" #op "\n"			\
+	__asm__ __volatile__("@ atomic_" #op #suffix "\n"		\
 "1:	ldrex	%0, [%3]\n"						\
 "	" #asm_op "	%0, %0, %4\n"					\
+	__OVERFLOW_POST							\
 "	strex	%1, %0, [%3]\n"						\
 "	teq	%1, #0\n"						\
-"	bne	1b"							\
+"	bne	1b\n"							\
+	__OVERFLOW_EXTABLE						\
 	: "=&r" (result), "=&r" (tmp), "+Qo" (v->counter)		\
 	: "r" (&v->counter), "Ir" (i)					\
 	: "cc");							\
 }									\
 
-#define ATOMIC_OP_RETURN(op, c_op, asm_op)				\
-static inline int atomic_##op##_return_relaxed(int i, atomic_t *v)	\
+#define ATOMIC_OP(op, c_op, asm_op) __ATOMIC_OP(op, _unchecked, c_op, asm_op)\
+				    __ATOMIC_OP(op, , c_op, asm_op##s)
+
+#define __ATOMIC_OP_RETURN(op, suffix, c_op, asm_op)			\
+static inline int atomic_##op##_return##suffix##_relaxed(int i, atomic##suffix##_t *v)\
 {									\
-	unsigned long tmp;						\
+	int tmp;							\
 	int result;							\
 									\
 	prefetchw(&v->counter);						\
 									\
-	__asm__ __volatile__("@ atomic_" #op "_return\n"		\
+	__asm__ __volatile__("@ atomic_" #op "_return" #suffix "\n"	\
 "1:	ldrex	%0, [%3]\n"						\
-"	" #asm_op "	%0, %0, %4\n"					\
-"	strex	%1, %0, [%3]\n"						\
-"	teq	%1, #0\n"						\
-"	bne	1b"							\
-	: "=&r" (result), "=&r" (tmp), "+Qo" (v->counter)		\
+"	" #asm_op "	%1, %0, %4\n"					\
+	__OVERFLOW_POST_RETURN						\
+"	strex	%0, %1, [%3]\n"						\
+"	teq	%0, #0\n"						\
+"	bne	1b\n"							\
+	__OVERFLOW_EXTABLE						\
+	: "=&r" (tmp), "=&r" (result), "+Qo" (v->counter)		\
 	: "r" (&v->counter), "Ir" (i)					\
 	: "cc");							\
 									\
 	return result;							\
 }
 
+#define ATOMIC_OP_RETURN(op, c_op, asm_op) __ATOMIC_OP_RETURN(op, _unchecked, c_op, asm_op)\
+					   __ATOMIC_OP_RETURN(op, , c_op, asm_op##s)
+
 #define ATOMIC_FETCH_OP(op, c_op, asm_op)				\
 static inline int atomic_fetch_##op##_relaxed(int i, atomic_t *v)	\
 {									\
@@ -99,6 +152,7 @@ static inline int atomic_fetch_##op##_relaxed(int i, atomic_t *v)	\
 }
 
 #define atomic_add_return_relaxed	atomic_add_return_relaxed
+#define atomic_add_return_unchecked_relaxed	atomic_add_return_unchecked_relaxed
 #define atomic_sub_return_relaxed	atomic_sub_return_relaxed
 #define atomic_fetch_add_relaxed	atomic_fetch_add_relaxed
 #define atomic_fetch_sub_relaxed	atomic_fetch_sub_relaxed
@@ -141,12 +195,17 @@ static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 	__asm__ __volatile__ ("@ atomic_add_unless\n"
 "1:	ldrex	%0, [%4]\n"
 "	teq	%0, %5\n"
-"	beq	2f\n"
-"	add	%1, %0, %6\n"
+"	beq	4f\n"
+"	adds	%1, %0, %6\n"
+
+	__OVERFLOW_POST
+
 "	strex	%2, %1, [%4]\n"
 "	teq	%2, #0\n"
 "	bne	1b\n"
-"2:"
+
+	__OVERFLOW_EXTABLE
+
 	: "=&r" (oldval), "=&r" (newval), "=&r" (tmp), "+Qo" (v->counter)
 	: "r" (&v->counter), "r" (u), "r" (a)
 	: "cc");
@@ -157,14 +216,36 @@ static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 	return oldval;
 }
 
+static inline int atomic_cmpxchg_unchecked(atomic_unchecked_t *ptr, int old, int new)
+{
+	unsigned long oldval, res;
+
+	smp_mb();
+
+	do {
+		__asm__ __volatile__("@ atomic_cmpxchg_unchecked\n"
+		"ldrex	%1, [%3]\n"
+		"mov	%0, #0\n"
+		"teq	%1, %4\n"
+		"strexeq %0, %5, [%3]\n"
+		    : "=&r" (res), "=&r" (oldval), "+Qo" (ptr->counter)
+		    : "r" (&ptr->counter), "Ir" (old), "r" (new)
+		    : "cc");
+	} while (res);
+
+	smp_mb();
+
+	return oldval;
+}
+
 #else /* ARM_ARCH_6 */
 
 #ifdef CONFIG_SMP
 #error SMP not supported on pre-ARMv6 CPUs
 #endif
 
-#define ATOMIC_OP(op, c_op, asm_op)					\
-static inline void atomic_##op(int i, atomic_t *v)			\
+#define __ATOMIC_OP(op, suffix, c_op, asm_op)				\
+static inline void atomic_##op##suffix(int i, atomic##suffix##_t *v)	\
 {									\
 	unsigned long flags;						\
 									\
@@ -173,8 +254,11 @@ static inline void atomic_##op(int i, atomic_t *v)			\
 	raw_local_irq_restore(flags);					\
 }									\
 
-#define ATOMIC_OP_RETURN(op, c_op, asm_op)				\
-static inline int atomic_##op##_return(int i, atomic_t *v)		\
+#define ATOMIC_OP(op, c_op, asm_op) __ATOMIC_OP(op, , c_op, asm_op)	\
+				    __ATOMIC_OP(op, _unchecked, c_op, asm_op)
+
+#define __ATOMIC_OP_RETURN(op, suffix, c_op, asm_op)			\
+static inline int atomic_##op##_return##suffix(int i, atomic##suffix##_t *v)\
 {									\
 	unsigned long flags;						\
 	int val;							\
@@ -201,6 +285,9 @@ static inline int atomic_fetch_##op(int i, atomic_t *v)			\
 	return val;							\
 }
 
+#define ATOMIC_OP_RETURN(op, c_op, asm_op) __ATOMIC_OP_RETURN(op, , c_op, asm_op)\
+					   __ATOMIC_OP_RETURN(op, _unchecked, c_op, asm_op)
+
 static inline int atomic_cmpxchg(atomic_t *v, int old, int new)
 {
 	int ret;
@@ -215,6 +302,11 @@ static inline int atomic_cmpxchg(atomic_t *v, int old, int new)
 	return ret;
 }
 
+static inline int atomic_cmpxchg_unchecked(atomic_unchecked_t *v, int old, int new)
+{
+	return atomic_cmpxchg((atomic_t *)v, old, new);
+}
+
 static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int c, old;
@@ -250,16 +342,29 @@ ATOMIC_OPS(xor, ^=, eor)
 #undef ATOMIC_OPS
 #undef ATOMIC_FETCH_OP
 #undef ATOMIC_OP_RETURN
+#undef __ATOMIC_OP_RETURN
 #undef ATOMIC_OP
+#undef __ATOMIC_OP
 
 #define atomic_xchg(v, new) (xchg(&((v)->counter), new))
+#define atomic_xchg_unchecked(v, new) (xchg_unchecked(&((v)->counter), new))
 
 #define atomic_inc(v)		atomic_add(1, v)
+static inline void atomic_inc_unchecked(atomic_unchecked_t *v)
+{
+	atomic_add_unchecked(1, v);
+}
 #define atomic_dec(v)		atomic_sub(1, v)
+static inline void atomic_dec_unchecked(atomic_unchecked_t *v)
+{
+	atomic_sub_unchecked(1, v);
+}
 
 #define atomic_inc_and_test(v)	(atomic_add_return(1, v) == 0)
+#define atomic_inc_and_test_unchecked(v)	(atomic_add_return_unchecked(1, v) == 0)
 #define atomic_dec_and_test(v)	(atomic_sub_return(1, v) == 0)
 #define atomic_inc_return_relaxed(v)    (atomic_add_return_relaxed(1, v))
+#define atomic_inc_return_unchecked_relaxed(v)    (atomic_add_return_unchecked_relaxed(1, v))
 #define atomic_dec_return_relaxed(v)    (atomic_sub_return_relaxed(1, v))
 #define atomic_sub_and_test(i, v) (atomic_sub_return(i, v) == 0)
 
@@ -270,6 +375,14 @@ typedef struct {
 	long long counter;
 } atomic64_t;
 
+#ifdef CONFIG_PAX_REFCOUNT
+typedef struct {
+	long long counter;
+} atomic64_unchecked_t;
+#else
+typedef atomic64_t atomic64_unchecked_t;
+#endif
+
 #define ATOMIC64_INIT(i) { (i) }
 
 #ifdef CONFIG_ARM_LPAE
@@ -286,6 +399,19 @@ static inline long long atomic64_read(const atomic64_t *v)
 	return result;
 }
 
+static inline long long atomic64_read_unchecked(const atomic64_unchecked_t *v)
+{
+	long long result;
+
+	__asm__ __volatile__("@ atomic64_read_unchecked\n"
+"	ldrd	%0, %H0, [%1]"
+	: "=&r" (result)
+	: "r" (&v->counter), "Qo" (v->counter)
+	);
+
+	return result;
+}
+
 static inline void atomic64_set(atomic64_t *v, long long i)
 {
 	__asm__ __volatile__("@ atomic64_set\n"
@@ -294,6 +420,15 @@ static inline void atomic64_set(atomic64_t *v, long long i)
 	: "r" (&v->counter), "r" (i)
 	);
 }
+
+static inline void atomic64_set_unchecked(atomic64_unchecked_t *v, long long i)
+{
+	__asm__ __volatile__("@ atomic64_set_unchecked\n"
+"	strd	%2, %H2, [%1]"
+	: "=Qo" (v->counter)
+	: "r" (&v->counter), "r" (i)
+	);
+}
 #else
 static inline long long atomic64_read(const atomic64_t *v)
 {
@@ -308,6 +443,19 @@ static inline long long atomic64_read(const atomic64_t *v)
 	return result;
 }
 
+static inline long long atomic64_read_unchecked(const atomic64_unchecked_t *v)
+{
+	long long result;
+
+	__asm__ __volatile__("@ atomic64_read_unchecked\n"
+"	ldrexd	%0, %H0, [%1]"
+	: "=&r" (result)
+	: "r" (&v->counter), "Qo" (v->counter)
+	);
+
+	return result;
+}
+
 static inline void atomic64_set(atomic64_t *v, long long i)
 {
 	long long tmp;
@@ -322,50 +470,82 @@ static inline void atomic64_set(atomic64_t *v, long long i)
 	: "r" (&v->counter), "r" (i)
 	: "cc");
 }
+
+static inline void atomic64_set_unchecked(atomic64_unchecked_t *v, long long i)
+{
+	long long tmp;
+
+	prefetchw(&v->counter);
+	__asm__ __volatile__("@ atomic64_set_unchecked\n"
+"1:	ldrexd	%0, %H0, [%2]\n"
+"	strexd	%0, %3, %H3, [%2]\n"
+"	teq	%0, #0\n"
+"	bne	1b"
+	: "=&r" (tmp), "=Qo" (v->counter)
+	: "r" (&v->counter), "r" (i)
+	: "cc");
+}
 #endif
 
-#define ATOMIC64_OP(op, op1, op2)					\
-static inline void atomic64_##op(long long i, atomic64_t *v)		\
+#define __OVERFLOW_POST_RETURN64	\
+	"	bvc	3f\n"		\
+"	mov	%Q1, %Q0\n"		\
+"	mov	%R1, %R0\n"		\
+	"2:	" REFCOUNT_TRAP_INSN "\n"\
+	"3:\n"
+
+#define __ATOMIC64_OP(op, suffix, op1, op2)				\
+static inline void atomic64_##op##suffix(long long i, atomic64##suffix##_t *v)\
 {									\
 	long long result;						\
 	unsigned long tmp;						\
 									\
 	prefetchw(&v->counter);						\
-	__asm__ __volatile__("@ atomic64_" #op "\n"			\
+	__asm__ __volatile__("@ atomic64_" #op #suffix "\n"		\
 "1:	ldrexd	%0, %H0, [%3]\n"					\
 "	" #op1 " %Q0, %Q0, %Q4\n"					\
 "	" #op2 " %R0, %R0, %R4\n"					\
+	__OVERFLOW_POST							\
 "	strexd	%1, %0, %H0, [%3]\n"					\
 "	teq	%1, #0\n"						\
-"	bne	1b"							\
+"	bne	1b\n"							\
+	__OVERFLOW_EXTABLE						\
 	: "=&r" (result), "=&r" (tmp), "+Qo" (v->counter)		\
 	: "r" (&v->counter), "r" (i)					\
 	: "cc");							\
 }									\
 
-#define ATOMIC64_OP_RETURN(op, op1, op2)				\
+#define ATOMIC64_OP(op, op1, op2) __ATOMIC64_OP(op, _unchecked, op1, op2) \
+				  __ATOMIC64_OP(op, , op1, op2##s)
+
+#define __ATOMIC64_OP_RETURN(op, suffix, op1, op2)			\
 static inline long long							\
-atomic64_##op##_return_relaxed(long long i, atomic64_t *v)		\
+atomic64_##op##_return##suffix##_relaxed(long long i, atomic64##suffix##_t *v) \
 {									\
 	long long result;						\
-	unsigned long tmp;						\
+	long long tmp;							\
 									\
 	prefetchw(&v->counter);						\
 									\
-	__asm__ __volatile__("@ atomic64_" #op "_return\n"		\
+	__asm__ __volatile__("@ atomic64_" #op "_return" #suffix "\n"	\
 "1:	ldrexd	%0, %H0, [%3]\n"					\
-"	" #op1 " %Q0, %Q0, %Q4\n"					\
-"	" #op2 " %R0, %R0, %R4\n"					\
-"	strexd	%1, %0, %H0, [%3]\n"					\
-"	teq	%1, #0\n"						\
-"	bne	1b"							\
-	: "=&r" (result), "=&r" (tmp), "+Qo" (v->counter)		\
+"	" #op1 " %Q1, %Q0, %Q4\n"					\
+"	" #op2 " %R1, %R0, %R4\n"					\
+	__OVERFLOW_POST_RETURN64					\
+"	strexd	%0, %1, %H1, [%3]\n"					\
+"	teq	%0, #0\n"						\
+"	bne	1b\n"							\
+	__OVERFLOW_EXTABLE						\
+	: "=&r" (tmp), "=&r" (result), "+Qo" (v->counter)		\
 	: "r" (&v->counter), "r" (i)					\
 	: "cc");							\
 									\
 	return result;							\
 }
 
+#define ATOMIC64_OP_RETURN(op, op1, op2) __ATOMIC64_OP_RETURN(op, _unchecked, op1, op2) \
+					 __ATOMIC64_OP_RETURN(op, , op1, op2##s)
+
 #define ATOMIC64_FETCH_OP(op, op1, op2)					\
 static inline long long							\
 atomic64_fetch_##op##_relaxed(long long i, atomic64_t *v)		\
@@ -398,6 +578,7 @@ ATOMIC64_OPS(add, adds, adc)
 ATOMIC64_OPS(sub, subs, sbc)
 
 #define atomic64_add_return_relaxed	atomic64_add_return_relaxed
+#define atomic64_add_return_unchecked_relaxed	atomic64_add_return_unchecked_relaxed
 #define atomic64_sub_return_relaxed	atomic64_sub_return_relaxed
 #define atomic64_fetch_add_relaxed	atomic64_fetch_add_relaxed
 #define atomic64_fetch_sub_relaxed	atomic64_fetch_sub_relaxed
@@ -422,7 +603,10 @@ ATOMIC64_OPS(xor, eor, eor)
 #undef ATOMIC64_OPS
 #undef ATOMIC64_FETCH_OP
 #undef ATOMIC64_OP_RETURN
+#undef __ATOMIC64_OP_RETURN
 #undef ATOMIC64_OP
+#undef __ATOMIC64_OP
+#undef __OVERFLOW_POST_RETURN
 
 static inline long long
 atomic64_cmpxchg_relaxed(atomic64_t *ptr, long long old, long long new)
@@ -448,6 +632,13 @@ atomic64_cmpxchg_relaxed(atomic64_t *ptr, long long old, long long new)
 }
 #define atomic64_cmpxchg_relaxed	atomic64_cmpxchg_relaxed
 
+static inline long long
+atomic64_cmpxchg_unchecked_relaxed(atomic64_unchecked_t *ptr, long long old, long long new)
+{
+	return atomic64_cmpxchg_relaxed((atomic64_t *)ptr, old, new);
+}
+#define atomic64_cmpxchg_unchecked_relaxed	atomic64_cmpxchg_unchecked_relaxed
+
 static inline long long atomic64_xchg_relaxed(atomic64_t *ptr, long long new)
 {
 	long long result;
@@ -468,25 +659,36 @@ static inline long long atomic64_xchg_relaxed(atomic64_t *ptr, long long new)
 }
 #define atomic64_xchg_relaxed		atomic64_xchg_relaxed
 
+static inline long long atomic64_xchg_unchecked_relaxed(atomic64_unchecked_t *ptr, long long new)
+{
+	return atomic64_xchg_relaxed((atomic64_t *)ptr, new);
+}
+#define atomic64_xchg_unchecked_relaxed		atomic64_xchg_unchecked_relaxed
+
 static inline long long atomic64_dec_if_positive(atomic64_t *v)
 {
 	long long result;
-	unsigned long tmp;
+	u64 tmp;
 
 	smp_mb();
 	prefetchw(&v->counter);
 
 	__asm__ __volatile__("@ atomic64_dec_if_positive\n"
 "1:	ldrexd	%0, %H0, [%3]\n"
-"	subs	%Q0, %Q0, #1\n"
-"	sbc	%R0, %R0, #0\n"
-"	teq	%R0, #0\n"
-"	bmi	2f\n"
-"	strexd	%1, %0, %H0, [%3]\n"
-"	teq	%1, #0\n"
+"	subs	%Q1, %Q0, #1\n"
+"	sbcs	%R1, %R0, #0\n"
+
+	__OVERFLOW_POST_RETURN64
+
+"	teq	%R1, #0\n"
+"	bmi	4f\n"
+"	strexd	%0, %1, %H1, [%3]\n"
+"	teq	%0, #0\n"
 "	bne	1b\n"
-"2:"
-	: "=&r" (result), "=&r" (tmp), "+Qo" (v->counter)
+
+	__OVERFLOW_EXTABLE
+
+	: "=&r" (tmp), "=&r" (result), "+Qo" (v->counter)
 	: "r" (&v->counter)
 	: "cc");
 
@@ -509,13 +711,18 @@ static inline int atomic64_add_unless(atomic64_t *v, long long a, long long u)
 "	teq	%0, %5\n"
 "	teqeq	%H0, %H5\n"
 "	moveq	%1, #0\n"
-"	beq	2f\n"
+"	beq	4f\n"
 "	adds	%Q0, %Q0, %Q6\n"
-"	adc	%R0, %R0, %R6\n"
+"	adcs	%R0, %R0, %R6\n"
+
+	__OVERFLOW_POST
+
 "	strexd	%2, %0, %H0, [%4]\n"
 "	teq	%2, #0\n"
 "	bne	1b\n"
-"2:"
+
+	__OVERFLOW_EXTABLE
+
 	: "=&r" (val), "+r" (ret), "=&r" (tmp), "+Qo" (v->counter)
 	: "r" (&v->counter), "r" (u), "r" (a)
 	: "cc");
@@ -526,12 +733,19 @@ static inline int atomic64_add_unless(atomic64_t *v, long long a, long long u)
 	return ret;
 }
 
+#undef __OVERFLOW_EXTABLE
+#undef __OVERFLOW_POST_RETURN64
+#undef __OVERFLOW_POST
+
 #define atomic64_add_negative(a, v)	(atomic64_add_return((a), (v)) < 0)
 #define atomic64_inc(v)			atomic64_add(1LL, (v))
+#define atomic64_inc_unchecked(v)	atomic64_add_unchecked(1LL, (v))
 #define atomic64_inc_return_relaxed(v)	atomic64_add_return_relaxed(1LL, (v))
+#define atomic64_inc_return_unchecked_relaxed(v)	atomic64_add_return_unchecked_relaxed(1LL, (v))
 #define atomic64_inc_and_test(v)	(atomic64_inc_return(v) == 0)
 #define atomic64_sub_and_test(a, v)	(atomic64_sub_return((a), (v)) == 0)
 #define atomic64_dec(v)			atomic64_sub(1LL, (v))
+#define atomic64_dec_unchecked(v)	atomic64_sub_unchecked(1LL, (v))
 #define atomic64_dec_return_relaxed(v)	atomic64_sub_return_relaxed(1LL, (v))
 #define atomic64_dec_and_test(v)	(atomic64_dec_return((v)) == 0)
 #define atomic64_inc_not_zero(v)	atomic64_add_unless((v), 1LL, 0LL)
diff --git a/arch/arm/include/asm/cache.h b/arch/arm/include/asm/cache.h
index 75fe66bc0..2255c8669 100644
--- a/arch/arm/include/asm/cache.h
+++ b/arch/arm/include/asm/cache.h
@@ -4,8 +4,10 @@
 #ifndef __ASMARM_CACHE_H
 #define __ASMARM_CACHE_H
 
+#include <linux/const.h>
+
 #define L1_CACHE_SHIFT		CONFIG_ARM_L1_CACHE_SHIFT
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 /*
  * Memory returned by kmalloc() may be used for DMA, so we must make
diff --git a/arch/arm/include/asm/cacheflush.h b/arch/arm/include/asm/cacheflush.h
index 9156fc303..0521e3e42 100644
--- a/arch/arm/include/asm/cacheflush.h
+++ b/arch/arm/include/asm/cacheflush.h
@@ -116,7 +116,7 @@ struct cpu_cache_fns {
 	void (*dma_unmap_area)(const void *, size_t, int);
 
 	void (*dma_flush_range)(const void *, const void *);
-};
+} __no_const __no_randomize_layout;
 
 /*
  * Select the calling method
diff --git a/arch/arm/include/asm/checksum.h b/arch/arm/include/asm/checksum.h
index 524692f4a..a8871ec56 100644
--- a/arch/arm/include/asm/checksum.h
+++ b/arch/arm/include/asm/checksum.h
@@ -37,7 +37,19 @@ __wsum
 csum_partial_copy_nocheck(const void *src, void *dst, int len, __wsum sum);
 
 __wsum
-csum_partial_copy_from_user(const void __user *src, void *dst, int len, __wsum sum, int *err_ptr);
+__csum_partial_copy_from_user(const void __user *src, void *dst, int len, __wsum sum, int *err_ptr);
+
+static inline __wsum
+csum_partial_copy_from_user(const void __user *src, void *dst, int len, __wsum sum, int *err_ptr)
+{
+	__wsum ret;
+	pax_open_userland();
+	ret = __csum_partial_copy_from_user(src, dst, len, sum, err_ptr);
+	pax_close_userland();
+	return ret;
+}
+
+
 
 /*
  * 	Fold a partial checksum without adding pseudo headers
diff --git a/arch/arm/include/asm/cmpxchg.h b/arch/arm/include/asm/cmpxchg.h
index 97882f9ba..ff9d6ac47 100644
--- a/arch/arm/include/asm/cmpxchg.h
+++ b/arch/arm/include/asm/cmpxchg.h
@@ -117,6 +117,10 @@ static inline unsigned long __xchg(unsigned long x, volatile void *ptr, int size
 	(__typeof__(*(ptr)))__xchg((unsigned long)(x), (ptr),		\
 				   sizeof(*(ptr)));			\
 })
+#define xchg_unchecked_relaxed(ptr, x) ({				\
+	(__typeof__(*(ptr)))__xchg((unsigned long)(x), (ptr),		\
+				   sizeof(*(ptr)));			\
+})
 
 #include <asm-generic/cmpxchg-local.h>
 
@@ -128,6 +132,7 @@ static inline unsigned long __xchg(unsigned long x, volatile void *ptr, int size
 #endif
 
 #define xchg xchg_relaxed
+#define xchg_unchecked xchg_unchecked_relaxed
 
 /*
  * cmpxchg_local and cmpxchg64_local are atomic wrt current CPU. Always make
diff --git a/arch/arm/include/asm/cpuidle.h b/arch/arm/include/asm/cpuidle.h
index baefe1d51..29cb35ac0 100644
--- a/arch/arm/include/asm/cpuidle.h
+++ b/arch/arm/include/asm/cpuidle.h
@@ -32,7 +32,7 @@ struct device_node;
 struct cpuidle_ops {
 	int (*suspend)(unsigned long arg);
 	int (*init)(struct device_node *, int cpu);
-};
+} __no_const;
 
 struct of_cpuidle_method {
 	const char *method;
diff --git a/arch/arm/include/asm/domain.h b/arch/arm/include/asm/domain.h
index 99d9f630d..ec44cb50b 100644
--- a/arch/arm/include/asm/domain.h
+++ b/arch/arm/include/asm/domain.h
@@ -42,7 +42,6 @@
 #define DOMAIN_USER	1
 #define DOMAIN_IO	0
 #endif
-#define DOMAIN_VECTORS	3
 
 /*
  * Domain types
@@ -51,10 +50,29 @@
 #define DOMAIN_CLIENT	1
 #ifdef CONFIG_CPU_USE_DOMAINS
 #define DOMAIN_MANAGER	3
+#define DOMAIN_VECTORS	3
+#define DOMAIN_USERCLIENT	DOMAIN_CLIENT
+#else
+
+#ifdef CONFIG_PAX_KERNEXEC
+#define DOMAIN_MANAGER	1
+#define DOMAIN_KERNEXEC	3
 #else
 #define DOMAIN_MANAGER	1
 #endif
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+#define DOMAIN_USERCLIENT	0
+#define DOMAIN_UDEREF		1
+#define DOMAIN_VECTORS		DOMAIN_KERNEL
+#else
+#define DOMAIN_USERCLIENT	1
+#define DOMAIN_VECTORS		DOMAIN_USER
+#endif
+
+#endif
+#define DOMAIN_KERNELCLIENT	1
+
 #define domain_mask(dom)	((3) << (2 * (dom)))
 #define domain_val(dom,type)	((type) << (2 * (dom)))
 
@@ -62,13 +80,19 @@
 #define DACR_INIT \
 	(domain_val(DOMAIN_USER, DOMAIN_NOACCESS) | \
 	 domain_val(DOMAIN_KERNEL, DOMAIN_MANAGER) | \
-	 domain_val(DOMAIN_IO, DOMAIN_CLIENT) | \
+	 domain_val(DOMAIN_IO, DOMAIN_KERNELCLIENT) | \
 	 domain_val(DOMAIN_VECTORS, DOMAIN_CLIENT))
+#elif defined(CONFIG_PAX_MEMORY_UDEREF)
+	/* DOMAIN_VECTORS is defined to DOMAIN_KERNEL */
+#define DACR_INIT \
+	(domain_val(DOMAIN_USER, DOMAIN_USERCLIENT) | \
+	 domain_val(DOMAIN_KERNEL, DOMAIN_MANAGER) | \
+	 domain_val(DOMAIN_IO, DOMAIN_KERNELCLIENT))
 #else
 #define DACR_INIT \
-	(domain_val(DOMAIN_USER, DOMAIN_CLIENT) | \
+	(domain_val(DOMAIN_USER, DOMAIN_USERCLIENT) | \
 	 domain_val(DOMAIN_KERNEL, DOMAIN_MANAGER) | \
-	 domain_val(DOMAIN_IO, DOMAIN_CLIENT) | \
+	 domain_val(DOMAIN_IO, DOMAIN_KERNELCLIENT) | \
 	 domain_val(DOMAIN_VECTORS, DOMAIN_CLIENT))
 #endif
 
@@ -124,6 +148,17 @@ static inline void set_domain(unsigned val)
 		set_domain(domain);				\
 	} while (0)
 
+#elif defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+#define modify_domain(dom,type)					\
+	do {							\
+		struct thread_info *thread = current_thread_info(); \
+		unsigned int domain = get_domain();		\
+		domain &= ~domain_mask(dom);			\
+		domain = domain | domain_val(dom, type);	\
+		thread->cpu_domain = domain;			\
+		set_domain(domain);				\
+	} while (0)
+
 #else
 static inline void modify_domain(unsigned dom, unsigned type)	{ }
 #endif
diff --git a/arch/arm/include/asm/elf.h b/arch/arm/include/asm/elf.h
index d2315ffd8..f60b47ba9 100644
--- a/arch/arm/include/asm/elf.h
+++ b/arch/arm/include/asm/elf.h
@@ -117,7 +117,14 @@ int dump_task_regs(struct task_struct *t, elf_gregset_t *elfregs);
    the loader.  We need to make sure that it is out of the way of the program
    that it will "exec", and that there is sufficient room for the brk.  */
 
-#define ELF_ET_DYN_BASE	(TASK_SIZE / 3 * 2)
+#define ELF_ET_DYN_BASE		(TASK_SIZE / 3 * 2)
+
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	0x00008000UL
+
+#define PAX_DELTA_MMAP_LEN	((current->personality == PER_LINUX_32BIT) ? 16 : 10)
+#define PAX_DELTA_STACK_LEN	((current->personality == PER_LINUX_32BIT) ? 16 : 10)
+#endif
 
 /* When the program starts, a1 contains a pointer to a function to be 
    registered with atexit, as per the SVR4 ABI.  A value of 0 means we 
diff --git a/arch/arm/include/asm/fncpy.h b/arch/arm/include/asm/fncpy.h
index de5354746..52b9a289f 100644
--- a/arch/arm/include/asm/fncpy.h
+++ b/arch/arm/include/asm/fncpy.h
@@ -81,7 +81,9 @@
 	BUG_ON((uintptr_t)(dest_buf) & (FNCPY_ALIGN - 1) ||		\
 		(__funcp_address & ~(uintptr_t)1 & (FNCPY_ALIGN - 1)));	\
 									\
+	pax_open_kernel();						\
 	memcpy(dest_buf, (void const *)(__funcp_address & ~1), size);	\
+	pax_close_kernel();						\
 	flush_icache_range((unsigned long)(dest_buf),			\
 		(unsigned long)(dest_buf) + (size));			\
 									\
diff --git a/arch/arm/include/asm/futex.h b/arch/arm/include/asm/futex.h
index 6795368ad..6c4d74984 100644
--- a/arch/arm/include/asm/futex.h
+++ b/arch/arm/include/asm/futex.h
@@ -107,6 +107,7 @@ futex_atomic_cmpxchg_inatomic(u32 *uval, u32 __user *uaddr,
 		return -EFAULT;
 
 	preempt_disable();
+
 	__ua_flags = uaccess_save_and_enable();
 	__asm__ __volatile__("@futex_atomic_cmpxchg_inatomic\n"
 	"1:	" TUSER(ldr) "	%1, [%4]\n"
diff --git a/arch/arm/include/asm/kmap_types.h b/arch/arm/include/asm/kmap_types.h
index 83eb2f772..ed77159d4 100644
--- a/arch/arm/include/asm/kmap_types.h
+++ b/arch/arm/include/asm/kmap_types.h
@@ -4,6 +4,6 @@
 /*
  * This is the "bare minimum".  AIO seems to require this.
  */
-#define KM_TYPE_NR 16
+#define KM_TYPE_NR 17
 
 #endif
diff --git a/arch/arm/include/asm/mach/dma.h b/arch/arm/include/asm/mach/dma.h
index 9e614a18e..3302cca0c 100644
--- a/arch/arm/include/asm/mach/dma.h
+++ b/arch/arm/include/asm/mach/dma.h
@@ -22,7 +22,7 @@ struct dma_ops {
 	int	(*residue)(unsigned int, dma_t *);		/* optional */
 	int	(*setspeed)(unsigned int, dma_t *, int);	/* optional */
 	const char *type;
-};
+} __do_const;
 
 struct dma_struct {
 	void		*addr;		/* single DMA address		*/
diff --git a/arch/arm/include/asm/mach/map.h b/arch/arm/include/asm/mach/map.h
index 9b7c328fb..2dfe68bd2 100644
--- a/arch/arm/include/asm/mach/map.h
+++ b/arch/arm/include/asm/mach/map.h
@@ -23,17 +23,19 @@ struct map_desc {
 
 /* types 0-3 are defined in asm/io.h */
 enum {
-	MT_UNCACHED = 4,
-	MT_CACHECLEAN,
-	MT_MINICLEAN,
+	MT_UNCACHED_RW = 4,
+	MT_CACHECLEAN_RO,
+	MT_MINICLEAN_RO,
 	MT_LOW_VECTORS,
 	MT_HIGH_VECTORS,
-	MT_MEMORY_RWX,
+	__MT_MEMORY_RWX,
 	MT_MEMORY_RW,
-	MT_ROM,
-	MT_MEMORY_RWX_NONCACHED,
+	MT_MEMORY_RX,
+	MT_ROM_RX,
+	MT_MEMORY_RW_NONCACHED,
+	MT_MEMORY_RX_NONCACHED,
 	MT_MEMORY_RW_DTCM,
-	MT_MEMORY_RWX_ITCM,
+	MT_MEMORY_RX_ITCM,
 	MT_MEMORY_RW_SO,
 	MT_MEMORY_DMA_READY,
 };
diff --git a/arch/arm/include/asm/outercache.h b/arch/arm/include/asm/outercache.h
index c2bf24f40..69e437cf2 100644
--- a/arch/arm/include/asm/outercache.h
+++ b/arch/arm/include/asm/outercache.h
@@ -39,7 +39,7 @@ struct outer_cache_fns {
 	/* This is an ARM L2C thing */
 	void (*write_sec)(unsigned long, unsigned);
 	void (*configure)(const struct l2x0_regs *);
-};
+} __no_const;
 
 extern struct outer_cache_fns outer_cache;
 
diff --git a/arch/arm/include/asm/page.h b/arch/arm/include/asm/page.h
index 4355f0ec4..cd9168e6b 100644
--- a/arch/arm/include/asm/page.h
+++ b/arch/arm/include/asm/page.h
@@ -23,6 +23,7 @@
 
 #else
 
+#include <linux/compiler.h>
 #include <asm/glue.h>
 
 /*
@@ -114,7 +115,7 @@ struct cpu_user_fns {
 	void (*cpu_clear_user_highpage)(struct page *page, unsigned long vaddr);
 	void (*cpu_copy_user_highpage)(struct page *to, struct page *from,
 			unsigned long vaddr, struct vm_area_struct *vma);
-};
+} __no_const;
 
 #ifdef MULTI_USER
 extern struct cpu_user_fns cpu_user;
diff --git a/arch/arm/include/asm/pgalloc.h b/arch/arm/include/asm/pgalloc.h
index b2902a5cd..da11e4d1d 100644
--- a/arch/arm/include/asm/pgalloc.h
+++ b/arch/arm/include/asm/pgalloc.h
@@ -17,6 +17,7 @@
 #include <asm/processor.h>
 #include <asm/cacheflush.h>
 #include <asm/tlbflush.h>
+#include <asm/system_info.h>
 
 #define check_pgt_cache()		do { } while (0)
 
@@ -43,6 +44,11 @@ static inline void pud_populate(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
 	set_pud(pud, __pud(__pa(pmd) | PMD_TYPE_TABLE));
 }
 
+static inline void pud_populate_kernel(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
+{
+	pud_populate(mm, pud, pmd);
+}
+
 #else	/* !CONFIG_ARM_LPAE */
 
 /*
@@ -51,6 +57,7 @@ static inline void pud_populate(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
 #define pmd_alloc_one(mm,addr)		({ BUG(); ((pmd_t *)2); })
 #define pmd_free(mm, pmd)		do { } while (0)
 #define pud_populate(mm,pmd,pte)	BUG()
+#define pud_populate_kernel(mm,pmd,pte)	BUG()
 
 #endif	/* CONFIG_ARM_LPAE */
 
@@ -128,6 +135,19 @@ static inline void pte_free(struct mm_struct *mm, pgtable_t pte)
 	__free_page(pte);
 }
 
+static inline void __section_update(pmd_t *pmdp, unsigned long addr, pmdval_t prot)
+{
+#ifdef CONFIG_ARM_LPAE
+	pmdp[0] = __pmd(pmd_val(pmdp[0]) | prot);
+#else
+	if (addr & SECTION_SIZE)
+		pmdp[1] = __pmd(pmd_val(pmdp[1]) | prot);
+	else
+		pmdp[0] = __pmd(pmd_val(pmdp[0]) | prot);
+#endif
+	flush_pmd_entry(pmdp);
+}
+
 static inline void __pmd_populate(pmd_t *pmdp, phys_addr_t pte,
 				  pmdval_t prot)
 {
diff --git a/arch/arm/include/asm/pgtable-2level-hwdef.h b/arch/arm/include/asm/pgtable-2level-hwdef.h
index 3f82e9da7..2a85e8b56 100644
--- a/arch/arm/include/asm/pgtable-2level-hwdef.h
+++ b/arch/arm/include/asm/pgtable-2level-hwdef.h
@@ -28,7 +28,7 @@
 /*
  *   - section
  */
-#define PMD_SECT_PXN    (_AT(pmdval_t, 1) << 0)     /* v7 */
+#define PMD_SECT_PXN		(_AT(pmdval_t, 1) << 0)     /* v7 */
 #define PMD_SECT_BUFFERABLE	(_AT(pmdval_t, 1) << 2)
 #define PMD_SECT_CACHEABLE	(_AT(pmdval_t, 1) << 3)
 #define PMD_SECT_XN		(_AT(pmdval_t, 1) << 4)		/* v6 */
@@ -40,6 +40,7 @@
 #define PMD_SECT_nG		(_AT(pmdval_t, 1) << 17)	/* v6 */
 #define PMD_SECT_SUPER		(_AT(pmdval_t, 1) << 18)	/* v6 */
 #define PMD_SECT_AF		(_AT(pmdval_t, 0))
+#define PMD_SECT_RDONLY		(_AT(pmdval_t, 0))
 
 #define PMD_SECT_UNCACHED	(_AT(pmdval_t, 0))
 #define PMD_SECT_BUFFERED	(PMD_SECT_BUFFERABLE)
@@ -70,6 +71,7 @@
  *   - extended small page/tiny page
  */
 #define PTE_EXT_XN		(_AT(pteval_t, 1) << 0)		/* v6 */
+#define PTE_EXT_PXN		(_AT(pteval_t, 1) << 2)		/* v7 */
 #define PTE_EXT_AP_MASK		(_AT(pteval_t, 3) << 4)
 #define PTE_EXT_AP0		(_AT(pteval_t, 1) << 4)
 #define PTE_EXT_AP1		(_AT(pteval_t, 2) << 4)
diff --git a/arch/arm/include/asm/pgtable-2level.h b/arch/arm/include/asm/pgtable-2level.h
index 92fd2c8a9..061dae1f1 100644
--- a/arch/arm/include/asm/pgtable-2level.h
+++ b/arch/arm/include/asm/pgtable-2level.h
@@ -127,6 +127,9 @@
 #define L_PTE_SHARED		(_AT(pteval_t, 1) << 10)	/* shared(v6), coherent(xsc3) */
 #define L_PTE_NONE		(_AT(pteval_t, 1) << 11)
 
+/* Two-level page tables only have PXN in the PGD, not in the PTE. */
+#define L_PTE_PXN		(_AT(pteval_t, 0))
+
 /*
  * These are the memory types, defined to be compatible with
  * pre-ARMv6 CPUs cacheable and bufferable bits: n/a,n/a,C,B
diff --git a/arch/arm/include/asm/pgtable-3level.h b/arch/arm/include/asm/pgtable-3level.h
index 2a029bcea..a0524c76e 100644
--- a/arch/arm/include/asm/pgtable-3level.h
+++ b/arch/arm/include/asm/pgtable-3level.h
@@ -80,6 +80,7 @@
 #define L_PTE_USER		(_AT(pteval_t, 1) << 6)		/* AP[1] */
 #define L_PTE_SHARED		(_AT(pteval_t, 3) << 8)		/* SH[1:0], inner shareable */
 #define L_PTE_YOUNG		(_AT(pteval_t, 1) << 10)	/* AF */
+#define L_PTE_PXN		(_AT(pteval_t, 1) << 53)	/* PXN */
 #define L_PTE_XN		(_AT(pteval_t, 1) << 54)	/* XN */
 #define L_PTE_DIRTY		(_AT(pteval_t, 1) << 55)
 #define L_PTE_SPECIAL		(_AT(pteval_t, 1) << 56)
@@ -90,10 +91,12 @@
 #define L_PMD_SECT_DIRTY	(_AT(pmdval_t, 1) << 55)
 #define L_PMD_SECT_NONE		(_AT(pmdval_t, 1) << 57)
 #define L_PMD_SECT_RDONLY	(_AT(pteval_t, 1) << 58)
+#define PMD_SECT_RDONLY		PMD_SECT_AP2
 
 /*
  * To be used in assembly code with the upper page attributes.
  */
+#define L_PTE_PXN_HIGH		(1 << (53 - 32))
 #define L_PTE_XN_HIGH		(1 << (54 - 32))
 #define L_PTE_DIRTY_HIGH	(1 << (55 - 32))
 
diff --git a/arch/arm/include/asm/pgtable.h b/arch/arm/include/asm/pgtable.h
index a8d656d9a..2febb8aee 100644
--- a/arch/arm/include/asm/pgtable.h
+++ b/arch/arm/include/asm/pgtable.h
@@ -33,6 +33,9 @@
 #include <asm/pgtable-2level.h>
 #endif
 
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+
 /*
  * Just any arbitrary offset to the start of the vmalloc VM area: the
  * current 8MB value just means that there will be a 8MB "hole" after the
@@ -48,6 +51,9 @@
 #define LIBRARY_TEXT_START	0x0c000000
 
 #ifndef __ASSEMBLY__
+extern pteval_t __supported_pte_mask;
+extern pmdval_t __supported_pmd_mask;
+
 extern void __pte_error(const char *file, int line, pte_t);
 extern void __pmd_error(const char *file, int line, pmd_t);
 extern void __pgd_error(const char *file, int line, pgd_t);
@@ -56,6 +62,48 @@ extern void __pgd_error(const char *file, int line, pgd_t);
 #define pmd_ERROR(pmd)		__pmd_error(__FILE__, __LINE__, pmd)
 #define pgd_ERROR(pgd)		__pgd_error(__FILE__, __LINE__, pgd)
 
+#define  __HAVE_ARCH_PAX_OPEN_KERNEL
+#define  __HAVE_ARCH_PAX_CLOSE_KERNEL
+
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+#include <asm/domain.h>
+#include <linux/thread_info.h>
+#include <linux/preempt.h>
+
+static inline int test_domain(int domain, int domaintype)
+{
+	return ((current_thread_info()->cpu_domain) & domain_val(domain, 3)) == domain_val(domain, domaintype);
+}
+#endif
+
+#ifdef CONFIG_PAX_KERNEXEC
+static inline unsigned long pax_open_kernel(void) {
+#ifdef CONFIG_ARM_LPAE
+	/* TODO */
+#else
+	preempt_disable();
+	BUG_ON(test_domain(DOMAIN_KERNEL, DOMAIN_KERNEXEC));
+	modify_domain(DOMAIN_KERNEL, DOMAIN_KERNEXEC);
+#endif
+	return 0;
+}
+
+static inline unsigned long pax_close_kernel(void) {
+#ifdef CONFIG_ARM_LPAE
+	/* TODO */
+#else
+	BUG_ON(test_domain(DOMAIN_KERNEL, DOMAIN_MANAGER));
+	/* DOMAIN_MANAGER = "client" under KERNEXEC */
+	modify_domain(DOMAIN_KERNEL, DOMAIN_MANAGER);
+	preempt_enable_no_resched();
+#endif
+	return 0;
+}
+#else
+static inline unsigned long pax_open_kernel(void) { return 0; }
+static inline unsigned long pax_close_kernel(void) { return 0; }
+#endif
+
 /*
  * This is the lowest virtual address we can permit any user space
  * mapping to be mapped at.  This is particularly important for
@@ -75,8 +123,8 @@ extern void __pgd_error(const char *file, int line, pgd_t);
 /*
  * The pgprot_* and protection_map entries will be fixed up in runtime
  * to include the cachable and bufferable bits based on memory policy,
- * as well as any architecture dependent bits like global/ASID and SMP
- * shared mapping bits.
+ * as well as any architecture dependent bits like global/ASID, PXN,
+ * and SMP shared mapping bits.
  */
 #define _L_PTE_DEFAULT	L_PTE_PRESENT | L_PTE_YOUNG
 
@@ -308,7 +356,7 @@ static inline pte_t pte_mknexec(pte_t pte)
 static inline pte_t pte_modify(pte_t pte, pgprot_t newprot)
 {
 	const pteval_t mask = L_PTE_XN | L_PTE_RDONLY | L_PTE_USER |
-		L_PTE_NONE | L_PTE_VALID;
+		L_PTE_NONE | L_PTE_VALID | __supported_pte_mask;
 	pte_val(pte) = (pte_val(pte) & ~mask) | (pgprot_val(newprot) & mask);
 	return pte;
 }
diff --git a/arch/arm/include/asm/smp.h b/arch/arm/include/asm/smp.h
index 3d6dc8b46..1262ad315 100644
--- a/arch/arm/include/asm/smp.h
+++ b/arch/arm/include/asm/smp.h
@@ -108,7 +108,7 @@ struct smp_operations {
 	int  (*cpu_disable)(unsigned int cpu);
 #endif
 #endif
-};
+} __no_const;
 
 struct of_cpu_method {
 	const char *method;
diff --git a/arch/arm/include/asm/string.h b/arch/arm/include/asm/string.h
index cf4f3aad0..8f2f2d9a6 100644
--- a/arch/arm/include/asm/string.h
+++ b/arch/arm/include/asm/string.h
@@ -7,19 +7,19 @@
  */
 
 #define __HAVE_ARCH_STRRCHR
-extern char * strrchr(const char * s, int c);
+extern char * strrchr(const char * s, int c) __nocapture(-1);
 
 #define __HAVE_ARCH_STRCHR
-extern char * strchr(const char * s, int c);
+extern char * strchr(const char * s, int c) __nocapture(-1);
 
 #define __HAVE_ARCH_MEMCPY
-extern void * memcpy(void *, const void *, __kernel_size_t);
+extern void * memcpy(void *, const void *, __kernel_size_t) __nocapture(2);
 
 #define __HAVE_ARCH_MEMMOVE
-extern void * memmove(void *, const void *, __kernel_size_t);
+extern void * memmove(void *, const void *, __kernel_size_t) __nocapture(2);
 
 #define __HAVE_ARCH_MEMCHR
-extern void * memchr(const void *, int, __kernel_size_t);
+extern void * memchr(const void *, int, __kernel_size_t) __nocapture(-1);
 
 #define __HAVE_ARCH_MEMSET
 extern void * memset(void *, int, __kernel_size_t);
diff --git a/arch/arm/include/asm/thread_info.h b/arch/arm/include/asm/thread_info.h
index 776757d16..a552c1d75 100644
--- a/arch/arm/include/asm/thread_info.h
+++ b/arch/arm/include/asm/thread_info.h
@@ -73,6 +73,9 @@ struct thread_info {
 	.flags		= 0,						\
 	.preempt_count	= INIT_PREEMPT_COUNT,				\
 	.addr_limit	= KERNEL_DS,					\
+	.cpu_domain	= domain_val(DOMAIN_USER, DOMAIN_USERCLIENT) |	\
+			  domain_val(DOMAIN_KERNEL, DOMAIN_KERNELCLIENT) | \
+			  domain_val(DOMAIN_IO, DOMAIN_KERNELCLIENT),	\
 }
 
 #define init_thread_info	(init_thread_union.thread_info)
@@ -143,6 +146,10 @@ extern int vfp_restore_user_hwstate(struct user_vfp __user *,
 #define TIF_SYSCALL_AUDIT	5	/* syscall auditing active */
 #define TIF_SYSCALL_TRACEPOINT	6	/* syscall tracepoint instrumentation */
 #define TIF_SECCOMP		7	/* seccomp syscall filtering active */
+/* within 8 bits of TIF_SYSCALL_TRACE
+ *  to meet flexible second operand requirements
+ */
+#define TIF_GRSEC_SETXID	8
 
 #define TIF_NOHZ		12	/* in adaptive nohz mode */
 #define TIF_USING_IWMMXT	17
@@ -158,10 +165,11 @@ extern int vfp_restore_user_hwstate(struct user_vfp __user *,
 #define _TIF_SYSCALL_TRACEPOINT	(1 << TIF_SYSCALL_TRACEPOINT)
 #define _TIF_SECCOMP		(1 << TIF_SECCOMP)
 #define _TIF_USING_IWMMXT	(1 << TIF_USING_IWMMXT)
+#define _TIF_GRSEC_SETXID	(1 << TIF_GRSEC_SETXID)
 
 /* Checks for any syscall work in entry-common.S */
 #define _TIF_SYSCALL_WORK (_TIF_SYSCALL_TRACE | _TIF_SYSCALL_AUDIT | \
-			   _TIF_SYSCALL_TRACEPOINT | _TIF_SECCOMP)
+			   _TIF_SYSCALL_TRACEPOINT | _TIF_SECCOMP | _TIF_GRSEC_SETXID)
 
 /*
  * Change these and you break ASM code in entry-common.S
diff --git a/arch/arm/include/asm/timex.h b/arch/arm/include/asm/timex.h
index f6fcc67ef..5895d62b9 100644
--- a/arch/arm/include/asm/timex.h
+++ b/arch/arm/include/asm/timex.h
@@ -13,6 +13,7 @@
 #define _ASMARM_TIMEX_H
 
 typedef unsigned long cycles_t;
+extern int read_current_timer(unsigned long *timer_val);
 #define get_cycles()	({ cycles_t c; read_current_timer(&c) ? 0 : c; })
 
 #endif
diff --git a/arch/arm/include/asm/tls.h b/arch/arm/include/asm/tls.h
index 5f833f7ad..76e664486 100644
--- a/arch/arm/include/asm/tls.h
+++ b/arch/arm/include/asm/tls.h
@@ -3,6 +3,7 @@
 
 #include <linux/compiler.h>
 #include <asm/thread_info.h>
+#include <asm/pgtable.h>
 
 #ifdef __ASSEMBLY__
 #include <asm/asm-offsets.h>
@@ -89,7 +90,9 @@ static inline void set_tls(unsigned long val)
 			 * at 0xffff0fe0 must be used instead.  (see
 			 * entry-armv.S for details)
 			 */
+			pax_open_kernel();
 			*((unsigned int *)0xffff0ff0) = val;
+			pax_close_kernel();
 #endif
 		}
 
diff --git a/arch/arm/include/asm/uaccess.h b/arch/arm/include/asm/uaccess.h
index a93c0f99a..5c31bbb4a 100644
--- a/arch/arm/include/asm/uaccess.h
+++ b/arch/arm/include/asm/uaccess.h
@@ -18,6 +18,7 @@
 #include <asm/domain.h>
 #include <asm/unified.h>
 #include <asm/compiler.h>
+#include <asm/pgtable.h>
 
 #ifndef CONFIG_HAVE_EFFICIENT_UNALIGNED_ACCESS
 #include <asm-generic/uaccess-unaligned.h>
@@ -50,6 +51,59 @@ struct exception_table_entry
 extern int fixup_exception(struct pt_regs *regs);
 
 /*
+ * These two are intentionally not defined anywhere - if the kernel
+ * code generates any references to them, that's a bug.
+ */
+extern int __get_user_bad(void);
+extern int __put_user_bad(void);
+
+/*
+ * Note that this is actually 0x1,0000,0000
+ */
+#define KERNEL_DS	0x00000000
+#define get_ds()	(KERNEL_DS)
+
+#ifdef CONFIG_MMU
+
+#define USER_DS		TASK_SIZE
+#define get_fs()	(current_thread_info()->addr_limit)
+
+static inline void set_fs(mm_segment_t fs)
+{
+	current_thread_info()->addr_limit = fs;
+	modify_domain(DOMAIN_KERNEL, fs ? DOMAIN_KERNELCLIENT : DOMAIN_MANAGER);
+}
+
+#define segment_eq(a, b)	((a) == (b))
+
+#define __HAVE_ARCH_PAX_OPEN_USERLAND
+#define __HAVE_ARCH_PAX_CLOSE_USERLAND
+
+static inline void pax_open_userland(void)
+{
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (segment_eq(get_fs(), USER_DS)) {
+		BUG_ON(test_domain(DOMAIN_USER, DOMAIN_UDEREF));
+		modify_domain(DOMAIN_USER, DOMAIN_UDEREF);
+	}
+#endif
+
+}
+
+static inline void pax_close_userland(void)
+{
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (segment_eq(get_fs(), USER_DS)) {
+		BUG_ON(test_domain(DOMAIN_USER, DOMAIN_NOACCESS));
+		modify_domain(DOMAIN_USER, DOMAIN_NOACCESS);
+	}
+#endif
+
+}
+
+/*
  * These two functions allow hooking accesses to userspace to increase
  * system integrity by ensuring that the kernel can not inadvertantly
  * perform such accesses (eg, via list poison values) which could then
@@ -66,6 +120,7 @@ static inline unsigned int uaccess_save_and_enable(void)
 
 	return old_domain;
 #else
+	pax_open_userland();
 	return 0;
 #endif
 }
@@ -75,35 +130,11 @@ static inline void uaccess_restore(unsigned int flags)
 #ifdef CONFIG_CPU_SW_DOMAIN_PAN
 	/* Restore the user access mask */
 	set_domain(flags);
+#else
+	pax_close_userland();
 #endif
 }
 
-/*
- * These two are intentionally not defined anywhere - if the kernel
- * code generates any references to them, that's a bug.
- */
-extern int __get_user_bad(void);
-extern int __put_user_bad(void);
-
-/*
- * Note that this is actually 0x1,0000,0000
- */
-#define KERNEL_DS	0x00000000
-#define get_ds()	(KERNEL_DS)
-
-#ifdef CONFIG_MMU
-
-#define USER_DS		TASK_SIZE
-#define get_fs()	(current_thread_info()->addr_limit)
-
-static inline void set_fs(mm_segment_t fs)
-{
-	current_thread_info()->addr_limit = fs;
-	modify_domain(DOMAIN_KERNEL, fs ? DOMAIN_CLIENT : DOMAIN_MANAGER);
-}
-
-#define segment_eq(a, b)	((a) == (b))
-
 /* We use 33-bit arithmetic here... */
 #define __range_ok(addr, size) ({ \
 	unsigned long flag, roksum; \
@@ -268,6 +299,7 @@ static inline void set_fs(mm_segment_t fs)
 
 #endif /* CONFIG_MMU */
 
+#define access_ok_noprefault(type, addr, size) access_ok((type), (addr), (size))
 #define access_ok(type, addr, size)	(__range_ok(addr, size) == 0)
 
 #define user_addr_max() \
@@ -474,10 +506,10 @@ do {									\
 
 
 #ifdef CONFIG_MMU
-extern unsigned long __must_check
+extern unsigned long __must_check __size_overflow(3)
 arm_copy_from_user(void *to, const void __user *from, unsigned long n);
 
-static inline unsigned long __must_check
+static inline unsigned long __must_check __size_overflow(3)
 __copy_from_user(void *to, const void __user *from, unsigned long n)
 {
 	unsigned int __ua_flags;
@@ -489,9 +521,9 @@ __copy_from_user(void *to, const void __user *from, unsigned long n)
 	return n;
 }
 
-extern unsigned long __must_check
+extern unsigned long __must_check __size_overflow(3)
 arm_copy_to_user(void __user *to, const void *from, unsigned long n);
-extern unsigned long __must_check
+extern unsigned long __must_check __size_overflow(3)
 __copy_to_user_std(void __user *to, const void *from, unsigned long n);
 
 static inline unsigned long __must_check
@@ -511,9 +543,9 @@ __copy_to_user(void __user *to, const void *from, unsigned long n)
 #endif
 }
 
-extern unsigned long __must_check
+extern unsigned long __must_check __size_overflow(2)
 arm_clear_user(void __user *addr, unsigned long n);
-extern unsigned long __must_check
+extern unsigned long __must_check __size_overflow(2)
 __clear_user_std(void __user *addr, unsigned long n);
 
 static inline unsigned long __must_check
@@ -533,6 +565,9 @@ __clear_user(void __user *addr, unsigned long n)
 
 static inline unsigned long __must_check copy_from_user(void *to, const void __user *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	if (access_ok(VERIFY_READ, from, n))
 		n = __copy_from_user(to, from, n);
 	else /* security hole - plug it */
@@ -542,6 +577,9 @@ static inline unsigned long __must_check copy_from_user(void *to, const void __u
 
 static inline unsigned long __must_check copy_to_user(void __user *to, const void *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	if (access_ok(VERIFY_WRITE, to, n))
 		n = __copy_to_user(to, from, n);
 	return n;
diff --git a/arch/arm/include/uapi/asm/ptrace.h b/arch/arm/include/uapi/asm/ptrace.h
index 5af0ed1b8..cea838833 100644
--- a/arch/arm/include/uapi/asm/ptrace.h
+++ b/arch/arm/include/uapi/asm/ptrace.h
@@ -92,7 +92,7 @@
  * ARMv7 groups of PSR bits
  */
 #define APSR_MASK	0xf80f0000	/* N, Z, C, V, Q and GE flags */
-#define PSR_ISET_MASK	0x01000010	/* ISA state (J, T) mask */
+#define PSR_ISET_MASK	0x01000020	/* ISA state (J, T) mask */
 #define PSR_IT_MASK	0x0600fc00	/* If-Then execution state mask */
 #define PSR_ENDIAN_MASK	0x00000200	/* Endianness state mask */
 
diff --git a/arch/arm/kernel/armksyms.c b/arch/arm/kernel/armksyms.c
index 7e45f69a0..2c047db42 100644
--- a/arch/arm/kernel/armksyms.c
+++ b/arch/arm/kernel/armksyms.c
@@ -59,7 +59,7 @@ EXPORT_SYMBOL(arm_delay_ops);
 
 	/* networking */
 EXPORT_SYMBOL(csum_partial);
-EXPORT_SYMBOL(csum_partial_copy_from_user);
+EXPORT_SYMBOL(__csum_partial_copy_from_user);
 EXPORT_SYMBOL(csum_partial_copy_nocheck);
 EXPORT_SYMBOL(__csum_ipv6_magic);
 
diff --git a/arch/arm/kernel/cpuidle.c b/arch/arm/kernel/cpuidle.c
index 7dccc964d..84da24370 100644
--- a/arch/arm/kernel/cpuidle.c
+++ b/arch/arm/kernel/cpuidle.c
@@ -19,7 +19,7 @@ extern struct of_cpuidle_method __cpuidle_method_of_table[];
 static const struct of_cpuidle_method __cpuidle_method_of_table_sentinel
 	__used __section(__cpuidle_method_of_table_end);
 
-static struct cpuidle_ops cpuidle_ops[NR_CPUS];
+static struct cpuidle_ops cpuidle_ops[NR_CPUS] __read_only;
 
 /**
  * arm_cpuidle_simple_enter() - a wrapper to cpu_do_idle()
diff --git a/arch/arm/kernel/efi.c b/arch/arm/kernel/efi.c
index 9f43ba012..1cee4757e 100644
--- a/arch/arm/kernel/efi.c
+++ b/arch/arm/kernel/efi.c
@@ -60,9 +60,9 @@ int __init efi_create_mapping(struct mm_struct *mm, efi_memory_desc_t *md)
 	 * preference.
 	 */
 	if (md->attribute & EFI_MEMORY_WB)
-		desc.type = MT_MEMORY_RWX;
+		desc.type = __MT_MEMORY_RWX;
 	else if (md->attribute & EFI_MEMORY_WT)
-		desc.type = MT_MEMORY_RWX_NONCACHED;
+		desc.type = MT_MEMORY_RW_NONCACHED;
 	else if (md->attribute & EFI_MEMORY_WC)
 		desc.type = MT_DEVICE_WC;
 	else
diff --git a/arch/arm/kernel/entry-armv.S b/arch/arm/kernel/entry-armv.S
index 9f157e7c5..8e3f85763 100644
--- a/arch/arm/kernel/entry-armv.S
+++ b/arch/arm/kernel/entry-armv.S
@@ -50,6 +50,87 @@
 9997:
 	.endm
 
+	.macro	pax_enter_kernel
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	@ make aligned space for saved DACR
+	sub	sp, sp, #8
+	@ save regs
+	stmdb	sp!, {r1, r2}
+	@ read DACR from cpu_domain into r1
+	mov	r2, sp
+	@ assume 8K pages, since we have to split the immediate in two
+	bic	r2, r2, #(0x1fc0)
+	bic	r2, r2, #(0x3f)
+	ldr	r1, [r2, #TI_CPU_DOMAIN]
+	@ store old DACR on stack
+	str	r1, [sp, #8]
+#ifdef CONFIG_PAX_KERNEXEC
+	@ set type of DOMAIN_KERNEL to DOMAIN_KERNELCLIENT
+	bic	r1, r1, #(domain_val(DOMAIN_KERNEL, 3))
+	orr	r1, r1, #(domain_val(DOMAIN_KERNEL, DOMAIN_KERNELCLIENT))
+#endif
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	@ set current DOMAIN_USER to DOMAIN_NOACCESS
+	bic	r1, r1, #(domain_val(DOMAIN_USER, 3))
+#endif
+	@ write r1 to current_thread_info()->cpu_domain
+	str	r1, [r2, #TI_CPU_DOMAIN]
+	@ write r1 to DACR
+	mcr	p15, 0, r1, c3, c0, 0
+	@ instruction sync
+	instr_sync
+	@ restore regs
+	ldmia	sp!, {r1, r2}
+#endif
+	.endm
+
+	.macro	pax_open_userland
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	@ save regs
+	stmdb	sp!, {r0, r1}
+	@ read DACR from cpu_domain into r1
+	mov	r0, sp
+	@ assume 8K pages, since we have to split the immediate in two
+	bic	r0, r0, #(0x1fc0)
+	bic	r0, r0, #(0x3f)
+	ldr	r1, [r0, #TI_CPU_DOMAIN]
+	@ set current DOMAIN_USER to DOMAIN_CLIENT
+	bic	r1, r1, #(domain_val(DOMAIN_USER, 3))
+	orr	r1, r1, #(domain_val(DOMAIN_USER, DOMAIN_UDEREF))
+	@ write r1 to current_thread_info()->cpu_domain
+	str	r1, [r0, #TI_CPU_DOMAIN]
+	@ write r1 to DACR
+	mcr	p15, 0, r1, c3, c0, 0
+	@ instruction sync
+	instr_sync
+	@ restore regs
+	ldmia	sp!, {r0, r1}
+#endif
+	.endm
+
+	.macro	pax_close_userland
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	@ save regs
+	stmdb	sp!, {r0, r1}
+	@ read DACR from cpu_domain into r1
+	mov	r0, sp
+	@ assume 8K pages, since we have to split the immediate in two
+	bic	r0, r0, #(0x1fc0)
+	bic	r0, r0, #(0x3f)
+	ldr	r1, [r0, #TI_CPU_DOMAIN]
+	@ set current DOMAIN_USER to DOMAIN_NOACCESS
+	bic	r1, r1, #(domain_val(DOMAIN_USER, 3))
+	@ write r1 to current_thread_info()->cpu_domain
+	str	r1, [r0, #TI_CPU_DOMAIN]
+	@ write r1 to DACR
+	mcr	p15, 0, r1, c3, c0, 0
+	@ instruction sync
+	instr_sync
+	@ restore regs
+	ldmia	sp!, {r0, r1}
+#endif
+	.endm
+
 	.macro	pabt_helper
 	@ PABORT handler takes pt_regs in r2, fault address in r4 and psr in r5
 #ifdef MULTI_PABORT
@@ -92,11 +173,15 @@
  * Invalid mode handlers
  */
 	.macro	inv_entry, reason
+
+	pax_enter_kernel
+
 	sub	sp, sp, #PT_REGS_SIZE
  ARM(	stmib	sp, {r1 - lr}		)
  THUMB(	stmia	sp, {r0 - r12}		)
  THUMB(	str	sp, [sp, #S_SP]		)
  THUMB(	str	lr, [sp, #S_LR]		)
+
 	mov	r1, #\reason
 	.endm
 
@@ -152,6 +237,9 @@ ENDPROC(__und_invalid)
 	.macro	svc_entry, stack_hole=0, trace=1, uaccess=1
  UNWIND(.fnstart		)
  UNWIND(.save {r0 - pc}		)
+
+	pax_enter_kernel
+
 	sub	sp, sp, #(SVC_REGS_SIZE + \stack_hole - 4)
 #ifdef CONFIG_THUMB2_KERNEL
  SPFIX(	str	r0, [sp]	)	@ temporarily saved
@@ -167,7 +255,12 @@ ENDPROC(__und_invalid)
 	ldmia	r0, {r3 - r5}
 	add	r7, sp, #S_SP - 4	@ here for interlock avoidance
 	mov	r6, #-1			@  ""  ""      ""       ""
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	@ offset sp by 8 as done in pax_enter_kernel
+	add	r2, sp, #(SVC_REGS_SIZE + \stack_hole + 4)
+#else
 	add	r2, sp, #(SVC_REGS_SIZE + \stack_hole - 4)
+#endif
  SPFIX(	addeq	r2, r2, #4	)
 	str	r3, [sp, #-4]!		@ save the "real" r0 copied
 					@ from the exception stack
@@ -382,6 +475,9 @@ ENDPROC(__fiq_abt)
 	.macro	usr_entry, trace=1, uaccess=1
  UNWIND(.fnstart	)
  UNWIND(.cantunwind	)	@ don't unwind the user space
+
+	pax_enter_kernel_user
+
 	sub	sp, sp, #PT_REGS_SIZE
  ARM(	stmib	sp, {r1 - r12}	)
  THUMB(	stmia	sp, {r0 - r12}	)
@@ -495,7 +591,9 @@ __und_usr:
 	tst	r3, #PSR_T_BIT			@ Thumb mode?
 	bne	__und_usr_thumb
 	sub	r4, r2, #4			@ ARM instr at LR - 4
+	pax_open_userland
 1:	ldrt	r0, [r4]
+	pax_close_userland
  ARM_BE8(rev	r0, r0)				@ little endian instruction
 
 	uaccess_disable ip
@@ -531,11 +629,15 @@ __und_usr_thumb:
  */
 	.arch	armv6t2
 #endif
+	pax_open_userland
 2:	ldrht	r5, [r4]
+	pax_close_userland
 ARM_BE8(rev16	r5, r5)				@ little endian instruction
 	cmp	r5, #0xe800			@ 32bit instruction if xx != 0
 	blo	__und_usr_fault_16_pan		@ 16bit undefined instruction
+	pax_open_userland
 3:	ldrht	r0, [r2]
+	pax_close_userland
 ARM_BE8(rev16	r0, r0)				@ little endian instruction
 	uaccess_disable ip
 	add	r2, r2, #2			@ r2 is PC + 2, make it PC + 4
@@ -566,7 +668,8 @@ ENDPROC(__und_usr)
  */
 	.pushsection .text.fixup, "ax"
 	.align	2
-4:	str     r4, [sp, #S_PC]			@ retry current instruction
+4:	pax_close_userland
+	str     r4, [sp, #S_PC]			@ retry current instruction
 	ret	r9
 	.popsection
 	.pushsection __ex_table,"a"
@@ -788,7 +891,7 @@ ENTRY(__switch_to)
  THUMB(	str	lr, [ip], #4		   )
 	ldr	r4, [r2, #TI_TP_VALUE]
 	ldr	r5, [r2, #TI_TP_VALUE + 4]
-#ifdef CONFIG_CPU_USE_DOMAINS
+#if defined(CONFIG_CPU_USE_DOMAINS) || defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
 	mrc	p15, 0, r6, c3, c0, 0		@ Get domain register
 	str	r6, [r1, #TI_CPU_DOMAIN]	@ Save old domain register
 	ldr	r6, [r2, #TI_CPU_DOMAIN]
@@ -799,7 +902,7 @@ ENTRY(__switch_to)
 	ldr	r8, =__stack_chk_guard
 	ldr	r7, [r7, #TSK_STACK_CANARY]
 #endif
-#ifdef CONFIG_CPU_USE_DOMAINS
+#if defined(CONFIG_CPU_USE_DOMAINS) || defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
 	mcr	p15, 0, r6, c3, c0, 0		@ Set domain register
 #endif
 	mov	r5, r0
diff --git a/arch/arm/kernel/entry-common.S b/arch/arm/kernel/entry-common.S
index 10c3283d6..c47cdf5d9 100644
--- a/arch/arm/kernel/entry-common.S
+++ b/arch/arm/kernel/entry-common.S
@@ -11,18 +11,46 @@
 #include <asm/assembler.h>
 #include <asm/unistd.h>
 #include <asm/ftrace.h>
+#include <asm/domain.h>
 #include <asm/unwind.h>
 
+#include "entry-header.S"
+
 #ifdef CONFIG_NEED_RET_TO_USER
 #include <mach/entry-macro.S>
 #else
 	.macro  arch_ret_to_user, tmp1, tmp2
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	@ save regs
+	stmdb	sp!, {r1, r2}
+	@ read DACR from cpu_domain into r1
+	mov     r2, sp
+	@ assume 8K pages, since we have to split the immediate in two
+	bic     r2, r2, #(0x1fc0)
+	bic     r2, r2, #(0x3f)
+	ldr     r1, [r2, #TI_CPU_DOMAIN]
+#ifdef CONFIG_PAX_KERNEXEC
+	@ set type of DOMAIN_KERNEL to DOMAIN_KERNELCLIENT
+	bic     r1, r1, #(domain_val(DOMAIN_KERNEL, 3))
+	orr     r1, r1, #(domain_val(DOMAIN_KERNEL, DOMAIN_KERNELCLIENT))
+#endif
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	@ set current DOMAIN_USER to DOMAIN_UDEREF
+	bic     r1, r1, #(domain_val(DOMAIN_USER, 3))
+	orr     r1, r1, #(domain_val(DOMAIN_USER, DOMAIN_UDEREF))
+#endif
+	@ write r1 to current_thread_info()->cpu_domain
+	str     r1, [r2, #TI_CPU_DOMAIN]
+	@ write r1 to DACR
+	mcr     p15, 0, r1, c3, c0, 0
+	@ instruction sync
+	instr_sync
+	@ restore regs
+	ldmia	sp!, {r1, r2}
+#endif
 	.endm
 #endif
 
-#include "entry-header.S"
-
-
 	.align	5
 #if !(IS_ENABLED(CONFIG_TRACE_IRQFLAGS) || IS_ENABLED(CONFIG_CONTEXT_TRACKING))
 /*
@@ -36,7 +64,9 @@ ret_fast_syscall:
  UNWIND(.cantunwind	)
 	disable_irq_notrace			@ disable interrupts
 	ldr	r1, [tsk, #TI_FLAGS]		@ re-check for syscall tracing
-	tst	r1, #_TIF_SYSCALL_WORK | _TIF_WORK_MASK
+	tst	r1, #_TIF_SYSCALL_WORK
+	bne	fast_work_pending
+	tst	r1, #_TIF_WORK_MASK
 	bne	fast_work_pending
 
 	/* perform architecture specific actions before user return */
@@ -62,7 +92,9 @@ ret_fast_syscall:
 	str	r0, [sp, #S_R0 + S_OFF]!	@ save returned r0
 	disable_irq_notrace			@ disable interrupts
 	ldr	r1, [tsk, #TI_FLAGS]		@ re-check for syscall tracing
-	tst	r1, #_TIF_SYSCALL_WORK | _TIF_WORK_MASK
+	tst	r1, #_TIF_SYSCALL_WORK
+	bne	__sys_trace_return_nosave
+	tst	r1, #_TIF_WORK_MASK
 	beq	no_work_pending
  UNWIND(.fnend		)
 ENDPROC(ret_fast_syscall)
@@ -199,6 +231,12 @@ ENTRY(vector_swi)
 
 	uaccess_disable tbl
 
+	/*
+	 * do this here to avoid a performance hit of wrapping the code above
+	 * that directly dereferences userland to parse the SWI instruction
+	 */
+	pax_enter_kernel_user
+
 	adr	tbl, sys_call_table		@ load syscall table pointer
 
 #if defined(CONFIG_OABI_COMPAT)
diff --git a/arch/arm/kernel/entry-header.S b/arch/arm/kernel/entry-header.S
index 6391728c8..6bf90b858 100644
--- a/arch/arm/kernel/entry-header.S
+++ b/arch/arm/kernel/entry-header.S
@@ -196,6 +196,59 @@
 	msr	cpsr_c, \rtemp			@ switch back to the SVC mode
 	.endm
 
+	.macro	pax_enter_kernel_user
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	@ save regs
+	stmdb	sp!, {r0, r1}
+	@ read DACR from cpu_domain into r1
+	mov	r0, sp
+	@ assume 8K pages, since we have to split the immediate in two
+	bic	r0, r0, #(0x1fc0)
+	bic	r0, r0, #(0x3f)
+	ldr	r1, [r0, #TI_CPU_DOMAIN]
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	@ set current DOMAIN_USER to DOMAIN_NOACCESS
+	bic	r1, r1, #(domain_val(DOMAIN_USER, 3))
+#endif
+#ifdef CONFIG_PAX_KERNEXEC
+	@ set current DOMAIN_KERNEL to DOMAIN_KERNELCLIENT
+	bic	r1, r1, #(domain_val(DOMAIN_KERNEL, 3))
+	orr	r1, r1, #(domain_val(DOMAIN_KERNEL, DOMAIN_KERNELCLIENT))
+#endif
+	@ write r1 to current_thread_info()->cpu_domain
+	str	r1, [r0, #TI_CPU_DOMAIN]
+	@ write r1 to DACR
+	mcr	p15, 0, r1, c3, c0, 0
+	@ instruction sync
+	instr_sync
+	@ restore regs
+	ldmia	sp!, {r0, r1}
+#endif
+	.endm
+
+	.macro  pax_exit_kernel
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	@ save regs
+	stmdb	sp!, {r0, r1}
+	@ read old DACR from stack into r1
+	ldr	r1, [sp, #(8 + S_SP)]
+	sub	r1, r1, #8
+	ldr	r1, [r1]
+
+	@ write r1 to current_thread_info()->cpu_domain
+	mov	r0, sp
+	@ assume 8K pages, since we have to split the immediate in two
+	bic	r0, r0, #(0x1fc0)
+	bic	r0, r0, #(0x3f)
+	str	r1, [r0, #TI_CPU_DOMAIN]
+	@ write r1 to DACR
+	mcr	p15, 0, r1, c3, c0, 0
+	@ instruction sync
+	instr_sync
+	@ restore regs
+	ldmia	sp!, {r0, r1}
+#endif
+	.endm
 
 	.macro	svc_exit, rpsr, irq = 0
 	.if	\irq != 0
@@ -219,6 +272,8 @@
 	uaccess_restore
 	str	r1, [tsk, #TI_ADDR_LIMIT]
 
+	pax_exit_kernel
+
 #ifndef CONFIG_THUMB2_KERNEL
 	@ ARM mode SVC restore
 	msr	spsr_cxsf, \rpsr
diff --git a/arch/arm/kernel/fiq.c b/arch/arm/kernel/fiq.c
index 059c3da0f..8e45cfc02 100644
--- a/arch/arm/kernel/fiq.c
+++ b/arch/arm/kernel/fiq.c
@@ -95,7 +95,10 @@ void set_fiq_handler(void *start, unsigned int length)
 	void *base = vectors_page;
 	unsigned offset = FIQ_OFFSET;
 
+	pax_open_kernel();
 	memcpy(base + offset, start, length);
+	pax_close_kernel();
+
 	if (!cache_is_vipt_nonaliasing())
 		flush_icache_range((unsigned long)base + offset, offset +
 				   length);
diff --git a/arch/arm/kernel/module-plts.c b/arch/arm/kernel/module-plts.c
index 0c7efc344..39270854c 100644
--- a/arch/arm/kernel/module-plts.c
+++ b/arch/arm/kernel/module-plts.c
@@ -30,17 +30,12 @@ struct plt_entries {
 	u32	lit[PLT_ENT_COUNT];
 };
 
-static bool in_init(const struct module *mod, u32 addr)
-{
-	return addr - (u32)mod->init_layout.base < mod->init_layout.size;
-}
-
 u32 get_module_plt(struct module *mod, unsigned long loc, Elf32_Addr val)
 {
 	struct plt_entries *plt, *plt_end;
 	int c, *count;
 
-	if (in_init(mod, loc)) {
+	if (within_module_init(loc, mod)) {
 		plt = (void *)mod->arch.init_plt->sh_addr;
 		plt_end = (void *)plt + mod->arch.init_plt->sh_size;
 		count = &mod->arch.init_plt_count;
diff --git a/arch/arm/kernel/module.c b/arch/arm/kernel/module.c
index 4f14b5ce6..91ff2610e 100644
--- a/arch/arm/kernel/module.c
+++ b/arch/arm/kernel/module.c
@@ -38,17 +38,47 @@
 #endif
 
 #ifdef CONFIG_MMU
-void *module_alloc(unsigned long size)
+static inline void *__module_alloc(unsigned long size, pgprot_t prot)
 {
-	void *p = __vmalloc_node_range(size, 1, MODULES_VADDR, MODULES_END,
-				GFP_KERNEL, PAGE_KERNEL_EXEC, 0, NUMA_NO_NODE,
+	void *p;
+
+	if (!size || (!IS_ENABLED(CONFIG_ARM_MODULE_PLTS) && PAGE_ALIGN(size) > MODULES_END - MODULES_VADDR))
+		return NULL;
+
+	p = __vmalloc_node_range(size, 1, MODULES_VADDR, MODULES_END,
+				GFP_KERNEL, prot, 0, NUMA_NO_NODE,
 				__builtin_return_address(0));
 	if (!IS_ENABLED(CONFIG_ARM_MODULE_PLTS) || p)
 		return p;
 	return __vmalloc_node_range(size, 1,  VMALLOC_START, VMALLOC_END,
-				GFP_KERNEL, PAGE_KERNEL_EXEC, 0, NUMA_NO_NODE,
+				GFP_KERNEL, prot, 0, NUMA_NO_NODE,
 				__builtin_return_address(0));
 }
+
+void *module_alloc(unsigned long size)
+{
+
+#ifdef CONFIG_PAX_KERNEXEC
+	return __module_alloc(size, PAGE_KERNEL);
+#else
+	return __module_alloc(size, PAGE_KERNEL_EXEC);
+#endif
+
+}
+
+#ifdef CONFIG_PAX_KERNEXEC
+void module_memfree_exec(void *module_region)
+{
+	module_memfree(module_region);
+}
+EXPORT_SYMBOL(module_memfree_exec);
+
+void *module_alloc_exec(unsigned long size)
+{
+	return __module_alloc(size, PAGE_KERNEL_EXEC);
+}
+EXPORT_SYMBOL(module_alloc_exec);
+#endif
 #endif
 
 int
diff --git a/arch/arm/kernel/patch.c b/arch/arm/kernel/patch.c
index 69bda1a57..755113ad7 100644
--- a/arch/arm/kernel/patch.c
+++ b/arch/arm/kernel/patch.c
@@ -66,6 +66,7 @@ void __kprobes __patch_text_real(void *addr, unsigned int insn, bool remap)
 	else
 		__acquire(&patch_lock);
 
+	pax_open_kernel();
 	if (thumb2 && __opcode_is_thumb16(insn)) {
 		*(u16 *)waddr = __opcode_to_mem_thumb16(insn);
 		size = sizeof(u16);
@@ -97,6 +98,7 @@ void __kprobes __patch_text_real(void *addr, unsigned int insn, bool remap)
 		*(u32 *)waddr = insn;
 		size = sizeof(u32);
 	}
+	pax_close_kernel();
 
 	if (waddr != addr) {
 		flush_kernel_vmap_range(waddr, twopage ? size / 2 : size);
diff --git a/arch/arm/kernel/process.c b/arch/arm/kernel/process.c
index 612eb530f..5a44c8c8f 100644
--- a/arch/arm/kernel/process.c
+++ b/arch/arm/kernel/process.c
@@ -118,8 +118,8 @@ void __show_regs(struct pt_regs *regs)
 
 	show_regs_print_info(KERN_DEFAULT);
 
-	print_symbol("PC is at %s\n", instruction_pointer(regs));
-	print_symbol("LR is at %s\n", regs->ARM_lr);
+	printk("PC is at %pA\n", (void *)instruction_pointer(regs));
+	printk("LR is at %pA\n", (void *)regs->ARM_lr);
 	printk("pc : [<%08lx>]    lr : [<%08lx>]    psr: %08lx\n"
 	       "sp : %08lx  ip : %08lx  fp : %08lx\n",
 		regs->ARM_pc, regs->ARM_lr, regs->ARM_cpsr,
@@ -233,7 +233,7 @@ copy_thread(unsigned long clone_flags, unsigned long stack_start,
 
 	memset(&thread->cpu_context, 0, sizeof(struct cpu_context_save));
 
-#ifdef CONFIG_CPU_USE_DOMAINS
+#if defined(CONFIG_CPU_USE_DOMAINS) || defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
 	/*
 	 * Copy the initial value of the domain access control register
 	 * from the current thread: thread->addr_limit will have been
@@ -337,7 +337,7 @@ static struct vm_area_struct gate_vma = {
 
 static int __init gate_vma_init(void)
 {
-	gate_vma.vm_page_prot = PAGE_READONLY_EXEC;
+	gate_vma.vm_page_prot = vm_get_page_prot(gate_vma.vm_flags);
 	return 0;
 }
 arch_initcall(gate_vma_init);
@@ -366,92 +366,14 @@ const char *arch_vma_name(struct vm_area_struct *vma)
 	return is_gate_vma(vma) ? "[vectors]" : NULL;
 }
 
-/* If possible, provide a placement hint at a random offset from the
- * stack for the sigpage and vdso pages.
- */
-static unsigned long sigpage_addr(const struct mm_struct *mm,
-				  unsigned int npages)
-{
-	unsigned long offset;
-	unsigned long first;
-	unsigned long last;
-	unsigned long addr;
-	unsigned int slots;
-
-	first = PAGE_ALIGN(mm->start_stack);
-
-	last = TASK_SIZE - (npages << PAGE_SHIFT);
-
-	/* No room after stack? */
-	if (first > last)
-		return 0;
-
-	/* Just enough room? */
-	if (first == last)
-		return first;
-
-	slots = ((last - first) >> PAGE_SHIFT) + 1;
-
-	offset = get_random_int() % slots;
-
-	addr = first + (offset << PAGE_SHIFT);
-
-	return addr;
-}
-
-static struct page *signal_page;
-extern struct page *get_signal_page(void);
-
-static const struct vm_special_mapping sigpage_mapping = {
-	.name = "[sigpage]",
-	.pages = &signal_page,
-};
-
 int arch_setup_additional_pages(struct linux_binprm *bprm, int uses_interp)
 {
 	struct mm_struct *mm = current->mm;
-	struct vm_area_struct *vma;
-	unsigned long npages;
-	unsigned long addr;
-	unsigned long hint;
-	int ret = 0;
-
-	if (!signal_page)
-		signal_page = get_signal_page();
-	if (!signal_page)
-		return -ENOMEM;
-
-	npages = 1; /* for sigpage */
-	npages += vdso_total_pages;
 
 	if (down_write_killable(&mm->mmap_sem))
 		return -EINTR;
-	hint = sigpage_addr(mm, npages);
-	addr = get_unmapped_area(NULL, hint, npages << PAGE_SHIFT, 0, 0);
-	if (IS_ERR_VALUE(addr)) {
-		ret = addr;
-		goto up_fail;
-	}
-
-	vma = _install_special_mapping(mm, addr, PAGE_SIZE,
-		VM_READ | VM_EXEC | VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC,
-		&sigpage_mapping);
-
-	if (IS_ERR(vma)) {
-		ret = PTR_ERR(vma);
-		goto up_fail;
-	}
-
-	mm->context.sigpage = addr;
-
-	/* Unlike the sigpage, failure to install the vdso is unlikely
-	 * to be fatal to the process, so no error check needed
-	 * here.
-	 */
-	arm_install_vdso(mm, addr + PAGE_SIZE);
-
- up_fail:
+	mm->context.sigpage = (PAGE_OFFSET + (get_random_int() % 0x3FFEFFE0)) & 0xFFFFFFFC;
 	up_write(&mm->mmap_sem);
-	return ret;
+	return 0;
 }
 #endif
diff --git a/arch/arm/kernel/ptrace.c b/arch/arm/kernel/ptrace.c
index ce131ed59..26f9765b1 100644
--- a/arch/arm/kernel/ptrace.c
+++ b/arch/arm/kernel/ptrace.c
@@ -928,10 +928,19 @@ static void tracehook_report_syscall(struct pt_regs *regs,
 	regs->ARM_ip = ip;
 }
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+extern void gr_delayed_cred_worker(void);
+#endif
+
 asmlinkage int syscall_trace_enter(struct pt_regs *regs, int scno)
 {
 	current_thread_info()->syscall = scno;
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	if (test_thread_flag(TIF_SYSCALL_TRACE))
 		tracehook_report_syscall(regs, PTRACE_SYSCALL_ENTER);
 
diff --git a/arch/arm/kernel/reboot.c b/arch/arm/kernel/reboot.c
index 3fa867a2a..d6106070b 100644
--- a/arch/arm/kernel/reboot.c
+++ b/arch/arm/kernel/reboot.c
@@ -120,6 +120,7 @@ void machine_power_off(void)
 
 	if (pm_power_off)
 		pm_power_off();
+	while (1);
 }
 
 /*
diff --git a/arch/arm/kernel/setup.c b/arch/arm/kernel/setup.c
index df7f2a75e..d9d2bc11d 100644
--- a/arch/arm/kernel/setup.c
+++ b/arch/arm/kernel/setup.c
@@ -112,21 +112,23 @@ EXPORT_SYMBOL(elf_hwcap);
 unsigned int elf_hwcap2 __read_mostly;
 EXPORT_SYMBOL(elf_hwcap2);
 
+pteval_t __supported_pte_mask __read_only;
+pmdval_t __supported_pmd_mask __read_only;
 
 #ifdef MULTI_CPU
-struct processor processor __read_mostly;
+struct processor processor __read_only;
 #endif
 #ifdef MULTI_TLB
-struct cpu_tlb_fns cpu_tlb __read_mostly;
+struct cpu_tlb_fns cpu_tlb __read_only;
 #endif
 #ifdef MULTI_USER
-struct cpu_user_fns cpu_user __read_mostly;
+struct cpu_user_fns cpu_user __read_only;
 #endif
 #ifdef MULTI_CACHE
-struct cpu_cache_fns cpu_cache __read_mostly;
+struct cpu_cache_fns cpu_cache __read_only;
 #endif
 #ifdef CONFIG_OUTER_CACHE
-struct outer_cache_fns outer_cache __read_mostly;
+struct outer_cache_fns outer_cache __read_only;
 EXPORT_SYMBOL(outer_cache);
 #endif
 
@@ -257,9 +259,13 @@ static int __get_cpu_architecture(void)
 		 * Register 0 and check for VMSAv7 or PMSAv7 */
 		unsigned int mmfr0 = read_cpuid_ext(CPUID_EXT_MMFR0);
 		if ((mmfr0 & 0x0000000f) >= 0x00000003 ||
-		    (mmfr0 & 0x000000f0) >= 0x00000030)
+		    (mmfr0 & 0x000000f0) >= 0x00000030) {
 			cpu_arch = CPU_ARCH_ARMv7;
-		else if ((mmfr0 & 0x0000000f) == 0x00000002 ||
+			if ((mmfr0 & 0x0000000f) == 0x00000005 || (mmfr0 & 0x0000000f) == 0x00000004) {
+				__supported_pte_mask |= L_PTE_PXN;
+				__supported_pmd_mask |= PMD_PXNTABLE;
+			}
+		} else if ((mmfr0 & 0x0000000f) == 0x00000002 ||
 			 (mmfr0 & 0x000000f0) == 0x00000020)
 			cpu_arch = CPU_ARCH_ARMv6;
 		else
diff --git a/arch/arm/kernel/signal.c b/arch/arm/kernel/signal.c
index 7b8f21414..ece8e2863 100644
--- a/arch/arm/kernel/signal.c
+++ b/arch/arm/kernel/signal.c
@@ -24,8 +24,6 @@
 
 extern const unsigned long sigreturn_codes[7];
 
-static unsigned long signal_return_offset;
-
 #ifdef CONFIG_CRUNCH
 static int preserve_crunch_context(struct crunch_sigframe __user *frame)
 {
@@ -388,8 +386,7 @@ setup_return(struct pt_regs *regs, struct ksignal *ksig,
 			 * except when the MPU has protected the vectors
 			 * page from PL0
 			 */
-			retcode = mm->context.sigpage + signal_return_offset +
-				  (idx << 2) + thumb;
+			retcode = mm->context.sigpage + (idx << 2) + thumb;
 		} else
 #endif
 		{
@@ -601,33 +598,3 @@ do_work_pending(struct pt_regs *regs, unsigned int thread_flags, int syscall)
 	} while (thread_flags & _TIF_WORK_MASK);
 	return 0;
 }
-
-struct page *get_signal_page(void)
-{
-	unsigned long ptr;
-	unsigned offset;
-	struct page *page;
-	void *addr;
-
-	page = alloc_pages(GFP_KERNEL, 0);
-
-	if (!page)
-		return NULL;
-
-	addr = page_address(page);
-
-	/* Give the signal return code some randomness */
-	offset = 0x200 + (get_random_int() & 0x7fc);
-	signal_return_offset = offset;
-
-	/*
-	 * Copy signal return handlers into the vector page, and
-	 * set sigreturn to be a pointer to these.
-	 */
-	memcpy(addr + offset, sigreturn_codes, sizeof(sigreturn_codes));
-
-	ptr = (unsigned long)addr + offset;
-	flush_icache_range(ptr, ptr + sizeof(sigreturn_codes));
-
-	return page;
-}
diff --git a/arch/arm/kernel/smp.c b/arch/arm/kernel/smp.c
index 861521606..f5be3075a 100644
--- a/arch/arm/kernel/smp.c
+++ b/arch/arm/kernel/smp.c
@@ -82,7 +82,7 @@ enum ipi_msg_type {
 
 static DECLARE_COMPLETION(cpu_running);
 
-static struct smp_operations smp_ops;
+static struct smp_operations smp_ops __read_only;
 
 void __init smp_set_ops(const struct smp_operations *ops)
 {
diff --git a/arch/arm/kernel/tcm.c b/arch/arm/kernel/tcm.c
index b10e13607..cb5edf9c7 100644
--- a/arch/arm/kernel/tcm.c
+++ b/arch/arm/kernel/tcm.c
@@ -64,7 +64,7 @@ static struct map_desc itcm_iomap[] __initdata = {
 		.virtual	= ITCM_OFFSET,
 		.pfn		= __phys_to_pfn(ITCM_OFFSET),
 		.length		= 0,
-		.type		= MT_MEMORY_RWX_ITCM,
+		.type		= MT_MEMORY_RX_ITCM,
 	}
 };
 
@@ -362,7 +362,9 @@ no_dtcm:
 		start = &__sitcm_text;
 		end   = &__eitcm_text;
 		ram   = &__itcm_start;
+		pax_open_kernel();
 		memcpy(start, ram, itcm_code_sz);
+		pax_close_kernel();
 		pr_debug("CPU ITCM: copied code from %p - %p\n",
 			 start, end);
 		itcm_present = true;
diff --git a/arch/arm/kernel/traps.c b/arch/arm/kernel/traps.c
index bc698383e..e5dfdd404 100644
--- a/arch/arm/kernel/traps.c
+++ b/arch/arm/kernel/traps.c
@@ -65,7 +65,7 @@ static void dump_mem(const char *, const char *, unsigned long, unsigned long);
 void dump_backtrace_entry(unsigned long where, unsigned long from, unsigned long frame)
 {
 #ifdef CONFIG_KALLSYMS
-	printk("[<%08lx>] (%ps) from [<%08lx>] (%pS)\n", where, (void *)where, from, (void *)from);
+	printk("[<%08lx>] (%pA) from [<%08lx>] (%pA)\n", where, (void *)where, from, (void *)from);
 #else
 	printk("Function entered at [<%08lx>] from [<%08lx>]\n", where, from);
 #endif
@@ -267,6 +267,8 @@ static arch_spinlock_t die_lock = __ARCH_SPIN_LOCK_UNLOCKED;
 static int die_owner = -1;
 static unsigned int die_nest_count;
 
+extern void gr_handle_kernel_exploit(void);
+
 static unsigned long oops_begin(void)
 {
 	int cpu;
@@ -309,6 +311,9 @@ static void oops_end(unsigned long flags, struct pt_regs *regs, int signr)
 		panic("Fatal exception in interrupt");
 	if (panic_on_oops)
 		panic("Fatal exception");
+
+	gr_handle_kernel_exploit();
+
 	if (signr)
 		do_exit(signr);
 }
diff --git a/arch/arm/kernel/vmlinux.lds.S b/arch/arm/kernel/vmlinux.lds.S
index d24e5dd2a..77cf6cf94 100644
--- a/arch/arm/kernel/vmlinux.lds.S
+++ b/arch/arm/kernel/vmlinux.lds.S
@@ -44,7 +44,8 @@
 #endif
 
 #if (defined(CONFIG_SMP_ON_UP) && !defined(CONFIG_DEBUG_SPINLOCK)) || \
-	defined(CONFIG_GENERIC_BUG) || defined(CONFIG_JUMP_LABEL)
+	defined(CONFIG_GENERIC_BUG) || defined(CONFIG_JUMP_LABEL) || \
+	defined(CONFIG_PAX_REFCOUNT)
 #define ARM_EXIT_KEEP(x)	x
 #define ARM_EXIT_DISCARD(x)
 #else
diff --git a/arch/arm/kvm/arm.c b/arch/arm/kvm/arm.c
index c94b90d43..0cc68306e 100644
--- a/arch/arm/kvm/arm.c
+++ b/arch/arm/kvm/arm.c
@@ -59,7 +59,7 @@ static unsigned long hyp_default_vectors;
 static DEFINE_PER_CPU(struct kvm_vcpu *, kvm_arm_running_vcpu);
 
 /* The VMID used in the VTTBR */
-static atomic64_t kvm_vmid_gen = ATOMIC64_INIT(1);
+static atomic64_unchecked_t kvm_vmid_gen = ATOMIC64_INIT(1);
 static u32 kvm_next_vmid;
 static unsigned int kvm_vmid_bits __read_mostly;
 static DEFINE_SPINLOCK(kvm_vmid_lock);
@@ -388,7 +388,7 @@ void force_vm_exit(const cpumask_t *mask)
  */
 static bool need_new_vmid_gen(struct kvm *kvm)
 {
-	return unlikely(kvm->arch.vmid_gen != atomic64_read(&kvm_vmid_gen));
+	return unlikely(kvm->arch.vmid_gen != atomic64_read_unchecked(&kvm_vmid_gen));
 }
 
 /**
@@ -421,7 +421,7 @@ static void update_vttbr(struct kvm *kvm)
 
 	/* First user of a new VMID generation? */
 	if (unlikely(kvm_next_vmid == 0)) {
-		atomic64_inc(&kvm_vmid_gen);
+		atomic64_inc_unchecked(&kvm_vmid_gen);
 		kvm_next_vmid = 1;
 
 		/*
@@ -438,7 +438,7 @@ static void update_vttbr(struct kvm *kvm)
 		kvm_call_hyp(__kvm_flush_vm_context);
 	}
 
-	kvm->arch.vmid_gen = atomic64_read(&kvm_vmid_gen);
+	kvm->arch.vmid_gen = atomic64_read_unchecked(&kvm_vmid_gen);
 	kvm->arch.vmid = kvm_next_vmid;
 	kvm_next_vmid++;
 	kvm_next_vmid &= (1 << kvm_vmid_bits) - 1;
diff --git a/arch/arm/lib/copy_page.S b/arch/arm/lib/copy_page.S
index 6ee2f6706..d1cce7642 100644
--- a/arch/arm/lib/copy_page.S
+++ b/arch/arm/lib/copy_page.S
@@ -10,6 +10,7 @@
  *  ASM optimised string functions
  */
 #include <linux/linkage.h>
+#include <linux/const.h>
 #include <asm/assembler.h>
 #include <asm/asm-offsets.h>
 #include <asm/cache.h>
diff --git a/arch/arm/lib/csumpartialcopyuser.S b/arch/arm/lib/csumpartialcopyuser.S
index 1712f132b..a3165dc56 100644
--- a/arch/arm/lib/csumpartialcopyuser.S
+++ b/arch/arm/lib/csumpartialcopyuser.S
@@ -71,8 +71,8 @@
  *  Returns : r0 = checksum, [[sp, #0], #0] = 0 or -EFAULT
  */
 
-#define FN_ENTRY	ENTRY(csum_partial_copy_from_user)
-#define FN_EXIT		ENDPROC(csum_partial_copy_from_user)
+#define FN_ENTRY	ENTRY(__csum_partial_copy_from_user)
+#define FN_EXIT		ENDPROC(__csum_partial_copy_from_user)
 
 #include "csumpartialcopygeneric.S"
 
diff --git a/arch/arm/lib/delay.c b/arch/arm/lib/delay.c
index 8044591dc..c9b2609bb 100644
--- a/arch/arm/lib/delay.c
+++ b/arch/arm/lib/delay.c
@@ -29,7 +29,7 @@
 /*
  * Default to the loop-based delay implementation.
  */
-struct arm_delay_ops arm_delay_ops = {
+struct arm_delay_ops arm_delay_ops __read_only = {
 	.delay		= __loop_delay,
 	.const_udelay	= __loop_const_udelay,
 	.udelay		= __loop_udelay,
diff --git a/arch/arm/lib/uaccess_with_memcpy.c b/arch/arm/lib/uaccess_with_memcpy.c
index 6bd1089b0..e9994008b 100644
--- a/arch/arm/lib/uaccess_with_memcpy.c
+++ b/arch/arm/lib/uaccess_with_memcpy.c
@@ -84,7 +84,7 @@ pin_page_for_write(const void __user *_addr, pte_t **ptep, spinlock_t **ptlp)
 	return 1;
 }
 
-static unsigned long noinline
+static unsigned long noinline __size_overflow(3)
 __copy_to_user_memcpy(void __user *to, const void *from, unsigned long n)
 {
 	unsigned long ua_flags;
@@ -157,7 +157,7 @@ arm_copy_to_user(void __user *to, const void *from, unsigned long n)
 	return n;
 }
 	
-static unsigned long noinline
+static unsigned long noinline __size_overflow(2)
 __clear_user_memset(void __user *addr, unsigned long n)
 {
 	unsigned long ua_flags;
diff --git a/arch/arm/mach-exynos/suspend.c b/arch/arm/mach-exynos/suspend.c
index 06332f626..1fa0c7132 100644
--- a/arch/arm/mach-exynos/suspend.c
+++ b/arch/arm/mach-exynos/suspend.c
@@ -724,8 +724,10 @@ void __init exynos_pm_init(void)
 	tmp |= pm_data->wake_disable_mask;
 	pmu_raw_writel(tmp, S5P_WAKEUP_MASK);
 
-	exynos_pm_syscore_ops.suspend	= pm_data->pm_suspend;
-	exynos_pm_syscore_ops.resume	= pm_data->pm_resume;
+	pax_open_kernel();
+	const_cast(exynos_pm_syscore_ops.suspend)	= pm_data->pm_suspend;
+	const_cast(exynos_pm_syscore_ops.resume)	= pm_data->pm_resume;
+	pax_close_kernel();
 
 	register_syscore_ops(&exynos_pm_syscore_ops);
 	suspend_set_ops(&exynos_suspend_ops);
diff --git a/arch/arm/mach-mmp/mmp2.c b/arch/arm/mach-mmp/mmp2.c
index afba5460c..9e5403d90 100644
--- a/arch/arm/mach-mmp/mmp2.c
+++ b/arch/arm/mach-mmp/mmp2.c
@@ -98,7 +98,9 @@ void __init mmp2_init_irq(void)
 {
 	mmp2_init_icu();
 #ifdef CONFIG_PM
-	icu_irq_chip.irq_set_wake = mmp2_set_wake;
+	pax_open_kernel();
+	const_cast(icu_irq_chip.irq_set_wake) = mmp2_set_wake;
+	pax_close_kernel();
 #endif
 }
 
diff --git a/arch/arm/mach-mmp/pxa910.c b/arch/arm/mach-mmp/pxa910.c
index 1ccbba9ac..7a95c292f 100644
--- a/arch/arm/mach-mmp/pxa910.c
+++ b/arch/arm/mach-mmp/pxa910.c
@@ -84,7 +84,9 @@ void __init pxa910_init_irq(void)
 {
 	icu_init_irq();
 #ifdef CONFIG_PM
-	icu_irq_chip.irq_set_wake = pxa910_set_wake;
+	pax_open_kernel();
+	const_cast(icu_irq_chip.irq_set_wake) = pxa910_set_wake;
+	pax_close_kernel();
 #endif
 }
 
diff --git a/arch/arm/mach-mvebu/coherency.c b/arch/arm/mach-mvebu/coherency.c
index ae2a018b9..297ad08ab 100644
--- a/arch/arm/mach-mvebu/coherency.c
+++ b/arch/arm/mach-mvebu/coherency.c
@@ -156,7 +156,7 @@ exit:
 
 /*
  * This ioremap hook is used on Armada 375/38x to ensure that all MMIO
- * areas are mapped as MT_UNCACHED instead of MT_DEVICE. This is
+ * areas are mapped as MT_UNCACHED_RW instead of MT_DEVICE. This is
  * needed for the HW I/O coherency mechanism to work properly without
  * deadlock.
  */
@@ -164,7 +164,7 @@ static void __iomem *
 armada_wa_ioremap_caller(phys_addr_t phys_addr, size_t size,
 			 unsigned int mtype, void *caller)
 {
-	mtype = MT_UNCACHED;
+	mtype = MT_UNCACHED_RW;
 	return __arm_ioremap_caller(phys_addr, size, mtype, caller);
 }
 
@@ -174,7 +174,7 @@ static void __init armada_375_380_coherency_init(struct device_node *np)
 
 	coherency_cpu_base = of_iomap(np, 0);
 	arch_ioremap_caller = armada_wa_ioremap_caller;
-	pci_ioremap_set_mem_type(MT_UNCACHED);
+	pci_ioremap_set_mem_type(MT_UNCACHED_RW);
 
 	/*
 	 * We should switch the PL310 to I/O coherency mode only if
diff --git a/arch/arm/mach-mvebu/pmsu.c b/arch/arm/mach-mvebu/pmsu.c
index f39bd51bc..866c78042 100644
--- a/arch/arm/mach-mvebu/pmsu.c
+++ b/arch/arm/mach-mvebu/pmsu.c
@@ -93,7 +93,7 @@
 #define ARMADA_370_CRYPT0_ENG_ATTR     0x1
 
 extern void ll_disable_coherency(void);
-extern void ll_enable_coherency(void);
+extern int ll_enable_coherency(void);
 
 extern void armada_370_xp_cpu_resume(void);
 extern void armada_38x_cpu_resume(void);
diff --git a/arch/arm/mach-omap2/board-n8x0.c b/arch/arm/mach-omap2/board-n8x0.c
index b6443a4e0..20a0b7405 100644
--- a/arch/arm/mach-omap2/board-n8x0.c
+++ b/arch/arm/mach-omap2/board-n8x0.c
@@ -569,7 +569,7 @@ static int n8x0_menelaus_late_init(struct device *dev)
 }
 #endif
 
-struct menelaus_platform_data n8x0_menelaus_platform_data __initdata = {
+struct menelaus_platform_data n8x0_menelaus_platform_data __initconst = {
 	.late_init = n8x0_menelaus_late_init,
 };
 
diff --git a/arch/arm/mach-omap2/omap-mpuss-lowpower.c b/arch/arm/mach-omap2/omap-mpuss-lowpower.c
index ad982465e..69437a80e 100644
--- a/arch/arm/mach-omap2/omap-mpuss-lowpower.c
+++ b/arch/arm/mach-omap2/omap-mpuss-lowpower.c
@@ -88,7 +88,7 @@ struct cpu_pm_ops {
 	void (*resume)(void);
 	void (*scu_prepare)(unsigned int cpu_id, unsigned int cpu_state);
 	void (*hotplug_restart)(void);
-};
+} __no_const;
 
 static DEFINE_PER_CPU(struct omap4_cpu_pm_info, omap4_pm_info);
 static struct powerdomain *mpuss_pd;
@@ -106,7 +106,7 @@ static void dummy_cpu_resume(void)
 static void dummy_scu_prepare(unsigned int cpu_id, unsigned int cpu_state)
 {}
 
-static struct cpu_pm_ops omap_pm_ops = {
+static struct cpu_pm_ops omap_pm_ops __read_only = {
 	.finish_suspend		= default_finish_suspend,
 	.resume			= dummy_cpu_resume,
 	.scu_prepare		= dummy_scu_prepare,
diff --git a/arch/arm/mach-omap2/omap-smp.c b/arch/arm/mach-omap2/omap-smp.c
index b4de3da6d..e02739337 100644
--- a/arch/arm/mach-omap2/omap-smp.c
+++ b/arch/arm/mach-omap2/omap-smp.c
@@ -19,6 +19,7 @@
 #include <linux/device.h>
 #include <linux/smp.h>
 #include <linux/io.h>
+#include <linux/irq.h>
 #include <linux/irqchip/arm-gic.h>
 
 #include <asm/smp_scu.h>
diff --git a/arch/arm/mach-omap2/omap_device.c b/arch/arm/mach-omap2/omap_device.c
index e920dd83e..ef999171b 100644
--- a/arch/arm/mach-omap2/omap_device.c
+++ b/arch/arm/mach-omap2/omap_device.c
@@ -530,7 +530,7 @@ void omap_device_delete(struct omap_device *od)
 struct platform_device __init *omap_device_build(const char *pdev_name,
 						 int pdev_id,
 						 struct omap_hwmod *oh,
-						 void *pdata, int pdata_len)
+						 const void *pdata, int pdata_len)
 {
 	struct omap_hwmod *ohs[] = { oh };
 
@@ -558,7 +558,7 @@ struct platform_device __init *omap_device_build(const char *pdev_name,
 struct platform_device __init *omap_device_build_ss(const char *pdev_name,
 						    int pdev_id,
 						    struct omap_hwmod **ohs,
-						    int oh_cnt, void *pdata,
+						    int oh_cnt, const void *pdata,
 						    int pdata_len)
 {
 	int ret = -ENOMEM;
diff --git a/arch/arm/mach-omap2/omap_device.h b/arch/arm/mach-omap2/omap_device.h
index 78c02b355..c94109a2f 100644
--- a/arch/arm/mach-omap2/omap_device.h
+++ b/arch/arm/mach-omap2/omap_device.h
@@ -72,12 +72,12 @@ int omap_device_idle(struct platform_device *pdev);
 /* Core code interface */
 
 struct platform_device *omap_device_build(const char *pdev_name, int pdev_id,
-					  struct omap_hwmod *oh, void *pdata,
+					  struct omap_hwmod *oh, const void *pdata,
 					  int pdata_len);
 
 struct platform_device *omap_device_build_ss(const char *pdev_name, int pdev_id,
 					 struct omap_hwmod **oh, int oh_cnt,
-					 void *pdata, int pdata_len);
+					 const void *pdata, int pdata_len);
 
 struct omap_device *omap_device_alloc(struct platform_device *pdev,
 				      struct omap_hwmod **ohs, int oh_cnt);
diff --git a/arch/arm/mach-omap2/omap_hwmod.c b/arch/arm/mach-omap2/omap_hwmod.c
index 1052b2969..54669b02d 100644
--- a/arch/arm/mach-omap2/omap_hwmod.c
+++ b/arch/arm/mach-omap2/omap_hwmod.c
@@ -206,10 +206,10 @@ struct omap_hwmod_soc_ops {
 	void (*update_context_lost)(struct omap_hwmod *oh);
 	int (*get_context_lost)(struct omap_hwmod *oh);
 	int (*disable_direct_prcm)(struct omap_hwmod *oh);
-};
+} __no_const;
 
 /* soc_ops: adapts the omap_hwmod code to the currently-booted SoC */
-static struct omap_hwmod_soc_ops soc_ops;
+static struct omap_hwmod_soc_ops soc_ops __read_only;
 
 /* omap_hwmod_list contains all registered struct omap_hwmods */
 static LIST_HEAD(omap_hwmod_list);
diff --git a/arch/arm/mach-omap2/powerdomains43xx_data.c b/arch/arm/mach-omap2/powerdomains43xx_data.c
index 95fee54c3..b5dd79d96 100644
--- a/arch/arm/mach-omap2/powerdomains43xx_data.c
+++ b/arch/arm/mach-omap2/powerdomains43xx_data.c
@@ -10,6 +10,7 @@
 
 #include <linux/kernel.h>
 #include <linux/init.h>
+#include <asm/pgtable.h>
 
 #include "powerdomain.h"
 
@@ -129,7 +130,9 @@ static int am43xx_check_vcvp(void)
 
 void __init am43xx_powerdomains_init(void)
 {
-	omap4_pwrdm_operations.pwrdm_has_voltdm = am43xx_check_vcvp;
+	pax_open_kernel();
+	const_cast(omap4_pwrdm_operations.pwrdm_has_voltdm) = am43xx_check_vcvp;
+	pax_close_kernel();
 	pwrdm_register_platform_funcs(&omap4_pwrdm_operations);
 	pwrdm_register_pwrdms(powerdomains_am43xx);
 	pwrdm_complete_init();
diff --git a/arch/arm/mach-omap2/wd_timer.c b/arch/arm/mach-omap2/wd_timer.c
index ff0a68cf7..b312aa004 100644
--- a/arch/arm/mach-omap2/wd_timer.c
+++ b/arch/arm/mach-omap2/wd_timer.c
@@ -110,7 +110,9 @@ static int __init omap_init_wdt(void)
 	struct omap_hwmod *oh;
 	char *oh_name = "wd_timer2";
 	char *dev_name = "omap_wdt";
-	struct omap_wd_timer_platform_data pdata;
+	static struct omap_wd_timer_platform_data pdata = {
+		.read_reset_sources = prm_read_reset_sources
+	};
 
 	if (!cpu_class_is_omap2() || of_have_populated_dt())
 		return 0;
@@ -121,8 +123,6 @@ static int __init omap_init_wdt(void)
 		return -EINVAL;
 	}
 
-	pdata.read_reset_sources = prm_read_reset_sources;
-
 	pdev = omap_device_build(dev_name, id, oh, &pdata,
 				 sizeof(struct omap_wd_timer_platform_data));
 	WARN(IS_ERR(pdev), "Can't build omap_device for %s:%s.\n",
diff --git a/arch/arm/mach-s3c64xx/mach-smdk6410.c b/arch/arm/mach-s3c64xx/mach-smdk6410.c
index 92ec8c3b4..3b094723b 100644
--- a/arch/arm/mach-s3c64xx/mach-smdk6410.c
+++ b/arch/arm/mach-s3c64xx/mach-smdk6410.c
@@ -240,7 +240,7 @@ static struct platform_device smdk6410_b_pwr_5v = {
 };
 #endif
 
-static struct s3c_ide_platdata smdk6410_ide_pdata __initdata = {
+static const struct s3c_ide_platdata smdk6410_ide_pdata __initconst = {
 	.setup_gpio	= s3c64xx_ide_setup_gpio,
 };
 
diff --git a/arch/arm/mach-shmobile/platsmp-apmu.c b/arch/arm/mach-shmobile/platsmp-apmu.c
index 0c6bb458b..0f18d70ab 100644
--- a/arch/arm/mach-shmobile/platsmp-apmu.c
+++ b/arch/arm/mach-shmobile/platsmp-apmu.c
@@ -22,6 +22,7 @@
 #include <asm/proc-fns.h>
 #include <asm/smp_plat.h>
 #include <asm/suspend.h>
+#include <asm/pgtable.h>
 #include "common.h"
 #include "platsmp-apmu.h"
 #include "rcar-gen2.h"
@@ -316,6 +317,8 @@ static int shmobile_smp_apmu_enter_suspend(suspend_state_t state)
 
 void __init shmobile_smp_apmu_suspend_init(void)
 {
-	shmobile_suspend_ops.enter = shmobile_smp_apmu_enter_suspend;
+	pax_open_kernel();
+	const_cast(shmobile_suspend_ops.enter) = shmobile_smp_apmu_enter_suspend;
+	pax_close_kernel();
 }
 #endif
diff --git a/arch/arm/mach-tegra/cpuidle-tegra20.c b/arch/arm/mach-tegra/cpuidle-tegra20.c
index afcee04f2..63e52ac6c 100644
--- a/arch/arm/mach-tegra/cpuidle-tegra20.c
+++ b/arch/arm/mach-tegra/cpuidle-tegra20.c
@@ -178,7 +178,7 @@ static int tegra20_idle_lp2_coupled(struct cpuidle_device *dev,
 	bool entered_lp2 = false;
 
 	if (tegra_pending_sgi())
-		ACCESS_ONCE(abort_flag) = true;
+		ACCESS_ONCE_RW(abort_flag) = true;
 
 	cpuidle_coupled_parallel_barrier(dev, &abort_barrier);
 
diff --git a/arch/arm/mach-tegra/irq.c b/arch/arm/mach-tegra/irq.c
index a69b22d37..8523a039e 100644
--- a/arch/arm/mach-tegra/irq.c
+++ b/arch/arm/mach-tegra/irq.c
@@ -20,6 +20,7 @@
 #include <linux/cpu_pm.h>
 #include <linux/interrupt.h>
 #include <linux/io.h>
+#include <linux/irq.h>
 #include <linux/irqchip/arm-gic.h>
 #include <linux/irq.h>
 #include <linux/kernel.h>
diff --git a/arch/arm/mach-ux500/pm.c b/arch/arm/mach-ux500/pm.c
index 8538910db..2f39bc4d6 100644
--- a/arch/arm/mach-ux500/pm.c
+++ b/arch/arm/mach-ux500/pm.c
@@ -10,6 +10,7 @@
  */
 
 #include <linux/kernel.h>
+#include <linux/irq.h>
 #include <linux/irqchip/arm-gic.h>
 #include <linux/delay.h>
 #include <linux/io.h>
diff --git a/arch/arm/mach-zynq/platsmp.c b/arch/arm/mach-zynq/platsmp.c
index 7cd9865bd..a00b6abdc 100644
--- a/arch/arm/mach-zynq/platsmp.c
+++ b/arch/arm/mach-zynq/platsmp.c
@@ -24,6 +24,7 @@
 #include <linux/io.h>
 #include <asm/cacheflush.h>
 #include <asm/smp_scu.h>
+#include <linux/irq.h>
 #include <linux/irqchip/arm-gic.h>
 #include "common.h"
 
diff --git a/arch/arm/mm/Kconfig b/arch/arm/mm/Kconfig
index d15a7fe51..6cc4fc907 100644
--- a/arch/arm/mm/Kconfig
+++ b/arch/arm/mm/Kconfig
@@ -445,6 +445,7 @@ config CPU_32v5
 
 config CPU_32v6
 	bool
+	select CPU_USE_DOMAINS if CPU_V6 && MMU && !PAX_KERNEXEC && !PAX_MEMORY_UDEREF
 	select TLS_REG_EMUL if !CPU_32v6K && !MMU
 
 config CPU_32v6K
@@ -599,6 +600,7 @@ config CPU_CP15_MPU
 
 config CPU_USE_DOMAINS
 	bool
+	depends on !ARM_LPAE && !PAX_KERNEXEC && !PAX_MEMORY_UDEREF
 	help
 	  This option enables or disables the use of domain switching
 	  via the set_fs() function.
@@ -809,7 +811,7 @@ config NEED_KUSER_HELPERS
 
 config KUSER_HELPERS
 	bool "Enable kuser helpers in vector page" if !NEED_KUSER_HELPERS
-	depends on MMU
+	depends on MMU && (!(CPU_V6 || CPU_V6K || CPU_V7) || GRKERNSEC_OLD_ARM_USERLAND)
 	default y
 	help
 	  Warning: disabling this option may break user programs.
@@ -823,7 +825,7 @@ config KUSER_HELPERS
 	  See Documentation/arm/kernel_user_helpers.txt for details.
 
 	  However, the fixed address nature of these helpers can be used
-	  by ROP (return orientated programming) authors when creating
+	  by ROP (Return Oriented Programming) authors when creating
 	  exploits.
 
 	  If all of the binaries and libraries which run on your platform
@@ -838,7 +840,7 @@ config KUSER_HELPERS
 
 config VDSO
 	bool "Enable VDSO for acceleration of some system calls"
-	depends on AEABI && MMU && CPU_V7
+	depends on AEABI && MMU && CPU_V7 && !PAX_KERNEXEC && !PAX_MEMORY_UDEREF
 	default y if ARM_ARCH_TIMER
 	select GENERIC_TIME_VSYSCALL
 	help
diff --git a/arch/arm/mm/alignment.c b/arch/arm/mm/alignment.c
index 7d5f4c736..c6a081602 100644
--- a/arch/arm/mm/alignment.c
+++ b/arch/arm/mm/alignment.c
@@ -778,6 +778,7 @@ do_alignment(unsigned long addr, unsigned int fsr, struct pt_regs *regs)
 	u16 tinstr = 0;
 	int isize = 4;
 	int thumb2_32b = 0;
+	bool is_user_mode = user_mode(regs);
 
 	if (interrupts_enabled(regs))
 		local_irq_enable();
@@ -786,14 +787,24 @@ do_alignment(unsigned long addr, unsigned int fsr, struct pt_regs *regs)
 
 	if (thumb_mode(regs)) {
 		u16 *ptr = (u16 *)(instrptr & ~1);
-		fault = probe_kernel_address(ptr, tinstr);
+		if (is_user_mode) {
+			pax_open_userland();
+			fault = probe_kernel_address(ptr, tinstr);
+			pax_close_userland();
+		} else
+			fault = probe_kernel_address(ptr, tinstr);
 		tinstr = __mem_to_opcode_thumb16(tinstr);
 		if (!fault) {
 			if (cpu_architecture() >= CPU_ARCH_ARMv7 &&
 			    IS_T32(tinstr)) {
 				/* Thumb-2 32-bit */
 				u16 tinst2 = 0;
-				fault = probe_kernel_address(ptr + 1, tinst2);
+				if (is_user_mode) {
+					pax_open_userland();
+					fault = probe_kernel_address(ptr + 1, tinst2);
+					pax_close_userland();
+				} else
+					fault = probe_kernel_address(ptr + 1, tinst2);
 				tinst2 = __mem_to_opcode_thumb16(tinst2);
 				instr = __opcode_thumb32_compose(tinstr, tinst2);
 				thumb2_32b = 1;
@@ -803,7 +814,12 @@ do_alignment(unsigned long addr, unsigned int fsr, struct pt_regs *regs)
 			}
 		}
 	} else {
-		fault = probe_kernel_address((void *)instrptr, instr);
+		if (is_user_mode) {
+			pax_open_userland();
+			fault = probe_kernel_address((void *)instrptr, instr);
+			pax_close_userland();
+		} else
+			fault = probe_kernel_address((void *)instrptr, instr);
 		instr = __mem_to_opcode_arm(instr);
 	}
 
@@ -812,7 +828,7 @@ do_alignment(unsigned long addr, unsigned int fsr, struct pt_regs *regs)
 		goto bad_or_fault;
 	}
 
-	if (user_mode(regs))
+	if (is_user_mode)
 		goto user;
 
 	ai_sys += 1;
diff --git a/arch/arm/mm/cache-l2x0.c b/arch/arm/mm/cache-l2x0.c
index cc12905ae..88463b3fc 100644
--- a/arch/arm/mm/cache-l2x0.c
+++ b/arch/arm/mm/cache-l2x0.c
@@ -44,7 +44,7 @@ struct l2c_init_data {
 	void (*configure)(void __iomem *);
 	void (*unlock)(void __iomem *, unsigned);
 	struct outer_cache_fns outer_cache;
-};
+} __do_const;
 
 #define CACHE_LINE_SIZE		32
 
diff --git a/arch/arm/mm/context.c b/arch/arm/mm/context.c
index c8c8b9ed0..c55cc79e7 100644
--- a/arch/arm/mm/context.c
+++ b/arch/arm/mm/context.c
@@ -43,7 +43,7 @@
 #define NUM_USER_ASIDS		ASID_FIRST_VERSION
 
 static DEFINE_RAW_SPINLOCK(cpu_asid_lock);
-static atomic64_t asid_generation = ATOMIC64_INIT(ASID_FIRST_VERSION);
+static atomic64_unchecked_t asid_generation = ATOMIC64_INIT(ASID_FIRST_VERSION);
 static DECLARE_BITMAP(asid_map, NUM_USER_ASIDS);
 
 static DEFINE_PER_CPU(atomic64_t, active_asids);
@@ -193,7 +193,7 @@ static u64 new_context(struct mm_struct *mm, unsigned int cpu)
 {
 	static u32 cur_idx = 1;
 	u64 asid = atomic64_read(&mm->context.id);
-	u64 generation = atomic64_read(&asid_generation);
+	u64 generation = atomic64_read_unchecked(&asid_generation);
 
 	if (asid != 0) {
 		u64 newasid = generation | (asid & ~ASID_MASK);
@@ -225,7 +225,7 @@ static u64 new_context(struct mm_struct *mm, unsigned int cpu)
 	 */
 	asid = find_next_zero_bit(asid_map, NUM_USER_ASIDS, cur_idx);
 	if (asid == NUM_USER_ASIDS) {
-		generation = atomic64_add_return(ASID_FIRST_VERSION,
+		generation = atomic64_add_return_unchecked(ASID_FIRST_VERSION,
 						 &asid_generation);
 		flush_context(cpu);
 		asid = find_next_zero_bit(asid_map, NUM_USER_ASIDS, 1);
@@ -254,14 +254,14 @@ void check_and_switch_context(struct mm_struct *mm, struct task_struct *tsk)
 	cpu_set_reserved_ttbr0();
 
 	asid = atomic64_read(&mm->context.id);
-	if (!((asid ^ atomic64_read(&asid_generation)) >> ASID_BITS)
+	if (!((asid ^ atomic64_read_unchecked(&asid_generation)) >> ASID_BITS)
 	    && atomic64_xchg(&per_cpu(active_asids, cpu), asid))
 		goto switch_mm_fastpath;
 
 	raw_spin_lock_irqsave(&cpu_asid_lock, flags);
 	/* Check that our ASID belongs to the current generation. */
 	asid = atomic64_read(&mm->context.id);
-	if ((asid ^ atomic64_read(&asid_generation)) >> ASID_BITS) {
+	if ((asid ^ atomic64_read_unchecked(&asid_generation)) >> ASID_BITS) {
 		asid = new_context(mm, cpu);
 		atomic64_set(&mm->context.id, asid);
 	}
diff --git a/arch/arm/mm/fault.c b/arch/arm/mm/fault.c
index 3a2e678b8..ebdbf80ef 100644
--- a/arch/arm/mm/fault.c
+++ b/arch/arm/mm/fault.c
@@ -25,6 +25,7 @@
 #include <asm/system_misc.h>
 #include <asm/system_info.h>
 #include <asm/tlbflush.h>
+#include <asm/sections.h>
 
 #include "fault.h"
 
@@ -138,6 +139,31 @@ __do_kernel_fault(struct mm_struct *mm, unsigned long addr, unsigned int fsr,
 	if (fixup_exception(regs))
 		return;
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (addr < TASK_SIZE) {
+		if (current->signal->curr_ip)
+			printk(KERN_EMERG "PAX: From %pI4: %s:%d, uid/euid: %u/%u, attempted to access userland memory at %08lx\n", &current->signal->curr_ip, current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()), addr);
+		else
+			printk(KERN_EMERG "PAX: %s:%d, uid/euid: %u/%u, attempted to access userland memory at %08lx\n", current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()), addr);
+	}
+#endif
+
+#ifdef CONFIG_PAX_KERNEXEC
+	if ((fsr & FSR_WRITE) &&
+	    (((unsigned long)_stext <= addr && addr < init_mm.end_code) ||
+	     (MODULES_VADDR <= addr && addr < MODULES_END)))
+	{
+		if (current->signal->curr_ip)
+			printk(KERN_EMERG "PAX: From %pI4: %s:%d, uid/euid: %u/%u, attempted to modify kernel code\n", &current->signal->curr_ip, current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()));
+		else
+			printk(KERN_EMERG "PAX: %s:%d, uid/euid: %u/%u, attempted to modify kernel code\n", current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()));
+	}
+#endif
+
 	/*
 	 * No handler, we'll have to terminate things with extreme prejudice.
 	 */
@@ -173,6 +199,13 @@ __do_user_fault(struct task_struct *tsk, unsigned long addr,
 	}
 #endif
 
+#ifdef CONFIG_PAX_PAGEEXEC
+	if ((tsk->mm->pax_flags & MF_PAX_PAGEEXEC) && (fsr & FSR_LNX_PF)) {
+		pax_report_fault(regs, (void *)regs->ARM_pc, (void *)regs->ARM_sp);
+		do_group_exit(SIGKILL);
+	}
+#endif
+
 	tsk->thread.address = addr;
 	tsk->thread.error_code = fsr;
 	tsk->thread.trap_no = 14;
@@ -400,6 +433,33 @@ do_page_fault(unsigned long addr, unsigned int fsr, struct pt_regs *regs)
 }
 #endif					/* CONFIG_MMU */
 
+#ifdef CONFIG_PAX_PAGEEXEC
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 20; i++) {
+		unsigned char c;
+		if (get_user(c, (__force unsigned char __user *)pc+i))
+			printk(KERN_CONT "?? ");
+		else
+			printk(KERN_CONT "%02x ", c);
+	}
+	printk("\n");
+
+	printk(KERN_ERR "PAX: bytes at SP-4: ");
+	for (i = -1; i < 20; i++) {
+		unsigned long c;
+		if (get_user(c, (__force unsigned long __user *)sp+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08lx ", c);
+	}
+	printk("\n");
+}
+#endif
+
 /*
  * First Level Translation Fault Handler
  *
@@ -547,9 +607,22 @@ do_DataAbort(unsigned long addr, unsigned int fsr, struct pt_regs *regs)
 	const struct fsr_info *inf = fsr_info + fsr_fs(fsr);
 	struct siginfo info;
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (addr < TASK_SIZE && is_domain_fault(fsr)) {
+		if (current->signal->curr_ip)
+			printk(KERN_EMERG "PAX: From %pI4: %s:%d, uid/euid: %u/%u, attempted to access userland memory at %08lx\n", &current->signal->curr_ip, current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()), addr);
+		else
+			printk(KERN_EMERG "PAX: %s:%d, uid/euid: %u/%u, attempted to access userland memory at %08lx\n", current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()), addr);
+		goto die;
+	}
+#endif
+
 	if (!inf->fn(addr, fsr & ~FSR_LNX_PF, regs))
 		return;
 
+die:
 	pr_alert("Unhandled fault: %s (0x%03x) at 0x%08lx\n",
 		inf->name, fsr, addr);
 	show_pte(current->mm, addr);
@@ -574,15 +647,118 @@ hook_ifault_code(int nr, int (*fn)(unsigned long, unsigned int, struct pt_regs *
 	ifsr_info[nr].name = name;
 }
 
+asmlinkage int sys_sigreturn(struct pt_regs *regs);
+asmlinkage int sys_rt_sigreturn(struct pt_regs *regs);
+
 asmlinkage void __exception
 do_PrefetchAbort(unsigned long addr, unsigned int ifsr, struct pt_regs *regs)
 {
 	const struct fsr_info *inf = ifsr_info + fsr_fs(ifsr);
 	struct siginfo info;
+	unsigned long pc = instruction_pointer(regs);
+
+	if (user_mode(regs)) {
+		unsigned long sigpage = current->mm->context.sigpage;
+
+		if (sigpage <= pc && pc < sigpage + 7*4) {
+			if (pc < sigpage + 3*4)
+				sys_sigreturn(regs);
+			else
+				sys_rt_sigreturn(regs);
+			return;
+		}
+		if (pc == 0xffff0f60UL) {
+			/*
+			 * PaX: __kuser_cmpxchg64 emulation
+			 */
+			// TODO
+			//regs->ARM_pc = regs->ARM_lr;
+			//return;
+		}
+		if (pc == 0xffff0fa0UL) {
+			/*
+			 * PaX: __kuser_memory_barrier emulation
+			 */
+			// dmb(); implied by the exception
+			regs->ARM_pc = regs->ARM_lr;
+#ifdef CONFIG_ARM_THUMB
+			if (regs->ARM_lr & 1) {
+				regs->ARM_cpsr |= PSR_T_BIT;
+				regs->ARM_pc &= ~0x1U;
+			} else
+				regs->ARM_cpsr &= ~PSR_T_BIT;
+#endif
+			return;
+		}
+		if (pc == 0xffff0fc0UL) {
+			/*
+			 * PaX: __kuser_cmpxchg emulation
+			 */
+			// TODO
+			//long new;
+			//int op;
+
+			//op = FUTEX_OP_SET << 28;
+			//new = futex_atomic_op_inuser(op, regs->ARM_r2);
+			//regs->ARM_r0 = old != new;
+			//regs->ARM_pc = regs->ARM_lr;
+			//return;
+		}
+		if (pc == 0xffff0fe0UL) {
+			/*
+			 * PaX: __kuser_get_tls emulation
+			 */
+			regs->ARM_r0 = current_thread_info()->tp_value[0];
+			regs->ARM_pc = regs->ARM_lr;
+#ifdef CONFIG_ARM_THUMB
+			if (regs->ARM_lr & 1) {
+				regs->ARM_cpsr |= PSR_T_BIT;
+				regs->ARM_pc &= ~0x1U;
+			} else
+				regs->ARM_cpsr &= ~PSR_T_BIT;
+#endif
+			return;
+		}
+	}
+
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	else if (is_domain_fault(ifsr) || is_xn_fault(ifsr)) {
+		if (current->signal->curr_ip)
+			printk(KERN_EMERG "PAX: From %pI4: %s:%d, uid/euid: %u/%u, attempted to execute %s memory at %08lx\n", &current->signal->curr_ip, current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()),
+					pc >= TASK_SIZE ? "non-executable kernel" : "userland", pc);
+		else
+			printk(KERN_EMERG "PAX: %s:%d, uid/euid: %u/%u, attempted to execute %s memory at %08lx\n", current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()),
+					pc >= TASK_SIZE ? "non-executable kernel" : "userland", pc);
+		goto die;
+	}
+#endif
+
+#ifdef CONFIG_PAX_REFCOUNT
+	if (fsr_fs(ifsr) == FAULT_CODE_DEBUG) {
+#ifdef CONFIG_THUMB2_KERNEL
+		unsigned short bkpt;
+
+		if (!probe_kernel_address((const unsigned short *)pc, bkpt) && cpu_to_le16(bkpt) == 0xbef1) {
+#else
+		unsigned int bkpt;
+
+		if (!probe_kernel_address((const unsigned int *)pc, bkpt) && cpu_to_le32(bkpt) == 0xe12f1073) {
+#endif
+			current->thread.error_code = ifsr;
+			current->thread.trap_no = 0;
+			pax_report_refcount_error(regs, NULL);
+			fixup_exception(regs);
+			return;
+		}
+	}
+#endif
 
 	if (!inf->fn(addr, ifsr | FSR_LNX_PF, regs))
 		return;
 
+die:
 	pr_alert("Unhandled prefetch abort: %s (0x%03x) at 0x%08lx\n",
 		inf->name, ifsr, addr);
 
diff --git a/arch/arm/mm/fault.h b/arch/arm/mm/fault.h
index 05ec5e0df..0b70277aa 100644
--- a/arch/arm/mm/fault.h
+++ b/arch/arm/mm/fault.h
@@ -3,6 +3,7 @@
 
 /*
  * Fault status register encodings.  We steal bit 31 for our own purposes.
+ * Set when the FSR value is from an instruction fault.
  */
 #define FSR_LNX_PF		(1 << 31)
 #define FSR_WRITE		(1 << 11)
@@ -22,6 +23,17 @@ static inline int fsr_fs(unsigned int fsr)
 }
 #endif
 
+/* valid for LPAE and !LPAE */
+static inline int is_xn_fault(unsigned int fsr)
+{
+	return ((fsr_fs(fsr) & 0x3c) == 0xc);
+}
+
+static inline int is_domain_fault(unsigned int fsr)
+{
+	return ((fsr_fs(fsr) & 0xD) == 0x9);
+}
+
 void do_bad_area(unsigned long addr, unsigned int fsr, struct pt_regs *regs);
 unsigned long search_exception_table(unsigned long addr);
 void early_abt_enable(void);
diff --git a/arch/arm/mm/init.c b/arch/arm/mm/init.c
index 370581aeb..b985cc165 100644
--- a/arch/arm/mm/init.c
+++ b/arch/arm/mm/init.c
@@ -747,7 +747,46 @@ void free_tcmmem(void)
 {
 #ifdef CONFIG_HAVE_TCM
 	extern char __tcm_start, __tcm_end;
+#endif
 
+#ifdef CONFIG_PAX_KERNEXEC
+	unsigned long addr;
+	pgd_t *pgd;
+	pud_t *pud;
+	pmd_t *pmd;
+	int cpu_arch = cpu_architecture();
+	unsigned int cr = get_cr();
+
+	if (cpu_arch >= CPU_ARCH_ARMv6 && (cr & CR_XP)) {
+		/* make pages tables, etc before .text NX */
+		for (addr = PAGE_OFFSET; addr < (unsigned long)_stext; addr += SECTION_SIZE) {
+			pgd = pgd_offset_k(addr);
+			pud = pud_offset(pgd, addr);
+			pmd = pmd_offset(pud, addr);
+			__section_update(pmd, addr, PMD_SECT_XN);
+		}
+		/* make init NX */
+		for (addr = (unsigned long)__init_begin; addr < (unsigned long)_sdata; addr += SECTION_SIZE) {
+			pgd = pgd_offset_k(addr);
+			pud = pud_offset(pgd, addr);
+			pmd = pmd_offset(pud, addr);
+			__section_update(pmd, addr, PMD_SECT_XN);
+		}
+		/* make kernel code/rodata RX */
+		for (addr = (unsigned long)_stext; addr < (unsigned long)__init_begin; addr += SECTION_SIZE) {
+			pgd = pgd_offset_k(addr);
+			pud = pud_offset(pgd, addr);
+			pmd = pmd_offset(pud, addr);
+#ifdef CONFIG_ARM_LPAE
+			__section_update(pmd, addr, PMD_SECT_RDONLY);
+#else
+			__section_update(pmd, addr, PMD_SECT_APX|PMD_SECT_AP_WRITE);
+#endif
+		}
+	}
+#endif
+
+#ifdef CONFIG_HAVE_TCM
 	poison_init_mem(&__tcm_start, &__tcm_end - &__tcm_start);
 	free_reserved_area(&__tcm_start, &__tcm_end, -1, "TCM link");
 #endif
diff --git a/arch/arm/mm/ioremap.c b/arch/arm/mm/ioremap.c
index ff0eed23d..f17f1c920 100644
--- a/arch/arm/mm/ioremap.c
+++ b/arch/arm/mm/ioremap.c
@@ -411,9 +411,9 @@ __arm_ioremap_exec(phys_addr_t phys_addr, size_t size, bool cached)
 	unsigned int mtype;
 
 	if (cached)
-		mtype = MT_MEMORY_RWX;
+		mtype = MT_MEMORY_RX;
 	else
-		mtype = MT_MEMORY_RWX_NONCACHED;
+		mtype = MT_MEMORY_RX_NONCACHED;
 
 	return __arm_ioremap_caller(phys_addr, size, mtype,
 			__builtin_return_address(0));
diff --git a/arch/arm/mm/mmap.c b/arch/arm/mm/mmap.c
index 66353caa3..8aad9f865 100644
--- a/arch/arm/mm/mmap.c
+++ b/arch/arm/mm/mmap.c
@@ -59,6 +59,7 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	struct vm_area_struct *vma;
 	int do_align = 0;
 	int aliasing = cache_is_vipt_aliasing();
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 	struct vm_unmapped_area_info info;
 
 	/*
@@ -81,6 +82,10 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	if (len > TASK_SIZE)
 		return -ENOMEM;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		if (do_align)
 			addr = COLOUR_ALIGN(addr, pgoff);
@@ -88,8 +93,7 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 			addr = PAGE_ALIGN(addr);
 
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -99,19 +103,21 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	info.high_limit = TASK_SIZE;
 	info.align_mask = do_align ? (PAGE_MASK & (SHMLBA - 1)) : 0;
 	info.align_offset = pgoff << PAGE_SHIFT;
+	info.threadstack_offset = offset;
 	return vm_unmapped_area(&info);
 }
 
 unsigned long
-arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
-			const unsigned long len, const unsigned long pgoff,
-			const unsigned long flags)
+arch_get_unmapped_area_topdown(struct file *filp, unsigned long addr0,
+			unsigned long len, unsigned long pgoff,
+			unsigned long flags)
 {
 	struct vm_area_struct *vma;
 	struct mm_struct *mm = current->mm;
 	unsigned long addr = addr0;
 	int do_align = 0;
 	int aliasing = cache_is_vipt_aliasing();
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 	struct vm_unmapped_area_info info;
 
 	/*
@@ -132,6 +138,10 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		return addr;
 	}
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	/* requesting a specific address */
 	if (addr) {
 		if (do_align)
@@ -139,8 +149,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		else
 			addr = PAGE_ALIGN(addr);
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-				(!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -150,6 +159,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	info.high_limit = mm->mmap_base;
 	info.align_mask = do_align ? (PAGE_MASK & (SHMLBA - 1)) : 0;
 	info.align_offset = pgoff << PAGE_SHIFT;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 	/*
@@ -182,14 +192,30 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 {
 	unsigned long random_factor = 0UL;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (current->flags & PF_RANDOMIZE)
 		random_factor = arch_mmap_rnd();
 
 	if (mmap_is_legacy()) {
 		mm->mmap_base = TASK_UNMAPPED_BASE + random_factor;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base += mm->delta_mmap;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area;
 	} else {
 		mm->mmap_base = mmap_base(random_factor);
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base -= mm->delta_mmap + mm->delta_stack;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area_topdown;
 	}
 }
diff --git a/arch/arm/mm/mmu.c b/arch/arm/mm/mmu.c
index 30fe03f95..738d54e80 100644
--- a/arch/arm/mm/mmu.c
+++ b/arch/arm/mm/mmu.c
@@ -243,7 +243,15 @@ __setup("noalign", noalign_setup);
 #define PROT_PTE_S2_DEVICE	PROT_PTE_DEVICE
 #define PROT_SECT_DEVICE	PMD_TYPE_SECT|PMD_SECT_AP_WRITE
 
-static struct mem_type mem_types[] = {
+#ifdef CONFIG_PAX_KERNEXEC
+#define L_PTE_KERNEXEC		L_PTE_RDONLY
+#define PMD_SECT_KERNEXEC	PMD_SECT_RDONLY
+#else
+#define L_PTE_KERNEXEC		L_PTE_DIRTY
+#define PMD_SECT_KERNEXEC	PMD_SECT_AP_WRITE
+#endif
+
+static struct mem_type mem_types[] __read_only = {
 	[MT_DEVICE] = {		  /* Strongly ordered / ARMv6 shared device */
 		.prot_pte	= PROT_PTE_DEVICE | L_PTE_MT_DEV_SHARED |
 				  L_PTE_SHARED,
@@ -272,19 +280,19 @@ static struct mem_type mem_types[] = {
 		.prot_sect	= PROT_SECT_DEVICE,
 		.domain		= DOMAIN_IO,
 	},
-	[MT_UNCACHED] = {
+	[MT_UNCACHED_RW] = {
 		.prot_pte	= PROT_PTE_DEVICE,
 		.prot_l1	= PMD_TYPE_TABLE,
 		.prot_sect	= PMD_TYPE_SECT | PMD_SECT_XN,
 		.domain		= DOMAIN_IO,
 	},
-	[MT_CACHECLEAN] = {
-		.prot_sect = PMD_TYPE_SECT | PMD_SECT_XN,
+	[MT_CACHECLEAN_RO] = {
+		.prot_sect = PMD_TYPE_SECT | PMD_SECT_XN | PMD_SECT_RDONLY,
 		.domain    = DOMAIN_KERNEL,
 	},
 #ifndef CONFIG_ARM_LPAE
-	[MT_MINICLEAN] = {
-		.prot_sect = PMD_TYPE_SECT | PMD_SECT_XN | PMD_SECT_MINICACHE,
+	[MT_MINICLEAN_RO] = {
+		.prot_sect = PMD_TYPE_SECT | PMD_SECT_MINICACHE | PMD_SECT_XN | PMD_SECT_RDONLY,
 		.domain    = DOMAIN_KERNEL,
 	},
 #endif
@@ -300,7 +308,7 @@ static struct mem_type mem_types[] = {
 		.prot_l1   = PMD_TYPE_TABLE,
 		.domain    = DOMAIN_VECTORS,
 	},
-	[MT_MEMORY_RWX] = {
+	[__MT_MEMORY_RWX] = {
 		.prot_pte  = L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_DIRTY,
 		.prot_l1   = PMD_TYPE_TABLE,
 		.prot_sect = PMD_TYPE_SECT | PMD_SECT_AP_WRITE,
@@ -313,17 +321,30 @@ static struct mem_type mem_types[] = {
 		.prot_sect = PMD_TYPE_SECT | PMD_SECT_AP_WRITE,
 		.domain    = DOMAIN_KERNEL,
 	},
-	[MT_ROM] = {
-		.prot_sect = PMD_TYPE_SECT,
+	[MT_MEMORY_RX] = {
+		.prot_pte  = L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_KERNEXEC,
+		.prot_l1   = PMD_TYPE_TABLE,
+		.prot_sect = PMD_TYPE_SECT | PMD_SECT_KERNEXEC,
+		.domain	   = DOMAIN_KERNEL,
+	},
+	[MT_ROM_RX] = {
+		.prot_sect = PMD_TYPE_SECT | PMD_SECT_RDONLY,
 		.domain    = DOMAIN_KERNEL,
 	},
-	[MT_MEMORY_RWX_NONCACHED] = {
+	[MT_MEMORY_RW_NONCACHED] = {
 		.prot_pte  = L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_DIRTY |
 				L_PTE_MT_BUFFERABLE,
 		.prot_l1   = PMD_TYPE_TABLE,
 		.prot_sect = PMD_TYPE_SECT | PMD_SECT_AP_WRITE,
 		.domain    = DOMAIN_KERNEL,
 	},
+	[MT_MEMORY_RX_NONCACHED] = {
+		.prot_pte  = L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_KERNEXEC |
+				L_PTE_MT_BUFFERABLE,
+		.prot_l1   = PMD_TYPE_TABLE,
+		.prot_sect = PMD_TYPE_SECT | PMD_SECT_KERNEXEC,
+		.domain    = DOMAIN_KERNEL,
+	},
 	[MT_MEMORY_RW_DTCM] = {
 		.prot_pte  = L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_DIRTY |
 				L_PTE_XN,
@@ -331,9 +352,10 @@ static struct mem_type mem_types[] = {
 		.prot_sect = PMD_TYPE_SECT | PMD_SECT_XN,
 		.domain    = DOMAIN_KERNEL,
 	},
-	[MT_MEMORY_RWX_ITCM] = {
-		.prot_pte  = L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_DIRTY,
+	[MT_MEMORY_RX_ITCM] = {
+		.prot_pte  = L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_KERNEXEC,
 		.prot_l1   = PMD_TYPE_TABLE,
+		.prot_sect = PMD_TYPE_SECT | PMD_SECT_KERNEXEC,
 		.domain    = DOMAIN_KERNEL,
 	},
 	[MT_MEMORY_RW_SO] = {
@@ -586,9 +608,14 @@ static void __init build_mem_type_table(void)
 		 * Mark cache clean areas and XIP ROM read only
 		 * from SVC mode and no access from userspace.
 		 */
-		mem_types[MT_ROM].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
-		mem_types[MT_MINICLEAN].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
-		mem_types[MT_CACHECLEAN].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
+		mem_types[MT_ROM_RX].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
+#ifdef CONFIG_PAX_KERNEXEC
+		mem_types[MT_MEMORY_RX].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
+		mem_types[MT_MEMORY_RX_NONCACHED].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
+		mem_types[MT_MEMORY_RX_ITCM].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
+#endif
+		mem_types[MT_MINICLEAN_RO].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
+		mem_types[MT_CACHECLEAN_RO].prot_sect |= PMD_SECT_APX|PMD_SECT_AP_WRITE;
 #endif
 
 		/*
@@ -605,13 +632,17 @@ static void __init build_mem_type_table(void)
 			mem_types[MT_DEVICE_WC].prot_pte |= L_PTE_SHARED;
 			mem_types[MT_DEVICE_CACHED].prot_sect |= PMD_SECT_S;
 			mem_types[MT_DEVICE_CACHED].prot_pte |= L_PTE_SHARED;
-			mem_types[MT_MEMORY_RWX].prot_sect |= PMD_SECT_S;
-			mem_types[MT_MEMORY_RWX].prot_pte |= L_PTE_SHARED;
+			mem_types[__MT_MEMORY_RWX].prot_sect |= PMD_SECT_S;
+			mem_types[__MT_MEMORY_RWX].prot_pte |= L_PTE_SHARED;
 			mem_types[MT_MEMORY_RW].prot_sect |= PMD_SECT_S;
 			mem_types[MT_MEMORY_RW].prot_pte |= L_PTE_SHARED;
+			mem_types[MT_MEMORY_RX].prot_sect |= PMD_SECT_S;
+			mem_types[MT_MEMORY_RX].prot_pte |= L_PTE_SHARED;
 			mem_types[MT_MEMORY_DMA_READY].prot_pte |= L_PTE_SHARED;
-			mem_types[MT_MEMORY_RWX_NONCACHED].prot_sect |= PMD_SECT_S;
-			mem_types[MT_MEMORY_RWX_NONCACHED].prot_pte |= L_PTE_SHARED;
+			mem_types[MT_MEMORY_RW_NONCACHED].prot_sect |= PMD_SECT_S;
+			mem_types[MT_MEMORY_RW_NONCACHED].prot_pte |= L_PTE_SHARED;
+			mem_types[MT_MEMORY_RX_NONCACHED].prot_sect |= PMD_SECT_S;
+			mem_types[MT_MEMORY_RX_NONCACHED].prot_pte |= L_PTE_SHARED;
 		}
 	}
 
@@ -622,15 +653,20 @@ static void __init build_mem_type_table(void)
 	if (cpu_arch >= CPU_ARCH_ARMv6) {
 		if (cpu_arch >= CPU_ARCH_ARMv7 && (cr & CR_TRE)) {
 			/* Non-cacheable Normal is XCB = 001 */
-			mem_types[MT_MEMORY_RWX_NONCACHED].prot_sect |=
+			mem_types[MT_MEMORY_RW_NONCACHED].prot_sect |=
+				PMD_SECT_BUFFERED;
+			mem_types[MT_MEMORY_RX_NONCACHED].prot_sect |=
 				PMD_SECT_BUFFERED;
 		} else {
 			/* For both ARMv6 and non-TEX-remapping ARMv7 */
-			mem_types[MT_MEMORY_RWX_NONCACHED].prot_sect |=
+			mem_types[MT_MEMORY_RW_NONCACHED].prot_sect |=
+				PMD_SECT_TEX(1);
+			mem_types[MT_MEMORY_RX_NONCACHED].prot_sect |=
 				PMD_SECT_TEX(1);
 		}
 	} else {
-		mem_types[MT_MEMORY_RWX_NONCACHED].prot_sect |= PMD_SECT_BUFFERABLE;
+		mem_types[MT_MEMORY_RW_NONCACHED].prot_sect |= PMD_SECT_BUFFERABLE;
+		mem_types[MT_MEMORY_RX_NONCACHED].prot_sect |= PMD_SECT_BUFFERABLE;
 	}
 
 #ifdef CONFIG_ARM_LPAE
@@ -651,6 +687,8 @@ static void __init build_mem_type_table(void)
 	user_pgprot |= PTE_EXT_PXN;
 #endif
 
+	user_pgprot |= __supported_pte_mask;
+
 	for (i = 0; i < 16; i++) {
 		pteval_t v = pgprot_val(protection_map[i]);
 		protection_map[i] = __pgprot(v | user_pgprot);
@@ -668,21 +706,24 @@ static void __init build_mem_type_table(void)
 
 	mem_types[MT_LOW_VECTORS].prot_l1 |= ecc_mask;
 	mem_types[MT_HIGH_VECTORS].prot_l1 |= ecc_mask;
-	mem_types[MT_MEMORY_RWX].prot_sect |= ecc_mask | cp->pmd;
-	mem_types[MT_MEMORY_RWX].prot_pte |= kern_pgprot;
+	mem_types[__MT_MEMORY_RWX].prot_sect |= ecc_mask | cp->pmd;
+	mem_types[__MT_MEMORY_RWX].prot_pte |= kern_pgprot;
 	mem_types[MT_MEMORY_RW].prot_sect |= ecc_mask | cp->pmd;
 	mem_types[MT_MEMORY_RW].prot_pte |= kern_pgprot;
+	mem_types[MT_MEMORY_RX].prot_sect |= ecc_mask | cp->pmd;
+	mem_types[MT_MEMORY_RX].prot_pte |= kern_pgprot;
 	mem_types[MT_MEMORY_DMA_READY].prot_pte |= kern_pgprot;
-	mem_types[MT_MEMORY_RWX_NONCACHED].prot_sect |= ecc_mask;
-	mem_types[MT_ROM].prot_sect |= cp->pmd;
+	mem_types[MT_MEMORY_RW_NONCACHED].prot_sect |= ecc_mask;
+	mem_types[MT_MEMORY_RX_NONCACHED].prot_sect |= ecc_mask;
+	mem_types[MT_ROM_RX].prot_sect |= cp->pmd;
 
 	switch (cp->pmd) {
 	case PMD_SECT_WT:
-		mem_types[MT_CACHECLEAN].prot_sect |= PMD_SECT_WT;
+		mem_types[MT_CACHECLEAN_RO].prot_sect |= PMD_SECT_WT;
 		break;
 	case PMD_SECT_WB:
 	case PMD_SECT_WBWA:
-		mem_types[MT_CACHECLEAN].prot_sect |= PMD_SECT_WB;
+		mem_types[MT_CACHECLEAN_RO].prot_sect |= PMD_SECT_WB;
 		break;
 	}
 	pr_info("Memory policy: %sData cache %s\n",
@@ -959,7 +1000,7 @@ static void __init create_mapping(struct map_desc *md)
 		return;
 	}
 
-	if ((md->type == MT_DEVICE || md->type == MT_ROM) &&
+	if ((md->type == MT_DEVICE || md->type == MT_ROM_RX) &&
 	    md->virtual >= PAGE_OFFSET && md->virtual < FIXADDR_START &&
 	    (md->virtual < VMALLOC_START || md->virtual >= VMALLOC_END)) {
 		pr_warn("BUG: mapping for 0x%08llx at 0x%08lx out of vmalloc space\n",
@@ -1320,18 +1361,15 @@ void __init arm_mm_memblock_reserve(void)
  * Any other function or debugging method which may touch any device _will_
  * crash the kernel.
  */
+
+static char vectors[PAGE_SIZE * 2] __read_only __aligned(PAGE_SIZE);
+
 static void __init devicemaps_init(const struct machine_desc *mdesc)
 {
 	struct map_desc map;
 	unsigned long addr;
-	void *vectors;
 
-	/*
-	 * Allocate the vector page early.
-	 */
-	vectors = early_alloc(PAGE_SIZE * 2);
-
-	early_trap_init(vectors);
+	early_trap_init(&vectors);
 
 	/*
 	 * Clear page table except top pmd used by early fixmaps
@@ -1347,7 +1385,7 @@ static void __init devicemaps_init(const struct machine_desc *mdesc)
 	map.pfn = __phys_to_pfn(CONFIG_XIP_PHYS_ADDR & SECTION_MASK);
 	map.virtual = MODULES_VADDR;
 	map.length = ((unsigned long)_exiprom - map.virtual + ~SECTION_MASK) & SECTION_MASK;
-	map.type = MT_ROM;
+	map.type = MT_ROM_RX;
 	create_mapping(&map);
 #endif
 
@@ -1358,14 +1396,14 @@ static void __init devicemaps_init(const struct machine_desc *mdesc)
 	map.pfn = __phys_to_pfn(FLUSH_BASE_PHYS);
 	map.virtual = FLUSH_BASE;
 	map.length = SZ_1M;
-	map.type = MT_CACHECLEAN;
+	map.type = MT_CACHECLEAN_RO;
 	create_mapping(&map);
 #endif
 #ifdef FLUSH_BASE_MINICACHE
 	map.pfn = __phys_to_pfn(FLUSH_BASE_PHYS + SZ_1M);
 	map.virtual = FLUSH_BASE_MINICACHE;
 	map.length = SZ_1M;
-	map.type = MT_MINICLEAN;
+	map.type = MT_MINICLEAN_RO;
 	create_mapping(&map);
 #endif
 
@@ -1374,7 +1412,7 @@ static void __init devicemaps_init(const struct machine_desc *mdesc)
 	 * location (0xffff0000).  If we aren't using high-vectors, also
 	 * create a mapping at the low-vectors virtual address.
 	 */
-	map.pfn = __phys_to_pfn(virt_to_phys(vectors));
+	map.pfn = __phys_to_pfn(virt_to_phys(&vectors));
 	map.virtual = 0xffff0000;
 	map.length = PAGE_SIZE;
 #ifdef CONFIG_KUSER_HELPERS
@@ -1437,12 +1475,14 @@ static void __init kmap_init(void)
 static void __init map_lowmem(void)
 {
 	struct memblock_region *reg;
+#ifndef CONFIG_PAX_KERNEXEC
 #ifdef CONFIG_XIP_KERNEL
 	phys_addr_t kernel_x_start = round_down(__pa(_sdata), SECTION_SIZE);
 #else
 	phys_addr_t kernel_x_start = round_down(__pa(_stext), SECTION_SIZE);
 #endif
 	phys_addr_t kernel_x_end = round_up(__pa(__init_end), SECTION_SIZE);
+#endif
 
 	/* Map all the lowmem memory banks. */
 	for_each_memblock(memory, reg) {
@@ -1458,11 +1498,48 @@ static void __init map_lowmem(void)
 		if (start >= end)
 			break;
 
+#ifdef CONFIG_PAX_KERNEXEC
+		map.pfn = __phys_to_pfn(start);
+		map.virtual = __phys_to_virt(start);
+		map.length = end - start;
+
+		if (map.virtual <= (unsigned long)_stext && ((unsigned long)_end < (map.virtual + map.length))) {
+			struct map_desc kernel;
+			struct map_desc initmap;
+
+			/* when freeing initmem we will make this RW */
+			initmap.pfn = __phys_to_pfn(__pa(__init_begin));
+			initmap.virtual = (unsigned long)__init_begin;
+			initmap.length = _sdata - __init_begin;
+			initmap.type = __MT_MEMORY_RWX;
+			create_mapping(&initmap);
+
+			/* when freeing initmem we will make this RX */
+			kernel.pfn = __phys_to_pfn(__pa(_stext));
+			kernel.virtual = (unsigned long)_stext;
+			kernel.length = __init_begin - _stext;
+			kernel.type = __MT_MEMORY_RWX;
+			create_mapping(&kernel);
+
+			if (map.virtual < (unsigned long)_stext) {
+				map.length = (unsigned long)_stext - map.virtual;
+				map.type = __MT_MEMORY_RWX;
+				create_mapping(&map);
+			}
+
+			map.pfn = __phys_to_pfn(__pa(_sdata));
+			map.virtual = (unsigned long)_sdata;
+			map.length = end - __pa(_sdata);
+		}
+
+		map.type = MT_MEMORY_RW;
+		create_mapping(&map);
+#else
 		if (end < kernel_x_start) {
 			map.pfn = __phys_to_pfn(start);
 			map.virtual = __phys_to_virt(start);
 			map.length = end - start;
-			map.type = MT_MEMORY_RWX;
+			map.type = __MT_MEMORY_RWX;
 
 			create_mapping(&map);
 		} else if (start >= kernel_x_end) {
@@ -1486,7 +1563,7 @@ static void __init map_lowmem(void)
 			map.pfn = __phys_to_pfn(kernel_x_start);
 			map.virtual = __phys_to_virt(kernel_x_start);
 			map.length = kernel_x_end - kernel_x_start;
-			map.type = MT_MEMORY_RWX;
+			map.type = __MT_MEMORY_RWX;
 
 			create_mapping(&map);
 
@@ -1499,6 +1576,7 @@ static void __init map_lowmem(void)
 				create_mapping(&map);
 			}
 		}
+#endif
 	}
 }
 
diff --git a/arch/arm/net/bpf_jit_32.c b/arch/arm/net/bpf_jit_32.c
index 93d0b6d0b..2db6d9995 100644
--- a/arch/arm/net/bpf_jit_32.c
+++ b/arch/arm/net/bpf_jit_32.c
@@ -20,6 +20,7 @@
 #include <asm/cacheflush.h>
 #include <asm/hwcap.h>
 #include <asm/opcodes.h>
+#include <asm/pgtable.h>
 
 #include "bpf_jit_32.h"
 
@@ -72,54 +73,38 @@ struct jit_ctx {
 #endif
 };
 
+#ifdef CONFIG_GRKERNSEC_BPF_HARDEN
+int bpf_jit_enable __read_only;
+#else
 int bpf_jit_enable __read_mostly;
+#endif
 
-static inline int call_neg_helper(struct sk_buff *skb, int offset, void *ret,
-		      unsigned int size)
-{
-	void *ptr = bpf_internal_load_pointer_neg_helper(skb, offset, size);
-
-	if (!ptr)
-		return -EFAULT;
-	memcpy(ret, ptr, size);
-	return 0;
-}
-
-static u64 jit_get_skb_b(struct sk_buff *skb, int offset)
+static u64 jit_get_skb_b(struct sk_buff *skb, unsigned offset)
 {
 	u8 ret;
 	int err;
 
-	if (offset < 0)
-		err = call_neg_helper(skb, offset, &ret, 1);
-	else
-		err = skb_copy_bits(skb, offset, &ret, 1);
+	err = skb_copy_bits(skb, offset, &ret, 1);
 
 	return (u64)err << 32 | ret;
 }
 
-static u64 jit_get_skb_h(struct sk_buff *skb, int offset)
+static u64 jit_get_skb_h(struct sk_buff *skb, unsigned offset)
 {
 	u16 ret;
 	int err;
 
-	if (offset < 0)
-		err = call_neg_helper(skb, offset, &ret, 2);
-	else
-		err = skb_copy_bits(skb, offset, &ret, 2);
+	err = skb_copy_bits(skb, offset, &ret, 2);
 
 	return (u64)err << 32 | ntohs(ret);
 }
 
-static u64 jit_get_skb_w(struct sk_buff *skb, int offset)
+static u64 jit_get_skb_w(struct sk_buff *skb, unsigned offset)
 {
 	u32 ret;
 	int err;
 
-	if (offset < 0)
-		err = call_neg_helper(skb, offset, &ret, 4);
-	else
-		err = skb_copy_bits(skb, offset, &ret, 4);
+	err = skb_copy_bits(skb, offset, &ret, 4);
 
 	return (u64)err << 32 | ntohl(ret);
 }
@@ -191,8 +176,10 @@ static void jit_fill_hole(void *area, unsigned int size)
 {
 	u32 *ptr;
 	/* We are guaranteed to have aligned memory. */
+	pax_open_kernel();
 	for (ptr = area; size >= sizeof(u32); size -= sizeof(u32))
 		*ptr++ = __opcode_to_mem_arm(ARM_INST_UDF);
+	pax_close_kernel();
 }
 
 static void build_prologue(struct jit_ctx *ctx)
@@ -554,6 +541,9 @@ static int build_body(struct jit_ctx *ctx)
 		case BPF_LD | BPF_B | BPF_ABS:
 			load_order = 0;
 load:
+			/* the interpreter will deal with the negative K */
+			if ((int)k < 0)
+				return -ENOTSUPP;
 			emit_mov_i(r_off, k, ctx);
 load_common:
 			ctx->seen |= SEEN_DATA | SEEN_CALL;
@@ -568,18 +558,6 @@ load_common:
 				condt = ARM_COND_HI;
 			}
 
-			/*
-			 * test for negative offset, only if we are
-			 * currently scheduled to take the fast
-			 * path. this will update the flags so that
-			 * the slowpath instruction are ignored if the
-			 * offset is negative.
-			 *
-			 * for loard_order == 0 the HI condition will
-			 * make loads at offset 0 take the slow path too.
-			 */
-			_emit(condt, ARM_CMP_I(r_off, 0), ctx);
-
 			_emit(condt, ARM_ADD_R(r_scratch, r_off, r_skb_data),
 			      ctx);
 
diff --git a/arch/arm/plat-iop/setup.c b/arch/arm/plat-iop/setup.c
index 8151bde99..9be301f92 100644
--- a/arch/arm/plat-iop/setup.c
+++ b/arch/arm/plat-iop/setup.c
@@ -24,7 +24,7 @@ static struct map_desc iop3xx_std_desc[] __initdata = {
 		.virtual	= IOP3XX_PERIPHERAL_VIRT_BASE,
 		.pfn		= __phys_to_pfn(IOP3XX_PERIPHERAL_PHYS_BASE),
 		.length		= IOP3XX_PERIPHERAL_SIZE,
-		.type		= MT_UNCACHED,
+		.type		= MT_UNCACHED_RW,
 	},
 };
 
diff --git a/arch/arm/plat-omap/sram.c b/arch/arm/plat-omap/sram.c
index a5bc92d7e..0bb473095 100644
--- a/arch/arm/plat-omap/sram.c
+++ b/arch/arm/plat-omap/sram.c
@@ -93,6 +93,8 @@ void __init omap_map_sram(unsigned long start, unsigned long size,
 	 * Looks like we need to preserve some bootloader code at the
 	 * beginning of SRAM for jumping to flash for reboot to work...
 	 */
+	pax_open_kernel();
 	memset_io(omap_sram_base + omap_sram_skip, 0,
 		  omap_sram_size - omap_sram_skip);
+	pax_close_kernel();
 }
diff --git a/arch/arm64/Kconfig b/arch/arm64/Kconfig
index bc3f00f58..88ded6a33 100644
--- a/arch/arm64/Kconfig
+++ b/arch/arm64/Kconfig
@@ -891,6 +891,7 @@ config RELOCATABLE
 
 config RANDOMIZE_BASE
 	bool "Randomize the address of the kernel image"
+	depends on BROKEN_SECURITY
 	select ARM64_MODULE_PLTS if MODULES
 	select RELOCATABLE
 	help
diff --git a/arch/arm64/Kconfig.debug b/arch/arm64/Kconfig.debug
index 0cc758cdd..de67415b6 100644
--- a/arch/arm64/Kconfig.debug
+++ b/arch/arm64/Kconfig.debug
@@ -6,6 +6,7 @@ config ARM64_PTDUMP
 	bool "Export kernel pagetable layout to userspace via debugfs"
 	depends on DEBUG_KERNEL
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
         help
 	  Say Y here if you want to show the kernel pagetable layout in a
 	  debugfs file. This information is only useful for kernel developers
diff --git a/arch/arm64/crypto/sha1-ce-glue.c b/arch/arm64/crypto/sha1-ce-glue.c
index aefda9868..29378748a 100644
--- a/arch/arm64/crypto/sha1-ce-glue.c
+++ b/arch/arm64/crypto/sha1-ce-glue.c
@@ -29,7 +29,7 @@ struct sha1_ce_state {
 	u32			finalize;
 };
 
-asmlinkage void sha1_ce_transform(struct sha1_ce_state *sst, u8 const *src,
+asmlinkage void sha1_ce_transform(struct sha1_state *sst, u8 const *src,
 				  int blocks);
 
 static int sha1_ce_update(struct shash_desc *desc, const u8 *data,
@@ -39,8 +39,7 @@ static int sha1_ce_update(struct shash_desc *desc, const u8 *data,
 
 	sctx->finalize = 0;
 	kernel_neon_begin_partial(16);
-	sha1_base_do_update(desc, data, len,
-			    (sha1_block_fn *)sha1_ce_transform);
+	sha1_base_do_update(desc, data, len, sha1_ce_transform);
 	kernel_neon_end();
 
 	return 0;
@@ -64,10 +63,9 @@ static int sha1_ce_finup(struct shash_desc *desc, const u8 *data,
 	sctx->finalize = finalize;
 
 	kernel_neon_begin_partial(16);
-	sha1_base_do_update(desc, data, len,
-			    (sha1_block_fn *)sha1_ce_transform);
+	sha1_base_do_update(desc, data, len, sha1_ce_transform);
 	if (!finalize)
-		sha1_base_do_finalize(desc, (sha1_block_fn *)sha1_ce_transform);
+		sha1_base_do_finalize(desc, sha1_ce_transform);
 	kernel_neon_end();
 	return sha1_base_finish(desc, out);
 }
@@ -78,7 +76,7 @@ static int sha1_ce_final(struct shash_desc *desc, u8 *out)
 
 	sctx->finalize = 0;
 	kernel_neon_begin_partial(16);
-	sha1_base_do_finalize(desc, (sha1_block_fn *)sha1_ce_transform);
+	sha1_base_do_finalize(desc, sha1_ce_transform);
 	kernel_neon_end();
 	return sha1_base_finish(desc, out);
 }
diff --git a/arch/arm64/include/asm/atomic.h b/arch/arm64/include/asm/atomic.h
index c0235e0ff..86eb6849c 100644
--- a/arch/arm64/include/asm/atomic.h
+++ b/arch/arm64/include/asm/atomic.h
@@ -57,11 +57,13 @@
 #define atomic_set(v, i)		WRITE_ONCE(((v)->counter), (i))
 
 #define atomic_add_return_relaxed	atomic_add_return_relaxed
+#define atomic_add_return_unchecked_relaxed	atomic_add_return_relaxed
 #define atomic_add_return_acquire	atomic_add_return_acquire
 #define atomic_add_return_release	atomic_add_return_release
 #define atomic_add_return		atomic_add_return
 
 #define atomic_inc_return_relaxed(v)	atomic_add_return_relaxed(1, (v))
+#define atomic_inc_return_unchecked_relaxed(v)	atomic_add_return_relaxed(1, (v))
 #define atomic_inc_return_acquire(v)	atomic_add_return_acquire(1, (v))
 #define atomic_inc_return_release(v)	atomic_add_return_release(1, (v))
 #define atomic_inc_return(v)		atomic_add_return(1, (v))
@@ -128,6 +130,8 @@
 #define __atomic_add_unless(v, a, u)	___atomic_add_unless(v, a, u,)
 #define atomic_andnot			atomic_andnot
 
+#define atomic_inc_return_unchecked_relaxed(v)	atomic_add_return_relaxed(1, (v))
+
 /*
  * 64-bit atomic operations.
  */
@@ -206,5 +210,16 @@
 
 #define atomic64_inc_not_zero(v)	atomic64_add_unless((v), 1, 0)
 
+#define atomic64_read_unchecked(v)		atomic64_read(v)
+#define atomic64_set_unchecked(v, i)		atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v)		atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v)	atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v)		atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v)		atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v)	atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v)		atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n)	atomic64_cmpxchg((v), (o), (n))
+#define atomic64_xchg_unchecked(v, n)		atomic64_xchg((v), (n))
+
 #endif
 #endif
diff --git a/arch/arm64/include/asm/cache.h b/arch/arm64/include/asm/cache.h
index 5082b30bc..9ef38c255 100644
--- a/arch/arm64/include/asm/cache.h
+++ b/arch/arm64/include/asm/cache.h
@@ -16,10 +16,14 @@
 #ifndef __ASM_CACHE_H
 #define __ASM_CACHE_H
 
+#include <linux/const.h>
+
 #include <asm/cachetype.h>
 
+#include <linux/const.h>
+
 #define L1_CACHE_SHIFT		7
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 /*
  * Memory returned by kmalloc() may be used for DMA, so we must make
diff --git a/arch/arm64/include/asm/percpu.h b/arch/arm64/include/asm/percpu.h
index 5394c8405..05e5a9575 100644
--- a/arch/arm64/include/asm/percpu.h
+++ b/arch/arm64/include/asm/percpu.h
@@ -123,16 +123,16 @@ static inline void __percpu_write(void *ptr, unsigned long val, int size)
 {
 	switch (size) {
 	case 1:
-		ACCESS_ONCE(*(u8 *)ptr) = (u8)val;
+		ACCESS_ONCE_RW(*(u8 *)ptr) = (u8)val;
 		break;
 	case 2:
-		ACCESS_ONCE(*(u16 *)ptr) = (u16)val;
+		ACCESS_ONCE_RW(*(u16 *)ptr) = (u16)val;
 		break;
 	case 4:
-		ACCESS_ONCE(*(u32 *)ptr) = (u32)val;
+		ACCESS_ONCE_RW(*(u32 *)ptr) = (u32)val;
 		break;
 	case 8:
-		ACCESS_ONCE(*(u64 *)ptr) = (u64)val;
+		ACCESS_ONCE_RW(*(u64 *)ptr) = (u64)val;
 		break;
 	default:
 		BUILD_BUG();
diff --git a/arch/arm64/include/asm/pgalloc.h b/arch/arm64/include/asm/pgalloc.h
index d25f4f137..61d52da44 100644
--- a/arch/arm64/include/asm/pgalloc.h
+++ b/arch/arm64/include/asm/pgalloc.h
@@ -51,6 +51,11 @@ static inline void pud_populate(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
 {
 	__pud_populate(pud, __pa(pmd), PMD_TYPE_TABLE);
 }
+
+static inline void pud_populate_kernel(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
+{
+	pud_populate(mm, pud, pmd);
+}
 #else
 static inline void __pud_populate(pud_t *pud, phys_addr_t pmd, pudval_t prot)
 {
@@ -80,6 +85,11 @@ static inline void pgd_populate(struct mm_struct *mm, pgd_t *pgd, pud_t *pud)
 {
 	__pgd_populate(pgd, __pa(pud), PUD_TYPE_TABLE);
 }
+
+static inline void pgd_populate_kernel(struct mm_struct *mm, pgd_t *pgd, pud_t *pud)
+{
+	pgd_populate(mm, pgd, pud);
+}
 #else
 static inline void __pgd_populate(pgd_t *pgdp, phys_addr_t pud, pgdval_t prot)
 {
diff --git a/arch/arm64/include/asm/pgtable.h b/arch/arm64/include/asm/pgtable.h
index e20bd4311..7e476da1e 100644
--- a/arch/arm64/include/asm/pgtable.h
+++ b/arch/arm64/include/asm/pgtable.h
@@ -23,6 +23,9 @@
 #include <asm/pgtable-hwdef.h>
 #include <asm/pgtable-prot.h>
 
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+
 /*
  * VMALLOC range.
  *
@@ -718,6 +721,9 @@ static inline void update_mmu_cache(struct vm_area_struct *vma,
 #define kc_vaddr_to_offset(v)	((v) & ~VA_START)
 #define kc_offset_to_vaddr(o)	((o) | VA_START)
 
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+
 #endif /* !__ASSEMBLY__ */
 
 #endif /* __ASM_PGTABLE_H */
diff --git a/arch/arm64/include/asm/string.h b/arch/arm64/include/asm/string.h
index 2eb714c46..3a1047127 100644
--- a/arch/arm64/include/asm/string.h
+++ b/arch/arm64/include/asm/string.h
@@ -17,40 +17,40 @@
 #define __ASM_STRING_H
 
 #define __HAVE_ARCH_STRRCHR
-extern char *strrchr(const char *, int c);
+extern char *strrchr(const char *, int c) __nocapture(-1);
 
 #define __HAVE_ARCH_STRCHR
-extern char *strchr(const char *, int c);
+extern char *strchr(const char *, int c) __nocapture(-1);
 
 #define __HAVE_ARCH_STRCMP
-extern int strcmp(const char *, const char *);
+extern int strcmp(const char *, const char *) __nocapture();
 
 #define __HAVE_ARCH_STRNCMP
-extern int strncmp(const char *, const char *, __kernel_size_t);
+extern int strncmp(const char *, const char *, __kernel_size_t) __nocapture(1, 2);
 
 #define __HAVE_ARCH_STRLEN
-extern __kernel_size_t strlen(const char *);
+extern __kernel_size_t strlen(const char *) __nocapture(1);
 
 #define __HAVE_ARCH_STRNLEN
-extern __kernel_size_t strnlen(const char *, __kernel_size_t);
+extern __kernel_size_t strnlen(const char *, __kernel_size_t) __nocapture(1);
 
 #define __HAVE_ARCH_MEMCPY
-extern void *memcpy(void *, const void *, __kernel_size_t);
-extern void *__memcpy(void *, const void *, __kernel_size_t);
+extern void *memcpy(void *, const void *, __kernel_size_t) __nocapture(2);
+extern void *__memcpy(void *, const void *, __kernel_size_t) __nocapture(2);
 
 #define __HAVE_ARCH_MEMMOVE
-extern void *memmove(void *, const void *, __kernel_size_t);
-extern void *__memmove(void *, const void *, __kernel_size_t);
+extern void *memmove(void *, const void *, __kernel_size_t) __nocapture(2);
+extern void *__memmove(void *, const void *, __kernel_size_t) __nocapture(2);
 
 #define __HAVE_ARCH_MEMCHR
-extern void *memchr(const void *, int, __kernel_size_t);
+extern void *memchr(const void *, int, __kernel_size_t) __nocapture(-1);
 
 #define __HAVE_ARCH_MEMSET
 extern void *memset(void *, int, __kernel_size_t);
 extern void *__memset(void *, int, __kernel_size_t);
 
 #define __HAVE_ARCH_MEMCMP
-extern int memcmp(const void *, const void *, size_t);
+extern int memcmp(const void *, const void *, size_t) __nocapture(1, 2);
 
 
 #if defined(CONFIG_KASAN) && !defined(__SANITIZE_ADDRESS__)
diff --git a/arch/arm64/include/asm/uaccess.h b/arch/arm64/include/asm/uaccess.h
index db849839e..d256a3edc 100644
--- a/arch/arm64/include/asm/uaccess.h
+++ b/arch/arm64/include/asm/uaccess.h
@@ -110,6 +110,7 @@ static inline void set_fs(mm_segment_t fs)
  */
 #define untagged_addr(addr)		sign_extend64(addr, 55)
 
+#define access_ok_noprefault(type, addr, size) access_ok((type), (addr), (size))
 #define access_ok(type, addr, size)	__range_ok(addr, size)
 #define user_addr_max			get_fs
 
@@ -279,6 +280,9 @@ static inline unsigned long __must_check __copy_from_user(void *to, const void _
 
 static inline unsigned long __must_check __copy_to_user(void __user *to, const void *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	kasan_check_read(from, n);
 	check_object_size(from, n, true);
 	return __arch_copy_to_user(to, from, n);
@@ -286,6 +290,9 @@ static inline unsigned long __must_check __copy_to_user(void __user *to, const v
 
 static inline unsigned long __must_check copy_from_user(void *to, const void __user *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	kasan_check_write(to, n);
 
 	if (access_ok(VERIFY_READ, from, n)) {
@@ -298,6 +305,9 @@ static inline unsigned long __must_check copy_from_user(void *to, const void __u
 
 static inline unsigned long __must_check copy_to_user(void __user *to, const void *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	kasan_check_read(from, n);
 
 	if (access_ok(VERIFY_WRITE, to, n)) {
diff --git a/arch/arm64/kernel/hibernate.c b/arch/arm64/kernel/hibernate.c
index 65d81f965..6a46f097c 100644
--- a/arch/arm64/kernel/hibernate.c
+++ b/arch/arm64/kernel/hibernate.c
@@ -166,7 +166,7 @@ EXPORT_SYMBOL(arch_hibernation_header_restore);
 static int create_safe_exec_page(void *src_start, size_t length,
 				 unsigned long dst_addr,
 				 phys_addr_t *phys_dst_addr,
-				 void *(*allocator)(gfp_t mask),
+				 unsigned long (*allocator)(gfp_t mask),
 				 gfp_t mask)
 {
 	int rc = 0;
@@ -174,7 +174,7 @@ static int create_safe_exec_page(void *src_start, size_t length,
 	pud_t *pud;
 	pmd_t *pmd;
 	pte_t *pte;
-	unsigned long dst = (unsigned long)allocator(mask);
+	unsigned long dst = allocator(mask);
 
 	if (!dst) {
 		rc = -ENOMEM;
@@ -184,9 +184,9 @@ static int create_safe_exec_page(void *src_start, size_t length,
 	memcpy((void *)dst, src_start, length);
 	flush_icache_range(dst, dst + length);
 
-	pgd = pgd_offset_raw(allocator(mask), dst_addr);
+	pgd = pgd_offset_raw((pgd_t *)allocator(mask), dst_addr);
 	if (pgd_none(*pgd)) {
-		pud = allocator(mask);
+		pud = (pud_t *)allocator(mask);
 		if (!pud) {
 			rc = -ENOMEM;
 			goto out;
@@ -196,7 +196,7 @@ static int create_safe_exec_page(void *src_start, size_t length,
 
 	pud = pud_offset(pgd, dst_addr);
 	if (pud_none(*pud)) {
-		pmd = allocator(mask);
+		pmd = (pmd_t *)allocator(mask);
 		if (!pmd) {
 			rc = -ENOMEM;
 			goto out;
@@ -206,7 +206,7 @@ static int create_safe_exec_page(void *src_start, size_t length,
 
 	pmd = pmd_offset(pud, dst_addr);
 	if (pmd_none(*pmd)) {
-		pte = allocator(mask);
+		pte = (pte_t *)allocator(mask);
 		if (!pte) {
 			rc = -ENOMEM;
 			goto out;
@@ -449,7 +449,7 @@ int swsusp_arch_resume(void)
 	rc = create_safe_exec_page(__hibernate_exit_text_start, exit_size,
 				   (unsigned long)hibernate_exit,
 				   &phys_hibernate_exit,
-				   (void *)get_safe_page, GFP_ATOMIC);
+				   get_safe_page, GFP_ATOMIC);
 	if (rc) {
 		pr_err("Failed to create safe executable page for hibernate_exit code.");
 		goto out;
diff --git a/arch/arm64/kernel/probes/decode-insn.c b/arch/arm64/kernel/probes/decode-insn.c
index 37e47a9d6..f8597fc9b 100644
--- a/arch/arm64/kernel/probes/decode-insn.c
+++ b/arch/arm64/kernel/probes/decode-insn.c
@@ -157,10 +157,10 @@ arm_kprobe_decode_insn(kprobe_opcode_t *addr, struct arch_specific_insn *asi)
 		mod = __module_address((unsigned long)addr);
 		if (mod && within_module_init((unsigned long)addr, mod) &&
 			!within_module_init((unsigned long)scan_end, mod))
-			scan_end = (kprobe_opcode_t *)mod->init_layout.base;
+			scan_end = (kprobe_opcode_t *)mod->init_layout.base_rx;
 		else if (mod && within_module_core((unsigned long)addr, mod) &&
 			!within_module_core((unsigned long)scan_end, mod))
-			scan_end = (kprobe_opcode_t *)mod->core_layout.base;
+			scan_end = (kprobe_opcode_t *)mod->core_layout.base_rx;
 		preempt_enable();
 	}
 #endif
diff --git a/arch/arm64/kernel/process.c b/arch/arm64/kernel/process.c
index 9cc866721..5edbcffb9 100644
--- a/arch/arm64/kernel/process.c
+++ b/arch/arm64/kernel/process.c
@@ -64,7 +64,7 @@ EXPORT_SYMBOL(__stack_chk_guard);
 /*
  * Function pointers to optional machine specific functions
  */
-void (*pm_power_off)(void);
+void (* pm_power_off)(void);
 EXPORT_SYMBOL_GPL(pm_power_off);
 
 void (*arm_pm_restart)(enum reboot_mode reboot_mode, const char *cmd);
@@ -110,7 +110,7 @@ void machine_shutdown(void)
  * activity (executing tasks, handling interrupts). smp_send_stop()
  * achieves this.
  */
-void machine_halt(void)
+void __noreturn machine_halt(void)
 {
 	local_irq_disable();
 	smp_send_stop();
@@ -123,12 +123,13 @@ void machine_halt(void)
  * achieves this. When the system power is turned off, it will take all CPUs
  * with it.
  */
-void machine_power_off(void)
+void __noreturn machine_power_off(void)
 {
 	local_irq_disable();
 	smp_send_stop();
 	if (pm_power_off)
 		pm_power_off();
+	while(1);
 }
 
 /*
@@ -140,7 +141,7 @@ void machine_power_off(void)
  * executing pre-reset code, and using RAM that the primary CPU's code wishes
  * to use. Implementing such co-ordination would be essentially impossible.
  */
-void machine_restart(char *cmd)
+void __noreturn machine_restart(char *cmd)
 {
 	/* Disable interrupts first */
 	local_irq_disable();
diff --git a/arch/arm64/kernel/stacktrace.c b/arch/arm64/kernel/stacktrace.c
index d34fd7217..8b6faee9a 100644
--- a/arch/arm64/kernel/stacktrace.c
+++ b/arch/arm64/kernel/stacktrace.c
@@ -95,8 +95,8 @@ int notrace unwind_frame(struct task_struct *tsk, struct stackframe *frame)
 		struct pt_regs *irq_args;
 		unsigned long orig_sp = IRQ_STACK_TO_TASK_STACK(irq_stack_ptr);
 
-		if (object_is_on_stack((void *)orig_sp) &&
-		   object_is_on_stack((void *)frame->fp)) {
+		if (object_starts_on_stack((void *)orig_sp) &&
+		   object_starts_on_stack((void *)frame->fp)) {
 			frame->sp = orig_sp;
 
 			/* orig_sp is the saved pt_regs, find the elr */
diff --git a/arch/arm64/kernel/traps.c b/arch/arm64/kernel/traps.c
index 9595d3d9c..7ee5abbfb 100644
--- a/arch/arm64/kernel/traps.c
+++ b/arch/arm64/kernel/traps.c
@@ -512,7 +512,7 @@ asmlinkage long do_ni_syscall(struct pt_regs *regs)
 			__show_regs(regs);
 	}
 
-	return sys_ni_syscall();
+	return -ENOSYS;
 }
 
 static const char *esr_class_str[] = {
diff --git a/arch/avr32/include/asm/cache.h b/arch/avr32/include/asm/cache.h
index c3a58a189..78fbf54a9 100644
--- a/arch/avr32/include/asm/cache.h
+++ b/arch/avr32/include/asm/cache.h
@@ -1,8 +1,10 @@
 #ifndef __ASM_AVR32_CACHE_H
 #define __ASM_AVR32_CACHE_H
 
+#include <linux/const.h>
+
 #define L1_CACHE_SHIFT 5
-#define L1_CACHE_BYTES (1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES (_AC(1,UL) << L1_CACHE_SHIFT)
 
 /*
  * Memory returned by kmalloc() may be used for DMA, so we must make
diff --git a/arch/avr32/include/asm/elf.h b/arch/avr32/include/asm/elf.h
index 0388ece75..87c8df102 100644
--- a/arch/avr32/include/asm/elf.h
+++ b/arch/avr32/include/asm/elf.h
@@ -84,8 +84,14 @@ typedef struct user_fpu_struct elf_fpregset_t;
    the loader.  We need to make sure that it is out of the way of the program
    that it will "exec", and that there is sufficient room for the brk.  */
 
-#define ELF_ET_DYN_BASE         (TASK_SIZE / 3 * 2)
+#define ELF_ET_DYN_BASE		(TASK_SIZE / 3 * 2)
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	0x00001000UL
+
+#define PAX_DELTA_MMAP_LEN	15
+#define PAX_DELTA_STACK_LEN	15
+#endif
 
 /* This yields a mask that user programs can use to figure out what
    instruction set this CPU supports.  This could be done in user space,
diff --git a/arch/avr32/include/asm/kmap_types.h b/arch/avr32/include/asm/kmap_types.h
index 479330b89..53717a870 100644
--- a/arch/avr32/include/asm/kmap_types.h
+++ b/arch/avr32/include/asm/kmap_types.h
@@ -2,9 +2,9 @@
 #define __ASM_AVR32_KMAP_TYPES_H
 
 #ifdef CONFIG_DEBUG_HIGHMEM
-# define KM_TYPE_NR 29
+# define KM_TYPE_NR 30
 #else
-# define KM_TYPE_NR 14
+# define KM_TYPE_NR 15
 #endif
 
 #endif /* __ASM_AVR32_KMAP_TYPES_H */
diff --git a/arch/avr32/mm/fault.c b/arch/avr32/mm/fault.c
index a4b7edac8..d057f9ebb 100644
--- a/arch/avr32/mm/fault.c
+++ b/arch/avr32/mm/fault.c
@@ -41,6 +41,23 @@ static inline int notify_page_fault(struct pt_regs *regs, int trap)
 
 int exception_trace = 1;
 
+#ifdef CONFIG_PAX_PAGEEXEC
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 20; i++) {
+		unsigned char c;
+		if (get_user(c, (unsigned char *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%02x ", c);
+	}
+	printk("\n");
+}
+#endif
+
 /*
  * This routine handles page faults. It determines the address and the
  * problem, and then passes it off to one of the appropriate routines.
@@ -178,6 +195,16 @@ bad_area:
 	up_read(&mm->mmap_sem);
 
 	if (user_mode(regs)) {
+
+#ifdef CONFIG_PAX_PAGEEXEC
+		if (mm->pax_flags & MF_PAX_PAGEEXEC) {
+			if (ecr == ECR_PROTECTION_X || ecr == ECR_TLB_MISS_X) {
+				pax_report_fault(regs, (void *)regs->pc, (void *)regs->sp);
+				do_group_exit(SIGKILL);
+			}
+		}
+#endif
+
 		if (exception_trace && printk_ratelimit())
 			printk("%s%s[%d]: segfault at %08lx pc %08lx "
 			       "sp %08lx ecr %lu\n",
diff --git a/arch/blackfin/Kconfig.debug b/arch/blackfin/Kconfig.debug
index f3337ee03..15b6f8d7b 100644
--- a/arch/blackfin/Kconfig.debug
+++ b/arch/blackfin/Kconfig.debug
@@ -18,6 +18,7 @@ config DEBUG_VERBOSE
 config DEBUG_MMRS
 	tristate "Generate Blackfin MMR tree"
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	help
 	  Create a tree of Blackfin MMRs via the debugfs tree.  If
 	  you enable this, you will find all MMRs laid out in the
diff --git a/arch/blackfin/include/asm/cache.h b/arch/blackfin/include/asm/cache.h
index 568885a2c..f8008df2e 100644
--- a/arch/blackfin/include/asm/cache.h
+++ b/arch/blackfin/include/asm/cache.h
@@ -7,6 +7,7 @@
 #ifndef __ARCH_BLACKFIN_CACHE_H
 #define __ARCH_BLACKFIN_CACHE_H
 
+#include <linux/const.h>
 #include <linux/linkage.h>	/* for asmlinkage */
 
 /*
@@ -14,7 +15,7 @@
  * Blackfin loads 32 bytes for cache
  */
 #define L1_CACHE_SHIFT	5
-#define L1_CACHE_BYTES	(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES	(_AC(1,UL) << L1_CACHE_SHIFT)
 #define SMP_CACHE_BYTES	L1_CACHE_BYTES
 
 #define ARCH_DMA_MINALIGN	L1_CACHE_BYTES
diff --git a/arch/cris/include/arch-v10/arch/cache.h b/arch/cris/include/arch-v10/arch/cache.h
index aea27184d..3639a60b7 100644
--- a/arch/cris/include/arch-v10/arch/cache.h
+++ b/arch/cris/include/arch-v10/arch/cache.h
@@ -1,8 +1,9 @@
 #ifndef _ASM_ARCH_CACHE_H
 #define _ASM_ARCH_CACHE_H
 
+#include <linux/const.h>
 /* Etrax 100LX have 32-byte cache-lines. */
-#define L1_CACHE_BYTES 32
 #define L1_CACHE_SHIFT 5
+#define L1_CACHE_BYTES (_AC(1,UL) << L1_CACHE_SHIFT)
 
 #endif /* _ASM_ARCH_CACHE_H */
diff --git a/arch/cris/include/arch-v32/arch/cache.h b/arch/cris/include/arch-v32/arch/cache.h
index 7caf25d58..ee65ac530 100644
--- a/arch/cris/include/arch-v32/arch/cache.h
+++ b/arch/cris/include/arch-v32/arch/cache.h
@@ -1,11 +1,12 @@
 #ifndef _ASM_CRIS_ARCH_CACHE_H
 #define _ASM_CRIS_ARCH_CACHE_H
 
+#include <linux/const.h>
 #include <arch/hwregs/dma.h>
 
 /* A cache-line is 32 bytes. */
-#define L1_CACHE_BYTES 32
 #define L1_CACHE_SHIFT 5
+#define L1_CACHE_BYTES (_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define __read_mostly __attribute__((__section__(".data..read_mostly")))
 
diff --git a/arch/frv/include/asm/atomic.h b/arch/frv/include/asm/atomic.h
index 1c2a5e264..2579e5f45 100644
--- a/arch/frv/include/asm/atomic.h
+++ b/arch/frv/include/asm/atomic.h
@@ -146,6 +146,16 @@ static inline void atomic64_dec(atomic64_t *v)
 #define atomic64_cmpxchg(v, old, new)	(__cmpxchg_64(old, new, &(v)->counter))
 #define atomic64_xchg(v, new)		(__xchg_64(new, &(v)->counter))
 
+#define atomic64_read_unchecked(v)		atomic64_read(v)
+#define atomic64_set_unchecked(v, i)		atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v)		atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v)	atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v)		atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v)		atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v)	atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v)		atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n)	atomic64_cmpxchg((v), (o), (n))
+
 static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int c, old;
diff --git a/arch/frv/include/asm/cache.h b/arch/frv/include/asm/cache.h
index 2797163b8..c2a401df9 100644
--- a/arch/frv/include/asm/cache.h
+++ b/arch/frv/include/asm/cache.h
@@ -12,10 +12,11 @@
 #ifndef __ASM_CACHE_H
 #define __ASM_CACHE_H
 
+#include <linux/const.h>
 
 /* bytes per L1 cache line */
 #define L1_CACHE_SHIFT		(CONFIG_FRV_L1_CACHE_SHIFT)
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define __cacheline_aligned	__attribute__((aligned(L1_CACHE_BYTES)))
 #define ____cacheline_aligned	__attribute__((aligned(L1_CACHE_BYTES)))
diff --git a/arch/frv/include/asm/kmap_types.h b/arch/frv/include/asm/kmap_types.h
index 43901f220..0d8b86566 100644
--- a/arch/frv/include/asm/kmap_types.h
+++ b/arch/frv/include/asm/kmap_types.h
@@ -2,6 +2,6 @@
 #ifndef _ASM_KMAP_TYPES_H
 #define _ASM_KMAP_TYPES_H
 
-#define KM_TYPE_NR 17
+#define KM_TYPE_NR 18
 
 #endif
diff --git a/arch/frv/mm/elf-fdpic.c b/arch/frv/mm/elf-fdpic.c
index 836f14707..4cf23f597 100644
--- a/arch/frv/mm/elf-fdpic.c
+++ b/arch/frv/mm/elf-fdpic.c
@@ -61,6 +61,7 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 {
 	struct vm_area_struct *vma;
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(current->mm, filp, flags);
 
 	if (len > TASK_SIZE)
 		return -ENOMEM;
@@ -73,8 +74,7 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 	if (addr) {
 		addr = PAGE_ALIGN(addr);
 		vma = find_vma(current->mm, addr);
-		if (TASK_SIZE - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			goto success;
 	}
 
@@ -85,6 +85,7 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 	info.high_limit = (current->mm->start_stack - 0x00200000);
 	info.align_mask = 0;
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 	if (!(addr & ~PAGE_MASK))
 		goto success;
diff --git a/arch/hexagon/include/asm/cache.h b/arch/hexagon/include/asm/cache.h
index 69952c184..4fa2908f2 100644
--- a/arch/hexagon/include/asm/cache.h
+++ b/arch/hexagon/include/asm/cache.h
@@ -21,9 +21,11 @@
 #ifndef __ASM_CACHE_H
 #define __ASM_CACHE_H
 
+#include <linux/const.h>
+
 /* Bytes per L1 cache line */
-#define L1_CACHE_SHIFT		(5)
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_SHIFT		5
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define ARCH_DMA_MINALIGN	L1_CACHE_BYTES
 
diff --git a/arch/ia64/Kconfig b/arch/ia64/Kconfig
index 18ca6a9ce..77b0e0d0b 100644
--- a/arch/ia64/Kconfig
+++ b/arch/ia64/Kconfig
@@ -519,6 +519,7 @@ config KEXEC
 	bool "kexec system call"
 	depends on !IA64_HP_SIM && (!SMP || HOTPLUG_CPU)
 	select KEXEC_CORE
+	depends on !GRKERNSEC_KMEM
 	help
 	  kexec is a system call that implements the ability to shutdown your
 	  current kernel, and to start another kernel.  It is like a reboot
diff --git a/arch/ia64/Makefile b/arch/ia64/Makefile
index c100d780f..07538ccb6 100644
--- a/arch/ia64/Makefile
+++ b/arch/ia64/Makefile
@@ -98,5 +98,6 @@ endef
 archprepare: make_nr_irqs_h
 PHONY += make_nr_irqs_h
 
+make_nr_irqs_h: KBUILD_CFLAGS := $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
 make_nr_irqs_h:
 	$(Q)$(MAKE) $(build)=arch/ia64/kernel include/generated/nr-irqs.h
diff --git a/arch/ia64/include/asm/atomic.h b/arch/ia64/include/asm/atomic.h
index f565ad376..484af469b 100644
--- a/arch/ia64/include/asm/atomic.h
+++ b/arch/ia64/include/asm/atomic.h
@@ -307,4 +307,14 @@ atomic64_add_negative (__s64 i, atomic64_t *v)
 #define atomic64_inc(v)			atomic64_add(1, (v))
 #define atomic64_dec(v)			atomic64_sub(1, (v))
 
+#define atomic64_read_unchecked(v)		atomic64_read(v)
+#define atomic64_set_unchecked(v, i)		atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v)		atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v)	atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v)		atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v)		atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v)	atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v)		atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n)	atomic64_cmpxchg((v), (o), (n))
+
 #endif /* _ASM_IA64_ATOMIC_H */
diff --git a/arch/ia64/include/asm/cache.h b/arch/ia64/include/asm/cache.h
index 988254a7d..e1ee8855a 100644
--- a/arch/ia64/include/asm/cache.h
+++ b/arch/ia64/include/asm/cache.h
@@ -1,6 +1,7 @@
 #ifndef _ASM_IA64_CACHE_H
 #define _ASM_IA64_CACHE_H
 
+#include <linux/const.h>
 
 /*
  * Copyright (C) 1998-2000 Hewlett-Packard Co
@@ -9,7 +10,7 @@
 
 /* Bytes per L1 (data) cache line.  */
 #define L1_CACHE_SHIFT		CONFIG_IA64_L1_CACHE_SHIFT
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #ifdef CONFIG_SMP
 # define SMP_CACHE_SHIFT	L1_CACHE_SHIFT
diff --git a/arch/ia64/include/asm/elf.h b/arch/ia64/include/asm/elf.h
index 5a83c5cc3..4d7f553aa 100644
--- a/arch/ia64/include/asm/elf.h
+++ b/arch/ia64/include/asm/elf.h
@@ -42,6 +42,13 @@
  */
 #define ELF_ET_DYN_BASE		(TASK_UNMAPPED_BASE + 0x800000000UL)
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(current->personality == PER_LINUX32 ? 0x08048000UL : 0x4000000000000000UL)
+
+#define PAX_DELTA_MMAP_LEN	(current->personality == PER_LINUX32 ? 16 : 3*PAGE_SHIFT - 13)
+#define PAX_DELTA_STACK_LEN	(current->personality == PER_LINUX32 ? 16 : 3*PAGE_SHIFT - 13)
+#endif
+
 #define PT_IA_64_UNWIND		0x70000001
 
 /* IA-64 relocations: */
diff --git a/arch/ia64/include/asm/pgalloc.h b/arch/ia64/include/asm/pgalloc.h
index f5e70e961..624fad58c 100644
--- a/arch/ia64/include/asm/pgalloc.h
+++ b/arch/ia64/include/asm/pgalloc.h
@@ -39,6 +39,12 @@ pgd_populate(struct mm_struct *mm, pgd_t * pgd_entry, pud_t * pud)
 	pgd_val(*pgd_entry) = __pa(pud);
 }
 
+static inline void
+pgd_populate_kernel(struct mm_struct *mm, pgd_t * pgd_entry, pud_t * pud)
+{
+	pgd_populate(mm, pgd_entry, pud);
+}
+
 static inline pud_t *pud_alloc_one(struct mm_struct *mm, unsigned long addr)
 {
 	return quicklist_alloc(0, GFP_KERNEL, NULL);
@@ -57,6 +63,12 @@ pud_populate(struct mm_struct *mm, pud_t * pud_entry, pmd_t * pmd)
 	pud_val(*pud_entry) = __pa(pmd);
 }
 
+static inline void
+pud_populate_kernel(struct mm_struct *mm, pud_t * pud_entry, pmd_t * pmd)
+{
+	pud_populate(mm, pud_entry, pmd);
+}
+
 static inline pmd_t *pmd_alloc_one(struct mm_struct *mm, unsigned long addr)
 {
 	return quicklist_alloc(0, GFP_KERNEL, NULL);
diff --git a/arch/ia64/include/asm/pgtable.h b/arch/ia64/include/asm/pgtable.h
index 9f3ed9ee8..c99b418c5 100644
--- a/arch/ia64/include/asm/pgtable.h
+++ b/arch/ia64/include/asm/pgtable.h
@@ -12,7 +12,7 @@
  *	David Mosberger-Tang <davidm@hpl.hp.com>
  */
 
-
+#include <linux/const.h>
 #include <asm/mman.h>
 #include <asm/page.h>
 #include <asm/processor.h>
@@ -139,6 +139,17 @@
 #define PAGE_READONLY	__pgprot(__ACCESS_BITS | _PAGE_PL_3 | _PAGE_AR_R)
 #define PAGE_COPY	__pgprot(__ACCESS_BITS | _PAGE_PL_3 | _PAGE_AR_R)
 #define PAGE_COPY_EXEC	__pgprot(__ACCESS_BITS | _PAGE_PL_3 | _PAGE_AR_RX)
+
+#ifdef CONFIG_PAX_PAGEEXEC
+# define PAGE_SHARED_NOEXEC	__pgprot(__ACCESS_BITS | _PAGE_PL_3 | _PAGE_AR_RW)
+# define PAGE_READONLY_NOEXEC	__pgprot(__ACCESS_BITS | _PAGE_PL_3 | _PAGE_AR_R)
+# define PAGE_COPY_NOEXEC	__pgprot(__ACCESS_BITS | _PAGE_PL_3 | _PAGE_AR_R)
+#else
+# define PAGE_SHARED_NOEXEC	PAGE_SHARED
+# define PAGE_READONLY_NOEXEC	PAGE_READONLY
+# define PAGE_COPY_NOEXEC	PAGE_COPY
+#endif
+
 #define PAGE_GATE	__pgprot(__ACCESS_BITS | _PAGE_PL_0 | _PAGE_AR_X_RX)
 #define PAGE_KERNEL	__pgprot(__DIRTY_BITS  | _PAGE_PL_0 | _PAGE_AR_RWX)
 #define PAGE_KERNELRX	__pgprot(__ACCESS_BITS | _PAGE_PL_0 | _PAGE_AR_RX)
diff --git a/arch/ia64/include/asm/spinlock.h b/arch/ia64/include/asm/spinlock.h
index ca9e76149..40dffaf15 100644
--- a/arch/ia64/include/asm/spinlock.h
+++ b/arch/ia64/include/asm/spinlock.h
@@ -73,7 +73,7 @@ static __always_inline void __ticket_spin_unlock(arch_spinlock_t *lock)
 	unsigned short	*p = (unsigned short *)&lock->lock + 1, tmp;
 
 	asm volatile ("ld2.bias %0=[%1]" : "=r"(tmp) : "r"(p));
-	ACCESS_ONCE(*p) = (tmp + 2) & ~1;
+	ACCESS_ONCE_RW(*p) = (tmp + 2) & ~1;
 }
 
 static __always_inline void __ticket_spin_unlock_wait(arch_spinlock_t *lock)
diff --git a/arch/ia64/include/asm/uaccess.h b/arch/ia64/include/asm/uaccess.h
index bfe13196f..da0014bdd 100644
--- a/arch/ia64/include/asm/uaccess.h
+++ b/arch/ia64/include/asm/uaccess.h
@@ -70,6 +70,7 @@
 	 && ((segment).seg == KERNEL_DS.seg						\
 	     || likely(REGION_OFFSET((unsigned long) (addr)) < RGN_MAP_LIMIT)));	\
 })
+#define access_ok_noprefault(type, addr, size) access_ok((type), (addr), (size))
 #define access_ok(type, addr, size)	__access_ok((addr), (size), get_fs())
 
 /*
@@ -241,17 +242,23 @@ extern unsigned long __must_check __copy_user (void __user *to, const void __use
 static inline unsigned long
 __copy_to_user (void __user *to, const void *from, unsigned long count)
 {
+	if (count > INT_MAX)
+		return count;
+
 	check_object_size(from, count, true);
 
-	return __copy_user(to, (__force void __user *) from, count);
+	return __copy_user(to, (void __force_user *) from, count);
 }
 
 static inline unsigned long
 __copy_from_user (void *to, const void __user *from, unsigned long count)
 {
+	if (count > INT_MAX)
+		return count;
+
 	check_object_size(to, count, false);
 
-	return __copy_user((__force void __user *) to, from, count);
+	return __copy_user((void __force_user *) to, from, count);
 }
 
 #define __copy_to_user_inatomic		__copy_to_user
@@ -260,11 +267,11 @@ __copy_from_user (void *to, const void __user *from, unsigned long count)
 ({											\
 	void __user *__cu_to = (to);							\
 	const void *__cu_from = (from);							\
-	long __cu_len = (n);								\
+	unsigned long __cu_len = (n);							\
 											\
-	if (__access_ok(__cu_to, __cu_len, get_fs())) {					\
-		check_object_size(__cu_from, __cu_len, true);			\
-		__cu_len = __copy_user(__cu_to, (__force void __user *)  __cu_from, __cu_len);	\
+	if (__cu_len <= INT_MAX && __access_ok(__cu_to, __cu_len, get_fs())) {		\
+		check_object_size(__cu_from, __cu_len, true);				\
+		__cu_len = __copy_user(__cu_to, (void __force_user *)  __cu_from, __cu_len);	\
 	}										\
 	__cu_len;									\
 })
@@ -272,10 +279,10 @@ __copy_from_user (void *to, const void __user *from, unsigned long count)
 static inline unsigned long
 copy_from_user(void *to, const void __user *from, unsigned long n)
 {
-	check_object_size(to, n, false);
-	if (likely(__access_ok(from, n, get_fs())))
-		n = __copy_user((__force void __user *) to, from, n);
-	else
+	if (likely(__access_ok(from, n, get_fs()))) {
+		check_object_size(to, n, false);
+		n = __copy_user((void __force_user *) to, from, n);
+	} else if ((long)n > 0)
 		memset(to, 0, n);
 	return n;
 }
diff --git a/arch/ia64/kernel/module.c b/arch/ia64/kernel/module.c
index 6ab0ae7d6..88f1b6018 100644
--- a/arch/ia64/kernel/module.c
+++ b/arch/ia64/kernel/module.c
@@ -486,13 +486,13 @@ module_frob_arch_sections (Elf_Ehdr *ehdr, Elf_Shdr *sechdrs, char *secstrings,
 static inline int
 in_init (const struct module *mod, uint64_t addr)
 {
-	return addr - (uint64_t) mod->init_layout.base < mod->init_layout.size;
+	return within_module_init(addr, mod);
 }
 
 static inline int
 in_core (const struct module *mod, uint64_t addr)
 {
-	return addr - (uint64_t) mod->core_layout.base < mod->core_layout.size;
+	return within_module_core(addr, mod);
 }
 
 static inline int
@@ -676,6 +676,14 @@ do_reloc (struct module *mod, uint8_t r_type, Elf64_Sym *sym, uint64_t addend,
 
 	      case RV_BDREL:
 		val -= (uint64_t) (in_init(mod, val) ? mod->init_layout.base : mod->core_layout.base);
+		if (within_module_rx(val, &mod->init_layout))
+			val -= mod->init_layout.base_rx;
+		else if (within_module_rw(val, &mod->init_layout))
+			val -= mod->init_layout.base_rw;
+		else if (within_module_rx(val, &mod->core_layout))
+			val -= mod->core_layout.base_rx;
+		else if (within_module_rw(val, &mod->core_layout))
+			val -= mod->core_layout.base_rw;
 		break;
 
 	      case RV_LTV:
@@ -810,15 +818,15 @@ apply_relocate_add (Elf64_Shdr *sechdrs, const char *strtab, unsigned int symind
 		 *     addresses have been selected...
 		 */
 		uint64_t gp;
-		if (mod->core_layout.size > MAX_LTOFF)
+		if (mod->core_layout.size_rx + mod->core_layout.size_rw > MAX_LTOFF)
 			/*
 			 * This takes advantage of fact that SHF_ARCH_SMALL gets allocated
 			 * at the end of the module.
 			 */
-			gp = mod->core_layout.size - MAX_LTOFF / 2;
+			gp = mod->core_layout.size_rx + mod->core_layout.size_rw - MAX_LTOFF / 2;
 		else
-			gp = mod->core_layout.size / 2;
-		gp = (uint64_t) mod->core_layout.base + ((gp + 7) & -8);
+			gp = (mod->core_layout.size_rx + mod->core_layout.size_rw) / 2;
+		gp = (uint64_t) mod->core_layout.base_rx + ((gp + 7) & -8);
 		mod->arch.gp = gp;
 		DEBUGP("%s: placing gp at 0x%lx\n", __func__, gp);
 	}
diff --git a/arch/ia64/kernel/palinfo.c b/arch/ia64/kernel/palinfo.c
index c39c3cd3a..3c77738fc 100644
--- a/arch/ia64/kernel/palinfo.c
+++ b/arch/ia64/kernel/palinfo.c
@@ -980,7 +980,7 @@ static int palinfo_cpu_callback(struct notifier_block *nfb,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block __refdata palinfo_cpu_notifier =
+static struct notifier_block palinfo_cpu_notifier =
 {
 	.notifier_call = palinfo_cpu_callback,
 	.priority = 0,
diff --git a/arch/ia64/kernel/sys_ia64.c b/arch/ia64/kernel/sys_ia64.c
index 41e33f84c..65180b2a2 100644
--- a/arch/ia64/kernel/sys_ia64.c
+++ b/arch/ia64/kernel/sys_ia64.c
@@ -28,6 +28,7 @@ arch_get_unmapped_area (struct file *filp, unsigned long addr, unsigned long len
 	unsigned long align_mask = 0;
 	struct mm_struct *mm = current->mm;
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 
 	if (len > RGN_MAP_LIMIT)
 		return -ENOMEM;
@@ -43,6 +44,13 @@ arch_get_unmapped_area (struct file *filp, unsigned long addr, unsigned long len
 	if (REGION_NUMBER(addr) == RGN_HPAGE)
 		addr = 0;
 #endif
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (mm->pax_flags & MF_PAX_RANDMMAP)
+		addr = mm->free_area_cache;
+	else
+#endif
+
 	if (!addr)
 		addr = TASK_UNMAPPED_BASE;
 
@@ -61,6 +69,7 @@ arch_get_unmapped_area (struct file *filp, unsigned long addr, unsigned long len
 	info.high_limit = TASK_SIZE;
 	info.align_mask = align_mask;
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	return vm_unmapped_area(&info);
 }
 
diff --git a/arch/ia64/kernel/vmlinux.lds.S b/arch/ia64/kernel/vmlinux.lds.S
index dc506b05f..39baade84 100644
--- a/arch/ia64/kernel/vmlinux.lds.S
+++ b/arch/ia64/kernel/vmlinux.lds.S
@@ -171,7 +171,7 @@ SECTIONS {
 	/* Per-cpu data: */
 	. = ALIGN(PERCPU_PAGE_SIZE);
 	PERCPU_VADDR(SMP_CACHE_BYTES, PERCPU_ADDR, :percpu)
-	__phys_per_cpu_start = __per_cpu_load;
+	__phys_per_cpu_start = per_cpu_load;
 	/*
 	 * ensure percpu data fits
 	 * into percpu page size
diff --git a/arch/ia64/mm/fault.c b/arch/ia64/mm/fault.c
index fa6ad95e9..b46bd89b9 100644
--- a/arch/ia64/mm/fault.c
+++ b/arch/ia64/mm/fault.c
@@ -72,6 +72,23 @@ mapped_kernel_page_is_present (unsigned long address)
 	return pte_present(pte);
 }
 
+#ifdef CONFIG_PAX_PAGEEXEC
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 8; i++) {
+		unsigned int c;
+		if (get_user(c, (unsigned int *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08x ", c);
+	}
+	printk("\n");
+}
+#endif
+
 #	define VM_READ_BIT	0
 #	define VM_WRITE_BIT	1
 #	define VM_EXEC_BIT	2
@@ -151,8 +168,21 @@ retry:
 	if (((isr >> IA64_ISR_R_BIT) & 1UL) && (!(vma->vm_flags & (VM_READ | VM_WRITE))))
 		goto bad_area;
 
-	if ((vma->vm_flags & mask) != mask)
+	if ((vma->vm_flags & mask) != mask) {
+
+#ifdef CONFIG_PAX_PAGEEXEC
+		if (!(vma->vm_flags & VM_EXEC) && (mask & VM_EXEC)) {
+			if (!(mm->pax_flags & MF_PAX_PAGEEXEC) || address != regs->cr_iip)
+				goto bad_area;
+
+			up_read(&mm->mmap_sem);
+			pax_report_fault(regs, (void *)regs->cr_iip, (void *)regs->r12);
+			do_group_exit(SIGKILL);
+		}
+#endif
+
 		goto bad_area;
+	}
 
 	/*
 	 * If for any reason at all we couldn't handle the fault, make
diff --git a/arch/ia64/mm/hugetlbpage.c b/arch/ia64/mm/hugetlbpage.c
index 85de86d36..db7f6b877 100644
--- a/arch/ia64/mm/hugetlbpage.c
+++ b/arch/ia64/mm/hugetlbpage.c
@@ -138,6 +138,7 @@ unsigned long hugetlb_get_unmapped_area(struct file *file, unsigned long addr, u
 		unsigned long pgoff, unsigned long flags)
 {
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(current->mm, file, flags);
 
 	if (len > RGN_MAP_LIMIT)
 		return -ENOMEM;
@@ -161,6 +162,7 @@ unsigned long hugetlb_get_unmapped_area(struct file *file, unsigned long addr, u
 	info.high_limit = HPAGE_REGION_BASE + RGN_MAP_LIMIT;
 	info.align_mask = PAGE_MASK & (HPAGE_SIZE - 1);
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	return vm_unmapped_area(&info);
 }
 
diff --git a/arch/ia64/mm/init.c b/arch/ia64/mm/init.c
index 1841ef691..74d833027 100644
--- a/arch/ia64/mm/init.c
+++ b/arch/ia64/mm/init.c
@@ -119,6 +119,19 @@ ia64_init_addr_space (void)
 		vma->vm_start = current->thread.rbs_bot & PAGE_MASK;
 		vma->vm_end = vma->vm_start + PAGE_SIZE;
 		vma->vm_flags = VM_DATA_DEFAULT_FLAGS|VM_GROWSUP|VM_ACCOUNT;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+		if (current->mm->pax_flags & MF_PAX_PAGEEXEC) {
+			vma->vm_flags &= ~VM_EXEC;
+
+#ifdef CONFIG_PAX_MPROTECT
+			if (current->mm->pax_flags & MF_PAX_MPROTECT)
+				vma->vm_flags &= ~VM_MAYEXEC;
+#endif
+
+		}
+#endif
+
 		vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
 		down_write(&current->mm->mmap_sem);
 		if (insert_vm_struct(current->mm, vma)) {
@@ -279,7 +292,7 @@ static int __init gate_vma_init(void)
 	gate_vma.vm_start = FIXADDR_USER_START;
 	gate_vma.vm_end = FIXADDR_USER_END;
 	gate_vma.vm_flags = VM_READ | VM_MAYREAD | VM_EXEC | VM_MAYEXEC;
-	gate_vma.vm_page_prot = __P101;
+	gate_vma.vm_page_prot = vm_get_page_prot(gate_vma.vm_flags);
 
 	return 0;
 }
diff --git a/arch/m32r/include/asm/cache.h b/arch/m32r/include/asm/cache.h
index 40b3ee981..8c2c112b9 100644
--- a/arch/m32r/include/asm/cache.h
+++ b/arch/m32r/include/asm/cache.h
@@ -1,8 +1,10 @@
 #ifndef _ASM_M32R_CACHE_H
 #define _ASM_M32R_CACHE_H
 
+#include <linux/const.h>
+
 /* L1 cache line size */
 #define L1_CACHE_SHIFT		4
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #endif  /* _ASM_M32R_CACHE_H */
diff --git a/arch/m32r/lib/usercopy.c b/arch/m32r/lib/usercopy.c
index 82abd159d..d95ae5db0 100644
--- a/arch/m32r/lib/usercopy.c
+++ b/arch/m32r/lib/usercopy.c
@@ -14,6 +14,9 @@
 unsigned long
 __generic_copy_to_user(void __user *to, const void *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	prefetch(from);
 	if (access_ok(VERIFY_WRITE, to, n))
 		__copy_user(to,from,n);
@@ -23,6 +26,9 @@ __generic_copy_to_user(void __user *to, const void *from, unsigned long n)
 unsigned long
 __generic_copy_from_user(void *to, const void __user *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	prefetchw(to);
 	if (access_ok(VERIFY_READ, from, n))
 		__copy_user_zeroing(to,from,n);
diff --git a/arch/m68k/include/asm/cache.h b/arch/m68k/include/asm/cache.h
index 0395c51e4..5f2603124 100644
--- a/arch/m68k/include/asm/cache.h
+++ b/arch/m68k/include/asm/cache.h
@@ -4,9 +4,11 @@
 #ifndef __ARCH_M68K_CACHE_H
 #define __ARCH_M68K_CACHE_H
 
+#include <linux/const.h>
+
 /* bytes per L1 cache line */
 #define        L1_CACHE_SHIFT  4
-#define        L1_CACHE_BYTES  (1<< L1_CACHE_SHIFT)
+#define        L1_CACHE_BYTES  (_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define ARCH_DMA_MINALIGN	L1_CACHE_BYTES
 
diff --git a/arch/m68k/kernel/time.c b/arch/m68k/kernel/time.c
index 4e5aa2f4f..172c46953 100644
--- a/arch/m68k/kernel/time.c
+++ b/arch/m68k/kernel/time.c
@@ -107,6 +107,7 @@ static int rtc_ioctl(struct device *dev, unsigned int cmd, unsigned long arg)
 
 	switch (cmd) {
 	case RTC_PLL_GET:
+		memset(&pll, 0, sizeof(pll));
 		if (!mach_get_rtc_pll || mach_get_rtc_pll(&pll))
 			return -EINVAL;
 		return copy_to_user(argp, &pll, sizeof pll) ? -EFAULT : 0;
diff --git a/arch/metag/mm/hugetlbpage.c b/arch/metag/mm/hugetlbpage.c
index db1b7da91..8e1368481 100644
--- a/arch/metag/mm/hugetlbpage.c
+++ b/arch/metag/mm/hugetlbpage.c
@@ -189,6 +189,7 @@ hugetlb_get_unmapped_area_new_pmd(unsigned long len)
 	info.high_limit = TASK_SIZE;
 	info.align_mask = PAGE_MASK & HUGEPT_MASK;
 	info.align_offset = 0;
+	info.threadstack_offset = 0;
 	return vm_unmapped_area(&info);
 }
 
diff --git a/arch/microblaze/include/asm/cache.h b/arch/microblaze/include/asm/cache.h
index 4efe96a03..60e869982 100644
--- a/arch/microblaze/include/asm/cache.h
+++ b/arch/microblaze/include/asm/cache.h
@@ -13,11 +13,12 @@
 #ifndef _ASM_MICROBLAZE_CACHE_H
 #define _ASM_MICROBLAZE_CACHE_H
 
+#include <linux/const.h>
 #include <asm/registers.h>
 
 #define L1_CACHE_SHIFT 5
 /* word-granular cache in microblaze */
-#define L1_CACHE_BYTES	(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES	(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define SMP_CACHE_BYTES	L1_CACHE_BYTES
 
diff --git a/arch/mips/Kbuild b/arch/mips/Kbuild
index 5c3f688a5..f8cc1b3f3 100644
--- a/arch/mips/Kbuild
+++ b/arch/mips/Kbuild
@@ -1,7 +1,7 @@
 # Fail on warnings - also for files referenced in subdirs
 # -Werror can be disabled for specific files using:
 # CFLAGS_<file.o> := -Wno-error
-subdir-ccflags-y := -Werror
+# subdir-ccflags-y := -Werror
 
 # platform specific definitions
 include arch/mips/Kbuild.platforms
diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index 212ff9292..36b3437c2 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -50,6 +50,7 @@ config MIPS
 	select HAVE_MOD_ARCH_SPECIFIC
 	select HAVE_NMI
 	select VIRT_TO_BUS
+	select HAVE_GCC_PLUGINS
 	select MODULES_USE_ELF_REL if MODULES
 	select MODULES_USE_ELF_RELA if MODULES && 64BIT
 	select CLONE_BACKWARDS
@@ -2561,7 +2562,7 @@ config RELOCATION_TABLE_SIZE
 
 config RANDOMIZE_BASE
 	bool "Randomize the address of the kernel image"
-	depends on RELOCATABLE
+	depends on RELOCATABLE && BROKEN_SECURITY
 	---help---
 	   Randomizes the physical and virtual address at which the
 	   kernel image is loaded, as a security feature that
@@ -2777,6 +2778,7 @@ source "kernel/Kconfig.preempt"
 config KEXEC
 	bool "Kexec system call"
 	select KEXEC_CORE
+	depends on !GRKERNSEC_KMEM
 	help
 	  kexec is a system call that implements the ability to shutdown your
 	  current kernel, and to start another kernel.  It is like a reboot
diff --git a/arch/mips/include/asm/atomic.h b/arch/mips/include/asm/atomic.h
index 0ab176bdb..c4469a461 100644
--- a/arch/mips/include/asm/atomic.h
+++ b/arch/mips/include/asm/atomic.h
@@ -22,15 +22,39 @@
 #include <asm/cmpxchg.h>
 #include <asm/war.h>
 
+#ifdef CONFIG_GENERIC_ATOMIC64
+#include <asm-generic/atomic64.h>
+#endif
+
 #define ATOMIC_INIT(i)	  { (i) }
 
+#ifdef CONFIG_64BIT
+#define _ASM_EXTABLE(from, to)		\
+"	.section __ex_table,\"a\"\n"	\
+"	.dword	" #from ", " #to"\n"	\
+"	.previous\n"
+#else
+#define _ASM_EXTABLE(from, to)		\
+"	.section __ex_table,\"a\"\n"	\
+"	.word	" #from ", " #to"\n"	\
+"	.previous\n"
+#endif
+
 /*
  * atomic_read - read atomic variable
  * @v: pointer of type atomic_t
  *
  * Atomically reads the value of @v.
  */
-#define atomic_read(v)		READ_ONCE((v)->counter)
+static inline int atomic_read(const atomic_t *v)
+{
+	return READ_ONCE(v->counter);
+}
+
+static inline int atomic_read_unchecked(const atomic_unchecked_t *v)
+{
+	return READ_ONCE(v->counter);
+}
 
 /*
  * atomic_set - set atomic variable
@@ -39,47 +63,77 @@
  *
  * Atomically sets the value of @v to @i.
  */
-#define atomic_set(v, i)	WRITE_ONCE((v)->counter, (i))
+static inline void atomic_set(atomic_t *v, int i)
+{
+	WRITE_ONCE(v->counter, i);
+}
+
+static inline void atomic_set_unchecked(atomic_unchecked_t *v, int i)
+{
+	WRITE_ONCE(v->counter, i);
+}
 
-#define ATOMIC_OP(op, c_op, asm_op)					      \
-static __inline__ void atomic_##op(int i, atomic_t * v)			      \
+#ifdef CONFIG_PAX_REFCOUNT
+#define __OVERFLOW_POST				\
+	"	b	4f		\n"	\
+	"	.set	noreorder	\n"	\
+	"3:	b	5f		\n"	\
+	"	move	%0, %1		\n"	\
+	"	.set	reorder		\n"
+#define __OVERFLOW_EXTABLE	\
+	"3:\n"			\
+	_ASM_EXTABLE(2b, 3b)
+#else
+#define __OVERFLOW_POST
+#define __OVERFLOW_EXTABLE
+#endif
+
+#define __ATOMIC_OP(op, suffix, asm_op, extable)			      \
+static inline void atomic_##op##suffix(int i, atomic##suffix##_t * v)	      \
 {									      \
 	if (kernel_uses_llsc && R10000_LLSC_WAR) {			      \
 		int temp;						      \
 									      \
 		__asm__ __volatile__(					      \
-		"	.set	arch=r4000				\n"   \
-		"1:	ll	%0, %1		# atomic_" #op "	\n"   \
-		"	" #asm_op " %0, %2				\n"   \
+		"	.set	mips3					\n"   \
+		"1:	ll	%0, %1		# atomic_" #op #suffix "\n"   \
+		"2:	" #asm_op " %0, %2				\n"   \
 		"	sc	%0, %1					\n"   \
 		"	beqzl	%0, 1b					\n"   \
+		extable							      \
 		"	.set	mips0					\n"   \
 		: "=&r" (temp), "+" GCC_OFF_SMALL_ASM() (v->counter)	      \
 		: "Ir" (i));						      \
 	} else if (kernel_uses_llsc) {					      \
 		int temp;						      \
 									      \
-		do {							      \
-			__asm__ __volatile__(				      \
-			"	.set	"MIPS_ISA_LEVEL"		\n"   \
-			"	ll	%0, %1		# atomic_" #op "\n"   \
-			"	" #asm_op " %0, %2			\n"   \
-			"	sc	%0, %1				\n"   \
-			"	.set	mips0				\n"   \
-			: "=&r" (temp), "+" GCC_OFF_SMALL_ASM() (v->counter)  \
-			: "Ir" (i));					      \
-		} while (unlikely(!temp));				      \
+		__asm__ __volatile__(					      \
+		"	.set	"MIPS_ISA_LEVEL"			\n"   \
+		"1:	ll	%0, %1		# atomic_" #op #suffix "\n"   \
+		"2:	" #asm_op " %0, %2				\n"   \
+		"	sc	%0, %1					\n"   \
+		"	beqz	%0, 1b					\n"   \
+			extable						      \
+		"	.set	mips0					\n"   \
+		: "=&r" (temp), "+" GCC_OFF_SMALL_ASM() (v->counter)	      \
+		: "Ir" (i));						      \
 	} else {							      \
 		unsigned long flags;					      \
 									      \
 		raw_local_irq_save(flags);				      \
-		v->counter c_op i;					      \
+		__asm__ __volatile__(					      \
+		"2:	" #asm_op " %0, %1				\n"   \
+		extable							      \
+		: "+r" (v->counter) : "Ir" (i));			      \
 		raw_local_irq_restore(flags);				      \
 	}								      \
 }
 
-#define ATOMIC_OP_RETURN(op, c_op, asm_op)				      \
-static __inline__ int atomic_##op##_return_relaxed(int i, atomic_t * v)	      \
+#define ATOMIC_OP(op, asm_op) __ATOMIC_OP(op, _unchecked, asm_op##u, )	      \
+			      __ATOMIC_OP(op, , asm_op, __OVERFLOW_EXTABLE)
+
+#define __ATOMIC_OP_RETURN(op, suffix, asm_op, post_op, extable)	      \
+static inline int atomic_##op##_return##suffix##_relaxed(int i, atomic##suffix##_t * v) \
 {									      \
 	int result;							      \
 									      \
@@ -87,12 +141,15 @@ static __inline__ int atomic_##op##_return_relaxed(int i, atomic_t * v)	      \
 		int temp;						      \
 									      \
 		__asm__ __volatile__(					      \
-		"	.set	arch=r4000				\n"   \
-		"1:	ll	%1, %2		# atomic_" #op "_return	\n"   \
-		"	" #asm_op " %0, %1, %3				\n"   \
+		"	.set	mips3					\n"   \
+		"1:	ll	%1, %2	# atomic_" #op "_return" #suffix"\n"  \
+		"2:	" #asm_op " %0, %1, %3				\n"   \
 		"	sc	%0, %2					\n"   \
 		"	beqzl	%0, 1b					\n"   \
-		"	" #asm_op " %0, %1, %3				\n"   \
+		post_op							      \
+		extable							      \
+		"4:	" #asm_op " %0, %1, %3				\n"   \
+		"5:							\n"   \
 		"	.set	mips0					\n"   \
 		: "=&r" (result), "=&r" (temp),				      \
 		  "+" GCC_OFF_SMALL_ASM() (v->counter)			      \
@@ -100,32 +157,40 @@ static __inline__ int atomic_##op##_return_relaxed(int i, atomic_t * v)	      \
 	} else if (kernel_uses_llsc) {					      \
 		int temp;						      \
 									      \
-		do {							      \
-			__asm__ __volatile__(				      \
-			"	.set	"MIPS_ISA_LEVEL"		\n"   \
-			"	ll	%1, %2	# atomic_" #op "_return	\n"   \
-			"	" #asm_op " %0, %1, %3			\n"   \
-			"	sc	%0, %2				\n"   \
-			"	.set	mips0				\n"   \
-			: "=&r" (result), "=&r" (temp),			      \
-			  "+" GCC_OFF_SMALL_ASM() (v->counter)		      \
-			: "Ir" (i));					      \
-		} while (unlikely(!result));				      \
-									      \
-		result = temp; result c_op i;				      \
+		__asm__ __volatile__(					      \
+		"	.set	"MIPS_ISA_LEVEL"			\n"   \
+		"1:	ll	%1, %2	# atomic_" #op "_return" #suffix "\n" \
+		"2:	" #asm_op " %0, %1, %3				\n"   \
+		"	sc	%0, %2					\n"   \
+		post_op							      \
+		extable							      \
+		"4:	" #asm_op " %0, %1, %3				\n"   \
+		"5:							\n"   \
+		"	.set	mips0					\n"   \
+		: "=&r" (result), "=&r" (temp),				      \
+		  "+" GCC_OFF_SMALL_ASM() (v->counter)			      \
+		: "Ir" (i));						      \
 	} else {							      \
 		unsigned long flags;					      \
 									      \
 		raw_local_irq_save(flags);				      \
-		result = v->counter;					      \
-		result c_op i;						      \
-		v->counter = result;					      \
+		__asm__ __volatile__(					      \
+		"	lw	%0, %1					\n"   \
+		"2:	" #asm_op " %0, %1, %2				\n"   \
+		"	sw	%0, %1					\n"   \
+		"3:							\n"   \
+		extable							      \
+		: "=&r" (result), "+" GCC_OFF_SMALL_ASM() (v->counter)	      \
+		: "Ir" (i));						      \
 		raw_local_irq_restore(flags);				      \
 	}								      \
 									      \
 	return result;							      \
 }
 
+#define ATOMIC_OP_RETURN(op, asm_op) __ATOMIC_OP_RETURN(op, _unchecked, asm_op##u, , )	\
+				     __ATOMIC_OP_RETURN(op, , asm_op, __OVERFLOW_POST, __OVERFLOW_EXTABLE)
+
 #define ATOMIC_FETCH_OP(op, c_op, asm_op)				      \
 static __inline__ int atomic_fetch_##op##_relaxed(int i, atomic_t * v)	      \
 {									      \
@@ -173,13 +238,13 @@ static __inline__ int atomic_fetch_##op##_relaxed(int i, atomic_t * v)	      \
 	return result;							      \
 }
 
-#define ATOMIC_OPS(op, c_op, asm_op)					      \
-	ATOMIC_OP(op, c_op, asm_op)					      \
-	ATOMIC_OP_RETURN(op, c_op, asm_op)				      \
-	ATOMIC_FETCH_OP(op, c_op, asm_op)
+#define ATOMIC_OPS(op, asm_op)					      \
+	ATOMIC_OP(op, asm_op)					      \
+	ATOMIC_OP_RETURN(op, asm_op)				      \
+	ATOMIC_FETCH_OP(op, asm_op)
 
-ATOMIC_OPS(add, +=, addu)
-ATOMIC_OPS(sub, -=, subu)
+ATOMIC_OPS(add, addu)
+ATOMIC_OPS(sub, subu)
 
 #define atomic_add_return_relaxed	atomic_add_return_relaxed
 #define atomic_sub_return_relaxed	atomic_sub_return_relaxed
@@ -187,13 +252,13 @@ ATOMIC_OPS(sub, -=, subu)
 #define atomic_fetch_sub_relaxed	atomic_fetch_sub_relaxed
 
 #undef ATOMIC_OPS
-#define ATOMIC_OPS(op, c_op, asm_op)					      \
-	ATOMIC_OP(op, c_op, asm_op)					      \
-	ATOMIC_FETCH_OP(op, c_op, asm_op)
+#define ATOMIC_OPS(op, asm_op)					      \
+	ATOMIC_OP(op, asm_op)					      \
+	ATOMIC_FETCH_OP(op, asm_op)
 
-ATOMIC_OPS(and, &=, and)
-ATOMIC_OPS(or, |=, or)
-ATOMIC_OPS(xor, ^=, xor)
+ATOMIC_OPS(and, and)
+ATOMIC_OPS(or, or)
+ATOMIC_OPS(xor, xor)
 
 #define atomic_fetch_and_relaxed	atomic_fetch_and_relaxed
 #define atomic_fetch_or_relaxed		atomic_fetch_or_relaxed
@@ -202,7 +267,9 @@ ATOMIC_OPS(xor, ^=, xor)
 #undef ATOMIC_OPS
 #undef ATOMIC_FETCH_OP
 #undef ATOMIC_OP_RETURN
+#undef __ATOMIC_OP_RETURN
 #undef ATOMIC_OP
+#undef __ATOMIC_OP
 
 /*
  * atomic_sub_if_positive - conditionally subtract integer from atomic variable
@@ -212,7 +279,7 @@ ATOMIC_OPS(xor, ^=, xor)
  * Atomically test @v and subtract @i if @v is greater or equal than @i.
  * The function returns the old value of @v minus @i.
  */
-static __inline__ int atomic_sub_if_positive(int i, atomic_t * v)
+static __inline__ int atomic_sub_if_positive(int i, atomic_t *v)
 {
 	int result;
 
@@ -222,7 +289,7 @@ static __inline__ int atomic_sub_if_positive(int i, atomic_t * v)
 		int temp;
 
 		__asm__ __volatile__(
-		"	.set	arch=r4000				\n"
+		"	.set	"MIPS_ISA_LEVEL"			\n"
 		"1:	ll	%1, %2		# atomic_sub_if_positive\n"
 		"	subu	%0, %1, %3				\n"
 		"	bltz	%0, 1f					\n"
@@ -271,8 +338,26 @@ static __inline__ int atomic_sub_if_positive(int i, atomic_t * v)
 	return result;
 }
 
-#define atomic_cmpxchg(v, o, n) (cmpxchg(&((v)->counter), (o), (n)))
-#define atomic_xchg(v, new) (xchg(&((v)->counter), (new)))
+static inline int atomic_cmpxchg(atomic_t *v, int old, int new)
+{
+	return cmpxchg(&v->counter, old, new);
+}
+
+static inline int atomic_cmpxchg_unchecked(atomic_unchecked_t *v, int old,
+					   int new)
+{
+	return cmpxchg(&(v->counter), old, new);
+}
+
+static inline int atomic_xchg(atomic_t *v, int new)
+{
+	return xchg(&v->counter, new);
+}
+
+static inline int atomic_xchg_unchecked(atomic_unchecked_t *v, int new)
+{
+	return xchg(&(v->counter), new);
+}
 
 /**
  * __atomic_add_unless - add unless the number is a given value
@@ -300,6 +385,10 @@ static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
 
 #define atomic_dec_return(v) atomic_sub_return(1, (v))
 #define atomic_inc_return(v) atomic_add_return(1, (v))
+static __inline__ int atomic_inc_return_unchecked(atomic_unchecked_t *v)
+{
+	return atomic_add_return_unchecked(1, v);
+}
 
 /*
  * atomic_sub_and_test - subtract value from variable and test result
@@ -321,6 +410,10 @@ static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
  * other cases.
  */
 #define atomic_inc_and_test(v) (atomic_inc_return(v) == 0)
+static __inline__ int atomic_inc_and_test_unchecked(atomic_unchecked_t *v)
+{
+	return atomic_add_return_unchecked(1, v) == 0;
+}
 
 /*
  * atomic_dec_and_test - decrement by 1 and test
@@ -345,6 +438,10 @@ static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
  * Atomically increments @v by 1.
  */
 #define atomic_inc(v) atomic_add(1, (v))
+static __inline__ void atomic_inc_unchecked(atomic_unchecked_t *v)
+{
+	atomic_add_unchecked(1, v);
+}
 
 /*
  * atomic_dec - decrement and test
@@ -353,6 +450,10 @@ static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
  * Atomically decrements @v by 1.
  */
 #define atomic_dec(v) atomic_sub(1, (v))
+static __inline__ void atomic_dec_unchecked(atomic_unchecked_t *v)
+{
+	atomic_sub_unchecked(1, v);
+}
 
 /*
  * atomic_add_negative - add and test if negative
@@ -374,54 +475,77 @@ static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
  * @v: pointer of type atomic64_t
  *
  */
-#define atomic64_read(v)	READ_ONCE((v)->counter)
+static inline long atomic64_read(const atomic64_t *v)
+{
+	return READ_ONCE(v->counter);
+}
+
+static inline long atomic64_read_unchecked(const atomic64_unchecked_t *v)
+{
+	return READ_ONCE(v->counter);
+}
 
 /*
  * atomic64_set - set atomic variable
  * @v: pointer of type atomic64_t
  * @i: required value
  */
-#define atomic64_set(v, i)	WRITE_ONCE((v)->counter, (i))
+static inline void atomic64_set(atomic64_t *v, long i)
+{
+	WRITE_ONCE(v->counter, i);
+}
 
-#define ATOMIC64_OP(op, c_op, asm_op)					      \
-static __inline__ void atomic64_##op(long i, atomic64_t * v)		      \
+static inline void atomic64_set_unchecked(atomic64_unchecked_t *v, long i)
+{
+	WRITE_ONCE(v->counter, i);
+}
+
+#define __ATOMIC64_OP(op, suffix, asm_op, extable)			      \
+static inline void atomic64_##op##suffix(long i, atomic64##suffix##_t * v)    \
 {									      \
 	if (kernel_uses_llsc && R10000_LLSC_WAR) {			      \
 		long temp;						      \
 									      \
 		__asm__ __volatile__(					      \
-		"	.set	arch=r4000				\n"   \
-		"1:	lld	%0, %1		# atomic64_" #op "	\n"   \
-		"	" #asm_op " %0, %2				\n"   \
+		"	.set	"MIPS_ISA_LEVEL"			\n"   \
+		"1:	lld	%0, %1		# atomic64_" #op #suffix "\n" \
+		"2:	" #asm_op " %0, %2				\n"   \
 		"	scd	%0, %1					\n"   \
 		"	beqzl	%0, 1b					\n"   \
+		extable							      \
 		"	.set	mips0					\n"   \
 		: "=&r" (temp), "+" GCC_OFF_SMALL_ASM() (v->counter)	      \
 		: "Ir" (i));						      \
 	} else if (kernel_uses_llsc) {					      \
 		long temp;						      \
 									      \
-		do {							      \
-			__asm__ __volatile__(				      \
-			"	.set	"MIPS_ISA_LEVEL"		\n"   \
-			"	lld	%0, %1		# atomic64_" #op "\n" \
-			"	" #asm_op " %0, %2			\n"   \
-			"	scd	%0, %1				\n"   \
-			"	.set	mips0				\n"   \
-			: "=&r" (temp), "+" GCC_OFF_SMALL_ASM() (v->counter)      \
-			: "Ir" (i));					      \
-		} while (unlikely(!temp));				      \
+		__asm__ __volatile__(					      \
+		"	.set	"MIPS_ISA_LEVEL"			\n"   \
+		"1:	lld	%0, %1		# atomic64_" #op #suffix "\n" \
+		"2:	" #asm_op " %0, %2				\n"   \
+		"	scd	%0, %1					\n"   \
+		"	beqz	%0, 1b					\n"   \
+			extable						      \
+		"	.set	mips0					\n"   \
+		: "=&r" (temp), "+" GCC_OFF_SMALL_ASM() (v->counter)	      \
+		: "Ir" (i));						      \
 	} else {							      \
 		unsigned long flags;					      \
 									      \
 		raw_local_irq_save(flags);				      \
-		v->counter c_op i;					      \
+		__asm__ __volatile__(					      \
+		"2:	" #asm_op " %0, %1				\n"   \
+		extable							      \
+		: "+" GCC_OFF_SMALL_ASM() (v->counter) : "Ir" (i));	      \
 		raw_local_irq_restore(flags);				      \
 	}								      \
 }
 
-#define ATOMIC64_OP_RETURN(op, c_op, asm_op)				      \
-static __inline__ long atomic64_##op##_return_relaxed(long i, atomic64_t * v) \
+#define ATOMIC64_OP(op, asm_op) __ATOMIC64_OP(op, _unchecked, asm_op##u, )    \
+				__ATOMIC64_OP(op, , asm_op, __OVERFLOW_EXTABLE)
+
+#define __ATOMIC64_OP_RETURN(op, suffix, asm_op, post_op, extable)	      \
+static inline long atomic64_##op##_return##suffix##_relaxed(long i, atomic64##suffix##_t * v)\
 {									      \
 	long result;							      \
 									      \
@@ -429,12 +553,15 @@ static __inline__ long atomic64_##op##_return_relaxed(long i, atomic64_t * v) \
 		long temp;						      \
 									      \
 		__asm__ __volatile__(					      \
-		"	.set	arch=r4000				\n"   \
+		"	.set	mips3					\n"   \
 		"1:	lld	%1, %2		# atomic64_" #op "_return\n"  \
-		"	" #asm_op " %0, %1, %3				\n"   \
+		"2:	" #asm_op " %0, %1, %3				\n"   \
 		"	scd	%0, %2					\n"   \
 		"	beqzl	%0, 1b					\n"   \
-		"	" #asm_op " %0, %1, %3				\n"   \
+		post_op							      \
+		extable							      \
+		"4:	" #asm_op " %0, %1, %3				\n"   \
+		"5:							\n"   \
 		"	.set	mips0					\n"   \
 		: "=&r" (result), "=&r" (temp),				      \
 		  "+" GCC_OFF_SMALL_ASM() (v->counter)			      \
@@ -442,33 +569,42 @@ static __inline__ long atomic64_##op##_return_relaxed(long i, atomic64_t * v) \
 	} else if (kernel_uses_llsc) {					      \
 		long temp;						      \
 									      \
-		do {							      \
-			__asm__ __volatile__(				      \
-			"	.set	"MIPS_ISA_LEVEL"		\n"   \
-			"	lld	%1, %2	# atomic64_" #op "_return\n"  \
-			"	" #asm_op " %0, %1, %3			\n"   \
-			"	scd	%0, %2				\n"   \
-			"	.set	mips0				\n"   \
-			: "=&r" (result), "=&r" (temp),			      \
-			  "=" GCC_OFF_SMALL_ASM() (v->counter)		      \
-			: "Ir" (i), GCC_OFF_SMALL_ASM() (v->counter)	      \
-			: "memory");					      \
-		} while (unlikely(!result));				      \
-									      \
-		result = temp; result c_op i;				      \
+		__asm__ __volatile__(					      \
+		"	.set	"MIPS_ISA_LEVEL"			\n"   \
+		"1:	lld	%1, %2	# atomic64_" #op "_return" #suffix "\n"\
+		"2:	" #asm_op " %0, %1, %3				\n"   \
+		"	scd	%0, %2					\n"   \
+		"	beqz	%0, 1b					\n"   \
+		post_op							      \
+		extable							      \
+		"4:	" #asm_op " %0, %1, %3				\n"   \
+		"5:							\n"   \
+		"	.set	mips0					\n"   \
+		: "=&r" (result), "=&r" (temp),				      \
+		  "=" GCC_OFF_SMALL_ASM() (v->counter)			      \
+		: "Ir" (i), GCC_OFF_SMALL_ASM() (v->counter)		      \
+		: "memory");						      \
 	} else {							      \
 		unsigned long flags;					      \
 									      \
 		raw_local_irq_save(flags);				      \
-		result = v->counter;					      \
-		result c_op i;						      \
-		v->counter = result;					      \
+		__asm__ __volatile__(					      \
+		"	ld	%0, %1					\n"   \
+		"2:	" #asm_op " %0, %1, %2				\n"   \
+		"	sd	%0, %1					\n"   \
+		"3:							\n"   \
+		extable							      \
+		: "=&r" (result), "+" GCC_OFF_SMALL_ASM() (v->counter)	      \
+		: "Ir" (i));						      \
 		raw_local_irq_restore(flags);				      \
 	}								      \
 									      \
 	return result;							      \
 }
 
+#define ATOMIC64_OP_RETURN(op, asm_op) __ATOMIC64_OP_RETURN(op, _unchecked, asm_op##u, , )	\
+				       __ATOMIC64_OP_RETURN(op, , asm_op, __OVERFLOW_POST, __OVERFLOW_EXTABLE)
+
 #define ATOMIC64_FETCH_OP(op, c_op, asm_op)				      \
 static __inline__ long atomic64_fetch_##op##_relaxed(long i, atomic64_t * v)  \
 {									      \
@@ -517,13 +653,13 @@ static __inline__ long atomic64_fetch_##op##_relaxed(long i, atomic64_t * v)  \
 	return result;							      \
 }
 
-#define ATOMIC64_OPS(op, c_op, asm_op)					      \
-	ATOMIC64_OP(op, c_op, asm_op)					      \
-	ATOMIC64_OP_RETURN(op, c_op, asm_op)				      \
-	ATOMIC64_FETCH_OP(op, c_op, asm_op)
+#define ATOMIC64_OPS(op, asm_op)					      \
+	ATOMIC64_OP(op, asm_op)					      \
+	ATOMIC64_OP_RETURN(op, asm_op)				      \
+	ATOMIC64_FETCH_OP(op, asm_op)
 
-ATOMIC64_OPS(add, +=, daddu)
-ATOMIC64_OPS(sub, -=, dsubu)
+ATOMIC64_OPS(add, daddu)
+ATOMIC64_OPS(sub, dsubu)
 
 #define atomic64_add_return_relaxed	atomic64_add_return_relaxed
 #define atomic64_sub_return_relaxed	atomic64_sub_return_relaxed
@@ -531,13 +667,13 @@ ATOMIC64_OPS(sub, -=, dsubu)
 #define atomic64_fetch_sub_relaxed	atomic64_fetch_sub_relaxed
 
 #undef ATOMIC64_OPS
-#define ATOMIC64_OPS(op, c_op, asm_op)					      \
-	ATOMIC64_OP(op, c_op, asm_op)					      \
-	ATOMIC64_FETCH_OP(op, c_op, asm_op)
+#define ATOMIC64_OPS(op, asm_op)					      \
+	ATOMIC64_OP(op, asm_op)					      \
+	ATOMIC64_FETCH_OP(op, asm_op)
 
-ATOMIC64_OPS(and, &=, and)
-ATOMIC64_OPS(or, |=, or)
-ATOMIC64_OPS(xor, ^=, xor)
+ATOMIC64_OPS(and, and)
+ATOMIC64_OPS(or, or)
+ATOMIC64_OPS(xor, xor)
 
 #define atomic64_fetch_and_relaxed	atomic64_fetch_and_relaxed
 #define atomic64_fetch_or_relaxed	atomic64_fetch_or_relaxed
@@ -546,7 +682,11 @@ ATOMIC64_OPS(xor, ^=, xor)
 #undef ATOMIC64_OPS
 #undef ATOMIC64_FETCH_OP
 #undef ATOMIC64_OP_RETURN
+#undef __ATOMIC64_OP_RETURN
 #undef ATOMIC64_OP
+#undef __ATOMIC64_OP
+#undef __OVERFLOW_EXTABLE
+#undef __OVERFLOW_POST
 
 /*
  * atomic64_sub_if_positive - conditionally subtract integer from atomic
@@ -557,7 +697,7 @@ ATOMIC64_OPS(xor, ^=, xor)
  * Atomically test @v and subtract @i if @v is greater or equal than @i.
  * The function returns the old value of @v minus @i.
  */
-static __inline__ long atomic64_sub_if_positive(long i, atomic64_t * v)
+static __inline__ long atomic64_sub_if_positive(long i, atomic64_t *v)
 {
 	long result;
 
@@ -567,7 +707,7 @@ static __inline__ long atomic64_sub_if_positive(long i, atomic64_t * v)
 		long temp;
 
 		__asm__ __volatile__(
-		"	.set	arch=r4000				\n"
+		"	.set	"MIPS_ISA_LEVEL"			\n"
 		"1:	lld	%1, %2		# atomic64_sub_if_positive\n"
 		"	dsubu	%0, %1, %3				\n"
 		"	bltz	%0, 1f					\n"
@@ -616,9 +756,26 @@ static __inline__ long atomic64_sub_if_positive(long i, atomic64_t * v)
 	return result;
 }
 
-#define atomic64_cmpxchg(v, o, n) \
-	((__typeof__((v)->counter))cmpxchg(&((v)->counter), (o), (n)))
-#define atomic64_xchg(v, new) (xchg(&((v)->counter), (new)))
+static inline long atomic64_cmpxchg(atomic64_t *v, long old, long new)
+{
+	return cmpxchg(&v->counter, old, new);
+}
+
+static inline long atomic64_cmpxchg_unchecked(atomic64_unchecked_t *v, long old,
+					      long new)
+{
+	return cmpxchg(&(v->counter), old, new);
+}
+
+static inline long atomic64_xchg(atomic64_t *v, long new)
+{
+	return xchg(&v->counter, new);
+}
+
+static inline long atomic64_xchg_unchecked(atomic64_unchecked_t *v, long new)
+{
+	return xchg(&(v->counter), new);
+}
 
 /**
  * atomic64_add_unless - add unless the number is a given value
@@ -648,6 +805,7 @@ static __inline__ int atomic64_add_unless(atomic64_t *v, long a, long u)
 
 #define atomic64_dec_return(v) atomic64_sub_return(1, (v))
 #define atomic64_inc_return(v) atomic64_add_return(1, (v))
+#define atomic64_inc_return_unchecked(v) atomic64_add_return_unchecked(1, (v))
 
 /*
  * atomic64_sub_and_test - subtract value from variable and test result
@@ -669,6 +827,7 @@ static __inline__ int atomic64_add_unless(atomic64_t *v, long a, long u)
  * other cases.
  */
 #define atomic64_inc_and_test(v) (atomic64_inc_return(v) == 0)
+#define atomic64_inc_and_test_unchecked(v) atomic64_add_return_unchecked(1, (v)) == 0)
 
 /*
  * atomic64_dec_and_test - decrement by 1 and test
@@ -693,6 +852,7 @@ static __inline__ int atomic64_add_unless(atomic64_t *v, long a, long u)
  * Atomically increments @v by 1.
  */
 #define atomic64_inc(v) atomic64_add(1, (v))
+#define atomic64_inc_unchecked(v) atomic64_add_unchecked(1, (v))
 
 /*
  * atomic64_dec - decrement and test
@@ -701,6 +861,7 @@ static __inline__ int atomic64_add_unless(atomic64_t *v, long a, long u)
  * Atomically decrements @v by 1.
  */
 #define atomic64_dec(v) atomic64_sub(1, (v))
+#define atomic64_dec_unchecked(v) atomic64_sub_unchecked(1, (v))
 
 /*
  * atomic64_add_negative - add and test if negative
diff --git a/arch/mips/include/asm/cache.h b/arch/mips/include/asm/cache.h
index b4db69fbc..8f3b09336 100644
--- a/arch/mips/include/asm/cache.h
+++ b/arch/mips/include/asm/cache.h
@@ -9,10 +9,11 @@
 #ifndef _ASM_CACHE_H
 #define _ASM_CACHE_H
 
+#include <linux/const.h>
 #include <kmalloc.h>
 
 #define L1_CACHE_SHIFT		CONFIG_MIPS_L1_CACHE_SHIFT
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define SMP_CACHE_SHIFT		L1_CACHE_SHIFT
 #define SMP_CACHE_BYTES		L1_CACHE_BYTES
diff --git a/arch/mips/include/asm/elf.h b/arch/mips/include/asm/elf.h
index 2b3dc2973..1f7bdc44f 100644
--- a/arch/mips/include/asm/elf.h
+++ b/arch/mips/include/asm/elf.h
@@ -458,6 +458,13 @@ extern const char *__elf_platform;
 #define ELF_ET_DYN_BASE		(TASK_SIZE / 3 * 2)
 #endif
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(TASK_IS_32BIT_ADDR ? 0x00400000UL : 0x00400000UL)
+
+#define PAX_DELTA_MMAP_LEN	(TASK_IS_32BIT_ADDR ? 27-PAGE_SHIFT : 36-PAGE_SHIFT)
+#define PAX_DELTA_STACK_LEN	(TASK_IS_32BIT_ADDR ? 27-PAGE_SHIFT : 36-PAGE_SHIFT)
+#endif
+
 /* update AT_VECTOR_SIZE_ARCH if the number of NEW_AUX_ENT entries changes */
 #define ARCH_DLINFO							\
 do {									\
diff --git a/arch/mips/include/asm/exec.h b/arch/mips/include/asm/exec.h
index c1f6afa4b..38cc6e9a3 100644
--- a/arch/mips/include/asm/exec.h
+++ b/arch/mips/include/asm/exec.h
@@ -12,6 +12,6 @@
 #ifndef _ASM_EXEC_H
 #define _ASM_EXEC_H
 
-extern unsigned long arch_align_stack(unsigned long sp);
+#define arch_align_stack(x) ((x) & ~0xfUL)
 
 #endif /* _ASM_EXEC_H */
diff --git a/arch/mips/include/asm/hw_irq.h b/arch/mips/include/asm/hw_irq.h
index 9e8ef5994..1139d6bbd 100644
--- a/arch/mips/include/asm/hw_irq.h
+++ b/arch/mips/include/asm/hw_irq.h
@@ -10,7 +10,7 @@
 
 #include <linux/atomic.h>
 
-extern atomic_t irq_err_count;
+extern atomic_unchecked_t irq_err_count;
 
 /*
  * interrupt-retrigger: NOP for now. This may not be appropriate for all
diff --git a/arch/mips/include/asm/irq.h b/arch/mips/include/asm/irq.h
index 15e0fecbc..3ee3eecf3 100644
--- a/arch/mips/include/asm/irq.h
+++ b/arch/mips/include/asm/irq.h
@@ -11,7 +11,6 @@
 
 #include <linux/linkage.h>
 #include <linux/smp.h>
-#include <linux/irqdomain.h>
 
 #include <asm/mipsmtregs.h>
 
diff --git a/arch/mips/include/asm/local.h b/arch/mips/include/asm/local.h
index 8feaed62a..1bd8a64b9 100644
--- a/arch/mips/include/asm/local.h
+++ b/arch/mips/include/asm/local.h
@@ -13,15 +13,25 @@ typedef struct
 	atomic_long_t a;
 } local_t;
 
+typedef struct {
+	atomic_long_unchecked_t a;
+} local_unchecked_t;
+
 #define LOCAL_INIT(i)	{ ATOMIC_LONG_INIT(i) }
 
 #define local_read(l)	atomic_long_read(&(l)->a)
+#define local_read_unchecked(l)	atomic_long_read_unchecked(&(l)->a)
 #define local_set(l, i) atomic_long_set(&(l)->a, (i))
+#define local_set_unchecked(l, i)	atomic_long_set_unchecked(&(l)->a, (i))
 
 #define local_add(i, l) atomic_long_add((i), (&(l)->a))
+#define local_add_unchecked(i, l) atomic_long_add_unchecked((i), (&(l)->a))
 #define local_sub(i, l) atomic_long_sub((i), (&(l)->a))
+#define local_sub_unchecked(i, l) atomic_long_sub_unchecked((i), (&(l)->a))
 #define local_inc(l)	atomic_long_inc(&(l)->a)
+#define local_inc_unchecked(l)	atomic_long_inc_unchecked(&(l)->a)
 #define local_dec(l)	atomic_long_dec(&(l)->a)
+#define local_dec_unchecked(l)	atomic_long_dec_unchecked(&(l)->a)
 
 /*
  * Same as above, but return the result value
@@ -71,6 +81,51 @@ static __inline__ long local_add_return(long i, local_t * l)
 	return result;
 }
 
+static __inline__ long local_add_return_unchecked(long i, local_unchecked_t * l)
+{
+	unsigned long result;
+
+	if (kernel_uses_llsc && R10000_LLSC_WAR) {
+		unsigned long temp;
+
+		__asm__ __volatile__(
+		"	.set	mips3					\n"
+		"1:"	__LL	"%1, %2		# local_add_return	\n"
+		"	addu	%0, %1, %3				\n"
+			__SC	"%0, %2					\n"
+		"	beqzl	%0, 1b					\n"
+		"	addu	%0, %1, %3				\n"
+		"	.set	mips0					\n"
+		: "=&r" (result), "=&r" (temp), "=m" (l->a.counter)
+		: "Ir" (i), "m" (l->a.counter)
+		: "memory");
+	} else if (kernel_uses_llsc) {
+		unsigned long temp;
+
+		__asm__ __volatile__(
+		"	.set	mips3					\n"
+		"1:"	__LL	"%1, %2		# local_add_return	\n"
+		"	addu	%0, %1, %3				\n"
+			__SC	"%0, %2					\n"
+		"	beqz	%0, 1b					\n"
+		"	addu	%0, %1, %3				\n"
+		"	.set	mips0					\n"
+		: "=&r" (result), "=&r" (temp), "=m" (l->a.counter)
+		: "Ir" (i), "m" (l->a.counter)
+		: "memory");
+	} else {
+		unsigned long flags;
+
+		local_irq_save(flags);
+		result = l->a.counter;
+		result += i;
+		l->a.counter = result;
+		local_irq_restore(flags);
+	}
+
+	return result;
+}
+
 static __inline__ long local_sub_return(long i, local_t * l)
 {
 	unsigned long result;
@@ -118,6 +173,8 @@ static __inline__ long local_sub_return(long i, local_t * l)
 
 #define local_cmpxchg(l, o, n) \
 	((long)cmpxchg_local(&((l)->a.counter), (o), (n)))
+#define local_cmpxchg_unchecked(l, o, n) \
+	((long)cmpxchg_local(&((l)->a.counter), (o), (n)))
 #define local_xchg(l, n) (atomic_long_xchg((&(l)->a), (n)))
 
 /**
diff --git a/arch/mips/include/asm/page.h b/arch/mips/include/asm/page.h
index 5f9875980..a3a7cb2c5 100644
--- a/arch/mips/include/asm/page.h
+++ b/arch/mips/include/asm/page.h
@@ -118,7 +118,7 @@ extern void copy_user_highpage(struct page *to, struct page *from,
   #ifdef CONFIG_CPU_MIPS32
     typedef struct { unsigned long pte_low, pte_high; } pte_t;
     #define pte_val(x)	  ((x).pte_low | ((unsigned long long)(x).pte_high << 32))
-    #define __pte(x)	  ({ pte_t __pte = {(x), ((unsigned long long)(x)) >> 32}; __pte; })
+    #define __pte(x)	  ({ pte_t __pte = {(x), (x) >> 32}; __pte; })
   #else
      typedef struct { unsigned long long pte; } pte_t;
      #define pte_val(x) ((x).pte)
diff --git a/arch/mips/include/asm/pgalloc.h b/arch/mips/include/asm/pgalloc.h
index 93c079a1c..1d6bf7cce 100644
--- a/arch/mips/include/asm/pgalloc.h
+++ b/arch/mips/include/asm/pgalloc.h
@@ -37,6 +37,11 @@ static inline void pud_populate(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
 {
 	set_pud(pud, __pud((unsigned long)pmd));
 }
+
+static inline void pud_populate_kernel(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
+{
+	pud_populate(mm, pud, pmd);
+}
 #endif
 
 /*
diff --git a/arch/mips/include/asm/pgtable.h b/arch/mips/include/asm/pgtable.h
index 70128d3f7..471bc2521 100644
--- a/arch/mips/include/asm/pgtable.h
+++ b/arch/mips/include/asm/pgtable.h
@@ -20,6 +20,9 @@
 #include <asm/io.h>
 #include <asm/pgtable-bits.h>
 
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+
 struct mm_struct;
 struct vm_area_struct;
 
diff --git a/arch/mips/include/asm/thread_info.h b/arch/mips/include/asm/thread_info.h
index e309d8fcb..20eefecfa 100644
--- a/arch/mips/include/asm/thread_info.h
+++ b/arch/mips/include/asm/thread_info.h
@@ -101,6 +101,9 @@ static inline struct thread_info *current_thread_info(void)
 #define TIF_NOTIFY_RESUME	5	/* callback before returning to user */
 #define TIF_UPROBE		6	/* breakpointed or singlestepping */
 #define TIF_RESTORE_SIGMASK	9	/* restore signal mask in do_signal() */
+/* li takes a 32bit immediate */
+#define TIF_GRSEC_SETXID	10	/* update credentials on syscall entry/exit */
+
 #define TIF_USEDFPU		16	/* FPU was used by this task this quantum (SMP) */
 #define TIF_MEMDIE		18	/* is terminating due to OOM killer */
 #define TIF_NOHZ		19	/* in adaptive nohz mode */
@@ -137,14 +140,16 @@ static inline struct thread_info *current_thread_info(void)
 #define _TIF_USEDMSA		(1<<TIF_USEDMSA)
 #define _TIF_MSA_CTX_LIVE	(1<<TIF_MSA_CTX_LIVE)
 #define _TIF_SYSCALL_TRACEPOINT	(1<<TIF_SYSCALL_TRACEPOINT)
+#define _TIF_GRSEC_SETXID	(1<<TIF_GRSEC_SETXID)
 
 #define _TIF_WORK_SYSCALL_ENTRY	(_TIF_NOHZ | _TIF_SYSCALL_TRACE |	\
 				 _TIF_SYSCALL_AUDIT | \
-				 _TIF_SYSCALL_TRACEPOINT | _TIF_SECCOMP)
+				 _TIF_SYSCALL_TRACEPOINT | _TIF_SECCOMP | \
+				 _TIF_GRSEC_SETXID)
 
 /* work to do in syscall_trace_leave() */
 #define _TIF_WORK_SYSCALL_EXIT	(_TIF_NOHZ | _TIF_SYSCALL_TRACE |	\
-				 _TIF_SYSCALL_AUDIT | _TIF_SYSCALL_TRACEPOINT)
+				 _TIF_SYSCALL_AUDIT | _TIF_SYSCALL_TRACEPOINT | _TIF_GRSEC_SETXID)
 
 /* work to do on interrupt/exception return */
 #define _TIF_WORK_MASK		\
@@ -153,7 +158,7 @@ static inline struct thread_info *current_thread_info(void)
 /* work to do on any return to u-space */
 #define _TIF_ALLWORK_MASK	(_TIF_NOHZ | _TIF_WORK_MASK |		\
 				 _TIF_WORK_SYSCALL_EXIT |		\
-				 _TIF_SYSCALL_TRACEPOINT)
+				 _TIF_SYSCALL_TRACEPOINT | _TIF_GRSEC_SETXID)
 
 /*
  * We stash processor id into a COP0 register to retrieve it fast
diff --git a/arch/mips/include/asm/uaccess.h b/arch/mips/include/asm/uaccess.h
index 21a2aaba2..c00b80dfd 100644
--- a/arch/mips/include/asm/uaccess.h
+++ b/arch/mips/include/asm/uaccess.h
@@ -147,6 +147,7 @@ static inline bool eva_kernel_access(void)
 	__ok == 0;							\
 })
 
+#define access_ok_noprefault(type, addr, size) access_ok((type), (addr), (size))
 #define access_ok(type, addr, size)					\
 	likely(__access_ok((addr), (size), __access_mask))
 
diff --git a/arch/mips/kernel/binfmt_elfn32.c b/arch/mips/kernel/binfmt_elfn32.c
index 58ad63d7e..051b4b71b 100644
--- a/arch/mips/kernel/binfmt_elfn32.c
+++ b/arch/mips/kernel/binfmt_elfn32.c
@@ -36,6 +36,13 @@ typedef elf_fpreg_t elf_fpregset_t[ELF_NFPREG];
 #undef ELF_ET_DYN_BASE
 #define ELF_ET_DYN_BASE		(TASK32_SIZE / 3 * 2)
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(TASK_IS_32BIT_ADDR ? 0x00400000UL : 0x00400000UL)
+
+#define PAX_DELTA_MMAP_LEN	(TASK_IS_32BIT_ADDR ? 27-PAGE_SHIFT : 36-PAGE_SHIFT)
+#define PAX_DELTA_STACK_LEN	(TASK_IS_32BIT_ADDR ? 27-PAGE_SHIFT : 36-PAGE_SHIFT)
+#endif
+
 #include <asm/processor.h>
 #include <linux/module.h>
 #include <linux/elfcore.h>
diff --git a/arch/mips/kernel/binfmt_elfo32.c b/arch/mips/kernel/binfmt_elfo32.c
index 49fb88148..b9ab7c202 100644
--- a/arch/mips/kernel/binfmt_elfo32.c
+++ b/arch/mips/kernel/binfmt_elfo32.c
@@ -40,6 +40,13 @@ typedef elf_fpreg_t elf_fpregset_t[ELF_NFPREG];
 #undef ELF_ET_DYN_BASE
 #define ELF_ET_DYN_BASE		(TASK32_SIZE / 3 * 2)
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(TASK_IS_32BIT_ADDR ? 0x00400000UL : 0x00400000UL)
+
+#define PAX_DELTA_MMAP_LEN	(TASK_IS_32BIT_ADDR ? 27-PAGE_SHIFT : 36-PAGE_SHIFT)
+#define PAX_DELTA_STACK_LEN	(TASK_IS_32BIT_ADDR ? 27-PAGE_SHIFT : 36-PAGE_SHIFT)
+#endif
+
 #include <asm/processor.h>
 
 #include <linux/module.h>
diff --git a/arch/mips/kernel/irq-gt641xx.c b/arch/mips/kernel/irq-gt641xx.c
index 44a1f792e..2bd6aa3ad 100644
--- a/arch/mips/kernel/irq-gt641xx.c
+++ b/arch/mips/kernel/irq-gt641xx.c
@@ -110,7 +110,7 @@ void gt641xx_irq_dispatch(void)
 		}
 	}
 
-	atomic_inc(&irq_err_count);
+	atomic_inc_unchecked(&irq_err_count);
 }
 
 void __init gt641xx_irq_init(void)
diff --git a/arch/mips/kernel/irq.c b/arch/mips/kernel/irq.c
index f25f7eab7..19e1c628b 100644
--- a/arch/mips/kernel/irq.c
+++ b/arch/mips/kernel/irq.c
@@ -34,17 +34,17 @@ void ack_bad_irq(unsigned int irq)
 	printk("unexpected IRQ # %d\n", irq);
 }
 
-atomic_t irq_err_count;
+atomic_unchecked_t irq_err_count;
 
 int arch_show_interrupts(struct seq_file *p, int prec)
 {
-	seq_printf(p, "%*s: %10u\n", prec, "ERR", atomic_read(&irq_err_count));
+	seq_printf(p, "%*s: %10u\n", prec, "ERR", atomic_read_unchecked(&irq_err_count));
 	return 0;
 }
 
 asmlinkage void spurious_interrupt(void)
 {
-	atomic_inc(&irq_err_count);
+	atomic_inc_unchecked(&irq_err_count);
 }
 
 void __init init_IRQ(void)
@@ -61,6 +61,8 @@ void __init init_IRQ(void)
 }
 
 #ifdef CONFIG_DEBUG_STACKOVERFLOW
+
+extern void gr_handle_kernel_exploit(void);
 static inline void check_stack_overflow(void)
 {
 	unsigned long sp;
@@ -76,6 +78,7 @@ static inline void check_stack_overflow(void)
 		printk("do_IRQ: stack overflow: %ld\n",
 		       sp - sizeof(struct thread_info));
 		dump_stack();
+		gr_handle_kernel_exploit();
 	}
 }
 #else
diff --git a/arch/mips/kernel/pm-cps.c b/arch/mips/kernel/pm-cps.c
index 5b31a9405..15ac4a10a 100644
--- a/arch/mips/kernel/pm-cps.c
+++ b/arch/mips/kernel/pm-cps.c
@@ -172,7 +172,7 @@ int cps_pm_enter_state(enum cps_pm_state state)
 	nc_core_ready_count = nc_addr;
 
 	/* Ensure ready_count is zero-initialised before the assembly runs */
-	ACCESS_ONCE(*nc_core_ready_count) = 0;
+	ACCESS_ONCE_RW(*nc_core_ready_count) = 0;
 	coupled_barrier(&per_cpu(pm_barrier, core), online);
 
 	/* Run the generated entry code */
diff --git a/arch/mips/kernel/process.c b/arch/mips/kernel/process.c
index d2d061520..46c1803cb 100644
--- a/arch/mips/kernel/process.c
+++ b/arch/mips/kernel/process.c
@@ -545,18 +545,6 @@ out:
 	return pc;
 }
 
-/*
- * Don't forget that the stack pointer must be aligned on a 8 bytes
- * boundary for 32-bits ABI and 16 bytes for 64-bits ABI.
- */
-unsigned long arch_align_stack(unsigned long sp)
-{
-	if (!(current->personality & ADDR_NO_RANDOMIZE) && randomize_va_space)
-		sp -= get_random_int() & ~PAGE_MASK;
-
-	return sp & ALMASK;
-}
-
 static void arch_dump_stack(void *info)
 {
 	struct pt_regs *regs;
diff --git a/arch/mips/kernel/ptrace.c b/arch/mips/kernel/ptrace.c
index 6103b24d1..8253315fb 100644
--- a/arch/mips/kernel/ptrace.c
+++ b/arch/mips/kernel/ptrace.c
@@ -882,6 +882,10 @@ long arch_ptrace(struct task_struct *child, long request,
 	return ret;
 }
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+extern void gr_delayed_cred_worker(void);
+#endif
+
 /*
  * Notification of system call entry/exit
  * - triggered by current->work.syscall_trace
@@ -899,6 +903,11 @@ asmlinkage long syscall_trace_enter(struct pt_regs *regs, long syscall)
 	if (secure_computing(NULL) == -1)
 		return -1;
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	if (unlikely(test_thread_flag(TIF_SYSCALL_TRACEPOINT)))
 		trace_sys_enter(regs, regs->regs[2]);
 
diff --git a/arch/mips/kernel/sync-r4k.c b/arch/mips/kernel/sync-r4k.c
index 4472a7f98..c5905e682 100644
--- a/arch/mips/kernel/sync-r4k.c
+++ b/arch/mips/kernel/sync-r4k.c
@@ -18,8 +18,8 @@
 #include <asm/mipsregs.h>
 
 static unsigned int initcount = 0;
-static atomic_t count_count_start = ATOMIC_INIT(0);
-static atomic_t count_count_stop = ATOMIC_INIT(0);
+static atomic_unchecked_t count_count_start = ATOMIC_INIT(0);
+static atomic_unchecked_t count_count_stop = ATOMIC_INIT(0);
 
 #define COUNTON 100
 #define NR_LOOPS 3
@@ -46,13 +46,13 @@ void synchronise_count_master(int cpu)
 
 	for (i = 0; i < NR_LOOPS; i++) {
 		/* slaves loop on '!= 2' */
-		while (atomic_read(&count_count_start) != 1)
+		while (atomic_read_unchecked(&count_count_start) != 1)
 			mb();
-		atomic_set(&count_count_stop, 0);
+		atomic_set_unchecked(&count_count_stop, 0);
 		smp_wmb();
 
 		/* Let the slave writes its count register */
-		atomic_inc(&count_count_start);
+		atomic_inc_unchecked(&count_count_start);
 
 		/* Count will be initialised to current timer */
 		if (i == 1)
@@ -67,11 +67,11 @@ void synchronise_count_master(int cpu)
 		/*
 		 * Wait for slave to leave the synchronization point:
 		 */
-		while (atomic_read(&count_count_stop) != 1)
+		while (atomic_read_unchecked(&count_count_stop) != 1)
 			mb();
-		atomic_set(&count_count_start, 0);
+		atomic_set_unchecked(&count_count_start, 0);
 		smp_wmb();
-		atomic_inc(&count_count_stop);
+		atomic_inc_unchecked(&count_count_stop);
 	}
 	/* Arrange for an interrupt in a short while */
 	write_c0_compare(read_c0_count() + COUNTON);
@@ -96,8 +96,8 @@ void synchronise_count_slave(int cpu)
 	 */
 
 	for (i = 0; i < NR_LOOPS; i++) {
-		atomic_inc(&count_count_start);
-		while (atomic_read(&count_count_start) != 2)
+		atomic_inc_unchecked(&count_count_start);
+		while (atomic_read_unchecked(&count_count_start) != 2)
 			mb();
 
 		/*
@@ -106,8 +106,8 @@ void synchronise_count_slave(int cpu)
 		if (i == NR_LOOPS-1)
 			write_c0_count(initcount);
 
-		atomic_inc(&count_count_stop);
-		while (atomic_read(&count_count_stop) != 2)
+		atomic_inc_unchecked(&count_count_stop);
+		while (atomic_read_unchecked(&count_count_stop) != 2)
 			mb();
 	}
 	/* Arrange for an interrupt in a short while */
diff --git a/arch/mips/kernel/traps.c b/arch/mips/kernel/traps.c
index 3de85be24..73560ecb2 100644
--- a/arch/mips/kernel/traps.c
+++ b/arch/mips/kernel/traps.c
@@ -695,7 +695,18 @@ asmlinkage void do_ov(struct pt_regs *regs)
 	};
 
 	prev_state = exception_enter();
-	die_if_kernel("Integer overflow", regs);
+	if (unlikely(!user_mode(regs))) {
+
+#ifdef CONFIG_PAX_REFCOUNT
+		if (fixup_exception(regs)) {
+			pax_report_refcount_error(regs, NULL);
+			exception_exit(prev_state);
+			return;
+		}
+#endif
+
+		die("Integer overflow", regs);
+	}
 
 	force_sig_info(SIGFPE, &info, current);
 	exception_exit(prev_state);
diff --git a/arch/mips/lib/ashldi3.c b/arch/mips/lib/ashldi3.c
index 927dc94a0..27269eea3 100644
--- a/arch/mips/lib/ashldi3.c
+++ b/arch/mips/lib/ashldi3.c
@@ -2,7 +2,11 @@
 
 #include "libgcc.h"
 
-long long notrace __ashldi3(long long u, word_type b)
+#ifdef CONFIG_64BIT
+DWtype notrace __ashlti3(DWtype u, word_type b)
+#else
+DWtype notrace __ashldi3(DWtype u, word_type b)
+#endif
 {
 	DWunion uu, w;
 	word_type bm;
@@ -11,19 +15,22 @@ long long notrace __ashldi3(long long u, word_type b)
 		return u;
 
 	uu.ll = u;
-	bm = 32 - b;
+	bm = BITS_PER_LONG - b;
 
 	if (bm <= 0) {
 		w.s.low = 0;
-		w.s.high = (unsigned int) uu.s.low << -bm;
+		w.s.high = (unsigned long) uu.s.low << -bm;
 	} else {
-		const unsigned int carries = (unsigned int) uu.s.low >> bm;
+		const unsigned long carries = (unsigned long) uu.s.low >> bm;
 
-		w.s.low = (unsigned int) uu.s.low << b;
-		w.s.high = ((unsigned int) uu.s.high << b) | carries;
+		w.s.low = (unsigned long) uu.s.low << b;
+		w.s.high = ((unsigned long) uu.s.high << b) | carries;
 	}
 
 	return w.ll;
 }
-
+#ifdef CONFIG_64BIT
+EXPORT_SYMBOL(__ashlti3);
+#else
 EXPORT_SYMBOL(__ashldi3);
+#endif
diff --git a/arch/mips/lib/ashrdi3.c b/arch/mips/lib/ashrdi3.c
index 9fdf1a598..6741f0ec2 100644
--- a/arch/mips/lib/ashrdi3.c
+++ b/arch/mips/lib/ashrdi3.c
@@ -2,7 +2,11 @@
 
 #include "libgcc.h"
 
-long long notrace __ashrdi3(long long u, word_type b)
+#ifdef CONFIG_64BIT
+DWtype notrace __ashrti3(DWtype u, word_type b)
+#else
+DWtype notrace __ashrdi3(DWtype u, word_type b)
+#endif
 {
 	DWunion uu, w;
 	word_type bm;
@@ -11,21 +15,24 @@ long long notrace __ashrdi3(long long u, word_type b)
 		return u;
 
 	uu.ll = u;
-	bm = 32 - b;
+	bm = BITS_PER_LONG - b;
 
 	if (bm <= 0) {
 		/* w.s.high = 1..1 or 0..0 */
 		w.s.high =
-		    uu.s.high >> 31;
+		    uu.s.high >> (BITS_PER_LONG - 1);
 		w.s.low = uu.s.high >> -bm;
 	} else {
-		const unsigned int carries = (unsigned int) uu.s.high << bm;
+		const unsigned long carries = (unsigned long) uu.s.high << bm;
 
 		w.s.high = uu.s.high >> b;
-		w.s.low = ((unsigned int) uu.s.low >> b) | carries;
+		w.s.low = ((unsigned long) uu.s.low >> b) | carries;
 	}
 
 	return w.ll;
 }
-
+#ifdef CONFIG_64BIT
+EXPORT_SYMBOL(__ashrti3);
+#else
 EXPORT_SYMBOL(__ashrdi3);
+#endif
diff --git a/arch/mips/lib/libgcc.h b/arch/mips/lib/libgcc.h
index 05909d58e..b03284bf8 100644
--- a/arch/mips/lib/libgcc.h
+++ b/arch/mips/lib/libgcc.h
@@ -5,13 +5,19 @@
 
 typedef int word_type __attribute__ ((mode (__word__)));
 
+#ifdef CONFIG_64BIT
+typedef int DWtype __attribute__((mode(TI)));
+#else
+typedef long long DWtype;
+#endif
+
 #ifdef __BIG_ENDIAN
 struct DWstruct {
-	int high, low;
+	long high, low;
 };
 #elif defined(__LITTLE_ENDIAN)
 struct DWstruct {
-	int low, high;
+	long low, high;
 };
 #else
 #error I feel sick.
@@ -19,7 +25,7 @@ struct DWstruct {
 
 typedef union {
 	struct DWstruct s;
-	long long ll;
+	DWtype ll;
 } DWunion;
 
 #endif /* __ASM_LIBGCC_H */
diff --git a/arch/mips/mm/fault.c b/arch/mips/mm/fault.c
index 9560ad731..da2754031 100644
--- a/arch/mips/mm/fault.c
+++ b/arch/mips/mm/fault.c
@@ -31,6 +31,23 @@
 
 int show_unhandled_signals = 1;
 
+#ifdef CONFIG_PAX_PAGEEXEC
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 5; i++) {
+		unsigned int c;
+		if (get_user(c, (unsigned int *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08x ", c);
+	}
+	printk("\n");
+}
+#endif
+
 /*
  * This routine handles page faults.  It determines the address,
  * and the problem, and then passes it off to one of the appropriate
@@ -205,6 +222,14 @@ bad_area:
 bad_area_nosemaphore:
 	/* User mode accesses just cause a SIGSEGV */
 	if (user_mode(regs)) {
+
+#ifdef CONFIG_PAX_PAGEEXEC
+		if (cpu_has_rixi && (mm->pax_flags & MF_PAX_PAGEEXEC) && !write && address == instruction_pointer(regs)) {
+			pax_report_fault(regs, (void *)address, (void *)user_stack_pointer(regs));
+			do_group_exit(SIGKILL);
+		}
+#endif
+
 		tsk->thread.cp0_badvaddr = address;
 		tsk->thread.error_code = write;
 		if (show_unhandled_signals &&
diff --git a/arch/mips/mm/init.c b/arch/mips/mm/init.c
index 72f7478ee..06abd2a1d 100644
--- a/arch/mips/mm/init.c
+++ b/arch/mips/mm/init.c
@@ -474,10 +474,10 @@ void __init mem_init(void)
 
 #ifdef CONFIG_64BIT
 	if ((unsigned long) &_text > (unsigned long) CKSEG0)
-		/* The -4 is a hack so that user tools don't have to handle
+		/* The -0x2000-4 is a hack so that user tools don't have to handle
 		   the overflow.  */
 		kclist_add(&kcore_kseg0, (void *) CKSEG0,
-				0x80000000 - 4, KCORE_TEXT);
+				0x80000000 - 0x2000 - 4, KCORE_TEXT);
 #endif
 }
 #endif /* !CONFIG_NEED_MULTIPLE_NODES */
diff --git a/arch/mips/mm/mmap.c b/arch/mips/mm/mmap.c
index 353037699..754dde3e3 100644
--- a/arch/mips/mm/mmap.c
+++ b/arch/mips/mm/mmap.c
@@ -59,6 +59,7 @@ static unsigned long arch_get_unmapped_area_common(struct file *filp,
 	struct vm_area_struct *vma;
 	unsigned long addr = addr0;
 	int do_color_align;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 	struct vm_unmapped_area_info info;
 
 	if (unlikely(len > TASK_SIZE))
@@ -84,6 +85,11 @@ static unsigned long arch_get_unmapped_area_common(struct file *filp,
 		do_color_align = 1;
 
 	/* requesting a specific address */
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(current->mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		if (do_color_align)
 			addr = COLOUR_ALIGN(addr, pgoff);
@@ -91,14 +97,14 @@ static unsigned long arch_get_unmapped_area_common(struct file *filp,
 			addr = PAGE_ALIGN(addr);
 
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
 	info.length = len;
 	info.align_mask = do_color_align ? (PAGE_MASK & shm_align_mask) : 0;
 	info.align_offset = pgoff << PAGE_SHIFT;
+	info.threadstack_offset = offset;
 
 	if (dir == DOWN) {
 		info.flags = VM_UNMAPPED_AREA_TOPDOWN;
@@ -160,14 +166,30 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 {
 	unsigned long random_factor = 0UL;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (current->flags & PF_RANDOMIZE)
 		random_factor = arch_mmap_rnd();
 
 	if (mmap_is_legacy()) {
 		mm->mmap_base = TASK_UNMAPPED_BASE + random_factor;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base += mm->delta_mmap;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area;
 	} else {
 		mm->mmap_base = mmap_base(random_factor);
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base -= mm->delta_mmap + mm->delta_stack;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area_topdown;
 	}
 }
diff --git a/arch/mips/sgi-ip27/ip27-nmi.c b/arch/mips/sgi-ip27/ip27-nmi.c
index cfceaea92..65deeb41e 100644
--- a/arch/mips/sgi-ip27/ip27-nmi.c
+++ b/arch/mips/sgi-ip27/ip27-nmi.c
@@ -187,9 +187,9 @@ void
 cont_nmi_dump(void)
 {
 #ifndef REAL_NMI_SIGNAL
-	static atomic_t nmied_cpus = ATOMIC_INIT(0);
+	static atomic_unchecked_t nmied_cpus = ATOMIC_INIT(0);
 
-	atomic_inc(&nmied_cpus);
+	atomic_inc_unchecked(&nmied_cpus);
 #endif
 	/*
 	 * Only allow 1 cpu to proceed
@@ -233,7 +233,7 @@ cont_nmi_dump(void)
 		udelay(10000);
 	}
 #else
-	while (atomic_read(&nmied_cpus) != num_online_cpus());
+	while (atomic_read_unchecked(&nmied_cpus) != num_online_cpus());
 #endif
 
 	/*
diff --git a/arch/mips/sni/rm200.c b/arch/mips/sni/rm200.c
index 160b88000..3b53fdc63 100644
--- a/arch/mips/sni/rm200.c
+++ b/arch/mips/sni/rm200.c
@@ -270,7 +270,7 @@ spurious_8259A_irq:
 			       "spurious RM200 8259A interrupt: IRQ%d.\n", irq);
 			spurious_irq_mask |= irqmask;
 		}
-		atomic_inc(&irq_err_count);
+		atomic_inc_unchecked(&irq_err_count);
 		/*
 		 * Theoretically we do not have to handle this IRQ,
 		 * but in Linux this does not cause problems and is
diff --git a/arch/mips/vr41xx/common/icu.c b/arch/mips/vr41xx/common/icu.c
index 41e873bc8..34d33a769 100644
--- a/arch/mips/vr41xx/common/icu.c
+++ b/arch/mips/vr41xx/common/icu.c
@@ -653,7 +653,7 @@ static int icu_get_irq(unsigned int irq)
 
 	printk(KERN_ERR "spurious ICU interrupt: %04x,%04x\n", pend1, pend2);
 
-	atomic_inc(&irq_err_count);
+	atomic_inc_unchecked(&irq_err_count);
 
 	return -1;
 }
diff --git a/arch/mips/vr41xx/common/irq.c b/arch/mips/vr41xx/common/irq.c
index ae0e4ee6c..e8f069236 100644
--- a/arch/mips/vr41xx/common/irq.c
+++ b/arch/mips/vr41xx/common/irq.c
@@ -64,7 +64,7 @@ static void irq_dispatch(unsigned int irq)
 	irq_cascade_t *cascade;
 
 	if (irq >= NR_IRQS) {
-		atomic_inc(&irq_err_count);
+		atomic_inc_unchecked(&irq_err_count);
 		return;
 	}
 
@@ -84,7 +84,7 @@ static void irq_dispatch(unsigned int irq)
 		ret = cascade->get_irq(irq);
 		irq = ret;
 		if (ret < 0)
-			atomic_inc(&irq_err_count);
+			atomic_inc_unchecked(&irq_err_count);
 		else
 			irq_dispatch(irq);
 		if (!irqd_irq_disabled(idata) && chip->irq_unmask)
diff --git a/arch/mn10300/proc-mn103e010/include/proc/cache.h b/arch/mn10300/proc-mn103e010/include/proc/cache.h
index 967d144f3..db12197e6 100644
--- a/arch/mn10300/proc-mn103e010/include/proc/cache.h
+++ b/arch/mn10300/proc-mn103e010/include/proc/cache.h
@@ -11,12 +11,14 @@
 #ifndef _ASM_PROC_CACHE_H
 #define _ASM_PROC_CACHE_H
 
+#include <linux/const.h>
+
 /* L1 cache */
 
 #define L1_CACHE_NWAYS		4	/* number of ways in caches */
 #define L1_CACHE_NENTRIES	256	/* number of entries in each way */
-#define L1_CACHE_BYTES		16	/* bytes per entry */
 #define L1_CACHE_SHIFT		4	/* shift for bytes per entry */
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)	/* bytes per entry */
 #define L1_CACHE_WAYDISP	0x1000	/* displacement of one way from the next */
 
 #define L1_CACHE_TAG_VALID	0x00000001	/* cache tag valid bit */
diff --git a/arch/mn10300/proc-mn2ws0050/include/proc/cache.h b/arch/mn10300/proc-mn2ws0050/include/proc/cache.h
index bcb5df2d8..84fabd26c 100644
--- a/arch/mn10300/proc-mn2ws0050/include/proc/cache.h
+++ b/arch/mn10300/proc-mn2ws0050/include/proc/cache.h
@@ -16,13 +16,15 @@
 #ifndef _ASM_PROC_CACHE_H
 #define _ASM_PROC_CACHE_H
 
+#include <linux/const.h>
+
 /*
  * L1 cache
  */
 #define L1_CACHE_NWAYS		4		/* number of ways in caches */
 #define L1_CACHE_NENTRIES	128		/* number of entries in each way */
-#define L1_CACHE_BYTES		32		/* bytes per entry */
 #define L1_CACHE_SHIFT		5		/* shift for bytes per entry */
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)	/* bytes per entry */
 #define L1_CACHE_WAYDISP	0x1000		/* distance from one way to the next */
 
 #define L1_CACHE_TAG_VALID	0x00000001	/* cache tag valid bit */
diff --git a/arch/openrisc/include/asm/cache.h b/arch/openrisc/include/asm/cache.h
index 4ce7a01a2..449202aa2 100644
--- a/arch/openrisc/include/asm/cache.h
+++ b/arch/openrisc/include/asm/cache.h
@@ -19,11 +19,13 @@
 #ifndef __ASM_OPENRISC_CACHE_H
 #define __ASM_OPENRISC_CACHE_H
 
+#include <linux/const.h>
+
 /* FIXME: How can we replace these with values from the CPU...
  * they shouldn't be hard-coded!
  */
 
-#define L1_CACHE_BYTES 16
 #define L1_CACHE_SHIFT 4
+#define L1_CACHE_BYTES (_AC(1,UL) << L1_CACHE_SHIFT)
 
 #endif /* __ASM_OPENRISC_CACHE_H */
diff --git a/arch/parisc/include/asm/atomic.h b/arch/parisc/include/asm/atomic.h
index 5394b9c5f..e77a306e4 100644
--- a/arch/parisc/include/asm/atomic.h
+++ b/arch/parisc/include/asm/atomic.h
@@ -327,6 +327,16 @@ static inline long atomic64_dec_if_positive(atomic64_t *v)
 	return dec;
 }
 
+#define atomic64_read_unchecked(v)		atomic64_read(v)
+#define atomic64_set_unchecked(v, i)		atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v)		atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v)	atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v)		atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v)		atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v)	atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v)		atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n)	atomic64_cmpxchg((v), (o), (n))
+
 #endif /* !CONFIG_64BIT */
 
 
diff --git a/arch/parisc/include/asm/cache.h b/arch/parisc/include/asm/cache.h
index df0f52bd1..810699b6d 100644
--- a/arch/parisc/include/asm/cache.h
+++ b/arch/parisc/include/asm/cache.h
@@ -5,6 +5,7 @@
 #ifndef __ARCH_PARISC_CACHE_H
 #define __ARCH_PARISC_CACHE_H
 
+#include <linux/const.h>
 
 /*
  * PA 2.0 processors have 64 and 128-byte L2 cachelines; PA 1.1 processors
@@ -14,6 +15,8 @@
 #define L1_CACHE_BYTES 16
 #define L1_CACHE_SHIFT 4
 
+#define L1_CACHE_BYTES (_AC(1,UL) << L1_CACHE_SHIFT)
+
 #ifndef __ASSEMBLY__
 
 #define SMP_CACHE_BYTES L1_CACHE_BYTES
diff --git a/arch/parisc/include/asm/elf.h b/arch/parisc/include/asm/elf.h
index 78c9fd32c..42fa66a33 100644
--- a/arch/parisc/include/asm/elf.h
+++ b/arch/parisc/include/asm/elf.h
@@ -342,6 +342,13 @@ struct pt_regs;	/* forward declaration... */
 
 #define ELF_ET_DYN_BASE         (TASK_UNMAPPED_BASE + 0x01000000)
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	0x10000UL
+
+#define PAX_DELTA_MMAP_LEN	16
+#define PAX_DELTA_STACK_LEN	16
+#endif
+
 /* This yields a mask that user programs can use to figure out what
    instruction set this CPU supports.  This could be done in user space,
    but it's not easy, and we've already done it here.  */
diff --git a/arch/parisc/include/asm/pgalloc.h b/arch/parisc/include/asm/pgalloc.h
index f08dda3f0..ea6aa1b4d 100644
--- a/arch/parisc/include/asm/pgalloc.h
+++ b/arch/parisc/include/asm/pgalloc.h
@@ -61,6 +61,11 @@ static inline void pgd_populate(struct mm_struct *mm, pgd_t *pgd, pmd_t *pmd)
 		        (__u32)(__pa((unsigned long)pmd) >> PxD_VALUE_SHIFT));
 }
 
+static inline void pgd_populate_kernel(struct mm_struct *mm, pgd_t *pgd, pmd_t *pmd)
+{
+	pgd_populate(mm, pgd, pmd);
+}
+
 static inline pmd_t *pmd_alloc_one(struct mm_struct *mm, unsigned long address)
 {
 	pmd_t *pmd = (pmd_t *)__get_free_pages(GFP_KERNEL, PMD_ORDER);
@@ -96,6 +101,7 @@ static inline void pmd_free(struct mm_struct *mm, pmd_t *pmd)
 #define pmd_alloc_one(mm, addr)		({ BUG(); ((pmd_t *)2); })
 #define pmd_free(mm, x)			do { } while (0)
 #define pgd_populate(mm, pmd, pte)	BUG()
+#define pgd_populate_kernel(mm, pmd, pte)	BUG()
 
 #endif
 
diff --git a/arch/parisc/include/asm/pgtable.h b/arch/parisc/include/asm/pgtable.h
index 3a4ed9f91..29b7218a9 100644
--- a/arch/parisc/include/asm/pgtable.h
+++ b/arch/parisc/include/asm/pgtable.h
@@ -236,6 +236,17 @@ static inline void purge_tlb_entries(struct mm_struct *mm, unsigned long addr)
 #define PAGE_EXECREAD   __pgprot(_PAGE_PRESENT | _PAGE_USER | _PAGE_READ | _PAGE_EXEC |_PAGE_ACCESSED)
 #define PAGE_COPY       PAGE_EXECREAD
 #define PAGE_RWX        __pgprot(_PAGE_PRESENT | _PAGE_USER | _PAGE_READ | _PAGE_WRITE | _PAGE_EXEC |_PAGE_ACCESSED)
+
+#ifdef CONFIG_PAX_PAGEEXEC
+# define PAGE_SHARED_NOEXEC	__pgprot(_PAGE_PRESENT | _PAGE_USER | _PAGE_READ | _PAGE_WRITE | _PAGE_ACCESSED)
+# define PAGE_COPY_NOEXEC	__pgprot(_PAGE_PRESENT | _PAGE_USER | _PAGE_READ | _PAGE_ACCESSED)
+# define PAGE_READONLY_NOEXEC	__pgprot(_PAGE_PRESENT | _PAGE_USER | _PAGE_READ | _PAGE_ACCESSED)
+#else
+# define PAGE_SHARED_NOEXEC	PAGE_SHARED
+# define PAGE_COPY_NOEXEC	PAGE_COPY
+# define PAGE_READONLY_NOEXEC	PAGE_READONLY
+#endif
+
 #define PAGE_KERNEL	__pgprot(_PAGE_KERNEL)
 #define PAGE_KERNEL_EXEC	__pgprot(_PAGE_KERNEL_EXEC)
 #define PAGE_KERNEL_RWX	__pgprot(_PAGE_KERNEL_RWX)
diff --git a/arch/parisc/include/asm/uaccess.h b/arch/parisc/include/asm/uaccess.h
index 482847865..89b1fbe79 100644
--- a/arch/parisc/include/asm/uaccess.h
+++ b/arch/parisc/include/asm/uaccess.h
@@ -221,17 +221,17 @@ static inline unsigned long __must_check copy_from_user(void *to,
                                           const void __user *from,
                                           unsigned long n)
 {
-        int sz = __compiletime_object_size(to);
+        size_t sz = __compiletime_object_size(to);
         unsigned long ret = n;
 
-        if (likely(sz == -1 || sz >= n))
+        if (likely(sz == (size_t)-1 || sz >= n))
                 ret = __copy_from_user(to, from, n);
         else if (!__builtin_constant_p(n))
 		copy_user_overflow(sz, n);
 	else
                 __bad_copy_user();
 
-	if (unlikely(ret))
+	if (unlikely(ret && (long)ret > 0))
 		memset(to + (n - ret), 0, ret);
         return ret;
 }
diff --git a/arch/parisc/kernel/module.c b/arch/parisc/kernel/module.c
index a0ecdb4ab..71d2069cc 100644
--- a/arch/parisc/kernel/module.c
+++ b/arch/parisc/kernel/module.c
@@ -100,14 +100,12 @@
  * or init pieces the location is */
 static inline int in_init(struct module *me, void *loc)
 {
-	return (loc >= me->init_layout.base &&
-		loc <= (me->init_layout.base + me->init_layout.size));
+	within_module_init((unsigned long)loc, me);
 }
 
 static inline int in_core(struct module *me, void *loc)
 {
-	return (loc >= me->core_layout.base &&
-		loc <= (me->core_layout.base + me->core_layout.size));
+	within_module_core((unsigned long)loc, me);
 }
 
 static inline int in_local(struct module *me, void *loc)
@@ -367,13 +365,13 @@ int module_frob_arch_sections(CONST Elf_Ehdr *hdr,
 	}
 
 	/* align things a bit */
-	me->core_layout.size = ALIGN(me->core_layout.size, 16);
-	me->arch.got_offset = me->core_layout.size;
-	me->core_layout.size += gots * sizeof(struct got_entry);
+	me->core_layout.size_rw = ALIGN(me->core_layout.size_rw, 16);
+	me->arch.got_offset = me->core_layout.size_rw;
+	me->core_layout.size_rw += gots * sizeof(struct got_entry);
 
-	me->core_layout.size = ALIGN(me->core_layout.size, 16);
-	me->arch.fdesc_offset = me->core_layout.size;
-	me->core_layout.size += fdescs * sizeof(Elf_Fdesc);
+	me->core_layout.size_rw = ALIGN(me->core_layout.size_rw, 16);
+	me->arch.fdesc_offset = me->core_layout.size_rw;
+	me->core_layout.size_rw += fdescs * sizeof(Elf_Fdesc);
 
 	me->arch.got_max = gots;
 	me->arch.fdesc_max = fdescs;
@@ -391,7 +389,7 @@ static Elf64_Word get_got(struct module *me, unsigned long value, long addend)
 
 	BUG_ON(value == 0);
 
-	got = me->core_layout.base + me->arch.got_offset;
+	got = me->core_layout.base_rw + me->arch.got_offset;
 	for (i = 0; got[i].addr; i++)
 		if (got[i].addr == value)
 			goto out;
@@ -409,7 +407,7 @@ static Elf64_Word get_got(struct module *me, unsigned long value, long addend)
 #ifdef CONFIG_64BIT
 static Elf_Addr get_fdesc(struct module *me, unsigned long value)
 {
-	Elf_Fdesc *fdesc = me->core_layout.base + me->arch.fdesc_offset;
+	Elf_Fdesc *fdesc = me->core_layout.base_rw + me->arch.fdesc_offset;
 
 	if (!value) {
 		printk(KERN_ERR "%s: zero OPD requested!\n", me->name);
@@ -427,7 +425,7 @@ static Elf_Addr get_fdesc(struct module *me, unsigned long value)
 
 	/* Create new one */
 	fdesc->addr = value;
-	fdesc->gp = (Elf_Addr)me->core_layout.base + me->arch.got_offset;
+	fdesc->gp = (Elf_Addr)me->core_layout.base_rw + me->arch.got_offset;
 	return (Elf_Addr)fdesc;
 }
 #endif /* CONFIG_64BIT */
@@ -847,7 +845,7 @@ register_unwind_table(struct module *me,
 
 	table = (unsigned char *)sechdrs[me->arch.unwind_section].sh_addr;
 	end = table + sechdrs[me->arch.unwind_section].sh_size;
-	gp = (Elf_Addr)me->core_layout.base + me->arch.got_offset;
+	gp = (Elf_Addr)me->core_layout.base_rw + me->arch.got_offset;
 
 	DEBUGP("register_unwind_table(), sect = %d at 0x%p - 0x%p (gp=0x%lx)\n",
 	       me->arch.unwind_section, table, end, gp);
diff --git a/arch/parisc/kernel/sys_parisc.c b/arch/parisc/kernel/sys_parisc.c
index 0a393a04e..5b3199e0e 100644
--- a/arch/parisc/kernel/sys_parisc.c
+++ b/arch/parisc/kernel/sys_parisc.c
@@ -92,6 +92,7 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	unsigned long task_size = TASK_SIZE;
 	int do_color_align, last_mmap;
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(current->mm, filp, flags);
 
 	if (len > task_size)
 		return -ENOMEM;
@@ -109,6 +110,10 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr,
 		goto found_addr;
 	}
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		if (do_color_align && last_mmap)
 			addr = COLOR_ALIGN(addr, last_mmap, pgoff);
@@ -127,6 +132,7 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	info.high_limit = mmap_upper_limit();
 	info.align_mask = last_mmap ? (PAGE_MASK & (SHM_COLOUR - 1)) : 0;
 	info.align_offset = shared_align_offset(last_mmap, pgoff);
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 found_addr:
@@ -146,6 +152,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	unsigned long addr = addr0;
 	int do_color_align, last_mmap;
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(current->mm, filp, flags);
 
 #ifdef CONFIG_64BIT
 	/* This should only ever run for 32-bit processes.  */
@@ -170,6 +177,10 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	}
 
 	/* requesting a specific address */
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		if (do_color_align && last_mmap)
 			addr = COLOR_ALIGN(addr, last_mmap, pgoff);
@@ -187,6 +198,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	info.high_limit = mm->mmap_base;
 	info.align_mask = last_mmap ? (PAGE_MASK & (SHM_COLOUR - 1)) : 0;
 	info.align_offset = shared_align_offset(last_mmap, pgoff);
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 	if (!(addr & ~PAGE_MASK))
 		goto found_addr;
@@ -252,6 +264,13 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 	mm->mmap_legacy_base = mmap_legacy_base();
 	mm->mmap_base = mmap_upper_limit();
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (mm->pax_flags & MF_PAX_RANDMMAP) {
+		mm->mmap_legacy_base += mm->delta_mmap;
+		mm->mmap_base -= mm->delta_mmap + mm->delta_stack;
+	}
+#endif
+
 	if (mmap_is_legacy()) {
 		mm->mmap_base = mm->mmap_legacy_base;
 		mm->get_unmapped_area = arch_get_unmapped_area;
diff --git a/arch/parisc/kernel/traps.c b/arch/parisc/kernel/traps.c
index 97d6b208e..2ab023296 100644
--- a/arch/parisc/kernel/traps.c
+++ b/arch/parisc/kernel/traps.c
@@ -719,9 +719,7 @@ void notrace handle_interruption(int code, struct pt_regs *regs)
 
 			down_read(&current->mm->mmap_sem);
 			vma = find_vma(current->mm,regs->iaoq[0]);
-			if (vma && (regs->iaoq[0] >= vma->vm_start)
-				&& (vma->vm_flags & VM_EXEC)) {
-
+			if (vma && (regs->iaoq[0] >= vma->vm_start)) {
 				fault_address = regs->iaoq[0];
 				fault_space = regs->iasq[0];
 
diff --git a/arch/parisc/mm/fault.c b/arch/parisc/mm/fault.c
index 163af2c31..ed77b14b8 100644
--- a/arch/parisc/mm/fault.c
+++ b/arch/parisc/mm/fault.c
@@ -16,6 +16,7 @@
 #include <linux/interrupt.h>
 #include <linux/module.h>
 #include <linux/uaccess.h>
+#include <linux/unistd.h>
 
 #include <asm/traps.h>
 
@@ -50,7 +51,7 @@ int show_unhandled_signals = 1;
 static unsigned long
 parisc_acctyp(unsigned long code, unsigned int inst)
 {
-	if (code == 6 || code == 16)
+	if (code == 6 || code == 7 || code == 16)
 	    return VM_EXEC;
 
 	switch (inst & 0xf0000000) {
@@ -136,6 +137,116 @@ parisc_acctyp(unsigned long code, unsigned int inst)
 			}
 #endif
 
+#ifdef CONFIG_PAX_PAGEEXEC
+/*
+ * PaX: decide what to do with offenders (instruction_pointer(regs) = fault address)
+ *
+ * returns 1 when task should be killed
+ *         2 when rt_sigreturn trampoline was detected
+ *         3 when unpatched PLT trampoline was detected
+ */
+static int pax_handle_fetch_fault(struct pt_regs *regs)
+{
+
+#ifdef CONFIG_PAX_EMUPLT
+	int err;
+
+	do { /* PaX: unpatched PLT emulation */
+		unsigned int bl, depwi;
+
+		err = get_user(bl, (unsigned int *)instruction_pointer(regs));
+		err |= get_user(depwi, (unsigned int *)(instruction_pointer(regs)+4));
+
+		if (err)
+			break;
+
+		if (bl == 0xEA9F1FDDU && depwi == 0xD6801C1EU) {
+			unsigned int ldw, bv, ldw2, addr = instruction_pointer(regs)-12;
+
+			err = get_user(ldw, (unsigned int *)addr);
+			err |= get_user(bv, (unsigned int *)(addr+4));
+			err |= get_user(ldw2, (unsigned int *)(addr+8));
+
+			if (err)
+				break;
+
+			if (ldw == 0x0E801096U &&
+			    bv == 0xEAC0C000U &&
+			    ldw2 == 0x0E881095U)
+			{
+				unsigned int resolver, map;
+
+				err = get_user(resolver, (unsigned int *)(instruction_pointer(regs)+8));
+				err |= get_user(map, (unsigned int *)(instruction_pointer(regs)+12));
+				if (err)
+					break;
+
+				regs->gr[20] = instruction_pointer(regs)+8;
+				regs->gr[21] = map;
+				regs->gr[22] = resolver;
+				regs->iaoq[0] = resolver | 3UL;
+				regs->iaoq[1] = regs->iaoq[0] + 4;
+				return 3;
+			}
+		}
+	} while (0);
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+
+#ifndef CONFIG_PAX_EMUSIGRT
+	if (!(current->mm->pax_flags & MF_PAX_EMUTRAMP))
+		return 1;
+#endif
+
+	do { /* PaX: rt_sigreturn emulation */
+		unsigned int ldi1, ldi2, bel, nop;
+
+		err = get_user(ldi1, (unsigned int *)instruction_pointer(regs));
+		err |= get_user(ldi2, (unsigned int *)(instruction_pointer(regs)+4));
+		err |= get_user(bel, (unsigned int *)(instruction_pointer(regs)+8));
+		err |= get_user(nop, (unsigned int *)(instruction_pointer(regs)+12));
+
+		if (err)
+			break;
+
+		if ((ldi1 == 0x34190000U || ldi1 == 0x34190002U) &&
+		    ldi2 == 0x3414015AU &&
+		    bel == 0xE4008200U &&
+		    nop == 0x08000240U)
+		{
+			regs->gr[25] = (ldi1 & 2) >> 1;
+			regs->gr[20] = __NR_rt_sigreturn;
+			regs->gr[31] = regs->iaoq[1] + 16;
+			regs->sr[0] = regs->iasq[1];
+			regs->iaoq[0] = 0x100UL;
+			regs->iaoq[1] = regs->iaoq[0] + 4;
+			regs->iasq[0] = regs->sr[2];
+			regs->iasq[1] = regs->sr[2];
+			return 2;
+		}
+	} while (0);
+#endif
+
+	return 1;
+}
+
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 5; i++) {
+		unsigned int c;
+		if (get_user(c, (unsigned int *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08x ", c);
+	}
+	printk("\n");
+}
+#endif
+
 int fixup_exception(struct pt_regs *regs)
 {
 	const struct exception_table_entry *fix;
@@ -230,8 +341,33 @@ retry:
 
 good_area:
 
-	if ((vma->vm_flags & acc_type) != acc_type)
+	if ((vma->vm_flags & acc_type) != acc_type) {
+
+#ifdef CONFIG_PAX_PAGEEXEC
+		if ((mm->pax_flags & MF_PAX_PAGEEXEC) && (acc_type & VM_EXEC) &&
+		    (address & ~3UL) == instruction_pointer(regs))
+		{
+			up_read(&mm->mmap_sem);
+			switch (pax_handle_fetch_fault(regs)) {
+
+#ifdef CONFIG_PAX_EMUPLT
+			case 3:
+				return;
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+			case 2:
+				return;
+#endif
+
+			}
+			pax_report_fault(regs, (void *)instruction_pointer(regs), (void *)regs->gr[30]);
+			do_group_exit(SIGKILL);
+		}
+#endif
+
 		goto bad_area;
+	}
 
 	/*
 	 * If for any reason at all we couldn't handle the fault, make
diff --git a/arch/powerpc/Kconfig b/arch/powerpc/Kconfig
index 792cb1768..1a96a2257 100644
--- a/arch/powerpc/Kconfig
+++ b/arch/powerpc/Kconfig
@@ -146,6 +146,7 @@ config PPC
 	select ARCH_USE_BUILTIN_BSWAP
 	select OLD_SIGSUSPEND
 	select OLD_SIGACTION if PPC32
+	select HAVE_GCC_PLUGINS
 	select HAVE_DEBUG_STACKOVERFLOW
 	select HAVE_IRQ_EXIT_ON_IRQ_STACK
 	select ARCH_USE_CMPXCHG_LOCKREF if PPC64
@@ -446,6 +447,7 @@ config KEXEC
 	bool "kexec system call"
 	depends on (PPC_BOOK3S || FSL_BOOKE || (44x && !SMP)) || PPC_BOOK3E
 	select KEXEC_CORE
+	depends on !GRKERNSEC_KMEM
 	help
 	  kexec is a system call that implements the ability to shutdown your
 	  current kernel, and to start another kernel.  It is like a reboot
diff --git a/arch/powerpc/include/asm/atomic.h b/arch/powerpc/include/asm/atomic.h
index f08d567e0..94e549719 100644
--- a/arch/powerpc/include/asm/atomic.h
+++ b/arch/powerpc/include/asm/atomic.h
@@ -12,6 +12,11 @@
 
 #define ATOMIC_INIT(i)		{ (i) }
 
+#define _ASM_EXTABLE(from, to)			\
+"	.section	__ex_table,\"a\"\n"	\
+	PPC_LONG"	" #from ", " #to"\n"	\
+"	.previous\n"
+
 /*
  * Since *_return_relaxed and {cmp}xchg_relaxed are implemented with
  * a "bne-" instruction at the end, so an isync is enough as a acquire barrier
@@ -39,38 +44,79 @@ static __inline__ int atomic_read(const atomic_t *v)
 	return t;
 }
 
+static __inline__ int atomic_read_unchecked(const atomic_unchecked_t *v)
+{
+	int t;
+
+	__asm__ __volatile__("lwz%U1%X1 %0,%1" : "=r"(t) : "m"(v->counter));
+
+	return t;
+}
+
 static __inline__ void atomic_set(atomic_t *v, int i)
 {
 	__asm__ __volatile__("stw%U0%X0 %1,%0" : "=m"(v->counter) : "r"(i));
 }
 
-#define ATOMIC_OP(op, asm_op)						\
-static __inline__ void atomic_##op(int a, atomic_t *v)			\
+static __inline__ void atomic_set_unchecked(atomic_unchecked_t *v, int i)
+{
+	__asm__ __volatile__("stw%U0%X0 %1,%0" : "=m"(v->counter) : "r"(i));
+}
+
+#ifdef CONFIG_PAX_REFCOUNT
+#define __REFCOUNT_OP(op) op##o.
+#define __OVERFLOW_PRE			\
+	"	mcrxr	cr0\n"
+#define __OVERFLOW_POST			\
+	"	bf 4*cr0+so, 3f\n"	\
+	"2:	.long 0x00c00b00\n"	\
+	"3:\n"
+#define __OVERFLOW_EXTABLE		\
+	"\n4:\n"			\
+	_ASM_EXTABLE(2b, 4b)
+#else
+#define __REFCOUNT_OP(op) op
+#define __OVERFLOW_PRE
+#define __OVERFLOW_POST
+#define __OVERFLOW_EXTABLE
+#endif
+
+#define __ATOMIC_OP(op, suffix, pre_op, asm_op, post_op, extable)	\
+static inline void atomic_##op##suffix(int a, atomic##suffix##_t *v)	\
 {									\
 	int t;								\
 									\
 	__asm__ __volatile__(						\
-"1:	lwarx	%0,0,%3		# atomic_" #op "\n"			\
+"1:	lwarx	%0,0,%3		# atomic_" #op #suffix "\n"		\
+	pre_op								\
 	#asm_op " %0,%2,%0\n"						\
+	post_op								\
 	PPC405_ERR77(0,%3)						\
 "	stwcx.	%0,0,%3 \n"						\
 "	bne-	1b\n"							\
+	extable								\
 	: "=&r" (t), "+m" (v->counter)					\
 	: "r" (a), "r" (&v->counter)					\
 	: "cc");							\
 }									\
 
-#define ATOMIC_OP_RETURN_RELAXED(op, asm_op)				\
-static inline int atomic_##op##_return_relaxed(int a, atomic_t *v)	\
+#define ATOMIC_OP(op, asm_op) __ATOMIC_OP(op, , , asm_op, , )		\
+			      __ATOMIC_OP(op, _unchecked, __OVERFLOW_PRE, __REFCOUNT_OP(asm_op), __OVERFLOW_POST, __OVERFLOW_EXTABLE)
+
+#define __ATOMIC_OP_RETURN(op, suffix, pre_op, asm_op, post_op, extable)\
+static inline int atomic_##op##_return##suffix##_relaxed(int a, atomic##suffix##_t *v)\
 {									\
 	int t;								\
 									\
 	__asm__ __volatile__(						\
-"1:	lwarx	%0,0,%3		# atomic_" #op "_return_relaxed\n"	\
+"1:	lwarx	%0,0,%2		# atomic_" #op "_return" #suffix "_relaxed\n"\
+	pre_op								\
 	#asm_op " %0,%2,%0\n"						\
+	post_op								\
 	PPC405_ERR77(0, %3)						\
 "	stwcx.	%0,0,%3\n"						\
 "	bne-	1b\n"							\
+	extable								\
 	: "=&r" (t), "+m" (v->counter)					\
 	: "r" (a), "r" (&v->counter)					\
 	: "cc");							\
@@ -78,6 +124,9 @@ static inline int atomic_##op##_return_relaxed(int a, atomic_t *v)	\
 	return t;							\
 }
 
+#define ATOMIC_OP_RETURN_RELAXED(op, asm_op) __ATOMIC_OP_RETURN(op, , , asm_op, , )\
+				     __ATOMIC_OP_RETURN(op, _unchecked, __OVERFLOW_PRE, __REFCOUNT_OP(asm_op), __OVERFLOW_POST, __OVERFLOW_EXTABLE)
+
 #define ATOMIC_FETCH_OP_RELAXED(op, asm_op)				\
 static inline int atomic_fetch_##op##_relaxed(int a, atomic_t *v)	\
 {									\
@@ -105,6 +154,7 @@ ATOMIC_OPS(add, add)
 ATOMIC_OPS(sub, subf)
 
 #define atomic_add_return_relaxed atomic_add_return_relaxed
+#define atomic_add_return_unchecked_relaxed atomic_add_return_unchecked_relaxed
 #define atomic_sub_return_relaxed atomic_sub_return_relaxed
 
 #define atomic_fetch_add_relaxed atomic_fetch_add_relaxed
@@ -126,41 +176,22 @@ ATOMIC_OPS(xor, xor)
 #undef ATOMIC_OPS
 #undef ATOMIC_FETCH_OP_RELAXED
 #undef ATOMIC_OP_RETURN_RELAXED
+#undef __ATOMIC_OP_RETURN
 #undef ATOMIC_OP
+#undef __ATOMIC_OP
 
 #define atomic_add_negative(a, v)	(atomic_add_return((a), (v)) < 0)
 
-static __inline__ void atomic_inc(atomic_t *v)
-{
-	int t;
-
-	__asm__ __volatile__(
-"1:	lwarx	%0,0,%2		# atomic_inc\n\
-	addic	%0,%0,1\n"
-	PPC405_ERR77(0,%2)
-"	stwcx.	%0,0,%2 \n\
-	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
-}
-
-static __inline__ int atomic_inc_return_relaxed(atomic_t *v)
-{
-	int t;
-
-	__asm__ __volatile__(
-"1:	lwarx	%0,0,%2		# atomic_inc_return_relaxed\n"
-"	addic	%0,%0,1\n"
-	PPC405_ERR77(0, %2)
-"	stwcx.	%0,0,%2\n"
-"	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
-
-	return t;
-}
+/*
+ * atomic_inc - increment atomic variable
+ * @v: pointer of type atomic_t
+ *
+ * Automatically increments @v by 1
+ */
+#define atomic_inc(v) atomic_add(1, (v))
+#define atomic_inc_unchecked(v) atomic_add_unchecked(1, (v))
+#define atomic_inc_return_relaxed(v) atomic_add_return_relaxed(1, (v))
+#define atomic_inc_return_unchecked_relaxed(v) atomic_add_return_unchecked_relaxed(1, (v))
 
 /*
  * atomic_inc_and_test - increment and test
@@ -171,37 +202,20 @@ static __inline__ int atomic_inc_return_relaxed(atomic_t *v)
  * other cases.
  */
 #define atomic_inc_and_test(v) (atomic_inc_return(v) == 0)
+#define atomic_inc_and_test_unchecked(v) (atomic_inc_return_unchecked(v) == 0)
 
-static __inline__ void atomic_dec(atomic_t *v)
-{
-	int t;
-
-	__asm__ __volatile__(
-"1:	lwarx	%0,0,%2		# atomic_dec\n\
-	addic	%0,%0,-1\n"
-	PPC405_ERR77(0,%2)\
-"	stwcx.	%0,0,%2\n\
-	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
-}
+/* 
+ * atomic_dec - decrement atomic variable
+ * @v: pointer of type atomic_t
+ * 
+ * Atomically decrements @v by 1
+ */
+#define atomic_dec(v) atomic_sub(1, (v))
+#define atomic_dec_return_relaxed(v) atomic_sub_return_relaxed(1, (v))
 
-static __inline__ int atomic_dec_return_relaxed(atomic_t *v)
+static __inline__ void atomic_dec_unchecked(atomic_unchecked_t *v)
 {
-	int t;
-
-	__asm__ __volatile__(
-"1:	lwarx	%0,0,%2		# atomic_dec_return_relaxed\n"
-"	addic	%0,%0,-1\n"
-	PPC405_ERR77(0, %2)
-"	stwcx.	%0,0,%2\n"
-"	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
-
-	return t;
+	atomic_sub_unchecked(1, v);
 }
 
 #define atomic_inc_return_relaxed atomic_inc_return_relaxed
@@ -216,6 +230,16 @@ static __inline__ int atomic_dec_return_relaxed(atomic_t *v)
 #define atomic_xchg(v, new) (xchg(&((v)->counter), new))
 #define atomic_xchg_relaxed(v, new) xchg_relaxed(&((v)->counter), (new))
 
+static inline int atomic_cmpxchg_unchecked(atomic_unchecked_t *v, int old, int new)
+{
+	return cmpxchg(&(v->counter), old, new);
+}
+
+static inline int atomic_xchg_unchecked(atomic_unchecked_t *v, int new) 
+{
+	return xchg(&(v->counter), new);
+}
+
 /**
  * __atomic_add_unless - add unless the number is a given value
  * @v: pointer of type atomic_t
@@ -233,14 +257,21 @@ static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
 	PPC_ATOMIC_ENTRY_BARRIER
 "1:	lwarx	%0,0,%1		# __atomic_add_unless\n\
 	cmpw	0,%0,%3 \n\
-	beq-	2f \n\
-	add	%0,%2,%0 \n"
+	beq-	5f \n"
+
+	__OVERFLOW_PRE
+	__REFCOUNT_OP(add) "	%0,%2,%0 \n"
+	__OVERFLOW_POST
+
 	PPC405_ERR77(0,%2)
 "	stwcx.	%0,0,%1 \n\
 	bne-	1b \n"
+
+	__OVERFLOW_EXTABLE
+
 	PPC_ATOMIC_EXIT_BARRIER
 "	subf	%0,%2,%0 \n\
-2:"
+5:"
 	: "=&r" (t)
 	: "r" (&v->counter), "r" (a), "r" (u)
 	: "cc", "memory");
@@ -323,37 +354,59 @@ static __inline__ long atomic64_read(const atomic64_t *v)
 	return t;
 }
 
+static __inline__ long atomic64_read_unchecked(const atomic64_unchecked_t *v)
+{
+	long t;
+
+	__asm__ __volatile__("ld%U1%X1 %0,%1" : "=r"(t) : "m"(v->counter));
+
+	return t;
+}
+
 static __inline__ void atomic64_set(atomic64_t *v, long i)
 {
 	__asm__ __volatile__("std%U0%X0 %1,%0" : "=m"(v->counter) : "r"(i));
 }
 
-#define ATOMIC64_OP(op, asm_op)						\
-static __inline__ void atomic64_##op(long a, atomic64_t *v)		\
+static __inline__ void atomic64_set_unchecked(atomic64_unchecked_t *v, long i)
+{
+	__asm__ __volatile__("std%U0%X0 %1,%0" : "=m"(v->counter) : "r"(i));
+}
+
+#define __ATOMIC64_OP(op, suffix, pre_op, asm_op, post_op, extable)	\
+static inline void atomic64_##op##suffix(long a, atomic64##suffix##_t *v)\
 {									\
 	long t;								\
 									\
 	__asm__ __volatile__(						\
 "1:	ldarx	%0,0,%3		# atomic64_" #op "\n"			\
+	pre_op								\
 	#asm_op " %0,%2,%0\n"						\
+	post_op								\
 "	stdcx.	%0,0,%3 \n"						\
 "	bne-	1b\n"							\
+	extable								\
 	: "=&r" (t), "+m" (v->counter)					\
 	: "r" (a), "r" (&v->counter)					\
 	: "cc");							\
 }
 
-#define ATOMIC64_OP_RETURN_RELAXED(op, asm_op)				\
-static inline long							\
-atomic64_##op##_return_relaxed(long a, atomic64_t *v)			\
+#define ATOMIC64_OP(op, asm_op) __ATOMIC64_OP(op, , , asm_op, , )		\
+				__ATOMIC64_OP(op, _unchecked, __OVERFLOW_PRE, __REFCOUNT_OP(asm_op), __OVERFLOW_POST, __OVERFLOW_EXTABLE)
+
+#define __ATOMIC64_OP_RETURN(op, suffix, pre_op, asm_op, post_op, extable)\
+static inline long atomic64_##op##_return##suffix##_relaxed(long a, atomic64##suffix##_t *v)\
 {									\
 	long t;								\
 									\
 	__asm__ __volatile__(						\
 "1:	ldarx	%0,0,%3		# atomic64_" #op "_return_relaxed\n"	\
+	pre_op								\
 	#asm_op " %0,%2,%0\n"						\
+	post_op								\
 "	stdcx.	%0,0,%3\n"						\
 "	bne-	1b\n"							\
+	extable								\
 	: "=&r" (t), "+m" (v->counter)					\
 	: "r" (a), "r" (&v->counter)					\
 	: "cc");							\
@@ -361,6 +414,9 @@ atomic64_##op##_return_relaxed(long a, atomic64_t *v)			\
 	return t;							\
 }
 
+#define ATOMIC64_OP_RETURN_RELAXED(op, asm_op) __ATOMIC64_OP_RETURN(op, , , asm_op, , )\
+				       __ATOMIC64_OP_RETURN(op, _unchecked, __OVERFLOW_PRE, __REFCOUNT_OP(asm_op), __OVERFLOW_POST, __OVERFLOW_EXTABLE)
+
 #define ATOMIC64_FETCH_OP_RELAXED(op, asm_op)				\
 static inline long							\
 atomic64_fetch_##op##_relaxed(long a, atomic64_t *v)			\
@@ -409,38 +465,33 @@ ATOMIC64_OPS(xor, xor)
 #undef ATOPIC64_OPS
 #undef ATOMIC64_FETCH_OP_RELAXED
 #undef ATOMIC64_OP_RETURN_RELAXED
+#undef __ATOMIC64_OP_RETURN
 #undef ATOMIC64_OP
+#undef __ATOMIC64_OP
+#undef __OVERFLOW_EXTABLE
+#undef __OVERFLOW_POST
+#undef __OVERFLOW_PRE
+#undef __REFCOUNT_OP
 
 #define atomic64_add_negative(a, v)	(atomic64_add_return((a), (v)) < 0)
 
-static __inline__ void atomic64_inc(atomic64_t *v)
-{
-	long t;
+/*
+ * atomic64_inc - increment atomic variable
+ * @v: pointer of type atomic64_t
+ *
+ * Automatically increments @v by 1
+ */
+#define atomic64_inc(v) atomic64_add(1, (v))
+#define atomic64_inc_return_relaxed(v) atomic64_add_return_relaxed(1, (v))
 
-	__asm__ __volatile__(
-"1:	ldarx	%0,0,%2		# atomic64_inc\n\
-	addic	%0,%0,1\n\
-	stdcx.	%0,0,%2 \n\
-	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
+static inline void atomic64_inc_unchecked(atomic64_unchecked_t *v)
+{
+	atomic64_add_unchecked(1, v);
 }
 
-static __inline__ long atomic64_inc_return_relaxed(atomic64_t *v)
+static inline long atomic64_inc_return_unchecked_relaxed(atomic64_unchecked_t *v)
 {
-	long t;
-
-	__asm__ __volatile__(
-"1:	ldarx	%0,0,%2		# atomic64_inc_return_relaxed\n"
-"	addic	%0,%0,1\n"
-"	stdcx.	%0,0,%2\n"
-"	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
-
-	return t;
+	return atomic64_add_return_unchecked_relaxed(1, v);
 }
 
 /*
@@ -453,34 +504,18 @@ static __inline__ long atomic64_inc_return_relaxed(atomic64_t *v)
  */
 #define atomic64_inc_and_test(v) (atomic64_inc_return(v) == 0)
 
-static __inline__ void atomic64_dec(atomic64_t *v)
-{
-	long t;
-
-	__asm__ __volatile__(
-"1:	ldarx	%0,0,%2		# atomic64_dec\n\
-	addic	%0,%0,-1\n\
-	stdcx.	%0,0,%2\n\
-	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
-}
+/* 
+ * atomic64_dec - decrement atomic variable
+ * @v: pointer of type atomic64_t
+ * 
+ * Atomically decrements @v by 1
+ */
+#define atomic64_dec(v) atomic64_sub(1, (v))
+#define atomic64_dec_return_relaxed(v) atomic64_sub_return_relaxed(1, (v))
 
-static __inline__ long atomic64_dec_return_relaxed(atomic64_t *v)
+static __inline__ void atomic64_dec_unchecked(atomic64_unchecked_t *v)
 {
-	long t;
-
-	__asm__ __volatile__(
-"1:	ldarx	%0,0,%2		# atomic64_dec_return_relaxed\n"
-"	addic	%0,%0,-1\n"
-"	stdcx.	%0,0,%2\n"
-"	bne-	1b"
-	: "=&r" (t), "+m" (v->counter)
-	: "r" (&v->counter)
-	: "cc", "xer");
-
-	return t;
+	atomic64_sub_unchecked(1, v);
 }
 
 #define atomic64_inc_return_relaxed atomic64_inc_return_relaxed
@@ -522,6 +557,16 @@ static __inline__ long atomic64_dec_if_positive(atomic64_t *v)
 #define atomic64_xchg(v, new) (xchg(&((v)->counter), new))
 #define atomic64_xchg_relaxed(v, new) xchg_relaxed(&((v)->counter), (new))
 
+static inline long atomic64_cmpxchg_unchecked(atomic64_unchecked_t *v, long old, long new)
+{
+	return cmpxchg(&(v->counter), old, new);
+}
+
+static inline long atomic64_xchg_unchecked(atomic64_unchecked_t *v, long new)
+{
+	return xchg(&(v->counter), new);
+}
+
 /**
  * atomic64_add_unless - add unless the number is a given value
  * @v: pointer of type atomic64_t
@@ -537,15 +582,22 @@ static __inline__ int atomic64_add_unless(atomic64_t *v, long a, long u)
 
 	__asm__ __volatile__ (
 	PPC_ATOMIC_ENTRY_BARRIER
-"1:	ldarx	%0,0,%1		# __atomic_add_unless\n\
+"1:	ldarx	%0,0,%1		# atomic64_add_unless\n\
 	cmpd	0,%0,%3 \n\
-	beq-	2f \n\
-	add	%0,%2,%0 \n"
+	beq-	5f \n"
+
+	__OVERFLOW_PRE
+	__REFCOUNT_OP(add) "	%0,%2,%0 \n"
+	__OVERFLOW_POST
+
 "	stdcx.	%0,0,%1 \n\
 	bne-	1b \n"
 	PPC_ATOMIC_EXIT_BARRIER
+
+	__OVERFLOW_EXTABLE
+
 "	subf	%0,%2,%0 \n\
-2:"
+5:"
 	: "=&r" (t)
 	: "r" (&v->counter), "r" (a), "r" (u)
 	: "cc", "memory");
diff --git a/arch/powerpc/include/asm/book3s/32/hash.h b/arch/powerpc/include/asm/book3s/32/hash.h
index 880db13a2..bb4ed4add 100644
--- a/arch/powerpc/include/asm/book3s/32/hash.h
+++ b/arch/powerpc/include/asm/book3s/32/hash.h
@@ -20,6 +20,7 @@
 #define _PAGE_HASHPTE	0x002	/* hash_page has made an HPTE for this pte */
 #define _PAGE_USER	0x004	/* usermode access allowed */
 #define _PAGE_GUARDED	0x008	/* G: prohibit speculative access */
+#define _PAGE_NX	_PAGE_GUARDED
 #define _PAGE_COHERENT	0x010	/* M: enforce memory coherence (SMP systems) */
 #define _PAGE_NO_CACHE	0x020	/* I: cache inhibit */
 #define _PAGE_WRITETHRU	0x040	/* W: cache write-through */
diff --git a/arch/powerpc/include/asm/book3s/32/pgtable.h b/arch/powerpc/include/asm/book3s/32/pgtable.h
index 38b33dcfc..945d1f13f 100644
--- a/arch/powerpc/include/asm/book3s/32/pgtable.h
+++ b/arch/powerpc/include/asm/book3s/32/pgtable.h
@@ -226,7 +226,7 @@ static inline void huge_ptep_set_wrprotect(struct mm_struct *mm,
 static inline void __ptep_set_access_flags(pte_t *ptep, pte_t entry)
 {
 	unsigned long set = pte_val(entry) &
-		(_PAGE_DIRTY | _PAGE_ACCESSED | _PAGE_RW | _PAGE_EXEC);
+		(_PAGE_DIRTY | _PAGE_ACCESSED | _PAGE_RW | _PAGE_EXEC | _PAGE_NX);
 	unsigned long clr = ~pte_val(entry) & _PAGE_RO;
 
 	pte_update(ptep, clr, set);
diff --git a/arch/powerpc/include/asm/book3s/64/pgalloc.h b/arch/powerpc/include/asm/book3s/64/pgalloc.h
index cd5e7aa8c..77090615a 100644
--- a/arch/powerpc/include/asm/book3s/64/pgalloc.h
+++ b/arch/powerpc/include/asm/book3s/64/pgalloc.h
@@ -91,6 +91,11 @@ static inline void pgd_populate(struct mm_struct *mm, pgd_t *pgd, pud_t *pud)
 	pgd_set(pgd, __pgtable_ptr_val(pud) | PGD_VAL_BITS);
 }
 
+static inline void pgd_populate_kernel(struct mm_struct *mm, pgd_t *pgd, pud_t *pud)
+{
+	pgd_populate(mm, pgd, pud);
+}
+
 static inline pud_t *pud_alloc_one(struct mm_struct *mm, unsigned long addr)
 {
 	return kmem_cache_alloc(PGT_CACHE(PUD_INDEX_SIZE), GFP_KERNEL);
@@ -106,6 +111,11 @@ static inline void pud_populate(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
 	pud_set(pud, __pgtable_ptr_val(pmd) | PUD_VAL_BITS);
 }
 
+static inline void pud_populate_kernel(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
+{
+	pud_populate_kernel(mm, pud, pmd);
+}
+
 static inline void __pud_free_tlb(struct mmu_gather *tlb, pud_t *pud,
                                   unsigned long address)
 {
diff --git a/arch/powerpc/include/asm/cache.h b/arch/powerpc/include/asm/cache.h
index ffbafbf76..71d037fb0 100644
--- a/arch/powerpc/include/asm/cache.h
+++ b/arch/powerpc/include/asm/cache.h
@@ -3,6 +3,8 @@
 
 #ifdef __KERNEL__
 
+#include <asm/reg.h>
+#include <linux/const.h>
 
 /* bytes per L1 cache line */
 #if defined(CONFIG_8xx) || defined(CONFIG_403GCX)
@@ -22,7 +24,7 @@
 #define L1_CACHE_SHIFT		7
 #endif
 
-#define	L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define	L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define	SMP_CACHE_BYTES		L1_CACHE_BYTES
 
diff --git a/arch/powerpc/include/asm/elf.h b/arch/powerpc/include/asm/elf.h
index ee46ffef6..b36c98cf5 100644
--- a/arch/powerpc/include/asm/elf.h
+++ b/arch/powerpc/include/asm/elf.h
@@ -30,6 +30,18 @@
 
 #define ELF_ET_DYN_BASE	0x20000000
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(0x10000000UL)
+
+#ifdef __powerpc64__
+#define PAX_DELTA_MMAP_LEN	(is_32bit_task() ? 16 : 28)
+#define PAX_DELTA_STACK_LEN	(is_32bit_task() ? 16 : 28)
+#else
+#define PAX_DELTA_MMAP_LEN	15
+#define PAX_DELTA_STACK_LEN	15
+#endif
+#endif
+
 #define ELF_CORE_EFLAGS (is_elf2_task() ? 2 : 0)
 
 /*
diff --git a/arch/powerpc/include/asm/exec.h b/arch/powerpc/include/asm/exec.h
index 8196e9c7d..d83a9f35f 100644
--- a/arch/powerpc/include/asm/exec.h
+++ b/arch/powerpc/include/asm/exec.h
@@ -4,6 +4,6 @@
 #ifndef _ASM_POWERPC_EXEC_H
 #define _ASM_POWERPC_EXEC_H
 
-extern unsigned long arch_align_stack(unsigned long sp);
+#define arch_align_stack(x) ((x) & ~0xfUL)
 
 #endif /* _ASM_POWERPC_EXEC_H */
diff --git a/arch/powerpc/include/asm/kmap_types.h b/arch/powerpc/include/asm/kmap_types.h
index 5acabbd7a..7ea14fa61 100644
--- a/arch/powerpc/include/asm/kmap_types.h
+++ b/arch/powerpc/include/asm/kmap_types.h
@@ -10,7 +10,7 @@
  * 2 of the License, or (at your option) any later version.
  */
 
-#define KM_TYPE_NR 16
+#define KM_TYPE_NR 17
 
 #endif	/* __KERNEL__ */
 #endif	/* _ASM_POWERPC_KMAP_TYPES_H */
diff --git a/arch/powerpc/include/asm/local.h b/arch/powerpc/include/asm/local.h
index b8da91363..c02b593cc 100644
--- a/arch/powerpc/include/asm/local.h
+++ b/arch/powerpc/include/asm/local.h
@@ -9,21 +9,65 @@ typedef struct
 	atomic_long_t a;
 } local_t;
 
+typedef struct
+{
+	atomic_long_unchecked_t a;
+} local_unchecked_t;
+
 #define LOCAL_INIT(i)	{ ATOMIC_LONG_INIT(i) }
 
 #define local_read(l)	atomic_long_read(&(l)->a)
+#define local_read_unchecked(l)	atomic_long_read_unchecked(&(l)->a)
 #define local_set(l,i)	atomic_long_set(&(l)->a, (i))
+#define local_set_unchecked(l,i)	atomic_long_set_unchecked(&(l)->a, (i))
 
 #define local_add(i,l)	atomic_long_add((i),(&(l)->a))
+#define local_add_unchecked(i,l)	atomic_long_add_unchecked((i),(&(l)->a))
 #define local_sub(i,l)	atomic_long_sub((i),(&(l)->a))
+#define local_sub_unchecked(i,l)	atomic_long_sub_unchecked((i),(&(l)->a))
 #define local_inc(l)	atomic_long_inc(&(l)->a)
+#define local_inc_unchecked(l)	atomic_long_inc_unchecked(&(l)->a)
 #define local_dec(l)	atomic_long_dec(&(l)->a)
+#define local_dec_unchecked(l)	atomic_long_dec_unchecked(&(l)->a)
 
 static __inline__ long local_add_return(long a, local_t *l)
 {
 	long t;
 
 	__asm__ __volatile__(
+"1:"	PPC_LLARX(%0,0,%2,0) "			# local_add_return\n"
+
+#ifdef CONFIG_PAX_REFCOUNT
+"	mcrxr   cr0\n"
+"	addo.	%0,%1,%0\n"
+"	bf 4*cr0+so, 3f\n"
+"2:.long " "0x00c00b00""\n"
+#else
+"	add	%0,%1,%0\n"
+#endif
+
+"3:\n"
+	PPC405_ERR77(0,%2)
+	PPC_STLCX	"%0,0,%2 \n\
+	bne-	1b"
+
+#ifdef CONFIG_PAX_REFCOUNT
+"\n4:\n"
+	_ASM_EXTABLE(2b, 4b)
+#endif
+
+	: "=&r" (t)
+	: "r" (a), "r" (&(l->a.counter))
+	: "cc", "memory");
+
+	return t;
+}
+
+static __inline__ long local_add_return_unchecked(long a, local_unchecked_t *l)
+{
+	long t;
+
+	__asm__ __volatile__(
 "1:"	PPC_LLARX(%0,0,%2,0) "			# local_add_return\n\
 	add	%0,%1,%0\n"
 	PPC405_ERR77(0,%2)
@@ -101,6 +145,8 @@ static __inline__ long local_dec_return(local_t *l)
 
 #define local_cmpxchg(l, o, n) \
 	(cmpxchg_local(&((l)->a.counter), (o), (n)))
+#define local_cmpxchg_unchecked(l, o, n) \
+	(cmpxchg_local(&((l)->a.counter), (o), (n)))
 #define local_xchg(l, n) (xchg_local(&((l)->a.counter), (n)))
 
 /**
diff --git a/arch/powerpc/include/asm/mman.h b/arch/powerpc/include/asm/mman.h
index 30922f699..0bb237c59 100644
--- a/arch/powerpc/include/asm/mman.h
+++ b/arch/powerpc/include/asm/mman.h
@@ -26,7 +26,7 @@ static inline unsigned long arch_calc_vm_prot_bits(unsigned long prot,
 }
 #define arch_calc_vm_prot_bits(prot, pkey) arch_calc_vm_prot_bits(prot, pkey)
 
-static inline pgprot_t arch_vm_get_page_prot(unsigned long vm_flags)
+static inline pgprot_t arch_vm_get_page_prot(vm_flags_t vm_flags)
 {
 	return (vm_flags & VM_SAO) ? __pgprot(_PAGE_SAO) : __pgprot(0);
 }
diff --git a/arch/powerpc/include/asm/nohash/64/pgalloc.h b/arch/powerpc/include/asm/nohash/64/pgalloc.h
index 897d2e1c8..399f34fda 100644
--- a/arch/powerpc/include/asm/nohash/64/pgalloc.h
+++ b/arch/powerpc/include/asm/nohash/64/pgalloc.h
@@ -54,6 +54,7 @@ static inline void pgd_free(struct mm_struct *mm, pgd_t *pgd)
 #ifndef CONFIG_PPC_64K_PAGES
 
 #define pgd_populate(MM, PGD, PUD)	pgd_set(PGD, (unsigned long)PUD)
+#define pgd_populate_kernel(MM, PGD, PUD)	pgd_populate((MM), (PGD), (PUD))
 
 static inline pud_t *pud_alloc_one(struct mm_struct *mm, unsigned long addr)
 {
@@ -70,6 +71,11 @@ static inline void pud_populate(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
 	pud_set(pud, (unsigned long)pmd);
 }
 
+static inline void pud_populate_kernel(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
+{
+	pud_populate(mm, pud, pmd);
+}
+
 static inline void pmd_populate_kernel(struct mm_struct *mm, pmd_t *pmd,
 				       pte_t *pte)
 {
@@ -139,6 +145,7 @@ extern void __tlb_remove_table(void *_table);
 #endif
 
 #define pud_populate(mm, pud, pmd)	pud_set(pud, (unsigned long)pmd)
+#define pud_populate_kernel(mm, pud, pmd)	pud_populate((mm), (pud), (pmd))
 
 static inline void pmd_populate_kernel(struct mm_struct *mm, pmd_t *pmd,
 				       pte_t *pte)
diff --git a/arch/powerpc/include/asm/page.h b/arch/powerpc/include/asm/page.h
index 56398e7e6..287a77203 100644
--- a/arch/powerpc/include/asm/page.h
+++ b/arch/powerpc/include/asm/page.h
@@ -230,8 +230,9 @@ extern long long virt_phys_offset;
  * and needs to be executable.  This means the whole heap ends
  * up being executable.
  */
-#define VM_DATA_DEFAULT_FLAGS32	(VM_READ | VM_WRITE | VM_EXEC | \
-				 VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)
+#define VM_DATA_DEFAULT_FLAGS32 \
+	(((current->personality & READ_IMPLIES_EXEC) ? VM_EXEC : 0) | \
+	 VM_READ | VM_WRITE | VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)
 
 #define VM_DATA_DEFAULT_FLAGS64	(VM_READ | VM_WRITE | \
 				 VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)
@@ -259,6 +260,9 @@ extern long long virt_phys_offset;
 #define is_kernel_addr(x)	((x) >= PAGE_OFFSET)
 #endif
 
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+
 #ifndef CONFIG_PPC_BOOK3S_64
 /*
  * Use the top bit of the higher-level page table entries to indicate whether
diff --git a/arch/powerpc/include/asm/page_64.h b/arch/powerpc/include/asm/page_64.h
index dd5f0712a..047071863 100644
--- a/arch/powerpc/include/asm/page_64.h
+++ b/arch/powerpc/include/asm/page_64.h
@@ -169,15 +169,18 @@ do {						\
  * stack by default, so in the absence of a PT_GNU_STACK program header
  * we turn execute permission off.
  */
-#define VM_STACK_DEFAULT_FLAGS32	(VM_READ | VM_WRITE | VM_EXEC | \
-					 VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)
+#define VM_STACK_DEFAULT_FLAGS32 \
+	(((current->personality & READ_IMPLIES_EXEC) ? VM_EXEC : 0) | \
+	 VM_READ | VM_WRITE | VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)
 
 #define VM_STACK_DEFAULT_FLAGS64	(VM_READ | VM_WRITE | \
 					 VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)
 
+#ifndef CONFIG_PAX_PAGEEXEC
 #define VM_STACK_DEFAULT_FLAGS \
 	(is_32bit_task() ? \
 	 VM_STACK_DEFAULT_FLAGS32 : VM_STACK_DEFAULT_FLAGS64)
+#endif
 
 #include <asm-generic/getorder.h>
 
diff --git a/arch/powerpc/include/asm/pgtable.h b/arch/powerpc/include/asm/pgtable.h
index 9bd87f269..f600e6d02 100644
--- a/arch/powerpc/include/asm/pgtable.h
+++ b/arch/powerpc/include/asm/pgtable.h
@@ -1,6 +1,7 @@
 #ifndef _ASM_POWERPC_PGTABLE_H
 #define _ASM_POWERPC_PGTABLE_H
 
+#include <linux/const.h>
 #ifndef __ASSEMBLY__
 #include <linux/mmdebug.h>
 #include <linux/mmzone.h>
diff --git a/arch/powerpc/include/asm/pte-common.h b/arch/powerpc/include/asm/pte-common.h
index 4ba26dd25..2d1137dcc 100644
--- a/arch/powerpc/include/asm/pte-common.h
+++ b/arch/powerpc/include/asm/pte-common.h
@@ -16,6 +16,9 @@
 #ifndef _PAGE_EXEC
 #define _PAGE_EXEC	0
 #endif
+#ifndef _PAGE_NX
+#define _PAGE_NX	0
+#endif
 #ifndef _PAGE_ENDIAN
 #define _PAGE_ENDIAN	0
 #endif
@@ -53,13 +56,13 @@
 #define PMD_PAGE_SIZE(pmd)	bad_call_to_PMD_PAGE_SIZE()
 #endif
 #ifndef _PAGE_KERNEL_RO
-#define _PAGE_KERNEL_RO		(_PAGE_RO)
+#define _PAGE_KERNEL_RO		(_PAGE_RO | _PAGE_NX)
 #endif
 #ifndef _PAGE_KERNEL_ROX
 #define _PAGE_KERNEL_ROX	(_PAGE_EXEC | _PAGE_RO)
 #endif
 #ifndef _PAGE_KERNEL_RW
-#define _PAGE_KERNEL_RW		(_PAGE_DIRTY | _PAGE_RW | _PAGE_HWWRITE)
+#define _PAGE_KERNEL_RW		(_PAGE_DIRTY | _PAGE_RW | _PAGE_HWWRITE | _PAGE_NX)
 #endif
 #ifndef _PAGE_KERNEL_RWX
 #define _PAGE_KERNEL_RWX	(_PAGE_DIRTY | _PAGE_RW | _PAGE_HWWRITE | _PAGE_EXEC)
@@ -142,15 +145,12 @@ static inline bool pte_user(pte_t pte)
  * Note due to the way vm flags are laid out, the bits are XWR
  */
 #define PAGE_NONE	__pgprot(_PAGE_BASE)
-#define PAGE_SHARED	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RW)
-#define PAGE_SHARED_X	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RW | \
-				 _PAGE_EXEC)
-#define PAGE_COPY	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO)
-#define PAGE_COPY_X	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO | \
-				 _PAGE_EXEC)
-#define PAGE_READONLY	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO)
-#define PAGE_READONLY_X	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO | \
-				 _PAGE_EXEC)
+#define PAGE_SHARED	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RW | _PAGE_NX)
+#define PAGE_SHARED_X	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RW | _PAGE_EXEC)
+#define PAGE_COPY	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO | _PAGE_NX)
+#define PAGE_COPY_X	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO | _PAGE_EXEC)
+#define PAGE_READONLY	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO | _PAGE_NX)
+#define PAGE_READONLY_X	__pgprot(_PAGE_BASE | _PAGE_USER | _PAGE_RO | _PAGE_EXEC)
 
 #define __P000	PAGE_NONE
 #define __P001	PAGE_READONLY
@@ -171,11 +171,9 @@ static inline bool pte_user(pte_t pte)
 #define __S111	PAGE_SHARED_X
 
 /* Permission masks used for kernel mappings */
-#define PAGE_KERNEL	__pgprot(_PAGE_BASE | _PAGE_KERNEL_RW)
-#define PAGE_KERNEL_NC	__pgprot(_PAGE_BASE_NC | _PAGE_KERNEL_RW | \
-				 _PAGE_NO_CACHE)
-#define PAGE_KERNEL_NCG	__pgprot(_PAGE_BASE_NC | _PAGE_KERNEL_RW | \
-				 _PAGE_NO_CACHE | _PAGE_GUARDED)
+#define PAGE_KERNEL	__pgprot(_PAGE_BASE | _PAGE_KERNEL_RW | _PAGE_NX)
+#define PAGE_KERNEL_NC	__pgprot(_PAGE_BASE_NC | _PAGE_KERNEL_RW | _PAGE_NO_CACHE)
+#define PAGE_KERNEL_NCG	__pgprot(_PAGE_BASE_NC | _PAGE_KERNEL_RW | _PAGE_NO_CACHE | _PAGE_GUARDED)
 #define PAGE_KERNEL_X	__pgprot(_PAGE_BASE | _PAGE_KERNEL_RWX)
 #define PAGE_KERNEL_RO	__pgprot(_PAGE_BASE | _PAGE_KERNEL_RO)
 #define PAGE_KERNEL_ROX	__pgprot(_PAGE_BASE | _PAGE_KERNEL_ROX)
diff --git a/arch/powerpc/include/asm/reg.h b/arch/powerpc/include/asm/reg.h
index 52cbf043e..c41eb7e31 100644
--- a/arch/powerpc/include/asm/reg.h
+++ b/arch/powerpc/include/asm/reg.h
@@ -270,6 +270,7 @@
 #define SPRN_DBCR	0x136	/* e300 Data Breakpoint Control Reg */
 #define SPRN_DSISR	0x012	/* Data Storage Interrupt Status Register */
 #define   DSISR_NOHPTE		0x40000000	/* no translation found */
+#define   DSISR_GUARDED		0x10000000	/* fetch from guarded storage */
 #define   DSISR_PROTFAULT	0x08000000	/* protection fault */
 #define   DSISR_ISSTORE		0x02000000	/* access was a store */
 #define   DSISR_DABRMATCH	0x00400000	/* hit data breakpoint */
diff --git a/arch/powerpc/include/asm/smp.h b/arch/powerpc/include/asm/smp.h
index 0d02c11dc..33a8f086e 100644
--- a/arch/powerpc/include/asm/smp.h
+++ b/arch/powerpc/include/asm/smp.h
@@ -51,7 +51,7 @@ struct smp_ops_t {
 	int   (*cpu_disable)(void);
 	void  (*cpu_die)(unsigned int nr);
 	int   (*cpu_bootable)(unsigned int nr);
-};
+} __no_const;
 
 extern void smp_send_debugger_break(void);
 extern void start_secondary_resume(void);
diff --git a/arch/powerpc/include/asm/spinlock.h b/arch/powerpc/include/asm/spinlock.h
index fa37fe93b..867d3cff6 100644
--- a/arch/powerpc/include/asm/spinlock.h
+++ b/arch/powerpc/include/asm/spinlock.h
@@ -27,6 +27,7 @@
 #include <asm/asm-compat.h>
 #include <asm/synch.h>
 #include <asm/ppc-opcode.h>
+#include <asm/atomic.h>
 
 #ifdef CONFIG_PPC64
 /* use 0x800000yy when locked, where yy == CPU number */
@@ -228,13 +229,29 @@ static inline long __arch_read_trylock(arch_rwlock_t *rw)
 	__asm__ __volatile__(
 "1:	" PPC_LWARX(%0,0,%1,1) "\n"
 	__DO_SIGN_EXTEND
-"	addic.		%0,%0,1\n\
-	ble-		2f\n"
+
+#ifdef	CONFIG_PAX_REFCOUNT
+"	mcrxr	cr0\n"
+"	addico.		%0,%0,1\n"
+"	bf 4*cr0+so, 3f\n"
+"2:.long " "0x00c00b00""\n"
+#else
+"	addic.		%0,%0,1\n"
+#endif
+
+"3:\n"
+	"ble-		4f\n"
 	PPC405_ERR77(0,%1)
 "	stwcx.		%0,0,%1\n\
 	bne-		1b\n"
 	PPC_ACQUIRE_BARRIER
-"2:"	: "=&r" (tmp)
+"4:"	
+
+#ifdef CONFIG_PAX_REFCOUNT
+	_ASM_EXTABLE(2b,4b)
+#endif
+
+	: "=&r" (tmp)
 	: "r" (&rw->lock)
 	: "cr0", "xer", "memory");
 
@@ -310,11 +327,27 @@ static inline void arch_read_unlock(arch_rwlock_t *rw)
 	__asm__ __volatile__(
 	"# read_unlock\n\t"
 	PPC_RELEASE_BARRIER
-"1:	lwarx		%0,0,%1\n\
-	addic		%0,%0,-1\n"
+"1:	lwarx		%0,0,%1\n"
+
+#ifdef CONFIG_PAX_REFCOUNT
+"	mcrxr 	cr0\n"
+"	addico.		%0,%0,-1\n"
+"	bf 4*cr0+so, 3f\n"
+"2:.long " "0x00c00b00""\n"
+#else
+"	addic.		%0,%0,-1\n"
+#endif
+
+"3:\n"
 	PPC405_ERR77(0,%1)
 "	stwcx.		%0,0,%1\n\
 	bne-		1b"
+
+#ifdef CONFIG_PAX_REFCOUNT
+"\n4:\n"
+	_ASM_EXTABLE(2b, 4b)
+#endif
+
 	: "=&r"(tmp)
 	: "r"(&rw->lock)
 	: "cr0", "xer", "memory");
diff --git a/arch/powerpc/include/asm/string.h b/arch/powerpc/include/asm/string.h
index da3cdffca..c774844ed 100644
--- a/arch/powerpc/include/asm/string.h
+++ b/arch/powerpc/include/asm/string.h
@@ -11,17 +11,17 @@
 #define __HAVE_ARCH_MEMCMP
 #define __HAVE_ARCH_MEMCHR
 
-extern char * strcpy(char *,const char *);
-extern char * strncpy(char *,const char *, __kernel_size_t);
-extern __kernel_size_t strlen(const char *);
-extern int strcmp(const char *,const char *);
-extern int strncmp(const char *, const char *, __kernel_size_t);
-extern char * strcat(char *, const char *);
+extern char * strcpy(char *,const char *) __nocapture(2);
+extern char * strncpy(char *,const char *, __kernel_size_t) __nocapture(2);
+extern __kernel_size_t strlen(const char *) __nocapture(1);
+extern int strcmp(const char *,const char *) __nocapture();
+extern int strncmp(const char *, const char *, __kernel_size_t) __nocapture(1, 2);
+extern char * strcat(char *, const char *) __nocapture(2);
 extern void * memset(void *,int,__kernel_size_t);
-extern void * memcpy(void *,const void *,__kernel_size_t);
-extern void * memmove(void *,const void *,__kernel_size_t);
-extern int memcmp(const void *,const void *,__kernel_size_t);
-extern void * memchr(const void *,int,__kernel_size_t);
+extern void * memcpy(void *,const void *,__kernel_size_t) __nocapture(2);
+extern void * memmove(void *,const void *,__kernel_size_t) __nocapture(2);
+extern int memcmp(const void *,const void *,__kernel_size_t) __nocapture(1, 2);
+extern void * memchr(const void *,int,__kernel_size_t) __nocapture(1);
 
 #endif /* __KERNEL__ */
 
diff --git a/arch/powerpc/include/asm/thread_info.h b/arch/powerpc/include/asm/thread_info.h
index 87e4b2d8d..c36239071 100644
--- a/arch/powerpc/include/asm/thread_info.h
+++ b/arch/powerpc/include/asm/thread_info.h
@@ -107,6 +107,8 @@ static inline struct thread_info *current_thread_info(void)
 #if defined(CONFIG_PPC64)
 #define TIF_ELF2ABI		18	/* function descriptors must die! */
 #endif
+/* mask must be expressable within 16 bits to satisfy 'andi' instruction reqs */
+#define TIF_GRSEC_SETXID	6	/* update credentials on syscall entry/exit */
 
 /* as above, but as bit values */
 #define _TIF_SYSCALL_TRACE	(1<<TIF_SYSCALL_TRACE)
@@ -125,9 +127,10 @@ static inline struct thread_info *current_thread_info(void)
 #define _TIF_SYSCALL_TRACEPOINT	(1<<TIF_SYSCALL_TRACEPOINT)
 #define _TIF_EMULATE_STACK_STORE	(1<<TIF_EMULATE_STACK_STORE)
 #define _TIF_NOHZ		(1<<TIF_NOHZ)
+#define _TIF_GRSEC_SETXID	(1<<TIF_GRSEC_SETXID)
 #define _TIF_SYSCALL_DOTRACE	(_TIF_SYSCALL_TRACE | _TIF_SYSCALL_AUDIT | \
 				 _TIF_SECCOMP | _TIF_SYSCALL_TRACEPOINT | \
-				 _TIF_NOHZ)
+				 _TIF_NOHZ | _TIF_GRSEC_SETXID)
 
 #define _TIF_USER_WORK_MASK	(_TIF_SIGPENDING | _TIF_NEED_RESCHED | \
 				 _TIF_NOTIFY_RESUME | _TIF_UPROBE | \
diff --git a/arch/powerpc/include/asm/uaccess.h b/arch/powerpc/include/asm/uaccess.h
index c266227fd..f3dc6bb28 100644
--- a/arch/powerpc/include/asm/uaccess.h
+++ b/arch/powerpc/include/asm/uaccess.h
@@ -58,6 +58,7 @@
 
 #endif
 
+#define access_ok_noprefault(type, addr, size) access_ok((type), (addr), (size))
 #define access_ok(type, addr, size)		\
 	(__chk_user_ptr(addr),			\
 	 __access_ok((__force unsigned long)(addr), (size), get_fs()))
@@ -303,43 +304,6 @@ do {								\
 extern unsigned long __copy_tofrom_user(void __user *to,
 		const void __user *from, unsigned long size);
 
-#ifndef __powerpc64__
-
-static inline unsigned long copy_from_user(void *to,
-		const void __user *from, unsigned long n)
-{
-	if (likely(access_ok(VERIFY_READ, from, n))) {
-		check_object_size(to, n, false);
-		return __copy_tofrom_user((__force void __user *)to, from, n);
-	}
-	memset(to, 0, n);
-	return n;
-}
-
-static inline unsigned long copy_to_user(void __user *to,
-		const void *from, unsigned long n)
-{
-	if (access_ok(VERIFY_WRITE, to, n)) {
-		check_object_size(from, n, true);
-		return __copy_tofrom_user(to, (__force void __user *)from, n);
-	}
-	return n;
-}
-
-#else /* __powerpc64__ */
-
-#define __copy_in_user(to, from, size) \
-	__copy_tofrom_user((to), (from), (size))
-
-extern unsigned long copy_from_user(void *to, const void __user *from,
-				    unsigned long n);
-extern unsigned long copy_to_user(void __user *to, const void *from,
-				  unsigned long n);
-extern unsigned long copy_in_user(void __user *to, const void __user *from,
-				  unsigned long n);
-
-#endif /* __powerpc64__ */
-
 static inline unsigned long __copy_from_user_inatomic(void *to,
 		const void __user *from, unsigned long n)
 {
@@ -412,6 +376,70 @@ static inline unsigned long __copy_to_user(void __user *to,
 	return __copy_to_user_inatomic(to, from, size);
 }
 
+#ifndef __powerpc64__
+
+static inline unsigned long __must_check copy_from_user(void *to,
+		const void __user *from, unsigned long n)
+{
+	if ((long)n < 0)
+		return n;
+
+	if (likely(access_ok(VERIFY_READ, from, n))) {
+		check_object_size(to, n, false);
+		return __copy_tofrom_user((void __force_user *)to, from, n);
+	}
+	memset(to, 0, n);
+	return n;
+}
+
+static inline unsigned long __must_check copy_to_user(void __user *to,
+		const void *from, unsigned long n)
+{
+	if ((long)n < 0)
+		return n;
+
+	if (likely(access_ok(VERIFY_WRITE, to, n))) {
+		check_object_size(from, n, true);
+		return __copy_tofrom_user(to, (void __force_user *)from, n);
+	}
+	return n;
+}
+
+#else /* __powerpc64__ */
+
+#define __copy_in_user(to, from, size) \
+	__copy_tofrom_user((to), (from), (size))
+
+static inline unsigned long __must_check copy_from_user(void *to, const void __user *from, unsigned long n)
+{
+	if ((long)n < 0 || n > INT_MAX)
+		return n;
+
+	if (likely(access_ok(VERIFY_READ, from, n))) {
+		check_object_size(to, n, false);
+		n = __copy_from_user(to, from, n);
+	} else
+		memset(to, 0, n);
+	return n;
+}
+
+static inline unsigned long __must_check copy_to_user(void __user *to, const void *from, unsigned long n)
+{
+	if ((long)n < 0 || n > INT_MAX)
+		return n;
+
+	if (likely(access_ok(VERIFY_WRITE, to, n))) {
+		check_object_size(from, n, true);
+		n = __copy_to_user(to, from, n);
+	}
+	return n;
+}
+
+extern unsigned long copy_in_user(void __user *to, const void __user *from,
+				  unsigned long n);
+
+#endif /* __powerpc64__ */
+
 extern unsigned long __clear_user(void __user *addr, unsigned long size);
 
 static inline unsigned long clear_user(void __user *addr, unsigned long size)
diff --git a/arch/powerpc/kernel/Makefile b/arch/powerpc/kernel/Makefile
index fe4c075bc..fcb460088 100644
--- a/arch/powerpc/kernel/Makefile
+++ b/arch/powerpc/kernel/Makefile
@@ -14,6 +14,11 @@ CFLAGS_prom_init.o      += -fPIC
 CFLAGS_btext.o		+= -fPIC
 endif
 
+CFLAGS_cputable.o += $(DISABLE_LATENT_ENTROPY_PLUGIN)
+CFLAGS_prom_init.o += $(DISABLE_LATENT_ENTROPY_PLUGIN)
+CFLAGS_btext.o += $(DISABLE_LATENT_ENTROPY_PLUGIN)
+CFLAGS_prom.o += $(DISABLE_LATENT_ENTROPY_PLUGIN)
+
 ifdef CONFIG_FUNCTION_TRACER
 # Do not trace early boot code
 CFLAGS_REMOVE_cputable.o = -mno-sched-epilog $(CC_FLAGS_FTRACE)
@@ -26,6 +31,8 @@ CFLAGS_REMOVE_ftrace.o = -mno-sched-epilog $(CC_FLAGS_FTRACE)
 CFLAGS_REMOVE_time.o = -mno-sched-epilog $(CC_FLAGS_FTRACE)
 endif
 
+CFLAGS_REMOVE_prom_init.o += $(LATENT_ENTROPY_PLUGIN_CFLAGS)
+
 obj-y				:= cputable.o ptrace.o syscalls.o \
 				   irq.o align.o signal_32.o pmc.o vdso.o \
 				   process.o systbl.o idle.o \
diff --git a/arch/powerpc/kernel/exceptions-64e.S b/arch/powerpc/kernel/exceptions-64e.S
index 38a1f9643..ed94e428d 100644
--- a/arch/powerpc/kernel/exceptions-64e.S
+++ b/arch/powerpc/kernel/exceptions-64e.S
@@ -1010,6 +1010,7 @@ storage_fault_common:
 	std	r14,_DAR(r1)
 	std	r15,_DSISR(r1)
 	addi	r3,r1,STACK_FRAME_OVERHEAD
+	bl	save_nvgprs
 	mr	r4,r14
 	mr	r5,r15
 	ld	r14,PACA_EXGEN+EX_R14(r13)
@@ -1018,8 +1019,7 @@ storage_fault_common:
 	cmpdi	r3,0
 	bne-	1f
 	b	ret_from_except_lite
-1:	bl	save_nvgprs
-	mr	r5,r3
+1:	mr	r5,r3
 	addi	r3,r1,STACK_FRAME_OVERHEAD
 	ld	r4,_DAR(r1)
 	bl	bad_page_fault
diff --git a/arch/powerpc/kernel/exceptions-64s.S b/arch/powerpc/kernel/exceptions-64s.S
index bffec73db..9cc5a35f5 100644
--- a/arch/powerpc/kernel/exceptions-64s.S
+++ b/arch/powerpc/kernel/exceptions-64s.S
@@ -1520,10 +1520,10 @@ handle_page_fault:
 11:	ld	r4,_DAR(r1)
 	ld	r5,_DSISR(r1)
 	addi	r3,r1,STACK_FRAME_OVERHEAD
+	bl	save_nvgprs
 	bl	do_page_fault
 	cmpdi	r3,0
 	beq+	12f
-	bl	save_nvgprs
 	mr	r5,r3
 	addi	r3,r1,STACK_FRAME_OVERHEAD
 	lwz	r4,_DAR(r1)
diff --git a/arch/powerpc/kernel/irq.c b/arch/powerpc/kernel/irq.c
index 08887cf2b..0c98725aa 100644
--- a/arch/powerpc/kernel/irq.c
+++ b/arch/powerpc/kernel/irq.c
@@ -477,6 +477,8 @@ void migrate_irqs(void)
 }
 #endif
 
+extern void gr_handle_kernel_exploit(void);
+
 static inline void check_stack_overflow(void)
 {
 #ifdef CONFIG_DEBUG_STACKOVERFLOW
@@ -489,6 +491,7 @@ static inline void check_stack_overflow(void)
 		pr_err("do_IRQ: stack overflow: %ld\n",
 			sp - sizeof(struct thread_info));
 		dump_stack();
+		gr_handle_kernel_exploit();
 	}
 #endif
 }
diff --git a/arch/powerpc/kernel/module_32.c b/arch/powerpc/kernel/module_32.c
index 5a7a78f12..c0e4207d1 100644
--- a/arch/powerpc/kernel/module_32.c
+++ b/arch/powerpc/kernel/module_32.c
@@ -158,7 +158,7 @@ int module_frob_arch_sections(Elf32_Ehdr *hdr,
 			me->arch.core_plt_section = i;
 	}
 	if (!me->arch.core_plt_section || !me->arch.init_plt_section) {
-		pr_err("Module doesn't contain .plt or .init.plt sections.\n");
+		pr_err("Module $s doesn't contain .plt or .init.plt sections.\n", me->name);
 		return -ENOEXEC;
 	}
 
@@ -188,11 +188,16 @@ static uint32_t do_plt_call(void *location,
 
 	pr_debug("Doing plt for call to 0x%x at 0x%x\n", val, (unsigned int)location);
 	/* Init, or core PLT? */
-	if (location >= mod->core_layout.base
-	    && location < mod->core_layout.base + mod->core_layout.size)
+	if ((location >= mod->core_layout.base_rx && location < mod->core_layout.base_rx + mod->core_layout.size_rx) ||
+	    (location >= mod->core_layout.base_rw && location < mod->core_layout.base_rw + mod->core_layout.size_rw))
 		entry = (void *)sechdrs[mod->arch.core_plt_section].sh_addr;
-	else
+	else if ((location >= mod->init_layout.base_rx && location < mod->init_layout.base_rx + mod->init_layout.size_rx) ||
+		 (location >= mod->init_layout.base_rw && location < mod->init_layout.base_rw + mod->init_layout.size_rw))
 		entry = (void *)sechdrs[mod->arch.init_plt_section].sh_addr;
+	else {
+		printk(KERN_ERR "%s: invalid R_PPC_REL24 entry found\n", mod->name);
+		return ~0UL;
+	}
 
 	/* Find this entry, or if that fails, the next avail. entry */
 	while (entry->jump[0]) {
@@ -301,7 +306,7 @@ int apply_relocate_add(Elf32_Shdr *sechdrs,
 #ifdef CONFIG_DYNAMIC_FTRACE
 int module_finalize_ftrace(struct module *module, const Elf_Shdr *sechdrs)
 {
-	module->arch.tramp = do_plt_call(module->core_layout.base,
+	module->arch.tramp = do_plt_call(module->core_layout.base_rx,
 					 (unsigned long)ftrace_caller,
 					 sechdrs, module);
 	if (!module->arch.tramp)
diff --git a/arch/powerpc/kernel/process.c b/arch/powerpc/kernel/process.c
index ad37aa175..51da6c4b5 100644
--- a/arch/powerpc/kernel/process.c
+++ b/arch/powerpc/kernel/process.c
@@ -1360,8 +1360,8 @@ void show_regs(struct pt_regs * regs)
 	 * Lookup NIP late so we have the best change of getting the
 	 * above info out without failing
 	 */
-	printk("NIP ["REG"] %pS\n", regs->nip, (void *)regs->nip);
-	printk("LR ["REG"] %pS\n", regs->link, (void *)regs->link);
+	printk("NIP ["REG"] %pA\n", regs->nip, (void *)regs->nip);
+	printk("LR ["REG"] %pA\n", regs->link, (void *)regs->link);
 #endif
 	show_stack(current, (unsigned long *) regs->gpr[1]);
 	if (!user_mode(regs))
@@ -1882,10 +1882,10 @@ void show_stack(struct task_struct *tsk, unsigned long *stack)
 		newsp = stack[0];
 		ip = stack[STACK_FRAME_LR_SAVE];
 		if (!firstframe || ip != lr) {
-			printk("["REG"] ["REG"] %pS", sp, ip, (void *)ip);
+			printk("["REG"] ["REG"] %pA", sp, ip, (void *)ip);
 #ifdef CONFIG_FUNCTION_GRAPH_TRACER
 			if ((ip == rth) && curr_frame >= 0) {
-				printk(" (%pS)",
+				printk(" (%pA)",
 				       (void *)current->ret_stack[curr_frame].ret);
 				curr_frame--;
 			}
@@ -1905,7 +1905,7 @@ void show_stack(struct task_struct *tsk, unsigned long *stack)
 			struct pt_regs *regs = (struct pt_regs *)
 				(sp + STACK_FRAME_OVERHEAD);
 			lr = regs->link;
-			printk("--- interrupt: %lx at %pS\n    LR = %pS\n",
+			printk("--- interrupt: %lx at %pA\n    LR = %pA\n",
 			       regs->trap, (void *)regs->nip, (void *)lr);
 			firstframe = 1;
 		}
@@ -1942,13 +1942,6 @@ void notrace __ppc64_runlatch_off(void)
 }
 #endif /* CONFIG_PPC64 */
 
-unsigned long arch_align_stack(unsigned long sp)
-{
-	if (!(current->personality & ADDR_NO_RANDOMIZE) && randomize_va_space)
-		sp -= get_random_int() & ~PAGE_MASK;
-	return sp & ~0xf;
-}
-
 static inline unsigned long brk_rnd(void)
 {
         unsigned long rnd = 0;
diff --git a/arch/powerpc/kernel/ptrace.c b/arch/powerpc/kernel/ptrace.c
index bf91658a8..edd21f8a5 100644
--- a/arch/powerpc/kernel/ptrace.c
+++ b/arch/powerpc/kernel/ptrace.c
@@ -3312,6 +3312,10 @@ static int do_seccomp(struct pt_regs *regs)
 static inline int do_seccomp(struct pt_regs *regs) { return 0; }
 #endif /* CONFIG_SECCOMP */
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+extern void gr_delayed_cred_worker(void);
+#endif
+
 /**
  * do_syscall_trace_enter() - Do syscall tracing on kernel entry.
  * @regs: the pt_regs of the task to trace (current)
@@ -3335,6 +3339,11 @@ long do_syscall_trace_enter(struct pt_regs *regs)
 {
 	user_exit();
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	/*
 	 * The tracer may decide to abort the syscall, if so tracehook
 	 * will return !0. Note that the tracer may also just change
@@ -3353,6 +3362,7 @@ long do_syscall_trace_enter(struct pt_regs *regs)
 	if (regs->gpr[0] >= NR_syscalls)
 		goto skip;
 
+
 	if (unlikely(test_thread_flag(TIF_SYSCALL_TRACEPOINT)))
 		trace_sys_enter(regs, regs->gpr[0]);
 
@@ -3384,6 +3394,11 @@ void do_syscall_trace_leave(struct pt_regs *regs)
 {
 	int step;
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	audit_syscall_exit(regs);
 
 	if (unlikely(test_thread_flag(TIF_SYSCALL_TRACEPOINT)))
diff --git a/arch/powerpc/kernel/signal_32.c b/arch/powerpc/kernel/signal_32.c
index a7daf749b..d8159e51a 100644
--- a/arch/powerpc/kernel/signal_32.c
+++ b/arch/powerpc/kernel/signal_32.c
@@ -1000,7 +1000,7 @@ int handle_rt_signal32(struct ksignal *ksig, sigset_t *oldset,
 	/* Save user registers on the stack */
 	frame = &rt_sf->uc.uc_mcontext;
 	addr = frame;
-	if (vdso32_rt_sigtramp && current->mm->context.vdso_base) {
+	if (vdso32_rt_sigtramp && current->mm->context.vdso_base != ~0UL) {
 		sigret = 0;
 		tramp = current->mm->context.vdso_base + vdso32_rt_sigtramp;
 	} else {
diff --git a/arch/powerpc/kernel/signal_64.c b/arch/powerpc/kernel/signal_64.c
index 70409bb90..6cc6990ab 100644
--- a/arch/powerpc/kernel/signal_64.c
+++ b/arch/powerpc/kernel/signal_64.c
@@ -770,7 +770,7 @@ int handle_rt_signal64(struct ksignal *ksig, sigset_t *set, struct pt_regs *regs
 	current->thread.fp_state.fpscr = 0;
 
 	/* Set up to return from userspace. */
-	if (vdso64_rt_sigtramp && current->mm->context.vdso_base) {
+	if (vdso64_rt_sigtramp && current->mm->context.vdso_base != ~0UL) {
 		regs->link = current->mm->context.vdso_base + vdso64_rt_sigtramp;
 	} else {
 		err |= setup_trampoline(__NR_rt_sigreturn, &frame->tramp[0]);
diff --git a/arch/powerpc/kernel/traps.c b/arch/powerpc/kernel/traps.c
index 62859ebe0..035955dc7 100644
--- a/arch/powerpc/kernel/traps.c
+++ b/arch/powerpc/kernel/traps.c
@@ -37,6 +37,7 @@
 #include <linux/debugfs.h>
 #include <linux/ratelimit.h>
 #include <linux/context_tracking.h>
+#include <linux/uaccess.h>
 
 #include <asm/emulated_ops.h>
 #include <asm/pgtable.h>
@@ -145,6 +146,8 @@ static unsigned __kprobes long oops_begin(struct pt_regs *regs)
 	return flags;
 }
 
+extern void gr_handle_kernel_exploit(void);
+
 static void __kprobes oops_end(unsigned long flags, struct pt_regs *regs,
 			       int signr)
 {
@@ -194,6 +197,9 @@ static void __kprobes oops_end(unsigned long flags, struct pt_regs *regs,
 		panic("Fatal exception in interrupt");
 	if (panic_on_oops)
 		panic("Fatal exception");
+
+	gr_handle_kernel_exploit();
+
 	do_exit(signr);
 }
 
@@ -1145,6 +1151,26 @@ void __kprobes program_check_exception(struct pt_regs *regs)
 	enum ctx_state prev_state = exception_enter();
 	unsigned int reason = get_reason(regs);
 
+#ifdef CONFIG_PAX_REFCOUNT
+	unsigned int bkpt;
+	const struct exception_table_entry *entry;
+
+	if (reason & REASON_ILLEGAL) {
+		/* Check if PaX bad instruction */
+		if (!probe_kernel_address((const void *)regs->nip, bkpt) && bkpt == 0xc00b00) {
+			current->thread.trap_nr = 0;
+			pax_report_refcount_error(regs, NULL);
+			/* fixup_exception() for PowerPC does not exist, simulate its job */
+			if ((entry = search_exception_tables(regs->nip)) != NULL) {
+				regs->nip = entry->fixup;
+				return;
+			}
+			/* fixup_exception() could not handle */
+			goto bail;
+		}
+	}
+#endif
+
 	/* We can now get here via a FP Unavailable exception if the core
 	 * has no FPU, in that case the reason flags will be 0 */
 
diff --git a/arch/powerpc/kernel/vdso.c b/arch/powerpc/kernel/vdso.c
index 4111d30ba..fa5e7be35 100644
--- a/arch/powerpc/kernel/vdso.c
+++ b/arch/powerpc/kernel/vdso.c
@@ -35,6 +35,7 @@
 #include <asm/vdso.h>
 #include <asm/vdso_datapage.h>
 #include <asm/setup.h>
+#include <asm/mman.h>
 
 #undef DEBUG
 
@@ -180,7 +181,7 @@ int arch_setup_additional_pages(struct linux_binprm *bprm, int uses_interp)
 	vdso_base = VDSO32_MBASE;
 #endif
 
-	current->mm->context.vdso_base = 0;
+	current->mm->context.vdso_base = ~0UL;
 
 	/* vDSO has a problem and was disabled, just don't "enable" it for the
 	 * process
@@ -201,7 +202,7 @@ int arch_setup_additional_pages(struct linux_binprm *bprm, int uses_interp)
 	vdso_base = get_unmapped_area(NULL, vdso_base,
 				      (vdso_pages << PAGE_SHIFT) +
 				      ((VDSO_ALIGNMENT - 1) & PAGE_MASK),
-				      0, 0);
+				      0, MAP_PRIVATE | MAP_EXECUTABLE);
 	if (IS_ERR_VALUE(vdso_base)) {
 		rc = vdso_base;
 		goto fail_mmapsem;
diff --git a/arch/powerpc/lib/usercopy_64.c b/arch/powerpc/lib/usercopy_64.c
index 5eea6f3c1..5d1039679 100644
--- a/arch/powerpc/lib/usercopy_64.c
+++ b/arch/powerpc/lib/usercopy_64.c
@@ -9,22 +9,6 @@
 #include <linux/module.h>
 #include <asm/uaccess.h>
 
-unsigned long copy_from_user(void *to, const void __user *from, unsigned long n)
-{
-	if (likely(access_ok(VERIFY_READ, from, n)))
-		n = __copy_from_user(to, from, n);
-	else
-		memset(to, 0, n);
-	return n;
-}
-
-unsigned long copy_to_user(void __user *to, const void *from, unsigned long n)
-{
-	if (likely(access_ok(VERIFY_WRITE, to, n)))
-		n = __copy_to_user(to, from, n);
-	return n;
-}
-
 unsigned long copy_in_user(void __user *to, const void __user *from,
 			   unsigned long n)
 {
@@ -35,7 +19,5 @@ unsigned long copy_in_user(void __user *to, const void __user *from,
 	return n;
 }
 
-EXPORT_SYMBOL(copy_from_user);
-EXPORT_SYMBOL(copy_to_user);
 EXPORT_SYMBOL(copy_in_user);
 
diff --git a/arch/powerpc/mm/fault.c b/arch/powerpc/mm/fault.c
index bb1ffc559..9ae5cb60e 100644
--- a/arch/powerpc/mm/fault.c
+++ b/arch/powerpc/mm/fault.c
@@ -34,6 +34,10 @@
 #include <linux/context_tracking.h>
 #include <linux/hugetlb.h>
 #include <linux/uaccess.h>
+#include <linux/slab.h>
+#include <linux/pagemap.h>
+#include <linux/compiler.h>
+#include <linux/unistd.h>
 
 #include <asm/firmware.h>
 #include <asm/page.h>
@@ -68,6 +72,33 @@ static inline int notify_page_fault(struct pt_regs *regs)
 }
 #endif
 
+#ifdef CONFIG_PAX_PAGEEXEC
+/*
+ * PaX: decide what to do with offenders (regs->nip = fault address)
+ *
+ * returns 1 when task should be killed
+ */
+static int pax_handle_fetch_fault(struct pt_regs *regs)
+{
+	return 1;
+}
+
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 5; i++) {
+		unsigned int c;
+		if (get_user(c, (unsigned int __user *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08x ", c);
+	}
+	printk("\n");
+}
+#endif
+
 /*
  * Check whether the instruction at regs->nip is a store using
  * an update addressing form which will update r1.
@@ -227,7 +258,7 @@ int __kprobes do_page_fault(struct pt_regs *regs, unsigned long address,
 	 * indicate errors in DSISR but can validly be set in SRR1.
 	 */
 	if (trap == 0x400)
-		error_code &= 0x48200000;
+		error_code &= 0x58200000;
 	else
 		is_write = error_code & DSISR_ISSTORE;
 #else
@@ -384,12 +415,16 @@ good_area:
          * "undefined".  Of those that can be set, this is the only
          * one which seems bad.
          */
-	if (error_code & 0x10000000)
+	if (error_code & DSISR_GUARDED)
                 /* Guarded storage error. */
 		goto bad_area;
 #endif /* CONFIG_8xx */
 
 	if (is_exec) {
+#ifdef CONFIG_PPC_STD_MMU
+		if (error_code & DSISR_GUARDED)
+			goto bad_area;
+#endif
 		/*
 		 * Allow execution from readable areas if the MMU does not
 		 * provide separate controls over reading and executing.
@@ -484,6 +519,23 @@ bad_area:
 bad_area_nosemaphore:
 	/* User mode accesses cause a SIGSEGV */
 	if (user_mode(regs)) {
+
+#ifdef CONFIG_PAX_PAGEEXEC
+		if (mm->pax_flags & MF_PAX_PAGEEXEC) {
+#ifdef CONFIG_PPC_STD_MMU
+			if (is_exec && (error_code & (DSISR_PROTFAULT | DSISR_GUARDED))) {
+#else
+			if (is_exec && regs->nip == address) {
+#endif
+				switch (pax_handle_fetch_fault(regs)) {
+				}
+
+				pax_report_fault(regs, (void *)regs->nip, (void *)regs->gpr[PT_R1]);
+				do_group_exit(SIGKILL);
+			}
+		}
+#endif
+
 		_exception(SIGSEGV, regs, code, address);
 		goto bail;
 	}
diff --git a/arch/powerpc/mm/mmap.c b/arch/powerpc/mm/mmap.c
index 2f1e44362..de888bf31 100644
--- a/arch/powerpc/mm/mmap.c
+++ b/arch/powerpc/mm/mmap.c
@@ -194,6 +194,10 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 {
 	unsigned long random_factor = 0UL;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (current->flags & PF_RANDOMIZE)
 		random_factor = arch_mmap_rnd();
 
@@ -205,9 +209,21 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 	 */
 	if (mmap_is_legacy()) {
 		mm->mmap_base = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base += mm->delta_mmap;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area;
 	} else {
 		mm->mmap_base = mmap_base(random_factor);
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base -= mm->delta_mmap + mm->delta_stack;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area_topdown;
 	}
 }
diff --git a/arch/powerpc/mm/slice.c b/arch/powerpc/mm/slice.c
index 2b2745890..7c7c59b1b 100644
--- a/arch/powerpc/mm/slice.c
+++ b/arch/powerpc/mm/slice.c
@@ -105,7 +105,7 @@ static int slice_area_is_free(struct mm_struct *mm, unsigned long addr,
 	if ((mm->task_size - len) < addr)
 		return 0;
 	vma = find_vma(mm, addr);
-	return (!vma || (addr + len) <= vma->vm_start);
+	return check_heap_stack_gap(vma, addr, len, 0);
 }
 
 static int slice_low_has_vma(struct mm_struct *mm, unsigned long slice)
@@ -276,6 +276,12 @@ static unsigned long slice_find_area_bottomup(struct mm_struct *mm,
 	info.align_offset = 0;
 
 	addr = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (mm->pax_flags & MF_PAX_RANDMMAP)
+		addr += mm->delta_mmap;
+#endif
+
 	while (addr < TASK_SIZE) {
 		info.low_limit = addr;
 		if (!slice_scan_available(addr, available, 1, &addr))
@@ -410,6 +416,11 @@ unsigned long slice_get_unmapped_area(unsigned long addr, unsigned long len,
 	if (fixed && addr > (mm->task_size - len))
 		return -ENOMEM;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!fixed && (mm->pax_flags & MF_PAX_RANDMMAP))
+		addr = 0;
+#endif
+
 	/* If hint, make sure it matches our alignment restrictions */
 	if (!fixed && addr) {
 		addr = _ALIGN_UP(addr, 1ul << pshift);
@@ -555,10 +566,10 @@ unsigned long arch_get_unmapped_area(struct file *filp,
 }
 
 unsigned long arch_get_unmapped_area_topdown(struct file *filp,
-					     const unsigned long addr0,
-					     const unsigned long len,
-					     const unsigned long pgoff,
-					     const unsigned long flags)
+					     unsigned long addr0,
+					     unsigned long len,
+					     unsigned long pgoff,
+					     unsigned long flags)
 {
 	return slice_get_unmapped_area(addr0, len, flags,
 				       current->mm->context.user_psize, 1);
diff --git a/arch/powerpc/platforms/cell/spufs/file.c b/arch/powerpc/platforms/cell/spufs/file.c
index 06254467e..139a0aa77 100644
--- a/arch/powerpc/platforms/cell/spufs/file.c
+++ b/arch/powerpc/platforms/cell/spufs/file.c
@@ -263,9 +263,9 @@ spufs_mem_mmap_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
 	return VM_FAULT_NOPAGE;
 }
 
-static int spufs_mem_mmap_access(struct vm_area_struct *vma,
+static ssize_t spufs_mem_mmap_access(struct vm_area_struct *vma,
 				unsigned long address,
-				void *buf, int len, int write)
+				void *buf, size_t len, int write)
 {
 	struct spu_context *ctx = vma->vm_file->private_data;
 	unsigned long offset = address - vma->vm_start;
diff --git a/arch/s390/Kconfig.debug b/arch/s390/Kconfig.debug
index 26c5d5beb..a308c28f4 100644
--- a/arch/s390/Kconfig.debug
+++ b/arch/s390/Kconfig.debug
@@ -9,6 +9,7 @@ config S390_PTDUMP
 	bool "Export kernel pagetable layout to userspace via debugfs"
 	depends on DEBUG_KERNEL
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	---help---
 	  Say Y here if you want to show the kernel pagetable layout in a
 	  debugfs file. This information is only useful for kernel developers
diff --git a/arch/s390/include/asm/atomic.h b/arch/s390/include/asm/atomic.h
index d28cc2f5b..a93731242 100644
--- a/arch/s390/include/asm/atomic.h
+++ b/arch/s390/include/asm/atomic.h
@@ -342,4 +342,14 @@ static inline long long atomic64_dec_if_positive(atomic64_t *v)
 #define atomic64_dec_and_test(_v)	(atomic64_sub_return(1, _v) == 0)
 #define atomic64_inc_not_zero(v)	atomic64_add_unless((v), 1, 0)
 
+#define atomic64_read_unchecked(v)		atomic64_read(v)
+#define atomic64_set_unchecked(v, i)		atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v)		atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v)	atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v)		atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v)		atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v)	atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v)		atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n)	atomic64_cmpxchg((v), (o), (n))
+
 #endif /* __ARCH_S390_ATOMIC__  */
diff --git a/arch/s390/include/asm/cache.h b/arch/s390/include/asm/cache.h
index 05219a5e0..032f5f046 100644
--- a/arch/s390/include/asm/cache.h
+++ b/arch/s390/include/asm/cache.h
@@ -9,8 +9,10 @@
 #ifndef __ARCH_S390_CACHE_H
 #define __ARCH_S390_CACHE_H
 
-#define L1_CACHE_BYTES     256
+#include <linux/const.h>
+
 #define L1_CACHE_SHIFT     8
+#define L1_CACHE_BYTES     (_AC(1,UL) << L1_CACHE_SHIFT)
 #define NET_SKB_PAD	   32
 
 #define __read_mostly __section(.data..read_mostly)
diff --git a/arch/s390/include/asm/elf.h b/arch/s390/include/asm/elf.h
index 1736c7d3c..261351cfd 100644
--- a/arch/s390/include/asm/elf.h
+++ b/arch/s390/include/asm/elf.h
@@ -167,6 +167,13 @@ extern unsigned int vdso_enabled;
 				(STACK_TOP / 3 * 2) : \
 				(STACK_TOP / 3 * 2) & ~((1UL << 32) - 1))
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(test_thread_flag(TIF_31BIT) ? 0x10000UL : 0x80000000UL)
+
+#define PAX_DELTA_MMAP_LEN	(test_thread_flag(TIF_31BIT) ? 15 : 26)
+#define PAX_DELTA_STACK_LEN	(test_thread_flag(TIF_31BIT) ? 15 : 26)
+#endif
+
 /* This yields a mask that user programs can use to figure out what
    instruction set this CPU supports. */
 
diff --git a/arch/s390/include/asm/exec.h b/arch/s390/include/asm/exec.h
index c4a93d632..4d2a9b416 100644
--- a/arch/s390/include/asm/exec.h
+++ b/arch/s390/include/asm/exec.h
@@ -7,6 +7,6 @@
 #ifndef __ASM_EXEC_H
 #define __ASM_EXEC_H
 
-extern unsigned long arch_align_stack(unsigned long sp);
+#define arch_align_stack(x) ((x) & ~0xfUL)
 
 #endif /* __ASM_EXEC_H */
diff --git a/arch/s390/include/asm/uaccess.h b/arch/s390/include/asm/uaccess.h
index 52d7c8709..577d292e6 100644
--- a/arch/s390/include/asm/uaccess.h
+++ b/arch/s390/include/asm/uaccess.h
@@ -59,6 +59,7 @@ static inline int __range_ok(unsigned long addr, unsigned long size)
 	__range_ok((unsigned long)(addr), (size));	\
 })
 
+#define access_ok_noprefault(type, addr, size) access_ok((type), (addr), (size))
 #define access_ok(type, addr, size) __access_ok(addr, size)
 
 /*
@@ -337,6 +338,10 @@ static inline unsigned long __must_check
 copy_to_user(void __user *to, const void *from, unsigned long n)
 {
 	might_fault();
+
+	if ((long)n < 0)
+		return n;
+
 	return __copy_to_user(to, from, n);
 }
 
@@ -360,10 +365,14 @@ copy_to_user(void __user *to, const void *from, unsigned long n)
 static inline unsigned long __must_check
 copy_from_user(void *to, const void __user *from, unsigned long n)
 {
-	unsigned int sz = __compiletime_object_size(to);
+	size_t sz = __compiletime_object_size(to);
 
 	might_fault();
-	if (unlikely(sz != -1 && sz < n)) {
+
+	if ((long)n < 0)
+		return n;
+
+	if (unlikely(sz != (size_t)-1 && sz < n)) {
 		if (!__builtin_constant_p(n))
 			copy_user_overflow(sz, n);
 		else
diff --git a/arch/s390/kernel/module.c b/arch/s390/kernel/module.c
index fbc07891f..e7962a199 100644
--- a/arch/s390/kernel/module.c
+++ b/arch/s390/kernel/module.c
@@ -163,11 +163,11 @@ int module_frob_arch_sections(Elf_Ehdr *hdr, Elf_Shdr *sechdrs,
 
 	/* Increase core size by size of got & plt and set start
 	   offsets for got and plt. */
-	me->core_layout.size = ALIGN(me->core_layout.size, 4);
-	me->arch.got_offset = me->core_layout.size;
-	me->core_layout.size += me->arch.got_size;
-	me->arch.plt_offset = me->core_layout.size;
-	me->core_layout.size += me->arch.plt_size;
+	me->core_layout.size_rw = ALIGN(me->core_layout.size_rw, 4);
+	me->arch.got_offset = me->core_layout.size_rw;
+	me->core_layout.size_rw += me->arch.got_size;
+	me->arch.plt_offset = me->core_layout.size_rx;
+	me->core_layout.size_rx += me->arch.plt_size;
 	return 0;
 }
 
@@ -283,7 +283,7 @@ static int apply_rela(Elf_Rela *rela, Elf_Addr base, Elf_Sym *symtab,
 		if (info->got_initialized == 0) {
 			Elf_Addr *gotent;
 
-			gotent = me->core_layout.base + me->arch.got_offset +
+			gotent = me->core_layout.base_rw + me->arch.got_offset +
 				info->got_offset;
 			*gotent = val;
 			info->got_initialized = 1;
@@ -306,7 +306,7 @@ static int apply_rela(Elf_Rela *rela, Elf_Addr base, Elf_Sym *symtab,
 			rc = apply_rela_bits(loc, val, 0, 64, 0);
 		else if (r_type == R_390_GOTENT ||
 			 r_type == R_390_GOTPLTENT) {
-			val += (Elf_Addr) me->core_layout.base - loc;
+			val += (Elf_Addr) me->core_layout.base_rw - loc;
 			rc = apply_rela_bits(loc, val, 1, 32, 1);
 		}
 		break;
@@ -319,7 +319,7 @@ static int apply_rela(Elf_Rela *rela, Elf_Addr base, Elf_Sym *symtab,
 	case R_390_PLTOFF64:	/* 16 bit offset from GOT to PLT. */
 		if (info->plt_initialized == 0) {
 			unsigned int *ip;
-			ip = me->core_layout.base + me->arch.plt_offset +
+			ip = me->core_layout.base_rx + me->arch.plt_offset +
 				info->plt_offset;
 			ip[0] = 0x0d10e310; /* basr 1,0; lg 1,10(1); br 1 */
 			ip[1] = 0x100a0004;
@@ -338,7 +338,7 @@ static int apply_rela(Elf_Rela *rela, Elf_Addr base, Elf_Sym *symtab,
 			       val - loc + 0xffffUL < 0x1ffffeUL) ||
 			      (r_type == R_390_PLT32DBL &&
 			       val - loc + 0xffffffffULL < 0x1fffffffeULL)))
-				val = (Elf_Addr) me->core_layout.base +
+				val = (Elf_Addr) me->core_layout.base_rx +
 					me->arch.plt_offset +
 					info->plt_offset;
 			val += rela->r_addend - loc;
@@ -360,7 +360,7 @@ static int apply_rela(Elf_Rela *rela, Elf_Addr base, Elf_Sym *symtab,
 	case R_390_GOTOFF32:	/* 32 bit offset to GOT.  */
 	case R_390_GOTOFF64:	/* 64 bit offset to GOT. */
 		val = val + rela->r_addend -
-			((Elf_Addr) me->core_layout.base + me->arch.got_offset);
+			((Elf_Addr) me->core_layout.base_rw + me->arch.got_offset);
 		if (r_type == R_390_GOTOFF16)
 			rc = apply_rela_bits(loc, val, 0, 16, 0);
 		else if (r_type == R_390_GOTOFF32)
@@ -370,7 +370,7 @@ static int apply_rela(Elf_Rela *rela, Elf_Addr base, Elf_Sym *symtab,
 		break;
 	case R_390_GOTPC:	/* 32 bit PC relative offset to GOT. */
 	case R_390_GOTPCDBL:	/* 32 bit PC rel. off. to GOT shifted by 1. */
-		val = (Elf_Addr) me->core_layout.base + me->arch.got_offset +
+		val = (Elf_Addr) me->core_layout.base_rw + me->arch.got_offset +
 			rela->r_addend - loc;
 		if (r_type == R_390_GOTPC)
 			rc = apply_rela_bits(loc, val, 1, 32, 0);
diff --git a/arch/s390/kernel/process.c b/arch/s390/kernel/process.c
index bba4fa74b..9c32b3ca1 100644
--- a/arch/s390/kernel/process.c
+++ b/arch/s390/kernel/process.c
@@ -217,13 +217,6 @@ unsigned long get_wchan(struct task_struct *p)
 	return 0;
 }
 
-unsigned long arch_align_stack(unsigned long sp)
-{
-	if (!(current->personality & ADDR_NO_RANDOMIZE) && randomize_va_space)
-		sp -= get_random_int() & ~PAGE_MASK;
-	return sp & ~0xf;
-}
-
 static inline unsigned long brk_rnd(void)
 {
 	return (get_random_int() & BRK_RND_MASK) << PAGE_SHIFT;
diff --git a/arch/s390/mm/mmap.c b/arch/s390/mm/mmap.c
index eb9df2822..7b686bab6 100644
--- a/arch/s390/mm/mmap.c
+++ b/arch/s390/mm/mmap.c
@@ -201,9 +201,9 @@ s390_get_unmapped_area(struct file *filp, unsigned long addr,
 }
 
 static unsigned long
-s390_get_unmapped_area_topdown(struct file *filp, const unsigned long addr,
-			  const unsigned long len, const unsigned long pgoff,
-			  const unsigned long flags)
+s390_get_unmapped_area_topdown(struct file *filp, unsigned long addr,
+			  unsigned long len, unsigned long pgoff,
+			  unsigned long flags)
 {
 	struct mm_struct *mm = current->mm;
 	unsigned long area;
@@ -230,6 +230,10 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 {
 	unsigned long random_factor = 0UL;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (current->flags & PF_RANDOMIZE)
 		random_factor = arch_mmap_rnd();
 
@@ -239,9 +243,21 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 	 */
 	if (mmap_is_legacy()) {
 		mm->mmap_base = mmap_base_legacy(random_factor);
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base += mm->delta_mmap;
+#endif
+
 		mm->get_unmapped_area = s390_get_unmapped_area;
 	} else {
 		mm->mmap_base = mmap_base(random_factor);
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base -= mm->delta_mmap + mm->delta_stack;
+#endif
+
 		mm->get_unmapped_area = s390_get_unmapped_area_topdown;
 	}
 }
diff --git a/arch/score/include/asm/cache.h b/arch/score/include/asm/cache.h
index ae3d59f2d..f65f0751c 100644
--- a/arch/score/include/asm/cache.h
+++ b/arch/score/include/asm/cache.h
@@ -1,7 +1,9 @@
 #ifndef _ASM_SCORE_CACHE_H
 #define _ASM_SCORE_CACHE_H
 
+#include <linux/const.h>
+
 #define L1_CACHE_SHIFT		4
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #endif /* _ASM_SCORE_CACHE_H */
diff --git a/arch/score/include/asm/exec.h b/arch/score/include/asm/exec.h
index f9f3cd59c..58ff438bd 100644
--- a/arch/score/include/asm/exec.h
+++ b/arch/score/include/asm/exec.h
@@ -1,6 +1,6 @@
 #ifndef _ASM_SCORE_EXEC_H
 #define _ASM_SCORE_EXEC_H
 
-extern unsigned long arch_align_stack(unsigned long sp);
+#define arch_align_stack(x) (x)
 
 #endif /* _ASM_SCORE_EXEC_H */
diff --git a/arch/score/kernel/process.c b/arch/score/kernel/process.c
index aae948070..93e40a460 100644
--- a/arch/score/kernel/process.c
+++ b/arch/score/kernel/process.c
@@ -114,8 +114,3 @@ unsigned long get_wchan(struct task_struct *task)
 
 	return task_pt_regs(task)->cp0_epc;
 }
-
-unsigned long arch_align_stack(unsigned long sp)
-{
-	return sp;
-}
diff --git a/arch/sh/include/asm/cache.h b/arch/sh/include/asm/cache.h
index ef9e555aa..331bd29e7 100644
--- a/arch/sh/include/asm/cache.h
+++ b/arch/sh/include/asm/cache.h
@@ -9,10 +9,11 @@
 #define __ASM_SH_CACHE_H
 #ifdef __KERNEL__
 
+#include <linux/const.h>
 #include <linux/init.h>
 #include <cpu/cache.h>
 
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define __read_mostly __attribute__((__section__(".data..read_mostly")))
 
diff --git a/arch/sh/mm/mmap.c b/arch/sh/mm/mmap.c
index 677717780..d44b59233 100644
--- a/arch/sh/mm/mmap.c
+++ b/arch/sh/mm/mmap.c
@@ -36,6 +36,7 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	struct mm_struct *mm = current->mm;
 	struct vm_area_struct *vma;
 	int do_colour_align;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 	struct vm_unmapped_area_info info;
 
 	if (flags & MAP_FIXED) {
@@ -55,6 +56,10 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	if (filp || (flags & MAP_SHARED))
 		do_colour_align = 1;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		if (do_colour_align)
 			addr = COLOUR_ALIGN(addr, pgoff);
@@ -62,14 +67,13 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr,
 			addr = PAGE_ALIGN(addr);
 
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
 	info.flags = 0;
 	info.length = len;
-	info.low_limit = TASK_UNMAPPED_BASE;
+	info.low_limit = mm->mmap_base;
 	info.high_limit = TASK_SIZE;
 	info.align_mask = do_colour_align ? (PAGE_MASK & shm_align_mask) : 0;
 	info.align_offset = pgoff << PAGE_SHIFT;
@@ -77,14 +81,15 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr,
 }
 
 unsigned long
-arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
-			  const unsigned long len, const unsigned long pgoff,
-			  const unsigned long flags)
+arch_get_unmapped_area_topdown(struct file *filp, unsigned long addr0,
+			  unsigned long len, unsigned long pgoff,
+			  unsigned long flags)
 {
 	struct vm_area_struct *vma;
 	struct mm_struct *mm = current->mm;
 	unsigned long addr = addr0;
 	int do_colour_align;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 	struct vm_unmapped_area_info info;
 
 	if (flags & MAP_FIXED) {
@@ -104,6 +109,10 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	if (filp || (flags & MAP_SHARED))
 		do_colour_align = 1;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	/* requesting a specific address */
 	if (addr) {
 		if (do_colour_align)
@@ -112,8 +121,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 			addr = PAGE_ALIGN(addr);
 
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -135,6 +143,12 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		VM_BUG_ON(addr != -ENOMEM);
 		info.flags = 0;
 		info.low_limit = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += mm->delta_mmap;
+#endif
+
 		info.high_limit = TASK_SIZE;
 		addr = vm_unmapped_area(&info);
 	}
diff --git a/arch/sparc/Kconfig b/arch/sparc/Kconfig
index 59b09600d..75a8bcb04 100644
--- a/arch/sparc/Kconfig
+++ b/arch/sparc/Kconfig
@@ -39,6 +39,7 @@ config SPARC
 	select GENERIC_STRNCPY_FROM_USER
 	select GENERIC_STRNLEN_USER
 	select MODULES_USE_ELF_RELA
+	select HAVE_GCC_PLUGINS
 	select ODD_RT_SIGACTION
 	select OLD_SIGSUSPEND
 	select ARCH_HAS_SG_CHAIN
diff --git a/arch/sparc/include/asm/atomic_64.h b/arch/sparc/include/asm/atomic_64.h
index 24827a3f7..5dd45ac40 100644
--- a/arch/sparc/include/asm/atomic_64.h
+++ b/arch/sparc/include/asm/atomic_64.h
@@ -15,18 +15,38 @@
 #define ATOMIC64_INIT(i)	{ (i) }
 
 #define atomic_read(v)		READ_ONCE((v)->counter)
+static inline int atomic_read_unchecked(const atomic_unchecked_t *v)
+{
+	return READ_ONCE(v->counter);
+}
 #define atomic64_read(v)	READ_ONCE((v)->counter)
+static inline long atomic64_read_unchecked(const atomic64_unchecked_t *v)
+{
+	return READ_ONCE(v->counter);
+}
 
 #define atomic_set(v, i)	WRITE_ONCE(((v)->counter), (i))
+static inline void atomic_set_unchecked(atomic_unchecked_t *v, int i)
+{
+	WRITE_ONCE(v->counter, i);
+}
 #define atomic64_set(v, i)	WRITE_ONCE(((v)->counter), (i))
+static inline void atomic64_set_unchecked(atomic64_unchecked_t *v, long i)
+{
+	WRITE_ONCE(v->counter, i);
+}
+
+#define __ATOMIC_OP(op, suffix)						\
+void atomic_##op##suffix(int, atomic##suffix##_t *);			\
+void atomic64_##op##suffix(long, atomic64##suffix##_t *);
 
-#define ATOMIC_OP(op)							\
-void atomic_##op(int, atomic_t *);					\
-void atomic64_##op(long, atomic64_t *);
+#define ATOMIC_OP(op) __ATOMIC_OP(op, ) __ATOMIC_OP(op, _unchecked)
 
-#define ATOMIC_OP_RETURN(op)						\
-int atomic_##op##_return(int, atomic_t *);				\
-long atomic64_##op##_return(long, atomic64_t *);
+#define __ATOMIC_OP_RETURN(op, suffix)					\
+int atomic_##op##_return##suffix(int, atomic##suffix##_t *);		\
+long atomic64_##op##_return##suffix(long, atomic64##suffix##_t *);
+
+#define ATOMIC_OP_RETURN(op) __ATOMIC_OP_RETURN(op, ) __ATOMIC_OP_RETURN(op, _unchecked)
 
 #define ATOMIC_FETCH_OP(op)						\
 int atomic_fetch_##op(int, atomic_t *);					\
@@ -47,13 +67,23 @@ ATOMIC_OPS(xor)
 #undef ATOMIC_OPS
 #undef ATOMIC_FETCH_OP
 #undef ATOMIC_OP_RETURN
+#undef __ATOMIC_OP_RETURN
 #undef ATOMIC_OP
+#undef __ATOMIC_OP
 
 #define atomic_dec_return(v)   atomic_sub_return(1, v)
 #define atomic64_dec_return(v) atomic64_sub_return(1, v)
 
 #define atomic_inc_return(v)   atomic_add_return(1, v)
+static inline int atomic_inc_return_unchecked(atomic_unchecked_t *v)
+{
+	return atomic_add_return_unchecked(1, v);
+}
 #define atomic64_inc_return(v) atomic64_add_return(1, v)
+static inline long atomic64_inc_return_unchecked(atomic64_unchecked_t *v)
+{
+	return atomic64_add_return_unchecked(1, v);
+}
 
 /*
  * atomic_inc_and_test - increment and test
@@ -64,6 +94,10 @@ ATOMIC_OPS(xor)
  * other cases.
  */
 #define atomic_inc_and_test(v) (atomic_inc_return(v) == 0)
+static inline int atomic_inc_and_test_unchecked(atomic_unchecked_t *v)
+{
+	return atomic_inc_return_unchecked(v) == 0;
+}
 #define atomic64_inc_and_test(v) (atomic64_inc_return(v) == 0)
 
 #define atomic_sub_and_test(i, v) (atomic_sub_return(i, v) == 0)
@@ -73,25 +107,60 @@ ATOMIC_OPS(xor)
 #define atomic64_dec_and_test(v) (atomic64_sub_return(1, v) == 0)
 
 #define atomic_inc(v) atomic_add(1, v)
+static inline void atomic_inc_unchecked(atomic_unchecked_t *v)
+{
+	atomic_add_unchecked(1, v);
+}
 #define atomic64_inc(v) atomic64_add(1, v)
+static inline void atomic64_inc_unchecked(atomic64_unchecked_t *v)
+{
+	atomic64_add_unchecked(1, v);
+}
 
 #define atomic_dec(v) atomic_sub(1, v)
+static inline void atomic_dec_unchecked(atomic_unchecked_t *v)
+{
+	atomic_sub_unchecked(1, v);
+}
 #define atomic64_dec(v) atomic64_sub(1, v)
+static inline void atomic64_dec_unchecked(atomic64_unchecked_t *v)
+{
+	atomic64_sub_unchecked(1, v);
+}
 
 #define atomic_add_negative(i, v) (atomic_add_return(i, v) < 0)
 #define atomic64_add_negative(i, v) (atomic64_add_return(i, v) < 0)
 
 #define atomic_cmpxchg(v, o, n) (cmpxchg(&((v)->counter), (o), (n)))
+static inline int atomic_cmpxchg_unchecked(atomic_unchecked_t *v, int old, int new)
+{
+	return cmpxchg(&v->counter, old, new);
+}
 #define atomic_xchg(v, new) (xchg(&((v)->counter), new))
+static inline int atomic_xchg_unchecked(atomic_unchecked_t *v, int new)
+{
+	return xchg(&v->counter, new);
+}
 
 static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 {
-	int c, old;
+	int c, old, new;
 	c = atomic_read(v);
 	for (;;) {
-		if (unlikely(c == (u)))
+		if (unlikely(c == u))
 			break;
-		old = atomic_cmpxchg((v), c, c + (a));
+
+		asm volatile("addcc %2, %0, %0\n"
+
+#ifdef CONFIG_PAX_REFCOUNT
+			     "tvs %%icc, 6\n"
+#endif
+
+			     : "=r" (new)
+			     : "0" (c), "ir" (a)
+			     : "cc");
+
+		old = atomic_cmpxchg(v, c, new);
 		if (likely(old == c))
 			break;
 		c = old;
@@ -101,21 +170,42 @@ static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 
 #define atomic64_cmpxchg(v, o, n) \
 	((__typeof__((v)->counter))cmpxchg(&((v)->counter), (o), (n)))
+static inline long atomic64_cmpxchg_unchecked(atomic64_unchecked_t *v, long old,
+					      long new)
+{
+	return cmpxchg(&(v->counter), old, new);
+}
+
 #define atomic64_xchg(v, new) (xchg(&((v)->counter), new))
+static inline long atomic64_xchg_unchecked(atomic64_unchecked_t *v, long new)
+{
+	return xchg(&v->counter, new);
+}
 
 static inline long atomic64_add_unless(atomic64_t *v, long a, long u)
 {
-	long c, old;
+	long c, old, new;
 	c = atomic64_read(v);
 	for (;;) {
-		if (unlikely(c == (u)))
+		if (unlikely(c == u))
 			break;
-		old = atomic64_cmpxchg((v), c, c + (a));
+
+		asm volatile("addcc %2, %0, %0\n"
+
+#ifdef CONFIG_PAX_REFCOUNT
+			     "tvs %%xcc, 6\n"
+#endif
+
+			     : "=r" (new)
+			     : "0" (c), "ir" (a)
+			     : "cc");
+
+		old = atomic64_cmpxchg(v, c, new);
 		if (likely(old == c))
 			break;
 		c = old;
 	}
-	return c != (u);
+	return c != u;
 }
 
 #define atomic64_inc_not_zero(v) atomic64_add_unless((v), 1, 0)
diff --git a/arch/sparc/include/asm/cache.h b/arch/sparc/include/asm/cache.h
index 5bb6991b4..5c2132e96 100644
--- a/arch/sparc/include/asm/cache.h
+++ b/arch/sparc/include/asm/cache.h
@@ -7,10 +7,12 @@
 #ifndef _SPARC_CACHE_H
 #define _SPARC_CACHE_H
 
+#include <linux/const.h>
+
 #define ARCH_SLAB_MINALIGN	__alignof__(unsigned long long)
 
 #define L1_CACHE_SHIFT 5
-#define L1_CACHE_BYTES 32
+#define L1_CACHE_BYTES (_AC(1,UL) << L1_CACHE_SHIFT)
 
 #ifdef CONFIG_SPARC32
 #define SMP_CACHE_BYTES_SHIFT 5
diff --git a/arch/sparc/include/asm/elf_32.h b/arch/sparc/include/asm/elf_32.h
index a24e41fcd..47677ff75 100644
--- a/arch/sparc/include/asm/elf_32.h
+++ b/arch/sparc/include/asm/elf_32.h
@@ -114,6 +114,13 @@ typedef struct {
 
 #define ELF_ET_DYN_BASE         (TASK_UNMAPPED_BASE)
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	0x10000UL
+
+#define PAX_DELTA_MMAP_LEN	16
+#define PAX_DELTA_STACK_LEN	16
+#endif
+
 /* This yields a mask that user programs can use to figure out what
    instruction set this cpu supports.  This can NOT be done in userspace
    on Sparc.  */
diff --git a/arch/sparc/include/asm/elf_64.h b/arch/sparc/include/asm/elf_64.h
index 93310837c..59c0499d8 100644
--- a/arch/sparc/include/asm/elf_64.h
+++ b/arch/sparc/include/asm/elf_64.h
@@ -190,6 +190,13 @@ typedef struct {
 #define ELF_ET_DYN_BASE		0x0000010000000000UL
 #define COMPAT_ELF_ET_DYN_BASE	0x0000000070000000UL
 
+#ifdef CONFIG_PAX_ASLR
+#define PAX_ELF_ET_DYN_BASE	(test_thread_flag(TIF_32BIT) ? 0x10000UL : 0x100000UL)
+
+#define PAX_DELTA_MMAP_LEN	(test_thread_flag(TIF_32BIT) ? 14 : 28)
+#define PAX_DELTA_STACK_LEN	(test_thread_flag(TIF_32BIT) ? 15 : 29)
+#endif
+
 extern unsigned long sparc64_elf_hwcap;
 #define ELF_HWCAP	sparc64_elf_hwcap
 
diff --git a/arch/sparc/include/asm/pgalloc_32.h b/arch/sparc/include/asm/pgalloc_32.h
index 0346c7e62..c5c25b906 100644
--- a/arch/sparc/include/asm/pgalloc_32.h
+++ b/arch/sparc/include/asm/pgalloc_32.h
@@ -35,6 +35,7 @@ static inline void pgd_set(pgd_t * pgdp, pmd_t * pmdp)
 }
 
 #define pgd_populate(MM, PGD, PMD)      pgd_set(PGD, PMD)
+#define pgd_populate_kernel(MM, PGD, PMD)      pgd_populate((MM), (PGD), (PMD))
 
 static inline pmd_t *pmd_alloc_one(struct mm_struct *mm,
 				   unsigned long address)
diff --git a/arch/sparc/include/asm/pgalloc_64.h b/arch/sparc/include/asm/pgalloc_64.h
index 3529f1378..d98a28c42 100644
--- a/arch/sparc/include/asm/pgalloc_64.h
+++ b/arch/sparc/include/asm/pgalloc_64.h
@@ -21,6 +21,7 @@ static inline void __pgd_populate(pgd_t *pgd, pud_t *pud)
 }
 
 #define pgd_populate(MM, PGD, PUD)	__pgd_populate(PGD, PUD)
+#define pgd_populate_kernel(MM, PGD, PMD)	pgd_populate((MM), (PGD), (PMD))
 
 static inline pgd_t *pgd_alloc(struct mm_struct *mm)
 {
@@ -38,6 +39,7 @@ static inline void __pud_populate(pud_t *pud, pmd_t *pmd)
 }
 
 #define pud_populate(MM, PUD, PMD)	__pud_populate(PUD, PMD)
+#define pud_populate_kernel(MM, PUD, PMD)	pud_populate((MM), (PUD), (PMD))
 
 static inline pud_t *pud_alloc_one(struct mm_struct *mm, unsigned long addr)
 {
diff --git a/arch/sparc/include/asm/pgtable.h b/arch/sparc/include/asm/pgtable.h
index 59ba6f620..451812819 100644
--- a/arch/sparc/include/asm/pgtable.h
+++ b/arch/sparc/include/asm/pgtable.h
@@ -5,4 +5,8 @@
 #else
 #include <asm/pgtable_32.h>
 #endif
+
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+
 #endif
diff --git a/arch/sparc/include/asm/pgtable_32.h b/arch/sparc/include/asm/pgtable_32.h
index ce6f56980..593b043b9 100644
--- a/arch/sparc/include/asm/pgtable_32.h
+++ b/arch/sparc/include/asm/pgtable_32.h
@@ -51,6 +51,9 @@ unsigned long __init bootmem_init(unsigned long *pages_avail);
 #define PAGE_SHARED	SRMMU_PAGE_SHARED
 #define PAGE_COPY	SRMMU_PAGE_COPY
 #define PAGE_READONLY	SRMMU_PAGE_RDONLY
+#define PAGE_SHARED_NOEXEC	SRMMU_PAGE_SHARED_NOEXEC
+#define PAGE_COPY_NOEXEC	SRMMU_PAGE_COPY_NOEXEC
+#define PAGE_READONLY_NOEXEC	SRMMU_PAGE_RDONLY_NOEXEC
 #define PAGE_KERNEL	SRMMU_PAGE_KERNEL
 
 /* Top-level page directory - dummy used by init-mm.
@@ -63,18 +66,18 @@ extern unsigned long ptr_in_current_pgd;
 
 /*         xwr */
 #define __P000  PAGE_NONE
-#define __P001  PAGE_READONLY
-#define __P010  PAGE_COPY
-#define __P011  PAGE_COPY
+#define __P001  PAGE_READONLY_NOEXEC
+#define __P010  PAGE_COPY_NOEXEC
+#define __P011  PAGE_COPY_NOEXEC
 #define __P100  PAGE_READONLY
 #define __P101  PAGE_READONLY
 #define __P110  PAGE_COPY
 #define __P111  PAGE_COPY
 
 #define __S000	PAGE_NONE
-#define __S001	PAGE_READONLY
-#define __S010	PAGE_SHARED
-#define __S011	PAGE_SHARED
+#define __S001	PAGE_READONLY_NOEXEC
+#define __S010	PAGE_SHARED_NOEXEC
+#define __S011	PAGE_SHARED_NOEXEC
 #define __S100	PAGE_READONLY
 #define __S101	PAGE_READONLY
 #define __S110	PAGE_SHARED
diff --git a/arch/sparc/include/asm/pgtsrmmu.h b/arch/sparc/include/asm/pgtsrmmu.h
index ae51a111a..eadfd03fc 100644
--- a/arch/sparc/include/asm/pgtsrmmu.h
+++ b/arch/sparc/include/asm/pgtsrmmu.h
@@ -111,6 +111,11 @@
 				    SRMMU_EXEC | SRMMU_REF)
 #define SRMMU_PAGE_RDONLY  __pgprot(SRMMU_VALID | SRMMU_CACHE | \
 				    SRMMU_EXEC | SRMMU_REF)
+
+#define SRMMU_PAGE_SHARED_NOEXEC	__pgprot(SRMMU_VALID | SRMMU_CACHE | SRMMU_WRITE | SRMMU_REF)
+#define SRMMU_PAGE_COPY_NOEXEC		__pgprot(SRMMU_VALID | SRMMU_CACHE | SRMMU_REF)
+#define SRMMU_PAGE_RDONLY_NOEXEC	__pgprot(SRMMU_VALID | SRMMU_CACHE | SRMMU_REF)
+
 #define SRMMU_PAGE_KERNEL  __pgprot(SRMMU_VALID | SRMMU_CACHE | SRMMU_PRIV | \
 				    SRMMU_DIRTY | SRMMU_REF)
 
diff --git a/arch/sparc/include/asm/setup.h b/arch/sparc/include/asm/setup.h
index 29d64b175..4272fe8d2 100644
--- a/arch/sparc/include/asm/setup.h
+++ b/arch/sparc/include/asm/setup.h
@@ -55,8 +55,8 @@ int handle_ldf_stq(u32 insn, struct pt_regs *regs);
 void handle_ld_nf(u32 insn, struct pt_regs *regs);
 
 /* init_64.c */
-extern atomic_t dcpage_flushes;
-extern atomic_t dcpage_flushes_xcall;
+extern atomic_unchecked_t dcpage_flushes;
+extern atomic_unchecked_t dcpage_flushes_xcall;
 
 extern int sysctl_tsb_ratio;
 #endif
diff --git a/arch/sparc/include/asm/spinlock_64.h b/arch/sparc/include/asm/spinlock_64.h
index 87990b7c6..352fff04f 100644
--- a/arch/sparc/include/asm/spinlock_64.h
+++ b/arch/sparc/include/asm/spinlock_64.h
@@ -96,14 +96,19 @@ static inline void arch_spin_lock_flags(arch_spinlock_t *lock, unsigned long fla
 
 /* Multi-reader locks, these are much saner than the 32-bit Sparc ones... */
 
-static void inline arch_read_lock(arch_rwlock_t *lock)
+static inline void arch_read_lock(arch_rwlock_t *lock)
 {
 	unsigned long tmp1, tmp2;
 
 	__asm__ __volatile__ (
 "1:	ldsw		[%2], %0\n"
 "	brlz,pn		%0, 2f\n"
-"4:	 add		%0, 1, %1\n"
+"4:	 addcc		%0, 1, %1\n"
+
+#ifdef CONFIG_PAX_REFCOUNT
+"	tvs		%%icc, 6\n"
+#endif
+
 "	cas		[%2], %0, %1\n"
 "	cmp		%0, %1\n"
 "	bne,pn		%%icc, 1b\n"
@@ -116,10 +121,10 @@ static void inline arch_read_lock(arch_rwlock_t *lock)
 "	.previous"
 	: "=&r" (tmp1), "=&r" (tmp2)
 	: "r" (lock)
-	: "memory");
+	: "memory", "cc");
 }
 
-static int inline arch_read_trylock(arch_rwlock_t *lock)
+static inline int arch_read_trylock(arch_rwlock_t *lock)
 {
 	int tmp1, tmp2;
 
@@ -127,7 +132,12 @@ static int inline arch_read_trylock(arch_rwlock_t *lock)
 "1:	ldsw		[%2], %0\n"
 "	brlz,a,pn	%0, 2f\n"
 "	 mov		0, %0\n"
-"	add		%0, 1, %1\n"
+"	addcc		%0, 1, %1\n"
+
+#ifdef CONFIG_PAX_REFCOUNT
+"	tvs		%%icc, 6\n"
+#endif
+
 "	cas		[%2], %0, %1\n"
 "	cmp		%0, %1\n"
 "	bne,pn		%%icc, 1b\n"
@@ -140,13 +150,18 @@ static int inline arch_read_trylock(arch_rwlock_t *lock)
 	return tmp1;
 }
 
-static void inline arch_read_unlock(arch_rwlock_t *lock)
+static inline void arch_read_unlock(arch_rwlock_t *lock)
 {
 	unsigned long tmp1, tmp2;
 
 	__asm__ __volatile__(
 "1:	lduw	[%2], %0\n"
-"	sub	%0, 1, %1\n"
+"	subcc	%0, 1, %1\n"
+
+#ifdef CONFIG_PAX_REFCOUNT
+"	tvs	%%icc, 6\n"
+#endif
+
 "	cas	[%2], %0, %1\n"
 "	cmp	%0, %1\n"
 "	bne,pn	%%xcc, 1b\n"
@@ -156,7 +171,7 @@ static void inline arch_read_unlock(arch_rwlock_t *lock)
 	: "memory");
 }
 
-static void inline arch_write_lock(arch_rwlock_t *lock)
+static inline void arch_write_lock(arch_rwlock_t *lock)
 {
 	unsigned long mask, tmp1, tmp2;
 
@@ -181,7 +196,7 @@ static void inline arch_write_lock(arch_rwlock_t *lock)
 	: "memory");
 }
 
-static void inline arch_write_unlock(arch_rwlock_t *lock)
+static inline void arch_write_unlock(arch_rwlock_t *lock)
 {
 	__asm__ __volatile__(
 "	stw		%%g0, [%0]"
@@ -190,7 +205,7 @@ static void inline arch_write_unlock(arch_rwlock_t *lock)
 	: "memory");
 }
 
-static int inline arch_write_trylock(arch_rwlock_t *lock)
+static inline int arch_write_trylock(arch_rwlock_t *lock)
 {
 	unsigned long mask, tmp1, tmp2, result;
 
diff --git a/arch/sparc/include/asm/thread_info_32.h b/arch/sparc/include/asm/thread_info_32.h
index 229475f0d..2fca91633 100644
--- a/arch/sparc/include/asm/thread_info_32.h
+++ b/arch/sparc/include/asm/thread_info_32.h
@@ -48,6 +48,7 @@ struct thread_info {
 	struct reg_window32	reg_window[NSWINS];	/* align for ldd! */
 	unsigned long		rwbuf_stkptrs[NSWINS];
 	unsigned long		w_saved;
+	unsigned long		lowest_stack;
 };
 
 /*
diff --git a/arch/sparc/include/asm/thread_info_64.h b/arch/sparc/include/asm/thread_info_64.h
index 3d7b925f6..493ce8222 100644
--- a/arch/sparc/include/asm/thread_info_64.h
+++ b/arch/sparc/include/asm/thread_info_64.h
@@ -59,6 +59,8 @@ struct thread_info {
 	struct pt_regs		*kern_una_regs;
 	unsigned int		kern_una_insn;
 
+	unsigned long		lowest_stack;
+
 	unsigned long		fpregs[(7 * 256) / sizeof(unsigned long)]
 		__attribute__ ((aligned(64)));
 };
@@ -180,12 +182,13 @@ register struct thread_info *current_thread_info_reg asm("g6");
 #define TIF_NEED_RESCHED	3	/* rescheduling necessary */
 /* flag bit 4 is available */
 #define TIF_UNALIGNED		5	/* allowed to do unaligned accesses */
-/* flag bit 6 is available */
+#define TIF_GRSEC_SETXID	6	/* update credentials on syscall entry/exit */
 #define TIF_32BIT		7	/* 32-bit binary */
 #define TIF_NOHZ		8	/* in adaptive nohz mode */
 #define TIF_SECCOMP		9	/* secure computing */
 #define TIF_SYSCALL_AUDIT	10	/* syscall auditing active */
 #define TIF_SYSCALL_TRACEPOINT	11	/* syscall tracepoint instrumentation */
+
 /* NOTE: Thread flags >= 12 should be ones we have no interest
  *       in using in assembly, else we can't use the mask as
  *       an immediate value in instructions such as andcc.
@@ -205,12 +208,17 @@ register struct thread_info *current_thread_info_reg asm("g6");
 #define _TIF_SYSCALL_AUDIT	(1<<TIF_SYSCALL_AUDIT)
 #define _TIF_SYSCALL_TRACEPOINT	(1<<TIF_SYSCALL_TRACEPOINT)
 #define _TIF_POLLING_NRFLAG	(1<<TIF_POLLING_NRFLAG)
+#define _TIF_GRSEC_SETXID	(1<<TIF_GRSEC_SETXID)
 
 #define _TIF_USER_WORK_MASK	((0xff << TI_FLAG_WSAVED_SHIFT) | \
 				 _TIF_DO_NOTIFY_RESUME_MASK | \
 				 _TIF_NEED_RESCHED)
 #define _TIF_DO_NOTIFY_RESUME_MASK	(_TIF_NOTIFY_RESUME | _TIF_SIGPENDING)
 
+#define _TIF_WORK_SYSCALL		\
+	(_TIF_SYSCALL_TRACE | _TIF_SECCOMP | _TIF_SYSCALL_AUDIT | \
+	 _TIF_SYSCALL_TRACEPOINT | _TIF_NOHZ | _TIF_GRSEC_SETXID)
+
 #define is_32bit_task()	(test_thread_flag(TIF_32BIT))
 
 /*
diff --git a/arch/sparc/include/asm/uaccess.h b/arch/sparc/include/asm/uaccess.h
index bd56c28ff..4b63d83e1 100644
--- a/arch/sparc/include/asm/uaccess.h
+++ b/arch/sparc/include/asm/uaccess.h
@@ -1,5 +1,6 @@
 #ifndef ___ASM_SPARC_UACCESS_H
 #define ___ASM_SPARC_UACCESS_H
+
 #if defined(__sparc__) && defined(__arch64__)
 #include <asm/uaccess_64.h>
 #else
diff --git a/arch/sparc/include/asm/uaccess_32.h b/arch/sparc/include/asm/uaccess_32.h
index ea55f86d7..dbf15cfb5 100644
--- a/arch/sparc/include/asm/uaccess_32.h
+++ b/arch/sparc/include/asm/uaccess_32.h
@@ -47,6 +47,7 @@
 #define __user_ok(addr, size) ({ (void)(size); (addr) < STACK_TOP; })
 #define __kernel_ok (segment_eq(get_fs(), KERNEL_DS))
 #define __access_ok(addr, size) (__user_ok((addr) & get_fs().seg, (size)))
+#define access_ok_noprefault(type, addr, size) access_ok((type), (addr), (size))
 #define access_ok(type, addr, size) \
 	({ (void)(type); __access_ok((unsigned long)(addr), size); })
 
@@ -248,6 +249,9 @@ unsigned long __copy_user(void __user *to, const void __user *from, unsigned lon
 
 static inline unsigned long copy_to_user(void __user *to, const void *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	if (n && __access_ok((unsigned long) to, n)) {
 		check_object_size(from, n, true);
 		return __copy_user(to, (__force void __user *) from, n);
@@ -257,12 +261,18 @@ static inline unsigned long copy_to_user(void __user *to, const void *from, unsi
 
 static inline unsigned long __copy_to_user(void __user *to, const void *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	check_object_size(from, n, true);
 	return __copy_user(to, (__force void __user *) from, n);
 }
 
 static inline unsigned long copy_from_user(void *to, const void __user *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	if (n && __access_ok((unsigned long) from, n)) {
 		check_object_size(to, n, false);
 		return __copy_user((__force void __user *) to, from, n);
@@ -274,6 +284,9 @@ static inline unsigned long copy_from_user(void *to, const void __user *from, un
 
 static inline unsigned long __copy_from_user(void *to, const void __user *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	return __copy_user((__force void __user *) to, from, n);
 }
 
diff --git a/arch/sparc/include/asm/uaccess_64.h b/arch/sparc/include/asm/uaccess_64.h
index a6847fc05..a5ac14a01 100644
--- a/arch/sparc/include/asm/uaccess_64.h
+++ b/arch/sparc/include/asm/uaccess_64.h
@@ -10,6 +10,7 @@
 #include <linux/compiler.h>
 #include <linux/string.h>
 #include <linux/thread_info.h>
+#include <linux/kernel.h>
 #include <asm/asi.h>
 #include <asm/spitfire.h>
 #include <asm-generic/uaccess-unaligned.h>
@@ -76,6 +77,11 @@ static inline int __access_ok(const void __user * addr, unsigned long size)
 	return 1;
 }
 
+static inline int access_ok_noprefault(int type, const void __user * addr, unsigned long size)
+{
+	return 1;
+}
+
 static inline int access_ok(int type, const void __user * addr, unsigned long size)
 {
 	return 1;
@@ -207,6 +213,9 @@ unsigned long __must_check ___copy_from_user(void *to,
 static inline unsigned long __must_check
 copy_from_user(void *to, const void __user *from, unsigned long size)
 {
+	if ((long)size < 0 || size > INT_MAX)
+		return size;
+
 	check_object_size(to, size, false);
 
 	return ___copy_from_user(to, from, size);
@@ -219,6 +228,9 @@ unsigned long __must_check ___copy_to_user(void __user *to,
 static inline unsigned long __must_check
 copy_to_user(void __user *to, const void *from, unsigned long size)
 {
+	if ((long)size < 0 || size > INT_MAX)
+		return size;
+
 	check_object_size(from, size, true);
 
 	return ___copy_to_user(to, from, size);
diff --git a/arch/sparc/kernel/Makefile b/arch/sparc/kernel/Makefile
index fdb13327f..1b10f89f0 100644
--- a/arch/sparc/kernel/Makefile
+++ b/arch/sparc/kernel/Makefile
@@ -4,7 +4,7 @@
 #
 
 asflags-y := -ansi
-ccflags-y := -Werror
+#ccflags-y := -Werror
 
 extra-y     := head_$(BITS).o
 
diff --git a/arch/sparc/kernel/process_32.c b/arch/sparc/kernel/process_32.c
index b7780a5be..28315f023 100644
--- a/arch/sparc/kernel/process_32.c
+++ b/arch/sparc/kernel/process_32.c
@@ -123,14 +123,14 @@ void show_regs(struct pt_regs *r)
 
         printk("PSR: %08lx PC: %08lx NPC: %08lx Y: %08lx    %s\n",
 	       r->psr, r->pc, r->npc, r->y, print_tainted());
-	printk("PC: <%pS>\n", (void *) r->pc);
+	printk("PC: <%pA>\n", (void *) r->pc);
 	printk("%%G: %08lx %08lx  %08lx %08lx  %08lx %08lx  %08lx %08lx\n",
 	       r->u_regs[0], r->u_regs[1], r->u_regs[2], r->u_regs[3],
 	       r->u_regs[4], r->u_regs[5], r->u_regs[6], r->u_regs[7]);
 	printk("%%O: %08lx %08lx  %08lx %08lx  %08lx %08lx  %08lx %08lx\n",
 	       r->u_regs[8], r->u_regs[9], r->u_regs[10], r->u_regs[11],
 	       r->u_regs[12], r->u_regs[13], r->u_regs[14], r->u_regs[15]);
-	printk("RPC: <%pS>\n", (void *) r->u_regs[15]);
+	printk("RPC: <%pA>\n", (void *) r->u_regs[15]);
 
 	printk("%%L: %08lx %08lx  %08lx %08lx  %08lx %08lx  %08lx %08lx\n",
 	       rw->locals[0], rw->locals[1], rw->locals[2], rw->locals[3],
@@ -167,7 +167,7 @@ void show_stack(struct task_struct *tsk, unsigned long *_ksp)
 		rw = (struct reg_window32 *) fp;
 		pc = rw->ins[7];
 		printk("[%08lx : ", pc);
-		printk("%pS ] ", (void *) pc);
+		printk("%pA ] ", (void *) pc);
 		fp = rw->ins[6];
 	} while (++count < 16);
 	printk("\n");
diff --git a/arch/sparc/kernel/process_64.c b/arch/sparc/kernel/process_64.c
index fa14402b3..b2a740806 100644
--- a/arch/sparc/kernel/process_64.c
+++ b/arch/sparc/kernel/process_64.c
@@ -161,7 +161,7 @@ static void show_regwindow(struct pt_regs *regs)
 	printk("i4: %016lx i5: %016lx i6: %016lx i7: %016lx\n",
 	       rwk->ins[4], rwk->ins[5], rwk->ins[6], rwk->ins[7]);
 	if (regs->tstate & TSTATE_PRIV)
-		printk("I7: <%pS>\n", (void *) rwk->ins[7]);
+		printk("I7: <%pA>\n", (void *) rwk->ins[7]);
 }
 
 void show_regs(struct pt_regs *regs)
@@ -170,7 +170,7 @@ void show_regs(struct pt_regs *regs)
 
 	printk("TSTATE: %016lx TPC: %016lx TNPC: %016lx Y: %08x    %s\n", regs->tstate,
 	       regs->tpc, regs->tnpc, regs->y, print_tainted());
-	printk("TPC: <%pS>\n", (void *) regs->tpc);
+	printk("TPC: <%pA>\n", (void *) regs->tpc);
 	printk("g0: %016lx g1: %016lx g2: %016lx g3: %016lx\n",
 	       regs->u_regs[0], regs->u_regs[1], regs->u_regs[2],
 	       regs->u_regs[3]);
@@ -183,7 +183,7 @@ void show_regs(struct pt_regs *regs)
 	printk("o4: %016lx o5: %016lx sp: %016lx ret_pc: %016lx\n",
 	       regs->u_regs[12], regs->u_regs[13], regs->u_regs[14],
 	       regs->u_regs[15]);
-	printk("RPC: <%pS>\n", (void *) regs->u_regs[15]);
+	printk("RPC: <%pA>\n", (void *) regs->u_regs[15]);
 	show_regwindow(regs);
 	show_stack(current, (unsigned long *) regs->u_regs[UREG_FP]);
 }
@@ -278,7 +278,7 @@ void arch_trigger_all_cpu_backtrace(bool include_self)
 		       ((tp && tp->task) ? tp->task->pid : -1));
 
 		if (gp->tstate & TSTATE_PRIV) {
-			printk("             TPC[%pS] O7[%pS] I7[%pS] RPC[%pS]\n",
+			printk("             TPC[%pA] O7[%pA] I7[%pA] RPC[%pA]\n",
 			       (void *) gp->tpc,
 			       (void *) gp->o7,
 			       (void *) gp->i7,
diff --git a/arch/sparc/kernel/prom_common.c b/arch/sparc/kernel/prom_common.c
index 79cc0d1a4..46d6233bb 100644
--- a/arch/sparc/kernel/prom_common.c
+++ b/arch/sparc/kernel/prom_common.c
@@ -144,7 +144,7 @@ static int __init prom_common_nextprop(phandle node, char *prev, char *buf)
 
 unsigned int prom_early_allocated __initdata;
 
-static struct of_pdt_ops prom_sparc_ops __initdata = {
+static const struct of_pdt_ops prom_sparc_ops __initconst = {
 	.nextprop = prom_common_nextprop,
 	.getproplen = prom_getproplen,
 	.getproperty = prom_getproperty,
diff --git a/arch/sparc/kernel/ptrace_64.c b/arch/sparc/kernel/ptrace_64.c
index 9ddc4928a..27a561995 100644
--- a/arch/sparc/kernel/ptrace_64.c
+++ b/arch/sparc/kernel/ptrace_64.c
@@ -1060,6 +1060,10 @@ long arch_ptrace(struct task_struct *child, long request,
 	return ret;
 }
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+extern void gr_delayed_cred_worker(void);
+#endif
+
 asmlinkage int syscall_trace_enter(struct pt_regs *regs)
 {
 	int ret = 0;
@@ -1070,6 +1074,11 @@ asmlinkage int syscall_trace_enter(struct pt_regs *regs)
 	if (test_thread_flag(TIF_NOHZ))
 		user_exit();
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	if (test_thread_flag(TIF_SYSCALL_TRACE))
 		ret = tracehook_report_syscall_entry(regs);
 
@@ -1088,6 +1097,11 @@ asmlinkage void syscall_trace_leave(struct pt_regs *regs)
 	if (test_thread_flag(TIF_NOHZ))
 		user_exit();
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	audit_syscall_exit(regs);
 
 	if (unlikely(test_thread_flag(TIF_SYSCALL_TRACEPOINT)))
diff --git a/arch/sparc/kernel/smp_64.c b/arch/sparc/kernel/smp_64.c
index d3035ba6c..40683bd6f 100644
--- a/arch/sparc/kernel/smp_64.c
+++ b/arch/sparc/kernel/smp_64.c
@@ -891,7 +891,7 @@ void smp_flush_dcache_page_impl(struct page *page, int cpu)
 		return;
 
 #ifdef CONFIG_DEBUG_DCFLUSH
-	atomic_inc(&dcpage_flushes);
+	atomic_inc_unchecked(&dcpage_flushes);
 #endif
 
 	this_cpu = get_cpu();
@@ -915,7 +915,7 @@ void smp_flush_dcache_page_impl(struct page *page, int cpu)
 			xcall_deliver(data0, __pa(pg_addr),
 				      (u64) pg_addr, cpumask_of(cpu));
 #ifdef CONFIG_DEBUG_DCFLUSH
-			atomic_inc(&dcpage_flushes_xcall);
+			atomic_inc_unchecked(&dcpage_flushes_xcall);
 #endif
 		}
 	}
@@ -934,7 +934,7 @@ void flush_dcache_page_all(struct mm_struct *mm, struct page *page)
 	preempt_disable();
 
 #ifdef CONFIG_DEBUG_DCFLUSH
-	atomic_inc(&dcpage_flushes);
+	atomic_inc_unchecked(&dcpage_flushes);
 #endif
 	data0 = 0;
 	pg_addr = page_address(page);
@@ -951,7 +951,7 @@ void flush_dcache_page_all(struct mm_struct *mm, struct page *page)
 		xcall_deliver(data0, __pa(pg_addr),
 			      (u64) pg_addr, cpu_online_mask);
 #ifdef CONFIG_DEBUG_DCFLUSH
-		atomic_inc(&dcpage_flushes_xcall);
+		atomic_inc_unchecked(&dcpage_flushes_xcall);
 #endif
 	}
 	__local_flush_dcache_page(page);
diff --git a/arch/sparc/kernel/sys_sparc_32.c b/arch/sparc/kernel/sys_sparc_32.c
index 646988d4c..b88905f08 100644
--- a/arch/sparc/kernel/sys_sparc_32.c
+++ b/arch/sparc/kernel/sys_sparc_32.c
@@ -54,7 +54,7 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 	if (len > TASK_SIZE - PAGE_SIZE)
 		return -ENOMEM;
 	if (!addr)
-		addr = TASK_UNMAPPED_BASE;
+		addr = current->mm->mmap_base;
 
 	info.flags = 0;
 	info.length = len;
diff --git a/arch/sparc/kernel/sys_sparc_64.c b/arch/sparc/kernel/sys_sparc_64.c
index fe8b8ee8e..3f17a966f 100644
--- a/arch/sparc/kernel/sys_sparc_64.c
+++ b/arch/sparc/kernel/sys_sparc_64.c
@@ -89,13 +89,14 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 	struct vm_area_struct * vma;
 	unsigned long task_size = TASK_SIZE;
 	int do_color_align;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 	struct vm_unmapped_area_info info;
 
 	if (flags & MAP_FIXED) {
 		/* We do not accept a shared mapping if it would violate
 		 * cache aliasing constraints.
 		 */
-		if ((flags & MAP_SHARED) &&
+		if ((filp || (flags & MAP_SHARED)) &&
 		    ((addr - (pgoff << PAGE_SHIFT)) & (SHMLBA - 1)))
 			return -EINVAL;
 		return addr;
@@ -110,6 +111,10 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 	if (filp || (flags & MAP_SHARED))
 		do_color_align = 1;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		if (do_color_align)
 			addr = COLOR_ALIGN(addr, pgoff);
@@ -117,22 +122,28 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 			addr = PAGE_ALIGN(addr);
 
 		vma = find_vma(mm, addr);
-		if (task_size - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (task_size - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
 	info.flags = 0;
 	info.length = len;
-	info.low_limit = TASK_UNMAPPED_BASE;
+	info.low_limit = mm->mmap_base;
 	info.high_limit = min(task_size, VA_EXCLUDE_START);
 	info.align_mask = do_color_align ? (PAGE_MASK & (SHMLBA - 1)) : 0;
 	info.align_offset = pgoff << PAGE_SHIFT;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 	if ((addr & ~PAGE_MASK) && task_size > VA_EXCLUDE_END) {
 		VM_BUG_ON(addr != -ENOMEM);
 		info.low_limit = VA_EXCLUDE_END;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += mm->delta_mmap;
+#endif
+
 		info.high_limit = task_size;
 		addr = vm_unmapped_area(&info);
 	}
@@ -141,15 +152,16 @@ unsigned long arch_get_unmapped_area(struct file *filp, unsigned long addr, unsi
 }
 
 unsigned long
-arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
-			  const unsigned long len, const unsigned long pgoff,
-			  const unsigned long flags)
+arch_get_unmapped_area_topdown(struct file *filp, unsigned long addr0,
+			  unsigned long len, unsigned long pgoff,
+			  unsigned long flags)
 {
 	struct vm_area_struct *vma;
 	struct mm_struct *mm = current->mm;
 	unsigned long task_size = STACK_TOP32;
 	unsigned long addr = addr0;
 	int do_color_align;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 	struct vm_unmapped_area_info info;
 
 	/* This should only ever run for 32-bit processes.  */
@@ -159,7 +171,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		/* We do not accept a shared mapping if it would violate
 		 * cache aliasing constraints.
 		 */
-		if ((flags & MAP_SHARED) &&
+		if ((filp || (flags & MAP_SHARED)) &&
 		    ((addr - (pgoff << PAGE_SHIFT)) & (SHMLBA - 1)))
 			return -EINVAL;
 		return addr;
@@ -172,6 +184,10 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	if (filp || (flags & MAP_SHARED))
 		do_color_align = 1;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	/* requesting a specific address */
 	if (addr) {
 		if (do_color_align)
@@ -180,8 +196,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 			addr = PAGE_ALIGN(addr);
 
 		vma = find_vma(mm, addr);
-		if (task_size - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (task_size - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -191,6 +206,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	info.high_limit = mm->mmap_base;
 	info.align_mask = do_color_align ? (PAGE_MASK & (SHMLBA - 1)) : 0;
 	info.align_offset = pgoff << PAGE_SHIFT;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 	/*
@@ -203,6 +219,12 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		VM_BUG_ON(addr != -ENOMEM);
 		info.flags = 0;
 		info.low_limit = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += mm->delta_mmap;
+#endif
+
 		info.high_limit = STACK_TOP32;
 		addr = vm_unmapped_area(&info);
 	}
@@ -259,10 +281,14 @@ unsigned long get_fb_unmapped_area(struct file *filp, unsigned long orig_addr, u
 EXPORT_SYMBOL(get_fb_unmapped_area);
 
 /* Essentially the same as PowerPC.  */
-static unsigned long mmap_rnd(void)
+static unsigned long mmap_rnd(struct mm_struct *mm)
 {
 	unsigned long rnd = 0UL;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (current->flags & PF_RANDOMIZE) {
 		unsigned long val = get_random_long();
 		if (test_thread_flag(TIF_32BIT))
@@ -275,7 +301,7 @@ static unsigned long mmap_rnd(void)
 
 void arch_pick_mmap_layout(struct mm_struct *mm)
 {
-	unsigned long random_factor = mmap_rnd();
+	unsigned long random_factor = mmap_rnd(mm);
 	unsigned long gap;
 
 	/*
@@ -288,6 +314,12 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 	    gap == RLIM_INFINITY ||
 	    sysctl_legacy_va_layout) {
 		mm->mmap_base = TASK_UNMAPPED_BASE + random_factor;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base += mm->delta_mmap;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area;
 	} else {
 		/* We know it's 32-bit */
@@ -299,6 +331,12 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 			gap = (task_size / 6 * 5);
 
 		mm->mmap_base = PAGE_ALIGN(task_size - gap - random_factor);
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			mm->mmap_base -= mm->delta_mmap + mm->delta_stack;
+#endif
+
 		mm->get_unmapped_area = arch_get_unmapped_area_topdown;
 	}
 }
diff --git a/arch/sparc/kernel/syscalls.S b/arch/sparc/kernel/syscalls.S
index c4a1b5c40..c5e0ef330 100644
--- a/arch/sparc/kernel/syscalls.S
+++ b/arch/sparc/kernel/syscalls.S
@@ -62,7 +62,7 @@ sys32_rt_sigreturn:
 #endif
 	.align	32
 1:	ldx	[%g6 + TI_FLAGS], %l5
-	andcc	%l5, (_TIF_SYSCALL_TRACE|_TIF_SECCOMP|_TIF_SYSCALL_AUDIT|_TIF_SYSCALL_TRACEPOINT|_TIF_NOHZ), %g0
+	andcc	%l5, _TIF_WORK_SYSCALL, %g0
 	be,pt	%icc, rtrap
 	 nop
 	call	syscall_trace_leave
@@ -230,7 +230,7 @@ linux_sparc_syscall32:
 
 	srl	%i3, 0, %o3				! IEU0
 	srl	%i2, 0, %o2				! IEU0	Group
-	andcc	%l0, (_TIF_SYSCALL_TRACE|_TIF_SECCOMP|_TIF_SYSCALL_AUDIT|_TIF_SYSCALL_TRACEPOINT|_TIF_NOHZ), %g0
+	andcc	%l0, _TIF_WORK_SYSCALL, %g0
 	bne,pn	%icc, linux_syscall_trace32		! CTI
 	 mov	%i0, %l5				! IEU1
 5:	call	%l7					! CTI	Group brk forced
@@ -254,7 +254,7 @@ linux_sparc_syscall:
 
 	mov	%i3, %o3				! IEU1
 	mov	%i4, %o4				! IEU0	Group
-	andcc	%l0, (_TIF_SYSCALL_TRACE|_TIF_SECCOMP|_TIF_SYSCALL_AUDIT|_TIF_SYSCALL_TRACEPOINT|_TIF_NOHZ), %g0
+	andcc	%l0, _TIF_WORK_SYSCALL, %g0
 	bne,pn	%icc, linux_syscall_trace		! CTI	Group
 	 mov	%i0, %l5				! IEU0
 2:	call	%l7					! CTI	Group brk forced
@@ -269,7 +269,7 @@ ret_sys_call:
 
 	cmp	%o0, -ERESTART_RESTARTBLOCK
 	bgeu,pn	%xcc, 1f
-	 andcc	%l0, (_TIF_SYSCALL_TRACE|_TIF_SECCOMP|_TIF_SYSCALL_AUDIT|_TIF_SYSCALL_TRACEPOINT|_TIF_NOHZ), %g0
+	 andcc	%l0, _TIF_WORK_SYSCALL, %g0
 	ldx	[%sp + PTREGS_OFF + PT_V9_TNPC], %l1 ! pc = npc
 
 2:
diff --git a/arch/sparc/kernel/traps_32.c b/arch/sparc/kernel/traps_32.c
index 4f21df7d4..0a374da5c 100644
--- a/arch/sparc/kernel/traps_32.c
+++ b/arch/sparc/kernel/traps_32.c
@@ -44,6 +44,8 @@ static void instruction_dump(unsigned long *pc)
 #define __SAVE __asm__ __volatile__("save %sp, -0x40, %sp\n\t")
 #define __RESTORE __asm__ __volatile__("restore %g0, %g0, %g0\n\t")
 
+extern void gr_handle_kernel_exploit(void);
+
 void __noreturn die_if_kernel(char *str, struct pt_regs *regs)
 {
 	static int die_counter;
@@ -76,15 +78,17 @@ void __noreturn die_if_kernel(char *str, struct pt_regs *regs)
 		      count++ < 30				&&
                       (((unsigned long) rw) >= PAGE_OFFSET)	&&
 		      !(((unsigned long) rw) & 0x7)) {
-			printk("Caller[%08lx]: %pS\n", rw->ins[7],
+			printk("Caller[%08lx]: %pA\n", rw->ins[7],
 			       (void *) rw->ins[7]);
 			rw = (struct reg_window32 *)rw->ins[6];
 		}
 	}
 	printk("Instruction DUMP:");
 	instruction_dump ((unsigned long *) regs->pc);
-	if(regs->psr & PSR_PS)
+	if(regs->psr & PSR_PS) {
+		gr_handle_kernel_exploit();
 		do_exit(SIGKILL);
+	}
 	do_exit(SIGSEGV);
 }
 
diff --git a/arch/sparc/kernel/traps_64.c b/arch/sparc/kernel/traps_64.c
index d21cd625c..4e2ca8674 100644
--- a/arch/sparc/kernel/traps_64.c
+++ b/arch/sparc/kernel/traps_64.c
@@ -79,7 +79,7 @@ static void dump_tl1_traplog(struct tl1_traplog *p)
 		       i + 1,
 		       p->trapstack[i].tstate, p->trapstack[i].tpc,
 		       p->trapstack[i].tnpc, p->trapstack[i].tt);
-		printk("TRAPLOG: TPC<%pS>\n", (void *) p->trapstack[i].tpc);
+		printk("TRAPLOG: TPC<%pA>\n", (void *) p->trapstack[i].tpc);
 	}
 }
 
@@ -99,6 +99,12 @@ void bad_trap(struct pt_regs *regs, long lvl)
 
 	lvl -= 0x100;
 	if (regs->tstate & TSTATE_PRIV) {
+
+#ifdef CONFIG_PAX_REFCOUNT
+		if (lvl == 6)
+			pax_report_refcount_error(regs, NULL);
+#endif
+
 		sprintf(buffer, "Kernel bad sw trap %lx", lvl);
 		die_if_kernel(buffer, regs);
 	}
@@ -117,11 +123,16 @@ void bad_trap(struct pt_regs *regs, long lvl)
 void bad_trap_tl1(struct pt_regs *regs, long lvl)
 {
 	char buffer[32];
-	
+
 	if (notify_die(DIE_TRAP_TL1, "bad trap tl1", regs,
 		       0, lvl, SIGTRAP) == NOTIFY_STOP)
 		return;
 
+#ifdef CONFIG_PAX_REFCOUNT
+	if (lvl == 6)
+		pax_report_refcount_error(regs, NULL);
+#endif
+
 	dump_tl1_traplog((struct tl1_traplog *)(regs + 1));
 
 	sprintf (buffer, "Bad trap %lx at tl>0", lvl);
@@ -1151,7 +1162,7 @@ static void cheetah_log_errors(struct pt_regs *regs, struct cheetah_err_info *in
 	       regs->tpc, regs->tnpc, regs->u_regs[UREG_I7], regs->tstate);
 	printk("%s" "ERROR(%d): ",
 	       (recoverable ? KERN_WARNING : KERN_CRIT), smp_processor_id());
-	printk("TPC<%pS>\n", (void *) regs->tpc);
+	printk("TPC<%pA>\n", (void *) regs->tpc);
 	printk("%s" "ERROR(%d): M_SYND(%lx),  E_SYND(%lx)%s%s\n",
 	       (recoverable ? KERN_WARNING : KERN_CRIT), smp_processor_id(),
 	       (afsr & CHAFSR_M_SYNDROME) >> CHAFSR_M_SYNDROME_SHIFT,
@@ -1758,7 +1769,7 @@ void cheetah_plus_parity_error(int type, struct pt_regs *regs)
 		       smp_processor_id(),
 		       (type & 0x1) ? 'I' : 'D',
 		       regs->tpc);
-		printk(KERN_EMERG "TPC<%pS>\n", (void *) regs->tpc);
+		printk(KERN_EMERG "TPC<%pA>\n", (void *) regs->tpc);
 		panic("Irrecoverable Cheetah+ parity error.");
 	}
 
@@ -1766,7 +1777,7 @@ void cheetah_plus_parity_error(int type, struct pt_regs *regs)
 	       smp_processor_id(),
 	       (type & 0x1) ? 'I' : 'D',
 	       regs->tpc);
-	printk(KERN_WARNING "TPC<%pS>\n", (void *) regs->tpc);
+	printk(KERN_WARNING "TPC<%pA>\n", (void *) regs->tpc);
 }
 
 struct sun4v_error_entry {
@@ -1839,8 +1850,8 @@ struct sun4v_error_entry {
 /*0x38*/u64		reserved_5;
 };
 
-static atomic_t sun4v_resum_oflow_cnt = ATOMIC_INIT(0);
-static atomic_t sun4v_nonresum_oflow_cnt = ATOMIC_INIT(0);
+static atomic_unchecked_t sun4v_resum_oflow_cnt = ATOMIC_INIT(0);
+static atomic_unchecked_t sun4v_nonresum_oflow_cnt = ATOMIC_INIT(0);
 
 static const char *sun4v_err_type_to_str(u8 type)
 {
@@ -1932,7 +1943,7 @@ static void sun4v_report_real_raddr(const char *pfx, struct pt_regs *regs)
 }
 
 static void sun4v_log_error(struct pt_regs *regs, struct sun4v_error_entry *ent,
-			    int cpu, const char *pfx, atomic_t *ocnt)
+			    int cpu, const char *pfx, atomic_unchecked_t *ocnt)
 {
 	u64 *raw_ptr = (u64 *) ent;
 	u32 attrs;
@@ -1990,8 +2001,8 @@ static void sun4v_log_error(struct pt_regs *regs, struct sun4v_error_entry *ent,
 
 	show_regs(regs);
 
-	if ((cnt = atomic_read(ocnt)) != 0) {
-		atomic_set(ocnt, 0);
+	if ((cnt = atomic_read_unchecked(ocnt)) != 0) {
+		atomic_set_unchecked(ocnt, 0);
 		wmb();
 		printk("%s: Queue overflowed %d times.\n",
 		       pfx, cnt);
@@ -2048,7 +2059,7 @@ out:
  */
 void sun4v_resum_overflow(struct pt_regs *regs)
 {
-	atomic_inc(&sun4v_resum_oflow_cnt);
+	atomic_inc_unchecked(&sun4v_resum_oflow_cnt);
 }
 
 /* We run with %pil set to PIL_NORMAL_MAX and PSTATE_IE enabled in %pstate.
@@ -2101,7 +2112,7 @@ void sun4v_nonresum_overflow(struct pt_regs *regs)
 	/* XXX Actually even this can make not that much sense.  Perhaps
 	 * XXX we should just pull the plug and panic directly from here?
 	 */
-	atomic_inc(&sun4v_nonresum_oflow_cnt);
+	atomic_inc_unchecked(&sun4v_nonresum_oflow_cnt);
 }
 
 static void sun4v_tlb_error(struct pt_regs *regs)
@@ -2120,9 +2131,9 @@ void sun4v_itlb_error_report(struct pt_regs *regs, int tl)
 
 	printk(KERN_EMERG "SUN4V-ITLB: Error at TPC[%lx], tl %d\n",
 	       regs->tpc, tl);
-	printk(KERN_EMERG "SUN4V-ITLB: TPC<%pS>\n", (void *) regs->tpc);
+	printk(KERN_EMERG "SUN4V-ITLB: TPC<%pA>\n", (void *) regs->tpc);
 	printk(KERN_EMERG "SUN4V-ITLB: O7[%lx]\n", regs->u_regs[UREG_I7]);
-	printk(KERN_EMERG "SUN4V-ITLB: O7<%pS>\n",
+	printk(KERN_EMERG "SUN4V-ITLB: O7<%pA>\n",
 	       (void *) regs->u_regs[UREG_I7]);
 	printk(KERN_EMERG "SUN4V-ITLB: vaddr[%lx] ctx[%lx] "
 	       "pte[%lx] error[%lx]\n",
@@ -2143,9 +2154,9 @@ void sun4v_dtlb_error_report(struct pt_regs *regs, int tl)
 
 	printk(KERN_EMERG "SUN4V-DTLB: Error at TPC[%lx], tl %d\n",
 	       regs->tpc, tl);
-	printk(KERN_EMERG "SUN4V-DTLB: TPC<%pS>\n", (void *) regs->tpc);
+	printk(KERN_EMERG "SUN4V-DTLB: TPC<%pA>\n", (void *) regs->tpc);
 	printk(KERN_EMERG "SUN4V-DTLB: O7[%lx]\n", regs->u_regs[UREG_I7]);
-	printk(KERN_EMERG "SUN4V-DTLB: O7<%pS>\n",
+	printk(KERN_EMERG "SUN4V-DTLB: O7<%pA>\n",
 	       (void *) regs->u_regs[UREG_I7]);
 	printk(KERN_EMERG "SUN4V-DTLB: vaddr[%lx] ctx[%lx] "
 	       "pte[%lx] error[%lx]\n",
@@ -2362,13 +2373,13 @@ void show_stack(struct task_struct *tsk, unsigned long *_ksp)
 			fp = (unsigned long)sf->fp + STACK_BIAS;
 		}
 
-		printk(" [%016lx] %pS\n", pc, (void *) pc);
+		printk(" [%016lx] %pA\n", pc, (void *) pc);
 #ifdef CONFIG_FUNCTION_GRAPH_TRACER
 		if ((pc + 8UL) == (unsigned long) &return_to_handler) {
 			int index = tsk->curr_ret_stack;
 			if (tsk->ret_stack && index >= graph) {
 				pc = tsk->ret_stack[index - graph].ret;
-				printk(" [%016lx] %pS\n", pc, (void *) pc);
+				printk(" [%016lx] %pA\n", pc, (void *) pc);
 				graph++;
 			}
 		}
@@ -2386,6 +2397,8 @@ static inline struct reg_window *kernel_stack_up(struct reg_window *rw)
 	return (struct reg_window *) (fp + STACK_BIAS);
 }
 
+extern void gr_handle_kernel_exploit(void);
+
 void __noreturn die_if_kernel(char *str, struct pt_regs *regs)
 {
 	static int die_counter;
@@ -2414,7 +2427,7 @@ void __noreturn die_if_kernel(char *str, struct pt_regs *regs)
 		while (rw &&
 		       count++ < 30 &&
 		       kstack_valid(tp, (unsigned long) rw)) {
-			printk("Caller[%016lx]: %pS\n", rw->ins[7],
+			printk("Caller[%016lx]: %pA\n", rw->ins[7],
 			       (void *) rw->ins[7]);
 
 			rw = kernel_stack_up(rw);
@@ -2429,8 +2442,10 @@ void __noreturn die_if_kernel(char *str, struct pt_regs *regs)
 	}
 	if (panic_on_oops)
 		panic("Fatal exception");
-	if (regs->tstate & TSTATE_PRIV)
+	if (regs->tstate & TSTATE_PRIV) {
+		gr_handle_kernel_exploit();
 		do_exit(SIGKILL);
+	}
 	do_exit(SIGSEGV);
 }
 EXPORT_SYMBOL(die_if_kernel);
diff --git a/arch/sparc/kernel/unaligned_64.c b/arch/sparc/kernel/unaligned_64.c
index 9aacb9159..6415c82e7 100644
--- a/arch/sparc/kernel/unaligned_64.c
+++ b/arch/sparc/kernel/unaligned_64.c
@@ -297,7 +297,7 @@ static void log_unaligned(struct pt_regs *regs)
 	static DEFINE_RATELIMIT_STATE(ratelimit, 5 * HZ, 5);
 
 	if (__ratelimit(&ratelimit)) {
-		printk("Kernel unaligned access at TPC[%lx] %pS\n",
+		printk("Kernel unaligned access at TPC[%lx] %pA\n",
 		       regs->tpc, (void *) regs->tpc);
 	}
 }
diff --git a/arch/sparc/lib/Makefile b/arch/sparc/lib/Makefile
index 4f2384a42..4e8894967 100644
--- a/arch/sparc/lib/Makefile
+++ b/arch/sparc/lib/Makefile
@@ -2,7 +2,7 @@
 #
 
 asflags-y := -ansi -DST_DIV0=0x02
-ccflags-y := -Werror
+#ccflags-y := -Werror
 
 lib-$(CONFIG_SPARC32) += ashrdi3.o
 lib-$(CONFIG_SPARC32) += memcpy.o memset.o
diff --git a/arch/sparc/lib/atomic_64.S b/arch/sparc/lib/atomic_64.S
index a5c5a0279..47db32c89 100644
--- a/arch/sparc/lib/atomic_64.S
+++ b/arch/sparc/lib/atomic_64.S
@@ -16,11 +16,22 @@
 	 * barriers.
 	 */
 
-#define ATOMIC_OP(op)							\
-ENTRY(atomic_##op) /* %o0 = increment, %o1 = atomic_ptr */		\
+#ifdef CONFIG_PAX_REFCOUNT
+#define __REFCOUNT_OP(op) op##cc
+#define __OVERFLOW_IOP tvs	%icc, 6;
+#define __OVERFLOW_XOP tvs	%xcc, 6;
+#else
+#define __REFCOUNT_OP(op) op
+#define __OVERFLOW_IOP
+#define __OVERFLOW_XOP
+#endif
+
+#define __ATOMIC_OP(op, suffix, asm_op, post_op)			\
+ENTRY(atomic_##op##suffix) /* %o0 = increment, %o1 = atomic_ptr */	\
 	BACKOFF_SETUP(%o2);						\
 1:	lduw	[%o1], %g1;						\
-	op	%g1, %o0, %g7;						\
+	asm_op	%g1, %o0, %g7;						\
+	post_op								\
 	cas	[%o1], %g1, %g7;					\
 	cmp	%g1, %g7;						\
 	bne,pn	%icc, BACKOFF_LABEL(2f, 1b);				\
@@ -28,13 +39,17 @@ ENTRY(atomic_##op) /* %o0 = increment, %o1 = atomic_ptr */		\
 	retl;								\
 	 nop;								\
 2:	BACKOFF_SPIN(%o2, %o3, 1b);					\
-ENDPROC(atomic_##op);							\
+ENDPROC(atomic_##op##suffix);
+
+#define ATOMIC_OP(op) __ATOMIC_OP(op, , op, ) \
+		      __ATOMIC_OP(op, _unchecked, __REFCOUNT_OP(op), __OVERFLOW_IOP)
 
-#define ATOMIC_OP_RETURN(op)						\
-ENTRY(atomic_##op##_return) /* %o0 = increment, %o1 = atomic_ptr */	\
+#define __ATOMIC_OP_RETURN(op, suffix, asm_op, post_op)			\
+ENTRY(atomic_##op##_return##suffix) /* %o0 = increment, %o1 = atomic_ptr */\
 	BACKOFF_SETUP(%o2);						\
 1:	lduw	[%o1], %g1;						\
-	op	%g1, %o0, %g7;						\
+	asm_op	%g1, %o0, %g7;						\
+	post_op								\
 	cas	[%o1], %g1, %g7;					\
 	cmp	%g1, %g7;						\
 	bne,pn	%icc, BACKOFF_LABEL(2f, 1b);				\
@@ -42,7 +57,10 @@ ENTRY(atomic_##op##_return) /* %o0 = increment, %o1 = atomic_ptr */	\
 	retl;								\
 	 sra	%g1, 0, %o0;						\
 2:	BACKOFF_SPIN(%o2, %o3, 1b);					\
-ENDPROC(atomic_##op##_return);
+ENDPROC(atomic_##op##_return##suffix);
+
+#define ATOMIC_OP_RETURN(op) __ATOMIC_OP_RETURN(op, , op, ) \
+			     __ATOMIC_OP_RETURN(op, _unchecked, __REFCOUNT_OP(op), __OVERFLOW_IOP)
 
 #define ATOMIC_FETCH_OP(op)						\
 ENTRY(atomic_fetch_##op) /* %o0 = increment, %o1 = atomic_ptr */	\
@@ -73,13 +91,16 @@ ATOMIC_OPS(xor)
 #undef ATOMIC_OPS
 #undef ATOMIC_FETCH_OP
 #undef ATOMIC_OP_RETURN
+#undef __ATOMIC_OP_RETURN
 #undef ATOMIC_OP
+#undef __ATOMIC_OP
 
-#define ATOMIC64_OP(op)							\
-ENTRY(atomic64_##op) /* %o0 = increment, %o1 = atomic_ptr */		\
+#define __ATOMIC64_OP(op, suffix, asm_op, post_op)			\
+ENTRY(atomic64_##op##suffix) /* %o0 = increment, %o1 = atomic_ptr */	\
 	BACKOFF_SETUP(%o2);						\
 1:	ldx	[%o1], %g1;						\
-	op	%g1, %o0, %g7;						\
+	asm_op	%g1, %o0, %g7;						\
+	post_op								\
 	casx	[%o1], %g1, %g7;					\
 	cmp	%g1, %g7;						\
 	bne,pn	%xcc, BACKOFF_LABEL(2f, 1b);				\
@@ -87,13 +108,17 @@ ENTRY(atomic64_##op) /* %o0 = increment, %o1 = atomic_ptr */		\
 	retl;								\
 	 nop;								\
 2:	BACKOFF_SPIN(%o2, %o3, 1b);					\
-ENDPROC(atomic64_##op);							\
+ENDPROC(atomic64_##op##suffix);
+
+#define ATOMIC64_OP(op) __ATOMIC64_OP(op, , op, ) \
+			__ATOMIC64_OP(op, _unchecked, __REFCOUNT_OP(op), __OVERFLOW_XOP)
 
-#define ATOMIC64_OP_RETURN(op)						\
-ENTRY(atomic64_##op##_return) /* %o0 = increment, %o1 = atomic_ptr */	\
+#define __ATOMIC64_OP_RETURN(op, suffix, asm_op, post_op)		\
+ENTRY(atomic64_##op##_return##suffix) /* %o0 = increment, %o1 = atomic_ptr */\
 	BACKOFF_SETUP(%o2);						\
 1:	ldx	[%o1], %g1;						\
-	op	%g1, %o0, %g7;						\
+	asm_op	%g1, %o0, %g7;						\
+	post_op								\
 	casx	[%o1], %g1, %g7;					\
 	cmp	%g1, %g7;						\
 	bne,pn	%xcc, BACKOFF_LABEL(2f, 1b);				\
@@ -101,7 +126,10 @@ ENTRY(atomic64_##op##_return) /* %o0 = increment, %o1 = atomic_ptr */	\
 	retl;								\
 	 op	%g1, %o0, %o0;						\
 2:	BACKOFF_SPIN(%o2, %o3, 1b);					\
-ENDPROC(atomic64_##op##_return);
+ENDPROC(atomic64_##op##_return##suffix);
+
+#define ATOMIC64_OP_RETURN(op) __ATOMIC64_OP_RETURN(op, , op, ) \
+			       __ATOMIC64_OP_RETURN(op, _unchecked, __REFCOUNT_OP(op), __OVERFLOW_XOP)
 
 #define ATOMIC64_FETCH_OP(op)						\
 ENTRY(atomic64_fetch_##op) /* %o0 = increment, %o1 = atomic_ptr */	\
@@ -132,7 +160,12 @@ ATOMIC64_OPS(xor)
 #undef ATOMIC64_OPS
 #undef ATOMIC64_FETCH_OP
 #undef ATOMIC64_OP_RETURN
+#undef __ATOMIC64_OP_RETURN
 #undef ATOMIC64_OP
+#undef __ATOMIC64_OP
+#undef __OVERFLOW_XOP
+#undef __OVERFLOW_IOP
+#undef __REFCOUNT_OP
 
 ENTRY(atomic64_dec_if_positive) /* %o0 = atomic_ptr */
 	BACKOFF_SETUP(%o2)
diff --git a/arch/sparc/lib/ksyms.c b/arch/sparc/lib/ksyms.c
index de5e97817..cf4885460 100644
--- a/arch/sparc/lib/ksyms.c
+++ b/arch/sparc/lib/ksyms.c
@@ -101,7 +101,9 @@ EXPORT_SYMBOL(__clear_user);
 /* Atomic counter implementation. */
 #define ATOMIC_OP(op)							\
 EXPORT_SYMBOL(atomic_##op);						\
-EXPORT_SYMBOL(atomic64_##op);
+EXPORT_SYMBOL(atomic_##op##_unchecked);					\
+EXPORT_SYMBOL(atomic64_##op);						\
+EXPORT_SYMBOL(atomic64_##op##_unchecked);
 
 #define ATOMIC_OP_RETURN(op)						\
 EXPORT_SYMBOL(atomic_##op##_return);					\
@@ -114,6 +116,8 @@ EXPORT_SYMBOL(atomic64_fetch_##op);
 #define ATOMIC_OPS(op) ATOMIC_OP(op) ATOMIC_OP_RETURN(op) ATOMIC_FETCH_OP(op)
 
 ATOMIC_OPS(add)
+EXPORT_SYMBOL(atomic_add_return_unchecked);
+EXPORT_SYMBOL(atomic64_add_return_unchecked);
 ATOMIC_OPS(sub)
 
 #undef ATOMIC_OPS
diff --git a/arch/sparc/mm/Makefile b/arch/sparc/mm/Makefile
index 30c3eccfd..736f015d4 100644
--- a/arch/sparc/mm/Makefile
+++ b/arch/sparc/mm/Makefile
@@ -2,7 +2,7 @@
 #
 
 asflags-y := -ansi
-ccflags-y := -Werror
+#ccflags-y := -Werror
 
 obj-$(CONFIG_SPARC64)   += ultra.o tlb.o tsb.o gup.o
 obj-y                   += fault_$(BITS).o
diff --git a/arch/sparc/mm/fault_32.c b/arch/sparc/mm/fault_32.c
index 4714061d6..bad7f9ada 100644
--- a/arch/sparc/mm/fault_32.c
+++ b/arch/sparc/mm/fault_32.c
@@ -22,6 +22,9 @@
 #include <linux/interrupt.h>
 #include <linux/kdebug.h>
 #include <linux/uaccess.h>
+#include <linux/slab.h>
+#include <linux/pagemap.h>
+#include <linux/compiler.h>
 
 #include <asm/page.h>
 #include <asm/pgtable.h>
@@ -156,6 +159,277 @@ static unsigned long compute_si_addr(struct pt_regs *regs, int text_fault)
 	return safe_compute_effective_address(regs, insn);
 }
 
+#ifdef CONFIG_PAX_PAGEEXEC
+#ifdef CONFIG_PAX_DLRESOLVE
+static void pax_emuplt_close(struct vm_area_struct *vma)
+{
+	vma->vm_mm->call_dl_resolve = 0UL;
+}
+
+static int pax_emuplt_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
+{
+	unsigned int *kaddr;
+
+	vmf->page = alloc_page(GFP_HIGHUSER);
+	if (!vmf->page)
+		return VM_FAULT_OOM;
+
+	kaddr = kmap(vmf->page);
+	memset(kaddr, 0, PAGE_SIZE);
+	kaddr[0] = 0x9DE3BFA8U; /* save */
+	flush_dcache_page(vmf->page);
+	kunmap(vmf->page);
+	return VM_FAULT_MAJOR;
+}
+
+static const struct vm_operations_struct pax_vm_ops = {
+	.close = pax_emuplt_close,
+	.fault = pax_emuplt_fault
+};
+
+static int pax_insert_vma(struct vm_area_struct *vma, unsigned long addr)
+{
+	int ret;
+
+	INIT_LIST_HEAD(&vma->anon_vma_chain);
+	vma->vm_mm = current->mm;
+	vma->vm_start = addr;
+	vma->vm_end = addr + PAGE_SIZE;
+	vma->vm_flags = VM_READ | VM_EXEC | VM_MAYREAD | VM_MAYEXEC;
+	vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
+	vma->vm_ops = &pax_vm_ops;
+
+	ret = insert_vm_struct(current->mm, vma);
+	if (ret)
+		return ret;
+
+	++current->mm->total_vm;
+	return 0;
+}
+#endif
+
+/*
+ * PaX: decide what to do with offenders (regs->pc = fault address)
+ *
+ * returns 1 when task should be killed
+ *         2 when patched PLT trampoline was detected
+ *         3 when unpatched PLT trampoline was detected
+ */
+static int pax_handle_fetch_fault(struct pt_regs *regs)
+{
+
+#ifdef CONFIG_PAX_EMUPLT
+	int err;
+
+	do { /* PaX: patched PLT emulation #1 */
+		unsigned int sethi1, sethi2, jmpl;
+
+		err = get_user(sethi1, (unsigned int *)regs->pc);
+		err |= get_user(sethi2, (unsigned int *)(regs->pc+4));
+		err |= get_user(jmpl, (unsigned int *)(regs->pc+8));
+
+		if (err)
+			break;
+
+		if ((sethi1 & 0xFFC00000U) == 0x03000000U &&
+		    (sethi2 & 0xFFC00000U) == 0x03000000U &&
+		    (jmpl & 0xFFFFE000U) == 0x81C06000U)
+		{
+			unsigned int addr;
+
+			regs->u_regs[UREG_G1] = (sethi2 & 0x003FFFFFU) << 10;
+			addr = regs->u_regs[UREG_G1];
+			addr += (((jmpl | 0xFFFFE000U) ^ 0x00001000U) + 0x00001000U);
+			regs->pc = addr;
+			regs->npc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #2 */
+		unsigned int ba;
+
+		err = get_user(ba, (unsigned int *)regs->pc);
+
+		if (err)
+			break;
+
+		if ((ba & 0xFFC00000U) == 0x30800000U || (ba & 0xFFF80000U) == 0x30480000U) {
+			unsigned int addr;
+
+			if ((ba & 0xFFC00000U) == 0x30800000U)
+				addr = regs->pc + ((((ba | 0xFFC00000U) ^ 0x00200000U) + 0x00200000U) << 2);
+			else
+				addr = regs->pc + ((((ba | 0xFFF80000U) ^ 0x00040000U) + 0x00040000U) << 2);
+			regs->pc = addr;
+			regs->npc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #3 */
+		unsigned int sethi, bajmpl, nop;
+
+		err = get_user(sethi, (unsigned int *)regs->pc);
+		err |= get_user(bajmpl, (unsigned int *)(regs->pc+4));
+		err |= get_user(nop, (unsigned int *)(regs->pc+8));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    ((bajmpl & 0xFFFFE000U) == 0x81C06000U || (bajmpl & 0xFFF80000U) == 0x30480000U) &&
+		    nop == 0x01000000U)
+		{
+			unsigned int addr;
+
+			addr = (sethi & 0x003FFFFFU) << 10;
+			regs->u_regs[UREG_G1] = addr;
+			if ((bajmpl & 0xFFFFE000U) == 0x81C06000U)
+				addr += (((bajmpl | 0xFFFFE000U) ^ 0x00001000U) + 0x00001000U);
+			else
+				addr = regs->pc + ((((bajmpl | 0xFFF80000U) ^ 0x00040000U) + 0x00040000U) << 2);
+			regs->pc = addr;
+			regs->npc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: unpatched PLT emulation step 1 */
+		unsigned int sethi, ba, nop;
+
+		err = get_user(sethi, (unsigned int *)regs->pc);
+		err |= get_user(ba, (unsigned int *)(regs->pc+4));
+		err |= get_user(nop, (unsigned int *)(regs->pc+8));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    ((ba & 0xFFC00000U) == 0x30800000U || (ba & 0xFFF80000U) == 0x30680000U) &&
+		    nop == 0x01000000U)
+		{
+			unsigned int addr, save, call;
+
+			if ((ba & 0xFFC00000U) == 0x30800000U)
+				addr = regs->pc + 4 + ((((ba | 0xFFC00000U) ^ 0x00200000U) + 0x00200000U) << 2);
+			else
+				addr = regs->pc + 4 + ((((ba | 0xFFF80000U) ^ 0x00040000U) + 0x00040000U) << 2);
+
+			err = get_user(save, (unsigned int *)addr);
+			err |= get_user(call, (unsigned int *)(addr+4));
+			err |= get_user(nop, (unsigned int *)(addr+8));
+			if (err)
+				break;
+
+#ifdef CONFIG_PAX_DLRESOLVE
+			if (save == 0x9DE3BFA8U &&
+			    (call & 0xC0000000U) == 0x40000000U &&
+			    nop == 0x01000000U)
+			{
+				struct vm_area_struct *vma;
+				unsigned long call_dl_resolve;
+
+				down_read(&current->mm->mmap_sem);
+				call_dl_resolve = current->mm->call_dl_resolve;
+				up_read(&current->mm->mmap_sem);
+				if (likely(call_dl_resolve))
+					goto emulate;
+
+				vma = kmem_cache_zalloc(vm_area_cachep, GFP_KERNEL);
+
+				down_write(&current->mm->mmap_sem);
+				if (current->mm->call_dl_resolve) {
+					call_dl_resolve = current->mm->call_dl_resolve;
+					up_write(&current->mm->mmap_sem);
+					if (vma)
+						kmem_cache_free(vm_area_cachep, vma);
+					goto emulate;
+				}
+
+				call_dl_resolve = get_unmapped_area(NULL, 0UL, PAGE_SIZE, 0UL, MAP_PRIVATE);
+				if (!vma || (call_dl_resolve & ~PAGE_MASK)) {
+					up_write(&current->mm->mmap_sem);
+					if (vma)
+						kmem_cache_free(vm_area_cachep, vma);
+					return 1;
+				}
+
+				if (pax_insert_vma(vma, call_dl_resolve)) {
+					up_write(&current->mm->mmap_sem);
+					kmem_cache_free(vm_area_cachep, vma);
+					return 1;
+				}
+
+				current->mm->call_dl_resolve = call_dl_resolve;
+				up_write(&current->mm->mmap_sem);
+
+emulate:
+				regs->u_regs[UREG_G1] = (sethi & 0x003FFFFFU) << 10;
+				regs->pc = call_dl_resolve;
+				regs->npc = addr+4;
+				return 3;
+			}
+#endif
+
+			/* PaX: glibc 2.4+ generates sethi/jmpl instead of save/call */
+			if ((save & 0xFFC00000U) == 0x05000000U &&
+			    (call & 0xFFFFE000U) == 0x85C0A000U &&
+			    nop == 0x01000000U)
+			{
+				regs->u_regs[UREG_G1] = (sethi & 0x003FFFFFU) << 10;
+				regs->u_regs[UREG_G2] = addr + 4;
+				addr = (save & 0x003FFFFFU) << 10;
+				addr += (((call | 0xFFFFE000U) ^ 0x00001000U) + 0x00001000U);
+				regs->pc = addr;
+				regs->npc = addr+4;
+				return 3;
+			}
+		}
+	} while (0);
+
+	do { /* PaX: unpatched PLT emulation step 2 */
+		unsigned int save, call, nop;
+
+		err = get_user(save, (unsigned int *)(regs->pc-4));
+		err |= get_user(call, (unsigned int *)regs->pc);
+		err |= get_user(nop, (unsigned int *)(regs->pc+4));
+		if (err)
+			break;
+
+		if (save == 0x9DE3BFA8U &&
+		    (call & 0xC0000000U) == 0x40000000U &&
+		    nop == 0x01000000U)
+		{
+			unsigned int dl_resolve = regs->pc + ((((call | 0xC0000000U) ^ 0x20000000U) + 0x20000000U) << 2);
+
+			regs->u_regs[UREG_RETPC] = regs->pc;
+			regs->pc = dl_resolve;
+			regs->npc = dl_resolve+4;
+			return 3;
+		}
+	} while (0);
+#endif
+
+	return 1;
+}
+
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 8; i++) {
+		unsigned int c;
+		if (get_user(c, (unsigned int *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08x ", c);
+	}
+	printk("\n");
+}
+#endif
+
 static noinline void do_fault_siginfo(int code, int sig, struct pt_regs *regs,
 				      int text_fault)
 {
@@ -226,6 +500,24 @@ good_area:
 		if (!(vma->vm_flags & VM_WRITE))
 			goto bad_area;
 	} else {
+
+#ifdef CONFIG_PAX_PAGEEXEC
+		if ((mm->pax_flags & MF_PAX_PAGEEXEC) && text_fault && !(vma->vm_flags & VM_EXEC)) {
+			up_read(&mm->mmap_sem);
+			switch (pax_handle_fetch_fault(regs)) {
+
+#ifdef CONFIG_PAX_EMUPLT
+			case 2:
+			case 3:
+				return;
+#endif
+
+			}
+			pax_report_fault(regs, (void *)regs->pc, (void *)regs->u_regs[UREG_FP]);
+			do_group_exit(SIGKILL);
+		}
+#endif
+
 		/* Allow reads even for write-only mappings */
 		if (!(vma->vm_flags & (VM_READ | VM_EXEC)))
 			goto bad_area;
diff --git a/arch/sparc/mm/fault_64.c b/arch/sparc/mm/fault_64.c
index 3f291d8c5..b33533894 100644
--- a/arch/sparc/mm/fault_64.c
+++ b/arch/sparc/mm/fault_64.c
@@ -23,6 +23,9 @@
 #include <linux/percpu.h>
 #include <linux/context_tracking.h>
 #include <linux/uaccess.h>
+#include <linux/slab.h>
+#include <linux/pagemap.h>
+#include <linux/compiler.h>
 
 #include <asm/page.h>
 #include <asm/pgtable.h>
@@ -76,7 +79,7 @@ static void __kprobes bad_kernel_pc(struct pt_regs *regs, unsigned long vaddr)
 	printk(KERN_CRIT "OOPS: Bogus kernel PC [%016lx] in fault handler\n",
 	       regs->tpc);
 	printk(KERN_CRIT "OOPS: RPC [%016lx]\n", regs->u_regs[15]);
-	printk("OOPS: RPC <%pS>\n", (void *) regs->u_regs[15]);
+	printk("OOPS: RPC <%pA>\n", (void *) regs->u_regs[15]);
 	printk(KERN_CRIT "OOPS: Fault was to vaddr[%lx]\n", vaddr);
 	dump_stack();
 	unhandled_fault(regs->tpc, current, regs);
@@ -276,6 +279,466 @@ static void noinline __kprobes bogus_32bit_fault_tpc(struct pt_regs *regs)
 	show_regs(regs);
 }
 
+#ifdef CONFIG_PAX_PAGEEXEC
+#ifdef CONFIG_PAX_DLRESOLVE
+static void pax_emuplt_close(struct vm_area_struct *vma)
+{
+	vma->vm_mm->call_dl_resolve = 0UL;
+}
+
+static int pax_emuplt_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
+{
+	unsigned int *kaddr;
+
+	vmf->page = alloc_page(GFP_HIGHUSER);
+	if (!vmf->page)
+		return VM_FAULT_OOM;
+
+	kaddr = kmap(vmf->page);
+	memset(kaddr, 0, PAGE_SIZE);
+	kaddr[0] = 0x9DE3BFA8U; /* save */
+	flush_dcache_page(vmf->page);
+	kunmap(vmf->page);
+	return VM_FAULT_MAJOR;
+}
+
+static const struct vm_operations_struct pax_vm_ops = {
+	.close = pax_emuplt_close,
+	.fault = pax_emuplt_fault
+};
+
+static int pax_insert_vma(struct vm_area_struct *vma, unsigned long addr)
+{
+	int ret;
+
+	INIT_LIST_HEAD(&vma->anon_vma_chain);
+	vma->vm_mm = current->mm;
+	vma->vm_start = addr;
+	vma->vm_end = addr + PAGE_SIZE;
+	vma->vm_flags = VM_READ | VM_EXEC | VM_MAYREAD | VM_MAYEXEC;
+	vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
+	vma->vm_ops = &pax_vm_ops;
+
+	ret = insert_vm_struct(current->mm, vma);
+	if (ret)
+		return ret;
+
+	++current->mm->total_vm;
+	return 0;
+}
+#endif
+
+/*
+ * PaX: decide what to do with offenders (regs->tpc = fault address)
+ *
+ * returns 1 when task should be killed
+ *         2 when patched PLT trampoline was detected
+ *         3 when unpatched PLT trampoline was detected
+ */
+static int pax_handle_fetch_fault(struct pt_regs *regs)
+{
+
+#ifdef CONFIG_PAX_EMUPLT
+	int err;
+
+	do { /* PaX: patched PLT emulation #1 */
+		unsigned int sethi1, sethi2, jmpl;
+
+		err = get_user(sethi1, (unsigned int *)regs->tpc);
+		err |= get_user(sethi2, (unsigned int *)(regs->tpc+4));
+		err |= get_user(jmpl, (unsigned int *)(regs->tpc+8));
+
+		if (err)
+			break;
+
+		if ((sethi1 & 0xFFC00000U) == 0x03000000U &&
+		    (sethi2 & 0xFFC00000U) == 0x03000000U &&
+		    (jmpl & 0xFFFFE000U) == 0x81C06000U)
+		{
+			unsigned long addr;
+
+			regs->u_regs[UREG_G1] = (sethi2 & 0x003FFFFFU) << 10;
+			addr = regs->u_regs[UREG_G1];
+			addr += (((jmpl | 0xFFFFFFFFFFFFE000UL) ^ 0x00001000UL) + 0x00001000UL);
+
+			if (test_thread_flag(TIF_32BIT))
+				addr &= 0xFFFFFFFFUL;
+
+			regs->tpc = addr;
+			regs->tnpc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #2 */
+		unsigned int ba;
+
+		err = get_user(ba, (unsigned int *)regs->tpc);
+
+		if (err)
+			break;
+
+		if ((ba & 0xFFC00000U) == 0x30800000U || (ba & 0xFFF80000U) == 0x30480000U) {
+			unsigned long addr;
+
+			if ((ba & 0xFFC00000U) == 0x30800000U)
+				addr = regs->tpc + ((((ba | 0xFFFFFFFFFFC00000UL) ^ 0x00200000UL) + 0x00200000UL) << 2);
+			else
+				addr = regs->tpc + ((((ba | 0xFFFFFFFFFFF80000UL) ^ 0x00040000UL) + 0x00040000UL) << 2);
+
+			if (test_thread_flag(TIF_32BIT))
+				addr &= 0xFFFFFFFFUL;
+
+			regs->tpc = addr;
+			regs->tnpc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #3 */
+		unsigned int sethi, bajmpl, nop;
+
+		err = get_user(sethi, (unsigned int *)regs->tpc);
+		err |= get_user(bajmpl, (unsigned int *)(regs->tpc+4));
+		err |= get_user(nop, (unsigned int *)(regs->tpc+8));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    ((bajmpl & 0xFFFFE000U) == 0x81C06000U || (bajmpl & 0xFFF80000U) == 0x30480000U) &&
+		    nop == 0x01000000U)
+		{
+			unsigned long addr;
+
+			addr = (sethi & 0x003FFFFFU) << 10;
+			regs->u_regs[UREG_G1] = addr;
+			if ((bajmpl & 0xFFFFE000U) == 0x81C06000U)
+				addr += (((bajmpl | 0xFFFFFFFFFFFFE000UL) ^ 0x00001000UL) + 0x00001000UL);
+			else
+				addr = regs->tpc + ((((bajmpl | 0xFFFFFFFFFFF80000UL) ^ 0x00040000UL) + 0x00040000UL) << 2);
+
+			if (test_thread_flag(TIF_32BIT))
+				addr &= 0xFFFFFFFFUL;
+
+			regs->tpc = addr;
+			regs->tnpc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #4 */
+		unsigned int sethi, mov1, call, mov2;
+
+		err = get_user(sethi, (unsigned int *)regs->tpc);
+		err |= get_user(mov1, (unsigned int *)(regs->tpc+4));
+		err |= get_user(call, (unsigned int *)(regs->tpc+8));
+		err |= get_user(mov2, (unsigned int *)(regs->tpc+12));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    mov1 == 0x8210000FU &&
+		    (call & 0xC0000000U) == 0x40000000U &&
+		    mov2 == 0x9E100001U)
+		{
+			unsigned long addr;
+
+			regs->u_regs[UREG_G1] = regs->u_regs[UREG_RETPC];
+			addr = regs->tpc + 4 + ((((call | 0xFFFFFFFFC0000000UL) ^ 0x20000000UL) + 0x20000000UL) << 2);
+
+			if (test_thread_flag(TIF_32BIT))
+				addr &= 0xFFFFFFFFUL;
+
+			regs->tpc = addr;
+			regs->tnpc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #5 */
+		unsigned int sethi, sethi1, sethi2, or1, or2, sllx, jmpl, nop;
+
+		err = get_user(sethi, (unsigned int *)regs->tpc);
+		err |= get_user(sethi1, (unsigned int *)(regs->tpc+4));
+		err |= get_user(sethi2, (unsigned int *)(regs->tpc+8));
+		err |= get_user(or1, (unsigned int *)(regs->tpc+12));
+		err |= get_user(or2, (unsigned int *)(regs->tpc+16));
+		err |= get_user(sllx, (unsigned int *)(regs->tpc+20));
+		err |= get_user(jmpl, (unsigned int *)(regs->tpc+24));
+		err |= get_user(nop, (unsigned int *)(regs->tpc+28));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    (sethi1 & 0xFFC00000U) == 0x03000000U &&
+		    (sethi2 & 0xFFC00000U) == 0x0B000000U &&
+		    (or1 & 0xFFFFE000U) == 0x82106000U &&
+		    (or2 & 0xFFFFE000U) == 0x8A116000U &&
+		    sllx == 0x83287020U &&
+		    jmpl == 0x81C04005U &&
+		    nop == 0x01000000U)
+		{
+			unsigned long addr;
+
+			regs->u_regs[UREG_G1] = ((sethi1 & 0x003FFFFFU) << 10) | (or1 & 0x000003FFU);
+			regs->u_regs[UREG_G1] <<= 32;
+			regs->u_regs[UREG_G5] = ((sethi2 & 0x003FFFFFU) << 10) | (or2 & 0x000003FFU);
+			addr = regs->u_regs[UREG_G1] + regs->u_regs[UREG_G5];
+			regs->tpc = addr;
+			regs->tnpc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: patched PLT emulation #6 */
+		unsigned int sethi, sethi1, sethi2, sllx, or,  jmpl, nop;
+
+		err = get_user(sethi, (unsigned int *)regs->tpc);
+		err |= get_user(sethi1, (unsigned int *)(regs->tpc+4));
+		err |= get_user(sethi2, (unsigned int *)(regs->tpc+8));
+		err |= get_user(sllx, (unsigned int *)(regs->tpc+12));
+		err |= get_user(or, (unsigned int *)(regs->tpc+16));
+		err |= get_user(jmpl, (unsigned int *)(regs->tpc+20));
+		err |= get_user(nop, (unsigned int *)(regs->tpc+24));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    (sethi1 & 0xFFC00000U) == 0x03000000U &&
+		    (sethi2 & 0xFFC00000U) == 0x0B000000U &&
+		    sllx == 0x83287020U &&
+		    (or & 0xFFFFE000U) == 0x8A116000U &&
+		    jmpl == 0x81C04005U &&
+		    nop == 0x01000000U)
+		{
+			unsigned long addr;
+
+			regs->u_regs[UREG_G1] = (sethi1 & 0x003FFFFFU) << 10;
+			regs->u_regs[UREG_G1] <<= 32;
+			regs->u_regs[UREG_G5] = ((sethi2 & 0x003FFFFFU) << 10) | (or & 0x3FFU);
+			addr = regs->u_regs[UREG_G1] + regs->u_regs[UREG_G5];
+			regs->tpc = addr;
+			regs->tnpc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: unpatched PLT emulation step 1 */
+		unsigned int sethi, ba, nop;
+
+		err = get_user(sethi, (unsigned int *)regs->tpc);
+		err |= get_user(ba, (unsigned int *)(regs->tpc+4));
+		err |= get_user(nop, (unsigned int *)(regs->tpc+8));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    ((ba & 0xFFC00000U) == 0x30800000U || (ba & 0xFFF80000U) == 0x30680000U) &&
+		    nop == 0x01000000U)
+		{
+			unsigned long addr;
+			unsigned int save, call;
+			unsigned int sethi1, sethi2, or1, or2, sllx, add, jmpl;
+
+			if ((ba & 0xFFC00000U) == 0x30800000U)
+				addr = regs->tpc + 4 + ((((ba | 0xFFFFFFFFFFC00000UL) ^ 0x00200000UL) + 0x00200000UL) << 2);
+			else
+				addr = regs->tpc + 4 + ((((ba | 0xFFFFFFFFFFF80000UL) ^ 0x00040000UL) + 0x00040000UL) << 2);
+
+			if (test_thread_flag(TIF_32BIT))
+				addr &= 0xFFFFFFFFUL;
+
+			err = get_user(save, (unsigned int *)addr);
+			err |= get_user(call, (unsigned int *)(addr+4));
+			err |= get_user(nop, (unsigned int *)(addr+8));
+			if (err)
+				break;
+
+#ifdef CONFIG_PAX_DLRESOLVE
+			if (save == 0x9DE3BFA8U &&
+			    (call & 0xC0000000U) == 0x40000000U &&
+			    nop == 0x01000000U)
+			{
+				struct vm_area_struct *vma;
+				unsigned long call_dl_resolve;
+
+				down_read(&current->mm->mmap_sem);
+				call_dl_resolve = current->mm->call_dl_resolve;
+				up_read(&current->mm->mmap_sem);
+				if (likely(call_dl_resolve))
+					goto emulate;
+
+				vma = kmem_cache_zalloc(vm_area_cachep, GFP_KERNEL);
+
+				down_write(&current->mm->mmap_sem);
+				if (current->mm->call_dl_resolve) {
+					call_dl_resolve = current->mm->call_dl_resolve;
+					up_write(&current->mm->mmap_sem);
+					if (vma)
+						kmem_cache_free(vm_area_cachep, vma);
+					goto emulate;
+				}
+
+				call_dl_resolve = get_unmapped_area(NULL, 0UL, PAGE_SIZE, 0UL, MAP_PRIVATE);
+				if (!vma || (call_dl_resolve & ~PAGE_MASK)) {
+					up_write(&current->mm->mmap_sem);
+					if (vma)
+						kmem_cache_free(vm_area_cachep, vma);
+					return 1;
+				}
+
+				if (pax_insert_vma(vma, call_dl_resolve)) {
+					up_write(&current->mm->mmap_sem);
+					kmem_cache_free(vm_area_cachep, vma);
+					return 1;
+				}
+
+				current->mm->call_dl_resolve = call_dl_resolve;
+				up_write(&current->mm->mmap_sem);
+
+emulate:
+				regs->u_regs[UREG_G1] = (sethi & 0x003FFFFFU) << 10;
+				regs->tpc = call_dl_resolve;
+				regs->tnpc = addr+4;
+				return 3;
+			}
+#endif
+
+			/* PaX: glibc 2.4+ generates sethi/jmpl instead of save/call */
+			if ((save & 0xFFC00000U) == 0x05000000U &&
+			    (call & 0xFFFFE000U) == 0x85C0A000U &&
+			    nop == 0x01000000U)
+			{
+				regs->u_regs[UREG_G1] = (sethi & 0x003FFFFFU) << 10;
+				regs->u_regs[UREG_G2] = addr + 4;
+				addr = (save & 0x003FFFFFU) << 10;
+				addr += (((call | 0xFFFFFFFFFFFFE000UL) ^ 0x00001000UL) + 0x00001000UL);
+
+				if (test_thread_flag(TIF_32BIT))
+					addr &= 0xFFFFFFFFUL;
+
+				regs->tpc = addr;
+				regs->tnpc = addr+4;
+				return 3;
+			}
+
+			/* PaX: 64-bit PLT stub */
+			err = get_user(sethi1, (unsigned int *)addr);
+			err |= get_user(sethi2, (unsigned int *)(addr+4));
+			err |= get_user(or1, (unsigned int *)(addr+8));
+			err |= get_user(or2, (unsigned int *)(addr+12));
+			err |= get_user(sllx, (unsigned int *)(addr+16));
+			err |= get_user(add, (unsigned int *)(addr+20));
+			err |= get_user(jmpl, (unsigned int *)(addr+24));
+			err |= get_user(nop, (unsigned int *)(addr+28));
+			if (err)
+				break;
+
+			if ((sethi1 & 0xFFC00000U) == 0x09000000U &&
+			    (sethi2 & 0xFFC00000U) == 0x0B000000U &&
+			    (or1 & 0xFFFFE000U) == 0x88112000U &&
+			    (or2 & 0xFFFFE000U) == 0x8A116000U &&
+			    sllx == 0x89293020U &&
+			    add == 0x8A010005U &&
+			    jmpl == 0x89C14000U &&
+			    nop == 0x01000000U)
+			{
+				regs->u_regs[UREG_G1] = (sethi & 0x003FFFFFU) << 10;
+				regs->u_regs[UREG_G4] = ((sethi1 & 0x003FFFFFU) << 10) | (or1 & 0x000003FFU);
+				regs->u_regs[UREG_G4] <<= 32;
+				regs->u_regs[UREG_G5] = ((sethi2 & 0x003FFFFFU) << 10) | (or2 & 0x000003FFU);
+				regs->u_regs[UREG_G5] += regs->u_regs[UREG_G4];
+				regs->u_regs[UREG_G4] = addr + 24;
+				addr = regs->u_regs[UREG_G5];
+				regs->tpc = addr;
+				regs->tnpc = addr+4;
+				return 3;
+			}
+		}
+	} while (0);
+
+#ifdef CONFIG_PAX_DLRESOLVE
+	do { /* PaX: unpatched PLT emulation step 2 */
+		unsigned int save, call, nop;
+
+		err = get_user(save, (unsigned int *)(regs->tpc-4));
+		err |= get_user(call, (unsigned int *)regs->tpc);
+		err |= get_user(nop, (unsigned int *)(regs->tpc+4));
+		if (err)
+			break;
+
+		if (save == 0x9DE3BFA8U &&
+		    (call & 0xC0000000U) == 0x40000000U &&
+		    nop == 0x01000000U)
+		{
+			unsigned long dl_resolve = regs->tpc + ((((call | 0xFFFFFFFFC0000000UL) ^ 0x20000000UL) + 0x20000000UL) << 2);
+
+			if (test_thread_flag(TIF_32BIT))
+				dl_resolve &= 0xFFFFFFFFUL;
+
+			regs->u_regs[UREG_RETPC] = regs->tpc;
+			regs->tpc = dl_resolve;
+			regs->tnpc = dl_resolve+4;
+			return 3;
+		}
+	} while (0);
+#endif
+
+	do { /* PaX: patched PLT emulation #7, must be AFTER the unpatched PLT emulation */
+		unsigned int sethi, ba, nop;
+
+		err = get_user(sethi, (unsigned int *)regs->tpc);
+		err |= get_user(ba, (unsigned int *)(regs->tpc+4));
+		err |= get_user(nop, (unsigned int *)(regs->tpc+8));
+
+		if (err)
+			break;
+
+		if ((sethi & 0xFFC00000U) == 0x03000000U &&
+		    (ba & 0xFFF00000U) == 0x30600000U &&
+		    nop == 0x01000000U)
+		{
+			unsigned long addr;
+
+			addr = (sethi & 0x003FFFFFU) << 10;
+			regs->u_regs[UREG_G1] = addr;
+			addr = regs->tpc + ((((ba | 0xFFFFFFFFFFF80000UL) ^ 0x00040000UL) + 0x00040000UL) << 2);
+
+			if (test_thread_flag(TIF_32BIT))
+				addr &= 0xFFFFFFFFUL;
+
+			regs->tpc = addr;
+			regs->tnpc = addr+4;
+			return 2;
+		}
+	} while (0);
+
+#endif
+
+	return 1;
+}
+
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	unsigned long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 8; i++) {
+		unsigned int c;
+		if (get_user(c, (unsigned int *)pc+i))
+			printk(KERN_CONT "???????? ");
+		else
+			printk(KERN_CONT "%08x ", c);
+	}
+	printk("\n");
+}
+#endif
+
 asmlinkage void __kprobes do_sparc64_fault(struct pt_regs *regs)
 {
 	enum ctx_state prev_state = exception_enter();
@@ -350,6 +813,29 @@ retry:
 	if (!vma)
 		goto bad_area;
 
+#ifdef CONFIG_PAX_PAGEEXEC
+	/* PaX: detect ITLB misses on non-exec pages */
+	if ((mm->pax_flags & MF_PAX_PAGEEXEC) && vma->vm_start <= address &&
+	    !(vma->vm_flags & VM_EXEC) && (fault_code & FAULT_CODE_ITLB))
+	{
+		if (address != regs->tpc)
+			goto good_area;
+
+		up_read(&mm->mmap_sem);
+		switch (pax_handle_fetch_fault(regs)) {
+
+#ifdef CONFIG_PAX_EMUPLT
+		case 2:
+		case 3:
+			return;
+#endif
+
+		}
+		pax_report_fault(regs, (void *)regs->tpc, (void *)(regs->u_regs[UREG_FP] + STACK_BIAS));
+		do_group_exit(SIGKILL);
+	}
+#endif
+
 	/* Pure DTLB misses do not tell us whether the fault causing
 	 * load/store/atomic was a write or not, it only says that there
 	 * was no match.  So in such a case we (carefully) read the
diff --git a/arch/sparc/mm/hugetlbpage.c b/arch/sparc/mm/hugetlbpage.c
index 988acc8b1..f26345c45 100644
--- a/arch/sparc/mm/hugetlbpage.c
+++ b/arch/sparc/mm/hugetlbpage.c
@@ -26,8 +26,10 @@ static unsigned long hugetlb_get_unmapped_area_bottomup(struct file *filp,
 							unsigned long addr,
 							unsigned long len,
 							unsigned long pgoff,
-							unsigned long flags)
+							unsigned long flags,
+							unsigned long offset)
 {
+	struct mm_struct *mm = current->mm;
 	unsigned long task_size = TASK_SIZE;
 	struct vm_unmapped_area_info info;
 
@@ -36,15 +38,22 @@ static unsigned long hugetlb_get_unmapped_area_bottomup(struct file *filp,
 
 	info.flags = 0;
 	info.length = len;
-	info.low_limit = TASK_UNMAPPED_BASE;
+	info.low_limit = mm->mmap_base;
 	info.high_limit = min(task_size, VA_EXCLUDE_START);
 	info.align_mask = PAGE_MASK & ~HPAGE_MASK;
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 	if ((addr & ~PAGE_MASK) && task_size > VA_EXCLUDE_END) {
 		VM_BUG_ON(addr != -ENOMEM);
 		info.low_limit = VA_EXCLUDE_END;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += mm->delta_mmap;
+#endif
+
 		info.high_limit = task_size;
 		addr = vm_unmapped_area(&info);
 	}
@@ -53,10 +62,11 @@ static unsigned long hugetlb_get_unmapped_area_bottomup(struct file *filp,
 }
 
 static unsigned long
-hugetlb_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
-				  const unsigned long len,
-				  const unsigned long pgoff,
-				  const unsigned long flags)
+hugetlb_get_unmapped_area_topdown(struct file *filp, unsigned long addr0,
+				  unsigned long len,
+				  unsigned long pgoff,
+				  unsigned long flags,
+				  unsigned long offset)
 {
 	struct mm_struct *mm = current->mm;
 	unsigned long addr = addr0;
@@ -71,6 +81,7 @@ hugetlb_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	info.high_limit = mm->mmap_base;
 	info.align_mask = PAGE_MASK & ~HPAGE_MASK;
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 	/*
@@ -83,6 +94,12 @@ hugetlb_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		VM_BUG_ON(addr != -ENOMEM);
 		info.flags = 0;
 		info.low_limit = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += mm->delta_mmap;
+#endif
+
 		info.high_limit = STACK_TOP32;
 		addr = vm_unmapped_area(&info);
 	}
@@ -97,6 +114,7 @@ hugetlb_get_unmapped_area(struct file *file, unsigned long addr,
 	struct mm_struct *mm = current->mm;
 	struct vm_area_struct *vma;
 	unsigned long task_size = TASK_SIZE;
+	unsigned long offset = gr_rand_threadstack_offset(mm, file, flags);
 
 	if (test_thread_flag(TIF_32BIT))
 		task_size = STACK_TOP32;
@@ -112,19 +130,22 @@ hugetlb_get_unmapped_area(struct file *file, unsigned long addr,
 		return addr;
 	}
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		addr = ALIGN(addr, HPAGE_SIZE);
 		vma = find_vma(mm, addr);
-		if (task_size - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (task_size - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 	if (mm->get_unmapped_area == arch_get_unmapped_area)
 		return hugetlb_get_unmapped_area_bottomup(file, addr, len,
-				pgoff, flags);
+				pgoff, flags, offset);
 	else
 		return hugetlb_get_unmapped_area_topdown(file, addr, len,
-				pgoff, flags);
+				pgoff, flags, offset);
 }
 
 pte_t *huge_pte_alloc(struct mm_struct *mm,
diff --git a/arch/sparc/mm/init_64.c b/arch/sparc/mm/init_64.c
index 05c770825..222a5464b 100644
--- a/arch/sparc/mm/init_64.c
+++ b/arch/sparc/mm/init_64.c
@@ -189,9 +189,9 @@ unsigned long sparc64_kern_sec_context __read_mostly;
 int num_kernel_image_mappings;
 
 #ifdef CONFIG_DEBUG_DCFLUSH
-atomic_t dcpage_flushes = ATOMIC_INIT(0);
+atomic_unchecked_t dcpage_flushes = ATOMIC_INIT(0);
 #ifdef CONFIG_SMP
-atomic_t dcpage_flushes_xcall = ATOMIC_INIT(0);
+atomic_unchecked_t dcpage_flushes_xcall = ATOMIC_INIT(0);
 #endif
 #endif
 
@@ -199,7 +199,7 @@ inline void flush_dcache_page_impl(struct page *page)
 {
 	BUG_ON(tlb_type == hypervisor);
 #ifdef CONFIG_DEBUG_DCFLUSH
-	atomic_inc(&dcpage_flushes);
+	atomic_inc_unchecked(&dcpage_flushes);
 #endif
 
 #ifdef DCACHE_ALIASING_POSSIBLE
@@ -462,10 +462,10 @@ void mmu_info(struct seq_file *m)
 
 #ifdef CONFIG_DEBUG_DCFLUSH
 	seq_printf(m, "DCPageFlushes\t: %d\n",
-		   atomic_read(&dcpage_flushes));
+		   atomic_read_unchecked(&dcpage_flushes));
 #ifdef CONFIG_SMP
 	seq_printf(m, "DCPageFlushesXC\t: %d\n",
-		   atomic_read(&dcpage_flushes_xcall));
+		   atomic_read_unchecked(&dcpage_flushes_xcall));
 #endif /* CONFIG_SMP */
 #endif /* CONFIG_DEBUG_DCFLUSH */
 }
diff --git a/arch/tile/Kconfig b/arch/tile/Kconfig
index 78da75b67..264302daa 100644
--- a/arch/tile/Kconfig
+++ b/arch/tile/Kconfig
@@ -193,6 +193,7 @@ source "kernel/Kconfig.hz"
 config KEXEC
 	bool "kexec system call"
 	select KEXEC_CORE
+	depends on !GRKERNSEC_KMEM
 	---help---
 	  kexec is a system call that implements the ability to shutdown your
 	  current kernel, and to start another kernel.  It is like a reboot
diff --git a/arch/tile/include/asm/atomic_64.h b/arch/tile/include/asm/atomic_64.h
index 4cefa0c9f..98d8b8365 100644
--- a/arch/tile/include/asm/atomic_64.h
+++ b/arch/tile/include/asm/atomic_64.h
@@ -195,6 +195,16 @@ static inline long atomic64_add_unless(atomic64_t *v, long a, long u)
 
 #define atomic64_inc_not_zero(v)	atomic64_add_unless((v), 1, 0)
 
+#define atomic64_read_unchecked(v)		atomic64_read(v)
+#define atomic64_set_unchecked(v, i)		atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v)		atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v)	atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v)		atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v)		atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v)	atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v)		atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n)	atomic64_cmpxchg((v), (o), (n))
+
 #endif /* !__ASSEMBLY__ */
 
 #endif /* _ASM_TILE_ATOMIC_64_H */
diff --git a/arch/tile/include/asm/cache.h b/arch/tile/include/asm/cache.h
index 6160761d5..00cac88db 100644
--- a/arch/tile/include/asm/cache.h
+++ b/arch/tile/include/asm/cache.h
@@ -15,11 +15,12 @@
 #ifndef _ASM_TILE_CACHE_H
 #define _ASM_TILE_CACHE_H
 
+#include <linux/const.h>
 #include <arch/chip.h>
 
 /* bytes per L1 data cache line */
 #define L1_CACHE_SHIFT		CHIP_L1D_LOG_LINE_SIZE()
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 /* bytes per L2 cache line */
 #define L2_CACHE_SHIFT		CHIP_L2_LOG_LINE_SIZE()
diff --git a/arch/tile/include/asm/uaccess.h b/arch/tile/include/asm/uaccess.h
index a77369e91..7ba6ecd51 100644
--- a/arch/tile/include/asm/uaccess.h
+++ b/arch/tile/include/asm/uaccess.h
@@ -428,9 +428,9 @@ static inline unsigned long __must_check copy_from_user(void *to,
 					  const void __user *from,
 					  unsigned long n)
 {
-	int sz = __compiletime_object_size(to);
+	size_t sz = __compiletime_object_size(to);
 
-	if (likely(sz == -1 || sz >= n))
+	if (likely(sz == (size_t)-1 || sz >= n))
 		n = _copy_from_user(to, from, n);
 	else if (!__builtin_constant_p(n))
 		copy_user_overflow(sz, n);
diff --git a/arch/tile/mm/hugetlbpage.c b/arch/tile/mm/hugetlbpage.c
index 77ceaa343..3630dea00 100644
--- a/arch/tile/mm/hugetlbpage.c
+++ b/arch/tile/mm/hugetlbpage.c
@@ -174,6 +174,7 @@ static unsigned long hugetlb_get_unmapped_area_bottomup(struct file *file,
 	info.high_limit = TASK_SIZE;
 	info.align_mask = PAGE_MASK & ~huge_page_mask(h);
 	info.align_offset = 0;
+	info.threadstack_offset = 0;
 	return vm_unmapped_area(&info);
 }
 
@@ -191,6 +192,7 @@ static unsigned long hugetlb_get_unmapped_area_topdown(struct file *file,
 	info.high_limit = current->mm->mmap_base;
 	info.align_mask = PAGE_MASK & ~huge_page_mask(h);
 	info.align_offset = 0;
+	info.threadstack_offset = 0;
 	addr = vm_unmapped_area(&info);
 
 	/*
diff --git a/arch/um/Makefile b/arch/um/Makefile
index 0ca46eded..8d7fd38ec 100644
--- a/arch/um/Makefile
+++ b/arch/um/Makefile
@@ -73,6 +73,8 @@ USER_CFLAGS = $(patsubst $(KERNEL_DEFINES),,$(patsubst -I%,,$(KBUILD_CFLAGS))) \
 		-D_FILE_OFFSET_BITS=64 -idirafter $(srctree)/include \
 		-idirafter $(obj)/include -D__KERNEL__ -D__UM_HOST__
 
+USER_CFLAGS	:= $(filter-out $(GCC_PLUGINS_CFLAGS),$(USER_CFLAGS))
+
 #This will adjust *FLAGS accordingly to the platform.
 include $(ARCH_DIR)/Makefile-os-$(OS)
 
diff --git a/arch/um/include/asm/cache.h b/arch/um/include/asm/cache.h
index 19e1bdd67..3665b77a6 100644
--- a/arch/um/include/asm/cache.h
+++ b/arch/um/include/asm/cache.h
@@ -1,6 +1,7 @@
 #ifndef __UM_CACHE_H
 #define __UM_CACHE_H
 
+#include <linux/const.h>
 
 #if defined(CONFIG_UML_X86) && !defined(CONFIG_64BIT)
 # define L1_CACHE_SHIFT		(CONFIG_X86_L1_CACHE_SHIFT)
@@ -12,6 +13,6 @@
 # define L1_CACHE_SHIFT		5
 #endif
 
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #endif
diff --git a/arch/um/include/asm/kmap_types.h b/arch/um/include/asm/kmap_types.h
index 2e0a6b1d8..a64d0f53a 100644
--- a/arch/um/include/asm/kmap_types.h
+++ b/arch/um/include/asm/kmap_types.h
@@ -8,6 +8,6 @@
 
 /* No more #include "asm/arch/kmap_types.h" ! */
 
-#define KM_TYPE_NR 14
+#define KM_TYPE_NR 15
 
 #endif
diff --git a/arch/um/include/asm/page.h b/arch/um/include/asm/page.h
index f878bec23..ca0930054 100644
--- a/arch/um/include/asm/page.h
+++ b/arch/um/include/asm/page.h
@@ -14,6 +14,9 @@
 #define PAGE_SIZE	(_AC(1, UL) << PAGE_SHIFT)
 #define PAGE_MASK	(~(PAGE_SIZE-1))
 
+#define ktla_ktva(addr)			(addr)
+#define ktva_ktla(addr)			(addr)
+
 #ifndef __ASSEMBLY__
 
 struct page;
diff --git a/arch/um/include/asm/pgtable-3level.h b/arch/um/include/asm/pgtable-3level.h
index bae8523a1..ba9484b8f 100644
--- a/arch/um/include/asm/pgtable-3level.h
+++ b/arch/um/include/asm/pgtable-3level.h
@@ -58,6 +58,7 @@
 #define pud_present(x)	(pud_val(x) & _PAGE_PRESENT)
 #define pud_populate(mm, pud, pmd) \
 	set_pud(pud, __pud(_PAGE_TABLE + __pa(pmd)))
+#define pud_populate_kernel(mm, pud, pmd) pud_populate((mm), (pud), (pmd))
 
 #ifdef CONFIG_64BIT
 #define set_pud(pudptr, pudval) set_64bit((u64 *) (pudptr), pud_val(pudval))
diff --git a/arch/um/kernel/process.c b/arch/um/kernel/process.c
index 034b42c7a..5c186ce90 100644
--- a/arch/um/kernel/process.c
+++ b/arch/um/kernel/process.c
@@ -343,22 +343,6 @@ int singlestepping(void * t)
 	return 2;
 }
 
-/*
- * Only x86 and x86_64 have an arch_align_stack().
- * All other arches have "#define arch_align_stack(x) (x)"
- * in their asm/exec.h
- * As this is included in UML from asm-um/system-generic.h,
- * we can use it to behave as the subarch does.
- */
-#ifndef arch_align_stack
-unsigned long arch_align_stack(unsigned long sp)
-{
-	if (!(current->personality & ADDR_NO_RANDOMIZE) && randomize_va_space)
-		sp -= get_random_int() % 8192;
-	return sp & ~0xf;
-}
-#endif
-
 unsigned long get_wchan(struct task_struct *p)
 {
 	unsigned long stack_page, sp, ip;
diff --git a/arch/unicore32/include/asm/cache.h b/arch/unicore32/include/asm/cache.h
index ad8f795d8..2c7eec635 100644
--- a/arch/unicore32/include/asm/cache.h
+++ b/arch/unicore32/include/asm/cache.h
@@ -12,8 +12,10 @@
 #ifndef __UNICORE_CACHE_H__
 #define __UNICORE_CACHE_H__
 
-#define L1_CACHE_SHIFT		(5)
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#include <linux/const.h>
+
+#define L1_CACHE_SHIFT		5
+#define L1_CACHE_BYTES		(_AC(1,UL) << L1_CACHE_SHIFT)
 
 /*
  * Memory returned by kmalloc() may be used for DMA, so we must make
diff --git a/arch/x86/Kconfig b/arch/x86/Kconfig
index 2a1f0ce7c..ca2cc51da 100644
--- a/arch/x86/Kconfig
+++ b/arch/x86/Kconfig
@@ -39,14 +39,13 @@ config X86
 	select ARCH_MIGHT_HAVE_PC_SERIO
 	select ARCH_SUPPORTS_ATOMIC_RMW
 	select ARCH_SUPPORTS_DEFERRED_STRUCT_PAGE_INIT
-	select ARCH_SUPPORTS_INT128		if X86_64
+	select ARCH_SUPPORTS_INT128		if X86_64 && !PAX_SIZE_OVERFLOW_EXTRA && !PAX_SIZE_OVERFLOW
 	select ARCH_SUPPORTS_NUMA_BALANCING	if X86_64
 	select ARCH_USE_BUILTIN_BSWAP
 	select ARCH_USE_CMPXCHG_LOCKREF		if X86_64
 	select ARCH_USE_QUEUED_RWLOCKS
 	select ARCH_USE_QUEUED_SPINLOCKS
 	select ARCH_WANT_BATCHED_UNMAP_TLB_FLUSH if SMP
-	select ARCH_WANTS_DYNAMIC_TASK_STRUCT
 	select ARCH_WANT_FRAME_POINTERS
 	select ARCH_WANT_IPC_PARSE_VERSION	if X86_32
 	select BUILDTIME_EXTABLE_SORT
@@ -93,7 +92,7 @@ config X86
 	select HAVE_ARCH_TRANSPARENT_HUGEPAGE
 	select HAVE_ARCH_WITHIN_STACK_FRAMES
 	select HAVE_EBPF_JIT			if X86_64
-	select HAVE_CC_STACKPROTECTOR
+	select HAVE_CC_STACKPROTECTOR		if X86_64 || !PAX_MEMORY_UDEREF
 	select HAVE_CMPXCHG_DOUBLE
 	select HAVE_CMPXCHG_LOCAL
 	select HAVE_CONTEXT_TRACKING		if X86_64
@@ -136,6 +135,7 @@ config X86
 	select HAVE_NMI
 	select HAVE_OPROFILE
 	select HAVE_OPTPROBES
+	select HAVE_PAX_INITIFY_INIT_EXIT if GCC_PLUGINS
 	select HAVE_PCSPKR_PLATFORM
 	select HAVE_PERF_EVENTS
 	select HAVE_PERF_EVENTS_NMI
@@ -189,11 +189,13 @@ config MMU
 	def_bool y
 
 config ARCH_MMAP_RND_BITS_MIN
-	default 28 if 64BIT
+	default 28 if 64BIT && !PAX_PER_CPU_PGD
+	default 27 if 64BIT && PAX_PER_CPU_PGD
 	default 8
 
 config ARCH_MMAP_RND_BITS_MAX
-	default 32 if 64BIT
+	default 32 if 64BIT && !PAX_PER_CPU_PGD
+	default 27 if 64BIT && PAX_PER_CPU_PGD
 	default 16
 
 config ARCH_MMAP_RND_COMPAT_BITS_MIN
@@ -295,7 +297,7 @@ config X86_64_SMP
 
 config X86_32_LAZY_GS
 	def_bool y
-	depends on X86_32 && !CC_STACKPROTECTOR
+	depends on X86_32 && !CC_STACKPROTECTOR && !PAX_MEMORY_UDEREF
 
 config ARCH_SUPPORTS_UPROBES
 	def_bool y
@@ -677,6 +679,7 @@ config SCHED_OMIT_FRAME_POINTER
 
 menuconfig HYPERVISOR_GUEST
 	bool "Linux guest support"
+	depends on !GRKERNSEC_CONFIG_AUTO || GRKERNSEC_CONFIG_VIRT_GUEST || (GRKERNSEC_CONFIG_VIRT_HOST && GRKERNSEC_CONFIG_VIRT_XEN)
 	---help---
 	  Say Y here to enable options for running Linux under various hyper-
 	  visors. This option enables basic hypervisor detection and platform
@@ -1078,6 +1081,7 @@ config VM86
 
 config X86_16BIT
 	bool "Enable support for 16-bit segments" if EXPERT
+	depends on !GRKERNSEC
 	default y
 	depends on MODIFY_LDT_SYSCALL
 	---help---
@@ -1232,6 +1236,7 @@ choice
 
 config NOHIGHMEM
 	bool "off"
+	depends on !(PAX_PAGEEXEC && PAX_ENABLE_PAE)
 	---help---
 	  Linux can use up to 64 Gigabytes of physical memory on x86 systems.
 	  However, the address space of 32-bit x86 processors is only 4
@@ -1268,6 +1273,7 @@ config NOHIGHMEM
 
 config HIGHMEM4G
 	bool "4GB"
+	depends on !(PAX_PAGEEXEC && PAX_ENABLE_PAE)
 	---help---
 	  Select this if you have a 32-bit processor and between 1 and 4
 	  gigabytes of physical RAM.
@@ -1320,7 +1326,7 @@ config PAGE_OFFSET
 	hex
 	default 0xB0000000 if VMSPLIT_3G_OPT
 	default 0x80000000 if VMSPLIT_2G
-	default 0x78000000 if VMSPLIT_2G_OPT
+	default 0x70000000 if VMSPLIT_2G_OPT
 	default 0x40000000 if VMSPLIT_1G
 	default 0xC0000000
 	depends on X86_32
@@ -1341,7 +1347,6 @@ config X86_PAE
 
 config ARCH_PHYS_ADDR_T_64BIT
 	def_bool y
-	depends on X86_64 || X86_PAE
 
 config ARCH_DMA_ADDR_T_64BIT
 	def_bool y
@@ -1472,7 +1477,7 @@ config ARCH_PROC_KCORE_TEXT
 
 config ILLEGAL_POINTER_VALUE
        hex
-       default 0 if X86_32
+       default 0xfffff000 if X86_32
        default 0xdead000000000000 if X86_64
 
 source "mm/Kconfig"
@@ -1795,6 +1800,7 @@ source kernel/Kconfig.hz
 config KEXEC
 	bool "kexec system call"
 	select KEXEC_CORE
+	depends on !GRKERNSEC_KMEM
 	---help---
 	  kexec is a system call that implements the ability to shutdown your
 	  current kernel, and to start another kernel.  It is like a reboot
@@ -1922,7 +1928,7 @@ config RELOCATABLE
 
 config RANDOMIZE_BASE
 	bool "Randomize the address of the kernel image (KASLR)"
-	depends on RELOCATABLE
+	depends on RELOCATABLE && BROKEN_SECURITY
 	default n
 	---help---
 	  In support of Kernel Address Space Layout Randomization (KASLR),
@@ -1966,7 +1972,9 @@ config X86_NEED_RELOCS
 
 config PHYSICAL_ALIGN
 	hex "Alignment value to which kernel should be aligned"
-	default "0x200000"
+	default "0x1000000"
+	range 0x200000 0x1000000 if PAX_KERNEXEC && X86_PAE
+	range 0x400000 0x1000000 if PAX_KERNEXEC && !X86_PAE
 	range 0x2000 0x1000000 if X86_32
 	range 0x200000 0x1000000 if X86_64
 	---help---
@@ -2081,6 +2089,7 @@ config COMPAT_VDSO
 	def_bool n
 	prompt "Disable the 32-bit vDSO (needed for glibc 2.3.3)"
 	depends on X86_32 || IA32_EMULATION
+	depends on !PAX_PAGEEXEC && !PAX_SEGMEXEC && !PAX_KERNEXEC && !PAX_MEMORY_UDEREF
 	---help---
 	  Certain buggy versions of glibc will crash if they are
 	  presented with a 32-bit vDSO that is not mapped at the address
@@ -2121,15 +2130,6 @@ choice
 
 	  If unsure, select "Emulate".
 
-	config LEGACY_VSYSCALL_NATIVE
-		bool "Native"
-		help
-		  Actual executable code is located in the fixed vsyscall
-		  address mapping, implementing time() efficiently. Since
-		  this makes the mapping executable, it can be used during
-		  security vulnerability exploitation (traditionally as
-		  ROP gadgets). This configuration is not recommended.
-
 	config LEGACY_VSYSCALL_EMULATE
 		bool "Emulate"
 		help
@@ -2210,6 +2210,22 @@ config MODIFY_LDT_SYSCALL
 
 	  Saying 'N' here may make sense for embedded or server kernels.
 
+config DEFAULT_MODIFY_LDT_SYSCALL
+	bool "Allow userspace to modify the LDT by default"
+	default y
+
+	---help---
+	  Modifying the LDT (Local Descriptor Table) may be needed to run a
+	  16-bit or segmented code such as Dosemu or Wine. This is done via
+	  a system call which is not needed to run portable applications,
+	  and which can sometimes be abused to exploit some weaknesses of
+	  the architecture, opening new vulnerabilities.
+
+	  For this reason this option allows one to enable or disable the
+	  feature at runtime. It is recommended to say 'N' here to leave
+	  the system protected, and to enable it at runtime only if needed
+	  by setting the sys.kernel.modify_ldt sysctl.
+
 source "kernel/livepatch/Kconfig"
 
 endmenu
diff --git a/arch/x86/Kconfig.cpu b/arch/x86/Kconfig.cpu
index 3ba5ff2f2..44bdacc79 100644
--- a/arch/x86/Kconfig.cpu
+++ b/arch/x86/Kconfig.cpu
@@ -329,7 +329,7 @@ config X86_PPRO_FENCE
 
 config X86_F00F_BUG
 	def_bool y
-	depends on M586MMX || M586TSC || M586 || M486
+	depends on (M586MMX || M586TSC || M586 || M486) && !PAX_KERNEXEC
 
 config X86_INVD_BUG
 	def_bool y
@@ -337,7 +337,7 @@ config X86_INVD_BUG
 
 config X86_ALIGNMENT_16
 	def_bool y
-	depends on MWINCHIP3D || MWINCHIPC6 || MCYRIXIII || MELAN || MK6 || M586MMX || M586TSC || M586 || M486 || MVIAC3_2 || MGEODEGX1
+	depends on MWINCHIP3D || MWINCHIPC6 || MCYRIXIII || X86_ELAN || MK8 || MK7 || MK6 || MCORE2 || MPENTIUM4 || MPENTIUMIII || MPENTIUMII || M686 || M586MMX || M586TSC || M586 || M486 || MVIAC3_2 || MGEODEGX1
 
 config X86_INTEL_USERCOPY
 	def_bool y
@@ -379,7 +379,7 @@ config X86_CMPXCHG64
 # generates cmov.
 config X86_CMOV
 	def_bool y
-	depends on (MK8 || MK7 || MCORE2 || MPENTIUM4 || MPENTIUMM || MPENTIUMIII || MPENTIUMII || M686 || MVIAC3_2 || MVIAC7 || MCRUSOE || MEFFICEON || X86_64 || MATOM || MGEODE_LX)
+	depends on (MK8 || MK7 || MCORE2 || MPSC || MPENTIUM4 || MPENTIUMM || MPENTIUMIII || MPENTIUMII || M686 || MVIAC3_2 || MVIAC7 || MCRUSOE || MEFFICEON || X86_64 || MATOM || MGEODE_LX)
 
 config X86_MINIMUM_CPU_FAMILY
 	int
diff --git a/arch/x86/Kconfig.debug b/arch/x86/Kconfig.debug
index 67eec5509..1a5c1ab1d 100644
--- a/arch/x86/Kconfig.debug
+++ b/arch/x86/Kconfig.debug
@@ -55,6 +55,7 @@ config X86_PTDUMP
 	tristate "Export kernel pagetable layout to userspace via debugfs"
 	depends on DEBUG_KERNEL
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	select X86_PTDUMP_CORE
 	---help---
 	  Say Y here if you want to show the kernel pagetable layout in a
@@ -84,6 +85,7 @@ config DEBUG_RODATA_TEST
 
 config DEBUG_WX
 	bool "Warn on W+X mappings at boot"
+	depends on BROKEN
 	select X86_PTDUMP_CORE
 	---help---
 	  Generate a warning if any W+X mappings are found at boot.
@@ -111,7 +113,7 @@ config DEBUG_WX
 
 config DEBUG_SET_MODULE_RONX
 	bool "Set loadable kernel module data as NX and text as RO"
-	depends on MODULES
+	depends on MODULES && BROKEN
 	---help---
 	  This option helps catch unintended modifications to loadable
 	  kernel module's text and read-only data. It also prevents execution
@@ -353,6 +355,7 @@ config X86_DEBUG_FPU
 config PUNIT_ATOM_DEBUG
 	tristate "ATOM Punit debug driver"
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	select IOSF_MBI
 	---help---
 	  This is a debug driver, which gets the power states
diff --git a/arch/x86/Makefile b/arch/x86/Makefile
index 830ed391e..56602a56a 100644
--- a/arch/x86/Makefile
+++ b/arch/x86/Makefile
@@ -75,9 +75,6 @@ ifeq ($(CONFIG_X86_32),y)
         # CPU-specific tuning. Anything which can be shared with UML should go here.
         include arch/x86/Makefile_32.cpu
         KBUILD_CFLAGS += $(cflags-y)
-
-        # temporary until string.h is fixed
-        KBUILD_CFLAGS += -ffreestanding
 else
         BITS := 64
         UTS_MACHINE := x86_64
@@ -126,6 +123,9 @@ else
         KBUILD_CFLAGS += $(call cc-option,-maccumulate-outgoing-args)
 endif
 
+# temporary until string.h is fixed
+KBUILD_CFLAGS += -ffreestanding
+
 ifdef CONFIG_X86_X32
 	x32_ld_ok := $(call try-run,\
 			/bin/echo -e '1: .quad 1b' | \
@@ -191,6 +191,7 @@ archheaders:
 	$(Q)$(MAKE) $(build)=arch/x86/entry/syscalls all
 
 archprepare:
+	$(if $(LDFLAGS_BUILD_ID),,$(error $(OLD_LD)))
 ifeq ($(CONFIG_KEXEC_FILE),y)
 	$(Q)$(MAKE) $(build)=arch/x86/purgatory arch/x86/purgatory/kexec-purgatory.c
 endif
@@ -277,3 +278,9 @@ define archhelp
   echo  '                  FDARGS="..."  arguments for the booted kernel'
   echo  '                  FDINITRD=file initrd for the booted kernel'
 endef
+
+define OLD_LD
+
+*** ${VERSION}.${PATCHLEVEL} PaX kernels no longer build correctly with old versions of binutils.
+*** Please upgrade your binutils to 2.18 or newer
+endef
diff --git a/arch/x86/boot/bitops.h b/arch/x86/boot/bitops.h
index 0d41d6813..2d6120cf3 100644
--- a/arch/x86/boot/bitops.h
+++ b/arch/x86/boot/bitops.h
@@ -28,7 +28,7 @@ static inline bool variable_test_bit(int nr, const void *addr)
 	bool v;
 	const u32 *p = (const u32 *)addr;
 
-	asm("btl %2,%1; setc %0" : "=qm" (v) : "m" (*p), "Ir" (nr));
+	asm volatile("btl %2,%1; setc %0" : "=qm" (v) : "m" (*p), "Ir" (nr));
 	return v;
 }
 
@@ -39,7 +39,7 @@ static inline bool variable_test_bit(int nr, const void *addr)
 
 static inline void set_bit(int nr, void *addr)
 {
-	asm("btsl %1,%0" : "+m" (*(u32 *)addr) : "Ir" (nr));
+	asm volatile("btsl %1,%0" : "+m" (*(u32 *)addr) : "Ir" (nr));
 }
 
 #endif /* BOOT_BITOPS_H */
diff --git a/arch/x86/boot/boot.h b/arch/x86/boot/boot.h
index e5612f3e3..e755d051b 100644
--- a/arch/x86/boot/boot.h
+++ b/arch/x86/boot/boot.h
@@ -84,7 +84,7 @@ static inline void io_delay(void)
 static inline u16 ds(void)
 {
 	u16 seg;
-	asm("movw %%ds,%0" : "=rm" (seg));
+	asm volatile("movw %%ds,%0" : "=rm" (seg));
 	return seg;
 }
 
diff --git a/arch/x86/boot/compressed/Makefile b/arch/x86/boot/compressed/Makefile
index 536ccfcc0..1295cc1f2 100644
--- a/arch/x86/boot/compressed/Makefile
+++ b/arch/x86/boot/compressed/Makefile
@@ -35,6 +35,23 @@ KBUILD_CFLAGS += -mno-mmx -mno-sse
 KBUILD_CFLAGS += $(call cc-option,-ffreestanding)
 KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
 
+ifdef CONFIG_DEBUG_INFO
+ifdef CONFIG_DEBUG_INFO_SPLIT
+KBUILD_CFLAGS   += $(call cc-option, -gsplit-dwarf, -g)
+else
+KBUILD_CFLAGS	+= -g
+endif
+KBUILD_AFLAGS	+= -Wa,--gdwarf-2
+endif
+ifdef CONFIG_DEBUG_INFO_DWARF4
+KBUILD_CFLAGS	+= $(call cc-option, -gdwarf-4,)
+endif
+
+ifdef CONFIG_DEBUG_INFO_REDUCED
+KBUILD_CFLAGS 	+= $(call cc-option, -femit-struct-debug-baseonly) \
+		   $(call cc-option,-fno-var-tracking)
+endif
+
 KBUILD_AFLAGS  := $(KBUILD_CFLAGS) -D__ASSEMBLY__
 GCOV_PROFILE := n
 UBSAN_SANITIZE :=n
diff --git a/arch/x86/boot/compressed/efi_stub_32.S b/arch/x86/boot/compressed/efi_stub_32.S
index a53440e81..c3dbf1ed7 100644
--- a/arch/x86/boot/compressed/efi_stub_32.S
+++ b/arch/x86/boot/compressed/efi_stub_32.S
@@ -46,16 +46,13 @@ ENTRY(efi_call_phys)
 	 * parameter 2, ..., param n. To make things easy, we save the return
 	 * address of efi_call_phys in a global variable.
 	 */
-	popl	%ecx
-	movl	%ecx, saved_return_addr(%edx)
-	/* get the function pointer into ECX*/
-	popl	%ecx
-	movl	%ecx, efi_rt_function_ptr(%edx)
+	popl	saved_return_addr(%edx)
+	popl	efi_rt_function_ptr(%edx)
 
 	/*
 	 * 3. Call the physical function.
 	 */
-	call	*%ecx
+	call	*efi_rt_function_ptr(%edx)
 
 	/*
 	 * 4. Balance the stack. And because EAX contain the return value,
@@ -67,15 +64,12 @@ ENTRY(efi_call_phys)
 1:	popl	%edx
 	subl	$1b, %edx
 
-	movl	efi_rt_function_ptr(%edx), %ecx
-	pushl	%ecx
+	pushl	efi_rt_function_ptr(%edx)
 
 	/*
 	 * 10. Push the saved return address onto the stack and return.
 	 */
-	movl	saved_return_addr(%edx), %ecx
-	pushl	%ecx
-	ret
+	jmpl	*saved_return_addr(%edx)
 ENDPROC(efi_call_phys)
 .previous
 
diff --git a/arch/x86/boot/compressed/efi_thunk_64.S b/arch/x86/boot/compressed/efi_thunk_64.S
index 630384a4c..278e7884d 100644
--- a/arch/x86/boot/compressed/efi_thunk_64.S
+++ b/arch/x86/boot/compressed/efi_thunk_64.S
@@ -189,8 +189,8 @@ efi_gdt64:
 	.long	0			/* Filled out by user */
 	.word	0
 	.quad	0x0000000000000000	/* NULL descriptor */
-	.quad	0x00af9a000000ffff	/* __KERNEL_CS */
-	.quad	0x00cf92000000ffff	/* __KERNEL_DS */
+	.quad	0x00af9b000000ffff	/* __KERNEL_CS */
+	.quad	0x00cf93000000ffff	/* __KERNEL_DS */
 	.quad	0x0080890000000000	/* TS descriptor */
 	.quad   0x0000000000000000	/* TS continued */
 efi_gdt64_end:
diff --git a/arch/x86/boot/compressed/head_32.S b/arch/x86/boot/compressed/head_32.S
index 103852427..b6acc21b4 100644
--- a/arch/x86/boot/compressed/head_32.S
+++ b/arch/x86/boot/compressed/head_32.S
@@ -169,10 +169,10 @@ preferred_addr:
 	addl    %eax, %ebx
 	notl	%eax
 	andl    %eax, %ebx
-	cmpl	$LOAD_PHYSICAL_ADDR, %ebx
+	cmpl	$____LOAD_PHYSICAL_ADDR, %ebx
 	jge	1f
 #endif
-	movl	$LOAD_PHYSICAL_ADDR, %ebx
+	movl	$____LOAD_PHYSICAL_ADDR, %ebx
 1:
 
 	/* Target address to relocate to for decompression */
diff --git a/arch/x86/boot/compressed/head_64.S b/arch/x86/boot/compressed/head_64.S
index 0d80a7ad6..ed3e0ff94 100644
--- a/arch/x86/boot/compressed/head_64.S
+++ b/arch/x86/boot/compressed/head_64.S
@@ -103,10 +103,10 @@ ENTRY(startup_32)
 	addl	%eax, %ebx
 	notl	%eax
 	andl	%eax, %ebx
-	cmpl	$LOAD_PHYSICAL_ADDR, %ebx
+	cmpl	$____LOAD_PHYSICAL_ADDR, %ebx
 	jge	1f
 #endif
-	movl	$LOAD_PHYSICAL_ADDR, %ebx
+	movl	$____LOAD_PHYSICAL_ADDR, %ebx
 1:
 
 	/* Target address to relocate to for decompression */
@@ -333,10 +333,10 @@ preferred_addr:
 	addq	%rax, %rbp
 	notq	%rax
 	andq	%rax, %rbp
-	cmpq	$LOAD_PHYSICAL_ADDR, %rbp
+	cmpq	$____LOAD_PHYSICAL_ADDR, %rbp
 	jge	1f
 #endif
-	movq	$LOAD_PHYSICAL_ADDR, %rbp
+	movq	$____LOAD_PHYSICAL_ADDR, %rbp
 1:
 
 	/* Target address to relocate to for decompression */
@@ -444,8 +444,8 @@ gdt:
 	.long	gdt
 	.word	0
 	.quad	0x0000000000000000	/* NULL descriptor */
-	.quad	0x00af9a000000ffff	/* __KERNEL_CS */
-	.quad	0x00cf92000000ffff	/* __KERNEL_DS */
+	.quad	0x00af9b000000ffff	/* __KERNEL_CS */
+	.quad	0x00cf93000000ffff	/* __KERNEL_DS */
 	.quad	0x0080890000000000	/* TS descriptor */
 	.quad   0x0000000000000000	/* TS continued */
 gdt_end:
diff --git a/arch/x86/boot/compressed/misc.c b/arch/x86/boot/compressed/misc.c
index b3c5a5f03..596115e47 100644
--- a/arch/x86/boot/compressed/misc.c
+++ b/arch/x86/boot/compressed/misc.c
@@ -176,13 +176,17 @@ static void handle_relocations(void *output, unsigned long output_len,
 	int *reloc;
 	unsigned long delta, map, ptr;
 	unsigned long min_addr = (unsigned long)output;
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	unsigned long max_addr = min_addr + (VO___bss_start - VO__text - __PAGE_OFFSET - ____LOAD_PHYSICAL_ADDR);
+#else
 	unsigned long max_addr = min_addr + (VO___bss_start - VO__text);
+#endif
 
 	/*
 	 * Calculate the delta between where vmlinux was linked to load
 	 * and where it was actually loaded.
 	 */
-	delta = min_addr - LOAD_PHYSICAL_ADDR;
+	delta = min_addr - ____LOAD_PHYSICAL_ADDR;
 
 	/*
 	 * The kernel contains a table of relocation addresses. Those
@@ -199,7 +203,7 @@ static void handle_relocations(void *output, unsigned long output_len,
 	 * from __START_KERNEL_map.
 	 */
 	if (IS_ENABLED(CONFIG_X86_64))
-		delta = virt_addr - LOAD_PHYSICAL_ADDR;
+		delta = virt_addr - ____LOAD_PHYSICAL_ADDR;
 
 	if (!delta) {
 		debug_putstr("No relocation needed... ");
@@ -274,7 +278,7 @@ static void parse_elf(void *output)
 	Elf32_Ehdr ehdr;
 	Elf32_Phdr *phdrs, *phdr;
 #endif
-	void *dest;
+	void *dest, *prev;
 	int i;
 
 	memcpy(&ehdr, output, sizeof(ehdr));
@@ -301,11 +305,14 @@ static void parse_elf(void *output)
 		case PT_LOAD:
 #ifdef CONFIG_RELOCATABLE
 			dest = output;
-			dest += (phdr->p_paddr - LOAD_PHYSICAL_ADDR);
+			dest += (phdr->p_paddr - ____LOAD_PHYSICAL_ADDR);
 #else
 			dest = (void *)(phdr->p_paddr);
 #endif
 			memmove(dest, output + phdr->p_offset, phdr->p_filesz);
+			if (i)
+				memset(prev, 0xff, dest - prev);
+			prev = dest + phdr->p_filesz;
 			break;
 		default: /* Ignore other PT_* */ break;
 		}
@@ -337,7 +344,11 @@ asmlinkage __visible void *extract_kernel(void *rmode, memptr heap,
 				  unsigned char *output,
 				  unsigned long output_len)
 {
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	const unsigned long kernel_total_size = VO__end - VO__text - __PAGE_OFFSET - ____LOAD_PHYSICAL_ADDR;
+#else
 	const unsigned long kernel_total_size = VO__end - VO__text;
+#endif
 	unsigned long virt_addr = (unsigned long)output;
 
 	/* Retain x86 boot parameters pointer passed from startup_32/64. */
@@ -395,7 +406,7 @@ asmlinkage __visible void *extract_kernel(void *rmode, memptr heap,
 		error("Destination address too large");
 #endif
 #ifndef CONFIG_RELOCATABLE
-	if ((unsigned long)output != LOAD_PHYSICAL_ADDR)
+	if ((unsigned long)output != ____LOAD_PHYSICAL_ADDR)
 		error("Destination address does not match LOAD_PHYSICAL_ADDR");
 	if ((unsigned long)output != virt_addr)
 		error("Destination virtual address changed when not relocatable");
diff --git a/arch/x86/boot/compressed/pagetable.c b/arch/x86/boot/compressed/pagetable.c
index 56589d0a8..f2085bef3 100644
--- a/arch/x86/boot/compressed/pagetable.c
+++ b/arch/x86/boot/compressed/pagetable.c
@@ -14,6 +14,7 @@
  */
 #define __pa(x)  ((unsigned long)(x))
 #define __va(x)  ((void *)((unsigned long)(x)))
+#undef CONFIG_PAX_KERNEXEC
 
 #include "misc.h"
 
diff --git a/arch/x86/boot/cpucheck.c b/arch/x86/boot/cpucheck.c
index 4ad7d70e8..c70396355 100644
--- a/arch/x86/boot/cpucheck.c
+++ b/arch/x86/boot/cpucheck.c
@@ -126,9 +126,9 @@ int check_cpu(int *cpu_level_ptr, int *req_level_ptr, u32 **err_flags_ptr)
 		u32 ecx = MSR_K7_HWCR;
 		u32 eax, edx;
 
-		asm("rdmsr" : "=a" (eax), "=d" (edx) : "c" (ecx));
+		asm volatile("rdmsr" : "=a" (eax), "=d" (edx) : "c" (ecx));
 		eax &= ~(1 << 15);
-		asm("wrmsr" : : "a" (eax), "d" (edx), "c" (ecx));
+		asm volatile("wrmsr" : : "a" (eax), "d" (edx), "c" (ecx));
 
 		get_cpuflags();	/* Make sure it really did something */
 		err = check_cpuflags();
@@ -141,9 +141,9 @@ int check_cpu(int *cpu_level_ptr, int *req_level_ptr, u32 **err_flags_ptr)
 		u32 ecx = MSR_VIA_FCR;
 		u32 eax, edx;
 
-		asm("rdmsr" : "=a" (eax), "=d" (edx) : "c" (ecx));
+		asm volatile("rdmsr" : "=a" (eax), "=d" (edx) : "c" (ecx));
 		eax |= (1<<1)|(1<<7);
-		asm("wrmsr" : : "a" (eax), "d" (edx), "c" (ecx));
+		asm volatile("wrmsr" : : "a" (eax), "d" (edx), "c" (ecx));
 
 		set_bit(X86_FEATURE_CX8, cpu.flags);
 		err = check_cpuflags();
@@ -154,12 +154,12 @@ int check_cpu(int *cpu_level_ptr, int *req_level_ptr, u32 **err_flags_ptr)
 		u32 eax, edx;
 		u32 level = 1;
 
-		asm("rdmsr" : "=a" (eax), "=d" (edx) : "c" (ecx));
-		asm("wrmsr" : : "a" (~0), "d" (edx), "c" (ecx));
-		asm("cpuid"
+		asm volatile("rdmsr" : "=a" (eax), "=d" (edx) : "c" (ecx));
+		asm volatile("wrmsr" : : "a" (~0), "d" (edx), "c" (ecx));
+		asm volatile("cpuid"
 		    : "+a" (level), "=d" (cpu.flags[0])
 		    : : "ecx", "ebx");
-		asm("wrmsr" : : "a" (eax), "d" (edx), "c" (ecx));
+		asm volatile("wrmsr" : : "a" (eax), "d" (edx), "c" (ecx));
 
 		err = check_cpuflags();
 	} else if (err == 0x01 &&
diff --git a/arch/x86/boot/header.S b/arch/x86/boot/header.S
index 3dd5be33a..16720a237 100644
--- a/arch/x86/boot/header.S
+++ b/arch/x86/boot/header.S
@@ -438,7 +438,7 @@ setup_data:		.quad 0			# 64-bit physical pointer to
 						# single linked list of
 						# struct setup_data
 
-pref_address:		.quad LOAD_PHYSICAL_ADDR	# preferred load addr
+pref_address:		.quad ____LOAD_PHYSICAL_ADDR	# preferred load addr
 
 #
 # Getting to provably safe in-place decompression is hard. Worst case
@@ -543,7 +543,12 @@ pref_address:		.quad LOAD_PHYSICAL_ADDR	# preferred load addr
 
 #define ZO_INIT_SIZE	(ZO__end - ZO_startup_32 + ZO_z_min_extract_offset)
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+#define VO_INIT_SIZE	(VO__end - VO__text - __PAGE_OFFSET - ____LOAD_PHYSICAL_ADDR)
+#else
 #define VO_INIT_SIZE	(VO__end - VO__text)
+#endif
+
 #if ZO_INIT_SIZE > VO_INIT_SIZE
 # define INIT_SIZE ZO_INIT_SIZE
 #else
diff --git a/arch/x86/boot/memory.c b/arch/x86/boot/memory.c
index db75d07c3..8e6d0afad 100644
--- a/arch/x86/boot/memory.c
+++ b/arch/x86/boot/memory.c
@@ -19,7 +19,7 @@
 
 static int detect_memory_e820(void)
 {
-	int count = 0;
+	unsigned int count = 0;
 	struct biosregs ireg, oreg;
 	struct e820entry *desc = boot_params.e820_map;
 	static struct e820entry buf; /* static so it is zeroed */
diff --git a/arch/x86/boot/video-vesa.c b/arch/x86/boot/video-vesa.c
index ba3e10065..6501b8fa6 100644
--- a/arch/x86/boot/video-vesa.c
+++ b/arch/x86/boot/video-vesa.c
@@ -201,6 +201,7 @@ static void vesa_store_pm_info(void)
 
 	boot_params.screen_info.vesapm_seg = oreg.es;
 	boot_params.screen_info.vesapm_off = oreg.di;
+	boot_params.screen_info.vesapm_size = oreg.cx;
 }
 
 /*
diff --git a/arch/x86/boot/video.c b/arch/x86/boot/video.c
index 77780e386..86be0cbe1 100644
--- a/arch/x86/boot/video.c
+++ b/arch/x86/boot/video.c
@@ -100,7 +100,7 @@ static void store_mode_params(void)
 static unsigned int get_entry(void)
 {
 	char entry_buf[4];
-	int i, len = 0;
+	unsigned int i, len = 0;
 	int key;
 	unsigned int v;
 
diff --git a/arch/x86/crypto/aes-x86_64-asm_64.S b/arch/x86/crypto/aes-x86_64-asm_64.S
index 910565547..41779c152 100644
--- a/arch/x86/crypto/aes-x86_64-asm_64.S
+++ b/arch/x86/crypto/aes-x86_64-asm_64.S
@@ -8,6 +8,8 @@
  * including this sentence is retained in full.
  */
 
+#include <asm/alternative-asm.h>
+
 .extern crypto_ft_tab
 .extern crypto_it_tab
 .extern crypto_fl_tab
@@ -70,6 +72,8 @@
 	je	B192;			\
 	leaq	32(r9),r9;
 
+#define ret	pax_force_retaddr; ret
+
 #define epilogue(FUNC,r1,r2,r3,r4,r5,r6,r7,r8,r9) \
 	movq	r1,r2;			\
 	movq	r3,r4;			\
diff --git a/arch/x86/crypto/aesni-intel_asm.S b/arch/x86/crypto/aesni-intel_asm.S
index 383a6f84a..a4db591d1 100644
--- a/arch/x86/crypto/aesni-intel_asm.S
+++ b/arch/x86/crypto/aesni-intel_asm.S
@@ -32,6 +32,7 @@
 #include <linux/linkage.h>
 #include <asm/inst.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 
 /*
  * The following macros are used to move an (un)aligned 16 byte value to/from
@@ -218,7 +219,7 @@ enc:        .octa 0x2
 * num_initial_blocks = b mod 4
 * encrypt the initial num_initial_blocks blocks and apply ghash on
 * the ciphertext
-* %r10, %r11, %r12, %rax, %xmm5, %xmm6, %xmm7, %xmm8, %xmm9 registers
+* %r10, %r11, %r15, %rax, %xmm5, %xmm6, %xmm7, %xmm8, %xmm9 registers
 * are clobbered
 * arg1, %arg2, %arg3, %r14 are used as a pointer only, not modified
 */
@@ -228,8 +229,8 @@ enc:        .octa 0x2
 XMM2 XMM3 XMM4 XMMDst TMP6 TMP7 i i_seq operation
         MOVADQ     SHUF_MASK(%rip), %xmm14
 	mov	   arg7, %r10           # %r10 = AAD
-	mov	   arg8, %r12           # %r12 = aadLen
-	mov	   %r12, %r11
+	mov	   arg8, %r15           # %r15 = aadLen
+	mov	   %r15, %r11
 	pxor	   %xmm\i, %xmm\i
 
 _get_AAD_loop\num_initial_blocks\operation:
@@ -238,17 +239,17 @@ _get_AAD_loop\num_initial_blocks\operation:
 	psrldq	   $4, %xmm\i
 	pxor	   \TMP1, %xmm\i
 	add	   $4, %r10
-	sub	   $4, %r12
+	sub	   $4, %r15
 	jne	   _get_AAD_loop\num_initial_blocks\operation
 
 	cmp	   $16, %r11
 	je	   _get_AAD_loop2_done\num_initial_blocks\operation
 
-	mov	   $16, %r12
+	mov	   $16, %r15
 _get_AAD_loop2\num_initial_blocks\operation:
 	psrldq	   $4, %xmm\i
-	sub	   $4, %r12
-	cmp	   %r11, %r12
+	sub	   $4, %r15
+	cmp	   %r11, %r15
 	jne	   _get_AAD_loop2\num_initial_blocks\operation
 
 _get_AAD_loop2_done\num_initial_blocks\operation:
@@ -443,7 +444,7 @@ _initial_blocks_done\num_initial_blocks\operation:
 * num_initial_blocks = b mod 4
 * encrypt the initial num_initial_blocks blocks and apply ghash on
 * the ciphertext
-* %r10, %r11, %r12, %rax, %xmm5, %xmm6, %xmm7, %xmm8, %xmm9 registers
+* %r10, %r11, %r15, %rax, %xmm5, %xmm6, %xmm7, %xmm8, %xmm9 registers
 * are clobbered
 * arg1, %arg2, %arg3, %r14 are used as a pointer only, not modified
 */
@@ -453,8 +454,8 @@ _initial_blocks_done\num_initial_blocks\operation:
 XMM2 XMM3 XMM4 XMMDst TMP6 TMP7 i i_seq operation
         MOVADQ     SHUF_MASK(%rip), %xmm14
 	mov	   arg7, %r10           # %r10 = AAD
-	mov	   arg8, %r12           # %r12 = aadLen
-	mov	   %r12, %r11
+	mov	   arg8, %r15           # %r15 = aadLen
+	mov	   %r15, %r11
 	pxor	   %xmm\i, %xmm\i
 _get_AAD_loop\num_initial_blocks\operation:
 	movd	   (%r10), \TMP1
@@ -462,15 +463,15 @@ _get_AAD_loop\num_initial_blocks\operation:
 	psrldq	   $4, %xmm\i
 	pxor	   \TMP1, %xmm\i
 	add	   $4, %r10
-	sub	   $4, %r12
+	sub	   $4, %r15
 	jne	   _get_AAD_loop\num_initial_blocks\operation
 	cmp	   $16, %r11
 	je	   _get_AAD_loop2_done\num_initial_blocks\operation
-	mov	   $16, %r12
+	mov	   $16, %r15
 _get_AAD_loop2\num_initial_blocks\operation:
 	psrldq	   $4, %xmm\i
-	sub	   $4, %r12
-	cmp	   %r11, %r12
+	sub	   $4, %r15
+	cmp	   %r11, %r15
 	jne	   _get_AAD_loop2\num_initial_blocks\operation
 _get_AAD_loop2_done\num_initial_blocks\operation:
 	PSHUFB_XMM   %xmm14, %xmm\i # byte-reflect the AAD data
@@ -1280,8 +1281,8 @@ _esb_loop_\@:
 * poly = x^128 + x^127 + x^126 + x^121 + 1
 *
 *****************************************************************************/
-ENTRY(aesni_gcm_dec)
-	push	%r12
+RAP_ENTRY(aesni_gcm_dec)
+	push	%r15
 	push	%r13
 	push	%r14
 	mov	%rsp, %r14
@@ -1291,8 +1292,8 @@ ENTRY(aesni_gcm_dec)
 */
 	sub	$VARIABLE_OFFSET, %rsp
 	and	$~63, %rsp                        # align rsp to 64 bytes
-	mov	%arg6, %r12
-	movdqu	(%r12), %xmm13			  # %xmm13 = HashKey
+	mov	%arg6, %r15
+	movdqu	(%r15), %xmm13			  # %xmm13 = HashKey
         movdqa  SHUF_MASK(%rip), %xmm2
 	PSHUFB_XMM %xmm2, %xmm13
 
@@ -1320,10 +1321,10 @@ ENTRY(aesni_gcm_dec)
 	movdqa %xmm13, HashKey(%rsp)           # store HashKey<<1 (mod poly)
 	mov %arg4, %r13    # save the number of bytes of plaintext/ciphertext
 	and $-16, %r13                      # %r13 = %r13 - (%r13 mod 16)
-	mov %r13, %r12
-	and $(3<<4), %r12
+	mov %r13, %r15
+	and $(3<<4), %r15
 	jz _initial_num_blocks_is_0_decrypt
-	cmp $(2<<4), %r12
+	cmp $(2<<4), %r15
 	jb _initial_num_blocks_is_1_decrypt
 	je _initial_num_blocks_is_2_decrypt
 _initial_num_blocks_is_3_decrypt:
@@ -1373,16 +1374,16 @@ _zero_cipher_left_decrypt:
 	sub $16, %r11
 	add %r13, %r11
 	movdqu (%arg3,%r11,1), %xmm1   # receive the last <16 byte block
-	lea SHIFT_MASK+16(%rip), %r12
-	sub %r13, %r12
+	lea SHIFT_MASK+16(%rip), %r15
+	sub %r13, %r15
 # adjust the shuffle mask pointer to be able to shift 16-%r13 bytes
 # (%r13 is the number of bytes in plaintext mod 16)
-	movdqu (%r12), %xmm2           # get the appropriate shuffle mask
+	movdqu (%r15), %xmm2           # get the appropriate shuffle mask
 	PSHUFB_XMM %xmm2, %xmm1            # right shift 16-%r13 butes
 
 	movdqa  %xmm1, %xmm2
 	pxor %xmm1, %xmm0            # Ciphertext XOR E(K, Yn)
-	movdqu ALL_F-SHIFT_MASK(%r12), %xmm1
+	movdqu ALL_F-SHIFT_MASK(%r15), %xmm1
 	# get the appropriate mask to mask out top 16-%r13 bytes of %xmm0
 	pand %xmm1, %xmm0            # mask out top 16-%r13 bytes of %xmm0
 	pand    %xmm1, %xmm2
@@ -1411,9 +1412,9 @@ _less_than_8_bytes_left_decrypt:
 	sub	$1, %r13
 	jne	_less_than_8_bytes_left_decrypt
 _multiple_of_16_bytes_decrypt:
-	mov	arg8, %r12		  # %r13 = aadLen (number of bytes)
-	shl	$3, %r12		  # convert into number of bits
-	movd	%r12d, %xmm15		  # len(A) in %xmm15
+	mov	arg8, %r15		  # %r13 = aadLen (number of bytes)
+	shl	$3, %r15		  # convert into number of bits
+	movd	%r15d, %xmm15		  # len(A) in %xmm15
 	shl	$3, %arg4		  # len(C) in bits (*128)
 	MOVQ_R64_XMM	%arg4, %xmm1
 	pslldq	$8, %xmm15		  # %xmm15 = len(A)||0x0000000000000000
@@ -1452,7 +1453,8 @@ _return_T_done_decrypt:
 	mov	%r14, %rsp
 	pop	%r14
 	pop	%r13
-	pop	%r12
+	pop	%r15
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_gcm_dec)
 
@@ -1540,8 +1542,8 @@ ENDPROC(aesni_gcm_dec)
 *
 * poly = x^128 + x^127 + x^126 + x^121 + 1
 ***************************************************************************/
-ENTRY(aesni_gcm_enc)
-	push	%r12
+RAP_ENTRY(aesni_gcm_enc)
+	push	%r15
 	push	%r13
 	push	%r14
 	mov	%rsp, %r14
@@ -1551,8 +1553,8 @@ ENTRY(aesni_gcm_enc)
 #
 	sub	$VARIABLE_OFFSET, %rsp
 	and	$~63, %rsp
-	mov	%arg6, %r12
-	movdqu	(%r12), %xmm13
+	mov	%arg6, %r15
+	movdqu	(%r15), %xmm13
         movdqa  SHUF_MASK(%rip), %xmm2
 	PSHUFB_XMM %xmm2, %xmm13
 
@@ -1576,13 +1578,13 @@ ENTRY(aesni_gcm_enc)
 	movdqa	%xmm13, HashKey(%rsp)
 	mov	%arg4, %r13            # %xmm13 holds HashKey<<1 (mod poly)
 	and	$-16, %r13
-	mov	%r13, %r12
+	mov	%r13, %r15
 
         # Encrypt first few blocks
 
-	and	$(3<<4), %r12
+	and	$(3<<4), %r15
 	jz	_initial_num_blocks_is_0_encrypt
-	cmp	$(2<<4), %r12
+	cmp	$(2<<4), %r15
 	jb	_initial_num_blocks_is_1_encrypt
 	je	_initial_num_blocks_is_2_encrypt
 _initial_num_blocks_is_3_encrypt:
@@ -1635,14 +1637,14 @@ _zero_cipher_left_encrypt:
 	sub $16, %r11
 	add %r13, %r11
 	movdqu (%arg3,%r11,1), %xmm1     # receive the last <16 byte blocks
-	lea SHIFT_MASK+16(%rip), %r12
-	sub %r13, %r12
+	lea SHIFT_MASK+16(%rip), %r15
+	sub %r13, %r15
 	# adjust the shuffle mask pointer to be able to shift 16-r13 bytes
 	# (%r13 is the number of bytes in plaintext mod 16)
-	movdqu	(%r12), %xmm2           # get the appropriate shuffle mask
+	movdqu	(%r15), %xmm2           # get the appropriate shuffle mask
 	PSHUFB_XMM	%xmm2, %xmm1            # shift right 16-r13 byte
 	pxor	%xmm1, %xmm0            # Plaintext XOR Encrypt(K, Yn)
-	movdqu	ALL_F-SHIFT_MASK(%r12), %xmm1
+	movdqu	ALL_F-SHIFT_MASK(%r15), %xmm1
 	# get the appropriate mask to mask out top 16-r13 bytes of xmm0
 	pand	%xmm1, %xmm0            # mask out top 16-r13 bytes of xmm0
         movdqa SHUF_MASK(%rip), %xmm10
@@ -1675,9 +1677,9 @@ _less_than_8_bytes_left_encrypt:
 	sub $1, %r13
 	jne _less_than_8_bytes_left_encrypt
 _multiple_of_16_bytes_encrypt:
-	mov	arg8, %r12    # %r12 = addLen (number of bytes)
-	shl	$3, %r12
-	movd	%r12d, %xmm15       # len(A) in %xmm15
+	mov	arg8, %r15    # %r15 = addLen (number of bytes)
+	shl	$3, %r15
+	movd	%r15d, %xmm15       # len(A) in %xmm15
 	shl	$3, %arg4               # len(C) in bits (*128)
 	MOVQ_R64_XMM	%arg4, %xmm1
 	pslldq	$8, %xmm15          # %xmm15 = len(A)||0x0000000000000000
@@ -1716,7 +1718,8 @@ _return_T_done_encrypt:
 	mov	%r14, %rsp
 	pop	%r14
 	pop	%r13
-	pop	%r12
+	pop	%r15
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_gcm_enc)
 
@@ -1734,6 +1737,7 @@ _key_expansion_256a:
 	pxor %xmm1, %xmm0
 	movaps %xmm0, (TKEYP)
 	add $0x10, TKEYP
+	pax_force_retaddr
 	ret
 ENDPROC(_key_expansion_128)
 ENDPROC(_key_expansion_256a)
@@ -1760,6 +1764,7 @@ _key_expansion_192a:
 	shufps $0b01001110, %xmm2, %xmm1
 	movaps %xmm1, 0x10(TKEYP)
 	add $0x20, TKEYP
+	pax_force_retaddr
 	ret
 ENDPROC(_key_expansion_192a)
 
@@ -1780,6 +1785,7 @@ _key_expansion_192b:
 
 	movaps %xmm0, (TKEYP)
 	add $0x10, TKEYP
+	pax_force_retaddr
 	ret
 ENDPROC(_key_expansion_192b)
 
@@ -1793,6 +1799,7 @@ _key_expansion_256b:
 	pxor %xmm1, %xmm2
 	movaps %xmm2, (TKEYP)
 	add $0x10, TKEYP
+	pax_force_retaddr
 	ret
 ENDPROC(_key_expansion_256b)
 
@@ -1908,13 +1915,14 @@ ENTRY(aesni_set_key)
 	popl KEYP
 #endif
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_set_key)
 
 /*
  * void aesni_enc(struct crypto_aes_ctx *ctx, u8 *dst, const u8 *src)
  */
-ENTRY(aesni_enc)
+RAP_ENTRY(aesni_enc)
 	FRAME_BEGIN
 #ifndef __x86_64__
 	pushl KEYP
@@ -1932,6 +1940,7 @@ ENTRY(aesni_enc)
 	popl KEYP
 #endif
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_enc)
 
@@ -1990,6 +1999,7 @@ _aesni_enc1:
 	AESENC KEY STATE
 	movaps 0x70(TKEYP), KEY
 	AESENCLAST KEY STATE
+	pax_force_retaddr
 	ret
 ENDPROC(_aesni_enc1)
 
@@ -2099,13 +2109,14 @@ _aesni_enc4:
 	AESENCLAST KEY STATE2
 	AESENCLAST KEY STATE3
 	AESENCLAST KEY STATE4
+	pax_force_retaddr
 	ret
 ENDPROC(_aesni_enc4)
 
 /*
  * void aesni_dec (struct crypto_aes_ctx *ctx, u8 *dst, const u8 *src)
  */
-ENTRY(aesni_dec)
+RAP_ENTRY(aesni_dec)
 	FRAME_BEGIN
 #ifndef __x86_64__
 	pushl KEYP
@@ -2124,6 +2135,7 @@ ENTRY(aesni_dec)
 	popl KEYP
 #endif
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_dec)
 
@@ -2182,6 +2194,7 @@ _aesni_dec1:
 	AESDEC KEY STATE
 	movaps 0x70(TKEYP), KEY
 	AESDECLAST KEY STATE
+	pax_force_retaddr
 	ret
 ENDPROC(_aesni_dec1)
 
@@ -2291,6 +2304,7 @@ _aesni_dec4:
 	AESDECLAST KEY STATE2
 	AESDECLAST KEY STATE3
 	AESDECLAST KEY STATE4
+	pax_force_retaddr
 	ret
 ENDPROC(_aesni_dec4)
 
@@ -2351,6 +2365,7 @@ ENTRY(aesni_ecb_enc)
 	popl LEN
 #endif
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_ecb_enc)
 
@@ -2412,6 +2427,7 @@ ENTRY(aesni_ecb_dec)
 	popl LEN
 #endif
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_ecb_dec)
 
@@ -2456,6 +2472,7 @@ ENTRY(aesni_cbc_enc)
 	popl IVP
 #endif
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_cbc_enc)
 
@@ -2549,6 +2566,7 @@ ENTRY(aesni_cbc_dec)
 	popl IVP
 #endif
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_cbc_dec)
 
@@ -2578,6 +2596,7 @@ _aesni_inc_init:
 	mov $1, TCTR_LOW
 	MOVQ_R64_XMM TCTR_LOW INC
 	MOVQ_R64_XMM CTR TCTR_LOW
+	pax_force_retaddr
 	ret
 ENDPROC(_aesni_inc_init)
 
@@ -2607,6 +2626,7 @@ _aesni_inc:
 .Linc_low:
 	movaps CTR, IV
 	PSHUFB_XMM BSWAP_MASK IV
+	pax_force_retaddr
 	ret
 ENDPROC(_aesni_inc)
 
@@ -2614,7 +2634,7 @@ ENDPROC(_aesni_inc)
  * void aesni_ctr_enc(struct crypto_aes_ctx *ctx, const u8 *dst, u8 *src,
  *		      size_t len, u8 *iv)
  */
-ENTRY(aesni_ctr_enc)
+RAP_ENTRY(aesni_ctr_enc)
 	FRAME_BEGIN
 	cmp $16, LEN
 	jb .Lctr_enc_just_ret
@@ -2670,6 +2690,7 @@ ENTRY(aesni_ctr_enc)
 	movups IV, (IVP)
 .Lctr_enc_just_ret:
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_ctr_enc)
 
@@ -2798,6 +2819,7 @@ ENTRY(aesni_xts_crypt8)
 	movdqu STATE4, 0x70(OUTP)
 
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(aesni_xts_crypt8)
 
diff --git a/arch/x86/crypto/aesni-intel_glue.c b/arch/x86/crypto/aesni-intel_glue.c
index 0ab5ee1c2..a5d431f6e 100644
--- a/arch/x86/crypto/aesni-intel_glue.c
+++ b/arch/x86/crypto/aesni-intel_glue.c
@@ -71,9 +71,9 @@ struct aesni_xts_ctx {
 
 asmlinkage int aesni_set_key(struct crypto_aes_ctx *ctx, const u8 *in_key,
 			     unsigned int key_len);
-asmlinkage void aesni_enc(struct crypto_aes_ctx *ctx, u8 *out,
+asmlinkage void aesni_enc(void *ctx, u8 *out,
 			  const u8 *in);
-asmlinkage void aesni_dec(struct crypto_aes_ctx *ctx, u8 *out,
+asmlinkage void aesni_dec(void *ctx, u8 *out,
 			  const u8 *in);
 asmlinkage void aesni_ecb_enc(struct crypto_aes_ctx *ctx, u8 *out,
 			      const u8 *in, unsigned int len);
diff --git a/arch/x86/crypto/blowfish-x86_64-asm_64.S b/arch/x86/crypto/blowfish-x86_64-asm_64.S
index 246c67006..4fb760301 100644
--- a/arch/x86/crypto/blowfish-x86_64-asm_64.S
+++ b/arch/x86/crypto/blowfish-x86_64-asm_64.S
@@ -21,6 +21,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 .file "blowfish-x86_64-asm.S"
 .text
@@ -149,13 +150,15 @@ ENTRY(__blowfish_enc_blk)
 	jnz .L__enc_xor;
 
 	write_block();
+	pax_force_retaddr
 	ret;
 .L__enc_xor:
 	xor_block();
+	pax_force_retaddr
 	ret;
 ENDPROC(__blowfish_enc_blk)
 
-ENTRY(blowfish_dec_blk)
+RAP_ENTRY(blowfish_dec_blk)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -183,6 +186,7 @@ ENTRY(blowfish_dec_blk)
 
 	movq %r11, %rbp;
 
+	pax_force_retaddr
 	ret;
 ENDPROC(blowfish_dec_blk)
 
@@ -334,6 +338,7 @@ ENTRY(__blowfish_enc_blk_4way)
 
 	popq %rbx;
 	popq %rbp;
+	pax_force_retaddr
 	ret;
 
 .L__enc_xor4:
@@ -341,10 +346,11 @@ ENTRY(__blowfish_enc_blk_4way)
 
 	popq %rbx;
 	popq %rbp;
+	pax_force_retaddr
 	ret;
 ENDPROC(__blowfish_enc_blk_4way)
 
-ENTRY(blowfish_dec_blk_4way)
+RAP_ENTRY(blowfish_dec_blk_4way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -375,5 +381,6 @@ ENTRY(blowfish_dec_blk_4way)
 	popq %rbx;
 	popq %rbp;
 
+	pax_force_retaddr
 	ret;
 ENDPROC(blowfish_dec_blk_4way)
diff --git a/arch/x86/crypto/camellia-aesni-avx-asm_64.S b/arch/x86/crypto/camellia-aesni-avx-asm_64.S
index aa9e8bd16..0b8def4ee 100644
--- a/arch/x86/crypto/camellia-aesni-avx-asm_64.S
+++ b/arch/x86/crypto/camellia-aesni-avx-asm_64.S
@@ -17,6 +17,7 @@
 
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 
 #define CAMELLIA_TABLE_BYTE_LEN 272
 
@@ -192,6 +193,7 @@ roundsm16_x0_x1_x2_x3_x4_x5_x6_x7_y0_y1_y2_y3_y4_y5_y6_y7_cd:
 	roundsm16(%xmm0, %xmm1, %xmm2, %xmm3, %xmm4, %xmm5, %xmm6, %xmm7,
 		  %xmm8, %xmm9, %xmm10, %xmm11, %xmm12, %xmm13, %xmm14, %xmm15,
 		  %rcx, (%r9));
+	pax_force_retaddr
 	ret;
 ENDPROC(roundsm16_x0_x1_x2_x3_x4_x5_x6_x7_y0_y1_y2_y3_y4_y5_y6_y7_cd)
 
@@ -200,6 +202,7 @@ roundsm16_x4_x5_x6_x7_x0_x1_x2_x3_y4_y5_y6_y7_y0_y1_y2_y3_ab:
 	roundsm16(%xmm4, %xmm5, %xmm6, %xmm7, %xmm0, %xmm1, %xmm2, %xmm3,
 		  %xmm12, %xmm13, %xmm14, %xmm15, %xmm8, %xmm9, %xmm10, %xmm11,
 		  %rax, (%r9));
+	pax_force_retaddr
 	ret;
 ENDPROC(roundsm16_x4_x5_x6_x7_x0_x1_x2_x3_y4_y5_y6_y7_y0_y1_y2_y3_ab)
 
@@ -783,6 +786,7 @@ __camellia_enc_blk16:
 		    %xmm15, (key_table)(CTX, %r8, 8), (%rax), 1 * 16(%rax));
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 
 .align 8
@@ -870,6 +874,7 @@ __camellia_dec_blk16:
 		    %xmm15, (key_table)(CTX), (%rax), 1 * 16(%rax));
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 
 .align 8
@@ -889,7 +894,7 @@ __camellia_dec_blk16:
 	jmp .Ldec_max24;
 ENDPROC(__camellia_dec_blk16)
 
-ENTRY(camellia_ecb_enc_16way)
+RAP_ENTRY(camellia_ecb_enc_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -911,10 +916,11 @@ ENTRY(camellia_ecb_enc_16way)
 		     %xmm8, %rsi);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_ecb_enc_16way)
 
-ENTRY(camellia_ecb_dec_16way)
+RAP_ENTRY(camellia_ecb_dec_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -941,10 +947,11 @@ ENTRY(camellia_ecb_dec_16way)
 		     %xmm8, %rsi);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_ecb_dec_16way)
 
-ENTRY(camellia_cbc_dec_16way)
+RAP_ENTRY(camellia_cbc_dec_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -992,6 +999,7 @@ ENTRY(camellia_cbc_dec_16way)
 		     %xmm8, %rsi);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_cbc_dec_16way)
 
@@ -1001,7 +1009,7 @@ ENDPROC(camellia_cbc_dec_16way)
 	vpslldq $8, tmp, tmp; \
 	vpsubq tmp, x, x;
 
-ENTRY(camellia_ctr_16way)
+RAP_ENTRY(camellia_ctr_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -1105,6 +1113,7 @@ ENTRY(camellia_ctr_16way)
 		     %xmm8, %rsi);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_ctr_16way)
 
@@ -1249,10 +1258,11 @@ camellia_xts_crypt_16way:
 		     %xmm8, %rsi);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_xts_crypt_16way)
 
-ENTRY(camellia_xts_enc_16way)
+RAP_ENTRY(camellia_xts_enc_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -1266,7 +1276,7 @@ ENTRY(camellia_xts_enc_16way)
 	jmp camellia_xts_crypt_16way;
 ENDPROC(camellia_xts_enc_16way)
 
-ENTRY(camellia_xts_dec_16way)
+RAP_ENTRY(camellia_xts_dec_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
diff --git a/arch/x86/crypto/camellia-aesni-avx2-asm_64.S b/arch/x86/crypto/camellia-aesni-avx2-asm_64.S
index 16186c186..3468f832e 100644
--- a/arch/x86/crypto/camellia-aesni-avx2-asm_64.S
+++ b/arch/x86/crypto/camellia-aesni-avx2-asm_64.S
@@ -12,6 +12,7 @@
 
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 
 #define CAMELLIA_TABLE_BYTE_LEN 272
 
@@ -231,6 +232,7 @@ roundsm32_x0_x1_x2_x3_x4_x5_x6_x7_y0_y1_y2_y3_y4_y5_y6_y7_cd:
 	roundsm32(%ymm0, %ymm1, %ymm2, %ymm3, %ymm4, %ymm5, %ymm6, %ymm7,
 		  %ymm8, %ymm9, %ymm10, %ymm11, %ymm12, %ymm13, %ymm14, %ymm15,
 		  %rcx, (%r9));
+	pax_force_retaddr
 	ret;
 ENDPROC(roundsm32_x0_x1_x2_x3_x4_x5_x6_x7_y0_y1_y2_y3_y4_y5_y6_y7_cd)
 
@@ -239,6 +241,7 @@ roundsm32_x4_x5_x6_x7_x0_x1_x2_x3_y4_y5_y6_y7_y0_y1_y2_y3_ab:
 	roundsm32(%ymm4, %ymm5, %ymm6, %ymm7, %ymm0, %ymm1, %ymm2, %ymm3,
 		  %ymm12, %ymm13, %ymm14, %ymm15, %ymm8, %ymm9, %ymm10, %ymm11,
 		  %rax, (%r9));
+	pax_force_retaddr
 	ret;
 ENDPROC(roundsm32_x4_x5_x6_x7_x0_x1_x2_x3_y4_y5_y6_y7_y0_y1_y2_y3_ab)
 
@@ -823,6 +826,7 @@ __camellia_enc_blk32:
 		    %ymm15, (key_table)(CTX, %r8, 8), (%rax), 1 * 32(%rax));
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 
 .align 8
@@ -910,6 +914,7 @@ __camellia_dec_blk32:
 		    %ymm15, (key_table)(CTX), (%rax), 1 * 32(%rax));
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 
 .align 8
@@ -929,7 +934,7 @@ __camellia_dec_blk32:
 	jmp .Ldec_max24;
 ENDPROC(__camellia_dec_blk32)
 
-ENTRY(camellia_ecb_enc_32way)
+RAP_ENTRY(camellia_ecb_enc_32way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (32 blocks)
@@ -955,10 +960,11 @@ ENTRY(camellia_ecb_enc_32way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_ecb_enc_32way)
 
-ENTRY(camellia_ecb_dec_32way)
+RAP_ENTRY(camellia_ecb_dec_32way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (32 blocks)
@@ -989,10 +995,11 @@ ENTRY(camellia_ecb_dec_32way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_ecb_dec_32way)
 
-ENTRY(camellia_cbc_dec_32way)
+RAP_ENTRY(camellia_cbc_dec_32way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (32 blocks)
@@ -1057,6 +1064,7 @@ ENTRY(camellia_cbc_dec_32way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_cbc_dec_32way)
 
@@ -1074,7 +1082,7 @@ ENDPROC(camellia_cbc_dec_32way)
 	vpslldq $8, tmp1, tmp1; \
 	vpsubq tmp1, x, x;
 
-ENTRY(camellia_ctr_32way)
+RAP_ENTRY(camellia_ctr_32way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (32 blocks)
@@ -1197,6 +1205,7 @@ ENTRY(camellia_ctr_32way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_ctr_32way)
 
@@ -1364,10 +1373,11 @@ camellia_xts_crypt_32way:
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_xts_crypt_32way)
 
-ENTRY(camellia_xts_enc_32way)
+RAP_ENTRY(camellia_xts_enc_32way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (32 blocks)
@@ -1382,7 +1392,7 @@ ENTRY(camellia_xts_enc_32way)
 	jmp camellia_xts_crypt_32way;
 ENDPROC(camellia_xts_enc_32way)
 
-ENTRY(camellia_xts_dec_32way)
+RAP_ENTRY(camellia_xts_dec_32way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (32 blocks)
diff --git a/arch/x86/crypto/camellia-x86_64-asm_64.S b/arch/x86/crypto/camellia-x86_64-asm_64.S
index 310319c60..9253a8f6e 100644
--- a/arch/x86/crypto/camellia-x86_64-asm_64.S
+++ b/arch/x86/crypto/camellia-x86_64-asm_64.S
@@ -21,6 +21,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 .file "camellia-x86_64-asm_64.S"
 .text
@@ -228,16 +229,18 @@ ENTRY(__camellia_enc_blk)
 	enc_outunpack(mov, RT1);
 
 	movq RRBP, %rbp;
+	pax_force_retaddr
 	ret;
 
 .L__enc_xor:
 	enc_outunpack(xor, RT1);
 
 	movq RRBP, %rbp;
+	pax_force_retaddr
 	ret;
 ENDPROC(__camellia_enc_blk)
 
-ENTRY(camellia_dec_blk)
+RAP_ENTRY(camellia_dec_blk)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -272,6 +275,7 @@ ENTRY(camellia_dec_blk)
 	dec_outunpack();
 
 	movq RRBP, %rbp;
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_dec_blk)
 
@@ -463,6 +467,7 @@ ENTRY(__camellia_enc_blk_2way)
 
 	movq RRBP, %rbp;
 	popq %rbx;
+	pax_force_retaddr
 	ret;
 
 .L__enc2_xor:
@@ -470,10 +475,11 @@ ENTRY(__camellia_enc_blk_2way)
 
 	movq RRBP, %rbp;
 	popq %rbx;
+	pax_force_retaddr
 	ret;
 ENDPROC(__camellia_enc_blk_2way)
 
-ENTRY(camellia_dec_blk_2way)
+RAP_ENTRY(camellia_dec_blk_2way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -510,5 +516,6 @@ ENTRY(camellia_dec_blk_2way)
 
 	movq RRBP, %rbp;
 	movq RXOR, %rbx;
+	pax_force_retaddr
 	ret;
 ENDPROC(camellia_dec_blk_2way)
diff --git a/arch/x86/crypto/camellia_aesni_avx2_glue.c b/arch/x86/crypto/camellia_aesni_avx2_glue.c
index 60907c139..fe8638d2b 100644
--- a/arch/x86/crypto/camellia_aesni_avx2_glue.c
+++ b/arch/x86/crypto/camellia_aesni_avx2_glue.c
@@ -27,20 +27,20 @@
 #define CAMELLIA_AESNI_AVX2_PARALLEL_BLOCKS 32
 
 /* 32-way AVX2/AES-NI parallel cipher functions */
-asmlinkage void camellia_ecb_enc_32way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_ecb_enc_32way(void *ctx, u8 *dst,
 				       const u8 *src);
-asmlinkage void camellia_ecb_dec_32way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_ecb_dec_32way(void *ctx, u8 *dst,
 				       const u8 *src);
 
-asmlinkage void camellia_cbc_dec_32way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_cbc_dec_32way(void *ctx, u8 *dst,
 				       const u8 *src);
-asmlinkage void camellia_ctr_32way(struct camellia_ctx *ctx, u8 *dst,
-				   const u8 *src, le128 *iv);
+asmlinkage void camellia_ctr_32way(void *ctx, u128 *dst,
+				   const u128 *src, le128 *iv);
 
-asmlinkage void camellia_xts_enc_32way(struct camellia_ctx *ctx, u8 *dst,
-				       const u8 *src, le128 *iv);
-asmlinkage void camellia_xts_dec_32way(struct camellia_ctx *ctx, u8 *dst,
-				       const u8 *src, le128 *iv);
+asmlinkage void camellia_xts_enc_32way(void *ctx, u128 *dst,
+				       const u128 *src, le128 *iv);
+asmlinkage void camellia_xts_dec_32way(void *ctx, u128 *dst,
+				       const u128 *src, le128 *iv);
 
 static const struct common_glue_ctx camellia_enc = {
 	.num_funcs = 4,
diff --git a/arch/x86/crypto/camellia_aesni_avx_glue.c b/arch/x86/crypto/camellia_aesni_avx_glue.c
index d96429da8..18ab2e6cd 100644
--- a/arch/x86/crypto/camellia_aesni_avx_glue.c
+++ b/arch/x86/crypto/camellia_aesni_avx_glue.c
@@ -26,28 +26,28 @@
 #define CAMELLIA_AESNI_PARALLEL_BLOCKS 16
 
 /* 16-way parallel cipher functions (avx/aes-ni) */
-asmlinkage void camellia_ecb_enc_16way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_ecb_enc_16way(void *ctx, u8 *dst,
 				       const u8 *src);
 EXPORT_SYMBOL_GPL(camellia_ecb_enc_16way);
 
-asmlinkage void camellia_ecb_dec_16way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_ecb_dec_16way(void *ctx, u8 *dst,
 				       const u8 *src);
 EXPORT_SYMBOL_GPL(camellia_ecb_dec_16way);
 
-asmlinkage void camellia_cbc_dec_16way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_cbc_dec_16way(void *ctx, u8 *dst,
 				       const u8 *src);
 EXPORT_SYMBOL_GPL(camellia_cbc_dec_16way);
 
-asmlinkage void camellia_ctr_16way(struct camellia_ctx *ctx, u8 *dst,
-				   const u8 *src, le128 *iv);
+asmlinkage void camellia_ctr_16way(void *ctx, u128 *dst,
+				   const u128 *src, le128 *iv);
 EXPORT_SYMBOL_GPL(camellia_ctr_16way);
 
-asmlinkage void camellia_xts_enc_16way(struct camellia_ctx *ctx, u8 *dst,
-				       const u8 *src, le128 *iv);
+asmlinkage void camellia_xts_enc_16way(void *ctx, u128 *dst,
+				       const u128 *src, le128 *iv);
 EXPORT_SYMBOL_GPL(camellia_xts_enc_16way);
 
-asmlinkage void camellia_xts_dec_16way(struct camellia_ctx *ctx, u8 *dst,
-				       const u8 *src, le128 *iv);
+asmlinkage void camellia_xts_dec_16way(void *ctx, u128 *dst,
+				       const u128 *src, le128 *iv);
 EXPORT_SYMBOL_GPL(camellia_xts_dec_16way);
 
 void camellia_xts_enc(void *ctx, u128 *dst, const u128 *src, le128 *iv)
diff --git a/arch/x86/crypto/camellia_glue.c b/arch/x86/crypto/camellia_glue.c
index aa76cad9d..ffd88081b 100644
--- a/arch/x86/crypto/camellia_glue.c
+++ b/arch/x86/crypto/camellia_glue.c
@@ -39,7 +39,7 @@
 asmlinkage void __camellia_enc_blk(struct camellia_ctx *ctx, u8 *dst,
 				   const u8 *src, bool xor);
 EXPORT_SYMBOL_GPL(__camellia_enc_blk);
-asmlinkage void camellia_dec_blk(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_dec_blk(void *ctx, u8 *dst,
 				 const u8 *src);
 EXPORT_SYMBOL_GPL(camellia_dec_blk);
 
@@ -47,7 +47,7 @@ EXPORT_SYMBOL_GPL(camellia_dec_blk);
 asmlinkage void __camellia_enc_blk_2way(struct camellia_ctx *ctx, u8 *dst,
 					const u8 *src, bool xor);
 EXPORT_SYMBOL_GPL(__camellia_enc_blk_2way);
-asmlinkage void camellia_dec_blk_2way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_dec_blk_2way(void *ctx, u8 *dst,
 				      const u8 *src);
 EXPORT_SYMBOL_GPL(camellia_dec_blk_2way);
 
@@ -1279,8 +1279,10 @@ static int camellia_setkey(struct crypto_tfm *tfm, const u8 *in_key,
 				 &tfm->crt_flags);
 }
 
-void camellia_decrypt_cbc_2way(void *ctx, u128 *dst, const u128 *src)
+void camellia_decrypt_cbc_2way(void *ctx, u8 *_dst, const u8 *_src)
 {
+	u128 *dst = (u128 *)_dst;
+	u128 *src = (u128 *)_src;
 	u128 iv = *src;
 
 	camellia_dec_blk_2way(ctx, (u8 *)dst, (u8 *)src);
diff --git a/arch/x86/crypto/cast5-avx-x86_64-asm_64.S b/arch/x86/crypto/cast5-avx-x86_64-asm_64.S
index 14fa1966b..5de8a4a9b 100644
--- a/arch/x86/crypto/cast5-avx-x86_64-asm_64.S
+++ b/arch/x86/crypto/cast5-avx-x86_64-asm_64.S
@@ -25,6 +25,7 @@
 
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 
 .file "cast5-avx-x86_64-asm_64.S"
 
@@ -282,6 +283,7 @@ __cast5_enc_blk16:
 	outunpack_blocks(RR3, RL3, RTMP, RX, RKM);
 	outunpack_blocks(RR4, RL4, RTMP, RX, RKM);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__cast5_enc_blk16)
 
@@ -353,6 +355,7 @@ __cast5_dec_blk16:
 	outunpack_blocks(RR3, RL3, RTMP, RX, RKM);
 	outunpack_blocks(RR4, RL4, RTMP, RX, RKM);
 
+	pax_force_retaddr
 	ret;
 
 .L__skip_dec:
@@ -360,7 +363,7 @@ __cast5_dec_blk16:
 	jmp .L__dec_tail;
 ENDPROC(__cast5_dec_blk16)
 
-ENTRY(cast5_ecb_enc_16way)
+RAP_ENTRY(cast5_ecb_enc_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -391,10 +394,11 @@ ENTRY(cast5_ecb_enc_16way)
 	vmovdqu RL4, (7*4*4)(%r11);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast5_ecb_enc_16way)
 
-ENTRY(cast5_ecb_dec_16way)
+RAP_ENTRY(cast5_ecb_dec_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -425,6 +429,7 @@ ENTRY(cast5_ecb_dec_16way)
 	vmovdqu RL4, (7*4*4)(%r11);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast5_ecb_dec_16way)
 
@@ -436,10 +441,10 @@ ENTRY(cast5_cbc_dec_16way)
 	 */
 	FRAME_BEGIN
 
-	pushq %r12;
+	pushq %r14;
 
 	movq %rsi, %r11;
-	movq %rdx, %r12;
+	movq %rdx, %r14;
 
 	vmovdqu (0*16)(%rdx), RL1;
 	vmovdqu (1*16)(%rdx), RR1;
@@ -453,16 +458,16 @@ ENTRY(cast5_cbc_dec_16way)
 	call __cast5_dec_blk16;
 
 	/* xor with src */
-	vmovq (%r12), RX;
+	vmovq (%r14), RX;
 	vpshufd $0x4f, RX, RX;
 	vpxor RX, RR1, RR1;
-	vpxor 0*16+8(%r12), RL1, RL1;
-	vpxor 1*16+8(%r12), RR2, RR2;
-	vpxor 2*16+8(%r12), RL2, RL2;
-	vpxor 3*16+8(%r12), RR3, RR3;
-	vpxor 4*16+8(%r12), RL3, RL3;
-	vpxor 5*16+8(%r12), RR4, RR4;
-	vpxor 6*16+8(%r12), RL4, RL4;
+	vpxor 0*16+8(%r14), RL1, RL1;
+	vpxor 1*16+8(%r14), RR2, RR2;
+	vpxor 2*16+8(%r14), RL2, RL2;
+	vpxor 3*16+8(%r14), RR3, RR3;
+	vpxor 4*16+8(%r14), RL3, RL3;
+	vpxor 5*16+8(%r14), RR4, RR4;
+	vpxor 6*16+8(%r14), RL4, RL4;
 
 	vmovdqu RR1, (0*16)(%r11);
 	vmovdqu RL1, (1*16)(%r11);
@@ -473,9 +478,10 @@ ENTRY(cast5_cbc_dec_16way)
 	vmovdqu RR4, (6*16)(%r11);
 	vmovdqu RL4, (7*16)(%r11);
 
-	popq %r12;
+	popq %r14;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast5_cbc_dec_16way)
 
@@ -488,10 +494,10 @@ ENTRY(cast5_ctr_16way)
 	 */
 	FRAME_BEGIN
 
-	pushq %r12;
+	pushq %r14;
 
 	movq %rsi, %r11;
-	movq %rdx, %r12;
+	movq %rdx, %r14;
 
 	vpcmpeqd RTMP, RTMP, RTMP;
 	vpsrldq $8, RTMP, RTMP; /* low: -1, high: 0 */
@@ -531,14 +537,14 @@ ENTRY(cast5_ctr_16way)
 	call __cast5_enc_blk16;
 
 	/* dst = src ^ iv */
-	vpxor (0*16)(%r12), RR1, RR1;
-	vpxor (1*16)(%r12), RL1, RL1;
-	vpxor (2*16)(%r12), RR2, RR2;
-	vpxor (3*16)(%r12), RL2, RL2;
-	vpxor (4*16)(%r12), RR3, RR3;
-	vpxor (5*16)(%r12), RL3, RL3;
-	vpxor (6*16)(%r12), RR4, RR4;
-	vpxor (7*16)(%r12), RL4, RL4;
+	vpxor (0*16)(%r14), RR1, RR1;
+	vpxor (1*16)(%r14), RL1, RL1;
+	vpxor (2*16)(%r14), RR2, RR2;
+	vpxor (3*16)(%r14), RL2, RL2;
+	vpxor (4*16)(%r14), RR3, RR3;
+	vpxor (5*16)(%r14), RL3, RL3;
+	vpxor (6*16)(%r14), RR4, RR4;
+	vpxor (7*16)(%r14), RL4, RL4;
 	vmovdqu RR1, (0*16)(%r11);
 	vmovdqu RL1, (1*16)(%r11);
 	vmovdqu RR2, (2*16)(%r11);
@@ -548,8 +554,9 @@ ENTRY(cast5_ctr_16way)
 	vmovdqu RR4, (6*16)(%r11);
 	vmovdqu RL4, (7*16)(%r11);
 
-	popq %r12;
+	popq %r14;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast5_ctr_16way)
diff --git a/arch/x86/crypto/cast6-avx-x86_64-asm_64.S b/arch/x86/crypto/cast6-avx-x86_64-asm_64.S
index c41938988..b853452a1 100644
--- a/arch/x86/crypto/cast6-avx-x86_64-asm_64.S
+++ b/arch/x86/crypto/cast6-avx-x86_64-asm_64.S
@@ -25,6 +25,7 @@
 
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 #include "glue_helper-asm-avx.S"
 
 .file "cast6-avx-x86_64-asm_64.S"
@@ -296,6 +297,7 @@ __cast6_enc_blk8:
 	outunpack_blocks(RA1, RB1, RC1, RD1, RTMP, RX, RKRF, RKM);
 	outunpack_blocks(RA2, RB2, RC2, RD2, RTMP, RX, RKRF, RKM);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__cast6_enc_blk8)
 
@@ -341,10 +343,11 @@ __cast6_dec_blk8:
 	outunpack_blocks(RA1, RB1, RC1, RD1, RTMP, RX, RKRF, RKM);
 	outunpack_blocks(RA2, RB2, RC2, RD2, RTMP, RX, RKRF, RKM);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__cast6_dec_blk8)
 
-ENTRY(cast6_ecb_enc_8way)
+RAP_ENTRY(cast6_ecb_enc_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -361,10 +364,11 @@ ENTRY(cast6_ecb_enc_8way)
 	store_8way(%r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast6_ecb_enc_8way)
 
-ENTRY(cast6_ecb_dec_8way)
+RAP_ENTRY(cast6_ecb_dec_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -381,10 +385,11 @@ ENTRY(cast6_ecb_dec_8way)
 	store_8way(%r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast6_ecb_dec_8way)
 
-ENTRY(cast6_cbc_dec_8way)
+RAP_ENTRY(cast6_cbc_dec_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -392,24 +397,25 @@ ENTRY(cast6_cbc_dec_8way)
 	 */
 	FRAME_BEGIN
 
-	pushq %r12;
+	pushq %r14;
 
 	movq %rsi, %r11;
-	movq %rdx, %r12;
+	movq %rdx, %r14;
 
 	load_8way(%rdx, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	call __cast6_dec_blk8;
 
-	store_cbc_8way(%r12, %r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
+	store_cbc_8way(%r14, %r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
-	popq %r12;
+	popq %r14;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast6_cbc_dec_8way)
 
-ENTRY(cast6_ctr_8way)
+RAP_ENTRY(cast6_ctr_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -418,25 +424,26 @@ ENTRY(cast6_ctr_8way)
 	 */
 	FRAME_BEGIN
 
-	pushq %r12;
+	pushq %r14;
 
 	movq %rsi, %r11;
-	movq %rdx, %r12;
+	movq %rdx, %r14;
 
 	load_ctr_8way(%rcx, .Lbswap128_mask, RA1, RB1, RC1, RD1, RA2, RB2, RC2,
 		      RD2, RX, RKR, RKM);
 
 	call __cast6_enc_blk8;
 
-	store_ctr_8way(%r12, %r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
+	store_ctr_8way(%r14, %r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
-	popq %r12;
+	popq %r14;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast6_ctr_8way)
 
-ENTRY(cast6_xts_enc_8way)
+RAP_ENTRY(cast6_xts_enc_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -457,10 +464,11 @@ ENTRY(cast6_xts_enc_8way)
 	store_xts_8way(%r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast6_xts_enc_8way)
 
-ENTRY(cast6_xts_dec_8way)
+RAP_ENTRY(cast6_xts_dec_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -481,5 +489,6 @@ ENTRY(cast6_xts_dec_8way)
 	store_xts_8way(%r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(cast6_xts_dec_8way)
diff --git a/arch/x86/crypto/cast6_avx_glue.c b/arch/x86/crypto/cast6_avx_glue.c
index 50e684768..bf7c2d84d 100644
--- a/arch/x86/crypto/cast6_avx_glue.c
+++ b/arch/x86/crypto/cast6_avx_glue.c
@@ -41,20 +41,20 @@
 
 #define CAST6_PARALLEL_BLOCKS 8
 
-asmlinkage void cast6_ecb_enc_8way(struct cast6_ctx *ctx, u8 *dst,
+asmlinkage void cast6_ecb_enc_8way(void *ctx, u8 *dst,
 				   const u8 *src);
-asmlinkage void cast6_ecb_dec_8way(struct cast6_ctx *ctx, u8 *dst,
+asmlinkage void cast6_ecb_dec_8way(void *ctx, u8 *dst,
 				   const u8 *src);
 
-asmlinkage void cast6_cbc_dec_8way(struct cast6_ctx *ctx, u8 *dst,
+asmlinkage void cast6_cbc_dec_8way(void *ctx, u8 *dst,
 				   const u8 *src);
-asmlinkage void cast6_ctr_8way(struct cast6_ctx *ctx, u8 *dst, const u8 *src,
+asmlinkage void cast6_ctr_8way(void *ctx, u128 *dst, const u128 *src,
 			       le128 *iv);
 
-asmlinkage void cast6_xts_enc_8way(struct cast6_ctx *ctx, u8 *dst,
-				   const u8 *src, le128 *iv);
-asmlinkage void cast6_xts_dec_8way(struct cast6_ctx *ctx, u8 *dst,
-				   const u8 *src, le128 *iv);
+asmlinkage void cast6_xts_enc_8way(void *ctx, u128 *dst,
+				   const u128 *src, le128 *iv);
+asmlinkage void cast6_xts_dec_8way(void *ctx, u128 *dst,
+				   const u128 *src, le128 *iv);
 
 static void cast6_xts_enc(void *ctx, u128 *dst, const u128 *src, le128 *iv)
 {
diff --git a/arch/x86/crypto/crc32-pclmul_asm.S b/arch/x86/crypto/crc32-pclmul_asm.S
index f24730429..b5003919f 100644
--- a/arch/x86/crypto/crc32-pclmul_asm.S
+++ b/arch/x86/crypto/crc32-pclmul_asm.S
@@ -102,6 +102,12 @@
  *	                     size_t len, uint crc32)
  */
 
+#ifndef __x86_64__
+__i686_get_pc_thunk_cx:
+	mov     (%esp),%ecx
+	ret
+#endif
+
 ENTRY(crc32_pclmul_le_16) /* buffer and buffer size are 16 bytes aligned */
 	movdqa  (BUF), %xmm1
 	movdqa  0x10(BUF), %xmm2
@@ -113,9 +119,8 @@ ENTRY(crc32_pclmul_le_16) /* buffer and buffer size are 16 bytes aligned */
 	add     $0x40, BUF
 #ifndef __x86_64__
 	/* This is for position independent code(-fPIC) support for 32bit */
-	call    delta
+	call    __i686_get_pc_thunk_cx
 delta:
-	pop     %ecx
 #endif
 	cmp     $0x40, LEN
 	jb      less_64
@@ -123,7 +128,7 @@ delta:
 #ifdef __x86_64__
 	movdqa .Lconstant_R2R1(%rip), CONSTANT
 #else
-	movdqa .Lconstant_R2R1 - delta(%ecx), CONSTANT
+	movdqa %cs:.Lconstant_R2R1 - delta (%ecx), CONSTANT
 #endif
 
 loop_64:/*  64 bytes Full cache line folding */
@@ -172,7 +177,7 @@ less_64:/*  Folding cache line into 128bit */
 #ifdef __x86_64__
 	movdqa  .Lconstant_R4R3(%rip), CONSTANT
 #else
-	movdqa  .Lconstant_R4R3 - delta(%ecx), CONSTANT
+	movdqa  %cs:.Lconstant_R4R3 - delta(%ecx), CONSTANT
 #endif
 	prefetchnta     (BUF)
 
@@ -220,8 +225,8 @@ fold_64:
 	movdqa  .Lconstant_R5(%rip), CONSTANT
 	movdqa  .Lconstant_mask32(%rip), %xmm3
 #else
-	movdqa  .Lconstant_R5 - delta(%ecx), CONSTANT
-	movdqa  .Lconstant_mask32 - delta(%ecx), %xmm3
+	movdqa  %cs:.Lconstant_R5 - delta(%ecx), CONSTANT
+	movdqa  %cs:.Lconstant_mask32 - delta(%ecx), %xmm3
 #endif
 	psrldq  $0x04, %xmm2
 	pand    %xmm3, %xmm1
@@ -232,7 +237,7 @@ fold_64:
 #ifdef __x86_64__
 	movdqa  .Lconstant_RUpoly(%rip), CONSTANT
 #else
-	movdqa  .Lconstant_RUpoly - delta(%ecx), CONSTANT
+	movdqa  %cs:.Lconstant_RUpoly - delta(%ecx), CONSTANT
 #endif
 	movdqa  %xmm1, %xmm2
 	pand    %xmm3, %xmm1
diff --git a/arch/x86/crypto/crc32c-pcl-intel-asm_64.S b/arch/x86/crypto/crc32c-pcl-intel-asm_64.S
index dc05f010c..23c8bfdd2 100644
--- a/arch/x86/crypto/crc32c-pcl-intel-asm_64.S
+++ b/arch/x86/crypto/crc32c-pcl-intel-asm_64.S
@@ -45,6 +45,7 @@
 
 #include <asm/inst.h>
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 ## ISCSI CRC 32 Implementation with crc32 and pclmulqdq Instruction
 
@@ -309,6 +310,7 @@ do_return:
 	popq    %rsi
 	popq    %rdi
 	popq    %rbx
+	pax_force_retaddr
         ret
 ENDPROC(crc_pcl)
 
diff --git a/arch/x86/crypto/ghash-clmulni-intel_asm.S b/arch/x86/crypto/ghash-clmulni-intel_asm.S
index eed55c8cc..b35418704 100644
--- a/arch/x86/crypto/ghash-clmulni-intel_asm.S
+++ b/arch/x86/crypto/ghash-clmulni-intel_asm.S
@@ -19,6 +19,7 @@
 #include <linux/linkage.h>
 #include <asm/inst.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 
 .data
 
@@ -90,6 +91,7 @@ __clmul_gf128mul_ble:
 	psrlq $1, T2
 	pxor T2, T1
 	pxor T1, DATA
+	pax_force_retaddr
 	ret
 ENDPROC(__clmul_gf128mul_ble)
 
@@ -104,6 +106,7 @@ ENTRY(clmul_ghash_mul)
 	PSHUFB_XMM BSWAP DATA
 	movups DATA, (%rdi)
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(clmul_ghash_mul)
 
@@ -133,5 +136,6 @@ ENTRY(clmul_ghash_update)
 	movups DATA, (%rdi)
 .Lupdate_just_ret:
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(clmul_ghash_update)
diff --git a/arch/x86/crypto/glue_helper.c b/arch/x86/crypto/glue_helper.c
index 6a8559893..fed2ada5f 100644
--- a/arch/x86/crypto/glue_helper.c
+++ b/arch/x86/crypto/glue_helper.c
@@ -165,7 +165,7 @@ __glue_cbc_decrypt_128bit(const struct common_glue_ctx *gctx,
 				src -= num_blocks - 1;
 				dst -= num_blocks - 1;
 
-				gctx->funcs[i].fn_u.cbc(ctx, dst, src);
+				gctx->funcs[i].fn_u.cbc(ctx, (u8 *)dst, (u8 *)src);
 
 				nbytes -= bsize;
 				if (nbytes < bsize)
diff --git a/arch/x86/crypto/salsa20-x86_64-asm_64.S b/arch/x86/crypto/salsa20-x86_64-asm_64.S
index 9279e0b2d..c4b3d2c41 100644
--- a/arch/x86/crypto/salsa20-x86_64-asm_64.S
+++ b/arch/x86/crypto/salsa20-x86_64-asm_64.S
@@ -1,4 +1,5 @@
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 # enter salsa20_encrypt_bytes
 ENTRY(salsa20_encrypt_bytes)
@@ -789,6 +790,7 @@ ENTRY(salsa20_encrypt_bytes)
 	add	%r11,%rsp
 	mov	%rdi,%rax
 	mov	%rsi,%rdx
+	pax_force_retaddr
 	ret
 #   bytesatleast65:
 ._bytesatleast65:
@@ -889,6 +891,7 @@ ENTRY(salsa20_keysetup)
 	add	%r11,%rsp
 	mov	%rdi,%rax
 	mov	%rsi,%rdx
+	pax_force_retaddr
 	ret
 ENDPROC(salsa20_keysetup)
 
@@ -914,5 +917,6 @@ ENTRY(salsa20_ivsetup)
 	add	%r11,%rsp
 	mov	%rdi,%rax
 	mov	%rsi,%rdx
+	pax_force_retaddr
 	ret
 ENDPROC(salsa20_ivsetup)
diff --git a/arch/x86/crypto/serpent-avx-x86_64-asm_64.S b/arch/x86/crypto/serpent-avx-x86_64-asm_64.S
index 8be571808..d2bcbcd35 100644
--- a/arch/x86/crypto/serpent-avx-x86_64-asm_64.S
+++ b/arch/x86/crypto/serpent-avx-x86_64-asm_64.S
@@ -25,6 +25,7 @@
 
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 #include "glue_helper-asm-avx.S"
 
 .file "serpent-avx-x86_64-asm_64.S"
@@ -619,6 +620,7 @@ __serpent_enc_blk8_avx:
 	write_blocks(RA1, RB1, RC1, RD1, RK0, RK1, RK2);
 	write_blocks(RA2, RB2, RC2, RD2, RK0, RK1, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__serpent_enc_blk8_avx)
 
@@ -673,10 +675,11 @@ __serpent_dec_blk8_avx:
 	write_blocks(RC1, RD1, RB1, RE1, RK0, RK1, RK2);
 	write_blocks(RC2, RD2, RB2, RE2, RK0, RK1, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__serpent_dec_blk8_avx)
 
-ENTRY(serpent_ecb_enc_8way_avx)
+RAP_ENTRY(serpent_ecb_enc_8way_avx)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -691,10 +694,11 @@ ENTRY(serpent_ecb_enc_8way_avx)
 	store_8way(%rsi, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_ecb_enc_8way_avx)
 
-ENTRY(serpent_ecb_dec_8way_avx)
+RAP_ENTRY(serpent_ecb_dec_8way_avx)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -709,10 +713,11 @@ ENTRY(serpent_ecb_dec_8way_avx)
 	store_8way(%rsi, RC1, RD1, RB1, RE1, RC2, RD2, RB2, RE2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_ecb_dec_8way_avx)
 
-ENTRY(serpent_cbc_dec_8way_avx)
+RAP_ENTRY(serpent_cbc_dec_8way_avx)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -727,10 +732,11 @@ ENTRY(serpent_cbc_dec_8way_avx)
 	store_cbc_8way(%rdx, %rsi, RC1, RD1, RB1, RE1, RC2, RD2, RB2, RE2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_cbc_dec_8way_avx)
 
-ENTRY(serpent_ctr_8way_avx)
+RAP_ENTRY(serpent_ctr_8way_avx)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -747,10 +753,11 @@ ENTRY(serpent_ctr_8way_avx)
 	store_ctr_8way(%rdx, %rsi, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_ctr_8way_avx)
 
-ENTRY(serpent_xts_enc_8way_avx)
+RAP_ENTRY(serpent_xts_enc_8way_avx)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -769,10 +776,11 @@ ENTRY(serpent_xts_enc_8way_avx)
 	store_xts_8way(%rsi, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_xts_enc_8way_avx)
 
-ENTRY(serpent_xts_dec_8way_avx)
+RAP_ENTRY(serpent_xts_dec_8way_avx)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -791,5 +799,6 @@ ENTRY(serpent_xts_dec_8way_avx)
 	store_xts_8way(%rsi, RC1, RD1, RB1, RE1, RC2, RD2, RB2, RE2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_xts_dec_8way_avx)
diff --git a/arch/x86/crypto/serpent-avx2-asm_64.S b/arch/x86/crypto/serpent-avx2-asm_64.S
index 97c48add3..25416dedb 100644
--- a/arch/x86/crypto/serpent-avx2-asm_64.S
+++ b/arch/x86/crypto/serpent-avx2-asm_64.S
@@ -16,6 +16,7 @@
 
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 #include "glue_helper-asm-avx2.S"
 
 .file "serpent-avx2-asm_64.S"
@@ -611,6 +612,7 @@ __serpent_enc_blk16:
 	write_blocks(RA1, RB1, RC1, RD1, RK0, RK1, RK2);
 	write_blocks(RA2, RB2, RC2, RD2, RK0, RK1, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__serpent_enc_blk16)
 
@@ -665,10 +667,11 @@ __serpent_dec_blk16:
 	write_blocks(RC1, RD1, RB1, RE1, RK0, RK1, RK2);
 	write_blocks(RC2, RD2, RB2, RE2, RK0, RK1, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__serpent_dec_blk16)
 
-ENTRY(serpent_ecb_enc_16way)
+RAP_ENTRY(serpent_ecb_enc_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -687,10 +690,11 @@ ENTRY(serpent_ecb_enc_16way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_ecb_enc_16way)
 
-ENTRY(serpent_ecb_dec_16way)
+RAP_ENTRY(serpent_ecb_dec_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -709,10 +713,11 @@ ENTRY(serpent_ecb_dec_16way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_ecb_dec_16way)
 
-ENTRY(serpent_cbc_dec_16way)
+RAP_ENTRY(serpent_cbc_dec_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -732,10 +737,11 @@ ENTRY(serpent_cbc_dec_16way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_cbc_dec_16way)
 
-ENTRY(serpent_ctr_16way)
+RAP_ENTRY(serpent_ctr_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -757,10 +763,11 @@ ENTRY(serpent_ctr_16way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_ctr_16way)
 
-ENTRY(serpent_xts_enc_16way)
+RAP_ENTRY(serpent_xts_enc_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -783,10 +790,11 @@ ENTRY(serpent_xts_enc_16way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_xts_enc_16way)
 
-ENTRY(serpent_xts_dec_16way)
+RAP_ENTRY(serpent_xts_dec_16way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst (16 blocks)
@@ -809,5 +817,6 @@ ENTRY(serpent_xts_dec_16way)
 	vzeroupper;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_xts_dec_16way)
diff --git a/arch/x86/crypto/serpent-sse2-x86_64-asm_64.S b/arch/x86/crypto/serpent-sse2-x86_64-asm_64.S
index acc066c7c..1559cc4ff 100644
--- a/arch/x86/crypto/serpent-sse2-x86_64-asm_64.S
+++ b/arch/x86/crypto/serpent-sse2-x86_64-asm_64.S
@@ -25,6 +25,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 .file "serpent-sse2-x86_64-asm_64.S"
 .text
@@ -690,12 +691,14 @@ ENTRY(__serpent_enc_blk_8way)
 	write_blocks(%rsi, RA1, RB1, RC1, RD1, RK0, RK1, RK2);
 	write_blocks(%rax, RA2, RB2, RC2, RD2, RK0, RK1, RK2);
 
+	pax_force_retaddr
 	ret;
 
 .L__enc_xor8:
 	xor_blocks(%rsi, RA1, RB1, RC1, RD1, RK0, RK1, RK2);
 	xor_blocks(%rax, RA2, RB2, RC2, RD2, RK0, RK1, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__serpent_enc_blk_8way)
 
@@ -750,5 +753,6 @@ ENTRY(serpent_dec_blk_8way)
 	write_blocks(%rsi, RC1, RD1, RB1, RE1, RK0, RK1, RK2);
 	write_blocks(%rax, RC2, RD2, RB2, RE2, RK0, RK1, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(serpent_dec_blk_8way)
diff --git a/arch/x86/crypto/serpent_avx2_glue.c b/arch/x86/crypto/serpent_avx2_glue.c
index 870f6d812..9fed18eb7 100644
--- a/arch/x86/crypto/serpent_avx2_glue.c
+++ b/arch/x86/crypto/serpent_avx2_glue.c
@@ -27,18 +27,18 @@
 #define SERPENT_AVX2_PARALLEL_BLOCKS 16
 
 /* 16-way AVX2 parallel cipher functions */
-asmlinkage void serpent_ecb_enc_16way(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_ecb_enc_16way(void *ctx, u8 *dst,
 				      const u8 *src);
-asmlinkage void serpent_ecb_dec_16way(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_ecb_dec_16way(void *ctx, u8 *dst,
 				      const u8 *src);
-asmlinkage void serpent_cbc_dec_16way(void *ctx, u128 *dst, const u128 *src);
+asmlinkage void serpent_cbc_dec_16way(void *ctx, u8 *dst, const u8 *src);
 
 asmlinkage void serpent_ctr_16way(void *ctx, u128 *dst, const u128 *src,
 				  le128 *iv);
-asmlinkage void serpent_xts_enc_16way(struct serpent_ctx *ctx, u8 *dst,
-				      const u8 *src, le128 *iv);
-asmlinkage void serpent_xts_dec_16way(struct serpent_ctx *ctx, u8 *dst,
-				      const u8 *src, le128 *iv);
+asmlinkage void serpent_xts_enc_16way(void *ctx, u128 *dst,
+				      const u128 *src, le128 *iv);
+asmlinkage void serpent_xts_dec_16way(void *ctx, u128 *dst,
+				      const u128 *src, le128 *iv);
 
 static const struct common_glue_ctx serpent_enc = {
 	.num_funcs = 3,
diff --git a/arch/x86/crypto/serpent_avx_glue.c b/arch/x86/crypto/serpent_avx_glue.c
index 6f778d3da..3cf277e02 100644
--- a/arch/x86/crypto/serpent_avx_glue.c
+++ b/arch/x86/crypto/serpent_avx_glue.c
@@ -41,28 +41,28 @@
 #include <asm/crypto/glue_helper.h>
 
 /* 8-way parallel cipher functions */
-asmlinkage void serpent_ecb_enc_8way_avx(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_ecb_enc_8way_avx(void  *ctx, u8 *dst,
 					 const u8 *src);
 EXPORT_SYMBOL_GPL(serpent_ecb_enc_8way_avx);
 
-asmlinkage void serpent_ecb_dec_8way_avx(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_ecb_dec_8way_avx(void *ctx, u8 *dst,
 					 const u8 *src);
 EXPORT_SYMBOL_GPL(serpent_ecb_dec_8way_avx);
 
-asmlinkage void serpent_cbc_dec_8way_avx(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_cbc_dec_8way_avx(void *ctx, u8 *dst,
 					 const u8 *src);
 EXPORT_SYMBOL_GPL(serpent_cbc_dec_8way_avx);
 
-asmlinkage void serpent_ctr_8way_avx(struct serpent_ctx *ctx, u8 *dst,
-				     const u8 *src, le128 *iv);
+asmlinkage void serpent_ctr_8way_avx(void *ctx, u128 *dst,
+				     const u128 *src, le128 *iv);
 EXPORT_SYMBOL_GPL(serpent_ctr_8way_avx);
 
-asmlinkage void serpent_xts_enc_8way_avx(struct serpent_ctx *ctx, u8 *dst,
-					 const u8 *src, le128 *iv);
+asmlinkage void serpent_xts_enc_8way_avx(void *ctx, u128 *dst,
+					 const u128 *src, le128 *iv);
 EXPORT_SYMBOL_GPL(serpent_xts_enc_8way_avx);
 
-asmlinkage void serpent_xts_dec_8way_avx(struct serpent_ctx *ctx, u8 *dst,
-					 const u8 *src, le128 *iv);
+asmlinkage void serpent_xts_dec_8way_avx(void *ctx, u128 *dst,
+					 const u128 *src, le128 *iv);
 EXPORT_SYMBOL_GPL(serpent_xts_dec_8way_avx);
 
 void __serpent_crypt_ctr(void *ctx, u128 *dst, const u128 *src, le128 *iv)
diff --git a/arch/x86/crypto/serpent_sse2_glue.c b/arch/x86/crypto/serpent_sse2_glue.c
index 644f97ab8..4d069a1c5 100644
--- a/arch/x86/crypto/serpent_sse2_glue.c
+++ b/arch/x86/crypto/serpent_sse2_glue.c
@@ -45,8 +45,10 @@
 #include <asm/crypto/serpent-sse2.h>
 #include <asm/crypto/glue_helper.h>
 
-static void serpent_decrypt_cbc_xway(void *ctx, u128 *dst, const u128 *src)
+static void serpent_decrypt_cbc_xway(void *ctx, u8 *_dst, const u8 *_src)
 {
+	u128 *dst = (u128 *)_dst;
+	const u128 *src = (const u128 *)_src;
 	u128 ivs[SERPENT_PARALLEL_BLOCKS - 1];
 	unsigned int j;
 
diff --git a/arch/x86/crypto/sha1-mb/sha1_mb_mgr_flush_avx2.S b/arch/x86/crypto/sha1-mb/sha1_mb_mgr_flush_avx2.S
index 96df6a39d..8519a8fcb 100644
--- a/arch/x86/crypto/sha1-mb/sha1_mb_mgr_flush_avx2.S
+++ b/arch/x86/crypto/sha1-mb/sha1_mb_mgr_flush_avx2.S
@@ -103,7 +103,7 @@ offset = \_offset
 
 # JOB* sha1_mb_mgr_flush_avx2(MB_MGR *state)
 # arg 1 : rcx : state
-ENTRY(sha1_mb_mgr_flush_avx2)
+RAP_ENTRY(sha1_mb_mgr_flush_avx2)
 	FRAME_BEGIN
 	push	%rbx
 
@@ -226,7 +226,7 @@ ENDPROC(sha1_mb_mgr_flush_avx2)
 #################################################################
 
 .align 16
-ENTRY(sha1_mb_mgr_get_comp_job_avx2)
+RAP_ENTRY(sha1_mb_mgr_get_comp_job_avx2)
 	push    %rbx
 
 	## if bit 32+3 is set, then all lanes are empty
diff --git a/arch/x86/crypto/sha1-mb/sha1_mb_mgr_submit_avx2.S b/arch/x86/crypto/sha1-mb/sha1_mb_mgr_submit_avx2.S
index 63a0d9c8e..a6038fdd9 100644
--- a/arch/x86/crypto/sha1-mb/sha1_mb_mgr_submit_avx2.S
+++ b/arch/x86/crypto/sha1-mb/sha1_mb_mgr_submit_avx2.S
@@ -98,7 +98,7 @@ lane_data       = %r10
 # JOB* submit_mb_mgr_submit_avx2(MB_MGR *state, job_sha1 *job)
 # arg 1 : rcx : state
 # arg 2 : rdx : job
-ENTRY(sha1_mb_mgr_submit_avx2)
+RAP_ENTRY(sha1_mb_mgr_submit_avx2)
 	FRAME_BEGIN
 	push	%rbx
 	push	%r12
diff --git a/arch/x86/crypto/sha1_ssse3_asm.S b/arch/x86/crypto/sha1_ssse3_asm.S
index a4109506a..02d2056f1 100644
--- a/arch/x86/crypto/sha1_ssse3_asm.S
+++ b/arch/x86/crypto/sha1_ssse3_asm.S
@@ -29,6 +29,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 #define CTX	%rdi	// arg1
 #define BUF	%rsi	// arg2
@@ -71,13 +72,14 @@
  * param: function's name
  */
 .macro SHA1_VECTOR_ASM  name
-	ENTRY(\name)
+ALIGN
+	RAP_ENTRY(\name)
 
 	push	%rbx
 	push	%rbp
-	push	%r12
+	push	%r14
 
-	mov	%rsp, %r12
+	mov	%rsp, %r14
 	sub	$64, %rsp		# allocate workspace
 	and	$~15, %rsp		# align stack
 
@@ -99,11 +101,12 @@
 	xor	%rax, %rax
 	rep stosq
 
-	mov	%r12, %rsp		# deallocate workspace
+	mov	%r14, %rsp		# deallocate workspace
 
-	pop	%r12
+	pop	%r14
 	pop	%rbp
 	pop	%rbx
+	pax_force_retaddr
 	ret
 
 	ENDPROC(\name)
diff --git a/arch/x86/crypto/sha1_ssse3_glue.c b/arch/x86/crypto/sha1_ssse3_glue.c
index fc6173915..03f7efe90 100644
--- a/arch/x86/crypto/sha1_ssse3_glue.c
+++ b/arch/x86/crypto/sha1_ssse3_glue.c
@@ -31,8 +31,8 @@
 #include <crypto/sha1_base.h>
 #include <asm/fpu/api.h>
 
-typedef void (sha1_transform_fn)(u32 *digest, const char *data,
-				unsigned int rounds);
+typedef void (sha1_transform_fn)(struct sha1_state *digest, const u8 *data,
+				int rounds);
 
 static int sha1_update(struct shash_desc *desc, const u8 *data,
 			     unsigned int len, sha1_transform_fn *sha1_xform)
@@ -47,8 +47,7 @@ static int sha1_update(struct shash_desc *desc, const u8 *data,
 	BUILD_BUG_ON(offsetof(struct sha1_state, state) != 0);
 
 	kernel_fpu_begin();
-	sha1_base_do_update(desc, data, len,
-			    (sha1_block_fn *)sha1_xform);
+	sha1_base_do_update(desc, data, len, sha1_xform);
 	kernel_fpu_end();
 
 	return 0;
@@ -62,29 +61,26 @@ static int sha1_finup(struct shash_desc *desc, const u8 *data,
 
 	kernel_fpu_begin();
 	if (len)
-		sha1_base_do_update(desc, data, len,
-				    (sha1_block_fn *)sha1_xform);
-	sha1_base_do_finalize(desc, (sha1_block_fn *)sha1_xform);
+		sha1_base_do_update(desc, data, len, sha1_xform);
+	sha1_base_do_finalize(desc, sha1_xform);
 	kernel_fpu_end();
 
 	return sha1_base_finish(desc, out);
 }
 
-asmlinkage void sha1_transform_ssse3(u32 *digest, const char *data,
-				     unsigned int rounds);
+asmlinkage void sha1_transform_ssse3(struct sha1_state *digest, const u8 *data,
+				     int rounds);
 
 static int sha1_ssse3_update(struct shash_desc *desc, const u8 *data,
 			     unsigned int len)
 {
-	return sha1_update(desc, data, len,
-			(sha1_transform_fn *) sha1_transform_ssse3);
+	return sha1_update(desc, data, len, sha1_transform_ssse3);
 }
 
 static int sha1_ssse3_finup(struct shash_desc *desc, const u8 *data,
 			      unsigned int len, u8 *out)
 {
-	return sha1_finup(desc, data, len, out,
-			(sha1_transform_fn *) sha1_transform_ssse3);
+	return sha1_finup(desc, data, len, out, sha1_transform_ssse3);
 }
 
 /* Add padding and return the message digest. */
@@ -124,21 +120,19 @@ static void unregister_sha1_ssse3(void)
 }
 
 #ifdef CONFIG_AS_AVX
-asmlinkage void sha1_transform_avx(u32 *digest, const char *data,
-				   unsigned int rounds);
+asmlinkage void sha1_transform_avx(struct sha1_state *digest, const u8 *data,
+				   int rounds);
 
 static int sha1_avx_update(struct shash_desc *desc, const u8 *data,
 			     unsigned int len)
 {
-	return sha1_update(desc, data, len,
-			(sha1_transform_fn *) sha1_transform_avx);
+	return sha1_update(desc, data, len, sha1_transform_avx);
 }
 
 static int sha1_avx_finup(struct shash_desc *desc, const u8 *data,
 			      unsigned int len, u8 *out)
 {
-	return sha1_finup(desc, data, len, out,
-			(sha1_transform_fn *) sha1_transform_avx);
+	return sha1_finup(desc, data, len, out, sha1_transform_avx);
 }
 
 static int sha1_avx_final(struct shash_desc *desc, u8 *out)
@@ -196,8 +190,8 @@ static inline void unregister_sha1_avx(void) { }
 #if defined(CONFIG_AS_AVX2) && (CONFIG_AS_AVX)
 #define SHA1_AVX2_BLOCK_OPTSIZE	4	/* optimal 4*64 bytes of SHA1 blocks */
 
-asmlinkage void sha1_transform_avx2(u32 *digest, const char *data,
-				    unsigned int rounds);
+asmlinkage void sha1_transform_avx2(struct sha1_state *digest, const u8 *data,
+				    int rounds);
 
 static bool avx2_usable(void)
 {
@@ -209,8 +203,8 @@ static bool avx2_usable(void)
 	return false;
 }
 
-static void sha1_apply_transform_avx2(u32 *digest, const char *data,
-				unsigned int rounds)
+static void sha1_apply_transform_avx2(struct sha1_state *digest, const u8 *data,
+				int rounds)
 {
 	/* Select the optimal transform based on data block size */
 	if (rounds >= SHA1_AVX2_BLOCK_OPTSIZE)
@@ -222,15 +216,13 @@ static void sha1_apply_transform_avx2(u32 *digest, const char *data,
 static int sha1_avx2_update(struct shash_desc *desc, const u8 *data,
 			     unsigned int len)
 {
-	return sha1_update(desc, data, len,
-		(sha1_transform_fn *) sha1_apply_transform_avx2);
+	return sha1_update(desc, data, len, sha1_apply_transform_avx2);
 }
 
 static int sha1_avx2_finup(struct shash_desc *desc, const u8 *data,
 			      unsigned int len, u8 *out)
 {
-	return sha1_finup(desc, data, len, out,
-		(sha1_transform_fn *) sha1_apply_transform_avx2);
+	return sha1_finup(desc, data, len, out, sha1_apply_transform_avx2);
 }
 
 static int sha1_avx2_final(struct shash_desc *desc, u8 *out)
@@ -274,21 +266,19 @@ static inline void unregister_sha1_avx2(void) { }
 #endif
 
 #ifdef CONFIG_AS_SHA1_NI
-asmlinkage void sha1_ni_transform(u32 *digest, const char *data,
-				   unsigned int rounds);
+asmlinkage void sha1_ni_transform(struct sha1_state *digest, const u8 *data,
+				   int rounds);
 
 static int sha1_ni_update(struct shash_desc *desc, const u8 *data,
 			     unsigned int len)
 {
-	return sha1_update(desc, data, len,
-		(sha1_transform_fn *) sha1_ni_transform);
+	return sha1_update(desc, data, len, sha1_ni_transform);
 }
 
 static int sha1_ni_finup(struct shash_desc *desc, const u8 *data,
 			      unsigned int len, u8 *out)
 {
-	return sha1_finup(desc, data, len, out,
-		(sha1_transform_fn *) sha1_ni_transform);
+	return sha1_finup(desc, data, len, out, sha1_ni_transform);
 }
 
 static int sha1_ni_final(struct shash_desc *desc, u8 *out)
diff --git a/arch/x86/crypto/sha256-avx-asm.S b/arch/x86/crypto/sha256-avx-asm.S
index 92b3b5d75..8732479e6 100644
--- a/arch/x86/crypto/sha256-avx-asm.S
+++ b/arch/x86/crypto/sha256-avx-asm.S
@@ -49,6 +49,7 @@
 
 #ifdef CONFIG_AS_AVX
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 ## assume buffers not aligned
 #define    VMOVDQ vmovdqu
@@ -347,8 +348,7 @@ a = TMP_
 ## arg 3 : Num blocks
 ########################################################################
 .text
-ENTRY(sha256_transform_avx)
-.align 32
+RAP_ENTRY(sha256_transform_avx)
 	pushq   %rbx
 	pushq   %rbp
 	pushq   %r13
@@ -460,6 +460,7 @@ done_hash:
 	popq    %r13
 	popq    %rbp
 	popq    %rbx
+	pax_force_retaddr
 	ret
 ENDPROC(sha256_transform_avx)
 
diff --git a/arch/x86/crypto/sha256-avx2-asm.S b/arch/x86/crypto/sha256-avx2-asm.S
index 570ec5ec6..9bcfa252a 100644
--- a/arch/x86/crypto/sha256-avx2-asm.S
+++ b/arch/x86/crypto/sha256-avx2-asm.S
@@ -50,6 +50,7 @@
 
 #ifdef CONFIG_AS_AVX2
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 ## assume buffers not aligned
 #define	VMOVDQ vmovdqu
@@ -528,8 +529,7 @@ STACK_SIZE	= _RSP      + _RSP_SIZE
 ## arg 3 : Num blocks
 ########################################################################
 .text
-ENTRY(sha256_transform_rorx)
-.align 32
+RAP_ENTRY(sha256_transform_rorx)
 	pushq	%rbx
 	pushq	%rbp
 	pushq	%r12
@@ -720,6 +720,7 @@ done_hash:
 	popq	%r12
 	popq	%rbp
 	popq	%rbx
+	pax_force_retaddr
 	ret
 ENDPROC(sha256_transform_rorx)
 
diff --git a/arch/x86/crypto/sha256-mb/sha256_mb_mgr_flush_avx2.S b/arch/x86/crypto/sha256-mb/sha256_mb_mgr_flush_avx2.S
index a78a0694d..127cb66d2 100644
--- a/arch/x86/crypto/sha256-mb/sha256_mb_mgr_flush_avx2.S
+++ b/arch/x86/crypto/sha256-mb/sha256_mb_mgr_flush_avx2.S
@@ -101,7 +101,7 @@ offset = \_offset
 
 # JOB_SHA256* sha256_mb_mgr_flush_avx2(MB_MGR *state)
 # arg 1 : rcx : state
-ENTRY(sha256_mb_mgr_flush_avx2)
+RAP_ENTRY(sha256_mb_mgr_flush_avx2)
 	FRAME_BEGIN
         push    %rbx
 
@@ -225,7 +225,7 @@ ENDPROC(sha256_mb_mgr_flush_avx2)
 ##############################################################################
 
 .align 16
-ENTRY(sha256_mb_mgr_get_comp_job_avx2)
+RAP_ENTRY(sha256_mb_mgr_get_comp_job_avx2)
 	push	%rbx
 
 	## if bit 32+3 is set, then all lanes are empty
diff --git a/arch/x86/crypto/sha256-mb/sha256_mb_mgr_submit_avx2.S b/arch/x86/crypto/sha256-mb/sha256_mb_mgr_submit_avx2.S
index 7ea670e25..5aa297a55 100644
--- a/arch/x86/crypto/sha256-mb/sha256_mb_mgr_submit_avx2.S
+++ b/arch/x86/crypto/sha256-mb/sha256_mb_mgr_submit_avx2.S
@@ -96,7 +96,7 @@ lane_data	= %r10
 # JOB* sha256_mb_mgr_submit_avx2(MB_MGR *state, JOB_SHA256 *job)
 # arg 1 : rcx : state
 # arg 2 : rdx : job
-ENTRY(sha256_mb_mgr_submit_avx2)
+RAP_ENTRY(sha256_mb_mgr_submit_avx2)
 	FRAME_BEGIN
 	push	%rbx
 	push	%r12
diff --git a/arch/x86/crypto/sha256-ssse3-asm.S b/arch/x86/crypto/sha256-ssse3-asm.S
index 2cedc44e8..6fb85823b 100644
--- a/arch/x86/crypto/sha256-ssse3-asm.S
+++ b/arch/x86/crypto/sha256-ssse3-asm.S
@@ -47,6 +47,7 @@
 ########################################################################
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 ## assume buffers not aligned
 #define    MOVDQ movdqu
@@ -352,9 +353,7 @@ a = TMP_
 ## arg 2 : pointer to input data
 ## arg 3 : Num blocks
 ########################################################################
-.text
-ENTRY(sha256_transform_ssse3)
-.align 32
+RAP_ENTRY(sha256_transform_ssse3)
 	pushq   %rbx
 	pushq   %rbp
 	pushq   %r13
@@ -471,6 +470,7 @@ done_hash:
 	popq    %rbp
 	popq    %rbx
 
+	pax_force_retaddr
 	ret
 ENDPROC(sha256_transform_ssse3)
 
diff --git a/arch/x86/crypto/sha256_ni_asm.S b/arch/x86/crypto/sha256_ni_asm.S
index 748cdf21a..959bb4d59 100644
--- a/arch/x86/crypto/sha256_ni_asm.S
+++ b/arch/x86/crypto/sha256_ni_asm.S
@@ -97,7 +97,7 @@
 
 .text
 .align 32
-ENTRY(sha256_ni_transform)
+RAP_ENTRY(sha256_ni_transform)
 
 	shl		$6, NUM_BLKS		/*  convert to bytes */
 	jz		.Ldone_hash
diff --git a/arch/x86/crypto/sha256_ssse3_glue.c b/arch/x86/crypto/sha256_ssse3_glue.c
index 9e79baf03..c5186c743 100644
--- a/arch/x86/crypto/sha256_ssse3_glue.c
+++ b/arch/x86/crypto/sha256_ssse3_glue.c
@@ -40,9 +40,9 @@
 #include <asm/fpu/api.h>
 #include <linux/string.h>
 
-asmlinkage void sha256_transform_ssse3(u32 *digest, const char *data,
-				       u64 rounds);
-typedef void (sha256_transform_fn)(u32 *digest, const char *data, u64 rounds);
+asmlinkage void sha256_transform_ssse3(struct sha256_state *digest, const u8 *data,
+				       int rounds);
+typedef void (sha256_transform_fn)(struct sha256_state *digest, const u8 *data, int rounds);
 
 static int sha256_update(struct shash_desc *desc, const u8 *data,
 			 unsigned int len, sha256_transform_fn *sha256_xform)
@@ -57,8 +57,7 @@ static int sha256_update(struct shash_desc *desc, const u8 *data,
 	BUILD_BUG_ON(offsetof(struct sha256_state, state) != 0);
 
 	kernel_fpu_begin();
-	sha256_base_do_update(desc, data, len,
-			      (sha256_block_fn *)sha256_xform);
+	sha256_base_do_update(desc, data, len, sha256_xform);
 	kernel_fpu_end();
 
 	return 0;
@@ -72,9 +71,8 @@ static int sha256_finup(struct shash_desc *desc, const u8 *data,
 
 	kernel_fpu_begin();
 	if (len)
-		sha256_base_do_update(desc, data, len,
-				      (sha256_block_fn *)sha256_xform);
-	sha256_base_do_finalize(desc, (sha256_block_fn *)sha256_xform);
+		sha256_base_do_update(desc, data, len, sha256_xform);
+	sha256_base_do_finalize(desc, sha256_xform);
 	kernel_fpu_end();
 
 	return sha256_base_finish(desc, out);
@@ -146,8 +144,8 @@ static void unregister_sha256_ssse3(void)
 }
 
 #ifdef CONFIG_AS_AVX
-asmlinkage void sha256_transform_avx(u32 *digest, const char *data,
-				     u64 rounds);
+asmlinkage void sha256_transform_avx(struct sha256_state *digest, const u8 *data,
+				     int rounds);
 
 static int sha256_avx_update(struct shash_desc *desc, const u8 *data,
 			 unsigned int len)
@@ -230,8 +228,8 @@ static inline void unregister_sha256_avx(void) { }
 #endif
 
 #if defined(CONFIG_AS_AVX2) && defined(CONFIG_AS_AVX)
-asmlinkage void sha256_transform_rorx(u32 *digest, const char *data,
-				      u64 rounds);
+asmlinkage void sha256_transform_rorx(struct sha256_state *digest, const u8 *data,
+				      int rounds);
 
 static int sha256_avx2_update(struct shash_desc *desc, const u8 *data,
 			 unsigned int len)
@@ -312,8 +310,8 @@ static inline void unregister_sha256_avx2(void) { }
 #endif
 
 #ifdef CONFIG_AS_SHA256_NI
-asmlinkage void sha256_ni_transform(u32 *digest, const char *data,
-				   u64 rounds); /*unsigned int rounds);*/
+asmlinkage void sha256_ni_transform(struct sha256_state *digest, const u8 *data,
+				   int rounds); /*unsigned int rounds);*/
 
 static int sha256_ni_update(struct shash_desc *desc, const u8 *data,
 			 unsigned int len)
diff --git a/arch/x86/crypto/sha512-avx-asm.S b/arch/x86/crypto/sha512-avx-asm.S
index 565274d6a..779d34a4f 100644
--- a/arch/x86/crypto/sha512-avx-asm.S
+++ b/arch/x86/crypto/sha512-avx-asm.S
@@ -49,6 +49,7 @@
 
 #ifdef CONFIG_AS_AVX
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 .text
 
@@ -277,7 +278,8 @@ frame_size = frame_GPRSAVE + GPRSAVE_SIZE
 # message blocks.
 # L is the message length in SHA512 blocks
 ########################################################################
-ENTRY(sha512_transform_avx)
+ALIGN
+RAP_ENTRY(sha512_transform_avx)
 	cmp $0, msglen
 	je nowork
 
@@ -364,6 +366,7 @@ updateblock:
 	mov	frame_RSPSAVE(%rsp), %rsp
 
 nowork:
+	pax_force_retaddr
 	ret
 ENDPROC(sha512_transform_avx)
 
diff --git a/arch/x86/crypto/sha512-avx2-asm.S b/arch/x86/crypto/sha512-avx2-asm.S
index 1f20b35d8..ab1f3a838 100644
--- a/arch/x86/crypto/sha512-avx2-asm.S
+++ b/arch/x86/crypto/sha512-avx2-asm.S
@@ -51,6 +51,7 @@
 
 #ifdef CONFIG_AS_AVX2
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 .text
 
@@ -568,7 +569,8 @@ frame_size = frame_GPRSAVE + GPRSAVE_SIZE
 #   message blocks.
 # L is the message length in SHA512 blocks
 ########################################################################
-ENTRY(sha512_transform_rorx)
+ALIGN
+RAP_ENTRY(sha512_transform_rorx)
 	# Allocate Stack Space
 	mov	%rsp, %rax
 	sub	$frame_size, %rsp
@@ -678,6 +680,7 @@ done_hash:
 
 	# Restore Stack Pointer
 	mov	frame_RSPSAVE(%rsp), %rsp
+	pax_force_retaddr
 	ret
 ENDPROC(sha512_transform_rorx)
 
diff --git a/arch/x86/crypto/sha512-mb/sha512_mb_mgr_flush_avx2.S b/arch/x86/crypto/sha512-mb/sha512_mb_mgr_flush_avx2.S
index 3ddba19a0..2d3abc732 100644
--- a/arch/x86/crypto/sha512-mb/sha512_mb_mgr_flush_avx2.S
+++ b/arch/x86/crypto/sha512-mb/sha512_mb_mgr_flush_avx2.S
@@ -107,7 +107,7 @@ offset = \_offset
 
 # JOB* sha512_mb_mgr_flush_avx2(MB_MGR *state)
 # arg 1 : rcx : state
-ENTRY(sha512_mb_mgr_flush_avx2)
+RAP_ENTRY(sha512_mb_mgr_flush_avx2)
 	FRAME_BEGIN
 	push	%rbx
 
@@ -220,7 +220,7 @@ return_null:
 ENDPROC(sha512_mb_mgr_flush_avx2)
 .align 16
 
-ENTRY(sha512_mb_mgr_get_comp_job_avx2)
+RAP_ENTRY(sha512_mb_mgr_get_comp_job_avx2)
         push    %rbx
 
 	mov     _unused_lanes(state), unused_lanes
diff --git a/arch/x86/crypto/sha512-mb/sha512_mb_mgr_submit_avx2.S b/arch/x86/crypto/sha512-mb/sha512_mb_mgr_submit_avx2.S
index 815f07bdd..70fbc7b51 100644
--- a/arch/x86/crypto/sha512-mb/sha512_mb_mgr_submit_avx2.S
+++ b/arch/x86/crypto/sha512-mb/sha512_mb_mgr_submit_avx2.S
@@ -98,7 +98,7 @@
 # JOB* sha512_mb_mgr_submit_avx2(MB_MGR *state, JOB *job)
 # arg 1 : rcx : state
 # arg 2 : rdx : job
-ENTRY(sha512_mb_mgr_submit_avx2)
+RAP_ENTRY(sha512_mb_mgr_submit_avx2)
 	FRAME_BEGIN
 	push	%rbx
 	push	%r12
diff --git a/arch/x86/crypto/sha512-ssse3-asm.S b/arch/x86/crypto/sha512-ssse3-asm.S
index e610e29cb..83f1cdee1 100644
--- a/arch/x86/crypto/sha512-ssse3-asm.S
+++ b/arch/x86/crypto/sha512-ssse3-asm.S
@@ -48,6 +48,7 @@
 ########################################################################
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 .text
 
@@ -275,7 +276,8 @@ frame_size = frame_GPRSAVE + GPRSAVE_SIZE
 #   message blocks.
 # L is the message length in SHA512 blocks.
 ########################################################################
-ENTRY(sha512_transform_ssse3)
+ALIGN
+RAP_ENTRY(sha512_transform_ssse3)
 
 	cmp $0, msglen
 	je nowork
@@ -363,6 +365,7 @@ updateblock:
 	mov	frame_RSPSAVE(%rsp), %rsp
 
 nowork:
+	pax_force_retaddr
 	ret
 ENDPROC(sha512_transform_ssse3)
 
diff --git a/arch/x86/crypto/sha512_ssse3_glue.c b/arch/x86/crypto/sha512_ssse3_glue.c
index 2b0e2a682..59a1f9446 100644
--- a/arch/x86/crypto/sha512_ssse3_glue.c
+++ b/arch/x86/crypto/sha512_ssse3_glue.c
@@ -39,10 +39,10 @@
 
 #include <linux/string.h>
 
-asmlinkage void sha512_transform_ssse3(u64 *digest, const char *data,
-				       u64 rounds);
+asmlinkage void sha512_transform_ssse3(struct sha512_state *digest, const u8 *data,
+				       int rounds);
 
-typedef void (sha512_transform_fn)(u64 *digest, const char *data, u64 rounds);
+typedef void (sha512_transform_fn)(struct sha512_state *digest, const u8 *data, int rounds);
 
 static int sha512_update(struct shash_desc *desc, const u8 *data,
 		       unsigned int len, sha512_transform_fn *sha512_xform)
@@ -57,8 +57,7 @@ static int sha512_update(struct shash_desc *desc, const u8 *data,
 	BUILD_BUG_ON(offsetof(struct sha512_state, state) != 0);
 
 	kernel_fpu_begin();
-	sha512_base_do_update(desc, data, len,
-			      (sha512_block_fn *)sha512_xform);
+	sha512_base_do_update(desc, data, len, sha512_xform);
 	kernel_fpu_end();
 
 	return 0;
@@ -72,9 +71,8 @@ static int sha512_finup(struct shash_desc *desc, const u8 *data,
 
 	kernel_fpu_begin();
 	if (len)
-		sha512_base_do_update(desc, data, len,
-				      (sha512_block_fn *)sha512_xform);
-	sha512_base_do_finalize(desc, (sha512_block_fn *)sha512_xform);
+		sha512_base_do_update(desc, data, len, sha512_xform);
+	sha512_base_do_finalize(desc, sha512_xform);
 	kernel_fpu_end();
 
 	return sha512_base_finish(desc, out);
@@ -146,8 +144,8 @@ static void unregister_sha512_ssse3(void)
 }
 
 #ifdef CONFIG_AS_AVX
-asmlinkage void sha512_transform_avx(u64 *digest, const char *data,
-				     u64 rounds);
+asmlinkage void sha512_transform_avx(struct sha512_state *digest, const u8 *data,
+				     int rounds);
 static bool avx_usable(void)
 {
 	if (!cpu_has_xfeatures(XFEATURE_MASK_SSE | XFEATURE_MASK_YMM, NULL)) {
@@ -229,8 +227,8 @@ static inline void unregister_sha512_avx(void) { }
 #endif
 
 #if defined(CONFIG_AS_AVX2) && defined(CONFIG_AS_AVX)
-asmlinkage void sha512_transform_rorx(u64 *digest, const char *data,
-				      u64 rounds);
+asmlinkage void sha512_transform_rorx(struct sha512_state *digest, const u8 *data,
+				      int rounds);
 
 static int sha512_avx2_update(struct shash_desc *desc, const u8 *data,
 		       unsigned int len)
diff --git a/arch/x86/crypto/twofish-avx-x86_64-asm_64.S b/arch/x86/crypto/twofish-avx-x86_64-asm_64.S
index dc66273e6..30aba4bb6 100644
--- a/arch/x86/crypto/twofish-avx-x86_64-asm_64.S
+++ b/arch/x86/crypto/twofish-avx-x86_64-asm_64.S
@@ -25,6 +25,7 @@
 
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 #include "glue_helper-asm-avx.S"
 
 .file "twofish-avx-x86_64-asm_64.S"
@@ -285,6 +286,7 @@ __twofish_enc_blk8:
 	outunpack_blocks(RC1, RD1, RA1, RB1, RK1, RX0, RY0, RK2);
 	outunpack_blocks(RC2, RD2, RA2, RB2, RK1, RX0, RY0, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__twofish_enc_blk8)
 
@@ -325,10 +327,11 @@ __twofish_dec_blk8:
 	outunpack_blocks(RA1, RB1, RC1, RD1, RK1, RX0, RY0, RK2);
 	outunpack_blocks(RA2, RB2, RC2, RD2, RK1, RX0, RY0, RK2);
 
+	pax_force_retaddr
 	ret;
 ENDPROC(__twofish_dec_blk8)
 
-ENTRY(twofish_ecb_enc_8way)
+RAP_ENTRY(twofish_ecb_enc_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -345,10 +348,11 @@ ENTRY(twofish_ecb_enc_8way)
 	store_8way(%r11, RC1, RD1, RA1, RB1, RC2, RD2, RA2, RB2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(twofish_ecb_enc_8way)
 
-ENTRY(twofish_ecb_dec_8way)
+RAP_ENTRY(twofish_ecb_dec_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -365,10 +369,11 @@ ENTRY(twofish_ecb_dec_8way)
 	store_8way(%r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(twofish_ecb_dec_8way)
 
-ENTRY(twofish_cbc_dec_8way)
+RAP_ENTRY(twofish_cbc_dec_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -376,24 +381,25 @@ ENTRY(twofish_cbc_dec_8way)
 	 */
 	FRAME_BEGIN
 
-	pushq %r12;
+	pushq %r14;
 
 	movq %rsi, %r11;
-	movq %rdx, %r12;
+	movq %rdx, %r14;
 
 	load_8way(%rdx, RC1, RD1, RA1, RB1, RC2, RD2, RA2, RB2);
 
 	call __twofish_dec_blk8;
 
-	store_cbc_8way(%r12, %r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
+	store_cbc_8way(%r14, %r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
-	popq %r12;
+	popq %r14;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(twofish_cbc_dec_8way)
 
-ENTRY(twofish_ctr_8way)
+RAP_ENTRY(twofish_ctr_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -402,25 +408,26 @@ ENTRY(twofish_ctr_8way)
 	 */
 	FRAME_BEGIN
 
-	pushq %r12;
+	pushq %r14;
 
 	movq %rsi, %r11;
-	movq %rdx, %r12;
+	movq %rdx, %r14;
 
 	load_ctr_8way(%rcx, .Lbswap128_mask, RA1, RB1, RC1, RD1, RA2, RB2, RC2,
 		      RD2, RX0, RX1, RY0);
 
 	call __twofish_enc_blk8;
 
-	store_ctr_8way(%r12, %r11, RC1, RD1, RA1, RB1, RC2, RD2, RA2, RB2);
+	store_ctr_8way(%r14, %r11, RC1, RD1, RA1, RB1, RC2, RD2, RA2, RB2);
 
-	popq %r12;
+	popq %r14;
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(twofish_ctr_8way)
 
-ENTRY(twofish_xts_enc_8way)
+RAP_ENTRY(twofish_xts_enc_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -441,10 +448,11 @@ ENTRY(twofish_xts_enc_8way)
 	store_xts_8way(%r11, RC1, RD1, RA1, RB1, RC2, RD2, RA2, RB2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(twofish_xts_enc_8way)
 
-ENTRY(twofish_xts_dec_8way)
+RAP_ENTRY(twofish_xts_dec_8way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -465,5 +473,6 @@ ENTRY(twofish_xts_dec_8way)
 	store_xts_8way(%r11, RA1, RB1, RC1, RD1, RA2, RB2, RC2, RD2);
 
 	FRAME_END
+	pax_force_retaddr
 	ret;
 ENDPROC(twofish_xts_dec_8way)
diff --git a/arch/x86/crypto/twofish-i586-asm_32.S b/arch/x86/crypto/twofish-i586-asm_32.S
index 694ea4587..f2c141827 100644
--- a/arch/x86/crypto/twofish-i586-asm_32.S
+++ b/arch/x86/crypto/twofish-i586-asm_32.S
@@ -220,7 +220,7 @@
 	xor	%esi,		d ## D;\
 	ror	$1,		d ## D;
 
-ENTRY(twofish_enc_blk)
+RAP_ENTRY(twofish_enc_blk)
 	push	%ebp			/* save registers according to calling convention*/
 	push    %ebx
 	push    %esi
@@ -276,7 +276,7 @@ ENTRY(twofish_enc_blk)
 	ret
 ENDPROC(twofish_enc_blk)
 
-ENTRY(twofish_dec_blk)
+RAP_ENTRY(twofish_dec_blk)
 	push	%ebp			/* save registers according to calling convention*/
 	push    %ebx
 	push    %esi
diff --git a/arch/x86/crypto/twofish-x86_64-asm_64-3way.S b/arch/x86/crypto/twofish-x86_64-asm_64-3way.S
index 1c3b7ceb3..c9912c72b 100644
--- a/arch/x86/crypto/twofish-x86_64-asm_64-3way.S
+++ b/arch/x86/crypto/twofish-x86_64-asm_64-3way.S
@@ -21,6 +21,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 .file "twofish-x86_64-asm-3way.S"
 .text
@@ -258,6 +259,7 @@ ENTRY(__twofish_enc_blk_3way)
 	popq %r13;
 	popq %r14;
 	popq %r15;
+	pax_force_retaddr
 	ret;
 
 .L__enc_xor3:
@@ -269,10 +271,11 @@ ENTRY(__twofish_enc_blk_3way)
 	popq %r13;
 	popq %r14;
 	popq %r15;
+	pax_force_retaddr
 	ret;
 ENDPROC(__twofish_enc_blk_3way)
 
-ENTRY(twofish_dec_blk_3way)
+RAP_ENTRY(twofish_dec_blk_3way)
 	/* input:
 	 *	%rdi: ctx, CTX
 	 *	%rsi: dst
@@ -308,5 +311,6 @@ ENTRY(twofish_dec_blk_3way)
 	popq %r13;
 	popq %r14;
 	popq %r15;
+	pax_force_retaddr
 	ret;
 ENDPROC(twofish_dec_blk_3way)
diff --git a/arch/x86/crypto/twofish-x86_64-asm_64.S b/arch/x86/crypto/twofish-x86_64-asm_64.S
index a350c990d..080c5ab3e 100644
--- a/arch/x86/crypto/twofish-x86_64-asm_64.S
+++ b/arch/x86/crypto/twofish-x86_64-asm_64.S
@@ -22,6 +22,7 @@
 
 #include <linux/linkage.h>
 #include <asm/asm-offsets.h>
+#include <asm/alternative-asm.h>
 
 #define a_offset	0
 #define b_offset	4
@@ -215,7 +216,7 @@
 	xor	%r8d,		d ## D;\
 	ror	$1,		d ## D;
 
-ENTRY(twofish_enc_blk)
+RAP_ENTRY(twofish_enc_blk)
 	pushq    R1
 
 	/* %rdi contains the ctx address */
@@ -265,10 +266,11 @@ ENTRY(twofish_enc_blk)
 
 	popq	R1
 	movl	$1,%eax
+	pax_force_retaddr
 	ret
 ENDPROC(twofish_enc_blk)
 
-ENTRY(twofish_dec_blk)
+RAP_ENTRY(twofish_dec_blk)
 	pushq    R1
 
 	/* %rdi contains the ctx address */
@@ -317,5 +319,6 @@ ENTRY(twofish_dec_blk)
 
 	popq	R1
 	movl	$1,%eax
+	pax_force_retaddr
 	ret
 ENDPROC(twofish_dec_blk)
diff --git a/arch/x86/crypto/twofish_avx_glue.c b/arch/x86/crypto/twofish_avx_glue.c
index b7a3904b9..3e4d0d6e1 100644
--- a/arch/x86/crypto/twofish_avx_glue.c
+++ b/arch/x86/crypto/twofish_avx_glue.c
@@ -46,24 +46,25 @@
 #define TWOFISH_PARALLEL_BLOCKS 8
 
 /* 8-way parallel cipher functions */
-asmlinkage void twofish_ecb_enc_8way(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_ecb_enc_8way(void *ctx, u8 *dst,
 				     const u8 *src);
-asmlinkage void twofish_ecb_dec_8way(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_ecb_dec_8way(void *ctx, u8 *dst,
 				     const u8 *src);
 
-asmlinkage void twofish_cbc_dec_8way(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_cbc_dec_8way(void *ctx, u8 *dst,
 				     const u8 *src);
-asmlinkage void twofish_ctr_8way(struct twofish_ctx *ctx, u8 *dst,
-				 const u8 *src, le128 *iv);
+asmlinkage void twofish_ctr_8way(void *ctx, u128 *dst,
+				 const u128 *src, le128 *iv);
 
-asmlinkage void twofish_xts_enc_8way(struct twofish_ctx *ctx, u8 *dst,
-				     const u8 *src, le128 *iv);
-asmlinkage void twofish_xts_dec_8way(struct twofish_ctx *ctx, u8 *dst,
-				     const u8 *src, le128 *iv);
+asmlinkage void twofish_xts_enc_8way(void *ctx, u128 *dst,
+				     const u128 *src, le128 *iv);
+asmlinkage void twofish_xts_dec_8way(void *ctx, u128 *dst,
+				     const u128 *src, le128 *iv);
 
-static inline void twofish_enc_blk_3way(struct twofish_ctx *ctx, u8 *dst,
+static inline void twofish_enc_blk_3way(void *_ctx, u8 *dst,
 					const u8 *src)
 {
+	struct twofish_ctx *ctx = _ctx;
 	__twofish_enc_blk_3way(ctx, dst, src, false);
 }
 
diff --git a/arch/x86/crypto/twofish_glue.c b/arch/x86/crypto/twofish_glue.c
index 77e06c2da..a45c27b26 100644
--- a/arch/x86/crypto/twofish_glue.c
+++ b/arch/x86/crypto/twofish_glue.c
@@ -44,10 +44,10 @@
 #include <linux/module.h>
 #include <linux/types.h>
 
-asmlinkage void twofish_enc_blk(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_enc_blk(void *ctx, u8 *dst,
 				const u8 *src);
 EXPORT_SYMBOL_GPL(twofish_enc_blk);
-asmlinkage void twofish_dec_blk(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_dec_blk(void *ctx, u8 *dst,
 				const u8 *src);
 EXPORT_SYMBOL_GPL(twofish_dec_blk);
 
diff --git a/arch/x86/crypto/twofish_glue_3way.c b/arch/x86/crypto/twofish_glue_3way.c
index 2ebb5e978..a0b0aa93c 100644
--- a/arch/x86/crypto/twofish_glue_3way.c
+++ b/arch/x86/crypto/twofish_glue_3way.c
@@ -36,21 +36,21 @@
 EXPORT_SYMBOL_GPL(__twofish_enc_blk_3way);
 EXPORT_SYMBOL_GPL(twofish_dec_blk_3way);
 
-static inline void twofish_enc_blk_3way(struct twofish_ctx *ctx, u8 *dst,
+static inline void twofish_enc_blk_3way(void *ctx, u8 *dst,
 					const u8 *src)
 {
 	__twofish_enc_blk_3way(ctx, dst, src, false);
 }
 
-static inline void twofish_enc_blk_xor_3way(struct twofish_ctx *ctx, u8 *dst,
+static inline void twofish_enc_blk_xor_3way(void *ctx, u8 *dst,
 					    const u8 *src)
 {
 	__twofish_enc_blk_3way(ctx, dst, src, true);
 }
 
-void twofish_dec_blk_cbc_3way(void *ctx, u128 *dst, const u128 *src)
+void twofish_dec_blk_cbc_3way(void *ctx, u8 *_dst, const u8 *_src)
 {
-	u128 ivs[2];
+	u128 ivs[2], *dst = (u128 *)_dst, *src = (u128 *)_src;
 
 	ivs[0] = src[0];
 	ivs[1] = src[1];
@@ -118,10 +118,10 @@ static const struct common_glue_ctx twofish_ctr = {
 
 	.funcs = { {
 		.num_blocks = 3,
-		.fn_u = { .ecb = GLUE_FUNC_CAST(twofish_enc_blk_ctr_3way) }
+		.fn_u = { .ctr = GLUE_CTR_FUNC_CAST(twofish_enc_blk_ctr_3way) }
 	}, {
 		.num_blocks = 1,
-		.fn_u = { .ecb = GLUE_FUNC_CAST(twofish_enc_blk_ctr) }
+		.fn_u = { .ctr = GLUE_CTR_FUNC_CAST(twofish_enc_blk_ctr) }
 	} }
 };
 
diff --git a/arch/x86/entry/Makefile b/arch/x86/entry/Makefile
index 9976fcecd..bf5f3e0da 100644
--- a/arch/x86/entry/Makefile
+++ b/arch/x86/entry/Makefile
@@ -15,3 +15,5 @@ obj-y				+= vsyscall/
 
 obj-$(CONFIG_IA32_EMULATION)	+= entry_64_compat.o syscall_32.o
 
+CFLAGS_REMOVE_syscall_32.o = $(RAP_PLUGIN_ABS_CFLAGS)
+CFLAGS_REMOVE_syscall_64.o = $(RAP_PLUGIN_ABS_CFLAGS)
diff --git a/arch/x86/entry/calling.h b/arch/x86/entry/calling.h
index 9a9e58840..b900d1cf9 100644
--- a/arch/x86/entry/calling.h
+++ b/arch/x86/entry/calling.h
@@ -95,23 +95,26 @@ For 32-bit we have the following conventions - kernel is built with
 	.endm
 
 	.macro SAVE_C_REGS_HELPER offset=0 rax=1 rcx=1 r8910=1 r11=1
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	movq %r12, R12+\offset(%rsp)
+#endif
 	.if \r11
-	movq %r11, 6*8+\offset(%rsp)
+	movq %r11, R11+\offset(%rsp)
 	.endif
 	.if \r8910
-	movq %r10, 7*8+\offset(%rsp)
-	movq %r9,  8*8+\offset(%rsp)
-	movq %r8,  9*8+\offset(%rsp)
+	movq %r10, R10+\offset(%rsp)
+	movq %r9,  R9+\offset(%rsp)
+	movq %r8,  R8+\offset(%rsp)
 	.endif
 	.if \rax
-	movq %rax, 10*8+\offset(%rsp)
+	movq %rax, RAX+\offset(%rsp)
 	.endif
 	.if \rcx
-	movq %rcx, 11*8+\offset(%rsp)
+	movq %rcx, RCX+\offset(%rsp)
 	.endif
-	movq %rdx, 12*8+\offset(%rsp)
-	movq %rsi, 13*8+\offset(%rsp)
-	movq %rdi, 14*8+\offset(%rsp)
+	movq %rdx, RDX+\offset(%rsp)
+	movq %rsi, RSI+\offset(%rsp)
+	movq %rdi, RDI+\offset(%rsp)
 	.endm
 	.macro SAVE_C_REGS offset=0
 	SAVE_C_REGS_HELPER \offset, 1, 1, 1, 1
@@ -130,67 +133,78 @@ For 32-bit we have the following conventions - kernel is built with
 	.endm
 
 	.macro SAVE_EXTRA_REGS offset=0
-	movq %r15, 0*8+\offset(%rsp)
-	movq %r14, 1*8+\offset(%rsp)
-	movq %r13, 2*8+\offset(%rsp)
-	movq %r12, 3*8+\offset(%rsp)
-	movq %rbp, 4*8+\offset(%rsp)
-	movq %rbx, 5*8+\offset(%rsp)
+	movq %r15, R15+\offset(%rsp)
+	movq %r14, R14+\offset(%rsp)
+	movq %r13, R13+\offset(%rsp)
+#ifndef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	movq %r12, R12+\offset(%rsp)
+#endif
+	movq %rbp, RBP+\offset(%rsp)
+	movq %rbx, RBX+\offset(%rsp)
 	.endm
 
 	.macro RESTORE_EXTRA_REGS offset=0
-	movq 0*8+\offset(%rsp), %r15
-	movq 1*8+\offset(%rsp), %r14
-	movq 2*8+\offset(%rsp), %r13
-	movq 3*8+\offset(%rsp), %r12
-	movq 4*8+\offset(%rsp), %rbp
-	movq 5*8+\offset(%rsp), %rbx
+	movq R15+\offset(%rsp), %r15
+	movq R14+\offset(%rsp), %r14
+	movq R13+\offset(%rsp), %r13
+#ifndef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	movq R12+\offset(%rsp), %r12
+#endif
+	movq RBP+\offset(%rsp), %rbp
+	movq RBX+\offset(%rsp), %rbx
 	.endm
 
 	.macro ZERO_EXTRA_REGS
 	xorl	%r15d, %r15d
 	xorl	%r14d, %r14d
 	xorl	%r13d, %r13d
+#ifndef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
 	xorl	%r12d, %r12d
+#endif
 	xorl	%ebp, %ebp
 	xorl	%ebx, %ebx
 	.endm
 
-	.macro RESTORE_C_REGS_HELPER rstor_rax=1, rstor_rcx=1, rstor_r11=1, rstor_r8910=1, rstor_rdx=1
+	.macro RESTORE_C_REGS_HELPER rstor_rax=1, rstor_rcx=1, rstor_r11=1, rstor_r8910=1, rstor_rdx=1, rstor_r12=1
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	.if \rstor_r12
+	movq R12(%rsp), %r12
+	.endif
+#endif
 	.if \rstor_r11
-	movq 6*8(%rsp), %r11
+	movq R11(%rsp), %r11
 	.endif
 	.if \rstor_r8910
-	movq 7*8(%rsp), %r10
-	movq 8*8(%rsp), %r9
-	movq 9*8(%rsp), %r8
+	movq R10(%rsp), %r10
+	movq R9(%rsp), %r9
+	movq R8(%rsp), %r8
 	.endif
 	.if \rstor_rax
-	movq 10*8(%rsp), %rax
+	movq RAX(%rsp), %rax
 	.endif
 	.if \rstor_rcx
-	movq 11*8(%rsp), %rcx
+	movq RCX(%rsp), %rcx
 	.endif
 	.if \rstor_rdx
-	movq 12*8(%rsp), %rdx
+	movq RDX(%rsp), %rdx
 	.endif
-	movq 13*8(%rsp), %rsi
-	movq 14*8(%rsp), %rdi
+	movq RSI(%rsp), %rsi
+	movq RDI(%rsp), %rdi
 	.endm
 	.macro RESTORE_C_REGS
-	RESTORE_C_REGS_HELPER 1,1,1,1,1
+	RESTORE_C_REGS_HELPER 1,1,1,1,1,1
 	.endm
 	.macro RESTORE_C_REGS_EXCEPT_RAX
-	RESTORE_C_REGS_HELPER 0,1,1,1,1
+	RESTORE_C_REGS_HELPER 0,1,1,1,1,0
 	.endm
 	.macro RESTORE_C_REGS_EXCEPT_RCX
-	RESTORE_C_REGS_HELPER 1,0,1,1,1
+	RESTORE_C_REGS_HELPER 1,0,1,1,1,0
 	.endm
 	.macro RESTORE_C_REGS_EXCEPT_R11
-	RESTORE_C_REGS_HELPER 1,1,0,1,1
+	RESTORE_C_REGS_HELPER 1,1,0,1,1,1
 	.endm
 	.macro RESTORE_C_REGS_EXCEPT_RCX_R11
-	RESTORE_C_REGS_HELPER 1,0,0,1,1
+	RESTORE_C_REGS_HELPER 1,0,0,1,1,1
 	.endm
 
 	.macro REMOVE_PT_GPREGS_FROM_STACK addskip=0
diff --git a/arch/x86/entry/common.c b/arch/x86/entry/common.c
index 1433f6b46..dac4cbe4d 100644
--- a/arch/x86/entry/common.c
+++ b/arch/x86/entry/common.c
@@ -33,9 +33,7 @@
 
 static struct thread_info *pt_regs_to_thread_info(struct pt_regs *regs)
 {
-	unsigned long top_of_stack =
-		(unsigned long)(regs + 1) + TOP_OF_KERNEL_STACK_PADDING;
-	return (struct thread_info *)(top_of_stack - THREAD_SIZE);
+	return current_thread_info();
 }
 
 #ifdef CONFIG_CONTEXT_TRACKING
@@ -49,6 +47,12 @@ __visible inline void enter_from_user_mode(void)
 static inline void enter_from_user_mode(void) {}
 #endif
 
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+asmlinkage void pax_erase_kstack(void);
+#else
+static void pax_erase_kstack(void) {}
+#endif
+
 static void do_audit_syscall_entry(struct pt_regs *regs, u32 arch)
 {
 #ifdef CONFIG_X86_64
@@ -63,6 +67,10 @@ static void do_audit_syscall_entry(struct pt_regs *regs, u32 arch)
 	}
 }
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+extern void gr_delayed_cred_worker(void);
+#endif
+
 /*
  * Returns the syscall nr to run (which should match regs->orig_ax) or -1
  * to skip the syscall.
@@ -81,12 +89,19 @@ static long syscall_trace_enter(struct pt_regs *regs)
 
 	work = ACCESS_ONCE(ti->flags) & _TIF_WORK_SYSCALL_ENTRY;
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	if (unlikely(work & _TIF_SYSCALL_EMU))
 		emulated = true;
 
 	if ((emulated || (work & _TIF_SYSCALL_TRACE)) &&
-	    tracehook_report_syscall_entry(regs))
+	    tracehook_report_syscall_entry(regs)) {
+		pax_erase_kstack();
 		return -1L;
+	}
 
 	if (emulated)
 		return -1L;
@@ -121,8 +136,10 @@ static long syscall_trace_enter(struct pt_regs *regs)
 		}
 
 		ret = __secure_computing(&sd);
-		if (ret == -1)
+		if (ret == -1) {
+			pax_erase_kstack();
 			return ret;
+		}
 	}
 #endif
 
@@ -131,6 +148,7 @@ static long syscall_trace_enter(struct pt_regs *regs)
 
 	do_audit_syscall_entry(regs, arch);
 
+	pax_erase_kstack();
 	return ret ?: regs->orig_ax;
 }
 
@@ -237,7 +255,7 @@ static void syscall_slow_exit_work(struct pt_regs *regs, u32 cached_flags)
 	step = unlikely(
 		(cached_flags & (_TIF_SINGLESTEP | _TIF_SYSCALL_EMU))
 		== _TIF_SINGLESTEP);
-	if (step || cached_flags & _TIF_SYSCALL_TRACE)
+	if (step || (cached_flags & _TIF_SYSCALL_TRACE))
 		tracehook_report_syscall_exit(regs, step);
 }
 
@@ -256,6 +274,11 @@ __visible inline void syscall_return_slowpath(struct pt_regs *regs)
 	    WARN(irqs_disabled(), "syscall %ld left IRQs disabled", regs->orig_ax))
 		local_irq_enable();
 
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (unlikely(test_and_clear_thread_flag(TIF_GRSEC_SETXID)))
+		gr_delayed_cred_worker();
+#endif
+
 	/*
 	 * First do one-time work.  If these work items are enabled, we
 	 * want to run them exactly once per syscall exit with IRQs on.
@@ -285,9 +308,29 @@ __visible void do_syscall_64(struct pt_regs *regs)
 	 * regs->orig_ax, which changes the behavior of some syscalls.
 	 */
 	if (likely((nr & __SYSCALL_MASK) < NR_syscalls)) {
+#ifdef CONFIG_PAX_RAP
+		asm volatile("movq %[param1],%%rdi\n\t"
+			     "movq %[param2],%%rsi\n\t"
+			     "movq %[param3],%%rdx\n\t"
+			     "movq %[param4],%%rcx\n\t"
+			     "movq %[param5],%%r8\n\t"
+			     "movq %[param6],%%r9\n\t"
+			     "call *%P[syscall]\n\t"
+			     "mov %%rax,%[result]\n\t"
+			: [result] "=m" (regs->ax)
+			: [syscall] "m" (sys_call_table[nr & __SYSCALL_MASK]),
+			  [param1] "m" (regs->di),
+			  [param2] "m" (regs->si),
+			  [param3] "m" (regs->dx),
+			  [param4] "m" (regs->r10),
+			  [param5] "m" (regs->r8),
+			  [param6] "m" (regs->r9)
+			: "ax", "di", "si", "dx", "cx", "r8", "r9", "r10", "r11", "memory");
+#else
 		regs->ax = sys_call_table[nr & __SYSCALL_MASK](
 			regs->di, regs->si, regs->dx,
 			regs->r10, regs->r8, regs->r9);
+#endif
 	}
 
 	syscall_return_slowpath(regs);
@@ -327,10 +370,51 @@ static __always_inline void do_syscall_32_irqs_on(struct pt_regs *regs)
 		 * the high bits are zero.  Make sure we zero-extend all
 		 * of the args.
 		 */
+#ifdef CONFIG_PAX_RAP
+#ifdef CONFIG_X86_64
+		asm volatile("movl %[param1],%%edi\n\t"
+			     "movl %[param2],%%esi\n\t"
+			     "movl %[param3],%%edx\n\t"
+			     "movl %[param4],%%ecx\n\t"
+			     "movl %[param5],%%r8d\n\t"
+			     "movl %[param6],%%r9d\n\t"
+			     "call *%P[syscall]\n\t"
+			     "mov %%rax,%[result]\n\t"
+			: [result] "=m" (regs->ax)
+			: [syscall] "m" (ia32_sys_call_table[nr]),
+			  [param1] "m" (regs->bx),
+			  [param2] "m" (regs->cx),
+			  [param3] "m" (regs->dx),
+			  [param4] "m" (regs->si),
+			  [param5] "m" (regs->di),
+			  [param6] "m" (regs->bp)
+			: "ax", "di", "si", "dx", "cx", "r8", "r9", "r10", "r11", "memory");
+#else
+		asm volatile("pushl %[param6]\n\t"
+			     "pushl %[param5]\n\t"
+			     "pushl %[param4]\n\t"
+			     "pushl %[param3]\n\t"
+			     "pushl %[param2]\n\t"
+			     "pushl %[param1]\n\t"
+			     "call *%P[syscall]\n\t"
+			     "addl $6*8,%%esp\n\t"
+			     "mov %%eax,%[result]\n\t"
+			: [result] "=m" (regs->ax)
+			: [syscall] "m" (ia32_sys_call_table[nr]),
+			  [param1] "m" (regs->bx),
+			  [param2] "m" (regs->cx),
+			  [param3] "m" (regs->dx),
+			  [param4] "m" (regs->si),
+			  [param5] "m" (regs->di),
+			  [param6] "m" (regs->bp)
+			: "ax", "dx", "cx", "memory");
+#endif
+#else
 		regs->ax = ia32_sys_call_table[nr](
 			(unsigned int)regs->bx, (unsigned int)regs->cx,
 			(unsigned int)regs->dx, (unsigned int)regs->si,
 			(unsigned int)regs->di, (unsigned int)regs->bp);
+#endif
 	}
 
 	syscall_return_slowpath(regs);
@@ -354,6 +438,7 @@ __visible long do_fast_syscall_32(struct pt_regs *regs)
 
 	unsigned long landing_pad = (unsigned long)current->mm->context.vdso +
 		vdso_image_32.sym_int80_landing_pad;
+	u32 __user *saved_bp = (u32 __force_user *)(unsigned long)(u32)regs->sp;
 
 	/*
 	 * SYSENTER loses EIP, and even SYSCALL32 needs us to skip forward
@@ -373,11 +458,9 @@ __visible long do_fast_syscall_32(struct pt_regs *regs)
 		 * Micro-optimization: the pointer we're following is explicitly
 		 * 32 bits, so it can't be out of range.
 		 */
-		__get_user(*(u32 *)&regs->bp,
-			    (u32 __user __force *)(unsigned long)(u32)regs->sp)
+		__get_user_nocheck(*(u32 *)&regs->bp, saved_bp, sizeof(u32))
 #else
-		get_user(*(u32 *)&regs->bp,
-			 (u32 __user __force *)(unsigned long)(u32)regs->sp)
+		get_user(regs->bp, saved_bp)
 #endif
 		) {
 
diff --git a/arch/x86/entry/entry_32.S b/arch/x86/entry/entry_32.S
index b84a34969..7ed55b6a7 100644
--- a/arch/x86/entry/entry_32.S
+++ b/arch/x86/entry/entry_32.S
@@ -147,13 +147,157 @@
 	movl	\reg, PT_GS(%esp)
 .endm
 .macro SET_KERNEL_GS reg
+
+#ifdef CONFIG_CC_STACKPROTECTOR
 	movl	$(__KERNEL_STACK_CANARY), \reg
+#elif defined(CONFIG_PAX_MEMORY_UDEREF)
+	movl $(__USER_DS), \reg
+#else
+	xorl \reg, \reg
+#endif
+
 	movl	\reg, %gs
 .endm
 
 #endif /* CONFIG_X86_32_LAZY_GS */
 
-.macro SAVE_ALL pt_regs_ax=%eax
+.macro pax_enter_kernel
+#ifdef CONFIG_PAX_KERNEXEC
+	call pax_enter_kernel
+#endif
+.endm
+
+.macro pax_exit_kernel
+#ifdef CONFIG_PAX_KERNEXEC
+	call pax_exit_kernel
+#endif
+.endm
+
+#ifdef CONFIG_PAX_KERNEXEC
+ENTRY(pax_enter_kernel)
+#ifdef CONFIG_PARAVIRT
+	pushl %eax
+	pushl %ecx
+	call PARA_INDIRECT(pv_cpu_ops+PV_CPU_read_cr0)
+	mov %eax, %esi
+#else
+	mov %cr0, %esi
+#endif
+	bts $X86_CR0_WP_BIT, %esi
+	jnc 1f
+	mov %cs, %esi
+	cmp $__KERNEL_CS, %esi
+	jz 3f
+	ljmp $__KERNEL_CS, $3f
+1:	ljmp $__KERNEXEC_KERNEL_CS, $2f
+2:
+#ifdef CONFIG_PARAVIRT
+	mov %esi, %eax
+	call PARA_INDIRECT(pv_cpu_ops+PV_CPU_write_cr0)
+#else
+	mov %esi, %cr0
+#endif
+3:
+#ifdef CONFIG_PARAVIRT
+	popl %ecx
+	popl %eax
+#endif
+	ret
+ENDPROC(pax_enter_kernel)
+
+ENTRY(pax_exit_kernel)
+#ifdef CONFIG_PARAVIRT
+	pushl %eax
+	pushl %ecx
+#endif
+	mov %cs, %esi
+	cmp $__KERNEXEC_KERNEL_CS, %esi
+	jnz 2f
+#ifdef CONFIG_PARAVIRT
+	call PARA_INDIRECT(pv_cpu_ops+PV_CPU_read_cr0);
+	mov %eax, %esi
+#else
+	mov %cr0, %esi
+#endif
+	btr $X86_CR0_WP_BIT, %esi
+	ljmp $__KERNEL_CS, $1f
+1:
+#ifdef CONFIG_PARAVIRT
+	mov %esi, %eax
+	call PARA_INDIRECT(pv_cpu_ops+PV_CPU_write_cr0);
+#else
+	mov %esi, %cr0
+#endif
+2:
+#ifdef CONFIG_PARAVIRT
+	popl %ecx
+	popl %eax
+#endif
+	ret
+ENDPROC(pax_exit_kernel)
+#endif
+
+	.macro pax_erase_kstack
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+	call pax_erase_kstack
+#endif
+	.endm
+
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+/*
+ * ebp: thread_info
+ */
+ENTRY(pax_erase_kstack)
+	pushl %edi
+	pushl %ecx
+	pushl %eax
+	pushl %ebp
+
+	GET_THREAD_INFO(%ebp)
+	mov TI_lowest_stack(%ebp), %edi
+	mov $-0xBEEF, %eax
+	std
+
+1:	mov %edi, %ecx
+	and $THREAD_SIZE_asm - 1, %ecx
+	shr $2, %ecx
+	repne scasl
+	jecxz 2f
+
+	cmp $2*16, %ecx
+	jc 2f
+
+	mov $2*16, %ecx
+	repe scasl
+	jecxz 2f
+	jne 1b
+
+2:	cld
+	or $2*4, %edi
+	mov %esp, %ecx
+	sub %edi, %ecx
+
+	cmp $THREAD_SIZE_asm, %ecx
+	jb 3f
+	ud2
+3:
+
+	shr $2, %ecx
+	rep stosl
+
+	mov TI_task_thread_sp0(%ebp), %edi
+	sub $128, %edi
+	mov %edi, TI_lowest_stack(%ebp)
+
+	popl %ebp
+	popl %eax
+	popl %ecx
+	popl %edi
+	ret
+ENDPROC(pax_erase_kstack)
+#endif
+
+.macro __SAVE_ALL pt_regs_ax, _DS
 	cld
 	PUSH_GS
 	pushl	%fs
@@ -166,7 +310,7 @@
 	pushl	%edx
 	pushl	%ecx
 	pushl	%ebx
-	movl	$(__USER_DS), %edx
+	movl	$\_DS, %edx
 	movl	%edx, %ds
 	movl	%edx, %es
 	movl	$(__KERNEL_PERCPU), %edx
@@ -174,6 +318,15 @@
 	SET_KERNEL_GS %edx
 .endm
 
+.macro SAVE_ALL pt_regs_ax=%eax
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	__SAVE_ALL \pt_regs_ax, __KERNEL_DS
+	pax_enter_kernel
+#else
+	__SAVE_ALL \pt_regs_ax, __USER_DS
+#endif
+.endm
+
 .macro RESTORE_INT_REGS
 	popl	%ebx
 	popl	%ecx
@@ -213,7 +366,7 @@ ENTRY(ret_from_fork)
 	movl    %esp, %eax
 	call    syscall_return_slowpath
 	jmp     restore_all
-END(ret_from_fork)
+ENDPROC(ret_from_fork)
 
 ENTRY(ret_from_kernel_thread)
 	pushl	%eax
@@ -257,15 +410,23 @@ ret_from_intr:
 	andl	$SEGMENT_RPL_MASK, %eax
 #endif
 	cmpl	$USER_RPL, %eax
+
+#ifdef CONFIG_PAX_KERNEXEC
+	jae	resume_userspace
+
+	pax_exit_kernel
+	jmp	resume_kernel
+#else
 	jb	resume_kernel			# not returning to v8086 or userspace
+#endif
 
 ENTRY(resume_userspace)
 	DISABLE_INTERRUPTS(CLBR_ANY)
 	TRACE_IRQS_OFF
 	movl	%esp, %eax
 	call	prepare_exit_to_usermode
-	jmp	restore_all
-END(ret_from_exception)
+	jmp	.Lsyscall_32_done
+ENDPROC(ret_from_exception)
 
 #ifdef CONFIG_PREEMPT
 ENTRY(resume_kernel)
@@ -277,7 +438,7 @@ need_resched:
 	jz	restore_all
 	call	preempt_schedule_irq
 	jmp	need_resched
-END(resume_kernel)
+ENDPROC(resume_kernel)
 #endif
 
 GLOBAL(__begin_SYSENTER_singlestep_region)
@@ -344,6 +505,10 @@ sysenter_past_esp:
 	pushl	%eax			/* pt_regs->orig_ax */
 	SAVE_ALL pt_regs_ax=$-ENOSYS	/* save rest */
 
+#ifdef CONFIG_PAX_RANDKSTACK
+	pax_erase_kstack
+#endif
+
 	/*
 	 * SYSENTER doesn't filter flags, so we need to clear NT, AC
 	 * and TF ourselves.  To save a few cycles, we can check whether
@@ -379,11 +544,20 @@ sysenter_past_esp:
 	ALTERNATIVE "testl %eax, %eax; jz .Lsyscall_32_done", \
 		    "jmp .Lsyscall_32_done", X86_FEATURE_XENPV
 
+#ifdef CONFIG_PAX_RANDKSTACK
+	movl	%esp, %eax
+	call	pax_randomize_kstack
+#endif
+
+	pax_erase_kstack
+
 /* Opportunistic SYSEXIT */
 	TRACE_IRQS_ON			/* User mode traces as IRQs on. */
 	movl	PT_EIP(%esp), %edx	/* pt_regs->ip */
 	movl	PT_OLDESP(%esp), %ecx	/* pt_regs->sp */
 1:	mov	PT_FS(%esp), %fs
+2:	mov	PT_DS(%esp), %ds
+3:	mov	PT_ES(%esp), %es
 	PTGS_TO_GS
 	popl	%ebx			/* pt_regs->bx */
 	addl	$2*4, %esp		/* skip pt_regs->cx and pt_regs->dx */
@@ -409,10 +583,16 @@ sysenter_past_esp:
 	sysexit
 
 .pushsection .fixup, "ax"
-2:	movl	$0, PT_FS(%esp)
+4:	movl	$0, PT_FS(%esp)
+	jmp	1b
+5:	movl	$0, PT_DS(%esp)
+	jmp	1b
+6:	movl	$0, PT_ES(%esp)
 	jmp	1b
 .popsection
-	_ASM_EXTABLE(1b, 2b)
+	_ASM_EXTABLE(1b, 4b)
+	_ASM_EXTABLE(2b, 5b)
+	_ASM_EXTABLE(3b, 6b)
 	PTGS_TO_GS_EX
 
 .Lsysenter_fix_flags:
@@ -455,6 +635,10 @@ ENTRY(entry_INT80_32)
 	pushl	%eax			/* pt_regs->orig_ax */
 	SAVE_ALL pt_regs_ax=$-ENOSYS	/* save rest */
 
+#ifdef CONFIG_PAX_RANDKSTACK
+	pax_erase_kstack
+#endif
+
 	/*
 	 * User mode is traced as though IRQs are on, and the interrupt gate
 	 * turned them off.
@@ -465,6 +649,13 @@ ENTRY(entry_INT80_32)
 	call	do_int80_syscall_32
 .Lsyscall_32_done:
 
+#ifdef CONFIG_PAX_RANDKSTACK
+	movl	%esp, %eax
+	call	pax_randomize_kstack
+#endif
+
+	pax_erase_kstack
+
 restore_all:
 	TRACE_IRQS_IRET
 restore_all_notrace:
@@ -508,14 +699,34 @@ ldt_ss:
  * compensating for the offset by changing to the ESPFIX segment with
  * a base address that matches for the difference.
  */
-#define GDT_ESPFIX_SS PER_CPU_VAR(gdt_page) + (GDT_ENTRY_ESPFIX_SS * 8)
+#define GDT_ESPFIX_SS (GDT_ENTRY_ESPFIX_SS * 8)(%ebx)
 	mov	%esp, %edx			/* load kernel esp */
 	mov	PT_OLDESP(%esp), %eax		/* load userspace esp */
 	mov	%dx, %ax			/* eax: new kernel esp */
 	sub	%eax, %edx			/* offset (low word is 0) */
+#ifdef CONFIG_SMP
+	movl	PER_CPU_VAR(cpu_number), %ebx
+	shll	$PAGE_SHIFT_asm, %ebx
+	addl	$cpu_gdt_table, %ebx
+#else
+	movl	$cpu_gdt_table, %ebx
+#endif
 	shr	$16, %edx
-	mov	%dl, GDT_ESPFIX_SS + 4		/* bits 16..23 */
-	mov	%dh, GDT_ESPFIX_SS + 7		/* bits 24..31 */
+
+#ifdef CONFIG_PAX_KERNEXEC
+	mov	%cr0, %esi
+	btr	$X86_CR0_WP_BIT, %esi
+	mov	%esi, %cr0
+#endif
+
+	mov	%dl, 4 + GDT_ESPFIX_SS /* bits 16..23 */
+	mov	%dh, 7 + GDT_ESPFIX_SS /* bits 24..31 */
+
+#ifdef CONFIG_PAX_KERNEXEC
+	bts	$X86_CR0_WP_BIT, %esi
+	mov	%esi, %cr0
+#endif
+
 	pushl	$__ESPFIX_SS
 	pushl	%eax				/* new kernel esp */
 	/*
@@ -539,8 +750,15 @@ ENDPROC(entry_INT80_32)
  */
 #ifdef CONFIG_X86_ESPFIX32
 	/* fixup the stack */
-	mov	GDT_ESPFIX_SS + 4, %al /* bits 16..23 */
-	mov	GDT_ESPFIX_SS + 7, %ah /* bits 24..31 */
+#ifdef CONFIG_SMP
+	movl	PER_CPU_VAR(cpu_number), %ebx
+	shll	$PAGE_SHIFT_asm, %ebx
+	addl	$cpu_gdt_table, %ebx
+#else
+	movl	$cpu_gdt_table, %ebx
+#endif
+	mov	4 + GDT_ESPFIX_SS, %al /* bits 16..23 */
+	mov	7 + GDT_ESPFIX_SS, %ah /* bits 24..31 */
 	shl	$16, %eax
 	addl	%esp, %eax			/* the adjusted stack pointer */
 	pushl	$__KERNEL_DS
@@ -576,7 +794,7 @@ ENTRY(irq_entries_start)
 	jmp	common_interrupt
 	.align	8
     .endr
-END(irq_entries_start)
+ENDPROC(irq_entries_start)
 
 /*
  * the CPU automatically disables interrupts when executing an IRQ vector,
@@ -623,7 +841,7 @@ ENTRY(coprocessor_error)
 	pushl	$0
 	pushl	$do_coprocessor_error
 	jmp	error_code
-END(coprocessor_error)
+ENDPROC(coprocessor_error)
 
 ENTRY(simd_coprocessor_error)
 	ASM_CLAC
@@ -637,20 +855,20 @@ ENTRY(simd_coprocessor_error)
 	pushl	$do_simd_coprocessor_error
 #endif
 	jmp	error_code
-END(simd_coprocessor_error)
+ENDPROC(simd_coprocessor_error)
 
 ENTRY(device_not_available)
 	ASM_CLAC
 	pushl	$-1				# mark this as an int
 	pushl	$do_device_not_available
 	jmp	error_code
-END(device_not_available)
+ENDPROC(device_not_available)
 
 #ifdef CONFIG_PARAVIRT
 ENTRY(native_iret)
 	iret
 	_ASM_EXTABLE(native_iret, iret_exc)
-END(native_iret)
+ENDPROC(native_iret)
 #endif
 
 ENTRY(overflow)
@@ -658,59 +876,59 @@ ENTRY(overflow)
 	pushl	$0
 	pushl	$do_overflow
 	jmp	error_code
-END(overflow)
+ENDPROC(overflow)
 
 ENTRY(bounds)
 	ASM_CLAC
 	pushl	$0
 	pushl	$do_bounds
 	jmp	error_code
-END(bounds)
+ENDPROC(bounds)
 
 ENTRY(invalid_op)
 	ASM_CLAC
 	pushl	$0
 	pushl	$do_invalid_op
 	jmp	error_code
-END(invalid_op)
+ENDPROC(invalid_op)
 
 ENTRY(coprocessor_segment_overrun)
 	ASM_CLAC
 	pushl	$0
 	pushl	$do_coprocessor_segment_overrun
 	jmp	error_code
-END(coprocessor_segment_overrun)
+ENDPROC(coprocessor_segment_overrun)
 
 ENTRY(invalid_TSS)
 	ASM_CLAC
 	pushl	$do_invalid_TSS
 	jmp	error_code
-END(invalid_TSS)
+ENDPROC(invalid_TSS)
 
 ENTRY(segment_not_present)
 	ASM_CLAC
 	pushl	$do_segment_not_present
 	jmp	error_code
-END(segment_not_present)
+ENDPROC(segment_not_present)
 
 ENTRY(stack_segment)
 	ASM_CLAC
 	pushl	$do_stack_segment
 	jmp	error_code
-END(stack_segment)
+ENDPROC(stack_segment)
 
 ENTRY(alignment_check)
 	ASM_CLAC
 	pushl	$do_alignment_check
 	jmp	error_code
-END(alignment_check)
+ENDPROC(alignment_check)
 
 ENTRY(divide_error)
 	ASM_CLAC
 	pushl	$0				# no error code
 	pushl	$do_divide_error
 	jmp	error_code
-END(divide_error)
+ENDPROC(divide_error)
 
 #ifdef CONFIG_X86_MCE
 ENTRY(machine_check)
@@ -718,7 +936,7 @@ ENTRY(machine_check)
 	pushl	$0
 	pushl	machine_check_vector
 	jmp	error_code
-END(machine_check)
+ENDPROC(machine_check)
 #endif
 
 ENTRY(spurious_interrupt_bug)
@@ -726,7 +944,16 @@ ENTRY(spurious_interrupt_bug)
 	pushl	$0
 	pushl	$do_spurious_interrupt_bug
 	jmp	error_code
-END(spurious_interrupt_bug)
+ENDPROC(spurious_interrupt_bug)
+
+#ifdef CONFIG_PAX_REFCOUNT
+ENTRY(refcount_error)
+	ASM_CLAC
+	pushl	$0
+	pushl	$do_refcount_error
+	jmp	error_code
+ENDPROC(refcount_error)
+#endif
 
 #ifdef CONFIG_XEN
 ENTRY(xen_hypervisor_callback)
@@ -825,7 +1052,7 @@ BUILD_INTERRUPT3(hyperv_callback_vector, HYPERVISOR_CALLBACK_VECTOR,
 
 ENTRY(mcount)
 	ret
-END(mcount)
+ENDPROC(mcount)
 
 ENTRY(ftrace_caller)
 	pushl	%eax
@@ -855,7 +1082,7 @@ ftrace_graph_call:
 /* This is weak to keep gas from relaxing the jumps */
 WEAK(ftrace_stub)
 	ret
-END(ftrace_caller)
+ENDPROC(ftrace_caller)
 
 ENTRY(ftrace_regs_caller)
 	pushf	/* push flags before compare (in cs location) */
@@ -953,7 +1180,7 @@ trace:
 	popl	%ecx
 	popl	%eax
 	jmp	ftrace_stub
-END(mcount)
+ENDPROC(mcount)
 #endif /* CONFIG_DYNAMIC_FTRACE */
 #endif /* CONFIG_FUNCTION_TRACER */
 
@@ -971,7 +1198,7 @@ ENTRY(ftrace_graph_caller)
 	popl	%ecx
 	popl	%eax
 	ret
-END(ftrace_graph_caller)
+ENDPROC(ftrace_graph_caller)
 
 .globl return_to_handler
 return_to_handler:
@@ -990,7 +1217,7 @@ ENTRY(trace_page_fault)
 	ASM_CLAC
 	pushl	$trace_do_page_fault
 	jmp	error_code
-END(trace_page_fault)
+ENDPROC(trace_page_fault)
 #endif
 
 ENTRY(page_fault)
@@ -1019,16 +1246,19 @@ error_code:
 	movl	$-1, PT_ORIG_EAX(%esp)		# no syscall to restart
 	REG_TO_PTGS %ecx
 	SET_KERNEL_GS %ecx
-	movl	$(__USER_DS), %ecx
+	movl	$(__KERNEL_DS), %ecx
 	movl	%ecx, %ds
 	movl	%ecx, %es
+
+	pax_enter_kernel
+
 	TRACE_IRQS_OFF
 	movl	%esp, %eax			# pt_regs pointer
 	call	*%edi
 	jmp	ret_from_exception
-END(page_fault)
+ENDPROC(page_fault)
 
-ENTRY(debug)
+ENTRY(int1)
 	/*
 	 * #DB can happen at the first instruction of
 	 * entry_SYSENTER_32 or in Xen's SYSENTER prologue.  If this
@@ -1045,7 +1275,13 @@ ENTRY(debug)
 	movl	%esp, %eax			# pt_regs pointer
 
 	/* Are we currently on the SYSENTER stack? */
-	PER_CPU(cpu_tss + CPU_TSS_SYSENTER_stack + SIZEOF_SYSENTER_stack, %ecx)
+#ifdef CONFIG_SMP
+	imul	$TSS_size, PER_CPU_VAR(cpu_number), %ecx
+	lea	cpu_tss(%ecx), %ecx
+#else
+	movl	$cpu_tss, %ecx
+#endif
+	movl	CPU_TSS_SYSENTER_stack + SIZEOF_SYSENTER_stack(%ecx), %ecx
 	subl	%eax, %ecx	/* ecx = (end of SYSENTER_stack) - esp */
 	cmpl	$SIZEOF_SYSENTER_stack, %ecx
 	jb	.Ldebug_from_sysenter_stack
@@ -1062,7 +1298,7 @@ ENTRY(debug)
 	call	do_debug
 	movl	%ebp, %esp
 	jmp	ret_from_exception
-END(debug)
+ENDPROC(int1)
 
 /*
  * NMI is doubly nasty.  It can happen on the first instruction of
@@ -1087,13 +1323,22 @@ ENTRY(nmi)
 	movl	%esp, %eax			# pt_regs pointer
 
 	/* Are we currently on the SYSENTER stack? */
-	PER_CPU(cpu_tss + CPU_TSS_SYSENTER_stack + SIZEOF_SYSENTER_stack, %ecx)
+#ifdef CONFIG_SMP
+	imul	$TSS_size, PER_CPU_VAR(cpu_number), %ecx
+	lea	cpu_tss(%ecx), %ecx
+#else
+	movl	$cpu_tss, %ecx
+#endif
+	movl	CPU_TSS_SYSENTER_stack + SIZEOF_SYSENTER_stack(%ecx), %ecx
 	subl	%eax, %ecx	/* ecx = (end of SYSENTER_stack) - esp */
 	cmpl	$SIZEOF_SYSENTER_stack, %ecx
 	jb	.Lnmi_from_sysenter_stack
 
 	/* Not on SYSENTER stack. */
 	call	do_nmi
+
+	pax_exit_kernel
+
 	jmp	restore_all_notrace
 
 .Lnmi_from_sysenter_stack:
@@ -1105,6 +1350,9 @@ ENTRY(nmi)
 	movl	PER_CPU_VAR(cpu_current_top_of_stack), %esp
 	call	do_nmi
 	movl	%ebp, %esp
+
+	pax_exit_kernel
+
 	jmp	restore_all_notrace
 
 #ifdef CONFIG_X86_ESPFIX32
@@ -1124,11 +1372,14 @@ nmi_espfix_stack:
 	FIXUP_ESPFIX_STACK			# %eax == %esp
 	xorl	%edx, %edx			# zero error code
 	call	do_nmi
+
+	pax_exit_kernel
+
 	RESTORE_REGS
 	lss	12+4(%esp), %esp		# back to espfix stack
 	jmp	irq_return
 #endif
-END(nmi)
+ENDPROC(nmi)
 
 ENTRY(int3)
 	ASM_CLAC
@@ -1139,19 +1390,19 @@ ENTRY(int3)
 	movl	%esp, %eax			# pt_regs pointer
 	call	do_int3
 	jmp	ret_from_exception
-END(int3)
+ENDPROC(int3)
 
 ENTRY(general_protection)
 	pushl	$do_general_protection
 	jmp	error_code
-END(general_protection)
+ENDPROC(general_protection)
 
 #ifdef CONFIG_KVM_GUEST
 ENTRY(async_page_fault)
 	ASM_CLAC
 	pushl	$do_async_page_fault
 	jmp	error_code
-END(async_page_fault)
+ENDPROC(async_page_fault)
 #endif
 
 ENTRY(rewind_stack_do_exit)
@@ -1161,6 +1412,6 @@ ENTRY(rewind_stack_do_exit)
 	movl	PER_CPU_VAR(cpu_current_top_of_stack), %esi
 	leal	-TOP_OF_KERNEL_STACK_PADDING-PTREGS_SIZE(%esi), %esp
 
-	call	do_exit
+	call	do_group_exit
 1:	jmp 1b
-END(rewind_stack_do_exit)
+ENDPROC(rewind_stack_do_exit)
diff --git a/arch/x86/entry/entry_64.S b/arch/x86/entry/entry_64.S
index 02fff3ebf..c6685eca9 100644
--- a/arch/x86/entry/entry_64.S
+++ b/arch/x86/entry/entry_64.S
@@ -36,6 +36,8 @@
 #include <asm/smap.h>
 #include <asm/pgtable_types.h>
 #include <linux/err.h>
+#include <asm/pgtable.h>
+#include <asm/alternative-asm.h>
 
 /* Avoid __ASSEMBLER__'ifying <linux/audit.h> just for this.  */
 #include <linux/elf-em.h>
@@ -53,6 +55,395 @@ ENTRY(native_usergs_sysret64)
 ENDPROC(native_usergs_sysret64)
 #endif /* CONFIG_PARAVIRT */
 
+	.macro ljmpq sel, off
+#if defined(CONFIG_MPSC) || defined(CONFIG_MCORE2) || defined (CONFIG_MATOM)
+	.byte 0x48; ljmp *1234f(%rip)
+	.pushsection .rodata
+	.align 16
+	1234: .quad \off; .word \sel
+	.popsection
+#else
+	pushq	$\sel
+	pushq	$\off
+	lretq
+#endif
+	.endm
+
+	.macro pax_enter_kernel
+	pax_set_fptr_mask
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	call	pax_enter_kernel
+#endif
+	.endm
+
+	.macro pax_exit_kernel
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	call	pax_exit_kernel
+#endif
+	.endm
+
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+ENTRY(pax_enter_kernel)
+	pushq	%rdi
+
+#ifdef CONFIG_PARAVIRT
+	PV_SAVE_REGS(CLBR_RDI)
+#endif
+
+#ifdef CONFIG_PAX_KERNEXEC
+	GET_CR0_INTO_RDI
+	bts	$X86_CR0_WP_BIT,%rdi
+	jnc	3f
+	mov	%cs,%edi
+	cmp	$__KERNEL_CS,%edi
+	jnz	2f
+1:
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	ALTERNATIVE "jmp 111f", "", X86_FEATURE_PCID
+	GET_CR3_INTO_RDI
+	cmp	$0,%dil
+	jnz	112f
+	mov	$__KERNEL_DS,%edi
+	mov	%edi,%ss
+	jmp	111f
+112:	cmp	$1,%dil
+	jz	113f
+	ud2
+113:	sub	$4097,%rdi
+	bts	$63,%rdi
+	SET_RDI_INTO_CR3
+	mov	$__UDEREF_KERNEL_DS,%edi
+	mov	%edi,%ss
+111:
+#endif
+
+#ifdef CONFIG_PARAVIRT
+	PV_RESTORE_REGS(CLBR_RDI)
+#endif
+
+	popq	%rdi
+	pax_force_retaddr
+	retq
+
+#ifdef CONFIG_PAX_KERNEXEC
+2:	ljmpq	__KERNEL_CS,1b
+3:	ljmpq	__KERNEXEC_KERNEL_CS,4f
+4:	SET_RDI_INTO_CR0
+	jmp	1b
+#endif
+ENDPROC(pax_enter_kernel)
+
+ENTRY(pax_exit_kernel)
+	pushq	%rdi
+
+#ifdef CONFIG_PARAVIRT
+	PV_SAVE_REGS(CLBR_RDI)
+#endif
+
+#ifdef CONFIG_PAX_KERNEXEC
+	mov	%cs,%rdi
+	cmp	$__KERNEXEC_KERNEL_CS,%edi
+	jz	2f
+	GET_CR0_INTO_RDI
+	bts	$X86_CR0_WP_BIT,%rdi
+	jnc	4f
+1:
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	ALTERNATIVE "jmp 111f", "", X86_FEATURE_PCID
+	mov	%ss,%edi
+	cmp	$__UDEREF_KERNEL_DS,%edi
+	jnz	111f
+	GET_CR3_INTO_RDI
+	cmp	$0,%dil
+	jz	112f
+	ud2
+112:	add	$4097,%rdi
+	bts	$63,%rdi
+	SET_RDI_INTO_CR3
+	mov	$__KERNEL_DS,%edi
+	mov	%edi,%ss
+111:
+#endif
+
+#ifdef CONFIG_PARAVIRT
+	PV_RESTORE_REGS(CLBR_RDI);
+#endif
+
+	popq	%rdi
+	pax_force_retaddr
+	retq
+
+#ifdef CONFIG_PAX_KERNEXEC
+2:	GET_CR0_INTO_RDI
+	btr	$X86_CR0_WP_BIT,%rdi
+	jnc	4f
+	ljmpq	__KERNEL_CS,3f
+3:	SET_RDI_INTO_CR0
+	jmp	1b
+4:	ud2
+	jmp	4b
+#endif
+ENDPROC(pax_exit_kernel)
+#endif
+
+	.macro pax_enter_kernel_user
+	pax_set_fptr_mask
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	call	pax_enter_kernel_user
+#endif
+	.endm
+
+	.macro pax_exit_kernel_user
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	call	pax_exit_kernel_user
+#endif
+#ifdef CONFIG_PAX_RANDKSTACK
+	pushq	%rax
+	pushq	%r11
+	call	pax_randomize_kstack
+	popq	%r11
+	popq	%rax
+#endif
+	.endm
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+ENTRY(pax_enter_kernel_user)
+	pushq	%rdi
+	pushq	%rbx
+
+#ifdef CONFIG_PARAVIRT
+	PV_SAVE_REGS(CLBR_RDI)
+#endif
+
+	ALTERNATIVE "jmp 111f", "", X86_FEATURE_PCID
+	GET_CR3_INTO_RDI
+	cmp	$1,%dil
+	jnz	4f
+	sub	$4097,%rdi
+	bts	$63,%rdi
+	SET_RDI_INTO_CR3
+	jmp	3f
+111:
+
+	GET_CR3_INTO_RDI
+	mov	%rdi,%rbx
+	add	$__START_KERNEL_map,%rbx
+	sub	phys_base(%rip),%rbx
+
+#ifdef CONFIG_PARAVIRT
+	pushq %rdi
+	i = 0
+	.rept USER_PGD_PTRS
+	mov	i*8(%rbx),%rsi
+	mov	$0,%sil
+	lea	i*8(%rbx),%rdi
+	call	PARA_INDIRECT(pv_mmu_ops+PV_MMU_set_pgd_batched)
+	i = i + 1
+	.endr
+	popq	%rdi
+#else
+	i = 0
+	.rept USER_PGD_PTRS
+	movb	$0,i*8(%rbx)
+	i = i + 1
+	.endr
+#endif
+
+	SET_RDI_INTO_CR3
+
+#ifdef CONFIG_PAX_KERNEXEC
+	GET_CR0_INTO_RDI
+	bts	$X86_CR0_WP_BIT,%rdi
+	SET_RDI_INTO_CR0
+#endif
+
+3:
+
+#ifdef CONFIG_PARAVIRT
+	PV_RESTORE_REGS(CLBR_RDI)
+#endif
+
+	popq	%rbx
+	popq	%rdi
+	pax_force_retaddr
+	retq
+4:	ud2
+ENDPROC(pax_enter_kernel_user)
+
+ENTRY(pax_exit_kernel_user)
+	pushq	%rdi
+	pushq	%rbx
+
+#ifdef CONFIG_PARAVIRT
+	PV_SAVE_REGS(CLBR_RDI)
+#endif
+
+	GET_CR3_INTO_RDI
+	ALTERNATIVE "jmp 1f", "", X86_FEATURE_PCID
+	cmp	$0,%dil
+	jnz	3f
+	add	$4097,%rdi
+	bts	$63,%rdi
+	SET_RDI_INTO_CR3
+	jmp	2f
+1:
+
+	mov	%rdi,%rbx
+
+#ifdef CONFIG_PAX_KERNEXEC
+	GET_CR0_INTO_RDI
+	btr	$X86_CR0_WP_BIT,%rdi
+	jnc	3f
+	SET_RDI_INTO_CR0
+#endif
+
+	add	$__START_KERNEL_map,%rbx
+	sub	phys_base(%rip),%rbx
+
+#ifdef CONFIG_PARAVIRT
+	i = 0
+	.rept USER_PGD_PTRS
+	mov	i*8(%rbx),%rsi
+	mov	$0x67,%sil
+	lea	i*8(%rbx),%rdi
+	call	PARA_INDIRECT(pv_mmu_ops+PV_MMU_set_pgd_batched)
+	i = i + 1
+	.endr
+#else
+	i = 0
+	.rept USER_PGD_PTRS
+	movb	$0x67,i*8(%rbx)
+	i = i + 1
+	.endr
+#endif
+
+2:
+
+#ifdef CONFIG_PARAVIRT
+	PV_RESTORE_REGS(CLBR_RDI)
+#endif
+
+	popq	%rbx
+	popq	%rdi
+	pax_force_retaddr
+	retq
+3:	ud2
+ENDPROC(pax_exit_kernel_user)
+#endif
+
+	.macro pax_enter_kernel_nmi
+	pax_set_fptr_mask
+
+#ifdef CONFIG_PAX_KERNEXEC
+	GET_CR0_INTO_RDI
+	bts	$X86_CR0_WP_BIT,%rdi
+	jc	110f
+	SET_RDI_INTO_CR0
+	or	$2,%ebx
+110:
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	ALTERNATIVE "jmp 111f", "", X86_FEATURE_PCID
+	GET_CR3_INTO_RDI
+	cmp	$0,%dil
+	jz	111f
+	sub	$4097,%rdi
+	or	$4,%ebx
+	bts	$63,%rdi
+	SET_RDI_INTO_CR3
+	mov	$__UDEREF_KERNEL_DS,%edi
+	mov	%edi,%ss
+111:
+#endif
+	.endm
+
+	.macro pax_exit_kernel_nmi
+#ifdef CONFIG_PAX_KERNEXEC
+	btr	$1,%ebx
+	jnc	110f
+	GET_CR0_INTO_RDI
+	btr	$X86_CR0_WP_BIT,%rdi
+	SET_RDI_INTO_CR0
+110:
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	ALTERNATIVE "jmp 111f", "", X86_FEATURE_PCID
+	btr	$2,%ebx
+	jnc	111f
+	GET_CR3_INTO_RDI
+	add	$4097,%rdi
+	bts	$63,%rdi
+	SET_RDI_INTO_CR3
+	mov	$__KERNEL_DS,%edi
+	mov	%edi,%ss
+111:
+#endif
+	.endm
+
+	.macro pax_erase_kstack
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+	call	pax_erase_kstack
+#endif
+	.endm
+
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+ENTRY(pax_erase_kstack)
+	pushq	%rdi
+	pushq	%rcx
+	pushq	%rax
+	pushq	%r11
+
+	GET_THREAD_INFO(%r11)
+	mov	TI_lowest_stack(%r11), %rdi
+	mov	$-0xBEEF, %rax
+	std
+
+1:	mov	%edi, %ecx
+	and	$THREAD_SIZE_asm - 1, %ecx
+	shr	$3, %ecx
+	repne	scasq
+	jecxz	2f
+
+	cmp	$2*8, %ecx
+	jc	2f
+
+	mov	$2*8, %ecx
+	repe	scasq
+	jecxz	2f
+	jne	1b
+
+2:	cld
+	or	$2*8, %rdi
+	mov	%esp, %ecx
+	sub	%edi, %ecx
+
+	cmp	$THREAD_SIZE_asm, %rcx
+	jb	3f
+	ud2
+3:
+
+	shr	$3, %ecx
+	rep	stosq
+
+	mov	TI_task_thread_sp0(%r11), %rdi
+	sub	$256, %rdi
+	mov	%rdi, TI_lowest_stack(%r11)
+
+	popq	%r11
+	popq	%rax
+	popq	%rcx
+	popq	%rdi
+	pax_force_retaddr
+	ret
+ENDPROC(pax_erase_kstack)
+#endif
+
 .macro TRACE_IRQS_IRETQ
 #ifdef CONFIG_TRACE_IRQFLAGS
 	bt	$9, EFLAGS(%rsp)		/* interrupts off? */
@@ -88,7 +479,7 @@ ENDPROC(native_usergs_sysret64)
 .endm
 
 .macro TRACE_IRQS_IRETQ_DEBUG
-	bt	$9, EFLAGS(%rsp)		/* interrupts off? */
+	bt	$X86_EFLAGS_IF_BIT, EFLAGS(%rsp)	/* interrupts off? */
 	jnc	1f
 	TRACE_IRQS_ON_DEBUG
 1:
@@ -175,11 +566,22 @@ GLOBAL(entry_SYSCALL_64_after_swapgs)
 	pushq	%r11				/* pt_regs->r11 */
 	sub	$(6*8), %rsp			/* pt_regs->bp, bx, r12-15 not saved */
 
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	movq	%r12, R12(%rsp)
+#endif
+
+	pax_enter_kernel_user
+
+#ifdef CONFIG_PAX_RANDKSTACK
+	pax_erase_kstack
+#endif
+
 	/*
 	 * If we need to do entry work or if we guess we'll need to do
 	 * exit work, go straight to the slow path.
 	 */
-	testl	$_TIF_WORK_SYSCALL_ENTRY|_TIF_ALLWORK_MASK, ASM_THREAD_INFO(TI_flags, %rsp, SIZEOF_PTREGS)
+	GET_THREAD_INFO(%rcx)
+	testl	$_TIF_WORK_SYSCALL_ENTRY|_TIF_ALLWORK_MASK, TI_flags(%rcx)
 	jnz	entry_SYSCALL64_slow_path
 
 entry_SYSCALL_64_fastpath:
@@ -217,9 +619,13 @@ entry_SYSCALL_64_fastpath:
 	 */
 	DISABLE_INTERRUPTS(CLBR_NONE)
 	TRACE_IRQS_OFF
-	testl	$_TIF_ALLWORK_MASK, ASM_THREAD_INFO(TI_flags, %rsp, SIZEOF_PTREGS)
+	GET_THREAD_INFO(%rcx)
+	testl	$_TIF_ALLWORK_MASK, TI_flags(%rcx)
 	jnz	1f
 
+	pax_exit_kernel_user
+	pax_erase_kstack
+
 	LOCKDEP_SYS_EXIT
 	TRACE_IRQS_ON		/* user mode is traced as IRQs on */
 	movq	RIP(%rsp), %rcx
@@ -248,6 +654,9 @@ entry_SYSCALL64_slow_path:
 	call	do_syscall_64		/* returns with IRQs disabled */
 
 return_from_SYSCALL_64:
+	pax_exit_kernel_user
+	pax_erase_kstack
+
 	RESTORE_EXTRA_REGS
 	TRACE_IRQS_IRETQ		/* we're about to change IF */
 
@@ -272,13 +681,12 @@ return_from_SYSCALL_64:
 	.error "virtual address width changed -- SYSRET checks need update"
 	.endif
 
-	/* Change top 16 bits to be the sign-extension of 47th bit */
-	shl	$(64 - (__VIRTUAL_MASK_SHIFT+1)), %rcx
-	sar	$(64 - (__VIRTUAL_MASK_SHIFT+1)), %rcx
-
-	/* If this changed %rcx, it was not canonical */
-	cmpq	%rcx, %r11
-	jne	opportunistic_sysret_failed
+	/*
+	 * If the top 17 bits are not 0 then RIP isn't a userland address,
+	 * it may not even be canonical, fall back to iret
+	 */
+	shr	$(__VIRTUAL_MASK_SHIFT), %r11
+	jnz	opportunistic_sysret_failed
 
 	cmpq	$__USER_CS, CS(%rsp)		/* CS must match SYSRET */
 	jne	opportunistic_sysret_failed
@@ -326,7 +734,7 @@ syscall_return_via_sysret:
 opportunistic_sysret_failed:
 	SWAPGS
 	jmp	restore_c_regs_and_iret
-END(entry_SYSCALL_64)
+ENDPROC(entry_SYSCALL_64)
 
 ENTRY(stub_ptregs_64)
 	/*
@@ -353,13 +761,13 @@ ENTRY(stub_ptregs_64)
 1:
 	/* Called from C */
 	jmp	*%rax				/* called from C */
-END(stub_ptregs_64)
+ENDPROC(stub_ptregs_64)
 
 .macro ptregs_stub func
 ENTRY(ptregs_\func)
 	leaq	\func(%rip), %rax
 	jmp	stub_ptregs_64
-END(ptregs_\func)
+ENDPROC(ptregs_\func)
 .endm
 
 /* Instantiate ptregs_stub for each ptregs-using syscall */
@@ -401,10 +809,12 @@ ENTRY(ret_from_fork)
 1:
 	movq	%rsp, %rdi
 	call	syscall_return_slowpath	/* returns with IRQs disabled */
+	pax_exit_kernel_user
+	pax_erase_kstack
 	TRACE_IRQS_ON			/* user mode is traced as IRQS on */
 	SWAPGS
 	jmp	restore_regs_and_iret
-END(ret_from_fork)
+ENDPROC(ret_from_fork)
 
 /*
  * Build the entry stubs with some assembler magic.
@@ -419,7 +829,7 @@ ENTRY(irq_entries_start)
 	jmp	common_interrupt
 	.align	8
     .endr
-END(irq_entries_start)
+ENDPROC(irq_entries_start)
 
 /*
  * Interrupt entry/exit.
@@ -445,6 +855,12 @@ END(irq_entries_start)
 	 */
 	SWAPGS
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pax_enter_kernel_user
+#else
+	pax_enter_kernel
+#endif
+
 	/*
 	 * We need to tell lockdep that IRQs are off.  We can't do this until
 	 * we fix gsbase, and we should do it before enter_from_user_mode
@@ -457,7 +873,9 @@ END(irq_entries_start)
 
 	CALL_enter_from_user_mode
 
-1:
+	jmp	2f
+1:	pax_enter_kernel
+2:
 	/*
 	 * Save previous stack pointer, optionally switch to interrupt stack.
 	 * irq_count is used to check if a CPU is already on an interrupt stack
@@ -469,6 +887,7 @@ END(irq_entries_start)
 	incl	PER_CPU_VAR(irq_count)
 	cmovzq	PER_CPU_VAR(irq_stack_ptr), %rsp
 	pushq	%rdi
+
 	/* We entered an interrupt context - irqs are off: */
 	TRACE_IRQS_OFF
 
@@ -500,6 +919,8 @@ ret_from_intr:
 GLOBAL(retint_user)
 	mov	%rsp,%rdi
 	call	prepare_exit_to_usermode
+	pax_exit_kernel_user
+#	pax_erase_kstack
 	TRACE_IRQS_IRETQ
 	SWAPGS
 	jmp	restore_regs_and_iret
@@ -517,6 +938,21 @@ retint_kernel:
 	jmp	0b
 1:
 #endif
+
+	pax_exit_kernel
+
+#if defined(CONFIG_EFI) && defined(CONFIG_PAX_KERNEXEC_PLUGIN)
+	/* This is a quirk to allow IRQs/NMIs/MCEs during early EFI setup,
+	 * namely calling EFI runtime services with a phys mapping. We're
+	 * starting off with NOPs and patch in the real instrumentation
+	 * (BTS/OR) before starting any userland process; even before starting
+	 * up the APs.
+	 */
+	ALTERNATIVE "", "pax_force_retaddr 16*8", X86_FEATURE_ALWAYS
+#else
+	pax_force_retaddr RIP
+#endif
+
 	/*
 	 * The iretq could re-enable interrupts:
 	 */
@@ -560,15 +996,15 @@ native_irq_return_ldt:
 	SWAPGS
 	movq	PER_CPU_VAR(espfix_waddr), %rdi
 	movq	%rax, (0*8)(%rdi)		/* RAX */
-	movq	(2*8)(%rsp), %rax		/* RIP */
+	movq	(2*8 + RIP-RIP)(%rsp), %rax	/* RIP */
 	movq	%rax, (1*8)(%rdi)
-	movq	(3*8)(%rsp), %rax		/* CS */
+	movq	(2*8 + CS-RIP)(%rsp), %rax	/* CS */
 	movq	%rax, (2*8)(%rdi)
-	movq	(4*8)(%rsp), %rax		/* RFLAGS */
+	movq	(2*8 + EFLAGS-RIP)(%rsp), %rax	/* RFLAGS */
 	movq	%rax, (3*8)(%rdi)
-	movq	(6*8)(%rsp), %rax		/* SS */
+	movq	(2*8 + SS-RIP)(%rsp), %rax	/* SS */
 	movq	%rax, (5*8)(%rdi)
-	movq	(5*8)(%rsp), %rax		/* RSP */
+	movq	(2*8 + RSP-RIP)(%rsp), %rax	/* RSP */
 	movq	%rax, (4*8)(%rdi)
 	andl	$0xffff0000, %eax
 	popq	%rdi
@@ -578,7 +1014,7 @@ native_irq_return_ldt:
 	popq	%rax
 	jmp	native_irq_return_iret
 #endif
-END(common_interrupt)
+ENDPROC(common_interrupt)
 
 /*
  * APIC interrupts.
@@ -590,7 +1026,7 @@ ENTRY(\sym)
 .Lcommon_\sym:
 	interrupt \do_sym
 	jmp	ret_from_intr
-END(\sym)
+ENDPROC(\sym)
 .endm
 
 #ifdef CONFIG_TRACING
@@ -666,7 +1102,7 @@ apicinterrupt IRQ_WORK_VECTOR			irq_work_interrupt		smp_irq_work_interrupt
 /*
  * Exception entry points.
  */
-#define CPU_TSS_IST(x) PER_CPU_VAR(cpu_tss) + (TSS_ist + ((x) - 1) * 8)
+#define CPU_TSS_IST(x) (TSS_ist + ((x) - 1) * 8)(%r13)
 
 .macro idtentry sym do_sym has_error_code:req paranoid=0 shift_ist=-1
 ENTRY(\sym)
@@ -713,6 +1149,12 @@ ENTRY(\sym)
 	.endif
 
 	.if \shift_ist != -1
+#ifdef CONFIG_SMP
+	imul	$TSS_size, PER_CPU_VAR(cpu_number), %r13d
+	leaq	cpu_tss(%r13), %r13
+#else
+	leaq	cpu_tss(%rip), %r13
+#endif
 	subq	$EXCEPTION_STKSZ, CPU_TSS_IST(\shift_ist)
 	.endif
 
@@ -756,7 +1198,7 @@ ENTRY(\sym)
 
 	jmp	error_exit			/* %ebx: no swapgs flag */
 	.endif
-END(\sym)
+ENDPROC(\sym)
 .endm
 
 #ifdef CONFIG_TRACING
@@ -784,6 +1226,9 @@ idtentry coprocessor_error		do_coprocessor_error		has_error_code=0
 idtentry alignment_check		do_alignment_check		has_error_code=1
 idtentry simd_coprocessor_error		do_simd_coprocessor_error	has_error_code=0
 
+#ifdef CONFIG_PAX_REFCOUNT
+idtentry refcount_error			do_refcount_error		has_error_code=0
+#endif
 
 	/*
 	 * Reload gs selector with exception handling
@@ -798,8 +1243,9 @@ ENTRY(native_load_gs_index)
 2:	ALTERNATIVE "", "mfence", X86_BUG_SWAPGS_FENCE
 	SWAPGS
 	popfq
+	pax_force_retaddr
 	ret
-END(native_load_gs_index)
+ENDPROC(native_load_gs_index)
 
 	_ASM_EXTABLE(.Lgs_change, bad_gs)
 	.section .fixup, "ax"
@@ -827,8 +1273,9 @@ ENTRY(do_softirq_own_stack)
 	call	__do_softirq
 	leaveq
 	decl	PER_CPU_VAR(irq_count)
+	pax_force_retaddr
 	ret
-END(do_softirq_own_stack)
+ENDPROC(do_softirq_own_stack)
 
 #ifdef CONFIG_XEN
 idtentry xen_hypervisor_callback xen_do_hypervisor_callback has_error_code=0
@@ -864,7 +1311,7 @@ ENTRY(xen_do_hypervisor_callback)		/* do_hypervisor_callback(struct *pt_regs) */
 	call	xen_maybe_preempt_hcall
 #endif
 	jmp	error_exit
-END(xen_do_hypervisor_callback)
+ENDPROC(xen_do_hypervisor_callback)
 
 /*
  * Hypervisor uses this for application faults while it executes.
@@ -909,7 +1356,7 @@ ENTRY(xen_failsafe_callback)
 	SAVE_C_REGS
 	SAVE_EXTRA_REGS
 	jmp	error_exit
-END(xen_failsafe_callback)
+ENDPROC(xen_failsafe_callback)
 
 apicinterrupt3 HYPERVISOR_CALLBACK_VECTOR \
 	xen_hvm_callback_vector xen_evtchn_do_upcall
@@ -921,7 +1368,7 @@ apicinterrupt3 HYPERVISOR_CALLBACK_VECTOR \
 	hyperv_callback_vector hyperv_vector_handler
 #endif /* CONFIG_HYPERV */
 
-idtentry debug			do_debug		has_error_code=0	paranoid=1 shift_ist=DEBUG_STACK
+idtentry int1			do_debug		has_error_code=0	paranoid=1 shift_ist=DEBUG_STACK
 idtentry int3			do_int3			has_error_code=0	paranoid=1 shift_ist=DEBUG_STACK
 idtentry stack_segment		do_stack_segment	has_error_code=1
 
@@ -958,8 +1405,34 @@ ENTRY(paranoid_entry)
 	js	1f				/* negative -> in kernel */
 	SWAPGS
 	xorl	%ebx, %ebx
-1:	ret
-END(paranoid_entry)
+1:
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	testb	$3, CS+8(%rsp)
+	jz	1f
+	pax_enter_kernel_user
+	jmp	2f
+#endif
+1:	pax_enter_kernel
+2:
+	pax_force_retaddr
+	ret
+ENDPROC(paranoid_entry)
+
+ENTRY(paranoid_entry_nmi)
+	cld
+	SAVE_C_REGS 8
+	SAVE_EXTRA_REGS 8
+	movl	$1, %ebx
+	movl	$MSR_GS_BASE, %ecx
+	rdmsr
+	testl	%edx, %edx
+	js	1f	/* negative -> in kernel */
+	SWAPGS
+	xorl	%ebx, %ebx
+1:	pax_enter_kernel_nmi
+	pax_force_retaddr
+	ret
+ENDPROC(paranoid_entry_nmi)
 
 /*
  * "Paranoid" exit path from exception stack.  This is invoked
@@ -976,19 +1449,26 @@ END(paranoid_entry)
 ENTRY(paranoid_exit)
 	DISABLE_INTERRUPTS(CLBR_NONE)
 	TRACE_IRQS_OFF_DEBUG
-	testl	%ebx, %ebx			/* swapgs needed? */
+	testl	$1, %ebx			/* swapgs needed? */
 	jnz	paranoid_exit_no_swapgs
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pax_exit_kernel_user
+#else
+	pax_exit_kernel
+#endif
 	TRACE_IRQS_IRETQ
 	SWAPGS_UNSAFE_STACK
 	jmp	paranoid_exit_restore
 paranoid_exit_no_swapgs:
+	pax_exit_kernel
 	TRACE_IRQS_IRETQ_DEBUG
 paranoid_exit_restore:
 	RESTORE_EXTRA_REGS
 	RESTORE_C_REGS
 	REMOVE_PT_GPREGS_FROM_STACK 8
+	pax_force_retaddr_bts
 	INTERRUPT_RETURN
-END(paranoid_exit)
+ENDPROC(paranoid_exit)
 
 /*
  * Save all registers in pt_regs, and switch gs if needed.
@@ -1008,6 +1488,12 @@ ENTRY(error_entry)
 	 */
 	SWAPGS
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pax_enter_kernel_user
+#else
+	pax_enter_kernel
+#endif
+
 .Lerror_entry_from_usermode_after_swapgs:
 	/*
 	 * We need to tell lockdep that IRQs are off.  We can't do this until
@@ -1016,10 +1502,12 @@ ENTRY(error_entry)
 	 */
 	TRACE_IRQS_OFF
 	CALL_enter_from_user_mode
+	pax_force_retaddr
 	ret
 
 .Lerror_entry_done:
 	TRACE_IRQS_OFF
+	pax_force_retaddr
 	ret
 
 	/*
@@ -1037,7 +1525,7 @@ ENTRY(error_entry)
 	cmpq	%rax, RIP+8(%rsp)
 	je	.Lbstep_iret
 	cmpq	$.Lgs_change, RIP+8(%rsp)
-	jne	.Lerror_entry_done
+	jne	1f
 
 	/*
 	 * hack: .Lgs_change can fail with user gsbase.  If this happens, fix up
@@ -1045,7 +1533,8 @@ ENTRY(error_entry)
 	 * .Lgs_change's error handler with kernel gsbase.
 	 */
 	SWAPGS
-	jmp .Lerror_entry_done
+1:	pax_enter_kernel
+	jmp	.Lerror_entry_done
 
 .Lbstep_iret:
 	/* Fix truncated RIP */
@@ -1059,6 +1548,12 @@ ENTRY(error_entry)
 	 */
 	SWAPGS
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pax_enter_kernel_user
+#else
+	pax_enter_kernel
+#endif
+
 	/*
 	 * Pretend that the exception came from user mode: set up pt_regs
 	 * as if we faulted immediately after IRET and clear EBX so that
@@ -1069,11 +1564,11 @@ ENTRY(error_entry)
 	mov	%rax, %rsp
 	decl	%ebx
 	jmp	.Lerror_entry_from_usermode_after_swapgs
-END(error_entry)
+ENDPROC(error_entry)
 
 
 /*
- * On entry, EBS is a "return to kernel mode" flag:
+ * On entry, EBX is a "return to kernel mode" flag:
  *   1: already in kernel mode, don't need SWAPGS
  *   0: user gsbase is loaded, we need SWAPGS and standard preparation for return to usermode
  */
@@ -1081,10 +1576,10 @@ ENTRY(error_exit)
 	movl	%ebx, %eax
 	DISABLE_INTERRUPTS(CLBR_NONE)
 	TRACE_IRQS_OFF
-	testl	%eax, %eax
+	testl	$1, %eax
 	jnz	retint_kernel
 	jmp	retint_user
-END(error_exit)
+ENDPROC(error_exit)
 
 /* Runs on exception stack */
 ENTRY(nmi)
@@ -1138,6 +1633,8 @@ ENTRY(nmi)
 	 * other IST entries.
 	 */
 
+	ASM_CLAC
+
 	/* Use %rdx as our temp variable throughout */
 	pushq	%rdx
 
@@ -1181,6 +1678,12 @@ ENTRY(nmi)
 	pushq	%r14		/* pt_regs->r14 */
 	pushq	%r15		/* pt_regs->r15 */
 
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	xorl	%ebx, %ebx
+#endif
+
+	pax_enter_kernel_nmi
+
 	/*
 	 * At this point we no longer need to worry about stack damage
 	 * due to nesting -- we're on the normal thread stack and we're
@@ -1191,12 +1694,19 @@ ENTRY(nmi)
 	movq	$-1, %rsi
 	call	do_nmi
 
+	pax_exit_kernel_nmi
+
 	/*
 	 * Return back to user mode.  We must *not* do the normal exit
 	 * work, because we don't want to enable interrupts.  Fortunately,
 	 * do_nmi doesn't modify pt_regs.
 	 */
 	SWAPGS
+
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	movq	RBX(%rsp), %rbx
+#endif
+
 	jmp	restore_c_regs_and_iret
 
 .Lnmi_from_kernel:
@@ -1318,6 +1828,7 @@ nested_nmi_out:
 	popq	%rdx
 
 	/* We are returning to kernel mode, so this cannot result in a fault. */
+#	pax_force_retaddr_bts
 	INTERRUPT_RETURN
 
 first_nmi:
@@ -1346,7 +1857,7 @@ first_nmi:
 	pushq	%rsp		/* RSP (minus 8 because of the previous push) */
 	addq	$8, (%rsp)	/* Fix up RSP */
 	pushfq			/* RFLAGS */
-	pushq	$__KERNEL_CS	/* CS */
+	pushq	4*8(%rsp)	/* CS */
 	pushq	$1f		/* RIP */
 	INTERRUPT_RETURN	/* continues at repeat_nmi below */
 1:
@@ -1391,20 +1902,22 @@ end_repeat_nmi:
 	ALLOC_PT_GPREGS_ON_STACK
 
 	/*
-	 * Use paranoid_entry to handle SWAPGS, but no need to use paranoid_exit
+	 * Use paranoid_entry_nmi to handle SWAPGS, but no need to use paranoid_exit
 	 * as we should not be calling schedule in NMI context.
 	 * Even with normal interrupts enabled. An NMI should not be
 	 * setting NEED_RESCHED or anything that normal interrupts and
 	 * exceptions might do.
 	 */
-	call	paranoid_entry
+	call	paranoid_entry_nmi
 
 	/* paranoidentry do_nmi, 0; without TRACE_IRQS_OFF */
 	movq	%rsp, %rdi
 	movq	$-1, %rsi
 	call	do_nmi
 
-	testl	%ebx, %ebx			/* swapgs needed? */
+	pax_exit_kernel_nmi
+
+	testl	$1, %ebx			/* swapgs needed? */
 	jnz	nmi_restore
 nmi_swapgs:
 	SWAPGS_UNSAFE_STACK
@@ -1415,6 +1928,8 @@ nmi_restore:
 	/* Point RSP at the "iret" frame. */
 	REMOVE_PT_GPREGS_FROM_STACK 6*8
 
+	pax_force_retaddr_bts
+
 	/*
 	 * Clear "NMI executing".  Set DF first so that we can easily
 	 * distinguish the remaining code between here and IRET from
@@ -1432,12 +1947,12 @@ nmi_restore:
 	 * mode, so this cannot result in a fault.
 	 */
 	INTERRUPT_RETURN
-END(nmi)
+ENDPROC(nmi)
 
 ENTRY(ignore_sysret)
 	mov	$-ENOSYS, %eax
 	sysret
-END(ignore_sysret)
+ENDPROC(ignore_sysret)
 
 ENTRY(rewind_stack_do_exit)
 	/* Prevent any naive code from trying to unwind to our caller. */
@@ -1446,6 +1961,6 @@ ENTRY(rewind_stack_do_exit)
 	movq	PER_CPU_VAR(cpu_current_top_of_stack), %rax
 	leaq	-TOP_OF_KERNEL_STACK_PADDING-PTREGS_SIZE(%rax), %rsp
 
-	call	do_exit
+	call	do_group_exit
 1:	jmp 1b
-END(rewind_stack_do_exit)
+ENDPROC(rewind_stack_do_exit)
diff --git a/arch/x86/entry/entry_64_compat.S b/arch/x86/entry/entry_64_compat.S
index e1721dafb..83f2c499a 100644
--- a/arch/x86/entry/entry_64_compat.S
+++ b/arch/x86/entry/entry_64_compat.S
@@ -13,11 +13,39 @@
 #include <asm/irqflags.h>
 #include <asm/asm.h>
 #include <asm/smap.h>
+#include <asm/pgtable.h>
 #include <linux/linkage.h>
 #include <linux/err.h>
+#include <asm/alternative-asm.h>
 
 	.section .entry.text, "ax"
 
+	.macro pax_enter_kernel_user
+	pax_set_fptr_mask
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	call	pax_enter_kernel_user
+#endif
+	.endm
+
+	.macro pax_exit_kernel_user
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	call	pax_exit_kernel_user
+#endif
+#ifdef CONFIG_PAX_RANDKSTACK
+	pushq	%rax
+	pushq	%r11
+	call	pax_randomize_kstack
+	popq	%r11
+	popq	%rax
+#endif
+	.endm
+
+	.macro pax_erase_kstack
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+	call	pax_erase_kstack
+#endif
+	.endm
+
 /*
  * 32-bit SYSENTER entry.
  *
@@ -74,23 +102,34 @@ ENTRY(entry_SYSENTER_compat)
 	pushq	$__USER32_CS		/* pt_regs->cs */
 	pushq	$0			/* pt_regs->ip = 0 (placeholder) */
 	pushq	%rax			/* pt_regs->orig_ax */
+	xorl	%eax,%eax
 	pushq	%rdi			/* pt_regs->di */
 	pushq	%rsi			/* pt_regs->si */
 	pushq	%rdx			/* pt_regs->dx */
 	pushq	%rcx			/* pt_regs->cx */
 	pushq	$-ENOSYS		/* pt_regs->ax */
-	pushq   $0			/* pt_regs->r8  = 0 */
-	pushq   $0			/* pt_regs->r9  = 0 */
-	pushq   $0			/* pt_regs->r10 = 0 */
-	pushq   $0			/* pt_regs->r11 = 0 */
+	pushq   %rax			/* pt_regs->r8  = 0 */
+	pushq   %rax			/* pt_regs->r9  = 0 */
+	pushq   %rax			/* pt_regs->r10 = 0 */
+	pushq   %rax			/* pt_regs->r11 = 0 */
 	pushq   %rbx                    /* pt_regs->rbx */
 	pushq   %rbp                    /* pt_regs->rbp (will be overwritten) */
-	pushq   $0			/* pt_regs->r12 = 0 */
-	pushq   $0			/* pt_regs->r13 = 0 */
-	pushq   $0			/* pt_regs->r14 = 0 */
-	pushq   $0			/* pt_regs->r15 = 0 */
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	pushq   %r12                    /* pt_regs->r12 */
+#else
+	pushq   %rax                    /* pt_regs->r12 = 0 */
+#endif
+	pushq   %rax                    /* pt_regs->r13 = 0 */
+	pushq   %rax                    /* pt_regs->r14 = 0 */
+	pushq   %rax                    /* pt_regs->r15 = 0 */
 	cld
 
+	pax_enter_kernel_user
+
+#ifdef CONFIG_PAX_RANDKSTACK
+	pax_erase_kstack
+#endif
+
 	/*
 	 * SYSENTER doesn't filter flags, so we need to clear NT and AC
 	 * ourselves.  To save a few cycles, we can check whether
@@ -204,16 +243,27 @@ ENTRY(entry_SYSCALL_compat)
 	pushq	%rdx			/* pt_regs->dx */
 	pushq	%rbp			/* pt_regs->cx (stashed in bp) */
 	pushq	$-ENOSYS		/* pt_regs->ax */
-	pushq   $0			/* pt_regs->r8  = 0 */
-	pushq   $0			/* pt_regs->r9  = 0 */
-	pushq   $0			/* pt_regs->r10 = 0 */
-	pushq   $0			/* pt_regs->r11 = 0 */
+	xorl    %eax,%eax
+	pushq   %rax			/* pt_regs->r8  = 0 */
+	pushq   %rax			/* pt_regs->r9  = 0 */
+	pushq   %rax			/* pt_regs->r10 = 0 */
+	pushq   %rax			/* pt_regs->r11 = 0 */
 	pushq   %rbx                    /* pt_regs->rbx */
 	pushq   %rbp                    /* pt_regs->rbp (will be overwritten) */
-	pushq   $0			/* pt_regs->r12 = 0 */
-	pushq   $0			/* pt_regs->r13 = 0 */
-	pushq   $0			/* pt_regs->r14 = 0 */
-	pushq   $0			/* pt_regs->r15 = 0 */
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	pushq   %r12                    /* pt_regs->r12 */
+#else
+	pushq   %rax                    /* pt_regs->r12 = 0 */
+#endif
+	pushq   %rax                    /* pt_regs->r13 = 0 */
+	pushq   %rax                    /* pt_regs->r14 = 0 */
+	pushq   %rax                    /* pt_regs->r15 = 0 */
+
+	pax_enter_kernel_user
+
+#ifdef CONFIG_PAX_RANDKSTACK
+	pax_erase_kstack
+#endif
 
 	/*
 	 * User mode is traced as though IRQs are on, and SYSENTER
@@ -229,11 +279,18 @@ ENTRY(entry_SYSCALL_compat)
 
 	/* Opportunistic SYSRET */
 sysret32_from_system_call:
+	pax_exit_kernel_user
+	pax_erase_kstack
 	TRACE_IRQS_ON			/* User mode traces as IRQs on. */
 	movq	RBX(%rsp), %rbx		/* pt_regs->rbx */
 	movq	RBP(%rsp), %rbp		/* pt_regs->rbp */
 	movq	EFLAGS(%rsp), %r11	/* pt_regs->flags (in r11) */
 	movq	RIP(%rsp), %rcx		/* pt_regs->ip (in rcx) */
+
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	movq	R12(%rsp), %r12
+#endif
+
 	addq	$RAX, %rsp		/* Skip r8-r15 */
 	popq	%rax			/* pt_regs->rax */
 	popq	%rdx			/* Skip pt_regs->cx */
@@ -262,7 +319,7 @@ sysret32_from_system_call:
 	movq	RSP-ORIG_RAX(%rsp), %rsp
 	swapgs
 	sysretl
-END(entry_SYSCALL_compat)
+ENDPROC(entry_SYSCALL_compat)
 
 /*
  * 32-bit legacy system call entry.
@@ -314,10 +371,11 @@ ENTRY(entry_INT80_compat)
 	pushq	%rdx			/* pt_regs->dx */
 	pushq	%rcx			/* pt_regs->cx */
 	pushq	$-ENOSYS		/* pt_regs->ax */
-	pushq   $0			/* pt_regs->r8  = 0 */
-	pushq   $0			/* pt_regs->r9  = 0 */
-	pushq   $0			/* pt_regs->r10 = 0 */
-	pushq   $0			/* pt_regs->r11 = 0 */
+	xorl    %eax,%eax
+	pushq   %rax			/* pt_regs->r8  = 0 */
+	pushq   %rax			/* pt_regs->r9  = 0 */
+	pushq   %rax			/* pt_regs->r10 = 0 */
+	pushq   %rax			/* pt_regs->r11 = 0 */
 	pushq   %rbx                    /* pt_regs->rbx */
 	pushq   %rbp                    /* pt_regs->rbp */
 	pushq   %r12                    /* pt_regs->r12 */
@@ -326,6 +384,12 @@ ENTRY(entry_INT80_compat)
 	pushq   %r15                    /* pt_regs->r15 */
 	cld
 
+	pax_enter_kernel_user
+
+#ifdef CONFIG_PAX_RANDKSTACK
+	pax_erase_kstack
+#endif
+
 	/*
 	 * User mode is traced as though IRQs are on, and the interrupt
 	 * gate turned them off.
@@ -337,10 +401,12 @@ ENTRY(entry_INT80_compat)
 .Lsyscall_32_done:
 
 	/* Go back to user mode. */
+	pax_exit_kernel_user
+	pax_erase_kstack
 	TRACE_IRQS_ON
 	SWAPGS
 	jmp	restore_regs_and_iret
-END(entry_INT80_compat)
+ENDPROC(entry_INT80_compat)
 
 	ALIGN
 GLOBAL(stub32_clone)
diff --git a/arch/x86/entry/thunk_64.S b/arch/x86/entry/thunk_64.S
index 627ecbcb2..6490d113f 100644
--- a/arch/x86/entry/thunk_64.S
+++ b/arch/x86/entry/thunk_64.S
@@ -8,6 +8,7 @@
 #include <linux/linkage.h>
 #include "calling.h"
 #include <asm/asm.h>
+#include <asm/alternative-asm.h>
 
 	/* rdi:	arg1 ... normal C conventions. rax is saved/restored. */
 	.macro THUNK name, func, put_ret_addr_in_rdi=0
@@ -65,6 +66,7 @@
 	popq %rsi
 	popq %rdi
 	popq %rbp
+	pax_force_retaddr
 	ret
 	_ASM_NOKPROBE(.L_restore)
 #endif
diff --git a/arch/x86/entry/vdso/Makefile b/arch/x86/entry/vdso/Makefile
index d5409660f..443f0d7a4 100644
--- a/arch/x86/entry/vdso/Makefile
+++ b/arch/x86/entry/vdso/Makefile
@@ -170,7 +170,7 @@ quiet_cmd_vdso = VDSO    $@
 		       -Wl,-T,$(filter %.lds,$^) $(filter %.o,$^) && \
 		 sh $(srctree)/$(src)/checkundef.sh '$(NM)' '$@'
 
-VDSO_LDFLAGS = -fPIC -shared $(call cc-ldoption, -Wl$(comma)--hash-style=both) \
+VDSO_LDFLAGS = -fPIC -shared -Wl,--no-undefined $(call cc-ldoption, -Wl$(comma)--hash-style=both) \
 	$(call cc-ldoption, -Wl$(comma)--build-id) -Wl,-Bsymbolic $(LTO_CFLAGS)
 GCOV_PROFILE := n
 
diff --git a/arch/x86/entry/vdso/vclock_gettime.c b/arch/x86/entry/vdso/vclock_gettime.c
index 94d54d0de..390dce1b7 100644
--- a/arch/x86/entry/vdso/vclock_gettime.c
+++ b/arch/x86/entry/vdso/vclock_gettime.c
@@ -300,5 +300,5 @@ notrace time_t __vdso_time(time_t *t)
 		*t = result;
 	return result;
 }
-int time(time_t *t)
+time_t time(time_t *t)
 	__attribute__((weak, alias("__vdso_time")));
diff --git a/arch/x86/entry/vdso/vdso2c.h b/arch/x86/entry/vdso/vdso2c.h
index 3dab75f2a..2c439d084 100644
--- a/arch/x86/entry/vdso/vdso2c.h
+++ b/arch/x86/entry/vdso/vdso2c.h
@@ -12,7 +12,7 @@ static void BITSFUNC(go)(void *raw_addr, size_t raw_len,
 	unsigned long load_size = -1;  /* Work around bogus warning */
 	unsigned long mapping_size;
 	ELF(Ehdr) *hdr = (ELF(Ehdr) *)raw_addr;
-	int i;
+	unsigned int i;
 	unsigned long j;
 	ELF(Shdr) *symtab_hdr = NULL, *strtab_hdr, *secstrings_hdr,
 		*alt_sec = NULL;
@@ -89,7 +89,7 @@ static void BITSFUNC(go)(void *raw_addr, size_t raw_len,
 	for (i = 0;
 	     i < GET_LE(&symtab_hdr->sh_size) / GET_LE(&symtab_hdr->sh_entsize);
 	     i++) {
-		int k;
+		unsigned int k;
 		ELF(Sym) *sym = raw_addr + GET_LE(&symtab_hdr->sh_offset) +
 			GET_LE(&symtab_hdr->sh_entsize) * i;
 		const char *name = raw_addr + GET_LE(&strtab_hdr->sh_offset) +
diff --git a/arch/x86/entry/vdso/vma.c b/arch/x86/entry/vdso/vma.c
index f84076665..222abb1a2 100644
--- a/arch/x86/entry/vdso/vma.c
+++ b/arch/x86/entry/vdso/vma.c
@@ -21,10 +21,7 @@
 #include <asm/page.h>
 #include <asm/desc.h>
 #include <asm/cpufeature.h>
-
-#if defined(CONFIG_X86_64)
-unsigned int __read_mostly vdso64_enabled = 1;
-#endif
+#include <asm/mman.h>
 
 void __init init_vdso_image(const struct vdso_image *image)
 {
@@ -90,7 +87,7 @@ static int vdso_fault(const struct vm_special_mapping *sm,
 {
 	const struct vdso_image *image = vma->vm_mm->context.vdso_image;
 
-	if (!image || (vmf->pgoff << PAGE_SHIFT) >= image->size)
+	if (!image || vmf->pgoff >= (image->size >> PAGE_SHIFT))
 		return VM_FAULT_SIGBUS;
 
 	vmf->page = virt_to_page(image->data + (vmf->pgoff << PAGE_SHIFT));
@@ -128,7 +125,7 @@ static int vdso_mremap(const struct vm_special_mapping *sm,
 		return -EFAULT;
 
 	vdso_fix_landing(image, new_vma);
-	current->mm->context.vdso = (void __user *)new_vma->vm_start;
+	current->mm->context.vdso = new_vma->vm_start;
 
 	return 0;
 }
@@ -193,6 +190,11 @@ static int map_vdso(const struct vdso_image *image, bool calculate_addr)
 		.fault = vvar_fault,
 	};
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (mm->pax_flags & MF_PAX_RANDMMAP)
+		calculate_addr = false;
+#endif
+
 	if (calculate_addr) {
 		addr = vdso_addr(current->mm->start_stack,
 				 image->size - image->sym_vvar_start);
@@ -204,15 +206,15 @@ static int map_vdso(const struct vdso_image *image, bool calculate_addr)
 		return -EINTR;
 
 	addr = get_unmapped_area(NULL, addr,
-				 image->size - image->sym_vvar_start, 0, 0);
+				 image->size - image->sym_vvar_start, 0, MAP_EXECUTABLE);
 	if (IS_ERR_VALUE(addr)) {
 		ret = addr;
 		goto up_fail;
 	}
 
 	text_start = addr - image->sym_vvar_start;
-	current->mm->context.vdso = (void __user *)text_start;
-	current->mm->context.vdso_image = image;
+	mm->context.vdso = text_start;
+	mm->context.vdso_image = image;
 
 	/*
 	 * MAYWRITE to allow gdb to COW and set breakpoints
@@ -236,14 +238,12 @@ static int map_vdso(const struct vdso_image *image, bool calculate_addr)
 				       VM_PFNMAP,
 				       &vvar_mapping);
 
-	if (IS_ERR(vma)) {
+	if (IS_ERR(vma))
 		ret = PTR_ERR(vma);
-		goto up_fail;
-	}
 
 up_fail:
 	if (ret)
-		current->mm->context.vdso = NULL;
+		mm->context.vdso = 0;
 
 	up_write(&mm->mmap_sem);
 	return ret;
@@ -262,9 +262,6 @@ static int load_vdso32(void)
 #ifdef CONFIG_X86_64
 int arch_setup_additional_pages(struct linux_binprm *bprm, int uses_interp)
 {
-	if (!vdso64_enabled)
-		return 0;
-
 	return map_vdso(&vdso_image_64, true);
 }
 
@@ -273,12 +270,8 @@ int compat_arch_setup_additional_pages(struct linux_binprm *bprm,
 				       int uses_interp)
 {
 #ifdef CONFIG_X86_X32_ABI
-	if (test_thread_flag(TIF_X32)) {
-		if (!vdso64_enabled)
-			return 0;
-
+	if (test_thread_flag(TIF_X32))
 		return map_vdso(&vdso_image_x32, true);
-	}
 #endif
 #ifdef CONFIG_IA32_EMULATION
 	return load_vdso32();
@@ -295,15 +288,6 @@ int arch_setup_additional_pages(struct linux_binprm *bprm, int uses_interp)
 #endif
 
 #ifdef CONFIG_X86_64
-static __init int vdso_setup(char *s)
-{
-	vdso64_enabled = simple_strtoul(s, NULL, 0);
-	return 0;
-}
-__setup("vdso=", vdso_setup);
-#endif
-
-#ifdef CONFIG_X86_64
 static void vgetcpu_cpu_init(void *arg)
 {
 	int cpu = smp_processor_id();
diff --git a/arch/x86/entry/vsyscall/vsyscall_64.c b/arch/x86/entry/vsyscall/vsyscall_64.c
index 636c4b341..666991b77 100644
--- a/arch/x86/entry/vsyscall/vsyscall_64.c
+++ b/arch/x86/entry/vsyscall/vsyscall_64.c
@@ -38,10 +38,8 @@
 #define CREATE_TRACE_POINTS
 #include "vsyscall_trace.h"
 
-static enum { EMULATE, NATIVE, NONE } vsyscall_mode =
-#if defined(CONFIG_LEGACY_VSYSCALL_NATIVE)
-	NATIVE;
-#elif defined(CONFIG_LEGACY_VSYSCALL_NONE)
+static enum { EMULATE, NONE } vsyscall_mode =
+#if defined(CONFIG_LEGACY_VSYSCALL_NONE)
 	NONE;
 #else
 	EMULATE;
@@ -52,8 +50,6 @@ static int __init vsyscall_setup(char *str)
 	if (str) {
 		if (!strcmp("emulate", str))
 			vsyscall_mode = EMULATE;
-		else if (!strcmp("native", str))
-			vsyscall_mode = NATIVE;
 		else if (!strcmp("none", str))
 			vsyscall_mode = NONE;
 		else
@@ -271,8 +267,7 @@ do_ret:
 	return true;
 
 sigsegv:
-	force_sig(SIGSEGV, current);
-	return true;
+	do_group_exit(SIGKILL);
 }
 
 /*
@@ -290,8 +285,8 @@ static const struct vm_operations_struct gate_vma_ops = {
 static struct vm_area_struct gate_vma = {
 	.vm_start	= VSYSCALL_ADDR,
 	.vm_end		= VSYSCALL_ADDR + PAGE_SIZE,
-	.vm_page_prot	= PAGE_READONLY_EXEC,
-	.vm_flags	= VM_READ | VM_EXEC,
+	.vm_page_prot	= PAGE_READONLY,
+	.vm_flags	= VM_READ,
 	.vm_ops		= &gate_vma_ops,
 };
 
@@ -332,10 +327,7 @@ void __init map_vsyscall(void)
 	unsigned long physaddr_vsyscall = __pa_symbol(&__vsyscall_page);
 
 	if (vsyscall_mode != NONE)
-		__set_fixmap(VSYSCALL_PAGE, physaddr_vsyscall,
-			     vsyscall_mode == NATIVE
-			     ? PAGE_KERNEL_VSYSCALL
-			     : PAGE_KERNEL_VVAR);
+		__set_fixmap(VSYSCALL_PAGE, physaddr_vsyscall, PAGE_KERNEL_VVAR);
 
 	BUILD_BUG_ON((unsigned long)__fix_to_virt(VSYSCALL_PAGE) !=
 		     (unsigned long)VSYSCALL_ADDR);
diff --git a/arch/x86/entry/vsyscall/vsyscall_emu_64.S b/arch/x86/entry/vsyscall/vsyscall_emu_64.S
index c9596a9af..e1f6d5dbd 100644
--- a/arch/x86/entry/vsyscall/vsyscall_emu_64.S
+++ b/arch/x86/entry/vsyscall/vsyscall_emu_64.S
@@ -7,12 +7,13 @@
  */
 
 #include <linux/linkage.h>
+#include <linux/init.h>
 
 #include <asm/irq_vectors.h>
 #include <asm/page_types.h>
 #include <asm/unistd_64.h>
 
-__PAGE_ALIGNED_DATA
+	__READ_ONLY
 	.globl __vsyscall_page
 	.balign PAGE_SIZE, 0xcc
 	.type __vsyscall_page, @object
diff --git a/arch/x86/events/amd/iommu.c b/arch/x86/events/amd/iommu.c
index b28200dea..e93e14d68 100644
--- a/arch/x86/events/amd/iommu.c
+++ b/arch/x86/events/amd/iommu.c
@@ -80,12 +80,12 @@ static struct attribute_group amd_iommu_format_group = {
  * sysfs events attributes
  *---------------------------------------------*/
 struct amd_iommu_event_desc {
-	struct kobj_attribute attr;
+	struct device_attribute attr;
 	const char *event;
 };
 
-static ssize_t _iommu_event_show(struct kobject *kobj,
-				struct kobj_attribute *attr, char *buf)
+static ssize_t _iommu_event_show(struct device *dev,
+				struct device_attribute *attr, char *buf)
 {
 	struct amd_iommu_event_desc *event =
 		container_of(attr, struct amd_iommu_event_desc, attr);
@@ -407,7 +407,7 @@ static void perf_iommu_del(struct perf_event *event, int flags)
 static __init int _init_events_attrs(struct perf_amd_iommu *perf_iommu)
 {
 	struct attribute **attrs;
-	struct attribute_group *attr_group;
+	attribute_group_no_const *attr_group;
 	int i = 0, j;
 
 	while (amd_iommu_v2_event_descs[i].attr.attr.name)
diff --git a/arch/x86/events/core.c b/arch/x86/events/core.c
index 7b0f1d932..09c8710d0 100644
--- a/arch/x86/events/core.c
+++ b/arch/x86/events/core.c
@@ -1549,7 +1549,7 @@ static void __init pmu_check_apic(void)
 
 }
 
-static struct attribute_group x86_pmu_format_group = {
+static attribute_group_no_const x86_pmu_format_group = {
 	.name = "format",
 	.attrs = NULL,
 };
@@ -1680,7 +1680,7 @@ static struct attribute *events_attr[] = {
 	NULL,
 };
 
-static struct attribute_group x86_pmu_events_group = {
+static attribute_group_no_const x86_pmu_events_group = {
 	.name = "events",
 	.attrs = events_attr,
 };
@@ -2317,7 +2317,7 @@ static unsigned long get_segment_base(unsigned int segment)
 		if (idx > GDT_ENTRIES)
 			return 0;
 
-		desc = raw_cpu_ptr(gdt_page.gdt) + idx;
+		desc = get_cpu_gdt_table(smp_processor_id()) + idx;
 	}
 
 	return get_desc_base(desc);
@@ -2417,7 +2417,7 @@ perf_callchain_user(struct perf_callchain_entry_ctx *entry, struct pt_regs *regs
 			break;
 
 		perf_callchain_store(entry, frame.return_address);
-		fp = (void __user *)frame.next_frame;
+		fp = (void __force_user *)frame.next_frame;
 	}
 	pagefault_enable();
 }
diff --git a/arch/x86/events/intel/core.c b/arch/x86/events/intel/core.c
index 3ef34c6e6..166e15aa6 100644
--- a/arch/x86/events/intel/core.c
+++ b/arch/x86/events/intel/core.c
@@ -2408,6 +2408,8 @@ __intel_get_event_constraints(struct cpu_hw_events *cpuc, int idx,
 }
 
 static void
+intel_start_scheduling(struct cpu_hw_events *cpuc) __acquires(&cpuc->excl_cntrs->lock);
+static void
 intel_start_scheduling(struct cpu_hw_events *cpuc)
 {
 	struct intel_excl_cntrs *excl_cntrs = cpuc->excl_cntrs;
@@ -2417,14 +2419,18 @@ intel_start_scheduling(struct cpu_hw_events *cpuc)
 	/*
 	 * nothing needed if in group validation mode
 	 */
-	if (cpuc->is_fake || !is_ht_workaround_enabled())
+	if (cpuc->is_fake || !is_ht_workaround_enabled()) {
+		__acquire(&excl_cntrs->lock);
 		return;
+	}
 
 	/*
 	 * no exclusion needed
 	 */
-	if (WARN_ON_ONCE(!excl_cntrs))
+	if (WARN_ON_ONCE(!excl_cntrs)) {
+		__acquire(&excl_cntrs->lock);
 		return;
+	}
 
 	xl = &excl_cntrs->states[tid];
 
@@ -2464,6 +2470,8 @@ static void intel_commit_scheduling(struct cpu_hw_events *cpuc, int idx, int cnt
 }
 
 static void
+intel_stop_scheduling(struct cpu_hw_events *cpuc) __releases(&cpuc->excl_cntrs->lock);
+static void
 intel_stop_scheduling(struct cpu_hw_events *cpuc)
 {
 	struct intel_excl_cntrs *excl_cntrs = cpuc->excl_cntrs;
@@ -2473,13 +2481,18 @@ intel_stop_scheduling(struct cpu_hw_events *cpuc)
 	/*
 	 * nothing needed if in group validation mode
 	 */
-	if (cpuc->is_fake || !is_ht_workaround_enabled())
+	if (cpuc->is_fake || !is_ht_workaround_enabled()) {
+		__release(&excl_cntrs->lock);
 		return;
+	}
+
 	/*
 	 * no exclusion needed
 	 */
-	if (WARN_ON_ONCE(!excl_cntrs))
+	if (WARN_ON_ONCE(!excl_cntrs)) {
+		__release(&excl_cntrs->lock);
 		return;
+	}
 
 	xl = &excl_cntrs->states[tid];
 
@@ -2662,19 +2675,22 @@ static void intel_put_excl_constraints(struct cpu_hw_events *cpuc,
 	 * unused now.
 	 */
 	if (hwc->idx >= 0) {
+		bool sched_started;
+
 		xl = &excl_cntrs->states[tid];
+		sched_started = xl->sched_started;
 
 		/*
 		 * put_constraint may be called from x86_schedule_events()
 		 * which already has the lock held so here make locking
 		 * conditional.
 		 */
-		if (!xl->sched_started)
+		if (!sched_started)
 			raw_spin_lock(&excl_cntrs->lock);
 
 		xl->state[hwc->idx] = INTEL_EXCL_UNUSED;
 
-		if (!xl->sched_started)
+		if (!sched_started)
 			raw_spin_unlock(&excl_cntrs->lock);
 	}
 }
@@ -3608,10 +3624,10 @@ __init int intel_pmu_init(void)
 		x86_pmu.num_counters_fixed = max((int)edx.split.num_counters_fixed, 3);
 
 	if (boot_cpu_has(X86_FEATURE_PDCM)) {
-		u64 capabilities;
+		u64 capabilities = x86_pmu.intel_cap.capabilities;
 
-		rdmsrl(MSR_IA32_PERF_CAPABILITIES, capabilities);
-		x86_pmu.intel_cap.capabilities = capabilities;
+		if (rdmsrl_safe(MSR_IA32_PERF_CAPABILITIES, &x86_pmu.intel_cap.capabilities))
+			x86_pmu.intel_cap.capabilities = capabilities;
 	}
 
 	intel_ds_init();
diff --git a/arch/x86/events/intel/cqm.c b/arch/x86/events/intel/cqm.c
index 8f82b0293..b10c4b0f9 100644
--- a/arch/x86/events/intel/cqm.c
+++ b/arch/x86/events/intel/cqm.c
@@ -1488,7 +1488,7 @@ static struct attribute *intel_cmt_mbm_events_attr[] = {
 	NULL,
 };
 
-static struct attribute_group intel_cqm_events_group = {
+static attribute_group_no_const intel_cqm_events_group __read_only = {
 	.name = "events",
 	.attrs = NULL,
 };
@@ -1732,7 +1732,9 @@ static int __init intel_cqm_init(void)
 		goto out;
 	}
 
-	event_attr_intel_cqm_llc_scale.event_str = str;
+	pax_open_kernel();
+	const_cast(event_attr_intel_cqm_llc_scale.event_str) = str;
+	pax_close_kernel();
 
 	ret = intel_cqm_setup_rmid_cache();
 	if (ret)
@@ -1743,12 +1745,14 @@ static int __init intel_cqm_init(void)
 	if (ret && !cqm_enabled)
 		goto out;
 
+	pax_open_kernel();
 	if (cqm_enabled && mbm_enabled)
-		intel_cqm_events_group.attrs = intel_cmt_mbm_events_attr;
+		const_cast(intel_cqm_events_group.attrs) = intel_cmt_mbm_events_attr;
 	else if (!cqm_enabled && mbm_enabled)
-		intel_cqm_events_group.attrs = intel_mbm_events_attr;
+		const_cast(intel_cqm_events_group.attrs) = intel_mbm_events_attr;
 	else if (cqm_enabled && !mbm_enabled)
-		intel_cqm_events_group.attrs = intel_cqm_events_attr;
+		const_cast(intel_cqm_events_group.attrs) = intel_cqm_events_attr;
+	pax_close_kernel();
 
 	ret = perf_pmu_register(&intel_cqm_pmu, "intel_cqm", -1);
 	if (ret) {
diff --git a/arch/x86/events/intel/cstate.c b/arch/x86/events/intel/cstate.c
index 834262aec..a1fc484c9 100644
--- a/arch/x86/events/intel/cstate.c
+++ b/arch/x86/events/intel/cstate.c
@@ -95,14 +95,14 @@
 MODULE_LICENSE("GPL");
 
 #define DEFINE_CSTATE_FORMAT_ATTR(_var, _name, _format)		\
-static ssize_t __cstate_##_var##_show(struct kobject *kobj,	\
-				struct kobj_attribute *attr,	\
+static ssize_t __cstate_##_var##_show(struct device *dev,	\
+				struct device_attribute *attr,	\
 				char *page)			\
 {								\
 	BUILD_BUG_ON(sizeof(_format) >= PAGE_SIZE);		\
 	return sprintf(page, _format "\n");			\
 }								\
-static struct kobj_attribute format_attr_##_var =		\
+static struct device_attribute format_attr_##_var =		\
 	__ATTR(_name, 0444, __cstate_##_var##_show, NULL)
 
 static ssize_t cstate_get_attr_cpumask(struct device *dev,
diff --git a/arch/x86/events/intel/ds.c b/arch/x86/events/intel/ds.c
index 8fc714b4f..0ce11c3a4 100644
--- a/arch/x86/events/intel/ds.c
+++ b/arch/x86/events/intel/ds.c
@@ -601,7 +601,7 @@ unlock:
 
 static inline void intel_pmu_drain_pebs_buffer(void)
 {
-	struct pt_regs regs;
+	struct pt_regs regs = {};
 
 	x86_pmu.drain_pebs(&regs);
 }
@@ -909,7 +909,7 @@ static int intel_pmu_pebs_fixup_ip(struct pt_regs *regs)
 	struct cpu_hw_events *cpuc = this_cpu_ptr(&cpu_hw_events);
 	unsigned long from = cpuc->lbr_entries[0].from;
 	unsigned long old_to, to = cpuc->lbr_entries[0].to;
-	unsigned long ip = regs->ip;
+	unsigned long ip = ktva_ktla(regs->ip);
 	int is_64bit = 0;
 	void *kaddr;
 	int size;
@@ -961,6 +961,7 @@ static int intel_pmu_pebs_fixup_ip(struct pt_regs *regs)
 	} else {
 		kaddr = (void *)to;
 	}
+	kaddr = (void *)ktva_ktla((unsigned long)kaddr);
 
 	do {
 		struct insn insn;
@@ -1120,7 +1121,7 @@ static void setup_pebs_sample_data(struct perf_event *event,
 	}
 
 	if (event->attr.precise_ip > 1 && x86_pmu.intel_cap.pebs_format >= 2) {
-		regs->ip = pebs->real_ip;
+		set_linear_ip(regs, pebs->real_ip);
 		regs->flags |= PERF_EFLAGS_EXACT;
 	} else if (event->attr.precise_ip > 1 && intel_pmu_pebs_fixup_ip(regs))
 		regs->flags |= PERF_EFLAGS_EXACT;
diff --git a/arch/x86/events/intel/lbr.c b/arch/x86/events/intel/lbr.c
index 707d358e0..9eb1c4f18 100644
--- a/arch/x86/events/intel/lbr.c
+++ b/arch/x86/events/intel/lbr.c
@@ -811,7 +811,7 @@ static int branch_type(unsigned long from, unsigned long to, int abort)
 		 * Ensure we don't blindy read any address by validating it is
 		 * a known text address.
 		 */
-		if (kernel_text_address(from)) {
+		if (kernel_text_address(ktva_ktla(from))) {
 			addr = (void *)from;
 			/*
 			 * Assume we can get the maximum possible size
@@ -833,7 +833,7 @@ static int branch_type(unsigned long from, unsigned long to, int abort)
 #ifdef CONFIG_X86_64
 	is64 = kernel_ip((unsigned long)addr) || !test_thread_flag(TIF_IA32);
 #endif
-	insn_init(&insn, addr, bytes_read, is64);
+	insn_init(&insn, (void *)ktva_ktla((unsigned long)addr), bytes_read, is64);
 	insn_get_opcode(&insn);
 	if (!insn.opcode.got)
 		return X86_BR_ABORT;
diff --git a/arch/x86/events/intel/pt.c b/arch/x86/events/intel/pt.c
index 861a7d9cb..2ff89b2b4 100644
--- a/arch/x86/events/intel/pt.c
+++ b/arch/x86/events/intel/pt.c
@@ -172,11 +172,9 @@ static const struct attribute_group *pt_attr_groups[] = {
 
 static int __init pt_pmu_hw_init(void)
 {
-	struct dev_ext_attribute *de_attrs;
-	struct attribute **attrs;
-	size_t size;
+	static struct dev_ext_attribute de_attrs[ARRAY_SIZE(pt_caps)];
+	static struct attribute *attrs[ARRAY_SIZE(pt_caps)];
 	u64 reg;
-	int ret;
 	long i;
 
 	rdmsrl(MSR_PLATFORM_INFO, reg);
@@ -207,8 +205,6 @@ static int __init pt_pmu_hw_init(void)
 			pt_pmu.vmx = true;
 	}
 
-	attrs = NULL;
-
 	for (i = 0; i < PT_CPUID_LEAVES; i++) {
 		cpuid_count(20, i,
 			    &pt_pmu.caps[CR_EAX + i*PT_CPUID_REGS_NUM],
@@ -217,39 +213,25 @@ static int __init pt_pmu_hw_init(void)
 			    &pt_pmu.caps[CR_EDX + i*PT_CPUID_REGS_NUM]);
 	}
 
-	ret = -ENOMEM;
-	size = sizeof(struct attribute *) * (ARRAY_SIZE(pt_caps)+1);
-	attrs = kzalloc(size, GFP_KERNEL);
-	if (!attrs)
-		goto fail;
-
-	size = sizeof(struct dev_ext_attribute) * (ARRAY_SIZE(pt_caps)+1);
-	de_attrs = kzalloc(size, GFP_KERNEL);
-	if (!de_attrs)
-		goto fail;
-
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(pt_caps); i++) {
-		struct dev_ext_attribute *de_attr = de_attrs + i;
+		struct dev_ext_attribute *de_attr = &de_attrs[i];
 
-		de_attr->attr.attr.name = pt_caps[i].name;
+		const_cast(de_attr->attr.attr.name) = pt_caps[i].name;
 
 		sysfs_attr_init(&de_attr->attr.attr);
 
-		de_attr->attr.attr.mode		= S_IRUGO;
-		de_attr->attr.show		= pt_cap_show;
-		de_attr->var			= (void *)i;
+		const_cast(de_attr->attr.attr.mode)	= S_IRUGO;
+		const_cast(de_attr->attr.show)		= pt_cap_show;
+		const_cast(de_attr->var)		= (void *)i;
 
 		attrs[i] = &de_attr->attr.attr;
 	}
 
-	pt_cap_group.attrs = attrs;
+	const_cast(pt_cap_group.attrs) = attrs;
+	pax_close_kernel();
 
 	return 0;
-
-fail:
-	kfree(attrs);
-
-	return ret;
 }
 
 #define RTIT_CTL_CYC_PSB (RTIT_CTL_CYCLEACC	| \
diff --git a/arch/x86/events/intel/rapl.c b/arch/x86/events/intel/rapl.c
index 28865938a..f1911221d 100644
--- a/arch/x86/events/intel/rapl.c
+++ b/arch/x86/events/intel/rapl.c
@@ -117,14 +117,14 @@ static const char *const rapl_domain_names[NR_RAPL_DOMAINS] __initconst = {
 #define RAPL_EVENT_MASK	0xFFULL
 
 #define DEFINE_RAPL_FORMAT_ATTR(_var, _name, _format)		\
-static ssize_t __rapl_##_var##_show(struct kobject *kobj,	\
-				struct kobj_attribute *attr,	\
+static ssize_t __rapl_##_var##_show(struct device *dev,		\
+				struct device_attribute *attr,	\
 				char *page)			\
 {								\
 	BUILD_BUG_ON(sizeof(_format) >= PAGE_SIZE);		\
 	return sprintf(page, _format "\n");			\
 }								\
-static struct kobj_attribute format_attr_##_var =		\
+static struct device_attribute format_attr_##_var =		\
 	__ATTR(_name, 0444, __rapl_##_var##_show, NULL)
 
 #define RAPL_CNTR_WIDTH 32
@@ -533,7 +533,7 @@ static struct attribute *rapl_events_knl_attr[] = {
 	NULL,
 };
 
-static struct attribute_group rapl_pmu_events_group = {
+static attribute_group_no_const rapl_pmu_events_group __read_only = {
 	.name = "events",
 	.attrs = NULL, /* patched at runtime */
 };
diff --git a/arch/x86/events/intel/uncore.c b/arch/x86/events/intel/uncore.c
index 463dc7a5a..4c8d08bf8 100644
--- a/arch/x86/events/intel/uncore.c
+++ b/arch/x86/events/intel/uncore.c
@@ -90,8 +90,8 @@ end:
 	return map;
 }
 
-ssize_t uncore_event_show(struct kobject *kobj,
-			  struct kobj_attribute *attr, char *buf)
+ssize_t uncore_event_show(struct device *dev,
+			  struct device_attribute *attr, char *buf)
 {
 	struct uncore_event_desc *event =
 		container_of(attr, struct uncore_event_desc, attr);
@@ -819,7 +819,7 @@ static void uncore_types_exit(struct intel_uncore_type **types)
 static int __init uncore_type_init(struct intel_uncore_type *type, bool setid)
 {
 	struct intel_uncore_pmu *pmus;
-	struct attribute_group *attr_group;
+	attribute_group_no_const *attr_group;
 	struct attribute **attrs;
 	size_t size;
 	int i, j;
diff --git a/arch/x86/events/intel/uncore.h b/arch/x86/events/intel/uncore.h
index 78b9c23e2..2f5c61ece 100644
--- a/arch/x86/events/intel/uncore.h
+++ b/arch/x86/events/intel/uncore.h
@@ -122,9 +122,9 @@ struct intel_uncore_box {
 #define UNCORE_BOX_FLAG_INITIATED	0
 
 struct uncore_event_desc {
-	struct kobj_attribute attr;
+	struct device_attribute attr;
 	const char *config;
-};
+} __do_const;
 
 struct pci2phy_map {
 	struct list_head list;
@@ -134,8 +134,8 @@ struct pci2phy_map {
 
 struct pci2phy_map *__find_pci2phy_map(int segment);
 
-ssize_t uncore_event_show(struct kobject *kobj,
-			  struct kobj_attribute *attr, char *buf);
+ssize_t uncore_event_show(struct device *dev,
+			  struct device_attribute *attr, char *buf);
 
 #define INTEL_UNCORE_EVENT_DESC(_name, _config)			\
 {								\
@@ -144,14 +144,14 @@ ssize_t uncore_event_show(struct kobject *kobj,
 }
 
 #define DEFINE_UNCORE_FORMAT_ATTR(_var, _name, _format)			\
-static ssize_t __uncore_##_var##_show(struct kobject *kobj,		\
-				struct kobj_attribute *attr,		\
+static ssize_t __uncore_##_var##_show(struct device *dev,		\
+				struct device_attribute *attr,		\
 				char *page)				\
 {									\
 	BUILD_BUG_ON(sizeof(_format) >= PAGE_SIZE);			\
 	return sprintf(page, _format "\n");				\
 }									\
-static struct kobj_attribute format_attr_##_var =			\
+static struct device_attribute format_attr_##_var =			\
 	__ATTR(_name, 0444, __uncore_##_var##_show, NULL)
 
 static inline unsigned uncore_pci_box_ctl(struct intel_uncore_box *box)
diff --git a/arch/x86/events/perf_event.h b/arch/x86/events/perf_event.h
index 4ab002d4c..5a30205d5 100644
--- a/arch/x86/events/perf_event.h
+++ b/arch/x86/events/perf_event.h
@@ -801,7 +801,7 @@ static inline void set_linear_ip(struct pt_regs *regs, unsigned long ip)
 	regs->cs = kernel_ip(ip) ? __KERNEL_CS : __USER_CS;
 	if (regs->flags & X86_VM_MASK)
 		regs->flags ^= (PERF_EFLAGS_VM | X86_VM_MASK);
-	regs->ip = ip;
+	regs->ip = kernel_ip(ip) ? ktva_ktla(ip) : ip;
 }
 
 ssize_t x86_event_sysfs_show(char *page, u64 config, u64 event);
diff --git a/arch/x86/ia32/ia32_aout.c b/arch/x86/ia32/ia32_aout.c
index cb26f18d4..4f43f2399 100644
--- a/arch/x86/ia32/ia32_aout.c
+++ b/arch/x86/ia32/ia32_aout.c
@@ -153,6 +153,8 @@ static int aout_core_dump(struct coredump_params *cprm)
 	unsigned long dump_start, dump_size;
 	struct user32 dump;
 
+	memset(&dump, 0, sizeof(dump));
+
 	fs = get_fs();
 	set_fs(KERNEL_DS);
 	has_dumped = 1;
diff --git a/arch/x86/ia32/ia32_signal.c b/arch/x86/ia32/ia32_signal.c
index 2f29f4e40..ac453b42c 100644
--- a/arch/x86/ia32/ia32_signal.c
+++ b/arch/x86/ia32/ia32_signal.c
@@ -123,7 +123,7 @@ asmlinkage long sys32_sigreturn(void)
 	if (__get_user(set.sig[0], &frame->sc.oldmask)
 	    || (_COMPAT_NSIG_WORDS > 1
 		&& __copy_from_user((((char *) &set.sig) + 4),
-				    &frame->extramask,
+				    frame->extramask,
 				    sizeof(frame->extramask))))
 		goto badframe;
 
@@ -243,7 +243,7 @@ static void __user *get_sigframe(struct ksignal *ksig, struct pt_regs *regs,
 	sp -= frame_size;
 	/* Align the stack pointer according to the i386 ABI,
 	 * i.e. so that on function entry ((sp + 4) & 15) == 0. */
-	sp = ((sp + 4) & -16ul) - 4;
+	sp = ((sp - 12) & -16ul) - 4;
 	return (void __user *) sp;
 }
 
@@ -288,10 +288,10 @@ int ia32_setup_frame(int sig, struct ksignal *ksig,
 	} else {
 		/* Return stub is in 32bit vsyscall page */
 		if (current->mm->context.vdso)
-			restorer = current->mm->context.vdso +
-				vdso_image_32.sym___kernel_sigreturn;
+			restorer = (void __force_user *)(current->mm->context.vdso +
+				vdso_image_32.sym___kernel_sigreturn);
 		else
-			restorer = &frame->retcode;
+			restorer = frame->retcode;
 	}
 
 	put_user_try {
@@ -301,7 +301,7 @@ int ia32_setup_frame(int sig, struct ksignal *ksig,
 		 * These are actually not used anymore, but left because some
 		 * gdb versions depend on them as a marker.
 		 */
-		put_user_ex(*((u64 *)&code), (u64 __user *)frame->retcode);
+		put_user_ex(*((const u64 *)&code), (u64 __user *)frame->retcode);
 	} put_user_catch(err);
 
 	if (err)
@@ -343,7 +343,7 @@ int ia32_setup_rt_frame(int sig, struct ksignal *ksig,
 		0xb8,
 		__NR_ia32_rt_sigreturn,
 		0x80cd,
-		0,
+		0
 	};
 
 	frame = get_sigframe(ksig, regs, sizeof(*frame), &fpstate);
@@ -366,16 +366,19 @@ int ia32_setup_rt_frame(int sig, struct ksignal *ksig,
 
 		if (ksig->ka.sa.sa_flags & SA_RESTORER)
 			restorer = ksig->ka.sa.sa_restorer;
+		else if (current->mm->context.vdso)
+			/* Return stub is in 32bit vsyscall page */
+			restorer = (void __force_user *)(current->mm->context.vdso +
+				vdso_image_32.sym___kernel_rt_sigreturn);
 		else
-			restorer = current->mm->context.vdso +
-				vdso_image_32.sym___kernel_rt_sigreturn;
+			restorer = frame->retcode;
 		put_user_ex(ptr_to_compat(restorer), &frame->pretcode);
 
 		/*
 		 * Not actually used anymore, but left because some gdb
 		 * versions need it.
 		 */
-		put_user_ex(*((u64 *)&code), (u64 __user *)frame->retcode);
+		put_user_ex(*((const u64 *)&code), (u64 __user *)frame->retcode);
 	} put_user_catch(err);
 
 	err |= copy_siginfo_to_user32(&frame->info, &ksig->info);
diff --git a/arch/x86/ia32/sys_ia32.c b/arch/x86/ia32/sys_ia32.c
index 719cd702b..72af944a8 100644
--- a/arch/x86/ia32/sys_ia32.c
+++ b/arch/x86/ia32/sys_ia32.c
@@ -49,18 +49,26 @@
 
 #define AA(__x)		((unsigned long)(__x))
 
+static inline loff_t compose_loff(unsigned int high, unsigned int low)
+{
+	loff_t retval = low;
+
+	BUILD_BUG_ON(sizeof retval != sizeof low + sizeof high);
+	__builtin_memcpy((unsigned char *)&retval + sizeof low, &high, sizeof high);
+	return retval;
+}
 
 asmlinkage long sys32_truncate64(const char __user *filename,
-				 unsigned long offset_low,
-				 unsigned long offset_high)
+				 unsigned int offset_low,
+				 unsigned int offset_high)
 {
-       return sys_truncate(filename, ((loff_t) offset_high << 32) | offset_low);
+	return sys_truncate(filename, compose_loff(offset_high, offset_low));
 }
 
-asmlinkage long sys32_ftruncate64(unsigned int fd, unsigned long offset_low,
-				  unsigned long offset_high)
+asmlinkage long sys32_ftruncate64(unsigned int fd, unsigned int offset_low,
+				  unsigned int offset_high)
 {
-       return sys_ftruncate(fd, ((loff_t) offset_high << 32) | offset_low);
+	return sys_ftruncate(fd, ((unsigned long) offset_high << 32) | offset_low);
 }
 
 /*
@@ -69,8 +77,8 @@ asmlinkage long sys32_ftruncate64(unsigned int fd, unsigned long offset_low,
  */
 static int cp_stat64(struct stat64 __user *ubuf, struct kstat *stat)
 {
-	typeof(ubuf->st_uid) uid = 0;
-	typeof(ubuf->st_gid) gid = 0;
+	typeof(((struct stat64 *)0)->st_uid) uid = 0;
+	typeof(((struct stat64 *)0)->st_gid) gid = 0;
 	SET_UID(uid, from_kuid_munged(current_user_ns(), stat->uid));
 	SET_GID(gid, from_kgid_munged(current_user_ns(), stat->gid));
 	if (!access_ok(VERIFY_WRITE, ubuf, sizeof(struct stat64)) ||
@@ -196,29 +204,29 @@ long sys32_fadvise64_64(int fd, __u32 offset_low, __u32 offset_high,
 			__u32 len_low, __u32 len_high, int advice)
 {
 	return sys_fadvise64_64(fd,
-			       (((u64)offset_high)<<32) | offset_low,
-			       (((u64)len_high)<<32) | len_low,
+			       compose_loff(offset_high, offset_low),
+			       compose_loff(len_high, len_low),
 				advice);
 }
 
 asmlinkage ssize_t sys32_readahead(int fd, unsigned off_lo, unsigned off_hi,
 				   size_t count)
 {
-	return sys_readahead(fd, ((u64)off_hi << 32) | off_lo, count);
+	return sys_readahead(fd, compose_loff(off_hi, off_lo), count);
 }
 
 asmlinkage long sys32_sync_file_range(int fd, unsigned off_low, unsigned off_hi,
 				      unsigned n_low, unsigned n_hi,  int flags)
 {
 	return sys_sync_file_range(fd,
-				   ((u64)off_hi << 32) | off_low,
-				   ((u64)n_hi << 32) | n_low, flags);
+				   compose_loff(off_hi, off_low),
+				   compose_loff(n_hi, n_low), flags);
 }
 
 asmlinkage long sys32_fadvise64(int fd, unsigned offset_lo, unsigned offset_hi,
-				size_t len, int advice)
+				int len, int advice)
 {
-	return sys_fadvise64_64(fd, ((u64)offset_hi << 32) | offset_lo,
+	return sys_fadvise64_64(fd, compose_loff(offset_hi, offset_lo),
 				len, advice);
 }
 
@@ -226,6 +234,6 @@ asmlinkage long sys32_fallocate(int fd, int mode, unsigned offset_lo,
 				unsigned offset_hi, unsigned len_lo,
 				unsigned len_hi)
 {
-	return sys_fallocate(fd, mode, ((u64)offset_hi << 32) | offset_lo,
-			     ((u64)len_hi << 32) | len_lo);
+	return sys_fallocate(fd, mode, compose_loff(offset_hi, offset_lo),
+			     compose_loff(len_hi, len_lo));
 }
diff --git a/arch/x86/include/asm/alternative-asm.h b/arch/x86/include/asm/alternative-asm.h
index e7636bac7..b9d3a6dd0 100644
--- a/arch/x86/include/asm/alternative-asm.h
+++ b/arch/x86/include/asm/alternative-asm.h
@@ -4,6 +4,7 @@
 #ifdef __ASSEMBLY__
 
 #include <asm/asm.h>
+#include <asm/irq_vectors.h>
 
 #ifdef CONFIG_SMP
 	.macro LOCK_PREFIX
@@ -18,6 +19,45 @@
 	.endm
 #endif
 
+#ifdef KERNEXEC_PLUGIN
+	.macro pax_force_retaddr_bts rip=0
+	btsq $63,\rip(%rsp)
+	.endm
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_BTS
+	.macro pax_force_retaddr rip=0, reload=0
+	btsq $63,\rip(%rsp)
+	.endm
+	.macro pax_force_fptr ptr
+	btsq $63,\ptr
+	.endm
+	.macro pax_set_fptr_mask
+	.endm
+#endif
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR
+	.macro pax_force_retaddr rip=0, reload=0
+	.if \reload
+	pax_set_fptr_mask
+	.endif
+	orq %r12,\rip(%rsp)
+	.endm
+	.macro pax_force_fptr ptr
+	orq %r12,\ptr
+	.endm
+	.macro pax_set_fptr_mask
+	movabs $0x8000000000000000,%r12
+	.endm
+#endif
+#else
+	.macro pax_force_retaddr rip=0, reload=0
+	.endm
+	.macro pax_force_fptr ptr
+	.endm
+	.macro pax_force_retaddr_bts rip=0
+	.endm
+	.macro pax_set_fptr_mask
+	.endm
+#endif
+
 /*
  * Issue one struct alt_instr descriptor entry (need to put it into
  * the section .altinstructions, see below). This entry contains
@@ -50,7 +90,7 @@
 	altinstruction_entry 140b,143f,\feature,142b-140b,144f-143f,142b-141b
 	.popsection
 
-	.pushsection .altinstr_replacement,"ax"
+	.pushsection .altinstr_replacement,"a"
 143:
 	\newinstr
 144:
@@ -86,7 +126,7 @@
 	altinstruction_entry 140b,144f,\feature2,142b-140b,145f-144f,142b-141b
 	.popsection
 
-	.pushsection .altinstr_replacement,"ax"
+	.pushsection .altinstr_replacement,"a"
 143:
 	\newinstr1
 144:
@@ -95,6 +135,26 @@
 	.popsection
 .endm
 
+.macro __PAX_REFCOUNT section, counter
+#ifdef CONFIG_PAX_REFCOUNT
+	jo 111f
+	.pushsection .text.\section
+111:	lea \counter,%_ASM_CX
+	int $X86_REFCOUNT_VECTOR
+222:
+	.popsection
+333:
+	_ASM_EXTABLE(222b, 333b)
+#endif
+.endm
+
+.macro PAX_REFCOUNT64_OVERFLOW counter
+	__PAX_REFCOUNT refcount64_overflow, \counter
+.endm
+
+.macro PAX_REFCOUNT64_UNDERFLOW counter
+	__PAX_REFCOUNT refcount64_underflow, \counter
+.endm
 #endif  /*  __ASSEMBLY__  */
 
 #endif /* _ASM_X86_ALTERNATIVE_ASM_H */
diff --git a/arch/x86/include/asm/alternative.h b/arch/x86/include/asm/alternative.h
index e77a64431..6bbec6fbd 100644
--- a/arch/x86/include/asm/alternative.h
+++ b/arch/x86/include/asm/alternative.h
@@ -7,6 +7,7 @@
 #include <linux/stddef.h>
 #include <linux/stringify.h>
 #include <asm/asm.h>
+#include <asm/irq_vectors.h>
 
 /*
  * Alternative inline assembly for SMP.
@@ -137,7 +138,7 @@ static inline int alternatives_text_reserved(void *start, void *end)
 	".pushsection .altinstructions,\"a\"\n"				\
 	ALTINSTR_ENTRY(feature, 1)					\
 	".popsection\n"							\
-	".pushsection .altinstr_replacement, \"ax\"\n"			\
+	".pushsection .altinstr_replacement, \"a\"\n"			\
 	ALTINSTR_REPLACEMENT(newinstr, feature, 1)			\
 	".popsection"
 
@@ -147,7 +148,7 @@ static inline int alternatives_text_reserved(void *start, void *end)
 	ALTINSTR_ENTRY(feature1, 1)					\
 	ALTINSTR_ENTRY(feature2, 2)					\
 	".popsection\n"							\
-	".pushsection .altinstr_replacement, \"ax\"\n"			\
+	".pushsection .altinstr_replacement, \"a\"\n"			\
 	ALTINSTR_REPLACEMENT(newinstr1, feature1, 1)			\
 	ALTINSTR_REPLACEMENT(newinstr2, feature2, 2)			\
 	".popsection"
@@ -234,6 +235,35 @@ static inline int alternatives_text_reserved(void *start, void *end)
  */
 #define ASM_NO_INPUT_CLOBBER(clbr...) "i" (0) : clbr
 
+#ifdef CONFIG_PAX_REFCOUNT
+#define __PAX_REFCOUNT(size)				\
+	"jo 111f\n"					\
+	".if "__stringify(size)" == 4\n\t"		\
+	".pushsection .text.refcount_overflow\n"	\
+	".elseif "__stringify(size)" == -4\n\t"		\
+	".pushsection .text.refcount_underflow\n"	\
+	".elseif "__stringify(size)" == 8\n\t"		\
+	".pushsection .text.refcount64_overflow\n"	\
+	".elseif "__stringify(size)" == -8\n\t"		\
+	".pushsection .text.refcount64_underflow\n"	\
+	".else\n"					\
+	".error \"invalid size\"\n"			\
+	".endif\n"					\
+	"111:\tlea %[counter],%%"_ASM_CX"\n\t"		\
+	"int $"__stringify(X86_REFCOUNT_VECTOR)"\n"	\
+	"222:\n\t"					\
+	".popsection\n"					\
+	"333:\n"					\
+	_ASM_EXTABLE(222b, 333b)
+
+#define PAX_REFCOUNT_OVERFLOW(size)	__PAX_REFCOUNT(size)
+#define PAX_REFCOUNT_UNDERFLOW(size)	__PAX_REFCOUNT(-(size))
+#else
+#define __PAX_REFCOUNT(size)
+#define PAX_REFCOUNT_OVERFLOW(size)
+#define PAX_REFCOUNT_UNDERFLOW(size)
+#endif
+
 #endif /* __ASSEMBLY__ */
 
 #endif /* _ASM_X86_ALTERNATIVE_H */
diff --git a/arch/x86/include/asm/apic.h b/arch/x86/include/asm/apic.h
index 124357773..302ac39aa 100644
--- a/arch/x86/include/asm/apic.h
+++ b/arch/x86/include/asm/apic.h
@@ -49,7 +49,7 @@ static inline void generic_apic_probe(void)
 
 #ifdef CONFIG_X86_LOCAL_APIC
 
-extern unsigned int apic_verbosity;
+extern int apic_verbosity;
 extern int local_apic_timer_c2_ok;
 
 extern int disable_apic;
diff --git a/arch/x86/include/asm/apm.h b/arch/x86/include/asm/apm.h
index 93eebc636..6a643955f 100644
--- a/arch/x86/include/asm/apm.h
+++ b/arch/x86/include/asm/apm.h
@@ -34,7 +34,7 @@ static inline void apm_bios_call_asm(u32 func, u32 ebx_in, u32 ecx_in,
 	__asm__ __volatile__(APM_DO_ZERO_SEGS
 		"pushl %%edi\n\t"
 		"pushl %%ebp\n\t"
-		"lcall *%%cs:apm_bios_entry\n\t"
+		"lcall *%%ss:apm_bios_entry\n\t"
 		"setc %%al\n\t"
 		"popl %%ebp\n\t"
 		"popl %%edi\n\t"
@@ -58,7 +58,7 @@ static inline bool apm_bios_call_simple_asm(u32 func, u32 ebx_in,
 	__asm__ __volatile__(APM_DO_ZERO_SEGS
 		"pushl %%edi\n\t"
 		"pushl %%ebp\n\t"
-		"lcall *%%cs:apm_bios_entry\n\t"
+		"lcall *%%ss:apm_bios_entry\n\t"
 		"setc %%bl\n\t"
 		"popl %%ebp\n\t"
 		"popl %%edi\n\t"
diff --git a/arch/x86/include/asm/asm.h b/arch/x86/include/asm/asm.h
index 7acb51c49..46ba0b30f 100644
--- a/arch/x86/include/asm/asm.h
+++ b/arch/x86/include/asm/asm.h
@@ -79,30 +79,6 @@
 	_ASM_PTR (entry);					\
 	.popsection
 
-.macro ALIGN_DESTINATION
-	/* check for bad alignment of destination */
-	movl %edi,%ecx
-	andl $7,%ecx
-	jz 102f				/* already aligned */
-	subl $8,%ecx
-	negl %ecx
-	subl %ecx,%edx
-100:	movb (%rsi),%al
-101:	movb %al,(%rdi)
-	incq %rsi
-	incq %rdi
-	decl %ecx
-	jnz 100b
-102:
-	.section .fixup,"ax"
-103:	addl %ecx,%edx			/* ecx is zerorest also */
-	jmp copy_user_handle_tail
-	.previous
-
-	_ASM_EXTABLE(100b,103b)
-	_ASM_EXTABLE(101b,103b)
-	.endm
-
 #else
 # define _EXPAND_EXTABLE_HANDLE(x) #x
 # define _ASM_EXTABLE_HANDLE(from, to, handler)			\
diff --git a/arch/x86/include/asm/atomic.h b/arch/x86/include/asm/atomic.h
index 14635c5ea..199ea31d4 100644
--- a/arch/x86/include/asm/atomic.h
+++ b/arch/x86/include/asm/atomic.h
@@ -27,6 +27,17 @@ static __always_inline int atomic_read(const atomic_t *v)
 }
 
 /**
+ * atomic_read_unchecked - read atomic variable
+ * @v: pointer of type atomic_unchecked_t
+ *
+ * Atomically reads the value of @v.
+ */
+static __always_inline int __intentional_overflow(-1) atomic_read_unchecked(const atomic_unchecked_t *v)
+{
+	return ACCESS_ONCE((v)->counter);
+}
+
+/**
  * atomic_set - set atomic variable
  * @v: pointer of type atomic_t
  * @i: required value
@@ -39,6 +50,18 @@ static __always_inline void atomic_set(atomic_t *v, int i)
 }
 
 /**
+ * atomic_set_unchecked - set atomic variable
+ * @v: pointer of type atomic_unchecked_t
+ * @i: required value
+ *
+ * Atomically sets the value of @v to @i.
+ */
+static __always_inline void atomic_set_unchecked(atomic_unchecked_t *v, int i)
+{
+	v->counter = i;
+}
+
+/**
  * atomic_add - add integer to atomic variable
  * @i: integer value to add
  * @v: pointer of type atomic_t
@@ -47,8 +70,24 @@ static __always_inline void atomic_set(atomic_t *v, int i)
  */
 static __always_inline void atomic_add(int i, atomic_t *v)
 {
-	asm volatile(LOCK_PREFIX "addl %1,%0"
-		     : "+m" (v->counter)
+	asm volatile(LOCK_PREFIX "addl %1,%0\n\t"
+		     PAX_REFCOUNT_OVERFLOW(4)
+		     : [counter] "+m" (v->counter)
+		     : "ir" (i)
+		     : "cc", "cx");
+}
+
+/**
+ * atomic_add_unchecked - add integer to atomic variable
+ * @i: integer value to add
+ * @v: pointer of type atomic_unchecked_t
+ *
+ * Atomically adds @i to @v.
+ */
+static __always_inline void atomic_add_unchecked(int i, atomic_unchecked_t *v)
+{
+	asm volatile(LOCK_PREFIX "addl %1,%0\n"
+		     : [counter] "+m" (v->counter)
 		     : "ir" (i));
 }
 
@@ -61,7 +100,23 @@ static __always_inline void atomic_add(int i, atomic_t *v)
  */
 static __always_inline void atomic_sub(int i, atomic_t *v)
 {
-	asm volatile(LOCK_PREFIX "subl %1,%0"
+	asm volatile(LOCK_PREFIX "subl %1,%0\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(4)
+		     : [counter] "+m" (v->counter)
+		     : "ir" (i)
+		     : "cc", "cx");
+}
+
+/**
+ * atomic_sub_unchecked - subtract integer from atomic variable
+ * @i: integer value to subtract
+ * @v: pointer of type atomic_unchecked_t
+ *
+ * Atomically subtracts @i from @v.
+ */
+static __always_inline void atomic_sub_unchecked(int i, atomic_unchecked_t *v)
+{
+	asm volatile(LOCK_PREFIX "subl %1,%0\n"
 		     : "+m" (v->counter)
 		     : "ir" (i));
 }
@@ -77,7 +132,7 @@ static __always_inline void atomic_sub(int i, atomic_t *v)
  */
 static __always_inline bool atomic_sub_and_test(int i, atomic_t *v)
 {
-	GEN_BINARY_RMWcc(LOCK_PREFIX "subl", v->counter, "er", i, "%0", e);
+	GEN_BINARY_RMWcc(LOCK_PREFIX "subl", v->counter, -4, "er", i, "%0", e);
 }
 
 /**
@@ -88,7 +143,21 @@ static __always_inline bool atomic_sub_and_test(int i, atomic_t *v)
  */
 static __always_inline void atomic_inc(atomic_t *v)
 {
-	asm volatile(LOCK_PREFIX "incl %0"
+	asm volatile(LOCK_PREFIX "incl %0\n\t"
+		     PAX_REFCOUNT_OVERFLOW(4)
+		     : [counter] "+m" (v->counter)
+		     : : "cc", "cx");
+}
+
+/**
+ * atomic_inc_unchecked - increment atomic variable
+ * @v: pointer of type atomic_unchecked_t
+ *
+ * Atomically increments @v by 1.
+ */
+static __always_inline void atomic_inc_unchecked(atomic_unchecked_t *v)
+{
+	asm volatile(LOCK_PREFIX "incl %0\n"
 		     : "+m" (v->counter));
 }
 
@@ -100,7 +169,21 @@ static __always_inline void atomic_inc(atomic_t *v)
  */
 static __always_inline void atomic_dec(atomic_t *v)
 {
-	asm volatile(LOCK_PREFIX "decl %0"
+	asm volatile(LOCK_PREFIX "decl %0\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(4)
+		     : [counter] "+m" (v->counter)
+		     : : "cc", "cx");
+}
+
+/**
+ * atomic_dec_unchecked - decrement atomic variable
+ * @v: pointer of type atomic_unchecked_t
+ *
+ * Atomically decrements @v by 1.
+ */
+static __always_inline void atomic_dec_unchecked(atomic_unchecked_t *v)
+{
+	asm volatile(LOCK_PREFIX "decl %0\n"
 		     : "+m" (v->counter));
 }
 
@@ -114,7 +197,7 @@ static __always_inline void atomic_dec(atomic_t *v)
  */
 static __always_inline bool atomic_dec_and_test(atomic_t *v)
 {
-	GEN_UNARY_RMWcc(LOCK_PREFIX "decl", v->counter, "%0", e);
+	GEN_UNARY_RMWcc(LOCK_PREFIX "decl", v->counter, -4, "%0", e);
 }
 
 /**
@@ -127,7 +210,20 @@ static __always_inline bool atomic_dec_and_test(atomic_t *v)
  */
 static __always_inline bool atomic_inc_and_test(atomic_t *v)
 {
-	GEN_UNARY_RMWcc(LOCK_PREFIX "incl", v->counter, "%0", e);
+	GEN_UNARY_RMWcc(LOCK_PREFIX "incl", v->counter, 4, "%0", e);
+}
+
+/**
+ * atomic_inc_and_test_unchecked - increment and test
+ * @v: pointer of type atomic_unchecked_t
+ *
+ * Atomically increments @v by 1
+ * and returns true if the result is zero, or false for all
+ * other cases.
+ */
+static __always_inline int atomic_inc_and_test_unchecked(atomic_unchecked_t *v)
+{
+	GEN_UNARY_RMWcc_unchecked(LOCK_PREFIX "incl", v->counter, "%0", e);
 }
 
 /**
@@ -141,7 +237,7 @@ static __always_inline bool atomic_inc_and_test(atomic_t *v)
  */
 static __always_inline bool atomic_add_negative(int i, atomic_t *v)
 {
-	GEN_BINARY_RMWcc(LOCK_PREFIX "addl", v->counter, "er", i, "%0", s);
+	GEN_BINARY_RMWcc(LOCK_PREFIX "addl", v->counter, 4, "er", i, "%0", s);
 }
 
 /**
@@ -151,7 +247,19 @@ static __always_inline bool atomic_add_negative(int i, atomic_t *v)
  *
  * Atomically adds @i to @v and returns @i + @v
  */
-static __always_inline int atomic_add_return(int i, atomic_t *v)
+static __always_inline int __intentional_overflow(-1) atomic_add_return(int i, atomic_t *v)
+{
+	return i + xadd_check_overflow(&v->counter, i);
+}
+
+/**
+ * atomic_add_return_unchecked - add integer and return
+ * @i: integer value to add
+ * @v: pointer of type atomi_uncheckedc_t
+ *
+ * Atomically adds @i to @v and returns @i + @v
+ */
+static __always_inline int atomic_add_return_unchecked(int i, atomic_unchecked_t *v)
 {
 	return i + xadd(&v->counter, i);
 }
@@ -163,25 +271,34 @@ static __always_inline int atomic_add_return(int i, atomic_t *v)
  *
  * Atomically subtracts @i from @v and returns @v - @i
  */
-static __always_inline int atomic_sub_return(int i, atomic_t *v)
+static __always_inline int __intentional_overflow(-1) atomic_sub_return(int i, atomic_t *v)
 {
 	return atomic_add_return(-i, v);
 }
 
 #define atomic_inc_return(v)  (atomic_add_return(1, v))
+static __always_inline int atomic_inc_return_unchecked(atomic_unchecked_t *v)
+{
+	return atomic_add_return_unchecked(1, v);
+}
 #define atomic_dec_return(v)  (atomic_sub_return(1, v))
 
 static __always_inline int atomic_fetch_add(int i, atomic_t *v)
 {
-	return xadd(&v->counter, i);
+	return xadd_check_overflow(&v->counter, i);
 }
 
 static __always_inline int atomic_fetch_sub(int i, atomic_t *v)
 {
-	return xadd(&v->counter, -i);
+	return xadd_check_overflow(&v->counter, -i);
 }
 
-static __always_inline int atomic_cmpxchg(atomic_t *v, int old, int new)
+static __always_inline int __intentional_overflow(-1) atomic_cmpxchg(atomic_t *v, int old, int new)
+{
+	return cmpxchg(&v->counter, old, new);
+}
+
+static __always_inline int atomic_cmpxchg_unchecked(atomic_unchecked_t *v, int old, int new)
 {
 	return cmpxchg(&v->counter, old, new);
 }
@@ -191,6 +308,11 @@ static inline int atomic_xchg(atomic_t *v, int new)
 	return xchg(&v->counter, new);
 }
 
+static inline int atomic_xchg_unchecked(atomic_unchecked_t *v, int new)
+{
+	return xchg(&v->counter, new);
+}
+
 #define ATOMIC_OP(op)							\
 static inline void atomic_##op(int i, atomic_t *v)			\
 {									\
@@ -236,12 +358,20 @@ ATOMIC_OPS(xor, ^)
  */
 static __always_inline int __atomic_add_unless(atomic_t *v, int a, int u)
 {
-	int c, old;
+	int c, old, new;
 	c = atomic_read(v);
 	for (;;) {
-		if (unlikely(c == (u)))
+		if (unlikely(c == u))
 			break;
-		old = atomic_cmpxchg((v), c, c + (a));
+
+		asm volatile("addl %2,%0\n\t"
+			     PAX_REFCOUNT_OVERFLOW(4)
+			     : "=r" (new)
+			     : "0" (c), "ir" (a),
+			       [counter] "m" (v->counter)
+			     : "cc", "cx");
+
+		old = atomic_cmpxchg(v, c, new);
 		if (likely(old == c))
 			break;
 		c = old;
@@ -250,6 +380,114 @@ static __always_inline int __atomic_add_unless(atomic_t *v, int a, int u)
 }
 
 /**
+ * atomic_inc_not_zero_hint - increment if not null
+ * @v: pointer of type atomic_t
+ * @hint: probable value of the atomic before the increment
+ *
+ * This version of atomic_inc_not_zero() gives a hint of probable
+ * value of the atomic. This helps processor to not read the memory
+ * before doing the atomic read/modify/write cycle, lowering
+ * number of bus transactions on some arches.
+ *
+ * Returns: 0 if increment was not done, 1 otherwise.
+ */
+#define atomic_inc_not_zero_hint atomic_inc_not_zero_hint
+static inline int atomic_inc_not_zero_hint(atomic_t *v, int hint)
+{
+	int val, c = hint, new;
+
+	/* sanity test, should be removed by compiler if hint is a constant */
+	if (!hint)
+		return __atomic_add_unless(v, 1, 0);
+
+	do {
+		asm volatile("incl %0\n\t"
+			     PAX_REFCOUNT_OVERFLOW(4)
+			     : "=r" (new)
+			     : "0" (c),
+			       [counter] "m" (v->counter)
+			     : "cc", "cx");
+
+		val = atomic_cmpxchg(v, c, new);
+		if (val == c)
+			return 1;
+		c = val;
+	} while (c);
+
+	return 0;
+}
+
+#define atomic_inc_unless_negative atomic_inc_unless_negative
+static inline int atomic_inc_unless_negative(atomic_t *p)
+{
+	int v, v1, new;
+
+	for (v = 0; v >= 0; v = v1) {
+		asm volatile("incl %0\n\t"
+			     PAX_REFCOUNT_OVERFLOW(4)
+			     : "=r" (new)
+			     : "0" (v),
+			       [counter] "m" (p->counter)
+			     : "cc", "cx");
+
+		v1 = atomic_cmpxchg(p, v, new);
+		if (likely(v1 == v))
+			return 1;
+	}
+	return 0;
+}
+
+#define atomic_dec_unless_positive atomic_dec_unless_positive
+static inline int atomic_dec_unless_positive(atomic_t *p)
+{
+	int v, v1, new;
+
+	for (v = 0; v <= 0; v = v1) {
+		asm volatile("decl %0\n\t"
+			     PAX_REFCOUNT_UNDERFLOW(4)
+			     : "=r" (new)
+			     : "0" (v),
+			       [counter] "m" (p->counter)
+			     : "cc", "cx");
+
+		v1 = atomic_cmpxchg(p, v, new);
+		if (likely(v1 == v))
+			return 1;
+	}
+	return 0;
+}
+
+/*
+ * atomic_dec_if_positive - decrement by 1 if old value positive
+ * @v: pointer of type atomic_t
+ *
+ * The function returns the old value of *v minus 1, even if
+ * the atomic variable, v, was not decremented.
+ */
+#define atomic_dec_if_positive atomic_dec_if_positive
+static inline int atomic_dec_if_positive(atomic_t *v)
+{
+	int c, old, dec;
+	c = atomic_read(v);
+	for (;;) {
+		asm volatile("decl %0\n\t"
+			     PAX_REFCOUNT_UNDERFLOW(4)
+			     : "=r" (dec)
+			     : "0" (c),
+			       [counter] "m" (v->counter)
+			     : "cc", "cx");
+
+		if (unlikely(dec < 0))
+			break;
+		old = atomic_cmpxchg(v, c, dec);
+		if (likely(old == c))
+			break;
+		c = old;
+	}
+	return dec;
+}
+
+/**
  * atomic_inc_short - increment of a short integer
  * @v: pointer to type int
  *
diff --git a/arch/x86/include/asm/atomic64_32.h b/arch/x86/include/asm/atomic64_32.h
index 71d7705fb..99a1fe891 100644
--- a/arch/x86/include/asm/atomic64_32.h
+++ b/arch/x86/include/asm/atomic64_32.h
@@ -8,9 +8,17 @@
 /* An 64bit atomic type */
 
 typedef struct {
-	u64 __aligned(8) counter;
+	s64 __aligned(8) counter;
 } atomic64_t;
 
+#ifdef CONFIG_PAX_REFCOUNT
+typedef struct {
+	s64 __aligned(8) counter;
+} atomic64_unchecked_t;
+#else
+typedef atomic64_t atomic64_unchecked_t;
+#endif
+
 #define ATOMIC64_INIT(val)	{ (val) }
 
 #define __ATOMIC64_DECL(sym) void atomic64_##sym(atomic64_t *, ...)
@@ -36,21 +44,31 @@ typedef struct {
 	ATOMIC64_DECL_ONE(sym##_386)
 
 ATOMIC64_DECL_ONE(add_386);
+ATOMIC64_DECL_ONE(add_unchecked_386);
 ATOMIC64_DECL_ONE(sub_386);
+ATOMIC64_DECL_ONE(sub_unchecked_386);
 ATOMIC64_DECL_ONE(inc_386);
+ATOMIC64_DECL_ONE(inc_unchecked_386);
 ATOMIC64_DECL_ONE(dec_386);
+ATOMIC64_DECL_ONE(dec_unchecked_386);
 #endif
 
 #define alternative_atomic64(f, out, in...) \
 	__alternative_atomic64(f, f, ASM_OUTPUT2(out), ## in)
 
 ATOMIC64_DECL(read);
+ATOMIC64_DECL(read_unchecked);
 ATOMIC64_DECL(set);
+ATOMIC64_DECL(set_unchecked);
 ATOMIC64_DECL(xchg);
 ATOMIC64_DECL(add_return);
+ATOMIC64_DECL(add_return_unchecked);
 ATOMIC64_DECL(sub_return);
+ATOMIC64_DECL(sub_return_unchecked);
 ATOMIC64_DECL(inc_return);
+ATOMIC64_DECL(inc_return_unchecked);
 ATOMIC64_DECL(dec_return);
+ATOMIC64_DECL(dec_return_unchecked);
 ATOMIC64_DECL(dec_if_positive);
 ATOMIC64_DECL(inc_not_zero);
 ATOMIC64_DECL(add_unless);
@@ -76,6 +94,21 @@ static inline long long atomic64_cmpxchg(atomic64_t *v, long long o, long long n
 }
 
 /**
+ * atomic64_cmpxchg_unchecked - cmpxchg atomic64 variable
+ * @p: pointer to type atomic64_unchecked_t
+ * @o: expected value
+ * @n: new value
+ *
+ * Atomically sets @v to @n if it was equal to @o and returns
+ * the old value.
+ */
+
+static inline long long atomic64_cmpxchg_unchecked(atomic64_unchecked_t *v, long long o, long long n)
+{
+	return cmpxchg64(&v->counter, o, n);
+}
+
+/**
  * atomic64_xchg - xchg atomic64 variable
  * @v: pointer to type atomic64_t
  * @n: value to assign
@@ -95,6 +128,25 @@ static inline long long atomic64_xchg(atomic64_t *v, long long n)
 }
 
 /**
+ * atomic64_xchg_unchecked - xchg atomic64 variable
+ * @v: pointer to type atomic64_unchecked_t
+ * @n: value to assign
+ *
+ * Atomically xchgs the value of @v to @n and returns
+ * the old value.
+ */
+static inline long long atomic64_xchg_unchecked(atomic64_unchecked_t *v, long long n)
+{
+	long long o;
+	unsigned high = (unsigned)(n >> 32);
+	unsigned low = (unsigned)n;
+	alternative_atomic64(xchg, "=&A" (o),
+			     "S" (v), "b" (low), "c" (high)
+			     : "memory");
+	return o;
+}
+
+/**
  * atomic64_set - set atomic64 variable
  * @v: pointer to type atomic64_t
  * @i: value to assign
@@ -111,6 +163,22 @@ static inline void atomic64_set(atomic64_t *v, long long i)
 }
 
 /**
+ * atomic64_set_unchecked - set atomic64 variable
+ * @v: pointer to type atomic64_unchecked_t
+ * @n: value to assign
+ *
+ * Atomically sets the value of @v to @n.
+ */
+static inline void atomic64_set_unchecked(atomic64_unchecked_t *v, long long i)
+{
+	unsigned high = (unsigned)(i >> 32);
+	unsigned low = (unsigned)i;
+	alternative_atomic64(set, /* no output */,
+			     "S" (v), "b" (low), "c" (high)
+			     : "eax", "edx", "memory");
+}
+
+/**
  * atomic64_read - read atomic64 variable
  * @v: pointer to type atomic64_t
  *
@@ -124,6 +192,19 @@ static inline long long atomic64_read(const atomic64_t *v)
  }
 
 /**
+ * atomic64_read_unchecked - read atomic64 variable
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically reads the value of @v and returns it.
+ */
+static inline long long __intentional_overflow(-1) atomic64_read_unchecked(const atomic64_unchecked_t *v)
+{
+	long long r;
+	alternative_atomic64(read, "=&A" (r), "c" (v) : "memory");
+	return r;
+ }
+
+/**
  * atomic64_add_return - add and return
  * @i: integer value to add
  * @v: pointer to type atomic64_t
@@ -138,6 +219,21 @@ static inline long long atomic64_add_return(long long i, atomic64_t *v)
 	return i;
 }
 
+/**
+ * atomic64_add_return_unchecked - add and return
+ * @i: integer value to add
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically adds @i to @v and returns @i + *@v
+ */
+static inline long long atomic64_add_return_unchecked(long long i, atomic64_unchecked_t *v)
+{
+	alternative_atomic64(add_return_unchecked,
+			     ASM_OUTPUT2("+A" (i), "+c" (v)),
+			     ASM_NO_INPUT_CLOBBER("memory"));
+	return i;
+}
+
 /*
  * Other variants with different arithmetic operators:
  */
@@ -157,6 +253,14 @@ static inline long long atomic64_inc_return(atomic64_t *v)
 	return a;
 }
 
+static inline long long atomic64_inc_return_unchecked(atomic64_unchecked_t *v)
+{
+	long long a;
+	alternative_atomic64(inc_return_unchecked, "=&A" (a),
+			     "S" (v) : "memory", "ecx");
+	return a;
+}
+
 static inline long long atomic64_dec_return(atomic64_t *v)
 {
 	long long a;
@@ -181,6 +285,21 @@ static inline long long atomic64_add(long long i, atomic64_t *v)
 }
 
 /**
+ * atomic64_add_unchecked - add integer to atomic64 variable
+ * @i: integer value to add
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically adds @i to @v.
+ */
+static inline long long atomic64_add_unchecked(long long i, atomic64_unchecked_t *v)
+{
+	__alternative_atomic64(add_unchecked, add_return_unchecked,
+			       ASM_OUTPUT2("+A" (i), "+c" (v)),
+			       ASM_NO_INPUT_CLOBBER("memory"));
+	return i;
+}
+
+/**
  * atomic64_sub - subtract the atomic64 variable
  * @i: integer value to subtract
  * @v: pointer to type atomic64_t
@@ -222,6 +341,18 @@ static inline void atomic64_inc(atomic64_t *v)
 }
 
 /**
+ * atomic64_inc_unchecked - increment atomic64 variable
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically increments @v by 1.
+ */
+static inline void atomic64_inc_unchecked(atomic64_unchecked_t *v)
+{
+	__alternative_atomic64(inc_unchecked, inc_return_unchecked, /* no output */,
+			       "S" (v) : "memory", "eax", "ecx", "edx");
+}
+
+/**
  * atomic64_dec - decrement atomic64 variable
  * @v: pointer to type atomic64_t
  *
diff --git a/arch/x86/include/asm/atomic64_64.h b/arch/x86/include/asm/atomic64_64.h
index 89ed2f6ae..25490ad26 100644
--- a/arch/x86/include/asm/atomic64_64.h
+++ b/arch/x86/include/asm/atomic64_64.h
@@ -22,6 +22,18 @@ static inline long atomic64_read(const atomic64_t *v)
 }
 
 /**
+ * atomic64_read_unchecked - read atomic64 variable
+ * @v: pointer of type atomic64_unchecked_t
+ *
+ * Atomically reads the value of @v.
+ * Doesn't imply a read memory barrier.
+ */
+static inline long __intentional_overflow(-1) atomic64_read_unchecked(const atomic64_unchecked_t *v)
+{
+	return ACCESS_ONCE((v)->counter);
+}
+
+/**
  * atomic64_set - set atomic64 variable
  * @v: pointer to type atomic64_t
  * @i: required value
@@ -34,6 +46,18 @@ static inline void atomic64_set(atomic64_t *v, long i)
 }
 
 /**
+ * atomic64_set_unchecked - set atomic64 variable
+ * @v: pointer to type atomic64_unchecked_t
+ * @i: required value
+ *
+ * Atomically sets the value of @v to @i.
+ */
+static inline void atomic64_set_unchecked(atomic64_unchecked_t *v, long i)
+{
+	v->counter = i;
+}
+
+/**
  * atomic64_add - add integer to atomic64 variable
  * @i: integer value to add
  * @v: pointer to type atomic64_t
@@ -42,6 +66,22 @@ static inline void atomic64_set(atomic64_t *v, long i)
  */
 static __always_inline void atomic64_add(long i, atomic64_t *v)
 {
+	asm volatile(LOCK_PREFIX "addq %1,%0\n\t"
+		     PAX_REFCOUNT_OVERFLOW(8)
+		     : [counter] "=m" (v->counter)
+		     : "er" (i), "m" (v->counter)
+		     : "cc", "cx");
+}
+
+/**
+ * atomic64_add_unchecked - add integer to atomic64 variable
+ * @i: integer value to add
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically adds @i to @v.
+ */
+static __always_inline void atomic64_add_unchecked(long i, atomic64_unchecked_t *v)
+{
 	asm volatile(LOCK_PREFIX "addq %1,%0"
 		     : "=m" (v->counter)
 		     : "er" (i), "m" (v->counter));
@@ -56,7 +96,23 @@ static __always_inline void atomic64_add(long i, atomic64_t *v)
  */
 static inline void atomic64_sub(long i, atomic64_t *v)
 {
-	asm volatile(LOCK_PREFIX "subq %1,%0"
+	asm volatile(LOCK_PREFIX "subq %1,%0\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(8)
+		     : [counter] "=m" (v->counter)
+		     : "er" (i), "m" (v->counter)
+		     : "cc", "cx");
+}
+
+/**
+ * atomic64_sub_unchecked - subtract the atomic64 variable
+ * @i: integer value to subtract
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically subtracts @i from @v.
+ */
+static inline void atomic64_sub_unchecked(long i, atomic64_unchecked_t *v)
+{
+	asm volatile(LOCK_PREFIX "subq %1,%0\n"
 		     : "=m" (v->counter)
 		     : "er" (i), "m" (v->counter));
 }
@@ -72,7 +128,7 @@ static inline void atomic64_sub(long i, atomic64_t *v)
  */
 static inline bool atomic64_sub_and_test(long i, atomic64_t *v)
 {
-	GEN_BINARY_RMWcc(LOCK_PREFIX "subq", v->counter, "er", i, "%0", e);
+	GEN_BINARY_RMWcc(LOCK_PREFIX "subq", v->counter, -8, "er", i, "%0", e);
 }
 
 /**
@@ -83,6 +139,21 @@ static inline bool atomic64_sub_and_test(long i, atomic64_t *v)
  */
 static __always_inline void atomic64_inc(atomic64_t *v)
 {
+	asm volatile(LOCK_PREFIX "incq %0\n\t"
+		     PAX_REFCOUNT_OVERFLOW(8)
+		     : [counter] "=m" (v->counter)
+		     : "m" (v->counter)
+		     : "cc", "cx");
+}
+
+/**
+ * atomic64_inc_unchecked - increment atomic64 variable
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically increments @v by 1.
+ */
+static __always_inline void atomic64_inc_unchecked(atomic64_unchecked_t *v)
+{
 	asm volatile(LOCK_PREFIX "incq %0"
 		     : "=m" (v->counter)
 		     : "m" (v->counter));
@@ -96,7 +167,22 @@ static __always_inline void atomic64_inc(atomic64_t *v)
  */
 static __always_inline void atomic64_dec(atomic64_t *v)
 {
-	asm volatile(LOCK_PREFIX "decq %0"
+	asm volatile(LOCK_PREFIX "decq %0\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(8)
+		     : [counter] "=m" (v->counter)
+		     : "m" (v->counter)
+		     : "cc", "cx");
+}
+
+/**
+ * atomic64_dec_unchecked - decrement atomic64 variable
+ * @v: pointer to type atomic64_t
+ *
+ * Atomically decrements @v by 1.
+ */
+static __always_inline void atomic64_dec_unchecked(atomic64_unchecked_t *v)
+{
+	asm volatile(LOCK_PREFIX "decq %0\n"
 		     : "=m" (v->counter)
 		     : "m" (v->counter));
 }
@@ -111,7 +197,7 @@ static __always_inline void atomic64_dec(atomic64_t *v)
  */
 static inline bool atomic64_dec_and_test(atomic64_t *v)
 {
-	GEN_UNARY_RMWcc(LOCK_PREFIX "decq", v->counter, "%0", e);
+	GEN_UNARY_RMWcc(LOCK_PREFIX "decq", v->counter, -8, "%0", e);
 }
 
 /**
@@ -124,7 +210,7 @@ static inline bool atomic64_dec_and_test(atomic64_t *v)
  */
 static inline bool atomic64_inc_and_test(atomic64_t *v)
 {
-	GEN_UNARY_RMWcc(LOCK_PREFIX "incq", v->counter, "%0", e);
+	GEN_UNARY_RMWcc(LOCK_PREFIX "incq", v->counter, 8, "%0", e);
 }
 
 /**
@@ -138,7 +224,7 @@ static inline bool atomic64_inc_and_test(atomic64_t *v)
  */
 static inline bool atomic64_add_negative(long i, atomic64_t *v)
 {
-	GEN_BINARY_RMWcc(LOCK_PREFIX "addq", v->counter, "er", i, "%0", s);
+	GEN_BINARY_RMWcc(LOCK_PREFIX "addq", v->counter, 8, "er", i, "%0", s);
 }
 
 /**
@@ -150,6 +236,18 @@ static inline bool atomic64_add_negative(long i, atomic64_t *v)
  */
 static __always_inline long atomic64_add_return(long i, atomic64_t *v)
 {
+	return i + xadd_check_overflow(&v->counter, i);
+}
+
+/**
+ * atomic64_add_return_unchecked - add and return
+ * @i: integer value to add
+ * @v: pointer to type atomic64_unchecked_t
+ *
+ * Atomically adds @i to @v and returns @i + @v
+ */
+static __always_inline long atomic64_add_return_unchecked(long i, atomic64_unchecked_t *v)
+{
 	return i + xadd(&v->counter, i);
 }
 
@@ -160,15 +258,19 @@ static inline long atomic64_sub_return(long i, atomic64_t *v)
 
 static inline long atomic64_fetch_add(long i, atomic64_t *v)
 {
-	return xadd(&v->counter, i);
+	return xadd_check_overflow(&v->counter, i);
 }
 
 static inline long atomic64_fetch_sub(long i, atomic64_t *v)
 {
-	return xadd(&v->counter, -i);
+	return xadd_check_overflow(&v->counter, -i);
 }
 
 #define atomic64_inc_return(v)  (atomic64_add_return(1, (v)))
+static inline long atomic64_inc_return_unchecked(atomic64_unchecked_t *v)
+{
+	return atomic64_add_return_unchecked(1, v);
+}
 #define atomic64_dec_return(v)  (atomic64_sub_return(1, (v)))
 
 static inline long atomic64_cmpxchg(atomic64_t *v, long old, long new)
@@ -176,11 +278,21 @@ static inline long atomic64_cmpxchg(atomic64_t *v, long old, long new)
 	return cmpxchg(&v->counter, old, new);
 }
 
+static inline long atomic64_cmpxchg_unchecked(atomic64_unchecked_t *v, long old, long new)
+{
+	return cmpxchg(&v->counter, old, new);
+}
+
 static inline long atomic64_xchg(atomic64_t *v, long new)
 {
 	return xchg(&v->counter, new);
 }
 
+static inline long atomic64_xchg_unchecked(atomic64_unchecked_t *v, long new)
+{
+	return xchg(&v->counter, new);
+}
+
 /**
  * atomic64_add_unless - add unless the number is a given value
  * @v: pointer of type atomic64_t
@@ -192,17 +304,25 @@ static inline long atomic64_xchg(atomic64_t *v, long new)
  */
 static inline bool atomic64_add_unless(atomic64_t *v, long a, long u)
 {
-	long c, old;
+	long c, old, new;
 	c = atomic64_read(v);
 	for (;;) {
-		if (unlikely(c == (u)))
+		if (unlikely(c == u))
 			break;
-		old = atomic64_cmpxchg((v), c, c + (a));
+
+		asm volatile("addq %2,%0\n\t"
+			     PAX_REFCOUNT_OVERFLOW(8)
+			     : "=r" (new)
+			     : "0" (c), "ir" (a),
+			       [counter] "m" (v->counter)
+			     : "cc", "cx");
+
+		old = atomic64_cmpxchg(v, c, new);
 		if (likely(old == c))
 			break;
 		c = old;
 	}
-	return c != (u);
+	return c != u;
 }
 
 #define atomic64_inc_not_zero(v) atomic64_add_unless((v), 1, 0)
diff --git a/arch/x86/include/asm/bitops.h b/arch/x86/include/asm/bitops.h
index 68557f52b..d9828eca8 100644
--- a/arch/x86/include/asm/bitops.h
+++ b/arch/x86/include/asm/bitops.h
@@ -50,7 +50,7 @@
  * a mask operation on a byte.
  */
 #define IS_IMMEDIATE(nr)		(__builtin_constant_p(nr))
-#define CONST_MASK_ADDR(nr, addr)	BITOP_ADDR((void *)(addr) + ((nr)>>3))
+#define CONST_MASK_ADDR(nr, addr)	BITOP_ADDR((volatile void *)(addr) + ((nr)>>3))
 #define CONST_MASK(nr)			(1 << ((nr) & 7))
 
 /**
@@ -203,7 +203,7 @@ static __always_inline void change_bit(long nr, volatile unsigned long *addr)
  */
 static __always_inline bool test_and_set_bit(long nr, volatile unsigned long *addr)
 {
-	GEN_BINARY_RMWcc(LOCK_PREFIX "bts", *addr, "Ir", nr, "%0", c);
+	GEN_BINARY_RMWcc_unchecked(LOCK_PREFIX "bts", *addr, "Ir", nr, "%0", c);
 }
 
 /**
@@ -249,7 +249,7 @@ static __always_inline bool __test_and_set_bit(long nr, volatile unsigned long *
  */
 static __always_inline bool test_and_clear_bit(long nr, volatile unsigned long *addr)
 {
-	GEN_BINARY_RMWcc(LOCK_PREFIX "btr", *addr, "Ir", nr, "%0", c);
+	GEN_BINARY_RMWcc_unchecked(LOCK_PREFIX "btr", *addr, "Ir", nr, "%0", c);
 }
 
 /**
@@ -302,7 +302,7 @@ static __always_inline bool __test_and_change_bit(long nr, volatile unsigned lon
  */
 static __always_inline bool test_and_change_bit(long nr, volatile unsigned long *addr)
 {
-	GEN_BINARY_RMWcc(LOCK_PREFIX "btc", *addr, "Ir", nr, "%0", c);
+	GEN_BINARY_RMWcc_unchecked(LOCK_PREFIX "btc", *addr, "Ir", nr, "%0", c);
 }
 
 static __always_inline bool constant_test_bit(long nr, const volatile unsigned long *addr)
@@ -343,7 +343,7 @@ static bool test_bit(int nr, const volatile unsigned long *addr);
  *
  * Undefined if no bit exists, so code should check against 0 first.
  */
-static __always_inline unsigned long __ffs(unsigned long word)
+static __always_inline unsigned long __intentional_overflow(-1) __ffs(unsigned long word)
 {
 	asm("rep; bsf %1,%0"
 		: "=r" (word)
@@ -357,7 +357,7 @@ static __always_inline unsigned long __ffs(unsigned long word)
  *
  * Undefined if no zero exists, so code should check against ~0UL first.
  */
-static __always_inline unsigned long ffz(unsigned long word)
+static __always_inline unsigned long __intentional_overflow(-1) ffz(unsigned long word)
 {
 	asm("rep; bsf %1,%0"
 		: "=r" (word)
@@ -371,7 +371,7 @@ static __always_inline unsigned long ffz(unsigned long word)
  *
  * Undefined if no set bit exists, so code should check against 0 first.
  */
-static __always_inline unsigned long __fls(unsigned long word)
+static __always_inline unsigned long __intentional_overflow(-1) __fls(unsigned long word)
 {
 	asm("bsr %1,%0"
 	    : "=r" (word)
@@ -434,7 +434,7 @@ static __always_inline int ffs(int x)
  * set bit if value is nonzero. The last (most significant) bit is
  * at position 32.
  */
-static __always_inline int fls(int x)
+static __always_inline int __intentional_overflow(-1) fls(int x)
 {
 	int r;
 
@@ -476,7 +476,7 @@ static __always_inline int fls(int x)
  * at position 64.
  */
 #ifdef CONFIG_X86_64
-static __always_inline int fls64(__u64 x)
+static __always_inline __intentional_overflow(-1) int fls64(__u64 x)
 {
 	int bitpos = -1;
 	/*
diff --git a/arch/x86/include/asm/boot.h b/arch/x86/include/asm/boot.h
index abd06b19d..17fc65f3a 100644
--- a/arch/x86/include/asm/boot.h
+++ b/arch/x86/include/asm/boot.h
@@ -6,7 +6,7 @@
 #include <uapi/asm/boot.h>
 
 /* Physical address where kernel should be loaded. */
-#define LOAD_PHYSICAL_ADDR ((CONFIG_PHYSICAL_START \
+#define ____LOAD_PHYSICAL_ADDR ((CONFIG_PHYSICAL_START \
 				+ (CONFIG_PHYSICAL_ALIGN - 1)) \
 				& ~(CONFIG_PHYSICAL_ALIGN - 1))
 
diff --git a/arch/x86/include/asm/cache.h b/arch/x86/include/asm/cache.h
index 48f99f154..26ab08aea 100644
--- a/arch/x86/include/asm/cache.h
+++ b/arch/x86/include/asm/cache.h
@@ -5,12 +5,12 @@
 
 /* L1 cache line size */
 #define L1_CACHE_SHIFT	(CONFIG_X86_L1_CACHE_SHIFT)
-#define L1_CACHE_BYTES	(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_BYTES	(_AC(1,UL) << L1_CACHE_SHIFT)
 
 #define __read_mostly __attribute__((__section__(".data..read_mostly")))
 
 #define INTERNODE_CACHE_SHIFT CONFIG_X86_INTERNODE_CACHE_SHIFT
-#define INTERNODE_CACHE_BYTES (1 << INTERNODE_CACHE_SHIFT)
+#define INTERNODE_CACHE_BYTES (_AC(1,UL) << INTERNODE_CACHE_SHIFT)
 
 #ifdef CONFIG_X86_VSMP
 #ifdef CONFIG_SMP
diff --git a/arch/x86/include/asm/checksum_32.h b/arch/x86/include/asm/checksum_32.h
index 7b53743ed..5f207d2e4 100644
--- a/arch/x86/include/asm/checksum_32.h
+++ b/arch/x86/include/asm/checksum_32.h
@@ -30,6 +30,14 @@ asmlinkage __wsum csum_partial_copy_generic(const void *src, void *dst,
 					    int len, __wsum sum,
 					    int *src_err_ptr, int *dst_err_ptr);
 
+asmlinkage __wsum csum_partial_copy_generic_to_user(const void *src, void *dst,
+						  int len, __wsum sum,
+						  int *src_err_ptr, int *dst_err_ptr);
+
+asmlinkage __wsum csum_partial_copy_generic_from_user(const void *src, void *dst,
+						  int len, __wsum sum,
+						  int *src_err_ptr, int *dst_err_ptr);
+
 /*
  *	Note: when you get a NULL pointer exception here this means someone
  *	passed in an incorrect kernel address to one of these functions.
@@ -52,7 +60,7 @@ static inline __wsum csum_partial_copy_from_user(const void __user *src,
 
 	might_sleep();
 	stac();
-	ret = csum_partial_copy_generic((__force void *)src, dst,
+	ret = csum_partial_copy_generic_from_user((__force void *)src, dst,
 					len, sum, err_ptr, NULL);
 	clac();
 
@@ -183,7 +191,7 @@ static inline __wsum csum_and_copy_to_user(const void *src,
 	might_sleep();
 	if (access_ok(VERIFY_WRITE, dst, len)) {
 		stac();
-		ret = csum_partial_copy_generic(src, (__force void *)dst,
+		ret = csum_partial_copy_generic_to_user(src, (__force void *)dst,
 						len, sum, NULL, err_ptr);
 		clac();
 		return ret;
diff --git a/arch/x86/include/asm/cmpxchg.h b/arch/x86/include/asm/cmpxchg.h
index 9733361fe..49bda4260 100644
--- a/arch/x86/include/asm/cmpxchg.h
+++ b/arch/x86/include/asm/cmpxchg.h
@@ -15,8 +15,12 @@ extern void __cmpxchg_wrong_size(void)
 	__compiletime_error("Bad argument size for cmpxchg");
 extern void __xadd_wrong_size(void)
 	__compiletime_error("Bad argument size for xadd");
+extern void __xadd_check_overflow_wrong_size(void)
+	__compiletime_error("Bad argument size for xadd_check_overflow");
 extern void __add_wrong_size(void)
 	__compiletime_error("Bad argument size for add");
+extern void __add_check_overflow_wrong_size(void)
+	__compiletime_error("Bad argument size for add_check_overflow");
 
 /*
  * Constants for operation sizes. On 32-bit, the 64-bit size it set to
@@ -68,6 +72,32 @@ extern void __add_wrong_size(void)
 		__ret;							\
 	})
 
+#ifdef CONFIG_PAX_REFCOUNT
+#define __xchg_op_check_overflow(ptr, arg, op, lock)			\
+	({								\
+	        __typeof__ (*(ptr)) __ret = (arg);			\
+		switch (sizeof(*(ptr))) {				\
+		case __X86_CASE_L:					\
+			asm volatile (lock #op "l %0, %1\n"		\
+				      PAX_REFCOUNT_OVERFLOW(4)		\
+				      : "+r" (__ret), [counter] "+m" (*(ptr))\
+				      : : "memory", "cc", "cx");	\
+			break;						\
+		case __X86_CASE_Q:					\
+			asm volatile (lock #op "q %q0, %1\n"		\
+				      PAX_REFCOUNT_OVERFLOW(8)		\
+				      : "+r" (__ret), [counter] "+m" (*(ptr))\
+				      : : "memory", "cc", "cx");	\
+			break;						\
+		default:						\
+			__ ## op ## _check_overflow_wrong_size();	\
+		}							\
+		__ret;							\
+	})
+#else
+#define __xchg_op_check_overflow(ptr, arg, op, lock) __xchg_op(ptr, arg, op, lock)
+#endif
+
 /*
  * Note: no "lock" prefix even on SMP: xchg always implies lock anyway.
  * Since this is generally used to protect other memory information, we
@@ -166,6 +196,9 @@ extern void __add_wrong_size(void)
 #define xadd_sync(ptr, inc)	__xadd((ptr), (inc), "lock; ")
 #define xadd_local(ptr, inc)	__xadd((ptr), (inc), "")
 
+#define __xadd_check_overflow(ptr, inc, lock)	__xchg_op_check_overflow((ptr), (inc), xadd, lock)
+#define xadd_check_overflow(ptr, inc)		__xadd_check_overflow((ptr), (inc), LOCK_PREFIX)
+
 #define __add(ptr, inc, lock)						\
 	({								\
 	        __typeof__ (*(ptr)) __ret = (inc);			\
diff --git a/arch/x86/include/asm/compat.h b/arch/x86/include/asm/compat.h
index a18806165..280d840d1 100644
--- a/arch/x86/include/asm/compat.h
+++ b/arch/x86/include/asm/compat.h
@@ -42,7 +42,11 @@ typedef u32		compat_uint_t;
 typedef u32		compat_ulong_t;
 typedef u32		compat_u32;
 typedef u64 __attribute__((aligned(4))) compat_u64;
+#ifdef CHECKER_PLUGIN_USER
 typedef u32		compat_uptr_t;
+#else
+typedef u32		__user compat_uptr_t;
+#endif
 
 struct compat_timespec {
 	compat_time_t	tv_sec;
diff --git a/arch/x86/include/asm/cpufeature.h b/arch/x86/include/asm/cpufeature.h
index 1d2b69fc0..8ca35d6bb 100644
--- a/arch/x86/include/asm/cpufeature.h
+++ b/arch/x86/include/asm/cpufeature.h
@@ -156,7 +156,7 @@ static __always_inline __pure bool _static_cpu_has(u16 bit)
 			 " .byte 5f - 4f\n"		/* repl len */
 			 " .byte 3b - 2b\n"		/* pad len */
 			 ".previous\n"
-			 ".section .altinstr_replacement,\"ax\"\n"
+			 ".section .altinstr_replacement,\"a\"\n"
 			 "4: jmp %l[t_no]\n"
 			 "5:\n"
 			 ".previous\n"
diff --git a/arch/x86/include/asm/cpufeatures.h b/arch/x86/include/asm/cpufeatures.h
index 92a8308b9..4e44144cf 100644
--- a/arch/x86/include/asm/cpufeatures.h
+++ b/arch/x86/include/asm/cpufeatures.h
@@ -205,7 +205,8 @@
 
 #define X86_FEATURE_VMMCALL     ( 8*32+15) /* Prefer vmmcall to vmcall */
 #define X86_FEATURE_XENPV       ( 8*32+16) /* "" Xen paravirtual guest */
-
+#define X86_FEATURE_PCIDUDEREF	( 8*32+30) /* PaX PCID based UDEREF */
+#define X86_FEATURE_STRONGUDEREF (8*32+31) /* PaX PCID based strong UDEREF */
 
 /* Intel-defined CPU features, CPUID level 0x00000007:0 (ebx), word 9 */
 #define X86_FEATURE_FSGSBASE	( 9*32+ 0) /* {RD/WR}{FS/GS}BASE instructions*/
@@ -213,7 +214,7 @@
 #define X86_FEATURE_BMI1	( 9*32+ 3) /* 1st group bit manipulation extensions */
 #define X86_FEATURE_HLE		( 9*32+ 4) /* Hardware Lock Elision */
 #define X86_FEATURE_AVX2	( 9*32+ 5) /* AVX2 instructions */
-#define X86_FEATURE_SMEP	( 9*32+ 7) /* Supervisor Mode Execution Protection */
+#define X86_FEATURE_SMEP	( 9*32+ 7) /* Supervisor Mode Execution Prevention */
 #define X86_FEATURE_BMI2	( 9*32+ 8) /* 2nd group bit manipulation extensions */
 #define X86_FEATURE_ERMS	( 9*32+ 9) /* Enhanced REP MOVSB/STOSB */
 #define X86_FEATURE_INVPCID	( 9*32+10) /* Invalidate Processor Context ID */
diff --git a/arch/x86/include/asm/crypto/camellia.h b/arch/x86/include/asm/crypto/camellia.h
index bb93333d9..e3d3d5727 100644
--- a/arch/x86/include/asm/crypto/camellia.h
+++ b/arch/x86/include/asm/crypto/camellia.h
@@ -39,34 +39,35 @@ extern int xts_camellia_setkey(struct crypto_tfm *tfm, const u8 *key,
 /* regular block cipher functions */
 asmlinkage void __camellia_enc_blk(struct camellia_ctx *ctx, u8 *dst,
 				   const u8 *src, bool xor);
-asmlinkage void camellia_dec_blk(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_dec_blk(void *ctx, u8 *dst,
 				 const u8 *src);
 
 /* 2-way parallel cipher functions */
 asmlinkage void __camellia_enc_blk_2way(struct camellia_ctx *ctx, u8 *dst,
 					const u8 *src, bool xor);
-asmlinkage void camellia_dec_blk_2way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_dec_blk_2way(void *ctx, u8 *dst,
 				      const u8 *src);
 
 /* 16-way parallel cipher functions (avx/aes-ni) */
-asmlinkage void camellia_ecb_enc_16way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_ecb_enc_16way(void *ctx, u8 *dst,
 				       const u8 *src);
-asmlinkage void camellia_ecb_dec_16way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_ecb_dec_16way(void *ctx, u8 *dst,
 				       const u8 *src);
 
-asmlinkage void camellia_cbc_dec_16way(struct camellia_ctx *ctx, u8 *dst,
+asmlinkage void camellia_cbc_dec_16way(void *ctx, u8 *dst,
 				       const u8 *src);
-asmlinkage void camellia_ctr_16way(struct camellia_ctx *ctx, u8 *dst,
-				   const u8 *src, le128 *iv);
+asmlinkage void camellia_ctr_16way(void *ctx, u128 *dst,
+				   const u128 *src, le128 *iv);
 
-asmlinkage void camellia_xts_enc_16way(struct camellia_ctx *ctx, u8 *dst,
-				       const u8 *src, le128 *iv);
-asmlinkage void camellia_xts_dec_16way(struct camellia_ctx *ctx, u8 *dst,
-				       const u8 *src, le128 *iv);
+asmlinkage void camellia_xts_enc_16way(void *ctx, u128 *dst,
+				       const u128 *src, le128 *iv);
+asmlinkage void camellia_xts_dec_16way(void *ctx, u128 *dst,
+				       const u128 *src, le128 *iv);
 
-static inline void camellia_enc_blk(struct camellia_ctx *ctx, u8 *dst,
+static inline void camellia_enc_blk(void *_ctx, u8 *dst,
 				    const u8 *src)
 {
+	struct camellia_ctx *ctx = _ctx;
 	__camellia_enc_blk(ctx, dst, src, false);
 }
 
@@ -76,9 +77,10 @@ static inline void camellia_enc_blk_xor(struct camellia_ctx *ctx, u8 *dst,
 	__camellia_enc_blk(ctx, dst, src, true);
 }
 
-static inline void camellia_enc_blk_2way(struct camellia_ctx *ctx, u8 *dst,
+static inline void camellia_enc_blk_2way(void *_ctx, u8 *dst,
 					 const u8 *src)
 {
+	struct camellia_ctx *ctx = _ctx;
 	__camellia_enc_blk_2way(ctx, dst, src, false);
 }
 
@@ -89,7 +91,7 @@ static inline void camellia_enc_blk_xor_2way(struct camellia_ctx *ctx, u8 *dst,
 }
 
 /* glue helpers */
-extern void camellia_decrypt_cbc_2way(void *ctx, u128 *dst, const u128 *src);
+extern void camellia_decrypt_cbc_2way(void *ctx, u8 *dst, const u8 *src);
 extern void camellia_crypt_ctr(void *ctx, u128 *dst, const u128 *src,
 			       le128 *iv);
 extern void camellia_crypt_ctr_2way(void *ctx, u128 *dst, const u128 *src,
diff --git a/arch/x86/include/asm/crypto/glue_helper.h b/arch/x86/include/asm/crypto/glue_helper.h
index 03bb1065c..9e7a45cc8 100644
--- a/arch/x86/include/asm/crypto/glue_helper.h
+++ b/arch/x86/include/asm/crypto/glue_helper.h
@@ -11,16 +11,16 @@
 #include <crypto/b128ops.h>
 
 typedef void (*common_glue_func_t)(void *ctx, u8 *dst, const u8 *src);
-typedef void (*common_glue_cbc_func_t)(void *ctx, u128 *dst, const u128 *src);
+typedef void (*common_glue_cbc_func_t)(void *ctx, u8 *dst, const u8 *src);
 typedef void (*common_glue_ctr_func_t)(void *ctx, u128 *dst, const u128 *src,
 				       le128 *iv);
 typedef void (*common_glue_xts_func_t)(void *ctx, u128 *dst, const u128 *src,
 				       le128 *iv);
 
-#define GLUE_FUNC_CAST(fn) ((common_glue_func_t)(fn))
-#define GLUE_CBC_FUNC_CAST(fn) ((common_glue_cbc_func_t)(fn))
-#define GLUE_CTR_FUNC_CAST(fn) ((common_glue_ctr_func_t)(fn))
-#define GLUE_XTS_FUNC_CAST(fn) ((common_glue_xts_func_t)(fn))
+#define GLUE_FUNC_CAST(fn) (fn)
+#define GLUE_CBC_FUNC_CAST(fn) (fn)
+#define GLUE_CTR_FUNC_CAST(fn) (fn)
+#define GLUE_XTS_FUNC_CAST(fn) (fn)
 
 struct common_glue_func_entry {
 	unsigned int num_blocks; /* number of blocks that @fn will process */
diff --git a/arch/x86/include/asm/crypto/serpent-avx.h b/arch/x86/include/asm/crypto/serpent-avx.h
index 33c2b8a43..586871f68 100644
--- a/arch/x86/include/asm/crypto/serpent-avx.h
+++ b/arch/x86/include/asm/crypto/serpent-avx.h
@@ -16,20 +16,20 @@ struct serpent_xts_ctx {
 	struct serpent_ctx crypt_ctx;
 };
 
-asmlinkage void serpent_ecb_enc_8way_avx(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_ecb_enc_8way_avx(void *ctx, u8 *dst,
 					 const u8 *src);
-asmlinkage void serpent_ecb_dec_8way_avx(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_ecb_dec_8way_avx(void *ctx, u8 *dst,
 					 const u8 *src);
 
-asmlinkage void serpent_cbc_dec_8way_avx(struct serpent_ctx *ctx, u8 *dst,
+asmlinkage void serpent_cbc_dec_8way_avx(void *ctx, u8 *dst,
 					 const u8 *src);
-asmlinkage void serpent_ctr_8way_avx(struct serpent_ctx *ctx, u8 *dst,
-				     const u8 *src, le128 *iv);
+asmlinkage void serpent_ctr_8way_avx(void *ctx, u128 *dst,
+				     const u128 *src, le128 *iv);
 
-asmlinkage void serpent_xts_enc_8way_avx(struct serpent_ctx *ctx, u8 *dst,
-					 const u8 *src, le128 *iv);
-asmlinkage void serpent_xts_dec_8way_avx(struct serpent_ctx *ctx, u8 *dst,
-					 const u8 *src, le128 *iv);
+asmlinkage void serpent_xts_enc_8way_avx(void *ctx, u128 *dst,
+					 const u128 *src, le128 *iv);
+asmlinkage void serpent_xts_dec_8way_avx(void *ctx, u128 *dst,
+					 const u128 *src, le128 *iv);
 
 extern void __serpent_crypt_ctr(void *ctx, u128 *dst, const u128 *src,
 				le128 *iv);
diff --git a/arch/x86/include/asm/crypto/serpent-sse2.h b/arch/x86/include/asm/crypto/serpent-sse2.h
index e6e77dffb..fe4208105 100644
--- a/arch/x86/include/asm/crypto/serpent-sse2.h
+++ b/arch/x86/include/asm/crypto/serpent-sse2.h
@@ -13,7 +13,7 @@ asmlinkage void __serpent_enc_blk_4way(struct serpent_ctx *ctx, u8 *dst,
 asmlinkage void serpent_dec_blk_4way(struct serpent_ctx *ctx, u8 *dst,
 				     const u8 *src);
 
-static inline void serpent_enc_blk_xway(struct serpent_ctx *ctx, u8 *dst,
+static inline void serpent_enc_blk_xway(void *ctx, u8 *dst,
 					const u8 *src)
 {
 	__serpent_enc_blk_4way(ctx, dst, src, false);
@@ -25,7 +25,7 @@ static inline void serpent_enc_blk_xway_xor(struct serpent_ctx *ctx, u8 *dst,
 	__serpent_enc_blk_4way(ctx, dst, src, true);
 }
 
-static inline void serpent_dec_blk_xway(struct serpent_ctx *ctx, u8 *dst,
+static inline void serpent_dec_blk_xway(void *ctx, u8 *dst,
 					const u8 *src)
 {
 	serpent_dec_blk_4way(ctx, dst, src);
@@ -40,7 +40,7 @@ asmlinkage void __serpent_enc_blk_8way(struct serpent_ctx *ctx, u8 *dst,
 asmlinkage void serpent_dec_blk_8way(struct serpent_ctx *ctx, u8 *dst,
 				     const u8 *src);
 
-static inline void serpent_enc_blk_xway(struct serpent_ctx *ctx, u8 *dst,
+static inline void serpent_enc_blk_xway(void *ctx, u8 *dst,
 				   const u8 *src)
 {
 	__serpent_enc_blk_8way(ctx, dst, src, false);
@@ -52,7 +52,7 @@ static inline void serpent_enc_blk_xway_xor(struct serpent_ctx *ctx, u8 *dst,
 	__serpent_enc_blk_8way(ctx, dst, src, true);
 }
 
-static inline void serpent_dec_blk_xway(struct serpent_ctx *ctx, u8 *dst,
+static inline void serpent_dec_blk_xway(void *ctx, u8 *dst,
 				   const u8 *src)
 {
 	serpent_dec_blk_8way(ctx, dst, src);
diff --git a/arch/x86/include/asm/crypto/twofish.h b/arch/x86/include/asm/crypto/twofish.h
index 878c51cee..86fc65f8e 100644
--- a/arch/x86/include/asm/crypto/twofish.h
+++ b/arch/x86/include/asm/crypto/twofish.h
@@ -17,19 +17,19 @@ struct twofish_xts_ctx {
 };
 
 /* regular block cipher functions from twofish_x86_64 module */
-asmlinkage void twofish_enc_blk(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_enc_blk(void *ctx, u8 *dst,
 				const u8 *src);
-asmlinkage void twofish_dec_blk(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_dec_blk(void *ctx, u8 *dst,
 				const u8 *src);
 
 /* 3-way parallel cipher functions */
-asmlinkage void __twofish_enc_blk_3way(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void __twofish_enc_blk_3way(void *ctx, u8 *dst,
 				       const u8 *src, bool xor);
-asmlinkage void twofish_dec_blk_3way(struct twofish_ctx *ctx, u8 *dst,
+asmlinkage void twofish_dec_blk_3way(void *ctx, u8 *dst,
 				     const u8 *src);
 
 /* helpers from twofish_x86_64-3way module */
-extern void twofish_dec_blk_cbc_3way(void *ctx, u128 *dst, const u128 *src);
+extern void twofish_dec_blk_cbc_3way(void *ctx, u8 *dst, const u8 *src);
 extern void twofish_enc_blk_ctr(void *ctx, u128 *dst, const u128 *src,
 				le128 *iv);
 extern void twofish_enc_blk_ctr_3way(void *ctx, u128 *dst, const u128 *src,
diff --git a/arch/x86/include/asm/desc.h b/arch/x86/include/asm/desc.h
index 4e10d73cf..7319a478a 100644
--- a/arch/x86/include/asm/desc.h
+++ b/arch/x86/include/asm/desc.h
@@ -4,6 +4,7 @@
 #include <asm/desc_defs.h>
 #include <asm/ldt.h>
 #include <asm/mmu.h>
+#include <asm/pgtable.h>
 
 #include <linux/smp.h>
 #include <linux/percpu.h>
@@ -17,6 +18,7 @@ static inline void fill_ldt(struct desc_struct *desc, const struct user_desc *in
 
 	desc->type		= (info->read_exec_only ^ 1) << 1;
 	desc->type	       |= info->contents << 2;
+	desc->type	       |= info->seg_not_present ^ 1;
 
 	desc->s			= 1;
 	desc->dpl		= 0x3;
@@ -35,19 +37,14 @@ static inline void fill_ldt(struct desc_struct *desc, const struct user_desc *in
 }
 
 extern struct desc_ptr idt_descr;
-extern gate_desc idt_table[];
-extern struct desc_ptr debug_idt_descr;
-extern gate_desc debug_idt_table[];
-
-struct gdt_page {
-	struct desc_struct gdt[GDT_ENTRIES];
-} __attribute__((aligned(PAGE_SIZE)));
-
-DECLARE_PER_CPU_PAGE_ALIGNED(struct gdt_page, gdt_page);
+extern gate_desc idt_table[IDT_ENTRIES];
+extern const struct desc_ptr debug_idt_descr;
+extern gate_desc debug_idt_table[IDT_ENTRIES];
 
+extern struct desc_struct cpu_gdt_table[NR_CPUS][PAGE_SIZE / sizeof(struct desc_struct)];
 static inline struct desc_struct *get_cpu_gdt_table(unsigned int cpu)
 {
-	return per_cpu(gdt_page, cpu).gdt;
+	return cpu_gdt_table[cpu];
 }
 
 #ifdef CONFIG_X86_64
@@ -72,8 +69,14 @@ static inline void pack_gate(gate_desc *gate, unsigned char type,
 			     unsigned long base, unsigned dpl, unsigned flags,
 			     unsigned short seg)
 {
-	gate->a = (seg << 16) | (base & 0xffff);
-	gate->b = (base & 0xffff0000) | (((0x80 | type | (dpl << 5)) & 0xff) << 8);
+	gate->gate.offset_low	= base;
+	gate->gate.seg		= seg;
+	gate->gate.reserved	= 0;
+	gate->gate.type		= type;
+	gate->gate.s		= 0;
+	gate->gate.dpl		= dpl;
+	gate->gate.p		= 1;
+	gate->gate.offset_high	= base >> 16;
 }
 
 #endif
@@ -118,12 +121,16 @@ static inline void paravirt_free_ldt(struct desc_struct *ldt, unsigned entries)
 
 static inline void native_write_idt_entry(gate_desc *idt, int entry, const gate_desc *gate)
 {
+	pax_open_kernel();
 	memcpy(&idt[entry], gate, sizeof(*gate));
+	pax_close_kernel();
 }
 
 static inline void native_write_ldt_entry(struct desc_struct *ldt, int entry, const void *desc)
 {
+	pax_open_kernel();
 	memcpy(&ldt[entry], desc, 8);
+	pax_close_kernel();
 }
 
 static inline void
@@ -137,7 +144,9 @@ native_write_gdt_entry(struct desc_struct *gdt, int entry, const void *desc, int
 	default:	size = sizeof(*gdt);		break;
 	}
 
+	pax_open_kernel();
 	memcpy(&gdt[entry], desc, size);
+	pax_close_kernel();
 }
 
 static inline void pack_descriptor(struct desc_struct *desc, unsigned long base,
@@ -210,7 +219,9 @@ static inline void native_set_ldt(const void *addr, unsigned int entries)
 
 static inline void native_load_tr_desc(void)
 {
+	pax_open_kernel();
 	asm volatile("ltr %w0"::"q" (GDT_ENTRY_TSS*8));
+	pax_close_kernel();
 }
 
 static inline void native_load_gdt(const struct desc_ptr *dtr)
@@ -247,8 +258,10 @@ static inline void native_load_tls(struct thread_struct *t, unsigned int cpu)
 	struct desc_struct *gdt = get_cpu_gdt_table(cpu);
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < GDT_ENTRY_TLS_ENTRIES; i++)
 		gdt[GDT_ENTRY_TLS_MIN + i] = t->tls_array[i];
+	pax_close_kernel();
 }
 
 /* This intentionally ignores lm, since 32-bit apps don't have that field. */
@@ -280,7 +293,7 @@ static inline void clear_LDT(void)
 	set_ldt(NULL, 0);
 }
 
-static inline unsigned long get_desc_base(const struct desc_struct *desc)
+static inline unsigned long __intentional_overflow(-1) get_desc_base(const struct desc_struct *desc)
 {
 	return (unsigned)(desc->base0 | ((desc->base1) << 16) | ((desc->base2) << 24));
 }
@@ -304,7 +317,7 @@ static inline void set_desc_limit(struct desc_struct *desc, unsigned long limit)
 }
 
 #ifdef CONFIG_X86_64
-static inline void set_nmi_gate(int gate, void *addr)
+static inline void set_nmi_gate(int gate, const void *addr)
 {
 	gate_desc s;
 
@@ -314,14 +327,14 @@ static inline void set_nmi_gate(int gate, void *addr)
 #endif
 
 #ifdef CONFIG_TRACING
-extern struct desc_ptr trace_idt_descr;
-extern gate_desc trace_idt_table[];
+extern const struct desc_ptr trace_idt_descr;
+extern gate_desc trace_idt_table[IDT_ENTRIES];
 static inline void write_trace_idt_entry(int entry, const gate_desc *gate)
 {
 	write_idt_entry(trace_idt_table, entry, gate);
 }
 
-static inline void _trace_set_gate(int gate, unsigned type, void *addr,
+static inline void _trace_set_gate(int gate, unsigned type, const void *addr,
 				   unsigned dpl, unsigned ist, unsigned seg)
 {
 	gate_desc s;
@@ -341,7 +354,7 @@ static inline void write_trace_idt_entry(int entry, const gate_desc *gate)
 #define _trace_set_gate(gate, type, addr, dpl, ist, seg)
 #endif
 
-static inline void _set_gate(int gate, unsigned type, void *addr,
+static inline void _set_gate(int gate, unsigned type, const void *addr,
 			     unsigned dpl, unsigned ist, unsigned seg)
 {
 	gate_desc s;
@@ -364,14 +377,14 @@ static inline void _set_gate(int gate, unsigned type, void *addr,
 #define set_intr_gate_notrace(n, addr)					\
 	do {								\
 		BUG_ON((unsigned)n > 0xFF);				\
-		_set_gate(n, GATE_INTERRUPT, (void *)addr, 0, 0,	\
+		_set_gate(n, GATE_INTERRUPT, (const void *)addr, 0, 0,	\
 			  __KERNEL_CS);					\
 	} while (0)
 
 #define set_intr_gate(n, addr)						\
 	do {								\
 		set_intr_gate_notrace(n, addr);				\
-		_trace_set_gate(n, GATE_INTERRUPT, (void *)trace_##addr,\
+		_trace_set_gate(n, GATE_INTERRUPT, (const void *)trace_##addr,\
 				0, 0, __KERNEL_CS);			\
 	} while (0)
 
@@ -399,19 +412,19 @@ static inline void alloc_system_vector(int vector)
 /*
  * This routine sets up an interrupt gate at directory privilege level 3.
  */
-static inline void set_system_intr_gate(unsigned int n, void *addr)
+static inline void set_system_intr_gate(unsigned int n, const void *addr)
 {
 	BUG_ON((unsigned)n > 0xFF);
 	_set_gate(n, GATE_INTERRUPT, addr, 0x3, 0, __KERNEL_CS);
 }
 
-static inline void set_system_trap_gate(unsigned int n, void *addr)
+static inline void set_system_trap_gate(unsigned int n, const void *addr)
 {
 	BUG_ON((unsigned)n > 0xFF);
 	_set_gate(n, GATE_TRAP, addr, 0x3, 0, __KERNEL_CS);
 }
 
-static inline void set_trap_gate(unsigned int n, void *addr)
+static inline void set_trap_gate(unsigned int n, const void *addr)
 {
 	BUG_ON((unsigned)n > 0xFF);
 	_set_gate(n, GATE_TRAP, addr, 0, 0, __KERNEL_CS);
@@ -420,16 +433,16 @@ static inline void set_trap_gate(unsigned int n, void *addr)
 static inline void set_task_gate(unsigned int n, unsigned int gdt_entry)
 {
 	BUG_ON((unsigned)n > 0xFF);
-	_set_gate(n, GATE_TASK, (void *)0, 0, 0, (gdt_entry<<3));
+	_set_gate(n, GATE_TASK, (const void *)0, 0, 0, (gdt_entry<<3));
 }
 
-static inline void set_intr_gate_ist(int n, void *addr, unsigned ist)
+static inline void set_intr_gate_ist(int n, const void *addr, unsigned ist)
 {
 	BUG_ON((unsigned)n > 0xFF);
 	_set_gate(n, GATE_INTERRUPT, addr, 0, ist, __KERNEL_CS);
 }
 
-static inline void set_system_intr_gate_ist(int n, void *addr, unsigned ist)
+static inline void set_system_intr_gate_ist(int n, const void *addr, unsigned ist)
 {
 	BUG_ON((unsigned)n > 0xFF);
 	_set_gate(n, GATE_INTERRUPT, addr, 0x3, ist, __KERNEL_CS);
@@ -501,4 +514,17 @@ static inline void load_current_idt(void)
 	else
 		load_idt((const struct desc_ptr *)&idt_descr);
 }
+
+#ifdef CONFIG_X86_32
+static inline void set_user_cs(unsigned long base, unsigned long limit, int cpu)
+{
+	struct desc_struct d;
+
+	if (likely(limit))
+		limit = (limit - 1UL) >> PAGE_SHIFT;
+	pack_descriptor(&d, base, limit, 0xFB, 0xC);
+	write_gdt_entry(get_cpu_gdt_table(cpu), GDT_ENTRY_DEFAULT_USER_CS, &d, DESCTYPE_S);
+}
+#endif
+
 #endif /* _ASM_X86_DESC_H */
diff --git a/arch/x86/include/asm/desc_defs.h b/arch/x86/include/asm/desc_defs.h
index eb5deb424..ec19436dd 100644
--- a/arch/x86/include/asm/desc_defs.h
+++ b/arch/x86/include/asm/desc_defs.h
@@ -31,6 +31,12 @@ struct desc_struct {
 			unsigned base1: 8, type: 4, s: 1, dpl: 2, p: 1;
 			unsigned limit: 4, avl: 1, l: 1, d: 1, g: 1, base2: 8;
 		};
+		struct {
+			u16 offset_low;
+			u16 seg;
+			unsigned reserved: 8, type: 4, s: 1, dpl: 2, p: 1;
+			unsigned offset_high: 16;
+		} gate;
 	};
 } __attribute__((packed));
 
diff --git a/arch/x86/include/asm/div64.h b/arch/x86/include/asm/div64.h
index ced283ac7..ffe04ccf6 100644
--- a/arch/x86/include/asm/div64.h
+++ b/arch/x86/include/asm/div64.h
@@ -39,7 +39,7 @@
 	__mod;							\
 })
 
-static inline u64 div_u64_rem(u64 dividend, u32 divisor, u32 *remainder)
+static inline u64 __intentional_overflow(-1) div_u64_rem(u64 dividend, u32 divisor, u32 *remainder)
 {
 	union {
 		u64 v64;
diff --git a/arch/x86/include/asm/dma.h b/arch/x86/include/asm/dma.h
index fe884e18f..46149aefc 100644
--- a/arch/x86/include/asm/dma.h
+++ b/arch/x86/include/asm/dma.h
@@ -149,6 +149,7 @@
 #ifdef CONFIG_ISA_DMA_API
 extern spinlock_t  dma_spin_lock;
 
+static inline unsigned long claim_dma_lock(void) __acquires(&dma_spin_lock);
 static inline unsigned long claim_dma_lock(void)
 {
 	unsigned long flags;
@@ -156,6 +157,7 @@ static inline unsigned long claim_dma_lock(void)
 	return flags;
 }
 
+static inline void release_dma_lock(unsigned long flags) __releases(&dma_spin_lock);
 static inline void release_dma_lock(unsigned long flags)
 {
 	spin_unlock_irqrestore(&dma_spin_lock, flags);
diff --git a/arch/x86/include/asm/efi.h b/arch/x86/include/asm/efi.h
index d0bb76d81..bb192fc1c 100644
--- a/arch/x86/include/asm/efi.h
+++ b/arch/x86/include/asm/efi.h
@@ -151,6 +151,11 @@ static inline bool efi_is_native(void)
 
 static inline bool efi_runtime_supported(void)
 {
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	return false;
+#endif
+
 	if (efi_is_native())
 		return true;
 
diff --git a/arch/x86/include/asm/elf.h b/arch/x86/include/asm/elf.h
index e7f155c30..8611814b3 100644
--- a/arch/x86/include/asm/elf.h
+++ b/arch/x86/include/asm/elf.h
@@ -75,9 +75,6 @@ typedef struct user_fxsr_struct elf_fpxregset_t;
 
 #include <asm/vdso.h>
 
-#ifdef CONFIG_X86_64
-extern unsigned int vdso64_enabled;
-#endif
 #if defined(CONFIG_X86_32) || defined(CONFIG_IA32_EMULATION)
 extern unsigned int vdso32_enabled;
 #endif
@@ -250,7 +247,25 @@ extern int force_personality32;
    the loader.  We need to make sure that it is out of the way of the program
    that it will "exec", and that there is sufficient room for the brk.  */
 
+#ifdef CONFIG_PAX_SEGMEXEC
+#define ELF_ET_DYN_BASE		((current->mm->pax_flags & MF_PAX_SEGMEXEC) ? SEGMEXEC_TASK_SIZE/3*2 : TASK_SIZE/3*2)
+#else
 #define ELF_ET_DYN_BASE		(TASK_SIZE / 3 * 2)
+#endif
+
+#ifdef CONFIG_PAX_ASLR
+#ifdef CONFIG_X86_32
+#define PAX_ELF_ET_DYN_BASE	0x10000000UL
+
+#define PAX_DELTA_MMAP_LEN	(current->mm->pax_flags & MF_PAX_SEGMEXEC ? 15 : 16)
+#define PAX_DELTA_STACK_LEN	(current->mm->pax_flags & MF_PAX_SEGMEXEC ? 15 : 16)
+#else
+#define PAX_ELF_ET_DYN_BASE	0x400000UL
+
+#define PAX_DELTA_MMAP_LEN	((test_thread_flag(TIF_ADDR32)) ? 16 : TASK_SIZE_MAX_SHIFT - PAGE_SHIFT - 3)
+#define PAX_DELTA_STACK_LEN	((test_thread_flag(TIF_ADDR32)) ? 16 : TASK_SIZE_MAX_SHIFT - PAGE_SHIFT - 3)
+#endif
+#endif
 
 /* This yields a mask that user programs can use to figure out what
    instruction set this CPU supports.  This could be done in user space,
@@ -299,17 +314,13 @@ do {									\
 
 #define ARCH_DLINFO							\
 do {									\
-	if (vdso64_enabled)						\
-		NEW_AUX_ENT(AT_SYSINFO_EHDR,				\
-			    (unsigned long __force)current->mm->context.vdso); \
+	NEW_AUX_ENT(AT_SYSINFO_EHDR, current->mm->context.vdso);	\
 } while (0)
 
 /* As a historical oddity, the x32 and x86_64 vDSOs are controlled together. */
 #define ARCH_DLINFO_X32							\
 do {									\
-	if (vdso64_enabled)						\
-		NEW_AUX_ENT(AT_SYSINFO_EHDR,				\
-			    (unsigned long __force)current->mm->context.vdso); \
+	NEW_AUX_ENT(AT_SYSINFO_EHDR, current->mm->context.vdso);	\
 } while (0)
 
 #define AT_SYSINFO		32
@@ -324,10 +335,10 @@ else									\
 
 #endif /* !CONFIG_X86_32 */
 
-#define VDSO_CURRENT_BASE	((unsigned long)current->mm->context.vdso)
+#define VDSO_CURRENT_BASE	(current->mm->context.vdso)
 
 #define VDSO_ENTRY							\
-	((unsigned long)current->mm->context.vdso +			\
+	(current->mm->context.vdso +					\
 	 vdso_image_32.sym___kernel_vsyscall)
 
 struct linux_binprm;
diff --git a/arch/x86/include/asm/emergency-restart.h b/arch/x86/include/asm/emergency-restart.h
index 77a99ac06..39ff7f5fa 100644
--- a/arch/x86/include/asm/emergency-restart.h
+++ b/arch/x86/include/asm/emergency-restart.h
@@ -1,6 +1,6 @@
 #ifndef _ASM_X86_EMERGENCY_RESTART_H
 #define _ASM_X86_EMERGENCY_RESTART_H
 
-extern void machine_emergency_restart(void);
+extern void machine_emergency_restart(void) __noreturn;
 
 #endif /* _ASM_X86_EMERGENCY_RESTART_H */
diff --git a/arch/x86/include/asm/fixmap.h b/arch/x86/include/asm/fixmap.h
index 8554f960e..6c58add91 100644
--- a/arch/x86/include/asm/fixmap.h
+++ b/arch/x86/include/asm/fixmap.h
@@ -142,7 +142,7 @@ extern pte_t *kmap_pte;
 extern pte_t *pkmap_page_table;
 
 void __native_set_fixmap(enum fixed_addresses idx, pte_t pte);
-void native_set_fixmap(enum fixed_addresses idx,
+void native_set_fixmap(unsigned int idx,
 		       phys_addr_t phys, pgprot_t flags);
 
 #ifndef CONFIG_PARAVIRT
diff --git a/arch/x86/include/asm/floppy.h b/arch/x86/include/asm/floppy.h
index 1c7eefe32..d0e470288 100644
--- a/arch/x86/include/asm/floppy.h
+++ b/arch/x86/include/asm/floppy.h
@@ -229,18 +229,18 @@ static struct fd_routine_l {
 	int (*_dma_setup)(char *addr, unsigned long size, int mode, int io);
 } fd_routine[] = {
 	{
-		request_dma,
-		free_dma,
-		get_dma_residue,
-		dma_mem_alloc,
-		hard_dma_setup
+		._request_dma = request_dma,
+		._free_dma = free_dma,
+		._get_dma_residue = get_dma_residue,
+		._dma_mem_alloc = dma_mem_alloc,
+		._dma_setup = hard_dma_setup
 	},
 	{
-		vdma_request_dma,
-		vdma_nop,
-		vdma_get_dma_residue,
-		vdma_mem_alloc,
-		vdma_dma_setup
+		._request_dma = vdma_request_dma,
+		._free_dma = vdma_nop,
+		._get_dma_residue = vdma_get_dma_residue,
+		._dma_mem_alloc = vdma_mem_alloc,
+		._dma_setup = vdma_dma_setup
 	}
 };
 
diff --git a/arch/x86/include/asm/fpu/internal.h b/arch/x86/include/asm/fpu/internal.h
index 2737366ea..e152d4b98 100644
--- a/arch/x86/include/asm/fpu/internal.h
+++ b/arch/x86/include/asm/fpu/internal.h
@@ -102,9 +102,11 @@ extern void fpstate_sanitize_xstate(struct fpu *fpu);
 #define user_insn(insn, output, input...)				\
 ({									\
 	int err;							\
-	asm volatile(ASM_STAC "\n"					\
-		     "1:" #insn "\n\t"					\
-		     "2: " ASM_CLAC "\n"				\
+	user_access_begin();						\
+	asm volatile("1:"						\
+		     __copyuser_seg					\
+		     #insn "\n\t"					\
+		     "2:\n"						\
 		     ".section .fixup,\"ax\"\n"				\
 		     "3:  movl $-1,%[err]\n"				\
 		     "    jmp  2b\n"					\
@@ -112,6 +114,7 @@ extern void fpstate_sanitize_xstate(struct fpu *fpu);
 		     _ASM_EXTABLE(1b, 3b)				\
 		     : [err] "=r" (err), output				\
 		     : "0"(0), input);					\
+	user_access_end();						\
 	err;								\
 })
 
@@ -191,9 +194,9 @@ static inline int copy_user_to_fregs(struct fregs_state __user *fx)
 static inline void copy_fxregs_to_kernel(struct fpu *fpu)
 {
 	if (IS_ENABLED(CONFIG_X86_32))
-		asm volatile( "fxsave %[fx]" : [fx] "=m" (fpu->state.fxsave));
+		asm volatile( "fxsave %[fx]" : [fx] "=m" (fpu->state->fxsave));
 	else if (IS_ENABLED(CONFIG_AS_FXSAVEQ))
-		asm volatile("fxsaveq %[fx]" : [fx] "=m" (fpu->state.fxsave));
+		asm volatile("fxsaveq %[fx]" : [fx] "=m" (fpu->state->fxsave));
 	else {
 		/* Using "rex64; fxsave %0" is broken because, if the memory
 		 * operand uses any extended registers for addressing, a second
@@ -210,15 +213,15 @@ static inline void copy_fxregs_to_kernel(struct fpu *fpu)
 		 * an extended register is needed for addressing (fix submitted
 		 * to mainline 2005-11-21).
 		 *
-		 *  asm volatile("rex64/fxsave %0" : "=m" (fpu->state.fxsave));
+		 *  asm volatile("rex64/fxsave %0" : "=m" (fpu->state->fxsave));
 		 *
 		 * This, however, we can work around by forcing the compiler to
 		 * select an addressing mode that doesn't require extended
 		 * registers.
 		 */
 		asm volatile( "rex64/fxsave (%[fx])"
-			     : "=m" (fpu->state.fxsave)
-			     : [fx] "R" (&fpu->state.fxsave));
+			     : "=m" (fpu->state->fxsave)
+			     : [fx] "R" (&fpu->state->fxsave));
 	}
 }
 
@@ -390,9 +393,9 @@ static inline int copy_xregs_to_user(struct xregs_state __user *buf)
 	if (unlikely(err))
 		return -EFAULT;
 
-	stac();
-	XSTATE_OP(XSAVE, buf, -1, -1, err);
-	clac();
+	user_access_begin();
+	XSTATE_OP(__copyuser_seg XSAVE, buf, -1, -1, err);
+	user_access_end();
 
 	return err;
 }
@@ -402,14 +405,14 @@ static inline int copy_xregs_to_user(struct xregs_state __user *buf)
  */
 static inline int copy_user_to_xregs(struct xregs_state __user *buf, u64 mask)
 {
-	struct xregs_state *xstate = ((__force struct xregs_state *)buf);
+	struct xregs_state *xstate = ((__force_kernel struct xregs_state *)buf);
 	u32 lmask = mask;
 	u32 hmask = mask >> 32;
 	int err;
 
-	stac();
-	XSTATE_OP(XRSTOR, xstate, lmask, hmask, err);
-	clac();
+	user_access_begin();
+	XSTATE_OP(__copyuser_seg XRSTOR, xstate, lmask, hmask, err);
+	user_access_end();
 
 	return err;
 }
@@ -427,7 +430,7 @@ static inline int copy_user_to_xregs(struct xregs_state __user *buf, u64 mask)
 static inline int copy_fpregs_to_fpstate(struct fpu *fpu)
 {
 	if (likely(use_xsave())) {
-		copy_xregs_to_kernel(&fpu->state.xsave);
+		copy_xregs_to_kernel(&fpu->state->xsave);
 		return 1;
 	}
 
@@ -440,7 +443,7 @@ static inline int copy_fpregs_to_fpstate(struct fpu *fpu)
 	 * Legacy FPU register saving, FNSAVE always clears FPU registers,
 	 * so we have to mark them inactive:
 	 */
-	asm volatile("fnsave %[fp]; fwait" : [fp] "=m" (fpu->state.fsave));
+	asm volatile("fnsave %[fp]; fwait" : [fp] "=m" (fpu->state->fsave));
 
 	return 0;
 }
@@ -469,7 +472,7 @@ static inline void copy_kernel_to_fpregs(union fpregs_state *fpstate)
 			"fnclex\n\t"
 			"emms\n\t"
 			"fildl %P[addr]"	/* set F?P to defined value */
-			: : [addr] "m" (fpstate));
+			: : [addr] "m" (cpu_tss[raw_smp_processor_id()].x86_tss.sp0));
 	}
 
 	__copy_kernel_to_fpregs(fpstate);
@@ -614,7 +617,7 @@ switch_fpu_prepare(struct fpu *old_fpu, struct fpu *new_fpu, int cpu)
 			new_fpu->counter++;
 			__fpregs_activate(new_fpu);
 			trace_x86_fpu_regs_activated(new_fpu);
-			prefetch(&new_fpu->state);
+			prefetch(new_fpu->state);
 		} else {
 			__fpregs_deactivate_hw();
 		}
@@ -626,7 +629,7 @@ switch_fpu_prepare(struct fpu *old_fpu, struct fpu *new_fpu, int cpu)
 			if (fpu_want_lazy_restore(new_fpu, cpu))
 				fpu.preload = 0;
 			else
-				prefetch(&new_fpu->state);
+				prefetch(new_fpu->state);
 			fpregs_activate(new_fpu);
 		}
 	}
@@ -646,7 +649,7 @@ switch_fpu_prepare(struct fpu *old_fpu, struct fpu *new_fpu, int cpu)
 static inline void switch_fpu_finish(struct fpu *new_fpu, fpu_switch_t fpu_switch)
 {
 	if (fpu_switch.preload)
-		copy_kernel_to_fpregs(&new_fpu->state);
+		copy_kernel_to_fpregs(new_fpu->state);
 }
 
 /*
diff --git a/arch/x86/include/asm/fpu/types.h b/arch/x86/include/asm/fpu/types.h
index 48df486b0..e32babddd 100644
--- a/arch/x86/include/asm/fpu/types.h
+++ b/arch/x86/include/asm/fpu/types.h
@@ -276,6 +276,39 @@ union fpregs_state {
  */
 struct fpu {
 	/*
+	 * @state:
+	 *
+	 * In-memory copy of all FPU registers that we save/restore
+	 * over context switches. If the task is using the FPU then
+	 * the registers in the FPU are more recent than this state
+	 * copy. If the task context-switches away then they get
+	 * saved here and represent the FPU state.
+	 *
+	 * After context switches there may be a (short) time period
+	 * during which the in-FPU hardware registers are unchanged
+	 * and still perfectly match this state, if the tasks
+	 * scheduled afterwards are not using the FPU.
+	 *
+	 * This is the 'lazy restore' window of optimization, which
+	 * we track though 'fpu_fpregs_owner_ctx' and 'fpu->last_cpu'.
+	 *
+	 * We detect whether a subsequent task uses the FPU via setting
+	 * CR0::TS to 1, which causes any FPU use to raise a #NM fault.
+	 *
+	 * During this window, if the task gets scheduled again, we
+	 * might be able to skip having to do a restore from this
+	 * memory buffer to the hardware registers - at the cost of
+	 * incurring the overhead of #NM fault traps.
+	 *
+	 * Note that on modern CPUs that support the XSAVEOPT (or other
+	 * optimized XSAVE instructions), we don't use #NM traps anymore,
+	 * as the hardware can track whether FPU registers need saving
+	 * or not. On such CPUs we activate the non-lazy ('eagerfpu')
+	 * logic, which unconditionally saves/restores all FPU state
+	 * across context switches. (if FPU state exists.)
+	 */
+	union fpregs_state		*state;
+	/*
 	 * @last_cpu:
 	 *
 	 * Records the last CPU on which this context was loaded into
@@ -332,43 +365,6 @@ struct fpu {
 	 * deal with bursty apps that only use the FPU for a short time:
 	 */
 	unsigned char			counter;
-	/*
-	 * @state:
-	 *
-	 * In-memory copy of all FPU registers that we save/restore
-	 * over context switches. If the task is using the FPU then
-	 * the registers in the FPU are more recent than this state
-	 * copy. If the task context-switches away then they get
-	 * saved here and represent the FPU state.
-	 *
-	 * After context switches there may be a (short) time period
-	 * during which the in-FPU hardware registers are unchanged
-	 * and still perfectly match this state, if the tasks
-	 * scheduled afterwards are not using the FPU.
-	 *
-	 * This is the 'lazy restore' window of optimization, which
-	 * we track though 'fpu_fpregs_owner_ctx' and 'fpu->last_cpu'.
-	 *
-	 * We detect whether a subsequent task uses the FPU via setting
-	 * CR0::TS to 1, which causes any FPU use to raise a #NM fault.
-	 *
-	 * During this window, if the task gets scheduled again, we
-	 * might be able to skip having to do a restore from this
-	 * memory buffer to the hardware registers - at the cost of
-	 * incurring the overhead of #NM fault traps.
-	 *
-	 * Note that on modern CPUs that support the XSAVEOPT (or other
-	 * optimized XSAVE instructions), we don't use #NM traps anymore,
-	 * as the hardware can track whether FPU registers need saving
-	 * or not. On such CPUs we activate the non-lazy ('eagerfpu')
-	 * logic, which unconditionally saves/restores all FPU state
-	 * across context switches. (if FPU state exists.)
-	 */
-	union fpregs_state		state;
-	/*
-	 * WARNING: 'state' is dynamically-sized.  Do not put
-	 * anything after it here.
-	 */
 };
 
 #endif /* _ASM_X86_FPU_H */
diff --git a/arch/x86/include/asm/fpu/xstate.h b/arch/x86/include/asm/fpu/xstate.h
index 19f30a814..d0561c13b 100644
--- a/arch/x86/include/asm/fpu/xstate.h
+++ b/arch/x86/include/asm/fpu/xstate.h
@@ -43,6 +43,7 @@
 #define REX_PREFIX
 #endif
 
+extern unsigned int xstate_size;
 extern u64 xfeatures_mask;
 extern u64 xstate_fx_sw_bytes[USER_XSTATE_FX_SW_WORDS];
 
diff --git a/arch/x86/include/asm/futex.h b/arch/x86/include/asm/futex.h
index b4c1f5453..726053de7 100644
--- a/arch/x86/include/asm/futex.h
+++ b/arch/x86/include/asm/futex.h
@@ -12,25 +12,25 @@
 #include <asm/smap.h>
 
 #define __futex_atomic_op1(insn, ret, oldval, uaddr, oparg)	\
-	asm volatile("\t" ASM_STAC "\n"				\
-		     "1:\t" insn "\n"				\
-		     "2:\t" ASM_CLAC "\n"			\
+	typecheck(u32 __user *, uaddr);				\
+	asm volatile("1:\t" insn "\n"				\
+		     "2:\t\n"					\
 		     "\t.section .fixup,\"ax\"\n"		\
 		     "3:\tmov\t%3, %1\n"			\
 		     "\tjmp\t2b\n"				\
 		     "\t.previous\n"				\
 		     _ASM_EXTABLE(1b, 3b)			\
-		     : "=r" (oldval), "=r" (ret), "+m" (*uaddr)	\
+		     : "=r" (oldval), "=r" (ret), "+m" (*(u32 __user *)____m(uaddr))	\
 		     : "i" (-EFAULT), "0" (oparg), "1" (0))
 
 #define __futex_atomic_op2(insn, ret, oldval, uaddr, oparg)	\
-	asm volatile("\t" ASM_STAC "\n"				\
-		     "1:\tmovl	%2, %0\n"			\
+	typecheck(u32 __user *, uaddr);				\
+	asm volatile("1:\tmovl	%2, %0\n"			\
 		     "\tmovl\t%0, %3\n"				\
 		     "\t" insn "\n"				\
-		     "2:\t" LOCK_PREFIX "cmpxchgl %3, %2\n"	\
+		     "2:\t" LOCK_PREFIX __copyuser_seg"cmpxchgl %3, %2\n"	\
 		     "\tjnz\t1b\n"				\
-		     "3:\t" ASM_CLAC "\n"			\
+		     "3:\t\n"					\
 		     "\t.section .fixup,\"ax\"\n"		\
 		     "4:\tmov\t%5, %1\n"			\
 		     "\tjmp\t3b\n"				\
@@ -38,7 +38,7 @@
 		     _ASM_EXTABLE(1b, 4b)			\
 		     _ASM_EXTABLE(2b, 4b)			\
 		     : "=&a" (oldval), "=&r" (ret),		\
-		       "+m" (*uaddr), "=&r" (tem)		\
+		       "+m" (*(u32 __user *)____m(uaddr)), "=&r" (tem)	\
 		     : "r" (oparg), "i" (-EFAULT), "1" (0))
 
 static inline int futex_atomic_op_inuser(int encoded_op, u32 __user *uaddr)
@@ -57,12 +57,13 @@ static inline int futex_atomic_op_inuser(int encoded_op, u32 __user *uaddr)
 
 	pagefault_disable();
 
+	user_access_begin();
 	switch (op) {
 	case FUTEX_OP_SET:
-		__futex_atomic_op1("xchgl %0, %2", ret, oldval, uaddr, oparg);
+		__futex_atomic_op1(__copyuser_seg"xchgl %0, %2", ret, oldval, uaddr, oparg);
 		break;
 	case FUTEX_OP_ADD:
-		__futex_atomic_op1(LOCK_PREFIX "xaddl %0, %2", ret, oldval,
+		__futex_atomic_op1(LOCK_PREFIX __copyuser_seg"xaddl %0, %2", ret, oldval,
 				   uaddr, oparg);
 		break;
 	case FUTEX_OP_OR:
@@ -77,6 +78,7 @@ static inline int futex_atomic_op_inuser(int encoded_op, u32 __user *uaddr)
 	default:
 		ret = -ENOSYS;
 	}
+	user_access_end();
 
 	pagefault_enable();
 
diff --git a/arch/x86/include/asm/hw_irq.h b/arch/x86/include/asm/hw_irq.h
index b90e10530..30a595000 100644
--- a/arch/x86/include/asm/hw_irq.h
+++ b/arch/x86/include/asm/hw_irq.h
@@ -164,8 +164,8 @@ static inline void unlock_vector_lock(void) {}
 #endif	/* CONFIG_X86_LOCAL_APIC */
 
 /* Statistics */
-extern atomic_t irq_err_count;
-extern atomic_t irq_mis_count;
+extern atomic_unchecked_t irq_err_count;
+extern atomic_unchecked_t irq_mis_count;
 
 extern void elcr_set_level_irq(unsigned int irq);
 
diff --git a/arch/x86/include/asm/hypervisor.h b/arch/x86/include/asm/hypervisor.h
index 055ea9941..7dabb687f 100644
--- a/arch/x86/include/asm/hypervisor.h
+++ b/arch/x86/include/asm/hypervisor.h
@@ -43,7 +43,7 @@ struct hypervisor_x86 {
 
 	/* X2APIC detection (run once per boot) */
 	bool		(*x2apic_available)(void);
-};
+} __do_const;
 
 extern const struct hypervisor_x86 *x86_hyper;
 
diff --git a/arch/x86/include/asm/i8259.h b/arch/x86/include/asm/i8259.h
index 39bcefc20..272d904f1 100644
--- a/arch/x86/include/asm/i8259.h
+++ b/arch/x86/include/asm/i8259.h
@@ -63,7 +63,7 @@ struct legacy_pic {
 	int (*probe)(void);
 	int (*irq_pending)(unsigned int irq);
 	void (*make_irq)(unsigned int irq);
-};
+} __do_const;
 
 extern struct legacy_pic *legacy_pic;
 extern struct legacy_pic null_legacy_pic;
diff --git a/arch/x86/include/asm/io.h b/arch/x86/include/asm/io.h
index de25aad07..dc044764c 100644
--- a/arch/x86/include/asm/io.h
+++ b/arch/x86/include/asm/io.h
@@ -42,6 +42,7 @@
 #include <asm/page.h>
 #include <asm/early_ioremap.h>
 #include <asm/pgtable_types.h>
+#include <asm/processor.h>
 
 #define build_mmio_read(name, size, type, reg, barrier) \
 static inline type name(const volatile void __iomem *addr) \
@@ -54,12 +55,12 @@ static inline void name(type val, volatile void __iomem *addr) \
 "m" (*(volatile type __force *)addr) barrier); }
 
 build_mmio_read(readb, "b", unsigned char, "=q", :"memory")
-build_mmio_read(readw, "w", unsigned short, "=r", :"memory")
-build_mmio_read(readl, "l", unsigned int, "=r", :"memory")
+build_mmio_read(__intentional_overflow(-1) readw, "w", unsigned short, "=r", :"memory")
+build_mmio_read(__intentional_overflow(-1) readl, "l", unsigned int, "=r", :"memory")
 
 build_mmio_read(__readb, "b", unsigned char, "=q", )
-build_mmio_read(__readw, "w", unsigned short, "=r", )
-build_mmio_read(__readl, "l", unsigned int, "=r", )
+build_mmio_read(__intentional_overflow(-1) __readw, "w", unsigned short, "=r", )
+build_mmio_read(__intentional_overflow(-1) __readl, "l", unsigned int, "=r", )
 
 build_mmio_write(writeb, "b", unsigned char, "q", :"memory")
 build_mmio_write(writew, "w", unsigned short, "r", :"memory")
@@ -115,7 +116,7 @@ build_mmio_write(writeq, "q", unsigned long, "r", :"memory")
  *	this function
  */
 
-static inline phys_addr_t virt_to_phys(volatile void *address)
+static inline phys_addr_t __intentional_overflow(-1) virt_to_phys(volatile void *address)
 {
 	return __pa(address);
 }
@@ -194,7 +195,7 @@ static inline void __iomem *ioremap(resource_size_t offset, unsigned long size)
 	return ioremap_nocache(offset, size);
 }
 
-extern void iounmap(volatile void __iomem *addr);
+extern void iounmap(const volatile void __iomem *addr);
 
 extern void set_iounmap_nonlazy(void);
 
@@ -202,6 +203,17 @@ extern void set_iounmap_nonlazy(void);
 
 #include <asm-generic/iomap.h>
 
+#define ARCH_HAS_VALID_PHYS_ADDR_RANGE
+static inline int valid_phys_addr_range(unsigned long addr, size_t count)
+{
+	return ((addr + count + PAGE_SIZE - 1) >> PAGE_SHIFT) < (1ULL << (boot_cpu_data.x86_phys_bits - PAGE_SHIFT)) ? 1 : 0;
+}
+
+static inline int valid_mmap_phys_addr_range(unsigned long pfn, size_t count)
+{
+	return (pfn + (count >> PAGE_SHIFT)) < (1ULL << (boot_cpu_data.x86_phys_bits - PAGE_SHIFT)) ? 1 : 0;
+}
+
 /*
  * Convert a virtual cached pointer to an uncached pointer
  */
diff --git a/arch/x86/include/asm/irq_vectors.h b/arch/x86/include/asm/irq_vectors.h
index 6ca9fd623..4c0aa5575 100644
--- a/arch/x86/include/asm/irq_vectors.h
+++ b/arch/x86/include/asm/irq_vectors.h
@@ -48,6 +48,8 @@
 
 #define IA32_SYSCALL_VECTOR		0x80
 
+#define X86_REFCOUNT_VECTOR		0x81 /* Refcount Overflow or Underflow Exception */
+
 /*
  * Vectors 0x30-0x3f are used for ISA interrupts.
  *   round up to the next 16-vector boundary
diff --git a/arch/x86/include/asm/irqflags.h b/arch/x86/include/asm/irqflags.h
index b77f5edb0..cbf5ec60a 100644
--- a/arch/x86/include/asm/irqflags.h
+++ b/arch/x86/include/asm/irqflags.h
@@ -23,11 +23,17 @@ static inline unsigned long native_save_fl(void)
 		     : /* no input */
 		     : "memory");
 
+#if !defined(CONFIG_GRKERNSEC_CONFIG_VIRT_HOST) || !defined(CONFIG_GRKERNSEC_CONFIG_VIRT_VIRTUALBOX)
+	BUG_ON(flags & X86_EFLAGS_AC);
+#endif
 	return flags;
 }
 
 static inline void native_restore_fl(unsigned long flags)
 {
+#if !defined(CONFIG_GRKERNSEC_CONFIG_VIRT_HOST) || !defined(CONFIG_GRKERNSEC_CONFIG_VIRT_VIRTUALBOX)
+	BUG_ON(flags & X86_EFLAGS_AC);
+#endif
 	asm volatile("push %0 ; popf"
 		     : /* no output */
 		     :"g" (flags)
@@ -137,6 +143,11 @@ static inline notrace unsigned long arch_local_irq_save(void)
 	swapgs;					\
 	sysretl
 
+#define GET_CR0_INTO_RDI		mov %cr0, %rdi
+#define SET_RDI_INTO_CR0		mov %rdi, %cr0
+#define GET_CR3_INTO_RDI		mov %cr3, %rdi
+#define SET_RDI_INTO_CR3		mov %rdi, %cr3
+
 #else
 #define INTERRUPT_RETURN		iret
 #define ENABLE_INTERRUPTS_SYSEXIT	sti; sysexit
diff --git a/arch/x86/include/asm/kprobes.h b/arch/x86/include/asm/kprobes.h
index d1d1e5094..5bacb6d57 100644
--- a/arch/x86/include/asm/kprobes.h
+++ b/arch/x86/include/asm/kprobes.h
@@ -37,7 +37,7 @@ typedef u8 kprobe_opcode_t;
 #define RELATIVEJUMP_SIZE 5
 #define RELATIVECALL_OPCODE 0xe8
 #define RELATIVE_ADDR_SIZE 4
-#define MAX_STACK_SIZE 64
+#define MAX_STACK_SIZE 64UL
 #define CUR_STACK_SIZE(ADDR) \
 	(current_top_of_stack() - (unsigned long)(ADDR))
 #define MIN_STACK_SIZE(ADDR)				\
diff --git a/arch/x86/include/asm/kvm_emulate.h b/arch/x86/include/asm/kvm_emulate.h
index e9cd7befc..0f3574f73 100644
--- a/arch/x86/include/asm/kvm_emulate.h
+++ b/arch/x86/include/asm/kvm_emulate.h
@@ -279,6 +279,8 @@ enum x86emul_mode {
 #define X86EMUL_SMM_MASK             (1 << 6)
 #define X86EMUL_SMM_INSIDE_NMI_MASK  (1 << 7)
 
+struct fastop;
+
 struct x86_emulate_ctxt {
 	const struct x86_emulate_ops *ops;
 
@@ -311,7 +313,10 @@ struct x86_emulate_ctxt {
 	struct operand src;
 	struct operand src2;
 	struct operand dst;
-	int (*execute)(struct x86_emulate_ctxt *ctxt);
+	union {
+		int (*execute)(struct x86_emulate_ctxt *ctxt);
+		void (*fastop)(struct fastop *fake);
+	} u;
 	int (*check_perm)(struct x86_emulate_ctxt *ctxt);
 	/*
 	 * The following six fields are cleared together,
diff --git a/arch/x86/include/asm/local.h b/arch/x86/include/asm/local.h
index 751197809..cf525730a 100644
--- a/arch/x86/include/asm/local.h
+++ b/arch/x86/include/asm/local.h
@@ -10,33 +10,73 @@ typedef struct {
 	atomic_long_t a;
 } local_t;
 
+typedef struct {
+	atomic_long_unchecked_t a;
+} local_unchecked_t;
+
 #define LOCAL_INIT(i)	{ ATOMIC_LONG_INIT(i) }
 
 #define local_read(l)	atomic_long_read(&(l)->a)
+#define local_read_unchecked(l)	atomic_long_read_unchecked(&(l)->a)
 #define local_set(l, i)	atomic_long_set(&(l)->a, (i))
+#define local_set_unchecked(l, i)	atomic_long_set_unchecked(&(l)->a, (i))
 
 static inline void local_inc(local_t *l)
 {
-	asm volatile(_ASM_INC "%0"
+	asm volatile(_ASM_INC "%0\n\t"
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)
+		     : [counter] "+m" (l->a.counter)
+		     : : "cc", "cx");
+}
+
+static inline void local_inc_unchecked(local_unchecked_t *l)
+{
+	asm volatile(_ASM_INC "%0\n"
 		     : "+m" (l->a.counter));
 }
 
 static inline void local_dec(local_t *l)
 {
-	asm volatile(_ASM_DEC "%0"
+	asm volatile(_ASM_DEC "%0\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(BITS_PER_LONG/8)
+		     : [counter] "+m" (l->a.counter)
+		     : : "cc", "cx");
+}
+
+static inline void local_dec_unchecked(local_unchecked_t *l)
+{
+	asm volatile(_ASM_DEC "%0\n"
 		     : "+m" (l->a.counter));
 }
 
 static inline void local_add(long i, local_t *l)
 {
-	asm volatile(_ASM_ADD "%1,%0"
+	asm volatile(_ASM_ADD "%1,%0\n\t"
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)
+		     : [counter] "+m" (l->a.counter)
+		     : "ir" (i)
+		     : "cc", "cx");
+}
+
+static inline void local_add_unchecked(long i, local_unchecked_t *l)
+{
+	asm volatile(_ASM_ADD "%1,%0\n"
 		     : "+m" (l->a.counter)
 		     : "ir" (i));
 }
 
 static inline void local_sub(long i, local_t *l)
 {
-	asm volatile(_ASM_SUB "%1,%0"
+	asm volatile(_ASM_SUB "%1,%0\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(BITS_PER_LONG/8)
+		     : [counter] "+m" (l->a.counter)
+		     : "ir" (i)
+		     : "cc", "cx");
+}
+
+static inline void local_sub_unchecked(long i, local_unchecked_t *l)
+{
+	asm volatile(_ASM_SUB "%1,%0\n"
 		     : "+m" (l->a.counter)
 		     : "ir" (i));
 }
@@ -52,7 +92,7 @@ static inline void local_sub(long i, local_t *l)
  */
 static inline bool local_sub_and_test(long i, local_t *l)
 {
-	GEN_BINARY_RMWcc(_ASM_SUB, l->a.counter, "er", i, "%0", e);
+	GEN_BINARY_RMWcc(_ASM_SUB, l->a.counter, -BITS_PER_LONG/8, "er", i, "%0", e);
 }
 
 /**
@@ -65,7 +105,7 @@ static inline bool local_sub_and_test(long i, local_t *l)
  */
 static inline bool local_dec_and_test(local_t *l)
 {
-	GEN_UNARY_RMWcc(_ASM_DEC, l->a.counter, "%0", e);
+	GEN_UNARY_RMWcc(_ASM_DEC, l->a.counter, -BITS_PER_LONG/8, "%0", e);
 }
 
 /**
@@ -78,7 +118,7 @@ static inline bool local_dec_and_test(local_t *l)
  */
 static inline bool local_inc_and_test(local_t *l)
 {
-	GEN_UNARY_RMWcc(_ASM_INC, l->a.counter, "%0", e);
+	GEN_UNARY_RMWcc(_ASM_INC, l->a.counter, BITS_PER_LONG/8, "%0", e);
 }
 
 /**
@@ -92,7 +132,7 @@ static inline bool local_inc_and_test(local_t *l)
  */
 static inline bool local_add_negative(long i, local_t *l)
 {
-	GEN_BINARY_RMWcc(_ASM_ADD, l->a.counter, "er", i, "%0", s);
+	GEN_BINARY_RMWcc(_ASM_ADD, l->a.counter, BITS_PER_LONG/8, "er", i, "%0", s);
 }
 
 /**
@@ -105,6 +145,23 @@ static inline bool local_add_negative(long i, local_t *l)
 static inline long local_add_return(long i, local_t *l)
 {
 	long __i = i;
+	asm volatile(_ASM_XADD "%0, %1\n\t"
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)
+		     : "+r" (i), [counter] "+m" (l->a.counter)
+		     : : "memory", "cc", "cx");
+	return i + __i;
+}
+
+/**
+ * local_add_return_unchecked - add and return
+ * @i: integer value to add
+ * @l: pointer to type local_unchecked_t
+ *
+ * Atomically adds @i to @l and returns @i + @l
+ */
+static inline long local_add_return_unchecked(long i, local_unchecked_t *l)
+{
+	long __i = i;
 	asm volatile(_ASM_XADD "%0, %1;"
 		     : "+r" (i), "+m" (l->a.counter)
 		     : : "memory");
@@ -121,6 +178,8 @@ static inline long local_sub_return(long i, local_t *l)
 
 #define local_cmpxchg(l, o, n) \
 	(cmpxchg_local(&((l)->a.counter), (o), (n)))
+#define local_cmpxchg_unchecked(l, o, n) \
+	(cmpxchg_local(&((l)->a.counter), (o), (n)))
 /* Always has a lock prefix */
 #define local_xchg(l, n) (xchg(&((l)->a.counter), (n)))
 
diff --git a/arch/x86/include/asm/mce.h b/arch/x86/include/asm/mce.h
index 8bf766ef0..d800b6163 100644
--- a/arch/x86/include/asm/mce.h
+++ b/arch/x86/include/asm/mce.h
@@ -184,7 +184,7 @@ struct mca_msr_regs {
 	u32 (*status)	(int bank);
 	u32 (*addr)	(int bank);
 	u32 (*misc)	(int bank);
-};
+} __no_const;
 
 extern struct mce_vendor_flags mce_flags;
 
diff --git b/arch/x86/include/asm/mman.h b/arch/x86/include/asm/mman.h
new file mode 100644
index 000000000..2bfd3ba88
--- /dev/null
+++ b/arch/x86/include/asm/mman.h
@@ -0,0 +1,15 @@
+#ifndef _X86_MMAN_H
+#define _X86_MMAN_H
+
+#include <uapi/asm/mman.h>
+
+#ifdef __KERNEL__
+#ifndef __ASSEMBLY__
+#ifdef CONFIG_X86_32
+#define arch_mmap_check	i386_mmap_check
+int i386_mmap_check(unsigned long addr, unsigned long len, unsigned long flags);
+#endif
+#endif
+#endif
+
+#endif /* X86_MMAN_H */
diff --git a/arch/x86/include/asm/mmu.h b/arch/x86/include/asm/mmu.h
index 1ea0baef1..25de747db 100644
--- a/arch/x86/include/asm/mmu.h
+++ b/arch/x86/include/asm/mmu.h
@@ -19,7 +19,19 @@ typedef struct {
 #endif
 
 	struct mutex lock;
-	void __user *vdso;			/* vdso base address */
+	unsigned long vdso;			/* vdso base address */
+
+#ifdef CONFIG_X86_32
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+	unsigned long user_cs_base;
+	unsigned long user_cs_limit;
+
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_SMP)
+	cpumask_t cpu_user_cs_mask;
+#endif
+
+#endif
+#endif
 	const struct vdso_image *vdso_image;	/* vdso image in use */
 
 	atomic_t perf_rdpmc_allowed;	/* nonzero if rdpmc is allowed */
diff --git a/arch/x86/include/asm/mmu_context.h b/arch/x86/include/asm/mmu_context.h
index d8abfcf52..721da3081 100644
--- a/arch/x86/include/asm/mmu_context.h
+++ b/arch/x86/include/asm/mmu_context.h
@@ -46,7 +46,7 @@ struct ldt_struct {
 	 * allocations, but it's not worth trying to optimize.
 	 */
 	struct desc_struct *entries;
-	int size;
+	unsigned int size;
 };
 
 /*
@@ -58,6 +58,23 @@ void destroy_context_ldt(struct mm_struct *mm);
 static inline int init_new_context_ldt(struct task_struct *tsk,
 				       struct mm_struct *mm)
 {
+	if (tsk == current) {
+		mm->context.vdso = 0;
+
+#ifdef CONFIG_X86_32
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+		mm->context.user_cs_base = 0UL;
+		mm->context.user_cs_limit = ~0UL;
+
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_SMP)
+		cpumask_clear(&mm->context.cpu_user_cs_mask);
+#endif
+
+#endif
+#endif
+
+	}
+
 	return 0;
 }
 static inline void destroy_context_ldt(struct mm_struct *mm) {}
@@ -98,6 +115,20 @@ static inline void load_mm_ldt(struct mm_struct *mm)
 
 static inline void enter_lazy_tlb(struct mm_struct *mm, struct task_struct *tsk)
 {
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	if (!(static_cpu_has(X86_FEATURE_PCIDUDEREF))) {
+		unsigned int i;
+		pgd_t *pgd;
+
+		pax_open_kernel();
+		pgd = get_cpu_pgd(smp_processor_id(), kernel);
+		for (i = USER_PGD_PTRS; i < 2 * USER_PGD_PTRS; ++i)
+			set_pgd_batched(pgd+i, native_make_pgd(0));
+		pax_close_kernel();
+	}
+#endif
+
 #ifdef CONFIG_SMP
 	if (this_cpu_read(cpu_tlbstate.state) == TLBSTATE_OK)
 		this_cpu_write(cpu_tlbstate.state, TLBSTATE_LAZY);
diff --git a/arch/x86/include/asm/module.h b/arch/x86/include/asm/module.h
index e3b7819ca..ba128ecff 100644
--- a/arch/x86/include/asm/module.h
+++ b/arch/x86/include/asm/module.h
@@ -5,6 +5,7 @@
 
 #ifdef CONFIG_X86_64
 /* X86_64 does not define MODULE_PROC_FAMILY */
+#define MODULE_PROC_FAMILY ""
 #elif defined CONFIG_M486
 #define MODULE_PROC_FAMILY "486 "
 #elif defined CONFIG_M586
@@ -57,8 +58,26 @@
 #error unknown processor family
 #endif
 
-#ifdef CONFIG_X86_32
-# define MODULE_ARCH_VERMAGIC MODULE_PROC_FAMILY
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_BTS
+#define MODULE_PAX_KERNEXEC "KERNEXEC_BTS "
+#elif defined(CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR)
+#define MODULE_PAX_KERNEXEC "KERNEXEC_OR "
+#else
+#define MODULE_PAX_KERNEXEC ""
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+#define MODULE_PAX_UDEREF "UDEREF "
+#else
+#define MODULE_PAX_UDEREF ""
 #endif
 
+#ifdef CONFIG_PAX_RAP
+#define MODULE_PAX_RAP "RAP "
+#else
+#define MODULE_PAX_RAP ""
+#endif
+
+#define MODULE_ARCH_VERMAGIC MODULE_PROC_FAMILY MODULE_PAX_KERNEXEC MODULE_PAX_UDEREF MODULE_PAX_RAP
+
 #endif /* _ASM_X86_MODULE_H */
diff --git a/arch/x86/include/asm/nmi.h b/arch/x86/include/asm/nmi.h
index 5f2fc4441..106caa61e 100644
--- a/arch/x86/include/asm/nmi.h
+++ b/arch/x86/include/asm/nmi.h
@@ -36,26 +36,35 @@ enum {
 
 typedef int (*nmi_handler_t)(unsigned int, struct pt_regs *);
 
+struct nmiaction;
+
+struct nmiwork {
+	const struct nmiaction	*action;
+	u64			max_duration;
+	struct irq_work		irq_work;
+};
+
 struct nmiaction {
 	struct list_head	list;
 	nmi_handler_t		handler;
-	u64			max_duration;
-	struct irq_work		irq_work;
 	unsigned long		flags;
 	const char		*name;
-};
+	struct nmiwork		*work;
+} __do_const;
 
 #define register_nmi_handler(t, fn, fg, n, init...)	\
 ({							\
-	static struct nmiaction init fn##_na = {	\
+	static struct nmiwork fn##_nw;			\
+	static const struct nmiaction init fn##_na = {	\
 		.handler = (fn),			\
 		.name = (n),				\
 		.flags = (fg),				\
+		.work = &fn##_nw,			\
 	};						\
 	__register_nmi_handler((t), &fn##_na);		\
 })
 
-int __register_nmi_handler(unsigned int, struct nmiaction *);
+int __register_nmi_handler(unsigned int, const struct nmiaction *);
 
 void unregister_nmi_handler(unsigned int, const char *);
 
diff --git a/arch/x86/include/asm/page.h b/arch/x86/include/asm/page.h
index cf8f619b3..bbcf5e67e 100644
--- a/arch/x86/include/asm/page.h
+++ b/arch/x86/include/asm/page.h
@@ -58,6 +58,8 @@ static inline void copy_user_page(void *to, void *from, unsigned long vaddr,
 #define __va(x)			((void *)((unsigned long)(x)+PAGE_OFFSET))
 #endif
 
+#define __early_va(x)		((void *)((unsigned long)(x)+__START_KERNEL_map - phys_base))
+
 #define __boot_va(x)		__va(x)
 #define __boot_pa(x)		__pa(x)
 
@@ -65,11 +67,21 @@ static inline void copy_user_page(void *to, void *from, unsigned long vaddr,
  * virt_to_page(kaddr) returns a valid pointer if and only if
  * virt_addr_valid(kaddr) returns true.
  */
-#define virt_to_page(kaddr)	pfn_to_page(__pa(kaddr) >> PAGE_SHIFT)
 #define pfn_to_kaddr(pfn)      __va((pfn) << PAGE_SHIFT)
 extern bool __virt_addr_valid(unsigned long kaddr);
 #define virt_addr_valid(kaddr)	__virt_addr_valid((unsigned long) (kaddr))
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+#define virt_to_page(kaddr)	\
+	({ \
+		const void *__kaddr = (const void *)(kaddr); \
+		BUG_ON(!virt_addr_valid(__kaddr)); \
+		pfn_to_page(__pa(__kaddr) >> PAGE_SHIFT); \
+	})
+#else
+#define virt_to_page(kaddr)	pfn_to_page(__pa(kaddr) >> PAGE_SHIFT)
+#endif
+
 #endif	/* __ASSEMBLY__ */
 
 #include <asm-generic/memory_model.h>
diff --git a/arch/x86/include/asm/page_32.h b/arch/x86/include/asm/page_32.h
index 904f528cc..b4d0d2472 100644
--- a/arch/x86/include/asm/page_32.h
+++ b/arch/x86/include/asm/page_32.h
@@ -7,11 +7,17 @@
 
 #define __phys_addr_nodebug(x)	((x) - PAGE_OFFSET)
 #ifdef CONFIG_DEBUG_VIRTUAL
-extern unsigned long __phys_addr(unsigned long);
+extern unsigned long __intentional_overflow(-1) __phys_addr(unsigned long);
 #else
-#define __phys_addr(x)		__phys_addr_nodebug(x)
+static inline unsigned long __intentional_overflow(-1) __phys_addr(unsigned long x)
+{
+	return __phys_addr_nodebug(x);
+}
 #endif
-#define __phys_addr_symbol(x)	__phys_addr(x)
+static inline unsigned long __intentional_overflow(-1) __phys_addr_symbol(unsigned long x)
+{
+	return __phys_addr(x);
+}
 #define __phys_reloc_hide(x)	RELOC_HIDE((x), 0)
 
 #ifdef CONFIG_FLATMEM
diff --git a/arch/x86/include/asm/page_64.h b/arch/x86/include/asm/page_64.h
index b3bebf9e5..2c3570f2f 100644
--- a/arch/x86/include/asm/page_64.h
+++ b/arch/x86/include/asm/page_64.h
@@ -7,9 +7,9 @@
 
 /* duplicated to the one in bootmem.h */
 extern unsigned long max_pfn;
-extern unsigned long phys_base;
+extern const unsigned long phys_base;
 
-static inline unsigned long __phys_addr_nodebug(unsigned long x)
+static __always_inline unsigned long __intentional_overflow(-1) __phys_addr_nodebug(unsigned long x)
 {
 	unsigned long y = x - __START_KERNEL_map;
 
@@ -20,12 +20,14 @@ static inline unsigned long __phys_addr_nodebug(unsigned long x)
 }
 
 #ifdef CONFIG_DEBUG_VIRTUAL
-extern unsigned long __phys_addr(unsigned long);
-extern unsigned long __phys_addr_symbol(unsigned long);
+extern unsigned long __intentional_overflow(-1) __phys_addr(unsigned long);
+extern unsigned long __intentional_overflow(-1) __phys_addr_symbol(unsigned long);
 #else
 #define __phys_addr(x)		__phys_addr_nodebug(x)
-#define __phys_addr_symbol(x) \
-	((unsigned long)(x) - __START_KERNEL_map + phys_base)
+static inline unsigned long __intentional_overflow(-1) __phys_addr_symbol(unsigned long x)
+{
+	return x - __START_KERNEL_map + phys_base;
+}
 #endif
 
 #define __phys_reloc_hide(x)	(x)
diff --git a/arch/x86/include/asm/paravirt.h b/arch/x86/include/asm/paravirt.h
index 2970d22d7..fce32bdc1 100644
--- a/arch/x86/include/asm/paravirt.h
+++ b/arch/x86/include/asm/paravirt.h
@@ -509,7 +509,7 @@ static inline pmd_t __pmd(pmdval_t val)
 	return (pmd_t) { ret };
 }
 
-static inline pmdval_t pmd_val(pmd_t pmd)
+static inline __intentional_overflow(-1) pmdval_t pmd_val(pmd_t pmd)
 {
 	pmdval_t ret;
 
@@ -575,6 +575,18 @@ static inline void set_pgd(pgd_t *pgdp, pgd_t pgd)
 			    val);
 }
 
+static inline void set_pgd_batched(pgd_t *pgdp, pgd_t pgd)
+{
+	pgdval_t val = native_pgd_val(pgd);
+
+	if (sizeof(pgdval_t) > sizeof(long))
+		PVOP_VCALL3(pv_mmu_ops.set_pgd_batched, pgdp,
+			    val, (u64)val >> 32);
+	else
+		PVOP_VCALL2(pv_mmu_ops.set_pgd_batched, pgdp,
+			    val);
+}
+
 static inline void pgd_clear(pgd_t *pgdp)
 {
 	set_pgd(pgdp, __pgd(0));
@@ -659,6 +671,21 @@ static inline void __set_fixmap(unsigned /* enum fixed_addresses */ idx,
 	pv_mmu_ops.set_fixmap(idx, phys, flags);
 }
 
+#ifdef CONFIG_PAX_KERNEXEC
+static inline unsigned long pax_open_kernel(void)
+{
+	return PVOP_CALL0(unsigned long, pv_mmu_ops.pax_open_kernel);
+}
+
+static inline unsigned long pax_close_kernel(void)
+{
+	return PVOP_CALL0(unsigned long, pv_mmu_ops.pax_close_kernel);
+}
+#else
+static inline unsigned long pax_open_kernel(void) { return 0; }
+static inline unsigned long pax_close_kernel(void) { return 0; }
+#endif
+
 #if defined(CONFIG_SMP) && defined(CONFIG_PARAVIRT_SPINLOCKS)
 
 #ifdef CONFIG_QUEUED_SPINLOCKS
@@ -886,7 +913,7 @@ extern void default_banner(void);
 
 #define PARA_PATCH(struct, off)        ((PARAVIRT_PATCH_##struct + (off)) / 4)
 #define PARA_SITE(ptype, clobbers, ops) _PVSITE(ptype, clobbers, ops, .long, 4)
-#define PARA_INDIRECT(addr)	*%cs:addr
+#define PARA_INDIRECT(addr)	*%ss:addr
 #endif
 
 #define INTERRUPT_RETURN						\
@@ -944,6 +971,21 @@ extern void default_banner(void);
 	PARA_SITE(PARA_PATCH(pv_cpu_ops, PV_CPU_usergs_sysret64),	\
 		  CLBR_NONE,						\
 		  jmp PARA_INDIRECT(pv_cpu_ops+PV_CPU_usergs_sysret64))
+
+#define GET_CR0_INTO_RDI				\
+	call PARA_INDIRECT(pv_cpu_ops+PV_CPU_read_cr0);	\
+	mov %rax,%rdi
+
+#define SET_RDI_INTO_CR0				\
+	call PARA_INDIRECT(pv_cpu_ops+PV_CPU_write_cr0)
+
+#define GET_CR3_INTO_RDI				\
+	call PARA_INDIRECT(pv_mmu_ops+PV_MMU_read_cr3);	\
+	mov %rax,%rdi
+
+#define SET_RDI_INTO_CR3				\
+	call PARA_INDIRECT(pv_mmu_ops+PV_MMU_write_cr3)
+
 #endif	/* CONFIG_X86_32 */
 
 #endif /* __ASSEMBLY__ */
diff --git a/arch/x86/include/asm/paravirt_types.h b/arch/x86/include/asm/paravirt_types.h
index 7fa9e7740..aa09e68a7 100644
--- a/arch/x86/include/asm/paravirt_types.h
+++ b/arch/x86/include/asm/paravirt_types.h
@@ -83,7 +83,7 @@ struct pv_init_ops {
 	 */
 	unsigned (*patch)(u8 type, u16 clobber, void *insnbuf,
 			  unsigned long addr, unsigned len);
-};
+} __no_const __no_randomize_layout;
 
 
 struct pv_lazy_ops {
@@ -91,12 +91,12 @@ struct pv_lazy_ops {
 	void (*enter)(void);
 	void (*leave)(void);
 	void (*flush)(void);
-};
+} __no_randomize_layout;
 
 struct pv_time_ops {
 	unsigned long long (*sched_clock)(void);
 	unsigned long long (*steal_clock)(int cpu);
-};
+} __no_const __no_randomize_layout;
 
 struct pv_cpu_ops {
 	/* hooks for various privileged instructions */
@@ -178,7 +178,7 @@ struct pv_cpu_ops {
 
 	void (*start_context_switch)(struct task_struct *prev);
 	void (*end_context_switch)(struct task_struct *next);
-};
+} __no_const __no_randomize_layout;
 
 struct pv_irq_ops {
 	/*
@@ -201,7 +201,7 @@ struct pv_irq_ops {
 #ifdef CONFIG_X86_64
 	void (*adjust_exception_frame)(void);
 #endif
-};
+} __no_randomize_layout;
 
 struct pv_mmu_ops {
 	unsigned long (*read_cr2)(void);
@@ -285,6 +285,7 @@ struct pv_mmu_ops {
 	struct paravirt_callee_save make_pud;
 
 	void (*set_pgd)(pgd_t *pudp, pgd_t pgdval);
+	void (*set_pgd_batched)(pgd_t *pudp, pgd_t pgdval);
 #endif	/* CONFIG_PGTABLE_LEVELS == 4 */
 #endif	/* CONFIG_PGTABLE_LEVELS >= 3 */
 
@@ -296,7 +297,13 @@ struct pv_mmu_ops {
 	   an mfn.  We can tell which is which from the index. */
 	void (*set_fixmap)(unsigned /* enum fixed_addresses */ idx,
 			   phys_addr_t phys, pgprot_t flags);
-};
+
+#ifdef CONFIG_PAX_KERNEXEC
+	unsigned long (*pax_open_kernel)(void);
+	unsigned long (*pax_close_kernel)(void);
+#endif
+
+} __no_randomize_layout;
 
 struct arch_spinlock;
 #ifdef CONFIG_SMP
@@ -318,11 +325,14 @@ struct pv_lock_ops {
 	struct paravirt_callee_save lock_spinning;
 	void (*unlock_kick)(struct arch_spinlock *lock, __ticket_t ticket);
 #endif /* !CONFIG_QUEUED_SPINLOCKS */
-};
+} __no_randomize_layout;
 
 /* This contains all the paravirt structures: we get a convenient
  * number for each function using the offset which we use to indicate
- * what to patch. */
+ * what to patch.
+ * shouldn't be randomized due to the "NEAT TRICK" in paravirt.c
+ */
+
 struct paravirt_patch_template {
 	struct pv_init_ops pv_init_ops;
 	struct pv_time_ops pv_time_ops;
@@ -330,7 +340,7 @@ struct paravirt_patch_template {
 	struct pv_irq_ops pv_irq_ops;
 	struct pv_mmu_ops pv_mmu_ops;
 	struct pv_lock_ops pv_lock_ops;
-};
+} __no_randomize_layout;
 
 extern struct pv_info pv_info;
 extern struct pv_init_ops pv_init_ops;
diff --git a/arch/x86/include/asm/pgalloc.h b/arch/x86/include/asm/pgalloc.h
index b6d425999..da6324e9f 100644
--- a/arch/x86/include/asm/pgalloc.h
+++ b/arch/x86/include/asm/pgalloc.h
@@ -63,6 +63,13 @@ static inline void pmd_populate_kernel(struct mm_struct *mm,
 				       pmd_t *pmd, pte_t *pte)
 {
 	paravirt_alloc_pte(mm, __pa(pte) >> PAGE_SHIFT);
+	set_pmd(pmd, __pmd(__pa(pte) | _KERNPG_TABLE));
+}
+
+static inline void pmd_populate_user(struct mm_struct *mm,
+				       pmd_t *pmd, pte_t *pte)
+{
+	paravirt_alloc_pte(mm, __pa(pte) >> PAGE_SHIFT);
 	set_pmd(pmd, __pmd(__pa(pte) | _PAGE_TABLE));
 }
 
@@ -112,12 +119,22 @@ static inline void __pmd_free_tlb(struct mmu_gather *tlb, pmd_t *pmd,
 
 #ifdef CONFIG_X86_PAE
 extern void pud_populate(struct mm_struct *mm, pud_t *pudp, pmd_t *pmd);
+static inline void pud_populate_kernel(struct mm_struct *mm, pud_t *pudp, pmd_t *pmd)
+{
+	pud_populate(mm, pudp, pmd);
+}
 #else	/* !CONFIG_X86_PAE */
 static inline void pud_populate(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
 {
 	paravirt_alloc_pmd(mm, __pa(pmd) >> PAGE_SHIFT);
 	set_pud(pud, __pud(_PAGE_TABLE | __pa(pmd)));
 }
+
+static inline void pud_populate_kernel(struct mm_struct *mm, pud_t *pud, pmd_t *pmd)
+{
+	paravirt_alloc_pmd(mm, __pa(pmd) >> PAGE_SHIFT);
+	set_pud(pud, __pud(_KERNPG_TABLE | __pa(pmd)));
+}
 #endif	/* CONFIG_X86_PAE */
 
 #if CONFIG_PGTABLE_LEVELS > 3
@@ -127,6 +144,12 @@ static inline void pgd_populate(struct mm_struct *mm, pgd_t *pgd, pud_t *pud)
 	set_pgd(pgd, __pgd(_PAGE_TABLE | __pa(pud)));
 }
 
+static inline void pgd_populate_kernel(struct mm_struct *mm, pgd_t *pgd, pud_t *pud)
+{
+	paravirt_alloc_pud(mm, __pa(pud) >> PAGE_SHIFT);
+	set_pgd(pgd, __pgd(_KERNPG_TABLE | __pa(pud)));
+}
+
 static inline pud_t *pud_alloc_one(struct mm_struct *mm, unsigned long addr)
 {
 	gfp_t gfp = GFP_KERNEL_ACCOUNT;
diff --git a/arch/x86/include/asm/pgtable-2level.h b/arch/x86/include/asm/pgtable-2level.h
index fd74a1195..35fd5afe9 100644
--- a/arch/x86/include/asm/pgtable-2level.h
+++ b/arch/x86/include/asm/pgtable-2level.h
@@ -18,7 +18,9 @@ static inline void native_set_pte(pte_t *ptep , pte_t pte)
 
 static inline void native_set_pmd(pmd_t *pmdp, pmd_t pmd)
 {
+	pax_open_kernel();
 	*pmdp = pmd;
+	pax_close_kernel();
 }
 
 static inline void native_set_pte_atomic(pte_t *ptep, pte_t pte)
diff --git a/arch/x86/include/asm/pgtable-3level.h b/arch/x86/include/asm/pgtable-3level.h
index cdaa58c9b..ae30f0d67 100644
--- a/arch/x86/include/asm/pgtable-3level.h
+++ b/arch/x86/include/asm/pgtable-3level.h
@@ -92,12 +92,16 @@ static inline void native_set_pte_atomic(pte_t *ptep, pte_t pte)
 
 static inline void native_set_pmd(pmd_t *pmdp, pmd_t pmd)
 {
+	pax_open_kernel();
 	set_64bit((unsigned long long *)(pmdp), native_pmd_val(pmd));
+	pax_close_kernel();
 }
 
 static inline void native_set_pud(pud_t *pudp, pud_t pud)
 {
+	pax_open_kernel();
 	set_64bit((unsigned long long *)(pudp), native_pud_val(pud));
+	pax_close_kernel();
 }
 
 /*
@@ -116,9 +120,12 @@ static inline void native_pte_clear(struct mm_struct *mm, unsigned long addr,
 static inline void native_pmd_clear(pmd_t *pmd)
 {
 	u32 *tmp = (u32 *)pmd;
+
+	pax_open_kernel();
 	*tmp = 0;
 	smp_wmb();
 	*(tmp + 1) = 0;
+	pax_close_kernel();
 }
 
 static inline void pud_clear(pud_t *pudp)
diff --git a/arch/x86/include/asm/pgtable.h b/arch/x86/include/asm/pgtable.h
index 437feb436..a4b25705d 100644
--- a/arch/x86/include/asm/pgtable.h
+++ b/arch/x86/include/asm/pgtable.h
@@ -54,6 +54,7 @@ extern struct mm_struct *pgd_page_get_mm(struct page *page);
 
 #ifndef __PAGETABLE_PUD_FOLDED
 #define set_pgd(pgdp, pgd)		native_set_pgd(pgdp, pgd)
+#define set_pgd_batched(pgdp, pgd)	native_set_pgd_batched(pgdp, pgd)
 #define pgd_clear(pgd)			native_pgd_clear(pgd)
 #endif
 
@@ -88,12 +89,53 @@ extern struct mm_struct *pgd_page_get_mm(struct page *page);
 
 #define arch_end_context_switch(prev)	do {} while(0)
 
+#define pax_open_kernel()	native_pax_open_kernel()
+#define pax_close_kernel()	native_pax_close_kernel()
 #endif	/* CONFIG_PARAVIRT */
 
+#define  __HAVE_ARCH_PAX_OPEN_KERNEL
+#define  __HAVE_ARCH_PAX_CLOSE_KERNEL
+
+#ifdef CONFIG_PAX_KERNEXEC
+static inline unsigned long native_pax_open_kernel(void)
+{
+	unsigned long cr0;
+
+	preempt_disable();
+	barrier();
+	cr0 = read_cr0() ^ X86_CR0_WP;
+	BUG_ON(cr0 & X86_CR0_WP);
+	write_cr0(cr0);
+	barrier();
+	return cr0 ^ X86_CR0_WP;
+}
+
+static inline unsigned long native_pax_close_kernel(void)
+{
+	unsigned long cr0;
+
+	barrier();
+	cr0 = read_cr0() ^ X86_CR0_WP;
+	BUG_ON(!(cr0 & X86_CR0_WP));
+	write_cr0(cr0);
+	barrier();
+	preempt_enable_no_resched();
+	return cr0 ^ X86_CR0_WP;
+}
+#else
+static inline unsigned long native_pax_open_kernel(void) { return 0; }
+static inline unsigned long native_pax_close_kernel(void) { return 0; }
+#endif
+
 /*
  * The following only work if pte_present() is true.
  * Undefined behaviour if not..
  */
+static inline int pte_user(pte_t pte)
+{
+	return pte_val(pte) & _PAGE_USER;
+}
+
 static inline int pte_dirty(pte_t pte)
 {
 	return pte_flags(pte) & _PAGE_DIRTY;
@@ -168,6 +210,11 @@ static inline unsigned long pud_pfn(pud_t pud)
 	return (pud_val(pud) & pud_pfn_mask(pud)) >> PAGE_SHIFT;
 }
 
+static inline unsigned long pgd_pfn(pgd_t pgd)
+{
+	return (pgd_val(pgd) & PTE_PFN_MASK) >> PAGE_SHIFT;
+}
+
 #define pte_page(pte)	pfn_to_page(pte_pfn(pte))
 
 static inline int pmd_large(pmd_t pte)
@@ -224,9 +271,29 @@ static inline pte_t pte_wrprotect(pte_t pte)
 	return pte_clear_flags(pte, _PAGE_RW);
 }
 
+static inline pte_t pte_mkread(pte_t pte)
+{
+	return __pte(pte_val(pte) | _PAGE_USER);
+}
+
 static inline pte_t pte_mkexec(pte_t pte)
 {
-	return pte_clear_flags(pte, _PAGE_NX);
+#ifdef CONFIG_X86_PAE
+	if (__supported_pte_mask & _PAGE_NX)
+		return pte_clear_flags(pte, _PAGE_NX);
+	else
+#endif
+		return pte_set_flags(pte, _PAGE_USER);
+}
+
+static inline pte_t pte_exprotect(pte_t pte)
+{
+#ifdef CONFIG_X86_PAE
+	if (__supported_pte_mask & _PAGE_NX)
+		return pte_set_flags(pte, _PAGE_NX);
+	else
+#endif
+		return pte_clear_flags(pte, _PAGE_USER);
 }
 
 static inline pte_t pte_mkdirty(pte_t pte)
@@ -431,7 +498,7 @@ static inline pgprot_t pgprot_modify(pgprot_t oldprot, pgprot_t newprot)
 
 #define canon_pgprot(p) __pgprot(massage_pgprot(p))
 
-static inline int is_new_memtype_allowed(u64 paddr, unsigned long size,
+static inline int is_new_memtype_allowed(u64 paddr, u64 size,
 					 enum page_cache_mode pcm,
 					 enum page_cache_mode new_pcm)
 {
@@ -474,6 +541,16 @@ pte_t *populate_extra_pte(unsigned long vaddr);
 #endif
 
 #ifndef __ASSEMBLY__
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+extern pgd_t cpu_pgd[NR_CPUS][2][PTRS_PER_PGD];
+enum cpu_pgd_type {kernel = 0, user = 1};
+static inline pgd_t *get_cpu_pgd(unsigned int cpu, enum cpu_pgd_type type)
+{
+	return cpu_pgd[cpu][type];
+}
+#endif
+
 #include <linux/mm_types.h>
 #include <linux/mmdebug.h>
 #include <linux/log2.h>
@@ -675,7 +752,7 @@ static inline unsigned long pgd_page_vaddr(pgd_t pgd)
  * Currently stuck as a macro due to indirect forward reference to
  * linux/mmzone.h's __section_mem_map_addr() definition:
  */
-#define pgd_page(pgd)		pfn_to_page(pgd_val(pgd) >> PAGE_SHIFT)
+#define pgd_page(pgd)		pfn_to_page((pgd_val(pgd) & PTE_PFN_MASK) >> PAGE_SHIFT)
 
 /* to find an entry in a page-table-directory. */
 static inline unsigned long pud_index(unsigned long address)
@@ -690,7 +767,7 @@ static inline pud_t *pud_offset(pgd_t *pgd, unsigned long address)
 
 static inline int pgd_bad(pgd_t pgd)
 {
-	return (pgd_flags(pgd) & ~_PAGE_USER) != _KERNPG_TABLE;
+	return (pgd_flags(pgd) & ~(_PAGE_USER | _PAGE_NX)) != _KERNPG_TABLE;
 }
 
 static inline int pgd_none(pgd_t pgd)
@@ -719,7 +796,12 @@ static inline int pgd_none(pgd_t pgd)
  * pgd_offset() returns a (pgd_t *)
  * pgd_index() is used get the offset into the pgd page's array of pgd_t's;
  */
-#define pgd_offset(mm, address) ((mm)->pgd + pgd_index((address)))
+#define pgd_offset(mm, address) ((mm)->pgd + pgd_index(address))
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+#define pgd_offset_cpu(cpu, type, address) (get_cpu_pgd(cpu, type) + pgd_index(address))
+#endif
+
 /*
  * a shortcut which implies the use of the kernel's pgd, instead
  * of a process's
@@ -730,6 +812,25 @@ static inline int pgd_none(pgd_t pgd)
 #define KERNEL_PGD_BOUNDARY	pgd_index(PAGE_OFFSET)
 #define KERNEL_PGD_PTRS		(PTRS_PER_PGD - KERNEL_PGD_BOUNDARY)
 
+#ifdef CONFIG_X86_32
+#define USER_PGD_PTRS		KERNEL_PGD_BOUNDARY
+#else
+#define TASK_SIZE_MAX_SHIFT CONFIG_TASK_SIZE_MAX_SHIFT
+#define USER_PGD_PTRS		(_AC(1,UL) << (TASK_SIZE_MAX_SHIFT - PGDIR_SHIFT))
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+#ifdef __ASSEMBLY__
+#define pax_user_shadow_base	pax_user_shadow_base(%rip)
+#else
+extern unsigned long pax_user_shadow_base;
+extern pgdval_t clone_pgd_mask;
+#endif
+#else
+#define pax_user_shadow_base	(0UL)
+#endif
+
+#endif
+
 #ifndef __ASSEMBLY__
 
 extern int direct_gbpages;
@@ -901,11 +1002,24 @@ static inline void pmdp_set_wrprotect(struct mm_struct *mm,
  * dst and src can be on the same page, but the range must not overlap,
  * and must not cross a page boundary.
  */
-static inline void clone_pgd_range(pgd_t *dst, pgd_t *src, int count)
+static inline void clone_pgd_range(pgd_t *dst, const pgd_t *src, int count)
 {
-       memcpy(dst, src, count * sizeof(pgd_t));
+	pax_open_kernel();
+	while (count--)
+		*dst++ = *src++;
+	pax_close_kernel();
 }
 
+#ifdef CONFIG_PAX_PER_CPU_PGD
+extern void __clone_user_pgds(pgd_t *dst, const pgd_t *src);
+#endif
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+extern void __shadow_user_pgds(pgd_t *dst, const pgd_t *src);
+#else
+static inline void __shadow_user_pgds(pgd_t *dst, const pgd_t *src) {}
+#endif
+
 #define PTE_SHIFT ilog2(PTRS_PER_PTE)
 static inline int page_level_shift(enum pg_level level)
 {
diff --git a/arch/x86/include/asm/pgtable_32.h b/arch/x86/include/asm/pgtable_32.h
index b6c0b4048..3535d4751 100644
--- a/arch/x86/include/asm/pgtable_32.h
+++ b/arch/x86/include/asm/pgtable_32.h
@@ -25,9 +25,6 @@
 struct mm_struct;
 struct vm_area_struct;
 
-extern pgd_t swapper_pg_dir[1024];
-extern pgd_t initial_page_table[1024];
-
 static inline void pgtable_cache_init(void) { }
 static inline void check_pgt_cache(void) { }
 void paging_init(void);
@@ -45,6 +42,12 @@ void paging_init(void);
 # include <asm/pgtable-2level.h>
 #endif
 
+extern pgd_t swapper_pg_dir[PTRS_PER_PGD];
+extern pgd_t initial_page_table[PTRS_PER_PGD];
+#ifdef CONFIG_X86_PAE
+extern pmd_t swapper_pm_dir[PTRS_PER_PGD][PTRS_PER_PMD];
+#endif
+
 #if defined(CONFIG_HIGHPTE)
 #define pte_offset_map(dir, address)					\
 	((pte_t *)kmap_atomic(pmd_page(*(dir))) +		\
@@ -59,12 +62,17 @@ void paging_init(void);
 /* Clear a kernel PTE and flush it from the TLB */
 #define kpte_clear_flush(ptep, vaddr)		\
 do {						\
+	pax_open_kernel();			\
 	pte_clear(&init_mm, (vaddr), (ptep));	\
+	pax_close_kernel();			\
 	__flush_tlb_one((vaddr));		\
 } while (0)
 
 #endif /* !__ASSEMBLY__ */
 
+#define HAVE_ARCH_UNMAPPED_AREA
+#define HAVE_ARCH_UNMAPPED_AREA_TOPDOWN
+
 /*
  * kern_addr_valid() is (1) for FLATMEM and (0) for
  * SPARSEMEM and DISCONTIGMEM
diff --git a/arch/x86/include/asm/pgtable_32_types.h b/arch/x86/include/asm/pgtable_32_types.h
index 9fb2f2bc8..8e18c70e2 100644
--- a/arch/x86/include/asm/pgtable_32_types.h
+++ b/arch/x86/include/asm/pgtable_32_types.h
@@ -8,7 +8,7 @@
  */
 #ifdef CONFIG_X86_PAE
 # include <asm/pgtable-3level_types.h>
-# define PMD_SIZE	(1UL << PMD_SHIFT)
+# define PMD_SIZE	(_AC(1, UL) << PMD_SHIFT)
 # define PMD_MASK	(~(PMD_SIZE - 1))
 #else
 # include <asm/pgtable-2level_types.h>
@@ -46,6 +46,28 @@ extern bool __vmalloc_start_set; /* set once high_memory is set */
 # define VMALLOC_END	(FIXADDR_START - 2 * PAGE_SIZE)
 #endif
 
+#ifdef CONFIG_PAX_KERNEXEC
+#ifndef __ASSEMBLY__
+extern unsigned char MODULES_EXEC_VADDR[];
+extern unsigned char MODULES_EXEC_END[];
+
+extern unsigned char __LOAD_PHYSICAL_ADDR[];
+#define LOAD_PHYSICAL_ADDR ((unsigned long)__LOAD_PHYSICAL_ADDR)
+static inline unsigned long __intentional_overflow(-1) ktla_ktva(unsigned long addr)
+{
+	return addr + LOAD_PHYSICAL_ADDR + PAGE_OFFSET;
+
+}
+static inline unsigned long __intentional_overflow(-1) ktva_ktla(unsigned long addr)
+{
+	return addr - LOAD_PHYSICAL_ADDR - PAGE_OFFSET;
+}
+#endif
+#else
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+#endif
+
 #define MODULES_VADDR	VMALLOC_START
 #define MODULES_END	VMALLOC_END
 #define MODULES_LEN	(MODULES_VADDR - MODULES_END)
diff --git a/arch/x86/include/asm/pgtable_64.h b/arch/x86/include/asm/pgtable_64.h
index 1cc82ece9..ba29fd88b 100644
--- a/arch/x86/include/asm/pgtable_64.h
+++ b/arch/x86/include/asm/pgtable_64.h
@@ -16,11 +16,17 @@
 
 extern pud_t level3_kernel_pgt[512];
 extern pud_t level3_ident_pgt[512];
+extern pud_t level3_vmalloc_start_pgt[4][512];
+extern pud_t level3_vmalloc_end_pgt[512];
+extern pud_t level3_vmemmap_pgt[512];
+extern pud_t level2_vmemmap_pgt[512];
 extern pmd_t level2_kernel_pgt[512];
 extern pmd_t level2_fixmap_pgt[512];
-extern pmd_t level2_ident_pgt[512];
-extern pte_t level1_fixmap_pgt[512];
-extern pgd_t init_level4_pgt[];
+extern pmd_t level2_ident_pgt[2][512];
+extern pte_t level1_modules_pgt[4][512];
+extern pte_t level1_fixmap_pgt[3][512];
+extern pte_t level1_vsyscall_pgt[512];
+extern pgd_t init_level4_pgt[512];
 
 #define swapper_pg_dir init_level4_pgt
 
@@ -62,7 +68,9 @@ static inline void native_set_pte_atomic(pte_t *ptep, pte_t pte)
 
 static inline void native_set_pmd(pmd_t *pmdp, pmd_t pmd)
 {
+	pax_open_kernel();
 	*pmdp = pmd;
+	pax_close_kernel();
 }
 
 static inline void native_pmd_clear(pmd_t *pmd)
@@ -98,7 +106,9 @@ static inline pmd_t native_pmdp_get_and_clear(pmd_t *xp)
 
 static inline void native_set_pud(pud_t *pudp, pud_t pud)
 {
+	pax_open_kernel();
 	*pudp = pud;
+	pax_close_kernel();
 }
 
 static inline void native_pud_clear(pud_t *pud)
@@ -108,6 +118,13 @@ static inline void native_pud_clear(pud_t *pud)
 
 static inline void native_set_pgd(pgd_t *pgdp, pgd_t pgd)
 {
+	pax_open_kernel();
+	*pgdp = pgd;
+	pax_close_kernel();
+}
+
+static inline void native_set_pgd_batched(pgd_t *pgdp, pgd_t pgd)
+{
 	*pgdp = pgd;
 }
 
diff --git a/arch/x86/include/asm/pgtable_64_types.h b/arch/x86/include/asm/pgtable_64_types.h
index 6fdef9eef..7cda9d5a8 100644
--- a/arch/x86/include/asm/pgtable_64_types.h
+++ b/arch/x86/include/asm/pgtable_64_types.h
@@ -67,11 +67,16 @@ typedef struct { pteval_t pte; } pte_t;
 #define MODULES_VADDR    (__START_KERNEL_map + KERNEL_IMAGE_SIZE)
 #define MODULES_END      _AC(0xffffffffff000000, UL)
 #define MODULES_LEN   (MODULES_END - MODULES_VADDR)
+#define MODULES_EXEC_VADDR MODULES_VADDR
+#define MODULES_EXEC_END MODULES_END
 #define ESPFIX_PGD_ENTRY _AC(-2, UL)
 #define ESPFIX_BASE_ADDR (ESPFIX_PGD_ENTRY << PGDIR_SHIFT)
 #define EFI_VA_START	 ( -4 * (_AC(1, UL) << 30))
 #define EFI_VA_END	 (-68 * (_AC(1, UL) << 30))
 
+#define ktla_ktva(addr)		(addr)
+#define ktva_ktla(addr)		(addr)
+
 #define EARLY_DYNAMIC_PAGE_TABLES	64
 
 #endif /* _ASM_X86_PGTABLE_64_DEFS_H */
diff --git a/arch/x86/include/asm/pgtable_types.h b/arch/x86/include/asm/pgtable_types.h
index f1218f512..b0cafcd67 100644
--- a/arch/x86/include/asm/pgtable_types.h
+++ b/arch/x86/include/asm/pgtable_types.h
@@ -112,10 +112,14 @@
 
 #if defined(CONFIG_X86_64) || defined(CONFIG_X86_PAE)
 #define _PAGE_NX	(_AT(pteval_t, 1) << _PAGE_BIT_NX)
+#ifdef CONFIG_PAX_SEGMEXEC
+#define _PAGE_DEVMAP	(_AT(pteval_t, 0))
+#else
 #define _PAGE_DEVMAP	(_AT(u64, 1) << _PAGE_BIT_DEVMAP)
 #define __HAVE_ARCH_PTE_DEVMAP
+#endif
 #else
-#define _PAGE_NX	(_AT(pteval_t, 0))
+#define _PAGE_NX	(_AT(pteval_t, 1) << _PAGE_BIT_SOFTW2)
 #define _PAGE_DEVMAP	(_AT(pteval_t, 0))
 #endif
 
@@ -176,6 +180,9 @@ enum page_cache_mode {
 #define PAGE_READONLY_EXEC	__pgprot(_PAGE_PRESENT | _PAGE_USER |	\
 					 _PAGE_ACCESSED)
 
+#define PAGE_READONLY_NOEXEC PAGE_READONLY
+#define PAGE_SHARED_NOEXEC PAGE_SHARED
+
 #define __PAGE_KERNEL_EXEC						\
 	(_PAGE_PRESENT | _PAGE_RW | _PAGE_DIRTY | _PAGE_ACCESSED | _PAGE_GLOBAL)
 #define __PAGE_KERNEL		(__PAGE_KERNEL_EXEC | _PAGE_NX)
@@ -183,7 +190,7 @@ enum page_cache_mode {
 #define __PAGE_KERNEL_RO		(__PAGE_KERNEL & ~_PAGE_RW)
 #define __PAGE_KERNEL_RX		(__PAGE_KERNEL_EXEC & ~_PAGE_RW)
 #define __PAGE_KERNEL_NOCACHE		(__PAGE_KERNEL | _PAGE_NOCACHE)
-#define __PAGE_KERNEL_VSYSCALL		(__PAGE_KERNEL_RX | _PAGE_USER)
+#define __PAGE_KERNEL_VSYSCALL		(__PAGE_KERNEL_RO | _PAGE_USER)
 #define __PAGE_KERNEL_VVAR		(__PAGE_KERNEL_RO | _PAGE_USER)
 #define __PAGE_KERNEL_LARGE		(__PAGE_KERNEL | _PAGE_PSE)
 #define __PAGE_KERNEL_LARGE_EXEC	(__PAGE_KERNEL_EXEC | _PAGE_PSE)
@@ -229,7 +236,7 @@ enum page_cache_mode {
 #ifdef CONFIG_X86_64
 #define __PAGE_KERNEL_IDENT_LARGE_EXEC	__PAGE_KERNEL_LARGE_EXEC
 #else
-#define PTE_IDENT_ATTR	 0x003		/* PRESENT+RW */
+#define PTE_IDENT_ATTR	 0x063		/* PRESENT+RW+DIRTY+ACCESSED */
 #define PDE_IDENT_ATTR	 0x063		/* PRESENT+RW+DIRTY+ACCESSED */
 #define PGD_IDENT_ATTR	 0x001		/* PRESENT (no other attributes) */
 #endif
@@ -271,7 +278,17 @@ static inline pgdval_t pgd_flags(pgd_t pgd)
 {
 	return native_pgd_val(pgd) & PTE_FLAGS_MASK;
 }
+#endif
+
+#if CONFIG_PGTABLE_LEVELS == 3
+#include <asm-generic/pgtable-nopud.h>
+#endif
 
+#if CONFIG_PGTABLE_LEVELS == 2
+#include <asm-generic/pgtable-nopmd.h>
+#endif
+
+#ifndef __ASSEMBLY__
 #if CONFIG_PGTABLE_LEVELS > 3
 typedef struct { pudval_t pud; } pud_t;
 
@@ -285,8 +302,6 @@ static inline pudval_t native_pud_val(pud_t pud)
 	return pud.pud;
 }
 #else
-#include <asm-generic/pgtable-nopud.h>
-
 static inline pudval_t native_pud_val(pud_t pud)
 {
 	return native_pgd_val(pud.pgd);
@@ -306,8 +321,6 @@ static inline pmdval_t native_pmd_val(pmd_t pmd)
 	return pmd.pmd;
 }
 #else
-#include <asm-generic/pgtable-nopmd.h>
-
 static inline pmdval_t native_pmd_val(pmd_t pmd)
 {
 	return native_pgd_val(pmd.pud.pgd);
@@ -424,7 +437,6 @@ typedef struct page *pgtable_t;
 
 extern pteval_t __supported_pte_mask;
 extern void set_nx(void);
-extern int nx_enabled;
 
 #define pgprot_writecombine	pgprot_writecombine
 extern pgprot_t pgprot_writecombine(pgprot_t prot);
diff --git a/arch/x86/include/asm/pmem.h b/arch/x86/include/asm/pmem.h
index 643eba42d..0dbfcf537 100644
--- a/arch/x86/include/asm/pmem.h
+++ b/arch/x86/include/asm/pmem.h
@@ -38,7 +38,7 @@ static inline void arch_memcpy_to_pmem(void *dst, const void *src, size_t n)
 	 * fault) we would have already reported a general protection fault
 	 * before the WARN+BUG.
 	 */
-	rem = __copy_from_user_inatomic_nocache(dst, (void __user *) src, n);
+	rem = __copy_from_user_inatomic_nocache(dst, (void __force_user *) src, n);
 	if (WARN(rem, "%s: fault copying %p <- %p unwritten: %d\n",
 				__func__, dst, src, rem))
 		BUG();
diff --git a/arch/x86/include/asm/preempt.h b/arch/x86/include/asm/preempt.h
index 17f218645..f39430785 100644
--- a/arch/x86/include/asm/preempt.h
+++ b/arch/x86/include/asm/preempt.h
@@ -81,7 +81,7 @@ static __always_inline void __preempt_count_sub(int val)
  */
 static __always_inline bool __preempt_count_dec_and_test(void)
 {
-	GEN_UNARY_RMWcc("decl", __preempt_count, __percpu_arg(0), e);
+	GEN_UNARY_RMWcc("decl", __preempt_count, -4, __percpu_arg(0), e);
 }
 
 /*
diff --git a/arch/x86/include/asm/processor.h b/arch/x86/include/asm/processor.h
index 63def9537..3d8c20343 100644
--- a/arch/x86/include/asm/processor.h
+++ b/arch/x86/include/asm/processor.h
@@ -135,7 +135,7 @@ struct cpuinfo_x86 {
 	/* Index into per_cpu list: */
 	u16			cpu_index;
 	u32			microcode;
-};
+} __randomize_layout;
 
 #define X86_VENDOR_INTEL	0
 #define X86_VENDOR_CYRIX	1
@@ -205,9 +205,21 @@ static inline void native_cpuid(unsigned int *eax, unsigned int *ebx,
 	    : "memory");
 }
 
+/* invpcid (%rdx),%rax */
+#define __ASM_INVPCID ".byte 0x66,0x0f,0x38,0x82,0x02"
+
+#define INVPCID_SINGLE_ADDRESS	0UL
+#define INVPCID_SINGLE_CONTEXT	1UL
+#define INVPCID_ALL_GLOBAL	2UL
+#define INVPCID_ALL_NONGLOBAL	3UL
+
+#define PCID_KERNEL		0UL
+#define PCID_USER		1UL
+#define PCID_NOFLUSH		(1UL << 63)
+
 static inline void load_cr3(pgd_t *pgdir)
 {
-	write_cr3(__pa(pgdir));
+	write_cr3(__pa(pgdir) | PCID_KERNEL);
 }
 
 #ifdef CONFIG_X86_32
@@ -307,11 +319,9 @@ struct tss_struct {
 
 } ____cacheline_aligned;
 
-DECLARE_PER_CPU_SHARED_ALIGNED(struct tss_struct, cpu_tss);
+extern struct tss_struct cpu_tss[NR_CPUS];
 
-#ifdef CONFIG_X86_32
 DECLARE_PER_CPU(unsigned long, cpu_current_top_of_stack);
-#endif
 
 /*
  * Save the original ist values for checking stack pointers during debugging
@@ -388,6 +398,7 @@ struct thread_struct {
 	unsigned short		ds;
 	unsigned short		fsindex;
 	unsigned short		gsindex;
+	unsigned short		ss;
 #endif
 #ifdef CONFIG_X86_32
 	unsigned long		ip;
@@ -404,6 +415,9 @@ struct thread_struct {
 	unsigned long gs;
 #endif
 
+	/* Floating point and extended processor state */
+	struct fpu		fpu;
+
 	/* Save middle states of ptrace breakpoints */
 	struct perf_event	*ptrace_bps[HBP_NUM];
 	/* Debug status used for traps, single steps, etc... */
@@ -424,18 +438,9 @@ struct thread_struct {
 	/* Max allowed port in the bitmap, in bytes: */
 	unsigned		io_bitmap_max;
 
-	mm_segment_t		addr_limit;
-
 	unsigned int		sig_on_uaccess_err:1;
 	unsigned int		uaccess_err:1;	/* uaccess failed */
-
-	/* Floating point and extended processor state */
-	struct fpu		fpu;
-	/*
-	 * WARNING: 'fpu' is dynamically-sized.  It *MUST* be at
-	 * the end.
-	 */
-};
+} __randomize_layout;
 
 /*
  * Set IOPL bits in EFLAGS from given mask
@@ -478,12 +483,8 @@ static inline void native_swapgs(void)
 
 static inline unsigned long current_top_of_stack(void)
 {
-#ifdef CONFIG_X86_64
-	return this_cpu_read_stable(cpu_tss.x86_tss.sp0);
-#else
 	/* sp0 on x86_32 is special in and around vm86 mode. */
 	return this_cpu_read_stable(cpu_current_top_of_stack);
-#endif
 }
 
 #ifdef CONFIG_PARAVIRT
@@ -708,20 +709,29 @@ static inline void spin_lock_prefetch(const void *x)
 #define TOP_OF_INIT_STACK ((unsigned long)&init_stack + sizeof(init_stack) - \
 			   TOP_OF_KERNEL_STACK_PADDING)
 
+extern union fpregs_state init_fpregs_state;
+
 #ifdef CONFIG_X86_32
 /*
  * User space process size: 3GB (default).
  */
 #define TASK_SIZE		PAGE_OFFSET
 #define TASK_SIZE_MAX		TASK_SIZE
+
+#ifdef CONFIG_PAX_SEGMEXEC
+#define SEGMEXEC_TASK_SIZE	(TASK_SIZE / 2)
+#define STACK_TOP		((current->mm->pax_flags & MF_PAX_SEGMEXEC)?SEGMEXEC_TASK_SIZE:TASK_SIZE)
+#else
 #define STACK_TOP		TASK_SIZE
-#define STACK_TOP_MAX		STACK_TOP
+#endif
+
+#define STACK_TOP_MAX		TASK_SIZE
 
 #define INIT_THREAD  {							  \
 	.sp0			= TOP_OF_INIT_STACK,			  \
 	.sysenter_cs		= __KERNEL_CS,				  \
 	.io_bitmap_ptr		= NULL,					  \
-	.addr_limit		= KERNEL_DS,				  \
+	.fpu.state		= &init_fpregs_state,			  \
 }
 
 extern unsigned long thread_saved_pc(struct task_struct *tsk);
@@ -736,12 +746,7 @@ extern unsigned long thread_saved_pc(struct task_struct *tsk);
  * "struct pt_regs" is possible, but they may contain the
  * completely wrong values.
  */
-#define task_pt_regs(task) \
-({									\
-	unsigned long __ptr = (unsigned long)task_stack_page(task);	\
-	__ptr += THREAD_SIZE - TOP_OF_KERNEL_STACK_PADDING;		\
-	((struct pt_regs *)__ptr) - 1;					\
-})
+#define task_pt_regs(tsk)	((struct pt_regs *)(tsk)->thread.sp0 - 1)
 
 #define KSTK_ESP(task)		(task_pt_regs(task)->sp)
 
@@ -755,13 +760,13 @@ extern unsigned long thread_saved_pc(struct task_struct *tsk);
  * particular problem by preventing anything from being mapped
  * at the maximum canonical address.
  */
-#define TASK_SIZE_MAX	((1UL << 47) - PAGE_SIZE)
+#define TASK_SIZE_MAX	((1UL << TASK_SIZE_MAX_SHIFT) - PAGE_SIZE)
 
 /* This decides where the kernel will search for a free chunk of vm
  * space during mmap's.
  */
 #define IA32_PAGE_OFFSET	((current->personality & ADDR_LIMIT_3GB) ? \
-					0xc0000000 : 0xFFFFe000)
+					0xc0000000 : 0xFFFFf000)
 
 #define TASK_SIZE		(test_thread_flag(TIF_ADDR32) ? \
 					IA32_PAGE_OFFSET : TASK_SIZE_MAX)
@@ -773,7 +778,7 @@ extern unsigned long thread_saved_pc(struct task_struct *tsk);
 
 #define INIT_THREAD  {						\
 	.sp0			= TOP_OF_INIT_STACK,		\
-	.addr_limit		= KERNEL_DS,			\
+	.fpu.state		= &init_fpregs_state,		\
 }
 
 /*
@@ -796,6 +801,10 @@ extern void start_thread(struct pt_regs *regs, unsigned long new_ip,
  */
 #define TASK_UNMAPPED_BASE	(PAGE_ALIGN(TASK_SIZE / 3))
 
+#ifdef CONFIG_PAX_SEGMEXEC
+#define SEGMEXEC_TASK_UNMAPPED_BASE	(PAGE_ALIGN(SEGMEXEC_TASK_SIZE / 3))
+#endif
+
 #define KSTK_EIP(task)		(task_pt_regs(task)->ip)
 
 /* Get/set a process' ability to use the timestamp counter instruction */
@@ -841,7 +850,7 @@ static inline uint32_t hypervisor_cpuid_base(const char *sig, uint32_t leaves)
 	return 0;
 }
 
-extern unsigned long arch_align_stack(unsigned long sp);
+#define arch_align_stack(x) ((x) & ~0xfUL)
 extern void free_init_pages(char *what, unsigned long begin, unsigned long end);
 
 void default_idle(void);
@@ -851,6 +860,6 @@ bool xen_set_default_idle(void);
 #define xen_set_default_idle 0
 #endif
 
-void stop_this_cpu(void *dummy);
+void stop_this_cpu(void *dummy) __noreturn;
 void df_debug(struct pt_regs *regs, long error_code);
 #endif /* _ASM_X86_PROCESSOR_H */
diff --git a/arch/x86/include/asm/ptrace.h b/arch/x86/include/asm/ptrace.h
index 2b5d686ea..8693ed0dd 100644
--- a/arch/x86/include/asm/ptrace.h
+++ b/arch/x86/include/asm/ptrace.h
@@ -118,15 +118,16 @@ static inline int v8086_mode(struct pt_regs *regs)
 #ifdef CONFIG_X86_64
 static inline bool user_64bit_mode(struct pt_regs *regs)
 {
+	unsigned long cs = regs->cs & 0xffff;
 #ifndef CONFIG_PARAVIRT
 	/*
 	 * On non-paravirt systems, this is the only long mode CPL 3
 	 * selector.  We do not allow long mode selectors in the LDT.
 	 */
-	return regs->cs == __USER_CS;
+	return cs == __USER_CS;
 #else
 	/* Headers are too twisted for this to go in paravirt.h. */
-	return regs->cs == __USER_CS || regs->cs == pv_info.extra_user_64bit_cs;
+	return cs == __USER_CS || cs == pv_info.extra_user_64bit_cs;
 #endif
 }
 
@@ -173,9 +174,11 @@ static inline unsigned long regs_get_register(struct pt_regs *regs,
 	 * Traps from the kernel do not save sp and ss.
 	 * Use the helper function to retrieve sp.
 	 */
-	if (offset == offsetof(struct pt_regs, sp) &&
-	    regs->cs == __KERNEL_CS)
-		return kernel_stack_pointer(regs);
+	if (offset == offsetof(struct pt_regs, sp)) {
+		unsigned long cs = regs->cs & 0xffff;
+		if (cs == __KERNEL_CS || cs == __KERNEXEC_KERNEL_CS)
+			return kernel_stack_pointer(regs);
+	}
 #endif
 	return *(unsigned long *)((unsigned long)regs + offset);
 }
diff --git a/arch/x86/include/asm/realmode.h b/arch/x86/include/asm/realmode.h
index b2988c0ed..421f625fc 100644
--- a/arch/x86/include/asm/realmode.h
+++ b/arch/x86/include/asm/realmode.h
@@ -22,16 +22,14 @@ struct real_mode_header {
 #endif
 	/* APM/BIOS reboot */
 	u32	machine_real_restart_asm;
-#ifdef CONFIG_X86_64
 	u32	machine_real_restart_seg;
-#endif
 };
 
 /* This must match data at trampoline_32/64.S */
 struct trampoline_header {
 #ifdef CONFIG_X86_32
 	u32 start;
-	u16 gdt_pad;
+	u16 boot_cs;
 	u16 gdt_limit;
 	u32 gdt_base;
 #else
diff --git a/arch/x86/include/asm/reboot.h b/arch/x86/include/asm/reboot.h
index 2cb1cc253..787d52465 100644
--- a/arch/x86/include/asm/reboot.h
+++ b/arch/x86/include/asm/reboot.h
@@ -6,13 +6,13 @@
 struct pt_regs;
 
 struct machine_ops {
-	void (*restart)(char *cmd);
-	void (*halt)(void);
-	void (*power_off)(void);
+	void (* __noreturn restart)(char *cmd);
+	void (* __noreturn halt)(void);
+	void (* __noreturn power_off)(void);
 	void (*shutdown)(void);
 	void (*crash_shutdown)(struct pt_regs *);
-	void (*emergency_restart)(void);
-};
+	void (* __noreturn emergency_restart)(void);
+} __no_const;
 
 extern struct machine_ops machine_ops;
 
diff --git a/arch/x86/include/asm/rmwcc.h b/arch/x86/include/asm/rmwcc.h
index 661dd3056..e804f848d 100644
--- a/arch/x86/include/asm/rmwcc.h
+++ b/arch/x86/include/asm/rmwcc.h
@@ -5,7 +5,19 @@
 
 /* Use asm goto */
 
-#define __GEN_RMWcc(fullop, var, cc, ...)				\
+#define __GEN_RMWcc(fullop, var, size, cc, ...)				\
+do {									\
+	asm_volatile_goto (fullop					\
+			"\n\t"__PAX_REFCOUNT(size)			\
+			";j" #cc " %l[cc_label]"			\
+			: : [counter] "m" (var), ## __VA_ARGS__ 	\
+			: "memory", "cc", "cx" : cc_label);		\
+	return 0;							\
+cc_label:								\
+	return 1;							\
+} while (0)
+
+#define __GEN_RMWcc_unchecked(fullop, var, cc, ...)			\
 do {									\
 	asm_volatile_goto (fullop "; j" #cc " %l[cc_label]"		\
 			: : "m" (var), ## __VA_ARGS__ 			\
@@ -15,17 +27,34 @@ cc_label:								\
 	return 1;							\
 } while (0)
 
-#define GEN_UNARY_RMWcc(op, var, arg0, cc) 				\
-	__GEN_RMWcc(op " " arg0, var, cc)
+#define GEN_UNARY_RMWcc(op, var, size, arg0, cc) 			\
+	__GEN_RMWcc(op " " arg0, var, size, cc)
+
+#define GEN_UNARY_RMWcc_unchecked(op, var, arg0, cc) 			\
+	__GEN_RMWcc_unchecked(op " " arg0, var, cc)
 
-#define GEN_BINARY_RMWcc(op, var, vcon, val, arg0, cc)			\
-	__GEN_RMWcc(op " %1, " arg0, var, cc, vcon (val))
+#define GEN_BINARY_RMWcc(op, var, size, vcon, val, arg0, cc)		\
+	__GEN_RMWcc(op " %1, " arg0, var, size, cc, vcon (val))
+
+#define GEN_BINARY_RMWcc_unchecked(op, var, vcon, val, arg0, cc)	\
+	__GEN_RMWcc_unchecked(op " %1, " arg0, var, cc, vcon (val))
 
 #else /* defined(__GCC_ASM_FLAG_OUTPUTS__) || !defined(CC_HAVE_ASM_GOTO) */
 
 /* Use flags output or a set instruction */
 
-#define __GEN_RMWcc(fullop, var, cc, ...)				\
+#define __GEN_RMWcc(fullop, var, size, cc, ...)				\
+do {									\
+	bool c;								\
+	asm volatile (fullop 						\
+			"\n\t"__PAX_REFCOUNT(size)			\
+			";" CC_SET(cc)					\
+			: [counter] "+m" (var), CC_OUT(cc) (c)		\
+			: __VA_ARGS__ : "memory", "cc", "cx");		\
+	return c != 0;							\
+} while (0)
+
+#define __GEN_RMWcc_unchecked(fullop, var, cc, ...)			\
 do {									\
 	bool c;								\
 	asm volatile (fullop ";" CC_SET(cc)				\
@@ -34,11 +63,17 @@ do {									\
 	return c;							\
 } while (0)
 
-#define GEN_UNARY_RMWcc(op, var, arg0, cc)				\
-	__GEN_RMWcc(op " " arg0, var, cc)
+#define GEN_UNARY_RMWcc(op, var, size, arg0, cc)			\
+	__GEN_RMWcc(op " " arg0, var, size, cc)
+
+#define GEN_UNARY_RMWcc_unchecked(op, var, arg0, cc)			\
+	__GEN_RMWcc_unchecked(op " " arg0, var, cc)
+
+#define GEN_BINARY_RMWcc(op, var, size, vcon, val, arg0, cc)		\
+	__GEN_RMWcc(op " %2, " arg0, var, size, cc, vcon (val))
 
-#define GEN_BINARY_RMWcc(op, var, vcon, val, arg0, cc)			\
-	__GEN_RMWcc(op " %2, " arg0, var, cc, vcon (val))
+#define GEN_BINARY_RMWcc_unchecked(op, var, vcon, val, arg0, cc)	\
+	__GEN_RMWcc_unchecked(op " %2, " arg0, var, cc, vcon (val))
 
 #endif /* defined(__GCC_ASM_FLAG_OUTPUTS__) || !defined(CC_HAVE_ASM_GOTO) */
 
diff --git a/arch/x86/include/asm/rwsem.h b/arch/x86/include/asm/rwsem.h
index 8dbc762ad..5ff77d9b2 100644
--- a/arch/x86/include/asm/rwsem.h
+++ b/arch/x86/include/asm/rwsem.h
@@ -64,14 +64,15 @@ static inline void __down_read(struct rw_semaphore *sem)
 {
 	asm volatile("# beginning down_read\n\t"
 		     LOCK_PREFIX _ASM_INC "(%1)\n\t"
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)
 		     /* adds 0x00000001 */
 		     "  jns        1f\n"
 		     "  call call_rwsem_down_read_failed\n"
 		     "1:\n\t"
 		     "# ending down_read\n\t"
-		     : "+m" (sem->count)
+		     : [counter] "+m" (sem->count)
 		     : "a" (sem)
-		     : "memory", "cc");
+		     : "memory", "cc", "cx");
 }
 
 /*
@@ -85,14 +86,15 @@ static inline bool __down_read_trylock(struct rw_semaphore *sem)
 		     "1:\n\t"
 		     "  mov          %1,%2\n\t"
 		     "  add          %3,%2\n\t"
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)
 		     "  jle	     2f\n\t"
 		     LOCK_PREFIX "  cmpxchg  %2,%0\n\t"
 		     "  jnz	     1b\n\t"
 		     "2:\n\t"
 		     "# ending __down_read_trylock\n\t"
-		     : "+m" (sem->count), "=&a" (result), "=&r" (tmp)
+		     : [counter] "+m" (sem->count), "=&a" (result), "=&r" (tmp)
 		     : "i" (RWSEM_ACTIVE_READ_BIAS)
-		     : "memory", "cc");
+		     : "memory", "cc", "cx");
 	return result >= 0;
 }
 
@@ -105,6 +107,7 @@ static inline bool __down_read_trylock(struct rw_semaphore *sem)
 	struct rw_semaphore* ret;			\
 	asm volatile("# beginning down_write\n\t"	\
 		     LOCK_PREFIX "  xadd      %1,(%3)\n\t"	\
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)\
 		     /* adds 0xffff0001, returns the old value */ \
 		     "  test " __ASM_SEL(%w1,%k1) "," __ASM_SEL(%w1,%k1) "\n\t" \
 		     /* was the active mask 0 before? */\
@@ -112,9 +115,9 @@ static inline bool __down_read_trylock(struct rw_semaphore *sem)
 		     "  call " slow_path "\n"		\
 		     "1:\n"				\
 		     "# ending down_write"		\
-		     : "+m" (sem->count), "=d" (tmp), "=a" (ret)	\
+		     : [counter] "+m" (sem->count), "=d" (tmp), "=a" (ret)\
 		     : "a" (sem), "1" (RWSEM_ACTIVE_WRITE_BIAS) \
-		     : "memory", "cc");			\
+		     : "memory", "cc", "cx");		\
 	ret;						\
 })
 
@@ -146,15 +149,16 @@ static inline bool __down_write_trylock(struct rw_semaphore *sem)
 		     "  jnz          2f\n\t"
 		     "  mov          %1,%2\n\t"
 		     "  add          %4,%2\n\t"
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)
 		     LOCK_PREFIX "  cmpxchg  %2,%0\n\t"
 		     "  jnz	     1b\n\t"
 		     "2:\n\t"
 		     CC_SET(e)
 		     "# ending __down_write_trylock\n\t"
-		     : "+m" (sem->count), "=&a" (tmp0), "=&r" (tmp1),
+		     : [counter] "+m" (sem->count), "=&a" (tmp0), "=&r" (tmp1),
 		       CC_OUT(e) (result)
 		     : "er" (RWSEM_ACTIVE_WRITE_BIAS)
-		     : "memory", "cc");
+		     : "memory", "cc", "cx");
 	return result;
 }
 
@@ -166,14 +170,15 @@ static inline void __up_read(struct rw_semaphore *sem)
 	long tmp;
 	asm volatile("# beginning __up_read\n\t"
 		     LOCK_PREFIX "  xadd      %1,(%2)\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(BITS_PER_LONG/8)
 		     /* subtracts 1, returns the old value */
 		     "  jns        1f\n\t"
 		     "  call call_rwsem_wake\n" /* expects old value in %edx */
 		     "1:\n"
 		     "# ending __up_read\n"
-		     : "+m" (sem->count), "=d" (tmp)
+		     : [counter] "+m" (sem->count), "=d" (tmp)
 		     : "a" (sem), "1" (-RWSEM_ACTIVE_READ_BIAS)
-		     : "memory", "cc");
+		     : "memory", "cc", "cx");
 }
 
 /*
@@ -184,14 +189,15 @@ static inline void __up_write(struct rw_semaphore *sem)
 	long tmp;
 	asm volatile("# beginning __up_write\n\t"
 		     LOCK_PREFIX "  xadd      %1,(%2)\n\t"
+		     PAX_REFCOUNT_UNDERFLOW(BITS_PER_LONG/8)
 		     /* subtracts 0xffff0001, returns the old value */
 		     "  jns        1f\n\t"
 		     "  call call_rwsem_wake\n" /* expects old value in %edx */
 		     "1:\n\t"
 		     "# ending __up_write\n"
-		     : "+m" (sem->count), "=d" (tmp)
+		     : [counter] "+m" (sem->count), "=d" (tmp)
 		     : "a" (sem), "1" (-RWSEM_ACTIVE_WRITE_BIAS)
-		     : "memory", "cc");
+		     : "memory", "cc", "cx");
 }
 
 /*
@@ -201,6 +207,7 @@ static inline void __downgrade_write(struct rw_semaphore *sem)
 {
 	asm volatile("# beginning __downgrade_write\n\t"
 		     LOCK_PREFIX _ASM_ADD "%2,(%1)\n\t"
+		     PAX_REFCOUNT_OVERFLOW(BITS_PER_LONG/8)
 		     /*
 		      * transitions 0xZZZZ0001 -> 0xYYYY0001 (i386)
 		      *     0xZZZZZZZZ00000001 -> 0xYYYYYYYY00000001 (x86_64)
@@ -209,9 +216,9 @@ static inline void __downgrade_write(struct rw_semaphore *sem)
 		     "  call call_rwsem_downgrade_wake\n"
 		     "1:\n\t"
 		     "# ending __downgrade_write\n"
-		     : "+m" (sem->count)
+		     : [counter] "+m" (sem->count)
 		     : "a" (sem), "er" (-RWSEM_WAITING_BIAS)
-		     : "memory", "cc");
+		     : "memory", "cc", "cx");
 }
 
 #endif /* __KERNEL__ */
diff --git a/arch/x86/include/asm/segment.h b/arch/x86/include/asm/segment.h
index 1549caa09..aa9ebe12f 100644
--- a/arch/x86/include/asm/segment.h
+++ b/arch/x86/include/asm/segment.h
@@ -83,14 +83,20 @@
  *  26 - ESPFIX small SS
  *  27 - per-cpu			[ offset to per-cpu data area ]
  *  28 - stack_canary-20		[ for stack protector ]		<=== cacheline #8
- *  29 - unused
- *  30 - unused
+ *  29 - PCI BIOS CS
+ *  30 - PCI BIOS DS
  *  31 - TSS for double fault handler
  */
+#define GDT_ENTRY_KERNEXEC_EFI_CS	(1)
+#define GDT_ENTRY_KERNEXEC_EFI_DS	(2)
+#define __KERNEXEC_EFI_CS	(GDT_ENTRY_KERNEXEC_EFI_CS*8)
+#define __KERNEXEC_EFI_DS	(GDT_ENTRY_KERNEXEC_EFI_DS*8)
+
 #define GDT_ENTRY_TLS_MIN		6
 #define GDT_ENTRY_TLS_MAX 		(GDT_ENTRY_TLS_MIN + GDT_ENTRY_TLS_ENTRIES - 1)
 
 #define GDT_ENTRY_KERNEL_CS		12
+#define GDT_ENTRY_KERNEXEC_KERNEL_CS	4
 #define GDT_ENTRY_KERNEL_DS		13
 #define GDT_ENTRY_DEFAULT_USER_CS	14
 #define GDT_ENTRY_DEFAULT_USER_DS	15
@@ -107,6 +113,12 @@
 #define GDT_ENTRY_PERCPU		27
 #define GDT_ENTRY_STACK_CANARY		28
 
+#define GDT_ENTRY_PCIBIOS_CS		29
+#define __PCIBIOS_DS (GDT_ENTRY_PCIBIOS_DS * 8)
+
+#define GDT_ENTRY_PCIBIOS_DS		30
+#define __PCIBIOS_CS (GDT_ENTRY_PCIBIOS_CS * 8)
+
 #define GDT_ENTRY_DOUBLEFAULT_TSS	31
 
 /*
@@ -119,6 +131,7 @@
  */
 
 #define __KERNEL_CS			(GDT_ENTRY_KERNEL_CS*8)
+#define __KERNEXEC_KERNEL_CS		(GDT_ENTRY_KERNEXEC_KERNEL_CS*8)
 #define __KERNEL_DS			(GDT_ENTRY_KERNEL_DS*8)
 #define __USER_DS			(GDT_ENTRY_DEFAULT_USER_DS*8 + 3)
 #define __USER_CS			(GDT_ENTRY_DEFAULT_USER_CS*8 + 3)
@@ -130,7 +143,7 @@
 #define PNP_CS16			(GDT_ENTRY_PNPBIOS_CS16*8)
 
 /* "Is this PNP code selector (PNP_CS32 or PNP_CS16)?" */
-#define SEGMENT_IS_PNP_CODE(x)		(((x) & 0xf4) == PNP_CS32)
+#define SEGMENT_IS_PNP_CODE(x)		(((x) & 0xFFFCU) == PNP_CS32 || ((x) & 0xFFFCU) == PNP_CS16)
 
 /* data segment for BIOS: */
 #define PNP_DS				(GDT_ENTRY_PNPBIOS_DS*8)
@@ -177,6 +190,8 @@
 #define GDT_ENTRY_DEFAULT_USER_DS	5
 #define GDT_ENTRY_DEFAULT_USER_CS	6
 
+#define GDT_ENTRY_KERNEXEC_KERNEL_CS	7
+
 /* Needs two entries */
 #define GDT_ENTRY_TSS			8
 /* Needs two entries */
@@ -188,10 +203,12 @@
 /* Abused to load per CPU data from limit */
 #define GDT_ENTRY_PER_CPU		15
 
+#define GDT_ENTRY_UDEREF_KERNEL_DS	16
+
 /*
  * Number of entries in the GDT table:
  */
-#define GDT_ENTRIES			16
+#define GDT_ENTRIES			17
 
 /*
  * Segment selector values corresponding to the above entries:
@@ -201,7 +218,9 @@
  */
 #define __KERNEL32_CS			(GDT_ENTRY_KERNEL32_CS*8)
 #define __KERNEL_CS			(GDT_ENTRY_KERNEL_CS*8)
+#define __KERNEXEC_KERNEL_CS		(GDT_ENTRY_KERNEXEC_KERNEL_CS*8)
 #define __KERNEL_DS			(GDT_ENTRY_KERNEL_DS*8)
+#define __UDEREF_KERNEL_DS		(GDT_ENTRY_UDEREF_KERNEL_DS*8)
 #define __USER32_CS			(GDT_ENTRY_DEFAULT_USER32_CS*8 + 3)
 #define __USER_DS			(GDT_ENTRY_DEFAULT_USER_DS*8 + 3)
 #define __USER32_DS			__USER_DS
diff --git a/arch/x86/include/asm/setup.h b/arch/x86/include/asm/setup.h
index ac1d5da14..6c4be50ca 100644
--- a/arch/x86/include/asm/setup.h
+++ b/arch/x86/include/asm/setup.h
@@ -61,6 +61,7 @@ static inline void x86_ce4100_early_setup(void) { }
 #ifndef _SETUP
 
 #include <asm/espfix.h>
+#include <asm/uaccess.h>
 #include <linux/kernel.h>
 
 /*
@@ -76,7 +77,7 @@ static inline bool kaslr_enabled(void)
 
 static inline unsigned long kaslr_offset(void)
 {
-	return (unsigned long)&_text - __START_KERNEL;
+	return ktla_ktva((unsigned long)&_text) - __START_KERNEL;
 }
 
 /*
diff --git a/arch/x86/include/asm/smap.h b/arch/x86/include/asm/smap.h
index db333300b..fa80df301 100644
--- a/arch/x86/include/asm/smap.h
+++ b/arch/x86/include/asm/smap.h
@@ -25,6 +25,18 @@
 
 #include <asm/alternative-asm.h>
 
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define ASM_PAX_OPEN_USERLAND					\
+	ALTERNATIVE "", "call __pax_open_userland", X86_FEATURE_STRONGUDEREF
+
+#define ASM_PAX_CLOSE_USERLAND					\
+	ALTERNATIVE "", "call __pax_close_userland", X86_FEATURE_STRONGUDEREF
+
+#else
+#define ASM_PAX_OPEN_USERLAND
+#define ASM_PAX_CLOSE_USERLAND
+#endif
+
 #ifdef CONFIG_X86_SMAP
 
 #define ASM_CLAC \
@@ -40,10 +52,44 @@
 
 #endif /* CONFIG_X86_SMAP */
 
+#define ASM_USER_ACCESS_BEGIN	ASM_PAX_OPEN_USERLAND; ASM_STAC
+#define ASM_USER_ACCESS_END	ASM_CLAC; ASM_PAX_CLOSE_USERLAND
+
 #else /* __ASSEMBLY__ */
 
 #include <asm/alternative.h>
 
+#define __HAVE_ARCH_PAX_OPEN_USERLAND
+#define __HAVE_ARCH_PAX_CLOSE_USERLAND
+
+extern void __pax_open_userland(void);
+static __always_inline unsigned long pax_open_userland(void)
+{
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	asm volatile(ALTERNATIVE("", "call %P[open]", X86_FEATURE_STRONGUDEREF)
+		:
+		: [open] "i" (__pax_open_userland)
+		: "memory", "rax");
+#endif
+
+	return 0;
+}
+
+extern void __pax_close_userland(void);
+static __always_inline unsigned long pax_close_userland(void)
+{
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	asm volatile(ALTERNATIVE("", "call %P[close]", X86_FEATURE_STRONGUDEREF)
+		:
+		: [close] "i" (__pax_close_userland)
+		: "memory", "rax");
+#endif
+
+	return 0;
+}
+
 #ifdef CONFIG_X86_SMAP
 
 static __always_inline void clac(void)
diff --git a/arch/x86/include/asm/smp.h b/arch/x86/include/asm/smp.h
index ebd0c164c..ff7f35d9a 100644
--- a/arch/x86/include/asm/smp.h
+++ b/arch/x86/include/asm/smp.h
@@ -25,7 +25,7 @@ DECLARE_PER_CPU_READ_MOSTLY(cpumask_var_t, cpu_core_map);
 /* cpus sharing the last level cache: */
 DECLARE_PER_CPU_READ_MOSTLY(cpumask_var_t, cpu_llc_shared_map);
 DECLARE_PER_CPU_READ_MOSTLY(u16, cpu_llc_id);
-DECLARE_PER_CPU_READ_MOSTLY(int, cpu_number);
+DECLARE_PER_CPU_READ_MOSTLY(unsigned int, cpu_number);
 
 static inline struct cpumask *cpu_llc_shared_mask(int cpu)
 {
@@ -59,7 +59,7 @@ struct smp_ops {
 
 	void (*send_call_func_ipi)(const struct cpumask *mask);
 	void (*send_call_func_single_ipi)(int cpu);
-};
+} __no_const;
 
 /* Globals due to paravirt */
 extern void set_cpu_sibling_map(int cpu);
diff --git a/arch/x86/include/asm/stackprotector.h b/arch/x86/include/asm/stackprotector.h
index 58505f019..bff3b5b64 100644
--- a/arch/x86/include/asm/stackprotector.h
+++ b/arch/x86/include/asm/stackprotector.h
@@ -49,7 +49,7 @@
  * head_32 for boot CPU and setup_per_cpu_areas() for others.
  */
 #define GDT_STACK_CANARY_INIT						\
-	[GDT_ENTRY_STACK_CANARY] = GDT_ENTRY_INIT(0x4090, 0, 0x18),
+	[GDT_ENTRY_STACK_CANARY] = GDT_ENTRY_INIT(0x4090, 0, 0x17),
 
 /*
  * Initialize the stackprotector canary value.
@@ -114,7 +114,7 @@ static inline void setup_stack_canary_segment(int cpu)
 
 static inline void load_stack_canary_segment(void)
 {
-#ifdef CONFIG_X86_32
+#if defined(CONFIG_X86_32) && !defined(CONFIG_PAX_MEMORY_UDEREF)
 	asm volatile ("mov %0, %%gs" : : "r" (0));
 #endif
 }
diff --git a/arch/x86/include/asm/stacktrace.h b/arch/x86/include/asm/stacktrace.h
index 0944218af..2f17b1b30 100644
--- a/arch/x86/include/asm/stacktrace.h
+++ b/arch/x86/include/asm/stacktrace.h
@@ -11,28 +11,20 @@
 
 extern int kstack_depth_to_print;
 
-struct thread_info;
+struct task_struct;
 struct stacktrace_ops;
 
-typedef unsigned long (*walk_stack_t)(struct task_struct *task,
-				      unsigned long *stack,
-				      unsigned long bp,
-				      const struct stacktrace_ops *ops,
-				      void *data,
-				      unsigned long *end,
-				      int *graph);
-
-extern unsigned long
-print_context_stack(struct task_struct *task,
-		    unsigned long *stack, unsigned long bp,
-		    const struct stacktrace_ops *ops, void *data,
-		    unsigned long *end, int *graph);
-
-extern unsigned long
-print_context_stack_bp(struct task_struct *task,
-		       unsigned long *stack, unsigned long bp,
-		       const struct stacktrace_ops *ops, void *data,
-		       unsigned long *end, int *graph);
+typedef unsigned long walk_stack_t(struct task_struct *task,
+				   void *stack_start,
+				   unsigned long *stack,
+				   unsigned long bp,
+				   const struct stacktrace_ops *ops,
+				   void *data,
+				   unsigned long *end,
+				   int *graph);
+
+extern walk_stack_t print_context_stack;
+extern walk_stack_t print_context_stack_bp;
 
 /* Generic stack tracer with callbacks */
 
@@ -40,7 +32,7 @@ struct stacktrace_ops {
 	int (*address)(void *data, unsigned long address, int reliable);
 	/* On negative return stop dumping */
 	int (*stack)(void *data, char *name);
-	walk_stack_t	walk_stack;
+	walk_stack_t	*walk_stack;
 };
 
 void dump_trace(struct task_struct *tsk, struct pt_regs *regs,
diff --git a/arch/x86/include/asm/string_32.h b/arch/x86/include/asm/string_32.h
index 3d3e8353e..50b64b198 100644
--- a/arch/x86/include/asm/string_32.h
+++ b/arch/x86/include/asm/string_32.h
@@ -6,28 +6,28 @@
 /* Let gcc decide whether to inline or use the out of line functions */
 
 #define __HAVE_ARCH_STRCPY
-extern char *strcpy(char *dest, const char *src);
+extern char *strcpy(char *dest, const char *src) __nocapture(2);
 
 #define __HAVE_ARCH_STRNCPY
-extern char *strncpy(char *dest, const char *src, size_t count);
+extern char *strncpy(char *dest, const char *src, size_t count) __nocapture(2);
 
 #define __HAVE_ARCH_STRCAT
-extern char *strcat(char *dest, const char *src);
+extern char *strcat(char *dest, const char *src) __nocapture(2);
 
 #define __HAVE_ARCH_STRNCAT
-extern char *strncat(char *dest, const char *src, size_t count);
+extern char *strncat(char *dest, const char *src, size_t count) __nocapture(2);
 
 #define __HAVE_ARCH_STRCMP
-extern int strcmp(const char *cs, const char *ct);
+extern int strcmp(const char *cs, const char *ct) __nocapture();
 
 #define __HAVE_ARCH_STRNCMP
-extern int strncmp(const char *cs, const char *ct, size_t count);
+extern int strncmp(const char *cs, const char *ct, size_t count) __nocapture(1, 2);
 
 #define __HAVE_ARCH_STRCHR
-extern char *strchr(const char *s, int c);
+extern char *strchr(const char *s, int c) __nocapture(-1);
 
 #define __HAVE_ARCH_STRLEN
-extern size_t strlen(const char *s);
+extern size_t strlen(const char *s) __nocapture(1);
 
 static __always_inline void *__memcpy(void *to, const void *from, size_t n)
 {
@@ -197,12 +197,12 @@ static inline void *__memcpy3d(void *to, const void *from, size_t len)
 #endif
 
 #define __HAVE_ARCH_MEMMOVE
-void *memmove(void *dest, const void *src, size_t n);
+void *memmove(void *dest, const void *src, size_t n) __nocapture(2);
 
 #define memcmp __builtin_memcmp
 
 #define __HAVE_ARCH_MEMCHR
-extern void *memchr(const void *cs, int c, size_t count);
+extern void *memchr(const void *cs, int c, size_t count) __nocapture(-1);
 
 static inline void *__memset_generic(void *s, char c, size_t count)
 {
@@ -243,11 +243,11 @@ void *__constant_c_memset(void *s, unsigned long c, size_t count)
 
 /* Added by Gertjan van Wingerde to make minix and sysv module work */
 #define __HAVE_ARCH_STRNLEN
-extern size_t strnlen(const char *s, size_t count);
+extern size_t strnlen(const char *s, size_t count) __nocapture(1);
 /* end of additional stuff */
 
 #define __HAVE_ARCH_STRSTR
-extern char *strstr(const char *cs, const char *ct);
+extern char *strstr(const char *cs, const char *ct) __nocapture(-1, 2);
 
 /*
  * This looks horribly ugly, but the compiler can optimize it totally,
diff --git a/arch/x86/include/asm/string_64.h b/arch/x86/include/asm/string_64.h
index 90dbbd966..607d3ba36 100644
--- a/arch/x86/include/asm/string_64.h
+++ b/arch/x86/include/asm/string_64.h
@@ -27,8 +27,8 @@ static __always_inline void *__inline_memcpy(void *to, const void *from, size_t
    function. */
 
 #define __HAVE_ARCH_MEMCPY 1
-extern void *memcpy(void *to, const void *from, size_t len);
-extern void *__memcpy(void *to, const void *from, size_t len);
+extern void *memcpy(void *to, const void *from, size_t len) __nocapture(2);
+extern void *__memcpy(void *to, const void *from, size_t len) __nocapture(2);
 
 #ifndef CONFIG_KMEMCHECK
 #if (__GNUC__ == 4 && __GNUC_MINOR__ < 3) || __GNUC__ < 4
@@ -56,14 +56,14 @@ void *memset(void *s, int c, size_t n);
 void *__memset(void *s, int c, size_t n);
 
 #define __HAVE_ARCH_MEMMOVE
-void *memmove(void *dest, const void *src, size_t count);
-void *__memmove(void *dest, const void *src, size_t count);
+void *memmove(void *dest, const void *src, size_t count) __nocapture(2);
+void *__memmove(void *dest, const void *src, size_t count) __nocapture(2);
 
-int memcmp(const void *cs, const void *ct, size_t count);
-size_t strlen(const char *s);
-char *strcpy(char *dest, const char *src);
-char *strcat(char *dest, const char *src);
-int strcmp(const char *cs, const char *ct);
+int memcmp(const void *cs, const void *ct, size_t count) __nocapture(1, 2);
+size_t strlen(const char *s) __nocapture(1);
+char *strcpy(char *dest, const char *src) __nocapture(2);
+char *strcat(char *dest, const char *src) __nocapture(2);
+int strcmp(const char *cs, const char *ct) __nocapture(1, 2);
 
 #if defined(CONFIG_KASAN) && !defined(__SANITIZE_ADDRESS__)
 
@@ -89,7 +89,7 @@ int strcmp(const char *cs, const char *ct);
  *
  * Return 0 for success, -EFAULT for fail
  */
-int memcpy_mcsafe(void *dst, const void *src, size_t cnt);
+int memcpy_mcsafe(void *dst, const void *src, size_t cnt) __nocapture(2);
 
 #endif /* __KERNEL__ */
 
diff --git a/arch/x86/include/asm/switch_to.h b/arch/x86/include/asm/switch_to.h
index 8f321a1b0..620718367 100644
--- a/arch/x86/include/asm/switch_to.h
+++ b/arch/x86/include/asm/switch_to.h
@@ -110,7 +110,7 @@ do {									\
 	     "call __switch_to\n\t"					  \
 	     "movq "__percpu_arg([current_task])",%%rsi\n\t"		  \
 	     __switch_canary						  \
-	     "movq %P[thread_info](%%rsi),%%r8\n\t"			  \
+	     "movq "__percpu_arg([thread_info])",%%r8\n\t"		  \
 	     "movq %%rax,%%rdi\n\t" 					  \
 	     "testl  %[_tif_fork],%P[ti_flags](%%r8)\n\t"		  \
 	     "jnz   ret_from_fork\n\t"					  \
@@ -121,7 +121,7 @@ do {									\
 	       [threadrsp] "i" (offsetof(struct task_struct, thread.sp)), \
 	       [ti_flags] "i" (offsetof(struct thread_info, flags)),	  \
 	       [_tif_fork] "i" (_TIF_FORK),			  	  \
-	       [thread_info] "i" (offsetof(struct task_struct, stack)),   \
+	       [thread_info] "m" (current_tinfo),			  \
 	       [current_task] "m" (current_task)			  \
 	       __switch_canary_iparam					  \
 	     : "memory", "cc" __EXTRA_CLOBBER)
diff --git a/arch/x86/include/asm/sys_ia32.h b/arch/x86/include/asm/sys_ia32.h
index 82c34ee25..940fa40cf 100644
--- a/arch/x86/include/asm/sys_ia32.h
+++ b/arch/x86/include/asm/sys_ia32.h
@@ -20,8 +20,8 @@
 #include <asm/ia32.h>
 
 /* ia32/sys_ia32.c */
-asmlinkage long sys32_truncate64(const char __user *, unsigned long, unsigned long);
-asmlinkage long sys32_ftruncate64(unsigned int, unsigned long, unsigned long);
+asmlinkage long sys32_truncate64(const char __user *, unsigned int, unsigned int);
+asmlinkage long sys32_ftruncate64(unsigned int, unsigned int, unsigned int);
 
 asmlinkage long sys32_stat64(const char __user *, struct stat64 __user *);
 asmlinkage long sys32_lstat64(const char __user *, struct stat64 __user *);
@@ -42,7 +42,7 @@ long sys32_vm86_warning(void);
 asmlinkage ssize_t sys32_readahead(int, unsigned, unsigned, size_t);
 asmlinkage long sys32_sync_file_range(int, unsigned, unsigned,
 				      unsigned, unsigned, int);
-asmlinkage long sys32_fadvise64(int, unsigned, unsigned, size_t, int);
+asmlinkage long sys32_fadvise64(int, unsigned, unsigned, int, int);
 asmlinkage long sys32_fallocate(int, int, unsigned,
 				unsigned, unsigned, unsigned);
 
diff --git a/arch/x86/include/asm/thread_info.h b/arch/x86/include/asm/thread_info.h
index 8b7c8d8e0..a60b006b7 100644
--- a/arch/x86/include/asm/thread_info.h
+++ b/arch/x86/include/asm/thread_info.h
@@ -39,7 +39,7 @@
 #  define TOP_OF_KERNEL_STACK_PADDING 8
 # endif
 #else
-# define TOP_OF_KERNEL_STACK_PADDING 0
+# define TOP_OF_KERNEL_STACK_PADDING 16
 #endif
 
 /*
@@ -53,20 +53,21 @@ struct task_struct;
 #include <linux/atomic.h>
 
 struct thread_info {
-	struct task_struct	*task;		/* main task structure */
 	__u32			flags;		/* low level flags */
 	__u32			status;		/* thread synchronous flags */
 	__u32			cpu;		/* current CPU */
+	mm_segment_t		addr_limit;
+	unsigned long		lowest_stack;
 };
 
-#define INIT_THREAD_INFO(tsk)			\
+#define INIT_THREAD_INFO			\
 {						\
-	.task		= &tsk,			\
 	.flags		= 0,			\
 	.cpu		= 0,			\
+	.addr_limit	= KERNEL_DS,		\
 }
 
-#define init_thread_info	(init_thread_union.thread_info)
+#define init_thread_info	(init_thread_union.stack)
 #define init_stack		(init_thread_union.stack)
 
 #else /* !__ASSEMBLY__ */
@@ -106,6 +107,7 @@ struct thread_info {
 #define TIF_SYSCALL_TRACEPOINT	28	/* syscall tracepoint instrumentation */
 #define TIF_ADDR32		29	/* 32-bit address space on 64 bits */
 #define TIF_X32			30	/* 32-bit native x86-64 binary */
+#define TIF_GRSEC_SETXID	31	/* update credentials on syscall entry/exit */
 
 #define _TIF_SYSCALL_TRACE	(1 << TIF_SYSCALL_TRACE)
 #define _TIF_NOTIFY_RESUME	(1 << TIF_NOTIFY_RESUME)
@@ -129,6 +131,7 @@ struct thread_info {
 #define _TIF_SYSCALL_TRACEPOINT	(1 << TIF_SYSCALL_TRACEPOINT)
 #define _TIF_ADDR32		(1 << TIF_ADDR32)
 #define _TIF_X32		(1 << TIF_X32)
+#define _TIF_GRSEC_SETXID	(1 << TIF_GRSEC_SETXID)
 
 /*
  * work to do in syscall_trace_enter().  Also includes TIF_NOHZ for
@@ -137,12 +140,12 @@ struct thread_info {
 #define _TIF_WORK_SYSCALL_ENTRY	\
 	(_TIF_SYSCALL_TRACE | _TIF_SYSCALL_EMU | _TIF_SYSCALL_AUDIT |	\
 	 _TIF_SECCOMP | _TIF_SYSCALL_TRACEPOINT |	\
-	 _TIF_NOHZ)
+	 _TIF_NOHZ | _TIF_GRSEC_SETXID)
 
 /* work to do on any return to user space */
 #define _TIF_ALLWORK_MASK						\
 	((0x0000FFFF & ~_TIF_SECCOMP) | _TIF_SYSCALL_TRACEPOINT |	\
-	_TIF_NOHZ)
+	_TIF_NOHZ | _TIF_GRSEC_SETXID)
 
 /* flags to check in __switch_to() */
 #define _TIF_WORK_CTXSW							\
@@ -160,9 +163,11 @@ struct thread_info {
  */
 #ifndef __ASSEMBLY__
 
+DECLARE_PER_CPU(struct thread_info *, current_tinfo);
+
 static inline struct thread_info *current_thread_info(void)
 {
-	return (struct thread_info *)(current_top_of_stack() - THREAD_SIZE);
+	return this_cpu_read_stable(current_tinfo);
 }
 
 static inline unsigned long current_stack_pointer(void)
@@ -181,21 +186,21 @@ static inline unsigned long current_stack_pointer(void)
  * entirely contained by a single stack frame.
  *
  * Returns:
- *		 1 if within a frame
- *		-1 if placed across a frame boundary (or outside stack)
- *		 0 unable to determine (no frame pointers, etc)
+ *		 GOOD_FRAME if within a frame
+ *		 BAD_STACK if placed across a frame boundary (or outside stack)
+ *		 GOOD_STACK unable to determine (no frame pointers, etc)
  */
-static inline int arch_within_stack_frames(const void * const stack,
-					   const void * const stackend,
-					   const void *obj, unsigned long len)
+static __always_inline int arch_within_stack_frames(unsigned long stack,
+					   unsigned long stackend,
+					   unsigned long obj, unsigned long len)
 {
 #if defined(CONFIG_FRAME_POINTER)
-	const void *frame = NULL;
-	const void *oldframe;
+	unsigned long frame = 0;
+	unsigned long oldframe;
 
-	oldframe = __builtin_frame_address(1);
+	oldframe = (unsigned long)__builtin_frame_address(1);
 	if (oldframe)
-		frame = __builtin_frame_address(2);
+		frame = (unsigned long)__builtin_frame_address(2);
 	/*
 	 * low ----------------------------------------------> high
 	 * [saved bp][saved ip][args][local vars][saved bp][saved ip]
@@ -210,48 +215,21 @@ static inline int arch_within_stack_frames(const void * const stack,
 		 * the copy as invalid.
 		 */
 		if (obj + len <= frame)
-			return obj >= oldframe + 2 * sizeof(void *) ? 1 : -1;
+			return obj >= oldframe + 2 * sizeof(unsigned long) ? GOOD_FRAME : BAD_STACK;
 		oldframe = frame;
-		frame = *(const void * const *)frame;
+		frame = *(unsigned long *)frame;
 	}
-	return -1;
+	return BAD_STACK;
 #else
-	return 0;
+	return GOOD_STACK;
 #endif
 }
 
 #else /* !__ASSEMBLY__ */
 
-#ifdef CONFIG_X86_64
-# define cpu_current_top_of_stack (cpu_tss + TSS_sp0)
-#endif
-
-/*
- * ASM operand which evaluates to a 'thread_info' address of
- * the current task, if it is known that "reg" is exactly "off"
- * bytes below the top of the stack currently.
- *
- * ( The kernel stack's size is known at build time, it is usually
- *   2 or 4 pages, and the bottom  of the kernel stack contains
- *   the thread_info structure. So to access the thread_info very
- *   quickly from assembly code we can calculate down from the
- *   top of the kernel stack to the bottom, using constant,
- *   build-time calculations only. )
- *
- * For example, to fetch the current thread_info->flags value into %eax
- * on x86-64 defconfig kernels, in syscall entry code where RSP is
- * currently at exactly SIZEOF_PTREGS bytes away from the top of the
- * stack:
- *
- *      mov ASM_THREAD_INFO(TI_flags, %rsp, SIZEOF_PTREGS), %eax
- *
- * will translate to:
- *
- *      8b 84 24 b8 c0 ff ff      mov    -0x3f48(%rsp), %eax
- *
- * which is below the current RSP by almost 16K.
- */
-#define ASM_THREAD_INFO(field, reg, off) ((field)+(off)-THREAD_SIZE)(reg)
+/* Load thread_info address into "reg" */
+#define GET_THREAD_INFO(reg) \
+	_ASM_MOV PER_CPU_VAR(current_tinfo),reg ;
 
 #endif
 
@@ -293,6 +271,13 @@ static inline bool in_ia32_syscall(void)
 extern void arch_task_cache_init(void);
 extern int arch_dup_task_struct(struct task_struct *dst, struct task_struct *src);
 extern void arch_release_task_struct(struct task_struct *tsk);
+
+#define __HAVE_THREAD_FUNCTIONS
+#define task_thread_info(task)	(&(task)->tinfo)
+#define task_stack_page(task)	((task)->stack)
+#define setup_thread_stack(p, org) do {} while (0)
+#define end_of_stack(p) ((unsigned long *)task_stack_page(p) + 1)
+
 #endif	/* !__ASSEMBLY__ */
 
 #endif /* _ASM_X86_THREAD_INFO_H */
diff --git a/arch/x86/include/asm/tlbflush.h b/arch/x86/include/asm/tlbflush.h
index dee8a7038..270877a19 100644
--- a/arch/x86/include/asm/tlbflush.h
+++ b/arch/x86/include/asm/tlbflush.h
@@ -89,7 +89,9 @@ static inline void cr4_set_bits(unsigned long mask)
 {
 	unsigned long cr4;
 
+//	BUG_ON(!arch_irqs_disabled());
 	cr4 = this_cpu_read(cpu_tlbstate.cr4);
+	BUG_ON(cr4 != __read_cr4());
 	if ((cr4 | mask) != cr4) {
 		cr4 |= mask;
 		this_cpu_write(cpu_tlbstate.cr4, cr4);
@@ -102,7 +104,9 @@ static inline void cr4_clear_bits(unsigned long mask)
 {
 	unsigned long cr4;
 
+//	BUG_ON(!arch_irqs_disabled());
 	cr4 = this_cpu_read(cpu_tlbstate.cr4);
+	BUG_ON(cr4 != __read_cr4());
 	if ((cr4 & ~mask) != cr4) {
 		cr4 &= ~mask;
 		this_cpu_write(cpu_tlbstate.cr4, cr4);
@@ -113,6 +117,7 @@ static inline void cr4_clear_bits(unsigned long mask)
 /* Read the CR4 shadow. */
 static inline unsigned long cr4_read_shadow(void)
 {
+//	BUG_ON(!arch_irqs_disabled());
 	return this_cpu_read(cpu_tlbstate.cr4);
 }
 
@@ -135,6 +140,25 @@ static inline void cr4_set_bits_and_update_boot(unsigned long mask)
 
 static inline void __native_flush_tlb(void)
 {
+	if (static_cpu_has(X86_FEATURE_INVPCID)) {
+		u64 descriptor[2];
+
+		descriptor[0] = PCID_KERNEL;
+		asm volatile(__ASM_INVPCID : : "d"(&descriptor), "a"(INVPCID_ALL_NONGLOBAL) : "memory");
+		return;
+	}
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	if (static_cpu_has(X86_FEATURE_PCIDUDEREF)) {
+		unsigned int cpu = raw_get_cpu();
+
+		native_write_cr3(__pa(get_cpu_pgd(cpu, user)) | PCID_USER);
+		native_write_cr3(__pa(get_cpu_pgd(cpu, kernel)) | PCID_KERNEL);
+		raw_put_cpu_no_resched();
+		return;
+	}
+#endif
+
 	/*
 	 * If current->mm == NULL then we borrow a mm which may change during a
 	 * task switch and therefore we must not be preempted while we write CR3
@@ -147,13 +171,21 @@ static inline void __native_flush_tlb(void)
 
 static inline void __native_flush_tlb_global_irq_disabled(void)
 {
-	unsigned long cr4;
-
-	cr4 = this_cpu_read(cpu_tlbstate.cr4);
-	/* clear PGE */
-	native_write_cr4(cr4 & ~X86_CR4_PGE);
-	/* write old PGE again and flush TLBs */
-	native_write_cr4(cr4);
+	if (static_cpu_has(X86_FEATURE_INVPCID)) {
+		u64 descriptor[2];
+
+		descriptor[0] = PCID_KERNEL;
+		asm volatile(__ASM_INVPCID : : "d"(&descriptor), "a"(INVPCID_ALL_GLOBAL) : "memory");
+	} else {
+		unsigned long cr4;
+
+		cr4 = this_cpu_read(cpu_tlbstate.cr4);
+		BUG_ON(cr4 != __read_cr4());
+		/* clear PGE */
+		native_write_cr4(cr4 & ~X86_CR4_PGE);
+		/* write old PGE again and flush TLBs */
+		native_write_cr4(cr4);
+	}
 }
 
 static inline void __native_flush_tlb_global(void)
@@ -183,6 +215,43 @@ static inline void __native_flush_tlb_global(void)
 
 static inline void __native_flush_tlb_single(unsigned long addr)
 {
+	if (static_cpu_has(X86_FEATURE_INVPCID)) {
+		u64 descriptor[2];
+
+		descriptor[0] = PCID_KERNEL;
+		descriptor[1] = addr;
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+		if (static_cpu_has(X86_FEATURE_PCIDUDEREF)) {
+			if (!static_cpu_has(X86_FEATURE_STRONGUDEREF) || addr >= TASK_SIZE_MAX) {
+				if (addr < TASK_SIZE_MAX)
+					descriptor[1] += pax_user_shadow_base;
+				asm volatile(__ASM_INVPCID : : "d"(&descriptor), "a"(INVPCID_SINGLE_ADDRESS) : "memory");
+			}
+
+			descriptor[0] = PCID_USER;
+			descriptor[1] = addr;
+		}
+#endif
+
+		asm volatile(__ASM_INVPCID : : "d"(&descriptor), "a"(INVPCID_SINGLE_ADDRESS) : "memory");
+		return;
+	}
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	if (static_cpu_has(X86_FEATURE_PCIDUDEREF)) {
+		unsigned int cpu = raw_get_cpu();
+
+		native_write_cr3(__pa(get_cpu_pgd(cpu, user)) | PCID_USER | PCID_NOFLUSH);
+		asm volatile("invlpg (%0)" ::"r" (addr) : "memory");
+		native_write_cr3(__pa(get_cpu_pgd(cpu, kernel)) | PCID_KERNEL | PCID_NOFLUSH);
+		raw_put_cpu_no_resched();
+
+		if (!static_cpu_has(X86_FEATURE_STRONGUDEREF) && addr < TASK_SIZE_MAX)
+			addr += pax_user_shadow_base;
+	}
+#endif
+
 	asm volatile("invlpg (%0)" ::"r" (addr) : "memory");
 }
 
diff --git a/arch/x86/include/asm/trace/fpu.h b/arch/x86/include/asm/trace/fpu.h
index 9217ab1f5..90c91bfcd 100644
--- a/arch/x86/include/asm/trace/fpu.h
+++ b/arch/x86/include/asm/trace/fpu.h
@@ -25,8 +25,8 @@ DECLARE_EVENT_CLASS(x86_fpu,
 		__entry->fpstate_active	= fpu->fpstate_active;
 		__entry->counter	= fpu->counter;
 		if (boot_cpu_has(X86_FEATURE_OSXSAVE)) {
-			__entry->xfeatures = fpu->state.xsave.header.xfeatures;
-			__entry->xcomp_bv  = fpu->state.xsave.header.xcomp_bv;
+			__entry->xfeatures = fpu->state->xsave.header.xfeatures;
+			__entry->xcomp_bv  = fpu->state->xsave.header.xcomp_bv;
 		}
 	),
 	TP_printk("x86/fpu: %p fpregs_active: %d fpstate_active: %d counter: %d xfeatures: %llx xcomp_bv: %llx",
diff --git a/arch/x86/include/asm/traps.h b/arch/x86/include/asm/traps.h
index c34966197..9b914af68 100644
--- a/arch/x86/include/asm/traps.h
+++ b/arch/x86/include/asm/traps.h
@@ -10,7 +10,7 @@
 #define dotraplinkage __visible
 
 asmlinkage void divide_error(void);
-asmlinkage void debug(void);
+asmlinkage void int1(void);
 asmlinkage void nmi(void);
 asmlinkage void int3(void);
 asmlinkage void xen_debug(void);
@@ -38,6 +38,15 @@ asmlinkage void machine_check(void);
 #endif /* CONFIG_X86_MCE */
 asmlinkage void simd_coprocessor_error(void);
 
+#ifdef CONFIG_PAX_REFCOUNT
+asmlinkage void refcount_error(void);
+#endif
+
+#ifdef CONFIG_PAX_RAP
+asmlinkage void rap_call_error(void);
+asmlinkage void rap_ret_error(void);
+#endif
+
 #ifdef CONFIG_TRACING
 asmlinkage void trace_page_fault(void);
 #define trace_stack_segment stack_segment
@@ -54,6 +63,7 @@ asmlinkage void trace_page_fault(void);
 #define trace_alignment_check alignment_check
 #define trace_simd_coprocessor_error simd_coprocessor_error
 #define trace_async_page_fault async_page_fault
+#define trace_refcount_error refcount_error
 #endif
 
 dotraplinkage void do_divide_error(struct pt_regs *, long);
@@ -107,7 +117,7 @@ extern int panic_on_unrecovered_nmi;
 
 void math_emulate(struct math_emu_info *);
 #ifndef CONFIG_X86_32
-asmlinkage void smp_thermal_interrupt(void);
+asmlinkage void smp_thermal_interrupt(struct pt_regs *regs);
 asmlinkage void smp_threshold_interrupt(void);
 asmlinkage void smp_deferred_error_interrupt(void);
 #endif
@@ -139,6 +149,9 @@ enum {
 	X86_TRAP_AC,		/* 17, Alignment Check */
 	X86_TRAP_MC,		/* 18, Machine Check */
 	X86_TRAP_XF,		/* 19, SIMD Floating-Point Exception */
+	X86_TRAP_VE,		/* 20, Virtualization Exception */
+	X86_TRAP_CP,		/* 21, Control Protection Exception */
+	X86_TRAP_SX = 30,	/* 30, Security Exception */
 	X86_TRAP_IRET = 32,	/* 32, IRET Exception */
 };
 
diff --git a/arch/x86/include/asm/uaccess.h b/arch/x86/include/asm/uaccess.h
index 2131c4ce7..120dcaaf9 100644
--- a/arch/x86/include/asm/uaccess.h
+++ b/arch/x86/include/asm/uaccess.h
@@ -8,6 +8,7 @@
 #include <linux/kasan-checks.h>
 #include <linux/thread_info.h>
 #include <linux/string.h>
+#include <linux/spinlock.h>
 #include <asm/asm.h>
 #include <asm/page.h>
 #include <asm/smap.h>
@@ -29,12 +30,17 @@
 #define USER_DS 	MAKE_MM_SEG(TASK_SIZE_MAX)
 
 #define get_ds()	(KERNEL_DS)
-#define get_fs()	(current->thread.addr_limit)
-#define set_fs(x)	(current->thread.addr_limit = (x))
+#define get_fs()	(current_thread_info()->addr_limit)
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_MEMORY_UDEREF)
+void __set_fs(mm_segment_t x);
+void set_fs(mm_segment_t x);
+#else
+#define set_fs(x)	(current_thread_info()->addr_limit = (x))
+#endif
 
 #define segment_eq(a, b)	((a).seg == (b).seg)
 
-#define user_addr_max() (current->thread.addr_limit.seg)
+#define user_addr_max() (current_thread_info()->addr_limit.seg)
 #define __addr_ok(addr) 	\
 	((unsigned long __force)(addr) < user_addr_max())
 
@@ -87,8 +93,36 @@ static inline bool __chk_range_not_ok(unsigned long addr, unsigned long size, un
  * checks that the pointer is in the user space range - after calling
  * this function, memory access functions may still return -EFAULT.
  */
-#define access_ok(type, addr, size) \
-	likely(!__range_not_ok(addr, size, user_addr_max()))
+extern int _cond_resched(void);
+#define access_ok_noprefault(type, addr, size) (likely(!__range_not_ok(addr, size, user_addr_max())))
+#define access_ok(type, addr, size)					\
+({									\
+	unsigned long __size = size;					\
+	unsigned long __addr = (unsigned long)addr;			\
+	bool __ret_ao = __range_not_ok(__addr, __size, user_addr_max()) == 0;\
+	if (__ret_ao && __size < 256 * PAGE_SIZE) {			\
+		unsigned long __addr_ao = __addr & PAGE_MASK;		\
+		unsigned long __end_ao = __addr + __size - 1;		\
+		if (unlikely((__end_ao ^ __addr_ao) & PAGE_MASK)) {	\
+			while (__addr_ao <= __end_ao) {			\
+				char __c_ao;				\
+				__addr_ao += PAGE_SIZE;			\
+				if (__size > PAGE_SIZE)			\
+					_cond_resched();		\
+				if (__get_user(__c_ao, (char __user *)__addr))	\
+					break;				\
+				if ((type) != VERIFY_WRITE) {		\
+					__addr = __addr_ao;		\
+					continue;			\
+				}					\
+				if (__put_user(__c_ao, (char __user *)__addr))	\
+					break;				\
+				__addr = __addr_ao;			\
+			}						\
+		}							\
+	}								\
+	__ret_ao;							\
+})
 
 /*
  * The exception table consists of triples of addresses relative to the
@@ -142,15 +176,27 @@ extern int __get_user_4(void);
 extern int __get_user_8(void);
 extern int __get_user_bad(void);
 
-#define __uaccess_begin() stac()
-#define __uaccess_end()   clac()
+#define __uaccess_begin() pax_open_userland(); stac()
+#define __uaccess_end()   clac(); pax_close_userland()
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define __copyuser_seg "gs;"
+#define __COPYUSER_SET_ES "pushl %%gs; popl %%es\n"
+#define __COPYUSER_RESTORE_ES "pushl %%ss; popl %%es\n"
+#else
+#define __copyuser_seg
+#define __COPYUSER_SET_ES
+#define __COPYUSER_RESTORE_ES
+#endif
 
 /*
- * This is a type: either unsigned long, if the argument fits into
- * that type, or otherwise unsigned long long.
+ * This is a type: either (un)signed int, if the argument fits into
+ * that type, or otherwise (un)signed long long.
  */
 #define __inttype(x) \
-__typeof__(__builtin_choose_expr(sizeof(x) > sizeof(0UL), 0ULL, 0UL))
+__typeof__(__builtin_choose_expr(sizeof(x) > sizeof(0U),		\
+	__builtin_choose_expr(__type_is_unsigned(__typeof__(x)), 0ULL, 0LL),\
+	__builtin_choose_expr(__type_is_unsigned(__typeof__(x)), 0U, 0)))
 
 /**
  * get_user: - Get a simple variable from user space.
@@ -201,14 +247,12 @@ __typeof__(__builtin_choose_expr(sizeof(x) > sizeof(0UL), 0ULL, 0UL))
 	asm volatile("call __put_user_" #size : "=a" (__ret_pu)	\
 		     : "0" ((typeof(*(ptr)))(x)), "c" (ptr) : "ebx")
 
-
-
 #ifdef CONFIG_X86_32
 #define __put_user_asm_u64(x, addr, err, errret)			\
 	asm volatile("\n"						\
-		     "1:	movl %%eax,0(%2)\n"			\
-		     "2:	movl %%edx,4(%2)\n"			\
-		     "3:"						\
+		     "1:	"__copyuser_seg"movl %%eax,0(%2)\n"	\
+		     "2:	"__copyuser_seg"movl %%edx,4(%2)\n"	\
+		     "3:\n"						\
 		     ".section .fixup,\"ax\"\n"				\
 		     "4:	movl %3,%0\n"				\
 		     "	jmp 3b\n"					\
@@ -220,9 +264,9 @@ __typeof__(__builtin_choose_expr(sizeof(x) > sizeof(0UL), 0ULL, 0UL))
 
 #define __put_user_asm_ex_u64(x, addr)					\
 	asm volatile("\n"						\
-		     "1:	movl %%eax,0(%1)\n"			\
-		     "2:	movl %%edx,4(%1)\n"			\
-		     "3:"						\
+		     "1:	"__copyuser_seg"movl %%eax,0(%1)\n"	\
+		     "2:	"__copyuser_seg"movl %%edx,4(%1)\n"	\
+		     "3:\n"						\
 		     _ASM_EXTABLE_EX(1b, 2b)				\
 		     _ASM_EXTABLE_EX(2b, 3b)				\
 		     : : "A" (x), "r" (addr))
@@ -269,10 +313,10 @@ extern void __put_user_8(void);
 #define put_user(x, ptr)					\
 ({								\
 	int __ret_pu;						\
-	__typeof__(*(ptr)) __pu_val;				\
+	__inttype(*(ptr)) __pu_val;				\
 	__chk_user_ptr(ptr);					\
 	might_fault();						\
-	__pu_val = x;						\
+	__pu_val = (__inttype(*(ptr)))(x);			\
 	switch (sizeof(*(ptr))) {				\
 	case 1:							\
 		__put_user_x(1, __pu_val, ptr, __ret_pu);	\
@@ -345,10 +389,9 @@ do {									\
 #define __get_user_asm_u64(x, ptr, retval, errret)			\
 ({									\
 	__typeof__(ptr) __ptr = (ptr);					\
-	asm volatile(ASM_STAC "\n"					\
-		     "1:	movl %2,%%eax\n"			\
+	asm volatile("1:	movl %2,%%eax\n"			\
 		     "2:	movl %3,%%edx\n"			\
-		     "3: " ASM_CLAC "\n"				\
+		     "3:\n"						\
 		     ".section .fixup,\"ax\"\n"				\
 		     "4:	mov %4,%0\n"				\
 		     "	xorl %%eax,%%eax\n"				\
@@ -376,10 +419,10 @@ do {									\
 	__chk_user_ptr(ptr);						\
 	switch (size) {							\
 	case 1:								\
-		__get_user_asm(x, ptr, retval, "b", "b", "=q", errret);	\
+		__get_user_asm(x, ptr, retval, "zbl", "k", "=r", errret);\
 		break;							\
 	case 2:								\
-		__get_user_asm(x, ptr, retval, "w", "w", "=r", errret);	\
+		__get_user_asm(x, ptr, retval, "zwl", "k", "=r", errret);\
 		break;							\
 	case 4:								\
 		__get_user_asm(x, ptr, retval, "l", "k", "=r", errret);	\
@@ -393,17 +436,19 @@ do {									\
 } while (0)
 
 #define __get_user_asm(x, addr, err, itype, rtype, ltype, errret)	\
+do {									\
 	asm volatile("\n"						\
-		     "1:	mov"itype" %2,%"rtype"1\n"		\
+		     "1:	"__copyuser_seg"mov"itype" %2,%"rtype"1\n"\
 		     "2:\n"						\
 		     ".section .fixup,\"ax\"\n"				\
 		     "3:	mov %3,%0\n"				\
-		     "	xor"itype" %"rtype"1,%"rtype"1\n"		\
+		     "	xorl %k1,%k1\n"					\
 		     "	jmp 2b\n"					\
 		     ".previous\n"					\
 		     _ASM_EXTABLE(1b, 3b)				\
-		     : "=r" (err), ltype(x)				\
-		     : "m" (__m(addr)), "i" (errret), "0" (err))
+		     : "=r" (err), ltype (x)				\
+		     : "m" (__m(addr)), "i" (errret), "0" (err));	\
+} while (0)
 
 /*
  * This doesn't do __uaccess_begin/end - the exception handling
@@ -414,10 +459,10 @@ do {									\
 	__chk_user_ptr(ptr);						\
 	switch (size) {							\
 	case 1:								\
-		__get_user_asm_ex(x, ptr, "b", "b", "=q");		\
+		__get_user_asm_ex(x, ptr, "zbl", "k", "=r");		\
 		break;							\
 	case 2:								\
-		__get_user_asm_ex(x, ptr, "w", "w", "=r");		\
+		__get_user_asm_ex(x, ptr, "zwl", "k", "=r");		\
 		break;							\
 	case 4:								\
 		__get_user_asm_ex(x, ptr, "l", "k", "=r");		\
@@ -431,10 +476,10 @@ do {									\
 } while (0)
 
 #define __get_user_asm_ex(x, addr, itype, rtype, ltype)			\
-	asm volatile("1:	mov"itype" %1,%"rtype"0\n"		\
+	asm volatile("1:	"__copyuser_seg"mov"itype" %1,%"rtype"0\n"\
 		     "2:\n"						\
 		     ".section .fixup,\"ax\"\n"				\
-                     "3:xor"itype" %"rtype"0,%"rtype"0\n"		\
+		     "3:xorl %k0,%k0\n"					\
 		     "  jmp 2b\n"					\
 		     ".previous\n"					\
 		     _ASM_EXTABLE_EX(1b, 3b)				\
@@ -456,13 +501,24 @@ do {									\
 	__uaccess_begin();						\
 	__get_user_size(__gu_val, (ptr), (size), __gu_err, -EFAULT);	\
 	__uaccess_end();						\
-	(x) = (__force __typeof__(*(ptr)))__gu_val;			\
+	(x) = (__typeof__(*(ptr)))__gu_val;				\
 	__builtin_expect(__gu_err, 0);					\
 })
 
 /* FIXME: this hack is definitely wrong -AK */
 struct __large_struct { unsigned long buf[100]; };
-#define __m(x) (*(struct __large_struct __user *)(x))
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define ____m(x)					\
+({							\
+	unsigned long ____x = (unsigned long)(x);	\
+	if (____x < pax_user_shadow_base)		\
+		____x += pax_user_shadow_base;		\
+	(typeof(x))____x;				\
+})
+#else
+#define ____m(x) (x)
+#endif
+#define __m(x) (*(struct __large_struct __user *)____m(x))
 
 /*
  * Tell gcc we read from memory instead of writing: this is because
@@ -470,8 +526,9 @@ struct __large_struct { unsigned long buf[100]; };
  * aliasing issues.
  */
 #define __put_user_asm(x, addr, err, itype, rtype, ltype, errret)	\
+do {									\
 	asm volatile("\n"						\
-		     "1:	mov"itype" %"rtype"1,%2\n"		\
+		     "1:	"__copyuser_seg"mov"itype" %"rtype"1,%2\n"\
 		     "2:\n"						\
 		     ".section .fixup,\"ax\"\n"				\
 		     "3:	mov %3,%0\n"				\
@@ -479,10 +536,11 @@ struct __large_struct { unsigned long buf[100]; };
 		     ".previous\n"					\
 		     _ASM_EXTABLE(1b, 3b)				\
 		     : "=r"(err)					\
-		     : ltype(x), "m" (__m(addr)), "i" (errret), "0" (err))
+		     : ltype (x), "m" (__m(addr)), "i" (errret), "0" (err));\
+} while (0)
 
 #define __put_user_asm_ex(x, addr, itype, rtype, ltype)			\
-	asm volatile("1:	mov"itype" %"rtype"0,%1\n"		\
+	asm volatile("1:	"__copyuser_seg"mov"itype" %"rtype"0,%1\n"\
 		     "2:\n"						\
 		     _ASM_EXTABLE_EX(1b, 2b)				\
 		     : : ltype(x), "m" (__m(addr)))
@@ -522,8 +580,12 @@ struct __large_struct { unsigned long buf[100]; };
  * On error, the variable @x is set to zero.
  */
 
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define __get_user(x, ptr)	get_user((x), (ptr))
+#else
 #define __get_user(x, ptr)						\
 	__get_user_nocheck((x), (ptr), sizeof(*(ptr)))
+#endif
 
 /**
  * __put_user: - Write a simple value into user space, with less checking.
@@ -546,8 +608,12 @@ struct __large_struct { unsigned long buf[100]; };
  * Returns zero on success, or -EFAULT on error.
  */
 
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define __put_user(x, ptr)	put_user((x), (ptr))
+#else
 #define __put_user(x, ptr)						\
 	__put_user_nocheck((__typeof__(*(ptr)))(x), (ptr), sizeof(*(ptr)))
+#endif
 
 #define __get_user_unaligned __get_user
 #define __put_user_unaligned __put_user
@@ -565,7 +631,7 @@ struct __large_struct { unsigned long buf[100]; };
 #define get_user_ex(x, ptr)	do {					\
 	unsigned long __gue_val;					\
 	__get_user_size_ex((__gue_val), (ptr), (sizeof(*(ptr))));	\
-	(x) = (__force __typeof__(*(ptr)))__gue_val;			\
+	(x) = (__typeof__(*(ptr)))__gue_val;				\
 } while (0)
 
 #define put_user_try		uaccess_try
@@ -583,7 +649,7 @@ extern __must_check long strlen_user(const char __user *str);
 extern __must_check long strnlen_user(const char __user *str, long n);
 
 unsigned long __must_check clear_user(void __user *mem, unsigned long len);
-unsigned long __must_check __clear_user(void __user *mem, unsigned long len);
+unsigned long __must_check __clear_user(void __user *mem, unsigned long len) __size_overflow(2);
 
 extern void __cmpxchg_wrong_size(void)
 	__compiletime_error("Bad argument size for cmpxchg");
@@ -591,22 +657,22 @@ extern void __cmpxchg_wrong_size(void)
 #define __user_atomic_cmpxchg_inatomic(uval, ptr, old, new, size)	\
 ({									\
 	int __ret = 0;							\
-	__typeof__(ptr) __uval = (uval);				\
-	__typeof__(*(ptr)) __old = (old);				\
-	__typeof__(*(ptr)) __new = (new);				\
+	__typeof__(uval) __uval = (uval);				\
+	__typeof__(*(uval)) __old = (old);				\
+	__typeof__(*(uval)) __new = (new);				\
 	__uaccess_begin();						\
 	switch (size) {							\
 	case 1:								\
 	{								\
 		asm volatile("\n"					\
-			"1:\t" LOCK_PREFIX "cmpxchgb %4, %2\n"		\
+			"1:\t" LOCK_PREFIX __copyuser_seg"cmpxchgb %4, %2\n"\
 			"2:\n"						\
 			"\t.section .fixup, \"ax\"\n"			\
 			"3:\tmov     %3, %0\n"				\
 			"\tjmp     2b\n"				\
 			"\t.previous\n"					\
 			_ASM_EXTABLE(1b, 3b)				\
-			: "+r" (__ret), "=a" (__old), "+m" (*(ptr))	\
+			: "+r" (__ret), "=a" (__old), "+m" (*____m(ptr))\
 			: "i" (-EFAULT), "q" (__new), "1" (__old)	\
 			: "memory"					\
 		);							\
@@ -615,14 +681,14 @@ extern void __cmpxchg_wrong_size(void)
 	case 2:								\
 	{								\
 		asm volatile("\n"					\
-			"1:\t" LOCK_PREFIX "cmpxchgw %4, %2\n"		\
+			"1:\t" LOCK_PREFIX __copyuser_seg"cmpxchgw %4, %2\n"\
 			"2:\n"						\
 			"\t.section .fixup, \"ax\"\n"			\
 			"3:\tmov     %3, %0\n"				\
 			"\tjmp     2b\n"				\
 			"\t.previous\n"					\
 			_ASM_EXTABLE(1b, 3b)				\
-			: "+r" (__ret), "=a" (__old), "+m" (*(ptr))	\
+			: "+r" (__ret), "=a" (__old), "+m" (*____m(ptr))\
 			: "i" (-EFAULT), "r" (__new), "1" (__old)	\
 			: "memory"					\
 		);							\
@@ -631,14 +697,14 @@ extern void __cmpxchg_wrong_size(void)
 	case 4:								\
 	{								\
 		asm volatile("\n"					\
-			"1:\t" LOCK_PREFIX "cmpxchgl %4, %2\n"		\
+			"1:\t" LOCK_PREFIX __copyuser_seg"cmpxchgl %4, %2\n"\
 			"2:\n"						\
 			"\t.section .fixup, \"ax\"\n"			\
 			"3:\tmov     %3, %0\n"				\
 			"\tjmp     2b\n"				\
 			"\t.previous\n"					\
 			_ASM_EXTABLE(1b, 3b)				\
-			: "+r" (__ret), "=a" (__old), "+m" (*(ptr))	\
+			: "+r" (__ret), "=a" (__old), "+m" (*____m(ptr))\
 			: "i" (-EFAULT), "r" (__new), "1" (__old)	\
 			: "memory"					\
 		);							\
@@ -650,14 +716,14 @@ extern void __cmpxchg_wrong_size(void)
 			__cmpxchg_wrong_size();				\
 									\
 		asm volatile("\n"					\
-			"1:\t" LOCK_PREFIX "cmpxchgq %4, %2\n"		\
+			"1:\t" LOCK_PREFIX __copyuser_seg"cmpxchgq %4, %2\n"\
 			"2:\n"						\
 			"\t.section .fixup, \"ax\"\n"			\
 			"3:\tmov     %3, %0\n"				\
 			"\tjmp     2b\n"				\
 			"\t.previous\n"					\
 			_ASM_EXTABLE(1b, 3b)				\
-			: "+r" (__ret), "=a" (__old), "+m" (*(ptr))	\
+			: "+r" (__ret), "=a" (__old), "+m" (*____m(ptr))\
 			: "i" (-EFAULT), "r" (__new), "1" (__old)	\
 			: "memory"					\
 		);							\
@@ -690,17 +756,6 @@ extern struct movsl_mask {
 
 #define ARCH_HAS_NOCACHE_UACCESS 1
 
-#ifdef CONFIG_X86_32
-# include <asm/uaccess_32.h>
-#else
-# include <asm/uaccess_64.h>
-#endif
-
-unsigned long __must_check _copy_from_user(void *to, const void __user *from,
-					   unsigned n);
-unsigned long __must_check _copy_to_user(void __user *to, const void *from,
-					 unsigned n);
-
 extern void __compiletime_error("usercopy buffer size is too small")
 __bad_copy_user(void);
 
@@ -709,22 +764,30 @@ static inline void copy_user_overflow(int size, unsigned long count)
 	WARN(1, "Buffer overflow detected (%d < %lu)!\n", size, count);
 }
 
+#ifdef CONFIG_X86_32
+# include <asm/uaccess_32.h>
+#else
+# include <asm/uaccess_64.h>
+#endif
+
 static __always_inline unsigned long __must_check
 copy_from_user(void *to, const void __user *from, unsigned long n)
 {
-	int sz = __compiletime_object_size(to);
+	size_t sz = __compiletime_object_size(to);
 
 	might_fault();
 
 	kasan_check_write(to, n);
 
-	if (likely(sz < 0 || sz >= n)) {
-		check_object_size(to, n, false);
-		n = _copy_from_user(to, from, n);
-	} else if (!__builtin_constant_p(n))
-		copy_user_overflow(sz, n);
-	else
-		__bad_copy_user();
+	if (unlikely(sz != (size_t)-1  && sz < n)) {
+		if (!__builtin_constant_p(n))
+			copy_user_overflow(sz, n);
+		else
+			__bad_copy_user();
+	} else if (access_ok(VERIFY_READ, from, n))
+		n = __copy_from_user(to, from, n);
+	else if ((long)n > 0)
+		memset(to, 0, n);
 
 	return n;
 }
@@ -732,19 +795,19 @@ copy_from_user(void *to, const void __user *from, unsigned long n)
 static __always_inline unsigned long __must_check
 copy_to_user(void __user *to, const void *from, unsigned long n)
 {
-	int sz = __compiletime_object_size(from);
+	size_t sz = __compiletime_object_size(from);
 
 	kasan_check_read(from, n);
 
 	might_fault();
 
-	if (likely(sz < 0 || sz >= n)) {
-		check_object_size(from, n, true);
-		n = _copy_to_user(to, from, n);
-	} else if (!__builtin_constant_p(n))
-		copy_user_overflow(sz, n);
-	else
-		__bad_copy_user();
+	if (unlikely(sz != (size_t)-1  && sz < n)) {
+		if (!__builtin_constant_p(n))
+			copy_user_overflow(sz, n);
+		else
+			__bad_copy_user();
+	} else if (access_ok(VERIFY_WRITE, to, n))
+		n = __copy_to_user(to, from, n);
 
 	return n;
 }
diff --git a/arch/x86/include/asm/uaccess_32.h b/arch/x86/include/asm/uaccess_32.h
index 7d3bdd1ed..67d81f675 100644
--- a/arch/x86/include/asm/uaccess_32.h
+++ b/arch/x86/include/asm/uaccess_32.h
@@ -34,9 +34,12 @@ unsigned long __must_check __copy_from_user_ll_nocache_nozero
  * The caller should also make sure he pins the user space address
  * so that we don't result in page fault and sleep.
  */
-static __always_inline unsigned long __must_check
+static __always_inline __size_overflow(3) unsigned long __must_check
 __copy_to_user_inatomic(void __user *to, const void *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
 	check_object_size(from, n, true);
 	return __copy_to_user_ll(to, from, n);
 }
@@ -60,12 +63,17 @@ static __always_inline unsigned long __must_check
 __copy_to_user(void __user *to, const void *from, unsigned long n)
 {
 	might_fault();
+
 	return __copy_to_user_inatomic(to, from, n);
 }
 
-static __always_inline unsigned long
+static __always_inline __size_overflow(3) unsigned long
 __copy_from_user_inatomic(void *to, const void __user *from, unsigned long n)
 {
+	if ((long)n < 0)
+		return n;
+
+	check_object_size(to, n, false);
 	return __copy_from_user_ll_nozero(to, from, n);
 }
 
@@ -96,6 +104,10 @@ static __always_inline unsigned long
 __copy_from_user(void *to, const void __user *from, unsigned long n)
 {
 	might_fault();
+
+	if ((long)n < 0)
+		return n;
+
 	check_object_size(to, n, false);
 	if (__builtin_constant_p(n)) {
 		unsigned long ret;
@@ -125,6 +137,11 @@ static __always_inline unsigned long __copy_from_user_nocache(void *to,
 				const void __user *from, unsigned long n)
 {
 	might_fault();
+
+	if ((long)n < 0)
+		return n;
+
+	check_object_size(to, n, false);
 	if (__builtin_constant_p(n)) {
 		unsigned long ret;
 
@@ -153,7 +170,11 @@ static __always_inline unsigned long
 __copy_from_user_inatomic_nocache(void *to, const void __user *from,
 				  unsigned long n)
 {
-       return __copy_from_user_ll_nocache_nozero(to, from, n);
+	if ((long)n < 0)
+		return n;
+
+	check_object_size(to, n, false);
+	return __copy_from_user_ll_nocache_nozero(to, from, n);
 }
 
 #endif /* _ASM_X86_UACCESS_32_H */
diff --git a/arch/x86/include/asm/uaccess_64.h b/arch/x86/include/asm/uaccess_64.h
index 673059a10..286a5bf65 100644
--- a/arch/x86/include/asm/uaccess_64.h
+++ b/arch/x86/include/asm/uaccess_64.h
@@ -11,6 +11,7 @@
 #include <asm/alternative.h>
 #include <asm/cpufeatures.h>
 #include <asm/page.h>
+#include <asm/pgtable.h>
 
 /*
  * Copy To/From Userspace
@@ -24,8 +25,8 @@ copy_user_generic_string(void *to, const void *from, unsigned len);
 __must_check unsigned long
 copy_user_generic_unrolled(void *to, const void *from, unsigned len);
 
-static __always_inline __must_check unsigned long
-copy_user_generic(void *to, const void *from, unsigned len)
+static __always_inline __must_check __size_overflow(3) unsigned long
+copy_user_generic(void *to, const void *from, unsigned long len)
 {
 	unsigned ret;
 
@@ -47,68 +48,86 @@ copy_user_generic(void *to, const void *from, unsigned len)
 }
 
 __must_check unsigned long
-copy_in_user(void __user *to, const void __user *from, unsigned len);
+copy_in_user(void __user *to, const void __user *from, unsigned long len);
 
 static __always_inline __must_check
-int __copy_from_user_nocheck(void *dst, const void __user *src, unsigned size)
+unsigned long __copy_from_user_nocheck(void *dst, const void __user *src, unsigned long size)
 {
-	int ret = 0;
+	size_t sz = __compiletime_object_size(dst);
+	unsigned ret = 0;
+
+	if (size > INT_MAX)
+		return size;
 
 	check_object_size(dst, size, false);
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (!access_ok_noprefault(VERIFY_READ, src, size))
+		return size;
+#endif
+
+	if (unlikely(sz != (size_t)-1 && sz < size)) {
+		 if(__builtin_constant_p(size))
+			__bad_copy_user();
+		else
+			copy_user_overflow(sz, size);
+		return size;
+	}
+
 	if (!__builtin_constant_p(size))
-		return copy_user_generic(dst, (__force void *)src, size);
+		return copy_user_generic(dst, (__force_kernel const void *)____m(src), size);
 	switch (size) {
 	case 1:
 		__uaccess_begin();
-		__get_user_asm(*(u8 *)dst, (u8 __user *)src,
+		__get_user_asm(*(u8 *)dst, (const u8 __user *)src,
 			      ret, "b", "b", "=q", 1);
 		__uaccess_end();
 		return ret;
 	case 2:
 		__uaccess_begin();
-		__get_user_asm(*(u16 *)dst, (u16 __user *)src,
+		__get_user_asm(*(u16 *)dst, (const u16 __user *)src,
 			      ret, "w", "w", "=r", 2);
 		__uaccess_end();
 		return ret;
 	case 4:
 		__uaccess_begin();
-		__get_user_asm(*(u32 *)dst, (u32 __user *)src,
+		__get_user_asm(*(u32 *)dst, (const u32 __user *)src,
 			      ret, "l", "k", "=r", 4);
 		__uaccess_end();
 		return ret;
 	case 8:
 		__uaccess_begin();
-		__get_user_asm(*(u64 *)dst, (u64 __user *)src,
+		__get_user_asm(*(u64 *)dst, (const u64 __user *)src,
 			      ret, "q", "", "=r", 8);
 		__uaccess_end();
 		return ret;
 	case 10:
 		__uaccess_begin();
-		__get_user_asm(*(u64 *)dst, (u64 __user *)src,
+		__get_user_asm(*(u64 *)dst, (const u64 __user *)src,
 			       ret, "q", "", "=r", 10);
 		if (likely(!ret))
 			__get_user_asm(*(u16 *)(8 + (char *)dst),
-				       (u16 __user *)(8 + (char __user *)src),
+				       (const u16 __user *)(8 + (const char __user *)src),
 				       ret, "w", "w", "=r", 2);
 		__uaccess_end();
 		return ret;
 	case 16:
 		__uaccess_begin();
-		__get_user_asm(*(u64 *)dst, (u64 __user *)src,
+		__get_user_asm(*(u64 *)dst, (const u64 __user *)src,
 			       ret, "q", "", "=r", 16);
 		if (likely(!ret))
 			__get_user_asm(*(u64 *)(8 + (char *)dst),
-				       (u64 __user *)(8 + (char __user *)src),
+				       (const u64 __user *)(8 + (const char __user *)src),
 				       ret, "q", "", "=r", 8);
 		__uaccess_end();
 		return ret;
 	default:
-		return copy_user_generic(dst, (__force void *)src, size);
+		return copy_user_generic(dst, (__force_kernel const void *)____m(src), size);
 	}
 }
 
 static __always_inline __must_check
-int __copy_from_user(void *dst, const void __user *src, unsigned size)
+unsigned long __copy_from_user(void *dst, const void __user *src, unsigned long size)
 {
 	might_fault();
 	kasan_check_write(dst, size);
@@ -116,67 +135,85 @@ int __copy_from_user(void *dst, const void __user *src, unsigned size)
 }
 
 static __always_inline __must_check
-int __copy_to_user_nocheck(void __user *dst, const void *src, unsigned size)
+unsigned long __copy_to_user_nocheck(void __user *dst, const void *src, unsigned long size)
 {
-	int ret = 0;
+	size_t sz = __compiletime_object_size(src);
+	unsigned ret = 0;
+
+	if (size > INT_MAX)
+		return size;
 
 	check_object_size(src, size, true);
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (!access_ok_noprefault(VERIFY_WRITE, dst, size))
+		return size;
+#endif
+
+	if (unlikely(sz != (size_t)-1 && sz < size)) {
+		 if(__builtin_constant_p(size))
+			__bad_copy_user();
+		else
+			copy_user_overflow(sz, size);
+		return size;
+	}
+
 	if (!__builtin_constant_p(size))
-		return copy_user_generic((__force void *)dst, src, size);
+		return copy_user_generic((__force_kernel void *)____m(dst), src, size);
 	switch (size) {
 	case 1:
 		__uaccess_begin();
-		__put_user_asm(*(u8 *)src, (u8 __user *)dst,
+		__put_user_asm(*(const u8 *)src, (u8 __user *)dst,
 			      ret, "b", "b", "iq", 1);
 		__uaccess_end();
 		return ret;
 	case 2:
 		__uaccess_begin();
-		__put_user_asm(*(u16 *)src, (u16 __user *)dst,
+		__put_user_asm(*(const u16 *)src, (u16 __user *)dst,
 			      ret, "w", "w", "ir", 2);
 		__uaccess_end();
 		return ret;
 	case 4:
 		__uaccess_begin();
-		__put_user_asm(*(u32 *)src, (u32 __user *)dst,
+		__put_user_asm(*(const u32 *)src, (u32 __user *)dst,
 			      ret, "l", "k", "ir", 4);
 		__uaccess_end();
 		return ret;
 	case 8:
 		__uaccess_begin();
-		__put_user_asm(*(u64 *)src, (u64 __user *)dst,
+		__put_user_asm(*(const u64 *)src, (u64 __user *)dst,
 			      ret, "q", "", "er", 8);
 		__uaccess_end();
 		return ret;
 	case 10:
 		__uaccess_begin();
-		__put_user_asm(*(u64 *)src, (u64 __user *)dst,
+		__put_user_asm(*(const u64 *)src, (u64 __user *)dst,
 			       ret, "q", "", "er", 10);
 		if (likely(!ret)) {
 			asm("":::"memory");
-			__put_user_asm(4[(u16 *)src], 4 + (u16 __user *)dst,
+			__put_user_asm(4[(const u16 *)src], 4 + (u16 __user *)dst,
 				       ret, "w", "w", "ir", 2);
 		}
 		__uaccess_end();
 		return ret;
 	case 16:
 		__uaccess_begin();
-		__put_user_asm(*(u64 *)src, (u64 __user *)dst,
+		__put_user_asm(*(const u64 *)src, (u64 __user *)dst,
 			       ret, "q", "", "er", 16);
 		if (likely(!ret)) {
 			asm("":::"memory");
-			__put_user_asm(1[(u64 *)src], 1 + (u64 __user *)dst,
+			__put_user_asm(1[(const u64 *)src], 1 + (u64 __user *)dst,
 				       ret, "q", "", "er", 8);
 		}
 		__uaccess_end();
 		return ret;
 	default:
-		return copy_user_generic((__force void *)dst, src, size);
+		return copy_user_generic((__force_kernel void *)____m(dst), src, size);
 	}
 }
 
 static __always_inline __must_check
-int __copy_to_user(void __user *dst, const void *src, unsigned size)
+unsigned long __copy_to_user(void __user *dst, const void *src, unsigned long size)
 {
 	might_fault();
 	kasan_check_read(src, size);
@@ -184,19 +221,30 @@ int __copy_to_user(void __user *dst, const void *src, unsigned size)
 }
 
 static __always_inline __must_check
-int __copy_in_user(void __user *dst, const void __user *src, unsigned size)
+unsigned long __copy_in_user(void __user *dst, const void __user *src, unsigned size)
 {
-	int ret = 0;
+	unsigned ret = 0;
 
 	might_fault();
+
+	if (size > INT_MAX)
+		return size;
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (!access_ok_noprefault(VERIFY_READ, src, size))
+		return size;
+	if (!access_ok_noprefault(VERIFY_WRITE, dst, size))
+		return size;
+#endif
+
 	if (!__builtin_constant_p(size))
-		return copy_user_generic((__force void *)dst,
-					 (__force void *)src, size);
+		return copy_user_generic((__force_kernel void *)____m(dst),
+					 (__force_kernel const void *)____m(src), size);
 	switch (size) {
 	case 1: {
 		u8 tmp;
 		__uaccess_begin();
-		__get_user_asm(tmp, (u8 __user *)src,
+		__get_user_asm(tmp, (const u8 __user *)src,
 			       ret, "b", "b", "=q", 1);
 		if (likely(!ret))
 			__put_user_asm(tmp, (u8 __user *)dst,
@@ -207,7 +255,7 @@ int __copy_in_user(void __user *dst, const void __user *src, unsigned size)
 	case 2: {
 		u16 tmp;
 		__uaccess_begin();
-		__get_user_asm(tmp, (u16 __user *)src,
+		__get_user_asm(tmp, (const u16 __user *)src,
 			       ret, "w", "w", "=r", 2);
 		if (likely(!ret))
 			__put_user_asm(tmp, (u16 __user *)dst,
@@ -219,7 +267,7 @@ int __copy_in_user(void __user *dst, const void __user *src, unsigned size)
 	case 4: {
 		u32 tmp;
 		__uaccess_begin();
-		__get_user_asm(tmp, (u32 __user *)src,
+		__get_user_asm(tmp, (const u32 __user *)src,
 			       ret, "l", "k", "=r", 4);
 		if (likely(!ret))
 			__put_user_asm(tmp, (u32 __user *)dst,
@@ -230,7 +278,7 @@ int __copy_in_user(void __user *dst, const void __user *src, unsigned size)
 	case 8: {
 		u64 tmp;
 		__uaccess_begin();
-		__get_user_asm(tmp, (u64 __user *)src,
+		__get_user_asm(tmp, (const u64 __user *)src,
 			       ret, "q", "", "=r", 8);
 		if (likely(!ret))
 			__put_user_asm(tmp, (u64 __user *)dst,
@@ -239,45 +287,67 @@ int __copy_in_user(void __user *dst, const void __user *src, unsigned size)
 		return ret;
 	}
 	default:
-		return copy_user_generic((__force void *)dst,
-					 (__force void *)src, size);
+		return copy_user_generic((__force_kernel void *)____m(dst),
+					 (__force_kernel const void *)____m(src), size);
 	}
 }
 
-static __must_check __always_inline int
-__copy_from_user_inatomic(void *dst, const void __user *src, unsigned size)
+static __must_check __always_inline unsigned long
+__copy_from_user_inatomic(void *dst, const void __user *src, unsigned long size)
 {
 	kasan_check_write(dst, size);
 	return __copy_from_user_nocheck(dst, src, size);
 }
 
-static __must_check __always_inline int
-__copy_to_user_inatomic(void __user *dst, const void *src, unsigned size)
+static __must_check __always_inline unsigned long
+__copy_to_user_inatomic(void __user *dst, const void *src, unsigned long size)
 {
 	kasan_check_read(src, size);
 	return __copy_to_user_nocheck(dst, src, size);
 }
 
-extern long __copy_user_nocache(void *dst, const void __user *src,
-				unsigned size, int zerorest);
+extern unsigned long __copy_user_nocache(void *dst, const void __user *src,
+				unsigned long size, int zerorest) __size_overflow(3);
 
-static inline int
-__copy_from_user_nocache(void *dst, const void __user *src, unsigned size)
+static inline unsigned long
+__copy_from_user_nocache(void *dst, const void __user *src, unsigned long size)
 {
 	might_fault();
 	kasan_check_write(dst, size);
+
+	if (size > INT_MAX)
+		return size;
+
+	check_object_size(dst, size, false);
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (!access_ok_noprefault(VERIFY_READ, src, size))
+		return size;
+#endif
+
 	return __copy_user_nocache(dst, src, size, 1);
 }
 
-static inline int
+static inline unsigned long
 __copy_from_user_inatomic_nocache(void *dst, const void __user *src,
-				  unsigned size)
+				  unsigned long size)
 {
 	kasan_check_write(dst, size);
+
+	if (size > INT_MAX)
+		return size;
+
+	check_object_size(dst, size, false);
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (!access_ok_noprefault(VERIFY_READ, src, size))
+		return size;
+#endif
+
 	return __copy_user_nocache(dst, src, size, 0);
 }
 
 unsigned long
-copy_user_handle_tail(char *to, char *from, unsigned len);
+copy_user_handle_tail(char __user *to, char __user *from, unsigned long len) __size_overflow(3);
 
 #endif /* _ASM_X86_UACCESS_64_H */
diff --git a/arch/x86/include/asm/word-at-a-time.h b/arch/x86/include/asm/word-at-a-time.h
index 5b2389815..77fdd78ba 100644
--- a/arch/x86/include/asm/word-at-a-time.h
+++ b/arch/x86/include/asm/word-at-a-time.h
@@ -11,7 +11,7 @@
  * and shift, for example.
  */
 struct word_at_a_time {
-	const unsigned long one_bits, high_bits;
+	unsigned long one_bits, high_bits;
 };
 
 #define WORD_AT_A_TIME_CONSTANTS { REPEAT_BYTE(0x01), REPEAT_BYTE(0x80) }
diff --git a/arch/x86/include/asm/x86_init.h b/arch/x86/include/asm/x86_init.h
index 6ba793178..dc843cd7d 100644
--- a/arch/x86/include/asm/x86_init.h
+++ b/arch/x86/include/asm/x86_init.h
@@ -126,7 +126,7 @@ struct x86_init_ops {
 	struct x86_init_timers		timers;
 	struct x86_init_iommu		iommu;
 	struct x86_init_pci		pci;
-};
+} __no_const;
 
 /**
  * struct x86_cpuinit_ops - platform specific cpu hotplug setups
@@ -137,7 +137,7 @@ struct x86_cpuinit_ops {
 	void (*setup_percpu_clockev)(void);
 	void (*early_percpu_clock_init)(void);
 	void (*fixup_cpu_id)(struct cpuinfo_x86 *c, int node);
-};
+} __no_const;
 
 struct timespec;
 
@@ -225,12 +225,12 @@ struct x86_msi_ops {
 	void (*teardown_msi_irq)(unsigned int irq);
 	void (*teardown_msi_irqs)(struct pci_dev *dev);
 	void (*restore_msi_irqs)(struct pci_dev *dev);
-};
+} __no_const;
 
 struct x86_io_apic_ops {
 	unsigned int	(*read)   (unsigned int apic, unsigned int reg);
 	void		(*disable)(void);
-};
+} __no_const;
 
 extern struct x86_init_ops x86_init;
 extern struct x86_cpuinit_ops x86_cpuinit;
diff --git a/arch/x86/include/asm/xen/page.h b/arch/x86/include/asm/xen/page.h
index f5fb840b4..e45184eb3 100644
--- a/arch/x86/include/asm/xen/page.h
+++ b/arch/x86/include/asm/xen/page.h
@@ -82,7 +82,7 @@ static inline int xen_safe_read_ulong(unsigned long *addr, unsigned long *val)
  * - get_phys_to_machine() is to be called by __pfn_to_mfn() only in special
  *   cases needing an extended handling.
  */
-static inline unsigned long __pfn_to_mfn(unsigned long pfn)
+static inline unsigned long __intentional_overflow(-1) __pfn_to_mfn(unsigned long pfn)
 {
 	unsigned long mfn;
 
diff --git a/arch/x86/include/uapi/asm/e820.h b/arch/x86/include/uapi/asm/e820.h
index 9dafe59cf..0293c1d70 100644
--- a/arch/x86/include/uapi/asm/e820.h
+++ b/arch/x86/include/uapi/asm/e820.h
@@ -69,7 +69,7 @@ struct e820map {
 #define ISA_START_ADDRESS	0xa0000
 #define ISA_END_ADDRESS		0x100000
 
-#define BIOS_BEGIN		0x000a0000
+#define BIOS_BEGIN		0x000c0000
 #define BIOS_END		0x00100000
 
 #define BIOS_ROM_BASE		0xffe00000
diff --git a/arch/x86/kernel/Makefile b/arch/x86/kernel/Makefile
index 0503f5bfb..f00b6e838 100644
--- a/arch/x86/kernel/Makefile
+++ b/arch/x86/kernel/Makefile
@@ -46,7 +46,7 @@ obj-$(CONFIG_MODIFY_LDT_SYSCALL)	+= ldt.o
 obj-y			+= setup.o x86_init.o i8259.o irqinit.o jump_label.o
 obj-$(CONFIG_IRQ_WORK)  += irq_work.o
 obj-y			+= probe_roms.o
-obj-$(CONFIG_X86_32)	+= i386_ksyms_32.o
+obj-$(CONFIG_X86_32)	+= sys_i386_32.o i386_ksyms_32.o
 obj-$(CONFIG_X86_64)	+= sys_x86_64.o x8664_ksyms_64.o
 obj-$(CONFIG_X86_64)	+= mcount_64.o
 obj-$(CONFIG_X86_ESPFIX64)	+= espfix_64.o
diff --git a/arch/x86/kernel/acpi/boot.c b/arch/x86/kernel/acpi/boot.c
index d99ca57cb..b63aafcac 100644
--- a/arch/x86/kernel/acpi/boot.c
+++ b/arch/x86/kernel/acpi/boot.c
@@ -1358,7 +1358,7 @@ static void __init acpi_reduced_hw_init(void)
  * If your system is blacklisted here, but you find that acpi=force
  * works for you, please contact linux-acpi@vger.kernel.org
  */
-static struct dmi_system_id __initdata acpi_dmi_table[] = {
+static const struct dmi_system_id __initconst acpi_dmi_table[] = {
 	/*
 	 * Boxes that need ACPI disabled
 	 */
@@ -1433,7 +1433,7 @@ static struct dmi_system_id __initdata acpi_dmi_table[] = {
 };
 
 /* second table for DMI checks that should run after early-quirks */
-static struct dmi_system_id __initdata acpi_dmi_table_late[] = {
+static const struct dmi_system_id __initconst acpi_dmi_table_late[] = {
 	/*
 	 * HP laptops which use a DSDT reporting as HP/SB400/10000,
 	 * which includes some code which overrides all temperature
diff --git a/arch/x86/kernel/acpi/sleep.c b/arch/x86/kernel/acpi/sleep.c
index adb3eaf8f..0eb666c2a 100644
--- a/arch/x86/kernel/acpi/sleep.c
+++ b/arch/x86/kernel/acpi/sleep.c
@@ -100,8 +100,12 @@ int x86_acpi_suspend_lowlevel(void)
 #else /* CONFIG_64BIT */
 #ifdef CONFIG_SMP
 	stack_start = (unsigned long)temp_stack + sizeof(temp_stack);
+
+	pax_open_kernel();
 	early_gdt_descr.address =
 			(unsigned long)get_cpu_gdt_table(smp_processor_id());
+	pax_close_kernel();
+
 	initial_gs = per_cpu_offset(smp_processor_id());
 #endif
 	initial_code = (unsigned long)wakeup_long64;
diff --git a/arch/x86/kernel/acpi/wakeup_32.S b/arch/x86/kernel/acpi/wakeup_32.S
index 0c26b1b44..9120e26ee 100644
--- a/arch/x86/kernel/acpi/wakeup_32.S
+++ b/arch/x86/kernel/acpi/wakeup_32.S
@@ -2,6 +2,7 @@
 #include <linux/linkage.h>
 #include <asm/segment.h>
 #include <asm/page_types.h>
+#include <asm/smap.h>
 
 # Copyright 2003, 2008 Pavel Machek <pavel@suse.cz>, distribute under GPLv2
 
@@ -31,13 +32,11 @@ wakeup_pmode_return:
 	# and restore the stack ... but you need gdt for this to work
 	movl	saved_context_esp, %esp
 
-	movl	%cs:saved_magic, %eax
-	cmpl	$0x12345678, %eax
+	cmpl	$0x12345678, saved_magic
 	jne	bogus_magic
 
 	# jump to place where we left off
-	movl	saved_eip, %eax
-	jmp	*%eax
+	jmp	*(saved_eip)
 
 bogus_magic:
 	jmp	bogus_magic
@@ -69,6 +68,7 @@ restore_registers:
 	movl	saved_context_edi, %edi
 	pushl	saved_context_eflags
 	popfl
+	ASM_CLAC
 	ret
 
 ENTRY(do_suspend_lowlevel)
diff --git a/arch/x86/kernel/acpi/wakeup_64.S b/arch/x86/kernel/acpi/wakeup_64.S
index 169963f47..d5caf113c 100644
--- a/arch/x86/kernel/acpi/wakeup_64.S
+++ b/arch/x86/kernel/acpi/wakeup_64.S
@@ -6,6 +6,7 @@
 #include <asm/msr.h>
 #include <asm/asm-offsets.h>
 #include <asm/frame.h>
+#include <asm/smap.h>
 
 # Copyright 2003 Pavel Machek <pavel@suse.cz>, distribute under GPLv2
 
@@ -93,6 +94,7 @@ ENTRY(do_suspend_lowlevel)
 	movq	%rbx, %cr0
 	pushq	pt_regs_flags(%rax)
 	popfq
+	ASM_CLAC
 	movq	pt_regs_sp(%rax), %rsp
 	movq	pt_regs_bp(%rax), %rbp
 	movq	pt_regs_si(%rax), %rsi
diff --git a/arch/x86/kernel/alternative.c b/arch/x86/kernel/alternative.c
index 5cb272a7a..d22cf7902 100644
--- a/arch/x86/kernel/alternative.c
+++ b/arch/x86/kernel/alternative.c
@@ -21,6 +21,7 @@
 #include <asm/tlbflush.h>
 #include <asm/io.h>
 #include <asm/fixmap.h>
+#include <asm/boot.h>
 
 int __read_mostly alternatives_patched;
 
@@ -262,7 +263,9 @@ static void __init_or_module add_nops(void *insns, unsigned int len)
 		unsigned int noplen = len;
 		if (noplen > ASM_NOP_MAX)
 			noplen = ASM_NOP_MAX;
+		pax_open_kernel();
 		memcpy(insns, ideal_nops[noplen], noplen);
+		pax_close_kernel();
 		insns += noplen;
 		len -= noplen;
 	}
@@ -290,6 +293,13 @@ recompute_jump(struct alt_instr *a, u8 *orig_insn, u8 *repl_insn, u8 *insnbuf)
 	if (a->replacementlen != 5)
 		return;
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	if (orig_insn < (u8 *)_text || (u8 *)_einittext <= orig_insn)
+		orig_insn = (u8 *)ktva_ktla((unsigned long)orig_insn);
+	else
+		orig_insn -= ____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR;
+#endif
+
 	o_dspl = *(s32 *)(insnbuf + 1);
 
 	/* next_rip of the replacement JMP */
@@ -365,6 +375,7 @@ void __init_or_module apply_alternatives(struct alt_instr *start,
 {
 	struct alt_instr *a;
 	u8 *instr, *replacement;
+	u8 *vinstr, *vreplacement;
 	u8 insnbuf[MAX_PATCH_LEN];
 
 	DPRINTK("alt table %p -> %p", start, end);
@@ -380,46 +391,71 @@ void __init_or_module apply_alternatives(struct alt_instr *start,
 	for (a = start; a < end; a++) {
 		int insnbuf_sz = 0;
 
-		instr = (u8 *)&a->instr_offset + a->instr_offset;
-		replacement = (u8 *)&a->repl_offset + a->repl_offset;
+		vinstr = instr = (u8 *)&a->instr_offset + a->instr_offset;
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		if ((u8 *)_text - (____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR) <= instr &&
+		    instr < (u8 *)_einittext - (____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR)) {
+			instr += ____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR;
+			vinstr = (u8 *)ktla_ktva((unsigned long)instr);
+		} else if ((u8 *)_text <= instr && instr < (u8 *)_einittext) {
+			vinstr = (u8 *)ktla_ktva((unsigned long)instr);
+		} else {
+			instr = (u8 *)ktva_ktla((unsigned long)instr);
+		}
+#endif
+
+		vreplacement = replacement = (u8 *)&a->repl_offset + a->repl_offset;
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		if ((u8 *)_text - (____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR) <= replacement &&
+		    replacement < (u8 *)_einittext - (____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR)) {
+			replacement += ____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR;
+			vreplacement = (u8 *)ktla_ktva((unsigned long)replacement);
+		} else if ((u8 *)_text <= replacement && replacement < (u8 *)_einittext) {
+			vreplacement = (u8 *)ktla_ktva((unsigned long)replacement);
+		} else
+			replacement = (u8 *)ktva_ktla((unsigned long)replacement);
+#endif
+
 		BUG_ON(a->instrlen > sizeof(insnbuf));
 		BUG_ON(a->cpuid >= (NCAPINTS + NBUGINTS) * 32);
 		if (!boot_cpu_has(a->cpuid)) {
 			if (a->padlen > 1)
-				optimize_nops(a, instr);
+				optimize_nops(a, vinstr);
 
 			continue;
 		}
 
-		DPRINTK("feat: %d*32+%d, old: (%p, len: %d), repl: (%p, len: %d), pad: %d",
+		DPRINTK("feat: %d*32+%d, old: (%p/%p, len: %d), repl: (%p, len: %d), pad: %d",
 			a->cpuid >> 5,
 			a->cpuid & 0x1f,
-			instr, a->instrlen,
-			replacement, a->replacementlen, a->padlen);
+			instr, vinstr, a->instrlen,
+			vreplacement, a->replacementlen, a->padlen);
 
-		DUMP_BYTES(instr, a->instrlen, "%p: old_insn: ", instr);
-		DUMP_BYTES(replacement, a->replacementlen, "%p: rpl_insn: ", replacement);
+		DUMP_BYTES(vinstr, a->instrlen, "%p: old_insn: ", vinstr);
+		DUMP_BYTES(vreplacement, a->replacementlen, "%p: rpl_insn: ", vreplacement);
 
-		memcpy(insnbuf, replacement, a->replacementlen);
+		memcpy(insnbuf, vreplacement, a->replacementlen);
 		insnbuf_sz = a->replacementlen;
 
 		/* 0xe8 is a relative jump; fix the offset. */
 		if (*insnbuf == 0xe8 && a->replacementlen == 5) {
-			*(s32 *)(insnbuf + 1) += replacement - instr;
+			*(s32 *)(insnbuf + 1) += vreplacement - instr;
 			DPRINTK("Fix CALL offset: 0x%x, CALL 0x%lx",
 				*(s32 *)(insnbuf + 1),
-				(unsigned long)instr + *(s32 *)(insnbuf + 1) + 5);
+				(unsigned long)vinstr + *(s32 *)(insnbuf + 1) + 5);
 		}
 
-		if (a->replacementlen && is_jmp(replacement[0]))
-			recompute_jump(a, instr, replacement, insnbuf);
+		if (a->replacementlen && is_jmp(vreplacement[0]))
+			recompute_jump(a, instr, vreplacement, insnbuf);
 
 		if (a->instrlen > a->replacementlen) {
 			add_nops(insnbuf + a->replacementlen,
 				 a->instrlen - a->replacementlen);
 			insnbuf_sz += a->instrlen - a->replacementlen;
 		}
-		DUMP_BYTES(insnbuf, insnbuf_sz, "%p: final_insn: ", instr);
+		DUMP_BYTES(insnbuf, insnbuf_sz, "%p: final_insn: ", vinstr);
 
 		text_poke_early(instr, insnbuf, insnbuf_sz);
 	}
@@ -435,10 +471,16 @@ static void alternatives_smp_lock(const s32 *start, const s32 *end,
 	for (poff = start; poff < end; poff++) {
 		u8 *ptr = (u8 *)poff + *poff;
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		ptr += ____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR;
+		if (ptr < (u8 *)_text || (u8 *)_einittext <= ptr)
+			ptr -= ____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR;
+#endif
+
 		if (!*poff || ptr < text || ptr >= text_end)
 			continue;
 		/* turn DS segment override prefix into lock prefix */
-		if (*ptr == 0x3e)
+		if (*(u8 *)ktla_ktva((unsigned long)ptr) == 0x3e)
 			text_poke(ptr, ((unsigned char []){0xf0}), 1);
 	}
 	mutex_unlock(&text_mutex);
@@ -453,10 +495,16 @@ static void alternatives_smp_unlock(const s32 *start, const s32 *end,
 	for (poff = start; poff < end; poff++) {
 		u8 *ptr = (u8 *)poff + *poff;
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		ptr += ____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR;
+		if (ptr < (u8 *)_text || (u8 *)_einittext <= ptr)
+			ptr -= ____LOAD_PHYSICAL_ADDR - LOAD_PHYSICAL_ADDR;
+#endif
+
 		if (!*poff || ptr < text || ptr >= text_end)
 			continue;
 		/* turn lock prefix into DS segment override prefix */
-		if (*ptr == 0xf0)
+		if (*(u8 *)ktla_ktva((unsigned long)ptr) == 0xf0)
 			text_poke(ptr, ((unsigned char []){0x3E}), 1);
 	}
 	mutex_unlock(&text_mutex);
@@ -545,7 +593,9 @@ void alternatives_enable_smp(void)
 	if (uniproc_patched) {
 		pr_info("switching to SMP code\n");
 		BUG_ON(num_online_cpus() != 1);
+		pax_open_kernel();
 		clear_cpu_cap(&boot_cpu_data, X86_FEATURE_UP);
+		pax_close_kernel();
 		clear_cpu_cap(&cpu_data(0), X86_FEATURE_UP);
 		list_for_each_entry(mod, &smp_alt_modules, next)
 			alternatives_smp_lock(mod->locks, mod->locks_end,
@@ -593,7 +643,7 @@ void __init_or_module apply_paravirt(struct paravirt_patch_site *start,
 
 		BUG_ON(p->len > MAX_PATCH_LEN);
 		/* prep the buffer with the original instructions */
-		memcpy(insnbuf, p->instr, p->len);
+		memcpy(insnbuf, (const void *)ktla_ktva((unsigned long)p->instr), p->len);
 		used = pv_init_ops.patch(p->instrtype, p->clobbers, insnbuf,
 					 (unsigned long)p->instr, p->len);
 
@@ -640,7 +690,7 @@ void __init alternative_instructions(void)
 	if (!uniproc_patched || num_possible_cpus() == 1)
 		free_init_pages("SMP alternatives",
 				(unsigned long)__smp_locks,
-				(unsigned long)__smp_locks_end);
+				PAGE_ALIGN((unsigned long)__smp_locks_end));
 #endif
 
 	apply_paravirt(__parainstructions, __parainstructions_end);
@@ -661,13 +711,17 @@ void __init alternative_instructions(void)
  * instructions. And on the local CPU you need to be protected again NMI or MCE
  * handlers seeing an inconsistent instruction while you patch.
  */
-void *__init_or_module text_poke_early(void *addr, const void *opcode,
+void *__kprobes text_poke_early(void *addr, const void *opcode,
 					      size_t len)
 {
 	unsigned long flags;
 	local_irq_save(flags);
-	memcpy(addr, opcode, len);
+
+	pax_open_kernel();
+	memcpy((void *)ktla_ktva((unsigned long)addr), opcode, len);
 	sync_core();
+	pax_close_kernel();
+
 	local_irq_restore(flags);
 	/* Could also do a CLFLUSH here to speed up CPU recovery; but
 	   that causes hangs on some VIA CPUs. */
@@ -689,20 +743,29 @@ void *__init_or_module text_poke_early(void *addr, const void *opcode,
  */
 void *text_poke(void *addr, const void *opcode, size_t len)
 {
-	unsigned long flags;
-	char *vaddr;
+	unsigned char *vaddr = (void *)ktla_ktva((unsigned long)addr);
 	struct page *pages[2];
-	int i;
+	size_t i;
+
+#ifndef CONFIG_PAX_KERNEXEC
+	unsigned long flags;
+#endif
 
 	if (!core_kernel_text((unsigned long)addr)) {
-		pages[0] = vmalloc_to_page(addr);
-		pages[1] = vmalloc_to_page(addr + PAGE_SIZE);
+		pages[0] = vmalloc_to_page(vaddr);
+		pages[1] = vmalloc_to_page(vaddr + PAGE_SIZE);
 	} else {
-		pages[0] = virt_to_page(addr);
+		pages[0] = virt_to_page(vaddr);
 		WARN_ON(!PageReserved(pages[0]));
-		pages[1] = virt_to_page(addr + PAGE_SIZE);
+		pages[1] = virt_to_page(vaddr + PAGE_SIZE);
 	}
 	BUG_ON(!pages[0]);
+
+#ifdef CONFIG_PAX_KERNEXEC
+	text_poke_early(addr, opcode, len);
+	for (i = 0; i < len; i++)
+		BUG_ON((vaddr)[i] != ((const unsigned char *)opcode)[i]);
+#else
 	local_irq_save(flags);
 	set_fixmap(FIX_TEXT_POKE0, page_to_phys(pages[0]));
 	if (pages[1])
@@ -719,6 +782,7 @@ void *text_poke(void *addr, const void *opcode, size_t len)
 	for (i = 0; i < len; i++)
 		BUG_ON(((char *)addr)[i] != ((char *)opcode)[i]);
 	local_irq_restore(flags);
+#endif
 	return addr;
 }
 
@@ -772,7 +836,7 @@ int poke_int3_handler(struct pt_regs *regs)
  */
 void *text_poke_bp(void *addr, const void *opcode, size_t len, void *handler)
 {
-	unsigned char int3 = 0xcc;
+	const unsigned char int3 = 0xcc;
 
 	bp_int3_handler = handler;
 	bp_int3_addr = (u8 *)addr + sizeof(int3);
diff --git a/arch/x86/kernel/apic/apic.c b/arch/x86/kernel/apic/apic.c
index 076c315cd..88957c613 100644
--- a/arch/x86/kernel/apic/apic.c
+++ b/arch/x86/kernel/apic/apic.c
@@ -181,7 +181,7 @@ int first_system_vector = FIRST_SYSTEM_VECTOR;
 /*
  * Debug level, exported for io_apic.c
  */
-unsigned int apic_verbosity;
+int apic_verbosity;
 
 int pic_mode;
 
@@ -1905,7 +1905,7 @@ static void __smp_error_interrupt(struct pt_regs *regs)
 		apic_write(APIC_ESR, 0);
 	v = apic_read(APIC_ESR);
 	ack_APIC_irq();
-	atomic_inc(&irq_err_count);
+	atomic_inc_unchecked(&irq_err_count);
 
 	apic_printk(APIC_DEBUG, KERN_DEBUG "APIC error on CPU%d: %02x",
 		    smp_processor_id(), v);
diff --git a/arch/x86/kernel/apic/apic_flat_64.c b/arch/x86/kernel/apic/apic_flat_64.c
index 5b2ae106b..b3551c00a 100644
--- a/arch/x86/kernel/apic/apic_flat_64.c
+++ b/arch/x86/kernel/apic/apic_flat_64.c
@@ -25,7 +25,7 @@
 static struct apic apic_physflat;
 static struct apic apic_flat;
 
-struct apic __read_mostly *apic = &apic_flat;
+struct apic *apic __read_only = &apic_flat;
 EXPORT_SYMBOL_GPL(apic);
 
 static int flat_acpi_madt_oem_check(char *oem_id, char *oem_table_id)
@@ -154,7 +154,7 @@ static int flat_probe(void)
 	return 1;
 }
 
-static struct apic apic_flat =  {
+static struct apic apic_flat __read_only =  {
 	.name				= "flat",
 	.probe				= flat_probe,
 	.acpi_madt_oem_check		= flat_acpi_madt_oem_check,
@@ -248,7 +248,7 @@ static int physflat_probe(void)
 	return 0;
 }
 
-static struct apic apic_physflat =  {
+static struct apic apic_physflat __read_only =  {
 
 	.name				= "physical flat",
 	.probe				= physflat_probe,
diff --git a/arch/x86/kernel/apic/apic_noop.c b/arch/x86/kernel/apic/apic_noop.c
index c05688b2d..a250c5a6d 100644
--- a/arch/x86/kernel/apic/apic_noop.c
+++ b/arch/x86/kernel/apic/apic_noop.c
@@ -108,7 +108,7 @@ static void noop_apic_write(u32 reg, u32 v)
 	WARN_ON_ONCE(boot_cpu_has(X86_FEATURE_APIC) && !disable_apic);
 }
 
-struct apic apic_noop = {
+struct apic apic_noop __read_only = {
 	.name				= "noop",
 	.probe				= noop_probe,
 	.acpi_madt_oem_check		= NULL,
diff --git a/arch/x86/kernel/apic/bigsmp_32.c b/arch/x86/kernel/apic/bigsmp_32.c
index 06dbaa458..817a7bb27 100644
--- a/arch/x86/kernel/apic/bigsmp_32.c
+++ b/arch/x86/kernel/apic/bigsmp_32.c
@@ -142,7 +142,7 @@ static int probe_bigsmp(void)
 	return dmi_bigsmp;
 }
 
-static struct apic apic_bigsmp = {
+static struct apic apic_bigsmp __read_only = {
 
 	.name				= "bigsmp",
 	.probe				= probe_bigsmp,
diff --git a/arch/x86/kernel/apic/io_apic.c b/arch/x86/kernel/apic/io_apic.c
index 48e6d84f1..fdefc5776 100644
--- a/arch/x86/kernel/apic/io_apic.c
+++ b/arch/x86/kernel/apic/io_apic.c
@@ -1683,7 +1683,7 @@ static unsigned int startup_ioapic_irq(struct irq_data *data)
 	return was_pending;
 }
 
-atomic_t irq_mis_count;
+atomic_unchecked_t irq_mis_count;
 
 #ifdef CONFIG_GENERIC_PENDING_IRQ
 static bool io_apic_level_ack_pending(struct mp_chip_data *data)
@@ -1822,7 +1822,7 @@ static void ioapic_ack_level(struct irq_data *irq_data)
 	 * at the cpu.
 	 */
 	if (!(v & (1 << (i & 0x1f)))) {
-		atomic_inc(&irq_mis_count);
+		atomic_inc_unchecked(&irq_mis_count);
 		eoi_ioapic_pin(cfg->vector, irq_data->chip_data);
 	}
 
@@ -1868,7 +1868,7 @@ static int ioapic_set_affinity(struct irq_data *irq_data,
 	return ret;
 }
 
-static struct irq_chip ioapic_chip __read_mostly = {
+static struct irq_chip ioapic_chip = {
 	.name			= "IO-APIC",
 	.irq_startup		= startup_ioapic_irq,
 	.irq_mask		= mask_ioapic_irq,
@@ -1879,7 +1879,7 @@ static struct irq_chip ioapic_chip __read_mostly = {
 	.flags			= IRQCHIP_SKIP_SET_WAKE,
 };
 
-static struct irq_chip ioapic_ir_chip __read_mostly = {
+static struct irq_chip ioapic_ir_chip = {
 	.name			= "IR-IO-APIC",
 	.irq_startup		= startup_ioapic_irq,
 	.irq_mask		= mask_ioapic_irq,
@@ -1937,7 +1937,7 @@ static void ack_lapic_irq(struct irq_data *data)
 	ack_APIC_irq();
 }
 
-static struct irq_chip lapic_chip __read_mostly = {
+static struct irq_chip lapic_chip = {
 	.name		= "local-APIC",
 	.irq_mask	= mask_lapic_irq,
 	.irq_unmask	= unmask_lapic_irq,
diff --git a/arch/x86/kernel/apic/msi.c b/arch/x86/kernel/apic/msi.c
index ade25320d..5fc7f4f96 100644
--- a/arch/x86/kernel/apic/msi.c
+++ b/arch/x86/kernel/apic/msi.c
@@ -269,7 +269,7 @@ static void hpet_msi_write_msg(struct irq_data *data, struct msi_msg *msg)
 	hpet_msi_write(irq_data_get_irq_handler_data(data), msg);
 }
 
-static struct irq_chip hpet_msi_controller = {
+static irq_chip_no_const hpet_msi_controller __read_only = {
 	.name = "HPET-MSI",
 	.irq_unmask = hpet_msi_unmask,
 	.irq_mask = hpet_msi_mask,
diff --git a/arch/x86/kernel/apic/probe_32.c b/arch/x86/kernel/apic/probe_32.c
index 563096267..0ed042c6e 100644
--- a/arch/x86/kernel/apic/probe_32.c
+++ b/arch/x86/kernel/apic/probe_32.c
@@ -72,7 +72,7 @@ static int probe_default(void)
 	return 1;
 }
 
-static struct apic apic_default = {
+static struct apic apic_default __read_only = {
 
 	.name				= "default",
 	.probe				= probe_default,
@@ -126,7 +126,7 @@ static struct apic apic_default = {
 
 apic_driver(apic_default);
 
-struct apic *apic = &apic_default;
+struct apic *apic __read_only = &apic_default;
 EXPORT_SYMBOL_GPL(apic);
 
 static int cmdline_apic __initdata;
diff --git a/arch/x86/kernel/apic/vector.c b/arch/x86/kernel/apic/vector.c
index 5d30c5e42..3c83cc467 100644
--- a/arch/x86/kernel/apic/vector.c
+++ b/arch/x86/kernel/apic/vector.c
@@ -37,6 +37,7 @@ static struct irq_chip lapic_controller;
 static struct apic_chip_data *legacy_irq_data[NR_IRQS_LEGACY];
 #endif
 
+void lock_vector_lock(void) __acquires(&vector_lock);
 void lock_vector_lock(void)
 {
 	/* Used to the online set of cpus does not change
@@ -45,6 +46,7 @@ void lock_vector_lock(void)
 	raw_spin_lock(&vector_lock);
 }
 
+void unlock_vector_lock(void) __releases(&vector_lock);
 void unlock_vector_lock(void)
 {
 	raw_spin_unlock(&vector_lock);
diff --git a/arch/x86/kernel/apic/x2apic_cluster.c b/arch/x86/kernel/apic/x2apic_cluster.c
index 54f35d988..d752bd5e7 100644
--- a/arch/x86/kernel/apic/x2apic_cluster.c
+++ b/arch/x86/kernel/apic/x2apic_cluster.c
@@ -227,7 +227,7 @@ static void cluster_vector_allocation_domain(int cpu, struct cpumask *retmask,
 		cpumask_and(retmask, mask, per_cpu(cpus_in_cluster, cpu));
 }
 
-static struct apic apic_x2apic_cluster = {
+static struct apic apic_x2apic_cluster __read_only = {
 
 	.name				= "cluster x2apic",
 	.probe				= x2apic_cluster_probe,
diff --git a/arch/x86/kernel/apic/x2apic_phys.c b/arch/x86/kernel/apic/x2apic_phys.c
index 4f13f54f1..96e44318e 100644
--- a/arch/x86/kernel/apic/x2apic_phys.c
+++ b/arch/x86/kernel/apic/x2apic_phys.c
@@ -98,7 +98,7 @@ static int x2apic_phys_probe(void)
 	return apic == &apic_x2apic_phys;
 }
 
-static struct apic apic_x2apic_phys = {
+static struct apic apic_x2apic_phys __read_only = {
 
 	.name				= "physical x2apic",
 	.probe				= x2apic_phys_probe,
diff --git a/arch/x86/kernel/apic/x2apic_uv_x.c b/arch/x86/kernel/apic/x2apic_uv_x.c
index cb0673c1e..dc976d7da 100644
--- a/arch/x86/kernel/apic/x2apic_uv_x.c
+++ b/arch/x86/kernel/apic/x2apic_uv_x.c
@@ -560,7 +560,7 @@ static int uv_probe(void)
 	return apic == &apic_x2apic_uv_x;
 }
 
-static struct apic __refdata apic_x2apic_uv_x = {
+static struct apic apic_x2apic_uv_x __read_only = {
 
 	.name				= "UV large system",
 	.probe				= uv_probe,
diff --git a/arch/x86/kernel/apm_32.c b/arch/x86/kernel/apm_32.c
index c7364bd63..20cd21abb 100644
--- a/arch/x86/kernel/apm_32.c
+++ b/arch/x86/kernel/apm_32.c
@@ -432,7 +432,7 @@ static DEFINE_MUTEX(apm_mutex);
  * This is for buggy BIOS's that refer to (real mode) segment 0x40
  * even though they are called in protected mode.
  */
-static struct desc_struct bad_bios_desc = GDT_ENTRY_INIT(0x4092,
+static const struct desc_struct bad_bios_desc = GDT_ENTRY_INIT(0x4093,
 			(unsigned long)__va(0x400UL), PAGE_SIZE - 0x400 - 1);
 
 static const char driver_version[] = "1.16ac";	/* no spaces */
@@ -610,7 +610,10 @@ static long __apm_bios_call(void *_call)
 	BUG_ON(cpu != 0);
 	gdt = get_cpu_gdt_table(cpu);
 	save_desc_40 = gdt[0x40 / 8];
+
+	pax_open_kernel();
 	gdt[0x40 / 8] = bad_bios_desc;
+	pax_close_kernel();
 
 	apm_irq_save(flags);
 	APM_DO_SAVE_SEGS;
@@ -619,7 +622,11 @@ static long __apm_bios_call(void *_call)
 			  &call->esi);
 	APM_DO_RESTORE_SEGS;
 	apm_irq_restore(flags);
+
+	pax_open_kernel();
 	gdt[0x40 / 8] = save_desc_40;
+	pax_close_kernel();
+
 	put_cpu();
 
 	return call->eax & 0xff;
@@ -686,7 +693,10 @@ static long __apm_bios_call_simple(void *_call)
 	BUG_ON(cpu != 0);
 	gdt = get_cpu_gdt_table(cpu);
 	save_desc_40 = gdt[0x40 / 8];
+
+	pax_open_kernel();
 	gdt[0x40 / 8] = bad_bios_desc;
+	pax_close_kernel();
 
 	apm_irq_save(flags);
 	APM_DO_SAVE_SEGS;
@@ -694,7 +704,11 @@ static long __apm_bios_call_simple(void *_call)
 					 &call->eax);
 	APM_DO_RESTORE_SEGS;
 	apm_irq_restore(flags);
+
+	pax_open_kernel();
 	gdt[0x40 / 8] = save_desc_40;
+	pax_close_kernel();
+
 	put_cpu();
 	return error;
 }
@@ -2039,7 +2053,7 @@ static int __init swab_apm_power_in_minutes(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id __initdata apm_dmi_table[] = {
+static const struct dmi_system_id __initconst apm_dmi_table[] = {
 	{
 		print_if_true,
 		KERN_WARNING "IBM T23 - BIOS 1.03b+ and controller firmware 1.02+ may be needed for Linux APM.",
@@ -2349,12 +2363,15 @@ static int __init apm_init(void)
 	 * code to that CPU.
 	 */
 	gdt = get_cpu_gdt_table(0);
+
+	pax_open_kernel();
 	set_desc_base(&gdt[APM_CS >> 3],
 		 (unsigned long)__va((unsigned long)apm_info.bios.cseg << 4));
 	set_desc_base(&gdt[APM_CS_16 >> 3],
 		 (unsigned long)__va((unsigned long)apm_info.bios.cseg_16 << 4));
 	set_desc_base(&gdt[APM_DS >> 3],
 		 (unsigned long)__va((unsigned long)apm_info.bios.dseg << 4));
+	pax_close_kernel();
 
 	proc_create("apm", 0, NULL, &apm_file_ops);
 
diff --git a/arch/x86/kernel/asm-offsets.c b/arch/x86/kernel/asm-offsets.c
index 2bd5c6ff7..4907fd0cd 100644
--- a/arch/x86/kernel/asm-offsets.c
+++ b/arch/x86/kernel/asm-offsets.c
@@ -31,9 +31,11 @@ void common(void) {
 	BLANK();
 	OFFSET(TI_flags, thread_info, flags);
 	OFFSET(TI_status, thread_info, status);
+	OFFSET(TI_lowest_stack, thread_info, lowest_stack);
+	DEFINE(TI_task_thread_sp0, offsetof(struct task_struct, thread.sp0) - offsetof(struct task_struct, tinfo));
 
 	BLANK();
-	OFFSET(TASK_addr_limit, task_struct, thread.addr_limit);
+	OFFSET(TASK_addr_limit, task_struct, tinfo.addr_limit);
 
 	BLANK();
 	OFFSET(crypto_tfm_ctx_offset, crypto_tfm, __crt_ctx);
@@ -68,8 +70,26 @@ void common(void) {
 	OFFSET(PV_CPU_iret, pv_cpu_ops, iret);
 	OFFSET(PV_CPU_read_cr0, pv_cpu_ops, read_cr0);
 	OFFSET(PV_MMU_read_cr2, pv_mmu_ops, read_cr2);
+
+#ifdef CONFIG_PAX_KERNEXEC
+	OFFSET(PV_CPU_write_cr0, pv_cpu_ops, write_cr0);
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	OFFSET(PV_MMU_read_cr3, pv_mmu_ops, read_cr3);
+	OFFSET(PV_MMU_write_cr3, pv_mmu_ops, write_cr3);
+#ifdef CONFIG_X86_64
+	OFFSET(PV_MMU_set_pgd_batched, pv_mmu_ops, set_pgd_batched);
+#endif
 #endif
 
+#endif
+
+	BLANK();
+	DEFINE(PAGE_SIZE_asm, PAGE_SIZE);
+	DEFINE(PAGE_SHIFT_asm, PAGE_SHIFT);
+	DEFINE(THREAD_SIZE_asm, THREAD_SIZE);
+
 #ifdef CONFIG_XEN
 	BLANK();
 	OFFSET(XEN_vcpu_info_mask, vcpu_info, evtchn_upcall_mask);
@@ -88,4 +108,5 @@ void common(void) {
 
 	BLANK();
 	DEFINE(PTREGS_SIZE, sizeof(struct pt_regs));
+	DEFINE(TSS_size, sizeof(struct tss_struct));
 }
diff --git a/arch/x86/kernel/cpu/Makefile b/arch/x86/kernel/cpu/Makefile
index 4a8697f7d..8a1342851 100644
--- a/arch/x86/kernel/cpu/Makefile
+++ b/arch/x86/kernel/cpu/Makefile
@@ -12,10 +12,6 @@ endif
 KCOV_INSTRUMENT_common.o := n
 KCOV_INSTRUMENT_perf_event.o := n
 
-# Make sure load_percpu_segment has no stackprotector
-nostackp := $(call cc-option, -fno-stack-protector)
-CFLAGS_common.o		:= $(nostackp)
-
 obj-y			:= intel_cacheinfo.o scattered.o topology.o
 obj-y			+= common.o
 obj-y			+= rdrand.o
diff --git a/arch/x86/kernel/cpu/amd.c b/arch/x86/kernel/cpu/amd.c
index 1e81a37c0..7a498d67e 100644
--- a/arch/x86/kernel/cpu/amd.c
+++ b/arch/x86/kernel/cpu/amd.c
@@ -788,7 +788,7 @@ static void init_amd(struct cpuinfo_x86 *c)
 static unsigned int amd_size_cache(struct cpuinfo_x86 *c, unsigned int size)
 {
 	/* AMD errata T13 (order #21922) */
-	if ((c->x86 == 6)) {
+	if (c->x86 == 6) {
 		/* Duron Rev A0 */
 		if (c->x86_model == 3 && c->x86_mask == 0)
 			size = 64;
diff --git a/arch/x86/kernel/cpu/bugs_64.c b/arch/x86/kernel/cpu/bugs_64.c
index a972ac4c7..938c16341 100644
--- a/arch/x86/kernel/cpu/bugs_64.c
+++ b/arch/x86/kernel/cpu/bugs_64.c
@@ -10,6 +10,7 @@
 #include <asm/processor.h>
 #include <asm/mtrr.h>
 #include <asm/cacheflush.h>
+#include <asm/sections.h>
 
 void __init check_bugs(void)
 {
@@ -18,6 +19,7 @@ void __init check_bugs(void)
 	pr_info("CPU: ");
 	print_cpu_info(&boot_cpu_data);
 #endif
+	set_memory_nx((unsigned long)_sinitdata, (__START_KERNEL_map + KERNEL_IMAGE_SIZE - (unsigned long)_sinitdata) >> PAGE_SHIFT);
 	alternative_instructions();
 
 	/*
diff --git a/arch/x86/kernel/cpu/common.c b/arch/x86/kernel/cpu/common.c
index bcc9ccc22..84b8a8243 100644
--- a/arch/x86/kernel/cpu/common.c
+++ b/arch/x86/kernel/cpu/common.c
@@ -93,60 +93,6 @@ static const struct cpu_dev default_cpu = {
 
 static const struct cpu_dev *this_cpu = &default_cpu;
 
-DEFINE_PER_CPU_PAGE_ALIGNED(struct gdt_page, gdt_page) = { .gdt = {
-#ifdef CONFIG_X86_64
-	/*
-	 * We need valid kernel segments for data and code in long mode too
-	 * IRET will check the segment types  kkeil 2000/10/28
-	 * Also sysret mandates a special GDT layout
-	 *
-	 * TLS descriptors are currently at a different place compared to i386.
-	 * Hopefully nobody expects them at a fixed place (Wine?)
-	 */
-	[GDT_ENTRY_KERNEL32_CS]		= GDT_ENTRY_INIT(0xc09b, 0, 0xfffff),
-	[GDT_ENTRY_KERNEL_CS]		= GDT_ENTRY_INIT(0xa09b, 0, 0xfffff),
-	[GDT_ENTRY_KERNEL_DS]		= GDT_ENTRY_INIT(0xc093, 0, 0xfffff),
-	[GDT_ENTRY_DEFAULT_USER32_CS]	= GDT_ENTRY_INIT(0xc0fb, 0, 0xfffff),
-	[GDT_ENTRY_DEFAULT_USER_DS]	= GDT_ENTRY_INIT(0xc0f3, 0, 0xfffff),
-	[GDT_ENTRY_DEFAULT_USER_CS]	= GDT_ENTRY_INIT(0xa0fb, 0, 0xfffff),
-#else
-	[GDT_ENTRY_KERNEL_CS]		= GDT_ENTRY_INIT(0xc09a, 0, 0xfffff),
-	[GDT_ENTRY_KERNEL_DS]		= GDT_ENTRY_INIT(0xc092, 0, 0xfffff),
-	[GDT_ENTRY_DEFAULT_USER_CS]	= GDT_ENTRY_INIT(0xc0fa, 0, 0xfffff),
-	[GDT_ENTRY_DEFAULT_USER_DS]	= GDT_ENTRY_INIT(0xc0f2, 0, 0xfffff),
-	/*
-	 * Segments used for calling PnP BIOS have byte granularity.
-	 * They code segments and data segments have fixed 64k limits,
-	 * the transfer segment sizes are set at run time.
-	 */
-	/* 32-bit code */
-	[GDT_ENTRY_PNPBIOS_CS32]	= GDT_ENTRY_INIT(0x409a, 0, 0xffff),
-	/* 16-bit code */
-	[GDT_ENTRY_PNPBIOS_CS16]	= GDT_ENTRY_INIT(0x009a, 0, 0xffff),
-	/* 16-bit data */
-	[GDT_ENTRY_PNPBIOS_DS]		= GDT_ENTRY_INIT(0x0092, 0, 0xffff),
-	/* 16-bit data */
-	[GDT_ENTRY_PNPBIOS_TS1]		= GDT_ENTRY_INIT(0x0092, 0, 0),
-	/* 16-bit data */
-	[GDT_ENTRY_PNPBIOS_TS2]		= GDT_ENTRY_INIT(0x0092, 0, 0),
-	/*
-	 * The APM segments have byte granularity and their bases
-	 * are set at run time.  All have 64k limits.
-	 */
-	/* 32-bit code */
-	[GDT_ENTRY_APMBIOS_BASE]	= GDT_ENTRY_INIT(0x409a, 0, 0xffff),
-	/* 16-bit code */
-	[GDT_ENTRY_APMBIOS_BASE+1]	= GDT_ENTRY_INIT(0x009a, 0, 0xffff),
-	/* data */
-	[GDT_ENTRY_APMBIOS_BASE+2]	= GDT_ENTRY_INIT(0x4092, 0, 0xffff),
-
-	[GDT_ENTRY_ESPFIX_SS]		= GDT_ENTRY_INIT(0xc092, 0, 0xfffff),
-	[GDT_ENTRY_PERCPU]		= GDT_ENTRY_INIT(0xc092, 0, 0xfffff),
-	GDT_STACK_CANARY_INIT
-#endif
-} };
-EXPORT_PER_CPU_SYMBOL_GPL(gdt_page);
-
 static int __init x86_mpx_setup(char *s)
 {
 	/* require an exact match without trailing characters */
@@ -281,6 +227,10 @@ static __always_inline void setup_smep(struct cpuinfo_x86 *c)
 {
 	if (cpu_has(c, X86_FEATURE_SMEP))
 		cr4_set_bits(X86_CR4_SMEP);
+#ifdef CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_NONE
+	else
+		panic("PAX: this KERNEXEC configuration requires SMEP support\n");
+#endif
 }
 
 static __init int setup_disable_smap(char *arg)
@@ -306,6 +256,109 @@ static __always_inline void setup_smap(struct cpuinfo_x86 *c)
 	}
 }
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+#ifdef CONFIG_X86_64
+static bool uderef_enabled __read_only = true;
+unsigned long pax_user_shadow_base __read_only;
+EXPORT_SYMBOL(pax_user_shadow_base);
+extern char pax_enter_kernel_user[];
+extern char pax_exit_kernel_user[];
+
+static int __init setup_pax_weakuderef(char *str)
+{
+	if (uderef_enabled)
+		pax_user_shadow_base = 1UL << TASK_SIZE_MAX_SHIFT;
+	return 1;
+}
+__setup("pax_weakuderef", setup_pax_weakuderef);
+#endif
+
+static int __init setup_pax_nouderef(char *str)
+{
+#ifdef CONFIG_X86_32
+	unsigned int cpu;
+	struct desc_struct *gdt;
+
+	for (cpu = 0; cpu < nr_cpu_ids; cpu++) {
+		gdt = get_cpu_gdt_table(cpu);
+		gdt[GDT_ENTRY_KERNEL_DS].type = 3;
+		gdt[GDT_ENTRY_KERNEL_DS].limit = 0xf;
+		gdt[GDT_ENTRY_DEFAULT_USER_CS].limit = 0xf;
+		gdt[GDT_ENTRY_DEFAULT_USER_DS].limit = 0xf;
+	}
+	loadsegment(ds, __KERNEL_DS);
+	loadsegment(es, __KERNEL_DS);
+	loadsegment(ss, __KERNEL_DS);
+#else
+	memcpy(pax_enter_kernel_user, (unsigned char []){0xc3}, 1);
+	memcpy(pax_exit_kernel_user, (unsigned char []){0xc3}, 1);
+	clone_pgd_mask = ~(pgdval_t)0UL;
+	pax_user_shadow_base = 0UL;
+	setup_clear_cpu_cap(X86_FEATURE_PCIDUDEREF);
+	uderef_enabled = false;
+#endif
+
+	return 0;
+}
+early_param("pax_nouderef", setup_pax_nouderef);
+#endif
+
+#ifdef CONFIG_X86_64
+static __init int setup_disable_pcid(char *arg)
+{
+	setup_clear_cpu_cap(X86_FEATURE_PCID);
+	setup_clear_cpu_cap(X86_FEATURE_INVPCID);
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (uderef_enabled)
+		pax_user_shadow_base = 1UL << TASK_SIZE_MAX_SHIFT;
+#endif
+
+	return 1;
+}
+__setup("nopcid", setup_disable_pcid);
+
+static void setup_pcid(struct cpuinfo_x86 *c)
+{
+	if (cpu_has(c, X86_FEATURE_PCID)) {
+		printk("PAX: PCID detected\n");
+		cr4_set_bits(X86_CR4_PCIDE);
+	} else
+		clear_cpu_cap(c, X86_FEATURE_INVPCID);
+
+	if (cpu_has(c, X86_FEATURE_INVPCID))
+		printk("PAX: INVPCID detected\n");
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	if (!uderef_enabled) {
+		printk("PAX: UDEREF disabled\n");
+		return;
+	}
+
+	if (!cpu_has(c, X86_FEATURE_PCID)) {
+		pax_open_kernel();
+		pax_user_shadow_base = 1UL << TASK_SIZE_MAX_SHIFT;
+		pax_close_kernel();
+		printk("PAX: slow and weak UDEREF enabled\n");
+		return;
+	}
+
+	set_cpu_cap(c, X86_FEATURE_PCIDUDEREF);
+
+	pax_open_kernel();
+	clone_pgd_mask = ~(pgdval_t)0UL;
+	pax_close_kernel();
+	if (pax_user_shadow_base)
+		printk("PAX: weak UDEREF enabled\n");
+	else {
+		set_cpu_cap(c, X86_FEATURE_STRONGUDEREF);
+		printk("PAX: strong UDEREF enabled\n");
+	}
+#endif
+
+}
+#endif
+
 /*
  * Protection Keys are not available in 32-bit mode.
  */
@@ -451,7 +504,7 @@ void switch_to_new_gdt(int cpu)
 {
 	struct desc_ptr gdt_descr;
 
-	gdt_descr.address = (long)get_cpu_gdt_table(cpu);
+	gdt_descr.address = (unsigned long)get_cpu_gdt_table(cpu);
 	gdt_descr.size = GDT_SIZE - 1;
 	load_gdt(&gdt_descr);
 	/* Reload the per-cpu base */
@@ -972,9 +1025,11 @@ static void x86_init_cache_qos(struct cpuinfo_x86 *c)
 	 * in case CQM bits really aren't there in this CPU.
 	 */
 	if (c != &boot_cpu_data) {
+		pax_open_kernel();
 		boot_cpu_data.x86_cache_max_rmid =
 			min(boot_cpu_data.x86_cache_max_rmid,
 			    c->x86_cache_max_rmid);
+		pax_close_kernel();
 	}
 }
 
@@ -1041,6 +1096,20 @@ static void identify_cpu(struct cpuinfo_x86 *c)
 	setup_smep(c);
 	setup_smap(c);
 
+#ifdef CONFIG_X86_32
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (!(__supported_pte_mask & _PAGE_NX))
+		clear_cpu_cap(c, X86_FEATURE_PSE);
+#endif
+#if defined(CONFIG_PAX_SEGMEXEC) || defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	clear_cpu_cap(c, X86_FEATURE_SEP);
+#endif
+#endif
+
+#ifdef CONFIG_X86_64
+	setup_pcid(c);
+#endif
+
 	/*
 	 * The vendor-specific functions might have changed features.
 	 * Now we do "generic changes."
@@ -1086,10 +1155,14 @@ static void identify_cpu(struct cpuinfo_x86 *c)
 	 * executed, c == &boot_cpu_data.
 	 */
 	if (c != &boot_cpu_data) {
+		pax_open_kernel();
+
 		/* AND the already accumulated flags with these */
 		for (i = 0; i < NCAPINTS; i++)
 			boot_cpu_data.x86_capability[i] &= c->x86_capability[i];
 
+		pax_close_kernel();
+
 		/* OR, i.e. replicate the bug flags */
 		for (i = NCAPINTS; i < NCAPINTS + NBUGINTS; i++)
 			c->x86_capability[i] |= boot_cpu_data.x86_capability[i];
@@ -1121,7 +1194,7 @@ void enable_sep_cpu(void)
 		return;
 
 	cpu = get_cpu();
-	tss = &per_cpu(cpu_tss, cpu);
+	tss = cpu_tss + cpu;
 
 	/*
 	 * We cache MSR_IA32_SYSENTER_CS's value in the TSS's ss1 field --
@@ -1263,10 +1336,12 @@ static __init int setup_disablecpuid(char *arg)
 }
 __setup("clearcpuid=", setup_disablecpuid);
 
+DEFINE_PER_CPU(struct thread_info *, current_tinfo) = &init_task.tinfo;
+EXPORT_PER_CPU_SYMBOL(current_tinfo);
+
 #ifdef CONFIG_X86_64
-struct desc_ptr idt_descr = { NR_VECTORS * 16 - 1, (unsigned long) idt_table };
-struct desc_ptr debug_idt_descr = { NR_VECTORS * 16 - 1,
-				    (unsigned long) debug_idt_table };
+struct desc_ptr idt_descr __read_only = { NR_VECTORS * 16 - 1, (unsigned long) idt_table };
+const struct desc_ptr debug_idt_descr = { NR_VECTORS * 16 - 1, (unsigned long) debug_idt_table };
 
 DEFINE_PER_CPU_FIRST(union irq_stack_union,
 		     irq_stack_union) __aligned(PAGE_SIZE) __visible;
@@ -1378,21 +1453,21 @@ EXPORT_PER_CPU_SYMBOL(current_task);
 DEFINE_PER_CPU(int, __preempt_count) = INIT_PREEMPT_COUNT;
 EXPORT_PER_CPU_SYMBOL(__preempt_count);
 
+#ifdef CONFIG_CC_STACKPROTECTOR
+DEFINE_PER_CPU_ALIGNED(struct stack_canary, stack_canary);
+#endif
+
+#endif	/* CONFIG_X86_64 */
+
 /*
  * On x86_32, vm86 modifies tss.sp0, so sp0 isn't a reliable way to find
  * the top of the kernel stack.  Use an extra percpu variable to track the
  * top of the kernel stack directly.
  */
 DEFINE_PER_CPU(unsigned long, cpu_current_top_of_stack) =
-	(unsigned long)&init_thread_union + THREAD_SIZE;
+	(unsigned long)&init_thread_union - 16 + THREAD_SIZE;
 EXPORT_PER_CPU_SYMBOL(cpu_current_top_of_stack);
 
-#ifdef CONFIG_CC_STACKPROTECTOR
-DEFINE_PER_CPU_ALIGNED(struct stack_canary, stack_canary);
-#endif
-
-#endif	/* CONFIG_X86_64 */
-
 /*
  * Clear all 6 debug registers:
  */
@@ -1468,7 +1543,7 @@ void cpu_init(void)
 	 */
 	load_ucode_ap();
 
-	t = &per_cpu(cpu_tss, cpu);
+	t = cpu_tss + cpu;
 	oist = &per_cpu(orig_ist, cpu);
 
 #ifdef CONFIG_NUMA
@@ -1500,7 +1575,6 @@ void cpu_init(void)
 	wrmsrl(MSR_KERNEL_GS_BASE, 0);
 	barrier();
 
-	x86_configure_nx();
 	x2apic_setup();
 
 	/*
@@ -1552,7 +1626,7 @@ void cpu_init(void)
 {
 	int cpu = smp_processor_id();
 	struct task_struct *curr = current;
-	struct tss_struct *t = &per_cpu(cpu_tss, cpu);
+	struct tss_struct *t = cpu_tss + cpu;
 	struct thread_struct *thread = &curr->thread;
 
 	wait_for_master_cpu(cpu);
diff --git a/arch/x86/kernel/cpu/intel.c b/arch/x86/kernel/cpu/intel.c
index fcd484d2b..8a466c149 100644
--- a/arch/x86/kernel/cpu/intel.c
+++ b/arch/x86/kernel/cpu/intel.c
@@ -56,7 +56,9 @@ void check_mpx_erratum(struct cpuinfo_x86 *c)
 	 * is no such hardware known at the moment.
 	 */
 	if (cpu_has(c, X86_FEATURE_MPX) && !cpu_has(c, X86_FEATURE_SMEP)) {
+		pax_open_kernel();
 		setup_clear_cpu_cap(X86_FEATURE_MPX);
+		pax_close_kernel();
 		pr_warn("x86/mpx: Disabling MPX since SMEP not present\n");
 	}
 }
@@ -177,8 +179,10 @@ static void early_init_intel(struct cpuinfo_x86 *c)
 		rdmsrl(MSR_IA32_MISC_ENABLE, misc_enable);
 		if (!(misc_enable & MSR_IA32_MISC_ENABLE_FAST_STRING)) {
 			pr_info("Disabled fast string operations\n");
+			pax_open_kernel();
 			setup_clear_cpu_cap(X86_FEATURE_REP_GOOD);
 			setup_clear_cpu_cap(X86_FEATURE_ERMS);
+			pax_close_kernel();
 		}
 	}
 
@@ -194,7 +198,9 @@ static void early_init_intel(struct cpuinfo_x86 *c)
 	 */
 	if (c->x86 == 5 && c->x86_model == 9) {
 		pr_info("Disabling PGE capability bit\n");
+		pax_open_kernel();
 		setup_clear_cpu_cap(X86_FEATURE_PGE);
+		pax_close_kernel();
 	}
 
 	if (c->cpuid_level >= 0x00000001) {
diff --git a/arch/x86/kernel/cpu/intel_cacheinfo.c b/arch/x86/kernel/cpu/intel_cacheinfo.c
index de6626c18..c84e8c157 100644
--- a/arch/x86/kernel/cpu/intel_cacheinfo.c
+++ b/arch/x86/kernel/cpu/intel_cacheinfo.c
@@ -519,25 +519,23 @@ cache_private_attrs_is_visible(struct kobject *kobj,
 	return 0;
 }
 
+static struct attribute *amd_l3_attrs[4];
+
 static struct attribute_group cache_private_group = {
 	.is_visible = cache_private_attrs_is_visible,
+	.attrs = amd_l3_attrs,
 };
 
 static void init_amd_l3_attrs(void)
 {
 	int n = 1;
-	static struct attribute **amd_l3_attrs;
-
-	if (amd_l3_attrs) /* already initialized */
-		return;
 
 	if (amd_nb_has_feature(AMD_NB_L3_INDEX_DISABLE))
 		n += 2;
 	if (amd_nb_has_feature(AMD_NB_L3_PARTITIONING))
 		n += 1;
 
-	amd_l3_attrs = kcalloc(n, sizeof(*amd_l3_attrs), GFP_KERNEL);
-	if (!amd_l3_attrs)
+	if (n > 1 && amd_l3_attrs[0]) /* already initialized */
 		return;
 
 	n = 0;
@@ -547,8 +545,6 @@ static void init_amd_l3_attrs(void)
 	}
 	if (amd_nb_has_feature(AMD_NB_L3_PARTITIONING))
 		amd_l3_attrs[n++] = &dev_attr_subcaches.attr;
-
-	cache_private_group.attrs = amd_l3_attrs;
 }
 
 const struct attribute_group *
@@ -559,7 +555,7 @@ cache_get_priv_group(struct cacheinfo *this_leaf)
 	if (this_leaf->level < 3 || !nb)
 		return NULL;
 
-	if (nb && nb->l3_cache.indices)
+	if (nb->l3_cache.indices)
 		init_amd_l3_attrs();
 
 	return &cache_private_group;
diff --git a/arch/x86/kernel/cpu/mcheck/mce.c b/arch/x86/kernel/cpu/mcheck/mce.c
index 79d8ec849..ba9ae33c8 100644
--- a/arch/x86/kernel/cpu/mcheck/mce.c
+++ b/arch/x86/kernel/cpu/mcheck/mce.c
@@ -47,6 +47,7 @@
 #include <asm/tlbflush.h>
 #include <asm/mce.h>
 #include <asm/msr.h>
+#include <asm/local.h>
 
 #include "mce-internal.h"
 
@@ -209,8 +210,7 @@ static struct notifier_block mce_srao_nb;
 void mce_register_decode_chain(struct notifier_block *nb)
 {
 	/* Ensure SRAO notifier has the highest priority in the decode chain. */
-	if (nb != &mce_srao_nb && nb->priority == INT_MAX)
-		nb->priority -= 1;
+	BUG_ON(nb != &mce_srao_nb && nb->priority == INT_MAX);
 
 	atomic_notifier_chain_register(&x86_mce_decoder_chain, nb);
 }
@@ -262,7 +262,7 @@ static inline u32 smca_misc_reg(int bank)
 	return MSR_AMD64_SMCA_MCx_MISC(bank);
 }
 
-struct mca_msr_regs msr_ops = {
+struct mca_msr_regs msr_ops __read_only = {
 	.ctl	= ctl_reg,
 	.status	= status_reg,
 	.addr	= addr_reg,
@@ -281,7 +281,7 @@ static void print_mce(struct mce *m)
 			!(m->mcgstatus & MCG_STATUS_EIPV) ? " !INEXACT!" : "",
 				m->cs, m->ip);
 
-		if (m->cs == __KERNEL_CS)
+		if (m->cs == __KERNEL_CS || m->cs == __KERNEXEC_KERNEL_CS)
 			print_symbol("{%s}", m->ip);
 		pr_cont("\n");
 	}
@@ -314,10 +314,10 @@ static void print_mce(struct mce *m)
 
 #define PANIC_TIMEOUT 5 /* 5 seconds */
 
-static atomic_t mce_panicked;
+static atomic_unchecked_t mce_panicked;
 
 static int fake_panic;
-static atomic_t mce_fake_panicked;
+static atomic_unchecked_t mce_fake_panicked;
 
 /* Panic in progress. Enable interrupts and wait for final IPI */
 static void wait_for_panic(void)
@@ -343,7 +343,7 @@ static void mce_panic(const char *msg, struct mce *final, char *exp)
 		/*
 		 * Make sure only one CPU runs in machine check panic
 		 */
-		if (atomic_inc_return(&mce_panicked) > 1)
+		if (atomic_inc_return_unchecked(&mce_panicked) > 1)
 			wait_for_panic();
 		barrier();
 
@@ -351,7 +351,7 @@ static void mce_panic(const char *msg, struct mce *final, char *exp)
 		console_verbose();
 	} else {
 		/* Don't log too much for fake panic */
-		if (atomic_inc_return(&mce_fake_panicked) > 1)
+		if (atomic_inc_return_unchecked(&mce_fake_panicked) > 1)
 			return;
 	}
 	pending = mce_gen_pool_prepare_records();
@@ -387,7 +387,7 @@ static void mce_panic(const char *msg, struct mce *final, char *exp)
 	if (!fake_panic) {
 		if (panic_timeout == 0)
 			panic_timeout = mca_cfg.panic_timeout;
-		panic(msg);
+		panic("%s", msg);
 	} else
 		pr_emerg(HW_ERR "Fake kernel panic: %s\n", msg);
 }
@@ -761,7 +761,7 @@ static int mce_timed_out(u64 *t, const char *msg)
 	 * might have been modified by someone else.
 	 */
 	rmb();
-	if (atomic_read(&mce_panicked))
+	if (atomic_read_unchecked(&mce_panicked))
 		wait_for_panic();
 	if (!mca_cfg.monarch_timeout)
 		goto out;
@@ -1691,10 +1691,12 @@ static void __mcheck_cpu_init_vendor(struct cpuinfo_x86 *c)
 		 * Install proper ops for Scalable MCA enabled processors
 		 */
 		if (mce_flags.smca) {
+			pax_open_kernel();
 			msr_ops.ctl	= smca_ctl_reg;
 			msr_ops.status	= smca_status_reg;
 			msr_ops.addr	= smca_addr_reg;
 			msr_ops.misc	= smca_misc_reg;
+			pax_close_kernel();
 		}
 		mce_amd_feature_init(c);
 
@@ -1747,7 +1749,7 @@ static void unexpected_machine_check(struct pt_regs *regs, long error_code)
 }
 
 /* Call the installed machine check handler for this CPU setup. */
-void (*machine_check_vector)(struct pt_regs *, long error_code) =
+void (*machine_check_vector)(struct pt_regs *, long error_code) __read_only =
 						unexpected_machine_check;
 
 /*
@@ -1776,7 +1778,9 @@ void mcheck_cpu_init(struct cpuinfo_x86 *c)
 		return;
 	}
 
+	pax_open_kernel();
 	machine_check_vector = do_machine_check;
+	pax_close_kernel();
 
 	__mcheck_cpu_init_generic();
 	__mcheck_cpu_init_vendor(c);
@@ -1808,7 +1812,7 @@ void mcheck_cpu_clear(struct cpuinfo_x86 *c)
  */
 
 static DEFINE_SPINLOCK(mce_chrdev_state_lock);
-static int mce_chrdev_open_count;	/* #times opened */
+static local_t mce_chrdev_open_count;	/* #times opened */
 static int mce_chrdev_open_exclu;	/* already open exclusive? */
 
 static int mce_chrdev_open(struct inode *inode, struct file *file)
@@ -1816,7 +1820,7 @@ static int mce_chrdev_open(struct inode *inode, struct file *file)
 	spin_lock(&mce_chrdev_state_lock);
 
 	if (mce_chrdev_open_exclu ||
-	    (mce_chrdev_open_count && (file->f_flags & O_EXCL))) {
+	    (local_read(&mce_chrdev_open_count) && (file->f_flags & O_EXCL))) {
 		spin_unlock(&mce_chrdev_state_lock);
 
 		return -EBUSY;
@@ -1824,7 +1828,7 @@ static int mce_chrdev_open(struct inode *inode, struct file *file)
 
 	if (file->f_flags & O_EXCL)
 		mce_chrdev_open_exclu = 1;
-	mce_chrdev_open_count++;
+	local_inc(&mce_chrdev_open_count);
 
 	spin_unlock(&mce_chrdev_state_lock);
 
@@ -1835,7 +1839,7 @@ static int mce_chrdev_release(struct inode *inode, struct file *file)
 {
 	spin_lock(&mce_chrdev_state_lock);
 
-	mce_chrdev_open_count--;
+	local_dec(&mce_chrdev_open_count);
 	mce_chrdev_open_exclu = 0;
 
 	spin_unlock(&mce_chrdev_state_lock);
@@ -2529,7 +2533,7 @@ static __init void mce_init_banks(void)
 
 	for (i = 0; i < mca_cfg.banks; i++) {
 		struct mce_bank *b = &mce_banks[i];
-		struct device_attribute *a = &b->attr;
+		device_attribute_no_const *a = &b->attr;
 
 		sysfs_attr_init(&a->attr);
 		a->attr.name	= b->attrname;
@@ -2636,7 +2640,7 @@ struct dentry *mce_get_debugfs_dir(void)
 static void mce_reset(void)
 {
 	cpu_missing = 0;
-	atomic_set(&mce_fake_panicked, 0);
+	atomic_set_unchecked(&mce_fake_panicked, 0);
 	atomic_set(&mce_executing, 0);
 	atomic_set(&mce_callin, 0);
 	atomic_set(&global_nwo, 0);
diff --git a/arch/x86/kernel/cpu/mcheck/p5.c b/arch/x86/kernel/cpu/mcheck/p5.c
index 2a0717bf8..7fbc6417d 100644
--- a/arch/x86/kernel/cpu/mcheck/p5.c
+++ b/arch/x86/kernel/cpu/mcheck/p5.c
@@ -12,6 +12,7 @@
 #include <asm/tlbflush.h>
 #include <asm/mce.h>
 #include <asm/msr.h>
+#include <asm/pgtable.h>
 
 /* By default disabled */
 int mce_p5_enabled __read_mostly;
@@ -52,7 +53,9 @@ void intel_p5_mcheck_init(struct cpuinfo_x86 *c)
 	if (!cpu_has(c, X86_FEATURE_MCE))
 		return;
 
+	pax_open_kernel();
 	machine_check_vector = pentium_machine_check;
+	pax_close_kernel();
 	/* Make sure the vector pointer is visible before we enable MCEs: */
 	wmb();
 
diff --git a/arch/x86/kernel/cpu/mcheck/winchip.c b/arch/x86/kernel/cpu/mcheck/winchip.c
index c6a722e1d..40161401f 100644
--- a/arch/x86/kernel/cpu/mcheck/winchip.c
+++ b/arch/x86/kernel/cpu/mcheck/winchip.c
@@ -11,6 +11,7 @@
 #include <asm/tlbflush.h>
 #include <asm/mce.h>
 #include <asm/msr.h>
+#include <asm/pgtable.h>
 
 /* Machine check handler for WinChip C6: */
 static void winchip_machine_check(struct pt_regs *regs, long error_code)
@@ -28,7 +29,9 @@ void winchip_mcheck_init(struct cpuinfo_x86 *c)
 {
 	u32 lo, hi;
 
+	pax_open_kernel();
 	machine_check_vector = winchip_machine_check;
+	pax_close_kernel();
 	/* Make sure the vector pointer is visible before we enable MCEs: */
 	wmb();
 
diff --git a/arch/x86/kernel/cpu/microcode/intel.c b/arch/x86/kernel/cpu/microcode/intel.c
index 8c88845b9..83b75d5be 100644
--- a/arch/x86/kernel/cpu/microcode/intel.c
+++ b/arch/x86/kernel/cpu/microcode/intel.c
@@ -1072,13 +1072,13 @@ static enum ucode_state request_microcode_fw(int cpu, struct device *device,
 
 static int get_ucode_user(void *to, const void *from, size_t n)
 {
-	return copy_from_user(to, from, n);
+	return copy_from_user(to, (const void __force_user *)from, n);
 }
 
 static enum ucode_state
 request_microcode_user(int cpu, const void __user *buf, size_t size)
 {
-	return generic_load_microcode(cpu, (void *)buf, size, &get_ucode_user);
+	return generic_load_microcode(cpu, (__force_kernel void *)buf, size, &get_ucode_user);
 }
 
 static void microcode_fini_cpu(int cpu)
diff --git a/arch/x86/kernel/cpu/mshyperv.c b/arch/x86/kernel/cpu/mshyperv.c
index 8f44c5a50..ed71f8c76 100644
--- a/arch/x86/kernel/cpu/mshyperv.c
+++ b/arch/x86/kernel/cpu/mshyperv.c
@@ -206,7 +206,7 @@ static void __init ms_hyperv_init_platform(void)
 		x86_platform.get_nmi_reason = hv_get_nmi_reason;
 }
 
-const __refconst struct hypervisor_x86 x86_hyper_ms_hyperv = {
+const struct hypervisor_x86 x86_hyper_ms_hyperv = {
 	.name			= "Microsoft HyperV",
 	.detect			= ms_hyperv_platform,
 	.init_platform		= ms_hyperv_init_platform,
diff --git a/arch/x86/kernel/cpu/mtrr/generic.c b/arch/x86/kernel/cpu/mtrr/generic.c
index fdc55215d..d31149c08 100644
--- a/arch/x86/kernel/cpu/mtrr/generic.c
+++ b/arch/x86/kernel/cpu/mtrr/generic.c
@@ -726,7 +726,8 @@ static DEFINE_RAW_SPINLOCK(set_atomicity_lock);
  * The caller must ensure that local interrupts are disabled and
  * are reenabled after post_set() has been called.
  */
-static void prepare_set(void) __acquires(set_atomicity_lock)
+static void prepare_set(void) __acquires(&set_atomicity_lock);
+static void prepare_set(void)
 {
 	unsigned long cr0;
 
@@ -762,7 +763,8 @@ static void prepare_set(void) __acquires(set_atomicity_lock)
 	wbinvd();
 }
 
-static void post_set(void) __releases(set_atomicity_lock)
+static void post_set(void) __releases(&set_atomicity_lock);
+static void post_set(void)
 {
 	/* Flush TLBs (no need to flush caches - they are disabled) */
 	count_vm_tlb_event(NR_TLB_LOCAL_FLUSH_ALL);
diff --git a/arch/x86/kernel/cpu/mtrr/main.c b/arch/x86/kernel/cpu/mtrr/main.c
index 28f1b54b7..1004b6d72 100644
--- a/arch/x86/kernel/cpu/mtrr/main.c
+++ b/arch/x86/kernel/cpu/mtrr/main.c
@@ -72,7 +72,7 @@ static DEFINE_MUTEX(mtrr_mutex);
 u64 size_or_mask, size_and_mask;
 static bool mtrr_aps_delayed_init;
 
-static const struct mtrr_ops *mtrr_ops[X86_VENDOR_NUM];
+static const struct mtrr_ops *mtrr_ops[X86_VENDOR_NUM] __read_only;
 
 const struct mtrr_ops *mtrr_if;
 
diff --git a/arch/x86/kernel/cpu/mtrr/mtrr.h b/arch/x86/kernel/cpu/mtrr/mtrr.h
index 6c7ced07d..55ee55425 100644
--- a/arch/x86/kernel/cpu/mtrr/mtrr.h
+++ b/arch/x86/kernel/cpu/mtrr/mtrr.h
@@ -25,7 +25,7 @@ struct mtrr_ops {
 	int	(*validate_add_page)(unsigned long base, unsigned long size,
 				     unsigned int type);
 	int	(*have_wrcomb)(void);
-};
+} __do_const;
 
 extern int generic_get_free_region(unsigned long base, unsigned long size,
 				   int replace_reg);
diff --git a/arch/x86/kernel/cpu/vmware.c b/arch/x86/kernel/cpu/vmware.c
index 1ff0598d3..5ef563181 100644
--- a/arch/x86/kernel/cpu/vmware.c
+++ b/arch/x86/kernel/cpu/vmware.c
@@ -137,7 +137,7 @@ static bool __init vmware_legacy_x2apic_available(void)
 	       (eax & (1 << VMWARE_PORT_CMD_LEGACY_X2APIC)) != 0;
 }
 
-const __refconst struct hypervisor_x86 x86_hyper_vmware = {
+const struct hypervisor_x86 x86_hyper_vmware = {
 	.name			= "VMware",
 	.detect			= vmware_platform,
 	.set_cpu_features	= vmware_set_cpu_features,
diff --git a/arch/x86/kernel/crash_dump_64.c b/arch/x86/kernel/crash_dump_64.c
index afa64adb7..dce67dd30 100644
--- a/arch/x86/kernel/crash_dump_64.c
+++ b/arch/x86/kernel/crash_dump_64.c
@@ -36,7 +36,7 @@ ssize_t copy_oldmem_page(unsigned long pfn, char *buf,
 		return -ENOMEM;
 
 	if (userbuf) {
-		if (copy_to_user(buf, vaddr + offset, csize)) {
+		if (copy_to_user((char __force_user *)buf, vaddr + offset, csize)) {
 			iounmap(vaddr);
 			return -EFAULT;
 		}
diff --git a/arch/x86/kernel/doublefault.c b/arch/x86/kernel/doublefault.c
index f6dfd9334..892ade462 100644
--- a/arch/x86/kernel/doublefault.c
+++ b/arch/x86/kernel/doublefault.c
@@ -12,7 +12,7 @@
 
 #define DOUBLEFAULT_STACKSIZE (1024)
 static unsigned long doublefault_stack[DOUBLEFAULT_STACKSIZE];
-#define STACK_START (unsigned long)(doublefault_stack+DOUBLEFAULT_STACKSIZE)
+#define STACK_START (unsigned long)(doublefault_stack+DOUBLEFAULT_STACKSIZE-2)
 
 #define ptr_ok(x) ((x) > PAGE_OFFSET && (x) < PAGE_OFFSET + MAXMEM)
 
@@ -22,7 +22,7 @@ static void doublefault_fn(void)
 	unsigned long gdt, tss;
 
 	native_store_gdt(&gdt_desc);
-	gdt = gdt_desc.address;
+	gdt = (unsigned long)gdt_desc.address;
 
 	printk(KERN_EMERG "PANIC: double fault, gdt at %08lx [%d bytes]\n", gdt, gdt_desc.size);
 
@@ -59,10 +59,10 @@ struct tss_struct doublefault_tss __cacheline_aligned = {
 		/* 0x2 bit is always set */
 		.flags		= X86_EFLAGS_SF | 0x2,
 		.sp		= STACK_START,
-		.es		= __USER_DS,
+		.es		= __KERNEL_DS,
 		.cs		= __KERNEL_CS,
 		.ss		= __KERNEL_DS,
-		.ds		= __USER_DS,
+		.ds		= __KERNEL_DS,
 		.fs		= __KERNEL_PERCPU,
 
 		.__cr3		= __pa_nodebug(swapper_pg_dir),
diff --git a/arch/x86/kernel/dumpstack.c b/arch/x86/kernel/dumpstack.c
index 92e8f0a71..a2430f043 100644
--- a/arch/x86/kernel/dumpstack.c
+++ b/arch/x86/kernel/dumpstack.c
@@ -2,6 +2,9 @@
  *  Copyright (C) 1991, 1992  Linus Torvalds
  *  Copyright (C) 2000, 2001, 2002 Andi Kleen, SuSE Labs
  */
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+#define __INCLUDED_BY_HIDESYM 1
+#endif
 #include <linux/kallsyms.h>
 #include <linux/kprobes.h>
 #include <linux/uaccess.h>
@@ -35,7 +38,7 @@ static void printk_stack_address(unsigned long address, int reliable,
 
 void printk_address(unsigned long address)
 {
-	pr_cont(" [<%p>] %pS\n", (void *)address, (void *)address);
+	pr_cont(" [<%p>] %pA\n", (void *)address, (void *)address);
 }
 
 #ifdef CONFIG_FUNCTION_GRAPH_TRACER
@@ -77,10 +80,8 @@ print_ftrace_graph_addr(unsigned long addr, void *data,
  * severe exception (double fault, nmi, stack fault, debug, mce) hardware stack
  */
 
-static inline int valid_stack_ptr(struct task_struct *task,
-			void *p, unsigned int size, void *end)
+static inline int valid_stack_ptr(void *t, void *p, unsigned int size, void *end)
 {
-	void *t = task_stack_page(task);
 	if (end) {
 		if (p < end && p >= (end-THREAD_SIZE))
 			return 1;
@@ -91,7 +92,7 @@ static inline int valid_stack_ptr(struct task_struct *task,
 }
 
 unsigned long
-print_context_stack(struct task_struct *task,
+print_context_stack(struct task_struct *task, void *stack_start,
 		unsigned long *stack, unsigned long bp,
 		const struct stacktrace_ops *ops, void *data,
 		unsigned long *end, int *graph)
@@ -106,7 +107,7 @@ print_context_stack(struct task_struct *task,
 	    PAGE_SIZE)
 		stack = (unsigned long *)task_stack_page(task);
 
-	while (valid_stack_ptr(task, stack, sizeof(*stack), end)) {
+	while (valid_stack_ptr(stack_start, stack, sizeof(*stack), end)) {
 		unsigned long addr;
 
 		addr = *stack;
@@ -127,7 +128,7 @@ print_context_stack(struct task_struct *task,
 EXPORT_SYMBOL_GPL(print_context_stack);
 
 unsigned long
-print_context_stack_bp(struct task_struct *task,
+print_context_stack_bp(struct task_struct *task, void *stack_start,
 		       unsigned long *stack, unsigned long bp,
 		       const struct stacktrace_ops *ops, void *data,
 		       unsigned long *end, int *graph)
@@ -135,7 +136,7 @@ print_context_stack_bp(struct task_struct *task,
 	struct stack_frame *frame = (struct stack_frame *)bp;
 	unsigned long *ret_addr = &frame->return_address;
 
-	while (valid_stack_ptr(task, ret_addr, sizeof(*ret_addr), end)) {
+	while (valid_stack_ptr(stack_start, ret_addr, sizeof(*ret_addr), end)) {
 		unsigned long addr = *ret_addr;
 
 		if (!__kernel_text_address(addr))
@@ -240,6 +241,7 @@ EXPORT_SYMBOL_GPL(oops_begin);
 NOKPROBE_SYMBOL(oops_begin);
 
 void __noreturn rewind_stack_do_exit(int signr);
+extern void gr_handle_kernel_exploit(void);
 
 void oops_end(unsigned long flags, struct pt_regs *regs, int signr)
 {
@@ -263,6 +265,8 @@ void oops_end(unsigned long flags, struct pt_regs *regs, int signr)
 	if (panic_on_oops)
 		panic("Fatal exception");
 
+	gr_handle_kernel_exploit();
+
 	/*
 	 * We're not going to return, but we might be on an IST stack or
 	 * have very little stack space left.  Rewind the stack and kill
diff --git a/arch/x86/kernel/dumpstack_32.c b/arch/x86/kernel/dumpstack_32.c
index 09675712e..84666bcc8 100644
--- a/arch/x86/kernel/dumpstack_32.c
+++ b/arch/x86/kernel/dumpstack_32.c
@@ -15,6 +15,7 @@
 #include <linux/nmi.h>
 
 #include <asm/stacktrace.h>
+#include <asm/desc.h>
 
 static void *is_irq_stack(void *p, void *irq)
 {
@@ -61,13 +62,14 @@ void dump_trace(struct task_struct *task, struct pt_regs *regs,
 		bp = stack_frame(task, regs);
 
 	for (;;) {
+		void *stack_start = (void *)((unsigned long)stack & ~(THREAD_SIZE-1));
 		void *end_stack;
 
 		end_stack = is_hardirq_stack(stack, cpu);
 		if (!end_stack)
 			end_stack = is_softirq_stack(stack, cpu);
 
-		bp = ops->walk_stack(task, stack, bp, ops, data,
+		bp = ops->walk_stack(task, stack_start, stack, bp, ops, data,
 				     end_stack, &graph);
 
 		/* Stop if not on irq stack */
@@ -137,16 +139,17 @@ void show_regs(struct pt_regs *regs)
 		unsigned int code_len = code_bytes;
 		unsigned char c;
 		u8 *ip;
+		unsigned long cs_base = get_desc_base(&get_cpu_gdt_table(0)[(0xffff & regs->cs) >> 3]);
 
 		pr_emerg("Stack:\n");
 		show_stack_log_lvl(NULL, regs, &regs->sp, 0, KERN_EMERG);
 
 		pr_emerg("Code:");
 
-		ip = (u8 *)regs->ip - code_prologue;
+		ip = (u8 *)regs->ip - code_prologue + cs_base;
 		if (ip < (u8 *)PAGE_OFFSET || probe_kernel_address(ip, c)) {
 			/* try starting at IP */
-			ip = (u8 *)regs->ip;
+			ip = (u8 *)regs->ip + cs_base;
 			code_len = code_len - code_prologue + 1;
 		}
 		for (i = 0; i < code_len; i++, ip++) {
@@ -155,7 +158,7 @@ void show_regs(struct pt_regs *regs)
 				pr_cont("  Bad EIP value.");
 				break;
 			}
-			if (ip == (u8 *)regs->ip)
+			if (ip == (u8 *)regs->ip + cs_base)
 				pr_cont(" <%02x>", c);
 			else
 				pr_cont(" %02x", c);
@@ -168,6 +171,7 @@ int is_valid_bugaddr(unsigned long ip)
 {
 	unsigned short ud2;
 
+	ip = ktla_ktva(ip);
 	if (ip < PAGE_OFFSET)
 		return 0;
 	if (probe_kernel_address((unsigned short *)ip, ud2))
@@ -175,3 +179,15 @@ int is_valid_bugaddr(unsigned long ip)
 
 	return ud2 == 0x0b0f;
 }
+
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+void __used pax_check_alloca(unsigned long size)
+{
+	unsigned long sp = (unsigned long)&sp, stack_left;
+
+	/* all kernel stacks are of the same size */
+	stack_left = sp & (THREAD_SIZE - 1);
+	BUG_ON(stack_left < 256 || size >= stack_left - 256);
+}
+EXPORT_SYMBOL(pax_check_alloca);
+#endif
diff --git a/arch/x86/kernel/dumpstack_64.c b/arch/x86/kernel/dumpstack_64.c
index 9ee4520ce..bacb90c16 100644
--- a/arch/x86/kernel/dumpstack_64.c
+++ b/arch/x86/kernel/dumpstack_64.c
@@ -158,6 +158,7 @@ void dump_trace(struct task_struct *task, struct pt_regs *regs,
 	unsigned used = 0;
 	int graph = 0;
 	int done = 0;
+	void *stack_start;
 
 	if (!task)
 		task = current;
@@ -190,17 +191,19 @@ void dump_trace(struct task_struct *task, struct pt_regs *regs,
 		done = 1;
 
 		switch (stype) {
-
-		/* Break out early if we are on the thread stack */
 		case STACK_IS_NORMAL:
+			/*
+			 * This handles the process stack:
+			 */
+			stack_start = (void *)((unsigned long)stack & ~(THREAD_SIZE-1));
+			bp = ops->walk_stack(task, stack_start, stack, bp, ops, data, NULL, &graph);
 			break;
 
 		case STACK_IS_EXCEPTION:
-
 			if (ops->stack(data, id) < 0)
 				break;
 
-			bp = ops->walk_stack(task, stack, bp, ops,
+			bp = ops->walk_stack(task, stack_end - EXCEPTION_STKSZ, stack, bp, ops,
 					     data, stack_end, &graph);
 			ops->stack(data, "<EOE>");
 			/*
@@ -208,15 +211,16 @@ void dump_trace(struct task_struct *task, struct pt_regs *regs,
 			 * second-to-last pointer (index -2 to end) in the
 			 * exception stack:
 			 */
+			if ((u16)stack_end[-1] != __KERNEL_DS)
+				goto out;
 			stack = (unsigned long *) stack_end[-2];
 			done = 0;
 			break;
 
 		case STACK_IS_IRQ:
-
 			if (ops->stack(data, "IRQ") < 0)
 				break;
-			bp = ops->walk_stack(task, stack, bp,
+			bp = ops->walk_stack(task, irq_stack, stack, bp,
 				     ops, data, stack_end, &graph);
 			/*
 			 * We link to the next stack (which would be
@@ -235,10 +239,7 @@ void dump_trace(struct task_struct *task, struct pt_regs *regs,
 		}
 	}
 
-	/*
-	 * This handles the process stack:
-	 */
-	bp = ops->walk_stack(task, stack, bp, ops, data, NULL, &graph);
+out:
 	put_cpu();
 }
 EXPORT_SYMBOL(dump_trace);
@@ -355,8 +356,55 @@ int is_valid_bugaddr(unsigned long ip)
 {
 	unsigned short ud2;
 
-	if (__copy_from_user(&ud2, (const void __user *) ip, sizeof(ud2)))
+	if (probe_kernel_address((unsigned short *)ip, ud2))
 		return 0;
 
 	return ud2 == 0x0b0f;
 }
+
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+void __used pax_check_alloca(unsigned long size)
+{
+	unsigned long sp = (unsigned long)&sp, stack_start, stack_end;
+	unsigned cpu, used;
+	char *id;
+
+	/* check the process stack first */
+	stack_start = (unsigned long)task_stack_page(current);
+	stack_end = stack_start + THREAD_SIZE;
+	if (likely(stack_start <= sp && sp < stack_end)) {
+		unsigned long stack_left = sp & (THREAD_SIZE - 1);
+		BUG_ON(stack_left < 256 || size >= stack_left - 256);
+		return;
+	}
+
+	cpu = get_cpu();
+
+	/* check the irq stacks */
+	stack_end = (unsigned long)per_cpu(irq_stack_ptr, cpu);
+	stack_start = stack_end - IRQ_STACK_SIZE;
+	if (stack_start <= sp && sp < stack_end) {
+		unsigned long stack_left = sp & (IRQ_STACK_SIZE - 1);
+		put_cpu();
+		BUG_ON(stack_left < 256 || size >= stack_left - 256);
+		return;
+	}
+
+	/* check the exception stacks */
+	used = 0;
+	stack_end = (unsigned long)in_exception_stack(cpu, sp, &used, &id);
+	stack_start = stack_end - EXCEPTION_STKSZ;
+	if (stack_end && stack_start <= sp && sp < stack_end) {
+		unsigned long stack_left = sp & (EXCEPTION_STKSZ - 1);
+		put_cpu();
+		BUG_ON(stack_left < 256 || size >= stack_left - 256);
+		return;
+	}
+
+	put_cpu();
+
+	/* unknown stack */
+	BUG();
+}
+EXPORT_SYMBOL(pax_check_alloca);
+#endif
diff --git a/arch/x86/kernel/e820.c b/arch/x86/kernel/e820.c
index 625eb698c..e12a51395 100644
--- a/arch/x86/kernel/e820.c
+++ b/arch/x86/kernel/e820.c
@@ -800,8 +800,8 @@ unsigned long __init e820_end_of_low_ram_pfn(void)
 
 static void early_panic(char *msg)
 {
-	early_printk(msg);
-	panic(msg);
+	early_printk("%s", msg);
+	panic("%s", msg);
 }
 
 static int userdef __initdata;
diff --git a/arch/x86/kernel/early_printk.c b/arch/x86/kernel/early_printk.c
index 8a121991e..e63bebfd7 100644
--- a/arch/x86/kernel/early_printk.c
+++ b/arch/x86/kernel/early_printk.c
@@ -7,6 +7,7 @@
 #include <linux/pci_regs.h>
 #include <linux/pci_ids.h>
 #include <linux/errno.h>
+#include <linux/sched.h>
 #include <asm/io.h>
 #include <asm/processor.h>
 #include <asm/fcntl.h>
diff --git a/arch/x86/kernel/espfix_64.c b/arch/x86/kernel/espfix_64.c
index 04f89caef..43ad7de00 100644
--- a/arch/x86/kernel/espfix_64.c
+++ b/arch/x86/kernel/espfix_64.c
@@ -41,6 +41,7 @@
 #include <asm/pgalloc.h>
 #include <asm/setup.h>
 #include <asm/espfix.h>
+#include <asm/bug.h>
 
 /*
  * Note: we only need 6*8 = 48 bytes for the espfix stack, but round
@@ -70,8 +71,10 @@ static DEFINE_MUTEX(espfix_init_mutex);
 #define ESPFIX_MAX_PAGES  DIV_ROUND_UP(CONFIG_NR_CPUS, ESPFIX_STACKS_PER_PAGE)
 static void *espfix_pages[ESPFIX_MAX_PAGES];
 
-static __page_aligned_bss pud_t espfix_pud_page[PTRS_PER_PUD]
-	__aligned(PAGE_SIZE);
+static __page_aligned_rodata pud_t espfix_pud_page[PTRS_PER_PUD];
+static __page_aligned_rodata pmd_t espfix_pmd_page[PTRS_PER_PMD];
+static __page_aligned_rodata pte_t espfix_pte_page[PTRS_PER_PTE];
+static __page_aligned_rodata char espfix_stack_page[ESPFIX_MAX_PAGES][PAGE_SIZE];
 
 static unsigned int page_random, slot_random;
 
@@ -122,10 +125,19 @@ static void init_espfix_random(void)
 void __init init_espfix_bsp(void)
 {
 	pgd_t *pgd_p;
+	pud_t *pud_p;
+	unsigned long index = pgd_index(ESPFIX_BASE_ADDR);
 
 	/* Install the espfix pud into the kernel page directory */
-	pgd_p = &init_level4_pgt[pgd_index(ESPFIX_BASE_ADDR)];
-	pgd_populate(&init_mm, pgd_p, (pud_t *)espfix_pud_page);
+	pgd_p = &init_level4_pgt[index];
+	pud_p = espfix_pud_page;
+	paravirt_alloc_pud(&init_mm, __pa(pud_p) >> PAGE_SHIFT);
+	set_pgd(pgd_p, __pgd(PGTABLE_PROT | __pa(pud_p)));
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	clone_pgd_range(get_cpu_pgd(0, kernel) + index, swapper_pg_dir + index, 1);
+	clone_pgd_range(get_cpu_pgd(0, user) + index, swapper_pg_dir + index, 1);
+#endif
 
 	/* Randomize the locations */
 	init_espfix_random();
@@ -170,35 +182,39 @@ void init_espfix_ap(int cpu)
 	pud_p = &espfix_pud_page[pud_index(addr)];
 	pud = *pud_p;
 	if (!pud_present(pud)) {
-		struct page *page = alloc_pages_node(node, PGALLOC_GFP, 0);
-
-		pmd_p = (pmd_t *)page_address(page);
+		if (cpu)
+			pmd_p = page_address(alloc_pages_node(node, PGALLOC_GFP, 0));
+		else
+			pmd_p = espfix_pmd_page;
 		pud = __pud(__pa(pmd_p) | (PGTABLE_PROT & ptemask));
 		paravirt_alloc_pmd(&init_mm, __pa(pmd_p) >> PAGE_SHIFT);
 		for (n = 0; n < ESPFIX_PUD_CLONES; n++)
 			set_pud(&pud_p[n], pud);
-	}
+	} else
+		BUG_ON(!cpu);
 
 	pmd_p = pmd_offset(&pud, addr);
 	pmd = *pmd_p;
 	if (!pmd_present(pmd)) {
-		struct page *page = alloc_pages_node(node, PGALLOC_GFP, 0);
-
-		pte_p = (pte_t *)page_address(page);
+		if (cpu)
+			pte_p = page_address(alloc_pages_node(node, PGALLOC_GFP, 0));
+		else
+			pte_p = espfix_pte_page;
 		pmd = __pmd(__pa(pte_p) | (PGTABLE_PROT & ptemask));
 		paravirt_alloc_pte(&init_mm, __pa(pte_p) >> PAGE_SHIFT);
 		for (n = 0; n < ESPFIX_PMD_CLONES; n++)
 			set_pmd(&pmd_p[n], pmd);
-	}
+	} else
+		BUG_ON(!cpu);
 
 	pte_p = pte_offset_kernel(&pmd, addr);
-	stack_page = page_address(alloc_pages_node(node, GFP_KERNEL, 0));
+	stack_page = espfix_stack_page[page];
 	pte = __pte(__pa(stack_page) | (__PAGE_KERNEL_RO & ptemask));
 	for (n = 0; n < ESPFIX_PTE_CLONES; n++)
 		set_pte(&pte_p[n*PTE_STRIDE], pte);
 
 	/* Job is done for this CPU and any CPU which shares this page */
-	ACCESS_ONCE(espfix_pages[page]) = stack_page;
+	ACCESS_ONCE_RW(espfix_pages[page]) = stack_page;
 
 unlock_done:
 	mutex_unlock(&espfix_init_mutex);
diff --git a/arch/x86/kernel/fpu/core.c b/arch/x86/kernel/fpu/core.c
index c289e2f4a..e2d3af1ae 100644
--- a/arch/x86/kernel/fpu/core.c
+++ b/arch/x86/kernel/fpu/core.c
@@ -135,7 +135,7 @@ void __kernel_fpu_end(void)
 	struct fpu *fpu = &current->thread.fpu;
 
 	if (fpu->fpregs_active)
-		copy_kernel_to_fpregs(&fpu->state);
+		copy_kernel_to_fpregs(fpu->state);
 	else
 		__fpregs_deactivate_hw();
 
@@ -200,7 +200,7 @@ void fpu__save(struct fpu *fpu)
 	if (fpu->fpregs_active) {
 		if (!copy_fpregs_to_fpstate(fpu)) {
 			if (use_eager_fpu())
-				copy_kernel_to_fpregs(&fpu->state);
+				copy_kernel_to_fpregs(fpu->state);
 			else
 				fpregs_deactivate(fpu);
 		}
@@ -260,7 +260,7 @@ int fpu__copy(struct fpu *dst_fpu, struct fpu *src_fpu)
 	 * leak into the child task:
 	 */
 	if (use_eager_fpu())
-		memset(&dst_fpu->state.xsave, 0, fpu_kernel_xstate_size);
+		memset(&dst_fpu->state->xsave, 0, fpu_kernel_xstate_size);
 
 	/*
 	 * Save current FPU registers directly into the child
@@ -279,11 +279,10 @@ int fpu__copy(struct fpu *dst_fpu, struct fpu *src_fpu)
 	 */
 	preempt_disable();
 	if (!copy_fpregs_to_fpstate(dst_fpu)) {
-		memcpy(&src_fpu->state, &dst_fpu->state,
-		       fpu_kernel_xstate_size);
+		memcpy(src_fpu->state, dst_fpu->state, fpu_kernel_xstate_size);
 
 		if (use_eager_fpu())
-			copy_kernel_to_fpregs(&src_fpu->state);
+			copy_kernel_to_fpregs(src_fpu->state);
 		else
 			fpregs_deactivate(src_fpu);
 	}
@@ -304,7 +303,7 @@ void fpu__activate_curr(struct fpu *fpu)
 	WARN_ON_FPU(fpu != &current->thread.fpu);
 
 	if (!fpu->fpstate_active) {
-		fpstate_init(&fpu->state);
+		fpstate_init(fpu->state);
 		trace_x86_fpu_init_state(fpu);
 
 		trace_x86_fpu_activate_state(fpu);
@@ -332,7 +331,7 @@ void fpu__activate_fpstate_read(struct fpu *fpu)
 		fpu__save(fpu);
 	} else {
 		if (!fpu->fpstate_active) {
-			fpstate_init(&fpu->state);
+			fpstate_init(fpu->state);
 			trace_x86_fpu_init_state(fpu);
 
 			trace_x86_fpu_activate_state(fpu);
@@ -367,7 +366,7 @@ void fpu__activate_fpstate_write(struct fpu *fpu)
 		/* Invalidate any lazy state: */
 		fpu->last_cpu = -1;
 	} else {
-		fpstate_init(&fpu->state);
+		fpstate_init(fpu->state);
 		trace_x86_fpu_init_state(fpu);
 
 		trace_x86_fpu_activate_state(fpu);
@@ -430,7 +429,7 @@ void fpu__current_fpstate_write_end(void)
 	 * an XRSTOR if they are active.
 	 */
 	if (fpregs_active())
-		copy_kernel_to_fpregs(&fpu->state);
+		copy_kernel_to_fpregs(fpu->state);
 
 	/*
 	 * Our update is done and the fpregs/fpstate are in sync
@@ -457,7 +456,7 @@ void fpu__restore(struct fpu *fpu)
 	kernel_fpu_disable();
 	trace_x86_fpu_before_restore(fpu);
 	fpregs_activate(fpu);
-	copy_kernel_to_fpregs(&fpu->state);
+	copy_kernel_to_fpregs(fpu->state);
 	fpu->counter++;
 	trace_x86_fpu_after_restore(fpu);
 	kernel_fpu_enable();
@@ -550,11 +549,11 @@ int fpu__exception_code(struct fpu *fpu, int trap_nr)
 		 * fully reproduce the context of the exception.
 		 */
 		if (boot_cpu_has(X86_FEATURE_FXSR)) {
-			cwd = fpu->state.fxsave.cwd;
-			swd = fpu->state.fxsave.swd;
+			cwd = fpu->state->fxsave.cwd;
+			swd = fpu->state->fxsave.swd;
 		} else {
-			cwd = (unsigned short)fpu->state.fsave.cwd;
-			swd = (unsigned short)fpu->state.fsave.swd;
+			cwd = (unsigned short)fpu->state->fsave.cwd;
+			swd = (unsigned short)fpu->state->fsave.swd;
 		}
 
 		err = swd & ~cwd;
@@ -568,7 +567,7 @@ int fpu__exception_code(struct fpu *fpu, int trap_nr)
 		unsigned short mxcsr = MXCSR_DEFAULT;
 
 		if (boot_cpu_has(X86_FEATURE_XMM))
-			mxcsr = fpu->state.fxsave.mxcsr;
+			mxcsr = fpu->state->fxsave.mxcsr;
 
 		err = ~(mxcsr >> 7) & mxcsr;
 	}
diff --git a/arch/x86/kernel/fpu/init.c b/arch/x86/kernel/fpu/init.c
index 93982aebb..086162ebe 100644
--- a/arch/x86/kernel/fpu/init.c
+++ b/arch/x86/kernel/fpu/init.c
@@ -45,7 +45,7 @@ static void fpu__init_cpu_generic(void)
 	/* Flush out any pending x87 state: */
 #ifdef CONFIG_MATH_EMULATION
 	if (!boot_cpu_has(X86_FEATURE_FPU))
-		fpstate_init_soft(&current->thread.fpu.state.soft);
+		fpstate_init_soft(&current->thread.fpu.state->soft);
 	else
 #endif
 		asm volatile ("fninit");
@@ -148,51 +148,7 @@ static void __init fpu__init_system_generic(void)
 unsigned int fpu_kernel_xstate_size;
 EXPORT_SYMBOL_GPL(fpu_kernel_xstate_size);
 
-/* Get alignment of the TYPE. */
-#define TYPE_ALIGN(TYPE) offsetof(struct { char x; TYPE test; }, test)
-
-/*
- * Enforce that 'MEMBER' is the last field of 'TYPE'.
- *
- * Align the computed size with alignment of the TYPE,
- * because that's how C aligns structs.
- */
-#define CHECK_MEMBER_AT_END_OF(TYPE, MEMBER) \
-	BUILD_BUG_ON(sizeof(TYPE) != ALIGN(offsetofend(TYPE, MEMBER), \
-					   TYPE_ALIGN(TYPE)))
-
-/*
- * We append the 'struct fpu' to the task_struct:
- */
-static void __init fpu__init_task_struct_size(void)
-{
-	int task_size = sizeof(struct task_struct);
-
-	/*
-	 * Subtract off the static size of the register state.
-	 * It potentially has a bunch of padding.
-	 */
-	task_size -= sizeof(((struct task_struct *)0)->thread.fpu.state);
-
-	/*
-	 * Add back the dynamically-calculated register state
-	 * size.
-	 */
-	task_size += fpu_kernel_xstate_size;
-
-	/*
-	 * We dynamically size 'struct fpu', so we require that
-	 * it be at the end of 'thread_struct' and that
-	 * 'thread_struct' be at the end of 'task_struct'.  If
-	 * you hit a compile error here, check the structure to
-	 * see if something got added to the end.
-	 */
-	CHECK_MEMBER_AT_END_OF(struct fpu, state);
-	CHECK_MEMBER_AT_END_OF(struct thread_struct, fpu);
-	CHECK_MEMBER_AT_END_OF(struct task_struct, thread);
-
-	arch_task_struct_size = task_size;
-}
+union fpregs_state init_fpregs_state;
 
 /*
  * Set up the user and kernel xstate sizes based on the legacy FPU context size.
@@ -387,7 +343,6 @@ void __init fpu__init_system(struct cpuinfo_x86 *c)
 	fpu__init_system_generic();
 	fpu__init_system_xstate_size_legacy();
 	fpu__init_system_xstate();
-	fpu__init_task_struct_size();
 
 	fpu__init_system_ctx_switch();
 }
diff --git a/arch/x86/kernel/fpu/regset.c b/arch/x86/kernel/fpu/regset.c
index c114b132d..0b0d95943 100644
--- a/arch/x86/kernel/fpu/regset.c
+++ b/arch/x86/kernel/fpu/regset.c
@@ -41,7 +41,7 @@ int xfpregs_get(struct task_struct *target, const struct user_regset *regset,
 	fpstate_sanitize_xstate(fpu);
 
 	return user_regset_copyout(&pos, &count, &kbuf, &ubuf,
-				   &fpu->state.fxsave, 0, -1);
+				   &fpu->state->fxsave, 0, -1);
 }
 
 int xfpregs_set(struct task_struct *target, const struct user_regset *regset,
@@ -58,19 +58,19 @@ int xfpregs_set(struct task_struct *target, const struct user_regset *regset,
 	fpstate_sanitize_xstate(fpu);
 
 	ret = user_regset_copyin(&pos, &count, &kbuf, &ubuf,
-				 &fpu->state.fxsave, 0, -1);
+				 &fpu->state->fxsave, 0, -1);
 
 	/*
 	 * mxcsr reserved bits must be masked to zero for security reasons.
 	 */
-	fpu->state.fxsave.mxcsr &= mxcsr_feature_mask;
+	fpu->state->fxsave.mxcsr &= mxcsr_feature_mask;
 
 	/*
 	 * update the header bits in the xsave header, indicating the
 	 * presence of FP and SSE state.
 	 */
 	if (boot_cpu_has(X86_FEATURE_XSAVE))
-		fpu->state.xsave.header.xfeatures |= XFEATURE_MASK_FPSSE;
+		fpu->state->xsave.header.xfeatures |= XFEATURE_MASK_FPSSE;
 
 	return ret;
 }
@@ -86,7 +86,7 @@ int xstateregs_get(struct task_struct *target, const struct user_regset *regset,
 	if (!boot_cpu_has(X86_FEATURE_XSAVE))
 		return -ENODEV;
 
-	xsave = &fpu->state.xsave;
+	xsave = &fpu->state->xsave;
 
 	fpu__activate_fpstate_read(fpu);
 
@@ -126,7 +126,7 @@ int xstateregs_set(struct task_struct *target, const struct user_regset *regset,
 	if ((pos != 0) || (count < fpu_user_xstate_size))
 		return -EFAULT;
 
-	xsave = &fpu->state.xsave;
+	xsave = &fpu->state->xsave;
 
 	fpu__activate_fpstate_write(fpu);
 
@@ -139,7 +139,7 @@ int xstateregs_set(struct task_struct *target, const struct user_regset *regset,
 	 * In case of failure, mark all states as init:
 	 */
 	if (ret)
-		fpstate_init(&fpu->state);
+		fpstate_init(fpu->state);
 
 	/*
 	 * mxcsr reserved bits must be masked to zero for security reasons.
@@ -229,7 +229,7 @@ static inline u32 twd_fxsr_to_i387(struct fxregs_state *fxsave)
 void
 convert_from_fxsr(struct user_i387_ia32_struct *env, struct task_struct *tsk)
 {
-	struct fxregs_state *fxsave = &tsk->thread.fpu.state.fxsave;
+	struct fxregs_state *fxsave = &tsk->thread.fpu.state->fxsave;
 	struct _fpreg *to = (struct _fpreg *) &env->st_space[0];
 	struct _fpxreg *from = (struct _fpxreg *) &fxsave->st_space[0];
 	int i;
@@ -267,7 +267,7 @@ void convert_to_fxsr(struct task_struct *tsk,
 		     const struct user_i387_ia32_struct *env)
 
 {
-	struct fxregs_state *fxsave = &tsk->thread.fpu.state.fxsave;
+	struct fxregs_state *fxsave = &tsk->thread.fpu.state->fxsave;
 	struct _fpreg *from = (struct _fpreg *) &env->st_space[0];
 	struct _fpxreg *to = (struct _fpxreg *) &fxsave->st_space[0];
 	int i;
@@ -305,7 +305,7 @@ int fpregs_get(struct task_struct *target, const struct user_regset *regset,
 
 	if (!boot_cpu_has(X86_FEATURE_FXSR))
 		return user_regset_copyout(&pos, &count, &kbuf, &ubuf,
-					   &fpu->state.fsave, 0,
+					   &fpu->state->fsave, 0,
 					   -1);
 
 	fpstate_sanitize_xstate(fpu);
@@ -336,7 +336,7 @@ int fpregs_set(struct task_struct *target, const struct user_regset *regset,
 
 	if (!boot_cpu_has(X86_FEATURE_FXSR))
 		return user_regset_copyin(&pos, &count, &kbuf, &ubuf,
-					  &fpu->state.fsave, 0,
+					  &fpu->state->fsave, 0,
 					  -1);
 
 	if (pos > 0 || count < sizeof(env))
@@ -351,7 +351,7 @@ int fpregs_set(struct task_struct *target, const struct user_regset *regset,
 	 * presence of FP.
 	 */
 	if (boot_cpu_has(X86_FEATURE_XSAVE))
-		fpu->state.xsave.header.xfeatures |= XFEATURE_MASK_FP;
+		fpu->state->xsave.header.xfeatures |= XFEATURE_MASK_FP;
 	return ret;
 }
 
diff --git a/arch/x86/kernel/fpu/signal.c b/arch/x86/kernel/fpu/signal.c
index a184c210e..a1731b7ec 100644
--- a/arch/x86/kernel/fpu/signal.c
+++ b/arch/x86/kernel/fpu/signal.c
@@ -56,7 +56,7 @@ static inline int check_for_xstate(struct fxregs_state __user *buf,
 static inline int save_fsave_header(struct task_struct *tsk, void __user *buf)
 {
 	if (use_fxsr()) {
-		struct xregs_state *xsave = &tsk->thread.fpu.state.xsave;
+		struct xregs_state *xsave = &tsk->thread.fpu.state->xsave;
 		struct user_i387_ia32_struct env;
 		struct _fpstate_32 __user *fp = buf;
 
@@ -85,19 +85,19 @@ static inline int save_xstate_epilog(void __user *buf, int ia32_frame)
 
 	/* Setup the bytes not touched by the [f]xsave and reserved for SW. */
 	sw_bytes = ia32_frame ? &fx_sw_reserved_ia32 : &fx_sw_reserved;
-	err = __copy_to_user(&x->i387.sw_reserved, sw_bytes, sizeof(*sw_bytes));
+	err = __copy_to_user(x->i387.sw_reserved, sw_bytes, sizeof(*sw_bytes));
 
 	if (!use_xsave())
 		return err;
 
 	err |= __put_user(FP_XSTATE_MAGIC2,
-			  (__u32 *)(buf + fpu_user_xstate_size));
+			  (__u32 __user *)(buf + fpu_user_xstate_size));
 
 	/*
 	 * Read the xfeatures which we copied (directly from the cpu or
 	 * from the state in task struct) to the user buffers.
 	 */
-	err |= __get_user(xfeatures, (__u32 *)&x->header.xfeatures);
+	err |= __get_user(xfeatures, (__u32 __user *)&x->header.xfeatures);
 
 	/*
 	 * For legacy compatible, we always set FP/SSE bits in the bit
@@ -112,7 +112,7 @@ static inline int save_xstate_epilog(void __user *buf, int ia32_frame)
 	 */
 	xfeatures |= XFEATURE_MASK_FPSSE;
 
-	err |= __put_user(xfeatures, (__u32 *)&x->header.xfeatures);
+	err |= __put_user(xfeatures, (__u32 __user *)&x->header.xfeatures);
 
 	return err;
 }
@@ -121,6 +121,7 @@ static inline int copy_fpregs_to_sigframe(struct xregs_state __user *buf)
 {
 	int err;
 
+	buf = (struct xregs_state __user *)____m(buf);
 	if (use_xsave())
 		err = copy_xregs_to_user(buf);
 	else if (use_fxsr())
@@ -155,7 +156,7 @@ static inline int copy_fpregs_to_sigframe(struct xregs_state __user *buf)
  */
 int copy_fpstate_to_sigframe(void __user *buf, void __user *buf_fx, int size)
 {
-	struct xregs_state *xsave = &current->thread.fpu.state.xsave;
+	struct xregs_state *xsave = &current->thread.fpu.state->xsave;
 	struct task_struct *tsk = current;
 	int ia32_fxstate = (buf != buf_fx);
 
@@ -209,7 +210,7 @@ sanitize_restored_xstate(struct task_struct *tsk,
 			 struct user_i387_ia32_struct *ia32_env,
 			 u64 xfeatures, int fx_only)
 {
-	struct xregs_state *xsave = &tsk->thread.fpu.state.xsave;
+	struct xregs_state *xsave = &tsk->thread.fpu.state->xsave;
 	struct xstate_header *header = &xsave->header;
 
 	if (use_xsave()) {
@@ -242,6 +243,7 @@ sanitize_restored_xstate(struct task_struct *tsk,
  */
 static inline int copy_user_to_fpregs_zeroing(void __user *buf, u64 xbv, int fx_only)
 {
+	buf = (void __user *)____m(buf);
 	if (use_xsave()) {
 		if ((unsigned long)buf % 64 || fx_only) {
 			u64 init_bv = xfeatures_mask & ~XFEATURE_MASK_FPSSE;
@@ -325,14 +327,14 @@ static int __fpu__restore_sig(void __user *buf, void __user *buf_fx, int size)
 
 		if (using_compacted_format()) {
 			err = copyin_to_xsaves(NULL, buf_fx,
-					       &fpu->state.xsave);
+					       &fpu->state->xsave);
 		} else {
-			err = __copy_from_user(&fpu->state.xsave,
+			err = __copy_from_user(&fpu->state->xsave,
 					       buf_fx, state_size);
 		}
 
 		if (err || __copy_from_user(&env, buf, sizeof(env))) {
-			fpstate_init(&fpu->state);
+			fpstate_init(fpu->state);
 			trace_x86_fpu_init_state(fpu);
 			err = -1;
 		} else {
diff --git a/arch/x86/kernel/fpu/xstate.c b/arch/x86/kernel/fpu/xstate.c
index 01567aa87..4583b36a8 100644
--- a/arch/x86/kernel/fpu/xstate.c
+++ b/arch/x86/kernel/fpu/xstate.c
@@ -151,14 +151,14 @@ static int xfeature_is_user(int xfeature_nr)
  */
 void fpstate_sanitize_xstate(struct fpu *fpu)
 {
-	struct fxregs_state *fx = &fpu->state.fxsave;
+	struct fxregs_state *fx = &fpu->state->fxsave;
 	int feature_bit;
 	u64 xfeatures;
 
 	if (!use_xsaveopt())
 		return;
 
-	xfeatures = fpu->state.xsave.header.xfeatures;
+	xfeatures = fpu->state->xsave.header.xfeatures;
 
 	/*
 	 * None of the feature bits are in init state. So nothing else
@@ -863,7 +863,7 @@ const void *get_xsave_field_ptr(int xsave_state)
 	 */
 	fpu__save(fpu);
 
-	return get_xsave_addr(&fpu->state.xsave, xsave_state);
+	return get_xsave_addr(&fpu->state->xsave, xsave_state);
 }
 
 #define NR_VALID_PKRU_BITS (CONFIG_NR_PROTECTION_KEYS * 2)
diff --git a/arch/x86/kernel/ftrace.c b/arch/x86/kernel/ftrace.c
index d036cfb44..cb4c99113 100644
--- a/arch/x86/kernel/ftrace.c
+++ b/arch/x86/kernel/ftrace.c
@@ -89,7 +89,7 @@ static unsigned long text_ip_addr(unsigned long ip)
 	 * kernel identity mapping to modify code.
 	 */
 	if (within(ip, (unsigned long)_text, (unsigned long)_etext))
-		ip = (unsigned long)__va(__pa_symbol(ip));
+		ip = (unsigned long)__va(__pa_symbol(ktla_ktva(ip)));
 
 	return ip;
 }
@@ -105,6 +105,8 @@ ftrace_modify_code_direct(unsigned long ip, unsigned const char *old_code,
 {
 	unsigned char replaced[MCOUNT_INSN_SIZE];
 
+	ip = ktla_ktva(ip);
+
 	ftrace_expected = old_code;
 
 	/*
@@ -233,7 +235,7 @@ static int update_ftrace_func(unsigned long ip, void *new)
 	unsigned char old[MCOUNT_INSN_SIZE];
 	int ret;
 
-	memcpy(old, (void *)ip, MCOUNT_INSN_SIZE);
+	memcpy(old, (void *)ktla_ktva(ip), MCOUNT_INSN_SIZE);
 
 	ftrace_update_func = ip;
 	/* Make sure the breakpoints see the ftrace_update_func update */
@@ -314,7 +316,7 @@ static int add_break(unsigned long ip, const char *old)
 	unsigned char replaced[MCOUNT_INSN_SIZE];
 	unsigned char brk = BREAKPOINT_INSTRUCTION;
 
-	if (probe_kernel_read(replaced, (void *)ip, MCOUNT_INSN_SIZE))
+	if (probe_kernel_read(replaced, (void *)ktla_ktva(ip), MCOUNT_INSN_SIZE))
 		return -EFAULT;
 
 	ftrace_expected = old;
@@ -681,11 +683,11 @@ static unsigned char *ftrace_jmp_replace(unsigned long ip, unsigned long addr)
 /* Module allocation simplifies allocating memory for code */
 static inline void *alloc_tramp(unsigned long size)
 {
-	return module_alloc(size);
+	return module_alloc_exec(size);
 }
 static inline void tramp_free(void *tramp)
 {
-	module_memfree(tramp);
+	module_memfree_exec(tramp);
 }
 #else
 /* Trampolines can only be created if modules are supported */
@@ -763,7 +765,9 @@ create_trampoline(struct ftrace_ops *ops, unsigned int *tramp_size)
 	*tramp_size = size + MCOUNT_INSN_SIZE + sizeof(void *);
 
 	/* Copy ftrace_caller onto the trampoline memory */
+	pax_open_kernel();
 	ret = probe_kernel_read(trampoline, (void *)start_offset, size);
+	pax_close_kernel();
 	if (WARN_ON(ret < 0)) {
 		tramp_free(trampoline);
 		return 0;
@@ -773,6 +777,7 @@ create_trampoline(struct ftrace_ops *ops, unsigned int *tramp_size)
 
 	/* The trampoline ends with a jmp to ftrace_epilogue */
 	jmp = ftrace_jmp_replace(ip, (unsigned long)ftrace_epilogue);
+	pax_open_kernel();
 	memcpy(trampoline + size, jmp, MCOUNT_INSN_SIZE);
 
 	/*
@@ -785,6 +790,7 @@ create_trampoline(struct ftrace_ops *ops, unsigned int *tramp_size)
 
 	ptr = (unsigned long *)(trampoline + size + MCOUNT_INSN_SIZE);
 	*ptr = (unsigned long)ops;
+	pax_close_kernel();
 
 	op_offset -= start_offset;
 	memcpy(&op_ptr, trampoline + op_offset, OP_REF_SIZE);
@@ -802,7 +808,9 @@ create_trampoline(struct ftrace_ops *ops, unsigned int *tramp_size)
 	op_ptr.offset = offset;
 
 	/* put in the new offset to the ftrace_ops */
+	pax_open_kernel();
 	memcpy(trampoline + op_offset, &op_ptr, OP_REF_SIZE);
+	pax_close_kernel();
 
 	/* ALLOC_TRAMP flags lets us know we created it */
 	ops->flags |= FTRACE_OPS_FL_ALLOC_TRAMP;
diff --git a/arch/x86/kernel/head64.c b/arch/x86/kernel/head64.c
index 54a2372f5..46504a418 100644
--- a/arch/x86/kernel/head64.c
+++ b/arch/x86/kernel/head64.c
@@ -62,12 +62,12 @@ again:
 	pgd = *pgd_p;
 
 	/*
-	 * The use of __START_KERNEL_map rather than __PAGE_OFFSET here is
-	 * critical -- __PAGE_OFFSET would point us back into the dynamic
+	 * The use of __early_va rather than __va here is critical:
+	 * __va would point us back into the dynamic
 	 * range and we might end up looping forever...
 	 */
 	if (pgd)
-		pud_p = (pudval_t *)((pgd & PTE_PFN_MASK) + __START_KERNEL_map - phys_base);
+		pud_p = (pudval_t *)(__early_va(pgd & PTE_PFN_MASK));
 	else {
 		if (next_early_pgt >= EARLY_DYNAMIC_PAGE_TABLES) {
 			reset_early_page_tables();
@@ -76,13 +76,13 @@ again:
 
 		pud_p = (pudval_t *)early_dynamic_pgts[next_early_pgt++];
 		memset(pud_p, 0, sizeof(*pud_p) * PTRS_PER_PUD);
-		*pgd_p = (pgdval_t)pud_p - __START_KERNEL_map + phys_base + _KERNPG_TABLE;
+		*pgd_p = (pgdval_t)__pa(pud_p) + _KERNPG_TABLE;
 	}
 	pud_p += pud_index(address);
 	pud = *pud_p;
 
 	if (pud)
-		pmd_p = (pmdval_t *)((pud & PTE_PFN_MASK) + __START_KERNEL_map - phys_base);
+		pmd_p = (pmdval_t *)(__early_va(pud & PTE_PFN_MASK));
 	else {
 		if (next_early_pgt >= EARLY_DYNAMIC_PAGE_TABLES) {
 			reset_early_page_tables();
@@ -91,7 +91,7 @@ again:
 
 		pmd_p = (pmdval_t *)early_dynamic_pgts[next_early_pgt++];
 		memset(pmd_p, 0, sizeof(*pmd_p) * PTRS_PER_PMD);
-		*pud_p = (pudval_t)pmd_p - __START_KERNEL_map + phys_base + _KERNPG_TABLE;
+		*pud_p = (pudval_t)__pa(pmd_p) + _KERNPG_TABLE;
 	}
 	pmd = (physaddr & PMD_MASK) + early_pmd_flags;
 	pmd_p[pmd_index(address)] = pmd;
@@ -155,8 +155,6 @@ asmlinkage __visible void __init x86_64_start_kernel(char * real_mode_data)
 
 	clear_bss();
 
-	clear_page(init_level4_pgt);
-
 	kasan_early_init();
 
 	for (i = 0; i < NUM_EXCEPTION_VECTORS; i++)
diff --git a/arch/x86/kernel/head_32.S b/arch/x86/kernel/head_32.S
index 6f8902b0d..5d42150a0 100644
--- a/arch/x86/kernel/head_32.S
+++ b/arch/x86/kernel/head_32.S
@@ -27,6 +27,12 @@
 /* Physical address */
 #define pa(X) ((X) - __PAGE_OFFSET)
 
+#ifdef CONFIG_PAX_KERNEXEC
+#define ta(X) (X)
+#else
+#define ta(X) ((X) - __PAGE_OFFSET)
+#endif
+
 /*
  * References to members of the new_cpu_data structure.
  */
@@ -56,11 +62,7 @@
  * and small than max_low_pfn, otherwise will waste some page table entries
  */
 
-#if PTRS_PER_PMD > 1
-#define PAGE_TABLE_SIZE(pages) (((pages) / PTRS_PER_PMD) + PTRS_PER_PGD)
-#else
-#define PAGE_TABLE_SIZE(pages) ((pages) / PTRS_PER_PGD)
-#endif
+#define PAGE_TABLE_SIZE(pages) ((pages) / PTRS_PER_PTE)
 
 /*
  * Number of possible pages in the lowmem region.
@@ -86,6 +88,12 @@ INIT_MAP_SIZE = PAGE_TABLE_SIZE(KERNEL_PAGES) * PAGE_SIZE
 RESERVE_BRK(pagetables, INIT_MAP_SIZE)
 
 /*
+ * Real beginning of normal "text" segment
+ */
+ENTRY(stext)
+ENTRY(_stext)
+
+/*
  * 32-bit kernel entrypoint; only used by the boot CPU.  On entry,
  * %esi points to the real-mode code as a 32-bit pointer.
  * CS and DS must be 4 GB flat segments, but we don't depend on
@@ -93,6 +101,13 @@ RESERVE_BRK(pagetables, INIT_MAP_SIZE)
  * can.
  */
 __HEAD
+
+#ifdef CONFIG_PAX_KERNEXEC
+	jmp startup_32
+/* PaX: fill first page in .text with int3 to catch NULL derefs in kernel mode */
+.fill PAGE_SIZE-5,1,0xcc
+#endif
+
 ENTRY(startup_32)
 	movl pa(stack_start),%ecx
 	
@@ -114,6 +129,66 @@ ENTRY(startup_32)
 2:
 	leal -__PAGE_OFFSET(%ecx),%esp
 
+#ifdef CONFIG_SMP
+	movl $pa(cpu_gdt_table),%edi
+	movl $__per_cpu_load,%eax
+	movw %ax,GDT_ENTRY_PERCPU * 8 + 2(%edi)
+	rorl $16,%eax
+	movb %al,GDT_ENTRY_PERCPU * 8 + 4(%edi)
+	movb %ah,GDT_ENTRY_PERCPU * 8 + 7(%edi)
+	movl $__per_cpu_end - 1,%eax
+	subl $__per_cpu_start,%eax
+	cmpl $0x100000,%eax
+	jb 1f
+	shrl $PAGE_SHIFT,%eax
+	orb $0x80,GDT_ENTRY_PERCPU * 8 + 6(%edi)
+1:
+	movw %ax,GDT_ENTRY_PERCPU * 8 + 0(%edi)
+	shrl $16,%eax
+	orb %al,GDT_ENTRY_PERCPU * 8 + 6(%edi)
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	movl $NR_CPUS,%ecx
+	movl $pa(cpu_gdt_table),%edi
+1:
+	movl $((((__PAGE_OFFSET-1) & 0xf0000000) >> 12) | 0x00c09700),GDT_ENTRY_KERNEL_DS * 8 + 4(%edi)
+	movl $((((__PAGE_OFFSET-1) & 0xf0000000) >> 12) | 0x00c0fb00),GDT_ENTRY_DEFAULT_USER_CS * 8 + 4(%edi)
+	movl $((((__PAGE_OFFSET-1) & 0xf0000000) >> 12) | 0x00c0f300),GDT_ENTRY_DEFAULT_USER_DS * 8 + 4(%edi)
+	addl $PAGE_SIZE_asm,%edi
+	loop 1b
+#endif
+
+#ifdef CONFIG_PAX_KERNEXEC
+	movl $pa(boot_gdt),%edi
+	movl $__LOAD_PHYSICAL_ADDR,%eax
+	movw %ax,GDT_ENTRY_BOOT_CS * 8 + 2(%edi)
+	rorl $16,%eax
+	movb %al,GDT_ENTRY_BOOT_CS * 8 + 4(%edi)
+	movb %ah,GDT_ENTRY_BOOT_CS * 8 + 7(%edi)
+	rorl $16,%eax
+
+	ljmp $(__BOOT_CS),$1f
+1:
+
+	movl $NR_CPUS,%ecx
+	movl $pa(cpu_gdt_table),%edi
+	addl $__PAGE_OFFSET,%eax
+1:
+	movb $0xc0,GDT_ENTRY_KERNEL_CS * 8 + 6(%edi)
+	movb $0xc0,GDT_ENTRY_KERNEXEC_KERNEL_CS * 8 + 6(%edi)
+	movw %ax,GDT_ENTRY_KERNEL_CS * 8 + 2(%edi)
+	movw %ax,GDT_ENTRY_KERNEXEC_KERNEL_CS * 8 + 2(%edi)
+	rorl $16,%eax
+	movb %al,GDT_ENTRY_KERNEL_CS * 8 + 4(%edi)
+	movb %al,GDT_ENTRY_KERNEXEC_KERNEL_CS * 8 + 4(%edi)
+	movb %ah,GDT_ENTRY_KERNEL_CS * 8 + 7(%edi)
+	movb %ah,GDT_ENTRY_KERNEXEC_KERNEL_CS * 8 + 7(%edi)
+	rorl $16,%eax
+	addl $PAGE_SIZE_asm,%edi
+	loop 1b
+#endif
+
 /*
  * Clear BSS first so that there are no surprises...
  */
@@ -209,8 +284,11 @@ ENTRY(startup_32)
 	movl %eax, pa(max_pfn_mapped)
 
 	/* Do early initialization of the fixmap area */
-	movl $pa(initial_pg_fixmap)+PDE_IDENT_ATTR,%eax
-	movl %eax,pa(initial_pg_pmd+0x1000*KPMDS-8)
+#ifdef CONFIG_COMPAT_VDSO
+	movl $pa(initial_pg_fixmap)+PDE_IDENT_ATTR+_PAGE_USER,pa(initial_pg_pmd+0x1000*KPMDS-8)
+#else
+	movl $pa(initial_pg_fixmap)+PDE_IDENT_ATTR,pa(initial_pg_pmd+0x1000*KPMDS-8)
+#endif
 #else	/* Not PAE */
 
 page_pde_offset = (__PAGE_OFFSET >> 20);
@@ -240,8 +318,11 @@ page_pde_offset = (__PAGE_OFFSET >> 20);
 	movl %eax, pa(max_pfn_mapped)
 
 	/* Do early initialization of the fixmap area */
-	movl $pa(initial_pg_fixmap)+PDE_IDENT_ATTR,%eax
-	movl %eax,pa(initial_page_table+0xffc)
+#ifdef CONFIG_COMPAT_VDSO
+	movl $pa(initial_pg_fixmap)+PDE_IDENT_ATTR+_PAGE_USER,pa(initial_page_table+0xffc)
+#else
+	movl $pa(initial_pg_fixmap)+PDE_IDENT_ATTR,pa(initial_page_table+0xffc)
+#endif
 #endif
 
 #ifdef CONFIG_PARAVIRT
@@ -255,9 +336,7 @@ page_pde_offset = (__PAGE_OFFSET >> 20);
 	cmpl $num_subarch_entries, %eax
 	jae bad_subarch
 
-	movl pa(subarch_entries)(,%eax,4), %eax
-	subl $__PAGE_OFFSET, %eax
-	jmp *%eax
+	jmp *pa(subarch_entries)(,%eax,4)
 
 bad_subarch:
 WEAK(lguest_entry)
@@ -269,10 +348,10 @@ WEAK(xen_entry)
 	__INITDATA
 
 subarch_entries:
-	.long default_entry		/* normal x86/PC */
-	.long lguest_entry		/* lguest hypervisor */
-	.long xen_entry			/* Xen hypervisor */
-	.long default_entry		/* Moorestown MID */
+	.long ta(default_entry)		/* normal x86/PC */
+	.long ta(lguest_entry)		/* lguest hypervisor */
+	.long ta(xen_entry)		/* Xen hypervisor */
+	.long ta(default_entry)		/* Moorestown MID */
 num_subarch_entries = (. - subarch_entries) / 4
 .previous
 #else
@@ -361,6 +440,7 @@ default_entry:
 	movl pa(mmu_cr4_features),%eax
 	movl %eax,%cr4
 
+#ifdef CONFIG_X86_PAE
 	testb $X86_CR4_PAE, %al		# check if PAE is enabled
 	jz enable_paging
 
@@ -389,6 +469,9 @@ default_entry:
 	/* Make changes effective */
 	wrmsr
 
+	btsl $_PAGE_BIT_NX-32,pa(__supported_pte_mask+4)
+#endif
+
 enable_paging:
 
 /*
@@ -456,14 +539,20 @@ is486:
 1:	movl $(__KERNEL_DS),%eax	# reload all the segment registers
 	movl %eax,%ss			# after changing gdt.
 
-	movl $(__USER_DS),%eax		# DS/ES contains default USER segment
+#	movl $(__KERNEL_DS),%eax	# DS/ES contains default KERNEL segment
 	movl %eax,%ds
 	movl %eax,%es
 
 	movl $(__KERNEL_PERCPU), %eax
 	movl %eax,%fs			# set this cpu's percpu
 
+#ifdef CONFIG_CC_STACKPROTECTOR
 	movl $(__KERNEL_STACK_CANARY),%eax
+#elif defined(CONFIG_PAX_MEMORY_UDEREF)
+	movl $(__USER_DS),%eax
+#else
+	xorl %eax,%eax
+#endif
 	movl %eax,%gs
 
 	xorl %eax,%eax			# Clear LDT
@@ -520,8 +609,11 @@ setup_once:
 	 * relocation.  Manually set base address in stack canary
 	 * segment descriptor.
 	 */
-	movl $gdt_page,%eax
+	movl $cpu_gdt_table,%eax
 	movl $stack_canary,%ecx
+#ifdef CONFIG_SMP
+	addl $__per_cpu_load,%ecx
+#endif
 	movw %cx, 8 * GDT_ENTRY_STACK_CANARY + 2(%eax)
 	shrl $16, %ecx
 	movb %cl, 8 * GDT_ENTRY_STACK_CANARY + 4(%eax)
@@ -608,8 +700,11 @@ ENDPROC(early_idt_handler_common)
 /* This is the default interrupt "handler" :-) */
 	ALIGN
 ignore_int:
-	cld
 #ifdef CONFIG_PRINTK
+	cmpl $2,%ss:early_recursion_flag
+	je hlt_loop
+	incl %ss:early_recursion_flag
+	cld
 	pushl %eax
 	pushl %ecx
 	pushl %edx
@@ -618,9 +713,6 @@ ignore_int:
 	movl $(__KERNEL_DS),%eax
 	movl %eax,%ds
 	movl %eax,%es
-	cmpl $2,early_recursion_flag
-	je hlt_loop
-	incl early_recursion_flag
 	pushl 16(%esp)
 	pushl 24(%esp)
 	pushl 32(%esp)
@@ -655,11 +747,8 @@ ENTRY(initial_code)
 ENTRY(setup_once_ref)
 	.long setup_once
 
-/*
- * BSS section
- */
-__PAGE_ALIGNED_BSS
-	.align PAGE_SIZE
+__READ_ONLY
+	.balign	PAGE_SIZE
 #ifdef CONFIG_X86_PAE
 initial_pg_pmd:
 	.fill 1024*KPMDS,4,0
@@ -672,15 +761,18 @@ initial_pg_fixmap:
 ENTRY(empty_zero_page)
 	.fill 4096,1,0
 ENTRY(swapper_pg_dir)
-	.fill 1024,4,0
+#ifdef CONFIG_X86_PAE
+	.fill PTRS_PER_PGD,8,0
+#else
+	.fill PTRS_PER_PGD,4,0
+#endif
 
 /*
  * This starts the data section.
  */
 #ifdef CONFIG_X86_PAE
-__PAGE_ALIGNED_DATA
-	/* Page-aligned for the benefit of paravirt? */
-	.align PAGE_SIZE
+__READ_ONLY
+	.balign	PAGE_SIZE
 ENTRY(initial_page_table)
 	.long	pa(initial_pg_pmd+PGD_IDENT_ATTR),0	/* low identity map */
 # if KPMDS == 3
@@ -698,13 +790,21 @@ ENTRY(initial_page_table)
 # else
 #  error "Kernel PMDs should be 1, 2 or 3"
 # endif
-	.align PAGE_SIZE		/* needs to be page-sized too */
+	.balign PAGE_SIZE		/* needs to be page-sized too */
+
+# ifdef CONFIG_PAX_PER_CPU_PGD
+ENTRY(cpu_pgd)
+	.rept 2*NR_CPUS
+	.fill	PTRS_PER_PGD,8,0
+	.endr
+# endif
+
 #endif
 
 .data
 .balign 4
 ENTRY(stack_start)
-	.long init_thread_union+THREAD_SIZE
+	.long init_thread_union+THREAD_SIZE-8
 
 __INITRODATA
 int_msg:
@@ -719,7 +819,7 @@ int_msg:
  * segment size, and 32-bit linear address value:
  */
 
-	.data
+__READ_ONLY
 .globl boot_gdt_descr
 .globl idt_descr
 
@@ -728,7 +828,7 @@ int_msg:
 	.word 0				# 32 bit align gdt_desc.address
 boot_gdt_descr:
 	.word __BOOT_DS+7
-	.long boot_gdt - __PAGE_OFFSET
+	.long pa(boot_gdt)
 
 	.word 0				# 32-bit align idt_desc.address
 idt_descr:
@@ -739,7 +839,7 @@ idt_descr:
 	.word 0				# 32 bit align gdt_desc.address
 ENTRY(early_gdt_descr)
 	.word GDT_ENTRIES*8-1
-	.long gdt_page			/* Overwritten for secondary CPUs */
+	.long cpu_gdt_table		/* Overwritten for secondary CPUs */
 
 /*
  * The boot_gdt must mirror the equivalent in setup.S and is
@@ -748,5 +848,65 @@ ENTRY(early_gdt_descr)
 	.align L1_CACHE_BYTES
 ENTRY(boot_gdt)
 	.fill GDT_ENTRY_BOOT_CS,8,0
-	.quad 0x00cf9a000000ffff	/* kernel 4GB code at 0x00000000 */
-	.quad 0x00cf92000000ffff	/* kernel 4GB data at 0x00000000 */
+	.quad 0x00cf9b000000ffff	/* kernel 4GB code at 0x00000000 */
+	.quad 0x00cf93000000ffff	/* kernel 4GB data at 0x00000000 */
+
+	.align PAGE_SIZE_asm
+ENTRY(cpu_gdt_table)
+	.rept NR_CPUS
+	.quad 0x0000000000000000	/* NULL descriptor */
+	.quad 0x0000000000000000	/* 0x0b reserved */
+	.quad 0x0000000000000000	/* 0x13 reserved */
+	.quad 0x0000000000000000	/* 0x1b reserved */
+
+#ifdef CONFIG_PAX_KERNEXEC
+	.quad 0x00cf9b000000ffff	/* 0x20 alternate kernel 4GB code at 0x00000000 */
+#else
+	.quad 0x0000000000000000	/* 0x20 unused */
+#endif
+
+	.quad 0x0000000000000000	/* 0x28 unused */
+	.quad 0x0000000000000000	/* 0x33 TLS entry 1 */
+	.quad 0x0000000000000000	/* 0x3b TLS entry 2 */
+	.quad 0x0000000000000000	/* 0x43 TLS entry 3 */
+	.quad 0x0000000000000000	/* 0x4b reserved */
+	.quad 0x0000000000000000	/* 0x53 reserved */
+	.quad 0x0000000000000000	/* 0x5b reserved */
+
+	.quad 0x00cf9b000000ffff	/* 0x60 kernel 4GB code at 0x00000000 */
+	.quad 0x00cf93000000ffff	/* 0x68 kernel 4GB data at 0x00000000 */
+	.quad 0x00cffb000000ffff	/* 0x73 user 4GB code at 0x00000000 */
+	.quad 0x00cff3000000ffff	/* 0x7b user 4GB data at 0x00000000 */
+
+	.quad 0x0000000000000000	/* 0x80 TSS descriptor */
+	.quad 0x0000000000000000	/* 0x88 LDT descriptor */
+
+	/*
+	 * Segments used for calling PnP BIOS have byte granularity.
+	 * The code segments and data segments have fixed 64k limits,
+	 * the transfer segment sizes are set at run time.
+	 */
+	.quad 0x00409b000000ffff	/* 0x90 32-bit code */
+	.quad 0x00009b000000ffff	/* 0x98 16-bit code */
+	.quad 0x000093000000ffff	/* 0xa0 16-bit data */
+	.quad 0x0000930000000000	/* 0xa8 16-bit data */
+	.quad 0x0000930000000000	/* 0xb0 16-bit data */
+
+	/*
+	 * The APM segments have byte granularity and their bases
+	 * are set at run time.  All have 64k limits.
+	 */
+	.quad 0x00409b000000ffff	/* 0xb8 APM CS    code */
+	.quad 0x00009b000000ffff	/* 0xc0 APM CS 16 code (16 bit) */
+	.quad 0x004093000000ffff	/* 0xc8 APM DS    data */
+
+	.quad 0x00c093000000ffff	/* 0xd0 - ESPFIX SS */
+	.quad 0x0040930000000000	/* 0xd8 - PERCPU */
+	.quad 0x0040910000000017	/* 0xe0 - STACK_CANARY */
+	.quad 0x0000000000000000	/* 0xe8 - PCIBIOS_CS */
+	.quad 0x0000000000000000	/* 0xf0 - PCIBIOS_DS */
+	.quad 0x0000000000000000	/* 0xf8 - GDT entry 31: double-fault TSS */
+
+	/* Be sure this is zeroed to avoid false validations in Xen */
+	.fill PAGE_SIZE_asm - GDT_SIZE,1,0
+	.endr
diff --git a/arch/x86/kernel/head_64.S b/arch/x86/kernel/head_64.S
index 9f8efc9f0..448c93f10 100644
--- a/arch/x86/kernel/head_64.S
+++ b/arch/x86/kernel/head_64.S
@@ -20,6 +20,8 @@
 #include <asm/processor-flags.h>
 #include <asm/percpu.h>
 #include <asm/nops.h>
+#include <asm/cpufeatures.h>
+#include <asm/alternative-asm.h>
 #include "../entry/calling.h"
 
 #ifdef CONFIG_PARAVIRT
@@ -41,6 +43,12 @@
 L4_PAGE_OFFSET = pgd_index(__PAGE_OFFSET_BASE)
 L4_START_KERNEL = pgd_index(__START_KERNEL_map)
 L3_START_KERNEL = pud_index(__START_KERNEL_map)
+L4_VMALLOC_START = pgd_index(VMALLOC_START)
+L3_VMALLOC_START = pud_index(VMALLOC_START)
+L4_VMALLOC_END = pgd_index(VMALLOC_END)
+L3_VMALLOC_END = pud_index(VMALLOC_END)
+L4_VMEMMAP_START = pgd_index(VMEMMAP_START)
+L3_VMEMMAP_START = pud_index(VMEMMAP_START)
 
 	.text
 	__HEAD
@@ -98,11 +106,36 @@ startup_64:
 	 * Fixup the physical addresses in the page table
 	 */
 	addq	%rbp, early_level4_pgt + (L4_START_KERNEL*8)(%rip)
+	addq	%rbp, init_level4_pgt + (L4_PAGE_OFFSET*8)(%rip)
+	addq	%rbp, init_level4_pgt + (L4_VMALLOC_START*8)(%rip)
+	addq	%rbp, init_level4_pgt + (L4_VMALLOC_START*8) + 8(%rip)
+	addq	%rbp, init_level4_pgt + (L4_VMALLOC_START*8) + 16(%rip)
+	addq	%rbp, init_level4_pgt + (L4_VMALLOC_START*8) + 24(%rip)
+	addq	%rbp, init_level4_pgt + (L4_VMALLOC_END*8)(%rip)
+	addq	%rbp, init_level4_pgt + (L4_VMEMMAP_START*8)(%rip)
+	addq	%rbp, init_level4_pgt + (L4_START_KERNEL*8)(%rip)
+
+	addq	%rbp, level3_ident_pgt + (0*8)(%rip)
+#ifndef CONFIG_XEN
+	addq	%rbp, level3_ident_pgt + (1*8)(%rip)
+#endif
+
+	addq	%rbp, level3_vmemmap_pgt + (L3_VMEMMAP_START*8)(%rip)
+
+	addq	%rbp, level3_kernel_pgt + (L3_START_KERNEL*8)(%rip)
+	addq	%rbp, level3_kernel_pgt + ((L3_START_KERNEL+1)*8)(%rip)
+
+	addq	%rbp, level2_ident_pgt + (0*8)(%rip)
 
-	addq	%rbp, level3_kernel_pgt + (510*8)(%rip)
-	addq	%rbp, level3_kernel_pgt + (511*8)(%rip)
+	addq	%rbp, level2_fixmap_pgt + (0*8)(%rip)
+	addq	%rbp, level2_fixmap_pgt + (1*8)(%rip)
+	addq	%rbp, level2_fixmap_pgt + (2*8)(%rip)
+	addq	%rbp, level2_fixmap_pgt + (3*8)(%rip)
 
+	addq	%rbp, level2_fixmap_pgt + (504*8)(%rip)
+	addq	%rbp, level2_fixmap_pgt + (505*8)(%rip)
 	addq	%rbp, level2_fixmap_pgt + (506*8)(%rip)
+	addq	%rbp, level2_fixmap_pgt + (507*8)(%rip)
 
 	/*
 	 * Set up the identity mapping for the switchover.  These
@@ -186,11 +219,12 @@ ENTRY(secondary_startup_64)
 	/* Sanitize CPU configuration */
 	call verify_cpu
 
+	orq	$-1, %rbp
 	movq	$(init_level4_pgt - __START_KERNEL_map), %rax
 1:
 
-	/* Enable PAE mode and PGE */
-	movl	$(X86_CR4_PAE | X86_CR4_PGE), %ecx
+	/* Enable PAE mode and PSE/PGE */
+	movl	$(X86_CR4_PSE | X86_CR4_PAE | X86_CR4_PGE), %ecx
 	movq	%rcx, %cr4
 
 	/* Setup early boot stage 4 level pagetables. */
@@ -211,10 +245,24 @@ ENTRY(secondary_startup_64)
 	movl	$MSR_EFER, %ecx
 	rdmsr
 	btsl	$_EFER_SCE, %eax	/* Enable System Call */
-	btl	$20,%edi		/* No Execute supported? */
+	btl	$(X86_FEATURE_NX & 31),%edi	/* No Execute supported? */
 	jnc     1f
 	btsl	$_EFER_NX, %eax
+	cmpq	$-1, %rbp
+	je	1f
 	btsq	$_PAGE_BIT_NX,early_pmd_flags(%rip)
+	btsq	$_PAGE_BIT_NX, init_level4_pgt + 8*L4_PAGE_OFFSET(%rip)
+	btsq	$_PAGE_BIT_NX, init_level4_pgt + (8*L4_VMALLOC_START)(%rip)
+	btsq	$_PAGE_BIT_NX, init_level4_pgt + (8*L4_VMALLOC_START) + 8(%rip)
+	btsq	$_PAGE_BIT_NX, init_level4_pgt + (8*L4_VMALLOC_START) + 16(%rip)
+	btsq	$_PAGE_BIT_NX, init_level4_pgt + (8*L4_VMALLOC_START) + 24(%rip)
+	btsq	$_PAGE_BIT_NX, init_level4_pgt + 8*L4_VMALLOC_END(%rip)
+	btsq	$_PAGE_BIT_NX, init_level4_pgt + 8*L4_VMEMMAP_START(%rip)
+	btsq	$_PAGE_BIT_NX, level2_fixmap_pgt + 8*504(%rip)
+	btsq	$_PAGE_BIT_NX, level2_fixmap_pgt + 8*505(%rip)
+	btsq	$_PAGE_BIT_NX, level2_fixmap_pgt + 8*506(%rip)
+	btsq	$_PAGE_BIT_NX, level2_fixmap_pgt + 8*507(%rip)
+	btsq	$_PAGE_BIT_NX, __supported_pte_mask(%rip)
 1:	wrmsr				/* Make changes effective */
 
 	/* Setup cr0 */
@@ -294,10 +342,10 @@ ENTRY(secondary_startup_64)
 	 *	REX.W + FF /5 JMP m16:64 Jump far, absolute indirect,
 	 *		address given in m16:64.
 	 */
-	movq	initial_code(%rip),%rax
+	pax_set_fptr_mask
 	pushq	$0		# fake return address to stop unwinder
 	pushq	$__KERNEL_CS	# set correct cs
-	pushq	%rax		# target address in negative space
+	pushq	initial_code(%rip) # target address in negative space
 	lretq
 ENDPROC(secondary_startup_64)
 
@@ -311,10 +359,9 @@ ENDPROC(secondary_startup_64)
  */
 ENTRY(start_cpu0)
 	movq stack_start(%rip),%rsp
-	movq	initial_code(%rip),%rax
 	pushq	$0		# fake return address to stop unwinder
 	pushq	$__KERNEL_CS	# set correct cs
-	pushq	%rax		# target address in negative space
+	pushq	initial_code(%rip) # target address in negative space
 	lretq
 ENDPROC(start_cpu0)
 #endif
@@ -328,7 +375,7 @@ ENDPROC(start_cpu0)
 	.quad	INIT_PER_CPU_VAR(irq_stack_union)
 
 	GLOBAL(stack_start)
-	.quad  init_thread_union+THREAD_SIZE-8
+	.quad  init_thread_union+THREAD_SIZE-16
 	.word  0
 	__FINITDATA
 
@@ -417,40 +464,70 @@ GLOBAL(name)
 	__INITDATA
 NEXT_PAGE(early_level4_pgt)
 	.fill	511,8,0
-	.quad	level3_kernel_pgt - __START_KERNEL_map + _PAGE_TABLE
+	.quad	level3_kernel_pgt - __START_KERNEL_map + _KERNPG_TABLE
 
 NEXT_PAGE(early_dynamic_pgts)
 	.fill	512*EARLY_DYNAMIC_PAGE_TABLES,8,0
 
-	.data
+	__READ_ONLY
 
-#ifndef CONFIG_XEN
 NEXT_PAGE(init_level4_pgt)
-	.fill	512,8,0
-#else
-NEXT_PAGE(init_level4_pgt)
-	.quad   level3_ident_pgt - __START_KERNEL_map + _KERNPG_TABLE
 	.org    init_level4_pgt + L4_PAGE_OFFSET*8, 0
 	.quad   level3_ident_pgt - __START_KERNEL_map + _KERNPG_TABLE
+	.org	init_level4_pgt + L4_VMALLOC_START*8, 0
+	.quad	level3_vmalloc_start_pgt - __START_KERNEL_map + PAGE_SIZE*0 + _KERNPG_TABLE
+	.quad	level3_vmalloc_start_pgt - __START_KERNEL_map + PAGE_SIZE*1 + _KERNPG_TABLE
+	.quad	level3_vmalloc_start_pgt - __START_KERNEL_map + PAGE_SIZE*2 + _KERNPG_TABLE
+	.quad	level3_vmalloc_start_pgt - __START_KERNEL_map + PAGE_SIZE*3 + _KERNPG_TABLE
+	.org	init_level4_pgt + L4_VMALLOC_END*8, 0
+	.quad	level3_vmalloc_end_pgt - __START_KERNEL_map + _KERNPG_TABLE
+	.org	init_level4_pgt + L4_VMEMMAP_START*8, 0
+	.quad	level3_vmemmap_pgt - __START_KERNEL_map + _KERNPG_TABLE
 	.org    init_level4_pgt + L4_START_KERNEL*8, 0
 	/* (2^48-(2*1024*1024*1024))/(2^39) = 511 */
-	.quad   level3_kernel_pgt - __START_KERNEL_map + _PAGE_TABLE
+	.quad   level3_kernel_pgt - __START_KERNEL_map + _KERNPG_TABLE
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+NEXT_PAGE(cpu_pgd)
+	.rept 2*NR_CPUS
+	.fill	512,8,0
+	.endr
+#endif
 
 NEXT_PAGE(level3_ident_pgt)
 	.quad	level2_ident_pgt - __START_KERNEL_map + _KERNPG_TABLE
+#ifdef CONFIG_XEN
 	.fill	511, 8, 0
+#else
+	.quad	level2_ident_pgt + PAGE_SIZE - __START_KERNEL_map + _KERNPG_TABLE
+	.fill	510,8,0
+#endif
+
+NEXT_PAGE(level3_vmalloc_start_pgt)
+	.fill	4*512,8,0
+
+NEXT_PAGE(level3_vmalloc_end_pgt)
+	.fill	512,8,0
+
+NEXT_PAGE(level3_vmemmap_pgt)
+	.fill	L3_VMEMMAP_START,8,0
+	.quad	level2_vmemmap_pgt - __START_KERNEL_map + _KERNPG_TABLE
+
 NEXT_PAGE(level2_ident_pgt)
-	/* Since I easily can, map the first 1G.
+	.quad	level1_ident_pgt - __START_KERNEL_map + _KERNPG_TABLE
+	/* Since I easily can, map the first 2G.
 	 * Don't set NX because code runs from these pages.
 	 */
-	PMDS(0, __PAGE_KERNEL_IDENT_LARGE_EXEC, PTRS_PER_PMD)
-#endif
+	PMDS(PMD_SIZE, __PAGE_KERNEL_IDENT_LARGE_EXEC, 2*PTRS_PER_PMD - 1)
 
 NEXT_PAGE(level3_kernel_pgt)
 	.fill	L3_START_KERNEL,8,0
 	/* (2^48-(2*1024*1024*1024)-((2^39)*511))/(2^30) = 510 */
 	.quad	level2_kernel_pgt - __START_KERNEL_map + _KERNPG_TABLE
-	.quad	level2_fixmap_pgt - __START_KERNEL_map + _PAGE_TABLE
+	.quad	level2_fixmap_pgt - __START_KERNEL_map + _KERNPG_TABLE
+
+NEXT_PAGE(level2_vmemmap_pgt)
+	.fill	512,8,0
 
 NEXT_PAGE(level2_kernel_pgt)
 	/*
@@ -467,31 +544,79 @@ NEXT_PAGE(level2_kernel_pgt)
 		KERNEL_IMAGE_SIZE/PMD_SIZE)
 
 NEXT_PAGE(level2_fixmap_pgt)
-	.fill	506,8,0
-	.quad	level1_fixmap_pgt - __START_KERNEL_map + _PAGE_TABLE
-	/* 8MB reserved for vsyscalls + a 2MB hole = 4 + 1 entries */
-	.fill	5,8,0
+	.quad	level1_modules_pgt - __START_KERNEL_map + 0 * PAGE_SIZE + _KERNPG_TABLE
+	.quad	level1_modules_pgt - __START_KERNEL_map + 1 * PAGE_SIZE + _KERNPG_TABLE
+	.quad	level1_modules_pgt - __START_KERNEL_map + 2 * PAGE_SIZE + _KERNPG_TABLE
+	.quad	level1_modules_pgt - __START_KERNEL_map + 3 * PAGE_SIZE + _KERNPG_TABLE
+	.fill	500,8,0
+	.quad	level1_fixmap_pgt - __START_KERNEL_map + 0 * PAGE_SIZE + _KERNPG_TABLE
+	.quad	level1_fixmap_pgt - __START_KERNEL_map + 1 * PAGE_SIZE + _KERNPG_TABLE
+	.quad	level1_fixmap_pgt - __START_KERNEL_map + 2 * PAGE_SIZE + _KERNPG_TABLE
+	.quad	level1_vsyscall_pgt - __START_KERNEL_map + _KERNPG_TABLE
+	/* 6MB reserved for vsyscalls + a 2MB hole = 3 + 1 entries */
+	.fill	4,8,0
+
+NEXT_PAGE(level1_ident_pgt)
+	.fill	512,8,0
+
+NEXT_PAGE(level1_modules_pgt)
+	.fill	4*512,8,0
 
 NEXT_PAGE(level1_fixmap_pgt)
+	.fill	3*512,8,0
+
+NEXT_PAGE(level1_vsyscall_pgt)
 	.fill	512,8,0
 
 #undef PMDS
 
-	.data
+	.align PAGE_SIZE
+ENTRY(cpu_gdt_table)
+	.rept NR_CPUS
+	.quad	0x0000000000000000	/* NULL descriptor */
+	.quad	0x00cf9b000000ffff	/* __KERNEL32_CS */
+	.quad	0x00af9b000000ffff	/* __KERNEL_CS */
+	.quad	0x00cf93000000ffff	/* __KERNEL_DS */
+	.quad	0x00cffb000000ffff	/* __USER32_CS */
+	.quad	0x00cff3000000ffff	/* __USER_DS, __USER32_DS  */
+	.quad	0x00affb000000ffff	/* __USER_CS */
+
+#ifdef CONFIG_PAX_KERNEXEC
+	.quad	0x00af9b000000ffff	/* __KERNEXEC_KERNEL_CS */
+#else
+	.quad	0x0			/* unused */
+#endif
+
+	.quad	0,0			/* TSS */
+	.quad	0,0			/* LDT */
+	.quad	0,0,0			/* three TLS descriptors */
+	.quad	0x0000f40000000000	/* node/CPU stored in limit */
+	/* asm/segment.h:GDT_ENTRIES must match this */
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	.quad	0x00cf93000000ffff	/* __UDEREF_KERNEL_DS */
+#else
+	.quad	0x0			/* unused */
+#endif
+
+	/* zero the remaining page */
+	.fill PAGE_SIZE / 8 - GDT_ENTRIES,8,0
+	.endr
+
 	.align 16
 	.globl early_gdt_descr
 early_gdt_descr:
 	.word	GDT_ENTRIES*8-1
 early_gdt_descr_base:
-	.quad	INIT_PER_CPU_VAR(gdt_page)
+	.quad	cpu_gdt_table
 
 ENTRY(phys_base)
 	/* This must match the first entry in level2_kernel_pgt */
 	.quad   0x0000000000000000
 
 #include "../../x86/xen/xen-head.S"
-	
-	__PAGE_ALIGNED_BSS
+
+	.section .rodata,"a",@progbits
 NEXT_PAGE(empty_zero_page)
 	.skip PAGE_SIZE
 
diff --git a/arch/x86/kernel/hpet.c b/arch/x86/kernel/hpet.c
index c6dfd801d..5df5ed180 100644
--- a/arch/x86/kernel/hpet.c
+++ b/arch/x86/kernel/hpet.c
@@ -136,7 +136,7 @@ int is_hpet_enabled(void)
 }
 EXPORT_SYMBOL_GPL(is_hpet_enabled);
 
-static void _hpet_print_config(const char *function, int line)
+static void __nocapture(1) _hpet_print_config(const char *function, int line)
 {
 	u32 i, timers, l, h;
 	printk(KERN_INFO "hpet: %s(%d):\n", function, line);
diff --git a/arch/x86/kernel/i386_ksyms_32.c b/arch/x86/kernel/i386_ksyms_32.c
index 1f9b878ef..895e3ede3 100644
--- a/arch/x86/kernel/i386_ksyms_32.c
+++ b/arch/x86/kernel/i386_ksyms_32.c
@@ -21,8 +21,12 @@ extern void cmpxchg8b_emu(void);
 EXPORT_SYMBOL(cmpxchg8b_emu);
 #endif
 
+EXPORT_SYMBOL_GPL(cpu_gdt_table);
+
 /* Networking helper routines. */
 EXPORT_SYMBOL(csum_partial_copy_generic);
+EXPORT_SYMBOL(csum_partial_copy_generic_to_user);
+EXPORT_SYMBOL(csum_partial_copy_generic_from_user);
 
 EXPORT_SYMBOL(__get_user_1);
 EXPORT_SYMBOL(__get_user_2);
@@ -45,3 +49,11 @@ EXPORT_SYMBOL(___preempt_schedule_notrace);
 #endif
 
 EXPORT_SYMBOL(__sw_hweight32);
+
+#ifdef CONFIG_PAX_KERNEXEC
+EXPORT_SYMBOL(__LOAD_PHYSICAL_ADDR);
+#endif
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+EXPORT_SYMBOL(cpu_pgd);
+#endif
diff --git a/arch/x86/kernel/i8259.c b/arch/x86/kernel/i8259.c
index be22f5a21..a04fa1406 100644
--- a/arch/x86/kernel/i8259.c
+++ b/arch/x86/kernel/i8259.c
@@ -110,7 +110,7 @@ static int i8259A_irq_pending(unsigned int irq)
 static void make_8259A_irq(unsigned int irq)
 {
 	disable_irq_nosync(irq);
-	io_apic_irqs &= ~(1<<irq);
+	io_apic_irqs &= ~(1UL<<irq);
 	irq_set_chip_and_handler(irq, &i8259A_chip, handle_level_irq);
 	enable_irq(irq);
 }
@@ -208,7 +208,7 @@ spurious_8259A_irq:
 			       "spurious 8259A interrupt: IRQ%d.\n", irq);
 			spurious_irq_mask |= irqmask;
 		}
-		atomic_inc(&irq_err_count);
+		atomic_inc_unchecked(&irq_err_count);
 		/*
 		 * Theoretically we do not have to handle this IRQ,
 		 * but in Linux this does not cause problems and is
@@ -356,14 +356,16 @@ static void init_8259A(int auto_eoi)
 	/* (slave's support for AEOI in flat mode is to be investigated) */
 	outb_pic(SLAVE_ICW4_DEFAULT, PIC_SLAVE_IMR);
 
+	pax_open_kernel();
 	if (auto_eoi)
 		/*
 		 * In AEOI mode we just have to mask the interrupt
 		 * when acking.
 		 */
-		i8259A_chip.irq_mask_ack = disable_8259A_irq;
+		const_cast(i8259A_chip.irq_mask_ack) = disable_8259A_irq;
 	else
-		i8259A_chip.irq_mask_ack = mask_and_ack_8259A;
+		const_cast(i8259A_chip.irq_mask_ack) = mask_and_ack_8259A;
+	pax_close_kernel();
 
 	udelay(100);		/* wait for 8259A to initialize */
 
diff --git a/arch/x86/kernel/io_delay.c b/arch/x86/kernel/io_delay.c
index 50c89e8a9..e148d28a3 100644
--- a/arch/x86/kernel/io_delay.c
+++ b/arch/x86/kernel/io_delay.c
@@ -58,7 +58,7 @@ static int __init dmi_io_delay_0xed_port(const struct dmi_system_id *id)
  * Quirk table for systems that misbehave (lock up, etc.) if port
  * 0x80 is used:
  */
-static struct dmi_system_id __initdata io_delay_0xed_port_dmi_table[] = {
+static const struct dmi_system_id __initconst io_delay_0xed_port_dmi_table[] = {
 	{
 		.callback	= dmi_io_delay_0xed_port,
 		.ident		= "Compaq Presario V6000",
diff --git a/arch/x86/kernel/ioport.c b/arch/x86/kernel/ioport.c
index 589b3193f..41d657506 100644
--- a/arch/x86/kernel/ioport.c
+++ b/arch/x86/kernel/ioport.c
@@ -6,6 +6,7 @@
 #include <linux/sched.h>
 #include <linux/kernel.h>
 #include <linux/capability.h>
+#include <linux/security.h>
 #include <linux/errno.h>
 #include <linux/types.h>
 #include <linux/ioport.h>
@@ -30,6 +31,12 @@ asmlinkage long sys_ioperm(unsigned long from, unsigned long num, int turn_on)
 		return -EINVAL;
 	if (turn_on && !capable(CAP_SYS_RAWIO))
 		return -EPERM;
+#ifdef CONFIG_GRKERNSEC_IO
+	if (turn_on && grsec_disable_privio) {
+		gr_handle_ioperm();
+		return -ENODEV;
+	}
+#endif
 
 	/*
 	 * If it's the first ioperm() call in this thread's lifetime, set the
@@ -54,7 +61,7 @@ asmlinkage long sys_ioperm(unsigned long from, unsigned long num, int turn_on)
 	 * because the ->io_bitmap_max value must match the bitmap
 	 * contents:
 	 */
-	tss = &per_cpu(cpu_tss, get_cpu());
+	tss = cpu_tss + get_cpu();
 
 	if (turn_on)
 		bitmap_clear(t->io_bitmap_ptr, from, num);
@@ -110,6 +117,12 @@ SYSCALL_DEFINE1(iopl, unsigned int, level)
 	if (level > old) {
 		if (!capable(CAP_SYS_RAWIO))
 			return -EPERM;
+#ifdef CONFIG_GRKERNSEC_IO
+		if (grsec_disable_privio) {
+			gr_handle_iopl();
+			return -ENODEV;
+		}
+#endif
 	}
 	regs->flags = (regs->flags & ~X86_EFLAGS_IOPL) |
 		(level << X86_EFLAGS_IOPL_BIT);
diff --git a/arch/x86/kernel/irq.c b/arch/x86/kernel/irq.c
index 9f669fdd2..00354af57 100644
--- a/arch/x86/kernel/irq.c
+++ b/arch/x86/kernel/irq.c
@@ -28,7 +28,7 @@ EXPORT_PER_CPU_SYMBOL(irq_stat);
 DEFINE_PER_CPU(struct pt_regs *, irq_regs);
 EXPORT_PER_CPU_SYMBOL(irq_regs);
 
-atomic_t irq_err_count;
+atomic_unchecked_t irq_err_count;
 
 /* Function pointer for generic interrupt vector handling */
 void (*x86_platform_ipi_callback)(void) = NULL;
@@ -146,9 +146,9 @@ int arch_show_interrupts(struct seq_file *p, int prec)
 		seq_puts(p, "  Hypervisor callback interrupts\n");
 	}
 #endif
-	seq_printf(p, "%*s: %10u\n", prec, "ERR", atomic_read(&irq_err_count));
+	seq_printf(p, "%*s: %10u\n", prec, "ERR", atomic_read_unchecked(&irq_err_count));
 #if defined(CONFIG_X86_IO_APIC)
-	seq_printf(p, "%*s: %10u\n", prec, "MIS", atomic_read(&irq_mis_count));
+	seq_printf(p, "%*s: %10u\n", prec, "MIS", atomic_read_unchecked(&irq_mis_count));
 #endif
 #ifdef CONFIG_HAVE_KVM
 	seq_printf(p, "%*s: ", prec, "PIN");
@@ -200,7 +200,7 @@ u64 arch_irq_stat_cpu(unsigned int cpu)
 
 u64 arch_irq_stat(void)
 {
-	u64 sum = atomic_read(&irq_err_count);
+	u64 sum = atomic_read_unchecked(&irq_err_count);
 	return sum;
 }
 
diff --git a/arch/x86/kernel/irq_32.c b/arch/x86/kernel/irq_32.c
index 1f38d9a4d..0eb6e6fc2 100644
--- a/arch/x86/kernel/irq_32.c
+++ b/arch/x86/kernel/irq_32.c
@@ -22,6 +22,8 @@
 
 #ifdef CONFIG_DEBUG_STACKOVERFLOW
 
+extern void gr_handle_kernel_exploit(void);
+
 int sysctl_panic_on_stackoverflow __read_mostly;
 
 /* Debugging check for stack overflow: is there less than 1KB free? */
@@ -32,13 +34,14 @@ static int check_stack_overflow(void)
 	__asm__ __volatile__("andl %%esp,%0" :
 			     "=r" (sp) : "0" (THREAD_SIZE - 1));
 
-	return sp < (sizeof(struct thread_info) + STACK_WARN);
+	return sp < STACK_WARN;
 }
 
 static void print_stack_overflow(void)
 {
 	printk(KERN_WARNING "low stack detected by irq handler\n");
 	dump_stack();
+	gr_handle_kernel_exploit();
 	if (sysctl_panic_on_stackoverflow)
 		panic("low stack detected by irq handler - check messages\n");
 }
@@ -69,10 +72,9 @@ static inline void *current_stack(void)
 
 static inline int execute_on_irq_stack(int overflow, struct irq_desc *desc)
 {
-	struct irq_stack *curstk, *irqstk;
+	struct irq_stack *irqstk;
 	u32 *isp, *prev_esp, arg1;
 
-	curstk = (struct irq_stack *) current_stack();
 	irqstk = __this_cpu_read(hardirq_stack);
 
 	/*
@@ -81,15 +83,19 @@ static inline int execute_on_irq_stack(int overflow, struct irq_desc *desc)
 	 * handler) we can't do that and just have to keep using the
 	 * current stack (which is the irq stack already after all)
 	 */
-	if (unlikely(curstk == irqstk))
+	if (unlikely((void *)current_stack_pointer - (void *)irqstk < THREAD_SIZE))
 		return 0;
 
-	isp = (u32 *) ((char *)irqstk + sizeof(*irqstk));
+	isp = (u32 *) ((char *)irqstk + sizeof(*irqstk) - 8);
 
 	/* Save the next esp at the bottom of the stack */
 	prev_esp = (u32 *)irqstk;
 	*prev_esp = current_stack_pointer();
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	__set_fs(MAKE_MM_SEG(0));
+#endif
+
 	if (unlikely(overflow))
 		call_on_stack(print_stack_overflow, isp);
 
@@ -100,6 +106,11 @@ static inline int execute_on_irq_stack(int overflow, struct irq_desc *desc)
 		     :  "0" (desc),   "1" (isp),
 			"D" (desc->handle_irq)
 		     : "memory", "cc", "ecx");
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	__set_fs(current_thread_info()->addr_limit);
+#endif
+
 	return 1;
 }
 
@@ -108,23 +119,11 @@ static inline int execute_on_irq_stack(int overflow, struct irq_desc *desc)
  */
 void irq_ctx_init(int cpu)
 {
-	struct irq_stack *irqstk;
-
 	if (per_cpu(hardirq_stack, cpu))
 		return;
 
-	irqstk = page_address(alloc_pages_node(cpu_to_node(cpu),
-					       THREADINFO_GFP,
-					       THREAD_SIZE_ORDER));
-	per_cpu(hardirq_stack, cpu) = irqstk;
-
-	irqstk = page_address(alloc_pages_node(cpu_to_node(cpu),
-					       THREADINFO_GFP,
-					       THREAD_SIZE_ORDER));
-	per_cpu(softirq_stack, cpu) = irqstk;
-
-	printk(KERN_DEBUG "CPU %u irqstacks, hard=%p soft=%p\n",
-	       cpu, per_cpu(hardirq_stack, cpu),  per_cpu(softirq_stack, cpu));
+	per_cpu(hardirq_stack, cpu) = page_address(alloc_pages_node(cpu_to_node(cpu), THREADINFO_GFP, THREAD_SIZE_ORDER));
+	per_cpu(softirq_stack, cpu) = page_address(alloc_pages_node(cpu_to_node(cpu), THREADINFO_GFP, THREAD_SIZE_ORDER));
 }
 
 void do_softirq_own_stack(void)
@@ -141,7 +140,16 @@ void do_softirq_own_stack(void)
 	prev_esp = (u32 *)irqstk;
 	*prev_esp = current_stack_pointer();
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	__set_fs(MAKE_MM_SEG(0));
+#endif
+
 	call_on_stack(__do_softirq, isp);
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	__set_fs(current_thread_info()->addr_limit);
+#endif
+
 }
 
 bool handle_irq(struct irq_desc *desc, struct pt_regs *regs)
diff --git a/arch/x86/kernel/irq_64.c b/arch/x86/kernel/irq_64.c
index 4a7903714..0c1319eb4 100644
--- a/arch/x86/kernel/irq_64.c
+++ b/arch/x86/kernel/irq_64.c
@@ -19,6 +19,8 @@
 #include <asm/idle.h>
 #include <asm/apic.h>
 
+extern void gr_handle_kernel_exploit(void);
+
 int sysctl_panic_on_stackoverflow;
 
 /*
@@ -45,9 +47,8 @@ static inline void stack_overflow_check(struct pt_regs *regs)
 	    regs->sp <= curbase + THREAD_SIZE)
 		return;
 
-	irq_stack_top = (u64)this_cpu_ptr(irq_stack_union.irq_stack) +
-			STACK_TOP_MARGIN;
 	irq_stack_bottom = (u64)__this_cpu_read(irq_stack_ptr);
+	irq_stack_top = irq_stack_bottom - IRQ_STACK_SIZE + 64 + STACK_TOP_MARGIN;
 	if (regs->sp >= irq_stack_top && regs->sp <= irq_stack_bottom)
 		return;
 
@@ -62,6 +63,8 @@ static inline void stack_overflow_check(struct pt_regs *regs)
 		irq_stack_top, irq_stack_bottom,
 		estack_top, estack_bottom);
 
+	gr_handle_kernel_exploit();
+
 	if (sysctl_panic_on_stackoverflow)
 		panic("low stack detected by irq handler - check messages\n");
 #endif
diff --git a/arch/x86/kernel/jump_label.c b/arch/x86/kernel/jump_label.c
index fc25f698d..d31d60cc3 100644
--- a/arch/x86/kernel/jump_label.c
+++ b/arch/x86/kernel/jump_label.c
@@ -32,6 +32,8 @@ static void bug_at(unsigned char *ip, int line)
 	 * Something went wrong. Crash the box, as something could be
 	 * corrupting the kernel.
 	 */
+	ip = (unsigned char *)ktla_ktva((unsigned long)ip);
+	pr_warning("Unexpected op at %pS [%p] %s:%d\n", ip, ip, __FILE__, line);
 	pr_warning("Unexpected op at %pS [%p] (%02x %02x %02x %02x %02x) %s:%d\n",
 	       ip, ip, ip[0], ip[1], ip[2], ip[3], ip[4], __FILE__, line);
 	BUG();
@@ -52,7 +54,7 @@ static void __jump_label_transform(struct jump_entry *entry,
 			 * Jump label is enabled for the first time.
 			 * So we expect a default_nop...
 			 */
-			if (unlikely(memcmp((void *)entry->code, default_nop, 5)
+			if (unlikely(memcmp((void *)ktla_ktva(entry->code), default_nop, 5)
 				     != 0))
 				bug_at((void *)entry->code, __LINE__);
 		} else {
@@ -60,7 +62,7 @@ static void __jump_label_transform(struct jump_entry *entry,
 			 * ...otherwise expect an ideal_nop. Otherwise
 			 * something went horribly wrong.
 			 */
-			if (unlikely(memcmp((void *)entry->code, ideal_nop, 5)
+			if (unlikely(memcmp((void *)ktla_ktva(entry->code), ideal_nop, 5)
 				     != 0))
 				bug_at((void *)entry->code, __LINE__);
 		}
@@ -76,13 +78,13 @@ static void __jump_label_transform(struct jump_entry *entry,
 		 * are converting the default nop to the ideal nop.
 		 */
 		if (init) {
-			if (unlikely(memcmp((void *)entry->code, default_nop, 5) != 0))
+			if (unlikely(memcmp((void *)ktla_ktva(entry->code), default_nop, 5) != 0))
 				bug_at((void *)entry->code, __LINE__);
 		} else {
 			code.jump = 0xe9;
 			code.offset = entry->target -
 				(entry->code + JUMP_LABEL_NOP_SIZE);
-			if (unlikely(memcmp((void *)entry->code, &code, 5) != 0))
+			if (unlikely(memcmp((void *)ktla_ktva(entry->code), &code, 5) != 0))
 				bug_at((void *)entry->code, __LINE__);
 		}
 		memcpy(&code, ideal_nops[NOP_ATOMIC5], JUMP_LABEL_NOP_SIZE);
diff --git a/arch/x86/kernel/kgdb.c b/arch/x86/kernel/kgdb.c
index 04cde527d..8b2900bb0 100644
--- a/arch/x86/kernel/kgdb.c
+++ b/arch/x86/kernel/kgdb.c
@@ -229,7 +229,10 @@ static void kgdb_correct_hw_break(void)
 		bp->attr.bp_addr = breakinfo[breakno].addr;
 		bp->attr.bp_len = breakinfo[breakno].len;
 		bp->attr.bp_type = breakinfo[breakno].type;
-		info->address = breakinfo[breakno].addr;
+		if (breakinfo[breakno].type == X86_BREAKPOINT_EXECUTE)
+			info->address = ktla_ktva(breakinfo[breakno].addr);
+		else
+			info->address = breakinfo[breakno].addr;
 		info->len = breakinfo[breakno].len;
 		info->type = breakinfo[breakno].type;
 		val = arch_install_hw_breakpoint(bp);
@@ -476,12 +479,12 @@ int kgdb_arch_handle_exception(int e_vector, int signo, int err_code,
 	case 'k':
 		/* clear the trace bit */
 		linux_regs->flags &= ~X86_EFLAGS_TF;
-		atomic_set(&kgdb_cpu_doing_single_step, -1);
+		atomic_set_unchecked(&kgdb_cpu_doing_single_step, -1);
 
 		/* set the trace bit if we're stepping */
 		if (remcomInBuffer[0] == 's') {
 			linux_regs->flags |= X86_EFLAGS_TF;
-			atomic_set(&kgdb_cpu_doing_single_step,
+			atomic_set_unchecked(&kgdb_cpu_doing_single_step,
 				   raw_smp_processor_id());
 		}
 
@@ -551,7 +554,7 @@ static int __kgdb_notify(struct die_args *args, unsigned long cmd)
 
 	switch (cmd) {
 	case DIE_DEBUG:
-		if (atomic_read(&kgdb_cpu_doing_single_step) != -1) {
+		if (atomic_read_unchecked(&kgdb_cpu_doing_single_step) != -1) {
 			if (user_mode(regs))
 				return single_step_cont(regs, args);
 			break;
@@ -754,11 +757,11 @@ int kgdb_arch_set_breakpoint(struct kgdb_bkpt *bpt)
 	char opc[BREAK_INSTR_SIZE];
 
 	bpt->type = BP_BREAKPOINT;
-	err = probe_kernel_read(bpt->saved_instr, (char *)bpt->bpt_addr,
+	err = probe_kernel_read(bpt->saved_instr, (const void *)ktla_ktva(bpt->bpt_addr),
 				BREAK_INSTR_SIZE);
 	if (err)
 		return err;
-	err = probe_kernel_write((char *)bpt->bpt_addr,
+	err = probe_kernel_write((void *)ktla_ktva(bpt->bpt_addr),
 				 arch_kgdb_ops.gdb_bpt_instr, BREAK_INSTR_SIZE);
 	if (!err)
 		return err;
@@ -770,7 +773,7 @@ int kgdb_arch_set_breakpoint(struct kgdb_bkpt *bpt)
 		return -EBUSY;
 	text_poke((void *)bpt->bpt_addr, arch_kgdb_ops.gdb_bpt_instr,
 		  BREAK_INSTR_SIZE);
-	err = probe_kernel_read(opc, (char *)bpt->bpt_addr, BREAK_INSTR_SIZE);
+	err = probe_kernel_read(opc, (const void *)ktla_ktva(bpt->bpt_addr), BREAK_INSTR_SIZE);
 	if (err)
 		return err;
 	if (memcmp(opc, arch_kgdb_ops.gdb_bpt_instr, BREAK_INSTR_SIZE))
@@ -794,13 +797,13 @@ int kgdb_arch_remove_breakpoint(struct kgdb_bkpt *bpt)
 	if (mutex_is_locked(&text_mutex))
 		goto knl_write;
 	text_poke((void *)bpt->bpt_addr, bpt->saved_instr, BREAK_INSTR_SIZE);
-	err = probe_kernel_read(opc, (char *)bpt->bpt_addr, BREAK_INSTR_SIZE);
+	err = probe_kernel_read(opc, (const void *)ktla_ktva(bpt->bpt_addr), BREAK_INSTR_SIZE);
 	if (err || memcmp(opc, bpt->saved_instr, BREAK_INSTR_SIZE))
 		goto knl_write;
 	return err;
 
 knl_write:
-	return probe_kernel_write((char *)bpt->bpt_addr,
+	return probe_kernel_write((void *)ktla_ktva(bpt->bpt_addr),
 				  (char *)bpt->saved_instr, BREAK_INSTR_SIZE);
 }
 
diff --git a/arch/x86/kernel/kprobes/core.c b/arch/x86/kernel/kprobes/core.c
index 7847e5c0e..cec50fdef 100644
--- a/arch/x86/kernel/kprobes/core.c
+++ b/arch/x86/kernel/kprobes/core.c
@@ -122,9 +122,12 @@ __synthesize_relative_insn(void *from, void *to, u8 op)
 		s32 raddr;
 	} __packed *insn;
 
-	insn = (struct __arch_relative_insn *)from;
+	insn = (struct __arch_relative_insn *)ktla_ktva((unsigned long)from);
+
+	pax_open_kernel();
 	insn->raddr = (s32)((long)(to) - ((long)(from) + 5));
 	insn->op = op;
+	pax_close_kernel();
 }
 
 /* Insert a jump instruction at address 'from', which jumps to address 'to'.*/
@@ -170,7 +173,7 @@ int can_boost(kprobe_opcode_t *opcodes)
 	kprobe_opcode_t opcode;
 	kprobe_opcode_t *orig_opcodes = opcodes;
 
-	if (search_exception_tables((unsigned long)opcodes))
+	if (search_exception_tables(ktva_ktla((unsigned long)opcodes)))
 		return 0;	/* Page fault may occur on this address. */
 
 retry:
@@ -262,12 +265,12 @@ __recover_probed_insn(kprobe_opcode_t *buf, unsigned long addr)
 	 * Fortunately, we know that the original code is the ideal 5-byte
 	 * long NOP.
 	 */
-	memcpy(buf, (void *)addr, MAX_INSN_SIZE * sizeof(kprobe_opcode_t));
+	memcpy(buf, (void *)ktla_ktva(addr), MAX_INSN_SIZE * sizeof(kprobe_opcode_t));
 	if (faddr)
 		memcpy(buf, ideal_nops[NOP_ATOMIC5], 5);
 	else
 		buf[0] = kp->opcode;
-	return (unsigned long)buf;
+	return ktva_ktla((unsigned long)buf);
 }
 
 /*
@@ -369,7 +372,9 @@ int __copy_instruction(u8 *dest, u8 *src)
 	/* Another subsystem puts a breakpoint, failed to recover */
 	if (insn.opcode.bytes[0] == BREAKPOINT_INSTRUCTION)
 		return 0;
+	pax_open_kernel();
 	memcpy(dest, insn.kaddr, length);
+	pax_close_kernel();
 
 #ifdef CONFIG_X86_64
 	if (insn_rip_relative(&insn)) {
@@ -396,7 +401,9 @@ int __copy_instruction(u8 *dest, u8 *src)
 			return 0;
 		}
 		disp = (u8 *) dest + insn_offset_displacement(&insn);
+		pax_open_kernel();
 		*(s32 *) disp = (s32) newdisp;
+		pax_close_kernel();
 	}
 #endif
 	return length;
@@ -538,7 +545,7 @@ static void setup_singlestep(struct kprobe *p, struct pt_regs *regs,
 		 * nor set current_kprobe, because it doesn't use single
 		 * stepping.
 		 */
-		regs->ip = (unsigned long)p->ainsn.insn;
+		regs->ip = ktva_ktla((unsigned long)p->ainsn.insn);
 		preempt_enable_no_resched();
 		return;
 	}
@@ -555,9 +562,9 @@ static void setup_singlestep(struct kprobe *p, struct pt_regs *regs,
 	regs->flags &= ~X86_EFLAGS_IF;
 	/* single step inline if the instruction is an int3 */
 	if (p->opcode == BREAKPOINT_INSTRUCTION)
-		regs->ip = (unsigned long)p->addr;
+		regs->ip = ktla_ktva((unsigned long)p->addr);
 	else
-		regs->ip = (unsigned long)p->ainsn.insn;
+		regs->ip = ktva_ktla((unsigned long)p->ainsn.insn);
 }
 NOKPROBE_SYMBOL(setup_singlestep);
 
@@ -642,7 +649,7 @@ int kprobe_int3_handler(struct pt_regs *regs)
 				setup_singlestep(p, regs, kcb, 0);
 			return 1;
 		}
-	} else if (*addr != BREAKPOINT_INSTRUCTION) {
+	} else if (*(kprobe_opcode_t *)ktla_ktva((unsigned long)addr) != BREAKPOINT_INSTRUCTION) {
 		/*
 		 * The breakpoint instruction was removed right
 		 * after we hit it.  Another cpu has removed
@@ -688,6 +695,9 @@ asm(
 	"	movq %rax, 152(%rsp)\n"
 	RESTORE_REGS_STRING
 	"	popfq\n"
+#ifdef KERNEXEC_PLUGIN
+	"	btsq $63,(%rsp)\n"
+#endif
 #else
 	"	pushf\n"
 	SAVE_REGS_STRING
@@ -829,7 +839,7 @@ static void resume_execution(struct kprobe *p, struct pt_regs *regs,
 			     struct kprobe_ctlblk *kcb)
 {
 	unsigned long *tos = stack_addr(regs);
-	unsigned long copy_ip = (unsigned long)p->ainsn.insn;
+	unsigned long copy_ip = ktva_ktla((unsigned long)p->ainsn.insn);
 	unsigned long orig_ip = (unsigned long)p->addr;
 	kprobe_opcode_t *insn = p->ainsn.insn;
 
diff --git a/arch/x86/kernel/kprobes/opt.c b/arch/x86/kernel/kprobes/opt.c
index 4425f593f..34a112f4a 100644
--- a/arch/x86/kernel/kprobes/opt.c
+++ b/arch/x86/kernel/kprobes/opt.c
@@ -80,6 +80,7 @@ found:
 /* Insert a move instruction which sets a pointer to eax/rdi (1st arg). */
 static void synthesize_set_arg1(kprobe_opcode_t *addr, unsigned long val)
 {
+	pax_open_kernel();
 #ifdef CONFIG_X86_64
 	*addr++ = 0x48;
 	*addr++ = 0xbf;
@@ -87,6 +88,7 @@ static void synthesize_set_arg1(kprobe_opcode_t *addr, unsigned long val)
 	*addr++ = 0xb8;
 #endif
 	*(unsigned long *)addr = val;
+	pax_close_kernel();
 }
 
 asm (
@@ -343,7 +345,7 @@ int arch_prepare_optimized_kprobe(struct optimized_kprobe *op,
 	 * Verify if the address gap is in 2GB range, because this uses
 	 * a relative jump.
 	 */
-	rel = (long)op->optinsn.insn - (long)op->kp.addr + RELATIVEJUMP_SIZE;
+	rel = (long)op->optinsn.insn - ktla_ktva((long)op->kp.addr) + RELATIVEJUMP_SIZE;
 	if (abs(rel) > 0x7fffffff) {
 		__arch_remove_optimized_kprobe(op, 0);
 		return -ERANGE;
@@ -360,16 +362,18 @@ int arch_prepare_optimized_kprobe(struct optimized_kprobe *op,
 	op->optinsn.size = ret;
 
 	/* Copy arch-dep-instance from template */
-	memcpy(buf, &optprobe_template_entry, TMPL_END_IDX);
+	pax_open_kernel();
+	memcpy(buf, (u8 *)ktla_ktva((unsigned long)&optprobe_template_entry), TMPL_END_IDX);
+	pax_close_kernel();
 
 	/* Set probe information */
 	synthesize_set_arg1(buf + TMPL_MOVE_IDX, (unsigned long)op);
 
 	/* Set probe function call */
-	synthesize_relcall(buf + TMPL_CALL_IDX, optimized_callback);
+	synthesize_relcall((u8 *)ktva_ktla((unsigned long)buf) + TMPL_CALL_IDX, optimized_callback);
 
 	/* Set returning jmp instruction at the tail of out-of-line buffer */
-	synthesize_reljump(buf + TMPL_END_IDX + op->optinsn.size,
+	synthesize_reljump((u8 *)ktva_ktla((unsigned long)buf) + TMPL_END_IDX + op->optinsn.size,
 			   (u8 *)op->kp.addr + op->optinsn.size);
 
 	flush_icache_range((unsigned long) buf,
@@ -394,7 +398,7 @@ void arch_optimize_kprobes(struct list_head *oplist)
 		WARN_ON(kprobe_disabled(&op->kp));
 
 		/* Backup instructions which will be replaced by jump address */
-		memcpy(op->optinsn.copied_insn, op->kp.addr + INT3_SIZE,
+		memcpy(op->optinsn.copied_insn, (u8 *)ktla_ktva((unsigned long)op->kp.addr) + INT3_SIZE,
 		       RELATIVE_ADDR_SIZE);
 
 		insn_buf[0] = RELATIVEJUMP_OPCODE;
@@ -442,7 +446,7 @@ int setup_detour_execution(struct kprobe *p, struct pt_regs *regs, int reenter)
 		/* This kprobe is really able to run optimized path. */
 		op = container_of(p, struct optimized_kprobe, kp);
 		/* Detour through copied instructions */
-		regs->ip = (unsigned long)op->optinsn.insn + TMPL_END_IDX;
+		regs->ip = ktva_ktla((unsigned long)op->optinsn.insn) + TMPL_END_IDX;
 		if (!reenter)
 			reset_current_kprobe();
 		preempt_enable_no_resched();
diff --git a/arch/x86/kernel/ksysfs.c b/arch/x86/kernel/ksysfs.c
index c2bedaea1..25e7ab60f 100644
--- a/arch/x86/kernel/ksysfs.c
+++ b/arch/x86/kernel/ksysfs.c
@@ -184,7 +184,7 @@ out:
 
 static struct kobj_attribute type_attr = __ATTR_RO(type);
 
-static struct bin_attribute data_attr = {
+static bin_attribute_no_const data_attr __read_only = {
 	.attr = {
 		.name = "data",
 		.mode = S_IRUGO,
diff --git a/arch/x86/kernel/kvm.c b/arch/x86/kernel/kvm.c
index 1726c4c12..feda8055f 100644
--- a/arch/x86/kernel/kvm.c
+++ b/arch/x86/kernel/kvm.c
@@ -544,7 +544,7 @@ static uint32_t __init kvm_detect(void)
 	return kvm_cpuid_base();
 }
 
-const struct hypervisor_x86 x86_hyper_kvm __refconst = {
+const struct hypervisor_x86 x86_hyper_kvm = {
 	.name			= "KVM",
 	.detect			= kvm_detect,
 	.x2apic_available	= kvm_para_available,
diff --git a/arch/x86/kernel/kvmclock.c b/arch/x86/kernel/kvmclock.c
index 3692249a7..d2966c7ee 100644
--- a/arch/x86/kernel/kvmclock.c
+++ b/arch/x86/kernel/kvmclock.c
@@ -29,7 +29,7 @@
 #include <asm/x86_init.h>
 #include <asm/reboot.h>
 
-static int kvmclock = 1;
+static int kvmclock __read_only = 1;
 static int msr_kvm_system_time = MSR_KVM_SYSTEM_TIME;
 static int msr_kvm_wall_clock = MSR_KVM_WALL_CLOCK;
 static cycle_t kvm_sched_clock_offset;
@@ -42,7 +42,7 @@ static int parse_no_kvmclock(char *arg)
 early_param("no-kvmclock", parse_no_kvmclock);
 
 /* The hypervisor will put information about time periodically here */
-static struct pvclock_vsyscall_time_info *hv_clock;
+static struct pvclock_vsyscall_time_info hv_clock[NR_CPUS] __page_aligned_bss;
 static struct pvclock_wall_clock wall_clock;
 
 struct pvclock_vsyscall_time_info *pvclock_pvti_cpu0_va(void)
@@ -161,7 +161,7 @@ bool kvm_check_and_clear_guest_paused(void)
 	struct pvclock_vcpu_time_info *src;
 	int cpu = smp_processor_id();
 
-	if (!hv_clock)
+	if (!kvmclock)
 		return ret;
 
 	src = &hv_clock[cpu].pvti;
@@ -188,7 +188,7 @@ int kvm_register_clock(char *txt)
 	int low, high, ret;
 	struct pvclock_vcpu_time_info *src;
 
-	if (!hv_clock)
+	if (!kvmclock)
 		return 0;
 
 	src = &hv_clock[cpu].pvti;
@@ -248,7 +248,6 @@ static void kvm_shutdown(void)
 void __init kvmclock_init(void)
 {
 	struct pvclock_vcpu_time_info *vcpu_time;
-	unsigned long mem;
 	int size, cpu;
 	u8 flags;
 
@@ -266,15 +265,8 @@ void __init kvmclock_init(void)
 	printk(KERN_INFO "kvm-clock: Using msrs %x and %x",
 		msr_kvm_system_time, msr_kvm_wall_clock);
 
-	mem = memblock_alloc(size, PAGE_SIZE);
-	if (!mem)
-		return;
-	hv_clock = __va(mem);
-	memset(hv_clock, 0, size);
-
 	if (kvm_register_clock("primary cpu clock")) {
-		hv_clock = NULL;
-		memblock_free(mem, size);
+		kvmclock = 0;
 		return;
 	}
 
@@ -315,7 +307,7 @@ int __init kvm_setup_vsyscall_timeinfo(void)
 	struct pvclock_vcpu_time_info *vcpu_time;
 	unsigned int size;
 
-	if (!hv_clock)
+	if (!kvmclock)
 		return 0;
 
 	size = PAGE_ALIGN(sizeof(struct pvclock_vsyscall_time_info)*NR_CPUS);
diff --git a/arch/x86/kernel/ldt.c b/arch/x86/kernel/ldt.c
index 6707039b9..254f32c7a 100644
--- a/arch/x86/kernel/ldt.c
+++ b/arch/x86/kernel/ldt.c
@@ -11,6 +11,7 @@
 #include <linux/sched.h>
 #include <linux/string.h>
 #include <linux/mm.h>
+#include <linux/ratelimit.h>
 #include <linux/smp.h>
 #include <linux/slab.h>
 #include <linux/vmalloc.h>
@@ -21,6 +22,14 @@
 #include <asm/mmu_context.h>
 #include <asm/syscalls.h>
 
+#ifdef CONFIG_GRKERNSEC
+int sysctl_modify_ldt __read_only = 0;
+#elif defined(CONFIG_DEFAULT_MODIFY_LDT_SYSCALL)
+int sysctl_modify_ldt __read_only = 1;
+#else
+int sysctl_modify_ldt __read_only = 0;
+#endif
+
 /* context.lock is held for us, so we don't need any locking. */
 static void flush_ldt(void *current_mm)
 {
@@ -109,6 +118,23 @@ int init_new_context_ldt(struct task_struct *tsk, struct mm_struct *mm)
 	struct mm_struct *old_mm;
 	int retval = 0;
 
+	if (tsk == current) {
+		mm->context.vdso = 0;
+
+#ifdef CONFIG_X86_32
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+		mm->context.user_cs_base = 0UL;
+		mm->context.user_cs_limit = ~0UL;
+
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_SMP)
+		cpumask_clear(&mm->context.cpu_user_cs_mask);
+#endif
+
+#endif
+#endif
+
+	}
+
 	mutex_init(&mm->context.lock);
 	old_mm = current->mm;
 	if (!old_mm) {
@@ -235,6 +261,14 @@ static int write_ldt(void __user *ptr, unsigned long bytecount, int oldmode)
 		/* The user wants to clear the entry. */
 		memset(&ldt, 0, sizeof(ldt));
 	} else {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		if ((mm->pax_flags & MF_PAX_SEGMEXEC) && (ldt_info.contents & MODIFY_LDT_CONTENTS_CODE)) {
+			error = -EINVAL;
+			goto out;
+		}
+#endif
+
 		if (!IS_ENABLED(CONFIG_X86_16BIT) && !ldt_info.seg_32bit) {
 			error = -EINVAL;
 			goto out;
@@ -276,6 +310,15 @@ asmlinkage int sys_modify_ldt(int func, void __user *ptr,
 {
 	int ret = -ENOSYS;
 
+	if (!sysctl_modify_ldt) {
+		printk_ratelimited(KERN_INFO
+			"Denied a call to modify_ldt() from %s[%d] (uid: %d)."
+			" Adjust sysctl if this was not an exploit attempt.\n",
+			current->comm, task_pid_nr(current),
+			from_kuid_munged(current_user_ns(), current_uid()));
+		return ret;
+	}
+
 	switch (func) {
 	case 0:
 		ret = read_ldt(ptr, bytecount);
diff --git a/arch/x86/kernel/machine_kexec_32.c b/arch/x86/kernel/machine_kexec_32.c
index 469b23d6a..5449cfed1 100644
--- a/arch/x86/kernel/machine_kexec_32.c
+++ b/arch/x86/kernel/machine_kexec_32.c
@@ -26,7 +26,7 @@
 #include <asm/cacheflush.h>
 #include <asm/debugreg.h>
 
-static void set_idt(void *newidt, __u16 limit)
+static void set_idt(struct desc_struct *newidt, __u16 limit)
 {
 	struct desc_ptr curidt;
 
@@ -38,7 +38,7 @@ static void set_idt(void *newidt, __u16 limit)
 }
 
 
-static void set_gdt(void *newgdt, __u16 limit)
+static void set_gdt(struct desc_struct *newgdt, __u16 limit)
 {
 	struct desc_ptr curgdt;
 
@@ -216,7 +216,7 @@ void machine_kexec(struct kimage *image)
 	}
 
 	control_page = page_address(image->control_code_page);
-	memcpy(control_page, relocate_kernel, KEXEC_CONTROL_CODE_MAX_SIZE);
+	memcpy(control_page, (void *)ktla_ktva((unsigned long)relocate_kernel), KEXEC_CONTROL_CODE_MAX_SIZE);
 
 	relocate_kernel_ptr = control_page;
 	page_list[PA_CONTROL_PAGE] = __pa(control_page);
diff --git a/arch/x86/kernel/mcount_64.S b/arch/x86/kernel/mcount_64.S
index 61924222a..0e4856e8a 100644
--- a/arch/x86/kernel/mcount_64.S
+++ b/arch/x86/kernel/mcount_64.S
@@ -7,7 +7,7 @@
 #include <linux/linkage.h>
 #include <asm/ptrace.h>
 #include <asm/ftrace.h>
-
+#include <asm/alternative-asm.h>
 
 	.code64
 	.section .entry.text, "ax"
@@ -148,8 +148,9 @@
 #ifdef CONFIG_DYNAMIC_FTRACE
 
 ENTRY(function_hook)
+	pax_force_retaddr
 	retq
-END(function_hook)
+ENDPROC(function_hook)
 
 ENTRY(ftrace_caller)
 	/* save_mcount_regs fills in first two parameters */
@@ -183,9 +184,10 @@ GLOBAL(ftrace_graph_call)
 #endif
 
 /* This is weak to keep gas from relaxing the jumps */
-WEAK(ftrace_stub)
+RAP_WEAK(ftrace_stub)
+	pax_force_retaddr
 	retq
-END(ftrace_caller)
+ENDPROC(ftrace_caller)
 
 ENTRY(ftrace_regs_caller)
 	/* Save the current flags before any operations that can change them */
@@ -256,7 +258,7 @@ GLOBAL(ftrace_regs_caller_end)
 
 	jmp ftrace_epilogue
 
-END(ftrace_regs_caller)
+ENDPROC(ftrace_regs_caller)
 
 
 #else /* ! CONFIG_DYNAMIC_FTRACE */
@@ -275,6 +277,7 @@ fgraph_trace:
 #endif
 
 GLOBAL(ftrace_stub)
+	pax_force_retaddr
 	retq
 
 trace:
@@ -287,12 +290,13 @@ trace:
 	 * ip and parent ip are used and the list function is called when
 	 * function tracing is enabled.
 	 */
+	pax_force_fptr ftrace_trace_function
 	call   *ftrace_trace_function
 
 	restore_mcount_regs
 
 	jmp fgraph_trace
-END(function_hook)
+ENDPROC(function_hook)
 #endif /* CONFIG_DYNAMIC_FTRACE */
 #endif /* CONFIG_FUNCTION_TRACER */
 
@@ -314,8 +318,9 @@ ENTRY(ftrace_graph_caller)
 
 	restore_mcount_regs
 
+	pax_force_retaddr
 	retq
-END(ftrace_graph_caller)
+ENDPROC(ftrace_graph_caller)
 
 GLOBAL(return_to_handler)
 	subq  $24, %rsp
@@ -331,5 +336,7 @@ GLOBAL(return_to_handler)
 	movq 8(%rsp), %rdx
 	movq (%rsp), %rax
 	addq $24, %rsp
+	pax_force_fptr %rdi
 	jmp *%rdi
+ENDPROC(return_to_handler)
 #endif
diff --git a/arch/x86/kernel/module.c b/arch/x86/kernel/module.c
index 477ae806c..a280c6743 100644
--- a/arch/x86/kernel/module.c
+++ b/arch/x86/kernel/module.c
@@ -76,17 +76,17 @@ static unsigned long int get_module_load_offset(void)
 }
 #endif
 
-void *module_alloc(unsigned long size)
+static inline void *__module_alloc(unsigned long size, pgprot_t prot)
 {
 	void *p;
 
-	if (PAGE_ALIGN(size) > MODULES_LEN)
+	if (!size || PAGE_ALIGN(size) > MODULES_LEN)
 		return NULL;
 
 	p = __vmalloc_node_range(size, MODULE_ALIGN,
 				    MODULES_VADDR + get_module_load_offset(),
-				    MODULES_END, GFP_KERNEL | __GFP_HIGHMEM,
-				    PAGE_KERNEL_EXEC, 0, NUMA_NO_NODE,
+				    MODULES_END, GFP_KERNEL | __GFP_HIGHMEM | __GFP_ZERO,
+				    prot, 0, NUMA_NO_NODE,
 				    __builtin_return_address(0));
 	if (p && (kasan_module_alloc(p, size) < 0)) {
 		vfree(p);
@@ -96,6 +96,51 @@ void *module_alloc(unsigned long size)
 	return p;
 }
 
+void *module_alloc(unsigned long size)
+{
+
+#ifdef CONFIG_PAX_KERNEXEC
+	return __module_alloc(size, PAGE_KERNEL);
+#else
+	return __module_alloc(size, PAGE_KERNEL_EXEC);
+#endif
+
+}
+
+#ifdef CONFIG_PAX_KERNEXEC
+#ifdef CONFIG_X86_32
+void *module_alloc_exec(unsigned long size)
+{
+	struct vm_struct *area;
+
+	if (size == 0)
+		return NULL;
+
+	area = __get_vm_area(size, VM_ALLOC, (unsigned long)&MODULES_EXEC_VADDR, (unsigned long)&MODULES_EXEC_END);
+	return area ? area->addr : NULL;
+}
+EXPORT_SYMBOL(module_alloc_exec);
+
+void module_memfree_exec(void *module_region)
+{
+	vunmap(module_region);
+}
+EXPORT_SYMBOL(module_memfree_exec);
+#else
+void module_memfree_exec(void *module_region)
+{
+	module_memfree(module_region);
+}
+EXPORT_SYMBOL(module_memfree_exec);
+
+void *module_alloc_exec(unsigned long size)
+{
+	return __module_alloc(size, PAGE_KERNEL_RX);
+}
+EXPORT_SYMBOL(module_alloc_exec);
+#endif
+#endif
+
 #ifdef CONFIG_X86_32
 int apply_relocate(Elf32_Shdr *sechdrs,
 		   const char *strtab,
@@ -106,14 +151,16 @@ int apply_relocate(Elf32_Shdr *sechdrs,
 	unsigned int i;
 	Elf32_Rel *rel = (void *)sechdrs[relsec].sh_addr;
 	Elf32_Sym *sym;
-	uint32_t *location;
+	uint32_t *plocation, location;
 
 	DEBUGP("Applying relocate section %u to %u\n",
 	       relsec, sechdrs[relsec].sh_info);
 	for (i = 0; i < sechdrs[relsec].sh_size / sizeof(*rel); i++) {
 		/* This is where to make the change */
-		location = (void *)sechdrs[sechdrs[relsec].sh_info].sh_addr
-			+ rel[i].r_offset;
+		plocation = (void *)sechdrs[sechdrs[relsec].sh_info].sh_addr + rel[i].r_offset;
+		location = (uint32_t)plocation;
+		if (sechdrs[sechdrs[relsec].sh_info].sh_flags & SHF_EXECINSTR)
+			plocation = (uint32_t *)ktla_ktva((unsigned long)plocation);
 		/* This is the symbol it is referring to.  Note that all
 		   undefined symbols have been resolved.  */
 		sym = (Elf32_Sym *)sechdrs[symindex].sh_addr
@@ -122,11 +169,15 @@ int apply_relocate(Elf32_Shdr *sechdrs,
 		switch (ELF32_R_TYPE(rel[i].r_info)) {
 		case R_386_32:
 			/* We add the value into the location given */
-			*location += sym->st_value;
+			pax_open_kernel();
+			*plocation += sym->st_value;
+			pax_close_kernel();
 			break;
 		case R_386_PC32:
 			/* Add the value, subtract its position */
-			*location += sym->st_value - (uint32_t)location;
+			pax_open_kernel();
+			*plocation += sym->st_value - location;
+			pax_close_kernel();
 			break;
 		default:
 			pr_err("%s: Unknown relocation: %u\n",
@@ -171,21 +222,30 @@ int apply_relocate_add(Elf64_Shdr *sechdrs,
 		case R_X86_64_NONE:
 			break;
 		case R_X86_64_64:
+			pax_open_kernel();
 			*(u64 *)loc = val;
+			pax_close_kernel();
 			break;
 		case R_X86_64_32:
+			pax_open_kernel();
 			*(u32 *)loc = val;
+			pax_close_kernel();
 			if (val != *(u32 *)loc)
 				goto overflow;
 			break;
 		case R_X86_64_32S:
+			pax_open_kernel();
 			*(s32 *)loc = val;
+			pax_close_kernel();
 			if ((s64)val != *(s32 *)loc)
 				goto overflow;
 			break;
 		case R_X86_64_PC32:
 			val -= (u64)loc;
+			pax_open_kernel();
 			*(u32 *)loc = val;
+			pax_close_kernel();
+
 #if 0
 			if ((s64)val != *(s32 *)loc)
 				goto overflow;
diff --git a/arch/x86/kernel/msr.c b/arch/x86/kernel/msr.c
index 7f3550acd..e53578342 100644
--- a/arch/x86/kernel/msr.c
+++ b/arch/x86/kernel/msr.c
@@ -39,6 +39,7 @@
 #include <linux/notifier.h>
 #include <linux/uaccess.h>
 #include <linux/gfp.h>
+#include <linux/grsecurity.h>
 
 #include <asm/cpufeature.h>
 #include <asm/msr.h>
@@ -83,6 +84,13 @@ static ssize_t msr_write(struct file *file, const char __user *buf,
 	int err = 0;
 	ssize_t bytes = 0;
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+	if (reg != MSR_IA32_ENERGY_PERF_BIAS) {
+		gr_handle_msr_write();
+		return -EPERM;
+	}
+#endif
+
 	if (count % 8)
 		return -EINVAL;	/* Invalid chunk size */
 
@@ -130,6 +138,10 @@ static long msr_ioctl(struct file *file, unsigned int ioc, unsigned long arg)
 			err = -EBADF;
 			break;
 		}
+#ifdef CONFIG_GRKERNSEC_KMEM
+		gr_handle_msr_write();
+		return -EPERM;
+#endif
 		if (copy_from_user(&regs, uregs, sizeof regs)) {
 			err = -EFAULT;
 			break;
@@ -213,7 +225,7 @@ static int msr_class_cpu_callback(struct notifier_block *nfb,
 	return notifier_from_errno(err);
 }
 
-static struct notifier_block __refdata msr_class_cpu_notifier = {
+static struct notifier_block msr_class_cpu_notifier = {
 	.notifier_call = msr_class_cpu_callback,
 };
 
diff --git a/arch/x86/kernel/nmi.c b/arch/x86/kernel/nmi.c
index bfe4d6c96..1c3f03ca6 100644
--- a/arch/x86/kernel/nmi.c
+++ b/arch/x86/kernel/nmi.c
@@ -101,16 +101,16 @@ fs_initcall(nmi_warning_debugfs);
 
 static void nmi_max_handler(struct irq_work *w)
 {
-	struct nmiaction *a = container_of(w, struct nmiaction, irq_work);
+	struct nmiwork *n = container_of(w, struct nmiwork, irq_work);
 	int remainder_ns, decimal_msecs;
-	u64 whole_msecs = ACCESS_ONCE(a->max_duration);
+	u64 whole_msecs = ACCESS_ONCE(n->max_duration);
 
 	remainder_ns = do_div(whole_msecs, (1000 * 1000));
 	decimal_msecs = remainder_ns / 1000;
 
 	printk_ratelimited(KERN_INFO
 		"INFO: NMI handler (%ps) took too long to run: %lld.%03d msecs\n",
-		a->handler, whole_msecs, decimal_msecs);
+		n->action->handler, whole_msecs, decimal_msecs);
 }
 
 static int nmi_handle(unsigned int type, struct pt_regs *regs)
@@ -137,11 +137,11 @@ static int nmi_handle(unsigned int type, struct pt_regs *regs)
 		delta = sched_clock() - delta;
 		trace_nmi_handler(a->handler, (int)delta, thishandled);
 
-		if (delta < nmi_longest_ns || delta < a->max_duration)
+		if (delta < nmi_longest_ns || delta < a->work->max_duration)
 			continue;
 
-		a->max_duration = delta;
-		irq_work_queue(&a->irq_work);
+		a->work->max_duration = delta;
+		irq_work_queue(&a->work->irq_work);
 	}
 
 	rcu_read_unlock();
@@ -151,7 +151,7 @@ static int nmi_handle(unsigned int type, struct pt_regs *regs)
 }
 NOKPROBE_SYMBOL(nmi_handle);
 
-int __register_nmi_handler(unsigned int type, struct nmiaction *action)
+int __register_nmi_handler(unsigned int type, const struct nmiaction *action)
 {
 	struct nmi_desc *desc = nmi_to_desc(type);
 	unsigned long flags;
@@ -159,7 +159,8 @@ int __register_nmi_handler(unsigned int type, struct nmiaction *action)
 	if (!action->handler)
 		return -EINVAL;
 
-	init_irq_work(&action->irq_work, nmi_max_handler);
+	action->work->action = action;
+	init_irq_work(&action->work->irq_work, nmi_max_handler);
 
 	spin_lock_irqsave(&desc->lock, flags);
 
@@ -177,9 +178,9 @@ int __register_nmi_handler(unsigned int type, struct nmiaction *action)
 	 * event confuses some handlers (kdump uses this flag)
 	 */
 	if (action->flags & NMI_FLAG_FIRST)
-		list_add_rcu(&action->list, &desc->head);
+		pax_list_add_rcu((struct list_head *)&action->list, &desc->head);
 	else
-		list_add_tail_rcu(&action->list, &desc->head);
+		pax_list_add_tail_rcu((struct list_head *)&action->list, &desc->head);
 	
 	spin_unlock_irqrestore(&desc->lock, flags);
 	return 0;
@@ -202,7 +203,7 @@ void unregister_nmi_handler(unsigned int type, const char *name)
 		if (!strcmp(n->name, name)) {
 			WARN(in_nmi(),
 				"Trying to free NMI (%s) from NMI context!\n", n->name);
-			list_del_rcu(&n->list);
+			pax_list_del_rcu((struct list_head *)&n->list);
 			break;
 		}
 	}
@@ -503,6 +504,17 @@ static DEFINE_PER_CPU(int, update_debug_stack);
 dotraplinkage notrace void
 do_nmi(struct pt_regs *regs, long error_code)
 {
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	if (!user_mode(regs)) {
+		unsigned long cs = regs->cs & 0xFFFF;
+		unsigned long ip = ktva_ktla(regs->ip);
+
+		if ((cs == __KERNEL_CS || cs == __KERNEXEC_KERNEL_CS) && ip <= (unsigned long)_etext)
+			regs->ip = ip;
+	}
+#endif
+
 	if (this_cpu_read(nmi_state) != NMI_NOT_RUNNING) {
 		this_cpu_write(nmi_state, NMI_LATCHED);
 		return;
diff --git a/arch/x86/kernel/nmi_selftest.c b/arch/x86/kernel/nmi_selftest.c
index 6d9582ec0..f74628792 100644
--- a/arch/x86/kernel/nmi_selftest.c
+++ b/arch/x86/kernel/nmi_selftest.c
@@ -43,7 +43,7 @@ static void __init init_nmi_testsuite(void)
 {
 	/* trap all the unknown NMIs we may generate */
 	register_nmi_handler(NMI_UNKNOWN, nmi_unk_cb, 0, "nmi_selftest_unk",
-			__initdata);
+			__initconst);
 }
 
 static void __init cleanup_nmi_testsuite(void)
@@ -66,7 +66,7 @@ static void __init test_nmi_ipi(struct cpumask *mask)
 	unsigned long timeout;
 
 	if (register_nmi_handler(NMI_LOCAL, test_nmi_ipi_callback,
-				 NMI_FLAG_FIRST, "nmi_selftest", __initdata)) {
+				 NMI_FLAG_FIRST, "nmi_selftest", __initconst)) {
 		nmi_fail = FAILURE;
 		return;
 	}
diff --git a/arch/x86/kernel/paravirt-spinlocks.c b/arch/x86/kernel/paravirt-spinlocks.c
index 1939a0269..7e81a8f87 100644
--- a/arch/x86/kernel/paravirt-spinlocks.c
+++ b/arch/x86/kernel/paravirt-spinlocks.c
@@ -23,16 +23,32 @@ bool pv_is_native_spin_unlock(void)
 }
 #endif
 
-struct pv_lock_ops pv_lock_ops = {
+#ifdef CONFIG_SMP
+#ifdef CONFIG_QUEUED_SPINLOCKS
+static void native_wait(u8 *ptr, u8 val)
+{
+}
+
+static void native_kick(int cpu)
+{
+}
+#else /* !CONFIG_QUEUED_SPINLOCKS */
+static void native_unlock_kick(struct arch_spinlock *lock, __ticket_t ticket)
+{
+}
+#endif /* !CONFIG_QUEUED_SPINLOCKS */
+#endif /* SMP */
+
+struct pv_lock_ops pv_lock_ops __read_only = {
 #ifdef CONFIG_SMP
 #ifdef CONFIG_QUEUED_SPINLOCKS
 	.queued_spin_lock_slowpath = native_queued_spin_lock_slowpath,
 	.queued_spin_unlock = PV_CALLEE_SAVE(__native_queued_spin_unlock),
-	.wait = paravirt_nop,
-	.kick = paravirt_nop,
+	.wait = native_wait,
+	.kick = native_kick,
 #else /* !CONFIG_QUEUED_SPINLOCKS */
 	.lock_spinning = __PV_IS_CALLEE_SAVE(paravirt_nop),
-	.unlock_kick = paravirt_nop,
+	.unlock_kick = native_unlock_kick,
 #endif /* !CONFIG_QUEUED_SPINLOCKS */
 #endif /* SMP */
 };
diff --git a/arch/x86/kernel/paravirt.c b/arch/x86/kernel/paravirt.c
index 1acfd76e3..8a3a86da2 100644
--- a/arch/x86/kernel/paravirt.c
+++ b/arch/x86/kernel/paravirt.c
@@ -65,6 +65,9 @@ u64 notrace _paravirt_ident_64(u64 x)
 {
 	return x;
 }
+#if defined(CONFIG_X86_32) && defined(CONFIG_X86_PAE)
+PV_CALLEE_SAVE_REGS_THUNK(_paravirt_ident_64);
+#endif
 
 void __init default_banner(void)
 {
@@ -140,15 +143,19 @@ unsigned paravirt_patch_default(u8 type, u16 clobbers, void *insnbuf,
 
 	if (opfunc == NULL)
 		/* If there's no function, patch it with a ud2a (BUG) */
-		ret = paravirt_patch_insns(insnbuf, len, ud2a, ud2a+sizeof(ud2a));
-	else if (opfunc == _paravirt_nop)
+		ret = paravirt_patch_insns(insnbuf, len, (const char *)ktva_ktla((unsigned long)ud2a), ud2a+sizeof(ud2a));
+	else if (opfunc == (void *)_paravirt_nop)
 		ret = 0;
 
 	/* identity functions just return their single argument */
-	else if (opfunc == _paravirt_ident_32)
+	else if (opfunc == (void *)_paravirt_ident_32)
 		ret = paravirt_patch_ident_32(insnbuf, len);
-	else if (opfunc == _paravirt_ident_64)
+	else if (opfunc == (void *)_paravirt_ident_64)
+		ret = paravirt_patch_ident_64(insnbuf, len);
+#if defined(CONFIG_X86_32) && defined(CONFIG_X86_PAE)
+	else if (opfunc == (void *)__raw_callee_save__paravirt_ident_64)
 		ret = paravirt_patch_ident_64(insnbuf, len);
+#endif
 
 	else if (type == PARAVIRT_PATCH(pv_cpu_ops.iret) ||
 		 type == PARAVIRT_PATCH(pv_cpu_ops.usergs_sysret64))
@@ -171,7 +178,7 @@ unsigned paravirt_patch_insns(void *insnbuf, unsigned len,
 	if (insn_len > len || start == NULL)
 		insn_len = len;
 	else
-		memcpy(insnbuf, start, insn_len);
+		memcpy(insnbuf, (const char *)ktla_ktva((unsigned long)start), insn_len);
 
 	return insn_len;
 }
@@ -293,7 +300,7 @@ enum paravirt_lazy_mode paravirt_get_lazy_mode(void)
 	return this_cpu_read(paravirt_lazy_mode);
 }
 
-struct pv_info pv_info = {
+struct pv_info pv_info __read_only = {
 	.name = "bare hardware",
 	.kernel_rpl = 0,
 	.shared_kernel_pmd = 1,	/* Only used when CONFIG_X86_PAE is set */
@@ -303,16 +310,16 @@ struct pv_info pv_info = {
 #endif
 };
 
-struct pv_init_ops pv_init_ops = {
+struct pv_init_ops pv_init_ops __read_only = {
 	.patch = native_patch,
 };
 
-struct pv_time_ops pv_time_ops = {
+struct pv_time_ops pv_time_ops __read_only = {
 	.sched_clock = native_sched_clock,
 	.steal_clock = native_steal_clock,
 };
 
-__visible struct pv_irq_ops pv_irq_ops = {
+__visible struct pv_irq_ops pv_irq_ops __read_only = {
 	.save_fl = __PV_IS_CALLEE_SAVE(native_save_fl),
 	.restore_fl = __PV_IS_CALLEE_SAVE(native_restore_fl),
 	.irq_disable = __PV_IS_CALLEE_SAVE(native_irq_disable),
@@ -324,7 +331,23 @@ __visible struct pv_irq_ops pv_irq_ops = {
 #endif
 };
 
-__visible struct pv_cpu_ops pv_cpu_ops = {
+static void native_alloc_ldt(struct desc_struct *ldt, unsigned entries)
+{
+}
+
+static void native_free_ldt(struct desc_struct *ldt, unsigned entries)
+{
+}
+
+static void native_start_context_switch(struct task_struct *prev)
+{
+}
+
+static void native_end_context_switch(struct task_struct *next)
+{
+}
+
+__visible struct pv_cpu_ops pv_cpu_ops __read_only = {
 	.cpuid = native_cpuid,
 	.get_debugreg = native_get_debugreg,
 	.set_debugreg = native_set_debugreg,
@@ -358,8 +381,8 @@ __visible struct pv_cpu_ops pv_cpu_ops = {
 	.write_gdt_entry = native_write_gdt_entry,
 	.write_idt_entry = native_write_idt_entry,
 
-	.alloc_ldt = paravirt_nop,
-	.free_ldt = paravirt_nop,
+	.alloc_ldt = native_alloc_ldt,
+	.free_ldt = native_free_ldt,
 
 	.load_sp0 = native_load_sp0,
 
@@ -372,8 +395,8 @@ __visible struct pv_cpu_ops pv_cpu_ops = {
 	.set_iopl_mask = native_set_iopl_mask,
 	.io_delay = native_io_delay,
 
-	.start_context_switch = paravirt_nop,
-	.end_context_switch = paravirt_nop,
+	.start_context_switch = native_start_context_switch,
+	.end_context_switch = native_end_context_switch,
 };
 
 /* At this point, native_get/set_debugreg has real function entries */
@@ -381,15 +404,64 @@ NOKPROBE_SYMBOL(native_get_debugreg);
 NOKPROBE_SYMBOL(native_set_debugreg);
 NOKPROBE_SYMBOL(native_load_idt);
 
-#if defined(CONFIG_X86_32) && !defined(CONFIG_X86_PAE)
+#ifdef CONFIG_X86_32
+#ifdef CONFIG_X86_PAE
+/* 64-bit pagetable entries */
+#define PTE_IDENT	PV_CALLEE_SAVE(_paravirt_ident_64)
+#else
 /* 32-bit pagetable entries */
 #define PTE_IDENT	__PV_IS_CALLEE_SAVE(_paravirt_ident_32)
+#endif
 #else
 /* 64-bit pagetable entries */
 #define PTE_IDENT	__PV_IS_CALLEE_SAVE(_paravirt_ident_64)
 #endif
 
-struct pv_mmu_ops pv_mmu_ops = {
+static void native_pgd_free(struct mm_struct *mm, pgd_t *pgd)
+{
+}
+
+static void native_alloc_pte(struct mm_struct *mm, unsigned long pfn)
+{
+}
+
+static void native_alloc_pmd(struct mm_struct *mm, unsigned long pfn)
+{
+}
+
+static void native_alloc_pud(struct mm_struct *mm, unsigned long pfn)
+{
+}
+
+static void native_release_pte(unsigned long pfn)
+{
+}
+
+static void native_release_pmd(unsigned long pfn)
+{
+}
+
+static void native_release_pud(unsigned long pfn)
+{
+}
+
+static void native_pte_update(struct mm_struct *mm, unsigned long addr, pte_t *ptep)
+{
+}
+
+static void native_dup_mmap(struct mm_struct *oldmm, struct mm_struct *mm)
+{
+}
+
+static void native_exit_mmap(struct mm_struct *mm)
+{
+}
+
+static void native_activate_mm(struct mm_struct *prev, struct mm_struct *next)
+{
+}
+
+struct pv_mmu_ops pv_mmu_ops __read_only = {
 
 	.read_cr2 = native_read_cr2,
 	.write_cr2 = native_write_cr2,
@@ -402,20 +474,20 @@ struct pv_mmu_ops pv_mmu_ops = {
 	.flush_tlb_others = native_flush_tlb_others,
 
 	.pgd_alloc = __paravirt_pgd_alloc,
-	.pgd_free = paravirt_nop,
+	.pgd_free = native_pgd_free,
 
-	.alloc_pte = paravirt_nop,
-	.alloc_pmd = paravirt_nop,
-	.alloc_pud = paravirt_nop,
-	.release_pte = paravirt_nop,
-	.release_pmd = paravirt_nop,
-	.release_pud = paravirt_nop,
+	.alloc_pte = native_alloc_pte,
+	.alloc_pmd = native_alloc_pmd,
+	.alloc_pud = native_alloc_pud,
+	.release_pte = native_release_pte,
+	.release_pmd = native_release_pmd,
+	.release_pud = native_release_pud,
 
 	.set_pte = native_set_pte,
 	.set_pte_at = native_set_pte_at,
 	.set_pmd = native_set_pmd,
 	.set_pmd_at = native_set_pmd_at,
-	.pte_update = paravirt_nop,
+	.pte_update = native_pte_update,
 
 	.ptep_modify_prot_start = __ptep_modify_prot_start,
 	.ptep_modify_prot_commit = __ptep_modify_prot_commit,
@@ -436,6 +508,7 @@ struct pv_mmu_ops pv_mmu_ops = {
 	.make_pud = PTE_IDENT,
 
 	.set_pgd = native_set_pgd,
+	.set_pgd_batched = native_set_pgd_batched,
 #endif
 #endif /* CONFIG_PGTABLE_LEVELS >= 3 */
 
@@ -445,9 +518,9 @@ struct pv_mmu_ops pv_mmu_ops = {
 	.make_pte = PTE_IDENT,
 	.make_pgd = PTE_IDENT,
 
-	.dup_mmap = paravirt_nop,
-	.exit_mmap = paravirt_nop,
-	.activate_mm = paravirt_nop,
+	.dup_mmap = native_dup_mmap,
+	.exit_mmap = native_exit_mmap,
+	.activate_mm = native_activate_mm,
 
 	.lazy_mode = {
 		.enter = paravirt_nop,
@@ -456,6 +529,12 @@ struct pv_mmu_ops pv_mmu_ops = {
 	},
 
 	.set_fixmap = native_set_fixmap,
+
+#ifdef CONFIG_PAX_KERNEXEC
+	.pax_open_kernel = native_pax_open_kernel,
+	.pax_close_kernel = native_pax_close_kernel,
+#endif
+
 };
 
 EXPORT_SYMBOL_GPL(pv_time_ops);
diff --git a/arch/x86/kernel/paravirt_patch_64.c b/arch/x86/kernel/paravirt_patch_64.c
index e70087a04..b0833770e 100644
--- a/arch/x86/kernel/paravirt_patch_64.c
+++ b/arch/x86/kernel/paravirt_patch_64.c
@@ -9,7 +9,11 @@ DEF_NATIVE(pv_irq_ops, save_fl, "pushfq; popq %rax");
 DEF_NATIVE(pv_mmu_ops, read_cr2, "movq %cr2, %rax");
 DEF_NATIVE(pv_mmu_ops, read_cr3, "movq %cr3, %rax");
 DEF_NATIVE(pv_mmu_ops, write_cr3, "movq %rdi, %cr3");
+
+#ifndef CONFIG_PAX_MEMORY_UDEREF
 DEF_NATIVE(pv_mmu_ops, flush_tlb_single, "invlpg (%rdi)");
+#endif
+
 DEF_NATIVE(pv_cpu_ops, clts, "clts");
 DEF_NATIVE(pv_cpu_ops, wbinvd, "wbinvd");
 
@@ -59,7 +63,11 @@ unsigned native_patch(u8 type, u16 clobbers, void *ibuf,
 		PATCH_SITE(pv_mmu_ops, read_cr3);
 		PATCH_SITE(pv_mmu_ops, write_cr3);
 		PATCH_SITE(pv_cpu_ops, clts);
+
+#ifndef CONFIG_PAX_MEMORY_UDEREF
 		PATCH_SITE(pv_mmu_ops, flush_tlb_single);
+#endif
+
 		PATCH_SITE(pv_cpu_ops, wbinvd);
 #if defined(CONFIG_PARAVIRT_SPINLOCKS) && defined(CONFIG_QUEUED_SPINLOCKS)
 		case PARAVIRT_PATCH(pv_lock_ops.queued_spin_unlock):
diff --git a/arch/x86/kernel/pci-calgary_64.c b/arch/x86/kernel/pci-calgary_64.c
index 5d400ba13..eaad6f6a0 100644
--- a/arch/x86/kernel/pci-calgary_64.c
+++ b/arch/x86/kernel/pci-calgary_64.c
@@ -1347,7 +1347,7 @@ static void __init get_tce_space_from_tar(void)
 			tce_space = be64_to_cpu(readq(target));
 			tce_space = tce_space & TAR_SW_BITS;
 
-			tce_space = tce_space & (~specified_table_size);
+			tce_space = tce_space & (~(unsigned long)specified_table_size);
 			info->tce_space = (u64 *)__va(tce_space);
 		}
 	}
diff --git a/arch/x86/kernel/pci-iommu_table.c b/arch/x86/kernel/pci-iommu_table.c
index f712dfdf1..0172a75cf 100644
--- a/arch/x86/kernel/pci-iommu_table.c
+++ b/arch/x86/kernel/pci-iommu_table.c
@@ -2,7 +2,7 @@
 #include <asm/iommu_table.h>
 #include <linux/string.h>
 #include <linux/kallsyms.h>
-
+#include <linux/sched.h>
 
 #define DEBUG 1
 
diff --git a/arch/x86/kernel/process.c b/arch/x86/kernel/process.c
index 62c0b0ea2..43bd8daa1 100644
--- a/arch/x86/kernel/process.c
+++ b/arch/x86/kernel/process.c
@@ -16,6 +16,7 @@
 #include <linux/dmi.h>
 #include <linux/utsname.h>
 #include <linux/stackprotector.h>
+#include <linux/kthread.h>
 #include <linux/tick.h>
 #include <linux/cpuidle.h>
 #include <trace/events/power.h>
@@ -40,7 +41,8 @@
  * section. Since TSS's are completely CPU-local, we want them
  * on exact cacheline boundaries, to eliminate cacheline ping-pong.
  */
-__visible DEFINE_PER_CPU_SHARED_ALIGNED(struct tss_struct, cpu_tss) = {
+struct tss_struct cpu_tss[NR_CPUS] __visible ____cacheline_internodealigned_in_smp = {
+	[0 ... NR_CPUS-1] = {
 	.x86_tss = {
 		.sp0 = TOP_OF_INIT_STACK,
 #ifdef CONFIG_X86_32
@@ -61,6 +63,7 @@ __visible DEFINE_PER_CPU_SHARED_ALIGNED(struct tss_struct, cpu_tss) = {
 #ifdef CONFIG_X86_32
 	.SYSENTER_stack_canary	= STACK_END_MAGIC,
 #endif
+}
 };
 EXPORT_PER_CPU_SYMBOL(cpu_tss);
 
@@ -81,13 +84,26 @@ void idle_notifier_unregister(struct notifier_block *n)
 EXPORT_SYMBOL_GPL(idle_notifier_unregister);
 #endif
 
+struct kmem_cache *fpregs_state_cachep;
+EXPORT_SYMBOL(fpregs_state_cachep);
+
+void __init arch_task_cache_init(void)
+{
+	/* create a slab on which task_structs can be allocated */
+	fpregs_state_cachep =
+		kmem_cache_create_usercopy("fpregs_state", fpu_kernel_xstate_size,
+			ARCH_MIN_TASKALIGN, SLAB_PANIC | SLAB_NOTRACK, 0, fpu_kernel_xstate_size, NULL);
+}
+
 /*
  * this gets called so that we can store lazy state into memory and copy the
  * current task into the new thread.
  */
 int arch_dup_task_struct(struct task_struct *dst, struct task_struct *src)
 {
-	memcpy(dst, src, arch_task_struct_size);
+	*dst = *src;
+	dst->thread.fpu.state = kmem_cache_alloc_node(fpregs_state_cachep, GFP_KERNEL, tsk_fork_get_node(src));
+	memcpy(dst->thread.fpu.state, src->thread.fpu.state, fpu_kernel_xstate_size);
 #ifdef CONFIG_VM86
 	dst->thread.vm86 = NULL;
 #endif
@@ -95,6 +111,12 @@ int arch_dup_task_struct(struct task_struct *dst, struct task_struct *src)
 	return fpu__copy(&dst->thread.fpu, &src->thread.fpu);
 }
 
+void arch_release_task_struct(struct task_struct *tsk)
+{
+	kmem_cache_free(fpregs_state_cachep, tsk->thread.fpu.state);
+	tsk->thread.fpu.state = NULL;
+}
+
 /*
  * Free current thread data structures etc..
  */
@@ -105,7 +127,7 @@ void exit_thread(struct task_struct *tsk)
 	struct fpu *fpu = &t->fpu;
 
 	if (bp) {
-		struct tss_struct *tss = &per_cpu(cpu_tss, get_cpu());
+		struct tss_struct *tss = cpu_tss + get_cpu();
 
 		t->io_bitmap_ptr = NULL;
 		clear_thread_flag(TIF_IO_BITMAP);
@@ -127,6 +149,9 @@ void flush_thread(void)
 {
 	struct task_struct *tsk = current;
 
+#if defined(CONFIG_X86_32) && !defined(CONFIG_CC_STACKPROTECTOR) && !defined(CONFIG_PAX_MEMORY_UDEREF)
+	loadsegment(gs, 0);
+#endif
 	flush_ptrace_hw_breakpoint(tsk);
 	memset(tsk->thread.tls_array, 0, sizeof(tsk->thread.tls_array));
 
@@ -268,7 +293,7 @@ static void __exit_idle(void)
 void exit_idle(void)
 {
 	/* idle loop has pid 0 */
-	if (current->pid)
+	if (task_pid_nr(current))
 		return;
 	__exit_idle();
 }
@@ -321,7 +346,7 @@ bool xen_set_default_idle(void)
 	return ret;
 }
 #endif
-void stop_this_cpu(void *dummy)
+__noreturn void stop_this_cpu(void *dummy)
 {
 	local_irq_disable();
 	/*
@@ -499,13 +524,6 @@ static int __init idle_setup(char *str)
 }
 early_param("idle", idle_setup);
 
-unsigned long arch_align_stack(unsigned long sp)
-{
-	if (!(current->personality & ADDR_NO_RANDOMIZE) && randomize_va_space)
-		sp -= get_random_int() % 8192;
-	return sp & ~0xf;
-}
-
 unsigned long arch_randomize_brk(struct mm_struct *mm)
 {
 	unsigned long range_end = mm->brk + 0x02000000;
@@ -537,9 +555,7 @@ unsigned long get_wchan(struct task_struct *p)
 	 * PADDING
 	 * ----------- top = topmax - TOP_OF_KERNEL_STACK_PADDING
 	 * stack
-	 * ----------- bottom = start + sizeof(thread_info)
-	 * thread_info
-	 * ----------- start
+	 * ----------- bottom = start
 	 *
 	 * The tasks stack pointer points at the location where the
 	 * framepointer is stored. The data on the stack is:
@@ -550,7 +566,7 @@ unsigned long get_wchan(struct task_struct *p)
 	 */
 	top = start + THREAD_SIZE - TOP_OF_KERNEL_STACK_PADDING;
 	top -= 2 * sizeof(unsigned long);
-	bottom = start + sizeof(struct thread_info);
+	bottom = start;
 
 	sp = READ_ONCE(p->thread.sp);
 	if (sp < bottom || sp > top)
@@ -567,3 +583,35 @@ unsigned long get_wchan(struct task_struct *p)
 	} while (count++ < 16 && p->state != TASK_RUNNING);
 	return 0;
 }
+
+#ifdef CONFIG_PAX_RANDKSTACK
+void pax_randomize_kstack(struct pt_regs *regs)
+{
+	struct thread_struct *thread = &current->thread;
+	unsigned long time;
+
+	if (!randomize_va_space)
+		return;
+
+	if (v8086_mode(regs))
+		return;
+
+	time = rdtsc();
+
+	/* P4 seems to return a 0 LSB, ignore it */
+#ifdef CONFIG_MPENTIUM4
+	time &= 0x3EUL;
+	time <<= 2;
+#elif defined(CONFIG_X86_64)
+	time &= 0xFUL;
+	time <<= 4;
+#else
+	time &= 0x1FUL;
+	time <<= 3;
+#endif
+
+	thread->sp0 ^= time;
+	load_sp0(cpu_tss + smp_processor_id(), thread);
+	this_cpu_write(cpu_current_top_of_stack, thread->sp0);
+}
+#endif
diff --git a/arch/x86/kernel/process_32.c b/arch/x86/kernel/process_32.c
index d86be29c3..eb6012e96 100644
--- a/arch/x86/kernel/process_32.c
+++ b/arch/x86/kernel/process_32.c
@@ -64,6 +64,7 @@ asmlinkage void ret_from_kernel_thread(void) __asm__("ret_from_kernel_thread");
 unsigned long thread_saved_pc(struct task_struct *tsk)
 {
 	return ((unsigned long *)tsk->thread.sp)[3];
+//XXX	return tsk->thread.eip;
 }
 
 void __show_regs(struct pt_regs *regs, int all)
@@ -76,16 +77,15 @@ void __show_regs(struct pt_regs *regs, int all)
 	if (user_mode(regs)) {
 		sp = regs->sp;
 		ss = regs->ss & 0xffff;
-		gs = get_user_gs(regs);
 	} else {
 		sp = kernel_stack_pointer(regs);
 		savesegment(ss, ss);
-		savesegment(gs, gs);
 	}
+	gs = get_user_gs(regs);
 
 	printk(KERN_DEFAULT "EIP: %04x:[<%08lx>] EFLAGS: %08lx CPU: %d\n",
 			(u16)regs->cs, regs->ip, regs->flags,
-			smp_processor_id());
+			raw_smp_processor_id());
 	print_symbol("EIP is at %s\n", regs->ip);
 
 	printk(KERN_DEFAULT "EAX: %08lx EBX: %08lx ECX: %08lx EDX: %08lx\n",
@@ -132,21 +132,22 @@ void release_thread(struct task_struct *dead_task)
 int copy_thread_tls(unsigned long clone_flags, unsigned long sp,
 	unsigned long arg, struct task_struct *p, unsigned long tls)
 {
-	struct pt_regs *childregs = task_pt_regs(p);
+	struct pt_regs *childregs = task_stack_page(p) + THREAD_SIZE - sizeof(struct pt_regs) - 8;
 	struct task_struct *tsk;
 	int err;
 
 	p->thread.sp = (unsigned long) childregs;
 	p->thread.sp0 = (unsigned long) (childregs+1);
+	p->tinfo.lowest_stack = (unsigned long)task_stack_page(p) + 2 * sizeof(unsigned long);
 	memset(p->thread.ptrace_bps, 0, sizeof(p->thread.ptrace_bps));
 
 	if (unlikely(p->flags & PF_KTHREAD)) {
 		/* kernel thread */
 		memset(childregs, 0, sizeof(struct pt_regs));
 		p->thread.ip = (unsigned long) ret_from_kernel_thread;
-		task_user_gs(p) = __KERNEL_STACK_CANARY;
-		childregs->ds = __USER_DS;
-		childregs->es = __USER_DS;
+		savesegment(gs, childregs->gs);
+		childregs->ds = __KERNEL_DS;
+		childregs->es = __KERNEL_DS;
 		childregs->fs = __KERNEL_PERCPU;
 		childregs->bx = sp;	/* function */
 		childregs->bp = arg;
@@ -246,7 +247,7 @@ __switch_to(struct task_struct *prev_p, struct task_struct *next_p)
 	struct fpu *prev_fpu = &prev->fpu;
 	struct fpu *next_fpu = &next->fpu;
 	int cpu = smp_processor_id();
-	struct tss_struct *tss = &per_cpu(cpu_tss, cpu);
+	struct tss_struct *tss = cpu_tss + cpu;
 	fpu_switch_t fpu_switch;
 
 	/* never put a printk in __switch_to... printk() calls wake_up*() indirectly */
@@ -265,6 +266,10 @@ __switch_to(struct task_struct *prev_p, struct task_struct *next_p)
 	 */
 	lazy_save_gs(prev->gs);
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	__set_fs(task_thread_info(next_p)->addr_limit);
+#endif
+
 	/*
 	 * Load the per-thread Thread-Local Storage descriptor.
 	 */
@@ -300,9 +305,9 @@ __switch_to(struct task_struct *prev_p, struct task_struct *next_p)
 	 * current_thread_info().
 	 */
 	load_sp0(tss, next);
-	this_cpu_write(cpu_current_top_of_stack,
-		       (unsigned long)task_stack_page(next_p) +
-		       THREAD_SIZE);
+	this_cpu_write(current_task, next_p);
+	this_cpu_write(current_tinfo, &next_p->tinfo);
+	this_cpu_write(cpu_current_top_of_stack, next->sp0);
 
 	/*
 	 * Restore %gs if needed (which is common)
@@ -312,7 +317,5 @@ __switch_to(struct task_struct *prev_p, struct task_struct *next_p)
 
 	switch_fpu_finish(next_fpu, fpu_switch);
 
-	this_cpu_write(current_task, next_p);
-
 	return prev_p;
 }
diff --git a/arch/x86/kernel/process_64.c b/arch/x86/kernel/process_64.c
index a21068e49..3f3a2ebdc 100644
--- a/arch/x86/kernel/process_64.c
+++ b/arch/x86/kernel/process_64.c
@@ -144,9 +144,10 @@ int copy_thread_tls(unsigned long clone_flags, unsigned long sp,
 	struct pt_regs *childregs;
 	struct task_struct *me = current;
 
-	p->thread.sp0 = (unsigned long)task_stack_page(p) + THREAD_SIZE;
+	p->thread.sp0 = (unsigned long)task_stack_page(p) + THREAD_SIZE - 16;
 	childregs = task_pt_regs(p);
 	p->thread.sp = (unsigned long) childregs;
+	p->tinfo.lowest_stack = (unsigned long)task_stack_page(p) + 2 * sizeof(unsigned long);
 	set_tsk_thread_flag(p, TIF_FORK);
 	p->thread.io_bitmap_ptr = NULL;
 
@@ -156,6 +157,8 @@ int copy_thread_tls(unsigned long clone_flags, unsigned long sp,
 	p->thread.fsbase = p->thread.fsindex ? 0 : me->thread.fsbase;
 	savesegment(es, p->thread.es);
 	savesegment(ds, p->thread.ds);
+	savesegment(ss, p->thread.ss);
+	BUG_ON(p->thread.ss == __UDEREF_KERNEL_DS);
 	memset(p->thread.ptrace_bps, 0, sizeof(p->thread.ptrace_bps));
 
 	if (unlikely(p->flags & PF_KTHREAD)) {
@@ -263,7 +266,7 @@ __switch_to(struct task_struct *prev_p, struct task_struct *next_p)
 	struct fpu *prev_fpu = &prev->fpu;
 	struct fpu *next_fpu = &next->fpu;
 	int cpu = smp_processor_id();
-	struct tss_struct *tss = &per_cpu(cpu_tss, cpu);
+	struct tss_struct *tss = cpu_tss + cpu;
 	unsigned prev_fsindex, prev_gsindex;
 	fpu_switch_t fpu_switch;
 
@@ -314,6 +317,10 @@ __switch_to(struct task_struct *prev_p, struct task_struct *next_p)
 	if (unlikely(next->ds | prev->ds))
 		loadsegment(ds, next->ds);
 
+	savesegment(ss, prev->ss);
+	if (unlikely(next->ss != prev->ss))
+		loadsegment(ss, next->ss);
+
 	/*
 	 * Switch FS and GS.
 	 *
@@ -423,10 +430,13 @@ __switch_to(struct task_struct *prev_p, struct task_struct *next_p)
 	 * Switch the PDA and FPU contexts.
 	 */
 	this_cpu_write(current_task, next_p);
+	this_cpu_write(current_tinfo, &next_p->tinfo);
 
 	/* Reload esp0 and ss1.  This changes current_thread_info(). */
 	load_sp0(tss, next);
 
+	this_cpu_write(cpu_current_top_of_stack, next->sp0);
+
 	/*
 	 * Now maybe reload the debug registers and handle I/O bitmaps
 	 */
diff --git a/arch/x86/kernel/ptrace.c b/arch/x86/kernel/ptrace.c
index a1606eadd..3e7a40851 100644
--- a/arch/x86/kernel/ptrace.c
+++ b/arch/x86/kernel/ptrace.c
@@ -169,7 +169,7 @@ unsigned long kernel_stack_pointer(struct pt_regs *regs)
 	unsigned long sp = (unsigned long)&regs->sp;
 	u32 *prev_esp;
 
-	if (context == (sp & ~(THREAD_SIZE - 1)))
+	if (context == ((sp + 8) & ~(THREAD_SIZE - 1)))
 		return sp;
 
 	prev_esp = (u32 *)(context);
@@ -411,6 +411,20 @@ static int putreg(struct task_struct *child,
 		if (child->thread.gsbase != value)
 			return do_arch_prctl(child, ARCH_SET_GS, value);
 		return 0;
+
+	case offsetof(struct user_regs_struct,ip):
+		/*
+		 * Protect against any attempt to set ip to an
+		 * impossible address.  There are dragons lurking if the
+		 * address is noncanonical.  (This explicitly allows
+		 * setting ip to TASK_SIZE_MAX, because user code can do
+		 * that all by itself by running off the end of its
+		 * address space.
+		 */
+		if (value > TASK_SIZE_MAX)
+			return -EIO;
+		break;
+
 #endif
 	}
 
@@ -533,7 +547,7 @@ static void ptrace_triggered(struct perf_event *bp,
 static unsigned long ptrace_get_dr7(struct perf_event *bp[])
 {
 	int i;
-	int dr7 = 0;
+	unsigned long dr7 = 0;
 	struct arch_hw_breakpoint *info;
 
 	for (i = 0; i < HBP_NUM; i++) {
@@ -767,7 +781,7 @@ long arch_ptrace(struct task_struct *child, long request,
 		 unsigned long addr, unsigned long data)
 {
 	int ret;
-	unsigned long __user *datap = (unsigned long __user *)data;
+	unsigned long __user *datap = (__force unsigned long __user *)data;
 
 	switch (request) {
 	/* read the word at location addr in the USER area. */
@@ -852,14 +866,14 @@ long arch_ptrace(struct task_struct *child, long request,
 		if ((int) addr < 0)
 			return -EIO;
 		ret = do_get_thread_area(child, addr,
-					(struct user_desc __user *)data);
+					(__force struct user_desc __user *) data);
 		break;
 
 	case PTRACE_SET_THREAD_AREA:
 		if ((int) addr < 0)
 			return -EIO;
 		ret = do_set_thread_area(child, addr,
-					(struct user_desc __user *)data, 0);
+					(__force struct user_desc __user *) data, 0);
 		break;
 #endif
 
@@ -1250,7 +1264,7 @@ long compat_arch_ptrace(struct task_struct *child, compat_long_t request,
 
 #ifdef CONFIG_X86_64
 
-static struct user_regset x86_64_regsets[] __read_mostly = {
+static user_regset_no_const x86_64_regsets[] __read_only = {
 	[REGSET_GENERAL] = {
 		.core_note_type = NT_PRSTATUS,
 		.n = sizeof(struct user_regs_struct) / sizeof(long),
@@ -1291,7 +1305,7 @@ static const struct user_regset_view user_x86_64_view = {
 #endif	/* CONFIG_X86_64 */
 
 #if defined CONFIG_X86_32 || defined CONFIG_IA32_EMULATION
-static struct user_regset x86_32_regsets[] __read_mostly = {
+static user_regset_no_const x86_32_regsets[] __read_only = {
 	[REGSET_GENERAL] = {
 		.core_note_type = NT_PRSTATUS,
 		.n = sizeof(struct user_regs_struct32) / sizeof(u32),
@@ -1344,7 +1358,7 @@ static const struct user_regset_view user_x86_32_view = {
  */
 u64 xstate_fx_sw_bytes[USER_XSTATE_FX_SW_WORDS];
 
-void update_regset_xstate_info(unsigned int size, u64 xstate_mask)
+void __init update_regset_xstate_info(unsigned int size, u64 xstate_mask)
 {
 #ifdef CONFIG_X86_64
 	x86_64_regsets[REGSET_XSTATE].n = size / sizeof(u64);
@@ -1379,7 +1393,7 @@ static void fill_sigtrap_info(struct task_struct *tsk,
 	memset(info, 0, sizeof(*info));
 	info->si_signo = SIGTRAP;
 	info->si_code = si_code;
-	info->si_addr = user_mode(regs) ? (void __user *)regs->ip : NULL;
+	info->si_addr = user_mode(regs) ? (__force void __user *)regs->ip : NULL;
 }
 
 void user_single_step_siginfo(struct task_struct *tsk,
diff --git a/arch/x86/kernel/pvclock.c b/arch/x86/kernel/pvclock.c
index 3599404e3..ebc784ffb 100644
--- a/arch/x86/kernel/pvclock.c
+++ b/arch/x86/kernel/pvclock.c
@@ -51,11 +51,11 @@ void pvclock_touch_watchdogs(void)
 	reset_hung_task_detector();
 }
 
-static atomic64_t last_value = ATOMIC64_INIT(0);
+static atomic64_unchecked_t last_value = ATOMIC64_INIT(0);
 
 void pvclock_resume(void)
 {
-	atomic64_set(&last_value, 0);
+	atomic64_set_unchecked(&last_value, 0);
 }
 
 u8 pvclock_read_flags(struct pvclock_vcpu_time_info *src)
@@ -107,11 +107,11 @@ cycle_t pvclock_clocksource_read(struct pvclock_vcpu_time_info *src)
 	 * updating at the same time, and one of them could be slightly behind,
 	 * making the assumption that last_value always go forward fail to hold.
 	 */
-	last = atomic64_read(&last_value);
+	last = atomic64_read_unchecked(&last_value);
 	do {
 		if (ret < last)
 			return last;
-		last = atomic64_cmpxchg(&last_value, last, ret);
+		last = atomic64_cmpxchg_unchecked(&last_value, last, ret);
 	} while (unlikely(last != ret));
 
 	return ret;
diff --git a/arch/x86/kernel/reboot.c b/arch/x86/kernel/reboot.c
index 63bf27d97..a75d12b53 100644
--- a/arch/x86/kernel/reboot.c
+++ b/arch/x86/kernel/reboot.c
@@ -83,6 +83,11 @@ static int __init set_bios_reboot(const struct dmi_system_id *d)
 
 void __noreturn machine_real_restart(unsigned int type)
 {
+
+#if defined(CONFIG_X86_32) && (defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF))
+	struct desc_struct *gdt;
+#endif
+
 	local_irq_disable();
 
 	/*
@@ -110,7 +115,29 @@ void __noreturn machine_real_restart(unsigned int type)
 
 	/* Jump to the identity-mapped low memory code */
 #ifdef CONFIG_X86_32
-	asm volatile("jmpl *%0" : :
+
+#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
+	gdt = get_cpu_gdt_table(smp_processor_id());
+	pax_open_kernel();
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	gdt[GDT_ENTRY_KERNEL_DS].type = 3;
+	gdt[GDT_ENTRY_KERNEL_DS].limit = 0xf;
+	loadsegment(ds, __KERNEL_DS);
+	loadsegment(es, __KERNEL_DS);
+	loadsegment(ss, __KERNEL_DS);
+#endif
+#ifdef CONFIG_PAX_KERNEXEC
+	gdt[GDT_ENTRY_KERNEL_CS].base0 = 0;
+	gdt[GDT_ENTRY_KERNEL_CS].base1 = 0;
+	gdt[GDT_ENTRY_KERNEL_CS].base2 = 0;
+	gdt[GDT_ENTRY_KERNEL_CS].limit0 = 0xffff;
+	gdt[GDT_ENTRY_KERNEL_CS].limit = 0xf;
+	gdt[GDT_ENTRY_KERNEL_CS].g = 1;
+#endif
+	pax_close_kernel();
+#endif
+
+	asm volatile("ljmpl *%0" : :
 		     "rm" (real_mode_header->machine_real_restart_asm),
 		     "a" (type));
 #else
@@ -150,7 +177,7 @@ static int __init set_kbd_reboot(const struct dmi_system_id *d)
 /*
  * This is a single dmi_table handling all reboot quirks.
  */
-static struct dmi_system_id __initdata reboot_dmi_table[] = {
+static const struct dmi_system_id __initconst reboot_dmi_table[] = {
 
 	/* Acer */
 	{	/* Handle reboot issue on Acer Aspire one */
@@ -540,7 +567,7 @@ void __attribute__((weak)) mach_reboot_fixups(void)
  * This means that this function can never return, it can misbehave
  * by not rebooting properly and hanging.
  */
-static void native_machine_emergency_restart(void)
+static void __noreturn native_machine_emergency_restart(void)
 {
 	int i;
 	int attempt = 0;
@@ -669,13 +696,13 @@ void native_machine_shutdown(void)
 #endif
 }
 
-static void __machine_emergency_restart(int emergency)
+static void __noreturn __machine_emergency_restart(int emergency)
 {
 	reboot_emergency = emergency;
 	machine_ops.emergency_restart();
 }
 
-static void native_machine_restart(char *__unused)
+static void __noreturn native_machine_restart(char *__unused)
 {
 	pr_notice("machine restart\n");
 
@@ -684,7 +711,7 @@ static void native_machine_restart(char *__unused)
 	__machine_emergency_restart(0);
 }
 
-static void native_machine_halt(void)
+static void __noreturn native_machine_halt(void)
 {
 	/* Stop other cpus and apics */
 	machine_shutdown();
@@ -694,7 +721,7 @@ static void native_machine_halt(void)
 	stop_this_cpu(NULL);
 }
 
-static void native_machine_power_off(void)
+static void __noreturn native_machine_power_off(void)
 {
 	if (pm_power_off) {
 		if (!reboot_force)
@@ -703,9 +730,10 @@ static void native_machine_power_off(void)
 	}
 	/* A fallback in case there is no PM info available */
 	tboot_shutdown(TB_SHUTDOWN_HALT);
+	unreachable();
 }
 
-struct machine_ops machine_ops = {
+struct machine_ops machine_ops __read_only = {
 	.power_off = native_machine_power_off,
 	.shutdown = native_machine_shutdown,
 	.emergency_restart = native_machine_emergency_restart,
diff --git a/arch/x86/kernel/reboot_fixups_32.c b/arch/x86/kernel/reboot_fixups_32.c
index c8e41e90f..64049ef37 100644
--- a/arch/x86/kernel/reboot_fixups_32.c
+++ b/arch/x86/kernel/reboot_fixups_32.c
@@ -57,7 +57,7 @@ struct device_fixup {
 	unsigned int vendor;
 	unsigned int device;
 	void (*reboot_fixup)(struct pci_dev *);
-};
+} __do_const;
 
 /*
  * PCI ids solely used for fixups_table go here
diff --git a/arch/x86/kernel/relocate_kernel_64.S b/arch/x86/kernel/relocate_kernel_64.S
index 98111b38e..73ca12504 100644
--- a/arch/x86/kernel/relocate_kernel_64.S
+++ b/arch/x86/kernel/relocate_kernel_64.S
@@ -96,8 +96,7 @@ relocate_kernel:
 
 	/* jump to identity mapped page */
 	addq	$(identity_mapped - relocate_kernel), %r8
-	pushq	%r8
-	ret
+	jmp	*%r8
 
 identity_mapped:
 	/* set return address to 0 if not preserving context */
diff --git a/arch/x86/kernel/setup.c b/arch/x86/kernel/setup.c
index d5219b1c8..0e04ab1fe 100644
--- a/arch/x86/kernel/setup.c
+++ b/arch/x86/kernel/setup.c
@@ -114,6 +114,7 @@
 #include <asm/microcode.h>
 #include <asm/mmu_context.h>
 #include <asm/kaslr.h>
+#include <asm/boot.h>
 
 /*
  * max_low_pfn_mapped: highest direct mapped pfn under 4GB
@@ -178,7 +179,7 @@ struct cpuinfo_x86 new_cpu_data = {
 	.wp_works_ok = -1,
 };
 /* common cpu data for all cpus */
-struct cpuinfo_x86 boot_cpu_data __read_mostly = {
+struct cpuinfo_x86 boot_cpu_data __read_only = {
 	.wp_works_ok = -1,
 };
 EXPORT_SYMBOL(boot_cpu_data);
@@ -202,17 +203,19 @@ struct ist_info ist_info;
 #endif
 
 #else
-struct cpuinfo_x86 boot_cpu_data __read_mostly = {
+struct cpuinfo_x86 boot_cpu_data __read_only = {
 	.x86_phys_bits = MAX_PHYSMEM_BITS,
 };
 EXPORT_SYMBOL(boot_cpu_data);
 #endif
 
 
-#if !defined(CONFIG_X86_PAE) || defined(CONFIG_X86_64)
-__visible unsigned long mmu_cr4_features;
+#ifdef CONFIG_X86_64
+__visible unsigned long mmu_cr4_features __read_only = X86_CR4_PSE | X86_CR4_PAE | X86_CR4_PGE;
+#elif defined(CONFIG_X86_PAE)
+__visible unsigned long mmu_cr4_features __read_only = X86_CR4_PAE;
 #else
-__visible unsigned long mmu_cr4_features = X86_CR4_PAE;
+__visible unsigned long mmu_cr4_features __read_only;
 #endif
 
 /* Boot loader ID and version as integers, for the benefit of proc_dointvec */
@@ -761,7 +764,7 @@ static void __init trim_bios_range(void)
 	 * area (640->1Mb) as ram even though it is not.
 	 * take them out.
 	 */
-	e820_remove_range(BIOS_BEGIN, BIOS_END - BIOS_BEGIN, E820_RAM, 1);
+	e820_remove_range(ISA_START_ADDRESS, ISA_END_ADDRESS - ISA_START_ADDRESS, E820_RAM, 1);
 
 	sanitize_e820_map(e820.map, ARRAY_SIZE(e820.map), &e820.nr_map);
 }
@@ -769,7 +772,7 @@ static void __init trim_bios_range(void)
 /* called before trim_bios_range() to spare extra sanitize */
 static void __init e820_add_kernel_range(void)
 {
-	u64 start = __pa_symbol(_text);
+	u64 start = __pa_symbol(ktla_ktva((unsigned long)_text));
 	u64 size = __pa_symbol(_end) - start;
 
 	/*
@@ -850,8 +853,8 @@ dump_kernel_offset(struct notifier_block *self, unsigned long v, void *p)
 
 void __init setup_arch(char **cmdline_p)
 {
-	memblock_reserve(__pa_symbol(_text),
-			 (unsigned long)__bss_stop - (unsigned long)_text);
+	memblock_reserve(__pa_symbol(ktla_ktva((unsigned long)_text)),
+			 (unsigned long)__bss_stop - ktla_ktva((unsigned long)_text));
 
 	early_reserve_initrd();
 
@@ -944,16 +947,16 @@ void __init setup_arch(char **cmdline_p)
 
 	if (!boot_params.hdr.root_flags)
 		root_mountflags &= ~MS_RDONLY;
-	init_mm.start_code = (unsigned long) _text;
-	init_mm.end_code = (unsigned long) _etext;
-	init_mm.end_data = (unsigned long) _edata;
+	init_mm.start_code = ktla_ktva((unsigned long)_text);
+	init_mm.end_code = ktla_ktva((unsigned long)_etext);
+	init_mm.end_data = (unsigned long)_edata;
 	init_mm.brk = _brk_end;
 
 	mpx_mm_init(&init_mm);
 
-	code_resource.start = __pa_symbol(_text);
-	code_resource.end = __pa_symbol(_etext)-1;
-	data_resource.start = __pa_symbol(_etext);
+	code_resource.start = __pa_symbol(ktla_ktva((unsigned long)_text));
+	code_resource.end = __pa_symbol(ktla_ktva((unsigned long)_etext))-1;
+	data_resource.start = __pa_symbol(_sdata);
 	data_resource.end = __pa_symbol(_edata)-1;
 	bss_resource.start = __pa_symbol(__bss_start);
 	bss_resource.end = __pa_symbol(__bss_stop)-1;
diff --git a/arch/x86/kernel/setup_percpu.c b/arch/x86/kernel/setup_percpu.c
index 7a40e0683..f60ccfe94 100644
--- a/arch/x86/kernel/setup_percpu.c
+++ b/arch/x86/kernel/setup_percpu.c
@@ -21,19 +21,17 @@
 #include <asm/cpu.h>
 #include <asm/stackprotector.h>
 
-DEFINE_PER_CPU_READ_MOSTLY(int, cpu_number);
+#ifdef CONFIG_SMP
+DEFINE_PER_CPU_READ_MOSTLY(unsigned int, cpu_number);
 EXPORT_PER_CPU_SYMBOL(cpu_number);
+#endif
 
-#ifdef CONFIG_X86_64
 #define BOOT_PERCPU_OFFSET ((unsigned long)__per_cpu_load)
-#else
-#define BOOT_PERCPU_OFFSET 0
-#endif
 
 DEFINE_PER_CPU_READ_MOSTLY(unsigned long, this_cpu_off) = BOOT_PERCPU_OFFSET;
 EXPORT_PER_CPU_SYMBOL(this_cpu_off);
 
-unsigned long __per_cpu_offset[NR_CPUS] __read_mostly = {
+unsigned long __per_cpu_offset[NR_CPUS] __read_only = {
 	[0 ... NR_CPUS-1] = BOOT_PERCPU_OFFSET,
 };
 EXPORT_SYMBOL(__per_cpu_offset);
@@ -66,7 +64,7 @@ static bool __init pcpu_need_numa(void)
 {
 #ifdef CONFIG_NEED_MULTIPLE_NODES
 	pg_data_t *last = NULL;
-	unsigned int cpu;
+	int cpu;
 
 	for_each_possible_cpu(cpu) {
 		int node = early_cpu_to_node(cpu);
@@ -155,10 +153,10 @@ static inline void setup_percpu_segment(int cpu)
 {
 #ifdef CONFIG_X86_32
 	struct desc_struct gdt;
+	unsigned long base = per_cpu_offset(cpu);
 
-	pack_descriptor(&gdt, per_cpu_offset(cpu), 0xFFFFF,
-			0x2 | DESCTYPE_S, 0x8);
-	gdt.s = 1;
+	pack_descriptor(&gdt, base, (VMALLOC_END - base - 1) >> PAGE_SHIFT,
+			0x83 | DESCTYPE_S, 0xC);
 	write_gdt_entry(get_cpu_gdt_table(cpu),
 			GDT_ENTRY_PERCPU, &gdt, DESCTYPE_S);
 #endif
@@ -219,6 +217,11 @@ void __init setup_per_cpu_areas(void)
 	/* alrighty, percpu areas up and running */
 	delta = (unsigned long)pcpu_base_addr - (unsigned long)__per_cpu_start;
 	for_each_possible_cpu(cpu) {
+#ifdef CONFIG_CC_STACKPROTECTOR
+#ifdef CONFIG_X86_32
+		unsigned long canary = per_cpu(stack_canary.canary, cpu);
+#endif
+#endif
 		per_cpu_offset(cpu) = delta + pcpu_unit_offsets[cpu];
 		per_cpu(this_cpu_off, cpu) = per_cpu_offset(cpu);
 		per_cpu(cpu_number, cpu) = cpu;
@@ -261,6 +264,12 @@ void __init setup_per_cpu_areas(void)
 		 */
 		set_cpu_numa_node(cpu, early_cpu_to_node(cpu));
 #endif
+#ifdef CONFIG_CC_STACKPROTECTOR
+#ifdef CONFIG_X86_32
+		if (!cpu)
+			per_cpu(stack_canary.canary, cpu) = canary;
+#endif
+#endif
 		/*
 		 * Up to this point, the boot CPU has been using .init.data
 		 * area.  Reload any changed state for the boot CPU.
diff --git a/arch/x86/kernel/signal.c b/arch/x86/kernel/signal.c
index 04cb3212d..e74f02124 100644
--- a/arch/x86/kernel/signal.c
+++ b/arch/x86/kernel/signal.c
@@ -226,7 +226,7 @@ static unsigned long align_sigframe(unsigned long sp)
 	 * Align the stack pointer according to the i386 ABI,
 	 * i.e. so that on function entry ((sp + 4) & 15) == 0.
 	 */
-	sp = ((sp + 4) & -16ul) - 4;
+	sp = ((sp - 12) & -16ul) - 4;
 #else /* !CONFIG_X86_32 */
 	sp = round_down(sp, 16) - 8;
 #endif
@@ -334,10 +334,9 @@ __setup_frame(int sig, struct ksignal *ksig, sigset_t *set,
 	}
 
 	if (current->mm->context.vdso)
-		restorer = current->mm->context.vdso +
-			vdso_image_32.sym___kernel_sigreturn;
+		restorer = (void __force_user *)(current->mm->context.vdso + vdso_image_32.sym___kernel_sigreturn);
 	else
-		restorer = &frame->retcode;
+		restorer = frame->retcode;
 	if (ksig->ka.sa.sa_flags & SA_RESTORER)
 		restorer = ksig->ka.sa.sa_restorer;
 
@@ -351,7 +350,7 @@ __setup_frame(int sig, struct ksignal *ksig, sigset_t *set,
 	 * reasons and because gdb uses it as a signature to notice
 	 * signal handler stack frames.
 	 */
-	err |= __put_user(*((u64 *)&retcode), (u64 *)frame->retcode);
+	err |= __put_user(*((u64 *)&retcode), (u64 __user *)frame->retcode);
 
 	if (err)
 		return -EFAULT;
@@ -398,8 +397,10 @@ static int __setup_rt_frame(int sig, struct ksignal *ksig,
 		save_altstack_ex(&frame->uc.uc_stack, regs->sp);
 
 		/* Set up to return from userspace.  */
-		restorer = current->mm->context.vdso +
-			vdso_image_32.sym___kernel_rt_sigreturn;
+		if (current->mm->context.vdso)
+			restorer = (void __force_user *)(current->mm->context.vdso + vdso_image_32.sym___kernel_rt_sigreturn);
+		else
+			restorer = (void __user *)&frame->retcode;
 		if (ksig->ka.sa.sa_flags & SA_RESTORER)
 			restorer = ksig->ka.sa.sa_restorer;
 		put_user_ex(restorer, &frame->pretcode);
@@ -411,7 +412,7 @@ static int __setup_rt_frame(int sig, struct ksignal *ksig,
 		 * reasons and because gdb uses it as a signature to notice
 		 * signal handler stack frames.
 		 */
-		put_user_ex(*((u64 *)&rt_retcode), (u64 *)frame->retcode);
+		put_user_ex(*((u64 *)&rt_retcode), (u64 __user *)frame->retcode);
 	} put_user_catch(err);
 	
 	err |= copy_siginfo_to_user(&frame->info, &ksig->info);
diff --git a/arch/x86/kernel/smp.c b/arch/x86/kernel/smp.c
index 658777cf3..6285f8885 100644
--- a/arch/x86/kernel/smp.c
+++ b/arch/x86/kernel/smp.c
@@ -336,7 +336,7 @@ static int __init nonmi_ipi_setup(char *str)
 
 __setup("nonmi_ipi", nonmi_ipi_setup);
 
-struct smp_ops smp_ops = {
+struct smp_ops smp_ops __read_only = {
 	.smp_prepare_boot_cpu	= native_smp_prepare_boot_cpu,
 	.smp_prepare_cpus	= native_smp_prepare_cpus,
 	.smp_cpus_done		= native_smp_cpus_done,
diff --git a/arch/x86/kernel/smpboot.c b/arch/x86/kernel/smpboot.c
index 9e152cdab..60ef5445f 100644
--- a/arch/x86/kernel/smpboot.c
+++ b/arch/x86/kernel/smpboot.c
@@ -225,14 +225,17 @@ static void notrace start_secondary(void *unused)
 
 	enable_start_cpu0 = 0;
 
-#ifdef CONFIG_X86_32
+	/* otherwise gcc will move up smp_processor_id before the cpu_init */
+	barrier();
+
 	/* switch away from the initial page table */
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	load_cr3(get_cpu_pgd(smp_processor_id(), kernel));
+#else
 	load_cr3(swapper_pg_dir);
-	__flush_tlb_all();
 #endif
+	__flush_tlb_all();
 
-	/* otherwise gcc will move up smp_processor_id before the cpu_init */
-	barrier();
 	/*
 	 * Check TSC synchronization with the BP:
 	 */
@@ -935,16 +938,15 @@ void common_cpu_up(unsigned int cpu, struct task_struct *idle)
 	alternatives_enable_smp();
 
 	per_cpu(current_task, cpu) = idle;
+	per_cpu(current_tinfo, cpu) = &idle->tinfo;
 
 #ifdef CONFIG_X86_32
-	/* Stack for startup_32 can be just as for start_secondary onwards */
 	irq_ctx_init(cpu);
-	per_cpu(cpu_current_top_of_stack, cpu) =
-		(unsigned long)task_stack_page(idle) + THREAD_SIZE;
 #else
 	clear_tsk_thread_flag(idle, TIF_FORK);
 	initial_gs = per_cpu_offset(cpu);
 #endif
+	per_cpu(cpu_current_top_of_stack, cpu) = (unsigned long)task_stack_page(idle) - 16 + THREAD_SIZE;
 }
 
 /*
@@ -965,9 +967,11 @@ static int do_boot_cpu(int apicid, int cpu, struct task_struct *idle)
 	unsigned long timeout;
 
 	idle->thread.sp = (unsigned long) (((struct pt_regs *)
-			  (THREAD_SIZE +  task_stack_page(idle))) - 1);
+			  (THREAD_SIZE - 16 + task_stack_page(idle))) - 1);
 
+	pax_open_kernel();
 	early_gdt_descr.address = (unsigned long)get_cpu_gdt_table(cpu);
+	pax_close_kernel();
 	initial_code = (unsigned long)start_secondary;
 	stack_start  = idle->thread.sp;
 
@@ -1115,6 +1119,15 @@ int native_cpu_up(unsigned int cpu, struct task_struct *tidle)
 
 	common_cpu_up(cpu, tidle);
 
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	clone_pgd_range(get_cpu_pgd(cpu, kernel) + KERNEL_PGD_BOUNDARY,
+			swapper_pg_dir + KERNEL_PGD_BOUNDARY,
+			KERNEL_PGD_PTRS);
+	clone_pgd_range(get_cpu_pgd(cpu, user) + KERNEL_PGD_BOUNDARY,
+			swapper_pg_dir + KERNEL_PGD_BOUNDARY,
+			KERNEL_PGD_PTRS);
+#endif
+
 	/*
 	 * We have to walk the irq descriptors to setup the vector
 	 * space for the cpu which comes online.  Prevent irq
diff --git a/arch/x86/kernel/step.c b/arch/x86/kernel/step.c
index c9a073866..3d1b1643e 100644
--- a/arch/x86/kernel/step.c
+++ b/arch/x86/kernel/step.c
@@ -45,7 +45,8 @@ unsigned long convert_ip_to_linear(struct task_struct *child, struct pt_regs *re
 			addr += base;
 		}
 		mutex_unlock(&child->mm->context.lock);
-	}
+	} else if (seg == __KERNEL_CS || seg == __KERNEXEC_KERNEL_CS)
+		addr = ktla_ktva(addr);
 #endif
 
 	return addr;
@@ -57,6 +58,9 @@ static int is_setting_trap_flag(struct task_struct *child, struct pt_regs *regs)
 	unsigned char opcode[15];
 	unsigned long addr = convert_ip_to_linear(child, regs);
 
+	if (addr == -1L)
+		return 0;
+
 	copied = access_process_vm(child, addr, opcode, sizeof(opcode), 0);
 	for (i = 0; i < copied; i++) {
 		switch (opcode[i]) {
diff --git b/arch/x86/kernel/sys_i386_32.c b/arch/x86/kernel/sys_i386_32.c
new file mode 100644
index 000000000..920e41328
--- /dev/null
+++ b/arch/x86/kernel/sys_i386_32.c
@@ -0,0 +1,189 @@
+/*
+ * This file contains various random system calls that
+ * have a non-standard calling sequence on the Linux/i386
+ * platform.
+ */
+
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/fs.h>
+#include <linux/smp.h>
+#include <linux/sem.h>
+#include <linux/msg.h>
+#include <linux/shm.h>
+#include <linux/stat.h>
+#include <linux/syscalls.h>
+#include <linux/mman.h>
+#include <linux/file.h>
+#include <linux/utsname.h>
+#include <linux/ipc.h>
+#include <linux/elf.h>
+
+#include <linux/uaccess.h>
+#include <linux/unistd.h>
+
+#include <asm/syscalls.h>
+
+int i386_mmap_check(unsigned long addr, unsigned long len, unsigned long flags)
+{
+	unsigned long pax_task_size = TASK_SIZE;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (current->mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
+
+	if (flags & MAP_FIXED)
+		if (len > pax_task_size || addr > pax_task_size - len)
+			return -EINVAL;
+
+	return 0;
+}
+
+/*
+ * Align a virtual address to avoid aliasing in the I$ on AMD F15h.
+ */
+static unsigned long get_align_mask(void)
+{
+	if (va_align.flags < 0 || !(va_align.flags & ALIGN_VA_32))
+		return 0;
+
+	if (!(current->flags & PF_RANDOMIZE))
+		return 0;
+
+	return va_align.mask;
+}
+
+unsigned long
+arch_get_unmapped_area(struct file *filp, unsigned long addr,
+		unsigned long len, unsigned long pgoff, unsigned long flags)
+{
+	struct mm_struct *mm = current->mm;
+	struct vm_area_struct *vma;
+	unsigned long pax_task_size = TASK_SIZE;
+	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
+
+	pax_task_size -= PAGE_SIZE;
+
+	if (len > pax_task_size)
+		return -ENOMEM;
+
+	if (flags & MAP_FIXED)
+		return addr;
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
+	if (addr) {
+		addr = PAGE_ALIGN(addr);
+		if (pax_task_size - len >= addr) {
+			vma = find_vma(mm, addr);
+			if (check_heap_stack_gap(vma, addr, len, offset))
+				return addr;
+		}
+	}
+
+	info.flags = 0;
+	info.length = len;
+	info.align_mask = filp ? get_align_mask() : 0;
+	info.align_offset = pgoff << PAGE_SHIFT;
+	info.threadstack_offset = offset;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (!(__supported_pte_mask & _PAGE_NX) && (mm->pax_flags & MF_PAX_PAGEEXEC) && (flags & MAP_EXECUTABLE)) {
+		info.low_limit = 0x00110000UL;
+		info.high_limit = mm->start_code;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += mm->delta_mmap & 0x03FFF000UL;
+#endif
+
+		if (info.low_limit < info.high_limit) {
+			addr = vm_unmapped_area(&info);
+			if (!IS_ERR_VALUE(addr))
+				return addr;
+		}
+	} else
+#endif
+
+	info.low_limit = mm->mmap_base;
+	info.high_limit = pax_task_size;
+
+	return vm_unmapped_area(&info);
+}
+
+unsigned long
+arch_get_unmapped_area_topdown(struct file *filp, unsigned long addr0,
+			  unsigned long len, unsigned long pgoff,
+			  unsigned long flags)
+{
+	struct vm_area_struct *vma;
+	struct mm_struct *mm = current->mm;
+	unsigned long addr = addr0, pax_task_size = TASK_SIZE;
+	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
+
+	pax_task_size -= PAGE_SIZE;
+
+	/* requested length too big for entire address space */
+	if (len > pax_task_size)
+		return -ENOMEM;
+
+	if (flags & MAP_FIXED)
+		return addr;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (!(__supported_pte_mask & _PAGE_NX) && (mm->pax_flags & MF_PAX_PAGEEXEC) && (flags & MAP_EXECUTABLE))
+		goto bottomup;
+#endif
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
+	/* requesting a specific address */
+	if (addr) {
+		addr = PAGE_ALIGN(addr);
+		if (pax_task_size - len >= addr) {
+			vma = find_vma(mm, addr);
+			if (check_heap_stack_gap(vma, addr, len, offset))
+				return addr;
+		}
+	}
+
+	info.flags = VM_UNMAPPED_AREA_TOPDOWN;
+	info.length = len;
+	info.low_limit = PAGE_SIZE;
+	info.high_limit = mm->mmap_base;
+	info.align_mask = filp ? get_align_mask() : 0;
+	info.align_offset = pgoff << PAGE_SHIFT;
+	info.threadstack_offset = offset;
+
+	addr = vm_unmapped_area(&info);
+	if (!(addr & ~PAGE_MASK))
+		return addr;
+	VM_BUG_ON(addr != -ENOMEM);
+
+bottomup:
+	/*
+	 * A failed mmap() very likely causes application failure,
+	 * so fall back to the bottom-up function here. This scenario
+	 * can happen with large stack limits and large mmap()
+	 * allocations.
+	 */
+	return arch_get_unmapped_area(filp, addr0, len, pgoff, flags);
+}
diff --git a/arch/x86/kernel/sys_x86_64.c b/arch/x86/kernel/sys_x86_64.c
index 10e0272d7..a73232fbe 100644
--- a/arch/x86/kernel/sys_x86_64.c
+++ b/arch/x86/kernel/sys_x86_64.c
@@ -97,8 +97,8 @@ out:
 	return error;
 }
 
-static void find_start_end(unsigned long flags, unsigned long *begin,
-			   unsigned long *end)
+static void find_start_end(struct mm_struct *mm, unsigned long flags,
+			   unsigned long *begin, unsigned long *end)
 {
 	if (!test_thread_flag(TIF_ADDR32) && (flags & MAP_32BIT)) {
 		unsigned long new_begin;
@@ -117,7 +117,7 @@ static void find_start_end(unsigned long flags, unsigned long *begin,
 				*begin = new_begin;
 		}
 	} else {
-		*begin = current->mm->mmap_legacy_base;
+		*begin = mm->mmap_legacy_base;
 		*end = TASK_SIZE;
 	}
 }
@@ -130,20 +130,24 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	struct vm_area_struct *vma;
 	struct vm_unmapped_area_info info;
 	unsigned long begin, end;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 
 	if (flags & MAP_FIXED)
 		return addr;
 
-	find_start_end(flags, &begin, &end);
+	find_start_end(mm, flags, &begin, &end);
 
 	if (len > end)
 		return -ENOMEM;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		addr = PAGE_ALIGN(addr);
 		vma = find_vma(mm, addr);
-		if (end - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (end - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -157,18 +161,20 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 		info.align_mask = get_align_mask();
 		info.align_offset += get_align_bits();
 	}
+	info.threadstack_offset = offset;
 	return vm_unmapped_area(&info);
 }
 
 unsigned long
-arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
-			  const unsigned long len, const unsigned long pgoff,
-			  const unsigned long flags)
+arch_get_unmapped_area_topdown(struct file *filp, unsigned long addr0,
+			  unsigned long len, unsigned long pgoff,
+			  unsigned long flags)
 {
 	struct vm_area_struct *vma;
 	struct mm_struct *mm = current->mm;
 	unsigned long addr = addr0;
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 
 	/* requested length too big for entire address space */
 	if (len > TASK_SIZE)
@@ -181,12 +187,15 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	if (!test_thread_flag(TIF_ADDR32) && (flags & MAP_32BIT))
 		goto bottomup;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	/* requesting a specific address */
 	if (addr) {
 		addr = PAGE_ALIGN(addr);
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-				(!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -200,6 +209,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		info.align_mask = get_align_mask();
 		info.align_offset += get_align_bits();
 	}
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 	if (!(addr & ~PAGE_MASK))
 		return addr;
diff --git a/arch/x86/kernel/tboot.c b/arch/x86/kernel/tboot.c
index 654f6c66f..cb648a267 100644
--- a/arch/x86/kernel/tboot.c
+++ b/arch/x86/kernel/tboot.c
@@ -44,6 +44,7 @@
 #include <asm/setup.h>
 #include <asm/e820.h>
 #include <asm/io.h>
+#include <asm/tlbflush.h>
 
 #include "../realmode/rm/wakeup.h"
 
@@ -145,6 +146,10 @@ static int map_tboot_pages(unsigned long vaddr, unsigned long start_pfn,
 	if (!tboot_pg_dir)
 		return -1;
 
+	clone_pgd_range(tboot_pg_dir + KERNEL_PGD_BOUNDARY,
+			swapper_pg_dir + KERNEL_PGD_BOUNDARY,
+			KERNEL_PGD_PTRS);
+
 	for (; nr > 0; nr--, vaddr += PAGE_SIZE, start_pfn++) {
 		if (map_tboot_page(vaddr, start_pfn, PAGE_KERNEL_EXEC))
 			return -1;
@@ -215,8 +220,6 @@ static int tboot_setup_sleep(void)
 
 void tboot_shutdown(u32 shutdown_type)
 {
-	void (*shutdown)(void);
-
 	if (!tboot_enabled())
 		return;
 
@@ -236,9 +239,12 @@ void tboot_shutdown(u32 shutdown_type)
 	tboot->shutdown_type = shutdown_type;
 
 	switch_to_tboot_pt();
+	__write_cr4(__read_cr4() & ~X86_CR4_PCIDE);
 
-	shutdown = (void(*)(void))(unsigned long)tboot->shutdown_entry;
-	shutdown();
+	/*
+	 * PaX: can't be a C indirect function call due to KERNEXEC
+	 */
+	asm volatile("jmp *%0" : : "r"((unsigned long)tboot->shutdown_entry));
 
 	/* should not reach here */
 	while (1)
@@ -304,7 +310,7 @@ static int tboot_extended_sleep(u8 sleep_state, u32 val_a, u32 val_b)
 	return -ENODEV;
 }
 
-static atomic_t ap_wfs_count;
+static atomic_unchecked_t ap_wfs_count;
 
 static int tboot_wait_for_aps(int num_aps)
 {
@@ -325,9 +331,9 @@ static int tboot_wait_for_aps(int num_aps)
 
 static int tboot_dying_cpu(unsigned int cpu)
 {
-	atomic_inc(&ap_wfs_count);
+	atomic_inc_unchecked(&ap_wfs_count);
 	if (num_online_cpus() == 1) {
-		if (tboot_wait_for_aps(atomic_read(&ap_wfs_count)))
+		if (tboot_wait_for_aps(atomic_read_unchecked(&ap_wfs_count)))
 			return -EBUSY;
 	}
 	return 0;
@@ -407,7 +413,7 @@ static __init int tboot_late_init(void)
 
 	tboot_create_trampoline();
 
-	atomic_set(&ap_wfs_count, 0);
+	atomic_set_unchecked(&ap_wfs_count, 0);
 	cpuhp_setup_state(CPUHP_AP_X86_TBOOT_DYING, "AP_X86_TBOOT_DYING", NULL,
 			  tboot_dying_cpu);
 #ifdef CONFIG_DEBUG_FS
diff --git a/arch/x86/kernel/time.c b/arch/x86/kernel/time.c
index d39c09119..1df434906 100644
--- a/arch/x86/kernel/time.c
+++ b/arch/x86/kernel/time.c
@@ -32,7 +32,7 @@ unsigned long profile_pc(struct pt_regs *regs)
 
 	if (!user_mode(regs) && in_lock_functions(pc)) {
 #ifdef CONFIG_FRAME_POINTER
-		return *(unsigned long *)(regs->bp + sizeof(long));
+		return ktla_ktva(*(unsigned long *)(regs->bp + sizeof(long)));
 #else
 		unsigned long *sp =
 			(unsigned long *)kernel_stack_pointer(regs);
@@ -41,11 +41,17 @@ unsigned long profile_pc(struct pt_regs *regs)
 		 * or above a saved flags. Eflags has bits 22-31 zero,
 		 * kernel addresses don't.
 		 */
+
+#ifdef CONFIG_PAX_KERNEXEC
+		return ktla_ktva(sp[0]);
+#else
 		if (sp[0] >> 22)
 			return sp[0];
 		if (sp[1] >> 22)
 			return sp[1];
 #endif
+
+#endif
 	}
 	return pc;
 }
diff --git a/arch/x86/kernel/tls.c b/arch/x86/kernel/tls.c
index 9692a5e9f..aea9fa5f8 100644
--- a/arch/x86/kernel/tls.c
+++ b/arch/x86/kernel/tls.c
@@ -140,6 +140,11 @@ int do_set_thread_area(struct task_struct *p, int idx,
 	if (idx < GDT_ENTRY_TLS_MIN || idx > GDT_ENTRY_TLS_MAX)
 		return -EINVAL;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((p->mm->pax_flags & MF_PAX_SEGMEXEC) && (info.contents & MODIFY_LDT_CONTENTS_CODE))
+		return -EINVAL;
+#endif
+
 	set_tls_desc(p, idx, &info, 1);
 
 	/*
@@ -298,7 +303,7 @@ int regset_tls_set(struct task_struct *target, const struct user_regset *regset,
 
 	if (kbuf)
 		info = kbuf;
-	else if (__copy_from_user(infobuf, ubuf, count))
+	else if (count > sizeof infobuf || __copy_from_user(infobuf, ubuf, count))
 		return -EFAULT;
 	else
 		info = infobuf;
diff --git a/arch/x86/kernel/tracepoint.c b/arch/x86/kernel/tracepoint.c
index 1c113db9e..287b42e46 100644
--- a/arch/x86/kernel/tracepoint.c
+++ b/arch/x86/kernel/tracepoint.c
@@ -9,11 +9,11 @@
 #include <linux/atomic.h>
 
 atomic_t trace_idt_ctr = ATOMIC_INIT(0);
-struct desc_ptr trace_idt_descr = { NR_VECTORS * 16 - 1,
+const struct desc_ptr trace_idt_descr = { NR_VECTORS * 16 - 1,
 				(unsigned long) trace_idt_table };
 
 /* No need to be aligned, but done to keep all IDTs defined the same way. */
-gate_desc trace_idt_table[NR_VECTORS] __page_aligned_bss;
+gate_desc trace_idt_table[NR_VECTORS] __page_aligned_rodata;
 
 static int trace_irq_vector_refcount;
 static DEFINE_MUTEX(irq_vector_mutex);
diff --git a/arch/x86/kernel/traps.c b/arch/x86/kernel/traps.c
index b70ca12dd..2eb147476 100644
--- a/arch/x86/kernel/traps.c
+++ b/arch/x86/kernel/traps.c
@@ -71,7 +71,7 @@
 #include <asm/proto.h>
 
 /* No need to be aligned, but done to keep all IDTs defined the same way. */
-gate_desc debug_idt_table[NR_VECTORS] __page_aligned_bss;
+gate_desc debug_idt_table[NR_VECTORS] __page_aligned_rodata;
 #else
 #include <asm/processor-flags.h>
 #include <asm/setup.h>
@@ -79,7 +79,7 @@ gate_desc debug_idt_table[NR_VECTORS] __page_aligned_bss;
 #endif
 
 /* Must be page-aligned because the real IDT is used in a fixmap. */
-gate_desc idt_table[NR_VECTORS] __page_aligned_bss;
+gate_desc idt_table[NR_VECTORS] __page_aligned_rodata;
 
 DECLARE_BITMAP(used_vectors, NR_VECTORS);
 EXPORT_SYMBOL_GPL(used_vectors);
@@ -169,7 +169,7 @@ void ist_end_non_atomic(void)
 }
 
 static nokprobe_inline int
-do_trap_no_signal(struct task_struct *tsk, int trapnr, char *str,
+do_trap_no_signal(struct task_struct *tsk, int trapnr, const char *str,
 		  struct pt_regs *regs,	long error_code)
 {
 	if (v8086_mode(regs)) {
@@ -189,8 +189,25 @@ do_trap_no_signal(struct task_struct *tsk, int trapnr, char *str,
 		if (!fixup_exception(regs, trapnr)) {
 			tsk->thread.error_code = error_code;
 			tsk->thread.trap_nr = trapnr;
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+			if (trapnr == X86_TRAP_SS && ((regs->cs & 0xFFFF) == __KERNEL_CS || (regs->cs & 0xFFFF) == __KERNEXEC_KERNEL_CS))
+				str = "PAX: suspicious stack segment fault";
+#endif
+
+#ifdef CONFIG_PAX_RAP
+			if (trapnr == X86_TRAP_UD)
+				str = "PAX: overwritten function pointer or return address detected";
+#endif
+
 			die(str, regs, error_code);
 		}
+
+#ifdef CONFIG_PAX_REFCOUNT
+		if (trapnr == X86_REFCOUNT_VECTOR)
+			pax_report_refcount_error(regs, str);
+#endif
+
 		return 0;
 	}
 
@@ -229,7 +246,7 @@ static siginfo_t *fill_trap_info(struct pt_regs *regs, int signr, int trapnr,
 }
 
 static void
-do_trap(int trapnr, int signr, char *str, struct pt_regs *regs,
+do_trap(int trapnr, int signr, const char *str, struct pt_regs *regs,
 	long error_code, siginfo_t *info)
 {
 	struct task_struct *tsk = current;
@@ -252,7 +269,7 @@ do_trap(int trapnr, int signr, char *str, struct pt_regs *regs,
 	if (show_unhandled_signals && unhandled_signal(tsk, signr) &&
 	    printk_ratelimit()) {
 		pr_info("%s[%d] trap %s ip:%lx sp:%lx error:%lx",
-			tsk->comm, tsk->pid, str,
+			tsk->comm, task_pid_nr(tsk), str,
 			regs->ip, regs->sp, error_code);
 		print_vma_addr(" in ", regs->ip);
 		pr_cont("\n");
@@ -262,7 +279,7 @@ do_trap(int trapnr, int signr, char *str, struct pt_regs *regs,
 }
 NOKPROBE_SYMBOL(do_trap);
 
-static void do_error_trap(struct pt_regs *regs, long error_code, char *str,
+static void do_error_trap(struct pt_regs *regs, long error_code, const char *str,
 			  unsigned long trapnr, int signr)
 {
 	siginfo_t info;
@@ -292,6 +309,37 @@ DO_ERROR(X86_TRAP_NP,     SIGBUS,  "segment not present",	segment_not_present)
 DO_ERROR(X86_TRAP_SS,     SIGBUS,  "stack segment",		stack_segment)
 DO_ERROR(X86_TRAP_AC,     SIGBUS,  "alignment check",		alignment_check)
 
+#ifdef CONFIG_PAX_REFCOUNT
+extern char __refcount_overflow_start[], __refcount_overflow_end[];
+extern char __refcount64_overflow_start[], __refcount64_overflow_end[];
+extern char __refcount_underflow_start[], __refcount_underflow_end[];
+extern char __refcount64_underflow_start[], __refcount64_underflow_end[];
+
+dotraplinkage void do_refcount_error(struct pt_regs *regs, long error_code)
+{
+	const char *str = NULL;
+
+	BUG_ON(!(regs->flags & X86_EFLAGS_OF));
+
+#define range_check(size, direction, type, value) \
+	if ((unsigned long)__##size##_##direction##_start <= regs->ip && \
+	    regs->ip < (unsigned long)__##size##_##direction##_end) { \
+		*(type *)regs->cx = value; \
+		str = #size " " #direction; \
+	}
+
+	range_check(refcount,   overflow,  int,       INT_MAX)
+	range_check(refcount64, overflow,  long long, LLONG_MAX)
+	range_check(refcount,   underflow, int,       INT_MIN)
+	range_check(refcount64, underflow, long long, LLONG_MIN)
+
+#undef range_check
+
+	BUG_ON(!str);
+	do_error_trap(regs, error_code, str, X86_REFCOUNT_VECTOR, SIGILL);
+}
+#endif
+
 #ifdef CONFIG_X86_64
 /* Runs on IST stack */
 dotraplinkage void do_double_fault(struct pt_regs *regs, long error_code)
@@ -332,6 +380,11 @@ dotraplinkage void do_double_fault(struct pt_regs *regs, long error_code)
 	tsk->thread.error_code = error_code;
 	tsk->thread.trap_nr = X86_TRAP_DF;
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	if ((unsigned long)tsk->stack - regs->sp <= PAGE_SIZE)
+		die("grsec: kernel stack overflow detected", regs, error_code);	
+#endif
+
 #ifdef CONFIG_DOUBLEFAULT
 	df_debug(regs, error_code);
 #endif
@@ -444,11 +497,35 @@ do_general_protection(struct pt_regs *regs, long error_code)
 		tsk->thread.error_code = error_code;
 		tsk->thread.trap_nr = X86_TRAP_GP;
 		if (notify_die(DIE_GPF, "general protection fault", regs, error_code,
-			       X86_TRAP_GP, SIGSEGV) != NOTIFY_STOP)
+			       X86_TRAP_GP, SIGSEGV) != NOTIFY_STOP) {
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+			if ((regs->cs & 0xFFFF) == __KERNEL_CS || (regs->cs & 0xFFFF) == __KERNEXEC_KERNEL_CS)
+				die("PAX: suspicious general protection fault", regs, error_code);
+			else
+#endif
+
 			die("general protection fault", regs, error_code);
+		}
 		return;
 	}
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_PAGEEXEC)
+	if (!(__supported_pte_mask & _PAGE_NX) && tsk->mm && (tsk->mm->pax_flags & MF_PAX_PAGEEXEC)) {
+		struct mm_struct *mm = tsk->mm;
+		unsigned long limit;
+
+		down_write(&mm->mmap_sem);
+		limit = mm->context.user_cs_limit;
+		if (limit < TASK_SIZE) {
+			track_exec_limit(mm, limit, TASK_SIZE, VM_EXEC);
+			up_write(&mm->mmap_sem);
+			return;
+		}
+		up_write(&mm->mmap_sem);
+	}
+#endif
+
 	tsk->thread.error_code = error_code;
 	tsk->thread.trap_nr = X86_TRAP_GP;
 
@@ -546,6 +623,9 @@ struct bad_iret_stack *fixup_bad_iret(struct bad_iret_stack *s)
 		container_of(task_pt_regs(current),
 			     struct bad_iret_stack, regs);
 
+	if ((current->thread.sp0 ^ (unsigned long)s) < THREAD_SIZE)
+		new_stack = s;
+
 	/* Copy the IRET target to the new stack. */
 	memmove(&new_stack->regs.ip, (void *)s->regs.sp, 5*8);
 
@@ -717,7 +797,7 @@ exit:
 	 * This is the most likely code path that involves non-trivial use
 	 * of the SYSENTER stack.  Check that we haven't overrun it.
 	 */
-	WARN(this_cpu_read(cpu_tss.SYSENTER_stack_canary) != STACK_END_MAGIC,
+	WARN(cpu_tss[raw_smp_processor_id()].SYSENTER_stack_canary != STACK_END_MAGIC,
 	     "Overran or corrupted SYSENTER stack\n");
 #endif
 	ist_exit(regs);
@@ -847,7 +927,7 @@ void __init early_trap_init(void)
 	 * since we don't have trace_debug and it will be reset to
 	 * 'debug' in trap_init() by set_intr_gate_ist().
 	 */
-	set_intr_gate_notrace(X86_TRAP_DB, debug);
+	set_intr_gate_notrace(X86_TRAP_DB, int1);
 	/* int3 can be called from all */
 	set_system_intr_gate(X86_TRAP_BP, &int3);
 #ifdef CONFIG_X86_32
@@ -914,6 +994,11 @@ void __init trap_init(void)
 	set_bit(IA32_SYSCALL_VECTOR, used_vectors);
 #endif
 
+#ifdef CONFIG_PAX_REFCOUNT
+	set_intr_gate(X86_REFCOUNT_VECTOR, refcount_error);
+	set_bit(X86_REFCOUNT_VECTOR, used_vectors);
+#endif
+
 	/*
 	 * Set the IDT descriptor to a fixed read-only location, so that the
 	 * "sidt" instruction will not leak the location of the kernel, and
@@ -932,7 +1017,7 @@ void __init trap_init(void)
 	 * in early_trap_init(). However, ITS works only after
 	 * cpu_init() loads TSS. See comments in early_trap_init().
 	 */
-	set_intr_gate_ist(X86_TRAP_DB, &debug, DEBUG_STACK);
+	set_intr_gate_ist(X86_TRAP_DB, &int1, DEBUG_STACK);
 	/* int3 can be called from all */
 	set_system_intr_gate_ist(X86_TRAP_BP, &int3, DEBUG_STACK);
 
@@ -940,7 +1025,7 @@ void __init trap_init(void)
 
 #ifdef CONFIG_X86_64
 	memcpy(&debug_idt_table, &idt_table, IDT_ENTRIES * 16);
-	set_nmi_gate(X86_TRAP_DB, &debug);
+	set_nmi_gate(X86_TRAP_DB, &int1);
 	set_nmi_gate(X86_TRAP_BP, &int3);
 #endif
 }
diff --git a/arch/x86/kernel/tsc.c b/arch/x86/kernel/tsc.c
index 78b9cb5a2..88ba83a37 100644
--- a/arch/x86/kernel/tsc.c
+++ b/arch/x86/kernel/tsc.c
@@ -23,6 +23,7 @@
 #include <asm/x86_init.h>
 #include <asm/geode.h>
 #include <asm/apic.h>
+#include <asm/pgtable.h>
 
 unsigned int __read_mostly cpu_khz;	/* TSC clocks / usec, not used here */
 EXPORT_SYMBOL(cpu_khz);
@@ -157,7 +158,7 @@ static void cyc2ns_write_end(int cpu, struct cyc2ns_data *data)
 	 */
 	smp_wmb();
 
-	ACCESS_ONCE(c2n->head) = data;
+	ACCESS_ONCE_RW(c2n->head) = data;
 }
 
 /*
@@ -992,7 +993,9 @@ static int time_cpufreq_notifier(struct notifier_block *nb, unsigned long val,
 	}
 	if ((val == CPUFREQ_PRECHANGE  && freq->old < freq->new) ||
 			(val == CPUFREQ_POSTCHANGE && freq->old > freq->new)) {
+		pax_open_kernel();
 		*lpj = cpufreq_scale(loops_per_jiffy_ref, ref_freq, freq->new);
+		pax_close_kernel();
 
 		tsc_khz = cpufreq_scale(tsc_khz_ref, ref_freq, freq->new);
 		if (!(freq->flags & CPUFREQ_CONST_LOOPS))
diff --git a/arch/x86/kernel/uprobes.c b/arch/x86/kernel/uprobes.c
index 495c776de..c0427ef8f 100644
--- a/arch/x86/kernel/uprobes.c
+++ b/arch/x86/kernel/uprobes.c
@@ -287,7 +287,7 @@ static int uprobe_init_insn(struct arch_uprobe *auprobe, struct insn *insn, bool
 {
 	u32 volatile *good_insns;
 
-	insn_init(insn, auprobe->insn, sizeof(auprobe->insn), x86_64);
+	insn_init(insn, (void *)ktva_ktla((unsigned long)auprobe->insn), sizeof(auprobe->insn), x86_64);
 	/* has the side-effect of processing the entire instruction */
 	insn_get_length(insn);
 	if (WARN_ON_ONCE(!insn_complete(insn)))
@@ -978,7 +978,7 @@ arch_uretprobe_hijack_return_addr(unsigned long trampoline_vaddr, struct pt_regs
 
 	if (nleft != rasize) {
 		pr_err("uprobe: return address clobbered: pid=%d, %%sp=%#lx, "
-			"%%ip=%#lx\n", current->pid, regs->sp, regs->ip);
+			"%%ip=%#lx\n", task_pid_nr(current), regs->sp, regs->ip);
 
 		force_sig_info(SIGSEGV, SEND_SIG_FORCED, current);
 	}
diff --git a/arch/x86/kernel/verify_cpu.S b/arch/x86/kernel/verify_cpu.S
index 014ea59aa..03cfe40e4 100644
--- a/arch/x86/kernel/verify_cpu.S
+++ b/arch/x86/kernel/verify_cpu.S
@@ -20,6 +20,7 @@
  *	arch/x86/boot/compressed/head_64.S: Boot cpu verification
  *	arch/x86/kernel/trampoline_64.S: secondary processor verification
  *	arch/x86/kernel/head_32.S: processor startup
+ *	arch/x86/kernel/acpi/realmode/wakeup.S: 32bit processor resume
  *
  *	verify_cpu, returns the status of longmode and SSE in register %eax.
  *		0: Success    1: Failure
diff --git a/arch/x86/kernel/vm86_32.c b/arch/x86/kernel/vm86_32.c
index 01f30e56f..a304a4c76 100644
--- a/arch/x86/kernel/vm86_32.c
+++ b/arch/x86/kernel/vm86_32.c
@@ -144,7 +144,7 @@ void save_v86_state(struct kernel_vm86_regs *regs, int retval)
 		do_exit(SIGSEGV);
 	}
 
-	tss = &per_cpu(cpu_tss, get_cpu());
+	tss = cpu_tss + get_cpu();
 	tsk->thread.sp0 = vm86->saved_sp0;
 	tsk->thread.sysenter_cs = __KERNEL_CS;
 	load_sp0(tss, &tsk->thread);
@@ -176,10 +176,8 @@ static void mark_screen_rdonly(struct mm_struct *mm)
 		goto out;
 	pmd = pmd_offset(pud, 0xA0000);
 
-	if (pmd_trans_huge(*pmd)) {
-		struct vm_area_struct *vma = find_vma(mm, 0xA0000);
-		split_huge_pmd(vma, pmd, 0xA0000);
-	}
+	if (pmd_trans_huge(*pmd))
+		split_huge_pmd(find_vma(mm, 0xA0000), pmd, 0xA0000);
 	if (pmd_none_or_clear_bad(pmd))
 		goto out;
 	pte = pte_offset_map_lock(mm, pmd, 0xA0000, &ptl);
@@ -263,6 +261,13 @@ static long do_sys_vm86(struct vm86plus_struct __user *user_vm86, bool plus)
 		return -EPERM;
 	}
 
+#ifdef CONFIG_GRKERNSEC_VM86
+	if (!capable(CAP_SYS_RAWIO)) {
+		gr_handle_vm86();
+		return -EPERM;
+	}
+#endif
+
 	if (!vm86) {
 		if (!(vm86 = kzalloc(sizeof(*vm86), GFP_KERNEL)))
 			return -ENOMEM;
@@ -358,7 +363,7 @@ static long do_sys_vm86(struct vm86plus_struct __user *user_vm86, bool plus)
 	vm86->saved_sp0 = tsk->thread.sp0;
 	lazy_save_gs(vm86->regs32.gs);
 
-	tss = &per_cpu(cpu_tss, get_cpu());
+	tss = cpu_tss + get_cpu();
 	/* make room for real-mode segments */
 	tsk->thread.sp0 += 16;
 
@@ -538,7 +543,7 @@ static void do_int(struct kernel_vm86_regs *regs, int i,
 		goto cannot_handle;
 	if (i == 0x21 && is_revectored(AH(regs), &vm86->int21_revectored))
 		goto cannot_handle;
-	intr_ptr = (unsigned long __user *) (i << 2);
+	intr_ptr = (unsigned long __force_user *) (i << 2);
 	if (get_user(segoffs, intr_ptr))
 		goto cannot_handle;
 	if ((segoffs >> 16) == BIOSSEG)
@@ -831,6 +836,14 @@ static inline int get_and_reset_irq(int irqnumber)
 static int do_vm86_irq_handling(int subfunction, int irqnumber)
 {
 	int ret;
+
+#ifdef CONFIG_GRKERNSEC_VM86
+	if (!capable(CAP_SYS_RAWIO)) {
+		gr_handle_vm86();
+		return -EPERM;
+	}
+#endif
+
 	switch (subfunction) {
 		case VM86_GET_AND_RESET_IRQ: {
 			return get_and_reset_irq(irqnumber);
diff --git a/arch/x86/kernel/vmlinux.lds.S b/arch/x86/kernel/vmlinux.lds.S
index 9297a002d..3dc41ac30 100644
--- a/arch/x86/kernel/vmlinux.lds.S
+++ b/arch/x86/kernel/vmlinux.lds.S
@@ -26,6 +26,13 @@
 #include <asm/page_types.h>
 #include <asm/cache.h>
 #include <asm/boot.h>
+#include <asm/segment.h>
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+#define __KERNEL_TEXT_OFFSET	(LOAD_OFFSET + ____LOAD_PHYSICAL_ADDR)
+#else
+#define __KERNEL_TEXT_OFFSET	0
+#endif
 
 #undef i386     /* in case the preprocessor is a 32bit one */
 
@@ -68,30 +75,44 @@ jiffies_64 = jiffies;
 
 PHDRS {
 	text PT_LOAD FLAGS(5);          /* R_E */
+#ifdef CONFIG_X86_32
+	module PT_LOAD FLAGS(5);        /* R_E */
+#endif
+#ifdef CONFIG_XEN
+	rodata PT_LOAD FLAGS(5);        /* R_E */
+#else
+	rodata PT_LOAD FLAGS(4);        /* R__ */
+#endif
 	data PT_LOAD FLAGS(6);          /* RW_ */
-#ifdef CONFIG_X86_64
+	init.begin PT_LOAD FLAGS(6);    /* RW_ */
 #ifdef CONFIG_SMP
 	percpu PT_LOAD FLAGS(6);        /* RW_ */
 #endif
-	init PT_LOAD FLAGS(7);          /* RWE */
-#endif
+	text.init PT_LOAD FLAGS(5);     /* R_E */
+	text.exit PT_LOAD FLAGS(5);     /* R_E */
+	init PT_LOAD FLAGS(6);          /* RW_ */
 	note PT_NOTE FLAGS(0);          /* ___ */
 }
 
 SECTIONS
 {
 #ifdef CONFIG_X86_32
-	. = LOAD_OFFSET + LOAD_PHYSICAL_ADDR;
-	phys_startup_32 = ABSOLUTE(startup_32 - LOAD_OFFSET);
+	. = LOAD_OFFSET + ____LOAD_PHYSICAL_ADDR;
 #else
 	. = __START_KERNEL;
-	phys_startup_64 = ABSOLUTE(startup_64 - LOAD_OFFSET);
 #endif
 
 	/* Text and read-only data */
-	.text :  AT(ADDR(.text) - LOAD_OFFSET) {
-		_text = .;
+	.text (. - __KERNEL_TEXT_OFFSET): AT(ADDR(.text) - LOAD_OFFSET + __KERNEL_TEXT_OFFSET) {
 		/* bootstrapping code */
+#ifdef CONFIG_X86_32
+		phys_startup_32 = ABSOLUTE(startup_32 - LOAD_OFFSET + __KERNEL_TEXT_OFFSET);
+		__LOAD_PHYSICAL_ADDR = . - LOAD_OFFSET + __KERNEL_TEXT_OFFSET;
+#else
+		phys_startup_64 = ABSOLUTE(startup_64 - LOAD_OFFSET + __KERNEL_TEXT_OFFSET);
+		__LOAD_PHYSICAL_ADDR = ABSOLUTE(. - LOAD_OFFSET + __KERNEL_TEXT_OFFSET);
+#endif
+		_text = .;
 		HEAD_TEXT
 		. = ALIGN(8);
 		_stext = .;
@@ -104,13 +125,35 @@ SECTIONS
 		SOFTIRQENTRY_TEXT
 		*(.fixup)
 		*(.gnu.warning)
-		/* End of text section */
-		_etext = .;
 	} :text = 0x9090
 
-	NOTES :text :note
+	. += __KERNEL_TEXT_OFFSET;
 
-	EXCEPTION_TABLE(16) :text = 0x9090
+#ifdef CONFIG_X86_32
+	. = ALIGN(PAGE_SIZE);
+	.module.text : AT(ADDR(.module.text) - LOAD_OFFSET) {
+
+#ifdef CONFIG_PAX_KERNEXEC
+		MODULES_EXEC_VADDR = .;
+		BYTE(0)
+		. += (CONFIG_PAX_KERNEXEC_MODULE_TEXT * 1024 * 1024);
+		. = ALIGN(HPAGE_SIZE) - 1;
+		MODULES_EXEC_END = .;
+#endif
+
+	} :module
+#endif
+
+	.text.end : AT(ADDR(.text.end) - LOAD_OFFSET) {
+		/* End of text section */
+		BYTE(0)
+		_etext = . - __KERNEL_TEXT_OFFSET;
+	}
+
+	. = ALIGN(PAGE_SIZE);
+	NOTES :rodata :note
+
+	EXCEPTION_TABLE(16) :rodata
 
 	/* .text should occupy whole number of pages */
 	. = ALIGN(PAGE_SIZE);
@@ -120,16 +163,20 @@ SECTIONS
 
 	/* Data */
 	.data : AT(ADDR(.data) - LOAD_OFFSET) {
+
+#ifdef CONFIG_PAX_KERNEXEC
+		. = ALIGN(HPAGE_SIZE);
+#else
+		. = ALIGN(PAGE_SIZE);
+#endif
+
 		/* Start of data section */
 		_sdata = .;
 
 		/* init_task */
 		INIT_TASK_DATA(THREAD_SIZE)
 
-#ifdef CONFIG_X86_32
-		/* 32 bit has nosave before _edata */
 		NOSAVE_DATA
-#endif
 
 		PAGE_ALIGNED_DATA(PAGE_SIZE)
 
@@ -172,12 +219,19 @@ SECTIONS
        . = ALIGN(__vvar_page + PAGE_SIZE, PAGE_SIZE);
 
 	/* Init code and data - will be freed after init */
-	. = ALIGN(PAGE_SIZE);
 	.init.begin : AT(ADDR(.init.begin) - LOAD_OFFSET) {
+		BYTE(0)
+
+#ifdef CONFIG_PAX_KERNEXEC
+		. = ALIGN(HPAGE_SIZE);
+#else
+		. = ALIGN(PAGE_SIZE);
+#endif
+
 		__init_begin = .; /* paired with __init_end */
-	}
+	} :init.begin
 
-#if defined(CONFIG_X86_64) && defined(CONFIG_SMP)
+#ifdef CONFIG_SMP
 	/*
 	 * percpu offsets are zero-based on SMP.  PERCPU_VADDR() changes the
 	 * output PHDR, so the next output section - .init.text - should
@@ -188,10 +242,13 @@ SECTIONS
 	       "per-CPU data too large - increase CONFIG_PHYSICAL_START")
 #endif
 
-	INIT_TEXT_SECTION(PAGE_SIZE)
-#ifdef CONFIG_X86_64
-	:init
-#endif
+	. = ALIGN(PAGE_SIZE);
+	init_begin = .;
+	.init.text (. - __KERNEL_TEXT_OFFSET): AT(init_begin - LOAD_OFFSET) {
+		VMLINUX_SYMBOL(_sinittext) = .;
+		INIT_TEXT
+		. = ALIGN(PAGE_SIZE);
+	} :text.init
 
 	/*
 	 * Section for code used exclusively before alternatives are run. All
@@ -200,11 +257,29 @@ SECTIONS
 	 *
 	 * See static_cpu_has() for an example.
 	 */
-	.altinstr_aux : AT(ADDR(.altinstr_aux) - LOAD_OFFSET) {
+	.altinstr_aux : AT(ADDR(.altinstr_aux) - LOAD_OFFSET + __KERNEL_TEXT_OFFSET) {
 		*(.altinstr_aux)
 	}
 
-	INIT_DATA_SECTION(16)
+	/*
+	 * .exit.text is discard at runtime, not link time, to deal with
+	 *  references from .altinstructions and .eh_frame
+	 */
+	.exit.text : AT(ADDR(.exit.text) - LOAD_OFFSET + __KERNEL_TEXT_OFFSET) {
+		EXIT_TEXT
+		VMLINUX_SYMBOL(_einittext) = .;
+
+#ifdef CONFIG_PAX_KERNEXEC
+		. = ALIGN(HPAGE_SIZE);
+#else
+		. = ALIGN(16);
+#endif
+
+	} :text.exit
+	. = init_begin + SIZEOF(.init.text) + SIZEOF(.altinstr_aux) + SIZEOF(.exit.text);
+
+	. = ALIGN(PAGE_SIZE);
+	INIT_DATA_SECTION(16) :init
 
 	.x86_cpu_dev.init : AT(ADDR(.x86_cpu_dev.init) - LOAD_OFFSET) {
 		__x86_cpu_dev_start = .;
@@ -275,19 +350,12 @@ SECTIONS
 	}
 
 	. = ALIGN(8);
-	/*
-	 * .exit.text is discard at runtime, not link time, to deal with
-	 *  references from .altinstructions and .eh_frame
-	 */
-	.exit.text : AT(ADDR(.exit.text) - LOAD_OFFSET) {
-		EXIT_TEXT
-	}
 
 	.exit.data : AT(ADDR(.exit.data) - LOAD_OFFSET) {
 		EXIT_DATA
 	}
 
-#if !defined(CONFIG_X86_64) || !defined(CONFIG_SMP)
+#ifndef CONFIG_SMP
 	PERCPU_SECTION(INTERNODE_CACHE_BYTES)
 #endif
 
@@ -306,16 +374,10 @@ SECTIONS
 	.smp_locks : AT(ADDR(.smp_locks) - LOAD_OFFSET) {
 		__smp_locks = .;
 		*(.smp_locks)
-		. = ALIGN(PAGE_SIZE);
 		__smp_locks_end = .;
+		. = ALIGN(PAGE_SIZE);
 	}
 
-#ifdef CONFIG_X86_64
-	.data_nosave : AT(ADDR(.data_nosave) - LOAD_OFFSET) {
-		NOSAVE_DATA
-	}
-#endif
-
 	/* BSS */
 	. = ALIGN(PAGE_SIZE);
 	.bss : AT(ADDR(.bss) - LOAD_OFFSET) {
@@ -331,6 +393,7 @@ SECTIONS
 		__brk_base = .;
 		. += 64 * 1024;		/* 64k alignment slop space */
 		*(.brk_reservation)	/* areas brk users have reserved */
+		. = ALIGN(HPAGE_SIZE);
 		__brk_limit = .;
 	}
 
@@ -361,13 +424,12 @@ SECTIONS
  * for the boot processor.
  */
 #define INIT_PER_CPU(x) init_per_cpu__##x = x + __per_cpu_load
-INIT_PER_CPU(gdt_page);
 INIT_PER_CPU(irq_stack_union);
 
 /*
  * Build-time check on the image size:
  */
-. = ASSERT((_end - _text <= KERNEL_IMAGE_SIZE),
+. = ASSERT((_end - _text - __KERNEL_TEXT_OFFSET <= KERNEL_IMAGE_SIZE),
 	   "kernel image bigger than KERNEL_IMAGE_SIZE");
 
 #ifdef CONFIG_SMP
diff --git a/arch/x86/kernel/x8664_ksyms_64.c b/arch/x86/kernel/x8664_ksyms_64.c
index 95e49f6e4..975337da8 100644
--- a/arch/x86/kernel/x8664_ksyms_64.c
+++ b/arch/x86/kernel/x8664_ksyms_64.c
@@ -35,8 +35,6 @@ EXPORT_SYMBOL(copy_user_generic_string);
 EXPORT_SYMBOL(copy_user_generic_unrolled);
 EXPORT_SYMBOL(copy_user_enhanced_fast_string);
 EXPORT_SYMBOL(__copy_user_nocache);
-EXPORT_SYMBOL(_copy_from_user);
-EXPORT_SYMBOL(_copy_to_user);
 
 EXPORT_SYMBOL_GPL(memcpy_mcsafe);
 
@@ -83,3 +81,7 @@ EXPORT_SYMBOL(native_load_gs_index);
 EXPORT_SYMBOL(___preempt_schedule);
 EXPORT_SYMBOL(___preempt_schedule_notrace);
 #endif
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+EXPORT_SYMBOL(cpu_pgd);
+#endif
diff --git a/arch/x86/kernel/x86_init.c b/arch/x86/kernel/x86_init.c
index 76c5e5243..6f2af84bf 100644
--- a/arch/x86/kernel/x86_init.c
+++ b/arch/x86/kernel/x86_init.c
@@ -91,7 +91,7 @@ struct x86_cpuinit_ops x86_cpuinit = {
 static void default_nmi_init(void) { };
 static int default_i8042_detect(void) { return 1; };
 
-struct x86_platform_ops x86_platform = {
+struct x86_platform_ops x86_platform __read_only = {
 	.calibrate_cpu			= native_calibrate_cpu,
 	.calibrate_tsc			= native_calibrate_tsc,
 	.get_wallclock			= mach_get_cmos_time,
@@ -108,7 +108,7 @@ struct x86_platform_ops x86_platform = {
 EXPORT_SYMBOL_GPL(x86_platform);
 
 #if defined(CONFIG_PCI_MSI)
-struct x86_msi_ops x86_msi = {
+struct x86_msi_ops x86_msi __read_only = {
 	.setup_msi_irqs		= native_setup_msi_irqs,
 	.teardown_msi_irq	= native_teardown_msi_irq,
 	.teardown_msi_irqs	= default_teardown_msi_irqs,
@@ -137,7 +137,7 @@ void arch_restore_msi_irqs(struct pci_dev *dev)
 }
 #endif
 
-struct x86_io_apic_ops x86_io_apic_ops = {
+struct x86_io_apic_ops x86_io_apic_ops __read_only = {
 	.read			= native_io_apic_read,
 	.disable		= native_disable_io_apic,
 };
diff --git a/arch/x86/kvm/cpuid.c b/arch/x86/kvm/cpuid.c
index 3235e0fe7..60b5e7107 100644
--- a/arch/x86/kvm/cpuid.c
+++ b/arch/x86/kvm/cpuid.c
@@ -224,15 +224,20 @@ int kvm_vcpu_ioctl_set_cpuid2(struct kvm_vcpu *vcpu,
 			      struct kvm_cpuid2 *cpuid,
 			      struct kvm_cpuid_entry2 __user *entries)
 {
-	int r;
+	int r, i;
 
 	r = -E2BIG;
 	if (cpuid->nent > KVM_MAX_CPUID_ENTRIES)
 		goto out;
 	r = -EFAULT;
-	if (copy_from_user(&vcpu->arch.cpuid_entries, entries,
-			   cpuid->nent * sizeof(struct kvm_cpuid_entry2)))
+	if (!access_ok(VERIFY_READ, entries, cpuid->nent * sizeof(struct kvm_cpuid_entry2)))
 		goto out;
+	for (i = 0; i < cpuid->nent; ++i) {
+		struct kvm_cpuid_entry2 cpuid_entry;
+		if (__copy_from_user(&cpuid_entry, entries + i, sizeof(cpuid_entry)))
+			goto out;
+		vcpu->arch.cpuid_entries[i] = cpuid_entry;
+	}
 	vcpu->arch.cpuid_nent = cpuid->nent;
 	kvm_apic_set_version(vcpu);
 	kvm_x86_ops->cpuid_update(vcpu);
@@ -245,15 +250,19 @@ int kvm_vcpu_ioctl_get_cpuid2(struct kvm_vcpu *vcpu,
 			      struct kvm_cpuid2 *cpuid,
 			      struct kvm_cpuid_entry2 __user *entries)
 {
-	int r;
+	int r, i;
 
 	r = -E2BIG;
 	if (cpuid->nent < vcpu->arch.cpuid_nent)
 		goto out;
 	r = -EFAULT;
-	if (copy_to_user(entries, &vcpu->arch.cpuid_entries,
-			 vcpu->arch.cpuid_nent * sizeof(struct kvm_cpuid_entry2)))
+	if (!access_ok(VERIFY_WRITE, entries, vcpu->arch.cpuid_nent * sizeof(struct kvm_cpuid_entry2)))
 		goto out;
+	for (i = 0; i < vcpu->arch.cpuid_nent; ++i) {
+		struct kvm_cpuid_entry2 cpuid_entry = vcpu->arch.cpuid_entries[i];
+		if (__copy_to_user(entries + i, &cpuid_entry, sizeof(cpuid_entry)))
+			goto out;
+	}
 	return 0;
 
 out:
diff --git a/arch/x86/kvm/emulate.c b/arch/x86/kvm/emulate.c
index a3ce9d260..0c0ef16ea 100644
--- a/arch/x86/kvm/emulate.c
+++ b/arch/x86/kvm/emulate.c
@@ -971,7 +971,7 @@ static int em_bsr_c(struct x86_emulate_ctxt *ctxt)
 static __always_inline u8 test_cc(unsigned int condition, unsigned long flags)
 {
 	u8 rc;
-	void (*fop)(void) = (void *)em_setcc + 4 * (condition & 0xf);
+	void (*fop)(struct fastop *) = (void *)em_setcc + 4 * (condition & 0xf);
 
 	flags = (flags & EFLAGS_MASK) | X86_EFLAGS_IF;
 	asm("push %[flags]; popf; call *%[fastop]"
@@ -1893,7 +1893,7 @@ static int em_push_sreg(struct x86_emulate_ctxt *ctxt)
 static int em_pop_sreg(struct x86_emulate_ctxt *ctxt)
 {
 	int seg = ctxt->src2.val;
-	unsigned long selector;
+	u16 selector;
 	int rc;
 
 	rc = emulate_pop(ctxt, &selector, 2);
@@ -1905,7 +1905,7 @@ static int em_pop_sreg(struct x86_emulate_ctxt *ctxt)
 	if (ctxt->op_bytes > 2)
 		rsp_increment(ctxt, ctxt->op_bytes - 2);
 
-	rc = load_segment_descriptor(ctxt, (u16)selector, seg);
+	rc = load_segment_descriptor(ctxt, selector, seg);
 	return rc;
 }
 
@@ -3868,7 +3868,7 @@ static int check_cr_write(struct x86_emulate_ctxt *ctxt)
 	int cr = ctxt->modrm_reg;
 	u64 efer = 0;
 
-	static u64 cr_reserved_bits[] = {
+	static const u64 cr_reserved_bits[] = {
 		0xffffffff00000000ULL,
 		0, 0, 0, /* CR3 checked later */
 		CR4_RESERVED_BITS,
@@ -4954,7 +4954,10 @@ done_prefixes:
 	if (ctxt->d == 0)
 		return EMULATION_FAILED;
 
-	ctxt->execute = opcode.u.execute;
+	if (ctxt->d & Fastop)
+		ctxt->u.fastop = opcode.u.fastop;
+	else
+		ctxt->u.execute = opcode.u.execute;
 
 	if (unlikely(ctxt->ud) && likely(!(ctxt->d & EmulateOnUD)))
 		return EMULATION_FAILED;
@@ -5269,15 +5272,14 @@ special_insn:
 	else
 		ctxt->eflags &= ~X86_EFLAGS_RF;
 
-	if (ctxt->execute) {
+	if (ctxt->u.execute) {
 		if (ctxt->d & Fastop) {
-			void (*fop)(struct fastop *) = (void *)ctxt->execute;
-			rc = fastop(ctxt, fop);
+			rc = fastop(ctxt, ctxt->u.fastop);
 			if (rc != X86EMUL_CONTINUE)
 				goto done;
 			goto writeback;
 		}
-		rc = ctxt->execute(ctxt);
+		rc = ctxt->u.execute(ctxt);
 		if (rc != X86EMUL_CONTINUE)
 			goto done;
 		goto writeback;
diff --git a/arch/x86/kvm/i8259.c b/arch/x86/kvm/i8259.c
index 7cc2360f1..6ae123647 100644
--- a/arch/x86/kvm/i8259.c
+++ b/arch/x86/kvm/i8259.c
@@ -39,14 +39,14 @@
 
 static void pic_irq_request(struct kvm *kvm, int level);
 
+static void pic_lock(struct kvm_pic *s) __acquires(&s->lock);
 static void pic_lock(struct kvm_pic *s)
-	__acquires(&s->lock)
 {
 	spin_lock(&s->lock);
 }
 
+static void pic_unlock(struct kvm_pic *s) __releases(&s->lock);
 static void pic_unlock(struct kvm_pic *s)
-	__releases(&s->lock)
 {
 	bool wakeup = s->wakeup_needed;
 	struct kvm_vcpu *vcpu, *found = NULL;
@@ -72,6 +72,7 @@ static void pic_unlock(struct kvm_pic *s)
 	}
 }
 
+static void pic_clear_isr(struct kvm_kpic_state *s, int irq) __must_hold(s->pics_state);
 static void pic_clear_isr(struct kvm_kpic_state *s, int irq)
 {
 	s->isr &= ~(1 << irq);
@@ -219,6 +220,7 @@ void kvm_pic_clear_all(struct kvm_pic *s, int irq_source_id)
 /*
  * acknowledge interrupt 'irq'
  */
+static inline void pic_intack(struct kvm_kpic_state *s, int irq) __must_hold(s);
 static inline void pic_intack(struct kvm_kpic_state *s, int irq)
 {
 	s->isr |= 1 << irq;
@@ -273,6 +275,7 @@ int kvm_pic_read_irq(struct kvm *kvm)
 	return intno;
 }
 
+void kvm_pic_reset(struct kvm_kpic_state *s) __must_hold(s);
 void kvm_pic_reset(struct kvm_kpic_state *s)
 {
 	int irq, i;
@@ -307,6 +310,7 @@ void kvm_pic_reset(struct kvm_kpic_state *s)
 			pic_clear_isr(s, irq);
 }
 
+static void pic_ioport_write(void *opaque, u32 addr, u32 val) __must_hold(opaque);
 static void pic_ioport_write(void *opaque, u32 addr, u32 val)
 {
 	struct kvm_kpic_state *s = opaque;
@@ -400,6 +404,7 @@ static void pic_ioport_write(void *opaque, u32 addr, u32 val)
 		}
 }
 
+static u32 pic_poll_read(struct kvm_kpic_state *s, u32 addr1) __must_hold(s);
 static u32 pic_poll_read(struct kvm_kpic_state *s, u32 addr1)
 {
 	int ret;
@@ -422,6 +427,7 @@ static u32 pic_poll_read(struct kvm_kpic_state *s, u32 addr1)
 	return ret;
 }
 
+static u32 pic_ioport_read(void *opaque, u32 addr1) __must_hold(opaque);
 static u32 pic_ioport_read(void *opaque, u32 addr1)
 {
 	struct kvm_kpic_state *s = opaque;
diff --git a/arch/x86/kvm/ioapic.c b/arch/x86/kvm/ioapic.c
index 6e219e5c0..ccaf11560 100644
--- a/arch/x86/kvm/ioapic.c
+++ b/arch/x86/kvm/ioapic.c
@@ -415,6 +415,8 @@ static void kvm_ioapic_eoi_inject_work(struct work_struct *work)
 #define IOAPIC_SUCCESSIVE_IRQ_MAX_COUNT 10000
 
 static void __kvm_ioapic_update_eoi(struct kvm_vcpu *vcpu,
+			struct kvm_ioapic *ioapic, int vector, int trigger_mode) __must_hold(&ioapic->lock);
+static void __kvm_ioapic_update_eoi(struct kvm_vcpu *vcpu,
 			struct kvm_ioapic *ioapic, int vector, int trigger_mode)
 {
 	struct dest_map *dest_map = &ioapic->rtc_status.dest_map;
diff --git a/arch/x86/kvm/lapic.c b/arch/x86/kvm/lapic.c
index d2255e4f9..65d458a72 100644
--- a/arch/x86/kvm/lapic.c
+++ b/arch/x86/kvm/lapic.c
@@ -57,7 +57,7 @@
 #define APIC_BUS_CYCLE_NS 1
 
 /* #define apic_debug(fmt,arg...) printk(KERN_WARNING fmt,##arg) */
-#define apic_debug(fmt, arg...)
+#define apic_debug(fmt, arg...) do {} while (0)
 
 /* 14 is the version for Xeon and Pentium 8.4.8*/
 #define APIC_VERSION			(0x14UL | ((KVM_APIC_LVT_NUM - 1) << 16))
diff --git a/arch/x86/kvm/paging_tmpl.h b/arch/x86/kvm/paging_tmpl.h
index a01105485..da14b4785 100644
--- a/arch/x86/kvm/paging_tmpl.h
+++ b/arch/x86/kvm/paging_tmpl.h
@@ -355,7 +355,7 @@ retry_walk:
 		if (unlikely(kvm_is_error_hva(host_addr)))
 			goto error;
 
-		ptep_user = (pt_element_t __user *)((void *)host_addr + offset);
+		ptep_user = (pt_element_t __force_user *)((void *)host_addr + offset);
 		if (unlikely(__copy_from_user(&pte, ptep_user, sizeof(pte))))
 			goto error;
 		walker->ptep_user[walker->level - 1] = ptep_user;
diff --git a/arch/x86/kvm/svm.c b/arch/x86/kvm/svm.c
index af523d84d..ba7da48f1 100644
--- a/arch/x86/kvm/svm.c
+++ b/arch/x86/kvm/svm.c
@@ -4120,7 +4120,11 @@ static void reload_tss(struct kvm_vcpu *vcpu)
 	int cpu = raw_smp_processor_id();
 
 	struct svm_cpu_data *sd = per_cpu(svm_data, cpu);
+
+	pax_open_kernel();
 	sd->tss_desc->type = 9; /* available 32/64-bit TSS */
+	pax_close_kernel();
+
 	load_TR_desc();
 }
 
@@ -4559,6 +4563,10 @@ static void svm_vcpu_run(struct kvm_vcpu *vcpu)
 #endif
 #endif
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	__set_fs(current_thread_info()->addr_limit);
+#endif
+
 	reload_tss(vcpu);
 
 	local_irq_disable();
@@ -4961,7 +4969,7 @@ static inline void avic_post_state_restore(struct kvm_vcpu *vcpu)
 	avic_handle_ldr_update(vcpu);
 }
 
-static struct kvm_x86_ops svm_x86_ops = {
+static struct kvm_x86_ops svm_x86_ops __read_only = {
 	.cpu_has_kvm_support = has_svm,
 	.disabled_by_bios = is_disabled,
 	.hardware_setup = svm_hardware_setup,
diff --git a/arch/x86/kvm/vmx.c b/arch/x86/kvm/vmx.c
index 7a72db535..b5f6032b4 100644
--- a/arch/x86/kvm/vmx.c
+++ b/arch/x86/kvm/vmx.c
@@ -1666,14 +1666,14 @@ static __always_inline void vmcs_writel(unsigned long field, unsigned long value
 	__vmcs_writel(field, value);
 }
 
-static __always_inline void vmcs_clear_bits(unsigned long field, u32 mask)
+static __always_inline void vmcs_clear_bits(unsigned long field, unsigned long mask)
 {
         BUILD_BUG_ON_MSG(__builtin_constant_p(field) && ((field) & 0x6000) == 0x2000,
 			 "vmcs_clear_bits does not support 64-bit fields");
 	__vmcs_writel(field, __vmcs_readl(field) & ~mask);
 }
 
-static __always_inline void vmcs_set_bits(unsigned long field, u32 mask)
+static __always_inline void vmcs_set_bits(unsigned long field, unsigned long mask)
 {
         BUILD_BUG_ON_MSG(__builtin_constant_p(field) && ((field) & 0x6000) == 0x2000,
 			 "vmcs_set_bits does not support 64-bit fields");
@@ -1952,7 +1952,11 @@ static void reload_tss(void)
 	struct desc_struct *descs;
 
 	descs = (void *)gdt->address;
+
+	pax_open_kernel();
 	descs[GDT_ENTRY_TSS].type = 9; /* available TSS */
+	pax_close_kernel();
+
 	load_TR_desc();
 }
 
@@ -2256,6 +2260,10 @@ static void vmx_vcpu_load(struct kvm_vcpu *vcpu, int cpu)
 		vmcs_writel(HOST_TR_BASE, kvm_read_tr_base()); /* 22.2.4 */
 		vmcs_writel(HOST_GDTR_BASE, gdt->address);   /* 22.2.4 */
 
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		vmcs_writel(HOST_CR3, read_cr3());  /* 22.2.3  FIXME: shadow tables */
+#endif
+
 		rdmsrl(MSR_IA32_SYSENTER_ESP, sysenter_esp);
 		vmcs_writel(HOST_IA32_SYSENTER_ESP, sysenter_esp); /* 22.2.3 */
 
@@ -2580,7 +2588,7 @@ static void setup_msrs(struct vcpu_vmx *vmx)
  * guest_tsc = (host_tsc * tsc multiplier) >> 48 + tsc_offset
  * -- Intel TSC Scaling for Virtualization White Paper, sec 1.3
  */
-static u64 guest_read_tsc(struct kvm_vcpu *vcpu)
+static u64 __intentional_overflow(-1) guest_read_tsc(struct kvm_vcpu *vcpu)
 {
 	u64 host_tsc, tsc_offset;
 
@@ -4840,7 +4848,10 @@ static void vmx_set_constant_host_state(struct vcpu_vmx *vmx)
 	unsigned long cr4;
 
 	vmcs_writel(HOST_CR0, read_cr0() & ~X86_CR0_TS);  /* 22.2.3 */
+
+#ifndef CONFIG_PAX_PER_CPU_PGD
 	vmcs_writel(HOST_CR3, read_cr3());  /* 22.2.3  FIXME: shadow tables */
+#endif
 
 	/* Save the most likely value for this task's CR4 in the VMCS. */
 	cr4 = cr4_read_shadow();
@@ -4867,7 +4878,7 @@ static void vmx_set_constant_host_state(struct vcpu_vmx *vmx)
 	vmcs_writel(HOST_IDTR_BASE, dt.address);   /* 22.2.4 */
 	vmx->host_idt_base = dt.address;
 
-	vmcs_writel(HOST_RIP, vmx_return); /* 22.2.5 */
+	vmcs_writel(HOST_RIP, ktla_ktva(vmx_return)); /* 22.2.5 */
 
 	rdmsr(MSR_IA32_SYSENTER_CS, low32, high32);
 	vmcs_write32(HOST_IA32_SYSENTER_CS, low32);
@@ -6428,11 +6439,17 @@ static __init int hardware_setup(void)
 	 * page upon invalidation.  No need to do anything if not
 	 * using the APIC_ACCESS_ADDR VMCS field.
 	 */
-	if (!flexpriority_enabled)
+	if (!flexpriority_enabled) {
+		pax_open_kernel();
 		kvm_x86_ops->set_apic_access_page_addr = NULL;
+		pax_close_kernel();
+	}
 
-	if (!cpu_has_vmx_tpr_shadow())
+	if (!cpu_has_vmx_tpr_shadow()) {
+		pax_open_kernel();
 		kvm_x86_ops->update_cr8_intercept = NULL;
+		pax_close_kernel();
+	}
 
 	if (enable_ept && !cpu_has_vmx_ept_2m_page())
 		kvm_disable_largepages();
@@ -6498,10 +6515,12 @@ static __init int hardware_setup(void)
 		enable_pml = 0;
 
 	if (!enable_pml) {
+		pax_open_kernel();
 		kvm_x86_ops->slot_enable_log_dirty = NULL;
 		kvm_x86_ops->slot_disable_log_dirty = NULL;
 		kvm_x86_ops->flush_log_dirty = NULL;
 		kvm_x86_ops->enable_log_dirty_pt_masked = NULL;
+		pax_close_kernel();
 	}
 
 	if (cpu_has_vmx_preemption_timer() && enable_preemption_timer) {
@@ -8889,6 +8908,12 @@ static void __noclone vmx_vcpu_run(struct kvm_vcpu *vcpu)
 		"jmp 2f \n\t"
 		"1: " __ex(ASM_VMX_VMRESUME) "\n\t"
 		"2: "
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		"ljmp %[cs],$3f\n\t"
+		"3: "
+#endif
+
 		/* Save guest registers, load host registers, keep flags */
 		"mov %0, %c[wordsize](%%" _ASM_SP ") \n\t"
 		"pop %0 \n\t"
@@ -8941,6 +8966,11 @@ static void __noclone vmx_vcpu_run(struct kvm_vcpu *vcpu)
 #endif
 		[cr2]"i"(offsetof(struct vcpu_vmx, vcpu.arch.cr2)),
 		[wordsize]"i"(sizeof(ulong))
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		,[cs]"i"(__KERNEL_CS)
+#endif
+
 	      : "cc", "memory"
 #ifdef CONFIG_X86_64
 		, "rax", "rbx", "rdi", "rsi"
@@ -8954,7 +8984,7 @@ static void __noclone vmx_vcpu_run(struct kvm_vcpu *vcpu)
 	if (debugctlmsr)
 		update_debugctlmsr(debugctlmsr);
 
-#ifndef CONFIG_X86_64
+#ifdef CONFIG_X86_32
 	/*
 	 * The sysexit path does not restore ds/es, so we must set them to
 	 * a reasonable value ourselves.
@@ -8963,8 +8993,18 @@ static void __noclone vmx_vcpu_run(struct kvm_vcpu *vcpu)
 	 * may be executed in interrupt context, which saves and restore segments
 	 * around it, nullifying its effect.
 	 */
-	loadsegment(ds, __USER_DS);
-	loadsegment(es, __USER_DS);
+	loadsegment(ds, __KERNEL_DS);
+	loadsegment(es, __KERNEL_DS);
+	loadsegment(ss, __KERNEL_DS);
+
+#ifdef CONFIG_PAX_KERNEXEC
+	loadsegment(fs, __KERNEL_PERCPU);
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	__set_fs(current_thread_info()->addr_limit);
+#endif
+
 #endif
 
 	vcpu->arch.regs_avail = ~((1 << VCPU_REGS_RIP) | (1 << VCPU_REGS_RSP)
@@ -11176,7 +11216,7 @@ static void vmx_setup_mce(struct kvm_vcpu *vcpu)
 			~FEATURE_CONTROL_LMCE;
 }
 
-static struct kvm_x86_ops vmx_x86_ops = {
+static struct kvm_x86_ops vmx_x86_ops __read_only = {
 	.cpu_has_kvm_support = cpu_has_kvm_support,
 	.disabled_by_bios = vmx_disabled_by_bios,
 	.hardware_setup = hardware_setup,
diff --git a/arch/x86/kvm/x86.c b/arch/x86/kvm/x86.c
index 2fff65794..84ea93aaf 100644
--- a/arch/x86/kvm/x86.c
+++ b/arch/x86/kvm/x86.c
@@ -1957,8 +1957,8 @@ static int xen_hvm_config(struct kvm_vcpu *vcpu, u64 data)
 {
 	struct kvm *kvm = vcpu->kvm;
 	int lm = is_long_mode(vcpu);
-	u8 *blob_addr = lm ? (u8 *)(long)kvm->arch.xen_hvm_config.blob_addr_64
-		: (u8 *)(long)kvm->arch.xen_hvm_config.blob_addr_32;
+	u8 __user *blob_addr = lm ? (u8 __user *)(long)kvm->arch.xen_hvm_config.blob_addr_64
+		: (u8 __user *)(long)kvm->arch.xen_hvm_config.blob_addr_32;
 	u8 blob_size = lm ? kvm->arch.xen_hvm_config.blob_size_64
 		: kvm->arch.xen_hvm_config.blob_size_32;
 	u32 page_num = data & ~PAGE_MASK;
@@ -2666,6 +2666,8 @@ long kvm_arch_dev_ioctl(struct file *filp,
 		if (n < msr_list.nmsrs)
 			goto out;
 		r = -EFAULT;
+		if (num_msrs_to_save > ARRAY_SIZE(msrs_to_save))
+			goto out;
 		if (copy_to_user(user_msr_list->indices, &msrs_to_save,
 				 num_msrs_to_save * sizeof(u32)))
 			goto out;
@@ -3082,7 +3084,7 @@ static int kvm_vcpu_ioctl_x86_set_debugregs(struct kvm_vcpu *vcpu,
 
 static void fill_xsave(u8 *dest, struct kvm_vcpu *vcpu)
 {
-	struct xregs_state *xsave = &vcpu->arch.guest_fpu.state.xsave;
+	struct xregs_state *xsave = &vcpu->arch.guest_fpu.state->xsave;
 	u64 xstate_bv = xsave->header.xfeatures;
 	u64 valid;
 
@@ -3118,7 +3120,7 @@ static void fill_xsave(u8 *dest, struct kvm_vcpu *vcpu)
 
 static void load_xsave(struct kvm_vcpu *vcpu, u8 *src)
 {
-	struct xregs_state *xsave = &vcpu->arch.guest_fpu.state.xsave;
+	struct xregs_state *xsave = &vcpu->arch.guest_fpu.state->xsave;
 	u64 xstate_bv = *(u64 *)(src + XSAVE_HDR_OFFSET);
 	u64 valid;
 
@@ -3162,7 +3164,7 @@ static void kvm_vcpu_ioctl_x86_get_xsave(struct kvm_vcpu *vcpu,
 		fill_xsave((u8 *) guest_xsave->region, vcpu);
 	} else {
 		memcpy(guest_xsave->region,
-			&vcpu->arch.guest_fpu.state.fxsave,
+			&vcpu->arch.guest_fpu.state->fxsave,
 			sizeof(struct fxregs_state));
 		*(u64 *)&guest_xsave->region[XSAVE_HDR_OFFSET / sizeof(u32)] =
 			XFEATURE_MASK_FPSSE;
@@ -3187,7 +3189,7 @@ static int kvm_vcpu_ioctl_x86_set_xsave(struct kvm_vcpu *vcpu,
 	} else {
 		if (xstate_bv & ~XFEATURE_MASK_FPSSE)
 			return -EINVAL;
-		memcpy(&vcpu->arch.guest_fpu.state.fxsave,
+		memcpy(&vcpu->arch.guest_fpu.state->fxsave,
 			guest_xsave->region, sizeof(struct fxregs_state));
 	}
 	return 0;
@@ -5751,7 +5753,7 @@ static unsigned long kvm_get_guest_ip(void)
 	unsigned long ip = 0;
 
 	if (__this_cpu_read(current_vcpu))
-		ip = kvm_rip_read(__this_cpu_read(current_vcpu));
+		ip = kvm_get_linear_rip(__this_cpu_read(current_vcpu));
 
 	return ip;
 }
@@ -6474,6 +6476,7 @@ void kvm_arch_mmu_notifier_invalidate_page(struct kvm *kvm,
  * exiting to the userspace.  Otherwise, the value will be returned to the
  * userspace.
  */
+static int vcpu_enter_guest(struct kvm_vcpu *vcpu) __must_hold(&vcpu->kvm->srcu);
 static int vcpu_enter_guest(struct kvm_vcpu *vcpu)
 {
 	int r;
@@ -6749,6 +6752,7 @@ out:
 	return r;
 }
 
+static inline int vcpu_block(struct kvm *kvm, struct kvm_vcpu *vcpu) __must_hold(&kvm->srcu);
 static inline int vcpu_block(struct kvm *kvm, struct kvm_vcpu *vcpu)
 {
 	if (!kvm_arch_vcpu_runnable(vcpu) &&
@@ -7296,7 +7300,7 @@ int kvm_arch_vcpu_ioctl_translate(struct kvm_vcpu *vcpu,
 int kvm_arch_vcpu_ioctl_get_fpu(struct kvm_vcpu *vcpu, struct kvm_fpu *fpu)
 {
 	struct fxregs_state *fxsave =
-			&vcpu->arch.guest_fpu.state.fxsave;
+			&vcpu->arch.guest_fpu.state->fxsave;
 
 	memcpy(fpu->fpr, fxsave->st_space, 128);
 	fpu->fcw = fxsave->cwd;
@@ -7313,7 +7317,7 @@ int kvm_arch_vcpu_ioctl_get_fpu(struct kvm_vcpu *vcpu, struct kvm_fpu *fpu)
 int kvm_arch_vcpu_ioctl_set_fpu(struct kvm_vcpu *vcpu, struct kvm_fpu *fpu)
 {
 	struct fxregs_state *fxsave =
-			&vcpu->arch.guest_fpu.state.fxsave;
+			&vcpu->arch.guest_fpu.state->fxsave;
 
 	memcpy(fxsave->st_space, fpu->fpr, 128);
 	fxsave->cwd = fpu->fcw;
@@ -7329,9 +7333,9 @@ int kvm_arch_vcpu_ioctl_set_fpu(struct kvm_vcpu *vcpu, struct kvm_fpu *fpu)
 
 static void fx_init(struct kvm_vcpu *vcpu)
 {
-	fpstate_init(&vcpu->arch.guest_fpu.state);
+	fpstate_init(vcpu->arch.guest_fpu.state);
 	if (boot_cpu_has(X86_FEATURE_XSAVES))
-		vcpu->arch.guest_fpu.state.xsave.header.xcomp_bv =
+		vcpu->arch.guest_fpu.state->xsave.header.xcomp_bv =
 			host_xcr0 | XSTATE_COMPACTION_ENABLED;
 
 	/*
@@ -7354,7 +7358,7 @@ void kvm_load_guest_fpu(struct kvm_vcpu *vcpu)
 	 */
 	vcpu->guest_fpu_loaded = 1;
 	__kernel_fpu_begin();
-	__copy_kernel_to_fpregs(&vcpu->arch.guest_fpu.state);
+	__copy_kernel_to_fpregs(vcpu->arch.guest_fpu.state);
 	trace_kvm_fpu(1);
 }
 
@@ -7654,6 +7658,8 @@ bool kvm_vcpu_is_bsp(struct kvm_vcpu *vcpu)
 struct static_key kvm_no_apic_vcpu __read_mostly;
 EXPORT_SYMBOL_GPL(kvm_no_apic_vcpu);
 
+extern struct kmem_cache *fpregs_state_cachep;
+
 int kvm_arch_vcpu_init(struct kvm_vcpu *vcpu)
 {
 	struct page *page;
@@ -7671,11 +7677,14 @@ int kvm_arch_vcpu_init(struct kvm_vcpu *vcpu)
 	else
 		vcpu->arch.mp_state = KVM_MP_STATE_UNINITIALIZED;
 
-	page = alloc_page(GFP_KERNEL | __GFP_ZERO);
-	if (!page) {
-		r = -ENOMEM;
+	r = -ENOMEM;
+	vcpu->arch.guest_fpu.state = kmem_cache_alloc(fpregs_state_cachep, GFP_KERNEL);
+	if (!vcpu->arch.guest_fpu.state)
 		goto fail;
-	}
+
+	page = alloc_page(GFP_KERNEL | __GFP_ZERO);
+	if (!page)
+		goto fail_free_fpregs;
 	vcpu->arch.pio_data = page_address(page);
 
 	kvm_set_tsc_khz(vcpu, max_tsc_khz);
@@ -7733,6 +7742,9 @@ fail_mmu_destroy:
 	kvm_mmu_destroy(vcpu);
 fail_free_pio_data:
 	free_page((unsigned long)vcpu->arch.pio_data);
+fail_free_fpregs:
+	kmem_cache_free(fpregs_state_cachep, vcpu->arch.guest_fpu.state);
+	vcpu->arch.guest_fpu.state = NULL;
 fail:
 	return r;
 }
@@ -7751,6 +7763,8 @@ void kvm_arch_vcpu_uninit(struct kvm_vcpu *vcpu)
 	free_page((unsigned long)vcpu->arch.pio_data);
 	if (!lapic_in_kernel(vcpu))
 		static_key_slow_dec(&kvm_no_apic_vcpu);
+	kmem_cache_free(fpregs_state_cachep, vcpu->arch.guest_fpu.state);
+	vcpu->arch.guest_fpu.state = NULL;
 }
 
 void kvm_arch_sched_in(struct kvm_vcpu *vcpu, int cpu)
diff --git a/arch/x86/lguest/boot.c b/arch/x86/lguest/boot.c
index 25da5bc8d..3c3fbd488 100644
--- a/arch/x86/lguest/boot.c
+++ b/arch/x86/lguest/boot.c
@@ -1329,9 +1329,10 @@ static __init int early_put_chars(u32 vtermno, const char *buf, int count)
  * Rebooting also tells the Host we're finished, but the RESTART flag tells the
  * Launcher to reboot us.
  */
-static void lguest_restart(char *reason)
+static __noreturn void lguest_restart(char *reason)
 {
 	hcall(LHCALL_SHUTDOWN, __pa(reason), LGUEST_SHUTDOWN_RESTART, 0, 0);
+	BUG();
 }
 
 /*G:050
diff --git a/arch/x86/lib/Makefile b/arch/x86/lib/Makefile
index 34a74131a..499d0da98 100644
--- a/arch/x86/lib/Makefile
+++ b/arch/x86/lib/Makefile
@@ -29,6 +29,10 @@ lib-$(CONFIG_RANDOMIZE_BASE) += kaslr.o
 obj-y += msr.o msr-reg.o msr-reg-export.o hweight.o
 
 ifeq ($(CONFIG_X86_32),y)
+        CFLAGS_strstr_32.o += $(INITIFY_DISABLE_VERIFY_NOCAPTURE_FUNCTIONS)
+        CFLAGS_string_32.o += $(INITIFY_DISABLE_VERIFY_NOCAPTURE_FUNCTIONS)
+        CFLAGS_memcpy_32.o += $(INITIFY_DISABLE_VERIFY_NOCAPTURE_FUNCTIONS)
+
         obj-y += atomic64_32.o
         lib-y += atomic64_cx8_32.o
         lib-y += checksum_32.o
diff --git a/arch/x86/lib/atomic64_386_32.S b/arch/x86/lib/atomic64_386_32.S
index 9b0ca8fe8..bf83b2c4a 100644
--- a/arch/x86/lib/atomic64_386_32.S
+++ b/arch/x86/lib/atomic64_386_32.S
@@ -10,6 +10,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/irq_vectors.h>
 #include <asm/alternative-asm.h>
 
 /* if you want SMP support, implement these with real spinlocks */
@@ -45,6 +46,10 @@ BEGIN(read)
 	movl  (v), %eax
 	movl 4(v), %edx
 RET_ENDP
+BEGIN(read_unchecked)
+	movl  (v), %eax
+	movl 4(v), %edx
+RET_ENDP
 #undef v
 
 #define v %esi
@@ -52,6 +57,10 @@ BEGIN(set)
 	movl %ebx,  (v)
 	movl %ecx, 4(v)
 RET_ENDP
+BEGIN(set_unchecked)
+	movl %ebx,  (v)
+	movl %ecx, 4(v)
+RET_ENDP
 #undef v
 
 #define v  %esi
@@ -67,6 +76,12 @@ RET_ENDP
 BEGIN(add)
 	addl %eax,  (v)
 	adcl %edx, 4(v)
+
+	PAX_REFCOUNT64_OVERFLOW (v)
+RET_ENDP
+BEGIN(add_unchecked)
+	addl %eax,  (v)
+	adcl %edx, 4(v)
 RET_ENDP
 #undef v
 
@@ -74,6 +89,15 @@ RET_ENDP
 BEGIN(add_return)
 	addl  (v), %eax
 	adcl 4(v), %edx
+
+	movl %eax,  (v)
+	movl %edx, 4(v)
+
+	PAX_REFCOUNT64_OVERFLOW (v)
+RET_ENDP
+BEGIN(add_return_unchecked)
+	addl  (v), %eax
+	adcl 4(v), %edx
 	movl %eax,  (v)
 	movl %edx, 4(v)
 RET_ENDP
@@ -83,6 +107,12 @@ RET_ENDP
 BEGIN(sub)
 	subl %eax,  (v)
 	sbbl %edx, 4(v)
+
+	PAX_REFCOUNT64_UNDERFLOW (v)
+RET_ENDP
+BEGIN(sub_unchecked)
+	subl %eax,  (v)
+	sbbl %edx, 4(v)
 RET_ENDP
 #undef v
 
@@ -93,6 +123,18 @@ BEGIN(sub_return)
 	sbbl $0, %edx
 	addl  (v), %eax
 	adcl 4(v), %edx
+
+	movl %eax,  (v)
+	movl %edx, 4(v)
+
+	PAX_REFCOUNT64_UNDERFLOW (v)
+RET_ENDP
+BEGIN(sub_return_unchecked)
+	negl %edx
+	negl %eax
+	sbbl $0, %edx
+	addl  (v), %eax
+	adcl 4(v), %edx
 	movl %eax,  (v)
 	movl %edx, 4(v)
 RET_ENDP
@@ -102,6 +144,12 @@ RET_ENDP
 BEGIN(inc)
 	addl $1,  (v)
 	adcl $0, 4(v)
+
+	PAX_REFCOUNT64_OVERFLOW (v)
+RET_ENDP
+BEGIN(inc_unchecked)
+	addl $1,  (v)
+	adcl $0, 4(v)
 RET_ENDP
 #undef v
 
@@ -111,6 +159,17 @@ BEGIN(inc_return)
 	movl 4(v), %edx
 	addl $1, %eax
 	adcl $0, %edx
+
+	movl %eax,  (v)
+	movl %edx, 4(v)
+
+	PAX_REFCOUNT64_OVERFLOW (v)
+RET_ENDP
+BEGIN(inc_return_unchecked)
+	movl  (v), %eax
+	movl 4(v), %edx
+	addl $1, %eax
+	adcl $0, %edx
 	movl %eax,  (v)
 	movl %edx, 4(v)
 RET_ENDP
@@ -120,6 +179,12 @@ RET_ENDP
 BEGIN(dec)
 	subl $1,  (v)
 	sbbl $0, 4(v)
+
+	PAX_REFCOUNT64_UNDERFLOW (v)
+RET_ENDP
+BEGIN(dec_unchecked)
+	subl $1,  (v)
+	sbbl $0, 4(v)
 RET_ENDP
 #undef v
 
@@ -129,6 +194,17 @@ BEGIN(dec_return)
 	movl 4(v), %edx
 	subl $1, %eax
 	sbbl $0, %edx
+
+	movl %eax,  (v)
+	movl %edx, 4(v)
+
+	PAX_REFCOUNT64_UNDERFLOW (v)
+RET_ENDP
+BEGIN(dec_return_unchecked)
+	movl  (v), %eax
+	movl 4(v), %edx
+	subl $1, %eax
+	sbbl $0, %edx
 	movl %eax,  (v)
 	movl %edx, 4(v)
 RET_ENDP
@@ -140,6 +216,9 @@ BEGIN(add_unless)
 	adcl %edx, %edi
 	addl  (v), %eax
 	adcl 4(v), %edx
+
+	PAX_REFCOUNT64_OVERFLOW (v)
+
 	cmpl %eax, %ecx
 	je 3f
 1:
@@ -165,6 +244,9 @@ BEGIN(inc_not_zero)
 1:
 	addl $1, %eax
 	adcl $0, %edx
+
+	PAX_REFCOUNT64_OVERFLOW (v)
+
 	movl %eax,  (v)
 	movl %edx, 4(v)
 	movl $1, %eax
@@ -183,6 +265,9 @@ BEGIN(dec_if_positive)
 	movl 4(v), %edx
 	subl $1, %eax
 	sbbl $0, %edx
+
+	PAX_REFCOUNT64_UNDERFLOW (v)
+
 	js 1f
 	movl %eax,  (v)
 	movl %edx, 4(v)
diff --git a/arch/x86/lib/atomic64_cx8_32.S b/arch/x86/lib/atomic64_cx8_32.S
index db3ae8544..3852140d1 100644
--- a/arch/x86/lib/atomic64_cx8_32.S
+++ b/arch/x86/lib/atomic64_cx8_32.S
@@ -10,6 +10,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/irq_vectors.h>
 #include <asm/alternative-asm.h>
 
 .macro read64 reg
@@ -22,9 +23,16 @@
 
 ENTRY(atomic64_read_cx8)
 	read64 %ecx
+	pax_force_retaddr
 	ret
 ENDPROC(atomic64_read_cx8)
 
+ENTRY(atomic64_read_unchecked_cx8)
+	read64 %ecx
+	pax_force_retaddr
+	ret
+ENDPROC(atomic64_read_unchecked_cx8)
+
 ENTRY(atomic64_set_cx8)
 1:
 /* we don't need LOCK_PREFIX since aligned 64-bit writes
@@ -32,20 +40,33 @@ ENTRY(atomic64_set_cx8)
 	cmpxchg8b (%esi)
 	jne 1b
 
+	pax_force_retaddr
 	ret
 ENDPROC(atomic64_set_cx8)
 
+ENTRY(atomic64_set_unchecked_cx8)
+1:
+/* we don't need LOCK_PREFIX since aligned 64-bit writes
+ * are atomic on 586 and newer */
+	cmpxchg8b (%esi)
+	jne 1b
+
+	pax_force_retaddr
+	ret
+ENDPROC(atomic64_set_unchecked_cx8)
+
 ENTRY(atomic64_xchg_cx8)
 1:
 	LOCK_PREFIX
 	cmpxchg8b (%esi)
 	jne 1b
 
+	pax_force_retaddr
 	ret
 ENDPROC(atomic64_xchg_cx8)
 
-.macro addsub_return func ins insc
-ENTRY(atomic64_\func\()_return_cx8)
+.macro addsub_return func ins insc unchecked=""
+ENTRY(atomic64_\func\()_return\unchecked\()_cx8)
 	pushl %ebp
 	pushl %ebx
 	pushl %esi
@@ -61,26 +82,37 @@ ENTRY(atomic64_\func\()_return_cx8)
 	movl %edx, %ecx
 	\ins\()l %esi, %ebx
 	\insc\()l %edi, %ecx
+
+.ifb \unchecked
+.if \func == add
+	PAX_REFCOUNT64_OVERFLOW (%ebp)
+.else
+	PAX_REFCOUNT64_UNDERFLOW (%ebp)
+.endif
+.endif
+
 	LOCK_PREFIX
 	cmpxchg8b (%ebp)
 	jne 1b
-
-10:
 	movl %ebx, %eax
 	movl %ecx, %edx
+
 	popl %edi
 	popl %esi
 	popl %ebx
 	popl %ebp
+	pax_force_retaddr
 	ret
-ENDPROC(atomic64_\func\()_return_cx8)
+ENDPROC(atomic64_\func\()_return\unchecked\()_cx8)
 .endm
 
 addsub_return add add adc
 addsub_return sub sub sbb
+addsub_return add add adc _unchecked
+addsub_return sub sub sbb _unchecked
 
-.macro incdec_return func ins insc
-ENTRY(atomic64_\func\()_return_cx8)
+.macro incdec_return func ins insc unchecked=""
+ENTRY(atomic64_\func\()_return\unchecked\()_cx8)
 	pushl %ebx
 
 	read64 %esi
@@ -89,20 +121,31 @@ ENTRY(atomic64_\func\()_return_cx8)
 	movl %edx, %ecx
 	\ins\()l $1, %ebx
 	\insc\()l $0, %ecx
+
+.ifb \unchecked
+.if \func == inc
+	PAX_REFCOUNT64_OVERFLOW (%esi)
+.else
+	PAX_REFCOUNT64_UNDERFLOW (%esi)
+.endif
+.endif
+
 	LOCK_PREFIX
 	cmpxchg8b (%esi)
 	jne 1b
-
-10:
 	movl %ebx, %eax
 	movl %ecx, %edx
+
 	popl %ebx
+	pax_force_retaddr
 	ret
-ENDPROC(atomic64_\func\()_return_cx8)
+ENDPROC(atomic64_\func\()_return\unchecked\()_cx8)
 .endm
 
 incdec_return inc add adc
 incdec_return dec sub sbb
+incdec_return inc add adc _unchecked
+incdec_return dec sub sbb _unchecked
 
 ENTRY(atomic64_dec_if_positive_cx8)
 	pushl %ebx
@@ -113,6 +156,9 @@ ENTRY(atomic64_dec_if_positive_cx8)
 	movl %edx, %ecx
 	subl $1, %ebx
 	sbb $0, %ecx
+
+	PAX_REFCOUNT64_UNDERFLOW (%esi)
+
 	js 2f
 	LOCK_PREFIX
 	cmpxchg8b (%esi)
@@ -122,6 +168,7 @@ ENTRY(atomic64_dec_if_positive_cx8)
 	movl %ebx, %eax
 	movl %ecx, %edx
 	popl %ebx
+	pax_force_retaddr
 	ret
 ENDPROC(atomic64_dec_if_positive_cx8)
 
@@ -144,6 +191,9 @@ ENTRY(atomic64_add_unless_cx8)
 	movl %edx, %ecx
 	addl %ebp, %ebx
 	adcl %edi, %ecx
+
+	PAX_REFCOUNT64_OVERFLOW (%esi)
+
 	LOCK_PREFIX
 	cmpxchg8b (%esi)
 	jne 1b
@@ -153,6 +203,7 @@ ENTRY(atomic64_add_unless_cx8)
 	addl $8, %esp
 	popl %ebx
 	popl %ebp
+	pax_force_retaddr
 	ret
 4:
 	cmpl %edx, 4(%esp)
@@ -173,6 +224,9 @@ ENTRY(atomic64_inc_not_zero_cx8)
 	xorl %ecx, %ecx
 	addl $1, %ebx
 	adcl %edx, %ecx
+
+	PAX_REFCOUNT64_OVERFLOW (%esi)
+
 	LOCK_PREFIX
 	cmpxchg8b (%esi)
 	jne 1b
@@ -180,5 +234,6 @@ ENTRY(atomic64_inc_not_zero_cx8)
 	movl $1, %eax
 3:
 	popl %ebx
+	pax_force_retaddr
 	ret
 ENDPROC(atomic64_inc_not_zero_cx8)
diff --git a/arch/x86/lib/checksum_32.S b/arch/x86/lib/checksum_32.S
index c1e623209..ebbeba730 100644
--- a/arch/x86/lib/checksum_32.S
+++ b/arch/x86/lib/checksum_32.S
@@ -28,7 +28,8 @@
 #include <linux/linkage.h>
 #include <asm/errno.h>
 #include <asm/asm.h>
-				
+#include <asm/segment.h>
+
 /*
  * computes a partial checksum, e.g. for TCP/UDP fragments
  */
@@ -280,7 +281,22 @@ unsigned int csum_partial_copy_generic (const char *src, char *dst,
 
 #define ARGBASE 16		
 #define FP		12
-		
+
+ENTRY(csum_partial_copy_generic_to_user)
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pushl %gs
+	popl %es
+	jmp csum_partial_copy_generic
+#endif
+
+ENTRY(csum_partial_copy_generic_from_user)
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pushl %gs
+	popl %ds
+#endif
+
 ENTRY(csum_partial_copy_generic)
 	subl  $4,%esp	
 	pushl %edi
@@ -299,7 +315,7 @@ ENTRY(csum_partial_copy_generic)
 	jmp 4f
 SRC(1:	movw (%esi), %bx	)
 	addl $2, %esi
-DST(	movw %bx, (%edi)	)
+DST(	movw %bx, %es:(%edi)	)
 	addl $2, %edi
 	addw %bx, %ax	
 	adcl $0, %eax
@@ -311,30 +327,30 @@ DST(	movw %bx, (%edi)	)
 SRC(1:	movl (%esi), %ebx	)
 SRC(	movl 4(%esi), %edx	)
 	adcl %ebx, %eax
-DST(	movl %ebx, (%edi)	)
+DST(	movl %ebx, %es:(%edi)	)
 	adcl %edx, %eax
-DST(	movl %edx, 4(%edi)	)
+DST(	movl %edx, %es:4(%edi)	)
 
 SRC(	movl 8(%esi), %ebx	)
 SRC(	movl 12(%esi), %edx	)
 	adcl %ebx, %eax
-DST(	movl %ebx, 8(%edi)	)
+DST(	movl %ebx, %es:8(%edi)	)
 	adcl %edx, %eax
-DST(	movl %edx, 12(%edi)	)
+DST(	movl %edx, %es:12(%edi)	)
 
 SRC(	movl 16(%esi), %ebx 	)
 SRC(	movl 20(%esi), %edx	)
 	adcl %ebx, %eax
-DST(	movl %ebx, 16(%edi)	)
+DST(	movl %ebx, %es:16(%edi)	)
 	adcl %edx, %eax
-DST(	movl %edx, 20(%edi)	)
+DST(	movl %edx, %es:20(%edi)	)
 
 SRC(	movl 24(%esi), %ebx	)
 SRC(	movl 28(%esi), %edx	)
 	adcl %ebx, %eax
-DST(	movl %ebx, 24(%edi)	)
+DST(	movl %ebx, %es:24(%edi)	)
 	adcl %edx, %eax
-DST(	movl %edx, 28(%edi)	)
+DST(	movl %edx, %es:28(%edi)	)
 
 	lea 32(%esi), %esi
 	lea 32(%edi), %edi
@@ -348,7 +364,7 @@ DST(	movl %edx, 28(%edi)	)
 	shrl $2, %edx			# This clears CF
 SRC(3:	movl (%esi), %ebx	)
 	adcl %ebx, %eax
-DST(	movl %ebx, (%edi)	)
+DST(	movl %ebx, %es:(%edi)	)
 	lea 4(%esi), %esi
 	lea 4(%edi), %edi
 	dec %edx
@@ -360,12 +376,12 @@ DST(	movl %ebx, (%edi)	)
 	jb 5f
 SRC(	movw (%esi), %cx	)
 	leal 2(%esi), %esi
-DST(	movw %cx, (%edi)	)
+DST(	movw %cx, %es:(%edi)	)
 	leal 2(%edi), %edi
 	je 6f
 	shll $16,%ecx
 SRC(5:	movb (%esi), %cl	)
-DST(	movb %cl, (%edi)	)
+DST(	movb %cl, %es:(%edi)	)
 6:	addl %ecx, %eax
 	adcl $0, %eax
 7:
@@ -376,7 +392,7 @@ DST(	movb %cl, (%edi)	)
 
 6001:
 	movl ARGBASE+20(%esp), %ebx	# src_err_ptr
-	movl $-EFAULT, (%ebx)
+	movl $-EFAULT, %ss:(%ebx)
 
 	# zero the complete destination - computing the rest
 	# is too much work 
@@ -389,34 +405,58 @@ DST(	movb %cl, (%edi)	)
 
 6002:
 	movl ARGBASE+24(%esp), %ebx	# dst_err_ptr
-	movl $-EFAULT,(%ebx)
+	movl $-EFAULT,%ss:(%ebx)
 	jmp 5000b
 
 .previous
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pushl %ss
+	popl %ds
+	pushl %ss
+	popl %es
+#endif
+
 	popl %ebx
 	popl %esi
 	popl %edi
 	popl %ecx			# equivalent to addl $4,%esp
 	ret	
-ENDPROC(csum_partial_copy_generic)
+ENDPROC(csum_partial_copy_generic_to_user)
 
 #else
 
 /* Version for PentiumII/PPro */
 
 #define ROUND1(x) \
+	nop; nop; nop;				\
 	SRC(movl x(%esi), %ebx	)	;	\
 	addl %ebx, %eax			;	\
-	DST(movl %ebx, x(%edi)	)	; 
+	DST(movl %ebx, %es:x(%edi))	;
 
 #define ROUND(x) \
+	nop; nop; nop;				\
 	SRC(movl x(%esi), %ebx	)	;	\
 	adcl %ebx, %eax			;	\
-	DST(movl %ebx, x(%edi)	)	;
+	DST(movl %ebx, %es:x(%edi))	;
 
 #define ARGBASE 12
-		
+
+ENTRY(csum_partial_copy_generic_to_user)
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pushl %gs
+	popl %es
+	jmp csum_partial_copy_generic
+#endif
+
+ENTRY(csum_partial_copy_generic_from_user)
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pushl %gs
+	popl %ds
+#endif
+
 ENTRY(csum_partial_copy_generic)
 	pushl %ebx
 	pushl %edi
@@ -435,7 +475,7 @@ ENTRY(csum_partial_copy_generic)
 	subl %ebx, %edi  
 	lea  -1(%esi),%edx
 	andl $-32,%edx
-	lea 3f(%ebx,%ebx), %ebx
+	lea 3f(%ebx,%ebx,2), %ebx
 	testl %esi, %esi 
 	jmp *%ebx
 1:	addl $64,%esi
@@ -456,19 +496,19 @@ ENTRY(csum_partial_copy_generic)
 	jb 5f
 SRC(	movw (%esi), %dx         )
 	leal 2(%esi), %esi
-DST(	movw %dx, (%edi)         )
+DST(	movw %dx, %es:(%edi)     )
 	leal 2(%edi), %edi
 	je 6f
 	shll $16,%edx
 5:
 SRC(	movb (%esi), %dl         )
-DST(	movb %dl, (%edi)         )
+DST(	movb %dl, %es:(%edi)     )
 6:	addl %edx, %eax
 	adcl $0, %eax
 7:
 .section .fixup, "ax"
 6001:	movl	ARGBASE+20(%esp), %ebx	# src_err_ptr	
-	movl $-EFAULT, (%ebx)
+	movl $-EFAULT, %ss:(%ebx)
 	# zero the complete destination (computing the rest is too much work)
 	movl ARGBASE+8(%esp),%edi	# dst
 	movl ARGBASE+12(%esp),%ecx	# len
@@ -476,15 +516,22 @@ DST(	movb %dl, (%edi)         )
 	rep; stosb
 	jmp 7b
 6002:	movl ARGBASE+24(%esp), %ebx	# dst_err_ptr
-	movl $-EFAULT, (%ebx)
+	movl $-EFAULT, %ss:(%ebx)
 	jmp  7b			
 .previous				
 
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	pushl %ss
+	popl %ds
+	pushl %ss
+	popl %es
+#endif
+
 	popl %esi
 	popl %edi
 	popl %ebx
 	ret
-ENDPROC(csum_partial_copy_generic)
+ENDPROC(csum_partial_copy_generic_to_user)
 				
 #undef ROUND
 #undef ROUND1		
diff --git a/arch/x86/lib/clear_page_64.S b/arch/x86/lib/clear_page_64.S
index 65be7cfaf..d4cb4b43c 100644
--- a/arch/x86/lib/clear_page_64.S
+++ b/arch/x86/lib/clear_page_64.S
@@ -21,6 +21,7 @@ ENTRY(clear_page)
 	movl $4096/8,%ecx
 	xorl %eax,%eax
 	rep stosq
+	pax_force_retaddr
 	ret
 ENDPROC(clear_page)
 
@@ -43,6 +44,7 @@ ENTRY(clear_page_orig)
 	leaq	64(%rdi),%rdi
 	jnz	.Lloop
 	nop
+	pax_force_retaddr
 	ret
 ENDPROC(clear_page_orig)
 
@@ -50,5 +52,6 @@ ENTRY(clear_page_c_e)
 	movl $4096,%ecx
 	xorl %eax,%eax
 	rep stosb
+	pax_force_retaddr
 	ret
 ENDPROC(clear_page_c_e)
diff --git a/arch/x86/lib/cmpxchg16b_emu.S b/arch/x86/lib/cmpxchg16b_emu.S
index 9b330242e..e52ee4469 100644
--- a/arch/x86/lib/cmpxchg16b_emu.S
+++ b/arch/x86/lib/cmpxchg16b_emu.S
@@ -7,6 +7,7 @@
  */
 #include <linux/linkage.h>
 #include <asm/percpu.h>
+#include <asm/alternative-asm.h>
 
 .text
 
@@ -43,11 +44,13 @@ ENTRY(this_cpu_cmpxchg16b_emu)
 
 	popfq
 	mov $1, %al
+	pax_force_retaddr
 	ret
 
 .Lnot_same:
 	popfq
 	xor %al,%al
+	pax_force_retaddr
 	ret
 
 ENDPROC(this_cpu_cmpxchg16b_emu)
diff --git a/arch/x86/lib/copy_page_64.S b/arch/x86/lib/copy_page_64.S
index 24ef1c210..a119ef110 100644
--- a/arch/x86/lib/copy_page_64.S
+++ b/arch/x86/lib/copy_page_64.S
@@ -15,13 +15,14 @@ ENTRY(copy_page)
 	ALTERNATIVE "jmp copy_page_regs", "", X86_FEATURE_REP_GOOD
 	movl	$4096/8, %ecx
 	rep	movsq
+	pax_force_retaddr
 	ret
 ENDPROC(copy_page)
 
 ENTRY(copy_page_regs)
 	subq	$2*8,	%rsp
 	movq	%rbx,	(%rsp)
-	movq	%r12,	1*8(%rsp)
+	movq	%r13,	1*8(%rsp)
 
 	movl	$(4096/64)-5,	%ecx
 	.p2align 4
@@ -34,7 +35,7 @@ ENTRY(copy_page_regs)
 	movq	0x8*4(%rsi), %r9
 	movq	0x8*5(%rsi), %r10
 	movq	0x8*6(%rsi), %r11
-	movq	0x8*7(%rsi), %r12
+	movq	0x8*7(%rsi), %r13
 
 	prefetcht0 5*64(%rsi)
 
@@ -45,7 +46,7 @@ ENTRY(copy_page_regs)
 	movq	%r9,  0x8*4(%rdi)
 	movq	%r10, 0x8*5(%rdi)
 	movq	%r11, 0x8*6(%rdi)
-	movq	%r12, 0x8*7(%rdi)
+	movq	%r13, 0x8*7(%rdi)
 
 	leaq	64 (%rsi), %rsi
 	leaq	64 (%rdi), %rdi
@@ -64,7 +65,7 @@ ENTRY(copy_page_regs)
 	movq	0x8*4(%rsi), %r9
 	movq	0x8*5(%rsi), %r10
 	movq	0x8*6(%rsi), %r11
-	movq	0x8*7(%rsi), %r12
+	movq	0x8*7(%rsi), %r13
 
 	movq	%rax, 0x8*0(%rdi)
 	movq	%rbx, 0x8*1(%rdi)
@@ -73,14 +74,15 @@ ENTRY(copy_page_regs)
 	movq	%r9,  0x8*4(%rdi)
 	movq	%r10, 0x8*5(%rdi)
 	movq	%r11, 0x8*6(%rdi)
-	movq	%r12, 0x8*7(%rdi)
+	movq	%r13, 0x8*7(%rdi)
 
 	leaq	64(%rdi), %rdi
 	leaq	64(%rsi), %rsi
 	jnz	.Loop2
 
 	movq	(%rsp), %rbx
-	movq	1*8(%rsp), %r12
+	movq	1*8(%rsp), %r13
 	addq	$2*8, %rsp
+	pax_force_retaddr
 	ret
 ENDPROC(copy_page_regs)
diff --git a/arch/x86/lib/copy_user_64.S b/arch/x86/lib/copy_user_64.S
index bf603ebbf..5271364c3 100644
--- a/arch/x86/lib/copy_user_64.S
+++ b/arch/x86/lib/copy_user_64.S
@@ -14,51 +14,34 @@
 #include <asm/alternative-asm.h>
 #include <asm/asm.h>
 #include <asm/smap.h>
+#include <asm/pgtable.h>
+#include <asm/frame.h>
 
-/* Standard copy_to_user with segment limit checking */
-ENTRY(_copy_to_user)
-	mov PER_CPU_VAR(current_task), %rax
-	movq %rdi,%rcx
-	addq %rdx,%rcx
-	jc bad_to_user
-	cmpq TASK_addr_limit(%rax),%rcx
-	ja bad_to_user
-	ALTERNATIVE_2 "jmp copy_user_generic_unrolled",		\
-		      "jmp copy_user_generic_string",		\
-		      X86_FEATURE_REP_GOOD,			\
-		      "jmp copy_user_enhanced_fast_string",	\
-		      X86_FEATURE_ERMS
-ENDPROC(_copy_to_user)
-
-/* Standard copy_from_user with segment limit checking */
-ENTRY(_copy_from_user)
-	mov PER_CPU_VAR(current_task), %rax
-	movq %rsi,%rcx
-	addq %rdx,%rcx
-	jc bad_from_user
-	cmpq TASK_addr_limit(%rax),%rcx
-	ja bad_from_user
-	ALTERNATIVE_2 "jmp copy_user_generic_unrolled",		\
-		      "jmp copy_user_generic_string",		\
-		      X86_FEATURE_REP_GOOD,			\
-		      "jmp copy_user_enhanced_fast_string",	\
-		      X86_FEATURE_ERMS
-ENDPROC(_copy_from_user)
-
+.macro ALIGN_DESTINATION
+	/* check for bad alignment of destination */
+	movl %edi,%ecx
+	andl $7,%ecx
+	jz 102f				/* already aligned */
+	subl $8,%ecx
+	negl %ecx
+	subl %ecx,%edx
+100:	movb (%rsi),%al
+101:	movb %al,(%rdi)
+	incq %rsi
+	incq %rdi
+	decl %ecx
+	jnz 100b
+102:
 	.section .fixup,"ax"
-	/* must zero dest */
-ENTRY(bad_from_user)
-bad_from_user:
-	movl %edx,%ecx
-	xorl %eax,%eax
-	rep
-	stosb
-bad_to_user:
-	movl %edx,%eax
-	ret
-ENDPROC(bad_from_user)
+103:	addl %ecx,%edx			/* ecx is zerorest also */
+	FRAME_END
+	jmp copy_user_handle_tail
 	.previous
 
+	_ASM_EXTABLE(100b,103b)
+	_ASM_EXTABLE(101b,103b)
+.endm
+
 /*
  * copy_user_generic_unrolled - memory copy with exception handling.
  * This version is for CPUs like P4 that don't have efficient micro
@@ -73,7 +56,8 @@ ENDPROC(bad_from_user)
  * eax uncopied bytes or 0 if successful.
  */
 ENTRY(copy_user_generic_unrolled)
-	ASM_STAC
+	FRAME_BEGIN
+	ASM_USER_ACCESS_BEGIN
 	cmpl $8,%edx
 	jb 20f		/* less then 8 bytes, go to byte copy loop */
 	ALIGN_DESTINATION
@@ -121,7 +105,9 @@ ENTRY(copy_user_generic_unrolled)
 	decl %ecx
 	jnz 21b
 23:	xor %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 
 	.section .fixup,"ax"
@@ -131,7 +117,8 @@ ENTRY(copy_user_generic_unrolled)
 40:	leal (%rdx,%rcx,8),%edx
 	jmp 60f
 50:	movl %ecx,%edx
-60:	jmp copy_user_handle_tail /* ecx is zerorest also */
+60:	FRAME_END
+	jmp copy_user_handle_tail /* ecx is zerorest also */
 	.previous
 
 	_ASM_EXTABLE(1b,30b)
@@ -175,7 +162,8 @@ ENDPROC(copy_user_generic_unrolled)
  * eax uncopied bytes or 0 if successful.
  */
 ENTRY(copy_user_generic_string)
-	ASM_STAC
+	FRAME_BEGIN
+	ASM_USER_ACCESS_BEGIN
 	cmpl $8,%edx
 	jb 2f		/* less than 8 bytes, go to byte copy loop */
 	ALIGN_DESTINATION
@@ -188,12 +176,15 @@ ENTRY(copy_user_generic_string)
 3:	rep
 	movsb
 	xorl %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 
 	.section .fixup,"ax"
 11:	leal (%rdx,%rcx,8),%ecx
 12:	movl %ecx,%edx		/* ecx is zerorest also */
+	FRAME_END
 	jmp copy_user_handle_tail
 	.previous
 
@@ -214,16 +205,20 @@ ENDPROC(copy_user_generic_string)
  * eax uncopied bytes or 0 if successful.
  */
 ENTRY(copy_user_enhanced_fast_string)
-	ASM_STAC
+	FRAME_BEGIN
+	ASM_USER_ACCESS_BEGIN
 	movl %edx,%ecx
 1:	rep
 	movsb
 	xorl %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 
 	.section .fixup,"ax"
 12:	movl %ecx,%edx		/* ecx is zerorest also */
+	FRAME_END
 	jmp copy_user_handle_tail
 	.previous
 
@@ -240,7 +235,17 @@ ENDPROC(copy_user_enhanced_fast_string)
  *  - Require 4-byte alignment when size is 4 bytes.
  */
 ENTRY(__copy_user_nocache)
-	ASM_STAC
+	FRAME_BEGIN
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	mov pax_user_shadow_base,%rcx
+	cmp %rcx,%rsi
+	jae 1f
+	add %rcx,%rsi
+1:
+#endif
+
+	ASM_USER_ACCESS_BEGIN
 
 	/* If size is less than 8 bytes, go to 4-byte copy */
 	cmpl $8,%edx
@@ -334,8 +339,10 @@ ENTRY(__copy_user_nocache)
 	/* Finished copying; fence the prior stores */
 .L_finish_copy:
 	xorl %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
 	sfence
+	FRAME_END
+	pax_force_retaddr
 	ret
 
 	.section .fixup,"ax"
@@ -353,6 +360,7 @@ ENTRY(__copy_user_nocache)
 	movl %ecx,%edx
 .L_fixup_handle_tail:
 	sfence
+	FRAME_END
 	jmp copy_user_handle_tail
 	.previous
 
diff --git a/arch/x86/lib/csum-copy_64.S b/arch/x86/lib/csum-copy_64.S
index 7e48807b2..cc966ffce 100644
--- a/arch/x86/lib/csum-copy_64.S
+++ b/arch/x86/lib/csum-copy_64.S
@@ -8,6 +8,7 @@
 #include <linux/linkage.h>
 #include <asm/errno.h>
 #include <asm/asm.h>
+#include <asm/alternative-asm.h>
 
 /*
  * Checksum copy with exception handling.
@@ -52,7 +53,7 @@ ENTRY(csum_partial_copy_generic)
 .Lignore:
 	subq  $7*8, %rsp
 	movq  %rbx, 2*8(%rsp)
-	movq  %r12, 3*8(%rsp)
+	movq  %r15, 3*8(%rsp)
 	movq  %r14, 4*8(%rsp)
 	movq  %r13, 5*8(%rsp)
 	movq  %rbp, 6*8(%rsp)
@@ -64,16 +65,16 @@ ENTRY(csum_partial_copy_generic)
 	movl  %edx, %ecx
 
 	xorl  %r9d, %r9d
-	movq  %rcx, %r12
+	movq  %rcx, %r15
 
-	shrq  $6, %r12
+	shrq  $6, %r15
 	jz	.Lhandle_tail       /* < 64 */
 
 	clc
 
 	/* main loop. clear in 64 byte blocks */
 	/* r9: zero, r8: temp2, rbx: temp1, rax: sum, rcx: saved length */
-	/* r11:	temp3, rdx: temp4, r12 loopcnt */
+	/* r11:	temp3, rdx: temp4, r15 loopcnt */
 	/* r10:	temp5, rbp: temp6, r14 temp7, r13 temp8 */
 	.p2align 4
 .Lloop:
@@ -107,7 +108,7 @@ ENTRY(csum_partial_copy_generic)
 	adcq  %r14, %rax
 	adcq  %r13, %rax
 
-	decl %r12d
+	decl %r15d
 
 	dest
 	movq %rbx, (%rsi)
@@ -200,11 +201,12 @@ ENTRY(csum_partial_copy_generic)
 
 .Lende:
 	movq 2*8(%rsp), %rbx
-	movq 3*8(%rsp), %r12
+	movq 3*8(%rsp), %r15
 	movq 4*8(%rsp), %r14
 	movq 5*8(%rsp), %r13
 	movq 6*8(%rsp), %rbp
 	addq $7*8, %rsp
+	pax_force_retaddr
 	ret
 
 	/* Exception handlers. Very simple, zeroing is done in the wrappers */
diff --git a/arch/x86/lib/csum-wrappers_64.c b/arch/x86/lib/csum-wrappers_64.c
index 8bd53589e..a6c9102fd 100644
--- a/arch/x86/lib/csum-wrappers_64.c
+++ b/arch/x86/lib/csum-wrappers_64.c
@@ -53,10 +53,10 @@ csum_partial_copy_from_user(const void __user *src, void *dst,
 			len -= 2;
 		}
 	}
-	stac();
-	isum = csum_partial_copy_generic((__force const void *)src,
+	user_access_begin();
+	isum = csum_partial_copy_generic((const void __force_kernel *)____m(src),
 				dst, len, isum, errp, NULL);
-	clac();
+	user_access_end();
 	if (unlikely(*errp))
 		goto out_err;
 
@@ -110,10 +110,10 @@ csum_partial_copy_to_user(const void *src, void __user *dst,
 	}
 
 	*errp = 0;
-	stac();
-	ret = csum_partial_copy_generic(src, (void __force *)dst,
+	user_access_begin();
+	ret = csum_partial_copy_generic(src, (void __force_kernel *)____m(dst),
 					len, isum, NULL, errp);
-	clac();
+	user_access_end();
 	return ret;
 }
 EXPORT_SYMBOL(csum_partial_copy_to_user);
diff --git a/arch/x86/lib/getuser.S b/arch/x86/lib/getuser.S
index 0ef5128c2..4a52ddc2f 100644
--- a/arch/x86/lib/getuser.S
+++ b/arch/x86/lib/getuser.S
@@ -32,56 +32,127 @@
 #include <asm/thread_info.h>
 #include <asm/asm.h>
 #include <asm/smap.h>
+#include <asm/segment.h>
+#include <asm/pgtable.h>
+#include <asm/frame.h>
+#include <asm/alternative-asm.h>
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define __copyuser_seg gs;
+#else
+#define __copyuser_seg
+#endif
 
 	.text
 ENTRY(__get_user_1)
+	FRAME_BEGIN
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_MEMORY_UDEREF)
 	mov PER_CPU_VAR(current_task), %_ASM_DX
 	cmp TASK_addr_limit(%_ASM_DX),%_ASM_AX
 	jae bad_get_user
-	ASM_STAC
-1:	movzbl (%_ASM_AX),%edx
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov pax_user_shadow_base,%_ASM_DX
+	cmp %_ASM_DX,%_ASM_AX
+	jae 1234f
+	add %_ASM_DX,%_ASM_AX
+1234:
+#endif
+
+#endif
+
+	ASM_USER_ACCESS_BEGIN
+1:	__copyuser_seg movzbl (%_ASM_AX),%edx
 	xor %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(__get_user_1)
 
 ENTRY(__get_user_2)
+	FRAME_BEGIN
 	add $1,%_ASM_AX
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_MEMORY_UDEREF)
 	jc bad_get_user
 	mov PER_CPU_VAR(current_task), %_ASM_DX
 	cmp TASK_addr_limit(%_ASM_DX),%_ASM_AX
 	jae bad_get_user
-	ASM_STAC
-2:	movzwl -1(%_ASM_AX),%edx
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov pax_user_shadow_base,%_ASM_DX
+	cmp %_ASM_DX,%_ASM_AX
+	jae 1234f
+	add %_ASM_DX,%_ASM_AX
+1234:
+#endif
+
+#endif
+
+	ASM_USER_ACCESS_BEGIN
+2:	__copyuser_seg movzwl -1(%_ASM_AX),%edx
 	xor %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(__get_user_2)
 
 ENTRY(__get_user_4)
+	FRAME_BEGIN
 	add $3,%_ASM_AX
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_MEMORY_UDEREF)
 	jc bad_get_user
 	mov PER_CPU_VAR(current_task), %_ASM_DX
 	cmp TASK_addr_limit(%_ASM_DX),%_ASM_AX
 	jae bad_get_user
-	ASM_STAC
-3:	movl -3(%_ASM_AX),%edx
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov pax_user_shadow_base,%_ASM_DX
+	cmp %_ASM_DX,%_ASM_AX
+	jae 1234f
+	add %_ASM_DX,%_ASM_AX
+1234:
+#endif
+
+#endif
+
+	ASM_USER_ACCESS_BEGIN
+3:	__copyuser_seg movl -3(%_ASM_AX),%edx
 	xor %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(__get_user_4)
 
 ENTRY(__get_user_8)
+	FRAME_BEGIN
+
 #ifdef CONFIG_X86_64
 	add $7,%_ASM_AX
 	jc bad_get_user
 	mov PER_CPU_VAR(current_task), %_ASM_DX
 	cmp TASK_addr_limit(%_ASM_DX),%_ASM_AX
 	jae bad_get_user
-	ASM_STAC
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+	mov pax_user_shadow_base,%_ASM_DX
+	cmp %_ASM_DX,%_ASM_AX
+	jae 1234f
+	add %_ASM_DX,%_ASM_AX
+1234:
+#endif
+
+	ASM_USER_ACCESS_BEGIN
 4:	movq -7(%_ASM_AX),%rdx
 	xor %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 #else
 	add $7,%_ASM_AX
@@ -89,11 +160,13 @@ ENTRY(__get_user_8)
 	mov PER_CPU_VAR(current_task), %_ASM_DX
 	cmp TASK_addr_limit(%_ASM_DX),%_ASM_AX
 	jae bad_get_user_8
-	ASM_STAC
-4:	movl -7(%_ASM_AX),%edx
-5:	movl -3(%_ASM_AX),%ecx
+	ASM_USER_ACCESS_BEGIN
+4:	__copyuser_seg movl -7(%_ASM_AX),%edx
+5:	__copyuser_seg movl -3(%_ASM_AX),%ecx
 	xor %eax,%eax
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 #endif
 ENDPROC(__get_user_8)
@@ -102,7 +175,9 @@ ENDPROC(__get_user_8)
 bad_get_user:
 	xor %edx,%edx
 	mov $(-EFAULT),%_ASM_AX
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 END(bad_get_user)
 
@@ -111,7 +186,9 @@ bad_get_user_8:
 	xor %edx,%edx
 	xor %ecx,%ecx
 	mov $(-EFAULT),%_ASM_AX
-	ASM_CLAC
+	ASM_USER_ACCESS_END
+	FRAME_END
+	pax_force_retaddr
 	ret
 END(bad_get_user_8)
 #endif
diff --git a/arch/x86/lib/insn.c b/arch/x86/lib/insn.c
index 1088eb8f3..fac84689c 100644
--- a/arch/x86/lib/insn.c
+++ b/arch/x86/lib/insn.c
@@ -20,8 +20,10 @@
 
 #ifdef __KERNEL__
 #include <linux/string.h>
+#include <asm/pgtable_types.h>
 #else
 #include <string.h>
+#define ktla_ktva(addr) addr
 #endif
 #include <asm/inat.h>
 #include <asm/insn.h>
@@ -60,9 +62,9 @@ void insn_init(struct insn *insn, const void *kaddr, int buf_len, int x86_64)
 		buf_len = MAX_INSN_SIZE;
 
 	memset(insn, 0, sizeof(*insn));
-	insn->kaddr = kaddr;
-	insn->end_kaddr = kaddr + buf_len;
-	insn->next_byte = kaddr;
+	insn->kaddr = (void *)ktla_ktva((unsigned long)kaddr);
+	insn->end_kaddr = insn->kaddr + buf_len;
+	insn->next_byte = insn->kaddr;
 	insn->x86_64 = x86_64 ? 1 : 0;
 	insn->opnd_bytes = 4;
 	if (x86_64)
diff --git a/arch/x86/lib/iomap_copy_64.S b/arch/x86/lib/iomap_copy_64.S
index 33147fef3..12a8815fa 100644
--- a/arch/x86/lib/iomap_copy_64.S
+++ b/arch/x86/lib/iomap_copy_64.S
@@ -16,6 +16,7 @@
  */
 
 #include <linux/linkage.h>
+#include <asm/alternative-asm.h>
 
 /*
  * override generic version in lib/iomap_copy.c
@@ -23,5 +24,6 @@
 ENTRY(__iowrite32_copy)
 	movl %edx,%ecx
 	rep movsd
+	pax_force_retaddr
 	ret
 ENDPROC(__iowrite32_copy)
diff --git a/arch/x86/lib/memcpy_64.S b/arch/x86/lib/memcpy_64.S
index 2ec0b0abb..3e02ccd1a 100644
--- a/arch/x86/lib/memcpy_64.S
+++ b/arch/x86/lib/memcpy_64.S
@@ -37,6 +37,7 @@ ENTRY(memcpy)
 	rep movsq
 	movl %edx, %ecx
 	rep movsb
+	pax_force_retaddr
 	ret
 ENDPROC(memcpy)
 ENDPROC(__memcpy)
@@ -49,6 +50,7 @@ ENTRY(memcpy_erms)
 	movq %rdi, %rax
 	movq %rdx, %rcx
 	rep movsb
+	pax_force_retaddr
 	ret
 ENDPROC(memcpy_erms)
 
@@ -133,6 +135,7 @@ ENTRY(memcpy_orig)
 	movq %r9,	1*8(%rdi)
 	movq %r10,	-2*8(%rdi, %rdx)
 	movq %r11,	-1*8(%rdi, %rdx)
+	pax_force_retaddr
 	retq
 	.p2align 4
 .Lless_16bytes:
@@ -145,6 +148,7 @@ ENTRY(memcpy_orig)
 	movq -1*8(%rsi, %rdx),	%r9
 	movq %r8,	0*8(%rdi)
 	movq %r9,	-1*8(%rdi, %rdx)
+	pax_force_retaddr
 	retq
 	.p2align 4
 .Lless_8bytes:
@@ -158,6 +162,7 @@ ENTRY(memcpy_orig)
 	movl -4(%rsi, %rdx), %r8d
 	movl %ecx, (%rdi)
 	movl %r8d, -4(%rdi, %rdx)
+	pax_force_retaddr
 	retq
 	.p2align 4
 .Lless_3bytes:
@@ -176,6 +181,7 @@ ENTRY(memcpy_orig)
 	movb %cl, (%rdi)
 
 .Lend:
+	pax_force_retaddr
 	retq
 ENDPROC(memcpy_orig)
 
diff --git a/arch/x86/lib/memmove_64.S b/arch/x86/lib/memmove_64.S
index 90ce01bee..8817b347c 100644
--- a/arch/x86/lib/memmove_64.S
+++ b/arch/x86/lib/memmove_64.S
@@ -41,7 +41,7 @@ ENTRY(__memmove)
 	jg 2f
 
 .Lmemmove_begin_forward:
-	ALTERNATIVE "", "movq %rdx, %rcx; rep movsb; retq", X86_FEATURE_ERMS
+	ALTERNATIVE "", "movq %rdx, %rcx; rep movsb; pax_force_retaddr; retq", X86_FEATURE_ERMS
 
 	/*
 	 * movsq instruction have many startup latency
@@ -204,6 +204,7 @@ ENTRY(__memmove)
 	movb (%rsi), %r11b
 	movb %r11b, (%rdi)
 13:
+	pax_force_retaddr
 	retq
 ENDPROC(__memmove)
 ENDPROC(memmove)
diff --git a/arch/x86/lib/memset_64.S b/arch/x86/lib/memset_64.S
index e1229ecd2..2ca5a7ae8 100644
--- a/arch/x86/lib/memset_64.S
+++ b/arch/x86/lib/memset_64.S
@@ -40,6 +40,7 @@ ENTRY(__memset)
 	movl %edx,%ecx
 	rep stosb
 	movq %r9,%rax
+	pax_force_retaddr
 	ret
 ENDPROC(memset)
 ENDPROC(__memset)
@@ -61,6 +62,7 @@ ENTRY(memset_erms)
 	movq %rdx,%rcx
 	rep stosb
 	movq %r9,%rax
+	pax_force_retaddr
 	ret
 ENDPROC(memset_erms)
 
@@ -123,6 +125,7 @@ ENTRY(memset_orig)
 
 .Lende:
 	movq	%r10,%rax
+	pax_force_retaddr
 	ret
 
 .Lbad_alignment:
diff --git a/arch/x86/lib/mmx_32.c b/arch/x86/lib/mmx_32.c
index c2311a678..3b01ad91b 100644
--- a/arch/x86/lib/mmx_32.c
+++ b/arch/x86/lib/mmx_32.c
@@ -29,6 +29,7 @@ void *_mmx_memcpy(void *to, const void *from, size_t len)
 {
 	void *p;
 	int i;
+	unsigned long cr0;
 
 	if (unlikely(in_interrupt()))
 		return __memcpy(to, from, len);
@@ -39,44 +40,72 @@ void *_mmx_memcpy(void *to, const void *from, size_t len)
 	kernel_fpu_begin();
 
 	__asm__ __volatile__ (
-		"1: prefetch (%0)\n"		/* This set is 28 bytes */
-		"   prefetch 64(%0)\n"
-		"   prefetch 128(%0)\n"
-		"   prefetch 192(%0)\n"
-		"   prefetch 256(%0)\n"
+		"1: prefetch (%1)\n"		/* This set is 28 bytes */
+		"   prefetch 64(%1)\n"
+		"   prefetch 128(%1)\n"
+		"   prefetch 192(%1)\n"
+		"   prefetch 256(%1)\n"
 		"2:  \n"
 		".section .fixup, \"ax\"\n"
-		"3: movw $0x1AEB, 1b\n"	/* jmp on 26 bytes */
+		"3:  \n"
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %%cr0, %0\n"
+		"   movl %0, %%eax\n"
+		"   andl $0xFFFEFFFF, %%eax\n"
+		"   movl %%eax, %%cr0\n"
+#endif
+
+		"   movw $0x1AEB, 1b\n"	/* jmp on 26 bytes */
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %0, %%cr0\n"
+#endif
+
 		"   jmp 2b\n"
 		".previous\n"
 			_ASM_EXTABLE(1b, 3b)
-			: : "r" (from));
+			: "=&r" (cr0) : "r" (from) : "ax");
 
 	for ( ; i > 5; i--) {
 		__asm__ __volatile__ (
-		"1:  prefetch 320(%0)\n"
-		"2:  movq (%0), %%mm0\n"
-		"  movq 8(%0), %%mm1\n"
-		"  movq 16(%0), %%mm2\n"
-		"  movq 24(%0), %%mm3\n"
-		"  movq %%mm0, (%1)\n"
-		"  movq %%mm1, 8(%1)\n"
-		"  movq %%mm2, 16(%1)\n"
-		"  movq %%mm3, 24(%1)\n"
-		"  movq 32(%0), %%mm0\n"
-		"  movq 40(%0), %%mm1\n"
-		"  movq 48(%0), %%mm2\n"
-		"  movq 56(%0), %%mm3\n"
-		"  movq %%mm0, 32(%1)\n"
-		"  movq %%mm1, 40(%1)\n"
-		"  movq %%mm2, 48(%1)\n"
-		"  movq %%mm3, 56(%1)\n"
+		"1:  prefetch 320(%1)\n"
+		"2:  movq (%1), %%mm0\n"
+		"  movq 8(%1), %%mm1\n"
+		"  movq 16(%1), %%mm2\n"
+		"  movq 24(%1), %%mm3\n"
+		"  movq %%mm0, (%2)\n"
+		"  movq %%mm1, 8(%2)\n"
+		"  movq %%mm2, 16(%2)\n"
+		"  movq %%mm3, 24(%2)\n"
+		"  movq 32(%1), %%mm0\n"
+		"  movq 40(%1), %%mm1\n"
+		"  movq 48(%1), %%mm2\n"
+		"  movq 56(%1), %%mm3\n"
+		"  movq %%mm0, 32(%2)\n"
+		"  movq %%mm1, 40(%2)\n"
+		"  movq %%mm2, 48(%2)\n"
+		"  movq %%mm3, 56(%2)\n"
 		".section .fixup, \"ax\"\n"
-		"3: movw $0x05EB, 1b\n"	/* jmp on 5 bytes */
+		"3:\n"
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %%cr0, %0\n"
+		"   movl %0, %%eax\n"
+		"   andl $0xFFFEFFFF, %%eax\n"
+		"   movl %%eax, %%cr0\n"
+#endif
+
+		"   movw $0x05EB, 1b\n"	/* jmp on 5 bytes */
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %0, %%cr0\n"
+#endif
+
 		"   jmp 2b\n"
 		".previous\n"
 			_ASM_EXTABLE(1b, 3b)
-			: : "r" (from), "r" (to) : "memory");
+			: "=&r" (cr0) : "r" (from), "r" (to) : "memory", "ax");
 
 		from += 64;
 		to += 64;
@@ -158,6 +187,7 @@ static void fast_clear_page(void *page)
 static void fast_copy_page(void *to, void *from)
 {
 	int i;
+	unsigned long cr0;
 
 	kernel_fpu_begin();
 
@@ -166,42 +196,70 @@ static void fast_copy_page(void *to, void *from)
 	 * but that is for later. -AV
 	 */
 	__asm__ __volatile__(
-		"1: prefetch (%0)\n"
-		"   prefetch 64(%0)\n"
-		"   prefetch 128(%0)\n"
-		"   prefetch 192(%0)\n"
-		"   prefetch 256(%0)\n"
+		"1: prefetch (%1)\n"
+		"   prefetch 64(%1)\n"
+		"   prefetch 128(%1)\n"
+		"   prefetch 192(%1)\n"
+		"   prefetch 256(%1)\n"
 		"2:  \n"
 		".section .fixup, \"ax\"\n"
-		"3: movw $0x1AEB, 1b\n"	/* jmp on 26 bytes */
+		"3:  \n"
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %%cr0, %0\n"
+		"   movl %0, %%eax\n"
+		"   andl $0xFFFEFFFF, %%eax\n"
+		"   movl %%eax, %%cr0\n"
+#endif
+
+		"   movw $0x1AEB, 1b\n"	/* jmp on 26 bytes */
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %0, %%cr0\n"
+#endif
+
 		"   jmp 2b\n"
 		".previous\n"
-			_ASM_EXTABLE(1b, 3b) : : "r" (from));
+			_ASM_EXTABLE(1b, 3b) : "=&r" (cr0) : "r" (from) : "ax");
 
 	for (i = 0; i < (4096-320)/64; i++) {
 		__asm__ __volatile__ (
-		"1: prefetch 320(%0)\n"
-		"2: movq (%0), %%mm0\n"
-		"   movntq %%mm0, (%1)\n"
-		"   movq 8(%0), %%mm1\n"
-		"   movntq %%mm1, 8(%1)\n"
-		"   movq 16(%0), %%mm2\n"
-		"   movntq %%mm2, 16(%1)\n"
-		"   movq 24(%0), %%mm3\n"
-		"   movntq %%mm3, 24(%1)\n"
-		"   movq 32(%0), %%mm4\n"
-		"   movntq %%mm4, 32(%1)\n"
-		"   movq 40(%0), %%mm5\n"
-		"   movntq %%mm5, 40(%1)\n"
-		"   movq 48(%0), %%mm6\n"
-		"   movntq %%mm6, 48(%1)\n"
-		"   movq 56(%0), %%mm7\n"
-		"   movntq %%mm7, 56(%1)\n"
+		"1: prefetch 320(%1)\n"
+		"2: movq (%1), %%mm0\n"
+		"   movntq %%mm0, (%2)\n"
+		"   movq 8(%1), %%mm1\n"
+		"   movntq %%mm1, 8(%2)\n"
+		"   movq 16(%1), %%mm2\n"
+		"   movntq %%mm2, 16(%2)\n"
+		"   movq 24(%1), %%mm3\n"
+		"   movntq %%mm3, 24(%2)\n"
+		"   movq 32(%1), %%mm4\n"
+		"   movntq %%mm4, 32(%2)\n"
+		"   movq 40(%1), %%mm5\n"
+		"   movntq %%mm5, 40(%2)\n"
+		"   movq 48(%1), %%mm6\n"
+		"   movntq %%mm6, 48(%2)\n"
+		"   movq 56(%1), %%mm7\n"
+		"   movntq %%mm7, 56(%2)\n"
 		".section .fixup, \"ax\"\n"
-		"3: movw $0x05EB, 1b\n"	/* jmp on 5 bytes */
+		"3:\n"
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %%cr0, %0\n"
+		"   movl %0, %%eax\n"
+		"   andl $0xFFFEFFFF, %%eax\n"
+		"   movl %%eax, %%cr0\n"
+#endif
+
+		"   movw $0x05EB, 1b\n"	/* jmp on 5 bytes */
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %0, %%cr0\n"
+#endif
+
 		"   jmp 2b\n"
 		".previous\n"
-		_ASM_EXTABLE(1b, 3b) : : "r" (from), "r" (to) : "memory");
+		_ASM_EXTABLE(1b, 3b) : "=&r" (cr0) : "r" (from), "r" (to) : "memory", "ax");
 
 		from += 64;
 		to += 64;
@@ -280,47 +338,76 @@ static void fast_clear_page(void *page)
 static void fast_copy_page(void *to, void *from)
 {
 	int i;
+	unsigned long cr0;
 
 	kernel_fpu_begin();
 
 	__asm__ __volatile__ (
-		"1: prefetch (%0)\n"
-		"   prefetch 64(%0)\n"
-		"   prefetch 128(%0)\n"
-		"   prefetch 192(%0)\n"
-		"   prefetch 256(%0)\n"
+		"1: prefetch (%1)\n"
+		"   prefetch 64(%1)\n"
+		"   prefetch 128(%1)\n"
+		"   prefetch 192(%1)\n"
+		"   prefetch 256(%1)\n"
 		"2:  \n"
 		".section .fixup, \"ax\"\n"
-		"3: movw $0x1AEB, 1b\n"	/* jmp on 26 bytes */
+		"3:  \n"
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %%cr0, %0\n"
+		"   movl %0, %%eax\n"
+		"   andl $0xFFFEFFFF, %%eax\n"
+		"   movl %%eax, %%cr0\n"
+#endif
+
+		"   movw $0x1AEB, 1b\n"	/* jmp on 26 bytes */
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %0, %%cr0\n"
+#endif
+
 		"   jmp 2b\n"
 		".previous\n"
-			_ASM_EXTABLE(1b, 3b) : : "r" (from));
+			_ASM_EXTABLE(1b, 3b) : "=&r" (cr0) : "r" (from) : "ax");
 
 	for (i = 0; i < 4096/64; i++) {
 		__asm__ __volatile__ (
-		"1: prefetch 320(%0)\n"
-		"2: movq (%0), %%mm0\n"
-		"   movq 8(%0), %%mm1\n"
-		"   movq 16(%0), %%mm2\n"
-		"   movq 24(%0), %%mm3\n"
-		"   movq %%mm0, (%1)\n"
-		"   movq %%mm1, 8(%1)\n"
-		"   movq %%mm2, 16(%1)\n"
-		"   movq %%mm3, 24(%1)\n"
-		"   movq 32(%0), %%mm0\n"
-		"   movq 40(%0), %%mm1\n"
-		"   movq 48(%0), %%mm2\n"
-		"   movq 56(%0), %%mm3\n"
-		"   movq %%mm0, 32(%1)\n"
-		"   movq %%mm1, 40(%1)\n"
-		"   movq %%mm2, 48(%1)\n"
-		"   movq %%mm3, 56(%1)\n"
+		"1: prefetch 320(%1)\n"
+		"2: movq (%1), %%mm0\n"
+		"   movq 8(%1), %%mm1\n"
+		"   movq 16(%1), %%mm2\n"
+		"   movq 24(%1), %%mm3\n"
+		"   movq %%mm0, (%2)\n"
+		"   movq %%mm1, 8(%2)\n"
+		"   movq %%mm2, 16(%2)\n"
+		"   movq %%mm3, 24(%2)\n"
+		"   movq 32(%1), %%mm0\n"
+		"   movq 40(%1), %%mm1\n"
+		"   movq 48(%1), %%mm2\n"
+		"   movq 56(%1), %%mm3\n"
+		"   movq %%mm0, 32(%2)\n"
+		"   movq %%mm1, 40(%2)\n"
+		"   movq %%mm2, 48(%2)\n"
+		"   movq %%mm3, 56(%2)\n"
 		".section .fixup, \"ax\"\n"
-		"3: movw $0x05EB, 1b\n"	/* jmp on 5 bytes */
+		"3:\n"
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %%cr0, %0\n"
+		"   movl %0, %%eax\n"
+		"   andl $0xFFFEFFFF, %%eax\n"
+		"   movl %%eax, %%cr0\n"
+#endif
+
+		"   movw $0x05EB, 1b\n"	/* jmp on 5 bytes */
+
+#ifdef CONFIG_PAX_KERNEXEC
+		"   movl %0, %%cr0\n"
+#endif
+
 		"   jmp 2b\n"
 		".previous\n"
 			_ASM_EXTABLE(1b, 3b)
-			: : "r" (from), "r" (to) : "memory");
+			: "=&r" (cr0) : "r" (from), "r" (to) : "memory", "ax");
 
 		from += 64;
 		to += 64;
diff --git a/arch/x86/lib/msr-reg.S b/arch/x86/lib/msr-reg.S
index c81556409..303dcfabd 100644
--- a/arch/x86/lib/msr-reg.S
+++ b/arch/x86/lib/msr-reg.S
@@ -2,6 +2,7 @@
 #include <linux/errno.h>
 #include <asm/asm.h>
 #include <asm/msr.h>
+#include <asm/alternative-asm.h>
 
 #ifdef CONFIG_X86_64
 /*
@@ -34,6 +35,7 @@ ENTRY(\op\()_safe_regs)
 	movl    %edi, 28(%r10)
 	popq %rbp
 	popq %rbx
+	pax_force_retaddr
 	ret
 3:
 	movl    $-EIO, %r11d
diff --git a/arch/x86/lib/putuser.S b/arch/x86/lib/putuser.S
index c891ece81..27057c064 100644
--- a/arch/x86/lib/putuser.S
+++ b/arch/x86/lib/putuser.S
@@ -15,7 +15,10 @@
 #include <asm/errno.h>
 #include <asm/asm.h>
 #include <asm/smap.h>
-
+#include <asm/segment.h>
+#include <asm/pgtable.h>
+#include <asm/frame.h>
+#include <asm/alternative-asm.h>
 
 /*
  * __put_user_X
@@ -29,55 +32,125 @@
  * as they get called from within inline assembly.
  */
 
-#define ENTER	mov PER_CPU_VAR(current_task), %_ASM_BX
-#define EXIT	ASM_CLAC ;	\
+#define ENTER	FRAME_BEGIN
+#define EXIT	ASM_USER_ACCESS_END ;	\
+		FRAME_END ;		\
+		pax_force_retaddr ;	\
 		ret
 
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define _DEST %_ASM_CX,%_ASM_BX
+#else
+#define _DEST %_ASM_CX
+#endif
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#define __copyuser_seg gs;
+#else
+#define __copyuser_seg
+#endif
+
 .text
 ENTRY(__put_user_1)
 	ENTER
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov PER_CPU_VAR(current_task), %_ASM_BX
 	cmp TASK_addr_limit(%_ASM_BX),%_ASM_CX
 	jae bad_put_user
-	ASM_STAC
-1:	movb %al,(%_ASM_CX)
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov pax_user_shadow_base,%_ASM_BX
+	cmp %_ASM_BX,%_ASM_CX
+	jb 1234f
+	xor %ebx,%ebx
+1234:
+#endif
+
+#endif
+
+	ASM_USER_ACCESS_BEGIN
+1:	__copyuser_seg movb %al,(_DEST)
 	xor %eax,%eax
 	EXIT
 ENDPROC(__put_user_1)
 
 ENTRY(__put_user_2)
 	ENTER
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov PER_CPU_VAR(current_task), %_ASM_BX
 	mov TASK_addr_limit(%_ASM_BX),%_ASM_BX
 	sub $1,%_ASM_BX
 	cmp %_ASM_BX,%_ASM_CX
 	jae bad_put_user
-	ASM_STAC
-2:	movw %ax,(%_ASM_CX)
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov pax_user_shadow_base,%_ASM_BX
+	cmp %_ASM_BX,%_ASM_CX
+	jb 1234f
+	xor %ebx,%ebx
+1234:
+#endif
+
+#endif
+
+	ASM_USER_ACCESS_BEGIN
+2:	__copyuser_seg movw %ax,(_DEST)
 	xor %eax,%eax
 	EXIT
 ENDPROC(__put_user_2)
 
 ENTRY(__put_user_4)
 	ENTER
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov PER_CPU_VAR(current_task), %_ASM_BX
 	mov TASK_addr_limit(%_ASM_BX),%_ASM_BX
 	sub $3,%_ASM_BX
 	cmp %_ASM_BX,%_ASM_CX
 	jae bad_put_user
-	ASM_STAC
-3:	movl %eax,(%_ASM_CX)
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov pax_user_shadow_base,%_ASM_BX
+	cmp %_ASM_BX,%_ASM_CX
+	jb 1234f
+	xor %ebx,%ebx
+1234:
+#endif
+
+#endif
+
+	ASM_USER_ACCESS_BEGIN
+3:	__copyuser_seg movl %eax,(_DEST)
 	xor %eax,%eax
 	EXIT
 ENDPROC(__put_user_4)
 
 ENTRY(__put_user_8)
 	ENTER
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov PER_CPU_VAR(current_task), %_ASM_BX
 	mov TASK_addr_limit(%_ASM_BX),%_ASM_BX
 	sub $7,%_ASM_BX
 	cmp %_ASM_BX,%_ASM_CX
 	jae bad_put_user
-	ASM_STAC
-4:	mov %_ASM_AX,(%_ASM_CX)
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	mov pax_user_shadow_base,%_ASM_BX
+	cmp %_ASM_BX,%_ASM_CX
+	jb 1234f
+	xor %ebx,%ebx
+1234:
+#endif
+
+#endif
+
+	ASM_USER_ACCESS_BEGIN
+4:	__copyuser_seg mov %_ASM_AX,(_DEST)
 #ifdef CONFIG_X86_32
-5:	movl %edx,4(%_ASM_CX)
+5:	__copyuser_seg movl %edx,4(_DEST)
 #endif
 	xor %eax,%eax
 	EXIT
diff --git a/arch/x86/lib/rwsem.S b/arch/x86/lib/rwsem.S
index bf2c6074e..0e6d18b31 100644
--- a/arch/x86/lib/rwsem.S
+++ b/arch/x86/lib/rwsem.S
@@ -95,6 +95,7 @@ ENTRY(call_rwsem_down_read_failed)
 	__ASM_SIZE(pop,) %__ASM_REG(dx)
 	restore_common_regs
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(call_rwsem_down_read_failed)
 
@@ -105,6 +106,7 @@ ENTRY(call_rwsem_down_write_failed)
 	call rwsem_down_write_failed
 	restore_common_regs
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(call_rwsem_down_write_failed)
 
@@ -128,6 +130,7 @@ ENTRY(call_rwsem_wake)
 	call rwsem_wake
 	restore_common_regs
 1:	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(call_rwsem_wake)
 
@@ -140,5 +143,6 @@ ENTRY(call_rwsem_downgrade_wake)
 	__ASM_SIZE(pop,) %__ASM_REG(dx)
 	restore_common_regs
 	FRAME_END
+	pax_force_retaddr
 	ret
 ENDPROC(call_rwsem_downgrade_wake)
diff --git a/arch/x86/lib/usercopy_32.c b/arch/x86/lib/usercopy_32.c
index 3bc7baf2a..63d1a4dfe 100644
--- a/arch/x86/lib/usercopy_32.c
+++ b/arch/x86/lib/usercopy_32.c
@@ -42,11 +42,13 @@ do {									\
 	int __d0;							\
 	might_fault();							\
 	__asm__ __volatile__(						\
+		__COPYUSER_SET_ES					\
 		ASM_STAC "\n"						\
 		"0:	rep; stosl\n"					\
 		"	movl %2,%0\n"					\
 		"1:	rep; stosb\n"					\
 		"2: " ASM_CLAC "\n"					\
+		__COPYUSER_RESTORE_ES					\
 		".section .fixup,\"ax\"\n"				\
 		"3:	lea 0(%2,%0,4),%0\n"				\
 		"	jmp 2b\n"					\
@@ -98,7 +100,7 @@ EXPORT_SYMBOL(__clear_user);
 
 #ifdef CONFIG_X86_INTEL_USERCOPY
 static unsigned long
-__copy_user_intel(void __user *to, const void *from, unsigned long size)
+__generic_copy_to_user_intel(void __user *to, const void *from, unsigned long size)
 {
 	int d0, d1;
 	__asm__ __volatile__(
@@ -110,36 +112,36 @@ __copy_user_intel(void __user *to, const void *from, unsigned long size)
 		       "       .align 2,0x90\n"
 		       "3:     movl 0(%4), %%eax\n"
 		       "4:     movl 4(%4), %%edx\n"
-		       "5:     movl %%eax, 0(%3)\n"
-		       "6:     movl %%edx, 4(%3)\n"
+		       "5:     "__copyuser_seg" movl %%eax, 0(%3)\n"
+		       "6:     "__copyuser_seg" movl %%edx, 4(%3)\n"
 		       "7:     movl 8(%4), %%eax\n"
 		       "8:     movl 12(%4),%%edx\n"
-		       "9:     movl %%eax, 8(%3)\n"
-		       "10:    movl %%edx, 12(%3)\n"
+		       "9:     "__copyuser_seg" movl %%eax, 8(%3)\n"
+		       "10:    "__copyuser_seg" movl %%edx, 12(%3)\n"
 		       "11:    movl 16(%4), %%eax\n"
 		       "12:    movl 20(%4), %%edx\n"
-		       "13:    movl %%eax, 16(%3)\n"
-		       "14:    movl %%edx, 20(%3)\n"
+		       "13:    "__copyuser_seg" movl %%eax, 16(%3)\n"
+		       "14:    "__copyuser_seg" movl %%edx, 20(%3)\n"
 		       "15:    movl 24(%4), %%eax\n"
 		       "16:    movl 28(%4), %%edx\n"
-		       "17:    movl %%eax, 24(%3)\n"
-		       "18:    movl %%edx, 28(%3)\n"
+		       "17:    "__copyuser_seg" movl %%eax, 24(%3)\n"
+		       "18:    "__copyuser_seg" movl %%edx, 28(%3)\n"
 		       "19:    movl 32(%4), %%eax\n"
 		       "20:    movl 36(%4), %%edx\n"
-		       "21:    movl %%eax, 32(%3)\n"
-		       "22:    movl %%edx, 36(%3)\n"
+		       "21:    "__copyuser_seg" movl %%eax, 32(%3)\n"
+		       "22:    "__copyuser_seg" movl %%edx, 36(%3)\n"
 		       "23:    movl 40(%4), %%eax\n"
 		       "24:    movl 44(%4), %%edx\n"
-		       "25:    movl %%eax, 40(%3)\n"
-		       "26:    movl %%edx, 44(%3)\n"
+		       "25:    "__copyuser_seg" movl %%eax, 40(%3)\n"
+		       "26:    "__copyuser_seg" movl %%edx, 44(%3)\n"
 		       "27:    movl 48(%4), %%eax\n"
 		       "28:    movl 52(%4), %%edx\n"
-		       "29:    movl %%eax, 48(%3)\n"
-		       "30:    movl %%edx, 52(%3)\n"
+		       "29:    "__copyuser_seg" movl %%eax, 48(%3)\n"
+		       "30:    "__copyuser_seg" movl %%edx, 52(%3)\n"
 		       "31:    movl 56(%4), %%eax\n"
 		       "32:    movl 60(%4), %%edx\n"
-		       "33:    movl %%eax, 56(%3)\n"
-		       "34:    movl %%edx, 60(%3)\n"
+		       "33:    "__copyuser_seg" movl %%eax, 56(%3)\n"
+		       "34:    "__copyuser_seg" movl %%edx, 60(%3)\n"
 		       "       addl $-64, %0\n"
 		       "       addl $64, %4\n"
 		       "       addl $64, %3\n"
@@ -149,10 +151,116 @@ __copy_user_intel(void __user *to, const void *from, unsigned long size)
 		       "       shrl  $2, %0\n"
 		       "       andl  $3, %%eax\n"
 		       "       cld\n"
+		       __COPYUSER_SET_ES
 		       "99:    rep; movsl\n"
 		       "36:    movl %%eax, %0\n"
 		       "37:    rep; movsb\n"
 		       "100:\n"
+		       __COPYUSER_RESTORE_ES
+		       ".section .fixup,\"ax\"\n"
+		       "101:   lea 0(%%eax,%0,4),%0\n"
+		       "       jmp 100b\n"
+		       ".previous\n"
+		       _ASM_EXTABLE(1b,100b)
+		       _ASM_EXTABLE(2b,100b)
+		       _ASM_EXTABLE(3b,100b)
+		       _ASM_EXTABLE(4b,100b)
+		       _ASM_EXTABLE(5b,100b)
+		       _ASM_EXTABLE(6b,100b)
+		       _ASM_EXTABLE(7b,100b)
+		       _ASM_EXTABLE(8b,100b)
+		       _ASM_EXTABLE(9b,100b)
+		       _ASM_EXTABLE(10b,100b)
+		       _ASM_EXTABLE(11b,100b)
+		       _ASM_EXTABLE(12b,100b)
+		       _ASM_EXTABLE(13b,100b)
+		       _ASM_EXTABLE(14b,100b)
+		       _ASM_EXTABLE(15b,100b)
+		       _ASM_EXTABLE(16b,100b)
+		       _ASM_EXTABLE(17b,100b)
+		       _ASM_EXTABLE(18b,100b)
+		       _ASM_EXTABLE(19b,100b)
+		       _ASM_EXTABLE(20b,100b)
+		       _ASM_EXTABLE(21b,100b)
+		       _ASM_EXTABLE(22b,100b)
+		       _ASM_EXTABLE(23b,100b)
+		       _ASM_EXTABLE(24b,100b)
+		       _ASM_EXTABLE(25b,100b)
+		       _ASM_EXTABLE(26b,100b)
+		       _ASM_EXTABLE(27b,100b)
+		       _ASM_EXTABLE(28b,100b)
+		       _ASM_EXTABLE(29b,100b)
+		       _ASM_EXTABLE(30b,100b)
+		       _ASM_EXTABLE(31b,100b)
+		       _ASM_EXTABLE(32b,100b)
+		       _ASM_EXTABLE(33b,100b)
+		       _ASM_EXTABLE(34b,100b)
+		       _ASM_EXTABLE(35b,100b)
+		       _ASM_EXTABLE(36b,100b)
+		       _ASM_EXTABLE(37b,100b)
+		       _ASM_EXTABLE(99b,101b)
+		       : "=&c"(size), "=&D" (d0), "=&S" (d1)
+		       :  "1"(to), "2"(from), "0"(size)
+		       : "eax", "edx", "memory");
+	return size;
+}
+
+static unsigned long
+__generic_copy_from_user_intel(void *to, const void __user *from, unsigned long size)
+{
+	int d0, d1;
+	__asm__ __volatile__(
+		       "       .align 2,0x90\n"
+		       "1:     "__copyuser_seg" movl 32(%4), %%eax\n"
+		       "       cmpl $67, %0\n"
+		       "       jbe 3f\n"
+		       "2:     "__copyuser_seg" movl 64(%4), %%eax\n"
+		       "       .align 2,0x90\n"
+		       "3:     "__copyuser_seg" movl 0(%4), %%eax\n"
+		       "4:     "__copyuser_seg" movl 4(%4), %%edx\n"
+		       "5:     movl %%eax, 0(%3)\n"
+		       "6:     movl %%edx, 4(%3)\n"
+		       "7:     "__copyuser_seg" movl 8(%4), %%eax\n"
+		       "8:     "__copyuser_seg" movl 12(%4),%%edx\n"
+		       "9:     movl %%eax, 8(%3)\n"
+		       "10:    movl %%edx, 12(%3)\n"
+		       "11:    "__copyuser_seg" movl 16(%4), %%eax\n"
+		       "12:    "__copyuser_seg" movl 20(%4), %%edx\n"
+		       "13:    movl %%eax, 16(%3)\n"
+		       "14:    movl %%edx, 20(%3)\n"
+		       "15:    "__copyuser_seg" movl 24(%4), %%eax\n"
+		       "16:    "__copyuser_seg" movl 28(%4), %%edx\n"
+		       "17:    movl %%eax, 24(%3)\n"
+		       "18:    movl %%edx, 28(%3)\n"
+		       "19:    "__copyuser_seg" movl 32(%4), %%eax\n"
+		       "20:    "__copyuser_seg" movl 36(%4), %%edx\n"
+		       "21:    movl %%eax, 32(%3)\n"
+		       "22:    movl %%edx, 36(%3)\n"
+		       "23:    "__copyuser_seg" movl 40(%4), %%eax\n"
+		       "24:    "__copyuser_seg" movl 44(%4), %%edx\n"
+		       "25:    movl %%eax, 40(%3)\n"
+		       "26:    movl %%edx, 44(%3)\n"
+		       "27:    "__copyuser_seg" movl 48(%4), %%eax\n"
+		       "28:    "__copyuser_seg" movl 52(%4), %%edx\n"
+		       "29:    movl %%eax, 48(%3)\n"
+		       "30:    movl %%edx, 52(%3)\n"
+		       "31:    "__copyuser_seg" movl 56(%4), %%eax\n"
+		       "32:    "__copyuser_seg" movl 60(%4), %%edx\n"
+		       "33:    movl %%eax, 56(%3)\n"
+		       "34:    movl %%edx, 60(%3)\n"
+		       "       addl $-64, %0\n"
+		       "       addl $64, %4\n"
+		       "       addl $64, %3\n"
+		       "       cmpl $63, %0\n"
+		       "       ja  1b\n"
+		       "35:    movl  %0, %%eax\n"
+		       "       shrl  $2, %0\n"
+		       "       andl  $3, %%eax\n"
+		       "       cld\n"
+		       "99:    rep; "__copyuser_seg" movsl\n"
+		       "36:    movl %%eax, %0\n"
+		       "37:    rep; "__copyuser_seg" movsb\n"
+		       "100:\n"
 		       ".section .fixup,\"ax\"\n"
 		       "101:   lea 0(%%eax,%0,4),%0\n"
 		       "       jmp 100b\n"
@@ -207,41 +315,41 @@ __copy_user_zeroing_intel(void *to, const void __user *from, unsigned long size)
 	int d0, d1;
 	__asm__ __volatile__(
 		       "        .align 2,0x90\n"
-		       "0:      movl 32(%4), %%eax\n"
+		       "0:      "__copyuser_seg" movl 32(%4), %%eax\n"
 		       "        cmpl $67, %0\n"
 		       "        jbe 2f\n"
-		       "1:      movl 64(%4), %%eax\n"
+		       "1:      "__copyuser_seg" movl 64(%4), %%eax\n"
 		       "        .align 2,0x90\n"
-		       "2:      movl 0(%4), %%eax\n"
-		       "21:     movl 4(%4), %%edx\n"
+		       "2:      "__copyuser_seg" movl 0(%4), %%eax\n"
+		       "21:     "__copyuser_seg" movl 4(%4), %%edx\n"
 		       "        movl %%eax, 0(%3)\n"
 		       "        movl %%edx, 4(%3)\n"
-		       "3:      movl 8(%4), %%eax\n"
-		       "31:     movl 12(%4),%%edx\n"
+		       "3:      "__copyuser_seg" movl 8(%4), %%eax\n"
+		       "31:     "__copyuser_seg" movl 12(%4),%%edx\n"
 		       "        movl %%eax, 8(%3)\n"
 		       "        movl %%edx, 12(%3)\n"
-		       "4:      movl 16(%4), %%eax\n"
-		       "41:     movl 20(%4), %%edx\n"
+		       "4:      "__copyuser_seg" movl 16(%4), %%eax\n"
+		       "41:     "__copyuser_seg" movl 20(%4), %%edx\n"
 		       "        movl %%eax, 16(%3)\n"
 		       "        movl %%edx, 20(%3)\n"
-		       "10:     movl 24(%4), %%eax\n"
-		       "51:     movl 28(%4), %%edx\n"
+		       "10:     "__copyuser_seg" movl 24(%4), %%eax\n"
+		       "51:     "__copyuser_seg" movl 28(%4), %%edx\n"
 		       "        movl %%eax, 24(%3)\n"
 		       "        movl %%edx, 28(%3)\n"
-		       "11:     movl 32(%4), %%eax\n"
-		       "61:     movl 36(%4), %%edx\n"
+		       "11:     "__copyuser_seg" movl 32(%4), %%eax\n"
+		       "61:     "__copyuser_seg" movl 36(%4), %%edx\n"
 		       "        movl %%eax, 32(%3)\n"
 		       "        movl %%edx, 36(%3)\n"
-		       "12:     movl 40(%4), %%eax\n"
-		       "71:     movl 44(%4), %%edx\n"
+		       "12:     "__copyuser_seg" movl 40(%4), %%eax\n"
+		       "71:     "__copyuser_seg" movl 44(%4), %%edx\n"
 		       "        movl %%eax, 40(%3)\n"
 		       "        movl %%edx, 44(%3)\n"
-		       "13:     movl 48(%4), %%eax\n"
-		       "81:     movl 52(%4), %%edx\n"
+		       "13:     "__copyuser_seg" movl 48(%4), %%eax\n"
+		       "81:     "__copyuser_seg" movl 52(%4), %%edx\n"
 		       "        movl %%eax, 48(%3)\n"
 		       "        movl %%edx, 52(%3)\n"
-		       "14:     movl 56(%4), %%eax\n"
-		       "91:     movl 60(%4), %%edx\n"
+		       "14:     "__copyuser_seg" movl 56(%4), %%eax\n"
+		       "91:     "__copyuser_seg" movl 60(%4), %%edx\n"
 		       "        movl %%eax, 56(%3)\n"
 		       "        movl %%edx, 60(%3)\n"
 		       "        addl $-64, %0\n"
@@ -253,9 +361,9 @@ __copy_user_zeroing_intel(void *to, const void __user *from, unsigned long size)
 		       "        shrl  $2, %0\n"
 		       "        andl $3, %%eax\n"
 		       "        cld\n"
-		       "6:      rep; movsl\n"
+		       "6:      rep; "__copyuser_seg" movsl\n"
 		       "        movl %%eax,%0\n"
-		       "7:      rep; movsb\n"
+		       "7:      rep; "__copyuser_seg" movsb\n"
 		       "8:\n"
 		       ".section .fixup,\"ax\"\n"
 		       "9:      lea 0(%%eax,%0,4),%0\n"
@@ -305,41 +413,41 @@ static unsigned long __copy_user_zeroing_intel_nocache(void *to,
 
 	__asm__ __volatile__(
 	       "        .align 2,0x90\n"
-	       "0:      movl 32(%4), %%eax\n"
+	       "0:      "__copyuser_seg" movl 32(%4), %%eax\n"
 	       "        cmpl $67, %0\n"
 	       "        jbe 2f\n"
-	       "1:      movl 64(%4), %%eax\n"
+	       "1:      "__copyuser_seg" movl 64(%4), %%eax\n"
 	       "        .align 2,0x90\n"
-	       "2:      movl 0(%4), %%eax\n"
-	       "21:     movl 4(%4), %%edx\n"
+	       "2:      "__copyuser_seg" movl 0(%4), %%eax\n"
+	       "21:     "__copyuser_seg" movl 4(%4), %%edx\n"
 	       "        movnti %%eax, 0(%3)\n"
 	       "        movnti %%edx, 4(%3)\n"
-	       "3:      movl 8(%4), %%eax\n"
-	       "31:     movl 12(%4),%%edx\n"
+	       "3:      "__copyuser_seg" movl 8(%4), %%eax\n"
+	       "31:     "__copyuser_seg" movl 12(%4),%%edx\n"
 	       "        movnti %%eax, 8(%3)\n"
 	       "        movnti %%edx, 12(%3)\n"
-	       "4:      movl 16(%4), %%eax\n"
-	       "41:     movl 20(%4), %%edx\n"
+	       "4:      "__copyuser_seg" movl 16(%4), %%eax\n"
+	       "41:     "__copyuser_seg" movl 20(%4), %%edx\n"
 	       "        movnti %%eax, 16(%3)\n"
 	       "        movnti %%edx, 20(%3)\n"
-	       "10:     movl 24(%4), %%eax\n"
-	       "51:     movl 28(%4), %%edx\n"
+	       "10:     "__copyuser_seg" movl 24(%4), %%eax\n"
+	       "51:     "__copyuser_seg" movl 28(%4), %%edx\n"
 	       "        movnti %%eax, 24(%3)\n"
 	       "        movnti %%edx, 28(%3)\n"
-	       "11:     movl 32(%4), %%eax\n"
-	       "61:     movl 36(%4), %%edx\n"
+	       "11:     "__copyuser_seg" movl 32(%4), %%eax\n"
+	       "61:     "__copyuser_seg" movl 36(%4), %%edx\n"
 	       "        movnti %%eax, 32(%3)\n"
 	       "        movnti %%edx, 36(%3)\n"
-	       "12:     movl 40(%4), %%eax\n"
-	       "71:     movl 44(%4), %%edx\n"
+	       "12:     "__copyuser_seg" movl 40(%4), %%eax\n"
+	       "71:     "__copyuser_seg" movl 44(%4), %%edx\n"
 	       "        movnti %%eax, 40(%3)\n"
 	       "        movnti %%edx, 44(%3)\n"
-	       "13:     movl 48(%4), %%eax\n"
-	       "81:     movl 52(%4), %%edx\n"
+	       "13:     "__copyuser_seg" movl 48(%4), %%eax\n"
+	       "81:     "__copyuser_seg" movl 52(%4), %%edx\n"
 	       "        movnti %%eax, 48(%3)\n"
 	       "        movnti %%edx, 52(%3)\n"
-	       "14:     movl 56(%4), %%eax\n"
-	       "91:     movl 60(%4), %%edx\n"
+	       "14:     "__copyuser_seg" movl 56(%4), %%eax\n"
+	       "91:     "__copyuser_seg" movl 60(%4), %%edx\n"
 	       "        movnti %%eax, 56(%3)\n"
 	       "        movnti %%edx, 60(%3)\n"
 	       "        addl $-64, %0\n"
@@ -352,9 +460,9 @@ static unsigned long __copy_user_zeroing_intel_nocache(void *to,
 	       "        shrl  $2, %0\n"
 	       "        andl $3, %%eax\n"
 	       "        cld\n"
-	       "6:      rep; movsl\n"
+	       "6:      rep; "__copyuser_seg" movsl\n"
 	       "        movl %%eax,%0\n"
-	       "7:      rep; movsb\n"
+	       "7:      rep; "__copyuser_seg" movsb\n"
 	       "8:\n"
 	       ".section .fixup,\"ax\"\n"
 	       "9:      lea 0(%%eax,%0,4),%0\n"
@@ -399,41 +507,41 @@ static unsigned long __copy_user_intel_nocache(void *to,
 
 	__asm__ __volatile__(
 	       "        .align 2,0x90\n"
-	       "0:      movl 32(%4), %%eax\n"
+	       "0:      "__copyuser_seg" movl 32(%4), %%eax\n"
 	       "        cmpl $67, %0\n"
 	       "        jbe 2f\n"
-	       "1:      movl 64(%4), %%eax\n"
+	       "1:      "__copyuser_seg" movl 64(%4), %%eax\n"
 	       "        .align 2,0x90\n"
-	       "2:      movl 0(%4), %%eax\n"
-	       "21:     movl 4(%4), %%edx\n"
+	       "2:      "__copyuser_seg" movl 0(%4), %%eax\n"
+	       "21:     "__copyuser_seg" movl 4(%4), %%edx\n"
 	       "        movnti %%eax, 0(%3)\n"
 	       "        movnti %%edx, 4(%3)\n"
-	       "3:      movl 8(%4), %%eax\n"
-	       "31:     movl 12(%4),%%edx\n"
+	       "3:      "__copyuser_seg" movl 8(%4), %%eax\n"
+	       "31:     "__copyuser_seg" movl 12(%4),%%edx\n"
 	       "        movnti %%eax, 8(%3)\n"
 	       "        movnti %%edx, 12(%3)\n"
-	       "4:      movl 16(%4), %%eax\n"
-	       "41:     movl 20(%4), %%edx\n"
+	       "4:      "__copyuser_seg" movl 16(%4), %%eax\n"
+	       "41:     "__copyuser_seg" movl 20(%4), %%edx\n"
 	       "        movnti %%eax, 16(%3)\n"
 	       "        movnti %%edx, 20(%3)\n"
-	       "10:     movl 24(%4), %%eax\n"
-	       "51:     movl 28(%4), %%edx\n"
+	       "10:     "__copyuser_seg" movl 24(%4), %%eax\n"
+	       "51:     "__copyuser_seg" movl 28(%4), %%edx\n"
 	       "        movnti %%eax, 24(%3)\n"
 	       "        movnti %%edx, 28(%3)\n"
-	       "11:     movl 32(%4), %%eax\n"
-	       "61:     movl 36(%4), %%edx\n"
+	       "11:     "__copyuser_seg" movl 32(%4), %%eax\n"
+	       "61:     "__copyuser_seg" movl 36(%4), %%edx\n"
 	       "        movnti %%eax, 32(%3)\n"
 	       "        movnti %%edx, 36(%3)\n"
-	       "12:     movl 40(%4), %%eax\n"
-	       "71:     movl 44(%4), %%edx\n"
+	       "12:     "__copyuser_seg" movl 40(%4), %%eax\n"
+	       "71:     "__copyuser_seg" movl 44(%4), %%edx\n"
 	       "        movnti %%eax, 40(%3)\n"
 	       "        movnti %%edx, 44(%3)\n"
-	       "13:     movl 48(%4), %%eax\n"
-	       "81:     movl 52(%4), %%edx\n"
+	       "13:     "__copyuser_seg" movl 48(%4), %%eax\n"
+	       "81:     "__copyuser_seg" movl 52(%4), %%edx\n"
 	       "        movnti %%eax, 48(%3)\n"
 	       "        movnti %%edx, 52(%3)\n"
-	       "14:     movl 56(%4), %%eax\n"
-	       "91:     movl 60(%4), %%edx\n"
+	       "14:     "__copyuser_seg" movl 56(%4), %%eax\n"
+	       "91:     "__copyuser_seg" movl 60(%4), %%edx\n"
 	       "        movnti %%eax, 56(%3)\n"
 	       "        movnti %%edx, 60(%3)\n"
 	       "        addl $-64, %0\n"
@@ -446,9 +554,9 @@ static unsigned long __copy_user_intel_nocache(void *to,
 	       "        shrl  $2, %0\n"
 	       "        andl $3, %%eax\n"
 	       "        cld\n"
-	       "6:      rep; movsl\n"
+	       "6:      rep; "__copyuser_seg" movsl\n"
 	       "        movl %%eax,%0\n"
-	       "7:      rep; movsb\n"
+	       "7:      rep; "__copyuser_seg" movsb\n"
 	       "8:\n"
 	       ".section .fixup,\"ax\"\n"
 	       "9:      lea 0(%%eax,%0,4),%0\n"
@@ -488,32 +596,36 @@ static unsigned long __copy_user_intel_nocache(void *to,
  */
 unsigned long __copy_user_zeroing_intel(void *to, const void __user *from,
 					unsigned long size);
-unsigned long __copy_user_intel(void __user *to, const void *from,
+unsigned long __generic_copy_to_user_intel(void __user *to, const void *from,
+					unsigned long size);
+unsigned long __generic_copy_from_user_intel(void *to, const void __user *from,
 					unsigned long size);
 unsigned long __copy_user_zeroing_intel_nocache(void *to,
 				const void __user *from, unsigned long size);
 #endif /* CONFIG_X86_INTEL_USERCOPY */
 
 /* Generic arbitrary sized copy.  */
-#define __copy_user(to, from, size)					\
+#define __copy_user(to, from, size, prefix, set, restore)		\
 do {									\
 	int __d0, __d1, __d2;						\
 	__asm__ __volatile__(						\
+		set							\
 		"	cmp  $7,%0\n"					\
 		"	jbe  1f\n"					\
 		"	movl %1,%0\n"					\
 		"	negl %0\n"					\
 		"	andl $7,%0\n"					\
 		"	subl %0,%3\n"					\
-		"4:	rep; movsb\n"					\
+		"4:	rep; "prefix"movsb\n"				\
 		"	movl %3,%0\n"					\
 		"	shrl $2,%0\n"					\
 		"	andl $3,%3\n"					\
 		"	.align 2,0x90\n"				\
-		"0:	rep; movsl\n"					\
+		"0:	rep; "prefix"movsl\n"				\
 		"	movl %3,%0\n"					\
-		"1:	rep; movsb\n"					\
+		"1:	rep; "prefix"movsb\n"				\
 		"2:\n"							\
+		restore							\
 		".section .fixup,\"ax\"\n"				\
 		"5:	addl %3,%0\n"					\
 		"	jmp 2b\n"					\
@@ -538,14 +650,14 @@ do {									\
 		"	negl %0\n"					\
 		"	andl $7,%0\n"					\
 		"	subl %0,%3\n"					\
-		"4:	rep; movsb\n"					\
+		"4:	rep; "__copyuser_seg"movsb\n"			\
 		"	movl %3,%0\n"					\
 		"	shrl $2,%0\n"					\
 		"	andl $3,%3\n"					\
 		"	.align 2,0x90\n"				\
-		"0:	rep; movsl\n"					\
+		"0:	rep; "__copyuser_seg"movsl\n"			\
 		"	movl %3,%0\n"					\
-		"1:	rep; movsb\n"					\
+		"1:	rep; "__copyuser_seg"movsb\n"			\
 		"2:\n"							\
 		".section .fixup,\"ax\"\n"				\
 		"5:	addl %3,%0\n"					\
@@ -572,9 +684,9 @@ unsigned long __copy_to_user_ll(void __user *to, const void *from,
 {
 	stac();
 	if (movsl_is_ok(to, from, n))
-		__copy_user(to, from, n);
+		__copy_user(to, from, n, "", __COPYUSER_SET_ES, __COPYUSER_RESTORE_ES);
 	else
-		n = __copy_user_intel(to, from, n);
+		n = __generic_copy_to_user_intel(to, from, n);
 	clac();
 	return n;
 }
@@ -598,10 +710,9 @@ unsigned long __copy_from_user_ll_nozero(void *to, const void __user *from,
 {
 	stac();
 	if (movsl_is_ok(to, from, n))
-		__copy_user(to, from, n);
+		__copy_user(to, from, n, __copyuser_seg, "", "");
 	else
-		n = __copy_user_intel((void __user *)to,
-				      (const void *)from, n);
+		n = __generic_copy_from_user_intel(to, from, n);
 	clac();
 	return n;
 }
@@ -632,60 +743,38 @@ unsigned long __copy_from_user_ll_nocache_nozero(void *to, const void __user *fr
 	if (n > 64 && static_cpu_has(X86_FEATURE_XMM2))
 		n = __copy_user_intel_nocache(to, from, n);
 	else
-		__copy_user(to, from, n);
+		__copy_user(to, from, n, __copyuser_seg, "", "");
 #else
-	__copy_user(to, from, n);
+	__copy_user(to, from, n, __copyuser_seg, "", "");
 #endif
 	clac();
 	return n;
 }
 EXPORT_SYMBOL(__copy_from_user_ll_nocache_nozero);
 
-/**
- * copy_to_user: - Copy a block of data into user space.
- * @to:   Destination address, in user space.
- * @from: Source address, in kernel space.
- * @n:    Number of bytes to copy.
- *
- * Context: User context only. This function may sleep if pagefaults are
- *          enabled.
- *
- * Copy data from kernel space to user space.
- *
- * Returns number of bytes that could not be copied.
- * On success, this will be zero.
- */
-unsigned long _copy_to_user(void __user *to, const void *from, unsigned n)
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+void __set_fs(mm_segment_t x)
 {
-	if (access_ok(VERIFY_WRITE, to, n))
-		n = __copy_to_user(to, from, n);
-	return n;
+	switch (x.seg) {
+	case 0:
+		loadsegment(gs, 0);
+		break;
+	case TASK_SIZE_MAX:
+		loadsegment(gs, __USER_DS);
+		break;
+	case -1UL:
+		loadsegment(gs, __KERNEL_DS);
+		break;
+	default:
+		BUG();
+	}
 }
-EXPORT_SYMBOL(_copy_to_user);
+EXPORT_SYMBOL(__set_fs);
 
-/**
- * copy_from_user: - Copy a block of data from user space.
- * @to:   Destination address, in kernel space.
- * @from: Source address, in user space.
- * @n:    Number of bytes to copy.
- *
- * Context: User context only. This function may sleep if pagefaults are
- *          enabled.
- *
- * Copy data from user space to kernel space.
- *
- * Returns number of bytes that could not be copied.
- * On success, this will be zero.
- *
- * If some data could not be copied, this function will pad the copied
- * data to the requested size using zero bytes.
- */
-unsigned long _copy_from_user(void *to, const void __user *from, unsigned n)
+void set_fs(mm_segment_t x)
 {
-	if (access_ok(VERIFY_READ, from, n))
-		n = __copy_from_user(to, from, n);
-	else
-		memset(to, 0, n);
-	return n;
+	current_thread_info()->addr_limit = x;
+	__set_fs(x);
 }
-EXPORT_SYMBOL(_copy_from_user);
+EXPORT_SYMBOL(set_fs);
+#endif
diff --git a/arch/x86/lib/usercopy_64.c b/arch/x86/lib/usercopy_64.c
index 69873589c..adaea4132 100644
--- a/arch/x86/lib/usercopy_64.c
+++ b/arch/x86/lib/usercopy_64.c
@@ -18,7 +18,7 @@ unsigned long __clear_user(void __user *addr, unsigned long size)
 	might_fault();
 	/* no memory constraint because it doesn't change any memory gcc knows
 	   about */
-	stac();
+	user_access_begin();
 	asm volatile(
 		"	testq  %[size8],%[size8]\n"
 		"	jz     4f\n"
@@ -39,9 +39,9 @@ unsigned long __clear_user(void __user *addr, unsigned long size)
 		_ASM_EXTABLE(0b,3b)
 		_ASM_EXTABLE(1b,2b)
 		: [size8] "=&c"(size), [dst] "=&D" (__d0)
-		: [size1] "r"(size & 7), "[size8]" (size / 8), "[dst]"(addr),
+		: [size1] "r"(size & 7), "[size8]" (size / 8), "[dst]"(____m(addr)),
 		  [zero] "r" (0UL), [eight] "r" (8UL));
-	clac();
+	user_access_end();
 	return size;
 }
 EXPORT_SYMBOL(__clear_user);
@@ -54,12 +54,11 @@ unsigned long clear_user(void __user *to, unsigned long n)
 }
 EXPORT_SYMBOL(clear_user);
 
-unsigned long copy_in_user(void __user *to, const void __user *from, unsigned len)
+unsigned long copy_in_user(void __user *to, const void __user *from, unsigned long len)
 {
-	if (access_ok(VERIFY_WRITE, to, len) && access_ok(VERIFY_READ, from, len)) { 
-		return copy_user_generic((__force void *)to, (__force void *)from, len);
-	} 
-	return len;		
+	if (access_ok(VERIFY_WRITE, to, len) && access_ok(VERIFY_READ, from, len))
+		return copy_user_generic((void __force_kernel *)____m(to), (void __force_kernel *)____m(from), len);
+	return len;
 }
 EXPORT_SYMBOL(copy_in_user);
 
@@ -69,8 +68,9 @@ EXPORT_SYMBOL(copy_in_user);
  * it is not necessary to optimize tail handling.
  */
 __visible unsigned long
-copy_user_handle_tail(char *to, char *from, unsigned len)
+copy_user_handle_tail(char __user *to, char __user *from, unsigned long len)
 {
+	user_access_end();
 	for (; len; --len, to++) {
 		char c;
 
@@ -79,10 +79,9 @@ copy_user_handle_tail(char *to, char *from, unsigned len)
 		if (__put_user_nocheck(c, to, sizeof(char)))
 			break;
 	}
-	clac();
 
 	/* If the destination is a kernel buffer, we always clear the end */
-	if (!__addr_ok(to))
-		memset(to, 0, len);
+	if (!__addr_ok(to) && (unsigned long)to >= TASK_SIZE_MAX + pax_user_shadow_base)
+		memset((void __force_kernel *)to, 0, len);
 	return len;
 }
diff --git a/arch/x86/math-emu/fpu_aux.c b/arch/x86/math-emu/fpu_aux.c
index 024f6e971..308f1b093 100644
--- a/arch/x86/math-emu/fpu_aux.c
+++ b/arch/x86/math-emu/fpu_aux.c
@@ -52,7 +52,7 @@ void fpstate_init_soft(struct swregs_state *soft)
 
 void finit(void)
 {
-	fpstate_init_soft(&current->thread.fpu.state.soft);
+	fpstate_init_soft(&current->thread.fpu.state->soft);
 }
 
 /*
diff --git a/arch/x86/math-emu/fpu_entry.c b/arch/x86/math-emu/fpu_entry.c
index e945fedf1..bffe686ab 100644
--- a/arch/x86/math-emu/fpu_entry.c
+++ b/arch/x86/math-emu/fpu_entry.c
@@ -643,7 +643,7 @@ int fpregs_soft_set(struct task_struct *target,
 		    unsigned int pos, unsigned int count,
 		    const void *kbuf, const void __user *ubuf)
 {
-	struct swregs_state *s387 = &target->thread.fpu.state.soft;
+	struct swregs_state *s387 = &target->thread.fpu.state->soft;
 	void *space = s387->st_space;
 	int ret;
 	int offset, other, i, tags, regnr, tag, newtop;
@@ -695,7 +695,7 @@ int fpregs_soft_get(struct task_struct *target,
 		    unsigned int pos, unsigned int count,
 		    void *kbuf, void __user *ubuf)
 {
-	struct swregs_state *s387 = &target->thread.fpu.state.soft;
+	struct swregs_state *s387 = &target->thread.fpu.state->soft;
 	const void *space = s387->st_space;
 	int ret;
 	int offset = (S387->ftop & 7) * 10, other = 80 - offset;
diff --git a/arch/x86/math-emu/fpu_etc.c b/arch/x86/math-emu/fpu_etc.c
index 233e5af56..dd82ff07a 100644
--- a/arch/x86/math-emu/fpu_etc.c
+++ b/arch/x86/math-emu/fpu_etc.c
@@ -119,9 +119,14 @@ static void fxam(FPU_REG *st0_ptr, u_char st0tag)
 	setcc(c);
 }
 
+static void FPU_ST0_illegal(FPU_REG *st0_ptr, u_char st0_tag)
+{
+	FPU_illegal();
+}
+
 static FUNC_ST0 const fp_etc_table[] = {
-	fchs, fabs, (FUNC_ST0) FPU_illegal, (FUNC_ST0) FPU_illegal,
-	ftst_, fxam, (FUNC_ST0) FPU_illegal, (FUNC_ST0) FPU_illegal
+	fchs, fabs, FPU_ST0_illegal, FPU_ST0_illegal,
+	ftst_, fxam, FPU_ST0_illegal, FPU_ST0_illegal
 };
 
 void FPU_etc(void)
diff --git a/arch/x86/math-emu/fpu_system.h b/arch/x86/math-emu/fpu_system.h
index 5e044d506..d342fce49 100644
--- a/arch/x86/math-emu/fpu_system.h
+++ b/arch/x86/math-emu/fpu_system.h
@@ -46,7 +46,7 @@ static inline struct desc_struct FPU_get_ldt_descriptor(unsigned seg)
 #define SEG_EXPAND_DOWN(s)	(((s).b & ((1 << 11) | (1 << 10))) \
 				 == (1 << 10))
 
-#define I387			(&current->thread.fpu.state)
+#define I387			(current->thread.fpu.state)
 #define FPU_info		(I387->soft.info)
 
 #define FPU_CS			(*(unsigned short *) &(FPU_info->regs->cs))
diff --git a/arch/x86/math-emu/fpu_trig.c b/arch/x86/math-emu/fpu_trig.c
index ecd066805..4b4c6646a 100644
--- a/arch/x86/math-emu/fpu_trig.c
+++ b/arch/x86/math-emu/fpu_trig.c
@@ -432,13 +432,13 @@ static void fxtract(FPU_REG *st0_ptr, u_char st0_tag)
 #endif /* PARANOID */
 }
 
-static void fdecstp(void)
+static void fdecstp(FPU_REG *st0_ptr, u_char st0_tag)
 {
 	clear_C1();
 	top--;
 }
 
-static void fincstp(void)
+static void fincstp(FPU_REG *st0_ptr, u_char st0_tag)
 {
 	clear_C1();
 	top++;
@@ -607,6 +607,11 @@ static int fsin(FPU_REG *st0_ptr, u_char tag)
 	}
 }
 
+static void _fsin(FPU_REG *st0_ptr, u_char tag)
+{
+	fsin(st0_ptr, tag);
+}
+
 static int f_cos(FPU_REG *st0_ptr, u_char tag)
 {
 	u_char st0_sign;
@@ -1625,7 +1630,7 @@ static void fscale(FPU_REG *st0_ptr, u_char st0_tag)
 
 static FUNC_ST0 const trig_table_a[] = {
 	f2xm1, fyl2x, fptan, fpatan,
-	fxtract, fprem1, (FUNC_ST0) fdecstp, (FUNC_ST0) fincstp
+	fxtract, fprem1, fdecstp, fincstp
 };
 
 void FPU_triga(void)
@@ -1634,7 +1639,7 @@ void FPU_triga(void)
 }
 
 static FUNC_ST0 const trig_table_b[] = {
-	fprem, fyl2xp1, fsqrt_, fsincos, frndint_, fscale, (FUNC_ST0) fsin, fcos
+	fprem, fyl2xp1, fsqrt_, fsincos, frndint_, fscale, _fsin, fcos
 };
 
 void FPU_trigb(void)
diff --git a/arch/x86/math-emu/reg_constant.c b/arch/x86/math-emu/reg_constant.c
index 005483549..a3bd67152 100644
--- a/arch/x86/math-emu/reg_constant.c
+++ b/arch/x86/math-emu/reg_constant.c
@@ -107,8 +107,13 @@ static void fldz(int rc)
 
 typedef void (*FUNC_RC) (int);
 
+static  void FPU_RC_illegal(int rc)
+{
+	FPU_illegal();
+}
+
 static FUNC_RC constants_table[] = {
-	fld1, fldl2t, fldl2e, fldpi, fldlg2, fldln2, fldz, (FUNC_RC) FPU_illegal
+	fld1, fldl2t, fldl2e, fldpi, fldlg2, fldln2, fldz, FPU_RC_illegal
 };
 
 void fconst(void)
diff --git a/arch/x86/mm/Makefile b/arch/x86/mm/Makefile
index 96d2b847e..b3db3803f 100644
--- a/arch/x86/mm/Makefile
+++ b/arch/x86/mm/Makefile
@@ -39,3 +39,7 @@ obj-$(CONFIG_X86_INTEL_MPX)	+= mpx.o
 obj-$(CONFIG_X86_INTEL_MEMORY_PROTECTION_KEYS) += pkeys.o
 obj-$(CONFIG_RANDOMIZE_MEMORY) += kaslr.o
 
+quote:="
+obj-$(CONFIG_X86_64)		+= uderef_64.o
+CFLAGS_uderef_64.o		:= -fcall-saved-rax -fcall-saved-rdi -fcall-saved-rsi -fcall-saved-rdx -fcall-saved-rcx -fcall-saved-r8 -fcall-saved-r9 -fcall-saved-r10 -fcall-saved-r11
+
diff --git a/arch/x86/mm/dump_pagetables.c b/arch/x86/mm/dump_pagetables.c
index ea9c49ada..7ab033a78 100644
--- a/arch/x86/mm/dump_pagetables.c
+++ b/arch/x86/mm/dump_pagetables.c
@@ -27,6 +27,7 @@
 struct pg_state {
 	int level;
 	pgprot_t current_prot;
+	pgprot_t current_prots[5];
 	unsigned long start_address;
 	unsigned long current_address;
 	const struct addr_marker *marker;
@@ -184,6 +185,23 @@ static unsigned long normalize_addr(unsigned long u)
 #endif
 }
 
+static pgprot_t merge_prot(pgprot_t old_prot, pgprot_t new_prot)
+{
+	if (!(pgprot_val(new_prot) & _PAGE_PRESENT))
+		return new_prot;
+
+	if (!(pgprot_val(old_prot) & _PAGE_PRESENT))
+		return new_prot;
+
+	if (pgprot_val(old_prot) & _PAGE_NX)
+		pgprot_val(new_prot) |= _PAGE_NX;
+
+	if (!(pgprot_val(old_prot) & _PAGE_RW))
+		pgprot_val(new_prot) &= ~_PAGE_RW;
+
+	return new_prot;
+}
+
 /*
  * This function gets called on a break in a continuous series
  * of PTE entries; the next one is different so we need to
@@ -200,11 +218,13 @@ static void note_page(struct seq_file *m, struct pg_state *st,
 	 * we have now. "break" is either changing perms, levels or
 	 * address space marker.
 	 */
+	new_prot = merge_prot(st->current_prots[level - 1], new_prot);
 	prot = pgprot_val(new_prot);
 	cur = pgprot_val(st->current_prot);
 
 	if (!st->level) {
 		/* First entry */
+		st->current_prots[0] = __pgprot(_PAGE_RW);
 		st->current_prot = new_prot;
 		st->level = level;
 		st->marker = address_markers;
@@ -216,9 +236,8 @@ static void note_page(struct seq_file *m, struct pg_state *st,
 		const char *unit = units;
 		unsigned long delta;
 		int width = sizeof(unsigned long) * 2;
-		pgprotval_t pr = pgprot_val(st->current_prot);
 
-		if (st->check_wx && (pr & _PAGE_RW) && !(pr & _PAGE_NX)) {
+		if (st->check_wx && (cur & _PAGE_RW) && !(cur & _PAGE_NX)) {
 			WARN_ONCE(1,
 				  "x86/mm: Found insecure W+X mapping at address %p/%pS\n",
 				  (void *)st->start_address,
@@ -304,9 +323,10 @@ static void walk_pmd_level(struct seq_file *m, struct pg_state *st, pud_t addr,
 	start = (pmd_t *) pud_page_vaddr(addr);
 	for (i = 0; i < PTRS_PER_PMD; i++) {
 		st->current_address = normalize_addr(P + i * PMD_LEVEL_MULT);
+		prot = pmd_flags(*start);
+		st->current_prots[3] = merge_prot(st->current_prots[2], __pgprot(prot));
 		if (!pmd_none(*start)) {
 			if (pmd_large(*start) || !pmd_present(*start)) {
-				prot = pmd_flags(*start);
 				note_page(m, st, __pgprot(prot), 3);
 			} else {
 				walk_pte_level(m, st, *start,
@@ -337,9 +357,10 @@ static void walk_pud_level(struct seq_file *m, struct pg_state *st, pgd_t addr,
 
 	for (i = 0; i < PTRS_PER_PUD; i++) {
 		st->current_address = normalize_addr(P + i * PUD_LEVEL_MULT);
+		prot = pud_flags(*start);
+		st->current_prots[2] = merge_prot(st->current_prots[1], __pgprot(start->pud));
 		if (!pud_none(*start)) {
 			if (pud_large(*start) || !pud_present(*start)) {
-				prot = pud_flags(*start);
 				note_page(m, st, __pgprot(prot), 2);
 			} else {
 				walk_pmd_level(m, st, *start,
@@ -395,9 +416,10 @@ static void ptdump_walk_pgd_level_core(struct seq_file *m, pgd_t *pgd,
 
 	for (i = 0; i < PTRS_PER_PGD; i++) {
 		st.current_address = normalize_addr(i * PGD_LEVEL_MULT);
+		prot = pgd_flags(*start);
+		st.current_prots[1] = __pgprot(prot);
 		if (!pgd_none(*start) && !is_hypervisor_range(i)) {
 			if (pgd_large(*start) || !pgd_present(*start)) {
-				prot = pgd_flags(*start);
 				note_page(m, &st, __pgprot(prot), 1);
 			} else {
 				walk_pud_level(m, &st, *start,
diff --git a/arch/x86/mm/extable.c b/arch/x86/mm/extable.c
index a3a983fd4..69f609905 100644
--- a/arch/x86/mm/extable.c
+++ b/arch/x86/mm/extable.c
@@ -102,7 +102,7 @@ int fixup_exception(struct pt_regs *regs, int trapnr)
 	ex_handler_t handler;
 
 #ifdef CONFIG_PNPBIOS
-	if (unlikely(SEGMENT_IS_PNP_CODE(regs->cs))) {
+	if (unlikely(!v8086_mode(regs) && SEGMENT_IS_PNP_CODE(regs->cs))) {
 		extern u32 pnp_bios_fault_eip, pnp_bios_fault_esp;
 		extern u32 pnp_bios_is_utter_crap;
 		pnp_bios_is_utter_crap = 1;
diff --git a/arch/x86/mm/fault.c b/arch/x86/mm/fault.c
index dc8023060..b245d863d 100644
--- a/arch/x86/mm/fault.c
+++ b/arch/x86/mm/fault.c
@@ -14,6 +14,8 @@
 #include <linux/prefetch.h>		/* prefetchw			*/
 #include <linux/context_tracking.h>	/* exception_enter(), ...	*/
 #include <linux/uaccess.h>		/* faulthandler_disabled()	*/
+#include <linux/unistd.h>
+#include <linux/compiler.h>
 
 #include <asm/cpufeature.h>		/* boot_cpu_has, ...		*/
 #include <asm/traps.h>			/* dotraplinkage, ...		*/
@@ -23,6 +25,11 @@
 #include <asm/vsyscall.h>		/* emulate_vsyscall		*/
 #include <asm/vm86.h>			/* struct vm86			*/
 #include <asm/mmu_context.h>		/* vma_pkey()			*/
+#include <asm/tlbflush.h>
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+#include <asm/stacktrace.h>
+#endif
 
 #define CREATE_TRACE_POINTS
 #include <asm/trace/exceptions.h>
@@ -126,7 +133,10 @@ check_prefetch_opcode(struct pt_regs *regs, unsigned char *instr,
 		return !instr_lo || (instr_lo>>1) == 1;
 	case 0x00:
 		/* Prefetch instruction is 0x0F0D or 0x0F18 */
-		if (probe_kernel_address(instr, opcode))
+		if (user_mode(regs)) {
+			if (__copy_from_user_inatomic(&opcode, (unsigned char __force_user *)(instr), 1))
+				return 0;
+		} else if (probe_kernel_address(instr, opcode))
 			return 0;
 
 		*prefetch = (instr_lo == 0xF) &&
@@ -151,7 +161,10 @@ is_prefetch(struct pt_regs *regs, unsigned long error_code, unsigned long addr)
 	if (error_code & PF_INSTR)
 		return 0;
 
-	instr = (void *)convert_ip_to_linear(current, regs);
+	addr = convert_ip_to_linear(current, regs);
+	if (addr == -1L)
+		return 0;
+	instr = (void *)addr;
 	max_instr = instr + 15;
 
 	if (user_mode(regs) && instr >= (unsigned char *)TASK_SIZE_MAX)
@@ -160,7 +173,10 @@ is_prefetch(struct pt_regs *regs, unsigned long error_code, unsigned long addr)
 	while (instr < max_instr) {
 		unsigned char opcode;
 
-		if (probe_kernel_address(instr, opcode))
+		if (user_mode(regs)) {
+			if (__copy_from_user_inatomic(&opcode, (unsigned char __force_user *)(instr), 1))
+				break;
+		} else if (probe_kernel_address(instr, opcode))
 			break;
 
 		instr++;
@@ -244,6 +260,34 @@ force_sig_info_fault(int si_signo, int si_code, unsigned long address,
 	force_sig_info(si_signo, &info, tsk);
 }
 
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+static bool pax_is_fetch_fault(struct pt_regs *regs, unsigned long error_code, unsigned long address);
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+static int pax_handle_fetch_fault(struct pt_regs *regs);
+#endif
+
+#ifdef CONFIG_PAX_PAGEEXEC
+static inline pmd_t * pax_get_pmd(struct mm_struct *mm, unsigned long address)
+{
+	pgd_t *pgd;
+	pud_t *pud;
+	pmd_t *pmd;
+
+	pgd = pgd_offset(mm, address);
+	if (!pgd_present(*pgd))
+		return NULL;
+	pud = pud_offset(pgd, address);
+	if (!pud_present(*pud))
+		return NULL;
+	pmd = pmd_offset(pud, address);
+	if (!pmd_present(*pmd))
+		return NULL;
+	return pmd;
+}
+#endif
+
 DEFINE_SPINLOCK(pgd_lock);
 LIST_HEAD(pgd_list);
 
@@ -294,10 +338,27 @@ void vmalloc_sync_all(void)
 	for (address = VMALLOC_START & PMD_MASK;
 	     address >= TASK_SIZE_MAX && address < FIXADDR_TOP;
 	     address += PMD_SIZE) {
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		unsigned long cpu;
+#else
 		struct page *page;
+#endif
 
 		spin_lock(&pgd_lock);
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		for (cpu = 0; cpu < nr_cpu_ids; ++cpu) {
+			pgd_t *pgd = get_cpu_pgd(cpu, user);
+			pmd_t *ret;
+
+			ret = vmalloc_sync_one(pgd, address);
+			if (!ret)
+				break;
+			pgd = get_cpu_pgd(cpu, kernel);
+#else
 		list_for_each_entry(page, &pgd_list, lru) {
+			pgd_t *pgd;
 			spinlock_t *pgt_lock;
 			pmd_t *ret;
 
@@ -305,8 +366,14 @@ void vmalloc_sync_all(void)
 			pgt_lock = &pgd_page_get_mm(page)->page_table_lock;
 
 			spin_lock(pgt_lock);
-			ret = vmalloc_sync_one(page_address(page), address);
+			pgd = page_address(page);
+#endif
+
+			ret = vmalloc_sync_one(pgd, address);
+
+#ifndef CONFIG_PAX_PER_CPU_PGD
 			spin_unlock(pgt_lock);
+#endif
 
 			if (!ret)
 				break;
@@ -340,6 +407,12 @@ static noinline int vmalloc_fault(unsigned long address)
 	 * an interrupt in the middle of a task switch..
 	 */
 	pgd_paddr = read_cr3();
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	BUG_ON(__pa(get_cpu_pgd(smp_processor_id(), kernel)) != (pgd_paddr & __PHYSICAL_MASK));
+	vmalloc_sync_one(__va(pgd_paddr + PTRS_PER_PGD * sizeof(pgd_t)), address);
+#endif
+
 	pmd_k = vmalloc_sync_one(__va(pgd_paddr), address);
 	if (!pmd_k)
 		return -1;
@@ -439,11 +512,24 @@ static noinline int vmalloc_fault(unsigned long address)
 	 * happen within a race in page table update. In the later
 	 * case just flush:
 	 */
-	pgd = (pgd_t *)__va(read_cr3()) + pgd_index(address);
 	pgd_ref = pgd_offset_k(address);
 	if (pgd_none(*pgd_ref))
 		return -1;
 
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	BUG_ON(__pa(get_cpu_pgd(smp_processor_id(), kernel)) != (read_cr3() & __PHYSICAL_MASK));
+	pgd = pgd_offset_cpu(smp_processor_id(), user, address);
+	if (pgd_none(*pgd)) {
+		set_pgd(pgd, *pgd_ref);
+		arch_flush_lazy_mmu_mode();
+	} else {
+		BUG_ON(pgd_page_vaddr(*pgd) != pgd_page_vaddr(*pgd_ref));
+	}
+	pgd = pgd_offset_cpu(smp_processor_id(), kernel, address);
+#else
+	pgd = (pgd_t *)__va(read_cr3()) + pgd_index(address);
+#endif
+
 	if (pgd_none(*pgd)) {
 		set_pgd(pgd, *pgd_ref);
 		arch_flush_lazy_mmu_mode();
@@ -616,7 +702,7 @@ static int is_errata93(struct pt_regs *regs, unsigned long address)
 static int is_errata100(struct pt_regs *regs, unsigned long address)
 {
 #ifdef CONFIG_X86_64
-	if ((regs->cs == __USER32_CS || (regs->cs & (1<<2))) && (address >> 32))
+	if ((regs->cs == __USER32_CS || (regs->cs & SEGMENT_LDT)) && (address >> 32))
 		return 1;
 #endif
 	return 0;
@@ -643,9 +729,9 @@ static int is_f00f_bug(struct pt_regs *regs, unsigned long address)
 }
 
 static const char nx_warning[] = KERN_CRIT
-"kernel tried to execute NX-protected page - exploit attempt? (uid: %d)\n";
+"kernel tried to execute NX-protected page - exploit attempt? (uid: %d, task: %s, pid: %d)\n";
 static const char smep_warning[] = KERN_CRIT
-"unable to execute userspace code (SMEP?) (uid: %d)\n";
+"unable to execute userspace code (SMEP?) (uid: %d, task: %s, pid: %d)\n";
 
 static void
 show_fault_oops(struct pt_regs *regs, unsigned long error_code,
@@ -654,7 +740,7 @@ show_fault_oops(struct pt_regs *regs, unsigned long error_code,
 	if (!oops_may_print())
 		return;
 
-	if (error_code & PF_INSTR) {
+	if ((__supported_pte_mask & _PAGE_NX) && (error_code & PF_INSTR)) {
 		unsigned int level;
 		pgd_t *pgd;
 		pte_t *pte;
@@ -665,12 +751,24 @@ show_fault_oops(struct pt_regs *regs, unsigned long error_code,
 		pte = lookup_address_in_pgd(pgd, address, &level);
 
 		if (pte && pte_present(*pte) && !pte_exec(*pte))
-			printk(nx_warning, from_kuid(&init_user_ns, current_uid()));
+			printk(nx_warning, from_kuid_munged(&init_user_ns, current_uid()), current->comm, task_pid_nr(current));
 		if (pte && pte_present(*pte) && pte_exec(*pte) &&
 				(pgd_flags(*pgd) & _PAGE_USER) &&
 				(__read_cr4() & X86_CR4_SMEP))
-			printk(smep_warning, from_kuid(&init_user_ns, current_uid()));
+			printk(smep_warning, from_kuid(&init_user_ns, current_uid()), current->comm, task_pid_nr(current));
+	}
+
+#ifdef CONFIG_PAX_KERNEXEC
+	if (init_mm.start_code <= address && address < init_mm.end_code) {
+		if (current->signal->curr_ip)
+			printk(KERN_EMERG "PAX: From %pI4: %s:%d, uid/euid: %u/%u, attempted to modify kernel code\n",
+					&current->signal->curr_ip, current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()));
+		else
+			printk(KERN_EMERG "PAX: %s:%d, uid/euid: %u/%u, attempted to modify kernel code\n", current->comm, task_pid_nr(current),
+					from_kuid_munged(&init_user_ns, current_uid()), from_kuid_munged(&init_user_ns, current_euid()));
 	}
+#endif
 
 	printk(KERN_ALERT "BUG: unable to handle kernel ");
 	if (address < PAGE_SIZE)
@@ -855,6 +953,21 @@ __bad_area_nosemaphore(struct pt_regs *regs, unsigned long error_code,
 		}
 #endif
 
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+		if (pax_is_fetch_fault(regs, error_code, address)) {
+
+#ifdef CONFIG_PAX_EMUTRAMP
+			switch (pax_handle_fetch_fault(regs)) {
+			case 2:
+				return;
+			}
+#endif
+
+			pax_report_fault(regs, (void *)regs->ip, (void *)regs->sp);
+			do_group_exit(SIGKILL);
+		}
+#endif
+
 		/*
 		 * To avoid leaking information about the kernel page table
 		 * layout, pretend that user-mode accesses to kernel addresses
@@ -966,7 +1079,7 @@ do_sigbus(struct pt_regs *regs, unsigned long error_code, unsigned long address,
 	if (fault & (VM_FAULT_HWPOISON|VM_FAULT_HWPOISON_LARGE)) {
 		printk(KERN_ERR
 	"MCE: Killing %s:%d due to hardware memory corruption fault at %lx\n",
-			tsk->comm, tsk->pid, address);
+			tsk->comm, task_pid_nr(tsk), address);
 		code = BUS_MCEERR_AR;
 	}
 #endif
@@ -1025,6 +1138,109 @@ static int spurious_fault_check(unsigned long error_code, pte_t *pte)
 	return 1;
 }
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_PAGEEXEC)
+static inline unsigned long get_limit(unsigned long segment)
+{
+	unsigned long __limit;
+
+	asm("lsll %1,%0" : "=r" (__limit) : "r" (segment));
+	return __limit + 1;
+}
+
+static int pax_handle_pageexec_fault(struct pt_regs *regs, struct mm_struct *mm, unsigned long address, unsigned long error_code)
+{
+	pte_t *pte;
+	pmd_t *pmd;
+	spinlock_t *ptl;
+	unsigned char pte_mask;
+
+	if ((__supported_pte_mask & _PAGE_NX) || (error_code & (PF_PROT|PF_USER)) != (PF_PROT|PF_USER) || v8086_mode(regs) ||
+	    !(mm->pax_flags & MF_PAX_PAGEEXEC))
+		return 0;
+
+	/* PaX: it's our fault, let's handle it if we can */
+
+	/* PaX: take a look at read faults before acquiring any locks */
+	if (unlikely(!(error_code & PF_WRITE) && (regs->ip == address))) {
+		/* instruction fetch attempt from a protected page in user mode */
+		up_read(&mm->mmap_sem);
+
+#ifdef CONFIG_PAX_EMUTRAMP
+		switch (pax_handle_fetch_fault(regs)) {
+		case 2:
+			return 1;
+		}
+#endif
+
+		pax_report_fault(regs, (void *)regs->ip, (void *)regs->sp);
+		do_group_exit(SIGKILL);
+	}
+
+	pmd = pax_get_pmd(mm, address);
+	if (unlikely(!pmd))
+		return 0;
+
+	pte = pte_offset_map_lock(mm, pmd, address, &ptl);
+	if (unlikely(!(pte_val(*pte) & _PAGE_PRESENT) || pte_user(*pte))) {
+		pte_unmap_unlock(pte, ptl);
+		return 0;
+	}
+
+	if (unlikely((error_code & PF_WRITE) && !pte_write(*pte))) {
+		/* write attempt to a protected page in user mode */
+		pte_unmap_unlock(pte, ptl);
+		return 0;
+	}
+
+#ifdef CONFIG_SMP
+	if (likely(address > get_limit(regs->cs) && cpumask_test_cpu(smp_processor_id(), &mm->context.cpu_user_cs_mask)))
+#else
+	if (likely(address > get_limit(regs->cs)))
+#endif
+	{
+		set_pte(pte, pte_mkread(*pte));
+		__flush_tlb_one(address);
+		pte_unmap_unlock(pte, ptl);
+		up_read(&mm->mmap_sem);
+		return 1;
+	}
+
+	pte_mask = _PAGE_ACCESSED | _PAGE_USER | ((error_code & PF_WRITE) << (_PAGE_BIT_DIRTY-1));
+
+	/*
+	 * PaX: fill DTLB with user rights and retry
+	 */
+	__asm__ __volatile__ (
+		"orb %2,(%1)\n"
+#if defined(CONFIG_M586) || defined(CONFIG_M586TSC)
+/*
+ * PaX: let this uncommented 'invlpg' remind us on the behaviour of Intel's
+ * (and AMD's) TLBs. namely, they do not cache PTEs that would raise *any*
+ * page fault when examined during a TLB load attempt. this is true not only
+ * for PTEs holding a non-present entry but also present entries that will
+ * raise a page fault (such as those set up by PaX, or the copy-on-write
+ * mechanism). in effect it means that we do *not* need to flush the TLBs
+ * for our target pages since their PTEs are simply not in the TLBs at all.
+
+ * the best thing in omitting it is that we gain around 15-20% speed in the
+ * fast path of the page fault handler and can get rid of tracing since we
+ * can no longer flush unintended entries.
+ */
+		"invlpg (%0)\n"
+#endif
+		ASM_STAC "\n"
+		__copyuser_seg"testb $0,(%0)\n"
+		ASM_CLAC "\n"
+		"xorb %3,(%1)\n"
+		:
+		: "r" (address), "r" (pte), "q" (pte_mask), "i" (_PAGE_USER)
+		: "memory", "cc");
+	pte_unmap_unlock(pte, ptl);
+	up_read(&mm->mmap_sem);
+	return 1;
+}
+#endif
+
 /*
  * Handle a spurious fault caused by a stale TLB entry.
  *
@@ -1112,6 +1328,10 @@ access_error(unsigned long error_code, struct vm_area_struct *vma)
 {
 	/* This is only called for the current mm, so: */
 	bool foreign = false;
+
+	if ((__supported_pte_mask & _PAGE_NX) && (error_code & PF_INSTR) && !(vma->vm_flags & VM_EXEC))
+		return 1;
+
 	/*
 	 * Make sure to check the VMA so that we do not perform
 	 * faults just to hit a PF_PK as soon as we fill in a
@@ -1183,6 +1403,22 @@ __do_page_fault(struct pt_regs *regs, unsigned long error_code,
 	tsk = current;
 	mm = tsk->mm;
 
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	if (!user_mode(regs) && address < 2 * pax_user_shadow_base) {
+		if (!search_exception_tables(regs->ip)) {
+			printk(KERN_EMERG "PAX: please report this to pageexec@freemail.hu\n");
+			bad_area_nosemaphore(regs, error_code, address, NULL);
+			return;
+		}
+		if (address < pax_user_shadow_base) {
+			printk(KERN_EMERG "PAX: please report this to pageexec@freemail.hu\n");
+			printk(KERN_EMERG "PAX: faulting IP: %pS\n", (void *)regs->ip);
+			show_trace_log_lvl(NULL, NULL, (void *)regs->sp, regs->bp, KERN_EMERG);
+		} else
+			address -= pax_user_shadow_base;
+	}
+#endif
+
 	/*
 	 * Detect and handle instructions that would cause a page fault for
 	 * both a tracked kernel page and a userspace page.
@@ -1309,6 +1545,11 @@ retry:
 		might_sleep();
 	}
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_PAGEEXEC)
+	if (pax_handle_pageexec_fault(regs, mm, address, error_code))
+		return;
+#endif
+
 	vma = find_vma(mm, address);
 	if (unlikely(!vma)) {
 		bad_area(regs, error_code, address);
@@ -1320,18 +1561,24 @@ retry:
 		bad_area(regs, error_code, address);
 		return;
 	}
-	if (error_code & PF_USER) {
-		/*
-		 * Accessing the stack below %sp is always a bug.
-		 * The large cushion allows instructions like enter
-		 * and pusha to work. ("enter $65535, $31" pushes
-		 * 32 pointers and then decrements %sp by 65535.)
-		 */
-		if (unlikely(address + 65536 + 32 * sizeof(unsigned long) < regs->sp)) {
-			bad_area(regs, error_code, address);
-			return;
-		}
+	/*
+	 * Accessing the stack below %sp is always a bug.
+	 * The large cushion allows instructions like enter
+	 * and pusha to work. ("enter $65535, $31" pushes
+	 * 32 pointers and then decrements %sp by 65535.)
+	 */
+	if (unlikely(address + 65536 + 32 * sizeof(unsigned long) < task_pt_regs(tsk)->sp)) {
+		bad_area(regs, error_code, address);
+		return;
 	}
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (unlikely((mm->pax_flags & MF_PAX_SEGMEXEC) && vma->vm_end - SEGMEXEC_TASK_SIZE - 1 < address - SEGMEXEC_TASK_SIZE - 1)) {
+		bad_area(regs, error_code, address);
+		return;
+	}
+#endif
+
 	if (unlikely(expand_stack(vma, address))) {
 		bad_area(regs, error_code, address);
 		return;
@@ -1451,3 +1698,292 @@ trace_do_page_fault(struct pt_regs *regs, unsigned long error_code)
 }
 NOKPROBE_SYMBOL(trace_do_page_fault);
 #endif /* CONFIG_TRACING */
+
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+static bool pax_is_fetch_fault(struct pt_regs *regs, unsigned long error_code, unsigned long address)
+{
+	struct mm_struct *mm = current->mm;
+	unsigned long ip = regs->ip;
+
+	if (v8086_mode(regs))
+		ip = ((regs->cs & 0xffff) << 4) + (ip & 0xffff);
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (mm->pax_flags & MF_PAX_PAGEEXEC) {
+		if ((__supported_pte_mask & _PAGE_NX) && (error_code & PF_INSTR))
+			return true;
+		if (!(error_code & (PF_PROT | PF_WRITE)) && ip == address)
+			return true;
+		return false;
+	}
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC) {
+		if (!(error_code & (PF_PROT | PF_WRITE)) && (ip + SEGMEXEC_TASK_SIZE == address))
+			return true;
+		return false;
+	}
+#endif
+
+	return false;
+}
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+static int pax_handle_fetch_fault_32(struct pt_regs *regs)
+{
+	int err;
+
+	do { /* PaX: libffi trampoline emulation */
+		unsigned char mov, jmp;
+		unsigned int addr1, addr2;
+
+#ifdef CONFIG_X86_64
+		if ((regs->ip + 9) >> 32)
+			break;
+#endif
+
+		err = get_user(mov, (unsigned char __user *)regs->ip);
+		err |= get_user(addr1, (unsigned int __user *)(regs->ip + 1));
+		err |= get_user(jmp, (unsigned char __user *)(regs->ip + 5));
+		err |= get_user(addr2, (unsigned int __user *)(regs->ip + 6));
+
+		if (err)
+			break;
+
+		if (mov == 0xB8 && jmp == 0xE9) {
+			regs->ax = addr1;
+			regs->ip = (unsigned int)(regs->ip + addr2 + 10);
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: gcc trampoline emulation #1 */
+		unsigned char mov1, mov2;
+		unsigned short jmp;
+		unsigned int addr1, addr2;
+
+#ifdef CONFIG_X86_64
+		if ((regs->ip + 11) >> 32)
+			break;
+#endif
+
+		err = get_user(mov1, (unsigned char __user *)regs->ip);
+		err |= get_user(addr1, (unsigned int __user *)(regs->ip + 1));
+		err |= get_user(mov2, (unsigned char __user *)(regs->ip + 5));
+		err |= get_user(addr2, (unsigned int __user *)(regs->ip + 6));
+		err |= get_user(jmp, (unsigned short __user *)(regs->ip + 10));
+
+		if (err)
+			break;
+
+		if (mov1 == 0xB9 && mov2 == 0xB8 && jmp == 0xE0FF) {
+			regs->cx = addr1;
+			regs->ax = addr2;
+			regs->ip = addr2;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: gcc trampoline emulation #2 */
+		unsigned char mov, jmp;
+		unsigned int addr1, addr2;
+
+#ifdef CONFIG_X86_64
+		if ((regs->ip + 9) >> 32)
+			break;
+#endif
+
+		err = get_user(mov, (unsigned char __user *)regs->ip);
+		err |= get_user(addr1, (unsigned int __user *)(regs->ip + 1));
+		err |= get_user(jmp, (unsigned char __user *)(regs->ip + 5));
+		err |= get_user(addr2, (unsigned int __user *)(regs->ip + 6));
+
+		if (err)
+			break;
+
+		if (mov == 0xB9 && jmp == 0xE9) {
+			regs->cx = addr1;
+			regs->ip = (unsigned int)(regs->ip + addr2 + 10);
+			return 2;
+		}
+	} while (0);
+
+	return 1; /* PaX in action */
+}
+
+#ifdef CONFIG_X86_64
+static int pax_handle_fetch_fault_64(struct pt_regs *regs)
+{
+	int err;
+
+	do { /* PaX: libffi trampoline emulation */
+		unsigned short mov1, mov2, jmp1;
+		unsigned char stcclc, jmp2;
+		unsigned long addr1, addr2;
+
+		err = get_user(mov1, (unsigned short __user *)regs->ip);
+		err |= get_user(addr1, (unsigned long __user *)(regs->ip + 2));
+		err |= get_user(mov2, (unsigned short __user *)(regs->ip + 10));
+		err |= get_user(addr2, (unsigned long __user *)(regs->ip + 12));
+		err |= get_user(stcclc, (unsigned char __user *)(regs->ip + 20));
+		err |= get_user(jmp1, (unsigned short __user *)(regs->ip + 21));
+		err |= get_user(jmp2, (unsigned char __user *)(regs->ip + 23));
+
+		if (err)
+			break;
+
+		if (mov1 == 0xBB49 && mov2 == 0xBA49 && (stcclc == 0xF8 || stcclc == 0xF9) && jmp1 == 0xFF49 && jmp2 == 0xE3) {
+			regs->r11 = addr1;
+			regs->r10 = addr2;
+			if (stcclc == 0xF8)
+				regs->flags &= ~X86_EFLAGS_CF;
+			else
+				regs->flags |= X86_EFLAGS_CF;
+			regs->ip = addr1;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: gcc trampoline emulation #1 */
+		unsigned short mov1, mov2, jmp1;
+		unsigned char jmp2;
+		unsigned int addr1;
+		unsigned long addr2;
+
+		err = get_user(mov1, (unsigned short __user *)regs->ip);
+		err |= get_user(addr1, (unsigned int __user *)(regs->ip + 2));
+		err |= get_user(mov2, (unsigned short __user *)(regs->ip + 6));
+		err |= get_user(addr2, (unsigned long __user *)(regs->ip + 8));
+		err |= get_user(jmp1, (unsigned short __user *)(regs->ip + 16));
+		err |= get_user(jmp2, (unsigned char __user *)(regs->ip + 18));
+
+		if (err)
+			break;
+
+		if (mov1 == 0xBB41 && mov2 == 0xBA49 && jmp1 == 0xFF49 && jmp2 == 0xE3) {
+			regs->r11 = addr1;
+			regs->r10 = addr2;
+			regs->ip = addr1;
+			return 2;
+		}
+	} while (0);
+
+	do { /* PaX: gcc trampoline emulation #2 */
+		unsigned short mov1, mov2, jmp1;
+		unsigned char jmp2;
+		unsigned long addr1, addr2;
+
+		err = get_user(mov1, (unsigned short __user *)regs->ip);
+		err |= get_user(addr1, (unsigned long __user *)(regs->ip + 2));
+		err |= get_user(mov2, (unsigned short __user *)(regs->ip + 10));
+		err |= get_user(addr2, (unsigned long __user *)(regs->ip + 12));
+		err |= get_user(jmp1, (unsigned short __user *)(regs->ip + 20));
+		err |= get_user(jmp2, (unsigned char __user *)(regs->ip + 22));
+
+		if (err)
+			break;
+
+		if (mov1 == 0xBB49 && mov2 == 0xBA49 && jmp1 == 0xFF49 && jmp2 == 0xE3) {
+			regs->r11 = addr1;
+			regs->r10 = addr2;
+			regs->ip = addr1;
+			return 2;
+		}
+	} while (0);
+
+	return 1; /* PaX in action */
+}
+#endif
+
+/*
+ * PaX: decide what to do with offenders (regs->ip = fault address)
+ *
+ * returns 1 when task should be killed
+ *         2 when gcc trampoline was detected
+ */
+static int pax_handle_fetch_fault(struct pt_regs *regs)
+{
+	if (v8086_mode(regs))
+		return 1;
+
+	if (!(current->mm->pax_flags & MF_PAX_EMUTRAMP))
+		return 1;
+
+#ifdef CONFIG_X86_32
+	return pax_handle_fetch_fault_32(regs);
+#else
+	if (regs->cs == __USER32_CS || (regs->cs & SEGMENT_LDT))
+		return pax_handle_fetch_fault_32(regs);
+	else
+		return pax_handle_fetch_fault_64(regs);
+#endif
+}
+#endif
+
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+void pax_report_insns(struct pt_regs *regs, void *pc, void *sp)
+{
+	long i;
+
+	printk(KERN_ERR "PAX: bytes at PC: ");
+	for (i = 0; i < 20; i++) {
+		unsigned char c;
+		if (get_user(c, (unsigned char __force_user *)pc+i))
+			printk(KERN_CONT "?? ");
+		else
+			printk(KERN_CONT "%02x ", c);
+	}
+	printk("\n");
+
+	printk(KERN_ERR "PAX: bytes at SP-%lu: ", (unsigned long)sizeof(long));
+	for (i = -1; i < 80 / (long)sizeof(long); i++) {
+		unsigned long c;
+		if (get_user(c, (unsigned long __force_user *)sp+i)) {
+#ifdef CONFIG_X86_32
+			printk(KERN_CONT "???????? ");
+#else
+			if ((regs->cs == __USER32_CS || (regs->cs & SEGMENT_LDT)))
+				printk(KERN_CONT "???????? ???????? ");
+			else
+				printk(KERN_CONT "???????????????? ");
+#endif
+		} else {
+#ifdef CONFIG_X86_64
+			if ((regs->cs == __USER32_CS || (regs->cs & SEGMENT_LDT))) {
+				printk(KERN_CONT "%08x ", (unsigned int)c);
+				printk(KERN_CONT "%08x ", (unsigned int)(c >> 32));
+			} else
+#endif
+				printk(KERN_CONT "%0*lx ", 2 * (int)sizeof(long), c);
+		}
+	}
+	printk("\n");
+}
+#endif
+
+/**
+ * probe_kernel_write(): safely attempt to write to a location
+ * @dst: address to write to
+ * @src: pointer to the data that shall be written
+ * @size: size of the data chunk
+ *
+ * Safely write to address @dst from the buffer at @src.  If a kernel fault
+ * happens, handle that and return -EFAULT.
+ */
+long notrace probe_kernel_write(void *dst, const void *src, size_t size)
+{
+	long ret;
+	mm_segment_t old_fs = get_fs();
+
+	set_fs(KERNEL_DS);
+	pagefault_disable();
+	pax_open_kernel();
+	ret = __copy_to_user_inatomic((void __force_user *)dst, src, size);
+	pax_close_kernel();
+	pagefault_enable();
+	set_fs(old_fs);
+
+	return ret ? -EFAULT : 0;
+}
diff --git a/arch/x86/mm/gup.c b/arch/x86/mm/gup.c
index b8b6a60b3..9193b7895 100644
--- a/arch/x86/mm/gup.c
+++ b/arch/x86/mm/gup.c
@@ -313,7 +313,7 @@ int __get_user_pages_fast(unsigned long start, int nr_pages, int write,
 	addr = start;
 	len = (unsigned long) nr_pages << PAGE_SHIFT;
 	end = start + len;
-	if (unlikely(!access_ok(write ? VERIFY_WRITE : VERIFY_READ,
+	if (unlikely(!access_ok_noprefault(write ? VERIFY_WRITE : VERIFY_READ,
 					(void __user *)start, len)))
 		return 0;
 
@@ -389,6 +389,10 @@ int get_user_pages_fast(unsigned long start, int nr_pages, int write,
 		goto slow_irqon;
 #endif
 
+	if (unlikely(!access_ok_noprefault(write ? VERIFY_WRITE : VERIFY_READ,
+					(void __user *)start, len)))
+		return 0;
+
 	/*
 	 * XXX: batch / limit 'nr', to avoid large irq off latency
 	 * needs some instrumenting to determine the common sizes used by
diff --git a/arch/x86/mm/highmem_32.c b/arch/x86/mm/highmem_32.c
index 6d18b70ed..9dc249e04 100644
--- a/arch/x86/mm/highmem_32.c
+++ b/arch/x86/mm/highmem_32.c
@@ -35,6 +35,8 @@ void *kmap_atomic_prot(struct page *page, pgprot_t prot)
 	unsigned long vaddr;
 	int idx, type;
 
+	BUG_ON(pgprot_val(prot) & _PAGE_USER);
+
 	preempt_disable();
 	pagefault_disable();
 
@@ -45,7 +47,11 @@ void *kmap_atomic_prot(struct page *page, pgprot_t prot)
 	idx = type + KM_TYPE_NR*smp_processor_id();
 	vaddr = __fix_to_virt(FIX_KMAP_BEGIN + idx);
 	BUG_ON(!pte_none(*(kmap_pte-idx)));
+
+	pax_open_kernel();
 	set_pte(kmap_pte-idx, mk_pte(page, prot));
+	pax_close_kernel();
+
 	arch_flush_lazy_mmu_mode();
 
 	return (void *)vaddr;
diff --git a/arch/x86/mm/hugetlbpage.c b/arch/x86/mm/hugetlbpage.c
index 2ae8584b4..e8f8f2948 100644
--- a/arch/x86/mm/hugetlbpage.c
+++ b/arch/x86/mm/hugetlbpage.c
@@ -74,23 +74,24 @@ int pud_huge(pud_t pud)
 #ifdef CONFIG_HUGETLB_PAGE
 static unsigned long hugetlb_get_unmapped_area_bottomup(struct file *file,
 		unsigned long addr, unsigned long len,
-		unsigned long pgoff, unsigned long flags)
+		unsigned long pgoff, unsigned long flags, unsigned long offset)
 {
 	struct hstate *h = hstate_file(file);
 	struct vm_unmapped_area_info info;
-
+	
 	info.flags = 0;
 	info.length = len;
 	info.low_limit = current->mm->mmap_legacy_base;
 	info.high_limit = TASK_SIZE;
 	info.align_mask = PAGE_MASK & ~huge_page_mask(h);
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	return vm_unmapped_area(&info);
 }
 
 static unsigned long hugetlb_get_unmapped_area_topdown(struct file *file,
 		unsigned long addr0, unsigned long len,
-		unsigned long pgoff, unsigned long flags)
+		unsigned long pgoff, unsigned long flags, unsigned long offset)
 {
 	struct hstate *h = hstate_file(file);
 	struct vm_unmapped_area_info info;
@@ -102,6 +103,7 @@ static unsigned long hugetlb_get_unmapped_area_topdown(struct file *file,
 	info.high_limit = current->mm->mmap_base;
 	info.align_mask = PAGE_MASK & ~huge_page_mask(h);
 	info.align_offset = 0;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 	/*
@@ -114,6 +116,12 @@ static unsigned long hugetlb_get_unmapped_area_topdown(struct file *file,
 		VM_BUG_ON(addr != -ENOMEM);
 		info.flags = 0;
 		info.low_limit = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (current->mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += current->mm->delta_mmap;
+#endif
+
 		info.high_limit = TASK_SIZE;
 		addr = vm_unmapped_area(&info);
 	}
@@ -128,10 +136,20 @@ hugetlb_get_unmapped_area(struct file *file, unsigned long addr,
 	struct hstate *h = hstate_file(file);
 	struct mm_struct *mm = current->mm;
 	struct vm_area_struct *vma;
+	unsigned long pax_task_size = TASK_SIZE;
+	unsigned long offset = gr_rand_threadstack_offset(mm, file, flags);
 
 	if (len & ~huge_page_mask(h))
 		return -EINVAL;
-	if (len > TASK_SIZE)
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
+
+	pax_task_size -= PAGE_SIZE;
+
+	if (len > pax_task_size)
 		return -ENOMEM;
 
 	if (flags & MAP_FIXED) {
@@ -140,19 +158,22 @@ hugetlb_get_unmapped_area(struct file *file, unsigned long addr,
 		return addr;
 	}
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		addr = ALIGN(addr, huge_page_size(h));
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (pax_task_size - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 	if (mm->get_unmapped_area == arch_get_unmapped_area)
 		return hugetlb_get_unmapped_area_bottomup(file, addr, len,
-				pgoff, flags);
+				pgoff, flags, offset);
 	else
 		return hugetlb_get_unmapped_area_topdown(file, addr, len,
-				pgoff, flags);
+				pgoff, flags, offset);
 }
 #endif /* CONFIG_HUGETLB_PAGE */
 
diff --git a/arch/x86/mm/init.c b/arch/x86/mm/init.c
index d28a2d741..3e6afa44d 100644
--- a/arch/x86/mm/init.c
+++ b/arch/x86/mm/init.c
@@ -4,6 +4,7 @@
 #include <linux/swap.h>
 #include <linux/memblock.h>
 #include <linux/bootmem.h>	/* for max_low_pfn */
+#include <linux/tboot.h>
 
 #include <asm/cacheflush.h>
 #include <asm/e820.h>
@@ -18,6 +19,7 @@
 #include <asm/dma.h>		/* for MAX_DMA_PFN */
 #include <asm/microcode.h>
 #include <asm/kaslr.h>
+#include <asm/bios_ebda.h>
 
 /*
  * We need to define the tracepoints somewhere, and tlb.c
@@ -633,7 +635,18 @@ void __init init_mem_mapping(void)
 	early_ioremap_page_table_range_init();
 #endif
 
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	clone_pgd_range(get_cpu_pgd(0, kernel) + KERNEL_PGD_BOUNDARY,
+			swapper_pg_dir + KERNEL_PGD_BOUNDARY,
+			KERNEL_PGD_PTRS);
+	clone_pgd_range(get_cpu_pgd(0, user) + KERNEL_PGD_BOUNDARY,
+			swapper_pg_dir + KERNEL_PGD_BOUNDARY,
+			KERNEL_PGD_PTRS);
+	load_cr3(get_cpu_pgd(0, kernel));
+#else
 	load_cr3(swapper_pg_dir);
+#endif
+
 	__flush_tlb_all();
 
 	early_memtest(0, max_pfn_mapped << PAGE_SHIFT);
@@ -649,10 +662,34 @@ void __init init_mem_mapping(void)
  * Access has to be given to non-kernel-ram areas as well, these contain the PCI
  * mmio resources as well as potential bios/acpi data regions.
  */
+
+#ifdef CONFIG_GRKERNSEC_KMEM
+static unsigned int ebda_start __read_only;
+static unsigned int ebda_end __read_only;
+#endif
+
 int devmem_is_allowed(unsigned long pagenr)
 {
+#ifdef CONFIG_GRKERNSEC_KMEM
+	/* allow BDA */
+	if (!pagenr)
+		return 1;
+	/* allow EBDA */
+	if (pagenr >= ebda_start && pagenr < ebda_end)
+		return 1;
+	/* if tboot is in use, allow access to its hardcoded serial log range */
+	if (tboot_enabled() && ((0x60000 >> PAGE_SHIFT) <= pagenr) && (pagenr < (0x68000 >> PAGE_SHIFT)))
+		return 1;
+	if ((ISA_START_ADDRESS >> PAGE_SHIFT) <= pagenr && pagenr < (ISA_END_ADDRESS >> PAGE_SHIFT))
+		return 1;
+	/* throw out everything else below 1MB */
+	if (pagenr <= 256)
+		return 0;
+#else
 	if (pagenr < 256)
 		return 1;
+#endif
+
 	if (iomem_is_exclusive(pagenr << PAGE_SHIFT))
 		return 0;
 	if (!page_is_ram(pagenr))
@@ -699,8 +736,33 @@ void free_init_pages(char *what, unsigned long begin, unsigned long end)
 	}
 }
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+static inline void gr_init_ebda(void)
+{
+	unsigned int ebda_addr;
+	unsigned int ebda_size = 0;
+
+	ebda_addr = get_bios_ebda();
+	if (ebda_addr) {
+		ebda_size = *(unsigned char *)phys_to_virt(ebda_addr);
+		ebda_size <<= 10;
+	}
+	if (ebda_addr && ebda_size) {
+		ebda_start = ebda_addr >> PAGE_SHIFT;
+		ebda_end = min((unsigned int)PAGE_ALIGN(ebda_addr + ebda_size), (unsigned int)0xa0000) >> PAGE_SHIFT;
+	} else {
+		ebda_start = 0x9f000 >> PAGE_SHIFT;
+		ebda_end = 0xa0000 >> PAGE_SHIFT;
+	}
+}
+#else
+static inline void gr_init_ebda(void) { }
+#endif
+
 void free_initmem(void)
 {
+	gr_init_ebda();
+
 	free_init_pages("unused kernel",
 			(unsigned long)(&__init_begin),
 			(unsigned long)(&__init_end));
diff --git a/arch/x86/mm/init_32.c b/arch/x86/mm/init_32.c
index cf8059016..90a1a8f32 100644
--- a/arch/x86/mm/init_32.c
+++ b/arch/x86/mm/init_32.c
@@ -51,6 +51,7 @@
 #include <asm/cacheflush.h>
 #include <asm/page_types.h>
 #include <asm/init.h>
+#include <asm/desc.h>
 
 #include "mm_internal.h"
 
@@ -61,33 +62,6 @@ static noinline int do_test_wp_bit(void);
 bool __read_mostly __vmalloc_start_set = false;
 
 /*
- * Creates a middle page table and puts a pointer to it in the
- * given global directory entry. This only returns the gd entry
- * in non-PAE compilation mode, since the middle layer is folded.
- */
-static pmd_t * __init one_md_table_init(pgd_t *pgd)
-{
-	pud_t *pud;
-	pmd_t *pmd_table;
-
-#ifdef CONFIG_X86_PAE
-	if (!(pgd_val(*pgd) & _PAGE_PRESENT)) {
-		pmd_table = (pmd_t *)alloc_low_page();
-		paravirt_alloc_pmd(&init_mm, __pa(pmd_table) >> PAGE_SHIFT);
-		set_pgd(pgd, __pgd(__pa(pmd_table) | _PAGE_PRESENT));
-		pud = pud_offset(pgd, 0);
-		BUG_ON(pmd_table != pmd_offset(pud, 0));
-
-		return pmd_table;
-	}
-#endif
-	pud = pud_offset(pgd, 0);
-	pmd_table = pmd_offset(pud, 0);
-
-	return pmd_table;
-}
-
-/*
  * Create a page table and place a pointer to it in a middle page
  * directory entry:
  */
@@ -97,13 +71,28 @@ static pte_t * __init one_page_table_init(pmd_t *pmd)
 		pte_t *page_table = (pte_t *)alloc_low_page();
 
 		paravirt_alloc_pte(&init_mm, __pa(page_table) >> PAGE_SHIFT);
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+		set_pmd(pmd, __pmd(__pa(page_table) | _KERNPG_TABLE));
+#else
 		set_pmd(pmd, __pmd(__pa(page_table) | _PAGE_TABLE));
+#endif
 		BUG_ON(page_table != pte_offset_kernel(pmd, 0));
 	}
 
 	return pte_offset_kernel(pmd, 0);
 }
 
+static pmd_t * __init one_md_table_init(pgd_t *pgd)
+{
+	pud_t *pud;
+	pmd_t *pmd_table;
+
+	pud = pud_offset(pgd, 0);
+	pmd_table = pmd_offset(pud, 0);
+
+	return pmd_table;
+}
+
 pmd_t * __init populate_extra_pmd(unsigned long vaddr)
 {
 	int pgd_idx = pgd_index(vaddr);
@@ -208,6 +197,7 @@ page_table_range_init(unsigned long start, unsigned long end, pgd_t *pgd_base)
 	int pgd_idx, pmd_idx;
 	unsigned long vaddr;
 	pgd_t *pgd;
+	pud_t *pud;
 	pmd_t *pmd;
 	pte_t *pte = NULL;
 	unsigned long count = page_table_range_init_count(start, end);
@@ -222,8 +212,13 @@ page_table_range_init(unsigned long start, unsigned long end, pgd_t *pgd_base)
 	pgd = pgd_base + pgd_idx;
 
 	for ( ; (pgd_idx < PTRS_PER_PGD) && (vaddr != end); pgd++, pgd_idx++) {
-		pmd = one_md_table_init(pgd);
-		pmd = pmd + pmd_index(vaddr);
+		pud = pud_offset(pgd, vaddr);
+		pmd = pmd_offset(pud, vaddr);
+
+#ifdef CONFIG_X86_PAE
+		paravirt_alloc_pmd(&init_mm, __pa(pmd) >> PAGE_SHIFT);
+#endif
+
 		for (; (pmd_idx < PTRS_PER_PMD) && (vaddr != end);
 							pmd++, pmd_idx++) {
 			pte = page_table_kmap_check(one_page_table_init(pmd),
@@ -235,11 +230,20 @@ page_table_range_init(unsigned long start, unsigned long end, pgd_t *pgd_base)
 	}
 }
 
-static inline int is_kernel_text(unsigned long addr)
+static inline int is_kernel_text(unsigned long start, unsigned long end)
 {
-	if (addr >= (unsigned long)_text && addr <= (unsigned long)__init_end)
-		return 1;
-	return 0;
+	if ((start >= ktla_ktva((unsigned long)_etext) ||
+	     end <= ktla_ktva((unsigned long)_stext)) &&
+	    (start >= ktla_ktva((unsigned long)_einittext) ||
+	     end <= ktla_ktva((unsigned long)_sinittext)) &&
+
+#ifdef CONFIG_ACPI_SLEEP
+	    (start >= (unsigned long)__va(acpi_wakeup_address) + 0x4000 || end <= (unsigned long)__va(acpi_wakeup_address)) &&
+#endif
+
+	    (start > (unsigned long)__va(0xfffff) || end <= (unsigned long)__va(0xc0000)))
+		return 0;
+	return 1;
 }
 
 /*
@@ -256,9 +260,10 @@ kernel_physical_mapping_init(unsigned long start,
 	unsigned long last_map_addr = end;
 	unsigned long start_pfn, end_pfn;
 	pgd_t *pgd_base = swapper_pg_dir;
-	int pgd_idx, pmd_idx, pte_ofs;
+	unsigned int pgd_idx, pmd_idx, pte_ofs;
 	unsigned long pfn;
 	pgd_t *pgd;
+	pud_t *pud;
 	pmd_t *pmd;
 	pte_t *pte;
 	unsigned pages_2m, pages_4k;
@@ -291,8 +296,13 @@ repeat:
 	pfn = start_pfn;
 	pgd_idx = pgd_index((pfn<<PAGE_SHIFT) + PAGE_OFFSET);
 	pgd = pgd_base + pgd_idx;
-	for (; pgd_idx < PTRS_PER_PGD; pgd++, pgd_idx++) {
-		pmd = one_md_table_init(pgd);
+	for (; pgd_idx < PTRS_PER_PGD && pfn < max_low_pfn; pgd++, pgd_idx++) {
+		pud = pud_offset(pgd, 0);
+		pmd = pmd_offset(pud, 0);
+
+#ifdef CONFIG_X86_PAE
+		paravirt_alloc_pmd(&init_mm, __pa(pmd) >> PAGE_SHIFT);
+#endif
 
 		if (pfn >= end_pfn)
 			continue;
@@ -304,14 +314,13 @@ repeat:
 #endif
 		for (; pmd_idx < PTRS_PER_PMD && pfn < end_pfn;
 		     pmd++, pmd_idx++) {
-			unsigned int addr = pfn * PAGE_SIZE + PAGE_OFFSET;
+			unsigned long address = pfn * PAGE_SIZE + PAGE_OFFSET;
 
 			/*
 			 * Map with big pages if possible, otherwise
 			 * create normal page tables:
 			 */
 			if (use_pse) {
-				unsigned int addr2;
 				pgprot_t prot = PAGE_KERNEL_LARGE;
 				/*
 				 * first pass will use the same initial
@@ -322,11 +331,7 @@ repeat:
 						 _PAGE_PSE);
 
 				pfn &= PMD_MASK >> PAGE_SHIFT;
-				addr2 = (pfn + PTRS_PER_PTE-1) * PAGE_SIZE +
-					PAGE_OFFSET + PAGE_SIZE-1;
-
-				if (is_kernel_text(addr) ||
-				    is_kernel_text(addr2))
+				if (is_kernel_text(address, address + PMD_SIZE))
 					prot = PAGE_KERNEL_LARGE_EXEC;
 
 				pages_2m++;
@@ -343,7 +348,7 @@ repeat:
 			pte_ofs = pte_index((pfn<<PAGE_SHIFT) + PAGE_OFFSET);
 			pte += pte_ofs;
 			for (; pte_ofs < PTRS_PER_PTE && pfn < end_pfn;
-			     pte++, pfn++, pte_ofs++, addr += PAGE_SIZE) {
+			     pte++, pfn++, pte_ofs++, address += PAGE_SIZE) {
 				pgprot_t prot = PAGE_KERNEL;
 				/*
 				 * first pass will use the same initial
@@ -351,7 +356,7 @@ repeat:
 				 */
 				pgprot_t init_prot = __pgprot(PTE_IDENT_ATTR);
 
-				if (is_kernel_text(addr))
+				if (is_kernel_text(address, address + PAGE_SIZE))
 					prot = PAGE_KERNEL_EXEC;
 
 				pages_4k++;
@@ -471,7 +476,7 @@ void __init native_pagetable_init(void)
 
 		pud = pud_offset(pgd, va);
 		pmd = pmd_offset(pud, va);
-		if (!pmd_present(*pmd))
+		if (!pmd_present(*pmd)) // PAX TODO || pmd_large(*pmd))
 			break;
 
 		/* should not be large page here */
@@ -529,12 +534,10 @@ void __init early_ioremap_page_table_range_init(void)
 
 static void __init pagetable_init(void)
 {
-	pgd_t *pgd_base = swapper_pg_dir;
-
-	permanent_kmaps_init(pgd_base);
+	permanent_kmaps_init(swapper_pg_dir);
 }
 
-pteval_t __supported_pte_mask __read_mostly = ~(_PAGE_NX | _PAGE_GLOBAL);
+pteval_t __supported_pte_mask __read_only = ~(_PAGE_NX | _PAGE_GLOBAL);
 EXPORT_SYMBOL_GPL(__supported_pte_mask);
 
 /* user-defined highmem size */
@@ -784,10 +787,10 @@ void __init mem_init(void)
 		((unsigned long)&__init_end -
 		 (unsigned long)&__init_begin) >> 10,
 
-		(unsigned long)&_etext, (unsigned long)&_edata,
-		((unsigned long)&_edata - (unsigned long)&_etext) >> 10,
+		(unsigned long)&_sdata, (unsigned long)&_edata,
+		((unsigned long)&_edata - (unsigned long)&_sdata) >> 10,
 
-		(unsigned long)&_text, (unsigned long)&_etext,
+		ktla_ktva((unsigned long)&_text), ktla_ktva((unsigned long)&_etext),
 		((unsigned long)&_etext - (unsigned long)&_text) >> 10);
 
 	/*
@@ -867,7 +870,7 @@ static noinline int do_test_wp_bit(void)
 const int rodata_test_data = 0xC3;
 EXPORT_SYMBOL_GPL(rodata_test_data);
 
-int kernel_set_to_readonly __read_mostly;
+int kernel_set_to_readonly __read_only;
 
 void set_kernel_text_rw(void)
 {
@@ -877,6 +880,7 @@ void set_kernel_text_rw(void)
 	if (!kernel_set_to_readonly)
 		return;
 
+	start = ktla_ktva(start);
 	pr_debug("Set kernel text: %lx - %lx for read write\n",
 		 start, start+size);
 
@@ -891,6 +895,7 @@ void set_kernel_text_ro(void)
 	if (!kernel_set_to_readonly)
 		return;
 
+	start = ktla_ktva(start);
 	pr_debug("Set kernel text: %lx - %lx for read only\n",
 		 start, start+size);
 
@@ -903,7 +908,7 @@ static void mark_nxdata_nx(void)
 	 * When this called, init has already been executed and released,
 	 * so everything past _etext should be NX.
 	 */
-	unsigned long start = PFN_ALIGN(_etext);
+	unsigned long start = ktla_ktva(PFN_ALIGN(_etext));
 	/*
 	 * This comes from is_kernel_text upper limit. Also HPAGE where used:
 	 */
@@ -919,26 +924,52 @@ void mark_rodata_ro(void)
 	unsigned long start = PFN_ALIGN(_text);
 	unsigned long size = PFN_ALIGN(_etext) - start;
 
-	set_pages_ro(virt_to_page(start), size >> PAGE_SHIFT);
-	printk(KERN_INFO "Write protecting the kernel text: %luk\n",
-		size >> 10);
+#ifdef CONFIG_PAX_KERNEXEC
+	/* PaX: limit KERNEL_CS to actual size */
+	unsigned long limit;
+	struct desc_struct d;
+	int cpu;
 
+	limit = get_kernel_rpl() ? ktva_ktla(0xffffffff) : (unsigned long)&_etext;
+	limit = (limit - 1UL) >> PAGE_SHIFT;
+
+	memset(__LOAD_PHYSICAL_ADDR + PAGE_OFFSET, POISON_FREE_INITMEM, PAGE_SIZE);
+	for (cpu = 0; cpu < nr_cpu_ids; cpu++) {
+		pack_descriptor(&d, get_desc_base(&get_cpu_gdt_table(cpu)[GDT_ENTRY_KERNEL_CS]), limit, 0x9B, 0xC);
+		write_gdt_entry(get_cpu_gdt_table(cpu), GDT_ENTRY_KERNEL_CS, &d, DESCTYPE_S);
+		write_gdt_entry(get_cpu_gdt_table(cpu), GDT_ENTRY_KERNEXEC_KERNEL_CS, &d, DESCTYPE_S);
+	}
+
+#ifdef CONFIG_MODULES
+	set_memory_4k((unsigned long)MODULES_EXEC_VADDR, (MODULES_EXEC_END - MODULES_EXEC_VADDR) >> PAGE_SHIFT);
+#endif
+#endif
+
+	start = ktla_ktva(start);
+#ifdef CONFIG_PAX_KERNEXEC
+	/* PaX: make KERNEL_CS read-only */
+	if (!get_kernel_rpl()) {
+#endif
 	kernel_set_to_readonly = 1;
 
+	set_pages_ro(virt_to_page(start), size >> PAGE_SHIFT);
+	printk(KERN_INFO "Write protecting the kernel text: %luk\n", size >> 10);
+
 #ifdef CONFIG_CPA_DEBUG
-	printk(KERN_INFO "Testing CPA: Reverting %lx-%lx\n",
-		start, start+size);
+	printk(KERN_INFO "Testing CPA: Reverting %lx-%lx\n", start, start+size);
 	set_pages_rw(virt_to_page(start), size>>PAGE_SHIFT);
 
 	printk(KERN_INFO "Testing CPA: write protecting again\n");
 	set_pages_ro(virt_to_page(start), size>>PAGE_SHIFT);
 #endif
+#ifdef CONFIG_PAX_KERNEXEC
+	}
+#endif
 
 	start += size;
-	size = (unsigned long)__end_rodata - start;
+	size = PFN_ALIGN(_sdata) - start;
 	set_pages_ro(virt_to_page(start), size >> PAGE_SHIFT);
-	printk(KERN_INFO "Write protecting the kernel read-only data: %luk\n",
-		size >> 10);
+	printk(KERN_INFO "Write protecting the kernel read-only data: %luk\n", size >> 10);
 	rodata_test();
 
 #ifdef CONFIG_CPA_DEBUG
diff --git a/arch/x86/mm/init_64.c b/arch/x86/mm/init_64.c
index 14b9dd71d..774d5178c 100644
--- a/arch/x86/mm/init_64.c
+++ b/arch/x86/mm/init_64.c
@@ -65,7 +65,7 @@
  * around without checking the pgd every time.
  */
 
-pteval_t __supported_pte_mask __read_mostly = ~0;
+pteval_t __supported_pte_mask __read_only = ~_PAGE_NX;
 EXPORT_SYMBOL_GPL(__supported_pte_mask);
 
 int force_personality32;
@@ -98,7 +98,12 @@ void sync_global_pgds(unsigned long start, unsigned long end, int removed)
 
 	for (address = start; address <= end; address += PGDIR_SIZE) {
 		const pgd_t *pgd_ref = pgd_offset_k(address);
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		unsigned long cpu;
+#else
 		struct page *page;
+#endif
 
 		/*
 		 * When it is called after memory hot remove, pgd_none()
@@ -109,6 +114,25 @@ void sync_global_pgds(unsigned long start, unsigned long end, int removed)
 			continue;
 
 		spin_lock(&pgd_lock);
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		for (cpu = 0; cpu < nr_cpu_ids; ++cpu) {
+			pgd_t *pgd = pgd_offset_cpu(cpu, user, address);
+
+			if (!pgd_none(*pgd_ref) && !pgd_none(*pgd))
+				BUG_ON(pgd_page_vaddr(*pgd)
+				       != pgd_page_vaddr(*pgd_ref));
+
+			if (removed) {
+				if (pgd_none(*pgd_ref) && !pgd_none(*pgd))
+					pgd_clear(pgd);
+			} else {
+				if (pgd_none(*pgd))
+					set_pgd(pgd, *pgd_ref);
+			}
+
+			pgd = pgd_offset_cpu(cpu, kernel, address);
+#else
 		list_for_each_entry(page, &pgd_list, lru) {
 			pgd_t *pgd;
 			spinlock_t *pgt_lock;
@@ -117,6 +141,7 @@ void sync_global_pgds(unsigned long start, unsigned long end, int removed)
 			/* the pgt_lock only for Xen */
 			pgt_lock = &pgd_page_get_mm(page)->page_table_lock;
 			spin_lock(pgt_lock);
+#endif
 
 			if (!pgd_none(*pgd_ref) && !pgd_none(*pgd))
 				BUG_ON(pgd_page_vaddr(*pgd)
@@ -130,7 +155,10 @@ void sync_global_pgds(unsigned long start, unsigned long end, int removed)
 					set_pgd(pgd, *pgd_ref);
 			}
 
+#ifndef CONFIG_PAX_PER_CPU_PGD
 			spin_unlock(pgt_lock);
+#endif
+
 		}
 		spin_unlock(&pgd_lock);
 	}
@@ -163,7 +191,7 @@ static pud_t *fill_pud(pgd_t *pgd, unsigned long vaddr)
 {
 	if (pgd_none(*pgd)) {
 		pud_t *pud = (pud_t *)spp_getpage();
-		pgd_populate(&init_mm, pgd, pud);
+		pgd_populate_kernel(&init_mm, pgd, pud);
 		if (pud != pud_offset(pgd, 0))
 			printk(KERN_ERR "PAGETABLE BUG #00! %p <-> %p\n",
 			       pud, pud_offset(pgd, 0));
@@ -175,7 +203,7 @@ static pmd_t *fill_pmd(pud_t *pud, unsigned long vaddr)
 {
 	if (pud_none(*pud)) {
 		pmd_t *pmd = (pmd_t *) spp_getpage();
-		pud_populate(&init_mm, pud, pmd);
+		pud_populate_kernel(&init_mm, pud, pmd);
 		if (pmd != pmd_offset(pud, 0))
 			printk(KERN_ERR "PAGETABLE BUG #01! %p <-> %p\n",
 			       pmd, pmd_offset(pud, 0));
@@ -204,7 +232,9 @@ void set_pte_vaddr_pud(pud_t *pud_page, unsigned long vaddr, pte_t new_pte)
 	pmd = fill_pmd(pud, vaddr);
 	pte = fill_pte(pmd, vaddr);
 
+	pax_open_kernel();
 	set_pte(pte, new_pte);
+	pax_close_kernel();
 
 	/*
 	 * It's enough to flush this one mapping.
@@ -266,14 +296,12 @@ static void __init __init_extra_mapping(unsigned long phys, unsigned long size,
 		pgd = pgd_offset_k((unsigned long)__va(phys));
 		if (pgd_none(*pgd)) {
 			pud = (pud_t *) spp_getpage();
-			set_pgd(pgd, __pgd(__pa(pud) | _KERNPG_TABLE |
-						_PAGE_USER));
+			set_pgd(pgd, __pgd(__pa(pud) | _PAGE_TABLE));
 		}
 		pud = pud_offset(pgd, (unsigned long)__va(phys));
 		if (pud_none(*pud)) {
 			pmd = (pmd_t *) spp_getpage();
-			set_pud(pud, __pud(__pa(pmd) | _KERNPG_TABLE |
-						_PAGE_USER));
+			set_pud(pud, __pud(__pa(pmd) | _PAGE_TABLE));
 		}
 		pmd = pmd_offset(pud, phys);
 		BUG_ON(!pmd_none(*pmd));
@@ -543,7 +571,7 @@ phys_pud_init(pud_t *pud_page, unsigned long paddr, unsigned long paddr_end,
 					   page_size_mask, prot);
 
 		spin_lock(&init_mm.page_table_lock);
-		pud_populate(&init_mm, pud, pmd);
+		pud_populate_kernel(&init_mm, pud, pmd);
 		spin_unlock(&init_mm.page_table_lock);
 	}
 	__flush_tlb_all();
@@ -590,7 +618,7 @@ kernel_physical_mapping_init(unsigned long paddr_start,
 					   page_size_mask);
 
 		spin_lock(&init_mm.page_table_lock);
-		pgd_populate(&init_mm, pgd, pud);
+		pgd_populate_kernel(&init_mm, pgd, pud);
 		spin_unlock(&init_mm.page_table_lock);
 		pgd_changed = true;
 	}
@@ -1013,7 +1041,7 @@ void __init mem_init(void)
 const int rodata_test_data = 0xC3;
 EXPORT_SYMBOL_GPL(rodata_test_data);
 
-int kernel_set_to_readonly;
+int kernel_set_to_readonly __read_only;
 
 void set_kernel_text_rw(void)
 {
@@ -1042,8 +1070,7 @@ void set_kernel_text_ro(void)
 	if (!kernel_set_to_readonly)
 		return;
 
-	pr_debug("Set kernel text: %lx - %lx for read only\n",
-		 start, end);
+	pr_debug("Set kernel text: %lx - %lx for read only\n", start, end);
 
 	/*
 	 * Set the kernel identity mapping for text RO.
@@ -1054,18 +1081,23 @@ void set_kernel_text_ro(void)
 void mark_rodata_ro(void)
 {
 	unsigned long start = PFN_ALIGN(_text);
+#ifdef CONFIG_PAX_KERNEXEC
+	unsigned long addr;
+	unsigned long end = PFN_ALIGN(_sdata);
+	unsigned long text_end = end;
+#else
 	unsigned long rodata_start = PFN_ALIGN(__start_rodata);
 	unsigned long end = (unsigned long) &__end_rodata_hpage_align;
 	unsigned long text_end = PFN_ALIGN(&__stop___ex_table);
 	unsigned long rodata_end = PFN_ALIGN(&__end_rodata);
+#endif
 	unsigned long all_end;
 
-	printk(KERN_INFO "Write protecting the kernel read-only data: %luk\n",
-	       (end - start) >> 10);
-	set_memory_ro(start, (end - start) >> PAGE_SHIFT);
-
 	kernel_set_to_readonly = 1;
 
+	printk(KERN_INFO "Write protecting the kernel read-only data: %luk\n", (end - start) >> 10);
+	set_memory_ro(start, (end - start) >> PAGE_SHIFT);
+
 	/*
 	 * The rodata/data/bss/brk section (but not the kernel text!)
 	 * should also be not-executable.
@@ -1091,12 +1123,54 @@ void mark_rodata_ro(void)
 	set_memory_ro(start, (end-start) >> PAGE_SHIFT);
 #endif
 
+#ifdef CONFIG_PAX_KERNEXEC
+	/* PaX: ensure that kernel code/rodata is read-only, the rest is non-executable */
+	for (addr = __START_KERNEL_map; addr < __START_KERNEL_map + KERNEL_IMAGE_SIZE; addr += PMD_SIZE) {
+		pgd_t *pgd;
+		pud_t *pud;
+		pmd_t *pmd;
+
+		pgd = pgd_offset_k(addr);
+		pud = pud_offset(pgd, addr);
+		pmd = pmd_offset(pud, addr);
+		if (!pmd_present(*pmd))
+			continue;
+		if (addr >= (unsigned long)_text)
+			BUG_ON(!pmd_large(*pmd));
+		if ((unsigned long)_text <= addr && addr < (unsigned long)_sdata)
+			BUG_ON(pmd_write(*pmd));
+//			set_pmd(pmd, __pmd(pmd_val(*pmd) & ~_PAGE_RW));
+		else
+			BUG_ON(!(pmd_flags(*pmd) & _PAGE_NX));
+//			set_pmd(pmd, __pmd(pmd_val(*pmd) | (_PAGE_NX & __supported_pte_mask)));
+	}
+
+	addr = (unsigned long)__va(__pa(__START_KERNEL_map));
+	end = addr + KERNEL_IMAGE_SIZE;
+	for (; addr < end; addr += PMD_SIZE) {
+		pgd_t *pgd;
+		pud_t *pud;
+		pmd_t *pmd;
+
+		pgd = pgd_offset_k(addr);
+		pud = pud_offset(pgd, addr);
+		pmd = pmd_offset(pud, addr);
+		if (!pmd_present(*pmd))
+			continue;
+		if (addr >= (unsigned long)_text)
+			BUG_ON(!pmd_large(*pmd));
+		if ((unsigned long)__va(__pa(_text)) <= addr && addr < (unsigned long)__va(__pa(_sdata)))
+			BUG_ON(pmd_write(*pmd));
+//			set_pmd(pmd, __pmd(pmd_val(*pmd) & ~_PAGE_RW));
+	}
+#else
 	free_init_pages("unused kernel",
 			(unsigned long) __va(__pa_symbol(text_end)),
 			(unsigned long) __va(__pa_symbol(rodata_start)));
 	free_init_pages("unused kernel",
 			(unsigned long) __va(__pa_symbol(rodata_end)),
 			(unsigned long) __va(__pa_symbol(_sdata)));
+#endif
 
 	debug_checkwx();
 }
diff --git a/arch/x86/mm/iomap_32.c b/arch/x86/mm/iomap_32.c
index ada98b39b..c812b6228 100644
--- a/arch/x86/mm/iomap_32.c
+++ b/arch/x86/mm/iomap_32.c
@@ -65,7 +65,11 @@ void *kmap_atomic_prot_pfn(unsigned long pfn, pgprot_t prot)
 	type = kmap_atomic_idx_push();
 	idx = type + KM_TYPE_NR * smp_processor_id();
 	vaddr = __fix_to_virt(FIX_KMAP_BEGIN + idx);
+
+	pax_open_kernel();
 	set_pte(kmap_pte - idx, pfn_pte(pfn, prot));
+	pax_close_kernel();
+
 	arch_flush_lazy_mmu_mode();
 
 	return (void *)vaddr;
diff --git a/arch/x86/mm/ioremap.c b/arch/x86/mm/ioremap.c
index 7aaa26358..e77438feb 100644
--- a/arch/x86/mm/ioremap.c
+++ b/arch/x86/mm/ioremap.c
@@ -58,8 +58,8 @@ static int __ioremap_check_ram(unsigned long start_pfn, unsigned long nr_pages,
 	unsigned long i;
 
 	for (i = 0; i < nr_pages; ++i)
-		if (pfn_valid(start_pfn + i) &&
-		    !PageReserved(pfn_to_page(start_pfn + i)))
+		if (pfn_valid(start_pfn + i) && (start_pfn + i >= 0x100 ||
+		    !PageReserved(pfn_to_page(start_pfn + i))))
 			return 1;
 
 	return 0;
@@ -80,7 +80,7 @@ static int __ioremap_check_ram(unsigned long start_pfn, unsigned long nr_pages,
  * caller shouldn't need to know that small detail.
  */
 static void __iomem *__ioremap_caller(resource_size_t phys_addr,
-		unsigned long size, enum page_cache_mode pcm, void *caller)
+		resource_size_t size, enum page_cache_mode pcm, void *caller)
 {
 	unsigned long offset, vaddr;
 	resource_size_t pfn, last_pfn, last_addr;
@@ -331,7 +331,7 @@ EXPORT_SYMBOL(ioremap_prot);
  *
  * Caller must ensure there is only one unmapping for the same pointer.
  */
-void iounmap(volatile void __iomem *addr)
+void iounmap(const volatile void __iomem *addr)
 {
 	struct vm_struct *p, *o;
 
@@ -394,31 +394,37 @@ int __init arch_ioremap_pmd_supported(void)
  */
 void *xlate_dev_mem_ptr(phys_addr_t phys)
 {
-	unsigned long start  = phys &  PAGE_MASK;
-	unsigned long offset = phys & ~PAGE_MASK;
-	void *vaddr;
+	phys_addr_t pfn = phys >> PAGE_SHIFT;
 
-	/* If page is RAM, we can use __va. Otherwise ioremap and unmap. */
-	if (page_is_ram(start >> PAGE_SHIFT))
-		return __va(phys);
-
-	vaddr = ioremap_cache(start, PAGE_SIZE);
-	/* Only add the offset on success and return NULL if the ioremap() failed: */
-	if (vaddr)
-		vaddr += offset;
+	if (page_is_ram(pfn)) {
+#ifdef CONFIG_HIGHMEM
+		if (pfn >= max_low_pfn)
+			return kmap_high(pfn_to_page(pfn));
+		else
+#endif
+			return __va(phys);
+	}
 
-	return vaddr;
+	return (void __force *)ioremap_cache(phys, 1);
 }
 
 void unxlate_dev_mem_ptr(phys_addr_t phys, void *addr)
 {
-	if (page_is_ram(phys >> PAGE_SHIFT))
+	phys_addr_t pfn = phys >> PAGE_SHIFT;
+
+	if (page_is_ram(pfn)) {
+#ifdef CONFIG_HIGHMEM
+		if (pfn >= max_low_pfn)
+			kunmap_high(pfn_to_page(pfn));
+#endif
 		return;
+	}
 
-	iounmap((void __iomem *)((unsigned long)addr & PAGE_MASK));
+	iounmap((void __iomem __force *)addr);
 }
 
-static pte_t bm_pte[PAGE_SIZE/sizeof(pte_t)] __page_aligned_bss;
+static pte_t __bm_pte[PAGE_SIZE/sizeof(pte_t)] __page_aligned_rodata;
+static pte_t *bm_pte __read_only = __bm_pte;
 
 static inline pmd_t * __init early_ioremap_pmd(unsigned long addr)
 {
@@ -454,8 +460,14 @@ void __init early_ioremap_init(void)
 	early_ioremap_setup();
 
 	pmd = early_ioremap_pmd(fix_to_virt(FIX_BTMAP_BEGIN));
-	memset(bm_pte, 0, sizeof(bm_pte));
-	pmd_populate_kernel(&init_mm, pmd, bm_pte);
+	if (pmd_none(*pmd))
+#ifdef CONFIG_COMPAT_VDSO
+		pmd_populate_user(&init_mm, pmd, __bm_pte);
+#else
+		pmd_populate_kernel(&init_mm, pmd, __bm_pte);
+#endif
+	else
+		bm_pte = (pte_t *)pmd_page_vaddr(*pmd);
 
 	/*
 	 * The boot-ioremap range spans multiple pmds, for which
diff --git a/arch/x86/mm/kmemcheck/kmemcheck.c b/arch/x86/mm/kmemcheck/kmemcheck.c
index 4515bae36..e16276443 100644
--- a/arch/x86/mm/kmemcheck/kmemcheck.c
+++ b/arch/x86/mm/kmemcheck/kmemcheck.c
@@ -627,9 +627,9 @@ bool kmemcheck_fault(struct pt_regs *regs, unsigned long address,
 	 * memory (e.g. tracked pages)? For now, we need this to avoid
 	 * invoking kmemcheck for PnP BIOS calls.
 	 */
-	if (regs->flags & X86_VM_MASK)
+	if (v8086_mode(regs))
 		return false;
-	if (regs->cs != __KERNEL_CS)
+	if (regs->cs != __KERNEL_CS && regs->cs != __KERNEXEC_KERNEL_CS)
 		return false;
 
 	pte = kmemcheck_pte_lookup(address);
diff --git a/arch/x86/mm/mmap.c b/arch/x86/mm/mmap.c
index d2dc0438d..41dfc2bf2 100644
--- a/arch/x86/mm/mmap.c
+++ b/arch/x86/mm/mmap.c
@@ -52,7 +52,7 @@ static unsigned long stack_maxrandom_size(void)
  * Leave an at least ~128 MB hole with possible stack randomization.
  */
 #define MIN_GAP (128*1024*1024UL + stack_maxrandom_size())
-#define MAX_GAP (TASK_SIZE/6*5)
+#define MAX_GAP (pax_task_size/6*5)
 
 static int mmap_is_legacy(void)
 {
@@ -81,16 +81,31 @@ unsigned long arch_mmap_rnd(void)
 	return rnd << PAGE_SHIFT;
 }
 
-static unsigned long mmap_base(unsigned long rnd)
+static unsigned long mmap_base(struct mm_struct *mm, unsigned long rnd)
 {
 	unsigned long gap = rlimit(RLIMIT_STACK);
+	unsigned long pax_task_size = TASK_SIZE;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
 
 	if (gap < MIN_GAP)
 		gap = MIN_GAP;
 	else if (gap > MAX_GAP)
 		gap = MAX_GAP;
 
-	return PAGE_ALIGN(TASK_SIZE - gap - rnd);
+	return PAGE_ALIGN(pax_task_size - gap - rnd);
+}
+
+static unsigned long mmap_legacy_base(struct mm_struct *mm, unsigned long rnd)
+{
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mmap_is_ia32() && (mm->pax_flags & MF_PAX_SEGMEXEC))
+		return SEGMEXEC_TASK_UNMAPPED_BASE + rnd;
+#endif
+	return TASK_UNMAPPED_BASE + rnd;
 }
 
 /*
@@ -101,18 +116,29 @@ void arch_pick_mmap_layout(struct mm_struct *mm)
 {
 	unsigned long random_factor = 0UL;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
 	if (current->flags & PF_RANDOMIZE)
 		random_factor = arch_mmap_rnd();
 
-	mm->mmap_legacy_base = TASK_UNMAPPED_BASE + random_factor;
+	mm->mmap_legacy_base = mmap_legacy_base(mm, random_factor);
 
 	if (mmap_is_legacy()) {
 		mm->mmap_base = mm->mmap_legacy_base;
 		mm->get_unmapped_area = arch_get_unmapped_area;
 	} else {
-		mm->mmap_base = mmap_base(random_factor);
+		mm->mmap_base = mmap_base(mm, random_factor);
 		mm->get_unmapped_area = arch_get_unmapped_area_topdown;
 	}
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (mm->pax_flags & MF_PAX_RANDMMAP) {
+		mm->mmap_legacy_base += mm->delta_mmap;
+		mm->mmap_base -= mm->delta_mmap + mm->delta_stack;
+	}
+#endif
+
 }
 
 const char *arch_vma_name(struct vm_area_struct *vma)
diff --git a/arch/x86/mm/mmio-mod.c b/arch/x86/mm/mmio-mod.c
index bef36622e..c5b252326 100644
--- a/arch/x86/mm/mmio-mod.c
+++ b/arch/x86/mm/mmio-mod.c
@@ -194,7 +194,7 @@ static void pre(struct kmmio_probe *p, struct pt_regs *regs,
 		break;
 	default:
 		{
-			unsigned char *ip = (unsigned char *)instptr;
+			unsigned char *ip = (unsigned char *)ktla_ktva(instptr);
 			my_trace->opcode = MMIO_UNKNOWN_OP;
 			my_trace->width = 0;
 			my_trace->value = (*ip) << 16 | *(ip + 1) << 8 |
@@ -234,7 +234,7 @@ static void post(struct kmmio_probe *p, unsigned long condition,
 static void ioremap_trace_core(resource_size_t offset, unsigned long size,
 							void __iomem *addr)
 {
-	static atomic_t next_id;
+	static atomic_unchecked_t next_id;
 	struct remap_trace *trace = kmalloc(sizeof(*trace), GFP_KERNEL);
 	/* These are page-unaligned. */
 	struct mmiotrace_map map = {
@@ -258,7 +258,7 @@ static void ioremap_trace_core(resource_size_t offset, unsigned long size,
 			.private = trace
 		},
 		.phys = offset,
-		.id = atomic_inc_return(&next_id)
+		.id = atomic_inc_return_unchecked(&next_id)
 	};
 	map.map_id = trace->id;
 
@@ -290,7 +290,7 @@ void mmiotrace_ioremap(resource_size_t offset, unsigned long size,
 	ioremap_trace_core(offset, size, addr);
 }
 
-static void iounmap_trace_core(volatile void __iomem *addr)
+static void iounmap_trace_core(const volatile void __iomem *addr)
 {
 	struct mmiotrace_map map = {
 		.phys = 0,
@@ -328,7 +328,7 @@ not_enabled:
 	}
 }
 
-void mmiotrace_iounmap(volatile void __iomem *addr)
+void mmiotrace_iounmap(const volatile void __iomem *addr)
 {
 	might_sleep();
 	if (is_enabled()) /* recheck and proper locking in *_core() */
diff --git a/arch/x86/mm/mpx.c b/arch/x86/mm/mpx.c
index 80476878e..6351be431 100644
--- a/arch/x86/mm/mpx.c
+++ b/arch/x86/mm/mpx.c
@@ -193,7 +193,7 @@ static int mpx_insn_decode(struct insn *insn,
 	 */
 	if (!nr_copied)
 		return -EFAULT;
-	insn_init(insn, buf, nr_copied, x86_64);
+	insn_init(insn, (void *)ktva_ktla((unsigned long)buf), nr_copied, x86_64);
 	insn_get_length(insn);
 	/*
 	 * copy_from_user() tries to get as many bytes as we could see in
@@ -293,11 +293,11 @@ siginfo_t *mpx_generate_siginfo(struct pt_regs *regs)
 	 * We were not able to extract an address from the instruction,
 	 * probably because there was something invalid in it.
 	 */
-	if (info->si_addr == (void *)-1) {
+	if (info->si_addr == (void __user *)-1) {
 		err = -EINVAL;
 		goto err_out;
 	}
-	trace_mpx_bounds_register_exception(info->si_addr, bndreg);
+	trace_mpx_bounds_register_exception((void __force_kernel *)info->si_addr, bndreg);
 	return info;
 err_out:
 	/* info might be NULL, but kfree() handles that */
diff --git a/arch/x86/mm/numa.c b/arch/x86/mm/numa.c
index fb682108f..591f415c9 100644
--- a/arch/x86/mm/numa.c
+++ b/arch/x86/mm/numa.c
@@ -528,7 +528,7 @@ static void __init numa_clear_kernel_node_hotplug(void)
 	}
 }
 
-static int __init numa_register_memblks(struct numa_meminfo *mi)
+static int __init __intentional_overflow(-1) numa_register_memblks(struct numa_meminfo *mi)
 {
 	unsigned long uninitialized_var(pfn_align);
 	int i, nid;
diff --git a/arch/x86/mm/pageattr.c b/arch/x86/mm/pageattr.c
index e3353c97d..2a8fbe5bd 100644
--- a/arch/x86/mm/pageattr.c
+++ b/arch/x86/mm/pageattr.c
@@ -265,7 +265,7 @@ static inline pgprot_t static_protections(pgprot_t prot, unsigned long address,
 	 */
 #ifdef CONFIG_PCI_BIOS
 	if (pcibios_enabled && within(pfn, BIOS_BEGIN >> PAGE_SHIFT, BIOS_END >> PAGE_SHIFT))
-		pgprot_val(forbidden) |= _PAGE_NX;
+		pgprot_val(forbidden) |= _PAGE_NX & __supported_pte_mask;
 #endif
 
 	/*
@@ -273,14 +273,14 @@ static inline pgprot_t static_protections(pgprot_t prot, unsigned long address,
 	 * Does not cover __inittext since that is gone later on. On
 	 * 64bit we do not enforce !NX on the low mapping
 	 */
-	if (within(address, (unsigned long)_text, (unsigned long)_etext))
-		pgprot_val(forbidden) |= _PAGE_NX;
+	if (within(address, ktla_ktva((unsigned long)_text), ktla_ktva((unsigned long)_etext)))
+		pgprot_val(forbidden) |= _PAGE_NX & __supported_pte_mask;
 
 	/*
 	 * The .rodata section needs to be read-only. Using the pfn
 	 * catches all aliases.
 	 */
-	if (within(pfn, __pa_symbol(__start_rodata) >> PAGE_SHIFT,
+	if (kernel_set_to_readonly && within(pfn, __pa_symbol(__start_rodata) >> PAGE_SHIFT,
 		   __pa_symbol(__end_rodata) >> PAGE_SHIFT))
 		pgprot_val(forbidden) |= _PAGE_RW;
 
@@ -321,6 +321,13 @@ static inline pgprot_t static_protections(pgprot_t prot, unsigned long address,
 	}
 #endif
 
+#ifdef CONFIG_PAX_KERNEXEC
+	if (within(pfn, __pa(ktla_ktva((unsigned long)&_text)) >> PAGE_SHIFT, __pa((unsigned long)&_sdata) >> PAGE_SHIFT)) {
+		pgprot_val(forbidden) |= _PAGE_RW;
+		pgprot_val(forbidden) |= _PAGE_NX & __supported_pte_mask;
+	}
+#endif
+
 	prot = __pgprot(pgprot_val(prot) & ~pgprot_val(forbidden));
 
 	return prot;
@@ -457,23 +464,37 @@ EXPORT_SYMBOL_GPL(slow_virt_to_phys);
 static void __set_pmd_pte(pte_t *kpte, unsigned long address, pte_t pte)
 {
 	/* change init_mm */
+	pax_open_kernel();
 	set_pte_atomic(kpte, pte);
+
 #ifdef CONFIG_X86_32
 	if (!SHARED_KERNEL_PMD) {
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		unsigned long cpu;
+#else
 		struct page *page;
+#endif
 
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		for (cpu = 0; cpu < nr_cpu_ids; ++cpu) {
+			pgd_t *pgd = get_cpu_pgd(cpu, kernel);
+#else
 		list_for_each_entry(page, &pgd_list, lru) {
-			pgd_t *pgd;
+			pgd_t *pgd = (pgd_t *)page_address(page);
+#endif
+
 			pud_t *pud;
 			pmd_t *pmd;
 
-			pgd = (pgd_t *)page_address(page) + pgd_index(address);
+			pgd += pgd_index(address);
 			pud = pud_offset(pgd, address);
 			pmd = pmd_offset(pud, address);
 			set_pte_atomic((pte_t *)pmd, pte);
 		}
 	}
 #endif
+	pax_close_kernel();
 }
 
 static int
@@ -711,6 +732,8 @@ __split_large_page(struct cpa_data *cpa, pte_t *kpte, unsigned long address,
 }
 
 static int split_large_page(struct cpa_data *cpa, pte_t *kpte,
+			    unsigned long address) __must_hold(&cpa_lock);
+static int split_large_page(struct cpa_data *cpa, pte_t *kpte,
 			    unsigned long address)
 {
 	struct page *base;
@@ -1153,6 +1176,7 @@ static int __cpa_process_fault(struct cpa_data *cpa, unsigned long vaddr,
 	}
 }
 
+static int __change_page_attr(struct cpa_data *cpa, int primary) __must_hold(&cpa_lock);
 static int __change_page_attr(struct cpa_data *cpa, int primary)
 {
 	unsigned long address;
@@ -1211,7 +1235,9 @@ repeat:
 		 * Do we really change anything ?
 		 */
 		if (pte_val(old_pte) != pte_val(new_pte)) {
+			pax_open_kernel();
 			set_pte_atomic(kpte, new_pte);
+			pax_close_kernel();
 			cpa->flags |= CPA_FLUSHTLB;
 		}
 		cpa->numpages = 1;
diff --git a/arch/x86/mm/pat.c b/arch/x86/mm/pat.c
index 170cc4ff0..33d18740d 100644
--- a/arch/x86/mm/pat.c
+++ b/arch/x86/mm/pat.c
@@ -632,7 +632,7 @@ int free_memtype(u64 start, u64 end)
 
 	if (IS_ERR(entry)) {
 		pr_info("x86/PAT: %s:%d freeing invalid memtype [mem %#010Lx-%#010Lx]\n",
-			current->comm, current->pid, start, end - 1);
+			current->comm, task_pid_nr(current), start, end - 1);
 		return -EINVAL;
 	}
 
@@ -804,7 +804,7 @@ int kernel_map_sync_memtype(u64 base, unsigned long size,
 
 	if (ioremap_change_attr((unsigned long)__va(base), id_sz, pcm) < 0) {
 		pr_info("x86/PAT: %s:%d ioremap_change_attr failed %s for [mem %#010Lx-%#010Lx]\n",
-			current->comm, current->pid,
+			current->comm, task_pid_nr(current),
 			cattr_name(pcm),
 			base, (unsigned long long)(base + size-1));
 		return -EINVAL;
@@ -839,7 +839,7 @@ static int reserve_pfn_range(u64 paddr, unsigned long size, pgprot_t *vma_prot,
 		pcm = lookup_memtype(paddr);
 		if (want_pcm != pcm) {
 			pr_warn("x86/PAT: %s:%d map pfn RAM range req %s for [mem %#010Lx-%#010Lx], got %s\n",
-				current->comm, current->pid,
+				current->comm, task_pid_nr(current),
 				cattr_name(want_pcm),
 				(unsigned long long)paddr,
 				(unsigned long long)(paddr + size - 1),
@@ -860,7 +860,7 @@ static int reserve_pfn_range(u64 paddr, unsigned long size, pgprot_t *vma_prot,
 		    !is_new_memtype_allowed(paddr, size, want_pcm, pcm)) {
 			free_memtype(paddr, paddr + size);
 			pr_err("x86/PAT: %s:%d map pfn expected mapping type %s for [mem %#010Lx-%#010Lx], got %s\n",
-			       current->comm, current->pid,
+			       current->comm, task_pid_nr(current),
 			       cattr_name(want_pcm),
 			       (unsigned long long)paddr,
 			       (unsigned long long)(paddr + size - 1),
diff --git a/arch/x86/mm/pat_rbtree.c b/arch/x86/mm/pat_rbtree.c
index de391b7bc..532da7a0a 100644
--- a/arch/x86/mm/pat_rbtree.c
+++ b/arch/x86/mm/pat_rbtree.c
@@ -170,7 +170,7 @@ success:
 
 failure:
 	pr_info("x86/PAT: %s:%d conflicting memory types %Lx-%Lx %s<->%s\n",
-		current->comm, current->pid, start, end,
+		current->comm, task_pid_nr(current), start, end,
 		cattr_name(found_type), cattr_name(match->type));
 	return -EBUSY;
 }
diff --git a/arch/x86/mm/pf_in.c b/arch/x86/mm/pf_in.c
index a23586953..3aa7bdda9 100644
--- a/arch/x86/mm/pf_in.c
+++ b/arch/x86/mm/pf_in.c
@@ -147,7 +147,7 @@ enum reason_type get_ins_type(unsigned long ins_addr)
 	int i;
 	enum reason_type rv = OTHERS;
 
-	p = (unsigned char *)ins_addr;
+	p = (unsigned char *)ktla_ktva(ins_addr);
 	p += skip_prefix(p, &prf);
 	p += get_opcode(p, &opcode);
 
@@ -167,7 +167,7 @@ static unsigned int get_ins_reg_width(unsigned long ins_addr)
 	struct prefix_bits prf;
 	int i;
 
-	p = (unsigned char *)ins_addr;
+	p = (unsigned char *)ktla_ktva(ins_addr);
 	p += skip_prefix(p, &prf);
 	p += get_opcode(p, &opcode);
 
@@ -190,7 +190,7 @@ unsigned int get_ins_mem_width(unsigned long ins_addr)
 	struct prefix_bits prf;
 	int i;
 
-	p = (unsigned char *)ins_addr;
+	p = (unsigned char *)ktla_ktva(ins_addr);
 	p += skip_prefix(p, &prf);
 	p += get_opcode(p, &opcode);
 
@@ -414,7 +414,7 @@ unsigned long get_ins_reg_val(unsigned long ins_addr, struct pt_regs *regs)
 	struct prefix_bits prf;
 	int i;
 
-	p = (unsigned char *)ins_addr;
+	p = (unsigned char *)ktla_ktva(ins_addr);
 	p += skip_prefix(p, &prf);
 	p += get_opcode(p, &opcode);
 	for (i = 0; i < ARRAY_SIZE(reg_rop); i++)
@@ -469,7 +469,7 @@ unsigned long get_ins_imm_val(unsigned long ins_addr)
 	struct prefix_bits prf;
 	int i;
 
-	p = (unsigned char *)ins_addr;
+	p = (unsigned char *)ktla_ktva(ins_addr);
 	p += skip_prefix(p, &prf);
 	p += get_opcode(p, &opcode);
 	for (i = 0; i < ARRAY_SIZE(imm_wop); i++)
diff --git a/arch/x86/mm/pgtable.c b/arch/x86/mm/pgtable.c
index 3feec5af4..0f77f72b2 100644
--- a/arch/x86/mm/pgtable.c
+++ b/arch/x86/mm/pgtable.c
@@ -98,10 +98,75 @@ static inline void pgd_list_del(pgd_t *pgd)
 	list_del(&page->lru);
 }
 
-#define UNSHARED_PTRS_PER_PGD				\
-	(SHARED_KERNEL_PMD ? KERNEL_PGD_BOUNDARY : PTRS_PER_PGD)
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+pgdval_t clone_pgd_mask __read_only = ~_PAGE_PRESENT;
 
+void __shadow_user_pgds(pgd_t *dst, const pgd_t *src)
+{
+	unsigned int count = USER_PGD_PTRS;
+
+	if (!pax_user_shadow_base)
+		return;
+
+	while (count--)
+		*dst++ = __pgd((pgd_val(*src++) | (_PAGE_NX & __supported_pte_mask)) & ~_PAGE_USER);
+}
+#endif
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+void __clone_user_pgds(pgd_t *dst, const pgd_t *src)
+{
+	unsigned int count = USER_PGD_PTRS;
+
+	while (count--) {
+		pgd_t pgd;
+
+#ifdef CONFIG_X86_64
+		pgd = __pgd(pgd_val(*src++) | _PAGE_USER);
+#else
+		pgd = *src++;
+#endif
 
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+		pgd = __pgd(pgd_val(pgd) & clone_pgd_mask);
+#endif
+
+		*dst++ = pgd;
+	}
+
+}
+#endif
+
+#ifdef CONFIG_X86_64
+#define pxd_t				pud_t
+#define pyd_t				pgd_t
+#define paravirt_release_pxd(pfn)	paravirt_release_pud(pfn)
+#define pgtable_pxd_page_ctor(page)	true
+#define pgtable_pxd_page_dtor(page)	do {} while (0)
+#define pxd_free(mm, pud)		pud_free((mm), (pud))
+#define pyd_populate(mm, pgd, pud)	pgd_populate((mm), (pgd), (pud))
+#define pyd_offset(mm, address)		pgd_offset((mm), (address))
+#define PYD_SIZE			PGDIR_SIZE
+#define mm_inc_nr_pxds(mm)		do {} while (0)
+#define mm_dec_nr_pxds(mm)		do {} while (0)
+#else
+#define pxd_t				pmd_t
+#define pyd_t				pud_t
+#define paravirt_release_pxd(pfn)	paravirt_release_pmd(pfn)
+#define pgtable_pxd_page_ctor(page)	pgtable_pmd_page_ctor(page)
+#define pgtable_pxd_page_dtor(page)	pgtable_pmd_page_dtor(page)
+#define pxd_free(mm, pud)		pmd_free((mm), (pud))
+#define pyd_populate(mm, pgd, pud)	pud_populate((mm), (pgd), (pud))
+#define pyd_offset(mm, address)		pud_offset((mm), (address))
+#define PYD_SIZE			PUD_SIZE
+#define mm_inc_nr_pxds(mm)		mm_inc_nr_pmds(mm)
+#define mm_dec_nr_pxds(mm)		mm_dec_nr_pmds(mm)
+#endif
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+static inline void pgd_ctor(struct mm_struct *mm, pgd_t *pgd) {}
+static inline void pgd_dtor(pgd_t *pgd) {}
+#else
 static void pgd_set_mm(pgd_t *pgd, struct mm_struct *mm)
 {
 	BUILD_BUG_ON(sizeof(virt_to_page(pgd)->index) < sizeof(mm));
@@ -142,6 +207,7 @@ static void pgd_dtor(pgd_t *pgd)
 	pgd_list_del(pgd);
 	spin_unlock(&pgd_lock);
 }
+#endif
 
 /*
  * List of all pgd's needed for non-PAE so it can invalidate entries
@@ -154,7 +220,7 @@ static void pgd_dtor(pgd_t *pgd)
  * -- nyc
  */
 
-#ifdef CONFIG_X86_PAE
+#if defined(CONFIG_X86_32) && defined(CONFIG_X86_PAE)
 /*
  * In PAE mode, we need to do a cr3 reload (=tlb flush) when
  * updating the top-level pagetable entries to guarantee the
@@ -166,7 +232,7 @@ static void pgd_dtor(pgd_t *pgd)
  * not shared between pagetables (!SHARED_KERNEL_PMDS), we allocate
  * and initialize the kernel pmds here.
  */
-#define PREALLOCATED_PMDS	UNSHARED_PTRS_PER_PGD
+#define PREALLOCATED_PXDS	(SHARED_KERNEL_PMD ? KERNEL_PGD_BOUNDARY : PTRS_PER_PGD)
 
 void pud_populate(struct mm_struct *mm, pud_t *pudp, pmd_t *pmd)
 {
@@ -184,26 +250,28 @@ void pud_populate(struct mm_struct *mm, pud_t *pudp, pmd_t *pmd)
 	 */
 	flush_tlb_mm(mm);
 }
+#elif defined(CONFIG_X86_64) && defined(CONFIG_PAX_PER_CPU_PGD)
+#define PREALLOCATED_PXDS	USER_PGD_PTRS
 #else  /* !CONFIG_X86_PAE */
 
 /* No need to prepopulate any pagetable entries in non-PAE modes. */
-#define PREALLOCATED_PMDS	0
+#define PREALLOCATED_PXDS	0
 
 #endif	/* CONFIG_X86_PAE */
 
-static void free_pmds(struct mm_struct *mm, pmd_t *pmds[])
+static void free_pxds(struct mm_struct *mm, pxd_t *pxds[])
 {
 	int i;
 
-	for(i = 0; i < PREALLOCATED_PMDS; i++)
-		if (pmds[i]) {
-			pgtable_pmd_page_dtor(virt_to_page(pmds[i]));
-			free_page((unsigned long)pmds[i]);
-			mm_dec_nr_pmds(mm);
+	for(i = 0; i < PREALLOCATED_PXDS; i++)
+		if (pxds[i]) {
+			pgtable_pxd_page_dtor(virt_to_page(pxds[i]));
+			free_page((unsigned long)pxds[i]);
+			mm_dec_nr_pxds(mm);
 		}
 }
 
-static int preallocate_pmds(struct mm_struct *mm, pmd_t *pmds[])
+static int preallocate_pxds(struct mm_struct *mm, pxd_t *pxds[])
 {
 	int i;
 	bool failed = false;
@@ -212,22 +280,22 @@ static int preallocate_pmds(struct mm_struct *mm, pmd_t *pmds[])
 	if (mm == &init_mm)
 		gfp &= ~__GFP_ACCOUNT;
 
-	for(i = 0; i < PREALLOCATED_PMDS; i++) {
-		pmd_t *pmd = (pmd_t *)__get_free_page(gfp);
-		if (!pmd)
+	for(i = 0; i < PREALLOCATED_PXDS; i++) {
+		pxd_t *pxd = (pxd_t *)__get_free_page(gfp);
+		if (!pxd)
 			failed = true;
-		if (pmd && !pgtable_pmd_page_ctor(virt_to_page(pmd))) {
-			free_page((unsigned long)pmd);
-			pmd = NULL;
+		if (pxd && !pgtable_pxd_page_ctor(virt_to_page(pxd))) {
+			free_page((unsigned long)pxd);
+			pxd = NULL;
 			failed = true;
 		}
-		if (pmd)
-			mm_inc_nr_pmds(mm);
-		pmds[i] = pmd;
+		if (pxd)
+			mm_inc_nr_pxds(mm);
+		pxds[i] = pxd;
 	}
 
 	if (failed) {
-		free_pmds(mm, pmds);
+		free_pxds(mm, pxds);
 		return -ENOMEM;
 	}
 
@@ -240,43 +308,47 @@ static int preallocate_pmds(struct mm_struct *mm, pmd_t *pmds[])
  * preallocate which never got a corresponding vma will need to be
  * freed manually.
  */
-static void pgd_mop_up_pmds(struct mm_struct *mm, pgd_t *pgdp)
+static void pgd_mop_up_pxds(struct mm_struct *mm, pgd_t *pgdp)
 {
 	int i;
 
-	for(i = 0; i < PREALLOCATED_PMDS; i++) {
+	for(i = 0; i < PREALLOCATED_PXDS; i++) {
 		pgd_t pgd = pgdp[i];
 
 		if (pgd_val(pgd) != 0) {
-			pmd_t *pmd = (pmd_t *)pgd_page_vaddr(pgd);
+			pxd_t *pxd = (pxd_t *)pgd_page_vaddr(pgd);
 
-			pgdp[i] = native_make_pgd(0);
+			set_pgd(pgdp + i, native_make_pgd(0));
 
-			paravirt_release_pmd(pgd_val(pgd) >> PAGE_SHIFT);
-			pmd_free(mm, pmd);
-			mm_dec_nr_pmds(mm);
+			paravirt_release_pxd(pgd_val(pgd) >> PAGE_SHIFT);
+			pxd_free(mm, pxd);
+			mm_dec_nr_pxds(mm);
 		}
 	}
 }
 
-static void pgd_prepopulate_pmd(struct mm_struct *mm, pgd_t *pgd, pmd_t *pmds[])
+static void pgd_prepopulate_pxd(struct mm_struct *mm, pgd_t *pgd, pxd_t *pxds[])
 {
-	pud_t *pud;
+	pyd_t *pyd;
 	int i;
 
-	if (PREALLOCATED_PMDS == 0) /* Work around gcc-3.4.x bug */
+	if (PREALLOCATED_PXDS == 0) /* Work around gcc-3.4.x bug */
 		return;
 
-	pud = pud_offset(pgd, 0);
+#ifdef CONFIG_X86_64
+	pyd = pyd_offset(mm, 0L);
+#else
+	pyd = pyd_offset(pgd, 0L);
+#endif
 
-	for (i = 0; i < PREALLOCATED_PMDS; i++, pud++) {
-		pmd_t *pmd = pmds[i];
+	for (i = 0; i < PREALLOCATED_PXDS; i++, pyd++) {
+		pxd_t *pxd = pxds[i];
 
 		if (i >= KERNEL_PGD_BOUNDARY)
-			memcpy(pmd, (pmd_t *)pgd_page_vaddr(swapper_pg_dir[i]),
-			       sizeof(pmd_t) * PTRS_PER_PMD);
+			memcpy(pxd, (pxd_t *)pgd_page_vaddr(swapper_pg_dir[i]),
+			       sizeof(pxd_t) * PTRS_PER_PMD);
 
-		pud_populate(mm, pud, pmd);
+		pyd_populate(mm, pyd, pxd);
 	}
 }
 
@@ -358,7 +430,7 @@ static inline void _pgd_free(pgd_t *pgd)
 pgd_t *pgd_alloc(struct mm_struct *mm)
 {
 	pgd_t *pgd;
-	pmd_t *pmds[PREALLOCATED_PMDS];
+	pxd_t *pxds[PREALLOCATED_PXDS];
 
 	pgd = _pgd_alloc();
 
@@ -367,11 +439,11 @@ pgd_t *pgd_alloc(struct mm_struct *mm)
 
 	mm->pgd = pgd;
 
-	if (preallocate_pmds(mm, pmds) != 0)
+	if (preallocate_pxds(mm, pxds) != 0)
 		goto out_free_pgd;
 
 	if (paravirt_pgd_alloc(mm) != 0)
-		goto out_free_pmds;
+		goto out_free_pxds;
 
 	/*
 	 * Make sure that pre-populating the pmds is atomic with
@@ -381,14 +453,14 @@ pgd_t *pgd_alloc(struct mm_struct *mm)
 	spin_lock(&pgd_lock);
 
 	pgd_ctor(mm, pgd);
-	pgd_prepopulate_pmd(mm, pgd, pmds);
+	pgd_prepopulate_pxd(mm, pgd, pxds);
 
 	spin_unlock(&pgd_lock);
 
 	return pgd;
 
-out_free_pmds:
-	free_pmds(mm, pmds);
+out_free_pxds:
+	free_pxds(mm, pxds);
 out_free_pgd:
 	_pgd_free(pgd);
 out:
@@ -397,7 +469,7 @@ out:
 
 void pgd_free(struct mm_struct *mm, pgd_t *pgd)
 {
-	pgd_mop_up_pmds(mm, pgd);
+	pgd_mop_up_pxds(mm, pgd);
 	pgd_dtor(pgd);
 	paravirt_pgd_free(mm, pgd);
 	_pgd_free(pgd);
@@ -530,6 +602,50 @@ void __init reserve_top_address(unsigned long reserve)
 
 int fixmaps_set;
 
+static void fix_user_fixmap(enum fixed_addresses idx, unsigned long address)
+{
+#ifdef CONFIG_X86_64
+	pgd_t *pgd;
+	pud_t *pud;
+	pmd_t *pmd;
+
+	switch (idx) {
+	default:
+		return;
+
+#ifdef CONFIG_X86_VSYSCALL_EMULATION
+	case VSYSCALL_PAGE:
+		break;
+#endif
+	}
+
+	pgd = pgd_offset_k(address);
+	if (!(pgd_val(*pgd) & _PAGE_USER)) {
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		unsigned int cpu;
+		pgd_t *pgd_cpu;
+
+		for_each_possible_cpu(cpu) {
+			pgd_cpu = pgd_offset_cpu(cpu, kernel, address);
+			set_pgd(pgd_cpu, __pgd(pgd_val(*pgd_cpu) | _PAGE_USER));
+
+			pgd_cpu = pgd_offset_cpu(cpu, user, address);
+			set_pgd(pgd_cpu, __pgd(pgd_val(*pgd_cpu) | _PAGE_USER));
+		}
+#endif
+		set_pgd(pgd, __pgd(pgd_val(*pgd) | _PAGE_USER));
+	}
+
+	pud = pud_offset(pgd, address);
+	if (!(pud_val(*pud) & _PAGE_USER))
+		set_pud(pud, __pud(pud_val(*pud) | _PAGE_USER));
+
+	pmd = pmd_offset(pud, address);
+	if (!(pmd_val(*pmd) & _PAGE_USER))
+		set_pmd(pmd, __pmd(pmd_val(*pmd) | _PAGE_USER));
+#endif
+}
+
 void __native_set_fixmap(enum fixed_addresses idx, pte_t pte)
 {
 	unsigned long address = __fix_to_virt(idx);
@@ -540,9 +656,10 @@ void __native_set_fixmap(enum fixed_addresses idx, pte_t pte)
 	}
 	set_pte_vaddr(address, pte);
 	fixmaps_set++;
+	fix_user_fixmap(idx, address);
 }
 
-void native_set_fixmap(enum fixed_addresses idx, phys_addr_t phys,
+void native_set_fixmap(unsigned int idx, phys_addr_t phys,
 		       pgprot_t flags)
 {
 	__native_set_fixmap(idx, pfn_pte(phys >> PAGE_SHIFT, flags));
@@ -606,9 +723,11 @@ int pmd_set_huge(pmd_t *pmd, phys_addr_t addr, pgprot_t prot)
 
 	prot = pgprot_4k_2_large(prot);
 
+	pax_open_kernel();
 	set_pte((pte_t *)pmd, pfn_pte(
 		(u64)addr >> PAGE_SHIFT,
 		__pgprot(pgprot_val(prot) | _PAGE_PSE)));
+	pax_close_kernel();
 
 	return 1;
 }
diff --git a/arch/x86/mm/pgtable_32.c b/arch/x86/mm/pgtable_32.c
index 9adce7768..b698e8be0 100644
--- a/arch/x86/mm/pgtable_32.c
+++ b/arch/x86/mm/pgtable_32.c
@@ -46,10 +46,13 @@ void set_pte_vaddr(unsigned long vaddr, pte_t pteval)
 		return;
 	}
 	pte = pte_offset_kernel(pmd, vaddr);
+
+	pax_open_kernel();
 	if (!pte_none(pteval))
 		set_pte_at(&init_mm, vaddr, pte, pteval);
 	else
 		pte_clear(&init_mm, vaddr, pte);
+	pax_close_kernel();
 
 	/*
 	 * It's enough to flush this one mapping.
diff --git a/arch/x86/mm/setup_nx.c b/arch/x86/mm/setup_nx.c
index f65a33f50..f408a9959 100644
--- a/arch/x86/mm/setup_nx.c
+++ b/arch/x86/mm/setup_nx.c
@@ -6,8 +6,10 @@
 #include <asm/proto.h>
 #include <asm/cpufeature.h>
 
+#if defined(CONFIG_X86_64) || defined(CONFIG_X86_PAE)
 static int disable_nx;
 
+#ifndef CONFIG_PAX_PAGEEXEC
 /*
  * noexec = on|off
  *
@@ -29,12 +31,17 @@ static int __init noexec_setup(char *str)
 	return 0;
 }
 early_param("noexec", noexec_setup);
+#endif
+
+#endif
 
 void x86_configure_nx(void)
 {
+#if defined(CONFIG_X86_64) || defined(CONFIG_X86_PAE)
 	if (boot_cpu_has(X86_FEATURE_NX) && !disable_nx)
 		__supported_pte_mask |= _PAGE_NX;
 	else
+#endif
 		__supported_pte_mask &= ~_PAGE_NX;
 }
 
diff --git a/arch/x86/mm/tlb.c b/arch/x86/mm/tlb.c
index 4dbe65622..b298320a3 100644
--- a/arch/x86/mm/tlb.c
+++ b/arch/x86/mm/tlb.c
@@ -47,7 +47,11 @@ void leave_mm(int cpu)
 		BUG();
 	if (cpumask_test_cpu(cpu, mm_cpumask(active_mm))) {
 		cpumask_clear_cpu(cpu, mm_cpumask(active_mm));
+
+#ifndef CONFIG_PAX_PER_CPU_PGD
 		load_cr3(swapper_pg_dir);
+#endif
+
 		/*
 		 * This gets called in the idle path where RCU
 		 * functions differently.  Tracing normally
@@ -61,6 +65,51 @@ EXPORT_SYMBOL_GPL(leave_mm);
 
 #endif /* CONFIG_SMP */
 
+static void pax_switch_mm(struct mm_struct *next, unsigned int cpu)
+{
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	pax_open_kernel();
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	if (static_cpu_has(X86_FEATURE_PCIDUDEREF))
+		__clone_user_pgds(get_cpu_pgd(cpu, user), next->pgd);
+	else
+#endif
+
+		__clone_user_pgds(get_cpu_pgd(cpu, kernel), next->pgd);
+
+	__shadow_user_pgds(get_cpu_pgd(cpu, kernel) + USER_PGD_PTRS, next->pgd);
+
+	pax_close_kernel();
+
+	BUG_ON((__pa(get_cpu_pgd(cpu, kernel)) | PCID_KERNEL) != (read_cr3() & __PHYSICAL_MASK) && (__pa(get_cpu_pgd(cpu, user)) | PCID_USER) != (read_cr3() & __PHYSICAL_MASK));
+
+#if defined(CONFIG_X86_64) && defined(CONFIG_PAX_MEMORY_UDEREF)
+	if (static_cpu_has(X86_FEATURE_PCIDUDEREF)) {
+		if (static_cpu_has(X86_FEATURE_INVPCID)) {
+			u64 descriptor[2];
+			descriptor[0] = PCID_USER;
+			asm volatile(__ASM_INVPCID : : "d"(&descriptor), "a"(INVPCID_SINGLE_CONTEXT) : "memory");
+			if (!static_cpu_has(X86_FEATURE_STRONGUDEREF)) {
+				descriptor[0] = PCID_KERNEL;
+				asm volatile(__ASM_INVPCID : : "d"(&descriptor), "a"(INVPCID_SINGLE_CONTEXT) : "memory");
+			}
+		} else {
+			write_cr3(__pa(get_cpu_pgd(cpu, user)) | PCID_USER);
+			if (static_cpu_has(X86_FEATURE_STRONGUDEREF))
+				write_cr3(__pa(get_cpu_pgd(cpu, kernel)) | PCID_KERNEL | PCID_NOFLUSH);
+			else
+				write_cr3(__pa(get_cpu_pgd(cpu, kernel)) | PCID_KERNEL);
+		}
+	} else
+#endif
+
+		load_cr3(get_cpu_pgd(cpu, kernel));
+#endif
+
+}
+
 void switch_mm(struct mm_struct *prev, struct mm_struct *next,
 	       struct task_struct *tsk)
 {
@@ -75,9 +124,15 @@ void switch_mm_irqs_off(struct mm_struct *prev, struct mm_struct *next,
 			struct task_struct *tsk)
 {
 	unsigned cpu = smp_processor_id();
+#if defined(CONFIG_X86_32) && defined(CONFIG_SMP) && (defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC))
+	int tlbstate = TLBSTATE_OK;
+#endif
 
 	if (likely(prev != next)) {
 #ifdef CONFIG_SMP
+#if defined(CONFIG_X86_32) && (defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC))
+		tlbstate = this_cpu_read(cpu_tlbstate.state);
+#endif
 		this_cpu_write(cpu_tlbstate.state, TLBSTATE_OK);
 		this_cpu_write(cpu_tlbstate.active_mm, next);
 #endif
@@ -96,7 +151,7 @@ void switch_mm_irqs_off(struct mm_struct *prev, struct mm_struct *next,
 		 * We need to prevent an outcome in which CPU 1 observes
 		 * the new PTE value and CPU 0 observes bit 1 clear in
 		 * mm_cpumask.  (If that occurs, then the IPI will never
-		 * be sent, and CPU 0's TLB will contain a stale entry.)
+		 * be sent, and CPU 1's TLB will contain a stale entry.)
 		 *
 		 * The bad outcome can occur if either CPU's load is
 		 * reordered before that CPU's store, so both CPUs must
@@ -111,7 +166,11 @@ void switch_mm_irqs_off(struct mm_struct *prev, struct mm_struct *next,
 		 * ordering guarantee we need.
 		 *
 		 */
+#ifdef CONFIG_PAX_PER_CPU_PGD
+		pax_switch_mm(next, cpu);
+#else
 		load_cr3(next->pgd);
+#endif
 
 		trace_tlb_flush(TLB_FLUSH_ON_TASK_SWITCH, TLB_FLUSH_ALL);
 
@@ -137,9 +196,31 @@ void switch_mm_irqs_off(struct mm_struct *prev, struct mm_struct *next,
 		if (unlikely(prev->context.ldt != next->context.ldt))
 			load_mm_ldt(next);
 #endif
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_SMP)
+		if (!(__supported_pte_mask & _PAGE_NX)) {
+			smp_mb__before_atomic();
+			cpumask_clear_cpu(cpu, &prev->context.cpu_user_cs_mask);
+			smp_mb__after_atomic();
+			cpumask_set_cpu(cpu, &next->context.cpu_user_cs_mask);
+		}
+#endif
+
+#if defined(CONFIG_X86_32) && (defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC))
+		if (unlikely(prev->context.user_cs_base != next->context.user_cs_base ||
+			     prev->context.user_cs_limit != next->context.user_cs_limit))
+			set_user_cs(next->context.user_cs_base, next->context.user_cs_limit, cpu);
+#ifdef CONFIG_SMP
+		else if (unlikely(tlbstate != TLBSTATE_OK))
+			set_user_cs(next->context.user_cs_base, next->context.user_cs_limit, cpu);
+#endif
+#endif
+
 	}
+	else {
+		pax_switch_mm(next, cpu);
+
 #ifdef CONFIG_SMP
-	  else {
 		this_cpu_write(cpu_tlbstate.state, TLBSTATE_OK);
 		BUG_ON(this_cpu_read(cpu_tlbstate.active_mm) != next);
 
@@ -160,13 +241,30 @@ void switch_mm_irqs_off(struct mm_struct *prev, struct mm_struct *next,
 			 * As above, load_cr3() is serializing and orders TLB
 			 * fills with respect to the mm_cpumask write.
 			 */
+
+#ifndef CONFIG_PAX_PER_CPU_PGD
 			load_cr3(next->pgd);
 			trace_tlb_flush(TLB_FLUSH_ON_TASK_SWITCH, TLB_FLUSH_ALL);
+#endif
+
 			load_mm_cr4(next);
 			load_mm_ldt(next);
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_PAGEEXEC)
+			if (!(__supported_pte_mask & _PAGE_NX))
+				cpumask_set_cpu(cpu, &next->context.cpu_user_cs_mask);
+#endif
+
+#if defined(CONFIG_X86_32) && (defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC))
+#ifdef CONFIG_PAX_PAGEEXEC
+			if (!((next->pax_flags & MF_PAX_PAGEEXEC) && (__supported_pte_mask & _PAGE_NX)))
+#endif
+				set_user_cs(next->context.user_cs_base, next->context.user_cs_limit, cpu);
+#endif
+
 		}
-	}
 #endif
+	}
 }
 
 #ifdef CONFIG_SMP
diff --git b/arch/x86/mm/uderef_64.c b/arch/x86/mm/uderef_64.c
new file mode 100644
index 000000000..3fda3f32d
--- /dev/null
+++ b/arch/x86/mm/uderef_64.c
@@ -0,0 +1,37 @@
+#include <linux/mm.h>
+#include <asm/pgtable.h>
+#include <asm/uaccess.h>
+
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+/* PaX: due to the special call convention these functions must
+ * - remain leaf functions under all configurations,
+ * - never be called directly, only dereferenced from the wrappers.
+ */
+void __used __pax_open_userland(void)
+{
+	unsigned int cpu;
+
+	if (unlikely(!segment_eq(get_fs(), USER_DS)))
+		return;
+
+	cpu = raw_get_cpu();
+	BUG_ON((read_cr3() & ~PAGE_MASK) != PCID_KERNEL);
+	write_cr3(__pa_nodebug(get_cpu_pgd(cpu, user)) | PCID_USER | PCID_NOFLUSH);
+	raw_put_cpu_no_resched();
+}
+EXPORT_SYMBOL(__pax_open_userland);
+
+void __used __pax_close_userland(void)
+{
+	unsigned int cpu;
+
+	if (unlikely(!segment_eq(get_fs(), USER_DS)))
+		return;
+
+	cpu = raw_get_cpu();
+	BUG_ON((read_cr3() & ~PAGE_MASK) != PCID_USER);
+	write_cr3(__pa_nodebug(get_cpu_pgd(cpu, kernel)) | PCID_KERNEL | PCID_NOFLUSH);
+	raw_put_cpu_no_resched();
+}
+EXPORT_SYMBOL(__pax_close_userland);
+#endif
diff --git a/arch/x86/net/bpf_jit.S b/arch/x86/net/bpf_jit.S
index f2a7faf47..b77bb6c35 100644
--- a/arch/x86/net/bpf_jit.S
+++ b/arch/x86/net/bpf_jit.S
@@ -9,6 +9,7 @@
  */
 #include <linux/linkage.h>
 #include <asm/frame.h>
+#include <asm/alternative-asm.h>
 
 /*
  * Calling convention :
@@ -39,6 +40,7 @@ FUNC(sk_load_word_positive_offset)
 	jle	bpf_slow_path_word
 	mov     (SKBDATA,%rsi),%eax
 	bswap   %eax  			/* ntohl() */
+	pax_force_retaddr
 	ret
 
 FUNC(sk_load_half)
@@ -52,6 +54,7 @@ FUNC(sk_load_half_positive_offset)
 	jle	bpf_slow_path_half
 	movzwl	(SKBDATA,%rsi),%eax
 	rol	$8,%ax			# ntohs()
+	pax_force_retaddr
 	ret
 
 FUNC(sk_load_byte)
@@ -62,6 +65,7 @@ FUNC(sk_load_byte_positive_offset)
 	cmp	%esi,%r9d   /* if (offset >= hlen) goto bpf_slow_path_byte */
 	jle	bpf_slow_path_byte
 	movzbl	(SKBDATA,%rsi),%eax
+	pax_force_retaddr
 	ret
 
 /* rsi contains offset and can be scratched */
@@ -85,6 +89,7 @@ bpf_slow_path_word:
 	js	bpf_error
 	mov	- MAX_BPF_STACK + 32(%rbp),%eax
 	bswap	%eax
+	pax_force_retaddr
 	ret
 
 bpf_slow_path_half:
@@ -93,12 +98,14 @@ bpf_slow_path_half:
 	mov	- MAX_BPF_STACK + 32(%rbp),%ax
 	rol	$8,%ax
 	movzwl	%ax,%eax
+	pax_force_retaddr
 	ret
 
 bpf_slow_path_byte:
 	bpf_slow_path_common(1)
 	js	bpf_error
 	movzbl	- MAX_BPF_STACK + 32(%rbp),%eax
+	pax_force_retaddr
 	ret
 
 #define sk_negative_common(SIZE)				\
@@ -123,6 +130,7 @@ FUNC(sk_load_word_negative_offset)
 	sk_negative_common(4)
 	mov	(%rax), %eax
 	bswap	%eax
+	pax_force_retaddr
 	ret
 
 bpf_slow_path_half_neg:
@@ -134,6 +142,7 @@ FUNC(sk_load_half_negative_offset)
 	mov	(%rax),%ax
 	rol	$8,%ax
 	movzwl	%ax,%eax
+	pax_force_retaddr
 	ret
 
 bpf_slow_path_byte_neg:
@@ -143,6 +152,7 @@ bpf_slow_path_byte_neg:
 FUNC(sk_load_byte_negative_offset)
 	sk_negative_common(1)
 	movzbl	(%rax), %eax
+	pax_force_retaddr
 	ret
 
 bpf_error:
@@ -153,4 +163,5 @@ bpf_error:
 	mov	- MAX_BPF_STACK + 16(%rbp),%r14
 	mov	- MAX_BPF_STACK + 24(%rbp),%r15
 	leaveq
+	pax_force_retaddr
 	ret
diff --git a/arch/x86/net/bpf_jit_comp.c b/arch/x86/net/bpf_jit_comp.c
index fe04a04da..99be1fa30 100644
--- a/arch/x86/net/bpf_jit_comp.c
+++ b/arch/x86/net/bpf_jit_comp.c
@@ -14,7 +14,11 @@
 #include <asm/cacheflush.h>
 #include <linux/bpf.h>
 
+#ifdef CONFIG_GRKERNSEC_BPF_HARDEN
+int bpf_jit_enable __read_only;
+#else
 int bpf_jit_enable __read_mostly;
+#endif
 
 /*
  * assembly code in arch/x86/net/bpf_jit.S
@@ -183,7 +187,9 @@ static u8 add_2reg(u8 byte, u32 dst_reg, u32 src_reg)
 static void jit_fill_hole(void *area, unsigned int size)
 {
 	/* fill whole space with int3 instructions */
+	pax_open_kernel();
 	memset(area, 0xcc, size);
+	pax_close_kernel();
 }
 
 struct jit_context {
@@ -1076,7 +1082,9 @@ common_load:
 				pr_err("bpf_jit_compile fatal error\n");
 				return -EFAULT;
 			}
+			pax_open_kernel();
 			memcpy(image + proglen, temp, ilen);
+			pax_close_kernel();
 		}
 		proglen += ilen;
 		addrs[i] = proglen;
@@ -1169,7 +1177,6 @@ struct bpf_prog *bpf_int_jit_compile(struct bpf_prog *prog)
 
 	if (image) {
 		bpf_flush_icache(header, image + proglen);
-		set_memory_ro((unsigned long)header, header->pages);
 		prog->bpf_func = (void *)image;
 		prog->jited = 1;
 	}
@@ -1188,12 +1195,8 @@ void bpf_jit_free(struct bpf_prog *fp)
 	unsigned long addr = (unsigned long)fp->bpf_func & PAGE_MASK;
 	struct bpf_binary_header *header = (void *)addr;
 
-	if (!fp->jited)
-		goto free_filter;
+	if (fp->jited)
+		bpf_jit_binary_free(header);
 
-	set_memory_rw(addr, header->pages);
-	bpf_jit_binary_free(header);
-
-free_filter:
 	bpf_prog_unlock_free(fp);
 }
diff --git a/arch/x86/oprofile/backtrace.c b/arch/x86/oprofile/backtrace.c
index cb31a4440..b9424351c 100644
--- a/arch/x86/oprofile/backtrace.c
+++ b/arch/x86/oprofile/backtrace.c
@@ -47,11 +47,11 @@ dump_user_backtrace_32(struct stack_frame_ia32 *head)
 	struct stack_frame_ia32 *fp;
 	unsigned long bytes;
 
-	bytes = copy_from_user_nmi(bufhead, head, sizeof(bufhead));
+	bytes = copy_from_user_nmi(bufhead, (const char __force_user *)head, sizeof(bufhead));
 	if (bytes != 0)
 		return NULL;
 
-	fp = (struct stack_frame_ia32 *) compat_ptr(bufhead[0].next_frame);
+	fp = (struct stack_frame_ia32 __force_kernel *) compat_ptr(bufhead[0].next_frame);
 
 	oprofile_add_trace(bufhead[0].return_address);
 
@@ -93,7 +93,7 @@ static struct stack_frame *dump_user_backtrace(struct stack_frame *head)
 	struct stack_frame bufhead[2];
 	unsigned long bytes;
 
-	bytes = copy_from_user_nmi(bufhead, head, sizeof(bufhead));
+	bytes = copy_from_user_nmi(bufhead, (const char __force_user *)head, sizeof(bufhead));
 	if (bytes != 0)
 		return NULL;
 
diff --git a/arch/x86/oprofile/nmi_int.c b/arch/x86/oprofile/nmi_int.c
index 28c04123b..568d0a476 100644
--- a/arch/x86/oprofile/nmi_int.c
+++ b/arch/x86/oprofile/nmi_int.c
@@ -23,6 +23,7 @@
 #include <asm/nmi.h>
 #include <asm/msr.h>
 #include <asm/apic.h>
+#include <asm/pgtable.h>
 
 #include "op_counter.h"
 #include "op_x86_model.h"
@@ -615,7 +616,7 @@ enum __force_cpu_type {
 
 static int force_cpu_type;
 
-static int set_cpu_type(const char *str, struct kernel_param *kp)
+static int set_cpu_type(const char *str, const struct kernel_param *kp)
 {
 	if (!strcmp(str, "timer")) {
 		force_cpu_type = timer;
@@ -786,8 +787,11 @@ int __init op_nmi_init(struct oprofile_operations *ops)
 	if (ret)
 		return ret;
 
-	if (!model->num_virt_counters)
-		model->num_virt_counters = model->num_counters;
+	if (!model->num_virt_counters) {
+		pax_open_kernel();
+		const_cast(model->num_virt_counters) = model->num_counters;
+		pax_close_kernel();
+	}
 
 	mux_init(ops);
 
diff --git a/arch/x86/oprofile/op_model_amd.c b/arch/x86/oprofile/op_model_amd.c
index 660a83c82..6ff762bb2 100644
--- a/arch/x86/oprofile/op_model_amd.c
+++ b/arch/x86/oprofile/op_model_amd.c
@@ -518,9 +518,11 @@ static int op_amd_init(struct oprofile_operations *ops)
 		num_counters = AMD64_NUM_COUNTERS;
 	}
 
-	op_amd_spec.num_counters = num_counters;
-	op_amd_spec.num_controls = num_counters;
-	op_amd_spec.num_virt_counters = max(num_counters, NUM_VIRT_COUNTERS);
+	pax_open_kernel();
+	const_cast(op_amd_spec.num_counters) = num_counters;
+	const_cast(op_amd_spec.num_controls) = num_counters;
+	const_cast(op_amd_spec.num_virt_counters) = max(num_counters, NUM_VIRT_COUNTERS);
+	pax_close_kernel();
 
 	return 0;
 }
diff --git a/arch/x86/oprofile/op_model_ppro.c b/arch/x86/oprofile/op_model_ppro.c
index 350f7096b..77882e0a0 100644
--- a/arch/x86/oprofile/op_model_ppro.c
+++ b/arch/x86/oprofile/op_model_ppro.c
@@ -19,6 +19,7 @@
 #include <asm/msr.h>
 #include <asm/apic.h>
 #include <asm/nmi.h>
+#include <asm/pgtable.h>
 
 #include "op_x86_model.h"
 #include "op_counter.h"
@@ -221,8 +222,10 @@ static void arch_perfmon_setup_counters(void)
 
 	num_counters = min((int)eax.split.num_counters, OP_MAX_COUNTER);
 
-	op_arch_perfmon_spec.num_counters = num_counters;
-	op_arch_perfmon_spec.num_controls = num_counters;
+	pax_open_kernel();
+	const_cast(op_arch_perfmon_spec.num_counters) = num_counters;
+	const_cast(op_arch_perfmon_spec.num_controls) = num_counters;
+	pax_close_kernel();
 }
 
 static int arch_perfmon_init(struct oprofile_operations *ignore)
diff --git a/arch/x86/oprofile/op_x86_model.h b/arch/x86/oprofile/op_x86_model.h
index 71e8a6733..6a313bb0b 100644
--- a/arch/x86/oprofile/op_x86_model.h
+++ b/arch/x86/oprofile/op_x86_model.h
@@ -52,7 +52,7 @@ struct op_x86_model_spec {
 	void		(*switch_ctrl)(struct op_x86_model_spec const *model,
 				       struct op_msrs const * const msrs);
 #endif
-};
+} __do_const;
 
 struct op_counter_config;
 
diff --git a/arch/x86/pci/intel_mid_pci.c b/arch/x86/pci/intel_mid_pci.c
index 5a18aedcb..22eac20fb 100644
--- a/arch/x86/pci/intel_mid_pci.c
+++ b/arch/x86/pci/intel_mid_pci.c
@@ -288,7 +288,7 @@ int __init intel_mid_pci_init(void)
 	pci_mmcfg_late_init();
 	pcibios_enable_irq = intel_mid_pci_irq_enable;
 	pcibios_disable_irq = intel_mid_pci_irq_disable;
-	pci_root_ops = intel_mid_pci_ops;
+	memcpy((void *)&pci_root_ops, &intel_mid_pci_ops, sizeof pci_root_ops);
 	pci_soc_mode = 1;
 	/* Continue with standard init */
 	return 1;
diff --git a/arch/x86/pci/irq.c b/arch/x86/pci/irq.c
index 9bd115484..e9d4656ff 100644
--- a/arch/x86/pci/irq.c
+++ b/arch/x86/pci/irq.c
@@ -51,7 +51,7 @@ struct irq_router {
 struct irq_router_handler {
 	u16 vendor;
 	int (*probe)(struct irq_router *r, struct pci_dev *router, u16 device);
-};
+} __do_const;
 
 int (*pcibios_enable_irq)(struct pci_dev *dev) = pirq_enable_irq;
 void (*pcibios_disable_irq)(struct pci_dev *dev) = pirq_disable_irq;
@@ -792,7 +792,7 @@ static __init int pico_router_probe(struct irq_router *r, struct pci_dev *router
 	return 0;
 }
 
-static __initdata struct irq_router_handler pirq_routers[] = {
+static __initconst const struct irq_router_handler pirq_routers[] = {
 	{ PCI_VENDOR_ID_INTEL, intel_router_probe },
 	{ PCI_VENDOR_ID_AL, ali_router_probe },
 	{ PCI_VENDOR_ID_ITE, ite_router_probe },
@@ -819,7 +819,7 @@ static struct pci_dev *pirq_router_dev;
 static void __init pirq_find_router(struct irq_router *r)
 {
 	struct irq_routing_table *rt = pirq_table;
-	struct irq_router_handler *h;
+	const struct irq_router_handler *h;
 
 #ifdef CONFIG_PCI_BIOS
 	if (!rt->signature) {
@@ -1092,7 +1092,7 @@ static int __init fix_acer_tm360_irqrouting(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id __initdata pciirq_dmi_table[] = {
+static const struct dmi_system_id __initconst pciirq_dmi_table[] = {
 	{
 		.callback = fix_broken_hp_bios_irq9,
 		.ident = "HP Pavilion N5400 Series Laptop",
diff --git a/arch/x86/pci/pcbios.c b/arch/x86/pci/pcbios.c
index 9770e55e7..76067ec82 100644
--- a/arch/x86/pci/pcbios.c
+++ b/arch/x86/pci/pcbios.c
@@ -79,7 +79,7 @@ union bios32 {
 static struct {
 	unsigned long address;
 	unsigned short segment;
-} bios32_indirect __initdata = { 0, __KERNEL_CS };
+} bios32_indirect __initdata = { 0, __PCIBIOS_CS };
 
 /*
  * Returns the entry point for the given service, NULL on error
@@ -92,37 +92,80 @@ static unsigned long __init bios32_service(unsigned long service)
 	unsigned long length;		/* %ecx */
 	unsigned long entry;		/* %edx */
 	unsigned long flags;
+	struct desc_struct d, *gdt;
 
 	local_irq_save(flags);
-	__asm__("lcall *(%%edi); cld"
+
+	gdt = get_cpu_gdt_table(smp_processor_id());
+
+	pack_descriptor(&d, 0UL, 0xFFFFFUL, 0x9B, 0xC);
+	write_gdt_entry(gdt, GDT_ENTRY_PCIBIOS_CS, &d, DESCTYPE_S);
+	pack_descriptor(&d, 0UL, 0xFFFFFUL, 0x93, 0xC);
+	write_gdt_entry(gdt, GDT_ENTRY_PCIBIOS_DS, &d, DESCTYPE_S);
+
+	__asm__("movw %w7, %%ds; lcall *(%%edi); push %%ss; pop %%ds; cld"
 		: "=a" (return_code),
 		  "=b" (address),
 		  "=c" (length),
 		  "=d" (entry)
 		: "0" (service),
 		  "1" (0),
-		  "D" (&bios32_indirect));
+		  "D" (&bios32_indirect),
+		  "r"(__PCIBIOS_DS)
+		: "memory");
+
+	pax_open_kernel();
+	gdt[GDT_ENTRY_PCIBIOS_CS].a = 0;
+	gdt[GDT_ENTRY_PCIBIOS_CS].b = 0;
+	gdt[GDT_ENTRY_PCIBIOS_DS].a = 0;
+	gdt[GDT_ENTRY_PCIBIOS_DS].b = 0;
+	pax_close_kernel();
+
 	local_irq_restore(flags);
 
 	switch (return_code) {
-		case 0:
-			return address + entry;
-		case 0x80:	/* Not present */
-			printk(KERN_WARNING "bios32_service(0x%lx): not present\n", service);
-			return 0;
-		default: /* Shouldn't happen */
-			printk(KERN_WARNING "bios32_service(0x%lx): returned 0x%x -- BIOS bug!\n",
-				service, return_code);
+	case 0: {
+		int cpu;
+		unsigned char flags;
+
+		printk(KERN_INFO "bios32_service: base:%08lx length:%08lx entry:%08lx\n", address, length, entry);
+		if (address >= 0xFFFF0 || length > 0x100000 - address || length <= entry) {
+			printk(KERN_WARNING "bios32_service: not valid\n");
 			return 0;
+		}
+		address = address + PAGE_OFFSET;
+		length += 16UL; /* some BIOSs underreport this... */
+		flags = 4;
+		if (length >= 64*1024*1024) {
+			length >>= PAGE_SHIFT;
+			flags |= 8;
+		}
+
+		for (cpu = 0; cpu < nr_cpu_ids; cpu++) {
+			gdt = get_cpu_gdt_table(cpu);
+			pack_descriptor(&d, address, length, 0x9b, flags);
+			write_gdt_entry(gdt, GDT_ENTRY_PCIBIOS_CS, &d, DESCTYPE_S);
+			pack_descriptor(&d, address, length, 0x93, flags);
+			write_gdt_entry(gdt, GDT_ENTRY_PCIBIOS_DS, &d, DESCTYPE_S);
+		}
+		return entry;
+	}
+	case 0x80:	/* Not present */
+		printk(KERN_WARNING "bios32_service(0x%lx): not present\n", service);
+		return 0;
+	default: /* Shouldn't happen */
+		printk(KERN_WARNING "bios32_service(0x%lx): returned 0x%x -- BIOS bug!\n",
+			service, return_code);
+		return 0;
 	}
 }
 
 static struct {
 	unsigned long address;
 	unsigned short segment;
-} pci_indirect = { 0, __KERNEL_CS };
+} pci_indirect __read_only = { 0, __PCIBIOS_CS };
 
-static int pci_bios_present;
+static int pci_bios_present __read_only;
 
 static int __init check_pcibios(void)
 {
@@ -131,11 +174,13 @@ static int __init check_pcibios(void)
 	unsigned long flags, pcibios_entry;
 
 	if ((pcibios_entry = bios32_service(PCI_SERVICE))) {
-		pci_indirect.address = pcibios_entry + PAGE_OFFSET;
+		pci_indirect.address = pcibios_entry;
 
 		local_irq_save(flags);
-		__asm__(
-			"lcall *(%%edi); cld\n\t"
+		__asm__("movw %w6, %%ds\n\t"
+			"lcall *%%ss:(%%edi); cld\n\t"
+			"push %%ss\n\t"
+			"pop %%ds\n\t"
 			"jc 1f\n\t"
 			"xor %%ah, %%ah\n"
 			"1:"
@@ -144,7 +189,8 @@ static int __init check_pcibios(void)
 			  "=b" (ebx),
 			  "=c" (ecx)
 			: "1" (PCIBIOS_PCI_BIOS_PRESENT),
-			  "D" (&pci_indirect)
+			  "D" (&pci_indirect),
+			  "r" (__PCIBIOS_DS)
 			: "memory");
 		local_irq_restore(flags);
 
@@ -202,7 +248,10 @@ static int pci_bios_read(unsigned int seg, unsigned int bus,
 		break;
 	}
 
-	__asm__("lcall *(%%esi); cld\n\t"
+	__asm__("movw %w6, %%ds\n\t"
+		"lcall *%%ss:(%%esi); cld\n\t"
+		"push %%ss\n\t"
+		"pop %%ds\n\t"
 		"jc 1f\n\t"
 		"xor %%ah, %%ah\n"
 		"1:"
@@ -211,7 +260,8 @@ static int pci_bios_read(unsigned int seg, unsigned int bus,
 		: "1" (number),
 		  "b" (bx),
 		  "D" ((long)reg),
-		  "S" (&pci_indirect));
+		  "S" (&pci_indirect),
+		  "r" (__PCIBIOS_DS));
 	/*
 	 * Zero-extend the result beyond 8 or 16 bits, do not trust the
 	 * BIOS having done it:
@@ -250,7 +300,10 @@ static int pci_bios_write(unsigned int seg, unsigned int bus,
 		break;
 	}
 
-	__asm__("lcall *(%%esi); cld\n\t"
+	__asm__("movw %w6, %%ds\n\t"
+		"lcall *%%ss:(%%esi); cld\n\t"
+		"push %%ss\n\t"
+		"pop %%ds\n\t"
 		"jc 1f\n\t"
 		"xor %%ah, %%ah\n"
 		"1:"
@@ -259,7 +312,8 @@ static int pci_bios_write(unsigned int seg, unsigned int bus,
 		  "c" (value),
 		  "b" (bx),
 		  "D" ((long)reg),
-		  "S" (&pci_indirect));
+		  "S" (&pci_indirect),
+		  "r" (__PCIBIOS_DS));
 
 	raw_spin_unlock_irqrestore(&pci_config_lock, flags);
 
@@ -362,10 +416,13 @@ struct irq_routing_table * pcibios_get_irq_routing_table(void)
 
 	DBG("PCI: Fetching IRQ routing table... ");
 	__asm__("push %%es\n\t"
+		"movw %w8, %%ds\n\t"
 		"push %%ds\n\t"
 		"pop  %%es\n\t"
-		"lcall *(%%esi); cld\n\t"
+		"lcall *%%ss:(%%esi); cld\n\t"
 		"pop %%es\n\t"
+		"push %%ss\n\t"
+		"pop %%ds\n"
 		"jc 1f\n\t"
 		"xor %%ah, %%ah\n"
 		"1:"
@@ -376,7 +433,8 @@ struct irq_routing_table * pcibios_get_irq_routing_table(void)
 		  "1" (0),
 		  "D" ((long) &opt),
 		  "S" (&pci_indirect),
-		  "m" (opt)
+		  "m" (opt),
+		  "r" (__PCIBIOS_DS)
 		: "memory");
 	DBG("OK  ret=%d, size=%d, map=%x\n", ret, opt.size, map);
 	if (ret & 0xff00)
@@ -400,7 +458,10 @@ int pcibios_set_irq_routing(struct pci_dev *dev, int pin, int irq)
 {
 	int ret;
 
-	__asm__("lcall *(%%esi); cld\n\t"
+	__asm__("movw %w5, %%ds\n\t"
+		"lcall *%%ss:(%%esi); cld\n\t"
+		"push %%ss\n\t"
+		"pop %%ds\n"
 		"jc 1f\n\t"
 		"xor %%ah, %%ah\n"
 		"1:"
@@ -408,7 +469,8 @@ int pcibios_set_irq_routing(struct pci_dev *dev, int pin, int irq)
 		: "0" (PCIBIOS_SET_PCI_HW_INT),
 		  "b" ((dev->bus->number << 8) | dev->devfn),
 		  "c" ((irq << 8) | (pin + 10)),
-		  "S" (&pci_indirect));
+		  "S" (&pci_indirect),
+		  "r" (__PCIBIOS_DS));
 	return !(ret & 0xff00);
 }
 EXPORT_SYMBOL(pcibios_set_irq_routing);
diff --git a/arch/x86/pci/vmd.c b/arch/x86/pci/vmd.c
index 7948be342..73a1aaa27 100644
--- a/arch/x86/pci/vmd.c
+++ b/arch/x86/pci/vmd.c
@@ -389,7 +389,7 @@ static void vmd_teardown_dma_ops(struct vmd_dev *vmd)
 #define ASSIGN_VMD_DMA_OPS(source, dest, fn)	\
 	do {					\
 		if (source->fn)			\
-			dest->fn = vmd_##fn;	\
+			const_cast(dest->fn) = vmd_##fn;	\
 	} while (0)
 
 static void vmd_setup_dma_ops(struct vmd_dev *vmd)
@@ -403,6 +403,7 @@ static void vmd_setup_dma_ops(struct vmd_dev *vmd)
 
 	if (!source)
 		return;
+	pax_open_kernel();
 	ASSIGN_VMD_DMA_OPS(source, dest, alloc);
 	ASSIGN_VMD_DMA_OPS(source, dest, free);
 	ASSIGN_VMD_DMA_OPS(source, dest, mmap);
@@ -420,6 +421,7 @@ static void vmd_setup_dma_ops(struct vmd_dev *vmd)
 #ifdef ARCH_HAS_DMA_GET_REQUIRED_MASK
 	ASSIGN_VMD_DMA_OPS(source, dest, get_required_mask);
 #endif
+	pax_close_kernel();
 	add_dma_domain(domain);
 }
 #undef ASSIGN_VMD_DMA_OPS
diff --git a/arch/x86/platform/efi/efi_32.c b/arch/x86/platform/efi/efi_32.c
index cef39b097..0e5aebe25 100644
--- a/arch/x86/platform/efi/efi_32.c
+++ b/arch/x86/platform/efi/efi_32.c
@@ -63,11 +63,27 @@ pgd_t * __init efi_call_phys_prolog(void)
 	struct desc_ptr gdt_descr;
 	pgd_t *save_pgd;
 
+#ifdef CONFIG_PAX_KERNEXEC
+	struct desc_struct d;
+#endif
+
 	/* Current pgd is swapper_pg_dir, we'll restore it later: */
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	save_pgd = get_cpu_pgd(smp_processor_id(), kernel);
+#else
 	save_pgd = swapper_pg_dir;
+#endif
+
 	load_cr3(initial_page_table);
 	__flush_tlb_all();
 
+#ifdef CONFIG_PAX_KERNEXEC
+	pack_descriptor(&d, 0, 0xFFFFF, 0x9B, 0xC);
+	write_gdt_entry(get_cpu_gdt_table(0), GDT_ENTRY_KERNEXEC_EFI_CS, &d, DESCTYPE_S);
+	pack_descriptor(&d, 0, 0xFFFFF, 0x93, 0xC);
+	write_gdt_entry(get_cpu_gdt_table(0), GDT_ENTRY_KERNEXEC_EFI_DS, &d, DESCTYPE_S);
+#endif
+
 	gdt_descr.address = __pa(get_cpu_gdt_table(0));
 	gdt_descr.size = GDT_SIZE - 1;
 	load_gdt(&gdt_descr);
@@ -79,6 +95,14 @@ void __init efi_call_phys_epilog(pgd_t *save_pgd)
 {
 	struct desc_ptr gdt_descr;
 
+#ifdef CONFIG_PAX_KERNEXEC
+	struct desc_struct d;
+
+	memset(&d, 0, sizeof d);
+	write_gdt_entry(get_cpu_gdt_table(0), GDT_ENTRY_KERNEXEC_EFI_CS, &d, DESCTYPE_S);
+	write_gdt_entry(get_cpu_gdt_table(0), GDT_ENTRY_KERNEXEC_EFI_DS, &d, DESCTYPE_S);
+#endif
+
 	gdt_descr.address = (unsigned long)get_cpu_gdt_table(0);
 	gdt_descr.size = GDT_SIZE - 1;
 	load_gdt(&gdt_descr);
diff --git a/arch/x86/platform/efi/efi_64.c b/arch/x86/platform/efi/efi_64.c
index 8dd3784eb..98465466a 100644
--- a/arch/x86/platform/efi/efi_64.c
+++ b/arch/x86/platform/efi/efi_64.c
@@ -92,6 +92,11 @@ pgd_t * __init efi_call_phys_prolog(void)
 		vaddress = (unsigned long)__va(pgd * PGDIR_SIZE);
 		set_pgd(pgd_offset_k(pgd * PGDIR_SIZE), *pgd_offset_k(vaddress));
 	}
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	load_cr3(swapper_pg_dir);
+#endif
+
 out:
 	__flush_tlb_all();
 
@@ -119,6 +124,10 @@ void __init efi_call_phys_epilog(pgd_t *save_pgd)
 
 	kfree(save_pgd);
 
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	load_cr3(get_cpu_pgd(smp_processor_id(), kernel));
+#endif
+
 	__flush_tlb_all();
 	early_code_mapping_set_exec(0);
 }
@@ -219,8 +228,23 @@ int __init efi_setup_page_tables(unsigned long pa_memmap, unsigned num_pages)
 	unsigned npages;
 	pgd_t *pgd;
 
-	if (efi_enabled(EFI_OLD_MEMMAP))
+	if (efi_enabled(EFI_OLD_MEMMAP)) {
+		/* PaX: We need to disable the NX bit in the PGD, otherwise we won't be
+		 * able to execute the EFI services.
+		 */
+		if (__supported_pte_mask & _PAGE_NX) {
+			unsigned long addr = (unsigned long) __va(0);
+			pgd_t pe = __pgd(pgd_val(*pgd_offset_k(addr)) &  ~_PAGE_NX);
+
+			pr_alert("PAX: Disabling NX protection for low memory map. Try booting without \"efi=old_map\"\n");
+#ifdef CONFIG_PAX_PER_CPU_PGD
+			set_pgd(pgd_offset_cpu(0, kernel, addr), pe);
+#endif
+			set_pgd(pgd_offset_k(addr), pe);
+		}
+
 		return 0;
+	}
 
 	efi_scratch.efi_pgt = (pgd_t *)__pa(efi_pgd);
 	pgd = efi_pgd;
diff --git a/arch/x86/platform/efi/efi_stub_32.S b/arch/x86/platform/efi/efi_stub_32.S
index 040192b50..7d3300f76 100644
--- a/arch/x86/platform/efi/efi_stub_32.S
+++ b/arch/x86/platform/efi/efi_stub_32.S
@@ -6,7 +6,9 @@
  */
 
 #include <linux/linkage.h>
+#include <linux/init.h>
 #include <asm/page_types.h>
+#include <asm/segment.h>
 
 /*
  * efi_call_phys(void *, ...) is a function with variable parameters.
@@ -20,7 +22,7 @@
  * service functions will comply with gcc calling convention, too.
  */
 
-.text
+__INIT
 ENTRY(efi_call_phys)
 	/*
 	 * 0. The function can only be called in Linux kernel. So CS has been
@@ -36,10 +38,24 @@ ENTRY(efi_call_phys)
 	 * The mapping of lower virtual memory has been created in prolog and
 	 * epilog.
 	 */
-	movl	$1f, %edx
-	subl	$__PAGE_OFFSET, %edx
-	jmp	*%edx
+#ifdef CONFIG_PAX_KERNEXEC
+	movl	$(__KERNEXEC_EFI_DS), %edx
+	mov	%edx, %ds
+	mov	%edx, %es
+	mov	%edx, %ss
+	addl	$2f,(1f)
+	ljmp	*(1f)
+
+__INITDATA
+1:	.long __LOAD_PHYSICAL_ADDR, __KERNEXEC_EFI_CS
+.previous
+
+2:
+	subl	$2b,(1b)
+#else
+	jmp	1f-__PAGE_OFFSET
 1:
+#endif
 
 	/*
 	 * 2. Now on the top of stack is the return
@@ -47,14 +63,8 @@ ENTRY(efi_call_phys)
 	 * parameter 2, ..., param n. To make things easy, we save the return
 	 * address of efi_call_phys in a global variable.
 	 */
-	popl	%edx
-	movl	%edx, saved_return_addr
-	/* get the function pointer into ECX*/
-	popl	%ecx
-	movl	%ecx, efi_rt_function_ptr
-	movl	$2f, %edx
-	subl	$__PAGE_OFFSET, %edx
-	pushl	%edx
+	popl	(saved_return_addr)
+	popl	(efi_rt_function_ptr)
 
 	/*
 	 * 3. Clear PG bit in %CR0.
@@ -73,9 +83,8 @@ ENTRY(efi_call_phys)
 	/*
 	 * 5. Call the physical function.
 	 */
-	jmp	*%ecx
+	call	*(efi_rt_function_ptr-__PAGE_OFFSET)
 
-2:
 	/*
 	 * 6. After EFI runtime service returns, control will return to
 	 * following instruction. We'd better readjust stack pointer first.
@@ -88,35 +97,36 @@ ENTRY(efi_call_phys)
 	movl	%cr0, %edx
 	orl	$0x80000000, %edx
 	movl	%edx, %cr0
-	jmp	1f
-1:
+
 	/*
 	 * 8. Now restore the virtual mode from flat mode by
 	 * adding EIP with PAGE_OFFSET.
 	 */
-	movl	$1f, %edx
-	jmp	*%edx
+#ifdef CONFIG_PAX_KERNEXEC
+	movl	$(__KERNEL_DS), %edx
+	mov	%edx, %ds
+	mov	%edx, %es
+	mov	%edx, %ss
+	ljmp	$(__KERNEL_CS),$1f
+#else
+	jmp	1f+__PAGE_OFFSET
+#endif
 1:
 
 	/*
 	 * 9. Balance the stack. And because EAX contain the return value,
 	 * we'd better not clobber it.
 	 */
-	leal	efi_rt_function_ptr, %edx
-	movl	(%edx), %ecx
-	pushl	%ecx
+	pushl	(efi_rt_function_ptr)
 
 	/*
-	 * 10. Push the saved return address onto the stack and return.
+	 * 10. Return to the saved return address.
 	 */
-	leal	saved_return_addr, %edx
-	movl	(%edx), %ecx
-	pushl	%ecx
-	ret
+	jmpl	*(saved_return_addr)
 ENDPROC(efi_call_phys)
 .previous
 
-.data
+__INITDATA
 saved_return_addr:
 	.long 0
 efi_rt_function_ptr:
diff --git a/arch/x86/platform/efi/efi_stub_64.S b/arch/x86/platform/efi/efi_stub_64.S
index cd9507594..a7b6d471a 100644
--- a/arch/x86/platform/efi/efi_stub_64.S
+++ b/arch/x86/platform/efi/efi_stub_64.S
@@ -11,6 +11,7 @@
 #include <asm/msr.h>
 #include <asm/processor-flags.h>
 #include <asm/page_types.h>
+#include <asm/alternative-asm.h>
 
 #define SAVE_XMM			\
 	mov %rsp, %rax;			\
@@ -53,5 +54,6 @@ ENTRY(efi_call)
 	addq $48, %rsp
 	RESTORE_XMM
 	popq %rbp
+	pax_force_retaddr 0, 1
 	ret
 ENDPROC(efi_call)
diff --git a/arch/x86/platform/intel-mid/intel-mid.c b/arch/x86/platform/intel-mid/intel-mid.c
index ce119d2ba..42159d95e 100644
--- a/arch/x86/platform/intel-mid/intel-mid.c
+++ b/arch/x86/platform/intel-mid/intel-mid.c
@@ -62,9 +62,9 @@
 enum intel_mid_timer_options intel_mid_timer_options;
 
 /* intel_mid_ops to store sub arch ops */
-static struct intel_mid_ops *intel_mid_ops;
+static const struct intel_mid_ops *intel_mid_ops;
 /* getter function for sub arch ops*/
-static void *(*get_intel_mid_ops[])(void) = INTEL_MID_OPS_INIT;
+static const void *(*get_intel_mid_ops[])(void) = INTEL_MID_OPS_INIT;
 enum intel_mid_cpu_type __intel_mid_cpu_chip;
 EXPORT_SYMBOL_GPL(__intel_mid_cpu_chip);
 
@@ -72,9 +72,10 @@ static void intel_mid_power_off(void)
 {
 };
 
-static void intel_mid_reboot(void)
+static void __noreturn intel_mid_reboot(void)
 {
 	intel_scu_ipc_simple_command(IPCMSG_COLD_BOOT, 0);
+	BUG();
 }
 
 static unsigned long __init intel_mid_calibrate_tsc(void)
diff --git a/arch/x86/platform/intel-mid/intel_mid_weak_decls.h b/arch/x86/platform/intel-mid/intel_mid_weak_decls.h
index 3c1c3866d..59a68ed4c 100644
--- a/arch/x86/platform/intel-mid/intel_mid_weak_decls.h
+++ b/arch/x86/platform/intel-mid/intel_mid_weak_decls.h
@@ -13,6 +13,6 @@
 /* For every CPU addition a new get_<cpuname>_ops interface needs
  * to be added.
  */
-extern void *get_penwell_ops(void);
-extern void *get_cloverview_ops(void);
-extern void *get_tangier_ops(void);
+extern const void *get_penwell_ops(void);
+extern const void *get_cloverview_ops(void);
+extern const void *get_tangier_ops(void);
diff --git a/arch/x86/platform/intel-mid/mfld.c b/arch/x86/platform/intel-mid/mfld.c
index 1eb47b629..dadfb57d9 100644
--- a/arch/x86/platform/intel-mid/mfld.c
+++ b/arch/x86/platform/intel-mid/mfld.c
@@ -61,12 +61,12 @@ static void __init penwell_arch_setup(void)
 	pm_power_off = mfld_power_off;
 }
 
-void *get_penwell_ops(void)
+const void *get_penwell_ops(void)
 {
 	return &penwell_ops;
 }
 
-void *get_cloverview_ops(void)
+const void *get_cloverview_ops(void)
 {
 	return &penwell_ops;
 }
diff --git a/arch/x86/platform/intel-mid/mrfld.c b/arch/x86/platform/intel-mid/mrfld.c
index 59253db41..81bb53462 100644
--- a/arch/x86/platform/intel-mid/mrfld.c
+++ b/arch/x86/platform/intel-mid/mrfld.c
@@ -94,7 +94,7 @@ static struct intel_mid_ops tangier_ops = {
 	.arch_setup = tangier_arch_setup,
 };
 
-void *get_tangier_ops(void)
+const void *get_tangier_ops(void)
 {
 	return &tangier_ops;
 }
diff --git a/arch/x86/platform/intel-quark/imr_selftest.c b/arch/x86/platform/intel-quark/imr_selftest.c
index f5bad4093..da1428a9a 100644
--- a/arch/x86/platform/intel-quark/imr_selftest.c
+++ b/arch/x86/platform/intel-quark/imr_selftest.c
@@ -54,7 +54,7 @@ static void __init imr_self_test_result(int res, const char *fmt, ...)
  */
 static void __init imr_self_test(void)
 {
-	phys_addr_t base  = virt_to_phys(&_text);
+	phys_addr_t base  = virt_to_phys((void *)ktla_ktva((unsigned long)_text));
 	size_t size = virt_to_phys(&__end_rodata) - base;
 	const char *fmt_over = "overlapped IMR @ (0x%08lx - 0x%08lx)\n";
 	int ret;
diff --git a/arch/x86/platform/olpc/olpc_dt.c b/arch/x86/platform/olpc/olpc_dt.c
index d6ee92986..045432762 100644
--- a/arch/x86/platform/olpc/olpc_dt.c
+++ b/arch/x86/platform/olpc/olpc_dt.c
@@ -156,7 +156,7 @@ void * __init prom_early_alloc(unsigned long size)
 	return res;
 }
 
-static struct of_pdt_ops prom_olpc_ops __initdata = {
+static const struct of_pdt_ops prom_olpc_ops __initconst = {
 	.nextprop = olpc_dt_nextprop,
 	.getproplen = olpc_dt_getproplen,
 	.getproperty = olpc_dt_getproperty,
diff --git a/arch/x86/power/cpu.c b/arch/x86/power/cpu.c
index b12c26e2e..eacc01fbc 100644
--- a/arch/x86/power/cpu.c
+++ b/arch/x86/power/cpu.c
@@ -160,11 +160,8 @@ static void do_fpu_end(void)
 static void fix_processor_context(void)
 {
 	int cpu = smp_processor_id();
-	struct tss_struct *t = &per_cpu(cpu_tss, cpu);
-#ifdef CONFIG_X86_64
-	struct desc_struct *desc = get_cpu_gdt_table(cpu);
-	tss_desc tss;
-#endif
+	struct tss_struct *t = cpu_tss + cpu;
+
 	set_tss_desc(cpu, t);	/*
 				 * This just modifies memory; should not be
 				 * necessary. But... This is necessary, because
@@ -173,10 +170,6 @@ static void fix_processor_context(void)
 				 */
 
 #ifdef CONFIG_X86_64
-	memcpy(&tss, &desc[GDT_ENTRY_TSS], sizeof(tss_desc));
-	tss.type = 0x9; /* The available 64-bit TSS (see AMD vol 2, pg 91 */
-	write_gdt_entry(desc, GDT_ENTRY_TSS, &tss, DESC_TSS);
-
 	syscall_init();				/* This sets MSR_*STAR and related */
 #endif
 	load_TR_desc();				/* This does ltr */
@@ -289,9 +282,13 @@ int hibernate_resume_nonboot_cpu_disable(void)
 	 * any more at that point (the page tables used by it previously may
 	 * have been overwritten by hibernate image data).
 	 */
+	pax_open_kernel();
 	smp_ops.play_dead = resume_play_dead;
+	pax_close_kernel();
 	ret = disable_nonboot_cpus();
+	pax_open_kernel();
 	smp_ops.play_dead = play_dead;
+	pax_close_kernel();
 	return ret;
 }
 #endif
diff --git a/arch/x86/power/hibernate_64.c b/arch/x86/power/hibernate_64.c
index 9634557a5..47043c7ff 100644
--- a/arch/x86/power/hibernate_64.c
+++ b/arch/x86/power/hibernate_64.c
@@ -130,15 +130,14 @@ static int relocate_restore_code(void)
 
 	/* Make the page containing the relocated code executable */
 	pgd = (pgd_t *)__va(read_cr3()) + pgd_index(relocated_restore_code);
+	set_pgd(pgd, __pgd(pgd_val(*pgd) & ~_PAGE_NX));
 	pud = pud_offset(pgd, relocated_restore_code);
-	if (pud_large(*pud)) {
-		set_pud(pud, __pud(pud_val(*pud) & ~_PAGE_NX));
-	} else {
+	set_pud(pud, __pud(pud_val(*pud) & ~_PAGE_NX));
+	if (!pud_large(*pud)) {
 		pmd_t *pmd = pmd_offset(pud, relocated_restore_code);
 
-		if (pmd_large(*pmd)) {
-			set_pmd(pmd, __pmd(pmd_val(*pmd) & ~_PAGE_NX));
-		} else {
+		set_pmd(pmd, __pmd(pmd_val(*pmd) & ~_PAGE_NX));
+		if (!pmd_large(*pmd)) {
 			pte_t *pte = pte_offset_kernel(pmd, relocated_restore_code);
 
 			set_pte(pte, __pte(pte_val(*pte) & ~_PAGE_NX));
diff --git a/arch/x86/power/hibernate_asm_32.S b/arch/x86/power/hibernate_asm_32.S
index 1d0fa0e24..5003de0df 100644
--- a/arch/x86/power/hibernate_asm_32.S
+++ b/arch/x86/power/hibernate_asm_32.S
@@ -11,6 +11,7 @@
 #include <asm/page_types.h>
 #include <asm/asm-offsets.h>
 #include <asm/processor-flags.h>
+#include <asm/smap.h>
 
 .text
 
@@ -74,6 +75,7 @@ done:
 
 	pushl saved_context_eflags
 	popfl
+	ASM_CLAC
 
 	/* Saved in save_processor_state. */
 	movl $saved_context, %eax
diff --git a/arch/x86/power/hibernate_asm_64.S b/arch/x86/power/hibernate_asm_64.S
index ce8da3a04..c3c8b8c87 100644
--- a/arch/x86/power/hibernate_asm_64.S
+++ b/arch/x86/power/hibernate_asm_64.S
@@ -22,6 +22,7 @@
 #include <asm/asm-offsets.h>
 #include <asm/processor-flags.h>
 #include <asm/frame.h>
+#include <asm/smap.h>
 
 ENTRY(swsusp_arch_suspend)
 	movq	$saved_context, %rax
@@ -133,6 +134,7 @@ ENTRY(restore_registers)
 	movq	pt_regs_r15(%rax), %r15
 	pushq	pt_regs_flags(%rax)
 	popfq
+	ASM_CLAC
 
 	/* Saved in save_processor_state. */
 	lgdt	saved_context_gdt_desc(%rax)
diff --git a/arch/x86/realmode/init.c b/arch/x86/realmode/init.c
index 5db706f14..267f9070c 100644
--- a/arch/x86/realmode/init.c
+++ b/arch/x86/realmode/init.c
@@ -85,7 +85,13 @@ static void __init setup_real_mode(void)
 		__va(real_mode_header->trampoline_header);
 
 #ifdef CONFIG_X86_32
-	trampoline_header->start = __pa_symbol(startup_32_smp);
+	trampoline_header->start = __pa_symbol(ktla_ktva((unsigned long)startup_32_smp));
+
+#ifdef CONFIG_PAX_KERNEXEC
+	trampoline_header->start -= LOAD_PHYSICAL_ADDR;
+#endif
+
+	trampoline_header->boot_cs = __BOOT_CS;
 	trampoline_header->gdt_limit = __BOOT_DS + 7;
 	trampoline_header->gdt_base = __pa_symbol(boot_gdt);
 #else
@@ -101,7 +107,7 @@ static void __init setup_real_mode(void)
 	*trampoline_cr4_features = mmu_cr4_features;
 
 	trampoline_pgd = (u64 *) __va(real_mode_header->trampoline_pgd);
-	trampoline_pgd[0] = trampoline_pgd_entry.pgd;
+	trampoline_pgd[0] = trampoline_pgd_entry.pgd & ~_PAGE_NX;
 	trampoline_pgd[511] = init_level4_pgt[511].pgd;
 #endif
 }
diff --git a/arch/x86/realmode/rm/header.S b/arch/x86/realmode/rm/header.S
index a28221d94..93c40f1b8 100644
--- a/arch/x86/realmode/rm/header.S
+++ b/arch/x86/realmode/rm/header.S
@@ -30,7 +30,9 @@ GLOBAL(real_mode_header)
 #endif
 	/* APM/BIOS reboot */
 	.long	pa_machine_real_restart_asm
-#ifdef CONFIG_X86_64
+#ifdef CONFIG_X86_32
+	.long	__KERNEL_CS
+#else
 	.long	__KERNEL32_CS
 #endif
 END(real_mode_header)
diff --git a/arch/x86/realmode/rm/reboot.S b/arch/x86/realmode/rm/reboot.S
index d66c607bd..3def84565 100644
--- a/arch/x86/realmode/rm/reboot.S
+++ b/arch/x86/realmode/rm/reboot.S
@@ -27,6 +27,10 @@ ENTRY(machine_real_restart_asm)
 	lgdtl	pa_tr_gdt
 
 	/* Disable paging to drop us out of long mode */
+	movl	%cr4, %eax
+	andl	$~X86_CR4_PCIDE, %eax
+	movl	%eax, %cr4
+
 	movl	%cr0, %eax
 	andl	$~X86_CR0_PG, %eax
 	movl	%eax, %cr0
diff --git a/arch/x86/realmode/rm/trampoline_32.S b/arch/x86/realmode/rm/trampoline_32.S
index 48ddd76bc..c26749f66 100644
--- a/arch/x86/realmode/rm/trampoline_32.S
+++ b/arch/x86/realmode/rm/trampoline_32.S
@@ -24,6 +24,12 @@
 #include <asm/page_types.h>
 #include "realmode.h"
 
+#ifdef CONFIG_PAX_KERNEXEC
+#define ta(X) (X)
+#else
+#define ta(X) (pa_ ## X)
+#endif
+
 	.text
 	.code16
 
@@ -38,8 +44,6 @@ ENTRY(trampoline_start)
 
 	cli			# We should be safe anyway
 
-	movl	tr_start, %eax	# where we need to go
-
 	movl	$0xA5A5A5A5, trampoline_status
 				# write marker for master knows we're running
 
@@ -55,7 +59,7 @@ ENTRY(trampoline_start)
 	movw	$1, %dx			# protected mode (PE) bit
 	lmsw	%dx			# into protected mode
 
-	ljmpl	$__BOOT_CS, $pa_startup_32
+	ljmpl *(trampoline_header)
 
 	.section ".text32","ax"
 	.code32
@@ -66,7 +70,7 @@ ENTRY(startup_32)			# note: also used from wakeup_asm.S
 	.balign 8
 GLOBAL(trampoline_header)
 	tr_start:		.space	4
-	tr_gdt_pad:		.space	2
+	tr_boot_cs:		.space	2
 	tr_gdt:			.space	6
 END(trampoline_header)
 	
diff --git a/arch/x86/realmode/rm/trampoline_64.S b/arch/x86/realmode/rm/trampoline_64.S
index dac7b20d2..72dbaca0d 100644
--- a/arch/x86/realmode/rm/trampoline_64.S
+++ b/arch/x86/realmode/rm/trampoline_64.S
@@ -93,6 +93,7 @@ ENTRY(startup_32)
 	movl	%edx, %gs
 
 	movl	pa_tr_cr4, %eax
+	andl	$~X86_CR4_PCIDE, %eax
 	movl	%eax, %cr4		# Enable PAE mode
 
 	# Setup trampoline 4 level pagetables
@@ -106,7 +107,7 @@ ENTRY(startup_32)
 	wrmsr
 
 	# Enable paging and in turn activate Long Mode
-	movl	$(X86_CR0_PG | X86_CR0_WP | X86_CR0_PE), %eax
+	movl	$(X86_CR0_PG | X86_CR0_PE), %eax
 	movl	%eax, %cr0
 
 	/*
diff --git a/arch/x86/realmode/rm/wakeup_asm.S b/arch/x86/realmode/rm/wakeup_asm.S
index 9e7e14797..25a4158e3 100644
--- a/arch/x86/realmode/rm/wakeup_asm.S
+++ b/arch/x86/realmode/rm/wakeup_asm.S
@@ -126,11 +126,10 @@ ENTRY(wakeup_start)
 	lgdtl	pmode_gdt
 
 	/* This really couldn't... */
-	movl	pmode_entry, %eax
 	movl	pmode_cr0, %ecx
 	movl	%ecx, %cr0
-	ljmpl	$__KERNEL_CS, $pa_startup_32
-	/* -> jmp *%eax in trampoline_32.S */
+
+	ljmpl	*pmode_entry
 #else
 	jmp	trampoline_start
 #endif
diff --git a/arch/x86/tools/Makefile b/arch/x86/tools/Makefile
index 604a37efd..e49702a20 100644
--- a/arch/x86/tools/Makefile
+++ b/arch/x86/tools/Makefile
@@ -37,7 +37,7 @@ $(obj)/test_get_len.o: $(srctree)/arch/x86/lib/insn.c $(srctree)/arch/x86/lib/in
 
 $(obj)/insn_sanity.o: $(srctree)/arch/x86/lib/insn.c $(srctree)/arch/x86/lib/inat.c $(srctree)/arch/x86/include/asm/inat_types.h $(srctree)/arch/x86/include/asm/inat.h $(srctree)/arch/x86/include/asm/insn.h $(objtree)/arch/x86/lib/inat-tables.c
 
-HOST_EXTRACFLAGS += -I$(srctree)/tools/include
+HOST_EXTRACFLAGS += -I$(srctree)/tools/include -ggdb
 hostprogs-y	+= relocs
 relocs-objs     := relocs_32.o relocs_64.o relocs_common.o
 PHONY += relocs
diff --git a/arch/x86/tools/relocs.c b/arch/x86/tools/relocs.c
index 0c2fae8d9..1d2a07981 100644
--- a/arch/x86/tools/relocs.c
+++ b/arch/x86/tools/relocs.c
@@ -1,5 +1,7 @@
 /* This is included from relocs_32/64.c */
 
+#include "../../../include/generated/autoconf.h"
+
 #define ElfW(type)		_ElfW(ELF_BITS, type)
 #define _ElfW(bits, type)	__ElfW(bits, type)
 #define __ElfW(bits, type)	Elf##bits##_##type
@@ -11,6 +13,7 @@
 #define Elf_Sym			ElfW(Sym)
 
 static Elf_Ehdr ehdr;
+static Elf_Phdr *phdr;
 
 struct relocs {
 	uint32_t	*offset;
@@ -45,6 +48,7 @@ static const char * const sym_regex_kernel[S_NSYMTYPES] = {
 	"^(xen_irq_disable_direct_reloc$|"
 	"xen_save_fl_direct_reloc$|"
 	"VDSO|"
+	"__rap_hash_|"
 	"__crc_)",
 
 /*
@@ -386,9 +390,39 @@ static void read_ehdr(FILE *fp)
 	}
 }
 
+static void read_phdrs(FILE *fp)
+{
+	unsigned int i;
+
+	phdr = calloc(ehdr.e_phnum, sizeof(Elf_Phdr));
+	if (!phdr) {
+		die("Unable to allocate %d program headers\n",
+		    ehdr.e_phnum);
+	}
+	if (fseek(fp, ehdr.e_phoff, SEEK_SET) < 0) {
+		die("Seek to %d failed: %s\n",
+			ehdr.e_phoff, strerror(errno));
+	}
+	if (fread(phdr, sizeof(*phdr), ehdr.e_phnum, fp) != ehdr.e_phnum) {
+		die("Cannot read ELF program headers: %s\n",
+			strerror(errno));
+	}
+	for(i = 0; i < ehdr.e_phnum; i++) {
+		phdr[i].p_type      = elf_word_to_cpu(phdr[i].p_type);
+		phdr[i].p_offset    = elf_off_to_cpu(phdr[i].p_offset);
+		phdr[i].p_vaddr     = elf_addr_to_cpu(phdr[i].p_vaddr);
+		phdr[i].p_paddr     = elf_addr_to_cpu(phdr[i].p_paddr);
+		phdr[i].p_filesz    = elf_word_to_cpu(phdr[i].p_filesz);
+		phdr[i].p_memsz     = elf_word_to_cpu(phdr[i].p_memsz);
+		phdr[i].p_flags     = elf_word_to_cpu(phdr[i].p_flags);
+		phdr[i].p_align     = elf_word_to_cpu(phdr[i].p_align);
+	}
+
+}
+
 static void read_shdrs(FILE *fp)
 {
-	int i;
+	unsigned int i;
 	Elf_Shdr shdr;
 
 	secs = calloc(ehdr.e_shnum, sizeof(struct section));
@@ -423,7 +457,7 @@ static void read_shdrs(FILE *fp)
 
 static void read_strtabs(FILE *fp)
 {
-	int i;
+	unsigned int i;
 	for (i = 0; i < ehdr.e_shnum; i++) {
 		struct section *sec = &secs[i];
 		if (sec->shdr.sh_type != SHT_STRTAB) {
@@ -448,7 +482,7 @@ static void read_strtabs(FILE *fp)
 
 static void read_symtabs(FILE *fp)
 {
-	int i,j;
+	unsigned int i,j;
 	for (i = 0; i < ehdr.e_shnum; i++) {
 		struct section *sec = &secs[i];
 		if (sec->shdr.sh_type != SHT_SYMTAB) {
@@ -479,9 +513,11 @@ static void read_symtabs(FILE *fp)
 }
 
 
-static void read_relocs(FILE *fp)
+static void read_relocs(FILE *fp, int use_real_mode)
 {
-	int i,j;
+	unsigned int i,j;
+	uint32_t base;
+
 	for (i = 0; i < ehdr.e_shnum; i++) {
 		struct section *sec = &secs[i];
 		if (sec->shdr.sh_type != SHT_REL_TYPE) {
@@ -501,9 +537,22 @@ static void read_relocs(FILE *fp)
 			die("Cannot read symbol table: %s\n",
 				strerror(errno));
 		}
+		base = 0;
+
+#ifdef CONFIG_X86_32
+		for (j = 0; !use_real_mode && j < ehdr.e_phnum; j++) {
+			if (phdr[j].p_type != PT_LOAD )
+				continue;
+			if (secs[sec->shdr.sh_info].shdr.sh_offset < phdr[j].p_offset || secs[sec->shdr.sh_info].shdr.sh_offset >= phdr[j].p_offset + phdr[j].p_filesz)
+				continue;
+			base = CONFIG_PAGE_OFFSET + phdr[j].p_paddr - phdr[j].p_vaddr;
+			break;
+		}
+#endif
+
 		for (j = 0; j < sec->shdr.sh_size/sizeof(Elf_Rel); j++) {
 			Elf_Rel *rel = &sec->reltab[j];
-			rel->r_offset = elf_addr_to_cpu(rel->r_offset);
+			rel->r_offset = elf_addr_to_cpu(rel->r_offset) + base;
 			rel->r_info   = elf_xword_to_cpu(rel->r_info);
 #if (SHT_REL_TYPE == SHT_RELA)
 			rel->r_addend = elf_xword_to_cpu(rel->r_addend);
@@ -515,7 +564,7 @@ static void read_relocs(FILE *fp)
 
 static void print_absolute_symbols(void)
 {
-	int i;
+	unsigned int i;
 	const char *format;
 
 	if (ELF_BITS == 64)
@@ -528,7 +577,7 @@ static void print_absolute_symbols(void)
 	for (i = 0; i < ehdr.e_shnum; i++) {
 		struct section *sec = &secs[i];
 		char *sym_strtab;
-		int j;
+		unsigned int j;
 
 		if (sec->shdr.sh_type != SHT_SYMTAB) {
 			continue;
@@ -555,7 +604,7 @@ static void print_absolute_symbols(void)
 
 static void print_absolute_relocs(void)
 {
-	int i, printed = 0;
+	unsigned int i, printed = 0;
 	const char *format;
 
 	if (ELF_BITS == 64)
@@ -568,7 +617,7 @@ static void print_absolute_relocs(void)
 		struct section *sec_applies, *sec_symtab;
 		char *sym_strtab;
 		Elf_Sym *sh_symtab;
-		int j;
+		unsigned int j;
 		if (sec->shdr.sh_type != SHT_REL_TYPE) {
 			continue;
 		}
@@ -645,13 +694,13 @@ static void add_reloc(struct relocs *r, uint32_t offset)
 static void walk_relocs(int (*process)(struct section *sec, Elf_Rel *rel,
 			Elf_Sym *sym, const char *symname))
 {
-	int i;
+	unsigned int i;
 	/* Walk through the relocations */
 	for (i = 0; i < ehdr.e_shnum; i++) {
 		char *sym_strtab;
 		Elf_Sym *sh_symtab;
 		struct section *sec_applies, *sec_symtab;
-		int j;
+		unsigned int j;
 		struct section *sec = &secs[i];
 
 		if (sec->shdr.sh_type != SHT_REL_TYPE) {
@@ -697,7 +746,7 @@ static void walk_relocs(int (*process)(struct section *sec, Elf_Rel *rel,
  * kernel data and does not require special treatment.
  *
  */
-static int per_cpu_shndx	= -1;
+static unsigned int per_cpu_shndx = ~0;
 static Elf_Addr per_cpu_load_addr;
 
 static void percpu_init(void)
@@ -830,6 +879,23 @@ static int do_reloc32(struct section *sec, Elf_Rel *rel, Elf_Sym *sym,
 {
 	unsigned r_type = ELF32_R_TYPE(rel->r_info);
 	int shn_abs = (sym->st_shndx == SHN_ABS) && !is_reloc(S_REL, symname);
+	char *sym_strtab = sec->link->link->strtab;
+
+	/* Don't relocate actual per-cpu variables, they are absolute indices, not addresses */
+	if (!strcmp(sec_name(sym->st_shndx), ".data..percpu") && strcmp(sym_name(sym_strtab, sym), "__per_cpu_load"))
+		return 0;
+
+#ifdef CONFIG_PAX_KERNEXEC
+	/* Don't relocate actual code, they are relocated implicitly by the base address of KERNEL_CS */
+	if (!strcmp(sec_name(sym->st_shndx), ".text.end") && !strcmp(sym_name(sym_strtab, sym), "_etext"))
+		return 0;
+	if (!strcmp(sec_name(sym->st_shndx), ".init.text"))
+		return 0;
+	if (!strcmp(sec_name(sym->st_shndx), ".exit.text"))
+		return 0;
+	if (!strcmp(sec_name(sym->st_shndx), ".text") && strcmp(sym_name(sym_strtab, sym), "__LOAD_PHYSICAL_ADDR"))
+		return 0;
+#endif
 
 	switch (r_type) {
 	case R_386_NONE:
@@ -968,7 +1034,7 @@ static int write32_as_text(uint32_t v, FILE *f)
 
 static void emit_relocs(int as_text, int use_real_mode)
 {
-	int i;
+	unsigned int i;
 	int (*write_reloc)(uint32_t, FILE *) = write32;
 	int (*do_reloc)(struct section *sec, Elf_Rel *rel, Elf_Sym *sym,
 			const char *symname);
@@ -1078,10 +1144,11 @@ void process(FILE *fp, int use_real_mode, int as_text,
 {
 	regex_init(use_real_mode);
 	read_ehdr(fp);
+	read_phdrs(fp);
 	read_shdrs(fp);
 	read_strtabs(fp);
 	read_symtabs(fp);
-	read_relocs(fp);
+	read_relocs(fp, use_real_mode);
 	if (ELF_BITS == 64)
 		percpu_init();
 	if (show_absolute_syms) {
diff --git a/arch/x86/um/mem_32.c b/arch/x86/um/mem_32.c
index 744afdc18..a0b8a0dd0 100644
--- a/arch/x86/um/mem_32.c
+++ b/arch/x86/um/mem_32.c
@@ -20,7 +20,7 @@ static int __init gate_vma_init(void)
 	gate_vma.vm_start = FIXADDR_USER_START;
 	gate_vma.vm_end = FIXADDR_USER_END;
 	gate_vma.vm_flags = VM_READ | VM_MAYREAD | VM_EXEC | VM_MAYEXEC;
-	gate_vma.vm_page_prot = __P101;
+	gate_vma.vm_page_prot = vm_get_page_prot(gate_vma.vm_flags);
 
 	return 0;
 }
diff --git a/arch/x86/um/tls_32.c b/arch/x86/um/tls_32.c
index 48e38584d..ab4458c19 100644
--- a/arch/x86/um/tls_32.c
+++ b/arch/x86/um/tls_32.c
@@ -261,7 +261,7 @@ out:
 	if (unlikely(task == current &&
 		     !t->arch.tls_array[idx - GDT_ENTRY_TLS_MIN].flushed)) {
 		printk(KERN_ERR "get_tls_entry: task with pid %d got here "
-				"without flushed TLS.", current->pid);
+				"without flushed TLS.", task_pid_nr(current));
 	}
 
 	return 0;
diff --git a/arch/x86/xen/Kconfig b/arch/x86/xen/Kconfig
index c7b15f3e2..cc09a659c 100644
--- a/arch/x86/xen/Kconfig
+++ b/arch/x86/xen/Kconfig
@@ -10,6 +10,7 @@ config XEN
 	select XEN_HAVE_VPMU
 	depends on X86_64 || (X86_32 && X86_PAE)
 	depends on X86_LOCAL_APIC && X86_TSC
+	depends on !GRKERNSEC_CONFIG_AUTO || GRKERNSEC_CONFIG_VIRT_XEN
 	help
 	  This is the Linux Xen port.  Enabling this will allow the
 	  kernel to boot in a paravirtualized environment under the
diff --git a/arch/x86/xen/enlighten.c b/arch/x86/xen/enlighten.c
index b86ebb1a9..e8a6e631b 100644
--- a/arch/x86/xen/enlighten.c
+++ b/arch/x86/xen/enlighten.c
@@ -134,8 +134,6 @@ EXPORT_SYMBOL_GPL(xen_start_info);
 
 struct shared_info xen_dummy_shared_info;
 
-void *xen_initial_gdt;
-
 RESERVE_BRK(shared_info_page_brk, PAGE_SIZE);
 __read_mostly int xen_have_vector_callback;
 EXPORT_SYMBOL_GPL(xen_have_vector_callback);
@@ -594,8 +592,7 @@ static void xen_load_gdt(const struct desc_ptr *dtr)
 {
 	unsigned long va = dtr->address;
 	unsigned int size = dtr->size + 1;
-	unsigned pages = DIV_ROUND_UP(size, PAGE_SIZE);
-	unsigned long frames[pages];
+	unsigned long frames[65536 / PAGE_SIZE];
 	int f;
 
 	/*
@@ -643,8 +640,7 @@ static void __init xen_load_gdt_boot(const struct desc_ptr *dtr)
 {
 	unsigned long va = dtr->address;
 	unsigned int size = dtr->size + 1;
-	unsigned pages = DIV_ROUND_UP(size, PAGE_SIZE);
-	unsigned long frames[pages];
+	unsigned long frames[(GDT_SIZE + PAGE_SIZE - 1) / PAGE_SIZE];
 	int f;
 
 	/*
@@ -652,7 +648,7 @@ static void __init xen_load_gdt_boot(const struct desc_ptr *dtr)
 	 * 8-byte entries, or 16 4k pages..
 	 */
 
-	BUG_ON(size > 65536);
+	BUG_ON(size > GDT_SIZE);
 	BUG_ON(va & ~PAGE_MASK);
 
 	for (f = 0; va < dtr->address + size; va += PAGE_SIZE, f++) {
@@ -781,7 +777,7 @@ static int cvt_gate_to_trap(int vector, const gate_desc *val,
 	 * so we should never see them.  Warn if
 	 * there's an unexpected IST-using fault handler.
 	 */
-	if (addr == (unsigned long)debug)
+	if (addr == (unsigned long)int1)
 		addr = (unsigned long)xen_debug;
 	else if (addr == (unsigned long)int3)
 		addr = (unsigned long)xen_int3;
@@ -1290,7 +1286,7 @@ static const struct pv_cpu_ops xen_cpu_ops __initconst = {
 	.end_context_switch = xen_end_context_switch,
 };
 
-static void xen_reboot(int reason)
+static __noreturn void xen_reboot(int reason)
 {
 	struct sched_shutdown r = { .reason = reason };
 	int cpu;
@@ -1298,26 +1294,26 @@ static void xen_reboot(int reason)
 	for_each_online_cpu(cpu)
 		xen_pmu_finish(cpu);
 
-	if (HYPERVISOR_sched_op(SCHEDOP_shutdown, &r))
-		BUG();
+	HYPERVISOR_sched_op(SCHEDOP_shutdown, &r);
+	BUG();
 }
 
-static void xen_restart(char *msg)
+static __noreturn void xen_restart(char *msg)
 {
 	xen_reboot(SHUTDOWN_reboot);
 }
 
-static void xen_emergency_restart(void)
+static __noreturn void xen_emergency_restart(void)
 {
 	xen_reboot(SHUTDOWN_reboot);
 }
 
-static void xen_machine_halt(void)
+static __noreturn void xen_machine_halt(void)
 {
 	xen_reboot(SHUTDOWN_poweroff);
 }
 
-static void xen_machine_power_off(void)
+static __noreturn void xen_machine_power_off(void)
 {
 	if (pm_power_off)
 		pm_power_off();
@@ -1471,8 +1467,11 @@ static void __ref xen_setup_gdt(int cpu)
 	pv_cpu_ops.write_gdt_entry = xen_write_gdt_entry_boot;
 	pv_cpu_ops.load_gdt = xen_load_gdt_boot;
 
-	setup_stack_canary_segment(0);
-	switch_to_new_gdt(0);
+	setup_stack_canary_segment(cpu);
+#ifdef CONFIG_X86_64
+	load_percpu_segment(cpu);
+#endif
+	switch_to_new_gdt(cpu);
 
 	pv_cpu_ops.write_gdt_entry = xen_write_gdt_entry;
 	pv_cpu_ops.load_gdt = xen_load_gdt;
@@ -1590,9 +1589,6 @@ asmlinkage __visible void __init xen_start_kernel(void)
 	 */
 	__userpte_alloc_gfp &= ~__GFP_HIGHMEM;
 
-	/* Work out if we support NX */
-	x86_configure_nx();
-
 	/* Get mfn list */
 	xen_build_dynamic_phys_to_machine();
 
@@ -1602,6 +1598,19 @@ asmlinkage __visible void __init xen_start_kernel(void)
 	 */
 	xen_setup_gdt(0);
 
+	/* Work out if we support NX */
+#if defined(CONFIG_X86_64) || defined(CONFIG_X86_PAE)
+	if ((cpuid_eax(0x80000000) & 0xffff0000) == 0x80000000 &&
+	    (cpuid_edx(0x80000001) & (1U << (X86_FEATURE_NX & 31)))) {
+		unsigned l, h;
+
+		__supported_pte_mask |= _PAGE_NX;
+		rdmsr(MSR_EFER, l, h);
+		l |= EFER_NX;
+		wrmsr(MSR_EFER, l, h);
+	}
+#endif
+
 	xen_init_irq_ops();
 	xen_init_cpuid_mask();
 
@@ -1619,13 +1628,6 @@ asmlinkage __visible void __init xen_start_kernel(void)
 
 	machine_ops = xen_machine_ops;
 
-	/*
-	 * The only reliable way to retain the initial address of the
-	 * percpu gdt_page is to remember it here, so we can go and
-	 * mark it RW later, when the initial percpu area is freed.
-	 */
-	xen_initial_gdt = &per_cpu(gdt_page, 0);
-
 	xen_smp_init();
 
 #ifdef CONFIG_ACPI_NUMA
diff --git a/arch/x86/xen/mmu.c b/arch/x86/xen/mmu.c
index 7d5afdb41..c89588c87 100644
--- a/arch/x86/xen/mmu.c
+++ b/arch/x86/xen/mmu.c
@@ -1940,7 +1940,14 @@ void __init xen_setup_kernel_pagetable(pgd_t *pgd, unsigned long max_pfn)
 		 * L3_k[511] -> level2_fixmap_pgt */
 		convert_pfn_mfn(level3_kernel_pgt);
 
+		convert_pfn_mfn(level3_vmalloc_start_pgt[0]);
+		convert_pfn_mfn(level3_vmalloc_start_pgt[1]);
+		convert_pfn_mfn(level3_vmalloc_start_pgt[2]);
+		convert_pfn_mfn(level3_vmalloc_start_pgt[3]);
+		convert_pfn_mfn(level3_vmalloc_end_pgt);
+		convert_pfn_mfn(level3_vmemmap_pgt);
 		/* L3_k[511][506] -> level1_fixmap_pgt */
+		/* L3_k[511][507] -> level1_vsyscall_pgt */
 		convert_pfn_mfn(level2_fixmap_pgt);
 	}
 	/* We get [511][511] and have Xen's version of level2_kernel_pgt */
@@ -1970,11 +1977,25 @@ void __init xen_setup_kernel_pagetable(pgd_t *pgd, unsigned long max_pfn)
 		set_page_prot(init_level4_pgt, PAGE_KERNEL_RO);
 		set_page_prot(level3_ident_pgt, PAGE_KERNEL_RO);
 		set_page_prot(level3_kernel_pgt, PAGE_KERNEL_RO);
+		set_page_prot(level3_vmalloc_start_pgt[0], PAGE_KERNEL_RO);
+		set_page_prot(level3_vmalloc_start_pgt[1], PAGE_KERNEL_RO);
+		set_page_prot(level3_vmalloc_start_pgt[2], PAGE_KERNEL_RO);
+		set_page_prot(level3_vmalloc_start_pgt[3], PAGE_KERNEL_RO);
+		set_page_prot(level3_vmalloc_end_pgt, PAGE_KERNEL_RO);
+		set_page_prot(level3_vmemmap_pgt, PAGE_KERNEL_RO);
 		set_page_prot(level3_user_vsyscall, PAGE_KERNEL_RO);
 		set_page_prot(level2_ident_pgt, PAGE_KERNEL_RO);
+		set_page_prot(level2_vmemmap_pgt, PAGE_KERNEL_RO);
 		set_page_prot(level2_kernel_pgt, PAGE_KERNEL_RO);
 		set_page_prot(level2_fixmap_pgt, PAGE_KERNEL_RO);
-		set_page_prot(level1_fixmap_pgt, PAGE_KERNEL_RO);
+		set_page_prot(level1_modules_pgt[0], PAGE_KERNEL_RO);
+		set_page_prot(level1_modules_pgt[1], PAGE_KERNEL_RO);
+		set_page_prot(level1_modules_pgt[2], PAGE_KERNEL_RO);
+		set_page_prot(level1_modules_pgt[3], PAGE_KERNEL_RO);
+		set_page_prot(level1_fixmap_pgt[0], PAGE_KERNEL_RO);
+		set_page_prot(level1_fixmap_pgt[1], PAGE_KERNEL_RO);
+		set_page_prot(level1_fixmap_pgt[2], PAGE_KERNEL_RO);
+		set_page_prot(level1_vsyscall_pgt, PAGE_KERNEL_RO);
 
 		/* Pin down new L4 */
 		pin_pagetable_pfn(MMUEXT_PIN_L4_TABLE,
@@ -2385,6 +2406,7 @@ static void __init xen_post_allocator_init(void)
 	pv_mmu_ops.set_pud = xen_set_pud;
 #if CONFIG_PGTABLE_LEVELS == 4
 	pv_mmu_ops.set_pgd = xen_set_pgd;
+	pv_mmu_ops.set_pgd_batched = xen_set_pgd;
 #endif
 
 	/* This will work as long as patching hasn't happened yet
@@ -2414,6 +2436,10 @@ static void xen_leave_lazy_mmu(void)
 	preempt_enable();
 }
 
+static void xen_pte_update(struct mm_struct *mm, unsigned long addr, pte_t *ptep)
+{
+}
+
 static const struct pv_mmu_ops xen_mmu_ops __initconst = {
 	.read_cr2 = xen_read_cr2,
 	.write_cr2 = xen_write_cr2,
@@ -2426,7 +2452,7 @@ static const struct pv_mmu_ops xen_mmu_ops __initconst = {
 	.flush_tlb_single = xen_flush_tlb_single,
 	.flush_tlb_others = xen_flush_tlb_others,
 
-	.pte_update = paravirt_nop,
+	.pte_update = xen_pte_update,
 
 	.pgd_alloc = xen_pgd_alloc,
 	.pgd_free = xen_pgd_free,
@@ -2463,6 +2489,7 @@ static const struct pv_mmu_ops xen_mmu_ops __initconst = {
 	.pud_val = PV_CALLEE_SAVE(xen_pud_val),
 	.make_pud = PV_CALLEE_SAVE(xen_make_pud),
 	.set_pgd = xen_set_pgd_hyper,
+	.set_pgd_batched = xen_set_pgd_hyper,
 
 	.alloc_pud = xen_alloc_pmd_init,
 	.release_pud = xen_release_pmd_init,
diff --git a/arch/x86/xen/pmu.c b/arch/x86/xen/pmu.c
index 32bdc2c90..073b8a5bd 100644
--- a/arch/x86/xen/pmu.c
+++ b/arch/x86/xen/pmu.c
@@ -444,6 +444,7 @@ static unsigned long xen_get_guest_ip(void)
 		return 0;
 	}
 
+	// TODO: adjust with the segment base
 	return xenpmu_data->pmu.r.regs.ip;
 }
 
diff --git a/arch/x86/xen/smp.c b/arch/x86/xen/smp.c
index 62284035b..2354210bf 100644
--- a/arch/x86/xen/smp.c
+++ b/arch/x86/xen/smp.c
@@ -312,17 +312,13 @@ static void __init xen_smp_prepare_boot_cpu(void)
 
 	if (xen_pv_domain()) {
 		if (!xen_feature(XENFEAT_writable_page_tables))
-			/* We've switched to the "real" per-cpu gdt, so make
-			 * sure the old memory can be recycled. */
-			make_lowmem_page_readwrite(xen_initial_gdt);
-
 #ifdef CONFIG_X86_32
 		/*
 		 * Xen starts us with XEN_FLAT_RING1_DS, but linux code
 		 * expects __USER_DS
 		 */
-		loadsegment(ds, __USER_DS);
-		loadsegment(es, __USER_DS);
+		loadsegment(ds, __KERNEL_DS);
+		loadsegment(es, __KERNEL_DS);
 #endif
 
 		xen_filter_cpu_maps();
@@ -412,7 +408,7 @@ cpu_initialize_context(unsigned int cpu, struct task_struct *idle)
 #ifdef CONFIG_X86_32
 	/* Note: PVH is not yet supported on x86_32. */
 	ctxt->user_regs.fs = __KERNEL_PERCPU;
-	ctxt->user_regs.gs = __KERNEL_STACK_CANARY;
+	savesegment(gs, ctxt->user_regs.gs);
 #endif
 	memset(&ctxt->fpu_ctxt, 0, sizeof(ctxt->fpu_ctxt));
 
@@ -420,8 +416,8 @@ cpu_initialize_context(unsigned int cpu, struct task_struct *idle)
 		ctxt->user_regs.eip = (unsigned long)cpu_bringup_and_idle;
 		ctxt->flags = VGCF_IN_KERNEL;
 		ctxt->user_regs.eflags = 0x1000; /* IOPL_RING1 */
-		ctxt->user_regs.ds = __USER_DS;
-		ctxt->user_regs.es = __USER_DS;
+		ctxt->user_regs.ds = __KERNEL_DS;
+		ctxt->user_regs.es = __KERNEL_DS;
 		ctxt->user_regs.ss = __KERNEL_DS;
 
 		xen_copy_trap_info(ctxt->trap_ctxt);
@@ -763,7 +759,7 @@ static const struct smp_ops xen_smp_ops __initconst = {
 
 void __init xen_smp_init(void)
 {
-	smp_ops = xen_smp_ops;
+	memcpy((void *)&smp_ops, &xen_smp_ops, sizeof smp_ops);
 	xen_fill_possible_map();
 }
 
diff --git a/arch/x86/xen/xen-asm_32.S b/arch/x86/xen/xen-asm_32.S
index feb6d40a0..e59382c5c 100644
--- a/arch/x86/xen/xen-asm_32.S
+++ b/arch/x86/xen/xen-asm_32.S
@@ -85,7 +85,7 @@ ENTRY(xen_iret)
 	pushw %fs
 	movl $(__KERNEL_PERCPU), %eax
 	movl %eax, %fs
-	movl %fs:xen_vcpu, %eax
+	mov PER_CPU_VAR(xen_vcpu), %eax
 	POP_FS
 #else
 	movl %ss:xen_vcpu, %eax
diff --git a/arch/x86/xen/xen-head.S b/arch/x86/xen/xen-head.S
index 7f8d8abf4..8ecf53e7a 100644
--- a/arch/x86/xen/xen-head.S
+++ b/arch/x86/xen/xen-head.S
@@ -50,6 +50,18 @@ ENTRY(startup_xen)
 	mov %_ASM_SI, xen_start_info
 	mov $init_thread_union+THREAD_SIZE, %_ASM_SP
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_SMP)
+	movl $cpu_gdt_table,%edi
+	movl $__per_cpu_load,%eax
+	movw %ax,__KERNEL_PERCPU + 2(%edi)
+	rorl $16,%eax
+	movb %al,__KERNEL_PERCPU + 4(%edi)
+	movb %ah,__KERNEL_PERCPU + 7(%edi)
+	movl $__per_cpu_end - 1,%eax
+	subl $__per_cpu_start,%eax
+	movw %ax,__KERNEL_PERCPU + 0(%edi)
+#endif
+
 	jmp xen_start_kernel
 
 	__FINIT
diff --git a/arch/x86/xen/xen-ops.h b/arch/x86/xen/xen-ops.h
index 3cbce3b08..f1221bcab 100644
--- a/arch/x86/xen/xen-ops.h
+++ b/arch/x86/xen/xen-ops.h
@@ -16,8 +16,6 @@ void xen_syscall_target(void);
 void xen_syscall32_target(void);
 #endif
 
-extern void *xen_initial_gdt;
-
 struct trap_info;
 void xen_copy_trap_info(struct trap_info *traps);
 
diff --git a/arch/xtensa/variants/dc232b/include/variant/core.h b/arch/xtensa/variants/dc232b/include/variant/core.h
index 525bd3d90..ef888b1c4 100644
--- a/arch/xtensa/variants/dc232b/include/variant/core.h
+++ b/arch/xtensa/variants/dc232b/include/variant/core.h
@@ -119,9 +119,9 @@
   ----------------------------------------------------------------------*/
 
 #define XCHAL_ICACHE_LINESIZE		32	/* I-cache line size in bytes */
-#define XCHAL_DCACHE_LINESIZE		32	/* D-cache line size in bytes */
 #define XCHAL_ICACHE_LINEWIDTH		5	/* log2(I line size in bytes) */
 #define XCHAL_DCACHE_LINEWIDTH		5	/* log2(D line size in bytes) */
+#define XCHAL_DCACHE_LINESIZE		(_AC(1,UL) << XCHAL_DCACHE_LINEWIDTH)	/* D-cache line size in bytes */
 
 #define XCHAL_ICACHE_SIZE		16384	/* I-cache size in bytes or 0 */
 #define XCHAL_DCACHE_SIZE		16384	/* D-cache size in bytes or 0 */
diff --git a/arch/xtensa/variants/fsf/include/variant/core.h b/arch/xtensa/variants/fsf/include/variant/core.h
index 2f337605c..835e50a88 100644
--- a/arch/xtensa/variants/fsf/include/variant/core.h
+++ b/arch/xtensa/variants/fsf/include/variant/core.h
@@ -11,6 +11,7 @@
 #ifndef _XTENSA_CORE_H
 #define _XTENSA_CORE_H
 
+#include <linux/const.h>
 
 /****************************************************************************
 	    Parameters Useful for Any Code, USER or PRIVILEGED
@@ -112,9 +113,9 @@
   ----------------------------------------------------------------------*/
 
 #define XCHAL_ICACHE_LINESIZE		16	/* I-cache line size in bytes */
-#define XCHAL_DCACHE_LINESIZE		16	/* D-cache line size in bytes */
 #define XCHAL_ICACHE_LINEWIDTH		4	/* log2(I line size in bytes) */
 #define XCHAL_DCACHE_LINEWIDTH		4	/* log2(D line size in bytes) */
+#define XCHAL_DCACHE_LINESIZE		(_AC(1,UL) << XCHAL_DCACHE_LINEWIDTH) /* D-cache line size in bytes */
 
 #define XCHAL_ICACHE_SIZE		8192	/* I-cache size in bytes or 0 */
 #define XCHAL_DCACHE_SIZE		8192	/* D-cache size in bytes or 0 */
diff --git a/block/bio.c b/block/bio.c
index aa7354088..ced15ee0e 100644
--- a/block/bio.c
+++ b/block/bio.c
@@ -1144,7 +1144,7 @@ struct bio *bio_copy_user_iov(struct request_queue *q,
 		/*
 		 * Overflow, abort
 		 */
-		if (end < start)
+		if (end < start || end - start > INT_MAX - nr_pages)
 			return ERR_PTR(-EINVAL);
 
 		nr_pages += end - start;
@@ -1269,7 +1269,7 @@ struct bio *bio_map_user_iov(struct request_queue *q,
 		/*
 		 * Overflow, abort
 		 */
-		if (end < start)
+		if (end < start || end - start > INT_MAX - nr_pages)
 			return ERR_PTR(-EINVAL);
 
 		nr_pages += end - start;
@@ -1777,7 +1777,7 @@ EXPORT_SYMBOL(bio_endio);
  * to @bio's bi_io_vec; it is the caller's responsibility to ensure that
  * @bio is not freed before the split.
  */
-struct bio *bio_split(struct bio *bio, int sectors,
+struct bio *bio_split(struct bio *bio, unsigned int sectors,
 		      gfp_t gfp, struct bio_set *bs)
 {
 	struct bio *split = NULL;
diff --git a/block/blk-cgroup.c b/block/blk-cgroup.c
index b08ccbb93..87fe4924f 100644
--- a/block/blk-cgroup.c
+++ b/block/blk-cgroup.c
@@ -561,10 +561,10 @@ u64 __blkg_prfill_rwstat(struct seq_file *sf, struct blkg_policy_data *pd,
 
 	for (i = 0; i < BLKG_RWSTAT_NR; i++)
 		seq_printf(sf, "%s %s %llu\n", dname, rwstr[i],
-			   (unsigned long long)atomic64_read(&rwstat->aux_cnt[i]));
+			   (unsigned long long)atomic64_read_unchecked(&rwstat->aux_cnt[i]));
 
-	v = atomic64_read(&rwstat->aux_cnt[BLKG_RWSTAT_READ]) +
-		atomic64_read(&rwstat->aux_cnt[BLKG_RWSTAT_WRITE]);
+	v = atomic64_read_unchecked(&rwstat->aux_cnt[BLKG_RWSTAT_READ]) +
+		atomic64_read_unchecked(&rwstat->aux_cnt[BLKG_RWSTAT_WRITE]);
 	seq_printf(sf, "%s Total %llu\n", dname, (unsigned long long)v);
 	return v;
 }
@@ -716,7 +716,7 @@ u64 blkg_stat_recursive_sum(struct blkcg_gq *blkg,
 		else
 			stat = (void *)blkg + off;
 
-		sum += blkg_stat_read(stat) + atomic64_read(&stat->aux_cnt);
+		sum += blkg_stat_read(stat) + atomic64_read_unchecked(&stat->aux_cnt);
 	}
 	rcu_read_unlock();
 
@@ -760,7 +760,7 @@ struct blkg_rwstat blkg_rwstat_recursive_sum(struct blkcg_gq *blkg,
 			rwstat = (void *)pos_blkg + off;
 
 		for (i = 0; i < BLKG_RWSTAT_NR; i++)
-			atomic64_add(atomic64_read(&rwstat->aux_cnt[i]) +
+			atomic64_add_unchecked(atomic64_read_unchecked(&rwstat->aux_cnt[i]) +
 				percpu_counter_sum_positive(&rwstat->cpu_cnt[i]),
 				&sum.aux_cnt[i]);
 	}
@@ -886,13 +886,13 @@ static int blkcg_print_stat(struct seq_file *sf, void *v)
 
 		rwstat = blkg_rwstat_recursive_sum(blkg, NULL,
 					offsetof(struct blkcg_gq, stat_bytes));
-		rbytes = atomic64_read(&rwstat.aux_cnt[BLKG_RWSTAT_READ]);
-		wbytes = atomic64_read(&rwstat.aux_cnt[BLKG_RWSTAT_WRITE]);
+		rbytes = atomic64_read_unchecked(&rwstat.aux_cnt[BLKG_RWSTAT_READ]);
+		wbytes = atomic64_read_unchecked(&rwstat.aux_cnt[BLKG_RWSTAT_WRITE]);
 
 		rwstat = blkg_rwstat_recursive_sum(blkg, NULL,
 					offsetof(struct blkcg_gq, stat_ios));
-		rios = atomic64_read(&rwstat.aux_cnt[BLKG_RWSTAT_READ]);
-		wios = atomic64_read(&rwstat.aux_cnt[BLKG_RWSTAT_WRITE]);
+		rios = atomic64_read_unchecked(&rwstat.aux_cnt[BLKG_RWSTAT_READ]);
+		wios = atomic64_read_unchecked(&rwstat.aux_cnt[BLKG_RWSTAT_WRITE]);
 
 		spin_unlock_irq(blkg->q->queue_lock);
 
diff --git a/block/blk-core.c b/block/blk-core.c
index 36c7ac328..ba1f2fdfa 100644
--- a/block/blk-core.c
+++ b/block/blk-core.c
@@ -3529,8 +3529,11 @@ int __init blk_dev_init(void)
 	if (!kblockd_workqueue)
 		panic("Failed to create kblockd\n");
 
-	request_cachep = kmem_cache_create("blkdev_requests",
-			sizeof(struct request), 0, SLAB_PANIC, NULL);
+	request_cachep = kmem_cache_create_usercopy("blkdev_requests",
+			sizeof(struct request), 0, SLAB_PANIC,
+			offsetof(struct request, __cmd),
+			sizeof(((struct request *)0)->__cmd),
+			NULL);
 
 	blk_requestq_cachep = kmem_cache_create("request_queue",
 			sizeof(struct request_queue), 0, SLAB_PANIC, NULL);
diff --git a/block/blk-map.c b/block/blk-map.c
index 27fd8d928..c03179e21 100644
--- a/block/blk-map.c
+++ b/block/blk-map.c
@@ -223,7 +223,7 @@ int blk_rq_map_kern(struct request_queue *q, struct request *rq, void *kbuf,
 	if (!len || !kbuf)
 		return -EINVAL;
 
-	do_copy = !blk_rq_aligned(q, addr, len) || object_is_on_stack(kbuf);
+	do_copy = !blk_rq_aligned(q, addr, len) || object_starts_on_stack(kbuf);
 	if (do_copy)
 		bio = bio_copy_kern(q, kbuf, len, gfp_mask, reading);
 	else
diff --git a/block/blk-softirq.c b/block/blk-softirq.c
index 53b1737e9..08177d2e7 100644
--- a/block/blk-softirq.c
+++ b/block/blk-softirq.c
@@ -18,7 +18,7 @@ static DEFINE_PER_CPU(struct list_head, blk_cpu_done);
  * Softirq action handler - move entries to local list and loop over them
  * while passing them to the queue registered handler.
  */
-static void blk_done_softirq(struct softirq_action *h)
+static __latent_entropy void blk_done_softirq(void)
 {
 	struct list_head *cpu_list, local_list;
 
diff --git a/block/cfq-iosched.c b/block/cfq-iosched.c
index 5e24d8803..c345d621d 100644
--- a/block/cfq-iosched.c
+++ b/block/cfq-iosched.c
@@ -1965,8 +1965,8 @@ static u64 cfqg_prfill_sectors_recursive(struct seq_file *sf,
 {
 	struct blkg_rwstat tmp = blkg_rwstat_recursive_sum(pd->blkg, NULL,
 					offsetof(struct blkcg_gq, stat_bytes));
-	u64 sum = atomic64_read(&tmp.aux_cnt[BLKG_RWSTAT_READ]) +
-		atomic64_read(&tmp.aux_cnt[BLKG_RWSTAT_WRITE]);
+	u64 sum = atomic64_read_unchecked(&tmp.aux_cnt[BLKG_RWSTAT_READ]) +
+		atomic64_read_unchecked(&tmp.aux_cnt[BLKG_RWSTAT_WRITE]);
 
 	return __blkg_prfill_u64(sf, pd, sum >> 9);
 }
diff --git a/block/compat_ioctl.c b/block/compat_ioctl.c
index 556826ac7..4e7c5fd7f 100644
--- a/block/compat_ioctl.c
+++ b/block/compat_ioctl.c
@@ -156,7 +156,7 @@ static int compat_cdrom_generic_command(struct block_device *bdev, fmode_t mode,
 	cgc = compat_alloc_user_space(sizeof(*cgc));
 	cgc32 = compat_ptr(arg);
 
-	if (copy_in_user(&cgc->cmd, &cgc32->cmd, sizeof(cgc->cmd)) ||
+	if (copy_in_user(cgc->cmd, cgc32->cmd, sizeof(cgc->cmd)) ||
 	    get_user(data, &cgc32->buffer) ||
 	    put_user(compat_ptr(data), &cgc->buffer) ||
 	    copy_in_user(&cgc->buflen, &cgc32->buflen,
@@ -341,7 +341,7 @@ static int compat_fd_ioctl(struct block_device *bdev, fmode_t mode,
 		err |= __get_user(f->spec1, &uf->spec1);
 		err |= __get_user(f->fmt_gap, &uf->fmt_gap);
 		err |= __get_user(name, &uf->name);
-		f->name = compat_ptr(name);
+		f->name = (void __force_kernel *)compat_ptr(name);
 		if (err) {
 			err = -EFAULT;
 			goto out;
diff --git a/block/genhd.c b/block/genhd.c
index fcd6d4fae..96e433b40 100644
--- a/block/genhd.c
+++ b/block/genhd.c
@@ -471,21 +471,24 @@ static char *bdevt_str(dev_t devt, char *buf)
 
 /*
  * Register device numbers dev..(dev+range-1)
- * range must be nonzero
+ * Noop if @range is zero.
  * The hash chain is sorted on range, so that subranges can override.
  */
 void blk_register_region(dev_t devt, unsigned long range, struct module *module,
 			 struct kobject *(*probe)(dev_t, int *, void *),
 			 int (*lock)(dev_t, void *), void *data)
 {
-	kobj_map(bdev_map, devt, range, module, probe, lock, data);
+	if (range)
+		kobj_map(bdev_map, devt, range, module, probe, lock, data);
 }
 
 EXPORT_SYMBOL(blk_register_region);
 
+/* undo blk_register_region(), noop if @range is zero */
 void blk_unregister_region(dev_t devt, unsigned long range)
 {
-	kobj_unmap(bdev_map, devt, range);
+	if (range)
+		kobj_unmap(bdev_map, devt, range);
 }
 
 EXPORT_SYMBOL(blk_unregister_region);
diff --git a/block/partitions/efi.c b/block/partitions/efi.c
index bcd86e5cd..fe457ef43 100644
--- a/block/partitions/efi.c
+++ b/block/partitions/efi.c
@@ -293,14 +293,14 @@ static gpt_entry *alloc_read_gpt_entries(struct parsed_partitions *state,
 	if (!gpt)
 		return NULL;
 
-	count = le32_to_cpu(gpt->num_partition_entries) *
-                le32_to_cpu(gpt->sizeof_partition_entry);
-	if (!count)
+	if (!le32_to_cpu(gpt->num_partition_entries))
 		return NULL;
-	pte = kmalloc(count, GFP_KERNEL);
+	pte = kcalloc(le32_to_cpu(gpt->num_partition_entries), le32_to_cpu(gpt->sizeof_partition_entry), GFP_KERNEL);
 	if (!pte)
 		return NULL;
 
+	count = le32_to_cpu(gpt->num_partition_entries) *
+                le32_to_cpu(gpt->sizeof_partition_entry);
 	if (read_lba(state, le64_to_cpu(gpt->partition_entry_lba),
 			(u8 *) pte, count) < count) {
 		kfree(pte);
diff --git a/block/scsi_ioctl.c b/block/scsi_ioctl.c
index 077479994..a0012eab9 100644
--- a/block/scsi_ioctl.c
+++ b/block/scsi_ioctl.c
@@ -67,7 +67,7 @@ static int scsi_get_bus(struct request_queue *q, int __user *p)
 	return put_user(0, p);
 }
 
-static int sg_get_timeout(struct request_queue *q)
+static int __intentional_overflow(-1) sg_get_timeout(struct request_queue *q)
 {
 	return jiffies_to_clock_t(q->sg_timeout);
 }
diff --git a/crypto/cast6_generic.c b/crypto/cast6_generic.c
index 058c8d755..55229ddb0 100644
--- a/crypto/cast6_generic.c
+++ b/crypto/cast6_generic.c
@@ -181,8 +181,9 @@ static inline void QBAR(u32 *block, u8 *Kr, u32 *Km)
 	block[2] ^= F1(block[3], Kr[0], Km[0]);
 }
 
-void __cast6_encrypt(struct cast6_ctx *c, u8 *outbuf, const u8 *inbuf)
+void __cast6_encrypt(void *_c, u8 *outbuf, const u8 *inbuf)
 {
+	struct cast6_ctx *c = _c;
 	const __be32 *src = (const __be32 *)inbuf;
 	__be32 *dst = (__be32 *)outbuf;
 	u32 block[4];
@@ -219,8 +220,9 @@ static void cast6_encrypt(struct crypto_tfm *tfm, u8 *outbuf, const u8 *inbuf)
 	__cast6_encrypt(crypto_tfm_ctx(tfm), outbuf, inbuf);
 }
 
-void __cast6_decrypt(struct cast6_ctx *c, u8 *outbuf, const u8 *inbuf)
+void __cast6_decrypt(void *_c, u8 *outbuf, const u8 *inbuf)
 {
+	struct cast6_ctx *c = _c;
 	const __be32 *src = (const __be32 *)inbuf;
 	__be32 *dst = (__be32 *)outbuf;
 	u32 block[4];
diff --git a/crypto/cryptd.c b/crypto/cryptd.c
index 0c654e59f..cf01e3e8f 100644
--- a/crypto/cryptd.c
+++ b/crypto/cryptd.c
@@ -65,7 +65,7 @@ struct cryptd_blkcipher_ctx {
 
 struct cryptd_blkcipher_request_ctx {
 	crypto_completion_t complete;
-};
+} __no_const;
 
 struct cryptd_hash_ctx {
 	atomic_t refcnt;
@@ -84,7 +84,7 @@ struct cryptd_aead_ctx {
 
 struct cryptd_aead_request_ctx {
 	crypto_completion_t complete;
-};
+} __no_const;
 
 static void cryptd_queue_worker(struct work_struct *work);
 
diff --git a/crypto/crypto_user.c b/crypto/crypto_user.c
index 1c5705481..e0299350c 100644
--- a/crypto/crypto_user.c
+++ b/crypto/crypto_user.c
@@ -490,7 +490,7 @@ static int crypto_user_rcv_msg(struct sk_buff *skb, struct nlmsghdr *nlh)
 			dump_alloc += CRYPTO_REPORT_MAXSIZE;
 
 		{
-			struct netlink_dump_control c = {
+			netlink_dump_control_no_const c = {
 				.dump = link->dump,
 				.done = link->done,
 				.min_dump_alloc = dump_alloc,
diff --git a/crypto/pcrypt.c b/crypto/pcrypt.c
index ee9cfb99f..30b36ed13 100644
--- a/crypto/pcrypt.c
+++ b/crypto/pcrypt.c
@@ -392,7 +392,7 @@ static int pcrypt_sysfs_add(struct padata_instance *pinst, const char *name)
 	int ret;
 
 	pinst->kobj.kset = pcrypt_kset;
-	ret = kobject_add(&pinst->kobj, NULL, name);
+	ret = kobject_add(&pinst->kobj, NULL, "%s", name);
 	if (!ret)
 		kobject_uevent(&pinst->kobj, KOBJ_ADD);
 
diff --git a/crypto/salsa20_generic.c b/crypto/salsa20_generic.c
index f550b5d94..8488bebe8 100644
--- a/crypto/salsa20_generic.c
+++ b/crypto/salsa20_generic.c
@@ -104,7 +104,7 @@ static void salsa20_wordtobyte(u8 output[64], const u32 input[16])
 static const char sigma[16] = "expand 32-byte k";
 static const char tau[16] = "expand 16-byte k";
 
-static void salsa20_keysetup(struct salsa20_ctx *ctx, const u8 *k, u32 kbytes)
+static void __salsa20_keysetup(struct salsa20_ctx *ctx, const u8 *k, u32 kbytes)
 {
 	const char *constants;
 
@@ -128,7 +128,7 @@ static void salsa20_keysetup(struct salsa20_ctx *ctx, const u8 *k, u32 kbytes)
 	ctx->input[15] = U8TO32_LITTLE(constants + 12);
 }
 
-static void salsa20_ivsetup(struct salsa20_ctx *ctx, const u8 *iv)
+static void __salsa20_ivsetup(struct salsa20_ctx *ctx, const u8 *iv)
 {
 	ctx->input[6] = U8TO32_LITTLE(iv + 0);
 	ctx->input[7] = U8TO32_LITTLE(iv + 4);
@@ -136,7 +136,7 @@ static void salsa20_ivsetup(struct salsa20_ctx *ctx, const u8 *iv)
 	ctx->input[9] = 0;
 }
 
-static void salsa20_encrypt_bytes(struct salsa20_ctx *ctx, u8 *dst,
+static void __salsa20_encrypt_bytes(struct salsa20_ctx *ctx, u8 *dst,
 				  const u8 *src, unsigned int bytes)
 {
 	u8 buf[64];
@@ -170,7 +170,7 @@ static int setkey(struct crypto_tfm *tfm, const u8 *key,
 		  unsigned int keysize)
 {
 	struct salsa20_ctx *ctx = crypto_tfm_ctx(tfm);
-	salsa20_keysetup(ctx, key, keysize);
+	__salsa20_keysetup(ctx, key, keysize);
 	return 0;
 }
 
@@ -186,24 +186,24 @@ static int encrypt(struct blkcipher_desc *desc,
 	blkcipher_walk_init(&walk, dst, src, nbytes);
 	err = blkcipher_walk_virt_block(desc, &walk, 64);
 
-	salsa20_ivsetup(ctx, walk.iv);
+	__salsa20_ivsetup(ctx, walk.iv);
 
 	if (likely(walk.nbytes == nbytes))
 	{
-		salsa20_encrypt_bytes(ctx, walk.dst.virt.addr,
+		__salsa20_encrypt_bytes(ctx, walk.dst.virt.addr,
 				      walk.src.virt.addr, nbytes);
 		return blkcipher_walk_done(desc, &walk, 0);
 	}
 
 	while (walk.nbytes >= 64) {
-		salsa20_encrypt_bytes(ctx, walk.dst.virt.addr,
+		__salsa20_encrypt_bytes(ctx, walk.dst.virt.addr,
 				      walk.src.virt.addr,
 				      walk.nbytes - (walk.nbytes % 64));
 		err = blkcipher_walk_done(desc, &walk, walk.nbytes % 64);
 	}
 
 	if (walk.nbytes) {
-		salsa20_encrypt_bytes(ctx, walk.dst.virt.addr,
+		__salsa20_encrypt_bytes(ctx, walk.dst.virt.addr,
 				      walk.src.virt.addr, walk.nbytes);
 		err = blkcipher_walk_done(desc, &walk, 0);
 	}
diff --git a/crypto/scatterwalk.c b/crypto/scatterwalk.c
index 52ce17a3d..fc10b38fa 100644
--- a/crypto/scatterwalk.c
+++ b/crypto/scatterwalk.c
@@ -62,14 +62,20 @@ void scatterwalk_map_and_copy(void *buf, struct scatterlist *sg,
 {
 	struct scatter_walk walk;
 	struct scatterlist tmp[2];
+	void *realbuf = buf;
 
 	if (!nbytes)
 		return;
 
 	sg = scatterwalk_ffwd(tmp, sg, start);
 
-	if (sg_page(sg) == virt_to_page(buf) &&
-	    sg->offset == offset_in_page(buf))
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	if (object_starts_on_stack(buf))
+		realbuf = buf - current->stack + current->lowmem_stack;
+#endif
+
+	if (sg_page(sg) == virt_to_page(realbuf) &&
+	    sg->offset == offset_in_page(realbuf))
 		return;
 
 	scatterwalk_start(&walk, sg);
diff --git a/crypto/serpent_generic.c b/crypto/serpent_generic.c
index 94970a794..f0c8d2670 100644
--- a/crypto/serpent_generic.c
+++ b/crypto/serpent_generic.c
@@ -442,8 +442,9 @@ int serpent_setkey(struct crypto_tfm *tfm, const u8 *key, unsigned int keylen)
 }
 EXPORT_SYMBOL_GPL(serpent_setkey);
 
-void __serpent_encrypt(struct serpent_ctx *ctx, u8 *dst, const u8 *src)
+void __serpent_encrypt(void *_ctx, u8 *dst, const u8 *src)
 {
+	struct serpent_ctx *ctx = _ctx;
 	const u32 *k = ctx->expkey;
 	const __le32 *s = (const __le32 *)src;
 	__le32	*d = (__le32 *)dst;
@@ -507,8 +508,9 @@ static void serpent_encrypt(struct crypto_tfm *tfm, u8 *dst, const u8 *src)
 	__serpent_encrypt(ctx, dst, src);
 }
 
-void __serpent_decrypt(struct serpent_ctx *ctx, u8 *dst, const u8 *src)
+void __serpent_decrypt(void *_ctx, u8 *dst, const u8 *src)
 {
+	struct serpent_ctx *ctx = _ctx;
 	const u32 *k = ctx->expkey;
 	const __le32 *s = (const __le32 *)src;
 	__le32	*d = (__le32 *)dst;
diff --git a/drivers/acpi/ac.c b/drivers/acpi/ac.c
index f71b756b0..b96847cdf 100644
--- a/drivers/acpi/ac.c
+++ b/drivers/acpi/ac.c
@@ -70,7 +70,7 @@ static SIMPLE_DEV_PM_OPS(acpi_ac_pm, NULL, acpi_ac_resume);
 
 #ifdef CONFIG_ACPI_PROCFS_POWER
 extern struct proc_dir_entry *acpi_lock_ac_dir(void);
-extern void *acpi_unlock_ac_dir(struct proc_dir_entry *acpi_ac_dir);
+extern void acpi_unlock_ac_dir(struct proc_dir_entry *acpi_ac_dir);
 static int acpi_ac_open_fs(struct inode *inode, struct file *file);
 #endif
 
diff --git a/drivers/acpi/acpi_video.c b/drivers/acpi/acpi_video.c
index c5557d070..8ece62499 100644
--- a/drivers/acpi/acpi_video.c
+++ b/drivers/acpi/acpi_video.c
@@ -406,7 +406,7 @@ static int video_set_report_key_events(const struct dmi_system_id *id)
 	return 0;
 }
 
-static struct dmi_system_id video_dmi_table[] = {
+static const struct dmi_system_id video_dmi_table[] = {
 	/*
 	 * Broken _BQC workaround http://bugzilla.kernel.org/show_bug.cgi?id=13121
 	 */
diff --git a/drivers/acpi/acpica/acutils.h b/drivers/acpi/acpica/acutils.h
index a7dbb2b88..93e986e8b 100644
--- a/drivers/acpi/acpica/acutils.h
+++ b/drivers/acpi/acpica/acutils.h
@@ -274,7 +274,7 @@ void acpi_ut_init_stack_ptr_trace(void);
 
 void acpi_ut_track_stack_ptr(void);
 
-void
+__nocapture(2) void
 acpi_ut_trace(u32 line_number,
 	      const char *function_name,
 	      const char *module_name, u32 component_id);
diff --git a/drivers/acpi/acpica/dbhistry.c b/drivers/acpi/acpica/dbhistry.c
index 46bd65d38..ec9da4830 100644
--- a/drivers/acpi/acpica/dbhistry.c
+++ b/drivers/acpi/acpica/dbhistry.c
@@ -155,7 +155,7 @@ void acpi_db_display_history(void)
 
 	for (i = 0; i < acpi_gbl_num_history; i++) {
 		if (acpi_gbl_history_buffer[history_index].command) {
-			acpi_os_printf("%3ld %s\n",
+			acpi_os_printf("%3u %s\n",
 				       acpi_gbl_history_buffer[history_index].
 				       cmd_num,
 				       acpi_gbl_history_buffer[history_index].
diff --git a/drivers/acpi/acpica/dbinput.c b/drivers/acpi/acpica/dbinput.c
index 7cd5d2e02..a837ce661 100644
--- a/drivers/acpi/acpica/dbinput.c
+++ b/drivers/acpi/acpica/dbinput.c
@@ -606,7 +606,7 @@ static u32 acpi_db_get_line(char *input_buffer)
 	    (acpi_gbl_db_parsed_buf, sizeof(acpi_gbl_db_parsed_buf),
 	     input_buffer)) {
 		acpi_os_printf
-		    ("Buffer overflow while parsing input line (max %u characters)\n",
+		    ("Buffer overflow while parsing input line (max %lu characters)\n",
 		     sizeof(acpi_gbl_db_parsed_buf));
 		return (0);
 	}
@@ -862,24 +862,24 @@ acpi_db_command_dispatch(char *input_buffer,
 
 		if (param_count == 0) {
 			acpi_os_printf
-			    ("Current debug level for file output is:    %8.8lX\n",
+			    ("Current debug level for file output is:    %8.8X\n",
 			     acpi_gbl_db_debug_level);
 			acpi_os_printf
-			    ("Current debug level for console output is: %8.8lX\n",
+			    ("Current debug level for console output is: %8.8X\n",
 			     acpi_gbl_db_console_debug_level);
 		} else if (param_count == 2) {
 			temp = acpi_gbl_db_console_debug_level;
 			acpi_gbl_db_console_debug_level =
 			    strtoul(acpi_gbl_db_args[1], NULL, 16);
 			acpi_os_printf
-			    ("Debug Level for console output was %8.8lX, now %8.8lX\n",
+			    ("Debug Level for console output was %8.8X, now %8.8X\n",
 			     temp, acpi_gbl_db_console_debug_level);
 		} else {
 			temp = acpi_gbl_db_debug_level;
 			acpi_gbl_db_debug_level =
 			    strtoul(acpi_gbl_db_args[1], NULL, 16);
 			acpi_os_printf
-			    ("Debug Level for file output was %8.8lX, now %8.8lX\n",
+			    ("Debug Level for file output was %8.8X, now %8.8X\n",
 			     temp, acpi_gbl_db_debug_level);
 		}
 		break;
diff --git a/drivers/acpi/acpica/dbstats.c b/drivers/acpi/acpica/dbstats.c
index a414e1fa6..de7023024 100644
--- a/drivers/acpi/acpica/dbstats.c
+++ b/drivers/acpi/acpica/dbstats.c
@@ -377,17 +377,17 @@ acpi_status acpi_db_display_statistics(char *type_arg)
 			       "ACPI_TYPE", "NODES", "OBJECTS");
 
 		for (i = 0; i < ACPI_TYPE_NS_NODE_MAX; i++) {
-			acpi_os_printf("%16.16s % 10ld% 10ld\n",
+			acpi_os_printf("%16.16s % 10d% 10d\n",
 				       acpi_ut_get_type_name(i),
 				       acpi_gbl_node_type_count[i],
 				       acpi_gbl_obj_type_count[i]);
 		}
 
-		acpi_os_printf("%16.16s % 10ld% 10ld\n", "Misc/Unknown",
+		acpi_os_printf("%16.16s % 10d% 10d\n", "Misc/Unknown",
 			       acpi_gbl_node_type_count_misc,
 			       acpi_gbl_obj_type_count_misc);
 
-		acpi_os_printf("%16.16s % 10ld% 10ld\n", "TOTALS:",
+		acpi_os_printf("%16.16s % 10d% 10d\n", "TOTALS:",
 			       acpi_gbl_num_nodes, acpi_gbl_num_objects);
 		break;
 
@@ -415,16 +415,16 @@ acpi_status acpi_db_display_statistics(char *type_arg)
 	case CMD_STAT_MISC:
 
 		acpi_os_printf("\nMiscellaneous Statistics:\n\n");
-		acpi_os_printf("Calls to AcpiPsFind:.. ........% 7ld\n",
+		acpi_os_printf("Calls to AcpiPsFind:.. ........% 7u\n",
 			       acpi_gbl_ps_find_count);
-		acpi_os_printf("Calls to AcpiNsLookup:..........% 7ld\n",
+		acpi_os_printf("Calls to AcpiNsLookup:..........% 7u\n",
 			       acpi_gbl_ns_lookup_count);
 
 		acpi_os_printf("\n");
 
 		acpi_os_printf("Mutex usage:\n\n");
 		for (i = 0; i < ACPI_NUM_MUTEX; i++) {
-			acpi_os_printf("%-28s:     % 7ld\n",
+			acpi_os_printf("%-28s:     % 7u\n",
 				       acpi_ut_get_mutex_name(i),
 				       acpi_gbl_mutex_info[i].use_count);
 		}
@@ -434,87 +434,87 @@ acpi_status acpi_db_display_statistics(char *type_arg)
 
 		acpi_os_printf("\nInternal object sizes:\n\n");
 
-		acpi_os_printf("Common         %3d\n",
+		acpi_os_printf("Common         %3lu\n",
 			       sizeof(struct acpi_object_common));
-		acpi_os_printf("Number         %3d\n",
+		acpi_os_printf("Number         %3lu\n",
 			       sizeof(struct acpi_object_integer));
-		acpi_os_printf("String         %3d\n",
+		acpi_os_printf("String         %3lu\n",
 			       sizeof(struct acpi_object_string));
-		acpi_os_printf("Buffer         %3d\n",
+		acpi_os_printf("Buffer         %3lu\n",
 			       sizeof(struct acpi_object_buffer));
-		acpi_os_printf("Package        %3d\n",
+		acpi_os_printf("Package        %3lu\n",
 			       sizeof(struct acpi_object_package));
-		acpi_os_printf("BufferField    %3d\n",
+		acpi_os_printf("BufferField    %3lu\n",
 			       sizeof(struct acpi_object_buffer_field));
-		acpi_os_printf("Device         %3d\n",
+		acpi_os_printf("Device         %3lu\n",
 			       sizeof(struct acpi_object_device));
-		acpi_os_printf("Event          %3d\n",
+		acpi_os_printf("Event          %3lu\n",
 			       sizeof(struct acpi_object_event));
-		acpi_os_printf("Method         %3d\n",
+		acpi_os_printf("Method         %3lu\n",
 			       sizeof(struct acpi_object_method));
-		acpi_os_printf("Mutex          %3d\n",
+		acpi_os_printf("Mutex          %3lu\n",
 			       sizeof(struct acpi_object_mutex));
-		acpi_os_printf("Region         %3d\n",
+		acpi_os_printf("Region         %3lu\n",
 			       sizeof(struct acpi_object_region));
-		acpi_os_printf("PowerResource  %3d\n",
+		acpi_os_printf("PowerResource  %3lu\n",
 			       sizeof(struct acpi_object_power_resource));
-		acpi_os_printf("Processor      %3d\n",
+		acpi_os_printf("Processor      %3lu\n",
 			       sizeof(struct acpi_object_processor));
-		acpi_os_printf("ThermalZone    %3d\n",
+		acpi_os_printf("ThermalZone    %3lu\n",
 			       sizeof(struct acpi_object_thermal_zone));
-		acpi_os_printf("RegionField    %3d\n",
+		acpi_os_printf("RegionField    %3lu\n",
 			       sizeof(struct acpi_object_region_field));
-		acpi_os_printf("BankField      %3d\n",
+		acpi_os_printf("BankField      %3lu\n",
 			       sizeof(struct acpi_object_bank_field));
-		acpi_os_printf("IndexField     %3d\n",
+		acpi_os_printf("IndexField     %3lu\n",
 			       sizeof(struct acpi_object_index_field));
-		acpi_os_printf("Reference      %3d\n",
+		acpi_os_printf("Reference      %3lu\n",
 			       sizeof(struct acpi_object_reference));
-		acpi_os_printf("Notify         %3d\n",
+		acpi_os_printf("Notify         %3lu\n",
 			       sizeof(struct acpi_object_notify_handler));
-		acpi_os_printf("AddressSpace   %3d\n",
+		acpi_os_printf("AddressSpace   %3lu\n",
 			       sizeof(struct acpi_object_addr_handler));
-		acpi_os_printf("Extra          %3d\n",
+		acpi_os_printf("Extra          %3lu\n",
 			       sizeof(struct acpi_object_extra));
-		acpi_os_printf("Data           %3d\n",
+		acpi_os_printf("Data           %3lu\n",
 			       sizeof(struct acpi_object_data));
 
 		acpi_os_printf("\n");
 
-		acpi_os_printf("ParseObject    %3d\n",
+		acpi_os_printf("ParseObject    %3lu\n",
 			       sizeof(struct acpi_parse_obj_common));
-		acpi_os_printf("ParseObjectNamed %3d\n",
+		acpi_os_printf("ParseObjectNamed %3lu\n",
 			       sizeof(struct acpi_parse_obj_named));
-		acpi_os_printf("ParseObjectAsl %3d\n",
+		acpi_os_printf("ParseObjectAsl %3lu\n",
 			       sizeof(struct acpi_parse_obj_asl));
-		acpi_os_printf("OperandObject  %3d\n",
+		acpi_os_printf("OperandObject  %3lu\n",
 			       sizeof(union acpi_operand_object));
-		acpi_os_printf("NamespaceNode  %3d\n",
+		acpi_os_printf("NamespaceNode  %3lu\n",
 			       sizeof(struct acpi_namespace_node));
-		acpi_os_printf("AcpiObject     %3d\n",
+		acpi_os_printf("AcpiObject     %3lu\n",
 			       sizeof(union acpi_object));
 
 		acpi_os_printf("\n");
 
-		acpi_os_printf("Generic State  %3d\n",
+		acpi_os_printf("Generic State  %3lu\n",
 			       sizeof(union acpi_generic_state));
-		acpi_os_printf("Common State   %3d\n",
+		acpi_os_printf("Common State   %3lu\n",
 			       sizeof(struct acpi_common_state));
-		acpi_os_printf("Control State  %3d\n",
+		acpi_os_printf("Control State  %3lu\n",
 			       sizeof(struct acpi_control_state));
-		acpi_os_printf("Update State   %3d\n",
+		acpi_os_printf("Update State   %3lu\n",
 			       sizeof(struct acpi_update_state));
-		acpi_os_printf("Scope State    %3d\n",
+		acpi_os_printf("Scope State    %3lu\n",
 			       sizeof(struct acpi_scope_state));
-		acpi_os_printf("Parse Scope    %3d\n",
+		acpi_os_printf("Parse Scope    %3lu\n",
 			       sizeof(struct acpi_pscope_state));
-		acpi_os_printf("Package State  %3d\n",
+		acpi_os_printf("Package State  %3lu\n",
 			       sizeof(struct acpi_pkg_state));
-		acpi_os_printf("Thread State   %3d\n",
+		acpi_os_printf("Thread State   %3lu\n",
 			       sizeof(struct acpi_thread_state));
-		acpi_os_printf("Result Values  %3d\n",
+		acpi_os_printf("Result Values  %3lu\n",
 			       sizeof(struct acpi_result_values));
-		acpi_os_printf("Notify Info    %3d\n",
+		acpi_os_printf("Notify Info    %3lu\n",
 			       sizeof(struct acpi_notify_info));
 		break;
 
diff --git a/drivers/acpi/acpica/hwxfsleep.c b/drivers/acpi/acpica/hwxfsleep.c
index f76e0eab3..4b83315dd 100644
--- a/drivers/acpi/acpica/hwxfsleep.c
+++ b/drivers/acpi/acpica/hwxfsleep.c
@@ -70,11 +70,12 @@ static acpi_status acpi_hw_sleep_dispatch(u8 sleep_state, u32 function_id);
 /* Legacy functions are optional, based upon ACPI_REDUCED_HARDWARE */
 
 static struct acpi_sleep_functions acpi_sleep_dispatch[] = {
-	{ACPI_HW_OPTIONAL_FUNCTION(acpi_hw_legacy_sleep),
-	 acpi_hw_extended_sleep},
-	{ACPI_HW_OPTIONAL_FUNCTION(acpi_hw_legacy_wake_prep),
-	 acpi_hw_extended_wake_prep},
-	{ACPI_HW_OPTIONAL_FUNCTION(acpi_hw_legacy_wake), acpi_hw_extended_wake}
+	{.legacy_function = ACPI_HW_OPTIONAL_FUNCTION(acpi_hw_legacy_sleep),
+	 .extended_function = acpi_hw_extended_sleep},
+	{.legacy_function = ACPI_HW_OPTIONAL_FUNCTION(acpi_hw_legacy_wake_prep),
+	 .extended_function = acpi_hw_extended_wake_prep},
+	{.legacy_function = ACPI_HW_OPTIONAL_FUNCTION(acpi_hw_legacy_wake),
+	 .extended_function = acpi_hw_extended_wake}
 };
 
 /*
diff --git a/drivers/acpi/acpica/utdebug.c b/drivers/acpi/acpica/utdebug.c
index 574422205..4ac231a6d 100644
--- a/drivers/acpi/acpica/utdebug.c
+++ b/drivers/acpi/acpica/utdebug.c
@@ -189,7 +189,7 @@ acpi_debug_print(u32 requested_debug_level,
 	 * Display the module name, current line number, thread ID (if requested),
 	 * current procedure nesting level, and the current procedure name
 	 */
-	acpi_os_printf("%9s-%04ld ", module_name, line_number);
+	acpi_os_printf("%9s-%04u ", module_name, line_number);
 
 #ifdef ACPI_APPLICATION
 	/*
diff --git a/drivers/acpi/apei/apei-internal.h b/drivers/acpi/apei/apei-internal.h
index 6e9f14c0a..7f9a99db3 100644
--- a/drivers/acpi/apei/apei-internal.h
+++ b/drivers/acpi/apei/apei-internal.h
@@ -19,7 +19,7 @@ typedef int (*apei_exec_ins_func_t)(struct apei_exec_context *ctx,
 struct apei_exec_ins_type {
 	u32 flags;
 	apei_exec_ins_func_t run;
-};
+} __do_const;
 
 struct apei_exec_context {
 	u32 ip;
diff --git a/drivers/acpi/apei/ghes.c b/drivers/acpi/apei/ghes.c
index caea575f2..4dd8306a6 100644
--- a/drivers/acpi/apei/ghes.c
+++ b/drivers/acpi/apei/ghes.c
@@ -483,7 +483,7 @@ static void __ghes_print_estatus(const char *pfx,
 				 const struct acpi_hest_generic *generic,
 				 const struct acpi_hest_generic_status *estatus)
 {
-	static atomic_t seqno;
+	static atomic_unchecked_t seqno;
 	unsigned int curr_seqno;
 	char pfx_seq[64];
 
@@ -494,7 +494,7 @@ static void __ghes_print_estatus(const char *pfx,
 		else
 			pfx = KERN_ERR;
 	}
-	curr_seqno = atomic_inc_return(&seqno);
+	curr_seqno = atomic_inc_return_unchecked(&seqno);
 	snprintf(pfx_seq, sizeof(pfx_seq), "%s{%u}" HW_ERR, pfx, curr_seqno);
 	printk("%s""Hardware error from APEI Generic Hardware Error Source: %d\n",
 	       pfx_seq, generic->header.source_id);
@@ -544,7 +544,7 @@ static int ghes_estatus_cached(struct acpi_hest_generic_status *estatus)
 		cache_estatus = GHES_ESTATUS_FROM_CACHE(cache);
 		if (memcmp(estatus, cache_estatus, len))
 			continue;
-		atomic_inc(&cache->count);
+		atomic_inc_unchecked(&cache->count);
 		now = sched_clock();
 		if (now - cache->time_in < GHES_ESTATUS_IN_CACHE_MAX_NSEC)
 			cached = 1;
@@ -578,7 +578,7 @@ static struct ghes_estatus_cache *ghes_estatus_cache_alloc(
 	cache_estatus = GHES_ESTATUS_FROM_CACHE(cache);
 	memcpy(cache_estatus, estatus, len);
 	cache->estatus_len = len;
-	atomic_set(&cache->count, 0);
+	atomic_set_unchecked(&cache->count, 0);
 	cache->generic = generic;
 	cache->time_in = sched_clock();
 	return cache;
@@ -628,7 +628,7 @@ static void ghes_estatus_cache_add(
 			slot_cache = cache;
 			break;
 		}
-		count = atomic_read(&cache->count);
+		count = atomic_read_unchecked(&cache->count);
 		period = duration;
 		do_div(period, (count + 1));
 		if (period > max_period) {
diff --git a/drivers/acpi/battery.c b/drivers/acpi/battery.c
index ab234791a..9aa32bfd0 100644
--- a/drivers/acpi/battery.c
+++ b/drivers/acpi/battery.c
@@ -75,7 +75,7 @@ MODULE_PARM_DESC(cache_time, "cache time in milliseconds");
 
 #ifdef CONFIG_ACPI_PROCFS_POWER
 extern struct proc_dir_entry *acpi_lock_battery_dir(void);
-extern void *acpi_unlock_battery_dir(struct proc_dir_entry *acpi_battery_dir);
+extern void acpi_unlock_battery_dir(struct proc_dir_entry *acpi_battery_dir);
 
 enum acpi_battery_files {
 	info_tag = 0,
diff --git a/drivers/acpi/bgrt.c b/drivers/acpi/bgrt.c
index 75f128e76..0fbae68c8 100644
--- a/drivers/acpi/bgrt.c
+++ b/drivers/acpi/bgrt.c
@@ -17,40 +17,40 @@
 
 static struct kobject *bgrt_kobj;
 
-static ssize_t show_version(struct device *dev,
-			    struct device_attribute *attr, char *buf)
+static ssize_t show_version(struct kobject *kobj,
+			    struct kobj_attribute *attr, char *buf)
 {
 	return snprintf(buf, PAGE_SIZE, "%d\n", bgrt_tab->version);
 }
-static DEVICE_ATTR(version, S_IRUGO, show_version, NULL);
+static KOBJECT_ATTR(version, S_IRUGO, show_version, NULL);
 
-static ssize_t show_status(struct device *dev,
-			   struct device_attribute *attr, char *buf)
+static ssize_t show_status(struct kobject *kobj,
+			   struct kobj_attribute *attr, char *buf)
 {
 	return snprintf(buf, PAGE_SIZE, "%d\n", bgrt_tab->status);
 }
-static DEVICE_ATTR(status, S_IRUGO, show_status, NULL);
+static KOBJECT_ATTR(status, S_IRUGO, show_status, NULL);
 
-static ssize_t show_type(struct device *dev,
-			 struct device_attribute *attr, char *buf)
+static ssize_t show_type(struct kobject *kobj,
+			 struct kobj_attribute *attr, char *buf)
 {
 	return snprintf(buf, PAGE_SIZE, "%d\n", bgrt_tab->image_type);
 }
-static DEVICE_ATTR(type, S_IRUGO, show_type, NULL);
+static KOBJECT_ATTR(type, S_IRUGO, show_type, NULL);
 
-static ssize_t show_xoffset(struct device *dev,
-			    struct device_attribute *attr, char *buf)
+static ssize_t show_xoffset(struct kobject *kobj,
+			    struct kobj_attribute *attr, char *buf)
 {
 	return snprintf(buf, PAGE_SIZE, "%d\n", bgrt_tab->image_offset_x);
 }
-static DEVICE_ATTR(xoffset, S_IRUGO, show_xoffset, NULL);
+static KOBJECT_ATTR(xoffset, S_IRUGO, show_xoffset, NULL);
 
-static ssize_t show_yoffset(struct device *dev,
-			    struct device_attribute *attr, char *buf)
+static ssize_t show_yoffset(struct kobject *kobj,
+			    struct kobj_attribute *attr, char *buf)
 {
 	return snprintf(buf, PAGE_SIZE, "%d\n", bgrt_tab->image_offset_y);
 }
-static DEVICE_ATTR(yoffset, S_IRUGO, show_yoffset, NULL);
+static KOBJECT_ATTR(yoffset, S_IRUGO, show_yoffset, NULL);
 
 static ssize_t image_read(struct file *file, struct kobject *kobj,
 	       struct bin_attribute *attr, char *buf, loff_t off, size_t count)
@@ -87,8 +87,10 @@ static int __init bgrt_init(void)
 	if (!bgrt_image)
 		return -ENODEV;
 
-	bin_attr_image.private = bgrt_image;
-	bin_attr_image.size = bgrt_image_size;
+	pax_open_kernel();
+	const_cast(bin_attr_image.private) = bgrt_image;
+	const_cast(bin_attr_image.size) = bgrt_image_size;
+	pax_close_kernel();
 
 	bgrt_kobj = kobject_create_and_add("bgrt", acpi_kobj);
 	if (!bgrt_kobj)
diff --git a/drivers/acpi/blacklist.c b/drivers/acpi/blacklist.c
index bdc67bad6..a82756b5e 100644
--- a/drivers/acpi/blacklist.c
+++ b/drivers/acpi/blacklist.c
@@ -47,13 +47,13 @@ struct acpi_blacklist_item {
 	u32 is_critical_error;
 };
 
-static struct dmi_system_id acpi_rev_dmi_table[] __initdata;
+static const struct dmi_system_id acpi_rev_dmi_table[] __initconst;
 
 /*
  * POLICY: If *anything* doesn't work, put it on the blacklist.
  *	   If they are critical errors, mark it critical, and abort driver load.
  */
-static struct acpi_blacklist_item acpi_blacklist[] __initdata = {
+static const struct acpi_blacklist_item acpi_blacklist[] __initconst = {
 	/* Compaq Presario 1700 */
 	{"PTLTD ", "  DSDT  ", 0x06040000, ACPI_SIG_DSDT, less_than_or_equal,
 	 "Multiple problems", 1},
@@ -144,7 +144,7 @@ static int __init dmi_enable_rev_override(const struct dmi_system_id *d)
 }
 #endif
 
-static struct dmi_system_id acpi_rev_dmi_table[] __initdata = {
+static const struct dmi_system_id acpi_rev_dmi_table[] __initconst = {
 #ifdef CONFIG_ACPI_REV_OVERRIDE_POSSIBLE
 	/*
 	 * DELL XPS 13 (2015) switches sound between HDA and I2S
diff --git a/drivers/acpi/bus.c b/drivers/acpi/bus.c
index 85b7d07fe..cfc2a30c3 100644
--- a/drivers/acpi/bus.c
+++ b/drivers/acpi/bus.c
@@ -66,7 +66,7 @@ static int set_copy_dsdt(const struct dmi_system_id *id)
 }
 #endif
 
-static struct dmi_system_id dsdt_dmi_table[] __initdata = {
+static const struct dmi_system_id dsdt_dmi_table[] __initconst = {
 	/*
 	 * Invoke DSDT corruption work-around on all Toshiba Satellite.
 	 * https://bugzilla.kernel.org/show_bug.cgi?id=14679
@@ -82,7 +82,7 @@ static struct dmi_system_id dsdt_dmi_table[] __initdata = {
 	{}
 };
 #else
-static struct dmi_system_id dsdt_dmi_table[] __initdata = {
+static const struct dmi_system_id dsdt_dmi_table[] __initconst = {
 	{}
 };
 #endif
diff --git a/drivers/acpi/button.c b/drivers/acpi/button.c
index 31abb0bdd..462db5833 100644
--- a/drivers/acpi/button.c
+++ b/drivers/acpi/button.c
@@ -477,7 +477,7 @@ static int acpi_button_remove(struct acpi_device *device)
 	return 0;
 }
 
-static int param_set_lid_init_state(const char *val, struct kernel_param *kp)
+static int param_set_lid_init_state(const char *val, const struct kernel_param *kp)
 {
 	int result = 0;
 
@@ -495,7 +495,7 @@ static int param_set_lid_init_state(const char *val, struct kernel_param *kp)
 	return result;
 }
 
-static int param_get_lid_init_state(char *buffer, struct kernel_param *kp)
+static int param_get_lid_init_state(char *buffer, const struct kernel_param *kp)
 {
 	switch (lid_init_state) {
 	case ACPI_BUTTON_LID_INIT_OPEN:
diff --git a/drivers/acpi/custom_method.c b/drivers/acpi/custom_method.c
index c68e72414..e86300825 100644
--- a/drivers/acpi/custom_method.c
+++ b/drivers/acpi/custom_method.c
@@ -29,6 +29,10 @@ static ssize_t cm_write(struct file *file, const char __user * user_buf,
 	struct acpi_table_header table;
 	acpi_status status;
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+	return -EPERM;
+#endif
+
 	if (!(*ppos)) {
 		/* parse the table header to get the table length */
 		if (count <= sizeof(struct acpi_table_header))
diff --git a/drivers/acpi/device_pm.c b/drivers/acpi/device_pm.c
index 993fd3139..cc15d1487 100644
--- a/drivers/acpi/device_pm.c
+++ b/drivers/acpi/device_pm.c
@@ -1026,6 +1026,8 @@ EXPORT_SYMBOL_GPL(acpi_subsys_freeze);
 
 #endif /* CONFIG_PM_SLEEP */
 
+static void acpi_dev_pm_detach(struct device *dev, bool power_off);
+
 static struct dev_pm_domain acpi_general_pm_domain = {
 	.ops = {
 		.runtime_suspend = acpi_subsys_runtime_suspend,
@@ -1042,6 +1044,7 @@ static struct dev_pm_domain acpi_general_pm_domain = {
 		.restore_early = acpi_subsys_resume_early,
 #endif
 	},
+	.detach = acpi_dev_pm_detach
 };
 
 /**
@@ -1119,7 +1122,6 @@ int acpi_dev_pm_attach(struct device *dev, bool power_on)
 		acpi_device_wakeup(adev, ACPI_STATE_S0, false);
 	}
 
-	dev->pm_domain->detach = acpi_dev_pm_detach;
 	return 0;
 }
 EXPORT_SYMBOL_GPL(acpi_dev_pm_attach);
diff --git a/drivers/acpi/ec.c b/drivers/acpi/ec.c
index e7bd57cc5..e26a064cf 100644
--- a/drivers/acpi/ec.c
+++ b/drivers/acpi/ec.c
@@ -1559,7 +1559,7 @@ static int ec_correct_ecdt(const struct dmi_system_id *id)
 	return 0;
 }
 
-static struct dmi_system_id ec_dmi_table[] __initdata = {
+static const struct dmi_system_id ec_dmi_table[] __initconst = {
 	{
 	ec_correct_ecdt, "MSI MS-171F", {
 	DMI_MATCH(DMI_SYS_VENDOR, "Micro-Star"),
@@ -1619,7 +1619,7 @@ error:
 	return ret;
 }
 
-static int param_set_event_clearing(const char *val, struct kernel_param *kp)
+static int param_set_event_clearing(const char *val, const struct kernel_param *kp)
 {
 	int result = 0;
 
@@ -1637,7 +1637,7 @@ static int param_set_event_clearing(const char *val, struct kernel_param *kp)
 	return result;
 }
 
-static int param_get_event_clearing(char *buffer, struct kernel_param *kp)
+static int param_get_event_clearing(char *buffer, const struct kernel_param *kp)
 {
 	switch (ec_event_clearing) {
 	case ACPI_EC_EVT_TIMING_STATUS:
diff --git a/drivers/acpi/osi.c b/drivers/acpi/osi.c
index 849f9d224..c97dd8167 100644
--- a/drivers/acpi/osi.c
+++ b/drivers/acpi/osi.c
@@ -318,7 +318,7 @@ static int __init dmi_disable_osi_win8(const struct dmi_system_id *d)
  * Note that _OSI("Linux")/_OSI("Darwin") determined here can be overridden
  * by acpi_osi=!Linux/acpi_osi=!Darwin command line options.
  */
-static struct dmi_system_id acpi_osi_dmi_table[] __initdata = {
+static const struct dmi_system_id acpi_osi_dmi_table[] __initconst = {
 	{
 	.callback = dmi_disable_osi_vista,
 	.ident = "Fujitsu Siemens",
diff --git a/drivers/acpi/pci_slot.c b/drivers/acpi/pci_slot.c
index f62c68e24..e90b61f7d 100644
--- a/drivers/acpi/pci_slot.c
+++ b/drivers/acpi/pci_slot.c
@@ -174,7 +174,7 @@ static int do_sta_before_sun(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id acpi_pci_slot_dmi_table[] __initdata = {
+static const struct dmi_system_id acpi_pci_slot_dmi_table[] __initconst = {
 	/*
 	 * Fujitsu Primequest machines will return 1023 to indicate an
 	 * error if the _SUN method is evaluated on SxFy objects that
diff --git a/drivers/acpi/processor_idle.c b/drivers/acpi/processor_idle.c
index cea52528a..c688abf27 100644
--- a/drivers/acpi/processor_idle.c
+++ b/drivers/acpi/processor_idle.c
@@ -841,7 +841,7 @@ static int acpi_processor_setup_cstates(struct acpi_processor *pr)
 {
 	int i, count = CPUIDLE_DRIVER_STATE_START;
 	struct acpi_processor_cx *cx;
-	struct cpuidle_state *state;
+	cpuidle_state_no_const *state;
 	struct cpuidle_driver *drv = &acpi_idle_driver;
 
 	if (max_cstate == 0)
@@ -1250,7 +1250,7 @@ static int acpi_processor_setup_lpi_states(struct acpi_processor *pr)
 {
 	int i;
 	struct acpi_lpi_state *lpi;
-	struct cpuidle_state *state;
+	cpuidle_state_no_const *state;
 	struct cpuidle_driver *drv = &acpi_idle_driver;
 
 	if (!pr->flags.has_lpi)
diff --git a/drivers/acpi/processor_pdc.c b/drivers/acpi/processor_pdc.c
index 7cfbda4d7..74f738cb6 100644
--- a/drivers/acpi/processor_pdc.c
+++ b/drivers/acpi/processor_pdc.c
@@ -173,7 +173,7 @@ static int __init set_no_mwait(const struct dmi_system_id *id)
 	return 0;
 }
 
-static struct dmi_system_id processor_idle_dmi_table[] __initdata = {
+static const struct dmi_system_id processor_idle_dmi_table[] __initconst = {
 	{
 	set_no_mwait, "Extensa 5220", {
 	DMI_MATCH(DMI_BIOS_VENDOR, "Phoenix Technologies LTD"),
diff --git a/drivers/acpi/sleep.c b/drivers/acpi/sleep.c
index 7a2e4d45b..0de00c5f1 100644
--- a/drivers/acpi/sleep.c
+++ b/drivers/acpi/sleep.c
@@ -154,7 +154,7 @@ static int __init init_nvs_nosave(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id acpisleep_dmi_table[] __initdata = {
+static const struct dmi_system_id acpisleep_dmi_table[] __initconst = {
 	{
 	.callback = init_old_suspend_ordering,
 	.ident = "Abit KN9 (nForce4 variant)",
diff --git a/drivers/acpi/sysfs.c b/drivers/acpi/sysfs.c
index 358165e9f..5e376401a 100644
--- a/drivers/acpi/sysfs.c
+++ b/drivers/acpi/sysfs.c
@@ -227,7 +227,7 @@ module_param_cb(trace_method_name, &param_ops_trace_method, &trace_method_name,
 module_param_cb(trace_debug_layer, &param_ops_trace_attrib, &acpi_gbl_trace_dbg_layer, 0644);
 module_param_cb(trace_debug_level, &param_ops_trace_attrib, &acpi_gbl_trace_dbg_level, 0644);
 
-static int param_set_trace_state(const char *val, struct kernel_param *kp)
+static int param_set_trace_state(const char *val, const struct kernel_param *kp)
 {
 	acpi_status status;
 	const char *method = trace_method_name;
@@ -263,7 +263,7 @@ static int param_set_trace_state(const char *val, struct kernel_param *kp)
 	return 0;
 }
 
-static int param_get_trace_state(char *buffer, struct kernel_param *kp)
+static int param_get_trace_state(char *buffer, const struct kernel_param *kp)
 {
 	if (!(acpi_gbl_trace_flags & ACPI_TRACE_ENABLED))
 		return sprintf(buffer, "disable");
@@ -292,7 +292,7 @@ MODULE_PARM_DESC(aml_debug_output,
 		 "To enable/disable the ACPI Debug Object output.");
 
 /* /sys/module/acpi/parameters/acpica_version */
-static int param_get_acpica_version(char *buffer, struct kernel_param *kp)
+static int param_get_acpica_version(char *buffer, const struct kernel_param *kp)
 {
 	int result;
 
@@ -484,11 +484,11 @@ static u32 num_counters;
 static struct attribute **all_attrs;
 static u32 acpi_gpe_count;
 
-static struct attribute_group interrupt_stats_attr_group = {
+static attribute_group_no_const interrupt_stats_attr_group = {
 	.name = "interrupts",
 };
 
-static struct kobj_attribute *counter_attrs;
+static kobj_attribute_no_const *counter_attrs;
 
 static void delete_gpe_attr_array(void)
 {
@@ -774,13 +774,13 @@ static void __exit interrupt_stats_exit(void)
 }
 
 static ssize_t
-acpi_show_profile(struct device *dev, struct device_attribute *attr,
+acpi_show_profile(struct kobject *kobj, struct kobj_attribute *attr,
 		  char *buf)
 {
 	return sprintf(buf, "%d\n", acpi_gbl_FADT.preferred_profile);
 }
 
-static const struct device_attribute pm_profile_attr =
+static const struct kobj_attribute pm_profile_attr =
 	__ATTR(pm_profile, S_IRUGO, acpi_show_profile, NULL);
 
 static ssize_t hotplug_enabled_show(struct kobject *kobj,
diff --git a/drivers/acpi/thermal.c b/drivers/acpi/thermal.c
index f4ebe3953..f937534d0 100644
--- a/drivers/acpi/thermal.c
+++ b/drivers/acpi/thermal.c
@@ -1208,7 +1208,7 @@ static int thermal_psv(const struct dmi_system_id *d) {
 	return 0;
 }
 
-static struct dmi_system_id thermal_dmi_table[] __initdata = {
+static const struct dmi_system_id thermal_dmi_table[] __initconst = {
 	/*
 	 * Award BIOS on this AOpen makes thermal control almost worthless.
 	 * http://bugzilla.kernel.org/show_bug.cgi?id=8842
diff --git a/drivers/acpi/video_detect.c b/drivers/acpi/video_detect.c
index 02ded25c8..ff23e2d89 100644
--- a/drivers/acpi/video_detect.c
+++ b/drivers/acpi/video_detect.c
@@ -41,7 +41,6 @@ ACPI_MODULE_NAME("video");
 void acpi_video_unregister_backlight(void);
 
 static bool backlight_notifier_registered;
-static struct notifier_block backlight_nb;
 static struct work_struct backlight_notify_work;
 
 static enum acpi_backlight_type acpi_backlight_cmdline = acpi_backlight_undef;
@@ -339,6 +338,10 @@ static int acpi_video_backlight_notify(struct notifier_block *nb,
 	return NOTIFY_OK;
 }
 
+static struct notifier_block backlight_nb = {
+	.notifier_call = acpi_video_backlight_notify,
+};
+
 /*
  * Determine which type of backlight interface to use on this system,
  * First check cmdline, then dmi quirks, then do autodetect.
@@ -369,8 +372,6 @@ enum acpi_backlight_type acpi_video_get_backlight_type(void)
 				    &video_caps, NULL);
 		INIT_WORK(&backlight_notify_work,
 			  acpi_video_backlight_notify_work);
-		backlight_nb.notifier_call = acpi_video_backlight_notify;
-		backlight_nb.priority = 0;
 		if (backlight_register_notifier(&backlight_nb) == 0)
 			backlight_notifier_registered = true;
 		init_done = true;
diff --git a/drivers/android/binder.c b/drivers/android/binder.c
index 4b1e4eabe..db24123bd 100644
--- a/drivers/android/binder.c
+++ b/drivers/android/binder.c
@@ -120,7 +120,7 @@ static DECLARE_WAIT_QUEUE_HEAD(binder_user_error_wait);
 static int binder_stop_on_user_error;
 
 static int binder_set_stop_on_user_error(const char *val,
-					 struct kernel_param *kp)
+					 const struct kernel_param *kp)
 {
 	int ret;
 
diff --git a/drivers/ata/libata-core.c b/drivers/ata/libata-core.c
index 223a770f7..295a50746 100644
--- a/drivers/ata/libata-core.c
+++ b/drivers/ata/libata-core.c
@@ -105,7 +105,7 @@ static unsigned int ata_dev_set_xfermode(struct ata_device *dev);
 static void ata_dev_xfermask(struct ata_device *dev);
 static unsigned long ata_dev_blacklisted(const struct ata_device *dev);
 
-atomic_t ata_print_id = ATOMIC_INIT(0);
+atomic_unchecked_t ata_print_id = ATOMIC_INIT(0);
 
 struct ata_force_param {
 	const char	*name;
@@ -4988,7 +4988,7 @@ void ata_qc_free(struct ata_queued_cmd *qc)
 	struct ata_port *ap;
 	unsigned int tag;
 
-	WARN_ON_ONCE(qc == NULL); /* ata_qc_from_tag _might_ return NULL */
+	BUG_ON(qc == NULL); /* ata_qc_from_tag _might_ return NULL */
 	ap = qc->ap;
 
 	qc->flags = 0;
@@ -5005,7 +5005,7 @@ void __ata_qc_complete(struct ata_queued_cmd *qc)
 	struct ata_port *ap;
 	struct ata_link *link;
 
-	WARN_ON_ONCE(qc == NULL); /* ata_qc_from_tag _might_ return NULL */
+	BUG_ON(qc == NULL); /* ata_qc_from_tag _might_ return NULL */
 	WARN_ON_ONCE(!(qc->flags & ATA_QCFLAG_ACTIVE));
 	ap = qc->ap;
 	link = qc->dev->link;
@@ -6117,6 +6117,7 @@ static void ata_finalize_port_ops(struct ata_port_operations *ops)
 		return;
 
 	spin_lock(&lock);
+	pax_open_kernel();
 
 	for (cur = ops->inherits; cur; cur = cur->inherits) {
 		void **inherit = (void **)cur;
@@ -6130,8 +6131,9 @@ static void ata_finalize_port_ops(struct ata_port_operations *ops)
 		if (IS_ERR(*pp))
 			*pp = NULL;
 
-	ops->inherits = NULL;
+	const_cast(ops->inherits) = NULL;
 
+	pax_close_kernel();
 	spin_unlock(&lock);
 }
 
@@ -6327,7 +6329,7 @@ int ata_host_register(struct ata_host *host, struct scsi_host_template *sht)
 
 	/* give ports names and add SCSI hosts */
 	for (i = 0; i < host->n_ports; i++) {
-		host->ports[i]->print_id = atomic_inc_return(&ata_print_id);
+		host->ports[i]->print_id = atomic_inc_return_unchecked(&ata_print_id);
 		host->ports[i]->local_port_no = i + 1;
 	}
 
diff --git a/drivers/ata/libata-scsi.c b/drivers/ata/libata-scsi.c
index 1e007a93b..67c25dbca 100644
--- a/drivers/ata/libata-scsi.c
+++ b/drivers/ata/libata-scsi.c
@@ -4689,7 +4689,7 @@ int ata_sas_port_init(struct ata_port *ap)
 
 	if (rc)
 		return rc;
-	ap->print_id = atomic_inc_return(&ata_print_id);
+	ap->print_id = atomic_inc_return_unchecked(&ata_print_id);
 	return 0;
 }
 EXPORT_SYMBOL_GPL(ata_sas_port_init);
diff --git a/drivers/ata/libata.h b/drivers/ata/libata.h
index 3b301a480..ff1567665 100644
--- a/drivers/ata/libata.h
+++ b/drivers/ata/libata.h
@@ -53,7 +53,7 @@ enum {
 	ATA_DNXFER_QUIET	= (1 << 31),
 };
 
-extern atomic_t ata_print_id;
+extern atomic_unchecked_t ata_print_id;
 extern int atapi_passthru16;
 extern int libata_fua;
 extern int libata_noacpi;
diff --git a/drivers/ata/pata_arasan_cf.c b/drivers/ata/pata_arasan_cf.c
index b4d54771c..9ec8e0bb7 100644
--- a/drivers/ata/pata_arasan_cf.c
+++ b/drivers/ata/pata_arasan_cf.c
@@ -864,7 +864,9 @@ static int arasan_cf_probe(struct platform_device *pdev)
 	/* Handle platform specific quirks */
 	if (quirk) {
 		if (quirk & CF_BROKEN_PIO) {
-			ap->ops->set_piomode = NULL;
+			pax_open_kernel();
+			const_cast(ap->ops->set_piomode) = NULL;
+			pax_close_kernel();
 			ap->pio_mask = 0;
 		}
 		if (quirk & CF_BROKEN_MWDMA)
diff --git a/drivers/atm/adummy.c b/drivers/atm/adummy.c
index f9b983ae6..887b9d89f 100644
--- a/drivers/atm/adummy.c
+++ b/drivers/atm/adummy.c
@@ -114,7 +114,7 @@ adummy_send(struct atm_vcc *vcc, struct sk_buff *skb)
 		vcc->pop(vcc, skb);
 	else
 		dev_kfree_skb_any(skb);
-	atomic_inc(&vcc->stats->tx);
+	atomic_inc_unchecked(&vcc->stats->tx);
 
 	return 0;
 }
diff --git a/drivers/atm/ambassador.c b/drivers/atm/ambassador.c
index cd3f62eb1..ff94eed43 100644
--- a/drivers/atm/ambassador.c
+++ b/drivers/atm/ambassador.c
@@ -454,7 +454,7 @@ static void tx_complete (amb_dev * dev, tx_out * tx) {
   PRINTD (DBG_FLOW|DBG_TX, "tx_complete %p %p", dev, tx);
   
   // VC layer stats
-  atomic_inc(&ATM_SKB(skb)->vcc->stats->tx);
+  atomic_inc_unchecked(&ATM_SKB(skb)->vcc->stats->tx);
   
   // free the descriptor
   kfree (tx_descr);
@@ -495,7 +495,7 @@ static void rx_complete (amb_dev * dev, rx_out * rx) {
 	  dump_skb ("<<<", vc, skb);
 	  
 	  // VC layer stats
-	  atomic_inc(&atm_vcc->stats->rx);
+	  atomic_inc_unchecked(&atm_vcc->stats->rx);
 	  __net_timestamp(skb);
 	  // end of our responsibility
 	  atm_vcc->push (atm_vcc, skb);
@@ -510,7 +510,7 @@ static void rx_complete (amb_dev * dev, rx_out * rx) {
       } else {
       	PRINTK (KERN_INFO, "dropped over-size frame");
 	// should we count this?
-	atomic_inc(&atm_vcc->stats->rx_drop);
+	atomic_inc_unchecked(&atm_vcc->stats->rx_drop);
       }
       
     } else {
@@ -1338,7 +1338,7 @@ static int amb_send (struct atm_vcc * atm_vcc, struct sk_buff * skb) {
   }
   
   if (check_area (skb->data, skb->len)) {
-    atomic_inc(&atm_vcc->stats->tx_err);
+    atomic_inc_unchecked(&atm_vcc->stats->tx_err);
     return -ENOMEM; // ?
   }
   
diff --git a/drivers/atm/atmtcp.c b/drivers/atm/atmtcp.c
index 480fa6ffb..947067c9d 100644
--- a/drivers/atm/atmtcp.c
+++ b/drivers/atm/atmtcp.c
@@ -206,7 +206,7 @@ static int atmtcp_v_send(struct atm_vcc *vcc,struct sk_buff *skb)
 		if (vcc->pop) vcc->pop(vcc,skb);
 		else dev_kfree_skb(skb);
 		if (dev_data) return 0;
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		return -ENOLINK;
 	}
 	size = skb->len+sizeof(struct atmtcp_hdr);
@@ -214,7 +214,7 @@ static int atmtcp_v_send(struct atm_vcc *vcc,struct sk_buff *skb)
 	if (!new_skb) {
 		if (vcc->pop) vcc->pop(vcc,skb);
 		else dev_kfree_skb(skb);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		return -ENOBUFS;
 	}
 	hdr = (void *) skb_put(new_skb,sizeof(struct atmtcp_hdr));
@@ -225,8 +225,8 @@ static int atmtcp_v_send(struct atm_vcc *vcc,struct sk_buff *skb)
 	if (vcc->pop) vcc->pop(vcc,skb);
 	else dev_kfree_skb(skb);
 	out_vcc->push(out_vcc,new_skb);
-	atomic_inc(&vcc->stats->tx);
-	atomic_inc(&out_vcc->stats->rx);
+	atomic_inc_unchecked(&vcc->stats->tx);
+	atomic_inc_unchecked(&out_vcc->stats->rx);
 	return 0;
 }
 
@@ -300,7 +300,7 @@ static int atmtcp_c_send(struct atm_vcc *vcc,struct sk_buff *skb)
 	read_unlock(&vcc_sklist_lock);
 	if (!out_vcc) {
 		result = -EUNATCH;
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		goto done;
 	}
 	skb_pull(skb,sizeof(struct atmtcp_hdr));
@@ -312,8 +312,8 @@ static int atmtcp_c_send(struct atm_vcc *vcc,struct sk_buff *skb)
 	__net_timestamp(new_skb);
 	skb_copy_from_linear_data(skb, skb_put(new_skb, skb->len), skb->len);
 	out_vcc->push(out_vcc,new_skb);
-	atomic_inc(&vcc->stats->tx);
-	atomic_inc(&out_vcc->stats->rx);
+	atomic_inc_unchecked(&vcc->stats->tx);
+	atomic_inc_unchecked(&out_vcc->stats->rx);
 done:
 	if (vcc->pop) vcc->pop(vcc,skb);
 	else dev_kfree_skb(skb);
diff --git a/drivers/atm/eni.c b/drivers/atm/eni.c
index 6339efd32..2b441d5be 100644
--- a/drivers/atm/eni.c
+++ b/drivers/atm/eni.c
@@ -525,7 +525,7 @@ static int rx_aal0(struct atm_vcc *vcc)
 		DPRINTK(DEV_LABEL "(itf %d): trashing empty cell\n",
 		    vcc->dev->number);
 		length = 0;
-		atomic_inc(&vcc->stats->rx_err);
+		atomic_inc_unchecked(&vcc->stats->rx_err);
 	}
 	else {
 		length = ATM_CELL_SIZE-1; /* no HEC */
@@ -580,7 +580,7 @@ static int rx_aal5(struct atm_vcc *vcc)
 			    size);
 		}
 		eff = length = 0;
-		atomic_inc(&vcc->stats->rx_err);
+		atomic_inc_unchecked(&vcc->stats->rx_err);
 	}
 	else {
 		size = (descr & MID_RED_COUNT)*(ATM_CELL_PAYLOAD >> 2);
@@ -597,7 +597,7 @@ static int rx_aal5(struct atm_vcc *vcc)
 			    "(VCI=%d,length=%ld,size=%ld (descr 0x%lx))\n",
 			    vcc->dev->number,vcc->vci,length,size << 2,descr);
 			length = eff = 0;
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 		}
 	}
 	skb = eff ? atm_alloc_charge(vcc,eff << 2,GFP_ATOMIC) : NULL;
@@ -770,7 +770,7 @@ rx_dequeued++;
 			vcc->push(vcc,skb);
 			pushed++;
 		}
-		atomic_inc(&vcc->stats->rx);
+		atomic_inc_unchecked(&vcc->stats->rx);
 	}
 	wake_up(&eni_dev->rx_wait);
 }
@@ -1230,7 +1230,7 @@ static void dequeue_tx(struct atm_dev *dev)
 				 DMA_TO_DEVICE);
 		if (vcc->pop) vcc->pop(vcc,skb);
 		else dev_kfree_skb_irq(skb);
-		atomic_inc(&vcc->stats->tx);
+		atomic_inc_unchecked(&vcc->stats->tx);
 		wake_up(&eni_dev->tx_wait);
 dma_complete++;
 	}
diff --git a/drivers/atm/firestream.c b/drivers/atm/firestream.c
index 85aaf2222..8730d15f1 100644
--- a/drivers/atm/firestream.c
+++ b/drivers/atm/firestream.c
@@ -753,7 +753,7 @@ static void process_txdone_queue (struct fs_dev *dev, struct queue *q)
 				}
 			}
 
-			atomic_inc(&ATM_SKB(skb)->vcc->stats->tx);
+			atomic_inc_unchecked(&ATM_SKB(skb)->vcc->stats->tx);
 
 			fs_dprintk (FS_DEBUG_TXMEM, "i");
 			fs_dprintk (FS_DEBUG_ALLOC, "Free t-skb: %p\n", skb);
@@ -820,7 +820,7 @@ static void process_incoming (struct fs_dev *dev, struct queue *q)
 #endif
 				skb_put (skb, qe->p1 & 0xffff); 
 				ATM_SKB(skb)->vcc = atm_vcc;
-				atomic_inc(&atm_vcc->stats->rx);
+				atomic_inc_unchecked(&atm_vcc->stats->rx);
 				__net_timestamp(skb);
 				fs_dprintk (FS_DEBUG_ALLOC, "Free rec-skb: %p (pushed)\n", skb);
 				atm_vcc->push (atm_vcc, skb);
@@ -841,12 +841,12 @@ static void process_incoming (struct fs_dev *dev, struct queue *q)
 				kfree (pe);
 			}
 			if (atm_vcc)
-				atomic_inc(&atm_vcc->stats->rx_drop);
+				atomic_inc_unchecked(&atm_vcc->stats->rx_drop);
 			break;
 		case 0x1f: /*  Reassembly abort: no buffers. */
 			/* Silently increment error counter. */
 			if (atm_vcc)
-				atomic_inc(&atm_vcc->stats->rx_drop);
+				atomic_inc_unchecked(&atm_vcc->stats->rx_drop);
 			break;
 		default: /* Hmm. Haven't written the code to handle the others yet... -- REW */
 			printk (KERN_WARNING "Don't know what to do with RX status %x: %s.\n", 
diff --git a/drivers/atm/fore200e.c b/drivers/atm/fore200e.c
index decad35e4..fe74de38a 100644
--- a/drivers/atm/fore200e.c
+++ b/drivers/atm/fore200e.c
@@ -932,9 +932,9 @@ fore200e_tx_irq(struct fore200e* fore200e)
 #endif
 		/* check error condition */
 		if (*entry->status & STATUS_ERROR)
-		    atomic_inc(&vcc->stats->tx_err);
+		    atomic_inc_unchecked(&vcc->stats->tx_err);
 		else
-		    atomic_inc(&vcc->stats->tx);
+		    atomic_inc_unchecked(&vcc->stats->tx);
 	    }
 	}
 
@@ -1083,7 +1083,7 @@ fore200e_push_rpd(struct fore200e* fore200e, struct atm_vcc* vcc, struct rpd* rp
     if (skb == NULL) {
 	DPRINTK(2, "unable to alloc new skb, rx PDU length = %d\n", pdu_len);
 
-	atomic_inc(&vcc->stats->rx_drop);
+	atomic_inc_unchecked(&vcc->stats->rx_drop);
 	return -ENOMEM;
     } 
 
@@ -1126,14 +1126,14 @@ fore200e_push_rpd(struct fore200e* fore200e, struct atm_vcc* vcc, struct rpd* rp
 
 	dev_kfree_skb_any(skb);
 
-	atomic_inc(&vcc->stats->rx_drop);
+	atomic_inc_unchecked(&vcc->stats->rx_drop);
 	return -ENOMEM;
     }
 
     ASSERT(atomic_read(&sk_atm(vcc)->sk_wmem_alloc) >= 0);
 
     vcc->push(vcc, skb);
-    atomic_inc(&vcc->stats->rx);
+    atomic_inc_unchecked(&vcc->stats->rx);
 
     ASSERT(atomic_read(&sk_atm(vcc)->sk_wmem_alloc) >= 0);
 
@@ -1211,7 +1211,7 @@ fore200e_rx_irq(struct fore200e* fore200e)
 		DPRINTK(2, "damaged PDU on %d.%d.%d\n",
 			fore200e->atm_dev->number,
 			entry->rpd->atm_header.vpi, entry->rpd->atm_header.vci);
-		atomic_inc(&vcc->stats->rx_err);
+		atomic_inc_unchecked(&vcc->stats->rx_err);
 	    }
 	}
 
@@ -1656,7 +1656,7 @@ fore200e_send(struct atm_vcc *vcc, struct sk_buff *skb)
 		goto retry_here;
 	    }
 
-	    atomic_inc(&vcc->stats->tx_err);
+	    atomic_inc_unchecked(&vcc->stats->tx_err);
 
 	    fore200e->tx_sat++;
 	    DPRINTK(2, "tx queue of device %s is saturated, PDU dropped - heartbeat is %08x\n",
diff --git a/drivers/atm/he.c b/drivers/atm/he.c
index 0f5cb3763..c8bcdefdb 100644
--- a/drivers/atm/he.c
+++ b/drivers/atm/he.c
@@ -1689,7 +1689,7 @@ he_service_rbrq(struct he_dev *he_dev, int group)
 
 		if (RBRQ_HBUF_ERR(he_dev->rbrq_head)) {
 			hprintk("HBUF_ERR!  (cid 0x%x)\n", cid);
-				atomic_inc(&vcc->stats->rx_drop);
+				atomic_inc_unchecked(&vcc->stats->rx_drop);
 			goto return_host_buffers;
 		}
 
@@ -1716,7 +1716,7 @@ he_service_rbrq(struct he_dev *he_dev, int group)
 				RBRQ_LEN_ERR(he_dev->rbrq_head)
 							? "LEN_ERR" : "",
 							vcc->vpi, vcc->vci);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto return_host_buffers;
 		}
 
@@ -1768,7 +1768,7 @@ he_service_rbrq(struct he_dev *he_dev, int group)
 		vcc->push(vcc, skb);
 		spin_lock(&he_dev->global_lock);
 
-		atomic_inc(&vcc->stats->rx);
+		atomic_inc_unchecked(&vcc->stats->rx);
 
 return_host_buffers:
 		++pdus_assembled;
@@ -2094,7 +2094,7 @@ __enqueue_tpd(struct he_dev *he_dev, struct he_tpd *tpd, unsigned cid)
 					tpd->vcc->pop(tpd->vcc, tpd->skb);
 				else
 					dev_kfree_skb_any(tpd->skb);
-				atomic_inc(&tpd->vcc->stats->tx_err);
+				atomic_inc_unchecked(&tpd->vcc->stats->tx_err);
 			}
 			dma_pool_free(he_dev->tpd_pool, tpd, TPD_ADDR(tpd->status));
 			return;
@@ -2506,7 +2506,7 @@ he_send(struct atm_vcc *vcc, struct sk_buff *skb)
 			vcc->pop(vcc, skb);
 		else
 			dev_kfree_skb_any(skb);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		return -EINVAL;
 	}
 
@@ -2517,7 +2517,7 @@ he_send(struct atm_vcc *vcc, struct sk_buff *skb)
 			vcc->pop(vcc, skb);
 		else
 			dev_kfree_skb_any(skb);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		return -EINVAL;
 	}
 #endif
@@ -2529,7 +2529,7 @@ he_send(struct atm_vcc *vcc, struct sk_buff *skb)
 			vcc->pop(vcc, skb);
 		else
 			dev_kfree_skb_any(skb);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		spin_unlock_irqrestore(&he_dev->global_lock, flags);
 		return -ENOMEM;
 	}
@@ -2571,7 +2571,7 @@ he_send(struct atm_vcc *vcc, struct sk_buff *skb)
 					vcc->pop(vcc, skb);
 				else
 					dev_kfree_skb_any(skb);
-				atomic_inc(&vcc->stats->tx_err);
+				atomic_inc_unchecked(&vcc->stats->tx_err);
 				spin_unlock_irqrestore(&he_dev->global_lock, flags);
 				return -ENOMEM;
 			}
@@ -2602,7 +2602,7 @@ he_send(struct atm_vcc *vcc, struct sk_buff *skb)
 	__enqueue_tpd(he_dev, tpd, cid);
 	spin_unlock_irqrestore(&he_dev->global_lock, flags);
 
-	atomic_inc(&vcc->stats->tx);
+	atomic_inc_unchecked(&vcc->stats->tx);
 
 	return 0;
 }
diff --git a/drivers/atm/horizon.c b/drivers/atm/horizon.c
index 5fc81e240..42907aed2 100644
--- a/drivers/atm/horizon.c
+++ b/drivers/atm/horizon.c
@@ -1018,7 +1018,7 @@ static void rx_schedule (hrz_dev * dev, int irq) {
 	{
 	  struct atm_vcc * vcc = ATM_SKB(skb)->vcc;
 	  // VC layer stats
-	  atomic_inc(&vcc->stats->rx);
+	  atomic_inc_unchecked(&vcc->stats->rx);
 	  __net_timestamp(skb);
 	  // end of our responsibility
 	  vcc->push (vcc, skb);
@@ -1170,7 +1170,7 @@ static void tx_schedule (hrz_dev * const dev, int irq) {
 	dev->tx_iovec = NULL;
 	
 	// VC layer stats
-	atomic_inc(&ATM_SKB(skb)->vcc->stats->tx);
+	atomic_inc_unchecked(&ATM_SKB(skb)->vcc->stats->tx);
 	
 	// free the skb
 	hrz_kfree_skb (skb);
diff --git a/drivers/atm/idt77252.c b/drivers/atm/idt77252.c
index 074616b39..d6b3d5f74 100644
--- a/drivers/atm/idt77252.c
+++ b/drivers/atm/idt77252.c
@@ -811,7 +811,7 @@ drain_scq(struct idt77252_dev *card, struct vc_map *vc)
 		else
 			dev_kfree_skb(skb);
 
-		atomic_inc(&vcc->stats->tx);
+		atomic_inc_unchecked(&vcc->stats->tx);
 	}
 
 	atomic_dec(&scq->used);
@@ -1073,13 +1073,13 @@ dequeue_rx(struct idt77252_dev *card, struct rsq_entry *rsqe)
 			if ((sb = dev_alloc_skb(64)) == NULL) {
 				printk("%s: Can't allocate buffers for aal0.\n",
 				       card->name);
-				atomic_add(i, &vcc->stats->rx_drop);
+				atomic_add_unchecked(i, &vcc->stats->rx_drop);
 				break;
 			}
 			if (!atm_charge(vcc, sb->truesize)) {
 				RXPRINTK("%s: atm_charge() dropped aal0 packets.\n",
 					 card->name);
-				atomic_add(i - 1, &vcc->stats->rx_drop);
+				atomic_add_unchecked(i - 1, &vcc->stats->rx_drop);
 				dev_kfree_skb(sb);
 				break;
 			}
@@ -1096,7 +1096,7 @@ dequeue_rx(struct idt77252_dev *card, struct rsq_entry *rsqe)
 			ATM_SKB(sb)->vcc = vcc;
 			__net_timestamp(sb);
 			vcc->push(vcc, sb);
-			atomic_inc(&vcc->stats->rx);
+			atomic_inc_unchecked(&vcc->stats->rx);
 
 			cell += ATM_CELL_PAYLOAD;
 		}
@@ -1133,13 +1133,13 @@ dequeue_rx(struct idt77252_dev *card, struct rsq_entry *rsqe)
 			         "(CDC: %08x)\n",
 			         card->name, len, rpp->len, readl(SAR_REG_CDC));
 			recycle_rx_pool_skb(card, rpp);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			return;
 		}
 		if (stat & SAR_RSQE_CRC) {
 			RXPRINTK("%s: AAL5 CRC error.\n", card->name);
 			recycle_rx_pool_skb(card, rpp);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			return;
 		}
 		if (skb_queue_len(&rpp->queue) > 1) {
@@ -1150,7 +1150,7 @@ dequeue_rx(struct idt77252_dev *card, struct rsq_entry *rsqe)
 				RXPRINTK("%s: Can't alloc RX skb.\n",
 					 card->name);
 				recycle_rx_pool_skb(card, rpp);
-				atomic_inc(&vcc->stats->rx_err);
+				atomic_inc_unchecked(&vcc->stats->rx_err);
 				return;
 			}
 			if (!atm_charge(vcc, skb->truesize)) {
@@ -1169,7 +1169,7 @@ dequeue_rx(struct idt77252_dev *card, struct rsq_entry *rsqe)
 			__net_timestamp(skb);
 
 			vcc->push(vcc, skb);
-			atomic_inc(&vcc->stats->rx);
+			atomic_inc_unchecked(&vcc->stats->rx);
 
 			return;
 		}
@@ -1191,7 +1191,7 @@ dequeue_rx(struct idt77252_dev *card, struct rsq_entry *rsqe)
 		__net_timestamp(skb);
 
 		vcc->push(vcc, skb);
-		atomic_inc(&vcc->stats->rx);
+		atomic_inc_unchecked(&vcc->stats->rx);
 
 		if (skb->truesize > SAR_FB_SIZE_3)
 			add_rx_skb(card, 3, SAR_FB_SIZE_3, 1);
@@ -1302,14 +1302,14 @@ idt77252_rx_raw(struct idt77252_dev *card)
 		if (vcc->qos.aal != ATM_AAL0) {
 			RPRINTK("%s: raw cell for non AAL0 vc %u.%u\n",
 				card->name, vpi, vci);
-			atomic_inc(&vcc->stats->rx_drop);
+			atomic_inc_unchecked(&vcc->stats->rx_drop);
 			goto drop;
 		}
 	
 		if ((sb = dev_alloc_skb(64)) == NULL) {
 			printk("%s: Can't allocate buffers for AAL0.\n",
 			       card->name);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto drop;
 		}
 
@@ -1328,7 +1328,7 @@ idt77252_rx_raw(struct idt77252_dev *card)
 		ATM_SKB(sb)->vcc = vcc;
 		__net_timestamp(sb);
 		vcc->push(vcc, sb);
-		atomic_inc(&vcc->stats->rx);
+		atomic_inc_unchecked(&vcc->stats->rx);
 
 drop:
 		skb_pull(queue, 64);
@@ -1953,13 +1953,13 @@ idt77252_send_skb(struct atm_vcc *vcc, struct sk_buff *skb, int oam)
 
 	if (vc == NULL) {
 		printk("%s: NULL connection in send().\n", card->name);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb(skb);
 		return -EINVAL;
 	}
 	if (!test_bit(VCF_TX, &vc->flags)) {
 		printk("%s: Trying to transmit on a non-tx VC.\n", card->name);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb(skb);
 		return -EINVAL;
 	}
@@ -1971,14 +1971,14 @@ idt77252_send_skb(struct atm_vcc *vcc, struct sk_buff *skb, int oam)
 		break;
 	default:
 		printk("%s: Unsupported AAL: %d\n", card->name, vcc->qos.aal);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb(skb);
 		return -EINVAL;
 	}
 
 	if (skb_shinfo(skb)->nr_frags != 0) {
 		printk("%s: No scatter-gather yet.\n", card->name);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb(skb);
 		return -EINVAL;
 	}
@@ -1986,7 +1986,7 @@ idt77252_send_skb(struct atm_vcc *vcc, struct sk_buff *skb, int oam)
 
 	err = queue_skb(card, vc, skb, oam);
 	if (err) {
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb(skb);
 		return err;
 	}
@@ -2009,7 +2009,7 @@ idt77252_send_oam(struct atm_vcc *vcc, void *cell, int flags)
 	skb = dev_alloc_skb(64);
 	if (!skb) {
 		printk("%s: Out of memory in send_oam().\n", card->name);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		return -ENOMEM;
 	}
 	atomic_add(skb->truesize, &sk_atm(vcc)->sk_wmem_alloc);
diff --git a/drivers/atm/iphase.c b/drivers/atm/iphase.c
index 809dd1e02..ee1075519 100644
--- a/drivers/atm/iphase.c
+++ b/drivers/atm/iphase.c
@@ -1146,7 +1146,7 @@ static int rx_pkt(struct atm_dev *dev)
 	status = (u_short) (buf_desc_ptr->desc_mode);  
 	if (status & (RX_CER | RX_PTE | RX_OFL))  
 	{  
-                atomic_inc(&vcc->stats->rx_err);
+                atomic_inc_unchecked(&vcc->stats->rx_err);
 		IF_ERR(printk("IA: bad packet, dropping it");)  
                 if (status & RX_CER) { 
                     IF_ERR(printk(" cause: packet CRC error\n");)
@@ -1169,7 +1169,7 @@ static int rx_pkt(struct atm_dev *dev)
 	len = dma_addr - buf_addr;  
         if (len > iadev->rx_buf_sz) {
            printk("Over %d bytes sdu received, dropped!!!\n", iadev->rx_buf_sz);
-           atomic_inc(&vcc->stats->rx_err);
+           atomic_inc_unchecked(&vcc->stats->rx_err);
 	   goto out_free_desc;
         }
 		  
@@ -1319,7 +1319,7 @@ static void rx_dle_intr(struct atm_dev *dev)
           ia_vcc = INPH_IA_VCC(vcc);
           if (ia_vcc == NULL)
           {
-             atomic_inc(&vcc->stats->rx_err);
+             atomic_inc_unchecked(&vcc->stats->rx_err);
              atm_return(vcc, skb->truesize);
              dev_kfree_skb_any(skb);
              goto INCR_DLE;
@@ -1331,7 +1331,7 @@ static void rx_dle_intr(struct atm_dev *dev)
           if ((length > iadev->rx_buf_sz) || (length > 
                               (skb->len - sizeof(struct cpcs_trailer))))
           {
-             atomic_inc(&vcc->stats->rx_err);
+             atomic_inc_unchecked(&vcc->stats->rx_err);
              IF_ERR(printk("rx_dle_intr: Bad  AAL5 trailer %d (skb len %d)", 
                                                             length, skb->len);)
              atm_return(vcc, skb->truesize);
@@ -1347,7 +1347,7 @@ static void rx_dle_intr(struct atm_dev *dev)
 
 	  IF_RX(printk("rx_dle_intr: skb push");)  
 	  vcc->push(vcc,skb);  
-	  atomic_inc(&vcc->stats->rx);
+	  atomic_inc_unchecked(&vcc->stats->rx);
           iadev->rx_pkt_cnt++;
       }  
 INCR_DLE:
@@ -2829,15 +2829,15 @@ static int ia_ioctl(struct atm_dev *dev, unsigned int cmd, void __user *arg)
          {
              struct k_sonet_stats *stats;
              stats = &PRIV(_ia_dev[board])->sonet_stats;
-             printk("section_bip: %d\n", atomic_read(&stats->section_bip));
-             printk("line_bip   : %d\n", atomic_read(&stats->line_bip));
-             printk("path_bip   : %d\n", atomic_read(&stats->path_bip));
-             printk("line_febe  : %d\n", atomic_read(&stats->line_febe));
-             printk("path_febe  : %d\n", atomic_read(&stats->path_febe));
-             printk("corr_hcs   : %d\n", atomic_read(&stats->corr_hcs));
-             printk("uncorr_hcs : %d\n", atomic_read(&stats->uncorr_hcs));
-             printk("tx_cells   : %d\n", atomic_read(&stats->tx_cells));
-             printk("rx_cells   : %d\n", atomic_read(&stats->rx_cells));
+             printk("section_bip: %d\n", atomic_read_unchecked(&stats->section_bip));
+             printk("line_bip   : %d\n", atomic_read_unchecked(&stats->line_bip));
+             printk("path_bip   : %d\n", atomic_read_unchecked(&stats->path_bip));
+             printk("line_febe  : %d\n", atomic_read_unchecked(&stats->line_febe));
+             printk("path_febe  : %d\n", atomic_read_unchecked(&stats->path_febe));
+             printk("corr_hcs   : %d\n", atomic_read_unchecked(&stats->corr_hcs));
+             printk("uncorr_hcs : %d\n", atomic_read_unchecked(&stats->uncorr_hcs));
+             printk("tx_cells   : %d\n", atomic_read_unchecked(&stats->tx_cells));
+             printk("rx_cells   : %d\n", atomic_read_unchecked(&stats->rx_cells));
          }
             ia_cmds.status = 0;
             break;
@@ -2942,7 +2942,7 @@ static int ia_pkt_tx (struct atm_vcc *vcc, struct sk_buff *skb) {
 	if ((desc == 0) || (desc > iadev->num_tx_desc))  
 	{  
 		IF_ERR(printk(DEV_LABEL "invalid desc for send: %d\n", desc);) 
-                atomic_inc(&vcc->stats->tx);
+                atomic_inc_unchecked(&vcc->stats->tx);
 		if (vcc->pop)   
 		    vcc->pop(vcc, skb);   
 		else  
@@ -3047,14 +3047,14 @@ static int ia_pkt_tx (struct atm_vcc *vcc, struct sk_buff *skb) {
         ATM_DESC(skb) = vcc->vci;
         skb_queue_tail(&iadev->tx_dma_q, skb);
 
-        atomic_inc(&vcc->stats->tx);
+        atomic_inc_unchecked(&vcc->stats->tx);
         iadev->tx_pkt_cnt++;
 	/* Increment transaction counter */  
 	writel(2, iadev->dma+IPHASE5575_TX_COUNTER);  
         
 #if 0        
         /* add flow control logic */ 
-        if (atomic_read(&vcc->stats->tx) % 20 == 0) {
+        if (atomic_read_unchecked(&vcc->stats->tx) % 20 == 0) {
           if (iavcc->vc_desc_cnt > 10) {
              vcc->tx_quota =  vcc->tx_quota * 3 / 4;
             printk("Tx1:  vcc->tx_quota = %d \n", (u32)vcc->tx_quota );
diff --git a/drivers/atm/lanai.c b/drivers/atm/lanai.c
index ce43ae3e8..969de382f 100644
--- a/drivers/atm/lanai.c
+++ b/drivers/atm/lanai.c
@@ -1295,7 +1295,7 @@ static void lanai_send_one_aal5(struct lanai_dev *lanai,
 	vcc_tx_add_aal5_trailer(lvcc, skb->len, 0, 0);
 	lanai_endtx(lanai, lvcc);
 	lanai_free_skb(lvcc->tx.atmvcc, skb);
-	atomic_inc(&lvcc->tx.atmvcc->stats->tx);
+	atomic_inc_unchecked(&lvcc->tx.atmvcc->stats->tx);
 }
 
 /* Try to fill the buffer - don't call unless there is backlog */
@@ -1418,7 +1418,7 @@ static void vcc_rx_aal5(struct lanai_vcc *lvcc, int endptr)
 	ATM_SKB(skb)->vcc = lvcc->rx.atmvcc;
 	__net_timestamp(skb);
 	lvcc->rx.atmvcc->push(lvcc->rx.atmvcc, skb);
-	atomic_inc(&lvcc->rx.atmvcc->stats->rx);
+	atomic_inc_unchecked(&lvcc->rx.atmvcc->stats->rx);
     out:
 	lvcc->rx.buf.ptr = end;
 	cardvcc_write(lvcc, endptr, vcc_rxreadptr);
@@ -1659,7 +1659,7 @@ static int handle_service(struct lanai_dev *lanai, u32 s)
 		DPRINTK("(itf %d) got RX service entry 0x%X for non-AAL5 "
 		    "vcc %d\n", lanai->number, (unsigned int) s, vci);
 		lanai->stats.service_rxnotaal5++;
-		atomic_inc(&lvcc->rx.atmvcc->stats->rx_err);
+		atomic_inc_unchecked(&lvcc->rx.atmvcc->stats->rx_err);
 		return 0;
 	}
 	if (likely(!(s & (SERVICE_TRASH | SERVICE_STREAM | SERVICE_CRCERR)))) {
@@ -1671,7 +1671,7 @@ static int handle_service(struct lanai_dev *lanai, u32 s)
 		int bytes;
 		read_unlock(&vcc_sklist_lock);
 		DPRINTK("got trashed rx pdu on vci %d\n", vci);
-		atomic_inc(&lvcc->rx.atmvcc->stats->rx_err);
+		atomic_inc_unchecked(&lvcc->rx.atmvcc->stats->rx_err);
 		lvcc->stats.x.aal5.service_trash++;
 		bytes = (SERVICE_GET_END(s) * 16) -
 		    (((unsigned long) lvcc->rx.buf.ptr) -
@@ -1683,7 +1683,7 @@ static int handle_service(struct lanai_dev *lanai, u32 s)
 	}
 	if (s & SERVICE_STREAM) {
 		read_unlock(&vcc_sklist_lock);
-		atomic_inc(&lvcc->rx.atmvcc->stats->rx_err);
+		atomic_inc_unchecked(&lvcc->rx.atmvcc->stats->rx_err);
 		lvcc->stats.x.aal5.service_stream++;
 		printk(KERN_ERR DEV_LABEL "(itf %d): Got AAL5 stream "
 		    "PDU on VCI %d!\n", lanai->number, vci);
@@ -1691,7 +1691,7 @@ static int handle_service(struct lanai_dev *lanai, u32 s)
 		return 0;
 	}
 	DPRINTK("got rx crc error on vci %d\n", vci);
-	atomic_inc(&lvcc->rx.atmvcc->stats->rx_err);
+	atomic_inc_unchecked(&lvcc->rx.atmvcc->stats->rx_err);
 	lvcc->stats.x.aal5.service_rxcrc++;
 	lvcc->rx.buf.ptr = &lvcc->rx.buf.start[SERVICE_GET_END(s) * 4];
 	cardvcc_write(lvcc, SERVICE_GET_END(s), vcc_rxreadptr);
diff --git a/drivers/atm/nicstar.c b/drivers/atm/nicstar.c
index 700ed15c2..a3a8a7380 100644
--- a/drivers/atm/nicstar.c
+++ b/drivers/atm/nicstar.c
@@ -1633,7 +1633,7 @@ static int ns_send(struct atm_vcc *vcc, struct sk_buff *skb)
 	if ((vc = (vc_map *) vcc->dev_data) == NULL) {
 		printk("nicstar%d: vcc->dev_data == NULL on ns_send().\n",
 		       card->index);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb_any(skb);
 		return -EINVAL;
 	}
@@ -1641,7 +1641,7 @@ static int ns_send(struct atm_vcc *vcc, struct sk_buff *skb)
 	if (!vc->tx) {
 		printk("nicstar%d: Trying to transmit on a non-tx VC.\n",
 		       card->index);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb_any(skb);
 		return -EINVAL;
 	}
@@ -1649,14 +1649,14 @@ static int ns_send(struct atm_vcc *vcc, struct sk_buff *skb)
 	if (vcc->qos.aal != ATM_AAL5 && vcc->qos.aal != ATM_AAL0) {
 		printk("nicstar%d: Only AAL0 and AAL5 are supported.\n",
 		       card->index);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb_any(skb);
 		return -EINVAL;
 	}
 
 	if (skb_shinfo(skb)->nr_frags != 0) {
 		printk("nicstar%d: No scatter-gather yet.\n", card->index);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb_any(skb);
 		return -EINVAL;
 	}
@@ -1704,11 +1704,11 @@ static int ns_send(struct atm_vcc *vcc, struct sk_buff *skb)
 	}
 
 	if (push_scqe(card, vc, scq, &scqe, skb) != 0) {
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		dev_kfree_skb_any(skb);
 		return -EIO;
 	}
-	atomic_inc(&vcc->stats->tx);
+	atomic_inc_unchecked(&vcc->stats->tx);
 
 	return 0;
 }
@@ -2025,14 +2025,14 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 				printk
 				    ("nicstar%d: Can't allocate buffers for aal0.\n",
 				     card->index);
-				atomic_add(i, &vcc->stats->rx_drop);
+				atomic_add_unchecked(i, &vcc->stats->rx_drop);
 				break;
 			}
 			if (!atm_charge(vcc, sb->truesize)) {
 				RXPRINTK
 				    ("nicstar%d: atm_charge() dropped aal0 packets.\n",
 				     card->index);
-				atomic_add(i - 1, &vcc->stats->rx_drop);	/* already increased by 1 */
+				atomic_add_unchecked(i - 1, &vcc->stats->rx_drop);	/* already increased by 1 */
 				dev_kfree_skb_any(sb);
 				break;
 			}
@@ -2047,7 +2047,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 			ATM_SKB(sb)->vcc = vcc;
 			__net_timestamp(sb);
 			vcc->push(vcc, sb);
-			atomic_inc(&vcc->stats->rx);
+			atomic_inc_unchecked(&vcc->stats->rx);
 			cell += ATM_CELL_PAYLOAD;
 		}
 
@@ -2064,7 +2064,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 			if (iovb == NULL) {
 				printk("nicstar%d: Out of iovec buffers.\n",
 				       card->index);
-				atomic_inc(&vcc->stats->rx_drop);
+				atomic_inc_unchecked(&vcc->stats->rx_drop);
 				recycle_rx_buf(card, skb);
 				return;
 			}
@@ -2088,7 +2088,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 		   small or large buffer itself. */
 	} else if (NS_PRV_IOVCNT(iovb) >= NS_MAX_IOVECS) {
 		printk("nicstar%d: received too big AAL5 SDU.\n", card->index);
-		atomic_inc(&vcc->stats->rx_err);
+		atomic_inc_unchecked(&vcc->stats->rx_err);
 		recycle_iovec_rx_bufs(card, (struct iovec *)iovb->data,
 				      NS_MAX_IOVECS);
 		NS_PRV_IOVCNT(iovb) = 0;
@@ -2108,7 +2108,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 			    ("nicstar%d: Expected a small buffer, and this is not one.\n",
 			     card->index);
 			which_list(card, skb);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			recycle_rx_buf(card, skb);
 			vc->rx_iov = NULL;
 			recycle_iov_buf(card, iovb);
@@ -2121,7 +2121,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 			    ("nicstar%d: Expected a large buffer, and this is not one.\n",
 			     card->index);
 			which_list(card, skb);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			recycle_iovec_rx_bufs(card, (struct iovec *)iovb->data,
 					      NS_PRV_IOVCNT(iovb));
 			vc->rx_iov = NULL;
@@ -2144,7 +2144,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 				printk(" - PDU size mismatch.\n");
 			else
 				printk(".\n");
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			recycle_iovec_rx_bufs(card, (struct iovec *)iovb->data,
 					      NS_PRV_IOVCNT(iovb));
 			vc->rx_iov = NULL;
@@ -2158,14 +2158,14 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 			/* skb points to a small buffer */
 			if (!atm_charge(vcc, skb->truesize)) {
 				push_rxbufs(card, skb);
-				atomic_inc(&vcc->stats->rx_drop);
+				atomic_inc_unchecked(&vcc->stats->rx_drop);
 			} else {
 				skb_put(skb, len);
 				dequeue_sm_buf(card, skb);
 				ATM_SKB(skb)->vcc = vcc;
 				__net_timestamp(skb);
 				vcc->push(vcc, skb);
-				atomic_inc(&vcc->stats->rx);
+				atomic_inc_unchecked(&vcc->stats->rx);
 			}
 		} else if (NS_PRV_IOVCNT(iovb) == 2) {	/* One small plus one large buffer */
 			struct sk_buff *sb;
@@ -2176,14 +2176,14 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 			if (len <= NS_SMBUFSIZE) {
 				if (!atm_charge(vcc, sb->truesize)) {
 					push_rxbufs(card, sb);
-					atomic_inc(&vcc->stats->rx_drop);
+					atomic_inc_unchecked(&vcc->stats->rx_drop);
 				} else {
 					skb_put(sb, len);
 					dequeue_sm_buf(card, sb);
 					ATM_SKB(sb)->vcc = vcc;
 					__net_timestamp(sb);
 					vcc->push(vcc, sb);
-					atomic_inc(&vcc->stats->rx);
+					atomic_inc_unchecked(&vcc->stats->rx);
 				}
 
 				push_rxbufs(card, skb);
@@ -2192,7 +2192,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 
 				if (!atm_charge(vcc, skb->truesize)) {
 					push_rxbufs(card, skb);
-					atomic_inc(&vcc->stats->rx_drop);
+					atomic_inc_unchecked(&vcc->stats->rx_drop);
 				} else {
 					dequeue_lg_buf(card, skb);
 					skb_push(skb, NS_SMBUFSIZE);
@@ -2202,7 +2202,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 					ATM_SKB(skb)->vcc = vcc;
 					__net_timestamp(skb);
 					vcc->push(vcc, skb);
-					atomic_inc(&vcc->stats->rx);
+					atomic_inc_unchecked(&vcc->stats->rx);
 				}
 
 				push_rxbufs(card, sb);
@@ -2223,7 +2223,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 					printk
 					    ("nicstar%d: Out of huge buffers.\n",
 					     card->index);
-					atomic_inc(&vcc->stats->rx_drop);
+					atomic_inc_unchecked(&vcc->stats->rx_drop);
 					recycle_iovec_rx_bufs(card,
 							      (struct iovec *)
 							      iovb->data,
@@ -2274,7 +2274,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 					card->hbpool.count++;
 				} else
 					dev_kfree_skb_any(hb);
-				atomic_inc(&vcc->stats->rx_drop);
+				atomic_inc_unchecked(&vcc->stats->rx_drop);
 			} else {
 				/* Copy the small buffer to the huge buffer */
 				sb = (struct sk_buff *)iov->iov_base;
@@ -2308,7 +2308,7 @@ static void dequeue_rx(ns_dev * card, ns_rsqe * rsqe)
 				ATM_SKB(hb)->vcc = vcc;
 				__net_timestamp(hb);
 				vcc->push(vcc, hb);
-				atomic_inc(&vcc->stats->rx);
+				atomic_inc_unchecked(&vcc->stats->rx);
 			}
 		}
 
diff --git a/drivers/atm/solos-pci.c b/drivers/atm/solos-pci.c
index 37dd4a159..1563ebad0 100644
--- a/drivers/atm/solos-pci.c
+++ b/drivers/atm/solos-pci.c
@@ -847,7 +847,7 @@ static void solos_bh(unsigned long card_arg)
 				}
 				atm_charge(vcc, skb->truesize);
 				vcc->push(vcc, skb);
-				atomic_inc(&vcc->stats->rx);
+				atomic_inc_unchecked(&vcc->stats->rx);
 				break;
 
 			case PKT_STATUS:
@@ -1128,7 +1128,7 @@ static uint32_t fpga_tx(struct solos_card *card)
 			vcc = SKB_CB(oldskb)->vcc;
 
 			if (vcc) {
-				atomic_inc(&vcc->stats->tx);
+				atomic_inc_unchecked(&vcc->stats->tx);
 				solos_pop(vcc, oldskb);
 			} else {
 				dev_kfree_skb_irq(oldskb);
diff --git a/drivers/atm/suni.c b/drivers/atm/suni.c
index 021593455..ce9f5b153 100644
--- a/drivers/atm/suni.c
+++ b/drivers/atm/suni.c
@@ -49,8 +49,8 @@ static DEFINE_SPINLOCK(sunis_lock);
 
 
 #define ADD_LIMITED(s,v) \
-    atomic_add((v),&stats->s); \
-    if (atomic_read(&stats->s) < 0) atomic_set(&stats->s,INT_MAX);
+    atomic_add_unchecked((v),&stats->s); \
+    if (atomic_read_unchecked(&stats->s) < 0) atomic_set_unchecked(&stats->s,INT_MAX);
 
 
 static void suni_hz(unsigned long from_timer)
diff --git a/drivers/atm/uPD98402.c b/drivers/atm/uPD98402.c
index 5120a96b3..e2572bdba 100644
--- a/drivers/atm/uPD98402.c
+++ b/drivers/atm/uPD98402.c
@@ -42,7 +42,7 @@ static int fetch_stats(struct atm_dev *dev,struct sonet_stats __user *arg,int ze
 	struct sonet_stats tmp;
  	int error = 0;
 
-	atomic_add(GET(HECCT),&PRIV(dev)->sonet_stats.uncorr_hcs);
+	atomic_add_unchecked(GET(HECCT),&PRIV(dev)->sonet_stats.uncorr_hcs);
 	sonet_copy_stats(&PRIV(dev)->sonet_stats,&tmp);
 	if (arg) error = copy_to_user(arg,&tmp,sizeof(tmp));
 	if (zero && !error) {
@@ -161,9 +161,9 @@ static int uPD98402_ioctl(struct atm_dev *dev,unsigned int cmd,void __user *arg)
 
 
 #define ADD_LIMITED(s,v) \
-    { atomic_add(GET(v),&PRIV(dev)->sonet_stats.s); \
-    if (atomic_read(&PRIV(dev)->sonet_stats.s) < 0) \
-	atomic_set(&PRIV(dev)->sonet_stats.s,INT_MAX); }
+    { atomic_add_unchecked(GET(v),&PRIV(dev)->sonet_stats.s); \
+    if (atomic_read_unchecked(&PRIV(dev)->sonet_stats.s) < 0) \
+	atomic_set_unchecked(&PRIV(dev)->sonet_stats.s,INT_MAX); }
 
 
 static void stat_event(struct atm_dev *dev)
@@ -194,7 +194,7 @@ static void uPD98402_int(struct atm_dev *dev)
 		if (reason & uPD98402_INT_PFM) stat_event(dev);
 		if (reason & uPD98402_INT_PCO) {
 			(void) GET(PCOCR); /* clear interrupt cause */
-			atomic_add(GET(HECCT),
+			atomic_add_unchecked(GET(HECCT),
 			    &PRIV(dev)->sonet_stats.uncorr_hcs);
 		}
 		if ((reason & uPD98402_INT_RFO) && 
@@ -222,9 +222,9 @@ static int uPD98402_start(struct atm_dev *dev)
 	PUT(~(uPD98402_INT_PFM | uPD98402_INT_ALM | uPD98402_INT_RFO |
 	  uPD98402_INT_LOS),PIMR); /* enable them */
 	(void) fetch_stats(dev,NULL,1); /* clear kernel counters */
-	atomic_set(&PRIV(dev)->sonet_stats.corr_hcs,-1);
-	atomic_set(&PRIV(dev)->sonet_stats.tx_cells,-1);
-	atomic_set(&PRIV(dev)->sonet_stats.rx_cells,-1);
+	atomic_set_unchecked(&PRIV(dev)->sonet_stats.corr_hcs,-1);
+	atomic_set_unchecked(&PRIV(dev)->sonet_stats.tx_cells,-1);
+	atomic_set_unchecked(&PRIV(dev)->sonet_stats.rx_cells,-1);
 	return 0;
 }
 
diff --git a/drivers/atm/zatm.c b/drivers/atm/zatm.c
index cecfb9437..87009ecd9 100644
--- a/drivers/atm/zatm.c
+++ b/drivers/atm/zatm.c
@@ -459,7 +459,7 @@ printk("dummy: 0x%08lx, 0x%08lx\n",dummy[0],dummy[1]);
 		}
 		if (!size) {
 			dev_kfree_skb_irq(skb);
-			if (vcc) atomic_inc(&vcc->stats->rx_err);
+			if (vcc) atomic_inc_unchecked(&vcc->stats->rx_err);
 			continue;
 		}
 		if (!atm_charge(vcc,skb->truesize)) {
@@ -469,7 +469,7 @@ printk("dummy: 0x%08lx, 0x%08lx\n",dummy[0],dummy[1]);
 		skb->len = size;
 		ATM_SKB(skb)->vcc = vcc;
 		vcc->push(vcc,skb);
-		atomic_inc(&vcc->stats->rx);
+		atomic_inc_unchecked(&vcc->stats->rx);
 	}
 	zout(pos & 0xffff,MTA(mbx));
 #if 0 /* probably a stupid idea */
@@ -733,7 +733,7 @@ if (*ZATM_PRV_DSC(skb) != (uPD98401_TXPD_V | uPD98401_TXPD_DP |
 			skb_queue_head(&zatm_vcc->backlog,skb);
 			break;
 		}
-	atomic_inc(&vcc->stats->tx);
+	atomic_inc_unchecked(&vcc->stats->tx);
 	wake_up(&zatm_vcc->tx_wait);
 }
 
diff --git a/drivers/base/bus.c b/drivers/base/bus.c
index 6470eb808..3a7d92b18 100644
--- a/drivers/base/bus.c
+++ b/drivers/base/bus.c
@@ -1136,7 +1136,7 @@ int subsys_interface_register(struct subsys_interface *sif)
 		return -EINVAL;
 
 	mutex_lock(&subsys->p->mutex);
-	list_add_tail(&sif->node, &subsys->p->interfaces);
+	pax_list_add_tail((struct list_head *)&sif->node, &subsys->p->interfaces);
 	if (sif->add_dev) {
 		subsys_dev_iter_init(&iter, subsys, NULL, NULL);
 		while ((dev = subsys_dev_iter_next(&iter)))
@@ -1161,7 +1161,7 @@ void subsys_interface_unregister(struct subsys_interface *sif)
 	subsys = sif->subsys;
 
 	mutex_lock(&subsys->p->mutex);
-	list_del_init(&sif->node);
+	pax_list_del_init((struct list_head *)&sif->node);
 	if (sif->remove_dev) {
 		subsys_dev_iter_init(&iter, subsys, NULL, NULL);
 		while ((dev = subsys_dev_iter_next(&iter)))
diff --git a/drivers/base/devres.c b/drivers/base/devres.c
index 8fc654f08..36e28e9e3 100644
--- a/drivers/base/devres.c
+++ b/drivers/base/devres.c
@@ -476,7 +476,9 @@ static int remove_nodes(struct device *dev,
 
 static int release_nodes(struct device *dev, struct list_head *first,
 			 struct list_head *end, unsigned long flags)
-	__releases(&dev->devres_lock)
+	__releases(&dev->devres_lock);
+static int release_nodes(struct device *dev, struct list_head *first,
+			 struct list_head *end, unsigned long flags)
 {
 	LIST_HEAD(todo);
 	int cnt;
diff --git a/drivers/base/devtmpfs.c b/drivers/base/devtmpfs.c
index 44a74cf13..a5dd826f8 100644
--- a/drivers/base/devtmpfs.c
+++ b/drivers/base/devtmpfs.c
@@ -354,7 +354,7 @@ int devtmpfs_mount(const char *mntdir)
 	if (!thread)
 		return 0;
 
-	err = sys_mount("devtmpfs", (char *)mntdir, "devtmpfs", MS_SILENT, NULL);
+	err = sys_mount((char __force_user *)"devtmpfs", (char __force_user *)mntdir, (char __force_user *)"devtmpfs", MS_SILENT, NULL);
 	if (err)
 		printk(KERN_INFO "devtmpfs: error mounting %i\n", err);
 	else
@@ -380,11 +380,11 @@ static int devtmpfsd(void *p)
 	*err = sys_unshare(CLONE_NEWNS);
 	if (*err)
 		goto out;
-	*err = sys_mount("devtmpfs", "/", "devtmpfs", MS_SILENT, options);
+	*err = sys_mount((char __force_user *)"devtmpfs", (char __force_user *)"/", (char __force_user *)"devtmpfs", MS_SILENT, (char __force_user *)options);
 	if (*err)
 		goto out;
-	sys_chdir("/.."); /* will traverse into overmounted root */
-	sys_chroot(".");
+	sys_chdir((char __force_user *)"/.."); /* will traverse into overmounted root */
+	sys_chroot((char __force_user *)".");
 	complete(&setup_done);
 	while (1) {
 		spin_lock(&req_lock);
diff --git a/drivers/base/node.c b/drivers/base/node.c
index 5548f9686..3cbdfc183 100644
--- a/drivers/base/node.c
+++ b/drivers/base/node.c
@@ -638,7 +638,7 @@ static ssize_t print_nodes_state(enum node_states state, char *buf)
 struct node_attr {
 	struct device_attribute attr;
 	enum node_states state;
-};
+} __do_const;
 
 static ssize_t show_node_state(struct device *dev,
 			       struct device_attribute *attr, char *buf)
diff --git a/drivers/base/platform-msi.c b/drivers/base/platform-msi.c
index 279e53989..4c9d7fb7c 100644
--- a/drivers/base/platform-msi.c
+++ b/drivers/base/platform-msi.c
@@ -24,6 +24,8 @@
 #include <linux/msi.h>
 #include <linux/slab.h>
 
+#include <asm/pgtable.h>
+
 #define DEV_ID_SHIFT	21
 #define MAX_DEV_MSIS	(1 << (32 - DEV_ID_SHIFT))
 
@@ -81,10 +83,12 @@ static void platform_msi_update_dom_ops(struct msi_domain_info *info)
 
 	BUG_ON(!ops);
 
+	pax_open_kernel();
 	if (ops->msi_init == NULL)
-		ops->msi_init = platform_msi_init;
+		const_cast(ops->msi_init) = platform_msi_init;
 	if (ops->set_desc == NULL)
-		ops->set_desc = platform_msi_set_desc;
+		const_cast(ops->set_desc) = platform_msi_set_desc;
+	pax_close_kernel();
 }
 
 static void platform_msi_write_msg(struct irq_data *data, struct msi_msg *msg)
@@ -102,16 +106,18 @@ static void platform_msi_update_chip_ops(struct msi_domain_info *info)
 	struct irq_chip *chip = info->chip;
 
 	BUG_ON(!chip);
+	pax_open_kernel();
 	if (!chip->irq_mask)
-		chip->irq_mask = irq_chip_mask_parent;
+		const_cast(chip->irq_mask) = irq_chip_mask_parent;
 	if (!chip->irq_unmask)
-		chip->irq_unmask = irq_chip_unmask_parent;
+		const_cast(chip->irq_unmask) = irq_chip_unmask_parent;
 	if (!chip->irq_eoi)
-		chip->irq_eoi = irq_chip_eoi_parent;
+		const_cast(chip->irq_eoi) = irq_chip_eoi_parent;
 	if (!chip->irq_set_affinity)
-		chip->irq_set_affinity = msi_domain_set_affinity;
+		const_cast(chip->irq_set_affinity) = msi_domain_set_affinity;
 	if (!chip->irq_write_msi_msg)
-		chip->irq_write_msi_msg = platform_msi_write_msg;
+		const_cast(chip->irq_write_msi_msg) = platform_msi_write_msg;
+	pax_close_kernel();
 }
 
 static void platform_msi_free_descs(struct device *dev, int base, int nvec)
diff --git a/drivers/base/power/domain.c b/drivers/base/power/domain.c
index a1f2aff33..58bf1bce8 100644
--- a/drivers/base/power/domain.c
+++ b/drivers/base/power/domain.c
@@ -1621,8 +1621,10 @@ int genpd_dev_pm_attach(struct device *dev)
 		goto out;
 	}
 
-	dev->pm_domain->detach = genpd_dev_pm_detach;
-	dev->pm_domain->sync = genpd_dev_pm_sync;
+	pax_open_kernel();
+	const_cast(dev->pm_domain->detach) = genpd_dev_pm_detach;
+	const_cast(dev->pm_domain->sync) = genpd_dev_pm_sync;
+	pax_close_kernel();
 
 	mutex_lock(&pd->lock);
 	ret = genpd_poweron(pd, 0);
diff --git a/drivers/base/power/runtime.c b/drivers/base/power/runtime.c
index 82a081ea4..b13ec3b00 100644
--- a/drivers/base/power/runtime.c
+++ b/drivers/base/power/runtime.c
@@ -16,35 +16,32 @@
 
 typedef int (*pm_callback_t)(struct device *);
 
-static pm_callback_t __rpm_get_callback(struct device *dev, size_t cb_offset)
-{
-	pm_callback_t cb;
-	const struct dev_pm_ops *ops;
-
-	if (dev->pm_domain)
-		ops = &dev->pm_domain->ops;
-	else if (dev->type && dev->type->pm)
-		ops = dev->type->pm;
-	else if (dev->class && dev->class->pm)
-		ops = dev->class->pm;
-	else if (dev->bus && dev->bus->pm)
-		ops = dev->bus->pm;
-	else
-		ops = NULL;
-
-	if (ops)
-		cb = *(pm_callback_t *)((void *)ops + cb_offset);
-	else
-		cb = NULL;
-
-	if (!cb && dev->driver && dev->driver->pm)
-		cb = *(pm_callback_t *)((void *)dev->driver->pm + cb_offset);
-
-	return cb;
-}
-
-#define RPM_GET_CALLBACK(dev, callback) \
-		__rpm_get_callback(dev, offsetof(struct dev_pm_ops, callback))
+#define RPM_GET_CALLBACK(dev, callback)			\
+({							\
+	pm_callback_t cb;				\
+	const struct dev_pm_ops *ops;			\
+							\
+	if (dev->pm_domain)				\
+		ops = &dev->pm_domain->ops;		\
+	else if (dev->type && dev->type->pm)		\
+		ops = dev->type->pm;			\
+	else if (dev->class && dev->class->pm)		\
+		ops = dev->class->pm;			\
+	else if (dev->bus && dev->bus->pm)		\
+		ops = dev->bus->pm;			\
+	else						\
+		ops = NULL;				\
+							\
+	if (ops)					\
+		cb = ops->callback;			\
+	else						\
+		cb = NULL;				\
+							\
+	if (!cb && dev->driver && dev->driver->pm)	\
+		cb = dev->driver->pm->callback;		\
+							\
+	cb;						\
+})
 
 static int rpm_resume(struct device *dev, int rpmflags);
 static int rpm_suspend(struct device *dev, int rpmflags);
@@ -263,8 +260,8 @@ static int rpm_check_suspend_allowed(struct device *dev)
  * @cb: Runtime PM callback to run.
  * @dev: Device to run the callback for.
  */
+static int __rpm_callback(int (*cb)(struct device *), struct device *dev) __must_hold(&dev->power.lock);
 static int __rpm_callback(int (*cb)(struct device *), struct device *dev)
-	__releases(&dev->power.lock) __acquires(&dev->power.lock)
 {
 	int retval;
 
@@ -412,8 +409,8 @@ static int rpm_callback(int (*cb)(struct device *), struct device *dev)
  *
  * This function must be called under dev->power.lock with interrupts disabled.
  */
+static int rpm_suspend(struct device *dev, int rpmflags) __must_hold(&dev->power.lock);
 static int rpm_suspend(struct device *dev, int rpmflags)
-	__releases(&dev->power.lock) __acquires(&dev->power.lock)
 {
 	int (*callback)(struct device *);
 	struct device *parent = NULL;
@@ -594,8 +591,8 @@ static int rpm_suspend(struct device *dev, int rpmflags)
  *
  * This function must be called under dev->power.lock with interrupts disabled.
  */
+static int rpm_resume(struct device *dev, int rpmflags) __must_hold(&dev->power.lock);
 static int rpm_resume(struct device *dev, int rpmflags)
-	__releases(&dev->power.lock) __acquires(&dev->power.lock)
 {
 	int (*callback)(struct device *);
 	struct device *parent = NULL;
diff --git a/drivers/base/power/sysfs.c b/drivers/base/power/sysfs.c
index a7b46798c..d30249044 100644
--- a/drivers/base/power/sysfs.c
+++ b/drivers/base/power/sysfs.c
@@ -181,7 +181,7 @@ static ssize_t rtpm_status_show(struct device *dev,
 			return -EIO;
 		}
 	}
-	return sprintf(buf, p);
+	return sprintf(buf, "%s", p);
 }
 
 static DEVICE_ATTR(runtime_status, 0444, rtpm_status_show, NULL);
diff --git a/drivers/base/power/wakeup.c b/drivers/base/power/wakeup.c
index 62e4de2aa..38961cd63 100644
--- a/drivers/base/power/wakeup.c
+++ b/drivers/base/power/wakeup.c
@@ -36,14 +36,14 @@ static bool pm_abort_suspend __read_mostly;
  * They need to be modified together atomically, so it's better to use one
  * atomic variable to hold them both.
  */
-static atomic_t combined_event_count = ATOMIC_INIT(0);
+static atomic_unchecked_t combined_event_count = ATOMIC_INIT(0);
 
 #define IN_PROGRESS_BITS	(sizeof(int) * 4)
 #define MAX_IN_PROGRESS		((1 << IN_PROGRESS_BITS) - 1)
 
 static void split_counters(unsigned int *cnt, unsigned int *inpr)
 {
-	unsigned int comb = atomic_read(&combined_event_count);
+	unsigned int comb = atomic_read_unchecked(&combined_event_count);
 
 	*cnt = (comb >> IN_PROGRESS_BITS);
 	*inpr = comb & MAX_IN_PROGRESS;
@@ -538,7 +538,7 @@ static void wakeup_source_activate(struct wakeup_source *ws)
 		ws->start_prevent_time = ws->last_time;
 
 	/* Increment the counter of events in progress. */
-	cec = atomic_inc_return(&combined_event_count);
+	cec = atomic_inc_return_unchecked(&combined_event_count);
 
 	trace_wakeup_source_activate(ws->name, cec);
 }
@@ -664,7 +664,7 @@ static void wakeup_source_deactivate(struct wakeup_source *ws)
 	 * Increment the counter of registered wakeup events and decrement the
 	 * couter of wakeup events in progress simultaneously.
 	 */
-	cec = atomic_add_return(MAX_IN_PROGRESS, &combined_event_count);
+	cec = atomic_add_return_unchecked(MAX_IN_PROGRESS, &combined_event_count);
 	trace_wakeup_source_deactivate(ws->name, cec);
 
 	split_counters(&cnt, &inpr);
diff --git a/drivers/base/regmap/regmap-debugfs.c b/drivers/base/regmap/regmap-debugfs.c
index 1ee3d4086..a41544a21 100644
--- a/drivers/base/regmap/regmap-debugfs.c
+++ b/drivers/base/regmap/regmap-debugfs.c
@@ -400,7 +400,7 @@ static const struct file_operations regmap_reg_ranges_fops = {
 static int regmap_access_show(struct seq_file *s, void *ignored)
 {
 	struct regmap *map = s->private;
-	int i, reg_len;
+	unsigned int i, reg_len;
 
 	reg_len = regmap_calc_reg_len(map->max_register);
 
diff --git a/drivers/base/regmap/regmap.c b/drivers/base/regmap/regmap.c
index e964d0688..633487fd8 100644
--- a/drivers/base/regmap/regmap.c
+++ b/drivers/base/regmap/regmap.c
@@ -402,8 +402,8 @@ static void regmap_unlock_mutex(void *__map)
 	mutex_unlock(&map->mutex);
 }
 
+static void regmap_lock_spinlock(void *__map) __acquires(&map->spinlock);
 static void regmap_lock_spinlock(void *__map)
-__acquires(&map->spinlock)
 {
 	struct regmap *map = __map;
 	unsigned long flags;
@@ -412,8 +412,8 @@ __acquires(&map->spinlock)
 	map->spinlock_flags = flags;
 }
 
+static void regmap_unlock_spinlock(void *__map) __releases(&map->spinlock);
 static void regmap_unlock_spinlock(void *__map)
-__releases(&map->spinlock)
 {
 	struct regmap *map = __map;
 	spin_unlock_irqrestore(&map->spinlock, map->spinlock_flags);
diff --git a/drivers/base/syscore.c b/drivers/base/syscore.c
index 8d98a329f..61d316524 100644
--- a/drivers/base/syscore.c
+++ b/drivers/base/syscore.c
@@ -22,7 +22,7 @@ static DEFINE_MUTEX(syscore_ops_lock);
 void register_syscore_ops(struct syscore_ops *ops)
 {
 	mutex_lock(&syscore_ops_lock);
-	list_add_tail(&ops->node, &syscore_ops_list);
+	pax_list_add_tail((struct list_head *)&ops->node, &syscore_ops_list);
 	mutex_unlock(&syscore_ops_lock);
 }
 EXPORT_SYMBOL_GPL(register_syscore_ops);
@@ -34,7 +34,7 @@ EXPORT_SYMBOL_GPL(register_syscore_ops);
 void unregister_syscore_ops(struct syscore_ops *ops)
 {
 	mutex_lock(&syscore_ops_lock);
-	list_del(&ops->node);
+	pax_list_del((struct list_head *)&ops->node);
 	mutex_unlock(&syscore_ops_lock);
 }
 EXPORT_SYMBOL_GPL(unregister_syscore_ops);
diff --git a/drivers/block/cciss.c b/drivers/block/cciss.c
index db9d6bb63..9c5dc788d 100644
--- a/drivers/block/cciss.c
+++ b/drivers/block/cciss.c
@@ -3017,7 +3017,7 @@ static void start_io(ctlr_info_t *h)
 	while (!list_empty(&h->reqQ)) {
 		c = list_entry(h->reqQ.next, CommandList_struct, list);
 		/* can't do anything if fifo is full */
-		if ((h->access.fifo_full(h))) {
+		if ((h->access->fifo_full(h))) {
 			dev_warn(&h->pdev->dev, "fifo full\n");
 			break;
 		}
@@ -3027,7 +3027,7 @@ static void start_io(ctlr_info_t *h)
 		h->Qdepth--;
 
 		/* Tell the controller execute command */
-		h->access.submit_command(h, c);
+		h->access->submit_command(h, c);
 
 		/* Put job onto the completed Q */
 		addQ(&h->cmpQ, c);
@@ -3453,17 +3453,17 @@ startio:
 
 static inline unsigned long get_next_completion(ctlr_info_t *h)
 {
-	return h->access.command_completed(h);
+	return h->access->command_completed(h);
 }
 
 static inline int interrupt_pending(ctlr_info_t *h)
 {
-	return h->access.intr_pending(h);
+	return h->access->intr_pending(h);
 }
 
 static inline long interrupt_not_for_us(ctlr_info_t *h)
 {
-	return ((h->access.intr_pending(h) == 0) ||
+	return ((h->access->intr_pending(h) == 0) ||
 		(h->interrupts_enabled == 0));
 }
 
@@ -3496,7 +3496,7 @@ static inline u32 next_command(ctlr_info_t *h)
 	u32 a;
 
 	if (unlikely(!(h->transMethod & CFGTBL_Trans_Performant)))
-		return h->access.command_completed(h);
+		return h->access->command_completed(h);
 
 	if ((*(h->reply_pool_head) & 1) == (h->reply_pool_wraparound)) {
 		a = *(h->reply_pool_head); /* Next cmd in ring buffer */
@@ -4053,7 +4053,7 @@ static void cciss_put_controller_into_performant_mode(ctlr_info_t *h)
 		trans_support & CFGTBL_Trans_use_short_tags);
 
 	/* Change the access methods to the performant access methods */
-	h->access = SA5_performant_access;
+	h->access = &SA5_performant_access;
 	h->transMethod = CFGTBL_Trans_Performant;
 
 	return;
@@ -4327,7 +4327,7 @@ static int cciss_pci_init(ctlr_info_t *h)
 	if (prod_index < 0)
 		return -ENODEV;
 	h->product_name = products[prod_index].product_name;
-	h->access = *(products[prod_index].access);
+	h->access = products[prod_index].access;
 
 	if (cciss_board_disabled(h)) {
 		dev_warn(&h->pdev->dev, "controller appears to be disabled\n");
@@ -5058,7 +5058,7 @@ reinit_after_soft_reset:
 	}
 
 	/* make sure the board interrupts are off */
-	h->access.set_intr_mask(h, CCISS_INTR_OFF);
+	h->access->set_intr_mask(h, CCISS_INTR_OFF);
 	rc = cciss_request_irq(h, do_cciss_msix_intr, do_cciss_intx);
 	if (rc)
 		goto clean2;
@@ -5108,7 +5108,7 @@ reinit_after_soft_reset:
 		 * fake ones to scoop up any residual completions.
 		 */
 		spin_lock_irqsave(&h->lock, flags);
-		h->access.set_intr_mask(h, CCISS_INTR_OFF);
+		h->access->set_intr_mask(h, CCISS_INTR_OFF);
 		spin_unlock_irqrestore(&h->lock, flags);
 		free_irq(h->intr[h->intr_mode], h);
 		rc = cciss_request_irq(h, cciss_msix_discard_completions,
@@ -5128,9 +5128,9 @@ reinit_after_soft_reset:
 		dev_info(&h->pdev->dev, "Board READY.\n");
 		dev_info(&h->pdev->dev,
 			"Waiting for stale completions to drain.\n");
-		h->access.set_intr_mask(h, CCISS_INTR_ON);
+		h->access->set_intr_mask(h, CCISS_INTR_ON);
 		msleep(10000);
-		h->access.set_intr_mask(h, CCISS_INTR_OFF);
+		h->access->set_intr_mask(h, CCISS_INTR_OFF);
 
 		rc = controller_reset_failed(h->cfgtable);
 		if (rc)
@@ -5153,7 +5153,7 @@ reinit_after_soft_reset:
 	cciss_scsi_setup(h);
 
 	/* Turn the interrupts on so we can service requests */
-	h->access.set_intr_mask(h, CCISS_INTR_ON);
+	h->access->set_intr_mask(h, CCISS_INTR_ON);
 
 	/* Get the firmware version */
 	inq_buff = kzalloc(sizeof(InquiryData_struct), GFP_KERNEL);
@@ -5225,7 +5225,7 @@ static void cciss_shutdown(struct pci_dev *pdev)
 	kfree(flush_buf);
 	if (return_code != IO_OK)
 		dev_warn(&h->pdev->dev, "Error flushing cache\n");
-	h->access.set_intr_mask(h, CCISS_INTR_OFF);
+	h->access->set_intr_mask(h, CCISS_INTR_OFF);
 	free_irq(h->intr[h->intr_mode], h);
 }
 
diff --git a/drivers/block/cciss.h b/drivers/block/cciss.h
index 7fda30e4a..2f279464f 100644
--- a/drivers/block/cciss.h
+++ b/drivers/block/cciss.h
@@ -101,7 +101,7 @@ struct ctlr_info
 	/* information about each logical volume */
 	drive_info_struct *drv[CISS_MAX_LUN];
 
-	struct access_method access;
+	struct access_method *access;
 
 	/* queue and queue Info */ 
 	struct list_head reqQ;
@@ -402,27 +402,27 @@ static bool SA5_performant_intr_pending(ctlr_info_t *h)
 }
 
 static struct access_method SA5_access = {
-	SA5_submit_command,
-	SA5_intr_mask,
-	SA5_fifo_full,
-	SA5_intr_pending,
-	SA5_completed,
+	.submit_command = SA5_submit_command,
+	.set_intr_mask = SA5_intr_mask,
+	.fifo_full = SA5_fifo_full,
+	.intr_pending = SA5_intr_pending,
+	.command_completed = SA5_completed,
 };
 
 static struct access_method SA5B_access = {
-        SA5_submit_command,
-        SA5B_intr_mask,
-        SA5_fifo_full,
-        SA5B_intr_pending,
-        SA5_completed,
+	.submit_command = SA5_submit_command,
+	.set_intr_mask = SA5B_intr_mask,
+	.fifo_full = SA5_fifo_full,
+	.intr_pending = SA5B_intr_pending,
+	.command_completed = SA5_completed,
 };
 
 static struct access_method SA5_performant_access = {
-	SA5_submit_command,
-	SA5_performant_intr_mask,
-	SA5_fifo_full,
-	SA5_performant_intr_pending,
-	SA5_performant_completed,
+	.submit_command = SA5_submit_command,
+	.set_intr_mask = SA5_performant_intr_mask,
+	.fifo_full = SA5_fifo_full,
+	.intr_pending = SA5_performant_intr_pending,
+	.command_completed = SA5_performant_completed,
 };
 
 struct board_type {
diff --git a/drivers/block/drbd/drbd_bitmap.c b/drivers/block/drbd/drbd_bitmap.c
index ab62b81c2..8f3845086 100644
--- a/drivers/block/drbd/drbd_bitmap.c
+++ b/drivers/block/drbd/drbd_bitmap.c
@@ -1034,7 +1034,7 @@ static void bm_page_io_async(struct drbd_bm_aio_ctx *ctx, int page_nr) __must_ho
 		submit_bio(bio);
 		/* this should not count as user activity and cause the
 		 * resync to throttle -- see drbd_rs_should_slow_down(). */
-		atomic_add(len >> 9, &device->rs_sect_ev);
+		atomic_add_unchecked(len >> 9, &device->rs_sect_ev);
 	}
 }
 
diff --git a/drivers/block/drbd/drbd_int.h b/drivers/block/drbd/drbd_int.h
index 4cb8f21ff..d056229d7 100644
--- a/drivers/block/drbd/drbd_int.h
+++ b/drivers/block/drbd/drbd_int.h
@@ -383,7 +383,7 @@ struct drbd_epoch {
 	struct drbd_connection *connection;
 	struct list_head list;
 	unsigned int barrier_nr;
-	atomic_t epoch_size; /* increased on every request added. */
+	atomic_unchecked_t epoch_size; /* increased on every request added. */
 	atomic_t active;     /* increased on every req. added, and dec on every finished. */
 	unsigned long flags;
 };
@@ -595,8 +595,8 @@ struct drbd_md {
 	u32 flags;
 	u32 md_size_sect;
 
-	s32 al_offset;	/* signed relative sector offset to activity log */
-	s32 bm_offset;	/* signed relative sector offset to bitmap */
+	s32 al_offset __intentional_overflow(0);	/* signed relative sector offset to activity log */
+	s32 bm_offset __intentional_overflow(0);	/* signed relative sector offset to bitmap */
 
 	/* cached value of bdev->disk_conf->meta_dev_idx (see below) */
 	s32 meta_dev_idx;
@@ -960,7 +960,7 @@ struct drbd_device {
 	unsigned int al_tr_number;
 	int al_tr_cycle;
 	wait_queue_head_t seq_wait;
-	atomic_t packet_seq;
+	atomic_unchecked_t packet_seq;
 	unsigned int peer_seq;
 	spinlock_t peer_seq_lock;
 	unsigned long comm_bm_set; /* communicated number of set bits. */
@@ -969,8 +969,8 @@ struct drbd_device {
 	struct mutex own_state_mutex;
 	struct mutex *state_mutex; /* either own_state_mutex or first_peer_device(device)->connection->cstate_mutex */
 	char congestion_reason;  /* Why we where congested... */
-	atomic_t rs_sect_in; /* for incoming resync data rate, SyncTarget */
-	atomic_t rs_sect_ev; /* for submitted resync data rate, both */
+	atomic_unchecked_t rs_sect_in; /* for incoming resync data rate, SyncTarget */
+	atomic_unchecked_t rs_sect_ev; /* for submitted resync data rate, both */
 	int rs_last_sect_ev; /* counter to compare with */
 	int rs_last_events;  /* counter of read or write "events" (unit sectors)
 			      * on the lower level device when we last looked. */
@@ -1129,7 +1129,7 @@ extern int drbd_send_drequest_csum(struct drbd_peer_device *, sector_t sector,
 				   enum drbd_packet cmd);
 extern int drbd_send_ov_request(struct drbd_peer_device *, sector_t sector, int size);
 
-extern int drbd_send_bitmap(struct drbd_device *device);
+extern int drbd_send_bitmap(struct drbd_device *device) __intentional_overflow(-1);
 extern void drbd_send_sr_reply(struct drbd_peer_device *, enum drbd_state_rv retcode);
 extern void conn_send_sr_reply(struct drbd_connection *connection, enum drbd_state_rv retcode);
 extern int drbd_send_rs_deallocated(struct drbd_peer_device *, struct drbd_peer_request *);
diff --git a/drivers/block/drbd/drbd_main.c b/drivers/block/drbd/drbd_main.c
index 83482721b..f2ddf22ff 100644
--- a/drivers/block/drbd/drbd_main.c
+++ b/drivers/block/drbd/drbd_main.c
@@ -1363,7 +1363,7 @@ static int _drbd_send_ack(struct drbd_peer_device *peer_device, enum drbd_packet
 	p->sector = sector;
 	p->block_id = block_id;
 	p->blksize = blksize;
-	p->seq_num = cpu_to_be32(atomic_inc_return(&peer_device->device->packet_seq));
+	p->seq_num = cpu_to_be32(atomic_inc_return_unchecked(&peer_device->device->packet_seq));
 	return drbd_send_command(peer_device, sock, cmd, sizeof(*p), NULL, 0);
 }
 
@@ -1695,7 +1695,7 @@ int drbd_send_dblock(struct drbd_peer_device *peer_device, struct drbd_request *
 		return -EIO;
 	p->sector = cpu_to_be64(req->i.sector);
 	p->block_id = (unsigned long)req;
-	p->seq_num = cpu_to_be32(atomic_inc_return(&device->packet_seq));
+	p->seq_num = cpu_to_be32(atomic_inc_return_unchecked(&device->packet_seq));
 	dp_flags = bio_flags_to_wire(peer_device->connection, req->master_bio);
 	if (device->state.conn >= C_SYNC_SOURCE &&
 	    device->state.conn <= C_PAUSED_SYNC_T)
@@ -1984,8 +1984,8 @@ void drbd_init_set_defaults(struct drbd_device *device)
 	atomic_set(&device->unacked_cnt, 0);
 	atomic_set(&device->local_cnt, 0);
 	atomic_set(&device->pp_in_use_by_net, 0);
-	atomic_set(&device->rs_sect_in, 0);
-	atomic_set(&device->rs_sect_ev, 0);
+	atomic_set_unchecked(&device->rs_sect_in, 0);
+	atomic_set_unchecked(&device->rs_sect_ev, 0);
 	atomic_set(&device->ap_in_flight, 0);
 	atomic_set(&device->md_io.in_use, 0);
 
@@ -2752,8 +2752,8 @@ void drbd_destroy_connection(struct kref *kref)
 	struct drbd_connection *connection = container_of(kref, struct drbd_connection, kref);
 	struct drbd_resource *resource = connection->resource;
 
-	if (atomic_read(&connection->current_epoch->epoch_size) !=  0)
-		drbd_err(connection, "epoch_size:%d\n", atomic_read(&connection->current_epoch->epoch_size));
+	if (atomic_read_unchecked(&connection->current_epoch->epoch_size) !=  0)
+		drbd_err(connection, "epoch_size:%d\n", atomic_read_unchecked(&connection->current_epoch->epoch_size));
 	kfree(connection->current_epoch);
 
 	idr_destroy(&connection->peer_devices);
diff --git a/drivers/block/drbd/drbd_nl.c b/drivers/block/drbd/drbd_nl.c
index f35db29ca..ac6c47248 100644
--- a/drivers/block/drbd/drbd_nl.c
+++ b/drivers/block/drbd/drbd_nl.c
@@ -89,8 +89,8 @@ int drbd_adm_get_initial_state(struct sk_buff *skb, struct netlink_callback *cb)
 #include "drbd_nla.h"
 #include <linux/genl_magic_func.h>
 
-static atomic_t drbd_genl_seq = ATOMIC_INIT(2); /* two. */
-static atomic_t notify_genl_seq = ATOMIC_INIT(2); /* two. */
+static atomic_unchecked_t drbd_genl_seq = ATOMIC_INIT(2); /* two. */
+static atomic_unchecked_t notify_genl_seq = ATOMIC_INIT(2); /* two. */
 
 DEFINE_MUTEX(notification_mutex);
 
@@ -4549,7 +4549,7 @@ void drbd_bcast_event(struct drbd_device *device, const struct sib_info *sib)
 	unsigned seq;
 	int err = -ENOMEM;
 
-	seq = atomic_inc_return(&drbd_genl_seq);
+	seq = atomic_inc_return_unchecked(&drbd_genl_seq);
 	msg = genlmsg_new(NLMSG_GOODSIZE, GFP_NOIO);
 	if (!msg)
 		goto failed;
@@ -4601,7 +4601,7 @@ void notify_resource_state(struct sk_buff *skb,
 	int err;
 
 	if (!skb) {
-		seq = atomic_inc_return(&notify_genl_seq);
+		seq = atomic_inc_return_unchecked(&notify_genl_seq);
 		skb = genlmsg_new(NLMSG_GOODSIZE, GFP_NOIO);
 		err = -ENOMEM;
 		if (!skb)
@@ -4652,7 +4652,7 @@ void notify_device_state(struct sk_buff *skb,
 	int err;
 
 	if (!skb) {
-		seq = atomic_inc_return(&notify_genl_seq);
+		seq = atomic_inc_return_unchecked(&notify_genl_seq);
 		skb = genlmsg_new(NLMSG_GOODSIZE, GFP_NOIO);
 		err = -ENOMEM;
 		if (!skb)
@@ -4701,7 +4701,7 @@ void notify_connection_state(struct sk_buff *skb,
 	int err;
 
 	if (!skb) {
-		seq = atomic_inc_return(&notify_genl_seq);
+		seq = atomic_inc_return_unchecked(&notify_genl_seq);
 		skb = genlmsg_new(NLMSG_GOODSIZE, GFP_NOIO);
 		err = -ENOMEM;
 		if (!skb)
@@ -4751,7 +4751,7 @@ void notify_peer_device_state(struct sk_buff *skb,
 	int err;
 
 	if (!skb) {
-		seq = atomic_inc_return(&notify_genl_seq);
+		seq = atomic_inc_return_unchecked(&notify_genl_seq);
 		skb = genlmsg_new(NLMSG_GOODSIZE, GFP_NOIO);
 		err = -ENOMEM;
 		if (!skb)
@@ -4794,7 +4794,7 @@ void notify_helper(enum drbd_notification_type type,
 {
 	struct drbd_resource *resource = device ? device->resource : connection->resource;
 	struct drbd_helper_info helper_info;
-	unsigned int seq = atomic_inc_return(&notify_genl_seq);
+	unsigned int seq = atomic_inc_return_unchecked(&notify_genl_seq);
 	struct sk_buff *skb = NULL;
 	struct drbd_genlmsghdr *dh;
 	int err;
diff --git a/drivers/block/drbd/drbd_receiver.c b/drivers/block/drbd/drbd_receiver.c
index 942384f34..2a20af47e 100644
--- a/drivers/block/drbd/drbd_receiver.c
+++ b/drivers/block/drbd/drbd_receiver.c
@@ -898,7 +898,7 @@ int drbd_connected(struct drbd_peer_device *peer_device)
 	struct drbd_device *device = peer_device->device;
 	int err;
 
-	atomic_set(&device->packet_seq, 0);
+	atomic_set_unchecked(&device->packet_seq, 0);
 	device->peer_seq = 0;
 
 	device->state_mutex = peer_device->connection->agreed_pro_version < 100 ?
@@ -1333,7 +1333,7 @@ static enum finish_epoch drbd_may_finish_epoch(struct drbd_connection *connectio
 	do {
 		next_epoch = NULL;
 
-		epoch_size = atomic_read(&epoch->epoch_size);
+		epoch_size = atomic_read_unchecked(&epoch->epoch_size);
 
 		switch (ev & ~EV_CLEANUP) {
 		case EV_PUT:
@@ -1373,7 +1373,7 @@ static enum finish_epoch drbd_may_finish_epoch(struct drbd_connection *connectio
 					rv = FE_DESTROYED;
 			} else {
 				epoch->flags = 0;
-				atomic_set(&epoch->epoch_size, 0);
+				atomic_set_unchecked(&epoch->epoch_size, 0);
 				/* atomic_set(&epoch->active, 0); is already zero */
 				if (rv == FE_STILL_LIVE)
 					rv = FE_RECYCLED;
@@ -1759,7 +1759,7 @@ static int receive_Barrier(struct drbd_connection *connection, struct packet_inf
 		conn_wait_active_ee_empty(connection);
 		drbd_flush(connection);
 
-		if (atomic_read(&connection->current_epoch->epoch_size)) {
+		if (atomic_read_unchecked(&connection->current_epoch->epoch_size)) {
 			epoch = kmalloc(sizeof(struct drbd_epoch), GFP_NOIO);
 			if (epoch)
 				break;
@@ -1773,11 +1773,11 @@ static int receive_Barrier(struct drbd_connection *connection, struct packet_inf
 	}
 
 	epoch->flags = 0;
-	atomic_set(&epoch->epoch_size, 0);
+	atomic_set_unchecked(&epoch->epoch_size, 0);
 	atomic_set(&epoch->active, 0);
 
 	spin_lock(&connection->epoch_lock);
-	if (atomic_read(&connection->current_epoch->epoch_size)) {
+	if (atomic_read_unchecked(&connection->current_epoch->epoch_size)) {
 		list_add(&epoch->list, &connection->current_epoch->list);
 		connection->current_epoch = epoch;
 		connection->epochs++;
@@ -2030,7 +2030,9 @@ static int e_end_resync_block(struct drbd_work *w, int unused)
 }
 
 static int recv_resync_read(struct drbd_peer_device *peer_device, sector_t sector,
-			    struct packet_info *pi) __releases(local)
+			    struct packet_info *pi) __releases(local);
+static int recv_resync_read(struct drbd_peer_device *peer_device, sector_t sector,
+			    struct packet_info *pi)
 {
 	struct drbd_device *device = peer_device->device;
 	struct drbd_peer_request *peer_req;
@@ -2052,7 +2054,7 @@ static int recv_resync_read(struct drbd_peer_device *peer_device, sector_t secto
 	list_add_tail(&peer_req->w.list, &device->sync_ee);
 	spin_unlock_irq(&device->resource->req_lock);
 
-	atomic_add(pi->size >> 9, &device->rs_sect_ev);
+	atomic_add_unchecked(pi->size >> 9, &device->rs_sect_ev);
 	if (drbd_submit_peer_request(device, peer_req, REQ_OP_WRITE, 0,
 				     DRBD_FAULT_RS_WR) == 0)
 		return 0;
@@ -2151,7 +2153,7 @@ static int receive_RSDataReply(struct drbd_connection *connection, struct packet
 		drbd_send_ack_dp(peer_device, P_NEG_ACK, p, pi->size);
 	}
 
-	atomic_add(pi->size >> 9, &device->rs_sect_in);
+	atomic_add_unchecked(pi->size >> 9, &device->rs_sect_in);
 
 	return err;
 }
@@ -2548,7 +2550,7 @@ static int receive_Data(struct drbd_connection *connection, struct packet_info *
 
 		err = wait_for_and_update_peer_seq(peer_device, peer_seq);
 		drbd_send_ack_dp(peer_device, P_NEG_ACK, p, pi->size);
-		atomic_inc(&connection->current_epoch->epoch_size);
+		atomic_inc_unchecked(&connection->current_epoch->epoch_size);
 		err2 = drbd_drain_block(peer_device, pi->size);
 		if (!err)
 			err = err2;
@@ -2589,7 +2591,7 @@ static int receive_Data(struct drbd_connection *connection, struct packet_info *
 
 	spin_lock(&connection->epoch_lock);
 	peer_req->epoch = connection->current_epoch;
-	atomic_inc(&peer_req->epoch->epoch_size);
+	atomic_inc_unchecked(&peer_req->epoch->epoch_size);
 	atomic_inc(&peer_req->epoch->active);
 	spin_unlock(&connection->epoch_lock);
 
@@ -2735,7 +2737,7 @@ bool drbd_rs_c_min_rate_throttle(struct drbd_device *device)
 
 	curr_events = (int)part_stat_read(&disk->part0, sectors[0]) +
 		      (int)part_stat_read(&disk->part0, sectors[1]) -
-			atomic_read(&device->rs_sect_ev);
+			atomic_read_unchecked(&device->rs_sect_ev);
 
 	if (atomic_read(&device->ap_actlog_cnt)
 	    || curr_events - device->rs_last_events > 64) {
@@ -2881,7 +2883,7 @@ static int receive_DataRequest(struct drbd_connection *connection, struct packet
 			device->use_csums = true;
 		} else if (pi->cmd == P_OV_REPLY) {
 			/* track progress, we may need to throttle */
-			atomic_add(size >> 9, &device->rs_sect_in);
+			atomic_add_unchecked(size >> 9, &device->rs_sect_in);
 			peer_req->w.cb = w_e_end_ov_reply;
 			dec_rs_pending(device);
 			/* drbd_rs_begin_io done when we sent this request,
@@ -2954,7 +2956,7 @@ static int receive_DataRequest(struct drbd_connection *connection, struct packet
 		goto out_free_e;
 
 submit_for_resync:
-	atomic_add(size >> 9, &device->rs_sect_ev);
+	atomic_add_unchecked(size >> 9, &device->rs_sect_ev);
 
 submit:
 	update_receiver_timing_details(connection, drbd_submit_peer_request);
@@ -4907,7 +4909,7 @@ static int receive_rs_deallocated(struct drbd_connection *connection, struct pac
 		list_add_tail(&peer_req->w.list, &device->sync_ee);
 		spin_unlock_irq(&device->resource->req_lock);
 
-		atomic_add(pi->size >> 9, &device->rs_sect_ev);
+		atomic_add_unchecked(pi->size >> 9, &device->rs_sect_ev);
 		err = drbd_submit_peer_request(device, peer_req, op, 0, DRBD_FAULT_RS_WR);
 
 		if (err) {
@@ -4931,7 +4933,7 @@ static int receive_rs_deallocated(struct drbd_connection *connection, struct pac
 		drbd_send_ack_ex(peer_device, P_NEG_ACK, sector, size, ID_SYNCER);
 	}
 
-	atomic_add(size >> 9, &device->rs_sect_in);
+	atomic_add_unchecked(size >> 9, &device->rs_sect_in);
 
 	return err;
 }
@@ -4940,7 +4942,7 @@ struct data_cmd {
 	int expect_payload;
 	unsigned int pkt_size;
 	int (*fn)(struct drbd_connection *, struct packet_info *);
-};
+} __do_const;
 
 static struct data_cmd drbd_cmd_handler[] = {
 	[P_DATA]	    = { 1, sizeof(struct p_data), receive_Data },
@@ -5068,7 +5070,7 @@ static void conn_disconnect(struct drbd_connection *connection)
 	if (!list_empty(&connection->current_epoch->list))
 		drbd_err(connection, "ASSERTION FAILED: connection->current_epoch->list not empty\n");
 	/* ok, no more ee's on the fly, it is safe to reset the epoch_size */
-	atomic_set(&connection->current_epoch->epoch_size, 0);
+	atomic_set_unchecked(&connection->current_epoch->epoch_size, 0);
 	connection->send.seen_any_write_yet = false;
 
 	drbd_info(connection, "Connection closed\n");
@@ -5574,7 +5576,7 @@ static int got_IsInSync(struct drbd_connection *connection, struct packet_info *
 		put_ldev(device);
 	}
 	dec_rs_pending(device);
-	atomic_add(blksize >> 9, &device->rs_sect_in);
+	atomic_add_unchecked(blksize >> 9, &device->rs_sect_in);
 
 	return 0;
 }
@@ -5825,7 +5827,7 @@ static int got_skip(struct drbd_connection *connection, struct packet_info *pi)
 struct meta_sock_cmd {
 	size_t pkt_size;
 	int (*fn)(struct drbd_connection *connection, struct packet_info *);
-};
+} __do_const;
 
 static void set_rcvtimeo(struct drbd_connection *connection, bool ping_timeout)
 {
diff --git a/drivers/block/drbd/drbd_state.c b/drivers/block/drbd/drbd_state.c
index eea0c4aec..4eba9a882 100644
--- a/drivers/block/drbd/drbd_state.c
+++ b/drivers/block/drbd/drbd_state.c
@@ -1507,9 +1507,10 @@ int drbd_bitmap_io_from_worker(struct drbd_device *device,
 
 void notify_resource_state_change(struct sk_buff *skb,
 				  unsigned int seq,
-				  struct drbd_resource_state_change *resource_state_change,
+				  void *_resource_state_change,
 				  enum drbd_notification_type type)
 {
+	struct drbd_resource_state_change *resource_state_change = _resource_state_change;
 	struct drbd_resource *resource = resource_state_change->resource;
 	struct resource_info resource_info = {
 		.res_role = resource_state_change->role[NEW],
@@ -1523,9 +1524,10 @@ void notify_resource_state_change(struct sk_buff *skb,
 
 void notify_connection_state_change(struct sk_buff *skb,
 				    unsigned int seq,
-				    struct drbd_connection_state_change *connection_state_change,
+				    void *_connection_state_change,
 				    enum drbd_notification_type type)
 {
+	struct drbd_connection_state_change *connection_state_change = _connection_state_change;
 	struct drbd_connection *connection = connection_state_change->connection;
 	struct connection_info connection_info = {
 		.conn_connection_state = connection_state_change->cstate[NEW],
@@ -1537,9 +1539,10 @@ void notify_connection_state_change(struct sk_buff *skb,
 
 void notify_device_state_change(struct sk_buff *skb,
 				unsigned int seq,
-				struct drbd_device_state_change *device_state_change,
+				void *_device_state_change,
 				enum drbd_notification_type type)
 {
+	struct drbd_device_state_change *device_state_change = _device_state_change;
 	struct drbd_device *device = device_state_change->device;
 	struct device_info device_info = {
 		.dev_disk_state = device_state_change->disk_state[NEW],
@@ -1550,9 +1553,10 @@ void notify_device_state_change(struct sk_buff *skb,
 
 void notify_peer_device_state_change(struct sk_buff *skb,
 				     unsigned int seq,
-				     struct drbd_peer_device_state_change *p,
+				     void *_p,
 				     enum drbd_notification_type type)
 {
+	struct drbd_peer_device_state_change *p = _p;
 	struct drbd_peer_device *peer_device = p->peer_device;
 	struct peer_device_info peer_device_info = {
 		.peer_repl_state = p->repl_state[NEW],
diff --git a/drivers/block/drbd/drbd_state.h b/drivers/block/drbd/drbd_state.h
index 6c9d5d4a8..110f64d9e 100644
--- a/drivers/block/drbd/drbd_state.h
+++ b/drivers/block/drbd/drbd_state.h
@@ -126,7 +126,7 @@ extern enum drbd_state_rv _drbd_set_state(struct drbd_device *, union drbd_state
 					  enum chg_state_flags,
 					  struct completion *done);
 extern void print_st_err(struct drbd_device *, union drbd_state,
-			union drbd_state, int);
+			union drbd_state, enum drbd_state_rv);
 
 enum drbd_state_rv
 _conn_request_state(struct drbd_connection *connection, union drbd_state mask, union drbd_state val,
diff --git a/drivers/block/drbd/drbd_state_change.h b/drivers/block/drbd/drbd_state_change.h
index 9e503a1a0..ac6026230 100644
--- a/drivers/block/drbd/drbd_state_change.h
+++ b/drivers/block/drbd/drbd_state_change.h
@@ -45,19 +45,19 @@ extern void forget_state_change(struct drbd_state_change *);
 
 extern void notify_resource_state_change(struct sk_buff *,
 					 unsigned int,
-					 struct drbd_resource_state_change *,
+					 void *,
 					 enum drbd_notification_type type);
 extern void notify_connection_state_change(struct sk_buff *,
 					   unsigned int,
-					   struct drbd_connection_state_change *,
+					   void *,
 					   enum drbd_notification_type type);
 extern void notify_device_state_change(struct sk_buff *,
 				       unsigned int,
-				       struct drbd_device_state_change *,
+				       void *,
 				       enum drbd_notification_type type);
 extern void notify_peer_device_state_change(struct sk_buff *,
 					    unsigned int,
-					    struct drbd_peer_device_state_change *,
+					    void *,
 					    enum drbd_notification_type type);
 
 #endif  /* DRBD_STATE_CHANGE_H */
diff --git a/drivers/block/drbd/drbd_worker.c b/drivers/block/drbd/drbd_worker.c
index c6755c9a0..258629304 100644
--- a/drivers/block/drbd/drbd_worker.c
+++ b/drivers/block/drbd/drbd_worker.c
@@ -87,7 +87,8 @@ void drbd_md_endio(struct bio *bio)
 /* reads on behalf of the partner,
  * "submitted" by the receiver
  */
-static void drbd_endio_read_sec_final(struct drbd_peer_request *peer_req) __releases(local)
+static void drbd_endio_read_sec_final(struct drbd_peer_request *peer_req) __releases(local);
+static void drbd_endio_read_sec_final(struct drbd_peer_request *peer_req)
 {
 	unsigned long flags = 0;
 	struct drbd_peer_device *peer_device = peer_req->peer_device;
@@ -108,7 +109,8 @@ static void drbd_endio_read_sec_final(struct drbd_peer_request *peer_req) __rele
 
 /* writes on behalf of the partner, or resync writes,
  * "submitted" by the receiver, final stage.  */
-void drbd_endio_write_sec_final(struct drbd_peer_request *peer_req) __releases(local)
+void drbd_endio_write_sec_final(struct drbd_peer_request *peer_req) __releases(local);
+void drbd_endio_write_sec_final(struct drbd_peer_request *peer_req)
 {
 	unsigned long flags = 0;
 	struct drbd_peer_device *peer_device = peer_req->peer_device;
@@ -408,7 +410,7 @@ static int read_for_csum(struct drbd_peer_device *peer_device, sector_t sector,
 	list_add_tail(&peer_req->w.list, &device->read_ee);
 	spin_unlock_irq(&device->resource->req_lock);
 
-	atomic_add(size >> 9, &device->rs_sect_ev);
+	atomic_add_unchecked(size >> 9, &device->rs_sect_ev);
 	if (drbd_submit_peer_request(device, peer_req, REQ_OP_READ, 0,
 				     DRBD_FAULT_RS_RD) == 0)
 		return 0;
@@ -554,7 +556,7 @@ static int drbd_rs_number_requests(struct drbd_device *device)
 	unsigned int sect_in;  /* Number of sectors that came in since the last turn */
 	int number, mxb;
 
-	sect_in = atomic_xchg(&device->rs_sect_in, 0);
+	sect_in = atomic_xchg_unchecked(&device->rs_sect_in, 0);
 	device->rs_in_flight -= sect_in;
 
 	rcu_read_lock();
@@ -1662,8 +1664,8 @@ void drbd_rs_controller_reset(struct drbd_device *device)
 	struct gendisk *disk = device->ldev->backing_bdev->bd_contains->bd_disk;
 	struct fifo_buffer *plan;
 
-	atomic_set(&device->rs_sect_in, 0);
-	atomic_set(&device->rs_sect_ev, 0);
+	atomic_set_unchecked(&device->rs_sect_in, 0);
+	atomic_set_unchecked(&device->rs_sect_ev, 0);
 	device->rs_in_flight = 0;
 	device->rs_last_events =
 		(int)part_stat_read(&disk->part0, sectors[0]) +
diff --git a/drivers/block/floppy.c b/drivers/block/floppy.c
index e3d8e4ced..4198ed887 100644
--- a/drivers/block/floppy.c
+++ b/drivers/block/floppy.c
@@ -961,6 +961,10 @@ static void empty(void)
 {
 }
 
+static void empty2(int i)
+{
+}
+
 static void (*floppy_work_fn)(void);
 
 static void floppy_work_workfn(struct work_struct *work)
@@ -1953,14 +1957,14 @@ static const struct cont_t wakeup_cont = {
 	.interrupt	= empty,
 	.redo		= do_wakeup,
 	.error		= empty,
-	.done		= (done_f)empty
+	.done		= empty2
 };
 
 static const struct cont_t intr_cont = {
 	.interrupt	= empty,
 	.redo		= process_fd_request,
 	.error		= empty,
-	.done		= (done_f)empty
+	.done		= empty2
 };
 
 static int wait_til_done(void (*handler)(void), bool interruptible)
diff --git a/drivers/block/pktcdvd.c b/drivers/block/pktcdvd.c
index 90fa4ac14..8328db67e 100644
--- a/drivers/block/pktcdvd.c
+++ b/drivers/block/pktcdvd.c
@@ -109,7 +109,7 @@ static int pkt_seq_show(struct seq_file *m, void *p);
 
 static sector_t get_zone(sector_t sector, struct pktcdvd_device *pd)
 {
-	return (sector + pd->offset) & ~(sector_t)(pd->settings.size - 1);
+	return (sector + pd->offset) & ~(sector_t)(pd->settings.size - 1UL);
 }
 
 /*
@@ -1890,7 +1890,7 @@ static noinline_for_stack int pkt_probe_settings(struct pktcdvd_device *pd)
 		return -EROFS;
 	}
 	pd->settings.fp = ti.fp;
-	pd->offset = (be32_to_cpu(ti.track_start) << 2) & (pd->settings.size - 1);
+	pd->offset = (be32_to_cpu(ti.track_start) << 2) & (pd->settings.size - 1UL);
 
 	if (ti.nwa_v) {
 		pd->nwa = be32_to_cpu(ti.next_writable);
diff --git a/drivers/block/rbd.c b/drivers/block/rbd.c
index 6c6519f64..f5fff9284 100644
--- a/drivers/block/rbd.c
+++ b/drivers/block/rbd.c
@@ -64,7 +64,7 @@
  * If the counter is already at its maximum value returns
  * -EINVAL without updating it.
  */
-static int atomic_inc_return_safe(atomic_t *v)
+static int __intentional_overflow(-1) atomic_inc_return_safe(atomic_t *v)
 {
 	unsigned int counter;
 
diff --git a/drivers/block/smart1,2.h b/drivers/block/smart1,2.h
index e5565fbae..71be10b44 100644
--- a/drivers/block/smart1,2.h
+++ b/drivers/block/smart1,2.h
@@ -108,11 +108,11 @@ static unsigned long smart4_intr_pending(ctlr_info_t *h)
 }
 
 static struct access_method smart4_access = {
-	smart4_submit_command,
-	smart4_intr_mask,
-	smart4_fifo_full,
-	smart4_intr_pending,
-	smart4_completed,
+	.submit_command = smart4_submit_command,
+	.set_intr_mask = smart4_intr_mask,
+	.fifo_full = smart4_fifo_full,
+	.intr_pending = smart4_intr_pending,
+	.command_completed = smart4_completed,
 };
 
 /*
@@ -144,11 +144,11 @@ static unsigned long smart2_intr_pending(ctlr_info_t *h)
 }
 
 static struct access_method smart2_access = {
-	smart2_submit_command,
-	smart2_intr_mask,
-	smart2_fifo_full,
-	smart2_intr_pending,
-	smart2_completed,
+	.submit_command = smart2_submit_command,
+	.set_intr_mask = smart2_intr_mask,
+	.fifo_full = smart2_fifo_full,
+	.intr_pending = smart2_intr_pending,
+	.command_completed = smart2_completed,
 };
 
 /*
@@ -180,11 +180,11 @@ static unsigned long smart2e_intr_pending(ctlr_info_t *h)
 }
 
 static struct access_method smart2e_access = {
-	smart2e_submit_command,
-	smart2e_intr_mask,
-	smart2e_fifo_full,
-	smart2e_intr_pending,
-	smart2e_completed,
+	.submit_command = smart2e_submit_command,
+	.set_intr_mask = smart2e_intr_mask,
+	.fifo_full = smart2e_fifo_full,
+	.intr_pending = smart2e_intr_pending,
+	.command_completed = smart2e_completed,
 };
 
 /*
@@ -270,9 +270,9 @@ static unsigned long smart1_intr_pending(ctlr_info_t *h)
 }
 
 static struct access_method smart1_access = {
-	smart1_submit_command,
-	smart1_intr_mask,
-	smart1_fifo_full,
-	smart1_intr_pending,
-	smart1_completed,
+	.submit_command = smart1_submit_command,
+	.set_intr_mask = smart1_intr_mask,
+	.fifo_full = smart1_fifo_full,
+	.intr_pending = smart1_intr_pending,
+	.command_completed = smart1_completed,
 };
diff --git a/drivers/bluetooth/btwilink.c b/drivers/bluetooth/btwilink.c
index 485281b3f..ab2019853 100644
--- a/drivers/bluetooth/btwilink.c
+++ b/drivers/bluetooth/btwilink.c
@@ -275,7 +275,7 @@ static int ti_st_send_frame(struct hci_dev *hdev, struct sk_buff *skb)
 
 static int bt_ti_probe(struct platform_device *pdev)
 {
-	static struct ti_st *hst;
+	struct ti_st *hst;
 	struct hci_dev *hdev;
 	int err;
 
diff --git a/drivers/bus/arm-cci.c b/drivers/bus/arm-cci.c
index ffa7c9dcb..a68b53e35 100644
--- a/drivers/bus/arm-cci.c
+++ b/drivers/bus/arm-cci.c
@@ -1475,8 +1475,10 @@ static int cci_pmu_init(struct cci_pmu *cci_pmu, struct platform_device *pdev)
 	char *name = model->name;
 	u32 num_cntrs;
 
-	pmu_event_attr_group.attrs = model->event_attrs;
-	pmu_format_attr_group.attrs = model->format_attrs;
+	pax_open_kernel();
+	const_cast(pmu_event_attr_group.attrs) = model->event_attrs;
+	const_cast(pmu_format_attr_group.attrs) = model->format_attrs;
+	pax_close_kernel();
 
 	cci_pmu->pmu = (struct pmu) {
 		.name		= cci_pmu->model->name,
diff --git a/drivers/cdrom/cdrom.c b/drivers/cdrom/cdrom.c
index 5d475b3a0..e9076c029 100644
--- a/drivers/cdrom/cdrom.c
+++ b/drivers/cdrom/cdrom.c
@@ -610,7 +610,6 @@ int register_cdrom(struct cdrom_device_info *cdi)
 	ENSURE(reset, CDC_RESET);
 	ENSURE(generic_packet, CDC_GENERIC_PACKET);
 	cdi->mc_flags = 0;
-	cdo->n_minors = 0;
 	cdi->options = CDO_USE_FFLAGS;
 
 	if (autoclose == 1 && CDROM_CAN(CDC_CLOSE_TRAY))
@@ -630,8 +629,11 @@ int register_cdrom(struct cdrom_device_info *cdi)
 	else
 		cdi->cdda_method = CDDA_OLD;
 
-	if (!cdo->generic_packet)
-		cdo->generic_packet = cdrom_dummy_generic_packet;
+	if (!cdo->generic_packet) {
+		pax_open_kernel();
+		const_cast(cdo->generic_packet) = cdrom_dummy_generic_packet;
+		pax_close_kernel();
+	}
 
 	cd_dbg(CD_REG_UNREG, "drive \"/dev/%s\" registered\n", cdi->name);
 	mutex_lock(&cdrom_mutex);
@@ -652,7 +654,6 @@ void unregister_cdrom(struct cdrom_device_info *cdi)
 	if (cdi->exit)
 		cdi->exit(cdi);
 
-	cdi->ops->n_minors--;
 	cd_dbg(CD_REG_UNREG, "drive \"/dev/%s\" unregistered\n", cdi->name);
 }
 
@@ -2137,7 +2138,7 @@ static int cdrom_read_cdda_old(struct cdrom_device_info *cdi, __u8 __user *ubuf,
 	 */
 	nr = nframes;
 	do {
-		cgc.buffer = kmalloc(CD_FRAMESIZE_RAW * nr, GFP_KERNEL);
+		cgc.buffer = kcalloc(nr, CD_FRAMESIZE_RAW, GFP_KERNEL);
 		if (cgc.buffer)
 			break;
 
@@ -3441,7 +3442,7 @@ static int cdrom_print_info(const char *header, int val, char *info,
 	struct cdrom_device_info *cdi;
 	int ret;
 
-	ret = scnprintf(info + *pos, max_size - *pos, header);
+	ret = scnprintf(info + *pos, max_size - *pos, "%s", header);
 	if (!ret)
 		return 1;
 
diff --git a/drivers/cdrom/gdrom.c b/drivers/cdrom/gdrom.c
index 584bc3126..e64a12cb4 100644
--- a/drivers/cdrom/gdrom.c
+++ b/drivers/cdrom/gdrom.c
@@ -491,7 +491,6 @@ static struct cdrom_device_ops gdrom_ops = {
 	.audio_ioctl		= gdrom_audio_ioctl,
 	.capability		= CDC_MULTI_SESSION | CDC_MEDIA_CHANGED |
 				  CDC_RESET | CDC_DRIVE_STATUS | CDC_CD_R,
-	.n_minors		= 1,
 };
 
 static int gdrom_bdops_open(struct block_device *bdev, fmode_t mode)
diff --git a/drivers/char/Kconfig b/drivers/char/Kconfig
index dcc09739a..8d34c8839 100644
--- a/drivers/char/Kconfig
+++ b/drivers/char/Kconfig
@@ -17,7 +17,8 @@ config DEVMEM
 
 config DEVKMEM
 	bool "/dev/kmem virtual device support"
-	default y
+	default n
+	depends on !GRKERNSEC_KMEM
 	help
 	  Say Y here if you want to support the /dev/kmem device. The
 	  /dev/kmem device is rarely used, but can be used for certain
@@ -573,6 +574,7 @@ config TELCLOCK
 config DEVPORT
 	bool
 	depends on ISA || PCI
+	depends on !GRKERNSEC_KMEM
 	default y
 
 source "drivers/s390/char/Kconfig"
diff --git a/drivers/char/agp/compat_ioctl.c b/drivers/char/agp/compat_ioctl.c
index a48e05b31..6bac83173 100644
--- a/drivers/char/agp/compat_ioctl.c
+++ b/drivers/char/agp/compat_ioctl.c
@@ -108,7 +108,7 @@ static int compat_agpioc_reserve_wrap(struct agp_file_private *priv, void __user
 			return -ENOMEM;
 		}
 
-		if (copy_from_user(usegment, (void __user *) ureserve.seg_list,
+		if (copy_from_user(usegment, (void __force_user *) ureserve.seg_list,
 				   sizeof(*usegment) * ureserve.seg_count)) {
 			kfree(usegment);
 			kfree(ksegment);
diff --git a/drivers/char/agp/frontend.c b/drivers/char/agp/frontend.c
index 0f64d149c..4cf4d6b94 100644
--- a/drivers/char/agp/frontend.c
+++ b/drivers/char/agp/frontend.c
@@ -806,7 +806,7 @@ static int agpioc_reserve_wrap(struct agp_file_private *priv, void __user *arg)
 	if (copy_from_user(&reserve, arg, sizeof(struct agp_region)))
 		return -EFAULT;
 
-	if ((unsigned) reserve.seg_count >= ~0U/sizeof(struct agp_segment))
+	if ((unsigned) reserve.seg_count >= ~0U/sizeof(struct agp_segment_priv))
 		return -EFAULT;
 
 	client = agp_find_client_by_pid(reserve.pid);
@@ -836,7 +836,7 @@ static int agpioc_reserve_wrap(struct agp_file_private *priv, void __user *arg)
 		if (segment == NULL)
 			return -ENOMEM;
 
-		if (copy_from_user(segment, (void __user *) reserve.seg_list,
+		if (copy_from_user(segment, (void __force_user *) reserve.seg_list,
 				   sizeof(struct agp_segment) * reserve.seg_count)) {
 			kfree(segment);
 			return -EFAULT;
diff --git a/drivers/char/agp/intel-gtt.c b/drivers/char/agp/intel-gtt.c
index 0f7d28a98..d8576c688 100644
--- a/drivers/char/agp/intel-gtt.c
+++ b/drivers/char/agp/intel-gtt.c
@@ -1420,8 +1420,8 @@ int intel_gmch_probe(struct pci_dev *bridge_pdev, struct pci_dev *gpu_pdev,
 }
 EXPORT_SYMBOL(intel_gmch_probe);
 
-void intel_gtt_get(u64 *gtt_total, size_t *stolen_size,
-		   phys_addr_t *mappable_base, u64 *mappable_end)
+void intel_gtt_get(u64 *gtt_total, u64 *stolen_size,
+		   u64 *mappable_base, u64 *mappable_end)
 {
 	*gtt_total = intel_private.gtt_total_entries << PAGE_SHIFT;
 	*stolen_size = intel_private.stolen_size;
diff --git a/drivers/char/hpet.c b/drivers/char/hpet.c
index be54e5331..50272fe81 100644
--- a/drivers/char/hpet.c
+++ b/drivers/char/hpet.c
@@ -574,7 +574,7 @@ static inline unsigned long hpet_time_div(struct hpets *hpets,
 }
 
 static int
-hpet_ioctl_common(struct hpet_dev *devp, int cmd, unsigned long arg,
+hpet_ioctl_common(struct hpet_dev *devp, unsigned int cmd, unsigned long arg,
 		  struct hpet_info *info)
 {
 	struct hpet_timer __iomem *timer;
diff --git a/drivers/char/ipmi/ipmi_msghandler.c b/drivers/char/ipmi/ipmi_msghandler.c
index d8619998c..445da20b9 100644
--- a/drivers/char/ipmi/ipmi_msghandler.c
+++ b/drivers/char/ipmi/ipmi_msghandler.c
@@ -436,7 +436,7 @@ struct ipmi_smi {
 	struct proc_dir_entry *proc_dir;
 	char                  proc_dir_name[10];
 
-	atomic_t stats[IPMI_NUM_STATS];
+	atomic_unchecked_t stats[IPMI_NUM_STATS];
 
 	/*
 	 * run_to_completion duplicate of smb_info, smi_info
@@ -468,9 +468,9 @@ static LIST_HEAD(smi_watchers);
 static DEFINE_MUTEX(smi_watchers_mutex);
 
 #define ipmi_inc_stat(intf, stat) \
-	atomic_inc(&(intf)->stats[IPMI_STAT_ ## stat])
+	atomic_inc_unchecked(&(intf)->stats[IPMI_STAT_ ## stat])
 #define ipmi_get_stat(intf, stat) \
-	((unsigned int) atomic_read(&(intf)->stats[IPMI_STAT_ ## stat]))
+	((unsigned int) atomic_read_unchecked(&(intf)->stats[IPMI_STAT_ ## stat]))
 
 static const char * const addr_src_to_str[] = {
 	"invalid", "hotmod", "hardcoded", "SPMI", "ACPI", "SMBIOS", "PCI",
@@ -2835,7 +2835,7 @@ int ipmi_register_smi(const struct ipmi_smi_handlers *handlers,
 	INIT_LIST_HEAD(&intf->cmd_rcvrs);
 	init_waitqueue_head(&intf->waitq);
 	for (i = 0; i < IPMI_NUM_STATS; i++)
-		atomic_set(&intf->stats[i], 0);
+		atomic_set_unchecked(&intf->stats[i], 0);
 
 	intf->proc_dir = NULL;
 
diff --git a/drivers/char/ipmi/ipmi_poweroff.c b/drivers/char/ipmi/ipmi_poweroff.c
index 9f2e3be2c..676c910e9 100644
--- a/drivers/char/ipmi/ipmi_poweroff.c
+++ b/drivers/char/ipmi/ipmi_poweroff.c
@@ -66,7 +66,7 @@ static void (*specific_poweroff_func)(ipmi_user_t user);
 /* Holds the old poweroff function so we can restore it on removal. */
 static void (*old_poweroff_func)(void);
 
-static int set_param_ifnum(const char *val, struct kernel_param *kp)
+static int set_param_ifnum(const char *val, const struct kernel_param *kp)
 {
 	int rv = param_set_int(val, kp);
 	if (rv)
diff --git a/drivers/char/ipmi/ipmi_si_intf.c b/drivers/char/ipmi/ipmi_si_intf.c
index a112c0146..5bd9d252e 100644
--- a/drivers/char/ipmi/ipmi_si_intf.c
+++ b/drivers/char/ipmi/ipmi_si_intf.c
@@ -302,7 +302,7 @@ struct smi_info {
 	unsigned char slave_addr;
 
 	/* Counters and things for the proc filesystem. */
-	atomic_t stats[SI_NUM_STATS];
+	atomic_unchecked_t stats[SI_NUM_STATS];
 
 	struct task_struct *thread;
 
@@ -311,9 +311,9 @@ struct smi_info {
 };
 
 #define smi_inc_stat(smi, stat) \
-	atomic_inc(&(smi)->stats[SI_STAT_ ## stat])
+	atomic_inc_unchecked(&(smi)->stats[SI_STAT_ ## stat])
 #define smi_get_stat(smi, stat) \
-	((unsigned int) atomic_read(&(smi)->stats[SI_STAT_ ## stat]))
+	((unsigned int) atomic_read_unchecked(&(smi)->stats[SI_STAT_ ## stat]))
 
 #define SI_MAX_PARMS 4
 
@@ -1344,7 +1344,7 @@ static unsigned int num_slave_addrs;
 #define IPMI_MEM_ADDR_SPACE 1
 static const char * const addr_space_to_str[] = { "i/o", "mem" };
 
-static int hotmod_handler(const char *val, struct kernel_param *kp);
+static int hotmod_handler(const char *val, const struct kernel_param *kp);
 
 module_param_call(hotmod, hotmod_handler, NULL, NULL, 0200);
 MODULE_PARM_DESC(hotmod, "Add and remove interfaces.  See"
@@ -1814,7 +1814,7 @@ static struct smi_info *smi_info_alloc(void)
 	return info;
 }
 
-static int hotmod_handler(const char *val, struct kernel_param *kp)
+static int hotmod_handler(const char *val, const struct kernel_param *kp)
 {
 	char *str = kstrdup(val, GFP_KERNEL);
 	int  rv;
@@ -3578,7 +3578,7 @@ static int try_smi_init(struct smi_info *new_smi)
 	atomic_set(&new_smi->req_events, 0);
 	new_smi->run_to_completion = false;
 	for (i = 0; i < SI_NUM_STATS; i++)
-		atomic_set(&new_smi->stats[i], 0);
+		atomic_set_unchecked(&new_smi->stats[i], 0);
 
 	new_smi->interrupt_disabled = true;
 	atomic_set(&new_smi->need_watch, 0);
diff --git a/drivers/char/ipmi/ipmi_ssif.c b/drivers/char/ipmi/ipmi_ssif.c
index 5673ffff0..3ab29080b 100644
--- a/drivers/char/ipmi/ipmi_ssif.c
+++ b/drivers/char/ipmi/ipmi_ssif.c
@@ -284,17 +284,17 @@ struct ssif_info {
 	unsigned int  multi_len;
 	unsigned int  multi_pos;
 
-	atomic_t stats[SSIF_NUM_STATS];
+	atomic_unchecked_t stats[SSIF_NUM_STATS];
 };
 
 #define ssif_inc_stat(ssif, stat) \
-	atomic_inc(&(ssif)->stats[SSIF_STAT_ ## stat])
+	atomic_inc_unchecked(&(ssif)->stats[SSIF_STAT_ ## stat])
 #define ssif_get_stat(ssif, stat) \
-	((unsigned int) atomic_read(&(ssif)->stats[SSIF_STAT_ ## stat]))
+	((unsigned int) atomic_read_unchecked(&(ssif)->stats[SSIF_STAT_ ## stat]))
 
 static bool initialized;
 
-static atomic_t next_intf = ATOMIC_INIT(0);
+static atomic_unchecked_t next_intf = ATOMIC_INIT(0);
 
 static void return_hosed_msg(struct ssif_info *ssif_info,
 			     struct ipmi_smi_msg *msg);
@@ -1608,7 +1608,7 @@ static int ssif_probe(struct i2c_client *client, const struct i2c_device_id *id)
 	}
 
  found:
-	ssif_info->intf_num = atomic_inc_return(&next_intf);
+	ssif_info->intf_num = atomic_inc_return_unchecked(&next_intf);
 
 	if (ssif_dbg_probe) {
 		pr_info("ssif_probe: i2c_probe found device at i2c address %x\n",
@@ -1622,7 +1622,7 @@ static int ssif_probe(struct i2c_client *client, const struct i2c_device_id *id)
 	ssif_info->retry_timer.function = retry_timeout;
 
 	for (i = 0; i < SSIF_NUM_STATS; i++)
-		atomic_set(&ssif_info->stats[i], 0);
+		atomic_set_unchecked(&ssif_info->stats[i], 0);
 
 	if (ssif_info->supports_pec)
 		ssif_info->client->flags |= I2C_CLIENT_PEC;
diff --git a/drivers/char/mem.c b/drivers/char/mem.c
index a33163dbb..43c157881 100644
--- a/drivers/char/mem.c
+++ b/drivers/char/mem.c
@@ -18,6 +18,7 @@
 #include <linux/raw.h>
 #include <linux/tty.h>
 #include <linux/capability.h>
+#include <linux/security.h>
 #include <linux/ptrace.h>
 #include <linux/device.h>
 #include <linux/highmem.h>
@@ -37,6 +38,10 @@
 
 #define DEVPORT_MINOR	4
 
+#if defined(CONFIG_GRKERNSEC) && !defined(CONFIG_GRKERNSEC_NO_RBAC)
+extern const struct file_operations grsec_fops;
+#endif
+
 static inline unsigned long size_inside_page(unsigned long start,
 					     unsigned long size)
 {
@@ -67,13 +72,22 @@ static inline int range_is_allowed(unsigned long pfn, unsigned long size)
 	u64 cursor = from;
 
 	while (cursor < to) {
-		if (!devmem_is_allowed(pfn))
+		if (!devmem_is_allowed(pfn)) {
+#ifdef CONFIG_GRKERNSEC_KMEM
+			gr_handle_mem_readwrite(from, to);
+#endif
 			return 0;
+		}
 		cursor += PAGE_SIZE;
 		pfn++;
 	}
 	return 1;
 }
+#elif defined(CONFIG_GRKERNSEC_KMEM)
+static inline int range_is_allowed(unsigned long pfn, unsigned long size)
+{
+	return 0;
+}
 #else
 static inline int range_is_allowed(unsigned long pfn, unsigned long size)
 {
@@ -98,6 +112,7 @@ static ssize_t read_mem(struct file *file, char __user *buf,
 	phys_addr_t p = *ppos;
 	ssize_t read, sz;
 	void *ptr;
+	char *temp;
 
 	if (p != *ppos)
 		return 0;
@@ -120,13 +135,19 @@ static ssize_t read_mem(struct file *file, char __user *buf,
 	}
 #endif
 
+	temp = kmalloc(PAGE_SIZE, GFP_KERNEL|GFP_USERCOPY);
+	if (!temp)
+		return -ENOMEM;
+
 	while (count > 0) {
 		unsigned long remaining;
 
 		sz = size_inside_page(p, count);
 
-		if (!range_is_allowed(p >> PAGE_SHIFT, count))
+		if (!range_is_allowed(p >> PAGE_SHIFT, count)) {
+			kfree(temp);
 			return -EPERM;
+		}
 
 		/*
 		 * On ia64 if a page has been mapped somewhere as uncached, then
@@ -134,13 +155,17 @@ static ssize_t read_mem(struct file *file, char __user *buf,
 		 * corruption may occur.
 		 */
 		ptr = xlate_dev_mem_ptr(p);
-		if (!ptr)
+		if (!ptr || probe_kernel_read(temp, ptr, sz)) {
+			kfree(temp);
 			return -EFAULT;
+		}
 
-		remaining = copy_to_user(buf, ptr, sz);
+		remaining = copy_to_user(buf, temp, sz);
 		unxlate_dev_mem_ptr(p, ptr);
-		if (remaining)
+		if (remaining) {
+			kfree(temp);
 			return -EFAULT;
+		}
 
 		buf += sz;
 		p += sz;
@@ -148,6 +173,8 @@ static ssize_t read_mem(struct file *file, char __user *buf,
 		read += sz;
 	}
 
+	kfree(temp);
+
 	*ppos += read;
 	return read;
 }
@@ -383,6 +410,8 @@ static ssize_t read_kmem(struct file *file, char __user *buf,
 
 	read = 0;
 	if (p < (unsigned long) high_memory) {
+		char *temp;
+
 		low_count = count;
 		if (count > (unsigned long)high_memory - p)
 			low_count = (unsigned long)high_memory - p;
@@ -400,6 +429,11 @@ static ssize_t read_kmem(struct file *file, char __user *buf,
 			count -= sz;
 		}
 #endif
+
+		temp = kmalloc(PAGE_SIZE, GFP_KERNEL|GFP_USERCOPY);
+		if (!temp)
+			return -ENOMEM;
+
 		while (low_count > 0) {
 			sz = size_inside_page(p, low_count);
 
@@ -410,14 +444,18 @@ static ssize_t read_kmem(struct file *file, char __user *buf,
 			 */
 			kbuf = xlate_dev_kmem_ptr((void *)p);
 
-			if (copy_to_user(buf, kbuf, sz))
+			if (probe_kernel_read(temp, kbuf, sz) || copy_to_user(buf, temp, sz)) {
+				kfree(temp);
 				return -EFAULT;
+			}
 			buf += sz;
 			p += sz;
 			read += sz;
 			low_count -= sz;
 			count -= sz;
 		}
+
+		kfree(temp);
 	}
 
 	if (count > 0) {
@@ -822,6 +860,9 @@ static const struct memdev {
 #ifdef CONFIG_PRINTK
 	[11] = { "kmsg", 0644, &kmsg_fops, 0 },
 #endif
+#if defined(CONFIG_GRKERNSEC) && !defined(CONFIG_GRKERNSEC_NO_RBAC)
+	[13] = { "grsec",S_IRUSR | S_IWUGO, &grsec_fops, 0 },
+#endif
 };
 
 static int memory_open(struct inode *inode, struct file *filp)
@@ -883,7 +924,7 @@ static int __init chr_dev_init(void)
 			continue;
 
 		device_create(mem_class, NULL, MKDEV(MEM_MAJOR, minor),
-			      NULL, devlist[minor].name);
+			      NULL, "%s", devlist[minor].name);
 	}
 
 	return tty_init();
diff --git a/drivers/char/nvram.c b/drivers/char/nvram.c
index 678fa97e4..5598cef80 100644
--- a/drivers/char/nvram.c
+++ b/drivers/char/nvram.c
@@ -235,7 +235,7 @@ static ssize_t nvram_read(struct file *file, char __user *buf,
 
 	spin_unlock_irq(&rtc_lock);
 
-	if (copy_to_user(buf, contents, tmp - contents))
+	if (tmp - contents > sizeof(contents) || copy_to_user(buf, contents, tmp - contents))
 		return -EFAULT;
 
 	*ppos = i;
diff --git a/drivers/char/pcmcia/synclink_cs.c b/drivers/char/pcmcia/synclink_cs.c
index d28922df0..3c343d6ec 100644
--- a/drivers/char/pcmcia/synclink_cs.c
+++ b/drivers/char/pcmcia/synclink_cs.c
@@ -2333,7 +2333,7 @@ static void mgslpc_close(struct tty_struct *tty, struct file * filp)
 
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgslpc_close(%s) entry, count=%d\n",
-			 __FILE__, __LINE__, info->device_name, port->count);
+			 __FILE__, __LINE__, info->device_name, atomic_read(&port->count));
 
 	if (tty_port_close_start(port, tty, filp) == 0)
 		goto cleanup;
@@ -2351,7 +2351,7 @@ static void mgslpc_close(struct tty_struct *tty, struct file * filp)
 cleanup:
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgslpc_close(%s) exit, count=%d\n", __FILE__, __LINE__,
-			tty->driver->name, port->count);
+			tty->driver->name, atomic_read(&port->count));
 }
 
 /* Wait until the transmitter is empty.
@@ -2493,7 +2493,7 @@ static int mgslpc_open(struct tty_struct *tty, struct file * filp)
 
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgslpc_open(%s), old ref count = %d\n",
-			 __FILE__, __LINE__, tty->driver->name, port->count);
+			 __FILE__, __LINE__, tty->driver->name, atomic_read(&port->count));
 
 	port->low_latency = (port->flags & ASYNC_LOW_LATENCY) ? 1 : 0;
 
@@ -2504,11 +2504,11 @@ static int mgslpc_open(struct tty_struct *tty, struct file * filp)
 		goto cleanup;
 	}
 	spin_lock(&port->lock);
-	port->count++;
+	atomic_inc(&port->count);
 	spin_unlock(&port->lock);
 	spin_unlock_irqrestore(&info->netlock, flags);
 
-	if (port->count == 1) {
+	if (atomic_read(&port->count) == 1) {
 		/* 1st open on this device, init hardware */
 		retval = startup(info, tty);
 		if (retval < 0)
@@ -3897,7 +3897,7 @@ static int hdlcdev_attach(struct net_device *dev, unsigned short encoding,
 	unsigned short new_crctype;
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	switch (encoding)
@@ -4001,7 +4001,7 @@ static int hdlcdev_open(struct net_device *dev)
 
 	/* arbitrate between network and tty opens */
 	spin_lock_irqsave(&info->netlock, flags);
-	if (info->port.count != 0 || info->netcount != 0) {
+	if (atomic_read(&info->port.count) != 0 || info->netcount != 0) {
 		printk(KERN_WARNING "%s: hdlc_open returning busy\n", dev->name);
 		spin_unlock_irqrestore(&info->netlock, flags);
 		return -EBUSY;
@@ -4091,7 +4091,7 @@ static int hdlcdev_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
 		printk("%s:hdlcdev_ioctl(%s)\n", __FILE__, dev->name);
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	if (cmd != SIOCWANDEV)
diff --git a/drivers/char/random.c b/drivers/char/random.c
index 3efb3bf0a..254139891 100644
--- a/drivers/char/random.c
+++ b/drivers/char/random.c
@@ -292,9 +292,6 @@
 /*
  * To allow fractional bits to be tracked, the entropy_count field is
  * denominated in units of 1/8th bits.
- *
- * 2*(ENTROPY_SHIFT + log2(poolbits)) must <= 31, or the multiply in
- * credit_entropy_bits() needs to be 64 bits wide.
  */
 #define ENTROPY_SHIFT 3
 #define ENTROPY_BITS(r) ((r)->entropy_count >> ENTROPY_SHIFT)
@@ -479,8 +476,8 @@ static ssize_t _extract_entropy(struct entropy_store *r, void *buf,
 
 static void crng_reseed(struct crng_state *crng, struct entropy_store *r);
 static void push_to_pool(struct work_struct *work);
-static __u32 input_pool_data[INPUT_POOL_WORDS];
-static __u32 blocking_pool_data[OUTPUT_POOL_WORDS];
+static __u32 input_pool_data[INPUT_POOL_WORDS] __latent_entropy;
+static __u32 blocking_pool_data[OUTPUT_POOL_WORDS] __latent_entropy;
 
 static struct entropy_store input_pool = {
 	.poolinfo = &poolinfo_table[0],
@@ -680,7 +677,7 @@ retry:
 		/* The +2 corresponds to the /4 in the denominator */
 
 		do {
-			unsigned int anfrac = min(pnfrac, pool_size/2);
+			u64 anfrac = min(pnfrac, pool_size/2);
 			unsigned int add =
 				((pool_size - entropy_count)*anfrac*3) >> s;
 
@@ -1476,7 +1473,7 @@ static ssize_t extract_entropy_user(struct entropy_store *r, void __user *buf,
 
 		extract_buf(r, tmp);
 		i = min_t(int, nbytes, EXTRACT_SIZE);
-		if (copy_to_user(buf, tmp, i)) {
+		if (i > sizeof(tmp) || copy_to_user(buf, tmp, i)) {
 			ret = -EFAULT;
 			break;
 		}
@@ -1926,7 +1923,7 @@ static char sysctl_bootid[16];
 static int proc_do_uuid(struct ctl_table *table, int write,
 			void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table fake_table;
+	ctl_table_no_const fake_table;
 	unsigned char buf[64], tmp_uuid[16], *uuid;
 
 	uuid = table->data;
@@ -1956,7 +1953,7 @@ static int proc_do_uuid(struct ctl_table *table, int write,
 static int proc_do_entropy(struct ctl_table *table, int write,
 			   void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table fake_table;
+	ctl_table_no_const fake_table;
 	int entropy_count;
 
 	entropy_count = *(int *)table->data >> ENTROPY_SHIFT;
diff --git a/drivers/char/sonypi.c b/drivers/char/sonypi.c
index e496daefe..3db53b6c9 100644
--- a/drivers/char/sonypi.c
+++ b/drivers/char/sonypi.c
@@ -54,6 +54,7 @@
 
 #include <asm/uaccess.h>
 #include <asm/io.h>
+#include <asm/local.h>
 
 #include <linux/sonypi.h>
 
@@ -490,7 +491,7 @@ static struct sonypi_device {
 	spinlock_t fifo_lock;
 	wait_queue_head_t fifo_proc_list;
 	struct fasync_struct *fifo_async;
-	int open_count;
+	local_t open_count;
 	int model;
 	struct input_dev *input_jog_dev;
 	struct input_dev *input_key_dev;
@@ -892,7 +893,7 @@ static int sonypi_misc_fasync(int fd, struct file *filp, int on)
 static int sonypi_misc_release(struct inode *inode, struct file *file)
 {
 	mutex_lock(&sonypi_device.lock);
-	sonypi_device.open_count--;
+	local_dec(&sonypi_device.open_count);
 	mutex_unlock(&sonypi_device.lock);
 	return 0;
 }
@@ -901,9 +902,9 @@ static int sonypi_misc_open(struct inode *inode, struct file *file)
 {
 	mutex_lock(&sonypi_device.lock);
 	/* Flush input queue on first open */
-	if (!sonypi_device.open_count)
+	if (!local_read(&sonypi_device.open_count))
 		kfifo_reset(&sonypi_device.fifo);
-	sonypi_device.open_count++;
+	local_inc(&sonypi_device.open_count);
 	mutex_unlock(&sonypi_device.lock);
 
 	return 0;
@@ -1491,7 +1492,7 @@ static struct platform_driver sonypi_driver = {
 
 static struct platform_device *sonypi_platform_device;
 
-static struct dmi_system_id __initdata sonypi_dmi_table[] = {
+static const struct dmi_system_id __initconst sonypi_dmi_table[] = {
 	{
 		.ident = "Sony Vaio",
 		.matches = {
diff --git a/drivers/char/tpm/tpm-chip.c b/drivers/char/tpm/tpm-chip.c
index e5950131b..9653af258 100644
--- a/drivers/char/tpm/tpm-chip.c
+++ b/drivers/char/tpm/tpm-chip.c
@@ -196,6 +196,11 @@ out:
 }
 EXPORT_SYMBOL_GPL(tpm_chip_alloc);
 
+static void tpm_put_device(void *dev)
+{
+	put_device(dev);
+}
+
 /**
  * tpmm_chip_alloc() - allocate a new struct tpm_chip instance
  * @pdev: parent device to which the chip is associated
@@ -213,9 +218,7 @@ struct tpm_chip *tpmm_chip_alloc(struct device *pdev,
 	if (IS_ERR(chip))
 		return chip;
 
-	rc = devm_add_action_or_reset(pdev,
-				      (void (*)(void *)) put_device,
-				      &chip->dev);
+	rc = devm_add_action_or_reset(pdev, tpm_put_device, &chip->dev);
 	if (rc)
 		return ERR_PTR(rc);
 
diff --git a/drivers/char/tpm/tpm_acpi.c b/drivers/char/tpm/tpm_acpi.c
index 565a9478c..dcdc06e5c 100644
--- a/drivers/char/tpm/tpm_acpi.c
+++ b/drivers/char/tpm/tpm_acpi.c
@@ -98,11 +98,12 @@ int read_log(struct tpm_bios_log *log)
 	virt = acpi_os_map_iomem(start, len);
 	if (!virt) {
 		kfree(log->bios_event_log);
+		log->bios_event_log = NULL;
 		printk("%s: ERROR - Unable to map memory\n", __func__);
 		return -EIO;
 	}
 
-	memcpy_fromio(log->bios_event_log, virt, len);
+	memcpy_fromio(log->bios_event_log, (const char __force_kernel *)virt, len);
 
 	acpi_os_unmap_iomem(virt, len);
 	return 0;
diff --git a/drivers/char/tpm/tpm_eventlog.c b/drivers/char/tpm/tpm_eventlog.c
index e72288632..78a48b992 100644
--- a/drivers/char/tpm/tpm_eventlog.c
+++ b/drivers/char/tpm/tpm_eventlog.c
@@ -108,8 +108,7 @@ static void *tpm_bios_measurements_start(struct seq_file *m, loff_t *pos)
 	converted_event_type = do_endian_conversion(event->event_type);
 
 	if (((converted_event_type == 0) && (converted_event_size == 0))
-	    || ((addr + sizeof(struct tcpa_event) + converted_event_size)
-		>= limit))
+	    || (converted_event_size >= limit - addr - sizeof(struct tcpa_event)))
 		return NULL;
 
 	return addr;
@@ -138,7 +137,7 @@ static void *tpm_bios_measurements_next(struct seq_file *m, void *v,
 	converted_event_type = do_endian_conversion(event->event_type);
 
 	if (((converted_event_type == 0) && (converted_event_size == 0)) ||
-	    ((v + sizeof(struct tcpa_event) + converted_event_size) >= limit))
+	    (converted_event_size >= limit - v - sizeof(struct tcpa_event)))
 		return NULL;
 
 	(*pos)++;
diff --git a/drivers/char/virtio_console.c b/drivers/char/virtio_console.c
index 4aae0d27e..3d84db8a8 100644
--- a/drivers/char/virtio_console.c
+++ b/drivers/char/virtio_console.c
@@ -692,11 +692,11 @@ static ssize_t fill_readbuf(struct port *port, char __user *out_buf,
 	if (to_user) {
 		ssize_t ret;
 
-		ret = copy_to_user(out_buf, buf->buf + buf->offset, out_count);
+		ret = copy_to_user((char __force_user *)out_buf, buf->buf + buf->offset, out_count);
 		if (ret)
 			return -EFAULT;
 	} else {
-		memcpy((__force char *)out_buf, buf->buf + buf->offset,
+		memcpy((__force_kernel char *)out_buf, buf->buf + buf->offset,
 		       out_count);
 	}
 
@@ -1171,7 +1171,7 @@ static int get_chars(u32 vtermno, char *buf, int count)
 	/* If we don't have an input queue yet, we can't get input. */
 	BUG_ON(!port->in_vq);
 
-	return fill_readbuf(port, (__force char __user *)buf, count, false);
+	return fill_readbuf(port, (char __force_user *)buf, count, false);
 }
 
 static void resize_console(struct port *port)
diff --git a/drivers/clk/bcm/clk-bcm2835.c b/drivers/clk/bcm/clk-bcm2835.c
index 3250694fd..ab0e01e97 100644
--- a/drivers/clk/bcm/clk-bcm2835.c
+++ b/drivers/clk/bcm/clk-bcm2835.c
@@ -1147,8 +1147,9 @@ static const struct clk_ops bcm2835_vpu_clock_clk_ops = {
 };
 
 static struct clk *bcm2835_register_pll(struct bcm2835_cprman *cprman,
-					const struct bcm2835_pll_data *data)
+					const void *_data)
 {
+	const struct bcm2835_pll_data *data = _data;
 	struct bcm2835_pll *pll;
 	struct clk_init_data init;
 
@@ -1174,8 +1175,9 @@ static struct clk *bcm2835_register_pll(struct bcm2835_cprman *cprman,
 
 static struct clk *
 bcm2835_register_pll_divider(struct bcm2835_cprman *cprman,
-			     const struct bcm2835_pll_divider_data *data)
+			     const void *_data)
 {
+	const struct bcm2835_pll_divider_data *data = _data;
 	struct bcm2835_pll_divider *divider;
 	struct clk_init_data init;
 	struct clk *clk;
@@ -1233,8 +1235,9 @@ bcm2835_register_pll_divider(struct bcm2835_cprman *cprman,
 }
 
 static struct clk *bcm2835_register_clock(struct bcm2835_cprman *cprman,
-					  const struct bcm2835_clock_data *data)
+					  const void *_data)
 {
+	const struct bcm2835_clock_data *data = _data;
 	struct bcm2835_clock *clock;
 	struct clk_init_data init;
 	const char *parents[1 << CM_SRC_BITS];
@@ -1276,8 +1279,10 @@ static struct clk *bcm2835_register_clock(struct bcm2835_cprman *cprman,
 }
 
 static struct clk *bcm2835_register_gate(struct bcm2835_cprman *cprman,
-					 const struct bcm2835_gate_data *data)
+					 const void *_data)
 {
+	const struct bcm2835_gate_data *data = _data;
+
 	return clk_register_gate(cprman->dev, data->name, data->parent,
 				 CLK_IGNORE_UNUSED | CLK_SET_RATE_GATE,
 				 cprman->regs + data->ctl_reg,
@@ -1292,8 +1297,7 @@ struct bcm2835_clk_desc {
 };
 
 /* assignment helper macros for different clock types */
-#define _REGISTER(f, ...) { .clk_register = (bcm2835_clk_register)f, \
-			    .data = __VA_ARGS__ }
+#define _REGISTER(f, ...) { .clk_register = f, .data = __VA_ARGS__ }
 #define REGISTER_PLL(...)	_REGISTER(&bcm2835_register_pll,	\
 					  &(struct bcm2835_pll_data)	\
 					  {__VA_ARGS__})
diff --git a/drivers/clk/clk-composite.c b/drivers/clk/clk-composite.c
index 00269de2f..3e17e606a 100644
--- a/drivers/clk/clk-composite.c
+++ b/drivers/clk/clk-composite.c
@@ -221,7 +221,7 @@ struct clk_hw *clk_hw_register_composite(struct device *dev, const char *name,
 	struct clk_hw *hw;
 	struct clk_init_data init;
 	struct clk_composite *composite;
-	struct clk_ops *clk_composite_ops;
+	clk_ops_no_const *clk_composite_ops;
 	int ret;
 
 	composite = kzalloc(sizeof(*composite), GFP_KERNEL);
diff --git a/drivers/clk/socfpga/clk-gate-a10.c b/drivers/clk/socfpga/clk-gate-a10.c
index c2d572748..1a305dbab 100644
--- a/drivers/clk/socfpga/clk-gate-a10.c
+++ b/drivers/clk/socfpga/clk-gate-a10.c
@@ -19,6 +19,7 @@
 #include <linux/mfd/syscon.h>
 #include <linux/of.h>
 #include <linux/regmap.h>
+#include <asm/pgtable.h>
 
 #include "clk.h"
 
@@ -97,7 +98,7 @@ static int socfpga_clk_prepare(struct clk_hw *hwclk)
 	return 0;
 }
 
-static struct clk_ops gateclk_ops = {
+static clk_ops_no_const gateclk_ops __read_only = {
 	.prepare = socfpga_clk_prepare,
 	.recalc_rate = socfpga_gate_clk_recalc_rate,
 };
@@ -128,8 +129,10 @@ static void __init __socfpga_gate_init(struct device_node *node,
 		socfpga_clk->hw.reg = clk_mgr_a10_base_addr + clk_gate[0];
 		socfpga_clk->hw.bit_idx = clk_gate[1];
 
-		gateclk_ops.enable = clk_gate_ops.enable;
-		gateclk_ops.disable = clk_gate_ops.disable;
+		pax_open_kernel();
+		const_cast(gateclk_ops.enable) = clk_gate_ops.enable;
+		const_cast(gateclk_ops.disable) = clk_gate_ops.disable;
+		pax_close_kernel();
 	}
 
 	rc = of_property_read_u32(node, "fixed-divider", &fixed_div);
diff --git a/drivers/clk/socfpga/clk-gate.c b/drivers/clk/socfpga/clk-gate.c
index aa7a6e6a1..1e9b426ed 100644
--- a/drivers/clk/socfpga/clk-gate.c
+++ b/drivers/clk/socfpga/clk-gate.c
@@ -21,6 +21,7 @@
 #include <linux/mfd/syscon.h>
 #include <linux/of.h>
 #include <linux/regmap.h>
+#include <asm/pgtable.h>
 
 #include "clk.h"
 
@@ -169,7 +170,7 @@ static int socfpga_clk_prepare(struct clk_hw *hwclk)
 	return 0;
 }
 
-static struct clk_ops gateclk_ops = {
+static clk_ops_no_const gateclk_ops __read_only = {
 	.prepare = socfpga_clk_prepare,
 	.recalc_rate = socfpga_clk_recalc_rate,
 	.get_parent = socfpga_clk_get_parent,
@@ -202,8 +203,10 @@ static void __init __socfpga_gate_init(struct device_node *node,
 		socfpga_clk->hw.reg = clk_mgr_base_addr + clk_gate[0];
 		socfpga_clk->hw.bit_idx = clk_gate[1];
 
-		gateclk_ops.enable = clk_gate_ops.enable;
-		gateclk_ops.disable = clk_gate_ops.disable;
+		pax_open_kernel();
+		const_cast(gateclk_ops.enable) = clk_gate_ops.enable;
+		const_cast(gateclk_ops.disable) = clk_gate_ops.disable;
+		pax_close_kernel();
 	}
 
 	rc = of_property_read_u32(node, "fixed-divider", &fixed_div);
diff --git a/drivers/clk/socfpga/clk-pll-a10.c b/drivers/clk/socfpga/clk-pll-a10.c
index 35fabe1a3..d847c5363 100644
--- a/drivers/clk/socfpga/clk-pll-a10.c
+++ b/drivers/clk/socfpga/clk-pll-a10.c
@@ -18,6 +18,7 @@
 #include <linux/io.h>
 #include <linux/of.h>
 #include <linux/of_address.h>
+#include <asm/pgtable.h>
 
 #include "clk.h"
 
@@ -69,7 +70,7 @@ static u8 clk_pll_get_parent(struct clk_hw *hwclk)
 		CLK_MGR_PLL_CLK_SRC_MASK;
 }
 
-static struct clk_ops clk_pll_ops = {
+static clk_ops_no_const clk_pll_ops __read_only = {
 	.recalc_rate = clk_pll_recalc_rate,
 	.get_parent = clk_pll_get_parent,
 };
@@ -112,8 +113,10 @@ static struct clk * __init __socfpga_pll_init(struct device_node *node,
 	pll_clk->hw.hw.init = &init;
 
 	pll_clk->hw.bit_idx = SOCFPGA_PLL_EXT_ENA;
-	clk_pll_ops.enable = clk_gate_ops.enable;
-	clk_pll_ops.disable = clk_gate_ops.disable;
+	pax_open_kernel();
+	const_cast(clk_pll_ops.enable) = clk_gate_ops.enable;
+	const_cast(clk_pll_ops.disable) = clk_gate_ops.disable;
+	pax_close_kernel();
 
 	clk = clk_register(NULL, &pll_clk->hw.hw);
 	if (WARN_ON(IS_ERR(clk))) {
diff --git a/drivers/clk/socfpga/clk-pll.c b/drivers/clk/socfpga/clk-pll.c
index c7f463172..8d1b7d0ba 100644
--- a/drivers/clk/socfpga/clk-pll.c
+++ b/drivers/clk/socfpga/clk-pll.c
@@ -20,6 +20,7 @@
 #include <linux/io.h>
 #include <linux/of.h>
 #include <linux/of_address.h>
+#include <asm/pgtable.h>
 
 #include "clk.h"
 
@@ -75,7 +76,7 @@ static u8 clk_pll_get_parent(struct clk_hw *hwclk)
 			CLK_MGR_PLL_CLK_SRC_MASK;
 }
 
-static struct clk_ops clk_pll_ops = {
+static clk_ops_no_const clk_pll_ops __read_only = {
 	.recalc_rate = clk_pll_recalc_rate,
 	.get_parent = clk_pll_get_parent,
 };
@@ -114,8 +115,10 @@ static __init struct clk *__socfpga_pll_init(struct device_node *node,
 	pll_clk->hw.hw.init = &init;
 
 	pll_clk->hw.bit_idx = SOCFPGA_PLL_EXT_ENA;
-	clk_pll_ops.enable = clk_gate_ops.enable;
-	clk_pll_ops.disable = clk_gate_ops.disable;
+	pax_open_kernel();
+	const_cast(clk_pll_ops.enable) = clk_gate_ops.enable;
+	const_cast(clk_pll_ops.disable) = clk_gate_ops.disable;
+	pax_close_kernel();
 
 	clk = clk_register(NULL, &pll_clk->hw.hw);
 	if (WARN_ON(IS_ERR(clk))) {
diff --git a/drivers/clk/ti/adpll.c b/drivers/clk/ti/adpll.c
index 255cafb18..7b41c3b42 100644
--- a/drivers/clk/ti/adpll.c
+++ b/drivers/clk/ti/adpll.c
@@ -589,7 +589,7 @@ static int ti_adpll_init_clkout(struct ti_adpll_data *d,
 {
 	struct ti_adpll_clkout_data *co;
 	struct clk_init_data init;
-	struct clk_ops *ops;
+	clk_ops_no_const *ops;
 	const char *parent_names[2];
 	const char *child_name;
 	struct clk *clock;
diff --git a/drivers/clk/ti/clk.c b/drivers/clk/ti/clk.c
index 5fcf24775..446780a7e 100644
--- a/drivers/clk/ti/clk.c
+++ b/drivers/clk/ti/clk.c
@@ -25,6 +25,8 @@
 #include <linux/regmap.h>
 #include <linux/bootmem.h>
 
+#include <asm/pgtable.h>
+
 #include "clock.h"
 
 #undef pr_fmt
@@ -84,8 +86,10 @@ int ti_clk_setup_ll_ops(struct ti_clk_ll_ops *ops)
 	}
 
 	ti_clk_ll_ops = ops;
-	ops->clk_readl = clk_memmap_readl;
-	ops->clk_writel = clk_memmap_writel;
+	pax_open_kernel();
+	const_cast(ops->clk_readl) = clk_memmap_readl;
+	const_cast(ops->clk_writel) = clk_memmap_writel;
+	pax_close_kernel();
 
 	return 0;
 }
diff --git a/drivers/cpufreq/acpi-cpufreq.c b/drivers/cpufreq/acpi-cpufreq.c
index 297e9128f..d5661fbba 100644
--- a/drivers/cpufreq/acpi-cpufreq.c
+++ b/drivers/cpufreq/acpi-cpufreq.c
@@ -694,8 +694,11 @@ static int acpi_cpufreq_cpu_init(struct cpufreq_policy *policy)
 	data->acpi_perf_cpu = cpu;
 	policy->driver_data = data;
 
-	if (cpu_has(c, X86_FEATURE_CONSTANT_TSC))
-		acpi_cpufreq_driver.flags |= CPUFREQ_CONST_LOOPS;
+	if (cpu_has(c, X86_FEATURE_CONSTANT_TSC)) {
+		pax_open_kernel();
+		const_cast(acpi_cpufreq_driver.flags) |= CPUFREQ_CONST_LOOPS;
+		pax_close_kernel();
+	}
 
 	result = acpi_processor_register_performance(perf, cpu);
 	if (result)
@@ -833,7 +836,9 @@ static int acpi_cpufreq_cpu_init(struct cpufreq_policy *policy)
 		policy->cur = acpi_cpufreq_guess_freq(data, policy->cpu);
 		break;
 	case ACPI_ADR_SPACE_FIXED_HARDWARE:
-		acpi_cpufreq_driver.get = get_cur_freq_on_cpu;
+		pax_open_kernel();
+		const_cast(acpi_cpufreq_driver.get) = get_cur_freq_on_cpu;
+		pax_close_kernel();
 		break;
 	default:
 		break;
@@ -930,8 +935,10 @@ static void __init acpi_cpufreq_boost_init(void)
 		if (!msrs)
 			return;
 
-		acpi_cpufreq_driver.set_boost = set_boost;
-		acpi_cpufreq_driver.boost_enabled = boost_state(0);
+		pax_open_kernel();
+		const_cast(acpi_cpufreq_driver.set_boost) = set_boost;
+		const_cast(acpi_cpufreq_driver.boost_enabled) = boost_state(0);
+		pax_close_kernel();
 
 		cpu_notifier_register_begin();
 
diff --git a/drivers/cpufreq/cpufreq-dt.c b/drivers/cpufreq/cpufreq-dt.c
index 204cd527f..babd45c91 100644
--- a/drivers/cpufreq/cpufreq-dt.c
+++ b/drivers/cpufreq/cpufreq-dt.c
@@ -370,7 +370,9 @@ static int dt_cpufreq_probe(struct platform_device *pdev)
 	if (ret)
 		return ret;
 
-	dt_cpufreq_driver.driver_data = dev_get_platdata(&pdev->dev);
+	pax_open_kernel();
+	const_cast(dt_cpufreq_driver.driver_data) = dev_get_platdata(&pdev->dev);
+	pax_close_kernel();
 
 	ret = cpufreq_register_driver(&dt_cpufreq_driver);
 	if (ret)
diff --git a/drivers/cpufreq/cpufreq.c b/drivers/cpufreq/cpufreq.c
index 3dd4884c6..6249a2906 100644
--- a/drivers/cpufreq/cpufreq.c
+++ b/drivers/cpufreq/cpufreq.c
@@ -528,12 +528,12 @@ EXPORT_SYMBOL_GPL(cpufreq_driver_resolve_freq);
  *                          SYSFS INTERFACE                          *
  *********************************************************************/
 static ssize_t show_boost(struct kobject *kobj,
-				 struct attribute *attr, char *buf)
+				 struct kobj_attribute *attr, char *buf)
 {
 	return sprintf(buf, "%d\n", cpufreq_driver->boost_enabled);
 }
 
-static ssize_t store_boost(struct kobject *kobj, struct attribute *attr,
+static ssize_t store_boost(struct kobject *kobj, struct kobj_attribute *attr,
 				  const char *buf, size_t count)
 {
 	int ret, enable;
@@ -2150,7 +2150,7 @@ void cpufreq_unregister_governor(struct cpufreq_governor *governor)
 	read_unlock_irqrestore(&cpufreq_driver_lock, flags);
 
 	mutex_lock(&cpufreq_governor_mutex);
-	list_del(&governor->governor_list);
+	pax_list_del(&governor->governor_list);
 	mutex_unlock(&cpufreq_governor_mutex);
 	return;
 }
@@ -2350,7 +2350,7 @@ static int cpufreq_cpu_callback(struct notifier_block *nfb,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block __refdata cpufreq_cpu_notifier = {
+static struct notifier_block cpufreq_cpu_notifier = {
 	.notifier_call = cpufreq_cpu_callback,
 };
 
@@ -2392,13 +2392,17 @@ int cpufreq_boost_trigger_state(int state)
 		return 0;
 
 	write_lock_irqsave(&cpufreq_driver_lock, flags);
-	cpufreq_driver->boost_enabled = state;
+	pax_open_kernel();
+	const_cast(cpufreq_driver->boost_enabled) = state;
+	pax_close_kernel();
 	write_unlock_irqrestore(&cpufreq_driver_lock, flags);
 
 	ret = cpufreq_driver->set_boost(state);
 	if (ret) {
 		write_lock_irqsave(&cpufreq_driver_lock, flags);
-		cpufreq_driver->boost_enabled = !state;
+		pax_open_kernel();
+		const_cast(cpufreq_driver->boost_enabled) = !state;
+		pax_close_kernel();
 		write_unlock_irqrestore(&cpufreq_driver_lock, flags);
 
 		pr_err("%s: Cannot %s BOOST\n",
@@ -2439,7 +2443,9 @@ int cpufreq_enable_boost_support(void)
 	if (cpufreq_boost_supported())
 		return 0;
 
-	cpufreq_driver->set_boost = cpufreq_boost_set_sw;
+	pax_open_kernel();
+	const_cast(cpufreq_driver->set_boost) = cpufreq_boost_set_sw;
+	pax_close_kernel();
 
 	/* This will get removed on driver unregister */
 	return create_boost_sysfs_file();
@@ -2496,8 +2502,11 @@ int cpufreq_register_driver(struct cpufreq_driver *driver_data)
 	cpufreq_driver = driver_data;
 	write_unlock_irqrestore(&cpufreq_driver_lock, flags);
 
-	if (driver_data->setpolicy)
-		driver_data->flags |= CPUFREQ_CONST_LOOPS;
+	if (driver_data->setpolicy) {
+		pax_open_kernel();
+		const_cast(driver_data->flags) |= CPUFREQ_CONST_LOOPS;
+		pax_close_kernel();
+	}
 
 	if (cpufreq_boost_supported()) {
 		ret = create_boost_sysfs_file();
diff --git a/drivers/cpufreq/cpufreq_governor.h b/drivers/cpufreq/cpufreq_governor.h
index ef1037e9c..c832d36ba 100644
--- a/drivers/cpufreq/cpufreq_governor.h
+++ b/drivers/cpufreq/cpufreq_governor.h
@@ -171,7 +171,7 @@ void cpufreq_dbs_governor_limits(struct cpufreq_policy *policy);
 struct od_ops {
 	unsigned int (*powersave_bias_target)(struct cpufreq_policy *policy,
 			unsigned int freq_next, unsigned int relation);
-};
+} __no_const;
 
 unsigned int dbs_update(struct cpufreq_policy *policy);
 void od_register_powersave_bias_handler(unsigned int (*f)
diff --git a/drivers/cpufreq/cpufreq_ondemand.c b/drivers/cpufreq/cpufreq_ondemand.c
index 3a1f49f5f..42a478e4c 100644
--- a/drivers/cpufreq/cpufreq_ondemand.c
+++ b/drivers/cpufreq/cpufreq_ondemand.c
@@ -408,7 +408,7 @@ static void od_start(struct cpufreq_policy *policy)
 	ondemand_powersave_bias_init(policy);
 }
 
-static struct od_ops od_ops = {
+static struct od_ops od_ops __read_only = {
 	.powersave_bias_target = generic_powersave_bias_target,
 };
 
@@ -464,14 +464,18 @@ void od_register_powersave_bias_handler(unsigned int (*f)
 		(struct cpufreq_policy *, unsigned int, unsigned int),
 		unsigned int powersave_bias)
 {
-	od_ops.powersave_bias_target = f;
+	pax_open_kernel();
+	const_cast(od_ops.powersave_bias_target) = f;
+	pax_close_kernel();
 	od_set_powersave_bias(powersave_bias);
 }
 EXPORT_SYMBOL_GPL(od_register_powersave_bias_handler);
 
 void od_unregister_powersave_bias_handler(void)
 {
-	od_ops.powersave_bias_target = generic_powersave_bias_target;
+	pax_open_kernel();
+	const_cast(od_ops.powersave_bias_target) = generic_powersave_bias_target;
+	pax_close_kernel();
 	od_set_powersave_bias(0);
 }
 EXPORT_SYMBOL_GPL(od_unregister_powersave_bias_handler);
diff --git a/drivers/cpufreq/intel_pstate.c b/drivers/cpufreq/intel_pstate.c
index 8c347f5c2..cb2b54b51 100644
--- a/drivers/cpufreq/intel_pstate.c
+++ b/drivers/cpufreq/intel_pstate.c
@@ -275,13 +275,13 @@ struct pstate_funcs {
 struct cpu_defaults {
 	struct pstate_adjust_policy pid_policy;
 	struct pstate_funcs funcs;
-};
+} __do_const;
 
 static inline int32_t get_target_pstate_use_performance(struct cpudata *cpu);
 static inline int32_t get_target_pstate_use_cpu_load(struct cpudata *cpu);
 
 static struct pstate_adjust_policy pid_params __read_mostly;
-static struct pstate_funcs pstate_funcs __read_mostly;
+static struct pstate_funcs *pstate_funcs __read_mostly;
 static int hwp_active __read_mostly;
 
 #ifdef CONFIG_ACPI
@@ -650,13 +650,13 @@ static void __init intel_pstate_debug_expose_params(void)
 /************************** sysfs begin ************************/
 #define show_one(file_name, object)					\
 	static ssize_t show_##file_name					\
-	(struct kobject *kobj, struct attribute *attr, char *buf)	\
+	(struct kobject *kobj, struct kobj_attribute *attr, char *buf)	\
 	{								\
 		return sprintf(buf, "%u\n", limits->object);		\
 	}
 
 static ssize_t show_turbo_pct(struct kobject *kobj,
-				struct attribute *attr, char *buf)
+				struct kobj_attribute *attr, char *buf)
 {
 	struct cpudata *cpu;
 	int total, no_turbo, turbo_pct;
@@ -672,7 +672,7 @@ static ssize_t show_turbo_pct(struct kobject *kobj,
 }
 
 static ssize_t show_num_pstates(struct kobject *kobj,
-				struct attribute *attr, char *buf)
+				struct kobj_attribute *attr, char *buf)
 {
 	struct cpudata *cpu;
 	int total;
@@ -683,7 +683,7 @@ static ssize_t show_num_pstates(struct kobject *kobj,
 }
 
 static ssize_t show_no_turbo(struct kobject *kobj,
-			     struct attribute *attr, char *buf)
+			     struct kobj_attribute *attr, char *buf)
 {
 	ssize_t ret;
 
@@ -696,7 +696,7 @@ static ssize_t show_no_turbo(struct kobject *kobj,
 	return ret;
 }
 
-static ssize_t store_no_turbo(struct kobject *a, struct attribute *b,
+static ssize_t store_no_turbo(struct kobject *a, struct kobj_attribute *b,
 			      const char *buf, size_t count)
 {
 	unsigned int input;
@@ -720,7 +720,7 @@ static ssize_t store_no_turbo(struct kobject *a, struct attribute *b,
 	return count;
 }
 
-static ssize_t store_max_perf_pct(struct kobject *a, struct attribute *b,
+static ssize_t store_max_perf_pct(struct kobject *a, struct kobj_attribute *b,
 				  const char *buf, size_t count)
 {
 	unsigned int input;
@@ -744,7 +744,7 @@ static ssize_t store_max_perf_pct(struct kobject *a, struct attribute *b,
 	return count;
 }
 
-static ssize_t store_min_perf_pct(struct kobject *a, struct attribute *b,
+static ssize_t store_min_perf_pct(struct kobject *a, struct kobj_attribute *b,
 				  const char *buf, size_t count)
 {
 	unsigned int input;
@@ -1143,7 +1143,7 @@ static void intel_pstate_set_pstate(struct cpudata *cpu, int pstate)
 	 * right CPU.
 	 */
 	wrmsrl_on_cpu(cpu->cpu, MSR_IA32_PERF_CTL,
-		      pstate_funcs.get_val(cpu, pstate));
+		      pstate_funcs->get_val(cpu, pstate));
 }
 
 static void intel_pstate_set_min_pstate(struct cpudata *cpu)
@@ -1162,14 +1162,14 @@ static void intel_pstate_max_within_limits(struct cpudata *cpu)
 
 static void intel_pstate_get_cpu_pstates(struct cpudata *cpu)
 {
-	cpu->pstate.min_pstate = pstate_funcs.get_min();
-	cpu->pstate.max_pstate = pstate_funcs.get_max();
-	cpu->pstate.max_pstate_physical = pstate_funcs.get_max_physical();
-	cpu->pstate.turbo_pstate = pstate_funcs.get_turbo();
-	cpu->pstate.scaling = pstate_funcs.get_scaling();
+	cpu->pstate.min_pstate = pstate_funcs->get_min();
+	cpu->pstate.max_pstate = pstate_funcs->get_max();
+	cpu->pstate.max_pstate_physical = pstate_funcs->get_max_physical();
+	cpu->pstate.turbo_pstate = pstate_funcs->get_turbo();
+	cpu->pstate.scaling = pstate_funcs->get_scaling();
 
-	if (pstate_funcs.get_vid)
-		pstate_funcs.get_vid(cpu);
+	if (pstate_funcs->get_vid)
+		pstate_funcs->get_vid(cpu);
 
 	intel_pstate_set_min_pstate(cpu);
 }
@@ -1315,7 +1315,7 @@ static inline void intel_pstate_update_pstate(struct cpudata *cpu, int pstate)
 		return;
 
 	cpu->pstate.current_pstate = pstate;
-	wrmsrl(MSR_IA32_PERF_CTL, pstate_funcs.get_val(cpu, pstate));
+	wrmsrl(MSR_IA32_PERF_CTL, pstate_funcs->get_val(cpu, pstate));
 }
 
 static inline void intel_pstate_adjust_busy_pstate(struct cpudata *cpu)
@@ -1325,7 +1325,7 @@ static inline void intel_pstate_adjust_busy_pstate(struct cpudata *cpu)
 
 	from = cpu->pstate.current_pstate;
 
-	target_pstate = pstate_funcs.get_target_pstate(cpu);
+	target_pstate = pstate_funcs->get_target_pstate(cpu);
 
 	intel_pstate_update_pstate(cpu, target_pstate);
 
@@ -1622,15 +1622,15 @@ static unsigned int force_load __initdata;
 
 static int __init intel_pstate_msrs_not_valid(void)
 {
-	if (!pstate_funcs.get_max() ||
-	    !pstate_funcs.get_min() ||
-	    !pstate_funcs.get_turbo())
+	if (!pstate_funcs->get_max() ||
+	    !pstate_funcs->get_min() ||
+	    !pstate_funcs->get_turbo())
 		return -ENODEV;
 
 	return 0;
 }
 
-static void __init copy_pid_params(struct pstate_adjust_policy *policy)
+static void __init copy_pid_params(const struct pstate_adjust_policy *policy)
 {
 	pid_params.sample_rate_ms = policy->sample_rate_ms;
 	pid_params.sample_rate_ns = pid_params.sample_rate_ms * NSEC_PER_MSEC;
@@ -1643,15 +1643,7 @@ static void __init copy_pid_params(struct pstate_adjust_policy *policy)
 
 static void __init copy_cpu_funcs(struct pstate_funcs *funcs)
 {
-	pstate_funcs.get_max   = funcs->get_max;
-	pstate_funcs.get_max_physical = funcs->get_max_physical;
-	pstate_funcs.get_min   = funcs->get_min;
-	pstate_funcs.get_turbo = funcs->get_turbo;
-	pstate_funcs.get_scaling = funcs->get_scaling;
-	pstate_funcs.get_val   = funcs->get_val;
-	pstate_funcs.get_vid   = funcs->get_vid;
-	pstate_funcs.get_target_pstate = funcs->get_target_pstate;
-
+	pstate_funcs = funcs;
 }
 
 #ifdef CONFIG_ACPI
diff --git a/drivers/cpufreq/p4-clockmod.c b/drivers/cpufreq/p4-clockmod.c
index fd7781231..97e3efece 100644
--- a/drivers/cpufreq/p4-clockmod.c
+++ b/drivers/cpufreq/p4-clockmod.c
@@ -130,10 +130,14 @@ static unsigned int cpufreq_p4_get_frequency(struct cpuinfo_x86 *c)
 		case 0x0F: /* Core Duo */
 		case 0x16: /* Celeron Core */
 		case 0x1C: /* Atom */
-			p4clockmod_driver.flags |= CPUFREQ_CONST_LOOPS;
+			pax_open_kernel();
+			const_cast(p4clockmod_driver.flags) |= CPUFREQ_CONST_LOOPS;
+			pax_close_kernel();
 			return speedstep_get_frequency(SPEEDSTEP_CPU_PCORE);
 		case 0x0D: /* Pentium M (Dothan) */
-			p4clockmod_driver.flags |= CPUFREQ_CONST_LOOPS;
+			pax_open_kernel();
+			const_cast(p4clockmod_driver.flags) |= CPUFREQ_CONST_LOOPS;
+			pax_close_kernel();
 			/* fall through */
 		case 0x09: /* Pentium M (Banias) */
 			return speedstep_get_frequency(SPEEDSTEP_CPU_PM);
@@ -145,7 +149,9 @@ static unsigned int cpufreq_p4_get_frequency(struct cpuinfo_x86 *c)
 
 	/* on P-4s, the TSC runs with constant frequency independent whether
 	 * throttling is active or not. */
-	p4clockmod_driver.flags |= CPUFREQ_CONST_LOOPS;
+	pax_open_kernel();
+	const_cast(p4clockmod_driver.flags) |= CPUFREQ_CONST_LOOPS;
+	pax_close_kernel();
 
 	if (speedstep_detect_processor() == SPEEDSTEP_CPU_P4M) {
 		pr_warn("Warning: Pentium 4-M detected. The speedstep-ich or acpi cpufreq modules offer voltage scaling in addition of frequency scaling. You should use either one instead of p4-clockmod, if possible.\n");
diff --git a/drivers/cpufreq/sparc-us3-cpufreq.c b/drivers/cpufreq/sparc-us3-cpufreq.c
index 9bb42ba50..b01b4a2dd 100644
--- a/drivers/cpufreq/sparc-us3-cpufreq.c
+++ b/drivers/cpufreq/sparc-us3-cpufreq.c
@@ -18,14 +18,12 @@
 #include <asm/head.h>
 #include <asm/timer.h>
 
-static struct cpufreq_driver *cpufreq_us3_driver;
-
 struct us3_freq_percpu_info {
 	struct cpufreq_frequency_table table[4];
 };
 
 /* Indexed by cpu number. */
-static struct us3_freq_percpu_info *us3_freq_table;
+static struct us3_freq_percpu_info us3_freq_table[NR_CPUS];
 
 /* UltraSPARC-III has three dividers: 1, 2, and 32.  These are controlled
  * in the Safari config register.
@@ -156,16 +154,27 @@ static int __init us3_freq_cpu_init(struct cpufreq_policy *policy)
 
 static int us3_freq_cpu_exit(struct cpufreq_policy *policy)
 {
-	if (cpufreq_us3_driver)
-		us3_freq_target(policy, 0);
+	us3_freq_target(policy, 0);
 
 	return 0;
 }
 
+static int __init us3_freq_init(void);
+static void __exit us3_freq_exit(void);
+
+static struct cpufreq_driver cpufreq_us3_driver = {
+	.init		= us3_freq_cpu_init,
+	.verify		= cpufreq_generic_frequency_table_verify,
+	.target_index	= us3_freq_target,
+	.get		= us3_freq_get,
+	.exit		= us3_freq_cpu_exit,
+	.name		= "UltraSPARC-III",
+
+};
+
 static int __init us3_freq_init(void)
 {
 	unsigned long manuf, impl, ver;
-	int ret;
 
 	if (tlb_type != cheetah && tlb_type != cheetah_plus)
 		return -ENODEV;
@@ -178,55 +187,15 @@ static int __init us3_freq_init(void)
 	    (impl == CHEETAH_IMPL ||
 	     impl == CHEETAH_PLUS_IMPL ||
 	     impl == JAGUAR_IMPL ||
-	     impl == PANTHER_IMPL)) {
-		struct cpufreq_driver *driver;
-
-		ret = -ENOMEM;
-		driver = kzalloc(sizeof(*driver), GFP_KERNEL);
-		if (!driver)
-			goto err_out;
-
-		us3_freq_table = kzalloc((NR_CPUS * sizeof(*us3_freq_table)),
-			GFP_KERNEL);
-		if (!us3_freq_table)
-			goto err_out;
-
-		driver->init = us3_freq_cpu_init;
-		driver->verify = cpufreq_generic_frequency_table_verify;
-		driver->target_index = us3_freq_target;
-		driver->get = us3_freq_get;
-		driver->exit = us3_freq_cpu_exit;
-		strcpy(driver->name, "UltraSPARC-III");
-
-		cpufreq_us3_driver = driver;
-		ret = cpufreq_register_driver(driver);
-		if (ret)
-			goto err_out;
-
-		return 0;
-
-err_out:
-		if (driver) {
-			kfree(driver);
-			cpufreq_us3_driver = NULL;
-		}
-		kfree(us3_freq_table);
-		us3_freq_table = NULL;
-		return ret;
-	}
+	     impl == PANTHER_IMPL))
+		return cpufreq_register_driver(&cpufreq_us3_driver);
 
 	return -ENODEV;
 }
 
 static void __exit us3_freq_exit(void)
 {
-	if (cpufreq_us3_driver) {
-		cpufreq_unregister_driver(cpufreq_us3_driver);
-		kfree(cpufreq_us3_driver);
-		cpufreq_us3_driver = NULL;
-		kfree(us3_freq_table);
-		us3_freq_table = NULL;
-	}
+	cpufreq_unregister_driver(&cpufreq_us3_driver);
 }
 
 MODULE_AUTHOR("David S. Miller <davem@redhat.com>");
diff --git a/drivers/cpufreq/speedstep-centrino.c b/drivers/cpufreq/speedstep-centrino.c
index 41bc5397f..e46a74d1e 100644
--- a/drivers/cpufreq/speedstep-centrino.c
+++ b/drivers/cpufreq/speedstep-centrino.c
@@ -352,8 +352,11 @@ static int centrino_cpu_init(struct cpufreq_policy *policy)
 	    !cpu_has(cpu, X86_FEATURE_EST))
 		return -ENODEV;
 
-	if (cpu_has(cpu, X86_FEATURE_CONSTANT_TSC))
-		centrino_driver.flags |= CPUFREQ_CONST_LOOPS;
+	if (cpu_has(cpu, X86_FEATURE_CONSTANT_TSC)) {
+		pax_open_kernel();
+		const_cast(centrino_driver.flags) |= CPUFREQ_CONST_LOOPS;
+		pax_close_kernel();
+	}
 
 	if (policy->cpu != 0)
 		return -ENODEV;
diff --git a/drivers/cpuidle/driver.c b/drivers/cpuidle/driver.c
index 389ade457..e328b5ce0 100644
--- a/drivers/cpuidle/driver.c
+++ b/drivers/cpuidle/driver.c
@@ -193,7 +193,7 @@ static int poll_idle(struct cpuidle_device *dev,
 
 static void poll_idle_init(struct cpuidle_driver *drv)
 {
-	struct cpuidle_state *state = &drv->states[0];
+	cpuidle_state_no_const *state = &drv->states[0];
 
 	snprintf(state->name, CPUIDLE_NAME_LEN, "POLL");
 	snprintf(state->desc, CPUIDLE_DESC_LEN, "CPUIDLE CORE POLL IDLE");
diff --git a/drivers/cpuidle/dt_idle_states.c b/drivers/cpuidle/dt_idle_states.c
index a5c111b67..11130028f 100644
--- a/drivers/cpuidle/dt_idle_states.c
+++ b/drivers/cpuidle/dt_idle_states.c
@@ -21,7 +21,7 @@
 
 #include "dt_idle_states.h"
 
-static int init_state_node(struct cpuidle_state *idle_state,
+static int init_state_node(cpuidle_state_no_const *idle_state,
 			   const struct of_device_id *matches,
 			   struct device_node *state_node)
 {
diff --git a/drivers/cpuidle/governor.c b/drivers/cpuidle/governor.c
index fb9f511cc..213e6cc1b 100644
--- a/drivers/cpuidle/governor.c
+++ b/drivers/cpuidle/governor.c
@@ -87,7 +87,7 @@ int cpuidle_register_governor(struct cpuidle_governor *gov)
 	mutex_lock(&cpuidle_lock);
 	if (__cpuidle_find_governor(gov->name) == NULL) {
 		ret = 0;
-		list_add_tail(&gov->governor_list, &cpuidle_governors);
+		pax_list_add_tail((struct list_head *)&gov->governor_list, &cpuidle_governors);
 		if (!cpuidle_curr_governor ||
 		    cpuidle_curr_governor->rating < gov->rating)
 			cpuidle_switch_governor(gov);
diff --git a/drivers/cpuidle/governors/ladder.c b/drivers/cpuidle/governors/ladder.c
index 63bd5a403..eea2dff9a 100644
--- a/drivers/cpuidle/governors/ladder.c
+++ b/drivers/cpuidle/governors/ladder.c
@@ -173,6 +173,15 @@ static void ladder_reflect(struct cpuidle_device *dev, int index)
 
 static struct cpuidle_governor ladder_governor = {
 	.name =		"ladder",
+	.rating =	25,
+	.enable =	ladder_enable_device,
+	.select =	ladder_select_state,
+	.reflect =	ladder_reflect,
+	.owner =	THIS_MODULE,
+};
+
+static struct cpuidle_governor ladder_governor_nohz = {
+	.name =		"ladder",
 	.rating =	10,
 	.enable =	ladder_enable_device,
 	.select =	ladder_select_state,
@@ -190,10 +199,8 @@ static int __init init_ladder(void)
 	 * governor is better so give it a higher rating than the menu
 	 * governor.
 	 */
-	if (!tick_nohz_enabled)
-		ladder_governor.rating = 25;
 
-	return cpuidle_register_governor(&ladder_governor);
+	return cpuidle_register_governor(tick_nohz_enabled ? &ladder_governor_nohz : &ladder_governor);
 }
 
 postcore_initcall(init_ladder);
diff --git a/drivers/cpuidle/sysfs.c b/drivers/cpuidle/sysfs.c
index 832a2c3f0..1794080df 100644
--- a/drivers/cpuidle/sysfs.c
+++ b/drivers/cpuidle/sysfs.c
@@ -135,7 +135,7 @@ static struct attribute *cpuidle_switch_attrs[] = {
 	NULL
 };
 
-static struct attribute_group cpuidle_attr_group = {
+static attribute_group_no_const cpuidle_attr_group = {
 	.attrs = cpuidle_default_attrs,
 	.name = "cpuidle",
 };
diff --git a/drivers/crypto/hifn_795x.c b/drivers/crypto/hifn_795x.c
index eee2c7e6c..268aa3e57 100644
--- a/drivers/crypto/hifn_795x.c
+++ b/drivers/crypto/hifn_795x.c
@@ -37,7 +37,7 @@ module_param_string(hifn_pll_ref, hifn_pll_ref, sizeof(hifn_pll_ref), 0444);
 MODULE_PARM_DESC(hifn_pll_ref,
 		 "PLL reference clock (pci[freq] or ext[freq], default ext)");
 
-static atomic_t hifn_dev_number;
+static atomic_unchecked_t hifn_dev_number;
 
 #define ACRYPTO_OP_DECRYPT	0
 #define ACRYPTO_OP_ENCRYPT	1
@@ -2483,7 +2483,7 @@ static int hifn_probe(struct pci_dev *pdev, const struct pci_device_id *id)
 		goto err_out_disable_pci_device;
 
 	snprintf(name, sizeof(name), "hifn%d",
-			atomic_inc_return(&hifn_dev_number) - 1);
+			atomic_inc_return_unchecked(&hifn_dev_number) - 1);
 
 	err = pci_request_regions(pdev, name);
 	if (err)
diff --git a/drivers/crypto/qat/qat_common/adf_aer.c b/drivers/crypto/qat/qat_common/adf_aer.c
index 2839fccdd..b40595a43 100644
--- a/drivers/crypto/qat/qat_common/adf_aer.c
+++ b/drivers/crypto/qat/qat_common/adf_aer.c
@@ -56,7 +56,7 @@
 static struct workqueue_struct *device_reset_wq;
 
 static pci_ers_result_t adf_error_detected(struct pci_dev *pdev,
-					   pci_channel_state_t state)
+					   enum pci_channel_state state)
 {
 	struct adf_accel_dev *accel_dev = adf_devmgr_pci_to_accel_dev(pdev);
 
diff --git a/drivers/crypto/qat/qat_common/adf_sriov.c b/drivers/crypto/qat/qat_common/adf_sriov.c
index 9320ae1d0..4bf8e7e56 100644
--- a/drivers/crypto/qat/qat_common/adf_sriov.c
+++ b/drivers/crypto/qat/qat_common/adf_sriov.c
@@ -93,7 +93,7 @@ static void adf_iov_send_resp(struct work_struct *work)
 	kfree(pf2vf_resp);
 }
 
-static void adf_vf2pf_bh_handler(void *data)
+static void adf_vf2pf_bh_handler(unsigned long data)
 {
 	struct adf_accel_vf_info *vf_info = (struct adf_accel_vf_info *)data;
 	struct adf_pf2vf_resp *pf2vf_resp;
@@ -126,7 +126,7 @@ static int adf_enable_sriov(struct adf_accel_dev *accel_dev)
 		vf_info->vf_nr = i;
 
 		tasklet_init(&vf_info->vf2pf_bh_tasklet,
-			     (void *)adf_vf2pf_bh_handler,
+			     adf_vf2pf_bh_handler,
 			     (unsigned long)vf_info);
 		mutex_init(&vf_info->pf2vf_lock);
 		ratelimit_state_init(&vf_info->vf2pf_ratelimit,
diff --git a/drivers/crypto/qat/qat_common/adf_vf_isr.c b/drivers/crypto/qat/qat_common/adf_vf_isr.c
index bf99e11a3..a44361cb3 100644
--- a/drivers/crypto/qat/qat_common/adf_vf_isr.c
+++ b/drivers/crypto/qat/qat_common/adf_vf_isr.c
@@ -112,9 +112,9 @@ static void adf_dev_stop_async(struct work_struct *work)
 	kfree(stop_data);
 }
 
-static void adf_pf2vf_bh_handler(void *data)
+static void adf_pf2vf_bh_handler(unsigned long data)
 {
-	struct adf_accel_dev *accel_dev = data;
+	struct adf_accel_dev *accel_dev = (struct adf_accel_dev *)data;
 	struct adf_hw_device_data *hw_data = accel_dev->hw_device;
 	struct adf_bar *pmisc =
 			&GET_BARS(accel_dev)[hw_data->get_misc_bar_id(hw_data)];
@@ -183,7 +183,7 @@ err:
 static int adf_setup_pf2vf_bh(struct adf_accel_dev *accel_dev)
 {
 	tasklet_init(&accel_dev->vf.pf2vf_bh_tasklet,
-		     (void *)adf_pf2vf_bh_handler, (unsigned long)accel_dev);
+		     adf_pf2vf_bh_handler, (unsigned long)accel_dev);
 
 	mutex_init(&accel_dev->vf.vf2pf_lock);
 	return 0;
diff --git a/drivers/devfreq/devfreq.c b/drivers/devfreq/devfreq.c
index 478006b77..fd0efda18 100644
--- a/drivers/devfreq/devfreq.c
+++ b/drivers/devfreq/devfreq.c
@@ -802,7 +802,7 @@ int devfreq_add_governor(struct devfreq_governor *governor)
 		goto err_out;
 	}
 
-	list_add(&governor->node, &devfreq_governor_list);
+	pax_list_add((struct list_head *)&governor->node, &devfreq_governor_list);
 
 	list_for_each_entry(devfreq, &devfreq_list, node) {
 		int ret = 0;
@@ -890,7 +890,7 @@ int devfreq_remove_governor(struct devfreq_governor *governor)
 		}
 	}
 
-	list_del(&governor->node);
+	pax_list_del((struct list_head *)&governor->node);
 err_out:
 	mutex_unlock(&devfreq_list_lock);
 
diff --git a/drivers/devfreq/governor_passive.c b/drivers/devfreq/governor_passive.c
index 9ef46e259..775fc7568 100644
--- a/drivers/devfreq/governor_passive.c
+++ b/drivers/devfreq/governor_passive.c
@@ -151,7 +151,7 @@ static int devfreq_passive_event_handler(struct devfreq *devfreq,
 	struct devfreq_passive_data *p_data
 			= (struct devfreq_passive_data *)devfreq->data;
 	struct devfreq *parent = (struct devfreq *)p_data->parent;
-	struct notifier_block *nb = &p_data->nb;
+	notifier_block_no_const *nb = &p_data->nb;
 	int ret = 0;
 
 	if (!parent)
diff --git a/drivers/dma/qcom/hidma.c b/drivers/dma/qcom/hidma.c
index b2374cd91..4f1e32c7f 100644
--- a/drivers/dma/qcom/hidma.c
+++ b/drivers/dma/qcom/hidma.c
@@ -547,7 +547,7 @@ static ssize_t hidma_show_values(struct device *dev,
 static int hidma_create_sysfs_entry(struct hidma_dev *dev, char *name,
 				    int mode)
 {
-	struct device_attribute *attrs;
+	device_attribute_no_const *attrs;
 	char *name_copy;
 
 	attrs = devm_kmalloc(dev->ddev.dev, sizeof(struct device_attribute),
diff --git a/drivers/dma/qcom/hidma_mgmt_sys.c b/drivers/dma/qcom/hidma_mgmt_sys.c
index d61f1068a..a23baa35e 100644
--- a/drivers/dma/qcom/hidma_mgmt_sys.c
+++ b/drivers/dma/qcom/hidma_mgmt_sys.c
@@ -194,7 +194,7 @@ static ssize_t set_values_channel(struct kobject *kobj,
 
 static int create_sysfs_entry(struct hidma_mgmt_dev *dev, char *name, int mode)
 {
-	struct device_attribute *attrs;
+	device_attribute_no_const *attrs;
 	char *name_copy;
 
 	attrs = devm_kmalloc(&dev->pdev->dev,
diff --git a/drivers/dma/sh/shdma-base.c b/drivers/dma/sh/shdma-base.c
index 10fcabad8..326f7097d 100644
--- a/drivers/dma/sh/shdma-base.c
+++ b/drivers/dma/sh/shdma-base.c
@@ -227,8 +227,8 @@ static int shdma_alloc_chan_resources(struct dma_chan *chan)
 		schan->slave_id = -EINVAL;
 	}
 
-	schan->desc = kcalloc(NR_DESCS_PER_CHANNEL,
-			      sdev->desc_size, GFP_KERNEL);
+	schan->desc = kcalloc(sdev->desc_size,
+			      NR_DESCS_PER_CHANNEL, GFP_KERNEL);
 	if (!schan->desc) {
 		ret = -ENOMEM;
 		goto edescalloc;
diff --git a/drivers/dma/sh/shdmac.c b/drivers/dma/sh/shdmac.c
index c94ffab0d..82c11f058 100644
--- a/drivers/dma/sh/shdmac.c
+++ b/drivers/dma/sh/shdmac.c
@@ -513,7 +513,7 @@ static int sh_dmae_nmi_handler(struct notifier_block *self,
 	return ret;
 }
 
-static struct notifier_block sh_dmae_nmi_notifier __read_mostly = {
+static struct notifier_block sh_dmae_nmi_notifier = {
 	.notifier_call	= sh_dmae_nmi_handler,
 
 	/* Run before NMI debug handler and KGDB */
diff --git a/drivers/edac/edac_device.c b/drivers/edac/edac_device.c
index a97900333..773b7f0f4 100644
--- a/drivers/edac/edac_device.c
+++ b/drivers/edac/edac_device.c
@@ -468,9 +468,9 @@ void edac_device_reset_delay_period(struct edac_device_ctl_info *edac_dev,
  */
 int edac_device_alloc_index(void)
 {
-	static atomic_t device_indexes = ATOMIC_INIT(0);
+	static atomic_unchecked_t device_indexes = ATOMIC_INIT(0);
 
-	return atomic_inc_return(&device_indexes) - 1;
+	return atomic_inc_return_unchecked(&device_indexes) - 1;
 }
 EXPORT_SYMBOL_GPL(edac_device_alloc_index);
 
diff --git a/drivers/edac/edac_device_sysfs.c b/drivers/edac/edac_device_sysfs.c
index 93da1a45c..5e2c149e3 100644
--- a/drivers/edac/edac_device_sysfs.c
+++ b/drivers/edac/edac_device_sysfs.c
@@ -749,7 +749,7 @@ static int edac_device_add_main_sysfs_attributes(
 		 */
 		while (sysfs_attrib->attr.name != NULL) {
 			err = sysfs_create_file(&edac_dev->kobj,
-				(struct attribute*) sysfs_attrib);
+				&sysfs_attrib->attr);
 			if (err)
 				goto err_out;
 
diff --git a/drivers/edac/edac_mc_sysfs.c b/drivers/edac/edac_mc_sysfs.c
index 4e0f8e720..0eb949927 100644
--- a/drivers/edac/edac_mc_sysfs.c
+++ b/drivers/edac/edac_mc_sysfs.c
@@ -50,7 +50,7 @@ int edac_mc_get_poll_msec(void)
 	return edac_mc_poll_msec;
 }
 
-static int edac_set_poll_msec(const char *val, struct kernel_param *kp)
+static int edac_set_poll_msec(const char *val, const struct kernel_param *kp)
 {
 	unsigned long l;
 	int ret;
@@ -154,7 +154,7 @@ static const char * const edac_caps[] = {
 struct dev_ch_attribute {
 	struct device_attribute attr;
 	int channel;
-};
+} __do_const;
 
 #define DEVICE_CHANNEL(_name, _mode, _show, _store, _var) \
 	static struct dev_ch_attribute dev_attr_legacy_##_name = \
diff --git a/drivers/edac/edac_module.c b/drivers/edac/edac_module.c
index 5f8543be9..46aa017a3 100644
--- a/drivers/edac/edac_module.c
+++ b/drivers/edac/edac_module.c
@@ -19,7 +19,7 @@
 
 #ifdef CONFIG_EDAC_DEBUG
 
-static int edac_set_debug_level(const char *buf, struct kernel_param *kp)
+static int edac_set_debug_level(const char *buf, const struct kernel_param *kp)
 {
 	unsigned long val;
 	int ret;
diff --git a/drivers/edac/edac_pci.c b/drivers/edac/edac_pci.c
index 8f2f2899a..cbb0d7cb2 100644
--- a/drivers/edac/edac_pci.c
+++ b/drivers/edac/edac_pci.c
@@ -29,7 +29,7 @@
 
 static DEFINE_MUTEX(edac_pci_ctls_mutex);
 static LIST_HEAD(edac_pci_list);
-static atomic_t pci_indexes = ATOMIC_INIT(0);
+static atomic_unchecked_t pci_indexes = ATOMIC_INIT(0);
 
 /*
  * edac_pci_alloc_ctl_info
@@ -224,7 +224,7 @@ static void edac_pci_workq_function(struct work_struct *work_req)
  */
 int edac_pci_alloc_index(void)
 {
-	return atomic_inc_return(&pci_indexes) - 1;
+	return atomic_inc_return_unchecked(&pci_indexes) - 1;
 }
 EXPORT_SYMBOL_GPL(edac_pci_alloc_index);
 
diff --git a/drivers/edac/edac_pci_sysfs.c b/drivers/edac/edac_pci_sysfs.c
index 6e3428ba4..9bdb20757 100644
--- a/drivers/edac/edac_pci_sysfs.c
+++ b/drivers/edac/edac_pci_sysfs.c
@@ -23,8 +23,8 @@ static int edac_pci_log_pe = 1;		/* log PCI parity errors */
 static int edac_pci_log_npe = 1;	/* log PCI non-parity error errors */
 static int edac_pci_poll_msec = 1000;	/* one second workq period */
 
-static atomic_t pci_parity_count = ATOMIC_INIT(0);
-static atomic_t pci_nonparity_count = ATOMIC_INIT(0);
+static atomic_unchecked_t pci_parity_count = ATOMIC_INIT(0);
+static atomic_unchecked_t pci_nonparity_count = ATOMIC_INIT(0);
 
 static struct kobject *edac_pci_top_main_kobj;
 static atomic_t edac_pci_sysfs_refcount = ATOMIC_INIT(0);
@@ -232,7 +232,7 @@ struct edac_pci_dev_attribute {
 	void *value;
 	 ssize_t(*show) (void *, char *);
 	 ssize_t(*store) (void *, const char *, size_t);
-};
+} __do_const;
 
 /* Set of show/store abstract level functions for PCI Parity object */
 static ssize_t edac_pci_dev_show(struct kobject *kobj, struct attribute *attr,
@@ -564,7 +564,7 @@ static void edac_pci_dev_parity_test(struct pci_dev *dev)
 			edac_printk(KERN_CRIT, EDAC_PCI,
 				"Signaled System Error on %s\n",
 				pci_name(dev));
-			atomic_inc(&pci_nonparity_count);
+			atomic_inc_unchecked(&pci_nonparity_count);
 		}
 
 		if (status & (PCI_STATUS_PARITY)) {
@@ -572,7 +572,7 @@ static void edac_pci_dev_parity_test(struct pci_dev *dev)
 				"Master Data Parity Error on %s\n",
 				pci_name(dev));
 
-			atomic_inc(&pci_parity_count);
+			atomic_inc_unchecked(&pci_parity_count);
 		}
 
 		if (status & (PCI_STATUS_DETECTED_PARITY)) {
@@ -580,7 +580,7 @@ static void edac_pci_dev_parity_test(struct pci_dev *dev)
 				"Detected Parity Error on %s\n",
 				pci_name(dev));
 
-			atomic_inc(&pci_parity_count);
+			atomic_inc_unchecked(&pci_parity_count);
 		}
 	}
 
@@ -603,7 +603,7 @@ static void edac_pci_dev_parity_test(struct pci_dev *dev)
 				edac_printk(KERN_CRIT, EDAC_PCI, "Bridge "
 					"Signaled System Error on %s\n",
 					pci_name(dev));
-				atomic_inc(&pci_nonparity_count);
+				atomic_inc_unchecked(&pci_nonparity_count);
 			}
 
 			if (status & (PCI_STATUS_PARITY)) {
@@ -611,7 +611,7 @@ static void edac_pci_dev_parity_test(struct pci_dev *dev)
 					"Master Data Parity Error on "
 					"%s\n", pci_name(dev));
 
-				atomic_inc(&pci_parity_count);
+				atomic_inc_unchecked(&pci_parity_count);
 			}
 
 			if (status & (PCI_STATUS_DETECTED_PARITY)) {
@@ -619,7 +619,7 @@ static void edac_pci_dev_parity_test(struct pci_dev *dev)
 					"Detected Parity Error on %s\n",
 					pci_name(dev));
 
-				atomic_inc(&pci_parity_count);
+				atomic_inc_unchecked(&pci_parity_count);
 			}
 		}
 	}
@@ -657,7 +657,7 @@ void edac_pci_do_parity_check(void)
 	if (!check_pci_errors)
 		return;
 
-	before_count = atomic_read(&pci_parity_count);
+	before_count = atomic_read_unchecked(&pci_parity_count);
 
 	/* scan all PCI devices looking for a Parity Error on devices and
 	 * bridges.
@@ -669,7 +669,7 @@ void edac_pci_do_parity_check(void)
 	/* Only if operator has selected panic on PCI Error */
 	if (edac_pci_get_panic_on_pe()) {
 		/* If the count is different 'after' from 'before' */
-		if (before_count != atomic_read(&pci_parity_count))
+		if (before_count != atomic_read_unchecked(&pci_parity_count))
 			panic("EDAC: PCI Parity Error");
 	}
 }
diff --git a/drivers/edac/mce_amd.h b/drivers/edac/mce_amd.h
index c2359a1ea..8bd119dd2 100644
--- a/drivers/edac/mce_amd.h
+++ b/drivers/edac/mce_amd.h
@@ -74,7 +74,7 @@ struct amd_decoder_ops {
 	bool (*mc0_mce)(u16, u8);
 	bool (*mc1_mce)(u16, u8);
 	bool (*mc2_mce)(u16, u8);
-};
+} __no_const;
 
 void amd_report_gart_errors(bool);
 void amd_register_ecc_decoder(void (*f)(int, struct mce *));
diff --git a/drivers/firewire/core-card.c b/drivers/firewire/core-card.c
index 57ea7f464..af06b7634 100644
--- a/drivers/firewire/core-card.c
+++ b/drivers/firewire/core-card.c
@@ -528,9 +528,9 @@ void fw_card_initialize(struct fw_card *card,
 			const struct fw_card_driver *driver,
 			struct device *device)
 {
-	static atomic_t index = ATOMIC_INIT(-1);
+	static atomic_unchecked_t index = ATOMIC_INIT(-1);
 
-	card->index = atomic_inc_return(&index);
+	card->index = atomic_inc_return_unchecked(&index);
 	card->driver = driver;
 	card->device = device;
 	card->current_tlabel = 0;
@@ -680,7 +680,7 @@ EXPORT_SYMBOL_GPL(fw_card_release);
 
 void fw_core_remove_card(struct fw_card *card)
 {
-	struct fw_card_driver dummy_driver = dummy_driver_template;
+	fw_card_driver_no_const dummy_driver = dummy_driver_template;
 
 	card->driver->update_phy_reg(card, 4,
 				     PHY_LINK_ACTIVE | PHY_CONTENDER, 0);
diff --git a/drivers/firewire/core-cdev.c b/drivers/firewire/core-cdev.c
index aee149bdf..2a189600e 100644
--- a/drivers/firewire/core-cdev.c
+++ b/drivers/firewire/core-cdev.c
@@ -970,7 +970,7 @@ static int ioctl_create_iso_context(struct client *client, union ioctl_arg *arg)
 {
 	struct fw_cdev_create_iso_context *a = &arg->create_iso_context;
 	struct fw_iso_context *context;
-	fw_iso_callback_t cb;
+	void *cb;
 	int ret;
 
 	BUILD_BUG_ON(FW_CDEV_ISO_CONTEXT_TRANSMIT != FW_ISO_CONTEXT_TRANSMIT ||
@@ -995,7 +995,7 @@ static int ioctl_create_iso_context(struct client *client, union ioctl_arg *arg)
 		break;
 
 	case FW_ISO_CONTEXT_RECEIVE_MULTICHANNEL:
-		cb = (fw_iso_callback_t)iso_mc_callback;
+		cb = iso_mc_callback;
 		break;
 
 	default:
diff --git a/drivers/firewire/core-device.c b/drivers/firewire/core-device.c
index f9e3aee6a..269dbdb05 100644
--- a/drivers/firewire/core-device.c
+++ b/drivers/firewire/core-device.c
@@ -256,7 +256,7 @@ EXPORT_SYMBOL(fw_device_enable_phys_dma);
 struct config_rom_attribute {
 	struct device_attribute attr;
 	u32 key;
-};
+} __do_const;
 
 static ssize_t show_immediate(struct device *dev,
 			      struct device_attribute *dattr, char *buf)
diff --git a/drivers/firewire/core-iso.c b/drivers/firewire/core-iso.c
index 38c0aa60b..95466e41e 100644
--- a/drivers/firewire/core-iso.c
+++ b/drivers/firewire/core-iso.c
@@ -162,7 +162,7 @@ size_t fw_iso_buffer_lookup(struct fw_iso_buffer *buffer, dma_addr_t completed)
 
 struct fw_iso_context *fw_iso_context_create(struct fw_card *card,
 		int type, int channel, int speed, size_t header_size,
-		fw_iso_callback_t callback, void *callback_data)
+		void *callback, void *callback_data)
 {
 	struct fw_iso_context *ctx;
 
diff --git a/drivers/firewire/core-transaction.c b/drivers/firewire/core-transaction.c
index d6a09b9cd..18e90ddc1 100644
--- a/drivers/firewire/core-transaction.c
+++ b/drivers/firewire/core-transaction.c
@@ -38,6 +38,7 @@
 #include <linux/timer.h>
 #include <linux/types.h>
 #include <linux/workqueue.h>
+#include <linux/sched.h>
 
 #include <asm/byteorder.h>
 
diff --git a/drivers/firewire/core.h b/drivers/firewire/core.h
index e1480ff68..1a429bdcd 100644
--- a/drivers/firewire/core.h
+++ b/drivers/firewire/core.h
@@ -111,6 +111,7 @@ struct fw_card_driver {
 
 	int (*stop_iso)(struct fw_iso_context *ctx);
 };
+typedef struct fw_card_driver __no_const fw_card_driver_no_const;
 
 void fw_card_initialize(struct fw_card *card,
 		const struct fw_card_driver *driver, struct device *device);
diff --git a/drivers/firewire/ohci.c b/drivers/firewire/ohci.c
index 8bf89267d..55a4930eb 100644
--- a/drivers/firewire/ohci.c
+++ b/drivers/firewire/ohci.c
@@ -2049,10 +2049,12 @@ static void bus_reset_work(struct work_struct *work)
 			  be32_to_cpu(ohci->next_header));
 	}
 
+#ifndef CONFIG_GRKERNSEC
 	if (param_remote_dma) {
 		reg_write(ohci, OHCI1394_PhyReqFilterHiSet, ~0);
 		reg_write(ohci, OHCI1394_PhyReqFilterLoSet, ~0);
 	}
+#endif
 
 	spin_unlock_irq(&ohci->lock);
 
@@ -2585,8 +2587,10 @@ static int ohci_enable_phys_dma(struct fw_card *card,
 	unsigned long flags;
 	int n, ret = 0;
 
+#ifndef CONFIG_GRKERNSEC
 	if (param_remote_dma)
 		return 0;
+#endif
 
 	/*
 	 * FIXME:  Make sure this bitmask is cleared when we clear the busReset
diff --git a/drivers/firmware/dmi-id.c b/drivers/firmware/dmi-id.c
index 44c01390d..5252697dc 100644
--- a/drivers/firmware/dmi-id.c
+++ b/drivers/firmware/dmi-id.c
@@ -16,7 +16,7 @@
 struct dmi_device_attribute{
 	struct device_attribute dev_attr;
 	int field;
-};
+} __do_const;
 #define to_dmi_dev_attr(_dev_attr) \
 	container_of(_dev_attr, struct dmi_device_attribute, dev_attr)
 
@@ -159,9 +159,14 @@ static int dmi_dev_uevent(struct device *dev, struct kobj_uevent_env *env)
 	return 0;
 }
 
+static void dmi_dev_release(struct device *dev)
+{
+	kfree(dev);
+}
+
 static struct class dmi_class = {
 	.name = "dmi",
-	.dev_release = (void(*)(struct device *)) kfree,
+	.dev_release = dmi_dev_release,
 	.dev_uevent = dmi_dev_uevent,
 };
 
diff --git a/drivers/firmware/dmi_scan.c b/drivers/firmware/dmi_scan.c
index 88bebe196..e599fad80 100644
--- a/drivers/firmware/dmi_scan.c
+++ b/drivers/firmware/dmi_scan.c
@@ -712,14 +712,18 @@ static int __init dmi_init(void)
 	if (!dmi_table)
 		goto err_tables;
 
-	bin_attr_smbios_entry_point.size = smbios_entry_point_size;
-	bin_attr_smbios_entry_point.private = smbios_entry_point;
+	pax_open_kernel();
+	const_cast(bin_attr_smbios_entry_point.size) = smbios_entry_point_size;
+	const_cast(bin_attr_smbios_entry_point.private) = smbios_entry_point;
+	pax_close_kernel();
 	ret = sysfs_create_bin_file(tables_kobj, &bin_attr_smbios_entry_point);
 	if (ret)
 		goto err_unmap;
 
-	bin_attr_DMI.size = dmi_len;
-	bin_attr_DMI.private = dmi_table;
+	pax_open_kernel();
+	const_cast(bin_attr_DMI.size) = dmi_len;
+	const_cast(bin_attr_DMI.private) = dmi_table;
+	pax_close_kernel();
 	ret = sysfs_create_bin_file(tables_kobj, &bin_attr_DMI);
 	if (!ret)
 		return 0;
diff --git a/drivers/firmware/efi/cper.c b/drivers/firmware/efi/cper.c
index d42537425..1da1716b9 100644
--- a/drivers/firmware/efi/cper.c
+++ b/drivers/firmware/efi/cper.c
@@ -44,12 +44,12 @@ static char rcd_decode_str[CPER_REC_LEN];
  */
 u64 cper_next_record_id(void)
 {
-	static atomic64_t seq;
+	static atomic64_unchecked_t seq;
 
-	if (!atomic64_read(&seq))
-		atomic64_set(&seq, ((u64)get_seconds()) << 32);
+	if (!atomic64_read_unchecked(&seq))
+		atomic64_set_unchecked(&seq, ((u64)get_seconds()) << 32);
 
-	return atomic64_inc_return(&seq);
+	return atomic64_inc_return_unchecked(&seq);
 }
 EXPORT_SYMBOL_GPL(cper_next_record_id);
 
diff --git a/drivers/firmware/efi/efi.c b/drivers/firmware/efi/efi.c
index 7dd2e2d37..15990acae 100644
--- a/drivers/firmware/efi/efi.c
+++ b/drivers/firmware/efi/efi.c
@@ -180,15 +180,17 @@ static struct attribute_group efi_subsys_attr_group = {
 };
 
 static struct efivars generic_efivars;
-static struct efivar_operations generic_ops;
+static efivar_operations_no_const generic_ops __read_only;
 
 static int generic_ops_register(void)
 {
-	generic_ops.get_variable = efi.get_variable;
-	generic_ops.set_variable = efi.set_variable;
-	generic_ops.set_variable_nonblocking = efi.set_variable_nonblocking;
-	generic_ops.get_next_variable = efi.get_next_variable;
-	generic_ops.query_variable_store = efi_query_variable_store;
+	pax_open_kernel();
+	const_cast(generic_ops.get_variable) = efi.get_variable;
+	const_cast(generic_ops.set_variable) = efi.set_variable;
+	const_cast(generic_ops.set_variable_nonblocking) = efi.set_variable_nonblocking;
+	const_cast(generic_ops.get_next_variable) = efi.get_next_variable;
+	const_cast(generic_ops.query_variable_store) = efi_query_variable_store;
+	pax_close_kernel();
 
 	return efivars_register(&generic_efivars, &generic_ops, efi_kobj);
 }
diff --git a/drivers/firmware/efi/efivars.c b/drivers/firmware/efi/efivars.c
index 116b244de..b16d9f278 100644
--- a/drivers/firmware/efi/efivars.c
+++ b/drivers/firmware/efi/efivars.c
@@ -583,7 +583,7 @@ efivar_create_sysfs_entry(struct efivar_entry *new_var)
 static int
 create_efivars_bin_attributes(void)
 {
-	struct bin_attribute *attr;
+	bin_attribute_no_const *attr;
 	int error;
 
 	/* new_var */
diff --git a/drivers/firmware/efi/libstub/Makefile b/drivers/firmware/efi/libstub/Makefile
index c06945160..fca41b67f 100644
--- a/drivers/firmware/efi/libstub/Makefile
+++ b/drivers/firmware/efi/libstub/Makefile
@@ -20,6 +20,8 @@ KBUILD_CFLAGS			:= $(cflags-y) -DDISABLE_BRANCH_PROFILING \
 				   $(call cc-option,-ffreestanding) \
 				   $(call cc-option,-fno-stack-protector)
 
+KBUILD_CFLAGS			:= $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
+
 GCOV_PROFILE			:= n
 KASAN_SANITIZE			:= n
 UBSAN_SANITIZE			:= n
diff --git a/drivers/firmware/efi/runtime-map.c b/drivers/firmware/efi/runtime-map.c
index 5c55227a3..97f497844 100644
--- a/drivers/firmware/efi/runtime-map.c
+++ b/drivers/firmware/efi/runtime-map.c
@@ -97,7 +97,7 @@ static void map_release(struct kobject *kobj)
 	kfree(entry);
 }
 
-static struct kobj_type __refdata map_ktype = {
+static const struct kobj_type __refconst map_ktype = {
 	.sysfs_ops	= &map_attr_ops,
 	.default_attrs	= def_attrs,
 	.release	= map_release,
diff --git a/drivers/firmware/google/gsmi.c b/drivers/firmware/google/gsmi.c
index f1ab05ea5..ab5122883 100644
--- a/drivers/firmware/google/gsmi.c
+++ b/drivers/firmware/google/gsmi.c
@@ -709,7 +709,7 @@ static u32 __init hash_oem_table_id(char s[8])
 	return local_hash_64(input, 32);
 }
 
-static struct dmi_system_id gsmi_dmi_table[] __initdata = {
+static const struct dmi_system_id gsmi_dmi_table[] __initconst = {
 	{
 		.ident = "Google Board",
 		.matches = {
diff --git a/drivers/firmware/google/memconsole.c b/drivers/firmware/google/memconsole.c
index 2f569aaed..3af549743 100644
--- a/drivers/firmware/google/memconsole.c
+++ b/drivers/firmware/google/memconsole.c
@@ -136,7 +136,7 @@ static bool __init found_memconsole(void)
 	return false;
 }
 
-static struct dmi_system_id memconsole_dmi_table[] __initdata = {
+static const struct dmi_system_id memconsole_dmi_table[] __initconst = {
 	{
 		.ident = "Google Board",
 		.matches = {
@@ -155,7 +155,10 @@ static int __init memconsole_init(void)
 	if (!found_memconsole())
 		return -ENODEV;
 
-	memconsole_bin_attr.size = memconsole_length;
+	pax_open_kernel();
+	const_cast(memconsole_bin_attr.size) = memconsole_length;
+	pax_close_kernel();
+
 	return sysfs_create_bin_file(firmware_kobj, &memconsole_bin_attr);
 }
 
diff --git a/drivers/firmware/memmap.c b/drivers/firmware/memmap.c
index 5de3ed292..d839c56af 100644
--- a/drivers/firmware/memmap.c
+++ b/drivers/firmware/memmap.c
@@ -124,7 +124,7 @@ static void __meminit release_firmware_map_entry(struct kobject *kobj)
 	kfree(entry);
 }
 
-static struct kobj_type __refdata memmap_ktype = {
+static const struct kobj_type __refconst memmap_ktype = {
 	.release	= release_firmware_map_entry,
 	.sysfs_ops	= &memmap_attr_ops,
 	.default_attrs	= def_attrs,
diff --git a/drivers/firmware/psci.c b/drivers/firmware/psci.c
index 8263429e2..d0ef61f7f 100644
--- a/drivers/firmware/psci.c
+++ b/drivers/firmware/psci.c
@@ -59,7 +59,7 @@ bool psci_tos_resident_on(int cpu)
 	return cpu == resident_cpu;
 }
 
-struct psci_operations psci_ops;
+struct psci_operations psci_ops __read_only;
 
 typedef unsigned long (psci_fn)(unsigned long, unsigned long,
 				unsigned long, unsigned long);
diff --git a/drivers/gpio/gpio-davinci.c b/drivers/gpio/gpio-davinci.c
index dd262f002..2834a849f 100644
--- a/drivers/gpio/gpio-davinci.c
+++ b/drivers/gpio/gpio-davinci.c
@@ -440,9 +440,9 @@ static struct irq_chip *davinci_gpio_get_irq_chip(unsigned int irq)
 	return &gpio_unbanked.chip;
 };
 
-static struct irq_chip *keystone_gpio_get_irq_chip(unsigned int irq)
+static irq_chip_no_const *keystone_gpio_get_irq_chip(unsigned int irq)
 {
-	static struct irq_chip gpio_unbanked;
+	static irq_chip_no_const gpio_unbanked;
 
 	gpio_unbanked = *irq_get_chip(irq);
 	return &gpio_unbanked;
@@ -472,7 +472,7 @@ static int davinci_gpio_irq_setup(struct platform_device *pdev)
 	struct davinci_gpio_regs __iomem *g;
 	struct irq_domain	*irq_domain = NULL;
 	const struct of_device_id *match;
-	struct irq_chip *irq_chip;
+	irq_chip_no_const *irq_chip;
 	gpio_get_irq_chip_cb_t gpio_get_irq_chip;
 
 	/*
diff --git a/drivers/gpio/gpio-em.c b/drivers/gpio/gpio-em.c
index 8d32ccc98..2d2ca6147 100644
--- a/drivers/gpio/gpio-em.c
+++ b/drivers/gpio/gpio-em.c
@@ -274,7 +274,7 @@ static int em_gio_probe(struct platform_device *pdev)
 	struct em_gio_priv *p;
 	struct resource *io[2], *irq[2];
 	struct gpio_chip *gpio_chip;
-	struct irq_chip *irq_chip;
+	irq_chip_no_const *irq_chip;
 	const char *name = dev_name(&pdev->dev);
 	unsigned int ngpios;
 	int ret;
diff --git a/drivers/gpio/gpio-ich.c b/drivers/gpio/gpio-ich.c
index 4f6d64351..eb4655ccb 100644
--- a/drivers/gpio/gpio-ich.c
+++ b/drivers/gpio/gpio-ich.c
@@ -95,7 +95,7 @@ struct ichx_desc {
 	 * this option allows driver caching written output values
 	 */
 	bool use_outlvl_cache;
-};
+} __do_const;
 
 static struct {
 	spinlock_t lock;
diff --git a/drivers/gpio/gpio-mpc8xxx.c b/drivers/gpio/gpio-mpc8xxx.c
index 793518a30..80ebce3f3 100644
--- a/drivers/gpio/gpio-mpc8xxx.c
+++ b/drivers/gpio/gpio-mpc8xxx.c
@@ -226,7 +226,7 @@ static int mpc512x_irq_set_type(struct irq_data *d, unsigned int flow_type)
 	return 0;
 }
 
-static struct irq_chip mpc8xxx_irq_chip = {
+static irq_chip_no_const mpc8xxx_irq_chip __read_only = {
 	.name		= "mpc8xxx-gpio",
 	.irq_unmask	= mpc8xxx_irq_unmask,
 	.irq_mask	= mpc8xxx_irq_mask,
@@ -337,7 +337,9 @@ static int mpc8xxx_probe(struct platform_device *pdev)
 	 * It's assumed that only a single type of gpio controller is available
 	 * on the current machine, so overwriting global data is fine.
 	 */
-	mpc8xxx_irq_chip.irq_set_type = devtype->irq_set_type;
+	pax_open_kernel();
+	const_cast(mpc8xxx_irq_chip.irq_set_type) = devtype->irq_set_type;
+	pax_close_kernel();
 
 	if (devtype->gpio_dir_out)
 		gc->direction_output = devtype->gpio_dir_out;
diff --git a/drivers/gpio/gpio-omap.c b/drivers/gpio/gpio-omap.c
index b98ede78c..c83e86072 100644
--- a/drivers/gpio/gpio-omap.c
+++ b/drivers/gpio/gpio-omap.c
@@ -1029,7 +1029,7 @@ static void omap_gpio_mod_init(struct gpio_bank *bank)
 		writel_relaxed(0, base + bank->regs->ctrl);
 }
 
-static int omap_gpio_chip_init(struct gpio_bank *bank, struct irq_chip *irqc)
+static int omap_gpio_chip_init(struct gpio_bank *bank, irq_chip_no_const *irqc)
 {
 	static int gpio;
 	int irq_base = 0;
@@ -1119,7 +1119,7 @@ static int omap_gpio_probe(struct platform_device *pdev)
 	const struct omap_gpio_platform_data *pdata;
 	struct resource *res;
 	struct gpio_bank *bank;
-	struct irq_chip *irqc;
+	irq_chip_no_const *irqc;
 	int ret;
 
 	match = of_match_device(of_match_ptr(omap_gpio_match), dev);
diff --git a/drivers/gpio/gpio-rcar.c b/drivers/gpio/gpio-rcar.c
index b96e0b466..c1e1b1693 100644
--- a/drivers/gpio/gpio-rcar.c
+++ b/drivers/gpio/gpio-rcar.c
@@ -391,7 +391,7 @@ static int gpio_rcar_probe(struct platform_device *pdev)
 	struct gpio_rcar_priv *p;
 	struct resource *io, *irq;
 	struct gpio_chip *gpio_chip;
-	struct irq_chip *irq_chip;
+	irq_chip_no_const *irq_chip;
 	struct device *dev = &pdev->dev;
 	const char *name = dev_name(dev);
 	unsigned int npins;
diff --git a/drivers/gpio/gpio-vr41xx.c b/drivers/gpio/gpio-vr41xx.c
index ac8deb01f..f3caa10c7 100644
--- a/drivers/gpio/gpio-vr41xx.c
+++ b/drivers/gpio/gpio-vr41xx.c
@@ -224,7 +224,7 @@ static int giu_get_irq(unsigned int irq)
 	printk(KERN_ERR "spurious GIU interrupt: %04x(%04x),%04x(%04x)\n",
 	       maskl, pendl, maskh, pendh);
 
-	atomic_inc(&irq_err_count);
+	atomic_inc_unchecked(&irq_err_count);
 
 	return -EINVAL;
 }
diff --git a/drivers/gpio/gpiolib.c b/drivers/gpio/gpiolib.c
index a8eea8a69..d131bfd48 100644
--- a/drivers/gpio/gpiolib.c
+++ b/drivers/gpio/gpiolib.c
@@ -1632,8 +1632,10 @@ static void gpiochip_irqchip_remove(struct gpio_chip *gpiochip)
 	}
 
 	if (gpiochip->irqchip) {
-		gpiochip->irqchip->irq_request_resources = NULL;
-		gpiochip->irqchip->irq_release_resources = NULL;
+		pax_open_kernel();
+		const_cast(gpiochip->irqchip->irq_request_resources) = NULL;
+		const_cast(gpiochip->irqchip->irq_release_resources) = NULL;
+		pax_close_kernel();
 		gpiochip->irqchip = NULL;
 	}
 }
@@ -1710,8 +1712,10 @@ int _gpiochip_irqchip_add(struct gpio_chip *gpiochip,
 	 */
 	if (!irqchip->irq_request_resources &&
 	    !irqchip->irq_release_resources) {
-		irqchip->irq_request_resources = gpiochip_irq_reqres;
-		irqchip->irq_release_resources = gpiochip_irq_relres;
+		pax_open_kernel();
+		const_cast(irqchip->irq_request_resources) = gpiochip_irq_reqres;
+		const_cast(irqchip->irq_release_resources) = gpiochip_irq_relres;
+		pax_close_kernel();
 	}
 
 	/*
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu.h b/drivers/gpu/drm/amd/amdgpu/amdgpu.h
index e443073f6..2ce0ad5a4 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu.h
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu.h
@@ -1797,7 +1797,7 @@ int amdgpu_debugfs_firmware_init(struct amdgpu_device *adev);
  * amdgpu smumgr functions
  */
 struct amdgpu_smumgr_funcs {
-	int (*check_fw_load_finish)(struct amdgpu_device *adev, uint32_t fwtype);
+	int (*check_fw_load_finish)(struct amdgpu_device *adev, enum AMDGPU_UCODE_ID fwtype);
 	int (*request_smu_load_fw)(struct amdgpu_device *adev);
 	int (*request_smu_specific_fw)(struct amdgpu_device *adev, uint32_t fwtype);
 };
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu_atpx_handler.c b/drivers/gpu/drm/amd/amdgpu/amdgpu_atpx_handler.c
index 1ed085f01..76d5db1cb 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu_atpx_handler.c
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu_atpx_handler.c
@@ -524,7 +524,7 @@ static int amdgpu_atpx_init(void)
  * look up whether we are the integrated or discrete GPU (all asics).
  * Returns the client id.
  */
-static int amdgpu_atpx_get_client_id(struct pci_dev *pdev)
+static enum vga_switcheroo_client_id amdgpu_atpx_get_client_id(struct pci_dev *pdev)
 {
 	if (amdgpu_atpx_priv.dhandle == ACPI_HANDLE(&pdev->dev))
 		return VGA_SWITCHEROO_IGD;
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu_cgs.c b/drivers/gpu/drm/amd/amdgpu/amdgpu_cgs.c
index 16e248e3f..71d1fd14d 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu_cgs.c
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu_cgs.c
@@ -1118,50 +1118,50 @@ static int amdgpu_cgs_call_acpi_method(struct cgs_device *cgs_device,
 }
 
 static const struct cgs_ops amdgpu_cgs_ops = {
-	amdgpu_cgs_gpu_mem_info,
-	amdgpu_cgs_gmap_kmem,
-	amdgpu_cgs_gunmap_kmem,
-	amdgpu_cgs_alloc_gpu_mem,
-	amdgpu_cgs_free_gpu_mem,
-	amdgpu_cgs_gmap_gpu_mem,
-	amdgpu_cgs_gunmap_gpu_mem,
-	amdgpu_cgs_kmap_gpu_mem,
-	amdgpu_cgs_kunmap_gpu_mem,
-	amdgpu_cgs_read_register,
-	amdgpu_cgs_write_register,
-	amdgpu_cgs_read_ind_register,
-	amdgpu_cgs_write_ind_register,
-	amdgpu_cgs_read_pci_config_byte,
-	amdgpu_cgs_read_pci_config_word,
-	amdgpu_cgs_read_pci_config_dword,
-	amdgpu_cgs_write_pci_config_byte,
-	amdgpu_cgs_write_pci_config_word,
-	amdgpu_cgs_write_pci_config_dword,
-	amdgpu_cgs_get_pci_resource,
-	amdgpu_cgs_atom_get_data_table,
-	amdgpu_cgs_atom_get_cmd_table_revs,
-	amdgpu_cgs_atom_exec_cmd_table,
-	amdgpu_cgs_create_pm_request,
-	amdgpu_cgs_destroy_pm_request,
-	amdgpu_cgs_set_pm_request,
-	amdgpu_cgs_pm_request_clock,
-	amdgpu_cgs_pm_request_engine,
-	amdgpu_cgs_pm_query_clock_limits,
-	amdgpu_cgs_set_camera_voltages,
-	amdgpu_cgs_get_firmware_info,
-	amdgpu_cgs_rel_firmware,
-	amdgpu_cgs_set_powergating_state,
-	amdgpu_cgs_set_clockgating_state,
-	amdgpu_cgs_get_active_displays_info,
-	amdgpu_cgs_notify_dpm_enabled,
-	amdgpu_cgs_call_acpi_method,
-	amdgpu_cgs_query_system_info,
+	.gpu_mem_info = amdgpu_cgs_gpu_mem_info,
+	.gmap_kmem = amdgpu_cgs_gmap_kmem,
+	.gunmap_kmem = amdgpu_cgs_gunmap_kmem,
+	.alloc_gpu_mem = amdgpu_cgs_alloc_gpu_mem,
+	.free_gpu_mem = amdgpu_cgs_free_gpu_mem,
+	.gmap_gpu_mem = amdgpu_cgs_gmap_gpu_mem,
+	.gunmap_gpu_mem = amdgpu_cgs_gunmap_gpu_mem,
+	.kmap_gpu_mem = amdgpu_cgs_kmap_gpu_mem,
+	.kunmap_gpu_mem = amdgpu_cgs_kunmap_gpu_mem,
+	.read_register = amdgpu_cgs_read_register,
+	.write_register = amdgpu_cgs_write_register,
+	.read_ind_register = amdgpu_cgs_read_ind_register,
+	.write_ind_register = amdgpu_cgs_write_ind_register,
+	.read_pci_config_byte = amdgpu_cgs_read_pci_config_byte,
+	.read_pci_config_word = amdgpu_cgs_read_pci_config_word,
+	.read_pci_config_dword = amdgpu_cgs_read_pci_config_dword,
+	.write_pci_config_byte = amdgpu_cgs_write_pci_config_byte,
+	.write_pci_config_word = amdgpu_cgs_write_pci_config_word,
+	.write_pci_config_dword = amdgpu_cgs_write_pci_config_dword,
+	.get_pci_resource = amdgpu_cgs_get_pci_resource,
+	.atom_get_data_table = amdgpu_cgs_atom_get_data_table,
+	.atom_get_cmd_table_revs = amdgpu_cgs_atom_get_cmd_table_revs,
+	.atom_exec_cmd_table = amdgpu_cgs_atom_exec_cmd_table,
+	.create_pm_request = amdgpu_cgs_create_pm_request,
+	.destroy_pm_request = amdgpu_cgs_destroy_pm_request,
+	.set_pm_request = amdgpu_cgs_set_pm_request,
+	.pm_request_clock = amdgpu_cgs_pm_request_clock,
+	.pm_request_engine = amdgpu_cgs_pm_request_engine,
+	.pm_query_clock_limits = amdgpu_cgs_pm_query_clock_limits,
+	.set_camera_voltages = amdgpu_cgs_set_camera_voltages,
+	.get_firmware_info = amdgpu_cgs_get_firmware_info,
+	.rel_firmware = amdgpu_cgs_rel_firmware,
+	.set_powergating_state = amdgpu_cgs_set_powergating_state,
+	.set_clockgating_state = amdgpu_cgs_set_clockgating_state,
+	.get_active_displays_info = amdgpu_cgs_get_active_displays_info,
+	.notify_dpm_enabled = amdgpu_cgs_notify_dpm_enabled,
+	.call_acpi_method = amdgpu_cgs_call_acpi_method,
+	.query_system_info = amdgpu_cgs_query_system_info
 };
 
 static const struct cgs_os_ops amdgpu_cgs_os_ops = {
-	amdgpu_cgs_add_irq_source,
-	amdgpu_cgs_irq_get,
-	amdgpu_cgs_irq_put
+	.add_irq_source = amdgpu_cgs_add_irq_source,
+	.irq_get = amdgpu_cgs_irq_get,
+	.irq_put = amdgpu_cgs_irq_put
 };
 
 struct cgs_device *amdgpu_cgs_create_device(struct amdgpu_device *adev)
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu_connectors.c b/drivers/gpu/drm/amd/amdgpu/amdgpu_connectors.c
index ff0b55a65..c58880ee9 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu_connectors.c
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu_connectors.c
@@ -701,7 +701,7 @@ static int amdgpu_connector_lvds_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int amdgpu_connector_lvds_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status amdgpu_connector_lvds_mode_valid(struct drm_connector *connector,
 					     struct drm_display_mode *mode)
 {
 	struct drm_encoder *encoder = amdgpu_connector_best_single_encoder(connector);
@@ -838,7 +838,7 @@ static int amdgpu_connector_vga_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int amdgpu_connector_vga_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status amdgpu_connector_vga_mode_valid(struct drm_connector *connector,
 					    struct drm_display_mode *mode)
 {
 	struct drm_device *dev = connector->dev;
@@ -1158,7 +1158,7 @@ static void amdgpu_connector_dvi_force(struct drm_connector *connector)
 		amdgpu_connector->use_digital = true;
 }
 
-static int amdgpu_connector_dvi_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status amdgpu_connector_dvi_mode_valid(struct drm_connector *connector,
 					    struct drm_display_mode *mode)
 {
 	struct drm_device *dev = connector->dev;
@@ -1427,7 +1427,7 @@ out:
 	return ret;
 }
 
-static int amdgpu_connector_dp_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status amdgpu_connector_dp_mode_valid(struct drm_connector *connector,
 					   struct drm_display_mode *mode)
 {
 	struct amdgpu_connector *amdgpu_connector = to_amdgpu_connector(connector);
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu_device.c b/drivers/gpu/drm/amd/amdgpu/amdgpu_device.c
index 39c01b942..ced138c5c 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu_device.c
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu_device.c
@@ -1059,7 +1059,7 @@ static bool amdgpu_switcheroo_can_switch(struct pci_dev *pdev)
 	* locking inversion with the driver load path. And the access here is
 	* completely racy anyway. So don't bother with locking for now.
 	*/
-	return dev->open_count == 0;
+	return local_read(&dev->open_count) == 0;
 }
 
 static const struct vga_switcheroo_client_ops amdgpu_switcheroo_ops = {
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu_drv.c b/drivers/gpu/drm/amd/amdgpu/amdgpu_drv.c
index 414a1600d..d0bb0acf6 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu_drv.c
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu_drv.c
@@ -588,9 +588,6 @@ static struct drm_driver kms_driver = {
 	.patchlevel = KMS_DRIVER_PATCHLEVEL,
 };
 
-static struct drm_driver *driver;
-static struct pci_driver *pdriver;
-
 static struct pci_driver amdgpu_kms_pci_driver = {
 	.name = DRIVER_NAME,
 	.id_table = pciidlist,
@@ -611,18 +608,20 @@ static int __init amdgpu_init(void)
 		return -EINVAL;
 	}
 	DRM_INFO("amdgpu kernel modesetting enabled.\n");
-	driver = &kms_driver;
-	pdriver = &amdgpu_kms_pci_driver;
-	driver->num_ioctls = amdgpu_max_kms_ioctl;
+
+	pax_open_kernel();
+	const_cast(kms_driver.num_ioctls) = amdgpu_max_kms_ioctl;
+	pax_close_kernel();
+
 	amdgpu_register_atpx_handler();
 	/* let modprobe override vga console setting */
-	return drm_pci_init(driver, pdriver);
+	return drm_pci_init(&kms_driver, &amdgpu_kms_pci_driver);
 }
 
 static void __exit amdgpu_exit(void)
 {
 	amdgpu_amdkfd_fini();
-	drm_pci_exit(driver, pdriver);
+	drm_pci_exit(&kms_driver, &amdgpu_kms_pci_driver);
 	amdgpu_unregister_atpx_handler();
 	amdgpu_sync_fini();
 	amd_sched_fence_slab_fini();
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu_gfx.h b/drivers/gpu/drm/amd/amdgpu/amdgpu_gfx.h
index 51321e154..3c80c0b23 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu_gfx.h
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu_gfx.h
@@ -27,6 +27,6 @@
 int amdgpu_gfx_scratch_get(struct amdgpu_device *adev, uint32_t *reg);
 void amdgpu_gfx_scratch_free(struct amdgpu_device *adev, uint32_t reg);
 
-unsigned amdgpu_gfx_parse_disable_cu(unsigned *mask, unsigned max_se, unsigned max_sh);
+void amdgpu_gfx_parse_disable_cu(unsigned *mask, unsigned max_se, unsigned max_sh);
 
 #endif
diff --git a/drivers/gpu/drm/amd/amdgpu/amdgpu_vm.c b/drivers/gpu/drm/amd/amdgpu/amdgpu_vm.c
index e86ca392a..f935a899b 100644
--- a/drivers/gpu/drm/amd/amdgpu/amdgpu_vm.c
+++ b/drivers/gpu/drm/amd/amdgpu/amdgpu_vm.c
@@ -202,7 +202,7 @@ int amdgpu_vm_grab_id(struct amdgpu_vm *vm, struct amdgpu_ring *ring,
 	unsigned i;
 	int r = 0;
 
-	fences = kmalloc_array(sizeof(void *), adev->vm_manager.num_ids,
+	fences = kmalloc_array(adev->vm_manager.num_ids, sizeof(void *),
 			       GFP_KERNEL);
 	if (!fences)
 		return -ENOMEM;
diff --git a/drivers/gpu/drm/amd/amdgpu/fiji_smc.c b/drivers/gpu/drm/amd/amdgpu/fiji_smc.c
index b3e19ba4c..28942dbea 100644
--- a/drivers/gpu/drm/amd/amdgpu/fiji_smc.c
+++ b/drivers/gpu/drm/amd/amdgpu/fiji_smc.c
@@ -519,7 +519,7 @@ static int fiji_smu_request_load_fw(struct amdgpu_device *adev)
 	return 0;
 }
 
-static uint32_t fiji_smu_get_mask_for_fw_type(uint32_t fw_type)
+static uint32_t fiji_smu_get_mask_for_fw_type(enum AMDGPU_UCODE_ID fw_type)
 {
 	switch (fw_type) {
 		case AMDGPU_UCODE_ID_SDMA0:
@@ -545,7 +545,7 @@ static uint32_t fiji_smu_get_mask_for_fw_type(uint32_t fw_type)
 }
 
 static int fiji_smu_check_fw_load_finish(struct amdgpu_device *adev,
-					uint32_t fw_type)
+					enum AMDGPU_UCODE_ID fw_type)
 {
 	uint32_t fw_mask = fiji_smu_get_mask_for_fw_type(fw_type);
 	int i;
diff --git a/drivers/gpu/drm/amd/amdgpu/iceland_smc.c b/drivers/gpu/drm/amd/amdgpu/iceland_smc.c
index 211839913..8f80ddcce 100644
--- a/drivers/gpu/drm/amd/amdgpu/iceland_smc.c
+++ b/drivers/gpu/drm/amd/amdgpu/iceland_smc.c
@@ -424,7 +424,7 @@ static enum AMDGPU_UCODE_ID iceland_convert_fw_type(uint32_t fw_type)
 	}
 }
 
-static uint32_t iceland_smu_get_mask_for_fw_type(uint32_t fw_type)
+static uint32_t iceland_smu_get_mask_for_fw_type(enum AMDGPU_UCODE_ID fw_type)
 {
 	switch (fw_type) {
 		case AMDGPU_UCODE_ID_SDMA0:
@@ -562,7 +562,7 @@ static int iceland_smu_request_load_fw(struct amdgpu_device *adev)
 }
 
 static int iceland_smu_check_fw_load_finish(struct amdgpu_device *adev,
-					    uint32_t fw_type)
+					    enum AMDGPU_UCODE_ID fw_type)
 {
 	uint32_t fw_mask = iceland_smu_get_mask_for_fw_type(fw_type);
 	int i;
diff --git a/drivers/gpu/drm/amd/amdgpu/tonga_smc.c b/drivers/gpu/drm/amd/amdgpu/tonga_smc.c
index 940de1836..9ef25f795 100644
--- a/drivers/gpu/drm/amd/amdgpu/tonga_smc.c
+++ b/drivers/gpu/drm/amd/amdgpu/tonga_smc.c
@@ -521,7 +521,7 @@ static int tonga_smu_request_load_fw(struct amdgpu_device *adev)
 	return 0;
 }
 
-static uint32_t tonga_smu_get_mask_for_fw_type(uint32_t fw_type)
+static uint32_t tonga_smu_get_mask_for_fw_type(enum AMDGPU_UCODE_ID fw_type)
 {
 	switch (fw_type) {
 		case AMDGPU_UCODE_ID_SDMA0:
@@ -547,7 +547,7 @@ static uint32_t tonga_smu_get_mask_for_fw_type(uint32_t fw_type)
 }
 
 static int tonga_smu_check_fw_load_finish(struct amdgpu_device *adev,
-					uint32_t fw_type)
+					enum AMDGPU_UCODE_ID fw_type)
 {
 	uint32_t fw_mask = tonga_smu_get_mask_for_fw_type(fw_type);
 	int i;
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_chardev.c b/drivers/gpu/drm/amd/amdkfd/kfd_chardev.c
index ee3e04e10..65f743671 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_chardev.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_chardev.c
@@ -418,7 +418,7 @@ static int kfd_ioctl_set_memory_policy(struct file *filep,
 		(args->alternate_policy == KFD_IOC_CACHE_POLICY_COHERENT)
 		   ? cache_policy_coherent : cache_policy_noncoherent;
 
-	if (!dev->dqm->ops.set_cache_memory_policy(dev->dqm,
+	if (!dev->dqm->ops->set_cache_memory_policy(dev->dqm,
 				&pdd->qpd,
 				default_policy,
 				alternate_policy,
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_device.c b/drivers/gpu/drm/amd/amdkfd/kfd_device.c
index 3f95f7cb4..0a62dad34 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_device.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_device.c
@@ -298,7 +298,7 @@ bool kgd2kfd_device_init(struct kfd_dev *kfd,
 		goto device_queue_manager_error;
 	}
 
-	if (kfd->dqm->ops.start(kfd->dqm) != 0) {
+	if (kfd->dqm->ops->start(kfd->dqm) != 0) {
 		dev_err(kfd_device,
 			"Error starting queuen manager for device (%x:%x)\n",
 			kfd->pdev->vendor, kfd->pdev->device);
@@ -354,7 +354,7 @@ void kgd2kfd_suspend(struct kfd_dev *kfd)
 	BUG_ON(kfd == NULL);
 
 	if (kfd->init_complete) {
-		kfd->dqm->ops.stop(kfd->dqm);
+		kfd->dqm->ops->stop(kfd->dqm);
 		amd_iommu_set_invalidate_ctx_cb(kfd->pdev, NULL);
 		amd_iommu_set_invalid_ppr_cb(kfd->pdev, NULL);
 		amd_iommu_free_device(kfd->pdev);
@@ -377,7 +377,7 @@ int kgd2kfd_resume(struct kfd_dev *kfd)
 		amd_iommu_set_invalidate_ctx_cb(kfd->pdev,
 						iommu_pasid_shutdown_callback);
 		amd_iommu_set_invalid_ppr_cb(kfd->pdev, iommu_invalid_ppr_cb);
-		kfd->dqm->ops.start(kfd->dqm);
+		kfd->dqm->ops->start(kfd->dqm);
 	}
 
 	return 0;
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.c b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.c
index f49c55119..ad74c7ef3 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.c
@@ -242,7 +242,7 @@ static int create_compute_queue_nocpsch(struct device_queue_manager *dqm,
 
 	BUG_ON(!dqm || !q || !qpd);
 
-	mqd = dqm->ops.get_mqd_manager(dqm, KFD_MQD_TYPE_COMPUTE);
+	mqd = dqm->ops->get_mqd_manager(dqm, KFD_MQD_TYPE_COMPUTE);
 	if (mqd == NULL)
 		return -ENOMEM;
 
@@ -288,14 +288,14 @@ static int destroy_queue_nocpsch(struct device_queue_manager *dqm,
 	mutex_lock(&dqm->lock);
 
 	if (q->properties.type == KFD_QUEUE_TYPE_COMPUTE) {
-		mqd = dqm->ops.get_mqd_manager(dqm, KFD_MQD_TYPE_COMPUTE);
+		mqd = dqm->ops->get_mqd_manager(dqm, KFD_MQD_TYPE_COMPUTE);
 		if (mqd == NULL) {
 			retval = -ENOMEM;
 			goto out;
 		}
 		deallocate_hqd(dqm, q);
 	} else if (q->properties.type == KFD_QUEUE_TYPE_SDMA) {
-		mqd = dqm->ops.get_mqd_manager(dqm, KFD_MQD_TYPE_SDMA);
+		mqd = dqm->ops->get_mqd_manager(dqm, KFD_MQD_TYPE_SDMA);
 		if (mqd == NULL) {
 			retval = -ENOMEM;
 			goto out;
@@ -347,7 +347,7 @@ static int update_queue(struct device_queue_manager *dqm, struct queue *q)
 	BUG_ON(!dqm || !q || !q->mqd);
 
 	mutex_lock(&dqm->lock);
-	mqd = dqm->ops.get_mqd_manager(dqm,
+	mqd = dqm->ops->get_mqd_manager(dqm,
 			get_mqd_type_from_queue_type(q->properties.type));
 	if (mqd == NULL) {
 		mutex_unlock(&dqm->lock);
@@ -414,7 +414,7 @@ static int register_process_nocpsch(struct device_queue_manager *dqm,
 	mutex_lock(&dqm->lock);
 	list_add(&n->list, &dqm->queues);
 
-	retval = dqm->ops_asic_specific.register_process(dqm, qpd);
+	retval = dqm->ops_asic_specific->register_process(dqm, qpd);
 
 	dqm->processes_count++;
 
@@ -502,7 +502,7 @@ int init_pipelines(struct device_queue_manager *dqm,
 
 	memset(hpdptr, 0, CIK_HPD_EOP_BYTES * pipes_num);
 
-	mqd = dqm->ops.get_mqd_manager(dqm, KFD_MQD_TYPE_COMPUTE);
+	mqd = dqm->ops->get_mqd_manager(dqm, KFD_MQD_TYPE_COMPUTE);
 	if (mqd == NULL) {
 		kfd_gtt_sa_free(dqm->dev, dqm->pipeline_mem);
 		return -ENOMEM;
@@ -635,7 +635,7 @@ static int create_sdma_queue_nocpsch(struct device_queue_manager *dqm,
 	struct mqd_manager *mqd;
 	int retval;
 
-	mqd = dqm->ops.get_mqd_manager(dqm, KFD_MQD_TYPE_SDMA);
+	mqd = dqm->ops->get_mqd_manager(dqm, KFD_MQD_TYPE_SDMA);
 	if (!mqd)
 		return -ENOMEM;
 
@@ -650,7 +650,7 @@ static int create_sdma_queue_nocpsch(struct device_queue_manager *dqm,
 	pr_debug("     sdma queue id: %d\n", q->properties.sdma_queue_id);
 	pr_debug("     sdma engine id: %d\n", q->properties.sdma_engine_id);
 
-	dqm->ops_asic_specific.init_sdma_vm(dqm, q, qpd);
+	dqm->ops_asic_specific->init_sdma_vm(dqm, q, qpd);
 	retval = mqd->init_mqd(mqd, &q->mqd, &q->mqd_mem_obj,
 				&q->gart_mqd_addr, &q->properties);
 	if (retval != 0) {
@@ -712,7 +712,7 @@ static int initialize_cpsch(struct device_queue_manager *dqm)
 	dqm->queue_count = dqm->processes_count = 0;
 	dqm->sdma_queue_count = 0;
 	dqm->active_runlist = false;
-	retval = dqm->ops_asic_specific.initialize(dqm);
+	retval = dqm->ops_asic_specific->initialize(dqm);
 	if (retval != 0)
 		goto fail_init_pipelines;
 
@@ -879,7 +879,7 @@ static int create_queue_cpsch(struct device_queue_manager *dqm, struct queue *q,
 	if (q->properties.type == KFD_QUEUE_TYPE_SDMA)
 		select_sdma_engine_id(q);
 
-	mqd = dqm->ops.get_mqd_manager(dqm,
+	mqd = dqm->ops->get_mqd_manager(dqm,
 			get_mqd_type_from_queue_type(q->properties.type));
 
 	if (mqd == NULL) {
@@ -887,7 +887,7 @@ static int create_queue_cpsch(struct device_queue_manager *dqm, struct queue *q,
 		return -ENOMEM;
 	}
 
-	dqm->ops_asic_specific.init_sdma_vm(dqm, q, qpd);
+	dqm->ops_asic_specific->init_sdma_vm(dqm, q, qpd);
 	retval = mqd->init_mqd(mqd, &q->mqd, &q->mqd_mem_obj,
 				&q->gart_mqd_addr, &q->properties);
 	if (retval != 0)
@@ -1060,7 +1060,7 @@ static int destroy_queue_cpsch(struct device_queue_manager *dqm,
 
 	}
 
-	mqd = dqm->ops.get_mqd_manager(dqm,
+	mqd = dqm->ops->get_mqd_manager(dqm,
 			get_mqd_type_from_queue_type(q->properties.type));
 	if (!mqd) {
 		retval = -ENOMEM;
@@ -1149,7 +1149,7 @@ static bool set_cache_memory_policy(struct device_queue_manager *dqm,
 		qpd->sh_mem_ape1_limit = limit >> 16;
 	}
 
-	retval = dqm->ops_asic_specific.set_cache_memory_policy(
+	retval = dqm->ops_asic_specific->set_cache_memory_policy(
 			dqm,
 			qpd,
 			default_policy,
@@ -1172,6 +1172,36 @@ out:
 	return false;
 }
 
+static const struct device_queue_manager_ops cp_dqm_ops = {
+	.create_queue = create_queue_cpsch,
+	.initialize = initialize_cpsch,
+	.start = start_cpsch,
+	.stop = stop_cpsch,
+	.destroy_queue = destroy_queue_cpsch,
+	.update_queue = update_queue,
+	.get_mqd_manager = get_mqd_manager_nocpsch,
+	.register_process = register_process_nocpsch,
+	.unregister_process = unregister_process_nocpsch,
+	.uninitialize = uninitialize_nocpsch,
+	.create_kernel_queue = create_kernel_queue_cpsch,
+	.destroy_kernel_queue = destroy_kernel_queue_cpsch,
+	.set_cache_memory_policy = set_cache_memory_policy,
+};
+
+static const struct device_queue_manager_ops no_cp_dqm_ops = {
+	.start = start_nocpsch,
+	.stop = stop_nocpsch,
+	.create_queue = create_queue_nocpsch,
+	.destroy_queue = destroy_queue_nocpsch,
+	.update_queue = update_queue,
+	.get_mqd_manager = get_mqd_manager_nocpsch,
+	.register_process = register_process_nocpsch,
+	.unregister_process = unregister_process_nocpsch,
+	.initialize = initialize_nocpsch,
+	.uninitialize = uninitialize_nocpsch,
+	.set_cache_memory_policy = set_cache_memory_policy,
+};
+
 struct device_queue_manager *device_queue_manager_init(struct kfd_dev *dev)
 {
 	struct device_queue_manager *dqm;
@@ -1189,33 +1219,11 @@ struct device_queue_manager *device_queue_manager_init(struct kfd_dev *dev)
 	case KFD_SCHED_POLICY_HWS:
 	case KFD_SCHED_POLICY_HWS_NO_OVERSUBSCRIPTION:
 		/* initialize dqm for cp scheduling */
-		dqm->ops.create_queue = create_queue_cpsch;
-		dqm->ops.initialize = initialize_cpsch;
-		dqm->ops.start = start_cpsch;
-		dqm->ops.stop = stop_cpsch;
-		dqm->ops.destroy_queue = destroy_queue_cpsch;
-		dqm->ops.update_queue = update_queue;
-		dqm->ops.get_mqd_manager = get_mqd_manager_nocpsch;
-		dqm->ops.register_process = register_process_nocpsch;
-		dqm->ops.unregister_process = unregister_process_nocpsch;
-		dqm->ops.uninitialize = uninitialize_nocpsch;
-		dqm->ops.create_kernel_queue = create_kernel_queue_cpsch;
-		dqm->ops.destroy_kernel_queue = destroy_kernel_queue_cpsch;
-		dqm->ops.set_cache_memory_policy = set_cache_memory_policy;
+		dqm->ops = &cp_dqm_ops;
 		break;
 	case KFD_SCHED_POLICY_NO_HWS:
 		/* initialize dqm for no cp scheduling */
-		dqm->ops.start = start_nocpsch;
-		dqm->ops.stop = stop_nocpsch;
-		dqm->ops.create_queue = create_queue_nocpsch;
-		dqm->ops.destroy_queue = destroy_queue_nocpsch;
-		dqm->ops.update_queue = update_queue;
-		dqm->ops.get_mqd_manager = get_mqd_manager_nocpsch;
-		dqm->ops.register_process = register_process_nocpsch;
-		dqm->ops.unregister_process = unregister_process_nocpsch;
-		dqm->ops.initialize = initialize_nocpsch;
-		dqm->ops.uninitialize = uninitialize_nocpsch;
-		dqm->ops.set_cache_memory_policy = set_cache_memory_policy;
+		dqm->ops = &no_cp_dqm_ops;
 		break;
 	default:
 		BUG();
@@ -1224,15 +1232,15 @@ struct device_queue_manager *device_queue_manager_init(struct kfd_dev *dev)
 
 	switch (dev->device_info->asic_family) {
 	case CHIP_CARRIZO:
-		device_queue_manager_init_vi(&dqm->ops_asic_specific);
+		device_queue_manager_init_vi(dqm);
 		break;
 
 	case CHIP_KAVERI:
-		device_queue_manager_init_cik(&dqm->ops_asic_specific);
+		device_queue_manager_init_cik(dqm);
 		break;
 	}
 
-	if (dqm->ops.initialize(dqm) != 0) {
+	if (dqm->ops->initialize(dqm) != 0) {
 		kfree(dqm);
 		return NULL;
 	}
@@ -1244,6 +1252,6 @@ void device_queue_manager_uninit(struct device_queue_manager *dqm)
 {
 	BUG_ON(!dqm);
 
-	dqm->ops.uninitialize(dqm);
+	dqm->ops->uninitialize(dqm);
 	kfree(dqm);
 }
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.h b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.h
index a625b9137..411e7d18b 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.h
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager.h
@@ -154,8 +154,8 @@ struct device_queue_manager_asic_ops {
  */
 
 struct device_queue_manager {
-	struct device_queue_manager_ops ops;
-	struct device_queue_manager_asic_ops ops_asic_specific;
+	const struct device_queue_manager_ops *ops;
+	const struct device_queue_manager_asic_ops *ops_asic_specific;
 
 	struct mqd_manager	*mqds[KFD_MQD_TYPE_MAX];
 	struct packet_manager	packets;
@@ -178,8 +178,8 @@ struct device_queue_manager {
 	bool			active_runlist;
 };
 
-void device_queue_manager_init_cik(struct device_queue_manager_asic_ops *ops);
-void device_queue_manager_init_vi(struct device_queue_manager_asic_ops *ops);
+void device_queue_manager_init_cik(struct device_queue_manager *dqm);
+void device_queue_manager_init_vi(struct device_queue_manager *dqm);
 void program_sh_mem_settings(struct device_queue_manager *dqm,
 					struct qcm_process_device *qpd);
 int init_pipelines(struct device_queue_manager *dqm,
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_cik.c b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_cik.c
index c6f435aa8..34fb24774 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_cik.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_cik.c
@@ -37,12 +37,16 @@ static int initialize_cpsch_cik(struct device_queue_manager *dqm);
 static void init_sdma_vm(struct device_queue_manager *dqm, struct queue *q,
 				struct qcm_process_device *qpd);
 
-void device_queue_manager_init_cik(struct device_queue_manager_asic_ops *ops)
+static const struct device_queue_manager_asic_ops cik_dqm_asic_ops = {
+	.set_cache_memory_policy = set_cache_memory_policy_cik,
+	.register_process = register_process_cik,
+	.initialize = initialize_cpsch_cik,
+	.init_sdma_vm = init_sdma_vm,
+};
+
+void device_queue_manager_init_cik(struct device_queue_manager *dqm)
 {
-	ops->set_cache_memory_policy = set_cache_memory_policy_cik;
-	ops->register_process = register_process_cik;
-	ops->initialize = initialize_cpsch_cik;
-	ops->init_sdma_vm = init_sdma_vm;
+	dqm->ops_asic_specific = &cik_dqm_asic_ops;
 }
 
 static uint32_t compute_sh_mem_bases_64bit(unsigned int top_address_nybble)
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_vi.c b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_vi.c
index 7e9cae9d3..fbe7ba5f7 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_vi.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_device_queue_manager_vi.c
@@ -39,12 +39,16 @@ static int initialize_cpsch_vi(struct device_queue_manager *dqm);
 static void init_sdma_vm(struct device_queue_manager *dqm, struct queue *q,
 				struct qcm_process_device *qpd);
 
-void device_queue_manager_init_vi(struct device_queue_manager_asic_ops *ops)
+static const struct device_queue_manager_asic_ops vi_dqm_asic_ops = {
+	.set_cache_memory_policy = set_cache_memory_policy_vi,
+	.register_process = register_process_vi,
+	.initialize = initialize_cpsch_vi,
+	.init_sdma_vm = init_sdma_vm,
+};
+
+void device_queue_manager_init_vi(struct device_queue_manager *dqm)
 {
-	ops->set_cache_memory_policy = set_cache_memory_policy_vi;
-	ops->register_process = register_process_vi;
-	ops->initialize = initialize_cpsch_vi;
-	ops->init_sdma_vm = init_sdma_vm;
+	dqm->ops_asic_specific = &vi_dqm_asic_ops;
 }
 
 static uint32_t compute_sh_mem_bases_64bit(unsigned int top_address_nybble)
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_interrupt.c b/drivers/gpu/drm/amd/amdkfd/kfd_interrupt.c
index 7f134aa9b..cd34d4a0d 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_interrupt.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_interrupt.c
@@ -50,8 +50,8 @@ static void interrupt_wq(struct work_struct *);
 
 int kfd_interrupt_init(struct kfd_dev *kfd)
 {
-	void *interrupt_ring = kmalloc_array(KFD_INTERRUPT_RING_SIZE,
-					kfd->device_info->ih_ring_entry_size,
+	void *interrupt_ring = kmalloc_array(kfd->device_info->ih_ring_entry_size,
+					KFD_INTERRUPT_RING_SIZE,
 					GFP_KERNEL);
 	if (!interrupt_ring)
 		return -ENOMEM;
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.c b/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.c
index 9beae87aa..1fe932617 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.c
@@ -56,7 +56,7 @@ static bool initialize(struct kernel_queue *kq, struct kfd_dev *dev,
 	switch (type) {
 	case KFD_QUEUE_TYPE_DIQ:
 	case KFD_QUEUE_TYPE_HIQ:
-		kq->mqd = dev->dqm->ops.get_mqd_manager(dev->dqm,
+		kq->mqd = dev->dqm->ops->get_mqd_manager(dev->dqm,
 						KFD_MQD_TYPE_HIQ);
 		break;
 	default:
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.h b/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.h
index 594053136..a75b0e591 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.h
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_kernel_queue.h
@@ -62,7 +62,7 @@ struct kernel_queue_ops {
 
 	void	(*submit_packet)(struct kernel_queue *kq);
 	void	(*rollback_packet)(struct kernel_queue *kq);
-};
+} __no_const;
 
 struct kernel_queue {
 	struct kernel_queue_ops ops;
diff --git a/drivers/gpu/drm/amd/amdkfd/kfd_process_queue_manager.c b/drivers/gpu/drm/amd/amdkfd/kfd_process_queue_manager.c
index 7b69070f7..d7bd78baf 100644
--- a/drivers/gpu/drm/amd/amdkfd/kfd_process_queue_manager.c
+++ b/drivers/gpu/drm/amd/amdkfd/kfd_process_queue_manager.c
@@ -194,7 +194,7 @@ int pqm_create_queue(struct process_queue_manager *pqm,
 
 	if (list_empty(&pqm->queues)) {
 		pdd->qpd.pqm = pqm;
-		dev->dqm->ops.register_process(dev->dqm, &pdd->qpd);
+		dev->dqm->ops->register_process(dev->dqm, &pdd->qpd);
 	}
 
 	pqn = kzalloc(sizeof(struct process_queue_node), GFP_KERNEL);
@@ -220,7 +220,7 @@ int pqm_create_queue(struct process_queue_manager *pqm,
 			goto err_create_queue;
 		pqn->q = q;
 		pqn->kq = NULL;
-		retval = dev->dqm->ops.create_queue(dev->dqm, q, &pdd->qpd,
+		retval = dev->dqm->ops->create_queue(dev->dqm, q, &pdd->qpd,
 						&q->properties.vmid);
 		pr_debug("DQM returned %d for create_queue\n", retval);
 		print_queue(q);
@@ -234,7 +234,7 @@ int pqm_create_queue(struct process_queue_manager *pqm,
 		kq->queue->properties.queue_id = *qid;
 		pqn->kq = kq;
 		pqn->q = NULL;
-		retval = dev->dqm->ops.create_kernel_queue(dev->dqm,
+		retval = dev->dqm->ops->create_kernel_queue(dev->dqm,
 							kq, &pdd->qpd);
 		break;
 	default:
@@ -265,7 +265,7 @@ err_allocate_pqn:
 	/* check if queues list is empty unregister process from device */
 	clear_bit(*qid, pqm->queue_slot_bitmap);
 	if (list_empty(&pqm->queues))
-		dev->dqm->ops.unregister_process(dev->dqm, &pdd->qpd);
+		dev->dqm->ops->unregister_process(dev->dqm, &pdd->qpd);
 	return retval;
 }
 
@@ -306,13 +306,13 @@ int pqm_destroy_queue(struct process_queue_manager *pqm, unsigned int qid)
 	if (pqn->kq) {
 		/* destroy kernel queue (DIQ) */
 		dqm = pqn->kq->dev->dqm;
-		dqm->ops.destroy_kernel_queue(dqm, pqn->kq, &pdd->qpd);
+		dqm->ops->destroy_kernel_queue(dqm, pqn->kq, &pdd->qpd);
 		kernel_queue_uninit(pqn->kq);
 	}
 
 	if (pqn->q) {
 		dqm = pqn->q->device->dqm;
-		retval = dqm->ops.destroy_queue(dqm, &pdd->qpd, pqn->q);
+		retval = dqm->ops->destroy_queue(dqm, &pdd->qpd, pqn->q);
 		if (retval != 0)
 			return retval;
 
@@ -324,7 +324,7 @@ int pqm_destroy_queue(struct process_queue_manager *pqm, unsigned int qid)
 	clear_bit(qid, pqm->queue_slot_bitmap);
 
 	if (list_empty(&pqm->queues))
-		dqm->ops.unregister_process(dqm, &pdd->qpd);
+		dqm->ops->unregister_process(dqm, &pdd->qpd);
 
 	return retval;
 }
@@ -349,7 +349,7 @@ int pqm_update_queue(struct process_queue_manager *pqm, unsigned int qid,
 	pqn->q->properties.queue_percent = p->queue_percent;
 	pqn->q->properties.priority = p->priority;
 
-	retval = pqn->q->device->dqm->ops.update_queue(pqn->q->device->dqm,
+	retval = pqn->q->device->dqm->ops->update_queue(pqn->q->device->dqm,
 							pqn->q);
 	if (retval != 0)
 		return retval;
diff --git a/drivers/gpu/drm/amd/powerplay/hwmgr/cz_clockpowergating.c b/drivers/gpu/drm/amd/powerplay/hwmgr/cz_clockpowergating.c
index 2028980f1..484984bfd 100644
--- a/drivers/gpu/drm/amd/powerplay/hwmgr/cz_clockpowergating.c
+++ b/drivers/gpu/drm/amd/powerplay/hwmgr/cz_clockpowergating.c
@@ -240,10 +240,16 @@ int cz_dpm_powergate_vce(struct pp_hwmgr *hwmgr, bool bgate)
 
 static const struct phm_master_table_item cz_enable_clock_power_gatings_list[] = {
 	/*we don't need an exit table here, because there is only D3 cold on Kv*/
-	{ phm_cf_want_uvd_power_gating, cz_tf_uvd_power_gating_initialize },
-	{ phm_cf_want_vce_power_gating, cz_tf_vce_power_gating_initialize },
+	{
+	  .isFunctionNeededInRuntimeTable = phm_cf_want_uvd_power_gating,
+	  .tableFunction = cz_tf_uvd_power_gating_initialize
+	},
+	{
+	  .isFunctionNeededInRuntimeTable = phm_cf_want_vce_power_gating,
+	  .tableFunction = cz_tf_vce_power_gating_initialize
+	},
 	/* to do { NULL, cz_tf_xdma_power_gating_enable }, */
-	{ NULL, NULL }
+	{ }
 };
 
 const struct phm_master_table_header cz_phm_enable_clock_power_gatings_master = {
diff --git a/drivers/gpu/drm/amd/powerplay/hwmgr/cz_hwmgr.c b/drivers/gpu/drm/amd/powerplay/hwmgr/cz_hwmgr.c
index 8cc0df9b5..365a42c47 100644
--- a/drivers/gpu/drm/amd/powerplay/hwmgr/cz_hwmgr.c
+++ b/drivers/gpu/drm/amd/powerplay/hwmgr/cz_hwmgr.c
@@ -916,13 +916,13 @@ static int cz_tf_update_low_mem_pstate(struct pp_hwmgr *hwmgr,
 }
 
 static const struct phm_master_table_item cz_set_power_state_list[] = {
-	{NULL, cz_tf_update_sclk_limit},
-	{NULL, cz_tf_set_deep_sleep_sclk_threshold},
-	{NULL, cz_tf_set_watermark_threshold},
-	{NULL, cz_tf_set_enabled_levels},
-	{NULL, cz_tf_enable_nb_dpm},
-	{NULL, cz_tf_update_low_mem_pstate},
-	{NULL, NULL}
+	{ .tableFunction = cz_tf_update_sclk_limit },
+	{ .tableFunction = cz_tf_set_deep_sleep_sclk_threshold },
+	{ .tableFunction = cz_tf_set_watermark_threshold },
+	{ .tableFunction = cz_tf_set_enabled_levels },
+	{ .tableFunction = cz_tf_enable_nb_dpm },
+	{ .tableFunction = cz_tf_update_low_mem_pstate },
+	{ }
 };
 
 static const struct phm_master_table_header cz_set_power_state_master = {
@@ -932,15 +932,15 @@ static const struct phm_master_table_header cz_set_power_state_master = {
 };
 
 static const struct phm_master_table_item cz_setup_asic_list[] = {
-	{NULL, cz_tf_reset_active_process_mask},
-	{NULL, cz_tf_upload_pptable_to_smu},
-	{NULL, cz_tf_init_sclk_limit},
-	{NULL, cz_tf_init_uvd_limit},
-	{NULL, cz_tf_init_vce_limit},
-	{NULL, cz_tf_init_acp_limit},
-	{NULL, cz_tf_init_power_gate_state},
-	{NULL, cz_tf_init_sclk_threshold},
-	{NULL, NULL}
+	{ .tableFunction = cz_tf_reset_active_process_mask },
+	{ .tableFunction = cz_tf_upload_pptable_to_smu },
+	{ .tableFunction = cz_tf_init_sclk_limit },
+	{ .tableFunction = cz_tf_init_uvd_limit },
+	{ .tableFunction = cz_tf_init_vce_limit },
+	{ .tableFunction = cz_tf_init_acp_limit },
+	{ .tableFunction = cz_tf_init_power_gate_state },
+	{ .tableFunction = cz_tf_init_sclk_threshold },
+	{ }
 };
 
 static const struct phm_master_table_header cz_setup_asic_master = {
@@ -985,10 +985,10 @@ static int cz_tf_reset_cc6_data(struct pp_hwmgr *hwmgr,
 }
 
 static const struct phm_master_table_item cz_power_down_asic_list[] = {
-	{NULL, cz_tf_power_up_display_clock_sys_pll},
-	{NULL, cz_tf_clear_nb_dpm_flag},
-	{NULL, cz_tf_reset_cc6_data},
-	{NULL, NULL}
+	{ .tableFunction = cz_tf_power_up_display_clock_sys_pll },
+	{ .tableFunction = cz_tf_clear_nb_dpm_flag },
+	{ .tableFunction = cz_tf_reset_cc6_data },
+	{ }
 };
 
 static const struct phm_master_table_header cz_power_down_asic_master = {
@@ -1096,8 +1096,8 @@ static int cz_tf_check_for_dpm_enabled(struct pp_hwmgr *hwmgr,
 }
 
 static const struct phm_master_table_item cz_disable_dpm_list[] = {
-	{ NULL, cz_tf_check_for_dpm_enabled},
-	{NULL, NULL},
+	{ .tableFunction = cz_tf_check_for_dpm_enabled },
+	{ },
 };
 
 
@@ -1108,13 +1108,13 @@ static const struct phm_master_table_header cz_disable_dpm_master = {
 };
 
 static const struct phm_master_table_item cz_enable_dpm_list[] = {
-	{ NULL, cz_tf_check_for_dpm_disabled },
-	{ NULL, cz_tf_program_voting_clients },
-	{ NULL, cz_tf_start_dpm},
-	{ NULL, cz_tf_program_bootup_state},
-	{ NULL, cz_tf_enable_didt },
-	{ NULL, cz_tf_reset_acp_boot_level },
-	{NULL, NULL},
+	{ .tableFunction = cz_tf_check_for_dpm_disabled },
+	{ .tableFunction = cz_tf_program_voting_clients },
+	{ .tableFunction = cz_tf_start_dpm },
+	{ .tableFunction = cz_tf_program_bootup_state },
+	{ .tableFunction = cz_tf_enable_didt },
+	{ .tableFunction = cz_tf_reset_acp_boot_level },
+	{ },
 };
 
 static const struct phm_master_table_header cz_enable_dpm_master = {
diff --git a/drivers/gpu/drm/amd/powerplay/hwmgr/fiji_thermal.c b/drivers/gpu/drm/amd/powerplay/hwmgr/fiji_thermal.c
index 92976b68d..7d1f7f671 100644
--- a/drivers/gpu/drm/amd/powerplay/hwmgr/fiji_thermal.c
+++ b/drivers/gpu/drm/amd/powerplay/hwmgr/fiji_thermal.c
@@ -617,17 +617,17 @@ static int tf_fiji_thermal_disable_alert(struct pp_hwmgr *hwmgr,
 
 static const struct phm_master_table_item
 fiji_thermal_start_thermal_controller_master_list[] = {
-	{NULL, tf_fiji_thermal_initialize},
-	{NULL, tf_fiji_thermal_set_temperature_range},
-	{NULL, tf_fiji_thermal_enable_alert},
+	{ .tableFunction = tf_fiji_thermal_initialize},
+	{ .tableFunction = tf_fiji_thermal_set_temperature_range},
+	{ .tableFunction = tf_fiji_thermal_enable_alert},
 /* We should restrict performance levels to low before we halt the SMC.
  * On the other hand we are still in boot state when we do this
  * so it would be pointless.
  * If this assumption changes we have to revisit this table.
  */
-	{NULL, tf_fiji_thermal_setup_fan_table},
-	{NULL, tf_fiji_thermal_start_smc_fan_control},
-	{NULL, NULL}
+	{ .tableFunction = tf_fiji_thermal_setup_fan_table},
+	{ .tableFunction = tf_fiji_thermal_start_smc_fan_control},
+	{ }
 };
 
 static const struct phm_master_table_header
@@ -639,10 +639,10 @@ fiji_thermal_start_thermal_controller_master = {
 
 static const struct phm_master_table_item
 fiji_thermal_set_temperature_range_master_list[] = {
-	{NULL, tf_fiji_thermal_disable_alert},
-	{NULL, tf_fiji_thermal_set_temperature_range},
-	{NULL, tf_fiji_thermal_enable_alert},
-	{NULL, NULL}
+	{ .tableFunction = tf_fiji_thermal_disable_alert},
+	{ .tableFunction = tf_fiji_thermal_set_temperature_range},
+	{ .tableFunction = tf_fiji_thermal_enable_alert},
+	{ }
 };
 
 static const struct phm_master_table_header
diff --git a/drivers/gpu/drm/amd/powerplay/hwmgr/polaris10_thermal.c b/drivers/gpu/drm/amd/powerplay/hwmgr/polaris10_thermal.c
index b206632d4..eeb47240e 100644
--- a/drivers/gpu/drm/amd/powerplay/hwmgr/polaris10_thermal.c
+++ b/drivers/gpu/drm/amd/powerplay/hwmgr/polaris10_thermal.c
@@ -645,18 +645,18 @@ static int tf_polaris10_thermal_avfs_enable(struct pp_hwmgr *hwmgr,
 
 static const struct phm_master_table_item
 polaris10_thermal_start_thermal_controller_master_list[] = {
-	{NULL, tf_polaris10_thermal_initialize},
-	{NULL, tf_polaris10_thermal_set_temperature_range},
-	{NULL, tf_polaris10_thermal_enable_alert},
-	{NULL, tf_polaris10_thermal_avfs_enable},
+	{ .tableFunction = tf_polaris10_thermal_initialize },
+	{ .tableFunction = tf_polaris10_thermal_set_temperature_range },
+	{ .tableFunction = tf_polaris10_thermal_enable_alert },
+	{ .tableFunction = tf_polaris10_thermal_avfs_enable },
 /* We should restrict performance levels to low before we halt the SMC.
  * On the other hand we are still in boot state when we do this
  * so it would be pointless.
  * If this assumption changes we have to revisit this table.
  */
-	{NULL, tf_polaris10_thermal_setup_fan_table},
-	{NULL, tf_polaris10_thermal_start_smc_fan_control},
-	{NULL, NULL}
+	{ .tableFunction = tf_polaris10_thermal_setup_fan_table },
+	{ .tableFunction = tf_polaris10_thermal_start_smc_fan_control },
+	{ }
 };
 
 static const struct phm_master_table_header
@@ -668,10 +668,10 @@ polaris10_thermal_start_thermal_controller_master = {
 
 static const struct phm_master_table_item
 polaris10_thermal_set_temperature_range_master_list[] = {
-	{NULL, tf_polaris10_thermal_disable_alert},
-	{NULL, tf_polaris10_thermal_set_temperature_range},
-	{NULL, tf_polaris10_thermal_enable_alert},
-	{NULL, NULL}
+	{ .tableFunction = tf_polaris10_thermal_disable_alert },
+	{ .tableFunction = tf_polaris10_thermal_set_temperature_range },
+	{ .tableFunction = tf_polaris10_thermal_enable_alert },
+	{ }
 };
 
 static const struct phm_master_table_header
diff --git a/drivers/gpu/drm/amd/powerplay/hwmgr/tonga_thermal.c b/drivers/gpu/drm/amd/powerplay/hwmgr/tonga_thermal.c
index 47ef1ca2d..d352d3857 100644
--- a/drivers/gpu/drm/amd/powerplay/hwmgr/tonga_thermal.c
+++ b/drivers/gpu/drm/amd/powerplay/hwmgr/tonga_thermal.c
@@ -526,16 +526,16 @@ static int tf_tonga_thermal_disable_alert(struct pp_hwmgr *hwmgr, void *input, v
 }
 
 static const struct phm_master_table_item tonga_thermal_start_thermal_controller_master_list[] = {
-	{ NULL, tf_tonga_thermal_initialize },
-	{ NULL, tf_tonga_thermal_set_temperature_range },
-	{ NULL, tf_tonga_thermal_enable_alert },
+	{ .tableFunction = tf_tonga_thermal_initialize },
+	{ .tableFunction = tf_tonga_thermal_set_temperature_range },
+	{ .tableFunction = tf_tonga_thermal_enable_alert },
 /* We should restrict performance levels to low before we halt the SMC.
  * On the other hand we are still in boot state when we do this so it would be pointless.
  * If this assumption changes we have to revisit this table.
  */
-	{ NULL, tf_tonga_thermal_setup_fan_table},
-	{ NULL, tf_tonga_thermal_start_smc_fan_control},
-	{ NULL, NULL }
+	{ .tableFunction = tf_tonga_thermal_setup_fan_table},
+	{ .tableFunction = tf_tonga_thermal_start_smc_fan_control},
+	{ }
 };
 
 static const struct phm_master_table_header tonga_thermal_start_thermal_controller_master = {
@@ -545,10 +545,10 @@ static const struct phm_master_table_header tonga_thermal_start_thermal_controll
 };
 
 static const struct phm_master_table_item tonga_thermal_set_temperature_range_master_list[] = {
-	{ NULL, tf_tonga_thermal_disable_alert},
-	{ NULL, tf_tonga_thermal_set_temperature_range},
-	{ NULL, tf_tonga_thermal_enable_alert},
-	{ NULL, NULL }
+	{ .tableFunction = tf_tonga_thermal_disable_alert},
+	{ .tableFunction = tf_tonga_thermal_set_temperature_range},
+	{ .tableFunction = tf_tonga_thermal_enable_alert},
+	{ }
 };
 
 static const struct phm_master_table_header tonga_thermal_set_temperature_range_master = {
diff --git a/drivers/gpu/drm/amd/scheduler/gpu_scheduler.c b/drivers/gpu/drm/amd/scheduler/gpu_scheduler.c
index ffe1f85ce..7017bfce4 100644
--- a/drivers/gpu/drm/amd/scheduler/gpu_scheduler.c
+++ b/drivers/gpu/drm/amd/scheduler/gpu_scheduler.c
@@ -137,7 +137,7 @@ int amd_sched_entity_init(struct amd_gpu_scheduler *sched,
 	if (r)
 		return r;
 
-	atomic_set(&entity->fence_seq, 0);
+	atomic_set_unchecked(&entity->fence_seq, 0);
 	entity->fence_context = fence_context_alloc(2);
 
 	return 0;
diff --git a/drivers/gpu/drm/amd/scheduler/gpu_scheduler.h b/drivers/gpu/drm/amd/scheduler/gpu_scheduler.h
index 51068e6c3..35b4c71fc 100644
--- a/drivers/gpu/drm/amd/scheduler/gpu_scheduler.h
+++ b/drivers/gpu/drm/amd/scheduler/gpu_scheduler.h
@@ -44,7 +44,7 @@ struct amd_sched_entity {
 	spinlock_t			queue_lock;
 	struct kfifo                    job_queue;
 
-	atomic_t			fence_seq;
+	atomic_unchecked_t		fence_seq;
 	uint64_t                        fence_context;
 
 	struct fence			*dependency;
diff --git a/drivers/gpu/drm/amd/scheduler/sched_fence.c b/drivers/gpu/drm/amd/scheduler/sched_fence.c
index 93ad2e1f8..970aecae1 100644
--- a/drivers/gpu/drm/amd/scheduler/sched_fence.c
+++ b/drivers/gpu/drm/amd/scheduler/sched_fence.c
@@ -60,7 +60,7 @@ struct amd_sched_fence *amd_sched_fence_create(struct amd_sched_entity *entity,
 	fence->sched = entity->sched;
 	spin_lock_init(&fence->lock);
 
-	seq = atomic_inc_return(&entity->fence_seq);
+	seq = atomic_inc_return_unchecked(&entity->fence_seq);
 	fence_init(&fence->scheduled, &amd_sched_fence_ops_scheduled,
 		   &fence->lock, entity->fence_context, seq);
 	fence_init(&fence->finished, &amd_sched_fence_ops_finished,
diff --git a/drivers/gpu/drm/armada/armada_drv.c b/drivers/gpu/drm/armada/armada_drv.c
index f5ebdd681..135c95c48 100644
--- a/drivers/gpu/drm/armada/armada_drv.c
+++ b/drivers/gpu/drm/armada/armada_drv.c
@@ -213,6 +213,7 @@ static struct drm_driver armada_drm_driver = {
 	.driver_features	= DRIVER_GEM | DRIVER_MODESET |
 				  DRIVER_HAVE_IRQ | DRIVER_PRIME,
 	.ioctls			= armada_ioctls,
+	.num_ioctls		= ARRAY_SIZE(armada_ioctls),
 	.fops			= &armada_drm_fops,
 };
 
@@ -333,8 +334,6 @@ static int __init armada_drm_init(void)
 {
 	int ret;
 
-	armada_drm_driver.num_ioctls = ARRAY_SIZE(armada_ioctls);
-
 	ret = platform_driver_register(&armada_lcd_platform_driver);
 	if (ret)
 		return ret;
diff --git a/drivers/gpu/drm/ast/ast_mode.c b/drivers/gpu/drm/ast/ast_mode.c
index 5957c3e65..970039e94 100644
--- a/drivers/gpu/drm/ast/ast_mode.c
+++ b/drivers/gpu/drm/ast/ast_mode.c
@@ -775,7 +775,7 @@ static int ast_get_modes(struct drm_connector *connector)
 	return 0;
 }
 
-static int ast_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status ast_mode_valid(struct drm_connector *connector,
 			  struct drm_display_mode *mode)
 {
 	struct ast_private *ast = connector->dev->dev_private;
diff --git a/drivers/gpu/drm/bochs/bochs_kms.c b/drivers/gpu/drm/bochs/bochs_kms.c
index 207a2cbcc..666b75abf 100644
--- a/drivers/gpu/drm/bochs/bochs_kms.c
+++ b/drivers/gpu/drm/bochs/bochs_kms.c
@@ -187,7 +187,7 @@ int bochs_connector_get_modes(struct drm_connector *connector)
 	return count;
 }
 
-static int bochs_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status bochs_connector_mode_valid(struct drm_connector *connector,
 				      struct drm_display_mode *mode)
 {
 	struct bochs_device *bochs =
diff --git a/drivers/gpu/drm/bridge/tc358767.c b/drivers/gpu/drm/bridge/tc358767.c
index a09825d8c..6faa4d771 100644
--- a/drivers/gpu/drm/bridge/tc358767.c
+++ b/drivers/gpu/drm/bridge/tc358767.c
@@ -1102,7 +1102,7 @@ static bool tc_bridge_mode_fixup(struct drm_bridge *bridge,
 	return true;
 }
 
-static int tc_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status tc_connector_mode_valid(struct drm_connector *connector,
 				   struct drm_display_mode *mode)
 {
 	/* Accept any mode */
diff --git a/drivers/gpu/drm/drm_crtc.c b/drivers/gpu/drm/drm_crtc.c
index ddebe54cd..68a674d9b 100644
--- a/drivers/gpu/drm/drm_crtc.c
+++ b/drivers/gpu/drm/drm_crtc.c
@@ -4364,7 +4364,7 @@ int drm_mode_getproperty_ioctl(struct drm_device *dev,
 					goto done;
 				}
 
-				if (copy_to_user(&enum_ptr[copied].name,
+				if (copy_to_user(enum_ptr[copied].name,
 						 &prop_enum->name, DRM_PROP_NAME_LEN)) {
 					ret = -EFAULT;
 					goto done;
diff --git a/drivers/gpu/drm/drm_drv.c b/drivers/gpu/drm/drm_drv.c
index be27ed36f..72aa552bc 100644
--- a/drivers/gpu/drm/drm_drv.c
+++ b/drivers/gpu/drm/drm_drv.c
@@ -368,7 +368,7 @@ void drm_unplug_dev(struct drm_device *dev)
 
 	drm_device_set_unplugged(dev);
 
-	if (dev->open_count == 0) {
+	if (local_read(&dev->open_count) == 0) {
 		drm_put_dev(dev);
 	}
 	mutex_unlock(&drm_global_mutex);
diff --git a/drivers/gpu/drm/drm_fb_cma_helper.c b/drivers/gpu/drm/drm_fb_cma_helper.c
index 1fd6eac14..e4206c9d6 100644
--- a/drivers/gpu/drm/drm_fb_cma_helper.c
+++ b/drivers/gpu/drm/drm_fb_cma_helper.c
@@ -335,7 +335,7 @@ static int drm_fbdev_cma_defio_init(struct fb_info *fbi,
 				    struct drm_gem_cma_object *cma_obj)
 {
 	struct fb_deferred_io *fbdefio;
-	struct fb_ops *fbops;
+	fb_ops_no_const *fbops;
 
 	/*
 	 * Per device structures are needed because:
@@ -362,7 +362,7 @@ static int drm_fbdev_cma_defio_init(struct fb_info *fbi,
 	fbdefio->deferred_io = drm_fb_helper_deferred_io;
 	fbi->fbdefio = fbdefio;
 	fb_deferred_io_init(fbi);
-	fbi->fbops->fb_mmap = drm_fbdev_cma_deferred_io_mmap;
+	fbops->fb_mmap = drm_fbdev_cma_deferred_io_mmap;
 
 	return 0;
 }
diff --git a/drivers/gpu/drm/drm_fops.c b/drivers/gpu/drm/drm_fops.c
index 323c238fc..0eaad2126 100644
--- a/drivers/gpu/drm/drm_fops.c
+++ b/drivers/gpu/drm/drm_fops.c
@@ -132,7 +132,7 @@ int drm_open(struct inode *inode, struct file *filp)
 		return PTR_ERR(minor);
 
 	dev = minor->dev;
-	if (!dev->open_count++)
+	if (local_inc_return(&dev->open_count) == 1)
 		need_setup = 1;
 
 	/* share address_space across all char-devs of a single device */
@@ -149,7 +149,7 @@ int drm_open(struct inode *inode, struct file *filp)
 	return 0;
 
 err_undo:
-	dev->open_count--;
+	local_dec(&dev->open_count);
 	drm_minor_release(minor);
 	return retcode;
 }
@@ -371,7 +371,7 @@ int drm_release(struct inode *inode, struct file *filp)
 
 	mutex_lock(&drm_global_mutex);
 
-	DRM_DEBUG("open_count = %d\n", dev->open_count);
+	DRM_DEBUG("open_count = %ld\n", local_read(&dev->open_count));
 
 	mutex_lock(&dev->filelist_mutex);
 	list_del(&file_priv->lhead);
@@ -384,10 +384,10 @@ int drm_release(struct inode *inode, struct file *filp)
 	 * Begin inline drm_release
 	 */
 
-	DRM_DEBUG("pid = %d, device = 0x%lx, open_count = %d\n",
+	DRM_DEBUG("pid = %d, device = 0x%lx, open_count = %ld\n",
 		  task_pid_nr(current),
 		  (long)old_encode_dev(file_priv->minor->kdev->devt),
-		  dev->open_count);
+		  local_read(&dev->open_count));
 
 	if (!drm_core_check_feature(dev, DRIVER_MODESET))
 		drm_legacy_lock_release(dev, filp);
@@ -425,7 +425,7 @@ int drm_release(struct inode *inode, struct file *filp)
 	 * End inline drm_release
 	 */
 
-	if (!--dev->open_count) {
+	if (local_dec_and_test(&dev->open_count)) {
 		drm_lastclose(dev);
 		if (drm_device_is_unplugged(dev))
 			drm_put_dev(dev);
@@ -564,6 +564,11 @@ unsigned int drm_poll(struct file *filp, struct poll_table_struct *wait)
 }
 EXPORT_SYMBOL(drm_poll);
 
+static void drm_pending_event_destroy(struct drm_pending_event *event)
+{
+	kfree(event);
+}
+
 /**
  * drm_event_reserve_init_locked - init a DRM event and reserve space for it
  * @dev: DRM device
diff --git a/drivers/gpu/drm/drm_global.c b/drivers/gpu/drm/drm_global.c
index 3d2e91c4d..d31c4c9e8 100644
--- a/drivers/gpu/drm/drm_global.c
+++ b/drivers/gpu/drm/drm_global.c
@@ -36,7 +36,7 @@
 struct drm_global_item {
 	struct mutex mutex;
 	void *object;
-	int refcount;
+	atomic_t refcount;
 };
 
 static struct drm_global_item glob[DRM_GLOBAL_NUM];
@@ -49,7 +49,7 @@ void drm_global_init(void)
 		struct drm_global_item *item = &glob[i];
 		mutex_init(&item->mutex);
 		item->object = NULL;
-		item->refcount = 0;
+		atomic_set(&item->refcount, 0);
 	}
 }
 
@@ -59,7 +59,7 @@ void drm_global_release(void)
 	for (i = 0; i < DRM_GLOBAL_NUM; ++i) {
 		struct drm_global_item *item = &glob[i];
 		BUG_ON(item->object != NULL);
-		BUG_ON(item->refcount != 0);
+		BUG_ON(atomic_read(&item->refcount) != 0);
 	}
 }
 
@@ -69,7 +69,7 @@ int drm_global_item_ref(struct drm_global_reference *ref)
 	struct drm_global_item *item = &glob[ref->global_type];
 
 	mutex_lock(&item->mutex);
-	if (item->refcount == 0) {
+	if (atomic_read(&item->refcount) == 0) {
 		item->object = kzalloc(ref->size, GFP_KERNEL);
 		if (unlikely(item->object == NULL)) {
 			ret = -ENOMEM;
@@ -82,7 +82,7 @@ int drm_global_item_ref(struct drm_global_reference *ref)
 			goto out_err;
 
 	}
-	++item->refcount;
+	atomic_inc(&item->refcount);
 	ref->object = item->object;
 	mutex_unlock(&item->mutex);
 	return 0;
@@ -98,9 +98,9 @@ void drm_global_item_unref(struct drm_global_reference *ref)
 	struct drm_global_item *item = &glob[ref->global_type];
 
 	mutex_lock(&item->mutex);
-	BUG_ON(item->refcount == 0);
+	BUG_ON(atomic_read(&item->refcount) == 0);
 	BUG_ON(ref->object != item->object);
-	if (--item->refcount == 0) {
+	if (atomic_dec_and_test(&item->refcount)) {
 		ref->release(ref);
 		item->object = NULL;
 	}
diff --git a/drivers/gpu/drm/drm_ioc32.c b/drivers/gpu/drm/drm_ioc32.c
index a6289752b..98c84f732 100644
--- a/drivers/gpu/drm/drm_ioc32.c
+++ b/drivers/gpu/drm/drm_ioc32.c
@@ -458,7 +458,7 @@ static int compat_drm_infobufs(struct file *file, unsigned int cmd,
 	request = compat_alloc_user_space(nbytes);
 	if (!request)
 		return -EFAULT;
-	list = (struct drm_buf_desc *) (request + 1);
+	list = (struct drm_buf_desc __user *) (request + 1);
 
 	if (__put_user(count, &request->count)
 	    || __put_user(list, &request->list))
@@ -519,7 +519,7 @@ static int compat_drm_mapbufs(struct file *file, unsigned int cmd,
 	request = compat_alloc_user_space(nbytes);
 	if (!request)
 		return -EFAULT;
-	list = (struct drm_buf_pub *) (request + 1);
+	list = (struct drm_buf_pub __user *) (request + 1);
 
 	if (__put_user(count, &request->count)
 	    || __put_user(list, &request->list))
@@ -1074,7 +1074,7 @@ static int compat_drm_mode_addfb2(struct file *file, unsigned int cmd,
 }
 #endif
 
-static drm_ioctl_compat_t *drm_compat_ioctls[] = {
+static drm_ioctl_compat_t drm_compat_ioctls[] = {
 	[DRM_IOCTL_NR(DRM_IOCTL_VERSION32)] = compat_drm_version,
 	[DRM_IOCTL_NR(DRM_IOCTL_GET_UNIQUE32)] = compat_drm_getunique,
 	[DRM_IOCTL_NR(DRM_IOCTL_GET_MAP32)] = compat_drm_getmap,
@@ -1123,7 +1123,6 @@ static drm_ioctl_compat_t *drm_compat_ioctls[] = {
 long drm_compat_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 {
 	unsigned int nr = DRM_IOCTL_NR(cmd);
-	drm_ioctl_compat_t *fn;
 	int ret;
 
 	/* Assume that ioctls without an explicit compat routine will just
@@ -1133,10 +1132,8 @@ long drm_compat_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 	if (nr >= ARRAY_SIZE(drm_compat_ioctls))
 		return drm_ioctl(filp, cmd, arg);
 
-	fn = drm_compat_ioctls[nr];
-
-	if (fn != NULL)
-		ret = (*fn) (filp, cmd, arg);
+	if (drm_compat_ioctls[nr] != NULL)
+		ret = (*drm_compat_ioctls[nr]) (filp, cmd, arg);
 	else
 		ret = drm_ioctl(filp, cmd, arg);
 
diff --git a/drivers/gpu/drm/drm_ioctl.c b/drivers/gpu/drm/drm_ioctl.c
index 33af4a5dd..ceb09f272 100644
--- a/drivers/gpu/drm/drm_ioctl.c
+++ b/drivers/gpu/drm/drm_ioctl.c
@@ -643,7 +643,7 @@ long drm_ioctl(struct file *filp,
 	struct drm_file *file_priv = filp->private_data;
 	struct drm_device *dev;
 	const struct drm_ioctl_desc *ioctl = NULL;
-	drm_ioctl_t *func;
+	drm_ioctl_no_const_t func;
 	unsigned int nr = DRM_IOCTL_NR(cmd);
 	int retcode = -EINVAL;
 	char stack_kdata[128];
diff --git a/drivers/gpu/drm/drm_pci.c b/drivers/gpu/drm/drm_pci.c
index b2f8f1062..39eb872a4 100644
--- a/drivers/gpu/drm/drm_pci.c
+++ b/drivers/gpu/drm/drm_pci.c
@@ -264,7 +264,7 @@ int drm_get_pci_dev(struct pci_dev *pdev, const struct pci_device_id *ent,
 	/* No locking needed since shadow-attach is single-threaded since it may
 	 * only be called from the per-driver module init hook. */
 	if (!drm_core_check_feature(dev, DRIVER_MODESET))
-		list_add_tail(&dev->legacy_dev_list, &driver->legacy_dev_list);
+		pax_list_add_tail(&dev->legacy_dev_list, (struct list_head *)&driver->legacy_dev_list);
 
 	return 0;
 
@@ -303,7 +303,10 @@ int drm_pci_init(struct drm_driver *driver, struct pci_driver *pdriver)
 		return pci_register_driver(pdriver);
 
 	/* If not using KMS, fall back to stealth mode manual scanning. */
-	INIT_LIST_HEAD(&driver->legacy_dev_list);
+	pax_open_kernel();
+	INIT_LIST_HEAD((struct list_head *)&driver->legacy_dev_list);
+	pax_close_kernel();
+
 	for (i = 0; pdriver->id_table[i].vendor != 0; i++) {
 		pid = &pdriver->id_table[i];
 
@@ -426,7 +429,7 @@ void drm_pci_exit(struct drm_driver *driver, struct pci_driver *pdriver)
 	} else {
 		list_for_each_entry_safe(dev, tmp, &driver->legacy_dev_list,
 					 legacy_dev_list) {
-			list_del(&dev->legacy_dev_list);
+			pax_list_del(&dev->legacy_dev_list);
 			drm_put_dev(dev);
 		}
 	}
diff --git a/drivers/gpu/drm/exynos/exynos_drm_drv.c b/drivers/gpu/drm/exynos/exynos_drm_drv.c
index 877d2efa2..7b2d94d82 100644
--- a/drivers/gpu/drm/exynos/exynos_drm_drv.c
+++ b/drivers/gpu/drm/exynos/exynos_drm_drv.c
@@ -548,6 +548,11 @@ static int compare_dev(struct device *dev, void *data)
 	return dev == (struct device *)data;
 }
 
+static int platform_bus_type_match(struct device *dev, void *data)
+{
+	return platform_bus_type.match(dev, data);
+}
+
 static struct component_match *exynos_drm_match_add(struct device *dev)
 {
 	struct component_match *match = NULL;
@@ -562,7 +567,7 @@ static struct component_match *exynos_drm_match_add(struct device *dev)
 
 		while ((d = bus_find_device(&platform_bus_type, p,
 					    &info->driver->driver,
-					    (void *)platform_bus_type.match))) {
+					    platform_bus_type_match))) {
 			put_device(p);
 			component_match_add(dev, &match, compare_dev, d);
 			p = d;
@@ -593,7 +598,6 @@ static int exynos_drm_platform_probe(struct platform_device *pdev)
 	struct component_match *match;
 
 	pdev->dev.coherent_dma_mask = DMA_BIT_MASK(32);
-	exynos_drm_driver.num_ioctls = ARRAY_SIZE(exynos_ioctls);
 
 	match = exynos_drm_match_add(&pdev->dev);
 	if (IS_ERR(match))
@@ -631,7 +635,7 @@ static struct device *exynos_drm_get_dma_device(void)
 
 		while ((dev = bus_find_device(&platform_bus_type, NULL,
 					    &info->driver->driver,
-					    (void *)platform_bus_type.match))) {
+					    platform_bus_type_match))) {
 			put_device(dev);
 			return dev;
 		}
@@ -652,7 +656,7 @@ static void exynos_drm_unregister_devices(void)
 
 		while ((dev = bus_find_device(&platform_bus_type, NULL,
 					    &info->driver->driver,
-					    (void *)platform_bus_type.match))) {
+					    platform_bus_type_match))) {
 			put_device(dev);
 			platform_device_unregister(to_platform_device(dev));
 		}
diff --git a/drivers/gpu/drm/exynos/exynos_drm_g2d.c b/drivers/gpu/drm/exynos/exynos_drm_g2d.c
index 6eca8bb88..d607c0176 100644
--- a/drivers/gpu/drm/exynos/exynos_drm_g2d.c
+++ b/drivers/gpu/drm/exynos/exynos_drm_g2d.c
@@ -1055,6 +1055,11 @@ int exynos_g2d_get_ver_ioctl(struct drm_device *drm_dev, void *data,
 	return 0;
 }
 
+static void exynos_g2d_dmabuf_destroy(struct drm_pending_event *event)
+{
+	kfree(event);
+}
+
 int exynos_g2d_set_cmdlist_ioctl(struct drm_device *drm_dev, void *data,
 				 struct drm_file *file)
 {
diff --git a/drivers/gpu/drm/exynos/exynos_hdmi.c b/drivers/gpu/drm/exynos/exynos_hdmi.c
index 2275efe41..c91e144bc 100644
--- a/drivers/gpu/drm/exynos/exynos_hdmi.c
+++ b/drivers/gpu/drm/exynos/exynos_hdmi.c
@@ -919,7 +919,7 @@ static int hdmi_find_phy_conf(struct hdmi_context *hdata, u32 pixel_clock)
 	return -EINVAL;
 }
 
-static int hdmi_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status hdmi_mode_valid(struct drm_connector *connector,
 			struct drm_display_mode *mode)
 {
 	struct hdmi_context *hdata = connector_to_hdmi(connector);
diff --git a/drivers/gpu/drm/gma500/cdv_intel_crt.c b/drivers/gpu/drm/gma500/cdv_intel_crt.c
index b837e7a92..cb5a14b7e 100644
--- a/drivers/gpu/drm/gma500/cdv_intel_crt.c
+++ b/drivers/gpu/drm/gma500/cdv_intel_crt.c
@@ -64,7 +64,7 @@ static void cdv_intel_crt_dpms(struct drm_encoder *encoder, int mode)
 	REG_WRITE(reg, temp);
 }
 
-static int cdv_intel_crt_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status cdv_intel_crt_mode_valid(struct drm_connector *connector,
 				struct drm_display_mode *mode)
 {
 	if (mode->flags & DRM_MODE_FLAG_DBLSCAN)
diff --git a/drivers/gpu/drm/gma500/cdv_intel_dp.c b/drivers/gpu/drm/gma500/cdv_intel_dp.c
index c52f9adf5..486d20365 100644
--- a/drivers/gpu/drm/gma500/cdv_intel_dp.c
+++ b/drivers/gpu/drm/gma500/cdv_intel_dp.c
@@ -505,7 +505,7 @@ static void cdv_intel_edp_backlight_off (struct gma_encoder *intel_encoder)
 	msleep(intel_dp->backlight_off_delay);
 }
 
-static int
+static enum drm_mode_status
 cdv_intel_dp_mode_valid(struct drm_connector *connector,
 		    struct drm_display_mode *mode)
 {
diff --git a/drivers/gpu/drm/gma500/cdv_intel_hdmi.c b/drivers/gpu/drm/gma500/cdv_intel_hdmi.c
index 563f193fc..f08789985 100644
--- a/drivers/gpu/drm/gma500/cdv_intel_hdmi.c
+++ b/drivers/gpu/drm/gma500/cdv_intel_hdmi.c
@@ -223,7 +223,7 @@ static int cdv_hdmi_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int cdv_hdmi_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status cdv_hdmi_mode_valid(struct drm_connector *connector,
 				 struct drm_display_mode *mode)
 {
 	if (mode->clock > 165000)
diff --git a/drivers/gpu/drm/gma500/cdv_intel_lvds.c b/drivers/gpu/drm/gma500/cdv_intel_lvds.c
index 38dc89083..c87ef7b8a 100644
--- a/drivers/gpu/drm/gma500/cdv_intel_lvds.c
+++ b/drivers/gpu/drm/gma500/cdv_intel_lvds.c
@@ -244,7 +244,7 @@ static void cdv_intel_lvds_restore(struct drm_connector *connector)
 {
 }
 
-static int cdv_intel_lvds_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status cdv_intel_lvds_mode_valid(struct drm_connector *connector,
 			      struct drm_display_mode *mode)
 {
 	struct drm_device *dev = connector->dev;
diff --git a/drivers/gpu/drm/gma500/mdfld_dsi_dpi.c b/drivers/gpu/drm/gma500/mdfld_dsi_dpi.c
index a05c02060..01bfdad77 100644
--- a/drivers/gpu/drm/gma500/mdfld_dsi_dpi.c
+++ b/drivers/gpu/drm/gma500/mdfld_dsi_dpi.c
@@ -120,9 +120,14 @@ static void dsi_set_pipe_plane_enable_state(struct drm_device *dev,
 	u32 pipeconf_reg = PIPEACONF;
 	u32 dspcntr_reg = DSPACNTR;
 
-	u32 dspcntr = dev_priv->dspcntr[pipe];
+	u32 dspcntr;
 	u32 mipi = MIPI_PORT_EN | PASS_FROM_SPHY_TO_AFE | SEL_FLOPPED_HSTX;
 
+	if (pipe == -1)
+		return;
+
+	dspcntr = dev_priv->dspcntr[pipe];
+
 	if (pipe) {
 		pipeconf_reg = PIPECCONF;
 		dspcntr_reg = DSPCCNTR;
@@ -645,6 +650,9 @@ static void mdfld_dsi_dpi_set_power(struct drm_encoder *encoder, bool on)
 	if (!gma_power_begin(dev, true))
 		return;
 
+	if (pipe == -1)
+		return;
+
 	if (on) {
 		if (mdfld_get_panel_type(dev, pipe) == TMD_VID)
 			mdfld_dsi_dpi_turn_on(dpi_output, pipe);
diff --git a/drivers/gpu/drm/gma500/mdfld_dsi_output.c b/drivers/gpu/drm/gma500/mdfld_dsi_output.c
index 907cb5179..ae6f60cd5 100644
--- a/drivers/gpu/drm/gma500/mdfld_dsi_output.c
+++ b/drivers/gpu/drm/gma500/mdfld_dsi_output.c
@@ -351,7 +351,7 @@ static int mdfld_dsi_connector_get_modes(struct drm_connector *connector)
 	return 0;
 }
 
-static int mdfld_dsi_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status mdfld_dsi_connector_mode_valid(struct drm_connector *connector,
 						struct drm_display_mode *mode)
 {
 	struct mdfld_dsi_connector *dsi_connector =
diff --git a/drivers/gpu/drm/gma500/oaktrail_hdmi.c b/drivers/gpu/drm/gma500/oaktrail_hdmi.c
index 8b2eb32ee..78566a80a 100644
--- a/drivers/gpu/drm/gma500/oaktrail_hdmi.c
+++ b/drivers/gpu/drm/gma500/oaktrail_hdmi.c
@@ -509,7 +509,7 @@ static void oaktrail_hdmi_dpms(struct drm_encoder *encoder, int mode)
 	HDMI_WRITE(HDMI_VIDEO_REG, temp);
 }
 
-static int oaktrail_hdmi_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status oaktrail_hdmi_mode_valid(struct drm_connector *connector,
 				struct drm_display_mode *mode)
 {
 	if (mode->clock > 165000)
diff --git a/drivers/gpu/drm/gma500/psb_drv.c b/drivers/gpu/drm/gma500/psb_drv.c
index 8f3ca526b..b341aa8a4 100644
--- a/drivers/gpu/drm/gma500/psb_drv.c
+++ b/drivers/gpu/drm/gma500/psb_drv.c
@@ -373,7 +373,6 @@ static int psb_driver_load(struct drm_device *dev, unsigned long flags)
 	drm_irq_install(dev, dev->pdev->irq);
 
 	dev->max_vblank_count = 0xffffff; /* only 24 bits of frame count */
-	dev->driver->get_vblank_counter = psb_get_vblank_counter;
 
 	psb_modeset_init(dev);
 	psb_fbdev_init(dev);
diff --git a/drivers/gpu/drm/gma500/psb_intel_drv.h b/drivers/gpu/drm/gma500/psb_intel_drv.h
index 2a3b7c684..fbd3fa340 100644
--- a/drivers/gpu/drm/gma500/psb_intel_drv.h
+++ b/drivers/gpu/drm/gma500/psb_intel_drv.h
@@ -255,7 +255,7 @@ extern int intelfb_remove(struct drm_device *dev,
 extern bool psb_intel_lvds_mode_fixup(struct drm_encoder *encoder,
 				      const struct drm_display_mode *mode,
 				      struct drm_display_mode *adjusted_mode);
-extern int psb_intel_lvds_mode_valid(struct drm_connector *connector,
+extern enum drm_mode_status psb_intel_lvds_mode_valid(struct drm_connector *connector,
 				     struct drm_display_mode *mode);
 extern int psb_intel_lvds_set_property(struct drm_connector *connector,
 					struct drm_property *property,
diff --git a/drivers/gpu/drm/gma500/psb_intel_lvds.c b/drivers/gpu/drm/gma500/psb_intel_lvds.c
index e55733ca4..524a9fdf0 100644
--- a/drivers/gpu/drm/gma500/psb_intel_lvds.c
+++ b/drivers/gpu/drm/gma500/psb_intel_lvds.c
@@ -343,7 +343,7 @@ static void psb_intel_lvds_restore(struct drm_connector *connector)
 	}
 }
 
-int psb_intel_lvds_mode_valid(struct drm_connector *connector,
+enum drm_mode_status psb_intel_lvds_mode_valid(struct drm_connector *connector,
 				 struct drm_display_mode *mode)
 {
 	struct drm_psb_private *dev_priv = connector->dev->dev_private;
diff --git a/drivers/gpu/drm/gma500/psb_intel_sdvo.c b/drivers/gpu/drm/gma500/psb_intel_sdvo.c
index e787d376b..91622fd35 100644
--- a/drivers/gpu/drm/gma500/psb_intel_sdvo.c
+++ b/drivers/gpu/drm/gma500/psb_intel_sdvo.c
@@ -1158,7 +1158,7 @@ static void psb_intel_sdvo_dpms(struct drm_encoder *encoder, int mode)
 	return;
 }
 
-static int psb_intel_sdvo_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status psb_intel_sdvo_mode_valid(struct drm_connector *connector,
 				 struct drm_display_mode *mode)
 {
 	struct psb_intel_sdvo *psb_intel_sdvo = intel_attached_sdvo(connector);
diff --git a/drivers/gpu/drm/i2c/tda998x_drv.c b/drivers/gpu/drm/i2c/tda998x_drv.c
index f4315bc8d..2048cc2ef 100644
--- a/drivers/gpu/drm/i2c/tda998x_drv.c
+++ b/drivers/gpu/drm/i2c/tda998x_drv.c
@@ -856,7 +856,7 @@ static void tda998x_encoder_dpms(struct drm_encoder *encoder, int mode)
 	priv->dpms = mode;
 }
 
-static int tda998x_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status tda998x_connector_mode_valid(struct drm_connector *connector,
 					struct drm_display_mode *mode)
 {
 	/* TDA19988 dotclock can go up to 165MHz */
diff --git a/drivers/gpu/drm/i810/i810_dma.c b/drivers/gpu/drm/i810/i810_dma.c
index d91856779..6cfd904c4 100644
--- a/drivers/gpu/drm/i810/i810_dma.c
+++ b/drivers/gpu/drm/i810/i810_dma.c
@@ -1250,7 +1250,7 @@ const struct drm_ioctl_desc i810_ioctls[] = {
 	DRM_IOCTL_DEF_DRV(I810_FLIP, i810_flip_bufs, DRM_AUTH|DRM_UNLOCKED),
 };
 
-int i810_max_ioctl = ARRAY_SIZE(i810_ioctls);
+const int i810_max_ioctl = ARRAY_SIZE(i810_ioctls);
 
 /**
  * Determine if the device really is AGP or not.
diff --git a/drivers/gpu/drm/i810/i810_drv.c b/drivers/gpu/drm/i810/i810_drv.c
index 44f4a131c..af9f6f5be 100644
--- a/drivers/gpu/drm/i810/i810_drv.c
+++ b/drivers/gpu/drm/i810/i810_drv.c
@@ -87,7 +87,11 @@ static int __init i810_init(void)
 		pr_err("drm/i810 does not support SMP\n");
 		return -EINVAL;
 	}
-	driver.num_ioctls = i810_max_ioctl;
+
+	pax_open_kernel();
+	const_cast(driver.num_ioctls) = i810_max_ioctl;
+	pax_close_kernel();
+
 	return drm_pci_init(&driver, &i810_pci_driver);
 }
 
diff --git a/drivers/gpu/drm/i810/i810_drv.h b/drivers/gpu/drm/i810/i810_drv.h
index 93ec5dc4e..204ec9264 100644
--- a/drivers/gpu/drm/i810/i810_drv.h
+++ b/drivers/gpu/drm/i810/i810_drv.h
@@ -110,8 +110,8 @@ typedef struct drm_i810_private {
 	int page_flipping;
 
 	wait_queue_head_t irq_queue;
-	atomic_t irq_received;
-	atomic_t irq_emitted;
+	atomic_unchecked_t irq_received;
+	atomic_unchecked_t irq_emitted;
 
 	int front_offset;
 } drm_i810_private_t;
@@ -128,7 +128,7 @@ extern int i810_driver_device_is_agp(struct drm_device *dev);
 
 extern long i810_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
 extern const struct drm_ioctl_desc i810_ioctls[];
-extern int i810_max_ioctl;
+extern const int i810_max_ioctl;
 
 #define I810_BASE(reg)		((unsigned long) \
 				dev_priv->mmio_map->handle)
diff --git a/drivers/gpu/drm/i915/dvo.h b/drivers/gpu/drm/i915/dvo.h
index 5e6a3013d..b6e143ebc 100644
--- a/drivers/gpu/drm/i915/dvo.h
+++ b/drivers/gpu/drm/i915/dvo.h
@@ -74,7 +74,7 @@ struct intel_dvo_dev_ops {
 	 *
 	 * \return MODE_OK if the mode is valid, or another MODE_* otherwise.
 	 */
-	int (*mode_valid)(struct intel_dvo_device *dvo,
+	enum drm_mode_status (*mode_valid)(struct intel_dvo_device *dvo,
 			  struct drm_display_mode *mode);
 
 	/*
diff --git a/drivers/gpu/drm/i915/i915_drv.c b/drivers/gpu/drm/i915/i915_drv.c
index d46fa2206..a93cd8a43 100644
--- a/drivers/gpu/drm/i915/i915_drv.c
+++ b/drivers/gpu/drm/i915/i915_drv.c
@@ -50,7 +50,7 @@
 #include "i915_vgpu.h"
 #include "intel_drv.h"
 
-static struct drm_driver driver;
+static drm_driver_no_const driver;
 
 static unsigned int i915_load_fail_count;
 
@@ -557,7 +557,7 @@ static bool i915_switcheroo_can_switch(struct pci_dev *pdev)
 	 * locking inversion with the driver load path. And the access here is
 	 * completely racy anyway. So don't bother with locking for now.
 	 */
-	return dev->open_count == 0;
+	return local_read(&dev->open_count) == 0;
 }
 
 static const struct vga_switcheroo_client_ops i915_switcheroo_ops = {
@@ -1224,8 +1224,11 @@ int i915_driver_load(struct pci_dev *pdev, const struct pci_device_id *ent)
 	struct drm_i915_private *dev_priv;
 	int ret;
 
-	if (i915.nuclear_pageflip)
+	if (i915.nuclear_pageflip) {
+		pax_open_kernel();
 		driver.driver_features |= DRIVER_ATOMIC;
+		pax_close_kernel();
+	}
 
 	ret = -ENOMEM;
 	dev_priv = kzalloc(sizeof(*dev_priv), GFP_KERNEL);
@@ -2610,7 +2613,7 @@ static const struct drm_ioctl_desc i915_ioctls[] = {
 	DRM_IOCTL_DEF_DRV(I915_GEM_CONTEXT_SETPARAM, i915_gem_context_setparam_ioctl, DRM_RENDER_ALLOW),
 };
 
-static struct drm_driver driver = {
+static drm_driver_no_const driver __read_only = {
 	/* Don't use MTRRs here; the Xserver or userspace app should
 	 * deal with them for Intel hardware.
 	 */
diff --git a/drivers/gpu/drm/i915/i915_gem_execbuffer.c b/drivers/gpu/drm/i915/i915_gem_execbuffer.c
index b35e5b647..998ddfc47 100644
--- a/drivers/gpu/drm/i915/i915_gem_execbuffer.c
+++ b/drivers/gpu/drm/i915/i915_gem_execbuffer.c
@@ -993,12 +993,12 @@ i915_gem_check_execbuffer(struct drm_i915_gem_execbuffer2 *exec)
 static int
 validate_exec_list(struct drm_device *dev,
 		   struct drm_i915_gem_exec_object2 *exec,
-		   int count)
+		   unsigned int count)
 {
 	unsigned relocs_total = 0;
 	unsigned relocs_max = UINT_MAX / sizeof(struct drm_i915_gem_relocation_entry);
 	unsigned invalid_flags;
-	int i;
+	unsigned int i;
 
 	invalid_flags = __EXEC_OBJECT_UNKNOWN_FLAGS;
 	if (USES_FULL_PPGTT(dev))
diff --git a/drivers/gpu/drm/i915/i915_gem_gtt.c b/drivers/gpu/drm/i915/i915_gem_gtt.c
index f38ceffd8..3f18728ce 100644
--- a/drivers/gpu/drm/i915/i915_gem_gtt.c
+++ b/drivers/gpu/drm/i915/i915_gem_gtt.c
@@ -3268,8 +3268,8 @@ int i915_ggtt_init_hw(struct drm_device *dev)
 	/* GMADR is the PCI mmio aperture into the global GTT. */
 	DRM_INFO("Memory usable by graphics device = %lluM\n",
 		 ggtt->base.total >> 20);
-	DRM_DEBUG_DRIVER("GMADR size = %lldM\n", ggtt->mappable_end >> 20);
-	DRM_DEBUG_DRIVER("GTT stolen size = %zdM\n", ggtt->stolen_size >> 20);
+	DRM_DEBUG_DRIVER("GMADR size = %lluM\n", ggtt->mappable_end >> 20);
+	DRM_DEBUG_DRIVER("GTT stolen size = %lluM\n", ggtt->stolen_size >> 20);
 #ifdef CONFIG_INTEL_IOMMU
 	if (intel_iommu_gfx_mapped)
 		DRM_INFO("VT-d active for gfx access\n");
diff --git a/drivers/gpu/drm/i915/i915_gem_gtt.h b/drivers/gpu/drm/i915/i915_gem_gtt.h
index aa5f31d1c..9df8e4da6 100644
--- a/drivers/gpu/drm/i915/i915_gem_gtt.h
+++ b/drivers/gpu/drm/i915/i915_gem_gtt.h
@@ -350,14 +350,14 @@ struct i915_address_space {
 struct i915_ggtt {
 	struct i915_address_space base;
 
-	size_t stolen_size;		/* Total size of stolen memory */
+	u64 stolen_size;		/* Total size of stolen memory */
 	size_t stolen_usable_size;	/* Total size minus BIOS reserved */
 	size_t stolen_reserved_base;
 	size_t stolen_reserved_size;
 	size_t size;			/* Total size of Global GTT */
 	u64 mappable_end;		/* End offset that we can CPU map */
 	struct io_mapping *mappable;	/* Mapping to our CPU mappable region */
-	phys_addr_t mappable_base;	/* PA of our GMADR */
+	u64 mappable_base;		/* PA of our GMADR */
 
 	/** "Graphics Stolen Memory" holds the global PTEs */
 	void __iomem *gsm;
diff --git a/drivers/gpu/drm/i915/i915_ioc32.c b/drivers/gpu/drm/i915/i915_ioc32.c
index 97f3a5640..32c712efa 100644
--- a/drivers/gpu/drm/i915/i915_ioc32.c
+++ b/drivers/gpu/drm/i915/i915_ioc32.c
@@ -65,7 +65,7 @@ static int compat_i915_getparam(struct file *file, unsigned int cmd,
 			 (unsigned long)request);
 }
 
-static drm_ioctl_compat_t *i915_compat_ioctls[] = {
+static drm_ioctl_compat_t i915_compat_ioctls[] = {
 	[DRM_I915_GETPARAM] = compat_i915_getparam,
 };
 
@@ -81,17 +81,13 @@ static drm_ioctl_compat_t *i915_compat_ioctls[] = {
 long i915_compat_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 {
 	unsigned int nr = DRM_IOCTL_NR(cmd);
-	drm_ioctl_compat_t *fn = NULL;
 	int ret;
 
 	if (nr < DRM_COMMAND_BASE || nr >= DRM_COMMAND_END)
 		return drm_compat_ioctl(filp, cmd, arg);
 
-	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(i915_compat_ioctls))
-		fn = i915_compat_ioctls[nr - DRM_COMMAND_BASE];
-
-	if (fn != NULL)
-		ret = (*fn) (filp, cmd, arg);
+	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(i915_compat_ioctls) && i915_compat_ioctls[nr - DRM_COMMAND_BASE])
+		ret = (*i915_compat_ioctls[nr - DRM_COMMAND_BASE])(filp, cmd, arg);
 	else
 		ret = drm_ioctl(filp, cmd, arg);
 
diff --git a/drivers/gpu/drm/i915/i915_irq.c b/drivers/gpu/drm/i915/i915_irq.c
index 1c2aec392..f807515a0 100644
--- a/drivers/gpu/drm/i915/i915_irq.c
+++ b/drivers/gpu/drm/i915/i915_irq.c
@@ -4541,14 +4541,15 @@ void intel_irq_init(struct drm_i915_private *dev_priv)
 	INIT_DELAYED_WORK(&dev_priv->gpu_error.hangcheck_work,
 			  i915_hangcheck_elapsed);
 
+	pax_open_kernel();
 	if (IS_GEN2(dev_priv)) {
 		dev->max_vblank_count = 0;
-		dev->driver->get_vblank_counter = i8xx_get_vblank_counter;
+		const_cast(dev->driver->get_vblank_counter) = i8xx_get_vblank_counter;
 	} else if (IS_G4X(dev_priv) || INTEL_INFO(dev_priv)->gen >= 5) {
 		dev->max_vblank_count = 0xffffffff; /* full 32 bit counter */
-		dev->driver->get_vblank_counter = g4x_get_vblank_counter;
+		const_cast(dev->driver->get_vblank_counter) = g4x_get_vblank_counter;
 	} else {
-		dev->driver->get_vblank_counter = i915_get_vblank_counter;
+		const_cast(dev->driver->get_vblank_counter) = i915_get_vblank_counter;
 		dev->max_vblank_count = 0xffffff; /* only 24 bits of frame count */
 	}
 
@@ -4560,32 +4561,32 @@ void intel_irq_init(struct drm_i915_private *dev_priv)
 	if (!IS_GEN2(dev_priv))
 		dev->vblank_disable_immediate = true;
 
-	dev->driver->get_vblank_timestamp = i915_get_vblank_timestamp;
-	dev->driver->get_scanout_position = i915_get_crtc_scanoutpos;
+	const_cast(dev->driver->get_vblank_timestamp) = i915_get_vblank_timestamp;
+	const_cast(dev->driver->get_scanout_position) = i915_get_crtc_scanoutpos;
 
 	if (IS_CHERRYVIEW(dev_priv)) {
-		dev->driver->irq_handler = cherryview_irq_handler;
-		dev->driver->irq_preinstall = cherryview_irq_preinstall;
-		dev->driver->irq_postinstall = cherryview_irq_postinstall;
-		dev->driver->irq_uninstall = cherryview_irq_uninstall;
-		dev->driver->enable_vblank = valleyview_enable_vblank;
-		dev->driver->disable_vblank = valleyview_disable_vblank;
+		const_cast(dev->driver->irq_handler) = cherryview_irq_handler;
+		const_cast(dev->driver->irq_preinstall) = cherryview_irq_preinstall;
+		const_cast(dev->driver->irq_postinstall) = cherryview_irq_postinstall;
+		const_cast(dev->driver->irq_uninstall) = cherryview_irq_uninstall;
+		const_cast(dev->driver->enable_vblank) = valleyview_enable_vblank;
+		const_cast(dev->driver->disable_vblank) = valleyview_disable_vblank;
 		dev_priv->display.hpd_irq_setup = i915_hpd_irq_setup;
 	} else if (IS_VALLEYVIEW(dev_priv)) {
-		dev->driver->irq_handler = valleyview_irq_handler;
-		dev->driver->irq_preinstall = valleyview_irq_preinstall;
-		dev->driver->irq_postinstall = valleyview_irq_postinstall;
-		dev->driver->irq_uninstall = valleyview_irq_uninstall;
-		dev->driver->enable_vblank = valleyview_enable_vblank;
-		dev->driver->disable_vblank = valleyview_disable_vblank;
+		const_cast(dev->driver->irq_handler) = valleyview_irq_handler;
+		const_cast(dev->driver->irq_preinstall) = valleyview_irq_preinstall;
+		const_cast(dev->driver->irq_postinstall) = valleyview_irq_postinstall;
+		const_cast(dev->driver->irq_uninstall) = valleyview_irq_uninstall;
+		const_cast(dev->driver->enable_vblank) = valleyview_enable_vblank;
+		const_cast(dev->driver->disable_vblank) = valleyview_disable_vblank;
 		dev_priv->display.hpd_irq_setup = i915_hpd_irq_setup;
 	} else if (INTEL_INFO(dev_priv)->gen >= 8) {
-		dev->driver->irq_handler = gen8_irq_handler;
-		dev->driver->irq_preinstall = gen8_irq_reset;
-		dev->driver->irq_postinstall = gen8_irq_postinstall;
-		dev->driver->irq_uninstall = gen8_irq_uninstall;
-		dev->driver->enable_vblank = gen8_enable_vblank;
-		dev->driver->disable_vblank = gen8_disable_vblank;
+		const_cast(dev->driver->irq_handler) = gen8_irq_handler;
+		const_cast(dev->driver->irq_preinstall) = gen8_irq_reset;
+		const_cast(dev->driver->irq_postinstall) = gen8_irq_postinstall;
+		const_cast(dev->driver->irq_uninstall) = gen8_irq_uninstall;
+		const_cast(dev->driver->enable_vblank) = gen8_enable_vblank;
+		const_cast(dev->driver->disable_vblank) = gen8_disable_vblank;
 		if (IS_BROXTON(dev))
 			dev_priv->display.hpd_irq_setup = bxt_hpd_irq_setup;
 		else if (HAS_PCH_SPT(dev) || HAS_PCH_KBP(dev))
@@ -4593,35 +4594,36 @@ void intel_irq_init(struct drm_i915_private *dev_priv)
 		else
 			dev_priv->display.hpd_irq_setup = ilk_hpd_irq_setup;
 	} else if (HAS_PCH_SPLIT(dev)) {
-		dev->driver->irq_handler = ironlake_irq_handler;
-		dev->driver->irq_preinstall = ironlake_irq_reset;
-		dev->driver->irq_postinstall = ironlake_irq_postinstall;
-		dev->driver->irq_uninstall = ironlake_irq_uninstall;
-		dev->driver->enable_vblank = ironlake_enable_vblank;
-		dev->driver->disable_vblank = ironlake_disable_vblank;
+		const_cast(dev->driver->irq_handler) = ironlake_irq_handler;
+		const_cast(dev->driver->irq_preinstall) = ironlake_irq_reset;
+		const_cast(dev->driver->irq_postinstall) = ironlake_irq_postinstall;
+		const_cast(dev->driver->irq_uninstall) = ironlake_irq_uninstall;
+		const_cast(dev->driver->enable_vblank) = ironlake_enable_vblank;
+		const_cast(dev->driver->disable_vblank) = ironlake_disable_vblank;
 		dev_priv->display.hpd_irq_setup = ilk_hpd_irq_setup;
 	} else {
 		if (IS_GEN2(dev_priv)) {
-			dev->driver->irq_preinstall = i8xx_irq_preinstall;
-			dev->driver->irq_postinstall = i8xx_irq_postinstall;
-			dev->driver->irq_handler = i8xx_irq_handler;
-			dev->driver->irq_uninstall = i8xx_irq_uninstall;
+			const_cast(dev->driver->irq_preinstall) = i8xx_irq_preinstall;
+			const_cast(dev->driver->irq_postinstall) = i8xx_irq_postinstall;
+			const_cast(dev->driver->irq_handler) = i8xx_irq_handler;
+			const_cast(dev->driver->irq_uninstall) = i8xx_irq_uninstall;
 		} else if (IS_GEN3(dev_priv)) {
-			dev->driver->irq_preinstall = i915_irq_preinstall;
-			dev->driver->irq_postinstall = i915_irq_postinstall;
-			dev->driver->irq_uninstall = i915_irq_uninstall;
-			dev->driver->irq_handler = i915_irq_handler;
+			const_cast(dev->driver->irq_preinstall) = i915_irq_preinstall;
+			const_cast(dev->driver->irq_postinstall) = i915_irq_postinstall;
+			const_cast(dev->driver->irq_uninstall) = i915_irq_uninstall;
+			const_cast(dev->driver->irq_handler) = i915_irq_handler;
 		} else {
-			dev->driver->irq_preinstall = i965_irq_preinstall;
-			dev->driver->irq_postinstall = i965_irq_postinstall;
-			dev->driver->irq_uninstall = i965_irq_uninstall;
-			dev->driver->irq_handler = i965_irq_handler;
+			const_cast(dev->driver->irq_preinstall) = i965_irq_preinstall;
+			const_cast(dev->driver->irq_postinstall) = i965_irq_postinstall;
+			const_cast(dev->driver->irq_uninstall) = i965_irq_uninstall;
+			const_cast(dev->driver->irq_handler) = i965_irq_handler;
 		}
 		if (I915_HAS_HOTPLUG(dev_priv))
 			dev_priv->display.hpd_irq_setup = i915_hpd_irq_setup;
-		dev->driver->enable_vblank = i915_enable_vblank;
-		dev->driver->disable_vblank = i915_disable_vblank;
+		const_cast(dev->driver->enable_vblank) = i915_enable_vblank;
+		const_cast(dev->driver->disable_vblank) = i915_disable_vblank;
 	}
+	pax_close_kernel();
 }
 
 /**
diff --git a/drivers/gpu/drm/i915/intel_display.c b/drivers/gpu/drm/i915/intel_display.c
index 6bc93ba7e..57e0fa973 100644
--- a/drivers/gpu/drm/i915/intel_display.c
+++ b/drivers/gpu/drm/i915/intel_display.c
@@ -15595,13 +15595,13 @@ struct intel_quirk {
 	int subsystem_vendor;
 	int subsystem_device;
 	void (*hook)(struct drm_device *dev);
-};
+} __do_const;
 
 /* For systems that don't have a meaningful PCI subdevice/subvendor ID */
 struct intel_dmi_quirk {
 	void (*hook)(struct drm_device *dev);
-	const struct dmi_system_id (*dmi_id_list)[];
-};
+	const struct dmi_system_id *dmi_id_list;
+} __do_const;
 
 static int intel_dmi_reverse_brightness(const struct dmi_system_id *id)
 {
@@ -15609,18 +15609,20 @@ static int intel_dmi_reverse_brightness(const struct dmi_system_id *id)
 	return 1;
 }
 
-static const struct intel_dmi_quirk intel_dmi_quirks[] = {
+static const struct dmi_system_id intel_dmi_quirks_table[] = {
 	{
-		.dmi_id_list = &(const struct dmi_system_id[]) {
-			{
-				.callback = intel_dmi_reverse_brightness,
-				.ident = "NCR Corporation",
-				.matches = {DMI_MATCH(DMI_SYS_VENDOR, "NCR Corporation"),
-					    DMI_MATCH(DMI_PRODUCT_NAME, ""),
-				},
-			},
-			{ }  /* terminating entry */
+		.callback = intel_dmi_reverse_brightness,
+		.ident = "NCR Corporation",
+		.matches = {DMI_MATCH(DMI_SYS_VENDOR, "NCR Corporation"),
+			    DMI_MATCH(DMI_PRODUCT_NAME, ""),
 		},
+	},
+	{ }  /* terminating entry */
+};
+
+static const struct intel_dmi_quirk intel_dmi_quirks[] = {
+	{
+		.dmi_id_list = intel_dmi_quirks_table,
 		.hook = quirk_invert_brightness,
 	},
 };
@@ -15703,7 +15705,7 @@ static void intel_init_quirks(struct drm_device *dev)
 			q->hook(dev);
 	}
 	for (i = 0; i < ARRAY_SIZE(intel_dmi_quirks); i++) {
-		if (dmi_check_system(*intel_dmi_quirks[i].dmi_id_list) != 0)
+		if (dmi_check_system(intel_dmi_quirks[i].dmi_id_list) != 0)
 			intel_dmi_quirks[i].hook(dev);
 	}
 }
diff --git a/drivers/gpu/drm/imx/imx-drm-core.c b/drivers/gpu/drm/imx/imx-drm-core.c
index 7bf90e9e6..30711b930 100644
--- a/drivers/gpu/drm/imx/imx-drm-core.c
+++ b/drivers/gpu/drm/imx/imx-drm-core.c
@@ -380,7 +380,7 @@ int imx_drm_add_crtc(struct drm_device *drm, struct drm_crtc *crtc,
 	if (imxdrm->pipes >= MAX_CRTC)
 		return -EINVAL;
 
-	if (imxdrm->drm->open_count)
+	if (local_read(&imxdrm->drm->open_count))
 		return -EBUSY;
 
 	imx_drm_crtc = kzalloc(sizeof(*imx_drm_crtc), GFP_KERNEL);
diff --git a/drivers/gpu/drm/imx/imx-tve.c b/drivers/gpu/drm/imx/imx-tve.c
index 5e875944f..98a690cbf 100644
--- a/drivers/gpu/drm/imx/imx-tve.c
+++ b/drivers/gpu/drm/imx/imx-tve.c
@@ -252,7 +252,7 @@ static int imx_tve_connector_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int imx_tve_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status imx_tve_connector_mode_valid(struct drm_connector *connector,
 					struct drm_display_mode *mode)
 {
 	struct imx_tve *tve = con_to_tve(connector);
diff --git a/drivers/gpu/drm/mediatek/mtk_hdmi.c b/drivers/gpu/drm/mediatek/mtk_hdmi.c
index 334562d06..90fa448bb 100644
--- a/drivers/gpu/drm/mediatek/mtk_hdmi.c
+++ b/drivers/gpu/drm/mediatek/mtk_hdmi.c
@@ -1232,7 +1232,7 @@ static int mtk_hdmi_conn_get_modes(struct drm_connector *conn)
 	return ret;
 }
 
-static int mtk_hdmi_conn_mode_valid(struct drm_connector *conn,
+static enum drm_mode_status mtk_hdmi_conn_mode_valid(struct drm_connector *conn,
 				    struct drm_display_mode *mode)
 {
 	struct mtk_hdmi *hdmi = hdmi_ctx_from_conn(conn);
diff --git a/drivers/gpu/drm/mga/mga_drv.c b/drivers/gpu/drm/mga/mga_drv.c
index 5e2f131a6..c134c7ca6 100644
--- a/drivers/gpu/drm/mga/mga_drv.c
+++ b/drivers/gpu/drm/mga/mga_drv.c
@@ -92,7 +92,10 @@ static struct pci_driver mga_pci_driver = {
 
 static int __init mga_init(void)
 {
-	driver.num_ioctls = mga_max_ioctl;
+	pax_open_kernel();
+	const_cast(driver.num_ioctls) = mga_max_ioctl;
+	pax_close_kernel();
+
 	return drm_pci_init(&driver, &mga_pci_driver);
 }
 
diff --git a/drivers/gpu/drm/mga/mga_drv.h b/drivers/gpu/drm/mga/mga_drv.h
index bb312339e..75b39f0fb 100644
--- a/drivers/gpu/drm/mga/mga_drv.h
+++ b/drivers/gpu/drm/mga/mga_drv.h
@@ -122,9 +122,9 @@ typedef struct drm_mga_private {
 	u32 clear_cmd;
 	u32 maccess;
 
-	atomic_t vbl_received;          /**< Number of vblanks received. */
+	atomic_unchecked_t vbl_received;          /**< Number of vblanks received. */
 	wait_queue_head_t fence_queue;
-	atomic_t last_fence_retired;
+	atomic_unchecked_t last_fence_retired;
 	u32 next_fence_to_post;
 
 	unsigned int fb_cpp;
@@ -152,7 +152,7 @@ typedef struct drm_mga_private {
 } drm_mga_private_t;
 
 extern const struct drm_ioctl_desc mga_ioctls[];
-extern int mga_max_ioctl;
+extern const int mga_max_ioctl;
 
 				/* mga_dma.c */
 extern int mga_dma_bootstrap(struct drm_device *dev, void *data,
diff --git a/drivers/gpu/drm/mga/mga_ioc32.c b/drivers/gpu/drm/mga/mga_ioc32.c
index 729bfd56b..14bae782b 100644
--- a/drivers/gpu/drm/mga/mga_ioc32.c
+++ b/drivers/gpu/drm/mga/mga_ioc32.c
@@ -190,7 +190,7 @@ static int compat_mga_dma_bootstrap(struct file *file, unsigned int cmd,
 	return 0;
 }
 
-drm_ioctl_compat_t *mga_compat_ioctls[] = {
+drm_ioctl_compat_t mga_compat_ioctls[] = {
 	[DRM_MGA_INIT] = compat_mga_init,
 	[DRM_MGA_GETPARAM] = compat_mga_getparam,
 	[DRM_MGA_DMA_BOOTSTRAP] = compat_mga_dma_bootstrap,
@@ -208,17 +208,13 @@ drm_ioctl_compat_t *mga_compat_ioctls[] = {
 long mga_compat_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 {
 	unsigned int nr = DRM_IOCTL_NR(cmd);
-	drm_ioctl_compat_t *fn = NULL;
 	int ret;
 
 	if (nr < DRM_COMMAND_BASE)
 		return drm_compat_ioctl(filp, cmd, arg);
 
-	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(mga_compat_ioctls))
-		fn = mga_compat_ioctls[nr - DRM_COMMAND_BASE];
-
-	if (fn != NULL)
-		ret = (*fn) (filp, cmd, arg);
+	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(mga_compat_ioctls) && mga_compat_ioctls[nr - DRM_COMMAND_BASE])
+		ret = (*mga_compat_ioctls[nr - DRM_COMMAND_BASE]) (filp, cmd, arg);
 	else
 		ret = drm_ioctl(filp, cmd, arg);
 
diff --git a/drivers/gpu/drm/mga/mga_irq.c b/drivers/gpu/drm/mga/mga_irq.c
index 693ba708c..465bcfc50 100644
--- a/drivers/gpu/drm/mga/mga_irq.c
+++ b/drivers/gpu/drm/mga/mga_irq.c
@@ -43,7 +43,7 @@ u32 mga_get_vblank_counter(struct drm_device *dev, unsigned int pipe)
 	if (pipe != 0)
 		return 0;
 
-	return atomic_read(&dev_priv->vbl_received);
+	return atomic_read_unchecked(&dev_priv->vbl_received);
 }
 
 
@@ -59,7 +59,7 @@ irqreturn_t mga_driver_irq_handler(int irq, void *arg)
 	/* VBLANK interrupt */
 	if (status & MGA_VLINEPEN) {
 		MGA_WRITE(MGA_ICLEAR, MGA_VLINEICLR);
-		atomic_inc(&dev_priv->vbl_received);
+		atomic_inc_unchecked(&dev_priv->vbl_received);
 		drm_handle_vblank(dev, 0);
 		handled = 1;
 	}
@@ -78,7 +78,7 @@ irqreturn_t mga_driver_irq_handler(int irq, void *arg)
 		if ((prim_start & ~0x03) != (prim_end & ~0x03))
 			MGA_WRITE(MGA_PRIMEND, prim_end);
 
-		atomic_inc(&dev_priv->last_fence_retired);
+		atomic_inc_unchecked(&dev_priv->last_fence_retired);
 		wake_up(&dev_priv->fence_queue);
 		handled = 1;
 	}
@@ -129,7 +129,7 @@ int mga_driver_fence_wait(struct drm_device *dev, unsigned int *sequence)
 	 * using fences.
 	 */
 	DRM_WAIT_ON(ret, dev_priv->fence_queue, 3 * HZ,
-		    (((cur_fence = atomic_read(&dev_priv->last_fence_retired))
+		    (((cur_fence = atomic_read_unchecked(&dev_priv->last_fence_retired))
 		      - *sequence) <= (1 << 23)));
 
 	*sequence = cur_fence;
diff --git a/drivers/gpu/drm/mga/mga_state.c b/drivers/gpu/drm/mga/mga_state.c
index 792f92449..aeb1334d3 100644
--- a/drivers/gpu/drm/mga/mga_state.c
+++ b/drivers/gpu/drm/mga/mga_state.c
@@ -1099,4 +1099,4 @@ const struct drm_ioctl_desc mga_ioctls[] = {
 	DRM_IOCTL_DEF_DRV(MGA_DMA_BOOTSTRAP, mga_dma_bootstrap, DRM_AUTH|DRM_MASTER|DRM_ROOT_ONLY),
 };
 
-int mga_max_ioctl = ARRAY_SIZE(mga_ioctls);
+const int mga_max_ioctl = ARRAY_SIZE(mga_ioctls);
diff --git a/drivers/gpu/drm/mgag200/mgag200_mode.c b/drivers/gpu/drm/mgag200/mgag200_mode.c
index 6b21cb27e..90c28760e 100644
--- a/drivers/gpu/drm/mgag200/mgag200_mode.c
+++ b/drivers/gpu/drm/mgag200/mgag200_mode.c
@@ -1574,7 +1574,7 @@ static uint32_t mga_vga_calculate_mode_bandwidth(struct drm_display_mode *mode,
 
 #define MODE_BANDWIDTH	MODE_BAD
 
-static int mga_vga_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status mga_vga_mode_valid(struct drm_connector *connector,
 				 struct drm_display_mode *mode)
 {
 	struct drm_device *dev = connector->dev;
diff --git a/drivers/gpu/drm/msm/dsi/dsi_manager.c b/drivers/gpu/drm/msm/dsi/dsi_manager.c
index c8d1f19c9..10d49d43c 100644
--- a/drivers/gpu/drm/msm/dsi/dsi_manager.c
+++ b/drivers/gpu/drm/msm/dsi/dsi_manager.c
@@ -306,7 +306,7 @@ static int dsi_mgr_connector_get_modes(struct drm_connector *connector)
 	return num;
 }
 
-static int dsi_mgr_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status dsi_mgr_connector_mode_valid(struct drm_connector *connector,
 				struct drm_display_mode *mode)
 {
 	int id = dsi_mgr_connector_get_id(connector);
diff --git a/drivers/gpu/drm/msm/edp/edp_connector.c b/drivers/gpu/drm/msm/edp/edp_connector.c
index 5960628ce..fe2e4de80 100644
--- a/drivers/gpu/drm/msm/edp/edp_connector.c
+++ b/drivers/gpu/drm/msm/edp/edp_connector.c
@@ -63,7 +63,7 @@ static int edp_connector_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int edp_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status edp_connector_mode_valid(struct drm_connector *connector,
 				 struct drm_display_mode *mode)
 {
 	struct edp_connector *edp_connector = to_edp_connector(connector);
diff --git a/drivers/gpu/drm/msm/hdmi/hdmi_connector.c b/drivers/gpu/drm/msm/hdmi/hdmi_connector.c
index a2515b466..cec0906da 100644
--- a/drivers/gpu/drm/msm/hdmi/hdmi_connector.c
+++ b/drivers/gpu/drm/msm/hdmi/hdmi_connector.c
@@ -377,7 +377,7 @@ static int msm_hdmi_connector_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int msm_hdmi_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status msm_hdmi_connector_mode_valid(struct drm_connector *connector,
 				 struct drm_display_mode *mode)
 {
 	struct hdmi_connector *hdmi_connector = to_hdmi_connector(connector);
diff --git a/drivers/gpu/drm/msm/mdp/mdp5/mdp5_kms.c b/drivers/gpu/drm/msm/mdp/mdp5/mdp5_kms.c
index ed7143d35..527b26ab1 100644
--- a/drivers/gpu/drm/msm/mdp/mdp5/mdp5_kms.c
+++ b/drivers/gpu/drm/msm/mdp/mdp5/mdp5_kms.c
@@ -647,9 +647,12 @@ struct msm_kms *mdp5_kms_init(struct drm_device *dev)
 	dev->mode_config.max_width = config->hw->lm.max_width;
 	dev->mode_config.max_height = config->hw->lm.max_height;
 
-	dev->driver->get_vblank_timestamp = mdp5_get_vblank_timestamp;
-	dev->driver->get_scanout_position = mdp5_get_scanoutpos;
-	dev->driver->get_vblank_counter = mdp5_get_vblank_counter;
+	pax_open_kernel();
+	const_cast(dev->driver->get_vblank_timestamp) = mdp5_get_vblank_timestamp;
+	const_cast(dev->driver->get_scanout_position) = mdp5_get_scanoutpos;
+	const_cast(dev->driver->get_vblank_counter) = mdp5_get_vblank_counter;
+	pax_close_kernel();
+
 	dev->max_vblank_count = 0xffffffff;
 	dev->vblank_disable_immediate = true;
 
diff --git a/drivers/gpu/drm/nouveau/nouveau_acpi.c b/drivers/gpu/drm/nouveau/nouveau_acpi.c
index 193573d19..3f62e5398 100644
--- a/drivers/gpu/drm/nouveau/nouveau_acpi.c
+++ b/drivers/gpu/drm/nouveau/nouveau_acpi.c
@@ -194,7 +194,7 @@ static int nouveau_dsm_power_state(enum vga_switcheroo_client_id id,
 	return nouveau_dsm_set_discrete_state(nouveau_dsm_priv.dhandle, state);
 }
 
-static int nouveau_dsm_get_client_id(struct pci_dev *pdev)
+static enum vga_switcheroo_client_id nouveau_dsm_get_client_id(struct pci_dev *pdev)
 {
 	/* easy option one - intel vendor ID means Integrated */
 	if (pdev->vendor == PCI_VENDOR_ID_INTEL)
diff --git a/drivers/gpu/drm/nouveau/nouveau_bios.c b/drivers/gpu/drm/nouveau/nouveau_bios.c
index 23ffe8571..f87a82de0 100644
--- a/drivers/gpu/drm/nouveau/nouveau_bios.c
+++ b/drivers/gpu/drm/nouveau/nouveau_bios.c
@@ -967,7 +967,7 @@ static int parse_bit_tmds_tbl_entry(struct drm_device *dev, struct nvbios *bios,
 struct bit_table {
 	const char id;
 	int (* const parse_fn)(struct drm_device *, struct nvbios *, struct bit_entry *);
-};
+} __no_const;
 
 #define BIT_TABLE(id, funcid) ((struct bit_table){ id, parse_bit_##funcid##_tbl_entry })
 
diff --git a/drivers/gpu/drm/nouveau/nouveau_connector.c b/drivers/gpu/drm/nouveau/nouveau_connector.c
index c1084088f..575750a96 100644
--- a/drivers/gpu/drm/nouveau/nouveau_connector.c
+++ b/drivers/gpu/drm/nouveau/nouveau_connector.c
@@ -862,7 +862,7 @@ get_tmds_link_bandwidth(struct drm_connector *connector, bool hdmi)
 		return 112000;
 }
 
-static int
+static enum drm_mode_status
 nouveau_connector_mode_valid(struct drm_connector *connector,
 			     struct drm_display_mode *mode)
 {
diff --git a/drivers/gpu/drm/nouveau/nouveau_drm.c b/drivers/gpu/drm/nouveau/nouveau_drm.c
index 66c1280c0..580abef0e 100644
--- a/drivers/gpu/drm/nouveau/nouveau_drm.c
+++ b/drivers/gpu/drm/nouveau/nouveau_drm.c
@@ -80,9 +80,8 @@ MODULE_PARM_DESC(runpm, "disable (0), force enable (1), optimus only default (-1
 int nouveau_runtime_pm = -1;
 module_param_named(runpm, nouveau_runtime_pm, int, 0400);
 
-static struct drm_driver driver_stub;
 static struct drm_driver driver_pci;
-static struct drm_driver driver_platform;
+static drm_driver_no_const driver_platform __read_only;
 
 static u64
 nouveau_pci_name(struct pci_dev *pdev)
@@ -942,7 +941,7 @@ nouveau_driver_fops = {
 };
 
 static struct drm_driver
-driver_stub = {
+driver_pci = {
 	.driver_features =
 		DRIVER_GEM | DRIVER_MODESET | DRIVER_PRIME | DRIVER_RENDER |
 		DRIVER_KMS_LEGACY_CONTEXT,
@@ -954,6 +953,8 @@ driver_stub = {
 	.postclose = nouveau_drm_postclose,
 	.lastclose = nouveau_vga_lastclose,
 
+	.set_busid = drm_pci_set_busid,
+
 #if defined(CONFIG_DEBUG_FS)
 	.debugfs_init = nouveau_drm_debugfs_init,
 	.debugfs_cleanup = nouveau_drm_debugfs_cleanup,
@@ -1086,9 +1087,10 @@ err_free:
 static int __init
 nouveau_drm_init(void)
 {
-	driver_pci = driver_stub;
-	driver_pci.set_busid = drm_pci_set_busid;
-	driver_platform = driver_stub;
+	pax_open_kernel();
+	driver_platform = driver_pci;
+	driver_platform.set_busid = NULL;
+	pax_close_kernel();
 
 	nouveau_display_options();
 
diff --git a/drivers/gpu/drm/nouveau/nouveau_drv.h b/drivers/gpu/drm/nouveau/nouveau_drv.h
index 822a0212c..a131e6668 100644
--- a/drivers/gpu/drm/nouveau/nouveau_drv.h
+++ b/drivers/gpu/drm/nouveau/nouveau_drv.h
@@ -124,7 +124,6 @@ struct nouveau_drm {
 		struct drm_global_reference mem_global_ref;
 		struct ttm_bo_global_ref bo_global_ref;
 		struct ttm_bo_device bdev;
-		atomic_t validate_sequence;
 		int (*move)(struct nouveau_channel *,
 			    struct ttm_buffer_object *,
 			    struct ttm_mem_reg *, struct ttm_mem_reg *);
diff --git a/drivers/gpu/drm/nouveau/nouveau_ioc32.c b/drivers/gpu/drm/nouveau/nouveau_ioc32.c
index 462679a8f..88e32a794 100644
--- a/drivers/gpu/drm/nouveau/nouveau_ioc32.c
+++ b/drivers/gpu/drm/nouveau/nouveau_ioc32.c
@@ -50,7 +50,7 @@ long nouveau_compat_ioctl(struct file *filp, unsigned int cmd,
 			 unsigned long arg)
 {
 	unsigned int nr = DRM_IOCTL_NR(cmd);
-	drm_ioctl_compat_t *fn = NULL;
+	drm_ioctl_compat_t fn = NULL;
 	int ret;
 
 	if (nr < DRM_COMMAND_BASE)
diff --git a/drivers/gpu/drm/nouveau/nouveau_ttm.c b/drivers/gpu/drm/nouveau/nouveau_ttm.c
index 1825dbc33..c1ec287aa 100644
--- a/drivers/gpu/drm/nouveau/nouveau_ttm.c
+++ b/drivers/gpu/drm/nouveau/nouveau_ttm.c
@@ -107,10 +107,10 @@ nouveau_vram_manager_new(struct ttm_mem_type_manager *man,
 }
 
 const struct ttm_mem_type_manager_func nouveau_vram_manager = {
-	nouveau_vram_manager_init,
-	nouveau_vram_manager_fini,
-	nouveau_vram_manager_new,
-	nouveau_vram_manager_del,
+	.init = nouveau_vram_manager_init,
+	.takedown = nouveau_vram_manager_fini,
+	.get_node = nouveau_vram_manager_new,
+	.put_node = nouveau_vram_manager_del,
 };
 
 static int
@@ -184,11 +184,11 @@ nouveau_gart_manager_debug(struct ttm_mem_type_manager *man, const char *prefix)
 }
 
 const struct ttm_mem_type_manager_func nouveau_gart_manager = {
-	nouveau_gart_manager_init,
-	nouveau_gart_manager_fini,
-	nouveau_gart_manager_new,
-	nouveau_gart_manager_del,
-	nouveau_gart_manager_debug
+	.init = nouveau_gart_manager_init,
+	.takedown = nouveau_gart_manager_fini,
+	.get_node = nouveau_gart_manager_new,
+	.put_node = nouveau_gart_manager_del,
+	.debug = nouveau_gart_manager_debug
 };
 
 /*XXX*/
@@ -257,11 +257,11 @@ nv04_gart_manager_debug(struct ttm_mem_type_manager *man, const char *prefix)
 }
 
 const struct ttm_mem_type_manager_func nv04_gart_manager = {
-	nv04_gart_manager_init,
-	nv04_gart_manager_fini,
-	nv04_gart_manager_new,
-	nv04_gart_manager_del,
-	nv04_gart_manager_debug
+	.init = nv04_gart_manager_init,
+	.takedown = nv04_gart_manager_fini,
+	.get_node = nv04_gart_manager_new,
+	.put_node = nv04_gart_manager_del,
+	.debug = nv04_gart_manager_debug
 };
 
 int
diff --git a/drivers/gpu/drm/nouveau/nouveau_vga.c b/drivers/gpu/drm/nouveau/nouveau_vga.c
index c6a180a0c..c5c7855d5 100644
--- a/drivers/gpu/drm/nouveau/nouveau_vga.c
+++ b/drivers/gpu/drm/nouveau/nouveau_vga.c
@@ -73,7 +73,7 @@ nouveau_switcheroo_can_switch(struct pci_dev *pdev)
 	 * locking inversion with the driver load path. And the access here is
 	 * completely racy anyway. So don't bother with locking for now.
 	 */
-	return dev->open_count == 0;
+	return local_read(&dev->open_count) == 0;
 }
 
 static const struct vga_switcheroo_client_ops
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadow.c b/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadow.c
index 7deb81b6d..bb22bc27a 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadow.c
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadow.c
@@ -154,11 +154,16 @@ shadow_fw_init(struct nvkm_bios *bios, const char *name)
 	return (void *)fw;
 }
 
+static void shadow_fw_fini(void *fw)
+{
+	release_firmware(fw);
+}
+
 static const struct nvbios_source
 shadow_fw = {
 	.name = "firmware",
 	.init = shadow_fw_init,
-	.fini = (void(*)(void *))release_firmware,
+	.fini = shadow_fw_fini,
 	.read = shadow_fw_read,
 	.rw = false,
 };
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadowpci.c b/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadowpci.c
index 9b91da09d..b3fa90d37 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadowpci.c
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/bios/shadowpci.c
@@ -111,11 +111,16 @@ platform_init(struct nvkm_bios *bios, const char *name)
 	return ERR_PTR(ret);
 }
 
+static void platform_fini(void *data)
+{
+	kfree(data);
+}
+
 const struct nvbios_source
 nvbios_platform = {
 	.name = "PLATFORM",
 	.init = platform_init,
-	.fini = (void(*)(void *))kfree,
+	.fini = platform_fini,
 	.read = pcirom_read,
 	.rw = true,
 };
diff --git a/drivers/gpu/drm/nouveau/nvkm/subdev/secboot/priv.h b/drivers/gpu/drm/nouveau/nvkm/subdev/secboot/priv.h
index a9a8a0e10..2ad6d622e 100644
--- a/drivers/gpu/drm/nouveau/nvkm/subdev/secboot/priv.h
+++ b/drivers/gpu/drm/nouveau/nvkm/subdev/secboot/priv.h
@@ -226,8 +226,8 @@ struct gm200_secboot_func {
 
 int gm200_secboot_init(struct nvkm_secboot *);
 void *gm200_secboot_dtor(struct nvkm_secboot *);
-int gm200_secboot_reset(struct nvkm_secboot *, u32);
-int gm200_secboot_start(struct nvkm_secboot *, u32);
+int gm200_secboot_reset(struct nvkm_secboot *, enum nvkm_secboot_falcon);
+int gm200_secboot_start(struct nvkm_secboot *, enum nvkm_secboot_falcon);
 
 int gm20x_secboot_prepare_blobs(struct gm200_secboot *);
 
diff --git a/drivers/gpu/drm/omapdrm/dss/display.c b/drivers/gpu/drm/omapdrm/dss/display.c
index 8dcdd7cf9..0e37527d1 100644
--- a/drivers/gpu/drm/omapdrm/dss/display.c
+++ b/drivers/gpu/drm/omapdrm/dss/display.c
@@ -112,12 +112,14 @@ int omapdss_register_display(struct omap_dss_device *dssdev)
 	if (dssdev->name == NULL)
 		dssdev->name = dssdev->alias;
 
+	pax_open_kernel();
 	if (drv && drv->get_resolution == NULL)
-		drv->get_resolution = omapdss_default_get_resolution;
+		const_cast(drv->get_resolution) = omapdss_default_get_resolution;
 	if (drv && drv->get_recommended_bpp == NULL)
-		drv->get_recommended_bpp = omapdss_default_get_recommended_bpp;
+		const_cast(drv->get_recommended_bpp) = omapdss_default_get_recommended_bpp;
 	if (drv && drv->get_timings == NULL)
-		drv->get_timings = omapdss_default_get_timings;
+		const_cast(drv->get_timings) = omapdss_default_get_timings;
+	pax_close_kernel();
 
 	mutex_lock(&panel_list_mutex);
 	list_add_tail(&dssdev->panel_list, &panel_list);
diff --git a/drivers/gpu/drm/omapdrm/omap_connector.c b/drivers/gpu/drm/omapdrm/omap_connector.c
index 137fe690a..bbfc18cf2 100644
--- a/drivers/gpu/drm/omapdrm/omap_connector.c
+++ b/drivers/gpu/drm/omapdrm/omap_connector.c
@@ -201,7 +201,7 @@ static int omap_connector_get_modes(struct drm_connector *connector)
 	return n;
 }
 
-static int omap_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status omap_connector_mode_valid(struct drm_connector *connector,
 				 struct drm_display_mode *mode)
 {
 	struct omap_connector *omap_connector = to_omap_connector(connector);
diff --git a/drivers/gpu/drm/qxl/qxl_cmd.c b/drivers/gpu/drm/qxl/qxl_cmd.c
index 04270f5d1..7688e90a6 100644
--- a/drivers/gpu/drm/qxl/qxl_cmd.c
+++ b/drivers/gpu/drm/qxl/qxl_cmd.c
@@ -285,27 +285,27 @@ static int wait_for_io_cmd_user(struct qxl_device *qdev, uint8_t val, long port,
 	int ret;
 
 	mutex_lock(&qdev->async_io_mutex);
-	irq_num = atomic_read(&qdev->irq_received_io_cmd);
+	irq_num = atomic_read_unchecked(&qdev->irq_received_io_cmd);
 	if (qdev->last_sent_io_cmd > irq_num) {
 		if (intr)
 			ret = wait_event_interruptible_timeout(qdev->io_cmd_event,
-							       atomic_read(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
+							       atomic_read_unchecked(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
 		else
 			ret = wait_event_timeout(qdev->io_cmd_event,
-						 atomic_read(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
+						 atomic_read_unchecked(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
 		/* 0 is timeout, just bail the "hw" has gone away */
 		if (ret <= 0)
 			goto out;
-		irq_num = atomic_read(&qdev->irq_received_io_cmd);
+		irq_num = atomic_read_unchecked(&qdev->irq_received_io_cmd);
 	}
 	outb(val, addr);
 	qdev->last_sent_io_cmd = irq_num + 1;
 	if (intr)
 		ret = wait_event_interruptible_timeout(qdev->io_cmd_event,
-						       atomic_read(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
+						       atomic_read_unchecked(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
 	else
 		ret = wait_event_timeout(qdev->io_cmd_event,
-					 atomic_read(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
+					 atomic_read_unchecked(&qdev->irq_received_io_cmd) > irq_num, 5*HZ);
 out:
 	if (ret > 0)
 		ret = 0;
diff --git a/drivers/gpu/drm/qxl/qxl_debugfs.c b/drivers/gpu/drm/qxl/qxl_debugfs.c
index 6911b8c44..89d686707 100644
--- a/drivers/gpu/drm/qxl/qxl_debugfs.c
+++ b/drivers/gpu/drm/qxl/qxl_debugfs.c
@@ -42,10 +42,10 @@ qxl_debugfs_irq_received(struct seq_file *m, void *data)
 	struct drm_info_node *node = (struct drm_info_node *) m->private;
 	struct qxl_device *qdev = node->minor->dev->dev_private;
 
-	seq_printf(m, "%d\n", atomic_read(&qdev->irq_received));
-	seq_printf(m, "%d\n", atomic_read(&qdev->irq_received_display));
-	seq_printf(m, "%d\n", atomic_read(&qdev->irq_received_cursor));
-	seq_printf(m, "%d\n", atomic_read(&qdev->irq_received_io_cmd));
+	seq_printf(m, "%d\n", atomic_read_unchecked(&qdev->irq_received));
+	seq_printf(m, "%d\n", atomic_read_unchecked(&qdev->irq_received_display));
+	seq_printf(m, "%d\n", atomic_read_unchecked(&qdev->irq_received_cursor));
+	seq_printf(m, "%d\n", atomic_read_unchecked(&qdev->irq_received_io_cmd));
 	seq_printf(m, "%d\n", qdev->irq_received_error);
 	return 0;
 }
diff --git a/drivers/gpu/drm/qxl/qxl_display.c b/drivers/gpu/drm/qxl/qxl_display.c
index 3aef12742..9ea766640 100644
--- a/drivers/gpu/drm/qxl/qxl_display.c
+++ b/drivers/gpu/drm/qxl/qxl_display.c
@@ -826,7 +826,7 @@ static int qxl_conn_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int qxl_conn_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status qxl_conn_mode_valid(struct drm_connector *connector,
 			       struct drm_display_mode *mode)
 {
 	struct drm_device *ddev = connector->dev;
diff --git a/drivers/gpu/drm/qxl/qxl_drv.c b/drivers/gpu/drm/qxl/qxl_drv.c
index 460bbceae..abeb896bc 100644
--- a/drivers/gpu/drm/qxl/qxl_drv.c
+++ b/drivers/gpu/drm/qxl/qxl_drv.c
@@ -37,7 +37,7 @@
 #include "qxl_drv.h"
 #include "qxl_object.h"
 
-extern int qxl_max_ioctls;
+extern const int qxl_max_ioctls;
 static const struct pci_device_id pciidlist[] = {
 	{ 0x1b36, 0x100, PCI_ANY_ID, PCI_ANY_ID, PCI_CLASS_DISPLAY_VGA << 8,
 	  0xffff00, 0 },
@@ -277,7 +277,11 @@ static int __init qxl_init(void)
 
 	if (qxl_modeset == 0)
 		return -EINVAL;
-	qxl_driver.num_ioctls = qxl_max_ioctls;
+
+	pax_open_kernel();
+	const_cast(qxl_driver.num_ioctls) = qxl_max_ioctls;
+	pax_close_kernel();
+
 	return drm_pci_init(&qxl_driver, &qxl_pci_driver);
 }
 
diff --git a/drivers/gpu/drm/qxl/qxl_drv.h b/drivers/gpu/drm/qxl/qxl_drv.h
index 8e633caa4..64debeb07 100644
--- a/drivers/gpu/drm/qxl/qxl_drv.h
+++ b/drivers/gpu/drm/qxl/qxl_drv.h
@@ -292,10 +292,10 @@ struct qxl_device {
 	unsigned int last_sent_io_cmd;
 
 	/* interrupt handling */
-	atomic_t irq_received;
-	atomic_t irq_received_display;
-	atomic_t irq_received_cursor;
-	atomic_t irq_received_io_cmd;
+	atomic_unchecked_t irq_received;
+	atomic_unchecked_t irq_received_display;
+	atomic_unchecked_t irq_received_cursor;
+	atomic_unchecked_t irq_received_io_cmd;
 	unsigned irq_received_error;
 	wait_queue_head_t display_event;
 	wait_queue_head_t cursor_event;
diff --git a/drivers/gpu/drm/qxl/qxl_ioctl.c b/drivers/gpu/drm/qxl/qxl_ioctl.c
index 5a4c8c492..faf4c73b3 100644
--- a/drivers/gpu/drm/qxl/qxl_ioctl.c
+++ b/drivers/gpu/drm/qxl/qxl_ioctl.c
@@ -183,7 +183,7 @@ static int qxl_process_single_command(struct qxl_device *qdev,
 
 	/* TODO copy slow path code from i915 */
 	fb_cmd = qxl_bo_kmap_atomic_page(qdev, cmd_bo, (release->release_offset & PAGE_SIZE));
-	unwritten = __copy_from_user_inatomic_nocache(fb_cmd + sizeof(union qxl_release_info) + (release->release_offset & ~PAGE_SIZE), (void *)(unsigned long)cmd->command, cmd->command_size);
+	unwritten = __copy_from_user_inatomic_nocache(fb_cmd + sizeof(union qxl_release_info) + (release->release_offset & ~PAGE_SIZE), (void __force_user *)(unsigned long)cmd->command, cmd->command_size);
 
 	{
 		struct qxl_drawable *draw = fb_cmd;
@@ -203,7 +203,7 @@ static int qxl_process_single_command(struct qxl_device *qdev,
 		struct drm_qxl_reloc reloc;
 
 		if (copy_from_user(&reloc,
-				       &((struct drm_qxl_reloc *)(uintptr_t)cmd->relocs)[i],
+				       &((struct drm_qxl_reloc __force_user *)(uintptr_t)cmd->relocs)[i],
 				       sizeof(reloc))) {
 			ret = -EFAULT;
 			goto out_free_bos;
@@ -282,10 +282,10 @@ static int qxl_execbuffer_ioctl(struct drm_device *dev, void *data,
 
 	for (cmd_num = 0; cmd_num < execbuffer->commands_num; ++cmd_num) {
 
-		struct drm_qxl_command *commands =
-			(struct drm_qxl_command *)(uintptr_t)execbuffer->commands;
+		struct drm_qxl_command __user *commands =
+			(struct drm_qxl_command __user *)(uintptr_t)execbuffer->commands;
 
-		if (copy_from_user(&user_cmd, &commands[cmd_num],
+		if (copy_from_user(&user_cmd, (struct drm_qxl_command __force_user *)&commands[cmd_num],
 				       sizeof(user_cmd)))
 			return -EFAULT;
 
@@ -439,4 +439,4 @@ const struct drm_ioctl_desc qxl_ioctls[] = {
 			  DRM_AUTH),
 };
 
-int qxl_max_ioctls = ARRAY_SIZE(qxl_ioctls);
+const int qxl_max_ioctls = ARRAY_SIZE(qxl_ioctls);
diff --git a/drivers/gpu/drm/qxl/qxl_irq.c b/drivers/gpu/drm/qxl/qxl_irq.c
index 0bf1e20c6..42a73107a 100644
--- a/drivers/gpu/drm/qxl/qxl_irq.c
+++ b/drivers/gpu/drm/qxl/qxl_irq.c
@@ -36,19 +36,19 @@ irqreturn_t qxl_irq_handler(int irq, void *arg)
 	if (!pending)
 		return IRQ_NONE;
 
-	atomic_inc(&qdev->irq_received);
+	atomic_inc_unchecked(&qdev->irq_received);
 
 	if (pending & QXL_INTERRUPT_DISPLAY) {
-		atomic_inc(&qdev->irq_received_display);
+		atomic_inc_unchecked(&qdev->irq_received_display);
 		wake_up_all(&qdev->display_event);
 		qxl_queue_garbage_collect(qdev, false);
 	}
 	if (pending & QXL_INTERRUPT_CURSOR) {
-		atomic_inc(&qdev->irq_received_cursor);
+		atomic_inc_unchecked(&qdev->irq_received_cursor);
 		wake_up_all(&qdev->cursor_event);
 	}
 	if (pending & QXL_INTERRUPT_IO_CMD) {
-		atomic_inc(&qdev->irq_received_io_cmd);
+		atomic_inc_unchecked(&qdev->irq_received_io_cmd);
 		wake_up_all(&qdev->io_cmd_event);
 	}
 	if (pending & QXL_INTERRUPT_ERROR) {
@@ -85,10 +85,10 @@ int qxl_irq_init(struct qxl_device *qdev)
 	init_waitqueue_head(&qdev->io_cmd_event);
 	INIT_WORK(&qdev->client_monitors_config_work,
 		  qxl_client_monitors_config_work_func);
-	atomic_set(&qdev->irq_received, 0);
-	atomic_set(&qdev->irq_received_display, 0);
-	atomic_set(&qdev->irq_received_cursor, 0);
-	atomic_set(&qdev->irq_received_io_cmd, 0);
+	atomic_set_unchecked(&qdev->irq_received, 0);
+	atomic_set_unchecked(&qdev->irq_received_display, 0);
+	atomic_set_unchecked(&qdev->irq_received_cursor, 0);
+	atomic_set_unchecked(&qdev->irq_received_io_cmd, 0);
 	qdev->irq_received_error = 0;
 	ret = drm_irq_install(qdev->ddev, qdev->ddev->pdev->irq);
 	qdev->ram_header->int_mask = QXL_INTERRUPT_MASK;
diff --git a/drivers/gpu/drm/qxl/qxl_ttm.c b/drivers/gpu/drm/qxl/qxl_ttm.c
index d50c9679e..f96d908a5 100644
--- a/drivers/gpu/drm/qxl/qxl_ttm.c
+++ b/drivers/gpu/drm/qxl/qxl_ttm.c
@@ -103,7 +103,7 @@ static void qxl_ttm_global_fini(struct qxl_device *qdev)
 	}
 }
 
-static struct vm_operations_struct qxl_ttm_vm_ops;
+static vm_operations_struct_no_const qxl_ttm_vm_ops __read_only;
 static const struct vm_operations_struct *ttm_vm_ops;
 
 static int qxl_ttm_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
@@ -145,8 +145,10 @@ int qxl_mmap(struct file *filp, struct vm_area_struct *vma)
 		return r;
 	if (unlikely(ttm_vm_ops == NULL)) {
 		ttm_vm_ops = vma->vm_ops;
+		pax_open_kernel();
 		qxl_ttm_vm_ops = *ttm_vm_ops;
 		qxl_ttm_vm_ops.fault = &qxl_ttm_fault;
+		pax_close_kernel();
 	}
 	vma->vm_ops = &qxl_ttm_vm_ops;
 	return 0;
@@ -474,25 +476,23 @@ static int qxl_mm_dump_table(struct seq_file *m, void *data)
 static int qxl_ttm_debugfs_init(struct qxl_device *qdev)
 {
 #if defined(CONFIG_DEBUG_FS)
-	static struct drm_info_list qxl_mem_types_list[QXL_DEBUGFS_MEM_TYPES];
-	static char qxl_mem_types_names[QXL_DEBUGFS_MEM_TYPES][32];
-	unsigned i;
-
-	for (i = 0; i < QXL_DEBUGFS_MEM_TYPES; i++) {
-		if (i == 0)
-			sprintf(qxl_mem_types_names[i], "qxl_mem_mm");
-		else
-			sprintf(qxl_mem_types_names[i], "qxl_surf_mm");
-		qxl_mem_types_list[i].name = qxl_mem_types_names[i];
-		qxl_mem_types_list[i].show = &qxl_mm_dump_table;
-		qxl_mem_types_list[i].driver_features = 0;
-		if (i == 0)
-			qxl_mem_types_list[i].data = qdev->mman.bdev.man[TTM_PL_VRAM].priv;
-		else
-			qxl_mem_types_list[i].data = qdev->mman.bdev.man[TTM_PL_PRIV0].priv;
+	static struct drm_info_list qxl_mem_types_list[QXL_DEBUGFS_MEM_TYPES] = {
+		{
+			.name = "qxl_mem_mm",
+			.show = &qxl_mm_dump_table,
+		},
+		{
+			.name = "qxl_surf_mm",
+			.show = &qxl_mm_dump_table,
+		}
+	};
 
-	}
-	return qxl_debugfs_add_files(qdev, qxl_mem_types_list, i);
+	pax_open_kernel();
+	const_cast(qxl_mem_types_list[0].data) = qdev->mman.bdev.man[TTM_PL_VRAM].priv;
+	const_cast(qxl_mem_types_list[1].data) = qdev->mman.bdev.man[TTM_PL_PRIV0].priv;
+	pax_close_kernel();
+
+	return qxl_debugfs_add_files(qdev, qxl_mem_types_list, QXL_DEBUGFS_MEM_TYPES);
 #else
 	return 0;
 #endif
diff --git a/drivers/gpu/drm/r128/r128_cce.c b/drivers/gpu/drm/r128/r128_cce.c
index 9e8f6163c..401567440 100644
--- a/drivers/gpu/drm/r128/r128_cce.c
+++ b/drivers/gpu/drm/r128/r128_cce.c
@@ -377,7 +377,7 @@ static int r128_do_init_cce(struct drm_device *dev, drm_r128_init_t *init)
 
 	/* GH: Simple idle check.
 	 */
-	atomic_set(&dev_priv->idle_count, 0);
+	atomic_set_unchecked(&dev_priv->idle_count, 0);
 
 	/* We don't support anything other than bus-mastering ring mode,
 	 * but the ring can be in either AGP or PCI space for the ring
diff --git a/drivers/gpu/drm/r128/r128_drv.c b/drivers/gpu/drm/r128/r128_drv.c
index c57b4de63..1a875fb16 100644
--- a/drivers/gpu/drm/r128/r128_drv.c
+++ b/drivers/gpu/drm/r128/r128_drv.c
@@ -94,7 +94,9 @@ static struct pci_driver r128_pci_driver = {
 
 static int __init r128_init(void)
 {
-	driver.num_ioctls = r128_max_ioctl;
+	pax_open_kernel();
+	const_cast(driver.num_ioctls) = r128_max_ioctl;
+	pax_close_kernel();
 
 	return drm_pci_init(&driver, &r128_pci_driver);
 }
diff --git a/drivers/gpu/drm/r128/r128_drv.h b/drivers/gpu/drm/r128/r128_drv.h
index 09143b840..86c8394cd 100644
--- a/drivers/gpu/drm/r128/r128_drv.h
+++ b/drivers/gpu/drm/r128/r128_drv.h
@@ -93,14 +93,14 @@ typedef struct drm_r128_private {
 	int is_pci;
 	unsigned long cce_buffers_offset;
 
-	atomic_t idle_count;
+	atomic_unchecked_t idle_count;
 
 	int page_flipping;
 	int current_page;
 	u32 crtc_offset;
 	u32 crtc_offset_cntl;
 
-	atomic_t vbl_received;
+	atomic_unchecked_t vbl_received;
 
 	u32 color_fmt;
 	unsigned int front_offset;
@@ -135,7 +135,7 @@ typedef struct drm_r128_buf_priv {
 } drm_r128_buf_priv_t;
 
 extern const struct drm_ioctl_desc r128_ioctls[];
-extern int r128_max_ioctl;
+extern const int r128_max_ioctl;
 
 				/* r128_cce.c */
 extern int r128_cce_init(struct drm_device *dev, void *data, struct drm_file *file_priv);
diff --git a/drivers/gpu/drm/r128/r128_ioc32.c b/drivers/gpu/drm/r128/r128_ioc32.c
index 663f38c63..ec159a123 100644
--- a/drivers/gpu/drm/r128/r128_ioc32.c
+++ b/drivers/gpu/drm/r128/r128_ioc32.c
@@ -178,7 +178,7 @@ static int compat_r128_getparam(struct file *file, unsigned int cmd,
 	return drm_ioctl(file, DRM_IOCTL_R128_GETPARAM, (unsigned long)getparam);
 }
 
-drm_ioctl_compat_t *r128_compat_ioctls[] = {
+drm_ioctl_compat_t r128_compat_ioctls[] = {
 	[DRM_R128_INIT] = compat_r128_init,
 	[DRM_R128_DEPTH] = compat_r128_depth,
 	[DRM_R128_STIPPLE] = compat_r128_stipple,
@@ -197,17 +197,13 @@ drm_ioctl_compat_t *r128_compat_ioctls[] = {
 long r128_compat_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 {
 	unsigned int nr = DRM_IOCTL_NR(cmd);
-	drm_ioctl_compat_t *fn = NULL;
 	int ret;
 
 	if (nr < DRM_COMMAND_BASE)
 		return drm_compat_ioctl(filp, cmd, arg);
 
-	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(r128_compat_ioctls))
-		fn = r128_compat_ioctls[nr - DRM_COMMAND_BASE];
-
-	if (fn != NULL)
-		ret = (*fn) (filp, cmd, arg);
+	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(r128_compat_ioctls) && r128_compat_ioctls[nr - DRM_COMMAND_BASE])
+		ret = (*r128_compat_ioctls[nr - DRM_COMMAND_BASE]) (filp, cmd, arg);
 	else
 		ret = drm_ioctl(filp, cmd, arg);
 
diff --git a/drivers/gpu/drm/r128/r128_irq.c b/drivers/gpu/drm/r128/r128_irq.c
index 9730f4918..920e9bfe6 100644
--- a/drivers/gpu/drm/r128/r128_irq.c
+++ b/drivers/gpu/drm/r128/r128_irq.c
@@ -41,7 +41,7 @@ u32 r128_get_vblank_counter(struct drm_device *dev, unsigned int pipe)
 	if (pipe != 0)
 		return 0;
 
-	return atomic_read(&dev_priv->vbl_received);
+	return atomic_read_unchecked(&dev_priv->vbl_received);
 }
 
 irqreturn_t r128_driver_irq_handler(int irq, void *arg)
@@ -55,7 +55,7 @@ irqreturn_t r128_driver_irq_handler(int irq, void *arg)
 	/* VBLANK interrupt */
 	if (status & R128_CRTC_VBLANK_INT) {
 		R128_WRITE(R128_GEN_INT_STATUS, R128_CRTC_VBLANK_INT_AK);
-		atomic_inc(&dev_priv->vbl_received);
+		atomic_inc_unchecked(&dev_priv->vbl_received);
 		drm_handle_vblank(dev, 0);
 		return IRQ_HANDLED;
 	}
diff --git a/drivers/gpu/drm/r128/r128_state.c b/drivers/gpu/drm/r128/r128_state.c
index 8fd2d9f58..4e991662b 100644
--- a/drivers/gpu/drm/r128/r128_state.c
+++ b/drivers/gpu/drm/r128/r128_state.c
@@ -320,10 +320,10 @@ static void r128_clear_box(drm_r128_private_t *dev_priv,
 
 static void r128_cce_performance_boxes(drm_r128_private_t *dev_priv)
 {
-	if (atomic_read(&dev_priv->idle_count) == 0)
+	if (atomic_read_unchecked(&dev_priv->idle_count) == 0)
 		r128_clear_box(dev_priv, 64, 4, 8, 8, 0, 255, 0);
 	else
-		atomic_set(&dev_priv->idle_count, 0);
+		atomic_set_unchecked(&dev_priv->idle_count, 0);
 }
 
 #endif
@@ -1641,4 +1641,4 @@ const struct drm_ioctl_desc r128_ioctls[] = {
 	DRM_IOCTL_DEF_DRV(R128_GETPARAM, r128_getparam, DRM_AUTH),
 };
 
-int r128_max_ioctl = ARRAY_SIZE(r128_ioctls);
+const int r128_max_ioctl = ARRAY_SIZE(r128_ioctls);
diff --git a/drivers/gpu/drm/radeon/mkregtable.c b/drivers/gpu/drm/radeon/mkregtable.c
index b928c17bd..e5d940016 100644
--- a/drivers/gpu/drm/radeon/mkregtable.c
+++ b/drivers/gpu/drm/radeon/mkregtable.c
@@ -624,14 +624,14 @@ static int parser_auth(struct table *t, const char *filename)
 	regex_t mask_rex;
 	regmatch_t match[4];
 	char buf[1024];
-	size_t end;
+	long end;
 	int len;
 	int done = 0;
 	int r;
 	unsigned o;
 	struct offset *offset;
 	char last_reg_s[10];
-	int last_reg;
+	unsigned long last_reg;
 
 	if (regcomp
 	    (&mask_rex, "(0x[0-9a-fA-F]*) *([_a-zA-Z0-9]*)", REG_EXTENDED)) {
diff --git a/drivers/gpu/drm/radeon/radeon_atpx_handler.c b/drivers/gpu/drm/radeon/radeon_atpx_handler.c
index 34b4ace5d..2f6e0e6a5 100644
--- a/drivers/gpu/drm/radeon/radeon_atpx_handler.c
+++ b/drivers/gpu/drm/radeon/radeon_atpx_handler.c
@@ -521,7 +521,7 @@ static int radeon_atpx_init(void)
  * look up whether we are the integrated or discrete GPU (all asics).
  * Returns the client id.
  */
-static int radeon_atpx_get_client_id(struct pci_dev *pdev)
+static enum vga_switcheroo_client_id radeon_atpx_get_client_id(struct pci_dev *pdev)
 {
 	if (radeon_atpx_priv.dhandle == ACPI_HANDLE(&pdev->dev))
 		return VGA_SWITCHEROO_IGD;
diff --git a/drivers/gpu/drm/radeon/radeon_connectors.c b/drivers/gpu/drm/radeon/radeon_connectors.c
index b79f3b002..a1fd177c0 100644
--- a/drivers/gpu/drm/radeon/radeon_connectors.c
+++ b/drivers/gpu/drm/radeon/radeon_connectors.c
@@ -857,7 +857,7 @@ static int radeon_lvds_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int radeon_lvds_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status radeon_lvds_mode_valid(struct drm_connector *connector,
 				  struct drm_display_mode *mode)
 {
 	struct drm_encoder *encoder = radeon_best_single_encoder(connector);
@@ -1000,7 +1000,7 @@ static int radeon_vga_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int radeon_vga_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status radeon_vga_mode_valid(struct drm_connector *connector,
 				  struct drm_display_mode *mode)
 {
 	struct drm_device *dev = connector->dev;
@@ -1139,7 +1139,7 @@ static int radeon_tv_get_modes(struct drm_connector *connector)
 	return 1;
 }
 
-static int radeon_tv_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status radeon_tv_mode_valid(struct drm_connector *connector,
 				struct drm_display_mode *mode)
 {
 	if ((mode->hdisplay > 1024) || (mode->vdisplay > 768))
@@ -1470,7 +1470,7 @@ static void radeon_dvi_force(struct drm_connector *connector)
 		radeon_connector->use_digital = true;
 }
 
-static int radeon_dvi_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status radeon_dvi_mode_valid(struct drm_connector *connector,
 				  struct drm_display_mode *mode)
 {
 	struct drm_device *dev = connector->dev;
@@ -1767,7 +1767,7 @@ out:
 	return ret;
 }
 
-static int radeon_dp_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status radeon_dp_mode_valid(struct drm_connector *connector,
 				  struct drm_display_mode *mode)
 {
 	struct drm_device *dev = connector->dev;
diff --git a/drivers/gpu/drm/radeon/radeon_device.c b/drivers/gpu/drm/radeon/radeon_device.c
index edd2d0396..62af79a3f 100644
--- a/drivers/gpu/drm/radeon/radeon_device.c
+++ b/drivers/gpu/drm/radeon/radeon_device.c
@@ -1289,7 +1289,7 @@ static bool radeon_switcheroo_can_switch(struct pci_dev *pdev)
 	 * locking inversion with the driver load path. And the access here is
 	 * completely racy anyway. So don't bother with locking for now.
 	 */
-	return dev->open_count == 0;
+	return local_read(&dev->open_count) == 0;
 }
 
 static const struct vga_switcheroo_client_ops radeon_switcheroo_ops = {
diff --git a/drivers/gpu/drm/radeon/radeon_drv.c b/drivers/gpu/drm/radeon/radeon_drv.c
index c01a7c6ab..fd62ace99 100644
--- a/drivers/gpu/drm/radeon/radeon_drv.c
+++ b/drivers/gpu/drm/radeon/radeon_drv.c
@@ -134,7 +134,7 @@ extern int radeon_get_crtc_scanoutpos(struct drm_device *dev, unsigned int crtc,
 				      const struct drm_display_mode *mode);
 extern bool radeon_is_px(struct drm_device *dev);
 extern const struct drm_ioctl_desc radeon_ioctls_kms[];
-extern int radeon_max_kms_ioctl;
+extern const int radeon_max_kms_ioctl;
 int radeon_mmap(struct file *filp, struct vm_area_struct *vma);
 int radeon_mode_dumb_mmap(struct drm_file *filp,
 			  struct drm_device *dev,
@@ -516,7 +516,7 @@ static struct drm_driver kms_driver = {
 	.driver_features =
 	    DRIVER_USE_AGP |
 	    DRIVER_HAVE_IRQ | DRIVER_IRQ_SHARED | DRIVER_GEM |
-	    DRIVER_PRIME | DRIVER_RENDER,
+	    DRIVER_PRIME | DRIVER_RENDER | DRIVER_MODESET,
 	.load = radeon_driver_load_kms,
 	.open = radeon_driver_open_kms,
 	.preclose = radeon_driver_preclose_kms,
@@ -591,8 +591,11 @@ static int __init radeon_init(void)
 		DRM_INFO("radeon kernel modesetting enabled.\n");
 		driver = &kms_driver;
 		pdriver = &radeon_kms_pci_driver;
-		driver->driver_features |= DRIVER_MODESET;
-		driver->num_ioctls = radeon_max_kms_ioctl;
+
+		pax_open_kernel();
+		const_cast(driver->num_ioctls) = radeon_max_kms_ioctl;
+		pax_close_kernel();
+
 		radeon_register_atpx_handler();
 
 	} else {
diff --git a/drivers/gpu/drm/radeon/radeon_ioc32.c b/drivers/gpu/drm/radeon/radeon_ioc32.c
index 0b98ea134..a3c770fd8 100644
--- a/drivers/gpu/drm/radeon/radeon_ioc32.c
+++ b/drivers/gpu/drm/radeon/radeon_ioc32.c
@@ -358,7 +358,7 @@ static int compat_radeon_cp_setparam(struct file *file, unsigned int cmd,
 	request = compat_alloc_user_space(sizeof(*request));
 	if (!access_ok(VERIFY_WRITE, request, sizeof(*request))
 	    || __put_user(req32.param, &request->param)
-	    || __put_user((void __user *)(unsigned long)req32.value,
+	    || __put_user((unsigned long)req32.value,
 			  &request->value))
 		return -EFAULT;
 
@@ -368,7 +368,7 @@ static int compat_radeon_cp_setparam(struct file *file, unsigned int cmd,
 #define compat_radeon_cp_setparam NULL
 #endif /* X86_64 || IA64 */
 
-static drm_ioctl_compat_t *radeon_compat_ioctls[] = {
+static drm_ioctl_compat_t radeon_compat_ioctls[] = {
 	[DRM_RADEON_CP_INIT] = compat_radeon_cp_init,
 	[DRM_RADEON_CLEAR] = compat_radeon_cp_clear,
 	[DRM_RADEON_STIPPLE] = compat_radeon_cp_stipple,
@@ -393,17 +393,13 @@ static drm_ioctl_compat_t *radeon_compat_ioctls[] = {
 long radeon_compat_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
 {
 	unsigned int nr = DRM_IOCTL_NR(cmd);
-	drm_ioctl_compat_t *fn = NULL;
 	int ret;
 
 	if (nr < DRM_COMMAND_BASE)
 		return drm_compat_ioctl(filp, cmd, arg);
 
-	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(radeon_compat_ioctls))
-		fn = radeon_compat_ioctls[nr - DRM_COMMAND_BASE];
-
-	if (fn != NULL)
-		ret = (*fn) (filp, cmd, arg);
+	if (nr < DRM_COMMAND_BASE + ARRAY_SIZE(radeon_compat_ioctls) && radeon_compat_ioctls[nr - DRM_COMMAND_BASE])
+		ret = (*radeon_compat_ioctls[nr - DRM_COMMAND_BASE]) (filp, cmd, arg);
 	else
 		ret = drm_ioctl(filp, cmd, arg);
 
diff --git a/drivers/gpu/drm/radeon/radeon_kms.c b/drivers/gpu/drm/radeon/radeon_kms.c
index 835563c1f..85913cca2 100644
--- a/drivers/gpu/drm/radeon/radeon_kms.c
+++ b/drivers/gpu/drm/radeon/radeon_kms.c
@@ -825,7 +825,7 @@ u32 radeon_get_vblank_counter_kms(struct drm_device *dev, unsigned int pipe)
  * Enable the interrupt on the requested crtc (all asics).
  * Returns 0 on success, -EINVAL on failure.
  */
-int radeon_enable_vblank_kms(struct drm_device *dev, int crtc)
+int radeon_enable_vblank_kms(struct drm_device *dev, unsigned int crtc)
 {
 	struct radeon_device *rdev = dev->dev_private;
 	unsigned long irqflags;
@@ -851,7 +851,7 @@ int radeon_enable_vblank_kms(struct drm_device *dev, int crtc)
  *
  * Disable the interrupt on the requested crtc (all asics).
  */
-void radeon_disable_vblank_kms(struct drm_device *dev, int crtc)
+void radeon_disable_vblank_kms(struct drm_device *dev, unsigned int crtc)
 {
 	struct radeon_device *rdev = dev->dev_private;
 	unsigned long irqflags;
@@ -880,7 +880,7 @@ void radeon_disable_vblank_kms(struct drm_device *dev, int crtc)
  * scanout position.  (all asics).
  * Returns postive status flags on success, negative error on failure.
  */
-int radeon_get_vblank_timestamp_kms(struct drm_device *dev, int crtc,
+int radeon_get_vblank_timestamp_kms(struct drm_device *dev, unsigned int crtc,
 				    int *max_error,
 				    struct timeval *vblank_time,
 				    unsigned flags)
@@ -949,4 +949,4 @@ const struct drm_ioctl_desc radeon_ioctls_kms[] = {
 	DRM_IOCTL_DEF_DRV(RADEON_GEM_OP, radeon_gem_op_ioctl, DRM_AUTH|DRM_RENDER_ALLOW),
 	DRM_IOCTL_DEF_DRV(RADEON_GEM_USERPTR, radeon_gem_userptr_ioctl, DRM_AUTH|DRM_RENDER_ALLOW),
 };
-int radeon_max_kms_ioctl = ARRAY_SIZE(radeon_ioctls_kms);
+const int radeon_max_kms_ioctl = ARRAY_SIZE(radeon_ioctls_kms);
diff --git a/drivers/gpu/drm/radeon/radeon_ttm.c b/drivers/gpu/drm/radeon/radeon_ttm.c
index c2e0a1ccd..6270bca98 100644
--- a/drivers/gpu/drm/radeon/radeon_ttm.c
+++ b/drivers/gpu/drm/radeon/radeon_ttm.c
@@ -974,7 +974,7 @@ void radeon_ttm_set_active_vram_size(struct radeon_device *rdev, u64 size)
 	man->size = size >> PAGE_SHIFT;
 }
 
-static struct vm_operations_struct radeon_ttm_vm_ops;
+static vm_operations_struct_no_const radeon_ttm_vm_ops __read_only;
 static const struct vm_operations_struct *ttm_vm_ops = NULL;
 
 static int radeon_ttm_fault(struct vm_area_struct *vma, struct vm_fault *vmf)
@@ -1015,8 +1015,10 @@ int radeon_mmap(struct file *filp, struct vm_area_struct *vma)
 	}
 	if (unlikely(ttm_vm_ops == NULL)) {
 		ttm_vm_ops = vma->vm_ops;
+		pax_open_kernel();
 		radeon_ttm_vm_ops = *ttm_vm_ops;
 		radeon_ttm_vm_ops.fault = &radeon_ttm_fault;
+		pax_close_kernel();
 	}
 	vma->vm_ops = &radeon_ttm_vm_ops;
 	return 0;
diff --git a/drivers/gpu/drm/savage/savage_bci.c b/drivers/gpu/drm/savage/savage_bci.c
index d47dff95f..0752202f8 100644
--- a/drivers/gpu/drm/savage/savage_bci.c
+++ b/drivers/gpu/drm/savage/savage_bci.c
@@ -1080,4 +1080,4 @@ const struct drm_ioctl_desc savage_ioctls[] = {
 	DRM_IOCTL_DEF_DRV(SAVAGE_BCI_EVENT_WAIT, savage_bci_event_wait, DRM_AUTH),
 };
 
-int savage_max_ioctl = ARRAY_SIZE(savage_ioctls);
+const int savage_max_ioctl = ARRAY_SIZE(savage_ioctls);
diff --git a/drivers/gpu/drm/savage/savage_drv.c b/drivers/gpu/drm/savage/savage_drv.c
index 21aed1feb..85d23a0f2 100644
--- a/drivers/gpu/drm/savage/savage_drv.c
+++ b/drivers/gpu/drm/savage/savage_drv.c
@@ -76,7 +76,10 @@ static struct pci_driver savage_pci_driver = {
 
 static int __init savage_init(void)
 {
-	driver.num_ioctls = savage_max_ioctl;
+	pax_open_kernel();
+	const_cast(driver.num_ioctls) = savage_max_ioctl;
+	pax_close_kernel();
+
 	return drm_pci_init(&driver, &savage_pci_driver);
 }
 
diff --git a/drivers/gpu/drm/savage/savage_drv.h b/drivers/gpu/drm/savage/savage_drv.h
index 37b699571..9b31aafc5 100644
--- a/drivers/gpu/drm/savage/savage_drv.h
+++ b/drivers/gpu/drm/savage/savage_drv.h
@@ -107,7 +107,7 @@ enum savage_family {
 };
 
 extern const struct drm_ioctl_desc savage_ioctls[];
-extern int savage_max_ioctl;
+extern const int savage_max_ioctl;
 
 #define S3_SAVAGE3D_SERIES(chip)  ((chip>=S3_SAVAGE3D) && (chip<=S3_SAVAGE_MX))
 
diff --git a/drivers/gpu/drm/sis/sis_drv.c b/drivers/gpu/drm/sis/sis_drv.c
index 79bce76cb..6c0221918 100644
--- a/drivers/gpu/drm/sis/sis_drv.c
+++ b/drivers/gpu/drm/sis/sis_drv.c
@@ -128,7 +128,10 @@ static struct pci_driver sis_pci_driver = {
 
 static int __init sis_init(void)
 {
-	driver.num_ioctls = sis_max_ioctl;
+	pax_open_kernel();
+	const_cast(driver.num_ioctls) = sis_max_ioctl;
+	pax_close_kernel();
+
 	return drm_pci_init(&driver, &sis_pci_driver);
 }
 
diff --git a/drivers/gpu/drm/sis/sis_drv.h b/drivers/gpu/drm/sis/sis_drv.h
index 328f8a750..0cfcf5556 100644
--- a/drivers/gpu/drm/sis/sis_drv.h
+++ b/drivers/gpu/drm/sis/sis_drv.h
@@ -77,6 +77,6 @@ extern void sis_reclaim_buffers_locked(struct drm_device *dev,
 extern void sis_lastclose(struct drm_device *dev);
 
 extern const struct drm_ioctl_desc sis_ioctls[];
-extern int sis_max_ioctl;
+extern const int sis_max_ioctl;
 
 #endif
diff --git a/drivers/gpu/drm/sis/sis_mm.c b/drivers/gpu/drm/sis/sis_mm.c
index 03defda77..6f56b6851 100644
--- a/drivers/gpu/drm/sis/sis_mm.c
+++ b/drivers/gpu/drm/sis/sis_mm.c
@@ -359,4 +359,4 @@ const struct drm_ioctl_desc sis_ioctls[] = {
 	DRM_IOCTL_DEF_DRV(SIS_FB_INIT, sis_fb_init, DRM_AUTH | DRM_MASTER | DRM_ROOT_ONLY),
 };
 
-int sis_max_ioctl = ARRAY_SIZE(sis_ioctls);
+const int sis_max_ioctl = ARRAY_SIZE(sis_ioctls);
diff --git a/drivers/gpu/drm/sti/sti_cursor.c b/drivers/gpu/drm/sti/sti_cursor.c
index 3b53f7f2e..b0576c24b 100644
--- a/drivers/gpu/drm/sti/sti_cursor.c
+++ b/drivers/gpu/drm/sti/sti_cursor.c
@@ -126,7 +126,7 @@ static int cursor_dbg_show(struct seq_file *s, void *data)
 	return 0;
 }
 
-static struct drm_info_list cursor_debugfs_files[] = {
+static drm_info_list_no_const cursor_debugfs_files[] __read_only = {
 	{ "cursor", cursor_dbg_show, 0, NULL },
 };
 
@@ -135,8 +135,10 @@ static int cursor_debugfs_init(struct sti_cursor *cursor,
 {
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(cursor_debugfs_files); i++)
 		cursor_debugfs_files[i].data = cursor;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(cursor_debugfs_files,
 					ARRAY_SIZE(cursor_debugfs_files),
diff --git a/drivers/gpu/drm/sti/sti_dvo.c b/drivers/gpu/drm/sti/sti_dvo.c
index 00881eb45..3863e5176 100644
--- a/drivers/gpu/drm/sti/sti_dvo.c
+++ b/drivers/gpu/drm/sti/sti_dvo.c
@@ -190,7 +190,7 @@ static int dvo_dbg_show(struct seq_file *s, void *data)
 	return 0;
 }
 
-static struct drm_info_list dvo_debugfs_files[] = {
+static drm_info_list_no_const dvo_debugfs_files[] __read_only = {
 	{ "dvo", dvo_dbg_show, 0, NULL },
 };
 
@@ -205,8 +205,10 @@ static int dvo_debugfs_init(struct sti_dvo *dvo, struct drm_minor *minor)
 {
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(dvo_debugfs_files); i++)
 		dvo_debugfs_files[i].data = dvo;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(dvo_debugfs_files,
 					ARRAY_SIZE(dvo_debugfs_files),
diff --git a/drivers/gpu/drm/sti/sti_gdp.c b/drivers/gpu/drm/sti/sti_gdp.c
index b8d942ca4..476893df5 100644
--- a/drivers/gpu/drm/sti/sti_gdp.c
+++ b/drivers/gpu/drm/sti/sti_gdp.c
@@ -284,22 +284,22 @@ static int gdp_node_dbg_show(struct seq_file *s, void *arg)
 	return 0;
 }
 
-static struct drm_info_list gdp0_debugfs_files[] = {
+static drm_info_list_no_const gdp0_debugfs_files[] __read_only = {
 	{ "gdp0", gdp_dbg_show, 0, NULL },
 	{ "gdp0_node", gdp_node_dbg_show, 0, NULL },
 };
 
-static struct drm_info_list gdp1_debugfs_files[] = {
+static drm_info_list_no_const gdp1_debugfs_files[] __read_only = {
 	{ "gdp1", gdp_dbg_show, 0, NULL },
 	{ "gdp1_node", gdp_node_dbg_show, 0, NULL },
 };
 
-static struct drm_info_list gdp2_debugfs_files[] = {
+static drm_info_list_no_const gdp2_debugfs_files[] __read_only = {
 	{ "gdp2", gdp_dbg_show, 0, NULL },
 	{ "gdp2_node", gdp_node_dbg_show, 0, NULL },
 };
 
-static struct drm_info_list gdp3_debugfs_files[] = {
+static drm_info_list_no_const gdp3_debugfs_files[] __read_only = {
 	{ "gdp3", gdp_dbg_show, 0, NULL },
 	{ "gdp3_node", gdp_node_dbg_show, 0, NULL },
 };
@@ -307,7 +307,7 @@ static struct drm_info_list gdp3_debugfs_files[] = {
 static int gdp_debugfs_init(struct sti_gdp *gdp, struct drm_minor *minor)
 {
 	unsigned int i;
-	struct drm_info_list *gdp_debugfs_files;
+	drm_info_list_no_const *gdp_debugfs_files;
 	int nb_files;
 
 	switch (gdp->plane.desc) {
@@ -331,8 +331,10 @@ static int gdp_debugfs_init(struct sti_gdp *gdp, struct drm_minor *minor)
 		return -EINVAL;
 	}
 
+	pax_open_kernel();
 	for (i = 0; i < nb_files; i++)
 		gdp_debugfs_files[i].data = gdp;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(gdp_debugfs_files,
 					nb_files,
diff --git a/drivers/gpu/drm/sti/sti_hda.c b/drivers/gpu/drm/sti/sti_hda.c
index 8505569f7..aae4422c6 100644
--- a/drivers/gpu/drm/sti/sti_hda.c
+++ b/drivers/gpu/drm/sti/sti_hda.c
@@ -394,7 +394,7 @@ static int hda_dbg_show(struct seq_file *s, void *data)
 	return 0;
 }
 
-static struct drm_info_list hda_debugfs_files[] = {
+static drm_info_list_no_const hda_debugfs_files[] __read_only = {
 	{ "hda", hda_dbg_show, 0, NULL },
 };
 
@@ -409,8 +409,10 @@ static int hda_debugfs_init(struct sti_hda *hda, struct drm_minor *minor)
 {
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(hda_debugfs_files); i++)
 		hda_debugfs_files[i].data = hda;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(hda_debugfs_files,
 					ARRAY_SIZE(hda_debugfs_files),
diff --git a/drivers/gpu/drm/sti/sti_hdmi.c b/drivers/gpu/drm/sti/sti_hdmi.c
index fedc17f98..d43c181c9 100644
--- a/drivers/gpu/drm/sti/sti_hdmi.c
+++ b/drivers/gpu/drm/sti/sti_hdmi.c
@@ -728,7 +728,7 @@ static int hdmi_dbg_show(struct seq_file *s, void *data)
 	return 0;
 }
 
-static struct drm_info_list hdmi_debugfs_files[] = {
+static drm_info_list_no_const hdmi_debugfs_files[] __read_only = {
 	{ "hdmi", hdmi_dbg_show, 0, NULL },
 };
 
@@ -743,8 +743,10 @@ static int hdmi_debugfs_init(struct sti_hdmi *hdmi, struct drm_minor *minor)
 {
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(hdmi_debugfs_files); i++)
 		hdmi_debugfs_files[i].data = hdmi;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(hdmi_debugfs_files,
 					ARRAY_SIZE(hdmi_debugfs_files),
diff --git a/drivers/gpu/drm/sti/sti_hqvdp.c b/drivers/gpu/drm/sti/sti_hqvdp.c
index e4b769d67..2958ddf54 100644
--- a/drivers/gpu/drm/sti/sti_hqvdp.c
+++ b/drivers/gpu/drm/sti/sti_hqvdp.c
@@ -627,7 +627,7 @@ static int hqvdp_dbg_show(struct seq_file *s, void *data)
 	return 0;
 }
 
-static struct drm_info_list hqvdp_debugfs_files[] = {
+static drm_info_list_no_const hqvdp_debugfs_files[] __read_only = {
 	{ "hqvdp", hqvdp_dbg_show, 0, NULL },
 };
 
@@ -635,8 +635,10 @@ static int hqvdp_debugfs_init(struct sti_hqvdp *hqvdp, struct drm_minor *minor)
 {
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(hqvdp_debugfs_files); i++)
 		hqvdp_debugfs_files[i].data = hqvdp;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(hqvdp_debugfs_files,
 					ARRAY_SIZE(hqvdp_debugfs_files),
diff --git a/drivers/gpu/drm/sti/sti_mixer.c b/drivers/gpu/drm/sti/sti_mixer.c
index 7d9aea805..e0542f635 100644
--- a/drivers/gpu/drm/sti/sti_mixer.c
+++ b/drivers/gpu/drm/sti/sti_mixer.c
@@ -173,18 +173,18 @@ static int mixer_dbg_show(struct seq_file *s, void *arg)
 	return 0;
 }
 
-static struct drm_info_list mixer0_debugfs_files[] = {
+static drm_info_list_no_const mixer0_debugfs_files[] __read_only = {
 	{ "mixer_main", mixer_dbg_show, 0, NULL },
 };
 
-static struct drm_info_list mixer1_debugfs_files[] = {
+static drm_info_list_no_const mixer1_debugfs_files[] __read_only = {
 	{ "mixer_aux", mixer_dbg_show, 0, NULL },
 };
 
 int sti_mixer_debugfs_init(struct sti_mixer *mixer, struct drm_minor *minor)
 {
 	unsigned int i;
-	struct drm_info_list *mixer_debugfs_files;
+	drm_info_list_no_const *mixer_debugfs_files;
 	int nb_files;
 
 	switch (mixer->id) {
@@ -200,8 +200,10 @@ int sti_mixer_debugfs_init(struct sti_mixer *mixer, struct drm_minor *minor)
 		return -EINVAL;
 	}
 
+	pax_open_kernel();
 	for (i = 0; i < nb_files; i++)
 		mixer_debugfs_files[i].data = mixer;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(mixer_debugfs_files,
 					nb_files,
diff --git a/drivers/gpu/drm/sti/sti_tvout.c b/drivers/gpu/drm/sti/sti_tvout.c
index e25995b35..8f2b12fbb 100644
--- a/drivers/gpu/drm/sti/sti_tvout.c
+++ b/drivers/gpu/drm/sti/sti_tvout.c
@@ -585,7 +585,7 @@ static int tvout_dbg_show(struct seq_file *s, void *data)
 	return 0;
 }
 
-static struct drm_info_list tvout_debugfs_files[] = {
+static drm_info_list_no_const tvout_debugfs_files[] __read_only = {
 	{ "tvout", tvout_dbg_show, 0, NULL },
 };
 
@@ -600,8 +600,10 @@ static int tvout_debugfs_init(struct sti_tvout *tvout, struct drm_minor *minor)
 {
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(tvout_debugfs_files); i++)
 		tvout_debugfs_files[i].data = tvout;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(tvout_debugfs_files,
 					ARRAY_SIZE(tvout_debugfs_files),
diff --git a/drivers/gpu/drm/sti/sti_vid.c b/drivers/gpu/drm/sti/sti_vid.c
index 47634a025..7a9b19f57 100644
--- a/drivers/gpu/drm/sti/sti_vid.c
+++ b/drivers/gpu/drm/sti/sti_vid.c
@@ -119,7 +119,7 @@ static int vid_dbg_show(struct seq_file *s, void *arg)
 	return 0;
 }
 
-static struct drm_info_list vid_debugfs_files[] = {
+static drm_info_list_no_const vid_debugfs_files[] __read_only = {
 	{ "vid", vid_dbg_show, 0, NULL },
 };
 
@@ -127,8 +127,10 @@ int vid_debugfs_init(struct sti_vid *vid, struct drm_minor *minor)
 {
 	unsigned int i;
 
+	pax_open_kernel();
 	for (i = 0; i < ARRAY_SIZE(vid_debugfs_files); i++)
 		vid_debugfs_files[i].data = vid;
+	pax_close_kernel();
 
 	return drm_debugfs_create_files(vid_debugfs_files,
 					ARRAY_SIZE(vid_debugfs_files),
diff --git a/drivers/gpu/drm/tegra/dc.c b/drivers/gpu/drm/tegra/dc.c
index 8495bd01b..21a97257e 100644
--- a/drivers/gpu/drm/tegra/dc.c
+++ b/drivers/gpu/drm/tegra/dc.c
@@ -1685,7 +1685,7 @@ static int tegra_dc_debugfs_init(struct tegra_dc *dc, struct drm_minor *minor)
 	}
 
 	for (i = 0; i < ARRAY_SIZE(debugfs_files); i++)
-		dc->debugfs_files[i].data = dc;
+		const_cast(dc->debugfs_files[i].data) = dc;
 
 	err = drm_debugfs_create_files(dc->debugfs_files,
 				       ARRAY_SIZE(debugfs_files),
diff --git a/drivers/gpu/drm/tegra/dsi.c b/drivers/gpu/drm/tegra/dsi.c
index 3dea1216b..c2b888ebc 100644
--- a/drivers/gpu/drm/tegra/dsi.c
+++ b/drivers/gpu/drm/tegra/dsi.c
@@ -63,7 +63,7 @@ struct tegra_dsi {
 	struct clk *clk_lp;
 	struct clk *clk;
 
-	struct drm_info_list *debugfs_files;
+	drm_info_list_no_const *debugfs_files;
 	struct drm_minor *minor;
 	struct dentry *debugfs;
 
diff --git a/drivers/gpu/drm/tegra/hdmi.c b/drivers/gpu/drm/tegra/hdmi.c
index cda0491ed..869916ed4 100644
--- a/drivers/gpu/drm/tegra/hdmi.c
+++ b/drivers/gpu/drm/tegra/hdmi.c
@@ -74,7 +74,7 @@ struct tegra_hdmi {
 	bool stereo;
 	bool dvi;
 
-	struct drm_info_list *debugfs_files;
+	drm_info_list_no_const *debugfs_files;
 	struct drm_minor *minor;
 	struct dentry *debugfs;
 };
diff --git a/drivers/gpu/drm/tegra/sor.c b/drivers/gpu/drm/tegra/sor.c
index 74d0540b8..f5277db74 100644
--- a/drivers/gpu/drm/tegra/sor.c
+++ b/drivers/gpu/drm/tegra/sor.c
@@ -1263,8 +1263,11 @@ static int tegra_sor_debugfs_init(struct tegra_sor *sor,
 		goto remove;
 	}
 
-	for (i = 0; i < ARRAY_SIZE(debugfs_files); i++)
-		sor->debugfs_files[i].data = sor;
+	for (i = 0; i < ARRAY_SIZE(debugfs_files); i++) {
+		pax_open_kernel();
+		const_cast(sor->debugfs_files[i].data) = sor;
+		pax_close_kernel();
+	}
 
 	err = drm_debugfs_create_files(sor->debugfs_files,
 				       ARRAY_SIZE(debugfs_files),
diff --git a/drivers/gpu/drm/tilcdc/Makefile b/drivers/gpu/drm/tilcdc/Makefile
index deeca4869..54e1b6cc2 100644
--- a/drivers/gpu/drm/tilcdc/Makefile
+++ b/drivers/gpu/drm/tilcdc/Makefile
@@ -1,7 +1,7 @@
 ccflags-y := -Iinclude/drm
-ifeq (, $(findstring -W,$(EXTRA_CFLAGS)))
-	ccflags-y += -Werror
-endif
+#ifeq (, $(findstring -W,$(EXTRA_CFLAGS)))
+#	ccflags-y += -Werror
+#endif
 
 obj-$(CONFIG_DRM_TILCDC_SLAVE_COMPAT) += tilcdc_slave_compat.o \
 					 tilcdc_slave_compat.dtb.o
diff --git a/drivers/gpu/drm/tilcdc/tilcdc_external.c b/drivers/gpu/drm/tilcdc/tilcdc_external.c
index 03acb4f99..8d4328e2b 100644
--- a/drivers/gpu/drm/tilcdc/tilcdc_external.c
+++ b/drivers/gpu/drm/tilcdc/tilcdc_external.c
@@ -27,7 +27,7 @@ static const struct tilcdc_panel_info panel_info_tda998x = {
 		.raster_order           = 0,
 };
 
-static int tilcdc_external_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status tilcdc_external_mode_valid(struct drm_connector *connector,
 				      struct drm_display_mode *mode)
 {
 	struct tilcdc_drm_private *priv = connector->dev->dev_private;
@@ -56,7 +56,7 @@ static int tilcdc_add_external_encoder(struct drm_device *dev, int *bpp,
 				       struct drm_connector *connector)
 {
 	struct tilcdc_drm_private *priv = dev->dev_private;
-	struct drm_connector_helper_funcs *connector_funcs;
+	drm_connector_helper_funcs_no_const *connector_funcs;
 
 	priv->connectors[priv->num_connectors] = connector;
 	priv->encoders[priv->num_encoders++] = connector->encoder;
diff --git a/drivers/gpu/drm/tilcdc/tilcdc_panel.c b/drivers/gpu/drm/tilcdc/tilcdc_panel.c
index ff7774c17..697a5fc2a 100644
--- a/drivers/gpu/drm/tilcdc/tilcdc_panel.c
+++ b/drivers/gpu/drm/tilcdc/tilcdc_panel.c
@@ -179,7 +179,7 @@ static int panel_connector_get_modes(struct drm_connector *connector)
 	return i;
 }
 
-static int panel_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status panel_connector_mode_valid(struct drm_connector *connector,
 		  struct drm_display_mode *mode)
 {
 	struct tilcdc_drm_private *priv = connector->dev->dev_private;
diff --git a/drivers/gpu/drm/tilcdc/tilcdc_tfp410.c b/drivers/gpu/drm/tilcdc/tilcdc_tfp410.c
index 6b8c5b3bf..0899e85c9 100644
--- a/drivers/gpu/drm/tilcdc/tilcdc_tfp410.c
+++ b/drivers/gpu/drm/tilcdc/tilcdc_tfp410.c
@@ -184,7 +184,7 @@ static int tfp410_connector_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int tfp410_connector_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status tfp410_connector_mode_valid(struct drm_connector *connector,
 		  struct drm_display_mode *mode)
 {
 	struct tilcdc_drm_private *priv = connector->dev->dev_private;
diff --git a/drivers/gpu/drm/ttm/ttm_bo_manager.c b/drivers/gpu/drm/ttm/ttm_bo_manager.c
index aa0bd054d..aea6a0150 100644
--- a/drivers/gpu/drm/ttm/ttm_bo_manager.c
+++ b/drivers/gpu/drm/ttm/ttm_bo_manager.c
@@ -148,10 +148,10 @@ static void ttm_bo_man_debug(struct ttm_mem_type_manager *man,
 }
 
 const struct ttm_mem_type_manager_func ttm_bo_manager_func = {
-	ttm_bo_man_init,
-	ttm_bo_man_takedown,
-	ttm_bo_man_get_node,
-	ttm_bo_man_put_node,
-	ttm_bo_man_debug
+	.init = ttm_bo_man_init,
+	.takedown = ttm_bo_man_takedown,
+	.get_node = ttm_bo_man_get_node,
+	.put_node = ttm_bo_man_put_node,
+	.debug = ttm_bo_man_debug
 };
 EXPORT_SYMBOL(ttm_bo_manager_func);
diff --git a/drivers/gpu/drm/ttm/ttm_memory.c b/drivers/gpu/drm/ttm/ttm_memory.c
index a1803fbcc..c53f6b02e 100644
--- a/drivers/gpu/drm/ttm/ttm_memory.c
+++ b/drivers/gpu/drm/ttm/ttm_memory.c
@@ -264,7 +264,7 @@ static int ttm_mem_init_kernel_zone(struct ttm_mem_global *glob,
 	zone->glob = glob;
 	glob->zone_kernel = zone;
 	ret = kobject_init_and_add(
-		&zone->kobj, &ttm_mem_zone_kobj_type, &glob->kobj, zone->name);
+		&zone->kobj, &ttm_mem_zone_kobj_type, &glob->kobj, "%s", zone->name);
 	if (unlikely(ret != 0)) {
 		kobject_put(&zone->kobj);
 		return ret;
@@ -348,7 +348,7 @@ static int ttm_mem_init_dma32_zone(struct ttm_mem_global *glob,
 	zone->glob = glob;
 	glob->zone_dma32 = zone;
 	ret = kobject_init_and_add(
-		&zone->kobj, &ttm_mem_zone_kobj_type, &glob->kobj, zone->name);
+		&zone->kobj, &ttm_mem_zone_kobj_type, &glob->kobj, "%s", zone->name);
 	if (unlikely(ret != 0)) {
 		kobject_put(&zone->kobj);
 		return ret;
diff --git a/drivers/gpu/drm/ttm/ttm_page_alloc.c b/drivers/gpu/drm/ttm/ttm_page_alloc.c
index a37de5db5..4a0db00c4 100644
--- a/drivers/gpu/drm/ttm/ttm_page_alloc.c
+++ b/drivers/gpu/drm/ttm/ttm_page_alloc.c
@@ -54,7 +54,7 @@
 
 #define NUM_PAGES_TO_ALLOC		(PAGE_SIZE/sizeof(struct page *))
 #define SMALL_ALLOCATION		16
-#define FREE_ALL_PAGES			(~0U)
+#define FREE_ALL_PAGES			(~0UL)
 /* times are in msecs */
 #define PAGE_FREE_INTERVAL		1000
 
@@ -299,15 +299,14 @@ static void ttm_pool_update_free_locked(struct ttm_page_pool *pool,
  * @free_all: If set to true will free all pages in pool
  * @use_static: Safe to use static buffer
  **/
-static int ttm_page_pool_free(struct ttm_page_pool *pool, unsigned nr_free,
+static unsigned long ttm_page_pool_free(struct ttm_page_pool *pool, unsigned long nr_free,
 			      bool use_static)
 {
 	static struct page *static_buf[NUM_PAGES_TO_ALLOC];
 	unsigned long irq_flags;
 	struct page *p;
 	struct page **pages_to_free;
-	unsigned freed_pages = 0,
-		 npages_to_free = nr_free;
+	unsigned long freed_pages = 0, npages_to_free = nr_free;
 
 	if (NUM_PAGES_TO_ALLOC < nr_free)
 		npages_to_free = NUM_PAGES_TO_ALLOC;
@@ -371,7 +370,8 @@ restart:
 		__list_del(&p->lru, &pool->list);
 
 		ttm_pool_update_free_locked(pool, freed_pages);
-		nr_free -= freed_pages;
+		if (likely(nr_free != FREE_ALL_PAGES))
+			nr_free -= freed_pages;
 	}
 
 	spin_unlock_irqrestore(&pool->lock, irq_flags);
@@ -399,7 +399,7 @@ ttm_pool_shrink_scan(struct shrinker *shrink, struct shrink_control *sc)
 	unsigned i;
 	unsigned pool_offset;
 	struct ttm_page_pool *pool;
-	int shrink_pages = sc->nr_to_scan;
+	unsigned long shrink_pages = sc->nr_to_scan;
 	unsigned long freed = 0;
 
 	if (!mutex_trylock(&lock))
@@ -407,7 +407,7 @@ ttm_pool_shrink_scan(struct shrinker *shrink, struct shrink_control *sc)
 	pool_offset = ++start_pool % NUM_POOLS;
 	/* select start pool in round robin fashion */
 	for (i = 0; i < NUM_POOLS; ++i) {
-		unsigned nr_free = shrink_pages;
+		unsigned long nr_free = shrink_pages;
 		if (shrink_pages == 0)
 			break;
 		pool = &_manager->pools[(i + pool_offset)%NUM_POOLS];
@@ -673,7 +673,7 @@ out:
 }
 
 /* Put all pages in pages list to correct pool to wait for reuse */
-static void ttm_put_pages(struct page **pages, unsigned npages, int flags,
+static void ttm_put_pages(struct page **pages, unsigned long npages, int flags,
 			  enum ttm_caching_state cstate)
 {
 	unsigned long irq_flags;
@@ -728,7 +728,7 @@ static int ttm_get_pages(struct page **pages, unsigned npages, int flags,
 	struct list_head plist;
 	struct page *p = NULL;
 	gfp_t gfp_flags = GFP_USER;
-	unsigned count;
+	unsigned long count;
 	int r;
 
 	/* set zero flag for page allocation if required */
diff --git a/drivers/gpu/drm/ttm/ttm_page_alloc_dma.c b/drivers/gpu/drm/ttm/ttm_page_alloc_dma.c
index bef9f6feb..ca48e17f8 100644
--- a/drivers/gpu/drm/ttm/ttm_page_alloc_dma.c
+++ b/drivers/gpu/drm/ttm/ttm_page_alloc_dma.c
@@ -56,7 +56,7 @@
 
 #define NUM_PAGES_TO_ALLOC		(PAGE_SIZE/sizeof(struct page *))
 #define SMALL_ALLOCATION		4
-#define FREE_ALL_PAGES			(~0U)
+#define FREE_ALL_PAGES			(~0UL)
 /* times are in msecs */
 #define IS_UNDEFINED			(0)
 #define IS_WC				(1<<1)
@@ -416,7 +416,7 @@ static void ttm_dma_page_put(struct dma_pool *pool, struct dma_page *d_page)
  * @nr_free: If set to true will free all pages in pool
  * @use_static: Safe to use static buffer
  **/
-static unsigned ttm_dma_page_pool_free(struct dma_pool *pool, unsigned nr_free,
+static unsigned long ttm_dma_page_pool_free(struct dma_pool *pool, unsigned long nr_free,
 				       bool use_static)
 {
 	static struct page *static_buf[NUM_PAGES_TO_ALLOC];
@@ -424,8 +424,7 @@ static unsigned ttm_dma_page_pool_free(struct dma_pool *pool, unsigned nr_free,
 	struct dma_page *dma_p, *tmp;
 	struct page **pages_to_free;
 	struct list_head d_pages;
-	unsigned freed_pages = 0,
-		 npages_to_free = nr_free;
+	unsigned long freed_pages = 0, npages_to_free = nr_free;
 
 	if (NUM_PAGES_TO_ALLOC < nr_free)
 		npages_to_free = NUM_PAGES_TO_ALLOC;
@@ -502,7 +501,8 @@ restart:
 	/* remove range of pages from the pool */
 	if (freed_pages) {
 		ttm_pool_update_free_locked(pool, freed_pages);
-		nr_free -= freed_pages;
+		if (likely(nr_free != FREE_ALL_PAGES))
+			nr_free -= freed_pages;
 	}
 
 	spin_unlock_irqrestore(&pool->lock, irq_flags);
@@ -939,7 +939,7 @@ void ttm_dma_unpopulate(struct ttm_dma_tt *ttm_dma, struct device *dev)
 	struct dma_page *d_page, *next;
 	enum pool_type type;
 	bool is_cached = false;
-	unsigned count = 0, i, npages = 0;
+	unsigned long count = 0, i, npages = 0;
 	unsigned long irq_flags;
 
 	type = ttm_to_type(ttm->page_flags, ttm->caching_state);
@@ -1014,7 +1014,7 @@ ttm_dma_pool_shrink_scan(struct shrinker *shrink, struct shrink_control *sc)
 	static unsigned start_pool;
 	unsigned idx = 0;
 	unsigned pool_offset;
-	unsigned shrink_pages = sc->nr_to_scan;
+	unsigned long shrink_pages = sc->nr_to_scan;
 	struct device_pools *p;
 	unsigned long freed = 0;
 
@@ -1027,7 +1027,7 @@ ttm_dma_pool_shrink_scan(struct shrinker *shrink, struct shrink_control *sc)
 		goto out;
 	pool_offset = ++start_pool % _manager->npools;
 	list_for_each_entry(p, &_manager->pools, pools) {
-		unsigned nr_free;
+		unsigned long nr_free;
 
 		if (!p->dev)
 			continue;
@@ -1041,7 +1041,7 @@ ttm_dma_pool_shrink_scan(struct shrinker *shrink, struct shrink_control *sc)
 		shrink_pages = ttm_dma_page_pool_free(p->pool, nr_free, true);
 		freed += nr_free - shrink_pages;
 
-		pr_debug("%s: (%s:%d) Asked to shrink %d, have %d more to go\n",
+		pr_debug("%s: (%s:%d) Asked to shrink %lu, have %lu more to go\n",
 			 p->pool->dev_name, p->pool->name, current->pid,
 			 nr_free, shrink_pages);
 	}
diff --git a/drivers/gpu/drm/udl/udl_connector.c b/drivers/gpu/drm/udl/udl_connector.c
index 4709b54c2..beb015dbb 100644
--- a/drivers/gpu/drm/udl/udl_connector.c
+++ b/drivers/gpu/drm/udl/udl_connector.c
@@ -80,7 +80,7 @@ static int udl_get_modes(struct drm_connector *connector)
 	return ret;
 }
 
-static int udl_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status udl_mode_valid(struct drm_connector *connector,
 			  struct drm_display_mode *mode)
 {
 	struct udl_device *udl = connector->dev->dev_private;
diff --git a/drivers/gpu/drm/udl/udl_fb.c b/drivers/gpu/drm/udl/udl_fb.c
index 611b6b9bb..e0faec11d 100644
--- a/drivers/gpu/drm/udl/udl_fb.c
+++ b/drivers/gpu/drm/udl/udl_fb.c
@@ -242,7 +242,6 @@ static int udl_fb_release(struct fb_info *info, int user)
 		fb_deferred_io_cleanup(info);
 		kfree(info->fbdefio);
 		info->fbdefio = NULL;
-		info->fbops->fb_mmap = udl_fb_mmap;
 	}
 #endif
 
diff --git a/drivers/gpu/drm/vc4/vc4_drv.c b/drivers/gpu/drm/vc4/vc4_drv.c
index 9ecef9385..d388af078 100644
--- a/drivers/gpu/drm/vc4/vc4_drv.c
+++ b/drivers/gpu/drm/vc4/vc4_drv.c
@@ -179,6 +179,11 @@ static int compare_dev(struct device *dev, void *data)
 	return dev == data;
 }
 
+static int vc4_match(struct device *dev, void *drv)
+{
+	return platform_bus_type.match(dev, drv);
+}
+
 static void vc4_match_add_drivers(struct device *dev,
 				  struct component_match **match,
 				  struct platform_driver *const *drivers,
@@ -190,8 +195,7 @@ static void vc4_match_add_drivers(struct device *dev,
 		struct device_driver *drv = &drivers[i]->driver;
 		struct device *p = NULL, *d;
 
-		while ((d = bus_find_device(&platform_bus_type, p, drv,
-					    (void *)platform_bus_type.match))) {
+		while ((d = bus_find_device(&platform_bus_type, p, drv, vc4_match))) {
 			put_device(p);
 			component_match_add(dev, match, compare_dev, d);
 			p = d;
diff --git a/drivers/gpu/drm/via/via_dma.c b/drivers/gpu/drm/via/via_dma.c
index d17d8f245..67e8e48b3 100644
--- a/drivers/gpu/drm/via/via_dma.c
+++ b/drivers/gpu/drm/via/via_dma.c
@@ -737,4 +737,4 @@ const struct drm_ioctl_desc via_ioctls[] = {
 	DRM_IOCTL_DEF_DRV(VIA_BLIT_SYNC, via_dma_blit_sync, DRM_AUTH)
 };
 
-int via_max_ioctl = ARRAY_SIZE(via_ioctls);
+const int via_max_ioctl = ARRAY_SIZE(via_ioctls);
diff --git a/drivers/gpu/drm/via/via_drv.c b/drivers/gpu/drm/via/via_drv.c
index ed8aa8ff8..114cc8d27 100644
--- a/drivers/gpu/drm/via/via_drv.c
+++ b/drivers/gpu/drm/via/via_drv.c
@@ -107,7 +107,10 @@ static struct pci_driver via_pci_driver = {
 
 static int __init via_init(void)
 {
-	driver.num_ioctls = via_max_ioctl;
+	pax_open_kernel();
+	const_cast(driver.num_ioctls) = via_max_ioctl;
+	pax_close_kernel();
+
 	via_init_command_verifier();
 	return drm_pci_init(&driver, &via_pci_driver);
 }
diff --git a/drivers/gpu/drm/via/via_drv.h b/drivers/gpu/drm/via/via_drv.h
index 286a785fa..c01826167 100644
--- a/drivers/gpu/drm/via/via_drv.h
+++ b/drivers/gpu/drm/via/via_drv.h
@@ -53,7 +53,7 @@ typedef struct drm_via_ring_buffer {
 typedef uint32_t maskarray_t[5];
 
 typedef struct drm_via_irq {
-	atomic_t irq_received;
+	atomic_unchecked_t irq_received;
 	uint32_t pending_mask;
 	uint32_t enable_mask;
 	wait_queue_head_t irq_queue;
@@ -77,7 +77,7 @@ typedef struct drm_via_private {
 	struct timeval last_vblank;
 	int last_vblank_valid;
 	unsigned usec_per_vblank;
-	atomic_t vbl_received;
+	atomic_unchecked_t vbl_received;
 	drm_via_state_t hc_state;
 	char pci_buf[VIA_PCI_BUF_SIZE];
 	const uint32_t *fire_offsets[VIA_FIRE_BUF_SIZE];
@@ -121,7 +121,7 @@ enum via_family {
 #define VIA_WRITE8(reg, val)	DRM_WRITE8(VIA_BASE, reg, val)
 
 extern const struct drm_ioctl_desc via_ioctls[];
-extern int via_max_ioctl;
+extern const int via_max_ioctl;
 
 extern int via_fb_init(struct drm_device *dev, void *data, struct drm_file *file_priv);
 extern int via_mem_alloc(struct drm_device *dev, void *data, struct drm_file *file_priv);
diff --git a/drivers/gpu/drm/via/via_irq.c b/drivers/gpu/drm/via/via_irq.c
index ea8172c74..6ceff63be 100644
--- a/drivers/gpu/drm/via/via_irq.c
+++ b/drivers/gpu/drm/via/via_irq.c
@@ -102,7 +102,7 @@ u32 via_get_vblank_counter(struct drm_device *dev, unsigned int pipe)
 	if (pipe != 0)
 		return 0;
 
-	return atomic_read(&dev_priv->vbl_received);
+	return atomic_read_unchecked(&dev_priv->vbl_received);
 }
 
 irqreturn_t via_driver_irq_handler(int irq, void *arg)
@@ -117,8 +117,8 @@ irqreturn_t via_driver_irq_handler(int irq, void *arg)
 
 	status = VIA_READ(VIA_REG_INTERRUPT);
 	if (status & VIA_IRQ_VBLANK_PENDING) {
-		atomic_inc(&dev_priv->vbl_received);
-		if (!(atomic_read(&dev_priv->vbl_received) & 0x0F)) {
+		atomic_inc_unchecked(&dev_priv->vbl_received);
+		if (!(atomic_read_unchecked(&dev_priv->vbl_received) & 0x0F)) {
 			do_gettimeofday(&cur_vblank);
 			if (dev_priv->last_vblank_valid) {
 				dev_priv->usec_per_vblank =
@@ -128,7 +128,7 @@ irqreturn_t via_driver_irq_handler(int irq, void *arg)
 			dev_priv->last_vblank = cur_vblank;
 			dev_priv->last_vblank_valid = 1;
 		}
-		if (!(atomic_read(&dev_priv->vbl_received) & 0xFF)) {
+		if (!(atomic_read_unchecked(&dev_priv->vbl_received) & 0xFF)) {
 			DRM_DEBUG("US per vblank is: %u\n",
 				  dev_priv->usec_per_vblank);
 		}
@@ -138,7 +138,7 @@ irqreturn_t via_driver_irq_handler(int irq, void *arg)
 
 	for (i = 0; i < dev_priv->num_irqs; ++i) {
 		if (status & cur_irq->pending_mask) {
-			atomic_inc(&cur_irq->irq_received);
+			atomic_inc_unchecked(&cur_irq->irq_received);
 			wake_up(&cur_irq->irq_queue);
 			handled = 1;
 			if (dev_priv->irq_map[drm_via_irq_dma0_td] == i)
@@ -243,11 +243,11 @@ via_driver_irq_wait(struct drm_device *dev, unsigned int irq, int force_sequence
 		DRM_WAIT_ON(ret, cur_irq->irq_queue, 3 * HZ,
 			    ((VIA_READ(masks[irq][2]) & masks[irq][3]) ==
 			     masks[irq][4]));
-		cur_irq_sequence = atomic_read(&cur_irq->irq_received);
+		cur_irq_sequence = atomic_read_unchecked(&cur_irq->irq_received);
 	} else {
 		DRM_WAIT_ON(ret, cur_irq->irq_queue, 3 * HZ,
 			    (((cur_irq_sequence =
-			       atomic_read(&cur_irq->irq_received)) -
+			       atomic_read_unchecked(&cur_irq->irq_received)) -
 			      *sequence) <= (1 << 23)));
 	}
 	*sequence = cur_irq_sequence;
@@ -285,7 +285,7 @@ void via_driver_irq_preinstall(struct drm_device *dev)
 		}
 
 		for (i = 0; i < dev_priv->num_irqs; ++i) {
-			atomic_set(&cur_irq->irq_received, 0);
+			atomic_set_unchecked(&cur_irq->irq_received, 0);
 			cur_irq->enable_mask = dev_priv->irq_masks[i][0];
 			cur_irq->pending_mask = dev_priv->irq_masks[i][1];
 			init_waitqueue_head(&cur_irq->irq_queue);
@@ -367,7 +367,7 @@ int via_wait_irq(struct drm_device *dev, void *data, struct drm_file *file_priv)
 	switch (irqwait->request.type & ~VIA_IRQ_FLAGS_MASK) {
 	case VIA_IRQ_RELATIVE:
 		irqwait->request.sequence +=
-			atomic_read(&cur_irq->irq_received);
+			atomic_read_unchecked(&cur_irq->irq_received);
 		irqwait->request.type &= ~_DRM_VBLANK_RELATIVE;
 	case VIA_IRQ_ABSOLUTE:
 		break;
diff --git a/drivers/gpu/drm/virtio/virtgpu_display.c b/drivers/gpu/drm/virtio/virtgpu_display.c
index 4e192aa2d..15665db20 100644
--- a/drivers/gpu/drm/virtio/virtgpu_display.c
+++ b/drivers/gpu/drm/virtio/virtgpu_display.c
@@ -192,7 +192,7 @@ static int virtio_gpu_conn_get_modes(struct drm_connector *connector)
 	return count;
 }
 
-static int virtio_gpu_conn_mode_valid(struct drm_connector *connector,
+static enum drm_mode_status virtio_gpu_conn_mode_valid(struct drm_connector *connector,
 				      struct drm_display_mode *mode)
 {
 	struct virtio_gpu_output *output =
diff --git a/drivers/gpu/drm/virtio/virtgpu_ttm.c b/drivers/gpu/drm/virtio/virtgpu_ttm.c
index 80482ac5f..bf693e517 100644
--- a/drivers/gpu/drm/virtio/virtgpu_ttm.c
+++ b/drivers/gpu/drm/virtio/virtgpu_ttm.c
@@ -198,11 +198,11 @@ static void ttm_bo_man_debug(struct ttm_mem_type_manager *man,
 }
 
 static const struct ttm_mem_type_manager_func virtio_gpu_bo_manager_func = {
-	ttm_bo_man_init,
-	ttm_bo_man_takedown,
-	ttm_bo_man_get_node,
-	ttm_bo_man_put_node,
-	ttm_bo_man_debug
+	.init = &ttm_bo_man_init,
+	.takedown = &ttm_bo_man_takedown,
+	.get_node = &ttm_bo_man_get_node,
+	.put_node = &ttm_bo_man_put_node,
+	.debug = &ttm_bo_man_debug
 };
 
 static int virtio_gpu_init_mem_type(struct ttm_bo_device *bdev, uint32_t type,
diff --git a/drivers/gpu/drm/vmwgfx/vmwgfx_drv.h b/drivers/gpu/drm/vmwgfx/vmwgfx_drv.h
index 74304b03f..d45379466 100644
--- a/drivers/gpu/drm/vmwgfx/vmwgfx_drv.h
+++ b/drivers/gpu/drm/vmwgfx/vmwgfx_drv.h
@@ -439,7 +439,7 @@ struct vmw_private {
 	 * Fencing and IRQs.
 	 */
 
-	atomic_t marker_seq;
+	atomic_unchecked_t marker_seq;
 	wait_queue_head_t fence_queue;
 	wait_queue_head_t fifo_queue;
 	spinlock_t waiter_lock;
diff --git a/drivers/gpu/drm/vmwgfx/vmwgfx_fifo.c b/drivers/gpu/drm/vmwgfx/vmwgfx_fifo.c
index b6a0806b0..9fb54795b 100644
--- a/drivers/gpu/drm/vmwgfx/vmwgfx_fifo.c
+++ b/drivers/gpu/drm/vmwgfx/vmwgfx_fifo.c
@@ -156,7 +156,7 @@ int vmw_fifo_init(struct vmw_private *dev_priv, struct vmw_fifo_state *fifo)
 		 (unsigned int) min,
 		 (unsigned int) fifo->capabilities);
 
-	atomic_set(&dev_priv->marker_seq, dev_priv->last_read_seqno);
+	atomic_set_unchecked(&dev_priv->marker_seq, dev_priv->last_read_seqno);
 	vmw_mmio_write(dev_priv->last_read_seqno, fifo_mem + SVGA_FIFO_FENCE);
 	vmw_marker_queue_init(&fifo->marker_queue);
 
@@ -355,7 +355,7 @@ static void *vmw_local_fifo_reserve(struct vmw_private *dev_priv,
 				if (reserveable)
 					vmw_mmio_write(bytes, fifo_mem +
 						       SVGA_FIFO_RESERVED);
-				return (void __force *) (fifo_mem +
+				return (void __force_kernel *) (fifo_mem +
 							 (next_cmd >> 2));
 			} else {
 				need_bounce = true;
@@ -544,7 +544,7 @@ int vmw_fifo_send_fence(struct vmw_private *dev_priv, uint32_t *seqno)
 
 	fm = vmw_fifo_reserve(dev_priv, bytes);
 	if (unlikely(fm == NULL)) {
-		*seqno = atomic_read(&dev_priv->marker_seq);
+		*seqno = atomic_read_unchecked(&dev_priv->marker_seq);
 		ret = -ENOMEM;
 		(void)vmw_fallback_wait(dev_priv, false, true, *seqno,
 					false, 3*HZ);
@@ -552,7 +552,7 @@ int vmw_fifo_send_fence(struct vmw_private *dev_priv, uint32_t *seqno)
 	}
 
 	do {
-		*seqno = atomic_add_return(1, &dev_priv->marker_seq);
+		*seqno = atomic_add_return_unchecked(1, &dev_priv->marker_seq);
 	} while (*seqno == 0);
 
 	if (!(fifo_state->capabilities & SVGA_FIFO_CAP_FENCE)) {
diff --git a/drivers/gpu/drm/vmwgfx/vmwgfx_gmrid_manager.c b/drivers/gpu/drm/vmwgfx/vmwgfx_gmrid_manager.c
index 170b61be1..fec7348ce 100644
--- a/drivers/gpu/drm/vmwgfx/vmwgfx_gmrid_manager.c
+++ b/drivers/gpu/drm/vmwgfx/vmwgfx_gmrid_manager.c
@@ -164,9 +164,9 @@ static void vmw_gmrid_man_debug(struct ttm_mem_type_manager *man,
 }
 
 const struct ttm_mem_type_manager_func vmw_gmrid_manager_func = {
-	vmw_gmrid_man_init,
-	vmw_gmrid_man_takedown,
-	vmw_gmrid_man_get_node,
-	vmw_gmrid_man_put_node,
-	vmw_gmrid_man_debug
+	.init = vmw_gmrid_man_init,
+	.takedown = vmw_gmrid_man_takedown,
+	.get_node = vmw_gmrid_man_get_node,
+	.put_node = vmw_gmrid_man_put_node,
+	.debug = vmw_gmrid_man_debug
 };
diff --git a/drivers/gpu/drm/vmwgfx/vmwgfx_irq.c b/drivers/gpu/drm/vmwgfx/vmwgfx_irq.c
index 0c7e17232..ead94fc91 100644
--- a/drivers/gpu/drm/vmwgfx/vmwgfx_irq.c
+++ b/drivers/gpu/drm/vmwgfx/vmwgfx_irq.c
@@ -103,7 +103,7 @@ bool vmw_seqno_passed(struct vmw_private *dev_priv,
 	 * emitted. Then the fence is stale and signaled.
 	 */
 
-	ret = ((atomic_read(&dev_priv->marker_seq) - seqno)
+	ret = ((atomic_read_unchecked(&dev_priv->marker_seq) - seqno)
 	       > VMW_FENCE_WRAP);
 
 	return ret;
@@ -142,7 +142,7 @@ int vmw_fallback_wait(struct vmw_private *dev_priv,
 		}
 	}
 
-	signal_seq = atomic_read(&dev_priv->marker_seq);
+	signal_seq = atomic_read_unchecked(&dev_priv->marker_seq);
 	ret = 0;
 
 	for (;;) {
diff --git a/drivers/gpu/drm/vmwgfx/vmwgfx_marker.c b/drivers/gpu/drm/vmwgfx/vmwgfx_marker.c
index efd1ffd68..0ae13ca2d 100644
--- a/drivers/gpu/drm/vmwgfx/vmwgfx_marker.c
+++ b/drivers/gpu/drm/vmwgfx/vmwgfx_marker.c
@@ -135,7 +135,7 @@ int vmw_wait_lag(struct vmw_private *dev_priv,
 	while (!vmw_lag_lt(queue, us)) {
 		spin_lock(&queue->lock);
 		if (list_empty(&queue->head))
-			seqno = atomic_read(&dev_priv->marker_seq);
+			seqno = atomic_read_unchecked(&dev_priv->marker_seq);
 		else {
 			marker = list_first_entry(&queue->head,
 						 struct vmw_marker, head);
diff --git a/drivers/gpu/vga/vga_switcheroo.c b/drivers/gpu/vga/vga_switcheroo.c
index 5f962bfcb..b095fc5d1 100644
--- a/drivers/gpu/vga/vga_switcheroo.c
+++ b/drivers/gpu/vga/vga_switcheroo.c
@@ -1054,7 +1054,7 @@ static int vga_switcheroo_runtime_resume(struct device *dev)
  * where the power switch is separate to the device being powered down.
  */
 int vga_switcheroo_init_domain_pm_ops(struct device *dev,
-				      struct dev_pm_domain *domain)
+				      dev_pm_domain_no_const *domain)
 {
 	/* copy over all the bus versions */
 	if (dev->bus && dev->bus->pm) {
@@ -1125,7 +1125,7 @@ static int vga_switcheroo_runtime_resume_hdmi_audio(struct device *dev)
  */
 int
 vga_switcheroo_init_domain_pm_optimus_hdmi_audio(struct device *dev,
-						 struct dev_pm_domain *domain)
+						 dev_pm_domain_no_const *domain)
 {
 	/* copy over all the bus versions */
 	if (dev->bus && dev->bus->pm) {
diff --git a/drivers/hid/hid-core.c b/drivers/hid/hid-core.c
index 08f53c7fd..8f2d6a37d 100644
--- a/drivers/hid/hid-core.c
+++ b/drivers/hid/hid-core.c
@@ -2637,7 +2637,7 @@ EXPORT_SYMBOL_GPL(hid_ignore);
 
 int hid_add_device(struct hid_device *hdev)
 {
-	static atomic_t id = ATOMIC_INIT(0);
+	static atomic_unchecked_t id = ATOMIC_INIT(0);
 	int ret;
 
 	if (WARN_ON(hdev->status & HID_STAT_ADDED))
@@ -2681,7 +2681,7 @@ int hid_add_device(struct hid_device *hdev)
 	/* XXX hack, any other cleaner solution after the driver core
 	 * is converted to allow more than 20 bytes as the device name? */
 	dev_set_name(&hdev->dev, "%04X:%04X:%04X.%04X", hdev->bus,
-		     hdev->vendor, hdev->product, atomic_inc_return(&id));
+		     hdev->vendor, hdev->product, atomic_inc_return_unchecked(&id));
 
 	hid_debug_register(hdev, dev_name(&hdev->dev));
 	ret = device_add(&hdev->dev);
diff --git a/drivers/hid/hid-magicmouse.c b/drivers/hid/hid-magicmouse.c
index d6fa496d0..dde31aaf1 100644
--- a/drivers/hid/hid-magicmouse.c
+++ b/drivers/hid/hid-magicmouse.c
@@ -34,7 +34,7 @@ module_param(emulate_scroll_wheel, bool, 0644);
 MODULE_PARM_DESC(emulate_scroll_wheel, "Emulate a scroll wheel");
 
 static unsigned int scroll_speed = 32;
-static int param_set_scroll_speed(const char *val, struct kernel_param *kp) {
+static int param_set_scroll_speed(const char *val, const struct kernel_param *kp) {
 	unsigned long speed;
 	if (!val || kstrtoul(val, 0, &speed) || speed > 63)
 		return -EINVAL;
diff --git a/drivers/hid/hid-sensor-custom.c b/drivers/hid/hid-sensor-custom.c
index 5614fee82..8a6f5f678 100644
--- a/drivers/hid/hid-sensor-custom.c
+++ b/drivers/hid/hid-sensor-custom.c
@@ -590,7 +590,7 @@ static int hid_sensor_custom_add_attributes(struct hid_sensor_custom
 		j = 0;
 		while (j < HID_CUSTOM_TOTAL_ATTRS &&
 		       hid_custom_attrs[j].name) {
-			struct device_attribute *device_attr;
+			device_attribute_no_const *device_attr;
 
 			device_attr = &sensor_inst->fields[i].sd_attrs[j];
 
diff --git a/drivers/hid/hid-wiimote-debug.c b/drivers/hid/hid-wiimote-debug.c
index c13fb5bd7..55a380241 100644
--- a/drivers/hid/hid-wiimote-debug.c
+++ b/drivers/hid/hid-wiimote-debug.c
@@ -66,7 +66,7 @@ static ssize_t wiidebug_eeprom_read(struct file *f, char __user *u, size_t s,
 	else if (size == 0)
 		return -EIO;
 
-	if (copy_to_user(u, buf, size))
+	if (size > sizeof(buf) || copy_to_user(u, buf, size))
 		return -EFAULT;
 
 	*off += size;
diff --git a/drivers/hv/channel.c b/drivers/hv/channel.c
index 56dd261f7..493d7e0da 100644
--- a/drivers/hv/channel.c
+++ b/drivers/hv/channel.c
@@ -398,7 +398,7 @@ int vmbus_establish_gpadl(struct vmbus_channel *channel, void *kbuffer,
 	int ret = 0;
 
 	next_gpadl_handle =
-		(atomic_inc_return(&vmbus_connection.next_gpadl_handle) - 1);
+		(atomic_inc_return_unchecked(&vmbus_connection.next_gpadl_handle) - 1);
 
 	ret = create_gpadl_header(kbuffer, size, &msginfo, &msgcount);
 	if (ret)
@@ -749,9 +749,7 @@ int vmbus_sendpacket_pagebuffer_ctl(struct vmbus_channel *channel,
 	 * Adjust the size down since vmbus_channel_packet_page_buffer is the
 	 * largest size we support
 	 */
-	descsize = sizeof(struct vmbus_channel_packet_page_buffer) -
-			  ((MAX_PAGE_BUFFER_COUNT - pagecount) *
-			  sizeof(struct hv_page_buffer));
+	descsize = offsetof(struct vmbus_channel_packet_page_buffer, range[pagecount]);
 	packetlen = descsize + bufferlen;
 	packetlen_aligned = ALIGN(packetlen, sizeof(u64));
 
diff --git a/drivers/hv/hv.c b/drivers/hv/hv.c
index a1c086ba3..20011443d 100644
--- a/drivers/hv/hv.c
+++ b/drivers/hv/hv.c
@@ -183,6 +183,7 @@ static struct clocksource hyperv_cs_tsc = {
 };
 #endif
 
+static char hv_hypercall_page[PAGE_SIZE] __aligned(PAGE_SIZE) __used __section(".text");
 
 /*
  * hv_init - Main initialization routine.
@@ -193,7 +194,6 @@ int hv_init(void)
 {
 	int max_leaf;
 	union hv_x64_msr_hypercall_contents hypercall_msr;
-	void *virtaddr = NULL;
 
 	memset(hv_context.synic_event_page, 0, sizeof(void *) * NR_CPUS);
 	memset(hv_context.synic_message_page, 0,
@@ -220,14 +220,9 @@ int hv_init(void)
 	/* See if the hypercall page is already set */
 	rdmsrl(HV_X64_MSR_HYPERCALL, hypercall_msr.as_uint64);
 
-	virtaddr = __vmalloc(PAGE_SIZE, GFP_KERNEL, PAGE_KERNEL_EXEC);
-
-	if (!virtaddr)
-		goto cleanup;
-
 	hypercall_msr.enable = 1;
 
-	hypercall_msr.guest_physical_address = vmalloc_to_pfn(virtaddr);
+	hypercall_msr.guest_physical_address = __phys_to_pfn(slow_virt_to_phys((void *)(ktla_ktva((unsigned long)hv_hypercall_page))));
 	wrmsrl(HV_X64_MSR_HYPERCALL, hypercall_msr.as_uint64);
 
 	/* Confirm that hypercall page did get setup. */
@@ -237,7 +232,7 @@ int hv_init(void)
 	if (!hypercall_msr.enable)
 		goto cleanup;
 
-	hv_context.hypercall_page = virtaddr;
+	hv_context.hypercall_page = hv_hypercall_page;
 
 #ifdef CONFIG_X86_64
 	if (ms_hyperv.features & HV_X64_MSR_REFERENCE_TSC_AVAILABLE) {
@@ -261,13 +256,9 @@ int hv_init(void)
 	return 0;
 
 cleanup:
-	if (virtaddr) {
-		if (hypercall_msr.enable) {
-			hypercall_msr.as_uint64 = 0;
-			wrmsrl(HV_X64_MSR_HYPERCALL, hypercall_msr.as_uint64);
-		}
-
-		vfree(virtaddr);
+	if (hypercall_msr.enable) {
+		hypercall_msr.as_uint64 = 0;
+		wrmsrl(HV_X64_MSR_HYPERCALL, hypercall_msr.as_uint64);
 	}
 
 	return -ENOTSUPP;
@@ -288,7 +279,6 @@ void hv_cleanup(void)
 	if (hv_context.hypercall_page) {
 		hypercall_msr.as_uint64 = 0;
 		wrmsrl(HV_X64_MSR_HYPERCALL, hypercall_msr.as_uint64);
-		vfree(hv_context.hypercall_page);
 		hv_context.hypercall_page = NULL;
 	}
 
diff --git a/drivers/hv/hv_balloon.c b/drivers/hv/hv_balloon.c
index df35fb7ed..fff7e4e10 100644
--- a/drivers/hv/hv_balloon.c
+++ b/drivers/hv/hv_balloon.c
@@ -471,7 +471,7 @@ MODULE_PARM_DESC(hot_add, "If set attempt memory hot_add");
 
 module_param(pressure_report_delay, uint, (S_IRUGO | S_IWUSR));
 MODULE_PARM_DESC(pressure_report_delay, "Delay in secs in reporting pressure");
-static atomic_t trans_id = ATOMIC_INIT(0);
+static atomic_unchecked_t trans_id = ATOMIC_INIT(0);
 
 static int dm_ring_size = (5 * PAGE_SIZE);
 
@@ -945,7 +945,7 @@ static void hot_add_req(struct work_struct *dummy)
 		pr_info("Memory hot add failed\n");
 
 	dm->state = DM_INITIALIZED;
-	resp.hdr.trans_id = atomic_inc_return(&trans_id);
+	resp.hdr.trans_id = atomic_inc_return_unchecked(&trans_id);
 	vmbus_sendpacket(dm->dev->channel, &resp,
 			sizeof(struct dm_hot_add_response),
 			(unsigned long)NULL,
@@ -1026,7 +1026,7 @@ static void post_status(struct hv_dynmem_device *dm)
 	memset(&status, 0, sizeof(struct dm_status));
 	status.hdr.type = DM_STATUS_REPORT;
 	status.hdr.size = sizeof(struct dm_status);
-	status.hdr.trans_id = atomic_inc_return(&trans_id);
+	status.hdr.trans_id = atomic_inc_return_unchecked(&trans_id);
 
 	/*
 	 * The host expects the guest to report free and committed memory.
@@ -1050,7 +1050,7 @@ static void post_status(struct hv_dynmem_device *dm)
 	 * send the status. This can happen if we were interrupted
 	 * after we picked our transaction ID.
 	 */
-	if (status.hdr.trans_id != atomic_read(&trans_id))
+	if (status.hdr.trans_id != atomic_read_unchecked(&trans_id))
 		return;
 
 	/*
@@ -1195,7 +1195,7 @@ static void balloon_up(struct work_struct *dummy)
 		 */
 
 		do {
-			bl_resp->hdr.trans_id = atomic_inc_return(&trans_id);
+			bl_resp->hdr.trans_id = atomic_inc_return_unchecked(&trans_id);
 			ret = vmbus_sendpacket(dm_device.dev->channel,
 						bl_resp,
 						bl_resp->hdr.size,
@@ -1241,7 +1241,7 @@ static void balloon_down(struct hv_dynmem_device *dm,
 
 	memset(&resp, 0, sizeof(struct dm_unballoon_response));
 	resp.hdr.type = DM_UNBALLOON_RESPONSE;
-	resp.hdr.trans_id = atomic_inc_return(&trans_id);
+	resp.hdr.trans_id = atomic_inc_return_unchecked(&trans_id);
 	resp.hdr.size = sizeof(struct dm_unballoon_response);
 
 	vmbus_sendpacket(dm_device.dev->channel, &resp,
@@ -1301,7 +1301,7 @@ static void version_resp(struct hv_dynmem_device *dm,
 	memset(&version_req, 0, sizeof(struct dm_version_request));
 	version_req.hdr.type = DM_VERSION_REQUEST;
 	version_req.hdr.size = sizeof(struct dm_version_request);
-	version_req.hdr.trans_id = atomic_inc_return(&trans_id);
+	version_req.hdr.trans_id = atomic_inc_return_unchecked(&trans_id);
 	version_req.version.version = dm->next_version;
 
 	/*
@@ -1488,7 +1488,7 @@ static int balloon_probe(struct hv_device *dev,
 	memset(&version_req, 0, sizeof(struct dm_version_request));
 	version_req.hdr.type = DM_VERSION_REQUEST;
 	version_req.hdr.size = sizeof(struct dm_version_request);
-	version_req.hdr.trans_id = atomic_inc_return(&trans_id);
+	version_req.hdr.trans_id = atomic_inc_return_unchecked(&trans_id);
 	version_req.version.version = DYNMEM_PROTOCOL_VERSION_WIN10;
 	version_req.is_last_attempt = 0;
 
@@ -1519,7 +1519,7 @@ static int balloon_probe(struct hv_device *dev,
 	memset(&cap_msg, 0, sizeof(struct dm_capabilities));
 	cap_msg.hdr.type = DM_CAPABILITIES_REPORT;
 	cap_msg.hdr.size = sizeof(struct dm_capabilities);
-	cap_msg.hdr.trans_id = atomic_inc_return(&trans_id);
+	cap_msg.hdr.trans_id = atomic_inc_return_unchecked(&trans_id);
 
 	cap_msg.caps.cap_bits.balloon = 1;
 	cap_msg.caps.cap_bits.hot_add = 1;
diff --git a/drivers/hv/hyperv_vmbus.h b/drivers/hv/hyperv_vmbus.h
index 718b5c72f..c1bf20383 100644
--- a/drivers/hv/hyperv_vmbus.h
+++ b/drivers/hv/hyperv_vmbus.h
@@ -566,7 +566,7 @@ enum vmbus_connect_state {
 struct vmbus_connection {
 	enum vmbus_connect_state conn_state;
 
-	atomic_t next_gpadl_handle;
+	atomic_unchecked_t next_gpadl_handle;
 
 	struct completion  unload_event;
 	/*
diff --git a/drivers/hwmon/acpi_power_meter.c b/drivers/hwmon/acpi_power_meter.c
index 579bdf93b..0dac21d52 100644
--- a/drivers/hwmon/acpi_power_meter.c
+++ b/drivers/hwmon/acpi_power_meter.c
@@ -116,7 +116,7 @@ struct sensor_template {
 		       struct device_attribute *devattr,
 		       const char *buf, size_t count);
 	int index;
-};
+} __do_const;
 
 /* Averaging interval */
 static int update_avg_interval(struct acpi_power_meter_resource *resource)
@@ -631,7 +631,7 @@ static int register_attrs(struct acpi_power_meter_resource *resource,
 			  struct sensor_template *attrs)
 {
 	struct device *dev = &resource->acpi_dev->dev;
-	struct sensor_device_attribute *sensors =
+	sensor_device_attribute_no_const *sensors =
 		&resource->sensors[resource->num_sensors];
 	int res = 0;
 
@@ -973,7 +973,7 @@ static int __init enable_cap_knobs(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id __initdata pm_dmi_table[] = {
+static const struct dmi_system_id __initconst pm_dmi_table[] = {
 	{
 		enable_cap_knobs, "IBM Active Energy Manager",
 		{
diff --git a/drivers/hwmon/applesmc.c b/drivers/hwmon/applesmc.c
index 0af7fd311..1fc50d474 100644
--- a/drivers/hwmon/applesmc.c
+++ b/drivers/hwmon/applesmc.c
@@ -1105,7 +1105,7 @@ static int applesmc_create_nodes(struct applesmc_node_group *groups, int num)
 {
 	struct applesmc_node_group *grp;
 	struct applesmc_dev_attr *node;
-	struct attribute *attr;
+	attribute_no_const *attr;
 	int ret, i;
 
 	for (grp = groups; grp->format; grp++) {
@@ -1242,7 +1242,7 @@ static int applesmc_dmi_match(const struct dmi_system_id *id)
  * Note that DMI_MATCH(...,"MacBook") will match "MacBookPro1,1".
  * So we need to put "Apple MacBook Pro" before "Apple MacBook".
  */
-static __initdata struct dmi_system_id applesmc_whitelist[] = {
+static const __initconst struct dmi_system_id applesmc_whitelist[] = {
 	{ applesmc_dmi_match, "Apple MacBook Air", {
 	  DMI_MATCH(DMI_BOARD_VENDOR, "Apple"),
 	  DMI_MATCH(DMI_PRODUCT_NAME, "MacBookAir") },
diff --git a/drivers/hwmon/asus_atk0110.c b/drivers/hwmon/asus_atk0110.c
index cccef8796..06ce8ec4d 100644
--- a/drivers/hwmon/asus_atk0110.c
+++ b/drivers/hwmon/asus_atk0110.c
@@ -147,10 +147,10 @@ MODULE_DEVICE_TABLE(acpi, atk_ids);
 struct atk_sensor_data {
 	struct list_head list;
 	struct atk_data *data;
-	struct device_attribute label_attr;
-	struct device_attribute input_attr;
-	struct device_attribute limit1_attr;
-	struct device_attribute limit2_attr;
+	device_attribute_no_const label_attr;
+	device_attribute_no_const input_attr;
+	device_attribute_no_const limit1_attr;
+	device_attribute_no_const limit2_attr;
 	char label_attr_name[ATTR_NAME_SIZE];
 	char input_attr_name[ATTR_NAME_SIZE];
 	char limit1_attr_name[ATTR_NAME_SIZE];
@@ -270,7 +270,7 @@ static ssize_t atk_name_show(struct device *dev,
 static struct device_attribute atk_name_attr =
 		__ATTR(name, 0444, atk_name_show, NULL);
 
-static void atk_init_attribute(struct device_attribute *attr, char *name,
+static void atk_init_attribute(device_attribute_no_const *attr, char *name,
 		sysfs_show_func show)
 {
 	sysfs_attr_init(&attr->attr);
diff --git a/drivers/hwmon/coretemp.c b/drivers/hwmon/coretemp.c
index 6a27eb2fe..349ed23ed 100644
--- a/drivers/hwmon/coretemp.c
+++ b/drivers/hwmon/coretemp.c
@@ -783,7 +783,7 @@ static int coretemp_cpu_callback(struct notifier_block *nfb,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block coretemp_cpu_notifier __refdata = {
+static struct notifier_block coretemp_cpu_notifier = {
 	.notifier_call = coretemp_cpu_callback,
 };
 
diff --git a/drivers/hwmon/dell-smm-hwmon.c b/drivers/hwmon/dell-smm-hwmon.c
index acf9c0361..1424826b1 100644
--- a/drivers/hwmon/dell-smm-hwmon.c
+++ b/drivers/hwmon/dell-smm-hwmon.c
@@ -886,7 +886,7 @@ static const struct i8k_config_data i8k_config_data[] = {
 	},
 };
 
-static struct dmi_system_id i8k_dmi_table[] __initdata = {
+static const struct dmi_system_id i8k_dmi_table[] __initconst = {
 	{
 		.ident = "Dell Inspiron",
 		.matches = {
@@ -1002,7 +1002,7 @@ MODULE_DEVICE_TABLE(dmi, i8k_dmi_table);
  * of affected Dell machines for which we disallow I8K_SMM_GET_FAN_TYPE call.
  * See bug: https://bugzilla.kernel.org/show_bug.cgi?id=100121
  */
-static struct dmi_system_id i8k_blacklist_fan_type_dmi_table[] __initdata = {
+static const struct dmi_system_id i8k_blacklist_fan_type_dmi_table[] __initconst = {
 	{
 		.ident = "Dell Studio XPS 8000",
 		.matches = {
diff --git a/drivers/hwmon/ibmaem.c b/drivers/hwmon/ibmaem.c
index 1f643782c..2b6e6150d 100644
--- a/drivers/hwmon/ibmaem.c
+++ b/drivers/hwmon/ibmaem.c
@@ -924,7 +924,7 @@ static int aem_register_sensors(struct aem_data *data,
 				const struct aem_rw_sensor_template *rw)
 {
 	struct device *dev = &data->pdev->dev;
-	struct sensor_device_attribute *sensors = data->sensors;
+	sensor_device_attribute_no_const *sensors = data->sensors;
 	int err;
 
 	/* Set up read-only sensors */
diff --git a/drivers/hwmon/iio_hwmon.c b/drivers/hwmon/iio_hwmon.c
index 89449871b..839863d0c 100644
--- a/drivers/hwmon/iio_hwmon.c
+++ b/drivers/hwmon/iio_hwmon.c
@@ -61,7 +61,7 @@ static int iio_hwmon_probe(struct platform_device *pdev)
 {
 	struct device *dev = &pdev->dev;
 	struct iio_hwmon_state *st;
-	struct sensor_device_attribute *a;
+	sensor_device_attribute_no_const *a;
 	int ret, i;
 	int in_i = 1, temp_i = 1, curr_i = 1, humidity_i = 1;
 	enum iio_chan_type type;
diff --git a/drivers/hwmon/nct6683.c b/drivers/hwmon/nct6683.c
index 559c596b2..3de1a9630 100644
--- a/drivers/hwmon/nct6683.c
+++ b/drivers/hwmon/nct6683.c
@@ -404,11 +404,11 @@ nct6683_create_attr_group(struct device *dev,
 			  const struct sensor_template_group *tg,
 			  int repeat)
 {
-	struct sensor_device_attribute_2 *a2;
-	struct sensor_device_attribute *a;
+	sensor_device_attribute_2_no_const *a2;
+	sensor_device_attribute_no_const *a;
 	struct sensor_device_template **t;
 	struct sensor_device_attr_u *su;
-	struct attribute_group *group;
+	attribute_group_no_const *group;
 	struct attribute **attrs;
 	int i, j, count;
 
diff --git a/drivers/hwmon/nct6775.c b/drivers/hwmon/nct6775.c
index d087a8e00..54e963a93 100644
--- a/drivers/hwmon/nct6775.c
+++ b/drivers/hwmon/nct6775.c
@@ -1049,10 +1049,10 @@ nct6775_create_attr_group(struct device *dev,
 			  const struct sensor_template_group *tg,
 			  int repeat)
 {
-	struct attribute_group *group;
+	attribute_group_no_const *group;
 	struct sensor_device_attr_u *su;
-	struct sensor_device_attribute *a;
-	struct sensor_device_attribute_2 *a2;
+	sensor_device_attribute_no_const *a;
+	sensor_device_attribute_2_no_const *a2;
 	struct attribute **attrs;
 	struct sensor_device_template **t;
 	int i, count;
diff --git a/drivers/hwmon/pmbus/pmbus_core.c b/drivers/hwmon/pmbus/pmbus_core.c
index ba59eaef2..dbf694c63 100644
--- a/drivers/hwmon/pmbus/pmbus_core.c
+++ b/drivers/hwmon/pmbus/pmbus_core.c
@@ -824,7 +824,7 @@ static int pmbus_add_attribute(struct pmbus_data *data, struct attribute *attr)
 	return 0;
 }
 
-static void pmbus_dev_attr_init(struct device_attribute *dev_attr,
+static void pmbus_dev_attr_init(device_attribute_no_const *dev_attr,
 				const char *name,
 				umode_t mode,
 				ssize_t (*show)(struct device *dev,
@@ -841,7 +841,7 @@ static void pmbus_dev_attr_init(struct device_attribute *dev_attr,
 	dev_attr->store = store;
 }
 
-static void pmbus_attr_init(struct sensor_device_attribute *a,
+static void pmbus_attr_init(sensor_device_attribute_no_const *a,
 			    const char *name,
 			    umode_t mode,
 			    ssize_t (*show)(struct device *dev,
@@ -863,7 +863,7 @@ static int pmbus_add_boolean(struct pmbus_data *data,
 			     u16 reg, u8 mask)
 {
 	struct pmbus_boolean *boolean;
-	struct sensor_device_attribute *a;
+	sensor_device_attribute_no_const *a;
 
 	boolean = devm_kzalloc(data->dev, sizeof(*boolean), GFP_KERNEL);
 	if (!boolean)
@@ -888,7 +888,7 @@ static struct pmbus_sensor *pmbus_add_sensor(struct pmbus_data *data,
 					     bool update, bool readonly)
 {
 	struct pmbus_sensor *sensor;
-	struct device_attribute *a;
+	device_attribute_no_const *a;
 
 	sensor = devm_kzalloc(data->dev, sizeof(*sensor), GFP_KERNEL);
 	if (!sensor)
@@ -919,7 +919,7 @@ static int pmbus_add_label(struct pmbus_data *data,
 			   const char *lstring, int index)
 {
 	struct pmbus_label *label;
-	struct device_attribute *a;
+	device_attribute_no_const *a;
 
 	label = devm_kzalloc(data->dev, sizeof(*label), GFP_KERNEL);
 	if (!label)
diff --git a/drivers/hwmon/sht15.c b/drivers/hwmon/sht15.c
index a2fdbb7d2..e749a3cf3 100644
--- a/drivers/hwmon/sht15.c
+++ b/drivers/hwmon/sht15.c
@@ -170,7 +170,7 @@ struct sht15_data {
 	int				supply_uv;
 	bool				supply_uv_valid;
 	struct work_struct		update_supply_work;
-	atomic_t			interrupt_handled;
+	atomic_unchecked_t		interrupt_handled;
 };
 
 /**
@@ -530,13 +530,13 @@ static int sht15_measurement(struct sht15_data *data,
 	ret = gpio_direction_input(data->pdata->gpio_data);
 	if (ret)
 		return ret;
-	atomic_set(&data->interrupt_handled, 0);
+	atomic_set_unchecked(&data->interrupt_handled, 0);
 
 	enable_irq(gpio_to_irq(data->pdata->gpio_data));
 	if (gpio_get_value(data->pdata->gpio_data) == 0) {
 		disable_irq_nosync(gpio_to_irq(data->pdata->gpio_data));
 		/* Only relevant if the interrupt hasn't occurred. */
-		if (!atomic_read(&data->interrupt_handled))
+		if (!atomic_read_unchecked(&data->interrupt_handled))
 			schedule_work(&data->read_work);
 	}
 	ret = wait_event_timeout(data->wait_queue,
@@ -808,7 +808,7 @@ static irqreturn_t sht15_interrupt_fired(int irq, void *d)
 
 	/* First disable the interrupt */
 	disable_irq_nosync(irq);
-	atomic_inc(&data->interrupt_handled);
+	atomic_inc_unchecked(&data->interrupt_handled);
 	/* Then schedule a reading work struct */
 	if (data->state != SHT15_READING_NOTHING)
 		schedule_work(&data->read_work);
@@ -830,11 +830,11 @@ static void sht15_bh_read_data(struct work_struct *work_s)
 		 * If not, then start the interrupt again - care here as could
 		 * have gone low in meantime so verify it hasn't!
 		 */
-		atomic_set(&data->interrupt_handled, 0);
+		atomic_set_unchecked(&data->interrupt_handled, 0);
 		enable_irq(gpio_to_irq(data->pdata->gpio_data));
 		/* If still not occurred or another handler was scheduled */
 		if (gpio_get_value(data->pdata->gpio_data)
-		    || atomic_read(&data->interrupt_handled))
+		    || atomic_read_unchecked(&data->interrupt_handled))
 			return;
 	}
 
diff --git a/drivers/hwmon/via-cputemp.c b/drivers/hwmon/via-cputemp.c
index ac91c07e3..8e6966306 100644
--- a/drivers/hwmon/via-cputemp.c
+++ b/drivers/hwmon/via-cputemp.c
@@ -295,7 +295,7 @@ static int via_cputemp_cpu_callback(struct notifier_block *nfb,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block via_cputemp_cpu_notifier __refdata = {
+static struct notifier_block via_cputemp_cpu_notifier = {
 	.notifier_call = via_cputemp_cpu_callback,
 };
 
diff --git a/drivers/i2c/busses/i2c-amd756-s4882.c b/drivers/i2c/busses/i2c-amd756-s4882.c
index 65e324054..e6c511d8a 100644
--- a/drivers/i2c/busses/i2c-amd756-s4882.c
+++ b/drivers/i2c/busses/i2c-amd756-s4882.c
@@ -39,7 +39,7 @@
 extern struct i2c_adapter amd756_smbus;
 
 static struct i2c_adapter *s4882_adapter;
-static struct i2c_algorithm *s4882_algo;
+static i2c_algorithm_no_const *s4882_algo;
 
 /* Wrapper access functions for multiplexed SMBus */
 static DEFINE_MUTEX(amd756_lock);
diff --git a/drivers/i2c/busses/i2c-designware-pcidrv.c b/drivers/i2c/busses/i2c-designware-pcidrv.c
index 96f8230cd..73d7616b3 100644
--- a/drivers/i2c/busses/i2c-designware-pcidrv.c
+++ b/drivers/i2c/busses/i2c-designware-pcidrv.c
@@ -57,7 +57,7 @@ struct dw_scl_sda_cfg {
 };
 
 struct dw_pci_controller {
-	u32 bus_num;
+	int bus_num;
 	u32 bus_cfg;
 	u32 tx_fifo_depth;
 	u32 rx_fifo_depth;
diff --git a/drivers/i2c/busses/i2c-nforce2-s4985.c b/drivers/i2c/busses/i2c-nforce2-s4985.c
index 88eda09e7..cf40434e4 100644
--- a/drivers/i2c/busses/i2c-nforce2-s4985.c
+++ b/drivers/i2c/busses/i2c-nforce2-s4985.c
@@ -37,7 +37,7 @@
 extern struct i2c_adapter *nforce2_smbus;
 
 static struct i2c_adapter *s4985_adapter;
-static struct i2c_algorithm *s4985_algo;
+static i2c_algorithm_no_const *s4985_algo;
 
 /* Wrapper access functions for multiplexed SMBus */
 static DEFINE_MUTEX(nforce2_lock);
diff --git a/drivers/i2c/i2c-dev.c b/drivers/i2c/i2c-dev.c
index 66f323fd3..af5b5737a 100644
--- a/drivers/i2c/i2c-dev.c
+++ b/drivers/i2c/i2c-dev.c
@@ -274,7 +274,7 @@ static noinline int i2cdev_ioctl_rdwr(struct i2c_client *client,
 			break;
 		}
 
-		data_ptrs[i] = (u8 __user *)rdwr_pa[i].buf;
+		data_ptrs[i] = (u8 __force_user *)rdwr_pa[i].buf;
 		rdwr_pa[i].buf = memdup_user(data_ptrs[i], rdwr_pa[i].len);
 		if (IS_ERR(rdwr_pa[i].buf)) {
 			res = PTR_ERR(rdwr_pa[i].buf);
diff --git a/drivers/ide/ide-cd.c b/drivers/ide/ide-cd.c
index bf9a2ad29..a54b1c4d4 100644
--- a/drivers/ide/ide-cd.c
+++ b/drivers/ide/ide-cd.c
@@ -768,7 +768,7 @@ static void cdrom_do_block_pc(ide_drive_t *drive, struct request *rq)
 		alignment = queue_dma_alignment(q) | q->dma_pad_mask;
 		if ((unsigned long)buf & alignment
 		    || blk_rq_bytes(rq) & q->dma_pad_mask
-		    || object_is_on_stack(buf))
+		    || object_starts_on_stack(buf))
 			drive->dma = 0;
 	}
 }
diff --git a/drivers/ide/ide-disk.c b/drivers/ide/ide-disk.c
index 83679da0c..6e67e4ff3 100644
--- a/drivers/ide/ide-disk.c
+++ b/drivers/ide/ide-disk.c
@@ -178,7 +178,7 @@ static ide_startstop_t __ide_do_rw_disk(ide_drive_t *drive, struct request *rq,
  * 1073741822 == 549756 MB or 48bit addressing fake drive
  */
 
-static ide_startstop_t ide_do_rw_disk(ide_drive_t *drive, struct request *rq,
+static ide_startstop_t __intentional_overflow(-1) ide_do_rw_disk(ide_drive_t *drive, struct request *rq,
 				      sector_t block)
 {
 	ide_hwif_t *hwif = drive->hwif;
diff --git a/drivers/ide/ide.c b/drivers/ide/ide.c
index d127ace6a..6ee866fcc 100644
--- a/drivers/ide/ide.c
+++ b/drivers/ide/ide.c
@@ -244,7 +244,7 @@ struct chs_geom {
 static unsigned int ide_disks;
 static struct chs_geom ide_disks_chs[MAX_HWIFS * MAX_DRIVES];
 
-static int ide_set_disk_chs(const char *str, struct kernel_param *kp)
+static int ide_set_disk_chs(const char *str, const struct kernel_param *kp)
 {
 	unsigned int a, b, c = 0, h = 0, s = 0, i, j = 1;
 
@@ -328,7 +328,7 @@ static void ide_dev_apply_params(ide_drive_t *drive, u8 unit)
 
 static unsigned int ide_ignore_cable;
 
-static int ide_set_ignore_cable(const char *s, struct kernel_param *kp)
+static int ide_set_ignore_cable(const char *s, const struct kernel_param *kp)
 {
 	int i, j = 1;
 
diff --git a/drivers/idle/intel_idle.c b/drivers/idle/intel_idle.c
index 67ec58f9e..0a78c7855 100644
--- a/drivers/idle/intel_idle.c
+++ b/drivers/idle/intel_idle.c
@@ -1208,36 +1208,46 @@ static void bxt_idle_state_table_update(void)
 	rdmsrl(MSR_PKGC6_IRTL, msr);
 	usec = irtl_2_usec(msr);
 	if (usec) {
-		bxt_cstates[2].exit_latency = usec;
-		bxt_cstates[2].target_residency = usec;
+		pax_open_kernel();
+		const_cast(bxt_cstates[2].exit_latency) = usec;
+		const_cast(bxt_cstates[2].target_residency) = usec;
+		pax_close_kernel();
 	}
 
 	rdmsrl(MSR_PKGC7_IRTL, msr);
 	usec = irtl_2_usec(msr);
 	if (usec) {
-		bxt_cstates[3].exit_latency = usec;
-		bxt_cstates[3].target_residency = usec;
+		pax_open_kernel();
+		const_cast(bxt_cstates[3].exit_latency) = usec;
+		const_cast(bxt_cstates[3].target_residency) = usec;
+		pax_close_kernel();
 	}
 
 	rdmsrl(MSR_PKGC8_IRTL, msr);
 	usec = irtl_2_usec(msr);
 	if (usec) {
-		bxt_cstates[4].exit_latency = usec;
-		bxt_cstates[4].target_residency = usec;
+		pax_open_kernel();
+		const_cast(bxt_cstates[4].exit_latency) = usec;
+		const_cast(bxt_cstates[4].target_residency) = usec;
+		pax_close_kernel();
 	}
 
 	rdmsrl(MSR_PKGC9_IRTL, msr);
 	usec = irtl_2_usec(msr);
 	if (usec) {
-		bxt_cstates[5].exit_latency = usec;
-		bxt_cstates[5].target_residency = usec;
+		pax_open_kernel();
+		const_cast(bxt_cstates[5].exit_latency) = usec;
+		const_cast(bxt_cstates[5].target_residency) = usec;
+		pax_close_kernel();
 	}
 
 	rdmsrl(MSR_PKGC10_IRTL, msr);
 	usec = irtl_2_usec(msr);
 	if (usec) {
-		bxt_cstates[6].exit_latency = usec;
-		bxt_cstates[6].target_residency = usec;
+		pax_open_kernel();
+		const_cast(bxt_cstates[6].exit_latency) = usec;
+		const_cast(bxt_cstates[6].target_residency) = usec;
+		pax_close_kernel();
 	}
 
 }
@@ -1280,8 +1290,10 @@ static void sklh_idle_state_table_update(void)
 			return;
 	}
 
-	skl_cstates[5].disabled = 1;	/* C8-SKL */
-	skl_cstates[6].disabled = 1;	/* C9-SKL */
+	pax_open_kernel();
+	const_cast(skl_cstates[5].disabled) = 1;	/* C8-SKL */
+	const_cast(skl_cstates[6].disabled) = 1;	/* C9-SKL */
+	pax_close_kernel();
 }
 /*
  * intel_idle_state_table_update()
diff --git a/drivers/iio/industrialio-core.c b/drivers/iio/industrialio-core.c
index d2b889918..5b0e8f58f 100644
--- a/drivers/iio/industrialio-core.c
+++ b/drivers/iio/industrialio-core.c
@@ -769,7 +769,7 @@ static ssize_t iio_write_channel_info(struct device *dev,
 }
 
 static
-int __iio_device_attr_init(struct device_attribute *dev_attr,
+int __iio_device_attr_init(device_attribute_no_const *dev_attr,
 			   const char *postfix,
 			   struct iio_chan_spec const *chan,
 			   ssize_t (*readfunc)(struct device *dev,
diff --git a/drivers/infiniband/core/cm.c b/drivers/infiniband/core/cm.c
index 71c7c4c32..f91d896f8 100644
--- a/drivers/infiniband/core/cm.c
+++ b/drivers/infiniband/core/cm.c
@@ -117,7 +117,7 @@ static char const counter_group_names[CM_COUNTER_GROUPS]
 
 struct cm_counter_group {
 	struct kobject obj;
-	atomic_long_t counter[CM_ATTR_COUNT];
+	atomic_long_unchecked_t counter[CM_ATTR_COUNT];
 };
 
 struct cm_counter_attribute {
@@ -1495,7 +1495,7 @@ static void cm_format_mra(struct cm_mra_msg *mra_msg,
 static void cm_format_rej(struct cm_rej_msg *rej_msg,
 			  struct cm_id_private *cm_id_priv,
 			  enum ib_cm_rej_reason reason,
-			  void *ari,
+			  const void *ari,
 			  u8 ari_length,
 			  const void *private_data,
 			  u8 private_data_len)
@@ -1539,7 +1539,7 @@ static void cm_dup_req_handler(struct cm_work *work,
 	struct ib_mad_send_buf *msg = NULL;
 	int ret;
 
-	atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+	atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 			counter[CM_REQ_COUNTER]);
 
 	/* Quick state check to discard duplicate REQs. */
@@ -1949,7 +1949,7 @@ static void cm_dup_rep_handler(struct cm_work *work)
 	if (!cm_id_priv)
 		return;
 
-	atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+	atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 			counter[CM_REP_COUNTER]);
 	ret = cm_alloc_response_msg(work->port, work->mad_recv_wc, &msg);
 	if (ret)
@@ -2116,7 +2116,7 @@ static int cm_rtu_handler(struct cm_work *work)
 	if (cm_id_priv->id.state != IB_CM_REP_SENT &&
 	    cm_id_priv->id.state != IB_CM_MRA_REP_RCVD) {
 		spin_unlock_irq(&cm_id_priv->lock);
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_RTU_COUNTER]);
 		goto out;
 	}
@@ -2299,7 +2299,7 @@ static int cm_dreq_handler(struct cm_work *work)
 	cm_id_priv = cm_acquire_id(dreq_msg->remote_comm_id,
 				   dreq_msg->local_comm_id);
 	if (!cm_id_priv) {
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_DREQ_COUNTER]);
 		cm_issue_drep(work->port, work->mad_recv_wc);
 		return -EINVAL;
@@ -2324,7 +2324,7 @@ static int cm_dreq_handler(struct cm_work *work)
 	case IB_CM_MRA_REP_RCVD:
 		break;
 	case IB_CM_TIMEWAIT:
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_DREQ_COUNTER]);
 		if (cm_alloc_response_msg(work->port, work->mad_recv_wc, &msg))
 			goto unlock;
@@ -2338,7 +2338,7 @@ static int cm_dreq_handler(struct cm_work *work)
 			cm_free_msg(msg);
 		goto deref;
 	case IB_CM_DREQ_RCVD:
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_DREQ_COUNTER]);
 		goto unlock;
 	default:
@@ -2401,12 +2401,13 @@ out:
 }
 
 int ib_send_cm_rej(struct ib_cm_id *cm_id,
-		   enum ib_cm_rej_reason reason,
-		   void *ari,
+		   int _reason,
+		   const void *ari,
 		   u8 ari_length,
 		   const void *private_data,
 		   u8 private_data_len)
 {
+	enum ib_cm_rej_reason reason = _reason;
 	struct cm_id_private *cm_id_priv;
 	struct ib_mad_send_buf *msg;
 	unsigned long flags;
@@ -2705,7 +2706,7 @@ static int cm_mra_handler(struct cm_work *work)
 		    ib_modify_mad(cm_id_priv->av.port->mad_agent,
 				  cm_id_priv->msg, timeout)) {
 			if (cm_id_priv->id.lap_state == IB_CM_MRA_LAP_RCVD)
-				atomic_long_inc(&work->port->
+				atomic_long_inc_unchecked(&work->port->
 						counter_group[CM_RECV_DUPLICATES].
 						counter[CM_MRA_COUNTER]);
 			goto out;
@@ -2714,7 +2715,7 @@ static int cm_mra_handler(struct cm_work *work)
 		break;
 	case IB_CM_MRA_REQ_RCVD:
 	case IB_CM_MRA_REP_RCVD:
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_MRA_COUNTER]);
 		/* fall through */
 	default:
@@ -2877,7 +2878,7 @@ static int cm_lap_handler(struct cm_work *work)
 	case IB_CM_LAP_IDLE:
 		break;
 	case IB_CM_MRA_LAP_SENT:
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_LAP_COUNTER]);
 		if (cm_alloc_response_msg(work->port, work->mad_recv_wc, &msg))
 			goto unlock;
@@ -2893,7 +2894,7 @@ static int cm_lap_handler(struct cm_work *work)
 			cm_free_msg(msg);
 		goto deref;
 	case IB_CM_LAP_RCVD:
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_LAP_COUNTER]);
 		goto unlock;
 	default:
@@ -2926,7 +2927,7 @@ deref:	cm_deref_id(cm_id_priv);
 static void cm_format_apr(struct cm_apr_msg *apr_msg,
 			  struct cm_id_private *cm_id_priv,
 			  enum ib_cm_apr_status status,
-			  void *info,
+			  const void *info,
 			  u8 info_length,
 			  const void *private_data,
 			  u8 private_data_len)
@@ -2946,12 +2947,13 @@ static void cm_format_apr(struct cm_apr_msg *apr_msg,
 }
 
 int ib_send_cm_apr(struct ib_cm_id *cm_id,
-		   enum ib_cm_apr_status status,
-		   void *info,
+		   int _status,
+		   const void *info,
 		   u8 info_length,
 		   const void *private_data,
 		   u8 private_data_len)
 {
+	enum ib_cm_apr_status status = _status;
 	struct cm_id_private *cm_id_priv;
 	struct ib_mad_send_buf *msg;
 	unsigned long flags;
@@ -3180,7 +3182,7 @@ static int cm_sidr_req_handler(struct cm_work *work)
 	cur_cm_id_priv = cm_insert_remote_sidr(cm_id_priv);
 	if (cur_cm_id_priv) {
 		spin_unlock_irq(&cm.lock);
-		atomic_long_inc(&work->port->counter_group[CM_RECV_DUPLICATES].
+		atomic_long_inc_unchecked(&work->port->counter_group[CM_RECV_DUPLICATES].
 				counter[CM_SIDR_REQ_COUNTER]);
 		goto out; /* Duplicate message. */
 	}
@@ -3394,10 +3396,10 @@ static void cm_send_handler(struct ib_mad_agent *mad_agent,
 	if (!msg->context[0] && (attr_index != CM_REJ_COUNTER))
 		msg->retries = 1;
 
-	atomic_long_add(1 + msg->retries,
+	atomic_long_add_unchecked(1 + msg->retries,
 			&port->counter_group[CM_XMIT].counter[attr_index]);
 	if (msg->retries)
-		atomic_long_add(msg->retries,
+		atomic_long_add_unchecked(msg->retries,
 				&port->counter_group[CM_XMIT_RETRIES].
 				counter[attr_index]);
 
@@ -3633,7 +3635,7 @@ static void cm_recv_handler(struct ib_mad_agent *mad_agent,
 	}
 
 	attr_id = be16_to_cpu(mad_recv_wc->recv_buf.mad->mad_hdr.attr_id);
-	atomic_long_inc(&port->counter_group[CM_RECV].
+	atomic_long_inc_unchecked(&port->counter_group[CM_RECV].
 			counter[attr_id - CM_ATTR_ID_OFFSET]);
 
 	work = kmalloc(sizeof *work + sizeof(struct ib_sa_path_rec) * paths,
@@ -3840,7 +3842,7 @@ static ssize_t cm_show_counter(struct kobject *obj, struct attribute *attr,
 	cm_attr = container_of(attr, struct cm_counter_attribute, attr);
 
 	return sprintf(buf, "%ld\n",
-		       atomic_long_read(&group->counter[cm_attr->index]));
+		       atomic_long_read_unchecked(&group->counter[cm_attr->index]));
 }
 
 static const struct sysfs_ops cm_counter_ops = {
diff --git a/drivers/infiniband/core/fmr_pool.c b/drivers/infiniband/core/fmr_pool.c
index cdbb1f1a6..7ed4277c7 100644
--- a/drivers/infiniband/core/fmr_pool.c
+++ b/drivers/infiniband/core/fmr_pool.c
@@ -98,8 +98,8 @@ struct ib_fmr_pool {
 
 	struct task_struct       *thread;
 
-	atomic_t                  req_ser;
-	atomic_t                  flush_ser;
+	atomic_unchecked_t        req_ser;
+	atomic_unchecked_t        flush_ser;
 
 	wait_queue_head_t         force_wait;
 };
@@ -179,10 +179,10 @@ static int ib_fmr_cleanup_thread(void *pool_ptr)
 	struct ib_fmr_pool *pool = pool_ptr;
 
 	do {
-		if (atomic_read(&pool->flush_ser) - atomic_read(&pool->req_ser) < 0) {
+		if (atomic_read_unchecked(&pool->flush_ser) - atomic_read_unchecked(&pool->req_ser) < 0) {
 			ib_fmr_batch_release(pool);
 
-			atomic_inc(&pool->flush_ser);
+			atomic_inc_unchecked(&pool->flush_ser);
 			wake_up_interruptible(&pool->force_wait);
 
 			if (pool->flush_function)
@@ -190,7 +190,7 @@ static int ib_fmr_cleanup_thread(void *pool_ptr)
 		}
 
 		set_current_state(TASK_INTERRUPTIBLE);
-		if (atomic_read(&pool->flush_ser) - atomic_read(&pool->req_ser) >= 0 &&
+		if (atomic_read_unchecked(&pool->flush_ser) - atomic_read_unchecked(&pool->req_ser) >= 0 &&
 		    !kthread_should_stop())
 			schedule();
 		__set_current_state(TASK_RUNNING);
@@ -262,8 +262,8 @@ struct ib_fmr_pool *ib_create_fmr_pool(struct ib_pd             *pd,
 	pool->dirty_watermark = params->dirty_watermark;
 	pool->dirty_len       = 0;
 	spin_lock_init(&pool->pool_lock);
-	atomic_set(&pool->req_ser,   0);
-	atomic_set(&pool->flush_ser, 0);
+	atomic_set_unchecked(&pool->req_ser,   0);
+	atomic_set_unchecked(&pool->flush_ser, 0);
 	init_waitqueue_head(&pool->force_wait);
 
 	pool->thread = kthread_run(ib_fmr_cleanup_thread,
@@ -388,11 +388,11 @@ int ib_flush_fmr_pool(struct ib_fmr_pool *pool)
 	}
 	spin_unlock_irq(&pool->pool_lock);
 
-	serial = atomic_inc_return(&pool->req_ser);
+	serial = atomic_inc_return_unchecked(&pool->req_ser);
 	wake_up_process(pool->thread);
 
 	if (wait_event_interruptible(pool->force_wait,
-				     atomic_read(&pool->flush_ser) - serial >= 0))
+				     atomic_read_unchecked(&pool->flush_ser) - serial >= 0))
 		return -EINTR;
 
 	return 0;
@@ -502,7 +502,7 @@ int ib_fmr_pool_unmap(struct ib_pool_fmr *fmr)
 		} else {
 			list_add_tail(&fmr->list, &pool->dirty_list);
 			if (++pool->dirty_len >= pool->dirty_watermark) {
-				atomic_inc(&pool->req_ser);
+				atomic_inc_unchecked(&pool->req_ser);
 				wake_up_process(pool->thread);
 			}
 		}
diff --git a/drivers/infiniband/core/netlink.c b/drivers/infiniband/core/netlink.c
index 10469b008..e8b45f36e 100644
--- a/drivers/infiniband/core/netlink.c
+++ b/drivers/infiniband/core/netlink.c
@@ -176,11 +176,10 @@ static int ibnl_rcv_msg(struct sk_buff *skb, struct nlmsghdr *nlh)
 			}
 
 			{
-				struct netlink_dump_control c = {
+				netlink_dump_control_no_const c = {
 					.dump = client->cb_table[op].dump,
-					.module = client->cb_table[op].module,
 				};
-				return netlink_dump_start(nls, skb, nlh, &c);
+				return __netlink_dump_start(nls, skb, nlh, &c, NULL, client->cb_table[op].module);
 			}
 		}
 	}
diff --git a/drivers/infiniband/core/sysfs.c b/drivers/infiniband/core/sysfs.c
index 15defefec..9cd7c283d 100644
--- a/drivers/infiniband/core/sysfs.c
+++ b/drivers/infiniband/core/sysfs.c
@@ -894,7 +894,7 @@ static struct attribute *alloc_hsa_lifespan(char *name, u8 port_num)
 static void setup_hw_stats(struct ib_device *device, struct ib_port *port,
 			   u8 port_num)
 {
-	struct attribute_group *hsag;
+	attribute_group_no_const *hsag;
 	struct rdma_hw_stats *stats;
 	int i, ret;
 
diff --git a/drivers/infiniband/core/ucm.c b/drivers/infiniband/core/ucm.c
index 7713ef089..0bb2981b9 100644
--- a/drivers/infiniband/core/ucm.c
+++ b/drivers/infiniband/core/ucm.c
@@ -920,14 +920,14 @@ static ssize_t ib_ucm_send_rej(struct ib_ucm_file *file,
 			       const char __user *inbuf,
 			       int in_len, int out_len)
 {
-	return ib_ucm_send_info(file, inbuf, in_len, (void *)ib_send_cm_rej);
+	return ib_ucm_send_info(file, inbuf, in_len, ib_send_cm_rej);
 }
 
 static ssize_t ib_ucm_send_apr(struct ib_ucm_file *file,
 			       const char __user *inbuf,
 			       int in_len, int out_len)
 {
-	return ib_ucm_send_info(file, inbuf, in_len, (void *)ib_send_cm_apr);
+	return ib_ucm_send_info(file, inbuf, in_len, ib_send_cm_apr);
 }
 
 static ssize_t ib_ucm_send_mra(struct ib_ucm_file *file,
diff --git a/drivers/infiniband/core/uverbs_cmd.c b/drivers/infiniband/core/uverbs_cmd.c
index f66473181..b46744fd0 100644
--- a/drivers/infiniband/core/uverbs_cmd.c
+++ b/drivers/infiniband/core/uverbs_cmd.c
@@ -974,6 +974,9 @@ ssize_t ib_uverbs_reg_mr(struct ib_uverbs_file *file,
 	if (copy_from_user(&cmd, buf, sizeof cmd))
 		return -EFAULT;
 
+	if (!access_ok_noprefault(VERIFY_READ, cmd.start, cmd.length))
+		return -EFAULT;
+
 	INIT_UDATA(&udata, buf + sizeof cmd,
 		   (unsigned long) cmd.response + sizeof resp,
 		   in_len - sizeof cmd, out_len - sizeof resp);
diff --git a/drivers/infiniband/hw/cxgb4/device.c b/drivers/infiniband/hw/cxgb4/device.c
index 3c4b2126e..bf4f82b66 100644
--- a/drivers/infiniband/hw/cxgb4/device.c
+++ b/drivers/infiniband/hw/cxgb4/device.c
@@ -111,7 +111,7 @@ void c4iw_log_wr_stats(struct t4_wq *wq, struct t4_cqe *cqe)
 	if (!wq->rdev->wr_log)
 		return;
 
-	idx = (atomic_inc_return(&wq->rdev->wr_log_idx) - 1) &
+	idx = (atomic_inc_return_unchecked(&wq->rdev->wr_log_idx) - 1) &
 		(wq->rdev->wr_log_size - 1);
 	le.poll_sge_ts = cxgb4_read_sge_timestamp(wq->rdev->lldi.ports[0]);
 	getnstimeofday(&le.poll_host_ts);
@@ -143,7 +143,7 @@ static int wr_log_show(struct seq_file *seq, void *v)
 
 #define ts2ns(ts) div64_u64((ts) * dev->rdev.lldi.cclk_ps, 1000)
 
-	idx = atomic_read(&dev->rdev.wr_log_idx) &
+	idx = atomic_read_unchecked(&dev->rdev.wr_log_idx) &
 		(dev->rdev.wr_log_size - 1);
 	end = idx - 1;
 	if (end < 0)
@@ -840,7 +840,7 @@ static int c4iw_rdev_open(struct c4iw_rdev *rdev)
 				       sizeof(*rdev->wr_log), GFP_KERNEL);
 		if (rdev->wr_log) {
 			rdev->wr_log_size = 1 << c4iw_wr_log_size_order;
-			atomic_set(&rdev->wr_log_idx, 0);
+			atomic_set_unchecked(&rdev->wr_log_idx, 0);
 		} else {
 			pr_err(MOD "error allocating wr_log. Logging disabled\n");
 		}
diff --git a/drivers/infiniband/hw/cxgb4/iw_cxgb4.h b/drivers/infiniband/hw/cxgb4/iw_cxgb4.h
index 4b83b84f7..7d402e0c4 100644
--- a/drivers/infiniband/hw/cxgb4/iw_cxgb4.h
+++ b/drivers/infiniband/hw/cxgb4/iw_cxgb4.h
@@ -180,7 +180,7 @@ struct c4iw_rdev {
 	struct c4iw_stats stats;
 	struct c4iw_hw_queue hw_queue;
 	struct t4_dev_status_page *status_page;
-	atomic_t wr_log_idx;
+	atomic_unchecked_t wr_log_idx;
 	struct wr_log_entry *wr_log;
 	int wr_log_size;
 };
diff --git a/drivers/infiniband/hw/cxgb4/mem.c b/drivers/infiniband/hw/cxgb4/mem.c
index 0b91b0f4d..866b3b927 100644
--- a/drivers/infiniband/hw/cxgb4/mem.c
+++ b/drivers/infiniband/hw/cxgb4/mem.c
@@ -266,7 +266,7 @@ static int write_tpt_entry(struct c4iw_rdev *rdev, u32 reset_tpt_entry,
 	int err;
 	struct fw_ri_tpte tpt;
 	u32 stag_idx;
-	static atomic_t key;
+	static atomic_unchecked_t key;
 
 	if (c4iw_fatal_error(rdev))
 		return -EIO;
@@ -287,7 +287,7 @@ static int write_tpt_entry(struct c4iw_rdev *rdev, u32 reset_tpt_entry,
 		if (rdev->stats.stag.cur > rdev->stats.stag.max)
 			rdev->stats.stag.max = rdev->stats.stag.cur;
 		mutex_unlock(&rdev->stats.lock);
-		*stag = (stag_idx << 8) | (atomic_inc_return(&key) & 0xff);
+		*stag = (stag_idx << 8) | (atomic_inc_return_unchecked(&key) & 0xff);
 	}
 	PDBG("%s stag_state 0x%0x type 0x%0x pdid 0x%0x, stag_idx 0x%x\n",
 	     __func__, stag_state, type, pdid, stag_idx);
diff --git a/drivers/infiniband/hw/hfi1/pcie.c b/drivers/infiniband/hw/hfi1/pcie.c
index 89c68da1c..addb2adc9 100644
--- a/drivers/infiniband/hw/hfi1/pcie.c
+++ b/drivers/infiniband/hw/hfi1/pcie.c
@@ -537,7 +537,7 @@ static void tune_pcie_caps(struct hfi1_devdata *dd)
  * PCI error infrastructure, registered via pci
  */
 static pci_ers_result_t
-pci_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+pci_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct hfi1_devdata *dd = pci_get_drvdata(pdev);
 	pci_ers_result_t ret = PCI_ERS_RESULT_RECOVERED;
diff --git a/drivers/infiniband/hw/i40iw/i40iw_ctrl.c b/drivers/infiniband/hw/i40iw/i40iw_ctrl.c
index 2c4b4d072..b45e806b3 100644
--- a/drivers/infiniband/hw/i40iw/i40iw_ctrl.c
+++ b/drivers/infiniband/hw/i40iw/i40iw_ctrl.c
@@ -4604,46 +4604,46 @@ static void i40iw_hw_stat_refresh_all(struct i40iw_dev_pestat *devstat)
 }
 
 static struct i40iw_cqp_ops iw_cqp_ops = {
-	i40iw_sc_cqp_init,
-	i40iw_sc_cqp_create,
-	i40iw_sc_cqp_post_sq,
-	i40iw_sc_cqp_get_next_send_wqe,
-	i40iw_sc_cqp_destroy,
-	i40iw_sc_poll_for_cqp_op_done
+	.cqp_init = i40iw_sc_cqp_init,
+	.cqp_create = i40iw_sc_cqp_create,
+	.cqp_post_sq = i40iw_sc_cqp_post_sq,
+	.cqp_get_next_send_wqe = i40iw_sc_cqp_get_next_send_wqe,
+	.cqp_destroy = i40iw_sc_cqp_destroy,
+	.poll_for_cqp_op_done = i40iw_sc_poll_for_cqp_op_done
 };
 
 static struct i40iw_ccq_ops iw_ccq_ops = {
-	i40iw_sc_ccq_init,
-	i40iw_sc_ccq_create,
-	i40iw_sc_ccq_destroy,
-	i40iw_sc_ccq_create_done,
-	i40iw_sc_ccq_get_cqe_info,
-	i40iw_sc_ccq_arm
+	.ccq_init = i40iw_sc_ccq_init,
+	.ccq_create = i40iw_sc_ccq_create,
+	.ccq_destroy = i40iw_sc_ccq_destroy,
+	.ccq_create_done = i40iw_sc_ccq_create_done,
+	.ccq_get_cqe_info = i40iw_sc_ccq_get_cqe_info,
+	.ccq_arm = i40iw_sc_ccq_arm
 };
 
 static struct i40iw_ceq_ops iw_ceq_ops = {
-	i40iw_sc_ceq_init,
-	i40iw_sc_ceq_create,
-	i40iw_sc_cceq_create_done,
-	i40iw_sc_cceq_destroy_done,
-	i40iw_sc_cceq_create,
-	i40iw_sc_ceq_destroy,
-	i40iw_sc_process_ceq
+	.ceq_init = i40iw_sc_ceq_init,
+	.ceq_create = i40iw_sc_ceq_create,
+	.cceq_create_done = i40iw_sc_cceq_create_done,
+	.cceq_destroy_done = i40iw_sc_cceq_destroy_done,
+	.cceq_create = i40iw_sc_cceq_create,
+	.ceq_destroy = i40iw_sc_ceq_destroy,
+	.process_ceq = i40iw_sc_process_ceq
 };
 
 static struct i40iw_aeq_ops iw_aeq_ops = {
-	i40iw_sc_aeq_init,
-	i40iw_sc_aeq_create,
-	i40iw_sc_aeq_destroy,
-	i40iw_sc_get_next_aeqe,
-	i40iw_sc_repost_aeq_entries,
-	i40iw_sc_aeq_create_done,
-	i40iw_sc_aeq_destroy_done
+	.aeq_init = i40iw_sc_aeq_init,
+	.aeq_create = i40iw_sc_aeq_create,
+	.aeq_destroy = i40iw_sc_aeq_destroy,
+	.get_next_aeqe = i40iw_sc_get_next_aeqe,
+	.repost_aeq_entries = i40iw_sc_repost_aeq_entries,
+	.aeq_create_done = i40iw_sc_aeq_create_done,
+	.aeq_destroy_done = i40iw_sc_aeq_destroy_done
 };
 
 /* iwarp pd ops */
 static struct i40iw_pd_ops iw_pd_ops = {
-	i40iw_sc_pd_init,
+	.pd_init = i40iw_sc_pd_init,
 };
 
 static struct i40iw_priv_qp_ops iw_priv_qp_ops = {
@@ -4662,61 +4662,59 @@ static struct i40iw_priv_qp_ops iw_priv_qp_ops = {
 };
 
 static struct i40iw_priv_cq_ops iw_priv_cq_ops = {
-	i40iw_sc_cq_init,
-	i40iw_sc_cq_create,
-	i40iw_sc_cq_destroy,
-	i40iw_sc_cq_modify,
+	.cq_init = i40iw_sc_cq_init,
+	.cq_create = i40iw_sc_cq_create,
+	.cq_destroy = i40iw_sc_cq_destroy,
+	.cq_modify = i40iw_sc_cq_modify,
 };
 
 static struct i40iw_mr_ops iw_mr_ops = {
-	i40iw_sc_alloc_stag,
-	i40iw_sc_mr_reg_non_shared,
-	i40iw_sc_mr_reg_shared,
-	i40iw_sc_dealloc_stag,
-	i40iw_sc_query_stag,
-	i40iw_sc_mw_alloc
+	.alloc_stag = i40iw_sc_alloc_stag,
+	.mr_reg_non_shared = i40iw_sc_mr_reg_non_shared,
+	.mr_reg_shared = i40iw_sc_mr_reg_shared,
+	.dealloc_stag = i40iw_sc_dealloc_stag,
+	.query_stag = i40iw_sc_query_stag,
+	.mw_alloc = i40iw_sc_mw_alloc
 };
 
 static struct i40iw_cqp_misc_ops iw_cqp_misc_ops = {
-	i40iw_sc_manage_push_page,
-	i40iw_sc_manage_hmc_pm_func_table,
-	i40iw_sc_set_hmc_resource_profile,
-	i40iw_sc_commit_fpm_values,
-	i40iw_sc_query_fpm_values,
-	i40iw_sc_static_hmc_pages_allocated,
-	i40iw_sc_add_arp_cache_entry,
-	i40iw_sc_del_arp_cache_entry,
-	i40iw_sc_query_arp_cache_entry,
-	i40iw_sc_manage_apbvt_entry,
-	i40iw_sc_manage_qhash_table_entry,
-	i40iw_sc_alloc_local_mac_ipaddr_entry,
-	i40iw_sc_add_local_mac_ipaddr_entry,
-	i40iw_sc_del_local_mac_ipaddr_entry,
-	i40iw_sc_cqp_nop,
-	i40iw_sc_commit_fpm_values_done,
-	i40iw_sc_query_fpm_values_done,
-	i40iw_sc_manage_hmc_pm_func_table_done,
-	i40iw_sc_suspend_qp,
-	i40iw_sc_resume_qp
+	.manage_push_page = i40iw_sc_manage_push_page,
+	.manage_hmc_pm_func_table = i40iw_sc_manage_hmc_pm_func_table,
+	.set_hmc_resource_profile = i40iw_sc_set_hmc_resource_profile,
+	.commit_fpm_values = i40iw_sc_commit_fpm_values,
+	.query_fpm_values = i40iw_sc_query_fpm_values,
+	.static_hmc_pages_allocated = i40iw_sc_static_hmc_pages_allocated,
+	.add_arp_cache_entry = i40iw_sc_add_arp_cache_entry,
+	.del_arp_cache_entry = i40iw_sc_del_arp_cache_entry,
+	.query_arp_cache_entry = i40iw_sc_query_arp_cache_entry,
+	.manage_apbvt_entry = i40iw_sc_manage_apbvt_entry,
+	.manage_qhash_table_entry = i40iw_sc_manage_qhash_table_entry,
+	.alloc_local_mac_ipaddr_table_entry = i40iw_sc_alloc_local_mac_ipaddr_entry,
+	.add_local_mac_ipaddr_entry = i40iw_sc_add_local_mac_ipaddr_entry,
+	.del_local_mac_ipaddr_entry = i40iw_sc_del_local_mac_ipaddr_entry,
+	.cqp_nop = i40iw_sc_cqp_nop,
+	.commit_fpm_values_done = i40iw_sc_commit_fpm_values_done,
+	.query_fpm_values_done = i40iw_sc_query_fpm_values_done,
+	.manage_hmc_pm_func_table_done = i40iw_sc_manage_hmc_pm_func_table_done,
+	.update_suspend_qp = i40iw_sc_suspend_qp,
+	.update_resume_qp = i40iw_sc_resume_qp
 };
 
 static struct i40iw_hmc_ops iw_hmc_ops = {
-	i40iw_sc_init_iw_hmc,
-	i40iw_sc_parse_fpm_query_buf,
-	i40iw_sc_configure_iw_fpm,
-	i40iw_sc_parse_fpm_commit_buf,
-	i40iw_sc_create_hmc_obj,
-	i40iw_sc_del_hmc_obj,
-	NULL,
-	NULL
+	.init_iw_hmc = i40iw_sc_init_iw_hmc,
+	.parse_fpm_query_buf = i40iw_sc_parse_fpm_query_buf,
+	.configure_iw_fpm = i40iw_sc_configure_iw_fpm,
+	.parse_fpm_commit_buf = i40iw_sc_parse_fpm_commit_buf,
+	.create_hmc_object = i40iw_sc_create_hmc_obj,
+	.del_hmc_object = i40iw_sc_del_hmc_obj
 };
 
 static const struct i40iw_device_pestat_ops iw_device_pestat_ops = {
-	i40iw_hw_stat_init,
-	i40iw_hw_stat_read_32,
-	i40iw_hw_stat_read_64,
-	i40iw_hw_stat_read_all,
-	i40iw_hw_stat_refresh_all
+	.iw_hw_stat_init = i40iw_hw_stat_init,
+	.iw_hw_stat_read_32 = i40iw_hw_stat_read_32,
+	.iw_hw_stat_read_64 = i40iw_hw_stat_read_64,
+	.iw_hw_stat_read_all = i40iw_hw_stat_read_all,
+	.iw_hw_stat_refresh_all = i40iw_hw_stat_refresh_all
 };
 
 /**
diff --git a/drivers/infiniband/hw/i40iw/i40iw_uk.c b/drivers/infiniband/hw/i40iw/i40iw_uk.c
index 4d28c3cb0..ec6b0b77f 100644
--- a/drivers/infiniband/hw/i40iw/i40iw_uk.c
+++ b/drivers/infiniband/hw/i40iw/i40iw_uk.c
@@ -919,29 +919,29 @@ enum i40iw_status_code i40iw_get_wqe_shift(u32 wqdepth, u32 sge, u32 inline_data
 }
 
 static struct i40iw_qp_uk_ops iw_qp_uk_ops = {
-	i40iw_qp_post_wr,
-	i40iw_qp_ring_push_db,
-	i40iw_rdma_write,
-	i40iw_rdma_read,
-	i40iw_send,
-	i40iw_inline_rdma_write,
-	i40iw_inline_send,
-	i40iw_stag_local_invalidate,
-	i40iw_mw_bind,
-	i40iw_post_receive,
-	i40iw_nop
+	.iw_qp_post_wr = i40iw_qp_post_wr,
+	.iw_qp_ring_push_db = i40iw_qp_ring_push_db,
+	.iw_rdma_write = i40iw_rdma_write,
+	.iw_rdma_read = i40iw_rdma_read,
+	.iw_send = i40iw_send,
+	.iw_inline_rdma_write = i40iw_inline_rdma_write,
+	.iw_inline_send = i40iw_inline_send,
+	.iw_stag_local_invalidate = i40iw_stag_local_invalidate,
+	.iw_mw_bind = i40iw_mw_bind,
+	.iw_post_receive = i40iw_post_receive,
+	.iw_post_nop = i40iw_nop
 };
 
 static struct i40iw_cq_ops iw_cq_ops = {
-	i40iw_cq_request_notification,
-	i40iw_cq_poll_completion,
-	i40iw_cq_post_entries,
-	i40iw_clean_cq
+	.iw_cq_request_notification = i40iw_cq_request_notification,
+	.iw_cq_poll_completion = i40iw_cq_poll_completion,
+	.iw_cq_post_entries = i40iw_cq_post_entries,
+	.iw_cq_clean = i40iw_clean_cq
 };
 
 static struct i40iw_device_uk_ops iw_device_uk_ops = {
-	i40iw_cq_uk_init,
-	i40iw_qp_uk_init,
+	.iwarp_cq_uk_init = i40iw_cq_uk_init,
+	.iwarp_qp_uk_init = i40iw_qp_uk_init,
 };
 
 /**
diff --git a/drivers/infiniband/hw/i40iw/i40iw_user.h b/drivers/infiniband/hw/i40iw/i40iw_user.h
index 276bcefff..b2e368422 100644
--- a/drivers/infiniband/hw/i40iw/i40iw_user.h
+++ b/drivers/infiniband/hw/i40iw/i40iw_user.h
@@ -343,7 +343,7 @@ struct i40iw_device_uk_ops {
 
 struct i40iw_dev_uk {
 	struct i40iw_device_uk_ops ops_uk;
-};
+} __no_const;
 
 struct i40iw_sq_uk_wr_trk_info {
 	u64 wrid;
diff --git a/drivers/infiniband/hw/mlx4/mad.c b/drivers/infiniband/hw/mlx4/mad.c
index 0f21c3a25..257e0a7af 100644
--- a/drivers/infiniband/hw/mlx4/mad.c
+++ b/drivers/infiniband/hw/mlx4/mad.c
@@ -99,7 +99,7 @@ __be64 mlx4_ib_gen_node_guid(void)
 
 __be64 mlx4_ib_get_new_demux_tid(struct mlx4_ib_demux_ctx *ctx)
 {
-	return cpu_to_be64(atomic_inc_return(&ctx->tid)) |
+	return cpu_to_be64(atomic_inc_return_unchecked(&ctx->tid)) |
 		cpu_to_be64(0xff00000000000000LL);
 }
 
diff --git a/drivers/infiniband/hw/mlx4/mcg.c b/drivers/infiniband/hw/mlx4/mcg.c
index 097bfcc4e..06fe83a03 100644
--- a/drivers/infiniband/hw/mlx4/mcg.c
+++ b/drivers/infiniband/hw/mlx4/mcg.c
@@ -1043,7 +1043,7 @@ int mlx4_ib_mcg_port_init(struct mlx4_ib_demux_ctx *ctx)
 {
 	char name[20];
 
-	atomic_set(&ctx->tid, 0);
+	atomic_set_unchecked(&ctx->tid, 0);
 	sprintf(name, "mlx4_ib_mcg%d", ctx->port);
 	ctx->mcg_wq = create_singlethread_workqueue(name);
 	if (!ctx->mcg_wq)
diff --git a/drivers/infiniband/hw/mlx4/mlx4_ib.h b/drivers/infiniband/hw/mlx4/mlx4_ib.h
index 686ab48ff..736a1d771 100644
--- a/drivers/infiniband/hw/mlx4/mlx4_ib.h
+++ b/drivers/infiniband/hw/mlx4/mlx4_ib.h
@@ -457,7 +457,7 @@ struct mlx4_ib_demux_ctx {
 	struct list_head	mcg_mgid0_list;
 	struct workqueue_struct	*mcg_wq;
 	struct mlx4_ib_demux_pv_ctx **tun;
-	atomic_t tid;
+	atomic_unchecked_t tid;
 	int    flushing; /* flushing the work queue */
 };
 
diff --git a/drivers/infiniband/hw/mthca/mthca_cmd.c b/drivers/infiniband/hw/mthca/mthca_cmd.c
index c7f49bbb0..6a021bb80 100644
--- a/drivers/infiniband/hw/mthca/mthca_cmd.c
+++ b/drivers/infiniband/hw/mthca/mthca_cmd.c
@@ -772,7 +772,7 @@ static void mthca_setup_cmd_doorbells(struct mthca_dev *dev, u64 base)
 	mthca_dbg(dev, "Mapped doorbell page for posting FW commands\n");
 }
 
-int mthca_QUERY_FW(struct mthca_dev *dev)
+int __intentional_overflow(-1) mthca_QUERY_FW(struct mthca_dev *dev)
 {
 	struct mthca_mailbox *mailbox;
 	u32 *outbox;
@@ -1612,7 +1612,7 @@ int mthca_HW2SW_MPT(struct mthca_dev *dev, struct mthca_mailbox *mailbox,
 			     CMD_TIME_CLASS_B);
 }
 
-int mthca_WRITE_MTT(struct mthca_dev *dev, struct mthca_mailbox *mailbox,
+int __intentional_overflow(-1) mthca_WRITE_MTT(struct mthca_dev *dev, struct mthca_mailbox *mailbox,
 		    int num_mtt)
 {
 	return mthca_cmd(dev, mailbox->dma, num_mtt, 0, CMD_WRITE_MTT,
@@ -1634,7 +1634,7 @@ int mthca_MAP_EQ(struct mthca_dev *dev, u64 event_mask, int unmap,
 			 0, CMD_MAP_EQ, CMD_TIME_CLASS_B);
 }
 
-int mthca_SW2HW_EQ(struct mthca_dev *dev, struct mthca_mailbox *mailbox,
+int __intentional_overflow(-1) mthca_SW2HW_EQ(struct mthca_dev *dev, struct mthca_mailbox *mailbox,
 		   int eq_num)
 {
 	return mthca_cmd(dev, mailbox->dma, eq_num, 0, CMD_SW2HW_EQ,
@@ -1857,7 +1857,7 @@ int mthca_CONF_SPECIAL_QP(struct mthca_dev *dev, int type, u32 qpn)
 			 CMD_TIME_CLASS_B);
 }
 
-int mthca_MAD_IFC(struct mthca_dev *dev, int ignore_mkey, int ignore_bkey,
+int __intentional_overflow(-1) mthca_MAD_IFC(struct mthca_dev *dev, int ignore_mkey, int ignore_bkey,
 		  int port, const struct ib_wc *in_wc, const struct ib_grh *in_grh,
 		  const void *in_mad, void *response_mad)
 {
diff --git a/drivers/infiniband/hw/mthca/mthca_main.c b/drivers/infiniband/hw/mthca/mthca_main.c
index ded76c101..0cf0a08c4 100644
--- a/drivers/infiniband/hw/mthca/mthca_main.c
+++ b/drivers/infiniband/hw/mthca/mthca_main.c
@@ -692,7 +692,7 @@ err_close:
 	return err;
 }
 
-static int mthca_setup_hca(struct mthca_dev *dev)
+static int __intentional_overflow(-1) mthca_setup_hca(struct mthca_dev *dev)
 {
 	int err;
 
diff --git a/drivers/infiniband/hw/mthca/mthca_mr.c b/drivers/infiniband/hw/mthca/mthca_mr.c
index ed9a989e5..6aa5dc2c6 100644
--- a/drivers/infiniband/hw/mthca/mthca_mr.c
+++ b/drivers/infiniband/hw/mthca/mthca_mr.c
@@ -81,7 +81,7 @@ struct mthca_mpt_entry {
  * through the bitmaps)
  */
 
-static u32 mthca_buddy_alloc(struct mthca_buddy *buddy, int order)
+static u32 __intentional_overflow(-1) mthca_buddy_alloc(struct mthca_buddy *buddy, int order)
 {
 	int o;
 	int m;
@@ -426,7 +426,7 @@ static inline u32 adjust_key(struct mthca_dev *dev, u32 key)
 		return key;
 }
 
-int mthca_mr_alloc(struct mthca_dev *dev, u32 pd, int buffer_size_shift,
+int __intentional_overflow(-1) mthca_mr_alloc(struct mthca_dev *dev, u32 pd, int buffer_size_shift,
 		   u64 iova, u64 total_size, u32 access, struct mthca_mr *mr)
 {
 	struct mthca_mailbox *mailbox;
@@ -516,7 +516,7 @@ int mthca_mr_alloc_notrans(struct mthca_dev *dev, u32 pd,
 	return mthca_mr_alloc(dev, pd, 12, 0, ~0ULL, access, mr);
 }
 
-int mthca_mr_alloc_phys(struct mthca_dev *dev, u32 pd,
+int __intentional_overflow(-1) mthca_mr_alloc_phys(struct mthca_dev *dev, u32 pd,
 			u64 *buffer_list, int buffer_size_shift,
 			int list_len, u64 iova, u64 total_size,
 			u32 access, struct mthca_mr *mr)
diff --git a/drivers/infiniband/hw/mthca/mthca_provider.c b/drivers/infiniband/hw/mthca/mthca_provider.c
index da2335f7f..d6f467762 100644
--- a/drivers/infiniband/hw/mthca/mthca_provider.c
+++ b/drivers/infiniband/hw/mthca/mthca_provider.c
@@ -772,7 +772,7 @@ unlock:
 	return 0;
 }
 
-static int mthca_resize_cq(struct ib_cq *ibcq, int entries, struct ib_udata *udata)
+static int __intentional_overflow(-1) mthca_resize_cq(struct ib_cq *ibcq, int entries, struct ib_udata *udata)
 {
 	struct mthca_dev *dev = to_mdev(ibcq->device);
 	struct mthca_cq *cq = to_mcq(ibcq);
diff --git a/drivers/infiniband/hw/nes/nes.c b/drivers/infiniband/hw/nes/nes.c
index 35cbb17be..d336a6834 100644
--- a/drivers/infiniband/hw/nes/nes.c
+++ b/drivers/infiniband/hw/nes/nes.c
@@ -97,7 +97,7 @@ MODULE_PARM_DESC(limit_maxrdreqsz, "Limit max read request size to 256 Bytes");
 LIST_HEAD(nes_adapter_list);
 static LIST_HEAD(nes_dev_list);
 
-atomic_t qps_destroyed;
+atomic_unchecked_t qps_destroyed;
 
 static unsigned int ee_flsh_adapter;
 static unsigned int sysfs_nonidx_addr;
@@ -268,7 +268,7 @@ static void nes_cqp_rem_ref_callback(struct nes_device *nesdev, struct nes_cqp_r
 	struct nes_qp *nesqp = cqp_request->cqp_callback_pointer;
 	struct nes_adapter *nesadapter = nesdev->nesadapter;
 
-	atomic_inc(&qps_destroyed);
+	atomic_inc_unchecked(&qps_destroyed);
 
 	/* Free the control structures */
 
diff --git a/drivers/infiniband/hw/nes/nes.h b/drivers/infiniband/hw/nes/nes.h
index bd9d132f1..70d84f412 100644
--- a/drivers/infiniband/hw/nes/nes.h
+++ b/drivers/infiniband/hw/nes/nes.h
@@ -180,17 +180,17 @@ extern unsigned int nes_debug_level;
 extern unsigned int wqm_quanta;
 extern struct list_head nes_adapter_list;
 
-extern atomic_t cm_connects;
-extern atomic_t cm_accepts;
-extern atomic_t cm_disconnects;
-extern atomic_t cm_closes;
-extern atomic_t cm_connecteds;
-extern atomic_t cm_connect_reqs;
-extern atomic_t cm_rejects;
-extern atomic_t mod_qp_timouts;
-extern atomic_t qps_created;
-extern atomic_t qps_destroyed;
-extern atomic_t sw_qps_destroyed;
+extern atomic_unchecked_t cm_connects;
+extern atomic_unchecked_t cm_accepts;
+extern atomic_unchecked_t cm_disconnects;
+extern atomic_unchecked_t cm_closes;
+extern atomic_unchecked_t cm_connecteds;
+extern atomic_unchecked_t cm_connect_reqs;
+extern atomic_unchecked_t cm_rejects;
+extern atomic_unchecked_t mod_qp_timouts;
+extern atomic_unchecked_t qps_created;
+extern atomic_unchecked_t qps_destroyed;
+extern atomic_unchecked_t sw_qps_destroyed;
 extern u32 mh_detected;
 extern u32 mh_pauses_sent;
 extern u32 cm_packets_sent;
@@ -199,16 +199,16 @@ extern u32 cm_packets_created;
 extern u32 cm_packets_received;
 extern u32 cm_packets_dropped;
 extern u32 cm_packets_retrans;
-extern atomic_t cm_listens_created;
-extern atomic_t cm_listens_destroyed;
+extern atomic_unchecked_t cm_listens_created;
+extern atomic_unchecked_t cm_listens_destroyed;
 extern u32 cm_backlog_drops;
-extern atomic_t cm_loopbacks;
-extern atomic_t cm_nodes_created;
-extern atomic_t cm_nodes_destroyed;
-extern atomic_t cm_accel_dropped_pkts;
-extern atomic_t cm_resets_recvd;
-extern atomic_t pau_qps_created;
-extern atomic_t pau_qps_destroyed;
+extern atomic_unchecked_t cm_loopbacks;
+extern atomic_unchecked_t cm_nodes_created;
+extern atomic_unchecked_t cm_nodes_destroyed;
+extern atomic_unchecked_t cm_accel_dropped_pkts;
+extern atomic_unchecked_t cm_resets_recvd;
+extern atomic_unchecked_t pau_qps_created;
+extern atomic_unchecked_t pau_qps_destroyed;
 
 extern u32 int_mod_timer_init;
 extern u32 int_mod_cq_depth_256;
diff --git a/drivers/infiniband/hw/nes/nes_cm.c b/drivers/infiniband/hw/nes/nes_cm.c
index 7f0aa23ae..3c2093998 100644
--- a/drivers/infiniband/hw/nes/nes_cm.c
+++ b/drivers/infiniband/hw/nes/nes_cm.c
@@ -69,14 +69,14 @@ u32 cm_packets_dropped;
 u32 cm_packets_retrans;
 u32 cm_packets_created;
 u32 cm_packets_received;
-atomic_t cm_listens_created;
-atomic_t cm_listens_destroyed;
+atomic_unchecked_t cm_listens_created;
+atomic_unchecked_t cm_listens_destroyed;
 u32 cm_backlog_drops;
-atomic_t cm_loopbacks;
-atomic_t cm_nodes_created;
-atomic_t cm_nodes_destroyed;
-atomic_t cm_accel_dropped_pkts;
-atomic_t cm_resets_recvd;
+atomic_unchecked_t cm_loopbacks;
+atomic_unchecked_t cm_nodes_created;
+atomic_unchecked_t cm_nodes_destroyed;
+atomic_unchecked_t cm_accel_dropped_pkts;
+atomic_unchecked_t cm_resets_recvd;
 
 static inline int mini_cm_accelerated(struct nes_cm_core *, struct nes_cm_node *);
 static struct nes_cm_listener *mini_cm_listen(struct nes_cm_core *, struct nes_vnic *, struct nes_cm_info *);
@@ -135,28 +135,28 @@ static void record_ird_ord(struct nes_cm_node *, u16, u16);
 /* instance of function pointers for client API */
 /* set address of this instance to cm_core->cm_ops at cm_core alloc */
 static const struct nes_cm_ops nes_cm_api = {
-	mini_cm_accelerated,
-	mini_cm_listen,
-	mini_cm_del_listen,
-	mini_cm_connect,
-	mini_cm_close,
-	mini_cm_accept,
-	mini_cm_reject,
-	mini_cm_recv_pkt,
-	mini_cm_dealloc_core,
-	mini_cm_get,
-	mini_cm_set
+	.accelerated = mini_cm_accelerated,
+	.listen = mini_cm_listen,
+	.stop_listener = mini_cm_del_listen,
+	.connect = mini_cm_connect,
+	.close = mini_cm_close,
+	.accept = mini_cm_accept,
+	.reject = mini_cm_reject,
+	.recv_pkt = mini_cm_recv_pkt,
+	.destroy_cm_core = mini_cm_dealloc_core,
+	.get = mini_cm_get,
+	.set = mini_cm_set
 };
 
 static struct nes_cm_core *g_cm_core;
 
-atomic_t cm_connects;
-atomic_t cm_accepts;
-atomic_t cm_disconnects;
-atomic_t cm_closes;
-atomic_t cm_connecteds;
-atomic_t cm_connect_reqs;
-atomic_t cm_rejects;
+atomic_unchecked_t cm_connects;
+atomic_unchecked_t cm_accepts;
+atomic_unchecked_t cm_disconnects;
+atomic_unchecked_t cm_closes;
+atomic_unchecked_t cm_connecteds;
+atomic_unchecked_t cm_connect_reqs;
+atomic_unchecked_t cm_rejects;
 
 int nes_add_ref_cm_node(struct nes_cm_node *cm_node)
 {
@@ -1333,7 +1333,7 @@ static int mini_cm_dec_refcnt_listen(struct nes_cm_core *cm_core,
 		kfree(listener);
 		listener = NULL;
 		ret = 0;
-		atomic_inc(&cm_listens_destroyed);
+		atomic_inc_unchecked(&cm_listens_destroyed);
 	} else {
 		spin_unlock_irqrestore(&cm_core->listen_list_lock, flags);
 	}
@@ -1537,7 +1537,7 @@ static struct nes_cm_node *make_cm_node(struct nes_cm_core *cm_core,
 		  cm_node->rem_mac);
 
 	add_hte_node(cm_core, cm_node);
-	atomic_inc(&cm_nodes_created);
+	atomic_inc_unchecked(&cm_nodes_created);
 
 	return cm_node;
 }
@@ -1596,7 +1596,7 @@ static int rem_ref_cm_node(struct nes_cm_core *cm_core,
 	}
 
 	atomic_dec(&cm_core->node_cnt);
-	atomic_inc(&cm_nodes_destroyed);
+	atomic_inc_unchecked(&cm_nodes_destroyed);
 	nesqp = cm_node->nesqp;
 	if (nesqp) {
 		nesqp->cm_node = NULL;
@@ -1660,7 +1660,7 @@ static int process_options(struct nes_cm_node *cm_node, u8 *optionsloc,
 
 static void drop_packet(struct sk_buff *skb)
 {
-	atomic_inc(&cm_accel_dropped_pkts);
+	atomic_inc_unchecked(&cm_accel_dropped_pkts);
 	dev_kfree_skb_any(skb);
 }
 
@@ -1723,7 +1723,7 @@ static void handle_rst_pkt(struct nes_cm_node *cm_node, struct sk_buff *skb,
 {
 
 	int	reset = 0;	/* whether to send reset in case of err.. */
-	atomic_inc(&cm_resets_recvd);
+	atomic_inc_unchecked(&cm_resets_recvd);
 	nes_debug(NES_DBG_CM, "Received Reset, cm_node = %p, state = %u."
 			" refcnt=%d\n", cm_node, cm_node->state,
 			atomic_read(&cm_node->ref_count));
@@ -2369,7 +2369,7 @@ static struct nes_cm_node *mini_cm_connect(struct nes_cm_core *cm_core,
 				rem_ref_cm_node(cm_node->cm_core, cm_node);
 				return NULL;
 			}
-			atomic_inc(&cm_loopbacks);
+			atomic_inc_unchecked(&cm_loopbacks);
 			loopbackremotenode->loopbackpartner = cm_node;
 			loopbackremotenode->tcp_cntxt.rcv_wscale =
 				NES_CM_DEFAULT_RCV_WND_SCALE;
@@ -2644,7 +2644,7 @@ static int mini_cm_recv_pkt(struct nes_cm_core *cm_core,
 				nes_queue_mgt_skbs(skb, nesvnic, cm_node->nesqp);
 			else {
 				rem_ref_cm_node(cm_core, cm_node);
-				atomic_inc(&cm_accel_dropped_pkts);
+				atomic_inc_unchecked(&cm_accel_dropped_pkts);
 				dev_kfree_skb_any(skb);
 			}
 			break;
@@ -2965,7 +2965,7 @@ static int nes_cm_disconn_true(struct nes_qp *nesqp)
 
 	if ((cm_id) && (cm_id->event_handler)) {
 		if (issue_disconn) {
-			atomic_inc(&cm_disconnects);
+			atomic_inc_unchecked(&cm_disconnects);
 			cm_event.event = IW_CM_EVENT_DISCONNECT;
 			cm_event.status = disconn_status;
 			cm_event.local_addr = cm_id->m_local_addr;
@@ -2987,7 +2987,7 @@ static int nes_cm_disconn_true(struct nes_qp *nesqp)
 		}
 
 		if (issue_close) {
-			atomic_inc(&cm_closes);
+			atomic_inc_unchecked(&cm_closes);
 			nes_disconnect(nesqp, 1);
 
 			cm_id->provider_data = nesqp;
@@ -3124,7 +3124,7 @@ int nes_accept(struct iw_cm_id *cm_id, struct iw_cm_conn_param *conn_param)
 
 	nes_debug(NES_DBG_CM, "QP%u, cm_node=%p, jiffies = %lu listener = %p\n",
 		nesqp->hwqp.qp_id, cm_node, jiffies, cm_node->listener);
-	atomic_inc(&cm_accepts);
+	atomic_inc_unchecked(&cm_accepts);
 
 	nes_debug(NES_DBG_CM, "netdev refcnt = %u.\n",
 			netdev_refcnt_read(nesvnic->netdev));
@@ -3320,7 +3320,7 @@ int nes_reject(struct iw_cm_id *cm_id, const void *pdata, u8 pdata_len)
 	struct nes_cm_core *cm_core;
 	u8 *start_buff;
 
-	atomic_inc(&cm_rejects);
+	atomic_inc_unchecked(&cm_rejects);
 	cm_node = (struct nes_cm_node *)cm_id->provider_data;
 	loopback = cm_node->loopbackpartner;
 	cm_core = cm_node->cm_core;
@@ -3382,7 +3382,7 @@ int nes_connect(struct iw_cm_id *cm_id, struct iw_cm_conn_param *conn_param)
 		  ntohs(raddr->sin_port), ntohl(laddr->sin_addr.s_addr),
 		  ntohs(laddr->sin_port));
 
-	atomic_inc(&cm_connects);
+	atomic_inc_unchecked(&cm_connects);
 	nesqp->active_conn = 1;
 
 	/* cache the cm_id in the qp */
@@ -3496,7 +3496,7 @@ int nes_create_listen(struct iw_cm_id *cm_id, int backlog)
 			g_cm_core->api->stop_listener(g_cm_core, (void *)cm_node);
 			return err;
 		}
-		atomic_inc(&cm_listens_created);
+		atomic_inc_unchecked(&cm_listens_created);
 	}
 
 	cm_id->add_ref(cm_id);
@@ -3603,7 +3603,7 @@ static void cm_event_connected(struct nes_cm_event *event)
 
 	if (nesqp->destroyed)
 		return;
-	atomic_inc(&cm_connecteds);
+	atomic_inc_unchecked(&cm_connecteds);
 	nes_debug(NES_DBG_CM, "QP%u attempting to connect to  0x%08X:0x%04X on"
 		  " local port 0x%04X. jiffies = %lu.\n",
 		  nesqp->hwqp.qp_id, ntohl(raddr->sin_addr.s_addr),
@@ -3788,7 +3788,7 @@ static void cm_event_reset(struct nes_cm_event *event)
 
 	cm_id->add_ref(cm_id);
 	ret = cm_id->event_handler(cm_id, &cm_event);
-	atomic_inc(&cm_closes);
+	atomic_inc_unchecked(&cm_closes);
 	cm_event.event = IW_CM_EVENT_CLOSE;
 	cm_event.status = 0;
 	cm_event.provider_data = cm_id->provider_data;
@@ -3828,7 +3828,7 @@ static void cm_event_mpa_req(struct nes_cm_event *event)
 		return;
 	cm_id = cm_node->cm_id;
 
-	atomic_inc(&cm_connect_reqs);
+	atomic_inc_unchecked(&cm_connect_reqs);
 	nes_debug(NES_DBG_CM, "cm_node = %p - cm_id = %p, jiffies = %lu\n",
 		  cm_node, cm_id, jiffies);
 
@@ -3877,7 +3877,7 @@ static void cm_event_mpa_reject(struct nes_cm_event *event)
 		return;
 	cm_id = cm_node->cm_id;
 
-	atomic_inc(&cm_connect_reqs);
+	atomic_inc_unchecked(&cm_connect_reqs);
 	nes_debug(NES_DBG_CM, "cm_node = %p - cm_id = %p, jiffies = %lu\n",
 		  cm_node, cm_id, jiffies);
 
diff --git a/drivers/infiniband/hw/nes/nes_mgt.c b/drivers/infiniband/hw/nes/nes_mgt.c
index 416645259..fc952c351 100644
--- a/drivers/infiniband/hw/nes/nes_mgt.c
+++ b/drivers/infiniband/hw/nes/nes_mgt.c
@@ -40,8 +40,8 @@
 #include "nes.h"
 #include "nes_mgt.h"
 
-atomic_t pau_qps_created;
-atomic_t pau_qps_destroyed;
+atomic_unchecked_t pau_qps_created;
+atomic_unchecked_t pau_qps_destroyed;
 
 static void nes_replenish_mgt_rq(struct nes_vnic_mgt *mgtvnic)
 {
@@ -621,7 +621,7 @@ void nes_destroy_pau_qp(struct nes_device *nesdev, struct nes_qp *nesqp)
 {
 	struct sk_buff *skb;
 	unsigned long flags;
-	atomic_inc(&pau_qps_destroyed);
+	atomic_inc_unchecked(&pau_qps_destroyed);
 
 	/* Free packets that have not yet been forwarded */
 	/* Lock is acquired by skb_dequeue when removing the skb */
@@ -810,7 +810,7 @@ static void nes_mgt_ce_handler(struct nes_device *nesdev, struct nes_hw_nic_cq *
 					cq->cq_vbase[head].cqe_words[NES_NIC_CQE_HASH_RCVNXT]);
 				skb_queue_head_init(&nesqp->pau_list);
 				spin_lock_init(&nesqp->pau_lock);
-				atomic_inc(&pau_qps_created);
+				atomic_inc_unchecked(&pau_qps_created);
 				nes_change_quad_hash(nesdev, mgtvnic->nesvnic, nesqp);
 			}
 
diff --git a/drivers/infiniband/hw/nes/nes_nic.c b/drivers/infiniband/hw/nes/nes_nic.c
index 2b27d1351..8f9d46c32 100644
--- a/drivers/infiniband/hw/nes/nes_nic.c
+++ b/drivers/infiniband/hw/nes/nes_nic.c
@@ -461,7 +461,7 @@ static bool nes_nic_send(struct sk_buff *skb, struct net_device *netdev)
 /**
  * nes_netdev_start_xmit
  */
-static int nes_netdev_start_xmit(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t nes_netdev_start_xmit(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct nes_vnic *nesvnic = netdev_priv(netdev);
 	struct nes_device *nesdev = nesvnic->nesdev;
@@ -1264,36 +1264,36 @@ static void nes_netdev_get_ethtool_stats(struct net_device *netdev,
 	target_stat_values[++index] = mh_detected;
 	target_stat_values[++index] = mh_pauses_sent;
 	target_stat_values[++index] = nesvnic->endnode_ipv4_tcp_retransmits;
-	target_stat_values[++index] = atomic_read(&cm_connects);
-	target_stat_values[++index] = atomic_read(&cm_accepts);
-	target_stat_values[++index] = atomic_read(&cm_disconnects);
-	target_stat_values[++index] = atomic_read(&cm_connecteds);
-	target_stat_values[++index] = atomic_read(&cm_connect_reqs);
-	target_stat_values[++index] = atomic_read(&cm_rejects);
-	target_stat_values[++index] = atomic_read(&mod_qp_timouts);
-	target_stat_values[++index] = atomic_read(&qps_created);
-	target_stat_values[++index] = atomic_read(&sw_qps_destroyed);
-	target_stat_values[++index] = atomic_read(&qps_destroyed);
-	target_stat_values[++index] = atomic_read(&cm_closes);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_connects);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_accepts);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_disconnects);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_connecteds);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_connect_reqs);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_rejects);
+	target_stat_values[++index] = atomic_read_unchecked(&mod_qp_timouts);
+	target_stat_values[++index] = atomic_read_unchecked(&qps_created);
+	target_stat_values[++index] = atomic_read_unchecked(&sw_qps_destroyed);
+	target_stat_values[++index] = atomic_read_unchecked(&qps_destroyed);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_closes);
 	target_stat_values[++index] = cm_packets_sent;
 	target_stat_values[++index] = cm_packets_bounced;
 	target_stat_values[++index] = cm_packets_created;
 	target_stat_values[++index] = cm_packets_received;
 	target_stat_values[++index] = cm_packets_dropped;
 	target_stat_values[++index] = cm_packets_retrans;
-	target_stat_values[++index] = atomic_read(&cm_listens_created);
-	target_stat_values[++index] = atomic_read(&cm_listens_destroyed);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_listens_created);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_listens_destroyed);
 	target_stat_values[++index] = cm_backlog_drops;
-	target_stat_values[++index] = atomic_read(&cm_loopbacks);
-	target_stat_values[++index] = atomic_read(&cm_nodes_created);
-	target_stat_values[++index] = atomic_read(&cm_nodes_destroyed);
-	target_stat_values[++index] = atomic_read(&cm_accel_dropped_pkts);
-	target_stat_values[++index] = atomic_read(&cm_resets_recvd);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_loopbacks);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_nodes_created);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_nodes_destroyed);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_accel_dropped_pkts);
+	target_stat_values[++index] = atomic_read_unchecked(&cm_resets_recvd);
 	target_stat_values[++index] = nesadapter->free_4kpbl;
 	target_stat_values[++index] = nesadapter->free_256pbl;
 	target_stat_values[++index] = int_mod_timer_init;
-	target_stat_values[++index] = atomic_read(&pau_qps_created);
-	target_stat_values[++index] = atomic_read(&pau_qps_destroyed);
+	target_stat_values[++index] = atomic_read_unchecked(&pau_qps_created);
+	target_stat_values[++index] = atomic_read_unchecked(&pau_qps_destroyed);
 }
 
 /**
diff --git a/drivers/infiniband/hw/nes/nes_verbs.c b/drivers/infiniband/hw/nes/nes_verbs.c
index bd6912573..10e85d54b 100644
--- a/drivers/infiniband/hw/nes/nes_verbs.c
+++ b/drivers/infiniband/hw/nes/nes_verbs.c
@@ -46,9 +46,9 @@
 
 #include <rdma/ib_umem.h>
 
-atomic_t mod_qp_timouts;
-atomic_t qps_created;
-atomic_t sw_qps_destroyed;
+atomic_unchecked_t mod_qp_timouts;
+atomic_unchecked_t qps_created;
+atomic_unchecked_t sw_qps_destroyed;
 
 static void nes_unregister_ofa_device(struct nes_ib_device *nesibdev);
 static int nes_dereg_mr(struct ib_mr *ib_mr);
@@ -1040,7 +1040,7 @@ static struct ib_qp *nes_create_qp(struct ib_pd *ibpd,
 	if (init_attr->create_flags)
 		return ERR_PTR(-EINVAL);
 
-	atomic_inc(&qps_created);
+	atomic_inc_unchecked(&qps_created);
 	switch (init_attr->qp_type) {
 		case IB_QPT_RC:
 			if (nes_drv_opt & NES_DRV_OPT_NO_INLINE_DATA) {
@@ -1376,7 +1376,7 @@ static int nes_destroy_qp(struct ib_qp *ibqp)
 	struct iw_cm_event cm_event;
 	int ret = 0;
 
-	atomic_inc(&sw_qps_destroyed);
+	atomic_inc_unchecked(&sw_qps_destroyed);
 	nesqp->destroyed = 1;
 
 	/* Blow away the connection if it exists. */
diff --git a/drivers/infiniband/hw/qib/qib_iba7322.c b/drivers/infiniband/hw/qib/qib_iba7322.c
index ce4034071..b21107686 100644
--- a/drivers/infiniband/hw/qib/qib_iba7322.c
+++ b/drivers/infiniband/hw/qib/qib_iba7322.c
@@ -150,7 +150,7 @@ static struct kparam_string kp_txselect = {
 	.string = txselect_list,
 	.maxlen = MAX_ATTEN_LEN
 };
-static int  setup_txselect(const char *, struct kernel_param *);
+static int  setup_txselect(const char *, const struct kernel_param *);
 module_param_call(txselect, setup_txselect, param_get_string,
 		  &kp_txselect, S_IWUSR | S_IRUGO);
 MODULE_PARM_DESC(txselect,
@@ -6177,7 +6177,7 @@ static void set_no_qsfp_atten(struct qib_devdata *dd, int change)
 }
 
 /* handle the txselect parameter changing */
-static int setup_txselect(const char *str, struct kernel_param *kp)
+static int setup_txselect(const char *str, const struct kernel_param *kp)
 {
 	struct qib_devdata *dd;
 	unsigned long val;
diff --git a/drivers/infiniband/hw/qib/qib_pcie.c b/drivers/infiniband/hw/qib/qib_pcie.c
index 6abe1c621..f866a3159 100644
--- a/drivers/infiniband/hw/qib/qib_pcie.c
+++ b/drivers/infiniband/hw/qib/qib_pcie.c
@@ -622,7 +622,7 @@ static void qib_tune_pcie_caps(struct qib_devdata *dd)
  * PCI error infrastructure, registered via pci
  */
 static pci_ers_result_t
-qib_pci_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+qib_pci_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct qib_devdata *dd = pci_get_drvdata(pdev);
 	pci_ers_result_t ret = PCI_ERS_RESULT_RECOVERED;
diff --git a/drivers/infiniband/sw/rxe/rxe_qp.c b/drivers/infiniband/sw/rxe/rxe_qp.c
index 979e44518..bd9986ef0 100644
--- a/drivers/infiniband/sw/rxe/rxe_qp.c
+++ b/drivers/infiniband/sw/rxe/rxe_qp.c
@@ -219,7 +219,7 @@ static void rxe_qp_init_misc(struct rxe_dev *rxe, struct rxe_qp *qp,
 	spin_lock_init(&qp->grp_lock);
 	spin_lock_init(&qp->state_lock);
 
-	atomic_set(&qp->ssn, 0);
+	atomic_set_unchecked(&qp->ssn, 0);
 	atomic_set(&qp->skb_out, 0);
 }
 
@@ -526,7 +526,7 @@ static void rxe_qp_reset(struct rxe_qp *qp)
 	}
 
 	/* cleanup attributes */
-	atomic_set(&qp->ssn, 0);
+	atomic_set_unchecked(&qp->ssn, 0);
 	qp->req.opcode = -1;
 	qp->req.need_retry = 0;
 	qp->req.noack_pkts = 0;
diff --git a/drivers/infiniband/sw/rxe/rxe_verbs.c b/drivers/infiniband/sw/rxe/rxe_verbs.c
index 4552be960..0c681252a 100644
--- a/drivers/infiniband/sw/rxe/rxe_verbs.c
+++ b/drivers/infiniband/sw/rxe/rxe_verbs.c
@@ -755,7 +755,7 @@ static int init_send_wqe(struct rxe_qp *qp, struct ib_send_wr *ibwr,
 	wqe->dma.cur_sge	= 0;
 	wqe->dma.sge_offset	= 0;
 	wqe->state		= wqe_state_posted;
-	wqe->ssn		= atomic_add_return(1, &qp->ssn);
+	wqe->ssn		= atomic_add_return_unchecked(1, &qp->ssn);
 
 	return 0;
 }
diff --git a/drivers/infiniband/sw/rxe/rxe_verbs.h b/drivers/infiniband/sw/rxe/rxe_verbs.h
index cac1d52a0..29bb90377 100644
--- a/drivers/infiniband/sw/rxe/rxe_verbs.h
+++ b/drivers/infiniband/sw/rxe/rxe_verbs.h
@@ -262,7 +262,7 @@ struct rxe_qp {
 	struct rxe_comp_info	comp;
 	struct rxe_resp_info	resp;
 
-	atomic_t		ssn;
+	atomic_unchecked_t	ssn;
 	atomic_t		skb_out;
 	int			need_req_skb;
 
diff --git a/drivers/infiniband/ulp/ipoib/ipoib_main.c b/drivers/infiniband/ulp/ipoib/ipoib_main.c
index 823a528ef..c8171f795 100644
--- a/drivers/infiniband/ulp/ipoib/ipoib_main.c
+++ b/drivers/infiniband/ulp/ipoib/ipoib_main.c
@@ -1029,7 +1029,7 @@ static void unicast_arp_send(struct sk_buff *skb, struct net_device *dev,
 	spin_unlock_irqrestore(&priv->lock, flags);
 }
 
-static int ipoib_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t ipoib_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct ipoib_dev_priv *priv = netdev_priv(dev);
 	struct ipoib_neigh *neigh;
diff --git a/drivers/infiniband/ulp/ipoib/ipoib_netlink.c b/drivers/infiniband/ulp/ipoib/ipoib_netlink.c
index cdc7df4fd..a2fdfdbc1 100644
--- a/drivers/infiniband/ulp/ipoib/ipoib_netlink.c
+++ b/drivers/infiniband/ulp/ipoib/ipoib_netlink.c
@@ -156,7 +156,7 @@ static size_t ipoib_get_size(const struct net_device *dev)
 		nla_total_size(2);	/* IFLA_IPOIB_UMCAST */
 }
 
-static struct rtnl_link_ops ipoib_link_ops __read_mostly = {
+static struct rtnl_link_ops ipoib_link_ops = {
 	.kind		= "ipoib",
 	.maxtype	= IFLA_IPOIB_MAX,
 	.policy		= ipoib_policy,
diff --git a/drivers/infiniband/ulp/srpt/ib_srpt.c b/drivers/infiniband/ulp/srpt/ib_srpt.c
index 883bbfe08..91c32be92 100644
--- a/drivers/infiniband/ulp/srpt/ib_srpt.c
+++ b/drivers/infiniband/ulp/srpt/ib_srpt.c
@@ -80,7 +80,7 @@ module_param(srpt_srq_size, int, 0444);
 MODULE_PARM_DESC(srpt_srq_size,
 		 "Shared receive queue (SRQ) size.");
 
-static int srpt_get_u64_x(char *buffer, struct kernel_param *kp)
+static int srpt_get_u64_x(char *buffer, const struct kernel_param *kp)
 {
 	return sprintf(buffer, "0x%016llx", *(u64 *)kp->arg);
 }
@@ -196,8 +196,9 @@ static const char *get_ch_state_name(enum rdma_ch_state s)
 /**
  * srpt_qp_event() - QP event callback function.
  */
-static void srpt_qp_event(struct ib_event *event, struct srpt_rdma_ch *ch)
+static void srpt_qp_event(struct ib_event *event, void *_ch)
 {
+	struct srpt_rdma_ch *ch = _ch;
 	pr_debug("QP event %d on cm_id=%p sess_name=%s state=%d\n",
 		 event->event, ch->cm_id, ch->sess_name, ch->state);
 
@@ -1628,8 +1629,7 @@ retry:
 	}
 
 	qp_init->qp_context = (void *)ch;
-	qp_init->event_handler
-		= (void(*)(struct ib_event *, void*))srpt_qp_event;
+	qp_init->event_handler = srpt_qp_event;
 	qp_init->send_cq = ch->cq;
 	qp_init->recv_cq = ch->cq;
 	qp_init->srq = sdev->srq;
diff --git a/drivers/input/evdev.c b/drivers/input/evdev.c
index e9ae3d500..96e494006 100644
--- a/drivers/input/evdev.c
+++ b/drivers/input/evdev.c
@@ -997,7 +997,7 @@ static int evdev_set_mask(struct evdev_client *client,
 	if (!cnt)
 		return 0;
 
-	mask = kcalloc(sizeof(unsigned long), BITS_TO_LONGS(cnt), GFP_KERNEL);
+	mask = kcalloc(BITS_TO_LONGS(cnt), sizeof(unsigned long), GFP_KERNEL);
 	if (!mask)
 		return -ENOMEM;
 
diff --git a/drivers/input/gameport/gameport.c b/drivers/input/gameport/gameport.c
index 4a2a9e370..b9261a79e 100644
--- a/drivers/input/gameport/gameport.c
+++ b/drivers/input/gameport/gameport.c
@@ -527,14 +527,14 @@ EXPORT_SYMBOL(gameport_set_phys);
  */
 static void gameport_init_port(struct gameport *gameport)
 {
-	static atomic_t gameport_no = ATOMIC_INIT(-1);
+	static atomic_unchecked_t gameport_no = ATOMIC_INIT(-1);
 
 	__module_get(THIS_MODULE);
 
 	mutex_init(&gameport->drv_mutex);
 	device_initialize(&gameport->dev);
 	dev_set_name(&gameport->dev, "gameport%lu",
-			(unsigned long)atomic_inc_return(&gameport_no));
+			(unsigned long)atomic_inc_return_unchecked(&gameport_no));
 	gameport->dev.bus = &gameport_bus;
 	gameport->dev.release = gameport_release_port;
 	if (gameport->parent)
diff --git a/drivers/input/input.c b/drivers/input/input.c
index d95c34ee5..2a6da5f1f 100644
--- a/drivers/input/input.c
+++ b/drivers/input/input.c
@@ -1780,7 +1780,7 @@ EXPORT_SYMBOL_GPL(input_class);
  */
 struct input_dev *input_allocate_device(void)
 {
-	static atomic_t input_no = ATOMIC_INIT(-1);
+	static atomic_unchecked_t input_no = ATOMIC_INIT(-1);
 	struct input_dev *dev;
 
 	dev = kzalloc(sizeof(struct input_dev), GFP_KERNEL);
@@ -1795,7 +1795,7 @@ struct input_dev *input_allocate_device(void)
 		INIT_LIST_HEAD(&dev->node);
 
 		dev_set_name(&dev->dev, "input%lu",
-			     (unsigned long)atomic_inc_return(&input_no));
+			     (unsigned long)atomic_inc_return_unchecked(&input_no));
 
 		__module_get(THIS_MODULE);
 	}
diff --git a/drivers/input/joystick/sidewinder.c b/drivers/input/joystick/sidewinder.c
index 4a95b2241..874c182af 100644
--- a/drivers/input/joystick/sidewinder.c
+++ b/drivers/input/joystick/sidewinder.c
@@ -30,6 +30,7 @@
 #include <linux/kernel.h>
 #include <linux/module.h>
 #include <linux/slab.h>
+#include <linux/sched.h>
 #include <linux/input.h>
 #include <linux/gameport.h>
 #include <linux/jiffies.h>
diff --git a/drivers/input/misc/ims-pcu.c b/drivers/input/misc/ims-pcu.c
index f47851868..e80d65272 100644
--- a/drivers/input/misc/ims-pcu.c
+++ b/drivers/input/misc/ims-pcu.c
@@ -1855,7 +1855,7 @@ static int ims_pcu_identify_type(struct ims_pcu *pcu, u8 *device_id)
 
 static int ims_pcu_init_application_mode(struct ims_pcu *pcu)
 {
-	static atomic_t device_no = ATOMIC_INIT(-1);
+	static atomic_unchecked_t device_no = ATOMIC_INIT(-1);
 
 	const struct ims_pcu_device_info *info;
 	int error;
@@ -1886,7 +1886,7 @@ static int ims_pcu_init_application_mode(struct ims_pcu *pcu)
 	}
 
 	/* Device appears to be operable, complete initialization */
-	pcu->device_no = atomic_inc_return(&device_no);
+	pcu->device_no = atomic_inc_return_unchecked(&device_no);
 
 	/*
 	 * PCU-B devices, both GEN_1 and GEN_2 do not have OFN sensor
diff --git a/drivers/input/mouse/psmouse.h b/drivers/input/mouse/psmouse.h
index e0ca6cda3..b5a26815e 100644
--- a/drivers/input/mouse/psmouse.h
+++ b/drivers/input/mouse/psmouse.h
@@ -126,7 +126,7 @@ struct psmouse_attribute {
 	ssize_t (*set)(struct psmouse *psmouse, void *data,
 			const char *buf, size_t count);
 	bool protect;
-};
+} __do_const;
 #define to_psmouse_attr(a)	container_of((a), struct psmouse_attribute, dattr)
 
 ssize_t psmouse_attr_show_helper(struct device *dev, struct device_attribute *attr,
diff --git a/drivers/input/mousedev.c b/drivers/input/mousedev.c
index b604564de..3f14ae4f5 100644
--- a/drivers/input/mousedev.c
+++ b/drivers/input/mousedev.c
@@ -744,7 +744,7 @@ static ssize_t mousedev_read(struct file *file, char __user *buffer,
 
 	spin_unlock_irq(&client->packet_lock);
 
-	if (copy_to_user(buffer, data, count))
+	if (count > sizeof(data) || copy_to_user(buffer, data, count))
 		return -EFAULT;
 
 	return count;
diff --git a/drivers/input/serio/serio.c b/drivers/input/serio/serio.c
index 1ca7f551e..25626076f 100644
--- a/drivers/input/serio/serio.c
+++ b/drivers/input/serio/serio.c
@@ -512,7 +512,7 @@ static void serio_release_port(struct device *dev)
  */
 static void serio_init_port(struct serio *serio)
 {
-	static atomic_t serio_no = ATOMIC_INIT(-1);
+	static atomic_unchecked_t serio_no = ATOMIC_INIT(-1);
 
 	__module_get(THIS_MODULE);
 
@@ -523,7 +523,7 @@ static void serio_init_port(struct serio *serio)
 	mutex_init(&serio->drv_mutex);
 	device_initialize(&serio->dev);
 	dev_set_name(&serio->dev, "serio%lu",
-		     (unsigned long)atomic_inc_return(&serio_no));
+		     (unsigned long)atomic_inc_return_unchecked(&serio_no));
 	serio->dev.bus = &serio_bus;
 	serio->dev.release = serio_release_port;
 	serio->dev.groups = serio_device_attr_groups;
diff --git a/drivers/input/serio/serio_raw.c b/drivers/input/serio/serio_raw.c
index 71ef5d65a..93380a96a 100644
--- a/drivers/input/serio/serio_raw.c
+++ b/drivers/input/serio/serio_raw.c
@@ -292,7 +292,7 @@ static irqreturn_t serio_raw_interrupt(struct serio *serio, unsigned char data,
 
 static int serio_raw_connect(struct serio *serio, struct serio_driver *drv)
 {
-	static atomic_t serio_raw_no = ATOMIC_INIT(-1);
+	static atomic_unchecked_t serio_raw_no = ATOMIC_INIT(-1);
 	struct serio_raw *serio_raw;
 	int err;
 
@@ -303,7 +303,7 @@ static int serio_raw_connect(struct serio *serio, struct serio_driver *drv)
 	}
 
 	snprintf(serio_raw->name, sizeof(serio_raw->name),
-		 "serio_raw%ld", (long)atomic_inc_return(&serio_raw_no));
+		 "serio_raw%ld", (long)atomic_inc_return_unchecked(&serio_raw_no));
 	kref_init(&serio_raw->kref);
 	INIT_LIST_HEAD(&serio_raw->client_list);
 	init_waitqueue_head(&serio_raw->wait);
diff --git a/drivers/input/touchscreen/htcpen.c b/drivers/input/touchscreen/htcpen.c
index 92e2243fb..8fd909285 100644
--- a/drivers/input/touchscreen/htcpen.c
+++ b/drivers/input/touchscreen/htcpen.c
@@ -219,7 +219,7 @@ static struct isa_driver htcpen_isa_driver = {
 	}
 };
 
-static struct dmi_system_id htcshift_dmi_table[] __initdata = {
+static const struct dmi_system_id htcshift_dmi_table[] __initconst = {
 	{
 		.ident = "Shift",
 		.matches = {
diff --git a/drivers/iommu/amd_iommu.c b/drivers/iommu/amd_iommu.c
index 822fc4afa..759e092db 100644
--- a/drivers/iommu/amd_iommu.c
+++ b/drivers/iommu/amd_iommu.c
@@ -791,11 +791,21 @@ static void copy_cmd_to_buffer(struct amd_iommu *iommu,
 
 static void build_completion_wait(struct iommu_cmd *cmd, u64 address)
 {
+	phys_addr_t physaddr;
 	WARN_ON(address & 0x7ULL);
 
 	memset(cmd, 0, sizeof(*cmd));
-	cmd->data[0] = lower_32_bits(__pa(address)) | CMD_COMPL_WAIT_STORE_MASK;
-	cmd->data[1] = upper_32_bits(__pa(address));
+
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	if (object_starts_on_stack((void *)address)) {
+		void *adjbuf = (void *)address - current->stack + current->lowmem_stack;
+		physaddr = __pa((u64)adjbuf);
+	} else
+#endif
+	physaddr = __pa(address);
+
+	cmd->data[0] = lower_32_bits(physaddr) | CMD_COMPL_WAIT_STORE_MASK;
+	cmd->data[1] = upper_32_bits(physaddr);
 	cmd->data[2] = 1;
 	CMD_SET_TYPE(cmd, CMD_COMPL_WAIT);
 }
@@ -940,15 +950,13 @@ static void build_inv_irt(struct iommu_cmd *cmd, u16 devid)
  * Writes the command to the IOMMUs command buffer and informs the
  * hardware about the new command.
  */
-static int iommu_queue_command_sync(struct amd_iommu *iommu,
-				    struct iommu_cmd *cmd,
-				    bool sync)
+static int __iommu_queue_command_sync(struct amd_iommu *iommu,
+				      struct iommu_cmd *cmd,
+				      bool sync)
 {
 	u32 left, tail, head, next_tail;
-	unsigned long flags;
 
 again:
-	spin_lock_irqsave(&iommu->lock, flags);
 
 	head      = readl(iommu->mmio_base + MMIO_CMD_HEAD_OFFSET);
 	tail      = readl(iommu->mmio_base + MMIO_CMD_TAIL_OFFSET);
@@ -957,15 +965,14 @@ again:
 
 	if (left <= 2) {
 		struct iommu_cmd sync_cmd;
-		volatile u64 sem = 0;
 		int ret;
 
-		build_completion_wait(&sync_cmd, (u64)&sem);
-		copy_cmd_to_buffer(iommu, &sync_cmd, tail);
+		iommu->cmd_sem = 0;
 
-		spin_unlock_irqrestore(&iommu->lock, flags);
+		build_completion_wait(&sync_cmd, (u64)&iommu->cmd_sem);
+		copy_cmd_to_buffer(iommu, &sync_cmd, tail);
 
-		if ((ret = wait_on_sem(&sem)) != 0)
+		if ((ret = wait_on_sem(&iommu->cmd_sem)) != 0)
 			return ret;
 
 		goto again;
@@ -976,9 +983,21 @@ again:
 	/* We need to sync now to make sure all commands are processed */
 	iommu->need_sync = sync;
 
+	return 0;
+}
+
+static int iommu_queue_command_sync(struct amd_iommu *iommu,
+				    struct iommu_cmd *cmd,
+				    bool sync)
+{
+	unsigned long flags;
+	int ret;
+
+	spin_lock_irqsave(&iommu->lock, flags);
+	ret = __iommu_queue_command_sync(iommu, cmd, sync);
 	spin_unlock_irqrestore(&iommu->lock, flags);
 
-	return 0;
+	return ret;
 }
 
 static int iommu_queue_command(struct amd_iommu *iommu, struct iommu_cmd *cmd)
@@ -993,19 +1012,29 @@ static int iommu_queue_command(struct amd_iommu *iommu, struct iommu_cmd *cmd)
 static int iommu_completion_wait(struct amd_iommu *iommu)
 {
 	struct iommu_cmd cmd;
-	volatile u64 sem = 0;
+	unsigned long flags;
 	int ret;
 
 	if (!iommu->need_sync)
 		return 0;
 
-	build_completion_wait(&cmd, (u64)&sem);
 
-	ret = iommu_queue_command_sync(iommu, &cmd, false);
+	build_completion_wait(&cmd, (u64)&iommu->cmd_sem);
+
+	spin_lock_irqsave(&iommu->lock, flags);
+
+	iommu->cmd_sem = 0;
+
+	ret = __iommu_queue_command_sync(iommu, &cmd, false);
 	if (ret)
-		return ret;
+		goto out_unlock;
+
+	ret = wait_on_sem(&iommu->cmd_sem);
 
-	return wait_on_sem(&sem);
+out_unlock:
+	spin_unlock_irqrestore(&iommu->lock, flags);
+
+	return ret;
 }
 
 static int iommu_flush_dte(struct amd_iommu *iommu, u16 devid)
diff --git a/drivers/iommu/amd_iommu_types.h b/drivers/iommu/amd_iommu_types.h
index caf5e3822..9652848e3 100644
--- a/drivers/iommu/amd_iommu_types.h
+++ b/drivers/iommu/amd_iommu_types.h
@@ -524,6 +524,8 @@ struct amd_iommu {
 	struct irq_domain *ir_domain;
 	struct irq_domain *msi_domain;
 #endif
+
+	volatile u64 __aligned(8) cmd_sem;
 };
 
 #define ACPIHID_UID_LEN 256
diff --git a/drivers/iommu/arm-smmu-v3.c b/drivers/iommu/arm-smmu-v3.c
index 641e88761..df73c18ed 100644
--- a/drivers/iommu/arm-smmu-v3.c
+++ b/drivers/iommu/arm-smmu-v3.c
@@ -626,7 +626,7 @@ struct arm_smmu_domain {
 	struct arm_smmu_device		*smmu;
 	struct mutex			init_mutex; /* Protects smmu pointer */
 
-	struct io_pgtable_ops		*pgtbl_ops;
+	struct io_pgtable		*pgtbl;
 	spinlock_t			pgtbl_lock;
 
 	enum arm_smmu_domain_stage	stage;
@@ -1448,7 +1448,7 @@ static void arm_smmu_domain_free(struct iommu_domain *domain)
 	struct arm_smmu_device *smmu = smmu_domain->smmu;
 
 	iommu_put_dma_cookie(domain);
-	free_io_pgtable_ops(smmu_domain->pgtbl_ops);
+	free_io_pgtable(smmu_domain->pgtbl);
 
 	/* Free the CD and ASID, if we allocated them */
 	if (smmu_domain->stage == ARM_SMMU_DOMAIN_S1) {
@@ -1526,7 +1526,7 @@ static int arm_smmu_domain_finalise(struct iommu_domain *domain)
 	unsigned long ias, oas;
 	enum io_pgtable_fmt fmt;
 	struct io_pgtable_cfg pgtbl_cfg;
-	struct io_pgtable_ops *pgtbl_ops;
+	struct io_pgtable *iop;
 	int (*finalise_stage_fn)(struct arm_smmu_domain *,
 				 struct io_pgtable_cfg *);
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
@@ -1564,16 +1564,16 @@ static int arm_smmu_domain_finalise(struct iommu_domain *domain)
 		.iommu_dev	= smmu->dev,
 	};
 
-	pgtbl_ops = alloc_io_pgtable_ops(fmt, &pgtbl_cfg, smmu_domain);
-	if (!pgtbl_ops)
+	iop = alloc_io_pgtable(fmt, &pgtbl_cfg, smmu_domain);
+	if (!iop)
 		return -ENOMEM;
 
 	domain->pgsize_bitmap = pgtbl_cfg.pgsize_bitmap;
-	smmu_domain->pgtbl_ops = pgtbl_ops;
+	smmu_domain->pgtbl = iop;
 
 	ret = finalise_stage_fn(smmu_domain, &pgtbl_cfg);
 	if (ret < 0)
-		free_io_pgtable_ops(pgtbl_ops);
+		free_io_pgtable(iop);
 
 	return ret;
 }
@@ -1711,13 +1711,13 @@ static int arm_smmu_map(struct iommu_domain *domain, unsigned long iova,
 	int ret;
 	unsigned long flags;
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
-	struct io_pgtable_ops *ops = smmu_domain->pgtbl_ops;
+	struct io_pgtable *iop = smmu_domain->pgtbl;
 
-	if (!ops)
+	if (!iop)
 		return -ENODEV;
 
 	spin_lock_irqsave(&smmu_domain->pgtbl_lock, flags);
-	ret = ops->map(ops, iova, paddr, size, prot);
+	ret = iop->ops->map(iop, iova, paddr, size, prot);
 	spin_unlock_irqrestore(&smmu_domain->pgtbl_lock, flags);
 	return ret;
 }
@@ -1728,13 +1728,13 @@ arm_smmu_unmap(struct iommu_domain *domain, unsigned long iova, size_t size)
 	size_t ret;
 	unsigned long flags;
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
-	struct io_pgtable_ops *ops = smmu_domain->pgtbl_ops;
+	struct io_pgtable *iop = smmu_domain->pgtbl;
 
-	if (!ops)
+	if (!iop)
 		return 0;
 
 	spin_lock_irqsave(&smmu_domain->pgtbl_lock, flags);
-	ret = ops->unmap(ops, iova, size);
+	ret = iop->ops->unmap(iop, iova, size);
 	spin_unlock_irqrestore(&smmu_domain->pgtbl_lock, flags);
 	return ret;
 }
@@ -1745,13 +1745,13 @@ arm_smmu_iova_to_phys(struct iommu_domain *domain, dma_addr_t iova)
 	phys_addr_t ret;
 	unsigned long flags;
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
-	struct io_pgtable_ops *ops = smmu_domain->pgtbl_ops;
+	struct io_pgtable *iop = smmu_domain->pgtbl;
 
-	if (!ops)
+	if (!iop)
 		return 0;
 
 	spin_lock_irqsave(&smmu_domain->pgtbl_lock, flags);
-	ret = ops->iova_to_phys(ops, iova);
+	ret = iop->ops->iova_to_phys(iop, iova);
 	spin_unlock_irqrestore(&smmu_domain->pgtbl_lock, flags);
 
 	return ret;
diff --git a/drivers/iommu/arm-smmu.c b/drivers/iommu/arm-smmu.c
index 2db74ebc3..4bbcf9d34 100644
--- a/drivers/iommu/arm-smmu.c
+++ b/drivers/iommu/arm-smmu.c
@@ -389,7 +389,7 @@ enum arm_smmu_domain_stage {
 
 struct arm_smmu_domain {
 	struct arm_smmu_device		*smmu;
-	struct io_pgtable_ops		*pgtbl_ops;
+	struct io_pgtable		*pgtbl;
 	spinlock_t			pgtbl_lock;
 	struct arm_smmu_cfg		cfg;
 	enum arm_smmu_domain_stage	stage;
@@ -831,7 +831,7 @@ static int arm_smmu_init_domain_context(struct iommu_domain *domain,
 {
 	int irq, start, ret = 0;
 	unsigned long ias, oas;
-	struct io_pgtable_ops *pgtbl_ops;
+	struct io_pgtable *pgtbl;
 	struct io_pgtable_cfg pgtbl_cfg;
 	enum io_pgtable_fmt fmt;
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
@@ -950,8 +950,8 @@ static int arm_smmu_init_domain_context(struct iommu_domain *domain,
 	};
 
 	smmu_domain->smmu = smmu;
-	pgtbl_ops = alloc_io_pgtable_ops(fmt, &pgtbl_cfg, smmu_domain);
-	if (!pgtbl_ops) {
+	pgtbl = alloc_io_pgtable(fmt, &pgtbl_cfg, smmu_domain);
+	if (!pgtbl) {
 		ret = -ENOMEM;
 		goto out_clear_smmu;
 	}
@@ -978,7 +978,7 @@ static int arm_smmu_init_domain_context(struct iommu_domain *domain,
 	mutex_unlock(&smmu_domain->init_mutex);
 
 	/* Publish page table ops for map/unmap */
-	smmu_domain->pgtbl_ops = pgtbl_ops;
+	smmu_domain->pgtbl = pgtbl;
 	return 0;
 
 out_clear_smmu:
@@ -1011,7 +1011,7 @@ static void arm_smmu_destroy_domain_context(struct iommu_domain *domain)
 		devm_free_irq(smmu->dev, irq, domain);
 	}
 
-	free_io_pgtable_ops(smmu_domain->pgtbl_ops);
+	free_io_pgtable(smmu_domain->pgtbl);
 	__arm_smmu_free_bitmap(smmu->context_map, cfg->cbndx);
 }
 
@@ -1248,13 +1248,13 @@ static int arm_smmu_map(struct iommu_domain *domain, unsigned long iova,
 	int ret;
 	unsigned long flags;
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
-	struct io_pgtable_ops *ops= smmu_domain->pgtbl_ops;
+	struct io_pgtable *iop = smmu_domain->pgtbl;
 
-	if (!ops)
+	if (!iop)
 		return -ENODEV;
 
 	spin_lock_irqsave(&smmu_domain->pgtbl_lock, flags);
-	ret = ops->map(ops, iova, paddr, size, prot);
+	ret = iop->ops->map(iop, iova, paddr, size, prot);
 	spin_unlock_irqrestore(&smmu_domain->pgtbl_lock, flags);
 	return ret;
 }
@@ -1265,13 +1265,13 @@ static size_t arm_smmu_unmap(struct iommu_domain *domain, unsigned long iova,
 	size_t ret;
 	unsigned long flags;
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
-	struct io_pgtable_ops *ops= smmu_domain->pgtbl_ops;
+	struct io_pgtable *iop = smmu_domain->pgtbl;
 
-	if (!ops)
+	if (!iop)
 		return 0;
 
 	spin_lock_irqsave(&smmu_domain->pgtbl_lock, flags);
-	ret = ops->unmap(ops, iova, size);
+	ret = iop->ops->unmap(iop, iova, size);
 	spin_unlock_irqrestore(&smmu_domain->pgtbl_lock, flags);
 	return ret;
 }
@@ -1282,7 +1282,7 @@ static phys_addr_t arm_smmu_iova_to_phys_hard(struct iommu_domain *domain,
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
 	struct arm_smmu_device *smmu = smmu_domain->smmu;
 	struct arm_smmu_cfg *cfg = &smmu_domain->cfg;
-	struct io_pgtable_ops *ops= smmu_domain->pgtbl_ops;
+	struct io_pgtable *iop = smmu_domain->pgtbl;
 	struct device *dev = smmu->dev;
 	void __iomem *cb_base;
 	u32 tmp;
@@ -1303,7 +1303,7 @@ static phys_addr_t arm_smmu_iova_to_phys_hard(struct iommu_domain *domain,
 		dev_err(dev,
 			"iova to phys timed out on %pad. Falling back to software table walk.\n",
 			&iova);
-		return ops->iova_to_phys(ops, iova);
+		return iop->ops->iova_to_phys(iop, iova);
 	}
 
 	phys = readq_relaxed(cb_base + ARM_SMMU_CB_PAR);
@@ -1322,9 +1322,9 @@ static phys_addr_t arm_smmu_iova_to_phys(struct iommu_domain *domain,
 	phys_addr_t ret;
 	unsigned long flags;
 	struct arm_smmu_domain *smmu_domain = to_smmu_domain(domain);
-	struct io_pgtable_ops *ops= smmu_domain->pgtbl_ops;
+	struct io_pgtable *iop = smmu_domain->pgtbl;
 
-	if (!ops)
+	if (!iop)
 		return 0;
 
 	spin_lock_irqsave(&smmu_domain->pgtbl_lock, flags);
@@ -1332,7 +1332,7 @@ static phys_addr_t arm_smmu_iova_to_phys(struct iommu_domain *domain,
 			smmu_domain->stage == ARM_SMMU_DOMAIN_S1) {
 		ret = arm_smmu_iova_to_phys_hard(domain, iova);
 	} else {
-		ret = ops->iova_to_phys(ops, iova);
+		ret = iop->ops->iova_to_phys(iop, iova);
 	}
 
 	spin_unlock_irqrestore(&smmu_domain->pgtbl_lock, flags);
@@ -1809,10 +1809,12 @@ static int arm_smmu_device_cfg_probe(struct arm_smmu_device *smmu)
 	if (smmu->features & ARM_SMMU_FEAT_FMT_AARCH64_64K)
 		smmu->pgsize_bitmap |= SZ_64K | SZ_512M;
 
+	pax_open_kernel();
 	if (arm_smmu_ops.pgsize_bitmap == -1UL)
-		arm_smmu_ops.pgsize_bitmap = smmu->pgsize_bitmap;
+		const_cast(arm_smmu_ops.pgsize_bitmap) = smmu->pgsize_bitmap;
 	else
-		arm_smmu_ops.pgsize_bitmap |= smmu->pgsize_bitmap;
+		const_cast(arm_smmu_ops.pgsize_bitmap) |= smmu->pgsize_bitmap;
+	pax_close_kernel();
 	dev_notice(smmu->dev, "\tSupported page sizes: 0x%08lx\n",
 		   smmu->pgsize_bitmap);
 
diff --git a/drivers/iommu/io-pgtable-arm-v7s.c b/drivers/iommu/io-pgtable-arm-v7s.c
index f50e51c1a..02c024776 100644
--- a/drivers/iommu/io-pgtable-arm-v7s.c
+++ b/drivers/iommu/io-pgtable-arm-v7s.c
@@ -49,9 +49,6 @@
 #define io_pgtable_to_data(x)						\
 	container_of((x), struct arm_v7s_io_pgtable, iop)
 
-#define io_pgtable_ops_to_data(x)					\
-	io_pgtable_to_data(io_pgtable_ops_to_pgtable(x))
-
 /*
  * We have 32 bits total; 12 bits resolved at level 1, 8 bits at level 2,
  * and 12 bits in a page. With some carefully-chosen coefficients we can
@@ -426,11 +423,10 @@ static int __arm_v7s_map(struct arm_v7s_io_pgtable *data, unsigned long iova,
 	return __arm_v7s_map(data, iova, paddr, size, prot, lvl + 1, cptep);
 }
 
-static int arm_v7s_map(struct io_pgtable_ops *ops, unsigned long iova,
+static int arm_v7s_map(struct io_pgtable *iop, unsigned long iova,
 			phys_addr_t paddr, size_t size, int prot)
 {
-	struct arm_v7s_io_pgtable *data = io_pgtable_ops_to_data(ops);
-	struct io_pgtable *iop = &data->iop;
+	struct arm_v7s_io_pgtable *data = io_pgtable_to_data(iop);
 	int ret;
 
 	/* If no access, then nothing to do */
@@ -593,10 +589,10 @@ static int __arm_v7s_unmap(struct arm_v7s_io_pgtable *data,
 	return __arm_v7s_unmap(data, iova, size, lvl + 1, ptep);
 }
 
-static int arm_v7s_unmap(struct io_pgtable_ops *ops, unsigned long iova,
+static int arm_v7s_unmap(struct io_pgtable *iop, unsigned long iova,
 			 size_t size)
 {
-	struct arm_v7s_io_pgtable *data = io_pgtable_ops_to_data(ops);
+	struct arm_v7s_io_pgtable *data = io_pgtable_to_data(iop);
 	size_t unmapped;
 
 	unmapped = __arm_v7s_unmap(data, iova, size, 1, data->pgd);
@@ -606,10 +602,10 @@ static int arm_v7s_unmap(struct io_pgtable_ops *ops, unsigned long iova,
 	return unmapped;
 }
 
-static phys_addr_t arm_v7s_iova_to_phys(struct io_pgtable_ops *ops,
+static phys_addr_t arm_v7s_iova_to_phys(struct io_pgtable *iop,
 					unsigned long iova)
 {
-	struct arm_v7s_io_pgtable *data = io_pgtable_ops_to_data(ops);
+	struct arm_v7s_io_pgtable *data = io_pgtable_to_data(iop);
 	arm_v7s_iopte *ptep = data->pgd, pte;
 	int lvl = 0;
 	u32 mask;
@@ -628,6 +624,12 @@ static phys_addr_t arm_v7s_iova_to_phys(struct io_pgtable_ops *ops,
 	return (pte & mask) | (iova & ~mask);
 }
 
+static struct io_pgtable_ops arm_v7s_io_pgtable_ops = {
+	.map		= arm_v7s_map,
+	.unmap		= arm_v7s_unmap,
+	.iova_to_phys	= arm_v7s_iova_to_phys,
+};
+
 static struct io_pgtable *arm_v7s_alloc_pgtable(struct io_pgtable_cfg *cfg,
 						void *cookie)
 {
@@ -662,11 +664,7 @@ static struct io_pgtable *arm_v7s_alloc_pgtable(struct io_pgtable_cfg *cfg,
 	if (!data->l2_tables)
 		goto out_free_data;
 
-	data->iop.ops = (struct io_pgtable_ops) {
-		.map		= arm_v7s_map,
-		.unmap		= arm_v7s_unmap,
-		.iova_to_phys	= arm_v7s_iova_to_phys,
-	};
+	data->iop.ops = &arm_v7s_io_pgtable_ops;
 
 	/* We have to do this early for __arm_v7s_alloc_table to work... */
 	data->iop.cfg = *cfg;
@@ -755,7 +753,7 @@ static struct iommu_gather_ops dummy_tlb_ops = {
 
 static int __init arm_v7s_do_selftests(void)
 {
-	struct io_pgtable_ops *ops;
+	struct io_pgtable *pgtbl;
 	struct io_pgtable_cfg cfg = {
 		.tlb = &dummy_tlb_ops,
 		.oas = 32,
@@ -770,8 +768,8 @@ static int __init arm_v7s_do_selftests(void)
 
 	cfg_cookie = &cfg;
 
-	ops = alloc_io_pgtable_ops(ARM_V7S, &cfg, &cfg);
-	if (!ops) {
+	pgtbl = alloc_io_pgtable(ARM_V7S, &cfg, &cfg);
+	if (!pgtbl) {
 		pr_err("selftest: failed to allocate io pgtable ops\n");
 		return -EINVAL;
 	}
@@ -780,13 +778,13 @@ static int __init arm_v7s_do_selftests(void)
 	 * Initial sanity checks.
 	 * Empty page tables shouldn't provide any translations.
 	 */
-	if (ops->iova_to_phys(ops, 42))
+	if (pgtbl->ops->iova_to_phys(pgtbl, 42))
 		return __FAIL(ops);
 
-	if (ops->iova_to_phys(ops, SZ_1G + 42))
+	if (pgtbl->ops->iova_to_phys(pgtbl, SZ_1G + 42))
 		return __FAIL(ops);
 
-	if (ops->iova_to_phys(ops, SZ_2G + 42))
+	if (pgtbl->ops->iova_to_phys(pgtbl, SZ_2G + 42))
 		return __FAIL(ops);
 
 	/*
@@ -796,18 +794,18 @@ static int __init arm_v7s_do_selftests(void)
 	i = find_first_bit(&cfg.pgsize_bitmap, BITS_PER_LONG);
 	while (i != BITS_PER_LONG) {
 		size = 1UL << i;
-		if (ops->map(ops, iova, iova, size, IOMMU_READ |
+		if (pgtbl->ops->map(pgtbl, iova, iova, size, IOMMU_READ |
 						    IOMMU_WRITE |
 						    IOMMU_NOEXEC |
 						    IOMMU_CACHE))
 			return __FAIL(ops);
 
 		/* Overlapping mappings */
-		if (!ops->map(ops, iova, iova + size, size,
+		if (!pgtbl->ops->map(pgtbl, iova, iova + size, size,
 			      IOMMU_READ | IOMMU_NOEXEC))
 			return __FAIL(ops);
 
-		if (ops->iova_to_phys(ops, iova + 42) != (iova + 42))
+		if (pgtbl->ops->iova_to_phys(pgtbl, iova + 42) != (iova + 42))
 			return __FAIL(ops);
 
 		iova += SZ_16M;
@@ -821,14 +819,14 @@ static int __init arm_v7s_do_selftests(void)
 	size = 1UL << __ffs(cfg.pgsize_bitmap);
 	while (i < loopnr) {
 		iova_start = i * SZ_16M;
-		if (ops->unmap(ops, iova_start + size, size) != size)
+		if (pgtbl->ops->unmap(pgtbl, iova_start + size, size) != size)
 			return __FAIL(ops);
 
 		/* Remap of partial unmap */
-		if (ops->map(ops, iova_start + size, size, size, IOMMU_READ))
+		if (pgtbl->ops->map(pgtbl, iova_start + size, size, size, IOMMU_READ))
 			return __FAIL(ops);
 
-		if (ops->iova_to_phys(ops, iova_start + size + 42)
+		if (pgtbl->ops->iova_to_phys(pgtbl, iova_start + size + 42)
 		    != (size + 42))
 			return __FAIL(ops);
 		i++;
@@ -840,17 +838,17 @@ static int __init arm_v7s_do_selftests(void)
 	while (i != BITS_PER_LONG) {
 		size = 1UL << i;
 
-		if (ops->unmap(ops, iova, size) != size)
+		if (pgtbl->ops->unmap(pgtbl, iova, size) != size)
 			return __FAIL(ops);
 
-		if (ops->iova_to_phys(ops, iova + 42))
+		if (pgtbl->ops->iova_to_phys(pgtbl, iova + 42))
 			return __FAIL(ops);
 
 		/* Remap full block */
-		if (ops->map(ops, iova, iova, size, IOMMU_WRITE))
+		if (pgtbl->ops->map(pgtbl, iova, iova, size, IOMMU_WRITE))
 			return __FAIL(ops);
 
-		if (ops->iova_to_phys(ops, iova + 42) != (iova + 42))
+		if (pgtbl->ops->iova_to_phys(pgtbl, iova + 42) != (iova + 42))
 			return __FAIL(ops);
 
 		iova += SZ_16M;
@@ -858,7 +856,7 @@ static int __init arm_v7s_do_selftests(void)
 		i = find_next_bit(&cfg.pgsize_bitmap, BITS_PER_LONG, i);
 	}
 
-	free_io_pgtable_ops(ops);
+	free_io_pgtable(pgtbl);
 
 	selftest_running = false;
 
diff --git a/drivers/iommu/io-pgtable-arm.c b/drivers/iommu/io-pgtable-arm.c
index f5c90e136..90a737c4a 100644
--- a/drivers/iommu/io-pgtable-arm.c
+++ b/drivers/iommu/io-pgtable-arm.c
@@ -39,9 +39,6 @@
 #define io_pgtable_to_data(x)						\
 	container_of((x), struct arm_lpae_io_pgtable, iop)
 
-#define io_pgtable_ops_to_data(x)					\
-	io_pgtable_to_data(io_pgtable_ops_to_pgtable(x))
-
 /*
  * For consistency with the architecture, we always consider
  * ARM_LPAE_MAX_LEVELS levels, with the walk starting at level n >=0
@@ -381,10 +378,10 @@ static arm_lpae_iopte arm_lpae_prot_to_pte(struct arm_lpae_io_pgtable *data,
 	return pte;
 }
 
-static int arm_lpae_map(struct io_pgtable_ops *ops, unsigned long iova,
+static int arm_lpae_map(struct io_pgtable *iop, unsigned long iova,
 			phys_addr_t paddr, size_t size, int iommu_prot)
 {
-	struct arm_lpae_io_pgtable *data = io_pgtable_ops_to_data(ops);
+	struct arm_lpae_io_pgtable *data = io_pgtable_to_data(iop);
 	arm_lpae_iopte *ptep = data->pgd;
 	int ret, lvl = ARM_LPAE_START_LVL(data);
 	arm_lpae_iopte prot;
@@ -530,11 +527,11 @@ static int __arm_lpae_unmap(struct arm_lpae_io_pgtable *data,
 	return __arm_lpae_unmap(data, iova, size, lvl + 1, ptep);
 }
 
-static int arm_lpae_unmap(struct io_pgtable_ops *ops, unsigned long iova,
+static int arm_lpae_unmap(struct io_pgtable *iop, unsigned long iova,
 			  size_t size)
 {
 	size_t unmapped;
-	struct arm_lpae_io_pgtable *data = io_pgtable_ops_to_data(ops);
+	struct arm_lpae_io_pgtable *data = io_pgtable_to_data(iop);
 	arm_lpae_iopte *ptep = data->pgd;
 	int lvl = ARM_LPAE_START_LVL(data);
 
@@ -545,10 +542,10 @@ static int arm_lpae_unmap(struct io_pgtable_ops *ops, unsigned long iova,
 	return unmapped;
 }
 
-static phys_addr_t arm_lpae_iova_to_phys(struct io_pgtable_ops *ops,
+static phys_addr_t arm_lpae_iova_to_phys(struct io_pgtable *iop,
 					 unsigned long iova)
 {
-	struct arm_lpae_io_pgtable *data = io_pgtable_ops_to_data(ops);
+	struct arm_lpae_io_pgtable *data = io_pgtable_to_data(iop);
 	arm_lpae_iopte pte, *ptep = data->pgd;
 	int lvl = ARM_LPAE_START_LVL(data);
 
@@ -615,6 +612,12 @@ static void arm_lpae_restrict_pgsizes(struct io_pgtable_cfg *cfg)
 	}
 }
 
+static struct io_pgtable_ops arm_lpae_io_pgtable_ops = {
+	.map		= arm_lpae_map,
+	.unmap		= arm_lpae_unmap,
+	.iova_to_phys	= arm_lpae_iova_to_phys,
+};
+
 static struct arm_lpae_io_pgtable *
 arm_lpae_alloc_pgtable(struct io_pgtable_cfg *cfg)
 {
@@ -651,11 +654,7 @@ arm_lpae_alloc_pgtable(struct io_pgtable_cfg *cfg)
 	pgd_bits = va_bits - (data->bits_per_level * (data->levels - 1));
 	data->pgd_size = 1UL << (pgd_bits + ilog2(sizeof(arm_lpae_iopte)));
 
-	data->iop.ops = (struct io_pgtable_ops) {
-		.map		= arm_lpae_map,
-		.unmap		= arm_lpae_unmap,
-		.iova_to_phys	= arm_lpae_iova_to_phys,
-	};
+	data->iop.ops = &arm_lpae_io_pgtable_ops;
 
 	return data;
 }
@@ -916,15 +915,15 @@ static void dummy_tlb_sync(void *cookie)
 	WARN_ON(cookie != cfg_cookie);
 }
 
-static struct iommu_gather_ops dummy_tlb_ops __initdata = {
+static const struct iommu_gather_ops dummy_tlb_ops __initconst = {
 	.tlb_flush_all	= dummy_tlb_flush_all,
 	.tlb_add_flush	= dummy_tlb_add_flush,
 	.tlb_sync	= dummy_tlb_sync,
 };
 
-static void __init arm_lpae_dump_ops(struct io_pgtable_ops *ops)
+static void __init arm_lpae_dump_ops(struct io_pgtable *iop)
 {
-	struct arm_lpae_io_pgtable *data = io_pgtable_ops_to_data(ops);
+	struct arm_lpae_io_pgtable *data = io_pgtable_to_data(iop);
 	struct io_pgtable_cfg *cfg = &data->iop.cfg;
 
 	pr_err("cfg: pgsize_bitmap 0x%lx, ias %u-bit\n",
@@ -934,9 +933,9 @@ static void __init arm_lpae_dump_ops(struct io_pgtable_ops *ops)
 		data->bits_per_level, data->pgd);
 }
 
-#define __FAIL(ops, i)	({						\
+#define __FAIL(iop, i)	({						\
 		WARN(1, "selftest: test failed for fmt idx %d\n", (i));	\
-		arm_lpae_dump_ops(ops);					\
+		arm_lpae_dump_ops(iop);					\
 		selftest_running = false;				\
 		-EFAULT;						\
 })
@@ -951,30 +950,32 @@ static int __init arm_lpae_run_tests(struct io_pgtable_cfg *cfg)
 	int i, j;
 	unsigned long iova;
 	size_t size;
-	struct io_pgtable_ops *ops;
+	struct io_pgtable *iop;
+	const struct io_pgtable_ops *ops;
 
 	selftest_running = true;
 
 	for (i = 0; i < ARRAY_SIZE(fmts); ++i) {
 		cfg_cookie = cfg;
-		ops = alloc_io_pgtable_ops(fmts[i], cfg, cfg);
-		if (!ops) {
+		iop = alloc_io_pgtable(fmts[i], cfg, cfg);
+		if (!iop) {
 			pr_err("selftest: failed to allocate io pgtable ops\n");
 			return -ENOMEM;
 		}
+		ops = iop->ops;
 
 		/*
 		 * Initial sanity checks.
 		 * Empty page tables shouldn't provide any translations.
 		 */
-		if (ops->iova_to_phys(ops, 42))
-			return __FAIL(ops, i);
+		if (ops->iova_to_phys(iop, 42))
+			return __FAIL(iop, i);
 
-		if (ops->iova_to_phys(ops, SZ_1G + 42))
-			return __FAIL(ops, i);
+		if (ops->iova_to_phys(iop, SZ_1G + 42))
+			return __FAIL(iop, i);
 
-		if (ops->iova_to_phys(ops, SZ_2G + 42))
-			return __FAIL(ops, i);
+		if (ops->iova_to_phys(iop, SZ_2G + 42))
+			return __FAIL(iop, i);
 
 		/*
 		 * Distinct mappings of different granule sizes.
@@ -984,19 +985,19 @@ static int __init arm_lpae_run_tests(struct io_pgtable_cfg *cfg)
 		while (j != BITS_PER_LONG) {
 			size = 1UL << j;
 
-			if (ops->map(ops, iova, iova, size, IOMMU_READ |
+			if (ops->map(iop, iova, iova, size, IOMMU_READ |
 							    IOMMU_WRITE |
 							    IOMMU_NOEXEC |
 							    IOMMU_CACHE))
-				return __FAIL(ops, i);
+				return __FAIL(iop, i);
 
 			/* Overlapping mappings */
-			if (!ops->map(ops, iova, iova + size, size,
+			if (!ops->map(iop, iova, iova + size, size,
 				      IOMMU_READ | IOMMU_NOEXEC))
-				return __FAIL(ops, i);
+				return __FAIL(iop, i);
 
-			if (ops->iova_to_phys(ops, iova + 42) != (iova + 42))
-				return __FAIL(ops, i);
+			if (ops->iova_to_phys(iop, iova + 42) != (iova + 42))
+				return __FAIL(iop, i);
 
 			iova += SZ_1G;
 			j++;
@@ -1005,15 +1006,15 @@ static int __init arm_lpae_run_tests(struct io_pgtable_cfg *cfg)
 
 		/* Partial unmap */
 		size = 1UL << __ffs(cfg->pgsize_bitmap);
-		if (ops->unmap(ops, SZ_1G + size, size) != size)
-			return __FAIL(ops, i);
+		if (ops->unmap(iop, SZ_1G + size, size) != size)
+			return __FAIL(iop, i);
 
 		/* Remap of partial unmap */
-		if (ops->map(ops, SZ_1G + size, size, size, IOMMU_READ))
-			return __FAIL(ops, i);
+		if (ops->map(iop, SZ_1G + size, size, size, IOMMU_READ))
+			return __FAIL(iop, i);
 
-		if (ops->iova_to_phys(ops, SZ_1G + size + 42) != (size + 42))
-			return __FAIL(ops, i);
+		if (ops->iova_to_phys(iop, SZ_1G + size + 42) != (size + 42))
+			return __FAIL(iop, i);
 
 		/* Full unmap */
 		iova = 0;
@@ -1021,25 +1022,25 @@ static int __init arm_lpae_run_tests(struct io_pgtable_cfg *cfg)
 		while (j != BITS_PER_LONG) {
 			size = 1UL << j;
 
-			if (ops->unmap(ops, iova, size) != size)
-				return __FAIL(ops, i);
+			if (ops->unmap(iop, iova, size) != size)
+				return __FAIL(iop, i);
 
-			if (ops->iova_to_phys(ops, iova + 42))
-				return __FAIL(ops, i);
+			if (ops->iova_to_phys(iop, iova + 42))
+				return __FAIL(iop, i);
 
 			/* Remap full block */
-			if (ops->map(ops, iova, iova, size, IOMMU_WRITE))
-				return __FAIL(ops, i);
+			if (ops->map(iop, iova, iova, size, IOMMU_WRITE))
+				return __FAIL(iop, i);
 
-			if (ops->iova_to_phys(ops, iova + 42) != (iova + 42))
-				return __FAIL(ops, i);
+			if (ops->iova_to_phys(iop, iova + 42) != (iova + 42))
+				return __FAIL(iop, i);
 
 			iova += SZ_1G;
 			j++;
 			j = find_next_bit(&cfg->pgsize_bitmap, BITS_PER_LONG, j);
 		}
 
-		free_io_pgtable_ops(ops);
+		free_io_pgtable(iop);
 	}
 
 	selftest_running = false;
diff --git a/drivers/iommu/io-pgtable.c b/drivers/iommu/io-pgtable.c
index 127558d83..bc60b81df 100644
--- a/drivers/iommu/io-pgtable.c
+++ b/drivers/iommu/io-pgtable.c
@@ -37,7 +37,7 @@ io_pgtable_init_table[IO_PGTABLE_NUM_FMTS] = {
 #endif
 };
 
-struct io_pgtable_ops *alloc_io_pgtable_ops(enum io_pgtable_fmt fmt,
+struct io_pgtable *alloc_io_pgtable(enum io_pgtable_fmt fmt,
 					    struct io_pgtable_cfg *cfg,
 					    void *cookie)
 {
@@ -59,21 +59,18 @@ struct io_pgtable_ops *alloc_io_pgtable_ops(enum io_pgtable_fmt fmt,
 	iop->cookie	= cookie;
 	iop->cfg	= *cfg;
 
-	return &iop->ops;
+	return iop;
 }
 
 /*
  * It is the IOMMU driver's responsibility to ensure that the page table
  * is no longer accessible to the walker by this point.
  */
-void free_io_pgtable_ops(struct io_pgtable_ops *ops)
+void free_io_pgtable(struct io_pgtable *iop)
 {
-	struct io_pgtable *iop;
-
-	if (!ops)
+	if (!iop)
 		return;
 
-	iop = container_of(ops, struct io_pgtable, ops);
 	io_pgtable_tlb_flush_all(iop);
 	io_pgtable_init_table[iop->fmt]->free(iop);
 }
diff --git a/drivers/iommu/io-pgtable.h b/drivers/iommu/io-pgtable.h
index 969d82cc9..1ba9b6ee0 100644
--- a/drivers/iommu/io-pgtable.h
+++ b/drivers/iommu/io-pgtable.h
@@ -109,17 +109,18 @@ struct io_pgtable_cfg {
  * These functions map directly onto the iommu_ops member functions with
  * the same names.
  */
+struct io_pgtable;
 struct io_pgtable_ops {
-	int (*map)(struct io_pgtable_ops *ops, unsigned long iova,
+	int (*map)(struct io_pgtable *iop, unsigned long iova,
 		   phys_addr_t paddr, size_t size, int prot);
-	int (*unmap)(struct io_pgtable_ops *ops, unsigned long iova,
+	int (*unmap)(struct io_pgtable *iop, unsigned long iova,
 		     size_t size);
-	phys_addr_t (*iova_to_phys)(struct io_pgtable_ops *ops,
+	phys_addr_t (*iova_to_phys)(struct io_pgtable *iop,
 				    unsigned long iova);
 };
 
 /**
- * alloc_io_pgtable_ops() - Allocate a page table allocator for use by an IOMMU.
+ * alloc_io_pgtable() - Allocate a page table allocator for use by an IOMMU.
  *
  * @fmt:    The page table format.
  * @cfg:    The page table configuration. This will be modified to represent
@@ -128,9 +129,9 @@ struct io_pgtable_ops {
  * @cookie: An opaque token provided by the IOMMU driver and passed back to
  *          the callback routines in cfg->tlb.
  */
-struct io_pgtable_ops *alloc_io_pgtable_ops(enum io_pgtable_fmt fmt,
-					    struct io_pgtable_cfg *cfg,
-					    void *cookie);
+struct io_pgtable *alloc_io_pgtable(enum io_pgtable_fmt fmt,
+				    struct io_pgtable_cfg *cfg,
+				    void *cookie);
 
 /**
  * free_io_pgtable_ops() - Free an io_pgtable_ops structure. The caller
@@ -139,7 +140,7 @@ struct io_pgtable_ops *alloc_io_pgtable_ops(enum io_pgtable_fmt fmt,
  *
  * @ops: The ops returned from alloc_io_pgtable_ops.
  */
-void free_io_pgtable_ops(struct io_pgtable_ops *ops);
+void free_io_pgtable(struct io_pgtable *iop);
 
 
 /*
@@ -161,11 +162,9 @@ struct io_pgtable {
 	void			*cookie;
 	bool			tlb_sync_pending;
 	struct io_pgtable_cfg	cfg;
-	struct io_pgtable_ops	ops;
+	const struct io_pgtable_ops	*ops;
 };
 
-#define io_pgtable_ops_to_pgtable(x) container_of((x), struct io_pgtable, ops)
-
 static inline void io_pgtable_tlb_flush_all(struct io_pgtable *iop)
 {
 	iop->cfg.tlb->tlb_flush_all(iop->cookie);
diff --git a/drivers/iommu/iommu.c b/drivers/iommu/iommu.c
index b06d93594..59bad569c 100644
--- a/drivers/iommu/iommu.c
+++ b/drivers/iommu/iommu.c
@@ -944,7 +944,7 @@ static int iommu_bus_notifier(struct notifier_block *nb,
 static int iommu_bus_init(struct bus_type *bus, const struct iommu_ops *ops)
 {
 	int err;
-	struct notifier_block *nb;
+	notifier_block_no_const *nb;
 	struct iommu_callback_data cb = {
 		.ops = ops,
 	};
diff --git a/drivers/iommu/ipmmu-vmsa.c b/drivers/iommu/ipmmu-vmsa.c
index 2fdbac67a..709531116 100644
--- a/drivers/iommu/ipmmu-vmsa.c
+++ b/drivers/iommu/ipmmu-vmsa.c
@@ -41,7 +41,7 @@ struct ipmmu_vmsa_domain {
 	struct iommu_domain io_domain;
 
 	struct io_pgtable_cfg cfg;
-	struct io_pgtable_ops *iop;
+	struct io_pgtable *iop;
 
 	unsigned int context_id;
 	spinlock_t lock;			/* Protects mappings */
@@ -319,8 +319,7 @@ static int ipmmu_domain_init_context(struct ipmmu_vmsa_domain *domain)
 	 */
 	domain->cfg.iommu_dev = domain->mmu->dev;
 
-	domain->iop = alloc_io_pgtable_ops(ARM_32_LPAE_S1, &domain->cfg,
-					   domain);
+	domain->iop = alloc_io_pgtable(ARM_32_LPAE_S1, &domain->cfg, domain);
 	if (!domain->iop)
 		return -EINVAL;
 
@@ -478,7 +477,7 @@ static void ipmmu_domain_free(struct iommu_domain *io_domain)
 	 * been detached.
 	 */
 	ipmmu_domain_destroy_context(domain);
-	free_io_pgtable_ops(domain->iop);
+	free_io_pgtable(domain->iop);
 	kfree(domain);
 }
 
@@ -547,7 +546,7 @@ static int ipmmu_map(struct iommu_domain *io_domain, unsigned long iova,
 	if (!domain)
 		return -ENODEV;
 
-	return domain->iop->map(domain->iop, iova, paddr, size, prot);
+	return domain->iop->ops->map(domain->iop, iova, paddr, size, prot);
 }
 
 static size_t ipmmu_unmap(struct iommu_domain *io_domain, unsigned long iova,
@@ -555,7 +554,7 @@ static size_t ipmmu_unmap(struct iommu_domain *io_domain, unsigned long iova,
 {
 	struct ipmmu_vmsa_domain *domain = to_vmsa_domain(io_domain);
 
-	return domain->iop->unmap(domain->iop, iova, size);
+	return domain->iop->ops->unmap(domain->iop, iova, size);
 }
 
 static phys_addr_t ipmmu_iova_to_phys(struct iommu_domain *io_domain,
@@ -565,7 +564,7 @@ static phys_addr_t ipmmu_iova_to_phys(struct iommu_domain *io_domain,
 
 	/* TODO: Is locking needed ? */
 
-	return domain->iop->iova_to_phys(domain->iop, iova);
+	return domain->iop->ops->iova_to_phys(domain->iop, iova);
 }
 
 static int ipmmu_find_utlbs(struct ipmmu_vmsa_device *mmu, struct device *dev,
diff --git a/drivers/iommu/irq_remapping.c b/drivers/iommu/irq_remapping.c
index 49721b4e1..62874d3f2 100644
--- a/drivers/iommu/irq_remapping.c
+++ b/drivers/iommu/irq_remapping.c
@@ -153,7 +153,7 @@ int __init irq_remap_enable_fault_handling(void)
 void panic_if_irq_remap(const char *msg)
 {
 	if (irq_remapping_enabled)
-		panic(msg);
+		panic("%s", msg);
 }
 
 void ir_ack_apic_edge(struct irq_data *data)
diff --git a/drivers/iommu/msm_iommu.c b/drivers/iommu/msm_iommu.c
index b09692bb5..aa64d5972 100644
--- a/drivers/iommu/msm_iommu.c
+++ b/drivers/iommu/msm_iommu.c
@@ -53,7 +53,7 @@ struct msm_priv {
 	struct list_head list_attached;
 	struct iommu_domain domain;
 	struct io_pgtable_cfg	cfg;
-	struct io_pgtable_ops	*iop;
+	struct io_pgtable	*iop;
 	struct device		*dev;
 	spinlock_t		pgtlock; /* pagetable lock */
 };
@@ -360,13 +360,15 @@ static int msm_iommu_domain_config(struct msm_priv *priv)
 		.iommu_dev = priv->dev,
 	};
 
-	priv->iop = alloc_io_pgtable_ops(ARM_V7S, &priv->cfg, priv);
+	priv->iop = alloc_io_pgtable(ARM_V7S, &priv->cfg, priv);
 	if (!priv->iop) {
 		dev_err(priv->dev, "Failed to allocate pgtable\n");
 		return -EINVAL;
 	}
 
-	msm_iommu_ops.pgsize_bitmap = priv->cfg.pgsize_bitmap;
+	pax_open_kernel();
+	const_cast(msm_iommu_ops.pgsize_bitmap) = priv->cfg.pgsize_bitmap;
+	pax_close_kernel();
 
 	return 0;
 }
@@ -429,7 +431,7 @@ static void msm_iommu_detach_dev(struct iommu_domain *domain,
 	struct msm_iommu_ctx_dev *master;
 	int ret;
 
-	free_io_pgtable_ops(priv->iop);
+	free_io_pgtable(priv->iop);
 
 	spin_lock_irqsave(&msm_iommu_lock, flags);
 	list_for_each_entry(iommu, &priv->list_attached, dom_node) {
@@ -455,7 +457,7 @@ static int msm_iommu_map(struct iommu_domain *domain, unsigned long iova,
 	int ret;
 
 	spin_lock_irqsave(&priv->pgtlock, flags);
-	ret = priv->iop->map(priv->iop, iova, pa, len, prot);
+	ret = priv->iop->ops->map(priv->iop, iova, pa, len, prot);
 	spin_unlock_irqrestore(&priv->pgtlock, flags);
 
 	return ret;
@@ -468,7 +470,7 @@ static size_t msm_iommu_unmap(struct iommu_domain *domain, unsigned long iova,
 	unsigned long flags;
 
 	spin_lock_irqsave(&priv->pgtlock, flags);
-	len = priv->iop->unmap(priv->iop, iova, len);
+	len = priv->iop->ops->unmap(priv->iop, iova, len);
 	spin_unlock_irqrestore(&priv->pgtlock, flags);
 
 	return len;
diff --git a/drivers/iommu/mtk_iommu.c b/drivers/iommu/mtk_iommu.c
index b12c12d74..27bf74559 100644
--- a/drivers/iommu/mtk_iommu.c
+++ b/drivers/iommu/mtk_iommu.c
@@ -97,7 +97,7 @@ struct mtk_iommu_domain {
 	spinlock_t			pgtlock; /* lock for page table */
 
 	struct io_pgtable_cfg		cfg;
-	struct io_pgtable_ops		*iop;
+	struct io_pgtable		*iop;
 
 	struct iommu_domain		domain;
 };
@@ -235,7 +235,7 @@ static int mtk_iommu_domain_finalise(struct mtk_iommu_data *data)
 	if (data->enable_4GB)
 		dom->cfg.quirks |= IO_PGTABLE_QUIRK_ARM_MTK_4GB;
 
-	dom->iop = alloc_io_pgtable_ops(ARM_V7S, &dom->cfg, data);
+	dom->iop = alloc_io_pgtable(ARM_V7S, &dom->cfg, data);
 	if (!dom->iop) {
 		dev_err(data->dev, "Failed to alloc io pgtable\n");
 		return -EINVAL;
@@ -328,7 +328,7 @@ static int mtk_iommu_map(struct iommu_domain *domain, unsigned long iova,
 	int ret;
 
 	spin_lock_irqsave(&dom->pgtlock, flags);
-	ret = dom->iop->map(dom->iop, iova, paddr, size, prot);
+	ret = dom->iop->ops->map(dom->iop, iova, paddr, size, prot);
 	spin_unlock_irqrestore(&dom->pgtlock, flags);
 
 	return ret;
@@ -342,7 +342,7 @@ static size_t mtk_iommu_unmap(struct iommu_domain *domain,
 	size_t unmapsz;
 
 	spin_lock_irqsave(&dom->pgtlock, flags);
-	unmapsz = dom->iop->unmap(dom->iop, iova, size);
+	unmapsz = dom->iop->ops->unmap(dom->iop, iova, size);
 	spin_unlock_irqrestore(&dom->pgtlock, flags);
 
 	return unmapsz;
@@ -356,7 +356,7 @@ static phys_addr_t mtk_iommu_iova_to_phys(struct iommu_domain *domain,
 	phys_addr_t pa;
 
 	spin_lock_irqsave(&dom->pgtlock, flags);
-	pa = dom->iop->iova_to_phys(dom->iop, iova);
+	pa = dom->iop->ops->iova_to_phys(dom->iop, iova);
 	spin_unlock_irqrestore(&dom->pgtlock, flags);
 
 	return pa;
@@ -615,7 +615,7 @@ static int mtk_iommu_remove(struct platform_device *pdev)
 	if (iommu_present(&platform_bus_type))
 		bus_set_iommu(&platform_bus_type, NULL);
 
-	free_io_pgtable_ops(data->m4u_dom->iop);
+	free_io_pgtable(data->m4u_dom->iop);
 	clk_disable_unprepare(data->bclk);
 	devm_free_irq(&pdev->dev, data->irq, data);
 	component_master_del(&pdev->dev, &mtk_iommu_com_ops);
diff --git a/drivers/irqchip/irq-gic.c b/drivers/irqchip/irq-gic.c
index 390fac59c..74fed85d6 100644
--- a/drivers/irqchip/irq-gic.c
+++ b/drivers/irqchip/irq-gic.c
@@ -392,7 +392,7 @@ static void gic_handle_cascade_irq(struct irq_desc *desc)
 	chained_irq_exit(chip, desc);
 }
 
-static struct irq_chip gic_chip = {
+static irq_chip_no_const gic_chip __read_only = {
 	.irq_mask		= gic_mask_irq,
 	.irq_unmask		= gic_unmask_irq,
 	.irq_eoi		= gic_eoi_irq,
diff --git a/drivers/irqchip/irq-i8259.c b/drivers/irqchip/irq-i8259.c
index 6b304eb39..6e3a1413e 100644
--- a/drivers/irqchip/irq-i8259.c
+++ b/drivers/irqchip/irq-i8259.c
@@ -204,7 +204,7 @@ spurious_8259A_irq:
 			printk(KERN_DEBUG "spurious 8259A interrupt: IRQ%d.\n", irq);
 			spurious_irq_mask |= irqmask;
 		}
-		atomic_inc(&irq_err_count);
+		atomic_inc_unchecked(&irq_err_count);
 		/*
 		 * Theoretically we do not have to handle this IRQ,
 		 * but in Linux this does not cause problems and is
diff --git a/drivers/irqchip/irq-mmp.c b/drivers/irqchip/irq-mmp.c
index 013fc9659..36a9a97b4 100644
--- a/drivers/irqchip/irq-mmp.c
+++ b/drivers/irqchip/irq-mmp.c
@@ -122,7 +122,7 @@ static void icu_unmask_irq(struct irq_data *d)
 	}
 }
 
-struct irq_chip icu_irq_chip = {
+irq_chip_no_const icu_irq_chip __read_only = {
 	.name		= "icu_irq",
 	.irq_mask	= icu_mask_irq,
 	.irq_mask_ack	= icu_mask_ack_irq,
diff --git a/drivers/irqchip/irq-renesas-intc-irqpin.c b/drivers/irqchip/irq-renesas-intc-irqpin.c
index 713177d97..3849ddd24 100644
--- a/drivers/irqchip/irq-renesas-intc-irqpin.c
+++ b/drivers/irqchip/irq-renesas-intc-irqpin.c
@@ -396,7 +396,7 @@ static int intc_irqpin_probe(struct platform_device *pdev)
 	struct intc_irqpin_iomem *i;
 	struct resource *io[INTC_IRQPIN_REG_NR];
 	struct resource *irq;
-	struct irq_chip *irq_chip;
+	irq_chip_no_const *irq_chip;
 	void (*enable_fn)(struct irq_data *d);
 	void (*disable_fn)(struct irq_data *d);
 	const char *name = dev_name(dev);
diff --git a/drivers/irqchip/irq-ts4800.c b/drivers/irqchip/irq-ts4800.c
index 2325fb3c4..fca752974 100644
--- a/drivers/irqchip/irq-ts4800.c
+++ b/drivers/irqchip/irq-ts4800.c
@@ -93,7 +93,7 @@ static int ts4800_ic_probe(struct platform_device *pdev)
 {
 	struct device_node *node = pdev->dev.of_node;
 	struct ts4800_irq_data *data;
-	struct irq_chip *irq_chip;
+	irq_chip_no_const *irq_chip;
 	struct resource *res;
 	int parent_irq;
 
diff --git a/drivers/isdn/capi/capi.c b/drivers/isdn/capi/capi.c
index 6a2df3297..dc962f1db 100644
--- a/drivers/isdn/capi/capi.c
+++ b/drivers/isdn/capi/capi.c
@@ -81,8 +81,8 @@ struct capiminor {
 
 	struct capi20_appl	*ap;
 	u32			ncci;
-	atomic_t		datahandle;
-	atomic_t		msgid;
+	atomic_unchecked_t	datahandle;
+	atomic_unchecked_t	msgid;
 
 	struct tty_port port;
 	int                ttyinstop;
@@ -391,7 +391,7 @@ gen_data_b3_resp_for(struct capiminor *mp, struct sk_buff *skb)
 		capimsg_setu16(s, 2, mp->ap->applid);
 		capimsg_setu8 (s, 4, CAPI_DATA_B3);
 		capimsg_setu8 (s, 5, CAPI_RESP);
-		capimsg_setu16(s, 6, atomic_inc_return(&mp->msgid));
+		capimsg_setu16(s, 6, atomic_inc_return_unchecked(&mp->msgid));
 		capimsg_setu32(s, 8, mp->ncci);
 		capimsg_setu16(s, 12, datahandle);
 	}
@@ -512,14 +512,14 @@ static void handle_minor_send(struct capiminor *mp)
 		mp->outbytes -= len;
 		spin_unlock_bh(&mp->outlock);
 
-		datahandle = atomic_inc_return(&mp->datahandle);
+		datahandle = atomic_inc_return_unchecked(&mp->datahandle);
 		skb_push(skb, CAPI_DATA_B3_REQ_LEN);
 		memset(skb->data, 0, CAPI_DATA_B3_REQ_LEN);
 		capimsg_setu16(skb->data, 0, CAPI_DATA_B3_REQ_LEN);
 		capimsg_setu16(skb->data, 2, mp->ap->applid);
 		capimsg_setu8 (skb->data, 4, CAPI_DATA_B3);
 		capimsg_setu8 (skb->data, 5, CAPI_REQ);
-		capimsg_setu16(skb->data, 6, atomic_inc_return(&mp->msgid));
+		capimsg_setu16(skb->data, 6, atomic_inc_return_unchecked(&mp->msgid));
 		capimsg_setu32(skb->data, 8, mp->ncci);	/* NCCI */
 		capimsg_setu32(skb->data, 12, (u32)(long)skb->data);/* Data32 */
 		capimsg_setu16(skb->data, 16, len);	/* Data length */
diff --git a/drivers/isdn/gigaset/bas-gigaset.c b/drivers/isdn/gigaset/bas-gigaset.c
index aecec6d32..11e13c561 100644
--- a/drivers/isdn/gigaset/bas-gigaset.c
+++ b/drivers/isdn/gigaset/bas-gigaset.c
@@ -2565,22 +2565,22 @@ static int gigaset_post_reset(struct usb_interface *intf)
 
 
 static const struct gigaset_ops gigops = {
-	gigaset_write_cmd,
-	gigaset_write_room,
-	gigaset_chars_in_buffer,
-	gigaset_brkchars,
-	gigaset_init_bchannel,
-	gigaset_close_bchannel,
-	gigaset_initbcshw,
-	gigaset_freebcshw,
-	gigaset_reinitbcshw,
-	gigaset_initcshw,
-	gigaset_freecshw,
-	gigaset_set_modem_ctrl,
-	gigaset_baud_rate,
-	gigaset_set_line_ctrl,
-	gigaset_isoc_send_skb,
-	gigaset_isoc_input,
+	.write_cmd = gigaset_write_cmd,
+	.write_room = gigaset_write_room,
+	.chars_in_buffer = gigaset_chars_in_buffer,
+	.brkchars = gigaset_brkchars,
+	.init_bchannel = gigaset_init_bchannel,
+	.close_bchannel = gigaset_close_bchannel,
+	.initbcshw = gigaset_initbcshw,
+	.freebcshw = gigaset_freebcshw,
+	.reinitbcshw = gigaset_reinitbcshw,
+	.initcshw = gigaset_initcshw,
+	.freecshw = gigaset_freecshw,
+	.set_modem_ctrl = gigaset_set_modem_ctrl,
+	.baud_rate = gigaset_baud_rate,
+	.set_line_ctrl = gigaset_set_line_ctrl,
+	.send_skb = gigaset_isoc_send_skb,
+	.handle_input = gigaset_isoc_input,
 };
 
 /* bas_gigaset_init
diff --git a/drivers/isdn/gigaset/interface.c b/drivers/isdn/gigaset/interface.c
index 600c79b03..3752bab3a 100644
--- a/drivers/isdn/gigaset/interface.c
+++ b/drivers/isdn/gigaset/interface.c
@@ -130,9 +130,9 @@ static int if_open(struct tty_struct *tty, struct file *filp)
 	}
 	tty->driver_data = cs;
 
-	++cs->port.count;
+	atomic_inc(&cs->port.count);
 
-	if (cs->port.count == 1) {
+	if (atomic_read(&cs->port.count) == 1) {
 		tty_port_tty_set(&cs->port, tty);
 		cs->port.low_latency = 1;
 	}
@@ -156,9 +156,9 @@ static void if_close(struct tty_struct *tty, struct file *filp)
 
 	if (!cs->connected)
 		gig_dbg(DEBUG_IF, "not connected");	/* nothing to do */
-	else if (!cs->port.count)
+	else if (!atomic_read(&cs->port.count))
 		dev_warn(cs->dev, "%s: device not opened\n", __func__);
-	else if (!--cs->port.count)
+	else if (!atomic_dec_return(&cs->port.count))
 		tty_port_tty_set(&cs->port, NULL);
 
 	mutex_unlock(&cs->mutex);
diff --git a/drivers/isdn/gigaset/ser-gigaset.c b/drivers/isdn/gigaset/ser-gigaset.c
index d1f8ab915..c0412f231 100644
--- a/drivers/isdn/gigaset/ser-gigaset.c
+++ b/drivers/isdn/gigaset/ser-gigaset.c
@@ -445,22 +445,22 @@ static int gigaset_set_line_ctrl(struct cardstate *cs, unsigned cflag)
 }
 
 static const struct gigaset_ops ops = {
-	gigaset_write_cmd,
-	gigaset_write_room,
-	gigaset_chars_in_buffer,
-	gigaset_brkchars,
-	gigaset_init_bchannel,
-	gigaset_close_bchannel,
-	gigaset_initbcshw,
-	gigaset_freebcshw,
-	gigaset_reinitbcshw,
-	gigaset_initcshw,
-	gigaset_freecshw,
-	gigaset_set_modem_ctrl,
-	gigaset_baud_rate,
-	gigaset_set_line_ctrl,
-	gigaset_m10x_send_skb,	/* asyncdata.c */
-	gigaset_m10x_input,	/* asyncdata.c */
+	.write_cmd = gigaset_write_cmd,
+	.write_room = gigaset_write_room,
+	.chars_in_buffer = gigaset_chars_in_buffer,
+	.brkchars = gigaset_brkchars,
+	.init_bchannel = gigaset_init_bchannel,
+	.close_bchannel = gigaset_close_bchannel,
+	.initbcshw = gigaset_initbcshw,
+	.freebcshw = gigaset_freebcshw,
+	.reinitbcshw = gigaset_reinitbcshw,
+	.initcshw = gigaset_initcshw,
+	.freecshw = gigaset_freecshw,
+	.set_modem_ctrl = gigaset_set_modem_ctrl,
+	.baud_rate = gigaset_baud_rate,
+	.set_line_ctrl = gigaset_set_line_ctrl,
+	.send_skb = gigaset_m10x_send_skb,	/* asyncdata.c */
+	.handle_input = gigaset_m10x_input,	/* asyncdata.c */
 };
 
 
diff --git a/drivers/isdn/gigaset/usb-gigaset.c b/drivers/isdn/gigaset/usb-gigaset.c
index 5f306e2ee..ff14829c2 100644
--- a/drivers/isdn/gigaset/usb-gigaset.c
+++ b/drivers/isdn/gigaset/usb-gigaset.c
@@ -543,7 +543,7 @@ static int gigaset_brkchars(struct cardstate *cs, const unsigned char buf[6])
 	gigaset_dbg_buffer(DEBUG_USBREQ, "brkchars", 6, buf);
 	memcpy(cs->hw.usb->bchars, buf, 6);
 	return usb_control_msg(udev, usb_sndctrlpipe(udev, 0), 0x19, 0x41,
-			       0, 0, &buf, 6, 2000);
+			       0, 0, cs->hw.usb->bchars, 6, 2000);
 }
 
 static void gigaset_freebcshw(struct bc_state *bcs)
@@ -862,22 +862,22 @@ static int gigaset_pre_reset(struct usb_interface *intf)
 }
 
 static const struct gigaset_ops ops = {
-	gigaset_write_cmd,
-	gigaset_write_room,
-	gigaset_chars_in_buffer,
-	gigaset_brkchars,
-	gigaset_init_bchannel,
-	gigaset_close_bchannel,
-	gigaset_initbcshw,
-	gigaset_freebcshw,
-	gigaset_reinitbcshw,
-	gigaset_initcshw,
-	gigaset_freecshw,
-	gigaset_set_modem_ctrl,
-	gigaset_baud_rate,
-	gigaset_set_line_ctrl,
-	gigaset_m10x_send_skb,
-	gigaset_m10x_input,
+	.write_cmd = gigaset_write_cmd,
+	.write_room = gigaset_write_room,
+	.chars_in_buffer = gigaset_chars_in_buffer,
+	.brkchars = gigaset_brkchars,
+	.init_bchannel = gigaset_init_bchannel,
+	.close_bchannel = gigaset_close_bchannel,
+	.initbcshw = gigaset_initbcshw,
+	.freebcshw = gigaset_freebcshw,
+	.reinitbcshw = gigaset_reinitbcshw,
+	.initcshw = gigaset_initcshw,
+	.freecshw = gigaset_freecshw,
+	.set_modem_ctrl = gigaset_set_modem_ctrl,
+	.baud_rate = gigaset_baud_rate,
+	.set_line_ctrl = gigaset_set_line_ctrl,
+	.send_skb = gigaset_m10x_send_skb,
+	.handle_input = gigaset_m10x_input,
 };
 
 /*
diff --git a/drivers/isdn/hardware/avm/b1.c b/drivers/isdn/hardware/avm/b1.c
index 4d9b19554..455075c60 100644
--- a/drivers/isdn/hardware/avm/b1.c
+++ b/drivers/isdn/hardware/avm/b1.c
@@ -176,7 +176,7 @@ int b1_load_t4file(avmcard *card, capiloaddatapart *t4file)
 	}
 	if (left) {
 		if (t4file->user) {
-			if (copy_from_user(buf, dp, left))
+			if (left > sizeof buf || copy_from_user(buf, dp, left))
 				return -EFAULT;
 		} else {
 			memcpy(buf, dp, left);
@@ -224,7 +224,7 @@ int b1_load_config(avmcard *card, capiloaddatapart *config)
 	}
 	if (left) {
 		if (config->user) {
-			if (copy_from_user(buf, dp, left))
+			if (left > sizeof buf || copy_from_user(buf, dp, left))
 				return -EFAULT;
 		} else {
 			memcpy(buf, dp, left);
diff --git a/drivers/isdn/hardware/eicon/capifunc.c b/drivers/isdn/hardware/eicon/capifunc.c
index 7a0bdbdd8..0a7b7db24 100644
--- a/drivers/isdn/hardware/eicon/capifunc.c
+++ b/drivers/isdn/hardware/eicon/capifunc.c
@@ -57,7 +57,7 @@ static u16 diva_send_message(struct capi_ctr *,
 			     diva_os_message_buffer_s *);
 extern void diva_os_set_controller_struct(struct capi_ctr *);
 
-extern void DIVA_DIDD_Read(DESCRIPTOR *, int);
+extern void DIVA_DIDD_Read(void *, int);
 
 /*
  * debug
@@ -1032,7 +1032,6 @@ static void didd_callback(void *context, DESCRIPTOR *adapter, int removal)
 			stop_dbg();
 		} else {
 			memcpy(&MAdapter, adapter, sizeof(MAdapter));
-			dprintf = (DIVA_DI_PRINTF) MAdapter.request;
 			DbgRegister("CAPI20", DRIVERRELEASE_CAPI, DBG_DEFAULT);
 		}
 	} else if ((adapter->type > 0) && (adapter->type < 16)) {	/* IDI Adapter */
@@ -1060,7 +1059,6 @@ static int divacapi_connect_didd(void)
 	for (x = 0; x < MAX_DESCRIPTORS; x++) {
 		if (DIDD_Table[x].type == IDI_DIMAINT) {	/* MAINT found */
 			memcpy(&MAdapter, &DIDD_Table[x], sizeof(DAdapter));
-			dprintf = (DIVA_DI_PRINTF) MAdapter.request;
 			DbgRegister("CAPI20", DRIVERRELEASE_CAPI, DBG_DEFAULT);
 			break;
 		}
@@ -1072,7 +1070,7 @@ static int divacapi_connect_didd(void)
 			req.didd_notify.e.Req = 0;
 			req.didd_notify.e.Rc =
 				IDI_SYNC_REQ_DIDD_REGISTER_ADAPTER_NOTIFY;
-			req.didd_notify.info.callback = (void *)didd_callback;
+			req.didd_notify.info.callback = didd_callback;
 			req.didd_notify.info.context = NULL;
 			DAdapter.request((ENTITY *)&req);
 			if (req.didd_notify.e.Rc != 0xff) {
diff --git a/drivers/isdn/hardware/eicon/dadapter.c b/drivers/isdn/hardware/eicon/dadapter.c
index 514209994..642b7dea4 100644
--- a/drivers/isdn/hardware/eicon/dadapter.c
+++ b/drivers/isdn/hardware/eicon/dadapter.c
@@ -63,10 +63,14 @@ static void no_printf(unsigned char *format, ...)
    ------------------------------------------------------------------------- */
 #include "debuglib.c"
 
+static void IDI_CALL_LINK_T no_request(ENTITY IDI_CALL_ENTITY_T *i)
+{
+}
+
 static DESCRIPTOR  MAdapter =  {IDI_DIMAINT, /* Adapter Type */
 				0x00,     /* Channels */
 				0x0000,    /* Features */
-				(IDI_CALL)no_printf};
+				no_request};
 /* --------------------------------------------------------------------------
    DAdapter. Only IDI clients with buffer, that is huge enough to
    get all descriptors will receive information about DAdapter
@@ -100,6 +104,11 @@ void diva_didd_load_time_init(void) {
 void diva_didd_load_time_finit(void) {
 	diva_os_destroy_spin_lock(&didd_spin, "didd");
 }
+
+static void diva_didd_no_request(ENTITY *e)
+{
+}
+
 /* --------------------------------------------------------------------------
    Called in order to register new adapter in adapter array
    return adapter handle (> 0) on success
@@ -111,13 +120,12 @@ static int diva_didd_add_descriptor(DESCRIPTOR *d) {
 	if (d->type == IDI_DIMAINT) {
 		if (d->request) {
 			MAdapter.request = d->request;
-			dprintf = (DIVA_DI_PRINTF)d->request;
 			diva_notify_adapter_change(&MAdapter, 0); /* Inserted */
 			DBG_TRC(("DIMAINT registered, dprintf=%08x", d->request))
 				} else {
 			DBG_TRC(("DIMAINT removed"))
 				diva_notify_adapter_change(&MAdapter, 1); /* About to remove */
-			MAdapter.request = (IDI_CALL)no_printf;
+			MAdapter.request = diva_didd_no_request;
 			dprintf = no_printf;
 		}
 		return (NEW_MAX_DESCRIPTORS);
@@ -149,7 +157,7 @@ static int diva_didd_remove_descriptor(IDI_CALL request) {
 		DBG_TRC(("DIMAINT removed"))
 			dprintf = no_printf;
 		diva_notify_adapter_change(&MAdapter, 1); /* About to remove */
-		MAdapter.request = (IDI_CALL)no_printf;
+		MAdapter.request = diva_didd_no_request;
 		return (0);
 	}
 	for (i = 0; (Adapters && (i < NEW_MAX_DESCRIPTORS)); i++) {
@@ -222,7 +230,7 @@ static void IDI_CALL_LINK_T diva_dadapter_request(	\
 	case IDI_SYNC_REQ_DIDD_REGISTER_ADAPTER_NOTIFY: {
 		diva_didd_adapter_notify_t *pinfo = &syncReq->didd_notify.info;
 		pinfo->handle = diva_register_adapter_callback(		\
-			(didd_adapter_change_callback_t)pinfo->callback,
+			pinfo->callback,
 			(void IDI_CALL_ENTITY_T *)pinfo->context);
 		e->Rc = 0xff;
 	} break;
diff --git a/drivers/isdn/hardware/eicon/diddfunc.c b/drivers/isdn/hardware/eicon/diddfunc.c
index b0b23ed8b..e3d4e18b9 100644
--- a/drivers/isdn/hardware/eicon/diddfunc.c
+++ b/drivers/isdn/hardware/eicon/diddfunc.c
@@ -28,12 +28,12 @@ static DESCRIPTOR _DAdapter;
 /*
  * didd callback function
  */
-static void *didd_callback(void *context, DESCRIPTOR *adapter,
+static void didd_callback(void *context, DESCRIPTOR *adapter,
 			   int removal)
 {
 	if (adapter->type == IDI_DADAPTER) {
 		DBG_ERR(("Notification about IDI_DADAPTER change ! Oops."))
-			return (NULL);
+			return;
 	} else if (adapter->type == IDI_DIMAINT) {
 		if (removal) {
 			DbgDeregister();
@@ -41,7 +41,6 @@ static void *didd_callback(void *context, DESCRIPTOR *adapter,
 			DbgRegister("DIDD", DRIVERRELEASE_DIDD, DBG_DEFAULT);
 		}
 	}
-	return (NULL);
 }
 
 /*
@@ -63,7 +62,7 @@ static int __init connect_didd(void)
 			req.didd_notify.e.Req = 0;
 			req.didd_notify.e.Rc =
 				IDI_SYNC_REQ_DIDD_REGISTER_ADAPTER_NOTIFY;
-			req.didd_notify.info.callback = (void *)didd_callback;
+			req.didd_notify.info.callback = didd_callback;
 			req.didd_notify.info.context = NULL;
 			_DAdapter.request((ENTITY *)&req);
 			if (req.didd_notify.e.Rc != 0xff)
diff --git a/drivers/isdn/hardware/eicon/divasfunc.c b/drivers/isdn/hardware/eicon/divasfunc.c
index 4be5f8814..1dbd479a7 100644
--- a/drivers/isdn/hardware/eicon/divasfunc.c
+++ b/drivers/isdn/hardware/eicon/divasfunc.c
@@ -130,12 +130,12 @@ static void stop_dbg(void)
 /*
  * didd callback function
  */
-static void *didd_callback(void *context, DESCRIPTOR *adapter,
+static void didd_callback(void *context, DESCRIPTOR *adapter,
 			   int removal)
 {
 	if (adapter->type == IDI_DADAPTER) {
 		DBG_ERR(("Notification about IDI_DADAPTER change ! Oops."));
-		return (NULL);
+		return;
 	}
 
 	if (adapter->type == IDI_DIMAINT) {
@@ -143,11 +143,9 @@ static void *didd_callback(void *context, DESCRIPTOR *adapter,
 			stop_dbg();
 		} else {
 			memcpy(&MAdapter, adapter, sizeof(MAdapter));
-			dprintf = (DIVA_DI_PRINTF) MAdapter.request;
 			start_dbg();
 		}
 	}
-	return (NULL);
 }
 
 /*
@@ -169,7 +167,7 @@ static int __init connect_didd(void)
 			req.didd_notify.e.Req = 0;
 			req.didd_notify.e.Rc =
 				IDI_SYNC_REQ_DIDD_REGISTER_ADAPTER_NOTIFY;
-			req.didd_notify.info.callback = (void *)didd_callback;
+			req.didd_notify.info.callback = didd_callback;
 			req.didd_notify.info.context = NULL;
 			DAdapter.request((ENTITY *)&req);
 			if (req.didd_notify.e.Rc != 0xff) {
@@ -179,7 +177,6 @@ static int __init connect_didd(void)
 			notify_handle = req.didd_notify.info.handle;
 		} else if (DIDD_Table[x].type == IDI_DIMAINT) {	/* MAINT found */
 			memcpy(&MAdapter, &DIDD_Table[x], sizeof(DAdapter));
-			dprintf = (DIVA_DI_PRINTF) MAdapter.request;
 			start_dbg();
 		}
 	}
diff --git a/drivers/isdn/hardware/eicon/divasync.h b/drivers/isdn/hardware/eicon/divasync.h
index dd6b53a2c..42661f6ab 100644
--- a/drivers/isdn/hardware/eicon/divasync.h
+++ b/drivers/isdn/hardware/eicon/divasync.h
@@ -138,7 +138,7 @@ typedef struct _diva_xdi_dma_descriptor_operation {
 #define IDI_SYNC_REQ_DIDD_GET_CFG_LIB_IFC           0x10
 typedef struct _diva_didd_adapter_notify {
 	dword handle; /* Notification handle */
-	void *callback;
+	didd_adapter_change_callback_t callback;
 	void *context;
 } diva_didd_adapter_notify_t;
 typedef struct _diva_didd_add_adapter {
diff --git a/drivers/isdn/hardware/eicon/idifunc.c b/drivers/isdn/hardware/eicon/idifunc.c
index fef6586fe..22353ff87 100644
--- a/drivers/isdn/hardware/eicon/idifunc.c
+++ b/drivers/isdn/hardware/eicon/idifunc.c
@@ -154,18 +154,17 @@ rescan:
 /*
  * DIDD notify callback
  */
-static void *didd_callback(void *context, DESCRIPTOR *adapter,
+static void didd_callback(void *context, DESCRIPTOR *adapter,
 			   int removal)
 {
 	if (adapter->type == IDI_DADAPTER) {
 		DBG_ERR(("Notification about IDI_DADAPTER change ! Oops."));
-		return (NULL);
+		return;
 	} else if (adapter->type == IDI_DIMAINT) {
 		if (removal) {
 			stop_dbg();
 		} else {
 			memcpy(&MAdapter, adapter, sizeof(MAdapter));
-			dprintf = (DIVA_DI_PRINTF) MAdapter.request;
 			DbgRegister("User IDI", DRIVERRELEASE_IDI, DBG_DEFAULT);
 		}
 	} else if ((adapter->type > 0) && (adapter->type < 16)) {	/* IDI Adapter */
@@ -175,7 +174,6 @@ static void *didd_callback(void *context, DESCRIPTOR *adapter,
 			um_new_card(adapter);
 		}
 	}
-	return (NULL);
 }
 
 /*
@@ -197,7 +195,7 @@ static int __init connect_didd(void)
 			req.didd_notify.e.Req = 0;
 			req.didd_notify.e.Rc =
 				IDI_SYNC_REQ_DIDD_REGISTER_ADAPTER_NOTIFY;
-			req.didd_notify.info.callback = (void *)didd_callback;
+			req.didd_notify.info.callback = didd_callback;
 			req.didd_notify.info.context = NULL;
 			DAdapter.request((ENTITY *)&req);
 			if (req.didd_notify.e.Rc != 0xff) {
@@ -207,7 +205,6 @@ static int __init connect_didd(void)
 			notify_handle = req.didd_notify.info.handle;
 		} else if (DIDD_Table[x].type == IDI_DIMAINT) {	/* MAINT found */
 			memcpy(&MAdapter, &DIDD_Table[x], sizeof(DAdapter));
-			dprintf = (DIVA_DI_PRINTF) MAdapter.request;
 			DbgRegister("User IDI", DRIVERRELEASE_IDI, DBG_DEFAULT);
 		} else if ((DIDD_Table[x].type > 0)
 			   && (DIDD_Table[x].type < 16)) {	/* IDI Adapter found */
diff --git a/drivers/isdn/hardware/eicon/mntfunc.c b/drivers/isdn/hardware/eicon/mntfunc.c
index 1cd9affb6..3775d52d9 100644
--- a/drivers/isdn/hardware/eicon/mntfunc.c
+++ b/drivers/isdn/hardware/eicon/mntfunc.c
@@ -26,8 +26,13 @@ extern void DIVA_DIDD_Read(void *, int);
 static dword notify_handle;
 static DESCRIPTOR DAdapter;
 static DESCRIPTOR MAdapter;
+
+static void didd_nothing(ENTITY IDI_CALL_ENTITY_T *e)
+{
+	diva_maint_prtComp((char *)e);
+}
 static DESCRIPTOR MaintDescriptor =
-{ IDI_DIMAINT, 0, 0, (IDI_CALL) diva_maint_prtComp };
+{ IDI_DIMAINT, 0, 0, didd_nothing };
 
 extern int diva_os_copy_to_user(void *os_handle, void __user *dst,
 				const void *src, int length);
@@ -44,7 +49,7 @@ static void no_printf(unsigned char *x, ...)
 /*
  *  DIDD callback function
  */
-static void *didd_callback(void *context, DESCRIPTOR *adapter,
+static void didd_callback(void *context, DESCRIPTOR *adapter,
 			   int removal)
 {
 	if (adapter->type == IDI_DADAPTER) {
@@ -56,7 +61,6 @@ static void *didd_callback(void *context, DESCRIPTOR *adapter,
 			dprintf = no_printf;
 		} else {
 			memcpy(&MAdapter, adapter, sizeof(MAdapter));
-			dprintf = (DIVA_DI_PRINTF) MAdapter.request;
 			DbgRegister("MAINT", DRIVERRELEASE_MNT, DBG_DEFAULT);
 		}
 	} else if ((adapter->type > 0) && (adapter->type < 16)) {
@@ -66,7 +70,6 @@ static void *didd_callback(void *context, DESCRIPTOR *adapter,
 			diva_mnt_add_xdi_adapter(adapter);
 		}
 	}
-	return (NULL);
 }
 
 /*
@@ -88,7 +91,7 @@ static int __init connect_didd(void)
 			req.didd_notify.e.Req = 0;
 			req.didd_notify.e.Rc =
 				IDI_SYNC_REQ_DIDD_REGISTER_ADAPTER_NOTIFY;
-			req.didd_notify.info.callback = (void *)didd_callback;
+			req.didd_notify.info.callback = didd_callback;
 			req.didd_notify.info.context = NULL;
 			DAdapter.request((ENTITY *)&req);
 			if (req.didd_notify.e.Rc != 0xff)
diff --git a/drivers/isdn/hardware/mISDN/avmfritz.c b/drivers/isdn/hardware/mISDN/avmfritz.c
index 292991c90..f36f4cb3e 100644
--- a/drivers/isdn/hardware/mISDN/avmfritz.c
+++ b/drivers/isdn/hardware/mISDN/avmfritz.c
@@ -156,7 +156,7 @@ _set_debug(struct fritzcard *card)
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct fritzcard *card;
diff --git a/drivers/isdn/hardware/mISDN/hfcmulti.c b/drivers/isdn/hardware/mISDN/hfcmulti.c
index 28543d795..bd8cf9117 100644
--- a/drivers/isdn/hardware/mISDN/hfcmulti.c
+++ b/drivers/isdn/hardware/mISDN/hfcmulti.c
@@ -2856,8 +2856,9 @@ irq_notforus:
  */
 
 static void
-hfcmulti_dbusy_timer(struct hfc_multi *hc)
+hfcmulti_dbusy_timer(unsigned long _hc)
 {
+	//struct hfc_multi *hc = (struct hfc_multi *)_hc;
 }
 
 
@@ -3878,7 +3879,7 @@ hfcmulti_initmode(struct dchannel *dch)
 		if (hc->dnum[pt]) {
 			mode_hfcmulti(hc, dch->slot, dch->dev.D.protocol,
 				      -1, 0, -1, 0);
-			dch->timer.function = (void *) hfcmulti_dbusy_timer;
+			dch->timer.function = hfcmulti_dbusy_timer;
 			dch->timer.data = (long) dch;
 			init_timer(&dch->timer);
 		}
@@ -3986,7 +3987,7 @@ hfcmulti_initmode(struct dchannel *dch)
 		hc->chan[i].slot_rx = -1;
 		hc->chan[i].conf = -1;
 		mode_hfcmulti(hc, i, dch->dev.D.protocol, -1, 0, -1, 0);
-		dch->timer.function = (void *) hfcmulti_dbusy_timer;
+		dch->timer.function = hfcmulti_dbusy_timer;
 		dch->timer.data = (long) dch;
 		init_timer(&dch->timer);
 		hc->chan[i - 2].slot_tx = -1;
diff --git a/drivers/isdn/hardware/mISDN/hfcpci.c b/drivers/isdn/hardware/mISDN/hfcpci.c
index ff48da61c..497fb7b73 100644
--- a/drivers/isdn/hardware/mISDN/hfcpci.c
+++ b/drivers/isdn/hardware/mISDN/hfcpci.c
@@ -301,8 +301,9 @@ reset_hfcpci(struct hfc_pci *hc)
  * Timer function called when kernel timer expires
  */
 static void
-hfcpci_Timer(struct hfc_pci *hc)
+hfcpci_Timer(unsigned long _hc)
 {
+	struct hfc_pci *hc = (struct hfc_pci *)_hc;
 	hc->hw.timer.expires = jiffies + 75;
 	/* WD RESET */
 /*
@@ -1241,8 +1242,9 @@ hfcpci_int(int intno, void *dev_id)
  * timer callback for D-chan busy resolution. Currently no function
  */
 static void
-hfcpci_dbusy_timer(struct hfc_pci *hc)
+hfcpci_dbusy_timer(unsigned long _hc)
 {
+//	struct hfc_pci *hc = (struct hfc_pci *)_hc;
 }
 
 /*
@@ -1717,7 +1719,7 @@ static void
 inithfcpci(struct hfc_pci *hc)
 {
 	printk(KERN_DEBUG "inithfcpci: entered\n");
-	hc->dch.timer.function = (void *) hfcpci_dbusy_timer;
+	hc->dch.timer.function = hfcpci_dbusy_timer;
 	hc->dch.timer.data = (long) &hc->dch;
 	init_timer(&hc->dch.timer);
 	hc->chanlimit = 2;
@@ -2044,7 +2046,7 @@ setup_hw(struct hfc_pci *hc)
 	Write_hfc(hc, HFCPCI_INT_M1, hc->hw.int_m1);
 	/* At this point the needed PCI config is done */
 	/* fifos are still not enabled */
-	hc->hw.timer.function = (void *) hfcpci_Timer;
+	hc->hw.timer.function = hfcpci_Timer;
 	hc->hw.timer.data = (long) hc;
 	init_timer(&hc->hw.timer);
 	/* default PCM master */
@@ -2293,9 +2295,9 @@ _hfcpci_softirq(struct device *dev, void *arg)
 }
 
 static void
-hfcpci_softirq(void *arg)
+hfcpci_softirq(unsigned long arg)
 {
-	WARN_ON_ONCE(driver_for_each_device(&hfc_driver.driver, NULL, arg,
+	WARN_ON_ONCE(driver_for_each_device(&hfc_driver.driver, NULL, (void *)arg,
 				      _hfcpci_softirq) != 0);
 
 	/* if next event would be in the past ... */
@@ -2330,7 +2332,7 @@ HFC_init(void)
 	if (poll != HFCPCI_BTRANS_THRESHOLD) {
 		printk(KERN_INFO "%s: Using alternative poll value of %d\n",
 		       __func__, poll);
-		hfc_tl.function = (void *)hfcpci_softirq;
+		hfc_tl.function = hfcpci_softirq;
 		hfc_tl.data = 0;
 		init_timer(&hfc_tl);
 		hfc_tl.expires = jiffies + tics;
diff --git a/drivers/isdn/hardware/mISDN/mISDNinfineon.c b/drivers/isdn/hardware/mISDN/mISDNinfineon.c
index d5bdbaf93..a7cdc61ea 100644
--- a/drivers/isdn/hardware/mISDN/mISDNinfineon.c
+++ b/drivers/isdn/hardware/mISDN/mISDNinfineon.c
@@ -244,7 +244,7 @@ _set_debug(struct inf_hw *card)
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct inf_hw *card;
@@ -586,9 +586,10 @@ reset_inf(struct inf_hw *hw)
 }
 
 static int
-inf_ctrl(struct inf_hw *hw, u32 cmd, u_long arg)
+inf_ctrl(struct ipac_hw *_hw, u32 cmd, u_long arg)
 {
 	int ret = 0;
+	struct inf_hw *hw = container_of(_hw, struct inf_hw, ipac);
 
 	switch (cmd) {
 	case HW_RESET_REQ:
@@ -915,7 +916,7 @@ setup_instance(struct inf_hw *card)
 	spin_lock_init(&card->lock);
 	card->ipac.isac.hwlock = &card->lock;
 	card->ipac.hwlock = &card->lock;
-	card->ipac.ctrl = (void *)&inf_ctrl;
+	card->ipac.ctrl = &inf_ctrl;
 
 	err = setup_io(card);
 	if (err)
diff --git a/drivers/isdn/hardware/mISDN/mISDNipac.c b/drivers/isdn/hardware/mISDN/mISDNipac.c
index aa9b6c3ca..ffd32571f 100644
--- a/drivers/isdn/hardware/mISDN/mISDNipac.c
+++ b/drivers/isdn/hardware/mISDN/mISDNipac.c
@@ -727,8 +727,9 @@ isac_release(struct isac_hw *isac)
 }
 
 static void
-dbusy_timer_handler(struct isac_hw *isac)
+dbusy_timer_handler(unsigned long _isac)
 {
+	struct isac_hw *isac = (struct isac_hw *)_isac;
 	int rbch, star;
 	u_long flags;
 
@@ -796,7 +797,7 @@ isac_init(struct isac_hw *isac)
 	}
 	isac->mon_tx = NULL;
 	isac->mon_rx = NULL;
-	isac->dch.timer.function = (void *) dbusy_timer_handler;
+	isac->dch.timer.function = dbusy_timer_handler;
 	isac->dch.timer.data = (long)isac;
 	init_timer(&isac->dch.timer);
 	isac->mocr = 0xaa;
diff --git a/drivers/isdn/hardware/mISDN/netjet.c b/drivers/isdn/hardware/mISDN/netjet.c
index afde4edef..e9fcae456 100644
--- a/drivers/isdn/hardware/mISDN/netjet.c
+++ b/drivers/isdn/hardware/mISDN/netjet.c
@@ -111,7 +111,7 @@ _set_debug(struct tiger_hw *card)
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct tiger_hw *card;
diff --git a/drivers/isdn/hardware/mISDN/speedfax.c b/drivers/isdn/hardware/mISDN/speedfax.c
index 5da75e05f..85c95d42d 100644
--- a/drivers/isdn/hardware/mISDN/speedfax.c
+++ b/drivers/isdn/hardware/mISDN/speedfax.c
@@ -94,7 +94,7 @@ _set_debug(struct sfax_hw *card)
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct sfax_hw *card;
@@ -186,9 +186,10 @@ reset_speedfax(struct sfax_hw *sf)
 }
 
 static int
-sfax_ctrl(struct sfax_hw  *sf, u32 cmd, u_long arg)
+sfax_ctrl(void *_sf, u32 cmd, u_long arg)
 {
 	int ret = 0;
+	struct sfax_hw *sf = (struct sfax_hw *)_sf;
 
 	switch (cmd) {
 	case HW_RESET_REQ:
@@ -386,7 +387,7 @@ setup_instance(struct sfax_hw *card)
 	spin_lock_init(&card->lock);
 	card->isac.hwlock = &card->lock;
 	card->isar.hwlock = &card->lock;
-	card->isar.ctrl = (void *)&sfax_ctrl;
+	card->isar.ctrl = &sfax_ctrl;
 	card->isac.name = card->name;
 	card->isar.name = card->name;
 	card->isar.owner = THIS_MODULE;
diff --git a/drivers/isdn/hardware/mISDN/w6692.c b/drivers/isdn/hardware/mISDN/w6692.c
index 741675525..2914e7ccf 100644
--- a/drivers/isdn/hardware/mISDN/w6692.c
+++ b/drivers/isdn/hardware/mISDN/w6692.c
@@ -101,7 +101,7 @@ _set_debug(struct w6692_hw *card)
 }
 
 static int
-set_debug(const char *val, struct kernel_param *kp)
+set_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret;
 	struct w6692_hw *card;
@@ -819,8 +819,9 @@ w6692_irq(int intno, void *dev_id)
 }
 
 static void
-dbusy_timer_handler(struct dchannel *dch)
+dbusy_timer_handler(unsigned long _dch)
 {
+	struct dchannel *dch = (struct dchannel *)_dch;
 	struct w6692_hw	*card = dch->hw;
 	int		rbch, star;
 	u_long		flags;
@@ -852,7 +853,7 @@ void initW6692(struct w6692_hw *card)
 {
 	u8	val;
 
-	card->dch.timer.function = (void *)dbusy_timer_handler;
+	card->dch.timer.function = dbusy_timer_handler;
 	card->dch.timer.data = (u_long)&card->dch;
 	init_timer(&card->dch.timer);
 	w6692_mode(&card->bc[0], ISDN_P_NONE);
diff --git a/drivers/isdn/hisax/amd7930_fn.c b/drivers/isdn/hisax/amd7930_fn.c
index 36817e0a0..b02bb988a 100644
--- a/drivers/isdn/hisax/amd7930_fn.c
+++ b/drivers/isdn/hisax/amd7930_fn.c
@@ -685,8 +685,9 @@ DC_Close_Amd7930(struct IsdnCardState *cs) {
 
 
 static void
-dbusy_timer_handler(struct IsdnCardState *cs)
+dbusy_timer_handler(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	u_long flags;
 	struct PStack *stptr;
 	WORD dtcr, der;
@@ -789,7 +790,7 @@ void Amd7930_init(struct IsdnCardState *cs)
 void setup_Amd7930(struct IsdnCardState *cs)
 {
 	INIT_WORK(&cs->tqueue, Amd7930_bh);
-	cs->dbusytimer.function = (void *) dbusy_timer_handler;
+	cs->dbusytimer.function = dbusy_timer_handler;
 	cs->dbusytimer.data = (long) cs;
 	init_timer(&cs->dbusytimer);
 }
diff --git a/drivers/isdn/hisax/arcofi.c b/drivers/isdn/hisax/arcofi.c
index 29ec2dfbd..9c7123c18 100644
--- a/drivers/isdn/hisax/arcofi.c
+++ b/drivers/isdn/hisax/arcofi.c
@@ -112,7 +112,8 @@ arcofi_fsm(struct IsdnCardState *cs, int event, void *data) {
 }
 
 static void
-arcofi_timer(struct IsdnCardState *cs) {
+arcofi_timer(unsigned long _cs) {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	arcofi_fsm(cs, ARCOFI_TIMEOUT, NULL);
 }
 
@@ -125,7 +126,7 @@ clear_arcofi(struct IsdnCardState *cs) {
 
 void
 init_arcofi(struct IsdnCardState *cs) {
-	cs->dc.isac.arcofitimer.function = (void *) arcofi_timer;
+	cs->dc.isac.arcofitimer.function = arcofi_timer;
 	cs->dc.isac.arcofitimer.data = (long) cs;
 	init_timer(&cs->dc.isac.arcofitimer);
 	init_waitqueue_head(&cs->dc.isac.arcofi_wait);
diff --git a/drivers/isdn/hisax/config.c b/drivers/isdn/hisax/config.c
index bf04d2a3c..a7d53c9c5 100644
--- a/drivers/isdn/hisax/config.c
+++ b/drivers/isdn/hisax/config.c
@@ -659,7 +659,7 @@ int jiftime(char *s, long mark)
 
 static u_char tmpbuf[HISAX_STATUS_BUFSIZE];
 
-void VHiSax_putstatus(struct IsdnCardState *cs, char *head, char *fmt,
+void VHiSax_putstatus(struct IsdnCardState *cs, char *head, const char *fmt,
 		      va_list args)
 {
 	/* if head == NULL the fmt contains the full info */
@@ -729,7 +729,7 @@ void VHiSax_putstatus(struct IsdnCardState *cs, char *head, char *fmt,
 	}
 }
 
-void HiSax_putstatus(struct IsdnCardState *cs, char *head, char *fmt, ...)
+void HiSax_putstatus(struct IsdnCardState *cs, char *head, const char *fmt, ...)
 {
 	va_list args;
 
diff --git a/drivers/isdn/hisax/diva.c b/drivers/isdn/hisax/diva.c
index 4fc90de68..fda68cdf8 100644
--- a/drivers/isdn/hisax/diva.c
+++ b/drivers/isdn/hisax/diva.c
@@ -796,8 +796,9 @@ reset_diva(struct IsdnCardState *cs)
 #define DIVA_ASSIGN 1
 
 static void
-diva_led_handler(struct IsdnCardState *cs)
+diva_led_handler(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	int blink = 0;
 
 	if ((cs->subtyp == DIVA_IPAC_ISA) ||
@@ -898,7 +899,7 @@ Diva_card_msg(struct IsdnCardState *cs, int mt, void *arg)
 	    (cs->subtyp != DIVA_IPAC_PCI) &&
 	    (cs->subtyp != DIVA_IPACX_PCI)) {
 		spin_lock_irqsave(&cs->lock, flags);
-		diva_led_handler(cs);
+		diva_led_handler((unsigned long)cs);
 		spin_unlock_irqrestore(&cs->lock, flags);
 	}
 	return (0);
@@ -976,7 +977,7 @@ static int setup_diva_common(struct IsdnCardState *cs)
 		printk(KERN_INFO "Diva: IPACX Design Id: %x\n",
 		       MemReadISAC_IPACX(cs, IPACX_ID) & 0x3F);
 	} else { /* DIVA 2.0 */
-		cs->hw.diva.tl.function = (void *) diva_led_handler;
+		cs->hw.diva.tl.function = diva_led_handler;
 		cs->hw.diva.tl.data = (long) cs;
 		init_timer(&cs->hw.diva.tl);
 		cs->readisac  = &ReadISAC;
diff --git a/drivers/isdn/hisax/elsa.c b/drivers/isdn/hisax/elsa.c
index d8ef64da2..9c502677e 100644
--- a/drivers/isdn/hisax/elsa.c
+++ b/drivers/isdn/hisax/elsa.c
@@ -606,8 +606,9 @@ check_arcofi(struct IsdnCardState *cs)
 #endif /* ARCOFI_USE */
 
 static void
-elsa_led_handler(struct IsdnCardState *cs)
+elsa_led_handler(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	int blink = 0;
 
 	if (cs->subtyp == ELSA_PCMCIA || cs->subtyp == ELSA_PCMCIA_IPAC)
@@ -715,7 +716,7 @@ Elsa_card_msg(struct IsdnCardState *cs, int mt, void *arg)
 			init_modem(cs);
 		}
 #endif
-		elsa_led_handler(cs);
+		elsa_led_handler((unsigned long)cs);
 		return (ret);
 	case (MDL_REMOVE | REQUEST):
 		cs->hw.elsa.status &= 0;
@@ -767,7 +768,7 @@ Elsa_card_msg(struct IsdnCardState *cs, int mt, void *arg)
 		else
 			cs->hw.elsa.status &= ~ELSA_BAD_PWR;
 	}
-	elsa_led_handler(cs);
+	elsa_led_handler((unsigned long)cs);
 	return (ret);
 }
 
@@ -1147,7 +1148,7 @@ static int setup_elsa_common(struct IsdnCard *card)
 	init_arcofi(cs);
 #endif
 	setup_isac(cs);
-	cs->hw.elsa.tl.function = (void *) elsa_led_handler;
+	cs->hw.elsa.tl.function = elsa_led_handler;
 	cs->hw.elsa.tl.data = (long) cs;
 	init_timer(&cs->hw.elsa.tl);
 	/* Teste Timer */
diff --git a/drivers/isdn/hisax/fsm.c b/drivers/isdn/hisax/fsm.c
index c7a94713e..5409bd35c 100644
--- a/drivers/isdn/hisax/fsm.c
+++ b/drivers/isdn/hisax/fsm.c
@@ -85,8 +85,9 @@ FsmChangeState(struct FsmInst *fi, int newstate)
 }
 
 static void
-FsmExpireTimer(struct FsmTimer *ft)
+FsmExpireTimer(unsigned long _ft)
 {
+	struct FsmTimer *ft = (struct FsmTimer *)_ft;
 #if FSM_TIMER_DEBUG
 	if (ft->fi->debug)
 		ft->fi->printdebug(ft->fi, "FsmExpireTimer %lx", (long) ft);
@@ -98,7 +99,7 @@ void
 FsmInitTimer(struct FsmInst *fi, struct FsmTimer *ft)
 {
 	ft->fi = fi;
-	ft->tl.function = (void *) FsmExpireTimer;
+	ft->tl.function = FsmExpireTimer;
 	ft->tl.data = (long) ft;
 #if FSM_TIMER_DEBUG
 	if (ft->fi->debug)
diff --git a/drivers/isdn/hisax/hfc4s8s_l1.c b/drivers/isdn/hisax/hfc4s8s_l1.c
index 9600cd771..86ca5a30a 100644
--- a/drivers/isdn/hisax/hfc4s8s_l1.c
+++ b/drivers/isdn/hisax/hfc4s8s_l1.c
@@ -299,8 +299,9 @@ Read_hfc16_stable(hfc4s8s_hw *hw, int reg)
 /* D-channel call from HiSax */
 /*****************************/
 static void
-dch_l2l1(struct hisax_d_if *iface, int pr, void *arg)
+dch_l2l1(struct hisax_if *_iface, int pr, void *arg)
 {
+	struct hisax_d_if *iface = container_of(_iface, struct hisax_d_if, ifc);
 	struct hfc4s8s_l1 *l1 = iface->ifc.priv;
 	struct sk_buff *skb = (struct sk_buff *) arg;
 	u_long flags;
@@ -591,8 +592,9 @@ bch_l2l1(struct hisax_if *ifc, int pr, void *arg)
 /* layer 1 timer function */
 /**************************/
 static void
-hfc_l1_timer(struct hfc4s8s_l1 *l1)
+hfc_l1_timer(unsigned long _l1)
 {
+	struct hfc4s8s_l1 *l1 = (struct hfc4s8s_l1 *)_l1;
 	u_long flags;
 
 	if (!l1->enabled)
@@ -1396,16 +1398,16 @@ setup_instance(hfc4s8s_hw *hw)
 		l1p = hw->l1 + i;
 		spin_lock_init(&l1p->lock);
 		l1p->hw = hw;
-		l1p->l1_timer.function = (void *) hfc_l1_timer;
+		l1p->l1_timer.function = hfc_l1_timer;
 		l1p->l1_timer.data = (long) (l1p);
 		init_timer(&l1p->l1_timer);
 		l1p->st_num = i;
 		skb_queue_head_init(&l1p->d_tx_queue);
 		l1p->d_if.ifc.priv = hw->l1 + i;
-		l1p->d_if.ifc.l2l1 = (void *) dch_l2l1;
+		l1p->d_if.ifc.l2l1 = dch_l2l1;
 
 		spin_lock_init(&l1p->b_ch[0].lock);
-		l1p->b_ch[0].b_if.ifc.l2l1 = (void *) bch_l2l1;
+		l1p->b_ch[0].b_if.ifc.l2l1 = bch_l2l1;
 		l1p->b_ch[0].b_if.ifc.priv = (void *) &l1p->b_ch[0];
 		l1p->b_ch[0].l1p = hw->l1 + i;
 		l1p->b_ch[0].bchan = 1;
@@ -1413,7 +1415,7 @@ setup_instance(hfc4s8s_hw *hw)
 		skb_queue_head_init(&l1p->b_ch[0].tx_queue);
 
 		spin_lock_init(&l1p->b_ch[1].lock);
-		l1p->b_ch[1].b_if.ifc.l2l1 = (void *) bch_l2l1;
+		l1p->b_ch[1].b_if.ifc.l2l1 = bch_l2l1;
 		l1p->b_ch[1].b_if.ifc.priv = (void *) &l1p->b_ch[1];
 		l1p->b_ch[1].l1p = hw->l1 + i;
 		l1p->b_ch[1].bchan = 2;
diff --git a/drivers/isdn/hisax/hfc_2bds0.c b/drivers/isdn/hisax/hfc_2bds0.c
index a756e5cb6..e4789baea 100644
--- a/drivers/isdn/hisax/hfc_2bds0.c
+++ b/drivers/isdn/hisax/hfc_2bds0.c
@@ -1014,7 +1014,7 @@ setstack_hfcd(struct PStack *st, struct IsdnCardState *cs)
 }
 
 static void
-hfc_dbusy_timer(struct IsdnCardState *cs)
+hfc_dbusy_timer(unsigned long _cs)
 {
 }
 
@@ -1073,7 +1073,7 @@ set_cs_func(struct IsdnCardState *cs)
 	cs->writeisacfifo = &dummyf;
 	cs->BC_Read_Reg = &ReadReg;
 	cs->BC_Write_Reg = &WriteReg;
-	cs->dbusytimer.function = (void *) hfc_dbusy_timer;
+	cs->dbusytimer.function = hfc_dbusy_timer;
 	cs->dbusytimer.data = (long) cs;
 	init_timer(&cs->dbusytimer);
 	INIT_WORK(&cs->tqueue, hfcd_bh);
diff --git a/drivers/isdn/hisax/hfc_pci.c b/drivers/isdn/hisax/hfc_pci.c
index 90449e1e9..9a5394c09 100644
--- a/drivers/isdn/hisax/hfc_pci.c
+++ b/drivers/isdn/hisax/hfc_pci.c
@@ -165,8 +165,9 @@ reset_hfcpci(struct IsdnCardState *cs)
 /* Timer function called when kernel timer expires */
 /***************************************************/
 static void
-hfcpci_Timer(struct IsdnCardState *cs)
+hfcpci_Timer(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	cs->hw.hfcpci.timer.expires = jiffies + 75;
 	/* WD RESET */
 /*      WriteReg(cs, HFCD_DATA, HFCD_CTMT, cs->hw.hfcpci.ctmt | 0x80);
@@ -1095,8 +1096,9 @@ hfcpci_interrupt(int intno, void *dev_id)
 /* timer callback for D-chan busy resolution. Currently no function */
 /********************************************************************/
 static void
-hfcpci_dbusy_timer(struct IsdnCardState *cs)
+hfcpci_dbusy_timer(unsigned long _cs)
 {
+	//struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 }
 
 /*************************************/
@@ -1582,7 +1584,7 @@ inithfcpci(struct IsdnCardState *cs)
 	cs->bcs[1].BC_SetStack = setstack_2b;
 	cs->bcs[0].BC_Close = close_hfcpci;
 	cs->bcs[1].BC_Close = close_hfcpci;
-	cs->dbusytimer.function = (void *) hfcpci_dbusy_timer;
+	cs->dbusytimer.function = hfcpci_dbusy_timer;
 	cs->dbusytimer.data = (long) cs;
 	init_timer(&cs->dbusytimer);
 	mode_hfcpci(cs->bcs, 0, 0);
@@ -1746,7 +1748,7 @@ setup_hfcpci(struct IsdnCard *card)
 	cs->BC_Write_Reg = NULL;
 	cs->irq_func = &hfcpci_interrupt;
 	cs->irq_flags |= IRQF_SHARED;
-	cs->hw.hfcpci.timer.function = (void *) hfcpci_Timer;
+	cs->hw.hfcpci.timer.function = hfcpci_Timer;
 	cs->hw.hfcpci.timer.data = (long) cs;
 	init_timer(&cs->hw.hfcpci.timer);
 	cs->cardmsg = &hfcpci_card_msg;
diff --git a/drivers/isdn/hisax/hfc_sx.c b/drivers/isdn/hisax/hfc_sx.c
index 13b2151c1..d3e0732aa 100644
--- a/drivers/isdn/hisax/hfc_sx.c
+++ b/drivers/isdn/hisax/hfc_sx.c
@@ -418,8 +418,9 @@ reset_hfcsx(struct IsdnCardState *cs)
 /* Timer function called when kernel timer expires */
 /***************************************************/
 static void
-hfcsx_Timer(struct IsdnCardState *cs)
+hfcsx_Timer(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	cs->hw.hfcsx.timer.expires = jiffies + 75;
 	/* WD RESET */
 /*      WriteReg(cs, HFCD_DATA, HFCD_CTMT, cs->hw.hfcsx.ctmt | 0x80);
@@ -860,8 +861,9 @@ hfcsx_interrupt(int intno, void *dev_id)
 /* timer callback for D-chan busy resolution. Currently no function */
 /********************************************************************/
 static void
-hfcsx_dbusy_timer(struct IsdnCardState *cs)
+hfcsx_dbusy_timer(unsigned long _cs)
 {
+	//struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 }
 
 /*************************************/
@@ -1495,7 +1497,7 @@ int setup_hfcsx(struct IsdnCard *card)
 	} else
 		return (0);	/* no valid card type */
 
-	cs->dbusytimer.function = (void *) hfcsx_dbusy_timer;
+	cs->dbusytimer.function = hfcsx_dbusy_timer;
 	cs->dbusytimer.data = (long) cs;
 	init_timer(&cs->dbusytimer);
 	INIT_WORK(&cs->tqueue, hfcsx_bh);
@@ -1507,7 +1509,7 @@ int setup_hfcsx(struct IsdnCard *card)
 	cs->BC_Write_Reg = NULL;
 	cs->irq_func = &hfcsx_interrupt;
 
-	cs->hw.hfcsx.timer.function = (void *) hfcsx_Timer;
+	cs->hw.hfcsx.timer.function = hfcsx_Timer;
 	cs->hw.hfcsx.timer.data = (long) cs;
 	cs->hw.hfcsx.b_fifo_size = 0; /* fifo size still unknown */
 	cs->hw.hfcsx.cirm = ccd_sp_irqtab[cs->irq & 0xF]; /* RAM not evaluated */
diff --git a/drivers/isdn/hisax/hfc_usb.c b/drivers/isdn/hisax/hfc_usb.c
index 678bd5224..1c4f12ad7 100644
--- a/drivers/isdn/hisax/hfc_usb.c
+++ b/drivers/isdn/hisax/hfc_usb.c
@@ -343,8 +343,10 @@ handle_led(hfcusb_data *hfc, int event)
 
 /* ISDN l1 timer T3 expires */
 static void
-l1_timer_expire_t3(hfcusb_data *hfc)
+l1_timer_expire_t3(unsigned long _hfc)
 {
+	hfcusb_data *hfc = (hfcusb_data *)_hfc;
+
 	hfc->d_if.ifc.l1l2(&hfc->d_if.ifc, PH_DEACTIVATE | INDICATION,
 			   NULL);
 
@@ -360,8 +362,10 @@ l1_timer_expire_t3(hfcusb_data *hfc)
 
 /* ISDN l1 timer T4 expires */
 static void
-l1_timer_expire_t4(hfcusb_data *hfc)
+l1_timer_expire_t4(unsigned long _hfc)
 {
+	hfcusb_data *hfc = (hfcusb_data *)_hfc;
+
 	hfc->d_if.ifc.l1l2(&hfc->d_if.ifc, PH_DEACTIVATE | INDICATION,
 			   NULL);
 
@@ -1167,12 +1171,12 @@ hfc_usb_init(hfcusb_data *hfc)
 	/* init the t3 timer */
 	init_timer(&hfc->t3_timer);
 	hfc->t3_timer.data = (long) hfc;
-	hfc->t3_timer.function = (void *) l1_timer_expire_t3;
+	hfc->t3_timer.function = l1_timer_expire_t3;
 
 	/* init the t4 timer */
 	init_timer(&hfc->t4_timer);
 	hfc->t4_timer.data = (long) hfc;
-	hfc->t4_timer.function = (void *) l1_timer_expire_t4;
+	hfc->t4_timer.function = l1_timer_expire_t4;
 
 	/* init the background machinery for control requests */
 	hfc->ctrl_read.bRequestType = 0xc0;
diff --git a/drivers/isdn/hisax/hfcscard.c b/drivers/isdn/hisax/hfcscard.c
index 394da646e..85f5f6313 100644
--- a/drivers/isdn/hisax/hfcscard.c
+++ b/drivers/isdn/hisax/hfcscard.c
@@ -41,8 +41,10 @@ hfcs_interrupt(int intno, void *dev_id)
 }
 
 static void
-hfcs_Timer(struct IsdnCardState *cs)
+hfcs_Timer(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
+
 	cs->hw.hfcD.timer.expires = jiffies + 75;
 	/* WD RESET */
 /*	WriteReg(cs, HFCD_DATA, HFCD_CTMT, cs->hw.hfcD.ctmt | 0x80);
@@ -253,7 +255,7 @@ int setup_hfcs(struct IsdnCard *card)
 		outb(0x57, cs->hw.hfcD.addr | 1);
 	}
 	set_cs_func(cs);
-	cs->hw.hfcD.timer.function = (void *) hfcs_Timer;
+	cs->hw.hfcD.timer.function = hfcs_Timer;
 	cs->hw.hfcD.timer.data = (long) cs;
 	init_timer(&cs->hw.hfcD.timer);
 	cs->cardmsg = &hfcs_card_msg;
diff --git a/drivers/isdn/hisax/hisax.h b/drivers/isdn/hisax/hisax.h
index 6ead6314e..338d0408b 100644
--- a/drivers/isdn/hisax/hisax.h
+++ b/drivers/isdn/hisax/hisax.h
@@ -1288,9 +1288,9 @@ int jiftime(char *s, long mark);
 int HiSax_command(isdn_ctrl *ic);
 int HiSax_writebuf_skb(int id, int chan, int ack, struct sk_buff *skb);
 __printf(3, 4)
-void HiSax_putstatus(struct IsdnCardState *cs, char *head, char *fmt, ...);
+void HiSax_putstatus(struct IsdnCardState *cs, char *head, const char *fmt, ...);
 __printf(3, 0)
-void VHiSax_putstatus(struct IsdnCardState *cs, char *head, char *fmt, va_list args);
+void VHiSax_putstatus(struct IsdnCardState *cs, char *head, const char *fmt, va_list args);
 void HiSax_reportcard(int cardnr, int sel);
 int QuickHex(char *txt, u_char *p, int cnt);
 void LogFrame(struct IsdnCardState *cs, u_char *p, int size);
diff --git a/drivers/isdn/hisax/icc.c b/drivers/isdn/hisax/icc.c
index 96d1df050..77a05ee6c 100644
--- a/drivers/isdn/hisax/icc.c
+++ b/drivers/isdn/hisax/icc.c
@@ -580,8 +580,9 @@ DC_Close_icc(struct IsdnCardState *cs) {
 }
 
 static void
-dbusy_timer_handler(struct IsdnCardState *cs)
+dbusy_timer_handler(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	struct PStack *stptr;
 	int	rbch, star;
 
@@ -676,7 +677,7 @@ clear_pending_icc_ints(struct IsdnCardState *cs)
 void setup_icc(struct IsdnCardState *cs)
 {
 	INIT_WORK(&cs->tqueue, icc_bh);
-	cs->dbusytimer.function = (void *) dbusy_timer_handler;
+	cs->dbusytimer.function = dbusy_timer_handler;
 	cs->dbusytimer.data = (long) cs;
 	init_timer(&cs->dbusytimer);
 }
diff --git a/drivers/isdn/hisax/ipacx.c b/drivers/isdn/hisax/ipacx.c
index 9cc26b40a..d7fa04459 100644
--- a/drivers/isdn/hisax/ipacx.c
+++ b/drivers/isdn/hisax/ipacx.c
@@ -35,7 +35,7 @@
 static void ph_command(struct IsdnCardState *cs, unsigned int command);
 static inline void cic_int(struct IsdnCardState *cs);
 static void dch_l2l1(struct PStack *st, int pr, void *arg);
-static void dbusy_timer_handler(struct IsdnCardState *cs);
+static void dbusy_timer_handler(unsigned long _cs);
 static void dch_empty_fifo(struct IsdnCardState *cs, int count);
 static void dch_fill_fifo(struct IsdnCardState *cs);
 static inline void dch_int(struct IsdnCardState *cs);
@@ -198,8 +198,9 @@ dch_l2l1(struct PStack *st, int pr, void *arg)
 //----------------------------------------------------------
 //----------------------------------------------------------
 static void
-dbusy_timer_handler(struct IsdnCardState *cs)
+dbusy_timer_handler(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	struct PStack *st;
 	int	rbchd, stard;
 
@@ -424,7 +425,7 @@ dch_init(struct IsdnCardState *cs)
 
 	cs->setstack_d      = dch_setstack;
 
-	cs->dbusytimer.function = (void *) dbusy_timer_handler;
+	cs->dbusytimer.function = dbusy_timer_handler;
 	cs->dbusytimer.data = (long) cs;
 	init_timer(&cs->dbusytimer);
 
diff --git a/drivers/isdn/hisax/isac.c b/drivers/isdn/hisax/isac.c
index df7e05ca8..0f7dca1b8 100644
--- a/drivers/isdn/hisax/isac.c
+++ b/drivers/isdn/hisax/isac.c
@@ -584,8 +584,9 @@ DC_Close_isac(struct IsdnCardState *cs)
 }
 
 static void
-dbusy_timer_handler(struct IsdnCardState *cs)
+dbusy_timer_handler(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	struct PStack *stptr;
 	int	rbch, star;
 
@@ -677,7 +678,7 @@ void clear_pending_isac_ints(struct IsdnCardState *cs)
 void setup_isac(struct IsdnCardState *cs)
 {
 	INIT_WORK(&cs->tqueue, isac_bh);
-	cs->dbusytimer.function = (void *) dbusy_timer_handler;
+	cs->dbusytimer.function = dbusy_timer_handler;
 	cs->dbusytimer.data = (long) cs;
 	init_timer(&cs->dbusytimer);
 }
diff --git a/drivers/isdn/hisax/isar.c b/drivers/isdn/hisax/isar.c
index f4956c73a..122d24947 100644
--- a/drivers/isdn/hisax/isar.c
+++ b/drivers/isdn/hisax/isar.c
@@ -1267,7 +1267,8 @@ isar_int_main(struct IsdnCardState *cs)
 }
 
 static void
-ftimer_handler(struct BCState *bcs) {
+ftimer_handler(unsigned long _bcs) {
+	struct BCState *bcs = (struct BCState *)_bcs;
 	if (bcs->cs->debug)
 		debugl1(bcs->cs, "ftimer flags %04lx",
 			bcs->Flag);
@@ -1902,7 +1903,7 @@ void initisar(struct IsdnCardState *cs)
 	cs->bcs[1].BC_SetStack = setstack_isar;
 	cs->bcs[0].BC_Close = close_isarstate;
 	cs->bcs[1].BC_Close = close_isarstate;
-	cs->bcs[0].hw.isar.ftimer.function = (void *) ftimer_handler;
+	cs->bcs[0].hw.isar.ftimer.function = ftimer_handler;
 	cs->bcs[0].hw.isar.ftimer.data = (long) &cs->bcs[0];
 	init_timer(&cs->bcs[0].hw.isar.ftimer);
 	cs->bcs[1].hw.isar.ftimer.function = (void *) ftimer_handler;
diff --git a/drivers/isdn/hisax/isdnl3.c b/drivers/isdn/hisax/isdnl3.c
index c754706f8..8b1ffd5d6 100644
--- a/drivers/isdn/hisax/isdnl3.c
+++ b/drivers/isdn/hisax/isdnl3.c
@@ -160,8 +160,9 @@ newl3state(struct l3_process *pc, int state)
 }
 
 static void
-L3ExpireTimer(struct L3Timer *t)
+L3ExpireTimer(unsigned long _t)
 {
+	struct L3Timer *t = (struct L3Timer *)_t;
 	t->pc->st->lli.l4l3(t->pc->st, t->event, t->pc);
 }
 
@@ -169,7 +170,7 @@ void
 L3InitTimer(struct l3_process *pc, struct L3Timer *t)
 {
 	t->pc = pc;
-	t->tl.function = (void *) L3ExpireTimer;
+	t->tl.function = L3ExpireTimer;
 	t->tl.data = (long) t;
 	init_timer(&t->tl);
 }
diff --git a/drivers/isdn/hisax/saphir.c b/drivers/isdn/hisax/saphir.c
index 6b2d0eccd..4bf5a9e50 100644
--- a/drivers/isdn/hisax/saphir.c
+++ b/drivers/isdn/hisax/saphir.c
@@ -159,8 +159,9 @@ Start_ISAC:
 }
 
 static void
-SaphirWatchDog(struct IsdnCardState *cs)
+SaphirWatchDog(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	u_long flags;
 
 	spin_lock_irqsave(&cs->lock, flags);
@@ -268,7 +269,7 @@ int setup_saphir(struct IsdnCard *card)
 	       cs->irq, cs->hw.saphir.cfg_reg);
 
 	setup_isac(cs);
-	cs->hw.saphir.timer.function = (void *) SaphirWatchDog;
+	cs->hw.saphir.timer.function = SaphirWatchDog;
 	cs->hw.saphir.timer.data = (long) cs;
 	init_timer(&cs->hw.saphir.timer);
 	cs->hw.saphir.timer.expires = jiffies + 4 * HZ;
diff --git a/drivers/isdn/hisax/teleint.c b/drivers/isdn/hisax/teleint.c
index bf647545c..e2a370924 100644
--- a/drivers/isdn/hisax/teleint.c
+++ b/drivers/isdn/hisax/teleint.c
@@ -179,8 +179,9 @@ Start_ISAC:
 }
 
 static void
-TeleInt_Timer(struct IsdnCardState *cs)
+TeleInt_Timer(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	int stat = 0;
 	u_long flags;
 
@@ -278,7 +279,7 @@ int setup_TeleInt(struct IsdnCard *card)
 	cs->bcs[0].hw.hfc.send = NULL;
 	cs->bcs[1].hw.hfc.send = NULL;
 	cs->hw.hfc.fifosize = 7 * 1024 + 512;
-	cs->hw.hfc.timer.function = (void *) TeleInt_Timer;
+	cs->hw.hfc.timer.function = TeleInt_Timer;
 	cs->hw.hfc.timer.data = (long) cs;
 	init_timer(&cs->hw.hfc.timer);
 	if (!request_region(cs->hw.hfc.addr, 2, "TeleInt isdn")) {
diff --git a/drivers/isdn/hisax/w6692.c b/drivers/isdn/hisax/w6692.c
index a85895585..908285bb0 100644
--- a/drivers/isdn/hisax/w6692.c
+++ b/drivers/isdn/hisax/w6692.c
@@ -681,8 +681,9 @@ DC_Close_W6692(struct IsdnCardState *cs)
 }
 
 static void
-dbusy_timer_handler(struct IsdnCardState *cs)
+dbusy_timer_handler(unsigned long _cs)
 {
+	struct IsdnCardState *cs = (struct IsdnCardState *)_cs;
 	struct PStack *stptr;
 	int rbch, star;
 	u_long flags;
@@ -901,7 +902,7 @@ static void initW6692(struct IsdnCardState *cs, int part)
 	if (part & 1) {
 		cs->setstack_d = setstack_W6692;
 		cs->DC_Close = DC_Close_W6692;
-		cs->dbusytimer.function = (void *) dbusy_timer_handler;
+		cs->dbusytimer.function = dbusy_timer_handler;
 		cs->dbusytimer.data = (long) cs;
 		init_timer(&cs->dbusytimer);
 		resetW6692(cs);
diff --git a/drivers/isdn/i4l/isdn_common.c b/drivers/isdn/i4l/isdn_common.c
index 9b856e189..fa03c92e8 100644
--- a/drivers/isdn/i4l/isdn_common.c
+++ b/drivers/isdn/i4l/isdn_common.c
@@ -1654,6 +1654,8 @@ isdn_ioctl(struct file *file, uint cmd, ulong arg)
 			} else
 				return -EINVAL;
 		case IIOCDBGVAR:
+			if (!capable(CAP_SYS_RAWIO))
+				return -EPERM;
 			if (arg) {
 				if (copy_to_user(argp, &dev, sizeof(ulong)))
 					return -EFAULT;
diff --git a/drivers/isdn/i4l/isdn_concap.c b/drivers/isdn/i4l/isdn_concap.c
index 91d57304d..336523ec0 100644
--- a/drivers/isdn/i4l/isdn_concap.c
+++ b/drivers/isdn/i4l/isdn_concap.c
@@ -80,9 +80,9 @@ static int isdn_concap_dl_disconn_req(struct concap_proto *concap)
 }
 
 struct concap_device_ops isdn_concap_reliable_dl_dops = {
-	&isdn_concap_dl_data_req,
-	&isdn_concap_dl_connect_req,
-	&isdn_concap_dl_disconn_req
+	.data_req = &isdn_concap_dl_data_req,
+	.connect_req = &isdn_concap_dl_connect_req,
+	.disconn_req = &isdn_concap_dl_disconn_req
 };
 
 /* The following should better go into a dedicated source file such that
diff --git a/drivers/isdn/i4l/isdn_tty.c b/drivers/isdn/i4l/isdn_tty.c
index 63eaa0a9f..00a663cca 100644
--- a/drivers/isdn/i4l/isdn_tty.c
+++ b/drivers/isdn/i4l/isdn_tty.c
@@ -1499,9 +1499,9 @@ isdn_tty_open(struct tty_struct *tty, struct file *filp)
 
 #ifdef ISDN_DEBUG_MODEM_OPEN
 	printk(KERN_DEBUG "isdn_tty_open %s, count = %d\n", tty->name,
-	       port->count);
+	       atomic_read(&port->count));
 #endif
-	port->count++;
+	atomic_inc(&port->count);
 	port->tty = tty;
 	/*
 	 * Start up serial port
@@ -1545,7 +1545,7 @@ isdn_tty_close(struct tty_struct *tty, struct file *filp)
 #endif
 		return;
 	}
-	if ((tty->count == 1) && (port->count != 1)) {
+	if ((tty->count == 1) && (atomic_read(&port->count) != 1)) {
 		/*
 		 * Uh, oh.  tty->count is 1, which means that the tty
 		 * structure will be freed.  Info->count should always
@@ -1554,15 +1554,15 @@ isdn_tty_close(struct tty_struct *tty, struct file *filp)
 		 * serial port won't be shutdown.
 		 */
 		printk(KERN_ERR "isdn_tty_close: bad port count; tty->count is 1, "
-		       "info->count is %d\n", port->count);
-		port->count = 1;
+		       "info->count is %d\n", atomic_read(&port->count));
+		atomic_set(&port->count, 1);
 	}
-	if (--port->count < 0) {
+	if (atomic_dec_return(&port->count) < 0) {
 		printk(KERN_ERR "isdn_tty_close: bad port count for ttyi%d: %d\n",
-		       info->line, port->count);
-		port->count = 0;
+		       info->line, atomic_read(&port->count));
+		atomic_set(&port->count, 0);
 	}
-	if (port->count) {
+	if (atomic_read(&port->count)) {
 #ifdef ISDN_DEBUG_MODEM_OPEN
 		printk(KERN_DEBUG "isdn_tty_close after info->count != 0\n");
 #endif
@@ -1617,7 +1617,7 @@ isdn_tty_hangup(struct tty_struct *tty)
 	if (isdn_tty_paranoia_check(info, tty->name, "isdn_tty_hangup"))
 		return;
 	isdn_tty_shutdown(info);
-	port->count = 0;
+	atomic_set(&port->count, 0);
 	tty_port_set_active(port, 0);
 	port->tty = NULL;
 	wake_up_interruptible(&port->open_wait);
@@ -1962,7 +1962,7 @@ isdn_tty_find_icall(int di, int ch, setup_parm *setup)
 	for (i = 0; i < ISDN_MAX_CHANNELS; i++) {
 		modem_info *info = &dev->mdm.info[i];
 
-		if (info->port.count == 0)
+		if (atomic_read(&info->port.count) == 0)
 			continue;
 		if ((info->emu.mdmreg[REG_SI1] & si2bit[si1]) &&  /* SI1 is matching */
 		    (info->emu.mdmreg[REG_SI2] == si2))	{         /* SI2 is matching */
diff --git a/drivers/isdn/i4l/isdn_x25iface.c b/drivers/isdn/i4l/isdn_x25iface.c
index 0c5d8de41..ba60076e0 100644
--- a/drivers/isdn/i4l/isdn_x25iface.c
+++ b/drivers/isdn/i4l/isdn_x25iface.c
@@ -53,14 +53,14 @@ static int isdn_x25iface_disconn_ind(struct concap_proto *);
 
 
 static struct concap_proto_ops ix25_pops = {
-	&isdn_x25iface_proto_new,
-	&isdn_x25iface_proto_del,
-	&isdn_x25iface_proto_restart,
-	&isdn_x25iface_proto_close,
-	&isdn_x25iface_xmit,
-	&isdn_x25iface_receive,
-	&isdn_x25iface_connect_ind,
-	&isdn_x25iface_disconn_ind
+	.proto_new = &isdn_x25iface_proto_new,
+	.proto_del = &isdn_x25iface_proto_del,
+	.restart = &isdn_x25iface_proto_restart,
+	.close = &isdn_x25iface_proto_close,
+	.encap_and_xmit = &isdn_x25iface_xmit,
+	.data_ind = &isdn_x25iface_receive,
+	.connect_ind = &isdn_x25iface_connect_ind,
+	.disconn_ind = &isdn_x25iface_disconn_ind
 };
 
 /* error message helper function */
diff --git a/drivers/isdn/mISDN/dsp.h b/drivers/isdn/mISDN/dsp.h
index fc1733a08..27bf26161 100644
--- a/drivers/isdn/mISDN/dsp.h
+++ b/drivers/isdn/mISDN/dsp.h
@@ -247,7 +247,7 @@ extern void dsp_cmx_hardware(struct dsp_conf *conf, struct dsp *dsp);
 extern int dsp_cmx_conf(struct dsp *dsp, u32 conf_id);
 extern void dsp_cmx_receive(struct dsp *dsp, struct sk_buff *skb);
 extern void dsp_cmx_hdlc(struct dsp *dsp, struct sk_buff *skb);
-extern void dsp_cmx_send(void *arg);
+extern void dsp_cmx_send(unsigned long arg);
 extern void dsp_cmx_transmit(struct dsp *dsp, struct sk_buff *skb);
 extern int dsp_cmx_del_conf_member(struct dsp *dsp);
 extern int dsp_cmx_del_conf(struct dsp_conf *conf);
@@ -259,7 +259,7 @@ extern u8 *dsp_dtmf_goertzel_decode(struct dsp *dsp, u8 *data, int len,
 
 extern int dsp_tone(struct dsp *dsp, int tone);
 extern void dsp_tone_copy(struct dsp *dsp, u8 *data, int len);
-extern void dsp_tone_timeout(void *arg);
+extern void dsp_tone_timeout(unsigned long arg);
 
 extern void dsp_bf_encrypt(struct dsp *dsp, u8 *data, int len);
 extern void dsp_bf_decrypt(struct dsp *dsp, u8 *data, int len);
diff --git a/drivers/isdn/mISDN/dsp_cmx.c b/drivers/isdn/mISDN/dsp_cmx.c
index 8e3aa0027..723faf82b 100644
--- a/drivers/isdn/mISDN/dsp_cmx.c
+++ b/drivers/isdn/mISDN/dsp_cmx.c
@@ -1625,8 +1625,8 @@ unsigned long	dsp_spl_jiffies; /* calculate the next time to fire */
 static u16	dsp_count; /* last sample count */
 static int	dsp_count_valid; /* if we have last sample count */
 
-void
-dsp_cmx_send(void *arg)
+void __intentional_overflow(-1)
+dsp_cmx_send(unsigned long arg)
 {
 	struct dsp_conf *conf;
 	struct dsp_conf_member *member;
diff --git a/drivers/isdn/mISDN/dsp_core.c b/drivers/isdn/mISDN/dsp_core.c
index 0222b1a35..67fb76a93 100644
--- a/drivers/isdn/mISDN/dsp_core.c
+++ b/drivers/isdn/mISDN/dsp_core.c
@@ -1092,7 +1092,7 @@ dspcreate(struct channel_req *crq)
 	ndsp->pcm_bank_tx = -1;
 	ndsp->hfc_conf = -1; /* current conference number */
 	/* set tone timer */
-	ndsp->tone.tl.function = (void *)dsp_tone_timeout;
+	ndsp->tone.tl.function = dsp_tone_timeout;
 	ndsp->tone.tl.data = (long) ndsp;
 	init_timer(&ndsp->tone.tl);
 
@@ -1204,7 +1204,7 @@ static int __init dsp_init(void)
 	}
 
 	/* set sample timer */
-	dsp_spl_tl.function = (void *)dsp_cmx_send;
+	dsp_spl_tl.function = dsp_cmx_send;
 	dsp_spl_tl.data = 0;
 	init_timer(&dsp_spl_tl);
 	dsp_spl_tl.expires = jiffies + dsp_tics;
diff --git a/drivers/isdn/mISDN/dsp_tones.c b/drivers/isdn/mISDN/dsp_tones.c
index 057e0d6a3..ed229b58f 100644
--- a/drivers/isdn/mISDN/dsp_tones.c
+++ b/drivers/isdn/mISDN/dsp_tones.c
@@ -457,9 +457,9 @@ dsp_tone_hw_message(struct dsp *dsp, u8 *sample, int len)
  * timer expires *
  *****************/
 void
-dsp_tone_timeout(void *arg)
+dsp_tone_timeout(unsigned long arg)
 {
-	struct dsp *dsp = arg;
+	struct dsp *dsp = (struct dsp *)arg;
 	struct dsp_tone *tone = &dsp->tone;
 	struct pattern *pat = (struct pattern *)tone->pattern;
 	int index = tone->index;
diff --git a/drivers/isdn/mISDN/fsm.c b/drivers/isdn/mISDN/fsm.c
index 26477d48b..4fa38762c 100644
--- a/drivers/isdn/mISDN/fsm.c
+++ b/drivers/isdn/mISDN/fsm.c
@@ -97,8 +97,9 @@ mISDN_FsmChangeState(struct FsmInst *fi, int newstate)
 EXPORT_SYMBOL(mISDN_FsmChangeState);
 
 static void
-FsmExpireTimer(struct FsmTimer *ft)
+FsmExpireTimer(unsigned long _ft)
 {
+	struct FsmTimer *ft = (struct FsmTimer *)_ft;
 #if FSM_TIMER_DEBUG
 	if (ft->fi->debug)
 		ft->fi->printdebug(ft->fi, "FsmExpireTimer %lx", (long) ft);
@@ -110,7 +111,7 @@ void
 mISDN_FsmInitTimer(struct FsmInst *fi, struct FsmTimer *ft)
 {
 	ft->fi = fi;
-	ft->tl.function = (void *) FsmExpireTimer;
+	ft->tl.function = FsmExpireTimer;
 	ft->tl.data = (long) ft;
 #if FSM_TIMER_DEBUG
 	if (ft->fi->debug)
diff --git a/drivers/isdn/mISDN/l1oip_core.c b/drivers/isdn/mISDN/l1oip_core.c
index 67c21876c..fc71e33ba 100644
--- a/drivers/isdn/mISDN/l1oip_core.c
+++ b/drivers/isdn/mISDN/l1oip_core.c
@@ -840,7 +840,7 @@ l1oip_send_bh(struct work_struct *work)
  * timer stuff
  */
 static void
-l1oip_keepalive(void *data)
+l1oip_keepalive(unsigned long data)
 {
 	struct l1oip *hc = (struct l1oip *)data;
 
@@ -848,7 +848,7 @@ l1oip_keepalive(void *data)
 }
 
 static void
-l1oip_timeout(void *data)
+l1oip_timeout(unsigned long data)
 {
 	struct l1oip			*hc = (struct l1oip *)data;
 	struct dchannel		*dch = hc->chan[hc->d_idx].dch;
@@ -1435,13 +1435,13 @@ init_card(struct l1oip *hc, int pri, int bundle)
 	if (ret)
 		return ret;
 
-	hc->keep_tl.function = (void *)l1oip_keepalive;
+	hc->keep_tl.function = l1oip_keepalive;
 	hc->keep_tl.data = (ulong)hc;
 	init_timer(&hc->keep_tl);
 	hc->keep_tl.expires = jiffies + 2 * HZ; /* two seconds first time */
 	add_timer(&hc->keep_tl);
 
-	hc->timeout_tl.function = (void *)l1oip_timeout;
+	hc->timeout_tl.function = l1oip_timeout;
 	hc->timeout_tl.data = (ulong)hc;
 	init_timer(&hc->timeout_tl);
 	hc->timeout_on = 0; /* state that we have timer off */
diff --git a/drivers/leds/leds-clevo-mail.c b/drivers/leds/leds-clevo-mail.c
index 0f9ed1ea0..492789f56 100644
--- a/drivers/leds/leds-clevo-mail.c
+++ b/drivers/leds/leds-clevo-mail.c
@@ -40,7 +40,7 @@ static int __init clevo_mail_led_dmi_callback(const struct dmi_system_id *id)
  * detected as working, but in reality it is not) as low as
  * possible.
  */
-static struct dmi_system_id clevo_mail_led_dmi_table[] __initdata = {
+static const struct dmi_system_id clevo_mail_led_dmi_table[] __initconst = {
 	{
 		.callback = clevo_mail_led_dmi_callback,
 		.ident = "Clevo D410J",
diff --git a/drivers/leds/leds-ss4200.c b/drivers/leds/leds-ss4200.c
index 732eb86bc..a9db8674c 100644
--- a/drivers/leds/leds-ss4200.c
+++ b/drivers/leds/leds-ss4200.c
@@ -91,7 +91,7 @@ MODULE_PARM_DESC(nodetect, "Skip DMI-based hardware detection");
  * detected as working, but in reality it is not) as low as
  * possible.
  */
-static struct dmi_system_id nas_led_whitelist[] __initdata = {
+static const struct dmi_system_id nas_led_whitelist[] __initconst = {
 	{
 		.callback = ss4200_led_dmi_callback,
 		.ident = "Intel SS4200-E",
diff --git a/drivers/lguest/core.c b/drivers/lguest/core.c
index 9e385b38d..70778823b 100644
--- a/drivers/lguest/core.c
+++ b/drivers/lguest/core.c
@@ -87,7 +87,7 @@ static __init int map_switcher(void)
 	 * Copy in the compiled-in Switcher code (from x86/switcher_32.S).
 	 * It goes in the first page, which we map in momentarily.
 	 */
-	memcpy(kmap(lg_switcher_pages[0]), start_switcher_text,
+	memcpy(kmap(lg_switcher_pages[0]), (void *)ktla_ktva((unsigned long)start_switcher_text),
 	       end_switcher_text - start_switcher_text);
 	kunmap(lg_switcher_pages[0]);
 
@@ -106,9 +106,16 @@ static __init int map_switcher(void)
 	 * We want the switcher text to be read-only and executable, and
 	 * the stacks to be read-write and non-executable.
 	 */
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	switcher_text_vma = __get_vm_area(PAGE_SIZE, VM_ALLOC|VM_NO_GUARD|VM_KERNEXEC,
+					  switcher_addr,
+					  switcher_addr + PAGE_SIZE);
+#else
 	switcher_text_vma = __get_vm_area(PAGE_SIZE, VM_ALLOC|VM_NO_GUARD,
 					  switcher_addr,
 					  switcher_addr + PAGE_SIZE);
+#endif
 
 	if (!switcher_text_vma) {
 		err = -ENOMEM;
diff --git a/drivers/lguest/page_tables.c b/drivers/lguest/page_tables.c
index e3abebc91..6a353284a 100644
--- a/drivers/lguest/page_tables.c
+++ b/drivers/lguest/page_tables.c
@@ -585,7 +585,7 @@ void pin_page(struct lg_cpu *cpu, unsigned long vaddr)
 /*:*/
 
 #ifdef CONFIG_X86_PAE
-static void release_pmd(pmd_t *spmd)
+static void __intentional_overflow(-1) release_pmd(pmd_t *spmd)
 {
 	/* If the entry's not present, there's nothing to release. */
 	if (pmd_flags(*spmd) & _PAGE_PRESENT) {
diff --git a/drivers/lguest/x86/core.c b/drivers/lguest/x86/core.c
index 6e9042e3d..befd030e3 100644
--- a/drivers/lguest/x86/core.c
+++ b/drivers/lguest/x86/core.c
@@ -60,7 +60,7 @@ static struct {
 /* Offset from where switcher.S was compiled to where we've copied it */
 static unsigned long switcher_offset(void)
 {
-	return switcher_addr - (unsigned long)start_switcher_text;
+	return switcher_addr - ktla_ktva((unsigned long)start_switcher_text);
 }
 
 /* This cpu's struct lguest_pages (after the Switcher text page) */
@@ -100,7 +100,13 @@ static void copy_in_guest_info(struct lg_cpu *cpu, struct lguest_pages *pages)
 	 * These copies are pretty cheap, so we do them unconditionally: */
 	/* Save the current Host top-level page directory.
 	 */
+
+#ifdef CONFIG_PAX_PER_CPU_PGD
+	pages->state.host_cr3 = read_cr3();
+#else
 	pages->state.host_cr3 = __pa(current->mm->pgd);
+#endif
+
 	/*
 	 * Set up the Guest's page tables to see this CPU's pages (and no
 	 * other CPU's pages).
@@ -498,7 +504,7 @@ void __init lguest_arch_host_init(void)
 	 * compiled-in switcher code and the high-mapped copy we just made.
 	 */
 	for (i = 0; i < IDT_ENTRIES; i++)
-		default_idt_entries[i] += switcher_offset();
+		default_idt_entries[i] = ktla_ktva(default_idt_entries[i]) + switcher_offset();
 
 	/*
 	 * Set up the Switcher's per-cpu areas.
@@ -581,7 +587,7 @@ void __init lguest_arch_host_init(void)
 	 * it will be undisturbed when we switch.  To change %cs and jump we
 	 * need this structure to feed to Intel's "lcall" instruction.
 	 */
-	lguest_entry.offset = (long)switch_to_guest + switcher_offset();
+	lguest_entry.offset = ktla_ktva((unsigned long)switch_to_guest) + switcher_offset();
 	lguest_entry.segment = LGUEST_CS;
 
 	/*
diff --git a/drivers/lguest/x86/switcher_32.S b/drivers/lguest/x86/switcher_32.S
index 40634b0db..4f5855e7c 100644
--- a/drivers/lguest/x86/switcher_32.S
+++ b/drivers/lguest/x86/switcher_32.S
@@ -87,6 +87,7 @@
 #include <asm/page.h>
 #include <asm/segment.h>
 #include <asm/lguest.h>
+#include <asm/processor-flags.h>
 
 // We mark the start of the code to copy
 // It's placed in .text tho it's never run here
@@ -149,6 +150,13 @@ ENTRY(switch_to_guest)
 	// Changes type when we load it: damn Intel!
 	// For after we switch over our page tables
 	// That entry will be read-only: we'd crash.
+
+#ifdef CONFIG_PAX_KERNEXEC
+	mov	%cr0, %edx
+	xor	$X86_CR0_WP, %edx
+	mov	%edx, %cr0
+#endif
+
 	movl	$(GDT_ENTRY_TSS*8), %edx
 	ltr	%dx
 
@@ -157,9 +165,15 @@ ENTRY(switch_to_guest)
 	// Let's clear it again for our return.
 	// The GDT descriptor of the Host
 	// Points to the table after two "size" bytes
-	movl	(LGUEST_PAGES_host_gdt_desc+2)(%eax), %edx
+	movl	(LGUEST_PAGES_host_gdt_desc+2)(%eax), %eax
 	// Clear "used" from type field (byte 5, bit 2)
-	andb	$0xFD, (GDT_ENTRY_TSS*8 + 5)(%edx)
+	andb	$0xFD, (GDT_ENTRY_TSS*8 + 5)(%eax)
+
+#ifdef CONFIG_PAX_KERNEXEC
+	mov	%cr0, %eax
+	xor	$X86_CR0_WP, %eax
+	mov	%eax, %cr0
+#endif
 
 	// Once our page table's switched, the Guest is live!
 	// The Host fades as we run this final step.
@@ -295,13 +309,12 @@ deliver_to_host:
 	// I consulted gcc, and it gave
 	// These instructions, which I gladly credit:
 	leal	(%edx,%ebx,8), %eax
-	movzwl	(%eax),%edx
-	movl	4(%eax), %eax
-	xorw	%ax, %ax
-	orl	%eax, %edx
+	movl	4(%eax), %edx
+	movw	(%eax), %dx
 	// Now the address of the handler's in %edx
 	// We call it now: its "iret" drops us home.
-	jmp	*%edx
+	ljmp	$__KERNEL_CS, $1f
+1:	jmp	*%edx
 
 // Every interrupt can come to us here
 // But we must truly tell each apart.
diff --git a/drivers/lightnvm/rrpc.c b/drivers/lightnvm/rrpc.c
index 37fcaadbf..e2be8ad3c 100644
--- a/drivers/lightnvm/rrpc.c
+++ b/drivers/lightnvm/rrpc.c
@@ -231,7 +231,7 @@ static void rrpc_put_blks(struct rrpc *rrpc)
 
 static struct rrpc_lun *get_next_lun(struct rrpc *rrpc)
 {
-	int next = atomic_inc_return(&rrpc->next_lun);
+	int next = atomic_inc_return_unchecked(&rrpc->next_lun);
 
 	return &rrpc->luns[next % rrpc->nr_luns];
 }
@@ -1389,7 +1389,7 @@ static void *rrpc_init(struct nvm_dev *dev, struct gendisk *tdisk,
 	rrpc->nr_sects = (unsigned long long)dev->sec_per_lun * rrpc->nr_luns;
 
 	/* simple round-robin strategy */
-	atomic_set(&rrpc->next_lun, -1);
+	atomic_set_unchecked(&rrpc->next_lun, -1);
 
 	ret = rrpc_area_init(rrpc, &soffset);
 	if (ret < 0) {
diff --git a/drivers/lightnvm/rrpc.h b/drivers/lightnvm/rrpc.h
index 5e87d52cb..26660404e 100644
--- a/drivers/lightnvm/rrpc.h
+++ b/drivers/lightnvm/rrpc.h
@@ -104,7 +104,7 @@ struct rrpc {
 	/* Write strategy variables. Move these into each for structure for each
 	 * strategy
 	 */
-	atomic_t next_lun; /* Whenever a page is written, this is updated
+	atomic_unchecked_t next_lun; /* Whenever a page is written, this is updated
 			    * to point to the next write lun
 			    */
 
diff --git a/drivers/md/bcache/Kconfig b/drivers/md/bcache/Kconfig
index 4d200883c..de60cb294 100644
--- a/drivers/md/bcache/Kconfig
+++ b/drivers/md/bcache/Kconfig
@@ -20,6 +20,7 @@ config BCACHE_CLOSURES_DEBUG
 	bool "Debug closures"
 	depends on BCACHE
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	---help---
 	Keeps all active closures in a linked list and provides a debugfs
 	interface to list them, which makes it possible to see asynchronous
diff --git a/drivers/md/bcache/alloc.c b/drivers/md/bcache/alloc.c
index ca4abe1cc..0b029ef6f 100644
--- a/drivers/md/bcache/alloc.c
+++ b/drivers/md/bcache/alloc.c
@@ -631,7 +631,7 @@ bool bch_alloc_sectors(struct cache_set *c, struct bkey *k, unsigned sectors,
 	for (i = 0; i < KEY_PTRS(&b->key); i++) {
 		SET_PTR_OFFSET(&b->key, i, PTR_OFFSET(&b->key, i) + sectors);
 
-		atomic_long_add(sectors,
+		atomic_long_add_unchecked(sectors,
 				&PTR_CACHE(c, &b->key, i)->sectors_written);
 	}
 
diff --git a/drivers/md/bcache/bcache.h b/drivers/md/bcache/bcache.h
index 6b420a55c..d5acb8fc5 100644
--- a/drivers/md/bcache/bcache.h
+++ b/drivers/md/bcache/bcache.h
@@ -433,12 +433,12 @@ struct cache {
 
 	/* The rest of this all shows up in sysfs */
 #define IO_ERROR_SHIFT		20
-	atomic_t		io_errors;
-	atomic_t		io_count;
+	atomic_unchecked_t	io_errors;
+	atomic_unchecked_t	io_count;
 
-	atomic_long_t		meta_sectors_written;
-	atomic_long_t		btree_sectors_written;
-	atomic_long_t		sectors_written;
+	atomic_long_unchecked_t	meta_sectors_written;
+	atomic_long_unchecked_t	btree_sectors_written;
+	atomic_long_unchecked_t	sectors_written;
 };
 
 struct gc_stat {
diff --git a/drivers/md/bcache/btree.c b/drivers/md/bcache/btree.c
index 76f7534d1..f5ad9e679 100644
--- a/drivers/md/bcache/btree.c
+++ b/drivers/md/bcache/btree.c
@@ -336,15 +336,17 @@ static void btree_complete_write(struct btree *b, struct btree_write *w)
 	w->journal	= NULL;
 }
 
-static void btree_node_write_unlock(struct closure *cl)
+static void btree_node_write_unlock(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct btree *b = container_of(cl, struct btree, io);
 
 	up(&b->io_mutex);
 }
 
-static void __btree_node_write_done(struct closure *cl)
+static void __btree_node_write_done(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct btree *b = container_of(cl, struct btree, io);
 	struct btree_write *w = btree_prev_write(b);
 
@@ -358,8 +360,9 @@ static void __btree_node_write_done(struct closure *cl)
 	closure_return_with_destructor(cl, btree_node_write_unlock);
 }
 
-static void btree_node_write_done(struct closure *cl)
+static void btree_node_write_done(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct btree *b = container_of(cl, struct btree, io);
 	struct bio_vec *bv;
 	int n;
@@ -367,7 +370,7 @@ static void btree_node_write_done(struct closure *cl)
 	bio_for_each_segment_all(bv, b->bio, n)
 		__free_page(bv->bv_page);
 
-	__btree_node_write_done(cl);
+	__btree_node_write_done(&cl->work);
 }
 
 static void btree_node_write_endio(struct bio *bio)
@@ -467,7 +470,7 @@ void __bch_btree_node_write(struct btree *b, struct closure *parent)
 
 	do_btree_node_write(b);
 
-	atomic_long_add(set_blocks(i, block_bytes(b->c)) * b->c->sb.block_size,
+	atomic_long_add_unchecked(set_blocks(i, block_bytes(b->c)) * b->c->sb.block_size,
 			&PTR_CACHE(b->c, &b->key, 0)->btree_sectors_written);
 
 	b->written += set_blocks(i, block_bytes(b->c));
diff --git a/drivers/md/bcache/closure.c b/drivers/md/bcache/closure.c
index 864e673ae..9c022d197 100644
--- a/drivers/md/bcache/closure.c
+++ b/drivers/md/bcache/closure.c
@@ -29,12 +29,12 @@ static inline void closure_put_after_sub(struct closure *cl, int flags)
 			closure_queue(cl);
 		} else {
 			struct closure *parent = cl->parent;
-			closure_fn *destructor = cl->fn;
+			work_func_t destructor = cl->fn;
 
 			closure_debug_destroy(cl);
 
 			if (destructor)
-				destructor(cl);
+				destructor(&cl->work);
 
 			if (parent)
 				closure_put(parent);
diff --git a/drivers/md/bcache/closure.h b/drivers/md/bcache/closure.h
index 9b2fe2d3e..be17fd240 100644
--- a/drivers/md/bcache/closure.h
+++ b/drivers/md/bcache/closure.h
@@ -152,7 +152,7 @@ struct closure {
 			struct workqueue_struct *wq;
 			struct task_struct	*task;
 			struct llist_node	list;
-			closure_fn		*fn;
+			work_func_t		fn;
 		};
 		struct work_struct	work;
 	};
@@ -236,10 +236,10 @@ static inline void closure_set_stopped(struct closure *cl)
 	atomic_sub(CLOSURE_RUNNING, &cl->remaining);
 }
 
-static inline void set_closure_fn(struct closure *cl, closure_fn *fn,
+static inline void set_closure_fn(struct closure *cl, work_func_t fn,
 				  struct workqueue_struct *wq)
 {
-	BUG_ON(object_is_on_stack(cl));
+	BUG_ON(object_starts_on_stack(cl));
 	closure_set_ip(cl);
 	cl->fn = fn;
 	cl->wq = wq;
@@ -254,7 +254,7 @@ static inline void closure_queue(struct closure *cl)
 		INIT_WORK(&cl->work, cl->work.func);
 		BUG_ON(!queue_work(wq, &cl->work));
 	} else
-		cl->fn(cl);
+		cl->fn(&cl->work);
 }
 
 /**
@@ -373,7 +373,7 @@ do {									\
  * asynchronously out of a new closure - @parent will then wait for @cl to
  * finish.
  */
-static inline void closure_call(struct closure *cl, closure_fn fn,
+static inline void closure_call(struct closure *cl, work_func_t fn,
 				struct workqueue_struct *wq,
 				struct closure *parent)
 {
diff --git a/drivers/md/bcache/io.c b/drivers/md/bcache/io.c
index e97b0acf7..5aff0fa37 100644
--- a/drivers/md/bcache/io.c
+++ b/drivers/md/bcache/io.c
@@ -60,7 +60,7 @@ void bch_count_io_errors(struct cache *ca, int error, const char *m)
 	 */
 
 	if (ca->set->error_decay) {
-		unsigned count = atomic_inc_return(&ca->io_count);
+		unsigned count = atomic_inc_return_unchecked(&ca->io_count);
 
 		while (count > ca->set->error_decay) {
 			unsigned errors;
@@ -72,16 +72,16 @@ void bch_count_io_errors(struct cache *ca, int error, const char *m)
 			 * succesfully do so, we rescale the errors once:
 			 */
 
-			count = atomic_cmpxchg(&ca->io_count, old, new);
+			count = atomic_cmpxchg_unchecked(&ca->io_count, old, new);
 
 			if (count == old) {
 				count = new;
 
-				errors = atomic_read(&ca->io_errors);
+				errors = atomic_read_unchecked(&ca->io_errors);
 				do {
 					old = errors;
 					new = ((uint64_t) errors * 127) / 128;
-					errors = atomic_cmpxchg(&ca->io_errors,
+					errors = atomic_cmpxchg_unchecked(&ca->io_errors,
 								old, new);
 				} while (old != errors);
 			}
@@ -90,7 +90,7 @@ void bch_count_io_errors(struct cache *ca, int error, const char *m)
 
 	if (error) {
 		char buf[BDEVNAME_SIZE];
-		unsigned errors = atomic_add_return(1 << IO_ERROR_SHIFT,
+		unsigned errors = atomic_add_return_unchecked(1 << IO_ERROR_SHIFT,
 						    &ca->io_errors);
 		errors >>= IO_ERROR_SHIFT;
 
diff --git a/drivers/md/bcache/journal.c b/drivers/md/bcache/journal.c
index 6925023e1..bff91f00c 100644
--- a/drivers/md/bcache/journal.c
+++ b/drivers/md/bcache/journal.c
@@ -555,10 +555,11 @@ static void journal_write_endio(struct bio *bio)
 	closure_put(&w->c->journal.io);
 }
 
-static void journal_write(struct closure *);
+static void journal_write(struct work_struct *);
 
-static void journal_write_done(struct closure *cl)
+static void journal_write_done(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct journal *j = container_of(cl, struct journal, io);
 	struct journal_write *w = (j->cur == j->w)
 		? &j->w[1]
@@ -568,17 +569,19 @@ static void journal_write_done(struct closure *cl)
 	continue_at_nobarrier(cl, journal_write, system_wq);
 }
 
-static void journal_write_unlock(struct closure *cl)
+static void journal_write_unlock(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, journal.io);
 
 	c->journal.io_in_flight = 0;
 	spin_unlock(&c->journal.lock);
 }
 
-static void journal_write_unlocked(struct closure *cl)
+static void journal_write_unlocked(struct work_struct *work)
 	__releases(c->journal.lock)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, journal.io);
 	struct cache *ca;
 	struct journal_write *w = c->journal.cur;
@@ -621,7 +624,7 @@ static void journal_write_unlocked(struct closure *cl)
 		ca = PTR_CACHE(c, k, i);
 		bio = &ca->journal.bio;
 
-		atomic_long_add(sectors, &ca->meta_sectors_written);
+		atomic_long_add_unchecked(sectors, &ca->meta_sectors_written);
 
 		bio_reset(bio);
 		bio->bi_iter.bi_sector	= PTR_OFFSET(k, i);
@@ -654,12 +657,13 @@ static void journal_write_unlocked(struct closure *cl)
 	continue_at(cl, journal_write_done, NULL);
 }
 
-static void journal_write(struct closure *cl)
+static void journal_write(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, journal.io);
 
 	spin_lock(&c->journal.lock);
-	journal_write_unlocked(cl);
+	journal_write_unlocked(&cl->work);
 }
 
 static void journal_try_write(struct cache_set *c)
diff --git a/drivers/md/bcache/movinggc.c b/drivers/md/bcache/movinggc.c
index 1881319f2..bec49974e 100644
--- a/drivers/md/bcache/movinggc.c
+++ b/drivers/md/bcache/movinggc.c
@@ -34,14 +34,16 @@ static bool moving_pred(struct keybuf *buf, struct bkey *k)
 
 /* Moving GC - IO loop */
 
-static void moving_io_destructor(struct closure *cl)
+static void moving_io_destructor(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct moving_io *io = container_of(cl, struct moving_io, cl);
 	kfree(io);
 }
 
-static void write_moving_finish(struct closure *cl)
+static void write_moving_finish(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct moving_io *io = container_of(cl, struct moving_io, cl);
 	struct bio *bio = &io->bio.bio;
 	struct bio_vec *bv;
@@ -92,8 +94,9 @@ static void moving_init(struct moving_io *io)
 	bch_bio_map(bio, NULL);
 }
 
-static void write_moving(struct closure *cl)
+static void write_moving(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct moving_io *io = container_of(cl, struct moving_io, cl);
 	struct data_insert_op *op = &io->op;
 
@@ -116,8 +119,9 @@ static void write_moving(struct closure *cl)
 	continue_at(cl, write_moving_finish, op->wq);
 }
 
-static void read_moving_submit(struct closure *cl)
+static void read_moving_submit(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct moving_io *io = container_of(cl, struct moving_io, cl);
 	struct bio *bio = &io->bio.bio;
 
diff --git a/drivers/md/bcache/request.c b/drivers/md/bcache/request.c
index 4b177fe11..be3cbd431 100644
--- a/drivers/md/bcache/request.c
+++ b/drivers/md/bcache/request.c
@@ -24,7 +24,7 @@
 
 struct kmem_cache *bch_search_cache;
 
-static void bch_data_insert_start(struct closure *);
+static void bch_data_insert_start(struct work_struct *);
 
 static unsigned cache_mode(struct cached_dev *dc, struct bio *bio)
 {
@@ -53,8 +53,9 @@ static void bio_csum(struct bio *bio, struct bkey *k)
 
 /* Insert data into cache */
 
-static void bch_data_insert_keys(struct closure *cl)
+static void bch_data_insert_keys(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct data_insert_op *op = container_of(cl, struct data_insert_op, cl);
 	atomic_t *journal_ref = NULL;
 	struct bkey *replace_key = op->replace ? &op->replace_key : NULL;
@@ -143,8 +144,9 @@ out:
 	continue_at(cl, bch_data_insert_keys, op->wq);
 }
 
-static void bch_data_insert_error(struct closure *cl)
+static void bch_data_insert_error(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct data_insert_op *op = container_of(cl, struct data_insert_op, cl);
 
 	/*
@@ -170,7 +172,7 @@ static void bch_data_insert_error(struct closure *cl)
 
 	op->insert_keys.top = dst;
 
-	bch_data_insert_keys(cl);
+	bch_data_insert_keys(&cl->work);
 }
 
 static void bch_data_insert_endio(struct bio *bio)
@@ -191,8 +193,9 @@ static void bch_data_insert_endio(struct bio *bio)
 	bch_bbio_endio(op->c, bio, bio->bi_error, "writing data to cache");
 }
 
-static void bch_data_insert_start(struct closure *cl)
+static void bch_data_insert_start(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct data_insert_op *op = container_of(cl, struct data_insert_op, cl);
 	struct bio *bio = op->bio, *n;
 
@@ -313,8 +316,9 @@ err:
  * If s->bypass is true, instead of inserting the data it invalidates the
  * region of the cache represented by s->cache_bio and op->inode.
  */
-void bch_data_insert(struct closure *cl)
+void bch_data_insert(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct data_insert_op *op = container_of(cl, struct data_insert_op, cl);
 
 	trace_bcache_write(op->c, op->inode, op->bio,
@@ -322,7 +326,7 @@ void bch_data_insert(struct closure *cl)
 
 	bch_keylist_init(&op->insert_keys);
 	bio_get(op->bio);
-	bch_data_insert_start(cl);
+	bch_data_insert_start(&cl->work);
 }
 
 /* Congested? */
@@ -570,8 +574,9 @@ static int cache_lookup_fn(struct btree_op *op, struct btree *b, struct bkey *k)
 	return n == bio ? MAP_DONE : MAP_CONTINUE;
 }
 
-static void cache_lookup(struct closure *cl)
+static void cache_lookup(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, iop.cl);
 	struct bio *bio = &s->bio.bio;
 	int ret;
@@ -631,8 +636,9 @@ static void do_bio_hook(struct search *s, struct bio *orig_bio)
 	bio_cnt_set(bio, 3);
 }
 
-static void search_free(struct closure *cl)
+static void search_free(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 	bio_complete(s);
 
@@ -676,19 +682,21 @@ static inline struct search *search_alloc(struct bio *bio,
 
 /* Cached devices */
 
-static void cached_dev_bio_complete(struct closure *cl)
+static void cached_dev_bio_complete(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 	struct cached_dev *dc = container_of(s->d, struct cached_dev, disk);
 
-	search_free(cl);
+	search_free(&cl->work);
 	cached_dev_put(dc);
 }
 
 /* Process reads */
 
-static void cached_dev_cache_miss_done(struct closure *cl)
+static void cached_dev_cache_miss_done(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 
 	if (s->iop.replace_collision)
@@ -702,11 +710,12 @@ static void cached_dev_cache_miss_done(struct closure *cl)
 			__free_page(bv->bv_page);
 	}
 
-	cached_dev_bio_complete(cl);
+	cached_dev_bio_complete(&cl->work);
 }
 
-static void cached_dev_read_error(struct closure *cl)
+static void cached_dev_read_error(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 	struct bio *bio = &s->bio.bio;
 
@@ -725,8 +734,9 @@ static void cached_dev_read_error(struct closure *cl)
 	continue_at(cl, cached_dev_cache_miss_done, NULL);
 }
 
-static void cached_dev_read_done(struct closure *cl)
+static void cached_dev_read_done(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 	struct cached_dev *dc = container_of(s->d, struct cached_dev, disk);
 
@@ -765,8 +775,9 @@ static void cached_dev_read_done(struct closure *cl)
 	continue_at(cl, cached_dev_cache_miss_done, NULL);
 }
 
-static void cached_dev_read_done_bh(struct closure *cl)
+static void cached_dev_read_done_bh(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 	struct cached_dev *dc = container_of(s->d, struct cached_dev, disk);
 
@@ -864,13 +875,14 @@ static void cached_dev_read(struct cached_dev *dc, struct search *s)
 
 /* Process writes */
 
-static void cached_dev_write_complete(struct closure *cl)
+static void cached_dev_write_complete(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 	struct cached_dev *dc = container_of(s->d, struct cached_dev, disk);
 
 	up_read_non_owner(&dc->writeback_lock);
-	cached_dev_bio_complete(cl);
+	cached_dev_bio_complete(&cl->work);
 }
 
 static void cached_dev_write(struct cached_dev *dc, struct search *s)
@@ -942,8 +954,9 @@ static void cached_dev_write(struct cached_dev *dc, struct search *s)
 	continue_at(cl, cached_dev_write_complete, NULL);
 }
 
-static void cached_dev_nodata(struct closure *cl)
+static void cached_dev_nodata(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 	struct bio *bio = &s->bio.bio;
 
@@ -1063,8 +1076,9 @@ static int flash_dev_cache_miss(struct btree *b, struct search *s,
 	return MAP_CONTINUE;
 }
 
-static void flash_dev_nodata(struct closure *cl)
+static void flash_dev_nodata(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct search *s = container_of(cl, struct search, cl);
 
 	if (s->iop.flush_journal)
diff --git a/drivers/md/bcache/request.h b/drivers/md/bcache/request.h
index 1ff36875c..b8f4a05aa 100644
--- a/drivers/md/bcache/request.h
+++ b/drivers/md/bcache/request.h
@@ -33,7 +33,7 @@ struct data_insert_op {
 };
 
 unsigned bch_get_congested(struct cache_set *);
-void bch_data_insert(struct closure *cl);
+void bch_data_insert(struct work_struct *work);
 
 void bch_cached_dev_request_init(struct cached_dev *dc);
 void bch_flash_dev_request_init(struct bcache_device *d);
diff --git a/drivers/md/bcache/stats.c b/drivers/md/bcache/stats.c
index 0ca072c20..5e6e5c36c 100644
--- a/drivers/md/bcache/stats.c
+++ b/drivers/md/bcache/stats.c
@@ -120,7 +120,7 @@ void bch_cache_accounting_destroy(struct cache_accounting *acc)
 	kobject_put(&acc->hour.kobj);
 	kobject_put(&acc->day.kobj);
 
-	atomic_set(&acc->closing, 1);
+	atomic_set_unchecked(&acc->closing, 1);
 	if (del_timer_sync(&acc->timer))
 		closure_return(&acc->cl);
 }
@@ -151,7 +151,7 @@ static void scale_accounting(unsigned long data)
 	struct cache_accounting *acc = (struct cache_accounting *) data;
 
 #define move_stat(name) do {						\
-	unsigned t = atomic_xchg(&acc->collector.name, 0);		\
+	unsigned t = atomic_xchg_unchecked(&acc->collector.name, 0);	\
 	t <<= 16;							\
 	acc->five_minute.name += t;					\
 	acc->hour.name += t;						\
@@ -174,7 +174,7 @@ static void scale_accounting(unsigned long data)
 
 	acc->timer.expires += accounting_delay;
 
-	if (!atomic_read(&acc->closing))
+	if (!atomic_read_unchecked(&acc->closing))
 		add_timer(&acc->timer);
 	else
 		closure_return(&acc->cl);
@@ -185,14 +185,14 @@ static void mark_cache_stats(struct cache_stat_collector *stats,
 {
 	if (!bypass)
 		if (hit)
-			atomic_inc(&stats->cache_hits);
+			atomic_inc_unchecked(&stats->cache_hits);
 		else
-			atomic_inc(&stats->cache_misses);
+			atomic_inc_unchecked(&stats->cache_misses);
 	else
 		if (hit)
-			atomic_inc(&stats->cache_bypass_hits);
+			atomic_inc_unchecked(&stats->cache_bypass_hits);
 		else
-			atomic_inc(&stats->cache_bypass_misses);
+			atomic_inc_unchecked(&stats->cache_bypass_misses);
 }
 
 void bch_mark_cache_accounting(struct cache_set *c, struct bcache_device *d,
@@ -206,22 +206,22 @@ void bch_mark_cache_accounting(struct cache_set *c, struct bcache_device *d,
 void bch_mark_cache_readahead(struct cache_set *c, struct bcache_device *d)
 {
 	struct cached_dev *dc = container_of(d, struct cached_dev, disk);
-	atomic_inc(&dc->accounting.collector.cache_readaheads);
-	atomic_inc(&c->accounting.collector.cache_readaheads);
+	atomic_inc_unchecked(&dc->accounting.collector.cache_readaheads);
+	atomic_inc_unchecked(&c->accounting.collector.cache_readaheads);
 }
 
 void bch_mark_cache_miss_collision(struct cache_set *c, struct bcache_device *d)
 {
 	struct cached_dev *dc = container_of(d, struct cached_dev, disk);
-	atomic_inc(&dc->accounting.collector.cache_miss_collisions);
-	atomic_inc(&c->accounting.collector.cache_miss_collisions);
+	atomic_inc_unchecked(&dc->accounting.collector.cache_miss_collisions);
+	atomic_inc_unchecked(&c->accounting.collector.cache_miss_collisions);
 }
 
 void bch_mark_sectors_bypassed(struct cache_set *c, struct cached_dev *dc,
 			       int sectors)
 {
-	atomic_add(sectors, &dc->accounting.collector.sectors_bypassed);
-	atomic_add(sectors, &c->accounting.collector.sectors_bypassed);
+	atomic_add_unchecked(sectors, &dc->accounting.collector.sectors_bypassed);
+	atomic_add_unchecked(sectors, &c->accounting.collector.sectors_bypassed);
 }
 
 void bch_cache_accounting_init(struct cache_accounting *acc,
diff --git a/drivers/md/bcache/stats.h b/drivers/md/bcache/stats.h
index adbff141c..018c2d2e3 100644
--- a/drivers/md/bcache/stats.h
+++ b/drivers/md/bcache/stats.h
@@ -2,13 +2,13 @@
 #define _BCACHE_STATS_H_
 
 struct cache_stat_collector {
-	atomic_t cache_hits;
-	atomic_t cache_misses;
-	atomic_t cache_bypass_hits;
-	atomic_t cache_bypass_misses;
-	atomic_t cache_readaheads;
-	atomic_t cache_miss_collisions;
-	atomic_t sectors_bypassed;
+	atomic_unchecked_t cache_hits;
+	atomic_unchecked_t cache_misses;
+	atomic_unchecked_t cache_bypass_hits;
+	atomic_unchecked_t cache_bypass_misses;
+	atomic_unchecked_t cache_readaheads;
+	atomic_unchecked_t cache_miss_collisions;
+	atomic_unchecked_t sectors_bypassed;
 };
 
 struct cache_stats {
@@ -28,7 +28,7 @@ struct cache_stats {
 struct cache_accounting {
 	struct closure		cl;
 	struct timer_list	timer;
-	atomic_t		closing;
+	atomic_unchecked_t	closing;
 
 	struct cache_stat_collector collector;
 
diff --git a/drivers/md/bcache/super.c b/drivers/md/bcache/super.c
index 849ad441c..a9e695e27 100644
--- a/drivers/md/bcache/super.c
+++ b/drivers/md/bcache/super.c
@@ -240,8 +240,9 @@ static void __write_super(struct cache_sb *sb, struct bio *bio)
 	submit_bio(bio);
 }
 
-static void bch_write_bdev_super_unlock(struct closure *cl)
+static void bch_write_bdev_super_unlock(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cached_dev *dc = container_of(cl, struct cached_dev, sb_write);
 
 	up(&dc->sb_write_mutex);
@@ -274,8 +275,9 @@ static void write_super_endio(struct bio *bio)
 	closure_put(&ca->set->sb_write);
 }
 
-static void bcache_write_super_unlock(struct closure *cl)
+static void bcache_write_super_unlock(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, sb_write);
 
 	up(&c->sb_write_mutex);
@@ -325,8 +327,9 @@ static void uuid_endio(struct bio *bio)
 	closure_put(cl);
 }
 
-static void uuid_io_unlock(struct closure *cl)
+static void uuid_io_unlock(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, uuid_write);
 
 	up(&c->uuid_write_mutex);
@@ -531,7 +534,7 @@ void bch_prio_write(struct cache *ca)
 
 	ca->disk_buckets->seq++;
 
-	atomic_long_add(ca->sb.bucket_size * prio_buckets(ca),
+	atomic_long_add_unchecked(ca->sb.bucket_size * prio_buckets(ca),
 			&ca->meta_sectors_written);
 
 	//pr_debug("free %zu, free_inc %zu, unused %zu", fifo_used(&ca->free),
@@ -1051,8 +1054,9 @@ void bch_cached_dev_release(struct kobject *kobj)
 	module_put(THIS_MODULE);
 }
 
-static void cached_dev_free(struct closure *cl)
+static void cached_dev_free(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cached_dev *dc = container_of(cl, struct cached_dev, disk.cl);
 
 	cancel_delayed_work_sync(&dc->writeback_rate_update);
@@ -1076,8 +1080,9 @@ static void cached_dev_free(struct closure *cl)
 	kobject_put(&dc->disk.kobj);
 }
 
-static void cached_dev_flush(struct closure *cl)
+static void cached_dev_flush(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cached_dev *dc = container_of(cl, struct cached_dev, disk.cl);
 	struct bcache_device *d = &dc->disk;
 
@@ -1193,8 +1198,9 @@ void bch_flash_dev_release(struct kobject *kobj)
 	kfree(d);
 }
 
-static void flash_dev_free(struct closure *cl)
+static void flash_dev_free(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct bcache_device *d = container_of(cl, struct bcache_device, cl);
 	mutex_lock(&bch_register_lock);
 	bcache_device_free(d);
@@ -1202,8 +1208,9 @@ static void flash_dev_free(struct closure *cl)
 	kobject_put(&d->kobj);
 }
 
-static void flash_dev_flush(struct closure *cl)
+static void flash_dev_flush(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct bcache_device *d = container_of(cl, struct bcache_device, cl);
 
 	mutex_lock(&bch_register_lock);
@@ -1322,8 +1329,9 @@ void bch_cache_set_release(struct kobject *kobj)
 	module_put(THIS_MODULE);
 }
 
-static void cache_set_free(struct closure *cl)
+static void cache_set_free(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, cl);
 	struct cache *ca;
 	unsigned i;
@@ -1368,8 +1376,9 @@ static void cache_set_free(struct closure *cl)
 	kobject_put(&c->kobj);
 }
 
-static void cache_set_flush(struct closure *cl)
+static void cache_set_flush(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, caching);
 	struct cache *ca;
 	struct btree *b;
@@ -1410,8 +1419,9 @@ static void cache_set_flush(struct closure *cl)
 	closure_return(cl);
 }
 
-static void __cache_set_unregister(struct closure *cl)
+static void __cache_set_unregister(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct cache_set *c = container_of(cl, struct cache_set, caching);
 	struct cached_dev *dc;
 	size_t i;
diff --git a/drivers/md/bcache/sysfs.c b/drivers/md/bcache/sysfs.c
index b3ff57d61..b2e30fb99 100644
--- a/drivers/md/bcache/sysfs.c
+++ b/drivers/md/bcache/sysfs.c
@@ -739,15 +739,15 @@ SHOW(__bch_cache)
 	sysfs_hprint(block_size,	block_bytes(ca));
 	sysfs_print(nbuckets,		ca->sb.nbuckets);
 	sysfs_print(discard,		ca->discard);
-	sysfs_hprint(written, atomic_long_read(&ca->sectors_written) << 9);
+	sysfs_hprint(written, atomic_long_read_unchecked(&ca->sectors_written) << 9);
 	sysfs_hprint(btree_written,
-		     atomic_long_read(&ca->btree_sectors_written) << 9);
+		     atomic_long_read_unchecked(&ca->btree_sectors_written) << 9);
 	sysfs_hprint(metadata_written,
-		     (atomic_long_read(&ca->meta_sectors_written) +
-		      atomic_long_read(&ca->btree_sectors_written)) << 9);
+		     (atomic_long_read_unchecked(&ca->meta_sectors_written) +
+		      atomic_long_read_unchecked(&ca->btree_sectors_written)) << 9);
 
 	sysfs_print(io_errors,
-		    atomic_read(&ca->io_errors) >> IO_ERROR_SHIFT);
+		    atomic_read_unchecked(&ca->io_errors) >> IO_ERROR_SHIFT);
 
 	if (attr == &sysfs_cache_replacement_policy)
 		return bch_snprint_string_list(buf, PAGE_SIZE,
@@ -870,11 +870,11 @@ STORE(__bch_cache)
 	}
 
 	if (attr == &sysfs_clear_stats) {
-		atomic_long_set(&ca->sectors_written, 0);
-		atomic_long_set(&ca->btree_sectors_written, 0);
-		atomic_long_set(&ca->meta_sectors_written, 0);
-		atomic_set(&ca->io_count, 0);
-		atomic_set(&ca->io_errors, 0);
+		atomic_long_set_unchecked(&ca->sectors_written, 0);
+		atomic_long_set_unchecked(&ca->btree_sectors_written, 0);
+		atomic_long_set_unchecked(&ca->meta_sectors_written, 0);
+		atomic_set_unchecked(&ca->io_count, 0);
+		atomic_set_unchecked(&ca->io_errors, 0);
 	}
 
 	return size;
diff --git a/drivers/md/bcache/writeback.c b/drivers/md/bcache/writeback.c
index d9fd2a62e..749b6c6cf 100644
--- a/drivers/md/bcache/writeback.c
+++ b/drivers/md/bcache/writeback.c
@@ -117,14 +117,16 @@ static void dirty_init(struct keybuf_key *w)
 	bch_bio_map(bio, NULL);
 }
 
-static void dirty_io_destructor(struct closure *cl)
+static void dirty_io_destructor(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct dirty_io *io = container_of(cl, struct dirty_io, cl);
 	kfree(io);
 }
 
-static void write_dirty_finish(struct closure *cl)
+static void write_dirty_finish(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct dirty_io *io = container_of(cl, struct dirty_io, cl);
 	struct keybuf_key *w = io->bio.bi_private;
 	struct cached_dev *dc = io->dc;
@@ -176,8 +178,9 @@ static void dirty_endio(struct bio *bio)
 	closure_put(&io->cl);
 }
 
-static void write_dirty(struct closure *cl)
+static void write_dirty(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct dirty_io *io = container_of(cl, struct dirty_io, cl);
 	struct keybuf_key *w = io->bio.bi_private;
 
@@ -203,8 +206,9 @@ static void read_dirty_endio(struct bio *bio)
 	dirty_endio(bio);
 }
 
-static void read_dirty_submit(struct closure *cl)
+static void read_dirty_submit(struct work_struct *work)
 {
+	struct closure *cl = container_of(work, struct closure, work);
 	struct dirty_io *io = container_of(cl, struct dirty_io, cl);
 
 	closure_bio_submit(&io->bio, cl);
diff --git a/drivers/md/bitmap.c b/drivers/md/bitmap.c
index 13041ee37..2d1c18462 100644
--- a/drivers/md/bitmap.c
+++ b/drivers/md/bitmap.c
@@ -1965,7 +1965,7 @@ void bitmap_status(struct seq_file *seq, struct bitmap *bitmap)
 		   chunk_kb ? "KB" : "B");
 	if (bitmap->storage.file) {
 		seq_printf(seq, ", file: ");
-		seq_file_path(seq, bitmap->storage.file, " \t\n");
+		seq_file_path(seq, bitmap->storage.file, " \t\n\\");
 	}
 
 	seq_printf(seq, "\n");
diff --git a/drivers/md/dm-cache-target.c b/drivers/md/dm-cache-target.c
index 59b2c5056..60bca5313 100644
--- a/drivers/md/dm-cache-target.c
+++ b/drivers/md/dm-cache-target.c
@@ -118,7 +118,7 @@ static void iot_io_end(struct io_tracker *iot, sector_t len)
  */
 struct dm_hook_info {
 	bio_end_io_t *bi_end_io;
-};
+} __no_const;
 
 static void dm_hook_bio(struct dm_hook_info *h, struct bio *bio,
 			bio_end_io_t *bi_end_io, void *bi_private)
@@ -182,16 +182,16 @@ struct cache_features {
 };
 
 struct cache_stats {
-	atomic_t read_hit;
-	atomic_t read_miss;
-	atomic_t write_hit;
-	atomic_t write_miss;
-	atomic_t demotion;
-	atomic_t promotion;
-	atomic_t copies_avoided;
-	atomic_t cache_cell_clash;
-	atomic_t commit_count;
-	atomic_t discard_count;
+	atomic_unchecked_t read_hit;
+	atomic_unchecked_t read_miss;
+	atomic_unchecked_t write_hit;
+	atomic_unchecked_t write_miss;
+	atomic_unchecked_t demotion;
+	atomic_unchecked_t promotion;
+	atomic_unchecked_t copies_avoided;
+	atomic_unchecked_t cache_cell_clash;
+	atomic_unchecked_t commit_count;
+	atomic_unchecked_t discard_count;
 };
 
 /*
@@ -270,8 +270,8 @@ struct cache {
 	atomic_t nr_io_migrations;
 
 	wait_queue_head_t quiescing_wait;
-	atomic_t quiescing;
-	atomic_t quiescing_ack;
+	atomic_unchecked_t quiescing;
+	atomic_unchecked_t quiescing_ack;
 
 	/*
 	 * cache_size entries, dirty if set
@@ -395,8 +395,10 @@ static struct dm_bio_prison_cell *alloc_prison_cell(struct cache *cache)
 	return dm_bio_prison_alloc_cell(cache->prison, GFP_NOWAIT);
 }
 
-static void free_prison_cell(struct cache *cache, struct dm_bio_prison_cell *cell)
+static void free_prison_cell(void *_cache, struct dm_bio_prison_cell *cell)
 {
+	struct cache *cache = _cache;
+
 	dm_bio_prison_free_cell(cache->prison, cell);
 }
 
@@ -493,8 +495,10 @@ static struct dm_bio_prison_cell *prealloc_get_cell(struct prealloc *p)
  * You can't have more than two cells in a prealloc struct.  BUG() will be
  * called if you try and overfill.
  */
-static void prealloc_put_cell(struct prealloc *p, struct dm_bio_prison_cell *cell)
+static void prealloc_put_cell(void *_p, struct dm_bio_prison_cell *cell)
 {
+	struct prealloc *p = _p;
+
 	if (!p->cell2)
 		p->cell2 = cell;
 
@@ -637,7 +641,7 @@ static void set_discard(struct cache *cache, dm_dblock_t b)
 	unsigned long flags;
 
 	BUG_ON(from_dblock(b) >= from_dblock(cache->discard_nr_blocks));
-	atomic_inc(&cache->stats.discard_count);
+	atomic_inc_unchecked(&cache->stats.discard_count);
 
 	spin_lock_irqsave(&cache->lock, flags);
 	set_bit(from_dblock(b), cache->discard_bitset);
@@ -685,10 +689,10 @@ static void load_stats(struct cache *cache)
 	struct dm_cache_statistics stats;
 
 	dm_cache_metadata_get_stats(cache->cmd, &stats);
-	atomic_set(&cache->stats.read_hit, stats.read_hits);
-	atomic_set(&cache->stats.read_miss, stats.read_misses);
-	atomic_set(&cache->stats.write_hit, stats.write_hits);
-	atomic_set(&cache->stats.write_miss, stats.write_misses);
+	atomic_set_unchecked(&cache->stats.read_hit, stats.read_hits);
+	atomic_set_unchecked(&cache->stats.read_miss, stats.read_misses);
+	atomic_set_unchecked(&cache->stats.write_hit, stats.write_hits);
+	atomic_set_unchecked(&cache->stats.write_miss, stats.write_misses);
 }
 
 static void save_stats(struct cache *cache)
@@ -698,10 +702,10 @@ static void save_stats(struct cache *cache)
 	if (get_cache_mode(cache) >= CM_READ_ONLY)
 		return;
 
-	stats.read_hits = atomic_read(&cache->stats.read_hit);
-	stats.read_misses = atomic_read(&cache->stats.read_miss);
-	stats.write_hits = atomic_read(&cache->stats.write_hit);
-	stats.write_misses = atomic_read(&cache->stats.write_miss);
+	stats.read_hits = atomic_read_unchecked(&cache->stats.read_hit);
+	stats.read_misses = atomic_read_unchecked(&cache->stats.read_miss);
+	stats.write_hits = atomic_read_unchecked(&cache->stats.write_hit);
+	stats.write_misses = atomic_read_unchecked(&cache->stats.write_miss);
 
 	dm_cache_metadata_set_stats(cache->cmd, &stats);
 }
@@ -1326,7 +1330,7 @@ static bool bio_writes_complete_block(struct cache *cache, struct bio *bio)
 
 static void avoid_copy(struct dm_cache_migration *mg)
 {
-	atomic_inc(&mg->cache->stats.copies_avoided);
+	atomic_inc_unchecked(&mg->cache->stats.copies_avoided);
 	migration_success_pre_commit(mg);
 }
 
@@ -1636,7 +1640,7 @@ static void process_discard_bio(struct cache *cache, struct prealloc *structs,
 
 	cell_prealloc = prealloc_get_cell(structs);
 	r = bio_detain_range(cache, dblock_to_oblock(cache, b), dblock_to_oblock(cache, e), bio, cell_prealloc,
-			     (cell_free_fn) prealloc_put_cell,
+			     prealloc_put_cell,
 			     structs, &new_ocell);
 	if (r > 0)
 		return;
@@ -1653,13 +1657,13 @@ static bool spare_migration_bandwidth(struct cache *cache)
 
 static void inc_hit_counter(struct cache *cache, struct bio *bio)
 {
-	atomic_inc(bio_data_dir(bio) == READ ?
+	atomic_inc_unchecked(bio_data_dir(bio) == READ ?
 		   &cache->stats.read_hit : &cache->stats.write_hit);
 }
 
 static void inc_miss_counter(struct cache *cache, struct bio *bio)
 {
-	atomic_inc(bio_data_dir(bio) == READ ?
+	atomic_inc_unchecked(bio_data_dir(bio) == READ ?
 		   &cache->stats.read_miss : &cache->stats.write_miss);
 }
 
@@ -1790,7 +1794,7 @@ static int cell_locker(struct policy_locker *locker, dm_oblock_t b)
 	struct dm_bio_prison_cell *cell_prealloc = prealloc_get_cell(l->structs);
 
 	return bio_detain(l->cache, b, NULL, cell_prealloc,
-			  (cell_free_fn) prealloc_put_cell,
+			  prealloc_put_cell,
 			  l->structs, &l->cell);
 }
 
@@ -1832,7 +1836,7 @@ static void process_cell(struct cache *cache, struct prealloc *structs,
 			 */
 
 			if (bio_data_dir(bio) == WRITE) {
-				atomic_inc(&cache->stats.demotion);
+				atomic_inc_unchecked(&cache->stats.demotion);
 				invalidate(cache, structs, block, lookup_result.cblock, new_ocell);
 				release_cell = false;
 
@@ -1865,14 +1869,14 @@ static void process_cell(struct cache *cache, struct prealloc *structs,
 		break;
 
 	case POLICY_NEW:
-		atomic_inc(&cache->stats.promotion);
+		atomic_inc_unchecked(&cache->stats.promotion);
 		promote(cache, structs, block, lookup_result.cblock, new_ocell);
 		release_cell = false;
 		break;
 
 	case POLICY_REPLACE:
-		atomic_inc(&cache->stats.demotion);
-		atomic_inc(&cache->stats.promotion);
+		atomic_inc_unchecked(&cache->stats.demotion);
+		atomic_inc_unchecked(&cache->stats.promotion);
 		demote_then_promote(cache, structs, lookup_result.old_oblock,
 				    block, lookup_result.cblock,
 				    ool.cell, new_ocell);
@@ -1902,7 +1906,7 @@ static void process_bio(struct cache *cache, struct prealloc *structs,
 	 */
 	cell_prealloc = prealloc_get_cell(structs);
 	r = bio_detain(cache, block, bio, cell_prealloc,
-		       (cell_free_fn) prealloc_put_cell,
+		       prealloc_put_cell,
 		       structs, &new_ocell);
 	if (r > 0)
 		return;
@@ -1926,7 +1930,7 @@ static int commit(struct cache *cache, bool clean_shutdown)
 	if (get_cache_mode(cache) >= CM_READ_ONLY)
 		return -EINVAL;
 
-	atomic_inc(&cache->stats.commit_count);
+	atomic_inc_unchecked(&cache->stats.commit_count);
 	r = dm_cache_commit(cache->cmd, clean_shutdown);
 	if (r)
 		metadata_operation_failed(cache, "dm_cache_commit", r);
@@ -2157,32 +2161,32 @@ static void process_invalidation_requests(struct cache *cache)
  *--------------------------------------------------------------*/
 static bool is_quiescing(struct cache *cache)
 {
-	return atomic_read(&cache->quiescing);
+	return atomic_read_unchecked(&cache->quiescing);
 }
 
 static void ack_quiescing(struct cache *cache)
 {
 	if (is_quiescing(cache)) {
-		atomic_inc(&cache->quiescing_ack);
+		atomic_inc_unchecked(&cache->quiescing_ack);
 		wake_up(&cache->quiescing_wait);
 	}
 }
 
 static void wait_for_quiescing_ack(struct cache *cache)
 {
-	wait_event(cache->quiescing_wait, atomic_read(&cache->quiescing_ack));
+	wait_event(cache->quiescing_wait, atomic_read_unchecked(&cache->quiescing_ack));
 }
 
 static void start_quiescing(struct cache *cache)
 {
-	atomic_inc(&cache->quiescing);
+	atomic_inc_unchecked(&cache->quiescing);
 	wait_for_quiescing_ack(cache);
 }
 
 static void stop_quiescing(struct cache *cache)
 {
-	atomic_set(&cache->quiescing, 0);
-	atomic_set(&cache->quiescing_ack, 0);
+	atomic_set_unchecked(&cache->quiescing, 0);
+	atomic_set_unchecked(&cache->quiescing_ack, 0);
 }
 
 static void wait_for_migrations(struct cache *cache)
@@ -2869,8 +2873,8 @@ static int cache_create(struct cache_args *ca, struct cache **result)
 	init_waitqueue_head(&cache->migration_wait);
 
 	init_waitqueue_head(&cache->quiescing_wait);
-	atomic_set(&cache->quiescing, 0);
-	atomic_set(&cache->quiescing_ack, 0);
+	atomic_set_unchecked(&cache->quiescing, 0);
+	atomic_set_unchecked(&cache->quiescing_ack, 0);
 
 	r = -ENOMEM;
 	atomic_set(&cache->nr_dirty, 0);
@@ -2937,12 +2941,12 @@ static int cache_create(struct cache_args *ca, struct cache **result)
 
 	load_stats(cache);
 
-	atomic_set(&cache->stats.demotion, 0);
-	atomic_set(&cache->stats.promotion, 0);
-	atomic_set(&cache->stats.copies_avoided, 0);
-	atomic_set(&cache->stats.cache_cell_clash, 0);
-	atomic_set(&cache->stats.commit_count, 0);
-	atomic_set(&cache->stats.discard_count, 0);
+	atomic_set_unchecked(&cache->stats.demotion, 0);
+	atomic_set_unchecked(&cache->stats.promotion, 0);
+	atomic_set_unchecked(&cache->stats.copies_avoided, 0);
+	atomic_set_unchecked(&cache->stats.cache_cell_clash, 0);
+	atomic_set_unchecked(&cache->stats.commit_count, 0);
+	atomic_set_unchecked(&cache->stats.discard_count, 0);
 
 	spin_lock_init(&cache->invalidation_lock);
 	INIT_LIST_HEAD(&cache->invalidation_requests);
@@ -3059,7 +3063,7 @@ static int cache_map(struct dm_target *ti, struct bio *bio)
 	}
 
 	r = bio_detain(cache, block, bio, cell,
-		       (cell_free_fn) free_prison_cell,
+		       free_prison_cell,
 		       cache, &cell);
 	if (r) {
 		if (r < 0)
@@ -3553,12 +3557,12 @@ static void cache_status(struct dm_target *ti, status_type_t type,
 		       cache->sectors_per_block,
 		       (unsigned long long) from_cblock(residency),
 		       (unsigned long long) from_cblock(cache->cache_size),
-		       (unsigned) atomic_read(&cache->stats.read_hit),
-		       (unsigned) atomic_read(&cache->stats.read_miss),
-		       (unsigned) atomic_read(&cache->stats.write_hit),
-		       (unsigned) atomic_read(&cache->stats.write_miss),
-		       (unsigned) atomic_read(&cache->stats.demotion),
-		       (unsigned) atomic_read(&cache->stats.promotion),
+		       (unsigned) atomic_read_unchecked(&cache->stats.read_hit),
+		       (unsigned) atomic_read_unchecked(&cache->stats.read_miss),
+		       (unsigned) atomic_read_unchecked(&cache->stats.write_hit),
+		       (unsigned) atomic_read_unchecked(&cache->stats.write_miss),
+		       (unsigned) atomic_read_unchecked(&cache->stats.demotion),
+		       (unsigned) atomic_read_unchecked(&cache->stats.promotion),
 		       (unsigned long) atomic_read(&cache->nr_dirty));
 
 		if (writethrough_mode(&cache->features))
diff --git a/drivers/md/dm-core.h b/drivers/md/dm-core.h
index 40ceba1fe..4141e1eb1 100644
--- a/drivers/md/dm-core.h
+++ b/drivers/md/dm-core.h
@@ -75,8 +75,8 @@ struct mapped_device {
 	 * Event handling.
 	 */
 	wait_queue_head_t eventq;
-	atomic_t event_nr;
-	atomic_t uevent_seq;
+	atomic_unchecked_t event_nr;
+	atomic_unchecked_t uevent_seq;
 	struct list_head uevent_list;
 	spinlock_t uevent_lock; /* Protect access to uevent_list */
 
diff --git a/drivers/md/dm-ioctl.c b/drivers/md/dm-ioctl.c
index 966eb4b61..aca05a3b8 100644
--- a/drivers/md/dm-ioctl.c
+++ b/drivers/md/dm-ioctl.c
@@ -1777,7 +1777,7 @@ static int validate_params(uint cmd, struct dm_ioctl *param)
 	    cmd == DM_LIST_VERSIONS_CMD)
 		return 0;
 
-	if ((cmd == DM_DEV_CREATE_CMD)) {
+	if (cmd == DM_DEV_CREATE_CMD) {
 		if (!*param->name) {
 			DMWARN("name not supplied when creating device");
 			return -EINVAL;
diff --git a/drivers/md/dm-mpath.c b/drivers/md/dm-mpath.c
index 15db5e9c5..16fc91b24 100644
--- a/drivers/md/dm-mpath.c
+++ b/drivers/md/dm-mpath.c
@@ -88,7 +88,7 @@ struct multipath {
 
 	atomic_t nr_valid_paths;	/* Total number of usable paths */
 	atomic_t pg_init_in_progress;	/* Only one pg_init allowed at once */
-	atomic_t pg_init_count;		/* Number of times pg_init called */
+	atomic_unchecked_t pg_init_count;/* Number of times pg_init called */
 
 	unsigned queue_mode;
 
@@ -203,7 +203,7 @@ static struct multipath *alloc_multipath(struct dm_target *ti)
 		set_bit(MPATHF_QUEUE_IO, &m->flags);
 		atomic_set(&m->nr_valid_paths, 0);
 		atomic_set(&m->pg_init_in_progress, 0);
-		atomic_set(&m->pg_init_count, 0);
+		atomic_set_unchecked(&m->pg_init_count, 0);
 		m->pg_init_delay_msecs = DM_PG_INIT_DELAY_DEFAULT;
 		INIT_WORK(&m->trigger_event, trigger_event);
 		init_waitqueue_head(&m->pg_init_wait);
@@ -351,7 +351,7 @@ static int __pg_init_all_paths(struct multipath *m)
 	if (atomic_read(&m->pg_init_in_progress) || test_bit(MPATHF_PG_INIT_DISABLED, &m->flags))
 		return 0;
 
-	atomic_inc(&m->pg_init_count);
+	atomic_inc_unchecked(&m->pg_init_count);
 	clear_bit(MPATHF_PG_INIT_REQUIRED, &m->flags);
 
 	/* Check here to reset pg_init_required */
@@ -397,7 +397,7 @@ static void __switch_pg(struct multipath *m, struct priority_group *pg)
 		clear_bit(MPATHF_QUEUE_IO, &m->flags);
 	}
 
-	atomic_set(&m->pg_init_count, 0);
+	atomic_set_unchecked(&m->pg_init_count, 0);
 }
 
 static struct pgpath *choose_path_in_pg(struct multipath *m,
@@ -1420,7 +1420,7 @@ static bool pg_init_limit_reached(struct multipath *m, struct pgpath *pgpath)
 
 	spin_lock_irqsave(&m->lock, flags);
 
-	if (atomic_read(&m->pg_init_count) <= m->pg_init_retries &&
+	if (atomic_read_unchecked(&m->pg_init_count) <= m->pg_init_retries &&
 	    !test_bit(MPATHF_PG_INIT_DISABLED, &m->flags))
 		set_bit(MPATHF_PG_INIT_REQUIRED, &m->flags);
 	else
@@ -1736,7 +1736,7 @@ static void multipath_status(struct dm_target *ti, status_type_t type,
 	/* Features */
 	if (type == STATUSTYPE_INFO)
 		DMEMIT("2 %u %u ", test_bit(MPATHF_QUEUE_IO, &m->flags),
-		       atomic_read(&m->pg_init_count));
+		       atomic_read_unchecked(&m->pg_init_count));
 	else {
 		DMEMIT("%u ", test_bit(MPATHF_QUEUE_IF_NO_PATH, &m->flags) +
 			      (m->pg_init_retries > 0) * 2 +
diff --git a/drivers/md/dm-raid.c b/drivers/md/dm-raid.c
index af2d79b52..d879687df 100644
--- a/drivers/md/dm-raid.c
+++ b/drivers/md/dm-raid.c
@@ -3196,7 +3196,7 @@ static void raid_status(struct dm_target *ti, status_type_t type,
 				      mddev->resync_max_sectors : mddev->dev_sectors;
 		progress = rs_get_progress(rs, resync_max_sectors, &array_in_sync);
 		resync_mismatches = (mddev->last_sync_action && !strcasecmp(mddev->last_sync_action, "check")) ?
-				    atomic64_read(&mddev->resync_mismatches) : 0;
+				    atomic64_read_unchecked(&mddev->resync_mismatches) : 0;
 		sync_action = decipher_sync_action(&rs->md);
 
 		/* HM FIXME: do we want another state char for raid0? It shows 'D' or 'A' now */
diff --git a/drivers/md/dm-raid1.c b/drivers/md/dm-raid1.c
index 7a6254d54..6d6b8fb56 100644
--- a/drivers/md/dm-raid1.c
+++ b/drivers/md/dm-raid1.c
@@ -42,7 +42,7 @@ enum dm_raid1_error {
 
 struct mirror {
 	struct mirror_set *ms;
-	atomic_t error_count;
+	atomic_unchecked_t error_count;
 	unsigned long error_type;
 	struct dm_dev *dev;
 	sector_t offset;
@@ -188,7 +188,7 @@ static struct mirror *get_valid_mirror(struct mirror_set *ms)
 	struct mirror *m;
 
 	for (m = ms->mirror; m < ms->mirror + ms->nr_mirrors; m++)
-		if (!atomic_read(&m->error_count))
+		if (!atomic_read_unchecked(&m->error_count))
 			return m;
 
 	return NULL;
@@ -220,7 +220,7 @@ static void fail_mirror(struct mirror *m, enum dm_raid1_error error_type)
 	 * simple way to tell if a device has encountered
 	 * errors.
 	 */
-	atomic_inc(&m->error_count);
+	atomic_inc_unchecked(&m->error_count);
 
 	if (test_and_set_bit(error_type, &m->error_type))
 		return;
@@ -379,7 +379,7 @@ static void reset_ms_flags(struct mirror_set *ms)
 
 	ms->leg_failure = 0;
 	for (m = 0; m < ms->nr_mirrors; m++) {
-		atomic_set(&(ms->mirror[m].error_count), 0);
+		atomic_set_unchecked(&(ms->mirror[m].error_count), 0);
 		ms->mirror[m].error_type = 0;
 	}
 }
@@ -424,7 +424,7 @@ static struct mirror *choose_mirror(struct mirror_set *ms, sector_t sector)
 	struct mirror *m = get_default_mirror(ms);
 
 	do {
-		if (likely(!atomic_read(&m->error_count)))
+		if (likely(!atomic_read_unchecked(&m->error_count)))
 			return m;
 
 		if (m-- == ms->mirror)
@@ -438,7 +438,7 @@ static int default_ok(struct mirror *m)
 {
 	struct mirror *default_mirror = get_default_mirror(m->ms);
 
-	return !atomic_read(&default_mirror->error_count);
+	return !atomic_read_unchecked(&default_mirror->error_count);
 }
 
 static int mirror_available(struct mirror_set *ms, struct bio *bio)
@@ -578,7 +578,7 @@ static void do_reads(struct mirror_set *ms, struct bio_list *reads)
 		 */
 		if (likely(region_in_sync(ms, region, 1)))
 			m = choose_mirror(ms, bio->bi_iter.bi_sector);
-		else if (m && atomic_read(&m->error_count))
+		else if (m && atomic_read_unchecked(&m->error_count))
 			m = NULL;
 
 		if (likely(m))
@@ -963,7 +963,7 @@ static int get_mirror(struct mirror_set *ms, struct dm_target *ti,
 	}
 
 	ms->mirror[mirror].ms = ms;
-	atomic_set(&(ms->mirror[mirror].error_count), 0);
+	atomic_set_unchecked(&(ms->mirror[mirror].error_count), 0);
 	ms->mirror[mirror].error_type = 0;
 	ms->mirror[mirror].offset = offset;
 
@@ -1389,7 +1389,7 @@ static void mirror_resume(struct dm_target *ti)
  */
 static char device_status_char(struct mirror *m)
 {
-	if (!atomic_read(&(m->error_count)))
+	if (!atomic_read_unchecked(&(m->error_count)))
 		return 'A';
 
 	return (test_bit(DM_RAID1_FLUSH_ERROR, &(m->error_type))) ? 'F' :
diff --git a/drivers/md/dm-stats.c b/drivers/md/dm-stats.c
index 38b05f23b..4f9959526 100644
--- a/drivers/md/dm-stats.c
+++ b/drivers/md/dm-stats.c
@@ -435,7 +435,7 @@ do_sync_free:
 		synchronize_rcu_expedited();
 		dm_stat_free(&s->rcu_head);
 	} else {
-		ACCESS_ONCE(dm_stat_need_rcu_barrier) = 1;
+		ACCESS_ONCE_RW(dm_stat_need_rcu_barrier) = 1;
 		call_rcu(&s->rcu_head, dm_stat_free);
 	}
 	return 0;
@@ -647,8 +647,8 @@ void dm_stats_account_io(struct dm_stats *stats, unsigned long bi_rw,
 				       ((bi_rw == WRITE) ==
 					(ACCESS_ONCE(last->last_rw) == WRITE))
 				       ));
-		ACCESS_ONCE(last->last_sector) = end_sector;
-		ACCESS_ONCE(last->last_rw) = bi_rw;
+		ACCESS_ONCE_RW(last->last_sector) = end_sector;
+		ACCESS_ONCE_RW(last->last_rw) = bi_rw;
 	}
 
 	rcu_read_lock();
diff --git a/drivers/md/dm-stripe.c b/drivers/md/dm-stripe.c
index 28193a57b..0543cc938 100644
--- a/drivers/md/dm-stripe.c
+++ b/drivers/md/dm-stripe.c
@@ -21,7 +21,7 @@ struct stripe {
 	struct dm_dev *dev;
 	sector_t physical_start;
 
-	atomic_t error_count;
+	atomic_unchecked_t error_count;
 };
 
 struct stripe_c {
@@ -190,7 +190,7 @@ static int stripe_ctr(struct dm_target *ti, unsigned int argc, char **argv)
 			kfree(sc);
 			return r;
 		}
-		atomic_set(&(sc->stripe[i].error_count), 0);
+		atomic_set_unchecked(&(sc->stripe[i].error_count), 0);
 	}
 
 	ti->private = sc;
@@ -357,7 +357,7 @@ static void stripe_status(struct dm_target *ti, status_type_t type,
 		DMEMIT("%d ", sc->stripes);
 		for (i = 0; i < sc->stripes; i++)  {
 			DMEMIT("%s ", sc->stripe[i].dev->name);
-			buffer[i] = atomic_read(&(sc->stripe[i].error_count)) ?
+			buffer[i] = atomic_read_unchecked(&(sc->stripe[i].error_count)) ?
 				'D' : 'A';
 		}
 		buffer[i] = '\0';
@@ -402,8 +402,8 @@ static int stripe_end_io(struct dm_target *ti, struct bio *bio, int error)
 	 */
 	for (i = 0; i < sc->stripes; i++)
 		if (!strcmp(sc->stripe[i].dev->name, major_minor)) {
-			atomic_inc(&(sc->stripe[i].error_count));
-			if (atomic_read(&(sc->stripe[i].error_count)) <
+			atomic_inc_unchecked(&(sc->stripe[i].error_count));
+			if (atomic_read_unchecked(&(sc->stripe[i].error_count)) <
 			    DM_IO_ERROR_THRESHOLD)
 				schedule_work(&sc->trigger_event);
 		}
diff --git a/drivers/md/dm-table.c b/drivers/md/dm-table.c
index 5ac239d0f..d91268c60 100644
--- a/drivers/md/dm-table.c
+++ b/drivers/md/dm-table.c
@@ -308,7 +308,7 @@ static int device_area_is_invalid(struct dm_target *ti, struct dm_dev *dev,
 	if (!dev_size)
 		return 0;
 
-	if ((start >= dev_size) || (start + len > dev_size)) {
+	if ((start >= dev_size) || (len > dev_size - start)) {
 		DMWARN("%s: %s too small for target: "
 		       "start=%llu, len=%llu, dev_size=%llu",
 		       dm_device_name(ti->table->md), bdevname(bdev, b),
diff --git a/drivers/md/dm-thin-metadata.c b/drivers/md/dm-thin-metadata.c
index a15091a0d..2d2020810 100644
--- a/drivers/md/dm-thin-metadata.c
+++ b/drivers/md/dm-thin-metadata.c
@@ -405,7 +405,7 @@ static void __setup_btree_details(struct dm_pool_metadata *pmd)
 {
 	pmd->info.tm = pmd->tm;
 	pmd->info.levels = 2;
-	pmd->info.value_type.context = pmd->data_sm;
+	pmd->info.value_type.context = (dm_space_map_no_const *)pmd->data_sm;
 	pmd->info.value_type.size = sizeof(__le64);
 	pmd->info.value_type.inc = data_block_inc;
 	pmd->info.value_type.dec = data_block_dec;
@@ -424,7 +424,7 @@ static void __setup_btree_details(struct dm_pool_metadata *pmd)
 
 	pmd->bl_info.tm = pmd->tm;
 	pmd->bl_info.levels = 1;
-	pmd->bl_info.value_type.context = pmd->data_sm;
+	pmd->bl_info.value_type.context = (dm_space_map_no_const *)pmd->data_sm;
 	pmd->bl_info.value_type.size = sizeof(__le64);
 	pmd->bl_info.value_type.inc = data_block_inc;
 	pmd->bl_info.value_type.dec = data_block_dec;
diff --git a/drivers/md/dm.c b/drivers/md/dm.c
index eeef575fb..af16c27cd 100644
--- a/drivers/md/dm.c
+++ b/drivers/md/dm.c
@@ -569,14 +569,16 @@ static void queue_io(struct mapped_device *md, struct bio *bio)
  * function to access the md->map field, and make sure they call
  * dm_put_live_table() when finished.
  */
-struct dm_table *dm_get_live_table(struct mapped_device *md, int *srcu_idx) __acquires(md->io_barrier)
+struct dm_table *dm_get_live_table(struct mapped_device *md, int *srcu_idx) __acquires(&md->io_barrier);
+struct dm_table *dm_get_live_table(struct mapped_device *md, int *srcu_idx)
 {
 	*srcu_idx = srcu_read_lock(&md->io_barrier);
 
 	return srcu_dereference(md->map, &md->io_barrier);
 }
 
-void dm_put_live_table(struct mapped_device *md, int srcu_idx) __releases(md->io_barrier)
+void dm_put_live_table(struct mapped_device *md, int srcu_idx) __releases(&md->io_barrier);
+void dm_put_live_table(struct mapped_device *md, int srcu_idx)
 {
 	srcu_read_unlock(&md->io_barrier, srcu_idx);
 }
@@ -591,13 +593,15 @@ void dm_sync_table(struct mapped_device *md)
  * A fast alternative to dm_get_live_table/dm_put_live_table.
  * The caller must not block between these two functions.
  */
-static struct dm_table *dm_get_live_table_fast(struct mapped_device *md) __acquires(RCU)
+static struct dm_table *dm_get_live_table_fast(struct mapped_device *md) __acquires(RCU);
+static struct dm_table *dm_get_live_table_fast(struct mapped_device *md)
 {
 	rcu_read_lock();
 	return rcu_dereference(md->map);
 }
 
-static void dm_put_live_table_fast(struct mapped_device *md) __releases(RCU)
+static void dm_put_live_table_fast(struct mapped_device *md) __releases(RCU);
+static void dm_put_live_table_fast(struct mapped_device *md)
 {
 	rcu_read_unlock();
 }
@@ -1484,8 +1488,8 @@ static struct mapped_device *alloc_dev(int minor)
 	spin_lock_init(&md->deferred_lock);
 	atomic_set(&md->holders, 1);
 	atomic_set(&md->open_count, 0);
-	atomic_set(&md->event_nr, 0);
-	atomic_set(&md->uevent_seq, 0);
+	atomic_set_unchecked(&md->event_nr, 0);
+	atomic_set_unchecked(&md->uevent_seq, 0);
 	INIT_LIST_HEAD(&md->uevent_list);
 	INIT_LIST_HEAD(&md->table_devices);
 	spin_lock_init(&md->uevent_lock);
@@ -1624,7 +1628,7 @@ static void event_callback(void *context)
 
 	dm_send_uevents(&uevents, &disk_to_dev(md->disk)->kobj);
 
-	atomic_inc(&md->event_nr);
+	atomic_inc_unchecked(&md->event_nr);
 	wake_up(&md->eventq);
 }
 
@@ -2409,18 +2413,18 @@ int dm_kobject_uevent(struct mapped_device *md, enum kobject_action action,
 
 uint32_t dm_next_uevent_seq(struct mapped_device *md)
 {
-	return atomic_add_return(1, &md->uevent_seq);
+	return atomic_add_return_unchecked(1, &md->uevent_seq);
 }
 
 uint32_t dm_get_event_nr(struct mapped_device *md)
 {
-	return atomic_read(&md->event_nr);
+	return atomic_read_unchecked(&md->event_nr);
 }
 
 int dm_wait_event(struct mapped_device *md, int event_nr)
 {
 	return wait_event_interruptible(md->eventq,
-			(event_nr != atomic_read(&md->event_nr)));
+			(event_nr != atomic_read_unchecked(&md->event_nr)));
 }
 
 void dm_uevent_add(struct mapped_device *md, struct list_head *elist)
diff --git a/drivers/md/md.c b/drivers/md/md.c
index db0aa6c05..33837441f 100644
--- a/drivers/md/md.c
+++ b/drivers/md/md.c
@@ -198,10 +198,10 @@ EXPORT_SYMBOL_GPL(bio_clone_mddev);
  *  start build, activate spare
  */
 static DECLARE_WAIT_QUEUE_HEAD(md_event_waiters);
-static atomic_t md_event_count;
+static atomic_unchecked_t md_event_count;
 void md_new_event(struct mddev *mddev)
 {
-	atomic_inc(&md_event_count);
+	atomic_inc_unchecked(&md_event_count);
 	wake_up(&md_event_waiters);
 }
 EXPORT_SYMBOL_GPL(md_new_event);
@@ -1434,7 +1434,7 @@ static int super_1_load(struct md_rdev *rdev, struct md_rdev *refdev, int minor_
 	if ((le32_to_cpu(sb->feature_map) & MD_FEATURE_RESHAPE_ACTIVE) &&
 	    (le32_to_cpu(sb->feature_map) & MD_FEATURE_NEW_OFFSET))
 		rdev->new_data_offset += (s32)le32_to_cpu(sb->new_offset);
-	atomic_set(&rdev->corrected_errors, le32_to_cpu(sb->cnt_corrected_read));
+	atomic_set_unchecked(&rdev->corrected_errors, le32_to_cpu(sb->cnt_corrected_read));
 
 	rdev->sb_size = le32_to_cpu(sb->max_dev) * 2 + 256;
 	bmask = queue_logical_block_size(rdev->bdev->bd_disk->queue)-1;
@@ -1700,7 +1700,7 @@ static void super_1_sync(struct mddev *mddev, struct md_rdev *rdev)
 	else
 		sb->resync_offset = cpu_to_le64(0);
 
-	sb->cnt_corrected_read = cpu_to_le32(atomic_read(&rdev->corrected_errors));
+	sb->cnt_corrected_read = cpu_to_le32(atomic_read_unchecked(&rdev->corrected_errors));
 
 	sb->raid_disks = cpu_to_le32(mddev->raid_disks);
 	sb->size = cpu_to_le64(mddev->dev_sectors);
@@ -2719,7 +2719,7 @@ __ATTR_PREALLOC(state, S_IRUGO|S_IWUSR, state_show, state_store);
 static ssize_t
 errors_show(struct md_rdev *rdev, char *page)
 {
-	return sprintf(page, "%d\n", atomic_read(&rdev->corrected_errors));
+	return sprintf(page, "%d\n", atomic_read_unchecked(&rdev->corrected_errors));
 }
 
 static ssize_t
@@ -2731,7 +2731,7 @@ errors_store(struct md_rdev *rdev, const char *buf, size_t len)
 	rv = kstrtouint(buf, 10, &n);
 	if (rv < 0)
 		return rv;
-	atomic_set(&rdev->corrected_errors, n);
+	atomic_set_unchecked(&rdev->corrected_errors, n);
 	return len;
 }
 static struct rdev_sysfs_entry rdev_errors =
@@ -3180,8 +3180,8 @@ int md_rdev_init(struct md_rdev *rdev)
 	rdev->sb_loaded = 0;
 	rdev->bb_page = NULL;
 	atomic_set(&rdev->nr_pending, 0);
-	atomic_set(&rdev->read_errors, 0);
-	atomic_set(&rdev->corrected_errors, 0);
+	atomic_set_unchecked(&rdev->read_errors, 0);
+	atomic_set_unchecked(&rdev->corrected_errors, 0);
 
 	INIT_LIST_HEAD(&rdev->same_set);
 	init_waitqueue_head(&rdev->blocked_wait);
@@ -4403,7 +4403,7 @@ mismatch_cnt_show(struct mddev *mddev, char *page)
 {
 	return sprintf(page, "%llu\n",
 		       (unsigned long long)
-		       atomic64_read(&mddev->resync_mismatches));
+		       atomic64_read_unchecked(&mddev->resync_mismatches));
 }
 
 static struct md_sysfs_entry md_mismatches = __ATTR_RO(mismatch_cnt);
@@ -5095,7 +5095,7 @@ static struct kobject *md_probe(dev_t dev, int *part, void *data)
 	return NULL;
 }
 
-static int add_named_array(const char *val, struct kernel_param *kp)
+static int add_named_array(const char *val, const struct kernel_param *kp)
 {
 	/* val must be "md_*" where * is not all digits.
 	 * We allocate an array with a large free minor number, and
@@ -5445,7 +5445,7 @@ static void md_clean(struct mddev *mddev)
 	mddev->new_layout = 0;
 	mddev->new_chunk_sectors = 0;
 	mddev->curr_resync = 0;
-	atomic64_set(&mddev->resync_mismatches, 0);
+	atomic64_set_unchecked(&mddev->resync_mismatches, 0);
 	mddev->suspend_lo = mddev->suspend_hi = 0;
 	mddev->sync_speed_min = mddev->sync_speed_max = 0;
 	mddev->recovery = 0;
@@ -5862,9 +5862,10 @@ static int get_array_info(struct mddev *mddev, void __user *arg)
 	info.patch_version = MD_PATCHLEVEL_VERSION;
 	info.ctime         = clamp_t(time64_t, mddev->ctime, 0, U32_MAX);
 	info.level         = mddev->level;
-	info.size          = mddev->dev_sectors / 2;
-	if (info.size != mddev->dev_sectors / 2) /* overflow */
+	if (2 * (sector_t)INT_MAX < mddev->dev_sectors) /* overflow */
 		info.size = -1;
+	else
+		info.size = mddev->dev_sectors / 2;
 	info.nr_disks      = nr;
 	info.raid_disks    = mddev->raid_disks;
 	info.md_minor      = mddev->md_minor;
@@ -7431,7 +7432,7 @@ static int md_seq_show(struct seq_file *seq, void *v)
 
 		spin_unlock(&pers_lock);
 		seq_printf(seq, "\n");
-		seq->poll_event = atomic_read(&md_event_count);
+		seq->poll_event = atomic_read_unchecked(&md_event_count);
 		return 0;
 	}
 	if (v == (void*)2) {
@@ -7531,7 +7532,7 @@ static int md_seq_open(struct inode *inode, struct file *file)
 		return error;
 
 	seq = file->private_data;
-	seq->poll_event = atomic_read(&md_event_count);
+	seq->poll_event = atomic_read_unchecked(&md_event_count);
 	return error;
 }
 
@@ -7548,7 +7549,7 @@ static unsigned int mdstat_poll(struct file *filp, poll_table *wait)
 	/* always allow read */
 	mask = POLLIN | POLLRDNORM;
 
-	if (seq->poll_event != atomic_read(&md_event_count))
+	if (seq->poll_event != atomic_read_unchecked(&md_event_count))
 		mask |= POLLERR | POLLPRI;
 	return mask;
 }
@@ -7644,7 +7645,7 @@ static int is_mddev_idle(struct mddev *mddev, int init)
 		struct gendisk *disk = rdev->bdev->bd_contains->bd_disk;
 		curr_events = (int)part_stat_read(&disk->part0, sectors[0]) +
 			      (int)part_stat_read(&disk->part0, sectors[1]) -
-			      atomic_read(&disk->sync_io);
+			      atomic_read_unchecked(&disk->sync_io);
 		/* sync IO will cause sync_io to increase before the disk_stats
 		 * as sync_io is counted when a request starts, and
 		 * disk_stats is counted when it completes.
@@ -7914,7 +7915,7 @@ void md_do_sync(struct md_thread *thread)
 		 * which defaults to physical size, but can be virtual size
 		 */
 		max_sectors = mddev->resync_max_sectors;
-		atomic64_set(&mddev->resync_mismatches, 0);
+		atomic64_set_unchecked(&mddev->resync_mismatches, 0);
 		/* we don't use the checkpoint if there's a bitmap */
 		if (test_bit(MD_RECOVERY_REQUESTED, &mddev->recovery))
 			j = mddev->resync_min;
@@ -8931,11 +8932,11 @@ static __exit void md_exit(void)
 subsys_initcall(md_init);
 module_exit(md_exit)
 
-static int get_ro(char *buffer, struct kernel_param *kp)
+static int get_ro(char *buffer, const struct kernel_param *kp)
 {
 	return sprintf(buffer, "%d", start_readonly);
 }
-static int set_ro(const char *val, struct kernel_param *kp)
+static int set_ro(const char *val, const struct kernel_param *kp)
 {
 	return kstrtouint(val, 10, (unsigned int *)&start_readonly);
 }
diff --git a/drivers/md/md.h b/drivers/md/md.h
index 20c667579..871764e86 100644
--- a/drivers/md/md.h
+++ b/drivers/md/md.h
@@ -96,13 +96,13 @@ struct md_rdev {
 					 * only maintained for arrays that
 					 * support hot removal
 					 */
-	atomic_t	read_errors;	/* number of consecutive read errors that
+	atomic_unchecked_t	read_errors;	/* number of consecutive read errors that
 					 * we have tried to ignore.
 					 */
 	time64_t	last_read_error;	/* monotonic time since our
 						 * last read error
 						 */
-	atomic_t	corrected_errors; /* number of corrected read errors,
+	atomic_unchecked_t	corrected_errors; /* number of corrected read errors,
 					   * for reporting to userspace and storing
 					   * in superblock.
 					   */
@@ -290,7 +290,7 @@ struct mddev {
 
 	sector_t			resync_max_sectors; /* may be set by personality */
 
-	atomic64_t			resync_mismatches; /* count of sectors where
+	atomic64_unchecked_t		resync_mismatches; /* count of sectors where
 							    * parity/replica mismatch found
 							    */
 
@@ -469,7 +469,7 @@ extern void mddev_unlock(struct mddev *mddev);
 
 static inline void md_sync_acct(struct block_device *bdev, unsigned long nr_sectors)
 {
-	atomic_add(nr_sectors, &bdev->bd_contains->bd_disk->sync_io);
+	atomic_add_unchecked(nr_sectors, &bdev->bd_contains->bd_disk->sync_io);
 }
 
 struct md_personality
diff --git a/drivers/md/persistent-data/dm-space-map-metadata.c b/drivers/md/persistent-data/dm-space-map-metadata.c
index 20557e2c6..c5fa1ef73 100644
--- a/drivers/md/persistent-data/dm-space-map-metadata.c
+++ b/drivers/md/persistent-data/dm-space-map-metadata.c
@@ -700,7 +700,7 @@ static int sm_metadata_extend(struct dm_space_map *sm, dm_block_t extra_blocks)
 	 * Flick into a mode where all blocks get allocated in the new area.
 	 */
 	smm->begin = old_len;
-	memcpy(sm, &bootstrap_ops, sizeof(*sm));
+	memcpy((void *)sm, &bootstrap_ops, sizeof(*sm));
 
 	/*
 	 * Extend.
@@ -738,7 +738,7 @@ out:
 	/*
 	 * Switch back to normal behaviour.
 	 */
-	memcpy(sm, &ops, sizeof(*sm));
+	memcpy((void *)sm, &ops, sizeof(*sm));
 	return r;
 }
 
diff --git a/drivers/md/persistent-data/dm-space-map.h b/drivers/md/persistent-data/dm-space-map.h
index 3e6d1153b..ffecdeb19 100644
--- a/drivers/md/persistent-data/dm-space-map.h
+++ b/drivers/md/persistent-data/dm-space-map.h
@@ -71,6 +71,7 @@ struct dm_space_map {
 					   dm_sm_threshold_fn fn,
 					   void *context);
 };
+typedef struct dm_space_map __no_const dm_space_map_no_const;
 
 /*----------------------------------------------------------------*/
 
diff --git a/drivers/md/raid1.c b/drivers/md/raid1.c
index 95bf4cd8f..3aa17b041 100644
--- a/drivers/md/raid1.c
+++ b/drivers/md/raid1.c
@@ -1053,7 +1053,7 @@ static void raid1_make_request(struct mddev *mddev, struct bio * bio)
 	struct blk_plug_cb *cb;
 	struct raid1_plug_cb *plug = NULL;
 	int first_clone;
-	int sectors_handled;
+	sector_t sectors_handled;
 	int max_sectors;
 	sector_t start_next_window;
 
@@ -1883,7 +1883,7 @@ static int fix_sync_read_error(struct r1bio *r1_bio)
 			if (r1_sync_page_io(rdev, sect, s,
 					    bio->bi_io_vec[idx].bv_page,
 					    READ) != 0)
-				atomic_add(s, &rdev->corrected_errors);
+				atomic_add_unchecked(s, &rdev->corrected_errors);
 		}
 		sectors -= s;
 		sect += s;
@@ -1974,7 +1974,7 @@ static void process_checks(struct r1bio *r1_bio)
 		} else
 			j = 0;
 		if (j >= 0)
-			atomic64_add(r1_bio->sectors, &mddev->resync_mismatches);
+			atomic64_add_unchecked(r1_bio->sectors, &mddev->resync_mismatches);
 		if (j < 0 || (test_bit(MD_RECOVERY_CHECK, &mddev->recovery)
 			      && !error)) {
 			/* No need to write to this device. */
@@ -2125,7 +2125,7 @@ static void fix_read_error(struct r1conf *conf, int read_disk,
 				rcu_read_unlock();
 				if (r1_sync_page_io(rdev, sect, s,
 						    conf->tmppage, READ)) {
-					atomic_add(s, &rdev->corrected_errors);
+					atomic_add_unchecked(s, &rdev->corrected_errors);
 					printk(KERN_INFO
 					       "md/raid1:%s: read error corrected "
 					       "(%d sectors at %llu on %s)\n",
diff --git a/drivers/md/raid10.c b/drivers/md/raid10.c
index 39fddda2f..be1dd5433 100644
--- a/drivers/md/raid10.c
+++ b/drivers/md/raid10.c
@@ -1063,7 +1063,7 @@ static void __make_request(struct mddev *mddev, struct bio *bio)
 	struct md_rdev *blocked_rdev;
 	struct blk_plug_cb *cb;
 	struct raid10_plug_cb *plug = NULL;
-	int sectors_handled;
+	sector_t sectors_handled;
 	int max_sectors;
 	int sectors;
 
@@ -1441,7 +1441,7 @@ static void raid10_make_request(struct mddev *mddev, struct bio *bio)
 {
 	struct r10conf *conf = mddev->private;
 	sector_t chunk_mask = (conf->geo.chunk_mask & conf->prev.chunk_mask);
-	int chunk_sects = chunk_mask + 1;
+	sector_t chunk_sects = chunk_mask + 1;
 
 	struct bio *split;
 
@@ -1829,7 +1829,7 @@ static void end_sync_read(struct bio *bio)
 		/* The write handler will notice the lack of
 		 * R10BIO_Uptodate and record any errors etc
 		 */
-		atomic_add(r10_bio->sectors,
+		atomic_add_unchecked(r10_bio->sectors,
 			   &conf->mirrors[d].rdev->corrected_errors);
 
 	/* for reconstruct, we always reschedule after a read.
@@ -1978,7 +1978,7 @@ static void sync_request_write(struct mddev *mddev, struct r10bio *r10_bio)
 			}
 			if (j == vcnt)
 				continue;
-			atomic64_add(r10_bio->sectors, &mddev->resync_mismatches);
+			atomic64_add_unchecked(r10_bio->sectors, &mddev->resync_mismatches);
 			if (test_bit(MD_RECOVERY_CHECK, &mddev->recovery))
 				/* Don't fix anything. */
 				continue;
@@ -2177,7 +2177,7 @@ static void check_decay_read_errors(struct mddev *mddev, struct md_rdev *rdev)
 {
 	long cur_time_mon;
 	unsigned long hours_since_last;
-	unsigned int read_errors = atomic_read(&rdev->read_errors);
+	unsigned int read_errors = atomic_read_unchecked(&rdev->read_errors);
 
 	cur_time_mon = ktime_get_seconds();
 
@@ -2198,9 +2198,9 @@ static void check_decay_read_errors(struct mddev *mddev, struct md_rdev *rdev)
 	 * overflowing the shift of read_errors by hours_since_last.
 	 */
 	if (hours_since_last >= 8 * sizeof(read_errors))
-		atomic_set(&rdev->read_errors, 0);
+		atomic_set_unchecked(&rdev->read_errors, 0);
 	else
-		atomic_set(&rdev->read_errors, read_errors >> hours_since_last);
+		atomic_set_unchecked(&rdev->read_errors, read_errors >> hours_since_last);
 }
 
 static int r10_sync_page_io(struct md_rdev *rdev, sector_t sector,
@@ -2254,8 +2254,8 @@ static void fix_read_error(struct r10conf *conf, struct mddev *mddev, struct r10
 		return;
 
 	check_decay_read_errors(mddev, rdev);
-	atomic_inc(&rdev->read_errors);
-	if (atomic_read(&rdev->read_errors) > max_read_errors) {
+	atomic_inc_unchecked(&rdev->read_errors);
+	if (atomic_read_unchecked(&rdev->read_errors) > max_read_errors) {
 		char b[BDEVNAME_SIZE];
 		bdevname(rdev->bdev, b);
 
@@ -2263,7 +2263,7 @@ static void fix_read_error(struct r10conf *conf, struct mddev *mddev, struct r10
 		       "md/raid10:%s: %s: Raid device exceeded "
 		       "read_error threshold [cur %d:max %d]\n",
 		       mdname(mddev), b,
-		       atomic_read(&rdev->read_errors), max_read_errors);
+		       atomic_read_unchecked(&rdev->read_errors), max_read_errors);
 		printk(KERN_NOTICE
 		       "md/raid10:%s: %s: Failing raid device\n",
 		       mdname(mddev), b);
@@ -2420,7 +2420,7 @@ static void fix_read_error(struct r10conf *conf, struct mddev *mddev, struct r10
 					       sect +
 					       choose_data_offset(r10_bio, rdev)),
 				       bdevname(rdev->bdev, b));
-				atomic_add(s, &rdev->corrected_errors);
+				atomic_add_unchecked(s, &rdev->corrected_errors);
 			}
 
 			rdev_dec_pending(rdev, mddev);
@@ -3191,6 +3191,7 @@ static sector_t raid10_sync_request(struct mddev *mddev, sector_t sector_nr,
 	} else {
 		/* resync. Schedule a read for every block at this virt offset */
 		int count = 0;
+		sector_t sectors;
 
 		bitmap_cond_end_sync(mddev->bitmap, sector_nr, 0);
 
@@ -3216,7 +3217,8 @@ static sector_t raid10_sync_request(struct mddev *mddev, sector_t sector_nr,
 		r10_bio->sector = sector_nr;
 		set_bit(R10BIO_IsSync, &r10_bio->state);
 		raid10_find_phys(conf, r10_bio);
-		r10_bio->sectors = (sector_nr | chunk_mask) - sector_nr + 1;
+		sectors = (sector_nr | chunk_mask) - sector_nr + 1;
+		r10_bio->sectors = sectors;
 
 		for (i = 0; i < conf->copies; i++) {
 			int d = r10_bio->devs[i].devnum;
diff --git a/drivers/md/raid5.c b/drivers/md/raid5.c
index a87549be8..da197afff 100644
--- a/drivers/md/raid5.c
+++ b/drivers/md/raid5.c
@@ -1120,23 +1120,23 @@ async_copy_data(int frombio, struct bio *bio, struct page **page,
 	struct bio_vec bvl;
 	struct bvec_iter iter;
 	struct page *bio_page;
-	int page_offset;
+	s64 page_offset;
 	struct async_submit_ctl submit;
 	enum async_tx_flags flags = 0;
 
 	if (bio->bi_iter.bi_sector >= sector)
-		page_offset = (signed)(bio->bi_iter.bi_sector - sector) * 512;
+		page_offset = (s64)(bio->bi_iter.bi_sector - sector) * 512;
 	else
-		page_offset = (signed)(sector - bio->bi_iter.bi_sector) * -512;
+		page_offset = (s64)(sector - bio->bi_iter.bi_sector) * -512;
 
 	if (frombio)
 		flags |= ASYNC_TX_FENCE;
 	init_async_submit(&submit, flags, tx, NULL, NULL, NULL);
 
 	bio_for_each_segment(bvl, bio, iter) {
-		int len = bvl.bv_len;
-		int clen;
-		int b_offset = 0;
+		s64 len = bvl.bv_len;
+		s64 clen;
+		s64 b_offset = 0;
 
 		if (page_offset < 0) {
 			b_offset = -page_offset;
@@ -2040,6 +2040,10 @@ static int grow_one_stripe(struct r5conf *conf, gfp_t gfp)
 	return 1;
 }
 
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+static atomic_unchecked_t raid5_cache_id = ATOMIC_INIT(0);
+#endif
+
 static int grow_stripes(struct r5conf *conf, int num)
 {
 	struct kmem_cache *sc;
@@ -2050,7 +2054,11 @@ static int grow_stripes(struct r5conf *conf, int num)
 			"raid%d-%s", conf->level, mdname(conf->mddev));
 	else
 		sprintf(conf->cache_name[0],
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+			"raid%d-%08lx", conf->level, atomic_inc_return_unchecked(&raid5_cache_id));
+#else
 			"raid%d-%p", conf->level, conf->mddev);
+#endif
 	sprintf(conf->cache_name[1], "%s-alt", conf->cache_name[0]);
 
 	conf->active_name = 0;
@@ -2354,21 +2362,21 @@ static void raid5_end_read_request(struct bio * bi)
 				mdname(conf->mddev), STRIPE_SECTORS,
 				(unsigned long long)s,
 				bdevname(rdev->bdev, b));
-			atomic_add(STRIPE_SECTORS, &rdev->corrected_errors);
+			atomic_add_unchecked(STRIPE_SECTORS, &rdev->corrected_errors);
 			clear_bit(R5_ReadError, &sh->dev[i].flags);
 			clear_bit(R5_ReWrite, &sh->dev[i].flags);
 		} else if (test_bit(R5_ReadNoMerge, &sh->dev[i].flags))
 			clear_bit(R5_ReadNoMerge, &sh->dev[i].flags);
 
-		if (atomic_read(&rdev->read_errors))
-			atomic_set(&rdev->read_errors, 0);
+		if (atomic_read_unchecked(&rdev->read_errors))
+			atomic_set_unchecked(&rdev->read_errors, 0);
 	} else {
 		const char *bdn = bdevname(rdev->bdev, b);
 		int retry = 0;
 		int set_bad = 0;
 
 		clear_bit(R5_UPTODATE, &sh->dev[i].flags);
-		atomic_inc(&rdev->read_errors);
+		atomic_inc_unchecked(&rdev->read_errors);
 		if (test_bit(R5_ReadRepl, &sh->dev[i].flags))
 			printk_ratelimited(
 				KERN_WARNING
@@ -2396,7 +2404,7 @@ static void raid5_end_read_request(struct bio * bi)
 				mdname(conf->mddev),
 				(unsigned long long)s,
 				bdn);
-		} else if (atomic_read(&rdev->read_errors)
+		} else if (atomic_read_unchecked(&rdev->read_errors)
 			 > conf->max_nr_stripes)
 			printk(KERN_WARNING
 			       "md/raid:%s: Too many read errors, failing device %s.\n",
@@ -3763,7 +3771,7 @@ static void handle_parity_checks5(struct r5conf *conf, struct stripe_head *sh,
 			 */
 			set_bit(STRIPE_INSYNC, &sh->state);
 		else {
-			atomic64_add(STRIPE_SECTORS, &conf->mddev->resync_mismatches);
+			atomic64_add_unchecked(STRIPE_SECTORS, &conf->mddev->resync_mismatches);
 			if (test_bit(MD_RECOVERY_CHECK, &conf->mddev->recovery))
 				/* don't try to repair!! */
 				set_bit(STRIPE_INSYNC, &sh->state);
@@ -3915,7 +3923,7 @@ static void handle_parity_checks6(struct r5conf *conf, struct stripe_head *sh,
 				 */
 			}
 		} else {
-			atomic64_add(STRIPE_SECTORS, &conf->mddev->resync_mismatches);
+			atomic64_add_unchecked(STRIPE_SECTORS, &conf->mddev->resync_mismatches);
 			if (test_bit(MD_RECOVERY_CHECK, &conf->mddev->recovery))
 				/* don't try to repair!! */
 				set_bit(STRIPE_INSYNC, &sh->state);
diff --git a/drivers/media/dvb-core/dvb_net.c b/drivers/media/dvb-core/dvb_net.c
index 9914f69a4..177e48b7b 100644
--- a/drivers/media/dvb-core/dvb_net.c
+++ b/drivers/media/dvb-core/dvb_net.c
@@ -882,7 +882,7 @@ static int dvb_net_sec_callback(const u8 *buffer1, size_t buffer1_len,
 	return 0;
 }
 
-static int dvb_net_tx(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t dvb_net_tx(struct sk_buff *skb, struct net_device *dev)
 {
 	dev_kfree_skb(skb);
 	return NETDEV_TX_OK;
diff --git a/drivers/media/dvb-core/dvbdev.c b/drivers/media/dvb-core/dvbdev.c
index 75a3f4b57..06b70a336 100644
--- a/drivers/media/dvb-core/dvbdev.c
+++ b/drivers/media/dvb-core/dvbdev.c
@@ -428,7 +428,7 @@ int dvb_register_device(struct dvb_adapter *adap, struct dvb_device **pdvbdev,
 			int demux_sink_pads)
 {
 	struct dvb_device *dvbdev;
-	struct file_operations *dvbdevfops;
+	file_operations_no_const *dvbdevfops;
 	struct device *clsdev;
 	int minor;
 	int id, ret;
diff --git a/drivers/media/dvb-frontends/af9033.h b/drivers/media/dvb-frontends/af9033.h
index 6ad22b69a..6e90e2af9 100644
--- a/drivers/media/dvb-frontends/af9033.h
+++ b/drivers/media/dvb-frontends/af9033.h
@@ -96,6 +96,6 @@ struct af9033_ops {
 	int (*pid_filter_ctrl)(struct dvb_frontend *fe, int onoff);
 	int (*pid_filter)(struct dvb_frontend *fe, int index, u16 pid,
 			  int onoff);
-};
+} __no_const;
 
 #endif /* AF9033_H */
diff --git a/drivers/media/dvb-frontends/cx24116.c b/drivers/media/dvb-frontends/cx24116.c
index 5b461bb57..48d570895 100644
--- a/drivers/media/dvb-frontends/cx24116.c
+++ b/drivers/media/dvb-frontends/cx24116.c
@@ -1462,7 +1462,7 @@ static int cx24116_tune(struct dvb_frontend *fe, bool re_tune,
 	return cx24116_read_status(fe, status);
 }
 
-static int cx24116_get_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo cx24116_get_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/dvb-frontends/cx24117.c b/drivers/media/dvb-frontends/cx24117.c
index 65a97c95b..6217471a8 100644
--- a/drivers/media/dvb-frontends/cx24117.c
+++ b/drivers/media/dvb-frontends/cx24117.c
@@ -1555,7 +1555,7 @@ static int cx24117_tune(struct dvb_frontend *fe, bool re_tune,
 	return cx24117_read_status(fe, status);
 }
 
-static int cx24117_get_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo cx24117_get_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/dvb-frontends/cx24120.c b/drivers/media/dvb-frontends/cx24120.c
index 216788ddb..378308706 100644
--- a/drivers/media/dvb-frontends/cx24120.c
+++ b/drivers/media/dvb-frontends/cx24120.c
@@ -1492,7 +1492,7 @@ static int cx24120_tune(struct dvb_frontend *fe, bool re_tune,
 	return cx24120_read_status(fe, status);
 }
 
-static int cx24120_get_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo cx24120_get_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/dvb-frontends/cx24123.c b/drivers/media/dvb-frontends/cx24123.c
index 113b09494..c9424e6c2 100644
--- a/drivers/media/dvb-frontends/cx24123.c
+++ b/drivers/media/dvb-frontends/cx24123.c
@@ -1009,7 +1009,7 @@ static int cx24123_tune(struct dvb_frontend *fe,
 	return retval;
 }
 
-static int cx24123_get_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo cx24123_get_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/dvb-frontends/cxd2820r_core.c b/drivers/media/dvb-frontends/cxd2820r_core.c
index 314d3b8c1..e2257bd45 100644
--- a/drivers/media/dvb-frontends/cxd2820r_core.c
+++ b/drivers/media/dvb-frontends/cxd2820r_core.c
@@ -572,7 +572,7 @@ error:
 	return DVBFE_ALGO_SEARCH_ERROR;
 }
 
-static int cxd2820r_get_frontend_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo cxd2820r_get_frontend_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_CUSTOM;
 }
diff --git a/drivers/media/dvb-frontends/dib3000.h b/drivers/media/dvb-frontends/dib3000.h
index d5dfafb4e..b7ed9d9fb 100644
--- a/drivers/media/dvb-frontends/dib3000.h
+++ b/drivers/media/dvb-frontends/dib3000.h
@@ -39,7 +39,7 @@ struct dib_fe_xfer_ops
 	int (*fifo_ctrl)(struct dvb_frontend *fe, int onoff);
 	int (*pid_ctrl)(struct dvb_frontend *fe, int index, int pid, int onoff);
 	int (*tuner_pass_ctrl)(struct dvb_frontend *fe, int onoff, u8 pll_ctrl);
-};
+} __no_const;
 
 #if IS_REACHABLE(CONFIG_DVB_DIB3000MB)
 extern struct dvb_frontend* dib3000mb_attach(const struct dib3000_config* config,
diff --git a/drivers/media/dvb-frontends/dib7000p.h b/drivers/media/dvb-frontends/dib7000p.h
index baa278928..c8de7fe1c 100644
--- a/drivers/media/dvb-frontends/dib7000p.h
+++ b/drivers/media/dvb-frontends/dib7000p.h
@@ -64,7 +64,7 @@ struct dib7000p_ops {
 	int (*get_adc_power)(struct dvb_frontend *fe);
 	int (*slave_reset)(struct dvb_frontend *fe);
 	struct dvb_frontend *(*init)(struct i2c_adapter *i2c_adap, u8 i2c_addr, struct dib7000p_config *cfg);
-};
+} __no_const;
 
 #if IS_REACHABLE(CONFIG_DVB_DIB7000P)
 void *dib7000p_attach(struct dib7000p_ops *ops);
diff --git a/drivers/media/dvb-frontends/dib8000.h b/drivers/media/dvb-frontends/dib8000.h
index 2b8b4b165..8cef451b3 100644
--- a/drivers/media/dvb-frontends/dib8000.h
+++ b/drivers/media/dvb-frontends/dib8000.h
@@ -61,7 +61,7 @@ struct dib8000_ops {
 	int (*pid_filter_ctrl)(struct dvb_frontend *fe, u8 onoff);
 	int (*pid_filter)(struct dvb_frontend *fe, u8 id, u16 pid, u8 onoff);
 	struct dvb_frontend *(*init)(struct i2c_adapter *i2c_adap, u8 i2c_addr, struct dib8000_config *cfg);
-};
+} __no_const;
 
 #if IS_REACHABLE(CONFIG_DVB_DIB8000)
 void *dib8000_attach(struct dib8000_ops *ops);
diff --git a/drivers/media/dvb-frontends/hd29l2.c b/drivers/media/dvb-frontends/hd29l2.c
index 1c7eb477e..c1cd6b869 100644
--- a/drivers/media/dvb-frontends/hd29l2.c
+++ b/drivers/media/dvb-frontends/hd29l2.c
@@ -555,7 +555,7 @@ err:
 	return DVBFE_ALGO_SEARCH_ERROR;
 }
 
-static int hd29l2_get_frontend_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo hd29l2_get_frontend_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_CUSTOM;
 }
diff --git a/drivers/media/dvb-frontends/lgdt3306a.c b/drivers/media/dvb-frontends/lgdt3306a.c
index 179c26e5e..af482feef 100644
--- a/drivers/media/dvb-frontends/lgdt3306a.c
+++ b/drivers/media/dvb-frontends/lgdt3306a.c
@@ -1734,7 +1734,7 @@ static int lgdt3306a_get_tune_settings(struct dvb_frontend *fe,
 	return 0;
 }
 
-static int lgdt3306a_search(struct dvb_frontend *fe)
+static enum dvbfe_search lgdt3306a_search(struct dvb_frontend *fe)
 {
 	enum fe_status status = 0;
 	int i, ret;
diff --git a/drivers/media/dvb-frontends/mb86a20s.c b/drivers/media/dvb-frontends/mb86a20s.c
index fe79358b0..6b9c49979 100644
--- a/drivers/media/dvb-frontends/mb86a20s.c
+++ b/drivers/media/dvb-frontends/mb86a20s.c
@@ -2054,7 +2054,7 @@ static void mb86a20s_release(struct dvb_frontend *fe)
 	kfree(state);
 }
 
-static int mb86a20s_get_frontend_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo mb86a20s_get_frontend_algo(struct dvb_frontend *fe)
 {
         return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/dvb-frontends/mt312.c b/drivers/media/dvb-frontends/mt312.c
index fc08429c9..c81669749 100644
--- a/drivers/media/dvb-frontends/mt312.c
+++ b/drivers/media/dvb-frontends/mt312.c
@@ -381,7 +381,7 @@ static int mt312_send_master_cmd(struct dvb_frontend *fe,
 }
 
 static int mt312_send_burst(struct dvb_frontend *fe,
-			    const enum fe_sec_mini_cmd c)
+			    enum fe_sec_mini_cmd c)
 {
 	struct mt312_state *state = fe->demodulator_priv;
 	const u8 mini_tab[2] = { 0x02, 0x03 };
@@ -405,7 +405,7 @@ static int mt312_send_burst(struct dvb_frontend *fe,
 }
 
 static int mt312_set_tone(struct dvb_frontend *fe,
-			  const enum fe_sec_tone_mode t)
+			  enum fe_sec_tone_mode t)
 {
 	struct mt312_state *state = fe->demodulator_priv;
 	const u8 tone_tab[2] = { 0x01, 0x00 };
@@ -429,7 +429,7 @@ static int mt312_set_tone(struct dvb_frontend *fe,
 }
 
 static int mt312_set_voltage(struct dvb_frontend *fe,
-			     const enum fe_sec_voltage v)
+			     enum fe_sec_voltage v)
 {
 	struct mt312_state *state = fe->demodulator_priv;
 	const u8 volt_tab[3] = { 0x00, 0x40, 0x00 };
diff --git a/drivers/media/dvb-frontends/s921.c b/drivers/media/dvb-frontends/s921.c
index b5e3d90eb..bd00dc60e 100644
--- a/drivers/media/dvb-frontends/s921.c
+++ b/drivers/media/dvb-frontends/s921.c
@@ -464,7 +464,7 @@ static int s921_tune(struct dvb_frontend *fe,
 	return rc;
 }
 
-static int s921_get_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo s921_get_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/pci/bt8xx/dst.c b/drivers/media/pci/bt8xx/dst.c
index 35bc9b228..d5072b11b 100644
--- a/drivers/media/pci/bt8xx/dst.c
+++ b/drivers/media/pci/bt8xx/dst.c
@@ -1683,7 +1683,7 @@ static int dst_tune_frontend(struct dvb_frontend* fe,
 	return 0;
 }
 
-static int dst_get_tuning_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo dst_get_tuning_algo(struct dvb_frontend *fe)
 {
 	return dst_algo ? DVBFE_ALGO_HW : DVBFE_ALGO_SW;
 }
diff --git a/drivers/media/pci/cx88/cx88-video.c b/drivers/media/pci/cx88/cx88-video.c
index 5dc1e3f08..ed6db075e 100644
--- a/drivers/media/pci/cx88/cx88-video.c
+++ b/drivers/media/pci/cx88/cx88-video.c
@@ -50,9 +50,9 @@ MODULE_VERSION(CX88_VERSION);
 
 /* ------------------------------------------------------------------ */
 
-static unsigned int video_nr[] = {[0 ... (CX88_MAXBOARDS - 1)] = UNSET };
-static unsigned int vbi_nr[]   = {[0 ... (CX88_MAXBOARDS - 1)] = UNSET };
-static unsigned int radio_nr[] = {[0 ... (CX88_MAXBOARDS - 1)] = UNSET };
+static int video_nr[] = {[0 ... (CX88_MAXBOARDS - 1)] = UNSET };
+static int vbi_nr[]   = {[0 ... (CX88_MAXBOARDS - 1)] = UNSET };
+static int radio_nr[] = {[0 ... (CX88_MAXBOARDS - 1)] = UNSET };
 
 module_param_array(video_nr, int, NULL, 0444);
 module_param_array(vbi_nr,   int, NULL, 0444);
diff --git a/drivers/media/pci/ivtv/ivtv-driver.c b/drivers/media/pci/ivtv/ivtv-driver.c
index 313aa6c2c..de17fc31d 100644
--- a/drivers/media/pci/ivtv/ivtv-driver.c
+++ b/drivers/media/pci/ivtv/ivtv-driver.c
@@ -83,7 +83,7 @@ static struct pci_device_id ivtv_pci_tbl[] = {
 MODULE_DEVICE_TABLE(pci,ivtv_pci_tbl);
 
 /* ivtv instance counter */
-static atomic_t ivtv_instance = ATOMIC_INIT(0);
+static atomic_unchecked_t ivtv_instance = ATOMIC_INIT(0);
 
 /* Parameter declarations */
 static int cardtype[IVTV_MAX_CARDS];
diff --git a/drivers/media/pci/pt1/va1j5jf8007s.c b/drivers/media/pci/pt1/va1j5jf8007s.c
index d0e70dc0e..e4fee6846 100644
--- a/drivers/media/pci/pt1/va1j5jf8007s.c
+++ b/drivers/media/pci/pt1/va1j5jf8007s.c
@@ -102,7 +102,7 @@ static int va1j5jf8007s_read_snr(struct dvb_frontend *fe, u16 *snr)
 	return 0;
 }
 
-static int va1j5jf8007s_get_frontend_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo va1j5jf8007s_get_frontend_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/pci/pt1/va1j5jf8007t.c b/drivers/media/pci/pt1/va1j5jf8007t.c
index 0268f20b8..de9dff74a 100644
--- a/drivers/media/pci/pt1/va1j5jf8007t.c
+++ b/drivers/media/pci/pt1/va1j5jf8007t.c
@@ -92,7 +92,7 @@ static int va1j5jf8007t_read_snr(struct dvb_frontend *fe, u16 *snr)
 	return 0;
 }
 
-static int va1j5jf8007t_get_frontend_algo(struct dvb_frontend *fe)
+static enum dvbfe_algo va1j5jf8007t_get_frontend_algo(struct dvb_frontend *fe)
 {
 	return DVBFE_ALGO_HW;
 }
diff --git a/drivers/media/pci/solo6x10/solo6x10-core.c b/drivers/media/pci/solo6x10/solo6x10-core.c
index f50d07229..0214f25e1 100644
--- a/drivers/media/pci/solo6x10/solo6x10-core.c
+++ b/drivers/media/pci/solo6x10/solo6x10-core.c
@@ -411,7 +411,7 @@ static void solo_device_release(struct device *dev)
 
 static int solo_sysfs_init(struct solo_dev *solo_dev)
 {
-	struct bin_attribute *sdram_attr = &solo_dev->sdram_attr;
+	bin_attribute_no_const *sdram_attr = &solo_dev->sdram_attr;
 	struct device *dev = &solo_dev->dev;
 	const char *driver;
 	int i;
diff --git a/drivers/media/pci/solo6x10/solo6x10-g723.c b/drivers/media/pci/solo6x10/solo6x10-g723.c
index 4a37a1c51..7e82dfd27 100644
--- a/drivers/media/pci/solo6x10/solo6x10-g723.c
+++ b/drivers/media/pci/solo6x10/solo6x10-g723.c
@@ -350,7 +350,7 @@ static int solo_snd_pcm_init(struct solo_dev *solo_dev)
 
 int solo_g723_init(struct solo_dev *solo_dev)
 {
-	static struct snd_device_ops ops = { NULL };
+	static struct snd_device_ops ops = { };
 	struct snd_card *card;
 	struct snd_kcontrol_new kctl;
 	char name[32];
diff --git a/drivers/media/pci/solo6x10/solo6x10-p2m.c b/drivers/media/pci/solo6x10/solo6x10-p2m.c
index 8c8484674..27b4f83d5 100644
--- a/drivers/media/pci/solo6x10/solo6x10-p2m.c
+++ b/drivers/media/pci/solo6x10/solo6x10-p2m.c
@@ -73,7 +73,7 @@ int solo_p2m_dma_desc(struct solo_dev *solo_dev,
 
 	/* Get next ID. According to Softlogic, 6110 has problems on !=0 P2M */
 	if (solo_dev->type != SOLO_DEV_6110 && multi_p2m) {
-		p2m_id = atomic_inc_return(&solo_dev->p2m_count) % SOLO_NR_P2M;
+		p2m_id = atomic_inc_return_unchecked(&solo_dev->p2m_count) % SOLO_NR_P2M;
 		if (p2m_id < 0)
 			p2m_id = -p2m_id;
 	}
diff --git a/drivers/media/pci/solo6x10/solo6x10.h b/drivers/media/pci/solo6x10/solo6x10.h
index 3f8da5e8c..b1de8beae 100644
--- a/drivers/media/pci/solo6x10/solo6x10.h
+++ b/drivers/media/pci/solo6x10/solo6x10.h
@@ -216,7 +216,7 @@ struct solo_dev {
 
 	/* P2M DMA Engine */
 	struct solo_p2m_dev	p2m_dev[SOLO_NR_P2M];
-	atomic_t		p2m_count;
+	atomic_unchecked_t	p2m_count;
 	int			p2m_jiffies;
 	unsigned int		p2m_timeouts;
 
diff --git a/drivers/media/pci/sta2x11/sta2x11_vip.c b/drivers/media/pci/sta2x11/sta2x11_vip.c
index aeb2b4e2d..53420d11e 100644
--- a/drivers/media/pci/sta2x11/sta2x11_vip.c
+++ b/drivers/media/pci/sta2x11/sta2x11_vip.c
@@ -775,8 +775,9 @@ static struct video_device video_dev_template = {
  *
  * IRQ_HANDLED, interrupt done.
  */
-static irqreturn_t vip_irq(int irq, struct sta2x11_vip *vip)
+static irqreturn_t vip_irq(int irq, void *_vip)
 {
+	struct sta2x11_vip *vip = _vip;
 	unsigned int status;
 
 	status = reg_read(vip, DVP_ITS);
@@ -1058,7 +1059,7 @@ static int sta2x11_vip_init_one(struct pci_dev *pdev,
 	spin_lock_init(&vip->slock);
 
 	ret = request_irq(pdev->irq,
-			  (irq_handler_t) vip_irq,
+			  vip_irq,
 			  IRQF_SHARED, KBUILD_MODNAME, vip);
 	if (ret) {
 		dev_err(&pdev->dev, "request_irq failed\n");
diff --git a/drivers/media/pci/tw68/tw68-core.c b/drivers/media/pci/tw68/tw68-core.c
index 8474528be..6c4e44242 100644
--- a/drivers/media/pci/tw68/tw68-core.c
+++ b/drivers/media/pci/tw68/tw68-core.c
@@ -61,7 +61,7 @@ static unsigned int card[] = {[0 ... (TW68_MAXBOARDS - 1)] = UNSET };
 module_param_array(card, int, NULL, 0444);
 MODULE_PARM_DESC(card, "card type");
 
-static atomic_t tw68_instance = ATOMIC_INIT(0);
+static atomic_unchecked_t tw68_instance = ATOMIC_INIT(0);
 
 /* ------------------------------------------------------------------ */
 
diff --git a/drivers/media/pci/tw686x/tw686x-core.c b/drivers/media/pci/tw686x/tw686x-core.c
index 71a0453b1..279d4478c 100644
--- a/drivers/media/pci/tw686x/tw686x-core.c
+++ b/drivers/media/pci/tw686x/tw686x-core.c
@@ -72,12 +72,12 @@ static const char *dma_mode_name(unsigned int mode)
 	}
 }
 
-static int tw686x_dma_mode_get(char *buffer, struct kernel_param *kp)
+static int tw686x_dma_mode_get(char *buffer, const struct kernel_param *kp)
 {
 	return sprintf(buffer, dma_mode_name(dma_mode));
 }
 
-static int tw686x_dma_mode_set(const char *val, struct kernel_param *kp)
+static int tw686x_dma_mode_set(const char *val, const struct kernel_param *kp)
 {
 	if (!strcasecmp(val, dma_mode_name(TW686X_DMA_MODE_MEMCPY)))
 		dma_mode = TW686X_DMA_MODE_MEMCPY;
diff --git a/drivers/media/pci/zoran/zoran.h b/drivers/media/pci/zoran/zoran.h
index 4e7db8939..bd7ef95aa 100644
--- a/drivers/media/pci/zoran/zoran.h
+++ b/drivers/media/pci/zoran/zoran.h
@@ -178,7 +178,6 @@ struct zoran_fh;
 
 struct zoran_mapping {
 	struct zoran_fh *fh;
-	atomic_t count;
 };
 
 struct zoran_buffer {
diff --git a/drivers/media/pci/zoran/zoran_card.c b/drivers/media/pci/zoran/zoran_card.c
index 9d2697f5b..65fb18f61 100644
--- a/drivers/media/pci/zoran/zoran_card.c
+++ b/drivers/media/pci/zoran/zoran_card.c
@@ -1356,7 +1356,7 @@ static int zoran_probe(struct pci_dev *pdev, const struct pci_device_id *ent)
 	if (zr->card.video_codec) {
 		codec_name = codecid_to_modulename(zr->card.video_codec);
 		if (codec_name) {
-			result = request_module(codec_name);
+			result = request_module("%s", codec_name);
 			if (result) {
 				dprintk(1,
 					KERN_ERR
@@ -1368,7 +1368,7 @@ static int zoran_probe(struct pci_dev *pdev, const struct pci_device_id *ent)
 	if (zr->card.video_vfe) {
 		vfe_name = codecid_to_modulename(zr->card.video_vfe);
 		if (vfe_name) {
-			result = request_module(vfe_name);
+			result = request_module("%s", vfe_name);
 			if (result < 0) {
 				dprintk(1,
 					KERN_ERR
diff --git a/drivers/media/pci/zoran/zoran_driver.c b/drivers/media/pci/zoran/zoran_driver.c
index 80caa70c6..d076ecf4e 100644
--- a/drivers/media/pci/zoran/zoran_driver.c
+++ b/drivers/media/pci/zoran/zoran_driver.c
@@ -2607,8 +2607,6 @@ zoran_poll (struct file *file,
 static void
 zoran_vm_open (struct vm_area_struct *vma)
 {
-	struct zoran_mapping *map = vma->vm_private_data;
-	atomic_inc(&map->count);
 }
 
 static void
@@ -2736,7 +2734,6 @@ zoran_mmap (struct file           *file,
 		return res;
 	}
 	map->fh = fh;
-	atomic_set(&map->count, 1);
 
 	vma->vm_ops = &zoran_vm_ops;
 	vma->vm_flags |= VM_DONTEXPAND;
diff --git a/drivers/media/platform/mtk-vcodec/venc/venc_h264_if.c b/drivers/media/platform/mtk-vcodec/venc/venc_h264_if.c
index 63d4be4ff..451b8e1c7 100644
--- a/drivers/media/platform/mtk-vcodec/venc/venc_h264_if.c
+++ b/drivers/media/platform/mtk-vcodec/venc/venc_h264_if.c
@@ -665,10 +665,10 @@ static int h264_enc_deinit(unsigned long handle)
 }
 
 static struct venc_common_if venc_h264_if = {
-	h264_enc_init,
-	h264_enc_encode,
-	h264_enc_set_param,
-	h264_enc_deinit,
+	.init = h264_enc_init,
+	.encode = h264_enc_encode,
+	.set_param = h264_enc_set_param,
+	.deinit = h264_enc_deinit,
 };
 
 struct venc_common_if *get_h264_enc_comm_if(void);
diff --git a/drivers/media/platform/mtk-vcodec/venc/venc_vp8_if.c b/drivers/media/platform/mtk-vcodec/venc/venc_vp8_if.c
index 6d9758479..8539e9b4d 100644
--- a/drivers/media/platform/mtk-vcodec/venc/venc_vp8_if.c
+++ b/drivers/media/platform/mtk-vcodec/venc/venc_vp8_if.c
@@ -470,10 +470,10 @@ static int vp8_enc_deinit(unsigned long handle)
 }
 
 static struct venc_common_if venc_vp8_if = {
-	vp8_enc_init,
-	vp8_enc_encode,
-	vp8_enc_set_param,
-	vp8_enc_deinit,
+	.init = vp8_enc_init,
+	.encode = vp8_enc_encode,
+	.set_param = vp8_enc_set_param,
+	.deinit = vp8_enc_deinit,
 };
 
 struct venc_common_if *get_vp8_enc_comm_if(void);
diff --git a/drivers/media/platform/omap/omap_vout.c b/drivers/media/platform/omap/omap_vout.c
index 6b01e126f..0f35c56bf 100644
--- a/drivers/media/platform/omap/omap_vout.c
+++ b/drivers/media/platform/omap/omap_vout.c
@@ -63,7 +63,6 @@ enum omap_vout_channels {
 	OMAP_VIDEO2,
 };
 
-static struct videobuf_queue_ops video_vbq_ops;
 /* Variables configurable through module params*/
 static u32 video1_numbuffers = 3;
 static u32 video2_numbuffers = 3;
@@ -1001,6 +1000,12 @@ static int omap_vout_open(struct file *file)
 {
 	struct videobuf_queue *q;
 	struct omap_vout_device *vout = NULL;
+	static struct videobuf_queue_ops video_vbq_ops = {
+		.buf_setup = omap_vout_buffer_setup,
+		.buf_prepare = omap_vout_buffer_prepare,
+		.buf_release = omap_vout_buffer_release,
+		.buf_queue = omap_vout_buffer_queue,
+	};
 
 	vout = video_drvdata(file);
 	v4l2_dbg(1, debug, &vout->vid_dev->v4l2_dev, "Entering %s\n", __func__);
@@ -1018,10 +1023,6 @@ static int omap_vout_open(struct file *file)
 	vout->type = V4L2_BUF_TYPE_VIDEO_OUTPUT;
 
 	q = &vout->vbq;
-	video_vbq_ops.buf_setup = omap_vout_buffer_setup;
-	video_vbq_ops.buf_prepare = omap_vout_buffer_prepare;
-	video_vbq_ops.buf_release = omap_vout_buffer_release;
-	video_vbq_ops.buf_queue = omap_vout_buffer_queue;
 	spin_lock_init(&vout->vbq_lock);
 
 	videobuf_queue_dma_contig_init(q, &video_vbq_ops, q->dev,
diff --git a/drivers/media/platform/s5p-tv/mixer.h b/drivers/media/platform/s5p-tv/mixer.h
index 869f0ce86..c9c6e9ecc 100644
--- a/drivers/media/platform/s5p-tv/mixer.h
+++ b/drivers/media/platform/s5p-tv/mixer.h
@@ -156,7 +156,7 @@ struct mxr_layer {
 	/** layer index (unique identifier) */
 	int idx;
 	/** callbacks for layer methods */
-	struct mxr_layer_ops ops;
+	struct mxr_layer_ops *ops;
 	/** format array */
 	const struct mxr_format **fmt_array;
 	/** size of format array */
diff --git a/drivers/media/platform/s5p-tv/mixer_grp_layer.c b/drivers/media/platform/s5p-tv/mixer_grp_layer.c
index d4d2564f7..f4570ea5f 100644
--- a/drivers/media/platform/s5p-tv/mixer_grp_layer.c
+++ b/drivers/media/platform/s5p-tv/mixer_grp_layer.c
@@ -235,7 +235,7 @@ struct mxr_layer *mxr_graph_layer_create(struct mxr_device *mdev, int idx)
 {
 	struct mxr_layer *layer;
 	int ret;
-	const struct mxr_layer_ops ops = {
+	static const struct mxr_layer_ops ops = {
 		.release = mxr_graph_layer_release,
 		.buffer_set = mxr_graph_buffer_set,
 		.stream_set = mxr_graph_stream_set,
diff --git a/drivers/media/platform/s5p-tv/mixer_reg.c b/drivers/media/platform/s5p-tv/mixer_reg.c
index a0ec14a1d..225f4ac0f 100644
--- a/drivers/media/platform/s5p-tv/mixer_reg.c
+++ b/drivers/media/platform/s5p-tv/mixer_reg.c
@@ -276,7 +276,7 @@ static void mxr_irq_layer_handle(struct mxr_layer *layer)
 		layer->update_buf = next;
 	}
 
-	layer->ops.buffer_set(layer, layer->update_buf);
+	layer->ops->buffer_set(layer, layer->update_buf);
 
 	if (done && done != layer->shadow_buf)
 		vb2_buffer_done(&done->vb.vb2_buf, VB2_BUF_STATE_DONE);
diff --git a/drivers/media/platform/s5p-tv/mixer_video.c b/drivers/media/platform/s5p-tv/mixer_video.c
index ee74e2b44..9d2dae9e5 100644
--- a/drivers/media/platform/s5p-tv/mixer_video.c
+++ b/drivers/media/platform/s5p-tv/mixer_video.c
@@ -201,7 +201,7 @@ static void mxr_layer_default_geo(struct mxr_layer *layer)
 	layer->geo.src.height = layer->geo.src.full_height;
 
 	mxr_geometry_dump(mdev, &layer->geo);
-	layer->ops.fix_geometry(layer, MXR_GEOMETRY_SINK, 0);
+	layer->ops->fix_geometry(layer, MXR_GEOMETRY_SINK, 0);
 	mxr_geometry_dump(mdev, &layer->geo);
 }
 
@@ -219,7 +219,7 @@ static void mxr_layer_update_output(struct mxr_layer *layer)
 	layer->geo.dst.full_width = mbus_fmt.width;
 	layer->geo.dst.full_height = mbus_fmt.height;
 	layer->geo.dst.field = mbus_fmt.field;
-	layer->ops.fix_geometry(layer, MXR_GEOMETRY_SINK, 0);
+	layer->ops->fix_geometry(layer, MXR_GEOMETRY_SINK, 0);
 
 	mxr_geometry_dump(mdev, &layer->geo);
 }
@@ -325,7 +325,7 @@ static int mxr_s_fmt(struct file *file, void *priv,
 	/* set source size to highest accepted value */
 	geo->src.full_width = max(geo->dst.full_width, pix->width);
 	geo->src.full_height = max(geo->dst.full_height, pix->height);
-	layer->ops.fix_geometry(layer, MXR_GEOMETRY_SOURCE, 0);
+	layer->ops->fix_geometry(layer, MXR_GEOMETRY_SOURCE, 0);
 	mxr_geometry_dump(mdev, &layer->geo);
 	/* set cropping to total visible screen */
 	geo->src.width = pix->width;
@@ -333,12 +333,12 @@ static int mxr_s_fmt(struct file *file, void *priv,
 	geo->src.x_offset = 0;
 	geo->src.y_offset = 0;
 	/* assure consistency of geometry */
-	layer->ops.fix_geometry(layer, MXR_GEOMETRY_CROP, MXR_NO_OFFSET);
+	layer->ops->fix_geometry(layer, MXR_GEOMETRY_CROP, MXR_NO_OFFSET);
 	mxr_geometry_dump(mdev, &layer->geo);
 	/* set full size to lowest possible value */
 	geo->src.full_width = 0;
 	geo->src.full_height = 0;
-	layer->ops.fix_geometry(layer, MXR_GEOMETRY_SOURCE, 0);
+	layer->ops->fix_geometry(layer, MXR_GEOMETRY_SOURCE, 0);
 	mxr_geometry_dump(mdev, &layer->geo);
 
 	/* returning results */
@@ -465,7 +465,7 @@ static int mxr_s_selection(struct file *file, void *fh,
 		target->width = s->r.width;
 		target->height = s->r.height;
 
-		layer->ops.fix_geometry(layer, stage, s->flags);
+		layer->ops->fix_geometry(layer, stage, s->flags);
 
 		/* retrieve update selection rectangle */
 		res.left = target->x_offset;
@@ -929,13 +929,13 @@ static int start_streaming(struct vb2_queue *vq, unsigned int count)
 	mxr_output_get(mdev);
 
 	mxr_layer_update_output(layer);
-	layer->ops.format_set(layer);
+	layer->ops->format_set(layer);
 	/* enabling layer in hardware */
 	spin_lock_irqsave(&layer->enq_slock, flags);
 	layer->state = MXR_LAYER_STREAMING;
 	spin_unlock_irqrestore(&layer->enq_slock, flags);
 
-	layer->ops.stream_set(layer, MXR_ENABLE);
+	layer->ops->stream_set(layer, MXR_ENABLE);
 	mxr_streamer_get(mdev);
 
 	return 0;
@@ -1007,7 +1007,7 @@ static void stop_streaming(struct vb2_queue *vq)
 	spin_unlock_irqrestore(&layer->enq_slock, flags);
 
 	/* disabling layer in hardware */
-	layer->ops.stream_set(layer, MXR_DISABLE);
+	layer->ops->stream_set(layer, MXR_DISABLE);
 	/* remove one streamer */
 	mxr_streamer_put(mdev);
 	/* allow changes in output configuration */
@@ -1045,8 +1045,8 @@ void mxr_base_layer_unregister(struct mxr_layer *layer)
 
 void mxr_layer_release(struct mxr_layer *layer)
 {
-	if (layer->ops.release)
-		layer->ops.release(layer);
+	if (layer->ops->release)
+		layer->ops->release(layer);
 }
 
 void mxr_base_layer_release(struct mxr_layer *layer)
@@ -1072,7 +1072,7 @@ struct mxr_layer *mxr_base_layer_create(struct mxr_device *mdev,
 
 	layer->mdev = mdev;
 	layer->idx = idx;
-	layer->ops = *ops;
+	layer->ops = ops;
 
 	spin_lock_init(&layer->enq_slock);
 	INIT_LIST_HEAD(&layer->enq_list);
diff --git a/drivers/media/platform/s5p-tv/mixer_vp_layer.c b/drivers/media/platform/s5p-tv/mixer_vp_layer.c
index 6fa6f673f..04b574b2f 100644
--- a/drivers/media/platform/s5p-tv/mixer_vp_layer.c
+++ b/drivers/media/platform/s5p-tv/mixer_vp_layer.c
@@ -207,7 +207,7 @@ struct mxr_layer *mxr_vp_layer_create(struct mxr_device *mdev, int idx)
 {
 	struct mxr_layer *layer;
 	int ret;
-	const struct mxr_layer_ops ops = {
+	static const struct mxr_layer_ops ops = {
 		.release = mxr_vp_layer_release,
 		.buffer_set = mxr_vp_buffer_set,
 		.stream_set = mxr_vp_stream_set,
diff --git a/drivers/media/platform/soc_camera/soc_camera.c b/drivers/media/platform/soc_camera/soc_camera.c
index 46c7186f7..47130c8b2 100644
--- a/drivers/media/platform/soc_camera/soc_camera.c
+++ b/drivers/media/platform/soc_camera/soc_camera.c
@@ -1791,7 +1791,7 @@ static int soc_camera_probe(struct soc_camera_host *ici,
 			goto eadd;
 
 		if (shd->module_name)
-			ret = request_module(shd->module_name);
+			ret = request_module("%s", shd->module_name);
 
 		ret = shd->add_device(icd);
 		if (ret < 0)
diff --git a/drivers/media/platform/sti/c8sectpfe/Kconfig b/drivers/media/platform/sti/c8sectpfe/Kconfig
index 7420a5057..e6f31a097 100644
--- a/drivers/media/platform/sti/c8sectpfe/Kconfig
+++ b/drivers/media/platform/sti/c8sectpfe/Kconfig
@@ -4,6 +4,7 @@ config DVB_C8SECTPFE
 	depends on ARCH_STI || ARCH_MULTIPLATFORM || COMPILE_TEST
 	select FW_LOADER
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	select DVB_LNBP21 if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_STV090x if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_STB6100 if MEDIA_SUBDRV_AUTOSELECT
diff --git a/drivers/media/radio/radio-cadet.c b/drivers/media/radio/radio-cadet.c
index 82affaedf..42833ec00 100644
--- a/drivers/media/radio/radio-cadet.c
+++ b/drivers/media/radio/radio-cadet.c
@@ -333,6 +333,8 @@ static ssize_t cadet_read(struct file *file, char __user *data, size_t count, lo
 	unsigned char readbuf[RDS_BUFFER];
 	int i = 0;
 
+	if (count > RDS_BUFFER)
+		return -EFAULT;
 	mutex_lock(&dev->lock);
 	if (dev->rdsstat == 0)
 		cadet_start_rds(dev);
@@ -349,8 +351,9 @@ static ssize_t cadet_read(struct file *file, char __user *data, size_t count, lo
 		readbuf[i++] = dev->rdsbuf[dev->rdsout++];
 	mutex_unlock(&dev->lock);
 
-	if (i && copy_to_user(data, readbuf, i))
-		return -EFAULT;
+	if (i > sizeof(readbuf) || (i && copy_to_user(data, readbuf, i)))
+		i = -EFAULT;
+
 	return i;
 }
 
diff --git a/drivers/media/radio/radio-maxiradio.c b/drivers/media/radio/radio-maxiradio.c
index 8253f79d5..ca5f5792f 100644
--- a/drivers/media/radio/radio-maxiradio.c
+++ b/drivers/media/radio/radio-maxiradio.c
@@ -61,7 +61,7 @@ MODULE_PARM_DESC(radio_nr, "Radio device number");
 /* TEA5757 pin mappings */
 static const int clk = 1, data = 2, wren = 4, mo_st = 8, power = 16;
 
-static atomic_t maxiradio_instance = ATOMIC_INIT(0);
+static atomic_unchecked_t maxiradio_instance = ATOMIC_INIT(0);
 
 #define PCI_VENDOR_ID_GUILLEMOT 0x5046
 #define PCI_DEVICE_ID_GUILLEMOT_MAXIRADIO 0x1001
diff --git a/drivers/media/radio/radio-shark.c b/drivers/media/radio/radio-shark.c
index 85667a95f..ec4dc0a3a 100644
--- a/drivers/media/radio/radio-shark.c
+++ b/drivers/media/radio/radio-shark.c
@@ -79,7 +79,7 @@ struct shark_device {
 	u32 last_val;
 };
 
-static atomic_t shark_instance = ATOMIC_INIT(0);
+static atomic_unchecked_t shark_instance = ATOMIC_INIT(0);
 
 static void shark_write_val(struct snd_tea575x *tea, u32 val)
 {
diff --git a/drivers/media/radio/radio-shark2.c b/drivers/media/radio/radio-shark2.c
index 0e65a85d5..3fa6f5c57 100644
--- a/drivers/media/radio/radio-shark2.c
+++ b/drivers/media/radio/radio-shark2.c
@@ -74,7 +74,7 @@ struct shark_device {
 	u8 *transfer_buffer;
 };
 
-static atomic_t shark_instance = ATOMIC_INIT(0);
+static atomic_unchecked_t shark_instance = ATOMIC_INIT(0);
 
 static int shark_write_reg(struct radio_tea5777 *tea, u64 reg)
 {
diff --git a/drivers/media/radio/radio-si476x.c b/drivers/media/radio/radio-si476x.c
index 271f725b1..35e8c8f81 100644
--- a/drivers/media/radio/radio-si476x.c
+++ b/drivers/media/radio/radio-si476x.c
@@ -1445,7 +1445,7 @@ static int si476x_radio_probe(struct platform_device *pdev)
 	struct si476x_radio *radio;
 	struct v4l2_ctrl *ctrl;
 
-	static atomic_t instance = ATOMIC_INIT(0);
+	static atomic_unchecked_t instance = ATOMIC_INIT(0);
 
 	radio = devm_kzalloc(&pdev->dev, sizeof(*radio), GFP_KERNEL);
 	if (!radio)
diff --git a/drivers/media/radio/wl128x/fmdrv_common.c b/drivers/media/radio/wl128x/fmdrv_common.c
index 749f07910..9e4c89388 100644
--- a/drivers/media/radio/wl128x/fmdrv_common.c
+++ b/drivers/media/radio/wl128x/fmdrv_common.c
@@ -71,7 +71,7 @@ module_param(default_rds_buf, uint, 0444);
 MODULE_PARM_DESC(default_rds_buf, "RDS buffer entries");
 
 /* Radio Nr */
-static u32 radio_nr = -1;
+static int radio_nr = -1;
 module_param(radio_nr, int, 0444);
 MODULE_PARM_DESC(radio_nr, "Radio Nr");
 
diff --git a/drivers/media/usb/dvb-usb/cinergyT2-core.c b/drivers/media/usb/dvb-usb/cinergyT2-core.c
index 9fd152749..8927230ad 100644
--- a/drivers/media/usb/dvb-usb/cinergyT2-core.c
+++ b/drivers/media/usb/dvb-usb/cinergyT2-core.c
@@ -50,29 +50,73 @@ static struct dvb_usb_device_properties cinergyt2_properties;
 
 static int cinergyt2_streaming_ctrl(struct dvb_usb_adapter *adap, int enable)
 {
-	char buf[] = { CINERGYT2_EP1_CONTROL_STREAM_TRANSFER, enable ? 1 : 0 };
-	char result[64];
-	return dvb_usb_generic_rw(adap->dev, buf, sizeof(buf), result,
-				sizeof(result), 0);
+	char *buf;
+	char *result;
+	int retval;
+
+	buf = kmalloc(2, GFP_KERNEL);
+	if (buf == NULL)
+		return -ENOMEM;
+	result = kmalloc(64, GFP_KERNEL);
+	if (result == NULL) {
+		kfree(buf);
+		return -ENOMEM;
+	}
+
+	buf[0] = CINERGYT2_EP1_CONTROL_STREAM_TRANSFER;
+	buf[1] = enable ? 1 : 0;
+
+	retval = dvb_usb_generic_rw(adap->dev, buf, 2, result, 64, 0);
+
+	kfree(buf);
+	kfree(result);
+	return retval;
 }
 
 static int cinergyt2_power_ctrl(struct dvb_usb_device *d, int enable)
 {
-	char buf[] = { CINERGYT2_EP1_SLEEP_MODE, enable ? 0 : 1 };
-	char state[3];
-	return dvb_usb_generic_rw(d, buf, sizeof(buf), state, sizeof(state), 0);
+	char *buf;
+	char *state;
+	int retval;
+
+	buf = kmalloc(2, GFP_KERNEL);
+	if (buf == NULL)
+		return -ENOMEM;
+	state = kmalloc(3, GFP_KERNEL);
+	if (state == NULL) {
+		kfree(buf);
+		return -ENOMEM;
+	}
+
+	buf[0] = CINERGYT2_EP1_SLEEP_MODE;
+	buf[1] = enable ? 1 : 0;
+
+	retval = dvb_usb_generic_rw(d, buf, 2, state, 3, 0);
+
+	kfree(buf);
+	kfree(state);
+	return retval;
 }
 
 static int cinergyt2_frontend_attach(struct dvb_usb_adapter *adap)
 {
-	char query[] = { CINERGYT2_EP1_GET_FIRMWARE_VERSION };
-	char state[3];
+	char *query;
+	char *state;
 	int ret;
+	query = kmalloc(1, GFP_KERNEL);
+	if (query == NULL)
+		return -ENOMEM;
+	state = kmalloc(3, GFP_KERNEL);
+	if (state == NULL) {
+		kfree(query);
+		return -ENOMEM;
+	}
+
+	query[0] = CINERGYT2_EP1_GET_FIRMWARE_VERSION;
 
 	adap->fe_adap[0].fe = cinergyt2_fe_attach(adap->dev);
 
-	ret = dvb_usb_generic_rw(adap->dev, query, sizeof(query), state,
-				sizeof(state), 0);
+	ret = dvb_usb_generic_rw(adap->dev, query, 1, state, 3, 0);
 	if (ret < 0) {
 		deb_rc("cinergyt2_power_ctrl() Failed to retrieve sleep "
 			"state info\n");
@@ -80,7 +124,8 @@ static int cinergyt2_frontend_attach(struct dvb_usb_adapter *adap)
 
 	/* Copy this pointer as we are gonna need it in the release phase */
 	cinergyt2_usb_device = adap->dev;
-
+	kfree(query);
+	kfree(state);
 	return 0;
 }
 
@@ -141,12 +186,23 @@ static int repeatable_keys[] = {
 static int cinergyt2_rc_query(struct dvb_usb_device *d, u32 *event, int *state)
 {
 	struct cinergyt2_state *st = d->priv;
-	u8 key[5] = {0, 0, 0, 0, 0}, cmd = CINERGYT2_EP1_GET_RC_EVENTS;
+	u8 *key, *cmd;
 	int i;
 
+	cmd = kmalloc(1, GFP_KERNEL);
+	if (cmd == NULL)
+		return -EINVAL;
+	key = kzalloc(5, GFP_KERNEL);
+	if (key == NULL) {
+		kfree(cmd);
+		return -EINVAL;
+	}
+
+	cmd[0] = CINERGYT2_EP1_GET_RC_EVENTS;
+
 	*state = REMOTE_NO_KEY_PRESSED;
 
-	dvb_usb_generic_rw(d, &cmd, 1, key, sizeof(key), 0);
+	dvb_usb_generic_rw(d, cmd, 1, key, 5, 0);
 	if (key[4] == 0xff) {
 		/* key repeat */
 		st->rc_counter++;
@@ -157,12 +213,12 @@ static int cinergyt2_rc_query(struct dvb_usb_device *d, u32 *event, int *state)
 					*event = d->last_event;
 					deb_rc("repeat key, event %x\n",
 						   *event);
-					return 0;
+					goto out;
 				}
 			}
 			deb_rc("repeated key (non repeatable)\n");
 		}
-		return 0;
+		goto out;
 	}
 
 	/* hack to pass checksum on the custom field */
@@ -174,6 +230,9 @@ static int cinergyt2_rc_query(struct dvb_usb_device *d, u32 *event, int *state)
 
 		deb_rc("key: %*ph\n", 5, key);
 	}
+out:
+	kfree(cmd);
+	kfree(key);
 	return 0;
 }
 
diff --git a/drivers/media/usb/dvb-usb/cinergyT2-fe.c b/drivers/media/usb/dvb-usb/cinergyT2-fe.c
index b3ec743a7..9c0e418f2 100644
--- a/drivers/media/usb/dvb-usb/cinergyT2-fe.c
+++ b/drivers/media/usb/dvb-usb/cinergyT2-fe.c
@@ -145,103 +145,176 @@ static int cinergyt2_fe_read_status(struct dvb_frontend *fe,
 				    enum fe_status *status)
 {
 	struct cinergyt2_fe_state *state = fe->demodulator_priv;
-	struct dvbt_get_status_msg result;
-	u8 cmd[] = { CINERGYT2_EP1_GET_TUNER_STATUS };
+	struct dvbt_get_status_msg *result;
+	u8 *cmd;
 	int ret;
 
-	ret = dvb_usb_generic_rw(state->d, cmd, sizeof(cmd), (u8 *)&result,
-			sizeof(result), 0);
+	cmd = kmalloc(1, GFP_KERNEL);
+	if (cmd == NULL)
+		return -ENOMEM;
+	result = kmalloc(sizeof(*result), GFP_KERNEL);
+	if (result == NULL) {
+		kfree(cmd);
+		return -ENOMEM;
+	}
+
+	cmd[0] = CINERGYT2_EP1_GET_TUNER_STATUS;
+
+	ret = dvb_usb_generic_rw(state->d, cmd, 1, (u8 *)result,
+			sizeof(*result), 0);
 	if (ret < 0)
-		return ret;
+		goto out;
 
 	*status = 0;
 
-	if (0xffff - le16_to_cpu(result.gain) > 30)
+	if (0xffff - le16_to_cpu(result->gain) > 30)
 		*status |= FE_HAS_SIGNAL;
-	if (result.lock_bits & (1 << 6))
+	if (result->lock_bits & (1 << 6))
 		*status |= FE_HAS_LOCK;
-	if (result.lock_bits & (1 << 5))
+	if (result->lock_bits & (1 << 5))
 		*status |= FE_HAS_SYNC;
-	if (result.lock_bits & (1 << 4))
+	if (result->lock_bits & (1 << 4))
 		*status |= FE_HAS_CARRIER;
-	if (result.lock_bits & (1 << 1))
+	if (result->lock_bits & (1 << 1))
 		*status |= FE_HAS_VITERBI;
 
 	if ((*status & (FE_HAS_CARRIER | FE_HAS_VITERBI | FE_HAS_SYNC)) !=
 			(FE_HAS_CARRIER | FE_HAS_VITERBI | FE_HAS_SYNC))
 		*status &= ~FE_HAS_LOCK;
 
-	return 0;
+out:
+	kfree(cmd);
+	kfree(result);
+	return ret;
 }
 
 static int cinergyt2_fe_read_ber(struct dvb_frontend *fe, u32 *ber)
 {
 	struct cinergyt2_fe_state *state = fe->demodulator_priv;
-	struct dvbt_get_status_msg status;
-	char cmd[] = { CINERGYT2_EP1_GET_TUNER_STATUS };
+	struct dvbt_get_status_msg *status;
+	char *cmd;
 	int ret;
 
-	ret = dvb_usb_generic_rw(state->d, cmd, sizeof(cmd), (char *)&status,
-				sizeof(status), 0);
+	cmd = kmalloc(1, GFP_KERNEL);
+	if (cmd == NULL)
+		return -ENOMEM;
+	status = kmalloc(sizeof(*status), GFP_KERNEL);
+	if (status == NULL) {
+		kfree(cmd);
+		return -ENOMEM;
+	}
+
+	cmd[0] = CINERGYT2_EP1_GET_TUNER_STATUS;
+
+	ret = dvb_usb_generic_rw(state->d, cmd, 1, (char *)status,
+				sizeof(*status), 0);
 	if (ret < 0)
-		return ret;
+		goto out;
 
-	*ber = le32_to_cpu(status.viterbi_error_rate);
+	*ber = le32_to_cpu(status->viterbi_error_rate);
+out:
+	kfree(cmd);
+	kfree(status);
 	return 0;
 }
 
 static int cinergyt2_fe_read_unc_blocks(struct dvb_frontend *fe, u32 *unc)
 {
 	struct cinergyt2_fe_state *state = fe->demodulator_priv;
-	struct dvbt_get_status_msg status;
-	u8 cmd[] = { CINERGYT2_EP1_GET_TUNER_STATUS };
+	struct dvbt_get_status_msg *status;
+	u8 *cmd;
 	int ret;
 
-	ret = dvb_usb_generic_rw(state->d, cmd, sizeof(cmd), (u8 *)&status,
-				sizeof(status), 0);
+	cmd = kmalloc(1, GFP_KERNEL);
+	if (cmd == NULL)
+		return -ENOMEM;
+	status = kmalloc(sizeof(*status), GFP_KERNEL);
+	if (status == NULL) {
+		kfree(cmd);
+		return -ENOMEM;
+	}
+
+	cmd[0] = CINERGYT2_EP1_GET_TUNER_STATUS;
+
+	ret = dvb_usb_generic_rw(state->d, cmd, 1, (u8 *)status,
+				sizeof(*status), 0);
 	if (ret < 0) {
 		err("cinergyt2_fe_read_unc_blocks() Failed! (Error=%d)\n",
 			ret);
-		return ret;
+		goto out;
 	}
-	*unc = le32_to_cpu(status.uncorrected_block_count);
-	return 0;
+	*unc = le32_to_cpu(status->uncorrected_block_count);
+
+out:
+	kfree(cmd);
+	kfree(status);
+	return ret;
 }
 
 static int cinergyt2_fe_read_signal_strength(struct dvb_frontend *fe,
 						u16 *strength)
 {
 	struct cinergyt2_fe_state *state = fe->demodulator_priv;
-	struct dvbt_get_status_msg status;
-	char cmd[] = { CINERGYT2_EP1_GET_TUNER_STATUS };
+	struct dvbt_get_status_msg *status;
+	char *cmd;
 	int ret;
 
-	ret = dvb_usb_generic_rw(state->d, cmd, sizeof(cmd), (char *)&status,
-				sizeof(status), 0);
+	cmd = kmalloc(1, GFP_KERNEL);
+	if (cmd == NULL)
+		return -ENOMEM;
+	status = kmalloc(sizeof(*status), GFP_KERNEL);
+	if (status == NULL) {
+		kfree(cmd);
+		return -ENOMEM;
+	}
+
+	cmd[0] = CINERGYT2_EP1_GET_TUNER_STATUS;
+
+	ret = dvb_usb_generic_rw(state->d, cmd, 1, (char *)status,
+				sizeof(*status), 0);
 	if (ret < 0) {
 		err("cinergyt2_fe_read_signal_strength() Failed!"
 			" (Error=%d)\n", ret);
-		return ret;
+		goto out;
 	}
-	*strength = (0xffff - le16_to_cpu(status.gain));
+	*strength = (0xffff - le16_to_cpu(status->gain));
+
+out:
+	kfree(cmd);
+	kfree(status);
 	return 0;
 }
 
 static int cinergyt2_fe_read_snr(struct dvb_frontend *fe, u16 *snr)
 {
 	struct cinergyt2_fe_state *state = fe->demodulator_priv;
-	struct dvbt_get_status_msg status;
-	char cmd[] = { CINERGYT2_EP1_GET_TUNER_STATUS };
+	struct dvbt_get_status_msg *status;
+	char *cmd;
 	int ret;
 
-	ret = dvb_usb_generic_rw(state->d, cmd, sizeof(cmd), (char *)&status,
-				sizeof(status), 0);
+	cmd = kmalloc(1, GFP_KERNEL);
+	if (cmd == NULL)
+		return -ENOMEM;
+	status = kmalloc(sizeof(*status), GFP_KERNEL);
+	if (status == NULL) {
+		kfree(cmd);
+		return -ENOMEM;
+	}
+
+	cmd[0] = CINERGYT2_EP1_GET_TUNER_STATUS;
+
+	ret = dvb_usb_generic_rw(state->d, cmd, 1, (char *)status,
+				sizeof(*status), 0);
 	if (ret < 0) {
 		err("cinergyt2_fe_read_snr() Failed! (Error=%d)\n", ret);
-		return ret;
+		goto out;
 	}
-	*snr = (status.snr << 8) | status.snr;
-	return 0;
+	*snr = (status->snr << 8) | status->snr;
+
+out:
+	kfree(cmd);
+	kfree(status);
+	return ret;
 }
 
 static int cinergyt2_fe_init(struct dvb_frontend *fe)
@@ -266,35 +339,46 @@ static int cinergyt2_fe_set_frontend(struct dvb_frontend *fe)
 {
 	struct dtv_frontend_properties *fep = &fe->dtv_property_cache;
 	struct cinergyt2_fe_state *state = fe->demodulator_priv;
-	struct dvbt_set_parameters_msg param;
-	char result[2];
+	struct dvbt_set_parameters_msg *param;
+	char *result;
 	int err;
 
-	param.cmd = CINERGYT2_EP1_SET_TUNER_PARAMETERS;
-	param.tps = cpu_to_le16(compute_tps(fep));
-	param.freq = cpu_to_le32(fep->frequency / 1000);
-	param.flags = 0;
+	result = kmalloc(2, GFP_KERNEL);
+	if (result == NULL)
+		return -ENOMEM;
+	param = kmalloc(sizeof(*param), GFP_KERNEL);
+	if (param == NULL) {
+		kfree(result);
+		return -ENOMEM;
+	}
+
+	param->cmd = CINERGYT2_EP1_SET_TUNER_PARAMETERS;
+	param->tps = cpu_to_le16(compute_tps(fep));
+	param->freq = cpu_to_le32(fep->frequency / 1000);
+	param->flags = 0;
 
 	switch (fep->bandwidth_hz) {
 	default:
 	case 8000000:
-		param.bandwidth = 8;
+		param->bandwidth = 8;
 		break;
 	case 7000000:
-		param.bandwidth = 7;
+		param->bandwidth = 7;
 		break;
 	case 6000000:
-		param.bandwidth = 6;
+		param->bandwidth = 6;
 		break;
 	}
 
 	err = dvb_usb_generic_rw(state->d,
-			(char *)&param, sizeof(param),
-			result, sizeof(result), 0);
+			(char *)param, sizeof(*param),
+			result, 2, 0);
 	if (err < 0)
 		err("cinergyt2_fe_set_frontend() Failed! err=%d\n", err);
 
-	return (err < 0) ? err : 0;
+	kfree(result);
+	kfree(param);
+	return err;
 }
 
 static void cinergyt2_fe_release(struct dvb_frontend *fe)
diff --git a/drivers/media/usb/dvb-usb/dvb-usb-firmware.c b/drivers/media/usb/dvb-usb/dvb-usb-firmware.c
index ec3a84be0..ec707fd62 100644
--- a/drivers/media/usb/dvb-usb/dvb-usb-firmware.c
+++ b/drivers/media/usb/dvb-usb/dvb-usb-firmware.c
@@ -35,42 +35,57 @@ static int usb_cypress_writemem(struct usb_device *udev,u16 addr,u8 *data, u8 le
 
 int usb_cypress_load_firmware(struct usb_device *udev, const struct firmware *fw, int type)
 {
-	struct hexline hx;
-	u8 reset;
+	struct hexline *hx;
+	u8 *reset;
 	int ret,pos=0;
 
+	reset = kmalloc(1, GFP_KERNEL);
+	if (reset == NULL)
+		return -ENOMEM;
+
+	hx = kmalloc(sizeof(struct hexline), GFP_KERNEL);
+	if (hx == NULL) {
+		kfree(reset);
+		return -ENOMEM;
+	}
+
 	/* stop the CPU */
-	reset = 1;
-	if ((ret = usb_cypress_writemem(udev,cypress[type].cpu_cs_register,&reset,1)) != 1)
+	reset[0] = 1;
+	if ((ret = usb_cypress_writemem(udev,cypress[type].cpu_cs_register,reset,1)) != 1)
 		err("could not stop the USB controller CPU.");
 
-	while ((ret = dvb_usb_get_hexline(fw,&hx,&pos)) > 0) {
-		deb_fw("writing to address 0x%04x (buffer: 0x%02x %02x)\n",hx.addr,hx.len,hx.chk);
-		ret = usb_cypress_writemem(udev,hx.addr,hx.data,hx.len);
+	while ((ret = dvb_usb_get_hexline(fw,hx,&pos)) > 0) {
+		deb_fw("writing to address 0x%04x (buffer: 0x%02x %02x)\n",hx->addr,hx->len,hx->chk);
+		ret = usb_cypress_writemem(udev,hx->addr,hx->data,hx->len);
 
-		if (ret != hx.len) {
+		if (ret != hx->len) {
 			err("error while transferring firmware "
 				"(transferred size: %d, block size: %d)",
-				ret,hx.len);
+				ret,hx->len);
 			ret = -EINVAL;
 			break;
 		}
 	}
 	if (ret < 0) {
 		err("firmware download failed at %d with %d",pos,ret);
+		kfree(reset);
+		kfree(hx);
 		return ret;
 	}
 
 	if (ret == 0) {
 		/* restart the CPU */
-		reset = 0;
-		if (ret || usb_cypress_writemem(udev,cypress[type].cpu_cs_register,&reset,1) != 1) {
+		reset[0] = 0;
+		if (ret || usb_cypress_writemem(udev,cypress[type].cpu_cs_register,reset,1) != 1) {
 			err("could not restart the USB controller CPU.");
 			ret = -EINVAL;
 		}
 	} else
 		ret = -EIO;
 
+	kfree(reset);
+	kfree(hx);
+
 	return ret;
 }
 EXPORT_SYMBOL(usb_cypress_load_firmware);
diff --git a/drivers/media/usb/dvb-usb/technisat-usb2.c b/drivers/media/usb/dvb-usb/technisat-usb2.c
index 0daa18ee3..d3b2061a6 100644
--- a/drivers/media/usb/dvb-usb/technisat-usb2.c
+++ b/drivers/media/usb/dvb-usb/technisat-usb2.c
@@ -89,8 +89,11 @@ struct technisat_usb2_state {
 static int technisat_usb2_i2c_access(struct usb_device *udev,
 		u8 device_addr, u8 *tx, u8 txlen, u8 *rx, u8 rxlen)
 {
-	u8 b[64];
-	int ret, actual_length;
+	u8 *b = kmalloc(64, GFP_KERNEL);
+	int ret, actual_length, error = 0;
+
+	if (b == NULL)
+		return -ENOMEM;
 
 	deb_i2c("i2c-access: %02x, tx: ", device_addr);
 	debug_dump(tx, txlen, deb_i2c);
@@ -123,7 +126,8 @@ static int technisat_usb2_i2c_access(struct usb_device *udev,
 
 	if (ret < 0) {
 		err("i2c-error: out failed %02x = %d", device_addr, ret);
-		return -ENODEV;
+		error = -ENODEV;
+		goto out;
 	}
 
 	ret = usb_bulk_msg(udev,
@@ -131,7 +135,8 @@ static int technisat_usb2_i2c_access(struct usb_device *udev,
 			b, 64, &actual_length, 1000);
 	if (ret < 0) {
 		err("i2c-error: in failed %02x = %d", device_addr, ret);
-		return -ENODEV;
+		error = -ENODEV;
+		goto out;
 	}
 
 	if (b[0] != I2C_STATUS_OK) {
@@ -139,8 +144,10 @@ static int technisat_usb2_i2c_access(struct usb_device *udev,
 		/* handle tuner-i2c-nak */
 		if (!(b[0] == I2C_STATUS_NAK &&
 				device_addr == 0x60
-				/* && device_is_technisat_usb2 */))
-			return -ENODEV;
+				/* && device_is_technisat_usb2 */)) {
+			error = -ENODEV;
+			goto out;
+		}
 	}
 
 	deb_i2c("status: %d, ", b[0]);
@@ -154,7 +161,9 @@ static int technisat_usb2_i2c_access(struct usb_device *udev,
 
 	deb_i2c("\n");
 
-	return 0;
+out:
+	kfree(b);
+	return error;
 }
 
 static int technisat_usb2_i2c_xfer(struct i2c_adapter *adap, struct i2c_msg *msg,
diff --git a/drivers/media/usb/pvrusb2/pvrusb2-context.c b/drivers/media/usb/pvrusb2/pvrusb2-context.c
index c45f30715..7d7926180 100644
--- a/drivers/media/usb/pvrusb2/pvrusb2-context.c
+++ b/drivers/media/usb/pvrusb2/pvrusb2-context.c
@@ -103,8 +103,10 @@ static void pvr2_context_destroy(struct pvr2_context *mp)
 }
 
 
-static void pvr2_context_notify(struct pvr2_context *mp)
+static void pvr2_context_notify(void *_mp)
 {
+	struct pvr2_context *mp = _mp;
+
 	pvr2_context_set_notify(mp,!0);
 }
 
@@ -119,9 +121,7 @@ static void pvr2_context_check(struct pvr2_context *mp)
 		pvr2_trace(PVR2_TRACE_CTXT,
 			   "pvr2_context %p (initialize)", mp);
 		/* Finish hardware initialization */
-		if (pvr2_hdw_initialize(mp->hdw,
-					(void (*)(void *))pvr2_context_notify,
-					mp)) {
+		if (pvr2_hdw_initialize(mp->hdw, pvr2_context_notify, mp)) {
 			mp->video_stream.stream =
 				pvr2_hdw_get_video_stream(mp->hdw);
 			/* Trigger interface initialization.  By doing this
diff --git a/drivers/media/usb/pvrusb2/pvrusb2-dvb.c b/drivers/media/usb/pvrusb2/pvrusb2-dvb.c
index 8c9579343..2309b9e06 100644
--- a/drivers/media/usb/pvrusb2/pvrusb2-dvb.c
+++ b/drivers/media/usb/pvrusb2/pvrusb2-dvb.c
@@ -101,8 +101,10 @@ static int pvr2_dvb_feed_thread(void *data)
 	return stat;
 }
 
-static void pvr2_dvb_notify(struct pvr2_dvb_adapter *adap)
+static void pvr2_dvb_notify(void *_adap)
 {
+	struct pvr2_dvb_adapter *adap = _adap;
+
 	wake_up(&adap->buffer_wait_data);
 }
 
@@ -161,8 +163,7 @@ static int pvr2_dvb_stream_do_start(struct pvr2_dvb_adapter *adap)
 		if (!(adap->buffer_storage[idx])) return -ENOMEM;
 	}
 
-	pvr2_stream_set_callback(pvr->video_stream.stream,
-				 (pvr2_stream_callback) pvr2_dvb_notify, adap);
+	pvr2_stream_set_callback(pvr->video_stream.stream, pvr2_dvb_notify, adap);
 
 	ret = pvr2_stream_set_buffer_count(stream, PVR2_DVB_BUFFER_COUNT);
 	if (ret < 0) return ret;
diff --git a/drivers/media/usb/pvrusb2/pvrusb2-hdw.c b/drivers/media/usb/pvrusb2/pvrusb2-hdw.c
index c9c5f88de..5e03d731d 100644
--- a/drivers/media/usb/pvrusb2/pvrusb2-hdw.c
+++ b/drivers/media/usb/pvrusb2/pvrusb2-hdw.c
@@ -2097,7 +2097,7 @@ static void pvr2_hdw_load_modules(struct pvr2_hdw *hdw)
 
 	cm = &hdw->hdw_desc->client_modules;
 	for (idx = 0; idx < cm->cnt; idx++) {
-		request_module(cm->lst[idx]);
+		request_module("%s", cm->lst[idx]);
 	}
 
 	ct = &hdw->hdw_desc->client_table;
diff --git a/drivers/media/usb/pvrusb2/pvrusb2-std.c b/drivers/media/usb/pvrusb2/pvrusb2-std.c
index 9a596a3a4..38de071f8 100644
--- a/drivers/media/usb/pvrusb2/pvrusb2-std.c
+++ b/drivers/media/usb/pvrusb2/pvrusb2-std.c
@@ -216,7 +216,7 @@ unsigned int pvr2_std_id_to_str(char *bufPtr, unsigned int bufSize,
 			bufSize -= c2;
 			bufPtr += c2;
 			c2 = scnprintf(bufPtr,bufSize,
-				       ip->name);
+				       "%s", ip->name);
 			c1 += c2;
 			bufSize -= c2;
 			bufPtr += c2;
diff --git a/drivers/media/usb/pvrusb2/pvrusb2-v4l2.c b/drivers/media/usb/pvrusb2/pvrusb2-v4l2.c
index 81f788b7b..9619f47a3 100644
--- a/drivers/media/usb/pvrusb2/pvrusb2-v4l2.c
+++ b/drivers/media/usb/pvrusb2/pvrusb2-v4l2.c
@@ -1069,8 +1069,10 @@ static int pvr2_v4l2_open(struct file *file)
 }
 
 
-static void pvr2_v4l2_notify(struct pvr2_v4l2_fh *fhp)
+static void pvr2_v4l2_notify(void *_fhp)
 {
+	struct pvr2_v4l2_fh *fhp = _fhp;
+
 	wake_up(&fhp->wait_data);
 }
 
@@ -1103,7 +1105,7 @@ static int pvr2_v4l2_iosetup(struct pvr2_v4l2_fh *fh)
 
 	hdw = fh->channel.mc_head->hdw;
 	sp = fh->pdi->stream->stream;
-	pvr2_stream_set_callback(sp,(pvr2_stream_callback)pvr2_v4l2_notify,fh);
+	pvr2_stream_set_callback(sp,pvr2_v4l2_notify,fh);
 	pvr2_hdw_set_stream_type(hdw,fh->pdi->config);
 	if ((ret = pvr2_hdw_set_streaming(hdw,!0)) < 0) return ret;
 	return pvr2_ioread_set_enabled(fh->rhp,!0);
diff --git a/drivers/media/usb/uvc/uvc_driver.c b/drivers/media/usb/uvc/uvc_driver.c
index 302e284a9..93781d63d 100644
--- a/drivers/media/usb/uvc/uvc_driver.c
+++ b/drivers/media/usb/uvc/uvc_driver.c
@@ -2078,7 +2078,7 @@ static int uvc_reset_resume(struct usb_interface *intf)
  * Module parameters
  */
 
-static int uvc_clock_param_get(char *buffer, struct kernel_param *kp)
+static int uvc_clock_param_get(char *buffer, const struct kernel_param *kp)
 {
 	if (uvc_clock_param == CLOCK_MONOTONIC)
 		return sprintf(buffer, "CLOCK_MONOTONIC");
@@ -2086,7 +2086,7 @@ static int uvc_clock_param_get(char *buffer, struct kernel_param *kp)
 		return sprintf(buffer, "CLOCK_REALTIME");
 }
 
-static int uvc_clock_param_set(const char *val, struct kernel_param *kp)
+static int uvc_clock_param_set(const char *val, const struct kernel_param *kp)
 {
 	if (strncasecmp(val, "clock_", strlen("clock_")) == 0)
 		val += strlen("clock_");
diff --git a/drivers/media/v4l2-core/v4l2-common.c b/drivers/media/v4l2-core/v4l2-common.c
index 5b808500e..97b84431d 100644
--- a/drivers/media/v4l2-core/v4l2-common.c
+++ b/drivers/media/v4l2-core/v4l2-common.c
@@ -268,7 +268,7 @@ struct v4l2_subdev *v4l2_spi_new_subdev(struct v4l2_device *v4l2_dev,
 	BUG_ON(!v4l2_dev);
 
 	if (info->modalias[0])
-		request_module(info->modalias);
+		request_module("%s", info->modalias);
 
 	spi = spi_new_device(master, info);
 
diff --git a/drivers/media/v4l2-core/v4l2-compat-ioctl32.c b/drivers/media/v4l2-core/v4l2-compat-ioctl32.c
index bacecbd68..277d1f866 100644
--- a/drivers/media/v4l2-core/v4l2-compat-ioctl32.c
+++ b/drivers/media/v4l2-core/v4l2-compat-ioctl32.c
@@ -449,7 +449,7 @@ static int get_v4l2_buffer32(struct v4l2_buffer *kp, struct v4l2_buffer32 __user
 		 * by passing a very big num_planes value */
 		uplane = compat_alloc_user_space(num_planes *
 						sizeof(struct v4l2_plane));
-		kp->m.planes = (__force struct v4l2_plane *)uplane;
+		kp->m.planes = (__force_kernel struct v4l2_plane *)uplane;
 
 		while (--num_planes >= 0) {
 			ret = get_v4l2_plane32(uplane, uplane32, kp->memory);
@@ -519,7 +519,7 @@ static int put_v4l2_buffer32(struct v4l2_buffer *kp, struct v4l2_buffer32 __user
 		if (num_planes == 0)
 			return 0;
 
-		uplane = (__force struct v4l2_plane __user *)kp->m.planes;
+		uplane = (struct v4l2_plane __force_user *)kp->m.planes;
 		if (get_user(p, &up->m.planes))
 			return -EFAULT;
 		uplane32 = compat_ptr(p);
@@ -581,7 +581,7 @@ static int get_v4l2_framebuffer32(struct v4l2_framebuffer *kp, struct v4l2_frame
 		get_user(kp->flags, &up->flags) ||
 		copy_from_user(&kp->fmt, &up->fmt, sizeof(up->fmt)))
 			return -EFAULT;
-	kp->base = (__force void *)compat_ptr(tmp);
+	kp->base = (__force_kernel void *)compat_ptr(tmp);
 	return 0;
 }
 
@@ -687,7 +687,7 @@ static int get_v4l2_ext_controls32(struct v4l2_ext_controls *kp, struct v4l2_ext
 			n * sizeof(struct v4l2_ext_control32)))
 		return -EFAULT;
 	kcontrols = compat_alloc_user_space(n * sizeof(struct v4l2_ext_control));
-	kp->controls = (__force struct v4l2_ext_control *)kcontrols;
+	kp->controls = (__force_kernel struct v4l2_ext_control *)kcontrols;
 	while (--n >= 0) {
 		u32 id;
 
@@ -714,7 +714,7 @@ static int put_v4l2_ext_controls32(struct v4l2_ext_controls *kp, struct v4l2_ext
 {
 	struct v4l2_ext_control32 __user *ucontrols;
 	struct v4l2_ext_control __user *kcontrols =
-		(__force struct v4l2_ext_control __user *)kp->controls;
+		(struct v4l2_ext_control __force_user *)kp->controls;
 	int n = kp->count;
 	compat_caddr_t p;
 
@@ -799,7 +799,7 @@ static int get_v4l2_edid32(struct v4l2_edid *kp, struct v4l2_edid32 __user *up)
 		get_user(tmp, &up->edid) ||
 		copy_from_user(kp->reserved, up->reserved, sizeof(kp->reserved)))
 			return -EFAULT;
-	kp->edid = (__force u8 *)compat_ptr(tmp);
+	kp->edid = (__force_kernel u8 *)compat_ptr(tmp);
 	return 0;
 }
 
diff --git a/drivers/media/v4l2-core/v4l2-device.c b/drivers/media/v4l2-core/v4l2-device.c
index 06fa5f1b2..2231ddaf7 100644
--- a/drivers/media/v4l2-core/v4l2-device.c
+++ b/drivers/media/v4l2-core/v4l2-device.c
@@ -74,9 +74,9 @@ int v4l2_device_put(struct v4l2_device *v4l2_dev)
 EXPORT_SYMBOL_GPL(v4l2_device_put);
 
 int v4l2_device_set_name(struct v4l2_device *v4l2_dev, const char *basename,
-						atomic_t *instance)
+						atomic_unchecked_t *instance)
 {
-	int num = atomic_inc_return(instance) - 1;
+	int num = atomic_inc_return_unchecked(instance) - 1;
 	int len = strlen(basename);
 
 	if (basename[len - 1] >= '0' && basename[len - 1] <= '9')
diff --git a/drivers/media/v4l2-core/v4l2-ioctl.c b/drivers/media/v4l2-core/v4l2-ioctl.c
index 51a0fa144..5ae0546dd 100644
--- a/drivers/media/v4l2-core/v4l2-ioctl.c
+++ b/drivers/media/v4l2-core/v4l2-ioctl.c
@@ -2425,49 +2425,216 @@ static int v4l_enum_freq_bands(const struct v4l2_ioctl_ops *ops,
 	return -ENOTTY;
 }
 
+static int v4l_vidioc_g_fbuf(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_fbuf(file, fh, arg);
+}
+
+static int v4l_vidioc_s_fbuf(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_s_fbuf(file, fh, arg);
+}
+
+static int v4l_vidioc_expbuf(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_expbuf(file, fh, arg);
+}
+
+static int v4l_vidioc_g_std(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_std(file, fh, arg);
+}
+
+static int v4l_vidioc_g_audio(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_audio(file, fh, arg);
+}
+
+static int v4l_vidioc_s_audio(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_s_audio(file, fh, arg);
+}
+
+static int v4l_vidioc_g_input(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_input(file, fh, arg);
+}
+
+static int v4l_vidioc_g_edid(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_edid(file, fh, arg);
+}
+
+static int v4l_vidioc_s_edid(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_s_edid(file, fh, arg);
+}
+
+static int v4l_vidioc_g_output(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_output(file, fh, arg);
+}
+
+static int v4l_vidioc_g_audout(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_audout(file, fh, arg);
+}
+
+static int v4l_vidioc_s_audout(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_s_audout(file, fh, arg);
+}
+
+static int v4l_vidioc_g_selection(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_selection(file, fh, arg);
+}
+
+static int v4l_vidioc_s_selection(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_s_selection(file, fh, arg);
+}
+
+static int v4l_vidioc_g_jpegcomp(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_jpegcomp(file, fh, arg);
+}
+
+static int v4l_vidioc_s_jpegcomp(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_s_jpegcomp(file, fh, arg);
+}
+
+static int v4l_vidioc_enumaudio(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_enumaudio(file, fh, arg);
+}
+
+static int v4l_vidioc_enumaudout(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_enumaudout(file, fh, arg);
+}
+
+static int v4l_vidioc_enum_framesizes(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_enum_framesizes(file, fh, arg);
+}
+
+static int v4l_vidioc_enum_frameintervals(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_enum_frameintervals(file, fh, arg);
+}
+
+static int v4l_vidioc_g_enc_index(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_enc_index(file, fh, arg);
+}
+
+static int v4l_vidioc_encoder_cmd(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_encoder_cmd(file, fh, arg);
+}
+
+static int v4l_vidioc_try_encoder_cmd(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_try_encoder_cmd(file, fh, arg);
+}
+
+static int v4l_vidioc_decoder_cmd(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_decoder_cmd(file, fh, arg);
+}
+
+static int v4l_vidioc_try_decoder_cmd(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_try_decoder_cmd(file, fh, arg);
+}
+
+static int v4l_vidioc_s_dv_timings(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_s_dv_timings(file, fh, arg);
+}
+
+static int v4l_vidioc_g_dv_timings(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_g_dv_timings(file, fh, arg);
+}
+
+static int v4l_vidioc_enum_dv_timings(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_enum_dv_timings(file, fh, arg);
+}
+
+static int v4l_vidioc_query_dv_timings(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_query_dv_timings(file, fh, arg);
+}
+
+static int v4l_vidioc_dv_timings_cap(const struct v4l2_ioctl_ops *ops,
+				struct file *file, void *fh, void *arg)
+{
+	return ops->vidioc_dv_timings_cap(file, fh, arg);
+}
+
 struct v4l2_ioctl_info {
 	unsigned int ioctl;
 	u32 flags;
 	const char * const name;
-	union {
-		u32 offset;
-		int (*func)(const struct v4l2_ioctl_ops *ops,
-				struct file *file, void *fh, void *p);
-	} u;
+	int (*func)(const struct v4l2_ioctl_ops *ops,
+			struct file *file, void *fh, void *p);
 	void (*debug)(const void *arg, bool write_only);
-};
+} __do_const;
+typedef struct v4l2_ioctl_info __no_const v4l2_ioctl_info_no_const;
 
 /* This control needs a priority check */
 #define INFO_FL_PRIO	(1 << 0)
 /* This control can be valid if the filehandle passes a control handler. */
 #define INFO_FL_CTRL	(1 << 1)
-/* This is a standard ioctl, no need for special code */
-#define INFO_FL_STD	(1 << 2)
 /* This is ioctl has its own function */
-#define INFO_FL_FUNC	(1 << 3)
+#define INFO_FL_FUNC	(1 << 2)
 /* Queuing ioctl */
-#define INFO_FL_QUEUE	(1 << 4)
+#define INFO_FL_QUEUE	(1 << 3)
 /* Zero struct from after the field to the end */
 #define INFO_FL_CLEAR(v4l2_struct, field)			\
 	((offsetof(struct v4l2_struct, field) +			\
 	  sizeof(((struct v4l2_struct *)0)->field)) << 16)
 #define INFO_FL_CLEAR_MASK (_IOC_SIZEMASK << 16)
 
-#define IOCTL_INFO_STD(_ioctl, _vidioc, _debug, _flags)			\
-	[_IOC_NR(_ioctl)] = {						\
-		.ioctl = _ioctl,					\
-		.flags = _flags | INFO_FL_STD,				\
-		.name = #_ioctl,					\
-		.u.offset = offsetof(struct v4l2_ioctl_ops, _vidioc),	\
-		.debug = _debug,					\
-	}
-
 #define IOCTL_INFO_FNC(_ioctl, _func, _debug, _flags)			\
 	[_IOC_NR(_ioctl)] = {						\
 		.ioctl = _ioctl,					\
 		.flags = _flags | INFO_FL_FUNC,				\
 		.name = #_ioctl,					\
-		.u.func = _func,					\
+		.func = _func,						\
 		.debug = _debug,					\
 	}
 
@@ -2478,17 +2645,17 @@ static struct v4l2_ioctl_info v4l2_ioctls[] = {
 	IOCTL_INFO_FNC(VIDIOC_S_FMT, v4l_s_fmt, v4l_print_format, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_REQBUFS, v4l_reqbufs, v4l_print_requestbuffers, INFO_FL_PRIO | INFO_FL_QUEUE),
 	IOCTL_INFO_FNC(VIDIOC_QUERYBUF, v4l_querybuf, v4l_print_buffer, INFO_FL_QUEUE | INFO_FL_CLEAR(v4l2_buffer, length)),
-	IOCTL_INFO_STD(VIDIOC_G_FBUF, vidioc_g_fbuf, v4l_print_framebuffer, 0),
-	IOCTL_INFO_STD(VIDIOC_S_FBUF, vidioc_s_fbuf, v4l_print_framebuffer, INFO_FL_PRIO),
+	IOCTL_INFO_FNC(VIDIOC_G_FBUF, v4l_vidioc_g_fbuf, v4l_print_framebuffer, 0),
+	IOCTL_INFO_FNC(VIDIOC_S_FBUF, v4l_vidioc_s_fbuf, v4l_print_framebuffer, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_OVERLAY, v4l_overlay, v4l_print_u32, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_QBUF, v4l_qbuf, v4l_print_buffer, INFO_FL_QUEUE),
-	IOCTL_INFO_STD(VIDIOC_EXPBUF, vidioc_expbuf, v4l_print_exportbuffer, INFO_FL_QUEUE | INFO_FL_CLEAR(v4l2_exportbuffer, flags)),
+	IOCTL_INFO_FNC(VIDIOC_EXPBUF, v4l_vidioc_expbuf, v4l_print_exportbuffer, INFO_FL_QUEUE | INFO_FL_CLEAR(v4l2_exportbuffer, flags)),
 	IOCTL_INFO_FNC(VIDIOC_DQBUF, v4l_dqbuf, v4l_print_buffer, INFO_FL_QUEUE),
 	IOCTL_INFO_FNC(VIDIOC_STREAMON, v4l_streamon, v4l_print_buftype, INFO_FL_PRIO | INFO_FL_QUEUE),
 	IOCTL_INFO_FNC(VIDIOC_STREAMOFF, v4l_streamoff, v4l_print_buftype, INFO_FL_PRIO | INFO_FL_QUEUE),
 	IOCTL_INFO_FNC(VIDIOC_G_PARM, v4l_g_parm, v4l_print_streamparm, INFO_FL_CLEAR(v4l2_streamparm, type)),
 	IOCTL_INFO_FNC(VIDIOC_S_PARM, v4l_s_parm, v4l_print_streamparm, INFO_FL_PRIO),
-	IOCTL_INFO_STD(VIDIOC_G_STD, vidioc_g_std, v4l_print_std, 0),
+	IOCTL_INFO_FNC(VIDIOC_G_STD, v4l_vidioc_g_std, v4l_print_std, 0),
 	IOCTL_INFO_FNC(VIDIOC_S_STD, v4l_s_std, v4l_print_std, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_ENUMSTD, v4l_enumstd, v4l_print_standard, INFO_FL_CLEAR(v4l2_standard, index)),
 	IOCTL_INFO_FNC(VIDIOC_ENUMINPUT, v4l_enuminput, v4l_print_enuminput, INFO_FL_CLEAR(v4l2_input, index)),
@@ -2496,19 +2663,19 @@ static struct v4l2_ioctl_info v4l2_ioctls[] = {
 	IOCTL_INFO_FNC(VIDIOC_S_CTRL, v4l_s_ctrl, v4l_print_control, INFO_FL_PRIO | INFO_FL_CTRL),
 	IOCTL_INFO_FNC(VIDIOC_G_TUNER, v4l_g_tuner, v4l_print_tuner, INFO_FL_CLEAR(v4l2_tuner, index)),
 	IOCTL_INFO_FNC(VIDIOC_S_TUNER, v4l_s_tuner, v4l_print_tuner, INFO_FL_PRIO),
-	IOCTL_INFO_STD(VIDIOC_G_AUDIO, vidioc_g_audio, v4l_print_audio, 0),
-	IOCTL_INFO_STD(VIDIOC_S_AUDIO, vidioc_s_audio, v4l_print_audio, INFO_FL_PRIO),
+	IOCTL_INFO_FNC(VIDIOC_G_AUDIO, v4l_vidioc_g_audio, v4l_print_audio, 0),
+	IOCTL_INFO_FNC(VIDIOC_S_AUDIO, v4l_vidioc_s_audio, v4l_print_audio, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_QUERYCTRL, v4l_queryctrl, v4l_print_queryctrl, INFO_FL_CTRL | INFO_FL_CLEAR(v4l2_queryctrl, id)),
 	IOCTL_INFO_FNC(VIDIOC_QUERYMENU, v4l_querymenu, v4l_print_querymenu, INFO_FL_CTRL | INFO_FL_CLEAR(v4l2_querymenu, index)),
-	IOCTL_INFO_STD(VIDIOC_G_INPUT, vidioc_g_input, v4l_print_u32, 0),
+	IOCTL_INFO_FNC(VIDIOC_G_INPUT, v4l_vidioc_g_input, v4l_print_u32, 0),
 	IOCTL_INFO_FNC(VIDIOC_S_INPUT, v4l_s_input, v4l_print_u32, INFO_FL_PRIO),
-	IOCTL_INFO_STD(VIDIOC_G_EDID, vidioc_g_edid, v4l_print_edid, 0),
-	IOCTL_INFO_STD(VIDIOC_S_EDID, vidioc_s_edid, v4l_print_edid, INFO_FL_PRIO),
-	IOCTL_INFO_STD(VIDIOC_G_OUTPUT, vidioc_g_output, v4l_print_u32, 0),
+	IOCTL_INFO_FNC(VIDIOC_G_EDID, v4l_vidioc_g_edid, v4l_print_edid, 0),
+	IOCTL_INFO_FNC(VIDIOC_S_EDID, v4l_vidioc_s_edid, v4l_print_edid, INFO_FL_PRIO),
+	IOCTL_INFO_FNC(VIDIOC_G_OUTPUT, v4l_vidioc_g_output, v4l_print_u32, 0),
 	IOCTL_INFO_FNC(VIDIOC_S_OUTPUT, v4l_s_output, v4l_print_u32, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_ENUMOUTPUT, v4l_enumoutput, v4l_print_enumoutput, INFO_FL_CLEAR(v4l2_output, index)),
-	IOCTL_INFO_STD(VIDIOC_G_AUDOUT, vidioc_g_audout, v4l_print_audioout, 0),
-	IOCTL_INFO_STD(VIDIOC_S_AUDOUT, vidioc_s_audout, v4l_print_audioout, INFO_FL_PRIO),
+	IOCTL_INFO_FNC(VIDIOC_G_AUDOUT, v4l_vidioc_g_audout, v4l_print_audioout, 0),
+	IOCTL_INFO_FNC(VIDIOC_S_AUDOUT, v4l_vidioc_s_audout, v4l_print_audioout, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_G_MODULATOR, v4l_g_modulator, v4l_print_modulator, INFO_FL_CLEAR(v4l2_modulator, index)),
 	IOCTL_INFO_FNC(VIDIOC_S_MODULATOR, v4l_s_modulator, v4l_print_modulator, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_G_FREQUENCY, v4l_g_frequency, v4l_print_frequency, INFO_FL_CLEAR(v4l2_frequency, tuner)),
@@ -2516,14 +2683,14 @@ static struct v4l2_ioctl_info v4l2_ioctls[] = {
 	IOCTL_INFO_FNC(VIDIOC_CROPCAP, v4l_cropcap, v4l_print_cropcap, INFO_FL_CLEAR(v4l2_cropcap, type)),
 	IOCTL_INFO_FNC(VIDIOC_G_CROP, v4l_g_crop, v4l_print_crop, INFO_FL_CLEAR(v4l2_crop, type)),
 	IOCTL_INFO_FNC(VIDIOC_S_CROP, v4l_s_crop, v4l_print_crop, INFO_FL_PRIO),
-	IOCTL_INFO_STD(VIDIOC_G_SELECTION, vidioc_g_selection, v4l_print_selection, INFO_FL_CLEAR(v4l2_selection, r)),
-	IOCTL_INFO_STD(VIDIOC_S_SELECTION, vidioc_s_selection, v4l_print_selection, INFO_FL_PRIO | INFO_FL_CLEAR(v4l2_selection, r)),
-	IOCTL_INFO_STD(VIDIOC_G_JPEGCOMP, vidioc_g_jpegcomp, v4l_print_jpegcompression, 0),
-	IOCTL_INFO_STD(VIDIOC_S_JPEGCOMP, vidioc_s_jpegcomp, v4l_print_jpegcompression, INFO_FL_PRIO),
+	IOCTL_INFO_FNC(VIDIOC_G_SELECTION, v4l_vidioc_g_selection, v4l_print_selection, INFO_FL_CLEAR(v4l2_selection, r)),
+	IOCTL_INFO_FNC(VIDIOC_S_SELECTION, v4l_vidioc_s_selection, v4l_print_selection, INFO_FL_PRIO | INFO_FL_CLEAR(v4l2_selection, r)),
+	IOCTL_INFO_FNC(VIDIOC_G_JPEGCOMP, v4l_vidioc_g_jpegcomp, v4l_print_jpegcompression, 0),
+	IOCTL_INFO_FNC(VIDIOC_S_JPEGCOMP, v4l_vidioc_s_jpegcomp, v4l_print_jpegcompression, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_QUERYSTD, v4l_querystd, v4l_print_std, 0),
 	IOCTL_INFO_FNC(VIDIOC_TRY_FMT, v4l_try_fmt, v4l_print_format, 0),
-	IOCTL_INFO_STD(VIDIOC_ENUMAUDIO, vidioc_enumaudio, v4l_print_audio, INFO_FL_CLEAR(v4l2_audio, index)),
-	IOCTL_INFO_STD(VIDIOC_ENUMAUDOUT, vidioc_enumaudout, v4l_print_audioout, INFO_FL_CLEAR(v4l2_audioout, index)),
+	IOCTL_INFO_FNC(VIDIOC_ENUMAUDIO, v4l_vidioc_enumaudio, v4l_print_audio, INFO_FL_CLEAR(v4l2_audio, index)),
+	IOCTL_INFO_FNC(VIDIOC_ENUMAUDOUT, v4l_vidioc_enumaudout, v4l_print_audioout, INFO_FL_CLEAR(v4l2_audioout, index)),
 	IOCTL_INFO_FNC(VIDIOC_G_PRIORITY, v4l_g_priority, v4l_print_u32, 0),
 	IOCTL_INFO_FNC(VIDIOC_S_PRIORITY, v4l_s_priority, v4l_print_u32, INFO_FL_PRIO),
 	IOCTL_INFO_FNC(VIDIOC_G_SLICED_VBI_CAP, v4l_g_sliced_vbi_cap, v4l_print_sliced_vbi_cap, INFO_FL_CLEAR(v4l2_sliced_vbi_cap, type)),
@@ -2531,26 +2698,26 @@ static struct v4l2_ioctl_info v4l2_ioctls[] = {
 	IOCTL_INFO_FNC(VIDIOC_G_EXT_CTRLS, v4l_g_ext_ctrls, v4l_print_ext_controls, INFO_FL_CTRL),
 	IOCTL_INFO_FNC(VIDIOC_S_EXT_CTRLS, v4l_s_ext_ctrls, v4l_print_ext_controls, INFO_FL_PRIO | INFO_FL_CTRL),
 	IOCTL_INFO_FNC(VIDIOC_TRY_EXT_CTRLS, v4l_try_ext_ctrls, v4l_print_ext_controls, INFO_FL_CTRL),
-	IOCTL_INFO_STD(VIDIOC_ENUM_FRAMESIZES, vidioc_enum_framesizes, v4l_print_frmsizeenum, INFO_FL_CLEAR(v4l2_frmsizeenum, pixel_format)),
-	IOCTL_INFO_STD(VIDIOC_ENUM_FRAMEINTERVALS, vidioc_enum_frameintervals, v4l_print_frmivalenum, INFO_FL_CLEAR(v4l2_frmivalenum, height)),
-	IOCTL_INFO_STD(VIDIOC_G_ENC_INDEX, vidioc_g_enc_index, v4l_print_enc_idx, 0),
-	IOCTL_INFO_STD(VIDIOC_ENCODER_CMD, vidioc_encoder_cmd, v4l_print_encoder_cmd, INFO_FL_PRIO | INFO_FL_CLEAR(v4l2_encoder_cmd, flags)),
-	IOCTL_INFO_STD(VIDIOC_TRY_ENCODER_CMD, vidioc_try_encoder_cmd, v4l_print_encoder_cmd, INFO_FL_CLEAR(v4l2_encoder_cmd, flags)),
-	IOCTL_INFO_STD(VIDIOC_DECODER_CMD, vidioc_decoder_cmd, v4l_print_decoder_cmd, INFO_FL_PRIO),
-	IOCTL_INFO_STD(VIDIOC_TRY_DECODER_CMD, vidioc_try_decoder_cmd, v4l_print_decoder_cmd, 0),
+	IOCTL_INFO_FNC(VIDIOC_ENUM_FRAMESIZES, v4l_vidioc_enum_framesizes, v4l_print_frmsizeenum, INFO_FL_CLEAR(v4l2_frmsizeenum, pixel_format)),
+	IOCTL_INFO_FNC(VIDIOC_ENUM_FRAMEINTERVALS, v4l_vidioc_enum_frameintervals, v4l_print_frmivalenum, INFO_FL_CLEAR(v4l2_frmivalenum, height)),
+	IOCTL_INFO_FNC(VIDIOC_G_ENC_INDEX, v4l_vidioc_g_enc_index, v4l_print_enc_idx, 0),
+	IOCTL_INFO_FNC(VIDIOC_ENCODER_CMD, v4l_vidioc_encoder_cmd, v4l_print_encoder_cmd, INFO_FL_PRIO | INFO_FL_CLEAR(v4l2_encoder_cmd, flags)),
+	IOCTL_INFO_FNC(VIDIOC_TRY_ENCODER_CMD, v4l_vidioc_try_encoder_cmd, v4l_print_encoder_cmd, INFO_FL_CLEAR(v4l2_encoder_cmd, flags)),
+	IOCTL_INFO_FNC(VIDIOC_DECODER_CMD, v4l_vidioc_decoder_cmd, v4l_print_decoder_cmd, INFO_FL_PRIO),
+	IOCTL_INFO_FNC(VIDIOC_TRY_DECODER_CMD, v4l_vidioc_try_decoder_cmd, v4l_print_decoder_cmd, 0),
 	IOCTL_INFO_FNC(VIDIOC_DBG_S_REGISTER, v4l_dbg_s_register, v4l_print_dbg_register, 0),
 	IOCTL_INFO_FNC(VIDIOC_DBG_G_REGISTER, v4l_dbg_g_register, v4l_print_dbg_register, 0),
 	IOCTL_INFO_FNC(VIDIOC_S_HW_FREQ_SEEK, v4l_s_hw_freq_seek, v4l_print_hw_freq_seek, INFO_FL_PRIO),
-	IOCTL_INFO_STD(VIDIOC_S_DV_TIMINGS, vidioc_s_dv_timings, v4l_print_dv_timings, INFO_FL_PRIO | INFO_FL_CLEAR(v4l2_dv_timings, bt.flags)),
-	IOCTL_INFO_STD(VIDIOC_G_DV_TIMINGS, vidioc_g_dv_timings, v4l_print_dv_timings, 0),
+	IOCTL_INFO_FNC(VIDIOC_S_DV_TIMINGS, v4l_vidioc_s_dv_timings, v4l_print_dv_timings, INFO_FL_PRIO | INFO_FL_CLEAR(v4l2_dv_timings, bt.flags)),
+	IOCTL_INFO_FNC(VIDIOC_G_DV_TIMINGS, v4l_vidioc_g_dv_timings, v4l_print_dv_timings, 0),
 	IOCTL_INFO_FNC(VIDIOC_DQEVENT, v4l_dqevent, v4l_print_event, 0),
 	IOCTL_INFO_FNC(VIDIOC_SUBSCRIBE_EVENT, v4l_subscribe_event, v4l_print_event_subscription, 0),
 	IOCTL_INFO_FNC(VIDIOC_UNSUBSCRIBE_EVENT, v4l_unsubscribe_event, v4l_print_event_subscription, 0),
 	IOCTL_INFO_FNC(VIDIOC_CREATE_BUFS, v4l_create_bufs, v4l_print_create_buffers, INFO_FL_PRIO | INFO_FL_QUEUE),
 	IOCTL_INFO_FNC(VIDIOC_PREPARE_BUF, v4l_prepare_buf, v4l_print_buffer, INFO_FL_QUEUE),
-	IOCTL_INFO_STD(VIDIOC_ENUM_DV_TIMINGS, vidioc_enum_dv_timings, v4l_print_enum_dv_timings, INFO_FL_CLEAR(v4l2_enum_dv_timings, pad)),
-	IOCTL_INFO_STD(VIDIOC_QUERY_DV_TIMINGS, vidioc_query_dv_timings, v4l_print_dv_timings, 0),
-	IOCTL_INFO_STD(VIDIOC_DV_TIMINGS_CAP, vidioc_dv_timings_cap, v4l_print_dv_timings_cap, INFO_FL_CLEAR(v4l2_dv_timings_cap, type)),
+	IOCTL_INFO_FNC(VIDIOC_ENUM_DV_TIMINGS, v4l_vidioc_enum_dv_timings, v4l_print_enum_dv_timings, INFO_FL_CLEAR(v4l2_enum_dv_timings, pad)),
+	IOCTL_INFO_FNC(VIDIOC_QUERY_DV_TIMINGS, v4l_vidioc_query_dv_timings, v4l_print_dv_timings, 0),
+	IOCTL_INFO_FNC(VIDIOC_DV_TIMINGS_CAP, v4l_vidioc_dv_timings_cap, v4l_print_dv_timings_cap, INFO_FL_CLEAR(v4l2_dv_timings_cap, type)),
 	IOCTL_INFO_FNC(VIDIOC_ENUM_FREQ_BANDS, v4l_enum_freq_bands, v4l_print_freq_band, 0),
 	IOCTL_INFO_FNC(VIDIOC_DBG_G_CHIP_INFO, v4l_dbg_g_chip_info, v4l_print_dbg_chip_info, INFO_FL_CLEAR(v4l2_dbg_chip_info, match)),
 	IOCTL_INFO_FNC(VIDIOC_QUERY_EXT_CTRL, v4l_query_ext_ctrl, v4l_print_query_ext_ctrl, INFO_FL_CTRL | INFO_FL_CLEAR(v4l2_query_ext_ctrl, id)),
@@ -2619,7 +2786,7 @@ static long __video_do_ioctl(struct file *file,
 	struct video_device *vfd = video_devdata(file);
 	const struct v4l2_ioctl_ops *ops = vfd->ioctl_ops;
 	bool write_only = false;
-	struct v4l2_ioctl_info default_info;
+	v4l2_ioctl_info_no_const default_info;
 	const struct v4l2_ioctl_info *info;
 	void *fh = file->private_data;
 	struct v4l2_fh *vfh = NULL;
@@ -2655,14 +2822,8 @@ static long __video_do_ioctl(struct file *file,
 	}
 
 	write_only = _IOC_DIR(cmd) == _IOC_WRITE;
-	if (info->flags & INFO_FL_STD) {
-		typedef int (*vidioc_op)(struct file *file, void *fh, void *p);
-		const void *p = vfd->ioctl_ops;
-		const vidioc_op *vidioc = p + info->u.offset;
-
-		ret = (*vidioc)(file, fh, arg);
-	} else if (info->flags & INFO_FL_FUNC) {
-		ret = info->u.func(ops, file, fh, arg);
+	if (info->flags & INFO_FL_FUNC) {
+		ret = info->func(ops, file, fh, arg);
 	} else if (!ops->vidioc_default) {
 		ret = -ENOTTY;
 	} else {
@@ -2710,7 +2871,7 @@ static int check_array_args(unsigned int cmd, void *parg, size_t *array_size,
 				ret = -EINVAL;
 				break;
 			}
-			*user_ptr = (void __user *)buf->m.planes;
+			*user_ptr = (void __force_user *)buf->m.planes;
 			*kernel_ptr = (void **)&buf->m.planes;
 			*array_size = sizeof(struct v4l2_plane) * buf->length;
 			ret = 1;
@@ -2727,7 +2888,7 @@ static int check_array_args(unsigned int cmd, void *parg, size_t *array_size,
 				ret = -EINVAL;
 				break;
 			}
-			*user_ptr = (void __user *)edid->edid;
+			*user_ptr = (void __force_user *)edid->edid;
 			*kernel_ptr = (void **)&edid->edid;
 			*array_size = edid->blocks * 128;
 			ret = 1;
@@ -2745,7 +2906,7 @@ static int check_array_args(unsigned int cmd, void *parg, size_t *array_size,
 				ret = -EINVAL;
 				break;
 			}
-			*user_ptr = (void __user *)ctrls->controls;
+			*user_ptr = (void __force_user *)ctrls->controls;
 			*kernel_ptr = (void **)&ctrls->controls;
 			*array_size = sizeof(struct v4l2_ext_control)
 				    * ctrls->count;
@@ -2846,7 +3007,7 @@ video_usercopy(struct file *file, unsigned int cmd, unsigned long arg,
 	}
 
 	if (has_array_args) {
-		*kernel_ptr = (void __force *)user_ptr;
+		*kernel_ptr = (void __force_kernel *)user_ptr;
 		if (copy_to_user(user_ptr, mbuf, array_size))
 			err = -EFAULT;
 		goto out_array_args;
diff --git a/drivers/memory/omap-gpmc.c b/drivers/memory/omap-gpmc.c
index f00f3e742..9138f668b 100644
--- a/drivers/memory/omap-gpmc.c
+++ b/drivers/memory/omap-gpmc.c
@@ -233,7 +233,7 @@ struct omap3_gpmc_regs {
 struct gpmc_device {
 	struct device *dev;
 	int irq;
-	struct irq_chip irq_chip;
+	struct irq_chip *irq_chip;
 	struct gpio_chip gpio_chip;
 	int nirqs;
 };
@@ -1254,10 +1254,10 @@ static int gpmc_irq_map(struct irq_domain *d, unsigned int virq,
 	irq_set_chip_data(virq, gpmc);
 	if (hw < GPMC_NR_NAND_IRQS) {
 		irq_modify_status(virq, IRQ_NOREQUEST, IRQ_NOAUTOEN);
-		irq_set_chip_and_handler(virq, &gpmc->irq_chip,
+		irq_set_chip_and_handler(virq, gpmc->irq_chip,
 					 handle_simple_irq);
 	} else {
-		irq_set_chip_and_handler(virq, &gpmc->irq_chip,
+		irq_set_chip_and_handler(virq, gpmc->irq_chip,
 					 handle_edge_irq);
 	}
 
@@ -1303,6 +1303,16 @@ static irqreturn_t gpmc_handle_irq(int irq, void *data)
 	return IRQ_HANDLED;
 }
 
+static struct irq_chip gpmc_irq_chip = {
+	.name = "gpmc",
+	.irq_enable = gpmc_irq_enable,
+	.irq_disable = gpmc_irq_disable,
+	.irq_ack = gpmc_irq_ack,
+	.irq_mask = gpmc_irq_mask,
+	.irq_unmask = gpmc_irq_unmask,
+	.irq_set_type = gpmc_irq_set_type,
+};
+
 static int gpmc_setup_irq(struct gpmc_device *gpmc)
 {
 	u32 regval;
@@ -1315,13 +1325,7 @@ static int gpmc_setup_irq(struct gpmc_device *gpmc)
 	regval = gpmc_read_reg(GPMC_IRQSTATUS);
 	gpmc_write_reg(GPMC_IRQSTATUS, regval);
 
-	gpmc->irq_chip.name = "gpmc";
-	gpmc->irq_chip.irq_enable = gpmc_irq_enable;
-	gpmc->irq_chip.irq_disable = gpmc_irq_disable;
-	gpmc->irq_chip.irq_ack = gpmc_irq_ack;
-	gpmc->irq_chip.irq_mask = gpmc_irq_mask;
-	gpmc->irq_chip.irq_unmask = gpmc_irq_unmask;
-	gpmc->irq_chip.irq_set_type = gpmc_irq_set_type;
+	gpmc->irq_chip = &gpmc_irq_chip;
 
 	gpmc_irq_domain = irq_domain_add_linear(gpmc->dev->of_node,
 						gpmc->nirqs,
diff --git a/drivers/message/fusion/mptbase.c b/drivers/message/fusion/mptbase.c
index 5537f8df8..f990a1d23 100644
--- a/drivers/message/fusion/mptbase.c
+++ b/drivers/message/fusion/mptbase.c
@@ -99,7 +99,7 @@ module_param(mpt_channel_mapping, int, 0);
 MODULE_PARM_DESC(mpt_channel_mapping, " Mapping id's to channels (default=0)");
 
 static int mpt_debug_level;
-static int mpt_set_debug_level(const char *val, struct kernel_param *kp);
+static int mpt_set_debug_level(const char *val, const struct kernel_param *kp);
 module_param_call(mpt_debug_level, mpt_set_debug_level, param_get_int,
 		  &mpt_debug_level, 0600);
 MODULE_PARM_DESC(mpt_debug_level,
@@ -242,7 +242,7 @@ pci_enable_io_access(struct pci_dev *pdev)
 	pci_write_config_word(pdev, PCI_COMMAND, command_reg);
 }
 
-static int mpt_set_debug_level(const char *val, struct kernel_param *kp)
+static int mpt_set_debug_level(const char *val, const struct kernel_param *kp)
 {
 	int ret = param_set_int(val, kp);
 	MPT_ADAPTER *ioc;
@@ -6748,8 +6748,13 @@ static int mpt_iocinfo_proc_show(struct seq_file *m, void *v)
 	seq_printf(m, "  MaxChainDepth = 0x%02x frames\n", ioc->facts.MaxChainDepth);
 	seq_printf(m, "  MinBlockSize = 0x%02x bytes\n", 4*ioc->facts.BlockSize);
 
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	seq_printf(m, "  RequestFrames @ 0x%p (Dma @ 0x%p)\n", NULL, NULL);
+#else
 	seq_printf(m, "  RequestFrames @ 0x%p (Dma @ 0x%p)\n",
 					(void *)ioc->req_frames, (void *)(ulong)ioc->req_frames_dma);
+#endif
+
 	/*
 	 *  Rounding UP to nearest 4-kB boundary here...
 	 */
@@ -6762,7 +6767,11 @@ static int mpt_iocinfo_proc_show(struct seq_file *m, void *v)
 					ioc->facts.GlobalCredits);
 
 	seq_printf(m, "  Frames   @ 0x%p (Dma @ 0x%p)\n",
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+					NULL, NULL);
+#else
 					(void *)ioc->alloc, (void *)(ulong)ioc->alloc_dma);
+#endif
 	sz = (ioc->reply_sz * ioc->reply_depth) + 128;
 	seq_printf(m, "    {CurRepSz=%d} x {CurRepDepth=%d} = %d bytes ^= 0x%x\n",
 					ioc->reply_sz, ioc->reply_depth, ioc->reply_sz*ioc->reply_depth, sz);
diff --git a/drivers/message/fusion/mptlan.c b/drivers/message/fusion/mptlan.c
index 6955c9e22..03bc46612 100644
--- a/drivers/message/fusion/mptlan.c
+++ b/drivers/message/fusion/mptlan.c
@@ -680,7 +680,7 @@ out:
 }
 
 /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
-static int
+static netdev_tx_t
 mpt_lan_sdu_send (struct sk_buff *skb, struct net_device *dev)
 {
 	struct mpt_lan_priv *priv = netdev_priv(dev);
diff --git a/drivers/message/fusion/mptsas.c b/drivers/message/fusion/mptsas.c
index 7ee1667ac..c36740da9 100644
--- a/drivers/message/fusion/mptsas.c
+++ b/drivers/message/fusion/mptsas.c
@@ -446,6 +446,23 @@ mptsas_is_end_device(struct mptsas_devinfo * attached)
 		return 0;
 }
 
+static inline void
+mptsas_set_rphy(MPT_ADAPTER *ioc, struct mptsas_phyinfo *phy_info, struct sas_rphy *rphy)
+{
+	if (phy_info->port_details) {
+		phy_info->port_details->rphy = rphy;
+		dsaswideprintk(ioc, printk(MYIOC_s_DEBUG_FMT "sas_rphy_add: rphy=%p\n",
+		    ioc->name, rphy));
+	}
+
+	if (rphy) {
+		dsaswideprintk(ioc, dev_printk(KERN_DEBUG,
+		    &rphy->dev, MYIOC_s_FMT "add:", ioc->name));
+		dsaswideprintk(ioc, printk(MYIOC_s_DEBUG_FMT "rphy=%p release=%p\n",
+		    ioc->name, rphy, rphy->dev.release));
+	}
+}
+
 /* no mutex */
 static void
 mptsas_port_delete(MPT_ADAPTER *ioc, struct mptsas_portinfo_details * port_details)
@@ -484,23 +501,6 @@ mptsas_get_rphy(struct mptsas_phyinfo *phy_info)
 		return NULL;
 }
 
-static inline void
-mptsas_set_rphy(MPT_ADAPTER *ioc, struct mptsas_phyinfo *phy_info, struct sas_rphy *rphy)
-{
-	if (phy_info->port_details) {
-		phy_info->port_details->rphy = rphy;
-		dsaswideprintk(ioc, printk(MYIOC_s_DEBUG_FMT "sas_rphy_add: rphy=%p\n",
-		    ioc->name, rphy));
-	}
-
-	if (rphy) {
-		dsaswideprintk(ioc, dev_printk(KERN_DEBUG,
-		    &rphy->dev, MYIOC_s_FMT "add:", ioc->name));
-		dsaswideprintk(ioc, printk(MYIOC_s_DEBUG_FMT "rphy=%p release=%p\n",
-		    ioc->name, rphy, rphy->dev.release));
-	}
-}
-
 static inline struct sas_port *
 mptsas_get_port(struct mptsas_phyinfo *phy_info)
 {
diff --git a/drivers/mfd/ab8500-debugfs.c b/drivers/mfd/ab8500-debugfs.c
index 0aecd7bd3..41bf9bf5d 100644
--- a/drivers/mfd/ab8500-debugfs.c
+++ b/drivers/mfd/ab8500-debugfs.c
@@ -100,7 +100,7 @@ static int irq_last;
 static u32 *irq_count;
 static int num_irqs;
 
-static struct device_attribute **dev_attr;
+static device_attribute_no_const **dev_attr;
 static char **event_name;
 
 static u8 avg_sample = SAMPLE_16;
diff --git a/drivers/mfd/kempld-core.c b/drivers/mfd/kempld-core.c
index da5722d7c..d4050306f 100644
--- a/drivers/mfd/kempld-core.c
+++ b/drivers/mfd/kempld-core.c
@@ -494,7 +494,7 @@ static struct platform_driver kempld_driver = {
 	.remove		= kempld_remove,
 };
 
-static struct dmi_system_id kempld_dmi_table[] __initdata = {
+static const struct dmi_system_id kempld_dmi_table[] __initconst = {
 	{
 		.ident = "BBL6",
 		.matches = {
diff --git a/drivers/mfd/max8925-i2c.c b/drivers/mfd/max8925-i2c.c
index 5c80aea32..100632361 100644
--- a/drivers/mfd/max8925-i2c.c
+++ b/drivers/mfd/max8925-i2c.c
@@ -151,7 +151,7 @@ static int max8925_probe(struct i2c_client *client,
 				   const struct i2c_device_id *id)
 {
 	struct max8925_platform_data *pdata = dev_get_platdata(&client->dev);
-	static struct max8925_chip *chip;
+	struct max8925_chip *chip;
 	struct device_node *node = client->dev.of_node;
 
 	if (node && !pdata) {
diff --git a/drivers/mfd/rn5t618.c b/drivers/mfd/rn5t618.c
index ee94080e1..e2a4a3d82 100644
--- a/drivers/mfd/rn5t618.c
+++ b/drivers/mfd/rn5t618.c
@@ -52,7 +52,6 @@ static const struct regmap_config rn5t618_regmap_config = {
 };
 
 static struct rn5t618 *rn5t618_pm_power_off;
-static struct notifier_block rn5t618_restart_handler;
 
 static void rn5t618_trigger_poweroff_sequence(bool repower)
 {
@@ -84,6 +83,12 @@ static int rn5t618_restart(struct notifier_block *this,
 	return NOTIFY_DONE;
 }
 
+static struct notifier_block rn5t618_restart_handler = {
+	.notifier_call = rn5t618_restart,
+	.priority = 192,
+
+};
+
 static const struct of_device_id rn5t618_of_match[] = {
 	{ .compatible = "ricoh,rn5t567", .data = (void *)RN5T567 },
 	{ .compatible = "ricoh,rn5t618", .data = (void *)RN5T618 },
@@ -133,9 +138,6 @@ static int rn5t618_i2c_probe(struct i2c_client *i2c,
 			dev_warn(&i2c->dev, "Poweroff callback already assigned\n");
 	}
 
-	rn5t618_restart_handler.notifier_call = rn5t618_restart;
-	rn5t618_restart_handler.priority = 192;
-
 	ret = register_restart_handler(&rn5t618_restart_handler);
 	if (ret) {
 		dev_err(&i2c->dev, "cannot register restart handler, %d\n", ret);
diff --git a/drivers/mfd/tps65910.c b/drivers/mfd/tps65910.c
index 11cab1582..d144bd9ad 100644
--- a/drivers/mfd/tps65910.c
+++ b/drivers/mfd/tps65910.c
@@ -230,7 +230,7 @@ static int tps65910_irq_init(struct tps65910 *tps65910, int irq,
 		    struct tps65910_platform_data *pdata)
 {
 	int ret = 0;
-	static struct regmap_irq_chip *tps6591x_irqs_chip;
+	struct regmap_irq_chip *tps6591x_irqs_chip;
 
 	if (!irq) {
 		dev_warn(tps65910->dev, "No interrupt support, no core IRQ\n");
diff --git a/drivers/mfd/twl4030-irq.c b/drivers/mfd/twl4030-irq.c
index b46c0cfc2..89e322b43 100644
--- a/drivers/mfd/twl4030-irq.c
+++ b/drivers/mfd/twl4030-irq.c
@@ -34,6 +34,7 @@
 #include <linux/of.h>
 #include <linux/irqdomain.h>
 #include <linux/i2c/twl.h>
+#include <asm/pgtable.h>
 
 #include "twl-core.h"
 
@@ -720,10 +721,12 @@ int twl4030_init_irq(struct device *dev, int irq_num)
 	 * Install an irq handler for each of the SIH modules;
 	 * clone dummy irq_chip since PIH can't *do* anything
 	 */
-	twl4030_irq_chip = dummy_irq_chip;
-	twl4030_irq_chip.name = "twl4030";
+	pax_open_kernel();
+	memcpy((void *)&twl4030_irq_chip, &dummy_irq_chip, sizeof twl4030_irq_chip);
+	const_cast(twl4030_irq_chip.name) = "twl4030";
 
-	twl4030_sih_irq_chip.irq_ack = dummy_irq_chip.irq_ack;
+	const_cast(twl4030_sih_irq_chip.irq_ack) = dummy_irq_chip.irq_ack;
+	pax_close_kernel();
 
 	for (i = irq_base; i < irq_end; i++) {
 		irq_set_chip_and_handler(i, &twl4030_irq_chip,
diff --git a/drivers/misc/c2port/core.c b/drivers/misc/c2port/core.c
index 1922cb8f6..e14fb42cf 100644
--- a/drivers/misc/c2port/core.c
+++ b/drivers/misc/c2port/core.c
@@ -918,7 +918,9 @@ struct c2port_device *c2port_device_register(char *name,
 		goto error_idr_alloc;
 	c2dev->id = ret;
 
-	bin_attr_flash_data.size = ops->blocks_num * ops->block_size;
+	pax_open_kernel();
+	const_cast(bin_attr_flash_data.size) = ops->blocks_num * ops->block_size;
+	pax_close_kernel();
 
 	c2dev->dev = device_create(c2port_class, NULL, 0, c2dev,
 				   "c2port%d", c2dev->id);
diff --git a/drivers/misc/kgdbts.c b/drivers/misc/kgdbts.c
index 99635dd9d..255bd78e5 100644
--- a/drivers/misc/kgdbts.c
+++ b/drivers/misc/kgdbts.c
@@ -834,7 +834,7 @@ static void run_plant_and_detach_test(int is_early)
 	char before[BREAK_INSTR_SIZE];
 	char after[BREAK_INSTR_SIZE];
 
-	probe_kernel_read(before, (char *)kgdbts_break_test,
+	probe_kernel_read(before, (void *)ktla_ktva((unsigned long)kgdbts_break_test),
 	  BREAK_INSTR_SIZE);
 	init_simple_test();
 	ts.tst = plant_and_detach_test;
@@ -842,7 +842,7 @@ static void run_plant_and_detach_test(int is_early)
 	/* Activate test with initial breakpoint */
 	if (!is_early)
 		kgdb_breakpoint();
-	probe_kernel_read(after, (char *)kgdbts_break_test,
+	probe_kernel_read(after, (void *)ktla_ktva((unsigned long)kgdbts_break_test),
 	  BREAK_INSTR_SIZE);
 	if (memcmp(before, after, BREAK_INSTR_SIZE)) {
 		printk(KERN_CRIT "kgdbts: ERROR kgdb corrupted memory\n");
@@ -1130,7 +1130,7 @@ static void kgdbts_put_char(u8 chr)
 		ts.run_test(0, chr);
 }
 
-static int param_set_kgdbts_var(const char *kmessage, struct kernel_param *kp)
+static int param_set_kgdbts_var(const char *kmessage, const struct kernel_param *kp)
 {
 	int len = strlen(kmessage);
 
diff --git a/drivers/misc/lis3lv02d/lis3lv02d.c b/drivers/misc/lis3lv02d/lis3lv02d.c
index fb8705fc3..dc2f679d0 100644
--- a/drivers/misc/lis3lv02d/lis3lv02d.c
+++ b/drivers/misc/lis3lv02d/lis3lv02d.c
@@ -497,7 +497,7 @@ static irqreturn_t lis302dl_interrupt(int irq, void *data)
 	 * the lid is closed. This leads to interrupts as soon as a little move
 	 * is done.
 	 */
-	atomic_inc(&lis3->count);
+	atomic_inc_unchecked(&lis3->count);
 
 	wake_up_interruptible(&lis3->misc_wait);
 	kill_fasync(&lis3->async_queue, SIGIO, POLL_IN);
@@ -583,7 +583,7 @@ static int lis3lv02d_misc_open(struct inode *inode, struct file *file)
 	if (lis3->pm_dev)
 		pm_runtime_get_sync(lis3->pm_dev);
 
-	atomic_set(&lis3->count, 0);
+	atomic_set_unchecked(&lis3->count, 0);
 	return 0;
 }
 
@@ -615,7 +615,7 @@ static ssize_t lis3lv02d_misc_read(struct file *file, char __user *buf,
 	add_wait_queue(&lis3->misc_wait, &wait);
 	while (true) {
 		set_current_state(TASK_INTERRUPTIBLE);
-		data = atomic_xchg(&lis3->count, 0);
+		data = atomic_xchg_unchecked(&lis3->count, 0);
 		if (data)
 			break;
 
@@ -656,7 +656,7 @@ static unsigned int lis3lv02d_misc_poll(struct file *file, poll_table *wait)
 					      struct lis3lv02d, miscdev);
 
 	poll_wait(file, &lis3->misc_wait, wait);
-	if (atomic_read(&lis3->count))
+	if (atomic_read_unchecked(&lis3->count))
 		return POLLIN | POLLRDNORM;
 	return 0;
 }
diff --git a/drivers/misc/lis3lv02d/lis3lv02d.h b/drivers/misc/lis3lv02d/lis3lv02d.h
index c439c827e..1f20f5713 100644
--- a/drivers/misc/lis3lv02d/lis3lv02d.h
+++ b/drivers/misc/lis3lv02d/lis3lv02d.h
@@ -297,7 +297,7 @@ struct lis3lv02d {
 	struct input_polled_dev	*idev;     /* input device */
 	struct platform_device	*pdev;     /* platform device */
 	struct regulator_bulk_data regulators[2];
-	atomic_t		count;     /* interrupt count after last read */
+	atomic_unchecked_t	count;     /* interrupt count after last read */
 	union axis_conversion	ac;        /* hw -> logical axis */
 	int			mapped_btns[3];
 
diff --git a/drivers/misc/lkdtm_core.c b/drivers/misc/lkdtm_core.c
index f9154b8d6..bb13e3e9c 100644
--- a/drivers/misc/lkdtm_core.c
+++ b/drivers/misc/lkdtm_core.c
@@ -78,7 +78,7 @@ static irqreturn_t jp_handle_irq_event(unsigned int irq,
 	return 0;
 }
 
-static void jp_tasklet_action(struct softirq_action *a)
+static void jp_tasklet_action(void)
 {
 	lkdtm_handler();
 	jprobe_return();
diff --git a/drivers/misc/mic/scif/scif_api.c b/drivers/misc/mic/scif/scif_api.c
index ddc9e4b08..9e27f4100 100644
--- a/drivers/misc/mic/scif/scif_api.c
+++ b/drivers/misc/mic/scif/scif_api.c
@@ -1486,10 +1486,12 @@ int scif_client_register(struct scif_client *client)
 {
 	struct subsys_interface *si = &client->si;
 
-	si->name = client->name;
-	si->subsys = &scif_peer_bus;
-	si->add_dev = scif_add_client_dev;
-	si->remove_dev = scif_remove_client_dev;
+	pax_open_kernel();
+	const_cast(si->name) = client->name;
+	const_cast(si->subsys) = &scif_peer_bus;
+	const_cast(si->add_dev) = scif_add_client_dev;
+	const_cast(si->remove_dev) = scif_remove_client_dev;
+	pax_close_kernel();
 
 	return subsys_interface_register(&client->si);
 }
diff --git a/drivers/misc/mic/scif/scif_rb.c b/drivers/misc/mic/scif/scif_rb.c
index 637cc4686..4fb1267a4 100644
--- a/drivers/misc/mic/scif/scif_rb.c
+++ b/drivers/misc/mic/scif/scif_rb.c
@@ -138,7 +138,7 @@ void scif_rb_commit(struct scif_rb *rb)
 	 * the read barrier in scif_rb_count(..)
 	 */
 	wmb();
-	ACCESS_ONCE(*rb->write_ptr) = rb->current_write_offset;
+	ACCESS_ONCE_RW(*rb->write_ptr) = rb->current_write_offset;
 #ifdef CONFIG_INTEL_MIC_CARD
 	/*
 	 * X100 Si bug: For the case where a Core is performing an EXT_WR
@@ -147,7 +147,7 @@ void scif_rb_commit(struct scif_rb *rb)
 	 * This way, if ordering is violated for the Interrupt Message, it will
 	 * fall just behind the first Posted associated with the first EXT_WR.
 	 */
-	ACCESS_ONCE(*rb->write_ptr) = rb->current_write_offset;
+	ACCESS_ONCE_RW(*rb->write_ptr) = rb->current_write_offset;
 #endif
 }
 
@@ -210,7 +210,7 @@ void scif_rb_update_read_ptr(struct scif_rb *rb)
 	 * scif_rb_space(..)
 	 */
 	mb();
-	ACCESS_ONCE(*rb->read_ptr) = new_offset;
+	ACCESS_ONCE_RW(*rb->read_ptr) = new_offset;
 #ifdef CONFIG_INTEL_MIC_CARD
 	/*
 	 * X100 Si Bug: For the case where a Core is performing an EXT_WR
@@ -219,7 +219,7 @@ void scif_rb_update_read_ptr(struct scif_rb *rb)
 	 * This way, if ordering is violated for the Interrupt Message, it will
 	 * fall just behind the first Posted associated with the first EXT_WR.
 	 */
-	ACCESS_ONCE(*rb->read_ptr) = new_offset;
+	ACCESS_ONCE_RW(*rb->read_ptr) = new_offset;
 #endif
 }
 
diff --git a/drivers/misc/panel.c b/drivers/misc/panel.c
index 6030ac5b8..e498727e9 100644
--- a/drivers/misc/panel.c
+++ b/drivers/misc/panel.c
@@ -1983,7 +1983,7 @@ static void panel_process_inputs(void)
 	}
 }
 
-static void panel_scan_timer(void)
+static void panel_scan_timer(unsigned long data)
 {
 	if (keypad.enabled && keypad_initialized) {
 		if (spin_trylock_irq(&pprt_lock)) {
@@ -2019,7 +2019,7 @@ static void init_scan_timer(void)
 	if (scan_timer.function)
 		return;		/* already started */
 
-	setup_timer(&scan_timer, (void *)&panel_scan_timer, 0);
+	setup_timer(&scan_timer, &panel_scan_timer, 0);
 	scan_timer.expires = jiffies + INPUT_POLL_TIME;
 	add_timer(&scan_timer);
 }
diff --git a/drivers/misc/sgi-gru/gruhandles.c b/drivers/misc/sgi-gru/gruhandles.c
index 1ee8e82ba..785f5280b 100644
--- a/drivers/misc/sgi-gru/gruhandles.c
+++ b/drivers/misc/sgi-gru/gruhandles.c
@@ -44,8 +44,8 @@ static void update_mcs_stats(enum mcs_op op, unsigned long clks)
 	unsigned long nsec;
 
 	nsec = CLKS2NSEC(clks);
-	atomic_long_inc(&mcs_op_statistics[op].count);
-	atomic_long_add(nsec, &mcs_op_statistics[op].total);
+	atomic_long_inc_unchecked(&mcs_op_statistics[op].count);
+	atomic_long_add_unchecked(nsec, &mcs_op_statistics[op].total);
 	if (mcs_op_statistics[op].max < nsec)
 		mcs_op_statistics[op].max = nsec;
 }
diff --git a/drivers/misc/sgi-gru/gruprocfs.c b/drivers/misc/sgi-gru/gruprocfs.c
index 4f7635922..cdfcb2e35 100644
--- a/drivers/misc/sgi-gru/gruprocfs.c
+++ b/drivers/misc/sgi-gru/gruprocfs.c
@@ -32,9 +32,9 @@
 
 #define printstat(s, f)		printstat_val(s, &gru_stats.f, #f)
 
-static void printstat_val(struct seq_file *s, atomic_long_t *v, char *id)
+static void printstat_val(struct seq_file *s, atomic_long_unchecked_t *v, char *id)
 {
-	unsigned long val = atomic_long_read(v);
+	unsigned long val = atomic_long_read_unchecked(v);
 
 	seq_printf(s, "%16lu %s\n", val, id);
 }
@@ -134,8 +134,8 @@ static int mcs_statistics_show(struct seq_file *s, void *p)
 
 	seq_printf(s, "%-20s%12s%12s%12s\n", "#id", "count", "aver-clks", "max-clks");
 	for (op = 0; op < mcsop_last; op++) {
-		count = atomic_long_read(&mcs_op_statistics[op].count);
-		total = atomic_long_read(&mcs_op_statistics[op].total);
+		count = atomic_long_read_unchecked(&mcs_op_statistics[op].count);
+		total = atomic_long_read_unchecked(&mcs_op_statistics[op].total);
 		max = mcs_op_statistics[op].max;
 		seq_printf(s, "%-20s%12ld%12ld%12ld\n", id[op], count,
 			   count ? total / count : 0, max);
diff --git a/drivers/misc/sgi-gru/grutables.h b/drivers/misc/sgi-gru/grutables.h
index 5c3ce2459..4915ccbbe 100644
--- a/drivers/misc/sgi-gru/grutables.h
+++ b/drivers/misc/sgi-gru/grutables.h
@@ -167,82 +167,82 @@ extern unsigned int gru_max_gids;
  * GRU statistics.
  */
 struct gru_stats_s {
-	atomic_long_t vdata_alloc;
-	atomic_long_t vdata_free;
-	atomic_long_t gts_alloc;
-	atomic_long_t gts_free;
-	atomic_long_t gms_alloc;
-	atomic_long_t gms_free;
-	atomic_long_t gts_double_allocate;
-	atomic_long_t assign_context;
-	atomic_long_t assign_context_failed;
-	atomic_long_t free_context;
-	atomic_long_t load_user_context;
-	atomic_long_t load_kernel_context;
-	atomic_long_t lock_kernel_context;
-	atomic_long_t unlock_kernel_context;
-	atomic_long_t steal_user_context;
-	atomic_long_t steal_kernel_context;
-	atomic_long_t steal_context_failed;
-	atomic_long_t nopfn;
-	atomic_long_t asid_new;
-	atomic_long_t asid_next;
-	atomic_long_t asid_wrap;
-	atomic_long_t asid_reuse;
-	atomic_long_t intr;
-	atomic_long_t intr_cbr;
-	atomic_long_t intr_tfh;
-	atomic_long_t intr_spurious;
-	atomic_long_t intr_mm_lock_failed;
-	atomic_long_t call_os;
-	atomic_long_t call_os_wait_queue;
-	atomic_long_t user_flush_tlb;
-	atomic_long_t user_unload_context;
-	atomic_long_t user_exception;
-	atomic_long_t set_context_option;
-	atomic_long_t check_context_retarget_intr;
-	atomic_long_t check_context_unload;
-	atomic_long_t tlb_dropin;
-	atomic_long_t tlb_preload_page;
-	atomic_long_t tlb_dropin_fail_no_asid;
-	atomic_long_t tlb_dropin_fail_upm;
-	atomic_long_t tlb_dropin_fail_invalid;
-	atomic_long_t tlb_dropin_fail_range_active;
-	atomic_long_t tlb_dropin_fail_idle;
-	atomic_long_t tlb_dropin_fail_fmm;
-	atomic_long_t tlb_dropin_fail_no_exception;
-	atomic_long_t tfh_stale_on_fault;
-	atomic_long_t mmu_invalidate_range;
-	atomic_long_t mmu_invalidate_page;
-	atomic_long_t flush_tlb;
-	atomic_long_t flush_tlb_gru;
-	atomic_long_t flush_tlb_gru_tgh;
-	atomic_long_t flush_tlb_gru_zero_asid;
-
-	atomic_long_t copy_gpa;
-	atomic_long_t read_gpa;
-
-	atomic_long_t mesq_receive;
-	atomic_long_t mesq_receive_none;
-	atomic_long_t mesq_send;
-	atomic_long_t mesq_send_failed;
-	atomic_long_t mesq_noop;
-	atomic_long_t mesq_send_unexpected_error;
-	atomic_long_t mesq_send_lb_overflow;
-	atomic_long_t mesq_send_qlimit_reached;
-	atomic_long_t mesq_send_amo_nacked;
-	atomic_long_t mesq_send_put_nacked;
-	atomic_long_t mesq_page_overflow;
-	atomic_long_t mesq_qf_locked;
-	atomic_long_t mesq_qf_noop_not_full;
-	atomic_long_t mesq_qf_switch_head_failed;
-	atomic_long_t mesq_qf_unexpected_error;
-	atomic_long_t mesq_noop_unexpected_error;
-	atomic_long_t mesq_noop_lb_overflow;
-	atomic_long_t mesq_noop_qlimit_reached;
-	atomic_long_t mesq_noop_amo_nacked;
-	atomic_long_t mesq_noop_put_nacked;
-	atomic_long_t mesq_noop_page_overflow;
+	atomic_long_unchecked_t vdata_alloc;
+	atomic_long_unchecked_t vdata_free;
+	atomic_long_unchecked_t gts_alloc;
+	atomic_long_unchecked_t gts_free;
+	atomic_long_unchecked_t gms_alloc;
+	atomic_long_unchecked_t gms_free;
+	atomic_long_unchecked_t gts_double_allocate;
+	atomic_long_unchecked_t assign_context;
+	atomic_long_unchecked_t assign_context_failed;
+	atomic_long_unchecked_t free_context;
+	atomic_long_unchecked_t load_user_context;
+	atomic_long_unchecked_t load_kernel_context;
+	atomic_long_unchecked_t lock_kernel_context;
+	atomic_long_unchecked_t unlock_kernel_context;
+	atomic_long_unchecked_t steal_user_context;
+	atomic_long_unchecked_t steal_kernel_context;
+	atomic_long_unchecked_t steal_context_failed;
+	atomic_long_unchecked_t nopfn;
+	atomic_long_unchecked_t asid_new;
+	atomic_long_unchecked_t asid_next;
+	atomic_long_unchecked_t asid_wrap;
+	atomic_long_unchecked_t asid_reuse;
+	atomic_long_unchecked_t intr;
+	atomic_long_unchecked_t intr_cbr;
+	atomic_long_unchecked_t intr_tfh;
+	atomic_long_unchecked_t intr_spurious;
+	atomic_long_unchecked_t intr_mm_lock_failed;
+	atomic_long_unchecked_t call_os;
+	atomic_long_unchecked_t call_os_wait_queue;
+	atomic_long_unchecked_t user_flush_tlb;
+	atomic_long_unchecked_t user_unload_context;
+	atomic_long_unchecked_t user_exception;
+	atomic_long_unchecked_t set_context_option;
+	atomic_long_unchecked_t check_context_retarget_intr;
+	atomic_long_unchecked_t check_context_unload;
+	atomic_long_unchecked_t tlb_dropin;
+	atomic_long_unchecked_t tlb_preload_page;
+	atomic_long_unchecked_t tlb_dropin_fail_no_asid;
+	atomic_long_unchecked_t tlb_dropin_fail_upm;
+	atomic_long_unchecked_t tlb_dropin_fail_invalid;
+	atomic_long_unchecked_t tlb_dropin_fail_range_active;
+	atomic_long_unchecked_t tlb_dropin_fail_idle;
+	atomic_long_unchecked_t tlb_dropin_fail_fmm;
+	atomic_long_unchecked_t tlb_dropin_fail_no_exception;
+	atomic_long_unchecked_t tfh_stale_on_fault;
+	atomic_long_unchecked_t mmu_invalidate_range;
+	atomic_long_unchecked_t mmu_invalidate_page;
+	atomic_long_unchecked_t flush_tlb;
+	atomic_long_unchecked_t flush_tlb_gru;
+	atomic_long_unchecked_t flush_tlb_gru_tgh;
+	atomic_long_unchecked_t flush_tlb_gru_zero_asid;
+
+	atomic_long_unchecked_t copy_gpa;
+	atomic_long_unchecked_t read_gpa;
+
+	atomic_long_unchecked_t mesq_receive;
+	atomic_long_unchecked_t mesq_receive_none;
+	atomic_long_unchecked_t mesq_send;
+	atomic_long_unchecked_t mesq_send_failed;
+	atomic_long_unchecked_t mesq_noop;
+	atomic_long_unchecked_t mesq_send_unexpected_error;
+	atomic_long_unchecked_t mesq_send_lb_overflow;
+	atomic_long_unchecked_t mesq_send_qlimit_reached;
+	atomic_long_unchecked_t mesq_send_amo_nacked;
+	atomic_long_unchecked_t mesq_send_put_nacked;
+	atomic_long_unchecked_t mesq_page_overflow;
+	atomic_long_unchecked_t mesq_qf_locked;
+	atomic_long_unchecked_t mesq_qf_noop_not_full;
+	atomic_long_unchecked_t mesq_qf_switch_head_failed;
+	atomic_long_unchecked_t mesq_qf_unexpected_error;
+	atomic_long_unchecked_t mesq_noop_unexpected_error;
+	atomic_long_unchecked_t mesq_noop_lb_overflow;
+	atomic_long_unchecked_t mesq_noop_qlimit_reached;
+	atomic_long_unchecked_t mesq_noop_amo_nacked;
+	atomic_long_unchecked_t mesq_noop_put_nacked;
+	atomic_long_unchecked_t mesq_noop_page_overflow;
 
 };
 
@@ -251,8 +251,8 @@ enum mcs_op {cchop_allocate, cchop_start, cchop_interrupt, cchop_interrupt_sync,
 	tghop_invalidate, mcsop_last};
 
 struct mcs_op_statistic {
-	atomic_long_t	count;
-	atomic_long_t	total;
+	atomic_long_unchecked_t	count;
+	atomic_long_unchecked_t	total;
 	unsigned long	max;
 };
 
@@ -275,7 +275,7 @@ extern struct mcs_op_statistic mcs_op_statistics[mcsop_last];
 
 #define STAT(id)	do {						\
 				if (gru_options & OPT_STATS)		\
-					atomic_long_inc(&gru_stats.id);	\
+					atomic_long_inc_unchecked(&gru_stats.id);	\
 			} while (0)
 
 #ifdef CONFIG_SGI_GRU_DEBUG
diff --git a/drivers/misc/sgi-xp/xp.h b/drivers/misc/sgi-xp/xp.h
index c862cd458..0d176fed8 100644
--- a/drivers/misc/sgi-xp/xp.h
+++ b/drivers/misc/sgi-xp/xp.h
@@ -288,7 +288,7 @@ struct xpc_interface {
 					xpc_notify_func, void *);
 	void (*received) (short, int, void *);
 	enum xp_retval (*partid_to_nasids) (short, void *);
-};
+} __no_const;
 
 extern struct xpc_interface xpc_interface;
 
diff --git a/drivers/misc/sgi-xp/xp_main.c b/drivers/misc/sgi-xp/xp_main.c
index 01be66d02..4a305b4de 100644
--- a/drivers/misc/sgi-xp/xp_main.c
+++ b/drivers/misc/sgi-xp/xp_main.c
@@ -71,20 +71,42 @@ EXPORT_SYMBOL_GPL(xpc_registrations);
 /*
  * Initialize the XPC interface to indicate that XPC isn't loaded.
  */
-static enum xp_retval
-xpc_notloaded(void)
+static void xpc_notloaded_connect(int ch_number)
+{
+}
+
+static void xpc_notloaded_disconnect(int ch_number)
+{
+}
+
+static enum xp_retval xpc_notloaded_send(short partid, int ch_number, u32 flags, void *payload,
+					 u16 payload_size)
+{
+	return xpNotLoaded;
+}
+
+static enum xp_retval xpc_notloaded_send_notify(short partid, int ch_number, u32 flags, void *payload,
+						u16 payload_size, xpc_notify_func func, void *key)
+{
+	return xpNotLoaded;
+}
+
+static void xpc_notloaded_received(short partid, int ch_number, void *payload)
+{
+}
+
+static enum xp_retval xpc_notloaded_partid_to_nasids(short partid, void *nasid_mask)
 {
 	return xpNotLoaded;
 }
 
 struct xpc_interface xpc_interface = {
-	(void (*)(int))xpc_notloaded,
-	(void (*)(int))xpc_notloaded,
-	(enum xp_retval(*)(short, int, u32, void *, u16))xpc_notloaded,
-	(enum xp_retval(*)(short, int, u32, void *, u16, xpc_notify_func,
-			   void *))xpc_notloaded,
-	(void (*)(short, int, void *))xpc_notloaded,
-	(enum xp_retval(*)(short, void *))xpc_notloaded
+	.connect = xpc_notloaded_connect,
+	.disconnect = xpc_notloaded_disconnect,
+	.send = xpc_notloaded_send,
+	.send_notify = xpc_notloaded_send_notify,
+	.received = xpc_notloaded_received,
+	.partid_to_nasids = xpc_notloaded_partid_to_nasids
 };
 EXPORT_SYMBOL_GPL(xpc_interface);
 
@@ -115,17 +137,12 @@ EXPORT_SYMBOL_GPL(xpc_set_interface);
 void
 xpc_clear_interface(void)
 {
-	xpc_interface.connect = (void (*)(int))xpc_notloaded;
-	xpc_interface.disconnect = (void (*)(int))xpc_notloaded;
-	xpc_interface.send = (enum xp_retval(*)(short, int, u32, void *, u16))
-	    xpc_notloaded;
-	xpc_interface.send_notify = (enum xp_retval(*)(short, int, u32, void *,
-						       u16, xpc_notify_func,
-						       void *))xpc_notloaded;
-	xpc_interface.received = (void (*)(short, int, void *))
-	    xpc_notloaded;
-	xpc_interface.partid_to_nasids = (enum xp_retval(*)(short, void *))
-	    xpc_notloaded;
+	xpc_interface.connect = xpc_notloaded_connect;
+	xpc_interface.disconnect = xpc_notloaded_disconnect;
+	xpc_interface.send = xpc_notloaded_send;
+	xpc_interface.send_notify = xpc_notloaded_send_notify;
+	xpc_interface.received = xpc_notloaded_received;
+	xpc_interface.partid_to_nasids = xpc_notloaded_partid_to_nasids;
 }
 EXPORT_SYMBOL_GPL(xpc_clear_interface);
 
diff --git a/drivers/misc/sgi-xp/xpc.h b/drivers/misc/sgi-xp/xpc.h
index b94d5f767..7f494c516 100644
--- a/drivers/misc/sgi-xp/xpc.h
+++ b/drivers/misc/sgi-xp/xpc.h
@@ -835,6 +835,7 @@ struct xpc_arch_operations {
 	void (*received_payload) (struct xpc_channel *, void *);
 	void (*notify_senders_of_disconnect) (struct xpc_channel *);
 };
+typedef struct xpc_arch_operations __no_const xpc_arch_operations_no_const;
 
 /* struct xpc_partition act_state values (for XPC HB) */
 
@@ -876,7 +877,7 @@ extern struct xpc_registration xpc_registrations[];
 /* found in xpc_main.c */
 extern struct device *xpc_part;
 extern struct device *xpc_chan;
-extern struct xpc_arch_operations xpc_arch_ops;
+extern xpc_arch_operations_no_const xpc_arch_ops;
 extern int xpc_disengage_timelimit;
 extern int xpc_disengage_timedout;
 extern int xpc_activate_IRQ_rcvd;
diff --git a/drivers/misc/sgi-xp/xpc_main.c b/drivers/misc/sgi-xp/xpc_main.c
index 7f327121e..8539ab27e 100644
--- a/drivers/misc/sgi-xp/xpc_main.c
+++ b/drivers/misc/sgi-xp/xpc_main.c
@@ -166,7 +166,7 @@ static struct notifier_block xpc_die_notifier = {
 	.notifier_call = xpc_system_die,
 };
 
-struct xpc_arch_operations xpc_arch_ops;
+xpc_arch_operations_no_const xpc_arch_ops;
 
 /*
  * Timer function to enforce the timelimit on the partition disengage.
diff --git a/drivers/misc/sgi-xp/xpnet.c b/drivers/misc/sgi-xp/xpnet.c
index 557f9782c..c8ce9fb11 100644
--- a/drivers/misc/sgi-xp/xpnet.c
+++ b/drivers/misc/sgi-xp/xpnet.c
@@ -421,7 +421,7 @@ xpnet_send(struct sk_buff *skb, struct xpnet_pending_msg *queued_msg,
  * destination partid.  If the destination partid octets are 0xffff,
  * this packet is to be broadcast to all connected partitions.
  */
-static int
+static netdev_tx_t
 xpnet_dev_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct xpnet_pending_msg *queued_msg;
diff --git a/drivers/misc/ti-st/st_kim.c b/drivers/misc/ti-st/st_kim.c
index 3c4399251..8d173bf18 100644
--- a/drivers/misc/ti-st/st_kim.c
+++ b/drivers/misc/ti-st/st_kim.c
@@ -581,9 +581,10 @@ static int show_list(struct seq_file *s, void *unused)
 	return 0;
 }
 
-static ssize_t show_install(struct device *dev,
-		struct device_attribute *attr, char *buf)
+static ssize_t show_install(struct kobject *_dev,
+		struct kobj_attribute *attr, char *buf)
 {
+	struct device *dev = (struct device *)_dev;
 	struct kim_data_s *kim_data = dev_get_drvdata(dev);
 	return sprintf(buf, "%d\n", kim_data->ldisc_install);
 }
@@ -610,47 +611,50 @@ static ssize_t store_baud_rate(struct device *dev,
 }
 #endif	/* if DEBUG */
 
-static ssize_t show_dev_name(struct device *dev,
-		struct device_attribute *attr, char *buf)
+static ssize_t show_dev_name(struct kobject *_dev,
+		struct kobj_attribute *attr, char *buf)
 {
+	struct device *dev = (struct device *)_dev;
 	struct kim_data_s *kim_data = dev_get_drvdata(dev);
 	return sprintf(buf, "%s\n", kim_data->dev_name);
 }
 
-static ssize_t show_baud_rate(struct device *dev,
-		struct device_attribute *attr, char *buf)
+static ssize_t show_baud_rate(struct kobject *_dev,
+		struct kobj_attribute *attr, char *buf)
 {
+	struct device *dev = (struct device *)_dev;
 	struct kim_data_s *kim_data = dev_get_drvdata(dev);
 	return sprintf(buf, "%d\n", kim_data->baud_rate);
 }
 
-static ssize_t show_flow_cntrl(struct device *dev,
-		struct device_attribute *attr, char *buf)
+static ssize_t show_flow_cntrl(struct kobject *_dev,
+		struct kobj_attribute *attr, char *buf)
 {
+	struct device *dev = (struct device *)_dev;
 	struct kim_data_s *kim_data = dev_get_drvdata(dev);
 	return sprintf(buf, "%d\n", kim_data->flow_cntrl);
 }
 
 /* structures specific for sysfs entries */
 static struct kobj_attribute ldisc_install =
-__ATTR(install, 0444, (void *)show_install, NULL);
+__ATTR(install, 0444, show_install, NULL);
 
 static struct kobj_attribute uart_dev_name =
 #ifdef DEBUG	/* TODO: move this to debug-fs if possible */
-__ATTR(dev_name, 0644, (void *)show_dev_name, (void *)store_dev_name);
+__ATTR(dev_name, 0644, show_dev_name, store_dev_name);
 #else
-__ATTR(dev_name, 0444, (void *)show_dev_name, NULL);
+__ATTR(dev_name, 0444, show_dev_name, NULL);
 #endif
 
 static struct kobj_attribute uart_baud_rate =
 #ifdef DEBUG	/* TODO: move to debugfs */
-__ATTR(baud_rate, 0644, (void *)show_baud_rate, (void *)store_baud_rate);
+__ATTR(baud_rate, 0644, show_baud_rate, store_baud_rate);
 #else
-__ATTR(baud_rate, 0444, (void *)show_baud_rate, NULL);
+__ATTR(baud_rate, 0444, show_baud_rate, NULL);
 #endif
 
 static struct kobj_attribute uart_flow_cntrl =
-__ATTR(flow_cntrl, 0444, (void *)show_flow_cntrl, NULL);
+__ATTR(flow_cntrl, 0444, show_flow_cntrl, NULL);
 
 static struct attribute *uim_attrs[] = {
 	&ldisc_install.attr,
diff --git a/drivers/mmc/card/mmc_test.c b/drivers/mmc/card/mmc_test.c
index c032eef45..16a2a74ba 100644
--- a/drivers/mmc/card/mmc_test.c
+++ b/drivers/mmc/card/mmc_test.c
@@ -2076,8 +2076,8 @@ static int mmc_test_rw_multiple_size(struct mmc_test_card *test,
 {
 	int ret = 0;
 	int i;
-	void *pre_req = test->card->host->ops->pre_req;
-	void *post_req = test->card->host->ops->post_req;
+	void (*pre_req)(struct mmc_host *, struct mmc_request *, bool) = test->card->host->ops->pre_req;
+	void (*post_req)(struct mmc_host *, struct mmc_request *, int) = test->card->host->ops->post_req;
 
 	if (rw->do_nonblock_req &&
 	    ((!pre_req && post_req) || (pre_req && !post_req))) {
diff --git a/drivers/mmc/host/dw_mmc.h b/drivers/mmc/host/dw_mmc.h
index e8cd2dec3..c1640f654 100644
--- a/drivers/mmc/host/dw_mmc.h
+++ b/drivers/mmc/host/dw_mmc.h
@@ -298,5 +298,5 @@ struct dw_mci_drv_data {
 						struct mmc_ios *ios);
 	int		(*switch_voltage)(struct mmc_host *mmc,
 					  struct mmc_ios *ios);
-};
+} __do_const;
 #endif /* _DW_MMC_H_ */
diff --git a/drivers/mmc/host/mmci.c b/drivers/mmc/host/mmci.c
index df990bb8c..e647253e9 100644
--- a/drivers/mmc/host/mmci.c
+++ b/drivers/mmc/host/mmci.c
@@ -1613,7 +1613,9 @@ static int mmci_probe(struct amba_device *dev,
 	mmc->caps |= MMC_CAP_CMD23;
 
 	if (variant->busy_detect) {
-		mmci_ops.card_busy = mmci_card_busy;
+		pax_open_kernel();
+		const_cast(mmci_ops.card_busy) = mmci_card_busy;
+		pax_close_kernel();
 		mmci_write_datactrlreg(host, MCI_ST_DPSM_BUSYMODE);
 		mmc->caps |= MMC_CAP_WAIT_WHILE_BUSY;
 		mmc->max_busy_timeout = 0;
diff --git a/drivers/mmc/host/omap_hsmmc.c b/drivers/mmc/host/omap_hsmmc.c
index 5f2f24a73..e80f6f358 100644
--- a/drivers/mmc/host/omap_hsmmc.c
+++ b/drivers/mmc/host/omap_hsmmc.c
@@ -2076,7 +2076,9 @@ static int omap_hsmmc_probe(struct platform_device *pdev)
 
 	if (host->pdata->controller_flags & OMAP_HSMMC_BROKEN_MULTIBLOCK_READ) {
 		dev_info(&pdev->dev, "multiblock reads disabled due to 35xx erratum 2.1.1.128; MMC read performance may suffer\n");
-		omap_hsmmc_ops.multi_io_quirk = omap_hsmmc_multi_io_quirk;
+		pax_open_kernel();
+		const_cast(omap_hsmmc_ops.multi_io_quirk) = omap_hsmmc_multi_io_quirk;
+		pax_close_kernel();
 	}
 
 	device_init_wakeup(&pdev->dev, true);
diff --git a/drivers/mmc/host/sdhci-esdhc-imx.c b/drivers/mmc/host/sdhci-esdhc-imx.c
index 99e0b334f..107a2cc2b 100644
--- a/drivers/mmc/host/sdhci-esdhc-imx.c
+++ b/drivers/mmc/host/sdhci-esdhc-imx.c
@@ -1231,9 +1231,12 @@ static int sdhci_esdhc_imx_probe(struct platform_device *pdev)
 		writel(0x0, host->ioaddr + ESDHC_TUNE_CTRL_STATUS);
 	}
 
-	if (imx_data->socdata->flags & ESDHC_FLAG_MAN_TUNING)
-		sdhci_esdhc_ops.platform_execute_tuning =
+	if (imx_data->socdata->flags & ESDHC_FLAG_MAN_TUNING) {
+		pax_open_kernel();
+		const_cast(sdhci_esdhc_ops.platform_execute_tuning) =
 					esdhc_executing_tuning;
+		pax_close_kernel();
+	}
 
 	if (imx_data->socdata->flags & ESDHC_FLAG_ERR004536)
 		host->quirks |= SDHCI_QUIRK_BROKEN_ADMA;
diff --git a/drivers/mmc/host/sdhci-s3c.c b/drivers/mmc/host/sdhci-s3c.c
index 784c5a848..356732858 100644
--- a/drivers/mmc/host/sdhci-s3c.c
+++ b/drivers/mmc/host/sdhci-s3c.c
@@ -598,9 +598,11 @@ static int sdhci_s3c_probe(struct platform_device *pdev)
 	 * we can use overriding functions instead of default.
 	 */
 	if (sc->no_divider) {
-		sdhci_s3c_ops.set_clock = sdhci_cmu_set_clock;
-		sdhci_s3c_ops.get_min_clock = sdhci_cmu_get_min_clock;
-		sdhci_s3c_ops.get_max_clock = sdhci_cmu_get_max_clock;
+		pax_open_kernel();
+		const_cast(sdhci_s3c_ops.set_clock) = sdhci_cmu_set_clock;
+		const_cast(sdhci_s3c_ops.get_min_clock) = sdhci_cmu_get_min_clock;
+		const_cast(sdhci_s3c_ops.get_max_clock) = sdhci_cmu_get_max_clock;
+		pax_close_kernel();
 	}
 
 	/* It supports additional host capabilities if needed */
diff --git a/drivers/mmc/host/tmio_mmc_pio.c b/drivers/mmc/host/tmio_mmc_pio.c
index 92467efc4..cb90505c3 100644
--- a/drivers/mmc/host/tmio_mmc_pio.c
+++ b/drivers/mmc/host/tmio_mmc_pio.c
@@ -1072,7 +1072,9 @@ int tmio_mmc_host_probe(struct tmio_mmc_host *_host,
 		goto host_free;
 	}
 
-	tmio_mmc_ops.start_signal_voltage_switch = _host->start_signal_voltage_switch;
+	pax_open_kernel();
+	const_cast(tmio_mmc_ops.start_signal_voltage_switch) = _host->start_signal_voltage_switch;
+	pax_close_kernel();
 	mmc->ops = &tmio_mmc_ops;
 
 	mmc->caps |= MMC_CAP_4_BIT_DATA | pdata->capabilities;
diff --git a/drivers/mtd/chips/cfi_cmdset_0020.c b/drivers/mtd/chips/cfi_cmdset_0020.c
index 94d3eb42c..7d342965f 100644
--- a/drivers/mtd/chips/cfi_cmdset_0020.c
+++ b/drivers/mtd/chips/cfi_cmdset_0020.c
@@ -666,7 +666,7 @@ cfi_staa_writev(struct mtd_info *mtd, const struct kvec *vecs,
 	size_t	 totlen = 0, thislen;
 	int	 ret = 0;
 	size_t	 buflen = 0;
-	static char *buffer;
+	char *buffer;
 
 	if (!ECCBUF_SIZE) {
 		/* We should fall back to a general writev implementation.
diff --git a/drivers/mtd/devices/block2mtd.c b/drivers/mtd/devices/block2mtd.c
index 7c887f111..62fd6905c 100644
--- a/drivers/mtd/devices/block2mtd.c
+++ b/drivers/mtd/devices/block2mtd.c
@@ -431,7 +431,7 @@ static int block2mtd_setup2(const char *val)
 }
 
 
-static int block2mtd_setup(const char *val, struct kernel_param *kp)
+static int block2mtd_setup(const char *val, const struct kernel_param *kp)
 {
 #ifdef MODULE
 	return block2mtd_setup2(val);
diff --git a/drivers/mtd/devices/phram.c b/drivers/mtd/devices/phram.c
index 8b66e52ca..7287696a2 100644
--- a/drivers/mtd/devices/phram.c
+++ b/drivers/mtd/devices/phram.c
@@ -266,7 +266,7 @@ static int phram_setup(const char *val)
 	return ret;
 }
 
-static int phram_param_call(const char *val, struct kernel_param *kp)
+static int phram_param_call(const char *val, const struct kernel_param *kp)
 {
 #ifdef MODULE
 	return phram_setup(val);
diff --git a/drivers/mtd/maps/gpio-addr-flash.c b/drivers/mtd/maps/gpio-addr-flash.c
index 385305e66..8051e876d 100644
--- a/drivers/mtd/maps/gpio-addr-flash.c
+++ b/drivers/mtd/maps/gpio-addr-flash.c
@@ -128,7 +128,7 @@ static void gf_copy_from(struct map_info *map, void *to, unsigned long from, ssi
  *	@map: MTD map state
  *	@ofs: desired offset to write
  */
-static void gf_write(struct map_info *map, map_word d1, unsigned long ofs)
+static void gf_write(struct map_info *map, const map_word d1, unsigned long ofs)
 {
 	struct async_state *state = gf_map_info_to_state(map);
 	uint16_t d;
diff --git a/drivers/mtd/maps/latch-addr-flash.c b/drivers/mtd/maps/latch-addr-flash.c
index 6dc97aa66..c251b90ed 100644
--- a/drivers/mtd/maps/latch-addr-flash.c
+++ b/drivers/mtd/maps/latch-addr-flash.c
@@ -52,7 +52,7 @@ static map_word lf_read(struct map_info *map, unsigned long ofs)
 	return datum;
 }
 
-static void lf_write(struct map_info *map, map_word datum, unsigned long ofs)
+static void lf_write(struct map_info *map, const map_word datum, unsigned long ofs)
 {
 	struct latch_addr_flash_info *info;
 
diff --git a/drivers/mtd/maps/pci.c b/drivers/mtd/maps/pci.c
index eb0242e0b..1a4c5b9dd 100644
--- a/drivers/mtd/maps/pci.c
+++ b/drivers/mtd/maps/pci.c
@@ -59,13 +59,13 @@ static void mtd_pci_copyfrom(struct map_info *_map, void *to, unsigned long from
 	memcpy_fromio(to, map->base + map->translate(map, from), len);
 }
 
-static void mtd_pci_write8(struct map_info *_map, map_word val, unsigned long ofs)
+static void mtd_pci_write8(struct map_info *_map, const map_word val, unsigned long ofs)
 {
 	struct map_pci_info *map = (struct map_pci_info *)_map;
 	writeb(val.x[0], map->base + map->translate(map, ofs));
 }
 
-static void mtd_pci_write32(struct map_info *_map, map_word val, unsigned long ofs)
+static void mtd_pci_write32(struct map_info *_map, const map_word val, unsigned long ofs)
 {
 	struct map_pci_info *map = (struct map_pci_info *)_map;
 	writel(val.x[0], map->base + map->translate(map, ofs));
diff --git a/drivers/mtd/maps/pcmciamtd.c b/drivers/mtd/maps/pcmciamtd.c
index 70bb403f6..3ae94c685 100644
--- a/drivers/mtd/maps/pcmciamtd.c
+++ b/drivers/mtd/maps/pcmciamtd.c
@@ -161,7 +161,7 @@ static void pcmcia_copy_from_remap(struct map_info *map, void *to, unsigned long
 }
 
 
-static void pcmcia_write8_remap(struct map_info *map, map_word d, unsigned long adr)
+static void pcmcia_write8_remap(struct map_info *map, const map_word d, unsigned long adr)
 {
 	void __iomem *addr = remap_window(map, adr);
 
@@ -173,7 +173,7 @@ static void pcmcia_write8_remap(struct map_info *map, map_word d, unsigned long
 }
 
 
-static void pcmcia_write16_remap(struct map_info *map, map_word d, unsigned long adr)
+static void pcmcia_write16_remap(struct map_info *map, const map_word d, unsigned long adr)
 {
 	void __iomem *addr = remap_window(map, adr);
 	if(!addr)
@@ -256,7 +256,7 @@ static void pcmcia_copy_from(struct map_info *map, void *to, unsigned long from,
 }
 
 
-static void pcmcia_write8(struct map_info *map, map_word d, unsigned long adr)
+static void pcmcia_write8(struct map_info *map, const map_word d, unsigned long adr)
 {
 	void __iomem *win_base = (void __iomem *)map->map_priv_2;
 
@@ -269,7 +269,7 @@ static void pcmcia_write8(struct map_info *map, map_word d, unsigned long adr)
 }
 
 
-static void pcmcia_write16(struct map_info *map, map_word d, unsigned long adr)
+static void pcmcia_write16(struct map_info *map, const map_word d, unsigned long adr)
 {
 	void __iomem *win_base = (void __iomem *)map->map_priv_2;
 
diff --git a/drivers/mtd/maps/sbc_gxx.c b/drivers/mtd/maps/sbc_gxx.c
index 556a2dfe9..e77132943 100644
--- a/drivers/mtd/maps/sbc_gxx.c
+++ b/drivers/mtd/maps/sbc_gxx.c
@@ -138,7 +138,7 @@ static void sbc_gxx_copy_from(struct map_info *map, void *to, unsigned long from
 	}
 }
 
-static void sbc_gxx_write8(struct map_info *map, map_word d, unsigned long adr)
+static void sbc_gxx_write8(struct map_info *map, const map_word d, unsigned long adr)
 {
 	spin_lock(&sbc_gxx_spin);
 	sbc_gxx_page(map, adr);
diff --git a/drivers/mtd/nand/brcmnand/bcm63138_nand.c b/drivers/mtd/nand/brcmnand/bcm63138_nand.c
index 59444b3a6..b8fd6d529 100644
--- a/drivers/mtd/nand/brcmnand/bcm63138_nand.c
+++ b/drivers/mtd/nand/brcmnand/bcm63138_nand.c
@@ -81,8 +81,10 @@ static int bcm63138_nand_probe(struct platform_device *pdev)
 	if (IS_ERR(priv->base))
 		return PTR_ERR(priv->base);
 
+	pax_open_kernel();
 	soc->ctlrdy_ack = bcm63138_nand_intc_ack;
 	soc->ctlrdy_set_enabled = bcm63138_nand_intc_set;
+	pax_close_kernel();
 
 	return brcmnand_probe(pdev, soc);
 }
diff --git a/drivers/mtd/nand/brcmnand/brcmnand.h b/drivers/mtd/nand/brcmnand/brcmnand.h
index ef5eabba8..2b61d030c 100644
--- a/drivers/mtd/nand/brcmnand/brcmnand.h
+++ b/drivers/mtd/nand/brcmnand/brcmnand.h
@@ -24,7 +24,7 @@ struct brcmnand_soc {
 	bool (*ctlrdy_ack)(struct brcmnand_soc *soc);
 	void (*ctlrdy_set_enabled)(struct brcmnand_soc *soc, bool en);
 	void (*prepare_data_bus)(struct brcmnand_soc *soc, bool prepare);
-};
+} __no_const;
 
 static inline void brcmnand_soc_data_bus_prepare(struct brcmnand_soc *soc)
 {
diff --git a/drivers/mtd/nand/brcmnand/iproc_nand.c b/drivers/mtd/nand/brcmnand/iproc_nand.c
index 585596c54..da877c207 100644
--- a/drivers/mtd/nand/brcmnand/iproc_nand.c
+++ b/drivers/mtd/nand/brcmnand/iproc_nand.c
@@ -120,9 +120,11 @@ static int iproc_nand_probe(struct platform_device *pdev)
 	if (IS_ERR(priv->ext_base))
 		return PTR_ERR(priv->ext_base);
 
+	pax_open_kernel();
 	soc->ctlrdy_ack = iproc_nand_intc_ack;
 	soc->ctlrdy_set_enabled = iproc_nand_intc_set;
 	soc->prepare_data_bus = iproc_nand_apb_access;
+	pax_close_kernel();
 
 	return brcmnand_probe(pdev, soc);
 }
diff --git a/drivers/mtd/nand/cafe_nand.c b/drivers/mtd/nand/cafe_nand.c
index 0b0c93702..e3a9cca4b 100644
--- a/drivers/mtd/nand/cafe_nand.c
+++ b/drivers/mtd/nand/cafe_nand.c
@@ -345,7 +345,17 @@ static irqreturn_t cafe_nand_interrupt(int irq, void *id)
 	return IRQ_HANDLED;
 }
 
-static void cafe_nand_bug(struct mtd_info *mtd)
+static void cafe_nand_bug_hwctl(struct mtd_info *mtd, int mode)
+{
+	BUG();
+}
+
+static int cafe_nand_bug_calculate(struct mtd_info *mtd, const uint8_t *dat, uint8_t *ecc_code)
+{
+	BUG();
+}
+
+static int cafe_nand_bug_correct(struct mtd_info *mtd, uint8_t *dat, uint8_t *read_ecc, uint8_t *calc_ecc)
 {
 	BUG();
 }
@@ -780,9 +790,9 @@ static int cafe_nand_probe(struct pci_dev *pdev,
 	cafe->nand.ecc.size = mtd->writesize;
 	cafe->nand.ecc.bytes = 14;
 	cafe->nand.ecc.strength = 4;
-	cafe->nand.ecc.hwctl  = (void *)cafe_nand_bug;
-	cafe->nand.ecc.calculate = (void *)cafe_nand_bug;
-	cafe->nand.ecc.correct  = (void *)cafe_nand_bug;
+	cafe->nand.ecc.hwctl  = cafe_nand_bug_hwctl;
+	cafe->nand.ecc.calculate = cafe_nand_bug_calculate;
+	cafe->nand.ecc.correct  = cafe_nand_bug_correct;
 	cafe->nand.ecc.write_page = cafe_nand_write_page_lowlevel;
 	cafe->nand.ecc.write_oob = cafe_nand_write_oob;
 	cafe->nand.ecc.read_page = cafe_nand_read_page;
diff --git a/drivers/mtd/nand/denali.c b/drivers/mtd/nand/denali.c
index 0476ae877..8d320ef65 100644
--- a/drivers/mtd/nand/denali.c
+++ b/drivers/mtd/nand/denali.c
@@ -24,6 +24,7 @@
 #include <linux/slab.h>
 #include <linux/mtd/mtd.h>
 #include <linux/module.h>
+#include <linux/slab.h>
 
 #include "denali.h"
 
diff --git a/drivers/mtd/nand/gpmi-nand/gpmi-nand.c b/drivers/mtd/nand/gpmi-nand/gpmi-nand.c
index 6e461560c..923c43660 100644
--- a/drivers/mtd/nand/gpmi-nand/gpmi-nand.c
+++ b/drivers/mtd/nand/gpmi-nand/gpmi-nand.c
@@ -414,7 +414,7 @@ void prepare_data_dma(struct gpmi_nand_data *this, enum dma_data_direction dr)
 
 	/* first try to map the upper buffer directly */
 	if (virt_addr_valid(this->upper_buf) &&
-		!object_is_on_stack(this->upper_buf)) {
+		!object_starts_on_stack(this->upper_buf)) {
 		sg_init_one(sgl, this->upper_buf, this->upper_len);
 		ret = dma_map_sg(this->dev, sgl, 1, dr);
 		if (ret == 0)
diff --git a/drivers/mtd/nftlmount.c b/drivers/mtd/nftlmount.c
index a5dfbfbeb..8042ab463 100644
--- a/drivers/mtd/nftlmount.c
+++ b/drivers/mtd/nftlmount.c
@@ -24,6 +24,7 @@
 #include <asm/errno.h>
 #include <linux/delay.h>
 #include <linux/slab.h>
+#include <linux/sched.h>
 #include <linux/mtd/mtd.h>
 #include <linux/mtd/nand.h>
 #include <linux/mtd/nftl.h>
diff --git a/drivers/mtd/sm_ftl.c b/drivers/mtd/sm_ftl.c
index 3692dd547..b731a9b44 100644
--- a/drivers/mtd/sm_ftl.c
+++ b/drivers/mtd/sm_ftl.c
@@ -56,7 +56,7 @@ static ssize_t sm_attr_show(struct device *dev, struct device_attribute *attr,
 #define SM_CIS_VENDOR_OFFSET 0x59
 static struct attribute_group *sm_create_sysfs_attributes(struct sm_ftl *ftl)
 {
-	struct attribute_group *attr_group;
+	attribute_group_no_const *attr_group;
 	struct attribute **attributes;
 	struct sm_sysfs_attribute *vendor_attribute;
 	char *vendor;
diff --git a/drivers/mtd/ubi/build.c b/drivers/mtd/ubi/build.c
index 0680516bb..eb890f312 100644
--- a/drivers/mtd/ubi/build.c
+++ b/drivers/mtd/ubi/build.c
@@ -1389,7 +1389,7 @@ static int __init bytes_str_to_int(const char *str)
  * This function returns zero in case of success and a negative error code in
  * case of error.
  */
-static int __init ubi_mtd_param_parse(const char *val, struct kernel_param *kp)
+static int __init ubi_mtd_param_parse(const char *val, const struct kernel_param *kp)
 {
 	int i, len;
 	struct mtd_dev_param *p;
diff --git a/drivers/net/bonding/bond_netlink.c b/drivers/net/bonding/bond_netlink.c
index b8df0f5e8..0d64b6e69 100644
--- a/drivers/net/bonding/bond_netlink.c
+++ b/drivers/net/bonding/bond_netlink.c
@@ -666,7 +666,7 @@ nla_put_failure:
 	return -EMSGSIZE;
 }
 
-struct rtnl_link_ops bond_link_ops __read_mostly = {
+struct rtnl_link_ops bond_link_ops = {
 	.kind			= "bond",
 	.priv_size		= sizeof(struct bonding),
 	.setup			= bond_setup,
diff --git a/drivers/net/caif/caif_hsi.c b/drivers/net/caif/caif_hsi.c
index ddabce759..6583c2948 100644
--- a/drivers/net/caif/caif_hsi.c
+++ b/drivers/net/caif/caif_hsi.c
@@ -1011,7 +1011,7 @@ static void cfhsi_aggregation_tout(unsigned long arg)
 	cfhsi_start_tx(cfhsi);
 }
 
-static int cfhsi_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t cfhsi_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct cfhsi *cfhsi = NULL;
 	int start_xfer = 0;
@@ -1441,7 +1441,7 @@ err:
 	return -ENODEV;
 }
 
-static struct rtnl_link_ops caif_hsi_link_ops __read_mostly = {
+static struct rtnl_link_ops caif_hsi_link_ops = {
 	.kind		= "cfhsi",
 	.priv_size	= sizeof(struct cfhsi),
 	.setup		= cfhsi_setup,
diff --git a/drivers/net/caif/caif_serial.c b/drivers/net/caif/caif_serial.c
index c2dea4916..4bf83b56c 100644
--- a/drivers/net/caif/caif_serial.c
+++ b/drivers/net/caif/caif_serial.c
@@ -277,7 +277,7 @@ error:
 	return tty_wr;
 }
 
-static int caif_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t caif_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct ser_device *ser;
 
diff --git a/drivers/net/caif/caif_spi.c b/drivers/net/caif/caif_spi.c
index 3a529fbe5..c55ad5e10 100644
--- a/drivers/net/caif/caif_spi.c
+++ b/drivers/net/caif/caif_spi.c
@@ -486,7 +486,7 @@ static void cfspi_xfer_done_cb(struct cfspi_ifc *ifc)
 	complete(&cfspi->comp);
 }
 
-static int cfspi_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t cfspi_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct cfspi *cfspi = NULL;
 	unsigned long flags;
diff --git a/drivers/net/caif/caif_virtio.c b/drivers/net/caif/caif_virtio.c
index b306210b0..c5345de11 100644
--- a/drivers/net/caif/caif_virtio.c
+++ b/drivers/net/caif/caif_virtio.c
@@ -519,7 +519,7 @@ err:
 }
 
 /* Put the CAIF packet on the virtio ring and kick the receiver */
-static int cfv_netdev_tx(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t cfv_netdev_tx(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct cfv_info *cfv = netdev_priv(netdev);
 	struct buf_info *buf_info;
diff --git a/drivers/net/can/Kconfig b/drivers/net/can/Kconfig
index 22570ea3a..c46237572 100644
--- a/drivers/net/can/Kconfig
+++ b/drivers/net/can/Kconfig
@@ -81,7 +81,7 @@ config CAN_BFIN
 
 config CAN_FLEXCAN
 	tristate "Support for Freescale FLEXCAN based chips"
-	depends on ARM || PPC
+	depends on (ARM && CPU_LITTLE_ENDIAN) || PPC
 	---help---
 	  Say Y here if you want to support for Freescale FlexCAN.
 
diff --git a/drivers/net/can/bfin_can.c b/drivers/net/can/bfin_can.c
index 1deb8ff90..4e2b0c153 100644
--- a/drivers/net/can/bfin_can.c
+++ b/drivers/net/can/bfin_can.c
@@ -338,7 +338,7 @@ static int bfin_can_get_berr_counter(const struct net_device *dev,
 	return 0;
 }
 
-static int bfin_can_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t bfin_can_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct bfin_can_priv *priv = netdev_priv(dev);
 	struct bfin_can_regs __iomem *reg = priv->membase;
diff --git a/drivers/net/can/dev.c b/drivers/net/can/dev.c
index 8d6208c0b..7731e3c09 100644
--- a/drivers/net/can/dev.c
+++ b/drivers/net/can/dev.c
@@ -1053,7 +1053,7 @@ static void can_dellink(struct net_device *dev, struct list_head *head)
 	return;
 }
 
-static struct rtnl_link_ops can_link_ops __read_mostly = {
+static struct rtnl_link_ops can_link_ops = {
 	.kind		= "can",
 	.maxtype	= IFLA_CAN_MAX,
 	.policy		= can_policy,
diff --git a/drivers/net/can/flexcan.c b/drivers/net/can/flexcan.c
index 16f7cadda..e643cf45e 100644
--- a/drivers/net/can/flexcan.c
+++ b/drivers/net/can/flexcan.c
@@ -465,7 +465,7 @@ static int flexcan_get_berr_counter(const struct net_device *dev,
 	return err;
 }
 
-static int flexcan_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t flexcan_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	const struct flexcan_priv *priv = netdev_priv(dev);
 	struct flexcan_regs __iomem *regs = priv->regs;
diff --git a/drivers/net/can/janz-ican3.c b/drivers/net/can/janz-ican3.c
index f13bb8d9b..26e4a4406 100644
--- a/drivers/net/can/janz-ican3.c
+++ b/drivers/net/can/janz-ican3.c
@@ -1684,7 +1684,7 @@ static int ican3_stop(struct net_device *ndev)
 	return 0;
 }
 
-static int ican3_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t ican3_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct ican3_dev *mod = netdev_priv(ndev);
 	struct can_frame *cf = (struct can_frame *)skb->data;
diff --git a/drivers/net/can/led.c b/drivers/net/can/led.c
index c1b667675..50a8a51f9 100644
--- a/drivers/net/can/led.c
+++ b/drivers/net/can/led.c
@@ -128,7 +128,7 @@ static int can_led_notifier(struct notifier_block *nb, unsigned long msg,
 }
 
 /* notifier block for netdevice event */
-static struct notifier_block can_netdev_notifier __read_mostly = {
+static struct notifier_block can_netdev_notifier = {
 	.notifier_call = can_led_notifier,
 };
 
diff --git a/drivers/net/can/sun4i_can.c b/drivers/net/can/sun4i_can.c
index 68ef0a4cd..9e4938b30 100644
--- a/drivers/net/can/sun4i_can.c
+++ b/drivers/net/can/sun4i_can.c
@@ -409,7 +409,7 @@ static int sun4ican_set_mode(struct net_device *dev, enum can_mode mode)
  * xx xx xx xx         ff         ll 00 11 22 33 44 55 66 77
  * [ can_id ] [flags] [len] [can data (up to 8 bytes]
  */
-static int sun4ican_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t sun4ican_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct sun4ican_priv *priv = netdev_priv(dev);
 	struct can_frame *cf = (struct can_frame *)skb->data;
diff --git a/drivers/net/can/vcan.c b/drivers/net/can/vcan.c
index 674f36708..ec3a31f43 100644
--- a/drivers/net/can/vcan.c
+++ b/drivers/net/can/vcan.c
@@ -163,7 +163,7 @@ static void vcan_setup(struct net_device *dev)
 	dev->destructor		= free_netdev;
 }
 
-static struct rtnl_link_ops vcan_link_ops __read_mostly = {
+static struct rtnl_link_ops vcan_link_ops = {
 	.kind	= "vcan",
 	.setup	= vcan_setup,
 };
diff --git a/drivers/net/can/xilinx_can.c b/drivers/net/can/xilinx_can.c
index c71a03593..08768cec4 100644
--- a/drivers/net/can/xilinx_can.c
+++ b/drivers/net/can/xilinx_can.c
@@ -386,7 +386,7 @@ static int xcan_do_set_mode(struct net_device *ndev, enum can_mode mode)
  *
  * Return: 0 on success and failure value on error
  */
-static int xcan_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t xcan_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct xcan_priv *priv = netdev_priv(ndev);
 	struct net_device_stats *stats = &ndev->stats;
diff --git a/drivers/net/dummy.c b/drivers/net/dummy.c
index 69fc8409a..77a32fc0f 100644
--- a/drivers/net/dummy.c
+++ b/drivers/net/dummy.c
@@ -167,7 +167,7 @@ static int dummy_validate(struct nlattr *tb[], struct nlattr *data[])
 	return 0;
 }
 
-static struct rtnl_link_ops dummy_link_ops __read_mostly = {
+static struct rtnl_link_ops dummy_link_ops = {
 	.kind		= DRV_NAME,
 	.setup		= dummy_setup,
 	.validate	= dummy_validate,
diff --git a/drivers/net/ethernet/8390/ax88796.c b/drivers/net/ethernet/8390/ax88796.c
index 39ca9350d..bd14a10c8 100644
--- a/drivers/net/ethernet/8390/ax88796.c
+++ b/drivers/net/ethernet/8390/ax88796.c
@@ -808,7 +808,7 @@ static int ax_probe(struct platform_device *pdev)
 	struct ei_device *ei_local;
 	struct ax_device *ax;
 	struct resource *irq, *mem, *mem2;
-	unsigned long mem_size, mem2_size = 0;
+	resource_size_t mem_size, mem2_size = 0;
 	int ret = 0;
 
 	dev = ax__alloc_ei_netdev(sizeof(struct ax_device));
@@ -852,9 +852,11 @@ static int ax_probe(struct platform_device *pdev)
 	if (ax->plat->reg_offsets)
 		ei_local->reg_offset = ax->plat->reg_offsets;
 	else {
+		resource_size_t _mem_size = mem_size;
+		_mem_size /= 0x18;
 		ei_local->reg_offset = ax->reg_offsets;
 		for (ret = 0; ret < 0x18; ret++)
-			ax->reg_offsets[ret] = (mem_size / 0x18) * ret;
+			ax->reg_offsets[ret] = _mem_size * ret;
 	}
 
 	if (!request_mem_region(mem->start, mem_size, pdev->name)) {
diff --git a/drivers/net/ethernet/8390/axnet_cs.c b/drivers/net/ethernet/8390/axnet_cs.c
index 4ea717d68..549ae6911 100644
--- a/drivers/net/ethernet/8390/axnet_cs.c
+++ b/drivers/net/ethernet/8390/axnet_cs.c
@@ -96,7 +96,7 @@ static void get_8390_hdr(struct net_device *,
 static void block_input(struct net_device *dev, int count,
 			struct sk_buff *skb, int ring_offset);
 static void block_output(struct net_device *dev, int count,
-			 const u_char *buf, const int start_page);
+			 const u_char *buf, int start_page);
 
 static void axnet_detach(struct pcmcia_device *p_dev);
 
@@ -667,7 +667,7 @@ static void block_input(struct net_device *dev, int count,
 /*====================================================================*/
 
 static void block_output(struct net_device *dev, int count,
-			 const u_char *buf, const int start_page)
+			 const u_char *buf, int start_page)
 {
     unsigned int nic_base = dev->base_addr;
 
diff --git a/drivers/net/ethernet/8390/ne2k-pci.c b/drivers/net/ethernet/8390/ne2k-pci.c
index 57e97910c..c93b6a03a 100644
--- a/drivers/net/ethernet/8390/ne2k-pci.c
+++ b/drivers/net/ethernet/8390/ne2k-pci.c
@@ -172,8 +172,8 @@ static void ne2k_pci_get_8390_hdr(struct net_device *dev, struct e8390_pkt_hdr *
 			  int ring_page);
 static void ne2k_pci_block_input(struct net_device *dev, int count,
 			  struct sk_buff *skb, int ring_offset);
-static void ne2k_pci_block_output(struct net_device *dev, const int count,
-		const unsigned char *buf, const int start_page);
+static void ne2k_pci_block_output(struct net_device *dev, int count,
+		const unsigned char *buf, int start_page);
 static const struct ethtool_ops ne2k_pci_ethtool_ops;
 
 
@@ -563,7 +563,7 @@ static void ne2k_pci_block_input(struct net_device *dev, int count,
 }
 
 static void ne2k_pci_block_output(struct net_device *dev, int count,
-				  const unsigned char *buf, const int start_page)
+				  const unsigned char *buf, int start_page)
 {
 	long nic_base = NE_BASE;
 	unsigned long dma_start;
diff --git a/drivers/net/ethernet/8390/pcnet_cs.c b/drivers/net/ethernet/8390/pcnet_cs.c
index 2f79d29f1..ed5a64e05 100644
--- a/drivers/net/ethernet/8390/pcnet_cs.c
+++ b/drivers/net/ethernet/8390/pcnet_cs.c
@@ -1208,7 +1208,7 @@ static void dma_block_input(struct net_device *dev, int count,
 /*====================================================================*/
 
 static void dma_block_output(struct net_device *dev, int count,
-			     const u_char *buf, const int start_page)
+			     const u_char *buf, int start_page)
 {
     unsigned int nic_base = dev->base_addr;
     struct pcnet_dev *info = PRIV(dev);
@@ -1387,7 +1387,7 @@ static void shmem_block_input(struct net_device *dev, int count,
 /*====================================================================*/
 
 static void shmem_block_output(struct net_device *dev, int count,
-			       const u_char *buf, const int start_page)
+			       const u_char *buf, int start_page)
 {
     void __iomem *shmem = ei_status.mem + (start_page << 8);
     shmem -= ei_status.tx_start_page << 8;
diff --git a/drivers/net/ethernet/adi/bfin_mac.c b/drivers/net/ethernet/adi/bfin_mac.c
index 38eaea18d..49e5aaaab 100644
--- a/drivers/net/ethernet/adi/bfin_mac.c
+++ b/drivers/net/ethernet/adi/bfin_mac.c
@@ -1097,7 +1097,7 @@ static void tx_reclaim_skb_timeout(unsigned long lp)
 	tx_reclaim_skb((struct bfin_mac_local *)lp);
 }
 
-static int bfin_mac_hard_start_xmit(struct sk_buff *skb,
+static netdev_tx_t bfin_mac_hard_start_xmit(struct sk_buff *skb,
 				struct net_device *dev)
 {
 	struct bfin_mac_local *lp = netdev_priv(dev);
diff --git a/drivers/net/ethernet/allwinner/sun4i-emac.c b/drivers/net/ethernet/allwinner/sun4i-emac.c
index 6ffdff68b..8b96f60a4 100644
--- a/drivers/net/ethernet/allwinner/sun4i-emac.c
+++ b/drivers/net/ethernet/allwinner/sun4i-emac.c
@@ -412,7 +412,7 @@ static void emac_timeout(struct net_device *dev)
 /* Hardware start transmission.
  * Send a packet to media from the upper layer.
  */
-static int emac_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t emac_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct emac_board_info *db = netdev_priv(dev);
 	unsigned long channel;
diff --git a/drivers/net/ethernet/altera/altera_tse_main.c b/drivers/net/ethernet/altera/altera_tse_main.c
index bda31f308..55cfc6eb8 100644
--- a/drivers/net/ethernet/altera/altera_tse_main.c
+++ b/drivers/net/ethernet/altera/altera_tse_main.c
@@ -551,7 +551,7 @@ static irqreturn_t altera_isr(int irq, void *dev_id)
  * physically contiguous fragment starting at
  * skb->data, for length of skb_headlen(skb).
  */
-static int tse_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t tse_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct altera_tse_private *priv = netdev_priv(dev);
 	unsigned int txsize = priv->tx_ring_size;
@@ -1243,7 +1243,7 @@ static int tse_shutdown(struct net_device *dev)
 	return 0;
 }
 
-static struct net_device_ops altera_tse_netdev_ops = {
+static net_device_ops_no_const altera_tse_netdev_ops __read_only = {
 	.ndo_open		= tse_open,
 	.ndo_stop		= tse_shutdown,
 	.ndo_start_xmit		= tse_start_xmit,
@@ -1480,11 +1480,13 @@ static int altera_tse_probe(struct platform_device *pdev)
 	ndev->netdev_ops = &altera_tse_netdev_ops;
 	altera_tse_set_ethtool_ops(ndev);
 
+	pax_open_kernel();
 	altera_tse_netdev_ops.ndo_set_rx_mode = tse_set_rx_mode;
 
 	if (priv->hash_filter)
 		altera_tse_netdev_ops.ndo_set_rx_mode =
 			tse_set_rx_mode_hashfilter;
+	pax_close_kernel();
 
 	/* Scatter/gather IO is not supported,
 	 * so it is turned off
diff --git a/drivers/net/ethernet/amd/7990.c b/drivers/net/ethernet/amd/7990.c
index dcf2a1f36..ec0c78246 100644
--- a/drivers/net/ethernet/amd/7990.c
+++ b/drivers/net/ethernet/amd/7990.c
@@ -535,7 +535,7 @@ void lance_tx_timeout(struct net_device *dev)
 }
 EXPORT_SYMBOL_GPL(lance_tx_timeout);
 
-int lance_start_xmit(struct sk_buff *skb, struct net_device *dev)
+netdev_tx_t lance_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct lance_private *lp = netdev_priv(dev);
 	volatile struct lance_init_block *ib = lp->init_block;
diff --git a/drivers/net/ethernet/amd/7990.h b/drivers/net/ethernet/amd/7990.h
index e9e0be313..1b8e3af93 100644
--- a/drivers/net/ethernet/amd/7990.h
+++ b/drivers/net/ethernet/amd/7990.h
@@ -240,7 +240,7 @@ struct lance_private {
 /* Now the prototypes we export */
 int lance_open(struct net_device *dev);
 int lance_close(struct net_device *dev);
-int lance_start_xmit(struct sk_buff *skb, struct net_device *dev);
+netdev_tx_t lance_start_xmit(struct sk_buff *skb, struct net_device *dev);
 void lance_set_multicast(struct net_device *dev);
 void lance_tx_timeout(struct net_device *dev);
 #ifdef CONFIG_NET_POLL_CONTROLLER
diff --git a/drivers/net/ethernet/amd/amd8111e.c b/drivers/net/ethernet/amd/amd8111e.c
index 94960055f..1fb7ac29b 100644
--- a/drivers/net/ethernet/amd/amd8111e.c
+++ b/drivers/net/ethernet/amd/amd8111e.c
@@ -1690,8 +1690,9 @@ static int amd8111e_resume(struct pci_dev *pci_dev)
 	return 0;
 }
 
-static void amd8111e_config_ipg(struct net_device *dev)
+static void amd8111e_config_ipg(unsigned long _dev)
 {
+	struct net_device *dev = (struct net_device *)_dev;
 	struct amd8111e_priv *lp = netdev_priv(dev);
 	struct ipg_info *ipg_data = &lp->ipg_data;
 	void __iomem *mmio = lp->mmio;
@@ -1904,7 +1905,7 @@ static int amd8111e_probe_one(struct pci_dev *pdev,
 	if(lp->options & OPTION_DYN_IPG_ENABLE){
 		init_timer(&lp->ipg_data.ipg_timer);
 		lp->ipg_data.ipg_timer.data = (unsigned long) dev;
-		lp->ipg_data.ipg_timer.function = (void *)&amd8111e_config_ipg;
+		lp->ipg_data.ipg_timer.function = &amd8111e_config_ipg;
 		lp->ipg_data.ipg_timer.expires = jiffies +
 						 IPG_CONVERGE_JIFFIES;
 		lp->ipg_data.ipg = DEFAULT_IPG;
diff --git a/drivers/net/ethernet/amd/atarilance.c b/drivers/net/ethernet/amd/atarilance.c
index d2bc8e5dc..2285a75d4 100644
--- a/drivers/net/ethernet/amd/atarilance.c
+++ b/drivers/net/ethernet/amd/atarilance.c
@@ -339,7 +339,7 @@ static unsigned long lance_probe1( struct net_device *dev, struct lance_addr
                                    *init_rec );
 static int lance_open( struct net_device *dev );
 static void lance_init_ring( struct net_device *dev );
-static int lance_start_xmit( struct sk_buff *skb, struct net_device *dev );
+static netdev_tx_t lance_start_xmit( struct sk_buff *skb, struct net_device *dev );
 static irqreturn_t lance_interrupt( int irq, void *dev_id );
 static int lance_rx( struct net_device *dev );
 static int lance_close( struct net_device *dev );
@@ -770,7 +770,7 @@ static void lance_tx_timeout (struct net_device *dev)
 
 /* XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX */
 
-static int lance_start_xmit( struct sk_buff *skb, struct net_device *dev )
+static netdev_tx_t lance_start_xmit( struct sk_buff *skb, struct net_device *dev )
 {
 	struct lance_private *lp = netdev_priv(dev);
 	struct lance_ioreg	 *IO = lp->iobase;
diff --git a/drivers/net/ethernet/amd/declance.c b/drivers/net/ethernet/amd/declance.c
index b799c7ac8..58bd5b38b 100644
--- a/drivers/net/ethernet/amd/declance.c
+++ b/drivers/net/ethernet/amd/declance.c
@@ -893,7 +893,7 @@ static void lance_tx_timeout(struct net_device *dev)
 	netif_wake_queue(dev);
 }
 
-static int lance_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t lance_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct lance_private *lp = netdev_priv(dev);
 	volatile struct lance_regs *ll = lp->ll;
diff --git a/drivers/net/ethernet/amd/pcnet32.c b/drivers/net/ethernet/amd/pcnet32.c
index c22bf52d3..a83f5f63c 100644
--- a/drivers/net/ethernet/amd/pcnet32.c
+++ b/drivers/net/ethernet/amd/pcnet32.c
@@ -318,7 +318,7 @@ static struct net_device_stats *pcnet32_get_stats(struct net_device *);
 static void pcnet32_load_multicast(struct net_device *dev);
 static void pcnet32_set_multicast_list(struct net_device *);
 static int pcnet32_ioctl(struct net_device *, struct ifreq *, int);
-static void pcnet32_watchdog(struct net_device *);
+static void pcnet32_watchdog(unsigned long);
 static int mdio_read(struct net_device *dev, int phy_id, int reg_num);
 static void mdio_write(struct net_device *dev, int phy_id, int reg_num,
 		       int val);
@@ -1915,7 +1915,7 @@ pcnet32_probe1(unsigned long ioaddr, int shared, struct pci_dev *pdev)
 
 	init_timer(&lp->watchdog_timer);
 	lp->watchdog_timer.data = (unsigned long)dev;
-	lp->watchdog_timer.function = (void *)&pcnet32_watchdog;
+	lp->watchdog_timer.function = &pcnet32_watchdog;
 
 	/* The PCNET32-specific entries in the device structure. */
 	dev->netdev_ops = &pcnet32_netdev_ops;
@@ -2837,8 +2837,9 @@ static void pcnet32_check_media(struct net_device *dev, int verbose)
  * Could possibly be changed to use mii_check_media instead.
  */
 
-static void pcnet32_watchdog(struct net_device *dev)
+static void pcnet32_watchdog(unsigned long _dev)
 {
+	struct net_device *dev = (struct net_device *)_dev;
 	struct pcnet32_private *lp = netdev_priv(dev);
 	unsigned long flags;
 
diff --git a/drivers/net/ethernet/amd/sun3lance.c b/drivers/net/ethernet/amd/sun3lance.c
index 3d8c6b2cd..35160ad4e 100644
--- a/drivers/net/ethernet/amd/sun3lance.c
+++ b/drivers/net/ethernet/amd/sun3lance.c
@@ -235,7 +235,7 @@ struct lance_private {
 static int lance_probe( struct net_device *dev);
 static int lance_open( struct net_device *dev );
 static void lance_init_ring( struct net_device *dev );
-static int lance_start_xmit( struct sk_buff *skb, struct net_device *dev );
+static netdev_tx_t lance_start_xmit( struct sk_buff *skb, struct net_device *dev );
 static irqreturn_t lance_interrupt( int irq, void *dev_id);
 static int lance_rx( struct net_device *dev );
 static int lance_close( struct net_device *dev );
@@ -511,7 +511,7 @@ static void lance_init_ring( struct net_device *dev )
 }
 
 
-static int lance_start_xmit( struct sk_buff *skb, struct net_device *dev )
+static netdev_tx_t lance_start_xmit( struct sk_buff *skb, struct net_device *dev )
 {
 	struct lance_private *lp = netdev_priv(dev);
 	int entry, len;
diff --git a/drivers/net/ethernet/amd/sunlance.c b/drivers/net/ethernet/amd/sunlance.c
index 9b56b4025..f183a4d4d 100644
--- a/drivers/net/ethernet/amd/sunlance.c
+++ b/drivers/net/ethernet/amd/sunlance.c
@@ -1106,7 +1106,7 @@ static void lance_tx_timeout(struct net_device *dev)
 	netif_wake_queue(dev);
 }
 
-static int lance_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t lance_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct lance_private *lp = netdev_priv(dev);
 	int entry, skblen, len;
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-common.h b/drivers/net/ethernet/amd/xgbe/xgbe-common.h
index bbef95973..999ab1d1b 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-common.h
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-common.h
@@ -1283,14 +1283,14 @@ do {									\
  * operations, everything works on mask values.
  */
 #define XMDIO_READ(_pdata, _mmd, _reg)					\
-	((_pdata)->hw_if.read_mmd_regs((_pdata), 0,			\
+	((_pdata)->hw_if->read_mmd_regs((_pdata), 0,			\
 		MII_ADDR_C45 | (_mmd << 16) | ((_reg) & 0xffff)))
 
 #define XMDIO_READ_BITS(_pdata, _mmd, _reg, _mask)			\
 	(XMDIO_READ((_pdata), _mmd, _reg) & _mask)
 
 #define XMDIO_WRITE(_pdata, _mmd, _reg, _val)				\
-	((_pdata)->hw_if.write_mmd_regs((_pdata), 0,			\
+	((_pdata)->hw_if->write_mmd_regs((_pdata), 0,			\
 		MII_ADDR_C45 | (_mmd << 16) | ((_reg) & 0xffff), (_val)))
 
 #define XMDIO_WRITE_BITS(_pdata, _mmd, _reg, _mask, _val)		\
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-dcb.c b/drivers/net/ethernet/amd/xgbe/xgbe-dcb.c
index 895d35639..b1c866e60 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-dcb.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-dcb.c
@@ -202,7 +202,7 @@ static int xgbe_dcb_ieee_setets(struct net_device *netdev,
 	pdata->num_tcs = max_tc + 1;
 	memcpy(pdata->ets, ets, sizeof(*pdata->ets));
 
-	pdata->hw_if.config_dcb_tc(pdata);
+	pdata->hw_if->config_dcb_tc(pdata);
 
 	return 0;
 }
@@ -249,7 +249,7 @@ static int xgbe_dcb_ieee_setpfc(struct net_device *netdev,
 
 	memcpy(pdata->pfc, pfc, sizeof(*pdata->pfc));
 
-	pdata->hw_if.config_dcb_pfc(pdata);
+	pdata->hw_if->config_dcb_pfc(pdata);
 
 	return 0;
 }
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-desc.c b/drivers/net/ethernet/amd/xgbe/xgbe-desc.c
index b3bc87fe3..5bdfdd34a 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-desc.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-desc.c
@@ -353,7 +353,7 @@ static int xgbe_map_rx_buffer(struct xgbe_prv_data *pdata,
 
 static void xgbe_wrapper_tx_descriptor_init(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	struct xgbe_channel *channel;
 	struct xgbe_ring *ring;
 	struct xgbe_ring_data *rdata;
@@ -394,7 +394,7 @@ static void xgbe_wrapper_tx_descriptor_init(struct xgbe_prv_data *pdata)
 
 static void xgbe_wrapper_rx_descriptor_init(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	struct xgbe_channel *channel;
 	struct xgbe_ring *ring;
 	struct xgbe_ring_desc *rdesc;
@@ -628,17 +628,12 @@ err_out:
 	return 0;
 }
 
-void xgbe_init_function_ptrs_desc(struct xgbe_desc_if *desc_if)
-{
-	DBGPR("-->xgbe_init_function_ptrs_desc\n");
-
-	desc_if->alloc_ring_resources = xgbe_alloc_ring_resources;
-	desc_if->free_ring_resources = xgbe_free_ring_resources;
-	desc_if->map_tx_skb = xgbe_map_tx_skb;
-	desc_if->map_rx_buffer = xgbe_map_rx_buffer;
-	desc_if->unmap_rdata = xgbe_unmap_rdata;
-	desc_if->wrapper_tx_desc_init = xgbe_wrapper_tx_descriptor_init;
-	desc_if->wrapper_rx_desc_init = xgbe_wrapper_rx_descriptor_init;
-
-	DBGPR("<--xgbe_init_function_ptrs_desc\n");
-}
+const struct xgbe_desc_if default_xgbe_desc_if = {
+	.alloc_ring_resources = xgbe_alloc_ring_resources,
+	.free_ring_resources = xgbe_free_ring_resources,
+	.map_tx_skb = xgbe_map_tx_skb,
+	.map_rx_buffer = xgbe_map_rx_buffer,
+	.unmap_rdata = xgbe_unmap_rdata,
+	.wrapper_tx_desc_init = xgbe_wrapper_tx_descriptor_init,
+	.wrapper_rx_desc_init = xgbe_wrapper_rx_descriptor_init,
+};
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-dev.c b/drivers/net/ethernet/amd/xgbe/xgbe-dev.c
index 1babcc11a..aa7f8f4ee 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-dev.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-dev.c
@@ -2816,7 +2816,7 @@ static void xgbe_powerdown_rx(struct xgbe_prv_data *pdata)
 
 static int xgbe_init(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 	int ret;
 
 	DBGPR("-->xgbe_init\n");
@@ -2882,107 +2882,102 @@ static int xgbe_init(struct xgbe_prv_data *pdata)
 	return 0;
 }
 
-void xgbe_init_function_ptrs_dev(struct xgbe_hw_if *hw_if)
-{
-	DBGPR("-->xgbe_init_function_ptrs\n");
-
-	hw_if->tx_complete = xgbe_tx_complete;
+const struct xgbe_hw_if default_xgbe_hw_if = {
+	.tx_complete = xgbe_tx_complete,
 
-	hw_if->set_mac_address = xgbe_set_mac_address;
-	hw_if->config_rx_mode = xgbe_config_rx_mode;
+	.set_mac_address = xgbe_set_mac_address,
+	.config_rx_mode = xgbe_config_rx_mode,
 
-	hw_if->enable_rx_csum = xgbe_enable_rx_csum;
-	hw_if->disable_rx_csum = xgbe_disable_rx_csum;
+	.enable_rx_csum = xgbe_enable_rx_csum,
+	.disable_rx_csum = xgbe_disable_rx_csum,
 
-	hw_if->enable_rx_vlan_stripping = xgbe_enable_rx_vlan_stripping;
-	hw_if->disable_rx_vlan_stripping = xgbe_disable_rx_vlan_stripping;
-	hw_if->enable_rx_vlan_filtering = xgbe_enable_rx_vlan_filtering;
-	hw_if->disable_rx_vlan_filtering = xgbe_disable_rx_vlan_filtering;
-	hw_if->update_vlan_hash_table = xgbe_update_vlan_hash_table;
+	.enable_rx_vlan_stripping = xgbe_enable_rx_vlan_stripping,
+	.disable_rx_vlan_stripping = xgbe_disable_rx_vlan_stripping,
+	.enable_rx_vlan_filtering = xgbe_enable_rx_vlan_filtering,
+	.disable_rx_vlan_filtering = xgbe_disable_rx_vlan_filtering,
+	.update_vlan_hash_table = xgbe_update_vlan_hash_table,
 
-	hw_if->read_mmd_regs = xgbe_read_mmd_regs;
-	hw_if->write_mmd_regs = xgbe_write_mmd_regs;
+	.read_mmd_regs = xgbe_read_mmd_regs,
+	.write_mmd_regs = xgbe_write_mmd_regs,
 
-	hw_if->set_gmii_speed = xgbe_set_gmii_speed;
-	hw_if->set_gmii_2500_speed = xgbe_set_gmii_2500_speed;
-	hw_if->set_xgmii_speed = xgbe_set_xgmii_speed;
+	.set_gmii_speed = xgbe_set_gmii_speed,
+	.set_gmii_2500_speed = xgbe_set_gmii_2500_speed,
+	.set_xgmii_speed = xgbe_set_xgmii_speed,
 
-	hw_if->enable_tx = xgbe_enable_tx;
-	hw_if->disable_tx = xgbe_disable_tx;
-	hw_if->enable_rx = xgbe_enable_rx;
-	hw_if->disable_rx = xgbe_disable_rx;
+	.enable_tx = xgbe_enable_tx,
+	.disable_tx = xgbe_disable_tx,
+	.enable_rx = xgbe_enable_rx,
+	.disable_rx = xgbe_disable_rx,
 
-	hw_if->powerup_tx = xgbe_powerup_tx;
-	hw_if->powerdown_tx = xgbe_powerdown_tx;
-	hw_if->powerup_rx = xgbe_powerup_rx;
-	hw_if->powerdown_rx = xgbe_powerdown_rx;
+	.powerup_tx = xgbe_powerup_tx,
+	.powerdown_tx = xgbe_powerdown_tx,
+	.powerup_rx = xgbe_powerup_rx,
+	.powerdown_rx = xgbe_powerdown_rx,
 
-	hw_if->dev_xmit = xgbe_dev_xmit;
-	hw_if->dev_read = xgbe_dev_read;
-	hw_if->enable_int = xgbe_enable_int;
-	hw_if->disable_int = xgbe_disable_int;
-	hw_if->init = xgbe_init;
-	hw_if->exit = xgbe_exit;
+	.dev_xmit = xgbe_dev_xmit,
+	.dev_read = xgbe_dev_read,
+	.enable_int = xgbe_enable_int,
+	.disable_int = xgbe_disable_int,
+	.init = xgbe_init,
+	.exit = xgbe_exit,
 
 	/* Descriptor related Sequences have to be initialized here */
-	hw_if->tx_desc_init = xgbe_tx_desc_init;
-	hw_if->rx_desc_init = xgbe_rx_desc_init;
-	hw_if->tx_desc_reset = xgbe_tx_desc_reset;
-	hw_if->rx_desc_reset = xgbe_rx_desc_reset;
-	hw_if->is_last_desc = xgbe_is_last_desc;
-	hw_if->is_context_desc = xgbe_is_context_desc;
-	hw_if->tx_start_xmit = xgbe_tx_start_xmit;
+	.tx_desc_init = xgbe_tx_desc_init,
+	.rx_desc_init = xgbe_rx_desc_init,
+	.tx_desc_reset = xgbe_tx_desc_reset,
+	.rx_desc_reset = xgbe_rx_desc_reset,
+	.is_last_desc = xgbe_is_last_desc,
+	.is_context_desc = xgbe_is_context_desc,
+	.tx_start_xmit = xgbe_tx_start_xmit,
 
 	/* For FLOW ctrl */
-	hw_if->config_tx_flow_control = xgbe_config_tx_flow_control;
-	hw_if->config_rx_flow_control = xgbe_config_rx_flow_control;
+	.config_tx_flow_control = xgbe_config_tx_flow_control,
+	.config_rx_flow_control = xgbe_config_rx_flow_control,
 
 	/* For RX coalescing */
-	hw_if->config_rx_coalesce = xgbe_config_rx_coalesce;
-	hw_if->config_tx_coalesce = xgbe_config_tx_coalesce;
-	hw_if->usec_to_riwt = xgbe_usec_to_riwt;
-	hw_if->riwt_to_usec = xgbe_riwt_to_usec;
+	.config_rx_coalesce = xgbe_config_rx_coalesce,
+	.config_tx_coalesce = xgbe_config_tx_coalesce,
+	.usec_to_riwt = xgbe_usec_to_riwt,
+	.riwt_to_usec = xgbe_riwt_to_usec,
 
 	/* For RX and TX threshold config */
-	hw_if->config_rx_threshold = xgbe_config_rx_threshold;
-	hw_if->config_tx_threshold = xgbe_config_tx_threshold;
+	.config_rx_threshold = xgbe_config_rx_threshold,
+	.config_tx_threshold = xgbe_config_tx_threshold,
 
 	/* For RX and TX Store and Forward Mode config */
-	hw_if->config_rsf_mode = xgbe_config_rsf_mode;
-	hw_if->config_tsf_mode = xgbe_config_tsf_mode;
+	.config_rsf_mode = xgbe_config_rsf_mode,
+	.config_tsf_mode = xgbe_config_tsf_mode,
 
 	/* For TX DMA Operating on Second Frame config */
-	hw_if->config_osp_mode = xgbe_config_osp_mode;
+	.config_osp_mode = xgbe_config_osp_mode,
 
 	/* For RX and TX PBL config */
-	hw_if->config_rx_pbl_val = xgbe_config_rx_pbl_val;
-	hw_if->get_rx_pbl_val = xgbe_get_rx_pbl_val;
-	hw_if->config_tx_pbl_val = xgbe_config_tx_pbl_val;
-	hw_if->get_tx_pbl_val = xgbe_get_tx_pbl_val;
-	hw_if->config_pblx8 = xgbe_config_pblx8;
+	.config_rx_pbl_val = xgbe_config_rx_pbl_val,
+	.get_rx_pbl_val = xgbe_get_rx_pbl_val,
+	.config_tx_pbl_val = xgbe_config_tx_pbl_val,
+	.get_tx_pbl_val = xgbe_get_tx_pbl_val,
+	.config_pblx8 = xgbe_config_pblx8,
 
 	/* For MMC statistics support */
-	hw_if->tx_mmc_int = xgbe_tx_mmc_int;
-	hw_if->rx_mmc_int = xgbe_rx_mmc_int;
-	hw_if->read_mmc_stats = xgbe_read_mmc_stats;
+	.tx_mmc_int = xgbe_tx_mmc_int,
+	.rx_mmc_int = xgbe_rx_mmc_int,
+	.read_mmc_stats = xgbe_read_mmc_stats,
 
 	/* For PTP config */
-	hw_if->config_tstamp = xgbe_config_tstamp;
-	hw_if->update_tstamp_addend = xgbe_update_tstamp_addend;
-	hw_if->set_tstamp_time = xgbe_set_tstamp_time;
-	hw_if->get_tstamp_time = xgbe_get_tstamp_time;
-	hw_if->get_tx_tstamp = xgbe_get_tx_tstamp;
+	.config_tstamp = xgbe_config_tstamp,
+	.update_tstamp_addend = xgbe_update_tstamp_addend,
+	.set_tstamp_time = xgbe_set_tstamp_time,
+	.get_tstamp_time = xgbe_get_tstamp_time,
+	.get_tx_tstamp = xgbe_get_tx_tstamp,
 
 	/* For Data Center Bridging config */
-	hw_if->config_tc = xgbe_config_tc;
-	hw_if->config_dcb_tc = xgbe_config_dcb_tc;
-	hw_if->config_dcb_pfc = xgbe_config_dcb_pfc;
+	.config_tc = xgbe_config_tc,
+	.config_dcb_tc = xgbe_config_dcb_tc,
+	.config_dcb_pfc = xgbe_config_dcb_pfc,
 
 	/* For Receive Side Scaling */
-	hw_if->enable_rss = xgbe_enable_rss;
-	hw_if->disable_rss = xgbe_disable_rss;
-	hw_if->set_rss_hash_key = xgbe_set_rss_hash_key;
-	hw_if->set_rss_lookup_table = xgbe_set_rss_lookup_table;
-
-	DBGPR("<--xgbe_init_function_ptrs\n");
-}
+	.enable_rss = xgbe_enable_rss,
+	.disable_rss = xgbe_disable_rss,
+	.set_rss_hash_key = xgbe_set_rss_hash_key,
+	.set_rss_lookup_table = xgbe_set_rss_lookup_table,
+};
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-drv.c b/drivers/net/ethernet/amd/xgbe/xgbe-drv.c
index a9b270956..8cf92f139 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-drv.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-drv.c
@@ -245,7 +245,7 @@ static int xgbe_maybe_stop_tx_queue(struct xgbe_channel *channel,
 		 * support, tell it now
 		 */
 		if (ring->tx.xmit_more)
-			pdata->hw_if.tx_start_xmit(channel, ring);
+			pdata->hw_if->tx_start_xmit(channel, ring);
 
 		return NETDEV_TX_BUSY;
 	}
@@ -273,7 +273,7 @@ static int xgbe_calc_rx_buf_size(struct net_device *netdev, unsigned int mtu)
 
 static void xgbe_enable_rx_tx_ints(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	struct xgbe_channel *channel;
 	enum xgbe_int int_id;
 	unsigned int i;
@@ -295,7 +295,7 @@ static void xgbe_enable_rx_tx_ints(struct xgbe_prv_data *pdata)
 
 static void xgbe_disable_rx_tx_ints(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	struct xgbe_channel *channel;
 	enum xgbe_int int_id;
 	unsigned int i;
@@ -318,7 +318,7 @@ static void xgbe_disable_rx_tx_ints(struct xgbe_prv_data *pdata)
 static irqreturn_t xgbe_isr(int irq, void *data)
 {
 	struct xgbe_prv_data *pdata = data;
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	struct xgbe_channel *channel;
 	unsigned int dma_isr, dma_ch_isr;
 	unsigned int mac_isr, mac_tssr;
@@ -447,7 +447,7 @@ static void xgbe_service(struct work_struct *work)
 						   struct xgbe_prv_data,
 						   service_work);
 
-	pdata->phy_if.phy_status(pdata);
+	pdata->phy_if->phy_status(pdata);
 }
 
 static void xgbe_service_timer(unsigned long data)
@@ -706,7 +706,7 @@ static void xgbe_free_irqs(struct xgbe_prv_data *pdata)
 
 void xgbe_init_tx_coalesce(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 
 	DBGPR("-->xgbe_init_tx_coalesce\n");
 
@@ -720,7 +720,7 @@ void xgbe_init_tx_coalesce(struct xgbe_prv_data *pdata)
 
 void xgbe_init_rx_coalesce(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 
 	DBGPR("-->xgbe_init_rx_coalesce\n");
 
@@ -735,7 +735,7 @@ void xgbe_init_rx_coalesce(struct xgbe_prv_data *pdata)
 
 static void xgbe_free_tx_data(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 	struct xgbe_channel *channel;
 	struct xgbe_ring *ring;
 	struct xgbe_ring_data *rdata;
@@ -760,7 +760,7 @@ static void xgbe_free_tx_data(struct xgbe_prv_data *pdata)
 
 static void xgbe_free_rx_data(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 	struct xgbe_channel *channel;
 	struct xgbe_ring *ring;
 	struct xgbe_ring_data *rdata;
@@ -788,13 +788,13 @@ static int xgbe_phy_init(struct xgbe_prv_data *pdata)
 	pdata->phy_link = -1;
 	pdata->phy_speed = SPEED_UNKNOWN;
 
-	return pdata->phy_if.phy_reset(pdata);
+	return pdata->phy_if->phy_reset(pdata);
 }
 
 int xgbe_powerdown(struct net_device *netdev, unsigned int caller)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	unsigned long flags;
 
 	DBGPR("-->xgbe_powerdown\n");
@@ -833,7 +833,7 @@ int xgbe_powerdown(struct net_device *netdev, unsigned int caller)
 int xgbe_powerup(struct net_device *netdev, unsigned int caller)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	unsigned long flags;
 
 	DBGPR("-->xgbe_powerup\n");
@@ -870,8 +870,8 @@ int xgbe_powerup(struct net_device *netdev, unsigned int caller)
 
 static int xgbe_start(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
-	struct xgbe_phy_if *phy_if = &pdata->phy_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
+	struct xgbe_phy_if *phy_if = pdata->phy_if;
 	struct net_device *netdev = pdata->netdev;
 	int ret;
 
@@ -914,8 +914,8 @@ err_phy:
 
 static void xgbe_stop(struct xgbe_prv_data *pdata)
 {
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
-	struct xgbe_phy_if *phy_if = &pdata->phy_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
+	struct xgbe_phy_if *phy_if = pdata->phy_if;
 	struct xgbe_channel *channel;
 	struct net_device *netdev = pdata->netdev;
 	struct netdev_queue *txq;
@@ -1143,7 +1143,7 @@ static int xgbe_set_hwtstamp_settings(struct xgbe_prv_data *pdata,
 		return -ERANGE;
 	}
 
-	pdata->hw_if.config_tstamp(pdata, mac_tscr);
+	pdata->hw_if->config_tstamp(pdata, mac_tscr);
 
 	memcpy(&pdata->tstamp_config, &config, sizeof(config));
 
@@ -1292,7 +1292,7 @@ static void xgbe_packet_info(struct xgbe_prv_data *pdata,
 static int xgbe_open(struct net_device *netdev)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 	int ret;
 
 	DBGPR("-->xgbe_open\n");
@@ -1364,7 +1364,7 @@ err_sysclk:
 static int xgbe_close(struct net_device *netdev)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 
 	DBGPR("-->xgbe_close\n");
 
@@ -1388,11 +1388,11 @@ static int xgbe_close(struct net_device *netdev)
 	return 0;
 }
 
-static int xgbe_xmit(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t xgbe_xmit(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 	struct xgbe_channel *channel;
 	struct xgbe_ring *ring;
 	struct xgbe_packet_data *packet;
@@ -1461,7 +1461,7 @@ tx_netdev_return:
 static void xgbe_set_rx_mode(struct net_device *netdev)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 
 	DBGPR("-->xgbe_set_rx_mode\n");
 
@@ -1473,7 +1473,7 @@ static void xgbe_set_rx_mode(struct net_device *netdev)
 static int xgbe_set_mac_address(struct net_device *netdev, void *addr)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	struct sockaddr *saddr = addr;
 
 	DBGPR("-->xgbe_set_mac_address\n");
@@ -1548,7 +1548,7 @@ static struct rtnl_link_stats64 *xgbe_get_stats64(struct net_device *netdev,
 
 	DBGPR("-->%s\n", __func__);
 
-	pdata->hw_if.read_mmc_stats(pdata);
+	pdata->hw_if->read_mmc_stats(pdata);
 
 	s->rx_packets = pstats->rxframecount_gb;
 	s->rx_bytes = pstats->rxoctetcount_gb;
@@ -1575,7 +1575,7 @@ static int xgbe_vlan_rx_add_vid(struct net_device *netdev, __be16 proto,
 				u16 vid)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 
 	DBGPR("-->%s\n", __func__);
 
@@ -1591,7 +1591,7 @@ static int xgbe_vlan_rx_kill_vid(struct net_device *netdev, __be16 proto,
 				 u16 vid)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 
 	DBGPR("-->%s\n", __func__);
 
@@ -1641,7 +1641,7 @@ static int xgbe_setup_tc(struct net_device *netdev, u32 handle, __be16 proto,
 		return -EINVAL;
 
 	pdata->num_tcs = tc;
-	pdata->hw_if.config_tc(pdata);
+	pdata->hw_if->config_tc(pdata);
 
 	return 0;
 }
@@ -1650,7 +1650,7 @@ static int xgbe_set_features(struct net_device *netdev,
 			     netdev_features_t features)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	netdev_features_t rxhash, rxcsum, rxvlan, rxvlan_filter;
 	int ret = 0;
 
@@ -1716,8 +1716,8 @@ struct net_device_ops *xgbe_get_netdev_ops(void)
 static void xgbe_rx_refresh(struct xgbe_channel *channel)
 {
 	struct xgbe_prv_data *pdata = channel->pdata;
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 	struct xgbe_ring *ring = channel->rx_ring;
 	struct xgbe_ring_data *rdata;
 
@@ -1794,8 +1794,8 @@ static struct sk_buff *xgbe_create_skb(struct xgbe_prv_data *pdata,
 static int xgbe_tx_poll(struct xgbe_channel *channel)
 {
 	struct xgbe_prv_data *pdata = channel->pdata;
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
-	struct xgbe_desc_if *desc_if = &pdata->desc_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
+	struct xgbe_desc_if *desc_if = pdata->desc_if;
 	struct xgbe_ring *ring = channel->tx_ring;
 	struct xgbe_ring_data *rdata;
 	struct xgbe_ring_desc *rdesc;
@@ -1865,7 +1865,7 @@ static int xgbe_tx_poll(struct xgbe_channel *channel)
 static int xgbe_rx_poll(struct xgbe_channel *channel, int budget)
 {
 	struct xgbe_prv_data *pdata = channel->pdata;
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	struct xgbe_ring *ring = channel->rx_ring;
 	struct xgbe_ring_data *rdata;
 	struct xgbe_packet_data *packet;
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-ethtool.c b/drivers/net/ethernet/amd/xgbe/xgbe-ethtool.c
index 11d9f0c5b..78767aba6 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-ethtool.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-ethtool.c
@@ -206,7 +206,7 @@ static void xgbe_get_ethtool_stats(struct net_device *netdev,
 	u8 *stat;
 	int i;
 
-	pdata->hw_if.read_mmc_stats(pdata);
+	pdata->hw_if->read_mmc_stats(pdata);
 	for (i = 0; i < XGBE_STATS_COUNT; i++) {
 		stat = (u8 *)pdata + xgbe_gstring_stats[i].stat_offset;
 		*data++ = *(u64 *)stat;
@@ -267,7 +267,7 @@ static int xgbe_set_pauseparam(struct net_device *netdev,
 		pdata->phy.advertising ^= ADVERTISED_Asym_Pause;
 
 	if (netif_running(netdev))
-		ret = pdata->phy_if.phy_config_aneg(pdata);
+		ret = pdata->phy_if->phy_config_aneg(pdata);
 
 	return ret;
 }
@@ -368,7 +368,7 @@ static int xgbe_set_settings(struct net_device *netdev,
 		pdata->phy.advertising &= ~ADVERTISED_Autoneg;
 
 	if (netif_running(netdev))
-		ret = pdata->phy_if.phy_config_aneg(pdata);
+		ret = pdata->phy_if->phy_config_aneg(pdata);
 
 	return ret;
 }
@@ -422,7 +422,7 @@ static int xgbe_set_coalesce(struct net_device *netdev,
 			     struct ethtool_coalesce *ec)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	unsigned int rx_frames, rx_riwt, rx_usecs;
 	unsigned int tx_frames;
 
@@ -545,7 +545,7 @@ static int xgbe_set_rxfh(struct net_device *netdev, const u32 *indir,
 			 const u8 *key, const u8 hfunc)
 {
 	struct xgbe_prv_data *pdata = netdev_priv(netdev);
-	struct xgbe_hw_if *hw_if = &pdata->hw_if;
+	struct xgbe_hw_if *hw_if = pdata->hw_if;
 	unsigned int ret;
 
 	if (hfunc != ETH_RSS_HASH_NO_CHANGE && hfunc != ETH_RSS_HASH_TOP) {
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-main.c b/drivers/net/ethernet/amd/xgbe/xgbe-main.c
index 3eee3201b..418868109 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-main.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-main.c
@@ -202,13 +202,6 @@ static void xgbe_default_config(struct xgbe_prv_data *pdata)
 	DBGPR("<--xgbe_default_config\n");
 }
 
-static void xgbe_init_all_fptrs(struct xgbe_prv_data *pdata)
-{
-	xgbe_init_function_ptrs_dev(&pdata->hw_if);
-	xgbe_init_function_ptrs_phy(&pdata->phy_if);
-	xgbe_init_function_ptrs_desc(&pdata->desc_if);
-}
-
 #ifdef CONFIG_ACPI
 static int xgbe_acpi_support(struct xgbe_prv_data *pdata)
 {
@@ -647,10 +640,12 @@ static int xgbe_probe(struct platform_device *pdev)
 	memcpy(netdev->dev_addr, pdata->mac_addr, netdev->addr_len);
 
 	/* Set all the function pointers */
-	xgbe_init_all_fptrs(pdata);
+	pdata->hw_if = &default_xgbe_hw_if;
+	pdata->phy_if = &default_xgbe_phy_if;
+	pdata->desc_if = &default_xgbe_desc_if;
 
 	/* Issue software reset to device */
-	pdata->hw_if.exit(pdata);
+	pdata->hw_if->exit(pdata);
 
 	/* Populate the hardware features */
 	xgbe_get_all_hw_features(pdata);
@@ -704,7 +699,7 @@ static int xgbe_probe(struct platform_device *pdev)
 	XGMAC_SET_BITS(pdata->rss_options, MAC_RSSCR, UDP4TE, 1);
 
 	/* Call MDIO/PHY initialization routine */
-	pdata->phy_if.phy_init(pdata);
+	pdata->phy_if->phy_init(pdata);
 
 	/* Set device operations */
 	netdev->netdev_ops = xgbe_get_netdev_ops();
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-mdio.c b/drivers/net/ethernet/amd/xgbe/xgbe-mdio.c
index 84c5d296d..697b4f2ff 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-mdio.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-mdio.c
@@ -202,7 +202,7 @@ static void xgbe_xgmii_mode(struct xgbe_prv_data *pdata)
 	xgbe_an_enable_kr_training(pdata);
 
 	/* Set MAC to 10G speed */
-	pdata->hw_if.set_xgmii_speed(pdata);
+	pdata->hw_if->set_xgmii_speed(pdata);
 
 	/* Set PCS to KR/10G speed */
 	reg = XMDIO_READ(pdata, MDIO_MMD_PCS, MDIO_CTRL2);
@@ -250,7 +250,7 @@ static void xgbe_gmii_2500_mode(struct xgbe_prv_data *pdata)
 	xgbe_an_disable_kr_training(pdata);
 
 	/* Set MAC to 2.5G speed */
-	pdata->hw_if.set_gmii_2500_speed(pdata);
+	pdata->hw_if->set_gmii_2500_speed(pdata);
 
 	/* Set PCS to KX/1G speed */
 	reg = XMDIO_READ(pdata, MDIO_MMD_PCS, MDIO_CTRL2);
@@ -298,7 +298,7 @@ static void xgbe_gmii_mode(struct xgbe_prv_data *pdata)
 	xgbe_an_disable_kr_training(pdata);
 
 	/* Set MAC to 1G speed */
-	pdata->hw_if.set_gmii_speed(pdata);
+	pdata->hw_if->set_gmii_speed(pdata);
 
 	/* Set PCS to KX/1G speed */
 	reg = XMDIO_READ(pdata, MDIO_MMD_PCS, MDIO_CTRL2);
@@ -877,13 +877,13 @@ static void xgbe_phy_adjust_link(struct xgbe_prv_data *pdata)
 
 		if (pdata->tx_pause != pdata->phy.tx_pause) {
 			new_state = 1;
-			pdata->hw_if.config_tx_flow_control(pdata);
+			pdata->hw_if->config_tx_flow_control(pdata);
 			pdata->tx_pause = pdata->phy.tx_pause;
 		}
 
 		if (pdata->rx_pause != pdata->phy.rx_pause) {
 			new_state = 1;
-			pdata->hw_if.config_rx_flow_control(pdata);
+			pdata->hw_if->config_rx_flow_control(pdata);
 			pdata->rx_pause = pdata->phy.rx_pause;
 		}
 
@@ -1348,14 +1348,13 @@ static void xgbe_phy_init(struct xgbe_prv_data *pdata)
 		xgbe_dump_phy_registers(pdata);
 }
 
-void xgbe_init_function_ptrs_phy(struct xgbe_phy_if *phy_if)
-{
-	phy_if->phy_init        = xgbe_phy_init;
+const struct xgbe_phy_if default_xgbe_phy_if = {
+	.phy_init        = xgbe_phy_init,
 
-	phy_if->phy_reset       = xgbe_phy_reset;
-	phy_if->phy_start       = xgbe_phy_start;
-	phy_if->phy_stop        = xgbe_phy_stop;
+	.phy_reset       = xgbe_phy_reset,
+	.phy_start       = xgbe_phy_start,
+	.phy_stop        = xgbe_phy_stop,
 
-	phy_if->phy_status      = xgbe_phy_status;
-	phy_if->phy_config_aneg = xgbe_phy_config_aneg;
-}
+	.phy_status      = xgbe_phy_status,
+	.phy_config_aneg = xgbe_phy_config_aneg,
+};
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe-ptp.c b/drivers/net/ethernet/amd/xgbe/xgbe-ptp.c
index b03e4f58d..78e4cc4e6 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe-ptp.c
+++ b/drivers/net/ethernet/amd/xgbe/xgbe-ptp.c
@@ -129,7 +129,7 @@ static cycle_t xgbe_cc_read(const struct cyclecounter *cc)
 						   tstamp_cc);
 	u64 nsec;
 
-	nsec = pdata->hw_if.get_tstamp_time(pdata);
+	nsec = pdata->hw_if->get_tstamp_time(pdata);
 
 	return nsec;
 }
@@ -158,7 +158,7 @@ static int xgbe_adjfreq(struct ptp_clock_info *info, s32 delta)
 
 	spin_lock_irqsave(&pdata->tstamp_lock, flags);
 
-	pdata->hw_if.update_tstamp_addend(pdata, addend);
+	pdata->hw_if->update_tstamp_addend(pdata, addend);
 
 	spin_unlock_irqrestore(&pdata->tstamp_lock, flags);
 
diff --git a/drivers/net/ethernet/amd/xgbe/xgbe.h b/drivers/net/ethernet/amd/xgbe/xgbe.h
index 98d9d63c4..04331226b 100644
--- a/drivers/net/ethernet/amd/xgbe/xgbe.h
+++ b/drivers/net/ethernet/amd/xgbe/xgbe.h
@@ -786,9 +786,9 @@ struct xgbe_prv_data {
 	int dev_irq;
 	unsigned int per_channel_irq;
 
-	struct xgbe_hw_if hw_if;
-	struct xgbe_phy_if phy_if;
-	struct xgbe_desc_if desc_if;
+	const struct xgbe_hw_if *hw_if;
+	const struct xgbe_phy_if *phy_if;
+	const struct xgbe_desc_if *desc_if;
 
 	/* AXI DMA settings */
 	unsigned int coherent;
@@ -951,6 +951,10 @@ struct xgbe_prv_data {
 #endif
 };
 
+extern const struct xgbe_hw_if default_xgbe_hw_if;
+extern const struct xgbe_phy_if default_xgbe_phy_if;
+extern const struct xgbe_desc_if default_xgbe_desc_if;
+
 /* Function prototypes*/
 
 void xgbe_init_function_ptrs_dev(struct xgbe_hw_if *);
diff --git a/drivers/net/ethernet/apm/xgene/xgene_enet_main.c b/drivers/net/ethernet/apm/xgene/xgene_enet_main.c
index d1d6b5eeb..19d60628b 100644
--- a/drivers/net/ethernet/apm/xgene/xgene_enet_main.c
+++ b/drivers/net/ethernet/apm/xgene/xgene_enet_main.c
@@ -111,7 +111,7 @@ static void xgene_enet_delete_bufpool(struct xgene_enet_desc_ring *buf_pool)
 	}
 }
 
-static irqreturn_t xgene_enet_rx_irq(const int irq, void *data)
+static irqreturn_t xgene_enet_rx_irq(int irq, void *data)
 {
 	struct xgene_enet_desc_ring *rx_ring = data;
 
@@ -577,7 +577,7 @@ static int xgene_enet_process_ring(struct xgene_enet_desc_ring *ring,
 	return processed;
 }
 
-static int xgene_enet_napi(struct napi_struct *napi, const int budget)
+static int xgene_enet_napi(struct napi_struct *napi, int budget)
 {
 	struct xgene_enet_desc_ring *ring;
 	int processed;
diff --git a/drivers/net/ethernet/arc/emac_main.c b/drivers/net/ethernet/arc/emac_main.c
index b0da9693f..1688f6b0a 100644
--- a/drivers/net/ethernet/arc/emac_main.c
+++ b/drivers/net/ethernet/arc/emac_main.c
@@ -608,7 +608,7 @@ static struct net_device_stats *arc_emac_stats(struct net_device *ndev)
  *
  * This function is invoked from upper layers to initiate transmission.
  */
-static int arc_emac_tx(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t arc_emac_tx(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct arc_emac_priv *priv = netdev_priv(ndev);
 	unsigned int len, *txbd_curr = &priv->txbd_curr;
diff --git a/drivers/net/ethernet/atheros/alx/main.c b/drivers/net/ethernet/atheros/alx/main.c
index 4eb17daef..5262e503b 100644
--- a/drivers/net/ethernet/atheros/alx/main.c
+++ b/drivers/net/ethernet/atheros/alx/main.c
@@ -1462,7 +1462,7 @@ static SIMPLE_DEV_PM_OPS(alx_pm_ops, alx_suspend, alx_resume);
 
 
 static pci_ers_result_t alx_pci_error_detected(struct pci_dev *pdev,
-					       pci_channel_state_t state)
+					       enum pci_channel_state state)
 {
 	struct alx_priv *alx = pci_get_drvdata(pdev);
 	struct net_device *netdev = alx->dev;
diff --git a/drivers/net/ethernet/atheros/atl1c/atl1c_main.c b/drivers/net/ethernet/atheros/atl1c/atl1c_main.c
index a3200ea6d..d02b523a9 100644
--- a/drivers/net/ethernet/atheros/atl1c/atl1c_main.c
+++ b/drivers/net/ethernet/atheros/atl1c/atl1c_main.c
@@ -2704,7 +2704,7 @@ static void atl1c_remove(struct pci_dev *pdev)
  * this device has been detected.
  */
 static pci_ers_result_t atl1c_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct atl1c_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/atheros/atl1e/atl1e_main.c b/drivers/net/ethernet/atheros/atl1e/atl1e_main.c
index 974713b19..5e0112baf 100644
--- a/drivers/net/ethernet/atheros/atl1e/atl1e_main.c
+++ b/drivers/net/ethernet/atheros/atl1e/atl1e_main.c
@@ -2475,7 +2475,7 @@ static void atl1e_remove(struct pci_dev *pdev)
  * this device has been detected.
  */
 static pci_ers_result_t
-atl1e_io_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+atl1e_io_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct atl1e_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/aurora/nb8800.c b/drivers/net/ethernet/aurora/nb8800.c
index b047fd607..d115fcb6d 100644
--- a/drivers/net/ethernet/aurora/nb8800.c
+++ b/drivers/net/ethernet/aurora/nb8800.c
@@ -396,7 +396,7 @@ static void nb8800_tx_dma_start_irq(struct net_device *dev)
 	spin_unlock(&priv->tx_lock);
 }
 
-static int nb8800_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t nb8800_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct nb8800_priv *priv = netdev_priv(dev);
 	struct nb8800_tx_desc *txd;
diff --git a/drivers/net/ethernet/broadcom/bcm63xx_enet.c b/drivers/net/ethernet/broadcom/bcm63xx_enet.c
index 6c8bc5fad..58c4f8c2e 100644
--- a/drivers/net/ethernet/broadcom/bcm63xx_enet.c
+++ b/drivers/net/ethernet/broadcom/bcm63xx_enet.c
@@ -571,7 +571,7 @@ static irqreturn_t bcm_enet_isr_dma(int irq, void *dev_id)
 /*
  * tx request callback
  */
-static int bcm_enet_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t bcm_enet_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct bcm_enet_priv *priv;
 	struct bcm_enet_desc *desc;
diff --git a/drivers/net/ethernet/broadcom/bnx2.c b/drivers/net/ethernet/broadcom/bnx2.c
index 8508813e7..b1b9932b0 100644
--- a/drivers/net/ethernet/broadcom/bnx2.c
+++ b/drivers/net/ethernet/broadcom/bnx2.c
@@ -8723,7 +8723,7 @@ static SIMPLE_DEV_PM_OPS(bnx2_pm_ops, bnx2_suspend, bnx2_resume);
  * this device has been detected.
  */
 static pci_ers_result_t bnx2_io_error_detected(struct pci_dev *pdev,
-					       pci_channel_state_t state)
+					       enum pci_channel_state state)
 {
 	struct net_device *dev = pci_get_drvdata(pdev);
 	struct bnx2 *bp = netdev_priv(dev);
diff --git a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_cmn.h b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_cmn.h
index 0e68fadec..3546d87a3 100644
--- a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_cmn.h
+++ b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_cmn.h
@@ -1124,7 +1124,7 @@ static inline u8 bnx2x_get_path_func_num(struct bnx2x *bp)
 static inline void bnx2x_init_bp_objs(struct bnx2x *bp)
 {
 	/* RX_MODE controlling object */
-	bnx2x_init_rx_mode_obj(bp, &bp->rx_mode_obj);
+	bnx2x_init_rx_mode_obj(bp);
 
 	/* multicast configuration controlling object */
 	bnx2x_init_mcast_obj(bp, &bp->mcast_obj, bp->fp->cl_id, bp->fp->cid,
diff --git a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.c b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.c
index 1fb80100e..0a8dc2050 100644
--- a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.c
+++ b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.c
@@ -5621,7 +5621,7 @@ static int bnx2x_get_link_speed_duplex(struct bnx2x_phy *phy,
 	return 0;
 }
 
-static int bnx2x_link_settings_status(struct bnx2x_phy *phy,
+static u8 bnx2x_link_settings_status(struct bnx2x_phy *phy,
 				      struct link_params *params,
 				      struct link_vars *vars)
 {
@@ -5695,7 +5695,7 @@ static int bnx2x_link_settings_status(struct bnx2x_phy *phy,
 	return rc;
 }
 
-static int bnx2x_warpcore_read_status(struct bnx2x_phy *phy,
+static u8 bnx2x_warpcore_read_status(struct bnx2x_phy *phy,
 				     struct link_params *params,
 				     struct link_vars *vars)
 {
@@ -7436,7 +7436,7 @@ static void bnx2x_8073_specific_func(struct bnx2x_phy *phy,
 	}
 }
 
-static int bnx2x_8073_config_init(struct bnx2x_phy *phy,
+static void bnx2x_8073_config_init(struct bnx2x_phy *phy,
 				  struct link_params *params,
 				  struct link_vars *vars)
 {
@@ -7499,7 +7499,7 @@ static int bnx2x_8073_config_init(struct bnx2x_phy *phy,
 	if (params->loopback_mode == LOOPBACK_EXT) {
 		bnx2x_807x_force_10G(bp, phy);
 		DP(NETIF_MSG_LINK, "Forced speed 10G on 807X\n");
-		return 0;
+		return;
 	} else {
 		bnx2x_cl45_write(bp, phy,
 				 MDIO_PMA_DEVAD, MDIO_PMA_REG_BCM_CTRL, 0x0002);
@@ -7581,7 +7581,6 @@ static int bnx2x_8073_config_init(struct bnx2x_phy *phy,
 	bnx2x_cl45_write(bp, phy, MDIO_AN_DEVAD, MDIO_AN_REG_CTRL, 0x1200);
 	DP(NETIF_MSG_LINK, "807x Autoneg Restart: Advertise 1G=%x, 10G=%x\n",
 		   ((val & (1<<5)) > 0), ((val & (1<<7)) > 0));
-	return 0;
 }
 
 static u8 bnx2x_8073_read_status(struct bnx2x_phy *phy,
@@ -7748,7 +7747,7 @@ static void bnx2x_8073_link_reset(struct bnx2x_phy *phy,
 /******************************************************************/
 /*			BCM8705 PHY SECTION			  */
 /******************************************************************/
-static int bnx2x_8705_config_init(struct bnx2x_phy *phy,
+static void bnx2x_8705_config_init(struct bnx2x_phy *phy,
 				  struct link_params *params,
 				  struct link_vars *vars)
 {
@@ -7772,7 +7771,6 @@ static int bnx2x_8705_config_init(struct bnx2x_phy *phy,
 			 MDIO_WIS_DEVAD, MDIO_WIS_REG_LASI_CNTL, 0x1);
 	/* BCM8705 doesn't have microcode, hence the 0 */
 	bnx2x_save_spirom_version(bp, params->port, params->shmem_base, 0);
-	return 0;
 }
 
 static u8 bnx2x_8705_read_status(struct bnx2x_phy *phy,
@@ -8959,7 +8957,7 @@ static u8 bnx2x_8706_8726_read_status(struct bnx2x_phy *phy,
 /******************************************************************/
 /*			BCM8706 PHY SECTION			  */
 /******************************************************************/
-static u8 bnx2x_8706_config_init(struct bnx2x_phy *phy,
+static void bnx2x_8706_config_init(struct bnx2x_phy *phy,
 				 struct link_params *params,
 				 struct link_vars *vars)
 {
@@ -9061,11 +9059,9 @@ static u8 bnx2x_8706_config_init(struct bnx2x_phy *phy,
 		bnx2x_cl45_write(bp, phy,
 			MDIO_PMA_DEVAD, MDIO_PMA_REG_DIGITAL_CTRL, tmp1);
 	}
-
-	return 0;
 }
 
-static int bnx2x_8706_read_status(struct bnx2x_phy *phy,
+static u8 bnx2x_8706_read_status(struct bnx2x_phy *phy,
 				  struct link_params *params,
 				  struct link_vars *vars)
 {
@@ -9142,7 +9138,7 @@ static u8 bnx2x_8726_read_status(struct bnx2x_phy *phy,
 }
 
 
-static int bnx2x_8726_config_init(struct bnx2x_phy *phy,
+static void bnx2x_8726_config_init(struct bnx2x_phy *phy,
 				  struct link_params *params,
 				  struct link_vars *vars)
 {
@@ -9223,8 +9219,6 @@ static int bnx2x_8726_config_init(struct bnx2x_phy *phy,
 				 phy->tx_preemphasis[1]);
 	}
 
-	return 0;
-
 }
 
 static void bnx2x_8726_link_reset(struct bnx2x_phy *phy,
@@ -9360,7 +9354,7 @@ static void bnx2x_8727_config_speed(struct bnx2x_phy *phy,
 	}
 }
 
-static int bnx2x_8727_config_init(struct bnx2x_phy *phy,
+static void bnx2x_8727_config_init(struct bnx2x_phy *phy,
 				  struct link_params *params,
 				  struct link_vars *vars)
 {
@@ -9442,8 +9436,6 @@ static int bnx2x_8727_config_init(struct bnx2x_phy *phy,
 				 MDIO_PMA_DEVAD, MDIO_PMA_REG_PHY_IDENTIFIER,
 				 (tmp2 & 0x7fff));
 	}
-
-	return 0;
 }
 
 static void bnx2x_8727_handle_mod_abs(struct bnx2x_phy *phy,
@@ -10018,7 +10010,7 @@ static int bnx2x_848xx_cmn_config_init(struct bnx2x_phy *phy,
 	return 0;
 }
 
-static int bnx2x_8481_config_init(struct bnx2x_phy *phy,
+static void bnx2x_8481_config_init(struct bnx2x_phy *phy,
 				  struct link_params *params,
 				  struct link_vars *vars)
 {
@@ -10032,7 +10024,7 @@ static int bnx2x_8481_config_init(struct bnx2x_phy *phy,
 	bnx2x_wait_reset_complete(bp, phy, params);
 
 	bnx2x_cl45_write(bp, phy, MDIO_PMA_DEVAD, MDIO_PMA_REG_CTRL, 1<<15);
-	return bnx2x_848xx_cmn_config_init(phy, params, vars);
+	bnx2x_848xx_cmn_config_init(phy, params, vars);
 }
 
 #define PHY848xx_CMDHDLR_WAIT 300
@@ -10282,7 +10274,7 @@ static u8 bnx2x_84833_get_reset_gpios(struct bnx2x *bp,
 	return reset_gpios;
 }
 
-static int bnx2x_84833_hw_reset_phy(struct bnx2x_phy *phy,
+static void bnx2x_84833_hw_reset_phy(struct bnx2x_phy *phy,
 				struct link_params *params)
 {
 	struct bnx2x *bp = params->bp;
@@ -10311,8 +10303,6 @@ static int bnx2x_84833_hw_reset_phy(struct bnx2x_phy *phy,
 	udelay(10);
 	DP(NETIF_MSG_LINK, "84833 hw reset on pin values 0x%x\n",
 		reset_gpios);
-
-	return 0;
 }
 
 static int bnx2x_8483x_disable_eee(struct bnx2x_phy *phy,
@@ -10355,7 +10345,7 @@ static int bnx2x_8483x_enable_eee(struct bnx2x_phy *phy,
 }
 
 #define PHY84833_CONSTANT_LATENCY 1193
-static int bnx2x_848x3_config_init(struct bnx2x_phy *phy,
+static void bnx2x_848x3_config_init(struct bnx2x_phy *phy,
 				   struct link_params *params,
 				   struct link_vars *vars)
 {
@@ -10502,7 +10492,7 @@ static int bnx2x_848x3_config_init(struct bnx2x_phy *phy,
 		if (rc) {
 			DP(NETIF_MSG_LINK, "Failed to configure EEE timers\n");
 			bnx2x_8483x_disable_eee(phy, params, vars);
-			return rc;
+			return;
 		}
 
 		if ((phy->req_duplex == DUPLEX_FULL) &&
@@ -10514,7 +10504,7 @@ static int bnx2x_848x3_config_init(struct bnx2x_phy *phy,
 			rc = bnx2x_8483x_disable_eee(phy, params, vars);
 		if (rc) {
 			DP(NETIF_MSG_LINK, "Failed to set EEE advertisement\n");
-			return rc;
+			return;
 		}
 	} else {
 		vars->eee_status &= ~SHMEM_EEE_SUPPORTED_MASK;
@@ -10553,7 +10543,6 @@ static int bnx2x_848x3_config_init(struct bnx2x_phy *phy,
 					  MDIO_84833_TOP_CFG_XGPHY_STRAP1,
 					  (u16)~MDIO_84833_SUPER_ISOLATE);
 	}
-	return rc;
 }
 
 static u8 bnx2x_848xx_read_status(struct bnx2x_phy *phy,
@@ -11113,7 +11102,7 @@ static void bnx2x_54618se_specific_func(struct bnx2x_phy *phy,
 	}
 }
 
-static int bnx2x_54618se_config_init(struct bnx2x_phy *phy,
+static void bnx2x_54618se_config_init(struct bnx2x_phy *phy,
 					       struct link_params *params,
 					       struct link_vars *vars)
 {
@@ -11315,8 +11304,6 @@ static int bnx2x_54618se_config_init(struct bnx2x_phy *phy,
 
 	bnx2x_cl22_write(bp, phy,
 			MDIO_PMA_REG_CTRL, autoneg_val);
-
-	return 0;
 }
 
 
@@ -11540,7 +11527,7 @@ static void bnx2x_7101_config_loopback(struct bnx2x_phy *phy,
 			 MDIO_XS_DEVAD, MDIO_XS_SFX7101_XGXS_TEST1, 0x100);
 }
 
-static int bnx2x_7101_config_init(struct bnx2x_phy *phy,
+static void bnx2x_7101_config_init(struct bnx2x_phy *phy,
 				  struct link_params *params,
 				  struct link_vars *vars)
 {
@@ -11577,7 +11564,6 @@ static int bnx2x_7101_config_init(struct bnx2x_phy *phy,
 			MDIO_PMA_DEVAD, MDIO_PMA_REG_7101_VER2, &fw_ver2);
 	bnx2x_save_spirom_version(bp, params->port,
 				  (u32)(fw_ver1<<16 | fw_ver2), phy->ver_addr);
-	return 0;
 }
 
 static u8 bnx2x_7101_read_status(struct bnx2x_phy *phy,
@@ -11746,9 +11732,9 @@ static const struct bnx2x_phy phy_serdes = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_xgxs_config_init,
-	.read_status	= (read_status_t)bnx2x_link_settings_status,
-	.link_reset	= (link_reset_t)bnx2x_int_link_reset,
+	.config_init	= bnx2x_xgxs_config_init,
+	.read_status	= bnx2x_link_settings_status,
+	.link_reset	= bnx2x_int_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
 	.format_fw_ver	= (format_fw_ver_t)NULL,
 	.hw_reset	= (hw_reset_t)NULL,
@@ -11782,14 +11768,14 @@ static const struct bnx2x_phy phy_xgxs = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_xgxs_config_init,
-	.read_status	= (read_status_t)bnx2x_link_settings_status,
-	.link_reset	= (link_reset_t)bnx2x_int_link_reset,
-	.config_loopback = (config_loopback_t)bnx2x_set_xgxs_loopback,
+	.config_init	= bnx2x_xgxs_config_init,
+	.read_status	= bnx2x_link_settings_status,
+	.link_reset	= bnx2x_int_link_reset,
+	.config_loopback = bnx2x_set_xgxs_loopback,
 	.format_fw_ver	= (format_fw_ver_t)NULL,
 	.hw_reset	= (hw_reset_t)NULL,
 	.set_link_led	= (set_link_led_t)NULL,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_xgxs_specific_func
+	.phy_specific_func = bnx2x_xgxs_specific_func
 };
 static const struct bnx2x_phy phy_warpcore = {
 	.type		= PORT_HW_CFG_XGXS_EXT_PHY_TYPE_DIRECT,
@@ -11820,12 +11806,12 @@ static const struct bnx2x_phy phy_warpcore = {
 	.speed_cap_mask	= 0,
 	/* req_duplex = */0,
 	/* rsrv = */0,
-	.config_init	= (config_init_t)bnx2x_warpcore_config_init,
-	.read_status	= (read_status_t)bnx2x_warpcore_read_status,
-	.link_reset	= (link_reset_t)bnx2x_warpcore_link_reset,
-	.config_loopback = (config_loopback_t)bnx2x_set_warpcore_loopback,
+	.config_init	= bnx2x_warpcore_config_init,
+	.read_status	= bnx2x_warpcore_read_status,
+	.link_reset	= bnx2x_warpcore_link_reset,
+	.config_loopback = bnx2x_set_warpcore_loopback,
 	.format_fw_ver	= (format_fw_ver_t)NULL,
-	.hw_reset	= (hw_reset_t)bnx2x_warpcore_hw_reset,
+	.hw_reset	= bnx2x_warpcore_hw_reset,
 	.set_link_led	= (set_link_led_t)NULL,
 	.phy_specific_func = (phy_specific_func_t)NULL
 };
@@ -11851,13 +11837,13 @@ static const struct bnx2x_phy phy_7101 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_7101_config_init,
-	.read_status	= (read_status_t)bnx2x_7101_read_status,
-	.link_reset	= (link_reset_t)bnx2x_common_ext_link_reset,
-	.config_loopback = (config_loopback_t)bnx2x_7101_config_loopback,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_7101_format_ver,
-	.hw_reset	= (hw_reset_t)bnx2x_7101_hw_reset,
-	.set_link_led	= (set_link_led_t)bnx2x_7101_set_link_led,
+	.config_init	= bnx2x_7101_config_init,
+	.read_status	= bnx2x_7101_read_status,
+	.link_reset	= bnx2x_common_ext_link_reset,
+	.config_loopback = bnx2x_7101_config_loopback,
+	.format_fw_ver	= bnx2x_7101_format_ver,
+	.hw_reset	= bnx2x_7101_hw_reset,
+	.set_link_led	= bnx2x_7101_set_link_led,
 	.phy_specific_func = (phy_specific_func_t)NULL
 };
 static const struct bnx2x_phy phy_8073 = {
@@ -11882,14 +11868,14 @@ static const struct bnx2x_phy phy_8073 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_8073_config_init,
-	.read_status	= (read_status_t)bnx2x_8073_read_status,
-	.link_reset	= (link_reset_t)bnx2x_8073_link_reset,
+	.config_init	= bnx2x_8073_config_init,
+	.read_status	= bnx2x_8073_read_status,
+	.link_reset	= bnx2x_8073_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_format_ver,
+	.format_fw_ver	= bnx2x_format_ver,
 	.hw_reset	= (hw_reset_t)NULL,
 	.set_link_led	= (set_link_led_t)NULL,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_8073_specific_func
+	.phy_specific_func = bnx2x_8073_specific_func
 };
 static const struct bnx2x_phy phy_8705 = {
 	.type		= PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8705,
@@ -11910,11 +11896,11 @@ static const struct bnx2x_phy phy_8705 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_8705_config_init,
-	.read_status	= (read_status_t)bnx2x_8705_read_status,
-	.link_reset	= (link_reset_t)bnx2x_common_ext_link_reset,
+	.config_init	= bnx2x_8705_config_init,
+	.read_status	= bnx2x_8705_read_status,
+	.link_reset	= bnx2x_common_ext_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_null_format_ver,
+	.format_fw_ver	= bnx2x_null_format_ver,
 	.hw_reset	= (hw_reset_t)NULL,
 	.set_link_led	= (set_link_led_t)NULL,
 	.phy_specific_func = (phy_specific_func_t)NULL
@@ -11939,11 +11925,11 @@ static const struct bnx2x_phy phy_8706 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_8706_config_init,
-	.read_status	= (read_status_t)bnx2x_8706_read_status,
-	.link_reset	= (link_reset_t)bnx2x_common_ext_link_reset,
+	.config_init	= bnx2x_8706_config_init,
+	.read_status	= bnx2x_8706_read_status,
+	.link_reset	= bnx2x_common_ext_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_format_ver,
+	.format_fw_ver	= bnx2x_format_ver,
 	.hw_reset	= (hw_reset_t)NULL,
 	.set_link_led	= (set_link_led_t)NULL,
 	.phy_specific_func = (phy_specific_func_t)NULL
@@ -11971,11 +11957,11 @@ static const struct bnx2x_phy phy_8726 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_8726_config_init,
-	.read_status	= (read_status_t)bnx2x_8726_read_status,
-	.link_reset	= (link_reset_t)bnx2x_8726_link_reset,
-	.config_loopback = (config_loopback_t)bnx2x_8726_config_loopback,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_format_ver,
+	.config_init	= bnx2x_8726_config_init,
+	.read_status	= bnx2x_8726_read_status,
+	.link_reset	= bnx2x_8726_link_reset,
+	.config_loopback = bnx2x_8726_config_loopback,
+	.format_fw_ver	= bnx2x_format_ver,
 	.hw_reset	= (hw_reset_t)NULL,
 	.set_link_led	= (set_link_led_t)NULL,
 	.phy_specific_func = (phy_specific_func_t)NULL
@@ -12002,14 +11988,14 @@ static const struct bnx2x_phy phy_8727 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_8727_config_init,
-	.read_status	= (read_status_t)bnx2x_8727_read_status,
-	.link_reset	= (link_reset_t)bnx2x_8727_link_reset,
+	.config_init	= bnx2x_8727_config_init,
+	.read_status	= bnx2x_8727_read_status,
+	.link_reset	= bnx2x_8727_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_format_ver,
-	.hw_reset	= (hw_reset_t)bnx2x_8727_hw_reset,
-	.set_link_led	= (set_link_led_t)bnx2x_8727_set_link_led,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_8727_specific_func
+	.format_fw_ver	= bnx2x_format_ver,
+	.hw_reset	= bnx2x_8727_hw_reset,
+	.set_link_led	= bnx2x_8727_set_link_led,
+	.phy_specific_func = bnx2x_8727_specific_func
 };
 static const struct bnx2x_phy phy_8481 = {
 	.type		= PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8481,
@@ -12037,13 +12023,13 @@ static const struct bnx2x_phy phy_8481 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_8481_config_init,
-	.read_status	= (read_status_t)bnx2x_848xx_read_status,
-	.link_reset	= (link_reset_t)bnx2x_8481_link_reset,
+	.config_init	= bnx2x_8481_config_init,
+	.read_status	= bnx2x_848xx_read_status,
+	.link_reset	= bnx2x_8481_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_848xx_format_ver,
-	.hw_reset	= (hw_reset_t)bnx2x_8481_hw_reset,
-	.set_link_led	= (set_link_led_t)bnx2x_848xx_set_link_led,
+	.format_fw_ver	= bnx2x_848xx_format_ver,
+	.hw_reset	= bnx2x_8481_hw_reset,
+	.set_link_led	= bnx2x_848xx_set_link_led,
 	.phy_specific_func = (phy_specific_func_t)NULL
 };
 
@@ -12074,14 +12060,14 @@ static const struct bnx2x_phy phy_84823 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_848x3_config_init,
-	.read_status	= (read_status_t)bnx2x_848xx_read_status,
-	.link_reset	= (link_reset_t)bnx2x_848x3_link_reset,
+	.config_init	= bnx2x_848x3_config_init,
+	.read_status	= bnx2x_848xx_read_status,
+	.link_reset	= bnx2x_848x3_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_848xx_format_ver,
+	.format_fw_ver	= bnx2x_848xx_format_ver,
 	.hw_reset	= (hw_reset_t)NULL,
-	.set_link_led	= (set_link_led_t)bnx2x_848xx_set_link_led,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_848xx_specific_func
+	.set_link_led	= bnx2x_848xx_set_link_led,
+	.phy_specific_func = bnx2x_848xx_specific_func
 };
 
 static const struct bnx2x_phy phy_84833 = {
@@ -12109,14 +12095,14 @@ static const struct bnx2x_phy phy_84833 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_848x3_config_init,
-	.read_status	= (read_status_t)bnx2x_848xx_read_status,
-	.link_reset	= (link_reset_t)bnx2x_848x3_link_reset,
+	.config_init	= bnx2x_848x3_config_init,
+	.read_status	= bnx2x_848xx_read_status,
+	.link_reset	= bnx2x_848x3_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_848xx_format_ver,
-	.hw_reset	= (hw_reset_t)bnx2x_84833_hw_reset_phy,
-	.set_link_led	= (set_link_led_t)bnx2x_848xx_set_link_led,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_848xx_specific_func
+	.format_fw_ver	= bnx2x_848xx_format_ver,
+	.hw_reset	= bnx2x_84833_hw_reset_phy,
+	.set_link_led	= bnx2x_848xx_set_link_led,
+	.phy_specific_func = bnx2x_848xx_specific_func
 };
 
 static const struct bnx2x_phy phy_84834 = {
@@ -12143,14 +12129,14 @@ static const struct bnx2x_phy phy_84834 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_848x3_config_init,
-	.read_status	= (read_status_t)bnx2x_848xx_read_status,
-	.link_reset	= (link_reset_t)bnx2x_848x3_link_reset,
+	.config_init	= bnx2x_848x3_config_init,
+	.read_status	= bnx2x_848xx_read_status,
+	.link_reset	= bnx2x_848x3_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_848xx_format_ver,
-	.hw_reset	= (hw_reset_t)bnx2x_84833_hw_reset_phy,
-	.set_link_led	= (set_link_led_t)bnx2x_848xx_set_link_led,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_848xx_specific_func
+	.format_fw_ver	= bnx2x_848xx_format_ver,
+	.hw_reset	= bnx2x_84833_hw_reset_phy,
+	.set_link_led	= bnx2x_848xx_set_link_led,
+	.phy_specific_func = bnx2x_848xx_specific_func
 };
 
 static const struct bnx2x_phy phy_84858 = {
@@ -12177,14 +12163,14 @@ static const struct bnx2x_phy phy_84858 = {
 	.speed_cap_mask	= 0,
 	.req_duplex	= 0,
 	.rsrv		= 0,
-	.config_init	= (config_init_t)bnx2x_848x3_config_init,
-	.read_status	= (read_status_t)bnx2x_848xx_read_status,
-	.link_reset	= (link_reset_t)bnx2x_848x3_link_reset,
+	.config_init	= bnx2x_848x3_config_init,
+	.read_status	= bnx2x_848xx_read_status,
+	.link_reset	= bnx2x_848x3_link_reset,
 	.config_loopback = (config_loopback_t)NULL,
-	.format_fw_ver	= (format_fw_ver_t)bnx2x_8485x_format_ver,
-	.hw_reset	= (hw_reset_t)bnx2x_84833_hw_reset_phy,
-	.set_link_led	= (set_link_led_t)bnx2x_848xx_set_link_led,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_848xx_specific_func
+	.format_fw_ver	= bnx2x_8485x_format_ver,
+	.hw_reset	= bnx2x_84833_hw_reset_phy,
+	.set_link_led	= bnx2x_848xx_set_link_led,
+	.phy_specific_func = bnx2x_848xx_specific_func
 };
 
 static const struct bnx2x_phy phy_54618se = {
@@ -12211,14 +12197,14 @@ static const struct bnx2x_phy phy_54618se = {
 	.speed_cap_mask	= 0,
 	/* req_duplex = */0,
 	/* rsrv = */0,
-	.config_init	= (config_init_t)bnx2x_54618se_config_init,
-	.read_status	= (read_status_t)bnx2x_54618se_read_status,
-	.link_reset	= (link_reset_t)bnx2x_54618se_link_reset,
-	.config_loopback = (config_loopback_t)bnx2x_54618se_config_loopback,
+	.config_init	= bnx2x_54618se_config_init,
+	.read_status	= bnx2x_54618se_read_status,
+	.link_reset	= bnx2x_54618se_link_reset,
+	.config_loopback = bnx2x_54618se_config_loopback,
 	.format_fw_ver	= (format_fw_ver_t)NULL,
 	.hw_reset	= (hw_reset_t)NULL,
-	.set_link_led	= (set_link_led_t)bnx2x_5461x_set_link_led,
-	.phy_specific_func = (phy_specific_func_t)bnx2x_54618se_specific_func
+	.set_link_led	= bnx2x_5461x_set_link_led,
+	.phy_specific_func = bnx2x_54618se_specific_func
 };
 /*****************************************************************/
 /*                                                               */
diff --git a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.h b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.h
index b7d251108..a625bae0f 100644
--- a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.h
+++ b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_link.h
@@ -126,7 +126,7 @@ struct link_vars;
 struct link_params;
 struct bnx2x_phy;
 
-typedef u8 (*config_init_t)(struct bnx2x_phy *phy, struct link_params *params,
+typedef void (*config_init_t)(struct bnx2x_phy *phy, struct link_params *params,
 			    struct link_vars *vars);
 typedef u8 (*read_status_t)(struct bnx2x_phy *phy, struct link_params *params,
 			    struct link_vars *vars);
@@ -134,7 +134,7 @@ typedef void (*link_reset_t)(struct bnx2x_phy *phy,
 			     struct link_params *params);
 typedef void (*config_loopback_t)(struct bnx2x_phy *phy,
 				  struct link_params *params);
-typedef u8 (*format_fw_ver_t)(u32 raw, u8 *str, u16 *len);
+typedef int (*format_fw_ver_t)(u32 raw, u8 *str, u16 *len);
 typedef void (*hw_reset_t)(struct bnx2x_phy *phy, struct link_params *params);
 typedef void (*set_link_led_t)(struct bnx2x_phy *phy,
 			       struct link_params *params, u8 mode);
diff --git a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_main.c b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_main.c
index e447c8ef4..f60ab58a7 100644
--- a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_main.c
+++ b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_main.c
@@ -14095,7 +14095,7 @@ static int bnx2x_eeh_nic_unload(struct bnx2x *bp)
  * this device has been detected.
  */
 static pci_ers_result_t bnx2x_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct net_device *dev = pci_get_drvdata(pdev);
 	struct bnx2x *bp = netdev_priv(dev);
diff --git a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.c b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.c
index ff702a707..cb3ae1691 100644
--- a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.c
+++ b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.c
@@ -2576,15 +2576,14 @@ int bnx2x_config_rx_mode(struct bnx2x *bp,
 	return rc;
 }
 
-void bnx2x_init_rx_mode_obj(struct bnx2x *bp,
-			    struct bnx2x_rx_mode_obj *o)
+void bnx2x_init_rx_mode_obj(struct bnx2x *bp)
 {
 	if (CHIP_IS_E1x(bp)) {
-		o->wait_comp      = bnx2x_empty_rx_mode_wait;
-		o->config_rx_mode = bnx2x_set_rx_mode_e1x;
+		bp->rx_mode_obj.wait_comp      = bnx2x_empty_rx_mode_wait;
+		bp->rx_mode_obj.config_rx_mode = bnx2x_set_rx_mode_e1x;
 	} else {
-		o->wait_comp      = bnx2x_wait_rx_mode_comp_e2;
-		o->config_rx_mode = bnx2x_set_rx_mode_e2;
+		bp->rx_mode_obj.wait_comp      = bnx2x_wait_rx_mode_comp_e2;
+		bp->rx_mode_obj.config_rx_mode = bnx2x_set_rx_mode_e2;
 	}
 }
 
diff --git a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.h b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.h
index 4048fc594..333809fce 100644
--- a/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.h
+++ b/drivers/net/ethernet/broadcom/bnx2x/bnx2x_sp.h
@@ -1436,8 +1436,7 @@ int bnx2x_vlan_mac_move(struct bnx2x *bp,
 
 /********************* RX MODE ****************/
 
-void bnx2x_init_rx_mode_obj(struct bnx2x *bp,
-			    struct bnx2x_rx_mode_obj *o);
+void bnx2x_init_rx_mode_obj(struct bnx2x *bp);
 
 /**
  * bnx2x_config_rx_mode - Send and RX_MODE ramrod according to the provided parameters.
diff --git a/drivers/net/ethernet/broadcom/bnxt/bnxt.c b/drivers/net/ethernet/broadcom/bnxt/bnxt.c
index 228c964e7..7bbb29da2 100644
--- a/drivers/net/ethernet/broadcom/bnxt/bnxt.c
+++ b/drivers/net/ethernet/broadcom/bnxt/bnxt.c
@@ -6915,7 +6915,7 @@ init_err_free:
  * this device has been detected.
  */
 static pci_ers_result_t bnxt_io_error_detected(struct pci_dev *pdev,
-					       pci_channel_state_t state)
+					       enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct bnxt *bp = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/broadcom/tg3.c b/drivers/net/ethernet/broadcom/tg3.c
index 6c4652b52..639451889 100644
--- a/drivers/net/ethernet/broadcom/tg3.c
+++ b/drivers/net/ethernet/broadcom/tg3.c
@@ -18103,7 +18103,7 @@ static void tg3_shutdown(struct pci_dev *pdev)
  * this device has been detected.
  */
 static pci_ers_result_t tg3_io_error_detected(struct pci_dev *pdev,
-					      pci_channel_state_t state)
+					      enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct tg3 *tp = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/broadcom/tg3.h b/drivers/net/ethernet/broadcom/tg3.h
index 3b5e98ecb..52b391656 100644
--- a/drivers/net/ethernet/broadcom/tg3.h
+++ b/drivers/net/ethernet/broadcom/tg3.h
@@ -150,6 +150,7 @@
 #define  CHIPREV_ID_5750_A0		 0x4000
 #define  CHIPREV_ID_5750_A1		 0x4001
 #define  CHIPREV_ID_5750_A3		 0x4003
+#define  CHIPREV_ID_5750_C1		 0x4201
 #define  CHIPREV_ID_5750_C2		 0x4202
 #define  CHIPREV_ID_5752_A0_HW		 0x5000
 #define  CHIPREV_ID_5752_A0		 0x6000
diff --git a/drivers/net/ethernet/brocade/bna/bfa_cs.h b/drivers/net/ethernet/brocade/bna/bfa_cs.h
index 1d11d666d..8f7a3cb9c 100644
--- a/drivers/net/ethernet/brocade/bna/bfa_cs.h
+++ b/drivers/net/ethernet/brocade/bna/bfa_cs.h
@@ -34,10 +34,19 @@ struct bfa_sm_table {
 	int		state;	/*!< state machine encoding	*/
 	char		*name;	/*!< state name for display	*/
 };
-#define BFA_SM(_sm)		((bfa_sm_t)(_sm))
+#define BFA_SM(_sm)		(_sm)
+
+#define bfa_sm_set_state(_sm, _state)	((_sm)->sm = (_state))
+#define bfa_sm_cmp_state(_sm, _state)	((_sm)->sm == (_state))
 
 /* State machine with entry actions. */
-typedef void (*bfa_fsm_t)(void *fsm, int event);
+struct bfa_ioc;
+enum ioc_event;
+struct bfa_iocpf;
+enum iocpf_event;
+
+typedef void (*bfa_fsm_ioc_t)(struct bfa_ioc *fsm, enum ioc_event event);
+typedef void (*bfa_fsm_iocpf_t)(struct bfa_iocpf *fsm, enum iocpf_event event);
 
 /* oc - object class eg. bfa_ioc
  * st - state, eg. reset
@@ -49,16 +58,37 @@ typedef void (*bfa_fsm_t)(void *fsm, int event);
 	static void oc ## _sm_ ## st ## _entry(otype * fsm)
 
 #define bfa_fsm_set_state(_fsm, _state) do {				\
-	(_fsm)->fsm = (bfa_fsm_t)(_state);				\
+	(_fsm)->fsm = (_state);						\
 	_state ## _entry(_fsm);						\
 } while (0)
 
 #define bfa_fsm_send_event(_fsm, _event)	((_fsm)->fsm((_fsm), (_event)))
-#define bfa_fsm_cmp_state(_fsm, _state)					\
-	((_fsm)->fsm == (bfa_fsm_t)(_state))
+#define bfa_fsm_cmp_state(_fsm, _state)		((_fsm)->fsm == (_state))
+
+/* For converting from state machine function to state encoding. */
+struct iocpf_sm_table {
+	bfa_fsm_iocpf_t	sm;	/*!< state machine function	*/
+	int		state;	/*!< state machine encoding	*/
+	char		*name;	/*!< state name for display	*/
+};
+struct ioc_sm_table {
+	bfa_fsm_ioc_t	sm;	/*!< state machine function	*/
+	int		state;	/*!< state machine encoding	*/
+	char		*name;	/*!< state name for display	*/
+};
+
+static inline int
+iocpf_sm_to_state(const struct iocpf_sm_table *smt, bfa_fsm_iocpf_t sm)
+{
+	int	i = 0;
+
+	while (smt[i].sm && smt[i].sm != sm)
+		i++;
+	return smt[i].state;
+}
 
 static inline int
-bfa_sm_to_state(const struct bfa_sm_table *smt, bfa_sm_t sm)
+ioc_sm_to_state(const struct ioc_sm_table *smt, bfa_fsm_ioc_t sm)
 {
 	int	i = 0;
 
diff --git a/drivers/net/ethernet/brocade/bna/bfa_ioc.c b/drivers/net/ethernet/brocade/bna/bfa_ioc.c
index 9e59663a6..3564807e8 100644
--- a/drivers/net/ethernet/brocade/bna/bfa_ioc.c
+++ b/drivers/net/ethernet/brocade/bna/bfa_ioc.c
@@ -122,7 +122,7 @@ bfa_fsm_state_decl(bfa_ioc, disabling, struct bfa_ioc, enum ioc_event);
 bfa_fsm_state_decl(bfa_ioc, disabled, struct bfa_ioc, enum ioc_event);
 bfa_fsm_state_decl(bfa_ioc, hwfail, struct bfa_ioc, enum ioc_event);
 
-static struct bfa_sm_table ioc_sm_table[] = {
+static struct ioc_sm_table ioc_sm_table[] = {
 	{BFA_SM(bfa_ioc_sm_uninit), BFA_IOC_UNINIT},
 	{BFA_SM(bfa_ioc_sm_reset), BFA_IOC_RESET},
 	{BFA_SM(bfa_ioc_sm_enabling), BFA_IOC_ENABLING},
@@ -191,7 +191,7 @@ bfa_fsm_state_decl(bfa_iocpf, disabling_sync, struct bfa_iocpf,
 						enum iocpf_event);
 bfa_fsm_state_decl(bfa_iocpf, disabled, struct bfa_iocpf, enum iocpf_event);
 
-static struct bfa_sm_table iocpf_sm_table[] = {
+static struct iocpf_sm_table iocpf_sm_table[] = {
 	{BFA_SM(bfa_iocpf_sm_reset), BFA_IOCPF_RESET},
 	{BFA_SM(bfa_iocpf_sm_fwcheck), BFA_IOCPF_FWMISMATCH},
 	{BFA_SM(bfa_iocpf_sm_mismatch), BFA_IOCPF_FWMISMATCH},
@@ -2862,12 +2862,12 @@ static enum bfa_ioc_state
 bfa_ioc_get_state(struct bfa_ioc *ioc)
 {
 	enum bfa_iocpf_state iocpf_st;
-	enum bfa_ioc_state ioc_st = bfa_sm_to_state(ioc_sm_table, ioc->fsm);
+	enum bfa_ioc_state ioc_st = ioc_sm_to_state(ioc_sm_table, ioc->fsm);
 
 	if (ioc_st == BFA_IOC_ENABLING ||
 		ioc_st == BFA_IOC_FAIL || ioc_st == BFA_IOC_INITFAIL) {
 
-		iocpf_st = bfa_sm_to_state(iocpf_sm_table, ioc->iocpf.fsm);
+		iocpf_st = iocpf_sm_to_state(iocpf_sm_table, ioc->iocpf.fsm);
 
 		switch (iocpf_st) {
 		case BFA_IOCPF_SEMWAIT:
@@ -2985,7 +2985,7 @@ bfa_nw_iocpf_timeout(struct bfa_ioc *ioc)
 {
 	enum bfa_iocpf_state iocpf_st;
 
-	iocpf_st = bfa_sm_to_state(iocpf_sm_table, ioc->iocpf.fsm);
+	iocpf_st = iocpf_sm_to_state(iocpf_sm_table, ioc->iocpf.fsm);
 
 	if (iocpf_st == BFA_IOCPF_HWINIT)
 		bfa_ioc_poll_fwinit(ioc);
diff --git a/drivers/net/ethernet/brocade/bna/bfa_ioc.h b/drivers/net/ethernet/brocade/bna/bfa_ioc.h
index 2c0b4c076..97873eb3c 100644
--- a/drivers/net/ethernet/brocade/bna/bfa_ioc.h
+++ b/drivers/net/ethernet/brocade/bna/bfa_ioc.h
@@ -156,7 +156,7 @@ struct bfa_ioc_notify {
 } while (0)
 
 struct bfa_iocpf {
-	bfa_fsm_t		fsm;
+	bfa_fsm_iocpf_t		fsm;
 	struct bfa_ioc		*ioc;
 	bool			fw_mismatch_notified;
 	bool			auto_recover;
@@ -164,7 +164,7 @@ struct bfa_iocpf {
 };
 
 struct bfa_ioc {
-	bfa_fsm_t		fsm;
+	bfa_fsm_ioc_t		fsm;
 	struct bfa		*bfa;
 	struct bfa_pcidev	pcidev;
 	struct timer_list	ioc_timer;
diff --git a/drivers/net/ethernet/brocade/bna/bfa_msgq.h b/drivers/net/ethernet/brocade/bna/bfa_msgq.h
index 66bc8b5ac..bf6446676 100644
--- a/drivers/net/ethernet/brocade/bna/bfa_msgq.h
+++ b/drivers/net/ethernet/brocade/bna/bfa_msgq.h
@@ -63,8 +63,10 @@ enum bfa_msgq_cmdq_flags {
 	BFA_MSGQ_CMDQ_F_DB_UPDATE	= 1,
 };
 
+enum cmdq_event;
+
 struct bfa_msgq_cmdq {
-	bfa_fsm_t			fsm;
+	void (*fsm)(struct bfa_msgq_cmdq *, enum cmdq_event);
 	enum bfa_msgq_cmdq_flags flags;
 
 	u16			producer_index;
@@ -89,8 +91,10 @@ enum bfa_msgq_rspq_flags {
 
 typedef void (*bfa_msgq_mcfunc_t)(void *cbarg, struct bfi_msgq_mhdr *mhdr);
 
+enum rspq_event;
+
 struct bfa_msgq_rspq {
-	bfa_fsm_t			fsm;
+	void (*fsm)(struct bfa_msgq_rspq *, enum rspq_event);
 	enum bfa_msgq_rspq_flags flags;
 
 	u16			producer_index;
diff --git a/drivers/net/ethernet/brocade/bna/bna_enet.c b/drivers/net/ethernet/brocade/bna/bna_enet.c
index 4e5c3874a..0791dab5b 100644
--- a/drivers/net/ethernet/brocade/bna/bna_enet.c
+++ b/drivers/net/ethernet/brocade/bna/bna_enet.c
@@ -1265,7 +1265,7 @@ bna_enet_mtu_get(struct bna_enet *enet)
 void
 bna_enet_enable(struct bna_enet *enet)
 {
-	if (enet->fsm != (bfa_sm_t)bna_enet_sm_stopped)
+	if (enet->fsm != bna_enet_sm_stopped)
 		return;
 
 	enet->flags |= BNA_ENET_F_ENABLED;
@@ -1676,10 +1676,10 @@ bna_cb_ioceth_reset(void *arg)
 }
 
 static struct bfa_ioc_cbfn bna_ioceth_cbfn = {
-	bna_cb_ioceth_enable,
-	bna_cb_ioceth_disable,
-	bna_cb_ioceth_hbfail,
-	bna_cb_ioceth_reset
+	.enable_cbfn = bna_cb_ioceth_enable,
+	.disable_cbfn = bna_cb_ioceth_disable,
+	.hbfail_cbfn = bna_cb_ioceth_hbfail,
+	.reset_cbfn = bna_cb_ioceth_reset
 };
 
 static void bna_attr_init(struct bna_ioceth *ioceth)
@@ -1759,12 +1759,12 @@ bna_ioceth_uninit(struct bna_ioceth *ioceth)
 void
 bna_ioceth_enable(struct bna_ioceth *ioceth)
 {
-	if (ioceth->fsm == (bfa_fsm_t)bna_ioceth_sm_ready) {
+	if (ioceth->fsm == bna_ioceth_sm_ready) {
 		bnad_cb_ioceth_ready(ioceth->bna->bnad);
 		return;
 	}
 
-	if (ioceth->fsm == (bfa_fsm_t)bna_ioceth_sm_stopped)
+	if (ioceth->fsm == bna_ioceth_sm_stopped)
 		bfa_fsm_send_event(ioceth, IOCETH_E_ENABLE);
 }
 
diff --git a/drivers/net/ethernet/brocade/bna/bna_tx_rx.c b/drivers/net/ethernet/brocade/bna/bna_tx_rx.c
index 95bc470ae..c12be9f97 100644
--- a/drivers/net/ethernet/brocade/bna/bna_tx_rx.c
+++ b/drivers/net/ethernet/brocade/bna/bna_tx_rx.c
@@ -1964,7 +1964,7 @@ static void
 bna_rx_stop(struct bna_rx *rx)
 {
 	rx->rx_flags &= ~BNA_RX_F_ENET_STARTED;
-	if (rx->fsm == (bfa_fsm_t) bna_rx_sm_stopped)
+	if (rx->fsm == bna_rx_sm_stopped)
 		bna_rx_mod_cb_rx_stopped(&rx->bna->rx_mod, rx);
 	else {
 		rx->stop_cbfn = bna_rx_mod_cb_rx_stopped;
@@ -2543,7 +2543,7 @@ bna_rx_destroy(struct bna_rx *rx)
 void
 bna_rx_enable(struct bna_rx *rx)
 {
-	if (rx->fsm != (bfa_sm_t)bna_rx_sm_stopped)
+	if (rx->fsm != bna_rx_sm_stopped)
 		return;
 
 	rx->rx_flags |= BNA_RX_F_ENABLED;
@@ -3531,7 +3531,7 @@ bna_tx_destroy(struct bna_tx *tx)
 void
 bna_tx_enable(struct bna_tx *tx)
 {
-	if (tx->fsm != (bfa_sm_t)bna_tx_sm_stopped)
+	if (tx->fsm != bna_tx_sm_stopped)
 		return;
 
 	tx->flags |= BNA_TX_F_ENABLED;
diff --git a/drivers/net/ethernet/brocade/bna/bna_types.h b/drivers/net/ethernet/brocade/bna/bna_types.h
index c438d032e..4653f43e8 100644
--- a/drivers/net/ethernet/brocade/bna/bna_types.h
+++ b/drivers/net/ethernet/brocade/bna/bna_types.h
@@ -320,8 +320,10 @@ struct bna_attr {
 
 /* IOCEth */
 
+enum bna_ioceth_event;
+
 struct bna_ioceth {
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bna_ioceth *, enum bna_ioceth_event);
 	struct bfa_ioc ioc;
 
 	struct bna_attr attr;
@@ -342,8 +344,10 @@ struct bna_pause_config {
 	enum bna_status rx_pause;
 };
 
+enum bna_enet_event;
+
 struct bna_enet {
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bna_enet *, enum bna_enet_event);
 	enum bna_enet_flags flags;
 
 	enum bna_enet_type type;
@@ -368,8 +372,10 @@ struct bna_enet {
 
 /* Ethport */
 
+enum bna_ethport_event;
+
 struct bna_ethport {
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bna_ethport *, enum bna_ethport_event);
 	enum bna_ethport_flags flags;
 
 	enum bna_link_status link_status;
@@ -462,13 +468,15 @@ struct bna_txq {
 };
 
 /* Tx object */
+enum bna_tx_event;
+
 struct bna_tx {
 	/* This should be the first one */
 	struct list_head			qe;
 	int			rid;
 	int			hw_id;
 
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bna_tx *, enum bna_tx_event);
 	enum bna_tx_flags flags;
 
 	enum bna_tx_type type;
@@ -706,8 +714,10 @@ struct bna_rxp {
 };
 
 /* RxF structure (hardware Rx Function) */
+enum bna_rxf_event;
+
 struct bna_rxf {
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bna_rxf *, enum bna_rxf_event);
 
 	struct bfa_msgq_cmd_entry msgq_cmd;
 	union {
@@ -777,13 +787,15 @@ struct bna_rxf {
 };
 
 /* Rx object */
+enum bna_rx_event;
+
 struct bna_rx {
 	/* This should be the first one */
 	struct list_head			qe;
 	int			rid;
 	int			hw_id;
 
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bna_rx *, enum bna_rx_event);
 
 	enum bna_rx_type type;
 
diff --git a/drivers/net/ethernet/brocade/bna/bnad.c b/drivers/net/ethernet/brocade/bna/bnad.c
index 2d81753d7..6da1b4044 100644
--- a/drivers/net/ethernet/brocade/bna/bnad.c
+++ b/drivers/net/ethernet/brocade/bna/bnad.c
@@ -1118,8 +1118,9 @@ bnad_cb_tx_resume(struct bnad *bnad, struct bna_tx *tx)
  * Free all TxQs buffers and then notify TX_E_CLEANUP_DONE to Tx fsm.
  */
 static void
-bnad_tx_cleanup(struct delayed_work *work)
+bnad_tx_cleanup(struct work_struct *_work)
 {
+	struct delayed_work *work = (struct delayed_work *)_work;
 	struct bnad_tx_info *tx_info =
 		container_of(work, struct bnad_tx_info, tx_cleanup_work);
 	struct bnad *bnad = NULL;
@@ -1197,7 +1198,7 @@ bnad_cb_rx_stall(struct bnad *bnad, struct bna_rx *rx)
  * Free all RxQs buffers and then notify RX_E_CLEANUP_DONE to Rx fsm.
  */
 static void
-bnad_rx_cleanup(void *work)
+bnad_rx_cleanup(struct work_struct *work)
 {
 	struct bnad_rx_info *rx_info =
 		container_of(work, struct bnad_rx_info, rx_cleanup_work);
@@ -2021,8 +2022,7 @@ bnad_setup_tx(struct bnad *bnad, u32 tx_id)
 	}
 	tx_info->tx = tx;
 
-	INIT_DELAYED_WORK(&tx_info->tx_cleanup_work,
-			(work_func_t)bnad_tx_cleanup);
+	INIT_DELAYED_WORK(&tx_info->tx_cleanup_work, bnad_tx_cleanup);
 
 	/* Register ISR for the Tx object */
 	if (intr_info->intr_type == BNA_INTR_T_MSIX) {
@@ -2278,8 +2278,7 @@ bnad_setup_rx(struct bnad *bnad, u32 rx_id)
 	rx_info->rx = rx;
 	spin_unlock_irqrestore(&bnad->bna_lock, flags);
 
-	INIT_WORK(&rx_info->rx_cleanup_work,
-			(work_func_t)(bnad_rx_cleanup));
+	INIT_WORK(&rx_info->rx_cleanup_work, bnad_rx_cleanup);
 
 	/*
 	 * Init NAPI, so that state is set to NAPI_STATE_SCHED,
diff --git a/drivers/net/ethernet/cadence/macb.c b/drivers/net/ethernet/cadence/macb.c
index ef0dbcfa6..8d94c4363 100644
--- a/drivers/net/ethernet/cadence/macb.c
+++ b/drivers/net/ethernet/cadence/macb.c
@@ -1342,7 +1342,7 @@ static inline int macb_clear_csum(struct sk_buff *skb)
 	return 0;
 }
 
-static int macb_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t macb_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	u16 queue_index = skb_get_queue_mapping(skb);
 	struct macb *bp = netdev_priv(dev);
@@ -2611,7 +2611,7 @@ static int at91ether_close(struct net_device *dev)
 }
 
 /* Transmit packet */
-static int at91ether_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t at91ether_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct macb *lp = netdev_priv(dev);
 
diff --git a/drivers/net/ethernet/cavium/liquidio/lio_main.c b/drivers/net/ethernet/cavium/liquidio/lio_main.c
index f00b44bf9..4c6a80864 100644
--- a/drivers/net/ethernet/cavium/liquidio/lio_main.c
+++ b/drivers/net/ethernet/cavium/liquidio/lio_main.c
@@ -466,7 +466,7 @@ static void stop_pci_io(struct octeon_device *oct)
  * this device has been detected.
  */
 static pci_ers_result_t liquidio_pcie_error_detected(struct pci_dev *pdev,
-						     pci_channel_state_t state)
+						     enum pci_channel_state state)
 {
 	struct octeon_device *oct = pci_get_drvdata(pdev);
 
@@ -2867,7 +2867,7 @@ static inline int send_nic_timestamp_pkt(struct octeon_device *oct,
  * @returns whether the packet was transmitted to the device okay or not
  *             (NETDEV_TX_OK or NETDEV_TX_BUSY)
  */
-static int liquidio_xmit(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t liquidio_xmit(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct lio *lio;
 	struct octnet_buf_free_info *finfo;
@@ -3369,7 +3369,7 @@ static void liquidio_del_vxlan_port(struct net_device *netdev,
 				    OCTNET_CMD_VXLAN_PORT_DEL);
 }
 
-static struct net_device_ops lionetdevops = {
+static net_device_ops_no_const lionetdevops __read_only = {
 	.ndo_open		= liquidio_open,
 	.ndo_stop		= liquidio_stop,
 	.ndo_start_xmit		= liquidio_xmit,
@@ -3597,8 +3597,11 @@ static int setup_nic_devices(struct octeon_device *octeon_dev)
 
 		SET_NETDEV_DEV(netdev, &octeon_dev->pci_dev->dev);
 
-		if (num_iqueues > 1)
+		if (num_iqueues > 1) {
+			pax_open_kernel();
 			lionetdevops.ndo_select_queue = select_q;
+			pax_close_kernel();
+		}
 
 		/* Associate the routines that will handle different
 		 * netdev tasks.
diff --git a/drivers/net/ethernet/chelsio/cxgb3/cxgb3_main.c b/drivers/net/ethernet/chelsio/cxgb3/cxgb3_main.c
index 79570e781..64de71405 100644
--- a/drivers/net/ethernet/chelsio/cxgb3/cxgb3_main.c
+++ b/drivers/net/ethernet/chelsio/cxgb3/cxgb3_main.c
@@ -2990,7 +2990,7 @@ void t3_fatal_err(struct adapter *adapter)
  * this device has been detected.
  */
 static pci_ers_result_t t3_io_error_detected(struct pci_dev *pdev,
-					     pci_channel_state_t state)
+					     enum pci_channel_state state)
 {
 	struct adapter *adapter = pci_get_drvdata(pdev);
 
diff --git a/drivers/net/ethernet/chelsio/cxgb3/l2t.h b/drivers/net/ethernet/chelsio/cxgb3/l2t.h
index 8cffcdfd5..aadf0431e 100644
--- a/drivers/net/ethernet/chelsio/cxgb3/l2t.h
+++ b/drivers/net/ethernet/chelsio/cxgb3/l2t.h
@@ -87,7 +87,7 @@ typedef void (*arp_failure_handler_func)(struct t3cdev * dev,
  */
 struct l2t_skb_cb {
 	arp_failure_handler_func arp_failure_handler;
-};
+} __no_const;
 
 #define L2T_SKB_CB(skb) ((struct l2t_skb_cb *)(skb)->cb)
 
diff --git a/drivers/net/ethernet/chelsio/cxgb4/cxgb4_main.c b/drivers/net/ethernet/chelsio/cxgb4/cxgb4_main.c
index 6694233e2..de0bc5870 100644
--- a/drivers/net/ethernet/chelsio/cxgb4/cxgb4_main.c
+++ b/drivers/net/ethernet/chelsio/cxgb4/cxgb4_main.c
@@ -4192,7 +4192,7 @@ bye:
 /* EEH callbacks */
 
 static pci_ers_result_t eeh_err_detected(struct pci_dev *pdev,
-					 pci_channel_state_t state)
+					 enum pci_channel_state state)
 {
 	int i;
 	struct adapter *adap = pci_get_drvdata(pdev);
diff --git a/drivers/net/ethernet/chelsio/cxgb4vf/adapter.h b/drivers/net/ethernet/chelsio/cxgb4vf/adapter.h
index 109bc6304..646ff4d8b 100644
--- a/drivers/net/ethernet/chelsio/cxgb4vf/adapter.h
+++ b/drivers/net/ethernet/chelsio/cxgb4vf/adapter.h
@@ -558,7 +558,7 @@ int t4vf_sge_alloc_eth_txq(struct adapter *, struct sge_eth_txq *,
 			   unsigned int);
 void t4vf_free_sge_resources(struct adapter *);
 
-int t4vf_eth_xmit(struct sk_buff *, struct net_device *);
+netdev_tx_t t4vf_eth_xmit(struct sk_buff *, struct net_device *);
 int t4vf_ethrx_handler(struct sge_rspq *, const __be64 *,
 		       const struct pkt_gl *);
 
diff --git a/drivers/net/ethernet/chelsio/cxgb4vf/sge.c b/drivers/net/ethernet/chelsio/cxgb4vf/sge.c
index c8fd4f8fe..af708fc84 100644
--- a/drivers/net/ethernet/chelsio/cxgb4vf/sge.c
+++ b/drivers/net/ethernet/chelsio/cxgb4vf/sge.c
@@ -1159,7 +1159,7 @@ static inline void txq_advance(struct sge_txq *tq, unsigned int n)
  *
  *	Add a packet to an SGE Ethernet TX queue.  Runs with softirqs disabled.
  */
-int t4vf_eth_xmit(struct sk_buff *skb, struct net_device *dev)
+netdev_tx_t t4vf_eth_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	u32 wr_mid;
 	u64 cntrl, *end;
diff --git a/drivers/net/ethernet/davicom/dm9000.c b/drivers/net/ethernet/davicom/dm9000.c
index f45385f5c..24f6c11ee 100644
--- a/drivers/net/ethernet/davicom/dm9000.c
+++ b/drivers/net/ethernet/davicom/dm9000.c
@@ -1021,7 +1021,7 @@ static void dm9000_send_packet(struct net_device *dev,
  *  Hardware start transmission.
  *  Send a packet to media from the upper layer.
  */
-static int
+static netdev_tx_t
 dm9000_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	unsigned long flags;
diff --git a/drivers/net/ethernet/dec/tulip/de4x5.c b/drivers/net/ethernet/dec/tulip/de4x5.c
index f0e9e2ef6..442241e20 100644
--- a/drivers/net/ethernet/dec/tulip/de4x5.c
+++ b/drivers/net/ethernet/dec/tulip/de4x5.c
@@ -912,7 +912,7 @@ static int     de4x5_init(struct net_device *dev);
 static int     de4x5_sw_reset(struct net_device *dev);
 static int     de4x5_rx(struct net_device *dev);
 static int     de4x5_tx(struct net_device *dev);
-static void    de4x5_ast(struct net_device *dev);
+static void    de4x5_ast(unsigned long _dev);
 static int     de4x5_txur(struct net_device *dev);
 static int     de4x5_rx_ovfc(struct net_device *dev);
 
@@ -1149,7 +1149,7 @@ de4x5_hw_init(struct net_device *dev, u_long iobase, struct device *gendev)
 	lp->gendev = gendev;
 	spin_lock_init(&lp->lock);
 	init_timer(&lp->timer);
-	lp->timer.function = (void (*)(unsigned long))de4x5_ast;
+	lp->timer.function = de4x5_ast;
 	lp->timer.data = (unsigned long)dev;
 	de4x5_parse_params(dev);
 
@@ -1743,8 +1743,9 @@ de4x5_tx(struct net_device *dev)
 }
 
 static void
-de4x5_ast(struct net_device *dev)
+de4x5_ast(unsigned long _dev)
 {
+	struct net_device *dev = (struct net_device *)_dev;
 	struct de4x5_private *lp = netdev_priv(dev);
 	int next_tick = DE4X5_AUTOSENSE_MS;
 	int dt;
@@ -2371,7 +2372,7 @@ autoconf_media(struct net_device *dev)
 	lp->media = INIT;
 	lp->tcount = 0;
 
-	de4x5_ast(dev);
+	de4x5_ast((unsigned long)dev);
 
 	return lp->media;
 }
@@ -5376,7 +5377,7 @@ de4x5_ioctl(struct net_device *dev, struct ifreq *rq, int cmd)
 	for (i=0; i<ETH_ALEN; i++) {
 	    tmp.addr[i] = dev->dev_addr[i];
 	}
-	if (copy_to_user(ioc->data, tmp.addr, ioc->len)) return -EFAULT;
+	if (ioc->len > sizeof tmp.addr || copy_to_user(ioc->data, tmp.addr, ioc->len)) return -EFAULT;
 	break;
 
     case DE4X5_SET_HWADDR:           /* Set the hardware address */
@@ -5416,7 +5417,7 @@ de4x5_ioctl(struct net_device *dev, struct ifreq *rq, int cmd)
 	spin_lock_irqsave(&lp->lock, flags);
 	memcpy(&statbuf, &lp->pktStats, ioc->len);
 	spin_unlock_irqrestore(&lp->lock, flags);
-	if (copy_to_user(ioc->data, &statbuf, ioc->len))
+	if (ioc->len > sizeof statbuf || copy_to_user(ioc->data, &statbuf, ioc->len))
 		return -EFAULT;
 	break;
     }
diff --git a/drivers/net/ethernet/emulex/benet/be_main.c b/drivers/net/ethernet/emulex/benet/be_main.c
index 874c7539a..e161da1cc 100644
--- a/drivers/net/ethernet/emulex/benet/be_main.c
+++ b/drivers/net/ethernet/emulex/benet/be_main.c
@@ -556,7 +556,7 @@ static void accumulate_16bit_val(u32 *acc, u16 val)
 
 	if (wrapped)
 		newacc += 65536;
-	ACCESS_ONCE(*acc) = newacc;
+	ACCESS_ONCE_RW(*acc) = newacc;
 }
 
 static void populate_erx_stats(struct be_adapter *adapter,
@@ -5544,7 +5544,7 @@ static void be_shutdown(struct pci_dev *pdev)
 }
 
 static pci_ers_result_t be_eeh_err_detected(struct pci_dev *pdev,
-					    pci_channel_state_t state)
+					    enum pci_channel_state state)
 {
 	struct be_adapter *adapter = pci_get_drvdata(pdev);
 
diff --git a/drivers/net/ethernet/faraday/ftgmac100.c b/drivers/net/ethernet/faraday/ftgmac100.c
index 36361f8bf..b3b5f9fe8 100644
--- a/drivers/net/ethernet/faraday/ftgmac100.c
+++ b/drivers/net/ethernet/faraday/ftgmac100.c
@@ -26,6 +26,7 @@
 #include <linux/ethtool.h>
 #include <linux/interrupt.h>
 #include <linux/io.h>
+#include <linux/irqreturn.h>
 #include <linux/module.h>
 #include <linux/netdevice.h>
 #include <linux/phy.h>
@@ -1174,7 +1175,7 @@ static int ftgmac100_stop(struct net_device *netdev)
 	return 0;
 }
 
-static int ftgmac100_hard_start_xmit(struct sk_buff *skb,
+static netdev_tx_t ftgmac100_hard_start_xmit(struct sk_buff *skb,
 				     struct net_device *netdev)
 {
 	struct ftgmac100 *priv = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/faraday/ftmac100.c b/drivers/net/ethernet/faraday/ftmac100.c
index dce5f7b7f..222e70996 100644
--- a/drivers/net/ethernet/faraday/ftmac100.c
+++ b/drivers/net/ethernet/faraday/ftmac100.c
@@ -31,6 +31,8 @@
 #include <linux/module.h>
 #include <linux/netdevice.h>
 #include <linux/platform_device.h>
+#include <linux/interrupt.h>
+#include <linux/irqreturn.h>
 
 #include "ftmac100.h"
 
@@ -1009,7 +1011,7 @@ static int ftmac100_stop(struct net_device *netdev)
 	return 0;
 }
 
-static int ftmac100_hard_start_xmit(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t ftmac100_hard_start_xmit(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct ftmac100 *priv = netdev_priv(netdev);
 	dma_addr_t map;
diff --git a/drivers/net/ethernet/freescale/fec_mpc52xx.c b/drivers/net/ethernet/freescale/fec_mpc52xx.c
index 446ae9d60..79d1d754a 100644
--- a/drivers/net/ethernet/freescale/fec_mpc52xx.c
+++ b/drivers/net/ethernet/freescale/fec_mpc52xx.c
@@ -305,7 +305,7 @@ static int mpc52xx_fec_close(struct net_device *dev)
  * invariant will hold if you make sure that the netif_*_queue()
  * calls are done at the proper times.
  */
-static int mpc52xx_fec_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t mpc52xx_fec_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct mpc52xx_fec_priv *priv = netdev_priv(dev);
 	struct bcom_fec_bd *bd;
diff --git a/drivers/net/ethernet/freescale/fs_enet/fs_enet-main.c b/drivers/net/ethernet/freescale/fs_enet/fs_enet-main.c
index 61fd486c5..06047eb8a 100644
--- a/drivers/net/ethernet/freescale/fs_enet/fs_enet-main.c
+++ b/drivers/net/ethernet/freescale/fs_enet/fs_enet-main.c
@@ -509,7 +509,7 @@ static struct sk_buff *tx_skb_align_workaround(struct net_device *dev,
 }
 #endif
 
-static int fs_enet_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t fs_enet_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct fs_enet_private *fep = netdev_priv(dev);
 	cbd_t __iomem *bdp;
diff --git a/drivers/net/ethernet/freescale/gianfar.c b/drivers/net/ethernet/freescale/gianfar.c
index 4b4f5bc0e..23b3b007d 100644
--- a/drivers/net/ethernet/freescale/gianfar.c
+++ b/drivers/net/ethernet/freescale/gianfar.c
@@ -112,7 +112,7 @@
 const char gfar_driver_version[] = "2.0";
 
 static int gfar_enet_open(struct net_device *dev);
-static int gfar_start_xmit(struct sk_buff *skb, struct net_device *dev);
+static netdev_tx_t gfar_start_xmit(struct sk_buff *skb, struct net_device *dev);
 static void gfar_reset_task(struct work_struct *work);
 static void gfar_timeout(struct net_device *dev);
 static int gfar_close(struct net_device *dev);
@@ -2316,7 +2316,7 @@ static inline bool gfar_csum_errata_76(struct gfar_private *priv,
 /* This is called by the kernel when a frame is ready for transmission.
  * It is pointed to by the dev->hard_start_xmit function pointer
  */
-static int gfar_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t gfar_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct gfar_private *priv = netdev_priv(dev);
 	struct gfar_priv_tx_q *tx_queue = NULL;
diff --git a/drivers/net/ethernet/freescale/ucc_geth.c b/drivers/net/ethernet/freescale/ucc_geth.c
index 5bf1ade28..4e7466642 100644
--- a/drivers/net/ethernet/freescale/ucc_geth.c
+++ b/drivers/net/ethernet/freescale/ucc_geth.c
@@ -3085,7 +3085,7 @@ static int ucc_geth_startup(struct ucc_geth_private *ugeth)
 
 /* This is called by the kernel when a frame is ready for transmission. */
 /* It is pointed to by the dev->hard_start_xmit function pointer */
-static int ucc_geth_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t ucc_geth_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct ucc_geth_private *ugeth = netdev_priv(dev);
 #ifdef CONFIG_UGETH_TX_ON_DEMAND
diff --git a/drivers/net/ethernet/hisilicon/hip04_eth.c b/drivers/net/ethernet/hisilicon/hip04_eth.c
index 0c4afe95e..d888314f4 100644
--- a/drivers/net/ethernet/hisilicon/hip04_eth.c
+++ b/drivers/net/ethernet/hisilicon/hip04_eth.c
@@ -422,7 +422,7 @@ static void hip04_start_tx_timer(struct hip04_priv *priv)
 			       ns, HRTIMER_MODE_REL);
 }
 
-static int hip04_mac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t hip04_mac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct hip04_priv *priv = netdev_priv(ndev);
 	struct net_device_stats *stats = &ndev->stats;
diff --git a/drivers/net/ethernet/hisilicon/hix5hd2_gmac.c b/drivers/net/ethernet/hisilicon/hix5hd2_gmac.c
index 275618bb4..abd170397 100644
--- a/drivers/net/ethernet/hisilicon/hix5hd2_gmac.c
+++ b/drivers/net/ethernet/hisilicon/hix5hd2_gmac.c
@@ -600,7 +600,7 @@ static irqreturn_t hix5hd2_interrupt(int irq, void *dev_id)
 	return IRQ_HANDLED;
 }
 
-static int hix5hd2_net_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t hix5hd2_net_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct hix5hd2_priv *priv = netdev_priv(dev);
 	struct hix5hd2_desc *desc;
diff --git a/drivers/net/ethernet/hisilicon/hns/hns_ae_adapt.c b/drivers/net/ethernet/hisilicon/hns/hns_ae_adapt.c
index e28d96099..6168a0049 100644
--- a/drivers/net/ethernet/hisilicon/hns/hns_ae_adapt.c
+++ b/drivers/net/ethernet/hisilicon/hns/hns_ae_adapt.c
@@ -844,16 +844,18 @@ int hns_dsaf_ae_init(struct dsaf_device *dsaf_dev)
 	struct hnae_ae_dev *ae_dev = &dsaf_dev->ae_dev;
 	static atomic_t id = ATOMIC_INIT(-1);
 
+	pax_open_kernel();
 	switch (dsaf_dev->dsaf_ver) {
 	case AE_VERSION_1:
-		hns_dsaf_ops.toggle_ring_irq = hns_ae_toggle_ring_irq;
+		const_cast(hns_dsaf_ops.toggle_ring_irq) = hns_ae_toggle_ring_irq;
 		break;
 	case AE_VERSION_2:
-		hns_dsaf_ops.toggle_ring_irq = hns_aev2_toggle_ring_irq;
+		const_cast(hns_dsaf_ops.toggle_ring_irq) = hns_aev2_toggle_ring_irq;
 		break;
 	default:
 		break;
 	}
+	pax_close_kernel();
 
 	snprintf(ae_dev->name, AE_NAME_SIZE, "%s%d", DSAF_DEVICE_NAME,
 		 (int)atomic_inc_return(&id));
diff --git a/drivers/net/ethernet/hisilicon/hns/hns_dsaf_main.h b/drivers/net/ethernet/hisilicon/hns/hns_dsaf_main.h
index 1daf018d9..25482335b 100644
--- a/drivers/net/ethernet/hisilicon/hns/hns_dsaf_main.h
+++ b/drivers/net/ethernet/hisilicon/hns/hns_dsaf_main.h
@@ -318,7 +318,7 @@ struct dsaf_device {
 	struct ppe_common_cb *ppe_common[DSAF_COMM_DEV_NUM];
 	struct rcb_common_cb *rcb_common[DSAF_COMM_DEV_NUM];
 	struct hns_mac_cb *mac_cb[DSAF_MAX_PORT_NUM];
-	struct dsaf_misc_op *misc_op;
+	const struct dsaf_misc_op *misc_op;
 
 	struct dsaf_hw_stats hw_stats[DSAF_NODE_NUM];
 	struct dsaf_int_stat int_stat;
diff --git a/drivers/net/ethernet/hisilicon/hns/hns_dsaf_misc.c b/drivers/net/ethernet/hisilicon/hns/hns_dsaf_misc.c
index 611b67b6f..63ecdd482 100644
--- a/drivers/net/ethernet/hisilicon/hns/hns_dsaf_misc.c
+++ b/drivers/net/ethernet/hisilicon/hns/hns_dsaf_misc.c
@@ -522,48 +522,46 @@ hns_mac_config_sds_loopback_acpi(struct hns_mac_cb *mac_cb, bool en)
 
 struct dsaf_misc_op *hns_misc_op_get(struct dsaf_device *dsaf_dev)
 {
-	struct dsaf_misc_op *misc_op;
-
-	misc_op = devm_kzalloc(dsaf_dev->dev, sizeof(*misc_op), GFP_KERNEL);
-	if (!misc_op)
-		return NULL;
-
-	if (dev_of_node(dsaf_dev->dev)) {
-		misc_op->cpld_set_led = hns_cpld_set_led;
-		misc_op->cpld_reset_led = cpld_led_reset;
-		misc_op->cpld_set_led_id = cpld_set_led_id;
-
-		misc_op->dsaf_reset = hns_dsaf_rst;
-		misc_op->xge_srst = hns_dsaf_xge_srst_by_port;
-		misc_op->xge_core_srst = hns_dsaf_xge_core_srst_by_port;
-		misc_op->ge_srst = hns_dsaf_ge_srst_by_port;
-		misc_op->ppe_srst = hns_ppe_srst_by_port;
-		misc_op->ppe_comm_srst = hns_ppe_com_srst;
-
-		misc_op->get_phy_if = hns_mac_get_phy_if;
-		misc_op->get_sfp_prsnt = hns_mac_get_sfp_prsnt;
-
-		misc_op->cfg_serdes_loopback = hns_mac_config_sds_loopback;
-	} else if (is_acpi_node(dsaf_dev->dev->fwnode)) {
-		misc_op->cpld_set_led = hns_cpld_set_led;
-		misc_op->cpld_reset_led = cpld_led_reset;
-		misc_op->cpld_set_led_id = cpld_set_led_id;
-
-		misc_op->dsaf_reset = hns_dsaf_rst_acpi;
-		misc_op->xge_srst = hns_dsaf_xge_srst_by_port_acpi;
-		misc_op->xge_core_srst = hns_dsaf_xge_core_srst_by_port_acpi;
-		misc_op->ge_srst = hns_dsaf_ge_srst_by_port_acpi;
-		misc_op->ppe_srst = hns_ppe_srst_by_port_acpi;
-		misc_op->ppe_comm_srst = hns_ppe_com_srst;
-
-		misc_op->get_phy_if = hns_mac_get_phy_if_acpi;
-		misc_op->get_sfp_prsnt = hns_mac_get_sfp_prsnt;
-
-		misc_op->cfg_serdes_loopback = hns_mac_config_sds_loopback_acpi;
-	} else {
-		devm_kfree(dsaf_dev->dev, (void *)misc_op);
-		misc_op = NULL;
-	}
+	static const struct dsaf_misc_op dsaf_misc_ops = {
+		.cpld_set_led = hns_cpld_set_led,
+		.cpld_reset_led = cpld_led_reset,
+		.cpld_set_led_id = cpld_set_led_id,
+
+		.dsaf_reset = hns_dsaf_rst,
+		.xge_srst = hns_dsaf_xge_srst_by_port,
+		.xge_core_srst = hns_dsaf_xge_core_srst_by_port,
+		.ge_srst = hns_dsaf_ge_srst_by_port,
+		.ppe_srst = hns_ppe_srst_by_port,
+		.ppe_comm_srst = hns_ppe_com_srst,
+
+		.get_phy_if = hns_mac_get_phy_if,
+		.get_sfp_prsnt = hns_mac_get_sfp_prsnt,
+
+		.cfg_serdes_loopback = hns_mac_config_sds_loopback,
+	};
+
+	static const struct dsaf_misc_op dsaf_misc_ops_acpi = {
+		.cpld_set_led = hns_cpld_set_led,
+		.cpld_reset_led = cpld_led_reset,
+		.cpld_set_led_id = cpld_set_led_id,
+
+		.dsaf_reset = hns_dsaf_rst_acpi,
+		.xge_srst = hns_dsaf_xge_srst_by_port_acpi,
+		.xge_core_srst = hns_dsaf_xge_core_srst_by_port_acpi,
+		.ge_srst = hns_dsaf_ge_srst_by_port_acpi,
+		.ppe_srst = hns_ppe_srst_by_port_acpi,
+		.ppe_comm_srst = hns_ppe_com_srst,
+
+		.get_phy_if = hns_mac_get_phy_if_acpi,
+		.get_sfp_prsnt = hns_mac_get_sfp_prsnt,
+
+		.cfg_serdes_loopback = hns_mac_config_sds_loopback_acpi,
+	};
+
+	if (dev_of_node(dsaf_dev->dev))
+		return &dsaf_misc_ops;
+	else if (is_acpi_node(dsaf_dev->dev->fwnode))
+		return &dsaf_misc_ops_acpi;
 
-	return (void *)misc_op;
+	return NULL;
 }
diff --git a/drivers/net/ethernet/i825xx/lib82596.c b/drivers/net/ethernet/i825xx/lib82596.c
index 3dbc53c21..fa08fb88e 100644
--- a/drivers/net/ethernet/i825xx/lib82596.c
+++ b/drivers/net/ethernet/i825xx/lib82596.c
@@ -347,7 +347,7 @@ static const char init_setup[] =
 	0x7f /*  *multi IA */ };
 
 static int i596_open(struct net_device *dev);
-static int i596_start_xmit(struct sk_buff *skb, struct net_device *dev);
+static netdev_tx_t i596_start_xmit(struct sk_buff *skb, struct net_device *dev);
 static irqreturn_t i596_interrupt(int irq, void *dev_id);
 static int i596_close(struct net_device *dev);
 static void i596_add_cmd(struct net_device *dev, struct i596_cmd *cmd);
@@ -965,7 +965,7 @@ static void i596_tx_timeout (struct net_device *dev)
 }
 
 
-static int i596_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t i596_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct i596_private *lp = netdev_priv(dev);
 	struct tx_cmd *tx_cmd;
diff --git a/drivers/net/ethernet/ibm/ehea/ehea_main.c b/drivers/net/ethernet/ibm/ehea/ehea_main.c
index 54efa9a51..0d297bdd6 100644
--- a/drivers/net/ethernet/ibm/ehea/ehea_main.c
+++ b/drivers/net/ethernet/ibm/ehea/ehea_main.c
@@ -2047,7 +2047,7 @@ static void ehea_xmit3(struct sk_buff *skb, struct net_device *dev,
 	dev_consume_skb_any(skb);
 }
 
-static int ehea_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t ehea_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct ehea_port *port = netdev_priv(dev);
 	struct ehea_swqe *swqe;
diff --git a/drivers/net/ethernet/ibm/emac/core.c b/drivers/net/ethernet/ibm/emac/core.c
index 7af09cbc5..010411af9 100644
--- a/drivers/net/ethernet/ibm/emac/core.c
+++ b/drivers/net/ethernet/ibm/emac/core.c
@@ -1415,7 +1415,7 @@ static inline int emac_xmit_finish(struct emac_instance *dev, int len)
 }
 
 /* Tx lock BH */
-static int emac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t emac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct emac_instance *dev = netdev_priv(ndev);
 	unsigned int len = skb->len;
@@ -1473,7 +1473,7 @@ static inline int emac_xmit_split(struct emac_instance *dev, int slot,
 }
 
 /* Tx lock BH disabled (SG version for TAH equipped EMACs) */
-static int emac_start_xmit_sg(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t emac_start_xmit_sg(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct emac_instance *dev = netdev_priv(ndev);
 	int nr_frags = skb_shinfo(skb)->nr_frags;
diff --git a/drivers/net/ethernet/intel/e100.c b/drivers/net/ethernet/intel/e100.c
index 8c8363dac..25e112563 100644
--- a/drivers/net/ethernet/intel/e100.c
+++ b/drivers/net/ethernet/intel/e100.c
@@ -3105,7 +3105,7 @@ static void e100_shutdown(struct pci_dev *pdev)
  * @pdev: Pointer to PCI device
  * @state: The current pci connection state
  */
-static pci_ers_result_t e100_io_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+static pci_ers_result_t e100_io_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct nic *nic = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/intel/e1000/e1000_main.c b/drivers/net/ethernet/intel/e1000/e1000_main.c
index f42129d09..d2e3932b2 100644
--- a/drivers/net/ethernet/intel/e1000/e1000_main.c
+++ b/drivers/net/ethernet/intel/e1000/e1000_main.c
@@ -5272,7 +5272,7 @@ static void e1000_netpoll(struct net_device *netdev)
  * this device has been detected.
  */
 static pci_ers_result_t e1000_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+							enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct e1000_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/intel/e1000e/netdev.c b/drivers/net/ethernet/intel/e1000e/netdev.c
index 7017281ba..6bbf47ec4 100644
--- a/drivers/net/ethernet/intel/e1000e/netdev.c
+++ b/drivers/net/ethernet/intel/e1000e/netdev.c
@@ -6784,7 +6784,7 @@ static void e1000_netpoll(struct net_device *netdev)
  * this device has been detected.
  */
 static pci_ers_result_t e1000_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct e1000_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/intel/fm10k/fm10k_pci.c b/drivers/net/ethernet/intel/fm10k/fm10k_pci.c
index 774a5654b..38b03e2b2 100644
--- a/drivers/net/ethernet/intel/fm10k/fm10k_pci.c
+++ b/drivers/net/ethernet/intel/fm10k/fm10k_pci.c
@@ -2249,7 +2249,7 @@ static int fm10k_suspend(struct pci_dev *pdev,
  * this device has been detected.
  */
 static pci_ers_result_t fm10k_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct fm10k_intfc *interface = pci_get_drvdata(pdev);
 	struct net_device *netdev = interface->netdev;
diff --git a/drivers/net/ethernet/intel/i40e/i40e_ptp.c b/drivers/net/ethernet/intel/i40e/i40e_ptp.c
index ed39cbad2..76569b92f 100644
--- a/drivers/net/ethernet/intel/i40e/i40e_ptp.c
+++ b/drivers/net/ethernet/intel/i40e/i40e_ptp.c
@@ -417,7 +417,7 @@ void i40e_ptp_set_increment(struct i40e_pf *pf)
 	wr32(hw, I40E_PRTTSYN_INC_H, incval >> 32);
 
 	/* Update the base adjustement value. */
-	ACCESS_ONCE(pf->ptp_base_adj) = incval;
+	ACCESS_ONCE_RW(pf->ptp_base_adj) = incval;
 	smp_mb(); /* Force the above update. */
 }
 
diff --git a/drivers/net/ethernet/intel/igb/igb_main.c b/drivers/net/ethernet/intel/igb/igb_main.c
index 942a89fb0..5ca83a98b 100644
--- a/drivers/net/ethernet/intel/igb/igb_main.c
+++ b/drivers/net/ethernet/intel/igb/igb_main.c
@@ -7809,7 +7809,7 @@ static void igb_netpoll(struct net_device *netdev)
  *  this device has been detected.
  **/
 static pci_ers_result_t igb_io_error_detected(struct pci_dev *pdev,
-					      pci_channel_state_t state)
+					      enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct igb_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/intel/igbvf/netdev.c b/drivers/net/ethernet/intel/igbvf/netdev.c
index b0778ba65..ed4357a2a 100644
--- a/drivers/net/ethernet/intel/igbvf/netdev.c
+++ b/drivers/net/ethernet/intel/igbvf/netdev.c
@@ -2511,7 +2511,7 @@ static void igbvf_netpoll(struct net_device *netdev)
  * this device has been detected.
  */
 static pci_ers_result_t igbvf_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct igbvf_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/intel/ixgbe/ixgbe_main.c b/drivers/net/ethernet/intel/ixgbe/ixgbe_main.c
index b4f03748a..e174bd76e 100644
--- a/drivers/net/ethernet/intel/ixgbe/ixgbe_main.c
+++ b/drivers/net/ethernet/intel/ixgbe/ixgbe_main.c
@@ -9846,7 +9846,7 @@ static void ixgbe_remove(struct pci_dev *pdev)
  * this device has been detected.
  */
 static pci_ers_result_t ixgbe_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct ixgbe_adapter *adapter = pci_get_drvdata(pdev);
 	struct net_device *netdev = adapter->netdev;
diff --git a/drivers/net/ethernet/intel/ixgbe/ixgbe_ptp.c b/drivers/net/ethernet/intel/ixgbe/ixgbe_ptp.c
index e5431bfe3..1db690e7c 100644
--- a/drivers/net/ethernet/intel/ixgbe/ixgbe_ptp.c
+++ b/drivers/net/ethernet/intel/ixgbe/ixgbe_ptp.c
@@ -1122,7 +1122,7 @@ void ixgbe_ptp_start_cyclecounter(struct ixgbe_adapter *adapter)
 	}
 
 	/* update the base incval used to calculate frequency adjustment */
-	ACCESS_ONCE(adapter->base_incval) = incval;
+	ACCESS_ONCE_RW(adapter->base_incval) = incval;
 	smp_mb();
 
 	/* need lock to prevent incorrect read while modifying cyclecounter */
diff --git a/drivers/net/ethernet/intel/ixgbevf/ixgbevf_main.c b/drivers/net/ethernet/intel/ixgbevf/ixgbevf_main.c
index d9d6616f0..3331f2844 100644
--- a/drivers/net/ethernet/intel/ixgbevf/ixgbevf_main.c
+++ b/drivers/net/ethernet/intel/ixgbevf/ixgbevf_main.c
@@ -3622,7 +3622,7 @@ static int ixgbevf_maybe_stop_tx(struct ixgbevf_ring *tx_ring, int size)
 	return __ixgbevf_maybe_stop_tx(tx_ring, size);
 }
 
-static int ixgbevf_xmit_frame(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t ixgbevf_xmit_frame(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct ixgbevf_adapter *adapter = netdev_priv(netdev);
 	struct ixgbevf_tx_buffer *first;
@@ -4212,7 +4212,7 @@ static void ixgbevf_remove(struct pci_dev *pdev)
  * this device has been detected.
  **/
 static pci_ers_result_t ixgbevf_io_error_detected(struct pci_dev *pdev,
-						  pci_channel_state_t state)
+						  enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct ixgbevf_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/marvell/mvneta.c b/drivers/net/ethernet/marvell/mvneta.c
index d41c28d00..ef80211f0 100644
--- a/drivers/net/ethernet/marvell/mvneta.c
+++ b/drivers/net/ethernet/marvell/mvneta.c
@@ -2290,7 +2290,7 @@ error:
 }
 
 /* Main tx processing */
-static int mvneta_tx(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t mvneta_tx(struct sk_buff *skb, struct net_device *dev)
 {
 	struct mvneta_port *pp = netdev_priv(dev);
 	u16 txq_id = skb_get_queue_mapping(skb);
diff --git a/drivers/net/ethernet/marvell/mvpp2.c b/drivers/net/ethernet/marvell/mvpp2.c
index 5588c560e..d62eadede 100644
--- a/drivers/net/ethernet/marvell/mvpp2.c
+++ b/drivers/net/ethernet/marvell/mvpp2.c
@@ -5237,7 +5237,7 @@ error:
 }
 
 /* Main tx processing */
-static int mvpp2_tx(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t mvpp2_tx(struct sk_buff *skb, struct net_device *dev)
 {
 	struct mvpp2_port *port = netdev_priv(dev);
 	struct mvpp2_tx_queue *txq, *aggr_txq;
diff --git a/drivers/net/ethernet/marvell/pxa168_eth.c b/drivers/net/ethernet/marvell/pxa168_eth.c
index 5d5000c8e..7437949ff 100644
--- a/drivers/net/ethernet/marvell/pxa168_eth.c
+++ b/drivers/net/ethernet/marvell/pxa168_eth.c
@@ -1271,7 +1271,7 @@ static int pxa168_rx_poll(struct napi_struct *napi, int budget)
 	return work_done;
 }
 
-static int pxa168_eth_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t pxa168_eth_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct pxa168_eth_private *pep = netdev_priv(dev);
 	struct net_device_stats *stats = &dev->stats;
diff --git a/drivers/net/ethernet/mellanox/mlx4/en_tx.c b/drivers/net/ethernet/mellanox/mlx4/en_tx.c
index e2509bba3..8357fefcc 100644
--- a/drivers/net/ethernet/mellanox/mlx4/en_tx.c
+++ b/drivers/net/ethernet/mellanox/mlx4/en_tx.c
@@ -495,8 +495,8 @@ static bool mlx4_en_process_tx_cq(struct net_device *dev,
 	wmb();
 
 	/* we want to dirty this cache line once */
-	ACCESS_ONCE(ring->last_nr_txbb) = last_nr_txbb;
-	ACCESS_ONCE(ring->cons) = ring_cons + txbbs_skipped;
+	ACCESS_ONCE_RW(ring->last_nr_txbb) = last_nr_txbb;
+	ACCESS_ONCE_RW(ring->cons) = ring_cons + txbbs_skipped;
 
 	if (ring->free_tx_desc == mlx4_en_recycle_tx_desc)
 		return done < budget;
diff --git a/drivers/net/ethernet/mellanox/mlx4/main.c b/drivers/net/ethernet/mellanox/mlx4/main.c
index 7183ac413..691c517b1 100644
--- a/drivers/net/ethernet/mellanox/mlx4/main.c
+++ b/drivers/net/ethernet/mellanox/mlx4/main.c
@@ -4061,7 +4061,7 @@ static const struct pci_device_id mlx4_pci_table[] = {
 MODULE_DEVICE_TABLE(pci, mlx4_pci_table);
 
 static pci_ers_result_t mlx4_pci_err_detected(struct pci_dev *pdev,
-					      pci_channel_state_t state)
+					      enum pci_channel_state state)
 {
 	struct mlx4_dev_persistent *persist = pci_get_drvdata(pdev);
 
diff --git a/drivers/net/ethernet/mellanox/mlx5/core/main.c b/drivers/net/ethernet/mellanox/mlx5/core/main.c
index 2385bae92..5413c5046 100644
--- a/drivers/net/ethernet/mellanox/mlx5/core/main.c
+++ b/drivers/net/ethernet/mellanox/mlx5/core/main.c
@@ -1412,7 +1412,7 @@ static void remove_one(struct pci_dev *pdev)
 }
 
 static pci_ers_result_t mlx5_pci_err_detected(struct pci_dev *pdev,
-					      pci_channel_state_t state)
+					      enum pci_channel_state state)
 {
 	struct mlx5_core_dev *dev = pci_get_drvdata(pdev);
 	struct mlx5_priv *priv = &dev->priv;
diff --git a/drivers/net/ethernet/mellanox/mlxsw/spectrum.c b/drivers/net/ethernet/mellanox/mlxsw/spectrum.c
index 5cdc96bdd..4c2a81828 100644
--- a/drivers/net/ethernet/mellanox/mlxsw/spectrum.c
+++ b/drivers/net/ethernet/mellanox/mlxsw/spectrum.c
@@ -4535,16 +4535,16 @@ static int mlxsw_sp_netdevice_event(struct notifier_block *unused,
 	return notifier_from_errno(err);
 }
 
-static struct notifier_block mlxsw_sp_netdevice_nb __read_mostly = {
+static struct notifier_block mlxsw_sp_netdevice_nb = {
 	.notifier_call = mlxsw_sp_netdevice_event,
 };
 
-static struct notifier_block mlxsw_sp_inetaddr_nb __read_mostly = {
+static struct notifier_block mlxsw_sp_inetaddr_nb = {
 	.notifier_call = mlxsw_sp_inetaddr_event,
 	.priority = 10,	/* Must be called before FIB notifier block */
 };
 
-static struct notifier_block mlxsw_sp_router_netevent_nb __read_mostly = {
+static struct notifier_block mlxsw_sp_router_netevent_nb = {
 	.notifier_call = mlxsw_sp_router_netevent_event,
 };
 
diff --git a/drivers/net/ethernet/micrel/ks8695net.c b/drivers/net/ethernet/micrel/ks8695net.c
index 20cb85bc0..6135d90f3 100644
--- a/drivers/net/ethernet/micrel/ks8695net.c
+++ b/drivers/net/ethernet/micrel/ks8695net.c
@@ -1156,7 +1156,7 @@ ks8695_timeout(struct net_device *ndev)
  *	sk_buff and adds it to the TX ring. It then kicks the TX DMA
  *	engine to ensure transmission begins.
  */
-static int
+static netdev_tx_t
 ks8695_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct ks8695_priv *ksp = netdev_priv(ndev);
diff --git a/drivers/net/ethernet/micrel/ks8851_mll.c b/drivers/net/ethernet/micrel/ks8851_mll.c
index 2fc5cd56c..6c6108a40 100644
--- a/drivers/net/ethernet/micrel/ks8851_mll.c
+++ b/drivers/net/ethernet/micrel/ks8851_mll.c
@@ -1020,7 +1020,7 @@ static void ks_write_qmu(struct ks_net *ks, u8 *pdata, u16 len)
  * spin_lock_irqsave is required because tx and rx should be mutual exclusive.
  * So while tx is in-progress, prevent IRQ interrupt from happenning.
  */
-static int ks_start_xmit(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t ks_start_xmit(struct sk_buff *skb, struct net_device *netdev)
 {
 	int retv = NETDEV_TX_OK;
 	struct ks_net *ks = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/moxa/moxart_ether.c b/drivers/net/ethernet/moxa/moxart_ether.c
index 4367dd687..c32f151b8 100644
--- a/drivers/net/ethernet/moxa/moxart_ether.c
+++ b/drivers/net/ethernet/moxa/moxart_ether.c
@@ -319,7 +319,7 @@ static irqreturn_t moxart_mac_interrupt(int irq, void *dev_id)
 	return IRQ_HANDLED;
 }
 
-static int moxart_mac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t moxart_mac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct moxart_mac_priv_t *priv = netdev_priv(ndev);
 	void *desc;
diff --git a/drivers/net/ethernet/neterion/s2io.c b/drivers/net/ethernet/neterion/s2io.c
index eaa37c079..8295b08c2 100644
--- a/drivers/net/ethernet/neterion/s2io.c
+++ b/drivers/net/ethernet/neterion/s2io.c
@@ -8556,7 +8556,7 @@ static void lro_append_pkt(struct s2io_nic *sp, struct lro *lro,
  * this device has been detected.
  */
 static pci_ers_result_t s2io_io_error_detected(struct pci_dev *pdev,
-					       pci_channel_state_t state)
+					       enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct s2io_nic *sp = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/neterion/vxge/vxge-config.c b/drivers/net/ethernet/neterion/vxge/vxge-config.c
index 6223930a8..975033d7d 100644
--- a/drivers/net/ethernet/neterion/vxge/vxge-config.c
+++ b/drivers/net/ethernet/neterion/vxge/vxge-config.c
@@ -3457,7 +3457,10 @@ __vxge_hw_fifo_create(struct __vxge_hw_vpath_handle *vp,
 	struct __vxge_hw_fifo *fifo;
 	struct vxge_hw_fifo_config *config;
 	u32 txdl_size, txdl_per_memblock;
-	struct vxge_hw_mempool_cbs fifo_mp_callback;
+	static struct vxge_hw_mempool_cbs fifo_mp_callback = {
+		.item_func_alloc = __vxge_hw_fifo_mempool_item_alloc,
+	};
+
 	struct __vxge_hw_virtualpath *vpath;
 
 	if ((vp == NULL) || (attr == NULL)) {
@@ -3540,8 +3543,6 @@ __vxge_hw_fifo_create(struct __vxge_hw_vpath_handle *vp,
 		goto exit;
 	}
 
-	fifo_mp_callback.item_func_alloc = __vxge_hw_fifo_mempool_item_alloc;
-
 	fifo->mempool =
 		__vxge_hw_mempool_create(vpath->hldev,
 			fifo->config->memblock_size,
diff --git a/drivers/net/ethernet/neterion/vxge/vxge-main.c b/drivers/net/ethernet/neterion/vxge/vxge-main.c
index 850d2b539..5161bca24 100644
--- a/drivers/net/ethernet/neterion/vxge/vxge-main.c
+++ b/drivers/net/ethernet/neterion/vxge/vxge-main.c
@@ -4043,7 +4043,7 @@ static int vxge_pm_resume(struct pci_dev *pdev)
  * this device has been detected.
  */
 static pci_ers_result_t vxge_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct __vxge_hw_device *hldev = pci_get_drvdata(pdev);
 	struct net_device *netdev = hldev->ndev;
diff --git a/drivers/net/ethernet/netronome/nfp/nfp_net_common.c b/drivers/net/ethernet/netronome/nfp/nfp_net_common.c
index 39dadfca8..2f40f846b 100644
--- a/drivers/net/ethernet/netronome/nfp/nfp_net_common.c
+++ b/drivers/net/ethernet/netronome/nfp/nfp_net_common.c
@@ -751,7 +751,7 @@ static void nfp_net_tx_csum(struct nfp_net *nn, struct nfp_net_r_vector *r_vec,
  *
  * Return: NETDEV_TX_OK on success.
  */
-static int nfp_net_tx(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t nfp_net_tx(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct nfp_net *nn = netdev_priv(netdev);
 	const struct skb_frag_struct *frag;
diff --git a/drivers/net/ethernet/netx-eth.c b/drivers/net/ethernet/netx-eth.c
index 0c49be93f..7b926e2ef 100644
--- a/drivers/net/ethernet/netx-eth.c
+++ b/drivers/net/ethernet/netx-eth.c
@@ -107,7 +107,7 @@ static void netx_eth_set_multicast_list(struct net_device *ndev)
 	/* implement me */
 }
 
-static int
+static netdev_tx_t
 netx_eth_hard_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct netx_eth_priv *priv = netdev_priv(ndev);
diff --git a/drivers/net/ethernet/nuvoton/w90p910_ether.c b/drivers/net/ethernet/nuvoton/w90p910_ether.c
index 87b7b8147..b352c4bfc 100644
--- a/drivers/net/ethernet/nuvoton/w90p910_ether.c
+++ b/drivers/net/ethernet/nuvoton/w90p910_ether.c
@@ -633,7 +633,7 @@ static int w90p910_send_frame(struct net_device *dev,
 	return 0;
 }
 
-static int w90p910_ether_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t w90p910_ether_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct w90p910_ether *ether = netdev_priv(dev);
 
diff --git a/drivers/net/ethernet/nvidia/forcedeth.c b/drivers/net/ethernet/nvidia/forcedeth.c
index 9b0d7f463..c29155fc0 100644
--- a/drivers/net/ethernet/nvidia/forcedeth.c
+++ b/drivers/net/ethernet/nvidia/forcedeth.c
@@ -357,8 +357,8 @@ struct ring_desc {
 };
 
 struct ring_desc_ex {
-	__le32 bufhigh;
-	__le32 buflow;
+	__le32 bufhigh __intentional_overflow(0);
+	__le32 buflow __intentional_overflow(0);
 	__le32 txvlan;
 	__le32 flaglen;
 };
diff --git a/drivers/net/ethernet/nxp/lpc_eth.c b/drivers/net/ethernet/nxp/lpc_eth.c
index 8e13ec84c..b654ea067 100644
--- a/drivers/net/ethernet/nxp/lpc_eth.c
+++ b/drivers/net/ethernet/nxp/lpc_eth.c
@@ -1053,7 +1053,7 @@ static int lpc_eth_close(struct net_device *ndev)
 	return 0;
 }
 
-static int lpc_eth_hard_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t lpc_eth_hard_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct netdata_local *pldat = netdev_priv(ndev);
 	u32 len, txidx;
diff --git a/drivers/net/ethernet/oki-semi/pch_gbe/pch_gbe_main.c b/drivers/net/ethernet/oki-semi/pch_gbe/pch_gbe_main.c
index 3cd87a41a..3eb33e7d2 100644
--- a/drivers/net/ethernet/oki-semi/pch_gbe/pch_gbe_main.c
+++ b/drivers/net/ethernet/oki-semi/pch_gbe/pch_gbe_main.c
@@ -2130,7 +2130,7 @@ static int pch_gbe_stop(struct net_device *netdev)
  *	- NETDEV_TX_OK:   Normal end
  *	- NETDEV_TX_BUSY: Error end
  */
-static int pch_gbe_xmit_frame(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t pch_gbe_xmit_frame(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct pch_gbe_adapter *adapter = netdev_priv(netdev);
 	struct pch_gbe_tx_ring *tx_ring = adapter->tx_ring;
@@ -2439,7 +2439,7 @@ static const struct net_device_ops pch_gbe_netdev_ops = {
 };
 
 static pci_ers_result_t pch_gbe_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct net_device *netdev = pci_get_drvdata(pdev);
 	struct pch_gbe_adapter *adapter = netdev_priv(netdev);
diff --git a/drivers/net/ethernet/qlogic/netxen/netxen_nic_main.c b/drivers/net/ethernet/qlogic/netxen/netxen_nic_main.c
index 1b8136496..80d665b2d 100644
--- a/drivers/net/ethernet/qlogic/netxen/netxen_nic_main.c
+++ b/drivers/net/ethernet/qlogic/netxen/netxen_nic_main.c
@@ -1757,7 +1757,7 @@ err_out:
 }
 
 static pci_ers_result_t netxen_io_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct netxen_adapter *adapter = pci_get_drvdata(pdev);
 
diff --git a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_init.c b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_init.c
index 74105c6d0..cf93de650 100644
--- a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_init.c
+++ b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_init.c
@@ -2320,7 +2320,9 @@ int qlcnic_83xx_configure_opmode(struct qlcnic_adapter *adapter)
 		max_tx_rings = QLCNIC_MAX_VNIC_TX_RINGS;
 	} else if (ret == QLC_83XX_DEFAULT_OPMODE) {
 		ahw->nic_mode = QLCNIC_DEFAULT_MODE;
-		adapter->nic_ops->init_driver = qlcnic_83xx_init_default_driver;
+		pax_open_kernel();
+		const_cast(adapter->nic_ops->init_driver) = qlcnic_83xx_init_default_driver;
+		pax_close_kernel();
 		ahw->idc.state_entry = qlcnic_83xx_idc_ready_state_entry;
 		max_sds_rings = QLCNIC_MAX_SDS_RINGS;
 		max_tx_rings = QLCNIC_MAX_TX_RINGS;
diff --git a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_vnic.c b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_vnic.c
index 34906750b..cf148ea45 100644
--- a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_vnic.c
+++ b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_83xx_vnic.c
@@ -207,17 +207,23 @@ int qlcnic_83xx_config_vnic_opmode(struct qlcnic_adapter *adapter)
 	case QLCNIC_NON_PRIV_FUNC:
 		ahw->op_mode = QLCNIC_NON_PRIV_FUNC;
 		ahw->idc.state_entry = qlcnic_83xx_idc_ready_state_entry;
-		nic_ops->init_driver = qlcnic_83xx_init_non_privileged_vnic;
+		pax_open_kernel();
+		const_cast(nic_ops->init_driver) = qlcnic_83xx_init_non_privileged_vnic;
+		pax_close_kernel();
 		break;
 	case QLCNIC_PRIV_FUNC:
 		ahw->op_mode = QLCNIC_PRIV_FUNC;
 		ahw->idc.state_entry = qlcnic_83xx_idc_vnic_pf_entry;
-		nic_ops->init_driver = qlcnic_83xx_init_privileged_vnic;
+		pax_open_kernel();
+		const_cast(nic_ops->init_driver) = qlcnic_83xx_init_privileged_vnic;
+		pax_close_kernel();
 		break;
 	case QLCNIC_MGMT_FUNC:
 		ahw->op_mode = QLCNIC_MGMT_FUNC;
 		ahw->idc.state_entry = qlcnic_83xx_idc_ready_state_entry;
-		nic_ops->init_driver = qlcnic_83xx_init_mgmt_vnic;
+		pax_open_kernel();
+		const_cast(nic_ops->init_driver) = qlcnic_83xx_init_mgmt_vnic;
+		pax_close_kernel();
 		break;
 	default:
 		dev_err(&adapter->pdev->dev, "Invalid Virtual NIC opmode\n");
diff --git a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_main.c b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_main.c
index 6d03721a6..f96afbeb6 100644
--- a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_main.c
+++ b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_main.c
@@ -3974,7 +3974,7 @@ static void qlcnic_82xx_io_resume(struct pci_dev *pdev)
 }
 
 static pci_ers_result_t qlcnic_io_error_detected(struct pci_dev *pdev,
-						 pci_channel_state_t state)
+						 enum pci_channel_state state)
 {
 	struct qlcnic_adapter *adapter = pci_get_drvdata(pdev);
 	struct qlcnic_hardware_ops *hw_ops = adapter->ahw->hw_ops;
diff --git a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_minidump.c b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_minidump.c
index 0844b7c75..afa10a163 100644
--- a/drivers/net/ethernet/qlogic/qlcnic/qlcnic_minidump.c
+++ b/drivers/net/ethernet/qlogic/qlcnic/qlcnic_minidump.c
@@ -1285,7 +1285,7 @@ flash_temp:
 int qlcnic_dump_fw(struct qlcnic_adapter *adapter)
 {
 	struct qlcnic_fw_dump *fw_dump = &adapter->ahw->fw_dump;
-	static const struct qlcnic_dump_operations *fw_dump_ops;
+	const struct qlcnic_dump_operations *fw_dump_ops;
 	struct qlcnic_83xx_dump_template_hdr *hdr_83xx;
 	u32 entry_offset, dump, no_entries, buf_offset = 0;
 	int i, k, ops_cnt, ops_index, dump_size = 0;
diff --git a/drivers/net/ethernet/realtek/r8169.c b/drivers/net/ethernet/realtek/r8169.c
index c071624e7..e5f0e0950 100644
--- a/drivers/net/ethernet/realtek/r8169.c
+++ b/drivers/net/ethernet/realtek/r8169.c
@@ -798,22 +798,22 @@ struct rtl8169_private {
 	struct mdio_ops {
 		void (*write)(struct rtl8169_private *, int, int);
 		int (*read)(struct rtl8169_private *, int);
-	} mdio_ops;
+	} __no_const mdio_ops;
 
 	struct pll_power_ops {
 		void (*down)(struct rtl8169_private *);
 		void (*up)(struct rtl8169_private *);
-	} pll_power_ops;
+	} __no_const pll_power_ops;
 
 	struct jumbo_ops {
 		void (*enable)(struct rtl8169_private *);
 		void (*disable)(struct rtl8169_private *);
-	} jumbo_ops;
+	} __no_const jumbo_ops;
 
 	struct csi_ops {
 		void (*write)(struct rtl8169_private *, int, int);
 		u32 (*read)(struct rtl8169_private *, int);
-	} csi_ops;
+	} __no_const csi_ops;
 
 	int (*set_speed)(struct net_device *, u8 aneg, u16 sp, u8 dpx, u32 adv);
 	int (*get_settings)(struct net_device *, struct ethtool_cmd *);
diff --git a/drivers/net/ethernet/renesas/sh_eth.c b/drivers/net/ethernet/renesas/sh_eth.c
index 92c9a9516..1c8f44b1f 100644
--- a/drivers/net/ethernet/renesas/sh_eth.c
+++ b/drivers/net/ethernet/renesas/sh_eth.c
@@ -2300,7 +2300,7 @@ static void sh_eth_tx_timeout(struct net_device *ndev)
 }
 
 /* Packet transmit function */
-static int sh_eth_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t sh_eth_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct sh_eth_private *mdp = netdev_priv(ndev);
 	struct sh_eth_txdesc *txdesc;
diff --git a/drivers/net/ethernet/rocker/rocker_main.c b/drivers/net/ethernet/rocker/rocker_main.c
index f0b09b05e..35869b187 100644
--- a/drivers/net/ethernet/rocker/rocker_main.c
+++ b/drivers/net/ethernet/rocker/rocker_main.c
@@ -2834,7 +2834,7 @@ out:
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block rocker_netdevice_nb __read_mostly = {
+static struct notifier_block rocker_netdevice_nb = {
 	.notifier_call = rocker_netdevice_event,
 };
 
@@ -2868,7 +2868,7 @@ static int rocker_netevent_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block rocker_netevent_nb __read_mostly = {
+static struct notifier_block rocker_netevent_nb = {
 	.notifier_call = rocker_netevent_event,
 };
 
diff --git a/drivers/net/ethernet/seeq/sgiseeq.c b/drivers/net/ethernet/seeq/sgiseeq.c
index c2bd5378f..540a981bd 100644
--- a/drivers/net/ethernet/seeq/sgiseeq.c
+++ b/drivers/net/ethernet/seeq/sgiseeq.c
@@ -578,7 +578,7 @@ static inline int sgiseeq_reset(struct net_device *dev)
 	return 0;
 }
 
-static int sgiseeq_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t sgiseeq_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct sgiseeq_private *sp = netdev_priv(dev);
 	struct hpc3_ethregs *hregs = sp->hregs;
diff --git a/drivers/net/ethernet/sfc/ptp.c b/drivers/net/ethernet/sfc/ptp.c
index c771e0af4..bbb368d3b 100644
--- a/drivers/net/ethernet/sfc/ptp.c
+++ b/drivers/net/ethernet/sfc/ptp.c
@@ -832,7 +832,7 @@ static int efx_ptp_synchronize(struct efx_nic *efx, unsigned int num_readings)
 		       ptp->start.dma_addr);
 
 	/* Clear flag that signals MC ready */
-	ACCESS_ONCE(*start) = 0;
+	ACCESS_ONCE_RW(*start) = 0;
 	rc = efx_mcdi_rpc_start(efx, MC_CMD_PTP, synch_buf,
 				MC_CMD_PTP_IN_SYNCHRONIZE_LEN);
 	EFX_BUG_ON_PARANOID(rc);
diff --git a/drivers/net/ethernet/sfc/selftest.c b/drivers/net/ethernet/sfc/selftest.c
index 9d78830da..74fc649e4 100644
--- a/drivers/net/ethernet/sfc/selftest.c
+++ b/drivers/net/ethernet/sfc/selftest.c
@@ -82,8 +82,8 @@ struct efx_loopback_state {
 	int packet_count;
 	struct sk_buff **skbs;
 	bool offload_csum;
-	atomic_t rx_good;
-	atomic_t rx_bad;
+	atomic_unchecked_t rx_good;
+	atomic_unchecked_t rx_bad;
 	struct efx_loopback_payload payload;
 };
 
@@ -349,12 +349,12 @@ void efx_loopback_rx_packet(struct efx_nic *efx,
 	netif_vdbg(efx, drv, efx->net_dev,
 		   "got loopback RX in %s loopback test\n", LOOPBACK_MODE(efx));
 
-	atomic_inc(&state->rx_good);
+	atomic_inc_unchecked(&state->rx_good);
 	return;
 
  err:
 #ifdef DEBUG
-	if (atomic_read(&state->rx_bad) == 0) {
+	if (atomic_read_unchecked(&state->rx_bad) == 0) {
 		netif_err(efx, drv, efx->net_dev, "received packet:\n");
 		print_hex_dump(KERN_ERR, "", DUMP_PREFIX_OFFSET, 0x10, 1,
 			       buf_ptr, pkt_len, 0);
@@ -363,7 +363,7 @@ void efx_loopback_rx_packet(struct efx_nic *efx,
 			       &state->payload, sizeof(state->payload), 0);
 	}
 #endif
-	atomic_inc(&state->rx_bad);
+	atomic_inc_unchecked(&state->rx_bad);
 }
 
 /* Initialise an efx_selftest_state for a new iteration */
@@ -397,8 +397,8 @@ static void efx_iterate_state(struct efx_nic *efx)
 	memcpy(&payload->msg, payload_msg, sizeof(payload_msg));
 
 	/* Fill out remaining state members */
-	atomic_set(&state->rx_good, 0);
-	atomic_set(&state->rx_bad, 0);
+	atomic_set_unchecked(&state->rx_good, 0);
+	atomic_set_unchecked(&state->rx_bad, 0);
 	smp_wmb();
 }
 
@@ -456,7 +456,7 @@ static int efx_poll_loopback(struct efx_nic *efx)
 {
 	struct efx_loopback_state *state = efx->loopback_selftest;
 
-	return atomic_read(&state->rx_good) == state->packet_count;
+	return atomic_read_unchecked(&state->rx_good) == state->packet_count;
 }
 
 static int efx_end_loopback(struct efx_tx_queue *tx_queue,
@@ -482,8 +482,8 @@ static int efx_end_loopback(struct efx_tx_queue *tx_queue,
 	netif_tx_unlock_bh(efx->net_dev);
 
 	/* Check TX completion and received packet counts */
-	rx_good = atomic_read(&state->rx_good);
-	rx_bad = atomic_read(&state->rx_bad);
+	rx_good = atomic_read_unchecked(&state->rx_good);
+	rx_bad = atomic_read_unchecked(&state->rx_bad);
 	if (tx_done != state->packet_count) {
 		/* Don't free the skbs; they will be picked up on TX
 		 * overflow or channel teardown.
diff --git a/drivers/net/ethernet/sgi/ioc3-eth.c b/drivers/net/ethernet/sgi/ioc3-eth.c
index 7a254da85..0693a2b4c 100644
--- a/drivers/net/ethernet/sgi/ioc3-eth.c
+++ b/drivers/net/ethernet/sgi/ioc3-eth.c
@@ -103,7 +103,7 @@ static inline struct net_device *priv_netdev(struct ioc3_private *dev)
 
 static int ioc3_ioctl(struct net_device *dev, struct ifreq *rq, int cmd);
 static void ioc3_set_multicast_list(struct net_device *dev);
-static int ioc3_start_xmit(struct sk_buff *skb, struct net_device *dev);
+static netdev_tx_t ioc3_start_xmit(struct sk_buff *skb, struct net_device *dev);
 static void ioc3_timeout(struct net_device *dev);
 static inline unsigned int ioc3_hash(const unsigned char *addr);
 static inline void ioc3_stop(struct ioc3_private *ip);
@@ -1397,7 +1397,7 @@ static struct pci_driver ioc3_driver = {
 	.remove		= ioc3_remove_one,
 };
 
-static int ioc3_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t ioc3_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	unsigned long data;
 	struct ioc3_private *ip = netdev_priv(dev);
diff --git a/drivers/net/ethernet/smsc/smc911x.c b/drivers/net/ethernet/smsc/smc911x.c
index cb49c9654..c1498cc78 100644
--- a/drivers/net/ethernet/smsc/smc911x.c
+++ b/drivers/net/ethernet/smsc/smc911x.c
@@ -514,7 +514,7 @@ static void smc911x_hardware_send_pkt(struct net_device *dev)
  * now, or set the card to generates an interrupt when ready
  * for the packet.
  */
-static int smc911x_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t smc911x_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct smc911x_local *lp = netdev_priv(dev);
 	unsigned int free;
diff --git a/drivers/net/ethernet/smsc/smc91x.c b/drivers/net/ethernet/smsc/smc91x.c
index 503a3b6dc..28d35c977 100644
--- a/drivers/net/ethernet/smsc/smc91x.c
+++ b/drivers/net/ethernet/smsc/smc91x.c
@@ -637,7 +637,7 @@ done:	if (!THROTTLE_TX_PKTS)
  * now, or set the card to generates an interrupt when ready
  * for the packet.
  */
-static int smc_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t smc_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct smc_local *lp = netdev_priv(dev);
 	void __iomem *ioaddr = lp->base;
diff --git a/drivers/net/ethernet/smsc/smsc911x.c b/drivers/net/ethernet/smsc/smsc911x.c
index 4f8910b7d..50636e8e9 100644
--- a/drivers/net/ethernet/smsc/smsc911x.c
+++ b/drivers/net/ethernet/smsc/smsc911x.c
@@ -1760,7 +1760,7 @@ static int smsc911x_stop(struct net_device *dev)
 }
 
 /* Entry point for transmitting a packet */
-static int smsc911x_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t smsc911x_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct smsc911x_data *pdata = netdev_priv(dev);
 	unsigned int freespace;
diff --git a/drivers/net/ethernet/stmicro/stmmac/mmc_core.c b/drivers/net/ethernet/stmicro/stmmac/mmc_core.c
index ce9aa7928..ad1831f41 100644
--- a/drivers/net/ethernet/stmicro/stmmac/mmc_core.c
+++ b/drivers/net/ethernet/stmicro/stmmac/mmc_core.c
@@ -140,8 +140,8 @@ void dwmac_mmc_ctrl(void __iomem *mmcaddr, unsigned int mode)
 
 	writel(value, mmcaddr + MMC_CNTRL);
 
-	pr_debug("stmmac: MMC ctrl register (offset 0x%x): 0x%08x\n",
-		 MMC_CNTRL, value);
+//	pr_debug("stmmac: MMC ctrl register (offset 0x%x): 0x%08x\n",
+//		 MMC_CNTRL, value);
 }
 
 /* To mask all all interrupts.*/
diff --git a/drivers/net/ethernet/stmicro/stmmac/stmmac_main.c b/drivers/net/ethernet/stmicro/stmmac/stmmac_main.c
index fe9e7b197..55f1ba67b 100644
--- a/drivers/net/ethernet/stmicro/stmmac/stmmac_main.c
+++ b/drivers/net/ethernet/stmicro/stmmac/stmmac_main.c
@@ -1171,8 +1171,8 @@ static int alloc_dma_desc_resources(struct stmmac_priv *priv)
 	if (!priv->rx_skbuff)
 		goto err_rx_skbuff;
 
-	priv->tx_skbuff_dma = kmalloc_array(DMA_TX_SIZE,
-					    sizeof(*priv->tx_skbuff_dma),
+	priv->tx_skbuff_dma = kmalloc_array(sizeof(*priv->tx_skbuff_dma),
+					    DMA_TX_SIZE,
 					    GFP_KERNEL);
 	if (!priv->tx_skbuff_dma)
 		goto err_tx_skbuff_dma;
diff --git a/drivers/net/ethernet/sun/sunbmac.c b/drivers/net/ethernet/sun/sunbmac.c
index aa4f9d2d8..d9ffff34c 100644
--- a/drivers/net/ethernet/sun/sunbmac.c
+++ b/drivers/net/ethernet/sun/sunbmac.c
@@ -950,7 +950,7 @@ static void bigmac_tx_timeout(struct net_device *dev)
 }
 
 /* Put a packet on the wire. */
-static int bigmac_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t bigmac_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct bigmac *bp = netdev_priv(dev);
 	int len, entry;
diff --git a/drivers/net/ethernet/sun/sunqe.c b/drivers/net/ethernet/sun/sunqe.c
index 9b825780b..71a2b343c 100644
--- a/drivers/net/ethernet/sun/sunqe.c
+++ b/drivers/net/ethernet/sun/sunqe.c
@@ -568,7 +568,7 @@ out:
 }
 
 /* Get a packet queued to go onto the wire. */
-static int qe_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t qe_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct sunqe *qep = netdev_priv(dev);
 	struct sunqe_buffers *qbufs = qep->buffers;
diff --git a/drivers/net/ethernet/sun/sunvnet.c b/drivers/net/ethernet/sun/sunvnet.c
index a2f9b47de..05a914785 100644
--- a/drivers/net/ethernet/sun/sunvnet.c
+++ b/drivers/net/ethernet/sun/sunvnet.c
@@ -131,7 +131,7 @@ static u16 vnet_select_queue(struct net_device *dev, struct sk_buff *skb,
 }
 
 /* Wrappers to common functions */
-static int vnet_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t vnet_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	return sunvnet_start_xmit_common(skb, dev, vnet_tx_port_find);
 }
diff --git a/drivers/net/ethernet/sun/sunvnet_common.c b/drivers/net/ethernet/sun/sunvnet_common.c
index 904a5a12a..6ef5cff9e 100644
--- a/drivers/net/ethernet/sun/sunvnet_common.c
+++ b/drivers/net/ethernet/sun/sunvnet_common.c
@@ -1126,7 +1126,7 @@ static inline struct sk_buff *vnet_skb_shape(struct sk_buff *skb, int ncookies)
 	return skb;
 }
 
-static int vnet_handle_offloads(struct vnet_port *port, struct sk_buff *skb,
+static netdev_tx_t vnet_handle_offloads(struct vnet_port *port, struct sk_buff *skb,
 				struct vnet_port *(*vnet_tx_port)
 				(struct sk_buff *, struct net_device *))
 {
@@ -1134,7 +1134,7 @@ static int vnet_handle_offloads(struct vnet_port *port, struct sk_buff *skb,
 	struct vio_dring_state *dr = &port->vio.drings[VIO_DRIVER_TX_RING];
 	struct sk_buff *segs;
 	int maclen, datalen;
-	int status;
+	netdev_tx_t status;
 	int gso_size, gso_type, gso_segs;
 	int hlen = skb_transport_header(skb) - skb_mac_header(skb);
 	int proto = IPPROTO_IP;
@@ -1190,7 +1190,7 @@ static int vnet_handle_offloads(struct vnet_port *port, struct sk_buff *skb,
 	skb_push(skb, maclen);
 	skb_reset_mac_header(skb);
 
-	status = 0;
+	status = NETDEV_TX_OK;
 	while (segs) {
 		struct sk_buff *curr = segs;
 
diff --git a/drivers/net/ethernet/synopsys/dwc_eth_qos.c b/drivers/net/ethernet/synopsys/dwc_eth_qos.c
index 4490ebaed..cbd62ea3e 100644
--- a/drivers/net/ethernet/synopsys/dwc_eth_qos.c
+++ b/drivers/net/ethernet/synopsys/dwc_eth_qos.c
@@ -2176,7 +2176,7 @@ static void dwceqos_tx_rollback(struct net_local *lp, struct dwceqos_tx *tx)
 	lp->gso_size = tx->prev_gso_size;
 }
 
-static int dwceqos_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t dwceqos_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct net_local *lp = netdev_priv(ndev);
 	struct dwceqos_tx trans;
diff --git a/drivers/net/ethernet/ti/cpmac.c b/drivers/net/ethernet/ti/cpmac.c
index d300d536d..31adc9327 100644
--- a/drivers/net/ethernet/ti/cpmac.c
+++ b/drivers/net/ethernet/ti/cpmac.c
@@ -544,7 +544,7 @@ fatal_error:
 
 }
 
-static int cpmac_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t cpmac_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	int queue, len;
 	struct cpmac_desc *desc;
diff --git a/drivers/net/ethernet/ti/davinci_emac.c b/drivers/net/ethernet/ti/davinci_emac.c
index 727a79f3c..38ef41954 100644
--- a/drivers/net/ethernet/ti/davinci_emac.c
+++ b/drivers/net/ethernet/ti/davinci_emac.c
@@ -943,7 +943,7 @@ static void emac_tx_handler(void *token, int len, int status)
  *
  * Returns success(NETDEV_TX_OK) or error code (typically out of desc's)
  */
-static int emac_dev_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t emac_dev_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct device *emac_dev = &ndev->dev;
 	int ret_code;
diff --git a/drivers/net/ethernet/ti/netcp_core.c b/drivers/net/ethernet/ti/netcp_core.c
index 32516661f..6eb86ae91 100644
--- a/drivers/net/ethernet/ti/netcp_core.c
+++ b/drivers/net/ethernet/ti/netcp_core.c
@@ -1237,7 +1237,7 @@ out:
 }
 
 /* Submit the packet */
-static int netcp_ndo_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t netcp_ndo_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct netcp_intf *netcp = netdev_priv(ndev);
 	int subqueue = skb_get_queue_mapping(skb);
diff --git a/drivers/net/ethernet/via/via-rhine.c b/drivers/net/ethernet/via/via-rhine.c
index 9d14731cd..7d6ad9182 100644
--- a/drivers/net/ethernet/via/via-rhine.c
+++ b/drivers/net/ethernet/via/via-rhine.c
@@ -2600,7 +2600,7 @@ static struct platform_driver rhine_driver_platform = {
 	}
 };
 
-static struct dmi_system_id rhine_dmi_table[] __initdata = {
+static const struct dmi_system_id rhine_dmi_table[] __initconst = {
 	{
 		.ident = "EPIA-M",
 		.matches = {
diff --git a/drivers/net/ethernet/wiznet/w5100.c b/drivers/net/ethernet/wiznet/w5100.c
index 37ab46cdb..287548029 100644
--- a/drivers/net/ethernet/wiznet/w5100.c
+++ b/drivers/net/ethernet/wiznet/w5100.c
@@ -836,7 +836,7 @@ static void w5100_tx_work(struct work_struct *work)
 	w5100_tx_skb(priv->ndev, skb);
 }
 
-static int w5100_start_tx(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t w5100_start_tx(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct w5100_priv *priv = netdev_priv(ndev);
 
diff --git a/drivers/net/ethernet/wiznet/w5300.c b/drivers/net/ethernet/wiznet/w5300.c
index 0b37ce9f2..4ec594be6 100644
--- a/drivers/net/ethernet/wiznet/w5300.c
+++ b/drivers/net/ethernet/wiznet/w5300.c
@@ -366,7 +366,7 @@ static void w5300_tx_timeout(struct net_device *ndev)
 	netif_wake_queue(ndev);
 }
 
-static int w5300_start_tx(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t w5300_start_tx(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct w5300_priv *priv = netdev_priv(ndev);
 
diff --git a/drivers/net/ethernet/xilinx/ll_temac_main.c b/drivers/net/ethernet/xilinx/ll_temac_main.c
index a9bd665fd..2fc292425 100644
--- a/drivers/net/ethernet/xilinx/ll_temac_main.c
+++ b/drivers/net/ethernet/xilinx/ll_temac_main.c
@@ -673,7 +673,7 @@ static inline int temac_check_tx_bd_space(struct temac_local *lp, int num_frag)
 	return 0;
 }
 
-static int temac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t temac_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct temac_local *lp = netdev_priv(ndev);
 	struct cdmac_bd *cur_p;
diff --git a/drivers/net/ethernet/xilinx/xilinx_axienet_main.c b/drivers/net/ethernet/xilinx/xilinx_axienet_main.c
index 36ee7ab30..7a76e3ff8 100644
--- a/drivers/net/ethernet/xilinx/xilinx_axienet_main.c
+++ b/drivers/net/ethernet/xilinx/xilinx_axienet_main.c
@@ -652,7 +652,7 @@ static inline int axienet_check_tx_bd_space(struct axienet_local *lp,
  * start the transmission. Additionally if checksum offloading is supported,
  * it populates AXI Stream Control fields with appropriate values.
  */
-static int axienet_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t axienet_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	u32 ii;
 	u32 num_frag;
diff --git a/drivers/net/ethernet/xilinx/xilinx_emaclite.c b/drivers/net/ethernet/xilinx/xilinx_emaclite.c
index 93dc10b10..65986711e 100644
--- a/drivers/net/ethernet/xilinx/xilinx_emaclite.c
+++ b/drivers/net/ethernet/xilinx/xilinx_emaclite.c
@@ -995,7 +995,7 @@ static int xemaclite_close(struct net_device *dev)
  *
  * Return:	0, always.
  */
-static int xemaclite_send(struct sk_buff *orig_skb, struct net_device *dev)
+static netdev_tx_t xemaclite_send(struct sk_buff *orig_skb, struct net_device *dev)
 {
 	struct net_local *lp = netdev_priv(dev);
 	struct sk_buff *new_skb;
diff --git a/drivers/net/geneve.c b/drivers/net/geneve.c
index 5ad706b99..6a5d38aeb 100644
--- a/drivers/net/geneve.c
+++ b/drivers/net/geneve.c
@@ -1444,7 +1444,7 @@ nla_put_failure:
 	return -EMSGSIZE;
 }
 
-static struct rtnl_link_ops geneve_link_ops __read_mostly = {
+static struct rtnl_link_ops geneve_link_ops = {
 	.kind		= "geneve",
 	.maxtype	= IFLA_GENEVE_MAX,
 	.policy		= geneve_policy,
@@ -1510,7 +1510,7 @@ static int geneve_netdevice_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block geneve_notifier_block __read_mostly = {
+static struct notifier_block geneve_notifier_block = {
 	.notifier_call = geneve_netdevice_event,
 };
 
diff --git a/drivers/net/gtp.c b/drivers/net/gtp.c
index 97e0cbca0..3aec9e578 100644
--- a/drivers/net/gtp.c
+++ b/drivers/net/gtp.c
@@ -58,7 +58,7 @@ struct pdp_ctx {
 	struct in_addr		ms_addr_ip4;
 	struct in_addr		sgsn_addr_ip4;
 
-	atomic_t		tx_seq;
+	atomic_unchecked_t	tx_seq;
 	struct rcu_head		rcu_head;
 };
 
@@ -407,7 +407,7 @@ static inline void gtp0_push_header(struct sk_buff *skb, struct pdp_ctx *pctx)
 	gtp0->flags	= 0x1e; /* v0, GTP-non-prime. */
 	gtp0->type	= GTP_TPDU;
 	gtp0->length	= htons(payload_len);
-	gtp0->seq	= htons((atomic_inc_return(&pctx->tx_seq) - 1) % 0xffff);
+	gtp0->seq	= htons((atomic_inc_return_unchecked(&pctx->tx_seq) - 1) % 0xffff);
 	gtp0->flow	= htons(pctx->u.v0.flow);
 	gtp0->number	= 0xff;
 	gtp0->spare[0]	= gtp0->spare[1] = gtp0->spare[2] = 0xff;
@@ -751,7 +751,7 @@ nla_put_failure:
 	return -EMSGSIZE;
 }
 
-static struct rtnl_link_ops gtp_link_ops __read_mostly = {
+static struct rtnl_link_ops gtp_link_ops = {
 	.kind		= "gtp",
 	.maxtype	= IFLA_GTP_MAX,
 	.policy		= gtp_policy,
@@ -959,7 +959,7 @@ static int ipv4_pdp_add(struct net_device *dev, struct genl_info *info)
 		return -ENOMEM;
 
 	ipv4_pdp_fill(pctx, info);
-	atomic_set(&pctx->tx_seq, 0);
+	atomic_set_unchecked(&pctx->tx_seq, 0);
 
 	switch (pctx->gtp_version) {
 	case GTP_V0:
diff --git a/drivers/net/hamradio/baycom_epp.c b/drivers/net/hamradio/baycom_epp.c
index 78dbc4454..b7831d0fd 100644
--- a/drivers/net/hamradio/baycom_epp.c
+++ b/drivers/net/hamradio/baycom_epp.c
@@ -768,7 +768,7 @@ static void epp_bh(struct work_struct *work)
  * ===================== network driver interface =========================
  */
 
-static int baycom_send_packet(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t baycom_send_packet(struct sk_buff *skb, struct net_device *dev)
 {
 	struct baycom_state *bc = netdev_priv(dev);
 
diff --git a/drivers/net/hyperv/hyperv_net.h b/drivers/net/hyperv/hyperv_net.h
index 591af71ea..a5bbc7a82 100644
--- a/drivers/net/hyperv/hyperv_net.h
+++ b/drivers/net/hyperv/hyperv_net.h
@@ -162,7 +162,7 @@ struct rndis_device {
 
 	enum rndis_device_state state;
 	bool link_state;
-	atomic_t new_req_id;
+	atomic_unchecked_t new_req_id;
 
 	spinlock_t request_lock;
 	struct list_head req_list;
diff --git a/drivers/net/hyperv/netvsc_drv.c b/drivers/net/hyperv/netvsc_drv.c
index c4d9653ca..a4c910193 100644
--- a/drivers/net/hyperv/netvsc_drv.c
+++ b/drivers/net/hyperv/netvsc_drv.c
@@ -349,7 +349,7 @@ not_ip:
 	return ret_val;
 }
 
-static int netvsc_start_xmit(struct sk_buff *skb, struct net_device *net)
+static netdev_tx_t netvsc_start_xmit(struct sk_buff *skb, struct net_device *net)
 {
 	struct net_device_context *net_device_ctx = netdev_priv(net);
 	struct hv_netvsc_packet *packet = NULL;
diff --git a/drivers/net/hyperv/rndis_filter.c b/drivers/net/hyperv/rndis_filter.c
index 8e830f741..37da185d1 100644
--- a/drivers/net/hyperv/rndis_filter.c
+++ b/drivers/net/hyperv/rndis_filter.c
@@ -101,7 +101,7 @@ static struct rndis_request *get_rndis_request(struct rndis_device *dev,
 	 * template
 	 */
 	set = &rndis_msg->msg.set_req;
-	set->req_id = atomic_inc_return(&dev->new_req_id);
+	set->req_id = atomic_inc_return_unchecked(&dev->new_req_id);
 
 	/* Add to the request list */
 	spin_lock_irqsave(&dev->request_lock, flags);
@@ -861,7 +861,7 @@ static void rndis_filter_halt_device(struct rndis_device *dev)
 
 	/* Setup the rndis set */
 	halt = &request->request_msg.msg.halt_req;
-	halt->req_id = atomic_inc_return(&dev->new_req_id);
+	halt->req_id = atomic_inc_return_unchecked(&dev->new_req_id);
 
 	/* Ignore return since this msg is optional. */
 	rndis_filter_send_request(dev, request);
@@ -1075,8 +1075,7 @@ int rndis_filter_device_add(struct hv_device *dev,
 	if (net_device->num_chn == 1)
 		goto out;
 
-	net_device->sub_cb_buf = vzalloc((net_device->num_chn - 1) *
-					 NETVSC_PACKET_SIZE);
+	net_device->sub_cb_buf = vzalloc(net_device->num_sc_offered * NETVSC_PACKET_SIZE);
 	if (!net_device->sub_cb_buf) {
 		net_device->num_chn = 1;
 		dev_info(&dev->device, "No memory for subchannels.\n");
diff --git a/drivers/net/ifb.c b/drivers/net/ifb.c
index 66c0eeafc..27486de4a 100644
--- a/drivers/net/ifb.c
+++ b/drivers/net/ifb.c
@@ -290,7 +290,7 @@ static int ifb_validate(struct nlattr *tb[], struct nlattr *data[])
 	return 0;
 }
 
-static struct rtnl_link_ops ifb_link_ops __read_mostly = {
+static struct rtnl_link_ops ifb_link_ops = {
 	.kind		= "ifb",
 	.priv_size	= sizeof(struct ifb_dev_private),
 	.setup		= ifb_setup,
diff --git a/drivers/net/ipvlan/ipvlan_core.c b/drivers/net/ipvlan/ipvlan_core.c
index b5f9511d8..c8835835a 100644
--- a/drivers/net/ipvlan/ipvlan_core.c
+++ b/drivers/net/ipvlan/ipvlan_core.c
@@ -484,7 +484,7 @@ static void ipvlan_multicast_enqueue(struct ipvl_port *port,
 		schedule_work(&port->wq);
 	} else {
 		spin_unlock(&port->backlog.lock);
-		atomic_long_inc(&skb->dev->rx_dropped);
+		atomic_long_inc_unchecked(&skb->dev->rx_dropped);
 		kfree_skb(skb);
 	}
 }
diff --git a/drivers/net/ipvlan/ipvlan_main.c b/drivers/net/ipvlan/ipvlan_main.c
index 18b4e8c7f..65f538653 100644
--- a/drivers/net/ipvlan/ipvlan_main.c
+++ b/drivers/net/ipvlan/ipvlan_main.c
@@ -734,15 +734,15 @@ static int ipvlan_addr4_event(struct notifier_block *unused,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block ipvlan_addr4_notifier_block __read_mostly = {
+static struct notifier_block ipvlan_addr4_notifier_block = {
 	.notifier_call = ipvlan_addr4_event,
 };
 
-static struct notifier_block ipvlan_notifier_block __read_mostly = {
+static struct notifier_block ipvlan_notifier_block = {
 	.notifier_call = ipvlan_device_event,
 };
 
-static struct notifier_block ipvlan_addr6_notifier_block __read_mostly = {
+static struct notifier_block ipvlan_addr6_notifier_block = {
 	.notifier_call = ipvlan_addr6_event,
 };
 
diff --git a/drivers/net/irda/vlsi_ir.c b/drivers/net/irda/vlsi_ir.c
index a0849f49b..147a4a618 100644
--- a/drivers/net/irda/vlsi_ir.c
+++ b/drivers/net/irda/vlsi_ir.c
@@ -142,7 +142,7 @@ static void vlsi_ring_debug(struct vlsi_ring *r)
 	printk(KERN_DEBUG "%s - ring %p / size %u / mask 0x%04x / len %u / dir %d / hw %p\n",
 		__func__, r, r->size, r->mask, r->len, r->dir, r->rd[0].hw);
 	printk(KERN_DEBUG "%s - head = %d / tail = %d\n", __func__,
-		atomic_read(&r->head) & r->mask, atomic_read(&r->tail) & r->mask);
+		atomic_read_unchecked(&r->head) & r->mask, atomic_read_unchecked(&r->tail) & r->mask);
 	for (i = 0; i < r->size; i++) {
 		rd = &r->rd[i];
 		printk(KERN_DEBUG "%s - ring descr %u: ", __func__, i);
@@ -301,8 +301,8 @@ static void vlsi_proc_ring(struct seq_file *seq, struct vlsi_ring *r)
 
 	seq_printf(seq, "size %u / mask 0x%04x / len %u / dir %d / hw %p\n",
 		r->size, r->mask, r->len, r->dir, r->rd[0].hw);
-	h = atomic_read(&r->head) & r->mask;
-	t = atomic_read(&r->tail) & r->mask;
+	h = atomic_read_unchecked(&r->head) & r->mask;
+	t = atomic_read_unchecked(&r->tail) & r->mask;
 	seq_printf(seq, "head = %d / tail = %d ", h, t);
 	if (h == t)
 		seq_printf(seq, "(empty)\n");
@@ -410,8 +410,8 @@ static struct vlsi_ring *vlsi_alloc_ring(struct pci_dev *pdev, struct ring_descr
 	r->rd = (struct ring_descr *)(r+1);
 	r->mask = size - 1;
 	r->size = size;
-	atomic_set(&r->head, 0);
-	atomic_set(&r->tail, 0);
+	atomic_set_unchecked(&r->head, 0);
+	atomic_set_unchecked(&r->tail, 0);
 
 	for (i = 0; i < size; i++) {
 		rd = r->rd + i;
@@ -1268,10 +1268,10 @@ static int vlsi_init_chip(struct pci_dev *pdev)
 		iobase+VLSI_PIO_RINGSIZE);	
 
 	ptr = inw(iobase+VLSI_PIO_RINGPTR);
-	atomic_set(&idev->rx_ring->head, RINGPTR_GET_RX(ptr));
-	atomic_set(&idev->rx_ring->tail, RINGPTR_GET_RX(ptr));
-	atomic_set(&idev->tx_ring->head, RINGPTR_GET_TX(ptr));
-	atomic_set(&idev->tx_ring->tail, RINGPTR_GET_TX(ptr));
+	atomic_set_unchecked(&idev->rx_ring->head, RINGPTR_GET_RX(ptr));
+	atomic_set_unchecked(&idev->rx_ring->tail, RINGPTR_GET_RX(ptr));
+	atomic_set_unchecked(&idev->tx_ring->head, RINGPTR_GET_TX(ptr));
+	atomic_set_unchecked(&idev->tx_ring->tail, RINGPTR_GET_TX(ptr));
 
 	vlsi_set_baud(idev, iobase);	/* idev->new_baud used as provided by caller */
 
diff --git a/drivers/net/irda/vlsi_ir.h b/drivers/net/irda/vlsi_ir.h
index f9db2ce4c..6cd460c4d 100644
--- a/drivers/net/irda/vlsi_ir.h
+++ b/drivers/net/irda/vlsi_ir.h
@@ -671,7 +671,7 @@ struct vlsi_ring {
 	unsigned		len;
 	unsigned		size;
 	unsigned		mask;
-	atomic_t		head, tail;
+	atomic_unchecked_t	head, tail;
 	struct ring_descr	*rd;
 };
 
@@ -681,13 +681,13 @@ static inline struct ring_descr *ring_last(struct vlsi_ring *r)
 {
 	int t;
 
-	t = atomic_read(&r->tail) & r->mask;
-	return (((t+1) & r->mask) == (atomic_read(&r->head) & r->mask)) ? NULL : &r->rd[t];
+	t = atomic_read_unchecked(&r->tail) & r->mask;
+	return (((t+1) & r->mask) == (atomic_read_unchecked(&r->head) & r->mask)) ? NULL : &r->rd[t];
 }
 
 static inline struct ring_descr *ring_put(struct vlsi_ring *r)
 {
-	atomic_inc(&r->tail);
+	atomic_inc_unchecked(&r->tail);
 	return ring_last(r);
 }
 
@@ -695,13 +695,13 @@ static inline struct ring_descr *ring_first(struct vlsi_ring *r)
 {
 	int h;
 
-	h = atomic_read(&r->head) & r->mask;
-	return (h == (atomic_read(&r->tail) & r->mask)) ? NULL : &r->rd[h];
+	h = atomic_read_unchecked(&r->head) & r->mask;
+	return (h == (atomic_read_unchecked(&r->tail) & r->mask)) ? NULL : &r->rd[h];
 }
 
 static inline struct ring_descr *ring_get(struct vlsi_ring *r)
 {
-	atomic_inc(&r->head);
+	atomic_inc_unchecked(&r->head);
 	return ring_first(r);
 }
 
diff --git a/drivers/net/loopback.c b/drivers/net/loopback.c
index 6255973e3..7ae59f57c 100644
--- a/drivers/net/loopback.c
+++ b/drivers/net/loopback.c
@@ -216,6 +216,6 @@ out:
 }
 
 /* Registered in net/core/dev.c */
-struct pernet_operations __net_initdata loopback_net_ops = {
+struct pernet_operations __net_initconst loopback_net_ops = {
        .init = loopback_net_init,
 };
diff --git a/drivers/net/macsec.c b/drivers/net/macsec.c
index b72ddc61e..7f75c10e8 100644
--- a/drivers/net/macsec.c
+++ b/drivers/net/macsec.c
@@ -3388,7 +3388,7 @@ nla_put_failure:
 	return -EMSGSIZE;
 }
 
-static struct rtnl_link_ops macsec_link_ops __read_mostly = {
+static struct rtnl_link_ops macsec_link_ops = {
 	.kind		= "macsec",
 	.priv_size	= sizeof(struct macsec_dev),
 	.maxtype	= IFLA_MACSEC_MAX,
diff --git a/drivers/net/macvlan.c b/drivers/net/macvlan.c
index 3234fcdea..954fb39e2 100644
--- a/drivers/net/macvlan.c
+++ b/drivers/net/macvlan.c
@@ -343,7 +343,7 @@ static void macvlan_broadcast_enqueue(struct macvlan_port *port,
 free_nskb:
 	kfree_skb(nskb);
 err:
-	atomic_long_inc(&skb->dev->rx_dropped);
+	atomic_long_inc_unchecked(&skb->dev->rx_dropped);
 }
 
 static void macvlan_flush_sources(struct macvlan_port *port,
@@ -1508,13 +1508,15 @@ static const struct nla_policy macvlan_policy[IFLA_MACVLAN_MAX + 1] = {
 int macvlan_link_register(struct rtnl_link_ops *ops)
 {
 	/* common fields */
-	ops->priv_size		= sizeof(struct macvlan_dev);
-	ops->validate		= macvlan_validate;
-	ops->maxtype		= IFLA_MACVLAN_MAX;
-	ops->policy		= macvlan_policy;
-	ops->changelink		= macvlan_changelink;
-	ops->get_size		= macvlan_get_size;
-	ops->fill_info		= macvlan_fill_info;
+	pax_open_kernel();
+	const_cast(ops->priv_size)	= sizeof(struct macvlan_dev);
+	const_cast(ops->validate)	= macvlan_validate;
+	const_cast(ops->maxtype)	= IFLA_MACVLAN_MAX;
+	const_cast(ops->policy)		= macvlan_policy;
+	const_cast(ops->changelink)	= macvlan_changelink;
+	const_cast(ops->get_size)	= macvlan_get_size;
+	const_cast(ops->fill_info)	= macvlan_fill_info;
+	pax_close_kernel();
 
 	return rtnl_link_register(ops);
 };
@@ -1602,7 +1604,7 @@ static int macvlan_device_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block macvlan_notifier_block __read_mostly = {
+static struct notifier_block macvlan_notifier_block = {
 	.notifier_call	= macvlan_device_event,
 };
 
diff --git a/drivers/net/macvtap.c b/drivers/net/macvtap.c
index 070e3290a..b829217c8 100644
--- a/drivers/net/macvtap.c
+++ b/drivers/net/macvtap.c
@@ -508,7 +508,7 @@ static void macvtap_setup(struct net_device *dev)
 	dev->tx_queue_len = TUN_READQ_SIZE;
 }
 
-static struct rtnl_link_ops macvtap_link_ops __read_mostly = {
+static struct rtnl_link_ops macvtap_link_ops = {
 	.kind		= "macvtap",
 	.setup		= macvtap_setup,
 	.newlink	= macvtap_newlink,
@@ -1049,7 +1049,7 @@ static long macvtap_ioctl(struct file *file, unsigned int cmd,
 
 		ret = 0;
 		u = q->flags;
-		if (copy_to_user(&ifr->ifr_name, vlan->dev->name, IFNAMSIZ) ||
+		if (copy_to_user(ifr->ifr_name, vlan->dev->name, IFNAMSIZ) ||
 		    put_user(u, &ifr->ifr_flags))
 			ret = -EFAULT;
 		macvtap_put_vlan(vlan);
@@ -1132,8 +1132,8 @@ static long macvtap_ioctl(struct file *file, unsigned int cmd,
 		}
 		ret = 0;
 		u = vlan->dev->type;
-		if (copy_to_user(&ifr->ifr_name, vlan->dev->name, IFNAMSIZ) ||
-		    copy_to_user(&ifr->ifr_hwaddr.sa_data, vlan->dev->dev_addr, ETH_ALEN) ||
+		if (copy_to_user(ifr->ifr_name, vlan->dev->name, IFNAMSIZ) ||
+		    copy_to_user(ifr->ifr_hwaddr.sa_data, vlan->dev->dev_addr, ETH_ALEN) ||
 		    put_user(u, &ifr->ifr_hwaddr.sa_family))
 			ret = -EFAULT;
 		macvtap_put_vlan(vlan);
@@ -1311,7 +1311,7 @@ static int macvtap_device_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block macvtap_notifier_block __read_mostly = {
+static struct notifier_block macvtap_notifier_block = {
 	.notifier_call	= macvtap_device_event,
 };
 
diff --git a/drivers/net/nlmon.c b/drivers/net/nlmon.c
index 7b7c70e23..a92dc8393 100644
--- a/drivers/net/nlmon.c
+++ b/drivers/net/nlmon.c
@@ -154,7 +154,7 @@ static int nlmon_validate(struct nlattr *tb[], struct nlattr *data[])
 	return 0;
 }
 
-static struct rtnl_link_ops nlmon_link_ops __read_mostly = {
+static struct rtnl_link_ops nlmon_link_ops = {
 	.kind			= "nlmon",
 	.priv_size		= sizeof(struct nlmon),
 	.setup			= nlmon_setup,
diff --git a/drivers/net/phy/phy_device.c b/drivers/net/phy/phy_device.c
index e977ba931..e3df8dcd8 100644
--- a/drivers/net/phy/phy_device.c
+++ b/drivers/net/phy/phy_device.c
@@ -411,7 +411,7 @@ static int get_phy_c45_devs_in_pkg(struct mii_bus *bus, int addr, int dev_addr,
  *   zero on success.
  *
  */
-static int get_phy_c45_ids(struct mii_bus *bus, int addr, u32 *phy_id,
+static int get_phy_c45_ids(struct mii_bus *bus, int addr, int *phy_id,
 			   struct phy_c45_device_ids *c45_ids) {
 	int phy_reg;
 	int i, reg_addr;
@@ -482,7 +482,7 @@ static int get_phy_c45_ids(struct mii_bus *bus, int addr, u32 *phy_id,
  *   its return value is in turn returned.
  *
  */
-static int get_phy_id(struct mii_bus *bus, int addr, u32 *phy_id,
+static int get_phy_id(struct mii_bus *bus, int addr, int *phy_id,
 		      bool is_c45, struct phy_c45_device_ids *c45_ids)
 {
 	int phy_reg;
@@ -520,7 +520,7 @@ static int get_phy_id(struct mii_bus *bus, int addr, u32 *phy_id,
 struct phy_device *get_phy_device(struct mii_bus *bus, int addr, bool is_c45)
 {
 	struct phy_c45_device_ids c45_ids = {0};
-	u32 phy_id = 0;
+	int phy_id = 0;
 	int r;
 
 	r = get_phy_id(bus, addr, &phy_id, is_c45, &c45_ids);
diff --git a/drivers/net/plip/plip.c b/drivers/net/plip/plip.c
index 9c4b41a4d..03da80ba2 100644
--- a/drivers/net/plip/plip.c
+++ b/drivers/net/plip/plip.c
@@ -950,7 +950,7 @@ plip_interrupt(void *dev_id)
 	spin_unlock_irqrestore(&nl->lock, flags);
 }
 
-static int
+static netdev_tx_t
 plip_tx_packet(struct sk_buff *skb, struct net_device *dev)
 {
 	struct net_local *nl = netdev_priv(dev);
diff --git a/drivers/net/ppp/ppp_generic.c b/drivers/net/ppp/ppp_generic.c
index f226db461..6d75edc3e 100644
--- a/drivers/net/ppp/ppp_generic.c
+++ b/drivers/net/ppp/ppp_generic.c
@@ -1135,7 +1135,7 @@ static struct net *ppp_nl_get_link_net(const struct net_device *dev)
 	return ppp->ppp_net;
 }
 
-static struct rtnl_link_ops ppp_link_ops __read_mostly = {
+static struct rtnl_link_ops ppp_link_ops = {
 	.kind		= "ppp",
 	.maxtype	= IFLA_PPP_MAX,
 	.policy		= ppp_nl_policy,
@@ -1253,7 +1253,6 @@ ppp_net_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
 	void __user *addr = (void __user *) ifr->ifr_ifru.ifru_data;
 	struct ppp_stats stats;
 	struct ppp_comp_stats cstats;
-	char *vers;
 
 	switch (cmd) {
 	case SIOCGPPPSTATS:
@@ -1275,8 +1274,7 @@ ppp_net_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
 		break;
 
 	case SIOCGPPPVER:
-		vers = PPP_VERSION;
-		if (copy_to_user(addr, vers, strlen(vers) + 1))
+		if (copy_to_user(addr, PPP_VERSION, sizeof(PPP_VERSION)))
 			break;
 		err = 0;
 		break;
diff --git a/drivers/net/ppp/pptp.c b/drivers/net/ppp/pptp.c
index ae0905ed4..f22c8e9db 100644
--- a/drivers/net/ppp/pptp.c
+++ b/drivers/net/ppp/pptp.c
@@ -368,7 +368,7 @@ allow_packet:
 		}
 
 		skb->ip_summed = CHECKSUM_NONE;
-		skb_set_network_header(skb, skb->head-skb->data);
+		skb->network_header = 0;
 		ppp_input(&po->chan, skb);
 
 		return NET_RX_SUCCESS;
diff --git a/drivers/net/rionet.c b/drivers/net/rionet.c
index a31f4610b..949a77af0 100644
--- a/drivers/net/rionet.c
+++ b/drivers/net/rionet.c
@@ -170,7 +170,7 @@ static int rionet_queue_tx_msg(struct sk_buff *skb, struct net_device *ndev,
 	return 0;
 }
 
-static int rionet_start_xmit(struct sk_buff *skb, struct net_device *ndev)
+static netdev_tx_t rionet_start_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	int i;
 	struct rionet_private *rnet = netdev_priv(ndev);
diff --git a/drivers/net/slip/slhc.c b/drivers/net/slip/slhc.c
index 27ed25252..80cffdeac 100644
--- a/drivers/net/slip/slhc.c
+++ b/drivers/net/slip/slhc.c
@@ -491,7 +491,7 @@ slhc_uncompress(struct slcompress *comp, unsigned char *icp, int isize)
 	register struct tcphdr *thp;
 	register struct iphdr *ip;
 	register struct cstate *cs;
-	int len, hdrlen;
+	long len, hdrlen;
 	unsigned char *cp = icp;
 
 	/* We've got a compressed packet; read the change byte */
diff --git a/drivers/net/team/team.c b/drivers/net/team/team.c
index a380649bf..fd8fe79cf 100644
--- a/drivers/net/team/team.c
+++ b/drivers/net/team/team.c
@@ -2135,7 +2135,7 @@ static unsigned int team_get_num_rx_queues(void)
 	return TEAM_DEFAULT_NUM_RX_QUEUES;
 }
 
-static struct rtnl_link_ops team_link_ops __read_mostly = {
+static struct rtnl_link_ops team_link_ops = {
 	.kind			= DRV_NAME,
 	.priv_size		= sizeof(struct team),
 	.setup			= team_setup,
@@ -2930,7 +2930,7 @@ static int team_device_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block team_notifier_block __read_mostly = {
+static struct notifier_block team_notifier_block = {
 	.notifier_call = team_device_event,
 };
 
diff --git a/drivers/net/tun.c b/drivers/net/tun.c
index 6f9df375c..3c37ed520 100644
--- a/drivers/net/tun.c
+++ b/drivers/net/tun.c
@@ -972,7 +972,7 @@ static void tun_set_headroom(struct net_device *dev, int new_hr)
 {
 	struct tun_struct *tun = netdev_priv(dev);
 
-	if (new_hr < NET_SKB_PAD)
+	if (new_hr < 0 || new_hr < NET_SKB_PAD)
 		new_hr = NET_SKB_PAD;
 
 	tun->align = new_hr;
@@ -1556,7 +1556,7 @@ static int tun_validate(struct nlattr *tb[], struct nlattr *data[])
 	return -EINVAL;
 }
 
-static struct rtnl_link_ops tun_link_ops __read_mostly = {
+static struct rtnl_link_ops tun_link_ops = {
 	.kind		= DRV_NAME,
 	.priv_size	= sizeof(struct tun_struct),
 	.setup		= tun_setup,
@@ -1985,7 +1985,7 @@ unlock:
 }
 
 static long __tun_chr_ioctl(struct file *file, unsigned int cmd,
-			    unsigned long arg, int ifreq_len)
+			    unsigned long arg, size_t ifreq_len)
 {
 	struct tun_file *tfile = file->private_data;
 	struct tun_struct *tun;
@@ -1999,6 +1999,9 @@ static long __tun_chr_ioctl(struct file *file, unsigned int cmd,
 	int le;
 	int ret;
 
+	if (ifreq_len > sizeof ifr)
+		return -EFAULT;
+
 	if (cmd == TUNSETIFF || cmd == TUNSETQUEUE || _IOC_TYPE(cmd) == 0x89) {
 		if (copy_from_user(&ifr, argp, ifreq_len))
 			return -EFAULT;
@@ -2514,7 +2517,7 @@ static int tun_device_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block tun_notifier_block __read_mostly = {
+static struct notifier_block tun_notifier_block = {
 	.notifier_call	= tun_device_event,
 };
 
diff --git a/drivers/net/usb/hso.c b/drivers/net/usb/hso.c
index 4b4458616..ae196593a 100644
--- a/drivers/net/usb/hso.c
+++ b/drivers/net/usb/hso.c
@@ -70,7 +70,7 @@
 #include <asm/byteorder.h>
 #include <linux/serial_core.h>
 #include <linux/serial.h>
-
+#include <asm/local.h>
 
 #define MOD_AUTHOR			"Option Wireless"
 #define MOD_DESCRIPTION			"USB High Speed Option driver"
@@ -1183,7 +1183,7 @@ static void put_rxbuf_data_and_resubmit_ctrl_urb(struct hso_serial *serial)
 	struct urb *urb;
 
 	urb = serial->rx_urb[0];
-	if (serial->port.count > 0) {
+	if (atomic_read(&serial->port.count) > 0) {
 		count = put_rxbuf_data(urb, serial);
 		if (count == -1)
 			return;
@@ -1221,7 +1221,7 @@ static void hso_std_serial_read_bulk_callback(struct urb *urb)
 	DUMP1(urb->transfer_buffer, urb->actual_length);
 
 	/* Anyone listening? */
-	if (serial->port.count == 0)
+	if (atomic_read(&serial->port.count) == 0)
 		return;
 
 	if (serial->parent->port_spec & HSO_INFO_CRC_BUG)
@@ -1237,8 +1237,9 @@ static void hso_std_serial_read_bulk_callback(struct urb *urb)
  * This needs to be a tasklet otherwise we will
  * end up recursively calling this function.
  */
-static void hso_unthrottle_tasklet(struct hso_serial *serial)
+static void hso_unthrottle_tasklet(unsigned long _serial)
 {
+	struct hso_serial *serial = (struct hso_serial *)_serial;
 	unsigned long flags;
 
 	spin_lock_irqsave(&serial->serial_lock, flags);
@@ -1282,18 +1283,17 @@ static int hso_serial_open(struct tty_struct *tty, struct file *filp)
 	tty_port_tty_set(&serial->port, tty);
 
 	/* check for port already opened, if not set the termios */
-	serial->port.count++;
-	if (serial->port.count == 1) {
+	if (atomic_inc_return(&serial->port.count) == 1) {
 		serial->rx_state = RX_IDLE;
 		/* Force default termio settings */
 		_hso_serial_set_termios(tty, NULL);
 		tasklet_init(&serial->unthrottle_tasklet,
-			     (void (*)(unsigned long))hso_unthrottle_tasklet,
+			     hso_unthrottle_tasklet,
 			     (unsigned long)serial);
 		result = hso_start_serial_device(serial->parent, GFP_KERNEL);
 		if (result) {
 			hso_stop_serial_device(serial->parent);
-			serial->port.count--;
+			atomic_dec(&serial->port.count);
 		} else {
 			kref_get(&serial->parent->ref);
 		}
@@ -1331,10 +1331,10 @@ static void hso_serial_close(struct tty_struct *tty, struct file *filp)
 
 	/* reset the rts and dtr */
 	/* do the actual close */
-	serial->port.count--;
+	atomic_dec(&serial->port.count);
 
-	if (serial->port.count <= 0) {
-		serial->port.count = 0;
+	if (atomic_read(&serial->port.count) <= 0) {
+		atomic_set(&serial->port.count, 0);
 		tty_port_tty_set(&serial->port, NULL);
 		if (!usb_gone)
 			hso_stop_serial_device(serial->parent);
@@ -1417,7 +1417,7 @@ static void hso_serial_set_termios(struct tty_struct *tty, struct ktermios *old)
 
 	/* the actual setup */
 	spin_lock_irqsave(&serial->serial_lock, flags);
-	if (serial->port.count)
+	if (atomic_read(&serial->port.count))
 		_hso_serial_set_termios(tty, old);
 	else
 		tty->termios = *old;
@@ -1891,7 +1891,7 @@ static void intr_callback(struct urb *urb)
 				D1("Pending read interrupt on port %d\n", i);
 				spin_lock(&serial->serial_lock);
 				if (serial->rx_state == RX_IDLE &&
-					serial->port.count > 0) {
+					atomic_read(&serial->port.count) > 0) {
 					/* Setup and send a ctrl req read on
 					 * port i */
 					if (!serial->rx_urb_filled[0]) {
@@ -3058,7 +3058,7 @@ static int hso_resume(struct usb_interface *iface)
 	/* Start all serial ports */
 	for (i = 0; i < HSO_SERIAL_TTY_MINORS; i++) {
 		if (serial_table[i] && (serial_table[i]->interface == iface)) {
-			if (dev2ser(serial_table[i])->port.count) {
+			if (atomic_read(&dev2ser(serial_table[i])->port.count)) {
 				result =
 				    hso_start_serial_device(serial_table[i], GFP_NOIO);
 				hso_kick_transmit(dev2ser(serial_table[i]));
diff --git a/drivers/net/usb/ipheth.c b/drivers/net/usb/ipheth.c
index 76465b117..2d72355fb 100644
--- a/drivers/net/usb/ipheth.c
+++ b/drivers/net/usb/ipheth.c
@@ -400,7 +400,7 @@ static int ipheth_close(struct net_device *net)
 	return 0;
 }
 
-static int ipheth_tx(struct sk_buff *skb, struct net_device *net)
+static netdev_tx_t ipheth_tx(struct sk_buff *skb, struct net_device *net)
 {
 	struct ipheth_device *dev = netdev_priv(net);
 	struct usb_device *udev = dev->udev;
diff --git a/drivers/net/usb/r8152.c b/drivers/net/usb/r8152.c
index c25424886..e4a52dc07 100644
--- a/drivers/net/usb/r8152.c
+++ b/drivers/net/usb/r8152.c
@@ -632,7 +632,7 @@ struct r8152 {
 		bool (*in_nway)(struct r8152 *);
 		void (*hw_phy_cfg)(struct r8152 *);
 		void (*autosuspend_en)(struct r8152 *tp, bool enable);
-	} rtl_ops;
+	} __no_const rtl_ops;
 
 	int intr_interval;
 	u32 saved_wolopts;
diff --git a/drivers/net/usb/sierra_net.c b/drivers/net/usb/sierra_net.c
index a25158876..6d1323305 100644
--- a/drivers/net/usb/sierra_net.c
+++ b/drivers/net/usb/sierra_net.c
@@ -51,7 +51,7 @@ static const char driver_name[] = "sierra_net";
 /* atomic counter partially included in MAC address to make sure 2 devices
  * do not end up with the same MAC - concept breaks in case of > 255 ifaces
  */
-static	atomic_t iface_counter = ATOMIC_INIT(0);
+static	atomic_unchecked_t iface_counter = ATOMIC_INIT(0);
 
 /*
  * SYNC Timer Delay definition used to set the expiry time
@@ -697,7 +697,7 @@ static int sierra_net_bind(struct usbnet *dev, struct usb_interface *intf)
 	dev->net->netdev_ops = &sierra_net_device_ops;
 
 	/* change MAC addr to include, ifacenum, and to be unique */
-	dev->net->dev_addr[ETH_ALEN-2] = atomic_inc_return(&iface_counter);
+	dev->net->dev_addr[ETH_ALEN-2] = atomic_inc_return_unchecked(&iface_counter);
 	dev->net->dev_addr[ETH_ALEN-1] = ifacenum;
 
 	/* we will have to manufacture ethernet headers, prepare template */
diff --git a/drivers/net/virtio_net.c b/drivers/net/virtio_net.c
index d8072092e..90cc005b7 100644
--- a/drivers/net/virtio_net.c
+++ b/drivers/net/virtio_net.c
@@ -48,7 +48,7 @@ module_param(gso, bool, 0444);
 DECLARE_EWMA(pkt_len, 1, 64)
 
 /* Minimum alignment for mergeable packet buffers. */
-#define MERGEABLE_BUFFER_ALIGN max(L1_CACHE_BYTES, 256)
+#define MERGEABLE_BUFFER_ALIGN max(L1_CACHE_BYTES, 256UL)
 
 #define VIRTNET_DRIVER_VERSION "1.0.0"
 
diff --git a/drivers/net/vrf.c b/drivers/net/vrf.c
index 1ce742032..8bef471ee 100644
--- a/drivers/net/vrf.c
+++ b/drivers/net/vrf.c
@@ -1287,7 +1287,7 @@ static const struct nla_policy vrf_nl_policy[IFLA_VRF_MAX + 1] = {
 	[IFLA_VRF_TABLE] = { .type = NLA_U32 },
 };
 
-static struct rtnl_link_ops vrf_link_ops __read_mostly = {
+static struct rtnl_link_ops vrf_link_ops = {
 	.kind		= DRV_NAME,
 	.priv_size	= sizeof(struct net_vrf),
 
@@ -1324,7 +1324,7 @@ out:
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block vrf_notifier_block __read_mostly = {
+static struct notifier_block vrf_notifier_block = {
 	.notifier_call = vrf_device_event,
 };
 
diff --git a/drivers/net/vxlan.c b/drivers/net/vxlan.c
index 5ae664c02..65d0be533 100644
--- a/drivers/net/vxlan.c
+++ b/drivers/net/vxlan.c
@@ -3169,7 +3169,7 @@ static struct net *vxlan_get_link_net(const struct net_device *dev)
 	return vxlan->net;
 }
 
-static struct rtnl_link_ops vxlan_link_ops __read_mostly = {
+static struct rtnl_link_ops vxlan_link_ops = {
 	.kind		= "vxlan",
 	.maxtype	= IFLA_VXLAN_MAX,
 	.policy		= vxlan_policy,
@@ -3253,7 +3253,7 @@ static int vxlan_netdevice_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block vxlan_notifier_block __read_mostly = {
+static struct notifier_block vxlan_notifier_block = {
 	.notifier_call = vxlan_netdevice_event,
 };
 
diff --git a/drivers/net/wan/lmc/lmc_media.c b/drivers/net/wan/lmc/lmc_media.c
index 5920c996f..ff2e4a565 100644
--- a/drivers/net/wan/lmc/lmc_media.c
+++ b/drivers/net/wan/lmc/lmc_media.c
@@ -95,62 +95,63 @@ static inline void write_av9110_bit (lmc_softc_t *, int);
 static void write_av9110(lmc_softc_t *, u32, u32, u32, u32, u32);
 
 lmc_media_t lmc_ds3_media = {
-  lmc_ds3_init,			/* special media init stuff */
-  lmc_ds3_default,		/* reset to default state */
-  lmc_ds3_set_status,		/* reset status to state provided */
-  lmc_dummy_set_1,		/* set clock source */
-  lmc_dummy_set2_1,		/* set line speed */
-  lmc_ds3_set_100ft,		/* set cable length */
-  lmc_ds3_set_scram,		/* set scrambler */
-  lmc_ds3_get_link_status,	/* get link status */
-  lmc_dummy_set_1,		/* set link status */
-  lmc_ds3_set_crc_length,	/* set CRC length */
-  lmc_dummy_set_1,		/* set T1 or E1 circuit type */
-  lmc_ds3_watchdog
+  .init = lmc_ds3_init,				/* special media init stuff */
+  .defaults = lmc_ds3_default,			/* reset to default state */
+  .set_status = lmc_ds3_set_status,		/* reset status to state provided */
+  .set_clock_source = lmc_dummy_set_1,		/* set clock source */
+  .set_speed = lmc_dummy_set2_1,		/* set line speed */
+  .set_cable_length = lmc_ds3_set_100ft,	/* set cable length */
+  .set_scrambler = lmc_ds3_set_scram,		/* set scrambler */
+  .get_link_status = lmc_ds3_get_link_status,	/* get link status */
+  .set_link_status = lmc_dummy_set_1,		/* set link status */
+  .set_crc_length = lmc_ds3_set_crc_length,	/* set CRC length */
+  .set_circuit_type = lmc_dummy_set_1,		/* set T1 or E1 circuit type */
+  .watchdog = lmc_ds3_watchdog
 };
 
 lmc_media_t lmc_hssi_media = {
-  lmc_hssi_init,		/* special media init stuff */
-  lmc_hssi_default,		/* reset to default state */
-  lmc_hssi_set_status,		/* reset status to state provided */
-  lmc_hssi_set_clock,		/* set clock source */
-  lmc_dummy_set2_1,		/* set line speed */
-  lmc_dummy_set_1,		/* set cable length */
-  lmc_dummy_set_1,		/* set scrambler */
-  lmc_hssi_get_link_status,	/* get link status */
-  lmc_hssi_set_link_status,	/* set link status */
-  lmc_hssi_set_crc_length,	/* set CRC length */
-  lmc_dummy_set_1,		/* set T1 or E1 circuit type */
-  lmc_hssi_watchdog
+  .init = lmc_hssi_init,			/* special media init stuff */
+  .defaults = lmc_hssi_default,			/* reset to default state */
+  .set_status = lmc_hssi_set_status,		/* reset status to state provided */
+  .set_clock_source = lmc_hssi_set_clock,	/* set clock source */
+  .set_speed = lmc_dummy_set2_1,		/* set line speed */
+  .set_cable_length = lmc_dummy_set_1,		/* set cable length */
+  .set_scrambler = lmc_dummy_set_1,		/* set scrambler */
+  .get_link_status = lmc_hssi_get_link_status,	/* get link status */
+  .set_link_status = lmc_hssi_set_link_status,	/* set link status */
+  .set_crc_length = lmc_hssi_set_crc_length,	/* set CRC length */
+  .set_circuit_type = lmc_dummy_set_1,		/* set T1 or E1 circuit type */
+  .watchdog = lmc_hssi_watchdog
 };
 
-lmc_media_t lmc_ssi_media = { lmc_ssi_init,	/* special media init stuff */
-  lmc_ssi_default,		/* reset to default state */
-  lmc_ssi_set_status,		/* reset status to state provided */
-  lmc_ssi_set_clock,		/* set clock source */
-  lmc_ssi_set_speed,		/* set line speed */
-  lmc_dummy_set_1,		/* set cable length */
-  lmc_dummy_set_1,		/* set scrambler */
-  lmc_ssi_get_link_status,	/* get link status */
-  lmc_ssi_set_link_status,	/* set link status */
-  lmc_ssi_set_crc_length,	/* set CRC length */
-  lmc_dummy_set_1,		/* set T1 or E1 circuit type */
-  lmc_ssi_watchdog
+lmc_media_t lmc_ssi_media = {
+  .init = lmc_ssi_init,				/* special media init stuff */
+  .defaults = lmc_ssi_default,			/* reset to default state */
+  .set_status = lmc_ssi_set_status,		/* reset status to state provided */
+  .set_clock_source = lmc_ssi_set_clock,	/* set clock source */
+  .set_speed = lmc_ssi_set_speed,		/* set line speed */
+  .set_cable_length = lmc_dummy_set_1,		/* set cable length */
+  .set_scrambler = lmc_dummy_set_1,		/* set scrambler */
+  .get_link_status = lmc_ssi_get_link_status,	/* get link status */
+  .set_link_status = lmc_ssi_set_link_status,	/* set link status */
+  .set_crc_length = lmc_ssi_set_crc_length,	/* set CRC length */
+  .set_circuit_type = lmc_dummy_set_1,		/* set T1 or E1 circuit type */
+  .watchdog = lmc_ssi_watchdog
 };
 
 lmc_media_t lmc_t1_media = {
-  lmc_t1_init,			/* special media init stuff */
-  lmc_t1_default,		/* reset to default state */
-  lmc_t1_set_status,		/* reset status to state provided */
-  lmc_t1_set_clock,		/* set clock source */
-  lmc_dummy_set2_1,		/* set line speed */
-  lmc_dummy_set_1,		/* set cable length */
-  lmc_dummy_set_1,		/* set scrambler */
-  lmc_t1_get_link_status,	/* get link status */
-  lmc_dummy_set_1,		/* set link status */
-  lmc_t1_set_crc_length,	/* set CRC length */
-  lmc_t1_set_circuit_type,	/* set T1 or E1 circuit type */
-  lmc_t1_watchdog
+  .init = lmc_t1_init,				/* special media init stuff */
+  .defaults = lmc_t1_default,			/* reset to default state */
+  .set_status = lmc_t1_set_status,		/* reset status to state provided */
+  .set_clock_source = lmc_t1_set_clock,		/* set clock source */
+  .set_speed = lmc_dummy_set2_1,		/* set line speed */
+  .set_cable_length = lmc_dummy_set_1,		/* set cable length */
+  .set_scrambler = lmc_dummy_set_1,		/* set scrambler */
+  .get_link_status = lmc_t1_get_link_status,	/* get link status */
+  .set_link_status = lmc_dummy_set_1,		/* set link status */
+  .set_crc_length = lmc_t1_set_crc_length,	/* set CRC length */
+  .set_circuit_type = lmc_t1_set_circuit_type,	/* set T1 or E1 circuit type */
+  .watchdog = lmc_t1_watchdog
 };
 
 static void
diff --git a/drivers/net/wan/z85230.c b/drivers/net/wan/z85230.c
index 2f0bd6955..e46ed7bba 100644
--- a/drivers/net/wan/z85230.c
+++ b/drivers/net/wan/z85230.c
@@ -485,9 +485,9 @@ static void z8530_status(struct z8530_channel *chan)
 
 struct z8530_irqhandler z8530_sync =
 {
-	z8530_rx,
-	z8530_tx,
-	z8530_status
+	.rx = z8530_rx,
+	.tx = z8530_tx,
+	.status = z8530_status
 };
 
 EXPORT_SYMBOL(z8530_sync);
@@ -605,15 +605,15 @@ static void z8530_dma_status(struct z8530_channel *chan)
 }
 
 static struct z8530_irqhandler z8530_dma_sync = {
-	z8530_dma_rx,
-	z8530_dma_tx,
-	z8530_dma_status
+	.rx = z8530_dma_rx,
+	.tx = z8530_dma_tx,
+	.status = z8530_dma_status
 };
 
 static struct z8530_irqhandler z8530_txdma_sync = {
-	z8530_rx,
-	z8530_dma_tx,
-	z8530_dma_status
+	.rx = z8530_rx,
+	.tx = z8530_dma_tx,
+	.status = z8530_dma_status
 };
 
 /**
@@ -680,9 +680,9 @@ static void z8530_status_clear(struct z8530_channel *chan)
 
 struct z8530_irqhandler z8530_nop=
 {
-	z8530_rx_clear,
-	z8530_tx_clear,
-	z8530_status_clear
+	.rx = z8530_rx_clear,
+	.tx = z8530_tx_clear,
+	.status = z8530_status_clear
 };
 
 
diff --git a/drivers/net/wimax/i2400m/rx.c b/drivers/net/wimax/i2400m/rx.c
index 0b602951f..b8bfa5b2b 100644
--- a/drivers/net/wimax/i2400m/rx.c
+++ b/drivers/net/wimax/i2400m/rx.c
@@ -1359,7 +1359,7 @@ int i2400m_rx_setup(struct i2400m *i2400m)
 		if (i2400m->rx_roq == NULL)
 			goto error_roq_alloc;
 
-		rd = kcalloc(I2400M_RO_CIN + 1, sizeof(*i2400m->rx_roq[0].log),
+		rd = kcalloc(sizeof(*i2400m->rx_roq[0].log), I2400M_RO_CIN + 1,
 			     GFP_KERNEL);
 		if (rd == NULL) {
 			result = -ENOMEM;
diff --git a/drivers/net/wireless/ath/ath10k/ce.c b/drivers/net/wireless/ath/ath10k/ce.c
index da9998ea9..5ef101a0e 100644
--- a/drivers/net/wireless/ath/ath10k/ce.c
+++ b/drivers/net/wireless/ath/ath10k/ce.c
@@ -887,12 +887,12 @@ static int ath10k_ce_init_dest_ring(struct ath10k *ar,
 	return 0;
 }
 
-static struct ath10k_ce_ring *
+static struct ath10k_ce_ring * __intentional_overflow(-1)
 ath10k_ce_alloc_src_ring(struct ath10k *ar, unsigned int ce_id,
 			 const struct ce_attr *attr)
 {
 	struct ath10k_ce_ring *src_ring;
-	u32 nentries = attr->src_nentries;
+	unsigned long nentries = attr->src_nentries;
 	dma_addr_t base_addr;
 
 	nentries = roundup_pow_of_two(nentries);
@@ -938,7 +938,7 @@ ath10k_ce_alloc_dest_ring(struct ath10k *ar, unsigned int ce_id,
 			  const struct ce_attr *attr)
 {
 	struct ath10k_ce_ring *dest_ring;
-	u32 nentries;
+	unsigned long nentries;
 	dma_addr_t base_addr;
 
 	nentries = roundup_pow_of_two(attr->dest_nentries);
diff --git a/drivers/net/wireless/ath/ath10k/htc.h b/drivers/net/wireless/ath/ath10k/htc.h
index 0c55cd92a..7fc013b37 100644
--- a/drivers/net/wireless/ath/ath10k/htc.h
+++ b/drivers/net/wireless/ath/ath10k/htc.h
@@ -269,13 +269,13 @@ enum ath10k_htc_ep_id {
 
 struct ath10k_htc_ops {
 	void (*target_send_suspend_complete)(struct ath10k *ar);
-};
+} __no_const;
 
 struct ath10k_htc_ep_ops {
 	void (*ep_tx_complete)(struct ath10k *, struct sk_buff *);
 	void (*ep_rx_complete)(struct ath10k *, struct sk_buff *);
 	void (*ep_tx_credits)(struct ath10k *);
-};
+} __no_const;
 
 /* service connection information */
 struct ath10k_htc_svc_conn_req {
diff --git a/drivers/net/wireless/ath/ath10k/mac.c b/drivers/net/wireless/ath/ath10k/mac.c
index 146365b93..b0aef3672 100644
--- a/drivers/net/wireless/ath/ath10k/mac.c
+++ b/drivers/net/wireless/ath/ath10k/mac.c
@@ -7991,8 +7991,11 @@ int ath10k_mac_register(struct ath10k *ar)
 	 * supports the pull-push mechanism.
 	 */
 	if (!test_bit(ATH10K_FW_FEATURE_PEER_FLOW_CONTROL,
-		      ar->running_fw->fw_file.fw_features))
-		ar->ops->wake_tx_queue = NULL;
+		      ar->running_fw->fw_file.fw_features)) {
+		pax_open_kernel();
+		const_cast(ar->ops->wake_tx_queue) = NULL;
+		pax_close_kernel();
+	}
 
 	ret = ath_regd_init(&ar->ath_common.regulatory, ar->hw->wiphy,
 			    ath10k_reg_notifier);
diff --git a/drivers/net/wireless/ath/ath6kl/core.h b/drivers/net/wireless/ath/ath6kl/core.h
index 0bf4592a3..11a7ae1e3 100644
--- a/drivers/net/wireless/ath/ath6kl/core.h
+++ b/drivers/net/wireless/ath/ath6kl/core.h
@@ -915,7 +915,7 @@ void ath6kl_tx_data_cleanup(struct ath6kl *ar);
 
 struct ath6kl_cookie *ath6kl_alloc_cookie(struct ath6kl *ar);
 void ath6kl_free_cookie(struct ath6kl *ar, struct ath6kl_cookie *cookie);
-int ath6kl_data_tx(struct sk_buff *skb, struct net_device *dev);
+netdev_tx_t ath6kl_data_tx(struct sk_buff *skb, struct net_device *dev);
 
 struct aggr_info *aggr_init(struct ath6kl_vif *vif);
 void aggr_conn_init(struct ath6kl_vif *vif, struct aggr_info *aggr_info,
diff --git a/drivers/net/wireless/ath/ath6kl/txrx.c b/drivers/net/wireless/ath/ath6kl/txrx.c
index 9df41d5e3..fb12f17f1 100644
--- a/drivers/net/wireless/ath/ath6kl/txrx.c
+++ b/drivers/net/wireless/ath/ath6kl/txrx.c
@@ -353,7 +353,7 @@ fail_ctrl_tx:
 	return status;
 }
 
-int ath6kl_data_tx(struct sk_buff *skb, struct net_device *dev)
+netdev_tx_t ath6kl_data_tx(struct sk_buff *skb, struct net_device *dev)
 {
 	struct ath6kl *ar = ath6kl_priv(dev);
 	struct ath6kl_cookie *cookie = NULL;
diff --git a/drivers/net/wireless/ath/ath9k/Kconfig b/drivers/net/wireless/ath/ath9k/Kconfig
index f68cb0045..7e16ed6cb 100644
--- a/drivers/net/wireless/ath/ath9k/Kconfig
+++ b/drivers/net/wireless/ath/ath9k/Kconfig
@@ -3,7 +3,6 @@ config ATH9K_HW
 config ATH9K_COMMON
 	tristate
 	select ATH_COMMON
-	select DEBUG_FS
 	select RELAY
 config ATH9K_DFS_DEBUGFS
 	def_bool y
diff --git a/drivers/net/wireless/ath/ath9k/ar9002_mac.c b/drivers/net/wireless/ath/ath9k/ar9002_mac.c
index f816909d9..e56cd8b02 100644
--- a/drivers/net/wireless/ath/ath9k/ar9002_mac.c
+++ b/drivers/net/wireless/ath/ath9k/ar9002_mac.c
@@ -220,8 +220,8 @@ ar9002_set_txdesc(struct ath_hw *ah, void *ds, struct ath_tx_info *i)
 	ads->ds_txstatus6 = ads->ds_txstatus7 = 0;
 	ads->ds_txstatus8 = ads->ds_txstatus9 = 0;
 
-	ACCESS_ONCE(ads->ds_link) = i->link;
-	ACCESS_ONCE(ads->ds_data) = i->buf_addr[0];
+	ACCESS_ONCE_RW(ads->ds_link) = i->link;
+	ACCESS_ONCE_RW(ads->ds_data) = i->buf_addr[0];
 
 	ctl1 = i->buf_len[0] | (i->is_last ? 0 : AR_TxMore);
 	ctl6 = SM(i->keytype, AR_EncrType);
@@ -235,26 +235,26 @@ ar9002_set_txdesc(struct ath_hw *ah, void *ds, struct ath_tx_info *i)
 
 	if ((i->is_first || i->is_last) &&
 	    i->aggr != AGGR_BUF_MIDDLE && i->aggr != AGGR_BUF_LAST) {
-		ACCESS_ONCE(ads->ds_ctl2) = set11nTries(i->rates, 0)
+		ACCESS_ONCE_RW(ads->ds_ctl2) = set11nTries(i->rates, 0)
 			| set11nTries(i->rates, 1)
 			| set11nTries(i->rates, 2)
 			| set11nTries(i->rates, 3)
 			| (i->dur_update ? AR_DurUpdateEna : 0)
 			| SM(0, AR_BurstDur);
 
-		ACCESS_ONCE(ads->ds_ctl3) = set11nRate(i->rates, 0)
+		ACCESS_ONCE_RW(ads->ds_ctl3) = set11nRate(i->rates, 0)
 			| set11nRate(i->rates, 1)
 			| set11nRate(i->rates, 2)
 			| set11nRate(i->rates, 3);
 	} else {
-		ACCESS_ONCE(ads->ds_ctl2) = 0;
-		ACCESS_ONCE(ads->ds_ctl3) = 0;
+		ACCESS_ONCE_RW(ads->ds_ctl2) = 0;
+		ACCESS_ONCE_RW(ads->ds_ctl3) = 0;
 	}
 
 	if (!i->is_first) {
-		ACCESS_ONCE(ads->ds_ctl0) = 0;
-		ACCESS_ONCE(ads->ds_ctl1) = ctl1;
-		ACCESS_ONCE(ads->ds_ctl6) = ctl6;
+		ACCESS_ONCE_RW(ads->ds_ctl0) = 0;
+		ACCESS_ONCE_RW(ads->ds_ctl1) = ctl1;
+		ACCESS_ONCE_RW(ads->ds_ctl6) = ctl6;
 		return;
 	}
 
@@ -279,7 +279,7 @@ ar9002_set_txdesc(struct ath_hw *ah, void *ds, struct ath_tx_info *i)
 		break;
 	}
 
-	ACCESS_ONCE(ads->ds_ctl0) = (i->pkt_len & AR_FrameLen)
+	ACCESS_ONCE_RW(ads->ds_ctl0) = (i->pkt_len & AR_FrameLen)
 		| (i->flags & ATH9K_TXDESC_VMF ? AR_VirtMoreFrag : 0)
 		| SM(i->txpower[0], AR_XmitPower0)
 		| (i->flags & ATH9K_TXDESC_VEOL ? AR_VEOL : 0)
@@ -289,27 +289,27 @@ ar9002_set_txdesc(struct ath_hw *ah, void *ds, struct ath_tx_info *i)
 		| (i->flags & ATH9K_TXDESC_RTSENA ? AR_RTSEnable :
 		   (i->flags & ATH9K_TXDESC_CTSENA ? AR_CTSEnable : 0));
 
-	ACCESS_ONCE(ads->ds_ctl1) = ctl1;
-	ACCESS_ONCE(ads->ds_ctl6) = ctl6;
+	ACCESS_ONCE_RW(ads->ds_ctl1) = ctl1;
+	ACCESS_ONCE_RW(ads->ds_ctl6) = ctl6;
 
 	if (i->aggr == AGGR_BUF_MIDDLE || i->aggr == AGGR_BUF_LAST)
 		return;
 
-	ACCESS_ONCE(ads->ds_ctl4) = set11nPktDurRTSCTS(i->rates, 0)
+	ACCESS_ONCE_RW(ads->ds_ctl4) = set11nPktDurRTSCTS(i->rates, 0)
 		| set11nPktDurRTSCTS(i->rates, 1);
 
-	ACCESS_ONCE(ads->ds_ctl5) = set11nPktDurRTSCTS(i->rates, 2)
+	ACCESS_ONCE_RW(ads->ds_ctl5) = set11nPktDurRTSCTS(i->rates, 2)
 		| set11nPktDurRTSCTS(i->rates, 3);
 
-	ACCESS_ONCE(ads->ds_ctl7) = set11nRateFlags(i->rates, 0)
+	ACCESS_ONCE_RW(ads->ds_ctl7) = set11nRateFlags(i->rates, 0)
 		| set11nRateFlags(i->rates, 1)
 		| set11nRateFlags(i->rates, 2)
 		| set11nRateFlags(i->rates, 3)
 		| SM(i->rtscts_rate, AR_RTSCTSRate);
 
-	ACCESS_ONCE(ads->ds_ctl9) = SM(i->txpower[1], AR_XmitPower1);
-	ACCESS_ONCE(ads->ds_ctl10) = SM(i->txpower[2], AR_XmitPower2);
-	ACCESS_ONCE(ads->ds_ctl11) = SM(i->txpower[3], AR_XmitPower3);
+	ACCESS_ONCE_RW(ads->ds_ctl9) = SM(i->txpower[1], AR_XmitPower1);
+	ACCESS_ONCE_RW(ads->ds_ctl10) = SM(i->txpower[2], AR_XmitPower2);
+	ACCESS_ONCE_RW(ads->ds_ctl11) = SM(i->txpower[3], AR_XmitPower3);
 }
 
 static int ar9002_hw_proc_txdesc(struct ath_hw *ah, void *ds,
diff --git a/drivers/net/wireless/ath/ath9k/ar9003_mac.c b/drivers/net/wireless/ath/ath9k/ar9003_mac.c
index da84b705c..83e497821 100644
--- a/drivers/net/wireless/ath/ath9k/ar9003_mac.c
+++ b/drivers/net/wireless/ath/ath9k/ar9003_mac.c
@@ -39,47 +39,47 @@ ar9003_set_txdesc(struct ath_hw *ah, void *ds, struct ath_tx_info *i)
 	      (i->qcu << AR_TxQcuNum_S) | desc_len;
 
 	checksum += val;
-	ACCESS_ONCE(ads->info) = val;
+	ACCESS_ONCE_RW(ads->info) = val;
 
 	checksum += i->link;
-	ACCESS_ONCE(ads->link) = i->link;
+	ACCESS_ONCE_RW(ads->link) = i->link;
 
 	checksum += i->buf_addr[0];
-	ACCESS_ONCE(ads->data0) = i->buf_addr[0];
+	ACCESS_ONCE_RW(ads->data0) = i->buf_addr[0];
 	checksum += i->buf_addr[1];
-	ACCESS_ONCE(ads->data1) = i->buf_addr[1];
+	ACCESS_ONCE_RW(ads->data1) = i->buf_addr[1];
 	checksum += i->buf_addr[2];
-	ACCESS_ONCE(ads->data2) = i->buf_addr[2];
+	ACCESS_ONCE_RW(ads->data2) = i->buf_addr[2];
 	checksum += i->buf_addr[3];
-	ACCESS_ONCE(ads->data3) = i->buf_addr[3];
+	ACCESS_ONCE_RW(ads->data3) = i->buf_addr[3];
 
 	checksum += (val = (i->buf_len[0] << AR_BufLen_S) & AR_BufLen);
-	ACCESS_ONCE(ads->ctl3) = val;
+	ACCESS_ONCE_RW(ads->ctl3) = val;
 	checksum += (val = (i->buf_len[1] << AR_BufLen_S) & AR_BufLen);
-	ACCESS_ONCE(ads->ctl5) = val;
+	ACCESS_ONCE_RW(ads->ctl5) = val;
 	checksum += (val = (i->buf_len[2] << AR_BufLen_S) & AR_BufLen);
-	ACCESS_ONCE(ads->ctl7) = val;
+	ACCESS_ONCE_RW(ads->ctl7) = val;
 	checksum += (val = (i->buf_len[3] << AR_BufLen_S) & AR_BufLen);
-	ACCESS_ONCE(ads->ctl9) = val;
+	ACCESS_ONCE_RW(ads->ctl9) = val;
 
 	checksum = (u16) (((checksum & 0xffff) + (checksum >> 16)) & 0xffff);
-	ACCESS_ONCE(ads->ctl10) = checksum;
+	ACCESS_ONCE_RW(ads->ctl10) = checksum;
 
 	if (i->is_first || i->is_last) {
-		ACCESS_ONCE(ads->ctl13) = set11nTries(i->rates, 0)
+		ACCESS_ONCE_RW(ads->ctl13) = set11nTries(i->rates, 0)
 			| set11nTries(i->rates, 1)
 			| set11nTries(i->rates, 2)
 			| set11nTries(i->rates, 3)
 			| (i->dur_update ? AR_DurUpdateEna : 0)
 			| SM(0, AR_BurstDur);
 
-		ACCESS_ONCE(ads->ctl14) = set11nRate(i->rates, 0)
+		ACCESS_ONCE_RW(ads->ctl14) = set11nRate(i->rates, 0)
 			| set11nRate(i->rates, 1)
 			| set11nRate(i->rates, 2)
 			| set11nRate(i->rates, 3);
 	} else {
-		ACCESS_ONCE(ads->ctl13) = 0;
-		ACCESS_ONCE(ads->ctl14) = 0;
+		ACCESS_ONCE_RW(ads->ctl13) = 0;
+		ACCESS_ONCE_RW(ads->ctl14) = 0;
 	}
 
 	ads->ctl20 = 0;
@@ -89,17 +89,17 @@ ar9003_set_txdesc(struct ath_hw *ah, void *ds, struct ath_tx_info *i)
 
 	ctl17 = SM(i->keytype, AR_EncrType);
 	if (!i->is_first) {
-		ACCESS_ONCE(ads->ctl11) = 0;
-		ACCESS_ONCE(ads->ctl12) = i->is_last ? 0 : AR_TxMore;
-		ACCESS_ONCE(ads->ctl15) = 0;
-		ACCESS_ONCE(ads->ctl16) = 0;
-		ACCESS_ONCE(ads->ctl17) = ctl17;
-		ACCESS_ONCE(ads->ctl18) = 0;
-		ACCESS_ONCE(ads->ctl19) = 0;
+		ACCESS_ONCE_RW(ads->ctl11) = 0;
+		ACCESS_ONCE_RW(ads->ctl12) = i->is_last ? 0 : AR_TxMore;
+		ACCESS_ONCE_RW(ads->ctl15) = 0;
+		ACCESS_ONCE_RW(ads->ctl16) = 0;
+		ACCESS_ONCE_RW(ads->ctl17) = ctl17;
+		ACCESS_ONCE_RW(ads->ctl18) = 0;
+		ACCESS_ONCE_RW(ads->ctl19) = 0;
 		return;
 	}
 
-	ACCESS_ONCE(ads->ctl11) = (i->pkt_len & AR_FrameLen)
+	ACCESS_ONCE_RW(ads->ctl11) = (i->pkt_len & AR_FrameLen)
 		| (i->flags & ATH9K_TXDESC_VMF ? AR_VirtMoreFrag : 0)
 		| SM(i->txpower[0], AR_XmitPower0)
 		| (i->flags & ATH9K_TXDESC_VEOL ? AR_VEOL : 0)
@@ -135,26 +135,26 @@ ar9003_set_txdesc(struct ath_hw *ah, void *ds, struct ath_tx_info *i)
 	val = (i->flags & ATH9K_TXDESC_PAPRD) >> ATH9K_TXDESC_PAPRD_S;
 	ctl12 |= SM(val, AR_PAPRDChainMask);
 
-	ACCESS_ONCE(ads->ctl12) = ctl12;
-	ACCESS_ONCE(ads->ctl17) = ctl17;
+	ACCESS_ONCE_RW(ads->ctl12) = ctl12;
+	ACCESS_ONCE_RW(ads->ctl17) = ctl17;
 
-	ACCESS_ONCE(ads->ctl15) = set11nPktDurRTSCTS(i->rates, 0)
+	ACCESS_ONCE_RW(ads->ctl15) = set11nPktDurRTSCTS(i->rates, 0)
 		| set11nPktDurRTSCTS(i->rates, 1);
 
-	ACCESS_ONCE(ads->ctl16) = set11nPktDurRTSCTS(i->rates, 2)
+	ACCESS_ONCE_RW(ads->ctl16) = set11nPktDurRTSCTS(i->rates, 2)
 		| set11nPktDurRTSCTS(i->rates, 3);
 
-	ACCESS_ONCE(ads->ctl18) = set11nRateFlags(i->rates, 0)
+	ACCESS_ONCE_RW(ads->ctl18) = set11nRateFlags(i->rates, 0)
 		| set11nRateFlags(i->rates, 1)
 		| set11nRateFlags(i->rates, 2)
 		| set11nRateFlags(i->rates, 3)
 		| SM(i->rtscts_rate, AR_RTSCTSRate);
 
-	ACCESS_ONCE(ads->ctl19) = AR_Not_Sounding;
+	ACCESS_ONCE_RW(ads->ctl19) = AR_Not_Sounding;
 
-	ACCESS_ONCE(ads->ctl20) = SM(i->txpower[1], AR_XmitPower1);
-	ACCESS_ONCE(ads->ctl21) = SM(i->txpower[2], AR_XmitPower2);
-	ACCESS_ONCE(ads->ctl22) = SM(i->txpower[3], AR_XmitPower3);
+	ACCESS_ONCE_RW(ads->ctl20) = SM(i->txpower[1], AR_XmitPower1);
+	ACCESS_ONCE_RW(ads->ctl21) = SM(i->txpower[2], AR_XmitPower2);
+	ACCESS_ONCE_RW(ads->ctl22) = SM(i->txpower[3], AR_XmitPower3);
 }
 
 static u16 ar9003_calc_ptr_chksum(struct ar9003_txc *ads)
diff --git a/drivers/net/wireless/ath/ath9k/hw.h b/drivers/net/wireless/ath/ath9k/hw.h
index 9cbca1229..eae7c7961 100644
--- a/drivers/net/wireless/ath/ath9k/hw.h
+++ b/drivers/net/wireless/ath/ath9k/hw.h
@@ -672,7 +672,7 @@ struct ath_hw_private_ops {
 #ifdef CONFIG_ATH9K_BTCOEX_SUPPORT
 	bool (*is_aic_enabled)(struct ath_hw *ah);
 #endif /* CONFIG_ATH9K_BTCOEX_SUPPORT */
-};
+} __no_const;
 
 /**
  * struct ath_spec_scan - parameters for Atheros spectral scan
@@ -748,7 +748,7 @@ struct ath_hw_ops {
 #ifdef CONFIG_ATH9K_BTCOEX_SUPPORT
 	void (*set_bt_ant_diversity)(struct ath_hw *hw, bool enable);
 #endif
-};
+} __no_const;
 
 struct ath_nf_limits {
 	s16 max;
diff --git a/drivers/net/wireless/ath/ath9k/main.c b/drivers/net/wireless/ath/ath9k/main.c
index 7cb65c303..d213e2a02 100644
--- a/drivers/net/wireless/ath/ath9k/main.c
+++ b/drivers/net/wireless/ath/ath9k/main.c
@@ -2622,16 +2622,18 @@ void ath9k_fill_chanctx_ops(void)
 	if (!ath9k_is_chanctx_enabled())
 		return;
 
-	ath9k_ops.hw_scan                  = ath9k_hw_scan;
-	ath9k_ops.cancel_hw_scan           = ath9k_cancel_hw_scan;
-	ath9k_ops.remain_on_channel        = ath9k_remain_on_channel;
-	ath9k_ops.cancel_remain_on_channel = ath9k_cancel_remain_on_channel;
-	ath9k_ops.add_chanctx              = ath9k_add_chanctx;
-	ath9k_ops.remove_chanctx           = ath9k_remove_chanctx;
-	ath9k_ops.change_chanctx           = ath9k_change_chanctx;
-	ath9k_ops.assign_vif_chanctx       = ath9k_assign_vif_chanctx;
-	ath9k_ops.unassign_vif_chanctx     = ath9k_unassign_vif_chanctx;
-	ath9k_ops.mgd_prepare_tx           = ath9k_mgd_prepare_tx;
+	pax_open_kernel();
+	const_cast(ath9k_ops.hw_scan)                  = ath9k_hw_scan;
+	const_cast(ath9k_ops.cancel_hw_scan)           = ath9k_cancel_hw_scan;
+	const_cast(ath9k_ops.remain_on_channel)        = ath9k_remain_on_channel;
+	const_cast(ath9k_ops.cancel_remain_on_channel) = ath9k_cancel_remain_on_channel;
+	const_cast(ath9k_ops.add_chanctx)              = ath9k_add_chanctx;
+	const_cast(ath9k_ops.remove_chanctx)           = ath9k_remove_chanctx;
+	const_cast(ath9k_ops.change_chanctx)           = ath9k_change_chanctx;
+	const_cast(ath9k_ops.assign_vif_chanctx)       = ath9k_assign_vif_chanctx;
+	const_cast(ath9k_ops.unassign_vif_chanctx)     = ath9k_unassign_vif_chanctx;
+	const_cast(ath9k_ops.mgd_prepare_tx)           = ath9k_mgd_prepare_tx;
+	pax_close_kernel();
 }
 
 #endif
diff --git a/drivers/net/wireless/ath/carl9170/carl9170.h b/drivers/net/wireless/ath/carl9170/carl9170.h
index 237d0cda1..6c094fd17 100644
--- a/drivers/net/wireless/ath/carl9170/carl9170.h
+++ b/drivers/net/wireless/ath/carl9170/carl9170.h
@@ -297,7 +297,7 @@ struct ar9170 {
 	unsigned long max_queue_stop_timeout[__AR9170_NUM_TXQ];
 	bool needs_full_reset;
 	bool force_usb_reset;
-	atomic_t pending_restarts;
+	atomic_unchecked_t pending_restarts;
 
 	/* interface mode settings */
 	struct list_head vif_list;
@@ -400,7 +400,7 @@ struct ar9170 {
 	struct carl9170_sta_tid __rcu *tx_ampdu_iter;
 	struct list_head tx_ampdu_list;
 	atomic_t tx_ampdu_upload;
-	atomic_t tx_ampdu_scheduler;
+	atomic_unchecked_t tx_ampdu_scheduler;
 	atomic_t tx_total_pending;
 	atomic_t tx_total_queued;
 	unsigned int tx_ampdu_list_len;
@@ -412,7 +412,7 @@ struct ar9170 {
 	spinlock_t mem_lock;
 	unsigned long *mem_bitmap;
 	atomic_t mem_free_blocks;
-	atomic_t mem_allocs;
+	atomic_unchecked_t mem_allocs;
 
 	/* rxstream mpdu merge */
 	struct ar9170_rx_head rx_plcp;
diff --git a/drivers/net/wireless/ath/carl9170/debug.c b/drivers/net/wireless/ath/carl9170/debug.c
index ec3a64e5d..4d4a4e2b2 100644
--- a/drivers/net/wireless/ath/carl9170/debug.c
+++ b/drivers/net/wireless/ath/carl9170/debug.c
@@ -223,7 +223,7 @@ static char *carl9170_debugfs_mem_usage_read(struct ar9170 *ar, char *buf,
 
 	ADD(buf, *len, bufsize, "cookies: used:%3d / total:%3d, allocs:%d\n",
 	    bitmap_weight(ar->mem_bitmap, ar->fw.mem_blocks),
-	    ar->fw.mem_blocks, atomic_read(&ar->mem_allocs));
+	    ar->fw.mem_blocks, atomic_read_unchecked(&ar->mem_allocs));
 
 	ADD(buf, *len, bufsize, "memory: free:%3d (%3d KiB) / total:%3d KiB)\n",
 	    atomic_read(&ar->mem_free_blocks),
@@ -674,7 +674,7 @@ static char *carl9170_debugfs_bug_read(struct ar9170 *ar, char *buf,
 	ADD(buf, *ret, bufsize, "reported firmware BUGs:%d\n",
 		ar->fw.bug_counter);
 	ADD(buf, *ret, bufsize, "pending restart requests:%d\n",
-		atomic_read(&ar->pending_restarts));
+		atomic_read_unchecked(&ar->pending_restarts));
 	return buf;
 }
 __DEBUGFS_DECLARE_RW_FILE(bug, 400, CARL9170_STOPPED);
@@ -781,7 +781,7 @@ DEBUGFS_READONLY_FILE(usb_rx_pool_urbs, 20, "%d",
 DEBUGFS_READONLY_FILE(tx_total_queued, 20, "%d",
 		      atomic_read(&ar->tx_total_queued));
 DEBUGFS_READONLY_FILE(tx_ampdu_scheduler, 20, "%d",
-		      atomic_read(&ar->tx_ampdu_scheduler));
+		      atomic_read_unchecked(&ar->tx_ampdu_scheduler));
 
 DEBUGFS_READONLY_FILE(tx_total_pending, 20, "%d",
 		      atomic_read(&ar->tx_total_pending));
diff --git a/drivers/net/wireless/ath/carl9170/main.c b/drivers/net/wireless/ath/carl9170/main.c
index ffb22a04b..231c7bcaf 100644
--- a/drivers/net/wireless/ath/carl9170/main.c
+++ b/drivers/net/wireless/ath/carl9170/main.c
@@ -320,7 +320,7 @@ static void carl9170_zap_queues(struct ar9170 *ar)
 	rcu_read_unlock();
 
 	atomic_set(&ar->tx_ampdu_upload, 0);
-	atomic_set(&ar->tx_ampdu_scheduler, 0);
+	atomic_set_unchecked(&ar->tx_ampdu_scheduler, 0);
 	atomic_set(&ar->tx_total_pending, 0);
 	atomic_set(&ar->tx_total_queued, 0);
 	atomic_set(&ar->mem_free_blocks, ar->fw.mem_blocks);
@@ -370,7 +370,7 @@ static int carl9170_op_start(struct ieee80211_hw *hw)
 		ar->max_queue_stop_timeout[i] = 0;
 	}
 
-	atomic_set(&ar->mem_allocs, 0);
+	atomic_set_unchecked(&ar->mem_allocs, 0);
 
 	err = carl9170_usb_open(ar);
 	if (err)
@@ -490,7 +490,7 @@ static void carl9170_restart_work(struct work_struct *work)
 
 	if (!err && !ar->force_usb_reset) {
 		ar->restart_counter++;
-		atomic_set(&ar->pending_restarts, 0);
+		atomic_set_unchecked(&ar->pending_restarts, 0);
 
 		ieee80211_restart_hw(ar->hw);
 	} else {
@@ -513,7 +513,7 @@ void carl9170_restart(struct ar9170 *ar, const enum carl9170_restart_reasons r)
 	 * By ignoring these *surplus* reset events, the device won't be
 	 * killed again, right after it has recovered.
 	 */
-	if (atomic_inc_return(&ar->pending_restarts) > 1) {
+	if (atomic_inc_return_unchecked(&ar->pending_restarts) > 1) {
 		dev_dbg(&ar->udev->dev, "ignoring restart (%d)\n", r);
 		return;
 	}
@@ -1820,7 +1820,7 @@ void *carl9170_alloc(size_t priv_size)
 	spin_lock_init(&ar->tx_ampdu_list_lock);
 	spin_lock_init(&ar->mem_lock);
 	spin_lock_init(&ar->state_lock);
-	atomic_set(&ar->pending_restarts, 0);
+	atomic_set_unchecked(&ar->pending_restarts, 0);
 	ar->vifs = 0;
 	for (i = 0; i < ar->hw->queues; i++) {
 		skb_queue_head_init(&ar->tx_status[i]);
diff --git a/drivers/net/wireless/ath/carl9170/tx.c b/drivers/net/wireless/ath/carl9170/tx.c
index 2bf04c9ed..ae059574f 100644
--- a/drivers/net/wireless/ath/carl9170/tx.c
+++ b/drivers/net/wireless/ath/carl9170/tx.c
@@ -193,7 +193,7 @@ static int carl9170_alloc_dev_space(struct ar9170 *ar, struct sk_buff *skb)
 	unsigned int chunks;
 	int cookie = -1;
 
-	atomic_inc(&ar->mem_allocs);
+	atomic_inc_unchecked(&ar->mem_allocs);
 
 	chunks = DIV_ROUND_UP(skb->len, ar->fw.mem_block_size);
 	if (unlikely(atomic_sub_return(chunks, &ar->mem_free_blocks) < 0)) {
@@ -1130,7 +1130,7 @@ static void carl9170_tx_ampdu(struct ar9170 *ar)
 	unsigned int i = 0, done_ampdus = 0;
 	u16 seq, queue, tmpssn;
 
-	atomic_inc(&ar->tx_ampdu_scheduler);
+	atomic_inc_unchecked(&ar->tx_ampdu_scheduler);
 	ar->tx_ampdu_schedule = false;
 
 	if (atomic_read(&ar->tx_ampdu_upload))
diff --git a/drivers/net/wireless/ath/wil6210/pcie_bus.c b/drivers/net/wireless/ath/wil6210/pcie_bus.c
index 7b5c4222b..caa69fa6a 100644
--- a/drivers/net/wireless/ath/wil6210/pcie_bus.c
+++ b/drivers/net/wireless/ath/wil6210/pcie_bus.c
@@ -159,7 +159,7 @@ static int wil_pcie_probe(struct pci_dev *pdev, const struct pci_device_id *id)
 	struct wil6210_priv *wil;
 	struct device *dev = &pdev->dev;
 	int rc;
-	const struct wil_platform_rops rops = {
+	static const struct wil_platform_rops rops = {
 		.ramdump = wil_platform_rop_ramdump,
 		.fw_recovery = wil_platform_rop_fw_recovery,
 	};
diff --git a/drivers/net/wireless/ath/wil6210/wil_platform.h b/drivers/net/wireless/ath/wil6210/wil_platform.h
index f8c41172a..72c917e0d 100644
--- a/drivers/net/wireless/ath/wil6210/wil_platform.h
+++ b/drivers/net/wireless/ath/wil6210/wil_platform.h
@@ -37,7 +37,7 @@ struct wil_platform_ops {
 	int (*resume)(void *handle);
 	void (*uninit)(void *handle);
 	int (*notify)(void *handle, enum wil_platform_event evt);
-};
+} __no_const;
 
 /**
  * struct wil_platform_rops - wil platform module callbacks from
diff --git a/drivers/net/wireless/atmel/at76c50x-usb.c b/drivers/net/wireless/atmel/at76c50x-usb.c
index 2e3ece345..b135b076d 100644
--- a/drivers/net/wireless/atmel/at76c50x-usb.c
+++ b/drivers/net/wireless/atmel/at76c50x-usb.c
@@ -346,7 +346,7 @@ static int at76_dfu_get_state(struct usb_device *udev, u8 *state)
 }
 
 /* Convert timeout from the DFU status to jiffies */
-static inline unsigned long at76_get_timeout(struct dfu_status *s)
+static inline unsigned long __intentional_overflow(-1) at76_get_timeout(struct dfu_status *s)
 {
 	return msecs_to_jiffies((s->poll_timeout[2] << 16)
 				| (s->poll_timeout[1] << 8)
diff --git a/drivers/net/wireless/atmel/atmel.c b/drivers/net/wireless/atmel/atmel.c
index b6107aea6..817004938 100644
--- a/drivers/net/wireless/atmel/atmel.c
+++ b/drivers/net/wireless/atmel/atmel.c
@@ -1648,9 +1648,10 @@ EXPORT_SYMBOL(stop_atmel_card);
 
 static int atmel_set_essid(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *dwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_point *dwrq = &wrqu->essid;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	/* Check if we asked for `any' */
@@ -1676,9 +1677,10 @@ static int atmel_set_essid(struct net_device *dev,
 
 static int atmel_get_essid(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *dwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_point *dwrq = &wrqu->essid;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	/* Get the current SSID */
@@ -1697,9 +1699,10 @@ static int atmel_get_essid(struct net_device *dev,
 
 static int atmel_get_wap(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct sockaddr *awrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct sockaddr *awrq = &wrqu->ap_addr;
 	struct atmel_private *priv = netdev_priv(dev);
 	memcpy(awrq->sa_data, priv->CurrentBSSID, ETH_ALEN);
 	awrq->sa_family = ARPHRD_ETHER;
@@ -1709,9 +1712,10 @@ static int atmel_get_wap(struct net_device *dev,
 
 static int atmel_set_encode(struct net_device *dev,
 			    struct iw_request_info *info,
-			    struct iw_point *dwrq,
+			    union iwreq_data *wrqu,
 			    char *extra)
 {
+	struct iw_point *dwrq = &wrqu->encoding;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	/* Basic checking: do we have a key to set ?
@@ -1798,9 +1802,10 @@ static int atmel_set_encode(struct net_device *dev,
 
 static int atmel_get_encode(struct net_device *dev,
 			    struct iw_request_info *info,
-			    struct iw_point *dwrq,
+			    union iwreq_data *wrqu,
 			    char *extra)
 {
+	struct iw_point *dwrq = &wrqu->encoding;
 	struct atmel_private *priv = netdev_priv(dev);
 	int index = (dwrq->flags & IW_ENCODE_INDEX) - 1;
 
@@ -2008,18 +2013,20 @@ static int atmel_get_auth(struct net_device *dev,
 
 static int atmel_get_name(struct net_device *dev,
 			  struct iw_request_info *info,
-			  char *cwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	char *cwrq = wrqu->name;
 	strcpy(cwrq, "IEEE 802.11-DS");
 	return 0;
 }
 
 static int atmel_set_rate(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->bitrate;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	if (vwrq->fixed == 0) {
@@ -2058,9 +2065,10 @@ static int atmel_set_rate(struct net_device *dev,
 
 static int atmel_set_mode(struct net_device *dev,
 			  struct iw_request_info *info,
-			  __u32 *uwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	__u32 *uwrq = &wrqu->mode;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	if (*uwrq != IW_MODE_ADHOC && *uwrq != IW_MODE_INFRA)
@@ -2072,9 +2080,10 @@ static int atmel_set_mode(struct net_device *dev,
 
 static int atmel_get_mode(struct net_device *dev,
 			  struct iw_request_info *info,
-			  __u32 *uwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	__u32 *uwrq = &wrqu->mode;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	*uwrq = priv->operating_mode;
@@ -2083,9 +2092,10 @@ static int atmel_get_mode(struct net_device *dev,
 
 static int atmel_get_rate(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->bitrate;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	if (priv->auto_tx_rate) {
@@ -2113,9 +2123,10 @@ static int atmel_get_rate(struct net_device *dev,
 
 static int atmel_set_power(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_param *vwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_param *vwrq = &wrqu->power;
 	struct atmel_private *priv = netdev_priv(dev);
 	priv->power_mode = vwrq->disabled ? 0 : 1;
 	return -EINPROGRESS;
@@ -2123,9 +2134,10 @@ static int atmel_set_power(struct net_device *dev,
 
 static int atmel_get_power(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_param *vwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_param *vwrq = &wrqu->power;
 	struct atmel_private *priv = netdev_priv(dev);
 	vwrq->disabled = priv->power_mode ? 0 : 1;
 	vwrq->flags = IW_POWER_ON;
@@ -2134,9 +2146,10 @@ static int atmel_get_power(struct net_device *dev,
 
 static int atmel_set_retry(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_param *vwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_param *vwrq = &wrqu->retry;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	if (!vwrq->disabled && (vwrq->flags & IW_RETRY_LIMIT)) {
@@ -2157,9 +2170,10 @@ static int atmel_set_retry(struct net_device *dev,
 
 static int atmel_get_retry(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_param *vwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_param *vwrq = &wrqu->retry;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	vwrq->disabled = 0;      /* Can't be disabled */
@@ -2180,9 +2194,10 @@ static int atmel_get_retry(struct net_device *dev,
 
 static int atmel_set_rts(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->rts;
 	struct atmel_private *priv = netdev_priv(dev);
 	int rthr = vwrq->value;
 
@@ -2198,9 +2213,10 @@ static int atmel_set_rts(struct net_device *dev,
 
 static int atmel_get_rts(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->rts;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	vwrq->value = priv->rts_threshold;
@@ -2212,9 +2228,10 @@ static int atmel_get_rts(struct net_device *dev,
 
 static int atmel_set_frag(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->frag;
 	struct atmel_private *priv = netdev_priv(dev);
 	int fthr = vwrq->value;
 
@@ -2231,9 +2248,10 @@ static int atmel_set_frag(struct net_device *dev,
 
 static int atmel_get_frag(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->frag;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	vwrq->value = priv->frag_threshold;
@@ -2245,9 +2263,10 @@ static int atmel_get_frag(struct net_device *dev,
 
 static int atmel_set_freq(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_freq *fwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_freq *fwrq = &wrqu->freq;
 	struct atmel_private *priv = netdev_priv(dev);
 	int rc = -EINPROGRESS;		/* Call commit handler */
 
@@ -2275,9 +2294,10 @@ static int atmel_set_freq(struct net_device *dev,
 
 static int atmel_get_freq(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_freq *fwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_freq *fwrq = &wrqu->freq;
 	struct atmel_private *priv = netdev_priv(dev);
 
 	fwrq->m = priv->channel;
@@ -2287,7 +2307,7 @@ static int atmel_get_freq(struct net_device *dev,
 
 static int atmel_set_scan(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *dwrq,
+			  union iwreq_data *dwrq,
 			  char *extra)
 {
 	struct atmel_private *priv = netdev_priv(dev);
@@ -2325,9 +2345,10 @@ static int atmel_set_scan(struct net_device *dev,
 
 static int atmel_get_scan(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *dwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct atmel_private *priv = netdev_priv(dev);
 	int i;
 	char *current_ev = extra;
@@ -2396,9 +2417,10 @@ static int atmel_get_scan(struct net_device *dev,
 
 static int atmel_get_range(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *dwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct atmel_private *priv = netdev_priv(dev);
 	struct iw_range *range = (struct iw_range *) extra;
 	int k, i, j;
@@ -2470,9 +2492,10 @@ static int atmel_get_range(struct net_device *dev,
 
 static int atmel_set_wap(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct sockaddr *awrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct sockaddr *awrq = &wrqu->ap_addr;
 	struct atmel_private *priv = netdev_priv(dev);
 	int i;
 	static const u8 any[] = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
@@ -2512,7 +2535,7 @@ static int atmel_set_wap(struct net_device *dev,
 
 static int atmel_config_commit(struct net_device *dev,
 			       struct iw_request_info *info,	/* NULL */
-			       void *zwrq,			/* NULL */
+			       union iwreq_data *zwrq,		/* NULL */
 			       char *extra)			/* NULL */
 {
 	return atmel_open(dev);
@@ -2520,61 +2543,61 @@ static int atmel_config_commit(struct net_device *dev,
 
 static const iw_handler atmel_handler[] =
 {
-	(iw_handler) atmel_config_commit,	/* SIOCSIWCOMMIT */
-	(iw_handler) atmel_get_name,		/* SIOCGIWNAME */
-	(iw_handler) NULL,			/* SIOCSIWNWID */
-	(iw_handler) NULL,			/* SIOCGIWNWID */
-	(iw_handler) atmel_set_freq,		/* SIOCSIWFREQ */
-	(iw_handler) atmel_get_freq,		/* SIOCGIWFREQ */
-	(iw_handler) atmel_set_mode,		/* SIOCSIWMODE */
-	(iw_handler) atmel_get_mode,		/* SIOCGIWMODE */
-	(iw_handler) NULL,			/* SIOCSIWSENS */
-	(iw_handler) NULL,			/* SIOCGIWSENS */
-	(iw_handler) NULL,			/* SIOCSIWRANGE */
-	(iw_handler) atmel_get_range,           /* SIOCGIWRANGE */
-	(iw_handler) NULL,			/* SIOCSIWPRIV */
-	(iw_handler) NULL,			/* SIOCGIWPRIV */
-	(iw_handler) NULL,			/* SIOCSIWSTATS */
-	(iw_handler) NULL,			/* SIOCGIWSTATS */
-	(iw_handler) NULL,			/* SIOCSIWSPY */
-	(iw_handler) NULL,			/* SIOCGIWSPY */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) atmel_set_wap,		/* SIOCSIWAP */
-	(iw_handler) atmel_get_wap,		/* SIOCGIWAP */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* SIOCGIWAPLIST */
-	(iw_handler) atmel_set_scan,		/* SIOCSIWSCAN */
-	(iw_handler) atmel_get_scan,		/* SIOCGIWSCAN */
-	(iw_handler) atmel_set_essid,		/* SIOCSIWESSID */
-	(iw_handler) atmel_get_essid,		/* SIOCGIWESSID */
-	(iw_handler) NULL,			/* SIOCSIWNICKN */
-	(iw_handler) NULL,			/* SIOCGIWNICKN */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) atmel_set_rate,		/* SIOCSIWRATE */
-	(iw_handler) atmel_get_rate,		/* SIOCGIWRATE */
-	(iw_handler) atmel_set_rts,		/* SIOCSIWRTS */
-	(iw_handler) atmel_get_rts,		/* SIOCGIWRTS */
-	(iw_handler) atmel_set_frag,		/* SIOCSIWFRAG */
-	(iw_handler) atmel_get_frag,		/* SIOCGIWFRAG */
-	(iw_handler) NULL,			/* SIOCSIWTXPOW */
-	(iw_handler) NULL,			/* SIOCGIWTXPOW */
-	(iw_handler) atmel_set_retry,		/* SIOCSIWRETRY */
-	(iw_handler) atmel_get_retry,		/* SIOCGIWRETRY */
-	(iw_handler) atmel_set_encode,		/* SIOCSIWENCODE */
-	(iw_handler) atmel_get_encode,		/* SIOCGIWENCODE */
-	(iw_handler) atmel_set_power,		/* SIOCSIWPOWER */
-	(iw_handler) atmel_get_power,		/* SIOCGIWPOWER */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* SIOCSIWGENIE */
-	(iw_handler) NULL,			/* SIOCGIWGENIE */
-	(iw_handler) atmel_set_auth,		/* SIOCSIWAUTH */
-	(iw_handler) atmel_get_auth,		/* SIOCGIWAUTH */
-	(iw_handler) atmel_set_encodeext,	/* SIOCSIWENCODEEXT */
-	(iw_handler) atmel_get_encodeext,	/* SIOCGIWENCODEEXT */
-	(iw_handler) NULL,			/* SIOCSIWPMKSA */
+	atmel_config_commit,	/* SIOCSIWCOMMIT */
+	atmel_get_name,		/* SIOCGIWNAME */
+	NULL,			/* SIOCSIWNWID */
+	NULL,			/* SIOCGIWNWID */
+	atmel_set_freq,		/* SIOCSIWFREQ */
+	atmel_get_freq,		/* SIOCGIWFREQ */
+	atmel_set_mode,		/* SIOCSIWMODE */
+	atmel_get_mode,		/* SIOCGIWMODE */
+	NULL,			/* SIOCSIWSENS */
+	NULL,			/* SIOCGIWSENS */
+	NULL,			/* SIOCSIWRANGE */
+	atmel_get_range,           /* SIOCGIWRANGE */
+	NULL,			/* SIOCSIWPRIV */
+	NULL,			/* SIOCGIWPRIV */
+	NULL,			/* SIOCSIWSTATS */
+	NULL,			/* SIOCGIWSTATS */
+	NULL,			/* SIOCSIWSPY */
+	NULL,			/* SIOCGIWSPY */
+	NULL,			/* -- hole -- */
+	NULL,			/* -- hole -- */
+	atmel_set_wap,		/* SIOCSIWAP */
+	atmel_get_wap,		/* SIOCGIWAP */
+	NULL,			/* -- hole -- */
+	NULL,			/* SIOCGIWAPLIST */
+	atmel_set_scan,		/* SIOCSIWSCAN */
+	atmel_get_scan,		/* SIOCGIWSCAN */
+	atmel_set_essid,		/* SIOCSIWESSID */
+	atmel_get_essid,		/* SIOCGIWESSID */
+	NULL,			/* SIOCSIWNICKN */
+	NULL,			/* SIOCGIWNICKN */
+	NULL,			/* -- hole -- */
+	NULL,			/* -- hole -- */
+	atmel_set_rate,		/* SIOCSIWRATE */
+	atmel_get_rate,		/* SIOCGIWRATE */
+	atmel_set_rts,		/* SIOCSIWRTS */
+	atmel_get_rts,		/* SIOCGIWRTS */
+	atmel_set_frag,		/* SIOCSIWFRAG */
+	atmel_get_frag,		/* SIOCGIWFRAG */
+	NULL,			/* SIOCSIWTXPOW */
+	NULL,			/* SIOCGIWTXPOW */
+	atmel_set_retry,		/* SIOCSIWRETRY */
+	atmel_get_retry,		/* SIOCGIWRETRY */
+	atmel_set_encode,		/* SIOCSIWENCODE */
+	atmel_get_encode,		/* SIOCGIWENCODE */
+	atmel_set_power,		/* SIOCSIWPOWER */
+	atmel_get_power,		/* SIOCGIWPOWER */
+	NULL,			/* -- hole -- */
+	NULL,			/* -- hole -- */
+	NULL,			/* SIOCSIWGENIE */
+	NULL,			/* SIOCGIWGENIE */
+	atmel_set_auth,		/* SIOCSIWAUTH */
+	atmel_get_auth,		/* SIOCGIWAUTH */
+	atmel_set_encodeext,	/* SIOCSIWENCODEEXT */
+	atmel_get_encodeext,	/* SIOCGIWENCODEEXT */
+	NULL,			/* SIOCSIWPMKSA */
 };
 
 static const iw_handler atmel_private_handler[] =
diff --git a/drivers/net/wireless/broadcom/b43/phy_lp.c b/drivers/net/wireless/broadcom/b43/phy_lp.c
index 6922cbb99..c45026c0d 100644
--- a/drivers/net/wireless/broadcom/b43/phy_lp.c
+++ b/drivers/net/wireless/broadcom/b43/phy_lp.c
@@ -2502,7 +2502,7 @@ static int lpphy_b2063_tune(struct b43_wldev *dev,
 {
 	struct ssb_bus *bus = dev->dev->sdev->bus;
 
-	static const struct b206x_channel *chandata = NULL;
+	const struct b206x_channel *chandata = NULL;
 	u32 crystal_freq = bus->chipco.pmu.crystalfreq * 1000;
 	u32 freqref, vco_freq, val1, val2, val3, timeout, timeoutref, count;
 	u16 old_comm15, scale;
diff --git a/drivers/net/wireless/broadcom/b43legacy/main.c b/drivers/net/wireless/broadcom/b43legacy/main.c
index 17aa4fd21..53fbf4ee9 100644
--- a/drivers/net/wireless/broadcom/b43legacy/main.c
+++ b/drivers/net/wireless/broadcom/b43legacy/main.c
@@ -1303,8 +1303,9 @@ static void handle_irq_ucode_debug(struct b43legacy_wldev *dev)
 }
 
 /* Interrupt handler bottom-half */
-static void b43legacy_interrupt_tasklet(struct b43legacy_wldev *dev)
+static void b43legacy_interrupt_tasklet(unsigned long _dev)
 {
+	struct b43legacy_wldev *dev = (struct b43legacy_wldev *)_dev;
 	u32 reason;
 	u32 dma_reason[ARRAY_SIZE(dev->dma_reason)];
 	u32 merged_dma_reason = 0;
@@ -3772,7 +3773,7 @@ static int b43legacy_one_core_attach(struct ssb_device *dev,
 	b43legacy_set_status(wldev, B43legacy_STAT_UNINIT);
 	wldev->bad_frames_preempt = modparam_bad_frames_preempt;
 	tasklet_init(&wldev->isr_tasklet,
-		     (void (*)(unsigned long))b43legacy_interrupt_tasklet,
+		     b43legacy_interrupt_tasklet,
 		     (unsigned long)wldev);
 	if (modparam_pio)
 		wldev->__using_pio = true;
diff --git a/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c b/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c
index abaf003a5..7c0fe5d5b 100644
--- a/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c
+++ b/drivers/net/wireless/broadcom/brcm80211/brcmfmac/cfg80211.c
@@ -5230,6 +5230,50 @@ static struct cfg80211_ops brcmf_cfg80211_ops = {
 	.tdls_oper = brcmf_cfg80211_tdls_oper,
 };
 
+static struct cfg80211_ops brcmf_cfg80211_ops2 = {
+	.add_virtual_intf = brcmf_cfg80211_add_iface,
+	.del_virtual_intf = brcmf_cfg80211_del_iface,
+	.change_virtual_intf = brcmf_cfg80211_change_iface,
+	.scan = brcmf_cfg80211_scan,
+	.set_wiphy_params = brcmf_cfg80211_set_wiphy_params,
+	.join_ibss = brcmf_cfg80211_join_ibss,
+	.leave_ibss = brcmf_cfg80211_leave_ibss,
+	.get_station = brcmf_cfg80211_get_station,
+	.dump_station = brcmf_cfg80211_dump_station,
+	.set_tx_power = brcmf_cfg80211_set_tx_power,
+	.get_tx_power = brcmf_cfg80211_get_tx_power,
+	.add_key = brcmf_cfg80211_add_key,
+	.del_key = brcmf_cfg80211_del_key,
+	.get_key = brcmf_cfg80211_get_key,
+	.set_default_key = brcmf_cfg80211_config_default_key,
+	.set_default_mgmt_key = brcmf_cfg80211_config_default_mgmt_key,
+	.set_power_mgmt = brcmf_cfg80211_set_power_mgmt,
+	.connect = brcmf_cfg80211_connect,
+	.disconnect = brcmf_cfg80211_disconnect,
+	.suspend = brcmf_cfg80211_suspend,
+	.resume = brcmf_cfg80211_resume,
+	.set_pmksa = brcmf_cfg80211_set_pmksa,
+	.del_pmksa = brcmf_cfg80211_del_pmksa,
+	.flush_pmksa = brcmf_cfg80211_flush_pmksa,
+	.start_ap = brcmf_cfg80211_start_ap,
+	.stop_ap = brcmf_cfg80211_stop_ap,
+	.change_beacon = brcmf_cfg80211_change_beacon,
+	.del_station = brcmf_cfg80211_del_station,
+	.change_station = brcmf_cfg80211_change_station,
+	.sched_scan_start = brcmf_cfg80211_sched_scan_start,
+	.sched_scan_stop = brcmf_cfg80211_sched_scan_stop,
+	.mgmt_frame_register = brcmf_cfg80211_mgmt_frame_register,
+	.mgmt_tx = brcmf_cfg80211_mgmt_tx,
+	.remain_on_channel = brcmf_p2p_remain_on_channel,
+	.cancel_remain_on_channel = brcmf_cfg80211_cancel_remain_on_channel,
+	.start_p2p_device = brcmf_p2p_start_device,
+	.stop_p2p_device = brcmf_p2p_stop_device,
+	.crit_proto_start = brcmf_cfg80211_crit_proto_start,
+	.crit_proto_stop = brcmf_cfg80211_crit_proto_stop,
+	.tdls_oper = brcmf_cfg80211_tdls_oper,
+	.set_rekey_data = brcmf_cfg80211_set_rekey_data,
+};
+
 struct brcmf_cfg80211_vif *brcmf_alloc_vif(struct brcmf_cfg80211_info *cfg,
 					   enum nl80211_iftype type)
 {
@@ -6846,7 +6890,7 @@ struct brcmf_cfg80211_info *brcmf_cfg80211_attach(struct brcmf_pub *drvr,
 	struct net_device *ndev = brcmf_get_ifp(drvr, 0)->ndev;
 	struct brcmf_cfg80211_info *cfg;
 	struct wiphy *wiphy;
-	struct cfg80211_ops *ops;
+	struct cfg80211_ops *ops = &brcmf_cfg80211_ops;
 	struct brcmf_cfg80211_vif *vif;
 	struct brcmf_if *ifp;
 	s32 err = 0;
@@ -6858,14 +6902,10 @@ struct brcmf_cfg80211_info *brcmf_cfg80211_attach(struct brcmf_pub *drvr,
 		return NULL;
 	}
 
-	ops = kmemdup(&brcmf_cfg80211_ops, sizeof(*ops), GFP_KERNEL);
-	if (!ops)
-		return NULL;
-
 	ifp = netdev_priv(ndev);
 #ifdef CONFIG_PM
 	if (brcmf_feat_is_enabled(ifp, BRCMF_FEAT_WOWL_GTK))
-		ops->set_rekey_data = brcmf_cfg80211_set_rekey_data;
+		ops = &brcmf_cfg80211_ops2;
 #endif
 	wiphy = wiphy_new(ops, sizeof(struct brcmf_cfg80211_info));
 	if (!wiphy) {
@@ -7004,7 +7044,6 @@ priv_out:
 	ifp->vif = NULL;
 wiphy_out:
 	brcmf_free_wiphy(wiphy);
-	kfree(ops);
 	return NULL;
 }
 
@@ -7015,7 +7054,6 @@ void brcmf_cfg80211_detach(struct brcmf_cfg80211_info *cfg)
 
 	brcmf_btcoex_detach(cfg);
 	wiphy_unregister(cfg->wiphy);
-	kfree(cfg->ops);
 	wl_deinit_priv(cfg);
 	brcmf_free_wiphy(cfg->wiphy);
 }
diff --git a/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy/phy_cmn.c b/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy/phy_cmn.c
index 1c4e9dd57..a6388e7af 100644
--- a/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy/phy_cmn.c
+++ b/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy/phy_cmn.c
@@ -394,8 +394,9 @@ struct shared_phy *wlc_phy_shared_attach(struct shared_phy_params *shp)
 	return sh;
 }
 
-static void wlc_phy_timercb_phycal(struct brcms_phy *pi)
+static void wlc_phy_timercb_phycal(void *_pi)
 {
+	struct brcms_phy *pi = _pi;
 	uint delay = 5;
 
 	if (PHY_PERICAL_MPHASE_PENDING(pi)) {
diff --git a/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.c b/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.c
index a0de5db0c..b72381791 100644
--- a/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.c
+++ b/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.c
@@ -57,12 +57,11 @@ void wlc_phy_shim_detach(struct phy_shim_info *physhim)
 }
 
 struct wlapi_timer *wlapi_init_timer(struct phy_shim_info *physhim,
-				     void (*fn)(struct brcms_phy *pi),
+				     void (*fn)(void *pi),
 				     void *arg, const char *name)
 {
 	return (struct wlapi_timer *)
-			brcms_init_timer(physhim->wl, (void (*)(void *))fn,
-					 arg, name);
+			brcms_init_timer(physhim->wl, fn, arg, name);
 }
 
 void wlapi_free_timer(struct wlapi_timer *t)
diff --git a/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.h b/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.h
index dd8774717..27d0934e6 100644
--- a/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.h
+++ b/drivers/net/wireless/broadcom/brcm80211/brcmsmac/phy_shim.h
@@ -131,7 +131,7 @@ void wlc_phy_shim_detach(struct phy_shim_info *physhim);
 
 /* PHY to WL utility functions */
 struct wlapi_timer *wlapi_init_timer(struct phy_shim_info *physhim,
-				     void (*fn)(struct brcms_phy *pi),
+				     void (*fn)(void *pi),
 				     void *arg, const char *name);
 void wlapi_free_timer(struct wlapi_timer *t);
 void wlapi_add_timer(struct wlapi_timer *t, uint ms, int periodic);
diff --git a/drivers/net/wireless/cisco/airo.c b/drivers/net/wireless/cisco/airo.c
index 69b826d22..669a1e0e0 100644
--- a/drivers/net/wireless/cisco/airo.c
+++ b/drivers/net/wireless/cisco/airo.c
@@ -4779,7 +4779,7 @@ static int get_dec_u16( char *buffer, int *start, int limit ) {
 }
 
 static int airo_config_commit(struct net_device *dev,
-			      struct iw_request_info *info, void *zwrq,
+			      struct iw_request_info *info, union iwreq_data *zwrq,
 			      char *extra);
 
 static inline int sniffing_mode(struct airo_info *ai)
@@ -5766,9 +5766,11 @@ static int airo_get_quality (StatusRid *status_rid, CapabilityRid *cap_rid)
  */
 static int airo_get_name(struct net_device *dev,
 			 struct iw_request_info *info,
-			 char *cwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	char *cwrq = wrqu->name;
+
 	strcpy(cwrq, "IEEE 802.11-DS");
 	return 0;
 }
@@ -5779,9 +5781,10 @@ static int airo_get_name(struct net_device *dev,
  */
 static int airo_set_freq(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_freq *fwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_freq *fwrq = &wrqu->freq;
 	struct airo_info *local = dev->ml_priv;
 	int rc = -EINPROGRESS;		/* Call commit handler */
 
@@ -5820,9 +5823,10 @@ static int airo_set_freq(struct net_device *dev,
  */
 static int airo_get_freq(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_freq *fwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_freq *fwrq = &wrqu->freq;
 	struct airo_info *local = dev->ml_priv;
 	StatusRid status_rid;		/* Card status info */
 	int ch;
@@ -5852,9 +5856,10 @@ static int airo_get_freq(struct net_device *dev,
  */
 static int airo_set_essid(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *dwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_point *dwrq = &wrqu->essid;
 	struct airo_info *local = dev->ml_priv;
 	SsidRid SSID_rid;		/* SSIDs */
 
@@ -5897,9 +5902,10 @@ static int airo_set_essid(struct net_device *dev,
  */
 static int airo_get_essid(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *dwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_point *dwrq = &wrqu->essid;
 	struct airo_info *local = dev->ml_priv;
 	StatusRid status_rid;		/* Card status info */
 
@@ -5925,9 +5931,10 @@ static int airo_get_essid(struct net_device *dev,
  */
 static int airo_set_wap(struct net_device *dev,
 			struct iw_request_info *info,
-			struct sockaddr *awrq,
+			union iwreq_data *wrqu,
 			char *extra)
 {
+	struct sockaddr *awrq = &wrqu->ap_addr;
 	struct airo_info *local = dev->ml_priv;
 	Cmd cmd;
 	Resp rsp;
@@ -5960,9 +5967,10 @@ static int airo_set_wap(struct net_device *dev,
  */
 static int airo_get_wap(struct net_device *dev,
 			struct iw_request_info *info,
-			struct sockaddr *awrq,
+			union iwreq_data *wrqu,
 			char *extra)
 {
+	struct sockaddr *awrq = &wrqu->ap_addr;
 	struct airo_info *local = dev->ml_priv;
 	StatusRid status_rid;		/* Card status info */
 
@@ -5981,9 +5989,10 @@ static int airo_get_wap(struct net_device *dev,
  */
 static int airo_set_nick(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_point *dwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct airo_info *local = dev->ml_priv;
 
 	/* Check the size of the string */
@@ -6004,9 +6013,10 @@ static int airo_set_nick(struct net_device *dev,
  */
 static int airo_get_nick(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_point *dwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -6023,9 +6033,10 @@ static int airo_get_nick(struct net_device *dev,
  */
 static int airo_set_rate(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->bitrate;
 	struct airo_info *local = dev->ml_priv;
 	CapabilityRid cap_rid;		/* Card capability info */
 	u8	brate = 0;
@@ -6093,9 +6104,10 @@ static int airo_set_rate(struct net_device *dev,
  */
 static int airo_get_rate(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->bitrate;
 	struct airo_info *local = dev->ml_priv;
 	StatusRid status_rid;		/* Card status info */
 
@@ -6115,9 +6127,10 @@ static int airo_get_rate(struct net_device *dev,
  */
 static int airo_set_rts(struct net_device *dev,
 			struct iw_request_info *info,
-			struct iw_param *vwrq,
+			union iwreq_data *wrqu,
 			char *extra)
 {
+	struct iw_param *vwrq = &wrqu->rts;
 	struct airo_info *local = dev->ml_priv;
 	int rthr = vwrq->value;
 
@@ -6139,9 +6152,10 @@ static int airo_set_rts(struct net_device *dev,
  */
 static int airo_get_rts(struct net_device *dev,
 			struct iw_request_info *info,
-			struct iw_param *vwrq,
+			union iwreq_data *wrqu,
 			char *extra)
 {
+	struct iw_param *vwrq = &wrqu->rts;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -6158,9 +6172,10 @@ static int airo_get_rts(struct net_device *dev,
  */
 static int airo_set_frag(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->frag;
 	struct airo_info *local = dev->ml_priv;
 	int fthr = vwrq->value;
 
@@ -6183,9 +6198,10 @@ static int airo_set_frag(struct net_device *dev,
  */
 static int airo_get_frag(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->frag;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -6202,9 +6218,10 @@ static int airo_get_frag(struct net_device *dev,
  */
 static int airo_set_mode(struct net_device *dev,
 			 struct iw_request_info *info,
-			 __u32 *uwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	__u32 *uwrq = &wrqu->mode;
 	struct airo_info *local = dev->ml_priv;
 	int reset = 0;
 
@@ -6265,9 +6282,10 @@ static int airo_set_mode(struct net_device *dev,
  */
 static int airo_get_mode(struct net_device *dev,
 			 struct iw_request_info *info,
-			 __u32 *uwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	__u32 *uwrq = &wrqu->mode;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -6300,9 +6318,10 @@ static inline int valid_index(struct airo_info *ai, int index)
  */
 static int airo_set_encode(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *dwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_point *dwrq = &wrqu->encoding;
 	struct airo_info *local = dev->ml_priv;
 	int perm = (dwrq->flags & IW_ENCODE_TEMP ? 0 : 1);
 	__le16 currentAuthType = local->config.authType;
@@ -6399,9 +6418,10 @@ static int airo_set_encode(struct net_device *dev,
  */
 static int airo_get_encode(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *dwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_point *dwrq = &wrqu->encoding;
 	struct airo_info *local = dev->ml_priv;
 	int index = (dwrq->flags & IW_ENCODE_INDEX) - 1;
 	int wep_key_len;
@@ -6746,9 +6766,10 @@ static int airo_get_auth(struct net_device *dev,
  */
 static int airo_set_txpow(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->txpower;
 	struct airo_info *local = dev->ml_priv;
 	CapabilityRid cap_rid;		/* Card capability info */
 	int i;
@@ -6783,9 +6804,10 @@ static int airo_set_txpow(struct net_device *dev,
  */
 static int airo_get_txpow(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->txpower;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -6803,9 +6825,10 @@ static int airo_get_txpow(struct net_device *dev,
  */
 static int airo_set_retry(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->retry;
 	struct airo_info *local = dev->ml_priv;
 	int rc = -EINVAL;
 
@@ -6841,9 +6864,10 @@ static int airo_set_retry(struct net_device *dev,
  */
 static int airo_get_retry(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->retry;
 	struct airo_info *local = dev->ml_priv;
 
 	vwrq->disabled = 0;      /* Can't be disabled */
@@ -6872,9 +6896,10 @@ static int airo_get_retry(struct net_device *dev,
  */
 static int airo_get_range(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *dwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct airo_info *local = dev->ml_priv;
 	struct iw_range *range = (struct iw_range *) extra;
 	CapabilityRid cap_rid;		/* Card capability info */
@@ -6998,9 +7023,10 @@ static int airo_get_range(struct net_device *dev,
  */
 static int airo_set_power(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->power;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -7055,9 +7081,10 @@ static int airo_set_power(struct net_device *dev,
  */
 static int airo_get_power(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *vwrq,
+			  union iwreq_data *wrqu,
 			  char *extra)
 {
+	struct iw_param *vwrq = &wrqu->power;
 	struct airo_info *local = dev->ml_priv;
 	__le16 mode;
 
@@ -7086,9 +7113,10 @@ static int airo_get_power(struct net_device *dev,
  */
 static int airo_set_sens(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->sens;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -7105,9 +7133,10 @@ static int airo_set_sens(struct net_device *dev,
  */
 static int airo_get_sens(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *vwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_param *vwrq = &wrqu->sens;
 	struct airo_info *local = dev->ml_priv;
 
 	readConfigRid(local, 1);
@@ -7125,9 +7154,10 @@ static int airo_get_sens(struct net_device *dev,
  */
 static int airo_get_aplist(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *dwrq,
+			   union iwreq_data *wrqu,
 			   char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct airo_info *local = dev->ml_priv;
 	struct sockaddr *address = (struct sockaddr *) extra;
 	struct iw_quality *qual;
@@ -7203,7 +7233,7 @@ static int airo_get_aplist(struct net_device *dev,
  */
 static int airo_set_scan(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_point *dwrq,
+			 union iwreq_data *dwrq,
 			 char *extra)
 {
 	struct airo_info *ai = dev->ml_priv;
@@ -7434,9 +7464,10 @@ static inline char *airo_translate_scan(struct net_device *dev,
  */
 static int airo_get_scan(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_point *dwrq,
+			 union iwreq_data *wrqu,
 			 char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct airo_info *ai = dev->ml_priv;
 	BSSListElement *net;
 	int err = 0;
@@ -7478,7 +7509,7 @@ out:
  */
 static int airo_config_commit(struct net_device *dev,
 			      struct iw_request_info *info,	/* NULL */
-			      void *zwrq,			/* NULL */
+			      union iwreq_data *zwrq,		/* NULL */
 			      char *extra)			/* NULL */
 {
 	struct airo_info *local = dev->ml_priv;
@@ -7528,61 +7559,61 @@ static const struct iw_priv_args airo_private_args[] = {
 
 static const iw_handler		airo_handler[] =
 {
-	(iw_handler) airo_config_commit,	/* SIOCSIWCOMMIT */
-	(iw_handler) airo_get_name,		/* SIOCGIWNAME */
-	(iw_handler) NULL,			/* SIOCSIWNWID */
-	(iw_handler) NULL,			/* SIOCGIWNWID */
-	(iw_handler) airo_set_freq,		/* SIOCSIWFREQ */
-	(iw_handler) airo_get_freq,		/* SIOCGIWFREQ */
-	(iw_handler) airo_set_mode,		/* SIOCSIWMODE */
-	(iw_handler) airo_get_mode,		/* SIOCGIWMODE */
-	(iw_handler) airo_set_sens,		/* SIOCSIWSENS */
-	(iw_handler) airo_get_sens,		/* SIOCGIWSENS */
-	(iw_handler) NULL,			/* SIOCSIWRANGE */
-	(iw_handler) airo_get_range,		/* SIOCGIWRANGE */
-	(iw_handler) NULL,			/* SIOCSIWPRIV */
-	(iw_handler) NULL,			/* SIOCGIWPRIV */
-	(iw_handler) NULL,			/* SIOCSIWSTATS */
-	(iw_handler) NULL,			/* SIOCGIWSTATS */
+	airo_config_commit,	/* SIOCSIWCOMMIT */
+	airo_get_name,		/* SIOCGIWNAME */
+	NULL,			/* SIOCSIWNWID */
+	NULL,			/* SIOCGIWNWID */
+	airo_set_freq,		/* SIOCSIWFREQ */
+	airo_get_freq,		/* SIOCGIWFREQ */
+	airo_set_mode,		/* SIOCSIWMODE */
+	airo_get_mode,		/* SIOCGIWMODE */
+	airo_set_sens,		/* SIOCSIWSENS */
+	airo_get_sens,		/* SIOCGIWSENS */
+	NULL,			/* SIOCSIWRANGE */
+	airo_get_range,		/* SIOCGIWRANGE */
+	NULL,			/* SIOCSIWPRIV */
+	NULL,			/* SIOCGIWPRIV */
+	NULL,			/* SIOCSIWSTATS */
+	NULL,			/* SIOCGIWSTATS */
 	iw_handler_set_spy,			/* SIOCSIWSPY */
 	iw_handler_get_spy,			/* SIOCGIWSPY */
 	iw_handler_set_thrspy,			/* SIOCSIWTHRSPY */
 	iw_handler_get_thrspy,			/* SIOCGIWTHRSPY */
-	(iw_handler) airo_set_wap,		/* SIOCSIWAP */
-	(iw_handler) airo_get_wap,		/* SIOCGIWAP */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) airo_get_aplist,		/* SIOCGIWAPLIST */
-	(iw_handler) airo_set_scan,		/* SIOCSIWSCAN */
-	(iw_handler) airo_get_scan,		/* SIOCGIWSCAN */
-	(iw_handler) airo_set_essid,		/* SIOCSIWESSID */
-	(iw_handler) airo_get_essid,		/* SIOCGIWESSID */
-	(iw_handler) airo_set_nick,		/* SIOCSIWNICKN */
-	(iw_handler) airo_get_nick,		/* SIOCGIWNICKN */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) airo_set_rate,		/* SIOCSIWRATE */
-	(iw_handler) airo_get_rate,		/* SIOCGIWRATE */
-	(iw_handler) airo_set_rts,		/* SIOCSIWRTS */
-	(iw_handler) airo_get_rts,		/* SIOCGIWRTS */
-	(iw_handler) airo_set_frag,		/* SIOCSIWFRAG */
-	(iw_handler) airo_get_frag,		/* SIOCGIWFRAG */
-	(iw_handler) airo_set_txpow,		/* SIOCSIWTXPOW */
-	(iw_handler) airo_get_txpow,		/* SIOCGIWTXPOW */
-	(iw_handler) airo_set_retry,		/* SIOCSIWRETRY */
-	(iw_handler) airo_get_retry,		/* SIOCGIWRETRY */
-	(iw_handler) airo_set_encode,		/* SIOCSIWENCODE */
-	(iw_handler) airo_get_encode,		/* SIOCGIWENCODE */
-	(iw_handler) airo_set_power,		/* SIOCSIWPOWER */
-	(iw_handler) airo_get_power,		/* SIOCGIWPOWER */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* SIOCSIWGENIE */
-	(iw_handler) NULL,			/* SIOCGIWGENIE */
-	(iw_handler) airo_set_auth,		/* SIOCSIWAUTH */
-	(iw_handler) airo_get_auth,		/* SIOCGIWAUTH */
-	(iw_handler) airo_set_encodeext,	/* SIOCSIWENCODEEXT */
-	(iw_handler) airo_get_encodeext,	/* SIOCGIWENCODEEXT */
-	(iw_handler) NULL,			/* SIOCSIWPMKSA */
+	airo_set_wap,		/* SIOCSIWAP */
+	airo_get_wap,		/* SIOCGIWAP */
+	NULL,			/* -- hole -- */
+	airo_get_aplist,		/* SIOCGIWAPLIST */
+	airo_set_scan,		/* SIOCSIWSCAN */
+	airo_get_scan,		/* SIOCGIWSCAN */
+	airo_set_essid,		/* SIOCSIWESSID */
+	airo_get_essid,		/* SIOCGIWESSID */
+	airo_set_nick,		/* SIOCSIWNICKN */
+	airo_get_nick,		/* SIOCGIWNICKN */
+	NULL,			/* -- hole -- */
+	NULL,			/* -- hole -- */
+	airo_set_rate,		/* SIOCSIWRATE */
+	airo_get_rate,		/* SIOCGIWRATE */
+	airo_set_rts,		/* SIOCSIWRTS */
+	airo_get_rts,		/* SIOCGIWRTS */
+	airo_set_frag,		/* SIOCSIWFRAG */
+	airo_get_frag,		/* SIOCGIWFRAG */
+	airo_set_txpow,		/* SIOCSIWTXPOW */
+	airo_get_txpow,		/* SIOCGIWTXPOW */
+	airo_set_retry,		/* SIOCSIWRETRY */
+	airo_get_retry,		/* SIOCGIWRETRY */
+	airo_set_encode,		/* SIOCSIWENCODE */
+	airo_get_encode,		/* SIOCGIWENCODE */
+	airo_set_power,		/* SIOCSIWPOWER */
+	airo_get_power,		/* SIOCGIWPOWER */
+	NULL,			/* -- hole -- */
+	NULL,			/* -- hole -- */
+	NULL,			/* SIOCSIWGENIE */
+	NULL,			/* SIOCGIWGENIE */
+	airo_set_auth,		/* SIOCSIWAUTH */
+	airo_get_auth,		/* SIOCGIWAUTH */
+	airo_set_encodeext,	/* SIOCSIWENCODEEXT */
+	airo_get_encodeext,	/* SIOCGIWENCODEEXT */
+	NULL,			/* SIOCSIWPMKSA */
 };
 
 /* Note : don't describe AIROIDIFC and AIROOLDIDIFC in here.
@@ -7845,7 +7876,7 @@ static int writerids(struct net_device *dev, aironet_ioctl *comp) {
 	struct airo_info *ai = dev->ml_priv;
 	int  ridcode;
         int  enabled;
-	static int (* writer)(struct airo_info *, u16 rid, const void *, int, int);
+	int (* writer)(struct airo_info *, u16 rid, const void *, int, int);
 	unsigned char *iobuf;
 
 	/* Only super-user can write RIDs */
diff --git a/drivers/net/wireless/intel/ipw2x00/ipw2100.c b/drivers/net/wireless/intel/ipw2x00/ipw2100.c
index 02a299a89..5afdac405 100644
--- a/drivers/net/wireless/intel/ipw2x00/ipw2100.c
+++ b/drivers/net/wireless/intel/ipw2x00/ipw2100.c
@@ -3220,8 +3220,9 @@ static void ipw2100_tx_send_data(struct ipw2100_priv *priv)
 	}
 }
 
-static void ipw2100_irq_tasklet(struct ipw2100_priv *priv)
+static void ipw2100_irq_tasklet(unsigned long _priv)
 {
+	struct ipw2100_priv *priv = (struct ipw2100_priv *)_priv;
 	struct net_device *dev = priv->net_dev;
 	unsigned long flags;
 	u32 inta, tmp;
@@ -6029,7 +6030,7 @@ static void ipw2100_rf_kill(struct work_struct *work)
 	spin_unlock_irqrestore(&priv->low_lock, flags);
 }
 
-static void ipw2100_irq_tasklet(struct ipw2100_priv *priv);
+static void ipw2100_irq_tasklet(unsigned long _priv);
 
 static const struct net_device_ops ipw2100_netdev_ops = {
 	.ndo_open		= ipw2100_open,
@@ -6158,8 +6159,7 @@ static struct net_device *ipw2100_alloc_device(struct pci_dev *pci_dev,
 	INIT_DELAYED_WORK(&priv->rf_kill, ipw2100_rf_kill);
 	INIT_DELAYED_WORK(&priv->scan_event, ipw2100_scan_event);
 
-	tasklet_init(&priv->irq_tasklet, (void (*)(unsigned long))
-		     ipw2100_irq_tasklet, (unsigned long)priv);
+	tasklet_init(&priv->irq_tasklet, ipw2100_irq_tasklet, (unsigned long)priv);
 
 	/* NOTE:  We do not start the deferred work for status checks yet */
 	priv->stop_rf_kill = 1;
diff --git a/drivers/net/wireless/intel/ipw2x00/ipw2200.c b/drivers/net/wireless/intel/ipw2x00/ipw2200.c
index 85d91de1e..f709be4f8 100644
--- a/drivers/net/wireless/intel/ipw2x00/ipw2200.c
+++ b/drivers/net/wireless/intel/ipw2x00/ipw2200.c
@@ -1968,8 +1968,9 @@ static void notify_wx_assoc_event(struct ipw_priv *priv)
 	wireless_send_event(priv->net_dev, SIOCGIWAP, &wrqu, NULL);
 }
 
-static void ipw_irq_tasklet(struct ipw_priv *priv)
+static void ipw_irq_tasklet(unsigned long _priv)
 {
+	struct ipw_priv *priv = (struct ipw_priv *)_priv;
 	u32 inta, inta_mask, handled = 0;
 	unsigned long flags;
 	int rc = 0;
@@ -10705,8 +10706,7 @@ static int ipw_setup_deferred_work(struct ipw_priv *priv)
 	INIT_WORK(&priv->qos_activate, ipw_bg_qos_activate);
 #endif				/* CONFIG_IPW2200_QOS */
 
-	tasklet_init(&priv->irq_tasklet, (void (*)(unsigned long))
-		     ipw_irq_tasklet, (unsigned long)priv);
+	tasklet_init(&priv->irq_tasklet, ipw_irq_tasklet, (unsigned long)priv);
 
 	return ret;
 }
diff --git a/drivers/net/wireless/intel/iwlegacy/3945-mac.c b/drivers/net/wireless/intel/iwlegacy/3945-mac.c
index 260d6a3a4..91b948537 100644
--- a/drivers/net/wireless/intel/iwlegacy/3945-mac.c
+++ b/drivers/net/wireless/intel/iwlegacy/3945-mac.c
@@ -1399,8 +1399,9 @@ il3945_dump_nic_error_log(struct il_priv *il)
 }
 
 static void
-il3945_irq_tasklet(struct il_priv *il)
+il3945_irq_tasklet(unsigned long _il)
 {
+	struct il_priv *il = (struct il_priv *)_il;
 	u32 inta, handled = 0;
 	u32 inta_fh;
 	unsigned long flags;
@@ -3432,7 +3433,7 @@ il3945_setup_deferred_work(struct il_priv *il)
 	setup_timer(&il->watchdog, il_bg_watchdog, (unsigned long)il);
 
 	tasklet_init(&il->irq_tasklet,
-		     (void (*)(unsigned long))il3945_irq_tasklet,
+		     il3945_irq_tasklet,
 		     (unsigned long)il);
 }
 
@@ -3469,7 +3470,7 @@ static struct attribute_group il3945_attribute_group = {
 	.attrs = il3945_sysfs_entries,
 };
 
-static struct ieee80211_ops il3945_mac_ops __read_mostly = {
+static struct ieee80211_ops il3945_mac_ops = {
 	.tx = il3945_mac_tx,
 	.start = il3945_mac_start,
 	.stop = il3945_mac_stop,
@@ -3633,7 +3634,9 @@ il3945_pci_probe(struct pci_dev *pdev, const struct pci_device_id *ent)
 	 */
 	if (il3945_mod_params.disable_hw_scan) {
 		D_INFO("Disabling hw_scan\n");
-		il3945_mac_ops.hw_scan = NULL;
+		pax_open_kernel();
+		const_cast(il3945_mac_ops.hw_scan) = NULL;
+		pax_close_kernel();
 	}
 
 	D_INFO("*** LOAD DRIVER ***\n");
diff --git a/drivers/net/wireless/intel/iwlegacy/4965-mac.c b/drivers/net/wireless/intel/iwlegacy/4965-mac.c
index a27559854..ca3e41c20 100644
--- a/drivers/net/wireless/intel/iwlegacy/4965-mac.c
+++ b/drivers/net/wireless/intel/iwlegacy/4965-mac.c
@@ -4361,8 +4361,9 @@ il4965_synchronize_irq(struct il_priv *il)
 }
 
 static void
-il4965_irq_tasklet(struct il_priv *il)
+il4965_irq_tasklet(unsigned long _il)
 {
+	struct il_priv *il = (struct il_priv *)_il;
 	u32 inta, handled = 0;
 	u32 inta_fh;
 	unsigned long flags;
@@ -6259,9 +6260,7 @@ il4965_setup_deferred_work(struct il_priv *il)
 
 	setup_timer(&il->watchdog, il_bg_watchdog, (unsigned long)il);
 
-	tasklet_init(&il->irq_tasklet,
-		     (void (*)(unsigned long))il4965_irq_tasklet,
-		     (unsigned long)il);
+	tasklet_init(&il->irq_tasklet, il4965_irq_tasklet, (unsigned long)il);
 }
 
 static void
diff --git a/drivers/net/wireless/intel/iwlwifi/dvm/debugfs.c b/drivers/net/wireless/intel/iwlwifi/dvm/debugfs.c
index f6591c83d..363b5b3bc 100644
--- a/drivers/net/wireless/intel/iwlwifi/dvm/debugfs.c
+++ b/drivers/net/wireless/intel/iwlwifi/dvm/debugfs.c
@@ -190,7 +190,7 @@ static ssize_t iwl_dbgfs_sram_write(struct file *file,
 {
 	struct iwl_priv *priv = file->private_data;
 	char buf[64];
-	int buf_size;
+	size_t buf_size;
 	u32 offset, len;
 
 	memset(buf, 0, sizeof(buf));
@@ -456,7 +456,7 @@ static ssize_t iwl_dbgfs_rx_handlers_write(struct file *file,
 	struct iwl_priv *priv = file->private_data;
 
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	u32 reset_flag;
 
 	memset(buf, 0, sizeof(buf));
@@ -537,7 +537,7 @@ static ssize_t iwl_dbgfs_disable_ht40_write(struct file *file,
 {
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int ht40;
 
 	memset(buf, 0, sizeof(buf));
@@ -589,7 +589,7 @@ static ssize_t iwl_dbgfs_sleep_level_override_write(struct file *file,
 {
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int value;
 
 	memset(buf, 0, sizeof(buf));
@@ -681,10 +681,10 @@ DEBUGFS_READ_FILE_OPS(temperature);
 DEBUGFS_READ_WRITE_FILE_OPS(sleep_level_override);
 DEBUGFS_READ_FILE_OPS(current_sleep_command);
 
-static const char *fmt_value = "  %-30s %10u\n";
-static const char *fmt_hex   = "  %-30s       0x%02X\n";
-static const char *fmt_table = "  %-30s %10u  %10u  %10u  %10u\n";
-static const char *fmt_header =
+static const char fmt_value[] = "  %-30s %10u\n";
+static const char fmt_hex[]   = "  %-30s       0x%02X\n";
+static const char fmt_table[] = "  %-30s %10u  %10u  %10u  %10u\n";
+static const char fmt_header[] =
 	"%-32s    current  cumulative       delta         max\n";
 
 static int iwl_statistics_flag(struct iwl_priv *priv, char *buf, int bufsz)
@@ -1854,7 +1854,7 @@ static ssize_t iwl_dbgfs_clear_ucode_statistics_write(struct file *file,
 {
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int clear;
 
 	memset(buf, 0, sizeof(buf));
@@ -1899,7 +1899,7 @@ static ssize_t iwl_dbgfs_ucode_tracing_write(struct file *file,
 {
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int trace;
 
 	memset(buf, 0, sizeof(buf));
@@ -1970,7 +1970,7 @@ static ssize_t iwl_dbgfs_missed_beacon_write(struct file *file,
 {
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int missed;
 
 	memset(buf, 0, sizeof(buf));
@@ -2011,7 +2011,7 @@ static ssize_t iwl_dbgfs_plcp_delta_write(struct file *file,
 
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int plcp;
 
 	memset(buf, 0, sizeof(buf));
@@ -2071,7 +2071,7 @@ static ssize_t iwl_dbgfs_txfifo_flush_write(struct file *file,
 
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int flush;
 
 	memset(buf, 0, sizeof(buf));
@@ -2161,7 +2161,7 @@ static ssize_t iwl_dbgfs_protection_mode_write(struct file *file,
 
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int rts;
 
 	if (!priv->cfg->ht_params)
@@ -2202,7 +2202,7 @@ static ssize_t iwl_dbgfs_echo_test_write(struct file *file,
 {
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 
 	memset(buf, 0, sizeof(buf));
 	buf_size = min(count, sizeof(buf) -  1);
@@ -2236,7 +2236,7 @@ static ssize_t iwl_dbgfs_log_event_write(struct file *file,
 	struct iwl_priv *priv = file->private_data;
 	u32 event_log_flag;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 
 	/* check that the interface is up */
 	if (!iwl_is_ready(priv))
@@ -2290,7 +2290,7 @@ static ssize_t iwl_dbgfs_calib_disabled_write(struct file *file,
 	struct iwl_priv *priv = file->private_data;
 	char buf[8];
 	u32 calib_disabled;
-	int buf_size;
+	size_t buf_size;
 
 	memset(buf, 0, sizeof(buf));
 	buf_size = min(count, sizeof(buf) - 1);
diff --git a/drivers/net/wireless/intel/iwlwifi/dvm/lib.c b/drivers/net/wireless/intel/iwlwifi/dvm/lib.c
index 6c2d6da7e..4660f3926 100644
--- a/drivers/net/wireless/intel/iwlwifi/dvm/lib.c
+++ b/drivers/net/wireless/intel/iwlwifi/dvm/lib.c
@@ -933,7 +933,7 @@ static void iwlagn_wowlan_program_keys(struct ieee80211_hw *hw,
 
 			rx_p1ks = data->tkip->rx_uni;
 
-			pn64 = atomic64_read(&key->tx_pn);
+			pn64 = atomic64_read_unchecked(&key->tx_pn);
 			tkip_tx_sc->iv16 = cpu_to_le16(TKIP_PN_TO_IV16(pn64));
 			tkip_tx_sc->iv32 = cpu_to_le32(TKIP_PN_TO_IV32(pn64));
 
@@ -986,7 +986,7 @@ static void iwlagn_wowlan_program_keys(struct ieee80211_hw *hw,
 			aes_sc = data->rsc_tsc->all_tsc_rsc.aes.unicast_rsc;
 			aes_tx_sc = &data->rsc_tsc->all_tsc_rsc.aes.tsc;
 
-			pn64 = atomic64_read(&key->tx_pn);
+			pn64 = atomic64_read_unchecked(&key->tx_pn);
 			aes_tx_sc->pn = cpu_to_le64(pn64);
 		} else
 			aes_sc = data->rsc_tsc->all_tsc_rsc.aes.multicast_rsc;
diff --git a/drivers/net/wireless/intel/iwlwifi/mvm/d3.c b/drivers/net/wireless/intel/iwlwifi/mvm/d3.c
index ea67ae9c8..89be09490 100644
--- a/drivers/net/wireless/intel/iwlwifi/mvm/d3.c
+++ b/drivers/net/wireless/intel/iwlwifi/mvm/d3.c
@@ -258,7 +258,7 @@ static void iwl_mvm_wowlan_program_keys(struct ieee80211_hw *hw,
 
 			rx_p1ks = data->tkip->rx_uni;
 
-			pn64 = atomic64_read(&key->tx_pn);
+			pn64 = atomic64_read_unchecked(&key->tx_pn);
 			tkip_tx_sc->iv16 = cpu_to_le16(TKIP_PN_TO_IV16(pn64));
 			tkip_tx_sc->iv32 = cpu_to_le32(TKIP_PN_TO_IV32(pn64));
 
@@ -313,7 +313,7 @@ static void iwl_mvm_wowlan_program_keys(struct ieee80211_hw *hw,
 			aes_sc = data->rsc_tsc->all_tsc_rsc.aes.unicast_rsc;
 			aes_tx_sc = &data->rsc_tsc->all_tsc_rsc.aes.tsc;
 
-			pn64 = atomic64_read(&key->tx_pn);
+			pn64 = atomic64_read_unchecked(&key->tx_pn);
 			aes_tx_sc->pn = cpu_to_le64(pn64);
 		} else {
 			aes_sc = data->rsc_tsc->all_tsc_rsc.aes.multicast_rsc;
@@ -1619,12 +1619,12 @@ static void iwl_mvm_d3_update_keys(struct ieee80211_hw *hw,
 		case WLAN_CIPHER_SUITE_CCMP:
 			iwl_mvm_set_aes_rx_seq(data->mvm, sc->aes.unicast_rsc,
 					       sta, key);
-			atomic64_set(&key->tx_pn, le64_to_cpu(sc->aes.tsc.pn));
+			atomic64_set_unchecked(&key->tx_pn, le64_to_cpu(sc->aes.tsc.pn));
 			break;
 		case WLAN_CIPHER_SUITE_TKIP:
 			iwl_mvm_tkip_sc_to_seq(&sc->tkip.tsc, &seq);
 			iwl_mvm_set_tkip_rx_seq(sc->tkip.unicast_rsc, key);
-			atomic64_set(&key->tx_pn,
+			atomic64_set_unchecked(&key->tx_pn,
 				     (u64)seq.tkip.iv16 |
 				     ((u64)seq.tkip.iv32 << 16));
 			break;
diff --git a/drivers/net/wireless/intel/iwlwifi/mvm/tx.c b/drivers/net/wireless/intel/iwlwifi/mvm/tx.c
index a0c1e3d07..a3c2b98f0 100644
--- a/drivers/net/wireless/intel/iwlwifi/mvm/tx.c
+++ b/drivers/net/wireless/intel/iwlwifi/mvm/tx.c
@@ -385,7 +385,7 @@ static inline void iwl_mvm_set_tx_cmd_pn(struct ieee80211_tx_info *info,
 	struct ieee80211_key_conf *keyconf = info->control.hw_key;
 	u64 pn;
 
-	pn = atomic64_inc_return(&keyconf->tx_pn);
+	pn = atomic64_inc_return_unchecked(&keyconf->tx_pn);
 	crypto_hdr[0] = pn;
 	crypto_hdr[2] = 0;
 	crypto_hdr[3] = 0x20 | (keyconf->keyidx << 6);
@@ -418,7 +418,7 @@ static void iwl_mvm_set_tx_cmd_crypto(struct iwl_mvm *mvm,
 
 	case WLAN_CIPHER_SUITE_TKIP:
 		tx_cmd->sec_ctl = TX_CMD_SEC_TKIP;
-		pn = atomic64_inc_return(&keyconf->tx_pn);
+		pn = atomic64_inc_return_unchecked(&keyconf->tx_pn);
 		ieee80211_tkip_add_iv(crypto_hdr, keyconf, pn);
 		ieee80211_get_tkip_p2k(keyconf, skb_frag, tx_cmd->key);
 		break;
diff --git a/drivers/net/wireless/intel/iwlwifi/pcie/trans.c b/drivers/net/wireless/intel/iwlwifi/pcie/trans.c
index 74f2f035b..8436ddc17 100644
--- a/drivers/net/wireless/intel/iwlwifi/pcie/trans.c
+++ b/drivers/net/wireless/intel/iwlwifi/pcie/trans.c
@@ -2346,7 +2346,7 @@ static ssize_t iwl_dbgfs_interrupt_write(struct file *file,
 	struct isr_statistics *isr_stats = &trans_pcie->isr_stats;
 
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	u32 reset_flag;
 
 	memset(buf, 0, sizeof(buf));
@@ -2367,7 +2367,7 @@ static ssize_t iwl_dbgfs_csr_write(struct file *file,
 {
 	struct iwl_trans *trans = file->private_data;
 	char buf[8];
-	int buf_size;
+	size_t buf_size;
 	int csr;
 
 	memset(buf, 0, sizeof(buf));
diff --git a/drivers/net/wireless/intersil/hostap/hostap_ioctl.c b/drivers/net/wireless/intersil/hostap/hostap_ioctl.c
index 3e5fa7872..6d26bebf3 100644
--- a/drivers/net/wireless/intersil/hostap/hostap_ioctl.c
+++ b/drivers/net/wireless/intersil/hostap/hostap_ioctl.c
@@ -101,8 +101,9 @@ static int prism2_get_datarates(struct net_device *dev, u8 *rates)
 
 static int prism2_get_name(struct net_device *dev,
 			   struct iw_request_info *info,
-			   char *name, char *extra)
+			   union iwreq_data *wrqu, char *extra)
 {
+	char *name = wrqu->name;
 	u8 rates[10];
 	int len, i, over2 = 0;
 
@@ -123,8 +124,9 @@ static int prism2_get_name(struct net_device *dev,
 
 static int prism2_ioctl_siwencode(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *erq, char *keybuf)
+				  union iwreq_data *wrqu, char *keybuf)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	int i;
@@ -225,8 +227,9 @@ static int prism2_ioctl_siwencode(struct net_device *dev,
 
 static int prism2_ioctl_giwencode(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *erq, char *key)
+				  union iwreq_data *wrqu, char *key)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	int i, len;
@@ -331,8 +334,9 @@ static int hostap_set_rate(struct net_device *dev)
 
 static int prism2_ioctl_siwrate(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *rrq, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -391,8 +395,9 @@ static int prism2_ioctl_siwrate(struct net_device *dev,
 
 static int prism2_ioctl_giwrate(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *rrq, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	u16 val;
 	struct hostap_interface *iface;
 	local_info_t *local;
@@ -450,8 +455,9 @@ static int prism2_ioctl_giwrate(struct net_device *dev,
 
 static int prism2_ioctl_siwsens(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *sens, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *sens = &wrqu->sens;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -471,8 +477,9 @@ static int prism2_ioctl_siwsens(struct net_device *dev,
 
 static int prism2_ioctl_giwsens(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *sens, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *sens = &wrqu->sens;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	__le16 val;
@@ -495,8 +502,9 @@ static int prism2_ioctl_giwsens(struct net_device *dev,
 /* Deprecated in new wireless extension API */
 static int prism2_ioctl_giwaplist(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *data, char *extra)
+				  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	struct sockaddr *addr;
@@ -536,8 +544,9 @@ static int prism2_ioctl_giwaplist(struct net_device *dev,
 
 static int prism2_ioctl_siwrts(struct net_device *dev,
 			       struct iw_request_info *info,
-			       struct iw_param *rts, char *extra)
+			       union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	__le16 val;
@@ -563,8 +572,9 @@ static int prism2_ioctl_siwrts(struct net_device *dev,
 
 static int prism2_ioctl_giwrts(struct net_device *dev,
 			       struct iw_request_info *info,
-			       struct iw_param *rts, char *extra)
+			       union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	__le16 val;
@@ -586,8 +596,9 @@ static int prism2_ioctl_giwrts(struct net_device *dev,
 
 static int prism2_ioctl_siwfrag(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *rts, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	__le16 val;
@@ -613,8 +624,9 @@ static int prism2_ioctl_siwfrag(struct net_device *dev,
 
 static int prism2_ioctl_giwfrag(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *rts, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	__le16 val;
@@ -679,11 +691,12 @@ static int hostap_join_ap(struct net_device *dev)
 
 static int prism2_ioctl_siwap(struct net_device *dev,
 			      struct iw_request_info *info,
-			      struct sockaddr *ap_addr, char *extra)
+			      union iwreq_data *wrqu, char *extra)
 {
 #ifdef PRISM2_NO_STATION_MODES
 	return -EOPNOTSUPP;
 #else /* PRISM2_NO_STATION_MODES */
+	struct sockaddr *ap_addr = &wrqu->ap_addr;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -719,8 +732,9 @@ static int prism2_ioctl_siwap(struct net_device *dev,
 
 static int prism2_ioctl_giwap(struct net_device *dev,
 			      struct iw_request_info *info,
-			      struct sockaddr *ap_addr, char *extra)
+			      union iwreq_data *wrqu, char *extra)
 {
+	struct sockaddr *ap_addr = &wrqu->ap_addr;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -755,8 +769,9 @@ static int prism2_ioctl_giwap(struct net_device *dev,
 
 static int prism2_ioctl_siwnickn(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_point *data, char *nickname)
+				 union iwreq_data *wrqu, char *nickname)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -776,8 +791,9 @@ static int prism2_ioctl_siwnickn(struct net_device *dev,
 
 static int prism2_ioctl_giwnickn(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_point *data, char *nickname)
+				 union iwreq_data *wrqu, char *nickname)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	int len;
@@ -803,8 +819,9 @@ static int prism2_ioctl_giwnickn(struct net_device *dev,
 
 static int prism2_ioctl_siwfreq(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_freq *freq, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *freq = &wrqu->freq;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -840,8 +857,9 @@ static int prism2_ioctl_siwfreq(struct net_device *dev,
 
 static int prism2_ioctl_giwfreq(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_freq *freq, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *freq = &wrqu->freq;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	u16 val;
@@ -884,8 +902,9 @@ static void hostap_monitor_set_type(local_info_t *local)
 
 static int prism2_ioctl_siwessid(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_point *data, char *ssid)
+				 union iwreq_data *wrqu, char *ssid)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -920,8 +939,9 @@ static int prism2_ioctl_siwessid(struct net_device *dev,
 
 static int prism2_ioctl_giwessid(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_point *data, char *essid)
+				 union iwreq_data *wrqu, char *essid)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	u16 val;
@@ -956,8 +976,9 @@ static int prism2_ioctl_giwessid(struct net_device *dev,
 
 static int prism2_ioctl_giwrange(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_point *data, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	struct iw_range *range = (struct iw_range *) extra;
@@ -1131,8 +1152,9 @@ static int hostap_monitor_mode_disable(local_info_t *local)
 
 static int prism2_ioctl_siwmode(struct net_device *dev,
 				struct iw_request_info *info,
-				__u32 *mode, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	__u32 *mode = &wrqu->mode;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	int double_reset = 0;
@@ -1207,8 +1229,9 @@ static int prism2_ioctl_siwmode(struct net_device *dev,
 
 static int prism2_ioctl_giwmode(struct net_device *dev,
 				struct iw_request_info *info,
-				__u32 *mode, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	__u32 *mode = &wrqu->mode;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -1232,11 +1255,12 @@ static int prism2_ioctl_giwmode(struct net_device *dev,
 
 static int prism2_ioctl_siwpower(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *wrq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
 #ifdef PRISM2_NO_STATION_MODES
 	return -EOPNOTSUPP;
 #else /* PRISM2_NO_STATION_MODES */
+	struct iw_param *wrq = &wrqu->power;
 	int ret = 0;
 
 	if (wrq->disabled)
@@ -1291,11 +1315,12 @@ static int prism2_ioctl_siwpower(struct net_device *dev,
 
 static int prism2_ioctl_giwpower(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rrq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
 #ifdef PRISM2_NO_STATION_MODES
 	return -EOPNOTSUPP;
 #else /* PRISM2_NO_STATION_MODES */
+	struct iw_param *rrq = &wrqu->power;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	__le16 enable, mcast;
@@ -1349,8 +1374,9 @@ static int prism2_ioctl_giwpower(struct net_device *dev,
 
 static int prism2_ioctl_siwretry(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rrq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct hostap_interface *iface;
 	local_info_t *local;
 
@@ -1410,8 +1436,9 @@ static int prism2_ioctl_siwretry(struct net_device *dev,
 
 static int prism2_ioctl_giwretry(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rrq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	__le16 shortretry, longretry, lifetime, altretry;
@@ -1504,8 +1531,9 @@ static u16 prism2_txpower_dBm_to_hfa386x(int val)
 
 static int prism2_ioctl_siwtxpow(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rrq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct hostap_interface *iface;
 	local_info_t *local;
 #ifdef RAW_TXPOWER_SETTING
@@ -1585,9 +1613,10 @@ static int prism2_ioctl_siwtxpow(struct net_device *dev,
 
 static int prism2_ioctl_giwtxpow(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rrq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
 #ifdef RAW_TXPOWER_SETTING
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	u16 resp0;
@@ -1720,8 +1749,9 @@ static inline int prism2_request_scan(struct net_device *dev)
 
 static int prism2_ioctl_siwscan(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_point *data, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	int ret;
@@ -2068,8 +2098,9 @@ static inline int prism2_ioctl_giwscan_sta(struct net_device *dev,
 
 static int prism2_ioctl_giwscan(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_point *data, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface;
 	local_info_t *local;
 	int res;
@@ -2314,7 +2345,7 @@ static int prism2_ioctl_priv_inquire(struct net_device *dev, int *i)
 
 static int prism2_ioctl_priv_prism2_param(struct net_device *dev,
 					  struct iw_request_info *info,
-					  void *wrqu, char *extra)
+					  union iwreq_data *wrqu, char *extra)
 {
 	struct hostap_interface *iface;
 	local_info_t *local;
@@ -2665,7 +2696,7 @@ static int prism2_ioctl_priv_prism2_param(struct net_device *dev,
 
 static int prism2_ioctl_priv_get_prism2_param(struct net_device *dev,
 					      struct iw_request_info *info,
-					      void *wrqu, char *extra)
+					      union iwreq_data *wrqu, char *extra)
 {
 	struct hostap_interface *iface;
 	local_info_t *local;
@@ -2852,7 +2883,7 @@ static int prism2_ioctl_priv_get_prism2_param(struct net_device *dev,
 
 static int prism2_ioctl_priv_readmif(struct net_device *dev,
 				     struct iw_request_info *info,
-				     void *wrqu, char *extra)
+				     union iwreq_data *wrqu, char *extra)
 {
 	struct hostap_interface *iface;
 	local_info_t *local;
@@ -2873,7 +2904,7 @@ static int prism2_ioctl_priv_readmif(struct net_device *dev,
 
 static int prism2_ioctl_priv_writemif(struct net_device *dev,
 				      struct iw_request_info *info,
-				      void *wrqu, char *extra)
+				      union iwreq_data *wrqu, char *extra)
 {
 	struct hostap_interface *iface;
 	local_info_t *local;
@@ -2911,7 +2942,7 @@ static int prism2_ioctl_priv_monitor(struct net_device *dev, int *i)
 		/* Disable monitor mode - old mode was not saved, so go to
 		 * Master mode */
 		mode = IW_MODE_MASTER;
-		ret = prism2_ioctl_siwmode(dev, NULL, &mode, NULL);
+		ret = prism2_ioctl_siwmode(dev, NULL, (union iwreq_data *)&mode, NULL);
 	} else if (*i == 1) {
 		/* netlink socket mode is not supported anymore since it did
 		 * not separate different devices from each other and was not
@@ -2928,7 +2959,7 @@ static int prism2_ioctl_priv_monitor(struct net_device *dev, int *i)
 			break;
 		}
 		mode = IW_MODE_MONITOR;
-		ret = prism2_ioctl_siwmode(dev, NULL, &mode, NULL);
+		ret = prism2_ioctl_siwmode(dev, NULL, (union iwreq_data *)&mode, NULL);
 		hostap_monitor_mode_enable(local);
 	} else
 		ret = -EINVAL;
@@ -3094,8 +3125,9 @@ static int prism2_set_genericelement(struct net_device *dev, u8 *elem,
 
 static int prism2_ioctl_siwauth(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *data, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *data = &wrqu->param;
 	struct hostap_interface *iface = netdev_priv(dev);
 	local_info_t *local = iface->local;
 
@@ -3160,8 +3192,9 @@ static int prism2_ioctl_siwauth(struct net_device *dev,
 
 static int prism2_ioctl_giwauth(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_param *data, char *extra)
+				union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *data = &wrqu->param;
 	struct hostap_interface *iface = netdev_priv(dev);
 	local_info_t *local = iface->local;
 
@@ -3199,8 +3232,9 @@ static int prism2_ioctl_giwauth(struct net_device *dev,
 
 static int prism2_ioctl_siwencodeext(struct net_device *dev,
 				     struct iw_request_info *info,
-				     struct iw_point *erq, char *extra)
+				     union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct hostap_interface *iface = netdev_priv(dev);
 	local_info_t *local = iface->local;
 	struct iw_encode_ext *ext = (struct iw_encode_ext *) extra;
@@ -3373,8 +3407,9 @@ static int prism2_ioctl_siwencodeext(struct net_device *dev,
 
 static int prism2_ioctl_giwencodeext(struct net_device *dev,
 				     struct iw_request_info *info,
-				     struct iw_point *erq, char *extra)
+				     union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct hostap_interface *iface = netdev_priv(dev);
 	local_info_t *local = iface->local;
 	struct lib80211_crypt_data **crypt;
@@ -3681,16 +3716,19 @@ static int prism2_ioctl_set_assoc_ap_addr(local_info_t *local,
 
 static int prism2_ioctl_siwgenie(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_point *data, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
+
 	return prism2_set_genericelement(dev, extra, data->length);
 }
 
 
 static int prism2_ioctl_giwgenie(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_point *data, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct hostap_interface *iface = netdev_priv(dev);
 	local_info_t *local = iface->local;
 	int len = local->generic_elem_len - 2;
@@ -3728,7 +3766,7 @@ static int prism2_ioctl_set_generic_element(local_info_t *local,
 
 static int prism2_ioctl_siwmlme(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_point *data, char *extra)
+				union iwreq_data *data, char *extra)
 {
 	struct hostap_interface *iface = netdev_priv(dev);
 	local_info_t *local = iface->local;
@@ -3883,70 +3921,70 @@ const struct ethtool_ops prism2_ethtool_ops = {
 
 static const iw_handler prism2_handler[] =
 {
-	(iw_handler) NULL,				/* SIOCSIWCOMMIT */
-	(iw_handler) prism2_get_name,			/* SIOCGIWNAME */
-	(iw_handler) NULL,				/* SIOCSIWNWID */
-	(iw_handler) NULL,				/* SIOCGIWNWID */
-	(iw_handler) prism2_ioctl_siwfreq,		/* SIOCSIWFREQ */
-	(iw_handler) prism2_ioctl_giwfreq,		/* SIOCGIWFREQ */
-	(iw_handler) prism2_ioctl_siwmode,		/* SIOCSIWMODE */
-	(iw_handler) prism2_ioctl_giwmode,		/* SIOCGIWMODE */
-	(iw_handler) prism2_ioctl_siwsens,		/* SIOCSIWSENS */
-	(iw_handler) prism2_ioctl_giwsens,		/* SIOCGIWSENS */
-	(iw_handler) NULL /* not used */,		/* SIOCSIWRANGE */
-	(iw_handler) prism2_ioctl_giwrange,		/* SIOCGIWRANGE */
-	(iw_handler) NULL /* not used */,		/* SIOCSIWPRIV */
-	(iw_handler) NULL /* kernel code */,		/* SIOCGIWPRIV */
-	(iw_handler) NULL /* not used */,		/* SIOCSIWSTATS */
-	(iw_handler) NULL /* kernel code */,		/* SIOCGIWSTATS */
-	iw_handler_set_spy,				/* SIOCSIWSPY */
-	iw_handler_get_spy,				/* SIOCGIWSPY */
-	iw_handler_set_thrspy,				/* SIOCSIWTHRSPY */
-	iw_handler_get_thrspy,				/* SIOCGIWTHRSPY */
-	(iw_handler) prism2_ioctl_siwap,		/* SIOCSIWAP */
-	(iw_handler) prism2_ioctl_giwap,		/* SIOCGIWAP */
-	(iw_handler) prism2_ioctl_siwmlme,		/* SIOCSIWMLME */
-	(iw_handler) prism2_ioctl_giwaplist,		/* SIOCGIWAPLIST */
-	(iw_handler) prism2_ioctl_siwscan,		/* SIOCSIWSCAN */
-	(iw_handler) prism2_ioctl_giwscan,		/* SIOCGIWSCAN */
-	(iw_handler) prism2_ioctl_siwessid,		/* SIOCSIWESSID */
-	(iw_handler) prism2_ioctl_giwessid,		/* SIOCGIWESSID */
-	(iw_handler) prism2_ioctl_siwnickn,		/* SIOCSIWNICKN */
-	(iw_handler) prism2_ioctl_giwnickn,		/* SIOCGIWNICKN */
-	(iw_handler) NULL,				/* -- hole -- */
-	(iw_handler) NULL,				/* -- hole -- */
-	(iw_handler) prism2_ioctl_siwrate,		/* SIOCSIWRATE */
-	(iw_handler) prism2_ioctl_giwrate,		/* SIOCGIWRATE */
-	(iw_handler) prism2_ioctl_siwrts,		/* SIOCSIWRTS */
-	(iw_handler) prism2_ioctl_giwrts,		/* SIOCGIWRTS */
-	(iw_handler) prism2_ioctl_siwfrag,		/* SIOCSIWFRAG */
-	(iw_handler) prism2_ioctl_giwfrag,		/* SIOCGIWFRAG */
-	(iw_handler) prism2_ioctl_siwtxpow,		/* SIOCSIWTXPOW */
-	(iw_handler) prism2_ioctl_giwtxpow,		/* SIOCGIWTXPOW */
-	(iw_handler) prism2_ioctl_siwretry,		/* SIOCSIWRETRY */
-	(iw_handler) prism2_ioctl_giwretry,		/* SIOCGIWRETRY */
-	(iw_handler) prism2_ioctl_siwencode,		/* SIOCSIWENCODE */
-	(iw_handler) prism2_ioctl_giwencode,		/* SIOCGIWENCODE */
-	(iw_handler) prism2_ioctl_siwpower,		/* SIOCSIWPOWER */
-	(iw_handler) prism2_ioctl_giwpower,		/* SIOCGIWPOWER */
-	(iw_handler) NULL,				/* -- hole -- */
-	(iw_handler) NULL,				/* -- hole -- */
-	(iw_handler) prism2_ioctl_siwgenie,		/* SIOCSIWGENIE */
-	(iw_handler) prism2_ioctl_giwgenie,		/* SIOCGIWGENIE */
-	(iw_handler) prism2_ioctl_siwauth,		/* SIOCSIWAUTH */
-	(iw_handler) prism2_ioctl_giwauth,		/* SIOCGIWAUTH */
-	(iw_handler) prism2_ioctl_siwencodeext,		/* SIOCSIWENCODEEXT */
-	(iw_handler) prism2_ioctl_giwencodeext,		/* SIOCGIWENCODEEXT */
-	(iw_handler) NULL,				/* SIOCSIWPMKSA */
-	(iw_handler) NULL,				/* -- hole -- */
+	NULL,				/* SIOCSIWCOMMIT */
+	prism2_get_name,		/* SIOCGIWNAME */
+	NULL,				/* SIOCSIWNWID */
+	NULL,				/* SIOCGIWNWID */
+	prism2_ioctl_siwfreq,		/* SIOCSIWFREQ */
+	prism2_ioctl_giwfreq,		/* SIOCGIWFREQ */
+	prism2_ioctl_siwmode,		/* SIOCSIWMODE */
+	prism2_ioctl_giwmode,		/* SIOCGIWMODE */
+	prism2_ioctl_siwsens,		/* SIOCSIWSENS */
+	prism2_ioctl_giwsens,		/* SIOCGIWSENS */
+	NULL /* not used */,		/* SIOCSIWRANGE */
+	prism2_ioctl_giwrange,		/* SIOCGIWRANGE */
+	NULL /* not used */,		/* SIOCSIWPRIV */
+	NULL /* kernel code */,		/* SIOCGIWPRIV */
+	NULL /* not used */,		/* SIOCSIWSTATS */
+	NULL /* kernel code */,		/* SIOCGIWSTATS */
+	iw_handler_set_spy,		/* SIOCSIWSPY */
+	iw_handler_get_spy,		/* SIOCGIWSPY */
+	iw_handler_set_thrspy,		/* SIOCSIWTHRSPY */
+	iw_handler_get_thrspy,		/* SIOCGIWTHRSPY */
+	prism2_ioctl_siwap,		/* SIOCSIWAP */
+	prism2_ioctl_giwap,		/* SIOCGIWAP */
+	prism2_ioctl_siwmlme,		/* SIOCSIWMLME */
+	prism2_ioctl_giwaplist,		/* SIOCGIWAPLIST */
+	prism2_ioctl_siwscan,		/* SIOCSIWSCAN */
+	prism2_ioctl_giwscan,		/* SIOCGIWSCAN */
+	prism2_ioctl_siwessid,		/* SIOCSIWESSID */
+	prism2_ioctl_giwessid,		/* SIOCGIWESSID */
+	prism2_ioctl_siwnickn,		/* SIOCSIWNICKN */
+	prism2_ioctl_giwnickn,		/* SIOCGIWNICKN */
+	NULL,				/* -- hole -- */
+	NULL,				/* -- hole -- */
+	prism2_ioctl_siwrate,		/* SIOCSIWRATE */
+	prism2_ioctl_giwrate,		/* SIOCGIWRATE */
+	prism2_ioctl_siwrts,		/* SIOCSIWRTS */
+	prism2_ioctl_giwrts,		/* SIOCGIWRTS */
+	prism2_ioctl_siwfrag,		/* SIOCSIWFRAG */
+	prism2_ioctl_giwfrag,		/* SIOCGIWFRAG */
+	prism2_ioctl_siwtxpow,		/* SIOCSIWTXPOW */
+	prism2_ioctl_giwtxpow,		/* SIOCGIWTXPOW */
+	prism2_ioctl_siwretry,		/* SIOCSIWRETRY */
+	prism2_ioctl_giwretry,		/* SIOCGIWRETRY */
+	prism2_ioctl_siwencode,		/* SIOCSIWENCODE */
+	prism2_ioctl_giwencode,		/* SIOCGIWENCODE */
+	prism2_ioctl_siwpower,		/* SIOCSIWPOWER */
+	prism2_ioctl_giwpower,		/* SIOCGIWPOWER */
+	NULL,				/* -- hole -- */
+	NULL,				/* -- hole -- */
+	prism2_ioctl_siwgenie,		/* SIOCSIWGENIE */
+	prism2_ioctl_giwgenie,		/* SIOCGIWGENIE */
+	prism2_ioctl_siwauth,		/* SIOCSIWAUTH */
+	prism2_ioctl_giwauth,		/* SIOCGIWAUTH */
+	prism2_ioctl_siwencodeext,	/* SIOCSIWENCODEEXT */
+	prism2_ioctl_giwencodeext,	/* SIOCGIWENCODEEXT */
+	NULL,				/* SIOCSIWPMKSA */
+	NULL,				/* -- hole -- */
 };
 
 static const iw_handler prism2_private_handler[] =
 {							/* SIOCIWFIRSTPRIV + */
-	(iw_handler) prism2_ioctl_priv_prism2_param,	/* 0 */
-	(iw_handler) prism2_ioctl_priv_get_prism2_param, /* 1 */
-	(iw_handler) prism2_ioctl_priv_writemif,	/* 2 */
-	(iw_handler) prism2_ioctl_priv_readmif,		/* 3 */
+	prism2_ioctl_priv_prism2_param,	/* 0 */
+	prism2_ioctl_priv_get_prism2_param, /* 1 */
+	prism2_ioctl_priv_writemif,	/* 2 */
+	prism2_ioctl_priv_readmif,		/* 3 */
 };
 
 const struct iw_handler_def hostap_iw_handler_def =
@@ -3954,8 +3992,8 @@ const struct iw_handler_def hostap_iw_handler_def =
 	.num_standard	= ARRAY_SIZE(prism2_handler),
 	.num_private	= ARRAY_SIZE(prism2_private_handler),
 	.num_private_args = ARRAY_SIZE(prism2_priv),
-	.standard	= (iw_handler *) prism2_handler,
-	.private	= (iw_handler *) prism2_private_handler,
+	.standard	= prism2_handler,
+	.private	= prism2_private_handler,
 	.private_args	= (struct iw_priv_args *) prism2_priv,
 	.get_wireless_stats = hostap_get_wireless_stats,
 };
diff --git a/drivers/net/wireless/intersil/orinoco/wext.c b/drivers/net/wireless/intersil/orinoco/wext.c
index 1d4dae422..0508fc162 100644
--- a/drivers/net/wireless/intersil/orinoco/wext.c
+++ b/drivers/net/wireless/intersil/orinoco/wext.c
@@ -154,9 +154,10 @@ static struct iw_statistics *orinoco_get_wireless_stats(struct net_device *dev)
 
 static int orinoco_ioctl_setwap(struct net_device *dev,
 				struct iw_request_info *info,
-				struct sockaddr *ap_addr,
+				union iwreq_data *wrqu,
 				char *extra)
 {
+	struct sockaddr *ap_addr = &wrqu->ap_addr;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int err = -EINPROGRESS;		/* Call commit handler */
 	unsigned long flags;
@@ -213,9 +214,10 @@ static int orinoco_ioctl_setwap(struct net_device *dev,
 
 static int orinoco_ioctl_getwap(struct net_device *dev,
 				struct iw_request_info *info,
-				struct sockaddr *ap_addr,
+				union iwreq_data *wrqu,
 				char *extra)
 {
+	struct sockaddr *ap_addr = &wrqu->ap_addr;
 	struct orinoco_private *priv = ndev_priv(dev);
 
 	int err = 0;
@@ -234,9 +236,10 @@ static int orinoco_ioctl_getwap(struct net_device *dev,
 
 static int orinoco_ioctl_setiwencode(struct net_device *dev,
 				     struct iw_request_info *info,
-				     struct iw_point *erq,
+				     union iwreq_data *wrqu,
 				     char *keybuf)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int index = (erq->flags & IW_ENCODE_INDEX) - 1;
 	int setindex = priv->tx_key;
@@ -325,9 +328,10 @@ static int orinoco_ioctl_setiwencode(struct net_device *dev,
 
 static int orinoco_ioctl_getiwencode(struct net_device *dev,
 				     struct iw_request_info *info,
-				     struct iw_point *erq,
+				     union iwreq_data *wrqu,
 				     char *keybuf)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int index = (erq->flags & IW_ENCODE_INDEX) - 1;
 	unsigned long flags;
@@ -361,9 +365,10 @@ static int orinoco_ioctl_getiwencode(struct net_device *dev,
 
 static int orinoco_ioctl_setessid(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *erq,
+				  union iwreq_data *wrqu,
 				  char *essidbuf)
 {
+	struct iw_point *erq = &wrqu->essid;
 	struct orinoco_private *priv = ndev_priv(dev);
 	unsigned long flags;
 
@@ -392,9 +397,10 @@ static int orinoco_ioctl_setessid(struct net_device *dev,
 
 static int orinoco_ioctl_getessid(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *erq,
+				  union iwreq_data *wrqu,
 				  char *essidbuf)
 {
+	struct iw_point *erq = &wrqu->essid;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int active;
 	int err = 0;
@@ -420,9 +426,10 @@ static int orinoco_ioctl_getessid(struct net_device *dev,
 
 static int orinoco_ioctl_setfreq(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_freq *frq,
+				 union iwreq_data *wrqu,
 				 char *extra)
 {
+	struct iw_freq *frq = &wrqu->freq;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int chan = -1;
 	unsigned long flags;
@@ -469,9 +476,10 @@ static int orinoco_ioctl_setfreq(struct net_device *dev,
 
 static int orinoco_ioctl_getfreq(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_freq *frq,
+				 union iwreq_data *wrqu,
 				 char *extra)
 {
+	struct iw_freq *frq = &wrqu->freq;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int tmp;
 
@@ -488,9 +496,10 @@ static int orinoco_ioctl_getfreq(struct net_device *dev,
 
 static int orinoco_ioctl_getsens(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *srq,
+				 union iwreq_data *wrqu,
 				 char *extra)
 {
+	struct iw_param *srq = &wrqu->sens;
 	struct orinoco_private *priv = ndev_priv(dev);
 	struct hermes *hw = &priv->hw;
 	u16 val;
@@ -517,9 +526,10 @@ static int orinoco_ioctl_getsens(struct net_device *dev,
 
 static int orinoco_ioctl_setsens(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *srq,
+				 union iwreq_data *wrqu,
 				 char *extra)
 {
+	struct iw_param *srq = &wrqu->sens;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int val = srq->value;
 	unsigned long flags;
@@ -540,9 +550,10 @@ static int orinoco_ioctl_setsens(struct net_device *dev,
 
 static int orinoco_ioctl_setrate(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rrq,
+				 union iwreq_data *wrqu,
 				 char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int ratemode;
 	int bitrate; /* 100s of kilobits */
@@ -574,9 +585,10 @@ static int orinoco_ioctl_setrate(struct net_device *dev,
 
 static int orinoco_ioctl_getrate(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rrq,
+				 union iwreq_data *wrqu,
 				 char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int err = 0;
 	int bitrate, automatic;
@@ -610,9 +622,10 @@ static int orinoco_ioctl_getrate(struct net_device *dev,
 
 static int orinoco_ioctl_setpower(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_param *prq,
+				  union iwreq_data *wrqu,
 				  char *extra)
 {
+	struct iw_param *prq = &wrqu->power;
 	struct orinoco_private *priv = ndev_priv(dev);
 	int err = -EINPROGRESS;		/* Call commit handler */
 	unsigned long flags;
@@ -664,9 +677,10 @@ static int orinoco_ioctl_setpower(struct net_device *dev,
 
 static int orinoco_ioctl_getpower(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_param *prq,
+				  union iwreq_data *wrqu,
 				  char *extra)
 {
+	struct iw_param *prq = &wrqu->power;
 	struct orinoco_private *priv = ndev_priv(dev);
 	struct hermes *hw = &priv->hw;
 	int err = 0;
@@ -1097,7 +1111,7 @@ static int orinoco_ioctl_set_mlme(struct net_device *dev,
 
 static int orinoco_ioctl_reset(struct net_device *dev,
 			       struct iw_request_info *info,
-			       void *wrqu,
+			       union iwreq_data *wrqu,
 			       char *extra)
 {
 	struct orinoco_private *priv = ndev_priv(dev);
@@ -1121,7 +1135,7 @@ static int orinoco_ioctl_reset(struct net_device *dev,
 
 static int orinoco_ioctl_setibssport(struct net_device *dev,
 				     struct iw_request_info *info,
-				     void *wrqu,
+				     union iwreq_data *wrqu,
 				     char *extra)
 
 {
@@ -1143,7 +1157,7 @@ static int orinoco_ioctl_setibssport(struct net_device *dev,
 
 static int orinoco_ioctl_getibssport(struct net_device *dev,
 				     struct iw_request_info *info,
-				     void *wrqu,
+				     union iwreq_data *wrqu,
 				     char *extra)
 {
 	struct orinoco_private *priv = ndev_priv(dev);
@@ -1155,7 +1169,7 @@ static int orinoco_ioctl_getibssport(struct net_device *dev,
 
 static int orinoco_ioctl_setport3(struct net_device *dev,
 				  struct iw_request_info *info,
-				  void *wrqu,
+				  union iwreq_data *wrqu,
 				  char *extra)
 {
 	struct orinoco_private *priv = ndev_priv(dev);
@@ -1201,7 +1215,7 @@ static int orinoco_ioctl_setport3(struct net_device *dev,
 
 static int orinoco_ioctl_getport3(struct net_device *dev,
 				  struct iw_request_info *info,
-				  void *wrqu,
+				  union iwreq_data *wrqu,
 				  char *extra)
 {
 	struct orinoco_private *priv = ndev_priv(dev);
@@ -1213,7 +1227,7 @@ static int orinoco_ioctl_getport3(struct net_device *dev,
 
 static int orinoco_ioctl_setpreamble(struct net_device *dev,
 				     struct iw_request_info *info,
-				     void *wrqu,
+				     union iwreq_data *wrqu,
 				     char *extra)
 {
 	struct orinoco_private *priv = ndev_priv(dev);
@@ -1245,7 +1259,7 @@ static int orinoco_ioctl_setpreamble(struct net_device *dev,
 
 static int orinoco_ioctl_getpreamble(struct net_device *dev,
 				     struct iw_request_info *info,
-				     void *wrqu,
+				     union iwreq_data *wrqu,
 				     char *extra)
 {
 	struct orinoco_private *priv = ndev_priv(dev);
@@ -1265,9 +1279,10 @@ static int orinoco_ioctl_getpreamble(struct net_device *dev,
  * For Wireless Tools 25 and 26 append "dummy" are the end. */
 static int orinoco_ioctl_getrid(struct net_device *dev,
 				struct iw_request_info *info,
-				struct iw_point *data,
+				union iwreq_data *wrqu,
 				char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct orinoco_private *priv = ndev_priv(dev);
 	struct hermes *hw = &priv->hw;
 	int rid = data->flags;
@@ -1303,7 +1318,7 @@ static int orinoco_ioctl_getrid(struct net_device *dev,
 /* Commit handler, called after set operations */
 static int orinoco_ioctl_commit(struct net_device *dev,
 				struct iw_request_info *info,
-				void *wrqu,
+				union iwreq_data *wrqu,
 				char *extra)
 {
 	struct orinoco_private *priv = ndev_priv(dev);
@@ -1347,36 +1362,36 @@ static const struct iw_priv_args orinoco_privtab[] = {
  */
 
 static const iw_handler	orinoco_handler[] = {
-	IW_HANDLER(SIOCSIWCOMMIT,	(iw_handler)orinoco_ioctl_commit),
-	IW_HANDLER(SIOCGIWNAME,		(iw_handler)cfg80211_wext_giwname),
-	IW_HANDLER(SIOCSIWFREQ,		(iw_handler)orinoco_ioctl_setfreq),
-	IW_HANDLER(SIOCGIWFREQ,		(iw_handler)orinoco_ioctl_getfreq),
-	IW_HANDLER(SIOCSIWMODE,		(iw_handler)cfg80211_wext_siwmode),
-	IW_HANDLER(SIOCGIWMODE,		(iw_handler)cfg80211_wext_giwmode),
-	IW_HANDLER(SIOCSIWSENS,		(iw_handler)orinoco_ioctl_setsens),
-	IW_HANDLER(SIOCGIWSENS,		(iw_handler)orinoco_ioctl_getsens),
-	IW_HANDLER(SIOCGIWRANGE,	(iw_handler)cfg80211_wext_giwrange),
+	IW_HANDLER(SIOCSIWCOMMIT,	orinoco_ioctl_commit),
+	IW_HANDLER(SIOCGIWNAME,		cfg80211_wext_giwname),
+	IW_HANDLER(SIOCSIWFREQ,		orinoco_ioctl_setfreq),
+	IW_HANDLER(SIOCGIWFREQ,		orinoco_ioctl_getfreq),
+	IW_HANDLER(SIOCSIWMODE,		cfg80211_wext_siwmode),
+	IW_HANDLER(SIOCGIWMODE,		cfg80211_wext_giwmode),
+	IW_HANDLER(SIOCSIWSENS,		orinoco_ioctl_setsens),
+	IW_HANDLER(SIOCGIWSENS,		orinoco_ioctl_getsens),
+	IW_HANDLER(SIOCGIWRANGE,	cfg80211_wext_giwrange),
 	IW_HANDLER(SIOCSIWSPY,		iw_handler_set_spy),
 	IW_HANDLER(SIOCGIWSPY,		iw_handler_get_spy),
 	IW_HANDLER(SIOCSIWTHRSPY,	iw_handler_set_thrspy),
 	IW_HANDLER(SIOCGIWTHRSPY,	iw_handler_get_thrspy),
-	IW_HANDLER(SIOCSIWAP,		(iw_handler)orinoco_ioctl_setwap),
-	IW_HANDLER(SIOCGIWAP,		(iw_handler)orinoco_ioctl_getwap),
-	IW_HANDLER(SIOCSIWSCAN,		(iw_handler)cfg80211_wext_siwscan),
-	IW_HANDLER(SIOCGIWSCAN,		(iw_handler)cfg80211_wext_giwscan),
-	IW_HANDLER(SIOCSIWESSID,	(iw_handler)orinoco_ioctl_setessid),
-	IW_HANDLER(SIOCGIWESSID,	(iw_handler)orinoco_ioctl_getessid),
-	IW_HANDLER(SIOCSIWRATE,		(iw_handler)orinoco_ioctl_setrate),
-	IW_HANDLER(SIOCGIWRATE,		(iw_handler)orinoco_ioctl_getrate),
-	IW_HANDLER(SIOCSIWRTS,		(iw_handler)cfg80211_wext_siwrts),
-	IW_HANDLER(SIOCGIWRTS,		(iw_handler)cfg80211_wext_giwrts),
-	IW_HANDLER(SIOCSIWFRAG,		(iw_handler)cfg80211_wext_siwfrag),
-	IW_HANDLER(SIOCGIWFRAG,		(iw_handler)cfg80211_wext_giwfrag),
-	IW_HANDLER(SIOCGIWRETRY,	(iw_handler)cfg80211_wext_giwretry),
-	IW_HANDLER(SIOCSIWENCODE,	(iw_handler)orinoco_ioctl_setiwencode),
-	IW_HANDLER(SIOCGIWENCODE,	(iw_handler)orinoco_ioctl_getiwencode),
-	IW_HANDLER(SIOCSIWPOWER,	(iw_handler)orinoco_ioctl_setpower),
-	IW_HANDLER(SIOCGIWPOWER,	(iw_handler)orinoco_ioctl_getpower),
+	IW_HANDLER(SIOCSIWAP,		orinoco_ioctl_setwap),
+	IW_HANDLER(SIOCGIWAP,		orinoco_ioctl_getwap),
+	IW_HANDLER(SIOCSIWSCAN,		cfg80211_wext_siwscan),
+	IW_HANDLER(SIOCGIWSCAN,		cfg80211_wext_giwscan),
+	IW_HANDLER(SIOCSIWESSID,	orinoco_ioctl_setessid),
+	IW_HANDLER(SIOCGIWESSID,	orinoco_ioctl_getessid),
+	IW_HANDLER(SIOCSIWRATE,		orinoco_ioctl_setrate),
+	IW_HANDLER(SIOCGIWRATE,		orinoco_ioctl_getrate),
+	IW_HANDLER(SIOCSIWRTS,		cfg80211_wext_siwrts),
+	IW_HANDLER(SIOCGIWRTS,		cfg80211_wext_giwrts),
+	IW_HANDLER(SIOCSIWFRAG,		cfg80211_wext_siwfrag),
+	IW_HANDLER(SIOCGIWFRAG,		cfg80211_wext_giwfrag),
+	IW_HANDLER(SIOCGIWRETRY,	cfg80211_wext_giwretry),
+	IW_HANDLER(SIOCSIWENCODE,	orinoco_ioctl_setiwencode),
+	IW_HANDLER(SIOCGIWENCODE,	orinoco_ioctl_getiwencode),
+	IW_HANDLER(SIOCSIWPOWER,	orinoco_ioctl_setpower),
+	IW_HANDLER(SIOCGIWPOWER,	orinoco_ioctl_getpower),
 	IW_HANDLER(SIOCSIWGENIE,	orinoco_ioctl_set_genie),
 	IW_HANDLER(SIOCGIWGENIE,	orinoco_ioctl_get_genie),
 	IW_HANDLER(SIOCSIWMLME,		orinoco_ioctl_set_mlme),
@@ -1391,15 +1406,15 @@ static const iw_handler	orinoco_handler[] = {
   Added typecasting since we no longer use iwreq_data -- Moustafa
  */
 static const iw_handler	orinoco_private_handler[] = {
-	[0] = (iw_handler)orinoco_ioctl_reset,
-	[1] = (iw_handler)orinoco_ioctl_reset,
-	[2] = (iw_handler)orinoco_ioctl_setport3,
-	[3] = (iw_handler)orinoco_ioctl_getport3,
-	[4] = (iw_handler)orinoco_ioctl_setpreamble,
-	[5] = (iw_handler)orinoco_ioctl_getpreamble,
-	[6] = (iw_handler)orinoco_ioctl_setibssport,
-	[7] = (iw_handler)orinoco_ioctl_getibssport,
-	[9] = (iw_handler)orinoco_ioctl_getrid,
+	[0] = orinoco_ioctl_reset,
+	[1] = orinoco_ioctl_reset,
+	[2] = orinoco_ioctl_setport3,
+	[3] = orinoco_ioctl_getport3,
+	[4] = orinoco_ioctl_setpreamble,
+	[5] = orinoco_ioctl_getpreamble,
+	[6] = orinoco_ioctl_setibssport,
+	[7] = orinoco_ioctl_getibssport,
+	[9] = orinoco_ioctl_getrid,
 };
 
 const struct iw_handler_def orinoco_handler_def = {
diff --git a/drivers/net/wireless/intersil/prism54/isl_ioctl.c b/drivers/net/wireless/intersil/prism54/isl_ioctl.c
index 48e8a978a..3499ec810 100644
--- a/drivers/net/wireless/intersil/prism54/isl_ioctl.c
+++ b/drivers/net/wireless/intersil/prism54/isl_ioctl.c
@@ -45,7 +45,7 @@ static void prism54_wpa_bss_ie_add(islpci_private *priv, u8 *bssid,
 				u8 *wpa_ie, size_t wpa_ie_len);
 static size_t prism54_wpa_bss_ie_get(islpci_private *priv, u8 *bssid, u8 *wpa_ie);
 static int prism54_set_wpa(struct net_device *, struct iw_request_info *,
-				__u32 *, char *);
+				union iwreq_data *, char *);
 
 /* In 500 kbps */
 static const unsigned char scan_rate_list[] = { 2, 4, 11, 22,
@@ -240,7 +240,7 @@ prism54_get_wireless_stats(struct net_device *ndev)
 
 static int
 prism54_commit(struct net_device *ndev, struct iw_request_info *info,
-	       char *cwrq, char *extra)
+	       union iwreq_data *cwrq, char *extra)
 {
 	islpci_private *priv = netdev_priv(ndev);
 
@@ -256,8 +256,9 @@ prism54_commit(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_name(struct net_device *ndev, struct iw_request_info *info,
-		 char *cwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	char *cwrq = wrqu->name;
 	islpci_private *priv = netdev_priv(ndev);
 	char *capabilities;
 	union oid_res_t r;
@@ -287,8 +288,9 @@ prism54_get_name(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_freq(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_freq *fwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *fwrq = &wrqu->freq;
 	islpci_private *priv = netdev_priv(ndev);
 	int rvalue;
 	u32 c;
@@ -307,8 +309,9 @@ prism54_set_freq(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_freq(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_freq *fwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *fwrq = &wrqu->freq;
 	islpci_private *priv = netdev_priv(ndev);
 	union oid_res_t r;
 	int rvalue;
@@ -324,8 +327,9 @@ prism54_get_freq(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_mode(struct net_device *ndev, struct iw_request_info *info,
-		 __u32 * uwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	__u32 *uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 	u32 mlmeautolevel = CARD_DEFAULT_MLME_MODE;
 
@@ -368,8 +372,9 @@ prism54_set_mode(struct net_device *ndev, struct iw_request_info *info,
 /* Use mib cache */
 static int
 prism54_get_mode(struct net_device *ndev, struct iw_request_info *info,
-		 __u32 * uwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	__u32 *uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 
 	BUG_ON((priv->iw_mode < IW_MODE_AUTO) || (priv->iw_mode >
@@ -386,8 +391,9 @@ prism54_get_mode(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_sens(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_param *vwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->sens;
 	islpci_private *priv = netdev_priv(ndev);
 	u32 sens;
 
@@ -399,8 +405,9 @@ prism54_set_sens(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_sens(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_param *vwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->sens;
 	islpci_private *priv = netdev_priv(ndev);
 	union oid_res_t r;
 	int rvalue;
@@ -416,8 +423,9 @@ prism54_get_sens(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_range(struct net_device *ndev, struct iw_request_info *info,
-		  struct iw_point *dwrq, char *extra)
+		  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	struct iw_range *range = (struct iw_range *) extra;
 	islpci_private *priv = netdev_priv(ndev);
 	u8 *data;
@@ -521,8 +529,9 @@ prism54_get_range(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_wap(struct net_device *ndev, struct iw_request_info *info,
-		struct sockaddr *awrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	struct sockaddr *awrq = &wrqu->ap_addr;
 	islpci_private *priv = netdev_priv(ndev);
 	char bssid[6];
 	int rvalue;
@@ -543,8 +552,9 @@ prism54_set_wap(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_wap(struct net_device *ndev, struct iw_request_info *info,
-		struct sockaddr *awrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	struct sockaddr *awrq = &wrqu->ap_addr;
 	islpci_private *priv = netdev_priv(ndev);
 	union oid_res_t r;
 	int rvalue;
@@ -559,7 +569,7 @@ prism54_get_wap(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_scan(struct net_device *dev, struct iw_request_info *info,
-		 struct iw_param *vwrq, char *extra)
+		 union iwreq_data *vwrq, char *extra)
 {
 	/* hehe the device does this automagicaly */
 	return 0;
@@ -679,8 +689,9 @@ prism54_translate_bss(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_scan(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_point *dwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	int i, rvalue;
 	struct obj_bsslist *bsslist;
@@ -733,8 +744,9 @@ prism54_get_scan(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_essid(struct net_device *ndev, struct iw_request_info *info,
-		  struct iw_point *dwrq, char *extra)
+		  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	struct obj_ssid essid;
 
@@ -760,8 +772,9 @@ prism54_set_essid(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_essid(struct net_device *ndev, struct iw_request_info *info,
-		  struct iw_point *dwrq, char *extra)
+		  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	struct obj_ssid *essid;
 	union oid_res_t r;
@@ -790,8 +803,9 @@ prism54_get_essid(struct net_device *ndev, struct iw_request_info *info,
  */
 static int
 prism54_set_nick(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_point *dwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 
 	if (dwrq->length > IW_ESSID_MAX_SIZE)
@@ -807,8 +821,9 @@ prism54_set_nick(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_nick(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_point *dwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 
 	dwrq->length = 0;
@@ -826,9 +841,9 @@ prism54_get_nick(struct net_device *ndev, struct iw_request_info *info,
 static int
 prism54_set_rate(struct net_device *ndev,
 		 struct iw_request_info *info,
-		 struct iw_param *vwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
-
+	struct iw_param *vwrq = &wrqu->bitrate;
 	islpci_private *priv = netdev_priv(ndev);
 	u32 rate, profile;
 	char *data;
@@ -899,8 +914,9 @@ prism54_set_rate(struct net_device *ndev,
 static int
 prism54_get_rate(struct net_device *ndev,
 		 struct iw_request_info *info,
-		 struct iw_param *vwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->bitrate;
 	islpci_private *priv = netdev_priv(ndev);
 	int rvalue;
 	char *data;
@@ -926,8 +942,9 @@ prism54_get_rate(struct net_device *ndev,
 
 static int
 prism54_set_rts(struct net_device *ndev, struct iw_request_info *info,
-		struct iw_param *vwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->rts;
 	islpci_private *priv = netdev_priv(ndev);
 
 	return mgt_set_request(priv, DOT11_OID_RTSTHRESH, 0, &vwrq->value);
@@ -935,8 +952,9 @@ prism54_set_rts(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_rts(struct net_device *ndev, struct iw_request_info *info,
-		struct iw_param *vwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->rts;
 	islpci_private *priv = netdev_priv(ndev);
 	union oid_res_t r;
 	int rvalue;
@@ -950,8 +968,9 @@ prism54_get_rts(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_frag(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_param *vwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->frag;
 	islpci_private *priv = netdev_priv(ndev);
 
 	return mgt_set_request(priv, DOT11_OID_FRAGTHRESH, 0, &vwrq->value);
@@ -959,8 +978,9 @@ prism54_set_frag(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_frag(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_param *vwrq, char *extra)
+		 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->frag;
 	islpci_private *priv = netdev_priv(ndev);
 	union oid_res_t r;
 	int rvalue;
@@ -980,8 +1000,9 @@ prism54_get_frag(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_retry(struct net_device *ndev, struct iw_request_info *info,
-		  struct iw_param *vwrq, char *extra)
+		  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->retry;
 	islpci_private *priv = netdev_priv(ndev);
 	u32 slimit = 0, llimit = 0;	/* short and long limit */
 	u32 lifetime = 0;
@@ -1022,8 +1043,9 @@ prism54_set_retry(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_retry(struct net_device *ndev, struct iw_request_info *info,
-		  struct iw_param *vwrq, char *extra)
+		  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->retry;
 	islpci_private *priv = netdev_priv(ndev);
 	union oid_res_t r;
 	int rvalue = 0;
@@ -1054,8 +1076,9 @@ prism54_get_retry(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_encode(struct net_device *ndev, struct iw_request_info *info,
-		   struct iw_point *dwrq, char *extra)
+		   union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	int rvalue = 0, force = 0;
 	int authen = DOT11_AUTH_OS, invoke = 0, exunencrypt = 0;
@@ -1155,8 +1178,9 @@ prism54_set_encode(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_encode(struct net_device *ndev, struct iw_request_info *info,
-		   struct iw_point *dwrq, char *extra)
+		   union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	struct obj_key *key;
 	u32 devindex, index = (dwrq->flags & IW_ENCODE_INDEX) - 1;
@@ -1203,8 +1227,9 @@ prism54_get_encode(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_txpower(struct net_device *ndev, struct iw_request_info *info,
-		    struct iw_param *vwrq, char *extra)
+		    union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->txpower;
 	islpci_private *priv = netdev_priv(ndev);
 	union oid_res_t r;
 	int rvalue;
@@ -1223,8 +1248,9 @@ prism54_get_txpower(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_txpower(struct net_device *ndev, struct iw_request_info *info,
-		    struct iw_param *vwrq, char *extra)
+		    union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->txpower;
 	islpci_private *priv = netdev_priv(ndev);
 	s32 u = vwrq->value;
 
@@ -1249,8 +1275,9 @@ prism54_set_txpower(struct net_device *ndev, struct iw_request_info *info,
 
 static int prism54_set_genie(struct net_device *ndev,
 			     struct iw_request_info *info,
-			     struct iw_point *data, char *extra)
+			     union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	int alen, ret = 0;
 	struct obj_attachment *attach;
@@ -1298,8 +1325,9 @@ static int prism54_set_genie(struct net_device *ndev,
 
 static int prism54_get_genie(struct net_device *ndev,
 			     struct iw_request_info *info,
-			     struct iw_point *data, char *extra)
+			     union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	int len = priv->wpa_ie_len;
 
@@ -1739,7 +1767,7 @@ out:
 
 static int
 prism54_reset(struct net_device *ndev, struct iw_request_info *info,
-	      __u32 * uwrq, char *extra)
+	      union iwreq_data * uwrq, char *extra)
 {
 	islpci_reset(netdev_priv(ndev), 0);
 
@@ -1748,8 +1776,9 @@ prism54_reset(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_oid(struct net_device *ndev, struct iw_request_info *info,
-		struct iw_point *dwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	union oid_res_t r;
 	int rvalue;
 	enum oid_num_t n = dwrq->flags;
@@ -1763,8 +1792,9 @@ prism54_get_oid(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_u32(struct net_device *ndev, struct iw_request_info *info,
-		__u32 * uwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	u32 oid = uwrq[0], u = uwrq[1];
 
 	return mgt_set_request(netdev_priv(ndev), oid, 0, &u);
@@ -1772,8 +1802,9 @@ prism54_set_u32(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_raw(struct net_device *ndev, struct iw_request_info *info,
-		struct iw_point *dwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	u32 oid = dwrq->flags;
 
 	return mgt_set_request(netdev_priv(ndev), oid, 0, extra);
@@ -1819,7 +1850,7 @@ prism54_acl_clean(struct islpci_acl *acl)
 
 static int
 prism54_add_mac(struct net_device *ndev, struct iw_request_info *info,
-		struct sockaddr *awrq, char *extra)
+		union iwreq_data *awrq, char *extra)
 {
 	islpci_private *priv = netdev_priv(ndev);
 	struct islpci_acl *acl = &priv->acl;
@@ -1848,7 +1879,7 @@ prism54_add_mac(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_del_mac(struct net_device *ndev, struct iw_request_info *info,
-		struct sockaddr *awrq, char *extra)
+		union iwreq_data *awrq, char *extra)
 {
 	islpci_private *priv = netdev_priv(ndev);
 	struct islpci_acl *acl = &priv->acl;
@@ -1875,8 +1906,9 @@ prism54_del_mac(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_mac(struct net_device *ndev, struct iw_request_info *info,
-		struct iw_point *dwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *dwrq = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	struct islpci_acl *acl = &priv->acl;
 	struct mac_entry *entry;
@@ -1903,8 +1935,9 @@ prism54_get_mac(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_policy(struct net_device *ndev, struct iw_request_info *info,
-		   __u32 * uwrq, char *extra)
+		   union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 	struct islpci_acl *acl = &priv->acl;
 	u32 mlmeautolevel;
@@ -1939,8 +1972,9 @@ prism54_set_policy(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_policy(struct net_device *ndev, struct iw_request_info *info,
-		   __u32 * uwrq, char *extra)
+		   union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 	struct islpci_acl *acl = &priv->acl;
 
@@ -1979,7 +2013,7 @@ prism54_mac_accept(struct islpci_acl *acl, char *mac)
 
 static int
 prism54_kick_all(struct net_device *ndev, struct iw_request_info *info,
-		 struct iw_point *dwrq, char *extra)
+		 union iwreq_data *dwrq, char *extra)
 {
 	struct obj_mlme *mlme;
 	int rvalue;
@@ -1999,7 +2033,7 @@ prism54_kick_all(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_kick_mac(struct net_device *ndev, struct iw_request_info *info,
-		 struct sockaddr *awrq, char *extra)
+		 union iwreq_data *awrq, char *extra)
 {
 	struct obj_mlme *mlme;
 	struct sockaddr *addr = (struct sockaddr *) extra;
@@ -2085,8 +2119,7 @@ link_changed(struct net_device *ndev, u32 bitrate)
 		netif_carrier_on(ndev);
 		if (priv->iw_mode == IW_MODE_INFRA) {
 			union iwreq_data uwrq;
-			prism54_get_wap(ndev, NULL, (struct sockaddr *) &uwrq,
-					NULL);
+			prism54_get_wap(ndev, NULL, &uwrq, NULL);
 			wireless_send_event(ndev, SIOCGIWAP, &uwrq, NULL);
 		} else
 			send_simple_event(netdev_priv(ndev),
@@ -2498,8 +2531,9 @@ prism54_set_mac_address(struct net_device *ndev, void *addr)
 
 static int
 prism54_set_wpa(struct net_device *ndev, struct iw_request_info *info,
-		__u32 * uwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 	u32 mlme, authen, dot1x, filter, wep;
 
@@ -2542,8 +2576,9 @@ prism54_set_wpa(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_wpa(struct net_device *ndev, struct iw_request_info *info,
-		__u32 * uwrq, char *extra)
+		union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 	*uwrq = priv->wpa;
 	return 0;
@@ -2551,8 +2586,9 @@ prism54_get_wpa(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_set_prismhdr(struct net_device *ndev, struct iw_request_info *info,
-		     __u32 * uwrq, char *extra)
+		    union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 	priv->monitor_type =
 	    (*uwrq ? ARPHRD_IEEE80211_PRISM : ARPHRD_IEEE80211);
@@ -2564,8 +2600,9 @@ prism54_set_prismhdr(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_get_prismhdr(struct net_device *ndev, struct iw_request_info *info,
-		     __u32 * uwrq, char *extra)
+		    union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 	*uwrq = (priv->monitor_type == ARPHRD_IEEE80211_PRISM);
 	return 0;
@@ -2573,8 +2610,9 @@ prism54_get_prismhdr(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_debug_oid(struct net_device *ndev, struct iw_request_info *info,
-		  __u32 * uwrq, char *extra)
+		  union iwreq_data *wrqu, char *extra)
 {
+	__u32 * uwrq = &wrqu->mode;
 	islpci_private *priv = netdev_priv(ndev);
 
 	priv->priv_oid = *uwrq;
@@ -2585,8 +2623,9 @@ prism54_debug_oid(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_debug_get_oid(struct net_device *ndev, struct iw_request_info *info,
-		      struct iw_point *data, char *extra)
+		      union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	struct islpci_mgmtframe *response;
 	int ret = -EIO;
@@ -2621,8 +2660,9 @@ prism54_debug_get_oid(struct net_device *ndev, struct iw_request_info *info,
 
 static int
 prism54_debug_set_oid(struct net_device *ndev, struct iw_request_info *info,
-		      struct iw_point *data, char *extra)
+		      union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	islpci_private *priv = netdev_priv(ndev);
 	struct islpci_mgmtframe *response;
 	int ret = 0, response_op = PIMFOR_OP_ERROR;
@@ -2682,60 +2722,60 @@ prism54_set_spy(struct net_device *ndev,
 }
 
 static const iw_handler prism54_handler[] = {
-	(iw_handler) prism54_commit,	/* SIOCSIWCOMMIT */
-	(iw_handler) prism54_get_name,	/* SIOCGIWNAME */
-	(iw_handler) NULL,	/* SIOCSIWNWID */
-	(iw_handler) NULL,	/* SIOCGIWNWID */
-	(iw_handler) prism54_set_freq,	/* SIOCSIWFREQ */
-	(iw_handler) prism54_get_freq,	/* SIOCGIWFREQ */
-	(iw_handler) prism54_set_mode,	/* SIOCSIWMODE */
-	(iw_handler) prism54_get_mode,	/* SIOCGIWMODE */
-	(iw_handler) prism54_set_sens,	/* SIOCSIWSENS */
-	(iw_handler) prism54_get_sens,	/* SIOCGIWSENS */
-	(iw_handler) NULL,	/* SIOCSIWRANGE */
-	(iw_handler) prism54_get_range,	/* SIOCGIWRANGE */
-	(iw_handler) NULL,	/* SIOCSIWPRIV */
-	(iw_handler) NULL,	/* SIOCGIWPRIV */
-	(iw_handler) NULL,	/* SIOCSIWSTATS */
-	(iw_handler) NULL,	/* SIOCGIWSTATS */
+	prism54_commit,	/* SIOCSIWCOMMIT */
+	prism54_get_name,	/* SIOCGIWNAME */
+	NULL,	/* SIOCSIWNWID */
+	NULL,	/* SIOCGIWNWID */
+	prism54_set_freq,	/* SIOCSIWFREQ */
+	prism54_get_freq,	/* SIOCGIWFREQ */
+	prism54_set_mode,	/* SIOCSIWMODE */
+	prism54_get_mode,	/* SIOCGIWMODE */
+	prism54_set_sens,	/* SIOCSIWSENS */
+	prism54_get_sens,	/* SIOCGIWSENS */
+	NULL,	/* SIOCSIWRANGE */
+	prism54_get_range,	/* SIOCGIWRANGE */
+	NULL,	/* SIOCSIWPRIV */
+	NULL,	/* SIOCGIWPRIV */
+	NULL,	/* SIOCSIWSTATS */
+	NULL,	/* SIOCGIWSTATS */
 	prism54_set_spy,	/* SIOCSIWSPY */
 	iw_handler_get_spy,	/* SIOCGIWSPY */
 	iw_handler_set_thrspy,	/* SIOCSIWTHRSPY */
 	iw_handler_get_thrspy,	/* SIOCGIWTHRSPY */
-	(iw_handler) prism54_set_wap,	/* SIOCSIWAP */
-	(iw_handler) prism54_get_wap,	/* SIOCGIWAP */
-	(iw_handler) NULL,	/* -- hole -- */
-	(iw_handler) NULL,	/* SIOCGIWAPLIST deprecated */
-	(iw_handler) prism54_set_scan,	/* SIOCSIWSCAN */
-	(iw_handler) prism54_get_scan,	/* SIOCGIWSCAN */
-	(iw_handler) prism54_set_essid,	/* SIOCSIWESSID */
-	(iw_handler) prism54_get_essid,	/* SIOCGIWESSID */
-	(iw_handler) prism54_set_nick,	/* SIOCSIWNICKN */
-	(iw_handler) prism54_get_nick,	/* SIOCGIWNICKN */
-	(iw_handler) NULL,	/* -- hole -- */
-	(iw_handler) NULL,	/* -- hole -- */
-	(iw_handler) prism54_set_rate,	/* SIOCSIWRATE */
-	(iw_handler) prism54_get_rate,	/* SIOCGIWRATE */
-	(iw_handler) prism54_set_rts,	/* SIOCSIWRTS */
-	(iw_handler) prism54_get_rts,	/* SIOCGIWRTS */
-	(iw_handler) prism54_set_frag,	/* SIOCSIWFRAG */
-	(iw_handler) prism54_get_frag,	/* SIOCGIWFRAG */
-	(iw_handler) prism54_set_txpower,	/* SIOCSIWTXPOW */
-	(iw_handler) prism54_get_txpower,	/* SIOCGIWTXPOW */
-	(iw_handler) prism54_set_retry,	/* SIOCSIWRETRY */
-	(iw_handler) prism54_get_retry,	/* SIOCGIWRETRY */
-	(iw_handler) prism54_set_encode,	/* SIOCSIWENCODE */
-	(iw_handler) prism54_get_encode,	/* SIOCGIWENCODE */
-	(iw_handler) NULL,	/* SIOCSIWPOWER */
-	(iw_handler) NULL,	/* SIOCGIWPOWER */
+	prism54_set_wap,	/* SIOCSIWAP */
+	prism54_get_wap,	/* SIOCGIWAP */
+	NULL,	/* -- hole -- */
+	NULL,	/* SIOCGIWAPLIST deprecated */
+	prism54_set_scan,	/* SIOCSIWSCAN */
+	prism54_get_scan,	/* SIOCGIWSCAN */
+	prism54_set_essid,	/* SIOCSIWESSID */
+	prism54_get_essid,	/* SIOCGIWESSID */
+	prism54_set_nick,	/* SIOCSIWNICKN */
+	prism54_get_nick,	/* SIOCGIWNICKN */
+	NULL,	/* -- hole -- */
+	NULL,	/* -- hole -- */
+	prism54_set_rate,	/* SIOCSIWRATE */
+	prism54_get_rate,	/* SIOCGIWRATE */
+	prism54_set_rts,	/* SIOCSIWRTS */
+	prism54_get_rts,	/* SIOCGIWRTS */
+	prism54_set_frag,	/* SIOCSIWFRAG */
+	prism54_get_frag,	/* SIOCGIWFRAG */
+	prism54_set_txpower,	/* SIOCSIWTXPOW */
+	prism54_get_txpower,	/* SIOCGIWTXPOW */
+	prism54_set_retry,	/* SIOCSIWRETRY */
+	prism54_get_retry,	/* SIOCGIWRETRY */
+	prism54_set_encode,	/* SIOCSIWENCODE */
+	prism54_get_encode,	/* SIOCGIWENCODE */
+	NULL,	/* SIOCSIWPOWER */
+	NULL,	/* SIOCGIWPOWER */
 	NULL,			/* -- hole -- */
 	NULL,			/* -- hole -- */
-	(iw_handler) prism54_set_genie,	/* SIOCSIWGENIE */
-	(iw_handler) prism54_get_genie,	/* SIOCGIWGENIE */
-	(iw_handler) prism54_set_auth,	/* SIOCSIWAUTH */
-	(iw_handler) prism54_get_auth,	/* SIOCGIWAUTH */
-	(iw_handler) prism54_set_encodeext, /* SIOCSIWENCODEEXT */
-	(iw_handler) prism54_get_encodeext, /* SIOCGIWENCODEEXT */
+	prism54_set_genie,	/* SIOCSIWGENIE */
+	prism54_get_genie,	/* SIOCGIWGENIE */
+	prism54_set_auth,	/* SIOCSIWAUTH */
+	prism54_get_auth,	/* SIOCGIWAUTH */
+	prism54_set_encodeext, /* SIOCSIWENCODEEXT */
+	prism54_get_encodeext, /* SIOCGIWENCODEEXT */
 	NULL,			/* SIOCSIWPMKSA */
 };
 
@@ -2872,31 +2912,31 @@ static const struct iw_priv_args prism54_private_args[] = {
 };
 
 static const iw_handler prism54_private_handler[] = {
-	(iw_handler) prism54_reset,
-	(iw_handler) prism54_get_policy,
-	(iw_handler) prism54_set_policy,
-	(iw_handler) prism54_get_mac,
-	(iw_handler) prism54_add_mac,
-	(iw_handler) NULL,
-	(iw_handler) prism54_del_mac,
-	(iw_handler) NULL,
-	(iw_handler) prism54_kick_mac,
-	(iw_handler) NULL,
-	(iw_handler) prism54_kick_all,
-	(iw_handler) prism54_get_wpa,
-	(iw_handler) prism54_set_wpa,
-	(iw_handler) NULL,
-	(iw_handler) prism54_debug_oid,
-	(iw_handler) prism54_debug_get_oid,
-	(iw_handler) prism54_debug_set_oid,
-	(iw_handler) prism54_get_oid,
-	(iw_handler) prism54_set_u32,
-	(iw_handler) NULL,
-	(iw_handler) prism54_set_raw,
-	(iw_handler) NULL,
-	(iw_handler) prism54_set_raw,
-	(iw_handler) prism54_get_prismhdr,
-	(iw_handler) prism54_set_prismhdr,
+	prism54_reset,
+	prism54_get_policy,
+	prism54_set_policy,
+	prism54_get_mac,
+	prism54_add_mac,
+	NULL,
+	prism54_del_mac,
+	NULL,
+	prism54_kick_mac,
+	NULL,
+	prism54_kick_all,
+	prism54_get_wpa,
+	prism54_set_wpa,
+	NULL,
+	prism54_debug_oid,
+	prism54_debug_get_oid,
+	prism54_debug_set_oid,
+	prism54_get_oid,
+	prism54_set_u32,
+	NULL,
+	prism54_set_raw,
+	NULL,
+	prism54_set_raw,
+	prism54_get_prismhdr,
+	prism54_set_prismhdr,
 };
 
 const struct iw_handler_def prism54_handler_def = {
diff --git a/drivers/net/wireless/mac80211_hwsim.c b/drivers/net/wireless/mac80211_hwsim.c
index 8c35ac838..42033c181 100644
--- a/drivers/net/wireless/mac80211_hwsim.c
+++ b/drivers/net/wireless/mac80211_hwsim.c
@@ -3360,20 +3360,20 @@ static int __init init_mac80211_hwsim(void)
 	if (channels < 1)
 		return -EINVAL;
 
-	mac80211_hwsim_mchan_ops = mac80211_hwsim_ops;
-	mac80211_hwsim_mchan_ops.hw_scan = mac80211_hwsim_hw_scan;
-	mac80211_hwsim_mchan_ops.cancel_hw_scan = mac80211_hwsim_cancel_hw_scan;
-	mac80211_hwsim_mchan_ops.sw_scan_start = NULL;
-	mac80211_hwsim_mchan_ops.sw_scan_complete = NULL;
-	mac80211_hwsim_mchan_ops.remain_on_channel = mac80211_hwsim_roc;
-	mac80211_hwsim_mchan_ops.cancel_remain_on_channel = mac80211_hwsim_croc;
-	mac80211_hwsim_mchan_ops.add_chanctx = mac80211_hwsim_add_chanctx;
-	mac80211_hwsim_mchan_ops.remove_chanctx = mac80211_hwsim_remove_chanctx;
-	mac80211_hwsim_mchan_ops.change_chanctx = mac80211_hwsim_change_chanctx;
-	mac80211_hwsim_mchan_ops.assign_vif_chanctx =
-		mac80211_hwsim_assign_vif_chanctx;
-	mac80211_hwsim_mchan_ops.unassign_vif_chanctx =
-		mac80211_hwsim_unassign_vif_chanctx;
+	pax_open_kernel();
+	memcpy((void *)&mac80211_hwsim_mchan_ops, &mac80211_hwsim_ops, sizeof mac80211_hwsim_mchan_ops);
+	const_cast(mac80211_hwsim_mchan_ops.hw_scan) = mac80211_hwsim_hw_scan;
+	const_cast(mac80211_hwsim_mchan_ops.cancel_hw_scan) = mac80211_hwsim_cancel_hw_scan;
+	const_cast(mac80211_hwsim_mchan_ops.sw_scan_start) = NULL;
+	const_cast(mac80211_hwsim_mchan_ops.sw_scan_complete) = NULL;
+	const_cast(mac80211_hwsim_mchan_ops.remain_on_channel) = mac80211_hwsim_roc;
+	const_cast(mac80211_hwsim_mchan_ops.cancel_remain_on_channel) = mac80211_hwsim_croc;
+	const_cast(mac80211_hwsim_mchan_ops.add_chanctx) = mac80211_hwsim_add_chanctx;
+	const_cast(mac80211_hwsim_mchan_ops.remove_chanctx) = mac80211_hwsim_remove_chanctx;
+	const_cast(mac80211_hwsim_mchan_ops.change_chanctx) = mac80211_hwsim_change_chanctx;
+	const_cast(mac80211_hwsim_mchan_ops.assign_vif_chanctx) = mac80211_hwsim_assign_vif_chanctx;
+	const_cast(mac80211_hwsim_mchan_ops.unassign_vif_chanctx) = mac80211_hwsim_unassign_vif_chanctx;
+	pax_close_kernel();
 
 	spin_lock_init(&hwsim_radio_lock);
 	INIT_LIST_HEAD(&hwsim_radios);
diff --git a/drivers/net/wireless/marvell/mwifiex/main.c b/drivers/net/wireless/marvell/mwifiex/main.c
index 1afd6a94c..88fbd0175 100644
--- a/drivers/net/wireless/marvell/mwifiex/main.c
+++ b/drivers/net/wireless/marvell/mwifiex/main.c
@@ -814,7 +814,7 @@ mwifiex_clone_skb_for_tx_status(struct mwifiex_private *priv,
 /*
  * CFG802.11 network device handler for data transmission.
  */
-static int
+static netdev_tx_t
 mwifiex_hard_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct mwifiex_private *priv = mwifiex_netdev_get_priv(dev);
diff --git a/drivers/net/wireless/ralink/rt2x00/rt2400pci.c b/drivers/net/wireless/ralink/rt2x00/rt2400pci.c
index 155f34398..5db43e7ae 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt2400pci.c
+++ b/drivers/net/wireless/ralink/rt2x00/rt2400pci.c
@@ -54,7 +54,7 @@
 	rt2x00mmio_regbusy_read((__dev), RFCSR, RFCSR_BUSY, (__reg))
 
 static void rt2400pci_bbp_write(struct rt2x00_dev *rt2x00dev,
-				const unsigned int word, const u8 value)
+				const unsigned int word, u8 value)
 {
 	u32 reg;
 
@@ -109,7 +109,7 @@ static void rt2400pci_bbp_read(struct rt2x00_dev *rt2x00dev,
 }
 
 static void rt2400pci_rf_write(struct rt2x00_dev *rt2x00dev,
-			       const unsigned int word, const u32 value)
+			       const unsigned int word, u32 value)
 {
 	u32 reg;
 
diff --git a/drivers/net/wireless/ralink/rt2x00/rt2500pci.c b/drivers/net/wireless/ralink/rt2x00/rt2500pci.c
index 2553cdd74..6a60ef96f 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt2500pci.c
+++ b/drivers/net/wireless/ralink/rt2x00/rt2500pci.c
@@ -54,7 +54,7 @@
 	rt2x00mmio_regbusy_read((__dev), RFCSR, RFCSR_BUSY, (__reg))
 
 static void rt2500pci_bbp_write(struct rt2x00_dev *rt2x00dev,
-				const unsigned int word, const u8 value)
+				const unsigned int word, u8 value)
 {
 	u32 reg;
 
@@ -109,7 +109,7 @@ static void rt2500pci_bbp_read(struct rt2x00_dev *rt2x00dev,
 }
 
 static void rt2500pci_rf_write(struct rt2x00_dev *rt2x00dev,
-			       const unsigned int word, const u32 value)
+			       const unsigned int word, u32 value)
 {
 	u32 reg;
 
diff --git a/drivers/net/wireless/ralink/rt2x00/rt2500usb.c b/drivers/net/wireless/ralink/rt2x00/rt2500usb.c
index 2d64611de..66754f4e0 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt2500usb.c
+++ b/drivers/net/wireless/ralink/rt2x00/rt2500usb.c
@@ -142,7 +142,7 @@ static int rt2500usb_regbusy_read(struct rt2x00_dev *rt2x00dev,
 	rt2500usb_regbusy_read((__dev), PHY_CSR10, PHY_CSR10_RF_BUSY, (__reg))
 
 static void rt2500usb_bbp_write(struct rt2x00_dev *rt2x00dev,
-				const unsigned int word, const u8 value)
+				const unsigned int word, u8 value)
 {
 	u16 reg;
 
@@ -196,7 +196,7 @@ static void rt2500usb_bbp_read(struct rt2x00_dev *rt2x00dev,
 }
 
 static void rt2500usb_rf_write(struct rt2x00_dev *rt2x00dev,
-			       const unsigned int word, const u32 value)
+			       const unsigned int word, u32 value)
 {
 	u16 reg;
 
diff --git a/drivers/net/wireless/ralink/rt2x00/rt2800lib.c b/drivers/net/wireless/ralink/rt2x00/rt2800lib.c
index bf3f0a399..9d2a6d000 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt2800lib.c
+++ b/drivers/net/wireless/ralink/rt2x00/rt2800lib.c
@@ -83,7 +83,7 @@ static inline bool rt2800_is_305x_soc(struct rt2x00_dev *rt2x00dev)
 }
 
 static void rt2800_bbp_write(struct rt2x00_dev *rt2x00dev,
-			     const unsigned int word, const u8 value)
+			     const unsigned int word, u8 value)
 {
 	u32 reg;
 
@@ -140,7 +140,7 @@ static void rt2800_bbp_read(struct rt2x00_dev *rt2x00dev,
 }
 
 static void rt2800_rfcsr_write(struct rt2x00_dev *rt2x00dev,
-			       const unsigned int word, const u8 value)
+			       const unsigned int word, u8 value)
 {
 	u32 reg;
 
@@ -195,7 +195,7 @@ static void rt2800_rfcsr_read(struct rt2x00_dev *rt2x00dev,
 }
 
 static void rt2800_rf_write(struct rt2x00_dev *rt2x00dev,
-			    const unsigned int word, const u32 value)
+			    const unsigned int word, u32 value)
 {
 	u32 reg;
 
diff --git a/drivers/net/wireless/ralink/rt2x00/rt2x00.h b/drivers/net/wireless/ralink/rt2x00/rt2x00.h
index f68d49212..38ba52d16 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt2x00.h
+++ b/drivers/net/wireless/ralink/rt2x00/rt2x00.h
@@ -378,7 +378,7 @@ struct rt2x00_intf {
 	 * for hardware which doesn't support hardware
 	 * sequence counting.
 	 */
-	atomic_t seqno;
+	atomic_unchecked_t seqno;
 };
 
 static inline struct rt2x00_intf* vif_to_intf(struct ieee80211_vif *vif)
diff --git a/drivers/net/wireless/ralink/rt2x00/rt2x00queue.c b/drivers/net/wireless/ralink/rt2x00/rt2x00queue.c
index 68b620b24..92ecd9ef7 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt2x00queue.c
+++ b/drivers/net/wireless/ralink/rt2x00/rt2x00queue.c
@@ -224,9 +224,9 @@ static void rt2x00queue_create_tx_descriptor_seq(struct rt2x00_dev *rt2x00dev,
 	 * sequence counter given by mac80211.
 	 */
 	if (test_bit(ENTRY_TXD_FIRST_FRAGMENT, &txdesc->flags))
-		seqno = atomic_add_return(0x10, &intf->seqno);
+		seqno = atomic_add_return_unchecked(0x10, &intf->seqno);
 	else
-		seqno = atomic_read(&intf->seqno);
+		seqno = atomic_read_unchecked(&intf->seqno);
 
 	hdr->seq_ctrl &= cpu_to_le16(IEEE80211_SCTL_FRAG);
 	hdr->seq_ctrl |= cpu_to_le16(seqno);
diff --git a/drivers/net/wireless/ralink/rt2x00/rt61pci.c b/drivers/net/wireless/ralink/rt2x00/rt61pci.c
index 1c4226701..e80c54bed 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt61pci.c
+++ b/drivers/net/wireless/ralink/rt2x00/rt61pci.c
@@ -63,7 +63,7 @@ MODULE_PARM_DESC(nohwcrypt, "Disable hardware encryption.");
 				H2M_MAILBOX_CSR_OWNER, (__reg))
 
 static void rt61pci_bbp_write(struct rt2x00_dev *rt2x00dev,
-			      const unsigned int word, const u8 value)
+			      const unsigned int word, u8 value)
 {
 	u32 reg;
 
@@ -118,7 +118,7 @@ static void rt61pci_bbp_read(struct rt2x00_dev *rt2x00dev,
 }
 
 static void rt61pci_rf_write(struct rt2x00_dev *rt2x00dev,
-			     const unsigned int word, const u32 value)
+			     const unsigned int word, u32 value)
 {
 	u32 reg;
 
diff --git a/drivers/net/wireless/ralink/rt2x00/rt73usb.c b/drivers/net/wireless/ralink/rt2x00/rt73usb.c
index 903cc6f67..d2029ec11 100644
--- a/drivers/net/wireless/ralink/rt2x00/rt73usb.c
+++ b/drivers/net/wireless/ralink/rt2x00/rt73usb.c
@@ -61,7 +61,7 @@ MODULE_PARM_DESC(nohwcrypt, "Disable hardware encryption.");
 	rt2x00usb_regbusy_read((__dev), PHY_CSR4, PHY_CSR4_BUSY, (__reg))
 
 static void rt73usb_bbp_write(struct rt2x00_dev *rt2x00dev,
-			      const unsigned int word, const u8 value)
+			      const unsigned int word, u8 value)
 {
 	u32 reg;
 
@@ -116,7 +116,7 @@ static void rt73usb_bbp_read(struct rt2x00_dev *rt2x00dev,
 }
 
 static void rt73usb_rf_write(struct rt2x00_dev *rt2x00dev,
-			     const unsigned int word, const u32 value)
+			     const unsigned int word, u32 value)
 {
 	u32 reg;
 
diff --git a/drivers/net/wireless/realtek/rtlwifi/base.c b/drivers/net/wireless/realtek/rtlwifi/base.c
index 4ac928bf1..9832ba83b 100644
--- a/drivers/net/wireless/realtek/rtlwifi/base.c
+++ b/drivers/net/wireless/realtek/rtlwifi/base.c
@@ -467,15 +467,15 @@ static void _rtl_init_deferred_work(struct ieee80211_hw *hw)
 	rtlpriv->works.hw = hw;
 	rtlpriv->works.rtl_wq = alloc_workqueue("%s", 0, 0, rtlpriv->cfg->name);
 	INIT_DELAYED_WORK(&rtlpriv->works.watchdog_wq,
-			  (void *)rtl_watchdog_wq_callback);
+			  rtl_watchdog_wq_callback);
 	INIT_DELAYED_WORK(&rtlpriv->works.ips_nic_off_wq,
-			  (void *)rtl_ips_nic_off_wq_callback);
+			  rtl_ips_nic_off_wq_callback);
 	INIT_DELAYED_WORK(&rtlpriv->works.ps_work,
-			  (void *)rtl_swlps_wq_callback);
+			  rtl_swlps_wq_callback);
 	INIT_DELAYED_WORK(&rtlpriv->works.ps_rfon_wq,
-			  (void *)rtl_swlps_rfon_wq_callback);
+			  rtl_swlps_rfon_wq_callback);
 	INIT_DELAYED_WORK(&rtlpriv->works.fwevt_wq,
-			  (void *)rtl_fwevt_wq_callback);
+			  rtl_fwevt_wq_callback);
 
 }
 
@@ -1559,7 +1559,7 @@ void rtl_beacon_statistic(struct ieee80211_hw *hw, struct sk_buff *skb)
 }
 EXPORT_SYMBOL_GPL(rtl_beacon_statistic);
 
-void rtl_watchdog_wq_callback(void *data)
+void rtl_watchdog_wq_callback(struct work_struct *data)
 {
 	struct rtl_works *rtlworks = container_of_dwork_rtl(data,
 							    struct rtl_works,
@@ -1722,7 +1722,7 @@ void rtl_watch_dog_timer_callback(unsigned long data)
 	mod_timer(&rtlpriv->works.watchdog_timer,
 		  jiffies + MSECS(RTL_WATCH_DOG_TIME));
 }
-void rtl_fwevt_wq_callback(void *data)
+void rtl_fwevt_wq_callback(struct work_struct *data)
 {
 	struct rtl_works *rtlworks =
 		container_of_dwork_rtl(data, struct rtl_works, fwevt_wq);
diff --git a/drivers/net/wireless/realtek/rtlwifi/base.h b/drivers/net/wireless/realtek/rtlwifi/base.h
index 74233d601..482e49556 100644
--- a/drivers/net/wireless/realtek/rtlwifi/base.h
+++ b/drivers/net/wireless/realtek/rtlwifi/base.h
@@ -134,8 +134,8 @@ int rtl_rx_agg_start(struct ieee80211_hw *hw,
 		     struct ieee80211_sta *sta, u16 tid);
 int rtl_rx_agg_stop(struct ieee80211_hw *hw,
 		    struct ieee80211_sta *sta, u16 tid);
-void rtl_watchdog_wq_callback(void *data);
-void rtl_fwevt_wq_callback(void *data);
+void rtl_watchdog_wq_callback(struct work_struct *data);
+void rtl_fwevt_wq_callback(struct work_struct *data);
 
 void rtl_get_tcb_desc(struct ieee80211_hw *hw,
 		      struct ieee80211_tx_info *info,
diff --git a/drivers/net/wireless/realtek/rtlwifi/pci.c b/drivers/net/wireless/realtek/rtlwifi/pci.c
index e538e23ba..9e24271aa 100644
--- a/drivers/net/wireless/realtek/rtlwifi/pci.c
+++ b/drivers/net/wireless/realtek/rtlwifi/pci.c
@@ -1094,13 +1094,16 @@ done:
 	return ret;
 }
 
-static void _rtl_pci_irq_tasklet(struct ieee80211_hw *hw)
+static void _rtl_pci_irq_tasklet(unsigned long _hw)
 {
+	struct ieee80211_hw *hw = (struct ieee80211_hw *)_hw;
+
 	_rtl_pci_tx_chk_waitq(hw);
 }
 
-static void _rtl_pci_prepare_bcn_tasklet(struct ieee80211_hw *hw)
+static void _rtl_pci_prepare_bcn_tasklet(unsigned long _hw)
 {
+	struct ieee80211_hw *hw = (struct ieee80211_hw *)_hw;
 	struct rtl_priv *rtlpriv = rtl_priv(hw);
 	struct rtl_pci *rtlpci = rtl_pcidev(rtl_pcipriv(hw));
 	struct rtl_mac *mac = rtl_mac(rtl_priv(hw));
@@ -1221,12 +1224,8 @@ static void _rtl_pci_init_struct(struct ieee80211_hw *hw,
 	rtlpci->acm_method = EACMWAY2_SW;
 
 	/*task */
-	tasklet_init(&rtlpriv->works.irq_tasklet,
-		     (void (*)(unsigned long))_rtl_pci_irq_tasklet,
-		     (unsigned long)hw);
-	tasklet_init(&rtlpriv->works.irq_prepare_bcn_tasklet,
-		     (void (*)(unsigned long))_rtl_pci_prepare_bcn_tasklet,
-		     (unsigned long)hw);
+	tasklet_init(&rtlpriv->works.irq_tasklet, _rtl_pci_irq_tasklet, (unsigned long)hw);
+	tasklet_init(&rtlpriv->works.irq_prepare_bcn_tasklet, _rtl_pci_prepare_bcn_tasklet, (unsigned long)hw);
 	INIT_WORK(&rtlpriv->works.lps_change_work,
 		  rtl_lps_change_work_callback);
 }
diff --git a/drivers/net/wireless/realtek/rtlwifi/ps.c b/drivers/net/wireless/realtek/rtlwifi/ps.c
index 424e26293..6b1ade8bb 100644
--- a/drivers/net/wireless/realtek/rtlwifi/ps.c
+++ b/drivers/net/wireless/realtek/rtlwifi/ps.c
@@ -198,7 +198,7 @@ static void _rtl_ps_inactive_ps(struct ieee80211_hw *hw)
 	ppsc->swrf_processing = false;
 }
 
-void rtl_ips_nic_off_wq_callback(void *data)
+void rtl_ips_nic_off_wq_callback(struct work_struct *data)
 {
 	struct rtl_works *rtlworks =
 	    container_of_dwork_rtl(data, struct rtl_works, ips_nic_off_wq);
@@ -582,7 +582,7 @@ void rtl_swlps_rf_awake(struct ieee80211_hw *hw)
 	spin_unlock_irqrestore(&rtlpriv->locks.lps_lock, flag);
 }
 
-void rtl_swlps_rfon_wq_callback(void *data)
+void rtl_swlps_rfon_wq_callback(struct work_struct *data)
 {
 	struct rtl_works *rtlworks =
 	    container_of_dwork_rtl(data, struct rtl_works, ps_rfon_wq);
@@ -696,7 +696,7 @@ void rtl_lps_leave(struct ieee80211_hw *hw)
 }
 EXPORT_SYMBOL_GPL(rtl_lps_leave);
 
-void rtl_swlps_wq_callback(void *data)
+void rtl_swlps_wq_callback(struct work_struct *data)
 {
 	struct rtl_works *rtlworks = container_of_dwork_rtl(data,
 				     struct rtl_works,
diff --git a/drivers/net/wireless/realtek/rtlwifi/ps.h b/drivers/net/wireless/realtek/rtlwifi/ps.h
index 0df2b5203..0607d337a 100644
--- a/drivers/net/wireless/realtek/rtlwifi/ps.h
+++ b/drivers/net/wireless/realtek/rtlwifi/ps.h
@@ -32,15 +32,15 @@ bool rtl_ps_enable_nic(struct ieee80211_hw *hw);
 bool rtl_ps_disable_nic(struct ieee80211_hw *hw);
 void rtl_ips_nic_off(struct ieee80211_hw *hw);
 void rtl_ips_nic_on(struct ieee80211_hw *hw);
-void rtl_ips_nic_off_wq_callback(void *data);
+void rtl_ips_nic_off_wq_callback(struct work_struct *data);
 void rtl_lps_enter(struct ieee80211_hw *hw);
 void rtl_lps_leave(struct ieee80211_hw *hw);
 
 void rtl_lps_set_psmode(struct ieee80211_hw *hw, u8 rt_psmode);
 
 void rtl_swlps_beacon(struct ieee80211_hw *hw, void *data, unsigned int len);
-void rtl_swlps_wq_callback(void *data);
-void rtl_swlps_rfon_wq_callback(void *data);
+void rtl_swlps_wq_callback(struct work_struct *data);
+void rtl_swlps_rfon_wq_callback(struct work_struct *data);
 void rtl_swlps_rf_awake(struct ieee80211_hw *hw);
 void rtl_swlps_rf_sleep(struct ieee80211_hw *hw);
 void rtl_p2p_ps_cmd(struct ieee80211_hw *hw , u8 p2p_ps_state);
diff --git a/drivers/net/wireless/ti/wl1251/sdio.c b/drivers/net/wireless/ti/wl1251/sdio.c
index b661f896e..ebea675a3 100644
--- a/drivers/net/wireless/ti/wl1251/sdio.c
+++ b/drivers/net/wireless/ti/wl1251/sdio.c
@@ -282,13 +282,17 @@ static int wl1251_sdio_probe(struct sdio_func *func,
 
 		irq_set_irq_type(wl->irq, IRQ_TYPE_EDGE_RISING);
 
-		wl1251_sdio_ops.enable_irq = wl1251_enable_line_irq;
-		wl1251_sdio_ops.disable_irq = wl1251_disable_line_irq;
+		pax_open_kernel();
+		const_cast(wl1251_sdio_ops.enable_irq) = wl1251_enable_line_irq;
+		const_cast(wl1251_sdio_ops.disable_irq) = wl1251_disable_line_irq;
+		pax_close_kernel();
 
 		wl1251_info("using dedicated interrupt line");
 	} else {
-		wl1251_sdio_ops.enable_irq = wl1251_sdio_enable_irq;
-		wl1251_sdio_ops.disable_irq = wl1251_sdio_disable_irq;
+		pax_open_kernel();
+		const_cast(wl1251_sdio_ops.enable_irq) = wl1251_sdio_enable_irq;
+		const_cast(wl1251_sdio_ops.disable_irq) = wl1251_sdio_disable_irq;
+		pax_close_kernel();
 
 		wl1251_info("using SDIO interrupt");
 	}
diff --git a/drivers/net/wireless/ti/wl12xx/main.c b/drivers/net/wireless/ti/wl12xx/main.c
index 29f13f890..adfe3cf80 100644
--- a/drivers/net/wireless/ti/wl12xx/main.c
+++ b/drivers/net/wireless/ti/wl12xx/main.c
@@ -656,7 +656,9 @@ static int wl12xx_identify_chip(struct wl1271 *wl)
 		       sizeof(wl->conf.mem));
 
 		/* read data preparation is only needed by wl127x */
-		wl->ops->prepare_read = wl127x_prepare_read;
+		pax_open_kernel();
+		const_cast(wl->ops->prepare_read) = wl127x_prepare_read;
+		pax_close_kernel();
 
 		wlcore_set_min_fw_ver(wl, WL127X_CHIP_VER,
 			      WL127X_IFTYPE_SR_VER,  WL127X_MAJOR_SR_VER,
@@ -681,7 +683,9 @@ static int wl12xx_identify_chip(struct wl1271 *wl)
 		       sizeof(wl->conf.mem));
 
 		/* read data preparation is only needed by wl127x */
-		wl->ops->prepare_read = wl127x_prepare_read;
+		pax_open_kernel();
+		const_cast(wl->ops->prepare_read) = wl127x_prepare_read;
+		pax_close_kernel();
 
 		wlcore_set_min_fw_ver(wl, WL127X_CHIP_VER,
 			      WL127X_IFTYPE_SR_VER,  WL127X_MAJOR_SR_VER,
diff --git a/drivers/net/wireless/ti/wl18xx/main.c b/drivers/net/wireless/ti/wl18xx/main.c
index 3f451467f..b936ca432 100644
--- a/drivers/net/wireless/ti/wl18xx/main.c
+++ b/drivers/net/wireless/ti/wl18xx/main.c
@@ -2031,8 +2031,10 @@ static int wl18xx_setup(struct wl1271 *wl)
 	}
 
 	if (!checksum_param) {
-		wl18xx_ops.set_rx_csum = NULL;
-		wl18xx_ops.init_vif = NULL;
+		pax_open_kernel();
+		const_cast(wl18xx_ops.set_rx_csum) = NULL;
+		const_cast(wl18xx_ops.init_vif) = NULL;
+		pax_close_kernel();
 	}
 
 	/* Enable 11a Band only if we have 5G antennas */
diff --git a/drivers/net/wireless/zydas/zd1201.c b/drivers/net/wireless/zydas/zd1201.c
index 799f70f2d..0c4b5d173 100644
--- a/drivers/net/wireless/zydas/zd1201.c
+++ b/drivers/net/wireless/zydas/zd1201.c
@@ -890,7 +890,7 @@ static void zd1201_set_multicast(struct net_device *dev)
 }
 
 static int zd1201_config_commit(struct net_device *dev, 
-    struct iw_request_info *info, struct iw_point *data, char *essid)
+    struct iw_request_info *info, union iwreq_data *data, char *essid)
 {
 	struct zd1201 *zd = netdev_priv(dev);
 
@@ -898,15 +898,18 @@ static int zd1201_config_commit(struct net_device *dev,
 }
 
 static int zd1201_get_name(struct net_device *dev,
-    struct iw_request_info *info, char *name, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	char *name = wrqu->name;
+
 	strcpy(name, "IEEE 802.11b");
 	return 0;
 }
 
 static int zd1201_set_freq(struct net_device *dev,
-    struct iw_request_info *info, struct iw_freq *freq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *freq = &wrqu->freq;
 	struct zd1201 *zd = netdev_priv(dev);
 	short channel = 0;
 	int err;
@@ -926,8 +929,9 @@ static int zd1201_set_freq(struct net_device *dev,
 }
 
 static int zd1201_get_freq(struct net_device *dev,
-    struct iw_request_info *info, struct iw_freq *freq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *freq = &wrqu->freq;
 	struct zd1201 *zd = netdev_priv(dev);
 	short channel;
 	int err;
@@ -942,8 +946,9 @@ static int zd1201_get_freq(struct net_device *dev,
 }
 
 static int zd1201_set_mode(struct net_device *dev,
-    struct iw_request_info *info, __u32 *mode, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	__u32 *mode = &wrqu->mode;
 	struct zd1201 *zd = netdev_priv(dev);
 	short porttype, monitor = 0;
 	unsigned char buffer[IW_ESSID_MAX_SIZE+2];
@@ -1004,8 +1009,9 @@ static int zd1201_set_mode(struct net_device *dev,
 }
 
 static int zd1201_get_mode(struct net_device *dev,
-    struct iw_request_info *info, __u32 *mode, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	__u32 *mode = &wrqu->mode;
 	struct zd1201 *zd = netdev_priv(dev);
 	short porttype;
 	int err;
@@ -1041,8 +1047,9 @@ static int zd1201_get_mode(struct net_device *dev,
 }
 
 static int zd1201_get_range(struct net_device *dev,
-    struct iw_request_info *info, struct iw_point *wrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *wrq = &wrqu->data;
 	struct iw_range *range = (struct iw_range *)extra;
 
 	wrq->length = sizeof(struct iw_range);
@@ -1080,8 +1087,9 @@ static int zd1201_get_range(struct net_device *dev,
  *	the stats after asking the bssid.
  */
 static int zd1201_get_wap(struct net_device *dev,
-    struct iw_request_info *info, struct sockaddr *ap_addr, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct sockaddr *ap_addr = &wrqu->ap_addr;
 	struct zd1201 *zd = netdev_priv(dev);
 	unsigned char buffer[6];
 
@@ -1101,15 +1109,16 @@ static int zd1201_get_wap(struct net_device *dev,
 }
 
 static int zd1201_set_scan(struct net_device *dev,
-    struct iw_request_info *info, struct iw_point *srq, char *extra)
+    struct iw_request_info *info, union iwreq_data *srq, char *extra)
 {
 	/* We do everything in get_scan */
 	return 0;
 }
 
 static int zd1201_get_scan(struct net_device *dev,
-    struct iw_request_info *info, struct iw_point *srq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *srq = &wrqu->data;
 	struct zd1201 *zd = netdev_priv(dev);
 	int err, i, j, enabled_save;
 	struct iw_event iwe;
@@ -1200,8 +1209,9 @@ static int zd1201_get_scan(struct net_device *dev,
 }
 
 static int zd1201_set_essid(struct net_device *dev,
-    struct iw_request_info *info, struct iw_point *data, char *essid)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *essid)
 {
+	struct iw_point *data = &wrqu->essid;
 	struct zd1201 *zd = netdev_priv(dev);
 
 	if (data->length > IW_ESSID_MAX_SIZE)
@@ -1215,8 +1225,9 @@ static int zd1201_set_essid(struct net_device *dev,
 }
 
 static int zd1201_get_essid(struct net_device *dev,
-    struct iw_request_info *info, struct iw_point *data, char *essid)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *essid)
 {
+	struct iw_point *data = &wrqu->essid;
 	struct zd1201 *zd = netdev_priv(dev);
 
 	memcpy(essid, zd->essid, zd->essidlen);
@@ -1227,8 +1238,10 @@ static int zd1201_get_essid(struct net_device *dev,
 }
 
 static int zd1201_get_nick(struct net_device *dev, struct iw_request_info *info,
-    struct iw_point *data, char *nick)
+    union iwreq_data *wrqu, char *nick)
 {
+	struct iw_point *data = &wrqu->data;
+
 	strcpy(nick, "zd1201");
 	data->flags = 1;
 	data->length = strlen(nick);
@@ -1236,8 +1249,9 @@ static int zd1201_get_nick(struct net_device *dev, struct iw_request_info *info,
 }
 
 static int zd1201_set_rate(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct zd1201 *zd = netdev_priv(dev);
 	short rate;
 	int err;
@@ -1269,8 +1283,9 @@ static int zd1201_set_rate(struct net_device *dev,
 }
 
 static int zd1201_get_rate(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->bitrate;
 	struct zd1201 *zd = netdev_priv(dev);
 	short rate;
 	int err;
@@ -1302,8 +1317,9 @@ static int zd1201_get_rate(struct net_device *dev,
 }
 
 static int zd1201_set_rts(struct net_device *dev, struct iw_request_info *info,
-    struct iw_param *rts, char *extra)
+    union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct zd1201 *zd = netdev_priv(dev);
 	int err;
 	short val = rts->value;
@@ -1322,8 +1338,9 @@ static int zd1201_set_rts(struct net_device *dev, struct iw_request_info *info,
 }
 
 static int zd1201_get_rts(struct net_device *dev, struct iw_request_info *info,
-    struct iw_param *rts, char *extra)
+    union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct zd1201 *zd = netdev_priv(dev);
 	short rtst;
 	int err;
@@ -1339,8 +1356,9 @@ static int zd1201_get_rts(struct net_device *dev, struct iw_request_info *info,
 }
 
 static int zd1201_set_frag(struct net_device *dev, struct iw_request_info *info,
-    struct iw_param *frag, char *extra)
+    union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *frag = &wrqu->frag;
 	struct zd1201 *zd = netdev_priv(dev);
 	int err;
 	short val = frag->value;
@@ -1360,8 +1378,9 @@ static int zd1201_set_frag(struct net_device *dev, struct iw_request_info *info,
 }
 
 static int zd1201_get_frag(struct net_device *dev, struct iw_request_info *info,
-    struct iw_param *frag, char *extra)
+    union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *frag = &wrqu->frag;
 	struct zd1201 *zd = netdev_priv(dev);
 	short fragt;
 	int err;
@@ -1377,20 +1396,21 @@ static int zd1201_get_frag(struct net_device *dev, struct iw_request_info *info,
 }
 
 static int zd1201_set_retry(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *rrq, char *extra)
 {
 	return 0;
 }
 
 static int zd1201_get_retry(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *rrq, char *extra)
 {
 	return 0;
 }
 
 static int zd1201_set_encode(struct net_device *dev,
-    struct iw_request_info *info, struct iw_point *erq, char *key)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *key)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct zd1201 *zd = netdev_priv(dev);
 	short i;
 	int err, rid;
@@ -1446,8 +1466,9 @@ static int zd1201_set_encode(struct net_device *dev,
 }
 
 static int zd1201_get_encode(struct net_device *dev,
-    struct iw_request_info *info, struct iw_point *erq, char *key)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *key)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct zd1201 *zd = netdev_priv(dev);
 	short i;
 	int err;
@@ -1479,8 +1500,9 @@ static int zd1201_get_encode(struct net_device *dev,
 }
 
 static int zd1201_set_power(struct net_device *dev, 
-    struct iw_request_info *info, struct iw_param *vwrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->power;
 	struct zd1201 *zd = netdev_priv(dev);
 	short enabled, duration, level;
 	int err;
@@ -1518,8 +1540,9 @@ out:
 }
 
 static int zd1201_get_power(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *vwrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *vwrq = &wrqu->power;
 	struct zd1201 *zd = netdev_priv(dev);
 	short enabled, level, duration;
 	int err;
@@ -1556,57 +1579,58 @@ static int zd1201_get_power(struct net_device *dev,
 
 static const iw_handler zd1201_iw_handler[] =
 {
-	(iw_handler) zd1201_config_commit,	/* SIOCSIWCOMMIT */
-	(iw_handler) zd1201_get_name,    	/* SIOCGIWNAME */
-	(iw_handler) NULL,			/* SIOCSIWNWID */
-	(iw_handler) NULL,			/* SIOCGIWNWID */
-	(iw_handler) zd1201_set_freq,		/* SIOCSIWFREQ */
-	(iw_handler) zd1201_get_freq,		/* SIOCGIWFREQ */
-	(iw_handler) zd1201_set_mode,		/* SIOCSIWMODE */
-	(iw_handler) zd1201_get_mode,		/* SIOCGIWMODE */
-	(iw_handler) NULL,                  	/* SIOCSIWSENS */
-	(iw_handler) NULL,           		/* SIOCGIWSENS */
-	(iw_handler) NULL,			/* SIOCSIWRANGE */
-	(iw_handler) zd1201_get_range,           /* SIOCGIWRANGE */
-	(iw_handler) NULL,			/* SIOCSIWPRIV */
-	(iw_handler) NULL,			/* SIOCGIWPRIV */
-	(iw_handler) NULL,			/* SIOCSIWSTATS */
-	(iw_handler) NULL,			/* SIOCGIWSTATS */
-	(iw_handler) NULL,			/* SIOCSIWSPY */
-	(iw_handler) NULL,			/* SIOCGIWSPY */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL/*zd1201_set_wap*/,		/* SIOCSIWAP */
-	(iw_handler) zd1201_get_wap,		/* SIOCGIWAP */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,       		/* SIOCGIWAPLIST */
-	(iw_handler) zd1201_set_scan,		/* SIOCSIWSCAN */
-	(iw_handler) zd1201_get_scan,		/* SIOCGIWSCAN */
-	(iw_handler) zd1201_set_essid,		/* SIOCSIWESSID */
-	(iw_handler) zd1201_get_essid,		/* SIOCGIWESSID */
-	(iw_handler) NULL,         		/* SIOCSIWNICKN */
-	(iw_handler) zd1201_get_nick, 		/* SIOCGIWNICKN */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) NULL,			/* -- hole -- */
-	(iw_handler) zd1201_set_rate,		/* SIOCSIWRATE */
-	(iw_handler) zd1201_get_rate,		/* SIOCGIWRATE */
-	(iw_handler) zd1201_set_rts,		/* SIOCSIWRTS */
-	(iw_handler) zd1201_get_rts,		/* SIOCGIWRTS */
-	(iw_handler) zd1201_set_frag,		/* SIOCSIWFRAG */
-	(iw_handler) zd1201_get_frag,		/* SIOCGIWFRAG */
-	(iw_handler) NULL,         		/* SIOCSIWTXPOW */
-	(iw_handler) NULL,          		/* SIOCGIWTXPOW */
-	(iw_handler) zd1201_set_retry,		/* SIOCSIWRETRY */
-	(iw_handler) zd1201_get_retry,		/* SIOCGIWRETRY */
-	(iw_handler) zd1201_set_encode,		/* SIOCSIWENCODE */
-	(iw_handler) zd1201_get_encode,		/* SIOCGIWENCODE */
-	(iw_handler) zd1201_set_power,		/* SIOCSIWPOWER */
-	(iw_handler) zd1201_get_power,		/* SIOCGIWPOWER */
+	zd1201_config_commit,	/* SIOCSIWCOMMIT */
+	zd1201_get_name,    	/* SIOCGIWNAME */
+	NULL,			/* SIOCSIWNWID */
+	NULL,			/* SIOCGIWNWID */
+	zd1201_set_freq,	/* SIOCSIWFREQ */
+	zd1201_get_freq,	/* SIOCGIWFREQ */
+	zd1201_set_mode,	/* SIOCSIWMODE */
+	zd1201_get_mode,	/* SIOCGIWMODE */
+	NULL,                  	/* SIOCSIWSENS */
+	NULL,           	/* SIOCGIWSENS */
+	NULL,			/* SIOCSIWRANGE */
+	zd1201_get_range,	/* SIOCGIWRANGE */
+	NULL,			/* SIOCSIWPRIV */
+	NULL,			/* SIOCGIWPRIV */
+	NULL,			/* SIOCSIWSTATS */
+	NULL,			/* SIOCGIWSTATS */
+	NULL,			/* SIOCSIWSPY */
+	NULL,			/* SIOCGIWSPY */
+	NULL,			/* -- hole -- */
+	NULL,			/* -- hole -- */
+	NULL/*zd1201_set_wap*/,	/* SIOCSIWAP */
+	zd1201_get_wap,		/* SIOCGIWAP */
+	NULL,			/* -- hole -- */
+	NULL,       		/* SIOCGIWAPLIST */
+	zd1201_set_scan,	/* SIOCSIWSCAN */
+	zd1201_get_scan,	/* SIOCGIWSCAN */
+	zd1201_set_essid,	/* SIOCSIWESSID */
+	zd1201_get_essid,	/* SIOCGIWESSID */
+	NULL,         		/* SIOCSIWNICKN */
+	zd1201_get_nick, 	/* SIOCGIWNICKN */
+	NULL,			/* -- hole -- */
+	NULL,			/* -- hole -- */
+	zd1201_set_rate,	/* SIOCSIWRATE */
+	zd1201_get_rate,	/* SIOCGIWRATE */
+	zd1201_set_rts,		/* SIOCSIWRTS */
+	zd1201_get_rts,		/* SIOCGIWRTS */
+	zd1201_set_frag,	/* SIOCSIWFRAG */
+	zd1201_get_frag,	/* SIOCGIWFRAG */
+	NULL,         		/* SIOCSIWTXPOW */
+	NULL,          		/* SIOCGIWTXPOW */
+	zd1201_set_retry,	/* SIOCSIWRETRY */
+	zd1201_get_retry,	/* SIOCGIWRETRY */
+	zd1201_set_encode,	/* SIOCSIWENCODE */
+	zd1201_get_encode,	/* SIOCGIWENCODE */
+	zd1201_set_power,	/* SIOCSIWPOWER */
+	zd1201_get_power,	/* SIOCGIWPOWER */
 };
 
 static int zd1201_set_hostauth(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->param;
 	struct zd1201 *zd = netdev_priv(dev);
 
 	if (!zd->ap)
@@ -1616,8 +1640,9 @@ static int zd1201_set_hostauth(struct net_device *dev,
 }
 
 static int zd1201_get_hostauth(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->param;
 	struct zd1201 *zd = netdev_priv(dev);
 	short hostauth;
 	int err;
@@ -1635,8 +1660,9 @@ static int zd1201_get_hostauth(struct net_device *dev,
 }
 
 static int zd1201_auth_sta(struct net_device *dev,
-    struct iw_request_info *info, struct sockaddr *sta, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct sockaddr *sta = &wrqu->addr;
 	struct zd1201 *zd = netdev_priv(dev);
 	unsigned char buffer[10];
 
@@ -1651,8 +1677,9 @@ static int zd1201_auth_sta(struct net_device *dev,
 }
 
 static int zd1201_set_maxassoc(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->param;
 	struct zd1201 *zd = netdev_priv(dev);
 	int err;
 
@@ -1666,8 +1693,9 @@ static int zd1201_set_maxassoc(struct net_device *dev,
 }
 
 static int zd1201_get_maxassoc(struct net_device *dev,
-    struct iw_request_info *info, struct iw_param *rrq, char *extra)
+    struct iw_request_info *info, union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rrq = &wrqu->param;
 	struct zd1201 *zd = netdev_priv(dev);
 	short maxassoc;
 	int err;
@@ -1685,12 +1713,12 @@ static int zd1201_get_maxassoc(struct net_device *dev,
 }
 
 static const iw_handler zd1201_private_handler[] = {
-	(iw_handler) zd1201_set_hostauth,	/* ZD1201SIWHOSTAUTH */
-	(iw_handler) zd1201_get_hostauth,	/* ZD1201GIWHOSTAUTH */
-	(iw_handler) zd1201_auth_sta,		/* ZD1201SIWAUTHSTA */
-	(iw_handler) NULL,			/* nothing to get */
-	(iw_handler) zd1201_set_maxassoc,	/* ZD1201SIMAXASSOC */
-	(iw_handler) zd1201_get_maxassoc,	/* ZD1201GIMAXASSOC */
+	zd1201_set_hostauth,	/* ZD1201SIWHOSTAUTH */
+	zd1201_get_hostauth,	/* ZD1201GIWHOSTAUTH */
+	zd1201_auth_sta,	/* ZD1201SIWAUTHSTA */
+	NULL,			/* nothing to get */
+	zd1201_set_maxassoc,	/* ZD1201SIMAXASSOC */
+	zd1201_get_maxassoc,	/* ZD1201GIMAXASSOC */
 };
 
 static const struct iw_priv_args zd1201_private_args[] = {
diff --git a/drivers/net/wireless/zydas/zd1211rw/zd_usb.c b/drivers/net/wireless/zydas/zd1211rw/zd_usb.c
index 426860611..5d2276bd4 100644
--- a/drivers/net/wireless/zydas/zd1211rw/zd_usb.c
+++ b/drivers/net/wireless/zydas/zd1211rw/zd_usb.c
@@ -380,7 +380,7 @@ static inline void handle_regs_int(struct urb *urb)
 {
 	struct zd_usb *usb = urb->context;
 	struct zd_usb_interrupt *intr = &usb->intr;
-	int len;
+	unsigned int len;
 	u16 int_num;
 
 	ZD_ASSERT(in_interrupt());
diff --git a/drivers/net/xen-netback/interface.c b/drivers/net/xen-netback/interface.c
index 83deeebfc..bbc8855cc 100644
--- a/drivers/net/xen-netback/interface.c
+++ b/drivers/net/xen-netback/interface.c
@@ -178,7 +178,7 @@ static u16 xenvif_select_queue(struct net_device *dev, struct sk_buff *skb,
 	return vif->hash.mapping[skb_get_hash_raw(skb) % size];
 }
 
-static int xenvif_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t xenvif_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct xenvif *vif = netdev_priv(dev);
 	struct xenvif_queue *queue = NULL;
diff --git a/drivers/net/xen-netfront.c b/drivers/net/xen-netfront.c
index 96ccd4e94..8e1c6b7ab 100644
--- a/drivers/net/xen-netfront.c
+++ b/drivers/net/xen-netfront.c
@@ -550,7 +550,7 @@ static u16 xennet_select_queue(struct net_device *dev, struct sk_buff *skb,
 
 #define MAX_XEN_SKB_FRAGS (65536 / XEN_PAGE_SIZE + 1)
 
-static int xennet_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t xennet_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct netfront_info *np = netdev_priv(dev);
 	struct netfront_stats *tx_stats = this_cpu_ptr(np->tx_stats);
diff --git a/drivers/ntb/test/ntb_pingpong.c b/drivers/ntb/test/ntb_pingpong.c
index 7d311799f..a18871358 100644
--- a/drivers/ntb/test/ntb_pingpong.c
+++ b/drivers/ntb/test/ntb_pingpong.c
@@ -99,7 +99,7 @@ struct pp_ctx {
 	unsigned long			db_delay;
 	struct dentry			*debugfs_node_dir;
 	struct dentry			*debugfs_count;
-	atomic_t			count;
+	atomic_unchecked_t		count;
 };
 
 static struct dentry *pp_debugfs_dir;
@@ -177,7 +177,7 @@ static void pp_db_event(void *ctx, int vec)
 		dev_dbg(&pp->ntb->dev,
 			"Pong vec %d bits %#llx\n",
 			vec, db_bits);
-		atomic_inc(&pp->count);
+		atomic_inc_unchecked(&pp->count);
 	}
 	spin_unlock_irqrestore(&pp->db_lock, irqflags);
 }
@@ -194,7 +194,7 @@ static int pp_debugfs_setup(struct pp_ctx *pp)
 	if (!pp->debugfs_node_dir)
 		return -ENODEV;
 
-	pp->debugfs_count = debugfs_create_atomic_t("count", S_IRUSR | S_IWUSR,
+	pp->debugfs_count = debugfs_create_atomic_unchecked_t("count", S_IRUSR | S_IWUSR,
 						    pp->debugfs_node_dir,
 						    &pp->count);
 	if (!pp->debugfs_count)
@@ -238,7 +238,7 @@ static int pp_probe(struct ntb_client *client,
 
 	pp->ntb = ntb;
 	pp->db_bits = 0;
-	atomic_set(&pp->count, 0);
+	atomic_set_unchecked(&pp->count, 0);
 	spin_lock_init(&pp->db_lock);
 	setup_timer(&pp->db_timer, pp_ping, (unsigned long)pp);
 	pp->db_delay = msecs_to_jiffies(delay_ms);
diff --git a/drivers/nvme/host/pci.c b/drivers/nvme/host/pci.c
index da134a0df..e3236aad0 100644
--- a/drivers/nvme/host/pci.c
+++ b/drivers/nvme/host/pci.c
@@ -2054,7 +2054,7 @@ static int nvme_resume(struct device *dev)
 static SIMPLE_DEV_PM_OPS(nvme_dev_pm_ops, nvme_suspend, nvme_resume);
 
 static pci_ers_result_t nvme_error_detected(struct pci_dev *pdev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct nvme_dev *dev = pci_get_drvdata(pdev);
 
diff --git a/drivers/of/fdt.c b/drivers/of/fdt.c
index 085c6389a..1819bbecd 100644
--- a/drivers/of/fdt.c
+++ b/drivers/of/fdt.c
@@ -1304,7 +1304,9 @@ static int __init of_fdt_raw_init(void)
 		pr_warn("not creating '/sys/firmware/fdt': CRC check failed\n");
 		return 0;
 	}
-	of_fdt_raw_attr.size = fdt_totalsize(initial_boot_params);
+	pax_open_kernel();
+	const_cast(of_fdt_raw_attr.size) = fdt_totalsize(initial_boot_params);
+	pax_close_kernel();
 	return sysfs_create_bin_file(firmware_kobj, &of_fdt_raw_attr);
 }
 late_initcall(of_fdt_raw_init);
diff --git a/drivers/oprofile/buffer_sync.c b/drivers/oprofile/buffer_sync.c
index 82f7000a2..d6d044744 100644
--- a/drivers/oprofile/buffer_sync.c
+++ b/drivers/oprofile/buffer_sync.c
@@ -345,7 +345,7 @@ static void add_data(struct op_entry *entry, struct mm_struct *mm)
 		if (cookie == NO_COOKIE)
 			offset = pc;
 		if (cookie == INVALID_COOKIE) {
-			atomic_inc(&oprofile_stats.sample_lost_no_mapping);
+			atomic_inc_unchecked(&oprofile_stats.sample_lost_no_mapping);
 			offset = pc;
 		}
 		if (cookie != last_cookie) {
@@ -389,14 +389,14 @@ add_sample(struct mm_struct *mm, struct op_sample *s, int in_kernel)
 	/* add userspace sample */
 
 	if (!mm) {
-		atomic_inc(&oprofile_stats.sample_lost_no_mm);
+		atomic_inc_unchecked(&oprofile_stats.sample_lost_no_mm);
 		return 0;
 	}
 
 	cookie = lookup_dcookie(mm, s->eip, &offset);
 
 	if (cookie == INVALID_COOKIE) {
-		atomic_inc(&oprofile_stats.sample_lost_no_mapping);
+		atomic_inc_unchecked(&oprofile_stats.sample_lost_no_mapping);
 		return 0;
 	}
 
@@ -554,7 +554,7 @@ void sync_buffer(int cpu)
 		/* ignore backtraces if failed to add a sample */
 		if (state == sb_bt_start) {
 			state = sb_bt_ignore;
-			atomic_inc(&oprofile_stats.bt_lost_no_mapping);
+			atomic_inc_unchecked(&oprofile_stats.bt_lost_no_mapping);
 		}
 	}
 	release_mm(mm);
diff --git a/drivers/oprofile/event_buffer.c b/drivers/oprofile/event_buffer.c
index c0cc4e7ff..44d4e5485 100644
--- a/drivers/oprofile/event_buffer.c
+++ b/drivers/oprofile/event_buffer.c
@@ -53,7 +53,7 @@ void add_event_entry(unsigned long value)
 	}
 
 	if (buffer_pos == buffer_size) {
-		atomic_inc(&oprofile_stats.event_lost_overflow);
+		atomic_inc_unchecked(&oprofile_stats.event_lost_overflow);
 		return;
 	}
 
diff --git a/drivers/oprofile/oprof.c b/drivers/oprofile/oprof.c
index ed2c3ec07..deda85a09 100644
--- a/drivers/oprofile/oprof.c
+++ b/drivers/oprofile/oprof.c
@@ -110,7 +110,7 @@ static void switch_worker(struct work_struct *work)
 	if (oprofile_ops.switch_events())
 		return;
 
-	atomic_inc(&oprofile_stats.multiplex_counter);
+	atomic_inc_unchecked(&oprofile_stats.multiplex_counter);
 	start_switch_worker();
 }
 
diff --git a/drivers/oprofile/oprofile_stats.c b/drivers/oprofile/oprofile_stats.c
index 59659cea4..6c860a009 100644
--- a/drivers/oprofile/oprofile_stats.c
+++ b/drivers/oprofile/oprofile_stats.c
@@ -30,11 +30,11 @@ void oprofile_reset_stats(void)
 		cpu_buf->sample_invalid_eip = 0;
 	}
 
-	atomic_set(&oprofile_stats.sample_lost_no_mm, 0);
-	atomic_set(&oprofile_stats.sample_lost_no_mapping, 0);
-	atomic_set(&oprofile_stats.event_lost_overflow, 0);
-	atomic_set(&oprofile_stats.bt_lost_no_mapping, 0);
-	atomic_set(&oprofile_stats.multiplex_counter, 0);
+	atomic_set_unchecked(&oprofile_stats.sample_lost_no_mm, 0);
+	atomic_set_unchecked(&oprofile_stats.sample_lost_no_mapping, 0);
+	atomic_set_unchecked(&oprofile_stats.event_lost_overflow, 0);
+	atomic_set_unchecked(&oprofile_stats.bt_lost_no_mapping, 0);
+	atomic_set_unchecked(&oprofile_stats.multiplex_counter, 0);
 }
 
 
diff --git a/drivers/oprofile/oprofile_stats.h b/drivers/oprofile/oprofile_stats.h
index 1fc622bd1..8c48fc31c 100644
--- a/drivers/oprofile/oprofile_stats.h
+++ b/drivers/oprofile/oprofile_stats.h
@@ -13,11 +13,11 @@
 #include <linux/atomic.h>
 
 struct oprofile_stat_struct {
-	atomic_t sample_lost_no_mm;
-	atomic_t sample_lost_no_mapping;
-	atomic_t bt_lost_no_mapping;
-	atomic_t event_lost_overflow;
-	atomic_t multiplex_counter;
+	atomic_unchecked_t sample_lost_no_mm;
+	atomic_unchecked_t sample_lost_no_mapping;
+	atomic_unchecked_t bt_lost_no_mapping;
+	atomic_unchecked_t event_lost_overflow;
+	atomic_unchecked_t multiplex_counter;
 };
 
 extern struct oprofile_stat_struct oprofile_stats;
diff --git a/drivers/oprofile/oprofilefs.c b/drivers/oprofile/oprofilefs.c
index a0e5260bd..a6d763731 100644
--- a/drivers/oprofile/oprofilefs.c
+++ b/drivers/oprofile/oprofilefs.c
@@ -176,8 +176,8 @@ int oprofilefs_create_ro_ulong(struct dentry *root,
 
 static ssize_t atomic_read_file(struct file *file, char __user *buf, size_t count, loff_t *offset)
 {
-	atomic_t *val = file->private_data;
-	return oprofilefs_ulong_to_user(atomic_read(val), buf, count, offset);
+	atomic_unchecked_t *val = file->private_data;
+	return oprofilefs_ulong_to_user(atomic_read_unchecked(val), buf, count, offset);
 }
 
 
@@ -189,7 +189,7 @@ static const struct file_operations atomic_ro_fops = {
 
 
 int oprofilefs_create_ro_atomic(struct dentry *root,
-	char const *name, atomic_t *val)
+	char const *name, atomic_unchecked_t *val)
 {
 	return __oprofilefs_create_file(root, name,
 					&atomic_ro_fops, 0444, val);
diff --git a/drivers/oprofile/timer_int.c b/drivers/oprofile/timer_int.c
index bdef916e5..88c7deea4 100644
--- a/drivers/oprofile/timer_int.c
+++ b/drivers/oprofile/timer_int.c
@@ -93,7 +93,7 @@ static int oprofile_cpu_notify(struct notifier_block *self,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block __refdata oprofile_cpu_notifier = {
+static struct notifier_block oprofile_cpu_notifier = {
 	.notifier_call = oprofile_cpu_notify,
 };
 
diff --git a/drivers/parport/procfs.c b/drivers/parport/procfs.c
index 74ed3e459..3e74a1c40 100644
--- a/drivers/parport/procfs.c
+++ b/drivers/parport/procfs.c
@@ -65,7 +65,7 @@ static int do_active_device(struct ctl_table *table, int write,
 
 	*ppos += len;
 
-	return copy_to_user(result, buffer, len) ? -EFAULT : 0;
+	return (len > sizeof buffer || copy_to_user(result, buffer, len)) ? -EFAULT : 0;
 }
 
 #ifdef CONFIG_PARPORT_1284
@@ -107,7 +107,7 @@ static int do_autoprobe(struct ctl_table *table, int write,
 
 	*ppos += len;
 
-	return copy_to_user (result, buffer, len) ? -EFAULT : 0;
+	return (len > sizeof buffer || copy_to_user (result, buffer, len)) ? -EFAULT : 0;
 }
 #endif /* IEEE1284.3 support. */
 
diff --git a/drivers/pci/hotplug/acpiphp_ibm.c b/drivers/pci/hotplug/acpiphp_ibm.c
index f6221d739..80121aed5 100644
--- a/drivers/pci/hotplug/acpiphp_ibm.c
+++ b/drivers/pci/hotplug/acpiphp_ibm.c
@@ -465,7 +465,9 @@ static int __init ibm_acpiphp_init(void)
 		goto init_cleanup;
 	}
 
-	ibm_apci_table_attr.size = ibm_get_table_from_acpi(NULL);
+	pax_open_kernel();
+	const_cast(ibm_apci_table_attr.size) = ibm_get_table_from_acpi(NULL);
+	pax_close_kernel();
 	retval = sysfs_create_bin_file(sysdir, &ibm_apci_table_attr);
 
 	return retval;
diff --git a/drivers/pci/hotplug/cpcihp_generic.c b/drivers/pci/hotplug/cpcihp_generic.c
index 88a44a707..de358ce27 100644
--- a/drivers/pci/hotplug/cpcihp_generic.c
+++ b/drivers/pci/hotplug/cpcihp_generic.c
@@ -73,7 +73,6 @@ static u16 port;
 static unsigned int enum_bit;
 static u8 enum_mask;
 
-static struct cpci_hp_controller_ops generic_hpc_ops;
 static struct cpci_hp_controller generic_hpc;
 
 static int __init validate_parameters(void)
@@ -139,6 +138,10 @@ static int query_enum(void)
 	return ((value & enum_mask) == enum_mask);
 }
 
+static struct cpci_hp_controller_ops generic_hpc_ops = {
+	.query_enum = query_enum,
+};
+
 static int __init cpcihp_generic_init(void)
 {
 	int status;
@@ -165,7 +168,6 @@ static int __init cpcihp_generic_init(void)
 	pci_dev_put(dev);
 
 	memset(&generic_hpc, 0, sizeof(struct cpci_hp_controller));
-	generic_hpc_ops.query_enum = query_enum;
 	generic_hpc.ops = &generic_hpc_ops;
 
 	status = cpci_hp_register_controller(&generic_hpc);
diff --git a/drivers/pci/hotplug/cpcihp_zt5550.c b/drivers/pci/hotplug/cpcihp_zt5550.c
index 5f49c3fd7..438f01901 100644
--- a/drivers/pci/hotplug/cpcihp_zt5550.c
+++ b/drivers/pci/hotplug/cpcihp_zt5550.c
@@ -59,7 +59,6 @@
 /* local variables */
 static bool debug;
 static bool poll;
-static struct cpci_hp_controller_ops zt5550_hpc_ops;
 static struct cpci_hp_controller zt5550_hpc;
 
 /* Primary cPCI bus bridge device */
@@ -204,6 +203,10 @@ static int zt5550_hc_disable_irq(void)
 	return 0;
 }
 
+static struct cpci_hp_controller_ops zt5550_hpc_ops = {
+	.query_enum = zt5550_hc_query_enum,
+};
+
 static int zt5550_hc_init_one(struct pci_dev *pdev, const struct pci_device_id *ent)
 {
 	int status;
@@ -215,16 +218,17 @@ static int zt5550_hc_init_one(struct pci_dev *pdev, const struct pci_device_id *
 	dbg("returned from zt5550_hc_config");
 
 	memset(&zt5550_hpc, 0, sizeof(struct cpci_hp_controller));
-	zt5550_hpc_ops.query_enum = zt5550_hc_query_enum;
 	zt5550_hpc.ops = &zt5550_hpc_ops;
 	if (!poll) {
 		zt5550_hpc.irq = hc_dev->irq;
 		zt5550_hpc.irq_flags = IRQF_SHARED;
 		zt5550_hpc.dev_id = hc_dev;
 
-		zt5550_hpc_ops.enable_irq = zt5550_hc_enable_irq;
-		zt5550_hpc_ops.disable_irq = zt5550_hc_disable_irq;
-		zt5550_hpc_ops.check_irq = zt5550_hc_check_irq;
+		pax_open_kernel();
+		const_cast(zt5550_hpc_ops.enable_irq) = zt5550_hc_enable_irq;
+		const_cast(zt5550_hpc_ops.disable_irq) = zt5550_hc_disable_irq;
+		const_cast(zt5550_hpc_ops.check_irq) = zt5550_hc_check_irq;
+		pax_open_kernel();
 	} else {
 		info("using ENUM# polling mode");
 	}
diff --git a/drivers/pci/hotplug/cpqphp_nvram.c b/drivers/pci/hotplug/cpqphp_nvram.c
index c25fc9061..b05477470 100644
--- a/drivers/pci/hotplug/cpqphp_nvram.c
+++ b/drivers/pci/hotplug/cpqphp_nvram.c
@@ -425,8 +425,10 @@ static u32 store_HRT(void __iomem *rom_start)
 
 void compaq_nvram_init(void __iomem *rom_start)
 {
+#ifndef CONFIG_PAX_KERNEXEC
 	if (rom_start)
 		compaq_int15_entry_point = (rom_start + ROM_INT15_PHY_ADDR - ROM_PHY_ADDR);
+#endif
 
 	dbg("int15 entry  = %p\n", compaq_int15_entry_point);
 
diff --git a/drivers/pci/hotplug/pci_hotplug_core.c b/drivers/pci/hotplug/pci_hotplug_core.c
index 9acd1997c..1b19f5ba9 100644
--- a/drivers/pci/hotplug/pci_hotplug_core.c
+++ b/drivers/pci/hotplug/pci_hotplug_core.c
@@ -434,8 +434,10 @@ int __pci_hp_register(struct hotplug_slot *slot, struct pci_bus *bus,
 		return -EINVAL;
 	}
 
-	slot->ops->owner = owner;
-	slot->ops->mod_name = mod_name;
+	pax_open_kernel();
+	const_cast(slot->ops->owner) = owner;
+	const_cast(slot->ops->mod_name) = mod_name;
+	pax_close_kernel();
 
 	mutex_lock(&pci_hp_mutex);
 	/*
diff --git a/drivers/pci/hotplug/pciehp_core.c b/drivers/pci/hotplug/pciehp_core.c
index ac531e674..716d058dd 100644
--- a/drivers/pci/hotplug/pciehp_core.c
+++ b/drivers/pci/hotplug/pciehp_core.c
@@ -87,7 +87,7 @@ static int init_slot(struct controller *ctrl)
 	struct slot *slot = ctrl->slot;
 	struct hotplug_slot *hotplug = NULL;
 	struct hotplug_slot_info *info = NULL;
-	struct hotplug_slot_ops *ops = NULL;
+	hotplug_slot_ops_no_const *ops = NULL;
 	char name[SLOT_NAME_SIZE];
 	int retval = -ENOMEM;
 
diff --git a/drivers/pci/msi.c b/drivers/pci/msi.c
index 98f12223c..d57e45104 100644
--- a/drivers/pci/msi.c
+++ b/drivers/pci/msi.c
@@ -476,8 +476,8 @@ static int populate_msi_sysfs(struct pci_dev *pdev)
 {
 	struct attribute **msi_attrs;
 	struct attribute *msi_attr;
-	struct device_attribute *msi_dev_attr;
-	struct attribute_group *msi_irq_group;
+	device_attribute_no_const *msi_dev_attr;
+	attribute_group_no_const *msi_irq_group;
 	const struct attribute_group **msi_irq_groups;
 	struct msi_desc *entry;
 	int ret = -ENOMEM;
@@ -539,7 +539,7 @@ error_attrs:
 	count = 0;
 	msi_attr = msi_attrs[count];
 	while (msi_attr) {
-		msi_dev_attr = container_of(msi_attr, struct device_attribute, attr);
+		msi_dev_attr = container_of(msi_attr, device_attribute_no_const, attr);
 		kfree(msi_attr->name);
 		kfree(msi_dev_attr);
 		++count;
@@ -1369,12 +1369,14 @@ static void pci_msi_domain_update_dom_ops(struct msi_domain_info *info)
 	if (ops == NULL) {
 		info->ops = &pci_msi_domain_ops_default;
 	} else {
+		pax_open_kernel();
 		if (ops->set_desc == NULL)
-			ops->set_desc = pci_msi_domain_set_desc;
+			const_cast(ops->set_desc) = pci_msi_domain_set_desc;
 		if (ops->msi_check == NULL)
-			ops->msi_check = pci_msi_domain_check_cap;
+			const_cast(ops->msi_check) = pci_msi_domain_check_cap;
 		if (ops->handle_error == NULL)
-			ops->handle_error = pci_msi_domain_handle_error;
+			const_cast(ops->handle_error) = pci_msi_domain_handle_error;
+		pax_close_kernel();
 	}
 }
 
@@ -1383,12 +1385,14 @@ static void pci_msi_domain_update_chip_ops(struct msi_domain_info *info)
 	struct irq_chip *chip = info->chip;
 
 	BUG_ON(!chip);
+	pax_open_kernel();
 	if (!chip->irq_write_msi_msg)
-		chip->irq_write_msi_msg = pci_msi_domain_write_msg;
+		const_cast(chip->irq_write_msi_msg) = pci_msi_domain_write_msg;
 	if (!chip->irq_mask)
-		chip->irq_mask = pci_msi_mask_irq;
+		const_cast(chip->irq_mask) = pci_msi_mask_irq;
 	if (!chip->irq_unmask)
-		chip->irq_unmask = pci_msi_unmask_irq;
+		const_cast(chip->irq_unmask) = pci_msi_unmask_irq;
+	pax_close_kernel();
 }
 
 /**
diff --git a/drivers/pci/pci-sysfs.c b/drivers/pci/pci-sysfs.c
index bcd10c795..c7c18bcee 100644
--- a/drivers/pci/pci-sysfs.c
+++ b/drivers/pci/pci-sysfs.c
@@ -1141,7 +1141,7 @@ static int pci_create_attr(struct pci_dev *pdev, int num, int write_combine)
 {
 	/* allocate attribute structure, piggyback attribute name */
 	int name_len = write_combine ? 13 : 10;
-	struct bin_attribute *res_attr;
+	bin_attribute_no_const *res_attr;
 	char *res_attr_name;
 	int retval;
 
@@ -1321,7 +1321,7 @@ static struct device_attribute reset_attr = __ATTR(reset, 0200, NULL, reset_stor
 static int pci_create_capabilities_sysfs(struct pci_dev *dev)
 {
 	int retval;
-	struct bin_attribute *attr;
+	bin_attribute_no_const *attr;
 
 	/* If the device has VPD, try to expose it in sysfs. */
 	if (dev->vpd) {
@@ -1368,7 +1368,7 @@ int __must_check pci_create_sysfs_dev_files(struct pci_dev *pdev)
 {
 	int retval;
 	int rom_size;
-	struct bin_attribute *attr;
+	bin_attribute_no_const *attr;
 
 	if (!sysfs_initialized)
 		return -EACCES;
diff --git a/drivers/pci/pci.h b/drivers/pci/pci.h
index 9730c474b..773a32251 100644
--- a/drivers/pci/pci.h
+++ b/drivers/pci/pci.h
@@ -113,7 +113,7 @@ struct pci_vpd_ops {
 
 struct pci_vpd {
 	const struct pci_vpd_ops *ops;
-	struct bin_attribute *attr; /* descriptor for sysfs VPD entry */
+	bin_attribute_no_const *attr; /* descriptor for sysfs VPD entry */
 	struct mutex	lock;
 	unsigned int	len;
 	u16		flag;
@@ -314,7 +314,7 @@ static inline int pci_iov_bus_range(struct pci_bus *bus)
 
 #endif /* CONFIG_PCI_IOV */
 
-unsigned long pci_cardbus_resource_alignment(struct resource *);
+unsigned long pci_cardbus_resource_alignment(const struct resource *);
 
 static inline resource_size_t pci_resource_alignment(struct pci_dev *dev,
 						     struct resource *res)
diff --git a/drivers/pci/pcie/aspm.c b/drivers/pci/pcie/aspm.c
index 0ec649d96..f93be686d 100644
--- a/drivers/pci/pcie/aspm.c
+++ b/drivers/pci/pcie/aspm.c
@@ -27,9 +27,9 @@
 #define MODULE_PARAM_PREFIX "pcie_aspm."
 
 /* Note: those are not register definitions */
-#define ASPM_STATE_L0S_UP	(1)	/* Upstream direction L0s state */
-#define ASPM_STATE_L0S_DW	(2)	/* Downstream direction L0s state */
-#define ASPM_STATE_L1		(4)	/* L1 state */
+#define ASPM_STATE_L0S_UP	(1U)	/* Upstream direction L0s state */
+#define ASPM_STATE_L0S_DW	(2U)	/* Downstream direction L0s state */
+#define ASPM_STATE_L1		(4U)	/* L1 state */
 #define ASPM_STATE_L0S		(ASPM_STATE_L0S_UP | ASPM_STATE_L0S_DW)
 #define ASPM_STATE_ALL		(ASPM_STATE_L0S | ASPM_STATE_L1)
 
@@ -775,7 +775,7 @@ void pci_disable_link_state(struct pci_dev *pdev, int state)
 }
 EXPORT_SYMBOL(pci_disable_link_state);
 
-static int pcie_aspm_set_policy(const char *val, struct kernel_param *kp)
+static int pcie_aspm_set_policy(const char *val, const struct kernel_param *kp)
 {
 	int i;
 	struct pcie_link_state *link;
@@ -802,7 +802,7 @@ static int pcie_aspm_set_policy(const char *val, struct kernel_param *kp)
 	return 0;
 }
 
-static int pcie_aspm_get_policy(char *buffer, struct kernel_param *kp)
+static int pcie_aspm_get_policy(char *buffer, const struct kernel_param *kp)
 {
 	int i, cnt = 0;
 	for (i = 0; i < ARRAY_SIZE(policy_str); i++)
diff --git a/drivers/pci/pcie/portdrv_pci.c b/drivers/pci/pcie/portdrv_pci.c
index 70d7ad8c6..66f87d6bb 100644
--- a/drivers/pci/pcie/portdrv_pci.c
+++ b/drivers/pci/pcie/portdrv_pci.c
@@ -370,7 +370,7 @@ static int __init dmi_pcie_pme_disable_msi(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id __initdata pcie_portdrv_dmi_table[] = {
+static const struct dmi_system_id __initconst pcie_portdrv_dmi_table[] = {
 	/*
 	 * Boxes that should not use MSI for PCIe PME signaling.
 	 */
diff --git a/drivers/pci/probe.c b/drivers/pci/probe.c
index f6eff4aaf..9ef8afbb8 100644
--- a/drivers/pci/probe.c
+++ b/drivers/pci/probe.c
@@ -180,7 +180,7 @@ int __pci_read_base(struct pci_dev *dev, enum pci_bar_type type,
 	u16 orig_cmd;
 	struct pci_bus_region region, inverted_region;
 
-	mask = type ? PCI_ROM_ADDRESS_MASK : ~0;
+	mask = type ? (u32)PCI_ROM_ADDRESS_MASK : ~0;
 
 	/* No printks while decoding is disabled! */
 	if (!dev->mmio_always_on) {
diff --git a/drivers/pci/proc.c b/drivers/pci/proc.c
index 2408abe4e..455d4d4cf 100644
--- a/drivers/pci/proc.c
+++ b/drivers/pci/proc.c
@@ -437,7 +437,16 @@ static const struct file_operations proc_bus_pci_dev_operations = {
 static int __init pci_proc_init(void)
 {
 	struct pci_dev *dev = NULL;
+
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	proc_bus_pci_dir = proc_mkdir_mode("bus/pci", S_IRUSR | S_IXUSR, NULL);
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	proc_bus_pci_dir = proc_mkdir_mode("bus/pci", S_IRUSR | S_IXUSR | S_IRGRP | S_IXGRP, NULL);
+#endif
+#else
 	proc_bus_pci_dir = proc_mkdir("bus/pci", NULL);
+#endif
 	proc_create("devices", 0, proc_bus_pci_dir,
 		    &proc_bus_pci_dev_operations);
 	proc_initialized = 1;
diff --git a/drivers/pci/setup-bus.c b/drivers/pci/setup-bus.c
index c74059e10..95cd7bc2a 100644
--- a/drivers/pci/setup-bus.c
+++ b/drivers/pci/setup-bus.c
@@ -405,8 +405,12 @@ static void __assign_resources_sorted(struct list_head *head,
 
 	/* Update res in head list with add_size in realloc_head list */
 	list_for_each_entry_safe(dev_res, tmp_res, head, list) {
-		dev_res->res->end += get_res_add_size(realloc_head,
-							dev_res->res);
+		resource_size_t add_size = get_res_add_size(realloc_head, dev_res->res);
+
+		if (dev_res->res->start == 0 && dev_res->res->end == RESOURCE_SIZE_MAX)
+			dev_res->res->end = add_size - 1;
+		else
+			dev_res->res->end += get_res_add_size(realloc_head, dev_res->res);
 
 		/*
 		 * There are two kinds of additional resources in the list:
@@ -1119,7 +1123,7 @@ static int pbus_size_mem(struct pci_bus *bus, unsigned long mask,
 	return 0;
 }
 
-unsigned long pci_cardbus_resource_alignment(struct resource *res)
+unsigned long pci_cardbus_resource_alignment(const struct resource *res)
 {
 	if (res->flags & IORESOURCE_IO)
 		return pci_cardbus_io_size;
diff --git a/drivers/pinctrl/nomadik/pinctrl-nomadik.c b/drivers/pinctrl/nomadik/pinctrl-nomadik.c
index 35f62180d..481d0982d 100644
--- a/drivers/pinctrl/nomadik/pinctrl-nomadik.c
+++ b/drivers/pinctrl/nomadik/pinctrl-nomadik.c
@@ -1098,7 +1098,7 @@ static int nmk_gpio_probe(struct platform_device *dev)
 	struct device_node *np = dev->dev.of_node;
 	struct nmk_gpio_chip *nmk_chip;
 	struct gpio_chip *chip;
-	struct irq_chip *irqchip;
+	irq_chip_no_const *irqchip;
 	int latent_irq;
 	bool supports_sleepmode;
 	int irq;
diff --git a/drivers/pinctrl/pinctrl-at91.c b/drivers/pinctrl/pinctrl-at91.c
index 80daead3a..388a2c670 100644
--- a/drivers/pinctrl/pinctrl-at91.c
+++ b/drivers/pinctrl/pinctrl-at91.c
@@ -23,6 +23,7 @@
 #include <linux/pinctrl/pinmux.h>
 /* Since we request GPIOs from ourself */
 #include <linux/pinctrl/consumer.h>
+#include <asm/pgtable.h>
 
 #include "pinctrl-at91.h"
 #include "core.h"
@@ -1600,7 +1601,9 @@ static int at91_gpio_of_irq_setup(struct platform_device *pdev,
 	at91_gpio->pioc_hwirq = irqd_to_hwirq(d);
 
 	/* Setup proper .irq_set_type function */
-	gpio_irqchip.irq_set_type = at91_gpio->ops->irq_type;
+	pax_open_kernel();
+	const_cast(gpio_irqchip.irq_set_type) = at91_gpio->ops->irq_type;
+	pax_close_kernel();
 
 	/* Disable irqs of this PIO controller */
 	writel_relaxed(~0, at91_gpio->regbase + PIO_IDR);
diff --git a/drivers/platform/chrome/chromeos_laptop.c b/drivers/platform/chrome/chromeos_laptop.c
index e8a44a9bc..d8599736a 100644
--- a/drivers/platform/chrome/chromeos_laptop.c
+++ b/drivers/platform/chrome/chromeos_laptop.c
@@ -518,7 +518,7 @@ static struct chromeos_laptop cr48 = {
 	.callback = chromeos_laptop_dmi_matched, \
 	.driver_data = (void *)&board_
 
-static struct dmi_system_id chromeos_laptop_dmi_table[] __initdata = {
+static const struct dmi_system_id chromeos_laptop_dmi_table[] __initconst = {
 	{
 		.ident = "Samsung Series 5 550",
 		.matches = {
diff --git a/drivers/platform/chrome/chromeos_pstore.c b/drivers/platform/chrome/chromeos_pstore.c
index 308a853ac..b0693fdec 100644
--- a/drivers/platform/chrome/chromeos_pstore.c
+++ b/drivers/platform/chrome/chromeos_pstore.c
@@ -14,7 +14,7 @@
 #include <linux/platform_device.h>
 #include <linux/pstore_ram.h>
 
-static struct dmi_system_id chromeos_pstore_dmi_table[] __initdata = {
+static const struct dmi_system_id chromeos_pstore_dmi_table[] __initconst = {
 	{
 		/*
 		 * Today all Chromebooks/boxes ship with Google_* as version and
diff --git a/drivers/platform/chrome/cros_ec_lpc.c b/drivers/platform/chrome/cros_ec_lpc.c
index f9a245465..275966484 100644
--- a/drivers/platform/chrome/cros_ec_lpc.c
+++ b/drivers/platform/chrome/cros_ec_lpc.c
@@ -300,7 +300,7 @@ static int cros_ec_lpc_remove(struct platform_device *pdev)
 	return 0;
 }
 
-static struct dmi_system_id cros_ec_lpc_dmi_table[] __initdata = {
+static const struct dmi_system_id cros_ec_lpc_dmi_table[] __initconst = {
 	{
 		/*
 		 * Today all Chromebooks/boxes ship with Google_* as version and
diff --git a/drivers/platform/x86/alienware-wmi.c b/drivers/platform/x86/alienware-wmi.c
index 005629447..8f8c2d5e8 100644
--- a/drivers/platform/x86/alienware-wmi.c
+++ b/drivers/platform/x86/alienware-wmi.c
@@ -209,7 +209,7 @@ struct wmax_led_args {
 } __packed;
 
 static struct platform_device *platform_device;
-static struct device_attribute *zone_dev_attrs;
+static device_attribute_no_const *zone_dev_attrs;
 static struct attribute **zone_attrs;
 static struct platform_zone *zone_data;
 
@@ -219,7 +219,7 @@ static struct platform_driver platform_driver = {
 		   }
 };
 
-static struct attribute_group zone_attribute_group = {
+static attribute_group_no_const zone_attribute_group = {
 	.name = "rgb_zones",
 };
 
diff --git a/drivers/platform/x86/apple-gmux.c b/drivers/platform/x86/apple-gmux.c
index a66be1373..124be136d 100644
--- a/drivers/platform/x86/apple-gmux.c
+++ b/drivers/platform/x86/apple-gmux.c
@@ -482,7 +482,7 @@ static int gmux_set_power_state(enum vga_switcheroo_client_id id,
 	return gmux_set_discrete_state(apple_gmux_data, state);
 }
 
-static int gmux_get_client_id(struct pci_dev *pdev)
+static enum vga_switcheroo_client_id gmux_get_client_id(struct pci_dev *pdev)
 {
 	/*
 	 * Early Macbook Pros with switchable graphics use nvidia
diff --git a/drivers/platform/x86/asus-wmi.c b/drivers/platform/x86/asus-wmi.c
index 7c093a0b7..f2fb59f42 100644
--- a/drivers/platform/x86/asus-wmi.c
+++ b/drivers/platform/x86/asus-wmi.c
@@ -1872,6 +1872,10 @@ static int show_dsts(struct seq_file *m, void *data)
 	int err;
 	u32 retval = -1;
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+	return -EPERM;
+#endif
+
 	err = asus_wmi_get_devstate(asus, asus->debug.dev_id, &retval);
 
 	if (err < 0)
@@ -1888,6 +1892,10 @@ static int show_devs(struct seq_file *m, void *data)
 	int err;
 	u32 retval = -1;
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+	return -EPERM;
+#endif
+
 	err = asus_wmi_set_devstate(asus->debug.dev_id, asus->debug.ctrl_param,
 				    &retval);
 
@@ -1912,6 +1920,10 @@ static int show_call(struct seq_file *m, void *data)
 	union acpi_object *obj;
 	acpi_status status;
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+	return -EPERM;
+#endif
+
 	status = wmi_evaluate_method(ASUS_WMI_MGMT_GUID,
 				     1, asus->debug.method_id,
 				     &input, &output);
diff --git a/drivers/platform/x86/compal-laptop.c b/drivers/platform/x86/compal-laptop.c
index e1c2b6d4b..8f25439ed 100644
--- a/drivers/platform/x86/compal-laptop.c
+++ b/drivers/platform/x86/compal-laptop.c
@@ -805,7 +805,7 @@ static int dmi_check_cb_extra(const struct dmi_system_id *id)
 	return 1;
 }
 
-static struct dmi_system_id __initdata compal_dmi_table[] = {
+static const struct dmi_system_id __initconst compal_dmi_table[] = {
 	{
 		.ident = "FL90/IFL90",
 		.matches = {
diff --git a/drivers/platform/x86/hdaps.c b/drivers/platform/x86/hdaps.c
index 458e6c948..089aee733 100644
--- a/drivers/platform/x86/hdaps.c
+++ b/drivers/platform/x86/hdaps.c
@@ -514,7 +514,7 @@ static int __init hdaps_dmi_match_invert(const struct dmi_system_id *id)
    "ThinkPad T42p", so the order of the entries matters.
    If your ThinkPad is not recognized, please update to latest
    BIOS. This is especially the case for some R52 ThinkPads. */
-static struct dmi_system_id __initdata hdaps_whitelist[] = {
+static const struct dmi_system_id __initconst hdaps_whitelist[] = {
 	HDAPS_DMI_MATCH_INVERT("IBM", "ThinkPad R50p", HDAPS_BOTH_AXES),
 	HDAPS_DMI_MATCH_NORMAL("IBM", "ThinkPad R50"),
 	HDAPS_DMI_MATCH_NORMAL("IBM", "ThinkPad R51"),
diff --git a/drivers/platform/x86/ibm_rtl.c b/drivers/platform/x86/ibm_rtl.c
index c62e5e11c..854b4188d 100644
--- a/drivers/platform/x86/ibm_rtl.c
+++ b/drivers/platform/x86/ibm_rtl.c
@@ -227,7 +227,7 @@ static void rtl_teardown_sysfs(void) {
 }
 
 
-static struct dmi_system_id __initdata ibm_rtl_dmi_table[] = {
+static const struct dmi_system_id __initconst ibm_rtl_dmi_table[] = {
 	{                                                  \
 		.matches = {                               \
 			DMI_MATCH(DMI_SYS_VENDOR, "IBM"),  \
diff --git a/drivers/platform/x86/intel_oaktrail.c b/drivers/platform/x86/intel_oaktrail.c
index 6aa33c4a8..cfb54257e 100644
--- a/drivers/platform/x86/intel_oaktrail.c
+++ b/drivers/platform/x86/intel_oaktrail.c
@@ -299,7 +299,7 @@ static int dmi_check_cb(const struct dmi_system_id *id)
 	return 0;
 }
 
-static struct dmi_system_id __initdata oaktrail_dmi_table[] = {
+static const struct dmi_system_id __initconst oaktrail_dmi_table[] = {
 	{
 		.ident = "OakTrail platform",
 		.matches = {
diff --git a/drivers/platform/x86/msi-laptop.c b/drivers/platform/x86/msi-laptop.c
index 423177046..cbf93a6fc 100644
--- a/drivers/platform/x86/msi-laptop.c
+++ b/drivers/platform/x86/msi-laptop.c
@@ -605,7 +605,7 @@ static int dmi_check_cb(const struct dmi_system_id *dmi)
 	return 1;
 }
 
-static struct dmi_system_id __initdata msi_dmi_table[] = {
+static const struct dmi_system_id __initconst msi_dmi_table[] = {
 	{
 		.ident = "MSI S270",
 		.matches = {
@@ -1000,12 +1000,14 @@ static int __init load_scm_model_init(struct platform_device *sdev)
 
 	if (!quirks->ec_read_only) {
 		/* allow userland write sysfs file  */
-		dev_attr_bluetooth.store = store_bluetooth;
-		dev_attr_wlan.store = store_wlan;
-		dev_attr_threeg.store = store_threeg;
-		dev_attr_bluetooth.attr.mode |= S_IWUSR;
-		dev_attr_wlan.attr.mode |= S_IWUSR;
-		dev_attr_threeg.attr.mode |= S_IWUSR;
+		pax_open_kernel();
+		const_cast(dev_attr_bluetooth.store) = store_bluetooth;
+		const_cast(dev_attr_wlan.store) = store_wlan;
+		const_cast(dev_attr_threeg.store) = store_threeg;
+		const_cast(dev_attr_bluetooth.attr.mode) |= S_IWUSR;
+		const_cast(dev_attr_wlan.attr.mode) |= S_IWUSR;
+		const_cast(dev_attr_threeg.attr.mode) |= S_IWUSR;
+		pax_close_kernel();
 	}
 
 	/* disable hardware control by fn key */
diff --git a/drivers/platform/x86/msi-wmi.c b/drivers/platform/x86/msi-wmi.c
index 978e6d640..1f0b37dec 100644
--- a/drivers/platform/x86/msi-wmi.c
+++ b/drivers/platform/x86/msi-wmi.c
@@ -184,7 +184,7 @@ static const struct backlight_ops msi_backlight_ops = {
 static void msi_wmi_notify(u32 value, void *context)
 {
 	struct acpi_buffer response = { ACPI_ALLOCATE_BUFFER, NULL };
-	static struct key_entry *key;
+	struct key_entry *key;
 	union acpi_object *obj;
 	acpi_status status;
 
diff --git a/drivers/platform/x86/samsung-laptop.c b/drivers/platform/x86/samsung-laptop.c
index 8c146e2b6..356c62ea6 100644
--- a/drivers/platform/x86/samsung-laptop.c
+++ b/drivers/platform/x86/samsung-laptop.c
@@ -1567,7 +1567,7 @@ static int __init samsung_dmi_matched(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id __initdata samsung_dmi_table[] = {
+static const struct dmi_system_id __initconst samsung_dmi_table[] = {
 	{
 		.matches = {
 			DMI_MATCH(DMI_SYS_VENDOR,
diff --git a/drivers/platform/x86/samsung-q10.c b/drivers/platform/x86/samsung-q10.c
index e6aac725a..e11ff24fc 100644
--- a/drivers/platform/x86/samsung-q10.c
+++ b/drivers/platform/x86/samsung-q10.c
@@ -95,7 +95,7 @@ static int __init dmi_check_callback(const struct dmi_system_id *id)
 	return 1;
 }
 
-static struct dmi_system_id __initdata samsungq10_dmi_table[] = {
+static const struct dmi_system_id __initconst samsungq10_dmi_table[] = {
 	{
 		.ident = "Samsung Q10",
 		.matches = {
diff --git a/drivers/platform/x86/sony-laptop.c b/drivers/platform/x86/sony-laptop.c
index 1dba3598c..2850ab953 100644
--- a/drivers/platform/x86/sony-laptop.c
+++ b/drivers/platform/x86/sony-laptop.c
@@ -2556,7 +2556,7 @@ static void sony_nc_gfx_switch_cleanup(struct platform_device *pd)
 }
 
 /* High speed charging function */
-static struct device_attribute *hsc_handle;
+static device_attribute_no_const *hsc_handle;
 
 static ssize_t sony_nc_highspeed_charging_store(struct device *dev,
 		struct device_attribute *attr,
@@ -2630,7 +2630,7 @@ static void sony_nc_highspeed_charging_cleanup(struct platform_device *pd)
 }
 
 /* low battery function */
-static struct device_attribute *lowbatt_handle;
+static device_attribute_no_const *lowbatt_handle;
 
 static ssize_t sony_nc_lowbatt_store(struct device *dev,
 		struct device_attribute *attr,
@@ -2696,7 +2696,7 @@ static void sony_nc_lowbatt_cleanup(struct platform_device *pd)
 }
 
 /* fan speed function */
-static struct device_attribute *fan_handle, *hsf_handle;
+static device_attribute_no_const *fan_handle, *hsf_handle;
 
 static ssize_t sony_nc_hsfan_store(struct device *dev,
 		struct device_attribute *attr,
@@ -2803,7 +2803,7 @@ static void sony_nc_fanspeed_cleanup(struct platform_device *pd)
 }
 
 /* USB charge function */
-static struct device_attribute *uc_handle;
+static device_attribute_no_const *uc_handle;
 
 static ssize_t sony_nc_usb_charge_store(struct device *dev,
 		struct device_attribute *attr,
@@ -2877,7 +2877,7 @@ static void sony_nc_usb_charge_cleanup(struct platform_device *pd)
 }
 
 /* Panel ID function */
-static struct device_attribute *panel_handle;
+static device_attribute_no_const *panel_handle;
 
 static ssize_t sony_nc_panelid_show(struct device *dev,
 		struct device_attribute *attr, char *buffer)
@@ -2924,7 +2924,7 @@ static void sony_nc_panelid_cleanup(struct platform_device *pd)
 }
 
 /* smart connect function */
-static struct device_attribute *sc_handle;
+static device_attribute_no_const *sc_handle;
 
 static ssize_t sony_nc_smart_conn_store(struct device *dev,
 		struct device_attribute *attr,
@@ -4880,7 +4880,7 @@ static struct acpi_driver sony_pic_driver = {
 	.drv.pm = &sony_pic_pm,
 };
 
-static struct dmi_system_id __initdata sonypi_dmi_table[] = {
+static const struct dmi_system_id __initconst sonypi_dmi_table[] = {
 	{
 		.ident = "Sony Vaio",
 		.matches = {
diff --git a/drivers/platform/x86/thinkpad_acpi.c b/drivers/platform/x86/thinkpad_acpi.c
index b65ce7519..d92001eea 100644
--- a/drivers/platform/x86/thinkpad_acpi.c
+++ b/drivers/platform/x86/thinkpad_acpi.c
@@ -2462,10 +2462,10 @@ static void hotkey_compare_and_issue_event(struct tp_nvram_state *oldn,
 				&& !tp_features.bright_unkfw)
 			TPACPI_MAY_SEND_KEY(TP_ACPI_HOTKEYSCAN_FNHOME);
 	}
+}
 
 #undef TPACPI_COMPARE_KEY
 #undef TPACPI_MAY_SEND_KEY
-}
 
 /*
  * Polling driver
@@ -4203,7 +4203,7 @@ static int bluetooth_get_status(void)
 			TPACPI_RFK_RADIO_ON : TPACPI_RFK_RADIO_OFF;
 }
 
-static int bluetooth_set_status(enum tpacpi_rfkill_state state)
+static int bluetooth_set_status(const enum tpacpi_rfkill_state state)
 {
 	int status;
 
@@ -4391,7 +4391,7 @@ static int wan_get_status(void)
 			TPACPI_RFK_RADIO_ON : TPACPI_RFK_RADIO_OFF;
 }
 
-static int wan_set_status(enum tpacpi_rfkill_state state)
+static int wan_set_status(const enum tpacpi_rfkill_state state)
 {
 	int status;
 
@@ -4577,7 +4577,7 @@ static int uwb_get_status(void)
 			TPACPI_RFK_RADIO_ON : TPACPI_RFK_RADIO_OFF;
 }
 
-static int uwb_set_status(enum tpacpi_rfkill_state state)
+static int uwb_set_status(const enum tpacpi_rfkill_state state)
 {
 	int status;
 
@@ -9526,7 +9526,7 @@ static struct ibm_init_struct ibms_init[] __initdata = {
 	},
 };
 
-static int __init set_ibm_param(const char *val, struct kernel_param *kp)
+static int __init set_ibm_param(const char *val, const struct kernel_param *kp)
 {
 	unsigned int i;
 	struct ibm_struct *ibm;
diff --git a/drivers/platform/x86/toshiba-wmi.c b/drivers/platform/x86/toshiba-wmi.c
index 2df07ee8f..92dca69e5 100644
--- a/drivers/platform/x86/toshiba-wmi.c
+++ b/drivers/platform/x86/toshiba-wmi.c
@@ -64,7 +64,7 @@ static void toshiba_wmi_notify(u32 value, void *context)
 	kfree(response.pointer);
 }
 
-static struct dmi_system_id toshiba_wmi_dmi_table[] __initdata = {
+static const struct dmi_system_id toshiba_wmi_dmi_table[] __initconst = {
 	{
 		.ident = "Toshiba laptop",
 		.matches = {
diff --git a/drivers/pnp/base.h b/drivers/pnp/base.h
index 3151fd164..12c5b207d 100644
--- a/drivers/pnp/base.h
+++ b/drivers/pnp/base.h
@@ -163,7 +163,7 @@ struct pnp_resource *pnp_add_resource(struct pnp_dev *dev,
 				      struct resource *res);
 struct pnp_resource *pnp_add_irq_resource(struct pnp_dev *dev, int irq,
 					  int flags);
-struct pnp_resource *pnp_add_dma_resource(struct pnp_dev *dev, int dma,
+struct pnp_resource *pnp_add_dma_resource(struct pnp_dev *dev, resource_size_t dma,
 					  int flags);
 struct pnp_resource *pnp_add_io_resource(struct pnp_dev *dev,
 					 resource_size_t start,
diff --git a/drivers/pnp/pnpbios/bioscalls.c b/drivers/pnp/pnpbios/bioscalls.c
index 438d4c72c..ca8a2fba1 100644
--- a/drivers/pnp/pnpbios/bioscalls.c
+++ b/drivers/pnp/pnpbios/bioscalls.c
@@ -59,7 +59,7 @@ do { \
 	set_desc_limit(&gdt[(selname) >> 3], (size) - 1); \
 } while(0)
 
-static struct desc_struct bad_bios_desc = GDT_ENTRY_INIT(0x4092,
+static const struct desc_struct bad_bios_desc = GDT_ENTRY_INIT(0x4093,
 			(unsigned long)__va(0x400UL), PAGE_SIZE - 0x400 - 1);
 
 /*
@@ -96,7 +96,10 @@ static inline u16 call_pnp_bios(u16 func, u16 arg1, u16 arg2, u16 arg3,
 
 	cpu = get_cpu();
 	save_desc_40 = get_cpu_gdt_table(cpu)[0x40 / 8];
+
+	pax_open_kernel();
 	get_cpu_gdt_table(cpu)[0x40 / 8] = bad_bios_desc;
+	pax_close_kernel();
 
 	/* On some boxes IRQ's during PnP BIOS calls are deadly.  */
 	spin_lock_irqsave(&pnp_bios_lock, flags);
@@ -134,7 +137,10 @@ static inline u16 call_pnp_bios(u16 func, u16 arg1, u16 arg2, u16 arg3,
 			     :"memory");
 	spin_unlock_irqrestore(&pnp_bios_lock, flags);
 
+	pax_open_kernel();
 	get_cpu_gdt_table(cpu)[0x40 / 8] = save_desc_40;
+	pax_close_kernel();
+
 	put_cpu();
 
 	/* If we get here and this is set then the PnP BIOS faulted on us. */
@@ -468,7 +474,7 @@ int pnp_bios_read_escd(char *data, u32 nvram_base)
 	return status;
 }
 
-void pnpbios_calls_init(union pnp_bios_install_struct *header)
+void __init pnpbios_calls_init(union pnp_bios_install_struct *header)
 {
 	int i;
 
@@ -476,6 +482,8 @@ void pnpbios_calls_init(union pnp_bios_install_struct *header)
 	pnp_bios_callpoint.offset = header->fields.pm16offset;
 	pnp_bios_callpoint.segment = PNP_CS16;
 
+	pax_open_kernel();
+
 	for_each_possible_cpu(i) {
 		struct desc_struct *gdt = get_cpu_gdt_table(i);
 		if (!gdt)
@@ -487,4 +495,6 @@ void pnpbios_calls_init(union pnp_bios_install_struct *header)
 		set_desc_base(&gdt[GDT_ENTRY_PNPBIOS_DS],
 			 (unsigned long)__va(header->fields.pm16dseg));
 	}
+
+	pax_close_kernel();
 }
diff --git a/drivers/pnp/pnpbios/core.c b/drivers/pnp/pnpbios/core.c
index c38a5b973..6b3284cff 100644
--- a/drivers/pnp/pnpbios/core.c
+++ b/drivers/pnp/pnpbios/core.c
@@ -494,7 +494,7 @@ static int __init exploding_pnp_bios(const struct dmi_system_id *d)
 	return 0;
 }
 
-static struct dmi_system_id pnpbios_dmi_table[] __initdata = {
+static const struct dmi_system_id pnpbios_dmi_table[] __initconst = {
 	{			/* PnPBIOS GPF on boot */
 	 .callback = exploding_pnp_bios,
 	 .ident = "Higraded P14H",
diff --git a/drivers/pnp/resource.c b/drivers/pnp/resource.c
index f980ff716..77121c4a8 100644
--- a/drivers/pnp/resource.c
+++ b/drivers/pnp/resource.c
@@ -543,7 +543,7 @@ struct pnp_resource *pnp_add_irq_resource(struct pnp_dev *dev, int irq,
 	return pnp_res;
 }
 
-struct pnp_resource *pnp_add_dma_resource(struct pnp_dev *dev, int dma,
+struct pnp_resource *pnp_add_dma_resource(struct pnp_dev *dev, resource_size_t dma,
 					  int flags)
 {
 	struct pnp_resource *pnp_res;
@@ -551,7 +551,7 @@ struct pnp_resource *pnp_add_dma_resource(struct pnp_dev *dev, int dma,
 
 	pnp_res = pnp_new_resource(dev);
 	if (!pnp_res) {
-		dev_err(&dev->dev, "can't add resource for DMA %d\n", dma);
+		dev_err(&dev->dev, "can't add resource for DMA %lld\n", dma);
 		return NULL;
 	}
 
diff --git a/drivers/power/pda_power.c b/drivers/power/pda_power.c
index dfe1ee89f..67e820cd3 100644
--- a/drivers/power/pda_power.c
+++ b/drivers/power/pda_power.c
@@ -38,7 +38,11 @@ static struct power_supply *pda_psy_ac, *pda_psy_usb;
 
 #if IS_ENABLED(CONFIG_USB_PHY)
 static struct usb_phy *transceiver;
-static struct notifier_block otg_nb;
+static int otg_handle_notification(struct notifier_block *nb,
+		unsigned long event, void *unused);
+static struct notifier_block otg_nb = {
+	.notifier_call = otg_handle_notification
+};
 #endif
 
 static struct regulator *ac_draw;
@@ -373,7 +377,6 @@ static int pda_power_probe(struct platform_device *pdev)
 
 #if IS_ENABLED(CONFIG_USB_PHY)
 	if (!IS_ERR_OR_NULL(transceiver) && pdata->use_otg_notifier) {
-		otg_nb.notifier_call = otg_handle_notification;
 		ret = usb_register_notifier(transceiver, &otg_nb);
 		if (ret) {
 			dev_err(dev, "failure to register otg notifier\n");
diff --git a/drivers/power/power_supply.h b/drivers/power/power_supply.h
index cc439fd89..8fa30df6b 100644
--- a/drivers/power/power_supply.h
+++ b/drivers/power/power_supply.h
@@ -16,12 +16,12 @@ struct power_supply;
 
 #ifdef CONFIG_SYSFS
 
-extern void power_supply_init_attrs(struct device_type *dev_type);
+extern void power_supply_init_attrs(void);
 extern int power_supply_uevent(struct device *dev, struct kobj_uevent_env *env);
 
 #else
 
-static inline void power_supply_init_attrs(struct device_type *dev_type) {}
+static inline void power_supply_init_attrs(void) {}
 #define power_supply_uevent NULL
 
 #endif /* CONFIG_SYSFS */
diff --git a/drivers/power/power_supply_core.c b/drivers/power/power_supply_core.c
index a74d8ca38..c98d74524 100644
--- a/drivers/power/power_supply_core.c
+++ b/drivers/power/power_supply_core.c
@@ -28,7 +28,10 @@ EXPORT_SYMBOL_GPL(power_supply_class);
 ATOMIC_NOTIFIER_HEAD(power_supply_notifier);
 EXPORT_SYMBOL_GPL(power_supply_notifier);
 
-static struct device_type power_supply_dev_type;
+extern const struct attribute_group *power_supply_attr_groups[];
+static struct device_type power_supply_dev_type = {
+	.groups = power_supply_attr_groups,
+};
 
 #define POWER_SUPPLY_DEFERRED_REGISTER_TIME	msecs_to_jiffies(10)
 
@@ -969,7 +972,7 @@ static int __init power_supply_class_init(void)
 		return PTR_ERR(power_supply_class);
 
 	power_supply_class->dev_uevent = power_supply_uevent;
-	power_supply_init_attrs(&power_supply_dev_type);
+	power_supply_init_attrs();
 
 	return 0;
 }
diff --git a/drivers/power/power_supply_sysfs.c b/drivers/power/power_supply_sysfs.c
index bcde8d134..0406331d7 100644
--- a/drivers/power/power_supply_sysfs.c
+++ b/drivers/power/power_supply_sysfs.c
@@ -239,17 +239,15 @@ static struct attribute_group power_supply_attr_group = {
 	.is_visible = power_supply_attr_is_visible,
 };
 
-static const struct attribute_group *power_supply_attr_groups[] = {
+const struct attribute_group *power_supply_attr_groups[] = {
 	&power_supply_attr_group,
 	NULL,
 };
 
-void power_supply_init_attrs(struct device_type *dev_type)
+void power_supply_init_attrs(void)
 {
 	int i;
 
-	dev_type->groups = power_supply_attr_groups;
-
 	for (i = 0; i < ARRAY_SIZE(power_supply_attrs); i++)
 		__power_supply_attrs[i] = &power_supply_attrs[i].attr;
 }
diff --git a/drivers/power/reset/at91-reset.c b/drivers/power/reset/at91-reset.c
index 1b5d45058..b6042f8bc 100644
--- a/drivers/power/reset/at91-reset.c
+++ b/drivers/power/reset/at91-reset.c
@@ -17,6 +17,7 @@
 #include <linux/of_address.h>
 #include <linux/platform_device.h>
 #include <linux/reboot.h>
+#include <asm/pgtable.h>
 
 #include <soc/at91/at91sam9_ddrsdr.h>
 #include <soc/at91/at91sam9_sdramc.h>
@@ -206,7 +207,9 @@ static int __init at91_reset_probe(struct platform_device *pdev)
 	}
 
 	match = of_match_node(at91_reset_of_match, pdev->dev.of_node);
-	at91_restart_nb.notifier_call = match->data;
+	pax_open_kernel();
+	const_cast(at91_restart_nb.notifier_call) = match->data;
+	pax_close_kernel();
 
 	sclk = devm_clk_get(&pdev->dev, NULL);
 	if (IS_ERR(sclk))
diff --git a/drivers/powercap/powercap_sys.c b/drivers/powercap/powercap_sys.c
index 14bde0db8..9391277e5 100644
--- a/drivers/powercap/powercap_sys.c
+++ b/drivers/powercap/powercap_sys.c
@@ -154,8 +154,77 @@ struct powercap_constraint_attr {
 	struct device_attribute name_attr;
 };
 
+static ssize_t show_constraint_name(struct device *dev,
+				struct device_attribute *dev_attr,
+				char *buf);
+
 static struct powercap_constraint_attr
-				constraint_attrs[MAX_CONSTRAINTS_PER_ZONE];
+				constraint_attrs[MAX_CONSTRAINTS_PER_ZONE] = {
+	[0 ... MAX_CONSTRAINTS_PER_ZONE - 1] = {
+		.power_limit_attr = {
+			.attr = {
+				.name	= NULL,
+				.mode	= S_IWUSR | S_IRUGO
+			},
+			.show	= show_constraint_power_limit_uw,
+			.store	= store_constraint_power_limit_uw
+		},
+
+		.time_window_attr = {
+			.attr = {
+				.name	= NULL,
+				.mode	= S_IWUSR | S_IRUGO
+			},
+			.show	= show_constraint_time_window_us,
+			.store	= store_constraint_time_window_us
+		},
+
+		.max_power_attr = {
+			.attr = {
+				.name	= NULL,
+				.mode	= S_IRUGO
+			},
+			.show	= show_constraint_max_power_uw,
+			.store	= NULL
+		},
+
+		.min_power_attr = {
+			.attr = {
+				.name	= NULL,
+				.mode	= S_IRUGO
+			},
+			.show	= show_constraint_min_power_uw,
+			.store	= NULL
+		},
+
+		.max_time_window_attr = {
+			.attr = {
+				.name	= NULL,
+				.mode	= S_IRUGO
+			},
+			.show	= show_constraint_max_time_window_us,
+			.store	= NULL
+		},
+
+		.min_time_window_attr = {
+			.attr = {
+				.name	= NULL,
+				.mode	= S_IRUGO
+			},
+			.show	= show_constraint_min_time_window_us,
+			.store	= NULL
+		},
+
+		.name_attr = {
+			.attr = {
+				.name	= NULL,
+				.mode	= S_IRUGO
+			},
+			.show	= show_constraint_name,
+			.store	= NULL
+		}
+	}
+};
 
 /* A list of powercap control_types */
 static LIST_HEAD(powercap_cntrl_list);
@@ -193,23 +262,16 @@ static ssize_t show_constraint_name(struct device *dev,
 }
 
 static int create_constraint_attribute(int id, const char *name,
-				int mode,
-				struct device_attribute *dev_attr,
-				ssize_t (*show)(struct device *,
-					struct device_attribute *, char *),
-				ssize_t (*store)(struct device *,
-					struct device_attribute *,
-				const char *, size_t)
-				)
+				struct device_attribute *dev_attr)
 {
+	name = kasprintf(GFP_KERNEL, "constraint_%d_%s", id, name);
 
-	dev_attr->attr.name = kasprintf(GFP_KERNEL, "constraint_%d_%s",
-								id, name);
-	if (!dev_attr->attr.name)
+	if (!name)
 		return -ENOMEM;
-	dev_attr->attr.mode = mode;
-	dev_attr->show = show;
-	dev_attr->store = store;
+
+	pax_open_kernel();
+	const_cast(dev_attr->attr.name) = name;
+	pax_close_kernel();
 
 	return 0;
 }
@@ -236,49 +298,31 @@ static int seed_constraint_attributes(void)
 
 	for (i = 0; i < MAX_CONSTRAINTS_PER_ZONE; ++i) {
 		ret = create_constraint_attribute(i, "power_limit_uw",
-					S_IWUSR | S_IRUGO,
-					&constraint_attrs[i].power_limit_attr,
-					show_constraint_power_limit_uw,
-					store_constraint_power_limit_uw);
+					&constraint_attrs[i].power_limit_attr);
 		if (ret)
 			goto err_alloc;
 		ret = create_constraint_attribute(i, "time_window_us",
-					S_IWUSR | S_IRUGO,
-					&constraint_attrs[i].time_window_attr,
-					show_constraint_time_window_us,
-					store_constraint_time_window_us);
+					&constraint_attrs[i].time_window_attr);
 		if (ret)
 			goto err_alloc;
-		ret = create_constraint_attribute(i, "name", S_IRUGO,
-				&constraint_attrs[i].name_attr,
-				show_constraint_name,
-				NULL);
+		ret = create_constraint_attribute(i, "name",
+				&constraint_attrs[i].name_attr);
 		if (ret)
 			goto err_alloc;
-		ret = create_constraint_attribute(i, "max_power_uw", S_IRUGO,
-				&constraint_attrs[i].max_power_attr,
-				show_constraint_max_power_uw,
-				NULL);
+		ret = create_constraint_attribute(i, "max_power_uw",
+				&constraint_attrs[i].max_power_attr);
 		if (ret)
 			goto err_alloc;
-		ret = create_constraint_attribute(i, "min_power_uw", S_IRUGO,
-				&constraint_attrs[i].min_power_attr,
-				show_constraint_min_power_uw,
-				NULL);
+		ret = create_constraint_attribute(i, "min_power_uw",
+				&constraint_attrs[i].min_power_attr);
 		if (ret)
 			goto err_alloc;
 		ret = create_constraint_attribute(i, "max_time_window_us",
-				S_IRUGO,
-				&constraint_attrs[i].max_time_window_attr,
-				show_constraint_max_time_window_us,
-				NULL);
+				&constraint_attrs[i].max_time_window_attr);
 		if (ret)
 			goto err_alloc;
 		ret = create_constraint_attribute(i, "min_time_window_us",
-				S_IRUGO,
-				&constraint_attrs[i].min_time_window_attr,
-				show_constraint_min_time_window_us,
-				NULL);
+				&constraint_attrs[i].min_time_window_attr);
 		if (ret)
 			goto err_alloc;
 
@@ -378,10 +422,12 @@ static void create_power_zone_common_attributes(
 		power_zone->zone_dev_attrs[count++] =
 					&dev_attr_max_energy_range_uj.attr;
 	if (power_zone->ops->get_energy_uj) {
+		pax_open_kernel();
 		if (power_zone->ops->reset_energy_uj)
-			dev_attr_energy_uj.attr.mode = S_IWUSR | S_IRUGO;
+			const_cast(dev_attr_energy_uj.attr.mode) = S_IWUSR | S_IRUGO;
 		else
-			dev_attr_energy_uj.attr.mode = S_IRUGO;
+			const_cast(dev_attr_energy_uj.attr.mode) = S_IRUGO;
+		pax_close_kernel();
 		power_zone->zone_dev_attrs[count++] =
 					&dev_attr_energy_uj.attr;
 	}
diff --git a/drivers/ptp/ptp_private.h b/drivers/ptp/ptp_private.h
index 9c5d41421..c7900ce54 100644
--- a/drivers/ptp/ptp_private.h
+++ b/drivers/ptp/ptp_private.h
@@ -51,7 +51,7 @@ struct ptp_clock {
 	struct mutex pincfg_mux; /* protect concurrent info->pin_config access */
 	wait_queue_head_t tsev_wq;
 	int defunct; /* tells readers to go away when clock is being removed */
-	struct device_attribute *pin_dev_attr;
+	device_attribute_no_const *pin_dev_attr;
 	struct attribute **pin_attr;
 	struct attribute_group pin_attr_group;
 };
diff --git a/drivers/ptp/ptp_sysfs.c b/drivers/ptp/ptp_sysfs.c
index 302e626fe..12579afe5 100644
--- a/drivers/ptp/ptp_sysfs.c
+++ b/drivers/ptp/ptp_sysfs.c
@@ -280,7 +280,7 @@ static int ptp_populate_pins(struct ptp_clock *ptp)
 		goto no_pin_attr;
 
 	for (i = 0; i < n_pins; i++) {
-		struct device_attribute *da = &ptp->pin_dev_attr[i];
+		device_attribute_no_const *da = &ptp->pin_dev_attr[i];
 		sysfs_attr_init(&da->attr);
 		da->attr.name = info->pin_config[i].name;
 		da->attr.mode = 0644;
diff --git a/drivers/regulator/core.c b/drivers/regulator/core.c
index db320e8fa..bbd864de5 100644
--- a/drivers/regulator/core.c
+++ b/drivers/regulator/core.c
@@ -3886,7 +3886,7 @@ regulator_register(const struct regulator_desc *regulator_desc,
 	const struct regulation_constraints *constraints = NULL;
 	const struct regulator_init_data *init_data;
 	struct regulator_config *config = NULL;
-	static atomic_t regulator_no = ATOMIC_INIT(-1);
+	static atomic_unchecked_t regulator_no = ATOMIC_INIT(-1);
 	struct regulator_dev *rdev;
 	struct device *dev;
 	int ret, i;
@@ -3979,7 +3979,7 @@ regulator_register(const struct regulator_desc *regulator_desc,
 	rdev->dev.class = &regulator_class;
 	rdev->dev.parent = dev;
 	dev_set_name(&rdev->dev, "regulator.%lu",
-		    (unsigned long) atomic_inc_return(&regulator_no));
+		    (unsigned long) atomic_inc_return_unchecked(&regulator_no));
 
 	/* set regulator constraints */
 	if (init_data)
diff --git a/drivers/regulator/max8660.c b/drivers/regulator/max8660.c
index b87f62dd4..34f1cdf4a 100644
--- a/drivers/regulator/max8660.c
+++ b/drivers/regulator/max8660.c
@@ -423,8 +423,10 @@ static int max8660_probe(struct i2c_client *client,
 		max8660->shadow_regs[MAX8660_OVER1] = 5;
 	} else {
 		/* Otherwise devices can be toggled via software */
-		max8660_dcdc_ops.enable = max8660_dcdc_enable;
-		max8660_dcdc_ops.disable = max8660_dcdc_disable;
+		pax_open_kernel();
+		const_cast(max8660_dcdc_ops.enable) = max8660_dcdc_enable;
+		const_cast(max8660_dcdc_ops.disable) = max8660_dcdc_disable;
+		pax_close_kernel();
 	}
 
 	/*
diff --git a/drivers/regulator/max8973-regulator.c b/drivers/regulator/max8973-regulator.c
index 3958f50c5..8139dc1ec 100644
--- a/drivers/regulator/max8973-regulator.c
+++ b/drivers/regulator/max8973-regulator.c
@@ -750,9 +750,11 @@ static int max8973_probe(struct i2c_client *client,
 		if (!pdata->enable_ext_control) {
 			max->desc.enable_reg = MAX8973_VOUT;
 			max->desc.enable_mask = MAX8973_VOUT_ENABLE;
-			max->ops.enable = regulator_enable_regmap;
-			max->ops.disable = regulator_disable_regmap;
-			max->ops.is_enabled = regulator_is_enabled_regmap;
+			pax_open_kernel();
+			const_cast(max->ops.enable) = regulator_enable_regmap;
+			const_cast(max->ops.disable) = regulator_disable_regmap;
+			const_cast(max->ops.is_enabled) = regulator_is_enabled_regmap;
+			pax_close_kernel();
 			break;
 		}
 
@@ -780,9 +782,11 @@ static int max8973_probe(struct i2c_client *client,
 
 		max->desc.enable_reg = MAX8973_VOUT;
 		max->desc.enable_mask = MAX8973_VOUT_ENABLE;
-		max->ops.enable = regulator_enable_regmap;
-		max->ops.disable = regulator_disable_regmap;
-		max->ops.is_enabled = regulator_is_enabled_regmap;
+		pax_open_kernel();
+		const_cast(max->ops.enable) = regulator_enable_regmap;
+		const_cast(max->ops.disable) = regulator_disable_regmap;
+		const_cast(max->ops.is_enabled) = regulator_is_enabled_regmap;
+		pax_close_kernel();
 		max->ops.set_current_limit = max8973_set_current_limit;
 		max->ops.get_current_limit = max8973_get_current_limit;
 		break;
diff --git a/drivers/regulator/mc13892-regulator.c b/drivers/regulator/mc13892-regulator.c
index 0d17c9206..ce5897e2f 100644
--- a/drivers/regulator/mc13892-regulator.c
+++ b/drivers/regulator/mc13892-regulator.c
@@ -584,10 +584,12 @@ static int mc13892_regulator_probe(struct platform_device *pdev)
 	mc13xxx_unlock(mc13892);
 
 	/* update mc13892_vcam ops */
-	memcpy(&mc13892_vcam_ops, mc13892_regulators[MC13892_VCAM].desc.ops,
+	pax_open_kernel();
+	memcpy((void *)&mc13892_vcam_ops, mc13892_regulators[MC13892_VCAM].desc.ops,
 						sizeof(struct regulator_ops));
-	mc13892_vcam_ops.set_mode = mc13892_vcam_set_mode,
-	mc13892_vcam_ops.get_mode = mc13892_vcam_get_mode,
+	const_cast(mc13892_vcam_ops.set_mode) = mc13892_vcam_set_mode,
+	const_cast(mc13892_vcam_ops.get_mode) = mc13892_vcam_get_mode,
+	pax_close_kernel();
 	mc13892_regulators[MC13892_VCAM].desc.ops = &mc13892_vcam_ops;
 
 	mc13xxx_data = mc13xxx_parse_regulators_dt(pdev, mc13892_regulators,
diff --git a/drivers/remoteproc/remoteproc_core.c b/drivers/remoteproc/remoteproc_core.c
index 7668ece55..4cdbda60a 100644
--- a/drivers/remoteproc/remoteproc_core.c
+++ b/drivers/remoteproc/remoteproc_core.c
@@ -329,9 +329,10 @@ void rproc_free_vring(struct rproc_vring *rvring)
  *
  * Returns 0 on success, or an appropriate error code otherwise
  */
-static int rproc_handle_vdev(struct rproc *rproc, struct fw_rsc_vdev *rsc,
+static int rproc_handle_vdev(struct rproc *rproc, void *_rsc,
 							int offset, int avail)
 {
+	struct fw_rsc_vdev *rsc = _rsc;
 	struct device *dev = &rproc->dev;
 	struct rproc_vdev *rvdev;
 	int i, ret;
@@ -406,9 +407,10 @@ free_rvdev:
  *
  * Returns 0 on success, or an appropriate error code otherwise
  */
-static int rproc_handle_trace(struct rproc *rproc, struct fw_rsc_trace *rsc,
+static int rproc_handle_trace(struct rproc *rproc, void *_rsc,
 							int offset, int avail)
 {
+	struct fw_rsc_trace *rsc = _rsc;
 	struct rproc_mem_entry *trace;
 	struct device *dev = &rproc->dev;
 	void *ptr;
@@ -486,9 +488,10 @@ static int rproc_handle_trace(struct rproc *rproc, struct fw_rsc_trace *rsc,
  * and not allow firmwares to request access to physical addresses that
  * are outside those ranges.
  */
-static int rproc_handle_devmem(struct rproc *rproc, struct fw_rsc_devmem *rsc,
+static int rproc_handle_devmem(struct rproc *rproc, void *_rsc,
 							int offset, int avail)
 {
+	struct fw_rsc_devmem *rsc = _rsc;
 	struct rproc_mem_entry *mapping;
 	struct device *dev = &rproc->dev;
 	int ret;
@@ -558,10 +561,11 @@ out:
  * pressure is important; it may have a substantial impact on performance.
  */
 static int rproc_handle_carveout(struct rproc *rproc,
-						struct fw_rsc_carveout *rsc,
+						void *_rsc,
 						int offset, int avail)
 
 {
+	struct fw_rsc_carveout *rsc = _rsc;
 	struct rproc_mem_entry *carveout, *mapping;
 	struct device *dev = &rproc->dev;
 	dma_addr_t dma;
@@ -680,9 +684,11 @@ free_carv:
 	return ret;
 }
 
-static int rproc_count_vrings(struct rproc *rproc, struct fw_rsc_vdev *rsc,
+static int rproc_count_vrings(struct rproc *rproc, void *_rsc,
 			      int offset, int avail)
 {
+	struct fw_rsc_vdev *rsc = _rsc;
+
 	/* Summarize the number of notification IDs */
 	rproc->max_notifyid += rsc->num_of_vrings;
 
@@ -694,18 +700,18 @@ static int rproc_count_vrings(struct rproc *rproc, struct fw_rsc_vdev *rsc,
  * enum fw_resource_type.
  */
 static rproc_handle_resource_t rproc_loading_handlers[RSC_LAST] = {
-	[RSC_CARVEOUT] = (rproc_handle_resource_t)rproc_handle_carveout,
-	[RSC_DEVMEM] = (rproc_handle_resource_t)rproc_handle_devmem,
-	[RSC_TRACE] = (rproc_handle_resource_t)rproc_handle_trace,
+	[RSC_CARVEOUT] = rproc_handle_carveout,
+	[RSC_DEVMEM] = rproc_handle_devmem,
+	[RSC_TRACE] = rproc_handle_trace,
 	[RSC_VDEV] = NULL, /* VDEVs were handled upon registrarion */
 };
 
 static rproc_handle_resource_t rproc_vdev_handler[RSC_LAST] = {
-	[RSC_VDEV] = (rproc_handle_resource_t)rproc_handle_vdev,
+	[RSC_VDEV] = rproc_handle_vdev,
 };
 
 static rproc_handle_resource_t rproc_count_vrings_handler[RSC_LAST] = {
-	[RSC_VDEV] = (rproc_handle_resource_t)rproc_count_vrings,
+	[RSC_VDEV] = rproc_count_vrings,
 };
 
 /* handle firmware resource entries before booting the remote processor */
diff --git a/drivers/rtc/rtc-armada38x.c b/drivers/rtc/rtc-armada38x.c
index 9a3f2a6f5..c19b00a13 100644
--- a/drivers/rtc/rtc-armada38x.c
+++ b/drivers/rtc/rtc-armada38x.c
@@ -18,6 +18,7 @@
 #include <linux/of.h>
 #include <linux/platform_device.h>
 #include <linux/rtc.h>
+#include <asm/pgtable.h>
 
 #define RTC_STATUS	    0x0
 #define RTC_STATUS_ALARM1	    BIT(0)
@@ -246,8 +247,10 @@ static __init int armada38x_rtc_probe(struct platform_device *pdev)
 		 * If there is no interrupt available then we can't
 		 * use the alarm
 		 */
-		armada38x_rtc_ops.set_alarm = NULL;
-		armada38x_rtc_ops.alarm_irq_enable = NULL;
+		pax_open_kernel();
+		const_cast(armada38x_rtc_ops.set_alarm) = NULL;
+		const_cast(armada38x_rtc_ops.alarm_irq_enable) = NULL;
+		pax_close_kernel();
 	}
 	platform_set_drvdata(pdev, rtc);
 	if (rtc->irq != -1)
diff --git a/drivers/rtc/rtc-cmos.c b/drivers/rtc/rtc-cmos.c
index 43745cac0..9eb24ff43 100644
--- a/drivers/rtc/rtc-cmos.c
+++ b/drivers/rtc/rtc-cmos.c
@@ -732,7 +732,9 @@ cmos_do_probe(struct device *dev, struct resource *ports, int rtc_irq)
 	hpet_rtc_timer_init();
 
 	/* export at least the first block of NVRAM */
-	nvram.size = address_space - NVRAM_OFFSET;
+	pax_open_kernel();
+	const_cast(nvram.size) = address_space - NVRAM_OFFSET;
+	pax_close_kernel();
 	retval = sysfs_create_bin_file(&dev->kobj, &nvram);
 	if (retval < 0) {
 		dev_dbg(dev, "can't create nvram file? %d\n", retval);
diff --git a/drivers/rtc/rtc-dev.c b/drivers/rtc/rtc-dev.c
index a6d9434ad..dc26b717b 100644
--- a/drivers/rtc/rtc-dev.c
+++ b/drivers/rtc/rtc-dev.c
@@ -16,6 +16,7 @@
 #include <linux/module.h>
 #include <linux/rtc.h>
 #include <linux/sched.h>
+#include <linux/grsecurity.h>
 #include "rtc-core.h"
 
 static dev_t rtc_devt;
@@ -347,6 +348,8 @@ static long rtc_dev_ioctl(struct file *file,
 		if (copy_from_user(&tm, uarg, sizeof(tm)))
 			return -EFAULT;
 
+		gr_log_timechange();
+
 		return rtc_set_time(rtc, &tm);
 
 	case RTC_PIE_ON:
diff --git a/drivers/rtc/rtc-ds1307.c b/drivers/rtc/rtc-ds1307.c
index 8e1c5cb6e..6fe95b959 100644
--- a/drivers/rtc/rtc-ds1307.c
+++ b/drivers/rtc/rtc-ds1307.c
@@ -111,7 +111,7 @@ struct ds1307 {
 	u8			offset; /* register's offset */
 	u8			regs[11];
 	u16			nvram_offset;
-	struct bin_attribute	*nvram;
+	bin_attribute_no_const	*nvram;
 	enum ds_type		type;
 	unsigned long		flags;
 #define HAS_NVRAM	0		/* bit 0 == sysfs file active */
diff --git a/drivers/rtc/rtc-m41t80.c b/drivers/rtc/rtc-m41t80.c
index 58698d21c..8560ebf9e 100644
--- a/drivers/rtc/rtc-m41t80.c
+++ b/drivers/rtc/rtc-m41t80.c
@@ -798,9 +798,11 @@ static int m41t80_probe(struct i2c_client *client,
 			dev_warn(&client->dev, "unable to request IRQ, alarms disabled\n");
 			client->irq = 0;
 		} else {
-			m41t80_rtc_ops.read_alarm = m41t80_read_alarm;
-			m41t80_rtc_ops.set_alarm = m41t80_set_alarm;
-			m41t80_rtc_ops.alarm_irq_enable = m41t80_alarm_irq_enable;
+			pax_open_kernel();
+			const_cast(m41t80_rtc_ops.read_alarm) = m41t80_read_alarm;
+			const_cast(m41t80_rtc_ops.set_alarm) = m41t80_set_alarm;
+			const_cast(m41t80_rtc_ops.alarm_irq_enable) = m41t80_alarm_irq_enable;
+			pax_close_kernel();
 			/* Enable the wakealarm */
 			device_init_wakeup(&client->dev, true);
 		}
diff --git a/drivers/rtc/rtc-m48t59.c b/drivers/rtc/rtc-m48t59.c
index d99a705be..99654e778 100644
--- a/drivers/rtc/rtc-m48t59.c
+++ b/drivers/rtc/rtc-m48t59.c
@@ -485,7 +485,9 @@ static int m48t59_rtc_probe(struct platform_device *pdev)
 	if (IS_ERR(m48t59->rtc))
 		return PTR_ERR(m48t59->rtc);
 
-	m48t59_nvram_attr.size = pdata->offset;
+	pax_open_kernel();
+	const_cast(m48t59_nvram_attr.size) = pdata->offset;
+	pax_close_kernel();
 
 	ret = sysfs_create_bin_file(&pdev->dev.kobj, &m48t59_nvram_attr);
 	if (ret)
diff --git a/drivers/rtc/rtc-rv3029c2.c b/drivers/rtc/rtc-rv3029c2.c
index 1f9f7b4bf..6f8788371 100644
--- a/drivers/rtc/rtc-rv3029c2.c
+++ b/drivers/rtc/rtc-rv3029c2.c
@@ -832,9 +832,11 @@ static int rv3029_probe(struct device *dev, struct regmap *regmap, int irq,
 			dev_warn(dev, "unable to request IRQ, alarms disabled\n");
 			rv3029->irq = 0;
 		} else {
-			rv3029_rtc_ops.read_alarm = rv3029_read_alarm;
-			rv3029_rtc_ops.set_alarm = rv3029_set_alarm;
-			rv3029_rtc_ops.alarm_irq_enable = rv3029_alarm_irq_enable;
+			pax_open_kernel();
+			const_cast(rv3029_rtc_ops.read_alarm) = rv3029_read_alarm;
+			const_cast(rv3029_rtc_ops.set_alarm) = rv3029_set_alarm;
+			const_cast(rv3029_rtc_ops.alarm_irq_enable) = rv3029_alarm_irq_enable;
+			pax_close_kernel();
 		}
 	}
 
diff --git a/drivers/rtc/rtc-rv8803.c b/drivers/rtc/rtc-rv8803.c
index 9a2f6a95d..da6bfcb01 100644
--- a/drivers/rtc/rtc-rv8803.c
+++ b/drivers/rtc/rtc-rv8803.c
@@ -497,6 +497,15 @@ static struct rtc_class_ops rv8803_rtc_ops = {
 	.ioctl = rv8803_ioctl,
 };
 
+static struct rtc_class_ops rv8803_rtc_alarm_ops = {
+	.read_time = rv8803_get_time,
+	.set_time = rv8803_set_time,
+	.ioctl = rv8803_ioctl,
+	.read_alarm = rv8803_get_alarm,
+	.set_alarm = rv8803_set_alarm,
+	.alarm_irq_enable = rv8803_alarm_irq_enable,
+};
+
 static int rv8803_probe(struct i2c_client *client,
 			const struct i2c_device_id *id)
 {
@@ -540,15 +549,11 @@ static int rv8803_probe(struct i2c_client *client,
 		if (err) {
 			dev_warn(&client->dev, "unable to request IRQ, alarms disabled\n");
 			client->irq = 0;
-		} else {
-			rv8803_rtc_ops.read_alarm = rv8803_get_alarm;
-			rv8803_rtc_ops.set_alarm = rv8803_set_alarm;
-			rv8803_rtc_ops.alarm_irq_enable = rv8803_alarm_irq_enable;
 		}
 	}
 
 	rv8803->rtc = devm_rtc_device_register(&client->dev, client->name,
-					       &rv8803_rtc_ops, THIS_MODULE);
+					       client->irq > 0 ? &rv8803_rtc_alarm_ops : &rv8803_rtc_ops, THIS_MODULE);
 	if (IS_ERR(rv8803->rtc)) {
 		dev_err(&client->dev, "unable to register the class device\n");
 		return PTR_ERR(rv8803->rtc);
diff --git a/drivers/rtc/rtc-rx8010.c b/drivers/rtc/rtc-rx8010.c
index 7163b91bb..d7a2c3113 100644
--- a/drivers/rtc/rtc-rx8010.c
+++ b/drivers/rtc/rtc-rx8010.c
@@ -483,9 +483,11 @@ static int rx8010_probe(struct i2c_client *client,
 			dev_err(&client->dev, "unable to request IRQ\n");
 			client->irq = 0;
 		} else {
-			rx8010_rtc_ops.read_alarm = rx8010_read_alarm;
-			rx8010_rtc_ops.set_alarm = rx8010_set_alarm;
-			rx8010_rtc_ops.alarm_irq_enable = rx8010_alarm_irq_enable;
+			pax_open_kernel();
+			const_cast(rx8010_rtc_ops.read_alarm) = rx8010_read_alarm;
+			const_cast(rx8010_rtc_ops.set_alarm) = rx8010_set_alarm;
+			const_cast(rx8010_rtc_ops.alarm_irq_enable) = rx8010_alarm_irq_enable;
+			pax_close_kernel();
 		}
 	}
 
diff --git a/drivers/rtc/rtc-test.c b/drivers/rtc/rtc-test.c
index 3a2da4c89..1d1d4b112 100644
--- a/drivers/rtc/rtc-test.c
+++ b/drivers/rtc/rtc-test.c
@@ -112,8 +112,10 @@ static int test_probe(struct platform_device *plat_dev)
 	struct rtc_device *rtc;
 
 	if (test_mmss64) {
-		test_rtc_ops.set_mmss64 = test_rtc_set_mmss64;
-		test_rtc_ops.set_mmss = NULL;
+		pax_open_kernel();
+		const_cast(test_rtc_ops.set_mmss64) = test_rtc_set_mmss64;
+		const_cast(test_rtc_ops.set_mmss) = NULL;
+		pax_close_kernel();
 	}
 
 	rtc = devm_rtc_device_register(&plat_dev->dev, "test",
diff --git a/drivers/scsi/aacraid/aachba.c b/drivers/scsi/aacraid/aachba.c
index 6678d1fd8..0293b70d9 100644
--- a/drivers/scsi/aacraid/aachba.c
+++ b/drivers/scsi/aacraid/aachba.c
@@ -770,6 +770,11 @@ static int aac_probe_container_callback1(struct scsi_cmnd * scsicmd)
 	return 0;
 }
 
+static void aac_probe_container_scsi_done(struct scsi_cmnd * scsicmd)
+{
+	scsicmd->device = NULL;
+}
+
 int aac_probe_container(struct aac_dev *dev, int cid)
 {
 	struct scsi_cmnd *scsicmd = kmalloc(sizeof(*scsicmd), GFP_KERNEL);
@@ -782,7 +787,7 @@ int aac_probe_container(struct aac_dev *dev, int cid)
 		return -ENOMEM;
 	}
 	scsicmd->list.next = NULL;
-	scsicmd->scsi_done = (void (*)(struct scsi_cmnd*))aac_probe_container_callback1;
+	scsicmd->scsi_done = aac_probe_container_scsi_done;
 
 	scsicmd->device = scsidev;
 	scsidev->sdev_state = 0;
diff --git a/drivers/scsi/aic7xxx/aic79xx.h b/drivers/scsi/aic7xxx/aic79xx.h
index d47b527b2..f2c4a8933 100644
--- a/drivers/scsi/aic7xxx/aic79xx.h
+++ b/drivers/scsi/aic7xxx/aic79xx.h
@@ -1046,7 +1046,7 @@ typedef enum {
 
 typedef uint8_t ahd_mode_state;
 
-typedef void ahd_callback_t (void *);
+typedef void ahd_linux_callback_t (u_long);
 
 struct ahd_completion
 {
diff --git a/drivers/scsi/aic7xxx/aic79xx_core.c b/drivers/scsi/aic7xxx/aic79xx_core.c
index 109e2c99e..7d3c9b542 100644
--- a/drivers/scsi/aic7xxx/aic79xx_core.c
+++ b/drivers/scsi/aic7xxx/aic79xx_core.c
@@ -207,7 +207,7 @@ static void		ahd_add_scb_to_free_list(struct ahd_softc *ahd,
 static u_int		ahd_rem_wscb(struct ahd_softc *ahd, u_int scbid,
 				     u_int prev, u_int next, u_int tid);
 static void		ahd_reset_current_bus(struct ahd_softc *ahd);
-static ahd_callback_t	ahd_stat_timer;
+static ahd_linux_callback_t	ahd_stat_timer;
 #ifdef AHD_DUMP_SEQ
 static void		ahd_dumpseq(struct ahd_softc *ahd);
 #endif
@@ -7041,10 +7041,9 @@ static const char *termstat_strings[] = {
 /***************************** Timer Facilities *******************************/
 #define ahd_timer_init init_timer
 #define ahd_timer_stop del_timer_sync
-typedef void ahd_linux_callback_t (u_long);
 
 static void
-ahd_timer_reset(ahd_timer_t *timer, int usec, ahd_callback_t *func, void *arg)
+ahd_timer_reset(ahd_timer_t *timer, int usec, ahd_linux_callback_t *func, void *arg)
 {
 	struct ahd_softc *ahd;
 
@@ -7052,7 +7051,7 @@ ahd_timer_reset(ahd_timer_t *timer, int usec, ahd_callback_t *func, void *arg)
 	del_timer(timer);
 	timer->data = (u_long)arg;
 	timer->expires = jiffies + (usec * HZ)/1000000;
-	timer->function = (ahd_linux_callback_t*)func;
+	timer->function = func;
 	add_timer(timer);
 }
 
@@ -8878,9 +8877,9 @@ ahd_reset_channel(struct ahd_softc *ahd, char channel, int initiate_reset)
 
 /**************************** Statistics Processing ***************************/
 static void
-ahd_stat_timer(void *arg)
+ahd_stat_timer(unsigned long arg)
 {
-	struct	ahd_softc *ahd = arg;
+	struct	ahd_softc *ahd = (struct ahd_softc *)arg;
 	u_long	s;
 	int	enint_coal;
 	
diff --git a/drivers/scsi/be2iscsi/be_main.c b/drivers/scsi/be2iscsi/be_main.c
index f05e77371..b48c4187b 100644
--- a/drivers/scsi/be2iscsi/be_main.c
+++ b/drivers/scsi/be2iscsi/be_main.c
@@ -5465,7 +5465,7 @@ beiscsi_hw_health_check(struct work_struct *work)
 
 
 static pci_ers_result_t beiscsi_eeh_err_detected(struct pci_dev *pdev,
-		pci_channel_state_t state)
+		enum pci_channel_state state)
 {
 	struct beiscsi_hba *phba = NULL;
 
diff --git a/drivers/scsi/bfa/bfa.h b/drivers/scsi/bfa/bfa.h
index 0e119d838..1bf8a4946 100644
--- a/drivers/scsi/bfa/bfa.h
+++ b/drivers/scsi/bfa/bfa.h
@@ -225,8 +225,10 @@ struct bfa_faa_args_s {
 	bfa_boolean_t		busy;
 };
 
+enum iocfc_event;
+
 struct bfa_iocfc_s {
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bfa_iocfc_s *, enum iocfc_event);
 	struct bfa_s		*bfa;
 	struct bfa_iocfc_cfg_s	cfg;
 	u32		req_cq_pi[BFI_IOC_MAX_CQS];
diff --git a/drivers/scsi/bfa/bfa_core.c b/drivers/scsi/bfa/bfa_core.c
index 7209afad8..2450c1255 100644
--- a/drivers/scsi/bfa/bfa_core.c
+++ b/drivers/scsi/bfa/bfa_core.c
@@ -1919,15 +1919,13 @@ bfa_comp_process(struct bfa_s *bfa, struct list_head *comp_q)
 	struct list_head		*qe;
 	struct list_head		*qen;
 	struct bfa_cb_qe_s	*hcb_qe;
-	bfa_cb_cbfn_status_t	cbfn;
 
 	list_for_each_safe(qe, qen, comp_q) {
 		hcb_qe = (struct bfa_cb_qe_s *) qe;
 		if (hcb_qe->pre_rmv) {
 			/* qe is invalid after return, dequeue before cbfn() */
 			list_del(qe);
-			cbfn = (bfa_cb_cbfn_status_t)(hcb_qe->cbfn);
-			cbfn(hcb_qe->cbarg, hcb_qe->fw_status);
+			hcb_qe->cbfn(hcb_qe->cbarg, hcb_qe->fw_status);
 		} else
 			hcb_qe->cbfn(hcb_qe->cbarg, BFA_TRUE);
 	}
diff --git a/drivers/scsi/bfa/bfa_cs.h b/drivers/scsi/bfa/bfa_cs.h
index df6760ca0..3b22f4da7 100644
--- a/drivers/scsi/bfa/bfa_cs.h
+++ b/drivers/scsi/bfa/bfa_cs.h
@@ -184,8 +184,6 @@ bfa_q_is_on_q_func(struct list_head *q, struct list_head *qe)
  * @ BFA state machine interfaces
  */
 
-typedef void (*bfa_sm_t)(void *sm, int event);
-
 /*
  * oc - object class eg. bfa_ioc
  * st - state, eg. reset
@@ -195,20 +193,75 @@ typedef void (*bfa_sm_t)(void *sm, int event);
 #define bfa_sm_state_decl(oc, st, otype, etype)		\
 	static void oc ## _sm_ ## st(otype * fsm, etype event)
 
-#define bfa_sm_set_state(_sm, _state)	((_sm)->sm = (bfa_sm_t)(_state))
+#define bfa_sm_set_state(_sm, _state)	((_sm)->sm = (_state))
 #define bfa_sm_send_event(_sm, _event)	((_sm)->sm((_sm), (_event)))
 #define bfa_sm_get_state(_sm)		((_sm)->sm)
-#define bfa_sm_cmp_state(_sm, _state)	((_sm)->sm == (bfa_sm_t)(_state))
+#define bfa_sm_cmp_state(_sm, _state)	((_sm)->sm == (_state))
 
 /*
  * For converting from state machine function to state encoding.
  */
-struct bfa_sm_table_s {
-	bfa_sm_t	sm;	/*  state machine function	*/
+struct bfa_iocpf_s;
+enum iocpf_event;
+typedef void (*bfa_fsm_iocpf_t)(struct bfa_iocpf_s *, enum iocpf_event);
+
+struct iocpf_sm_table_s {
+	bfa_fsm_iocpf_t sm;	/*  state machine function	*/
+	int		state;	/*  state machine encoding	*/
+	char		*name;	/*  state name for display	*/
+};
+
+struct bfa_ioc_s;
+enum ioc_event;
+typedef void (*bfa_fsm_ioc_t)(struct bfa_ioc_s *, enum ioc_event);
+
+struct ioc_sm_table_s {
+	bfa_fsm_ioc_t sm;	/*  state machine function	*/
 	int		state;	/*  state machine encoding	*/
 	char		*name;	/*  state name for display	*/
 };
-#define BFA_SM(_sm)	((bfa_sm_t)(_sm))
+
+struct bfa_fcs_rport_s;
+enum rport_event;
+typedef void(*bfa_fcs_rport_t)(struct bfa_fcs_rport_s *, enum rport_event);
+
+struct rport_sm_table_s {
+	bfa_fcs_rport_t sm;	/*  state machine function	*/
+	int		state;	/*  state machine encoding	*/
+	char		*name;	/*  state name for display	*/
+};
+
+struct bfa_fcs_vport_s;
+enum bfa_fcs_vport_event;
+typedef void(*bfa_fcs_vport_t)(struct bfa_fcs_vport_s *, enum bfa_fcs_vport_event);
+
+struct vport_sm_table_s {
+	bfa_fcs_vport_t sm;	/*  state machine function	*/
+	int		state;	/*  state machine encoding	*/
+	char		*name;	/*  state name for display	*/
+};
+
+struct bfa_fcs_itnim_s;
+enum bfa_fcs_itnim_event;
+typedef void(*bfa_fcs_itnim_t)(struct bfa_fcs_itnim_s *, enum bfa_fcs_itnim_event);
+
+struct itnim_sm_table_s {
+	bfa_fcs_itnim_t sm;	/*  state machine function	*/
+	int		state;	/*  state machine encoding	*/
+	char		*name;	/*  state name for display	*/
+};
+
+struct bfa_fcport_s;
+enum bfa_fcport_sm_event;
+typedef void(*bfa_fcport_t)(struct bfa_fcport_s *, enum bfa_fcport_sm_event);
+
+struct fcport_sm_table_s {
+	bfa_fcport_t sm;	/*  state machine function	*/
+	int		state;	/*  state machine encoding	*/
+	char		*name;	/*  state name for display	*/
+};
+
+#define BFA_SM(_sm)	(_sm)
 
 /*
  * State machine with entry actions.
@@ -226,17 +279,66 @@ typedef void (*bfa_fsm_t)(void *fsm, int event);
 	static void oc ## _sm_ ## st ## _entry(otype * fsm)
 
 #define bfa_fsm_set_state(_fsm, _state) do {	\
-	(_fsm)->fsm = (bfa_fsm_t)(_state);      \
+	(_fsm)->fsm = (_state);      \
 	_state ## _entry(_fsm);      \
 } while (0)
 
 #define bfa_fsm_send_event(_fsm, _event)	((_fsm)->fsm((_fsm), (_event)))
 #define bfa_fsm_get_state(_fsm)			((_fsm)->fsm)
-#define bfa_fsm_cmp_state(_fsm, _state)		\
-	((_fsm)->fsm == (bfa_fsm_t)(_state))
+#define bfa_fsm_cmp_state(_fsm, _state)		((_fsm)->fsm == (_state))
+
+static inline int
+iocpf_sm_to_state(struct iocpf_sm_table_s *smt, bfa_fsm_iocpf_t sm)
+{
+	int	i = 0;
+
+	while (smt[i].sm && smt[i].sm != sm)
+		i++;
+	return smt[i].state;
+}
+
+static inline int
+ioc_sm_to_state(struct ioc_sm_table_s *smt, bfa_fsm_ioc_t sm)
+{
+	int	i = 0;
+
+	while (smt[i].sm && smt[i].sm != sm)
+		i++;
+	return smt[i].state;
+}
+
+static inline int
+rport_sm_to_state(struct rport_sm_table_s *smt, bfa_fcs_rport_t sm)
+{
+	int	i = 0;
+
+	while (smt[i].sm && smt[i].sm != sm)
+		i++;
+	return smt[i].state;
+}
+
+static inline int
+vport_sm_to_state(struct vport_sm_table_s *smt, bfa_fcs_vport_t sm)
+{
+	int	i = 0;
+
+	while (smt[i].sm && smt[i].sm != sm)
+		i++;
+	return smt[i].state;
+}
+
+static inline int
+itnim_sm_to_state(struct itnim_sm_table_s *smt, bfa_fcs_itnim_t sm)
+{
+	int	i = 0;
+
+	while (smt[i].sm && smt[i].sm != sm)
+		i++;
+	return smt[i].state;
+}
 
 static inline int
-bfa_sm_to_state(struct bfa_sm_table_s *smt, bfa_sm_t sm)
+fcport_sm_to_state(struct fcport_sm_table_s *smt, bfa_fcport_t sm)
 {
 	int	i = 0;
 
diff --git a/drivers/scsi/bfa/bfa_fcpim.h b/drivers/scsi/bfa/bfa_fcpim.h
index e93921dec..ee6b4c0fb 100644
--- a/drivers/scsi/bfa/bfa_fcpim.h
+++ b/drivers/scsi/bfa/bfa_fcpim.h
@@ -37,7 +37,7 @@ struct bfa_iotag_s {
 
 struct bfa_itn_s {
 	bfa_isr_func_t isr;
-};
+} __no_const;
 
 void bfa_itn_create(struct bfa_s *bfa, struct bfa_rport_s *rport,
 		void (*isr)(struct bfa_s *bfa, struct bfi_msg_s *m));
@@ -165,9 +165,11 @@ struct bfa_fcp_mod_s {
 /*
  * BFA IO (initiator mode)
  */
+enum bfa_ioim_event;
+
 struct bfa_ioim_s {
 	struct list_head	qe;		/*  queue elememt	*/
-	bfa_sm_t		sm;		/*  BFA ioim state machine */
+	void (*sm)(struct bfa_ioim_s *, enum bfa_ioim_event);/*  BFA ioim state machine */
 	struct bfa_s		*bfa;		/*  BFA module	*/
 	struct bfa_fcpim_s	*fcpim;		/*  parent fcpim module */
 	struct bfa_itnim_s	*itnim;		/*  i-t-n nexus for this IO  */
@@ -197,9 +199,11 @@ struct bfa_ioim_sp_s {
 /*
  * BFA Task management command (initiator mode)
  */
+enum bfa_tskim_event;
+
 struct bfa_tskim_s {
 	struct list_head	qe;
-	bfa_sm_t		sm;
+	void (*sm)(struct bfa_tskim_s *, enum bfa_tskim_event);
 	struct bfa_s		*bfa;	/*  BFA module  */
 	struct bfa_fcpim_s	*fcpim;	/*  parent fcpim module	*/
 	struct bfa_itnim_s	*itnim;	/*  i-t-n nexus for this IO  */
@@ -219,9 +223,11 @@ struct bfa_tskim_s {
 /*
  * BFA i-t-n (initiator mode)
  */
+enum bfa_itnim_event;
+
 struct bfa_itnim_s {
 	struct list_head	qe;	/*  queue element	*/
-	bfa_sm_t		sm;	/*  i-t-n im BFA state machine  */
+	void (*sm)(struct bfa_itnim_s *, enum bfa_itnim_event);/*  i-t-n im BFA state machine  */
 	struct bfa_s		*bfa;	/*  bfa instance	*/
 	struct bfa_rport_s	*rport;	/*  bfa rport	*/
 	void			*ditn;	/*  driver i-t-n structure	*/
diff --git a/drivers/scsi/bfa/bfa_fcs.c b/drivers/scsi/bfa/bfa_fcs.c
index 1e7e139d7..c2031dd6a 100644
--- a/drivers/scsi/bfa/bfa_fcs.c
+++ b/drivers/scsi/bfa/bfa_fcs.c
@@ -39,10 +39,21 @@ struct bfa_fcs_mod_s {
 #define BFA_FCS_MODULE(_mod) { _mod ## _modinit, _mod ## _modexit }
 
 static struct bfa_fcs_mod_s fcs_modules[] = {
-	{ bfa_fcs_port_attach, NULL, NULL },
-	{ bfa_fcs_uf_attach, NULL, NULL },
-	{ bfa_fcs_fabric_attach, bfa_fcs_fabric_modinit,
-	  bfa_fcs_fabric_modexit },
+	{
+		.attach = bfa_fcs_port_attach,
+		.modinit = NULL,
+		.modexit = NULL
+	},
+	{
+		.attach = bfa_fcs_uf_attach,
+		.modinit = NULL,
+		.modexit = NULL
+	},
+	{
+		.attach = bfa_fcs_fabric_attach,
+		.modinit = bfa_fcs_fabric_modinit,
+		.modexit = bfa_fcs_fabric_modexit
+	},
 };
 
 /*
diff --git a/drivers/scsi/bfa/bfa_fcs.h b/drivers/scsi/bfa/bfa_fcs.h
index 0f797a55d..73b170a3c 100644
--- a/drivers/scsi/bfa/bfa_fcs.h
+++ b/drivers/scsi/bfa/bfa_fcs.h
@@ -67,8 +67,10 @@ struct bfa_fcs_s;
 #define BFA_FCS_PID_IS_WKA(pid)  ((bfa_ntoh3b(pid) > 0xFFF000) ?  1 : 0)
 #define BFA_FCS_MAX_RPORT_LOGINS 1024
 
+enum vport_ns_event;
+
 struct bfa_fcs_lport_ns_s {
-	bfa_sm_t        sm;		/*  state machine */
+	void (*sm)(struct bfa_fcs_lport_ns_s *, enum vport_ns_event);/*  state machine */
 	struct bfa_timer_s timer;
 	struct bfa_fcs_lport_s *port;	/*  parent port */
 	struct bfa_fcxp_s *fcxp;
@@ -77,18 +79,20 @@ struct bfa_fcs_lport_ns_s {
 	u8	num_rsnn_nn_retries;
 };
 
+enum port_scn_event;
 
 struct bfa_fcs_lport_scn_s {
-	bfa_sm_t        sm;		/*  state machine */
+	void (*sm)(struct bfa_fcs_lport_scn_s *, enum port_scn_event);/*  state machine */
 	struct bfa_timer_s timer;
 	struct bfa_fcs_lport_s *port;	/*  parent port */
 	struct bfa_fcxp_s *fcxp;
 	struct bfa_fcxp_wqe_s fcxp_wqe;
 };
 
+enum port_fdmi_event;
 
 struct bfa_fcs_lport_fdmi_s {
-	bfa_sm_t        sm;		/*  state machine */
+	void (*sm)(struct bfa_fcs_lport_fdmi_s *, enum port_fdmi_event);/*  state machine */
 	struct bfa_timer_s timer;
 	struct bfa_fcs_lport_ms_s *ms;	/*  parent ms */
 	struct bfa_fcxp_s *fcxp;
@@ -97,9 +101,10 @@ struct bfa_fcs_lport_fdmi_s {
 	u8	rsvd[3];
 };
 
+enum port_ms_event;
 
 struct bfa_fcs_lport_ms_s {
-	bfa_sm_t        sm;		/*  state machine */
+	void (*sm)(struct bfa_fcs_lport_ms_s *, enum port_ms_event);/*  state machine */
 	struct bfa_timer_s timer;
 	struct bfa_fcs_lport_s *port;	/*  parent port */
 	struct bfa_fcxp_s *fcxp;
@@ -139,10 +144,11 @@ union bfa_fcs_lport_topo_u {
 	struct bfa_fcs_lport_n2n_s pn2n;
 };
 
+enum bfa_fcs_lport_event;
 
 struct bfa_fcs_lport_s {
 	struct list_head         qe;	/*  used by port/vport */
-	bfa_sm_t               sm;	/*  state machine */
+	void (*sm)(struct bfa_fcs_lport_s *, enum bfa_fcs_lport_event);	/*  state machine */
 	struct bfa_fcs_fabric_s *fabric;	/*  parent fabric */
 	struct bfa_lport_cfg_s  port_cfg;	/*  port configuration */
 	struct bfa_timer_s link_timer;	/*  timer for link offline */
@@ -179,10 +185,11 @@ enum bfa_fcs_fabric_type {
 	BFA_FCS_FABRIC_LOOP = 3,
 };
 
+enum bfa_fcs_fabric_event;
 
 struct bfa_fcs_fabric_s {
 	struct list_head   qe;		/*  queue element */
-	bfa_sm_t	 sm;		/*  state machine */
+	void (*sm)(struct bfa_fcs_fabric_s *, enum bfa_fcs_fabric_event); /*  state machine */
 	struct bfa_fcs_s *fcs;		/*  FCS instance */
 	struct bfa_fcs_lport_s  bport;	/*  base logical port */
 	enum bfa_fcs_fabric_type fab_type; /*  fabric type */
@@ -355,9 +362,11 @@ void            bfa_fcs_lport_scn_process_rscn(struct bfa_fcs_lport_s *port,
 					      struct fchs_s *rx_frame, u32 len);
 void		bfa_fcs_lport_lip_scn_online(bfa_fcs_lport_t *port);
 
+enum bfa_fcs_vport_event;
+
 struct bfa_fcs_vport_s {
 	struct list_head		qe;		/*  queue elem	*/
-	bfa_sm_t		sm;		/*  state machine	*/
+	void (*sm)(struct bfa_fcs_vport_s *, enum bfa_fcs_vport_event);/*  state machine	*/
 	bfa_fcs_lport_t		lport;		/*  logical port	*/
 	struct bfa_timer_s	timer;
 	struct bfad_vport_s	*vport_drv;	/*  Driver private	*/
@@ -409,8 +418,10 @@ struct bfa_fcs_tin_s;
 struct bfa_fcs_iprp_s;
 
 /* Rport Features (RPF) */
+enum rpf_event;
+
 struct bfa_fcs_rpf_s {
-	bfa_sm_t	sm;	/*  state machine */
+	void (*sm)(struct bfa_fcs_rpf_s *, enum rpf_event); /*  state machine */
 	struct bfa_fcs_rport_s *rport;	/*  parent rport */
 	struct bfa_timer_s	timer;	/*  general purpose timer */
 	struct bfa_fcxp_s	*fcxp;	/*  FCXP needed for discarding */
@@ -425,6 +436,8 @@ struct bfa_fcs_rpf_s {
 	 */
 };
 
+enum rport_event;
+
 struct bfa_fcs_rport_s {
 	struct list_head	qe;	/*  used by port/vport */
 	struct bfa_fcs_lport_s *port;	/*  parent FCS port */
@@ -441,7 +454,7 @@ struct bfa_fcs_rport_s {
 	wwn_t	pwwn;	/*  port wwn of rport */
 	wwn_t	nwwn;	/*  node wwn of rport */
 	struct bfa_rport_symname_s psym_name; /*  port symbolic name  */
-	bfa_sm_t	sm;		/*  state machine */
+	void (*sm)(struct bfa_fcs_rport_s *, enum rport_event); /*  state machine */
 	struct bfa_timer_s timer;	/*  general purpose timer */
 	struct bfa_fcs_itnim_s *itnim;	/*  ITN initiator mode role */
 	struct bfa_fcs_tin_s *tin;	/*  ITN initiator mode role */
@@ -502,9 +515,10 @@ void  bfa_fcs_rpf_rport_offline(struct bfa_fcs_rport_s *rport);
  * forward declarations
  */
 struct bfad_itnim_s;
+enum bfa_fcs_itnim_event;
 
 struct bfa_fcs_itnim_s {
-	bfa_sm_t		sm;		/*  state machine */
+	void (*sm)(struct bfa_fcs_itnim_s *, enum bfa_fcs_itnim_event);/*  state machine */
 	struct bfa_fcs_rport_s	*rport;		/*  parent remote rport  */
 	struct bfad_itnim_s	*itnim_drv;	/*  driver peer instance */
 	struct bfa_fcs_s	*fcs;		/*  fcs instance	*/
diff --git a/drivers/scsi/bfa/bfa_fcs_fcpim.c b/drivers/scsi/bfa/bfa_fcs_fcpim.c
index 2e3b19e7e..7a9b7299d 100644
--- a/drivers/scsi/bfa/bfa_fcs_fcpim.c
+++ b/drivers/scsi/bfa/bfa_fcs_fcpim.c
@@ -60,7 +60,7 @@ static void	bfa_fcs_itnim_sm_hcb_offline(struct bfa_fcs_itnim_s *itnim,
 static void	bfa_fcs_itnim_sm_initiator(struct bfa_fcs_itnim_s *itnim,
 					   enum bfa_fcs_itnim_event event);
 
-static struct bfa_sm_table_s itnim_sm_table[] = {
+static struct itnim_sm_table_s itnim_sm_table[] = {
 	{BFA_SM(bfa_fcs_itnim_sm_offline), BFA_ITNIM_OFFLINE},
 	{BFA_SM(bfa_fcs_itnim_sm_prli_send), BFA_ITNIM_PRLI_SEND},
 	{BFA_SM(bfa_fcs_itnim_sm_prli), BFA_ITNIM_PRLI_SENT},
@@ -673,7 +673,7 @@ bfa_status_t
 bfa_fcs_itnim_get_online_state(struct bfa_fcs_itnim_s *itnim)
 {
 	bfa_trc(itnim->fcs, itnim->rport->pid);
-	switch (bfa_sm_to_state(itnim_sm_table, itnim->sm)) {
+	switch (itnim_sm_to_state(itnim_sm_table, itnim->sm)) {
 	case BFA_ITNIM_ONLINE:
 	case BFA_ITNIM_INITIATIOR:
 		return BFA_STATUS_OK;
@@ -773,7 +773,7 @@ bfa_fcs_itnim_attr_get(struct bfa_fcs_lport_s *port, wwn_t rpwwn,
 	if (itnim == NULL)
 		return BFA_STATUS_NO_FCPIM_NEXUS;
 
-	attr->state	    = bfa_sm_to_state(itnim_sm_table, itnim->sm);
+	attr->state	    = itnim_sm_to_state(itnim_sm_table, itnim->sm);
 	attr->retry	    = itnim->seq_rec;
 	attr->rec_support   = itnim->rec_support;
 	attr->conf_comp	    = itnim->conf_comp;
diff --git a/drivers/scsi/bfa/bfa_fcs_lport.c b/drivers/scsi/bfa/bfa_fcs_lport.c
index 7733ad530..11f32d166 100644
--- a/drivers/scsi/bfa/bfa_fcs_lport.c
+++ b/drivers/scsi/bfa/bfa_fcs_lport.c
@@ -90,15 +90,26 @@ static struct {
 	void		(*offline) (struct bfa_fcs_lport_s *port);
 } __port_action[] = {
 	{
-	bfa_fcs_lport_unknown_init, bfa_fcs_lport_unknown_online,
-			bfa_fcs_lport_unknown_offline}, {
-	bfa_fcs_lport_fab_init, bfa_fcs_lport_fab_online,
-			bfa_fcs_lport_fab_offline}, {
-	bfa_fcs_lport_n2n_init, bfa_fcs_lport_n2n_online,
-			bfa_fcs_lport_n2n_offline}, {
-	bfa_fcs_lport_loop_init, bfa_fcs_lport_loop_online,
-			bfa_fcs_lport_loop_offline},
-	};
+		.init = bfa_fcs_lport_unknown_init,
+		.online = bfa_fcs_lport_unknown_online,
+		.offline = bfa_fcs_lport_unknown_offline
+	},
+	{
+		.init = bfa_fcs_lport_fab_init,
+		.online = bfa_fcs_lport_fab_online,
+		.offline = bfa_fcs_lport_fab_offline
+	},
+	{
+		.init = bfa_fcs_lport_n2n_init,
+		.online = bfa_fcs_lport_n2n_online,
+		.offline = bfa_fcs_lport_n2n_offline
+	},
+	{
+		.init = bfa_fcs_lport_loop_init,
+		.online = bfa_fcs_lport_loop_online,
+		.offline = bfa_fcs_lport_loop_offline
+	},
+};
 
 /*
  *  fcs_port_sm FCS logical port state machine
@@ -6040,7 +6051,7 @@ static void	bfa_fcs_vport_sm_stopping(struct bfa_fcs_vport_s *vport,
 static void	bfa_fcs_vport_sm_logo_for_stop(struct bfa_fcs_vport_s *vport,
 					enum bfa_fcs_vport_event event);
 
-static struct bfa_sm_table_s  vport_sm_table[] = {
+static struct vport_sm_table_s vport_sm_table[] = {
 	{BFA_SM(bfa_fcs_vport_sm_uninit), BFA_FCS_VPORT_UNINIT},
 	{BFA_SM(bfa_fcs_vport_sm_created), BFA_FCS_VPORT_CREATED},
 	{BFA_SM(bfa_fcs_vport_sm_offline), BFA_FCS_VPORT_OFFLINE},
@@ -6871,7 +6882,7 @@ bfa_fcs_vport_get_attr(struct bfa_fcs_vport_s *vport,
 	memset(attr, 0, sizeof(struct bfa_vport_attr_s));
 
 	bfa_fcs_lport_get_attr(&vport->lport, &attr->port_attr);
-	attr->vport_state = bfa_sm_to_state(vport_sm_table, vport->sm);
+	attr->vport_state = vport_sm_to_state(vport_sm_table, vport->sm);
 }
 
 
diff --git a/drivers/scsi/bfa/bfa_fcs_rport.c b/drivers/scsi/bfa/bfa_fcs_rport.c
index de50349a3..6d676bea3 100644
--- a/drivers/scsi/bfa/bfa_fcs_rport.c
+++ b/drivers/scsi/bfa/bfa_fcs_rport.c
@@ -144,7 +144,7 @@ static void	bfa_fcs_rport_sm_fc4_off_delete(struct bfa_fcs_rport_s *rport,
 static void	bfa_fcs_rport_sm_delete_pending(struct bfa_fcs_rport_s *rport,
 						enum rport_event event);
 
-static struct bfa_sm_table_s rport_sm_table[] = {
+static struct rport_sm_table_s rport_sm_table[] = {
 	{BFA_SM(bfa_fcs_rport_sm_uninit), BFA_RPORT_UNINIT},
 	{BFA_SM(bfa_fcs_rport_sm_plogi_sending), BFA_RPORT_PLOGI},
 	{BFA_SM(bfa_fcs_rport_sm_plogiacc_sending), BFA_RPORT_ONLINE},
@@ -2980,7 +2980,7 @@ bfa_fcs_rport_send_ls_rjt(struct bfa_fcs_rport_s *rport, struct fchs_s *rx_fchs,
 int
 bfa_fcs_rport_get_state(struct bfa_fcs_rport_s *rport)
 {
-	return bfa_sm_to_state(rport_sm_table, rport->sm);
+	return rport_sm_to_state(rport_sm_table, rport->sm);
 }
 
 
diff --git a/drivers/scsi/bfa/bfa_ioc.c b/drivers/scsi/bfa/bfa_ioc.c
index a1ada4a31..6ed9ba271 100644
--- a/drivers/scsi/bfa/bfa_ioc.c
+++ b/drivers/scsi/bfa/bfa_ioc.c
@@ -148,7 +148,7 @@ bfa_fsm_state_decl(bfa_ioc, disabling, struct bfa_ioc_s, enum ioc_event);
 bfa_fsm_state_decl(bfa_ioc, disabled, struct bfa_ioc_s, enum ioc_event);
 bfa_fsm_state_decl(bfa_ioc, hwfail, struct bfa_ioc_s, enum ioc_event);
 
-static struct bfa_sm_table_s ioc_sm_table[] = {
+static struct ioc_sm_table_s ioc_sm_table[] = {
 	{BFA_SM(bfa_ioc_sm_uninit), BFA_IOC_UNINIT},
 	{BFA_SM(bfa_ioc_sm_reset), BFA_IOC_RESET},
 	{BFA_SM(bfa_ioc_sm_enabling), BFA_IOC_ENABLING},
@@ -236,7 +236,7 @@ bfa_fsm_state_decl(bfa_iocpf, disabling_sync, struct bfa_iocpf_s,
 						enum iocpf_event);
 bfa_fsm_state_decl(bfa_iocpf, disabled, struct bfa_iocpf_s, enum iocpf_event);
 
-static struct bfa_sm_table_s iocpf_sm_table[] = {
+static struct iocpf_sm_table_s iocpf_sm_table[] = {
 	{BFA_SM(bfa_iocpf_sm_reset), BFA_IOCPF_RESET},
 	{BFA_SM(bfa_iocpf_sm_fwcheck), BFA_IOCPF_FWMISMATCH},
 	{BFA_SM(bfa_iocpf_sm_mismatch), BFA_IOCPF_FWMISMATCH},
@@ -2830,12 +2830,12 @@ enum bfa_ioc_state
 bfa_ioc_get_state(struct bfa_ioc_s *ioc)
 {
 	enum bfa_iocpf_state iocpf_st;
-	enum bfa_ioc_state ioc_st = bfa_sm_to_state(ioc_sm_table, ioc->fsm);
+	enum bfa_ioc_state ioc_st = ioc_sm_to_state(ioc_sm_table, ioc->fsm);
 
 	if (ioc_st == BFA_IOC_ENABLING ||
 		ioc_st == BFA_IOC_FAIL || ioc_st == BFA_IOC_INITFAIL) {
 
-		iocpf_st = bfa_sm_to_state(iocpf_sm_table, ioc->iocpf.fsm);
+		iocpf_st = iocpf_sm_to_state(iocpf_sm_table, ioc->iocpf.fsm);
 
 		switch (iocpf_st) {
 		case BFA_IOCPF_SEMWAIT:
diff --git a/drivers/scsi/bfa/bfa_ioc.h b/drivers/scsi/bfa/bfa_ioc.h
index 713745da4..78b9671eb 100644
--- a/drivers/scsi/bfa/bfa_ioc.h
+++ b/drivers/scsi/bfa/bfa_ioc.h
@@ -259,7 +259,7 @@ struct bfa_ioc_cbfn_s {
 	bfa_ioc_disable_cbfn_t	disable_cbfn;
 	bfa_ioc_hbfail_cbfn_t	hbfail_cbfn;
 	bfa_ioc_reset_cbfn_t	reset_cbfn;
-};
+} __no_const;
 
 /*
  * IOC event notification mechanism.
@@ -286,16 +286,20 @@ struct bfa_ioc_notify_s {
 	(__notify)->cbarg = (__cbarg);      \
 } while (0)
 
+enum iocpf_event;
+
 struct bfa_iocpf_s {
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bfa_iocpf_s *, enum iocpf_event);
 	struct bfa_ioc_s	*ioc;
 	bfa_boolean_t		fw_mismatch_notified;
 	bfa_boolean_t		auto_recover;
 	u32			poll_time;
 };
 
+enum ioc_event;
+
 struct bfa_ioc_s {
-	bfa_fsm_t		fsm;
+	void (*fsm)(struct bfa_ioc_s *, enum ioc_event);
 	struct bfa_s		*bfa;
 	struct bfa_pcidev_s	pcidev;
 	struct bfa_timer_mod_s	*timer_mod;
@@ -353,7 +357,7 @@ struct bfa_ioc_hwif_s {
 	void		(*ioc_set_alt_fwstate)	(struct bfa_ioc_s *ioc,
 					enum bfi_ioc_state fwstate);
 	enum bfi_ioc_state	(*ioc_get_alt_fwstate)	(struct bfa_ioc_s *ioc);
-};
+} __no_const;
 
 /*
  * Queue element to wait for room in request queue. FIFO order is
@@ -779,8 +783,10 @@ struct bfa_dconf_s {
 };
 #pragma pack()
 
+enum bfa_dconf_event;
+
 struct bfa_dconf_mod_s {
-	bfa_sm_t		sm;
+	void (*sm)(struct bfa_dconf_mod_s *, enum bfa_dconf_event);
 	u8			instance;
 	bfa_boolean_t		read_data_valid;
 	bfa_boolean_t		min_cfg;
diff --git a/drivers/scsi/bfa/bfa_modules.h b/drivers/scsi/bfa/bfa_modules.h
index 53135f21f..640621b4c 100644
--- a/drivers/scsi/bfa/bfa_modules.h
+++ b/drivers/scsi/bfa/bfa_modules.h
@@ -79,12 +79,12 @@ enum {
 									\
 	extern struct bfa_module_s hal_mod_ ## __mod;			\
 	struct bfa_module_s hal_mod_ ## __mod = {			\
-		bfa_ ## __mod ## _meminfo,				\
-		bfa_ ## __mod ## _attach,				\
-		bfa_ ## __mod ## _detach,				\
-		bfa_ ## __mod ## _start,				\
-		bfa_ ## __mod ## _stop,					\
-		bfa_ ## __mod ## _iocdisable,				\
+		.meminfo = bfa_ ## __mod ## _meminfo,			\
+		.attach = bfa_ ## __mod ## _attach,			\
+		.detach = bfa_ ## __mod ## _detach,			\
+		.start = bfa_ ## __mod ## _start,			\
+		.stop = bfa_ ## __mod ## _stop,				\
+		.iocdisable = bfa_ ## __mod ## _iocdisable,		\
 	}
 
 #define BFA_CACHELINE_SZ	(256)
diff --git a/drivers/scsi/bfa/bfa_svc.c b/drivers/scsi/bfa/bfa_svc.c
index 12de29217..ec9f0ab6b 100644
--- a/drivers/scsi/bfa/bfa_svc.c
+++ b/drivers/scsi/bfa/bfa_svc.c
@@ -225,7 +225,7 @@ static void     bfa_fcport_ln_sm_up_dn_nf(struct bfa_fcport_ln_s *ln,
 static void     bfa_fcport_ln_sm_up_dn_up_nf(struct bfa_fcport_ln_s *ln,
 					enum bfa_fcport_ln_sm_event event);
 
-static struct bfa_sm_table_s hal_port_sm_table[] = {
+static struct fcport_sm_table_s hal_port_sm_table[] = {
 	{BFA_SM(bfa_fcport_sm_uninit), BFA_PORT_ST_UNINIT},
 	{BFA_SM(bfa_fcport_sm_enabling_qwait), BFA_PORT_ST_ENABLING_QWAIT},
 	{BFA_SM(bfa_fcport_sm_enabling), BFA_PORT_ST_ENABLING},
@@ -3642,7 +3642,7 @@ bfa_fcport_isr(struct bfa_s *bfa, struct bfi_msg_s *msg)
 	fcport->event_arg.i2hmsg = i2hmsg;
 
 	bfa_trc(bfa, msg->mhdr.msg_id);
-	bfa_trc(bfa, bfa_sm_to_state(hal_port_sm_table, fcport->sm));
+	bfa_trc(bfa, fcport_sm_to_state(hal_port_sm_table, fcport->sm));
 
 	switch (msg->mhdr.msg_id) {
 	case BFI_FCPORT_I2H_ENABLE_RSP:
@@ -4077,7 +4077,7 @@ bfa_fcport_get_attr(struct bfa_s *bfa, struct bfa_port_attr_s *attr)
 
 	attr->pport_cfg.path_tov  = bfa_fcpim_path_tov_get(bfa);
 	attr->pport_cfg.q_depth  = bfa_fcpim_qdepth_get(bfa);
-	attr->port_state = bfa_sm_to_state(hal_port_sm_table, fcport->sm);
+	attr->port_state = fcport_sm_to_state(hal_port_sm_table, fcport->sm);
 
 	attr->fec_state = fcport->fec_state;
 
@@ -4159,7 +4159,7 @@ bfa_fcport_is_disabled(struct bfa_s *bfa)
 {
 	struct bfa_fcport_s *fcport = BFA_FCPORT_MOD(bfa);
 
-	return bfa_sm_to_state(hal_port_sm_table, fcport->sm) ==
+	return fcport_sm_to_state(hal_port_sm_table, fcport->sm) ==
 		BFA_PORT_ST_DISABLED;
 
 }
@@ -4169,7 +4169,7 @@ bfa_fcport_is_dport(struct bfa_s *bfa)
 {
 	struct bfa_fcport_s *fcport = BFA_FCPORT_MOD(bfa);
 
-	return (bfa_sm_to_state(hal_port_sm_table, fcport->sm) ==
+	return (fcport_sm_to_state(hal_port_sm_table, fcport->sm) ==
 		BFA_PORT_ST_DPORT);
 }
 
@@ -4178,7 +4178,7 @@ bfa_fcport_is_ddport(struct bfa_s *bfa)
 {
 	struct bfa_fcport_s *fcport = BFA_FCPORT_MOD(bfa);
 
-	return (bfa_sm_to_state(hal_port_sm_table, fcport->sm) ==
+	return (fcport_sm_to_state(hal_port_sm_table, fcport->sm) ==
 		BFA_PORT_ST_DDPORT);
 }
 
diff --git a/drivers/scsi/bfa/bfa_svc.h b/drivers/scsi/bfa/bfa_svc.h
index ea2278bc7..6f51a7300 100644
--- a/drivers/scsi/bfa/bfa_svc.h
+++ b/drivers/scsi/bfa/bfa_svc.h
@@ -160,6 +160,8 @@ struct bfa_fcxp_rsp_info_s {
 	u32	rsp_maxlen;	/*  max response length expected */
 };
 
+typedef void (*bfa_sm_t)(void *sm, int event);
+
 struct bfa_fcxp_s {
 	struct list_head	qe;		/*  fcxp queue element */
 	bfa_sm_t	sm;		/*  state machine */
@@ -295,9 +297,11 @@ struct bfa_rport_info_s {
 /*
  * BFA rport data structure
  */
+enum bfa_rport_event;
+
 struct bfa_rport_s {
 	struct list_head	qe;	/*  queue element		    */
-	bfa_sm_t	sm;		/*  state machine		    */
+	void (*sm)(struct bfa_rport_s *, enum bfa_rport_event);/*  state machine		    */
 	struct bfa_s	*bfa;		/*  backpointer to BFA		    */
 	void		*rport_drv;	/*  fcs/driver rport object	    */
 	u16	fw_handle;	/*  firmware rport handle	    */
@@ -388,10 +392,12 @@ void	bfa_uf_res_recfg(struct bfa_s *bfa, u16 num_uf_fw);
 /*
  * LPS - bfa lport login/logout service interface
  */
+enum bfa_lps_event;
+
 struct bfa_lps_s {
 	struct list_head	qe;	/*  queue element		*/
 	struct bfa_s	*bfa;		/*  parent bfa instance	*/
-	bfa_sm_t	sm;		/*  finite state machine	*/
+	void (*sm)(struct bfa_lps_s *, enum bfa_lps_event);/*  finite state machine	*/
 	u8		bfa_tag;	/*  lport tag		*/
 	u8		fw_tag;		/*  lport fw tag                */
 	u8		reqq;		/*  lport request queue	*/
@@ -450,9 +456,11 @@ void	bfa_lps_isr(struct bfa_s *bfa, struct bfi_msg_s *msg);
 /*
  * Link notification data structure
  */
+enum bfa_fcport_ln_sm_event;
+
 struct bfa_fcport_ln_s {
 	struct bfa_fcport_s	*fcport;
-	bfa_sm_t		sm;
+	void (*sm)(struct bfa_fcport_ln_s *, enum bfa_fcport_ln_sm_event);
 	struct bfa_cb_qe_s	ln_qe;	/*  BFA callback queue elem for ln */
 	enum bfa_port_linkstate ln_event; /*  ln event for callback */
 };
@@ -466,7 +474,7 @@ struct bfa_fcport_trunk_s {
  */
 struct bfa_fcport_s {
 	struct bfa_s		*bfa;	/*  parent BFA instance */
-	bfa_sm_t		sm;	/*  port state machine */
+	void (*sm)(struct bfa_fcport_s *, enum bfa_fcport_sm_event);	/*  port state machine */
 	wwn_t			nwwn;	/*  node wwn of physical port */
 	wwn_t			pwwn;	/*  port wwn of physical oprt */
 	enum bfa_port_speed speed_sup;
@@ -714,9 +722,11 @@ struct bfa_fcdiag_lb_s {
 	u32        status;
 };
 
+enum bfa_dport_sm_event;
+
 struct bfa_dport_s {
 	struct bfa_s	*bfa;		/* Back pointer to BFA	*/
-	bfa_sm_t	sm;		/* finite state machine */
+	void (*sm)(struct bfa_dport_s *, enum bfa_dport_sm_event);/* finite state machine */
 	struct bfa_reqq_wait_s reqq_wait;
 	bfa_cb_diag_t	cbfn;
 	void		*cbarg;
diff --git a/drivers/scsi/bfa/bfad.c b/drivers/scsi/bfa/bfad.c
index 0e76e8669..b7d303c3d 100644
--- a/drivers/scsi/bfa/bfad.c
+++ b/drivers/scsi/bfa/bfad.c
@@ -406,6 +406,16 @@ bfad_hcb_comp(void *arg, bfa_status_t status)
 	complete(&fcomp->comp);
 }
 
+void
+bfad_stats_comp(void *arg, bfa_boolean_t _status)
+{
+	struct bfad_hal_comp *fcomp = (struct bfad_hal_comp *)arg;
+	bfa_status_t status = (bfa_status_t)_status;
+
+	fcomp->status = status;
+	complete(&fcomp->comp);
+}
+
 /*
  * bfa_init callback
  */
@@ -1440,7 +1450,7 @@ bfad_pci_remove(struct pci_dev *pdev)
  * PCI Error Recovery entry, error detected.
  */
 static pci_ers_result_t
-bfad_pci_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+bfad_pci_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct bfad_s *bfad = pci_get_drvdata(pdev);
 	unsigned long	flags;
diff --git a/drivers/scsi/bfa/bfad_bsg.c b/drivers/scsi/bfa/bfad_bsg.c
index d1ad0208d..661c0f95a 100644
--- a/drivers/scsi/bfa/bfad_bsg.c
+++ b/drivers/scsi/bfa/bfad_bsg.c
@@ -2145,7 +2145,7 @@ bfad_iocmd_fcport_get_stats(struct bfad_s *bfad, void *cmd)
 	struct bfa_cb_pending_q_s cb_qe;
 
 	init_completion(&fcomp.comp);
-	bfa_pending_q_init(&cb_qe, (bfa_cb_cbfn_t)bfad_hcb_comp,
+	bfa_pending_q_init(&cb_qe, bfad_stats_comp,
 			   &fcomp, &iocmd->stats);
 	spin_lock_irqsave(&bfad->bfad_lock, flags);
 	iocmd->status = bfa_fcport_get_stats(&bfad->bfa, &cb_qe);
@@ -2169,7 +2169,7 @@ bfad_iocmd_fcport_reset_stats(struct bfad_s *bfad, void *cmd)
 	struct bfa_cb_pending_q_s cb_qe;
 
 	init_completion(&fcomp.comp);
-	bfa_pending_q_init(&cb_qe, (bfa_cb_cbfn_t)bfad_hcb_comp, &fcomp, NULL);
+	bfa_pending_q_init(&cb_qe, bfad_stats_comp, &fcomp, NULL);
 
 	spin_lock_irqsave(&bfad->bfad_lock, flags);
 	iocmd->status = bfa_fcport_clear_stats(&bfad->bfa, &cb_qe);
@@ -2453,7 +2453,7 @@ bfad_iocmd_qos_get_stats(struct bfad_s *bfad, void *cmd)
 	struct bfa_fcport_s *fcport = BFA_FCPORT_MOD(&bfad->bfa);
 
 	init_completion(&fcomp.comp);
-	bfa_pending_q_init(&cb_qe, (bfa_cb_cbfn_t)bfad_hcb_comp,
+	bfa_pending_q_init(&cb_qe, bfad_stats_comp,
 			   &fcomp, &iocmd->stats);
 
 	spin_lock_irqsave(&bfad->bfad_lock, flags);
@@ -2484,7 +2484,7 @@ bfad_iocmd_qos_reset_stats(struct bfad_s *bfad, void *cmd)
 	struct bfa_fcport_s *fcport = BFA_FCPORT_MOD(&bfad->bfa);
 
 	init_completion(&fcomp.comp);
-	bfa_pending_q_init(&cb_qe, (bfa_cb_cbfn_t)bfad_hcb_comp,
+	bfa_pending_q_init(&cb_qe, bfad_stats_comp,
 			   &fcomp, NULL);
 
 	spin_lock_irqsave(&bfad->bfad_lock, flags);
diff --git a/drivers/scsi/bfa/bfad_drv.h b/drivers/scsi/bfa/bfad_drv.h
index f9e862093..807a9830f 100644
--- a/drivers/scsi/bfa/bfad_drv.h
+++ b/drivers/scsi/bfa/bfad_drv.h
@@ -187,8 +187,10 @@ union bfad_tmp_buf {
 /*
  * BFAD (PCI function) data structure
  */
+enum bfad_sm_event;
+
 struct bfad_s {
-	bfa_sm_t	sm;	/* state machine */
+	void (*sm)(struct bfad_s *, enum bfad_sm_event); /* state machine */
 	struct list_head list_entry;
 	struct bfa_s	bfa;
 	struct bfa_fcs_s bfa_fcs;
@@ -309,6 +311,7 @@ void		bfad_fcs_stop(struct bfad_s *bfad);
 void		bfad_remove_intr(struct bfad_s *bfad);
 void		bfad_hal_mem_release(struct bfad_s *bfad);
 void		bfad_hcb_comp(void *arg, bfa_status_t status);
+void		bfad_stats_comp(void *arg, bfa_boolean_t _status);
 
 int		bfad_setup_intr(struct bfad_s *bfad);
 void		bfad_remove_intr(struct bfad_s *bfad);
diff --git a/drivers/scsi/csiostor/csio_defs.h b/drivers/scsi/csiostor/csio_defs.h
index c38017b4a..3268e62fd 100644
--- a/drivers/scsi/csiostor/csio_defs.h
+++ b/drivers/scsi/csiostor/csio_defs.h
@@ -73,7 +73,8 @@ csio_list_deleted(struct list_head *list)
 #define csio_list_prev(elem)	(((struct list_head *)(elem))->prev)
 
 /* State machine */
-typedef void (*csio_sm_state_t)(void *, uint32_t);
+struct csio_sm;
+typedef void (*csio_sm_state_t)(struct csio_sm *, uint32_t);
 
 struct csio_sm {
 	struct list_head	sm_list;
@@ -81,9 +82,9 @@ struct csio_sm {
 };
 
 static inline void
-csio_set_state(void *smp, void *state)
+csio_set_state(struct csio_sm *smp, csio_sm_state_t state)
 {
-	((struct csio_sm *)smp)->sm_state = (csio_sm_state_t)state;
+	smp->sm_state = state;
 }
 
 static inline void
@@ -93,21 +94,21 @@ csio_init_state(struct csio_sm *smp, void *state)
 }
 
 static inline void
-csio_post_event(void *smp, uint32_t evt)
+csio_post_event(struct csio_sm *smp, uint32_t evt)
 {
-	((struct csio_sm *)smp)->sm_state(smp, evt);
+	smp->sm_state(smp, evt);
 }
 
 static inline csio_sm_state_t
-csio_get_state(void *smp)
+csio_get_state(struct csio_sm *smp)
 {
-	return ((struct csio_sm *)smp)->sm_state;
+	return smp->sm_state;
 }
 
 static inline bool
-csio_match_state(void *smp, void *state)
+csio_match_state(struct csio_sm *smp, csio_sm_state_t state)
 {
-	return (csio_get_state(smp) == (csio_sm_state_t)state);
+	return (csio_get_state(smp) == state);
 }
 
 #define	CSIO_ASSERT(cond)		BUG_ON(!(cond))
diff --git a/drivers/scsi/csiostor/csio_hw.c b/drivers/scsi/csiostor/csio_hw.c
index 14343bfd1..efe85070c 100644
--- a/drivers/scsi/csiostor/csio_hw.c
+++ b/drivers/scsi/csiostor/csio_hw.c
@@ -89,15 +89,15 @@ static void csio_mgmtm_cleanup(struct csio_mgmtm *);
 static void csio_hw_mbm_cleanup(struct csio_hw *);
 
 /* State machine forward declarations */
-static void csio_hws_uninit(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_configuring(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_initializing(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_ready(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_quiescing(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_quiesced(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_resetting(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_removing(struct csio_hw *, enum csio_hw_ev);
-static void csio_hws_pcierr(struct csio_hw *, enum csio_hw_ev);
+static void csio_hws_uninit(struct csio_sm *, uint32_t);
+static void csio_hws_configuring(struct csio_sm *, uint32_t);
+static void csio_hws_initializing(struct csio_sm *, uint32_t);
+static void csio_hws_ready(struct csio_sm *, uint32_t);
+static void csio_hws_quiescing(struct csio_sm *, uint32_t);
+static void csio_hws_quiesced(struct csio_sm *, uint32_t);
+static void csio_hws_resetting(struct csio_sm *, uint32_t);
+static void csio_hws_removing(struct csio_sm *, uint32_t);
+static void csio_hws_pcierr(struct csio_sm *, uint32_t);
 
 static void csio_hw_initialize(struct csio_hw *hw);
 static void csio_evtq_stop(struct csio_hw *hw);
@@ -105,12 +105,12 @@ static void csio_evtq_start(struct csio_hw *hw);
 
 int csio_is_hw_ready(struct csio_hw *hw)
 {
-	return csio_match_state(hw, csio_hws_ready);
+	return csio_match_state(&hw->sm, csio_hws_ready);
 }
 
 int csio_is_hw_removing(struct csio_hw *hw)
 {
-	return csio_match_state(hw, csio_hws_removing);
+	return csio_match_state(&hw->sm, csio_hws_removing);
 }
 
 
@@ -2326,8 +2326,11 @@ csio_hw_fatal_err(struct csio_hw *hw)
  *
  */
 static void
-csio_hws_uninit(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_uninit(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
@@ -2351,8 +2354,11 @@ csio_hws_uninit(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_configuring(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_configuring(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
@@ -2389,8 +2395,11 @@ csio_hws_configuring(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_initializing(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_initializing(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
@@ -2427,8 +2436,11 @@ csio_hws_initializing(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_ready(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_ready(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	/* Remember the event */
 	hw->evtflag = evt;
 
@@ -2476,8 +2488,11 @@ csio_hws_ready(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_quiescing(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_quiescing(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
@@ -2536,8 +2551,11 @@ csio_hws_quiescing(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_quiesced(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_quiesced(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
@@ -2561,8 +2579,11 @@ csio_hws_quiesced(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_resetting(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_resetting(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
@@ -2587,8 +2608,11 @@ csio_hws_resetting(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_removing(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_removing(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
@@ -2622,8 +2646,11 @@ csio_hws_removing(struct csio_hw *hw, enum csio_hw_ev evt)
  *
  */
 static void
-csio_hws_pcierr(struct csio_hw *hw, enum csio_hw_ev evt)
+csio_hws_pcierr(struct csio_sm *_hw, uint32_t _evt)
 {
+	struct csio_hw *hw = container_of(_hw, struct csio_hw, sm);
+	enum csio_hw_ev evt = _evt;
+
 	hw->prev_evt = hw->cur_evt;
 	hw->cur_evt = evt;
 	CSIO_INC_STATS(hw, n_evt_sm[evt]);
diff --git a/drivers/scsi/csiostor/csio_init.c b/drivers/scsi/csiostor/csio_init.c
index e46a333c6..1c3bf68ef 100644
--- a/drivers/scsi/csiostor/csio_init.c
+++ b/drivers/scsi/csiostor/csio_init.c
@@ -1053,7 +1053,7 @@ static void csio_remove_one(struct pci_dev *pdev)
  *
  */
 static pci_ers_result_t
-csio_pci_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+csio_pci_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct csio_hw *hw = pci_get_drvdata(pdev);
 
diff --git a/drivers/scsi/csiostor/csio_lnode.c b/drivers/scsi/csiostor/csio_lnode.c
index c00b2ff72..da72dbc43 100644
--- a/drivers/scsi/csiostor/csio_lnode.c
+++ b/drivers/scsi/csiostor/csio_lnode.c
@@ -55,10 +55,10 @@ int csio_fdmi_enable = 1;
 #define PORT_ID_PTR(_x)         ((uint8_t *)(&_x) + 1)
 
 /* Lnode SM declarations */
-static void csio_lns_uninit(struct csio_lnode *, enum csio_ln_ev);
-static void csio_lns_online(struct csio_lnode *, enum csio_ln_ev);
-static void csio_lns_ready(struct csio_lnode *, enum csio_ln_ev);
-static void csio_lns_offline(struct csio_lnode *, enum csio_ln_ev);
+static void csio_lns_uninit(struct csio_sm *, uint32_t);
+static void csio_lns_online(struct csio_sm *, uint32_t);
+static void csio_lns_ready(struct csio_sm *, uint32_t);
+static void csio_lns_offline(struct csio_sm *, uint32_t);
 
 static int csio_ln_mgmt_submit_req(struct csio_ioreq *,
 		void (*io_cbfn) (struct csio_hw *, struct csio_ioreq *),
@@ -1077,7 +1077,7 @@ csio_handle_link_down(struct csio_hw *hw, uint8_t portid, uint32_t fcfi,
 int
 csio_is_lnode_ready(struct csio_lnode *ln)
 {
-	return (csio_get_state(ln) == ((csio_sm_state_t)csio_lns_ready));
+	return (csio_get_state(&ln->sm) == csio_lns_ready);
 }
 
 /*****************************************************************************/
@@ -1093,8 +1093,10 @@ csio_is_lnode_ready(struct csio_lnode *ln)
  * Return - none.
  */
 static void
-csio_lns_uninit(struct csio_lnode *ln, enum csio_ln_ev evt)
+csio_lns_uninit(struct csio_sm *_ln, uint32_t _evt)
 {
+	struct csio_lnode *ln = container_of(_ln, struct csio_lnode, sm);
+	enum csio_ln_ev evt = _evt;
 	struct csio_hw *hw = csio_lnode_to_hw(ln);
 	struct csio_lnode *rln = hw->rln;
 	int rv;
@@ -1146,8 +1148,10 @@ csio_lns_uninit(struct csio_lnode *ln, enum csio_ln_ev evt)
  * Return - none.
  */
 static void
-csio_lns_online(struct csio_lnode *ln, enum csio_ln_ev evt)
+csio_lns_online(struct csio_sm *_ln, uint32_t _evt)
 {
+	struct csio_lnode *ln = container_of(_ln, struct csio_lnode, sm);
+	enum csio_ln_ev evt = _evt;
 	struct csio_hw *hw = csio_lnode_to_hw(ln);
 
 	CSIO_INC_STATS(ln, n_evt_sm[evt]);
@@ -1198,8 +1202,10 @@ csio_lns_online(struct csio_lnode *ln, enum csio_ln_ev evt)
  * Return - none.
  */
 static void
-csio_lns_ready(struct csio_lnode *ln, enum csio_ln_ev evt)
+csio_lns_ready(struct csio_sm *_ln, uint32_t _evt)
 {
+	struct csio_lnode *ln = container_of(_ln, struct csio_lnode, sm);
+	enum csio_ln_ev evt = _evt;
 	struct csio_hw *hw = csio_lnode_to_hw(ln);
 
 	CSIO_INC_STATS(ln, n_evt_sm[evt]);
@@ -1272,8 +1278,10 @@ csio_lns_ready(struct csio_lnode *ln, enum csio_ln_ev evt)
  * Return - none.
  */
 static void
-csio_lns_offline(struct csio_lnode *ln, enum csio_ln_ev evt)
+csio_lns_offline(struct csio_sm *_ln, uint32_t _evt)
 {
+	struct csio_lnode *ln = container_of(_ln, struct csio_lnode, sm);
+	enum csio_ln_ev evt = _evt;
 	struct csio_hw *hw = csio_lnode_to_hw(ln);
 	struct csio_lnode *rln = hw->rln;
 	int rv;
@@ -1349,15 +1357,15 @@ csio_free_fcfinfo(struct kref *kref)
 void
 csio_lnode_state_to_str(struct csio_lnode *ln, int8_t *str)
 {
-	if (csio_get_state(ln) == ((csio_sm_state_t)csio_lns_uninit)) {
+	if (csio_get_state(&ln->sm) == csio_lns_uninit) {
 		strcpy(str, "UNINIT");
 		return;
 	}
-	if (csio_get_state(ln) == ((csio_sm_state_t)csio_lns_ready)) {
+	if (csio_get_state(&ln->sm) == csio_lns_ready) {
 		strcpy(str, "READY");
 		return;
 	}
-	if (csio_get_state(ln) == ((csio_sm_state_t)csio_lns_offline)) {
+	if (csio_get_state(&ln->sm) == csio_lns_offline) {
 		strcpy(str, "OFFLINE");
 		return;
 	}
diff --git a/drivers/scsi/csiostor/csio_rnode.c b/drivers/scsi/csiostor/csio_rnode.c
index e9c3b045f..4ba3a598d 100644
--- a/drivers/scsi/csiostor/csio_rnode.c
+++ b/drivers/scsi/csiostor/csio_rnode.c
@@ -46,10 +46,10 @@ static int csio_rnode_init(struct csio_rnode *, struct csio_lnode *);
 static void csio_rnode_exit(struct csio_rnode *);
 
 /* Static machine forward declarations */
-static void csio_rns_uninit(struct csio_rnode *, enum csio_rn_ev);
-static void csio_rns_ready(struct csio_rnode *, enum csio_rn_ev);
-static void csio_rns_offline(struct csio_rnode *, enum csio_rn_ev);
-static void csio_rns_disappeared(struct csio_rnode *, enum csio_rn_ev);
+static void csio_rns_uninit(struct csio_sm *, uint32_t);
+static void csio_rns_ready(struct csio_sm *, uint32_t);
+static void csio_rns_offline(struct csio_sm *, uint32_t);
+static void csio_rns_disappeared(struct csio_sm *, uint32_t);
 
 /* RNF event mapping */
 static enum csio_rn_ev fwevt_to_rnevt[] = {
@@ -88,13 +88,13 @@ static enum csio_rn_ev fwevt_to_rnevt[] = {
 int
 csio_is_rnode_ready(struct csio_rnode *rn)
 {
-	return csio_match_state(rn, csio_rns_ready);
+	return csio_match_state(&rn->sm, csio_rns_ready);
 }
 
 static int
 csio_is_rnode_uninit(struct csio_rnode *rn)
 {
-	return csio_match_state(rn, csio_rns_uninit);
+	return csio_match_state(&rn->sm, csio_rns_uninit);
 }
 
 static int
@@ -601,8 +601,10 @@ __csio_unreg_rnode(struct csio_rnode *rn)
  *
  */
 static void
-csio_rns_uninit(struct csio_rnode *rn, enum csio_rn_ev evt)
+csio_rns_uninit(struct csio_sm *_rn, uint32_t _evt)
 {
+	struct csio_rnode *rn = container_of(_rn, struct csio_rnode, sm);
+	enum csio_rn_ev evt = _evt;
 	struct csio_lnode *ln = csio_rnode_to_lnode(rn);
 	int ret = 0;
 
@@ -641,8 +643,10 @@ csio_rns_uninit(struct csio_rnode *rn, enum csio_rn_ev evt)
  *
  */
 static void
-csio_rns_ready(struct csio_rnode *rn, enum csio_rn_ev evt)
+csio_rns_ready(struct csio_sm *_rn, uint32_t _evt)
 {
+	struct csio_rnode *rn = container_of(_rn, struct csio_rnode, sm);
+	enum csio_rn_ev evt = _evt;
 	struct csio_lnode *ln = csio_rnode_to_lnode(rn);
 	int ret = 0;
 
@@ -726,8 +730,10 @@ csio_rns_ready(struct csio_rnode *rn, enum csio_rn_ev evt)
  *
  */
 static void
-csio_rns_offline(struct csio_rnode *rn, enum csio_rn_ev evt)
+csio_rns_offline(struct csio_sm *_rn, uint32_t _evt)
 {
+	struct csio_rnode *rn = container_of(_rn, struct csio_rnode, sm);
+	enum csio_rn_ev evt = _evt;
 	struct csio_lnode *ln = csio_rnode_to_lnode(rn);
 	int ret = 0;
 
@@ -785,8 +791,10 @@ csio_rns_offline(struct csio_rnode *rn, enum csio_rn_ev evt)
  *
  */
 static void
-csio_rns_disappeared(struct csio_rnode *rn, enum csio_rn_ev evt)
+csio_rns_disappeared(struct csio_sm *_rn, uint32_t _evt)
 {
+	struct csio_rnode *rn = container_of(_rn, struct csio_rnode, sm);
+	enum csio_rn_ev evt = _evt;
 	struct csio_lnode *ln = csio_rnode_to_lnode(rn);
 	int ret = 0;
 
diff --git a/drivers/scsi/csiostor/csio_scsi.c b/drivers/scsi/csiostor/csio_scsi.c
index c2a6f9f29..5a37cc479 100644
--- a/drivers/scsi/csiostor/csio_scsi.c
+++ b/drivers/scsi/csiostor/csio_scsi.c
@@ -65,12 +65,12 @@ static int csio_ddp_descs = 128;
 static int csio_do_abrt_cls(struct csio_hw *,
 				      struct csio_ioreq *, bool);
 
-static void csio_scsis_uninit(struct csio_ioreq *, enum csio_scsi_ev);
-static void csio_scsis_io_active(struct csio_ioreq *, enum csio_scsi_ev);
-static void csio_scsis_tm_active(struct csio_ioreq *, enum csio_scsi_ev);
-static void csio_scsis_aborting(struct csio_ioreq *, enum csio_scsi_ev);
-static void csio_scsis_closing(struct csio_ioreq *, enum csio_scsi_ev);
-static void csio_scsis_shost_cmpl_await(struct csio_ioreq *, enum csio_scsi_ev);
+static void csio_scsis_uninit(struct csio_sm *, uint32_t);
+static void csio_scsis_io_active(struct csio_sm *, uint32_t);
+static void csio_scsis_tm_active(struct csio_sm *, uint32_t);
+static void csio_scsis_aborting(struct csio_sm *, uint32_t);
+static void csio_scsis_closing(struct csio_sm *, uint32_t);
+static void csio_scsis_shost_cmpl_await(struct csio_sm *, uint32_t);
 
 /*
  * csio_scsi_match_io - Match an ioreq with the given SCSI level data.
@@ -700,8 +700,10 @@ csio_scsi_abrt_cls(struct csio_ioreq *req, bool abort)
 /* START: SCSI SM                                                            */
 /*****************************************************************************/
 static void
-csio_scsis_uninit(struct csio_ioreq *req, enum csio_scsi_ev evt)
+csio_scsis_uninit(struct csio_sm *_req, uint32_t _evt)
 {
+	struct csio_ioreq *req = container_of(_req, struct csio_ioreq, sm);
+	enum csio_scsi_ev evt = _evt;
 	struct csio_hw *hw = req->lnode->hwp;
 	struct csio_scsim *scsim = csio_hw_to_scsim(hw);
 
@@ -770,8 +772,10 @@ csio_scsis_uninit(struct csio_ioreq *req, enum csio_scsi_ev evt)
 }
 
 static void
-csio_scsis_io_active(struct csio_ioreq *req, enum csio_scsi_ev evt)
+csio_scsis_io_active(struct csio_sm *_req, uint32_t _evt)
 {
+	struct csio_ioreq *req = container_of(_req, struct csio_ioreq, sm);
+	enum csio_scsi_ev evt = _evt;
 	struct csio_hw *hw = req->lnode->hwp;
 	struct csio_scsim *scm = csio_hw_to_scsim(hw);
 	struct csio_rnode *rn;
@@ -842,8 +846,10 @@ csio_scsis_io_active(struct csio_ioreq *req, enum csio_scsi_ev evt)
 }
 
 static void
-csio_scsis_tm_active(struct csio_ioreq *req, enum csio_scsi_ev evt)
+csio_scsis_tm_active(struct csio_sm *_req, uint32_t _evt)
 {
+	struct csio_ioreq *req = container_of(_req, struct csio_ioreq, sm);
+	enum csio_scsi_ev evt = _evt;
 	struct csio_hw *hw = req->lnode->hwp;
 	struct csio_scsim *scm = csio_hw_to_scsim(hw);
 
@@ -885,8 +891,10 @@ csio_scsis_tm_active(struct csio_ioreq *req, enum csio_scsi_ev evt)
 }
 
 static void
-csio_scsis_aborting(struct csio_ioreq *req, enum csio_scsi_ev evt)
+csio_scsis_aborting(struct csio_sm *_req, uint32_t _evt)
 {
+	struct csio_ioreq *req = container_of(_req, struct csio_ioreq, sm);
+	enum csio_scsi_ev evt = _evt;
 	struct csio_hw *hw = req->lnode->hwp;
 	struct csio_scsim *scm = csio_hw_to_scsim(hw);
 
@@ -982,8 +990,10 @@ csio_scsis_aborting(struct csio_ioreq *req, enum csio_scsi_ev evt)
 }
 
 static void
-csio_scsis_closing(struct csio_ioreq *req, enum csio_scsi_ev evt)
+csio_scsis_closing(struct csio_sm *_req, uint32_t _evt)
 {
+	struct csio_ioreq *req = container_of(_req, struct csio_ioreq, sm);
+	enum csio_scsi_ev evt = _evt;
 	struct csio_hw *hw = req->lnode->hwp;
 	struct csio_scsim *scm = csio_hw_to_scsim(hw);
 
@@ -1046,8 +1056,11 @@ csio_scsis_closing(struct csio_ioreq *req, enum csio_scsi_ev evt)
 }
 
 static void
-csio_scsis_shost_cmpl_await(struct csio_ioreq *req, enum csio_scsi_ev evt)
+csio_scsis_shost_cmpl_await(struct csio_sm *_req, uint32_t _evt)
 {
+	struct csio_ioreq *req = container_of(_req, struct csio_ioreq, sm);
+	enum csio_scsi_ev evt = _evt;
+
 	switch (evt) {
 	case CSIO_SCSIE_ABORT:
 	case CSIO_SCSIE_CLOSE:
diff --git a/drivers/scsi/esas2r/esas2r_init.c b/drivers/scsi/esas2r/esas2r_init.c
index 78ce4d61a..b3f6ff60b 100644
--- a/drivers/scsi/esas2r/esas2r_init.c
+++ b/drivers/scsi/esas2r/esas2r_init.c
@@ -237,7 +237,7 @@ static void esas2r_claim_interrupts(struct esas2r_adapter *a)
 		flags |= IRQF_SHARED;
 
 	esas2r_log(ESAS2R_LOG_INFO,
-		   "esas2r_claim_interrupts irq=%d (%p, %s, %x)",
+		   "esas2r_claim_interrupts irq=%d (%p, %s, %lx)",
 		   a->pcid->irq, a, a->name, flags);
 
 	if (request_irq(a->pcid->irq,
diff --git a/drivers/scsi/esas2r/esas2r_ioctl.c b/drivers/scsi/esas2r/esas2r_ioctl.c
index 3e8483410..34976f9a1 100644
--- a/drivers/scsi/esas2r/esas2r_ioctl.c
+++ b/drivers/scsi/esas2r/esas2r_ioctl.c
@@ -1301,7 +1301,7 @@ int esas2r_ioctl_handler(void *hostdata, int cmd, void __user *arg)
 	ioctl = kzalloc(sizeof(struct atto_express_ioctl), GFP_KERNEL);
 	if (ioctl == NULL) {
 		esas2r_log(ESAS2R_LOG_WARN,
-			   "ioctl_handler kzalloc failed for %d bytes",
+			   "ioctl_handler kzalloc failed for %lu bytes",
 			   sizeof(struct atto_express_ioctl));
 		return -ENOMEM;
 	}
diff --git a/drivers/scsi/esas2r/esas2r_log.h b/drivers/scsi/esas2r/esas2r_log.h
index 7b6397bb5..75b9d23cd 100644
--- a/drivers/scsi/esas2r/esas2r_log.h
+++ b/drivers/scsi/esas2r/esas2r_log.h
@@ -61,8 +61,8 @@ enum {
 #endif
 };
 
-int esas2r_log(const long level, const char *format, ...);
-int esas2r_log_dev(const long level,
+__printf(2, 3) int esas2r_log(const long level, const char *format, ...);
+__printf(3, 4) int esas2r_log_dev(const long level,
 		   const struct device *dev,
 		   const char *format,
 		   ...);
diff --git a/drivers/scsi/esas2r/esas2r_main.c b/drivers/scsi/esas2r/esas2r_main.c
index 2aca4d16f..cdee8638c 100644
--- a/drivers/scsi/esas2r/esas2r_main.c
+++ b/drivers/scsi/esas2r/esas2r_main.c
@@ -198,7 +198,7 @@ static ssize_t write_hw(struct file *file, struct kobject *kobj,
 					      GFP_KERNEL);
 		if (a->local_atto_ioctl == NULL) {
 			esas2r_log(ESAS2R_LOG_WARN,
-				   "write_hw kzalloc failed for %d bytes",
+				   "write_hw kzalloc failed for %lu bytes",
 				   sizeof(struct atto_ioctl));
 			return -ENOMEM;
 		}
@@ -1186,7 +1186,7 @@ retry:
 		} else {
 			esas2r_log(ESAS2R_LOG_CRIT,
 				   "unable to allocate a request for a "
-				   "device reset (%d:%d)!",
+				   "device reset (%d:%llu)!",
 				   cmd->device->id,
 				   cmd->device->lun);
 		}
diff --git a/drivers/scsi/fcoe/fcoe_sysfs.c b/drivers/scsi/fcoe/fcoe_sysfs.c
index 0675fd128..bbebe908d 100644
--- a/drivers/scsi/fcoe/fcoe_sysfs.c
+++ b/drivers/scsi/fcoe/fcoe_sysfs.c
@@ -33,8 +33,8 @@
  */
 #include "libfcoe.h"
 
-static atomic_t ctlr_num;
-static atomic_t fcf_num;
+static atomic_unchecked_t ctlr_num;
+static atomic_unchecked_t fcf_num;
 
 /*
  * fcoe_fcf_dev_loss_tmo: the default number of seconds that fcoe sysfs
@@ -724,7 +724,7 @@ struct fcoe_ctlr_device *fcoe_ctlr_device_add(struct device *parent,
 	if (!ctlr)
 		goto out;
 
-	ctlr->id = atomic_inc_return(&ctlr_num) - 1;
+	ctlr->id = atomic_inc_return_unchecked(&ctlr_num) - 1;
 	ctlr->f = f;
 	ctlr->mode = FIP_CONN_TYPE_FABRIC;
 	INIT_LIST_HEAD(&ctlr->fcfs);
@@ -941,7 +941,7 @@ struct fcoe_fcf_device *fcoe_fcf_device_add(struct fcoe_ctlr_device *ctlr,
 	fcf->dev.parent = &ctlr->dev;
 	fcf->dev.bus = &fcoe_bus_type;
 	fcf->dev.type = &fcoe_fcf_device_type;
-	fcf->id = atomic_inc_return(&fcf_num) - 1;
+	fcf->id = atomic_inc_return_unchecked(&fcf_num) - 1;
 	fcf->state = FCOE_FCF_STATE_UNKNOWN;
 
 	fcf->dev_loss_tmo = ctlr->fcf_dev_loss_tmo;
@@ -977,8 +977,8 @@ int __init fcoe_sysfs_setup(void)
 {
 	int error;
 
-	atomic_set(&ctlr_num, 0);
-	atomic_set(&fcf_num, 0);
+	atomic_set_unchecked(&ctlr_num, 0);
+	atomic_set_unchecked(&fcf_num, 0);
 
 	error = bus_register(&fcoe_bus_type);
 	if (error)
diff --git a/drivers/scsi/fcoe/fcoe_transport.c b/drivers/scsi/fcoe/fcoe_transport.c
index 7028dd37e..7392dc6fc 100644
--- a/drivers/scsi/fcoe/fcoe_transport.c
+++ b/drivers/scsi/fcoe/fcoe_transport.c
@@ -32,13 +32,13 @@ MODULE_AUTHOR("Open-FCoE.org");
 MODULE_DESCRIPTION("FIP discovery protocol and FCoE transport for FCoE HBAs");
 MODULE_LICENSE("GPL v2");
 
-static int fcoe_transport_create(const char *, struct kernel_param *);
-static int fcoe_transport_destroy(const char *, struct kernel_param *);
+static int fcoe_transport_create(const char *, const struct kernel_param *);
+static int fcoe_transport_destroy(const char *, const struct kernel_param *);
 static int fcoe_transport_show(char *buffer, const struct kernel_param *kp);
 static struct fcoe_transport *fcoe_transport_lookup(struct net_device *device);
 static struct fcoe_transport *fcoe_netdev_map_lookup(struct net_device *device);
-static int fcoe_transport_enable(const char *, struct kernel_param *);
-static int fcoe_transport_disable(const char *, struct kernel_param *);
+static int fcoe_transport_enable(const char *, const struct kernel_param *);
+static int fcoe_transport_disable(const char *, const struct kernel_param *);
 static int libfcoe_device_notification(struct notifier_block *notifier,
 				    ulong event, void *ptr);
 
@@ -846,7 +846,7 @@ EXPORT_SYMBOL(fcoe_ctlr_destroy_store);
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_create(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_create(const char *buffer, const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
@@ -911,7 +911,7 @@ out_nodev:
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_destroy(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_destroy(const char *buffer, const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
@@ -955,7 +955,7 @@ out_nodev:
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_disable(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_disable(const char *buffer, const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
@@ -989,7 +989,7 @@ out_nodev:
  *
  * Returns: 0 for success
  */
-static int fcoe_transport_enable(const char *buffer, struct kernel_param *kp)
+static int fcoe_transport_enable(const char *buffer, const struct kernel_param *kp)
 {
 	int rc = -ENODEV;
 	struct net_device *netdev = NULL;
diff --git a/drivers/scsi/hpsa.c b/drivers/scsi/hpsa.c
index 5138a841f..de7123719 100644
--- a/drivers/scsi/hpsa.c
+++ b/drivers/scsi/hpsa.c
@@ -942,10 +942,10 @@ static inline u32 next_command(struct ctlr_info *h, u8 q)
 	struct reply_queue_buffer *rq = &h->reply_queue[q];
 
 	if (h->transMethod & CFGTBL_Trans_io_accel1)
-		return h->access.command_completed(h, q);
+		return h->access->command_completed(h, q);
 
 	if (unlikely(!(h->transMethod & CFGTBL_Trans_Performant)))
-		return h->access.command_completed(h, q);
+		return h->access->command_completed(h, q);
 
 	if ((rq->head[rq->current_entry] & 1) == rq->wraparound) {
 		a = rq->head[rq->current_entry];
@@ -1127,7 +1127,7 @@ static void __enqueue_cmd_and_start_io(struct ctlr_info *h,
 		break;
 	default:
 		set_performant_mode(h, c, reply_queue);
-		h->access.submit_command(h, c);
+		h->access->submit_command(h, c);
 	}
 }
 
@@ -7026,17 +7026,17 @@ static void __iomem *remap_pci_mem(ulong base, ulong size)
 
 static inline unsigned long get_next_completion(struct ctlr_info *h, u8 q)
 {
-	return h->access.command_completed(h, q);
+	return h->access->command_completed(h, q);
 }
 
 static inline bool interrupt_pending(struct ctlr_info *h)
 {
-	return h->access.intr_pending(h);
+	return h->access->intr_pending(h);
 }
 
 static inline long interrupt_not_for_us(struct ctlr_info *h)
 {
-	return (h->access.intr_pending(h) == 0) ||
+	return (h->access->intr_pending(h) == 0) ||
 		(h->interrupts_enabled == 0);
 }
 
@@ -7964,7 +7964,7 @@ static int hpsa_pci_init(struct ctlr_info *h)
 	if (prod_index < 0)
 		return prod_index;
 	h->product_name = products[prod_index].product_name;
-	h->access = *(products[prod_index].access);
+	h->access = products[prod_index].access;
 
 	h->needs_abort_tags_swizzled =
 		ctlr_needs_abort_tags_swizzled(h->board_id);
@@ -8363,7 +8363,7 @@ static void controller_lockup_detected(struct ctlr_info *h)
 	unsigned long flags;
 	u32 lockup_detected;
 
-	h->access.set_intr_mask(h, HPSA_INTR_OFF);
+	h->access->set_intr_mask(h, HPSA_INTR_OFF);
 	spin_lock_irqsave(&h->lock, flags);
 	lockup_detected = readl(h->vaddr + SA5_SCRATCHPAD_OFFSET);
 	if (!lockup_detected) {
@@ -8701,7 +8701,7 @@ reinit_after_soft_reset:
 	}
 
 	/* make sure the board interrupts are off */
-	h->access.set_intr_mask(h, HPSA_INTR_OFF);
+	h->access->set_intr_mask(h, HPSA_INTR_OFF);
 
 	rc = hpsa_request_irqs(h, do_hpsa_intr_msi, do_hpsa_intr_intx);
 	if (rc)
@@ -8754,7 +8754,7 @@ reinit_after_soft_reset:
 		 * fake ones to scoop up any residual completions.
 		 */
 		spin_lock_irqsave(&h->lock, flags);
-		h->access.set_intr_mask(h, HPSA_INTR_OFF);
+		h->access->set_intr_mask(h, HPSA_INTR_OFF);
 		spin_unlock_irqrestore(&h->lock, flags);
 		hpsa_free_irqs(h);
 		rc = hpsa_request_irqs(h, hpsa_msix_discard_completions,
@@ -8784,9 +8784,9 @@ reinit_after_soft_reset:
 		dev_info(&h->pdev->dev, "Board READY.\n");
 		dev_info(&h->pdev->dev,
 			"Waiting for stale completions to drain.\n");
-		h->access.set_intr_mask(h, HPSA_INTR_ON);
+		h->access->set_intr_mask(h, HPSA_INTR_ON);
 		msleep(10000);
-		h->access.set_intr_mask(h, HPSA_INTR_OFF);
+		h->access->set_intr_mask(h, HPSA_INTR_OFF);
 
 		rc = controller_reset_failed(h->cfgtable);
 		if (rc)
@@ -8813,7 +8813,7 @@ reinit_after_soft_reset:
 
 
 	/* Turn the interrupts on so we can service requests */
-	h->access.set_intr_mask(h, HPSA_INTR_ON);
+	h->access->set_intr_mask(h, HPSA_INTR_ON);
 
 	hpsa_hba_inquiry(h);
 
@@ -8839,7 +8839,7 @@ reinit_after_soft_reset:
 
 clean7: /* perf, sg, cmd, irq, shost, pci, lu, aer/h */
 	hpsa_free_performant_mode(h);
-	h->access.set_intr_mask(h, HPSA_INTR_OFF);
+	h->access->set_intr_mask(h, HPSA_INTR_OFF);
 clean6: /* sg, cmd, irq, pci, lockup, wq/aer/h */
 	hpsa_free_sg_chain_blocks(h);
 clean5: /* cmd, irq, shost, pci, lu, aer/h */
@@ -8974,7 +8974,7 @@ static void hpsa_shutdown(struct pci_dev *pdev)
 	 * To write all data in the battery backed cache to disks
 	 */
 	hpsa_flush_cache(h);
-	h->access.set_intr_mask(h, HPSA_INTR_OFF);
+	h->access->set_intr_mask(h, HPSA_INTR_OFF);
 	hpsa_free_irqs(h);			/* init_one 4 */
 	hpsa_disable_interrupt_mode(h);		/* pci_init 2 */
 }
@@ -9116,7 +9116,7 @@ static int hpsa_enter_performant_mode(struct ctlr_info *h, u32 trans_support)
 				CFGTBL_Trans_enable_directed_msix |
 			(trans_support & (CFGTBL_Trans_io_accel1 |
 				CFGTBL_Trans_io_accel2));
-	struct access_method access = SA5_performant_access;
+	struct access_method *access = &SA5_performant_access;
 
 	/* This is a bit complicated.  There are 8 registers on
 	 * the controller which we write to to tell it 8 different
@@ -9158,7 +9158,7 @@ static int hpsa_enter_performant_mode(struct ctlr_info *h, u32 trans_support)
 	 * perform the superfluous readl() after each command submission.
 	 */
 	if (trans_support & (CFGTBL_Trans_io_accel1 | CFGTBL_Trans_io_accel2))
-		access = SA5_performant_access_no_read;
+		access = &SA5_performant_access_no_read;
 
 	/* Controller spec: zero out this buffer. */
 	for (i = 0; i < h->nreply_queues; i++)
@@ -9188,12 +9188,12 @@ static int hpsa_enter_performant_mode(struct ctlr_info *h, u32 trans_support)
 	 * enable outbound interrupt coalescing in accelerator mode;
 	 */
 	if (trans_support & CFGTBL_Trans_io_accel1) {
-		access = SA5_ioaccel_mode1_access;
+		access = &SA5_ioaccel_mode1_access;
 		writel(10, &h->cfgtable->HostWrite.CoalIntDelay);
 		writel(4, &h->cfgtable->HostWrite.CoalIntCount);
 	} else {
 		if (trans_support & CFGTBL_Trans_io_accel2) {
-			access = SA5_ioaccel_mode2_access;
+			access = &SA5_ioaccel_mode2_access;
 			writel(10, &h->cfgtable->HostWrite.CoalIntDelay);
 			writel(4, &h->cfgtable->HostWrite.CoalIntCount);
 		}
diff --git a/drivers/scsi/hpsa.h b/drivers/scsi/hpsa.h
index 9d45dde57..622095a98 100644
--- a/drivers/scsi/hpsa.h
+++ b/drivers/scsi/hpsa.h
@@ -180,7 +180,7 @@ struct ctlr_info {
 	unsigned int msix_vector;
 	unsigned int msi_vector;
 	int intr_mode; /* either PERF_MODE_INT or SIMPLE_MODE_INT */
-	struct access_method access;
+	struct access_method *access;
 
 	/* queue and queue Info */
 	unsigned int Qdepth;
@@ -581,38 +581,38 @@ static unsigned long SA5_ioaccel_mode1_completed(struct ctlr_info *h, u8 q)
 }
 
 static struct access_method SA5_access = {
-	SA5_submit_command,
-	SA5_intr_mask,
-	SA5_intr_pending,
-	SA5_completed,
+	.submit_command = SA5_submit_command,
+	.set_intr_mask = SA5_intr_mask,
+	.intr_pending = SA5_intr_pending,
+	.command_completed = SA5_completed,
 };
 
 static struct access_method SA5_ioaccel_mode1_access = {
-	SA5_submit_command,
-	SA5_performant_intr_mask,
-	SA5_ioaccel_mode1_intr_pending,
-	SA5_ioaccel_mode1_completed,
+	.submit_command = SA5_submit_command,
+	.set_intr_mask = SA5_performant_intr_mask,
+	.intr_pending = SA5_ioaccel_mode1_intr_pending,
+	.command_completed = SA5_ioaccel_mode1_completed,
 };
 
 static struct access_method SA5_ioaccel_mode2_access = {
-	SA5_submit_command_ioaccel2,
-	SA5_performant_intr_mask,
-	SA5_performant_intr_pending,
-	SA5_performant_completed,
+	.submit_command = SA5_submit_command_ioaccel2,
+	.set_intr_mask = SA5_performant_intr_mask,
+	.intr_pending = SA5_performant_intr_pending,
+	.command_completed = SA5_performant_completed,
 };
 
 static struct access_method SA5_performant_access = {
-	SA5_submit_command,
-	SA5_performant_intr_mask,
-	SA5_performant_intr_pending,
-	SA5_performant_completed,
+	.submit_command = SA5_submit_command,
+	.set_intr_mask = SA5_performant_intr_mask,
+	.intr_pending = SA5_performant_intr_pending,
+	.command_completed = SA5_performant_completed,
 };
 
 static struct access_method SA5_performant_access_no_read = {
-	SA5_submit_command_no_read,
-	SA5_performant_intr_mask,
-	SA5_performant_intr_pending,
-	SA5_performant_completed,
+	.submit_command = SA5_submit_command_no_read,
+	.set_intr_mask = SA5_performant_intr_mask,
+	.intr_pending = SA5_performant_intr_pending,
+	.command_completed = SA5_performant_completed,
 };
 
 struct board_type {
diff --git a/drivers/scsi/hptiop.c b/drivers/scsi/hptiop.c
index a83f705ed..b40c5e665 100644
--- a/drivers/scsi/hptiop.c
+++ b/drivers/scsi/hptiop.c
@@ -1082,7 +1082,6 @@ static const char *hptiop_info(struct Scsi_Host *host)
 static int hptiop_reset_hba(struct hptiop_hba *hba)
 {
 	if (atomic_xchg(&hba->resetting, 1) == 0) {
-		atomic_inc(&hba->reset_count);
 		hba->ops->post_msg(hba, IOPMU_INBOUND_MSG0_RESET);
 	}
 
@@ -1340,7 +1339,6 @@ static int hptiop_probe(struct pci_dev *pcidev, const struct pci_device_id *id)
 	hba->iopintf_v2 = 0;
 
 	atomic_set(&hba->resetting, 0);
-	atomic_set(&hba->reset_count, 0);
 
 	init_waitqueue_head(&hba->reset_wq);
 	init_waitqueue_head(&hba->ioctl_wq);
diff --git a/drivers/scsi/hptiop.h b/drivers/scsi/hptiop.h
index 4d1c51153..d5744cb20 100644
--- a/drivers/scsi/hptiop.h
+++ b/drivers/scsi/hptiop.h
@@ -330,7 +330,6 @@ struct hptiop_hba {
 	void        *dma_coherent[HPTIOP_MAX_REQUESTS];
 	dma_addr_t  dma_coherent_handle[HPTIOP_MAX_REQUESTS];
 
-	atomic_t    reset_count;
 	atomic_t    resetting;
 
 	wait_queue_head_t reset_wq;
diff --git a/drivers/scsi/ipr.c b/drivers/scsi/ipr.c
index 17d04c702..17a294827 100644
--- a/drivers/scsi/ipr.c
+++ b/drivers/scsi/ipr.c
@@ -948,7 +948,7 @@ static void ipr_send_command(struct ipr_cmnd *ipr_cmd)
  **/
 static void ipr_do_req(struct ipr_cmnd *ipr_cmd,
 		       void (*done) (struct ipr_cmnd *),
-		       void (*timeout_func) (struct ipr_cmnd *), u32 timeout)
+		       void (*timeout_func) (unsigned long), u32 timeout)
 {
 	list_add_tail(&ipr_cmd->queue, &ipr_cmd->hrrq->hrrq_pending_q);
 
@@ -956,7 +956,7 @@ static void ipr_do_req(struct ipr_cmnd *ipr_cmd,
 
 	ipr_cmd->timer.data = (unsigned long) ipr_cmd;
 	ipr_cmd->timer.expires = jiffies + timeout;
-	ipr_cmd->timer.function = (void (*)(unsigned long))timeout_func;
+	ipr_cmd->timer.function = timeout_func;
 
 	add_timer(&ipr_cmd->timer);
 
@@ -1038,7 +1038,7 @@ static void ipr_init_ioadl(struct ipr_cmnd *ipr_cmd, dma_addr_t dma_addr,
  * 	none
  **/
 static void ipr_send_blocking_cmd(struct ipr_cmnd *ipr_cmd,
-				  void (*timeout_func) (struct ipr_cmnd *ipr_cmd),
+				  void (*timeout_func) (unsigned long ipr_cmd),
 				  u32 timeout)
 {
 	struct ipr_ioa_cfg *ioa_cfg = ipr_cmd->ioa_cfg;
@@ -1058,7 +1058,7 @@ static int ipr_get_hrrq_index(struct ipr_ioa_cfg *ioa_cfg)
 	if (ioa_cfg->hrrq_num == 1)
 		hrrq = 0;
 	else {
-		hrrq = atomic_add_return(1, &ioa_cfg->hrrq_index);
+		hrrq = atomic_add_return_unchecked(1, &ioa_cfg->hrrq_index);
 		hrrq = (hrrq % (ioa_cfg->hrrq_num - 1)) + 1;
 	}
 	return hrrq;
@@ -2601,8 +2601,9 @@ static void ipr_process_error(struct ipr_cmnd *ipr_cmd)
  * Return value:
  * 	none
  **/
-static void ipr_timeout(struct ipr_cmnd *ipr_cmd)
+static void ipr_timeout(unsigned long _ipr_cmd)
 {
+	struct ipr_cmnd *ipr_cmd = (struct ipr_cmnd *)_ipr_cmd;
 	unsigned long lock_flags = 0;
 	struct ipr_ioa_cfg *ioa_cfg = ipr_cmd->ioa_cfg;
 
@@ -2633,8 +2634,9 @@ static void ipr_timeout(struct ipr_cmnd *ipr_cmd)
  * Return value:
  * 	none
  **/
-static void ipr_oper_timeout(struct ipr_cmnd *ipr_cmd)
+static void ipr_oper_timeout(unsigned long _ipr_cmd)
 {
+	struct ipr_cmnd *ipr_cmd = (struct ipr_cmnd *)_ipr_cmd;
 	unsigned long lock_flags = 0;
 	struct ipr_ioa_cfg *ioa_cfg = ipr_cmd->ioa_cfg;
 
@@ -5269,8 +5271,9 @@ static void ipr_bus_reset_done(struct ipr_cmnd *ipr_cmd)
  * Return value:
  *	none
  **/
-static void ipr_abort_timeout(struct ipr_cmnd *ipr_cmd)
+static void ipr_abort_timeout(unsigned long _ipr_cmd)
 {
+	struct ipr_cmnd *ipr_cmd = (struct ipr_cmnd *)_ipr_cmd;
 	struct ipr_cmnd *reset_cmd;
 	struct ipr_ioa_cfg *ioa_cfg = ipr_cmd->ioa_cfg;
 	struct ipr_cmd_pkt *cmd_pkt;
@@ -8042,8 +8045,9 @@ static int ipr_ioafp_identify_hrrq(struct ipr_cmnd *ipr_cmd)
  * Return value:
  * 	none
  **/
-static void ipr_reset_timer_done(struct ipr_cmnd *ipr_cmd)
+static void ipr_reset_timer_done(unsigned long _ipr_cmd)
 {
+	struct ipr_cmnd *ipr_cmd = (struct ipr_cmnd *)_ipr_cmd;
 	struct ipr_ioa_cfg *ioa_cfg = ipr_cmd->ioa_cfg;
 	unsigned long lock_flags = 0;
 
@@ -8081,7 +8085,7 @@ static void ipr_reset_start_timer(struct ipr_cmnd *ipr_cmd,
 
 	ipr_cmd->timer.data = (unsigned long) ipr_cmd;
 	ipr_cmd->timer.expires = jiffies + timeout;
-	ipr_cmd->timer.function = (void (*)(unsigned long))ipr_reset_timer_done;
+	ipr_cmd->timer.function = ipr_reset_timer_done;
 	add_timer(&ipr_cmd->timer);
 }
 
@@ -8111,9 +8115,9 @@ static void ipr_init_ioa_mem(struct ipr_ioa_cfg *ioa_cfg)
 
 	ioa_cfg->identify_hrrq_index = 0;
 	if (ioa_cfg->hrrq_num == 1)
-		atomic_set(&ioa_cfg->hrrq_index, 0);
+		atomic_set_unchecked(&ioa_cfg->hrrq_index, 0);
 	else
-		atomic_set(&ioa_cfg->hrrq_index, 1);
+		atomic_set_unchecked(&ioa_cfg->hrrq_index, 1);
 
 	/* Zero out config table */
 	memset(ioa_cfg->u.cfg_table, 0, ioa_cfg->cfg_table_size);
@@ -8167,7 +8171,7 @@ static int ipr_reset_next_stage(struct ipr_cmnd *ipr_cmd)
 
 	ipr_cmd->timer.data = (unsigned long) ipr_cmd;
 	ipr_cmd->timer.expires = jiffies + stage_time * HZ;
-	ipr_cmd->timer.function = (void (*)(unsigned long))ipr_oper_timeout;
+	ipr_cmd->timer.function = ipr_oper_timeout;
 	ipr_cmd->done = ipr_reset_ioa_job;
 	add_timer(&ipr_cmd->timer);
 
@@ -8239,7 +8243,7 @@ static int ipr_reset_enable_ioa(struct ipr_cmnd *ipr_cmd)
 
 	ipr_cmd->timer.data = (unsigned long) ipr_cmd;
 	ipr_cmd->timer.expires = jiffies + (ioa_cfg->transop_timeout * HZ);
-	ipr_cmd->timer.function = (void (*)(unsigned long))ipr_oper_timeout;
+	ipr_cmd->timer.function = ipr_oper_timeout;
 	ipr_cmd->done = ipr_reset_ioa_job;
 	add_timer(&ipr_cmd->timer);
 	list_add_tail(&ipr_cmd->queue, &ipr_cmd->hrrq->hrrq_pending_q);
@@ -9227,7 +9231,7 @@ static void ipr_pci_perm_failure(struct pci_dev *pdev)
  * 	PCI_ERS_RESULT_NEED_RESET or PCI_ERS_RESULT_DISCONNECT
  */
 static pci_ers_result_t ipr_pci_error_detected(struct pci_dev *pdev,
-					       pci_channel_state_t state)
+					       enum pci_channel_state state)
 {
 	switch (state) {
 	case pci_channel_io_frozen:
diff --git a/drivers/scsi/ipr.h b/drivers/scsi/ipr.h
index cdb51960b..f7e8eff49 100644
--- a/drivers/scsi/ipr.h
+++ b/drivers/scsi/ipr.h
@@ -1539,7 +1539,7 @@ struct ipr_ioa_cfg {
 
 	struct ipr_hrr_queue hrrq[IPR_MAX_HRRQ_NUM];
 	u32 hrrq_num;
-	atomic_t  hrrq_index;
+	atomic_unchecked_t  hrrq_index;
 	u16 identify_hrrq_index;
 
 	struct ipr_bus_attributes bus_attr[IPR_MAX_NUM_BUSES];
diff --git a/drivers/scsi/libfc/fc_exch.c b/drivers/scsi/libfc/fc_exch.c
index e72673b0a..977ed1494 100644
--- a/drivers/scsi/libfc/fc_exch.c
+++ b/drivers/scsi/libfc/fc_exch.c
@@ -101,12 +101,12 @@ struct fc_exch_mgr {
 	u16		pool_max_index;
 
 	struct {
-		atomic_t no_free_exch;
-		atomic_t no_free_exch_xid;
-		atomic_t xid_not_found;
-		atomic_t xid_busy;
-		atomic_t seq_not_found;
-		atomic_t non_bls_resp;
+		atomic_unchecked_t no_free_exch;
+		atomic_unchecked_t no_free_exch_xid;
+		atomic_unchecked_t xid_not_found;
+		atomic_unchecked_t xid_busy;
+		atomic_unchecked_t seq_not_found;
+		atomic_unchecked_t non_bls_resp;
 	} stats;
 };
 
@@ -809,7 +809,7 @@ static struct fc_exch *fc_exch_em_alloc(struct fc_lport *lport,
 	/* allocate memory for exchange */
 	ep = mempool_alloc(mp->ep_pool, GFP_ATOMIC);
 	if (!ep) {
-		atomic_inc(&mp->stats.no_free_exch);
+		atomic_inc_unchecked(&mp->stats.no_free_exch);
 		goto out;
 	}
 	memset(ep, 0, sizeof(*ep));
@@ -872,7 +872,7 @@ out:
 	return ep;
 err:
 	spin_unlock_bh(&pool->lock);
-	atomic_inc(&mp->stats.no_free_exch_xid);
+	atomic_inc_unchecked(&mp->stats.no_free_exch_xid);
 	mempool_free(ep, mp->ep_pool);
 	return NULL;
 }
@@ -1029,7 +1029,7 @@ static enum fc_pf_rjt_reason fc_seq_lookup_recip(struct fc_lport *lport,
 		xid = ntohs(fh->fh_ox_id);	/* we originated exch */
 		ep = fc_exch_find(mp, xid);
 		if (!ep) {
-			atomic_inc(&mp->stats.xid_not_found);
+			atomic_inc_unchecked(&mp->stats.xid_not_found);
 			reject = FC_RJT_OX_ID;
 			goto out;
 		}
@@ -1059,7 +1059,7 @@ static enum fc_pf_rjt_reason fc_seq_lookup_recip(struct fc_lport *lport,
 		ep = fc_exch_find(mp, xid);
 		if ((f_ctl & FC_FC_FIRST_SEQ) && fc_sof_is_init(fr_sof(fp))) {
 			if (ep) {
-				atomic_inc(&mp->stats.xid_busy);
+				atomic_inc_unchecked(&mp->stats.xid_busy);
 				reject = FC_RJT_RX_ID;
 				goto rel;
 			}
@@ -1070,7 +1070,7 @@ static enum fc_pf_rjt_reason fc_seq_lookup_recip(struct fc_lport *lport,
 			}
 			xid = ep->xid;	/* get our XID */
 		} else if (!ep) {
-			atomic_inc(&mp->stats.xid_not_found);
+			atomic_inc_unchecked(&mp->stats.xid_not_found);
 			reject = FC_RJT_RX_ID;	/* XID not found */
 			goto out;
 		}
@@ -1088,7 +1088,7 @@ static enum fc_pf_rjt_reason fc_seq_lookup_recip(struct fc_lport *lport,
 	} else {
 		sp = &ep->seq;
 		if (sp->id != fh->fh_seq_id) {
-			atomic_inc(&mp->stats.seq_not_found);
+			atomic_inc_unchecked(&mp->stats.seq_not_found);
 			if (f_ctl & FC_FC_END_SEQ) {
 				/*
 				 * Update sequence_id based on incoming last
@@ -1539,22 +1539,22 @@ static void fc_exch_recv_seq_resp(struct fc_exch_mgr *mp, struct fc_frame *fp)
 
 	ep = fc_exch_find(mp, ntohs(fh->fh_ox_id));
 	if (!ep) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto out;
 	}
 	if (ep->esb_stat & ESB_ST_COMPLETE) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto rel;
 	}
 	if (ep->rxid == FC_XID_UNKNOWN)
 		ep->rxid = ntohs(fh->fh_rx_id);
 	if (ep->sid != 0 && ep->sid != ntoh24(fh->fh_d_id)) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto rel;
 	}
 	if (ep->did != ntoh24(fh->fh_s_id) &&
 	    ep->did != FC_FID_FLOGI) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto rel;
 	}
 	sof = fr_sof(fp);
@@ -1563,7 +1563,7 @@ static void fc_exch_recv_seq_resp(struct fc_exch_mgr *mp, struct fc_frame *fp)
 		sp->ssb_stat |= SSB_ST_RESP;
 		sp->id = fh->fh_seq_id;
 	} else if (sp->id != fh->fh_seq_id) {
-		atomic_inc(&mp->stats.seq_not_found);
+		atomic_inc_unchecked(&mp->stats.seq_not_found);
 		goto rel;
 	}
 
@@ -1626,9 +1626,9 @@ static void fc_exch_recv_resp(struct fc_exch_mgr *mp, struct fc_frame *fp)
 	sp = fc_seq_lookup_orig(mp, fp);	/* doesn't hold sequence */
 
 	if (!sp)
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 	else
-		atomic_inc(&mp->stats.non_bls_resp);
+		atomic_inc_unchecked(&mp->stats.non_bls_resp);
 
 	fc_frame_free(fp);
 }
@@ -2269,13 +2269,13 @@ void fc_exch_update_stats(struct fc_lport *lport)
 
 	list_for_each_entry(ema, &lport->ema_list, ema_list) {
 		mp = ema->mp;
-		st->fc_no_free_exch += atomic_read(&mp->stats.no_free_exch);
+		st->fc_no_free_exch += atomic_read_unchecked(&mp->stats.no_free_exch);
 		st->fc_no_free_exch_xid +=
-				atomic_read(&mp->stats.no_free_exch_xid);
-		st->fc_xid_not_found += atomic_read(&mp->stats.xid_not_found);
-		st->fc_xid_busy += atomic_read(&mp->stats.xid_busy);
-		st->fc_seq_not_found += atomic_read(&mp->stats.seq_not_found);
-		st->fc_non_bls_resp += atomic_read(&mp->stats.non_bls_resp);
+				atomic_read_unchecked(&mp->stats.no_free_exch_xid);
+		st->fc_xid_not_found += atomic_read_unchecked(&mp->stats.xid_not_found);
+		st->fc_xid_busy += atomic_read_unchecked(&mp->stats.xid_busy);
+		st->fc_seq_not_found += atomic_read_unchecked(&mp->stats.seq_not_found);
+		st->fc_non_bls_resp += atomic_read_unchecked(&mp->stats.non_bls_resp);
 	}
 }
 EXPORT_SYMBOL(fc_exch_update_stats);
diff --git a/drivers/scsi/libsas/sas_ata.c b/drivers/scsi/libsas/sas_ata.c
index 763f012fd..641a55ac6 100644
--- a/drivers/scsi/libsas/sas_ata.c
+++ b/drivers/scsi/libsas/sas_ata.c
@@ -532,7 +532,7 @@ static struct ata_port_operations sas_sata_ops = {
 	.postreset		= ata_std_postreset,
 	.error_handler		= ata_std_error_handler,
 	.post_internal_cmd	= sas_ata_post_internal,
-	.qc_defer               = ata_std_qc_defer,
+	.qc_defer		= ata_std_qc_defer,
 	.qc_prep		= ata_noop_qc_prep,
 	.qc_issue		= sas_ata_qc_issue,
 	.qc_fill_rtf		= sas_ata_qc_fill_rtf,
diff --git a/drivers/scsi/lpfc/lpfc.h b/drivers/scsi/lpfc/lpfc.h
index b48485946..1ea4db4bb 100644
--- a/drivers/scsi/lpfc/lpfc.h
+++ b/drivers/scsi/lpfc/lpfc.h
@@ -430,7 +430,7 @@ struct lpfc_vport {
 	struct dentry *debug_nodelist;
 	struct dentry *vport_debugfs_root;
 	struct lpfc_debugfs_trc *disc_trc;
-	atomic_t disc_trc_cnt;
+	atomic_unchecked_t disc_trc_cnt;
 #endif
 	uint8_t stat_data_enabled;
 	uint8_t stat_data_blocked;
@@ -898,8 +898,8 @@ struct lpfc_hba {
 	struct timer_list fabric_block_timer;
 	unsigned long bit_flags;
 #define	FABRIC_COMANDS_BLOCKED	0
-	atomic_t num_rsrc_err;
-	atomic_t num_cmd_success;
+	atomic_unchecked_t num_rsrc_err;
+	atomic_unchecked_t num_cmd_success;
 	unsigned long last_rsrc_error_time;
 	unsigned long last_ramp_down_time;
 #ifdef CONFIG_SCSI_LPFC_DEBUG_FS
@@ -934,7 +934,7 @@ struct lpfc_hba {
 
 	struct dentry *debug_slow_ring_trc;
 	struct lpfc_debugfs_trc *slow_ring_trc;
-	atomic_t slow_ring_trc_cnt;
+	atomic_unchecked_t slow_ring_trc_cnt;
 	/* iDiag debugfs sub-directory */
 	struct dentry *idiag_root;
 	struct dentry *idiag_pci_cfg;
diff --git a/drivers/scsi/lpfc/lpfc_debugfs.c b/drivers/scsi/lpfc/lpfc_debugfs.c
index a63542bac..80692eedf 100644
--- a/drivers/scsi/lpfc/lpfc_debugfs.c
+++ b/drivers/scsi/lpfc/lpfc_debugfs.c
@@ -106,7 +106,7 @@ MODULE_PARM_DESC(lpfc_debugfs_mask_disc_trc,
 
 #include <linux/debugfs.h>
 
-static atomic_t lpfc_debugfs_seq_trc_cnt = ATOMIC_INIT(0);
+static atomic_unchecked_t lpfc_debugfs_seq_trc_cnt = ATOMIC_INIT(0);
 static unsigned long lpfc_debugfs_start_time = 0L;
 
 /* iDiag */
@@ -147,7 +147,7 @@ lpfc_debugfs_disc_trc_data(struct lpfc_vport *vport, char *buf, int size)
 	lpfc_debugfs_enable = 0;
 
 	len = 0;
-	index = (atomic_read(&vport->disc_trc_cnt) + 1) &
+	index = (atomic_read_unchecked(&vport->disc_trc_cnt) + 1) &
 		(lpfc_debugfs_max_disc_trc - 1);
 	for (i = index; i < lpfc_debugfs_max_disc_trc; i++) {
 		dtp = vport->disc_trc + i;
@@ -213,7 +213,7 @@ lpfc_debugfs_slow_ring_trc_data(struct lpfc_hba *phba, char *buf, int size)
 	lpfc_debugfs_enable = 0;
 
 	len = 0;
-	index = (atomic_read(&phba->slow_ring_trc_cnt) + 1) &
+	index = (atomic_read_unchecked(&phba->slow_ring_trc_cnt) + 1) &
 		(lpfc_debugfs_max_slow_ring_trc - 1);
 	for (i = index; i < lpfc_debugfs_max_slow_ring_trc; i++) {
 		dtp = phba->slow_ring_trc + i;
@@ -646,14 +646,14 @@ lpfc_debugfs_disc_trc(struct lpfc_vport *vport, int mask, char *fmt,
 		!vport || !vport->disc_trc)
 		return;
 
-	index = atomic_inc_return(&vport->disc_trc_cnt) &
+	index = atomic_inc_return_unchecked(&vport->disc_trc_cnt) &
 		(lpfc_debugfs_max_disc_trc - 1);
 	dtp = vport->disc_trc + index;
 	dtp->fmt = fmt;
 	dtp->data1 = data1;
 	dtp->data2 = data2;
 	dtp->data3 = data3;
-	dtp->seq_cnt = atomic_inc_return(&lpfc_debugfs_seq_trc_cnt);
+	dtp->seq_cnt = atomic_inc_return_unchecked(&lpfc_debugfs_seq_trc_cnt);
 	dtp->jif = jiffies;
 #endif
 	return;
@@ -684,14 +684,14 @@ lpfc_debugfs_slow_ring_trc(struct lpfc_hba *phba, char *fmt,
 		!phba || !phba->slow_ring_trc)
 		return;
 
-	index = atomic_inc_return(&phba->slow_ring_trc_cnt) &
+	index = atomic_inc_return_unchecked(&phba->slow_ring_trc_cnt) &
 		(lpfc_debugfs_max_slow_ring_trc - 1);
 	dtp = phba->slow_ring_trc + index;
 	dtp->fmt = fmt;
 	dtp->data1 = data1;
 	dtp->data2 = data2;
 	dtp->data3 = data3;
-	dtp->seq_cnt = atomic_inc_return(&lpfc_debugfs_seq_trc_cnt);
+	dtp->seq_cnt = atomic_inc_return_unchecked(&lpfc_debugfs_seq_trc_cnt);
 	dtp->jif = jiffies;
 #endif
 	return;
@@ -4268,7 +4268,7 @@ lpfc_debugfs_initialize(struct lpfc_vport *vport)
 						 "slow_ring buffer\n");
 				goto debug_failed;
 			}
-			atomic_set(&phba->slow_ring_trc_cnt, 0);
+			atomic_set_unchecked(&phba->slow_ring_trc_cnt, 0);
 			memset(phba->slow_ring_trc, 0,
 				(sizeof(struct lpfc_debugfs_trc) *
 				lpfc_debugfs_max_slow_ring_trc));
@@ -4314,7 +4314,7 @@ lpfc_debugfs_initialize(struct lpfc_vport *vport)
 				 "buffer\n");
 		goto debug_failed;
 	}
-	atomic_set(&vport->disc_trc_cnt, 0);
+	atomic_set_unchecked(&vport->disc_trc_cnt, 0);
 
 	snprintf(name, sizeof(name), "discovery_trace");
 	vport->debug_disc_trc =
diff --git a/drivers/scsi/lpfc/lpfc_init.c b/drivers/scsi/lpfc/lpfc_init.c
index b100a22b3..7bc84eaec 100644
--- a/drivers/scsi/lpfc/lpfc_init.c
+++ b/drivers/scsi/lpfc/lpfc_init.c
@@ -11127,7 +11127,7 @@ lpfc_pci_resume_one(struct pci_dev *pdev)
  * 	PCI_ERS_RESULT_DISCONNECT - device could not be recovered
  **/
 static pci_ers_result_t
-lpfc_io_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+lpfc_io_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct Scsi_Host *shost = pci_get_drvdata(pdev);
 	struct lpfc_hba *phba = ((struct lpfc_vport *)shost->hostdata)->phba;
@@ -11434,8 +11434,10 @@ lpfc_init(void)
 		printk(KERN_ERR "Could not register lpfcmgmt device, "
 			"misc_register returned with status %d", error);
 
-	lpfc_transport_functions.vport_create = lpfc_vport_create;
-	lpfc_transport_functions.vport_delete = lpfc_vport_delete;
+	pax_open_kernel();
+	const_cast(lpfc_transport_functions.vport_create) = lpfc_vport_create;
+	const_cast(lpfc_transport_functions.vport_delete) = lpfc_vport_delete;
+	pax_close_kernel();
 	lpfc_transport_template =
 				fc_attach_transport(&lpfc_transport_functions);
 	if (lpfc_transport_template == NULL)
diff --git a/drivers/scsi/lpfc/lpfc_scsi.c b/drivers/scsi/lpfc/lpfc_scsi.c
index d197aa176..c1178a684 100644
--- a/drivers/scsi/lpfc/lpfc_scsi.c
+++ b/drivers/scsi/lpfc/lpfc_scsi.c
@@ -261,7 +261,7 @@ lpfc_rampdown_queue_depth(struct lpfc_hba *phba)
 	unsigned long expires;
 
 	spin_lock_irqsave(&phba->hbalock, flags);
-	atomic_inc(&phba->num_rsrc_err);
+	atomic_inc_unchecked(&phba->num_rsrc_err);
 	phba->last_rsrc_error_time = jiffies;
 
 	expires = phba->last_ramp_down_time + QUEUE_RAMP_DOWN_INTERVAL;
@@ -303,8 +303,8 @@ lpfc_ramp_down_queue_handler(struct lpfc_hba *phba)
 	unsigned long num_rsrc_err, num_cmd_success;
 	int i;
 
-	num_rsrc_err = atomic_read(&phba->num_rsrc_err);
-	num_cmd_success = atomic_read(&phba->num_cmd_success);
+	num_rsrc_err = atomic_read_unchecked(&phba->num_rsrc_err);
+	num_cmd_success = atomic_read_unchecked(&phba->num_cmd_success);
 
 	/*
 	 * The error and success command counters are global per
@@ -331,8 +331,8 @@ lpfc_ramp_down_queue_handler(struct lpfc_hba *phba)
 			}
 		}
 	lpfc_destroy_vport_work_array(phba, vports);
-	atomic_set(&phba->num_rsrc_err, 0);
-	atomic_set(&phba->num_cmd_success, 0);
+	atomic_set_unchecked(&phba->num_rsrc_err, 0);
+	atomic_set_unchecked(&phba->num_cmd_success, 0);
 }
 
 /**
diff --git a/drivers/scsi/megaraid/megaraid_sas.h b/drivers/scsi/megaraid/megaraid_sas.h
index 3aaea713b..6cd098b0e 100644
--- a/drivers/scsi/megaraid/megaraid_sas.h
+++ b/drivers/scsi/megaraid/megaraid_sas.h
@@ -2048,7 +2048,7 @@ struct megasas_instance {
 	s8 init_id;
 
 	u16 max_num_sge;
-	u16 max_fw_cmds;
+	u16 max_fw_cmds __intentional_overflow(-1);
 	u16 max_mfi_cmds;
 	u16 max_scsi_cmds;
 	u16 ldio_threshold;
diff --git a/drivers/scsi/mpt3sas/mpt3sas_base.c b/drivers/scsi/mpt3sas/mpt3sas_base.c
index 750f82c33..956cdf0bd 100644
--- a/drivers/scsi/mpt3sas/mpt3sas_base.c
+++ b/drivers/scsi/mpt3sas/mpt3sas_base.c
@@ -105,7 +105,7 @@ _base_get_ioc_facts(struct MPT3SAS_ADAPTER *ioc, int sleep_flag);
  *
  */
 static int
-_scsih_set_fwfault_debug(const char *val, struct kernel_param *kp)
+_scsih_set_fwfault_debug(const char *val, const struct kernel_param *kp)
 {
 	int ret = param_set_int(val, kp);
 	struct MPT3SAS_ADAPTER *ioc;
diff --git a/drivers/scsi/mpt3sas/mpt3sas_scsih.c b/drivers/scsi/mpt3sas/mpt3sas_scsih.c
index 58e60298a..03e41fa37 100644
--- a/drivers/scsi/mpt3sas/mpt3sas_scsih.c
+++ b/drivers/scsi/mpt3sas/mpt3sas_scsih.c
@@ -280,7 +280,7 @@ struct _scsi_io_transfer {
  * Note: The logging levels are defined in mpt3sas_debug.h.
  */
 static int
-_scsih_set_debug_level(const char *val, struct kernel_param *kp)
+_scsih_set_debug_level(const char *val, const struct kernel_param *kp)
 {
 	int ret = param_set_int(val, kp);
 	struct MPT3SAS_ADAPTER *ioc;
@@ -8950,7 +8950,7 @@ scsih_resume(struct pci_dev *pdev)
  *      PCI_ERS_RESULT_NEED_RESET or PCI_ERS_RESULT_DISCONNECT
  */
 pci_ers_result_t
-scsih_pci_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+scsih_pci_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct Scsi_Host *shost = pci_get_drvdata(pdev);
 	struct MPT3SAS_ADAPTER *ioc = shost_priv(shost);
diff --git a/drivers/scsi/pmcraid.c b/drivers/scsi/pmcraid.c
index b2a88200f..d66f0cc45 100644
--- a/drivers/scsi/pmcraid.c
+++ b/drivers/scsi/pmcraid.c
@@ -201,8 +201,8 @@ static int pmcraid_slave_alloc(struct scsi_device *scsi_dev)
 		res->scsi_dev = scsi_dev;
 		scsi_dev->hostdata = res;
 		res->change_detected = 0;
-		atomic_set(&res->read_failures, 0);
-		atomic_set(&res->write_failures, 0);
+		atomic_set_unchecked(&res->read_failures, 0);
+		atomic_set_unchecked(&res->write_failures, 0);
 		rc = 0;
 	}
 	spin_unlock_irqrestore(&pinstance->resource_lock, lock_flags);
@@ -557,8 +557,9 @@ static void pmcraid_reset_type(struct pmcraid_instance *pinstance)
 
 static void pmcraid_ioa_reset(struct pmcraid_cmd *);
 
-static void pmcraid_bist_done(struct pmcraid_cmd *cmd)
+static void pmcraid_bist_done(unsigned long _cmd)
 {
+	struct pmcraid_cmd *cmd = (struct pmcraid_cmd *)_cmd;
 	struct pmcraid_instance *pinstance = cmd->drv_inst;
 	unsigned long lock_flags;
 	int rc;
@@ -573,8 +574,7 @@ static void pmcraid_bist_done(struct pmcraid_cmd *cmd)
 		cmd->timer.expires = jiffies + cmd->time_left;
 		cmd->time_left = 0;
 		cmd->timer.data = (unsigned long)cmd;
-		cmd->timer.function =
-			(void (*)(unsigned long))pmcraid_bist_done;
+		cmd->timer.function = pmcraid_bist_done;
 		add_timer(&cmd->timer);
 	} else {
 		cmd->time_left = 0;
@@ -607,7 +607,7 @@ static void pmcraid_start_bist(struct pmcraid_cmd *cmd)
 	cmd->time_left = msecs_to_jiffies(PMCRAID_BIST_TIMEOUT);
 	cmd->timer.data = (unsigned long)cmd;
 	cmd->timer.expires = jiffies + msecs_to_jiffies(PMCRAID_BIST_TIMEOUT);
-	cmd->timer.function = (void (*)(unsigned long))pmcraid_bist_done;
+	cmd->timer.function = pmcraid_bist_done;
 	add_timer(&cmd->timer);
 }
 
@@ -617,8 +617,9 @@ static void pmcraid_start_bist(struct pmcraid_cmd *cmd)
  * Return value
  *  None
  */
-static void pmcraid_reset_alert_done(struct pmcraid_cmd *cmd)
+static void pmcraid_reset_alert_done(unsigned long _cmd)
 {
+	struct pmcraid_cmd *cmd = (struct pmcraid_cmd *)_cmd;
 	struct pmcraid_instance *pinstance = cmd->drv_inst;
 	u32 status = ioread32(pinstance->ioa_status);
 	unsigned long lock_flags;
@@ -639,8 +640,7 @@ static void pmcraid_reset_alert_done(struct pmcraid_cmd *cmd)
 		cmd->time_left -= PMCRAID_CHECK_FOR_RESET_TIMEOUT;
 		cmd->timer.data = (unsigned long)cmd;
 		cmd->timer.expires = jiffies + PMCRAID_CHECK_FOR_RESET_TIMEOUT;
-		cmd->timer.function =
-			(void (*)(unsigned long))pmcraid_reset_alert_done;
+		cmd->timer.function = pmcraid_reset_alert_done;
 		add_timer(&cmd->timer);
 	}
 }
@@ -678,8 +678,7 @@ static void pmcraid_reset_alert(struct pmcraid_cmd *cmd)
 		cmd->time_left = PMCRAID_RESET_TIMEOUT;
 		cmd->timer.data = (unsigned long)cmd;
 		cmd->timer.expires = jiffies + PMCRAID_CHECK_FOR_RESET_TIMEOUT;
-		cmd->timer.function =
-			(void (*)(unsigned long))pmcraid_reset_alert_done;
+		cmd->timer.function = pmcraid_reset_alert_done;
 		add_timer(&cmd->timer);
 
 		iowrite32(DOORBELL_IOA_RESET_ALERT,
@@ -704,8 +703,9 @@ static void pmcraid_reset_alert(struct pmcraid_cmd *cmd)
  * Return value:
  *   None
  */
-static void pmcraid_timeout_handler(struct pmcraid_cmd *cmd)
+static void pmcraid_timeout_handler(unsigned long _cmd)
 {
+	struct pmcraid_cmd *cmd = (struct pmcraid_cmd *)_cmd;
 	struct pmcraid_instance *pinstance = cmd->drv_inst;
 	unsigned long lock_flags;
 
@@ -920,7 +920,7 @@ static void pmcraid_send_cmd(
 	struct pmcraid_cmd *cmd,
 	void (*cmd_done) (struct pmcraid_cmd *),
 	unsigned long timeout,
-	void (*timeout_func) (struct pmcraid_cmd *)
+	void (*timeout_func) (unsigned long)
 )
 {
 	/* initialize done function */
@@ -930,7 +930,7 @@ static void pmcraid_send_cmd(
 		/* setup timeout handler */
 		cmd->timer.data = (unsigned long)cmd;
 		cmd->timer.expires = jiffies + timeout;
-		cmd->timer.function = (void (*)(unsigned long))timeout_func;
+		cmd->timer.function = timeout_func;
 		add_timer(&cmd->timer);
 	}
 
@@ -1968,7 +1968,7 @@ static void pmcraid_soft_reset(struct pmcraid_cmd *cmd)
 	cmd->timer.data = (unsigned long)cmd;
 	cmd->timer.expires = jiffies +
 			     msecs_to_jiffies(PMCRAID_TRANSOP_TIMEOUT);
-	cmd->timer.function = (void (*)(unsigned long))pmcraid_timeout_handler;
+	cmd->timer.function = pmcraid_timeout_handler;
 
 	if (!timer_pending(&cmd->timer))
 		add_timer(&cmd->timer);
@@ -2641,9 +2641,9 @@ static int pmcraid_error_handler(struct pmcraid_cmd *cmd)
 
 	/* If this was a SCSI read/write command keep count of errors */
 	if (SCSI_CMD_TYPE(scsi_cmd->cmnd[0]) == SCSI_READ_CMD)
-		atomic_inc(&res->read_failures);
+		atomic_inc_unchecked(&res->read_failures);
 	else if (SCSI_CMD_TYPE(scsi_cmd->cmnd[0]) == SCSI_WRITE_CMD)
-		atomic_inc(&res->write_failures);
+		atomic_inc_unchecked(&res->write_failures);
 
 	if (!RES_IS_GSCSI(res->cfg_entry) &&
 		masked_ioasc != PMCRAID_IOASC_HW_DEVICE_BUS_STATUS_ERROR) {
@@ -3469,7 +3469,7 @@ static int pmcraid_queuecommand_lck(
 	 * block of scsi_cmd which is re-used (e.g. cancel/abort), which uses
 	 * hrrq_id assigned here in queuecommand
 	 */
-	ioarcb->hrrq_id = atomic_add_return(1, &(pinstance->last_message_id)) %
+	ioarcb->hrrq_id = atomic_add_return_unchecked(1, &(pinstance->last_message_id)) %
 			  pinstance->num_hrrq;
 	cmd->cmd_done = pmcraid_io_done;
 
@@ -3783,7 +3783,7 @@ static long pmcraid_ioctl_passthrough(
 	 * block of scsi_cmd which is re-used (e.g. cancel/abort), which uses
 	 * hrrq_id assigned here in queuecommand
 	 */
-	ioarcb->hrrq_id = atomic_add_return(1, &(pinstance->last_message_id)) %
+	ioarcb->hrrq_id = atomic_add_return_unchecked(1, &(pinstance->last_message_id)) %
 			  pinstance->num_hrrq;
 
 	if (request_size) {
@@ -4420,7 +4420,7 @@ static void pmcraid_worker_function(struct work_struct *workp)
 
 	pinstance = container_of(workp, struct pmcraid_instance, worker_q);
 	/* add resources only after host is added into system */
-	if (!atomic_read(&pinstance->expose_resources))
+	if (!atomic_read_unchecked(&pinstance->expose_resources))
 		return;
 
 	fw_version = be16_to_cpu(pinstance->inq_data->fw_version);
@@ -5237,8 +5237,8 @@ static int pmcraid_init_instance(struct pci_dev *pdev, struct Scsi_Host *host,
 	init_waitqueue_head(&pinstance->reset_wait_q);
 
 	atomic_set(&pinstance->outstanding_cmds, 0);
-	atomic_set(&pinstance->last_message_id, 0);
-	atomic_set(&pinstance->expose_resources, 0);
+	atomic_set_unchecked(&pinstance->last_message_id, 0);
+	atomic_set_unchecked(&pinstance->expose_resources, 0);
 
 	INIT_LIST_HEAD(&pinstance->free_res_q);
 	INIT_LIST_HEAD(&pinstance->used_res_q);
@@ -5949,7 +5949,7 @@ static int pmcraid_probe(struct pci_dev *pdev,
 	/* Schedule worker thread to handle CCN and take care of adding and
 	 * removing devices to OS
 	 */
-	atomic_set(&pinstance->expose_resources, 1);
+	atomic_set_unchecked(&pinstance->expose_resources, 1);
 	schedule_work(&pinstance->worker_q);
 	return rc;
 
diff --git a/drivers/scsi/pmcraid.h b/drivers/scsi/pmcraid.h
index e1d150f3f..6c6df444a 100644
--- a/drivers/scsi/pmcraid.h
+++ b/drivers/scsi/pmcraid.h
@@ -748,7 +748,7 @@ struct pmcraid_instance {
 	struct pmcraid_isr_param hrrq_vector[PMCRAID_NUM_MSIX_VECTORS];
 
 	/* Message id as filled in last fired IOARCB, used to identify HRRQ */
-	atomic_t last_message_id;
+	atomic_unchecked_t last_message_id;
 
 	/* configuration table */
 	struct pmcraid_config_table *cfg_table;
@@ -777,7 +777,7 @@ struct pmcraid_instance {
 	atomic_t outstanding_cmds;
 
 	/* should add/delete resources to mid-layer now ?*/
-	atomic_t expose_resources;
+	atomic_unchecked_t expose_resources;
 
 
 
@@ -813,8 +813,8 @@ struct pmcraid_resource_entry {
 		struct pmcraid_config_table_entry_ext cfg_entry_ext;
 	};
 	struct scsi_device *scsi_dev;	/* Link scsi_device structure */
-	atomic_t read_failures;		/* count of failed READ commands */
-	atomic_t write_failures;	/* count of failed WRITE commands */
+	atomic_unchecked_t read_failures;	/* count of failed READ commands */
+	atomic_unchecked_t write_failures;	/* count of failed WRITE commands */
 
 	/* To indicate add/delete/modify during CCN */
 	u8 change_detected;
diff --git a/drivers/scsi/qla2xxx/qla_attr.c b/drivers/scsi/qla2xxx/qla_attr.c
index fe7469c90..91e0c0b45 100644
--- a/drivers/scsi/qla2xxx/qla_attr.c
+++ b/drivers/scsi/qla2xxx/qla_attr.c
@@ -2186,7 +2186,7 @@ qla24xx_vport_disable(struct fc_vport *fc_vport, bool disable)
 	return 0;
 }
 
-struct fc_function_template qla2xxx_transport_functions = {
+fc_function_template_no_const qla2xxx_transport_functions = {
 
 	.show_host_node_name = 1,
 	.show_host_port_name = 1,
@@ -2234,7 +2234,7 @@ struct fc_function_template qla2xxx_transport_functions = {
 	.bsg_timeout = qla24xx_bsg_timeout,
 };
 
-struct fc_function_template qla2xxx_transport_vport_functions = {
+fc_function_template_no_const qla2xxx_transport_vport_functions = {
 
 	.show_host_node_name = 1,
 	.show_host_port_name = 1,
diff --git a/drivers/scsi/qla2xxx/qla_gbl.h b/drivers/scsi/qla2xxx/qla_gbl.h
index 6ca00813c..fbb9efd40 100644
--- a/drivers/scsi/qla2xxx/qla_gbl.h
+++ b/drivers/scsi/qla2xxx/qla_gbl.h
@@ -178,8 +178,8 @@ extern void qla2x00_disable_board_on_pci_error(struct work_struct *);
  */
 extern struct scsi_host_template qla2xxx_driver_template;
 extern struct scsi_transport_template *qla2xxx_transport_vport_template;
-extern void qla2x00_timer(scsi_qla_host_t *);
-extern void qla2x00_start_timer(scsi_qla_host_t *, void *, unsigned long);
+extern void qla2x00_timer(unsigned long);
+extern void qla2x00_start_timer(scsi_qla_host_t *, void (*)(unsigned long), unsigned long);
 extern void qla24xx_deallocate_vp_id(scsi_qla_host_t *);
 extern int qla24xx_disable_vp (scsi_qla_host_t *);
 extern int qla24xx_enable_vp (scsi_qla_host_t *);
@@ -583,8 +583,8 @@ extern void qla2x00_get_sym_node_name(scsi_qla_host_t *, uint8_t *, size_t);
 struct device_attribute;
 extern struct device_attribute *qla2x00_host_attrs[];
 struct fc_function_template;
-extern struct fc_function_template qla2xxx_transport_functions;
-extern struct fc_function_template qla2xxx_transport_vport_functions;
+extern fc_function_template_no_const qla2xxx_transport_functions;
+extern fc_function_template_no_const qla2xxx_transport_vport_functions;
 extern void qla2x00_alloc_sysfs_attr(scsi_qla_host_t *);
 extern void qla2x00_free_sysfs_attr(scsi_qla_host_t *, bool);
 extern void qla2x00_init_host_attr(scsi_qla_host_t *);
diff --git a/drivers/scsi/qla2xxx/qla_os.c b/drivers/scsi/qla2xxx/qla_os.c
index c172be184..1a52e4c29 100644
--- a/drivers/scsi/qla2xxx/qla_os.c
+++ b/drivers/scsi/qla2xxx/qla_os.c
@@ -301,12 +301,12 @@ struct scsi_transport_template *qla2xxx_transport_vport_template = NULL;
  */
 
 __inline__ void
-qla2x00_start_timer(scsi_qla_host_t *vha, void *func, unsigned long interval)
+qla2x00_start_timer(scsi_qla_host_t *vha, void (*func)(unsigned long), unsigned long interval)
 {
 	init_timer(&vha->timer);
 	vha->timer.expires = jiffies + interval * HZ;
 	vha->timer.data = (unsigned long)vha;
-	vha->timer.function = (void (*)(unsigned long))func;
+	vha->timer.function = func;
 	add_timer(&vha->timer);
 	vha->timer_active = 1;
 }
@@ -1510,8 +1510,10 @@ qla2x00_config_dma_addressing(struct qla_hw_data *ha)
 		    !pci_set_consistent_dma_mask(ha->pdev, DMA_BIT_MASK(64))) {
 			/* Ok, a 64bit DMA mask is applicable. */
 			ha->flags.enable_64bit_addressing = 1;
-			ha->isp_ops->calc_req_entries = qla2x00_calc_iocbs_64;
-			ha->isp_ops->build_iocbs = qla2x00_build_scsi_iocbs_64;
+			pax_open_kernel();
+			const_cast(ha->isp_ops->calc_req_entries) = qla2x00_calc_iocbs_64;
+			const_cast(ha->isp_ops->build_iocbs) = qla2x00_build_scsi_iocbs_64;
+			pax_close_kernel();
 			return;
 		}
 	}
@@ -5383,8 +5385,9 @@ qla2x00_rst_aen(scsi_qla_host_t *vha)
 * Context: Interrupt
 ***************************************************************************/
 void
-qla2x00_timer(scsi_qla_host_t *vha)
+qla2x00_timer(unsigned long _vha)
 {
+	scsi_qla_host_t *vha = (scsi_qla_host_t *)_vha;
 	unsigned long	cpu_flags = 0;
 	int		start_dpc = 0;
 	int		index;
@@ -5646,7 +5649,7 @@ qla2x00_release_firmware(void)
 }
 
 static pci_ers_result_t
-qla2xxx_pci_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+qla2xxx_pci_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	scsi_qla_host_t *vha = pci_get_drvdata(pdev);
 	struct qla_hw_data *ha = vha->hw;
diff --git a/drivers/scsi/qla2xxx/qla_target.c b/drivers/scsi/qla2xxx/qla_target.c
index bff9689f5..8caa18774 100644
--- a/drivers/scsi/qla2xxx/qla_target.c
+++ b/drivers/scsi/qla2xxx/qla_target.c
@@ -678,7 +678,7 @@ static int qlt_reset(struct scsi_qla_host *vha, void *iocb, int mcmd)
 	loop_id = le16_to_cpu(n->u.isp24.nport_handle);
 	if (loop_id == 0xFFFF) {
 		/* Global event */
-		atomic_inc(&vha->vha_tgt.qla_tgt->tgt_global_resets_count);
+		atomic_inc_unchecked(&vha->vha_tgt.qla_tgt->tgt_global_resets_count);
 		spin_lock_irqsave(&ha->tgt.sess_lock, flags);
 		qlt_clear_tgt_db(vha->vha_tgt.qla_tgt);
 		spin_unlock_irqrestore(&ha->tgt.sess_lock, flags);
@@ -845,8 +845,9 @@ static void qlt_undelete_sess(struct qla_tgt_sess *sess)
 	sess->deleted = 0;
 }
 
-static void qlt_del_sess_work_fn(struct delayed_work *work)
+static void qlt_del_sess_work_fn(struct work_struct *_work)
 {
+	struct delayed_work *work = container_of(_work, struct delayed_work, work);
 	struct qla_tgt *tgt = container_of(work, struct qla_tgt,
 	    sess_del_work);
 	struct scsi_qla_host *vha = tgt->vha;
@@ -5825,7 +5826,7 @@ static struct qla_tgt_sess *qlt_make_local_sess(struct scsi_qla_host *vha,
 
 retry:
 	global_resets =
-	    atomic_read(&vha->vha_tgt.qla_tgt->tgt_global_resets_count);
+	    atomic_read_unchecked(&vha->vha_tgt.qla_tgt->tgt_global_resets_count);
 
 	rc = qla24xx_get_loop_id(vha, s_id, &loop_id);
 	if (rc != 0) {
@@ -5864,12 +5865,12 @@ retry:
 	}
 
 	if (global_resets !=
-	    atomic_read(&vha->vha_tgt.qla_tgt->tgt_global_resets_count)) {
+	    atomic_read_unchecked(&vha->vha_tgt.qla_tgt->tgt_global_resets_count)) {
 		ql_dbg(ql_dbg_tgt_mgt, vha, 0xf043,
 		    "qla_target(%d): global reset during session discovery "
 		    "(counter was %d, new %d), retrying", vha->vp_idx,
 		    global_resets,
-		    atomic_read(&vha->vha_tgt.
+		    atomic_read_unchecked(&vha->vha_tgt.
 			qla_tgt->tgt_global_resets_count));
 		goto retry;
 	}
@@ -6080,8 +6081,7 @@ int qlt_add_target(struct qla_hw_data *ha, struct scsi_qla_host *base_vha)
 	init_waitqueue_head(&tgt->waitQ);
 	INIT_LIST_HEAD(&tgt->sess_list);
 	INIT_LIST_HEAD(&tgt->del_sess_list);
-	INIT_DELAYED_WORK(&tgt->sess_del_work,
-		(void (*)(struct work_struct *))qlt_del_sess_work_fn);
+	INIT_DELAYED_WORK(&tgt->sess_del_work, qlt_del_sess_work_fn);
 	spin_lock_init(&tgt->sess_work_lock);
 	INIT_WORK(&tgt->sess_work, qlt_sess_work_fn);
 	INIT_LIST_HEAD(&tgt->sess_works_list);
@@ -6089,7 +6089,7 @@ int qlt_add_target(struct qla_hw_data *ha, struct scsi_qla_host *base_vha)
 	INIT_LIST_HEAD(&tgt->srr_ctio_list);
 	INIT_LIST_HEAD(&tgt->srr_imm_list);
 	INIT_WORK(&tgt->srr_work, qlt_handle_srr_work);
-	atomic_set(&tgt->tgt_global_resets_count, 0);
+	atomic_set_unchecked(&tgt->tgt_global_resets_count, 0);
 
 	base_vha->vha_tgt.qla_tgt = tgt;
 
diff --git a/drivers/scsi/qla2xxx/qla_target.h b/drivers/scsi/qla2xxx/qla_target.h
index f26c5f60e..e88e9c5a4 100644
--- a/drivers/scsi/qla2xxx/qla_target.h
+++ b/drivers/scsi/qla2xxx/qla_target.h
@@ -876,7 +876,7 @@ struct qla_tgt {
 	struct list_head srr_imm_list;
 	struct work_struct srr_work;
 
-	atomic_t tgt_global_resets_count;
+	atomic_unchecked_t tgt_global_resets_count;
 
 	struct list_head tgt_list_entry;
 };
diff --git a/drivers/scsi/qla4xxx/ql4_def.h b/drivers/scsi/qla4xxx/ql4_def.h
index a7cfc270b..151f483fc 100644
--- a/drivers/scsi/qla4xxx/ql4_def.h
+++ b/drivers/scsi/qla4xxx/ql4_def.h
@@ -306,7 +306,7 @@ struct ddb_entry {
 					   * (4000 only) */
 	atomic_t relogin_timer;		  /* Max Time to wait for
 					   * relogin to complete */
-	atomic_t relogin_retry_count;	  /* Num of times relogin has been
+	atomic_unchecked_t relogin_retry_count;	  /* Num of times relogin has been
 					   * retried */
 	uint32_t default_time2wait;	  /* Default Min time between
 					   * relogins (+aens) */
diff --git a/drivers/scsi/qla4xxx/ql4_os.c b/drivers/scsi/qla4xxx/ql4_os.c
index 01c3610a6..f287da931 100644
--- a/drivers/scsi/qla4xxx/ql4_os.c
+++ b/drivers/scsi/qla4xxx/ql4_os.c
@@ -3956,7 +3956,7 @@ exit_session_conn_param:
  * Timer routines
  */
 
-static void qla4xxx_start_timer(struct scsi_qla_host *ha, void *func,
+static void qla4xxx_start_timer(struct scsi_qla_host *ha, void (*func)(unsigned long),
 				unsigned long interval)
 {
 	DEBUG(printk("scsi: %s: Starting timer thread for adapter %d\n",
@@ -3964,7 +3964,7 @@ static void qla4xxx_start_timer(struct scsi_qla_host *ha, void *func,
 	init_timer(&ha->timer);
 	ha->timer.expires = jiffies + interval * HZ;
 	ha->timer.data = (unsigned long)ha;
-	ha->timer.function = (void (*)(unsigned long))func;
+	ha->timer.function = func;
 	add_timer(&ha->timer);
 	ha->timer_active = 1;
 }
@@ -4490,12 +4490,12 @@ static void qla4xxx_check_relogin_flash_ddb(struct iscsi_cls_session *cls_sess)
 		 */
 		if (!iscsi_is_session_online(cls_sess)) {
 			/* Reset retry relogin timer */
-			atomic_inc(&ddb_entry->relogin_retry_count);
+			atomic_inc_unchecked(&ddb_entry->relogin_retry_count);
 			DEBUG2(ql4_printk(KERN_INFO, ha,
 				"%s: index[%d] relogin timed out-retrying"
 				" relogin (%d), retry (%d)\n", __func__,
 				ddb_entry->fw_ddb_index,
-				atomic_read(&ddb_entry->relogin_retry_count),
+				atomic_read_unchecked(&ddb_entry->relogin_retry_count),
 				ddb_entry->default_time2wait + 4));
 			set_bit(DPC_RELOGIN_DEVICE, &ha->dpc_flags);
 			atomic_set(&ddb_entry->retry_relogin_timer,
@@ -4508,8 +4508,9 @@ static void qla4xxx_check_relogin_flash_ddb(struct iscsi_cls_session *cls_sess)
  * qla4xxx_timer - checks every second for work to do.
  * @ha: Pointer to host adapter structure.
  **/
-static void qla4xxx_timer(struct scsi_qla_host *ha)
+static void qla4xxx_timer(unsigned long _ha)
 {
+	struct scsi_qla_host *ha = (struct scsi_qla_host *)_ha;
 	int start_dpc = 0;
 	uint16_t w;
 
@@ -6603,7 +6604,7 @@ static void qla4xxx_setup_flash_ddb_entry(struct scsi_qla_host *ha,
 
 	atomic_set(&ddb_entry->retry_relogin_timer, INVALID_ENTRY);
 	atomic_set(&ddb_entry->relogin_timer, 0);
-	atomic_set(&ddb_entry->relogin_retry_count, 0);
+	atomic_set_unchecked(&ddb_entry->relogin_retry_count, 0);
 	def_timeout = le16_to_cpu(ddb_entry->fw_ddb_entry.def_timeout);
 	ddb_entry->default_relogin_timeout =
 		(def_timeout > LOGIN_TOV) && (def_timeout < LOGIN_TOV * 10) ?
@@ -9557,7 +9558,7 @@ exit_host_reset:
  * RECOVERED - driver's pci_resume()
  */
 static pci_ers_result_t
-qla4xxx_pci_error_detected(struct pci_dev *pdev, pci_channel_state_t state)
+qla4xxx_pci_error_detected(struct pci_dev *pdev, enum pci_channel_state state)
 {
 	struct scsi_qla_host *ha = pci_get_drvdata(pdev);
 
diff --git a/drivers/scsi/scsi.c b/drivers/scsi/scsi.c
index 1deb6adc4..3057db539 100644
--- a/drivers/scsi/scsi.c
+++ b/drivers/scsi/scsi.c
@@ -591,7 +591,7 @@ void scsi_finish_command(struct scsi_cmnd *cmd)
 
 	good_bytes = scsi_bufflen(cmd);
         if (cmd->request->cmd_type != REQ_TYPE_BLOCK_PC) {
-		int old_good_bytes = good_bytes;
+		unsigned int old_good_bytes = good_bytes;
 		drv = scsi_cmd_to_driver(cmd);
 		if (drv->done)
 			good_bytes = drv->done(cmd);
diff --git a/drivers/scsi/scsi_debug.c b/drivers/scsi/scsi_debug.c
index 05e892a23..3fffafa07 100644
--- a/drivers/scsi/scsi_debug.c
+++ b/drivers/scsi/scsi_debug.c
@@ -289,10 +289,10 @@ struct sdebug_queue {
 	atomic_t blocked;	/* to temporarily stop more being queued */
 };
 
-static atomic_t sdebug_cmnd_count;   /* number of incoming commands */
-static atomic_t sdebug_completions;  /* count of deferred completions */
-static atomic_t sdebug_miss_cpus;    /* submission + completion cpus differ */
-static atomic_t sdebug_a_tsf;	     /* 'almost task set full' counter */
+static atomic_unchecked_t sdebug_cmnd_count;   /* number of incoming commands */
+static atomic_unchecked_t sdebug_completions;  /* count of deferred completions */
+static atomic_unchecked_t sdebug_miss_cpus;    /* submission + completion cpus differ */
+static atomic_unchecked_t sdebug_a_tsf;	     /* 'almost task set full' counter */
 
 struct opcode_info_t {
 	u8 num_attached;	/* 0 if this is it (i.e. a leaf); use 0xff */
@@ -3492,9 +3492,9 @@ static void sdebug_q_cmd_complete(struct sdebug_defer *sd_dp)
 	qc_idx = sd_dp->qc_idx;
 	sqp = sdebug_q_arr + sd_dp->sqa_idx;
 	if (sdebug_statistics) {
-		atomic_inc(&sdebug_completions);
+		atomic_inc_unchecked(&sdebug_completions);
 		if (raw_smp_processor_id() != sd_dp->issuing_cpu)
-			atomic_inc(&sdebug_miss_cpus);
+			atomic_inc_unchecked(&sdebug_miss_cpus);
 	}
 	if (unlikely((qc_idx < 0) || (qc_idx >= SDEBUG_CANQUEUE))) {
 		pr_err("wild qc_idx=%d\n", qc_idx);
@@ -3966,23 +3966,23 @@ static void tweak_cmnd_count(void)
 	if (modulo < 2)
 		return;
 	block_unblock_all_queues(true);
-	count = atomic_read(&sdebug_cmnd_count);
-	atomic_set(&sdebug_cmnd_count, (count / modulo) * modulo);
+	count = atomic_read_unchecked(&sdebug_cmnd_count);
+	atomic_set_unchecked(&sdebug_cmnd_count, (count / modulo) * modulo);
 	block_unblock_all_queues(false);
 }
 
 static void clear_queue_stats(void)
 {
-	atomic_set(&sdebug_cmnd_count, 0);
-	atomic_set(&sdebug_completions, 0);
-	atomic_set(&sdebug_miss_cpus, 0);
-	atomic_set(&sdebug_a_tsf, 0);
+	atomic_set_unchecked(&sdebug_cmnd_count, 0);
+	atomic_set_unchecked(&sdebug_completions, 0);
+	atomic_set_unchecked(&sdebug_miss_cpus, 0);
+	atomic_set_unchecked(&sdebug_a_tsf, 0);
 }
 
 static void setup_inject(struct sdebug_queue *sqp,
 			 struct sdebug_queued_cmd *sqcp)
 {
-	if ((atomic_read(&sdebug_cmnd_count) % abs(sdebug_every_nth)) > 0)
+	if ((atomic_read_unchecked(&sdebug_cmnd_count) % abs(sdebug_every_nth)) > 0)
 		return;
 	sqcp->inj_recovered = !!(SDEBUG_OPT_RECOVERED_ERR & sdebug_opts);
 	sqcp->inj_transport = !!(SDEBUG_OPT_TRANSPORT_ERR & sdebug_opts);
@@ -4039,9 +4039,9 @@ static int schedule_resp(struct scsi_cmnd *cmnd, struct sdebug_dev_info *devip,
 			    (SDEBUG_OPT_RARE_TSF & sdebug_opts) &&
 			    (scsi_result == 0))) {
 		if ((num_in_q == (qdepth - 1)) &&
-		    (atomic_inc_return(&sdebug_a_tsf) >=
+		    (atomic_inc_return_unchecked(&sdebug_a_tsf) >=
 		     abs(sdebug_every_nth))) {
-			atomic_set(&sdebug_a_tsf, 0);
+			atomic_set_unchecked(&sdebug_a_tsf, 0);
 			inject = 1;
 			scsi_result = device_qfull_result;
 		}
@@ -4296,10 +4296,10 @@ static int scsi_debug_show_info(struct seq_file *m, struct Scsi_Host *host)
 		   TICK_NSEC / 1000, "statistics", sdebug_statistics,
 		   sdebug_mq_active);
 	seq_printf(m, "cmnd_count=%d, completions=%d, %s=%d, a_tsf=%d\n",
-		   atomic_read(&sdebug_cmnd_count),
-		   atomic_read(&sdebug_completions),
-		   "miss_cpus", atomic_read(&sdebug_miss_cpus),
-		   atomic_read(&sdebug_a_tsf));
+		   atomic_read_unchecked(&sdebug_cmnd_count),
+		   atomic_read_unchecked(&sdebug_completions),
+		   "miss_cpus", atomic_read_unchecked(&sdebug_miss_cpus),
+		   atomic_read_unchecked(&sdebug_a_tsf));
 
 	seq_printf(m, "submit_queues=%d\n", submit_queues);
 	for (j = 0, sqp = sdebug_q_arr; j < submit_queues; ++j, ++sqp) {
@@ -5253,7 +5253,7 @@ static int sdebug_change_qdepth(struct scsi_device *sdev, int qdepth)
 
 static bool fake_timeout(struct scsi_cmnd *scp)
 {
-	if (0 == (atomic_read(&sdebug_cmnd_count) % abs(sdebug_every_nth))) {
+	if (0 == (atomic_read_unchecked(&sdebug_cmnd_count) % abs(sdebug_every_nth))) {
 		if (sdebug_every_nth < -1)
 			sdebug_every_nth = -1;
 		if (SDEBUG_OPT_TIMEOUT & sdebug_opts)
@@ -5284,7 +5284,7 @@ static int scsi_debug_queuecommand(struct Scsi_Host *shost,
 
 	scsi_set_resid(scp, 0);
 	if (sdebug_statistics)
-		atomic_inc(&sdebug_cmnd_count);
+		atomic_inc_unchecked(&sdebug_cmnd_count);
 	if (unlikely(sdebug_verbose &&
 		     !(SDEBUG_OPT_NO_CDB_NOISE & sdebug_opts))) {
 		char b[120];
diff --git a/drivers/scsi/scsi_lib.c b/drivers/scsi/scsi_lib.c
index c71344aeb..94f1f9edf 100644
--- a/drivers/scsi/scsi_lib.c
+++ b/drivers/scsi/scsi_lib.c
@@ -1513,7 +1513,7 @@ static void scsi_kill_request(struct request *req, struct request_queue *q)
 	shost = sdev->host;
 	scsi_init_cmd_errh(cmd);
 	cmd->result = DID_NO_CONNECT << 16;
-	atomic_inc(&cmd->device->iorequest_cnt);
+	atomic_inc_unchecked(&cmd->device->iorequest_cnt);
 
 	/*
 	 * SCSI request completion path will do scsi_device_unbusy(),
@@ -1536,9 +1536,9 @@ static void scsi_softirq_done(struct request *rq)
 
 	INIT_LIST_HEAD(&cmd->eh_entry);
 
-	atomic_inc(&cmd->device->iodone_cnt);
+	atomic_inc_unchecked(&cmd->device->iodone_cnt);
 	if (cmd->result)
-		atomic_inc(&cmd->device->ioerr_cnt);
+		atomic_inc_unchecked(&cmd->device->ioerr_cnt);
 
 	disposition = scsi_decide_disposition(cmd);
 	if (disposition != SUCCESS &&
@@ -1579,7 +1579,7 @@ static int scsi_dispatch_cmd(struct scsi_cmnd *cmd)
 	struct Scsi_Host *host = cmd->device->host;
 	int rtn = 0;
 
-	atomic_inc(&cmd->device->iorequest_cnt);
+	atomic_inc_unchecked(&cmd->device->iorequest_cnt);
 
 	/* check if the device is still usable */
 	if (unlikely(cmd->device->sdev_state == SDEV_DEL)) {
diff --git a/drivers/scsi/scsi_sysfs.c b/drivers/scsi/scsi_sysfs.c
index 82dfe07b1..2b3eeaec6 100644
--- a/drivers/scsi/scsi_sysfs.c
+++ b/drivers/scsi/scsi_sysfs.c
@@ -848,7 +848,7 @@ show_iostat_##field(struct device *dev, struct device_attribute *attr,	\
 		    char *buf)						\
 {									\
 	struct scsi_device *sdev = to_scsi_device(dev);			\
-	unsigned long long count = atomic_read(&sdev->field);		\
+	unsigned long long count = atomic_read_unchecked(&sdev->field);	\
 	return snprintf(buf, 20, "0x%llx\n", count);			\
 }									\
 static DEVICE_ATTR(field, S_IRUGO, show_iostat_##field, NULL)
diff --git a/drivers/scsi/scsi_transport_fc.c b/drivers/scsi/scsi_transport_fc.c
index 0f3a38695..1616cee48 100644
--- a/drivers/scsi/scsi_transport_fc.c
+++ b/drivers/scsi/scsi_transport_fc.c
@@ -502,7 +502,7 @@ static DECLARE_TRANSPORT_CLASS(fc_vport_class,
  * Netlink Infrastructure
  */
 
-static atomic_t fc_event_seq;
+static atomic_unchecked_t fc_event_seq;
 
 /**
  * fc_get_event_number - Obtain the next sequential FC event number
@@ -515,7 +515,7 @@ static atomic_t fc_event_seq;
 u32
 fc_get_event_number(void)
 {
-	return atomic_add_return(1, &fc_event_seq);
+	return atomic_add_return_unchecked(1, &fc_event_seq);
 }
 EXPORT_SYMBOL(fc_get_event_number);
 
@@ -659,7 +659,7 @@ static __init int fc_transport_init(void)
 {
 	int error;
 
-	atomic_set(&fc_event_seq, 0);
+	atomic_set_unchecked(&fc_event_seq, 0);
 
 	error = transport_class_register(&fc_host_class);
 	if (error)
@@ -849,7 +849,7 @@ static int fc_str_to_dev_loss(const char *buf, unsigned long *val)
 	char *cp;
 
 	*val = simple_strtoul(buf, &cp, 0);
-	if ((*cp && (*cp != '\n')) || (*val < 0))
+	if (*cp && (*cp != '\n'))
 		return -EINVAL;
 	/*
 	 * Check for overflow; dev_loss_tmo is u32
diff --git a/drivers/scsi/scsi_transport_iscsi.c b/drivers/scsi/scsi_transport_iscsi.c
index 42bca619f..ceceb5d22 100644
--- a/drivers/scsi/scsi_transport_iscsi.c
+++ b/drivers/scsi/scsi_transport_iscsi.c
@@ -79,7 +79,7 @@ struct iscsi_internal {
 	struct transport_container session_cont;
 };
 
-static atomic_t iscsi_session_nr; /* sysfs session id for next new session */
+static atomic_unchecked_t iscsi_session_nr; /* sysfs session id for next new session */
 static struct workqueue_struct *iscsi_eh_timer_workq;
 
 static DEFINE_IDA(iscsi_sess_ida);
@@ -2073,7 +2073,7 @@ int iscsi_add_session(struct iscsi_cls_session *session, unsigned int target_id)
 	int id = 0;
 	int err;
 
-	session->sid = atomic_add_return(1, &iscsi_session_nr);
+	session->sid = atomic_add_return_unchecked(1, &iscsi_session_nr);
 
 	if (target_id == ISCSI_MAX_TARGET) {
 		id = ida_simple_get(&iscsi_sess_ida, 0, 0, GFP_KERNEL);
@@ -4523,7 +4523,7 @@ static __init int iscsi_transport_init(void)
 	printk(KERN_INFO "Loading iSCSI transport class v%s.\n",
 		ISCSI_TRANSPORT_VERSION);
 
-	atomic_set(&iscsi_session_nr, 0);
+	atomic_set_unchecked(&iscsi_session_nr, 0);
 
 	err = class_register(&iscsi_transport_class);
 	if (err)
diff --git a/drivers/scsi/scsi_transport_spi.c b/drivers/scsi/scsi_transport_spi.c
index 319868f3f..a00cda54c 100644
--- a/drivers/scsi/scsi_transport_spi.c
+++ b/drivers/scsi/scsi_transport_spi.c
@@ -758,7 +758,7 @@ spi_dv_device_compare_inquiry(struct scsi_device *sdev, u8 *buffer,
 static enum spi_compare_returns
 spi_dv_retrain(struct scsi_device *sdev, u8 *buffer, u8 *ptr,
 	       enum spi_compare_returns 
-	       (*compare_fn)(struct scsi_device *, u8 *, u8 *, int))
+	       (*compare_fn)(struct scsi_device *, u8 *, u8 *, const int))
 {
 	struct spi_internal *i = to_spi_internal(sdev->host->transportt);
 	struct scsi_target *starget = sdev->sdev_target;
diff --git a/drivers/scsi/scsi_transport_srp.c b/drivers/scsi/scsi_transport_srp.c
index e3cd3ece4..97ab64368 100644
--- a/drivers/scsi/scsi_transport_srp.c
+++ b/drivers/scsi/scsi_transport_srp.c
@@ -35,7 +35,7 @@
 #include "scsi_priv.h"
 
 struct srp_host_attrs {
-	atomic_t next_port_id;
+	atomic_unchecked_t next_port_id;
 };
 #define to_srp_host_attrs(host)	((struct srp_host_attrs *)(host)->shost_data)
 
@@ -105,7 +105,7 @@ static int srp_host_setup(struct transport_container *tc, struct device *dev,
 	struct Scsi_Host *shost = dev_to_shost(dev);
 	struct srp_host_attrs *srp_host = to_srp_host_attrs(shost);
 
-	atomic_set(&srp_host->next_port_id, 0);
+	atomic_set_unchecked(&srp_host->next_port_id, 0);
 	return 0;
 }
 
@@ -226,7 +226,7 @@ static ssize_t show_reconnect_delay(struct device *dev,
 
 static ssize_t store_reconnect_delay(struct device *dev,
 				     struct device_attribute *attr,
-				     const char *buf, const size_t count)
+				     const char *buf, size_t count)
 {
 	struct srp_rport *rport = transport_class_to_srp_rport(dev);
 	int res, delay;
@@ -752,7 +752,7 @@ struct srp_rport *srp_rport_add(struct Scsi_Host *shost,
 			  rport_fast_io_fail_timedout);
 	INIT_DELAYED_WORK(&rport->dev_loss_work, rport_dev_loss_timedout);
 
-	id = atomic_inc_return(&to_srp_host_attrs(shost)->next_port_id);
+	id = atomic_inc_return_unchecked(&to_srp_host_attrs(shost)->next_port_id);
 	dev_set_name(&rport->dev, "port-%d:%d", shost->host_no, id);
 
 	transport_setup_device(&rport->dev);
diff --git a/drivers/scsi/sd.c b/drivers/scsi/sd.c
index d3e852ad5..5a04bedf4 100644
--- a/drivers/scsi/sd.c
+++ b/drivers/scsi/sd.c
@@ -112,7 +112,7 @@ static int sd_resume(struct device *);
 static void sd_rescan(struct device *);
 static int sd_init_command(struct scsi_cmnd *SCpnt);
 static void sd_uninit_command(struct scsi_cmnd *SCpnt);
-static int sd_done(struct scsi_cmnd *);
+static unsigned int sd_done(struct scsi_cmnd *);
 static int sd_eh_action(struct scsi_cmnd *, int);
 static void sd_read_capacity(struct scsi_disk *sdkp, unsigned char *buffer);
 static void scsi_disk_release(struct device *cdev);
@@ -1767,7 +1767,7 @@ static unsigned int sd_completed_bytes(struct scsi_cmnd *scmd)
  *
  *	Note: potentially run from within an ISR. Must not block.
  **/
-static int sd_done(struct scsi_cmnd *SCpnt)
+static unsigned int sd_done(struct scsi_cmnd *SCpnt)
 {
 	int result = SCpnt->result;
 	unsigned int good_bytes = result ? 0 : scsi_bufflen(SCpnt);
@@ -3080,7 +3080,7 @@ static int sd_probe(struct device *dev)
 	sdkp->disk = gd;
 	sdkp->index = index;
 	atomic_set(&sdkp->openers, 0);
-	atomic_set(&sdkp->device->ioerr_cnt, 0);
+	atomic_set_unchecked(&sdkp->device->ioerr_cnt, 0);
 
 	if (!sdp->request_queue->rq_timeout) {
 		if (sdp->type != TYPE_MOD)
diff --git a/drivers/scsi/sg.c b/drivers/scsi/sg.c
index a1c29b0af..4740ad32e 100644
--- a/drivers/scsi/sg.c
+++ b/drivers/scsi/sg.c
@@ -1093,7 +1093,7 @@ sg_ioctl(struct file *filp, unsigned int cmd_in, unsigned long arg)
 				       sdp->disk->disk_name,
 				       MKDEV(SCSI_GENERIC_MAJOR, sdp->index),
 				       NULL,
-				       (char *)arg);
+				       (char __user *)arg);
 	case BLKTRACESTART:
 		return blk_trace_startstop(sdp->device->request_queue, 1);
 	case BLKTRACESTOP:
diff --git a/drivers/scsi/sr.c b/drivers/scsi/sr.c
index ed179348d..108678b79 100644
--- a/drivers/scsi/sr.c
+++ b/drivers/scsi/sr.c
@@ -80,7 +80,7 @@ static DEFINE_MUTEX(sr_mutex);
 static int sr_probe(struct device *);
 static int sr_remove(struct device *);
 static int sr_init_command(struct scsi_cmnd *SCpnt);
-static int sr_done(struct scsi_cmnd *);
+static unsigned int sr_done(struct scsi_cmnd *);
 static int sr_runtime_suspend(struct device *dev);
 
 static struct dev_pm_ops sr_pm_ops = {
@@ -315,13 +315,13 @@ do_tur:
  * It will be notified on the end of a SCSI read / write, and will take one
  * of several actions based on success or failure.
  */
-static int sr_done(struct scsi_cmnd *SCpnt)
+static unsigned int sr_done(struct scsi_cmnd *SCpnt)
 {
 	int result = SCpnt->result;
-	int this_count = scsi_bufflen(SCpnt);
-	int good_bytes = (result == 0 ? this_count : 0);
-	int block_sectors = 0;
-	long error_sector;
+	unsigned int this_count = scsi_bufflen(SCpnt);
+	unsigned int good_bytes = (result == 0 ? this_count : 0);
+	unsigned int block_sectors = 0;
+	sector_t error_sector;
 	struct scsi_cd *cd = scsi_cd(SCpnt->request->rq_disk);
 
 #ifdef DEBUG
@@ -354,9 +354,12 @@ static int sr_done(struct scsi_cmnd *SCpnt)
 			if (cd->device->sector_size == 2048)
 				error_sector <<= 2;
 			error_sector &= ~(block_sectors - 1);
-			good_bytes = (error_sector -
-				      blk_rq_pos(SCpnt->request)) << 9;
-			if (good_bytes < 0 || good_bytes >= this_count)
+			if (error_sector >= blk_rq_pos(SCpnt->request)) {
+				good_bytes = (error_sector -
+					      blk_rq_pos(SCpnt->request)) << 9;
+				if (good_bytes >= this_count)
+					good_bytes = 0;
+			} else
 				good_bytes = 0;
 			/*
 			 * The SCSI specification allows for the value
diff --git a/drivers/soc/tegra/fuse/fuse-tegra.c b/drivers/soc/tegra/fuse/fuse-tegra.c
index de2c1bfe2..60b856356 100644
--- a/drivers/soc/tegra/fuse/fuse-tegra.c
+++ b/drivers/soc/tegra/fuse/fuse-tegra.c
@@ -72,7 +72,7 @@ static ssize_t fuse_read(struct file *fd, struct kobject *kobj,
 	return i;
 }
 
-static struct bin_attribute fuse_bin_attr = {
+static bin_attribute_no_const fuse_bin_attr = {
 	.attr = { .name = "fuse", .mode = S_IRUGO, },
 	.read = fuse_read,
 };
diff --git a/drivers/spi/spi.c b/drivers/spi/spi.c
index 935f1a511..3c4bf161a 100644
--- a/drivers/spi/spi.c
+++ b/drivers/spi/spi.c
@@ -2984,7 +2984,7 @@ int spi_bus_unlock(struct spi_master *master)
 EXPORT_SYMBOL_GPL(spi_bus_unlock);
 
 /* portable code must never pass more than 32 bytes */
-#define	SPI_BUFSIZ	max(32, SMP_CACHE_BYTES)
+#define	SPI_BUFSIZ	max(32UL, SMP_CACHE_BYTES)
 
 static u8	*buf;
 
diff --git a/drivers/staging/fbtft/fbtft-core.c b/drivers/staging/fbtft/fbtft-core.c
index 4c281df16..196093024 100644
--- a/drivers/staging/fbtft/fbtft-core.c
+++ b/drivers/staging/fbtft/fbtft-core.c
@@ -649,7 +649,7 @@ struct fb_info *fbtft_framebuffer_alloc(struct fbtft_display *display,
 {
 	struct fb_info *info;
 	struct fbtft_par *par;
-	struct fb_ops *fbops = NULL;
+	fb_ops_no_const *fbops = NULL;
 	struct fb_deferred_io *fbdefio = NULL;
 	u8 *vmem = NULL;
 	void *txbuf = NULL;
diff --git a/drivers/staging/fbtft/fbtft.h b/drivers/staging/fbtft/fbtft.h
index d3bc3943a..7fa336dc2 100644
--- a/drivers/staging/fbtft/fbtft.h
+++ b/drivers/staging/fbtft/fbtft.h
@@ -93,7 +93,7 @@ struct fbtft_ops {
 
 	int (*set_var)(struct fbtft_par *par);
 	int (*set_gamma)(struct fbtft_par *par, unsigned long *curves);
-};
+} __no_const;
 
 /**
  * struct fbtft_display - Describes the display properties
diff --git a/drivers/staging/gdm724x/gdm_lte.c b/drivers/staging/gdm724x/gdm_lte.c
index bb552193e..789b7580c 100644
--- a/drivers/staging/gdm724x/gdm_lte.c
+++ b/drivers/staging/gdm724x/gdm_lte.c
@@ -410,7 +410,7 @@ static s32 gdm_lte_tx_nic_type(struct net_device *dev, struct sk_buff *skb)
 	return nic_type;
 }
 
-static int gdm_lte_tx(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t gdm_lte_tx(struct sk_buff *skb, struct net_device *dev)
 {
 	struct nic *nic = netdev_priv(dev);
 	u32 nic_type;
diff --git a/drivers/staging/gdm724x/gdm_tty.c b/drivers/staging/gdm724x/gdm_tty.c
index eb7e2523c..b7bd5e55e 100644
--- a/drivers/staging/gdm724x/gdm_tty.c
+++ b/drivers/staging/gdm724x/gdm_tty.c
@@ -44,7 +44,7 @@
 #define gdm_tty_send_control(n, r, v, d, l) (\
 	n->tty_dev->send_control(n->tty_dev->priv_dev, r, v, d, l))
 
-#define GDM_TTY_READY(gdm) (gdm && gdm->tty_dev && gdm->port.count)
+#define GDM_TTY_READY(gdm) (gdm && gdm->tty_dev && atomic_read(&gdm->port.count))
 
 static struct tty_driver *gdm_driver[TTY_MAX_COUNT];
 static struct gdm *gdm_table[TTY_MAX_COUNT][GDM_TTY_MINOR];
diff --git a/drivers/staging/i4l/icn/icn.c b/drivers/staging/i4l/icn/icn.c
index 46d957c34..d590c95b6 100644
--- a/drivers/staging/i4l/icn/icn.c
+++ b/drivers/staging/i4l/icn/icn.c
@@ -1045,7 +1045,7 @@ icn_writecmd(const u_char *buf, int len, int user, icn_card *card)
 		if (count > len)
 			count = len;
 		if (user) {
-			if (copy_from_user(msg, buf, count))
+			if (count > sizeof msg || copy_from_user(msg, buf, count))
 				return -EFAULT;
 		} else
 			memcpy(msg, buf, count);
diff --git a/drivers/staging/iio/adc/ad7280a.c b/drivers/staging/iio/adc/ad7280a.c
index 2177f1dd2..f226336f1 100644
--- a/drivers/staging/iio/adc/ad7280a.c
+++ b/drivers/staging/iio/adc/ad7280a.c
@@ -547,8 +547,8 @@ static int ad7280_attr_init(struct ad7280_state *st)
 {
 	int dev, ch, cnt;
 
-	st->iio_attr = kcalloc(2, sizeof(*st->iio_attr) *
-			       (st->slave_num + 1) * AD7280A_CELLS_PER_DEV,
+	st->iio_attr = kcalloc(sizeof(*st->iio_attr) *
+			       (st->slave_num + 1) * AD7280A_CELLS_PER_DEV, 2,
 			       GFP_KERNEL);
 	if (!st->iio_attr)
 		return -ENOMEM;
diff --git a/drivers/staging/ks7010/ks_wlan_net.c b/drivers/staging/ks7010/ks_wlan_net.c
index 1e21eb1c4..d3f9dd7e1 100644
--- a/drivers/staging/ks7010/ks_wlan_net.c
+++ b/drivers/staging/ks7010/ks_wlan_net.c
@@ -181,9 +181,10 @@ int ks_wlan_setup_parameter(struct ks_wlan_private *priv,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get protocol name */
 static int ks_wlan_get_name(struct net_device *dev,
-			    struct iw_request_info *info, char *cwrq,
+			    struct iw_request_info *info, union iwreq_data *_cwrq,
 			    char *extra)
 {
+	char *cwrq = _cwrq->name;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -207,9 +208,10 @@ static int ks_wlan_get_name(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set frequency */
 static int ks_wlan_set_freq(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_freq *fwrq,
+			    struct iw_request_info *info, union iwreq_data *_fwrq,
 			    char *extra)
 {
+	struct iw_freq *fwrq = &_fwrq->freq;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int rc = -EINPROGRESS;	/* Call commit handler */
@@ -255,9 +257,10 @@ static int ks_wlan_set_freq(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get frequency */
 static int ks_wlan_get_freq(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_freq *fwrq,
+			    struct iw_request_info *info, union iwreq_data *_fwrq,
 			    char *extra)
 {
+	struct iw_freq *fwrq = &_fwrq->freq;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int f;
@@ -280,8 +283,9 @@ static int ks_wlan_get_freq(struct net_device *dev,
 /* Wireless Handler : set ESSID */
 static int ks_wlan_set_essid(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_point *dwrq, char *extra)
+			     union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->essid;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	size_t len;
@@ -340,8 +344,9 @@ static int ks_wlan_set_essid(struct net_device *dev,
 /* Wireless Handler : get ESSID */
 static int ks_wlan_get_essid(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_point *dwrq, char *extra)
+			     union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->essid;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -383,8 +388,9 @@ static int ks_wlan_get_essid(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set AP address */
 static int ks_wlan_set_wap(struct net_device *dev, struct iw_request_info *info,
-			   struct sockaddr *ap_addr, char *extra)
+			   union iwreq_data *_ap_addr, char *extra)
 {
+	struct sockaddr *ap_addr = &_ap_addr->ap_addr;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -421,8 +427,9 @@ static int ks_wlan_set_wap(struct net_device *dev, struct iw_request_info *info,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get AP address */
 static int ks_wlan_get_wap(struct net_device *dev, struct iw_request_info *info,
-			   struct sockaddr *awrq, char *extra)
+			   union iwreq_data *_awrq, char *extra)
 {
+	struct sockaddr *awrq = &_awrq->ap_addr;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -444,9 +451,10 @@ static int ks_wlan_get_wap(struct net_device *dev, struct iw_request_info *info,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set Nickname */
 static int ks_wlan_set_nick(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_point *dwrq,
+			    struct iw_request_info *info, union iwreq_data *_dwrq,
 			    char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -468,9 +476,10 @@ static int ks_wlan_set_nick(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get Nickname */
 static int ks_wlan_get_nick(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_point *dwrq,
+			    struct iw_request_info *info, union iwreq_data *_dwrq,
 			    char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -488,9 +497,10 @@ static int ks_wlan_get_nick(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set Bit-Rate */
 static int ks_wlan_set_rate(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_param *vwrq,
+			    struct iw_request_info *info, union iwreq_data *_vwrq,
 			    char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->bitrate;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int i = 0;
@@ -723,9 +733,10 @@ static int ks_wlan_set_rate(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get Bit-Rate */
 static int ks_wlan_get_rate(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_param *vwrq,
+			    struct iw_request_info *info, union iwreq_data *_vwrq,
 			    char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->bitrate;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -751,8 +762,9 @@ static int ks_wlan_get_rate(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set RTS threshold */
 static int ks_wlan_set_rts(struct net_device *dev, struct iw_request_info *info,
-			   struct iw_param *vwrq, char *extra)
+			   union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->rts;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int rthr = vwrq->value;
@@ -775,8 +787,9 @@ static int ks_wlan_set_rts(struct net_device *dev, struct iw_request_info *info,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get RTS threshold */
 static int ks_wlan_get_rts(struct net_device *dev, struct iw_request_info *info,
-			   struct iw_param *vwrq, char *extra)
+			   union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->rts;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -794,9 +807,10 @@ static int ks_wlan_get_rts(struct net_device *dev, struct iw_request_info *info,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set Fragmentation threshold */
 static int ks_wlan_set_frag(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_param *vwrq,
+			    struct iw_request_info *info, union iwreq_data *_vwrq,
 			    char *extra)
 {
+	struct iw_param *vwrq =&_vwrq->frag;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int fthr = vwrq->value;
@@ -820,9 +834,10 @@ static int ks_wlan_set_frag(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get Fragmentation threshold */
 static int ks_wlan_get_frag(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_param *vwrq,
+			    struct iw_request_info *info, union iwreq_data *_vwrq,
 			    char *extra)
 {
+	struct iw_param *vwrq =&_vwrq->frag;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -840,9 +855,10 @@ static int ks_wlan_get_frag(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set Mode of Operation */
 static int ks_wlan_set_mode(struct net_device *dev,
-			    struct iw_request_info *info, __u32 * uwrq,
+			    struct iw_request_info *info, union iwreq_data *_uwrq,
 			    char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -876,9 +892,10 @@ static int ks_wlan_set_mode(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get Mode of Operation */
 static int ks_wlan_get_mode(struct net_device *dev,
-			    struct iw_request_info *info, __u32 * uwrq,
+			    struct iw_request_info *info, union iwreq_data *_uwrq,
 			    char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -906,8 +923,9 @@ static int ks_wlan_get_mode(struct net_device *dev,
 /* Wireless Handler : set Encryption Key */
 static int ks_wlan_set_encode(struct net_device *dev,
 			      struct iw_request_info *info,
-			      struct iw_point *dwrq, char *extra)
+			      union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->encoding;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -1024,8 +1042,9 @@ static int ks_wlan_set_encode(struct net_device *dev,
 /* Wireless Handler : get Encryption Key */
 static int ks_wlan_get_encode(struct net_device *dev,
 			      struct iw_request_info *info,
-			      struct iw_point *dwrq, char *extra)
+			      union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->encoding;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	char zeros[16];
@@ -1080,7 +1099,7 @@ static int ks_wlan_get_encode(struct net_device *dev,
 /* Wireless Handler : set Tx-Power */
 static int ks_wlan_set_txpow(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_param *vwrq, char *extra)
+			     union iwreq_data *vwrq, char *extra)
 {
 	return -EOPNOTSUPP;	/* Not Support */
 }
@@ -1089,8 +1108,10 @@ static int ks_wlan_set_txpow(struct net_device *dev,
 /* Wireless Handler : get Tx-Power */
 static int ks_wlan_get_txpow(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_param *vwrq, char *extra)
+			     union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->txpower;
+
 	if (priv->sleep_mode == SLP_SLEEP) {
 		return -EPERM;
 	}
@@ -1107,7 +1128,7 @@ static int ks_wlan_get_txpow(struct net_device *dev,
 /* Wireless Handler : set Retry limits */
 static int ks_wlan_set_retry(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_param *vwrq, char *extra)
+			     union iwreq_data *vwrq, char *extra)
 {
 	return -EOPNOTSUPP;	/* Not Support */
 }
@@ -1116,8 +1137,10 @@ static int ks_wlan_set_retry(struct net_device *dev,
 /* Wireless Handler : get Retry limits */
 static int ks_wlan_get_retry(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_param *vwrq, char *extra)
+			     union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq =&_vwrq->retry;
+
 	if (priv->sleep_mode == SLP_SLEEP) {
 		return -EPERM;
 	}
@@ -1135,8 +1158,9 @@ static int ks_wlan_get_retry(struct net_device *dev,
 /* Wireless Handler : get range info */
 static int ks_wlan_get_range(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_point *dwrq, char *extra)
+			     union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	struct iw_range *range = (struct iw_range *)extra;
@@ -1266,8 +1290,9 @@ static int ks_wlan_get_range(struct net_device *dev,
 /* Wireless Handler : set Power Management */
 static int ks_wlan_set_power(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_param *vwrq, char *extra)
+			     union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq =&_vwrq->power;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	short enabled;
@@ -1301,8 +1326,9 @@ static int ks_wlan_set_power(struct net_device *dev,
 /* Wireless Handler : get Power Management */
 static int ks_wlan_get_power(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_param *vwrq, char *extra)
+			     union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq =&_vwrq->power;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -1322,8 +1348,9 @@ static int ks_wlan_get_power(struct net_device *dev,
 /* Wireless Handler : get wirless statistics */
 static int ks_wlan_get_iwstats(struct net_device *dev,
 			       struct iw_request_info *info,
-			       struct iw_quality *vwrq, char *extra)
+			       union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_quality *vwrq = &_vwrq->qual;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -1343,7 +1370,7 @@ static int ks_wlan_get_iwstats(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : set Sensitivity */
 static int ks_wlan_set_sens(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_param *vwrq,
+			    struct iw_request_info *info, union iwreq_data *vwrq,
 			    char *extra)
 {
 	return -EOPNOTSUPP;	/* Not Support */
@@ -1352,9 +1379,11 @@ static int ks_wlan_set_sens(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : get Sensitivity */
 static int ks_wlan_get_sens(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_param *vwrq,
+			    struct iw_request_info *info, union iwreq_data *_vwrq,
 			    char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->sens;
+
 	/* Not Support */
 	vwrq->value = 0;
 	vwrq->disabled = (vwrq->value == 0);
@@ -1368,8 +1397,9 @@ static int ks_wlan_get_sens(struct net_device *dev,
 /* Note : this is deprecated in favor of IWSCAN */
 static int ks_wlan_get_aplist(struct net_device *dev,
 			      struct iw_request_info *info,
-			      struct iw_point *dwrq, char *extra)
+			      union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	struct sockaddr *address = (struct sockaddr *)extra;
@@ -1596,9 +1626,10 @@ static inline char *ks_wlan_translate_scan(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Wireless Handler : Read Scan Results */
 static int ks_wlan_get_scan(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_point *dwrq,
+			    struct iw_request_info *info, union iwreq_data *_dwrq,
 			    char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int i;
@@ -1655,7 +1686,7 @@ static int ks_wlan_get_scan(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Commit handler : called after a bunch of SET operations */
 static int ks_wlan_config_commit(struct net_device *dev,
-				 struct iw_request_info *info, void *zwrq,
+				 struct iw_request_info *info, union iwreq_data *zwrq,
 				 char *extra)
 {
 	struct ks_wlan_private *priv =
@@ -1673,8 +1704,9 @@ static int ks_wlan_config_commit(struct net_device *dev,
 /* Wireless handler : set association ie params */
 static int ks_wlan_set_genie(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_point *dwrq, char *extra)
+			     union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq =&_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -1692,8 +1724,9 @@ static int ks_wlan_set_genie(struct net_device *dev,
 /* Wireless handler : set authentication mode params */
 static int ks_wlan_set_auth_mode(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *vwrq, char *extra)
+				 union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->param;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int index = (vwrq->flags & IW_AUTH_INDEX);
@@ -1832,8 +1865,9 @@ static int ks_wlan_set_auth_mode(struct net_device *dev,
 /* Wireless handler : get authentication mode params */
 static int ks_wlan_get_auth_mode(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *vwrq, char *extra)
+				 union iwreq_data *_vwrq, char *extra)
 {
+	struct iw_param *vwrq = &_vwrq->param;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	int index = (vwrq->flags & IW_AUTH_INDEX);
@@ -1878,8 +1912,9 @@ static int ks_wlan_get_auth_mode(struct net_device *dev,
 /* Wireless Handler : set encoding token & mode (WPA)*/
 static int ks_wlan_set_encode_ext(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *dwrq, char *extra)
+				  union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->encoding;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	struct iw_encode_ext *enc;
@@ -1986,8 +2021,9 @@ static int ks_wlan_set_encode_ext(struct net_device *dev,
 /* Wireless Handler : get encoding token & mode (WPA)*/
 static int ks_wlan_get_encode_ext(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *dwrq, char *extra)
+				  union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->encoding;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2009,8 +2045,9 @@ static int ks_wlan_get_encode_ext(struct net_device *dev,
 /* Wireless Handler : PMKSA cache operation (WPA2) */
 static int ks_wlan_set_pmksa(struct net_device *dev,
 			     struct iw_request_info *info,
-			     struct iw_point *dwrq, char *extra)
+			     union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	struct iw_pmksa *pmksa;
@@ -2168,9 +2205,10 @@ static int ks_wlan_set_stop_request(struct net_device *dev,
 /* Wireless Handler : set MLME */
 #include <linux/ieee80211.h>
 static int ks_wlan_set_mlme(struct net_device *dev,
-			    struct iw_request_info *info, struct iw_point *dwrq,
+			    struct iw_request_info *info, union iwreq_data *_dwrq,
 			    char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	struct iw_mlme *mlme = (struct iw_mlme *)extra;
@@ -2199,8 +2237,9 @@ static int ks_wlan_set_mlme(struct net_device *dev,
 /* Private handler : get firemware version */
 static int ks_wlan_get_firmware_version(struct net_device *dev,
 					struct iw_request_info *info,
-					struct iw_point *dwrq, char *extra)
+					union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	strcpy(extra, &(priv->firmware_version[0]));
@@ -2270,9 +2309,10 @@ static int ks_wlan_get_connect(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set preamble */
 static int ks_wlan_set_preamble(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2295,9 +2335,10 @@ static int ks_wlan_set_preamble(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get preamble */
 static int ks_wlan_get_preamble(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2312,9 +2353,10 @@ static int ks_wlan_get_preamble(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set power save mode */
 static int ks_wlan_set_powermgt(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2345,9 +2387,10 @@ static int ks_wlan_set_powermgt(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get power save made */
 static int ks_wlan_get_powermgt(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2362,9 +2405,10 @@ static int ks_wlan_get_powermgt(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set scan type */
 static int ks_wlan_set_scan_type(struct net_device *dev,
-				 struct iw_request_info *info, __u32 * uwrq,
+				 struct iw_request_info *info, union iwreq_data *_uwrq,
 				 char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2385,9 +2429,10 @@ static int ks_wlan_set_scan_type(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get scan type */
 static int ks_wlan_get_scan_type(struct net_device *dev,
-				 struct iw_request_info *info, __u32 * uwrq,
+				 struct iw_request_info *info, union iwreq_data *_uwrq,
 				 char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2536,9 +2581,10 @@ static int ks_wlan_get_wep_ascii(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set beacon lost count */
 static int ks_wlan_set_beacon_lost(struct net_device *dev,
-				   struct iw_request_info *info, __u32 * uwrq,
+				   struct iw_request_info *info, union iwreq_data *_uwrq,
 				   char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2561,9 +2607,10 @@ static int ks_wlan_set_beacon_lost(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get beacon lost count */
 static int ks_wlan_get_beacon_lost(struct net_device *dev,
-				   struct iw_request_info *info, __u32 * uwrq,
+				   struct iw_request_info *info, union iwreq_data *_uwrq,
 				   char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2578,9 +2625,10 @@ static int ks_wlan_get_beacon_lost(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set phy type */
 static int ks_wlan_set_phy_type(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2604,9 +2652,10 @@ static int ks_wlan_set_phy_type(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get phy type */
 static int ks_wlan_get_phy_type(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2621,9 +2670,10 @@ static int ks_wlan_get_phy_type(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set cts mode */
 static int ks_wlan_set_cts_mode(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2649,9 +2699,10 @@ static int ks_wlan_set_cts_mode(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get cts mode */
 static int ks_wlan_get_cts_mode(struct net_device *dev,
-				struct iw_request_info *info, __u32 * uwrq,
+				struct iw_request_info *info, union iwreq_data *_uwrq,
 				char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2667,8 +2718,9 @@ static int ks_wlan_get_cts_mode(struct net_device *dev,
 /* Private handler : set sleep mode */
 static int ks_wlan_set_sleep_mode(struct net_device *dev,
 				  struct iw_request_info *info,
-				  __u32 * uwrq, char *extra)
+				  union iwreq_data *_uwrq, char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2697,8 +2749,9 @@ static int ks_wlan_set_sleep_mode(struct net_device *dev,
 /* Private handler : get sleep mode */
 static int ks_wlan_get_sleep_mode(struct net_device *dev,
 				  struct iw_request_info *info,
-				  __u32 * uwrq, char *extra)
+				  union iwreq_data *_uwrq, char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2752,9 +2805,10 @@ static int ks_wlan_get_phy_information_timer(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set WPS enable */
 static int ks_wlan_set_wps_enable(struct net_device *dev,
-				  struct iw_request_info *info, __u32 * uwrq,
+				  struct iw_request_info *info, union iwreq_data *_uwrq,
 				  char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	DPRINTK(2, "\n");
@@ -2776,9 +2830,10 @@ static int ks_wlan_set_wps_enable(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get WPS enable */
 static int ks_wlan_get_wps_enable(struct net_device *dev,
-				  struct iw_request_info *info, __u32 * uwrq,
+				  struct iw_request_info *info, union iwreq_data *_uwrq,
 				  char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 	DPRINTK(2, "\n");
@@ -2797,8 +2852,9 @@ static int ks_wlan_get_wps_enable(struct net_device *dev,
 /* Private handler : set WPS probe req */
 static int ks_wlan_set_wps_probe_req(struct net_device *dev,
 				     struct iw_request_info *info,
-				     struct iw_point *dwrq, char *extra)
+				     union iwreq_data *_dwrq, char *extra)
 {
+	struct iw_point *dwrq = &_dwrq->data;
 	uint8_t *p = extra;
 	unsigned char len;
 	struct ks_wlan_private *priv =
@@ -2855,9 +2911,10 @@ static int ks_wlan_get_wps_probe_req(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set tx gain control value */
 static int ks_wlan_set_tx_gain(struct net_device *dev,
-			       struct iw_request_info *info, __u32 * uwrq,
+			       struct iw_request_info *info, union iwreq_data *_uwrq,
 			       char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2882,9 +2939,10 @@ static int ks_wlan_set_tx_gain(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get tx gain control value */
 static int ks_wlan_get_tx_gain(struct net_device *dev,
-			       struct iw_request_info *info, __u32 * uwrq,
+			       struct iw_request_info *info, union iwreq_data *_uwrq,
 			       char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2900,9 +2958,10 @@ static int ks_wlan_get_tx_gain(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : set rx gain control value */
 static int ks_wlan_set_rx_gain(struct net_device *dev,
-			       struct iw_request_info *info, __u32 * uwrq,
+			       struct iw_request_info *info, union iwreq_data *_uwrq,
 			       char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2927,9 +2986,10 @@ static int ks_wlan_set_rx_gain(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get rx gain control value */
 static int ks_wlan_get_rx_gain(struct net_device *dev,
-			       struct iw_request_info *info, __u32 * uwrq,
+			       struct iw_request_info *info, union iwreq_data *_uwrq,
 			       char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -2968,9 +3028,10 @@ static int ks_wlan_set_region(struct net_device *dev,
 /*------------------------------------------------------------------*/
 /* Private handler : get eeprom checksum result */
 static int ks_wlan_get_eeprom_cksum(struct net_device *dev,
-				    struct iw_request_info *info, __u32 * uwrq,
+				    struct iw_request_info *info, union iwreq_data *_uwrq,
 				    char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
 
@@ -3095,8 +3156,9 @@ static void print_hif_event(int event)
 /*------------------------------------------------------------------*/
 /* Private handler : get host command history */
 static int ks_wlan_hostt(struct net_device *dev, struct iw_request_info *info,
-			 __u32 * uwrq, char *extra)
+			 union iwreq_data *_uwrq, char *extra)
 {
+	__u32 *uwrq = &_uwrq->mode;
 	int i, event;
 	struct ks_wlan_private *priv =
 	    (struct ks_wlan_private *)netdev_priv(dev);
@@ -3167,119 +3229,119 @@ static const struct iw_priv_args ks_wlan_private_args[] = {
 };
 
 static const iw_handler ks_wlan_handler[] = {
-	(iw_handler) ks_wlan_config_commit,	/* SIOCSIWCOMMIT */
-	(iw_handler) ks_wlan_get_name,	/* SIOCGIWNAME */
-	(iw_handler) NULL,	/* SIOCSIWNWID */
-	(iw_handler) NULL,	/* SIOCGIWNWID */
-	(iw_handler) ks_wlan_set_freq,	/* SIOCSIWFREQ */
-	(iw_handler) ks_wlan_get_freq,	/* SIOCGIWFREQ */
-	(iw_handler) ks_wlan_set_mode,	/* SIOCSIWMODE */
-	(iw_handler) ks_wlan_get_mode,	/* SIOCGIWMODE */
+	ks_wlan_config_commit,	/* SIOCSIWCOMMIT */
+	ks_wlan_get_name,	/* SIOCGIWNAME */
+	NULL,	/* SIOCSIWNWID */
+	NULL,	/* SIOCGIWNWID */
+	ks_wlan_set_freq,	/* SIOCSIWFREQ */
+	ks_wlan_get_freq,	/* SIOCGIWFREQ */
+	ks_wlan_set_mode,	/* SIOCSIWMODE */
+	ks_wlan_get_mode,	/* SIOCGIWMODE */
 #ifndef KSC_OPNOTSUPP
-	(iw_handler) ks_wlan_set_sens,	/* SIOCSIWSENS */
-	(iw_handler) ks_wlan_get_sens,	/* SIOCGIWSENS */
+	ks_wlan_set_sens,	/* SIOCSIWSENS */
+	ks_wlan_get_sens,	/* SIOCGIWSENS */
 #else /* KSC_OPNOTSUPP */
-	(iw_handler) NULL,	/* SIOCSIWSENS */
-	(iw_handler) NULL,	/* SIOCGIWSENS */
+	NULL,	/* SIOCSIWSENS */
+	NULL,	/* SIOCGIWSENS */
 #endif /* KSC_OPNOTSUPP */
-	(iw_handler) NULL,	/* SIOCSIWRANGE */
-	(iw_handler) ks_wlan_get_range,	/* SIOCGIWRANGE */
-	(iw_handler) NULL,	/* SIOCSIWPRIV */
-	(iw_handler) NULL,	/* SIOCGIWPRIV */
-	(iw_handler) NULL,	/* SIOCSIWSTATS */
-	(iw_handler) ks_wlan_get_iwstats,	/* SIOCGIWSTATS */
-	(iw_handler) NULL,	/* SIOCSIWSPY */
-	(iw_handler) NULL,	/* SIOCGIWSPY */
-	(iw_handler) NULL,	/* SIOCSIWTHRSPY */
-	(iw_handler) NULL,	/* SIOCGIWTHRSPY */
-	(iw_handler) ks_wlan_set_wap,	/* SIOCSIWAP */
-	(iw_handler) ks_wlan_get_wap,	/* SIOCGIWAP */
-//      (iw_handler) NULL,                      /* SIOCSIWMLME */
-	(iw_handler) ks_wlan_set_mlme,	/* SIOCSIWMLME */
-	(iw_handler) ks_wlan_get_aplist,	/* SIOCGIWAPLIST */
-	(iw_handler) ks_wlan_set_scan,	/* SIOCSIWSCAN */
-	(iw_handler) ks_wlan_get_scan,	/* SIOCGIWSCAN */
-	(iw_handler) ks_wlan_set_essid,	/* SIOCSIWESSID */
-	(iw_handler) ks_wlan_get_essid,	/* SIOCGIWESSID */
-	(iw_handler) ks_wlan_set_nick,	/* SIOCSIWNICKN */
-	(iw_handler) ks_wlan_get_nick,	/* SIOCGIWNICKN */
-	(iw_handler) NULL,	/* -- hole -- */
-	(iw_handler) NULL,	/* -- hole -- */
-	(iw_handler) ks_wlan_set_rate,	/* SIOCSIWRATE */
-	(iw_handler) ks_wlan_get_rate,	/* SIOCGIWRATE */
-	(iw_handler) ks_wlan_set_rts,	/* SIOCSIWRTS */
-	(iw_handler) ks_wlan_get_rts,	/* SIOCGIWRTS */
-	(iw_handler) ks_wlan_set_frag,	/* SIOCSIWFRAG */
-	(iw_handler) ks_wlan_get_frag,	/* SIOCGIWFRAG */
+	NULL,	/* SIOCSIWRANGE */
+	ks_wlan_get_range,	/* SIOCGIWRANGE */
+	NULL,	/* SIOCSIWPRIV */
+	NULL,	/* SIOCGIWPRIV */
+	NULL,	/* SIOCSIWSTATS */
+	ks_wlan_get_iwstats,	/* SIOCGIWSTATS */
+	NULL,	/* SIOCSIWSPY */
+	NULL,	/* SIOCGIWSPY */
+	NULL,	/* SIOCSIWTHRSPY */
+	NULL,	/* SIOCGIWTHRSPY */
+	ks_wlan_set_wap,	/* SIOCSIWAP */
+	ks_wlan_get_wap,	/* SIOCGIWAP */
+//      NULL,                      /* SIOCSIWMLME */
+	ks_wlan_set_mlme,	/* SIOCSIWMLME */
+	ks_wlan_get_aplist,	/* SIOCGIWAPLIST */
+	ks_wlan_set_scan,	/* SIOCSIWSCAN */
+	ks_wlan_get_scan,	/* SIOCGIWSCAN */
+	ks_wlan_set_essid,	/* SIOCSIWESSID */
+	ks_wlan_get_essid,	/* SIOCGIWESSID */
+	ks_wlan_set_nick,	/* SIOCSIWNICKN */
+	ks_wlan_get_nick,	/* SIOCGIWNICKN */
+	NULL,	/* -- hole -- */
+	NULL,	/* -- hole -- */
+	ks_wlan_set_rate,	/* SIOCSIWRATE */
+	ks_wlan_get_rate,	/* SIOCGIWRATE */
+	ks_wlan_set_rts,	/* SIOCSIWRTS */
+	ks_wlan_get_rts,	/* SIOCGIWRTS */
+	ks_wlan_set_frag,	/* SIOCSIWFRAG */
+	ks_wlan_get_frag,	/* SIOCGIWFRAG */
 #ifndef KSC_OPNOTSUPP
-	(iw_handler) ks_wlan_set_txpow,	/* SIOCSIWTXPOW */
-	(iw_handler) ks_wlan_get_txpow,	/* SIOCGIWTXPOW */
-	(iw_handler) ks_wlan_set_retry,	/* SIOCSIWRETRY */
-	(iw_handler) ks_wlan_get_retry,	/* SIOCGIWRETRY */
+	ks_wlan_set_txpow,	/* SIOCSIWTXPOW */
+	ks_wlan_get_txpow,	/* SIOCGIWTXPOW */
+	ks_wlan_set_retry,	/* SIOCSIWRETRY */
+	ks_wlan_get_retry,	/* SIOCGIWRETRY */
 #else /* KSC_OPNOTSUPP */
-	(iw_handler) NULL,	/* SIOCSIWTXPOW */
-	(iw_handler) NULL,	/* SIOCGIWTXPOW */
-	(iw_handler) NULL,	/* SIOCSIWRETRY */
-	(iw_handler) NULL,	/* SIOCGIWRETRY */
+	NULL,	/* SIOCSIWTXPOW */
+	NULL,	/* SIOCGIWTXPOW */
+	NULL,	/* SIOCSIWRETRY */
+	NULL,	/* SIOCGIWRETRY */
 #endif /* KSC_OPNOTSUPP */
-	(iw_handler) ks_wlan_set_encode,	/* SIOCSIWENCODE */
-	(iw_handler) ks_wlan_get_encode,	/* SIOCGIWENCODE */
-	(iw_handler) ks_wlan_set_power,	/* SIOCSIWPOWER */
-	(iw_handler) ks_wlan_get_power,	/* SIOCGIWPOWER */
-	(iw_handler) NULL,	/* -- hole -- */
-	(iw_handler) NULL,	/* -- hole -- */
-//      (iw_handler) NULL,                      /* SIOCSIWGENIE */
-	(iw_handler) ks_wlan_set_genie,	/* SIOCSIWGENIE */
-	(iw_handler) NULL,	/* SIOCGIWGENIE */
-	(iw_handler) ks_wlan_set_auth_mode,	/* SIOCSIWAUTH */
-	(iw_handler) ks_wlan_get_auth_mode,	/* SIOCGIWAUTH */
-	(iw_handler) ks_wlan_set_encode_ext,	/* SIOCSIWENCODEEXT */
-	(iw_handler) ks_wlan_get_encode_ext,	/* SIOCGIWENCODEEXT */
-	(iw_handler) ks_wlan_set_pmksa,	/* SIOCSIWPMKSA */
-	(iw_handler) NULL,	/* -- hole -- */
+	ks_wlan_set_encode,	/* SIOCSIWENCODE */
+	ks_wlan_get_encode,	/* SIOCGIWENCODE */
+	ks_wlan_set_power,	/* SIOCSIWPOWER */
+	ks_wlan_get_power,	/* SIOCGIWPOWER */
+	NULL,	/* -- hole -- */
+	NULL,	/* -- hole -- */
+//      NULL,                      /* SIOCSIWGENIE */
+	ks_wlan_set_genie,	/* SIOCSIWGENIE */
+	NULL,	/* SIOCGIWGENIE */
+	ks_wlan_set_auth_mode,	/* SIOCSIWAUTH */
+	ks_wlan_get_auth_mode,	/* SIOCGIWAUTH */
+	ks_wlan_set_encode_ext,	/* SIOCSIWENCODEEXT */
+	ks_wlan_get_encode_ext,	/* SIOCGIWENCODEEXT */
+	ks_wlan_set_pmksa,	/* SIOCSIWPMKSA */
+	NULL,	/* -- hole -- */
 };
 
 /* private_handler */
 static const iw_handler ks_wlan_private_handler[] = {
-	(iw_handler) NULL,	/*  0 */
-	(iw_handler) NULL,	/*  1, used to be: KS_WLAN_GET_DRIVER_VERSION */
-	(iw_handler) NULL,	/*  2 */
-	(iw_handler) ks_wlan_get_firmware_version,	/*  3 KS_WLAN_GET_FIRM_VERSION */
+	NULL,	/*  0 */
+	NULL,	/*  1, used to be: KS_WLAN_GET_DRIVER_VERSION */
+	NULL,	/*  2 */
+	ks_wlan_get_firmware_version,	/*  3 KS_WLAN_GET_FIRM_VERSION */
 #ifdef WPS
-	(iw_handler) ks_wlan_set_wps_enable,	/*  4 KS_WLAN_SET_WPS_ENABLE  */
-	(iw_handler) ks_wlan_get_wps_enable,	/*  5 KS_WLAN_GET_WPS_ENABLE  */
-	(iw_handler) ks_wlan_set_wps_probe_req,	/*  6 KS_WLAN_SET_WPS_PROBE_REQ */
+	ks_wlan_set_wps_enable,	/*  4 KS_WLAN_SET_WPS_ENABLE  */
+	ks_wlan_get_wps_enable,	/*  5 KS_WLAN_GET_WPS_ENABLE  */
+	ks_wlan_set_wps_probe_req,	/*  6 KS_WLAN_SET_WPS_PROBE_REQ */
 #else
-	(iw_handler) NULL,	/*  4 */
-	(iw_handler) NULL,	/*  5 */
-	(iw_handler) NULL,	/*  6 */
+	NULL,	/*  4 */
+	NULL,	/*  5 */
+	NULL,	/*  6 */
 #endif /* WPS */
 
-	(iw_handler) ks_wlan_get_eeprom_cksum,	/*  7 KS_WLAN_GET_CONNECT */
-	(iw_handler) ks_wlan_set_preamble,	/*  8 KS_WLAN_SET_PREAMBLE */
-	(iw_handler) ks_wlan_get_preamble,	/*  9 KS_WLAN_GET_PREAMBLE */
-	(iw_handler) ks_wlan_set_powermgt,	/* 10 KS_WLAN_SET_POWER_SAVE */
-	(iw_handler) ks_wlan_get_powermgt,	/* 11 KS_WLAN_GET_POWER_SAVE */
-	(iw_handler) ks_wlan_set_scan_type,	/* 12 KS_WLAN_SET_SCAN_TYPE */
-	(iw_handler) ks_wlan_get_scan_type,	/* 13 KS_WLAN_GET_SCAN_TYPE */
-	(iw_handler) ks_wlan_set_rx_gain,	/* 14 KS_WLAN_SET_RX_GAIN */
-	(iw_handler) ks_wlan_get_rx_gain,	/* 15 KS_WLAN_GET_RX_GAIN */
-	(iw_handler) ks_wlan_hostt,	/* 16 KS_WLAN_HOSTT */
-	(iw_handler) NULL,	/* 17 */
-	(iw_handler) ks_wlan_set_beacon_lost,	/* 18 KS_WLAN_SET_BECAN_LOST */
-	(iw_handler) ks_wlan_get_beacon_lost,	/* 19 KS_WLAN_GET_BECAN_LOST */
-	(iw_handler) ks_wlan_set_tx_gain,	/* 20 KS_WLAN_SET_TX_GAIN */
-	(iw_handler) ks_wlan_get_tx_gain,	/* 21 KS_WLAN_GET_TX_GAIN */
-	(iw_handler) ks_wlan_set_phy_type,	/* 22 KS_WLAN_SET_PHY_TYPE */
-	(iw_handler) ks_wlan_get_phy_type,	/* 23 KS_WLAN_GET_PHY_TYPE */
-	(iw_handler) ks_wlan_set_cts_mode,	/* 24 KS_WLAN_SET_CTS_MODE */
-	(iw_handler) ks_wlan_get_cts_mode,	/* 25 KS_WLAN_GET_CTS_MODE */
-	(iw_handler) NULL,	/* 26 */
-	(iw_handler) NULL,	/* 27 */
-	(iw_handler) ks_wlan_set_sleep_mode,	/* 28 KS_WLAN_SET_SLEEP_MODE */
-	(iw_handler) ks_wlan_get_sleep_mode,	/* 29 KS_WLAN_GET_SLEEP_MODE */
-	(iw_handler) NULL,	/* 30 */
-	(iw_handler) NULL,	/* 31 */
+	ks_wlan_get_eeprom_cksum,	/*  7 KS_WLAN_GET_CONNECT */
+	ks_wlan_set_preamble,	/*  8 KS_WLAN_SET_PREAMBLE */
+	ks_wlan_get_preamble,	/*  9 KS_WLAN_GET_PREAMBLE */
+	ks_wlan_set_powermgt,	/* 10 KS_WLAN_SET_POWER_SAVE */
+	ks_wlan_get_powermgt,	/* 11 KS_WLAN_GET_POWER_SAVE */
+	ks_wlan_set_scan_type,	/* 12 KS_WLAN_SET_SCAN_TYPE */
+	ks_wlan_get_scan_type,	/* 13 KS_WLAN_GET_SCAN_TYPE */
+	ks_wlan_set_rx_gain,	/* 14 KS_WLAN_SET_RX_GAIN */
+	ks_wlan_get_rx_gain,	/* 15 KS_WLAN_GET_RX_GAIN */
+	ks_wlan_hostt,	/* 16 KS_WLAN_HOSTT */
+	NULL,	/* 17 */
+	ks_wlan_set_beacon_lost,	/* 18 KS_WLAN_SET_BECAN_LOST */
+	ks_wlan_get_beacon_lost,	/* 19 KS_WLAN_GET_BECAN_LOST */
+	ks_wlan_set_tx_gain,	/* 20 KS_WLAN_SET_TX_GAIN */
+	ks_wlan_get_tx_gain,	/* 21 KS_WLAN_GET_TX_GAIN */
+	ks_wlan_set_phy_type,	/* 22 KS_WLAN_SET_PHY_TYPE */
+	ks_wlan_get_phy_type,	/* 23 KS_WLAN_GET_PHY_TYPE */
+	ks_wlan_set_cts_mode,	/* 24 KS_WLAN_SET_CTS_MODE */
+	ks_wlan_get_cts_mode,	/* 25 KS_WLAN_GET_CTS_MODE */
+	NULL,	/* 26 */
+	NULL,	/* 27 */
+	ks_wlan_set_sleep_mode,	/* 28 KS_WLAN_SET_SLEEP_MODE */
+	ks_wlan_get_sleep_mode,	/* 29 KS_WLAN_GET_SLEEP_MODE */
+	NULL,	/* 30 */
+	NULL,	/* 31 */
 };
 
 static const struct iw_handler_def ks_wlan_handler_def = {
@@ -3287,8 +3349,8 @@ static const struct iw_handler_def ks_wlan_handler_def = {
 	.num_private = sizeof(ks_wlan_private_handler) / sizeof(iw_handler),
 	.num_private_args =
 	    sizeof(ks_wlan_private_args) / sizeof(struct iw_priv_args),
-	.standard = (iw_handler *) ks_wlan_handler,
-	.private = (iw_handler *) ks_wlan_private_handler,
+	.standard = ks_wlan_handler,
+	.private = ks_wlan_private_handler,
 	.private_args = (struct iw_priv_args *)ks_wlan_private_args,
 	.get_wireless_stats = ks_get_wireless_stats,
 };
@@ -3359,7 +3421,7 @@ void ks_wlan_tx_timeout(struct net_device *dev)
 }
 
 static
-int ks_wlan_start_xmit(struct sk_buff *skb, struct net_device *dev)
+netdev_tx_t ks_wlan_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct ks_wlan_private *priv = netdev_priv(dev);
 	int rc = 0;
diff --git a/drivers/staging/lustre/lnet/klnds/socklnd/socklnd.h b/drivers/staging/lustre/lnet/klnds/socklnd/socklnd.h
index a56632b4e..5d236d83e 100644
--- a/drivers/staging/lustre/lnet/klnds/socklnd/socklnd.h
+++ b/drivers/staging/lustre/lnet/klnds/socklnd/socklnd.h
@@ -305,10 +305,8 @@ struct ksock_conn {
 	struct ksock_route *ksnc_route;       /* owning route */
 	struct list_head   ksnc_list;         /* stash on peer's conn list */
 	struct socket      *ksnc_sock;        /* actual socket */
-	void               *ksnc_saved_data_ready;  /* socket's original
-						     * data_ready() callback */
-	void               *ksnc_saved_write_space; /* socket's original
-						     * write_space() callback */
+	void		   (*ksnc_saved_data_ready)(struct sock *sk); /* socket's original data_ready() callback */
+	void		   (*ksnc_saved_write_space)(struct sock *sk); /* socket's original write_space() callback */
 	atomic_t           ksnc_conn_refcount;/* conn refcount */
 	atomic_t           ksnc_sock_refcount;/* sock refcount */
 	struct ksock_sched *ksnc_scheduler;	/* who schedules this connection
diff --git a/drivers/staging/lustre/lnet/selftest/brw_test.c b/drivers/staging/lustre/lnet/selftest/brw_test.c
index 13d0454e7..f18459d23 100644
--- a/drivers/staging/lustre/lnet/selftest/brw_test.c
+++ b/drivers/staging/lustre/lnet/selftest/brw_test.c
@@ -324,7 +324,7 @@ brw_client_done_rpc(struct sfw_test_unit *tsu, struct srpc_client_rpc *rpc)
 		CERROR("BRW RPC to %s failed with %d\n",
 		       libcfs_id2str(rpc->crpc_dest), rpc->crpc_status);
 		if (!tsi->tsi_stopping)	/* rpc could have been aborted */
-			atomic_inc(&sn->sn_brw_errors);
+			atomic_inc_unchecked(&sn->sn_brw_errors);
 		return;
 	}
 
@@ -338,7 +338,7 @@ brw_client_done_rpc(struct sfw_test_unit *tsu, struct srpc_client_rpc *rpc)
 	       libcfs_id2str(rpc->crpc_dest), reply->brw_status);
 
 	if (reply->brw_status) {
-		atomic_inc(&sn->sn_brw_errors);
+		atomic_inc_unchecked(&sn->sn_brw_errors);
 		rpc->crpc_status = -(int)reply->brw_status;
 		return;
 	}
@@ -349,7 +349,7 @@ brw_client_done_rpc(struct sfw_test_unit *tsu, struct srpc_client_rpc *rpc)
 	if (brw_check_bulk(&rpc->crpc_bulk, reqst->brw_flags, magic)) {
 		CERROR("Bulk data from %s is corrupted!\n",
 		       libcfs_id2str(rpc->crpc_dest));
-		atomic_inc(&sn->sn_brw_errors);
+		atomic_inc_unchecked(&sn->sn_brw_errors);
 		rpc->crpc_status = -EBADMSG;
 	}
 }
@@ -484,14 +484,11 @@ brw_server_handle(struct srpc_server_rpc *rpc)
 	return 0;
 }
 
-struct sfw_test_client_ops brw_test_client;
-
-void brw_init_test_client(void)
-{
-	brw_test_client.tso_init = brw_client_init;
-	brw_test_client.tso_fini = brw_client_fini;
-	brw_test_client.tso_prep_rpc = brw_client_prep_rpc;
-	brw_test_client.tso_done_rpc = brw_client_done_rpc;
+struct sfw_test_client_ops brw_test_client = {
+	.tso_init = brw_client_init,
+	.tso_fini = brw_client_fini,
+	.tso_prep_rpc = brw_client_prep_rpc,
+	.tso_done_rpc = brw_client_done_rpc,
 };
 
 struct srpc_service brw_test_service;
diff --git a/drivers/staging/lustre/lnet/selftest/framework.c b/drivers/staging/lustre/lnet/selftest/framework.c
index c2f121f44..c315572e6 100644
--- a/drivers/staging/lustre/lnet/selftest/framework.c
+++ b/drivers/staging/lustre/lnet/selftest/framework.c
@@ -262,8 +262,8 @@ sfw_init_session(struct sfw_session *sn, lst_sid_t sid,
 	INIT_LIST_HEAD(&sn->sn_list);
 	INIT_LIST_HEAD(&sn->sn_batches);
 	atomic_set(&sn->sn_refcount, 1);	/* +1 for caller */
-	atomic_set(&sn->sn_brw_errors, 0);
-	atomic_set(&sn->sn_ping_errors, 0);
+	atomic_set_unchecked(&sn->sn_brw_errors, 0);
+	atomic_set_unchecked(&sn->sn_ping_errors, 0);
 	strlcpy(&sn->sn_name[0], name, sizeof(sn->sn_name));
 
 	sn->sn_timer_active = 0;
@@ -383,8 +383,8 @@ sfw_get_stats(struct srpc_stat_reqst *request, struct srpc_stat_reply *reply)
 	 * with 32 bits to send, this is ~49 days
 	 */
 	cnt->running_ms = jiffies_to_msecs(jiffies - sn->sn_started);
-	cnt->brw_errors = atomic_read(&sn->sn_brw_errors);
-	cnt->ping_errors = atomic_read(&sn->sn_ping_errors);
+	cnt->brw_errors = atomic_read_unchecked(&sn->sn_brw_errors);
+	cnt->ping_errors = atomic_read_unchecked(&sn->sn_ping_errors);
 	cnt->zombie_sessions = atomic_read(&sfw_data.fw_nzombies);
 
 	cnt->active_batches = 0;
@@ -1655,12 +1655,10 @@ sfw_startup(void)
 	INIT_LIST_HEAD(&sfw_data.fw_zombie_rpcs);
 	INIT_LIST_HEAD(&sfw_data.fw_zombie_sessions);
 
-	brw_init_test_client();
 	brw_init_test_service();
 	rc = sfw_register_test(&brw_test_service, &brw_test_client);
 	LASSERT(!rc);
 
-	ping_init_test_client();
 	ping_init_test_service();
 	rc = sfw_register_test(&ping_test_service, &ping_test_client);
 	LASSERT(!rc);
diff --git a/drivers/staging/lustre/lnet/selftest/ping_test.c b/drivers/staging/lustre/lnet/selftest/ping_test.c
index 9331ca4e3..23511dbe4 100644
--- a/drivers/staging/lustre/lnet/selftest/ping_test.c
+++ b/drivers/staging/lustre/lnet/selftest/ping_test.c
@@ -74,7 +74,7 @@ ping_client_fini(struct sfw_test_instance *tsi)
 	LASSERT(sn);
 	LASSERT(tsi->tsi_is_client);
 
-	errors = atomic_read(&sn->sn_ping_errors);
+	errors = atomic_read_unchecked(&sn->sn_ping_errors);
 	if (errors)
 		CWARN("%d pings have failed.\n", errors);
 	else
@@ -126,7 +126,7 @@ ping_client_done_rpc(struct sfw_test_unit *tsu, struct srpc_client_rpc *rpc)
 
 	if (rpc->crpc_status) {
 		if (!tsi->tsi_stopping)	/* rpc could have been aborted */
-			atomic_inc(&sn->sn_ping_errors);
+			atomic_inc_unchecked(&sn->sn_ping_errors);
 		CERROR("Unable to ping %s (%d): %d\n",
 		       libcfs_id2str(rpc->crpc_dest),
 		       reqst->pnr_seq, rpc->crpc_status);
@@ -141,7 +141,7 @@ ping_client_done_rpc(struct sfw_test_unit *tsu, struct srpc_client_rpc *rpc)
 
 	if (reply->pnr_magic != LST_PING_TEST_MAGIC) {
 		rpc->crpc_status = -EBADMSG;
-		atomic_inc(&sn->sn_ping_errors);
+		atomic_inc_unchecked(&sn->sn_ping_errors);
 		CERROR("Bad magic %u from %s, %u expected.\n",
 		       reply->pnr_magic, libcfs_id2str(rpc->crpc_dest),
 		       LST_PING_TEST_MAGIC);
@@ -150,7 +150,7 @@ ping_client_done_rpc(struct sfw_test_unit *tsu, struct srpc_client_rpc *rpc)
 
 	if (reply->pnr_seq != reqst->pnr_seq) {
 		rpc->crpc_status = -EBADMSG;
-		atomic_inc(&sn->sn_ping_errors);
+		atomic_inc_unchecked(&sn->sn_ping_errors);
 		CERROR("Bad seq %u from %s, %u expected.\n",
 		       reply->pnr_seq, libcfs_id2str(rpc->crpc_dest),
 		       reqst->pnr_seq);
@@ -206,15 +206,12 @@ ping_server_handle(struct srpc_server_rpc *rpc)
 	return 0;
 }
 
-struct sfw_test_client_ops ping_test_client;
-
-void ping_init_test_client(void)
-{
-	ping_test_client.tso_init = ping_client_init;
-	ping_test_client.tso_fini = ping_client_fini;
-	ping_test_client.tso_prep_rpc = ping_client_prep_rpc;
-	ping_test_client.tso_done_rpc = ping_client_done_rpc;
-}
+struct sfw_test_client_ops ping_test_client = {
+	.tso_init = ping_client_init,
+	.tso_fini = ping_client_fini,
+	.tso_prep_rpc = ping_client_prep_rpc,
+	.tso_done_rpc = ping_client_done_rpc,
+};
 
 struct srpc_service ping_test_service;
 
diff --git a/drivers/staging/lustre/lnet/selftest/selftest.h b/drivers/staging/lustre/lnet/selftest/selftest.h
index d033ac03d..528a10289 100644
--- a/drivers/staging/lustre/lnet/selftest/selftest.h
+++ b/drivers/staging/lustre/lnet/selftest/selftest.h
@@ -328,8 +328,8 @@ struct sfw_session {
 	struct list_head sn_batches; /* list of batches */
 	char		 sn_name[LST_NAME_SIZE];
 	atomic_t	 sn_refcount;
-	atomic_t	 sn_brw_errors;
-	atomic_t	 sn_ping_errors;
+	atomic_unchecked_t sn_brw_errors;
+	atomic_unchecked_t sn_ping_errors;
 	unsigned long	 sn_started;
 };
 
@@ -607,13 +607,11 @@ srpc_wait_service_shutdown(struct srpc_service *sv)
 }
 
 extern struct sfw_test_client_ops brw_test_client;
-void brw_init_test_client(void);
 
 extern struct srpc_service brw_test_service;
 void brw_init_test_service(void);
 
 extern struct sfw_test_client_ops ping_test_client;
-void ping_init_test_client(void);
 
 extern struct srpc_service ping_test_service;
 void ping_init_test_service(void);
diff --git a/drivers/staging/lustre/lustre/include/lustre/lustre_idl.h b/drivers/staging/lustre/lustre/include/lustre/lustre_idl.h
index 051864c23..72aca9bd7 100644
--- a/drivers/staging/lustre/lustre/include/lustre/lustre_idl.h
+++ b/drivers/staging/lustre/lustre/include/lustre/lustre_idl.h
@@ -784,7 +784,7 @@ static inline ino_t lu_igif_ino(const struct lu_fid *fid)
 	return fid_seq(fid);
 }
 
-void lustre_swab_ost_id(struct ost_id *oid);
+void lustre_swab_ost_id(void *oid);
 
 /**
  * Get inode generation from a igif.
@@ -851,8 +851,8 @@ static inline int fid_is_zero(const struct lu_fid *fid)
 	return fid_seq(fid) == 0 && fid_oid(fid) == 0;
 }
 
-void lustre_swab_lu_fid(struct lu_fid *fid);
-void lustre_swab_lu_seq_range(struct lu_seq_range *range);
+void lustre_swab_lu_fid(void *fid);
+void lustre_swab_lu_seq_range(void *range);
 
 static inline int lu_fid_eq(const struct lu_fid *f0, const struct lu_fid *f1)
 {
@@ -1157,7 +1157,7 @@ struct ptlrpc_body_v2 {
 	__u64 pb_padding[4];
 };
 
-void lustre_swab_ptlrpc_body(struct ptlrpc_body *pb);
+void lustre_swab_ptlrpc_body(void *pb);
 
 /* message body offset for lustre_msg_v2 */
 /* ptlrpc body offset in all request/reply messages */
@@ -1398,7 +1398,7 @@ struct obd_connect_data {
  * reserve the flag for future use.
  */
 
-void lustre_swab_connect(struct obd_connect_data *ocd);
+void lustre_swab_connect(void *ocd);
 
 /*
  * Supported checksum algorithms. Up to 32 checksum types are supported.
@@ -1752,10 +1752,10 @@ struct hsm_state_set {
 	__u64	hss_clearmask;
 };
 
-void lustre_swab_hsm_user_state(struct hsm_user_state *hus);
-void lustre_swab_hsm_state_set(struct hsm_state_set *hss);
+void lustre_swab_hsm_user_state(void *hus);
+void lustre_swab_hsm_state_set(void *hss);
 
-void lustre_swab_obd_statfs(struct obd_statfs *os);
+void lustre_swab_obd_statfs(void *os);
 
 /* ost_body.data values for OST_BRW */
 
@@ -1802,7 +1802,7 @@ struct obd_ioobj {
 #define ioobj_max_brw_set(ioo, num)					\
 do { (ioo)->ioo_max_brw = ((num) - 1) << IOOBJ_MAX_BRW_BITS; } while (0)
 
-void lustre_swab_obd_ioobj(struct obd_ioobj *ioo);
+void lustre_swab_obd_ioobj(void *ioo);
 
 /* multiple of 8 bytes => can array */
 struct niobuf_remote {
@@ -1811,7 +1811,7 @@ struct niobuf_remote {
 	__u32 flags;
 };
 
-void lustre_swab_niobuf_remote(struct niobuf_remote *nbr);
+void lustre_swab_niobuf_remote(void *nbr);
 
 /* lock value block communicated between the filter and llite */
 
@@ -1876,7 +1876,7 @@ struct obd_quotactl {
 	struct obd_dqblk	qc_dqblk;
 };
 
-void lustre_swab_obd_quotactl(struct obd_quotactl *q);
+void lustre_swab_obd_quotactl(void *q);
 
 #define Q_QUOTACHECK	0x800100 /* deprecated as of 2.4 */
 #define Q_INITQUOTA	0x800101 /* deprecated as of 2.4  */
@@ -1988,7 +1988,7 @@ enum mdt_reint_cmd {
 	REINT_MAX
 };
 
-void lustre_swab_generic_32s(__u32 *val);
+void lustre_swab_generic_32s(void *val);
 
 /* the disposition of the intent outlines what was executed */
 #define DISP_IT_EXECD	0x00000001
@@ -2147,7 +2147,7 @@ struct mdt_body {
 	__u64	  padding_10;
 }; /* 216 */
 
-void lustre_swab_mdt_body(struct mdt_body *b);
+void lustre_swab_mdt_body(void *b);
 
 struct mdt_ioepoch {
 	struct lustre_handle handle;
@@ -2156,7 +2156,7 @@ struct mdt_ioepoch {
 	__u32  padding;
 };
 
-void lustre_swab_mdt_ioepoch(struct mdt_ioepoch *b);
+void lustre_swab_mdt_ioepoch(void *b);
 
 /* permissions for md_perm.mp_perm */
 enum {
@@ -2465,7 +2465,7 @@ struct mdt_rec_reint {
 	__u32	   rr_padding_4; /* also fix lustre_swab_mdt_rec_reint */
 };
 
-void lustre_swab_mdt_rec_reint(struct mdt_rec_reint *rr);
+void lustre_swab_mdt_rec_reint(void *rr);
 
 /* lmv structures */
 struct lmv_desc {
@@ -2664,13 +2664,13 @@ union ldlm_gl_desc {
 	struct ldlm_gl_lquota_desc	lquota_desc;
 };
 
-void lustre_swab_gl_desc(union ldlm_gl_desc *);
+void lustre_swab_gl_desc(void *);
 
 struct ldlm_intent {
 	__u64 opc;
 };
 
-void lustre_swab_ldlm_intent(struct ldlm_intent *i);
+void lustre_swab_ldlm_intent(void *i);
 
 struct ldlm_resource_desc {
 	enum ldlm_type lr_type;
@@ -2695,7 +2695,7 @@ struct ldlm_request {
 	struct lustre_handle lock_handle[LDLM_LOCKREQ_HANDLES];
 };
 
-void lustre_swab_ldlm_request(struct ldlm_request *rq);
+void lustre_swab_ldlm_request(void *rq);
 
 /* If LDLM_ENQUEUE, 1 slot is already occupied, 1 is available.
  * Otherwise, 2 are available.
@@ -2718,7 +2718,7 @@ struct ldlm_reply {
 	__u64  lock_policy_res2;
 };
 
-void lustre_swab_ldlm_reply(struct ldlm_reply *r);
+void lustre_swab_ldlm_reply(void *r);
 
 #define ldlm_flags_to_wire(flags)    ((__u32)(flags))
 #define ldlm_flags_from_wire(flags)  ((__u64)(flags))
@@ -2763,7 +2763,7 @@ struct mgs_target_info {
 	char	     mti_params[MTI_PARAM_MAXLEN];
 };
 
-void lustre_swab_mgs_target_info(struct mgs_target_info *oinfo);
+void lustre_swab_mgs_target_info(void *oinfo);
 
 struct mgs_nidtbl_entry {
 	__u64	   mne_version;    /* table version of this entry */
@@ -2790,14 +2790,14 @@ struct mgs_config_body {
 	__u32    mcb_units;     /* # of units for bulk transfer */
 };
 
-void lustre_swab_mgs_config_body(struct mgs_config_body *body);
+void lustre_swab_mgs_config_body(void *body);
 
 struct mgs_config_res {
 	__u64    mcr_offset;    /* index of last config log */
 	__u64    mcr_size;      /* size of the log */
 };
 
-void lustre_swab_mgs_config_res(struct mgs_config_res *body);
+void lustre_swab_mgs_config_res(void *body);
 
 /* Config marker flags (in config log) */
 #define CM_START       0x01
@@ -3224,9 +3224,9 @@ struct ll_fiemap_info_key {
 	struct  ll_user_fiemap fiemap;
 };
 
-void lustre_swab_ost_body(struct ost_body *b);
-void lustre_swab_ost_last_id(__u64 *id);
-void lustre_swab_fiemap(struct ll_user_fiemap *fiemap);
+void lustre_swab_ost_body(void *b);
+void lustre_swab_ost_last_id(void *id);
+void lustre_swab_fiemap(void *fiemap);
 
 void lustre_swab_lov_user_md_v1(struct lov_user_md_v1 *lum);
 void lustre_swab_lov_user_md_v3(struct lov_user_md_v3 *lum);
@@ -3235,19 +3235,19 @@ void lustre_swab_lov_user_md_objects(struct lov_user_ost_data *lod,
 void lustre_swab_lov_mds_md(struct lov_mds_md *lmm);
 
 /* llog_swab.c */
-void lustre_swab_llogd_body(struct llogd_body *d);
-void lustre_swab_llog_hdr(struct llog_log_hdr *h);
-void lustre_swab_llogd_conn_body(struct llogd_conn_body *d);
+void lustre_swab_llogd_body(void *d);
+void lustre_swab_llog_hdr(void *h);
+void lustre_swab_llogd_conn_body(void *d);
 void lustre_swab_llog_rec(struct llog_rec_hdr *rec);
 
 struct lustre_cfg;
 void lustre_swab_lustre_cfg(struct lustre_cfg *lcfg);
 
 /* Functions for dumping PTLRPC fields */
-void dump_rniobuf(struct niobuf_remote *rnb);
-void dump_ioo(struct obd_ioobj *nb);
-void dump_ost_body(struct ost_body *ob);
-void dump_rcs(__u32 *rc);
+void dump_rniobuf(void *rnb);
+void dump_ioo(void *nb);
+void dump_ost_body(void *ob);
+void dump_rcs(void *rc);
 
 /* security opcodes */
 enum sec_cmd {
@@ -3280,7 +3280,7 @@ struct lustre_capa {
 	__u8	    lc_hmac[CAPA_HMAC_MAX_LEN];   /** HMAC */
 } __packed;
 
-void lustre_swab_lustre_capa(struct lustre_capa *c);
+void lustre_swab_lustre_capa(void *c);
 
 /** lustre_capa::lc_opc */
 enum {
@@ -3364,7 +3364,7 @@ struct layout_intent {
 	__u64 li_end;
 };
 
-void lustre_swab_layout_intent(struct layout_intent *li);
+void lustre_swab_layout_intent(void *li);
 
 /**
  * On the wire version of hsm_progress structure.
@@ -3384,12 +3384,10 @@ struct hsm_progress_kernel {
 	__u64			hpk_padding2;
 } __packed;
 
-void lustre_swab_hsm_user_state(struct hsm_user_state *hus);
-void lustre_swab_hsm_current_action(struct hsm_current_action *action);
-void lustre_swab_hsm_progress_kernel(struct hsm_progress_kernel *hpk);
-void lustre_swab_hsm_user_state(struct hsm_user_state *hus);
-void lustre_swab_hsm_user_item(struct hsm_user_item *hui);
-void lustre_swab_hsm_request(struct hsm_request *hr);
+void lustre_swab_hsm_current_action(void *action);
+void lustre_swab_hsm_progress_kernel(void *hpk);
+void lustre_swab_hsm_user_item(void *hui);
+void lustre_swab_hsm_request(void *hr);
 
 /** layout swap request structure
  * fid1 and fid2 are in mdt_body
@@ -3398,7 +3396,7 @@ struct mdc_swap_layouts {
 	__u64	   msl_flags;
 } __packed;
 
-void lustre_swab_swap_layouts(struct mdc_swap_layouts *msl);
+void lustre_swab_swap_layouts(void *msl);
 
 struct close_data {
 	struct lustre_handle	cd_handle;
@@ -3407,7 +3405,7 @@ struct close_data {
 	__u64			cd_reserved[8];
 };
 
-void lustre_swab_close_data(struct close_data *data);
+void lustre_swab_close_data(void *data);
 
 #endif
 /** @} lustreidl */
diff --git a/drivers/staging/lustre/lustre/include/lustre_dlm.h b/drivers/staging/lustre/lustre/include/lustre_dlm.h
index 60051a5cf..76ac7a762 100644
--- a/drivers/staging/lustre/lustre/include/lustre_dlm.h
+++ b/drivers/staging/lustre/lustre/include/lustre_dlm.h
@@ -964,9 +964,9 @@ struct ldlm_ast_work {
 struct ldlm_enqueue_info {
 	__u32 ei_type;   /** Type of the lock being enqueued. */
 	__u32 ei_mode;   /** Mode of the lock being enqueued. */
-	void *ei_cb_bl;  /** blocking lock callback */
-	void *ei_cb_cp;  /** lock completion callback */
-	void *ei_cb_gl;  /** lock glimpse callback */
+	ldlm_blocking_callback ei_cb_bl;  /** blocking lock callback */
+	ldlm_completion_callback ei_cb_cp;  /** lock completion callback */
+	ldlm_glimpse_callback ei_cb_gl;  /** lock glimpse callback */
 	void *ei_cbdata; /** Data to be passed into callbacks. */
 };
 
@@ -1060,7 +1060,7 @@ struct ldlm_callback_suite {
 	ldlm_completion_callback lcs_completion;
 	ldlm_blocking_callback   lcs_blocking;
 	ldlm_glimpse_callback    lcs_glimpse;
-};
+} __no_const;
 
 /* ldlm_lockd.c */
 int ldlm_get_ref(void);
diff --git a/drivers/staging/lustre/lustre/include/lustre_net.h b/drivers/staging/lustre/lustre/include/lustre_net.h
index d5debd615..ea5c42e68 100644
--- a/drivers/staging/lustre/lustre/include/lustre_net.h
+++ b/drivers/staging/lustre/lustre/include/lustre_net.h
@@ -2641,7 +2641,7 @@ void *lustre_msg_buf_v2(struct lustre_msg_v2 *m, int n, int min_size);
 void *lustre_msg_buf(struct lustre_msg *m, int n, int minlen);
 int lustre_msg_buflen(struct lustre_msg *m, int n);
 int lustre_msg_bufcount(struct lustre_msg *m);
-char *lustre_msg_string(struct lustre_msg *m, int n, int max_len);
+void *lustre_msg_string(struct lustre_msg *m, int n, int max_len);
 __u32 lustre_msghdr_get_flags(struct lustre_msg *msg);
 void lustre_msghdr_set_flags(struct lustre_msg *msg, __u32 flags);
 __u32 lustre_msg_get_flags(struct lustre_msg *msg);
diff --git a/drivers/staging/lustre/lustre/include/obd.h b/drivers/staging/lustre/lustre/include/obd.h
index a1bc2c478..6cd1797b8 100644
--- a/drivers/staging/lustre/lustre/include/obd.h
+++ b/drivers/staging/lustre/lustre/include/obd.h
@@ -1133,7 +1133,7 @@ struct md_ops {
 	 * lprocfs_alloc_md_stats() in obdclass/lprocfs_status.c. Also, add a
 	 * wrapper function in include/linux/obd_class.h.
 	 */
-};
+} __no_const;
 
 struct lsm_operations {
 	void (*lsm_free)(struct lov_stripe_md *);
diff --git a/drivers/staging/lustre/lustre/ldlm/ldlm_flock.c b/drivers/staging/lustre/lustre/ldlm/ldlm_flock.c
index d6b61bc39..3e4f655d8 100644
--- a/drivers/staging/lustre/lustre/ldlm/ldlm_flock.c
+++ b/drivers/staging/lustre/lustre/ldlm/ldlm_flock.c
@@ -143,7 +143,7 @@ static int ldlm_process_flock_lock(struct ldlm_lock *req, __u64 *flags,
 	int added = (mode == LCK_NL);
 	int overlaps = 0;
 	int splitted = 0;
-	const struct ldlm_callback_suite null_cbs = { NULL };
+	const struct ldlm_callback_suite null_cbs = { };
 
 	CDEBUG(D_DLMTRACE,
 	       "flags %#llx owner %llu pid %u mode %u start %llu end %llu\n",
diff --git a/drivers/staging/lustre/lustre/ldlm/ldlm_request.c b/drivers/staging/lustre/lustre/ldlm/ldlm_request.c
index af487f993..533b12129 100644
--- a/drivers/staging/lustre/lustre/ldlm/ldlm_request.c
+++ b/drivers/staging/lustre/lustre/ldlm/ldlm_request.c
@@ -1853,8 +1853,9 @@ static int ldlm_chain_lock_for_replay(struct ldlm_lock *lock, void *closure)
 
 static int replay_lock_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct ldlm_async_args *aa, int rc)
+				 void *_aa, int rc)
 {
+	struct ldlm_async_args *aa = _aa;
 	struct ldlm_lock     *lock;
 	struct ldlm_reply    *reply;
 	struct obd_export    *exp;
@@ -1981,7 +1982,7 @@ static int replay_one_lock(struct obd_import *imp, struct ldlm_lock *lock)
 	CLASSERT(sizeof(*aa) <= sizeof(req->rq_async_args));
 	aa = ptlrpc_req_async_args(req);
 	aa->lock_handle = body->lock_handle[0];
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)replay_lock_interpret;
+	req->rq_interpret_reply = replay_lock_interpret;
 	ptlrpcd_add_req(req);
 
 	return 0;
diff --git a/drivers/staging/lustre/lustre/llite/dir.c b/drivers/staging/lustre/lustre/llite/dir.c
index 5b381779c..929e628bf 100644
--- a/drivers/staging/lustre/lustre/llite/dir.c
+++ b/drivers/staging/lustre/lustre/llite/dir.c
@@ -136,7 +136,7 @@
  */
 
 /* returns the page unlocked, but with a reference */
-static int ll_dir_filler(void *_hash, struct page *page0)
+static int ll_dir_filler(struct file *_hash, struct page *page0)
 {
 	struct inode *inode = page0->mapping->host;
 	int hash64 = ll_i2sbi(inode)->ll_flags & LL_SBI_64BIT_HASH;
diff --git a/drivers/staging/lustre/lustre/llite/llite_internal.h b/drivers/staging/lustre/lustre/llite/llite_internal.h
index 4d6d589a1..f0268e92e 100644
--- a/drivers/staging/lustre/lustre/llite/llite_internal.h
+++ b/drivers/staging/lustre/lustre/llite/llite_internal.h
@@ -478,13 +478,13 @@ struct ll_sb_info {
 
 	/* metadata stat-ahead */
 	unsigned int	      ll_sa_max;     /* max statahead RPCs */
-	atomic_t		  ll_sa_total;   /* statahead thread started
+	atomic_unchecked_t	  ll_sa_total;   /* statahead thread started
 						  * count
 						  */
-	atomic_t		  ll_sa_wrong;   /* statahead thread stopped for
+	atomic_unchecked_t	  ll_sa_wrong;   /* statahead thread stopped for
 						  * low hit ratio
 						  */
-	atomic_t		  ll_agl_total;  /* AGL thread started count */
+	atomic_unchecked_t	  ll_agl_total;  /* AGL thread started count */
 
 	dev_t			  ll_sdev_orig; /* save s_dev before assign for
 						 * clustered nfs
diff --git a/drivers/staging/lustre/lustre/llite/llite_lib.c b/drivers/staging/lustre/lustre/llite/llite_lib.c
index 546063e72..5955697c2 100644
--- a/drivers/staging/lustre/lustre/llite/llite_lib.c
+++ b/drivers/staging/lustre/lustre/llite/llite_lib.c
@@ -113,9 +113,9 @@ static struct ll_sb_info *ll_init_sbi(struct super_block *sb)
 
 	/* metadata statahead is enabled by default */
 	sbi->ll_sa_max = LL_SA_RPC_DEF;
-	atomic_set(&sbi->ll_sa_total, 0);
-	atomic_set(&sbi->ll_sa_wrong, 0);
-	atomic_set(&sbi->ll_agl_total, 0);
+	atomic_set_unchecked(&sbi->ll_sa_total, 0);
+	atomic_set_unchecked(&sbi->ll_sa_wrong, 0);
+	atomic_set_unchecked(&sbi->ll_agl_total, 0);
 	sbi->ll_flags |= LL_SBI_AGL_ENABLED;
 
 	sbi->ll_sb = sb;
diff --git a/drivers/staging/lustre/lustre/llite/lproc_llite.c b/drivers/staging/lustre/lustre/llite/lproc_llite.c
index e86bf3c53..c2a3f3985 100644
--- a/drivers/staging/lustre/lustre/llite/lproc_llite.c
+++ b/drivers/staging/lustre/lustre/llite/lproc_llite.c
@@ -680,9 +680,9 @@ static int ll_statahead_stats_seq_show(struct seq_file *m, void *v)
 		   "statahead total: %u\n"
 		   "statahead wrong: %u\n"
 		   "agl total: %u\n",
-		   atomic_read(&sbi->ll_sa_total),
-		   atomic_read(&sbi->ll_sa_wrong),
-		   atomic_read(&sbi->ll_agl_total));
+		   atomic_read_unchecked(&sbi->ll_sa_total),
+		   atomic_read_unchecked(&sbi->ll_sa_wrong),
+		   atomic_read_unchecked(&sbi->ll_agl_total));
 	return 0;
 }
 
diff --git a/drivers/staging/lustre/lustre/llite/statahead.c b/drivers/staging/lustre/lustre/llite/statahead.c
index c1cb6b19e..62f954bec 100644
--- a/drivers/staging/lustre/lustre/llite/statahead.c
+++ b/drivers/staging/lustre/lustre/llite/statahead.c
@@ -945,7 +945,7 @@ static int ll_agl_thread(void *arg)
 	CDEBUG(D_READA, "agl thread started: sai %p, parent %pd\n",
 	       sai, parent);
 
-	atomic_inc(&sbi->ll_agl_total);
+	atomic_inc_unchecked(&sbi->ll_agl_total);
 	spin_lock(&plli->lli_agl_lock);
 	sai->sai_agl_valid = 1;
 	if (thread_is_init(thread))
@@ -1049,7 +1049,7 @@ static int ll_statahead_thread(void *arg)
 	if (sbi->ll_flags & LL_SBI_AGL_ENABLED)
 		ll_start_agl(parent, sai);
 
-	atomic_inc(&sbi->ll_sa_total);
+	atomic_inc_unchecked(&sbi->ll_sa_total);
 	spin_lock(&plli->lli_sa_lock);
 	if (thread_is_init(thread))
 		/* If someone else has changed the thread state
@@ -1472,7 +1472,7 @@ ll_sai_unplug(struct ll_statahead_info *sai, struct ll_sa_entry *entry)
 		sai->sai_miss++;
 		sai->sai_consecutive_miss++;
 		if (sa_low_hit(sai) && thread_is_running(thread)) {
-			atomic_inc(&sbi->ll_sa_wrong);
+			atomic_inc_unchecked(&sbi->ll_sa_wrong);
 			CDEBUG(D_READA, "Statahead for dir " DFID " hit ratio too low: hit/miss %llu/%llu, sent/replied %llu/%llu, stopping statahead thread\n",
 			       PFID(&lli->lli_fid), sai->sai_hit,
 			       sai->sai_miss, sai->sai_sent,
diff --git a/drivers/staging/lustre/lustre/lov/lov_internal.h b/drivers/staging/lustre/lustre/lov/lov_internal.h
index 12bd511e8..45e526d3f 100644
--- a/drivers/staging/lustre/lustre/lov/lov_internal.h
+++ b/drivers/staging/lustre/lustre/lov/lov_internal.h
@@ -107,9 +107,9 @@ struct lov_request_set {
 	 */
 	struct obd_device		*set_obd;
 	int				set_count;
-	atomic_t			set_completes;
-	atomic_t			set_success;
-	atomic_t			set_finish_checked;
+	atomic_unchecked_t		set_completes;
+	atomic_unchecked_t		set_success;
+	atomic_unchecked_t		set_finish_checked;
 	struct llog_cookie		*set_cookies;
 	int				set_cookie_sent;
 	struct list_head			set_list;
diff --git a/drivers/staging/lustre/lustre/lov/lov_io.c b/drivers/staging/lustre/lustre/lov/lov_io.c
index 84032a510..8aa608577 100644
--- a/drivers/staging/lustre/lustre/lov/lov_io.c
+++ b/drivers/staging/lustre/lustre/lov/lov_io.c
@@ -810,12 +810,32 @@ static void lov_empty_io_fini(const struct lu_env *env,
 }
 
 static void lov_empty_impossible(const struct lu_env *env,
-				 struct cl_io_slice *ios)
+				 const struct cl_io_slice *ios)
 {
 	LBUG();
 }
 
-#define LOV_EMPTY_IMPOSSIBLE ((void *)lov_empty_impossible)
+static int lov_empty_impossible2(const struct lu_env *env,
+				 const struct cl_io_slice *ios)
+{
+	LBUG();
+}
+
+static int lov_empty_impossible3(const struct lu_env *env,
+				 const struct cl_io_slice *slice,
+				 enum cl_req_type crt,
+				 struct cl_2queue *queue)
+{
+	LBUG();
+}
+
+static int lov_empty_impossible4(const struct lu_env *env,
+				 const struct cl_io_slice *slice,
+				 struct cl_page_list *queue, int from, int to,
+				 cl_commit_cbt cb)
+{
+	LBUG();
+}
 
 /**
  * An io operation vector for files without stripes.
@@ -825,32 +845,32 @@ static const struct cl_io_operations lov_empty_io_ops = {
 		[CIT_READ] = {
 			.cio_fini       = lov_empty_io_fini,
 #if 0
-			.cio_iter_init  = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock       = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end	= LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init  = lov_empty_impossible2,
+			.cio_lock       = lov_empty_impossible2,
+			.cio_start      = lov_empty_impossible2,
+			.cio_end	= lov_empty_impossible
 #endif
 		},
 		[CIT_WRITE] = {
 			.cio_fini      = lov_empty_io_fini,
-			.cio_iter_init = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start     = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end       = LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init = lov_empty_impossible2,
+			.cio_lock      = lov_empty_impossible2,
+			.cio_start     = lov_empty_impossible2,
+			.cio_end       = lov_empty_impossible
 		},
 		[CIT_SETATTR] = {
 			.cio_fini      = lov_empty_io_fini,
-			.cio_iter_init = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start     = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end       = LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init = lov_empty_impossible2,
+			.cio_lock      = lov_empty_impossible2,
+			.cio_start     = lov_empty_impossible2,
+			.cio_end       = lov_empty_impossible
 		},
 		[CIT_FAULT] = {
 			.cio_fini      = lov_empty_io_fini,
-			.cio_iter_init = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start     = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end       = LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init = lov_empty_impossible2,
+			.cio_lock      = lov_empty_impossible2,
+			.cio_start     = lov_empty_impossible2,
+			.cio_end       = lov_empty_impossible
 		},
 		[CIT_FSYNC] = {
 			.cio_fini   = lov_empty_io_fini
@@ -859,8 +879,8 @@ static const struct cl_io_operations lov_empty_io_ops = {
 			.cio_fini   = lov_empty_io_fini
 		}
 	},
-	.cio_submit                    = LOV_EMPTY_IMPOSSIBLE,
-	.cio_commit_async              = LOV_EMPTY_IMPOSSIBLE
+	.cio_submit                    = lov_empty_impossible3,
+	.cio_commit_async              = lov_empty_impossible4
 };
 
 int lov_io_init_raid0(const struct lu_env *env, struct cl_object *obj,
diff --git a/drivers/staging/lustre/lustre/lov/lov_obd.c b/drivers/staging/lustre/lustre/lov/lov_obd.c
index 9b92d5522..0d56df135 100644
--- a/drivers/staging/lustre/lustre/lov/lov_obd.c
+++ b/drivers/staging/lustre/lustre/lov/lov_obd.c
@@ -1126,7 +1126,7 @@ static int lov_getattr_interpret(struct ptlrpc_request_set *rqset,
 
 	/* don't do attribute merge if this async op failed */
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 	err = lov_fini_getattr_set(lovset);
 	return rc ? rc : err;
 }
@@ -1181,7 +1181,7 @@ static int lov_getattr_async(struct obd_export *exp, struct obd_info *oinfo,
 	}
 out:
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 	err = lov_fini_getattr_set(lovset);
 	return rc ? rc : err;
 }
@@ -1193,7 +1193,7 @@ static int lov_setattr_interpret(struct ptlrpc_request_set *rqset,
 	int err;
 
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 	err = lov_fini_setattr_set(lovset);
 	return rc ? rc : err;
 }
@@ -1255,7 +1255,7 @@ static int lov_setattr_async(struct obd_export *exp, struct obd_info *oinfo,
 		int err;
 
 		if (rc)
-			atomic_set(&set->set_completes, 0);
+			atomic_set_unchecked(&set->set_completes, 0);
 		err = lov_fini_setattr_set(set);
 		return rc ? rc : err;
 	}
@@ -1313,7 +1313,7 @@ int lov_statfs_interpret(struct ptlrpc_request_set *rqset, void *data, int rc)
 	int err;
 
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 
 	err = lov_fini_statfs_set(lovset);
 	return rc ? rc : err;
@@ -1346,7 +1346,7 @@ static int lov_statfs_async(struct obd_export *exp, struct obd_info *oinfo,
 		int err;
 
 		if (rc)
-			atomic_set(&set->set_completes, 0);
+			atomic_set_unchecked(&set->set_completes, 0);
 		err = lov_fini_statfs_set(set);
 		return rc ? rc : err;
 	}
diff --git a/drivers/staging/lustre/lustre/lov/lov_request.c b/drivers/staging/lustre/lustre/lov/lov_request.c
index 4099b51f8..bb809b2bd 100644
--- a/drivers/staging/lustre/lustre/lov/lov_request.c
+++ b/drivers/staging/lustre/lustre/lov/lov_request.c
@@ -41,9 +41,9 @@
 static void lov_init_set(struct lov_request_set *set)
 {
 	set->set_count = 0;
-	atomic_set(&set->set_completes, 0);
-	atomic_set(&set->set_success, 0);
-	atomic_set(&set->set_finish_checked, 0);
+	atomic_set_unchecked(&set->set_completes, 0);
+	atomic_set_unchecked(&set->set_success, 0);
+	atomic_set_unchecked(&set->set_finish_checked, 0);
 	set->set_cookies = NULL;
 	INIT_LIST_HEAD(&set->set_list);
 	atomic_set(&set->set_refcount, 1);
@@ -71,14 +71,14 @@ void lov_finish_set(struct lov_request_set *set)
 
 static int lov_set_finished(struct lov_request_set *set, int idempotent)
 {
-	int completes = atomic_read(&set->set_completes);
+	int completes = atomic_read_unchecked(&set->set_completes);
 
 	CDEBUG(D_INFO, "check set %d/%d\n", completes, set->set_count);
 
 	if (completes == set->set_count) {
 		if (idempotent)
 			return 1;
-		if (atomic_inc_return(&set->set_finish_checked) == 1)
+		if (atomic_inc_return_unchecked(&set->set_finish_checked) == 1)
 			return 1;
 	}
 	return 0;
@@ -90,9 +90,9 @@ static void lov_update_set(struct lov_request_set *set,
 	req->rq_complete = 1;
 	req->rq_rc = rc;
 
-	atomic_inc(&set->set_completes);
+	atomic_inc_unchecked(&set->set_completes);
 	if (rc == 0)
-		atomic_inc(&set->set_success);
+		atomic_inc_unchecked(&set->set_success);
 
 	wake_up(&set->set_waitq);
 }
@@ -192,7 +192,7 @@ static int common_attr_done(struct lov_request_set *set)
 	if (!set->set_oi->oi_oa)
 		return 0;
 
-	if (!atomic_read(&set->set_success))
+	if (!atomic_read_unchecked(&set->set_success))
 		return -EIO;
 
 	tmp_oa = kmem_cache_zalloc(obdo_cachep, GFP_NOFS);
@@ -239,7 +239,7 @@ int lov_fini_getattr_set(struct lov_request_set *set)
 	if (!set)
 		return 0;
 	LASSERT(set->set_exp);
-	if (atomic_read(&set->set_completes))
+	if (atomic_read_unchecked(&set->set_completes))
 		rc = common_attr_done(set);
 
 	lov_put_reqset(set);
@@ -330,7 +330,7 @@ int lov_fini_destroy_set(struct lov_request_set *set)
 	if (!set)
 		return 0;
 	LASSERT(set->set_exp);
-	if (atomic_read(&set->set_completes)) {
+	if (atomic_read_unchecked(&set->set_completes)) {
 		/* FIXME update qos data here */
 	}
 
@@ -410,7 +410,7 @@ int lov_fini_setattr_set(struct lov_request_set *set)
 	if (!set)
 		return 0;
 	LASSERT(set->set_exp);
-	if (atomic_read(&set->set_completes)) {
+	if (atomic_read_unchecked(&set->set_completes)) {
 		rc = common_attr_done(set);
 		/* FIXME update qos data here */
 	}
@@ -571,9 +571,9 @@ int lov_fini_statfs_set(struct lov_request_set *set)
 	if (!set)
 		return 0;
 
-	if (atomic_read(&set->set_completes)) {
+	if (atomic_read_unchecked(&set->set_completes)) {
 		rc = lov_fini_statfs(set->set_obd, set->set_oi->oi_osfs,
-				     atomic_read(&set->set_success));
+				     atomic_read_unchecked(&set->set_success));
 	}
 	lov_put_reqset(set);
 	return rc;
@@ -654,7 +654,7 @@ static int cb_statfs_update(void *cookie, int rc)
 	lov = &lovobd->u.lov;
 	osfs = set->set_oi->oi_osfs;
 	lov_sfs = oinfo->oi_osfs;
-	success = atomic_read(&set->set_success);
+	success = atomic_read_unchecked(&set->set_success);
 	/* XXX: the same is done in lov_update_common_set, however
 	 * lovset->set_exp is not initialized.
 	 */
@@ -682,7 +682,7 @@ out:
 	if (set->set_oi->oi_flags & OBD_STATFS_PTLRPCD &&
 	    lov_set_finished(set, 0)) {
 		lov_statfs_interpret(NULL, set, set->set_count !=
-				     atomic_read(&set->set_success));
+				     atomic_read_unchecked(&set->set_success));
 	}
 
 	return 0;
diff --git a/drivers/staging/lustre/lustre/obdclass/llog_swab.c b/drivers/staging/lustre/lustre/obdclass/llog_swab.c
index f7b9b1903..cb5810590 100644
--- a/drivers/staging/lustre/lustre/obdclass/llog_swab.c
+++ b/drivers/staging/lustre/lustre/obdclass/llog_swab.c
@@ -54,16 +54,20 @@ static void print_llogd_body(struct llogd_body *d)
 	CDEBUG(D_OTHER, "\tlgd_cur_offset: %#llx\n", d->lgd_cur_offset);
 }
 
-void lustre_swab_lu_fid(struct lu_fid *fid)
+void lustre_swab_lu_fid(void *_fid)
 {
+	struct lu_fid *fid = _fid;
+
 	__swab64s(&fid->f_seq);
 	__swab32s(&fid->f_oid);
 	__swab32s(&fid->f_ver);
 }
 EXPORT_SYMBOL(lustre_swab_lu_fid);
 
-void lustre_swab_ost_id(struct ost_id *oid)
+void lustre_swab_ost_id(void *_oid)
 {
+	struct ost_id *oid = _oid;
+
 	if (fid_seq_is_mdt0(oid->oi.oi_seq)) {
 		__swab64s(&oid->oi.oi_id);
 		__swab64s(&oid->oi.oi_seq);
@@ -80,8 +84,10 @@ static void lustre_swab_llog_id(struct llog_logid *log_id)
 	__swab32s(&log_id->lgl_ogen);
 }
 
-void lustre_swab_llogd_body(struct llogd_body *d)
+void lustre_swab_llogd_body(void *_d)
 {
+	struct llogd_body *d = _d;
+
 	print_llogd_body(d);
 	lustre_swab_llog_id(&d->lgd_logid);
 	__swab32s(&d->lgd_ctxt_idx);
@@ -94,8 +100,10 @@ void lustre_swab_llogd_body(struct llogd_body *d)
 }
 EXPORT_SYMBOL(lustre_swab_llogd_body);
 
-void lustre_swab_llogd_conn_body(struct llogd_conn_body *d)
+void lustre_swab_llogd_conn_body(void *_d)
 {
+	struct llogd_conn_body *d = _d;
+
 	__swab64s(&d->lgdc_gen.mnt_cnt);
 	__swab64s(&d->lgdc_gen.conn_cnt);
 	lustre_swab_llog_id(&d->lgdc_logid);
@@ -110,8 +118,10 @@ static void lustre_swab_ll_fid(struct ll_fid *fid)
 	__swab32s(&fid->f_type);
 }
 
-void lustre_swab_lu_seq_range(struct lu_seq_range *range)
+void lustre_swab_lu_seq_range(void *_range)
 {
+	struct lu_seq_range *range = _range;
+
 	__swab64s(&range->lsr_start);
 	__swab64s(&range->lsr_end);
 	__swab32s(&range->lsr_index);
@@ -290,8 +300,10 @@ static void print_llog_hdr(struct llog_log_hdr *h)
 	CDEBUG(D_OTHER, "\tllh_tail.lrt_len: %#x\n", h->llh_tail.lrt_len);
 }
 
-void lustre_swab_llog_hdr(struct llog_log_hdr *h)
+void lustre_swab_llog_hdr(void *_h)
 {
+	struct llog_log_hdr *h = _h;
+
 	print_llog_hdr(h);
 
 	lustre_swab_llog_rec(&h->llh_hdr);
diff --git a/drivers/staging/lustre/lustre/osc/osc_request.c b/drivers/staging/lustre/lustre/osc/osc_request.c
index 536b868ff..6aeaeae80 100644
--- a/drivers/staging/lustre/lustre/osc/osc_request.c
+++ b/drivers/staging/lustre/lustre/osc/osc_request.c
@@ -208,8 +208,9 @@ static inline void osc_pack_req_body(struct ptlrpc_request *req,
 
 static int osc_getattr_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct osc_async_args *aa, int rc)
+				 void *_aa, int rc)
 {
+	struct osc_async_args *aa = _aa;
 	struct ost_body *body;
 
 	if (rc != 0)
@@ -254,7 +255,7 @@ static int osc_getattr_async(struct obd_export *exp, struct obd_info *oinfo,
 	osc_pack_req_body(req, oinfo);
 
 	ptlrpc_request_set_replen(req);
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)osc_getattr_interpret;
+	req->rq_interpret_reply = osc_getattr_interpret;
 
 	CLASSERT(sizeof(*aa) <= sizeof(req->rq_async_args));
 	aa = ptlrpc_req_async_args(req);
@@ -350,8 +351,9 @@ out:
 
 static int osc_setattr_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct osc_setattr_args *sa, int rc)
+				 void *_sa, int rc)
 {
+	struct osc_setattr_args *sa = _sa;
 	struct ost_body *body;
 
 	if (rc != 0)
@@ -401,8 +403,7 @@ int osc_setattr_async_base(struct obd_export *exp, struct obd_info *oinfo,
 		/* Do not wait for response. */
 		ptlrpcd_add_req(req);
 	} else {
-		req->rq_interpret_reply =
-			(ptlrpc_interpterer_t)osc_setattr_interpret;
+		req->rq_interpret_reply = osc_setattr_interpret;
 
 		CLASSERT(sizeof(*sa) <= sizeof(req->rq_async_args));
 		sa = ptlrpc_req_async_args(req);
@@ -545,7 +546,7 @@ int osc_punch_base(struct obd_export *exp, struct obd_info *oinfo,
 
 	ptlrpc_request_set_replen(req);
 
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)osc_setattr_interpret;
+	req->rq_interpret_reply = osc_setattr_interpret;
 	CLASSERT(sizeof(*sa) <= sizeof(req->rq_async_args));
 	sa = ptlrpc_req_async_args(req);
 	sa->sa_oa = oinfo->oi_oa;
@@ -2174,8 +2175,9 @@ static int osc_enqueue_fini(struct ptlrpc_request *req,
 
 static int osc_enqueue_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct osc_enqueue_args *aa, int rc)
+				 void *_aa, int rc)
 {
+	struct osc_enqueue_args *aa = _aa;
 	struct ldlm_lock *lock;
 	struct lustre_handle *lockh = &aa->oa_lockh;
 	enum ldlm_mode mode = aa->oa_mode;
@@ -2366,8 +2368,7 @@ no_match:
 				aa->oa_flags = NULL;
 			}
 
-			req->rq_interpret_reply =
-				(ptlrpc_interpterer_t)osc_enqueue_interpret;
+			req->rq_interpret_reply = osc_enqueue_interpret;
 			if (rqset == PTLRPCD_SET)
 				ptlrpcd_add_req(req);
 			else
@@ -2443,8 +2444,9 @@ int osc_cancel_base(struct lustre_handle *lockh, __u32 mode)
 
 static int osc_statfs_interpret(const struct lu_env *env,
 				struct ptlrpc_request *req,
-				struct osc_async_args *aa, int rc)
+				void *_aa, int rc)
 {
+	struct osc_async_args *aa = _aa;
 	struct obd_statfs *msfs;
 
 	if (rc == -EBADR)
@@ -2512,7 +2514,7 @@ static int osc_statfs_async(struct obd_export *exp,
 		req->rq_no_delay = 1;
 	}
 
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)osc_statfs_interpret;
+	req->rq_interpret_reply = osc_statfs_interpret;
 	CLASSERT(sizeof(*aa) <= sizeof(req->rq_async_args));
 	aa = ptlrpc_req_async_args(req);
 	aa->aa_oi = oinfo;
diff --git a/drivers/staging/lustre/lustre/ptlrpc/layout.c b/drivers/staging/lustre/lustre/ptlrpc/layout.c
index ab5d85174..12e23ddcb 100644
--- a/drivers/staging/lustre/lustre/ptlrpc/layout.c
+++ b/drivers/staging/lustre/lustre/ptlrpc/layout.c
@@ -781,8 +781,8 @@ struct req_capsule;
 	.rmf_name    = (name),					\
 	.rmf_flags   = (flags),					\
 	.rmf_size    = (size),					\
-	.rmf_swabber = (void (*)(void *))(swabber),		\
-	.rmf_dumper  = (void (*)(void *))(dumper)		\
+	.rmf_swabber = (swabber),				\
+	.rmf_dumper  = (dumper)					\
 }
 
 struct req_msg_field RMF_GENERIC_DATA =
@@ -1889,8 +1889,7 @@ static void *__req_capsule_get(struct req_capsule *pill,
 	msg = __req_msg(pill, loc);
 	LASSERT(msg);
 
-	getter = (field->rmf_flags & RMF_F_STRING) ?
-		(typeof(getter))lustre_msg_string : lustre_msg_buf;
+	getter = (field->rmf_flags & RMF_F_STRING) ?  lustre_msg_string : lustre_msg_buf;
 
 	if (field->rmf_flags & RMF_F_STRUCT_ARRAY) {
 		/*
diff --git a/drivers/staging/lustre/lustre/ptlrpc/pack_generic.c b/drivers/staging/lustre/lustre/ptlrpc/pack_generic.c
index b514f18fa..dd4b44ffd 100644
--- a/drivers/staging/lustre/lustre/ptlrpc/pack_generic.c
+++ b/drivers/staging/lustre/lustre/ptlrpc/pack_generic.c
@@ -689,7 +689,7 @@ int lustre_msg_bufcount(struct lustre_msg *m)
 }
 EXPORT_SYMBOL(lustre_msg_bufcount);
 
-char *lustre_msg_string(struct lustre_msg *m, int index, int max_len)
+void *lustre_msg_string(struct lustre_msg *m, int index, int max_len)
 {
 	/* max_len == 0 means the string should fill the buffer */
 	char *str;
@@ -1461,8 +1461,10 @@ EXPORT_SYMBOL(do_set_info_async);
 /* byte flipping routines for all wire types declared in
  * lustre_idl.h implemented here.
  */
-void lustre_swab_ptlrpc_body(struct ptlrpc_body *b)
+void lustre_swab_ptlrpc_body(void *_b)
 {
+	struct ptlrpc_body *b = _b;
+
 	__swab32s(&b->pb_type);
 	__swab32s(&b->pb_version);
 	__swab32s(&b->pb_opc);
@@ -1493,8 +1495,10 @@ void lustre_swab_ptlrpc_body(struct ptlrpc_body *b)
 }
 EXPORT_SYMBOL(lustre_swab_ptlrpc_body);
 
-void lustre_swab_connect(struct obd_connect_data *ocd)
+void lustre_swab_connect(void *_ocd)
 {
+	struct obd_connect_data *ocd = _ocd;
+
 	__swab64s(&ocd->ocd_connect_flags);
 	__swab32s(&ocd->ocd_version);
 	__swab32s(&ocd->ocd_grant);
@@ -1568,8 +1572,10 @@ static void lustre_swab_obdo(struct obdo *o)
 	CLASSERT(offsetof(typeof(*o), o_padding_6) != 0);
 }
 
-void lustre_swab_obd_statfs(struct obd_statfs *os)
+void lustre_swab_obd_statfs(void *_os)
 {
+	struct obd_statfs *os = _os;
+
 	__swab64s(&os->os_type);
 	__swab64s(&os->os_blocks);
 	__swab64s(&os->os_bfree);
@@ -1593,42 +1599,54 @@ void lustre_swab_obd_statfs(struct obd_statfs *os)
 }
 EXPORT_SYMBOL(lustre_swab_obd_statfs);
 
-void lustre_swab_obd_ioobj(struct obd_ioobj *ioo)
+void lustre_swab_obd_ioobj(void *_ioo)
 {
+	struct obd_ioobj *ioo = _ioo;
+
 	lustre_swab_ost_id(&ioo->ioo_oid);
 	__swab32s(&ioo->ioo_max_brw);
 	__swab32s(&ioo->ioo_bufcnt);
 }
 EXPORT_SYMBOL(lustre_swab_obd_ioobj);
 
-void lustre_swab_niobuf_remote(struct niobuf_remote *nbr)
+void lustre_swab_niobuf_remote(void *_nbr)
 {
+	struct niobuf_remote *nbr = _nbr;
+
 	__swab64s(&nbr->offset);
 	__swab32s(&nbr->len);
 	__swab32s(&nbr->flags);
 }
 EXPORT_SYMBOL(lustre_swab_niobuf_remote);
 
-void lustre_swab_ost_body(struct ost_body *b)
+void lustre_swab_ost_body(void *_b)
 {
+	struct ost_body *b = _b;
+
 	lustre_swab_obdo(&b->oa);
 }
 EXPORT_SYMBOL(lustre_swab_ost_body);
 
-void lustre_swab_ost_last_id(u64 *id)
+void lustre_swab_ost_last_id(void *_id)
 {
+	u64 *id = _id;
+
 	__swab64s(id);
 }
 EXPORT_SYMBOL(lustre_swab_ost_last_id);
 
-void lustre_swab_generic_32s(__u32 *val)
+void lustre_swab_generic_32s(void *_val)
 {
+	__u32 *val = _val;
+
 	__swab32s(val);
 }
 EXPORT_SYMBOL(lustre_swab_generic_32s);
 
-void lustre_swab_gl_desc(union ldlm_gl_desc *desc)
+void lustre_swab_gl_desc(void *_desc)
 {
+	union ldlm_gl_desc *desc = _desc;
+
 	lustre_swab_lu_fid(&desc->lquota_desc.gl_id.qid_fid);
 	__swab64s(&desc->lquota_desc.gl_flags);
 	__swab64s(&desc->lquota_desc.gl_ver);
@@ -1672,8 +1690,10 @@ void lustre_swab_lquota_lvb(struct lquota_lvb *lvb)
 }
 EXPORT_SYMBOL(lustre_swab_lquota_lvb);
 
-void lustre_swab_mdt_body(struct mdt_body *b)
+void lustre_swab_mdt_body(void *_b)
 {
+	struct mdt_body *b = _b;
+
 	lustre_swab_lu_fid(&b->fid1);
 	lustre_swab_lu_fid(&b->fid2);
 	/* handle is opaque */
@@ -1706,8 +1726,10 @@ void lustre_swab_mdt_body(struct mdt_body *b)
 }
 EXPORT_SYMBOL(lustre_swab_mdt_body);
 
-void lustre_swab_mdt_ioepoch(struct mdt_ioepoch *b)
+void lustre_swab_mdt_ioepoch(void *_b)
 {
+	struct mdt_ioepoch *b = _b;
+
 	/* handle is opaque */
 	 __swab64s(&b->ioepoch);
 	 __swab32s(&b->flags);
@@ -1715,8 +1737,9 @@ void lustre_swab_mdt_ioepoch(struct mdt_ioepoch *b)
 }
 EXPORT_SYMBOL(lustre_swab_mdt_ioepoch);
 
-void lustre_swab_mgs_target_info(struct mgs_target_info *mti)
+void lustre_swab_mgs_target_info(void *_mti)
 {
+	struct mgs_target_info *mti = _mti;
 	int i;
 
 	__swab32s(&mti->mti_lustre_ver);
@@ -1754,16 +1777,20 @@ void lustre_swab_mgs_nidtbl_entry(struct mgs_nidtbl_entry *entry)
 }
 EXPORT_SYMBOL(lustre_swab_mgs_nidtbl_entry);
 
-void lustre_swab_mgs_config_body(struct mgs_config_body *body)
+void lustre_swab_mgs_config_body(void *_body)
 {
+	struct mgs_config_body *body = _body;
+
 	__swab64s(&body->mcb_offset);
 	__swab32s(&body->mcb_units);
 	__swab16s(&body->mcb_type);
 }
 EXPORT_SYMBOL(lustre_swab_mgs_config_body);
 
-void lustre_swab_mgs_config_res(struct mgs_config_res *body)
+void lustre_swab_mgs_config_res(void *_body)
 {
+	struct mgs_config_res *body = _body;
+
 	__swab64s(&body->mcr_offset);
 	__swab64s(&body->mcr_size);
 }
@@ -1791,8 +1818,10 @@ static void lustre_swab_obd_dqblk(struct obd_dqblk *b)
 	CLASSERT(offsetof(typeof(*b), dqb_padding) != 0);
 }
 
-void lustre_swab_obd_quotactl(struct obd_quotactl *q)
+void lustre_swab_obd_quotactl(void *_q)
 {
+	struct obd_quotactl *q = _q;
+
 	__swab32s(&q->qc_cmd);
 	__swab32s(&q->qc_type);
 	__swab32s(&q->qc_id);
@@ -1820,8 +1849,9 @@ static void lustre_swab_fiemap_extent(struct ll_fiemap_extent *fm_extent)
 	__swab32s(&fm_extent->fe_device);
 }
 
-void lustre_swab_fiemap(struct ll_user_fiemap *fiemap)
+void lustre_swab_fiemap(void *_fiemap)
 {
+	struct ll_user_fiemap *fiemap = _fiemap;
 	int i;
 
 	__swab64s(&fiemap->fm_start);
@@ -1836,8 +1866,10 @@ void lustre_swab_fiemap(struct ll_user_fiemap *fiemap)
 }
 EXPORT_SYMBOL(lustre_swab_fiemap);
 
-void lustre_swab_mdt_rec_reint (struct mdt_rec_reint *rr)
+void lustre_swab_mdt_rec_reint (void *_rr)
 {
+	struct mdt_rec_reint *rr = _rr;
+
 	__swab32s(&rr->rr_opcode);
 	__swab32s(&rr->rr_cap);
 	__swab32s(&rr->rr_fsuid);
@@ -1969,8 +2001,10 @@ static void lustre_swab_ldlm_policy_data(ldlm_wire_policy_data_t *d)
 	__swab32s(&d->l_flock.lfw_pid);
 }
 
-void lustre_swab_ldlm_intent(struct ldlm_intent *i)
+void lustre_swab_ldlm_intent(void *_i)
 {
+	struct ldlm_intent *i = _i;
+
 	__swab64s(&i->opc);
 }
 EXPORT_SYMBOL(lustre_swab_ldlm_intent);
@@ -1990,8 +2024,10 @@ static void lustre_swab_ldlm_lock_desc(struct ldlm_lock_desc *l)
 	lustre_swab_ldlm_policy_data(&l->l_policy_data);
 }
 
-void lustre_swab_ldlm_request(struct ldlm_request *rq)
+void lustre_swab_ldlm_request(void *_rq)
 {
+	struct ldlm_request *rq = _rq;
+
 	__swab32s(&rq->lock_flags);
 	lustre_swab_ldlm_lock_desc(&rq->lock_desc);
 	__swab32s(&rq->lock_count);
@@ -1999,8 +2035,10 @@ void lustre_swab_ldlm_request(struct ldlm_request *rq)
 }
 EXPORT_SYMBOL(lustre_swab_ldlm_request);
 
-void lustre_swab_ldlm_reply(struct ldlm_reply *r)
+void lustre_swab_ldlm_reply(void *_r)
 {
+	struct ldlm_reply *r = _r;
+
 	__swab32s(&r->lock_flags);
 	CLASSERT(offsetof(typeof(*r), lock_padding) != 0);
 	lustre_swab_ldlm_lock_desc(&r->lock_desc);
@@ -2011,8 +2049,10 @@ void lustre_swab_ldlm_reply(struct ldlm_reply *r)
 EXPORT_SYMBOL(lustre_swab_ldlm_reply);
 
 /* Dump functions */
-void dump_ioo(struct obd_ioobj *ioo)
+void dump_ioo(void *_ioo)
 {
+	struct obd_ioobj *ioo = _ioo;
+
 	CDEBUG(D_RPCTRACE,
 	       "obd_ioobj: ioo_oid=" DOSTID ", ioo_max_brw=%#x, ioo_bufct=%d\n",
 	       POSTID(&ioo->ioo_oid), ioo->ioo_max_brw,
@@ -2020,8 +2060,10 @@ void dump_ioo(struct obd_ioobj *ioo)
 }
 EXPORT_SYMBOL(dump_ioo);
 
-void dump_rniobuf(struct niobuf_remote *nb)
+void dump_rniobuf(void *_nb)
 {
+	struct niobuf_remote *nb = _nb;
+
 	CDEBUG(D_RPCTRACE, "niobuf_remote: offset=%llu, len=%d, flags=%x\n",
 	       nb->offset, nb->len, nb->flags);
 }
@@ -2089,14 +2131,18 @@ static void dump_obdo(struct obdo *oa)
 		CDEBUG(D_RPCTRACE, "obdo: o_lcookie = (llog_cookie dumping not yet implemented)\n");
 }
 
-void dump_ost_body(struct ost_body *ob)
+void dump_ost_body(void *_ob)
 {
+	struct ost_body *ob = _ob;
+
 	dump_obdo(&ob->oa);
 }
 EXPORT_SYMBOL(dump_ost_body);
 
-void dump_rcs(__u32 *rc)
+void dump_rcs(void *_rc)
 {
+	__u32 *rc = _rc;
+
 	CDEBUG(D_RPCTRACE, "rmf_rcs: %d\n", *rc);
 }
 EXPORT_SYMBOL(dump_rcs);
@@ -2173,8 +2219,10 @@ void _debug_req(struct ptlrpc_request *req,
 }
 EXPORT_SYMBOL(_debug_req);
 
-void lustre_swab_lustre_capa(struct lustre_capa *c)
+void lustre_swab_lustre_capa(void *_c)
 {
+	struct lustre_capa *c = _c;
+
 	lustre_swab_lu_fid(&c->lc_fid);
 	__swab64s(&c->lc_opc);
 	__swab64s(&c->lc_uid);
@@ -2186,15 +2234,19 @@ void lustre_swab_lustre_capa(struct lustre_capa *c)
 }
 EXPORT_SYMBOL(lustre_swab_lustre_capa);
 
-void lustre_swab_hsm_user_state(struct hsm_user_state *state)
+void lustre_swab_hsm_user_state(void *_state)
 {
+	struct hsm_user_state *state = _state;
+
 	__swab32s(&state->hus_states);
 	__swab32s(&state->hus_archive_id);
 }
 EXPORT_SYMBOL(lustre_swab_hsm_user_state);
 
-void lustre_swab_hsm_state_set(struct hsm_state_set *hss)
+void lustre_swab_hsm_state_set(void *_hss)
 {
+	struct hsm_state_set *hss = _hss;
+
 	__swab32s(&hss->hss_valid);
 	__swab64s(&hss->hss_setmask);
 	__swab64s(&hss->hss_clearmask);
@@ -2208,23 +2260,29 @@ static void lustre_swab_hsm_extent(struct hsm_extent *extent)
 	__swab64s(&extent->length);
 }
 
-void lustre_swab_hsm_current_action(struct hsm_current_action *action)
+void lustre_swab_hsm_current_action(void *_action)
 {
+	struct hsm_current_action *action = _action;
+
 	__swab32s(&action->hca_state);
 	__swab32s(&action->hca_action);
 	lustre_swab_hsm_extent(&action->hca_location);
 }
 EXPORT_SYMBOL(lustre_swab_hsm_current_action);
 
-void lustre_swab_hsm_user_item(struct hsm_user_item *hui)
+void lustre_swab_hsm_user_item(void *_hui)
 {
+	struct hsm_user_item *hui = _hui;
+
 	lustre_swab_lu_fid(&hui->hui_fid);
 	lustre_swab_hsm_extent(&hui->hui_extent);
 }
 EXPORT_SYMBOL(lustre_swab_hsm_user_item);
 
-void lustre_swab_layout_intent(struct layout_intent *li)
+void lustre_swab_layout_intent(void *_li)
 {
+	struct layout_intent *li = _li;
+
 	__swab32s(&li->li_opc);
 	__swab32s(&li->li_flags);
 	__swab64s(&li->li_start);
@@ -2232,8 +2290,10 @@ void lustre_swab_layout_intent(struct layout_intent *li)
 }
 EXPORT_SYMBOL(lustre_swab_layout_intent);
 
-void lustre_swab_hsm_progress_kernel(struct hsm_progress_kernel *hpk)
+void lustre_swab_hsm_progress_kernel(void *_hpk)
 {
+	struct hsm_progress_kernel *hpk = _hpk;
+
 	lustre_swab_lu_fid(&hpk->hpk_fid);
 	__swab64s(&hpk->hpk_cookie);
 	__swab64s(&hpk->hpk_extent.offset);
@@ -2243,8 +2303,10 @@ void lustre_swab_hsm_progress_kernel(struct hsm_progress_kernel *hpk)
 }
 EXPORT_SYMBOL(lustre_swab_hsm_progress_kernel);
 
-void lustre_swab_hsm_request(struct hsm_request *hr)
+void lustre_swab_hsm_request(void *_hr)
 {
+	struct hsm_request *hr = _hr;
+
 	__swab32s(&hr->hr_action);
 	__swab32s(&hr->hr_archive_id);
 	__swab64s(&hr->hr_flags);
@@ -2253,14 +2315,18 @@ void lustre_swab_hsm_request(struct hsm_request *hr)
 }
 EXPORT_SYMBOL(lustre_swab_hsm_request);
 
-void lustre_swab_swap_layouts(struct mdc_swap_layouts *msl)
+void lustre_swab_swap_layouts(void *_msl)
 {
+	struct mdc_swap_layouts *msl = _msl;
+
 	__swab64s(&msl->msl_flags);
 }
 EXPORT_SYMBOL(lustre_swab_swap_layouts);
 
-void lustre_swab_close_data(struct close_data *cd)
+void lustre_swab_close_data(void *_cd)
 {
+	struct close_data *cd = _cd;
+
 	lustre_swab_lu_fid(&cd->cd_fid);
 	__swab64s(&cd->cd_data_version);
 }
diff --git a/drivers/staging/rtl8188eu/core/rtw_mlme_ext.c b/drivers/staging/rtl8188eu/core/rtw_mlme_ext.c
index 7f32b39e5..e24cff380 100644
--- a/drivers/staging/rtl8188eu/core/rtw_mlme_ext.c
+++ b/drivers/staging/rtl8188eu/core/rtw_mlme_ext.c
@@ -3978,7 +3978,7 @@ static void init_mlme_ext_priv_value(struct adapter *padapter)
 		_12M_RATE_, _24M_RATE_, 0xff,
 	};
 
-	atomic_set(&pmlmeext->event_seq, 0);
+	atomic_set_unchecked(&pmlmeext->event_seq, 0);
 	pmlmeext->mgnt_seq = 0;/* reset to zero when disconnect at client mode */
 
 	pmlmeext->cur_channel = padapter->registrypriv.channel;
@@ -4171,7 +4171,7 @@ void free_mlme_ext_priv(struct mlme_ext_priv *pmlmeext)
 
 static void _mgt_dispatcher(struct adapter *padapter, struct mlme_handler *ptable, struct recv_frame *precv_frame)
 {
-	u8 bc_addr[ETH_ALEN] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
+	static const u8 bc_addr[ETH_ALEN] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
 	u8 *pframe = precv_frame->rx_data;
 
 	if (ptable->func) {
@@ -4190,7 +4190,7 @@ void mgt_dispatcher(struct adapter *padapter, struct recv_frame *precv_frame)
 #ifdef CONFIG_88EU_AP_MODE
 	struct mlme_priv *pmlmepriv = &padapter->mlmepriv;
 #endif /* CONFIG_88EU_AP_MODE */
-	u8 bc_addr[ETH_ALEN] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
+	static const u8 bc_addr[ETH_ALEN] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
 	u8 *pframe = precv_frame->rx_data;
 	struct sta_info *psta = rtw_get_stainfo(&padapter->stapriv, GetAddr2Ptr(pframe));
 
@@ -4215,7 +4215,7 @@ void mgt_dispatcher(struct adapter *padapter, struct recv_frame *precv_frame)
 
 	index = GetFrameSubType(pframe) >> 4;
 
-	if (index > 13) {
+	if (index > ARRAY_SIZE(mlme_sta_tbl)) {
 		RT_TRACE(_module_rtl871x_mlme_c_, _drv_err_, ("Currently we do not support reserved sub-fr-type=%d\n", index));
 		return;
 	}
@@ -4305,7 +4305,7 @@ void report_survey_event(struct adapter *padapter,
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct survey_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_Survey);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	psurvey_evt = (struct survey_event *)(pevtcmd + sizeof(struct C2HEvent_Header));
 
@@ -4355,7 +4355,7 @@ void report_surveydone_event(struct adapter *padapter)
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct surveydone_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_SurveyDone);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	psurveydone_evt = (struct surveydone_event *)(pevtcmd + sizeof(struct C2HEvent_Header));
 	psurveydone_evt->bss_cnt = pmlmeext->sitesurvey_res.bss_cnt;
@@ -4399,7 +4399,7 @@ void report_join_res(struct adapter *padapter, int res)
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct joinbss_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_JoinBss);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	pjoinbss_evt = (struct joinbss_event *)(pevtcmd + sizeof(struct C2HEvent_Header));
 	memcpy((unsigned char *)(&(pjoinbss_evt->network.network)), &(pmlmeinfo->network), sizeof(struct wlan_bssid_ex));
@@ -4450,7 +4450,7 @@ void report_del_sta_event(struct adapter *padapter, unsigned char *MacAddr, unsi
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct stadel_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_DelSTA);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	pdel_sta_evt = (struct stadel_event *)(pevtcmd + sizeof(struct C2HEvent_Header));
 	memcpy((unsigned char *)(&(pdel_sta_evt->macaddr)), MacAddr, ETH_ALEN);
@@ -4503,7 +4503,7 @@ void report_add_sta_event(struct adapter *padapter, unsigned char *MacAddr, int
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct stassoc_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_AddSTA);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	padd_sta_evt = (struct stassoc_event *)(pevtcmd + sizeof(struct C2HEvent_Header));
 	memcpy((unsigned char *)(&(padd_sta_evt->macaddr)), MacAddr, ETH_ALEN);
diff --git a/drivers/staging/rtl8188eu/hal/rtl8188eu_recv.c b/drivers/staging/rtl8188eu/hal/rtl8188eu_recv.c
index 255d6f215..52553d3f8 100644
--- a/drivers/staging/rtl8188eu/hal/rtl8188eu_recv.c
+++ b/drivers/staging/rtl8188eu/hal/rtl8188eu_recv.c
@@ -30,7 +30,7 @@ int	rtl8188eu_init_recv_priv(struct adapter *padapter)
 	struct recv_buf *precvbuf;
 
 	tasklet_init(&precvpriv->recv_tasklet,
-		     (void(*)(unsigned long))rtl8188eu_recv_tasklet,
+		     rtl8188eu_recv_tasklet,
 		     (unsigned long)padapter);
 
 	/* init recv_buf */
diff --git a/drivers/staging/rtl8188eu/hal/rtl8188eu_xmit.c b/drivers/staging/rtl8188eu/hal/rtl8188eu_xmit.c
index ec21d8c82..1c2e09cbd 100644
--- a/drivers/staging/rtl8188eu/hal/rtl8188eu_xmit.c
+++ b/drivers/staging/rtl8188eu/hal/rtl8188eu_xmit.c
@@ -26,7 +26,7 @@ s32	rtl8188eu_init_xmit_priv(struct adapter *adapt)
 	struct xmit_priv	*pxmitpriv = &adapt->xmitpriv;
 
 	tasklet_init(&pxmitpriv->xmit_tasklet,
-		     (void(*)(unsigned long))rtl8188eu_xmit_tasklet,
+		     rtl8188eu_xmit_tasklet,
 		     (unsigned long)adapt);
 	return _SUCCESS;
 }
diff --git a/drivers/staging/rtl8188eu/include/Hal8188EPhyCfg.h b/drivers/staging/rtl8188eu/include/Hal8188EPhyCfg.h
index 8990748a1..7727f8040 100644
--- a/drivers/staging/rtl8188eu/include/Hal8188EPhyCfg.h
+++ b/drivers/staging/rtl8188eu/include/Hal8188EPhyCfg.h
@@ -200,17 +200,9 @@ void PHY_GetTxPowerLevel8188E(struct adapter *adapter, u32 *powerlevel);
 
 void PHY_ScanOperationBackup8188E(struct adapter *Adapter, u8 Operation);
 
-/*  Call after initialization */
-void ChkFwCmdIoDone(struct adapter *adapter);
-
 /*  BB/MAC/RF other monitor API */
 void PHY_SetRFPathSwitch_8188E(struct adapter *adapter,	bool main);
 
-void PHY_SwitchEphyParameter(struct adapter *adapter);
-
-void PHY_EnableHostClkReq(struct adapter *adapter);
-
-bool SetAntennaConfig92C(struct adapter *adapter, u8 defaultant);
 
 /*--------------------------Exported Function prototype---------------------*/
 
diff --git a/drivers/staging/rtl8188eu/include/hal_intf.h b/drivers/staging/rtl8188eu/include/hal_intf.h
index eaf939bd4..356437b5b 100644
--- a/drivers/staging/rtl8188eu/include/hal_intf.h
+++ b/drivers/staging/rtl8188eu/include/hal_intf.h
@@ -212,7 +212,7 @@ struct hal_ops {
 
 	void (*hal_notch_filter)(struct adapter *adapter, bool enable);
 	void (*hal_reset_security_engine)(struct adapter *adapter);
-};
+} __no_const;
 
 enum rt_eeprom_type {
 	EEPROM_93C46,
@@ -246,7 +246,6 @@ void rtw_hal_sw_led_deinit(struct adapter *padapter);
 u32 rtw_hal_power_on(struct adapter *padapter);
 uint rtw_hal_init(struct adapter *padapter);
 uint rtw_hal_deinit(struct adapter *padapter);
-void rtw_hal_stop(struct adapter *padapter);
 void rtw_hal_set_hwreg(struct adapter *padapter, u8 variable, u8 *val);
 void rtw_hal_get_hwreg(struct adapter *padapter, u8 variable, u8 *val);
 
@@ -275,8 +274,6 @@ void	rtw_hal_free_recv_priv(struct adapter *padapter);
 
 void rtw_hal_update_ra_mask(struct adapter *padapter, u32 mac_id, u8 level);
 void	rtw_hal_add_ra_tid(struct adapter *adapt, u32 bitmap, u8 arg, u8 level);
-void	rtw_hal_clone_data(struct adapter *dst_adapt,
-			   struct adapter *src_adapt);
 
 void rtw_hal_bcn_related_reg_setting(struct adapter *padapter);
 
diff --git a/drivers/staging/rtl8188eu/include/odm_precomp.h b/drivers/staging/rtl8188eu/include/odm_precomp.h
index 9e5fe1777..bdb77bb57 100644
--- a/drivers/staging/rtl8188eu/include/odm_precomp.h
+++ b/drivers/staging/rtl8188eu/include/odm_precomp.h
@@ -70,7 +70,7 @@ void odm_RSSIMonitorCheckCE(struct odm_dm_struct *pDM_Odm);
 void odm_TXPowerTrackingThermalMeterInit(struct odm_dm_struct *pDM_Odm);
 void odm_EdcaTurboCheckCE(struct odm_dm_struct *pDM_Odm);
 void odm_TXPowerTrackingCheckCE(struct odm_dm_struct *pDM_Odm);
-void odm_SwAntDivChkAntSwitchCallback(void *FunctionContext);
+void odm_SwAntDivChkAntSwitchCallback(unsigned long FunctionContext);
 void odm_InitHybridAntDiv(struct odm_dm_struct *pDM_Odm);
 void odm_HwAntDiv(struct odm_dm_struct *pDM_Odm);
 
diff --git a/drivers/staging/rtl8188eu/include/recv_osdep.h b/drivers/staging/rtl8188eu/include/recv_osdep.h
index cad31587c..a1ca486f5 100644
--- a/drivers/staging/rtl8188eu/include/recv_osdep.h
+++ b/drivers/staging/rtl8188eu/include/recv_osdep.h
@@ -30,7 +30,6 @@ void rtw_recv_returnpacket(struct  net_device *cnxt, struct sk_buff *retpkt);
 
 void rtw_handle_tkip_mic_err(struct adapter *padapter, u8 bgroup);
 
-int rtw_init_recv_priv(struct recv_priv *precvpriv, struct adapter *padapter);
 void rtw_free_recv_priv(struct recv_priv *precvpriv);
 
 void rtw_os_recv_resource_alloc(struct recv_frame *recvfr);
diff --git a/drivers/staging/rtl8188eu/include/rtl8188e_recv.h b/drivers/staging/rtl8188eu/include/rtl8188e_recv.h
index 54048bc82..e86fdf487 100644
--- a/drivers/staging/rtl8188eu/include/rtl8188e_recv.h
+++ b/drivers/staging/rtl8188eu/include/rtl8188e_recv.h
@@ -54,7 +54,7 @@ enum rx_packet_type {
 s32 rtl8188eu_init_recv_priv(struct adapter *padapter);
 void rtl8188eu_free_recv_priv(struct adapter *padapter);
 void rtl8188eu_recv_hdl(struct adapter *padapter, struct recv_buf *precvbuf);
-void rtl8188eu_recv_tasklet(void *priv);
+void rtl8188eu_recv_tasklet(unsigned long _priv);
 void rtl8188e_query_rx_phy_status(struct recv_frame *fr, struct phy_stat *phy);
 void rtl8188e_process_phy_info(struct adapter *padapter, void *prframe);
 void update_recvframe_phyinfo_88e(struct recv_frame *fra, struct phy_stat *phy);
diff --git a/drivers/staging/rtl8188eu/include/rtl8188e_xmit.h b/drivers/staging/rtl8188eu/include/rtl8188e_xmit.h
index 65a63df20..171cfedbe 100644
--- a/drivers/staging/rtl8188eu/include/rtl8188e_xmit.h
+++ b/drivers/staging/rtl8188eu/include/rtl8188e_xmit.h
@@ -158,7 +158,7 @@ s32 rtl8188eu_hal_xmit(struct adapter *padapter, struct xmit_frame *frame);
 s32 rtl8188eu_mgnt_xmit(struct adapter *padapter, struct xmit_frame *frame);
 s32 rtl8188eu_xmit_buf_handler(struct adapter *padapter);
 #define hal_xmit_handler rtl8188eu_xmit_buf_handler
-void rtl8188eu_xmit_tasklet(void *priv);
+void rtl8188eu_xmit_tasklet(unsigned long _priv);
 s32 rtl8188eu_xmitframe_complete(struct adapter *padapter,
 				 struct xmit_priv *pxmitpriv,
 				 struct xmit_buf *pxmitbuf);
diff --git a/drivers/staging/rtl8188eu/include/rtw_cmd.h b/drivers/staging/rtl8188eu/include/rtw_cmd.h
index 08ca59217..0eeed5d51 100644
--- a/drivers/staging/rtl8188eu/include/rtw_cmd.h
+++ b/drivers/staging/rtl8188eu/include/rtw_cmd.h
@@ -368,7 +368,6 @@ void rtw_readtssi_cmdrsp_callback(struct adapter *adapt, struct cmd_obj *cmd);
 
 void rtw_setstaKey_cmdrsp_callback(struct adapter *adapt, struct cmd_obj *cmd);
 void rtw_setassocsta_cmdrsp_callback(struct adapter *adapt, struct cmd_obj *cm);
-void rtw_getrttbl_cmdrsp_callback(struct adapter *adapt, struct cmd_obj *cmd);
 
 struct _cmd_callback {
 	u32	cmd_code;
diff --git a/drivers/staging/rtl8188eu/include/rtw_eeprom.h b/drivers/staging/rtl8188eu/include/rtw_eeprom.h
index 5dd73841d..337cc49f4 100644
--- a/drivers/staging/rtl8188eu/include/rtw_eeprom.h
+++ b/drivers/staging/rtl8188eu/include/rtw_eeprom.h
@@ -116,10 +116,4 @@ struct eeprom_priv {
 	u8		efuse_eeprom_data[HWSET_MAX_SIZE_512];
 };
 
-void eeprom_write16(struct adapter *padapter, u16 reg, u16 data);
-u16 eeprom_read16(struct adapter *padapter, u16 reg);
-void read_eeprom_content(struct adapter *padapter);
-void eeprom_read_sz(struct adapter *adapt, u16 reg, u8 *data, u32 sz);
-void read_eeprom_content_by_attrib(struct adapter *padapter);
-
 #endif  /* __RTL871X_EEPROM_H__ */
diff --git a/drivers/staging/rtl8188eu/include/rtw_ioctl.h b/drivers/staging/rtl8188eu/include/rtw_ioctl.h
index 3a652df4b..4b3ac6bc3 100644
--- a/drivers/staging/rtl8188eu/include/rtw_ioctl.h
+++ b/drivers/staging/rtl8188eu/include/rtw_ioctl.h
@@ -103,13 +103,4 @@ static int oid_null_function(struct oid_par_priv *poid_par_priv) {
 
 extern struct iw_handler_def  rtw_handlers_def;
 
-int drv_query_info(struct  net_device *miniportadaptercontext, NDIS_OID oid,
-		   void *informationbuffer, u32 informationbufferlength,
-		   u32 *byteswritten, u32 *bytesneeded);
-
-int drv_set_info(struct  net_device *MiniportAdapterContext,
-		 NDIS_OID oid, void *informationbuffer,
-		 u32 informationbufferlength, u32 *bytesread,
-		 u32 *bytesneeded);
-
 #endif /*  #ifndef __INC_CEINFO_ */
diff --git a/drivers/staging/rtl8188eu/include/rtw_mlme_ext.h b/drivers/staging/rtl8188eu/include/rtw_mlme_ext.h
index 27382ff24..851aeb05a 100644
--- a/drivers/staging/rtl8188eu/include/rtw_mlme_ext.h
+++ b/drivers/staging/rtl8188eu/include/rtw_mlme_ext.h
@@ -404,7 +404,7 @@ struct p2p_oper_class_map {
 struct mlme_ext_priv {
 	struct adapter	*padapter;
 	u8	mlmeext_init;
-	atomic_t	event_seq;
+	atomic_unchecked_t	event_seq;
 	u16	mgnt_seq;
 
 	unsigned char	cur_channel;
@@ -550,8 +550,6 @@ void report_add_sta_event(struct adapter *padapter, unsigned char *addr,
 
 void beacon_timing_control(struct adapter *padapter);
 u8 set_tx_beacon_cmd(struct adapter *padapter);
-unsigned int setup_beacon_frame(struct adapter *padapter,
-				unsigned char *beacon_frame);
 void update_mgnt_tx_rate(struct adapter *padapter, u8 rate);
 void update_mgntframe_attrib(struct adapter *padapter,
 			     struct pkt_attrib *pattrib);
@@ -599,12 +597,6 @@ struct cmd_hdl {
 	u8 (*h2cfuns)(struct adapter  *padapter, u8 *pbuf);
 };
 
-u8 read_macreg_hdl(struct adapter *padapter, u8 *pbuf);
-u8 write_macreg_hdl(struct adapter *padapter, u8 *pbuf);
-u8 read_bbreg_hdl(struct adapter *padapter, u8 *pbuf);
-u8 write_bbreg_hdl(struct adapter *padapter, u8 *pbuf);
-u8 read_rfreg_hdl(struct adapter *padapter, u8 *pbuf);
-u8 write_rfreg_hdl(struct adapter *padapter, u8 *pbuf);
 u8 join_cmd_hdl(struct adapter *padapter, u8 *pbuf);
 u8 disconnect_hdl(struct adapter *padapter, u8 *pbuf);
 u8 createbss_hdl(struct adapter *padapter, u8 *pbuf);
@@ -613,8 +605,6 @@ u8 sitesurvey_cmd_hdl(struct adapter *padapter, u8 *pbuf);
 u8 setauth_hdl(struct adapter *padapter, u8 *pbuf);
 u8 setkey_hdl(struct adapter *padapter, u8 *pbuf);
 u8 set_stakey_hdl(struct adapter *padapter, u8 *pbuf);
-u8 set_assocsta_hdl(struct adapter *padapter, u8 *pbuf);
-u8 del_assocsta_hdl(struct adapter *padapter, u8 *pbuf);
 u8 add_ba_hdl(struct adapter *padapter, unsigned char *pbuf);
 
 u8 mlme_evt_hdl(struct adapter *padapter, unsigned char *pbuf);
diff --git a/drivers/staging/rtl8188eu/include/xmit_osdep.h b/drivers/staging/rtl8188eu/include/xmit_osdep.h
index f96ca6af9..104d496f9 100644
--- a/drivers/staging/rtl8188eu/include/xmit_osdep.h
+++ b/drivers/staging/rtl8188eu/include/xmit_osdep.h
@@ -35,7 +35,7 @@ struct sta_xmit_priv;
 struct xmit_frame;
 struct xmit_buf;
 
-int rtw_xmit_entry(struct sk_buff *pkt, struct  net_device *pnetdev);
+netdev_tx_t rtw_xmit_entry(struct sk_buff *pkt, struct  net_device *pnetdev);
 
 void rtw_os_xmit_schedule(struct adapter *padapter);
 
diff --git a/drivers/staging/rtl8188eu/os_dep/usb_ops_linux.c b/drivers/staging/rtl8188eu/os_dep/usb_ops_linux.c
index ce1e1a135..315c3e153 100644
--- a/drivers/staging/rtl8188eu/os_dep/usb_ops_linux.c
+++ b/drivers/staging/rtl8188eu/os_dep/usb_ops_linux.c
@@ -810,10 +810,10 @@ void usb_write_port_cancel(struct adapter *padapter)
 	}
 }
 
-void rtl8188eu_recv_tasklet(void *priv)
+void rtl8188eu_recv_tasklet(unsigned long priv)
 {
 	struct sk_buff *pskb;
-	struct adapter *adapt = priv;
+	struct adapter *adapt = (struct adapter *)priv;
 	struct recv_priv *precvpriv = &adapt->recvpriv;
 
 	while (NULL != (pskb = skb_dequeue(&precvpriv->rx_skb_queue))) {
@@ -829,10 +829,10 @@ void rtl8188eu_recv_tasklet(void *priv)
 	}
 }
 
-void rtl8188eu_xmit_tasklet(void *priv)
+void rtl8188eu_xmit_tasklet(unsigned long priv)
 {
 	int ret = false;
-	struct adapter *adapt = priv;
+	struct adapter *adapt = (struct adapter *)priv;
 	struct xmit_priv *pxmitpriv = &adapt->xmitpriv;
 
 	if (check_fwstate(&adapt->mlmepriv, _FW_UNDER_SURVEY))
diff --git a/drivers/staging/rtl8188eu/os_dep/xmit_linux.c b/drivers/staging/rtl8188eu/os_dep/xmit_linux.c
index 221e27506..bc552c9ad 100644
--- a/drivers/staging/rtl8188eu/os_dep/xmit_linux.c
+++ b/drivers/staging/rtl8188eu/os_dep/xmit_linux.c
@@ -208,7 +208,7 @@ static int rtw_mlcst2unicst(struct adapter *padapter, struct sk_buff *skb)
 }
 
 
-int rtw_xmit_entry(struct sk_buff *pkt, struct  net_device *pnetdev)
+netdev_tx_t rtw_xmit_entry(struct sk_buff *pkt, struct  net_device *pnetdev)
 {
 	struct adapter *padapter = (struct adapter *)rtw_netdev_priv(pnetdev);
 	struct xmit_priv *pxmitpriv = &padapter->xmitpriv;
diff --git a/drivers/staging/rtl8192e/rtl8192e/rtl_core.c b/drivers/staging/rtl8192e/rtl8192e/rtl_core.c
index 32fe7352d..ac6da1961 100644
--- a/drivers/staging/rtl8192e/rtl8192e/rtl_core.c
+++ b/drivers/staging/rtl8192e/rtl8192e/rtl_core.c
@@ -84,7 +84,7 @@ static struct pci_driver rtl8192_pci_driver = {
 };
 
 static short _rtl92e_is_tx_queue_empty(struct net_device *dev);
-static void _rtl92e_watchdog_wq_cb(void *data);
+static void _rtl92e_watchdog_wq_cb(struct work_struct *data);
 static void _rtl92e_watchdog_timer_cb(unsigned long data);
 static void _rtl92e_hard_data_xmit(struct sk_buff *skb, struct net_device *dev,
 				   int rate);
@@ -92,13 +92,13 @@ static int _rtl92e_hard_start_xmit(struct sk_buff *skb, struct net_device *dev);
 static void _rtl92e_tx_cmd(struct net_device *dev, struct sk_buff *skb);
 static short _rtl92e_tx(struct net_device *dev, struct sk_buff *skb);
 static short _rtl92e_pci_initdescring(struct net_device *dev);
-static void _rtl92e_irq_tx_tasklet(struct r8192_priv *priv);
-static void _rtl92e_irq_rx_tasklet(struct r8192_priv *priv);
+static void _rtl92e_irq_tx_tasklet(unsigned long priv);
+static void _rtl92e_irq_rx_tasklet(unsigned long priv);
 static void _rtl92e_cancel_deferred_work(struct r8192_priv *priv);
 static int _rtl92e_up(struct net_device *dev, bool is_silent_reset);
 static int _rtl92e_try_up(struct net_device *dev);
 static int _rtl92e_down(struct net_device *dev, bool shutdownrf);
-static void _rtl92e_restart(void *data);
+static void _rtl92e_restart(struct work_struct *data);
 
 /****************************************************************************
    -----------------------------IO STUFF-------------------------
@@ -375,7 +375,7 @@ static struct rtllib_qos_parameters def_qos_parameters = {
 	{0, 0, 0, 0}
 };
 
-static void _rtl92e_update_beacon(void *data)
+static void _rtl92e_update_beacon(struct work_struct *data)
 {
 	struct r8192_priv *priv = container_of_work_rsl(data, struct r8192_priv,
 				  update_beacon_wq.work);
@@ -391,7 +391,7 @@ static void _rtl92e_update_beacon(void *data)
 	_rtl92e_update_cap(dev, net->capability);
 }
 
-static void _rtl92e_qos_activate(void *data)
+static void _rtl92e_qos_activate(struct work_struct *data)
 {
 	struct r8192_priv *priv = container_of_work_rsl(data, struct r8192_priv,
 				  qos_activate);
@@ -527,8 +527,9 @@ static int _rtl92e_handle_assoc_response(struct net_device *dev,
 	return 0;
 }
 
-static void _rtl92e_prepare_beacon(struct r8192_priv *priv)
+static void _rtl92e_prepare_beacon(unsigned long _priv)
 {
+	struct r8192_priv *priv = (struct r8192_priv *)_priv;
 	struct net_device *dev = priv->rtllib->dev;
 	struct sk_buff *pskb = NULL, *pnewskb = NULL;
 	struct cb_desc *tcb_desc = NULL;
@@ -1002,30 +1003,30 @@ static void _rtl92e_init_priv_task(struct net_device *dev)
 {
 	struct r8192_priv *priv = rtllib_priv(dev);
 
-	INIT_WORK_RSL(&priv->reset_wq, (void *)_rtl92e_restart, dev);
-	INIT_WORK_RSL(&priv->rtllib->ips_leave_wq, (void *)rtl92e_ips_leave_wq,
+	INIT_WORK_RSL(&priv->reset_wq, _rtl92e_restart, dev);
+	INIT_WORK_RSL(&priv->rtllib->ips_leave_wq, rtl92e_ips_leave_wq,
 		      dev);
 	INIT_DELAYED_WORK_RSL(&priv->watch_dog_wq,
-			      (void *)_rtl92e_watchdog_wq_cb, dev);
+			      _rtl92e_watchdog_wq_cb, dev);
 	INIT_DELAYED_WORK_RSL(&priv->txpower_tracking_wq,
-			      (void *)rtl92e_dm_txpower_tracking_wq, dev);
+			      rtl92e_dm_txpower_tracking_wq, dev);
 	INIT_DELAYED_WORK_RSL(&priv->rfpath_check_wq,
-			      (void *)rtl92e_dm_rf_pathcheck_wq, dev);
+			      rtl92e_dm_rf_pathcheck_wq, dev);
 	INIT_DELAYED_WORK_RSL(&priv->update_beacon_wq,
-			      (void *)_rtl92e_update_beacon, dev);
-	INIT_WORK_RSL(&priv->qos_activate, (void *)_rtl92e_qos_activate, dev);
+			      _rtl92e_update_beacon, dev);
+	INIT_WORK_RSL(&priv->qos_activate, _rtl92e_qos_activate, dev);
 	INIT_DELAYED_WORK_RSL(&priv->rtllib->hw_wakeup_wq,
-			      (void *) rtl92e_hw_wakeup_wq, dev);
+			      rtl92e_hw_wakeup_wq, dev);
 	INIT_DELAYED_WORK_RSL(&priv->rtllib->hw_sleep_wq,
-			      (void *) rtl92e_hw_sleep_wq, dev);
+			      rtl92e_hw_sleep_wq, dev);
 	tasklet_init(&priv->irq_rx_tasklet,
-		     (void(*)(unsigned long))_rtl92e_irq_rx_tasklet,
+		     _rtl92e_irq_rx_tasklet,
 		     (unsigned long)priv);
 	tasklet_init(&priv->irq_tx_tasklet,
-		     (void(*)(unsigned long))_rtl92e_irq_tx_tasklet,
+		     _rtl92e_irq_tx_tasklet,
 		     (unsigned long)priv);
 	tasklet_init(&priv->irq_prepare_beacon_tasklet,
-		     (void(*)(unsigned long))_rtl92e_prepare_beacon,
+		     _rtl92e_prepare_beacon,
 		     (unsigned long)priv);
 }
 
@@ -1377,7 +1378,7 @@ static void _rtl92e_update_rxcounts(struct r8192_priv *priv, u32 *TotalRxBcnNum,
 	}
 }
 
-static void _rtl92e_watchdog_wq_cb(void *data)
+static void _rtl92e_watchdog_wq_cb(struct work_struct *data)
 {
 	struct r8192_priv *priv = container_of_dwork_rsl(data,
 				  struct r8192_priv, watch_dog_wq);
@@ -2142,13 +2143,15 @@ static void _rtl92e_tx_resume(struct net_device *dev)
 	}
 }
 
-static void _rtl92e_irq_tx_tasklet(struct r8192_priv *priv)
+static void _rtl92e_irq_tx_tasklet(unsigned long _priv)
 {
+	struct r8192_priv *priv = (struct r8192_priv *)_priv;
 	_rtl92e_tx_resume(priv->rtllib->dev);
 }
 
-static void _rtl92e_irq_rx_tasklet(struct r8192_priv *priv)
+static void _rtl92e_irq_rx_tasklet(unsigned long _priv)
 {
+	struct r8192_priv *priv= (struct r8192_priv *)_priv;
 	_rtl92e_rx_normal(priv->rtllib->dev);
 
 	rtl92e_writel(priv->rtllib->dev, INTA_MASK,
@@ -2236,7 +2239,7 @@ void rtl92e_commit(struct net_device *dev)
 	_rtl92e_up(dev, false);
 }
 
-static void _rtl92e_restart(void *data)
+static void _rtl92e_restart(struct work_struct *data)
 {
 	struct r8192_priv *priv = container_of_work_rsl(data, struct r8192_priv,
 				  reset_wq);
diff --git a/drivers/staging/rtl8192e/rtl8192e/rtl_core.h b/drivers/staging/rtl8192e/rtl8192e/rtl_core.h
index f627fdc15..3ad70fb83 100644
--- a/drivers/staging/rtl8192e/rtl8192e/rtl_core.h
+++ b/drivers/staging/rtl8192e/rtl8192e/rtl_core.h
@@ -586,12 +586,12 @@ void force_pci_posting(struct net_device *dev);
 void rtl92e_rx_enable(struct net_device *);
 void rtl92e_tx_enable(struct net_device *);
 
-void rtl92e_hw_sleep_wq(void *data);
+void rtl92e_hw_sleep_wq(struct work_struct *data);
 void rtl92e_commit(struct net_device *dev);
 
 void rtl92e_check_rfctrl_gpio_timer(unsigned long data);
 
-void rtl92e_hw_wakeup_wq(void *data);
+void rtl92e_hw_wakeup_wq(struct work_struct *data);
 
 void rtl92e_reset_desc_ring(struct net_device *dev);
 void rtl92e_set_wireless_mode(struct net_device *dev, u8 wireless_mode);
diff --git a/drivers/staging/rtl8192e/rtl8192e/rtl_dm.c b/drivers/staging/rtl8192e/rtl8192e/rtl_dm.c
index 9bc284812..17ccbf7dc 100644
--- a/drivers/staging/rtl8192e/rtl8192e/rtl_dm.c
+++ b/drivers/staging/rtl8192e/rtl8192e/rtl_dm.c
@@ -195,7 +195,7 @@ static void _rtl92e_dm_deinit_fsync(struct net_device *dev);
 static	void _rtl92e_dm_check_txrateandretrycount(struct net_device *dev);
 static  void _rtl92e_dm_check_ac_dc_power(struct net_device *dev);
 static void _rtl92e_dm_check_fsync(struct net_device *dev);
-static void _rtl92e_dm_check_rf_ctrl_gpio(void *data);
+static void _rtl92e_dm_check_rf_ctrl_gpio(struct work_struct *data);
 static void _rtl92e_dm_fsync_timer_callback(unsigned long data);
 
 /*---------------------Define local function prototype-----------------------*/
@@ -229,7 +229,7 @@ void rtl92e_dm_init(struct net_device *dev)
 		_rtl92e_dm_init_wa_broadcom_iot(dev);
 
 	INIT_DELAYED_WORK_RSL(&priv->gpio_change_rf_wq,
-			      (void *)_rtl92e_dm_check_rf_ctrl_gpio, dev);
+			      _rtl92e_dm_check_rf_ctrl_gpio, dev);
 }
 
 void rtl92e_dm_deinit(struct net_device *dev)
@@ -932,7 +932,7 @@ static void _rtl92e_dm_tx_power_tracking_cb_thermal(struct net_device *dev)
 	priv->txpower_count = 0;
 }
 
-void rtl92e_dm_txpower_tracking_wq(void *data)
+void rtl92e_dm_txpower_tracking_wq(struct work_struct *data)
 {
 	struct r8192_priv *priv = container_of_dwork_rsl(data,
 				  struct r8192_priv, txpower_tracking_wq);
@@ -1814,7 +1814,7 @@ static void _rtl92e_dm_init_wa_broadcom_iot(struct net_device *dev)
 	pHTInfo->WAIotTH = WAIotTHVal;
 }
 
-static void _rtl92e_dm_check_rf_ctrl_gpio(void *data)
+static void _rtl92e_dm_check_rf_ctrl_gpio(struct work_struct *data)
 {
 	struct r8192_priv *priv = container_of_dwork_rsl(data,
 				  struct r8192_priv, gpio_change_rf_wq);
@@ -1868,7 +1868,7 @@ static void _rtl92e_dm_check_rf_ctrl_gpio(void *data)
 	}
 }
 
-void rtl92e_dm_rf_pathcheck_wq(void *data)
+void rtl92e_dm_rf_pathcheck_wq(struct work_struct *data)
 {
 	struct r8192_priv *priv = container_of_dwork_rsl(data,
 				  struct r8192_priv,
diff --git a/drivers/staging/rtl8192e/rtl8192e/rtl_dm.h b/drivers/staging/rtl8192e/rtl8192e/rtl_dm.h
index 756a0dd00..d2de5e8ec 100644
--- a/drivers/staging/rtl8192e/rtl8192e/rtl_dm.h
+++ b/drivers/staging/rtl8192e/rtl8192e/rtl_dm.h
@@ -191,13 +191,13 @@ void rtl92e_dm_watchdog(struct net_device *dev);
 
 
 void    rtl92e_init_adaptive_rate(struct net_device *dev);
-void    rtl92e_dm_txpower_tracking_wq(void *data);
+void    rtl92e_dm_txpower_tracking_wq(struct work_struct *data);
 
 void rtl92e_dm_cck_txpower_adjust(struct net_device *dev, bool binch14);
 
 void    rtl92e_dm_restore_state(struct net_device *dev);
 void    rtl92e_dm_backup_state(struct net_device *dev);
 void    rtl92e_dm_init_edca_turbo(struct net_device *dev);
-void    rtl92e_dm_rf_pathcheck_wq(void *data);
+void    rtl92e_dm_rf_pathcheck_wq(struct work_struct *data);
 void rtl92e_dm_init_txpower_tracking(struct net_device *dev);
 #endif	/*__R8192UDM_H__ */
diff --git a/drivers/staging/rtl8192e/rtl8192e/rtl_ps.c b/drivers/staging/rtl8192e/rtl8192e/rtl_ps.c
index 98e4d88d0..5216a5fba 100644
--- a/drivers/staging/rtl8192e/rtl8192e/rtl_ps.c
+++ b/drivers/staging/rtl8192e/rtl8192e/rtl_ps.c
@@ -44,7 +44,7 @@ static void _rtl92e_hw_sleep(struct net_device *dev)
 	rtl92e_set_rf_state(dev, eRfSleep, RF_CHANGE_BY_PS);
 }
 
-void rtl92e_hw_sleep_wq(void *data)
+void rtl92e_hw_sleep_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_dwork_rsl(data,
 				     struct rtllib_device, hw_sleep_wq);
@@ -72,7 +72,7 @@ void rtl92e_hw_wakeup(struct net_device *dev)
 	rtl92e_set_rf_state(dev, eRfOn, RF_CHANGE_BY_PS);
 }
 
-void rtl92e_hw_wakeup_wq(void *data)
+void rtl92e_hw_wakeup_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_dwork_rsl(data,
 				     struct rtllib_device, hw_wakeup_wq);
@@ -172,7 +172,7 @@ void rtl92e_ips_leave(struct net_device *dev)
 	}
 }
 
-void rtl92e_ips_leave_wq(void *data)
+void rtl92e_ips_leave_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_work_rsl(data,
 				     struct rtllib_device, ips_leave_wq);
diff --git a/drivers/staging/rtl8192e/rtl8192e/rtl_ps.h b/drivers/staging/rtl8192e/rtl8192e/rtl_ps.h
index a46f4cffc..8f46fdaca 100644
--- a/drivers/staging/rtl8192e/rtl8192e/rtl_ps.h
+++ b/drivers/staging/rtl8192e/rtl8192e/rtl_ps.h
@@ -24,6 +24,7 @@
 #include <linux/types.h>
 
 struct net_device;
+struct work_struct;
 
 #define RT_CHECK_FOR_HANG_PERIOD 2
 
@@ -31,7 +32,7 @@ void rtl92e_hw_wakeup(struct net_device *dev);
 void rtl92e_enter_sleep(struct net_device *dev, u64 time);
 void rtl92e_rtllib_ips_leave_wq(struct net_device *dev);
 void rtl92e_rtllib_ips_leave(struct net_device *dev);
-void rtl92e_ips_leave_wq(void *data);
+void rtl92e_ips_leave_wq(struct work_struct *data);
 
 void rtl92e_ips_enter(struct net_device *dev);
 void rtl92e_ips_leave(struct net_device *dev);
diff --git a/drivers/staging/rtl8192e/rtl8192e/rtl_wx.c b/drivers/staging/rtl8192e/rtl8192e/rtl_wx.c
index 70df6a148..21c9f2ecb 100644
--- a/drivers/staging/rtl8192e/rtl8192e/rtl_wx.c
+++ b/drivers/staging/rtl8192e/rtl8192e/rtl_wx.c
@@ -1187,30 +1187,30 @@ static const struct iw_priv_args r8192_private_args[] = {
 };
 
 static iw_handler r8192_private_handler[] = {
-	(iw_handler)_rtl92e_wx_set_debug,   /*SIOCIWSECONDPRIV*/
-	(iw_handler)_rtl92e_wx_set_scan_type,
-	(iw_handler)_rtl92e_wx_set_rawtx,
-	(iw_handler)_rtl92e_wx_force_reset,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)_rtl92e_wx_adapter_power_status,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)_rtl92e_wx_set_lps_awake_interval,
-	(iw_handler)_rtl92e_wx_set_force_lps,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)NULL,
-	(iw_handler)_rtl92e_wx_set_promisc_mode,
-	(iw_handler)_rtl92e_wx_get_promisc_mode,
+	_rtl92e_wx_set_debug,   /*SIOCIWSECONDPRIV*/
+	_rtl92e_wx_set_scan_type,
+	_rtl92e_wx_set_rawtx,
+	_rtl92e_wx_force_reset,
+	NULL,
+	NULL,
+	_rtl92e_wx_adapter_power_status,
+	NULL,
+	NULL,
+	NULL,
+	_rtl92e_wx_set_lps_awake_interval,
+	_rtl92e_wx_set_force_lps,
+	NULL,
+	NULL,
+	NULL,
+	NULL,
+	NULL,
+	NULL,
+	NULL,
+	NULL,
+	NULL,
+	NULL,
+	_rtl92e_wx_set_promisc_mode,
+	_rtl92e_wx_get_promisc_mode,
 };
 
 static struct iw_statistics *_rtl92e_get_wireless_stats(struct net_device *dev)
diff --git a/drivers/staging/rtl8192e/rtllib.h b/drivers/staging/rtl8192e/rtllib.h
index 776e179d5..5a021e6fd 100644
--- a/drivers/staging/rtl8192e/rtllib.h
+++ b/drivers/staging/rtl8192e/rtllib.h
@@ -1993,7 +1993,7 @@ int rtllib_encrypt_fragment(
 	struct sk_buff *frag,
 	int hdr_len);
 
-int rtllib_xmit(struct sk_buff *skb,  struct net_device *dev);
+netdev_tx_t rtllib_xmit(struct sk_buff *skb,  struct net_device *dev);
 void rtllib_txb_free(struct rtllib_txb *);
 
 /* rtllib_rx.c */
@@ -2107,7 +2107,7 @@ int rtllib_wx_set_freq(struct rtllib_device *ieee, struct iw_request_info *a,
 
 int rtllib_wx_get_freq(struct rtllib_device *ieee, struct iw_request_info *a,
 		       union iwreq_data *wrqu, char *b);
-void rtllib_wx_sync_scan_wq(void *data);
+void rtllib_wx_sync_scan_wq(struct work_struct *data);
 
 int rtllib_wx_set_rawtx(struct rtllib_device *ieee,
 			struct iw_request_info *info,
diff --git a/drivers/staging/rtl8192e/rtllib_softmac.c b/drivers/staging/rtl8192e/rtllib_softmac.c
index 62154e3f4..bf1e43199 100644
--- a/drivers/staging/rtl8192e/rtllib_softmac.c
+++ b/drivers/staging/rtl8192e/rtllib_softmac.c
@@ -574,7 +574,7 @@ out:
 	wireless_send_event(ieee->dev, SIOCGIWSCAN, &wrqu, NULL);
 }
 
-static void rtllib_softmac_scan_wq(void *data)
+static void rtllib_softmac_scan_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_dwork_rsl(data,
 				     struct rtllib_device, softmac_scan_wq);
@@ -1513,7 +1513,7 @@ static void rtllib_associate_step2(struct rtllib_device *ieee)
 	}
 }
 
-static void rtllib_associate_complete_wq(void *data)
+static void rtllib_associate_complete_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = (struct rtllib_device *)
 				     container_of_work_rsl(data,
@@ -1582,7 +1582,7 @@ static void rtllib_associate_complete(struct rtllib_device *ieee)
 	schedule_work(&ieee->associate_complete_wq);
 }
 
-static void rtllib_associate_procedure_wq(void *data)
+static void rtllib_associate_procedure_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_dwork_rsl(data,
 				     struct rtllib_device,
@@ -2054,8 +2054,9 @@ static short rtllib_sta_ps_sleep(struct rtllib_device *ieee, u64 *time)
 
 }
 
-static inline void rtllib_sta_ps(struct rtllib_device *ieee)
+static inline void rtllib_sta_ps(unsigned long _ieee)
 {
+	struct rtllib_device *ieee = (struct rtllib_device *)_ieee;
 	u64 time;
 	short sleep;
 	unsigned long flags, flags2;
@@ -2576,7 +2577,7 @@ static void rtllib_start_monitor_mode(struct rtllib_device *ieee)
 	}
 }
 
-static void rtllib_start_ibss_wq(void *data)
+static void rtllib_start_ibss_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_dwork_rsl(data,
 				     struct rtllib_device, start_ibss_wq);
@@ -2741,7 +2742,7 @@ static void rtllib_start_bss(struct rtllib_device *ieee)
 	spin_unlock_irqrestore(&ieee->lock, flags);
 }
 
-static void rtllib_link_change_wq(void *data)
+static void rtllib_link_change_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_dwork_rsl(data,
 				     struct rtllib_device, link_change_wq);
@@ -2767,7 +2768,7 @@ void rtllib_disassociate(struct rtllib_device *ieee)
 	notify_wx_assoc_event(ieee);
 }
 
-static void rtllib_associate_retry_wq(void *data)
+static void rtllib_associate_retry_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_dwork_rsl(data,
 				     struct rtllib_device, associate_retry_wq);
@@ -3020,19 +3021,18 @@ void rtllib_softmac_init(struct rtllib_device *ieee)
 		    (unsigned long) ieee);
 
 	INIT_DELAYED_WORK_RSL(&ieee->link_change_wq,
-			      (void *)rtllib_link_change_wq, ieee);
+			      rtllib_link_change_wq, ieee);
 	INIT_DELAYED_WORK_RSL(&ieee->start_ibss_wq,
-			      (void *)rtllib_start_ibss_wq, ieee);
+			      rtllib_start_ibss_wq, ieee);
 	INIT_WORK_RSL(&ieee->associate_complete_wq,
-		      (void *)rtllib_associate_complete_wq, ieee);
+			      rtllib_associate_complete_wq, ieee);
 	INIT_DELAYED_WORK_RSL(&ieee->associate_procedure_wq,
-			      (void *)rtllib_associate_procedure_wq, ieee);
+			      rtllib_associate_procedure_wq, ieee);
 	INIT_DELAYED_WORK_RSL(&ieee->softmac_scan_wq,
-			      (void *)rtllib_softmac_scan_wq, ieee);
+			      rtllib_softmac_scan_wq, ieee);
 	INIT_DELAYED_WORK_RSL(&ieee->associate_retry_wq,
-			      (void *)rtllib_associate_retry_wq, ieee);
-	INIT_WORK_RSL(&ieee->wx_sync_scan_wq, (void *)rtllib_wx_sync_scan_wq,
-		      ieee);
+			      rtllib_associate_retry_wq, ieee);
+	INIT_WORK_RSL(&ieee->wx_sync_scan_wq, rtllib_wx_sync_scan_wq, ieee);
 
 	sema_init(&ieee->wx_sem, 1);
 	sema_init(&ieee->scan_sem, 1);
@@ -3042,7 +3042,7 @@ void rtllib_softmac_init(struct rtllib_device *ieee)
 	spin_lock_init(&ieee->beacon_lock);
 
 	tasklet_init(&ieee->ps_task,
-	     (void(*)(unsigned long)) rtllib_sta_ps,
+	     rtllib_sta_ps,
 	     (unsigned long)ieee);
 
 }
diff --git a/drivers/staging/rtl8192e/rtllib_softmac_wx.c b/drivers/staging/rtl8192e/rtllib_softmac_wx.c
index 61ed8b041..a8b7d01c8 100644
--- a/drivers/staging/rtl8192e/rtllib_softmac_wx.c
+++ b/drivers/staging/rtl8192e/rtllib_softmac_wx.c
@@ -327,7 +327,7 @@ out:
 }
 EXPORT_SYMBOL(rtllib_wx_set_mode);
 
-void rtllib_wx_sync_scan_wq(void *data)
+void rtllib_wx_sync_scan_wq(struct work_struct *data)
 {
 	struct rtllib_device *ieee = container_of_work_rsl(data,
 				     struct rtllib_device, wx_sync_scan_wq);
diff --git a/drivers/staging/rtl8192e/rtllib_tx.c b/drivers/staging/rtl8192e/rtllib_tx.c
index 58fc70ec5..3fe041e85 100644
--- a/drivers/staging/rtl8192e/rtllib_tx.c
+++ b/drivers/staging/rtl8192e/rtllib_tx.c
@@ -981,7 +981,7 @@ static int rtllib_xmit_inter(struct sk_buff *skb, struct net_device *dev)
 	return 1;
 
 }
-int rtllib_xmit(struct sk_buff *skb, struct net_device *dev)
+netdev_tx_t rtllib_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	memset(skb->cb, 0, sizeof(skb->cb));
 	return rtllib_xmit_inter(skb, dev);
diff --git a/drivers/staging/rtl8192u/ieee80211/ieee80211.h b/drivers/staging/rtl8192u/ieee80211/ieee80211.h
index 09e9499b7..dc65c7967 100644
--- a/drivers/staging/rtl8192u/ieee80211/ieee80211.h
+++ b/drivers/staging/rtl8192u/ieee80211/ieee80211.h
@@ -2174,7 +2174,7 @@ int ieee80211_set_encryption(struct ieee80211_device *ieee);
 int ieee80211_encrypt_fragment(struct ieee80211_device *ieee,
 			       struct sk_buff *frag, int hdr_len);
 
-int ieee80211_xmit(struct sk_buff *skb, struct net_device *dev);
+netdev_tx_t ieee80211_xmit(struct sk_buff *skb, struct net_device *dev);
 void ieee80211_txb_free(struct ieee80211_txb *);
 
 
diff --git a/drivers/staging/rtl8192u/ieee80211/ieee80211_softmac.c b/drivers/staging/rtl8192u/ieee80211/ieee80211_softmac.c
index 49db1b75c..8e1b69ae4 100644
--- a/drivers/staging/rtl8192u/ieee80211/ieee80211_softmac.c
+++ b/drivers/staging/rtl8192u/ieee80211/ieee80211_softmac.c
@@ -1765,9 +1765,9 @@ static short ieee80211_sta_ps_sleep(struct ieee80211_device *ieee, u32 *time_h,
 
 }
 
-static inline void ieee80211_sta_ps(struct ieee80211_device *ieee)
+static inline void ieee80211_sta_ps(unsigned long _ieee)
 {
-
+	struct ieee80211_device *ieee = (struct ieee80211_device *)_ieee;
 	u32 th, tl;
 	short sleep;
 
@@ -2735,7 +2735,7 @@ void ieee80211_softmac_init(struct ieee80211_device *ieee)
 	spin_lock_init(&ieee->beacon_lock);
 
 	tasklet_init(&ieee->ps_task,
-	     (void(*)(unsigned long)) ieee80211_sta_ps,
+	     ieee80211_sta_ps,
 	     (unsigned long)ieee);
 
 }
diff --git a/drivers/staging/rtl8192u/ieee80211/ieee80211_tx.c b/drivers/staging/rtl8192u/ieee80211/ieee80211_tx.c
index 1ab0aead2..41de55c8f 100644
--- a/drivers/staging/rtl8192u/ieee80211/ieee80211_tx.c
+++ b/drivers/staging/rtl8192u/ieee80211/ieee80211_tx.c
@@ -594,7 +594,7 @@ static void ieee80211_query_seqnum(struct ieee80211_device *ieee,
 	}
 }
 
-int ieee80211_xmit(struct sk_buff *skb, struct net_device *dev)
+netdev_tx_t ieee80211_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct ieee80211_device *ieee = netdev_priv(dev);
 	struct ieee80211_txb *txb = NULL;
diff --git a/drivers/staging/rtl8192u/r8192U_core.c b/drivers/staging/rtl8192u/r8192U_core.c
index dd0970fac..7fa0bdf85 100644
--- a/drivers/staging/rtl8192u/r8192U_core.c
+++ b/drivers/staging/rtl8192u/r8192U_core.c
@@ -2382,7 +2382,7 @@ static void rtl8192_init_priv_lock(struct r8192_priv *priv)
 
 static void rtl819x_watchdog_wqcallback(struct work_struct *work);
 
-static void rtl8192_irq_rx_tasklet(struct r8192_priv *priv);
+static void rtl8192_irq_rx_tasklet(unsigned long priv);
 /* init tasklet and wait_queue here. only 2.6 above kernel is considered */
 #define DRV_NAME "wlan0"
 static void rtl8192_init_priv_task(struct net_device *dev)
@@ -2405,7 +2405,7 @@ static void rtl8192_init_priv_task(struct net_device *dev)
 	INIT_WORK(&priv->qos_activate, rtl8192_qos_activate);
 
 	tasklet_init(&priv->irq_rx_tasklet,
-		     (void(*)(unsigned long))rtl8192_irq_rx_tasklet,
+		     rtl8192_irq_rx_tasklet,
 		     (unsigned long)priv);
 }
 
@@ -4942,8 +4942,9 @@ static void rtl8192_rx_cmd(struct sk_buff *skb)
 	}
 }
 
-static void rtl8192_irq_rx_tasklet(struct r8192_priv *priv)
+static void rtl8192_irq_rx_tasklet(unsigned long _priv)
 {
+	struct r8192_priv *priv = (struct r8192_priv *)_priv;
 	struct sk_buff *skb;
 	struct rtl8192_rx_info *info;
 
diff --git a/drivers/staging/rtl8712/rtl8712_recv.c b/drivers/staging/rtl8712/rtl8712_recv.c
index f25b34c7d..487a9630b 100644
--- a/drivers/staging/rtl8712/rtl8712_recv.c
+++ b/drivers/staging/rtl8712/rtl8712_recv.c
@@ -45,7 +45,7 @@ static u8 bridge_tunnel_header[] = {0xaa, 0xaa, 0x03, 0x00, 0x00, 0xf8};
 /* Ethernet-II snap header (RFC1042 for most EtherTypes) */
 static u8 rfc1042_header[] = {0xaa, 0xaa, 0x03, 0x00, 0x00, 0x00};
 
-static void recv_tasklet(void *priv);
+static void recv_tasklet(unsigned long _priv);
 
 int r8712_init_recv_priv(struct recv_priv *precvpriv, struct _adapter *padapter)
 {
@@ -79,7 +79,7 @@ int r8712_init_recv_priv(struct recv_priv *precvpriv, struct _adapter *padapter)
 	}
 	precvpriv->free_recv_buf_queue_cnt = NR_RECVBUFF;
 	tasklet_init(&precvpriv->recv_tasklet,
-	     (void(*)(unsigned long))recv_tasklet,
+	     recv_tasklet,
 	     (unsigned long)padapter);
 	skb_queue_head_init(&precvpriv->rx_skb_queue);
 
@@ -1103,7 +1103,7 @@ _exit_recvbuf2recvframe:
 	return _SUCCESS;
 }
 
-static void recv_tasklet(void *priv)
+static void recv_tasklet(unsigned long priv)
 {
 	struct sk_buff *pskb;
 	struct _adapter *padapter = (struct _adapter *)priv;
diff --git a/drivers/staging/rtl8712/rtl871x_io.h b/drivers/staging/rtl8712/rtl871x_io.h
index 26dd24cdd..2eb37c969 100644
--- a/drivers/staging/rtl8712/rtl871x_io.h
+++ b/drivers/staging/rtl8712/rtl871x_io.h
@@ -108,7 +108,7 @@ struct	_io_ops {
 			  u8 *pmem);
 	u32 (*_write_port)(struct intf_hdl *pintfhdl, u32 addr, u32 cnt,
 			   u8 *pmem);
-};
+} __no_const;
 
 struct io_req {
 	struct list_head list;
diff --git a/drivers/staging/rtl8712/rtl871x_ioctl.h b/drivers/staging/rtl8712/rtl871x_ioctl.h
index c9218be5b..ecda3f6cc 100644
--- a/drivers/staging/rtl8712/rtl871x_ioctl.h
+++ b/drivers/staging/rtl8712/rtl871x_ioctl.h
@@ -76,18 +76,4 @@ uint oid_null_function(struct oid_par_priv *poid_par_priv);
 
 extern struct iw_handler_def  r871x_handlers_def;
 
-uint drv_query_info(struct net_device *MiniportAdapterContext,
-		    uint Oid,
-		    void *InformationBuffer,
-		    u32 InformationBufferLength,
-		    u32 *BytesWritten,
-		    u32 *BytesNeeded);
-
-uint drv_set_info(struct net_device *MiniportAdapterContext,
-		  uint Oid,
-		  void *InformationBuffer,
-		  u32 InformationBufferLength,
-		  u32 *BytesRead,
-		  u32 *BytesNeeded);
-
 #endif
diff --git a/drivers/staging/rtl8712/rtl871x_xmit.c b/drivers/staging/rtl8712/rtl871x_xmit.c
index 99256baaf..1b789b8dd 100644
--- a/drivers/staging/rtl8712/rtl871x_xmit.c
+++ b/drivers/staging/rtl8712/rtl871x_xmit.c
@@ -152,7 +152,7 @@ sint _r8712_init_xmit_priv(struct xmit_priv *pxmitpriv,
 	alloc_hwxmits(padapter);
 	init_hwxmits(pxmitpriv->hwxmits, pxmitpriv->hwxmit_entry);
 	tasklet_init(&pxmitpriv->xmit_tasklet,
-		(void(*)(unsigned long))r8712_xmit_bh,
+		r8712_xmit_bh,
 		(unsigned long)padapter);
 	return _SUCCESS;
 }
diff --git a/drivers/staging/rtl8712/rtl871x_xmit.h b/drivers/staging/rtl8712/rtl871x_xmit.h
index a9633c3f7..77b0c85db 100644
--- a/drivers/staging/rtl8712/rtl871x_xmit.h
+++ b/drivers/staging/rtl8712/rtl871x_xmit.h
@@ -291,7 +291,7 @@ int r8712_pre_xmit(struct _adapter *padapter, struct xmit_frame *pxmitframe);
 int r8712_xmit_enqueue(struct _adapter *padapter,
 		       struct xmit_frame *pxmitframe);
 int r8712_xmit_direct(struct _adapter *padapter, struct xmit_frame *pxmitframe);
-void r8712_xmit_bh(void *priv);
+void r8712_xmit_bh(unsigned long priv);
 
 void xmitframe_xmitbuf_attach(struct xmit_frame *pxmitframe,
 			struct xmit_buf *pxmitbuf);
diff --git a/drivers/staging/rtl8712/usb_ops_linux.c b/drivers/staging/rtl8712/usb_ops_linux.c
index 6f1234570..3c8fb5a7b 100644
--- a/drivers/staging/rtl8712/usb_ops_linux.c
+++ b/drivers/staging/rtl8712/usb_ops_linux.c
@@ -331,10 +331,10 @@ void r8712_usb_read_port_cancel(struct _adapter *padapter)
 	}
 }
 
-void r8712_xmit_bh(void *priv)
+void r8712_xmit_bh(unsigned long priv)
 {
 	int ret = false;
-	struct _adapter *padapter = priv;
+	struct _adapter *padapter = (struct _adapter *)priv;
 	struct xmit_priv *pxmitpriv = &padapter->xmitpriv;
 
 	if (padapter->bDriverStopped ||
diff --git a/drivers/staging/rtl8712/xmit_linux.c b/drivers/staging/rtl8712/xmit_linux.c
index 695f9b9fc..5f8019a32 100644
--- a/drivers/staging/rtl8712/xmit_linux.c
+++ b/drivers/staging/rtl8712/xmit_linux.c
@@ -156,7 +156,7 @@ void r8712_xmit_complete(struct _adapter *padapter, struct xmit_frame *pxframe)
 	pxframe->pkt = NULL;
 }
 
-int r8712_xmit_entry(_pkt *pkt, struct  net_device *pnetdev)
+netdev_tx_t r8712_xmit_entry(_pkt *pkt, struct  net_device *pnetdev)
 {
 	struct xmit_frame *pxmitframe = NULL;
 	struct _adapter *padapter = netdev_priv(pnetdev);
diff --git a/drivers/staging/rtl8712/xmit_osdep.h b/drivers/staging/rtl8712/xmit_osdep.h
index 8eba7ca0d..6c4ce81ab 100644
--- a/drivers/staging/rtl8712/xmit_osdep.h
+++ b/drivers/staging/rtl8712/xmit_osdep.h
@@ -46,7 +46,7 @@ struct sta_xmit_priv;
 struct xmit_frame;
 struct xmit_buf;
 
-int r8712_xmit_entry(_pkt *pkt, struct  net_device *pnetdev);
+netdev_tx_t r8712_xmit_entry(_pkt *pkt, struct  net_device *pnetdev);
 void r8712_SetFilter(struct work_struct *work);
 int r8712_xmit_resource_alloc(struct _adapter *padapter,
 			   struct xmit_buf *pxmitbuf);
diff --git a/drivers/staging/rtl8723au/core/rtw_mlme_ext.c b/drivers/staging/rtl8723au/core/rtw_mlme_ext.c
index 7dd1540eb..52d139239 100644
--- a/drivers/staging/rtl8723au/core/rtw_mlme_ext.c
+++ b/drivers/staging/rtl8723au/core/rtw_mlme_ext.c
@@ -368,7 +368,7 @@ static void init_mlme_ext_priv23a_value(struct rtw_adapter *padapter)
 		_1M_RATE_, _2M_RATE_, _5M_RATE_, _11M_RATE_, _6M_RATE_,
 		_12M_RATE_, _24M_RATE_, 0xff,};
 
-	atomic_set(&pmlmeext->event_seq, 0);
+	atomic_set_unchecked(&pmlmeext->event_seq, 0);
 	/* reset to zero when disconnect at client mode */
 	pmlmeext->mgnt_seq = 0;
 
@@ -4734,7 +4734,7 @@ void report_survey_event23a(struct rtw_adapter *padapter,
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct survey_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_Survey);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	psurvey_evt = (struct survey_event*)(pevtcmd + sizeof(struct C2HEvent_Header));
 
@@ -4783,7 +4783,7 @@ void report_surveydone_event23a(struct rtw_adapter *padapter)
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct surveydone_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_SurveyDone);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	psurveydone_evt = (struct surveydone_event*)(pevtcmd + sizeof(struct C2HEvent_Header));
 	psurveydone_evt->bss_cnt = pmlmeext->sitesurvey_res.bss_cnt;
@@ -4825,7 +4825,7 @@ void report_join_res23a(struct rtw_adapter *padapter, int res)
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct joinbss_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_JoinBss);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	pjoinbss_evt = (struct joinbss_event*)(pevtcmd + sizeof(struct C2HEvent_Header));
 	memcpy((unsigned char *)&pjoinbss_evt->network.network,
@@ -4873,7 +4873,7 @@ void report_del_sta_event23a(struct rtw_adapter *padapter,
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct stadel_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_DelSTA);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	pdel_sta_evt = (struct stadel_event*)(pevtcmd + sizeof(struct C2HEvent_Header));
 	ether_addr_copy((unsigned char *)&pdel_sta_evt->macaddr, MacAddr);
@@ -4925,7 +4925,7 @@ void report_add_sta_event23a(struct rtw_adapter *padapter,
 	pc2h_evt_hdr = (struct C2HEvent_Header *)(pevtcmd);
 	pc2h_evt_hdr->len = sizeof(struct stassoc_event);
 	pc2h_evt_hdr->ID = GEN_EVT_CODE(_AddSTA);
-	pc2h_evt_hdr->seq = atomic_inc_return(&pmlmeext->event_seq);
+	pc2h_evt_hdr->seq = atomic_inc_return_unchecked(&pmlmeext->event_seq);
 
 	padd_sta_evt = (struct stassoc_event*)(pevtcmd + sizeof(struct C2HEvent_Header));
 	ether_addr_copy((unsigned char *)&padd_sta_evt->macaddr, MacAddr);
diff --git a/drivers/staging/rtl8723au/core/rtw_xmit.c b/drivers/staging/rtl8723au/core/rtw_xmit.c
index 3de40cfa5..82130682d 100644
--- a/drivers/staging/rtl8723au/core/rtw_xmit.c
+++ b/drivers/staging/rtl8723au/core/rtw_xmit.c
@@ -183,7 +183,7 @@ int _rtw_init_xmit_priv23a(struct xmit_priv *pxmitpriv,
 	mutex_init(&pxmitpriv->ack_tx_mutex);
 	rtw_sctx_init23a(&pxmitpriv->ack_tx_ops, 0);
 	tasklet_init(&padapter->xmitpriv.xmit_tasklet,
-		     (void(*)(unsigned long))rtl8723au_xmit_tasklet,
+		     rtl8723au_xmit_tasklet,
 		     (unsigned long)padapter);
 
 exit:
diff --git a/drivers/staging/rtl8723au/hal/rtl8723au_recv.c b/drivers/staging/rtl8723au/hal/rtl8723au_recv.c
index 0fec84bcb..298d283ed 100644
--- a/drivers/staging/rtl8723au/hal/rtl8723au_recv.c
+++ b/drivers/staging/rtl8723au/hal/rtl8723au_recv.c
@@ -33,7 +33,7 @@ int rtl8723au_init_recv_priv(struct rtw_adapter *padapter)
 	struct sk_buff *pskb;
 
 	tasklet_init(&precvpriv->recv_tasklet,
-		     (void(*)(unsigned long))rtl8723au_recv_tasklet,
+		     rtl8723au_recv_tasklet,
 		     (unsigned long)padapter);
 
 	precvpriv->int_in_urb = usb_alloc_urb(0, GFP_KERNEL);
diff --git a/drivers/staging/rtl8723au/hal/usb_ops_linux.c b/drivers/staging/rtl8723au/hal/usb_ops_linux.c
index 5c81ff482..b4c260187 100644
--- a/drivers/staging/rtl8723au/hal/usb_ops_linux.c
+++ b/drivers/staging/rtl8723au/hal/usb_ops_linux.c
@@ -483,7 +483,7 @@ _exit_recvbuf2recvframe:
 	return _SUCCESS;
 }
 
-void rtl8723au_recv_tasklet(void *priv)
+void rtl8723au_recv_tasklet(unsigned long priv)
 {
 	struct sk_buff *pskb;
 	struct rtw_adapter *padapter = (struct rtw_adapter *)priv;
@@ -658,7 +658,7 @@ int rtl8723au_read_port(struct rtw_adapter *adapter, u32 cnt,
 	return ret;
 }
 
-void rtl8723au_xmit_tasklet(void *priv)
+void rtl8723au_xmit_tasklet(unsigned long priv)
 {
 	int ret;
 	struct rtw_adapter *padapter = (struct rtw_adapter *)priv;
diff --git a/drivers/staging/rtl8723au/include/Hal8723APhyCfg.h b/drivers/staging/rtl8723au/include/Hal8723APhyCfg.h
index bcf36579f..74d47424c 100644
--- a/drivers/staging/rtl8723au/include/Hal8723APhyCfg.h
+++ b/drivers/staging/rtl8723au/include/Hal8723APhyCfg.h
@@ -135,7 +135,6 @@ void	PHY_SetBWMode23a8723A(struct rtw_adapter *pAdapter,
 /*  */
 void	PHY_SwChnl8723A(struct rtw_adapter *pAdapter, u8 channel);
 				/*  Call after initialization */
-void ChkFwCmdIoDone(struct rtw_adapter *Adapter);
 
 /*  */
 /*  Modify the value of the hw register when beacon interval be changed. */
@@ -144,13 +143,6 @@ void
 rtl8192c_PHY_SetBeaconHwReg(struct rtw_adapter *Adapter, u16 BeaconInterval);
 
 
-void PHY_SwitchEphyParameter(struct rtw_adapter *Adapter);
-
-void PHY_EnableHostClkReq(struct rtw_adapter *Adapter);
-
-bool
-SetAntennaConfig92C(struct rtw_adapter *Adapter, u8 DefaultAnt);
-
 /*--------------------------Exported Function prototype---------------------*/
 
 #define PHY_SetMacReg	PHY_SetBBReg
diff --git a/drivers/staging/rtl8723au/include/drv_types.h b/drivers/staging/rtl8723au/include/drv_types.h
index e83463aeb..84230f3e8 100644
--- a/drivers/staging/rtl8723au/include/drv_types.h
+++ b/drivers/staging/rtl8723au/include/drv_types.h
@@ -185,7 +185,7 @@ struct dvobj_priv {
 
 	struct usb_interface *pusbintf;
 	struct usb_device *pusbdev;
-	atomic_t continual_urb_error;
+	atomic_unchecked_t continual_urb_error;
 
 /*-------- below is for PCIE INTERFACE --------*/
 
diff --git a/drivers/staging/rtl8723au/include/hal_intf.h b/drivers/staging/rtl8723au/include/hal_intf.h
index b924d47fc..1e3e51c5c 100644
--- a/drivers/staging/rtl8723au/include/hal_intf.h
+++ b/drivers/staging/rtl8723au/include/hal_intf.h
@@ -97,10 +97,8 @@ int pm_netdev_open23a(struct net_device *pnetdev, u8 bnormal);
 
 int rtl8723au_hal_init(struct rtw_adapter *padapter);
 int rtl8723au_hal_deinit(struct rtw_adapter *padapter);
-void rtw_hal_stop(struct rtw_adapter *padapter);
 
 void rtw_hal_update_ra_mask23a(struct sta_info *psta, u8 rssi_level);
-void	rtw_hal_clone_data(struct rtw_adapter *dst_padapter, struct rtw_adapter *src_padapter);
 
 void hw_var_set_correct_tsf(struct rtw_adapter *padapter);
 void hw_var_set_mlme_disconnect(struct rtw_adapter *padapter);
diff --git a/drivers/staging/rtl8723au/include/recv_osdep.h b/drivers/staging/rtl8723au/include/recv_osdep.h
index c2d3f1bd5..bb0dc02f2 100644
--- a/drivers/staging/rtl8723au/include/recv_osdep.h
+++ b/drivers/staging/rtl8723au/include/recv_osdep.h
@@ -26,7 +26,6 @@ int rtw_recv_indicatepkt23a(struct rtw_adapter *adapter, struct recv_frame *prec
 
 void rtw_handle_tkip_mic_err23a(struct rtw_adapter *padapter, u8 bgroup);
 
-int	rtw_init_recv_priv(struct recv_priv *precvpriv, struct rtw_adapter *padapter);
 void rtw_free_recv_priv (struct recv_priv *precvpriv);
 
 int rtw_os_recv_resource_init(struct recv_priv *precvpriv, struct rtw_adapter *padapter);
diff --git a/drivers/staging/rtl8723au/include/rtw_ap.h b/drivers/staging/rtl8723au/include/rtw_ap.h
index 55a708f9f..2f111af44 100644
--- a/drivers/staging/rtl8723au/include/rtw_ap.h
+++ b/drivers/staging/rtl8723au/include/rtw_ap.h
@@ -26,8 +26,6 @@
 void init_mlme_ap_info23a(struct rtw_adapter *padapter);
 void free_mlme_ap_info23a(struct rtw_adapter *padapter);
 /* void update_BCNTIM(struct rtw_adapter *padapter); */
-void rtw_add_bcn_ie(struct rtw_adapter *padapter, struct wlan_bssid_ex *pnetwork, u8 index, u8 *data, u8 len);
-void rtw_remove_bcn_ie(struct rtw_adapter *padapter, struct wlan_bssid_ex *pnetwork, u8 index);
 void update_beacon23a(struct rtw_adapter *padapter, u8 ie_id, u8 *oui, u8 tx);
 void add_RATid23a(struct rtw_adapter *padapter, struct sta_info *psta, u8 rssi_level);
 void expire_timeout_chk23a(struct rtw_adapter *padapter);
diff --git a/drivers/staging/rtl8723au/include/rtw_cmd.h b/drivers/staging/rtl8723au/include/rtw_cmd.h
index d1fa95d28..338b933f8 100644
--- a/drivers/staging/rtl8723au/include/rtw_cmd.h
+++ b/drivers/staging/rtl8723au/include/rtw_cmd.h
@@ -712,7 +712,6 @@ int rtw_ps_cmd23a(struct rtw_adapter*padapter);
 int rtw_chk_hi_queue_cmd23a(struct rtw_adapter*padapter);
 #endif
 
-int rtw_set_chplan_cmd(struct rtw_adapter*padapter, u8 chplan, u8 enqueue);
 int rtw_led_blink_cmd(struct rtw_adapter*padapter, struct led_8723a *pLed);
 int rtw_set_csa_cmd(struct rtw_adapter*padapter, u8 new_ch_no);
 
diff --git a/drivers/staging/rtl8723au/include/rtw_eeprom.h b/drivers/staging/rtl8723au/include/rtw_eeprom.h
index a86f36e49..8addfe770 100644
--- a/drivers/staging/rtl8723au/include/rtw_eeprom.h
+++ b/drivers/staging/rtl8723au/include/rtw_eeprom.h
@@ -125,11 +125,4 @@ struct eeprom_priv {
 	u8		efuse_eeprom_data[HWSET_MAX_SIZE_512]; /* 92C:256bytes, 88E:512bytes, we use union set (512bytes) */
 };
 
-void eeprom_write16(struct rtw_adapter *padapter, u16 reg, u16 data);
-u16 eeprom_read16(struct rtw_adapter *padapter, u16 reg);
-void read_eeprom_content(struct rtw_adapter *padapter);
-void eeprom_read_sz(struct rtw_adapter *padapter, u16 reg, u8 *data, u32 sz);
-
-void read_eeprom_content_by_attrib(struct rtw_adapter *padapter);
-
 #endif  /* __RTL871X_EEPROM_H__ */
diff --git a/drivers/staging/rtl8723au/include/rtw_mlme_ext.h b/drivers/staging/rtl8723au/include/rtw_mlme_ext.h
index 0e7d3da91..4a54c4fa3 100644
--- a/drivers/staging/rtl8723au/include/rtw_mlme_ext.h
+++ b/drivers/staging/rtl8723au/include/rtw_mlme_ext.h
@@ -406,7 +406,7 @@ struct p2p_oper_class_map {
 struct mlme_ext_priv {
 	struct rtw_adapter	*padapter;
 	u8	mlmeext_init;
-	atomic_t		event_seq;
+	atomic_unchecked_t	event_seq;
 	u16	mgnt_seq;
 
 	/* struct fw_priv	fwpriv; */
@@ -541,8 +541,6 @@ void report_add_sta_event23a(struct rtw_adapter *padapter,
 			  unsigned char *MacAddr, int cam_idx);
 
 int set_tx_beacon_cmd23a(struct rtw_adapter*padapter);
-unsigned int setup_beacon_frame(struct rtw_adapter *padapter,
-				unsigned char *beacon_frame);
 void update_mgnt_tx_rate23a(struct rtw_adapter *padapter, u8 rate);
 void update_mgntframe_attrib23a(struct rtw_adapter *padapter,
 			     struct pkt_attrib *pattrib);
@@ -595,14 +593,6 @@ struct cmd_hdl {
 };
 
 
-int read_macreg_hdl(struct rtw_adapter *padapter, u8 *pbuf);
-int write_macreg_hdl(struct rtw_adapter *padapter, u8 *pbuf);
-int read_bbreg_hdl(struct rtw_adapter *padapter, u8 *pbuf);
-int write_bbreg_hdl(struct rtw_adapter *padapter, u8 *pbuf);
-int read_rfreg_hdl(struct rtw_adapter *padapter, u8 *pbuf);
-int write_rfreg_hdl(struct rtw_adapter *padapter, u8 *pbuf);
-
-
 int NULL_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
 int join_cmd_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
 int disconnect_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
@@ -612,8 +602,6 @@ int sitesurvey_cmd_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
 int setauth_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
 int setkey_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
 int set_stakey_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
-int set_assocsta_hdl(struct rtw_adapter *padapter, const u8 *pbuf);
-int del_assocsta_hdl(struct rtw_adapter *padapter, const u8 *pbuf);
 int add_ba_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
 
 int mlme_evt_hdl23a(struct rtw_adapter *padapter, const u8 *pbuf);
diff --git a/drivers/staging/rtl8723au/include/usb_ops.h b/drivers/staging/rtl8723au/include/usb_ops.h
index ff11e13b2..22a13acac 100644
--- a/drivers/staging/rtl8723au/include/usb_ops.h
+++ b/drivers/staging/rtl8723au/include/usb_ops.h
@@ -36,9 +36,9 @@ enum {
 
 void rtl8723au_set_hw_type(struct rtw_adapter *padapter);
 
-void rtl8723au_recv_tasklet(void *priv);
+void rtl8723au_recv_tasklet(unsigned long priv);
 
-void rtl8723au_xmit_tasklet(void *priv);
+void rtl8723au_xmit_tasklet(unsigned long priv);
 
 /* Increase and check if the continual_urb_error of this @param dvobjprive is
  * larger than MAX_CONTINUAL_URB_ERR. Return result
@@ -48,7 +48,7 @@ static inline int rtw_inc_and_chk_continual_urb_error(struct dvobj_priv *dvobj)
 	int ret = false;
 	int value;
 
-	value = atomic_inc_return(&dvobj->continual_urb_error);
+	value = atomic_inc_return_unchecked(&dvobj->continual_urb_error);
 	if (value > MAX_CONTINUAL_URB_ERR) {
 		DBG_8723A("[dvobj:%p][ERROR] continual_urb_error:%d > %d\n",
 			  dvobj, value, MAX_CONTINUAL_URB_ERR);
@@ -60,7 +60,7 @@ static inline int rtw_inc_and_chk_continual_urb_error(struct dvobj_priv *dvobj)
 /* Set the continual_urb_error of this @param dvobjprive to 0 */
 static inline void rtw_reset_continual_urb_error(struct dvobj_priv *dvobj)
 {
-	atomic_set(&dvobj->continual_urb_error, 0);
+	atomic_set_unchecked(&dvobj->continual_urb_error, 0);
 }
 
 bool rtl8723au_chip_configure(struct rtw_adapter *padapter);
diff --git a/drivers/staging/rtl8723au/include/xmit_osdep.h b/drivers/staging/rtl8723au/include/xmit_osdep.h
index 2be04c486..a494e09ae 100644
--- a/drivers/staging/rtl8723au/include/xmit_osdep.h
+++ b/drivers/staging/rtl8723au/include/xmit_osdep.h
@@ -21,7 +21,7 @@
 
 #define NR_XMITFRAME	256
 
-int rtw_xmit23a_entry23a(struct sk_buff *pkt, struct net_device *pnetdev);
+netdev_tx_t rtw_xmit23a_entry23a(struct sk_buff *pkt, struct net_device *pnetdev);
 
 void rtw_os_xmit_schedule23a(struct rtw_adapter *padapter);
 
diff --git a/drivers/staging/rtl8723au/os_dep/ioctl_cfg80211.c b/drivers/staging/rtl8723au/os_dep/ioctl_cfg80211.c
index d0ba37789..884c9d7d9 100644
--- a/drivers/staging/rtl8723au/os_dep/ioctl_cfg80211.c
+++ b/drivers/staging/rtl8723au/os_dep/ioctl_cfg80211.c
@@ -2435,7 +2435,7 @@ static int rtw_cfg80211_monitor_if_close(struct net_device *ndev)
 	return 0;
 }
 
-static int rtw_cfg80211_monitor_if_xmit_entry(struct sk_buff *skb,
+static netdev_tx_t rtw_cfg80211_monitor_if_xmit_entry(struct sk_buff *skb,
 					      struct net_device *ndev)
 {
 	int ret = 0;
diff --git a/drivers/staging/rtl8723au/os_dep/xmit_linux.c b/drivers/staging/rtl8723au/os_dep/xmit_linux.c
index 64be72ac3..d0d2f81a8 100644
--- a/drivers/staging/rtl8723au/os_dep/xmit_linux.c
+++ b/drivers/staging/rtl8723au/os_dep/xmit_linux.c
@@ -117,7 +117,7 @@ static void rtw_check_xmit_resource(struct rtw_adapter *padapter,
 	}
 }
 
-int rtw_xmit23a_entry23a(struct sk_buff *skb, struct net_device *pnetdev)
+netdev_tx_t rtw_xmit23a_entry23a(struct sk_buff *skb, struct net_device *pnetdev)
 {
 	struct rtw_adapter *padapter = netdev_priv(pnetdev);
 	struct xmit_priv *pxmitpriv = &padapter->xmitpriv;
diff --git a/drivers/staging/sm750fb/sm750.c b/drivers/staging/sm750fb/sm750.c
index 6ed004e40..f8ebf0834 100644
--- a/drivers/staging/sm750fb/sm750.c
+++ b/drivers/staging/sm750fb/sm750.c
@@ -725,6 +725,7 @@ static struct fb_ops lynxfb_ops = {
 	.fb_set_par = lynxfb_ops_set_par,
 	.fb_setcolreg = lynxfb_ops_setcolreg,
 	.fb_blank = lynxfb_ops_blank,
+	.fb_pan_display = lynxfb_ops_pan_display,
 	.fb_fillrect = cfb_fillrect,
 	.fb_imageblit = cfb_imageblit,
 	.fb_copyarea = cfb_copyarea,
@@ -770,7 +771,6 @@ static int lynxfb_set_fbinfo(struct fb_info *info, int index)
 	par->index = index;
 	output->channel = &crtc->channel;
 	sm750fb_set_drv(par);
-	lynxfb_ops.fb_pan_display = lynxfb_ops_pan_display;
 
 	/*
 	 * set current cursor variable and proc pointer,
@@ -787,16 +787,20 @@ static int lynxfb_set_fbinfo(struct fb_info *info, int index)
 
 	memset_io(crtc->cursor.vstart, 0, crtc->cursor.size);
 	if (!g_hwcursor) {
-		lynxfb_ops.fb_cursor = NULL;
+		pax_open_kernel();
+		const_cast(lynxfb_ops.fb_cursor) = NULL;
+		pax_close_kernel();
 		hw_cursor_disable(&crtc->cursor);
 	}
 
 	/* set info->fbops, must be set before fb_find_mode */
 	if (!sm750_dev->accel_off) {
 		/* use 2d acceleration */
-		lynxfb_ops.fb_fillrect = lynxfb_ops_fillrect;
-		lynxfb_ops.fb_copyarea = lynxfb_ops_copyarea;
-		lynxfb_ops.fb_imageblit = lynxfb_ops_imageblit;
+		pax_open_kernel();
+		const_cast(lynxfb_ops.fb_fillrect) = lynxfb_ops_fillrect;
+		const_cast(lynxfb_ops.fb_copyarea) = lynxfb_ops_copyarea;
+		const_cast(lynxfb_ops.fb_imageblit) = lynxfb_ops_imageblit;
+		pax_close_kernel();
 	}
 	info->fbops = &lynxfb_ops;
 
diff --git a/drivers/staging/unisys/visorbus/visorbus_private.h b/drivers/staging/unisys/visorbus/visorbus_private.h
index 39edd2018..d860d0c09 100644
--- a/drivers/staging/unisys/visorbus/visorbus_private.h
+++ b/drivers/staging/unisys/visorbus/visorbus_private.h
@@ -34,7 +34,7 @@ struct visorchipset_busdev_notifiers {
 	void (*device_destroy)(struct visor_device *bus_info);
 	void (*device_pause)(struct visor_device *bus_info);
 	void (*device_resume)(struct visor_device *bus_info);
-};
+} __no_const;
 
 /*  These functions live inside visorchipset, and will be called to indicate
  *  responses to specific events (by code outside of visorchipset).
@@ -49,7 +49,7 @@ struct visorchipset_busdev_responders {
 	void (*device_destroy)(struct visor_device *p, int response);
 	void (*device_pause)(struct visor_device *p, int response);
 	void (*device_resume)(struct visor_device *p, int response);
-};
+} __no_const;
 
 /** Register functions (in the bus driver) to get called by visorchipset
  *  whenever a bus or device appears for which this guest is to be the
diff --git a/drivers/staging/unisys/visornic/visornic_main.c b/drivers/staging/unisys/visornic/visornic_main.c
index a28388d3d..6ae29290c 100644
--- a/drivers/staging/unisys/visornic/visornic_main.c
+++ b/drivers/staging/unisys/visornic/visornic_main.c
@@ -797,7 +797,7 @@ static inline bool vnic_hit_low_watermark(struct visornic_devdata *devdata,
  *	can be called again.
  *	Returns NETDEV_TX_OK.
  */
-static int
+static netdev_tx_t
 visornic_xmit(struct sk_buff *skb, struct net_device *netdev)
 {
 	struct visornic_devdata *devdata;
diff --git a/drivers/staging/vt6655/rxtx.c b/drivers/staging/vt6655/rxtx.c
index e4c3165ae..d0c9eeb65 100644
--- a/drivers/staging/vt6655/rxtx.c
+++ b/drivers/staging/vt6655/rxtx.c
@@ -1243,7 +1243,7 @@ static void vnt_fill_txkey(struct ieee80211_hdr *hdr, u8 *key_buffer,
 		mic_hdr->payload_len = cpu_to_be16(payload_len);
 		ether_addr_copy(mic_hdr->mic_addr2, hdr->addr2);
 
-		pn64 = atomic64_read(&tx_key->tx_pn);
+		pn64 = atomic64_read_unchecked(&tx_key->tx_pn);
 		mic_hdr->ccmp_pn[5] = pn64;
 		mic_hdr->ccmp_pn[4] = pn64 >> 8;
 		mic_hdr->ccmp_pn[3] = pn64 >> 16;
diff --git a/drivers/staging/vt6656/rxtx.c b/drivers/staging/vt6656/rxtx.c
index aa59e7f14..094dd59cd 100644
--- a/drivers/staging/vt6656/rxtx.c
+++ b/drivers/staging/vt6656/rxtx.c
@@ -749,7 +749,7 @@ static void vnt_fill_txkey(struct vnt_usb_send_context *tx_context,
 		mic_hdr->payload_len = cpu_to_be16(payload_len);
 		ether_addr_copy(mic_hdr->mic_addr2, hdr->addr2);
 
-		pn64 = atomic64_read(&tx_key->tx_pn);
+		pn64 = atomic64_read_unchecked(&tx_key->tx_pn);
 		mic_hdr->ccmp_pn[5] = pn64;
 		mic_hdr->ccmp_pn[4] = pn64 >> 8;
 		mic_hdr->ccmp_pn[3] = pn64 >> 16;
diff --git a/drivers/staging/wilc1000/host_interface.h b/drivers/staging/wilc1000/host_interface.h
index ddfea29df..5305b3846 100644
--- a/drivers/staging/wilc1000/host_interface.h
+++ b/drivers/staging/wilc1000/host_interface.h
@@ -1,6 +1,7 @@
 #ifndef HOST_INT_H
 #define HOST_INT_H
 
+#include <linux/netdevice.h>
 #include "coreconfigurator.h"
 
 #define IP_ALEN  4
diff --git a/drivers/staging/wilc1000/linux_wlan.c b/drivers/staging/wilc1000/linux_wlan.c
index ad6684916..cb1c02581 100644
--- a/drivers/staging/wilc1000/linux_wlan.c
+++ b/drivers/staging/wilc1000/linux_wlan.c
@@ -983,7 +983,7 @@ static void linux_wlan_tx_complete(void *priv, int status)
 	kfree(pv_data);
 }
 
-int wilc_mac_xmit(struct sk_buff *skb, struct net_device *ndev)
+netdev_tx_t wilc_mac_xmit(struct sk_buff *skb, struct net_device *ndev)
 {
 	struct wilc_vif *vif;
 	struct tx_complete_data *tx_data = NULL;
diff --git a/drivers/staging/wilc1000/wilc_spi.c b/drivers/staging/wilc1000/wilc_spi.c
index 22cf4b785..2684b572a 100644
--- a/drivers/staging/wilc1000/wilc_spi.c
+++ b/drivers/staging/wilc1000/wilc_spi.c
@@ -19,6 +19,7 @@
 #include <linux/of_gpio.h>
 
 #include <linux/string.h>
+#include <linux/netdevice.h>
 #include "wilc_wlan_if.h"
 #include "wilc_wlan.h"
 #include "wilc_wfi_netdevice.h"
diff --git a/drivers/staging/wilc1000/wilc_wlan.h b/drivers/staging/wilc1000/wilc_wlan.h
index 30e5312ee..1493a7391 100644
--- a/drivers/staging/wilc1000/wilc_wlan.h
+++ b/drivers/staging/wilc1000/wilc_wlan.h
@@ -295,7 +295,7 @@ void wilc_chip_sleep_manually(struct wilc *wilc);
 
 void wilc_enable_tcp_ack_filter(bool value);
 int wilc_wlan_get_num_conn_ifcs(struct wilc *);
-int wilc_mac_xmit(struct sk_buff *skb, struct net_device *dev);
+netdev_tx_t wilc_mac_xmit(struct sk_buff *skb, struct net_device *dev);
 
 int wilc_mac_open(struct net_device *ndev);
 int wilc_mac_close(struct net_device *ndev);
diff --git a/drivers/staging/wlan-ng/p80211netdev.c b/drivers/staging/wlan-ng/p80211netdev.c
index 90cc8cdcf..56170254c 100644
--- a/drivers/staging/wlan-ng/p80211netdev.c
+++ b/drivers/staging/wlan-ng/p80211netdev.c
@@ -94,7 +94,7 @@
 static int p80211knetdev_init(netdevice_t *netdev);
 static int p80211knetdev_open(netdevice_t *netdev);
 static int p80211knetdev_stop(netdevice_t *netdev);
-static int p80211knetdev_hard_start_xmit(struct sk_buff *skb,
+static netdev_tx_t p80211knetdev_hard_start_xmit(struct sk_buff *skb,
 					 netdevice_t *netdev);
 static void p80211knetdev_set_multicast_list(netdevice_t *dev);
 static int p80211knetdev_do_ioctl(netdevice_t *dev, struct ifreq *ifr,
@@ -317,7 +317,7 @@ static void p80211netdev_rx_bh(unsigned long arg)
 * Returns:
 *	zero on success, non-zero on failure.
 ----------------------------------------------------------------*/
-static int p80211knetdev_hard_start_xmit(struct sk_buff *skb,
+static netdev_tx_t p80211knetdev_hard_start_xmit(struct sk_buff *skb,
 					 netdevice_t *netdev)
 {
 	int result = 0;
diff --git a/drivers/target/sbp/sbp_target.c b/drivers/target/sbp/sbp_target.c
index 58bb6ed18..d77a7e332 100644
--- a/drivers/target/sbp/sbp_target.c
+++ b/drivers/target/sbp/sbp_target.c
@@ -56,7 +56,7 @@ static const u32 sbp_unit_directory_template[] = {
 
 #define SESSION_MAINTENANCE_INTERVAL HZ
 
-static atomic_t login_id = ATOMIC_INIT(0);
+static atomic_unchecked_t login_id = ATOMIC_INIT(0);
 
 static void session_maintenance_work(struct work_struct *);
 static int sbp_run_transaction(struct fw_card *, int, int, int, int,
@@ -422,7 +422,7 @@ static void sbp_management_request_login(
 	login->login_lun = unpacked_lun;
 	login->status_fifo_addr = sbp2_pointer_to_addr(&req->orb.status_fifo);
 	login->exclusive = LOGIN_ORB_EXCLUSIVE(be32_to_cpu(req->orb.misc));
-	login->login_id = atomic_inc_return(&login_id);
+	login->login_id = atomic_inc_return_unchecked(&login_id);
 
 	login->tgt_agt = sbp_target_agent_register(login);
 	if (IS_ERR(login->tgt_agt)) {
diff --git a/drivers/thermal/devfreq_cooling.c b/drivers/thermal/devfreq_cooling.c
index 01f0015f8..aa5655196 100644
--- a/drivers/thermal/devfreq_cooling.c
+++ b/drivers/thermal/devfreq_cooling.c
@@ -363,6 +363,15 @@ static struct thermal_cooling_device_ops devfreq_cooling_ops = {
 	.set_cur_state = devfreq_cooling_set_cur_state,
 };
 
+static struct thermal_cooling_device_ops devfreq_cooling_power_ops = {
+	.get_max_state = devfreq_cooling_get_max_state,
+	.get_cur_state = devfreq_cooling_get_cur_state,
+	.set_cur_state = devfreq_cooling_set_cur_state,
+	.get_requested_power = devfreq_cooling_get_requested_power,
+	.state2power = devfreq_cooling_state2power,
+	.power2state = devfreq_cooling_power2state,
+};
+
 /**
  * devfreq_cooling_gen_tables() - Generate power and freq tables.
  * @dfc: Pointer to devfreq cooling device.
@@ -482,15 +491,9 @@ of_devfreq_cooling_register_power(struct device_node *np, struct devfreq *df,
 
 	dfc->devfreq = df;
 
-	if (dfc_power) {
+	if (dfc_power)
 		dfc->power_ops = dfc_power;
 
-		devfreq_cooling_ops.get_requested_power =
-			devfreq_cooling_get_requested_power;
-		devfreq_cooling_ops.state2power = devfreq_cooling_state2power;
-		devfreq_cooling_ops.power2state = devfreq_cooling_power2state;
-	}
-
 	err = devfreq_cooling_gen_tables(dfc);
 	if (err)
 		goto free_dfc;
@@ -502,7 +505,7 @@ of_devfreq_cooling_register_power(struct device_node *np, struct devfreq *df,
 	snprintf(dev_name, sizeof(dev_name), "thermal-devfreq-%d", dfc->id);
 
 	cdev = thermal_of_cooling_device_register(np, dev_name, dfc,
-						  &devfreq_cooling_ops);
+						  dfc_power ? &devfreq_cooling_power_ops : &devfreq_cooling_ops);
 	if (IS_ERR(cdev)) {
 		err = PTR_ERR(cdev);
 		dev_err(df->dev.parent,
diff --git a/drivers/thermal/int340x_thermal/int3400_thermal.c b/drivers/thermal/int340x_thermal/int3400_thermal.c
index 5836e5554..708bbd655 100644
--- a/drivers/thermal/int340x_thermal/int3400_thermal.c
+++ b/drivers/thermal/int340x_thermal/int3400_thermal.c
@@ -272,8 +272,10 @@ static int int3400_thermal_probe(struct platform_device *pdev)
 	platform_set_drvdata(pdev, priv);
 
 	if (priv->uuid_bitmap & 1 << INT3400_THERMAL_PASSIVE_1) {
-		int3400_thermal_ops.get_mode = int3400_thermal_get_mode;
-		int3400_thermal_ops.set_mode = int3400_thermal_set_mode;
+		pax_open_kernel();
+		const_cast(int3400_thermal_ops.get_mode) = int3400_thermal_get_mode;
+		const_cast(int3400_thermal_ops.set_mode) = int3400_thermal_set_mode;
+		pax_close_kernel();
 	}
 	priv->thermal = thermal_zone_device_register("INT3400 Thermal", 0, 0,
 						priv, &int3400_thermal_ops,
diff --git a/drivers/thermal/of-thermal.c b/drivers/thermal/of-thermal.c
index b8e509c60..f12be018b 100644
--- a/drivers/thermal/of-thermal.c
+++ b/drivers/thermal/of-thermal.c
@@ -31,6 +31,7 @@
 #include <linux/export.h>
 #include <linux/string.h>
 #include <linux/thermal.h>
+#include <linux/mm.h>
 
 #include "thermal_core.h"
 
@@ -425,9 +426,11 @@ thermal_zone_of_add_sensor(struct device_node *zone,
 	tz->ops = ops;
 	tz->sensor_data = data;
 
-	tzd->ops->get_temp = of_thermal_get_temp;
-	tzd->ops->get_trend = of_thermal_get_trend;
-	tzd->ops->set_emul_temp = of_thermal_set_emul_temp;
+	pax_open_kernel();
+	const_cast(tzd->ops->get_temp) = of_thermal_get_temp;
+	const_cast(tzd->ops->get_trend) = of_thermal_get_trend;
+	const_cast(tzd->ops->set_emul_temp) = of_thermal_set_emul_temp;
+	pax_close_kernel();
 	mutex_unlock(&tzd->lock);
 
 	return tzd;
@@ -553,9 +556,11 @@ void thermal_zone_of_sensor_unregister(struct device *dev,
 		return;
 
 	mutex_lock(&tzd->lock);
-	tzd->ops->get_temp = NULL;
-	tzd->ops->get_trend = NULL;
-	tzd->ops->set_emul_temp = NULL;
+	pax_open_kernel();
+	const_cast(tzd->ops->get_temp) = NULL;
+	const_cast(tzd->ops->get_trend) = NULL;
+	const_cast(tzd->ops->set_emul_temp) = NULL;
+	pax_close_kernel();
 
 	tz->ops = NULL;
 	tz->sensor_data = NULL;
diff --git a/drivers/thermal/x86_pkg_temp_thermal.c b/drivers/thermal/x86_pkg_temp_thermal.c
index 97f0a2bd9..5fa3381b5 100644
--- a/drivers/thermal/x86_pkg_temp_thermal.c
+++ b/drivers/thermal/x86_pkg_temp_thermal.c
@@ -567,7 +567,7 @@ static int pkg_temp_thermal_cpu_callback(struct notifier_block *nfb,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block pkg_temp_thermal_notifier __refdata = {
+static struct notifier_block pkg_temp_thermal_notifier = {
 	.notifier_call = pkg_temp_thermal_cpu_callback,
 };
 
diff --git a/drivers/tty/cyclades.c b/drivers/tty/cyclades.c
index c3e1604fe..3c921fab2 100644
--- a/drivers/tty/cyclades.c
+++ b/drivers/tty/cyclades.c
@@ -1568,10 +1568,10 @@ static int cy_open(struct tty_struct *tty, struct file *filp)
 	printk(KERN_DEBUG "cyc:cy_open ttyC%d, count = %d\n", info->line,
 			info->port.count);
 #endif
-	info->port.count++;
+	atomic_inc(&info->port.count);
 #ifdef CY_DEBUG_COUNT
 	printk(KERN_DEBUG "cyc:cy_open (%d): incrementing count to %d\n",
-		current->pid, info->port.count);
+		current->pid, atomic_read(&info->port.count));
 #endif
 
 	/*
@@ -3947,7 +3947,7 @@ static int cyclades_proc_show(struct seq_file *m, void *v)
 		for (j = 0; j < cy_card[i].nports; j++) {
 			info = &cy_card[i].ports[j];
 
-			if (info->port.count) {
+			if (atomic_read(&info->port.count)) {
 				/* XXX is the ldisc num worth this? */
 				struct tty_struct *tty;
 				struct tty_ldisc *ld;
diff --git a/drivers/tty/hvc/hvc_console.c b/drivers/tty/hvc/hvc_console.c
index ce8648753..c64337636 100644
--- a/drivers/tty/hvc/hvc_console.c
+++ b/drivers/tty/hvc/hvc_console.c
@@ -143,7 +143,9 @@ static uint32_t vtermnos[MAX_NR_HVC_CONSOLES] =
 static void hvc_console_print(struct console *co, const char *b,
 			      unsigned count)
 {
-	char c[N_OUTBUF] __ALIGNED__;
+	char c_stack[N_OUTBUF] __ALIGNED__;
+	char *c_alloc = NULL;
+	char *c;
 	unsigned i = 0, n = 0;
 	int r, donecr = 0, index = co->index;
 
@@ -155,8 +157,13 @@ static void hvc_console_print(struct console *co, const char *b,
 	if (vtermnos[index] == -1)
 		return;
 
+	if (slab_is_available())
+		c = c_alloc = kmalloc(N_OUTBUF, GFP_ATOMIC);
+	else
+		c = c_stack;
+
 	while (count > 0 || i > 0) {
-		if (count > 0 && i < sizeof(c)) {
+		if (count > 0 && i < sizeof(c_stack)) {
 			if (b[n] == '\n' && !donecr) {
 				c[i++] = '\r';
 				donecr = 1;
@@ -179,6 +186,8 @@ static void hvc_console_print(struct console *co, const char *b,
 			}
 		}
 	}
+
+	kfree(c_alloc);
 }
 
 static struct tty_driver *hvc_console_device(struct console *c, int *index)
@@ -343,7 +352,7 @@ static int hvc_open(struct tty_struct *tty, struct file * filp)
 
 	spin_lock_irqsave(&hp->port.lock, flags);
 	/* Check and then increment for fast path open. */
-	if (hp->port.count++ > 0) {
+	if (atomic_inc_return(&hp->port.count) > 1) {
 		spin_unlock_irqrestore(&hp->port.lock, flags);
 		hvc_kick();
 		return 0;
@@ -398,7 +407,7 @@ static void hvc_close(struct tty_struct *tty, struct file * filp)
 
 	spin_lock_irqsave(&hp->port.lock, flags);
 
-	if (--hp->port.count == 0) {
+	if (atomic_dec_return(&hp->port.count) == 0) {
 		spin_unlock_irqrestore(&hp->port.lock, flags);
 		/* We are done with the tty pointer now. */
 		tty_port_tty_set(&hp->port, NULL);
@@ -420,9 +429,9 @@ static void hvc_close(struct tty_struct *tty, struct file * filp)
 		 */
 		tty_wait_until_sent(tty, HVC_CLOSE_WAIT);
 	} else {
-		if (hp->port.count < 0)
+		if (atomic_read(&hp->port.count) < 0)
 			printk(KERN_ERR "hvc_close %X: oops, count is %d\n",
-				hp->vtermno, hp->port.count);
+				hp->vtermno, atomic_read(&hp->port.count));
 		spin_unlock_irqrestore(&hp->port.lock, flags);
 	}
 }
@@ -452,12 +461,12 @@ static void hvc_hangup(struct tty_struct *tty)
 	 * open->hangup case this can be called after the final close so prevent
 	 * that from happening for now.
 	 */
-	if (hp->port.count <= 0) {
+	if (atomic_read(&hp->port.count) <= 0) {
 		spin_unlock_irqrestore(&hp->port.lock, flags);
 		return;
 	}
 
-	hp->port.count = 0;
+	atomic_set(&hp->port.count, 0);
 	spin_unlock_irqrestore(&hp->port.lock, flags);
 	tty_port_tty_set(&hp->port, NULL);
 
@@ -505,7 +514,7 @@ static int hvc_write(struct tty_struct *tty, const unsigned char *buf, int count
 		return -EPIPE;
 
 	/* FIXME what's this (unprotected) check for? */
-	if (hp->port.count <= 0)
+	if (atomic_read(&hp->port.count) <= 0)
 		return -EIO;
 
 	spin_lock_irqsave(&hp->lock, flags);
diff --git a/drivers/tty/hvc/hvcs.c b/drivers/tty/hvc/hvcs.c
index 3c4d7c2b4..3410b8699 100644
--- a/drivers/tty/hvc/hvcs.c
+++ b/drivers/tty/hvc/hvcs.c
@@ -83,6 +83,7 @@
 #include <asm/hvcserver.h>
 #include <asm/uaccess.h>
 #include <asm/vio.h>
+#include <asm/local.h>
 
 /*
  * 1.3.0 -> 1.3.1 In hvcs_open memset(..,0x00,..) instead of memset(..,0x3F,00).
@@ -416,7 +417,7 @@ static ssize_t hvcs_vterm_state_store(struct device *dev, struct device_attribut
 
 	spin_lock_irqsave(&hvcsd->lock, flags);
 
-	if (hvcsd->port.count > 0) {
+	if (atomic_read(&hvcsd->port.count) > 0) {
 		spin_unlock_irqrestore(&hvcsd->lock, flags);
 		printk(KERN_INFO "HVCS: vterm state unchanged.  "
 				"The hvcs device node is still in use.\n");
@@ -1127,7 +1128,7 @@ static int hvcs_install(struct tty_driver *driver, struct tty_struct *tty)
 		}
 	}
 
-	hvcsd->port.count = 0;
+	atomic_set(&hvcsd->port.count, 0);
 	hvcsd->port.tty = tty;
 	tty->driver_data = hvcsd;
 
@@ -1180,7 +1181,7 @@ static int hvcs_open(struct tty_struct *tty, struct file *filp)
 	unsigned long flags;
 
 	spin_lock_irqsave(&hvcsd->lock, flags);
-	hvcsd->port.count++;
+	atomic_inc(&hvcsd->port.count);
 	hvcsd->todo_mask |= HVCS_SCHED_READ;
 	spin_unlock_irqrestore(&hvcsd->lock, flags);
 
@@ -1216,7 +1217,7 @@ static void hvcs_close(struct tty_struct *tty, struct file *filp)
 	hvcsd = tty->driver_data;
 
 	spin_lock_irqsave(&hvcsd->lock, flags);
-	if (--hvcsd->port.count == 0) {
+	if (atomic_dec_and_test(&hvcsd->port.count)) {
 
 		vio_disable_interrupts(hvcsd->vdev);
 
@@ -1241,10 +1242,10 @@ static void hvcs_close(struct tty_struct *tty, struct file *filp)
 
 		free_irq(irq, hvcsd);
 		return;
-	} else if (hvcsd->port.count < 0) {
+	} else if (atomic_read(&hvcsd->port.count) < 0) {
 		printk(KERN_ERR "HVCS: vty-server@%X open_count: %d"
 				" is missmanaged.\n",
-		hvcsd->vdev->unit_address, hvcsd->port.count);
+		hvcsd->vdev->unit_address, atomic_read(&hvcsd->port.count));
 	}
 
 	spin_unlock_irqrestore(&hvcsd->lock, flags);
@@ -1266,7 +1267,7 @@ static void hvcs_hangup(struct tty_struct * tty)
 
 	spin_lock_irqsave(&hvcsd->lock, flags);
 	/* Preserve this so that we know how many kref refs to put */
-	temp_open_count = hvcsd->port.count;
+	temp_open_count = atomic_read(&hvcsd->port.count);
 
 	/*
 	 * Don't kref put inside the spinlock because the destruction
@@ -1281,7 +1282,7 @@ static void hvcs_hangup(struct tty_struct * tty)
 	tty->driver_data = NULL;
 	hvcsd->port.tty = NULL;
 
-	hvcsd->port.count = 0;
+	atomic_set(&hvcsd->port.count, 0);
 
 	/* This will drop any buffered data on the floor which is OK in a hangup
 	 * scenario. */
@@ -1352,7 +1353,7 @@ static int hvcs_write(struct tty_struct *tty,
 	 * the middle of a write operation?  This is a crummy place to do this
 	 * but we want to keep it all in the spinlock.
 	 */
-	if (hvcsd->port.count <= 0) {
+	if (atomic_read(&hvcsd->port.count) <= 0) {
 		spin_unlock_irqrestore(&hvcsd->lock, flags);
 		return -ENODEV;
 	}
@@ -1426,7 +1427,7 @@ static int hvcs_write_room(struct tty_struct *tty)
 {
 	struct hvcs_struct *hvcsd = tty->driver_data;
 
-	if (!hvcsd || hvcsd->port.count <= 0)
+	if (!hvcsd || atomic_read(&hvcsd->port.count) <= 0)
 		return 0;
 
 	return HVCS_BUFF_LEN - hvcsd->chars_in_buffer;
diff --git a/drivers/tty/hvc/hvsi.c b/drivers/tty/hvc/hvsi.c
index 96ce6bd1c..208f20acb 100644
--- a/drivers/tty/hvc/hvsi.c
+++ b/drivers/tty/hvc/hvsi.c
@@ -85,7 +85,7 @@ struct hvsi_struct {
 	int n_outbuf;
 	uint32_t vtermno;
 	uint32_t virq;
-	atomic_t seqno; /* HVSI packet sequence number */
+	atomic_unchecked_t seqno; /* HVSI packet sequence number */
 	uint16_t mctrl;
 	uint8_t state;  /* HVSI protocol state */
 	uint8_t flags;
@@ -297,7 +297,7 @@ static int hvsi_version_respond(struct hvsi_struct *hp, uint16_t query_seqno)
 
 	packet.hdr.type = VS_QUERY_RESPONSE_PACKET_HEADER;
 	packet.hdr.len = sizeof(struct hvsi_query_response);
-	packet.hdr.seqno = cpu_to_be16(atomic_inc_return(&hp->seqno));
+	packet.hdr.seqno = cpu_to_be16(atomic_inc_return_unchecked(&hp->seqno));
 	packet.verb = cpu_to_be16(VSV_SEND_VERSION_NUMBER);
 	packet.u.version = HVSI_VERSION;
 	packet.query_seqno = cpu_to_be16(query_seqno+1);
@@ -557,7 +557,7 @@ static int hvsi_query(struct hvsi_struct *hp, uint16_t verb)
 
 	packet.hdr.type = VS_QUERY_PACKET_HEADER;
 	packet.hdr.len = sizeof(struct hvsi_query);
-	packet.hdr.seqno = cpu_to_be16(atomic_inc_return(&hp->seqno));
+	packet.hdr.seqno = cpu_to_be16(atomic_inc_return_unchecked(&hp->seqno));
 	packet.verb = cpu_to_be16(verb);
 
 	pr_debug("%s: sending %i bytes\n", __func__, packet.hdr.len);
@@ -599,7 +599,7 @@ static int hvsi_set_mctrl(struct hvsi_struct *hp, uint16_t mctrl)
 	int wrote;
 
 	packet.hdr.type = VS_CONTROL_PACKET_HEADER;
-	packet.hdr.seqno = cpu_to_be16(atomic_inc_return(&hp->seqno));
+	packet.hdr.seqno = cpu_to_be16(atomic_inc_return_unchecked(&hp->seqno));
 	packet.hdr.len = sizeof(struct hvsi_control);
 	packet.verb = cpu_to_be16(VSV_SET_MODEM_CTL);
 	packet.mask = cpu_to_be32(HVSI_TSDTR);
@@ -682,7 +682,7 @@ static int hvsi_put_chars(struct hvsi_struct *hp, const char *buf, int count)
 	BUG_ON(count > HVSI_MAX_OUTGOING_DATA);
 
 	packet.hdr.type = VS_DATA_PACKET_HEADER;
-	packet.hdr.seqno = cpu_to_be16(atomic_inc_return(&hp->seqno));
+	packet.hdr.seqno = cpu_to_be16(atomic_inc_return_unchecked(&hp->seqno));
 	packet.hdr.len = count + sizeof(struct hvsi_header);
 	memcpy(&packet.data, buf, count);
 
@@ -699,7 +699,7 @@ static void hvsi_close_protocol(struct hvsi_struct *hp)
 	struct hvsi_control packet __ALIGNED__;
 
 	packet.hdr.type = VS_CONTROL_PACKET_HEADER;
-	packet.hdr.seqno = cpu_to_be16(atomic_inc_return(&hp->seqno));
+	packet.hdr.seqno = cpu_to_be16(atomic_inc_return_unchecked(&hp->seqno));
 	packet.hdr.len = 6;
 	packet.verb = cpu_to_be16(VSV_CLOSE_PROTOCOL);
 
@@ -727,7 +727,7 @@ static int hvsi_open(struct tty_struct *tty, struct file *filp)
 
 	tty_port_tty_set(&hp->port, tty);
 	spin_lock_irqsave(&hp->lock, flags);
-	hp->port.count++;
+	atomic_inc(&hp->port.count);
 	atomic_set(&hp->seqno, 0);
 	h_vio_signal(hp->vtermno, VIO_IRQ_ENABLE);
 	spin_unlock_irqrestore(&hp->lock, flags);
@@ -784,7 +784,7 @@ static void hvsi_close(struct tty_struct *tty, struct file *filp)
 
 	spin_lock_irqsave(&hp->lock, flags);
 
-	if (--hp->port.count == 0) {
+	if (atomic_dec_return(&hp->port.count) == 0) {
 		tty_port_tty_set(&hp->port, NULL);
 		hp->inbuf_end = hp->inbuf; /* discard remaining partial packets */
 
@@ -817,9 +817,9 @@ static void hvsi_close(struct tty_struct *tty, struct file *filp)
 
 			spin_lock_irqsave(&hp->lock, flags);
 		}
-	} else if (hp->port.count < 0)
+	} else if (atomic_read(&hp->port.count) < 0)
 		printk(KERN_ERR "hvsi_close %lu: oops, count is %d\n",
-		       hp - hvsi_ports, hp->port.count);
+		       hp - hvsi_ports, atomic_read(&hp->port.count));
 
 	spin_unlock_irqrestore(&hp->lock, flags);
 }
@@ -834,7 +834,7 @@ static void hvsi_hangup(struct tty_struct *tty)
 	tty_port_tty_set(&hp->port, NULL);
 
 	spin_lock_irqsave(&hp->lock, flags);
-	hp->port.count = 0;
+	atomic_set(&hp->port.count, 0);
 	hp->n_outbuf = 0;
 	spin_unlock_irqrestore(&hp->lock, flags);
 }
diff --git a/drivers/tty/hvc/hvsi_lib.c b/drivers/tty/hvc/hvsi_lib.c
index a270f0458..7c77b5d1e 100644
--- a/drivers/tty/hvc/hvsi_lib.c
+++ b/drivers/tty/hvc/hvsi_lib.c
@@ -8,7 +8,7 @@
 
 static int hvsi_send_packet(struct hvsi_priv *pv, struct hvsi_header *packet)
 {
-	packet->seqno = cpu_to_be16(atomic_inc_return(&pv->seqno));
+	packet->seqno = cpu_to_be16(atomic_inc_return_unchecked(&pv->seqno));
 
 	/* Assumes that always succeeds, works in practice */
 	return pv->put_chars(pv->termno, (char *)packet, packet->len);
@@ -20,7 +20,7 @@ static void hvsi_start_handshake(struct hvsi_priv *pv)
 
 	/* Reset state */
 	pv->established = 0;
-	atomic_set(&pv->seqno, 0);
+	atomic_set_unchecked(&pv->seqno, 0);
 
 	pr_devel("HVSI@%x: Handshaking started\n", pv->termno);
 
diff --git a/drivers/tty/ipwireless/tty.c b/drivers/tty/ipwireless/tty.c
index 2685d59d2..a63936a0a 100644
--- a/drivers/tty/ipwireless/tty.c
+++ b/drivers/tty/ipwireless/tty.c
@@ -28,6 +28,7 @@
 #include <linux/tty_driver.h>
 #include <linux/tty_flip.h>
 #include <linux/uaccess.h>
+#include <asm/local.h>
 
 #include "tty.h"
 #include "network.h"
@@ -93,10 +94,10 @@ static int ipw_open(struct tty_struct *linux_tty, struct file *filp)
 		return -ENODEV;
 
 	mutex_lock(&tty->ipw_tty_mutex);
-	if (tty->port.count == 0)
+	if (atomic_read(&tty->port.count) == 0)
 		tty->tx_bytes_queued = 0;
 
-	tty->port.count++;
+	atomic_inc(&tty->port.count);
 
 	tty->port.tty = linux_tty;
 	linux_tty->driver_data = tty;
@@ -112,9 +113,7 @@ static int ipw_open(struct tty_struct *linux_tty, struct file *filp)
 
 static void do_ipw_close(struct ipw_tty *tty)
 {
-	tty->port.count--;
-
-	if (tty->port.count == 0) {
+	if (atomic_dec_return(&tty->port.count) == 0) {
 		struct tty_struct *linux_tty = tty->port.tty;
 
 		if (linux_tty != NULL) {
@@ -135,7 +134,7 @@ static void ipw_hangup(struct tty_struct *linux_tty)
 		return;
 
 	mutex_lock(&tty->ipw_tty_mutex);
-	if (tty->port.count == 0) {
+	if (atomic_read(&tty->port.count) == 0) {
 		mutex_unlock(&tty->ipw_tty_mutex);
 		return;
 	}
@@ -158,7 +157,7 @@ void ipwireless_tty_received(struct ipw_tty *tty, unsigned char *data,
 
 	mutex_lock(&tty->ipw_tty_mutex);
 
-	if (!tty->port.count) {
+	if (!atomic_read(&tty->port.count)) {
 		mutex_unlock(&tty->ipw_tty_mutex);
 		return;
 	}
@@ -197,7 +196,7 @@ static int ipw_write(struct tty_struct *linux_tty,
 		return -ENODEV;
 
 	mutex_lock(&tty->ipw_tty_mutex);
-	if (!tty->port.count) {
+	if (!atomic_read(&tty->port.count)) {
 		mutex_unlock(&tty->ipw_tty_mutex);
 		return -EINVAL;
 	}
@@ -237,7 +236,7 @@ static int ipw_write_room(struct tty_struct *linux_tty)
 	if (!tty)
 		return -ENODEV;
 
-	if (!tty->port.count)
+	if (!atomic_read(&tty->port.count))
 		return -EINVAL;
 
 	room = IPWIRELESS_TX_QUEUE_SIZE - tty->tx_bytes_queued;
@@ -270,7 +269,7 @@ static int ipw_chars_in_buffer(struct tty_struct *linux_tty)
 	if (!tty)
 		return 0;
 
-	if (!tty->port.count)
+	if (!atomic_read(&tty->port.count))
 		return 0;
 
 	return tty->tx_bytes_queued;
@@ -351,7 +350,7 @@ static int ipw_tiocmget(struct tty_struct *linux_tty)
 	if (!tty)
 		return -ENODEV;
 
-	if (!tty->port.count)
+	if (!atomic_read(&tty->port.count))
 		return -EINVAL;
 
 	return get_control_lines(tty);
@@ -367,7 +366,7 @@ ipw_tiocmset(struct tty_struct *linux_tty,
 	if (!tty)
 		return -ENODEV;
 
-	if (!tty->port.count)
+	if (!atomic_read(&tty->port.count))
 		return -EINVAL;
 
 	return set_control_lines(tty, set, clear);
@@ -381,7 +380,7 @@ static int ipw_ioctl(struct tty_struct *linux_tty,
 	if (!tty)
 		return -ENODEV;
 
-	if (!tty->port.count)
+	if (!atomic_read(&tty->port.count))
 		return -EINVAL;
 
 	/* FIXME: Exactly how is the tty object locked here .. */
@@ -537,7 +536,7 @@ void ipwireless_tty_free(struct ipw_tty *tty)
 				 * are gone */
 				mutex_lock(&ttyj->ipw_tty_mutex);
 			}
-			while (ttyj->port.count)
+			while (atomic_read(&ttyj->port.count))
 				do_ipw_close(ttyj);
 			ipwireless_disassociate_network_ttys(network,
 							     ttyj->channel_idx);
diff --git a/drivers/tty/moxa.c b/drivers/tty/moxa.c
index feaa6edda..81bab86fd 100644
--- a/drivers/tty/moxa.c
+++ b/drivers/tty/moxa.c
@@ -1186,7 +1186,7 @@ static int moxa_open(struct tty_struct *tty, struct file *filp)
 	}
 
 	ch = &brd->ports[port % MAX_PORTS_PER_BOARD];
-	ch->port.count++;
+	atomic_inc(&ch->port.count);
 	tty->driver_data = ch;
 	tty_port_tty_set(&ch->port, tty);
 	mutex_lock(&ch->port.mutex);
diff --git a/drivers/tty/n_gsm.c b/drivers/tty/n_gsm.c
index 54cab59e2..3c05ac4ca 100644
--- a/drivers/tty/n_gsm.c
+++ b/drivers/tty/n_gsm.c
@@ -1644,7 +1644,7 @@ static struct gsm_dlci *gsm_dlci_alloc(struct gsm_mux *gsm, int addr)
 	spin_lock_init(&dlci->lock);
 	mutex_init(&dlci->mutex);
 	dlci->fifo = &dlci->_fifo;
-	if (kfifo_alloc(&dlci->_fifo, 4096, GFP_KERNEL) < 0) {
+	if (kfifo_alloc(&dlci->_fifo, 4096, GFP_KERNEL)) {
 		kfree(dlci);
 		return NULL;
 	}
@@ -2652,7 +2652,7 @@ static inline void muxnet_put(struct gsm_mux_net *mux_net)
 	kref_put(&mux_net->ref, net_free);
 }
 
-static int gsm_mux_net_start_xmit(struct sk_buff *skb,
+static netdev_tx_t gsm_mux_net_start_xmit(struct sk_buff *skb,
 				      struct net_device *net)
 {
 	struct gsm_mux_net *mux_net = netdev_priv(net);
@@ -2943,7 +2943,7 @@ static int gsmtty_open(struct tty_struct *tty, struct file *filp)
 	struct gsm_dlci *dlci = tty->driver_data;
 	struct tty_port *port = &dlci->port;
 
-	port->count++;
+	atomic_inc(&port->count);
 	tty_port_tty_set(port, tty);
 
 	dlci->modem_rx = 0;
diff --git a/drivers/tty/n_tty.c b/drivers/tty/n_tty.c
index bdf0e6e89..ea92f7e59 100644
--- a/drivers/tty/n_tty.c
+++ b/drivers/tty/n_tty.c
@@ -1478,7 +1478,7 @@ n_tty_receive_char_lnext(struct tty_struct *tty, unsigned char c, char flag)
 
 static void
 n_tty_receive_buf_real_raw(struct tty_struct *tty, const unsigned char *cp,
-			   char *fp, int count)
+			   char *fp, size_t count)
 {
 	struct n_tty_data *ldata = tty->disc_data;
 	size_t n, head;
@@ -1498,7 +1498,7 @@ n_tty_receive_buf_real_raw(struct tty_struct *tty, const unsigned char *cp,
 
 static void
 n_tty_receive_buf_raw(struct tty_struct *tty, const unsigned char *cp,
-		      char *fp, int count)
+		      char *fp, size_t count)
 {
 	struct n_tty_data *ldata = tty->disc_data;
 	char flag = TTY_NORMAL;
@@ -1515,7 +1515,7 @@ n_tty_receive_buf_raw(struct tty_struct *tty, const unsigned char *cp,
 
 static void
 n_tty_receive_buf_closing(struct tty_struct *tty, const unsigned char *cp,
-			  char *fp, int count)
+			  char *fp, size_t count)
 {
 	char flag = TTY_NORMAL;
 
@@ -1529,7 +1529,7 @@ n_tty_receive_buf_closing(struct tty_struct *tty, const unsigned char *cp,
 
 static void
 n_tty_receive_buf_standard(struct tty_struct *tty, const unsigned char *cp,
-			  char *fp, int count)
+			  char *fp, size_t count)
 {
 	struct n_tty_data *ldata = tty->disc_data;
 	char flag = TTY_NORMAL;
@@ -1563,7 +1563,7 @@ n_tty_receive_buf_standard(struct tty_struct *tty, const unsigned char *cp,
 
 static void
 n_tty_receive_buf_fast(struct tty_struct *tty, const unsigned char *cp,
-		       char *fp, int count)
+		       char *fp, size_t count)
 {
 	struct n_tty_data *ldata = tty->disc_data;
 	char flag = TTY_NORMAL;
@@ -1588,7 +1588,7 @@ n_tty_receive_buf_fast(struct tty_struct *tty, const unsigned char *cp,
 }
 
 static void __receive_buf(struct tty_struct *tty, const unsigned char *cp,
-			  char *fp, int count)
+			  char *fp, size_t count)
 {
 	struct n_tty_data *ldata = tty->disc_data;
 	bool preops = I_ISTRIP(tty) || (I_IUCLC(tty) && L_IEXTEN(tty));
@@ -1666,10 +1666,10 @@ static void __receive_buf(struct tty_struct *tty, const unsigned char *cp,
  */
 static int
 n_tty_receive_buf_common(struct tty_struct *tty, const unsigned char *cp,
-			 char *fp, int count, int flow)
+			 char *fp, size_t count, int flow)
 {
 	struct n_tty_data *ldata = tty->disc_data;
-	int room, n, rcvd = 0, overflow;
+	size_t room, n, rcvd = 0, overflow;
 
 	down_read(&tty->termios_rwsem);
 
@@ -1692,15 +1692,16 @@ n_tty_receive_buf_common(struct tty_struct *tty, const unsigned char *cp,
 		room = N_TTY_BUF_SIZE - (ldata->read_head - tail);
 		if (I_PARMRK(tty))
 			room = (room + 2) / 3;
-		room--;
-		if (room <= 0) {
+		if (room <= 1) {
 			overflow = ldata->icanon && ldata->canon_head == tail;
-			if (overflow && room < 0)
+			if (overflow && room == 0)
 				ldata->read_head--;
 			room = overflow;
 			ldata->no_room = flow && !room;
-		} else
+		} else {
+			room--;
 			overflow = 0;
+		}
 
 		n = min(count, room);
 		if (!n)
@@ -2465,7 +2466,8 @@ void n_tty_inherit_ops(struct tty_ldisc_ops *ops)
 {
 	*ops = n_tty_ops;
 	ops->owner = NULL;
-	ops->refcount = ops->flags = 0;
+	atomic_set(&ops->refcount, 0);
+	ops->flags = 0;
 }
 EXPORT_SYMBOL_GPL(n_tty_inherit_ops);
 
diff --git a/drivers/tty/pty.c b/drivers/tty/pty.c
index 51e0d3288..d1ac13c79 100644
--- a/drivers/tty/pty.c
+++ b/drivers/tty/pty.c
@@ -856,8 +856,10 @@ static void __init unix98_pty_init(void)
 		panic("Couldn't register Unix98 pts driver");
 
 	/* Now create the /dev/ptmx special device */
+	pax_open_kernel();
 	tty_default_fops(&ptmx_fops);
-	ptmx_fops.open = ptmx_open;
+	const_cast(ptmx_fops.open) = ptmx_open;
+	pax_close_kernel();
 
 	cdev_init(&ptmx_cdev, &ptmx_fops);
 	if (cdev_add(&ptmx_cdev, MKDEV(TTYAUX_MAJOR, 2), 1) ||
diff --git a/drivers/tty/rocket.c b/drivers/tty/rocket.c
index b0cc47c77..58ea7a908 100644
--- a/drivers/tty/rocket.c
+++ b/drivers/tty/rocket.c
@@ -906,7 +906,7 @@ static int rp_open(struct tty_struct *tty, struct file *filp)
 	tty->driver_data = info;
 	tty_port_tty_set(port, tty);
 
-	if (port->count++ == 0) {
+	if (atomic_inc_return(&port->count) == 1) {
 		atomic_inc(&rp_num_ports_open);
 
 #ifdef ROCKET_DEBUG_OPEN
@@ -915,7 +915,7 @@ static int rp_open(struct tty_struct *tty, struct file *filp)
 #endif
 	}
 #ifdef ROCKET_DEBUG_OPEN
-	printk(KERN_INFO "rp_open ttyR%d, count=%d\n", info->line, info->port.count);
+	printk(KERN_INFO "rp_open ttyR%d, count=%d\n", info->line, atomic-read(&info->port.count));
 #endif
 
 	/*
@@ -1500,7 +1500,7 @@ static void rp_hangup(struct tty_struct *tty)
 #endif
 	rp_flush_buffer(tty);
 	spin_lock_irqsave(&info->port.lock, flags);
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		atomic_dec(&rp_num_ports_open);
 	clear_bit((info->aiop * 8) + info->chan, (void *) &xmit_flags[info->board]);
 	spin_unlock_irqrestore(&info->port.lock, flags);
diff --git a/drivers/tty/serial/8250/8250_core.c b/drivers/tty/serial/8250/8250_core.c
index dcf43f664..594793aa0 100644
--- a/drivers/tty/serial/8250/8250_core.c
+++ b/drivers/tty/serial/8250/8250_core.c
@@ -488,9 +488,9 @@ static void univ8250_release_port(struct uart_port *port)
 
 static void univ8250_rsa_support(struct uart_ops *ops)
 {
-	ops->config_port  = univ8250_config_port;
-	ops->request_port = univ8250_request_port;
-	ops->release_port = univ8250_release_port;
+	const_cast(ops->config_port)  = univ8250_config_port;
+	const_cast(ops->request_port) = univ8250_request_port;
+	const_cast(ops->release_port) = univ8250_release_port;
 }
 
 #else
@@ -533,8 +533,10 @@ static void __init serial8250_isa_init_ports(void)
 	}
 
 	/* chain base port ops to support Remote Supervisor Adapter */
-	univ8250_port_ops = *base_ops;
+	pax_open_kernel();
+	memcpy((void *)&univ8250_port_ops, base_ops, sizeof univ8250_port_ops);
 	univ8250_rsa_support(&univ8250_port_ops);
+	pax_close_kernel();
 
 	if (share_irqs)
 		irqflag = IRQF_SHARED;
diff --git a/drivers/tty/serial/8250/8250_pci.c b/drivers/tty/serial/8250/8250_pci.c
index bc51b32b2..f947b5b00 100644
--- a/drivers/tty/serial/8250/8250_pci.c
+++ b/drivers/tty/serial/8250/8250_pci.c
@@ -5795,7 +5795,7 @@ static struct pci_device_id serial_pci_tbl[] = {
 };
 
 static pci_ers_result_t serial8250_io_error_detected(struct pci_dev *dev,
-						pci_channel_state_t state)
+						enum pci_channel_state state)
 {
 	struct serial_private *priv = pci_get_drvdata(dev);
 
diff --git a/drivers/tty/serial/ioc4_serial.c b/drivers/tty/serial/ioc4_serial.c
index e5c42fef6..f091b02ba 100644
--- a/drivers/tty/serial/ioc4_serial.c
+++ b/drivers/tty/serial/ioc4_serial.c
@@ -437,7 +437,7 @@ struct ioc4_soft {
 		} is_intr_info[MAX_IOC4_INTR_ENTS];
 
 		/* Number of entries active in the above array */
-		atomic_t is_num_intrs;
+		atomic_unchecked_t is_num_intrs;
 	} is_intr_type[IOC4_NUM_INTR_TYPES];
 
 	/* is_ir_lock must be held while
@@ -974,7 +974,7 @@ intr_connect(struct ioc4_soft *soft, int type,
 	BUG_ON(!((type == IOC4_SIO_INTR_TYPE)
 	       || (type == IOC4_OTHER_INTR_TYPE)));
 
-	i = atomic_inc_return(&soft-> is_intr_type[type].is_num_intrs) - 1;
+	i = atomic_inc_return_unchecked(&soft-> is_intr_type[type].is_num_intrs) - 1;
 	BUG_ON(!(i < MAX_IOC4_INTR_ENTS || (printk("i %d\n", i), 0)));
 
 	/* Save off the lower level interrupt handler */
@@ -1001,7 +1001,7 @@ static irqreturn_t ioc4_intr(int irq, void *arg)
 
 	soft = arg;
 	for (intr_type = 0; intr_type < IOC4_NUM_INTR_TYPES; intr_type++) {
-		num_intrs = (int)atomic_read(
+		num_intrs = (int)atomic_read_unchecked(
 				&soft->is_intr_type[intr_type].is_num_intrs);
 
 		this_mir = this_ir = pending_intrs(soft, intr_type);
diff --git a/drivers/tty/serial/jsm/jsm_driver.c b/drivers/tty/serial/jsm/jsm_driver.c
index a119f11bf..120444e0a 100644
--- a/drivers/tty/serial/jsm/jsm_driver.c
+++ b/drivers/tty/serial/jsm/jsm_driver.c
@@ -336,7 +336,7 @@ static struct pci_driver jsm_driver = {
 };
 
 static pci_ers_result_t jsm_io_error_detected(struct pci_dev *pdev,
-					pci_channel_state_t state)
+					enum pci_channel_state state)
 {
 	struct jsm_board *brd = pci_get_drvdata(pdev);
 
diff --git a/drivers/tty/serial/kgdb_nmi.c b/drivers/tty/serial/kgdb_nmi.c
index 117df1516..8f7486f5a 100644
--- a/drivers/tty/serial/kgdb_nmi.c
+++ b/drivers/tty/serial/kgdb_nmi.c
@@ -53,7 +53,9 @@ static int kgdb_nmi_console_setup(struct console *co, char *options)
 	 * I/O utilities that messages sent to the console will automatically
 	 * be displayed on the dbg_io.
 	 */
-	dbg_io_ops->is_console = true;
+	pax_open_kernel();
+	const_cast(dbg_io_ops->is_console) = true;
+	pax_close_kernel();
 
 	return 0;
 }
diff --git a/drivers/tty/serial/kgdboc.c b/drivers/tty/serial/kgdboc.c
index a260cde74..604fce994 100644
--- a/drivers/tty/serial/kgdboc.c
+++ b/drivers/tty/serial/kgdboc.c
@@ -24,8 +24,9 @@
 #define MAX_CONFIG_LEN		40
 
 static struct kgdb_io		kgdboc_io_ops;
+static struct kgdb_io		kgdboc_io_ops_console;
 
-/* -1 = init not run yet, 0 = unconfigured, 1 = configured. */
+/* -1 = init not run yet, 0 = unconfigured, 1/2 = configured. */
 static int configured		= -1;
 
 static char config[MAX_CONFIG_LEN];
@@ -151,6 +152,8 @@ static void cleanup_kgdboc(void)
 	kgdboc_unregister_kbd();
 	if (configured == 1)
 		kgdb_unregister_io_module(&kgdboc_io_ops);
+	else if (configured == 2)
+		kgdb_unregister_io_module(&kgdboc_io_ops_console);
 }
 
 static int configure_kgdboc(void)
@@ -160,13 +163,13 @@ static int configure_kgdboc(void)
 	int err;
 	char *cptr = config;
 	struct console *cons;
+	int is_console = 0;
 
 	err = kgdboc_option_setup(config);
 	if (err || !strlen(config) || isspace(config[0]))
 		goto noconfig;
 
 	err = -ENODEV;
-	kgdboc_io_ops.is_console = 0;
 	kgdb_tty_driver = NULL;
 
 	kgdboc_use_kms = 0;
@@ -187,7 +190,7 @@ static int configure_kgdboc(void)
 		int idx;
 		if (cons->device && cons->device(cons, &idx) == p &&
 		    idx == tty_line) {
-			kgdboc_io_ops.is_console = 1;
+			is_console = 1;
 			break;
 		}
 		cons = cons->next;
@@ -197,7 +200,13 @@ static int configure_kgdboc(void)
 	kgdb_tty_line = tty_line;
 
 do_register:
-	err = kgdb_register_io_module(&kgdboc_io_ops);
+	if (is_console) {
+		err = kgdb_register_io_module(&kgdboc_io_ops_console);
+		configured = 2;
+	} else {
+		err = kgdb_register_io_module(&kgdboc_io_ops);
+		configured = 1;
+	}
 	if (err)
 		goto noconfig;
 
@@ -205,8 +214,6 @@ do_register:
 	if (err)
 		goto nmi_con_failed;
 
-	configured = 1;
-
 	return 0;
 
 nmi_con_failed:
@@ -223,7 +230,7 @@ noconfig:
 static int __init init_kgdboc(void)
 {
 	/* Already configured? */
-	if (configured == 1)
+	if (configured >= 1)
 		return 0;
 
 	return configure_kgdboc();
@@ -245,7 +252,7 @@ static void kgdboc_put_char(u8 chr)
 					kgdb_tty_line, chr);
 }
 
-static int param_set_kgdboc_var(const char *kmessage, struct kernel_param *kp)
+static int param_set_kgdboc_var(const char *kmessage, const struct kernel_param *kp)
 {
 	int len = strlen(kmessage);
 
@@ -272,7 +279,7 @@ static int param_set_kgdboc_var(const char *kmessage, struct kernel_param *kp)
 	if (config[len - 1] == '\n')
 		config[len - 1] = '\0';
 
-	if (configured == 1)
+	if (configured >= 1)
 		cleanup_kgdboc();
 
 	/* Go and configure with the new params. */
@@ -312,6 +319,15 @@ static struct kgdb_io kgdboc_io_ops = {
 	.post_exception		= kgdboc_post_exp_handler,
 };
 
+static struct kgdb_io kgdboc_io_ops_console = {
+	.name			= "kgdboc",
+	.read_char		= kgdboc_get_char,
+	.write_char		= kgdboc_put_char,
+	.pre_exception		= kgdboc_pre_exp_handler,
+	.post_exception		= kgdboc_post_exp_handler,
+	.is_console		= 1
+};
+
 #ifdef CONFIG_KGDB_SERIAL_CONSOLE
 /* This is only available if kgdboc is a built in for early debugging */
 static int __init kgdboc_early_init(char *opt)
diff --git a/drivers/tty/serial/msm_serial.c b/drivers/tty/serial/msm_serial.c
index 7312e7e01..0a0f8b6da 100644
--- a/drivers/tty/serial/msm_serial.c
+++ b/drivers/tty/serial/msm_serial.c
@@ -1726,7 +1726,7 @@ static struct uart_driver msm_uart_driver = {
 	.cons = MSM_CONSOLE,
 };
 
-static atomic_t msm_uart_next_id = ATOMIC_INIT(0);
+static atomic_unchecked_t msm_uart_next_id = ATOMIC_INIT(0);
 
 static const struct of_device_id msm_uartdm_table[] = {
 	{ .compatible = "qcom,msm-uartdm-v1.1", .data = (void *)UARTDM_1P1 },
@@ -1750,7 +1750,7 @@ static int msm_serial_probe(struct platform_device *pdev)
 		line = pdev->id;
 
 	if (line < 0)
-		line = atomic_inc_return(&msm_uart_next_id) - 1;
+		line = atomic_inc_return_unchecked(&msm_uart_next_id) - 1;
 
 	if (unlikely(line < 0 || line >= UART_NR))
 		return -ENXIO;
diff --git a/drivers/tty/serial/samsung.c b/drivers/tty/serial/samsung.c
index ae2095a66..a3cec8354 100644
--- a/drivers/tty/serial/samsung.c
+++ b/drivers/tty/serial/samsung.c
@@ -976,11 +976,16 @@ static void s3c24xx_serial_shutdown(struct uart_port *port)
 	ourport->tx_in_progress = 0;
 }
 
+static int s3c64xx_serial_startup(struct uart_port *port);
 static int s3c24xx_serial_startup(struct uart_port *port)
 {
 	struct s3c24xx_uart_port *ourport = to_ourport(port);
 	int ret;
 
+	/* Startup sequence is different for s3c64xx and higher SoC's */
+	if (s3c24xx_serial_has_interrupt_mask(port))
+		return s3c64xx_serial_startup(port);
+
 	dbg("s3c24xx_serial_startup: port=%p (%08llx,%p)\n",
 	    port, (unsigned long long)port->mapbase, port->membase);
 
@@ -1687,10 +1692,6 @@ static int s3c24xx_serial_init_port(struct s3c24xx_uart_port *ourport,
 	/* setup info for port */
 	port->dev	= &platdev->dev;
 
-	/* Startup sequence is different for s3c64xx and higher SoC's */
-	if (s3c24xx_serial_has_interrupt_mask(port))
-		s3c24xx_serial_ops.startup = s3c64xx_serial_startup;
-
 	port->uartclk = 1;
 
 	if (cfg->uart_flags & UPF_CONS_FLOW) {
diff --git a/drivers/tty/serial/serial_core.c b/drivers/tty/serial/serial_core.c
index 9fc15335c..01c597244 100644
--- a/drivers/tty/serial/serial_core.c
+++ b/drivers/tty/serial/serial_core.c
@@ -1473,7 +1473,7 @@ static void uart_close(struct tty_struct *tty, struct file *filp)
 		state = drv->state + tty->index;
 		port = &state->port;
 		spin_lock_irq(&port->lock);
-		--port->count;
+		atomic_dec(&port->count);
 		spin_unlock_irq(&port->lock);
 		return;
 	}
@@ -1614,7 +1614,7 @@ static void uart_hangup(struct tty_struct *tty)
 		uart_flush_buffer(tty);
 		uart_shutdown(tty, state);
 		spin_lock_irqsave(&port->lock, flags);
-		port->count = 0;
+		atomic_set(&port->count, 0);
 		spin_unlock_irqrestore(&port->lock, flags);
 		tty_port_set_active(port, 0);
 		tty_port_tty_set(port, NULL);
@@ -1717,7 +1717,7 @@ static int uart_open(struct tty_struct *tty, struct file *filp)
 	pr_debug("uart_open(%d) called\n", line);
 
 	spin_lock_irq(&port->lock);
-	++port->count;
+	atomic_inc(&port->count);
 	spin_unlock_irq(&port->lock);
 
 	/*
diff --git a/drivers/tty/synclink.c b/drivers/tty/synclink.c
index c13e27ecb..335a5129e 100644
--- a/drivers/tty/synclink.c
+++ b/drivers/tty/synclink.c
@@ -3075,7 +3075,7 @@ static void mgsl_close(struct tty_struct *tty, struct file * filp)
 	
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgsl_close(%s) entry, count=%d\n",
-			 __FILE__,__LINE__, info->device_name, info->port.count);
+			 __FILE__,__LINE__, info->device_name, atomic_read(&info->port.count));
 
 	if (tty_port_close_start(&info->port, tty, filp) == 0)
 		goto cleanup;
@@ -3093,7 +3093,7 @@ static void mgsl_close(struct tty_struct *tty, struct file * filp)
 cleanup:			
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgsl_close(%s) exit, count=%d\n", __FILE__,__LINE__,
-			tty->driver->name, info->port.count);
+			tty->driver->name, atomic_read(&info->port.count));
 			
 }	/* end of mgsl_close() */
 
@@ -3192,8 +3192,8 @@ static void mgsl_hangup(struct tty_struct *tty)
 
 	mgsl_flush_buffer(tty);
 	shutdown(info);
-	
-	info->port.count = 0;	
+
+	atomic_set(&info->port.count, 0);
 	tty_port_set_active(&info->port, 0);
 	info->port.tty = NULL;
 
@@ -3281,10 +3281,10 @@ static int block_til_ready(struct tty_struct *tty, struct file * filp,
 	
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):block_til_ready before block on %s count=%d\n",
-			 __FILE__,__LINE__, tty->driver->name, port->count );
+			 __FILE__,__LINE__, tty->driver->name, atomic_read(&port->count));
 
 	spin_lock_irqsave(&info->irq_spinlock, flags);
-	port->count--;
+	atomic_dec(&port->count);
 	spin_unlock_irqrestore(&info->irq_spinlock, flags);
 	port->blocked_open++;
 
@@ -3311,7 +3311,7 @@ static int block_til_ready(struct tty_struct *tty, struct file * filp,
 		
 		if (debug_level >= DEBUG_LEVEL_INFO)
 			printk("%s(%d):block_til_ready blocking on %s count=%d\n",
-				 __FILE__,__LINE__, tty->driver->name, port->count );
+				 __FILE__,__LINE__, tty->driver->name, atomic_read(&port->count));
 				 
 		tty_unlock(tty);
 		schedule();
@@ -3323,12 +3323,12 @@ static int block_til_ready(struct tty_struct *tty, struct file * filp,
 	
 	/* FIXME: Racy on hangup during close wait */
 	if (!tty_hung_up_p(filp))
-		port->count++;
+		atomic_inc(&port->count);
 	port->blocked_open--;
 	
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):block_til_ready after blocking on %s count=%d\n",
-			 __FILE__,__LINE__, tty->driver->name, port->count );
+			 __FILE__,__LINE__, tty->driver->name, atomic_read(&port->count));
 			 
 	if (!retval)
 		tty_port_set_active(port, 1);
@@ -3380,7 +3380,7 @@ static int mgsl_open(struct tty_struct *tty, struct file * filp)
 		
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgsl_open(%s), old ref count = %d\n",
-			 __FILE__,__LINE__,tty->driver->name, info->port.count);
+			 __FILE__,__LINE__,tty->driver->name, atomic_read(&info->port.count));
 
 	info->port.low_latency = (info->port.flags & ASYNC_LOW_LATENCY) ? 1 : 0;
 
@@ -3390,10 +3390,10 @@ static int mgsl_open(struct tty_struct *tty, struct file * filp)
 		spin_unlock_irqrestore(&info->netlock, flags);
 		goto cleanup;
 	}
-	info->port.count++;
+	atomic_inc(&info->port.count);
 	spin_unlock_irqrestore(&info->netlock, flags);
 
-	if (info->port.count == 1) {
+	if (atomic_read(&info->port.count) == 1) {
 		/* 1st open on this device, init hardware */
 		retval = startup(info);
 		if (retval < 0)
@@ -3417,8 +3417,8 @@ cleanup:
 	if (retval) {
 		if (tty->count == 1)
 			info->port.tty = NULL; /* tty layer will release tty struct */
-		if(info->port.count)
-			info->port.count--;
+		if (atomic_read(&info->port.count))
+			atomic_dec(&info->port.count);
 	}
 	
 	return retval;
@@ -7637,7 +7637,7 @@ static int hdlcdev_attach(struct net_device *dev, unsigned short encoding,
 	unsigned short new_crctype;
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	switch (encoding)
@@ -7733,7 +7733,7 @@ static int hdlcdev_open(struct net_device *dev)
 
 	/* arbitrate between network and tty opens */
 	spin_lock_irqsave(&info->netlock, flags);
-	if (info->port.count != 0 || info->netcount != 0) {
+	if (atomic_read(&info->port.count) != 0 || info->netcount != 0) {
 		printk(KERN_WARNING "%s: hdlc_open returning busy\n", dev->name);
 		spin_unlock_irqrestore(&info->netlock, flags);
 		return -EBUSY;
@@ -7819,7 +7819,7 @@ static int hdlcdev_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
 		printk("%s:hdlcdev_ioctl(%s)\n",__FILE__,dev->name);
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	if (cmd != SIOCWANDEV)
diff --git a/drivers/tty/synclink_gt.c b/drivers/tty/synclink_gt.c
index 7aca2d467..45a71214e 100644
--- a/drivers/tty/synclink_gt.c
+++ b/drivers/tty/synclink_gt.c
@@ -670,7 +670,7 @@ static int open(struct tty_struct *tty, struct file *filp)
 	tty->driver_data = info;
 	info->port.tty = tty;
 
-	DBGINFO(("%s open, old ref count = %d\n", info->device_name, info->port.count));
+	DBGINFO(("%s open, old ref count = %d\n", info->device_name, atomic_read(&info->port.count)));
 
 	mutex_lock(&info->port.mutex);
 	info->port.low_latency = (info->port.flags & ASYNC_LOW_LATENCY) ? 1 : 0;
@@ -682,10 +682,10 @@ static int open(struct tty_struct *tty, struct file *filp)
 		mutex_unlock(&info->port.mutex);
 		goto cleanup;
 	}
-	info->port.count++;
+	atomic_inc(&info->port.count);
 	spin_unlock_irqrestore(&info->netlock, flags);
 
-	if (info->port.count == 1) {
+	if (atomic_read(&info->port.count) == 1) {
 		/* 1st open on this device, init hardware */
 		retval = startup(info);
 		if (retval < 0) {
@@ -706,8 +706,8 @@ cleanup:
 	if (retval) {
 		if (tty->count == 1)
 			info->port.tty = NULL; /* tty layer will release tty struct */
-		if(info->port.count)
-			info->port.count--;
+		if(atomic_read(&info->port.count))
+			atomic_dec(&info->port.count);
 	}
 
 	DBGINFO(("%s open rc=%d\n", info->device_name, retval));
@@ -720,7 +720,7 @@ static void close(struct tty_struct *tty, struct file *filp)
 
 	if (sanity_check(info, tty->name, "close"))
 		return;
-	DBGINFO(("%s close entry, count=%d\n", info->device_name, info->port.count));
+	DBGINFO(("%s close entry, count=%d\n", info->device_name, atomic_read(&info->port.count)));
 
 	if (tty_port_close_start(&info->port, tty, filp) == 0)
 		goto cleanup;
@@ -737,7 +737,7 @@ static void close(struct tty_struct *tty, struct file *filp)
 	tty_port_close_end(&info->port, tty);
 	info->port.tty = NULL;
 cleanup:
-	DBGINFO(("%s close exit, count=%d\n", tty->driver->name, info->port.count));
+	DBGINFO(("%s close exit, count=%d\n", tty->driver->name, atomic_read(&info->port.count)));
 }
 
 static void hangup(struct tty_struct *tty)
@@ -755,7 +755,7 @@ static void hangup(struct tty_struct *tty)
 	shutdown(info);
 
 	spin_lock_irqsave(&info->port.lock, flags);
-	info->port.count = 0;
+	atomic_set(&info->port.count, 0);
 	info->port.tty = NULL;
 	spin_unlock_irqrestore(&info->port.lock, flags);
 	tty_port_set_active(&info->port, 0);
@@ -1435,7 +1435,7 @@ static int hdlcdev_attach(struct net_device *dev, unsigned short encoding,
 	unsigned short new_crctype;
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	DBGINFO(("%s hdlcdev_attach\n", info->device_name));
@@ -1531,7 +1531,7 @@ static int hdlcdev_open(struct net_device *dev)
 
 	/* arbitrate between network and tty opens */
 	spin_lock_irqsave(&info->netlock, flags);
-	if (info->port.count != 0 || info->netcount != 0) {
+	if (atomic_read(&info->port.count) != 0 || info->netcount != 0) {
 		DBGINFO(("%s hdlc_open busy\n", dev->name));
 		spin_unlock_irqrestore(&info->netlock, flags);
 		return -EBUSY;
@@ -1616,7 +1616,7 @@ static int hdlcdev_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
 	DBGINFO(("%s hdlcdev_ioctl\n", dev->name));
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	if (cmd != SIOCWANDEV)
@@ -2403,7 +2403,7 @@ static irqreturn_t slgt_interrupt(int dummy, void *dev_id)
 		if (port == NULL)
 			continue;
 		spin_lock(&port->lock);
-		if ((port->port.count || port->netcount) &&
+		if ((atomic_read(&port->port.count) || port->netcount) &&
 		    port->pending_bh && !port->bh_running &&
 		    !port->bh_requested) {
 			DBGISR(("%s bh queued\n", port->device_name));
@@ -3282,7 +3282,7 @@ static int block_til_ready(struct tty_struct *tty, struct file *filp,
 	add_wait_queue(&port->open_wait, &wait);
 
 	spin_lock_irqsave(&info->lock, flags);
-	port->count--;
+	atomic_dec(&port->count);
 	spin_unlock_irqrestore(&info->lock, flags);
 	port->blocked_open++;
 
@@ -3317,7 +3317,7 @@ static int block_til_ready(struct tty_struct *tty, struct file *filp,
 	remove_wait_queue(&port->open_wait, &wait);
 
 	if (!tty_hung_up_p(filp))
-		port->count++;
+		atomic_inc(&port->count);
 	port->blocked_open--;
 
 	if (!retval)
diff --git a/drivers/tty/synclinkmp.c b/drivers/tty/synclinkmp.c
index dec156586..bbf9fcc71 100644
--- a/drivers/tty/synclinkmp.c
+++ b/drivers/tty/synclinkmp.c
@@ -750,7 +750,7 @@ static int open(struct tty_struct *tty, struct file *filp)
 
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):%s open(), old ref count = %d\n",
-			 __FILE__,__LINE__,tty->driver->name, info->port.count);
+			 __FILE__,__LINE__,tty->driver->name, atomic_read(&info->port.count));
 
 	info->port.low_latency = (info->port.flags & ASYNC_LOW_LATENCY) ? 1 : 0;
 
@@ -760,10 +760,10 @@ static int open(struct tty_struct *tty, struct file *filp)
 		spin_unlock_irqrestore(&info->netlock, flags);
 		goto cleanup;
 	}
-	info->port.count++;
+	atomic_inc(&info->port.count);
 	spin_unlock_irqrestore(&info->netlock, flags);
 
-	if (info->port.count == 1) {
+	if (atomic_read(&info->port.count) == 1) {
 		/* 1st open on this device, init hardware */
 		retval = startup(info);
 		if (retval < 0)
@@ -787,8 +787,8 @@ cleanup:
 	if (retval) {
 		if (tty->count == 1)
 			info->port.tty = NULL; /* tty layer will release tty struct */
-		if(info->port.count)
-			info->port.count--;
+		if(atomic_read(&info->port.count))
+			atomic_dec(&info->port.count);
 	}
 
 	return retval;
@@ -806,7 +806,7 @@ static void close(struct tty_struct *tty, struct file *filp)
 
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):%s close() entry, count=%d\n",
-			 __FILE__,__LINE__, info->device_name, info->port.count);
+			 __FILE__,__LINE__, info->device_name, atomic_read(&info->port.count));
 
 	if (tty_port_close_start(&info->port, tty, filp) == 0)
 		goto cleanup;
@@ -825,7 +825,7 @@ static void close(struct tty_struct *tty, struct file *filp)
 cleanup:
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):%s close() exit, count=%d\n", __FILE__,__LINE__,
-			tty->driver->name, info->port.count);
+			tty->driver->name, atomic_read(&info->port.count));
 }
 
 /* Called by tty_hangup() when a hangup is signaled.
@@ -848,7 +848,7 @@ static void hangup(struct tty_struct *tty)
 	shutdown(info);
 
 	spin_lock_irqsave(&info->port.lock, flags);
-	info->port.count = 0;
+	atomic_set(&info->port.count, 0);
 	info->port.tty = NULL;
 	spin_unlock_irqrestore(&info->port.lock, flags);
 	tty_port_set_active(&info->port, 1);
@@ -1551,7 +1551,7 @@ static int hdlcdev_attach(struct net_device *dev, unsigned short encoding,
 	unsigned short new_crctype;
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	switch (encoding)
@@ -1647,7 +1647,7 @@ static int hdlcdev_open(struct net_device *dev)
 
 	/* arbitrate between network and tty opens */
 	spin_lock_irqsave(&info->netlock, flags);
-	if (info->port.count != 0 || info->netcount != 0) {
+	if (atomic_read(&info->port.count) != 0 || info->netcount != 0) {
 		printk(KERN_WARNING "%s: hdlc_open returning busy\n", dev->name);
 		spin_unlock_irqrestore(&info->netlock, flags);
 		return -EBUSY;
@@ -1733,7 +1733,7 @@ static int hdlcdev_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
 		printk("%s:hdlcdev_ioctl(%s)\n",__FILE__,dev->name);
 
 	/* return error if TTY interface open */
-	if (info->port.count)
+	if (atomic_read(&info->port.count))
 		return -EBUSY;
 
 	if (cmd != SIOCWANDEV)
@@ -2610,7 +2610,7 @@ static irqreturn_t synclinkmp_interrupt(int dummy, void *dev_id)
 		 * do not request bottom half processing if the
 		 * device is not open in a normal mode.
 		 */
-		if ( port && (port->port.count || port->netcount) &&
+		if ( port && (atomic_read(&port->port.count) || port->netcount) &&
 		     port->pending_bh && !port->bh_running &&
 		     !port->bh_requested ) {
 			if ( debug_level >= DEBUG_LEVEL_ISR )
@@ -3300,10 +3300,10 @@ static int block_til_ready(struct tty_struct *tty, struct file *filp,
 
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):%s block_til_ready() before block, count=%d\n",
-			 __FILE__,__LINE__, tty->driver->name, port->count );
+			 __FILE__,__LINE__, tty->driver->name, atomic_read(&port->count));
 
 	spin_lock_irqsave(&info->lock, flags);
-	port->count--;
+	atomic_dec(&port->count);
 	spin_unlock_irqrestore(&info->lock, flags);
 	port->blocked_open++;
 
@@ -3330,7 +3330,7 @@ static int block_til_ready(struct tty_struct *tty, struct file *filp,
 
 		if (debug_level >= DEBUG_LEVEL_INFO)
 			printk("%s(%d):%s block_til_ready() count=%d\n",
-				 __FILE__,__LINE__, tty->driver->name, port->count );
+				 __FILE__,__LINE__, tty->driver->name, atomic_read(&port->count));
 
 		tty_unlock(tty);
 		schedule();
@@ -3340,12 +3340,12 @@ static int block_til_ready(struct tty_struct *tty, struct file *filp,
 	set_current_state(TASK_RUNNING);
 	remove_wait_queue(&port->open_wait, &wait);
 	if (!tty_hung_up_p(filp))
-		port->count++;
+		atomic_inc(&port->count);
 	port->blocked_open--;
 
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):%s block_til_ready() after, count=%d\n",
-			 __FILE__,__LINE__, tty->driver->name, port->count );
+			 __FILE__,__LINE__, tty->driver->name, atomic_read(&port->count));
 
 	if (!retval)
 		tty_port_set_active(port, 1);
diff --git a/drivers/tty/sysrq.c b/drivers/tty/sysrq.c
index 52bbd27e9..7846d42d0 100644
--- a/drivers/tty/sysrq.c
+++ b/drivers/tty/sysrq.c
@@ -1090,7 +1090,7 @@ EXPORT_SYMBOL(unregister_sysrq_key);
 static ssize_t write_sysrq_trigger(struct file *file, const char __user *buf,
 				   size_t count, loff_t *ppos)
 {
-	if (count) {
+	if (count && capable(CAP_SYS_ADMIN)) {
 		char c;
 
 		if (get_user(c, buf))
diff --git a/drivers/tty/tty_io.c b/drivers/tty/tty_io.c
index 734a635e7..0518bb71e 100644
--- a/drivers/tty/tty_io.c
+++ b/drivers/tty/tty_io.c
@@ -105,6 +105,8 @@
 #include <linux/kmod.h>
 #include <linux/nsproxy.h>
 
+#include <linux/grsecurity.h>
+
 #undef TTY_DEBUG_HANGUP
 #ifdef TTY_DEBUG_HANGUP
 # define tty_debug_hangup(tty, f, args...)	tty_debug(tty, f, ##args)
@@ -2286,6 +2288,8 @@ static int tiocsti(struct tty_struct *tty, char __user *p)
 	char ch, mbz = 0;
 	struct tty_ldisc *ld;
 
+	if (gr_handle_tiocsti(tty))
+		return -EPERM;
 	if ((current->signal->tty != tty) && !capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (get_user(ch, p))
@@ -3560,7 +3564,7 @@ EXPORT_SYMBOL(tty_devnum);
 
 void tty_default_fops(struct file_operations *fops)
 {
-	*fops = tty_fops;
+	memcpy((void *)fops, &tty_fops, sizeof(tty_fops));
 }
 
 /*
diff --git a/drivers/tty/tty_ldisc.c b/drivers/tty/tty_ldisc.c
index 68947f6de..1f85fef28 100644
--- a/drivers/tty/tty_ldisc.c
+++ b/drivers/tty/tty_ldisc.c
@@ -68,7 +68,7 @@ int tty_register_ldisc(int disc, struct tty_ldisc_ops *new_ldisc)
 	raw_spin_lock_irqsave(&tty_ldiscs_lock, flags);
 	tty_ldiscs[disc] = new_ldisc;
 	new_ldisc->num = disc;
-	new_ldisc->refcount = 0;
+	atomic_set(&new_ldisc->refcount, 0);
 	raw_spin_unlock_irqrestore(&tty_ldiscs_lock, flags);
 
 	return ret;
@@ -96,7 +96,7 @@ int tty_unregister_ldisc(int disc)
 		return -EINVAL;
 
 	raw_spin_lock_irqsave(&tty_ldiscs_lock, flags);
-	if (tty_ldiscs[disc]->refcount)
+	if (atomic_read(&tty_ldiscs[disc]->refcount))
 		ret = -EBUSY;
 	else
 		tty_ldiscs[disc] = NULL;
@@ -117,7 +117,7 @@ static struct tty_ldisc_ops *get_ldops(int disc)
 	if (ldops) {
 		ret = ERR_PTR(-EAGAIN);
 		if (try_module_get(ldops->owner)) {
-			ldops->refcount++;
+			atomic_inc(&ldops->refcount);
 			ret = ldops;
 		}
 	}
@@ -130,7 +130,7 @@ static void put_ldops(struct tty_ldisc_ops *ldops)
 	unsigned long flags;
 
 	raw_spin_lock_irqsave(&tty_ldiscs_lock, flags);
-	ldops->refcount--;
+	atomic_dec(&ldops->refcount);
 	module_put(ldops->owner);
 	raw_spin_unlock_irqrestore(&tty_ldiscs_lock, flags);
 }
diff --git a/drivers/tty/tty_port.c b/drivers/tty/tty_port.c
index c3f9d93ba..f81070c99 100644
--- a/drivers/tty/tty_port.c
+++ b/drivers/tty/tty_port.c
@@ -236,7 +236,7 @@ void tty_port_hangup(struct tty_port *port)
 	unsigned long flags;
 
 	spin_lock_irqsave(&port->lock, flags);
-	port->count = 0;
+	atomic_set(&port->count, 0);
 	tty = port->tty;
 	if (tty)
 		set_bit(TTY_IO_ERROR, &tty->flags);
@@ -388,7 +388,7 @@ int tty_port_block_til_ready(struct tty_port *port,
 
 	/* The port lock protects the port counts */
 	spin_lock_irqsave(&port->lock, flags);
-	port->count--;
+	atomic_dec(&port->count);
 	port->blocked_open++;
 	spin_unlock_irqrestore(&port->lock, flags);
 
@@ -429,7 +429,7 @@ int tty_port_block_til_ready(struct tty_port *port,
 	   we must not mess that up further */
 	spin_lock_irqsave(&port->lock, flags);
 	if (!tty_hung_up_p(filp))
-		port->count++;
+		atomic_inc(&port->count);
 	port->blocked_open--;
 	spin_unlock_irqrestore(&port->lock, flags);
 	if (retval == 0)
@@ -462,18 +462,18 @@ int tty_port_close_start(struct tty_port *port,
 		return 0;
 
 	spin_lock_irqsave(&port->lock, flags);
-	if (tty->count == 1 && port->count != 1) {
+	if (tty->count == 1 && atomic_read(&port->count) != 1) {
 		tty_warn(tty, "%s: tty->count = 1 port count = %d\n", __func__,
-			 port->count);
-		port->count = 1;
+			 atomic_read(&port->count));
+		atomic_set(&port->count, 1);
 	}
-	if (--port->count < 0) {
+	if (atomic_dec_return(&port->count) < 0) {
 		tty_warn(tty, "%s: bad port count (%d)\n", __func__,
-			 port->count);
-		port->count = 0;
+			 atomic_read(&port->count));
+		atomic_set(&port->count, 0);
 	}
 
-	if (port->count) {
+	if (atomic_read(&port->count)) {
 		spin_unlock_irqrestore(&port->lock, flags);
 		return 0;
 	}
@@ -567,7 +567,7 @@ int tty_port_open(struct tty_port *port, struct tty_struct *tty,
 							struct file *filp)
 {
 	spin_lock_irq(&port->lock);
-	++port->count;
+	atomic_inc(&port->count);
 	spin_unlock_irq(&port->lock);
 	tty_port_tty_set(port, tty);
 
diff --git a/drivers/tty/vt/keyboard.c b/drivers/tty/vt/keyboard.c
index ece10e6b7..1621e805b 100644
--- a/drivers/tty/vt/keyboard.c
+++ b/drivers/tty/vt/keyboard.c
@@ -630,6 +630,16 @@ static void k_spec(struct vc_data *vc, unsigned char value, char up_flag)
 	     kbd->kbdmode == VC_OFF) &&
 	     value != KVAL(K_SAK))
 		return;		/* SAK is allowed even in raw mode */
+
+#if defined(CONFIG_GRKERNSEC_PROC) || defined(CONFIG_GRKERNSEC_PROC_MEMMAP)
+	{
+		void *func = fn_handler[value];
+		if (func == fn_show_state || func == fn_show_ptregs ||
+		    func == fn_show_mem)
+			return;
+	}
+#endif
+
 	fn_handler[value](vc);
 }
 
@@ -1858,9 +1868,6 @@ int vt_do_kdsk_ioctl(int cmd, struct kbentry __user *user_kbe, int perm,
 	if (copy_from_user(&tmp, user_kbe, sizeof(struct kbentry)))
 		return -EFAULT;
 
-	if (!capable(CAP_SYS_TTY_CONFIG))
-		perm = 0;
-
 	switch (cmd) {
 	case KDGKBENT:
 		/* Ensure another thread doesn't free it under us */
@@ -1875,6 +1882,9 @@ int vt_do_kdsk_ioctl(int cmd, struct kbentry __user *user_kbe, int perm,
 		spin_unlock_irqrestore(&kbd_event_lock, flags);
 		return put_user(val, &user_kbe->kb_value);
 	case KDSKBENT:
+		if (!capable(CAP_SYS_TTY_CONFIG))
+			perm = 0;
+
 		if (!perm)
 			return -EPERM;
 		if (!i && v == K_NOSUCHMAP) {
@@ -1965,9 +1975,6 @@ int vt_do_kdgkb_ioctl(int cmd, struct kbsentry __user *user_kdgkb, int perm)
 	int i, j, k;
 	int ret;
 
-	if (!capable(CAP_SYS_TTY_CONFIG))
-		perm = 0;
-
 	kbs = kmalloc(sizeof(*kbs), GFP_KERNEL);
 	if (!kbs) {
 		ret = -ENOMEM;
@@ -2001,6 +2008,9 @@ int vt_do_kdgkb_ioctl(int cmd, struct kbsentry __user *user_kdgkb, int perm)
 		kfree(kbs);
 		return ((p && *p) ? -EOVERFLOW : 0);
 	case KDSKBSENT:
+		if (!capable(CAP_SYS_TTY_CONFIG))
+			perm = 0;
+
 		if (!perm) {
 			ret = -EPERM;
 			goto reterr;
diff --git a/drivers/uio/uio.c b/drivers/uio/uio.c
index fba021f57..977a54ec0 100644
--- a/drivers/uio/uio.c
+++ b/drivers/uio/uio.c
@@ -25,6 +25,7 @@
 #include <linux/kobject.h>
 #include <linux/cdev.h>
 #include <linux/uio_driver.h>
+#include <asm/local.h>
 
 #define UIO_MAX_DEVICES		(1U << MINORBITS)
 
@@ -231,7 +232,7 @@ static ssize_t event_show(struct device *dev,
 			  struct device_attribute *attr, char *buf)
 {
 	struct uio_device *idev = dev_get_drvdata(dev);
-	return sprintf(buf, "%u\n", (unsigned int)atomic_read(&idev->event));
+	return sprintf(buf, "%u\n", (unsigned int)atomic_read_unchecked(&idev->event));
 }
 static DEVICE_ATTR_RO(event);
 
@@ -401,7 +402,7 @@ void uio_event_notify(struct uio_info *info)
 {
 	struct uio_device *idev = info->uio_dev;
 
-	atomic_inc(&idev->event);
+	atomic_inc_unchecked(&idev->event);
 	wake_up_interruptible(&idev->wait);
 	kill_fasync(&idev->async_queue, SIGIO, POLL_IN);
 }
@@ -454,7 +455,7 @@ static int uio_open(struct inode *inode, struct file *filep)
 	}
 
 	listener->dev = idev;
-	listener->event_count = atomic_read(&idev->event);
+	listener->event_count = atomic_read_unchecked(&idev->event);
 	filep->private_data = listener;
 
 	if (idev->info->open) {
@@ -505,7 +506,7 @@ static unsigned int uio_poll(struct file *filep, poll_table *wait)
 		return -EIO;
 
 	poll_wait(filep, &idev->wait, wait);
-	if (listener->event_count != atomic_read(&idev->event))
+	if (listener->event_count != atomic_read_unchecked(&idev->event))
 		return POLLIN | POLLRDNORM;
 	return 0;
 }
@@ -530,7 +531,7 @@ static ssize_t uio_read(struct file *filep, char __user *buf,
 	do {
 		set_current_state(TASK_INTERRUPTIBLE);
 
-		event_count = atomic_read(&idev->event);
+		event_count = atomic_read_unchecked(&idev->event);
 		if (event_count != listener->event_count) {
 			__set_current_state(TASK_RUNNING);
 			if (copy_to_user(buf, &event_count, count))
@@ -588,9 +589,13 @@ static ssize_t uio_write(struct file *filep, const char __user *buf,
 static int uio_find_mem_index(struct vm_area_struct *vma)
 {
 	struct uio_device *idev = vma->vm_private_data;
+	unsigned long size;
 
 	if (vma->vm_pgoff < MAX_UIO_MAPS) {
-		if (idev->info->mem[vma->vm_pgoff].size == 0)
+		size = idev->info->mem[vma->vm_pgoff].size;
+		if (size == 0)
+			return -1;
+		if (vma->vm_end - vma->vm_start > size)
 			return -1;
 		return (int)vma->vm_pgoff;
 	}
@@ -822,7 +827,7 @@ int __uio_register_device(struct module *owner,
 	idev->owner = owner;
 	idev->info = info;
 	init_waitqueue_head(&idev->wait);
-	atomic_set(&idev->event, 0);
+	atomic_set_unchecked(&idev->event, 0);
 
 	ret = uio_get_minor(idev);
 	if (ret)
diff --git a/drivers/usb/atm/cxacru.c b/drivers/usb/atm/cxacru.c
index 44a8199b3..999882bb1 100644
--- a/drivers/usb/atm/cxacru.c
+++ b/drivers/usb/atm/cxacru.c
@@ -474,7 +474,7 @@ static ssize_t cxacru_sysfs_store_adsl_config(struct device *dev,
 		ret = sscanf(buf + pos, "%x=%x%n", &index, &value, &tmp);
 		if (ret < 2)
 			return -EINVAL;
-		if (index < 0 || index > 0x7f)
+		if (index > 0x7f)
 			return -EINVAL;
 		if (tmp < 0 || tmp > len - pos)
 			return -EINVAL;
diff --git a/drivers/usb/atm/usbatm.c b/drivers/usb/atm/usbatm.c
index db322d9cc..f0f4bc1b3 100644
--- a/drivers/usb/atm/usbatm.c
+++ b/drivers/usb/atm/usbatm.c
@@ -331,7 +331,7 @@ static void usbatm_extract_one_cell(struct usbatm_data *instance, unsigned char
 		if (printk_ratelimit())
 			atm_warn(instance, "%s: OAM not supported (vpi %d, vci %d)!\n",
 				__func__, vpi, vci);
-		atomic_inc(&vcc->stats->rx_err);
+		atomic_inc_unchecked(&vcc->stats->rx_err);
 		return;
 	}
 
@@ -358,7 +358,7 @@ static void usbatm_extract_one_cell(struct usbatm_data *instance, unsigned char
 		if (length > ATM_MAX_AAL5_PDU) {
 			atm_rldbg(instance, "%s: bogus length %u (vcc: 0x%p)!\n",
 				  __func__, length, vcc);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto out;
 		}
 
@@ -367,14 +367,14 @@ static void usbatm_extract_one_cell(struct usbatm_data *instance, unsigned char
 		if (sarb->len < pdu_length) {
 			atm_rldbg(instance, "%s: bogus pdu_length %u (sarb->len: %u, vcc: 0x%p)!\n",
 				  __func__, pdu_length, sarb->len, vcc);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto out;
 		}
 
 		if (crc32_be(~0, skb_tail_pointer(sarb) - pdu_length, pdu_length) != 0xc704dd7b) {
 			atm_rldbg(instance, "%s: packet failed crc check (vcc: 0x%p)!\n",
 				  __func__, vcc);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto out;
 		}
 
@@ -387,7 +387,7 @@ static void usbatm_extract_one_cell(struct usbatm_data *instance, unsigned char
 			if (printk_ratelimit())
 				atm_err(instance, "%s: no memory for skb (length: %u)!\n",
 					__func__, length);
-			atomic_inc(&vcc->stats->rx_drop);
+			atomic_inc_unchecked(&vcc->stats->rx_drop);
 			goto out;
 		}
 
@@ -415,7 +415,7 @@ static void usbatm_extract_one_cell(struct usbatm_data *instance, unsigned char
 
 		vcc->push(vcc, skb);
 
-		atomic_inc(&vcc->stats->rx);
+		atomic_inc_unchecked(&vcc->stats->rx);
 	out:
 		skb_trim(sarb, 0);
 	}
@@ -613,7 +613,7 @@ static void usbatm_tx_process(unsigned long data)
 			struct atm_vcc *vcc = UDSL_SKB(skb)->atm.vcc;
 
 			usbatm_pop(vcc, skb);
-			atomic_inc(&vcc->stats->tx);
+			atomic_inc_unchecked(&vcc->stats->tx);
 
 			skb = skb_dequeue(&instance->sndqueue);
 		}
@@ -757,11 +757,11 @@ static int usbatm_atm_proc_read(struct atm_dev *atm_dev, loff_t *pos, char *page
 	if (!left--)
 		return sprintf(page,
 			       "AAL5: tx %d ( %d err ), rx %d ( %d err, %d drop )\n",
-			       atomic_read(&atm_dev->stats.aal5.tx),
-			       atomic_read(&atm_dev->stats.aal5.tx_err),
-			       atomic_read(&atm_dev->stats.aal5.rx),
-			       atomic_read(&atm_dev->stats.aal5.rx_err),
-			       atomic_read(&atm_dev->stats.aal5.rx_drop));
+			       atomic_read_unchecked(&atm_dev->stats.aal5.tx),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.tx_err),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.rx),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.rx_err),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.rx_drop));
 
 	if (!left--) {
 		if (instance->disconnected)
diff --git a/drivers/usb/core/devices.c b/drivers/usb/core/devices.c
index ef04b50e6..7582d9925 100644
--- a/drivers/usb/core/devices.c
+++ b/drivers/usb/core/devices.c
@@ -119,7 +119,7 @@ static const char format_endpt[] =
  * time it gets called.
  */
 static struct device_connect_event {
-	atomic_t count;
+	atomic_unchecked_t count;
 	wait_queue_head_t wait;
 } device_event = {
 	.count = ATOMIC_INIT(1),
@@ -157,7 +157,7 @@ static const struct class_info clas_info[] = {
 
 void usbfs_conn_disc_event(void)
 {
-	atomic_add(2, &device_event.count);
+	atomic_add_unchecked(2, &device_event.count);
 	wake_up(&device_event.wait);
 }
 
@@ -648,7 +648,7 @@ static unsigned int usb_device_poll(struct file *file,
 
 	poll_wait(file, &device_event.wait, wait);
 
-	event_count = atomic_read(&device_event.count);
+	event_count = atomic_read_unchecked(&device_event.count);
 	if (file->f_version != event_count) {
 		file->f_version = event_count;
 		return POLLIN | POLLRDNORM;
diff --git a/drivers/usb/core/devio.c b/drivers/usb/core/devio.c
index 09c8d9ca6..14ee687c4 100644
--- a/drivers/usb/core/devio.c
+++ b/drivers/usb/core/devio.c
@@ -290,7 +290,7 @@ static ssize_t usbdev_read(struct file *file, char __user *buf, size_t nbytes,
 	struct usb_dev_state *ps = file->private_data;
 	struct usb_device *dev = ps->dev;
 	ssize_t ret = 0;
-	unsigned len;
+	size_t len;
 	loff_t pos;
 	int i;
 
@@ -332,22 +332,22 @@ static ssize_t usbdev_read(struct file *file, char __user *buf, size_t nbytes,
 	for (i = 0; nbytes && i < dev->descriptor.bNumConfigurations; i++) {
 		struct usb_config_descriptor *config =
 			(struct usb_config_descriptor *)dev->rawdescriptors[i];
-		unsigned int length = le16_to_cpu(config->wTotalLength);
+		size_t length = le16_to_cpu(config->wTotalLength);
 
 		if (*ppos < pos + length) {
 
 			/* The descriptor may claim to be longer than it
 			 * really is.  Here is the actual allocated length. */
-			unsigned alloclen =
+			size_t alloclen =
 				le16_to_cpu(dev->config[i].desc.wTotalLength);
 
-			len = length - (*ppos - pos);
+			len = length + pos - *ppos;
 			if (len > nbytes)
 				len = nbytes;
 
 			/* Simply don't write (skip over) unallocated parts */
 			if (alloclen > (*ppos - pos)) {
-				alloclen -= (*ppos - pos);
+				alloclen = alloclen + pos - *ppos;
 				if (copy_to_user(buf,
 				    dev->rawdescriptors[i] + (*ppos - pos),
 				    min(len, alloclen))) {
@@ -1682,7 +1682,7 @@ static int proc_do_submiturb(struct usb_dev_state *ps, struct usbdevfs_urb *uurb
 		}
 	}
 	as->urb->dev = ps->dev;
-	as->urb->pipe = (uurb->type << 30) |
+	as->urb->pipe = ((unsigned int)uurb->type << 30) |
 			__create_pipe(ps->dev, uurb->endpoint & 0xf) |
 			(uurb->endpoint & USB_DIR_IN);
 
diff --git a/drivers/usb/core/hcd.c b/drivers/usb/core/hcd.c
index d2e3f655c..e389998e5 100644
--- a/drivers/usb/core/hcd.c
+++ b/drivers/usb/core/hcd.c
@@ -1630,7 +1630,7 @@ int usb_hcd_submit_urb (struct urb *urb, gfp_t mem_flags)
 	 */
 	usb_get_urb(urb);
 	atomic_inc(&urb->use_count);
-	atomic_inc(&urb->dev->urbnum);
+	atomic_inc_unchecked(&urb->dev->urbnum);
 	usbmon_urb_submit(&hcd->self, urb);
 
 	/* NOTE requirements on root-hub callers (usbfs and the hub
@@ -1657,7 +1657,7 @@ int usb_hcd_submit_urb (struct urb *urb, gfp_t mem_flags)
 		urb->hcpriv = NULL;
 		INIT_LIST_HEAD(&urb->urb_list);
 		atomic_dec(&urb->use_count);
-		atomic_dec(&urb->dev->urbnum);
+		atomic_dec_unchecked(&urb->dev->urbnum);
 		if (atomic_read(&urb->reject))
 			wake_up(&usb_kill_urb_queue);
 		usb_put_urb(urb);
diff --git a/drivers/usb/core/hub.c b/drivers/usb/core/hub.c
index f3a7408d6..c3989c4fc 100644
--- a/drivers/usb/core/hub.c
+++ b/drivers/usb/core/hub.c
@@ -26,6 +26,7 @@
 #include <linux/mutex.h>
 #include <linux/random.h>
 #include <linux/pm_qos.h>
+#include <linux/grsecurity.h>
 
 #include <asm/uaccess.h>
 #include <asm/byteorder.h>
@@ -4756,6 +4757,10 @@ static void hub_port_connect(struct usb_hub *hub, int port1, u16 portstatus,
 			goto done;
 		return;
 	}
+
+	if (gr_handle_new_usb())
+		goto done;
+
 	if (hub_is_superspeed(hub->hdev))
 		unit_load = 150;
 	else
diff --git a/drivers/usb/core/sysfs.c b/drivers/usb/core/sysfs.c
index c953a0f1c..54c64f446 100644
--- a/drivers/usb/core/sysfs.c
+++ b/drivers/usb/core/sysfs.c
@@ -259,7 +259,7 @@ static ssize_t urbnum_show(struct device *dev, struct device_attribute *attr,
 	struct usb_device *udev;
 
 	udev = to_usb_device(dev);
-	return sprintf(buf, "%d\n", atomic_read(&udev->urbnum));
+	return sprintf(buf, "%d\n", atomic_read_unchecked(&udev->urbnum));
 }
 static DEVICE_ATTR_RO(urbnum);
 
diff --git a/drivers/usb/core/usb.c b/drivers/usb/core/usb.c
index 5e80697ef..1e9107367 100644
--- a/drivers/usb/core/usb.c
+++ b/drivers/usb/core/usb.c
@@ -444,7 +444,7 @@ struct usb_device *usb_alloc_dev(struct usb_device *parent,
 	set_dev_node(&dev->dev, dev_to_node(bus->controller));
 	dev->state = USB_STATE_ATTACHED;
 	dev->lpm_disable_count = 1;
-	atomic_set(&dev->urbnum, 0);
+	atomic_set_unchecked(&dev->urbnum, 0);
 
 	INIT_LIST_HEAD(&dev->ep0.urb_list);
 	dev->ep0.desc.bLength = USB_DT_ENDPOINT_SIZE;
diff --git a/drivers/usb/early/ehci-dbgp.c b/drivers/usb/early/ehci-dbgp.c
index 12731e67d..0391d02ed 100644
--- a/drivers/usb/early/ehci-dbgp.c
+++ b/drivers/usb/early/ehci-dbgp.c
@@ -98,7 +98,8 @@ static inline u32 dbgp_len_update(u32 x, u32 len)
 
 #ifdef CONFIG_KGDB
 static struct kgdb_io kgdbdbgp_io_ops;
-#define dbgp_kgdb_mode (dbg_io_ops == &kgdbdbgp_io_ops)
+static struct kgdb_io kgdbdbgp_io_ops_console;
+#define dbgp_kgdb_mode (dbg_io_ops == &kgdbdbgp_io_ops || dbg_io_ops == &kgdbdbgp_io_ops_console)
 #else
 #define dbgp_kgdb_mode (0)
 #endif
@@ -1043,6 +1044,13 @@ static struct kgdb_io kgdbdbgp_io_ops = {
 	.write_char = kgdbdbgp_write_char,
 };
 
+static struct kgdb_io kgdbdbgp_io_ops_console = {
+	.name = "kgdbdbgp",
+	.read_char = kgdbdbgp_read_char,
+	.write_char = kgdbdbgp_write_char,
+	.is_console = 1
+};
+
 static int kgdbdbgp_wait_time;
 
 static int __init kgdbdbgp_parse_config(char *str)
@@ -1058,8 +1066,10 @@ static int __init kgdbdbgp_parse_config(char *str)
 		ptr++;
 		kgdbdbgp_wait_time = simple_strtoul(ptr, &ptr, 10);
 	}
-	kgdb_register_io_module(&kgdbdbgp_io_ops);
-	kgdbdbgp_io_ops.is_console = early_dbgp_console.index != -1;
+	if (early_dbgp_console.index != -1)
+		kgdb_register_io_module(&kgdbdbgp_io_ops_console);
+	else
+		kgdb_register_io_module(&kgdbdbgp_io_ops);
 
 	return 0;
 }
diff --git a/drivers/usb/gadget/function/f_phonet.c b/drivers/usb/gadget/function/f_phonet.c
index 0473d619d..5e9caa5aa 100644
--- a/drivers/usb/gadget/function/f_phonet.c
+++ b/drivers/usb/gadget/function/f_phonet.c
@@ -223,7 +223,7 @@ static void pn_tx_complete(struct usb_ep *ep, struct usb_request *req)
 	netif_wake_queue(dev);
 }
 
-static int pn_net_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t pn_net_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct phonet_port *port = netdev_priv(dev);
 	struct f_phonet *fp;
diff --git a/drivers/usb/gadget/function/f_uac1.c b/drivers/usb/gadget/function/f_uac1.c
index f2ac0cbc2..40382623c 100644
--- a/drivers/usb/gadget/function/f_uac1.c
+++ b/drivers/usb/gadget/function/f_uac1.c
@@ -14,6 +14,7 @@
 #include <linux/module.h>
 #include <linux/device.h>
 #include <linux/atomic.h>
+#include <linux/module.h>
 
 #include "u_uac1.h"
 
diff --git a/drivers/usb/gadget/function/u_serial.c b/drivers/usb/gadget/function/u_serial.c
index e0cd1e4c8..0a41c5533 100644
--- a/drivers/usb/gadget/function/u_serial.c
+++ b/drivers/usb/gadget/function/u_serial.c
@@ -752,9 +752,9 @@ static int gs_open(struct tty_struct *tty, struct file *file)
 			spin_lock_irq(&port->port_lock);
 
 			/* already open?  Great. */
-			if (port->port.count) {
+			if (atomic_read(&port->port.count)) {
 				status = 0;
-				port->port.count++;
+				atomic_inc(&port->port.count);
 
 			/* currently opening/closing? wait ... */
 			} else if (port->openclose) {
@@ -813,7 +813,7 @@ static int gs_open(struct tty_struct *tty, struct file *file)
 	tty->driver_data = port;
 	port->port.tty = tty;
 
-	port->port.count = 1;
+	atomic_set(&port->port.count, 1);
 	port->openclose = false;
 
 	/* if connected, start the I/O stream */
@@ -855,11 +855,11 @@ static void gs_close(struct tty_struct *tty, struct file *file)
 
 	spin_lock_irq(&port->port_lock);
 
-	if (port->port.count != 1) {
-		if (port->port.count == 0)
+	if (atomic_read(&port->port.count) != 1) {
+		if (atomic_read(&port->port.count) == 0)
 			WARN_ON(1);
 		else
-			--port->port.count;
+			atomic_dec(&port->port.count);
 		goto exit;
 	}
 
@@ -869,7 +869,7 @@ static void gs_close(struct tty_struct *tty, struct file *file)
 	 * and sleep if necessary
 	 */
 	port->openclose = true;
-	port->port.count = 0;
+	atomic_set(&port->port.count, 0);
 
 	gser = port->port_usb;
 	if (gser && gser->disconnect)
@@ -1324,7 +1324,7 @@ static int gs_closed(struct gs_port *port)
 	int cond;
 
 	spin_lock_irq(&port->port_lock);
-	cond = (port->port.count == 0) && !port->openclose;
+	cond = (atomic_read(&port->port.count) == 0) && !port->openclose;
 	spin_unlock_irq(&port->port_lock);
 	return cond;
 }
@@ -1469,7 +1469,7 @@ int gserial_connect(struct gserial *gser, u8 port_num)
 	/* if it's already open, start I/O ... and notify the serial
 	 * protocol about open/close status (connect/disconnect).
 	 */
-	if (port->port.count) {
+	if (atomic_read(&port->port.count)) {
 		pr_debug("gserial_connect: start ttyGS%d\n", port->port_num);
 		gs_start_io(port);
 		if (gser->connect)
@@ -1516,7 +1516,7 @@ void gserial_disconnect(struct gserial *gser)
 
 	port->port_usb = NULL;
 	gser->ioport = NULL;
-	if (port->port.count > 0 || port->openclose) {
+	if (atomic_read(&port->port.count) > 0 || port->openclose) {
 		wake_up_interruptible(&port->drain_wait);
 		if (port->port.tty)
 			tty_hangup(port->port.tty);
@@ -1529,7 +1529,7 @@ void gserial_disconnect(struct gserial *gser)
 
 	/* finally, free any unused/unusable I/O buffers */
 	spin_lock_irqsave(&port->port_lock, flags);
-	if (port->port.count == 0 && !port->openclose)
+	if (atomic_read(&port->port.count) == 0 && !port->openclose)
 		gs_buf_free(&port->port_write_buf);
 	gs_free_requests(gser->out, &port->read_pool, NULL);
 	gs_free_requests(gser->out, &port->read_queue, NULL);
diff --git a/drivers/usb/gadget/function/u_uac1.c b/drivers/usb/gadget/function/u_uac1.c
index c78c84138..48fd281c0 100644
--- a/drivers/usb/gadget/function/u_uac1.c
+++ b/drivers/usb/gadget/function/u_uac1.c
@@ -17,6 +17,7 @@
 #include <linux/ctype.h>
 #include <linux/random.h>
 #include <linux/syscalls.h>
+#include <linux/module.h>
 
 #include "u_uac1.h"
 
diff --git a/drivers/usb/gadget/udc/dummy_hcd.c b/drivers/usb/gadget/udc/dummy_hcd.c
index 77d07904f..d123802da 100644
--- a/drivers/usb/gadget/udc/dummy_hcd.c
+++ b/drivers/usb/gadget/udc/dummy_hcd.c
@@ -2458,7 +2458,7 @@ static int dummy_setup(struct usb_hcd *hcd)
 	struct dummy *dum;
 
 	dum = *((void **)dev_get_platdata(hcd->self.controller));
-	hcd->self.sg_tablesize = ~0;
+	hcd->self.sg_tablesize = SG_ALL;
 	if (usb_hcd_is_primary_hcd(hcd)) {
 		dum->hs_hcd = hcd_to_dummy_hcd(hcd);
 		dum->hs_hcd->dum = dum;
diff --git a/drivers/usb/host/ehci-hcd.c b/drivers/usb/host/ehci-hcd.c
index 1e5f529d5..5832376b2 100644
--- a/drivers/usb/host/ehci-hcd.c
+++ b/drivers/usb/host/ehci-hcd.c
@@ -573,7 +573,7 @@ static int ehci_init(struct usb_hcd *hcd)
 
 	/* Accept arbitrarily long scatter-gather lists */
 	if (!(hcd->driver->flags & HCD_LOCAL_MEM))
-		hcd->self.sg_tablesize = ~0;
+		hcd->self.sg_tablesize = SG_ALL;
 
 	/* Prepare for unlinking active QHs */
 	ehci->old_current = ~0;
diff --git a/drivers/usb/host/ehci-hub.c b/drivers/usb/host/ehci-hub.c
index 74f62d68f..459983a4a 100644
--- a/drivers/usb/host/ehci-hub.c
+++ b/drivers/usb/host/ehci-hub.c
@@ -777,7 +777,7 @@ static struct urb *request_single_step_set_feature_urb(
 	urb->transfer_flags = URB_DIR_IN;
 	usb_get_urb(urb);
 	atomic_inc(&urb->use_count);
-	atomic_inc(&urb->dev->urbnum);
+	atomic_inc_unchecked(&urb->dev->urbnum);
 	urb->setup_dma = dma_map_single(
 			hcd->self.controller,
 			urb->setup_packet,
@@ -844,7 +844,7 @@ static int ehset_single_step_set_feature(struct usb_hcd *hcd, int port)
 	urb->status = -EINPROGRESS;
 	usb_get_urb(urb);
 	atomic_inc(&urb->use_count);
-	atomic_inc(&urb->dev->urbnum);
+	atomic_inc_unchecked(&urb->dev->urbnum);
 	retval = submit_single_step_set_feature(hcd, urb, 0);
 	if (!retval && !wait_for_completion_timeout(&done,
 						msecs_to_jiffies(2000))) {
diff --git a/drivers/usb/host/ehci-q.c b/drivers/usb/host/ehci-q.c
index eca3710d8..eca7127f6 100644
--- a/drivers/usb/host/ehci-q.c
+++ b/drivers/usb/host/ehci-q.c
@@ -44,9 +44,9 @@
 
 static int
 qtd_fill(struct ehci_hcd *ehci, struct ehci_qtd *qtd, dma_addr_t buf,
-		  size_t len, int token, int maxpacket)
+		  size_t len, u32 token, int maxpacket)
 {
-	int	i, count;
+	u32	i, count;
 	u64	addr = buf;
 
 	/* one buffer entry per 4K ... first might be short or unaligned */
diff --git a/drivers/usb/host/fotg210-hcd.c b/drivers/usb/host/fotg210-hcd.c
index 66efa9a67..50b719d3c 100644
--- a/drivers/usb/host/fotg210-hcd.c
+++ b/drivers/usb/host/fotg210-hcd.c
@@ -5025,7 +5025,7 @@ static int hcd_fotg210_init(struct usb_hcd *hcd)
 
 	/* Accept arbitrarily long scatter-gather lists */
 	if (!(hcd->driver->flags & HCD_LOCAL_MEM))
-		hcd->self.sg_tablesize = ~0;
+		hcd->self.sg_tablesize = SG_ALL;
 	return 0;
 }
 
diff --git a/drivers/usb/host/hwa-hc.c b/drivers/usb/host/hwa-hc.c
index 1db0626c8..2e9f5ea5b 100644
--- a/drivers/usb/host/hwa-hc.c
+++ b/drivers/usb/host/hwa-hc.c
@@ -337,7 +337,10 @@ static int __hwahc_op_bwa_set(struct wusbhc *wusbhc, s8 stream_index,
 	struct hwahc *hwahc = container_of(wusbhc, struct hwahc, wusbhc);
 	struct wahc *wa = &hwahc->wa;
 	struct device *dev = &wa->usb_iface->dev;
-	u8 mas_le[UWB_NUM_MAS/8];
+	u8 *mas_le = kmalloc(UWB_NUM_MAS/8, GFP_KERNEL);
+
+	if (mas_le == NULL)
+		return -ENOMEM;
 
 	/* Set the stream index */
 	result = usb_control_msg(wa->usb_dev, usb_sndctrlpipe(wa->usb_dev, 0),
@@ -356,10 +359,12 @@ static int __hwahc_op_bwa_set(struct wusbhc *wusbhc, s8 stream_index,
 			WUSB_REQ_SET_WUSB_MAS,
 			USB_DIR_OUT | USB_TYPE_CLASS | USB_RECIP_INTERFACE,
 			0, wa->usb_iface->cur_altsetting->desc.bInterfaceNumber,
-			mas_le, 32, USB_CTRL_SET_TIMEOUT);
+			mas_le, UWB_NUM_MAS/8, USB_CTRL_SET_TIMEOUT);
 	if (result < 0)
 		dev_err(dev, "Cannot set WUSB MAS allocation: %d\n", result);
 out:
+	kfree(mas_le);
+
 	return result;
 }
 
@@ -812,7 +817,7 @@ static int hwahc_probe(struct usb_interface *usb_iface,
 		goto error_alloc;
 	}
 	usb_hcd->wireless = 1;
-	usb_hcd->self.sg_tablesize = ~0;
+	usb_hcd->self.sg_tablesize = SG_ALL;
 	wusbhc = usb_hcd_to_wusbhc(usb_hcd);
 	hwahc = container_of(wusbhc, struct hwahc, wusbhc);
 	hwahc_init(hwahc);
diff --git a/drivers/usb/host/ohci-hcd.c b/drivers/usb/host/ohci-hcd.c
index 86612ac3f..d43250595 100644
--- a/drivers/usb/host/ohci-hcd.c
+++ b/drivers/usb/host/ohci-hcd.c
@@ -444,7 +444,7 @@ static int ohci_init (struct ohci_hcd *ohci)
 	struct usb_hcd *hcd = ohci_to_hcd(ohci);
 
 	/* Accept arbitrarily long scatter-gather lists */
-	hcd->self.sg_tablesize = ~0;
+	hcd->self.sg_tablesize = SG_ALL;
 
 	if (distrust_firmware)
 		ohci->flags |= OHCI_QUIRK_HUB_POWER;
diff --git a/drivers/usb/host/r8a66597.h b/drivers/usb/host/r8a66597.h
index 672cea307..31a730dbe 100644
--- a/drivers/usb/host/r8a66597.h
+++ b/drivers/usb/host/r8a66597.h
@@ -125,7 +125,7 @@ struct r8a66597 {
 	unsigned short interval_map;
 	unsigned char pipe_cnt[R8A66597_MAX_NUM_PIPE];
 	unsigned char dma_map;
-	unsigned int max_root_hub;
+	unsigned char max_root_hub;
 
 	struct list_head child_device;
 	unsigned long child_connect_map[4];
diff --git a/drivers/usb/host/uhci-hcd.c b/drivers/usb/host/uhci-hcd.c
index a7de8e8bb..e1ef1344b 100644
--- a/drivers/usb/host/uhci-hcd.c
+++ b/drivers/usb/host/uhci-hcd.c
@@ -570,7 +570,7 @@ static int uhci_start(struct usb_hcd *hcd)
 	hcd->uses_new_polling = 1;
 	/* Accept arbitrarily long scatter-gather lists */
 	if (!(hcd->driver->flags & HCD_LOCAL_MEM))
-		hcd->self.sg_tablesize = ~0;
+		hcd->self.sg_tablesize = SG_ALL;
 
 	spin_lock_init(&uhci->lock);
 	setup_timer(&uhci->fsbr_timer, uhci_fsbr_timeout,
diff --git a/drivers/usb/host/xhci-pci.c b/drivers/usb/host/xhci-pci.c
index e96ae80d1..130fe39a5 100644
--- a/drivers/usb/host/xhci-pci.c
+++ b/drivers/usb/host/xhci-pci.c
@@ -32,7 +32,7 @@
 #define SSIC_PORT_CFG2		0x880c
 #define SSIC_PORT_CFG2_OFFSET	0x30
 #define PROG_DONE		(1 << 30)
-#define SSIC_PORT_UNUSED	(1 << 31)
+#define SSIC_PORT_UNUSED	(1U << 31)
 
 /* Device for a quirk */
 #define PCI_VENDOR_ID_FRESCO_LOGIC	0x1b73
diff --git a/drivers/usb/host/xhci-ring.c b/drivers/usb/host/xhci-ring.c
index 797137e26..b7be2b39f 100644
--- a/drivers/usb/host/xhci-ring.c
+++ b/drivers/usb/host/xhci-ring.c
@@ -1889,9 +1889,9 @@ td_cleanup:
 	 * unsigned).  Play it safe and say we didn't transfer anything.
 	 */
 	if (urb->actual_length > urb->transfer_buffer_length) {
-		xhci_warn(xhci, "URB transfer length is wrong, xHC issue? req. len = %u, act. len = %u\n",
+		xhci_warn(xhci, "URB transfer length is wrong, xHC issue? req. len = %u, trans. len = %u\n",
 			urb->transfer_buffer_length,
-			urb->actual_length);
+			EVENT_TRB_LEN(le32_to_cpu(event->transfer_len)));
 		urb->actual_length = 0;
 		if (td->urb->transfer_flags & URB_SHORT_NOT_OK)
 			*status = -EREMOTEIO;
@@ -1970,10 +1970,15 @@ static int process_ctrl_td(struct xhci_hcd *xhci, struct xhci_td *td,
 		return finish_td(xhci, td, event_trb, event, ep, status, false);
 	case COMP_STOP:
 		/* Did we stop at data stage? */
-		if (event_trb != ep_ring->dequeue && event_trb != td->last_trb)
-			td->urb->actual_length =
-				td->urb->transfer_buffer_length -
-				EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
+		if (event_trb != ep_ring->dequeue && event_trb != td->last_trb) {
+			if (td->urb->transfer_buffer_length >= EVENT_TRB_LEN(le32_to_cpu(event->transfer_len)))
+				td->urb->actual_length =
+					td->urb->transfer_buffer_length -
+					EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
+			else
+				td->urb->actual_length =
+					td->urb->transfer_buffer_length + 1;
+		}
 		/* fall through */
 	case COMP_STOP_INVAL:
 		return finish_td(xhci, td, event_trb, event, ep, status, false);
@@ -1987,12 +1992,15 @@ static int process_ctrl_td(struct xhci_hcd *xhci, struct xhci_td *td,
 		/* else fall through */
 	case COMP_STALL:
 		/* Did we transfer part of the data (middle) phase? */
-		if (event_trb != ep_ring->dequeue &&
-				event_trb != td->last_trb)
-			td->urb->actual_length =
-				td->urb->transfer_buffer_length -
-				EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
-		else if (!td->urb_length_set)
+		if (event_trb != ep_ring->dequeue && event_trb != td->last_trb) {
+			if (td->urb->transfer_buffer_length >= EVENT_TRB_LEN(le32_to_cpu(event->transfer_len)))
+				td->urb->actual_length =
+					td->urb->transfer_buffer_length -
+					EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
+			else
+				td->urb->actual_length =
+					td->urb->transfer_buffer_length + 1;
+		} else if (!td->urb_length_set)
 			td->urb->actual_length = 0;
 
 		return finish_td(xhci, td, event_trb, event, ep, status, false);
@@ -2025,9 +2033,12 @@ static int process_ctrl_td(struct xhci_hcd *xhci, struct xhci_td *td,
 			 * the last TRB.
 			 */
 			td->urb_length_set = true;
-			td->urb->actual_length =
-				td->urb->transfer_buffer_length -
-				EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
+			if (td->urb->transfer_buffer_length >= EVENT_TRB_LEN(le32_to_cpu(event->transfer_len)))
+				td->urb->actual_length =
+					td->urb->transfer_buffer_length -
+					EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
+			else
+				BUG();
 			xhci_dbg(xhci, "Waiting for status "
 					"stage event\n");
 			return 0;
@@ -2222,11 +2233,7 @@ static int process_bulk_intr_td(struct xhci_hcd *xhci, struct xhci_td *td,
 	/* Fast path - was this the last TRB in the TD for this URB? */
 	} else if (event_trb == td->last_trb) {
 		if (EVENT_TRB_LEN(le32_to_cpu(event->transfer_len)) != 0) {
-			td->urb->actual_length =
-				td->urb->transfer_buffer_length -
-				EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
-			if (td->urb->transfer_buffer_length <
-					td->urb->actual_length) {
+			if (td->urb->transfer_buffer_length < EVENT_TRB_LEN(le32_to_cpu(event->transfer_len))) {
 				xhci_warn(xhci, "HC gave bad length "
 						"of %d bytes left\n",
 					  EVENT_TRB_LEN(le32_to_cpu(event->transfer_len)));
@@ -2235,7 +2242,10 @@ static int process_bulk_intr_td(struct xhci_hcd *xhci, struct xhci_td *td,
 					*status = -EREMOTEIO;
 				else
 					*status = 0;
-			}
+			} else
+				td->urb->actual_length =
+					td->urb->transfer_buffer_length -
+					EVENT_TRB_LEN(le32_to_cpu(event->transfer_len));
 			/* Don't overwrite a previously set error code */
 			if (*status == -EINPROGRESS) {
 				if (td->urb->transfer_flags & URB_SHORT_NOT_OK)
diff --git a/drivers/usb/host/xhci.c b/drivers/usb/host/xhci.c
index 01d96c9b3..63270fff4 100644
--- a/drivers/usb/host/xhci.c
+++ b/drivers/usb/host/xhci.c
@@ -4838,7 +4838,7 @@ int xhci_gen_setup(struct usb_hcd *hcd, xhci_get_quirks_t get_quirks)
 	int			retval;
 
 	/* Accept arbitrarily long scatter-gather lists */
-	hcd->self.sg_tablesize = ~0;
+	hcd->self.sg_tablesize = SG_ALL;
 
 	/* support to build packet from discontinuous buffers */
 	hcd->self.no_sg_constraint = 1;
diff --git a/drivers/usb/misc/appledisplay.c b/drivers/usb/misc/appledisplay.c
index a0a3827b4..d7ec10b2a 100644
--- a/drivers/usb/misc/appledisplay.c
+++ b/drivers/usb/misc/appledisplay.c
@@ -84,7 +84,7 @@ struct appledisplay {
 	struct mutex sysfslock;		/* concurrent read and write */
 };
 
-static atomic_t count_displays = ATOMIC_INIT(0);
+static atomic_unchecked_t count_displays = ATOMIC_INIT(0);
 static struct workqueue_struct *wq;
 
 static void appledisplay_complete(struct urb *urb)
@@ -288,7 +288,7 @@ static int appledisplay_probe(struct usb_interface *iface,
 
 	/* Register backlight device */
 	snprintf(bl_name, sizeof(bl_name), "appledisplay%d",
-		atomic_inc_return(&count_displays) - 1);
+		atomic_inc_return_unchecked(&count_displays) - 1);
 	memset(&props, 0, sizeof(struct backlight_properties));
 	props.type = BACKLIGHT_RAW;
 	props.max_brightness = 0xff;
diff --git a/drivers/usb/misc/sisusbvga/sisusb_con.c b/drivers/usb/misc/sisusbvga/sisusb_con.c
index 460cebf32..eb16bb4cf 100644
--- a/drivers/usb/misc/sisusbvga/sisusb_con.c
+++ b/drivers/usb/misc/sisusbvga/sisusb_con.c
@@ -1368,29 +1368,77 @@ static void sisusbdummycon_init(struct vc_data *vc, int init)
 	vc_resize(vc, 80, 25);
 }
 
-static int sisusbdummycon_dummy(void)
+static void sisusb_con_deinit(struct vc_data *a)
 {
-    return 0;
 }
 
-#define SISUSBCONDUMMY	(void *)sisusbdummycon_dummy
+static void sisusb_con_clear(struct vc_data *a, int b, int c, int d, int e)
+{
+}
+
+static void sisusb_con_putc(struct vc_data *a, int b, int c, int d)
+{
+}
+
+static void sisusb_con_putcs(struct vc_data *a, const unsigned short *b, int c, int d, int e)
+{
+}
+
+static void sisusb_con_cursor(struct vc_data *a, int b)
+{
+}
+
+static int sisusb_con_scroll(struct vc_data *a, int b, int c, int d, int e)
+{
+	return 0;
+}
+
+static int sisusb_con_switch(struct vc_data *a)
+{
+	return 0;
+}
+
+static int sisusb_con_blank(struct vc_data *a, int b, int c)
+{
+	return 0;
+}
+
+static int sisusb_con_font_set(struct vc_data *a, struct console_font *b, unsigned c)
+{
+	return 0;
+}
+
+static int sisusb_con_font_get(struct vc_data *a, struct console_font *b)
+{
+	return 0;
+}
+
+static int sisusb_con_font_default(struct vc_data *a, struct console_font *b, char *c)
+{
+	return 0;
+}
+
+static int sisusb_con_font_copy(struct vc_data *a, int b)
+{
+	return 0;
+}
 
 static const struct consw sisusb_dummy_con = {
 	.owner =		THIS_MODULE,
 	.con_startup =		sisusbdummycon_startup,
 	.con_init =		sisusbdummycon_init,
-	.con_deinit =		SISUSBCONDUMMY,
-	.con_clear =		SISUSBCONDUMMY,
-	.con_putc =		SISUSBCONDUMMY,
-	.con_putcs =		SISUSBCONDUMMY,
-	.con_cursor =		SISUSBCONDUMMY,
-	.con_scroll =		SISUSBCONDUMMY,
-	.con_switch =		SISUSBCONDUMMY,
-	.con_blank =		SISUSBCONDUMMY,
-	.con_font_set =		SISUSBCONDUMMY,
-	.con_font_get =		SISUSBCONDUMMY,
-	.con_font_default =	SISUSBCONDUMMY,
-	.con_font_copy =	SISUSBCONDUMMY,
+	.con_deinit =		sisusb_con_deinit,
+	.con_clear =		sisusb_con_clear,
+	.con_putc =		sisusb_con_putc,
+	.con_putcs =		sisusb_con_putcs,
+	.con_cursor =		sisusb_con_cursor,
+	.con_scroll =		sisusb_con_scroll,
+	.con_switch =		sisusb_con_switch,
+	.con_blank =		sisusb_con_blank,
+	.con_font_set =		sisusb_con_font_set,
+	.con_font_get =		sisusb_con_font_get,
+	.con_font_default =	sisusb_con_font_default,
+	.con_font_copy =	sisusb_con_font_copy,
 };
 
 int
diff --git a/drivers/usb/serial/console.c b/drivers/usb/serial/console.c
index 8967715fe..4a3791bd1 100644
--- a/drivers/usb/serial/console.c
+++ b/drivers/usb/serial/console.c
@@ -126,7 +126,7 @@ static int usb_console_setup(struct console *co, char *options)
 
 	info->port = port;
 
-	++port->port.count;
+	atomic_inc(&port->port.count);
 	if (!tty_port_initialized(&port->port)) {
 		if (serial->type->set_termios) {
 			/*
@@ -172,7 +172,7 @@ static int usb_console_setup(struct console *co, char *options)
 	}
 	/* Now that any required fake tty operations are completed restore
 	 * the tty port count */
-	--port->port.count;
+	atomic_dec(&port->port.count);
 	/* The console is special in terms of closing the device so
 	 * indicate this port is now acting as a system console. */
 	port->port.console = 1;
@@ -184,7 +184,7 @@ static int usb_console_setup(struct console *co, char *options)
 	tty_port_tty_set(&port->port, NULL);
 	tty_kref_put(tty);
  reset_open_count:
-	port->port.count = 0;
+	atomic_set(&port->port.count, 0);
 	usb_autopm_put_interface(serial->interface);
  error_get_interface:
 	usb_serial_put(serial);
@@ -195,7 +195,7 @@ static int usb_console_setup(struct console *co, char *options)
 static void usb_console_write(struct console *co,
 					const char *buf, unsigned count)
 {
-	static struct usbcons_info *info = &usbcons_info;
+	struct usbcons_info *info = &usbcons_info;
 	struct usb_serial_port *port = info->port;
 	struct usb_serial *serial;
 	int retval = -ENODEV;
diff --git a/drivers/usb/storage/transport.c b/drivers/usb/storage/transport.c
index 1a59f335b..35f4c565f 100644
--- a/drivers/usb/storage/transport.c
+++ b/drivers/usb/storage/transport.c
@@ -709,7 +709,7 @@ void usb_stor_invoke_transport(struct scsi_cmnd *srb, struct us_data *us)
 	if (need_auto_sense) {
 		int temp_result;
 		struct scsi_eh_save ses;
-		int sense_size = US_SENSE_SIZE;
+		unsigned int sense_size = US_SENSE_SIZE;
 		struct scsi_sense_hdr sshdr;
 		const u8 *scdd;
 		u8 fm_ili;
diff --git a/drivers/usb/storage/usb.c b/drivers/usb/storage/usb.c
index 8c5f01151..05e59a2a6 100644
--- a/drivers/usb/storage/usb.c
+++ b/drivers/usb/storage/usb.c
@@ -942,7 +942,7 @@ static void usb_stor_scan_dwork(struct work_struct *work)
 	clear_bit(US_FLIDX_SCAN_PENDING, &us->dflags);
 }
 
-static unsigned int usb_stor_sg_tablesize(struct usb_interface *intf)
+static unsigned short usb_stor_sg_tablesize(struct usb_interface *intf)
 {
 	struct usb_device *usb_dev = interface_to_usbdev(intf);
 
diff --git a/drivers/usb/storage/usb.h b/drivers/usb/storage/usb.h
index 8fae28b40..8b4bfecf0 100644
--- a/drivers/usb/storage/usb.h
+++ b/drivers/usb/storage/usb.h
@@ -64,7 +64,7 @@ struct us_unusual_dev {
 	__u8  useProtocol;
 	__u8  useTransport;
 	int (*initFunction)(struct us_data *);
-};
+} __do_const;
 
 
 /* Dynamic bitflag definitions (us->dflags): used in set_bit() etc. */
diff --git a/drivers/usb/usbip/vhci.h b/drivers/usb/usbip/vhci.h
index a863a98a9..d272795fc 100644
--- a/drivers/usb/usbip/vhci.h
+++ b/drivers/usb/usbip/vhci.h
@@ -83,7 +83,7 @@ struct vhci_hcd {
 	unsigned resuming:1;
 	unsigned long re_timeout;
 
-	atomic_t seqnum;
+	atomic_unchecked_t seqnum;
 
 	/*
 	 * NOTE:
diff --git a/drivers/usb/usbip/vhci_hcd.c b/drivers/usb/usbip/vhci_hcd.c
index 2e0450bec..6ebf0f6aa 100644
--- a/drivers/usb/usbip/vhci_hcd.c
+++ b/drivers/usb/usbip/vhci_hcd.c
@@ -447,7 +447,7 @@ static void vhci_tx_urb(struct urb *urb)
 
 	spin_lock_irqsave(&vdev->priv_lock, flags);
 
-	priv->seqnum = atomic_inc_return(&the_controller->seqnum);
+	priv->seqnum = atomic_inc_return_unchecked(&the_controller->seqnum);
 	if (priv->seqnum == 0xffff)
 		dev_info(&urb->dev->dev, "seqnum max\n");
 
@@ -696,7 +696,7 @@ static int vhci_urb_dequeue(struct usb_hcd *hcd, struct urb *urb, int status)
 			return -ENOMEM;
 		}
 
-		unlink->seqnum = atomic_inc_return(&the_controller->seqnum);
+		unlink->seqnum = atomic_inc_return_unchecked(&the_controller->seqnum);
 		if (unlink->seqnum == 0xffff)
 			pr_info("seqnum max\n");
 
@@ -904,7 +904,7 @@ static int vhci_start(struct usb_hcd *hcd)
 		vdev->rhport = rhport;
 	}
 
-	atomic_set(&vhci->seqnum, 0);
+	atomic_set_unchecked(&vhci->seqnum, 0);
 	spin_lock_init(&vhci->lock);
 
 	hcd->power_budget = 0; /* no limit */
diff --git a/drivers/usb/usbip/vhci_rx.c b/drivers/usb/usbip/vhci_rx.c
index d656e0edc..466853eec 100644
--- a/drivers/usb/usbip/vhci_rx.c
+++ b/drivers/usb/usbip/vhci_rx.c
@@ -81,7 +81,7 @@ static void vhci_recv_ret_submit(struct vhci_device *vdev,
 	if (!urb) {
 		pr_err("cannot find a urb of seqnum %u\n", pdu->base.seqnum);
 		pr_info("max seqnum %d\n",
-			atomic_read(&the_controller->seqnum));
+			atomic_read_unchecked(&the_controller->seqnum));
 		usbip_event_add(ud, VDEV_EVENT_ERROR_TCP);
 		return;
 	}
diff --git a/drivers/usb/usbip/vhci_sysfs.c b/drivers/usb/usbip/vhci_sysfs.c
index 5b5462eb1..fac23a024 100644
--- a/drivers/usb/usbip/vhci_sysfs.c
+++ b/drivers/usb/usbip/vhci_sysfs.c
@@ -60,7 +60,7 @@ static ssize_t status_show(struct device *dev, struct device_attribute *attr,
 		if (vdev->ud.status == VDEV_ST_USED) {
 			out += sprintf(out, "%03u %08x ",
 				       vdev->speed, vdev->devid);
-			out += sprintf(out, "%16p ", vdev->ud.tcp_socket);
+			out += sprintf(out, "%16pK ", vdev->ud.tcp_socket);
 			out += sprintf(out, "%s", dev_name(&vdev->udev->dev));
 
 		} else {
diff --git a/drivers/usb/usbip/vudc_rx.c b/drivers/usb/usbip/vudc_rx.c
index e429b59f6..e0840c648 100644
--- a/drivers/usb/usbip/vudc_rx.c
+++ b/drivers/usb/usbip/vudc_rx.c
@@ -142,7 +142,7 @@ static int v_recv_cmd_submit(struct vudc *udc,
 	urb_p->urb->status = -EINPROGRESS;
 
 	/* FIXME: more pipe setup to please usbip_common */
-	urb_p->urb->pipe &= ~(3 << 30);
+	urb_p->urb->pipe &= ~(3U << 30);
 	switch (urb_p->ep->type) {
 	case USB_ENDPOINT_XFER_BULK:
 		urb_p->urb->pipe |= (PIPE_BULK << 30);
diff --git a/drivers/usb/wusbcore/wa-hc.h b/drivers/usb/wusbcore/wa-hc.h
index edc726715..9f65ce299 100644
--- a/drivers/usb/wusbcore/wa-hc.h
+++ b/drivers/usb/wusbcore/wa-hc.h
@@ -240,7 +240,7 @@ struct wahc {
 	spinlock_t xfer_list_lock;
 	struct work_struct xfer_enqueue_work;
 	struct work_struct xfer_error_work;
-	atomic_t xfer_id_count;
+	atomic_unchecked_t xfer_id_count;
 
 	kernel_ulong_t	quirks;
 };
@@ -305,7 +305,7 @@ static inline void wa_init(struct wahc *wa)
 	INIT_WORK(&wa->xfer_enqueue_work, wa_urb_enqueue_run);
 	INIT_WORK(&wa->xfer_error_work, wa_process_errored_transfers_run);
 	wa->dto_in_use = 0;
-	atomic_set(&wa->xfer_id_count, 1);
+	atomic_set_unchecked(&wa->xfer_id_count, 1);
 	/* init the buf in URBs */
 	for (index = 0; index < WA_MAX_BUF_IN_URBS; ++index)
 		usb_init_urb(&(wa->buf_in_urbs[index]));
diff --git a/drivers/usb/wusbcore/wa-xfer.c b/drivers/usb/wusbcore/wa-xfer.c
index 69af4fd9e..da390d742 100644
--- a/drivers/usb/wusbcore/wa-xfer.c
+++ b/drivers/usb/wusbcore/wa-xfer.c
@@ -314,7 +314,7 @@ static void wa_xfer_completion(struct wa_xfer *xfer)
  */
 static void wa_xfer_id_init(struct wa_xfer *xfer)
 {
-	xfer->id = atomic_add_return(1, &xfer->wa->xfer_id_count);
+	xfer->id = atomic_add_return_unchecked(1, &xfer->wa->xfer_id_count);
 }
 
 /* Return the xfer's ID. */
diff --git a/drivers/vfio/pci/vfio_pci.c b/drivers/vfio/pci/vfio_pci.c
index d624a5277..701719169 100644
--- a/drivers/vfio/pci/vfio_pci.c
+++ b/drivers/vfio/pci/vfio_pci.c
@@ -1283,7 +1283,7 @@ static void vfio_pci_remove(struct pci_dev *pdev)
 }
 
 static pci_ers_result_t vfio_pci_aer_err_detected(struct pci_dev *pdev,
-						  pci_channel_state_t state)
+						  enum pci_channel_state state)
 {
 	struct vfio_pci_device *vdev;
 	struct vfio_device *device;
diff --git a/drivers/vhost/vringh.c b/drivers/vhost/vringh.c
index 3bb02c60a..a01ff3878 100644
--- a/drivers/vhost/vringh.c
+++ b/drivers/vhost/vringh.c
@@ -551,7 +551,7 @@ static inline void __vringh_notify_disable(struct vringh *vrh,
 static inline int getu16_user(const struct vringh *vrh, u16 *val, const __virtio16 *p)
 {
 	__virtio16 v = 0;
-	int rc = get_user(v, (__force __virtio16 __user *)p);
+	int rc = get_user(v, (__force_user __virtio16 *)p);
 	*val = vringh16_to_cpu(vrh, v);
 	return rc;
 }
@@ -559,12 +559,12 @@ static inline int getu16_user(const struct vringh *vrh, u16 *val, const __virtio
 static inline int putu16_user(const struct vringh *vrh, __virtio16 *p, u16 val)
 {
 	__virtio16 v = cpu_to_vringh16(vrh, val);
-	return put_user(v, (__force __virtio16 __user *)p);
+	return put_user(v, (__force_user __virtio16 *)p);
 }
 
 static inline int copydesc_user(void *dst, const void *src, size_t len)
 {
-	return copy_from_user(dst, (__force void __user *)src, len) ?
+	return copy_from_user(dst, (void __force_user *)src, len) ?
 		-EFAULT : 0;
 }
 
@@ -572,19 +572,19 @@ static inline int putused_user(struct vring_used_elem *dst,
 			       const struct vring_used_elem *src,
 			       unsigned int num)
 {
-	return copy_to_user((__force void __user *)dst, src,
+	return copy_to_user((void __force_user *)dst, src,
 			    sizeof(*dst) * num) ? -EFAULT : 0;
 }
 
 static inline int xfer_from_user(void *src, void *dst, size_t len)
 {
-	return copy_from_user(dst, (__force void __user *)src, len) ?
+	return copy_from_user(dst, (void __force_user *)src, len) ?
 		-EFAULT : 0;
 }
 
 static inline int xfer_to_user(void *dst, void *src, size_t len)
 {
-	return copy_to_user((__force void __user *)dst, src, len) ?
+	return copy_to_user((void __force_user *)dst, src, len) ?
 		-EFAULT : 0;
 }
 
@@ -621,9 +621,9 @@ int vringh_init_user(struct vringh *vrh, u64 features,
 	vrh->last_used_idx = 0;
 	vrh->vring.num = num;
 	/* vring expects kernel addresses, but only used via accessors. */
-	vrh->vring.desc = (__force struct vring_desc *)desc;
-	vrh->vring.avail = (__force struct vring_avail *)avail;
-	vrh->vring.used = (__force struct vring_used *)used;
+	vrh->vring.desc = (__force_kernel struct vring_desc *)desc;
+	vrh->vring.avail = (__force_kernel struct vring_avail *)avail;
+	vrh->vring.used = (__force_kernel struct vring_used *)used;
 	return 0;
 }
 EXPORT_SYMBOL(vringh_init_user);
@@ -826,7 +826,7 @@ static inline int getu16_kern(const struct vringh *vrh,
 
 static inline int putu16_kern(const struct vringh *vrh, __virtio16 *p, u16 val)
 {
-	ACCESS_ONCE(*p) = cpu_to_vringh16(vrh, val);
+	ACCESS_ONCE_RW(*p) = cpu_to_vringh16(vrh, val);
 	return 0;
 }
 
diff --git a/drivers/video/backlight/kb3886_bl.c b/drivers/video/backlight/kb3886_bl.c
index 84a110a71..96312c3af 100644
--- a/drivers/video/backlight/kb3886_bl.c
+++ b/drivers/video/backlight/kb3886_bl.c
@@ -78,7 +78,7 @@ static struct kb3886bl_machinfo *bl_machinfo;
 static unsigned long kb3886bl_flags;
 #define KB3886BL_SUSPENDED     0x01
 
-static struct dmi_system_id kb3886bl_device_table[] __initdata = {
+static const struct dmi_system_id kb3886bl_device_table[] __initconst = {
 	{
 		.ident = "Sahara Touch-iT",
 		.matches = {
diff --git a/drivers/video/console/dummycon.c b/drivers/video/console/dummycon.c
index 9269d5685..78d2a060e 100644
--- a/drivers/video/console/dummycon.c
+++ b/drivers/video/console/dummycon.c
@@ -41,12 +41,60 @@ static void dummycon_init(struct vc_data *vc, int init)
 	vc_resize(vc, DUMMY_COLUMNS, DUMMY_ROWS);
 }
 
-static int dummycon_dummy(void)
+static void dummycon_deinit(struct vc_data *a)
+{
+}
+
+static void dummycon_clear(struct vc_data *a, int b, int c, int d, int e)
+{
+}
+
+static void dummycon_putc(struct vc_data *a, int b, int c, int d)
+{
+}
+
+static void dummycon_putcs(struct vc_data *a, const unsigned short *b, int c, int d, int e)
+{
+}
+
+static void dummycon_cursor(struct vc_data *a, int b)
+{
+}
+
+static int dummycon_scroll(struct vc_data *a, int b, int c, int d, int e)
+{
+    return 0;
+}
+
+static int dummycon_switch(struct vc_data *a)
 {
     return 0;
 }
 
-#define DUMMY	(void *)dummycon_dummy
+static int dummycon_blank(struct vc_data *a, int b, int c)
+{
+    return 0;
+}
+
+static int dummycon_font_set(struct vc_data *a, struct console_font *b, unsigned c)
+{
+    return 0;
+}
+
+static int dummycon_font_get(struct vc_data *a, struct console_font *b)
+{
+    return 0;
+}
+
+static int dummycon_font_default(struct vc_data *a, struct console_font *b , char *c)
+{
+    return 0;
+}
+
+static int dummycon_font_copy(struct vc_data *a, int b)
+{
+    return 0;
+}
 
 /*
  *  The console `switch' structure for the dummy console
@@ -58,17 +106,17 @@ const struct consw dummy_con = {
     .owner =		THIS_MODULE,
     .con_startup =	dummycon_startup,
     .con_init =		dummycon_init,
-    .con_deinit =	DUMMY,
-    .con_clear =	DUMMY,
-    .con_putc =		DUMMY,
-    .con_putcs =	DUMMY,
-    .con_cursor =	DUMMY,
-    .con_scroll =	DUMMY,
-    .con_switch =	DUMMY,
-    .con_blank =	DUMMY,
-    .con_font_set =	DUMMY,
-    .con_font_get =	DUMMY,
-    .con_font_default =	DUMMY,
-    .con_font_copy =	DUMMY,
+    .con_deinit =	dummycon_deinit,
+    .con_clear =	dummycon_clear,
+    .con_putc =		dummycon_putc,
+    .con_putcs =	dummycon_putcs,
+    .con_cursor =	dummycon_cursor,
+    .con_scroll =	dummycon_scroll,
+    .con_switch =	dummycon_switch,
+    .con_blank =	dummycon_blank,
+    .con_font_set =	dummycon_font_set,
+    .con_font_get =	dummycon_font_get,
+    .con_font_default =	dummycon_font_default,
+    .con_font_copy =	dummycon_font_copy,
 };
 EXPORT_SYMBOL_GPL(dummy_con);
diff --git a/drivers/video/console/fbcon.c b/drivers/video/console/fbcon.c
index b87f5cfda..6aad4f8c1 100644
--- a/drivers/video/console/fbcon.c
+++ b/drivers/video/console/fbcon.c
@@ -106,7 +106,7 @@ static int fbcon_softback_size = 32768;
 static unsigned long softback_buf, softback_curr;
 static unsigned long softback_in;
 static unsigned long softback_top, softback_end;
-static int softback_lines;
+static long softback_lines;
 /* console mappings */
 static int first_fb_vc;
 static int last_fb_vc = MAX_NR_CONSOLES - 1;
diff --git a/drivers/video/console/vgacon.c b/drivers/video/console/vgacon.c
index 11576611a..453a37381 100644
--- a/drivers/video/console/vgacon.c
+++ b/drivers/video/console/vgacon.c
@@ -1404,21 +1404,26 @@ static int vgacon_scroll(struct vc_data *c, int t, int b, int dir,
  *  The console `switch' structure for the VGA based console
  */
 
-static int vgacon_dummy(struct vc_data *c)
+static void vgacon_clear(struct vc_data *vc, int a, int b, int c, int d)
+{
+}
+
+static void vgacon_putc(struct vc_data *vc, int a, int b, int c)
 {
-	return 0;
 }
 
-#define DUMMY (void *) vgacon_dummy
+static void vgacon_putcs(struct vc_data *vc, const unsigned short *a, int b, int c, int d)
+{
+}
 
 const struct consw vga_con = {
 	.owner = THIS_MODULE,
 	.con_startup = vgacon_startup,
 	.con_init = vgacon_init,
 	.con_deinit = vgacon_deinit,
-	.con_clear = DUMMY,
-	.con_putc = DUMMY,
-	.con_putcs = DUMMY,
+	.con_clear = vgacon_clear,
+	.con_putc = vgacon_putc,
+	.con_putcs = vgacon_putcs,
 	.con_cursor = vgacon_cursor,
 	.con_scroll = vgacon_scroll,
 	.con_switch = vgacon_switch,
diff --git a/drivers/video/fbdev/arcfb.c b/drivers/video/fbdev/arcfb.c
index 1b0b233b8..6f34c2ca6 100644
--- a/drivers/video/fbdev/arcfb.c
+++ b/drivers/video/fbdev/arcfb.c
@@ -458,7 +458,7 @@ static ssize_t arcfb_write(struct fb_info *info, const char __user *buf,
 		return -ENOSPC;
 
 	err = 0;
-	if ((count + p) > fbmemlength) {
+	if (count > (fbmemlength - p)) {
 		count = fbmemlength - p;
 		err = -ENOSPC;
 	}
diff --git a/drivers/video/fbdev/aty/aty128fb.c b/drivers/video/fbdev/aty/aty128fb.c
index 0a4626886..e55dcb50a 100644
--- a/drivers/video/fbdev/aty/aty128fb.c
+++ b/drivers/video/fbdev/aty/aty128fb.c
@@ -144,7 +144,7 @@ enum {
 };
 
 /* Must match above enum */
-static char * const r128_family[] = {
+static const char * const r128_family[] = {
 	"AGP",
 	"PCI",
 	"PRO AGP",
diff --git a/drivers/video/fbdev/aty/atyfb_base.c b/drivers/video/fbdev/aty/atyfb_base.c
index f34ed47fc..7283c9f82 100644
--- a/drivers/video/fbdev/aty/atyfb_base.c
+++ b/drivers/video/fbdev/aty/atyfb_base.c
@@ -1335,10 +1335,14 @@ static int atyfb_set_par(struct fb_info *info)
 	par->accel_flags = var->accel_flags; /* hack */
 
 	if (var->accel_flags) {
-		info->fbops->fb_sync = atyfb_sync;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_sync) = atyfb_sync;
+		pax_close_kernel();
 		info->flags &= ~FBINFO_HWACCEL_DISABLED;
 	} else {
-		info->fbops->fb_sync = NULL;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_sync) = NULL;
+		pax_close_kernel();
 		info->flags |= FBINFO_HWACCEL_DISABLED;
 	}
 
diff --git a/drivers/video/fbdev/aty/mach64_ct.c b/drivers/video/fbdev/aty/mach64_ct.c
index 51f29d627..2c1533910 100644
--- a/drivers/video/fbdev/aty/mach64_ct.c
+++ b/drivers/video/fbdev/aty/mach64_ct.c
@@ -630,13 +630,14 @@ static void aty_resume_pll_ct(const struct fb_info *info,
 	aty_st_pll_ct(EXT_VPLL_CNTL, pll->ct.ext_vpll_cntl, par);
 }
 
-static int dummy(void)
+static int aty_set_dac(const struct fb_info * info,
+		const union aty_pll * pll, u32 bpp, u32 accel)
 {
 	return 0;
 }
 
 const struct aty_dac_ops aty_dac_ct = {
-	.set_dac	= (void *) dummy,
+	.set_dac	= aty_set_dac
 };
 
 const struct aty_pll_ops aty_pll_ct = {
diff --git a/drivers/video/fbdev/aty/mach64_cursor.c b/drivers/video/fbdev/aty/mach64_cursor.c
index 2fa0317ab..d687dab4e 100644
--- a/drivers/video/fbdev/aty/mach64_cursor.c
+++ b/drivers/video/fbdev/aty/mach64_cursor.c
@@ -8,6 +8,7 @@
 #include "../core/fb_draw.h"
 
 #include <asm/io.h>
+#include <asm/pgtable.h>
 
 #ifdef __sparc__
 #include <asm/fbio.h>
@@ -218,7 +219,9 @@ int aty_init_cursor(struct fb_info *info)
 	info->sprite.buf_align = 16; 	/* and 64 lines tall. */
 	info->sprite.flags = FB_PIXMAP_IO;
 
-	info->fbops->fb_cursor = atyfb_cursor;
+	pax_open_kernel();
+	const_cast(info->fbops->fb_cursor) = atyfb_cursor;
+	pax_close_kernel();
 
 	return 0;
 }
diff --git a/drivers/video/fbdev/aty/mach64_gx.c b/drivers/video/fbdev/aty/mach64_gx.c
index 10c988aef..f7d9299cf 100644
--- a/drivers/video/fbdev/aty/mach64_gx.c
+++ b/drivers/video/fbdev/aty/mach64_gx.c
@@ -894,17 +894,26 @@ static int aty_set_dac_unsupported(const struct fb_info *info,
 	return 0;
 }
 
-static int dummy(void)
+static int aty_var_to_pll(const struct fb_info * info, u32 vclk_per, u32 bpp, union aty_pll * pll)
 {
 	return 0;
 }
 
+static u32 aty_pll_to_var(const struct fb_info * info, const union aty_pll * pll)
+{
+	return 0;
+}
+
+static void aty_set_pll(const struct fb_info * info, const union aty_pll * pll)
+{
+}
+
 const struct aty_dac_ops aty_dac_unsupported = {
 	.set_dac	= aty_set_dac_unsupported,
 };
 
 const struct aty_pll_ops aty_pll_unsupported = {
-	.var_to_pll	= (void *) dummy,
-	.pll_to_var	= (void *) dummy,
-	.set_pll	= (void *) dummy,
+	.var_to_pll	= aty_var_to_pll,
+	.pll_to_var	= aty_pll_to_var,
+	.set_pll	= aty_set_pll,
 };
diff --git a/drivers/video/fbdev/core/fb_defio.c b/drivers/video/fbdev/core/fb_defio.c
index 74b5bcac8..5bddbeaaa 100644
--- a/drivers/video/fbdev/core/fb_defio.c
+++ b/drivers/video/fbdev/core/fb_defio.c
@@ -208,7 +208,9 @@ void fb_deferred_io_init(struct fb_info *info)
 
 	BUG_ON(!fbdefio);
 	mutex_init(&fbdefio->lock);
-	info->fbops->fb_mmap = fb_deferred_io_mmap;
+	pax_open_kernel();
+	const_cast(info->fbops->fb_mmap) = fb_deferred_io_mmap;
+	pax_close_kernel();
 	INIT_DELAYED_WORK(&info->deferred_work, fb_deferred_io_work);
 	INIT_LIST_HEAD(&fbdefio->pagelist);
 	if (fbdefio->delay == 0) /* set a default of 1 s */
@@ -239,7 +241,9 @@ void fb_deferred_io_cleanup(struct fb_info *info)
 		page->mapping = NULL;
 	}
 
-	info->fbops->fb_mmap = NULL;
+	pax_open_kernel();
+	const_cast(info->fbops->fb_mmap) = NULL;
+	pax_close_kernel();
 	mutex_destroy(&fbdefio->lock);
 }
 EXPORT_SYMBOL_GPL(fb_deferred_io_cleanup);
diff --git a/drivers/video/fbdev/core/fbmem.c b/drivers/video/fbdev/core/fbmem.c
index 76c1ad96f..6ec5e9488 100644
--- a/drivers/video/fbdev/core/fbmem.c
+++ b/drivers/video/fbdev/core/fbmem.c
@@ -1301,7 +1301,7 @@ static int do_fscreeninfo_to_user(struct fb_fix_screeninfo *fix,
 	__u32 data;
 	int err;
 
-	err = copy_to_user(&fix32->id, &fix->id, sizeof(fix32->id));
+	err = copy_to_user(fix32->id, &fix->id, sizeof(fix32->id));
 
 	data = (__u32) (unsigned long) fix->smem_start;
 	err |= put_user(data, &fix32->smem_start);
@@ -1435,10 +1435,7 @@ fb_mmap(struct file *file, struct vm_area_struct * vma)
 	return vm_iomap_memory(vma, start, len);
 }
 
-static int
-fb_open(struct inode *inode, struct file *file)
-__acquires(&info->lock)
-__releases(&info->lock)
+static int fb_open(struct inode *inode, struct file *file)
 {
 	int fbidx = iminor(inode);
 	struct fb_info *info;
@@ -1476,10 +1473,7 @@ out:
 	return res;
 }
 
-static int 
-fb_release(struct inode *inode, struct file *file)
-__acquires(&info->lock)
-__releases(&info->lock)
+static int fb_release(struct inode *inode, struct file *file)
 {
 	struct fb_info * const info = file->private_data;
 
diff --git a/drivers/video/fbdev/hyperv_fb.c b/drivers/video/fbdev/hyperv_fb.c
index 2fd49b235..67e3d8613 100644
--- a/drivers/video/fbdev/hyperv_fb.c
+++ b/drivers/video/fbdev/hyperv_fb.c
@@ -240,7 +240,7 @@ static uint screen_fb_size;
 static inline int synthvid_send(struct hv_device *hdev,
 				struct synthvid_msg *msg)
 {
-	static atomic64_t request_id = ATOMIC64_INIT(0);
+	static atomic64_unchecked_t request_id = ATOMIC64_INIT(0);
 	int ret;
 
 	msg->pipe_hdr.type = PIPE_MSG_DATA;
@@ -248,7 +248,7 @@ static inline int synthvid_send(struct hv_device *hdev,
 
 	ret = vmbus_sendpacket(hdev->channel, msg,
 			       msg->vid_hdr.size + sizeof(struct pipe_msg_hdr),
-			       atomic64_inc_return(&request_id),
+			       atomic64_inc_return_unchecked(&request_id),
 			       VM_PKT_DATA_INBAND, 0);
 
 	if (ret)
diff --git a/drivers/video/fbdev/i810/i810_accel.c b/drivers/video/fbdev/i810/i810_accel.c
index 7672d2ea9..b56437f7b 100644
--- a/drivers/video/fbdev/i810/i810_accel.c
+++ b/drivers/video/fbdev/i810/i810_accel.c
@@ -73,6 +73,7 @@ static inline int wait_for_space(struct fb_info *info, u32 space)
 		}
 	}
 	printk("ringbuffer lockup!!!\n");
+	printk("head:%u tail:%u iring.size:%u space:%u\n", head, tail, par->iring.size, space);
 	i810_report_error(mmio); 
 	par->dev_flags |= LOCKUP;
 	info->pixmap.scan_align = 1;
diff --git a/drivers/video/fbdev/matrox/matroxfb_DAC1064.c b/drivers/video/fbdev/matrox/matroxfb_DAC1064.c
index a01147fdf..5d896f879 100644
--- a/drivers/video/fbdev/matrox/matroxfb_DAC1064.c
+++ b/drivers/video/fbdev/matrox/matroxfb_DAC1064.c
@@ -1088,14 +1088,20 @@ static void MGAG100_restore(struct matrox_fb_info *minfo)
 
 #ifdef CONFIG_FB_MATROX_MYSTIQUE
 struct matrox_switch matrox_mystique = {
-	MGA1064_preinit, MGA1064_reset, MGA1064_init, MGA1064_restore,
+	.preinit = MGA1064_preinit,
+	.reset = MGA1064_reset,
+	.init = MGA1064_init,
+	.restore = MGA1064_restore,
 };
 EXPORT_SYMBOL(matrox_mystique);
 #endif
 
 #ifdef CONFIG_FB_MATROX_G
 struct matrox_switch matrox_G100 = {
-	MGAG100_preinit, MGAG100_reset, MGAG100_init, MGAG100_restore,
+	.preinit = MGAG100_preinit,
+	.reset = MGAG100_reset,
+	.init = MGAG100_init,
+	.restore = MGAG100_restore,
 };
 EXPORT_SYMBOL(matrox_G100);
 #endif
diff --git a/drivers/video/fbdev/matrox/matroxfb_Ti3026.c b/drivers/video/fbdev/matrox/matroxfb_Ti3026.c
index 195ad7cac..09743fc5b 100644
--- a/drivers/video/fbdev/matrox/matroxfb_Ti3026.c
+++ b/drivers/video/fbdev/matrox/matroxfb_Ti3026.c
@@ -738,7 +738,10 @@ static int Ti3026_preinit(struct matrox_fb_info *minfo)
 }
 
 struct matrox_switch matrox_millennium = {
-	Ti3026_preinit, Ti3026_reset, Ti3026_init, Ti3026_restore
+	.preinit = Ti3026_preinit,
+	.reset = Ti3026_reset,
+	.init = Ti3026_init,
+	.restore = Ti3026_restore
 };
 EXPORT_SYMBOL(matrox_millennium);
 #endif
diff --git a/drivers/video/fbdev/matrox/matroxfb_base.c b/drivers/video/fbdev/matrox/matroxfb_base.c
index 11eb09439..622ee31bf 100644
--- a/drivers/video/fbdev/matrox/matroxfb_base.c
+++ b/drivers/video/fbdev/matrox/matroxfb_base.c
@@ -2176,7 +2176,7 @@ static struct pci_driver matroxfb_driver = {
 #define RS1056x480	14	/* 132 x 60 text */
 #define RSNoxNo		15
 /* 10-FF */
-static struct { int xres, yres, left, right, upper, lower, hslen, vslen, vfreq; } timmings[] __initdata = {
+static struct { unsigned int xres, yres, left, right, upper, lower, hslen, vslen, vfreq; } timmings[] __initdata = {
 	{  640,  400,  48, 16, 39,  8,  96, 2, 70 },
 	{  640,  480,  48, 16, 33, 10,  96, 2, 60 },
 	{  800,  600, 144, 24, 28,  8, 112, 6, 60 },
diff --git a/drivers/video/fbdev/mb862xx/mb862xxfb_accel.c b/drivers/video/fbdev/mb862xx/mb862xxfb_accel.c
index fe92eed6d..239e386ad 100644
--- a/drivers/video/fbdev/mb862xx/mb862xxfb_accel.c
+++ b/drivers/video/fbdev/mb862xx/mb862xxfb_accel.c
@@ -312,14 +312,18 @@ void mb862xxfb_init_accel(struct fb_info *info, int xres)
 	struct mb862xxfb_par *par = info->par;
 
 	if (info->var.bits_per_pixel == 32) {
-		info->fbops->fb_fillrect = cfb_fillrect;
-		info->fbops->fb_copyarea = cfb_copyarea;
-		info->fbops->fb_imageblit = cfb_imageblit;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_fillrect) = cfb_fillrect;
+		const_cast(info->fbops->fb_copyarea) = cfb_copyarea;
+		const_cast(info->fbops->fb_imageblit) = cfb_imageblit;
+		pax_close_kernel();
 	} else {
 		outreg(disp, GC_L0EM, 3);
-		info->fbops->fb_fillrect = mb86290fb_fillrect;
-		info->fbops->fb_copyarea = mb86290fb_copyarea;
-		info->fbops->fb_imageblit = mb86290fb_imageblit;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_fillrect) = mb86290fb_fillrect;
+		const_cast(info->fbops->fb_copyarea) = mb86290fb_copyarea;
+		const_cast(info->fbops->fb_imageblit) = mb86290fb_imageblit;
+		pax_close_kernel();
 	}
 	outreg(draw, GDC_REG_DRAW_BASE, 0);
 	outreg(draw, GDC_REG_MODE_MISC, 0x8000);
diff --git a/drivers/video/fbdev/nvidia/nvidia.c b/drivers/video/fbdev/nvidia/nvidia.c
index ce7dab729..89d65219c 100644
--- a/drivers/video/fbdev/nvidia/nvidia.c
+++ b/drivers/video/fbdev/nvidia/nvidia.c
@@ -660,19 +660,23 @@ static int nvidiafb_set_par(struct fb_info *info)
 	info->fix.line_length = (info->var.xres_virtual *
 				 info->var.bits_per_pixel) >> 3;
 	if (info->var.accel_flags) {
-		info->fbops->fb_imageblit = nvidiafb_imageblit;
-		info->fbops->fb_fillrect = nvidiafb_fillrect;
-		info->fbops->fb_copyarea = nvidiafb_copyarea;
-		info->fbops->fb_sync = nvidiafb_sync;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_imageblit) = nvidiafb_imageblit;
+		const_cast(info->fbops->fb_fillrect) = nvidiafb_fillrect;
+		const_cast(info->fbops->fb_copyarea) = nvidiafb_copyarea;
+		const_cast(info->fbops->fb_sync) = nvidiafb_sync;
+		pax_close_kernel();
 		info->pixmap.scan_align = 4;
 		info->flags &= ~FBINFO_HWACCEL_DISABLED;
 		info->flags |= FBINFO_READS_FAST;
 		NVResetGraphics(info);
 	} else {
-		info->fbops->fb_imageblit = cfb_imageblit;
-		info->fbops->fb_fillrect = cfb_fillrect;
-		info->fbops->fb_copyarea = cfb_copyarea;
-		info->fbops->fb_sync = NULL;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_imageblit) = cfb_imageblit;
+		const_cast(info->fbops->fb_fillrect) = cfb_fillrect;
+		const_cast(info->fbops->fb_copyarea) = cfb_copyarea;
+		const_cast(info->fbops->fb_sync) = NULL;
+		pax_close_kernel();
 		info->pixmap.scan_align = 1;
 		info->flags |= FBINFO_HWACCEL_DISABLED;
 		info->flags &= ~FBINFO_READS_FAST;
@@ -1164,8 +1168,11 @@ static int nvidia_set_fbinfo(struct fb_info *info)
 	info->pixmap.size = 8 * 1024;
 	info->pixmap.flags = FB_PIXMAP_SYSTEM;
 
-	if (!hwcur)
-	    info->fbops->fb_cursor = NULL;
+	if (!hwcur) {
+		pax_open_kernel();
+		const_cast(info->fbops->fb_cursor) = NULL;
+		pax_close_kernel();
+	}
 
 	info->var.accel_flags = (!noaccel);
 
diff --git a/drivers/video/fbdev/omap2/omapfb/dss/display.c b/drivers/video/fbdev/omap2/omapfb/dss/display.c
index dd5468695..6ef7ef6bb 100644
--- a/drivers/video/fbdev/omap2/omapfb/dss/display.c
+++ b/drivers/video/fbdev/omap2/omapfb/dss/display.c
@@ -161,12 +161,14 @@ int omapdss_register_display(struct omap_dss_device *dssdev)
 	if (dssdev->name == NULL)
 		dssdev->name = dssdev->alias;
 
+	pax_open_kernel();
 	if (drv && drv->get_resolution == NULL)
-		drv->get_resolution = omapdss_default_get_resolution;
+		const_cast(drv->get_resolution) = omapdss_default_get_resolution;
 	if (drv && drv->get_recommended_bpp == NULL)
-		drv->get_recommended_bpp = omapdss_default_get_recommended_bpp;
+		const_cast(drv->get_recommended_bpp) = omapdss_default_get_recommended_bpp;
 	if (drv && drv->get_timings == NULL)
-		drv->get_timings = omapdss_default_get_timings;
+		const_cast(drv->get_timings) = omapdss_default_get_timings;
+	pax_close_kernel();
 
 	mutex_lock(&panel_list_mutex);
 	list_add_tail(&dssdev->panel_list, &panel_list);
diff --git a/drivers/video/fbdev/s1d13xxxfb.c b/drivers/video/fbdev/s1d13xxxfb.c
index 96aa46dc6..65e25546f 100644
--- a/drivers/video/fbdev/s1d13xxxfb.c
+++ b/drivers/video/fbdev/s1d13xxxfb.c
@@ -880,8 +880,10 @@ static int s1d13xxxfb_probe(struct platform_device *pdev)
 
 	switch(prod_id) {
 	case S1D13506_PROD_ID:	/* activate acceleration */
-		s1d13xxxfb_fbops.fb_fillrect = s1d13xxxfb_bitblt_solidfill;
-		s1d13xxxfb_fbops.fb_copyarea = s1d13xxxfb_bitblt_copyarea;
+		pax_open_kernel();
+		const_cast(s1d13xxxfb_fbops.fb_fillrect) = s1d13xxxfb_bitblt_solidfill;
+		const_cast(s1d13xxxfb_fbops.fb_copyarea) = s1d13xxxfb_bitblt_copyarea;
+		pax_close_kernel();
 		info->flags = FBINFO_DEFAULT | FBINFO_HWACCEL_YPAN |
 			FBINFO_HWACCEL_FILLRECT | FBINFO_HWACCEL_COPYAREA;
 		break;
diff --git a/drivers/video/fbdev/sh_mobile_lcdcfb.c b/drivers/video/fbdev/sh_mobile_lcdcfb.c
index 82c0a8caa..42499a1af 100644
--- a/drivers/video/fbdev/sh_mobile_lcdcfb.c
+++ b/drivers/video/fbdev/sh_mobile_lcdcfb.c
@@ -439,9 +439,9 @@ static unsigned long lcdc_sys_read_data(void *handle)
 }
 
 static struct sh_mobile_lcdc_sys_bus_ops sh_mobile_lcdc_sys_bus_ops = {
-	lcdc_sys_write_index,
-	lcdc_sys_write_data,
-	lcdc_sys_read_data,
+	.write_index = lcdc_sys_write_index,
+	.write_data = lcdc_sys_write_data,
+	.read_data = lcdc_sys_read_data,
 };
 
 static int sh_mobile_lcdc_sginit(struct fb_info *info,
diff --git a/drivers/video/fbdev/sis/sis_main.h b/drivers/video/fbdev/sis/sis_main.h
index 32e23c209..7b73082f9 100644
--- a/drivers/video/fbdev/sis/sis_main.h
+++ b/drivers/video/fbdev/sis/sis_main.h
@@ -763,7 +763,7 @@ extern void		SiS_SetCH700x(struct SiS_Private *SiS_Pr, unsigned short reg, unsig
 extern unsigned short	SiS_GetCH701x(struct SiS_Private *SiS_Pr, unsigned short reg);
 extern void		SiS_SetCH701x(struct SiS_Private *SiS_Pr, unsigned short reg, unsigned char val);
 extern void		SiS_SetCH70xxANDOR(struct SiS_Private *SiS_Pr, unsigned short reg,
-				unsigned char myor, unsigned char myand);
+				unsigned char myor, unsigned short myand);
 extern void		SiS_DDC2Delay(struct SiS_Private *SiS_Pr, unsigned int delaytime);
 extern void		SiS_SetChrontelGPIO(struct SiS_Private *SiS_Pr, unsigned short myvbinfo);
 extern unsigned short	SiS_HandleDDC(struct SiS_Private *SiS_Pr, unsigned int VBFlags, int VGAEngine,
diff --git a/drivers/video/fbdev/smscufx.c b/drivers/video/fbdev/smscufx.c
index 9279e5f66..d9fb0bd34 100644
--- a/drivers/video/fbdev/smscufx.c
+++ b/drivers/video/fbdev/smscufx.c
@@ -1174,7 +1174,9 @@ static int ufx_ops_release(struct fb_info *info, int user)
 		fb_deferred_io_cleanup(info);
 		kfree(info->fbdefio);
 		info->fbdefio = NULL;
-		info->fbops->fb_mmap = ufx_ops_mmap;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_mmap) = ufx_ops_mmap;
+		pax_close_kernel();
 	}
 
 	pr_debug("released /dev/fb%d user=%d count=%d",
diff --git a/drivers/video/fbdev/udlfb.c b/drivers/video/fbdev/udlfb.c
index e9c2f7ba3..87506f40f 100644
--- a/drivers/video/fbdev/udlfb.c
+++ b/drivers/video/fbdev/udlfb.c
@@ -623,11 +623,11 @@ static int dlfb_handle_damage(struct dlfb_data *dev, int x, int y,
 		dlfb_urb_completion(urb);
 
 error:
-	atomic_add(bytes_sent, &dev->bytes_sent);
-	atomic_add(bytes_identical, &dev->bytes_identical);
-	atomic_add(width*height*2, &dev->bytes_rendered);
+	atomic_add_unchecked(bytes_sent, &dev->bytes_sent);
+	atomic_add_unchecked(bytes_identical, &dev->bytes_identical);
+	atomic_add_unchecked(width*height*2, &dev->bytes_rendered);
 	end_cycles = get_cycles();
-	atomic_add(((unsigned int) ((end_cycles - start_cycles)
+	atomic_add_unchecked(((unsigned int) ((end_cycles - start_cycles)
 		    >> 10)), /* Kcycles */
 		   &dev->cpu_kcycles_used);
 
@@ -748,11 +748,11 @@ static void dlfb_dpy_deferred_io(struct fb_info *info,
 		dlfb_urb_completion(urb);
 
 error:
-	atomic_add(bytes_sent, &dev->bytes_sent);
-	atomic_add(bytes_identical, &dev->bytes_identical);
-	atomic_add(bytes_rendered, &dev->bytes_rendered);
+	atomic_add_unchecked(bytes_sent, &dev->bytes_sent);
+	atomic_add_unchecked(bytes_identical, &dev->bytes_identical);
+	atomic_add_unchecked(bytes_rendered, &dev->bytes_rendered);
 	end_cycles = get_cycles();
-	atomic_add(((unsigned int) ((end_cycles - start_cycles)
+	atomic_add_unchecked(((unsigned int) ((end_cycles - start_cycles)
 		    >> 10)), /* Kcycles */
 		   &dev->cpu_kcycles_used);
 }
@@ -991,7 +991,9 @@ static int dlfb_ops_release(struct fb_info *info, int user)
 		fb_deferred_io_cleanup(info);
 		kfree(info->fbdefio);
 		info->fbdefio = NULL;
-		info->fbops->fb_mmap = dlfb_ops_mmap;
+		pax_open_kernel();
+		const_cast(info->fbops->fb_mmap) = dlfb_ops_mmap;
+		pax_close_kernel();
 	}
 
 	pr_warn("released /dev/fb%d user=%d count=%d\n",
@@ -1373,7 +1375,7 @@ static ssize_t metrics_bytes_rendered_show(struct device *fbdev,
 	struct fb_info *fb_info = dev_get_drvdata(fbdev);
 	struct dlfb_data *dev = fb_info->par;
 	return snprintf(buf, PAGE_SIZE, "%u\n",
-			atomic_read(&dev->bytes_rendered));
+			atomic_read_unchecked(&dev->bytes_rendered));
 }
 
 static ssize_t metrics_bytes_identical_show(struct device *fbdev,
@@ -1381,7 +1383,7 @@ static ssize_t metrics_bytes_identical_show(struct device *fbdev,
 	struct fb_info *fb_info = dev_get_drvdata(fbdev);
 	struct dlfb_data *dev = fb_info->par;
 	return snprintf(buf, PAGE_SIZE, "%u\n",
-			atomic_read(&dev->bytes_identical));
+			atomic_read_unchecked(&dev->bytes_identical));
 }
 
 static ssize_t metrics_bytes_sent_show(struct device *fbdev,
@@ -1389,7 +1391,7 @@ static ssize_t metrics_bytes_sent_show(struct device *fbdev,
 	struct fb_info *fb_info = dev_get_drvdata(fbdev);
 	struct dlfb_data *dev = fb_info->par;
 	return snprintf(buf, PAGE_SIZE, "%u\n",
-			atomic_read(&dev->bytes_sent));
+			atomic_read_unchecked(&dev->bytes_sent));
 }
 
 static ssize_t metrics_cpu_kcycles_used_show(struct device *fbdev,
@@ -1397,7 +1399,7 @@ static ssize_t metrics_cpu_kcycles_used_show(struct device *fbdev,
 	struct fb_info *fb_info = dev_get_drvdata(fbdev);
 	struct dlfb_data *dev = fb_info->par;
 	return snprintf(buf, PAGE_SIZE, "%u\n",
-			atomic_read(&dev->cpu_kcycles_used));
+			atomic_read_unchecked(&dev->cpu_kcycles_used));
 }
 
 static ssize_t edid_show(
@@ -1457,10 +1459,10 @@ static ssize_t metrics_reset_store(struct device *fbdev,
 	struct fb_info *fb_info = dev_get_drvdata(fbdev);
 	struct dlfb_data *dev = fb_info->par;
 
-	atomic_set(&dev->bytes_rendered, 0);
-	atomic_set(&dev->bytes_identical, 0);
-	atomic_set(&dev->bytes_sent, 0);
-	atomic_set(&dev->cpu_kcycles_used, 0);
+	atomic_set_unchecked(&dev->bytes_rendered, 0);
+	atomic_set_unchecked(&dev->bytes_identical, 0);
+	atomic_set_unchecked(&dev->bytes_sent, 0);
+	atomic_set_unchecked(&dev->cpu_kcycles_used, 0);
 
 	return count;
 }
diff --git a/drivers/video/fbdev/uvesafb.c b/drivers/video/fbdev/uvesafb.c
index 178ae93b7..043ddcada 100644
--- a/drivers/video/fbdev/uvesafb.c
+++ b/drivers/video/fbdev/uvesafb.c
@@ -19,6 +19,7 @@
 #include <linux/io.h>
 #include <linux/mutex.h>
 #include <linux/slab.h>
+#include <linux/moduleloader.h>
 #include <video/edid.h>
 #include <video/uvesafb.h>
 #ifdef CONFIG_X86
@@ -565,10 +566,32 @@ static int uvesafb_vbe_getpmi(struct uvesafb_ktask *task,
 	if ((task->t.regs.eax & 0xffff) != 0x4f || task->t.regs.es < 0xc000) {
 		par->pmi_setpal = par->ypan = 0;
 	} else {
+
+#ifdef CONFIG_PAX_KERNEXEC
+#ifdef CONFIG_MODULES
+		par->pmi_code = module_alloc_exec((u16)task->t.regs.ecx);
+#endif
+		if (!par->pmi_code) {
+			par->pmi_setpal = par->ypan = 0;
+			return 0;
+		}
+#endif
+
 		par->pmi_base = (u16 *)phys_to_virt(((u32)task->t.regs.es << 4)
 						+ task->t.regs.edi);
+
+#if defined(CONFIG_MODULES) && defined(CONFIG_PAX_KERNEXEC)
+		pax_open_kernel();
+		memcpy(par->pmi_code, par->pmi_base, (u16)task->t.regs.ecx);
+		pax_close_kernel();
+
+		par->pmi_start = (void *)ktva_ktla((unsigned long)(par->pmi_code + par->pmi_base[1]));
+		par->pmi_pal = (void *)ktva_ktla((unsigned long)(par->pmi_code + par->pmi_base[2]));
+#else
 		par->pmi_start = (u8 *)par->pmi_base + par->pmi_base[1];
 		par->pmi_pal = (u8 *)par->pmi_base + par->pmi_base[2];
+#endif
+
 		printk(KERN_INFO "uvesafb: protected mode interface info at "
 				 "%04x:%04x\n",
 				 (u16)task->t.regs.es, (u16)task->t.regs.edi);
@@ -813,13 +836,14 @@ static int uvesafb_vbe_init(struct fb_info *info)
 	par->ypan = ypan;
 
 	if (par->pmi_setpal || par->ypan) {
+#if !defined(CONFIG_MODULES) || !defined(CONFIG_PAX_KERNEXEC)
 		if (__supported_pte_mask & _PAGE_NX) {
 			par->pmi_setpal = par->ypan = 0;
 			printk(KERN_WARNING "uvesafb: NX protection is active, "
 					    "better not use the PMI.\n");
-		} else {
+		} else
+#endif
 			uvesafb_vbe_getpmi(task, par);
-		}
 	}
 #else
 	/* The protected mode interface is not available on non-x86. */
@@ -1452,8 +1476,11 @@ static void uvesafb_init_info(struct fb_info *info, struct vbe_mode_ib *mode)
 	info->fix.ywrapstep = (par->ypan > 1) ? 1 : 0;
 
 	/* Disable blanking if the user requested so. */
-	if (!blank)
-		info->fbops->fb_blank = NULL;
+	if (!blank) {
+		pax_open_kernel();
+		const_cast(info->fbops->fb_blank) = NULL;
+		pax_close_kernel();
+	}
 
 	/*
 	 * Find out how much IO memory is required for the mode with
@@ -1524,8 +1551,11 @@ static void uvesafb_init_info(struct fb_info *info, struct vbe_mode_ib *mode)
 	info->flags = FBINFO_FLAG_DEFAULT |
 			(par->ypan ? FBINFO_HWACCEL_YPAN : 0);
 
-	if (!par->ypan)
-		info->fbops->fb_pan_display = NULL;
+	if (!par->ypan) {
+		pax_open_kernel();
+		const_cast(info->fbops->fb_pan_display) = NULL;
+		pax_close_kernel();
+	}
 }
 
 static void uvesafb_init_mtrr(struct fb_info *info)
@@ -1786,6 +1816,11 @@ out_mode:
 out:
 	kfree(par->vbe_modes);
 
+#if defined(CONFIG_MODULES) && defined(CONFIG_PAX_KERNEXEC)
+	if (par->pmi_code)
+		module_memfree_exec(par->pmi_code);
+#endif
+
 	framebuffer_release(info);
 	return err;
 }
@@ -1810,6 +1845,11 @@ static int uvesafb_remove(struct platform_device *dev)
 		kfree(par->vbe_state_orig);
 		kfree(par->vbe_state_saved);
 
+#if defined(CONFIG_MODULES) && defined(CONFIG_PAX_KERNEXEC)
+		if (par->pmi_code)
+			module_memfree_exec(par->pmi_code);
+#endif
+
 		framebuffer_release(info);
 	}
 	return 0;
diff --git a/drivers/video/fbdev/vesafb.c b/drivers/video/fbdev/vesafb.c
index 528fe917d..475d9e609 100644
--- a/drivers/video/fbdev/vesafb.c
+++ b/drivers/video/fbdev/vesafb.c
@@ -9,6 +9,7 @@
  */
 
 #include <linux/module.h>
+#include <linux/moduleloader.h>
 #include <linux/kernel.h>
 #include <linux/errno.h>
 #include <linux/string.h>
@@ -56,8 +57,8 @@ static int   vram_remap;			/* Set amount of memory to be used */
 static int   vram_total;			/* Set total amount of memory */
 static int   pmi_setpal __read_mostly = 1;	/* pmi for palette changes ??? */
 static int   ypan       __read_mostly;		/* 0..nothing, 1..ypan, 2..ywrap */
-static void  (*pmi_start)(void) __read_mostly;
-static void  (*pmi_pal)  (void) __read_mostly;
+static void  (*pmi_start)(void) __read_only;
+static void  (*pmi_pal)  (void) __read_only;
 static int   depth      __read_mostly;
 static int   vga_compat __read_mostly;
 /* --------------------------------------------------------------------- */
@@ -241,6 +242,7 @@ static int vesafb_probe(struct platform_device *dev)
 	unsigned int size_remap;
 	unsigned int size_total;
 	char *option = NULL;
+	void *pmi_code = NULL;
 
 	/* ignore error return of fb_get_options */
 	fb_get_options("vesafb", &option);
@@ -287,10 +289,6 @@ static int vesafb_probe(struct platform_device *dev)
 		size_remap = size_total;
 	vesafb_fix.smem_len = size_remap;
 
-#ifndef __i386__
-	screen_info.vesapm_seg = 0;
-#endif
-
 	if (!request_mem_region(vesafb_fix.smem_start, size_total, "vesafb")) {
 		printk(KERN_WARNING
 		       "vesafb: cannot reserve video memory at 0x%lx\n",
@@ -320,9 +318,21 @@ static int vesafb_probe(struct platform_device *dev)
 	printk(KERN_INFO "vesafb: mode is %dx%dx%d, linelength=%d, pages=%d\n",
 	       vesafb_defined.xres, vesafb_defined.yres, vesafb_defined.bits_per_pixel, vesafb_fix.line_length, screen_info.pages);
 
+#ifdef __i386__
+
+#if defined(CONFIG_MODULES) && defined(CONFIG_PAX_KERNEXEC)
+	pmi_code = module_alloc_exec(screen_info.vesapm_size);
+	if (!pmi_code)
+#elif !defined(CONFIG_PAX_KERNEXEC)
+	if (0)
+#endif
+
+#endif
+	screen_info.vesapm_seg = 0;
+
 	if (screen_info.vesapm_seg) {
-		printk(KERN_INFO "vesafb: protected mode interface info at %04x:%04x\n",
-		       screen_info.vesapm_seg,screen_info.vesapm_off);
+		printk(KERN_INFO "vesafb: protected mode interface info at %04x:%04x %04x bytes\n",
+		       screen_info.vesapm_seg,screen_info.vesapm_off,screen_info.vesapm_size);
 	}
 
 	if (screen_info.vesapm_seg < 0xc000)
@@ -330,9 +340,25 @@ static int vesafb_probe(struct platform_device *dev)
 
 	if (ypan || pmi_setpal) {
 		unsigned short *pmi_base;
+
 		pmi_base  = (unsigned short*)phys_to_virt(((unsigned long)screen_info.vesapm_seg << 4) + screen_info.vesapm_off);
-		pmi_start = (void*)((char*)pmi_base + pmi_base[1]);
-		pmi_pal   = (void*)((char*)pmi_base + pmi_base[2]);
+
+#if defined(CONFIG_MODULES) && defined(CONFIG_PAX_KERNEXEC)
+		pax_open_kernel();
+		memcpy(pmi_code, pmi_base, screen_info.vesapm_size);
+#else
+		pmi_code  = pmi_base;
+#endif
+
+		pmi_start = (void*)((char*)pmi_code + pmi_base[1]);
+		pmi_pal   = (void*)((char*)pmi_code + pmi_base[2]);
+
+#if defined(CONFIG_MODULES) && defined(CONFIG_PAX_KERNEXEC)
+		pmi_start = (void *)ktva_ktla((unsigned long)pmi_start);
+		pmi_pal = (void *)ktva_ktla((unsigned long)pmi_pal);
+		pax_close_kernel();
+#endif
+
 		printk(KERN_INFO "vesafb: pmi: set display start = %p, set palette = %p\n",pmi_start,pmi_pal);
 		if (pmi_base[3]) {
 			printk(KERN_INFO "vesafb: pmi: ports = ");
@@ -452,8 +478,11 @@ static int vesafb_probe(struct platform_device *dev)
 	info->flags = FBINFO_FLAG_DEFAULT | FBINFO_MISC_FIRMWARE |
 		(ypan ? FBINFO_HWACCEL_YPAN : 0);
 
-	if (!ypan)
-		info->fbops->fb_pan_display = NULL;
+	if (!ypan) {
+		pax_open_kernel();
+		const_cast(info->fbops->fb_pan_display) = NULL;
+		pax_close_kernel();
+	}
 
 	if (fb_alloc_cmap(&info->cmap, 256, 0) < 0) {
 		err = -ENOMEM;
@@ -467,6 +496,11 @@ static int vesafb_probe(struct platform_device *dev)
 	fb_info(info, "%s frame buffer device\n", info->fix.id);
 	return 0;
 err:
+
+#if defined(__i386__) && defined(CONFIG_MODULES) && defined(CONFIG_PAX_KERNEXEC)
+	module_memfree_exec(pmi_code);
+#endif
+
 	arch_phys_wc_del(par->wc_cookie);
 	if (info->screen_base)
 		iounmap(info->screen_base);
diff --git a/drivers/video/fbdev/via/via_clock.h b/drivers/video/fbdev/via/via_clock.h
index 88714ae0d..16c2e1113 100644
--- a/drivers/video/fbdev/via/via_clock.h
+++ b/drivers/video/fbdev/via/via_clock.h
@@ -56,7 +56,7 @@ struct via_clock {
 
 	void (*set_engine_pll_state)(u8 state);
 	void (*set_engine_pll)(struct via_pll_config config);
-};
+} __no_const;
 
 
 static inline u32 get_pll_internal_frequency(u32 ref_freq,
diff --git a/drivers/video/logo/logo_linux_clut224.ppm b/drivers/video/logo/logo_linux_clut224.ppm
index 3c14e43b8..263057016 100644
--- a/drivers/video/logo/logo_linux_clut224.ppm
+++ b/drivers/video/logo/logo_linux_clut224.ppm
@@ -2,1603 +2,1123 @@ P3
 # Standard 224-color Linux logo
 80 80
 255
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6   6   6   6  10  10  10  10  10  10
- 10  10  10   6   6   6   6   6   6   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6  10  10  10  14  14  14
- 22  22  22  26  26  26  30  30  30  34  34  34
- 30  30  30  30  30  30  26  26  26  18  18  18
- 14  14  14  10  10  10   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  14  14  14  26  26  26  42  42  42
- 54  54  54  66  66  66  78  78  78  78  78  78
- 78  78  78  74  74  74  66  66  66  54  54  54
- 42  42  42  26  26  26  18  18  18  10  10  10
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 22  22  22  42  42  42  66  66  66  86  86  86
- 66  66  66  38  38  38  38  38  38  22  22  22
- 26  26  26  34  34  34  54  54  54  66  66  66
- 86  86  86  70  70  70  46  46  46  26  26  26
- 14  14  14   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0  10  10  10  26  26  26
- 50  50  50  82  82  82  58  58  58   6   6   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  6   6   6  54  54  54  86  86  86  66  66  66
- 38  38  38  18  18  18   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6  22  22  22  50  50  50
- 78  78  78  34  34  34   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   6   6   6  70  70  70
- 78  78  78  46  46  46  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  18  18  18  42  42  42  82  82  82
- 26  26  26   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  14  14  14
- 46  46  46  34  34  34   6   6   6   2   2   6
- 42  42  42  78  78  78  42  42  42  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   0   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
- 10  10  10  30  30  30  66  66  66  58  58  58
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  26  26  26
- 86  86  86 101 101 101  46  46  46  10  10  10
-  2   2   6  58  58  58  70  70  70  34  34  34
- 10  10  10   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
- 14  14  14  42  42  42  86  86  86  10  10  10
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  30  30  30
- 94  94  94  94  94  94  58  58  58  26  26  26
-  2   2   6   6   6   6  78  78  78  54  54  54
- 22  22  22   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 22  22  22  62  62  62  62  62  62   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  26  26  26
- 54  54  54  38  38  38  18  18  18  10  10  10
-  2   2   6   2   2   6  34  34  34  82  82  82
- 38  38  38  14  14  14   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 30  30  30  78  78  78  30  30  30   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  10  10  10
- 10  10  10   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  78  78  78
- 50  50  50  18  18  18   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 38  38  38  86  86  86  14  14  14   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  54  54  54
- 66  66  66  26  26  26   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 42  42  42  82  82  82   2   2   6   2   2   6
-  2   2   6   6   6   6  10  10  10   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   6   6   6
- 14  14  14  10  10  10   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  18  18  18
- 82  82  82  34  34  34  10  10  10   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 46  46  46  86  86  86   2   2   6   2   2   6
-  6   6   6   6   6   6  22  22  22  34  34  34
-  6   6   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6  18  18  18  34  34  34
- 10  10  10  50  50  50  22  22  22   2   2   6
-  2   2   6   2   2   6   2   2   6  10  10  10
- 86  86  86  42  42  42  14  14  14   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   1   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 46  46  46  86  86  86   2   2   6   2   2   6
- 38  38  38 116 116 116  94  94  94  22  22  22
- 22  22  22   2   2   6   2   2   6   2   2   6
- 14  14  14  86  86  86 138 138 138 162 162 162
-154 154 154  38  38  38  26  26  26   6   6   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 86  86  86  46  46  46  14  14  14   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 46  46  46  86  86  86   2   2   6  14  14  14
-134 134 134 198 198 198 195 195 195 116 116 116
- 10  10  10   2   2   6   2   2   6   6   6   6
-101  98  89 187 187 187 210 210 210 218 218 218
-214 214 214 134 134 134  14  14  14   6   6   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 86  86  86  50  50  50  18  18  18   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   1   0   0   0
-  0   0   1   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 46  46  46  86  86  86   2   2   6  54  54  54
-218 218 218 195 195 195 226 226 226 246 246 246
- 58  58  58   2   2   6   2   2   6  30  30  30
-210 210 210 253 253 253 174 174 174 123 123 123
-221 221 221 234 234 234  74  74  74   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 70  70  70  58  58  58  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 46  46  46  82  82  82   2   2   6 106 106 106
-170 170 170  26  26  26  86  86  86 226 226 226
-123 123 123  10  10  10  14  14  14  46  46  46
-231 231 231 190 190 190   6   6   6  70  70  70
- 90  90  90 238 238 238 158 158 158   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 70  70  70  58  58  58  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   1   0   0   0
-  0   0   1   0   0   1   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 42  42  42  86  86  86   6   6   6 116 116 116
-106 106 106   6   6   6  70  70  70 149 149 149
-128 128 128  18  18  18  38  38  38  54  54  54
-221 221 221 106 106 106   2   2   6  14  14  14
- 46  46  46 190 190 190 198 198 198   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 74  74  74  62  62  62  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   1   0   0   0
-  0   0   1   0   0   0   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 42  42  42  94  94  94  14  14  14 101 101 101
-128 128 128   2   2   6  18  18  18 116 116 116
-118  98  46 121  92   8 121  92   8  98  78  10
-162 162 162 106 106 106   2   2   6   2   2   6
-  2   2   6 195 195 195 195 195 195   6   6   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 74  74  74  62  62  62  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   1   0   0   1
-  0   0   1   0   0   0   0   0   1   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 38  38  38  90  90  90  14  14  14  58  58  58
-210 210 210  26  26  26  54  38   6 154 114  10
-226 170  11 236 186  11 225 175  15 184 144  12
-215 174  15 175 146  61  37  26   9   2   2   6
- 70  70  70 246 246 246 138 138 138   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 70  70  70  66  66  66  26  26  26   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 38  38  38  86  86  86  14  14  14  10  10  10
-195 195 195 188 164 115 192 133   9 225 175  15
-239 182  13 234 190  10 232 195  16 232 200  30
-245 207  45 241 208  19 232 195  16 184 144  12
-218 194 134 211 206 186  42  42  42   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 50  50  50  74  74  74  30  30  30   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 34  34  34  86  86  86  14  14  14   2   2   6
-121  87  25 192 133   9 219 162  10 239 182  13
-236 186  11 232 195  16 241 208  19 244 214  54
-246 218  60 246 218  38 246 215  20 241 208  19
-241 208  19 226 184  13 121  87  25   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 50  50  50  82  82  82  34  34  34  10  10  10
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 34  34  34  82  82  82  30  30  30  61  42   6
-180 123   7 206 145  10 230 174  11 239 182  13
-234 190  10 238 202  15 241 208  19 246 218  74
-246 218  38 246 215  20 246 215  20 246 215  20
-226 184  13 215 174  15 184 144  12   6   6   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 26  26  26  94  94  94  42  42  42  14  14  14
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 30  30  30  78  78  78  50  50  50 104  69   6
-192 133   9 216 158  10 236 178  12 236 186  11
-232 195  16 241 208  19 244 214  54 245 215  43
-246 215  20 246 215  20 241 208  19 198 155  10
-200 144  11 216 158  10 156 118  10   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  6   6   6  90  90  90  54  54  54  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 30  30  30  78  78  78  46  46  46  22  22  22
-137  92   6 210 162  10 239 182  13 238 190  10
-238 202  15 241 208  19 246 215  20 246 215  20
-241 208  19 203 166  17 185 133  11 210 150  10
-216 158  10 210 150  10 102  78  10   2   2   6
-  6   6   6  54  54  54  14  14  14   2   2   6
-  2   2   6  62  62  62  74  74  74  30  30  30
- 10  10  10   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 34  34  34  78  78  78  50  50  50   6   6   6
- 94  70  30 139 102  15 190 146  13 226 184  13
-232 200  30 232 195  16 215 174  15 190 146  13
-168 122  10 192 133   9 210 150  10 213 154  11
-202 150  34 182 157 106 101  98  89   2   2   6
-  2   2   6  78  78  78 116 116 116  58  58  58
-  2   2   6  22  22  22  90  90  90  46  46  46
- 18  18  18   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 38  38  38  86  86  86  50  50  50   6   6   6
-128 128 128 174 154 114 156 107  11 168 122  10
-198 155  10 184 144  12 197 138  11 200 144  11
-206 145  10 206 145  10 197 138  11 188 164 115
-195 195 195 198 198 198 174 174 174  14  14  14
-  2   2   6  22  22  22 116 116 116 116 116 116
- 22  22  22   2   2   6  74  74  74  70  70  70
- 30  30  30  10  10  10   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  18  18  18
- 50  50  50 101 101 101  26  26  26  10  10  10
-138 138 138 190 190 190 174 154 114 156 107  11
-197 138  11 200 144  11 197 138  11 192 133   9
-180 123   7 190 142  34 190 178 144 187 187 187
-202 202 202 221 221 221 214 214 214  66  66  66
-  2   2   6   2   2   6  50  50  50  62  62  62
-  6   6   6   2   2   6  10  10  10  90  90  90
- 50  50  50  18  18  18   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0  10  10  10  34  34  34
- 74  74  74  74  74  74   2   2   6   6   6   6
-144 144 144 198 198 198 190 190 190 178 166 146
-154 121  60 156 107  11 156 107  11 168 124  44
-174 154 114 187 187 187 190 190 190 210 210 210
-246 246 246 253 253 253 253 253 253 182 182 182
-  6   6   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  62  62  62
- 74  74  74  34  34  34  14  14  14   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0  10  10  10  22  22  22  54  54  54
- 94  94  94  18  18  18   2   2   6  46  46  46
-234 234 234 221 221 221 190 190 190 190 190 190
-190 190 190 187 187 187 187 187 187 190 190 190
-190 190 190 195 195 195 214 214 214 242 242 242
-253 253 253 253 253 253 253 253 253 253 253 253
- 82  82  82   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  14  14  14
- 86  86  86  54  54  54  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  18  18  18  46  46  46  90  90  90
- 46  46  46  18  18  18   6   6   6 182 182 182
-253 253 253 246 246 246 206 206 206 190 190 190
-190 190 190 190 190 190 190 190 190 190 190 190
-206 206 206 231 231 231 250 250 250 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-202 202 202  14  14  14   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 42  42  42  86  86  86  42  42  42  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 14  14  14  38  38  38  74  74  74  66  66  66
-  2   2   6   6   6   6  90  90  90 250 250 250
-253 253 253 253 253 253 238 238 238 198 198 198
-190 190 190 190 190 190 195 195 195 221 221 221
-246 246 246 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253  82  82  82   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  78  78  78  70  70  70  34  34  34
- 14  14  14   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 34  34  34  66  66  66  78  78  78   6   6   6
-  2   2   6  18  18  18 218 218 218 253 253 253
-253 253 253 253 253 253 253 253 253 246 246 246
-226 226 226 231 231 231 246 246 246 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 178 178 178   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  18  18  18  90  90  90  62  62  62
- 30  30  30  10  10  10   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0  10  10  10  26  26  26
- 58  58  58  90  90  90  18  18  18   2   2   6
-  2   2   6 110 110 110 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-250 250 250 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 231 231 231  18  18  18   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6  18  18  18  94  94  94
- 54  54  54  26  26  26  10  10  10   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6  22  22  22  50  50  50
- 90  90  90  26  26  26   2   2   6   2   2   6
- 14  14  14 195 195 195 250 250 250 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-250 250 250 242 242 242  54  54  54   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6  38  38  38
- 86  86  86  50  50  50  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  14  14  14  38  38  38  82  82  82
- 34  34  34   2   2   6   2   2   6   2   2   6
- 42  42  42 195 195 195 246 246 246 253 253 253
-253 253 253 253 253 253 253 253 253 250 250 250
-242 242 242 242 242 242 250 250 250 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 250 250 250 246 246 246 238 238 238
-226 226 226 231 231 231 101 101 101   6   6   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
- 38  38  38  82  82  82  42  42  42  14  14  14
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
- 10  10  10  26  26  26  62  62  62  66  66  66
-  2   2   6   2   2   6   2   2   6   6   6   6
- 70  70  70 170 170 170 206 206 206 234 234 234
-246 246 246 250 250 250 250 250 250 238 238 238
-226 226 226 231 231 231 238 238 238 250 250 250
-250 250 250 250 250 250 246 246 246 231 231 231
-214 214 214 206 206 206 202 202 202 202 202 202
-198 198 198 202 202 202 182 182 182  18  18  18
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  62  62  62  66  66  66  30  30  30
- 10  10  10   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
- 14  14  14  42  42  42  82  82  82  18  18  18
-  2   2   6   2   2   6   2   2   6  10  10  10
- 94  94  94 182 182 182 218 218 218 242 242 242
-250 250 250 253 253 253 253 253 253 250 250 250
-234 234 234 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 246 246 246
-238 238 238 226 226 226 210 210 210 202 202 202
-195 195 195 195 195 195 210 210 210 158 158 158
-  6   6   6  14  14  14  50  50  50  14  14  14
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   6   6   6  86  86  86  46  46  46
- 18  18  18   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 22  22  22  54  54  54  70  70  70   2   2   6
-  2   2   6  10  10  10   2   2   6  22  22  22
-166 166 166 231 231 231 250 250 250 253 253 253
-253 253 253 253 253 253 253 253 253 250 250 250
-242 242 242 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 246 246 246
-231 231 231 206 206 206 198 198 198 226 226 226
- 94  94  94   2   2   6   6   6   6  38  38  38
- 30  30  30   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6  62  62  62  66  66  66
- 26  26  26  10  10  10   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 30  30  30  74  74  74  50  50  50   2   2   6
- 26  26  26  26  26  26   2   2   6 106 106 106
-238 238 238 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 246 246 246 218 218 218 202 202 202
-210 210 210  14  14  14   2   2   6   2   2   6
- 30  30  30  22  22  22   2   2   6   2   2   6
-  2   2   6   2   2   6  18  18  18  86  86  86
- 42  42  42  14  14  14   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 42  42  42  90  90  90  22  22  22   2   2   6
- 42  42  42   2   2   6  18  18  18 218 218 218
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 250 250 250 221 221 221
-218 218 218 101 101 101   2   2   6  14  14  14
- 18  18  18  38  38  38  10  10  10   2   2   6
-  2   2   6   2   2   6   2   2   6  78  78  78
- 58  58  58  22  22  22   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  18  18  18
- 54  54  54  82  82  82   2   2   6  26  26  26
- 22  22  22   2   2   6 123 123 123 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 250 250 250
-238 238 238 198 198 198   6   6   6  38  38  38
- 58  58  58  26  26  26  38  38  38   2   2   6
-  2   2   6   2   2   6   2   2   6  46  46  46
- 78  78  78  30  30  30  10  10  10   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0  10  10  10  30  30  30
- 74  74  74  58  58  58   2   2   6  42  42  42
-  2   2   6  22  22  22 231 231 231 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 250 250 250
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 246 246 246  46  46  46  38  38  38
- 42  42  42  14  14  14  38  38  38  14  14  14
-  2   2   6   2   2   6   2   2   6   6   6   6
- 86  86  86  46  46  46  14  14  14   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6  14  14  14  42  42  42
- 90  90  90  18  18  18  18  18  18  26  26  26
-  2   2   6 116 116 116 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 250 250 250 238 238 238
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253  94  94  94   6   6   6
-  2   2   6   2   2   6  10  10  10  34  34  34
-  2   2   6   2   2   6   2   2   6   2   2   6
- 74  74  74  58  58  58  22  22  22   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0  10  10  10  26  26  26  66  66  66
- 82  82  82   2   2   6  38  38  38   6   6   6
- 14  14  14 210 210 210 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 246 246 246 242 242 242
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 144 144 144   2   2   6
-  2   2   6   2   2   6   2   2   6  46  46  46
-  2   2   6   2   2   6   2   2   6   2   2   6
- 42  42  42  74  74  74  30  30  30  10  10  10
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  14  14  14  42  42  42  90  90  90
- 26  26  26   6   6   6  42  42  42   2   2   6
- 74  74  74 250 250 250 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 242 242 242 242 242 242
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 182 182 182   2   2   6
-  2   2   6   2   2   6   2   2   6  46  46  46
-  2   2   6   2   2   6   2   2   6   2   2   6
- 10  10  10  86  86  86  38  38  38  10  10  10
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
- 10  10  10  26  26  26  66  66  66  82  82  82
-  2   2   6  22  22  22  18  18  18   2   2   6
-149 149 149 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 234 234 234 242 242 242
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 206 206 206   2   2   6
-  2   2   6   2   2   6   2   2   6  38  38  38
-  2   2   6   2   2   6   2   2   6   2   2   6
-  6   6   6  86  86  86  46  46  46  14  14  14
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 18  18  18  46  46  46  86  86  86  18  18  18
-  2   2   6  34  34  34  10  10  10   6   6   6
-210 210 210 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 234 234 234 242 242 242
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 221 221 221   6   6   6
-  2   2   6   2   2   6   6   6   6  30  30  30
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  82  82  82  54  54  54  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 26  26  26  66  66  66  62  62  62   2   2   6
-  2   2   6  38  38  38  10  10  10  26  26  26
-238 238 238 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 238 238 238
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231   6   6   6
-  2   2   6   2   2   6  10  10  10  30  30  30
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  66  66  66  58  58  58  22  22  22
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 38  38  38  78  78  78   6   6   6   2   2   6
-  2   2   6  46  46  46  14  14  14  42  42  42
-246 246 246 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 242 242 242
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 234 234 234  10  10  10
-  2   2   6   2   2   6  22  22  22  14  14  14
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  66  66  66  62  62  62  22  22  22
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  18  18  18
- 50  50  50  74  74  74   2   2   6   2   2   6
- 14  14  14  70  70  70  34  34  34  62  62  62
-250 250 250 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 246 246 246
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 234 234 234  14  14  14
-  2   2   6   2   2   6  30  30  30   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  66  66  66  62  62  62  22  22  22
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  18  18  18
- 54  54  54  62  62  62   2   2   6   2   2   6
-  2   2   6  30  30  30  46  46  46  70  70  70
-250 250 250 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 246 246 246
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 226 226 226  10  10  10
-  2   2   6   6   6   6  30  30  30   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6  66  66  66  58  58  58  22  22  22
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  22  22  22
- 58  58  58  62  62  62   2   2   6   2   2   6
-  2   2   6   2   2   6  30  30  30  78  78  78
-250 250 250 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 246 246 246
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 206 206 206   2   2   6
- 22  22  22  34  34  34  18  14   6  22  22  22
- 26  26  26  18  18  18   6   6   6   2   2   6
-  2   2   6  82  82  82  54  54  54  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  26  26  26
- 62  62  62 106 106 106  74  54  14 185 133  11
-210 162  10 121  92   8   6   6   6  62  62  62
-238 238 238 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 246 246 246
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 158 158 158  18  18  18
- 14  14  14   2   2   6   2   2   6   2   2   6
-  6   6   6  18  18  18  66  66  66  38  38  38
-  6   6   6  94  94  94  50  50  50  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 10  10  10  10  10  10  18  18  18  38  38  38
- 78  78  78 142 134 106 216 158  10 242 186  14
-246 190  14 246 190  14 156 118  10  10  10  10
- 90  90  90 238 238 238 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 250 250 250
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 246 230 190
-238 204  91 238 204  91 181 142  44  37  26   9
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6  38  38  38  46  46  46
- 26  26  26 106 106 106  54  54  54  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6  14  14  14  22  22  22
- 30  30  30  38  38  38  50  50  50  70  70  70
-106 106 106 190 142  34 226 170  11 242 186  14
-246 190  14 246 190  14 246 190  14 154 114  10
-  6   6   6  74  74  74 226 226 226 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 231 231 231 250 250 250
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 228 184  62
-241 196  14 241 208  19 232 195  16  38  30  10
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   6   6   6  30  30  30  26  26  26
-203 166  17 154 142  90  66  66  66  26  26  26
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  18  18  18  38  38  38  58  58  58
- 78  78  78  86  86  86 101 101 101 123 123 123
-175 146  61 210 150  10 234 174  13 246 186  14
-246 190  14 246 190  14 246 190  14 238 190  10
-102  78  10   2   2   6  46  46  46 198 198 198
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 234 234 234 242 242 242
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 224 178  62
-242 186  14 241 196  14 210 166  10  22  18   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   6   6   6 121  92   8
-238 202  15 232 195  16  82  82  82  34  34  34
- 10  10  10   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
- 14  14  14  38  38  38  70  70  70 154 122  46
-190 142  34 200 144  11 197 138  11 197 138  11
-213 154  11 226 170  11 242 186  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-225 175  15  46  32   6   2   2   6  22  22  22
-158 158 158 250 250 250 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 250 250 250 242 242 242 224 178  62
-239 182  13 236 186  11 213 154  11  46  32   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6  61  42   6 225 175  15
-238 190  10 236 186  11 112 100  78  42  42  42
- 14  14  14   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 22  22  22  54  54  54 154 122  46 213 154  11
-226 170  11 230 174  11 226 170  11 226 170  11
-236 178  12 242 186  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-241 196  14 184 144  12  10  10  10   2   2   6
-  6   6   6 116 116 116 242 242 242 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 231 231 231 198 198 198 214 170  54
-236 178  12 236 178  12 210 150  10 137  92   6
- 18  14   6   2   2   6   2   2   6   2   2   6
-  6   6   6  70  47   6 200 144  11 236 178  12
-239 182  13 239 182  13 124 112  88  58  58  58
- 22  22  22   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 30  30  30  70  70  70 180 133  36 226 170  11
-239 182  13 242 186  14 242 186  14 246 186  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 232 195  16  98  70   6   2   2   6
-  2   2   6   2   2   6  66  66  66 221 221 221
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 206 206 206 198 198 198 214 166  58
-230 174  11 230 174  11 216 158  10 192 133   9
-163 110   8 116  81   8 102  78  10 116  81   8
-167 114   7 197 138  11 226 170  11 239 182  13
-242 186  14 242 186  14 162 146  94  78  78  78
- 34  34  34  14  14  14   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 30  30  30  78  78  78 190 142  34 226 170  11
-239 182  13 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 241 196  14 203 166  17  22  18   6
-  2   2   6   2   2   6   2   2   6  38  38  38
-218 218 218 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-250 250 250 206 206 206 198 198 198 202 162  69
-226 170  11 236 178  12 224 166  10 210 150  10
-200 144  11 197 138  11 192 133   9 197 138  11
-210 150  10 226 170  11 242 186  14 246 190  14
-246 190  14 246 186  14 225 175  15 124 112  88
- 62  62  62  30  30  30  14  14  14   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 30  30  30  78  78  78 174 135  50 224 166  10
-239 182  13 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 241 196  14 139 102  15
-  2   2   6   2   2   6   2   2   6   2   2   6
- 78  78  78 250 250 250 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-250 250 250 214 214 214 198 198 198 190 150  46
-219 162  10 236 178  12 234 174  13 224 166  10
-216 158  10 213 154  11 213 154  11 216 158  10
-226 170  11 239 182  13 246 190  14 246 190  14
-246 190  14 246 190  14 242 186  14 206 162  42
-101 101 101  58  58  58  30  30  30  14  14  14
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 30  30  30  74  74  74 174 135  50 216 158  10
-236 178  12 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 241 196  14 226 184  13
- 61  42   6   2   2   6   2   2   6   2   2   6
- 22  22  22 238 238 238 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 226 226 226 187 187 187 180 133  36
-216 158  10 236 178  12 239 182  13 236 178  12
-230 174  11 226 170  11 226 170  11 230 174  11
-236 178  12 242 186  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 186  14 239 182  13
-206 162  42 106 106 106  66  66  66  34  34  34
- 14  14  14   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 26  26  26  70  70  70 163 133  67 213 154  11
-236 178  12 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 241 196  14
-190 146  13  18  14   6   2   2   6   2   2   6
- 46  46  46 246 246 246 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 221 221 221  86  86  86 156 107  11
-216 158  10 236 178  12 242 186  14 246 186  14
-242 186  14 239 182  13 239 182  13 242 186  14
-242 186  14 246 186  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-242 186  14 225 175  15 142 122  72  66  66  66
- 30  30  30  10  10  10   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 26  26  26  70  70  70 163 133  67 210 150  10
-236 178  12 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-232 195  16 121  92   8  34  34  34 106 106 106
-221 221 221 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-242 242 242  82  82  82  18  14   6 163 110   8
-216 158  10 236 178  12 242 186  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 242 186  14 163 133  67
- 46  46  46  18  18  18   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  10  10  10
- 30  30  30  78  78  78 163 133  67 210 150  10
-236 178  12 246 186  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-241 196  14 215 174  15 190 178 144 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 218 218 218
- 58  58  58   2   2   6  22  18   6 167 114   7
-216 158  10 236 178  12 246 186  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 186  14 242 186  14 190 150  46
- 54  54  54  22  22  22   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 38  38  38  86  86  86 180 133  36 213 154  11
-236 178  12 246 186  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 232 195  16 190 146  13 214 214 214
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 250 250 250 170 170 170  26  26  26
-  2   2   6   2   2   6  37  26   9 163 110   8
-219 162  10 239 182  13 246 186  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 186  14 236 178  12 224 166  10 142 122  72
- 46  46  46  18  18  18   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  18  18  18
- 50  50  50 109 106  95 192 133   9 224 166  10
-242 186  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-242 186  14 226 184  13 210 162  10 142 110  46
-226 226 226 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-253 253 253 253 253 253 253 253 253 253 253 253
-198 198 198  66  66  66   2   2   6   2   2   6
-  2   2   6   2   2   6  50  34   6 156 107  11
-219 162  10 239 182  13 246 186  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 242 186  14
-234 174  13 213 154  11 154 122  46  66  66  66
- 30  30  30  10  10  10   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  22  22  22
- 58  58  58 154 121  60 206 145  10 234 174  13
-242 186  14 246 186  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 186  14 236 178  12 210 162  10 163 110   8
- 61  42   6 138 138 138 218 218 218 250 250 250
-253 253 253 253 253 253 253 253 253 250 250 250
-242 242 242 210 210 210 144 144 144  66  66  66
-  6   6   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6  61  42   6 163 110   8
-216 158  10 236 178  12 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 239 182  13 230 174  11 216 158  10
-190 142  34 124 112  88  70  70  70  38  38  38
- 18  18  18   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  22  22  22
- 62  62  62 168 124  44 206 145  10 224 166  10
-236 178  12 239 182  13 242 186  14 242 186  14
-246 186  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 236 178  12 216 158  10 175 118   6
- 80  54   7   2   2   6   6   6   6  30  30  30
- 54  54  54  62  62  62  50  50  50  38  38  38
- 14  14  14   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   6   6   6  80  54   7 167 114   7
-213 154  11 236 178  12 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 190  14 242 186  14 239 182  13 239 182  13
-230 174  11 210 150  10 174 135  50 124 112  88
- 82  82  82  54  54  54  34  34  34  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  18  18  18
- 50  50  50 158 118  36 192 133   9 200 144  11
-216 158  10 219 162  10 224 166  10 226 170  11
-230 174  11 236 178  12 239 182  13 239 182  13
-242 186  14 246 186  14 246 190  14 246 190  14
-246 190  14 246 190  14 246 190  14 246 190  14
-246 186  14 230 174  11 210 150  10 163 110   8
-104  69   6  10  10  10   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   6   6   6  91  60   6 167 114   7
-206 145  10 230 174  11 242 186  14 246 190  14
-246 190  14 246 190  14 246 186  14 242 186  14
-239 182  13 230 174  11 224 166  10 213 154  11
-180 133  36 124 112  88  86  86  86  58  58  58
- 38  38  38  22  22  22  10  10  10   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0  14  14  14
- 34  34  34  70  70  70 138 110  50 158 118  36
-167 114   7 180 123   7 192 133   9 197 138  11
-200 144  11 206 145  10 213 154  11 219 162  10
-224 166  10 230 174  11 239 182  13 242 186  14
-246 186  14 246 186  14 246 186  14 246 186  14
-239 182  13 216 158  10 185 133  11 152  99   6
-104  69   6  18  14   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   2   2   6   2   2   6   2   2   6
-  2   2   6   6   6   6  80  54   7 152  99   6
-192 133   9 219 162  10 236 178  12 239 182  13
-246 186  14 242 186  14 239 182  13 236 178  12
-224 166  10 206 145  10 192 133   9 154 121  60
- 94  94  94  62  62  62  42  42  42  22  22  22
- 14  14  14   6   6   6   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 18  18  18  34  34  34  58  58  58  78  78  78
-101  98  89 124 112  88 142 110  46 156 107  11
-163 110   8 167 114   7 175 118   6 180 123   7
-185 133  11 197 138  11 210 150  10 219 162  10
-226 170  11 236 178  12 236 178  12 234 174  13
-219 162  10 197 138  11 163 110   8 130  83   6
- 91  60   6  10  10  10   2   2   6   2   2   6
- 18  18  18  38  38  38  38  38  38  38  38  38
- 38  38  38  38  38  38  38  38  38  38  38  38
- 38  38  38  38  38  38  26  26  26   2   2   6
-  2   2   6   6   6   6  70  47   6 137  92   6
-175 118   6 200 144  11 219 162  10 230 174  11
-234 174  13 230 174  11 219 162  10 210 150  10
-192 133   9 163 110   8 124 112  88  82  82  82
- 50  50  50  30  30  30  14  14  14   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  14  14  14  22  22  22  34  34  34
- 42  42  42  58  58  58  74  74  74  86  86  86
-101  98  89 122 102  70 130  98  46 121  87  25
-137  92   6 152  99   6 163 110   8 180 123   7
-185 133  11 197 138  11 206 145  10 200 144  11
-180 123   7 156 107  11 130  83   6 104  69   6
- 50  34   6  54  54  54 110 110 110 101  98  89
- 86  86  86  82  82  82  78  78  78  78  78  78
- 78  78  78  78  78  78  78  78  78  78  78  78
- 78  78  78  82  82  82  86  86  86  94  94  94
-106 106 106 101 101 101  86  66  34 124  80   6
-156 107  11 180 123   7 192 133   9 200 144  11
-206 145  10 200 144  11 192 133   9 175 118   6
-139 102  15 109 106  95  70  70  70  42  42  42
- 22  22  22  10  10  10   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   6   6   6  10  10  10
- 14  14  14  22  22  22  30  30  30  38  38  38
- 50  50  50  62  62  62  74  74  74  90  90  90
-101  98  89 112 100  78 121  87  25 124  80   6
-137  92   6 152  99   6 152  99   6 152  99   6
-138  86   6 124  80   6  98  70   6  86  66  30
-101  98  89  82  82  82  58  58  58  46  46  46
- 38  38  38  34  34  34  34  34  34  34  34  34
- 34  34  34  34  34  34  34  34  34  34  34  34
- 34  34  34  34  34  34  38  38  38  42  42  42
- 54  54  54  82  82  82  94  86  76  91  60   6
-134  86   6 156 107  11 167 114   7 175 118   6
-175 118   6 167 114   7 152  99   6 121  87  25
-101  98  89  62  62  62  34  34  34  18  18  18
-  6   6   6   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6   6   6   6  10  10  10
- 18  18  18  22  22  22  30  30  30  42  42  42
- 50  50  50  66  66  66  86  86  86 101  98  89
-106  86  58  98  70   6 104  69   6 104  69   6
-104  69   6  91  60   6  82  62  34  90  90  90
- 62  62  62  38  38  38  22  22  22  14  14  14
- 10  10  10  10  10  10  10  10  10  10  10  10
- 10  10  10  10  10  10   6   6   6  10  10  10
- 10  10  10  10  10  10  10  10  10  14  14  14
- 22  22  22  42  42  42  70  70  70  89  81  66
- 80  54   7 104  69   6 124  80   6 137  92   6
-134  86   6 116  81   8 100  82  52  86  86  86
- 58  58  58  30  30  30  14  14  14   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6  10  10  10  14  14  14
- 18  18  18  26  26  26  38  38  38  54  54  54
- 70  70  70  86  86  86  94  86  76  89  81  66
- 89  81  66  86  86  86  74  74  74  50  50  50
- 30  30  30  14  14  14   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6  18  18  18  34  34  34  58  58  58
- 82  82  82  89  81  66  89  81  66  89  81  66
- 94  86  66  94  86  76  74  74  74  50  50  50
- 26  26  26  14  14  14   6   6   6   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  6   6   6   6   6   6  14  14  14  18  18  18
- 30  30  30  38  38  38  46  46  46  54  54  54
- 50  50  50  42  42  42  30  30  30  18  18  18
- 10  10  10   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   6   6   6  14  14  14  26  26  26
- 38  38  38  50  50  50  58  58  58  58  58  58
- 54  54  54  42  42  42  30  30  30  18  18  18
- 10  10  10   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
-  6   6   6  10  10  10  14  14  14  18  18  18
- 18  18  18  14  14  14  10  10  10   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   6   6   6
- 14  14  14  18  18  18  22  22  22  22  22  22
- 18  18  18  14  14  14  10  10  10   6   6   6
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
-  0   0   0   0   0   0   0   0   0   0   0   0
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  3 3 3  0 0 0  0 0 0
+0 0 0  0 0 0  0 0 0  0 0 0  3 3 3  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  1 1 1  0 0 0
+0 0 0  3 3 3  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  2 1 0  2 1 0  3 2 2
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  2 2 2  0 0 0  3 4 3  26 28 28
+37 38 37  37 38 37  14 17 19  2 2 2  0 0 0  2 2 2
+5 5 5  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  3 3 3  0 0 0  1 1 1  6 6 6
+2 2 2  0 0 0  3 3 3  4 4 4  4 4 4  4 4 4
+4 4 5  3 3 3  1 0 0  0 0 0  1 0 0  0 0 0
+1 1 1  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+2 2 2  0 0 0  0 0 0  14 17 19  60 74 84  137 136 137
+153 152 153  137 136 137  125 124 125  60 73 81  6 6 6  3 1 0
+0 0 0  3 3 3  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  0 0 0  4 4 4  41 54 63  125 124 125
+60 73 81  6 6 6  4 0 0  3 3 3  4 4 4  4 4 4
+4 4 4  0 0 0  6 9 11  41 54 63  41 65 82  22 30 35
+2 2 2  2 1 0  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  5 5 5  5 5 5  2 2 2  0 0 0
+4 0 0  6 6 6  41 54 63  137 136 137  174 174 174  167 166 167
+165 164 165  165 164 165  163 162 163  163 162 163  125 124 125  41 54 63
+1 1 1  0 0 0  0 0 0  3 3 3  5 5 5  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  5 5 5  5 5 5
+3 3 3  2 0 0  4 0 0  60 73 81  156 155 156  167 166 167
+163 162 163  85 115 134  5 7 8  0 0 0  4 4 4  5 5 5
+0 0 0  2 5 5  55 98 126  90 154 193  90 154 193  72 125 159
+37 51 59  2 0 0  1 1 1  4 5 5  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  4 4 4  1 1 1  0 0 0  3 3 3
+37 38 37  125 124 125  163 162 163  174 174 174  158 157 158  158 157 158
+156 155 156  156 155 156  158 157 158  165 164 165  174 174 174  166 165 166
+125 124 125  16 19 21  1 0 0  0 0 0  0 0 0  4 4 4
+5 5 5  5 5 5  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  5 5 5  5 5 5  1 1 1
+0 0 0  0 0 0  37 38 37  153 152 153  174 174 174  158 157 158
+174 174 174  163 162 163  37 38 37  4 3 3  4 0 0  1 1 1
+0 0 0  22 40 52  101 161 196  101 161 196  90 154 193  101 161 196
+64 123 161  14 17 19  0 0 0  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  5 5 5
+5 5 5  2 2 2  0 0 0  4 0 0  24 26 27  85 115 134
+156 155 156  174 174 174  167 166 167  156 155 156  154 153 154  157 156 157
+156 155 156  156 155 156  155 154 155  153 152 153  158 157 158  167 166 167
+174 174 174  156 155 156  60 74 84  16 19 21  0 0 0  0 0 0
+1 1 1  5 5 5  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  6 6 6  3 3 3  0 0 0  4 0 0
+13 16 17  60 73 81  137 136 137  165 164 165  156 155 156  153 152 153
+174 174 174  177 184 187  60 73 81  3 1 0  0 0 0  1 1 2
+22 30 35  64 123 161  136 185 209  90 154 193  90 154 193  90 154 193
+90 154 193  21 29 34  0 0 0  3 2 2  4 4 5  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  5 5 5  3 3 3
+0 0 0  0 0 0  10 13 16  60 74 84  157 156 157  174 174 174
+174 174 174  158 157 158  153 152 153  154 153 154  156 155 156  155 154 155
+156 155 156  155 154 155  154 153 154  157 156 157  154 153 154  153 152 153
+163 162 163  174 174 174  177 184 187  137 136 137  60 73 81  13 16 17
+4 0 0  0 0 0  3 3 3  5 5 5  4 4 4  4 4 4
+5 5 5  4 4 4  1 1 1  0 0 0  3 3 3  41 54 63
+131 129 131  174 174 174  174 174 174  174 174 174  167 166 167  174 174 174
+190 197 201  137 136 137  24 26 27  4 0 0  16 21 25  50 82 103
+90 154 193  136 185 209  90 154 193  101 161 196  101 161 196  101 161 196
+31 91 132  3 6 7  0 0 0  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  2 2 2  0 0 0  4 0 0
+4 0 0  43 57 68  137 136 137  177 184 187  174 174 174  163 162 163
+155 154 155  155 154 155  156 155 156  155 154 155  158 157 158  165 164 165
+167 166 167  166 165 166  163 162 163  157 156 157  155 154 155  155 154 155
+153 152 153  156 155 156  167 166 167  174 174 174  174 174 174  131 129 131
+41 54 63  5 5 5  0 0 0  0 0 0  3 3 3  4 4 4
+1 1 1  0 0 0  1 0 0  26 28 28  125 124 125  174 174 174
+177 184 187  174 174 174  174 174 174  156 155 156  131 129 131  137 136 137
+125 124 125  24 26 27  4 0 0  41 65 82  90 154 193  136 185 209
+136 185 209  101 161 196  53 118 160  37 112 160  90 154 193  34 86 122
+7 12 15  0 0 0  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  3 3 3  0 0 0  0 0 0  5 5 5  37 38 37
+125 124 125  167 166 167  174 174 174  167 166 167  158 157 158  155 154 155
+156 155 156  156 155 156  156 155 156  163 162 163  167 166 167  155 154 155
+137 136 137  153 152 153  156 155 156  165 164 165  163 162 163  156 155 156
+156 155 156  156 155 156  155 154 155  158 157 158  166 165 166  174 174 174
+167 166 167  125 124 125  37 38 37  1 0 0  0 0 0  0 0 0
+0 0 0  24 26 27  60 74 84  158 157 158  174 174 174  174 174 174
+166 165 166  158 157 158  125 124 125  41 54 63  13 16 17  6 6 6
+6 6 6  37 38 37  80 127 157  136 185 209  101 161 196  101 161 196
+90 154 193  28 67 93  6 10 14  13 20 25  13 20 25  6 10 14
+1 1 2  4 3 3  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+1 1 1  1 0 0  4 3 3  37 38 37  60 74 84  153 152 153
+167 166 167  167 166 167  158 157 158  154 153 154  155 154 155  156 155 156
+157 156 157  158 157 158  167 166 167  167 166 167  131 129 131  43 57 68
+26 28 28  37 38 37  60 73 81  131 129 131  165 164 165  166 165 166
+158 157 158  155 154 155  156 155 156  156 155 156  156 155 156  158 157 158
+165 164 165  174 174 174  163 162 163  60 74 84  16 19 21  13 16 17
+60 73 81  131 129 131  174 174 174  174 174 174  167 166 167  165 164 165
+137 136 137  60 73 81  24 26 27  4 0 0  4 0 0  16 19 21
+52 104 138  101 161 196  136 185 209  136 185 209  90 154 193  27 99 146
+13 20 25  4 5 7  2 5 5  4 5 7  1 1 2  0 0 0
+4 4 4  4 4 4  3 3 3  2 2 2  2 2 2  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  3 3 3  0 0 0
+0 0 0  13 16 17  60 73 81  137 136 137  174 174 174  166 165 166
+158 157 158  156 155 156  157 156 157  156 155 156  155 154 155  158 157 158
+167 166 167  174 174 174  153 152 153  60 73 81  16 19 21  4 0 0
+4 0 0  4 0 0  6 6 6  26 28 28  60 74 84  158 157 158
+174 174 174  166 165 166  157 156 157  155 154 155  156 155 156  156 155 156
+155 154 155  158 157 158  167 166 167  167 166 167  131 129 131  125 124 125
+137 136 137  167 166 167  167 166 167  174 174 174  158 157 158  125 124 125
+16 19 21  4 0 0  4 0 0  10 13 16  49 76 92  107 159 188
+136 185 209  136 185 209  90 154 193  26 108 161  22 40 52  6 10 14
+2 3 3  1 1 2  1 1 2  4 4 5  4 4 5  4 4 5
+4 4 5  2 2 1  0 0 0  0 0 0  0 0 0  2 2 2
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  3 3 3  0 0 0  1 0 0  4 0 0
+37 51 59  131 129 131  167 166 167  167 166 167  163 162 163  157 156 157
+157 156 157  155 154 155  153 152 153  157 156 157  167 166 167  174 174 174
+153 152 153  125 124 125  37 38 37  4 0 0  4 0 0  4 0 0
+4 3 3  4 3 3  4 0 0  6 6 6  4 0 0  37 38 37
+125 124 125  174 174 174  174 174 174  165 164 165  156 155 156  154 153 154
+156 155 156  156 155 156  155 154 155  163 162 163  158 157 158  163 162 163
+174 174 174  174 174 174  174 174 174  125 124 125  37 38 37  0 0 0
+4 0 0  6 9 11  41 54 63  90 154 193  136 185 209  146 190 211
+136 185 209  37 112 160  22 40 52  6 10 14  3 6 7  1 1 2
+1 1 2  3 3 3  1 1 2  3 3 3  4 4 4  4 4 4
+2 2 2  2 0 0  16 19 21  37 38 37  24 26 27  0 0 0
+0 0 0  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  5 5 5  5 5 5
+4 4 4  0 0 0  0 0 0  0 0 0  26 28 28  120 125 127
+158 157 158  174 174 174  165 164 165  157 156 157  155 154 155  156 155 156
+153 152 153  153 152 153  167 166 167  174 174 174  174 174 174  125 124 125
+37 38 37  4 0 0  0 0 0  4 0 0  4 3 3  4 4 4
+4 4 4  4 4 4  5 5 5  4 0 0  4 0 0  4 0 0
+4 3 3  43 57 68  137 136 137  174 174 174  174 174 174  165 164 165
+154 153 154  153 152 153  153 152 153  153 152 153  163 162 163  174 174 174
+174 174 174  153 152 153  60 73 81  6 6 6  4 0 0  4 3 3
+32 43 50  80 127 157  136 185 209  146 190 211  146 190 211  90 154 193
+28 67 93  28 67 93  40 71 93  3 6 7  1 1 2  2 5 5
+50 82 103  79 117 143  26 37 45  0 0 0  3 3 3  1 1 1
+0 0 0  41 54 63  137 136 137  174 174 174  153 152 153  60 73 81
+2 0 0  0 0 0
+4 4 4  4 4 4  4 4 4  4 4 4  6 6 6  2 2 2
+0 0 0  2 0 0  24 26 27  60 74 84  153 152 153  174 174 174
+174 174 174  157 156 157  154 153 154  156 155 156  154 153 154  153 152 153
+165 164 165  174 174 174  177 184 187  137 136 137  43 57 68  6 6 6
+4 0 0  2 0 0  3 3 3  5 5 5  5 5 5  4 4 4
+4 4 4  4 4 4  4 4 4  5 5 5  6 6 6  4 3 3
+4 0 0  4 0 0  24 26 27  60 73 81  153 152 153  174 174 174
+174 174 174  158 157 158  158 157 158  174 174 174  174 174 174  158 157 158
+60 74 84  24 26 27  4 0 0  4 0 0  17 23 27  59 113 148
+136 185 209  191 222 234  146 190 211  136 185 209  31 91 132  7 11 13
+22 40 52  101 161 196  90 154 193  6 9 11  3 4 4  43 95 132
+136 185 209  172 205 220  55 98 126  0 0 0  0 0 0  2 0 0
+26 28 28  153 152 153  177 184 187  167 166 167  177 184 187  165 164 165
+37 38 37  0 0 0
+4 4 4  4 4 4  5 5 5  5 5 5  1 1 1  0 0 0
+13 16 17  60 73 81  137 136 137  174 174 174  174 174 174  165 164 165
+153 152 153  153 152 153  155 154 155  154 153 154  158 157 158  174 174 174
+177 184 187  163 162 163  60 73 81  16 19 21  4 0 0  4 0 0
+4 3 3  4 4 4  5 5 5  5 5 5  4 4 4  5 5 5
+5 5 5  5 5 5  5 5 5  4 4 4  4 4 4  5 5 5
+6 6 6  4 0 0  4 0 0  4 0 0  24 26 27  60 74 84
+166 165 166  174 174 174  177 184 187  165 164 165  125 124 125  24 26 27
+4 0 0  4 0 0  5 5 5  50 82 103  136 185 209  172 205 220
+146 190 211  136 185 209  26 108 161  22 40 52  7 12 15  44 81 103
+71 116 144  28 67 93  37 51 59  41 65 82  100 139 164  101 161 196
+90 154 193  90 154 193  28 67 93  0 0 0  0 0 0  26 28 28
+125 124 125  167 166 167  163 162 163  153 152 153  163 162 163  174 174 174
+85 115 134  4 0 0
+4 4 4  5 5 5  4 4 4  1 0 0  4 0 0  34 47 55
+125 124 125  174 174 174  174 174 174  167 166 167  157 156 157  153 152 153
+155 154 155  155 154 155  158 157 158  166 165 166  167 166 167  154 153 154
+125 124 125  26 28 28  4 0 0  4 0 0  4 0 0  5 5 5
+5 5 5  4 4 4  4 4 4  4 4 4  4 4 4  1 1 1
+0 0 0  0 0 0  1 1 1  4 4 4  4 4 4  4 4 4
+5 5 5  5 5 5  4 3 3  4 0 0  4 0 0  6 6 6
+37 38 37  131 129 131  137 136 137  37 38 37  0 0 0  4 0 0
+4 5 5  43 61 72  90 154 193  172 205 220  146 190 211  136 185 209
+90 154 193  28 67 93  13 20 25  43 61 72  71 116 144  44 81 103
+2 5 5  7 11 13  59 113 148  101 161 196  90 154 193  28 67 93
+13 20 25  6 10 14  0 0 0  13 16 17  60 73 81  137 136 137
+166 165 166  158 157 158  156 155 156  154 153 154  167 166 167  174 174 174
+60 73 81  4 0 0
+4 4 4  4 4 4  0 0 0  3 3 3  60 74 84  174 174 174
+174 174 174  167 166 167  163 162 163  155 154 155  157 156 157  155 154 155
+156 155 156  163 162 163  167 166 167  158 157 158  125 124 125  37 38 37
+4 3 3  4 0 0  4 0 0  6 6 6  6 6 6  5 5 5
+4 4 4  4 4 4  4 4 4  1 1 1  0 0 0  2 3 3
+10 13 16  7 11 13  1 0 0  0 0 0  2 2 1  4 4 4
+4 4 4  4 4 4  4 4 4  5 5 5  4 3 3  4 0 0
+4 0 0  7 11 13  13 16 17  4 0 0  3 3 3  34 47 55
+80 127 157  146 190 211  172 205 220  136 185 209  136 185 209  136 185 209
+28 67 93  22 40 52  55 98 126  55 98 126  21 29 34  7 11 13
+50 82 103  101 161 196  101 161 196  35 83 115  13 20 25  2 2 1
+1 1 2  1 1 2  37 51 59  131 129 131  174 174 174  174 174 174
+167 166 167  163 162 163  163 162 163  167 166 167  174 174 174  125 124 125
+16 19 21  4 0 0
+4 4 4  4 0 0  4 0 0  60 74 84  174 174 174  174 174 174
+158 157 158  155 154 155  155 154 155  156 155 156  155 154 155  158 157 158
+167 166 167  165 164 165  131 129 131  60 73 81  13 16 17  4 0 0
+4 0 0  4 3 3  6 6 6  4 3 3  5 5 5  4 4 4
+4 4 4  3 2 2  0 0 0  0 0 0  7 11 13  45 69 86
+80 127 157  71 116 144  43 61 72  7 11 13  0 0 0  1 1 1
+4 3 3  4 4 4  4 4 4  4 4 4  6 6 6  5 5 5
+3 2 2  4 0 0  1 0 0  21 29 34  59 113 148  136 185 209
+146 190 211  136 185 209  136 185 209  136 185 209  136 185 209  136 185 209
+68 124 159  44 81 103  22 40 52  13 16 17  43 61 72  90 154 193
+136 185 209  59 113 148  21 29 34  3 4 3  1 1 1  0 0 0
+24 26 27  125 124 125  163 162 163  174 174 174  166 165 166  165 164 165
+163 162 163  125 124 125  125 124 125  125 124 125  125 124 125  26 28 28
+4 0 0  4 3 3
+3 3 3  0 0 0  24 26 27  153 152 153  177 184 187  158 157 158
+156 155 156  156 155 156  155 154 155  155 154 155  165 164 165  174 174 174
+155 154 155  60 74 84  26 28 28  4 0 0  4 0 0  3 1 0
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 3 3
+2 0 0  0 0 0  0 0 0  32 43 50  72 125 159  101 161 196
+136 185 209  101 161 196  101 161 196  79 117 143  32 43 50  0 0 0
+0 0 0  2 2 2  4 4 4  4 4 4  3 3 3  1 0 0
+0 0 0  4 5 5  49 76 92  101 161 196  146 190 211  146 190 211
+136 185 209  136 185 209  136 185 209  136 185 209  136 185 209  90 154 193
+28 67 93  13 16 17  37 51 59  80 127 157  136 185 209  90 154 193
+22 40 52  6 9 11  3 4 3  2 2 1  16 19 21  60 73 81
+137 136 137  163 162 163  158 157 158  166 165 166  167 166 167  153 152 153
+60 74 84  37 38 37  6 6 6  13 16 17  4 0 0  1 0 0
+3 2 2  4 4 4
+3 2 2  4 0 0  37 38 37  137 136 137  167 166 167  158 157 158
+157 156 157  154 153 154  157 156 157  167 166 167  174 174 174  125 124 125
+37 38 37  4 0 0  4 0 0  4 0 0  4 3 3  4 4 4
+4 4 4  4 4 4  5 5 5  5 5 5  1 1 1  0 0 0
+0 0 0  16 21 25  55 98 126  90 154 193  136 185 209  101 161 196
+101 161 196  101 161 196  136 185 209  136 185 209  101 161 196  55 98 126
+14 17 19  0 0 0  0 0 0  0 0 0  0 0 0  0 0 0
+22 40 52  90 154 193  146 190 211  146 190 211  136 185 209  136 185 209
+136 185 209  136 185 209  136 185 209  101 161 196  35 83 115  7 11 13
+17 23 27  59 113 148  136 185 209  101 161 196  34 86 122  7 12 15
+2 5 5  3 4 3  6 6 6  60 73 81  131 129 131  163 162 163
+166 165 166  174 174 174  174 174 174  163 162 163  125 124 125  41 54 63
+13 16 17  4 0 0  4 0 0  4 0 0  1 0 0  2 2 2
+4 4 4  4 4 4
+1 1 1  2 1 0  43 57 68  137 136 137  153 152 153  153 152 153
+163 162 163  156 155 156  165 164 165  167 166 167  60 74 84  6 6 6
+4 0 0  4 0 0  5 5 5  4 4 4  4 4 4  4 4 4
+4 5 5  6 6 6  4 3 3  0 0 0  0 0 0  11 15 18
+40 71 93  100 139 164  101 161 196  101 161 196  101 161 196  101 161 196
+101 161 196  101 161 196  101 161 196  101 161 196  136 185 209  136 185 209
+101 161 196  45 69 86  6 6 6  0 0 0  17 23 27  55 98 126
+136 185 209  146 190 211  136 185 209  136 185 209  136 185 209  136 185 209
+136 185 209  136 185 209  90 154 193  22 40 52  7 11 13  50 82 103
+136 185 209  136 185 209  53 118 160  22 40 52  7 11 13  2 5 5
+3 4 3  37 38 37  125 124 125  157 156 157  166 165 166  167 166 167
+174 174 174  174 174 174  137 136 137  60 73 81  4 0 0  4 0 0
+4 0 0  4 0 0  5 5 5  3 3 3  3 3 3  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  41 54 63  137 136 137  125 124 125  131 129 131
+155 154 155  167 166 167  174 174 174  60 74 84  6 6 6  4 0 0
+4 3 3  6 6 6  4 4 4  4 4 4  4 4 4  5 5 5
+4 4 4  1 1 1  0 0 0  3 6 7  41 65 82  72 125 159
+101 161 196  101 161 196  101 161 196  90 154 193  90 154 193  101 161 196
+101 161 196  101 161 196  101 161 196  101 161 196  101 161 196  136 185 209
+136 185 209  136 185 209  80 127 157  55 98 126  101 161 196  146 190 211
+136 185 209  136 185 209  136 185 209  101 161 196  136 185 209  101 161 196
+136 185 209  101 161 196  35 83 115  22 30 35  101 161 196  172 205 220
+90 154 193  28 67 93  7 11 13  2 5 5  3 4 3  13 16 17
+85 115 134  167 166 167  174 174 174  174 174 174  174 174 174  174 174 174
+167 166 167  60 74 84  13 16 17  4 0 0  4 0 0  4 3 3
+6 6 6  5 5 5  4 4 4  5 5 5  4 4 4  5 5 5
+5 5 5  5 5 5
+1 1 1  4 0 0  41 54 63  137 136 137  137 136 137  125 124 125
+131 129 131  167 166 167  157 156 157  37 38 37  6 6 6  4 0 0
+6 6 6  5 5 5  4 4 4  4 4 4  4 5 5  2 2 1
+0 0 0  0 0 0  26 37 45  58 111 146  101 161 196  101 161 196
+101 161 196  90 154 193  90 154 193  90 154 193  101 161 196  101 161 196
+101 161 196  101 161 196  101 161 196  101 161 196  101 161 196  101 161 196
+101 161 196  136 185 209  136 185 209  136 185 209  146 190 211  136 185 209
+136 185 209  101 161 196  136 185 209  136 185 209  101 161 196  136 185 209
+101 161 196  136 185 209  136 185 209  136 185 209  136 185 209  16 89 141
+7 11 13  2 5 5  2 5 5  13 16 17  60 73 81  154 154 154
+174 174 174  174 174 174  174 174 174  174 174 174  163 162 163  125 124 125
+24 26 27  4 0 0  4 0 0  4 0 0  5 5 5  5 5 5
+4 4 4  4 4 4  4 4 4  5 5 5  5 5 5  5 5 5
+5 5 5  4 4 4
+4 0 0  6 6 6  37 38 37  137 136 137  137 136 137  131 129 131
+131 129 131  153 152 153  131 129 131  26 28 28  4 0 0  4 3 3
+6 6 6  4 4 4  4 4 4  4 4 4  0 0 0  0 0 0
+13 20 25  51 88 114  90 154 193  101 161 196  101 161 196  90 154 193
+90 154 193  90 154 193  90 154 193  90 154 193  90 154 193  101 161 196
+101 161 196  101 161 196  101 161 196  101 161 196  136 185 209  101 161 196
+101 161 196  136 185 209  101 161 196  136 185 209  136 185 209  101 161 196
+136 185 209  101 161 196  136 185 209  101 161 196  101 161 196  101 161 196
+136 185 209  136 185 209  136 185 209  37 112 160  21 29 34  5 7 8
+2 5 5  13 16 17  43 57 68  131 129 131  174 174 174  174 174 174
+174 174 174  167 166 167  157 156 157  125 124 125  37 38 37  4 0 0
+4 0 0  4 0 0  5 5 5  5 5 5  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+1 1 1  4 0 0  41 54 63  153 152 153  137 136 137  137 136 137
+137 136 137  153 152 153  125 124 125  24 26 27  4 0 0  3 2 2
+4 4 4  4 4 4  4 3 3  4 0 0  3 6 7  43 61 72
+64 123 161  101 161 196  90 154 193  90 154 193  90 154 193  90 154 193
+90 154 193  90 154 193  90 154 193  90 154 193  101 161 196  90 154 193
+101 161 196  101 161 196  101 161 196  101 161 196  101 161 196  101 161 196
+101 161 196  101 161 196  101 161 196  101 161 196  101 161 196  101 161 196
+136 185 209  101 161 196  101 161 196  136 185 209  136 185 209  101 161 196
+101 161 196  90 154 193  28 67 93  13 16 17  7 11 13  3 6 7
+37 51 59  125 124 125  163 162 163  174 174 174  167 166 167  166 165 166
+167 166 167  131 129 131  60 73 81  4 0 0  4 0 0  4 0 0
+3 3 3  5 5 5  6 6 6  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  41 54 63  137 136 137  153 152 153  137 136 137
+153 152 153  157 156 157  125 124 125  24 26 27  0 0 0  2 2 2
+4 4 4  4 4 4  2 0 0  0 0 0  28 67 93  90 154 193
+90 154 193  90 154 193  90 154 193  90 154 193  64 123 161  90 154 193
+90 154 193  90 154 193  90 154 193  90 154 193  90 154 193  101 161 196
+90 154 193  101 161 196  101 161 196  101 161 196  90 154 193  136 185 209
+101 161 196  101 161 196  136 185 209  101 161 196  136 185 209  101 161 196
+101 161 196  101 161 196  136 185 209  101 161 196  101 161 196  90 154 193
+35 83 115  13 16 17  3 6 7  2 5 5  13 16 17  60 74 84
+154 154 154  166 165 166  165 164 165  158 157 158  163 162 163  157 156 157
+60 74 84  13 16 17  4 0 0  4 0 0  3 2 2  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+1 1 1  4 0 0  41 54 63  157 156 157  155 154 155  137 136 137
+153 152 153  158 157 158  137 136 137  26 28 28  2 0 0  2 2 2
+4 4 4  4 4 4  1 0 0  6 10 14  34 86 122  90 154 193
+64 123 161  90 154 193  64 123 161  90 154 193  90 154 193  90 154 193
+64 123 161  90 154 193  90 154 193  90 154 193  90 154 193  90 154 193
+101 161 196  101 161 196  101 161 196  101 161 196  101 161 196  101 161 196
+101 161 196  101 161 196  101 161 196  101 161 196  101 161 196  101 161 196
+136 185 209  101 161 196  136 185 209  90 154 193  26 108 161  22 40 52
+13 16 17  5 7 8  2 5 5  2 5 5  37 38 37  165 164 165
+174 174 174  163 162 163  154 154 154  165 164 165  167 166 167  60 73 81
+6 6 6  4 0 0  4 0 0  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  6 6 6  41 54 63  156 155 156  158 157 158  153 152 153
+156 155 156  165 164 165  137 136 137  26 28 28  0 0 0  2 2 2
+4 4 5  4 4 4  2 0 0  7 12 15  31 96 139  64 123 161
+90 154 193  64 123 161  90 154 193  90 154 193  64 123 161  90 154 193
+90 154 193  90 154 193  90 154 193  90 154 193  90 154 193  90 154 193
+90 154 193  90 154 193  90 154 193  101 161 196  101 161 196  101 161 196
+101 161 196  101 161 196  101 161 196  101 161 196  101 161 196  136 185 209
+101 161 196  136 185 209  26 108 161  22 40 52  7 11 13  5 7 8
+2 5 5  2 5 5  2 5 5  2 2 1  37 38 37  158 157 158
+174 174 174  154 154 154  156 155 156  167 166 167  165 164 165  37 38 37
+4 0 0  4 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+3 1 0  4 0 0  60 73 81  157 156 157  163 162 163  153 152 153
+158 157 158  167 166 167  137 136 137  26 28 28  2 0 0  2 2 2
+4 5 5  4 4 4  4 0 0  7 12 15  24 86 132  26 108 161
+37 112 160  64 123 161  90 154 193  64 123 161  90 154 193  90 154 193
+90 154 193  90 154 193  90 154 193  90 154 193  90 154 193  90 154 193
+90 154 193  101 161 196  90 154 193  101 161 196  101 161 196  101 161 196
+101 161 196  101 161 196  101 161 196  136 185 209  101 161 196  136 185 209
+90 154 193  35 83 115  13 16 17  13 16 17  7 11 13  3 6 7
+5 7 8  6 6 6  3 4 3  2 2 1  30 32 34  154 154 154
+167 166 167  154 154 154  154 154 154  174 174 174  165 164 165  37 38 37
+6 6 6  4 0 0  6 6 6  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  41 54 63  163 162 163  166 165 166  154 154 154
+163 162 163  174 174 174  137 136 137  26 28 28  0 0 0  2 2 2
+4 5 5  4 4 5  1 1 2  6 10 14  28 67 93  18 97 151
+18 97 151  18 97 151  26 108 161  37 112 160  37 112 160  90 154 193
+64 123 161  90 154 193  90 154 193  90 154 193  90 154 193  101 161 196
+90 154 193  101 161 196  101 161 196  90 154 193  101 161 196  101 161 196
+101 161 196  101 161 196  101 161 196  136 185 209  90 154 193  16 89 141
+13 20 25  7 11 13  5 7 8  5 7 8  2 5 5  4 5 5
+3 4 3  4 5 5  3 4 3  0 0 0  37 38 37  158 157 158
+174 174 174  158 157 158  158 157 158  167 166 167  174 174 174  41 54 63
+4 0 0  3 2 2  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+1 1 1  4 0 0  60 73 81  165 164 165  174 174 174  158 157 158
+167 166 167  174 174 174  153 152 153  26 28 28  2 0 0  2 2 2
+4 5 5  4 4 4  4 0 0  7 12 15  10 87 144  10 87 144
+18 97 151  18 97 151  18 97 151  26 108 161  26 108 161  26 108 161
+26 108 161  37 112 160  53 118 160  90 154 193  90 154 193  90 154 193
+90 154 193  90 154 193  101 161 196  101 161 196  101 161 196  101 161 196
+101 161 196  136 185 209  90 154 193  26 108 161  22 40 52  13 16 17
+7 11 13  3 6 7  5 7 8  5 7 8  2 5 5  4 5 5
+4 5 5  6 6 6  3 4 3  0 0 0  30 32 34  158 157 158
+174 174 174  156 155 156  155 154 155  165 164 165  154 153 154  37 38 37
+4 0 0  4 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  60 73 81  167 166 167  174 174 174  163 162 163
+174 174 174  174 174 174  153 152 153  26 28 28  0 0 0  3 3 3
+5 5 5  4 4 4  1 1 2  7 12 15  28 67 93  18 97 151
+18 97 151  18 97 151  18 97 151  18 97 151  18 97 151  26 108 161
+26 108 161  26 108 161  26 108 161  26 108 161  26 108 161  26 108 161
+90 154 193  26 108 161  90 154 193  90 154 193  90 154 193  101 161 196
+101 161 196  26 108 161  22 40 52  13 16 17  7 11 13  2 5 5
+2 5 5  6 6 6  2 5 5  4 5 5  4 5 5  4 5 5
+3 4 3  5 5 5  3 4 3  2 0 0  30 32 34  137 136 137
+153 152 153  137 136 137  131 129 131  137 136 137  131 129 131  37 38 37
+4 0 0  4 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+1 1 1  4 0 0  60 73 81  167 166 167  174 174 174  166 165 166
+174 174 174  177 184 187  153 152 153  30 32 34  1 0 0  3 3 3
+5 5 5  4 3 3  4 0 0  7 12 15  10 87 144  10 87 144
+18 97 151  18 97 151  18 97 151  26 108 161  26 108 161  26 108 161
+26 108 161  26 108 161  26 108 161  26 108 161  26 108 161  26 108 161
+26 108 161  26 108 161  26 108 161  90 154 193  90 154 193  26 108 161
+35 83 115  13 16 17  7 11 13  5 7 8  3 6 7  5 7 8
+2 5 5  6 6 6  4 5 5  4 5 5  3 4 3  4 5 5
+3 4 3  6 6 6  3 4 3  0 0 0  26 28 28  125 124 125
+131 129 131  125 124 125  125 124 125  131 129 131  131 129 131  37 38 37
+4 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+3 1 0  4 0 0  60 73 81  174 174 174  177 184 187  167 166 167
+174 174 174  177 184 187  153 152 153  30 32 34  0 0 0  3 3 3
+5 5 5  4 4 4  1 1 2  6 10 14  28 67 93  18 97 151
+18 97 151  18 97 151  18 97 151  18 97 151  18 97 151  26 108 161
+26 108 161  26 108 161  26 108 161  26 108 161  26 108 161  26 108 161
+26 108 161  90 154 193  26 108 161  26 108 161  24 86 132  13 20 25
+7 11 13  13 20 25  22 40 52  5 7 8  3 4 3  3 4 3
+4 5 5  3 4 3  4 5 5  3 4 3  4 5 5  3 4 3
+4 4 4  5 5 5  3 3 3  2 0 0  26 28 28  125 124 125
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+1 1 1  4 0 0  60 73 81  174 174 174  177 184 187  174 174 174
+174 174 174  190 197 201  157 156 157  30 32 34  1 0 0  3 3 3
+5 5 5  4 3 3  4 0 0  7 12 15  10 87 144  10 87 144
+18 97 151  19 95 150  19 95 150  18 97 151  18 97 151  26 108 161
+18 97 151  26 108 161  26 108 161  26 108 161  26 108 161  90 154 193
+26 108 161  26 108 161  26 108 161  22 40 52  2 5 5  3 4 3
+28 67 93  37 112 160  34 86 122  2 5 5  3 4 3  3 4 3
+3 4 3  3 4 3  3 4 3  2 2 1  3 4 3  4 4 4
+4 5 5  5 5 5  3 3 3  0 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  60 73 81  174 174 174  177 184 187  174 174 174
+174 174 174  190 197 201  158 157 158  30 32 34  0 0 0  2 2 2
+5 5 5  4 4 4  1 1 2  6 10 14  28 67 93  18 97 151
+10 87 144  19 95 150  19 95 150  18 97 151  18 97 151  18 97 151
+26 108 161  26 108 161  26 108 161  26 108 161  26 108 161  26 108 161
+18 97 151  22 40 52  2 5 5  2 2 1  22 40 52  26 108 161
+90 154 193  37 112 160  22 40 52  3 4 3  13 20 25  22 30 35
+3 6 7  1 1 1  2 2 2  6 9 11  5 5 5  4 3 3
+4 4 4  5 5 5  3 3 3  2 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+1 1 1  4 0 0  60 73 81  177 184 187  193 200 203  174 174 174
+177 184 187  193 200 203  163 162 163  30 32 34  4 0 0  2 2 2
+5 5 5  4 3 3  4 0 0  6 10 14  24 86 132  10 87 144
+10 87 144  10 87 144  19 95 150  19 95 150  19 95 150  18 97 151
+26 108 161  26 108 161  26 108 161  90 154 193  26 108 161  28 67 93
+6 10 14  2 5 5  13 20 25  24 86 132  37 112 160  90 154 193
+10 87 144  7 12 15  2 5 5  28 67 93  37 112 160  28 67 93
+2 2 1  7 12 15  35 83 115  28 67 93  3 6 7  1 0 0
+4 4 4  5 5 5  3 3 3  0 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  60 73 81  174 174 174  190 197 201  174 174 174
+177 184 187  193 200 203  163 162 163  30 32 34  0 0 0  2 2 2
+5 5 5  4 4 4  1 1 2  6 10 14  28 67 93  10 87 144
+10 87 144  16 89 141  19 95 150  10 87 144  26 108 161  26 108 161
+26 108 161  26 108 161  26 108 161  28 67 93  6 10 14  1 1 2
+7 12 15  28 67 93  26 108 161  16 89 141  24 86 132  21 29 34
+3 4 3  21 29 34  37 112 160  37 112 160  27 99 146  21 29 34
+21 29 34  26 108 161  90 154 193  35 83 115  1 1 2  2 0 0
+4 4 4  5 5 5  3 3 3  2 0 0  26 28 28  125 124 125
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+3 1 0  4 0 0  60 73 81  193 200 203  193 200 203  174 174 174
+190 197 201  193 200 203  165 164 165  37 38 37  4 0 0  2 2 2
+5 5 5  4 3 3  4 0 0  6 10 14  24 86 132  10 87 144
+10 87 144  10 87 144  16 89 141  18 97 151  18 97 151  10 87 144
+24 86 132  24 86 132  13 20 25  4 5 7  4 5 7  22 40 52
+18 97 151  37 112 160  26 108 161  7 12 15  1 1 1  0 0 0
+28 67 93  37 112 160  26 108 161  28 67 93  22 40 52  28 67 93
+26 108 161  90 154 193  26 108 161  10 87 144  0 0 0  2 0 0
+4 4 4  5 5 5  3 3 3  0 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  6 6 6  60 73 81  174 174 174  193 200 203  174 174 174
+190 197 201  193 200 203  165 164 165  30 32 34  0 0 0  2 2 2
+5 5 5  4 4 4  1 1 2  6 10 14  28 67 93  10 87 144
+10 87 144  10 87 144  10 87 144  18 97 151  28 67 93  6 10 14
+0 0 0  1 1 2  4 5 7  13 20 25  16 89 141  26 108 161
+26 108 161  26 108 161  24 86 132  6 9 11  2 3 3  22 40 52
+37 112 160  16 89 141  22 40 52  28 67 93  26 108 161  26 108 161
+90 154 193  26 108 161  26 108 161  28 67 93  1 1 1  4 0 0
+4 4 4  5 5 5  3 3 3  4 0 0  26 28 28  124 126 130
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  60 73 81  193 200 203  193 200 203  174 174 174
+193 200 203  193 200 203  167 166 167  37 38 37  4 0 0  2 2 2
+5 5 5  4 4 4  4 0 0  6 10 14  28 67 93  10 87 144
+10 87 144  10 87 144  18 97 151  10 87 144  13 20 25  4 5 7
+1 1 2  1 1 1  22 40 52  26 108 161  26 108 161  26 108 161
+26 108 161  26 108 161  26 108 161  24 86 132  22 40 52  22 40 52
+22 40 52  22 40 52  10 87 144  26 108 161  26 108 161  26 108 161
+26 108 161  26 108 161  90 154 193  10 87 144  0 0 0  4 0 0
+4 4 4  5 5 5  3 3 3  0 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  6 6 6  60 73 81  174 174 174  220 221 221  174 174 174
+190 197 201  205 212 215  167 166 167  30 32 34  0 0 0  2 2 2
+5 5 5  4 4 4  1 1 2  6 10 14  28 67 93  10 87 144
+10 87 144  10 87 144  10 87 144  10 87 144  22 40 52  1 1 2
+2 0 0  1 1 2  24 86 132  26 108 161  26 108 161  26 108 161
+26 108 161  19 95 150  16 89 141  10 87 144  22 40 52  22 40 52
+10 87 144  26 108 161  37 112 160  26 108 161  26 108 161  26 108 161
+26 108 161  26 108 161  26 108 161  28 67 93  2 0 0  3 1 0
+4 4 4  5 5 5  3 3 3  2 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  60 73 81  220 221 221  190 197 201  174 174 174
+193 200 203  193 200 203  174 174 174  37 38 37  4 0 0  2 2 2
+5 5 5  4 4 4  3 2 2  1 1 2  13 20 25  10 87 144
+10 87 144  10 87 144  10 87 144  10 87 144  10 87 144  13 20 25
+13 20 25  22 40 52  10 87 144  18 97 151  18 97 151  26 108 161
+10 87 144  13 20 25  6 10 14  21 29 34  24 86 132  18 97 151
+26 108 161  26 108 161  26 108 161  26 108 161  26 108 161  26 108 161
+26 108 161  90 154 193  18 97 151  13 20 25  0 0 0  4 3 3
+4 4 4  5 5 5  3 3 3  0 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  6 6 6  60 73 81  174 174 174  220 221 221  174 174 174
+190 197 201  220 221 221  167 166 167  30 32 34  1 0 0  2 2 2
+5 5 5  4 4 4  4 4 5  2 5 5  4 5 7  13 20 25
+28 67 93  10 87 144  10 87 144  10 87 144  10 87 144  10 87 144
+10 87 144  10 87 144  18 97 151  10 87 144  18 97 151  18 97 151
+28 67 93  2 3 3  0 0 0  28 67 93  26 108 161  26 108 161
+26 108 161  26 108 161  26 108 161  26 108 161  26 108 161  26 108 161
+26 108 161  10 87 144  13 20 25  1 1 2  3 2 2  4 4 4
+4 4 4  5 5 5  3 3 3  2 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  60 73 81  220 221 221  190 197 201  174 174 174
+193 200 203  193 200 203  174 174 174  26 28 28  4 0 0  4 3 3
+5 5 5  4 4 4  4 4 4  4 4 5  1 1 2  2 5 5
+4 5 7  22 40 52  10 87 144  10 87 144  18 97 151  10 87 144
+10 87 144  10 87 144  10 87 144  10 87 144  10 87 144  18 97 151
+10 87 144  28 67 93  22 40 52  10 87 144  26 108 161  18 97 151
+18 97 151  18 97 151  26 108 161  26 108 161  26 108 161  26 108 161
+22 40 52  1 1 2  0 0 0  2 3 3  4 4 4  4 4 4
+4 4 4  5 5 5  4 4 4  0 0 0  26 28 28  131 129 131
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  6 6 6  60 73 81  174 174 174  220 221 221  174 174 174
+190 197 201  220 221 221  190 197 201  41 54 63  4 0 0  2 2 2
+6 6 6  4 4 4  4 4 4  4 4 5  4 4 5  3 3 3
+1 1 2  1 1 2  6 10 14  22 40 52  10 87 144  18 97 151
+18 97 151  10 87 144  10 87 144  10 87 144  18 97 151  10 87 144
+10 87 144  18 97 151  26 108 161  18 97 151  18 97 151  10 87 144
+26 108 161  26 108 161  26 108 161  10 87 144  28 67 93  6 10 14
+1 1 2  1 1 2  4 3 3  4 4 5  4 4 4  4 4 4
+5 5 5  5 5 5  1 1 1  4 0 0  37 51 59  137 136 137
+137 136 137  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  4 0 0  60 73 81  220 221 221  193 200 203  174 174 174
+193 200 203  193 200 203  220 221 221  137 136 137  13 16 17  4 0 0
+2 2 2  4 4 4  4 4 4  4 4 4  4 4 4  4 4 5
+4 4 5  4 3 3  1 1 2  4 5 7  13 20 25  28 67 93
+10 87 144  10 87 144  10 87 144  10 87 144  10 87 144  10 87 144
+10 87 144  18 97 151  18 97 151  10 87 144  18 97 151  26 108 161
+26 108 161  18 97 151  28 67 93  6 10 14  0 0 0  0 0 0
+2 3 3  4 5 5  4 4 5  4 4 4  4 4 4  5 5 5
+3 3 3  1 1 1  0 0 0  16 19 21  125 124 125  137 136 137
+131 129 131  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  6 6 6  60 73 81  174 174 174  220 221 221  174 174 174
+193 200 203  190 197 201  220 221 221  220 221 221  153 152 153  30 32 34
+0 0 0  0 0 0  2 2 2  4 4 4  4 4 4  4 4 4
+4 4 4  4 5 5  4 5 7  1 1 2  1 1 2  4 5 7
+13 20 25  28 67 93  10 87 144  18 97 151  10 87 144  10 87 144
+10 87 144  10 87 144  10 87 144  18 97 151  26 108 161  18 97 151
+28 67 93  7 12 15  0 0 0  0 0 0  2 2 1  4 4 4
+4 5 5  4 5 5  4 4 4  4 4 4  3 3 3  0 0 0
+0 0 0  0 0 0  37 38 37  125 124 125  158 157 158  131 129 131
+125 124 125  125 124 125  125 124 125  137 136 137  131 129 131  37 38 37
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 3 3  4 0 0  41 54 63  193 200 203  220 221 221  174 174 174
+193 200 203  193 200 203  193 200 203  220 221 221  244 246 246  193 200 203
+120 125 127  5 5 5  1 0 0  0 0 0  1 1 1  4 4 4
+4 4 4  4 4 4  4 5 5  4 5 5  4 4 5  1 1 2
+4 5 7  4 5 7  22 40 52  10 87 144  10 87 144  10 87 144
+10 87 144  10 87 144  18 97 151  10 87 144  10 87 144  13 20 25
+4 5 7  2 3 3  1 1 2  4 4 4  4 5 5  4 4 4
+4 4 4  4 4 4  4 4 4  1 1 1  0 0 0  1 1 2
+24 26 27  60 74 84  153 152 153  163 162 163  137 136 137  125 124 125
+125 124 125  125 124 125  125 124 125  137 136 137  125 124 125  26 28 28
+0 0 0  3 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 0 0  6 6 6  26 28 28  156 155 156  220 221 221  220 221 221
+174 174 174  193 200 203  193 200 203  193 200 203  205 212 215  220 221 221
+220 221 221  167 166 167  60 73 81  7 11 13  0 0 0  0 0 0
+3 3 3  4 4 4  4 4 4  4 4 4  4 4 5  4 4 5
+4 4 5  1 1 2  1 1 2  4 5 7  22 40 52  10 87 144
+10 87 144  10 87 144  10 87 144  22 40 52  4 5 7  1 1 2
+1 1 2  4 4 5  4 4 4  4 4 4  4 4 4  4 4 4
+5 5 5  2 2 2  0 0 0  4 0 0  16 19 21  60 73 81
+137 136 137  167 166 167  158 157 158  137 136 137  131 129 131  131 129 131
+125 124 125  125 124 125  131 129 131  155 154 155  60 74 84  5 7 8
+0 0 0  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+5 5 5  4 0 0  4 0 0  60 73 81  193 200 203  220 221 221
+193 200 203  193 200 203  193 200 203  193 200 203  205 212 215  220 221 221
+220 221 221  220 221 221  220 221 221  137 136 137  43 57 68  6 6 6
+4 0 0  1 1 1  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 5  4 4 5  3 2 2  1 1 2  2 5 5  13 20 25
+22 40 52  22 40 52  13 20 25  2 3 3  1 1 2  3 3 3
+4 5 7  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+1 1 1  0 0 0  2 3 3  41 54 63  131 129 131  166 165 166
+166 165 166  155 154 155  153 152 153  137 136 137  137 136 137  125 124 125
+125 124 125  137 136 137  137 136 137  125 124 125  37 38 37  4 3 3
+4 3 3  5 5 5  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 3 3  6 6 6  6 6 6  13 16 17  60 73 81  167 166 167
+220 221 221  220 221 221  220 221 221  193 200 203  193 200 203  193 200 203
+205 212 215  220 221 221  220 221 221  244 246 246  205 212 215  125 124 125
+24 26 27  0 0 0  0 0 0  2 2 2  5 5 5  5 5 5
+4 4 4  4 4 4  4 4 4  4 4 5  1 1 2  4 5 7
+4 5 7  4 5 7  1 1 2  3 2 2  4 4 5  4 4 4
+4 4 4  4 4 4  5 5 5  4 4 4  0 0 0  0 0 0
+2 0 0  26 28 28  125 124 125  174 174 174  174 174 174  166 165 166
+156 155 156  153 152 153  137 136 137  137 136 137  131 129 131  137 136 137
+137 136 137  137 136 137  60 74 84  30 32 34  4 0 0  4 0 0
+5 5 5  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+5 5 5  6 6 6  4 0 0  4 0 0  6 6 6  26 28 28
+125 124 125  174 174 174  220 221 221  220 221 221  220 221 221  193 200 203
+205 212 215  220 221 221  205 212 215  220 221 221  220 221 221  244 246 246
+193 200 203  60 74 84  13 16 17  4 0 0  0 0 0  3 3 3
+5 5 5  5 5 5  4 4 4  4 4 4  4 4 5  3 3 3
+1 1 2  3 3 3  4 4 5  4 4 5  4 4 4  4 4 4
+5 5 5  5 5 5  2 2 2  0 0 0  0 0 0  13 16 17
+60 74 84  174 174 174  193 200 203  174 174 174  167 166 167  163 162 163
+153 152 153  153 152 153  137 136 137  137 136 137  153 152 153  137 136 137
+125 124 125  41 54 63  24 26 27  4 0 0  4 0 0  5 5 5
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 3 3  6 6 6  6 6 6  6 6 6  6 6 6  6 6 6
+6 6 6  37 38 37  131 129 131  220 221 221  220 221 221  220 221 221
+193 200 203  193 200 203  220 221 221  205 212 215  220 221 221  244 246 246
+244 246 246  244 246 246  174 174 174  41 54 63  0 0 0  0 0 0
+0 0 0  4 4 4  5 5 5  5 5 5  4 4 4  4 4 5
+4 4 5  4 4 5  4 4 4  4 4 4  6 6 6  6 6 6
+3 3 3  0 0 0  2 0 0  13 16 17  60 73 81  156 155 156
+220 221 221  193 200 203  174 174 174  165 164 165  163 162 163  154 153 154
+153 152 153  153 152 153  158 157 158  163 162 163  137 136 137  60 73 81
+13 16 17  4 0 0  4 0 0  4 3 3  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+5 5 5  4 3 3  4 3 3  6 6 6  6 6 6  6 6 6
+6 6 6  6 6 6  6 6 6  37 38 37  167 166 167  244 246 246
+244 246 246  220 221 221  205 212 215  205 212 215  220 221 221  193 200 203
+220 221 221  244 246 246  244 246 246  244 246 246  137 136 137  37 38 37
+3 2 2  0 0 0  1 1 1  5 5 5  5 5 5  4 4 4
+4 4 4  4 4 4  4 4 4  5 5 5  4 4 4  1 1 1
+0 0 0  5 5 5  43 57 68  153 152 153  193 200 203  220 221 221
+177 184 187  174 174 174  167 166 167  166 165 166  158 157 158  157 156 157
+158 157 158  166 165 166  156 155 156  85 115 134  13 16 17  4 0 0
+4 0 0  4 0 0  5 5 5  5 5 5  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+5 5 5  4 3 3  6 6 6  6 6 6  4 0 0  6 6 6
+6 6 6  6 6 6  6 6 6  6 6 6  13 16 17  60 73 81
+177 184 187  220 221 221  220 221 221  220 221 221  205 212 215  220 221 221
+220 221 221  205 212 215  220 221 221  244 246 246  244 246 246  205 212 215
+125 124 125  30 32 34  0 0 0  0 0 0  2 2 2  5 5 5
+4 4 4  4 4 4  4 4 4  1 1 1  0 0 0  1 0 0
+37 38 37  131 129 131  205 212 215  220 221 221  193 200 203  174 174 174
+174 174 174  174 174 174  167 166 167  165 164 165  166 165 166  167 166 167
+158 157 158  125 124 125  37 38 37  4 0 0  4 0 0  4 0 0
+4 3 3  5 5 5  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  5 5 5  4 3 3  4 3 3  6 6 6  6 6 6
+4 0 0  6 6 6  6 6 6  6 6 6  6 6 6  6 6 6
+26 28 28  125 124 125  205 212 215  220 221 221  220 221 221  220 221 221
+205 212 215  220 221 221  205 212 215  220 221 221  220 221 221  244 246 246
+244 246 246  190 197 201  60 74 84  16 19 21  4 0 0  0 0 0
+0 0 0  0 0 0  0 0 0  0 0 0  16 19 21  120 125 127
+177 184 187  220 221 221  205 212 215  177 184 187  174 174 174  177 184 187
+174 174 174  174 174 174  167 166 167  174 174 174  166 165 166  137 136 137
+60 73 81  13 16 17  4 0 0  4 0 0  4 3 3  6 6 6
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+5 5 5  4 3 3  5 5 5  4 3 3  6 6 6  4 0 0
+6 6 6  6 6 6  4 0 0  6 6 6  4 0 0  6 6 6
+6 6 6  6 6 6  37 38 37  137 136 137  193 200 203  220 221 221
+220 221 221  205 212 215  220 221 221  205 212 215  205 212 215  220 221 221
+220 221 221  220 221 221  244 246 246  166 165 166  43 57 68  2 2 2
+0 0 0  4 0 0  16 19 21  60 73 81  157 156 157  202 210 214
+220 221 221  193 200 203  177 184 187  177 184 187  177 184 187  174 174 174
+174 174 174  174 174 174  174 174 174  157 156 157  60 74 84  24 26 27
+4 0 0  4 0 0  4 0 0  6 6 6  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  5 5 5  4 3 3  5 5 5  6 6 6
+6 6 6  4 0 0  6 6 6  6 6 6  6 6 6  4 0 0
+4 0 0  4 0 0  6 6 6  24 26 27  60 73 81  167 166 167
+220 221 221  220 221 221  220 221 221  205 212 215  205 212 215  205 212 215
+205 212 215  220 221 221  220 221 221  220 221 221  205 212 215  137 136 137
+60 74 84  125 124 125  137 136 137  190 197 201  220 221 221  193 200 203
+177 184 187  177 184 187  177 184 187  174 174 174  174 174 174  177 184 187
+190 197 201  174 174 174  125 124 125  37 38 37  6 6 6  4 0 0
+4 0 0  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  5 5 5  5 5 5  4 3 3  6 6 6
+4 0 0  6 6 6  6 6 6  6 6 6  4 0 0  6 6 6
+6 6 6  6 6 6  4 0 0  4 0 0  6 6 6  6 6 6
+125 124 125  193 200 203  244 246 246  220 221 221  205 212 215  205 212 215
+205 212 215  193 200 203  205 212 215  205 212 215  220 221 221  220 221 221
+193 200 203  193 200 203  205 212 215  193 200 203  193 200 203  177 184 187
+190 197 201  190 197 201  174 174 174  190 197 201  193 200 203  190 197 201
+153 152 153  60 73 81  4 0 0  4 0 0  4 0 0  3 2 2
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  5 5 5  4 3 3
+6 6 6  4 3 3  4 3 3  4 3 3  6 6 6  6 6 6
+4 0 0  6 6 6  6 6 6  6 6 6  4 0 0  4 0 0
+4 0 0  26 28 28  131 129 131  220 221 221  244 246 246  220 221 221
+205 212 215  193 200 203  205 212 215  193 200 203  193 200 203  205 212 215
+220 221 221  193 200 203  193 200 203  193 200 203  190 197 201  174 174 174
+174 174 174  190 197 201  193 200 203  193 200 203  167 166 167  125 124 125
+6 6 6  4 0 0  4 0 0  4 3 3  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  5 5 5
+5 5 5  4 3 3  5 5 5  6 6 6  4 3 3  5 5 5
+6 6 6  6 6 6  4 0 0  6 6 6  6 6 6  6 6 6
+4 0 0  4 0 0  6 6 6  41 54 63  158 157 158  220 221 221
+220 221 221  220 221 221  193 200 203  193 200 203  193 200 203  190 197 201
+190 197 201  190 197 201  190 197 201  190 197 201  174 174 174  193 200 203
+193 200 203  220 221 221  174 174 174  125 124 125  37 38 37  4 0 0
+4 0 0  4 3 3  6 6 6  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  4 3 3  4 3 3  4 3 3  5 5 5
+4 3 3  6 6 6  5 5 5  4 3 3  6 6 6  6 6 6
+6 6 6  6 6 6  4 0 0  4 0 0  13 16 17  60 73 81
+174 174 174  220 221 221  220 221 221  205 212 215  190 197 201  174 174 174
+193 200 203  174 174 174  190 197 201  174 174 174  193 200 203  220 221 221
+193 200 203  131 129 131  37 38 37  6 6 6  4 0 0  4 0 0
+6 6 6  6 6 6  4 3 3  5 5 5  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  5 5 5  5 5 5  5 5 5
+5 5 5  4 3 3  4 3 3  5 5 5  4 3 3  4 3 3
+5 5 5  6 6 6  6 6 6  4 0 0  6 6 6  6 6 6
+6 6 6  125 124 125  174 174 174  220 221 221  220 221 221  193 200 203
+193 200 203  193 200 203  193 200 203  193 200 203  220 221 221  158 157 158
+60 73 81  6 6 6  4 0 0  4 0 0  5 5 5  6 6 6
+5 5 5  5 5 5  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  5 5 5  4 3 3  5 5 5  4 3 3
+5 5 5  5 5 5  6 6 6  6 6 6  4 0 0  4 0 0
+4 0 0  4 0 0  26 28 28  125 124 125  174 174 174  193 200 203
+193 200 203  174 174 174  193 200 203  167 166 167  125 124 125  6 6 6
+6 6 6  6 6 6  4 0 0  6 6 6  6 6 6  5 5 5
+4 3 3  5 5 5  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  5 5 5
+4 3 3  6 6 6  4 0 0  6 6 6  6 6 6  6 6 6
+6 6 6  4 0 0  4 0 0  6 6 6  37 38 37  125 124 125
+153 152 153  131 129 131  125 124 125  37 38 37  6 6 6  6 6 6
+6 6 6  4 0 0  6 6 6  6 6 6  4 3 3  5 5 5
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  5 5 5  4 3 3  5 5 5  4 3 3
+6 6 6  6 6 6  4 0 0  4 0 0  6 6 6  6 6 6
+24 26 27  24 26 27  6 6 6  6 6 6  6 6 6  4 0 0
+6 6 6  6 6 6  4 0 0  6 6 6  5 5 5  4 3 3
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  5 5 5  4 3 3  5 5 5  6 6 6
+4 0 0  6 6 6  6 6 6  6 6 6  6 6 6  6 6 6
+6 6 6  6 6 6  6 6 6  4 0 0  6 6 6  6 6 6
+4 0 0  6 6 6  6 6 6  4 3 3  5 5 5  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  5 5 5  4 3 3  5 5 5
+5 5 5  5 5 5  4 0 0  6 6 6  4 0 0  6 6 6
+6 6 6  6 6 6  6 6 6  4 0 0  6 6 6  4 0 0
+6 6 6  4 3 3  5 5 5  4 3 3  5 5 5  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  5 5 5
+4 3 3  6 6 6  4 3 3  6 6 6  6 6 6  6 6 6
+4 0 0  6 6 6  4 0 0  6 6 6  6 6 6  6 6 6
+6 6 6  4 3 3  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  4 3 3  5 5 5  4 0 0  6 6 6
+6 6 6  4 0 0  6 6 6  6 6 6  4 0 0  6 6 6
+4 3 3  5 5 5  5 5 5  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  5 5 5  4 3 3  5 5 5  6 6 6  4 3 3
+4 3 3  6 6 6  6 6 6  4 3 3  6 6 6  4 3 3
+5 5 5  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  5 5 5  4 3 3  6 6 6
+5 5 5  4 3 3  4 3 3  4 3 3  5 5 5  5 5 5
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  5 5 5  4 3 3
+5 5 5  4 3 3  5 5 5  5 5 5  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4  4 4 4  4 4 4  4 4 4  4 4 4
+4 4 4  4 4 4
diff --git a/drivers/xen/events/events_base.c b/drivers/xen/events/events_base.c
index d5dbdb9d2..8159bdd7f 100644
--- a/drivers/xen/events/events_base.c
+++ b/drivers/xen/events/events_base.c
@@ -1588,7 +1588,7 @@ void xen_irq_resume(void)
 	restore_pirqs();
 }
 
-static struct irq_chip xen_dynamic_chip __read_mostly = {
+static struct irq_chip xen_dynamic_chip = {
 	.name			= "xen-dyn",
 
 	.irq_disable		= disable_dynirq,
@@ -1602,7 +1602,7 @@ static struct irq_chip xen_dynamic_chip __read_mostly = {
 	.irq_retrigger		= retrigger_dynirq,
 };
 
-static struct irq_chip xen_pirq_chip __read_mostly = {
+static struct irq_chip xen_pirq_chip = {
 	.name			= "xen-pirq",
 
 	.irq_startup		= startup_pirq,
@@ -1622,7 +1622,7 @@ static struct irq_chip xen_pirq_chip __read_mostly = {
 	.irq_retrigger		= retrigger_dynirq,
 };
 
-static struct irq_chip xen_percpu_chip __read_mostly = {
+static struct irq_chip xen_percpu_chip = {
 	.name			= "xen-percpu",
 
 	.irq_disable		= disable_dynirq,
diff --git a/drivers/xen/xen-pciback/pci_stub.c b/drivers/xen/xen-pciback/pci_stub.c
index 258b7c325..6aad74adb 100644
--- a/drivers/xen/xen-pciback/pci_stub.c
+++ b/drivers/xen/xen-pciback/pci_stub.c
@@ -831,7 +831,7 @@ end:
 */
 
 static pci_ers_result_t xen_pcibk_error_detected(struct pci_dev *dev,
-	pci_channel_state_t error)
+	enum pci_channel_state error)
 {
 	struct pcistub_device *psdev;
 	pci_ers_result_t result;
diff --git a/drivers/xen/xenfs/xenstored.c b/drivers/xen/xenfs/xenstored.c
index fef20dbc6..d28b1aba6 100644
--- a/drivers/xen/xenfs/xenstored.c
+++ b/drivers/xen/xenfs/xenstored.c
@@ -24,7 +24,12 @@ static int xsd_release(struct inode *inode, struct file *file)
 static int xsd_kva_open(struct inode *inode, struct file *file)
 {
 	file->private_data = (void *)kasprintf(GFP_KERNEL, "0x%p",
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+					       NULL);
+#else
 					       xen_store_interface);
+#endif
+
 	if (!file->private_data)
 		return -ENOMEM;
 	return 0;
diff --git a/fs/9p/vfs_addr.c b/fs/9p/vfs_addr.c
index 6181ad79e..86db0223c 100644
--- a/fs/9p/vfs_addr.c
+++ b/fs/9p/vfs_addr.c
@@ -121,7 +121,7 @@ static int v9fs_vfs_readpages(struct file *filp, struct address_space *mapping,
 	if (ret == 0)
 		return ret;
 
-	ret = read_cache_pages(mapping, pages, (void *)v9fs_vfs_readpage, filp);
+	ret = read_cache_pages(mapping, pages, v9fs_vfs_readpage, filp);
 	p9_debug(P9_DEBUG_VFS, "  = %d\n", ret);
 	return ret;
 }
diff --git a/fs/9p/vfs_inode_dotl.c b/fs/9p/vfs_inode_dotl.c
index eeabcb0ba..cea07b5bc 100644
--- a/fs/9p/vfs_inode_dotl.c
+++ b/fs/9p/vfs_inode_dotl.c
@@ -179,7 +179,7 @@ static int v9fs_mapped_dotl_flags(int flags)
 {
 	int i;
 	int rflags = 0;
-	struct dotl_openflag_map dotl_oflag_map[] = {
+	static const struct dotl_openflag_map dotl_oflag_map[] = {
 		{ O_CREAT,	P9_DOTL_CREATE },
 		{ O_EXCL,	P9_DOTL_EXCL },
 		{ O_NOCTTY,	P9_DOTL_NOCTTY },
@@ -524,7 +524,7 @@ static int v9fs_mapped_iattr_valid(int iattr_valid)
 {
 	int i;
 	int p9_iattr_valid = 0;
-	struct dotl_iattr_map dotl_iattr_map[] = {
+	static const struct dotl_iattr_map dotl_iattr_map[] = {
 		{ ATTR_MODE,		P9_ATTR_MODE },
 		{ ATTR_UID,		P9_ATTR_UID },
 		{ ATTR_GID,		P9_ATTR_GID },
diff --git a/fs/Kconfig.binfmt b/fs/Kconfig.binfmt
index c7efddf6e..fa601eecb 100644
--- a/fs/Kconfig.binfmt
+++ b/fs/Kconfig.binfmt
@@ -112,7 +112,7 @@ config HAVE_AOUT
 
 config BINFMT_AOUT
 	tristate "Kernel support for a.out and ECOFF binaries"
-	depends on HAVE_AOUT
+	depends on HAVE_AOUT && BROKEN
 	---help---
 	  A.out (Assembler.OUTput) is a set of formats for libraries and
 	  executables used in the earliest versions of UNIX.  Linux used
diff --git a/fs/afs/file.c b/fs/afs/file.c
index 6344aee4a..217c57926 100644
--- a/fs/afs/file.c
+++ b/fs/afs/file.c
@@ -122,11 +122,11 @@ static void afs_file_readpage_read_complete(struct page *page,
 /*
  * read page from file, directory or symlink, given a key to use
  */
-int afs_page_filler(void *data, struct page *page)
+int afs_page_filler(struct file *data, struct page *page)
 {
 	struct inode *inode = page->mapping->host;
 	struct afs_vnode *vnode = AFS_FS_I(inode);
-	struct key *key = data;
+	struct key *key = (struct key *)data;
 	size_t len;
 	off_t offset;
 	int ret;
@@ -220,14 +220,14 @@ static int afs_readpage(struct file *file, struct page *page)
 	if (file) {
 		key = file->private_data;
 		ASSERT(key != NULL);
-		ret = afs_page_filler(key, page);
+		ret = afs_page_filler((struct file *)key, page);
 	} else {
 		struct inode *inode = page->mapping->host;
 		key = afs_request_key(AFS_FS_S(inode->i_sb)->volume->cell);
 		if (IS_ERR(key)) {
 			ret = PTR_ERR(key);
 		} else {
-			ret = afs_page_filler(key, page);
+			ret = afs_page_filler((struct file *)key, page);
 			key_put(key);
 		}
 	}
diff --git a/fs/afs/inode.c b/fs/afs/inode.c
index 86cc7264c..b9b7f73e7 100644
--- a/fs/afs/inode.c
+++ b/fs/afs/inode.c
@@ -142,7 +142,7 @@ struct inode *afs_iget_autocell(struct inode *dir, const char *dev_name,
 	struct afs_vnode *vnode;
 	struct super_block *sb;
 	struct inode *inode;
-	static atomic_t afs_autocell_ino;
+	static atomic_unchecked_t afs_autocell_ino;
 
 	_enter("{%x:%u},%*.*s,",
 	       AFS_FS_I(dir)->fid.vid, AFS_FS_I(dir)->fid.vnode,
@@ -155,7 +155,7 @@ struct inode *afs_iget_autocell(struct inode *dir, const char *dev_name,
 	data.fid.unique = 0;
 	data.fid.vnode = 0;
 
-	inode = iget5_locked(sb, atomic_inc_return(&afs_autocell_ino),
+	inode = iget5_locked(sb, atomic_inc_return_unchecked(&afs_autocell_ino),
 			     afs_iget5_autocell_test, afs_iget5_set,
 			     &data);
 	if (!inode) {
diff --git a/fs/afs/internal.h b/fs/afs/internal.h
index df976b2a7..fcafd4441 100644
--- a/fs/afs/internal.h
+++ b/fs/afs/internal.h
@@ -15,7 +15,7 @@
 #include <linux/pagemap.h>
 #include <linux/skbuff.h>
 #include <linux/rxrpc.h>
-#include <linux/key.h>
+#include <linux/key-type.h>
 #include <linux/workqueue.h>
 #include <linux/sched.h>
 #include <linux/fscache.h>
@@ -498,7 +498,7 @@ extern const struct file_operations afs_file_operations;
 
 extern int afs_open(struct inode *, struct file *);
 extern int afs_release(struct inode *, struct file *);
-extern int afs_page_filler(void *, struct page *);
+extern int afs_page_filler(struct file *, struct page *);
 
 /*
  * flock.c
diff --git a/fs/aio.c b/fs/aio.c
index 4fe81d1c6..85f39a003 100644
--- a/fs/aio.c
+++ b/fs/aio.c
@@ -455,7 +455,7 @@ static int aio_setup_ring(struct kioctx *ctx)
 	size += sizeof(struct io_event) * nr_events;
 
 	nr_pages = PFN_UP(size);
-	if (nr_pages < 0)
+	if (nr_pages <= 0)
 		return -EINVAL;
 
 	file = aio_private_file(ctx, nr_pages);
diff --git a/fs/attr.c b/fs/attr.c
index 3c42cab06..3e01da660 100644
--- a/fs/attr.c
+++ b/fs/attr.c
@@ -102,6 +102,10 @@ int inode_newsize_ok(const struct inode *inode, loff_t offset)
 		unsigned long limit;
 
 		limit = rlimit(RLIMIT_FSIZE);
+		if (offset > ULONG_MAX)
+			gr_learn_resource(current, RLIMIT_FSIZE, ULONG_MAX, 1);
+		else if (offset > 0)
+			gr_learn_resource(current, RLIMIT_FSIZE, (unsigned long)offset, 1);
 		if (limit != RLIM_INFINITY && offset > limit)
 			goto out_sig;
 		if (offset > inode->i_sb->s_maxbytes)
diff --git a/fs/autofs4/waitq.c b/fs/autofs4/waitq.c
index e44271dfc..0fdc215b0 100644
--- a/fs/autofs4/waitq.c
+++ b/fs/autofs4/waitq.c
@@ -56,7 +56,7 @@ static int autofs4_write(struct autofs_sb_info *sbi,
 {
 	unsigned long sigpipe, flags;
 	mm_segment_t fs;
-	const char *data = (const char *)addr;
+	const char __user *data = (const char __force_user *)addr;
 	ssize_t wr = 0;
 
 	sigpipe = sigismember(&current->pending.signal, SIGPIPE);
@@ -344,6 +344,10 @@ static int validate_request(struct autofs_wait_queue **wait,
 	return 1;
 }
 
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+static atomic_unchecked_t autofs_dummy_name_id = ATOMIC_INIT(0);
+#endif
+
 int autofs4_wait(struct autofs_sb_info *sbi,
 		 struct dentry *dentry, enum autofs_notify notify)
 {
@@ -389,7 +393,12 @@ int autofs4_wait(struct autofs_sb_info *sbi,
 
 	/* If this is a direct mount request create a dummy name */
 	if (IS_ROOT(dentry) && autofs_type_trigger(sbi->type))
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+		/* this name does get written to userland via autofs4_write() */
+		qstr.len = sprintf(name, "%08x", atomic_inc_return_unchecked(&autofs_dummy_name_id));
+#else
 		qstr.len = sprintf(name, "%p", dentry);
+#endif
 	else {
 		qstr.len = autofs4_getpath(sbi, dentry, &name);
 		if (!qstr.len) {
diff --git a/fs/befs/endian.h b/fs/befs/endian.h
index 27223878b..56059b576 100644
--- a/fs/befs/endian.h
+++ b/fs/befs/endian.h
@@ -11,7 +11,7 @@
 
 #include <asm/byteorder.h>
 
-static inline u64
+static inline u64 __intentional_overflow(-1)
 fs64_to_cpu(const struct super_block *sb, fs64 n)
 {
 	if (BEFS_SB(sb)->byte_order == BEFS_BYTESEX_LE)
@@ -29,7 +29,7 @@ cpu_to_fs64(const struct super_block *sb, u64 n)
 		return (__force fs64)cpu_to_be64(n);
 }
 
-static inline u32
+static inline u32 __intentional_overflow(-1)
 fs32_to_cpu(const struct super_block *sb, fs32 n)
 {
 	if (BEFS_SB(sb)->byte_order == BEFS_BYTESEX_LE)
@@ -47,7 +47,7 @@ cpu_to_fs32(const struct super_block *sb, u32 n)
 		return (__force fs32)cpu_to_be32(n);
 }
 
-static inline u16
+static inline u16 __intentional_overflow(-1)
 fs16_to_cpu(const struct super_block *sb, fs16 n)
 {
 	if (BEFS_SB(sb)->byte_order == BEFS_BYTESEX_LE)
diff --git a/fs/befs/linuxvfs.c b/fs/befs/linuxvfs.c
index 7da05b159..9df0a298c 100644
--- a/fs/befs/linuxvfs.c
+++ b/fs/befs/linuxvfs.c
@@ -431,10 +431,12 @@ static struct inode *befs_iget(struct super_block *sb, unsigned long ino)
 static int __init
 befs_init_inodecache(void)
 {
-	befs_inode_cachep = kmem_cache_create("befs_inode_cache",
+	befs_inode_cachep = kmem_cache_create_usercopy("befs_inode_cache",
 					      sizeof (struct befs_inode_info),
 					      0, (SLAB_RECLAIM_ACCOUNT|
 						SLAB_MEM_SPREAD|SLAB_ACCOUNT),
+					      offsetof(struct befs_inode_info, i_data.symlink),
+					      sizeof(((struct befs_inode_info *)0)->i_data.symlink),
 					      init_once);
 	if (befs_inode_cachep == NULL) {
 		pr_err("%s: Couldn't initialize inode slabcache\n", __func__);
diff --git a/fs/binfmt_aout.c b/fs/binfmt_aout.c
index ae1b5404f..15cfacf11 100644
--- a/fs/binfmt_aout.c
+++ b/fs/binfmt_aout.c
@@ -16,6 +16,7 @@
 #include <linux/string.h>
 #include <linux/fs.h>
 #include <linux/file.h>
+#include <linux/security.h>
 #include <linux/stat.h>
 #include <linux/fcntl.h>
 #include <linux/ptrace.h>
@@ -58,6 +59,8 @@ static int aout_core_dump(struct coredump_params *cprm)
 #endif
 #       define START_STACK(u)   ((void __user *)u.start_stack)
 
+	memset(&dump, 0, sizeof(dump));
+
 	fs = get_fs();
 	set_fs(KERNEL_DS);
 	has_dumped = 1;
@@ -68,10 +71,12 @@ static int aout_core_dump(struct coredump_params *cprm)
 
 /* If the size of the dump file exceeds the rlimit, then see what would happen
    if we wrote the stack, but not the data area.  */
+	gr_learn_resource(current, RLIMIT_CORE, (dump.u_dsize + dump.u_ssize+1) * PAGE_SIZE, 1);
 	if ((dump.u_dsize + dump.u_ssize+1) * PAGE_SIZE > cprm->limit)
 		dump.u_dsize = 0;
 
 /* Make sure we have enough room to write the stack and data areas. */
+	gr_learn_resource(current, RLIMIT_CORE, (dump.u_ssize + 1) * PAGE_SIZE, 1);
 	if ((dump.u_ssize + 1) * PAGE_SIZE > cprm->limit)
 		dump.u_ssize = 0;
 
@@ -228,6 +233,8 @@ static int load_aout_binary(struct linux_binprm * bprm)
 	rlim = rlimit(RLIMIT_DATA);
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
+
+	gr_learn_resource(current, RLIMIT_DATA, ex.a_data + ex.a_bss, 1);
 	if (ex.a_data + ex.a_bss > rlim)
 		return -ENOMEM;
 
@@ -257,6 +264,27 @@ static int load_aout_binary(struct linux_binprm * bprm)
 
 	install_exec_creds(bprm);
 
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+	current->mm->pax_flags = 0UL;
+#endif
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (!(N_FLAGS(ex) & F_PAX_PAGEEXEC)) {
+		current->mm->pax_flags |= MF_PAX_PAGEEXEC;
+
+#ifdef CONFIG_PAX_EMUTRAMP
+		if (N_FLAGS(ex) & F_PAX_EMUTRAMP)
+			current->mm->pax_flags |= MF_PAX_EMUTRAMP;
+#endif
+
+#ifdef CONFIG_PAX_MPROTECT
+		if (!(N_FLAGS(ex) & F_PAX_MPROTECT))
+			current->mm->pax_flags |= MF_PAX_MPROTECT;
+#endif
+
+	}
+#endif
+
 	if (N_MAGIC(ex) == OMAGIC) {
 		unsigned long text_addr, map_size;
 		loff_t pos;
@@ -311,7 +339,7 @@ static int load_aout_binary(struct linux_binprm * bprm)
 			return error;
 
 		error = vm_mmap(bprm->file, N_DATADDR(ex), ex.a_data,
-				PROT_READ | PROT_WRITE | PROT_EXEC,
+				PROT_READ | PROT_WRITE,
 				MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE | MAP_EXECUTABLE,
 				fd_offset + ex.a_text);
 		if (error != N_DATADDR(ex))
diff --git a/fs/binfmt_elf.c b/fs/binfmt_elf.c
index e5495f37c..641d63f0d 100644
--- a/fs/binfmt_elf.c
+++ b/fs/binfmt_elf.c
@@ -36,6 +36,7 @@
 #include <linux/coredump.h>
 #include <linux/sched.h>
 #include <linux/dax.h>
+#include <linux/xattr.h>
 #include <asm/uaccess.h>
 #include <asm/param.h>
 #include <asm/page.h>
@@ -67,6 +68,14 @@ static int elf_core_dump(struct coredump_params *cprm);
 #define elf_core_dump	NULL
 #endif
 
+#ifdef CONFIG_PAX_MPROTECT
+static void elf_handle_mprotect(struct vm_area_struct *vma, unsigned long newflags);
+#endif
+
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+static void elf_handle_mmap(struct file *file);
+#endif
+
 #if ELF_EXEC_PAGESIZE > PAGE_SIZE
 #define ELF_MIN_ALIGN	ELF_EXEC_PAGESIZE
 #else
@@ -86,6 +95,15 @@ static struct linux_binfmt elf_format = {
 	.load_binary	= load_elf_binary,
 	.load_shlib	= load_elf_library,
 	.core_dump	= elf_core_dump,
+
+#ifdef CONFIG_PAX_MPROTECT
+	.handle_mprotect= elf_handle_mprotect,
+#endif
+
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+	.handle_mmap	= elf_handle_mmap,
+#endif
+
 	.min_coredump	= ELF_EXEC_PAGESIZE,
 };
 
@@ -93,6 +111,8 @@ static struct linux_binfmt elf_format = {
 
 static int set_brk(unsigned long start, unsigned long end)
 {
+	unsigned long e = end;
+
 	start = ELF_PAGEALIGN(start);
 	end = ELF_PAGEALIGN(end);
 	if (end > start) {
@@ -100,7 +120,7 @@ static int set_brk(unsigned long start, unsigned long end)
 		if (error)
 			return error;
 	}
-	current->mm->start_brk = current->mm->brk = end;
+	current->mm->start_brk = current->mm->brk = e;
 	return 0;
 }
 
@@ -161,7 +181,7 @@ create_elf_tables(struct linux_binprm *bprm, struct elfhdr *exec,
 	elf_addr_t __user *u_rand_bytes;
 	const char *k_platform = ELF_PLATFORM;
 	const char *k_base_platform = ELF_BASE_PLATFORM;
-	unsigned char k_rand_bytes[16];
+	u32 k_rand_bytes[4];
 	int items;
 	elf_addr_t *elf_info;
 	int ei_index = 0;
@@ -208,8 +228,12 @@ create_elf_tables(struct linux_binprm *bprm, struct elfhdr *exec,
 	 * Generate 16 random bytes for userspace PRNG seeding.
 	 */
 	get_random_bytes(k_rand_bytes, sizeof(k_rand_bytes));
-	u_rand_bytes = (elf_addr_t __user *)
-		       STACK_ALLOC(p, sizeof(k_rand_bytes));
+	prandom_seed(k_rand_bytes[0] ^ prandom_u32());
+	prandom_seed(k_rand_bytes[1] ^ prandom_u32());
+	prandom_seed(k_rand_bytes[2] ^ prandom_u32());
+	prandom_seed(k_rand_bytes[3] ^ prandom_u32());
+	p = STACK_ROUND(p, sizeof(k_rand_bytes));
+	u_rand_bytes = (elf_addr_t __user *) p;
 	if (__copy_to_user(u_rand_bytes, k_rand_bytes, sizeof(k_rand_bytes)))
 		return -EFAULT;
 
@@ -517,14 +541,14 @@ static inline int arch_check_elf(struct elfhdr *ehdr, bool has_interp,
    an ELF header */
 
 static unsigned long load_elf_interp(struct elfhdr *interp_elf_ex,
-		struct file *interpreter, unsigned long *interp_map_addr,
+		struct file *interpreter,
 		unsigned long no_base, struct elf_phdr *interp_elf_phdata)
 {
 	struct elf_phdr *eppnt;
-	unsigned long load_addr = 0;
+	unsigned long load_addr = 0, pax_task_size = TASK_SIZE;
 	int load_addr_set = 0;
 	unsigned long last_bss = 0, elf_bss = 0;
-	unsigned long error = ~0UL;
+	unsigned long error = -EINVAL;
 	unsigned long total_size;
 	int i;
 
@@ -544,6 +568,11 @@ static unsigned long load_elf_interp(struct elfhdr *interp_elf_ex,
 		goto out;
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (current->mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
+
 	eppnt = interp_elf_phdata;
 	for (i = 0; i < interp_elf_ex->e_phnum; i++, eppnt++) {
 		if (eppnt->p_type == PT_LOAD) {
@@ -567,8 +596,6 @@ static unsigned long load_elf_interp(struct elfhdr *interp_elf_ex,
 			map_addr = elf_map(interpreter, load_addr + vaddr,
 					eppnt, elf_prot, elf_type, total_size);
 			total_size = 0;
-			if (!*interp_map_addr)
-				*interp_map_addr = map_addr;
 			error = map_addr;
 			if (BAD_ADDR(map_addr))
 				goto out;
@@ -587,8 +614,8 @@ static unsigned long load_elf_interp(struct elfhdr *interp_elf_ex,
 			k = load_addr + eppnt->p_vaddr;
 			if (BAD_ADDR(k) ||
 			    eppnt->p_filesz > eppnt->p_memsz ||
-			    eppnt->p_memsz > TASK_SIZE ||
-			    TASK_SIZE - eppnt->p_memsz < k) {
+			    eppnt->p_memsz > pax_task_size ||
+			    pax_task_size - eppnt->p_memsz < k) {
 				error = -ENOMEM;
 				goto out;
 			}
@@ -639,6 +666,336 @@ out:
 	return error;
 }
 
+#ifdef CONFIG_PAX_PT_PAX_FLAGS
+#ifdef CONFIG_PAX_SOFTMODE
+static unsigned long pax_parse_pt_pax_softmode(const struct elf_phdr * const elf_phdata)
+{
+	unsigned long pax_flags = 0UL;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (elf_phdata->p_flags & PF_PAGEEXEC)
+		pax_flags |= MF_PAX_PAGEEXEC;
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (elf_phdata->p_flags & PF_SEGMEXEC)
+		pax_flags |= MF_PAX_SEGMEXEC;
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+	if ((elf_phdata->p_flags & PF_EMUTRAMP) && (pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)))
+		pax_flags |= MF_PAX_EMUTRAMP;
+#endif
+
+#ifdef CONFIG_PAX_MPROTECT
+	if (elf_phdata->p_flags & PF_MPROTECT)
+		pax_flags |= MF_PAX_MPROTECT;
+#endif
+
+#if defined(CONFIG_PAX_RANDMMAP) || defined(CONFIG_PAX_RANDUSTACK)
+	if (randomize_va_space && (elf_phdata->p_flags & PF_RANDMMAP))
+		pax_flags |= MF_PAX_RANDMMAP;
+#endif
+
+	return pax_flags;
+}
+#endif
+
+static unsigned long pax_parse_pt_pax_hardmode(const struct elf_phdr * const elf_phdata)
+{
+	unsigned long pax_flags = 0UL;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (!(elf_phdata->p_flags & PF_NOPAGEEXEC))
+		pax_flags |= MF_PAX_PAGEEXEC;
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (!(elf_phdata->p_flags & PF_NOSEGMEXEC))
+		pax_flags |= MF_PAX_SEGMEXEC;
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+	if (!(elf_phdata->p_flags & PF_NOEMUTRAMP))
+		pax_flags |= MF_PAX_EMUTRAMP;
+#endif
+
+#ifdef CONFIG_PAX_MPROTECT
+	if (!(elf_phdata->p_flags & PF_NOMPROTECT))
+		pax_flags |= MF_PAX_MPROTECT;
+#endif
+
+#if defined(CONFIG_PAX_RANDMMAP) || defined(CONFIG_PAX_RANDUSTACK)
+	if (randomize_va_space && !(elf_phdata->p_flags & PF_NORANDMMAP))
+		pax_flags |= MF_PAX_RANDMMAP;
+#endif
+
+	return pax_flags;
+}
+#endif
+
+#ifdef CONFIG_PAX_XATTR_PAX_FLAGS
+#ifdef CONFIG_PAX_SOFTMODE
+static unsigned long pax_parse_xattr_pax_softmode(unsigned long pax_flags_softmode)
+{
+	unsigned long pax_flags = 0UL;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (pax_flags_softmode & MF_PAX_PAGEEXEC)
+		pax_flags |= MF_PAX_PAGEEXEC;
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (pax_flags_softmode & MF_PAX_SEGMEXEC)
+		pax_flags |= MF_PAX_SEGMEXEC;
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+	if ((pax_flags_softmode & MF_PAX_EMUTRAMP) && (pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)))
+		pax_flags |= MF_PAX_EMUTRAMP;
+#endif
+
+#ifdef CONFIG_PAX_MPROTECT
+	if (pax_flags_softmode & MF_PAX_MPROTECT)
+		pax_flags |= MF_PAX_MPROTECT;
+#endif
+
+#if defined(CONFIG_PAX_RANDMMAP) || defined(CONFIG_PAX_RANDUSTACK)
+	if (randomize_va_space && (pax_flags_softmode & MF_PAX_RANDMMAP))
+		pax_flags |= MF_PAX_RANDMMAP;
+#endif
+
+	return pax_flags;
+}
+#endif
+
+static unsigned long pax_parse_xattr_pax_hardmode(unsigned long pax_flags_hardmode)
+{
+	unsigned long pax_flags = 0UL;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (!(pax_flags_hardmode & MF_PAX_PAGEEXEC))
+		pax_flags |= MF_PAX_PAGEEXEC;
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (!(pax_flags_hardmode & MF_PAX_SEGMEXEC))
+		pax_flags |= MF_PAX_SEGMEXEC;
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+	if (!(pax_flags_hardmode & MF_PAX_EMUTRAMP))
+		pax_flags |= MF_PAX_EMUTRAMP;
+#endif
+
+#ifdef CONFIG_PAX_MPROTECT
+	if (!(pax_flags_hardmode & MF_PAX_MPROTECT))
+		pax_flags |= MF_PAX_MPROTECT;
+#endif
+
+#if defined(CONFIG_PAX_RANDMMAP) || defined(CONFIG_PAX_RANDUSTACK)
+	if (randomize_va_space && !(pax_flags_hardmode & MF_PAX_RANDMMAP))
+		pax_flags |= MF_PAX_RANDMMAP;
+#endif
+
+	return pax_flags;
+}
+#endif
+
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+static unsigned long pax_parse_defaults(void)
+{
+	unsigned long pax_flags = 0UL;
+
+#ifdef CONFIG_PAX_SOFTMODE
+	if (pax_softmode)
+		return pax_flags;
+#endif
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	pax_flags |= MF_PAX_PAGEEXEC;
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	pax_flags |= MF_PAX_SEGMEXEC;
+#endif
+
+#ifdef CONFIG_PAX_MPROTECT
+	pax_flags |= MF_PAX_MPROTECT;
+#endif
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (randomize_va_space)
+		pax_flags |= MF_PAX_RANDMMAP;
+#endif
+
+	return pax_flags;
+}
+
+static unsigned long pax_parse_ei_pax(const struct elfhdr * const elf_ex)
+{
+	unsigned long pax_flags = PAX_PARSE_FLAGS_FALLBACK;
+
+#ifdef CONFIG_PAX_EI_PAX
+
+#ifdef CONFIG_PAX_SOFTMODE
+	if (pax_softmode)
+		return pax_flags;
+#endif
+
+	pax_flags = 0UL;
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	if (!(elf_ex->e_ident[EI_PAX] & EF_PAX_PAGEEXEC))
+		pax_flags |= MF_PAX_PAGEEXEC;
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (!(elf_ex->e_ident[EI_PAX] & EF_PAX_SEGMEXEC))
+		pax_flags |= MF_PAX_SEGMEXEC;
+#endif
+
+#ifdef CONFIG_PAX_EMUTRAMP
+	if ((pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) && (elf_ex->e_ident[EI_PAX] & EF_PAX_EMUTRAMP))
+		pax_flags |= MF_PAX_EMUTRAMP;
+#endif
+
+#ifdef CONFIG_PAX_MPROTECT
+	if ((pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) && !(elf_ex->e_ident[EI_PAX] & EF_PAX_MPROTECT))
+		pax_flags |= MF_PAX_MPROTECT;
+#endif
+
+#ifdef CONFIG_PAX_ASLR
+	if (randomize_va_space && !(elf_ex->e_ident[EI_PAX] & EF_PAX_RANDMMAP))
+		pax_flags |= MF_PAX_RANDMMAP;
+#endif
+
+#endif
+
+	return pax_flags;
+
+}
+
+static unsigned long pax_parse_pt_pax(const struct elfhdr * const elf_ex, const struct elf_phdr * const elf_phdata)
+{
+
+#ifdef CONFIG_PAX_PT_PAX_FLAGS
+	unsigned long i;
+
+	for (i = 0UL; i < elf_ex->e_phnum; i++)
+		if (elf_phdata[i].p_type == PT_PAX_FLAGS) {
+			if (((elf_phdata[i].p_flags & PF_PAGEEXEC) && (elf_phdata[i].p_flags & PF_NOPAGEEXEC)) ||
+			    ((elf_phdata[i].p_flags & PF_SEGMEXEC) && (elf_phdata[i].p_flags & PF_NOSEGMEXEC)) ||
+			    ((elf_phdata[i].p_flags & PF_EMUTRAMP) && (elf_phdata[i].p_flags & PF_NOEMUTRAMP)) ||
+			    ((elf_phdata[i].p_flags & PF_MPROTECT) && (elf_phdata[i].p_flags & PF_NOMPROTECT)) ||
+			    ((elf_phdata[i].p_flags & PF_RANDMMAP) && (elf_phdata[i].p_flags & PF_NORANDMMAP)))
+				return PAX_PARSE_FLAGS_FALLBACK;
+
+#ifdef CONFIG_PAX_SOFTMODE
+			if (pax_softmode)
+				return pax_parse_pt_pax_softmode(&elf_phdata[i]);
+			else
+#endif
+
+				return pax_parse_pt_pax_hardmode(&elf_phdata[i]);
+			break;
+		}
+#endif
+
+	return PAX_PARSE_FLAGS_FALLBACK;
+}
+
+static unsigned long pax_parse_xattr_pax(struct file * const file)
+{
+
+#ifdef CONFIG_PAX_XATTR_PAX_FLAGS
+	ssize_t xattr_size, i;
+	unsigned char xattr_value[sizeof("pemrs") - 1];
+	unsigned long pax_flags_hardmode = 0UL, pax_flags_softmode = 0UL;
+
+	xattr_size = pax_getxattr(file->f_path.dentry, xattr_value, sizeof xattr_value);
+	if (xattr_size < 0 || xattr_size > sizeof xattr_value)
+		return PAX_PARSE_FLAGS_FALLBACK;
+
+	for (i = 0; i < xattr_size; i++)
+		switch (xattr_value[i]) {
+		default:
+			return PAX_PARSE_FLAGS_FALLBACK;
+
+#define parse_flag(option1, option2, flag)			\
+		case option1:					\
+			if (pax_flags_hardmode & MF_PAX_##flag)	\
+				return PAX_PARSE_FLAGS_FALLBACK;\
+			pax_flags_hardmode |= MF_PAX_##flag;	\
+			break;					\
+		case option2:					\
+			if (pax_flags_softmode & MF_PAX_##flag)	\
+				return PAX_PARSE_FLAGS_FALLBACK;\
+			pax_flags_softmode |= MF_PAX_##flag;	\
+			break;
+
+		parse_flag('p', 'P', PAGEEXEC);
+		parse_flag('e', 'E', EMUTRAMP);
+		parse_flag('m', 'M', MPROTECT);
+		parse_flag('r', 'R', RANDMMAP);
+		parse_flag('s', 'S', SEGMEXEC);
+
+#undef parse_flag
+		}
+
+	if (pax_flags_hardmode & pax_flags_softmode)
+		return PAX_PARSE_FLAGS_FALLBACK;
+
+#ifdef CONFIG_PAX_SOFTMODE
+	if (pax_softmode)
+		return pax_parse_xattr_pax_softmode(pax_flags_softmode);
+	else
+#endif
+
+		return pax_parse_xattr_pax_hardmode(pax_flags_hardmode);
+#else
+	return PAX_PARSE_FLAGS_FALLBACK;
+#endif
+
+}
+
+static long pax_parse_pax_flags(const struct elfhdr * const elf_ex, const struct elf_phdr * const elf_phdata, struct file * const file)
+{
+	unsigned long pax_flags, ei_pax_flags,  pt_pax_flags, xattr_pax_flags;
+
+	pax_flags = pax_parse_defaults();
+	ei_pax_flags = pax_parse_ei_pax(elf_ex);
+	pt_pax_flags = pax_parse_pt_pax(elf_ex, elf_phdata);
+	xattr_pax_flags = pax_parse_xattr_pax(file);
+
+	if (pt_pax_flags != PAX_PARSE_FLAGS_FALLBACK &&
+	    xattr_pax_flags != PAX_PARSE_FLAGS_FALLBACK &&
+	    pt_pax_flags != xattr_pax_flags)
+		return -EINVAL;
+	if (xattr_pax_flags != PAX_PARSE_FLAGS_FALLBACK)
+		pax_flags = xattr_pax_flags;
+	else if (pt_pax_flags != PAX_PARSE_FLAGS_FALLBACK)
+		pax_flags = pt_pax_flags;
+	else if (ei_pax_flags != PAX_PARSE_FLAGS_FALLBACK)
+		pax_flags = ei_pax_flags;
+
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_PAX_SEGMEXEC)
+	if ((pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) == (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) {
+		if ((__supported_pte_mask & _PAGE_NX))
+			pax_flags &= ~MF_PAX_SEGMEXEC;
+		else
+			pax_flags &= ~MF_PAX_PAGEEXEC;
+	}
+#endif
+
+	if (0 > pax_check_flags(&pax_flags))
+		return -EINVAL;
+
+	current->mm->pax_flags = pax_flags;
+	return 0;
+}
+#endif
+
 /*
  * These are the functions used to load ELF style executables and shared
  * libraries.  There is no binary dependent code anywhere else.
@@ -652,6 +1009,11 @@ static unsigned long randomize_stack_top(unsigned long stack_top)
 {
 	unsigned long random_variable = 0;
 
+#ifdef CONFIG_PAX_RANDUSTACK
+	if (current->mm->pax_flags & MF_PAX_RANDMMAP)
+		return stack_top - current->mm->delta_stack;
+#endif
+
 	if ((current->flags & PF_RANDOMIZE) &&
 		!(current->personality & ADDR_NO_RANDOMIZE)) {
 		random_variable = get_random_long();
@@ -671,7 +1033,7 @@ static int load_elf_binary(struct linux_binprm *bprm)
  	unsigned long load_addr = 0, load_bias = 0;
 	int load_addr_set = 0;
 	char * elf_interpreter = NULL;
-	unsigned long error;
+	unsigned long error = 0;
 	struct elf_phdr *elf_ppnt, *elf_phdata, *interp_elf_phdata = NULL;
 	unsigned long elf_bss, elf_brk;
 	int retval, i;
@@ -686,6 +1048,7 @@ static int load_elf_binary(struct linux_binprm *bprm)
 		struct elfhdr interp_elf_ex;
 	} *loc;
 	struct arch_elf_state arch_state = INIT_ARCH_ELF_STATE;
+	unsigned long pax_task_size;
 
 	loc = kmalloc(sizeof(*loc), GFP_KERNEL);
 	if (!loc) {
@@ -846,6 +1209,77 @@ static int load_elf_binary(struct linux_binprm *bprm)
 	/* Do this immediately, since STACK_TOP as used in setup_arg_pages
 	   may depend on the personality.  */
 	SET_PERSONALITY2(loc->elf_ex, &arch_state);
+
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+	current->mm->pax_flags = 0UL;
+#endif
+
+#ifdef CONFIG_PAX_DLRESOLVE
+	current->mm->call_dl_resolve = 0UL;
+#endif
+
+#if defined(CONFIG_PPC32) && defined(CONFIG_PAX_EMUSIGRT)
+	current->mm->call_syscall = 0UL;
+#endif
+
+#ifdef CONFIG_PAX_ASLR
+	current->mm->delta_mmap = 0UL;
+	current->mm->delta_stack = 0UL;
+#endif
+
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+	if (0 > pax_parse_pax_flags(&loc->elf_ex, elf_phdata, bprm->file)) {
+		retval = -EINVAL;
+		goto out_free_dentry;
+	}
+#endif
+
+#ifdef CONFIG_PAX_HAVE_ACL_FLAGS
+	pax_set_initial_flags(bprm);
+#elif defined(CONFIG_PAX_HOOK_ACL_FLAGS)
+	if (pax_set_initial_flags_func)
+		(pax_set_initial_flags_func)(bprm);
+#endif
+
+#ifdef CONFIG_ARCH_TRACK_EXEC_LIMIT
+	if ((current->mm->pax_flags & MF_PAX_PAGEEXEC) && !(__supported_pte_mask & _PAGE_NX)) {
+		current->mm->context.user_cs_limit = PAGE_SIZE;
+		current->mm->def_flags |= VM_PAGEEXEC | VM_NOHUGEPAGE;
+	}
+#endif
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (current->mm->pax_flags & MF_PAX_SEGMEXEC) {
+		current->mm->context.user_cs_base = SEGMEXEC_TASK_SIZE;
+		current->mm->context.user_cs_limit = TASK_SIZE-SEGMEXEC_TASK_SIZE;
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+		current->mm->def_flags |= VM_NOHUGEPAGE;
+	} else
+#endif
+
+	pax_task_size = TASK_SIZE;
+
+#if defined(CONFIG_ARCH_TRACK_EXEC_LIMIT) || defined(CONFIG_PAX_SEGMEXEC)
+	if (current->mm->pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) {
+		set_user_cs(current->mm->context.user_cs_base, current->mm->context.user_cs_limit, get_cpu());
+		put_cpu();
+	}
+#endif
+
+#ifdef CONFIG_PAX_ASLR
+	if (current->mm->pax_flags & MF_PAX_RANDMMAP) {
+		current->mm->delta_mmap = (pax_get_random_long() & ((1UL << PAX_DELTA_MMAP_LEN)-1)) << PAGE_SHIFT;
+		current->mm->delta_stack = (pax_get_random_long() & ((1UL << PAX_DELTA_STACK_LEN)-1)) << PAGE_SHIFT;
+	}
+#endif
+
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+	if (current->mm->pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) {
+		executable_stack = EXSTACK_DISABLE_X;
+		current->personality &= ~READ_IMPLIES_EXEC;
+	} else
+#endif
+
 	if (elf_read_implies_exec(loc->elf_ex, executable_stack))
 		current->personality |= READ_IMPLIES_EXEC;
 
@@ -922,8 +1356,21 @@ static int load_elf_binary(struct linux_binprm *bprm)
 			if (current->flags & PF_RANDOMIZE)
 				load_bias += arch_mmap_rnd();
 			load_bias = ELF_PAGESTART(load_bias);
-			total_size = total_mapping_size(elf_phdata,
-							loc->elf_ex.e_phnum);
+
+#ifdef CONFIG_PAX_RANDMMAP
+			/* PaX: randomize base address at the default exe base if requested */
+			if ((current->mm->pax_flags & MF_PAX_RANDMMAP) && elf_interpreter) {
+#ifdef CONFIG_SPARC64
+				load_bias = (pax_get_random_long() & ((1UL << PAX_DELTA_MMAP_LEN) - 1)) << (PAGE_SHIFT+1);
+#else
+				load_bias = (pax_get_random_long() & ((1UL << PAX_DELTA_MMAP_LEN) - 1)) << PAGE_SHIFT;
+#endif
+				load_bias = ELF_PAGESTART(PAX_ELF_ET_DYN_BASE - vaddr + load_bias);
+				elf_flags |= MAP_FIXED;
+			}
+#endif
+
+			total_size = total_mapping_size(elf_phdata, loc->elf_ex.e_phnum);
 			if (!total_size) {
 				retval = -EINVAL;
 				goto out_free_dentry;
@@ -959,9 +1406,9 @@ static int load_elf_binary(struct linux_binprm *bprm)
 		 * allowed task size. Note that p_filesz must always be
 		 * <= p_memsz so it is only necessary to check p_memsz.
 		 */
-		if (BAD_ADDR(k) || elf_ppnt->p_filesz > elf_ppnt->p_memsz ||
-		    elf_ppnt->p_memsz > TASK_SIZE ||
-		    TASK_SIZE - elf_ppnt->p_memsz < k) {
+		if (k >= pax_task_size || elf_ppnt->p_filesz > elf_ppnt->p_memsz ||
+		    elf_ppnt->p_memsz > pax_task_size ||
+		    pax_task_size - elf_ppnt->p_memsz < k) {
 			/* set_brk can never work. Avoid overflows. */
 			retval = -EINVAL;
 			goto out_free_dentry;
@@ -997,16 +1444,43 @@ static int load_elf_binary(struct linux_binprm *bprm)
 	if (retval)
 		goto out_free_dentry;
 	if (likely(elf_bss != elf_brk) && unlikely(padzero(elf_bss))) {
-		retval = -EFAULT; /* Nobody gets to see this, but.. */
-		goto out_free_dentry;
+		/*
+		 * This bss-zeroing can fail if the ELF
+		 * file specifies odd protections. So
+		 * we don't check the return value
+		 */
 	}
 
-	if (elf_interpreter) {
-		unsigned long interp_map_addr = 0;
+#ifdef CONFIG_PAX_RANDMMAP
+	if (current->mm->pax_flags & MF_PAX_RANDMMAP) {
+		unsigned long start, size, flags;
+		vm_flags_t vm_flags;
 
+		start = ELF_PAGEALIGN(elf_brk);
+		size = PAGE_SIZE + ((pax_get_random_long() & ((1UL << 22) - 1UL)) << 4);
+		flags = MAP_FIXED | MAP_PRIVATE;
+		vm_flags = VM_DONTEXPAND | VM_DONTDUMP;
+
+		down_write(&current->mm->mmap_sem);
+		start = get_unmapped_area(NULL, start, PAGE_ALIGN(size), 0, flags);
+		retval = -ENOMEM;
+		if (!IS_ERR_VALUE(start) && !find_vma_intersection(current->mm, start, start + size + PAGE_SIZE)) {
+//			if (current->personality & ADDR_NO_RANDOMIZE)
+//				vm_flags |= VM_READ | VM_MAYREAD;
+			start = mmap_region(NULL, start, PAGE_ALIGN(size), vm_flags, 0);
+			retval = IS_ERR_VALUE(start) ? start : 0;
+		}
+		up_write(&current->mm->mmap_sem);
+		if (retval == 0)
+			retval = set_brk(start + size, start + size + PAGE_SIZE);
+		if (retval < 0)
+			goto out_free_dentry;
+	}
+#endif
+
+	if (elf_interpreter) {
 		elf_entry = load_elf_interp(&loc->interp_elf_ex,
 					    interpreter,
-					    &interp_map_addr,
 					    load_bias, interp_elf_phdata);
 		if (!IS_ERR((void *)elf_entry)) {
 			/*
@@ -1056,6 +1530,7 @@ static int load_elf_binary(struct linux_binprm *bprm)
 	current->mm->end_data = end_data;
 	current->mm->start_stack = bprm->p;
 
+#ifndef CONFIG_PAX_RANDMMAP
 	if ((current->flags & PF_RANDOMIZE) && (randomize_va_space > 1)) {
 		current->mm->brk = current->mm->start_brk =
 			arch_randomize_brk(current->mm);
@@ -1063,6 +1538,7 @@ static int load_elf_binary(struct linux_binprm *bprm)
 		current->brk_randomized = 1;
 #endif
 	}
+#endif
 
 	if (current->personality & MMAP_PAGE_ZERO) {
 		/* Why this, you ask???  Well SVr4 maps page 0 as read-only,
@@ -1234,7 +1710,7 @@ static bool always_dump_vma(struct vm_area_struct *vma)
  * Decide what to dump of a segment, part, all or none.
  */
 static unsigned long vma_dump_size(struct vm_area_struct *vma,
-				   unsigned long mm_flags)
+				   unsigned long mm_flags, long signr)
 {
 #define FILTER(type)	(mm_flags & (1UL << MMF_DUMP_##type))
 
@@ -1281,7 +1757,7 @@ static unsigned long vma_dump_size(struct vm_area_struct *vma,
 	if (vma->vm_file == NULL)
 		return 0;
 
-	if (FILTER(MAPPED_PRIVATE))
+	if (signr == SIGKILL || FILTER(MAPPED_PRIVATE))
 		goto whole;
 
 	/*
@@ -1381,7 +1857,7 @@ static void fill_elf_header(struct elfhdr *elf, int segs,
 	return;
 }
 
-static void fill_elf_note_phdr(struct elf_phdr *phdr, int sz, loff_t offset)
+static void fill_elf_note_phdr(struct elf_phdr *phdr, size_t sz, loff_t offset)
 {
 	phdr->p_type = PT_NOTE;
 	phdr->p_offset = offset;
@@ -1488,9 +1964,9 @@ static void fill_auxv_note(struct memelfnote *note, struct mm_struct *mm)
 {
 	elf_addr_t *auxv = (elf_addr_t *) mm->saved_auxv;
 	int i = 0;
-	do
+	do {
 		i += 2;
-	while (auxv[i - 2] != AT_NULL);
+	} while (auxv[i - 2] != AT_NULL);
 	fill_note(note, "CORE", NT_AUXV, i * sizeof(elf_addr_t), auxv);
 }
 
@@ -1499,7 +1975,7 @@ static void fill_siginfo_note(struct memelfnote *note, user_siginfo_t *csigdata,
 {
 	mm_segment_t old_fs = get_fs();
 	set_fs(KERNEL_DS);
-	copy_siginfo_to_user((user_siginfo_t __user *) csigdata, siginfo);
+	copy_siginfo_to_user((user_siginfo_t __force_user *) csigdata, siginfo);
 	set_fs(old_fs);
 	fill_note(note, "CORE", NT_SIGINFO, sizeof(*csigdata), csigdata);
 }
@@ -2219,7 +2695,7 @@ static int elf_core_dump(struct coredump_params *cprm)
 			vma = next_vma(vma, gate_vma)) {
 		unsigned long dump_size;
 
-		dump_size = vma_dump_size(vma, cprm->mm_flags);
+		dump_size = vma_dump_size(vma, cprm->mm_flags, cprm->siginfo->si_signo);
 		vma_filesz[i++] = dump_size;
 		vma_data_size += dump_size;
 	}
@@ -2327,6 +2803,167 @@ out:
 
 #endif		/* CONFIG_ELF_CORE */
 
+#ifdef CONFIG_PAX_MPROTECT
+/* PaX: non-PIC ELF libraries need relocations on their executable segments
+ * therefore we'll grant them VM_MAYWRITE once during their life. Similarly
+ * we'll remove VM_MAYWRITE for good on RELRO segments.
+ *
+ * The checks favour ld-linux.so behaviour which operates on a per ELF segment
+ * basis because we want to allow the common case and not the special ones.
+ */
+static void elf_handle_mprotect(struct vm_area_struct *vma, unsigned long newflags)
+{
+	struct elfhdr elf_h;
+	struct elf_phdr elf_p;
+	unsigned long i;
+	unsigned long oldflags;
+	bool is_textrel_rw, is_textrel_rx, is_relro;
+
+	if (!(vma->vm_mm->pax_flags & MF_PAX_MPROTECT) || !vma->vm_file)
+		return;
+
+	oldflags = vma->vm_flags & (VM_MAYEXEC | VM_MAYWRITE | VM_MAYREAD | VM_EXEC | VM_WRITE | VM_READ);
+	newflags &= VM_MAYEXEC | VM_MAYWRITE | VM_MAYREAD | VM_EXEC | VM_WRITE | VM_READ;
+
+#ifdef CONFIG_PAX_ELFRELOCS
+	/* possible TEXTREL */
+	is_textrel_rw = !vma->anon_vma && oldflags == (VM_MAYEXEC | VM_MAYREAD | VM_EXEC | VM_READ) && newflags == (VM_WRITE | VM_READ);
+	is_textrel_rx = vma->anon_vma && oldflags == (VM_MAYEXEC | VM_MAYWRITE | VM_MAYREAD | VM_WRITE | VM_READ) && newflags == (VM_EXEC | VM_READ);
+#else
+	is_textrel_rw = false;
+	is_textrel_rx = false;
+#endif
+
+	/* possible RELRO */
+	is_relro = vma->anon_vma && oldflags == (VM_MAYWRITE | VM_MAYREAD | VM_READ) && newflags == (VM_MAYWRITE | VM_MAYREAD | VM_READ);
+
+	if (!is_textrel_rw && !is_textrel_rx && !is_relro)
+		return;
+
+	if (sizeof(elf_h) != kernel_read(vma->vm_file, 0UL, (char *)&elf_h, sizeof(elf_h)) ||
+	    memcmp(elf_h.e_ident, ELFMAG, SELFMAG) ||
+
+#ifdef CONFIG_PAX_ETEXECRELOCS
+	    ((is_textrel_rw || is_textrel_rx) && (elf_h.e_type != ET_DYN && elf_h.e_type != ET_EXEC)) ||
+#else
+	    ((is_textrel_rw || is_textrel_rx) && elf_h.e_type != ET_DYN) ||
+#endif
+
+	    (is_relro && (elf_h.e_type != ET_DYN && elf_h.e_type != ET_EXEC)) ||
+	    !elf_check_arch(&elf_h) ||
+	    elf_h.e_phentsize != sizeof(struct elf_phdr) ||
+	    elf_h.e_phnum > 65536UL / sizeof(struct elf_phdr))
+		return;
+
+	for (i = 0UL; i < elf_h.e_phnum; i++) {
+		if (sizeof(elf_p) != kernel_read(vma->vm_file, elf_h.e_phoff + i*sizeof(elf_p), (char *)&elf_p, sizeof(elf_p)))
+			return;
+		switch (elf_p.p_type) {
+		case PT_DYNAMIC:
+			if (!is_textrel_rw && !is_textrel_rx)
+				continue;
+			i = 0UL;
+			while ((i+1) * sizeof(elf_dyn) <= elf_p.p_filesz) {
+				elf_dyn dyn;
+
+				if (sizeof(dyn) != kernel_read(vma->vm_file, elf_p.p_offset + i*sizeof(dyn), (char *)&dyn, sizeof(dyn)))
+					break;
+				if (dyn.d_tag == DT_NULL)
+					break;
+				if (dyn.d_tag == DT_TEXTREL || (dyn.d_tag == DT_FLAGS && (dyn.d_un.d_val & DF_TEXTREL))) {
+					gr_log_textrel(vma, is_textrel_rw);
+					if (is_textrel_rw)
+						vma->vm_flags |= VM_MAYWRITE;
+					else
+						/* PaX: disallow write access after relocs are done, hopefully noone else needs it... */
+						vma->vm_flags &= ~VM_MAYWRITE;
+					break;
+				}
+				i++;
+			}
+			is_textrel_rw = false;
+			is_textrel_rx = false;
+			continue;
+
+		case PT_GNU_RELRO:
+			if (!is_relro)
+				continue;
+			if ((elf_p.p_offset >> PAGE_SHIFT) == vma->vm_pgoff && ELF_PAGEALIGN(elf_p.p_memsz) == vma->vm_end - vma->vm_start)
+				vma->vm_flags &= ~VM_MAYWRITE;
+			is_relro = false;
+			continue;
+
+#ifdef CONFIG_PAX_PT_PAX_FLAGS
+		case PT_PAX_FLAGS: {
+			const char *msg_mprotect = "", *msg_emutramp = "";
+			char *buffer_lib, *buffer_exe;
+
+			if (elf_p.p_flags & PF_NOMPROTECT)
+				msg_mprotect = "MPROTECT disabled";
+
+#ifdef CONFIG_PAX_EMUTRAMP
+			if (!(vma->vm_mm->pax_flags & MF_PAX_EMUTRAMP) && !(elf_p.p_flags & PF_NOEMUTRAMP))
+				msg_emutramp = "EMUTRAMP enabled";
+#endif
+
+			if (!msg_mprotect[0] && !msg_emutramp[0])
+				continue;
+
+			if (!printk_ratelimit())
+				continue;
+
+			buffer_lib = (char *)__get_free_page(GFP_KERNEL);
+			buffer_exe = (char *)__get_free_page(GFP_KERNEL);
+			if (buffer_lib && buffer_exe) {
+				char *path_lib, *path_exe;
+
+				path_lib = pax_get_path(&vma->vm_file->f_path, buffer_lib, PAGE_SIZE);
+				path_exe = pax_get_path(&vma->vm_mm->exe_file->f_path, buffer_exe, PAGE_SIZE);
+
+				pr_info("PAX: %s wants %s%s%s on %s\n", path_lib, msg_mprotect,
+					(msg_mprotect[0] && msg_emutramp[0] ? " and " : ""), msg_emutramp, path_exe);
+
+			}
+			free_page((unsigned long)buffer_exe);
+			free_page((unsigned long)buffer_lib);
+			continue;
+		}
+#endif
+
+		}
+	}
+}
+#endif
+
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+
+extern int grsec_enable_log_rwxmaps;
+
+static void elf_handle_mmap(struct file *file)
+{
+	struct elfhdr elf_h;
+	struct elf_phdr elf_p;
+	unsigned long i;
+
+	if (!grsec_enable_log_rwxmaps)
+		return;
+
+	if (sizeof(elf_h) != kernel_read(file, 0UL, (char *)&elf_h, sizeof(elf_h)) ||
+	    memcmp(elf_h.e_ident, ELFMAG, SELFMAG) ||
+	    (elf_h.e_type != ET_DYN && elf_h.e_type != ET_EXEC) || !elf_check_arch(&elf_h) ||
+	    elf_h.e_phentsize != sizeof(struct elf_phdr) ||
+	    elf_h.e_phnum > 65536UL / sizeof(struct elf_phdr))
+		return;
+
+	for (i = 0UL; i < elf_h.e_phnum; i++) {
+		if (sizeof(elf_p) != kernel_read(file, elf_h.e_phoff + i*sizeof(elf_p), (char *)&elf_p, sizeof(elf_p)))
+			return;
+		if (elf_p.p_type == PT_GNU_STACK && (elf_p.p_flags & PF_X))
+			gr_log_ptgnustack(file);
+	}
+}
+#endif
+
 static int __init init_elf_binfmt(void)
 {
 	register_binfmt(&elf_format);
diff --git a/fs/binfmt_elf_fdpic.c b/fs/binfmt_elf_fdpic.c
index 464a972e8..c889ed67b 100644
--- a/fs/binfmt_elf_fdpic.c
+++ b/fs/binfmt_elf_fdpic.c
@@ -1302,7 +1302,7 @@ static inline void fill_elf_fdpic_header(struct elfhdr *elf, int segs)
 	return;
 }
 
-static inline void fill_elf_note_phdr(struct elf_phdr *phdr, int sz, loff_t offset)
+static inline void fill_elf_note_phdr(struct elf_phdr *phdr, size_t sz, loff_t offset)
 {
 	phdr->p_type = PT_NOTE;
 	phdr->p_offset = offset;
@@ -1673,7 +1673,7 @@ static int elf_fdpic_core_dump(struct coredump_params *cprm)
 
 	/* Write notes phdr entry */
 	{
-		int sz = 0;
+		size_t sz = 0;
 
 		for (i = 0; i < numnote; i++)
 			sz += notesize(notes + i);
diff --git a/fs/block_dev.c b/fs/block_dev.c
index 496d99b80..f8cf02980 100644
--- a/fs/block_dev.c
+++ b/fs/block_dev.c
@@ -840,7 +840,7 @@ static bool bd_may_claim(struct block_device *bdev, struct block_device *whole,
 	else if (whole == bdev)
 		return true;  	 /* is a whole device which isn't held */
 
-	else if (whole->bd_holder == bd_may_claim)
+	else if (whole->bd_holder == (void *)bd_may_claim)
 		return true; 	 /* is a partition of a device that is being partitioned */
 	else if (whole->bd_holder != NULL)
 		return false;	 /* is a partition of a held device */
diff --git a/fs/btrfs/ctree.c b/fs/btrfs/ctree.c
index d1c56c94d..07bda1f8f 100644
--- a/fs/btrfs/ctree.c
+++ b/fs/btrfs/ctree.c
@@ -358,7 +358,7 @@ static inline void tree_mod_log_write_unlock(struct btrfs_fs_info *fs_info)
  */
 static inline u64 btrfs_inc_tree_mod_seq(struct btrfs_fs_info *fs_info)
 {
-	return atomic64_inc_return(&fs_info->tree_mod_seq);
+	return atomic64_inc_return_unchecked(&fs_info->tree_mod_seq);
 }
 
 /*
@@ -1182,9 +1182,12 @@ static noinline int __btrfs_cow_block(struct btrfs_trans_handle *trans,
 		free_extent_buffer(buf);
 		add_root_to_dirty_list(root);
 	} else {
-		if (root->root_key.objectid == BTRFS_TREE_RELOC_OBJECTID)
-			parent_start = parent->start;
-		else
+		if (root->root_key.objectid == BTRFS_TREE_RELOC_OBJECTID) {
+			if (parent)
+				parent_start = parent->start;
+			else
+				parent_start = 0;
+		} else
 			parent_start = 0;
 
 		WARN_ON(trans->transid != btrfs_header_generation(parent));
diff --git a/fs/btrfs/ctree.h b/fs/btrfs/ctree.h
index 469fa3268..eb7716d90 100644
--- a/fs/btrfs/ctree.h
+++ b/fs/btrfs/ctree.h
@@ -345,8 +345,8 @@ struct btrfs_dev_replace {
 	u64 replace_state;	/* see #define above */
 	u64 time_started;	/* seconds since 1-Jan-1970 */
 	u64 time_stopped;	/* seconds since 1-Jan-1970 */
-	atomic64_t num_write_errors;
-	atomic64_t num_uncorrectable_read_errors;
+	atomic64_unchecked_t num_write_errors;
+	atomic64_unchecked_t num_uncorrectable_read_errors;
 
 	u64 cursor_left;
 	u64 committed_cursor_left;
@@ -836,7 +836,7 @@ struct btrfs_fs_info {
 
 	/* this protects tree_mod_seq_list */
 	spinlock_t tree_mod_seq_lock;
-	atomic64_t tree_mod_seq;
+	atomic64_unchecked_t tree_mod_seq;
 	struct list_head tree_mod_seq_list;
 
 	/* this protects tree_mod_log */
@@ -1148,7 +1148,7 @@ struct btrfs_root {
 	struct list_head log_ctxs[2];
 	atomic_t log_writers;
 	atomic_t log_commit[2];
-	atomic_t log_batch;
+	atomic_unchecked_t log_batch;
 	int log_transid;
 	/* No matter the commit succeeds or not*/
 	int log_transid_committed;
diff --git a/fs/btrfs/delayed-inode.c b/fs/btrfs/delayed-inode.c
index de946dd74..3c04c5adb 100644
--- a/fs/btrfs/delayed-inode.c
+++ b/fs/btrfs/delayed-inode.c
@@ -456,7 +456,7 @@ static int __btrfs_add_delayed_deletion_item(struct btrfs_delayed_node *node,
 
 static void finish_one_item(struct btrfs_delayed_root *delayed_root)
 {
-	int seq = atomic_inc_return(&delayed_root->items_seq);
+	int seq = atomic_inc_return_unchecked(&delayed_root->items_seq);
 
 	/*
 	 * atomic_dec_return implies a barrier for waitqueue_active
@@ -1399,7 +1399,7 @@ void btrfs_assert_delayed_root_empty(struct btrfs_root *root)
 
 static int could_end_wait(struct btrfs_delayed_root *delayed_root, int seq)
 {
-	int val = atomic_read(&delayed_root->items_seq);
+	int val = atomic_read_unchecked(&delayed_root->items_seq);
 
 	if (val < seq || val >= seq + BTRFS_DELAYED_BATCH)
 		return 1;
@@ -1424,7 +1424,7 @@ void btrfs_balance_delayed_items(struct btrfs_root *root)
 		int seq;
 		int ret;
 
-		seq = atomic_read(&delayed_root->items_seq);
+		seq = atomic_read_unchecked(&delayed_root->items_seq);
 
 		ret = btrfs_wq_run_delayed_node(delayed_root, fs_info, 0);
 		if (ret)
diff --git a/fs/btrfs/delayed-inode.h b/fs/btrfs/delayed-inode.h
index 2495b3d40..8bdbb07da 100644
--- a/fs/btrfs/delayed-inode.h
+++ b/fs/btrfs/delayed-inode.h
@@ -43,7 +43,7 @@ struct btrfs_delayed_root {
 	 */
 	struct list_head prepare_list;
 	atomic_t items;		/* for delayed items */
-	atomic_t items_seq;	/* for delayed items */
+	atomic_unchecked_t items_seq;	/* for delayed items */
 	int nodes;		/* for delayed nodes */
 	wait_queue_head_t wait;
 };
@@ -90,7 +90,7 @@ static inline void btrfs_init_delayed_root(
 				struct btrfs_delayed_root *delayed_root)
 {
 	atomic_set(&delayed_root->items, 0);
-	atomic_set(&delayed_root->items_seq, 0);
+	atomic_set_unchecked(&delayed_root->items_seq, 0);
 	delayed_root->nodes = 0;
 	spin_lock_init(&delayed_root->lock);
 	init_waitqueue_head(&delayed_root->wait);
diff --git a/fs/btrfs/delayed-ref.c b/fs/btrfs/delayed-ref.c
index ac02e0414..c0b234ec1 100644
--- a/fs/btrfs/delayed-ref.c
+++ b/fs/btrfs/delayed-ref.c
@@ -658,7 +658,7 @@ add_delayed_tree_ref(struct btrfs_fs_info *fs_info,
 		action = BTRFS_ADD_DELAYED_REF;
 
 	if (is_fstree(ref_root))
-		seq = atomic64_read(&fs_info->tree_mod_seq);
+		seq = atomic64_read_unchecked(&fs_info->tree_mod_seq);
 	delayed_refs = &trans->transaction->delayed_refs;
 
 	/* first set the basic ref node struct up */
@@ -714,7 +714,7 @@ add_delayed_data_ref(struct btrfs_fs_info *fs_info,
 	delayed_refs = &trans->transaction->delayed_refs;
 
 	if (is_fstree(ref_root))
-		seq = atomic64_read(&fs_info->tree_mod_seq);
+		seq = atomic64_read_unchecked(&fs_info->tree_mod_seq);
 
 	/* first set the basic ref node struct up */
 	atomic_set(&ref->refs, 1);
diff --git a/fs/btrfs/dev-replace.c b/fs/btrfs/dev-replace.c
index e9bbff3c0..6985e2c7b 100644
--- a/fs/btrfs/dev-replace.c
+++ b/fs/btrfs/dev-replace.c
@@ -82,8 +82,8 @@ no_valid_dev_replace_entry_found:
 		dev_replace->replace_state = 0;
 		dev_replace->time_started = 0;
 		dev_replace->time_stopped = 0;
-		atomic64_set(&dev_replace->num_write_errors, 0);
-		atomic64_set(&dev_replace->num_uncorrectable_read_errors, 0);
+		atomic64_set_unchecked(&dev_replace->num_write_errors, 0);
+		atomic64_set_unchecked(&dev_replace->num_uncorrectable_read_errors, 0);
 		dev_replace->cursor_left = 0;
 		dev_replace->committed_cursor_left = 0;
 		dev_replace->cursor_left_last_write_of_item = 0;
@@ -112,9 +112,9 @@ no_valid_dev_replace_entry_found:
 	dev_replace->time_started = btrfs_dev_replace_time_started(eb, ptr);
 	dev_replace->time_stopped =
 		btrfs_dev_replace_time_stopped(eb, ptr);
-	atomic64_set(&dev_replace->num_write_errors,
+	atomic64_set_unchecked(&dev_replace->num_write_errors,
 		     btrfs_dev_replace_num_write_errors(eb, ptr));
-	atomic64_set(&dev_replace->num_uncorrectable_read_errors,
+	atomic64_set_unchecked(&dev_replace->num_uncorrectable_read_errors,
 		     btrfs_dev_replace_num_uncorrectable_read_errors(eb, ptr));
 	dev_replace->cursor_left = btrfs_dev_replace_cursor_left(eb, ptr);
 	dev_replace->committed_cursor_left = dev_replace->cursor_left;
@@ -274,9 +274,9 @@ int btrfs_run_dev_replace(struct btrfs_trans_handle *trans,
 	btrfs_set_dev_replace_time_started(eb, ptr, dev_replace->time_started);
 	btrfs_set_dev_replace_time_stopped(eb, ptr, dev_replace->time_stopped);
 	btrfs_set_dev_replace_num_write_errors(eb, ptr,
-		atomic64_read(&dev_replace->num_write_errors));
+		atomic64_read_unchecked(&dev_replace->num_write_errors));
 	btrfs_set_dev_replace_num_uncorrectable_read_errors(eb, ptr,
-		atomic64_read(&dev_replace->num_uncorrectable_read_errors));
+		atomic64_read_unchecked(&dev_replace->num_uncorrectable_read_errors));
 	dev_replace->cursor_left_last_write_of_item =
 		dev_replace->cursor_left;
 	btrfs_set_dev_replace_cursor_left(eb, ptr,
@@ -377,8 +377,8 @@ int btrfs_dev_replace_start(struct btrfs_root *root, char *tgtdev_name,
 	dev_replace->cursor_right = 0;
 	dev_replace->is_valid = 1;
 	dev_replace->item_needs_writeback = 1;
-	atomic64_set(&dev_replace->num_write_errors, 0);
-	atomic64_set(&dev_replace->num_uncorrectable_read_errors, 0);
+	atomic64_set_unchecked(&dev_replace->num_write_errors, 0);
+	atomic64_set_unchecked(&dev_replace->num_uncorrectable_read_errors, 0);
 	btrfs_dev_replace_unlock(dev_replace, 1);
 
 	ret = btrfs_sysfs_add_device_link(tgt_device->fs_devices, tgt_device);
@@ -648,9 +648,9 @@ void btrfs_dev_replace_status(struct btrfs_fs_info *fs_info,
 	args->status.time_started = dev_replace->time_started;
 	args->status.time_stopped = dev_replace->time_stopped;
 	args->status.num_write_errors =
-		atomic64_read(&dev_replace->num_write_errors);
+		atomic64_read_unchecked(&dev_replace->num_write_errors);
 	args->status.num_uncorrectable_read_errors =
-		atomic64_read(&dev_replace->num_uncorrectable_read_errors);
+		atomic64_read_unchecked(&dev_replace->num_uncorrectable_read_errors);
 	switch (dev_replace->replace_state) {
 	case BTRFS_IOCTL_DEV_REPLACE_STATE_NEVER_STARTED:
 	case BTRFS_IOCTL_DEV_REPLACE_STATE_CANCELED:
diff --git a/fs/btrfs/dev-replace.h b/fs/btrfs/dev-replace.h
index e922b42d9..2a5a145c2 100644
--- a/fs/btrfs/dev-replace.h
+++ b/fs/btrfs/dev-replace.h
@@ -42,8 +42,8 @@ void btrfs_dev_replace_set_lock_blocking(struct btrfs_dev_replace *dev_replace);
 void btrfs_dev_replace_clear_lock_blocking(
 					struct btrfs_dev_replace *dev_replace);
 
-static inline void btrfs_dev_replace_stats_inc(atomic64_t *stat_value)
+static inline void btrfs_dev_replace_stats_inc(atomic64_unchecked_t *stat_value)
 {
-	atomic64_inc(stat_value);
+	atomic64_inc_unchecked(stat_value);
 }
 #endif
diff --git a/fs/btrfs/disk-io.c b/fs/btrfs/disk-io.c
index dafcfd017..e57d31df6 100644
--- a/fs/btrfs/disk-io.c
+++ b/fs/btrfs/disk-io.c
@@ -1326,7 +1326,7 @@ static void __setup_root(u32 nodesize, u32 sectorsize, u32 stripesize,
 	atomic_set(&root->log_commit[0], 0);
 	atomic_set(&root->log_commit[1], 0);
 	atomic_set(&root->log_writers, 0);
-	atomic_set(&root->log_batch, 0);
+	atomic_set_unchecked(&root->log_batch, 0);
 	atomic_set(&root->orphan_inodes, 0);
 	atomic_set(&root->refs, 1);
 	atomic_set(&root->will_be_snapshoted, 0);
@@ -2677,7 +2677,7 @@ int open_ctree(struct super_block *sb,
 	atomic_set(&fs_info->defrag_running, 0);
 	atomic_set(&fs_info->qgroup_op_seq, 0);
 	atomic_set(&fs_info->reada_works_cnt, 0);
-	atomic64_set(&fs_info->tree_mod_seq, 0);
+	atomic64_set_unchecked(&fs_info->tree_mod_seq, 0);
 	fs_info->fs_frozen = 0;
 	fs_info->sb = sb;
 	fs_info->max_inline = BTRFS_DEFAULT_MAX_INLINE;
diff --git a/fs/btrfs/extent_map.c b/fs/btrfs/extent_map.c
index 26f9ac719..bc78edc4f 100644
--- a/fs/btrfs/extent_map.c
+++ b/fs/btrfs/extent_map.c
@@ -235,7 +235,9 @@ static void try_merge_map(struct extent_map_tree *tree, struct extent_map *em)
 			em->start = merge->start;
 			em->orig_start = merge->orig_start;
 			em->len += merge->len;
-			em->block_len += merge->block_len;
+			if (em->block_start != EXTENT_MAP_HOLE &&
+			    em->block_start != EXTENT_MAP_INLINE)
+				em->block_len += merge->block_len;
 			em->block_start = merge->block_start;
 			em->mod_len = (em->mod_len + em->mod_start) - merge->mod_start;
 			em->mod_start = merge->mod_start;
@@ -252,7 +254,9 @@ static void try_merge_map(struct extent_map_tree *tree, struct extent_map *em)
 		merge = rb_entry(rb, struct extent_map, rb_node);
 	if (rb && mergable_maps(em, merge)) {
 		em->len += merge->len;
-		em->block_len += merge->block_len;
+		if (em->block_start != EXTENT_MAP_HOLE &&
+		    em->block_start != EXTENT_MAP_INLINE)
+			em->block_len += merge->block_len;
 		rb_erase(&merge->rb_node, &tree->map);
 		RB_CLEAR_NODE(&merge->rb_node);
 		em->mod_len = (merge->mod_start + merge->mod_len) - em->mod_start;
diff --git a/fs/btrfs/file.c b/fs/btrfs/file.c
index fea31a4a6..8be7c86cd 100644
--- a/fs/btrfs/file.c
+++ b/fs/btrfs/file.c
@@ -1935,7 +1935,7 @@ int btrfs_sync_file(struct file *file, loff_t start, loff_t end, int datasync)
 		return ret;
 
 	inode_lock(inode);
-	atomic_inc(&root->log_batch);
+	atomic_inc_unchecked(&root->log_batch);
 	full_sync = test_bit(BTRFS_INODE_NEEDS_FULL_SYNC,
 			     &BTRFS_I(inode)->runtime_flags);
 	/*
@@ -1989,7 +1989,7 @@ int btrfs_sync_file(struct file *file, loff_t start, loff_t end, int datasync)
 		inode_unlock(inode);
 		goto out;
 	}
-	atomic_inc(&root->log_batch);
+	atomic_inc_unchecked(&root->log_batch);
 
 	/*
 	 * If the last transaction that changed this file was before the current
diff --git a/fs/btrfs/free-space-cache.h b/fs/btrfs/free-space-cache.h
index 3af651c2b..30b96445a 100644
--- a/fs/btrfs/free-space-cache.h
+++ b/fs/btrfs/free-space-cache.h
@@ -48,6 +48,7 @@ struct btrfs_free_space_op {
 	bool (*use_bitmap)(struct btrfs_free_space_ctl *ctl,
 			   struct btrfs_free_space *info);
 };
+typedef struct btrfs_free_space_op __no_const btrfs_free_space_op_no_const;
 
 struct btrfs_io_ctl;
 
diff --git a/fs/btrfs/raid56.c b/fs/btrfs/raid56.c
index cd8d302a1..dfd9e57ed 100644
--- a/fs/btrfs/raid56.c
+++ b/fs/btrfs/raid56.c
@@ -153,7 +153,7 @@ struct btrfs_raid_bio {
 
 	atomic_t stripes_pending;
 
-	atomic_t error;
+	atomic_unchecked_t error;
 	/*
 	 * these are two arrays of pointers.  We allocate the
 	 * rbio big enough to hold them both and setup their
@@ -916,7 +916,7 @@ static void raid_write_end_io(struct bio *bio)
 	/* OK, we have read all the stripes we need to. */
 	max_errors = (rbio->operation == BTRFS_RBIO_PARITY_SCRUB) ?
 		     0 : rbio->bbio->max_errors;
-	if (atomic_read(&rbio->error) > max_errors)
+	if (atomic_read_unchecked(&rbio->error) > max_errors)
 		err = -EIO;
 
 	rbio_orig_end_io(rbio, err);
@@ -999,7 +999,7 @@ static struct btrfs_raid_bio *alloc_rbio(struct btrfs_root *root,
 	rbio->faila = -1;
 	rbio->failb = -1;
 	atomic_set(&rbio->refs, 1);
-	atomic_set(&rbio->error, 0);
+	atomic_set_unchecked(&rbio->error, 0);
 	atomic_set(&rbio->stripes_pending, 0);
 
 	/*
@@ -1208,7 +1208,7 @@ static noinline void finish_rmw(struct btrfs_raid_bio *rbio)
 	set_bit(RBIO_RMW_LOCKED_BIT, &rbio->flags);
 	spin_unlock_irq(&rbio->bio_list_lock);
 
-	atomic_set(&rbio->error, 0);
+	atomic_set_unchecked(&rbio->error, 0);
 
 	/*
 	 * now that we've set rmw_locked, run through the
@@ -1398,11 +1398,11 @@ static int fail_rbio_index(struct btrfs_raid_bio *rbio, int failed)
 	if (rbio->faila == -1) {
 		/* first failure on this rbio */
 		rbio->faila = failed;
-		atomic_inc(&rbio->error);
+		atomic_inc_unchecked(&rbio->error);
 	} else if (rbio->failb == -1) {
 		/* second failure on this rbio */
 		rbio->failb = failed;
-		atomic_inc(&rbio->error);
+		atomic_inc_unchecked(&rbio->error);
 	} else {
 		ret = -EIO;
 	}
@@ -1464,7 +1464,7 @@ static void raid_rmw_end_io(struct bio *bio)
 	if (!atomic_dec_and_test(&rbio->stripes_pending))
 		return;
 
-	if (atomic_read(&rbio->error) > rbio->bbio->max_errors)
+	if (atomic_read_unchecked(&rbio->error) > rbio->bbio->max_errors)
 		goto cleanup;
 
 	/*
@@ -1519,7 +1519,7 @@ static int raid56_rmw_stripe(struct btrfs_raid_bio *rbio)
 
 	index_rbio_pages(rbio);
 
-	atomic_set(&rbio->error, 0);
+	atomic_set_unchecked(&rbio->error, 0);
 	/*
 	 * build a list of bios to read all the missing parts of this
 	 * stripe
@@ -2012,7 +2012,7 @@ static void raid_recover_end_io(struct bio *bio)
 	if (!atomic_dec_and_test(&rbio->stripes_pending))
 		return;
 
-	if (atomic_read(&rbio->error) > rbio->bbio->max_errors)
+	if (atomic_read_unchecked(&rbio->error) > rbio->bbio->max_errors)
 		rbio_orig_end_io(rbio, -EIO);
 	else
 		__raid_recover_end_io(rbio);
@@ -2041,7 +2041,7 @@ static int __raid56_parity_recover(struct btrfs_raid_bio *rbio)
 	if (ret)
 		goto cleanup;
 
-	atomic_set(&rbio->error, 0);
+	atomic_set_unchecked(&rbio->error, 0);
 
 	/*
 	 * read everything that hasn't failed.  Thanks to the
@@ -2050,7 +2050,7 @@ static int __raid56_parity_recover(struct btrfs_raid_bio *rbio)
 	 */
 	for (stripe = 0; stripe < rbio->real_stripes; stripe++) {
 		if (rbio->faila == stripe || rbio->failb == stripe) {
-			atomic_inc(&rbio->error);
+			atomic_inc_unchecked(&rbio->error);
 			continue;
 		}
 
@@ -2080,7 +2080,7 @@ static int __raid56_parity_recover(struct btrfs_raid_bio *rbio)
 		 * were up to date, or we might have no bios to read because
 		 * the devices were gone.
 		 */
-		if (atomic_read(&rbio->error) <= rbio->bbio->max_errors) {
+		if (atomic_read_unchecked(&rbio->error) <= rbio->bbio->max_errors) {
 			__raid_recover_end_io(rbio);
 			goto out;
 		} else {
@@ -2342,7 +2342,7 @@ static noinline void finish_parity_scrub(struct btrfs_raid_bio *rbio,
 		SetPageUptodate(q_page);
 	}
 
-	atomic_set(&rbio->error, 0);
+	atomic_set_unchecked(&rbio->error, 0);
 
 	for_each_set_bit(pagenr, rbio->dbitmap, rbio->stripe_npages) {
 		struct page *p;
@@ -2463,7 +2463,7 @@ static inline int is_data_stripe(struct btrfs_raid_bio *rbio, int stripe)
  */
 static void validate_rbio_for_parity_scrub(struct btrfs_raid_bio *rbio)
 {
-	if (atomic_read(&rbio->error) > rbio->bbio->max_errors)
+	if (atomic_read_unchecked(&rbio->error) > rbio->bbio->max_errors)
 		goto cleanup;
 
 	if (rbio->faila >= 0 || rbio->failb >= 0) {
@@ -2560,7 +2560,7 @@ static void raid56_parity_scrub_stripe(struct btrfs_raid_bio *rbio)
 
 	bio_list_init(&bio_list);
 
-	atomic_set(&rbio->error, 0);
+	atomic_set_unchecked(&rbio->error, 0);
 	/*
 	 * build a list of bios to read all the missing parts of this
 	 * stripe
diff --git a/fs/btrfs/scrub.c b/fs/btrfs/scrub.c
index 1d195d2b3..9d9cfa9fe 100644
--- a/fs/btrfs/scrub.c
+++ b/fs/btrfs/scrub.c
@@ -3720,7 +3720,7 @@ int scrub_enumerate_chunks(struct scrub_ctx *sctx,
 		if (ret)
 			break;
 		if (is_dev_replace &&
-		    atomic64_read(&dev_replace->num_write_errors) > 0) {
+		    atomic64_read_unchecked(&dev_replace->num_write_errors) > 0) {
 			ret = -EIO;
 			break;
 		}
diff --git a/fs/btrfs/super.c b/fs/btrfs/super.c
index 4071fe2bd..caa5e0ef4 100644
--- a/fs/btrfs/super.c
+++ b/fs/btrfs/super.c
@@ -268,7 +268,7 @@ void __btrfs_abort_transaction(struct btrfs_trans_handle *trans,
 		           function, line, errstr);
 		return;
 	}
-	ACCESS_ONCE(trans->transaction->aborted) = errno;
+	ACCESS_ONCE_RW(trans->transaction->aborted) = errno;
 	/* Wake up anybody who may be waiting on this transaction */
 	wake_up(&fs_info->transaction_wait);
 	wake_up(&fs_info->transaction_blocked_wait);
diff --git a/fs/btrfs/sysfs.c b/fs/btrfs/sysfs.c
index c6569905d..e86b7cc24 100644
--- a/fs/btrfs/sysfs.c
+++ b/fs/btrfs/sysfs.c
@@ -497,7 +497,7 @@ static int addrm_unknown_feature_attrs(struct btrfs_fs_info *fs_info, bool add)
 	for (set = 0; set < FEAT_MAX; set++) {
 		int i;
 		struct attribute *attrs[2];
-		struct attribute_group agroup = {
+		attribute_group_no_const agroup = {
 			.name = "features",
 			.attrs = attrs,
 		};
diff --git a/fs/btrfs/tests/btrfs-tests.c b/fs/btrfs/tests/btrfs-tests.c
index bf62ad919..9bb3ee87a 100644
--- a/fs/btrfs/tests/btrfs-tests.c
+++ b/fs/btrfs/tests/btrfs-tests.c
@@ -119,7 +119,7 @@ struct btrfs_fs_info *btrfs_alloc_dummy_fs_info(void)
 	fs_info->running_transaction = NULL;
 	fs_info->qgroup_tree = RB_ROOT;
 	fs_info->qgroup_ulist = NULL;
-	atomic64_set(&fs_info->tree_mod_seq, 0);
+	atomic64_set_unchecked(&fs_info->tree_mod_seq, 0);
 	INIT_LIST_HEAD(&fs_info->dirty_qgroups);
 	INIT_LIST_HEAD(&fs_info->dead_roots);
 	INIT_LIST_HEAD(&fs_info->tree_mod_seq_list);
diff --git a/fs/btrfs/tests/free-space-tests.c b/fs/btrfs/tests/free-space-tests.c
index 3221c8dee..8fe6170e2 100644
--- a/fs/btrfs/tests/free-space-tests.c
+++ b/fs/btrfs/tests/free-space-tests.c
@@ -409,7 +409,7 @@ test_steal_space_from_bitmap_to_extent(struct btrfs_block_group_cache *cache,
 	int ret;
 	u64 offset;
 	u64 max_extent_size;
-	const struct btrfs_free_space_op test_free_space_ops = {
+	const btrfs_free_space_op_no_const test_free_space_ops = {
 		.recalc_thresholds = cache->free_space_ctl->op->recalc_thresholds,
 		.use_bitmap = test_use_bitmap,
 	};
diff --git a/fs/btrfs/transaction.c b/fs/btrfs/transaction.c
index 95d41919d..f804459aa 100644
--- a/fs/btrfs/transaction.c
+++ b/fs/btrfs/transaction.c
@@ -277,7 +277,7 @@ loop:
 	if (!RB_EMPTY_ROOT(&fs_info->tree_mod_log))
 		WARN(1, KERN_ERR "BTRFS: tree_mod_log rb tree not empty when "
 			"creating a fresh transaction\n");
-	atomic64_set(&fs_info->tree_mod_seq, 0);
+	atomic64_set_unchecked(&fs_info->tree_mod_seq, 0);
 
 	spin_lock_init(&cur_trans->delayed_refs.lock);
 
diff --git a/fs/btrfs/tree-log.c b/fs/btrfs/tree-log.c
index e63c96ca0..1c65e3b2e 100644
--- a/fs/btrfs/tree-log.c
+++ b/fs/btrfs/tree-log.c
@@ -174,7 +174,7 @@ static int start_log_trans(struct btrfs_trans_handle *trans,
 		root->log_start_pid = current->pid;
 	}
 
-	atomic_inc(&root->log_batch);
+	atomic_inc_unchecked(&root->log_batch);
 	atomic_inc(&root->log_writers);
 	if (ctx) {
 		int index = root->log_transid % 2;
@@ -2768,7 +2768,7 @@ int btrfs_sync_log(struct btrfs_trans_handle *trans,
 		wait_log_commit(root, log_transid - 1);
 
 	while (1) {
-		int batch = atomic_read(&root->log_batch);
+		int batch = atomic_read_unchecked(&root->log_batch);
 		/* when we're on an ssd, just kick the log commit out */
 		if (!btrfs_test_opt(root->fs_info, SSD) &&
 		    test_bit(BTRFS_ROOT_MULTI_LOG_TASKS, &root->state)) {
@@ -2777,7 +2777,7 @@ int btrfs_sync_log(struct btrfs_trans_handle *trans,
 			mutex_lock(&root->log_mutex);
 		}
 		wait_for_writer(root);
-		if (batch == atomic_read(&root->log_batch))
+		if (batch == atomic_read_unchecked(&root->log_batch))
 			break;
 	}
 
@@ -2823,7 +2823,7 @@ int btrfs_sync_log(struct btrfs_trans_handle *trans,
 	btrfs_init_log_ctx(&root_log_ctx, NULL);
 
 	mutex_lock(&log_root_tree->log_mutex);
-	atomic_inc(&log_root_tree->log_batch);
+	atomic_inc_unchecked(&log_root_tree->log_batch);
 	atomic_inc(&log_root_tree->log_writers);
 
 	index2 = log_root_tree->log_transid % 2;
diff --git a/fs/btrfs/tree-log.h b/fs/btrfs/tree-log.h
index ab858e31c..96fd5a1b4 100644
--- a/fs/btrfs/tree-log.h
+++ b/fs/btrfs/tree-log.h
@@ -48,7 +48,7 @@ static inline void btrfs_init_log_ctx(struct btrfs_log_ctx *ctx,
 static inline void btrfs_set_log_full_commit(struct btrfs_fs_info *fs_info,
 					     struct btrfs_trans_handle *trans)
 {
-	ACCESS_ONCE(fs_info->last_trans_log_full_commit) = trans->transid;
+	ACCESS_ONCE_RW(fs_info->last_trans_log_full_commit) = trans->transid;
 }
 
 static inline int btrfs_need_log_full_commit(struct btrfs_fs_info *fs_info,
diff --git a/fs/btrfs/volumes.c b/fs/btrfs/volumes.c
index 7c9c6a4be..00d2c13f6 100644
--- a/fs/btrfs/volumes.c
+++ b/fs/btrfs/volumes.c
@@ -246,7 +246,7 @@ static struct btrfs_device *__alloc_device(void)
 
 	spin_lock_init(&dev->reada_lock);
 	atomic_set(&dev->reada_in_flight, 0);
-	atomic_set(&dev->dev_stats_ccnt, 0);
+	atomic_set_unchecked(&dev->dev_stats_ccnt, 0);
 	btrfs_device_data_ordered_init(dev);
 	INIT_RADIX_TREE(&dev->reada_zones, GFP_NOFS & ~__GFP_DIRECT_RECLAIM);
 	INIT_RADIX_TREE(&dev->reada_extents, GFP_NOFS & ~__GFP_DIRECT_RECLAIM);
@@ -5307,7 +5307,7 @@ static struct btrfs_bio *alloc_btrfs_bio(int total_stripes, int real_stripes)
 		sizeof(u64) * (total_stripes),
 		GFP_NOFS|__GFP_NOFAIL);
 
-	atomic_set(&bbio->error, 0);
+	atomic_set_unchecked(&bbio->error, 0);
 	atomic_set(&bbio->refs, 1);
 
 	return bbio;
@@ -6006,7 +6006,7 @@ static void btrfs_end_bio(struct bio *bio)
 	int is_orig_bio = 0;
 
 	if (bio->bi_error) {
-		atomic_inc(&bbio->error);
+		atomic_inc_unchecked(&bbio->error);
 		if (bio->bi_error == -EIO || bio->bi_error == -EREMOTEIO) {
 			unsigned int stripe_index =
 				btrfs_io_bio(bio)->stripe_index;
@@ -6044,7 +6044,7 @@ static void btrfs_end_bio(struct bio *bio)
 		/* only send an error to the higher layers if it is
 		 * beyond the tolerance of the btrfs bio
 		 */
-		if (atomic_read(&bbio->error) > bbio->max_errors) {
+		if (atomic_read_unchecked(&bbio->error) > bbio->max_errors) {
 			bio->bi_error = -EIO;
 		} else {
 			/*
@@ -6154,7 +6154,7 @@ static void submit_stripe_bio(struct btrfs_root *root, struct btrfs_bio *bbio,
 
 static void bbio_error(struct btrfs_bio *bbio, struct bio *bio, u64 logical)
 {
-	atomic_inc(&bbio->error);
+	atomic_inc_unchecked(&bbio->error);
 	if (atomic_dec_and_test(&bbio->stripes_pending)) {
 		/* Should be the original bio. */
 		WARN_ON(bio != bbio->orig_bio);
@@ -7031,10 +7031,10 @@ int btrfs_run_dev_stats(struct btrfs_trans_handle *trans,
 		if (!device->dev_stats_valid || !btrfs_dev_stats_dirty(device))
 			continue;
 
-		stats_cnt = atomic_read(&device->dev_stats_ccnt);
+		stats_cnt = atomic_read_unchecked(&device->dev_stats_ccnt);
 		ret = update_dev_stat_item(trans, dev_root, device);
 		if (!ret)
-			atomic_sub(stats_cnt, &device->dev_stats_ccnt);
+			atomic_sub_unchecked(stats_cnt, &device->dev_stats_ccnt);
 	}
 	mutex_unlock(&fs_devices->device_list_mutex);
 
diff --git a/fs/btrfs/volumes.h b/fs/btrfs/volumes.h
index 6613e6335..688bc8e25 100644
--- a/fs/btrfs/volumes.h
+++ b/fs/btrfs/volumes.h
@@ -148,8 +148,8 @@ struct btrfs_device {
 	int dev_stats_valid;
 
 	/* Counter to record the change of device stats */
-	atomic_t dev_stats_ccnt;
-	atomic_t dev_stat_values[BTRFS_DEV_STAT_VALUES_MAX];
+	atomic_unchecked_t dev_stats_ccnt;
+	atomic_unchecked_t dev_stat_values[BTRFS_DEV_STAT_VALUES_MAX];
 };
 
 /*
@@ -307,7 +307,7 @@ struct btrfs_bio {
 	struct bio *orig_bio;
 	unsigned long flags;
 	void *private;
-	atomic_t error;
+	atomic_unchecked_t error;
 	int max_errors;
 	int num_stripes;
 	int mirror_num;
@@ -466,21 +466,21 @@ int btrfs_remove_chunk(struct btrfs_trans_handle *trans,
 
 static inline int btrfs_dev_stats_dirty(struct btrfs_device *dev)
 {
-	return atomic_read(&dev->dev_stats_ccnt);
+	return atomic_read_unchecked(&dev->dev_stats_ccnt);
 }
 
 static inline void btrfs_dev_stat_inc(struct btrfs_device *dev,
 				      int index)
 {
-	atomic_inc(dev->dev_stat_values + index);
+	atomic_inc_unchecked(dev->dev_stat_values + index);
 	smp_mb__before_atomic();
-	atomic_inc(&dev->dev_stats_ccnt);
+	atomic_inc_unchecked(&dev->dev_stats_ccnt);
 }
 
 static inline int btrfs_dev_stat_read(struct btrfs_device *dev,
 				      int index)
 {
-	return atomic_read(dev->dev_stat_values + index);
+	return atomic_read_unchecked(dev->dev_stat_values + index);
 }
 
 static inline int btrfs_dev_stat_read_and_reset(struct btrfs_device *dev,
@@ -488,18 +488,18 @@ static inline int btrfs_dev_stat_read_and_reset(struct btrfs_device *dev,
 {
 	int ret;
 
-	ret = atomic_xchg(dev->dev_stat_values + index, 0);
+	ret = atomic_xchg_unchecked(dev->dev_stat_values + index, 0);
 	smp_mb__before_atomic();
-	atomic_inc(&dev->dev_stats_ccnt);
+	atomic_inc_unchecked(&dev->dev_stats_ccnt);
 	return ret;
 }
 
 static inline void btrfs_dev_stat_set(struct btrfs_device *dev,
 				      int index, unsigned long val)
 {
-	atomic_set(dev->dev_stat_values + index, val);
+	atomic_set_unchecked(dev->dev_stat_values + index, val);
 	smp_mb__before_atomic();
-	atomic_inc(&dev->dev_stats_ccnt);
+	atomic_inc_unchecked(&dev->dev_stats_ccnt);
 }
 
 static inline void btrfs_dev_stat_reset(struct btrfs_device *dev,
diff --git a/fs/buffer.c b/fs/buffer.c
index 9c8eb9b6d..236a1ca1c 100644
--- a/fs/buffer.c
+++ b/fs/buffer.c
@@ -3476,7 +3476,7 @@ void __init buffer_init(void)
 	bh_cachep = kmem_cache_create("buffer_head",
 			sizeof(struct buffer_head), 0,
 				(SLAB_RECLAIM_ACCOUNT|SLAB_PANIC|
-				SLAB_MEM_SPREAD),
+				SLAB_MEM_SPREAD|SLAB_NO_SANITIZE),
 				NULL);
 
 	/*
diff --git a/fs/cachefiles/bind.c b/fs/cachefiles/bind.c
index 6af790fc3..ec4c1e69f 100644
--- a/fs/cachefiles/bind.c
+++ b/fs/cachefiles/bind.c
@@ -39,13 +39,11 @@ int cachefiles_daemon_bind(struct cachefiles_cache *cache, char *args)
 	       args);
 
 	/* start by checking things over */
-	ASSERT(cache->fstop_percent >= 0 &&
-	       cache->fstop_percent < cache->fcull_percent &&
+	ASSERT(cache->fstop_percent < cache->fcull_percent &&
 	       cache->fcull_percent < cache->frun_percent &&
 	       cache->frun_percent  < 100);
 
-	ASSERT(cache->bstop_percent >= 0 &&
-	       cache->bstop_percent < cache->bcull_percent &&
+	ASSERT(cache->bstop_percent < cache->bcull_percent &&
 	       cache->bcull_percent < cache->brun_percent &&
 	       cache->brun_percent  < 100);
 
diff --git a/fs/cachefiles/daemon.c b/fs/cachefiles/daemon.c
index 1ee54ffd3..ba897480f 100644
--- a/fs/cachefiles/daemon.c
+++ b/fs/cachefiles/daemon.c
@@ -176,8 +176,8 @@ static ssize_t cachefiles_daemon_read(struct file *file, char __user *_buffer,
 	cachefiles_has_space(cache, 0, 0);
 
 	/* summarise */
-	f_released = atomic_xchg(&cache->f_released, 0);
-	b_released = atomic_long_xchg(&cache->b_released, 0);
+	f_released = atomic_xchg_unchecked(&cache->f_released, 0);
+	b_released = atomic_long_xchg_unchecked(&cache->b_released, 0);
 	clear_bit(CACHEFILES_STATE_CHANGED, &cache->flags);
 
 	n = snprintf(buffer, sizeof(buffer),
@@ -203,7 +203,7 @@ static ssize_t cachefiles_daemon_read(struct file *file, char __user *_buffer,
 	if (n > buflen)
 		return -EMSGSIZE;
 
-	if (copy_to_user(_buffer, buffer, n) != 0)
+	if (n > sizeof(buffer) || copy_to_user(_buffer, buffer, n) != 0)
 		return -EFAULT;
 
 	return n;
@@ -229,7 +229,7 @@ static ssize_t cachefiles_daemon_write(struct file *file,
 	if (test_bit(CACHEFILES_DEAD, &cache->flags))
 		return -EIO;
 
-	if (datalen < 0 || datalen > PAGE_SIZE - 1)
+	if (datalen > PAGE_SIZE - 1)
 		return -EOPNOTSUPP;
 
 	/* drag the command string into the kernel so we can parse it */
@@ -386,7 +386,7 @@ static int cachefiles_daemon_fstop(struct cachefiles_cache *cache, char *args)
 	if (args[0] != '%' || args[1] != '\0')
 		return -EINVAL;
 
-	if (fstop < 0 || fstop >= cache->fcull_percent)
+	if (fstop >= cache->fcull_percent)
 		return cachefiles_daemon_range_error(cache, args);
 
 	cache->fstop_percent = fstop;
@@ -458,7 +458,7 @@ static int cachefiles_daemon_bstop(struct cachefiles_cache *cache, char *args)
 	if (args[0] != '%' || args[1] != '\0')
 		return -EINVAL;
 
-	if (bstop < 0 || bstop >= cache->bcull_percent)
+	if (bstop >= cache->bcull_percent)
 		return cachefiles_daemon_range_error(cache, args);
 
 	cache->bstop_percent = bstop;
diff --git a/fs/cachefiles/internal.h b/fs/cachefiles/internal.h
index cd1effee8..73f876799 100644
--- a/fs/cachefiles/internal.h
+++ b/fs/cachefiles/internal.h
@@ -65,9 +65,9 @@ struct cachefiles_cache {
 	wait_queue_head_t		daemon_pollwq;	/* poll waitqueue for daemon */
 	struct rb_root			active_nodes;	/* active nodes (can't be culled) */
 	rwlock_t			active_lock;	/* lock for active_nodes */
-	atomic_t			gravecounter;	/* graveyard uniquifier */
-	atomic_t			f_released;	/* number of objects released lately */
-	atomic_long_t			b_released;	/* number of blocks released lately */
+	atomic_unchecked_t		gravecounter;	/* graveyard uniquifier */
+	atomic_unchecked_t		f_released;	/* number of objects released lately */
+	atomic_long_unchecked_t		b_released;	/* number of blocks released lately */
 	unsigned			frun_percent;	/* when to stop culling (% files) */
 	unsigned			fcull_percent;	/* when to start culling (% files) */
 	unsigned			fstop_percent;	/* when to stop allocating (% files) */
@@ -182,19 +182,19 @@ extern int cachefiles_check_in_use(struct cachefiles_cache *cache,
  * proc.c
  */
 #ifdef CONFIG_CACHEFILES_HISTOGRAM
-extern atomic_t cachefiles_lookup_histogram[HZ];
-extern atomic_t cachefiles_mkdir_histogram[HZ];
-extern atomic_t cachefiles_create_histogram[HZ];
+extern atomic_unchecked_t cachefiles_lookup_histogram[HZ];
+extern atomic_unchecked_t cachefiles_mkdir_histogram[HZ];
+extern atomic_unchecked_t cachefiles_create_histogram[HZ];
 
 extern int __init cachefiles_proc_init(void);
 extern void cachefiles_proc_cleanup(void);
 static inline
-void cachefiles_hist(atomic_t histogram[], unsigned long start_jif)
+void cachefiles_hist(atomic_unchecked_t histogram[], unsigned long start_jif)
 {
 	unsigned long jif = jiffies - start_jif;
 	if (jif >= HZ)
 		jif = HZ - 1;
-	atomic_inc(&histogram[jif]);
+	atomic_inc_unchecked(&histogram[jif]);
 }
 
 #else
diff --git a/fs/cachefiles/namei.c b/fs/cachefiles/namei.c
index c6ee4b5fb..de05717f1 100644
--- a/fs/cachefiles/namei.c
+++ b/fs/cachefiles/namei.c
@@ -274,8 +274,8 @@ void cachefiles_mark_object_inactive(struct cachefiles_cache *cache,
 	/* This object can now be culled, so we need to let the daemon know
 	 * that there is something it can remove if it needs to.
 	 */
-	atomic_long_add(i_blocks, &cache->b_released);
-	if (atomic_inc_return(&cache->f_released))
+	atomic_long_add_unchecked(i_blocks, &cache->b_released);
+	if (atomic_inc_return_unchecked(&cache->f_released))
 		cachefiles_state_changed(cache);
 }
 
@@ -334,7 +334,7 @@ try_again:
 	/* first step is to make up a grave dentry in the graveyard */
 	sprintf(nbuffer, "%08x%08x",
 		(uint32_t) get_seconds(),
-		(uint32_t) atomic_inc_return(&cache->gravecounter));
+		(uint32_t) atomic_inc_return_unchecked(&cache->gravecounter));
 
 	/* do the multiway lock magic */
 	trap = lock_rename(cache->graveyard, dir);
diff --git a/fs/cachefiles/proc.c b/fs/cachefiles/proc.c
index 125b90f6c..8c7bed556 100644
--- a/fs/cachefiles/proc.c
+++ b/fs/cachefiles/proc.c
@@ -14,9 +14,9 @@
 #include <linux/seq_file.h>
 #include "internal.h"
 
-atomic_t cachefiles_lookup_histogram[HZ];
-atomic_t cachefiles_mkdir_histogram[HZ];
-atomic_t cachefiles_create_histogram[HZ];
+atomic_unchecked_t cachefiles_lookup_histogram[HZ];
+atomic_unchecked_t cachefiles_mkdir_histogram[HZ];
+atomic_unchecked_t cachefiles_create_histogram[HZ];
 
 /*
  * display the latency histogram
@@ -35,9 +35,9 @@ static int cachefiles_histogram_show(struct seq_file *m, void *v)
 		return 0;
 	default:
 		index = (unsigned long) v - 3;
-		x = atomic_read(&cachefiles_lookup_histogram[index]);
-		y = atomic_read(&cachefiles_mkdir_histogram[index]);
-		z = atomic_read(&cachefiles_create_histogram[index]);
+		x = atomic_read_unchecked(&cachefiles_lookup_histogram[index]);
+		y = atomic_read_unchecked(&cachefiles_mkdir_histogram[index]);
+		z = atomic_read_unchecked(&cachefiles_create_histogram[index]);
 		if (x == 0 && y == 0 && z == 0)
 			return 0;
 
diff --git a/fs/ceph/super.c b/fs/ceph/super.c
index e247f6f0f..7c4ed520c 100644
--- a/fs/ceph/super.c
+++ b/fs/ceph/super.c
@@ -933,7 +933,7 @@ static int ceph_compare_super(struct super_block *sb, void *data)
 /*
  * construct our own bdi so we can control readahead, etc.
  */
-static atomic_long_t bdi_seq = ATOMIC_LONG_INIT(0);
+static atomic_long_unchecked_t bdi_seq = ATOMIC_LONG_INIT(0);
 
 static int ceph_register_bdi(struct super_block *sb,
 			     struct ceph_fs_client *fsc)
@@ -950,7 +950,7 @@ static int ceph_register_bdi(struct super_block *sb,
 			VM_MAX_READAHEAD * 1024 / PAGE_SIZE;
 
 	err = bdi_register(&fsc->backing_dev_info, NULL, "ceph-%ld",
-			   atomic_long_inc_return(&bdi_seq));
+			   atomic_long_inc_return_unchecked(&bdi_seq));
 	if (!err)
 		sb->s_bdi = &fsc->backing_dev_info;
 	return err;
diff --git a/fs/char_dev.c b/fs/char_dev.c
index 6edd82523..e8cbd2d1b 100644
--- a/fs/char_dev.c
+++ b/fs/char_dev.c
@@ -70,7 +70,7 @@ void chrdev_show(struct seq_file *f, off_t offset)
  *
  * Returns a -ve errno on failure.
  */
-static struct char_device_struct *
+static __nocapture(4) struct char_device_struct *
 __register_chrdev_region(unsigned int major, unsigned int baseminor,
 			   int minorct, const char *name)
 {
diff --git a/fs/cifs/cifs_debug.c b/fs/cifs/cifs_debug.c
index 3d03e48a9..0f2246384 100644
--- a/fs/cifs/cifs_debug.c
+++ b/fs/cifs/cifs_debug.c
@@ -265,8 +265,8 @@ static ssize_t cifs_stats_proc_write(struct file *file,
 	rc = kstrtobool_from_user(buffer, count, &bv);
 	if (rc == 0) {
 #ifdef CONFIG_CIFS_STATS2
-		atomic_set(&totBufAllocCount, 0);
-		atomic_set(&totSmBufAllocCount, 0);
+		atomic_set_unchecked(&totBufAllocCount, 0);
+		atomic_set_unchecked(&totSmBufAllocCount, 0);
 #endif /* CONFIG_CIFS_STATS2 */
 		spin_lock(&cifs_tcp_ses_lock);
 		list_for_each(tmp1, &cifs_tcp_ses_list) {
@@ -279,7 +279,7 @@ static ssize_t cifs_stats_proc_write(struct file *file,
 					tcon = list_entry(tmp3,
 							  struct cifs_tcon,
 							  tcon_list);
-					atomic_set(&tcon->num_smbs_sent, 0);
+					atomic_set_unchecked(&tcon->num_smbs_sent, 0);
 					if (server->ops->clear_stats)
 						server->ops->clear_stats(tcon);
 				}
@@ -313,8 +313,8 @@ static int cifs_stats_proc_show(struct seq_file *m, void *v)
 			smBufAllocCount.counter, cifs_min_small);
 #ifdef CONFIG_CIFS_STATS2
 	seq_printf(m, "Total Large %d Small %d Allocations\n",
-				atomic_read(&totBufAllocCount),
-				atomic_read(&totSmBufAllocCount));
+				atomic_read_unchecked(&totBufAllocCount),
+				atomic_read_unchecked(&totSmBufAllocCount));
 #endif /* CONFIG_CIFS_STATS2 */
 
 	seq_printf(m, "Operations (MIDs): %d\n", atomic_read(&midCount));
@@ -343,7 +343,7 @@ static int cifs_stats_proc_show(struct seq_file *m, void *v)
 				if (tcon->need_reconnect)
 					seq_puts(m, "\tDISCONNECTED ");
 				seq_printf(m, "\nSMBs: %d",
-					   atomic_read(&tcon->num_smbs_sent));
+					   atomic_read_unchecked(&tcon->num_smbs_sent));
 				if (server->ops->print_stats)
 					server->ops->print_stats(m, tcon);
 			}
diff --git a/fs/cifs/cifsfs.c b/fs/cifs/cifsfs.c
index 8c68d03a6..267f6dd21 100644
--- a/fs/cifs/cifsfs.c
+++ b/fs/cifs/cifsfs.c
@@ -1148,9 +1148,10 @@ cifs_init_request_bufs(void)
 	cifs_dbg(VFS, "CIFSMaxBufSize %d 0x%x\n",
 		 CIFSMaxBufSize, CIFSMaxBufSize);
 */
-	cifs_req_cachep = kmem_cache_create("cifs_request",
+	cifs_req_cachep = kmem_cache_create_usercopy("cifs_request",
 					    CIFSMaxBufSize + max_hdr_size, 0,
-					    SLAB_HWCACHE_ALIGN, NULL);
+					    SLAB_HWCACHE_ALIGN, 0,
+					    CIFSMaxBufSize + max_hdr_size, NULL);
 	if (cifs_req_cachep == NULL)
 		return -ENOMEM;
 
@@ -1176,9 +1177,9 @@ cifs_init_request_bufs(void)
 	more SMBs to use small buffer alloc and is still much more
 	efficient to alloc 1 per page off the slab compared to 17K (5page)
 	alloc of large cifs buffers even when page debugging is on */
-	cifs_sm_req_cachep = kmem_cache_create("cifs_small_rq",
+	cifs_sm_req_cachep = kmem_cache_create_usercopy("cifs_small_rq",
 			MAX_CIFS_SMALL_BUFFER_SIZE, 0, SLAB_HWCACHE_ALIGN,
-			NULL);
+			0, MAX_CIFS_SMALL_BUFFER_SIZE, NULL);
 	if (cifs_sm_req_cachep == NULL) {
 		mempool_destroy(cifs_req_poolp);
 		kmem_cache_destroy(cifs_req_cachep);
@@ -1262,8 +1263,8 @@ init_cifs(void)
 	atomic_set(&bufAllocCount, 0);
 	atomic_set(&smBufAllocCount, 0);
 #ifdef CONFIG_CIFS_STATS2
-	atomic_set(&totBufAllocCount, 0);
-	atomic_set(&totSmBufAllocCount, 0);
+	atomic_set_unchecked(&totBufAllocCount, 0);
+	atomic_set_unchecked(&totSmBufAllocCount, 0);
 #endif /* CONFIG_CIFS_STATS2 */
 
 	atomic_set(&midCount, 0);
diff --git a/fs/cifs/cifsglob.h b/fs/cifs/cifsglob.h
index 24184cae8..97d623c24 100644
--- a/fs/cifs/cifsglob.h
+++ b/fs/cifs/cifsglob.h
@@ -845,35 +845,35 @@ struct cifs_tcon {
 	__u16 Flags;		/* optional support bits */
 	enum statusEnum tidStatus;
 #ifdef CONFIG_CIFS_STATS
-	atomic_t num_smbs_sent;
+	atomic_unchecked_t num_smbs_sent;
 	union {
 		struct {
-			atomic_t num_writes;
-			atomic_t num_reads;
-			atomic_t num_flushes;
-			atomic_t num_oplock_brks;
-			atomic_t num_opens;
-			atomic_t num_closes;
-			atomic_t num_deletes;
-			atomic_t num_mkdirs;
-			atomic_t num_posixopens;
-			atomic_t num_posixmkdirs;
-			atomic_t num_rmdirs;
-			atomic_t num_renames;
-			atomic_t num_t2renames;
-			atomic_t num_ffirst;
-			atomic_t num_fnext;
-			atomic_t num_fclose;
-			atomic_t num_hardlinks;
-			atomic_t num_symlinks;
-			atomic_t num_locks;
-			atomic_t num_acl_get;
-			atomic_t num_acl_set;
+			atomic_unchecked_t num_writes;
+			atomic_unchecked_t num_reads;
+			atomic_unchecked_t num_flushes;
+			atomic_unchecked_t num_oplock_brks;
+			atomic_unchecked_t num_opens;
+			atomic_unchecked_t num_closes;
+			atomic_unchecked_t num_deletes;
+			atomic_unchecked_t num_mkdirs;
+			atomic_unchecked_t num_posixopens;
+			atomic_unchecked_t num_posixmkdirs;
+			atomic_unchecked_t num_rmdirs;
+			atomic_unchecked_t num_renames;
+			atomic_unchecked_t num_t2renames;
+			atomic_unchecked_t num_ffirst;
+			atomic_unchecked_t num_fnext;
+			atomic_unchecked_t num_fclose;
+			atomic_unchecked_t num_hardlinks;
+			atomic_unchecked_t num_symlinks;
+			atomic_unchecked_t num_locks;
+			atomic_unchecked_t num_acl_get;
+			atomic_unchecked_t num_acl_set;
 		} cifs_stats;
 #ifdef CONFIG_CIFS_SMB2
 		struct {
-			atomic_t smb2_com_sent[NUMBER_OF_SMB2_COMMANDS];
-			atomic_t smb2_com_failed[NUMBER_OF_SMB2_COMMANDS];
+			atomic_unchecked_t smb2_com_sent[NUMBER_OF_SMB2_COMMANDS];
+			atomic_unchecked_t smb2_com_failed[NUMBER_OF_SMB2_COMMANDS];
 		} smb2_stats;
 #endif /* CONFIG_CIFS_SMB2 */
 	} stats;
@@ -1226,7 +1226,7 @@ convert_delimiter(char *path, char delim)
 }
 
 #ifdef CONFIG_CIFS_STATS
-#define cifs_stats_inc atomic_inc
+#define cifs_stats_inc atomic_inc_unchecked
 
 static inline void cifs_stats_bytes_written(struct cifs_tcon *tcon,
 					    unsigned int bytes)
@@ -1589,8 +1589,8 @@ GLOBAL_EXTERN atomic_t tconInfoReconnectCount;
 /* Various Debug counters */
 GLOBAL_EXTERN atomic_t bufAllocCount;    /* current number allocated  */
 #ifdef CONFIG_CIFS_STATS2
-GLOBAL_EXTERN atomic_t totBufAllocCount; /* total allocated over all time */
-GLOBAL_EXTERN atomic_t totSmBufAllocCount;
+GLOBAL_EXTERN atomic_unchecked_t totBufAllocCount; /* total allocated over all time */
+GLOBAL_EXTERN atomic_unchecked_t totSmBufAllocCount;
 #endif
 GLOBAL_EXTERN atomic_t smBufAllocCount;
 GLOBAL_EXTERN atomic_t midCount;
diff --git a/fs/cifs/file.c b/fs/cifs/file.c
index 605438afe..b8185c27c 100644
--- a/fs/cifs/file.c
+++ b/fs/cifs/file.c
@@ -1386,7 +1386,7 @@ cifs_free_llist(struct list_head *llist)
 
 int
 cifs_unlock_range(struct cifsFileInfo *cfile, struct file_lock *flock,
-		  unsigned int xid)
+		  const unsigned int xid)
 {
 	int rc = 0, stored_rc;
 	int types[] = {LOCKING_ANDX_LARGE_FILES,
@@ -2072,10 +2072,14 @@ static int cifs_writepages(struct address_space *mapping,
 		index = mapping->writeback_index; /* Start from prev offset */
 		end = -1;
 	} else {
-		index = wbc->range_start >> PAGE_SHIFT;
-		end = wbc->range_end >> PAGE_SHIFT;
-		if (wbc->range_start == 0 && wbc->range_end == LLONG_MAX)
+		if (wbc->range_start == 0 && wbc->range_end == LLONG_MAX) {
 			range_whole = true;
+			index = 0;
+			end = ULONG_MAX;
+		} else {
+			index = wbc->range_start >> PAGE_SHIFT;
+			end = wbc->range_end >> PAGE_SHIFT;
+		}
 		scanned = true;
 	}
 	server = cifs_sb_master_tcon(cifs_sb)->ses->server;
@@ -2549,7 +2553,7 @@ cifs_write_from_iter(loff_t offset, size_t len, struct iov_iter *from,
 		wdata->pid = pid;
 		wdata->bytes = cur_len;
 		wdata->pagesz = PAGE_SIZE;
-		wdata->tailsz = cur_len - ((nr_pages - 1) * PAGE_SIZE);
+		wdata->tailsz = cur_len - nr_pages * PAGE_SIZE + PAGE_SIZE;
 		wdata->credits = credits;
 
 		if (!wdata->cfile->invalidHandle ||
diff --git a/fs/cifs/misc.c b/fs/cifs/misc.c
index c6729156f..bea28bc83 100644
--- a/fs/cifs/misc.c
+++ b/fs/cifs/misc.c
@@ -171,7 +171,7 @@ cifs_buf_get(void)
 		memset(ret_buf, 0, buf_size + 3);
 		atomic_inc(&bufAllocCount);
 #ifdef CONFIG_CIFS_STATS2
-		atomic_inc(&totBufAllocCount);
+		atomic_inc_unchecked(&totBufAllocCount);
 #endif /* CONFIG_CIFS_STATS2 */
 	}
 
@@ -206,7 +206,7 @@ cifs_small_buf_get(void)
 	/*	memset(ret_buf, 0, sizeof(struct smb_hdr) + 27);*/
 		atomic_inc(&smBufAllocCount);
 #ifdef CONFIG_CIFS_STATS2
-		atomic_inc(&totSmBufAllocCount);
+		atomic_inc_unchecked(&totSmBufAllocCount);
 #endif /* CONFIG_CIFS_STATS2 */
 
 	}
diff --git a/fs/cifs/smb1ops.c b/fs/cifs/smb1ops.c
index fc537c290..47d654c7b 100644
--- a/fs/cifs/smb1ops.c
+++ b/fs/cifs/smb1ops.c
@@ -622,27 +622,27 @@ static void
 cifs_clear_stats(struct cifs_tcon *tcon)
 {
 #ifdef CONFIG_CIFS_STATS
-	atomic_set(&tcon->stats.cifs_stats.num_writes, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_reads, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_flushes, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_oplock_brks, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_opens, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_posixopens, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_posixmkdirs, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_closes, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_deletes, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_mkdirs, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_rmdirs, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_renames, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_t2renames, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_ffirst, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_fnext, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_fclose, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_hardlinks, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_symlinks, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_locks, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_acl_get, 0);
-	atomic_set(&tcon->stats.cifs_stats.num_acl_set, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_writes, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_reads, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_flushes, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_oplock_brks, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_opens, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_posixopens, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_posixmkdirs, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_closes, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_deletes, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_mkdirs, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_rmdirs, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_renames, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_t2renames, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_ffirst, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_fnext, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_fclose, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_hardlinks, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_symlinks, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_locks, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_acl_get, 0);
+	atomic_set_unchecked(&tcon->stats.cifs_stats.num_acl_set, 0);
 #endif
 }
 
@@ -651,36 +651,36 @@ cifs_print_stats(struct seq_file *m, struct cifs_tcon *tcon)
 {
 #ifdef CONFIG_CIFS_STATS
 	seq_printf(m, " Oplocks breaks: %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_oplock_brks));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_oplock_brks));
 	seq_printf(m, "\nReads:  %d Bytes: %llu",
-		   atomic_read(&tcon->stats.cifs_stats.num_reads),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_reads),
 		   (long long)(tcon->bytes_read));
 	seq_printf(m, "\nWrites: %d Bytes: %llu",
-		   atomic_read(&tcon->stats.cifs_stats.num_writes),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_writes),
 		   (long long)(tcon->bytes_written));
 	seq_printf(m, "\nFlushes: %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_flushes));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_flushes));
 	seq_printf(m, "\nLocks: %d HardLinks: %d Symlinks: %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_locks),
-		   atomic_read(&tcon->stats.cifs_stats.num_hardlinks),
-		   atomic_read(&tcon->stats.cifs_stats.num_symlinks));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_locks),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_hardlinks),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_symlinks));
 	seq_printf(m, "\nOpens: %d Closes: %d Deletes: %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_opens),
-		   atomic_read(&tcon->stats.cifs_stats.num_closes),
-		   atomic_read(&tcon->stats.cifs_stats.num_deletes));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_opens),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_closes),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_deletes));
 	seq_printf(m, "\nPosix Opens: %d Posix Mkdirs: %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_posixopens),
-		   atomic_read(&tcon->stats.cifs_stats.num_posixmkdirs));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_posixopens),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_posixmkdirs));
 	seq_printf(m, "\nMkdirs: %d Rmdirs: %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_mkdirs),
-		   atomic_read(&tcon->stats.cifs_stats.num_rmdirs));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_mkdirs),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_rmdirs));
 	seq_printf(m, "\nRenames: %d T2 Renames %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_renames),
-		   atomic_read(&tcon->stats.cifs_stats.num_t2renames));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_renames),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_t2renames));
 	seq_printf(m, "\nFindFirst: %d FNext %d FClose %d",
-		   atomic_read(&tcon->stats.cifs_stats.num_ffirst),
-		   atomic_read(&tcon->stats.cifs_stats.num_fnext),
-		   atomic_read(&tcon->stats.cifs_stats.num_fclose));
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_ffirst),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_fnext),
+		   atomic_read_unchecked(&tcon->stats.cifs_stats.num_fclose));
 #endif
 }
 
diff --git a/fs/cifs/smb2ops.c b/fs/cifs/smb2ops.c
index 0e73cefca..e4dba34cd 100644
--- a/fs/cifs/smb2ops.c
+++ b/fs/cifs/smb2ops.c
@@ -427,8 +427,8 @@ smb2_clear_stats(struct cifs_tcon *tcon)
 #ifdef CONFIG_CIFS_STATS
 	int i;
 	for (i = 0; i < NUMBER_OF_SMB2_COMMANDS; i++) {
-		atomic_set(&tcon->stats.smb2_stats.smb2_com_sent[i], 0);
-		atomic_set(&tcon->stats.smb2_stats.smb2_com_failed[i], 0);
+		atomic_set_unchecked(&tcon->stats.smb2_stats.smb2_com_sent[i], 0);
+		atomic_set_unchecked(&tcon->stats.smb2_stats.smb2_com_failed[i], 0);
 	}
 #endif
 }
@@ -468,65 +468,65 @@ static void
 smb2_print_stats(struct seq_file *m, struct cifs_tcon *tcon)
 {
 #ifdef CONFIG_CIFS_STATS
-	atomic_t *sent = tcon->stats.smb2_stats.smb2_com_sent;
-	atomic_t *failed = tcon->stats.smb2_stats.smb2_com_failed;
+	atomic_unchecked_t *sent = tcon->stats.smb2_stats.smb2_com_sent;
+	atomic_unchecked_t *failed = tcon->stats.smb2_stats.smb2_com_failed;
 	seq_printf(m, "\nNegotiates: %d sent %d failed",
-		   atomic_read(&sent[SMB2_NEGOTIATE_HE]),
-		   atomic_read(&failed[SMB2_NEGOTIATE_HE]));
+		   atomic_read_unchecked(&sent[SMB2_NEGOTIATE_HE]),
+		   atomic_read_unchecked(&failed[SMB2_NEGOTIATE_HE]));
 	seq_printf(m, "\nSessionSetups: %d sent %d failed",
-		   atomic_read(&sent[SMB2_SESSION_SETUP_HE]),
-		   atomic_read(&failed[SMB2_SESSION_SETUP_HE]));
+		   atomic_read_unchecked(&sent[SMB2_SESSION_SETUP_HE]),
+		   atomic_read_unchecked(&failed[SMB2_SESSION_SETUP_HE]));
 	seq_printf(m, "\nLogoffs: %d sent %d failed",
-		   atomic_read(&sent[SMB2_LOGOFF_HE]),
-		   atomic_read(&failed[SMB2_LOGOFF_HE]));
+		   atomic_read_unchecked(&sent[SMB2_LOGOFF_HE]),
+		   atomic_read_unchecked(&failed[SMB2_LOGOFF_HE]));
 	seq_printf(m, "\nTreeConnects: %d sent %d failed",
-		   atomic_read(&sent[SMB2_TREE_CONNECT_HE]),
-		   atomic_read(&failed[SMB2_TREE_CONNECT_HE]));
+		   atomic_read_unchecked(&sent[SMB2_TREE_CONNECT_HE]),
+		   atomic_read_unchecked(&failed[SMB2_TREE_CONNECT_HE]));
 	seq_printf(m, "\nTreeDisconnects: %d sent %d failed",
-		   atomic_read(&sent[SMB2_TREE_DISCONNECT_HE]),
-		   atomic_read(&failed[SMB2_TREE_DISCONNECT_HE]));
+		   atomic_read_unchecked(&sent[SMB2_TREE_DISCONNECT_HE]),
+		   atomic_read_unchecked(&failed[SMB2_TREE_DISCONNECT_HE]));
 	seq_printf(m, "\nCreates: %d sent %d failed",
-		   atomic_read(&sent[SMB2_CREATE_HE]),
-		   atomic_read(&failed[SMB2_CREATE_HE]));
+		   atomic_read_unchecked(&sent[SMB2_CREATE_HE]),
+		   atomic_read_unchecked(&failed[SMB2_CREATE_HE]));
 	seq_printf(m, "\nCloses: %d sent %d failed",
-		   atomic_read(&sent[SMB2_CLOSE_HE]),
-		   atomic_read(&failed[SMB2_CLOSE_HE]));
+		   atomic_read_unchecked(&sent[SMB2_CLOSE_HE]),
+		   atomic_read_unchecked(&failed[SMB2_CLOSE_HE]));
 	seq_printf(m, "\nFlushes: %d sent %d failed",
-		   atomic_read(&sent[SMB2_FLUSH_HE]),
-		   atomic_read(&failed[SMB2_FLUSH_HE]));
+		   atomic_read_unchecked(&sent[SMB2_FLUSH_HE]),
+		   atomic_read_unchecked(&failed[SMB2_FLUSH_HE]));
 	seq_printf(m, "\nReads: %d sent %d failed",
-		   atomic_read(&sent[SMB2_READ_HE]),
-		   atomic_read(&failed[SMB2_READ_HE]));
+		   atomic_read_unchecked(&sent[SMB2_READ_HE]),
+		   atomic_read_unchecked(&failed[SMB2_READ_HE]));
 	seq_printf(m, "\nWrites: %d sent %d failed",
-		   atomic_read(&sent[SMB2_WRITE_HE]),
-		   atomic_read(&failed[SMB2_WRITE_HE]));
+		   atomic_read_unchecked(&sent[SMB2_WRITE_HE]),
+		   atomic_read_unchecked(&failed[SMB2_WRITE_HE]));
 	seq_printf(m, "\nLocks: %d sent %d failed",
-		   atomic_read(&sent[SMB2_LOCK_HE]),
-		   atomic_read(&failed[SMB2_LOCK_HE]));
+		   atomic_read_unchecked(&sent[SMB2_LOCK_HE]),
+		   atomic_read_unchecked(&failed[SMB2_LOCK_HE]));
 	seq_printf(m, "\nIOCTLs: %d sent %d failed",
-		   atomic_read(&sent[SMB2_IOCTL_HE]),
-		   atomic_read(&failed[SMB2_IOCTL_HE]));
+		   atomic_read_unchecked(&sent[SMB2_IOCTL_HE]),
+		   atomic_read_unchecked(&failed[SMB2_IOCTL_HE]));
 	seq_printf(m, "\nCancels: %d sent %d failed",
-		   atomic_read(&sent[SMB2_CANCEL_HE]),
-		   atomic_read(&failed[SMB2_CANCEL_HE]));
+		   atomic_read_unchecked(&sent[SMB2_CANCEL_HE]),
+		   atomic_read_unchecked(&failed[SMB2_CANCEL_HE]));
 	seq_printf(m, "\nEchos: %d sent %d failed",
-		   atomic_read(&sent[SMB2_ECHO_HE]),
-		   atomic_read(&failed[SMB2_ECHO_HE]));
+		   atomic_read_unchecked(&sent[SMB2_ECHO_HE]),
+		   atomic_read_unchecked(&failed[SMB2_ECHO_HE]));
 	seq_printf(m, "\nQueryDirectories: %d sent %d failed",
-		   atomic_read(&sent[SMB2_QUERY_DIRECTORY_HE]),
-		   atomic_read(&failed[SMB2_QUERY_DIRECTORY_HE]));
+		   atomic_read_unchecked(&sent[SMB2_QUERY_DIRECTORY_HE]),
+		   atomic_read_unchecked(&failed[SMB2_QUERY_DIRECTORY_HE]));
 	seq_printf(m, "\nChangeNotifies: %d sent %d failed",
-		   atomic_read(&sent[SMB2_CHANGE_NOTIFY_HE]),
-		   atomic_read(&failed[SMB2_CHANGE_NOTIFY_HE]));
+		   atomic_read_unchecked(&sent[SMB2_CHANGE_NOTIFY_HE]),
+		   atomic_read_unchecked(&failed[SMB2_CHANGE_NOTIFY_HE]));
 	seq_printf(m, "\nQueryInfos: %d sent %d failed",
-		   atomic_read(&sent[SMB2_QUERY_INFO_HE]),
-		   atomic_read(&failed[SMB2_QUERY_INFO_HE]));
+		   atomic_read_unchecked(&sent[SMB2_QUERY_INFO_HE]),
+		   atomic_read_unchecked(&failed[SMB2_QUERY_INFO_HE]));
 	seq_printf(m, "\nSetInfos: %d sent %d failed",
-		   atomic_read(&sent[SMB2_SET_INFO_HE]),
-		   atomic_read(&failed[SMB2_SET_INFO_HE]));
+		   atomic_read_unchecked(&sent[SMB2_SET_INFO_HE]),
+		   atomic_read_unchecked(&failed[SMB2_SET_INFO_HE]));
 	seq_printf(m, "\nOplockBreaks: %d sent %d failed",
-		   atomic_read(&sent[SMB2_OPLOCK_BREAK_HE]),
-		   atomic_read(&failed[SMB2_OPLOCK_BREAK_HE]));
+		   atomic_read_unchecked(&sent[SMB2_OPLOCK_BREAK_HE]),
+		   atomic_read_unchecked(&failed[SMB2_OPLOCK_BREAK_HE]));
 #endif
 }
 
diff --git a/fs/cifs/smb2pdu.c b/fs/cifs/smb2pdu.c
index 32e0e06f9..236644e32 100644
--- a/fs/cifs/smb2pdu.c
+++ b/fs/cifs/smb2pdu.c
@@ -2457,8 +2457,7 @@ SMB2_query_directory(const unsigned int xid, struct cifs_tcon *tcon,
 	default:
 		cifs_dbg(VFS, "info level %u isn't supported\n",
 			 srch_inf->info_level);
-		rc = -EINVAL;
-		goto qdir_exit;
+		return -EINVAL;
 	}
 
 	req->FileIndex = cpu_to_le32(index);
diff --git a/fs/coda/cache.c b/fs/coda/cache.c
index 5bb630a76..043dc7026 100644
--- a/fs/coda/cache.c
+++ b/fs/coda/cache.c
@@ -24,7 +24,7 @@
 #include "coda_linux.h"
 #include "coda_cache.h"
 
-static atomic_t permission_epoch = ATOMIC_INIT(0);
+static atomic_unchecked_t permission_epoch = ATOMIC_INIT(0);
 
 /* replace or extend an acl cache hit */
 void coda_cache_enter(struct inode *inode, int mask)
@@ -32,7 +32,7 @@ void coda_cache_enter(struct inode *inode, int mask)
 	struct coda_inode_info *cii = ITOC(inode);
 
 	spin_lock(&cii->c_lock);
-	cii->c_cached_epoch = atomic_read(&permission_epoch);
+	cii->c_cached_epoch = atomic_read_unchecked(&permission_epoch);
 	if (!uid_eq(cii->c_uid, current_fsuid())) {
 		cii->c_uid = current_fsuid();
                 cii->c_cached_perm = mask;
@@ -46,14 +46,14 @@ void coda_cache_clear_inode(struct inode *inode)
 {
 	struct coda_inode_info *cii = ITOC(inode);
 	spin_lock(&cii->c_lock);
-	cii->c_cached_epoch = atomic_read(&permission_epoch) - 1;
+	cii->c_cached_epoch = atomic_read_unchecked(&permission_epoch) - 1;
 	spin_unlock(&cii->c_lock);
 }
 
 /* remove all acl caches */
 void coda_cache_clear_all(struct super_block *sb)
 {
-	atomic_inc(&permission_epoch);
+	atomic_inc_unchecked(&permission_epoch);
 }
 
 
@@ -66,7 +66,7 @@ int coda_cache_check(struct inode *inode, int mask)
 	spin_lock(&cii->c_lock);
 	hit = (mask & cii->c_cached_perm) == mask &&
 	    uid_eq(cii->c_uid, current_fsuid()) &&
-	    cii->c_cached_epoch == atomic_read(&permission_epoch);
+	    cii->c_cached_epoch == atomic_read_unchecked(&permission_epoch);
 	spin_unlock(&cii->c_lock);
 
 	return hit;
diff --git a/fs/coda/dir.c b/fs/coda/dir.c
index 6fb8672c0..da34e6a4d 100644
--- a/fs/coda/dir.c
+++ b/fs/coda/dir.c
@@ -29,11 +29,10 @@
 #include "coda_int.h"
 
 /* same as fs/bad_inode.c */
-static int coda_return_EIO(void)
+static int coda_mknod(struct inode *inode, struct dentry *dentry, umode_t mode, dev_t dev)
 {
 	return -EIO;
 }
-#define CODA_EIO_ERROR ((void *) (coda_return_EIO))
 
 /* inode operations for directories */
 /* access routines: lookup, readlink, permission */
@@ -568,7 +567,7 @@ const struct inode_operations coda_dir_inode_operations = {
 	.symlink	= coda_symlink,
 	.mkdir		= coda_mkdir,
 	.rmdir		= coda_rmdir,
-	.mknod		= CODA_EIO_ERROR,
+	.mknod		= coda_mknod,
 	.rename		= coda_rename,
 	.permission	= coda_permission,
 	.getattr	= coda_getattr,
diff --git a/fs/compat.c b/fs/compat.c
index be6e48b0a..f7baebf9b 100644
--- a/fs/compat.c
+++ b/fs/compat.c
@@ -54,7 +54,7 @@
 #include <asm/ioctls.h>
 #include "internal.h"
 
-int compat_log = 1;
+int compat_log = 0;
 
 int compat_printk(const char *fmt, ...)
 {
@@ -512,7 +512,7 @@ COMPAT_SYSCALL_DEFINE2(io_setup, unsigned, nr_reqs, u32 __user *, ctx32p)
 
 	set_fs(KERNEL_DS);
 	/* The __user pointer cast is valid because of the set_fs() */
-	ret = sys_io_setup(nr_reqs, (aio_context_t __user *) &ctx64);
+	ret = sys_io_setup(nr_reqs, (aio_context_t __force_user *) &ctx64);
 	set_fs(oldfs);
 	/* truncating is ok because it's a user address */
 	if (!ret)
@@ -562,7 +562,7 @@ ssize_t compat_rw_copy_check_uvector(int type,
 		goto out;
 
 	ret = -EINVAL;
-	if (nr_segs > UIO_MAXIOV || nr_segs < 0)
+	if (nr_segs > UIO_MAXIOV)
 		goto out;
 	if (nr_segs > fast_segs) {
 		ret = -ENOMEM;
@@ -843,6 +843,7 @@ struct compat_old_linux_dirent {
 struct compat_readdir_callback {
 	struct dir_context ctx;
 	struct compat_old_linux_dirent __user *dirent;
+	struct file * file;
 	int result;
 };
 
@@ -862,6 +863,10 @@ static int compat_fillonedir(struct dir_context *ctx, const char *name,
 		buf->result = -EOVERFLOW;
 		return -EOVERFLOW;
 	}
+
+	if (!gr_acl_handle_filldir(buf->file, name, namlen, ino))
+		return 0;
+
 	buf->result++;
 	dirent = buf->dirent;
 	if (!access_ok(VERIFY_WRITE, dirent,
@@ -893,6 +898,7 @@ COMPAT_SYSCALL_DEFINE3(old_readdir, unsigned int, fd,
 	if (!f.file)
 		return -EBADF;
 
+	buf.file = f.file;
 	error = iterate_dir(f.file, &buf.ctx);
 	if (buf.result)
 		error = buf.result;
@@ -912,6 +918,7 @@ struct compat_getdents_callback {
 	struct dir_context ctx;
 	struct compat_linux_dirent __user *current_dir;
 	struct compat_linux_dirent __user *previous;
+	struct file * file;
 	int count;
 	int error;
 };
@@ -934,6 +941,10 @@ static int compat_filldir(struct dir_context *ctx, const char *name, int namlen,
 		buf->error = -EOVERFLOW;
 		return -EOVERFLOW;
 	}
+
+	if (!gr_acl_handle_filldir(buf->file, name, namlen, ino))
+		return 0;
+
 	dirent = buf->previous;
 	if (dirent) {
 		if (signal_pending(current))
@@ -981,6 +992,7 @@ COMPAT_SYSCALL_DEFINE3(getdents, unsigned int, fd,
 	if (!f.file)
 		return -EBADF;
 
+	buf.file = f.file;
 	error = iterate_dir(f.file, &buf.ctx);
 	if (error >= 0)
 		error = buf.error;
@@ -1001,6 +1013,7 @@ struct compat_getdents_callback64 {
 	struct dir_context ctx;
 	struct linux_dirent64 __user *current_dir;
 	struct linux_dirent64 __user *previous;
+	struct file * file;
 	int count;
 	int error;
 };
@@ -1019,6 +1032,10 @@ static int compat_filldir64(struct dir_context *ctx, const char *name,
 	buf->error = -EINVAL;	/* only used if we fail.. */
 	if (reclen > buf->count)
 		return -EINVAL;
+
+	if (!gr_acl_handle_filldir(buf->file, name, namlen, ino))
+		return 0;
+
 	dirent = buf->previous;
 
 	if (dirent) {
@@ -1070,13 +1087,13 @@ COMPAT_SYSCALL_DEFINE3(getdents64, unsigned int, fd,
 	if (!f.file)
 		return -EBADF;
 
+	buf.file = f.file;
 	error = iterate_dir(f.file, &buf.ctx);
 	if (error >= 0)
 		error = buf.error;
 	lastdirent = buf.previous;
 	if (lastdirent) {
-		typeof(lastdirent->d_off) d_off = buf.ctx.pos;
-		if (__put_user_unaligned(d_off, &lastdirent->d_off))
+		if (__put_user_unaligned(buf.ctx.pos, &lastdirent->d_off))
 			error = -EFAULT;
 		else
 			error = count - buf.count;
@@ -1331,7 +1348,7 @@ COMPAT_SYSCALL_DEFINE5(select, int, n, compat_ulong_t __user *, inp,
 }
 
 struct compat_sel_arg_struct {
-	compat_ulong_t n;
+	compat_long_t n;
 	compat_uptr_t inp;
 	compat_uptr_t outp;
 	compat_uptr_t exp;
diff --git a/fs/compat_binfmt_elf.c b/fs/compat_binfmt_elf.c
index 4d24d17bc..4f8c09e00 100644
--- a/fs/compat_binfmt_elf.c
+++ b/fs/compat_binfmt_elf.c
@@ -30,11 +30,13 @@
 #undef	elf_phdr
 #undef	elf_shdr
 #undef	elf_note
+#undef	elf_dyn
 #undef	elf_addr_t
 #define elfhdr		elf32_hdr
 #define elf_phdr	elf32_phdr
 #define elf_shdr	elf32_shdr
 #define elf_note	elf32_note
+#define elf_dyn		Elf32_Dyn
 #define elf_addr_t	Elf32_Addr
 
 /*
diff --git a/fs/compat_ioctl.c b/fs/compat_ioctl.c
index c1e9f29c9..4ea2e52c2 100644
--- a/fs/compat_ioctl.c
+++ b/fs/compat_ioctl.c
@@ -646,7 +646,7 @@ static int serial_struct_ioctl(struct file *file,
 		if (copy_in_user(ss, ss32, offsetof(SS32, iomem_base)) ||
 		    get_user(udata, &ss32->iomem_base))
 			return -EFAULT;
-		iomem_base = compat_ptr(udata);
+		iomem_base = (unsigned char __force_kernel *)compat_ptr(udata);
 		if (put_user(iomem_base, &ss->iomem_base) ||
 		    convert_in_user(&ss32->iomem_reg_shift,
 		      &ss->iomem_reg_shift) ||
@@ -728,8 +728,8 @@ static int do_i2c_rdwr_ioctl(struct file *file,
 	for (i = 0; i < nmsgs; i++) {
 		if (copy_in_user(&tmsgs[i].addr, &umsgs[i].addr, 3*sizeof(u16)))
 			return -EFAULT;
-		if (get_user(datap, &umsgs[i].buf) ||
-		    put_user(compat_ptr(datap), &tmsgs[i].buf))
+		if (get_user(datap, (compat_caddr_t __user *)&umsgs[i].buf) ||
+		    put_user(compat_ptr(datap), (u8 __user * __user *)&tmsgs[i].buf))
 			return -EFAULT;
 	}
 	return do_ioctl(file, cmd, (unsigned long)tdata);
@@ -820,7 +820,7 @@ static int compat_ioctl_preallocate(struct file *file,
 	    copy_in_user(&p->l_len,	&p32->l_len,	sizeof(s64)) ||
 	    copy_in_user(&p->l_sysid,	&p32->l_sysid,	sizeof(s32)) ||
 	    copy_in_user(&p->l_pid,	&p32->l_pid,	sizeof(u32)) ||
-	    copy_in_user(&p->l_pad,	&p32->l_pad,	4*sizeof(u32)))
+	    copy_in_user(p->l_pad,	p32->l_pad,	4*sizeof(u32)))
 		return -EFAULT;
 
 	return ioctl_preallocate(file, p);
@@ -1629,8 +1629,8 @@ COMPAT_SYSCALL_DEFINE3(ioctl, unsigned int, fd, unsigned int, cmd,
 static int __init init_sys32_ioctl_cmp(const void *p, const void *q)
 {
 	unsigned int a, b;
-	a = *(unsigned int *)p;
-	b = *(unsigned int *)q;
+	a = *(const unsigned int *)p;
+	b = *(const unsigned int *)q;
 	if (a > b)
 		return 1;
 	if (a < b)
diff --git a/fs/configfs/dir.c b/fs/configfs/dir.c
index 56fb26127..8c808f18e 100644
--- a/fs/configfs/dir.c
+++ b/fs/configfs/dir.c
@@ -1638,7 +1638,7 @@ static int configfs_readdir(struct file *file, struct dir_context *ctx)
 		list_move(q, &parent_sd->s_children);
 	for (p = q->next; p != &parent_sd->s_children; p = p->next) {
 		struct configfs_dirent *next;
-		const char *name;
+		const unsigned char * name;
 		int len;
 		struct inode *inode = NULL;
 
diff --git a/fs/coredump.c b/fs/coredump.c
index eb9c92c9b..235adec11 100644
--- a/fs/coredump.c
+++ b/fs/coredump.c
@@ -486,8 +486,8 @@ static void wait_for_dump_helpers(struct file *file)
 	struct pipe_inode_info *pipe = file->private_data;
 
 	pipe_lock(pipe);
-	pipe->readers++;
-	pipe->writers--;
+	atomic_inc(&pipe->readers);
+	atomic_dec(&pipe->writers);
 	wake_up_interruptible_sync(&pipe->wait);
 	kill_fasync(&pipe->fasync_readers, SIGIO, POLL_IN);
 	pipe_unlock(pipe);
@@ -496,11 +496,11 @@ static void wait_for_dump_helpers(struct file *file)
 	 * We actually want wait_event_freezable() but then we need
 	 * to clear TIF_SIGPENDING and improve dump_interrupted().
 	 */
-	wait_event_interruptible(pipe->wait, pipe->readers == 1);
+	wait_event_interruptible(pipe->wait, atomic_read(&pipe->readers) == 1);
 
 	pipe_lock(pipe);
-	pipe->readers--;
-	pipe->writers++;
+	atomic_dec(&pipe->readers);
+	atomic_inc(&pipe->writers);
 	pipe_unlock(pipe);
 }
 
@@ -547,7 +547,9 @@ void do_coredump(const siginfo_t *siginfo)
 	/* require nonrelative corefile path and be extra careful */
 	bool need_suid_safe = false;
 	bool core_dumped = false;
-	static atomic_t core_dump_count = ATOMIC_INIT(0);
+	static atomic_unchecked_t core_dump_count = ATOMIC_INIT(0);
+	long signr = siginfo->si_signo;
+	int dumpable;
 	struct coredump_params cprm = {
 		.siginfo = siginfo,
 		.regs = signal_pt_regs(),
@@ -560,12 +562,14 @@ void do_coredump(const siginfo_t *siginfo)
 		.mm_flags = mm->flags,
 	};
 
-	audit_core_dumps(siginfo->si_signo);
+	audit_core_dumps(signr);
+
+	dumpable = __get_dumpable(cprm.mm_flags);
 
 	binfmt = mm->binfmt;
 	if (!binfmt || !binfmt->core_dump)
 		goto fail;
-	if (!__get_dumpable(cprm.mm_flags))
+	if (!dumpable)
 		goto fail;
 
 	cred = prepare_creds();
@@ -583,7 +587,7 @@ void do_coredump(const siginfo_t *siginfo)
 		need_suid_safe = true;
 	}
 
-	retval = coredump_wait(siginfo->si_signo, &core_state);
+	retval = coredump_wait(signr, &core_state);
 	if (retval < 0)
 		goto fail_creds;
 
@@ -626,7 +630,7 @@ void do_coredump(const siginfo_t *siginfo)
 		}
 		cprm.limit = RLIM_INFINITY;
 
-		dump_count = atomic_inc_return(&core_dump_count);
+		dump_count = atomic_inc_return_unchecked(&core_dump_count);
 		if (core_pipe_limit && (core_pipe_limit < dump_count)) {
 			printk(KERN_WARNING "Pid %d(%s) over core_pipe_limit\n",
 			       task_tgid_vnr(current), current->comm);
@@ -660,6 +664,8 @@ void do_coredump(const siginfo_t *siginfo)
 		int open_flags = O_CREAT | O_RDWR | O_NOFOLLOW |
 				 O_LARGEFILE | O_EXCL;
 
+		gr_learn_resource(current, RLIMIT_CORE, binfmt->min_coredump, 1);
+
 		if (cprm.limit < binfmt->min_coredump)
 			goto fail_unlock;
 
@@ -685,7 +691,7 @@ void do_coredump(const siginfo_t *siginfo)
 			 * If it doesn't exist, that's fine. If there's some
 			 * other problem, we'll catch it at the filp_open().
 			 */
-			(void) sys_unlink((const char __user *)cn.corename);
+			(void) sys_unlink((const char __force_user *)cn.corename);
 			set_fs(old_fs);
 		}
 
@@ -766,7 +772,7 @@ close_fail:
 		filp_close(cprm.file, NULL);
 fail_dropcount:
 	if (ispipe)
-		atomic_dec(&core_dump_count);
+		atomic_dec_unchecked(&core_dump_count);
 fail_unlock:
 	kfree(cn.corename);
 	coredump_finish(mm, core_dumped);
@@ -774,6 +780,9 @@ fail_unlock:
 fail_creds:
 	put_cred(cred);
 fail:
+	if (signr == SIGSEGV || signr == SIGBUS || signr == SIGKILL || signr == SIGILL)
+		gr_handle_brute_attach(dumpable);
+
 	return;
 }
 
@@ -787,6 +796,8 @@ int dump_emit(struct coredump_params *cprm, const void *addr, int nr)
 	struct file *file = cprm->file;
 	loff_t pos = file->f_pos;
 	ssize_t n;
+
+	gr_learn_resource(current, RLIMIT_CORE, cprm->written + nr, 1);
 	if (cprm->written + nr > cprm->limit)
 		return 0;
 	while (nr) {
diff --git a/fs/dcache.c b/fs/dcache.c
index 5c7cc953a..58840d7c6 100644
--- a/fs/dcache.c
+++ b/fs/dcache.c
@@ -321,8 +321,9 @@ static void dentry_free(struct dentry *dentry)
  * d_iput() operation if defined.
  */
 static void dentry_unlink_inode(struct dentry * dentry)
-	__releases(dentry->d_lock)
-	__releases(dentry->d_inode->i_lock)
+	__releases(&dentry->d_lock)
+	__releases(&dentry->d_inode->i_lock);
+static void dentry_unlink_inode(struct dentry * dentry)
 {
 	struct inode *inode = dentry->d_inode;
 	bool hashed = !d_unhashed(dentry);
@@ -559,7 +560,8 @@ static void __dentry_kill(struct dentry *dentry)
  * Returns dentry requiring refcount drop, or NULL if we're done.
  */
 static struct dentry *dentry_kill(struct dentry *dentry)
-	__releases(dentry->d_lock)
+	__releases(&dentry->d_lock);
+static struct dentry *dentry_kill(struct dentry *dentry)
 {
 	struct inode *inode = dentry->d_inode;
 	struct dentry *parent = NULL;
@@ -589,7 +591,7 @@ static inline struct dentry *lock_parent(struct dentry *dentry)
 	struct dentry *parent = dentry->d_parent;
 	if (IS_ROOT(dentry))
 		return NULL;
-	if (unlikely(dentry->d_lockref.count < 0))
+	if (unlikely(__lockref_read(&dentry->d_lockref) < 0))
 		return NULL;
 	if (likely(spin_trylock(&parent->d_lock)))
 		return parent;
@@ -651,8 +653,8 @@ static inline bool fast_dput(struct dentry *dentry)
 	 */
 	if (unlikely(ret < 0)) {
 		spin_lock(&dentry->d_lock);
-		if (dentry->d_lockref.count > 1) {
-			dentry->d_lockref.count--;
+		if (__lockref_read(&dentry->d_lockref) > 1) {
+			__lockref_dec(&dentry->d_lockref);
 			spin_unlock(&dentry->d_lock);
 			return 1;
 		}
@@ -707,7 +709,7 @@ static inline bool fast_dput(struct dentry *dentry)
 	 * else could have killed it and marked it dead. Either way, we
 	 * don't need to do anything else.
 	 */
-	if (dentry->d_lockref.count) {
+	if (__lockref_read(&dentry->d_lockref)) {
 		spin_unlock(&dentry->d_lock);
 		return 1;
 	}
@@ -717,7 +719,7 @@ static inline bool fast_dput(struct dentry *dentry)
 	 * lock, and we just tested that it was zero, so we can just
 	 * set it to 1.
 	 */
-	dentry->d_lockref.count = 1;
+	__lockref_set(&dentry->d_lockref, 1);
 	return 0;
 }
 
@@ -754,8 +756,6 @@ void dput(struct dentry *dentry)
 		return;
 
 repeat:
-	might_sleep();
-
 	rcu_read_lock();
 	if (likely(fast_dput(dentry))) {
 		rcu_read_unlock();
@@ -783,7 +783,7 @@ repeat:
 		dentry->d_flags |= DCACHE_REFERENCED;
 	dentry_lru_add(dentry);
 
-	dentry->d_lockref.count--;
+	__lockref_dec(&dentry->d_lockref);
 	spin_unlock(&dentry->d_lock);
 	return;
 
@@ -800,7 +800,7 @@ EXPORT_SYMBOL(dput);
 /* This must be called with d_lock held */
 static inline void __dget_dlock(struct dentry *dentry)
 {
-	dentry->d_lockref.count++;
+	__lockref_inc(&dentry->d_lockref);
 }
 
 static inline void __dget(struct dentry *dentry)
@@ -841,8 +841,8 @@ repeat:
 		goto repeat;
 	}
 	rcu_read_unlock();
-	BUG_ON(!ret->d_lockref.count);
-	ret->d_lockref.count++;
+	BUG_ON(!__lockref_read(&ret->d_lockref));
+	__lockref_inc(&ret->d_lockref);
 	spin_unlock(&ret->d_lock);
 	return ret;
 }
@@ -920,9 +920,9 @@ restart:
 	spin_lock(&inode->i_lock);
 	hlist_for_each_entry(dentry, &inode->i_dentry, d_u.d_alias) {
 		spin_lock(&dentry->d_lock);
-		if (!dentry->d_lockref.count) {
+		if (!__lockref_read(&dentry->d_lockref)) {
 			struct dentry *parent = lock_parent(dentry);
-			if (likely(!dentry->d_lockref.count)) {
+			if (likely(!__lockref_read(&dentry->d_lockref))) {
 				__dentry_kill(dentry);
 				dput(parent);
 				goto restart;
@@ -957,7 +957,7 @@ static void shrink_dentry_list(struct list_head *list)
 		 * We found an inuse dentry which was not removed from
 		 * the LRU because of laziness during lookup. Do not free it.
 		 */
-		if (dentry->d_lockref.count > 0) {
+		if (__lockref_read(&dentry->d_lockref) > 0) {
 			spin_unlock(&dentry->d_lock);
 			if (parent)
 				spin_unlock(&parent->d_lock);
@@ -995,8 +995,8 @@ static void shrink_dentry_list(struct list_head *list)
 		dentry = parent;
 		while (dentry && !lockref_put_or_lock(&dentry->d_lockref)) {
 			parent = lock_parent(dentry);
-			if (dentry->d_lockref.count != 1) {
-				dentry->d_lockref.count--;
+			if (__lockref_read(&dentry->d_lockref) != 1) {
+				__lockref_inc(&dentry->d_lockref);
 				spin_unlock(&dentry->d_lock);
 				if (parent)
 					spin_unlock(&parent->d_lock);
@@ -1036,7 +1036,7 @@ static enum lru_status dentry_lru_isolate(struct list_head *item,
 	 * counts, just remove them from the LRU. Otherwise give them
 	 * another pass through the LRU.
 	 */
-	if (dentry->d_lockref.count) {
+	if (__lockref_read(&dentry->d_lockref)) {
 		d_lru_isolate(lru, dentry);
 		spin_unlock(&dentry->d_lock);
 		return LRU_REMOVED;
@@ -1373,7 +1373,7 @@ static enum d_walk_ret select_collect(void *_data, struct dentry *dentry)
 	} else {
 		if (dentry->d_flags & DCACHE_LRU_LIST)
 			d_lru_del(dentry);
-		if (!dentry->d_lockref.count) {
+		if (!__lockref_read(&dentry->d_lockref)) {
 			d_shrink_add(dentry, &data->dispose);
 			data->found++;
 		}
@@ -1421,7 +1421,7 @@ static enum d_walk_ret umount_check(void *_data, struct dentry *dentry)
 		return D_WALK_CONTINUE;
 
 	/* root with refcount 1 is fine */
-	if (dentry == _data && dentry->d_lockref.count == 1)
+	if (dentry == _data && __lockref_read(&dentry->d_lockref) == 1)
 		return D_WALK_CONTINUE;
 
 	printk(KERN_ERR "BUG: Dentry %p{i=%lx,n=%pd} "
@@ -1430,7 +1430,7 @@ static enum d_walk_ret umount_check(void *_data, struct dentry *dentry)
 		       dentry->d_inode ?
 		       dentry->d_inode->i_ino : 0UL,
 		       dentry,
-		       dentry->d_lockref.count,
+		       __lockref_read(&dentry->d_lockref),
 		       dentry->d_sb->s_type->name,
 		       dentry->d_sb->s_id);
 	WARN_ON(1);
@@ -1576,7 +1576,7 @@ struct dentry *__d_alloc(struct super_block *sb, const struct qstr *name)
 		dname = dentry->d_iname;
 	} else if (name->len > DNAME_INLINE_LEN-1) {
 		size_t size = offsetof(struct external_name, name[1]);
-		struct external_name *p = kmalloc(size + name->len,
+		struct external_name *p = kmalloc(round_up(size + name->len, sizeof(unsigned long)),
 						  GFP_KERNEL_ACCOUNT);
 		if (!p) {
 			kmem_cache_free(dentry_cache, dentry); 
@@ -1600,7 +1600,7 @@ struct dentry *__d_alloc(struct super_block *sb, const struct qstr *name)
 	smp_wmb();
 	dentry->d_name.name = dname;
 
-	dentry->d_lockref.count = 1;
+	__lockref_set(&dentry->d_lockref, 1);
 	dentry->d_flags = 0;
 	spin_lock_init(&dentry->d_lock);
 	seqcount_init(&dentry->d_seq);
@@ -1609,6 +1609,9 @@ struct dentry *__d_alloc(struct super_block *sb, const struct qstr *name)
 	dentry->d_sb = sb;
 	dentry->d_op = NULL;
 	dentry->d_fsdata = NULL;
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+	atomic_set(&dentry->chroot_refcnt, 0);
+#endif
 	INIT_HLIST_BL_NODE(&dentry->d_hash);
 	INIT_LIST_HEAD(&dentry->d_lru);
 	INIT_LIST_HEAD(&dentry->d_subdirs);
@@ -2250,7 +2253,7 @@ struct dentry *__d_lookup(const struct dentry *parent, const struct qstr *name)
 		if (!d_same_name(dentry, parent, name))
 			goto next;
 
-		dentry->d_lockref.count++;
+		__lockref_inc(&dentry->d_lockref);
 		found = dentry;
 		spin_unlock(&dentry->d_lock);
 		break;
@@ -2318,7 +2321,7 @@ again:
 	spin_lock(&dentry->d_lock);
 	inode = dentry->d_inode;
 	isdir = S_ISDIR(inode->i_mode);
-	if (dentry->d_lockref.count == 1) {
+	if (__lockref_read(&dentry->d_lockref) == 1) {
 		if (!spin_trylock(&inode->i_lock)) {
 			spin_unlock(&dentry->d_lock);
 			cpu_relax();
@@ -3500,7 +3503,7 @@ static enum d_walk_ret d_genocide_kill(void *data, struct dentry *dentry)
 
 		if (!(dentry->d_flags & DCACHE_GENOCIDE)) {
 			dentry->d_flags |= DCACHE_GENOCIDE;
-			dentry->d_lockref.count--;
+			__lockref_dec(&dentry->d_lockref);
 		}
 	}
 	return D_WALK_CONTINUE;
@@ -3571,8 +3574,8 @@ static void __init dcache_init(void)
 	 * but it is probably not worth it because of the cache nature
 	 * of the dcache. 
 	 */
-	dentry_cache = KMEM_CACHE(dentry,
-		SLAB_RECLAIM_ACCOUNT|SLAB_PANIC|SLAB_MEM_SPREAD|SLAB_ACCOUNT);
+	dentry_cache = KMEM_CACHE_USERCOPY(dentry,
+		SLAB_RECLAIM_ACCOUNT|SLAB_PANIC|SLAB_MEM_SPREAD|SLAB_ACCOUNT, d_iname);
 
 	/* Hash may have been set up in dcache_init_early */
 	if (!hashdist)
@@ -3607,8 +3610,9 @@ void __init vfs_caches_init_early(void)
 
 void __init vfs_caches_init(void)
 {
-	names_cachep = kmem_cache_create("names_cache", PATH_MAX, 0,
-			SLAB_HWCACHE_ALIGN|SLAB_PANIC, NULL);
+	names_cachep = kmem_cache_create_usercopy("names_cache", PATH_MAX, 0,
+			SLAB_HWCACHE_ALIGN|SLAB_PANIC| SLAB_NO_SANITIZE,
+			0, PATH_MAX, NULL);
 
 	dcache_init();
 	inode_init();
diff --git a/fs/debugfs/file.c b/fs/debugfs/file.c
index 309f4e9b2..6747d80c5 100644
--- a/fs/debugfs/file.c
+++ b/fs/debugfs/file.c
@@ -209,7 +209,7 @@ static int full_proxy_release(struct inode *inode, struct file *filp)
 	return 0;
 }
 
-static void __full_proxy_fops_init(struct file_operations *proxy_fops,
+static void __full_proxy_fops_init(file_operations_no_const *proxy_fops,
 				const struct file_operations *real_fops)
 {
 	proxy_fops->release = full_proxy_release;
@@ -229,7 +229,7 @@ static int full_proxy_open(struct inode *inode, struct file *filp)
 {
 	const struct dentry *dentry = F_DENTRY(filp);
 	const struct file_operations *real_fops = NULL;
-	struct file_operations *proxy_fops = NULL;
+	file_operations_no_const *proxy_fops = NULL;
 	int srcu_idx, r;
 
 	r = debugfs_use_file_start(dentry, &srcu_idx);
@@ -734,6 +734,43 @@ struct dentry *debugfs_create_atomic_t(const char *name, umode_t mode,
 }
 EXPORT_SYMBOL_GPL(debugfs_create_atomic_t);
 
+static int debugfs_atomic_unchecked_t_set(void *data, u64 val)
+{
+	atomic_set_unchecked((atomic_unchecked_t *)data, val);
+	return 0;
+}
+static int debugfs_atomic_unchecked_t_get(void *data, u64 *val)
+{
+	*val = atomic_read_unchecked((atomic_unchecked_t *)data);
+	return 0;
+}
+DEFINE_DEBUGFS_ATTRIBUTE(fops_atomic_unchecked_t, debugfs_atomic_unchecked_t_get,
+			debugfs_atomic_unchecked_t_set, "%lld\n");
+DEFINE_DEBUGFS_ATTRIBUTE(fops_atomic_unchecked_t_ro, debugfs_atomic_unchecked_t_get, NULL,
+			"%lld\n");
+DEFINE_DEBUGFS_ATTRIBUTE(fops_atomic_unchecked_t_wo, NULL, debugfs_atomic_unchecked_t_set,
+			"%lld\n");
+
+/**
+ * debugfs_create_atomic_unchecked_t - create a debugfs file that is used to read and
+ * write an atomic_unchecked_t value
+ * @name: a pointer to a string containing the name of the file to create.
+ * @mode: the permission that the file should have
+ * @parent: a pointer to the parent dentry for this file.  This should be a
+ *          directory dentry if set.  If this parameter is %NULL, then the
+ *          file will be created in the root of the debugfs filesystem.
+ * @value: a pointer to the variable that the file should read to and write
+ *         from.
+ */
+struct dentry *debugfs_create_atomic_unchecked_t(const char *name, umode_t mode,
+				 struct dentry *parent, atomic_unchecked_t *value)
+{
+	return debugfs_create_mode_unsafe(name, mode, parent, value,
+					&fops_atomic_unchecked_t, &fops_atomic_unchecked_t_ro,
+					&fops_atomic_unchecked_t_wo);
+}
+EXPORT_SYMBOL_GPL(debugfs_create_atomic_unchecked_t);
+
 ssize_t debugfs_read_file_bool(struct file *file, char __user *user_buf,
 			       size_t count, loff_t *ppos)
 {
diff --git a/fs/debugfs/inode.c b/fs/debugfs/inode.c
index 72361baf9..21d833e93 100644
--- a/fs/debugfs/inode.c
+++ b/fs/debugfs/inode.c
@@ -253,6 +253,10 @@ static struct dentry *start_creating(const char *name, struct dentry *parent)
 	struct dentry *dentry;
 	int error;
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+	return ERR_PTR(-ENODEV);
+#endif
+
 	pr_debug("debugfs: creating file '%s'\n",name);
 
 	if (IS_ERR(parent))
@@ -466,6 +470,10 @@ EXPORT_SYMBOL_GPL(debugfs_create_file_size);
  * If debugfs is not enabled in the kernel, the value -%ENODEV will be
  * returned.
  */
+#ifdef CONFIG_GRKERNSEC_SYSFS_RESTRICT
+extern int grsec_enable_sysfs_restrict;
+#endif
+
 struct dentry *debugfs_create_dir(const char *name, struct dentry *parent)
 {
 	struct dentry *dentry = start_creating(name, parent);
@@ -478,7 +486,12 @@ struct dentry *debugfs_create_dir(const char *name, struct dentry *parent)
 	if (unlikely(!inode))
 		return failed_creating(dentry);
 
-	inode->i_mode = S_IFDIR | S_IRWXU | S_IRUGO | S_IXUGO;
+#ifdef CONFIG_GRKERNSEC_SYSFS_RESTRICT
+	if (grsec_enable_sysfs_restrict)
+		inode->i_mode = S_IFDIR | S_IRWXU;
+	else
+#endif
+		inode->i_mode = S_IFDIR | S_IRWXU | S_IRUGO | S_IXUGO;
 	inode->i_op = &simple_dir_inode_operations;
 	inode->i_fop = &simple_dir_operations;
 
@@ -782,6 +795,10 @@ static int __init debugfs_init(void)
 {
 	int retval;
 
+#ifdef CONFIG_GRKERNSEC_KMEM
+	return -ENOSYS;
+#endif
+
 	retval = sysfs_create_mount_point(kernel_kobj, "debug");
 	if (retval)
 		return retval;
diff --git a/fs/ecryptfs/inode.c b/fs/ecryptfs/inode.c
index 9d153b6a1..60baa469b 100644
--- a/fs/ecryptfs/inode.c
+++ b/fs/ecryptfs/inode.c
@@ -639,7 +639,7 @@ static char *ecryptfs_readlink_lower(struct dentry *dentry, size_t *bufsiz)
 	old_fs = get_fs();
 	set_fs(get_ds());
 	rc = d_inode(lower_dentry)->i_op->readlink(lower_dentry,
-						   (char __user *)lower_buf,
+						   (char __force_user *)lower_buf,
 						   PATH_MAX);
 	set_fs(old_fs);
 	if (rc < 0)
diff --git a/fs/ecryptfs/miscdev.c b/fs/ecryptfs/miscdev.c
index e4141f257..d8263e837 100644
--- a/fs/ecryptfs/miscdev.c
+++ b/fs/ecryptfs/miscdev.c
@@ -304,7 +304,7 @@ check_list:
 		goto out_unlock_msg_ctx;
 	i = PKT_TYPE_SIZE + PKT_CTR_SIZE;
 	if (msg_ctx->msg) {
-		if (copy_to_user(&buf[i], packet_length, packet_length_size))
+		if (packet_length_size > sizeof(packet_length) || copy_to_user(&buf[i], packet_length, packet_length_size))
 			goto out_unlock_msg_ctx;
 		i += packet_length_size;
 		if (copy_to_user(&buf[i], msg_ctx->msg, msg_ctx->msg_size))
diff --git a/fs/exec.c b/fs/exec.c
index eebe8be7a..5b418f2a6 100644
--- a/fs/exec.c
+++ b/fs/exec.c
@@ -57,8 +57,20 @@
 #include <linux/oom.h>
 #include <linux/compat.h>
 #include <linux/vmalloc.h>
+#include <linux/random.h>
+#include <linux/seq_file.h>
+#include <linux/coredump.h>
+#include <linux/mman.h>
+
+#ifdef CONFIG_PAX_REFCOUNT
+#include <linux/kallsyms.h>
+#include <linux/kdebug.h>
+#endif
+
+#include <trace/events/fs.h>
 
 #include <asm/uaccess.h>
+#include <asm/sections.h>
 #include <asm/mmu_context.h>
 #include <asm/tlb.h>
 
@@ -67,19 +79,34 @@
 
 #include <trace/events/sched.h>
 
+#ifdef CONFIG_PAX_HAVE_ACL_FLAGS
+void __weak pax_set_initial_flags(struct linux_binprm *bprm)
+{
+	pr_warn_once("PAX: PAX_HAVE_ACL_FLAGS was enabled without providing the pax_set_initial_flags callback, this is probably not what you wanted.\n");
+}
+#endif
+
+#ifdef CONFIG_PAX_HOOK_ACL_FLAGS
+void (*pax_set_initial_flags_func)(struct linux_binprm *bprm);
+EXPORT_SYMBOL(pax_set_initial_flags_func);
+#endif
+
 int suid_dumpable = 0;
 
 static LIST_HEAD(formats);
 static DEFINE_RWLOCK(binfmt_lock);
 
+extern int gr_process_kernel_exec_ban(void);
+extern int gr_process_sugid_exec_ban(const struct linux_binprm *bprm);
+
 void __register_binfmt(struct linux_binfmt * fmt, int insert)
 {
 	BUG_ON(!fmt);
 	if (WARN_ON(!fmt->load_binary))
 		return;
 	write_lock(&binfmt_lock);
-	insert ? list_add(&fmt->lh, &formats) :
-		 list_add_tail(&fmt->lh, &formats);
+	insert ? pax_list_add((struct list_head *)&fmt->lh, &formats) :
+		 pax_list_add_tail((struct list_head *)&fmt->lh, &formats);
 	write_unlock(&binfmt_lock);
 }
 
@@ -88,7 +115,7 @@ EXPORT_SYMBOL(__register_binfmt);
 void unregister_binfmt(struct linux_binfmt * fmt)
 {
 	write_lock(&binfmt_lock);
-	list_del(&fmt->lh);
+	pax_list_del((struct list_head *)&fmt->lh);
 	write_unlock(&binfmt_lock);
 }
 
@@ -190,22 +217,15 @@ static struct page *get_arg_page(struct linux_binprm *bprm, unsigned long pos,
 		int write)
 {
 	struct page *page;
-	int ret;
 
-#ifdef CONFIG_STACK_GROWSUP
-	if (write) {
-		ret = expand_downwards(bprm->vma, pos);
-		if (ret < 0)
-			return NULL;
-	}
-#endif
+	if (0 > expand_downwards(bprm->vma, pos))
+		return NULL;
 	/*
 	 * We are doing an exec().  'current' is the process
 	 * doing the exec and bprm->mm is the new process's mm.
 	 */
-	ret = get_user_pages_remote(current, bprm->mm, pos, 1, write,
-			1, &page, NULL);
-	if (ret <= 0)
+	if (0 >= get_user_pages_remote(current, bprm->mm, pos, 1, write,
+			1, &page, NULL))
 		return NULL;
 
 	if (write) {
@@ -221,6 +241,17 @@ static struct page *get_arg_page(struct linux_binprm *bprm, unsigned long pos,
 		if (size <= ARG_MAX)
 			return page;
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+		// only allow 512KB for argv+env on suid/sgid binaries
+		// to prevent easy ASLR exhaustion
+		if (((!uid_eq(bprm->cred->euid, current_euid())) ||
+		     (!gid_eq(bprm->cred->egid, current_egid()))) &&
+		    (size > (512 * 1024))) {
+			put_page(page);
+			return NULL;
+		}
+#endif
+
 		/*
 		 * Limit to 1/4-th the stack size for the argv+env strings.
 		 * This ensures that:
@@ -279,6 +310,11 @@ static int __bprm_mm_init(struct linux_binprm *bprm)
 	vma->vm_end = STACK_TOP_MAX;
 	vma->vm_start = vma->vm_end - PAGE_SIZE;
 	vma->vm_flags = VM_SOFTDIRTY | VM_STACK_FLAGS | VM_STACK_INCOMPLETE_SETUP;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma->vm_flags &= ~(VM_EXEC | VM_MAYEXEC);
+#endif
+
 	vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
 	INIT_LIST_HEAD(&vma->anon_vma_chain);
 
@@ -290,6 +326,12 @@ static int __bprm_mm_init(struct linux_binprm *bprm)
 	arch_bprm_mm_init(mm, vma);
 	up_write(&mm->mmap_sem);
 	bprm->p = vma->vm_end - sizeof(void *);
+
+#ifdef CONFIG_PAX_RANDUSTACK
+	if (randomize_va_space)
+		bprm->p ^= prandom_u32() & ~PAGE_MASK;
+#endif
+
 	return 0;
 err:
 	up_write(&mm->mmap_sem);
@@ -407,7 +449,7 @@ struct user_arg_ptr {
 	} ptr;
 };
 
-static const char __user *get_user_arg_ptr(struct user_arg_ptr argv, int nr)
+const char __user *get_user_arg_ptr(struct user_arg_ptr argv, int nr)
 {
 	const char __user *native;
 
@@ -416,14 +458,14 @@ static const char __user *get_user_arg_ptr(struct user_arg_ptr argv, int nr)
 		compat_uptr_t compat;
 
 		if (get_user(compat, argv.ptr.compat + nr))
-			return ERR_PTR(-EFAULT);
+			return (const char __force_user *)ERR_PTR(-EFAULT);
 
 		return compat_ptr(compat);
 	}
 #endif
 
 	if (get_user(native, argv.ptr.native + nr))
-		return ERR_PTR(-EFAULT);
+		return (const char __force_user *)ERR_PTR(-EFAULT);
 
 	return native;
 }
@@ -442,7 +484,7 @@ static int count(struct user_arg_ptr argv, int max)
 			if (!p)
 				break;
 
-			if (IS_ERR(p))
+			if (IS_ERR((const char __force_kernel *)p))
 				return -EFAULT;
 
 			if (i >= max)
@@ -477,7 +519,7 @@ static int copy_strings(int argc, struct user_arg_ptr argv,
 
 		ret = -EFAULT;
 		str = get_user_arg_ptr(argv, argc);
-		if (IS_ERR(str))
+		if (IS_ERR((const char __force_kernel *)str))
 			goto out;
 
 		len = strnlen_user(str, MAX_ARG_STRLEN);
@@ -559,7 +601,7 @@ int copy_strings_kernel(int argc, const char *const *__argv,
 	int r;
 	mm_segment_t oldfs = get_fs();
 	struct user_arg_ptr argv = {
-		.ptr.native = (const char __user *const  __user *)__argv,
+		.ptr.native = (const char __user * const __force_user *)__argv,
 	};
 
 	set_fs(KERNEL_DS);
@@ -594,7 +636,8 @@ static int shift_arg_pages(struct vm_area_struct *vma, unsigned long shift)
 	unsigned long new_end = old_end - shift;
 	struct mmu_gather tlb;
 
-	BUG_ON(new_start > new_end);
+	if (new_start >= new_end || new_start < mmap_min_addr)
+		return -ENOMEM;
 
 	/*
 	 * ensure there are no vmas between where we want to go
@@ -603,6 +646,10 @@ static int shift_arg_pages(struct vm_area_struct *vma, unsigned long shift)
 	if (vma != find_vma(mm, new_start))
 		return -EFAULT;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	BUG_ON(pax_find_mirror_vma(vma));
+#endif
+
 	/*
 	 * cover the whole range: [new_start, old_end)
 	 */
@@ -680,20 +727,16 @@ int setup_arg_pages(struct linux_binprm *bprm,
 	stack_base = PAGE_ALIGN(stack_top - stack_base);
 
 	stack_shift = vma->vm_start - stack_base;
-	mm->arg_start = bprm->p - stack_shift;
+	mm->arg_end = mm->arg_start = bprm->p - stack_shift;
 	bprm->p = vma->vm_end - stack_shift;
 #else
 	stack_top = arch_align_stack(stack_top);
 	stack_top = PAGE_ALIGN(stack_top);
 
-	if (unlikely(stack_top < mmap_min_addr) ||
-	    unlikely(vma->vm_end - vma->vm_start >= stack_top - mmap_min_addr))
-		return -ENOMEM;
-
 	stack_shift = vma->vm_end - stack_top;
 
 	bprm->p -= stack_shift;
-	mm->arg_start = bprm->p;
+	mm->arg_end = mm->arg_start = bprm->p;
 #endif
 
 	if (bprm->loader)
@@ -703,8 +746,27 @@ int setup_arg_pages(struct linux_binprm *bprm,
 	if (down_write_killable(&mm->mmap_sem))
 		return -EINTR;
 
+	/* Move stack pages down in memory. */
+	if (stack_shift) {
+		ret = shift_arg_pages(vma, stack_shift);
+		if (ret)
+			goto out_unlock;
+	}
+
 	vm_flags = VM_STACK_FLAGS;
 
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+	if (mm->pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) {
+		vm_flags &= ~VM_EXEC;
+
+#ifdef CONFIG_PAX_MPROTECT
+		if (mm->pax_flags & MF_PAX_MPROTECT)
+			vm_flags &= ~VM_MAYEXEC;
+#endif
+
+	}
+#endif
+
 	/*
 	 * Adjust stack execute permissions; explicitly enable for
 	 * EXSTACK_ENABLE_X, disable for EXSTACK_DISABLE_X and leave alone
@@ -723,13 +785,6 @@ int setup_arg_pages(struct linux_binprm *bprm,
 		goto out_unlock;
 	BUG_ON(prev != vma);
 
-	/* Move stack pages down in memory. */
-	if (stack_shift) {
-		ret = shift_arg_pages(vma, stack_shift);
-		if (ret)
-			goto out_unlock;
-	}
-
 	/* mprotect_fixup is overkill to remove the temporary stack flags */
 	vma->vm_flags &= ~VM_STACK_INCOMPLETE_SETUP;
 
@@ -753,6 +808,27 @@ int setup_arg_pages(struct linux_binprm *bprm,
 #endif
 	current->mm->start_stack = bprm->p;
 	ret = expand_stack(vma, stack_base);
+
+#if !defined(CONFIG_STACK_GROWSUP) && defined(CONFIG_PAX_RANDMMAP)
+	if (!ret && (mm->pax_flags & MF_PAX_RANDMMAP) && STACK_TOP <= 0xFFFFFFFFU && STACK_TOP > vma->vm_end) {
+		unsigned long size;
+		vm_flags_t vm_flags;
+
+		size = STACK_TOP - vma->vm_end;
+		vm_flags = VM_NONE | VM_DONTEXPAND | VM_DONTDUMP;
+
+		ret = vma->vm_end != mmap_region(NULL, vma->vm_end, size, vm_flags, 0);
+
+#ifdef CONFIG_X86
+		if (!ret) {
+			size = PAGE_SIZE + mmap_min_addr + ((mm->delta_mmap ^ mm->delta_stack) & (0xFFUL << PAGE_SHIFT));
+			ret = 0 != mmap_region(NULL, 0, PAGE_ALIGN(size), vm_flags, 0);
+		}
+#endif
+
+	}
+#endif
+
 	if (ret)
 		ret = -EFAULT;
 
@@ -801,6 +877,7 @@ static struct file *do_open_execat(int fd, struct filename *name, int flags)
 {
 	struct file *file;
 	int err;
+	int unsafe_flags = 0;
 	struct open_flags open_exec_flags = {
 		.open_flag = O_LARGEFILE | O_RDONLY | __FMODE_EXEC,
 		.acc_mode = MAY_EXEC,
@@ -826,12 +903,22 @@ static struct file *do_open_execat(int fd, struct filename *name, int flags)
 	if (path_noexec(&file->f_path))
 		goto exit;
 
+	if (current->ptrace && !ptracer_capable(current, current_user_ns()))
+		unsafe_flags = LSM_UNSAFE_PTRACE;
+
+	if (gr_ptrace_readexec(file, unsafe_flags)) {
+		err = -EPERM;
+		goto exit;
+	}
+
 	err = deny_write_access(file);
 	if (err)
 		goto exit;
 
-	if (name->name[0] != '\0')
+	if (name->name[0] != '\0') {
 		fsnotify_open(file);
+		trace_open_exec(name->name);
+	}
 
 out:
 	return file;
@@ -861,10 +948,13 @@ int kernel_read(struct file *file, loff_t offset,
 	loff_t pos = offset;
 	int result;
 
+	if (count > INT_MAX)
+		return -EINVAL;
+
 	old_fs = get_fs();
 	set_fs(get_ds());
 	/* The cast to a user pointer is valid due to the set_fs() */
-	result = vfs_read(file, (void __user *)addr, count, &pos);
+	result = vfs_read(file, (void __force_user *)addr, count, &pos);
 	set_fs(old_fs);
 	return result;
 }
@@ -1443,7 +1533,7 @@ static void check_unsafe_exec(struct linux_binprm *bprm)
 	}
 	rcu_read_unlock();
 
-	if (p->fs->users > n_fs)
+	if (atomic_read(&p->fs->users) > n_fs)
 		bprm->unsafe |= LSM_UNSAFE_SHARE;
 	else
 		p->fs->in_exec = 1;
@@ -1646,6 +1736,31 @@ static int exec_binprm(struct linux_binprm *bprm)
 	return ret;
 }
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+static DEFINE_PER_CPU(u64, exec_counter);
+static int __init init_exec_counters(void)
+{
+	unsigned int cpu;
+
+	for_each_possible_cpu(cpu) {
+		per_cpu(exec_counter, cpu) = (u64)cpu;
+	}
+
+	return 0;
+}
+early_initcall(init_exec_counters);
+static inline void increment_exec_counter(void)
+{
+	BUILD_BUG_ON(NR_CPUS > (1 << 16));
+	current->exec_id = this_cpu_add_return(exec_counter, 1 << 16);
+}
+#else
+static inline void increment_exec_counter(void) {}
+#endif
+
+extern void gr_handle_exec_args(struct linux_binprm *bprm,
+				struct user_arg_ptr argv);
+
 /*
  * sys_execve() executes a new program.
  */
@@ -1654,6 +1769,11 @@ static int do_execveat_common(int fd, struct filename *filename,
 			      struct user_arg_ptr envp,
 			      int flags)
 {
+#ifdef CONFIG_GRKERNSEC
+	struct file *old_exec_file;
+	struct acl_subject_label *old_acl;
+	struct rlimit old_rlim[RLIM_NLIMITS];
+#endif
 	char *pathbuf = NULL;
 	struct linux_binprm *bprm;
 	struct file *file;
@@ -1663,6 +1783,8 @@ static int do_execveat_common(int fd, struct filename *filename,
 	if (IS_ERR(filename))
 		return PTR_ERR(filename);
 
+	gr_learn_resource(current, RLIMIT_NPROC, atomic_read(&current_user()->processes), 1);
+
 	/*
 	 * We move the actual failure in case of RLIMIT_NPROC excess from
 	 * set*uid() to execve() because too many poorly written programs
@@ -1726,6 +1848,11 @@ static int do_execveat_common(int fd, struct filename *filename,
 	}
 	bprm->interp = bprm->filename;
 
+	if (!gr_acl_handle_execve(file->f_path.dentry, file->f_path.mnt)) {
+		retval = -EACCES;
+		goto out_unmark;
+	}
+
 	retval = bprm_mm_init(bprm);
 	if (retval)
 		goto out_unmark;
@@ -1742,26 +1869,72 @@ static int do_execveat_common(int fd, struct filename *filename,
 	if (retval < 0)
 		goto out;
 
+#ifdef CONFIG_GRKERNSEC
+	old_acl = current->acl;
+	memcpy(old_rlim, current->signal->rlim, sizeof(old_rlim));
+	old_exec_file = current->exec_file;
+	get_file(file);
+	current->exec_file = file;
+#endif
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	/* limit suid stack to 8MB
+	 * we saved the old limits above and will restore them if this exec fails
+	 */
+	if (((!uid_eq(bprm->cred->euid, current_euid())) || (!gid_eq(bprm->cred->egid, current_egid()))) &&
+	    (old_rlim[RLIMIT_STACK].rlim_cur > (8 * 1024 * 1024)))
+		current->signal->rlim[RLIMIT_STACK].rlim_cur = 8 * 1024 * 1024;
+#endif
+
+	if (gr_process_kernel_exec_ban() || gr_process_sugid_exec_ban(bprm)) {
+		retval = -EPERM;
+		goto out_fail;
+	}
+
+	if (!gr_tpe_allow(file)) {
+		retval = -EACCES;
+		goto out_fail;
+	}
+
+	if (gr_check_crash_exec(file)) {
+		retval = -EACCES;
+		goto out_fail;
+	}
+
+	retval = gr_set_proc_label(file->f_path.dentry, file->f_path.mnt,
+					bprm->unsafe);
+	if (retval < 0)
+		goto out_fail;
+
 	retval = copy_strings_kernel(1, &bprm->filename, bprm);
 	if (retval < 0)
-		goto out;
+		goto out_fail;
 
 	bprm->exec = bprm->p;
 	retval = copy_strings(bprm->envc, envp, bprm);
 	if (retval < 0)
-		goto out;
+		goto out_fail;
 
 	retval = copy_strings(bprm->argc, argv, bprm);
 	if (retval < 0)
-		goto out;
+		goto out_fail;
+
+	gr_log_chroot_exec(file->f_path.dentry, file->f_path.mnt);
+
+	gr_handle_exec_args(bprm, argv);
 
 	would_dump(bprm, bprm->file);
 
 	retval = exec_binprm(bprm);
 	if (retval < 0)
-		goto out;
+		goto out_fail;
+#ifdef CONFIG_GRKERNSEC
+	if (old_exec_file)
+		fput(old_exec_file);
+#endif
 
 	/* execve succeeded */
+
+	increment_exec_counter();
 	current->fs->in_exec = 0;
 	current->in_execve = 0;
 	acct_update_integrals(current);
@@ -1773,6 +1946,14 @@ static int do_execveat_common(int fd, struct filename *filename,
 		put_files_struct(displaced);
 	return retval;
 
+out_fail:
+#ifdef CONFIG_GRKERNSEC
+	current->acl = old_acl;
+	memcpy(current->signal->rlim, old_rlim, sizeof(old_rlim));
+	fput(current->exec_file);
+	current->exec_file = old_exec_file;
+#endif
+
 out:
 	if (bprm->mm) {
 		acct_arg_size(bprm, 0);
@@ -1919,3 +2100,194 @@ COMPAT_SYSCALL_DEFINE5(execveat, int, fd,
 				  argv, envp, flags);
 }
 #endif
+
+int pax_check_flags(unsigned long *flags)
+{
+	int retval = 0;
+
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_SEGMEXEC)
+	if (*flags & MF_PAX_SEGMEXEC)
+	{
+		*flags &= ~MF_PAX_SEGMEXEC;
+		retval = -EINVAL;
+	}
+#endif
+
+	if ((*flags & MF_PAX_PAGEEXEC)
+
+#ifdef CONFIG_PAX_PAGEEXEC
+	    &&  (*flags & MF_PAX_SEGMEXEC)
+#endif
+
+	   )
+	{
+		*flags &= ~MF_PAX_PAGEEXEC;
+		retval = -EINVAL;
+	}
+
+	if ((*flags & MF_PAX_MPROTECT)
+
+#ifdef CONFIG_PAX_MPROTECT
+	    && !(*flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC))
+#endif
+
+	   )
+	{
+		*flags &= ~MF_PAX_MPROTECT;
+		retval = -EINVAL;
+	}
+
+	if ((*flags & MF_PAX_EMUTRAMP)
+
+#ifdef CONFIG_PAX_EMUTRAMP
+	    && !(*flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC))
+#endif
+
+	   )
+	{
+		*flags &= ~MF_PAX_EMUTRAMP;
+		retval = -EINVAL;
+	}
+
+	return retval;
+}
+
+EXPORT_SYMBOL(pax_check_flags);
+
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+char *pax_get_path(const struct path *path, char *buf, int buflen)
+{
+	char *pathname = d_path(path, buf, buflen);
+
+	if (IS_ERR(pathname))
+		goto toolong;
+
+	pathname = mangle_path(buf, pathname, "\t\n\\");
+	if (!pathname)
+		goto toolong;
+
+	*pathname = 0;
+	return buf;
+
+toolong:
+	return "<path too long>";
+}
+EXPORT_SYMBOL(pax_get_path);
+
+void pax_report_fault(struct pt_regs *regs, void *pc, void *sp)
+{
+	struct task_struct *tsk = current;
+	struct mm_struct *mm = current->mm;
+	char *buffer_exec = (char *)__get_free_page(GFP_KERNEL);
+	char *buffer_fault = (char *)__get_free_page(GFP_KERNEL);
+	char *path_exec = NULL;
+	char *path_fault = NULL;
+	unsigned long start = 0UL, end = 0UL, offset = 0UL;
+	siginfo_t info = { };
+
+	if (buffer_exec && buffer_fault) {
+		struct vm_area_struct *vma, *vma_exec = NULL, *vma_fault = NULL;
+
+		down_read(&mm->mmap_sem);
+		vma = mm->mmap;
+		while (vma && (!vma_exec || !vma_fault)) {
+			if (vma->vm_file && mm->exe_file == vma->vm_file && (vma->vm_flags & VM_EXEC))
+				vma_exec = vma;
+			if (vma->vm_start <= (unsigned long)pc && (unsigned long)pc < vma->vm_end)
+				vma_fault = vma;
+			vma = vma->vm_next;
+		}
+		if (vma_exec)
+			path_exec = pax_get_path(&vma_exec->vm_file->f_path, buffer_exec, PAGE_SIZE);
+		if (vma_fault) {
+			start = vma_fault->vm_start;
+			end = vma_fault->vm_end;
+			offset = vma_fault->vm_pgoff << PAGE_SHIFT;
+			if (vma_fault->vm_file)
+				path_fault = pax_get_path(&vma_fault->vm_file->f_path, buffer_fault, PAGE_SIZE);
+			else if ((unsigned long)pc >= mm->start_brk && (unsigned long)pc < mm->brk)
+				path_fault = "<heap>";
+			else if (vma_fault->vm_flags & (VM_GROWSDOWN | VM_GROWSUP))
+				path_fault = "<stack>";
+			else
+				path_fault = "<anonymous mapping>";
+		}
+		up_read(&mm->mmap_sem);
+	}
+	if (tsk->signal->curr_ip)
+		printk(KERN_ERR "PAX: From %pI4: execution attempt in: %s, %08lx-%08lx %08lx\n", &tsk->signal->curr_ip, path_fault, start, end, offset);
+	else
+		printk(KERN_ERR "PAX: execution attempt in: %s, %08lx-%08lx %08lx\n", path_fault, start, end, offset);
+	printk(KERN_ERR "PAX: terminating task: %s(%s):%d, uid/euid: %u/%u, PC: %p, SP: %p\n", path_exec, tsk->comm, task_pid_nr(tsk),
+			from_kuid_munged(&init_user_ns, task_uid(tsk)), from_kuid_munged(&init_user_ns, task_euid(tsk)), pc, sp);
+	free_page((unsigned long)buffer_exec);
+	free_page((unsigned long)buffer_fault);
+	pax_report_insns(regs, pc, sp);
+	info.si_signo = SIGKILL;
+	info.si_errno = 0;
+	info.si_code = SI_KERNEL;
+	info.si_pid = 0;
+	info.si_uid = 0;
+	do_coredump(&info);
+}
+#endif
+
+#ifdef CONFIG_PAX_REFCOUNT
+static DEFINE_RATELIMIT_STATE(refcount_ratelimit, 15 * HZ, 3);
+
+void pax_report_refcount_error(struct pt_regs *regs, const char *kind)
+{
+	do_send_sig_info(SIGKILL, SEND_SIG_FORCED, current, true);
+
+	if (!__ratelimit(&refcount_ratelimit))
+		return;
+
+	if (current->signal->curr_ip)
+		pr_emerg("PAX: From %pI4: %s detected in: %s:%d, uid/euid: %u/%u\n",
+			 &current->signal->curr_ip,
+			 kind ? kind : "refcount error",
+			 current->comm, task_pid_nr(current),
+			 from_kuid_munged(&init_user_ns, current_uid()),
+			 from_kuid_munged(&init_user_ns, current_euid()));
+	else
+		pr_emerg("PAX: %s detected in: %s:%d, uid/euid: %u/%u\n",
+			 kind ? kind : "refcount error",
+			 current->comm, task_pid_nr(current),
+			 from_kuid_munged(&init_user_ns, current_uid()),
+			 from_kuid_munged(&init_user_ns, current_euid()));
+	print_symbol(KERN_EMERG "PAX: refcount error occured at: %s\n", instruction_pointer(regs));
+	preempt_disable();
+	show_regs(regs);
+	preempt_enable();
+}
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_STACKLEAK
+void __used pax_track_stack(void)
+{
+	unsigned long sp = (unsigned long)&sp;
+	if (sp < current_thread_info()->lowest_stack &&
+	    sp >= (unsigned long)task_stack_page(current) + 2 * sizeof(unsigned long))
+		current_thread_info()->lowest_stack = sp;
+	if (unlikely((sp & ~(THREAD_SIZE - 1)) < (THREAD_SIZE/16)))
+		BUG();
+}
+EXPORT_SYMBOL(pax_track_stack);
+#endif
+
+#ifdef CONFIG_PAX_SIZE_OVERFLOW
+static DEFINE_RATELIMIT_STATE(size_overflow_ratelimit, 15 * HZ, 3);
+extern bool pax_size_overflow_report_only;
+
+void __nocapture(1, 3, 4) __used report_size_overflow(const char *file, unsigned int line, const char *func, const char *ssa_name)
+{
+	if (!pax_size_overflow_report_only || __ratelimit(&size_overflow_ratelimit)) {
+		pr_emerg("PAX: size overflow detected in function %s %s:%u %s", func, file, line, ssa_name);
+		dump_stack();
+	}
+
+	if (!pax_size_overflow_report_only)
+		do_group_exit(SIGKILL);
+}
+EXPORT_SYMBOL(report_size_overflow);
+#endif
diff --git a/fs/exofs/inode.c b/fs/exofs/inode.c
index 9dc4c6dbf..ed7c0e773 100644
--- a/fs/exofs/inode.c
+++ b/fs/exofs/inode.c
@@ -470,6 +470,11 @@ fail:
 	return ret;
 }
 
+static int readpage_filler(struct file *data, struct page *page)
+{
+	return readpage_strip(data, page);
+}
+
 static int exofs_readpages(struct file *file, struct address_space *mapping,
 			   struct list_head *pages, unsigned nr_pages)
 {
@@ -478,7 +483,7 @@ static int exofs_readpages(struct file *file, struct address_space *mapping,
 
 	_pcol_init(&pcol, nr_pages, mapping->host);
 
-	ret = read_cache_pages(mapping, pages, readpage_strip, &pcol);
+	ret = read_cache_pages(mapping, pages, readpage_filler, &pcol);
 	if (ret) {
 		EXOFS_ERR("read_cache_pages => %d\n", ret);
 		return ret;
diff --git a/fs/exofs/super.c b/fs/exofs/super.c
index 1076a4233..40b753683 100644
--- a/fs/exofs/super.c
+++ b/fs/exofs/super.c
@@ -192,10 +192,12 @@ static void exofs_init_once(void *foo)
  */
 static int init_inodecache(void)
 {
-	exofs_inode_cachep = kmem_cache_create("exofs_inode_cache",
+	exofs_inode_cachep = kmem_cache_create_usercopy("exofs_inode_cache",
 				sizeof(struct exofs_i_info), 0,
-				SLAB_RECLAIM_ACCOUNT | SLAB_MEM_SPREAD |
-				SLAB_ACCOUNT, exofs_init_once);
+				SLAB_RECLAIM_ACCOUNT | SLAB_MEM_SPREAD | SLAB_ACCOUNT,
+				offsetof(struct exofs_i_info, i_data),
+				sizeof(((struct exofs_i_info *)0)->i_data),
+				exofs_init_once);
 	if (exofs_inode_cachep == NULL)
 		return -ENOMEM;
 	return 0;
diff --git a/fs/ext2/balloc.c b/fs/ext2/balloc.c
index 4c40c0786..734564074 100644
--- a/fs/ext2/balloc.c
+++ b/fs/ext2/balloc.c
@@ -1184,10 +1184,10 @@ static int ext2_has_free_blocks(struct ext2_sb_info *sbi)
 
 	free_blocks = percpu_counter_read_positive(&sbi->s_freeblocks_counter);
 	root_blocks = le32_to_cpu(sbi->s_es->s_r_blocks_count);
-	if (free_blocks < root_blocks + 1 && !capable(CAP_SYS_RESOURCE) &&
+	if (free_blocks < root_blocks + 1 &&
 		!uid_eq(sbi->s_resuid, current_fsuid()) &&
 		(gid_eq(sbi->s_resgid, GLOBAL_ROOT_GID) ||
-		 !in_group_p (sbi->s_resgid))) {
+		 !in_group_p (sbi->s_resgid)) && !capable_nolog(CAP_SYS_RESOURCE)) {
 		return 0;
 	}
 	return 1;
diff --git a/fs/ext2/super.c b/fs/ext2/super.c
index 1d9379568..dbb5a08dc 100644
--- a/fs/ext2/super.c
+++ b/fs/ext2/super.c
@@ -203,10 +203,12 @@ static void init_once(void *foo)
 
 static int __init init_inodecache(void)
 {
-	ext2_inode_cachep = kmem_cache_create("ext2_inode_cache",
+	ext2_inode_cachep = kmem_cache_create_usercopy("ext2_inode_cache",
 					     sizeof(struct ext2_inode_info),
 					     0, (SLAB_RECLAIM_ACCOUNT|
 						SLAB_MEM_SPREAD|SLAB_ACCOUNT),
+					     offsetof(struct ext2_inode_info, i_data),
+					     sizeof(((struct ext2_inode_info *)0)->i_data),
 					     init_once);
 	if (ext2_inode_cachep == NULL)
 		return -ENOMEM;
@@ -273,10 +275,8 @@ static int ext2_show_options(struct seq_file *seq, struct dentry *root)
 #ifdef CONFIG_EXT2_FS_XATTR
 	if (test_opt(sb, XATTR_USER))
 		seq_puts(seq, ",user_xattr");
-	if (!test_opt(sb, XATTR_USER) &&
-	    (def_mount_opts & EXT2_DEFM_XATTR_USER)) {
+	if (!test_opt(sb, XATTR_USER))
 		seq_puts(seq, ",nouser_xattr");
-	}
 #endif
 
 #ifdef CONFIG_EXT2_FS_POSIX_ACL
@@ -864,8 +864,8 @@ static int ext2_fill_super(struct super_block *sb, void *data, int silent)
 	if (def_mount_opts & EXT2_DEFM_UID16)
 		set_opt(sbi->s_mount_opt, NO_UID32);
 #ifdef CONFIG_EXT2_FS_XATTR
-	if (def_mount_opts & EXT2_DEFM_XATTR_USER)
-		set_opt(sbi->s_mount_opt, XATTR_USER);
+	/* always enable user xattrs */
+	set_opt(sbi->s_mount_opt, XATTR_USER);
 #endif
 #ifdef CONFIG_EXT2_FS_POSIX_ACL
 	if (def_mount_opts & EXT2_DEFM_ACL)
diff --git a/fs/ext2/xattr.c b/fs/ext2/xattr.c
index b7f896f3f..61d52fecc 100644
--- a/fs/ext2/xattr.c
+++ b/fs/ext2/xattr.c
@@ -244,7 +244,7 @@ ext2_xattr_list(struct dentry *dentry, char *buffer, size_t buffer_size)
 	struct buffer_head *bh = NULL;
 	struct ext2_xattr_entry *entry;
 	char *end;
-	size_t rest = buffer_size;
+	size_t rest = buffer_size, total_size = 0;
 	int error;
 	struct mb_cache *ext2_mb_cache = EXT2_SB(inode->i_sb)->s_mb_cache;
 
@@ -307,9 +307,10 @@ bad_block:	ext2_error(inode->i_sb, "ext2_xattr_list",
 				*buffer++ = 0;
 			}
 			rest -= size;
+			total_size += size;
 		}
 	}
-	error = buffer_size - rest;  /* total size */
+	error = total_size;
 
 cleanup:
 	brelse(bh);
diff --git a/fs/ext4/balloc.c b/fs/ext4/balloc.c
index e04ec868e..953c3e6fb 100644
--- a/fs/ext4/balloc.c
+++ b/fs/ext4/balloc.c
@@ -566,8 +566,8 @@ static int ext4_has_free_clusters(struct ext4_sb_info *sbi,
 	/* Hm, nope.  Are (enough) root reserved clusters available? */
 	if (uid_eq(sbi->s_resuid, current_fsuid()) ||
 	    (!gid_eq(sbi->s_resgid, GLOBAL_ROOT_GID) && in_group_p(sbi->s_resgid)) ||
-	    capable(CAP_SYS_RESOURCE) ||
-	    (flags & EXT4_MB_USE_ROOT_BLOCKS)) {
+	    (flags & EXT4_MB_USE_ROOT_BLOCKS) ||
+	    capable_nolog(CAP_SYS_RESOURCE)) {
 
 		if (free_clusters >= (nclusters + dirty_clusters +
 				      resv_clusters))
diff --git a/fs/ext4/ext4.h b/fs/ext4/ext4.h
index 7bd21aaed..3288330bf 100644
--- a/fs/ext4/ext4.h
+++ b/fs/ext4/ext4.h
@@ -1440,19 +1440,19 @@ struct ext4_sb_info {
 	unsigned long s_mb_last_start;
 
 	/* stats for buddy allocator */
-	atomic_t s_bal_reqs;	/* number of reqs with len > 1 */
-	atomic_t s_bal_success;	/* we found long enough chunks */
-	atomic_t s_bal_allocated;	/* in blocks */
-	atomic_t s_bal_ex_scanned;	/* total extents scanned */
-	atomic_t s_bal_goals;	/* goal hits */
-	atomic_t s_bal_breaks;	/* too long searches */
-	atomic_t s_bal_2orders;	/* 2^order hits */
+	atomic_unchecked_t s_bal_reqs;	/* number of reqs with len > 1 */
+	atomic_unchecked_t s_bal_success;	/* we found long enough chunks */
+	atomic_unchecked_t s_bal_allocated;	/* in blocks */
+	atomic_unchecked_t s_bal_ex_scanned;	/* total extents scanned */
+	atomic_unchecked_t s_bal_goals;	/* goal hits */
+	atomic_unchecked_t s_bal_breaks;	/* too long searches */
+	atomic_unchecked_t s_bal_2orders;	/* 2^order hits */
 	spinlock_t s_bal_lock;
 	unsigned long s_mb_buddies_generated;
 	unsigned long long s_mb_generation_time;
-	atomic_t s_mb_lost_chunks;
-	atomic_t s_mb_preallocated;
-	atomic_t s_mb_discarded;
+	atomic_unchecked_t s_mb_lost_chunks;
+	atomic_unchecked_t s_mb_preallocated;
+	atomic_unchecked_t s_mb_discarded;
 	atomic_t s_lock_busy;
 
 	/* locality groups */
diff --git a/fs/ext4/extents.c b/fs/ext4/extents.c
index 7f69347bd..7fb5e14d0 100644
--- a/fs/ext4/extents.c
+++ b/fs/ext4/extents.c
@@ -876,7 +876,7 @@ ext4_find_extent(struct inode *inode, ext4_lblk_t block,
 	struct ext4_extent_header *eh;
 	struct buffer_head *bh;
 	struct ext4_ext_path *path = orig_path ? *orig_path : NULL;
-	short int depth, i, ppos = 0;
+	int depth, i, ppos = 0;
 	int ret;
 
 	eh = ext_inode_hdr(inode);
diff --git a/fs/ext4/mballoc.c b/fs/ext4/mballoc.c
index 7ae43c59b..d417c8597 100644
--- a/fs/ext4/mballoc.c
+++ b/fs/ext4/mballoc.c
@@ -1921,7 +1921,7 @@ void ext4_mb_simple_scan_group(struct ext4_allocation_context *ac,
 		BUG_ON(ac->ac_b_ex.fe_len != ac->ac_g_ex.fe_len);
 
 		if (EXT4_SB(sb)->s_mb_stats)
-			atomic_inc(&EXT4_SB(sb)->s_bal_2orders);
+			atomic_inc_unchecked(&EXT4_SB(sb)->s_bal_2orders);
 
 		break;
 	}
@@ -2244,7 +2244,7 @@ repeat:
 			ac->ac_status = AC_STATUS_CONTINUE;
 			ac->ac_flags |= EXT4_MB_HINT_FIRST;
 			cr = 3;
-			atomic_inc(&sbi->s_mb_lost_chunks);
+			atomic_inc_unchecked(&sbi->s_mb_lost_chunks);
 			goto repeat;
 		}
 	}
@@ -2743,25 +2743,25 @@ int ext4_mb_release(struct super_block *sb)
 	if (sbi->s_mb_stats) {
 		ext4_msg(sb, KERN_INFO,
 		       "mballoc: %u blocks %u reqs (%u success)",
-				atomic_read(&sbi->s_bal_allocated),
-				atomic_read(&sbi->s_bal_reqs),
-				atomic_read(&sbi->s_bal_success));
+				atomic_read_unchecked(&sbi->s_bal_allocated),
+				atomic_read_unchecked(&sbi->s_bal_reqs),
+				atomic_read_unchecked(&sbi->s_bal_success));
 		ext4_msg(sb, KERN_INFO,
 		      "mballoc: %u extents scanned, %u goal hits, "
 				"%u 2^N hits, %u breaks, %u lost",
-				atomic_read(&sbi->s_bal_ex_scanned),
-				atomic_read(&sbi->s_bal_goals),
-				atomic_read(&sbi->s_bal_2orders),
-				atomic_read(&sbi->s_bal_breaks),
-				atomic_read(&sbi->s_mb_lost_chunks));
+				atomic_read_unchecked(&sbi->s_bal_ex_scanned),
+				atomic_read_unchecked(&sbi->s_bal_goals),
+				atomic_read_unchecked(&sbi->s_bal_2orders),
+				atomic_read_unchecked(&sbi->s_bal_breaks),
+				atomic_read_unchecked(&sbi->s_mb_lost_chunks));
 		ext4_msg(sb, KERN_INFO,
 		       "mballoc: %lu generated and it took %Lu",
 				sbi->s_mb_buddies_generated,
 				sbi->s_mb_generation_time);
 		ext4_msg(sb, KERN_INFO,
 		       "mballoc: %u preallocated, %u discarded",
-				atomic_read(&sbi->s_mb_preallocated),
-				atomic_read(&sbi->s_mb_discarded));
+				atomic_read_unchecked(&sbi->s_mb_preallocated),
+				atomic_read_unchecked(&sbi->s_mb_discarded));
 	}
 
 	free_percpu(sbi->s_locality_groups);
@@ -3222,16 +3222,16 @@ static void ext4_mb_collect_stats(struct ext4_allocation_context *ac)
 	struct ext4_sb_info *sbi = EXT4_SB(ac->ac_sb);
 
 	if (sbi->s_mb_stats && ac->ac_g_ex.fe_len > 1) {
-		atomic_inc(&sbi->s_bal_reqs);
-		atomic_add(ac->ac_b_ex.fe_len, &sbi->s_bal_allocated);
+		atomic_inc_unchecked(&sbi->s_bal_reqs);
+		atomic_add_unchecked(ac->ac_b_ex.fe_len, &sbi->s_bal_allocated);
 		if (ac->ac_b_ex.fe_len >= ac->ac_o_ex.fe_len)
-			atomic_inc(&sbi->s_bal_success);
-		atomic_add(ac->ac_found, &sbi->s_bal_ex_scanned);
+			atomic_inc_unchecked(&sbi->s_bal_success);
+		atomic_add_unchecked(ac->ac_found, &sbi->s_bal_ex_scanned);
 		if (ac->ac_g_ex.fe_start == ac->ac_b_ex.fe_start &&
 				ac->ac_g_ex.fe_group == ac->ac_b_ex.fe_group)
-			atomic_inc(&sbi->s_bal_goals);
+			atomic_inc_unchecked(&sbi->s_bal_goals);
 		if (ac->ac_found > sbi->s_mb_max_to_scan)
-			atomic_inc(&sbi->s_bal_breaks);
+			atomic_inc_unchecked(&sbi->s_bal_breaks);
 	}
 
 	if (ac->ac_op == EXT4_MB_HISTORY_ALLOC)
@@ -3658,7 +3658,7 @@ ext4_mb_new_inode_pa(struct ext4_allocation_context *ac)
 	trace_ext4_mb_new_inode_pa(ac, pa);
 
 	ext4_mb_use_inode_pa(ac, pa);
-	atomic_add(pa->pa_free, &sbi->s_mb_preallocated);
+	atomic_add_unchecked(pa->pa_free, &sbi->s_mb_preallocated);
 
 	ei = EXT4_I(ac->ac_inode);
 	grp = ext4_get_group_info(sb, ac->ac_b_ex.fe_group);
@@ -3718,7 +3718,7 @@ ext4_mb_new_group_pa(struct ext4_allocation_context *ac)
 	trace_ext4_mb_new_group_pa(ac, pa);
 
 	ext4_mb_use_group_pa(ac, pa);
-	atomic_add(pa->pa_free, &EXT4_SB(sb)->s_mb_preallocated);
+	atomic_add_unchecked(pa->pa_free, &EXT4_SB(sb)->s_mb_preallocated);
 
 	grp = ext4_get_group_info(sb, ac->ac_b_ex.fe_group);
 	lg = ac->ac_lg;
@@ -3807,7 +3807,7 @@ ext4_mb_release_inode_pa(struct ext4_buddy *e4b, struct buffer_head *bitmap_bh,
 		 * from the bitmap and continue.
 		 */
 	}
-	atomic_add(free, &sbi->s_mb_discarded);
+	atomic_add_unchecked(free, &sbi->s_mb_discarded);
 
 	return err;
 }
@@ -3825,7 +3825,7 @@ ext4_mb_release_group_pa(struct ext4_buddy *e4b,
 	ext4_get_group_no_and_offset(sb, pa->pa_pstart, &group, &bit);
 	BUG_ON(group != e4b->bd_group && pa->pa_len != 0);
 	mb_free_blocks(pa->pa_inode, e4b, bit, pa->pa_len);
-	atomic_add(pa->pa_len, &EXT4_SB(sb)->s_mb_discarded);
+	atomic_add_unchecked(pa->pa_len, &EXT4_SB(sb)->s_mb_discarded);
 	trace_ext4_mballoc_discard(sb, NULL, group, bit, pa->pa_len);
 
 	return 0;
diff --git a/fs/ext4/resize.c b/fs/ext4/resize.c
index cf681004b..f96c5c05f 100644
--- a/fs/ext4/resize.c
+++ b/fs/ext4/resize.c
@@ -413,7 +413,7 @@ static int set_flexbg_block_bitmap(struct super_block *sb, handle_t *handle,
 
 	ext4_debug("mark blocks [%llu/%u] used\n", block, count);
 	for (count2 = count; count > 0; count -= count2, block += count2) {
-		ext4_fsblk_t start;
+		ext4_fsblk_t start, diff;
 		struct buffer_head *bh;
 		ext4_group_t group;
 		int err;
@@ -422,10 +422,6 @@ static int set_flexbg_block_bitmap(struct super_block *sb, handle_t *handle,
 		start = ext4_group_first_block_no(sb, group);
 		group -= flex_gd->groups[0].group;
 
-		count2 = EXT4_BLOCKS_PER_GROUP(sb) - (block - start);
-		if (count2 > count)
-			count2 = count;
-
 		if (flex_gd->bg_flags[group] & EXT4_BG_BLOCK_UNINIT) {
 			BUG_ON(flex_gd->count > 1);
 			continue;
@@ -443,9 +439,15 @@ static int set_flexbg_block_bitmap(struct super_block *sb, handle_t *handle,
 		err = ext4_journal_get_write_access(handle, bh);
 		if (err)
 			return err;
+
+		diff = block - start;
+		count2 = EXT4_BLOCKS_PER_GROUP(sb) - diff;
+		if (count2 > count)
+			count2 = count;
+
 		ext4_debug("mark block bitmap %#04llx (+%llu/%u)\n", block,
-			   block - start, count2);
-		ext4_set_bits(bh->b_data, block - start, count2);
+			   diff, count2);
+		ext4_set_bits(bh->b_data, diff, count2);
 
 		err = ext4_handle_dirty_metadata(handle, NULL, bh);
 		if (unlikely(err))
diff --git a/fs/ext4/super.c b/fs/ext4/super.c
index d0d437768..930df8a75 100644
--- a/fs/ext4/super.c
+++ b/fs/ext4/super.c
@@ -989,10 +989,12 @@ static void init_once(void *foo)
 
 static int __init init_inodecache(void)
 {
-	ext4_inode_cachep = kmem_cache_create("ext4_inode_cache",
+	ext4_inode_cachep = kmem_cache_create_usercopy("ext4_inode_cache",
 					     sizeof(struct ext4_inode_info),
 					     0, (SLAB_RECLAIM_ACCOUNT|
 						SLAB_MEM_SPREAD|SLAB_ACCOUNT),
+					     offsetof(struct ext4_inode_info, i_data),
+					     sizeof(((struct ext4_inode_info *)0)->i_data),
 					     init_once);
 	if (ext4_inode_cachep == NULL)
 		return -ENOMEM;
@@ -1387,7 +1389,7 @@ static ext4_fsblk_t get_sb_block(void **data)
 }
 
 #define DEFAULT_JOURNAL_IOPRIO (IOPRIO_PRIO_VALUE(IOPRIO_CLASS_BE, 3))
-static char deprecated_msg[] = "Mount option \"%s\" will be removed by %s\n"
+static const char deprecated_msg[] = "Mount option \"%s\" will be removed by %s\n"
 	"Contact linux-ext4@vger.kernel.org if you think we should keep it.\n";
 
 #ifdef CONFIG_QUOTA
diff --git a/fs/ext4/sysfs.c b/fs/ext4/sysfs.c
index 42145be5c..1f1db9029 100644
--- a/fs/ext4/sysfs.c
+++ b/fs/ext4/sysfs.c
@@ -45,7 +45,7 @@ struct ext4_attr {
 		int offset;
 		void *explicit_ptr;
 	} u;
-};
+} __do_const;
 
 static ssize_t session_write_kbytes_show(struct ext4_attr *a,
 					 struct ext4_sb_info *sbi, char *buf)
diff --git a/fs/ext4/xattr.c b/fs/ext4/xattr.c
index 2eb935ca5..2fda99e39 100644
--- a/fs/ext4/xattr.c
+++ b/fs/ext4/xattr.c
@@ -418,7 +418,7 @@ static int
 ext4_xattr_list_entries(struct dentry *dentry, struct ext4_xattr_entry *entry,
 			char *buffer, size_t buffer_size)
 {
-	size_t rest = buffer_size;
+	size_t rest = buffer_size, total_size = 0;
 
 	for (; !IS_LAST_ENTRY(entry); entry = EXT4_XATTR_NEXT(entry)) {
 		const struct xattr_handler *handler =
@@ -439,9 +439,10 @@ ext4_xattr_list_entries(struct dentry *dentry, struct ext4_xattr_entry *entry,
 				*buffer++ = 0;
 			}
 			rest -= size;
+			total_size += size;
 		}
 	}
-	return buffer_size - rest;  /* total size */
+	return total_size;
 }
 
 static int
diff --git a/fs/f2fs/f2fs.h b/fs/f2fs/f2fs.h
index 8467f4221..85514663b 100644
--- a/fs/f2fs/f2fs.h
+++ b/fs/f2fs/f2fs.h
@@ -50,7 +50,7 @@ enum {
 };
 
 struct f2fs_fault_info {
-	atomic_t inject_ops;
+	atomic_unchecked_t inject_ops;
 	unsigned int inject_rate;
 	unsigned int inject_type;
 };
@@ -78,9 +78,8 @@ static inline bool time_to_inject(int type)
 	else if (type == FAULT_EVICT_INODE && !IS_FAULT_SET(type))
 		return false;
 
-	atomic_inc(&f2fs_fault.inject_ops);
-	if (atomic_read(&f2fs_fault.inject_ops) >= f2fs_fault.inject_rate) {
-		atomic_set(&f2fs_fault.inject_ops, 0);
+	if (atomic_inc_return_unchecked(&f2fs_fault.inject_ops) >= f2fs_fault.inject_rate) {
+		atomic_set_unchecked(&f2fs_fault.inject_ops, 0);
 		printk("%sF2FS-fs : inject %s in %pF\n",
 				KERN_INFO,
 				fault_name[type],
diff --git a/fs/f2fs/super.c b/fs/f2fs/super.c
index 37edc853c..600131ae3 100644
--- a/fs/f2fs/super.c
+++ b/fs/f2fs/super.c
@@ -55,7 +55,7 @@ char *fault_name[FAULT_MAX] = {
 static void f2fs_build_fault_attr(unsigned int rate)
 {
 	if (rate) {
-		atomic_set(&f2fs_fault.inject_ops, 0);
+		atomic_set_unchecked(&f2fs_fault.inject_ops, 0);
 		f2fs_fault.inject_rate = rate;
 		f2fs_fault.inject_type = (1 << FAULT_MAX) - 1;
 	} else {
diff --git a/fs/fcntl.c b/fs/fcntl.c
index 350a2c8cf..9fb9bf7d2 100644
--- a/fs/fcntl.c
+++ b/fs/fcntl.c
@@ -103,6 +103,10 @@ void __f_setown(struct file *filp, struct pid *pid, enum pid_type type,
 		int force)
 {
 	security_file_set_fowner(filp);
+	if (gr_handle_chroot_fowner(pid, type))
+		return;
+	if (gr_check_protected_task_fowner(pid, type))
+		return;
 	f_modown(filp, pid, type, force);
 }
 EXPORT_SYMBOL(__f_setown);
diff --git a/fs/fhandle.c b/fs/fhandle.c
index ca3c3dd01..0c5456e09 100644
--- a/fs/fhandle.c
+++ b/fs/fhandle.c
@@ -8,6 +8,7 @@
 #include <linux/fs_struct.h>
 #include <linux/fsnotify.h>
 #include <linux/personality.h>
+#include <linux/grsecurity.h>
 #include <asm/uaccess.h>
 #include "internal.h"
 #include "mount.h"
@@ -67,8 +68,7 @@ static long do_sys_name_to_handle(struct path *path,
 	} else
 		retval = 0;
 	/* copy the mount id */
-	if (copy_to_user(mnt_id, &real_mount(path->mnt)->mnt_id,
-			 sizeof(*mnt_id)) ||
+	if (put_user(real_mount(path->mnt)->mnt_id, mnt_id) ||
 	    copy_to_user(ufh, handle,
 			 sizeof(struct file_handle) + handle_bytes))
 		retval = -EFAULT;
@@ -175,7 +175,7 @@ static int handle_to_path(int mountdirfd, struct file_handle __user *ufh,
 	 * the directory. Ideally we would like CAP_DAC_SEARCH.
 	 * But we don't have that
 	 */
-	if (!capable(CAP_DAC_READ_SEARCH)) {
+	if (!capable(CAP_DAC_READ_SEARCH) || !gr_chroot_fhandle()) {
 		retval = -EPERM;
 		goto out_err;
 	}
@@ -197,7 +197,7 @@ static int handle_to_path(int mountdirfd, struct file_handle __user *ufh,
 	/* copy the full handle */
 	*handle = f_handle;
 	if (copy_from_user(&handle->f_handle,
-			   &ufh->f_handle,
+			   ufh->f_handle,
 			   f_handle.handle_bytes)) {
 		retval = -EFAULT;
 		goto out_handle;
diff --git a/fs/file.c b/fs/file.c
index 6b1acdfe5..b908ebae5 100644
--- a/fs/file.c
+++ b/fs/file.c
@@ -16,6 +16,7 @@
 #include <linux/slab.h>
 #include <linux/vmalloc.h>
 #include <linux/file.h>
+#include <linux/security.h>
 #include <linux/fdtable.h>
 #include <linux/bitops.h>
 #include <linux/interrupt.h>
@@ -163,9 +164,10 @@ out:
  * Return <0 error code on error; 1 on successful completion.
  * The files->file_lock should be held on entry, and will be held on exit.
  */
-static int expand_fdtable(struct files_struct *files, int nr)
-	__releases(files->file_lock)
-	__acquires(files->file_lock)
+static int expand_fdtable(struct files_struct *files, unsigned int nr)
+	__releases(&files->file_lock)
+	__acquires(&files->file_lock);
+static int expand_fdtable(struct files_struct *files, unsigned int nr)
 {
 	struct fdtable *new_fdt, *cur_fdt;
 
@@ -208,9 +210,10 @@ static int expand_fdtable(struct files_struct *files, int nr)
  * expanded and execution may have blocked.
  * The files->file_lock should be held on entry, and will be held on exit.
  */
-static int expand_files(struct files_struct *files, int nr)
-	__releases(files->file_lock)
-	__acquires(files->file_lock)
+static int expand_files(struct files_struct *files, unsigned int nr)
+	__releases(&files->file_lock)
+	__acquires(&files->file_lock);
+static int expand_files(struct files_struct *files, unsigned int nr)
 {
 	struct fdtable *fdt;
 	int expanded = 0;
@@ -822,7 +825,9 @@ bool get_close_on_exec(unsigned int fd)
 
 static int do_dup2(struct files_struct *files,
 	struct file *file, unsigned fd, unsigned flags)
-__releases(&files->file_lock)
+__releases(&files->file_lock);
+static int do_dup2(struct files_struct *files,
+	struct file *file, unsigned fd, unsigned flags)
 {
 	struct file *tofree;
 	struct fdtable *fdt;
@@ -872,6 +877,7 @@ int replace_fd(unsigned fd, struct file *file, unsigned flags)
 	if (!file)
 		return __close_fd(files, fd);
 
+	gr_learn_resource(current, RLIMIT_NOFILE, fd, 0);
 	if (fd >= rlimit(RLIMIT_NOFILE))
 		return -EBADF;
 
@@ -898,6 +904,7 @@ SYSCALL_DEFINE3(dup3, unsigned int, oldfd, unsigned int, newfd, int, flags)
 	if (unlikely(oldfd == newfd))
 		return -EINVAL;
 
+	gr_learn_resource(current, RLIMIT_NOFILE, newfd, 0);
 	if (newfd >= rlimit(RLIMIT_NOFILE))
 		return -EBADF;
 
@@ -953,6 +960,7 @@ SYSCALL_DEFINE1(dup, unsigned int, fildes)
 int f_dupfd(unsigned int from, struct file *file, unsigned flags)
 {
 	int err;
+	gr_learn_resource(current, RLIMIT_NOFILE, from, 0);
 	if (from >= rlimit(RLIMIT_NOFILE))
 		return -EINVAL;
 	err = alloc_fd(from, flags);
diff --git a/fs/filesystems.c b/fs/filesystems.c
index c5618db11..50c38f47c 100644
--- a/fs/filesystems.c
+++ b/fs/filesystems.c
@@ -275,7 +275,11 @@ struct file_system_type *get_fs_type(const char *name)
 	int len = dot ? dot - name : strlen(name);
 
 	fs = __get_fs_type(name, len);
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+	if (!fs && (___request_module(true, "grsec_modharden_fs", "fs-%.*s", len, name) == 0))
+#else
 	if (!fs && (request_module("fs-%.*s", len, name) == 0))
+#endif
 		fs = __get_fs_type(name, len);
 
 	if (dot && fs && !(fs->fs_flags & FS_HAS_SUBTYPE)) {
diff --git a/fs/freevxfs/vxfs_super.c b/fs/freevxfs/vxfs_super.c
index 455ce5b77..ec65e7ed4 100644
--- a/fs/freevxfs/vxfs_super.c
+++ b/fs/freevxfs/vxfs_super.c
@@ -332,9 +332,11 @@ vxfs_init(void)
 {
 	int rv;
 
-	vxfs_inode_cachep = kmem_cache_create("vxfs_inode",
+	vxfs_inode_cachep = kmem_cache_create_usercopy("vxfs_inode",
 			sizeof(struct vxfs_inode_info), 0,
-			SLAB_RECLAIM_ACCOUNT|SLAB_MEM_SPREAD, NULL);
+			SLAB_RECLAIM_ACCOUNT|SLAB_MEM_SPREAD,
+			offsetof(struct vxfs_inode_info, vii_immed.vi_immed),
+			sizeof(((struct vxfs_inode_info *)0)->vii_immed.vi_immed),  NULL);
 	if (!vxfs_inode_cachep)
 		return -ENOMEM;
 	rv = register_filesystem(&vxfs_fs_type);
diff --git a/fs/fs-writeback.c b/fs/fs-writeback.c
index 05713a5da..6cfd433aa 100644
--- a/fs/fs-writeback.c
+++ b/fs/fs-writeback.c
@@ -880,9 +880,9 @@ fs_initcall(cgroup_writeback_init);
 #else	/* CONFIG_CGROUP_WRITEBACK */
 
 static struct bdi_writeback *
+locked_inode_to_wb_and_lock_list(struct inode *inode) __releases(&inode->i_lock) __acquires(&wb->list_lock);
+static struct bdi_writeback *
 locked_inode_to_wb_and_lock_list(struct inode *inode)
-	__releases(&inode->i_lock)
-	__acquires(&wb->list_lock)
 {
 	struct bdi_writeback *wb = inode_to_wb(inode);
 
@@ -891,8 +891,8 @@ locked_inode_to_wb_and_lock_list(struct inode *inode)
 	return wb;
 }
 
+static struct bdi_writeback *inode_to_wb_and_lock_list(struct inode *inode) __acquires(&wb->list_lock);
 static struct bdi_writeback *inode_to_wb_and_lock_list(struct inode *inode)
-	__acquires(&wb->list_lock)
 {
 	struct bdi_writeback *wb = inode_to_wb(inode);
 
@@ -1173,9 +1173,8 @@ static int write_inode(struct inode *inode, struct writeback_control *wbc)
  * Wait for writeback on an inode to complete. Called with i_lock held.
  * Caller must make sure inode cannot go away when we drop i_lock.
  */
+static void __inode_wait_for_writeback(struct inode *inode) __must_hold(&inode->i_lock);
 static void __inode_wait_for_writeback(struct inode *inode)
-	__releases(inode->i_lock)
-	__acquires(inode->i_lock)
 {
 	DEFINE_WAIT_BIT(wq, &inode->i_state, __I_SYNC);
 	wait_queue_head_t *wqh;
@@ -1204,8 +1203,8 @@ void inode_wait_for_writeback(struct inode *inode)
  * held and drops it. It is aimed for callers not holding any inode reference
  * so once i_lock is dropped, inode can go away.
  */
+static void inode_sleep_on_writeback(struct inode *inode) __releases(&inode->i_lock);
 static void inode_sleep_on_writeback(struct inode *inode)
-	__releases(inode->i_lock)
 {
 	DEFINE_WAIT(wait);
 	wait_queue_head_t *wqh = bit_waitqueue(&inode->i_state, __I_SYNC);
diff --git a/fs/fs_struct.c b/fs/fs_struct.c
index 7dca743b2..1ff87ae13 100644
--- a/fs/fs_struct.c
+++ b/fs/fs_struct.c
@@ -4,6 +4,7 @@
 #include <linux/path.h>
 #include <linux/slab.h>
 #include <linux/fs_struct.h>
+#include <linux/grsecurity.h>
 #include "internal.h"
 
 /*
@@ -15,14 +16,18 @@ void set_fs_root(struct fs_struct *fs, const struct path *path)
 	struct path old_root;
 
 	path_get(path);
+	gr_inc_chroot_refcnts(path->dentry, path->mnt);
 	spin_lock(&fs->lock);
 	write_seqcount_begin(&fs->seq);
 	old_root = fs->root;
 	fs->root = *path;
+	gr_set_chroot_entries(current, path);
 	write_seqcount_end(&fs->seq);
 	spin_unlock(&fs->lock);
-	if (old_root.dentry)
+	if (old_root.dentry) {
+		gr_dec_chroot_refcnts(old_root.dentry, old_root.mnt);
 		path_put(&old_root);
+	}
 }
 
 /*
@@ -67,6 +72,10 @@ void chroot_fs_refs(const struct path *old_root, const struct path *new_root)
 			int hits = 0;
 			spin_lock(&fs->lock);
 			write_seqcount_begin(&fs->seq);
+			/* this root replacement is only done by pivot_root,
+			   leave grsec's chroot tagging alone for this task
+			   so that a pivoted root isn't treated as a chroot
+			*/
 			hits += replace_path(&fs->root, old_root, new_root);
 			hits += replace_path(&fs->pwd, old_root, new_root);
 			write_seqcount_end(&fs->seq);
@@ -85,6 +94,7 @@ void chroot_fs_refs(const struct path *old_root, const struct path *new_root)
 
 void free_fs_struct(struct fs_struct *fs)
 {
+	gr_dec_chroot_refcnts(fs->root.dentry, fs->root.mnt);
 	path_put(&fs->root);
 	path_put(&fs->pwd);
 	kmem_cache_free(fs_cachep, fs);
@@ -99,7 +109,8 @@ void exit_fs(struct task_struct *tsk)
 		task_lock(tsk);
 		spin_lock(&fs->lock);
 		tsk->fs = NULL;
-		kill = !--fs->users;
+		gr_clear_chroot_entries(tsk);
+		kill = !atomic_dec_return(&fs->users);
 		spin_unlock(&fs->lock);
 		task_unlock(tsk);
 		if (kill)
@@ -112,7 +123,7 @@ struct fs_struct *copy_fs_struct(struct fs_struct *old)
 	struct fs_struct *fs = kmem_cache_alloc(fs_cachep, GFP_KERNEL);
 	/* We don't need to lock fs - think why ;-) */
 	if (fs) {
-		fs->users = 1;
+		atomic_set(&fs->users, 1);
 		fs->in_exec = 0;
 		spin_lock_init(&fs->lock);
 		seqcount_init(&fs->seq);
@@ -121,9 +132,13 @@ struct fs_struct *copy_fs_struct(struct fs_struct *old)
 		spin_lock(&old->lock);
 		fs->root = old->root;
 		path_get(&fs->root);
+		/* instead of calling gr_set_chroot_entries here,
+		   we call it from every caller of this function
+		*/
 		fs->pwd = old->pwd;
 		path_get(&fs->pwd);
 		spin_unlock(&old->lock);
+		gr_inc_chroot_refcnts(fs->root.dentry, fs->root.mnt);
 	}
 	return fs;
 }
@@ -139,8 +154,9 @@ int unshare_fs_struct(void)
 
 	task_lock(current);
 	spin_lock(&fs->lock);
-	kill = !--fs->users;
+	kill = !atomic_dec_return(&fs->users);
 	current->fs = new_fs;
+	gr_set_chroot_entries(current, &new_fs->root);
 	spin_unlock(&fs->lock);
 	task_unlock(current);
 
@@ -153,13 +169,13 @@ EXPORT_SYMBOL_GPL(unshare_fs_struct);
 
 int current_umask(void)
 {
-	return current->fs->umask;
+	return current->fs->umask | gr_acl_umask();
 }
 EXPORT_SYMBOL(current_umask);
 
 /* to be mentioned only in INIT_TASK */
 struct fs_struct init_fs = {
-	.users		= 1,
+	.users		= ATOMIC_INIT(1),
 	.lock		= __SPIN_LOCK_UNLOCKED(init_fs.lock),
 	.seq		= SEQCNT_ZERO(init_fs.seq),
 	.umask		= 0022,
diff --git a/fs/fscache/cookie.c b/fs/fscache/cookie.c
index 430407216..278019114 100644
--- a/fs/fscache/cookie.c
+++ b/fs/fscache/cookie.c
@@ -19,7 +19,7 @@
 
 struct kmem_cache *fscache_cookie_jar;
 
-static atomic_t fscache_object_debug_id = ATOMIC_INIT(0);
+static atomic_unchecked_t fscache_object_debug_id = ATOMIC_INIT(0);
 
 static int fscache_acquire_non_index_cookie(struct fscache_cookie *cookie);
 static int fscache_alloc_object(struct fscache_cache *cache,
@@ -69,11 +69,11 @@ struct fscache_cookie *__fscache_acquire_cookie(
 	       parent ? (char *) parent->def->name : "<no-parent>",
 	       def->name, netfs_data, enable);
 
-	fscache_stat(&fscache_n_acquires);
+	fscache_stat_unchecked(&fscache_n_acquires);
 
 	/* if there's no parent cookie, then we don't create one here either */
 	if (!parent) {
-		fscache_stat(&fscache_n_acquires_null);
+		fscache_stat_unchecked(&fscache_n_acquires_null);
 		_leave(" [no parent]");
 		return NULL;
 	}
@@ -88,7 +88,7 @@ struct fscache_cookie *__fscache_acquire_cookie(
 	/* allocate and initialise a cookie */
 	cookie = kmem_cache_alloc(fscache_cookie_jar, GFP_KERNEL);
 	if (!cookie) {
-		fscache_stat(&fscache_n_acquires_oom);
+		fscache_stat_unchecked(&fscache_n_acquires_oom);
 		_leave(" [ENOMEM]");
 		return NULL;
 	}
@@ -115,13 +115,13 @@ struct fscache_cookie *__fscache_acquire_cookie(
 
 	switch (cookie->def->type) {
 	case FSCACHE_COOKIE_TYPE_INDEX:
-		fscache_stat(&fscache_n_cookie_index);
+		fscache_stat_unchecked(&fscache_n_cookie_index);
 		break;
 	case FSCACHE_COOKIE_TYPE_DATAFILE:
-		fscache_stat(&fscache_n_cookie_data);
+		fscache_stat_unchecked(&fscache_n_cookie_data);
 		break;
 	default:
-		fscache_stat(&fscache_n_cookie_special);
+		fscache_stat_unchecked(&fscache_n_cookie_special);
 		break;
 	}
 
@@ -135,7 +135,7 @@ struct fscache_cookie *__fscache_acquire_cookie(
 			} else {
 				atomic_dec(&parent->n_children);
 				__fscache_cookie_put(cookie);
-				fscache_stat(&fscache_n_acquires_nobufs);
+				fscache_stat_unchecked(&fscache_n_acquires_nobufs);
 				_leave(" = NULL");
 				return NULL;
 			}
@@ -144,7 +144,7 @@ struct fscache_cookie *__fscache_acquire_cookie(
 		}
 	}
 
-	fscache_stat(&fscache_n_acquires_ok);
+	fscache_stat_unchecked(&fscache_n_acquires_ok);
 	_leave(" = %p", cookie);
 	return cookie;
 }
@@ -213,7 +213,7 @@ static int fscache_acquire_non_index_cookie(struct fscache_cookie *cookie)
 	cache = fscache_select_cache_for_object(cookie->parent);
 	if (!cache) {
 		up_read(&fscache_addremove_sem);
-		fscache_stat(&fscache_n_acquires_no_cache);
+		fscache_stat_unchecked(&fscache_n_acquires_no_cache);
 		_leave(" = -ENOMEDIUM [no cache]");
 		return -ENOMEDIUM;
 	}
@@ -297,14 +297,14 @@ static int fscache_alloc_object(struct fscache_cache *cache,
 	object = cache->ops->alloc_object(cache, cookie);
 	fscache_stat_d(&fscache_n_cop_alloc_object);
 	if (IS_ERR(object)) {
-		fscache_stat(&fscache_n_object_no_alloc);
+		fscache_stat_unchecked(&fscache_n_object_no_alloc);
 		ret = PTR_ERR(object);
 		goto error;
 	}
 
-	fscache_stat(&fscache_n_object_alloc);
+	fscache_stat_unchecked(&fscache_n_object_alloc);
 
-	object->debug_id = atomic_inc_return(&fscache_object_debug_id);
+	object->debug_id = atomic_inc_return_unchecked(&fscache_object_debug_id);
 
 	_debug("ALLOC OBJ%x: %s {%lx}",
 	       object->debug_id, cookie->def->name, object->events);
@@ -419,7 +419,7 @@ void __fscache_invalidate(struct fscache_cookie *cookie)
 
 	_enter("{%s}", cookie->def->name);
 
-	fscache_stat(&fscache_n_invalidates);
+	fscache_stat_unchecked(&fscache_n_invalidates);
 
 	/* Only permit invalidation of data files.  Invalidating an index will
 	 * require the caller to release all its attachments to the tree rooted
@@ -477,10 +477,10 @@ void __fscache_update_cookie(struct fscache_cookie *cookie)
 {
 	struct fscache_object *object;
 
-	fscache_stat(&fscache_n_updates);
+	fscache_stat_unchecked(&fscache_n_updates);
 
 	if (!cookie) {
-		fscache_stat(&fscache_n_updates_null);
+		fscache_stat_unchecked(&fscache_n_updates_null);
 		_leave(" [no cookie]");
 		return;
 	}
@@ -581,12 +581,12 @@ EXPORT_SYMBOL(__fscache_disable_cookie);
  */
 void __fscache_relinquish_cookie(struct fscache_cookie *cookie, bool retire)
 {
-	fscache_stat(&fscache_n_relinquishes);
+	fscache_stat_unchecked(&fscache_n_relinquishes);
 	if (retire)
-		fscache_stat(&fscache_n_relinquishes_retire);
+		fscache_stat_unchecked(&fscache_n_relinquishes_retire);
 
 	if (!cookie) {
-		fscache_stat(&fscache_n_relinquishes_null);
+		fscache_stat_unchecked(&fscache_n_relinquishes_null);
 		_leave(" [no cookie]");
 		return;
 	}
@@ -687,7 +687,7 @@ int __fscache_check_consistency(struct fscache_cookie *cookie)
 	if (test_bit(FSCACHE_IOERROR, &object->cache->flags))
 		goto inconsistent;
 
-	op->debug_id = atomic_inc_return(&fscache_op_debug_id);
+	op->debug_id = atomic_inc_return_unchecked(&fscache_op_debug_id);
 
 	__fscache_use_cookie(cookie);
 	if (fscache_submit_op(object, op) < 0)
diff --git a/fs/fscache/internal.h b/fs/fscache/internal.h
index 97ec45110..f722cee55 100644
--- a/fs/fscache/internal.h
+++ b/fs/fscache/internal.h
@@ -136,8 +136,8 @@ extern void fscache_operation_gc(struct work_struct *);
 extern int fscache_wait_for_deferred_lookup(struct fscache_cookie *);
 extern int fscache_wait_for_operation_activation(struct fscache_object *,
 						 struct fscache_operation *,
-						 atomic_t *,
-						 atomic_t *);
+						 atomic_unchecked_t *,
+						 atomic_unchecked_t *);
 extern void fscache_invalidate_writes(struct fscache_cookie *);
 
 /*
@@ -155,102 +155,102 @@ extern void fscache_proc_cleanup(void);
  * stats.c
  */
 #ifdef CONFIG_FSCACHE_STATS
-extern atomic_t fscache_n_ops_processed[FSCACHE_MAX_THREADS];
-extern atomic_t fscache_n_objs_processed[FSCACHE_MAX_THREADS];
-
-extern atomic_t fscache_n_op_pend;
-extern atomic_t fscache_n_op_run;
-extern atomic_t fscache_n_op_enqueue;
-extern atomic_t fscache_n_op_deferred_release;
-extern atomic_t fscache_n_op_initialised;
-extern atomic_t fscache_n_op_release;
-extern atomic_t fscache_n_op_gc;
-extern atomic_t fscache_n_op_cancelled;
-extern atomic_t fscache_n_op_rejected;
-
-extern atomic_t fscache_n_attr_changed;
-extern atomic_t fscache_n_attr_changed_ok;
-extern atomic_t fscache_n_attr_changed_nobufs;
-extern atomic_t fscache_n_attr_changed_nomem;
-extern atomic_t fscache_n_attr_changed_calls;
-
-extern atomic_t fscache_n_allocs;
-extern atomic_t fscache_n_allocs_ok;
-extern atomic_t fscache_n_allocs_wait;
-extern atomic_t fscache_n_allocs_nobufs;
-extern atomic_t fscache_n_allocs_intr;
-extern atomic_t fscache_n_allocs_object_dead;
-extern atomic_t fscache_n_alloc_ops;
-extern atomic_t fscache_n_alloc_op_waits;
-
-extern atomic_t fscache_n_retrievals;
-extern atomic_t fscache_n_retrievals_ok;
-extern atomic_t fscache_n_retrievals_wait;
-extern atomic_t fscache_n_retrievals_nodata;
-extern atomic_t fscache_n_retrievals_nobufs;
-extern atomic_t fscache_n_retrievals_intr;
-extern atomic_t fscache_n_retrievals_nomem;
-extern atomic_t fscache_n_retrievals_object_dead;
-extern atomic_t fscache_n_retrieval_ops;
-extern atomic_t fscache_n_retrieval_op_waits;
-
-extern atomic_t fscache_n_stores;
-extern atomic_t fscache_n_stores_ok;
-extern atomic_t fscache_n_stores_again;
-extern atomic_t fscache_n_stores_nobufs;
-extern atomic_t fscache_n_stores_oom;
-extern atomic_t fscache_n_store_ops;
-extern atomic_t fscache_n_store_calls;
-extern atomic_t fscache_n_store_pages;
-extern atomic_t fscache_n_store_radix_deletes;
-extern atomic_t fscache_n_store_pages_over_limit;
-
-extern atomic_t fscache_n_store_vmscan_not_storing;
-extern atomic_t fscache_n_store_vmscan_gone;
-extern atomic_t fscache_n_store_vmscan_busy;
-extern atomic_t fscache_n_store_vmscan_cancelled;
-extern atomic_t fscache_n_store_vmscan_wait;
-
-extern atomic_t fscache_n_marks;
-extern atomic_t fscache_n_uncaches;
-
-extern atomic_t fscache_n_acquires;
-extern atomic_t fscache_n_acquires_null;
-extern atomic_t fscache_n_acquires_no_cache;
-extern atomic_t fscache_n_acquires_ok;
-extern atomic_t fscache_n_acquires_nobufs;
-extern atomic_t fscache_n_acquires_oom;
-
-extern atomic_t fscache_n_invalidates;
-extern atomic_t fscache_n_invalidates_run;
-
-extern atomic_t fscache_n_updates;
-extern atomic_t fscache_n_updates_null;
-extern atomic_t fscache_n_updates_run;
-
-extern atomic_t fscache_n_relinquishes;
-extern atomic_t fscache_n_relinquishes_null;
-extern atomic_t fscache_n_relinquishes_waitcrt;
-extern atomic_t fscache_n_relinquishes_retire;
-
-extern atomic_t fscache_n_cookie_index;
-extern atomic_t fscache_n_cookie_data;
-extern atomic_t fscache_n_cookie_special;
-
-extern atomic_t fscache_n_object_alloc;
-extern atomic_t fscache_n_object_no_alloc;
-extern atomic_t fscache_n_object_lookups;
-extern atomic_t fscache_n_object_lookups_negative;
-extern atomic_t fscache_n_object_lookups_positive;
-extern atomic_t fscache_n_object_lookups_timed_out;
-extern atomic_t fscache_n_object_created;
-extern atomic_t fscache_n_object_avail;
-extern atomic_t fscache_n_object_dead;
-
-extern atomic_t fscache_n_checkaux_none;
-extern atomic_t fscache_n_checkaux_okay;
-extern atomic_t fscache_n_checkaux_update;
-extern atomic_t fscache_n_checkaux_obsolete;
+extern atomic_unchecked_t fscache_n_ops_processed[FSCACHE_MAX_THREADS];
+extern atomic_unchecked_t fscache_n_objs_processed[FSCACHE_MAX_THREADS];
+
+extern atomic_unchecked_t fscache_n_op_pend;
+extern atomic_unchecked_t fscache_n_op_run;
+extern atomic_unchecked_t fscache_n_op_enqueue;
+extern atomic_unchecked_t fscache_n_op_deferred_release;
+extern atomic_unchecked_t fscache_n_op_initialised;
+extern atomic_unchecked_t fscache_n_op_release;
+extern atomic_unchecked_t fscache_n_op_gc;
+extern atomic_unchecked_t fscache_n_op_cancelled;
+extern atomic_unchecked_t fscache_n_op_rejected;
+
+extern atomic_unchecked_t fscache_n_attr_changed;
+extern atomic_unchecked_t fscache_n_attr_changed_ok;
+extern atomic_unchecked_t fscache_n_attr_changed_nobufs;
+extern atomic_unchecked_t fscache_n_attr_changed_nomem;
+extern atomic_unchecked_t fscache_n_attr_changed_calls;
+
+extern atomic_unchecked_t fscache_n_allocs;
+extern atomic_unchecked_t fscache_n_allocs_ok;
+extern atomic_unchecked_t fscache_n_allocs_wait;
+extern atomic_unchecked_t fscache_n_allocs_nobufs;
+extern atomic_unchecked_t fscache_n_allocs_intr;
+extern atomic_unchecked_t fscache_n_allocs_object_dead;
+extern atomic_unchecked_t fscache_n_alloc_ops;
+extern atomic_unchecked_t fscache_n_alloc_op_waits;
+
+extern atomic_unchecked_t fscache_n_retrievals;
+extern atomic_unchecked_t fscache_n_retrievals_ok;
+extern atomic_unchecked_t fscache_n_retrievals_wait;
+extern atomic_unchecked_t fscache_n_retrievals_nodata;
+extern atomic_unchecked_t fscache_n_retrievals_nobufs;
+extern atomic_unchecked_t fscache_n_retrievals_intr;
+extern atomic_unchecked_t fscache_n_retrievals_nomem;
+extern atomic_unchecked_t fscache_n_retrievals_object_dead;
+extern atomic_unchecked_t fscache_n_retrieval_ops;
+extern atomic_unchecked_t fscache_n_retrieval_op_waits;
+
+extern atomic_unchecked_t fscache_n_stores;
+extern atomic_unchecked_t fscache_n_stores_ok;
+extern atomic_unchecked_t fscache_n_stores_again;
+extern atomic_unchecked_t fscache_n_stores_nobufs;
+extern atomic_unchecked_t fscache_n_stores_oom;
+extern atomic_unchecked_t fscache_n_store_ops;
+extern atomic_unchecked_t fscache_n_store_calls;
+extern atomic_unchecked_t fscache_n_store_pages;
+extern atomic_unchecked_t fscache_n_store_radix_deletes;
+extern atomic_unchecked_t fscache_n_store_pages_over_limit;
+
+extern atomic_unchecked_t fscache_n_store_vmscan_not_storing;
+extern atomic_unchecked_t fscache_n_store_vmscan_gone;
+extern atomic_unchecked_t fscache_n_store_vmscan_busy;
+extern atomic_unchecked_t fscache_n_store_vmscan_cancelled;
+extern atomic_unchecked_t fscache_n_store_vmscan_wait;
+
+extern atomic_unchecked_t fscache_n_marks;
+extern atomic_unchecked_t fscache_n_uncaches;
+
+extern atomic_unchecked_t fscache_n_acquires;
+extern atomic_unchecked_t fscache_n_acquires_null;
+extern atomic_unchecked_t fscache_n_acquires_no_cache;
+extern atomic_unchecked_t fscache_n_acquires_ok;
+extern atomic_unchecked_t fscache_n_acquires_nobufs;
+extern atomic_unchecked_t fscache_n_acquires_oom;
+
+extern atomic_unchecked_t fscache_n_invalidates;
+extern atomic_unchecked_t fscache_n_invalidates_run;
+
+extern atomic_unchecked_t fscache_n_updates;
+extern atomic_unchecked_t fscache_n_updates_null;
+extern atomic_unchecked_t fscache_n_updates_run;
+
+extern atomic_unchecked_t fscache_n_relinquishes;
+extern atomic_unchecked_t fscache_n_relinquishes_null;
+extern atomic_unchecked_t fscache_n_relinquishes_waitcrt;
+extern atomic_unchecked_t fscache_n_relinquishes_retire;
+
+extern atomic_unchecked_t fscache_n_cookie_index;
+extern atomic_unchecked_t fscache_n_cookie_data;
+extern atomic_unchecked_t fscache_n_cookie_special;
+
+extern atomic_unchecked_t fscache_n_object_alloc;
+extern atomic_unchecked_t fscache_n_object_no_alloc;
+extern atomic_unchecked_t fscache_n_object_lookups;
+extern atomic_unchecked_t fscache_n_object_lookups_negative;
+extern atomic_unchecked_t fscache_n_object_lookups_positive;
+extern atomic_unchecked_t fscache_n_object_lookups_timed_out;
+extern atomic_unchecked_t fscache_n_object_created;
+extern atomic_unchecked_t fscache_n_object_avail;
+extern atomic_unchecked_t fscache_n_object_dead;
+
+extern atomic_unchecked_t fscache_n_checkaux_none;
+extern atomic_unchecked_t fscache_n_checkaux_okay;
+extern atomic_unchecked_t fscache_n_checkaux_update;
+extern atomic_unchecked_t fscache_n_checkaux_obsolete;
 
 extern atomic_t fscache_n_cop_alloc_object;
 extern atomic_t fscache_n_cop_lookup_object;
@@ -280,6 +280,11 @@ static inline void fscache_stat(atomic_t *stat)
 	atomic_inc(stat);
 }
 
+static inline void fscache_stat_unchecked(atomic_unchecked_t *stat)
+{
+	atomic_inc_unchecked(stat);
+}
+
 static inline void fscache_stat_d(atomic_t *stat)
 {
 	atomic_dec(stat);
@@ -292,6 +297,7 @@ extern const struct file_operations fscache_stats_fops;
 
 #define __fscache_stat(stat) (NULL)
 #define fscache_stat(stat) do {} while (0)
+#define fscache_stat_unchecked(stat) do {} while (0)
 #define fscache_stat_d(stat) do {} while (0)
 #endif
 
diff --git a/fs/fscache/object.c b/fs/fscache/object.c
index 9e792e30f..6b2affb35 100644
--- a/fs/fscache/object.c
+++ b/fs/fscache/object.c
@@ -465,7 +465,7 @@ static const struct fscache_state *fscache_look_up_object(struct fscache_object
 	_debug("LOOKUP \"%s\" in \"%s\"",
 	       cookie->def->name, object->cache->tag->name);
 
-	fscache_stat(&fscache_n_object_lookups);
+	fscache_stat_unchecked(&fscache_n_object_lookups);
 	fscache_stat(&fscache_n_cop_lookup_object);
 	ret = object->cache->ops->lookup_object(object);
 	fscache_stat_d(&fscache_n_cop_lookup_object);
@@ -475,7 +475,7 @@ static const struct fscache_state *fscache_look_up_object(struct fscache_object
 	if (ret == -ETIMEDOUT) {
 		/* probably stuck behind another object, so move this one to
 		 * the back of the queue */
-		fscache_stat(&fscache_n_object_lookups_timed_out);
+		fscache_stat_unchecked(&fscache_n_object_lookups_timed_out);
 		_leave(" [timeout]");
 		return NO_TRANSIT;
 	}
@@ -503,7 +503,7 @@ void fscache_object_lookup_negative(struct fscache_object *object)
 	_enter("{OBJ%x,%s}", object->debug_id, object->state->name);
 
 	if (!test_and_set_bit(FSCACHE_OBJECT_IS_LOOKED_UP, &object->flags)) {
-		fscache_stat(&fscache_n_object_lookups_negative);
+		fscache_stat_unchecked(&fscache_n_object_lookups_negative);
 
 		/* Allow write requests to begin stacking up and read requests to begin
 		 * returning ENODATA.
@@ -538,7 +538,7 @@ void fscache_obtained_object(struct fscache_object *object)
 	/* if we were still looking up, then we must have a positive lookup
 	 * result, in which case there may be data available */
 	if (!test_and_set_bit(FSCACHE_OBJECT_IS_LOOKED_UP, &object->flags)) {
-		fscache_stat(&fscache_n_object_lookups_positive);
+		fscache_stat_unchecked(&fscache_n_object_lookups_positive);
 
 		/* We do (presumably) have data */
 		clear_bit_unlock(FSCACHE_COOKIE_NO_DATA_YET, &cookie->flags);
@@ -550,7 +550,7 @@ void fscache_obtained_object(struct fscache_object *object)
 		clear_bit_unlock(FSCACHE_COOKIE_LOOKING_UP, &cookie->flags);
 		wake_up_bit(&cookie->flags, FSCACHE_COOKIE_LOOKING_UP);
 	} else {
-		fscache_stat(&fscache_n_object_created);
+		fscache_stat_unchecked(&fscache_n_object_created);
 	}
 
 	set_bit(FSCACHE_OBJECT_IS_AVAILABLE, &object->flags);
@@ -586,7 +586,7 @@ static const struct fscache_state *fscache_object_available(struct fscache_objec
 	fscache_stat_d(&fscache_n_cop_lookup_complete);
 
 	fscache_hist(fscache_obj_instantiate_histogram, object->lookup_jif);
-	fscache_stat(&fscache_n_object_avail);
+	fscache_stat_unchecked(&fscache_n_object_avail);
 
 	_leave("");
 	return transit_to(JUMPSTART_DEPS);
@@ -735,7 +735,7 @@ static const struct fscache_state *fscache_drop_object(struct fscache_object *ob
 
 	/* this just shifts the object release to the work processor */
 	fscache_put_object(object);
-	fscache_stat(&fscache_n_object_dead);
+	fscache_stat_unchecked(&fscache_n_object_dead);
 
 	_leave("");
 	return transit_to(OBJECT_DEAD);
@@ -900,7 +900,7 @@ enum fscache_checkaux fscache_check_aux(struct fscache_object *object,
 	enum fscache_checkaux result;
 
 	if (!object->cookie->def->check_aux) {
-		fscache_stat(&fscache_n_checkaux_none);
+		fscache_stat_unchecked(&fscache_n_checkaux_none);
 		return FSCACHE_CHECKAUX_OKAY;
 	}
 
@@ -909,17 +909,17 @@ enum fscache_checkaux fscache_check_aux(struct fscache_object *object,
 	switch (result) {
 		/* entry okay as is */
 	case FSCACHE_CHECKAUX_OKAY:
-		fscache_stat(&fscache_n_checkaux_okay);
+		fscache_stat_unchecked(&fscache_n_checkaux_okay);
 		break;
 
 		/* entry requires update */
 	case FSCACHE_CHECKAUX_NEEDS_UPDATE:
-		fscache_stat(&fscache_n_checkaux_update);
+		fscache_stat_unchecked(&fscache_n_checkaux_update);
 		break;
 
 		/* entry requires deletion */
 	case FSCACHE_CHECKAUX_OBSOLETE:
-		fscache_stat(&fscache_n_checkaux_obsolete);
+		fscache_stat_unchecked(&fscache_n_checkaux_obsolete);
 		break;
 
 	default:
@@ -1007,7 +1007,7 @@ static const struct fscache_state *fscache_invalidate_object(struct fscache_obje
 {
 	const struct fscache_state *s;
 
-	fscache_stat(&fscache_n_invalidates_run);
+	fscache_stat_unchecked(&fscache_n_invalidates_run);
 	fscache_stat(&fscache_n_cop_invalidate_object);
 	s = _fscache_invalidate_object(object, event);
 	fscache_stat_d(&fscache_n_cop_invalidate_object);
@@ -1022,7 +1022,7 @@ static const struct fscache_state *fscache_update_object(struct fscache_object *
 {
 	_enter("{OBJ%x},%d", object->debug_id, event);
 
-	fscache_stat(&fscache_n_updates_run);
+	fscache_stat_unchecked(&fscache_n_updates_run);
 	fscache_stat(&fscache_n_cop_update_object);
 	object->cache->ops->update_object(object);
 	fscache_stat_d(&fscache_n_cop_update_object);
diff --git a/fs/fscache/operation.c b/fs/fscache/operation.c
index de67745e1..6a3a9b63b 100644
--- a/fs/fscache/operation.c
+++ b/fs/fscache/operation.c
@@ -17,7 +17,7 @@
 #include <linux/slab.h>
 #include "internal.h"
 
-atomic_t fscache_op_debug_id;
+atomic_unchecked_t fscache_op_debug_id;
 EXPORT_SYMBOL(fscache_op_debug_id);
 
 static void fscache_operation_dummy_cancel(struct fscache_operation *op)
@@ -40,12 +40,12 @@ void fscache_operation_init(struct fscache_operation *op,
 	INIT_WORK(&op->work, fscache_op_work_func);
 	atomic_set(&op->usage, 1);
 	op->state = FSCACHE_OP_ST_INITIALISED;
-	op->debug_id = atomic_inc_return(&fscache_op_debug_id);
+	op->debug_id = atomic_inc_return_unchecked(&fscache_op_debug_id);
 	op->processor = processor;
 	op->cancel = cancel ?: fscache_operation_dummy_cancel;
 	op->release = release;
 	INIT_LIST_HEAD(&op->pend_link);
-	fscache_stat(&fscache_n_op_initialised);
+	fscache_stat_unchecked(&fscache_n_op_initialised);
 }
 EXPORT_SYMBOL(fscache_operation_init);
 
@@ -68,7 +68,7 @@ void fscache_enqueue_operation(struct fscache_operation *op)
 	ASSERTCMP(atomic_read(&op->usage), >, 0);
 	ASSERTCMP(op->state, ==, FSCACHE_OP_ST_IN_PROGRESS);
 
-	fscache_stat(&fscache_n_op_enqueue);
+	fscache_stat_unchecked(&fscache_n_op_enqueue);
 	switch (op->flags & FSCACHE_OP_TYPE) {
 	case FSCACHE_OP_ASYNC:
 		_debug("queue async");
@@ -101,7 +101,7 @@ static void fscache_run_op(struct fscache_object *object,
 		wake_up_bit(&op->flags, FSCACHE_OP_WAITING);
 	if (op->processor)
 		fscache_enqueue_operation(op);
-	fscache_stat(&fscache_n_op_run);
+	fscache_stat_unchecked(&fscache_n_op_run);
 }
 
 /*
@@ -169,7 +169,7 @@ int fscache_submit_exclusive_op(struct fscache_object *object,
 	op->state = FSCACHE_OP_ST_PENDING;
 	flags = READ_ONCE(object->flags);
 	if (unlikely(!(flags & BIT(FSCACHE_OBJECT_IS_LIVE)))) {
-		fscache_stat(&fscache_n_op_rejected);
+		fscache_stat_unchecked(&fscache_n_op_rejected);
 		op->cancel(op);
 		op->state = FSCACHE_OP_ST_CANCELLED;
 		ret = -ENOBUFS;
@@ -185,11 +185,11 @@ int fscache_submit_exclusive_op(struct fscache_object *object,
 		if (object->n_in_progress > 0) {
 			atomic_inc(&op->usage);
 			list_add_tail(&op->pend_link, &object->pending_ops);
-			fscache_stat(&fscache_n_op_pend);
+			fscache_stat_unchecked(&fscache_n_op_pend);
 		} else if (!list_empty(&object->pending_ops)) {
 			atomic_inc(&op->usage);
 			list_add_tail(&op->pend_link, &object->pending_ops);
-			fscache_stat(&fscache_n_op_pend);
+			fscache_stat_unchecked(&fscache_n_op_pend);
 			fscache_start_operations(object);
 		} else {
 			ASSERTCMP(object->n_in_progress, ==, 0);
@@ -205,7 +205,7 @@ int fscache_submit_exclusive_op(struct fscache_object *object,
 		object->n_exclusive++;	/* reads and writes must wait */
 		atomic_inc(&op->usage);
 		list_add_tail(&op->pend_link, &object->pending_ops);
-		fscache_stat(&fscache_n_op_pend);
+		fscache_stat_unchecked(&fscache_n_op_pend);
 		ret = 0;
 	} else if (flags & BIT(FSCACHE_OBJECT_KILLED_BY_CACHE)) {
 		op->cancel(op);
@@ -254,7 +254,7 @@ int fscache_submit_op(struct fscache_object *object,
 	op->state = FSCACHE_OP_ST_PENDING;
 	flags = READ_ONCE(object->flags);
 	if (unlikely(!(flags & BIT(FSCACHE_OBJECT_IS_LIVE)))) {
-		fscache_stat(&fscache_n_op_rejected);
+		fscache_stat_unchecked(&fscache_n_op_rejected);
 		op->cancel(op);
 		op->state = FSCACHE_OP_ST_CANCELLED;
 		ret = -ENOBUFS;
@@ -269,11 +269,11 @@ int fscache_submit_op(struct fscache_object *object,
 		if (object->n_exclusive > 0) {
 			atomic_inc(&op->usage);
 			list_add_tail(&op->pend_link, &object->pending_ops);
-			fscache_stat(&fscache_n_op_pend);
+			fscache_stat_unchecked(&fscache_n_op_pend);
 		} else if (!list_empty(&object->pending_ops)) {
 			atomic_inc(&op->usage);
 			list_add_tail(&op->pend_link, &object->pending_ops);
-			fscache_stat(&fscache_n_op_pend);
+			fscache_stat_unchecked(&fscache_n_op_pend);
 			fscache_start_operations(object);
 		} else {
 			ASSERTCMP(object->n_exclusive, ==, 0);
@@ -285,7 +285,7 @@ int fscache_submit_op(struct fscache_object *object,
 		object->n_ops++;
 		atomic_inc(&op->usage);
 		list_add_tail(&op->pend_link, &object->pending_ops);
-		fscache_stat(&fscache_n_op_pend);
+		fscache_stat_unchecked(&fscache_n_op_pend);
 		ret = 0;
 	} else if (flags & BIT(FSCACHE_OBJECT_KILLED_BY_CACHE)) {
 		op->cancel(op);
@@ -369,7 +369,7 @@ int fscache_cancel_op(struct fscache_operation *op,
 		list_del_init(&op->pend_link);
 		put = true;
 
-		fscache_stat(&fscache_n_op_cancelled);
+		fscache_stat_unchecked(&fscache_n_op_cancelled);
 		op->cancel(op);
 		op->state = FSCACHE_OP_ST_CANCELLED;
 		if (test_bit(FSCACHE_OP_EXCLUSIVE, &op->flags))
@@ -385,7 +385,7 @@ int fscache_cancel_op(struct fscache_operation *op,
 		if (object->n_in_progress == 0)
 			fscache_start_operations(object);
 
-		fscache_stat(&fscache_n_op_cancelled);
+		fscache_stat_unchecked(&fscache_n_op_cancelled);
 		op->cancel(op);
 		op->state = FSCACHE_OP_ST_CANCELLED;
 		if (test_bit(FSCACHE_OP_EXCLUSIVE, &op->flags))
@@ -416,7 +416,7 @@ void fscache_cancel_all_ops(struct fscache_object *object)
 	while (!list_empty(&object->pending_ops)) {
 		op = list_entry(object->pending_ops.next,
 				struct fscache_operation, pend_link);
-		fscache_stat(&fscache_n_op_cancelled);
+		fscache_stat_unchecked(&fscache_n_op_cancelled);
 		list_del_init(&op->pend_link);
 
 		ASSERTCMP(op->state, ==, FSCACHE_OP_ST_PENDING);
@@ -493,7 +493,7 @@ void fscache_put_operation(struct fscache_operation *op)
 		    op->state != FSCACHE_OP_ST_COMPLETE,
 		    op->state, ==, FSCACHE_OP_ST_CANCELLED);
 
-	fscache_stat(&fscache_n_op_release);
+	fscache_stat_unchecked(&fscache_n_op_release);
 
 	if (op->release) {
 		op->release(op);
@@ -513,7 +513,7 @@ void fscache_put_operation(struct fscache_operation *op)
 		 * lock, and defer it otherwise */
 		if (!spin_trylock(&object->lock)) {
 			_debug("defer put");
-			fscache_stat(&fscache_n_op_deferred_release);
+			fscache_stat_unchecked(&fscache_n_op_deferred_release);
 
 			cache = object->cache;
 			spin_lock(&cache->op_gc_list_lock);
@@ -567,7 +567,7 @@ void fscache_operation_gc(struct work_struct *work)
 
 		_debug("GC DEFERRED REL OBJ%x OP%x",
 		       object->debug_id, op->debug_id);
-		fscache_stat(&fscache_n_op_gc);
+		fscache_stat_unchecked(&fscache_n_op_gc);
 
 		ASSERTCMP(atomic_read(&op->usage), ==, 0);
 		ASSERTCMP(op->state, ==, FSCACHE_OP_ST_DEAD);
diff --git a/fs/fscache/page.c b/fs/fscache/page.c
index c8c4f79c7..0512aeb9a 100644
--- a/fs/fscache/page.c
+++ b/fs/fscache/page.c
@@ -74,7 +74,7 @@ try_again:
 	val = radix_tree_lookup(&cookie->stores, page->index);
 	if (!val) {
 		rcu_read_unlock();
-		fscache_stat(&fscache_n_store_vmscan_not_storing);
+		fscache_stat_unchecked(&fscache_n_store_vmscan_not_storing);
 		__fscache_uncache_page(cookie, page);
 		return true;
 	}
@@ -104,11 +104,11 @@ try_again:
 	spin_unlock(&cookie->stores_lock);
 
 	if (xpage) {
-		fscache_stat(&fscache_n_store_vmscan_cancelled);
-		fscache_stat(&fscache_n_store_radix_deletes);
+		fscache_stat_unchecked(&fscache_n_store_vmscan_cancelled);
+		fscache_stat_unchecked(&fscache_n_store_radix_deletes);
 		ASSERTCMP(xpage, ==, page);
 	} else {
-		fscache_stat(&fscache_n_store_vmscan_gone);
+		fscache_stat_unchecked(&fscache_n_store_vmscan_gone);
 	}
 
 	wake_up_bit(&cookie->flags, 0);
@@ -123,11 +123,11 @@ page_busy:
 	 * sleeping on memory allocation, so we may need to impose a timeout
 	 * too. */
 	if (!(gfp & __GFP_DIRECT_RECLAIM) || !(gfp & __GFP_FS)) {
-		fscache_stat(&fscache_n_store_vmscan_busy);
+		fscache_stat_unchecked(&fscache_n_store_vmscan_busy);
 		return false;
 	}
 
-	fscache_stat(&fscache_n_store_vmscan_wait);
+	fscache_stat_unchecked(&fscache_n_store_vmscan_wait);
 	if (!release_page_wait_timeout(cookie, page))
 		_debug("fscache writeout timeout page: %p{%lx}",
 			page, page->index);
@@ -156,7 +156,7 @@ static void fscache_end_page_write(struct fscache_object *object,
 				     FSCACHE_COOKIE_STORING_TAG);
 		if (!radix_tree_tag_get(&cookie->stores, page->index,
 					FSCACHE_COOKIE_PENDING_TAG)) {
-			fscache_stat(&fscache_n_store_radix_deletes);
+			fscache_stat_unchecked(&fscache_n_store_radix_deletes);
 			xpage = radix_tree_delete(&cookie->stores, page->index);
 		}
 		spin_unlock(&cookie->stores_lock);
@@ -177,7 +177,7 @@ static void fscache_attr_changed_op(struct fscache_operation *op)
 
 	_enter("{OBJ%x OP%x}", object->debug_id, op->debug_id);
 
-	fscache_stat(&fscache_n_attr_changed_calls);
+	fscache_stat_unchecked(&fscache_n_attr_changed_calls);
 
 	if (fscache_object_is_active(object)) {
 		fscache_stat(&fscache_n_cop_attr_changed);
@@ -204,11 +204,11 @@ int __fscache_attr_changed(struct fscache_cookie *cookie)
 
 	ASSERTCMP(cookie->def->type, !=, FSCACHE_COOKIE_TYPE_INDEX);
 
-	fscache_stat(&fscache_n_attr_changed);
+	fscache_stat_unchecked(&fscache_n_attr_changed);
 
 	op = kzalloc(sizeof(*op), GFP_KERNEL);
 	if (!op) {
-		fscache_stat(&fscache_n_attr_changed_nomem);
+		fscache_stat_unchecked(&fscache_n_attr_changed_nomem);
 		_leave(" = -ENOMEM");
 		return -ENOMEM;
 	}
@@ -230,7 +230,7 @@ int __fscache_attr_changed(struct fscache_cookie *cookie)
 	if (fscache_submit_exclusive_op(object, op) < 0)
 		goto nobufs_dec;
 	spin_unlock(&cookie->lock);
-	fscache_stat(&fscache_n_attr_changed_ok);
+	fscache_stat_unchecked(&fscache_n_attr_changed_ok);
 	fscache_put_operation(op);
 	_leave(" = 0");
 	return 0;
@@ -242,7 +242,7 @@ nobufs:
 	fscache_put_operation(op);
 	if (wake_cookie)
 		__fscache_wake_unused_cookie(cookie);
-	fscache_stat(&fscache_n_attr_changed_nobufs);
+	fscache_stat_unchecked(&fscache_n_attr_changed_nobufs);
 	_leave(" = %d", -ENOBUFS);
 	return -ENOBUFS;
 }
@@ -293,7 +293,7 @@ static struct fscache_retrieval *fscache_alloc_retrieval(
 	/* allocate a retrieval operation and attempt to submit it */
 	op = kzalloc(sizeof(*op), GFP_NOIO);
 	if (!op) {
-		fscache_stat(&fscache_n_retrievals_nomem);
+		fscache_stat_unchecked(&fscache_n_retrievals_nomem);
 		return NULL;
 	}
 
@@ -332,12 +332,12 @@ int fscache_wait_for_deferred_lookup(struct fscache_cookie *cookie)
 		return 0;
 	}
 
-	fscache_stat(&fscache_n_retrievals_wait);
+	fscache_stat_unchecked(&fscache_n_retrievals_wait);
 
 	jif = jiffies;
 	if (wait_on_bit(&cookie->flags, FSCACHE_COOKIE_LOOKING_UP,
 			TASK_INTERRUPTIBLE) != 0) {
-		fscache_stat(&fscache_n_retrievals_intr);
+		fscache_stat_unchecked(&fscache_n_retrievals_intr);
 		_leave(" = -ERESTARTSYS");
 		return -ERESTARTSYS;
 	}
@@ -355,8 +355,8 @@ int fscache_wait_for_deferred_lookup(struct fscache_cookie *cookie)
  */
 int fscache_wait_for_operation_activation(struct fscache_object *object,
 					  struct fscache_operation *op,
-					  atomic_t *stat_op_waits,
-					  atomic_t *stat_object_dead)
+					  atomic_unchecked_t *stat_op_waits,
+					  atomic_unchecked_t *stat_object_dead)
 {
 	int ret;
 
@@ -365,7 +365,7 @@ int fscache_wait_for_operation_activation(struct fscache_object *object,
 
 	_debug(">>> WT");
 	if (stat_op_waits)
-		fscache_stat(stat_op_waits);
+		fscache_stat_unchecked(stat_op_waits);
 	if (wait_on_bit(&op->flags, FSCACHE_OP_WAITING,
 			TASK_INTERRUPTIBLE) != 0) {
 		ret = fscache_cancel_op(op, false);
@@ -382,7 +382,7 @@ int fscache_wait_for_operation_activation(struct fscache_object *object,
 check_if_dead:
 	if (op->state == FSCACHE_OP_ST_CANCELLED) {
 		if (stat_object_dead)
-			fscache_stat(stat_object_dead);
+			fscache_stat_unchecked(stat_object_dead);
 		_leave(" = -ENOBUFS [cancelled]");
 		return -ENOBUFS;
 	}
@@ -391,7 +391,7 @@ check_if_dead:
 		enum fscache_operation_state state = op->state;
 		fscache_cancel_op(op, true);
 		if (stat_object_dead)
-			fscache_stat(stat_object_dead);
+			fscache_stat_unchecked(stat_object_dead);
 		_leave(" = -ENOBUFS [obj dead %d]", state);
 		return -ENOBUFS;
 	}
@@ -420,7 +420,7 @@ int __fscache_read_or_alloc_page(struct fscache_cookie *cookie,
 
 	_enter("%p,%p,,,", cookie, page);
 
-	fscache_stat(&fscache_n_retrievals);
+	fscache_stat_unchecked(&fscache_n_retrievals);
 
 	if (hlist_empty(&cookie->backing_objects))
 		goto nobufs;
@@ -462,7 +462,7 @@ int __fscache_read_or_alloc_page(struct fscache_cookie *cookie,
 		goto nobufs_unlock_dec;
 	spin_unlock(&cookie->lock);
 
-	fscache_stat(&fscache_n_retrieval_ops);
+	fscache_stat_unchecked(&fscache_n_retrieval_ops);
 
 	/* we wait for the operation to become active, and then process it
 	 * *here*, in this thread, and not in the thread pool */
@@ -488,15 +488,15 @@ int __fscache_read_or_alloc_page(struct fscache_cookie *cookie,
 
 error:
 	if (ret == -ENOMEM)
-		fscache_stat(&fscache_n_retrievals_nomem);
+		fscache_stat_unchecked(&fscache_n_retrievals_nomem);
 	else if (ret == -ERESTARTSYS)
-		fscache_stat(&fscache_n_retrievals_intr);
+		fscache_stat_unchecked(&fscache_n_retrievals_intr);
 	else if (ret == -ENODATA)
-		fscache_stat(&fscache_n_retrievals_nodata);
+		fscache_stat_unchecked(&fscache_n_retrievals_nodata);
 	else if (ret < 0)
-		fscache_stat(&fscache_n_retrievals_nobufs);
+		fscache_stat_unchecked(&fscache_n_retrievals_nobufs);
 	else
-		fscache_stat(&fscache_n_retrievals_ok);
+		fscache_stat_unchecked(&fscache_n_retrievals_ok);
 
 	fscache_put_retrieval(op);
 	_leave(" = %d", ret);
@@ -511,7 +511,7 @@ nobufs_unlock:
 		__fscache_wake_unused_cookie(cookie);
 	fscache_put_retrieval(op);
 nobufs:
-	fscache_stat(&fscache_n_retrievals_nobufs);
+	fscache_stat_unchecked(&fscache_n_retrievals_nobufs);
 	_leave(" = -ENOBUFS");
 	return -ENOBUFS;
 }
@@ -550,7 +550,7 @@ int __fscache_read_or_alloc_pages(struct fscache_cookie *cookie,
 
 	_enter("%p,,%d,,,", cookie, *nr_pages);
 
-	fscache_stat(&fscache_n_retrievals);
+	fscache_stat_unchecked(&fscache_n_retrievals);
 
 	if (hlist_empty(&cookie->backing_objects))
 		goto nobufs;
@@ -588,7 +588,7 @@ int __fscache_read_or_alloc_pages(struct fscache_cookie *cookie,
 		goto nobufs_unlock_dec;
 	spin_unlock(&cookie->lock);
 
-	fscache_stat(&fscache_n_retrieval_ops);
+	fscache_stat_unchecked(&fscache_n_retrieval_ops);
 
 	/* we wait for the operation to become active, and then process it
 	 * *here*, in this thread, and not in the thread pool */
@@ -614,15 +614,15 @@ int __fscache_read_or_alloc_pages(struct fscache_cookie *cookie,
 
 error:
 	if (ret == -ENOMEM)
-		fscache_stat(&fscache_n_retrievals_nomem);
+		fscache_stat_unchecked(&fscache_n_retrievals_nomem);
 	else if (ret == -ERESTARTSYS)
-		fscache_stat(&fscache_n_retrievals_intr);
+		fscache_stat_unchecked(&fscache_n_retrievals_intr);
 	else if (ret == -ENODATA)
-		fscache_stat(&fscache_n_retrievals_nodata);
+		fscache_stat_unchecked(&fscache_n_retrievals_nodata);
 	else if (ret < 0)
-		fscache_stat(&fscache_n_retrievals_nobufs);
+		fscache_stat_unchecked(&fscache_n_retrievals_nobufs);
 	else
-		fscache_stat(&fscache_n_retrievals_ok);
+		fscache_stat_unchecked(&fscache_n_retrievals_ok);
 
 	fscache_put_retrieval(op);
 	_leave(" = %d", ret);
@@ -637,7 +637,7 @@ nobufs_unlock:
 	if (wake_cookie)
 		__fscache_wake_unused_cookie(cookie);
 nobufs:
-	fscache_stat(&fscache_n_retrievals_nobufs);
+	fscache_stat_unchecked(&fscache_n_retrievals_nobufs);
 	_leave(" = -ENOBUFS");
 	return -ENOBUFS;
 }
@@ -662,7 +662,7 @@ int __fscache_alloc_page(struct fscache_cookie *cookie,
 
 	_enter("%p,%p,,,", cookie, page);
 
-	fscache_stat(&fscache_n_allocs);
+	fscache_stat_unchecked(&fscache_n_allocs);
 
 	if (hlist_empty(&cookie->backing_objects))
 		goto nobufs;
@@ -696,7 +696,7 @@ int __fscache_alloc_page(struct fscache_cookie *cookie,
 		goto nobufs_unlock_dec;
 	spin_unlock(&cookie->lock);
 
-	fscache_stat(&fscache_n_alloc_ops);
+	fscache_stat_unchecked(&fscache_n_alloc_ops);
 
 	ret = fscache_wait_for_operation_activation(
 		object, &op->op,
@@ -712,11 +712,11 @@ int __fscache_alloc_page(struct fscache_cookie *cookie,
 
 error:
 	if (ret == -ERESTARTSYS)
-		fscache_stat(&fscache_n_allocs_intr);
+		fscache_stat_unchecked(&fscache_n_allocs_intr);
 	else if (ret < 0)
-		fscache_stat(&fscache_n_allocs_nobufs);
+		fscache_stat_unchecked(&fscache_n_allocs_nobufs);
 	else
-		fscache_stat(&fscache_n_allocs_ok);
+		fscache_stat_unchecked(&fscache_n_allocs_ok);
 
 	fscache_put_retrieval(op);
 	_leave(" = %d", ret);
@@ -730,7 +730,7 @@ nobufs_unlock:
 	if (wake_cookie)
 		__fscache_wake_unused_cookie(cookie);
 nobufs:
-	fscache_stat(&fscache_n_allocs_nobufs);
+	fscache_stat_unchecked(&fscache_n_allocs_nobufs);
 	_leave(" = -ENOBUFS");
 	return -ENOBUFS;
 }
@@ -806,7 +806,7 @@ static void fscache_write_op(struct fscache_operation *_op)
 
 	spin_lock(&cookie->stores_lock);
 
-	fscache_stat(&fscache_n_store_calls);
+	fscache_stat_unchecked(&fscache_n_store_calls);
 
 	/* find a page to store */
 	page = NULL;
@@ -817,7 +817,7 @@ static void fscache_write_op(struct fscache_operation *_op)
 	page = results[0];
 	_debug("gang %d [%lx]", n, page->index);
 	if (page->index >= op->store_limit) {
-		fscache_stat(&fscache_n_store_pages_over_limit);
+		fscache_stat_unchecked(&fscache_n_store_pages_over_limit);
 		goto superseded;
 	}
 
@@ -829,7 +829,7 @@ static void fscache_write_op(struct fscache_operation *_op)
 	spin_unlock(&cookie->stores_lock);
 	spin_unlock(&object->lock);
 
-	fscache_stat(&fscache_n_store_pages);
+	fscache_stat_unchecked(&fscache_n_store_pages);
 	fscache_stat(&fscache_n_cop_write_page);
 	ret = object->cache->ops->write_page(op, page);
 	fscache_stat_d(&fscache_n_cop_write_page);
@@ -935,7 +935,7 @@ int __fscache_write_page(struct fscache_cookie *cookie,
 	ASSERTCMP(cookie->def->type, !=, FSCACHE_COOKIE_TYPE_INDEX);
 	ASSERT(PageFsCache(page));
 
-	fscache_stat(&fscache_n_stores);
+	fscache_stat_unchecked(&fscache_n_stores);
 
 	if (test_bit(FSCACHE_COOKIE_INVALIDATING, &cookie->flags)) {
 		_leave(" = -ENOBUFS [invalidating]");
@@ -994,7 +994,7 @@ int __fscache_write_page(struct fscache_cookie *cookie,
 	spin_unlock(&cookie->stores_lock);
 	spin_unlock(&object->lock);
 
-	op->op.debug_id	= atomic_inc_return(&fscache_op_debug_id);
+	op->op.debug_id	= atomic_inc_return_unchecked(&fscache_op_debug_id);
 	op->store_limit = object->store_limit;
 
 	__fscache_use_cookie(cookie);
@@ -1003,8 +1003,8 @@ int __fscache_write_page(struct fscache_cookie *cookie,
 
 	spin_unlock(&cookie->lock);
 	radix_tree_preload_end();
-	fscache_stat(&fscache_n_store_ops);
-	fscache_stat(&fscache_n_stores_ok);
+	fscache_stat_unchecked(&fscache_n_store_ops);
+	fscache_stat_unchecked(&fscache_n_stores_ok);
 
 	/* the work queue now carries its own ref on the object */
 	fscache_put_operation(&op->op);
@@ -1012,14 +1012,14 @@ int __fscache_write_page(struct fscache_cookie *cookie,
 	return 0;
 
 already_queued:
-	fscache_stat(&fscache_n_stores_again);
+	fscache_stat_unchecked(&fscache_n_stores_again);
 already_pending:
 	spin_unlock(&cookie->stores_lock);
 	spin_unlock(&object->lock);
 	spin_unlock(&cookie->lock);
 	radix_tree_preload_end();
 	fscache_put_operation(&op->op);
-	fscache_stat(&fscache_n_stores_ok);
+	fscache_stat_unchecked(&fscache_n_stores_ok);
 	_leave(" = 0");
 	return 0;
 
@@ -1041,14 +1041,14 @@ nobufs:
 	fscache_put_operation(&op->op);
 	if (wake_cookie)
 		__fscache_wake_unused_cookie(cookie);
-	fscache_stat(&fscache_n_stores_nobufs);
+	fscache_stat_unchecked(&fscache_n_stores_nobufs);
 	_leave(" = -ENOBUFS");
 	return -ENOBUFS;
 
 nomem_free:
 	fscache_put_operation(&op->op);
 nomem:
-	fscache_stat(&fscache_n_stores_oom);
+	fscache_stat_unchecked(&fscache_n_stores_oom);
 	_leave(" = -ENOMEM");
 	return -ENOMEM;
 }
@@ -1066,7 +1066,7 @@ void __fscache_uncache_page(struct fscache_cookie *cookie, struct page *page)
 	ASSERTCMP(cookie->def->type, !=, FSCACHE_COOKIE_TYPE_INDEX);
 	ASSERTCMP(page, !=, NULL);
 
-	fscache_stat(&fscache_n_uncaches);
+	fscache_stat_unchecked(&fscache_n_uncaches);
 
 	/* cache withdrawal may beat us to it */
 	if (!PageFsCache(page))
@@ -1117,7 +1117,7 @@ void fscache_mark_page_cached(struct fscache_retrieval *op, struct page *page)
 	struct fscache_cookie *cookie = op->op.object->cookie;
 
 #ifdef CONFIG_FSCACHE_STATS
-	atomic_inc(&fscache_n_marks);
+	atomic_inc_unchecked(&fscache_n_marks);
 #endif
 
 	_debug("- mark %p{%lx}", page, page->index);
diff --git a/fs/fscache/stats.c b/fs/fscache/stats.c
index 7ac6e839b..352976ab0 100644
--- a/fs/fscache/stats.c
+++ b/fs/fscache/stats.c
@@ -18,100 +18,100 @@
 /*
  * operation counters
  */
-atomic_t fscache_n_op_pend;
-atomic_t fscache_n_op_run;
-atomic_t fscache_n_op_enqueue;
-atomic_t fscache_n_op_requeue;
-atomic_t fscache_n_op_deferred_release;
-atomic_t fscache_n_op_initialised;
-atomic_t fscache_n_op_release;
-atomic_t fscache_n_op_gc;
-atomic_t fscache_n_op_cancelled;
-atomic_t fscache_n_op_rejected;
-
-atomic_t fscache_n_attr_changed;
-atomic_t fscache_n_attr_changed_ok;
-atomic_t fscache_n_attr_changed_nobufs;
-atomic_t fscache_n_attr_changed_nomem;
-atomic_t fscache_n_attr_changed_calls;
-
-atomic_t fscache_n_allocs;
-atomic_t fscache_n_allocs_ok;
-atomic_t fscache_n_allocs_wait;
-atomic_t fscache_n_allocs_nobufs;
-atomic_t fscache_n_allocs_intr;
-atomic_t fscache_n_allocs_object_dead;
-atomic_t fscache_n_alloc_ops;
-atomic_t fscache_n_alloc_op_waits;
-
-atomic_t fscache_n_retrievals;
-atomic_t fscache_n_retrievals_ok;
-atomic_t fscache_n_retrievals_wait;
-atomic_t fscache_n_retrievals_nodata;
-atomic_t fscache_n_retrievals_nobufs;
-atomic_t fscache_n_retrievals_intr;
-atomic_t fscache_n_retrievals_nomem;
-atomic_t fscache_n_retrievals_object_dead;
-atomic_t fscache_n_retrieval_ops;
-atomic_t fscache_n_retrieval_op_waits;
-
-atomic_t fscache_n_stores;
-atomic_t fscache_n_stores_ok;
-atomic_t fscache_n_stores_again;
-atomic_t fscache_n_stores_nobufs;
-atomic_t fscache_n_stores_oom;
-atomic_t fscache_n_store_ops;
-atomic_t fscache_n_store_calls;
-atomic_t fscache_n_store_pages;
-atomic_t fscache_n_store_radix_deletes;
-atomic_t fscache_n_store_pages_over_limit;
-
-atomic_t fscache_n_store_vmscan_not_storing;
-atomic_t fscache_n_store_vmscan_gone;
-atomic_t fscache_n_store_vmscan_busy;
-atomic_t fscache_n_store_vmscan_cancelled;
-atomic_t fscache_n_store_vmscan_wait;
-
-atomic_t fscache_n_marks;
-atomic_t fscache_n_uncaches;
-
-atomic_t fscache_n_acquires;
-atomic_t fscache_n_acquires_null;
-atomic_t fscache_n_acquires_no_cache;
-atomic_t fscache_n_acquires_ok;
-atomic_t fscache_n_acquires_nobufs;
-atomic_t fscache_n_acquires_oom;
-
-atomic_t fscache_n_invalidates;
-atomic_t fscache_n_invalidates_run;
-
-atomic_t fscache_n_updates;
-atomic_t fscache_n_updates_null;
-atomic_t fscache_n_updates_run;
-
-atomic_t fscache_n_relinquishes;
-atomic_t fscache_n_relinquishes_null;
-atomic_t fscache_n_relinquishes_waitcrt;
-atomic_t fscache_n_relinquishes_retire;
-
-atomic_t fscache_n_cookie_index;
-atomic_t fscache_n_cookie_data;
-atomic_t fscache_n_cookie_special;
-
-atomic_t fscache_n_object_alloc;
-atomic_t fscache_n_object_no_alloc;
-atomic_t fscache_n_object_lookups;
-atomic_t fscache_n_object_lookups_negative;
-atomic_t fscache_n_object_lookups_positive;
-atomic_t fscache_n_object_lookups_timed_out;
-atomic_t fscache_n_object_created;
-atomic_t fscache_n_object_avail;
-atomic_t fscache_n_object_dead;
-
-atomic_t fscache_n_checkaux_none;
-atomic_t fscache_n_checkaux_okay;
-atomic_t fscache_n_checkaux_update;
-atomic_t fscache_n_checkaux_obsolete;
+atomic_unchecked_t fscache_n_op_pend;
+atomic_unchecked_t fscache_n_op_run;
+atomic_unchecked_t fscache_n_op_enqueue;
+atomic_unchecked_t fscache_n_op_requeue;
+atomic_unchecked_t fscache_n_op_deferred_release;
+atomic_unchecked_t fscache_n_op_initialised;
+atomic_unchecked_t fscache_n_op_release;
+atomic_unchecked_t fscache_n_op_gc;
+atomic_unchecked_t fscache_n_op_cancelled;
+atomic_unchecked_t fscache_n_op_rejected;
+
+atomic_unchecked_t fscache_n_attr_changed;
+atomic_unchecked_t fscache_n_attr_changed_ok;
+atomic_unchecked_t fscache_n_attr_changed_nobufs;
+atomic_unchecked_t fscache_n_attr_changed_nomem;
+atomic_unchecked_t fscache_n_attr_changed_calls;
+
+atomic_unchecked_t fscache_n_allocs;
+atomic_unchecked_t fscache_n_allocs_ok;
+atomic_unchecked_t fscache_n_allocs_wait;
+atomic_unchecked_t fscache_n_allocs_nobufs;
+atomic_unchecked_t fscache_n_allocs_intr;
+atomic_unchecked_t fscache_n_allocs_object_dead;
+atomic_unchecked_t fscache_n_alloc_ops;
+atomic_unchecked_t fscache_n_alloc_op_waits;
+
+atomic_unchecked_t fscache_n_retrievals;
+atomic_unchecked_t fscache_n_retrievals_ok;
+atomic_unchecked_t fscache_n_retrievals_wait;
+atomic_unchecked_t fscache_n_retrievals_nodata;
+atomic_unchecked_t fscache_n_retrievals_nobufs;
+atomic_unchecked_t fscache_n_retrievals_intr;
+atomic_unchecked_t fscache_n_retrievals_nomem;
+atomic_unchecked_t fscache_n_retrievals_object_dead;
+atomic_unchecked_t fscache_n_retrieval_ops;
+atomic_unchecked_t fscache_n_retrieval_op_waits;
+
+atomic_unchecked_t fscache_n_stores;
+atomic_unchecked_t fscache_n_stores_ok;
+atomic_unchecked_t fscache_n_stores_again;
+atomic_unchecked_t fscache_n_stores_nobufs;
+atomic_unchecked_t fscache_n_stores_oom;
+atomic_unchecked_t fscache_n_store_ops;
+atomic_unchecked_t fscache_n_store_calls;
+atomic_unchecked_t fscache_n_store_pages;
+atomic_unchecked_t fscache_n_store_radix_deletes;
+atomic_unchecked_t fscache_n_store_pages_over_limit;
+
+atomic_unchecked_t fscache_n_store_vmscan_not_storing;
+atomic_unchecked_t fscache_n_store_vmscan_gone;
+atomic_unchecked_t fscache_n_store_vmscan_busy;
+atomic_unchecked_t fscache_n_store_vmscan_cancelled;
+atomic_unchecked_t fscache_n_store_vmscan_wait;
+
+atomic_unchecked_t fscache_n_marks;
+atomic_unchecked_t fscache_n_uncaches;
+
+atomic_unchecked_t fscache_n_acquires;
+atomic_unchecked_t fscache_n_acquires_null;
+atomic_unchecked_t fscache_n_acquires_no_cache;
+atomic_unchecked_t fscache_n_acquires_ok;
+atomic_unchecked_t fscache_n_acquires_nobufs;
+atomic_unchecked_t fscache_n_acquires_oom;
+
+atomic_unchecked_t fscache_n_invalidates;
+atomic_unchecked_t fscache_n_invalidates_run;
+
+atomic_unchecked_t fscache_n_updates;
+atomic_unchecked_t fscache_n_updates_null;
+atomic_unchecked_t fscache_n_updates_run;
+
+atomic_unchecked_t fscache_n_relinquishes;
+atomic_unchecked_t fscache_n_relinquishes_null;
+atomic_unchecked_t fscache_n_relinquishes_waitcrt;
+atomic_unchecked_t fscache_n_relinquishes_retire;
+
+atomic_unchecked_t fscache_n_cookie_index;
+atomic_unchecked_t fscache_n_cookie_data;
+atomic_unchecked_t fscache_n_cookie_special;
+
+atomic_unchecked_t fscache_n_object_alloc;
+atomic_unchecked_t fscache_n_object_no_alloc;
+atomic_unchecked_t fscache_n_object_lookups;
+atomic_unchecked_t fscache_n_object_lookups_negative;
+atomic_unchecked_t fscache_n_object_lookups_positive;
+atomic_unchecked_t fscache_n_object_lookups_timed_out;
+atomic_unchecked_t fscache_n_object_created;
+atomic_unchecked_t fscache_n_object_avail;
+atomic_unchecked_t fscache_n_object_dead;
+
+atomic_unchecked_t fscache_n_checkaux_none;
+atomic_unchecked_t fscache_n_checkaux_okay;
+atomic_unchecked_t fscache_n_checkaux_update;
+atomic_unchecked_t fscache_n_checkaux_obsolete;
 
 atomic_t fscache_n_cop_alloc_object;
 atomic_t fscache_n_cop_lookup_object;
@@ -144,119 +144,119 @@ static int fscache_stats_show(struct seq_file *m, void *v)
 	seq_puts(m, "FS-Cache statistics\n");
 
 	seq_printf(m, "Cookies: idx=%u dat=%u spc=%u\n",
-		   atomic_read(&fscache_n_cookie_index),
-		   atomic_read(&fscache_n_cookie_data),
-		   atomic_read(&fscache_n_cookie_special));
+		   atomic_read_unchecked(&fscache_n_cookie_index),
+		   atomic_read_unchecked(&fscache_n_cookie_data),
+		   atomic_read_unchecked(&fscache_n_cookie_special));
 
 	seq_printf(m, "Objects: alc=%u nal=%u avl=%u ded=%u\n",
-		   atomic_read(&fscache_n_object_alloc),
-		   atomic_read(&fscache_n_object_no_alloc),
-		   atomic_read(&fscache_n_object_avail),
-		   atomic_read(&fscache_n_object_dead));
+		   atomic_read_unchecked(&fscache_n_object_alloc),
+		   atomic_read_unchecked(&fscache_n_object_no_alloc),
+		   atomic_read_unchecked(&fscache_n_object_avail),
+		   atomic_read_unchecked(&fscache_n_object_dead));
 	seq_printf(m, "ChkAux : non=%u ok=%u upd=%u obs=%u\n",
-		   atomic_read(&fscache_n_checkaux_none),
-		   atomic_read(&fscache_n_checkaux_okay),
-		   atomic_read(&fscache_n_checkaux_update),
-		   atomic_read(&fscache_n_checkaux_obsolete));
+		   atomic_read_unchecked(&fscache_n_checkaux_none),
+		   atomic_read_unchecked(&fscache_n_checkaux_okay),
+		   atomic_read_unchecked(&fscache_n_checkaux_update),
+		   atomic_read_unchecked(&fscache_n_checkaux_obsolete));
 
 	seq_printf(m, "Pages  : mrk=%u unc=%u\n",
-		   atomic_read(&fscache_n_marks),
-		   atomic_read(&fscache_n_uncaches));
+		   atomic_read_unchecked(&fscache_n_marks),
+		   atomic_read_unchecked(&fscache_n_uncaches));
 
 	seq_printf(m, "Acquire: n=%u nul=%u noc=%u ok=%u nbf=%u"
 		   " oom=%u\n",
-		   atomic_read(&fscache_n_acquires),
-		   atomic_read(&fscache_n_acquires_null),
-		   atomic_read(&fscache_n_acquires_no_cache),
-		   atomic_read(&fscache_n_acquires_ok),
-		   atomic_read(&fscache_n_acquires_nobufs),
-		   atomic_read(&fscache_n_acquires_oom));
+		   atomic_read_unchecked(&fscache_n_acquires),
+		   atomic_read_unchecked(&fscache_n_acquires_null),
+		   atomic_read_unchecked(&fscache_n_acquires_no_cache),
+		   atomic_read_unchecked(&fscache_n_acquires_ok),
+		   atomic_read_unchecked(&fscache_n_acquires_nobufs),
+		   atomic_read_unchecked(&fscache_n_acquires_oom));
 
 	seq_printf(m, "Lookups: n=%u neg=%u pos=%u crt=%u tmo=%u\n",
-		   atomic_read(&fscache_n_object_lookups),
-		   atomic_read(&fscache_n_object_lookups_negative),
-		   atomic_read(&fscache_n_object_lookups_positive),
-		   atomic_read(&fscache_n_object_created),
-		   atomic_read(&fscache_n_object_lookups_timed_out));
+		   atomic_read_unchecked(&fscache_n_object_lookups),
+		   atomic_read_unchecked(&fscache_n_object_lookups_negative),
+		   atomic_read_unchecked(&fscache_n_object_lookups_positive),
+		   atomic_read_unchecked(&fscache_n_object_created),
+		   atomic_read_unchecked(&fscache_n_object_lookups_timed_out));
 
 	seq_printf(m, "Invals : n=%u run=%u\n",
-		   atomic_read(&fscache_n_invalidates),
-		   atomic_read(&fscache_n_invalidates_run));
+		   atomic_read_unchecked(&fscache_n_invalidates),
+		   atomic_read_unchecked(&fscache_n_invalidates_run));
 
 	seq_printf(m, "Updates: n=%u nul=%u run=%u\n",
-		   atomic_read(&fscache_n_updates),
-		   atomic_read(&fscache_n_updates_null),
-		   atomic_read(&fscache_n_updates_run));
+		   atomic_read_unchecked(&fscache_n_updates),
+		   atomic_read_unchecked(&fscache_n_updates_null),
+		   atomic_read_unchecked(&fscache_n_updates_run));
 
 	seq_printf(m, "Relinqs: n=%u nul=%u wcr=%u rtr=%u\n",
-		   atomic_read(&fscache_n_relinquishes),
-		   atomic_read(&fscache_n_relinquishes_null),
-		   atomic_read(&fscache_n_relinquishes_waitcrt),
-		   atomic_read(&fscache_n_relinquishes_retire));
+		   atomic_read_unchecked(&fscache_n_relinquishes),
+		   atomic_read_unchecked(&fscache_n_relinquishes_null),
+		   atomic_read_unchecked(&fscache_n_relinquishes_waitcrt),
+		   atomic_read_unchecked(&fscache_n_relinquishes_retire));
 
 	seq_printf(m, "AttrChg: n=%u ok=%u nbf=%u oom=%u run=%u\n",
-		   atomic_read(&fscache_n_attr_changed),
-		   atomic_read(&fscache_n_attr_changed_ok),
-		   atomic_read(&fscache_n_attr_changed_nobufs),
-		   atomic_read(&fscache_n_attr_changed_nomem),
-		   atomic_read(&fscache_n_attr_changed_calls));
+		   atomic_read_unchecked(&fscache_n_attr_changed),
+		   atomic_read_unchecked(&fscache_n_attr_changed_ok),
+		   atomic_read_unchecked(&fscache_n_attr_changed_nobufs),
+		   atomic_read_unchecked(&fscache_n_attr_changed_nomem),
+		   atomic_read_unchecked(&fscache_n_attr_changed_calls));
 
 	seq_printf(m, "Allocs : n=%u ok=%u wt=%u nbf=%u int=%u\n",
-		   atomic_read(&fscache_n_allocs),
-		   atomic_read(&fscache_n_allocs_ok),
-		   atomic_read(&fscache_n_allocs_wait),
-		   atomic_read(&fscache_n_allocs_nobufs),
-		   atomic_read(&fscache_n_allocs_intr));
+		   atomic_read_unchecked(&fscache_n_allocs),
+		   atomic_read_unchecked(&fscache_n_allocs_ok),
+		   atomic_read_unchecked(&fscache_n_allocs_wait),
+		   atomic_read_unchecked(&fscache_n_allocs_nobufs),
+		   atomic_read_unchecked(&fscache_n_allocs_intr));
 	seq_printf(m, "Allocs : ops=%u owt=%u abt=%u\n",
-		   atomic_read(&fscache_n_alloc_ops),
-		   atomic_read(&fscache_n_alloc_op_waits),
-		   atomic_read(&fscache_n_allocs_object_dead));
+		   atomic_read_unchecked(&fscache_n_alloc_ops),
+		   atomic_read_unchecked(&fscache_n_alloc_op_waits),
+		   atomic_read_unchecked(&fscache_n_allocs_object_dead));
 
 	seq_printf(m, "Retrvls: n=%u ok=%u wt=%u nod=%u nbf=%u"
 		   " int=%u oom=%u\n",
-		   atomic_read(&fscache_n_retrievals),
-		   atomic_read(&fscache_n_retrievals_ok),
-		   atomic_read(&fscache_n_retrievals_wait),
-		   atomic_read(&fscache_n_retrievals_nodata),
-		   atomic_read(&fscache_n_retrievals_nobufs),
-		   atomic_read(&fscache_n_retrievals_intr),
-		   atomic_read(&fscache_n_retrievals_nomem));
+		   atomic_read_unchecked(&fscache_n_retrievals),
+		   atomic_read_unchecked(&fscache_n_retrievals_ok),
+		   atomic_read_unchecked(&fscache_n_retrievals_wait),
+		   atomic_read_unchecked(&fscache_n_retrievals_nodata),
+		   atomic_read_unchecked(&fscache_n_retrievals_nobufs),
+		   atomic_read_unchecked(&fscache_n_retrievals_intr),
+		   atomic_read_unchecked(&fscache_n_retrievals_nomem));
 	seq_printf(m, "Retrvls: ops=%u owt=%u abt=%u\n",
-		   atomic_read(&fscache_n_retrieval_ops),
-		   atomic_read(&fscache_n_retrieval_op_waits),
-		   atomic_read(&fscache_n_retrievals_object_dead));
+		   atomic_read_unchecked(&fscache_n_retrieval_ops),
+		   atomic_read_unchecked(&fscache_n_retrieval_op_waits),
+		   atomic_read_unchecked(&fscache_n_retrievals_object_dead));
 
 	seq_printf(m, "Stores : n=%u ok=%u agn=%u nbf=%u oom=%u\n",
-		   atomic_read(&fscache_n_stores),
-		   atomic_read(&fscache_n_stores_ok),
-		   atomic_read(&fscache_n_stores_again),
-		   atomic_read(&fscache_n_stores_nobufs),
-		   atomic_read(&fscache_n_stores_oom));
+		   atomic_read_unchecked(&fscache_n_stores),
+		   atomic_read_unchecked(&fscache_n_stores_ok),
+		   atomic_read_unchecked(&fscache_n_stores_again),
+		   atomic_read_unchecked(&fscache_n_stores_nobufs),
+		   atomic_read_unchecked(&fscache_n_stores_oom));
 	seq_printf(m, "Stores : ops=%u run=%u pgs=%u rxd=%u olm=%u\n",
-		   atomic_read(&fscache_n_store_ops),
-		   atomic_read(&fscache_n_store_calls),
-		   atomic_read(&fscache_n_store_pages),
-		   atomic_read(&fscache_n_store_radix_deletes),
-		   atomic_read(&fscache_n_store_pages_over_limit));
+		   atomic_read_unchecked(&fscache_n_store_ops),
+		   atomic_read_unchecked(&fscache_n_store_calls),
+		   atomic_read_unchecked(&fscache_n_store_pages),
+		   atomic_read_unchecked(&fscache_n_store_radix_deletes),
+		   atomic_read_unchecked(&fscache_n_store_pages_over_limit));
 
 	seq_printf(m, "VmScan : nos=%u gon=%u bsy=%u can=%u wt=%u\n",
-		   atomic_read(&fscache_n_store_vmscan_not_storing),
-		   atomic_read(&fscache_n_store_vmscan_gone),
-		   atomic_read(&fscache_n_store_vmscan_busy),
-		   atomic_read(&fscache_n_store_vmscan_cancelled),
-		   atomic_read(&fscache_n_store_vmscan_wait));
+		   atomic_read_unchecked(&fscache_n_store_vmscan_not_storing),
+		   atomic_read_unchecked(&fscache_n_store_vmscan_gone),
+		   atomic_read_unchecked(&fscache_n_store_vmscan_busy),
+		   atomic_read_unchecked(&fscache_n_store_vmscan_cancelled),
+		   atomic_read_unchecked(&fscache_n_store_vmscan_wait));
 
 	seq_printf(m, "Ops    : pend=%u run=%u enq=%u can=%u rej=%u\n",
-		   atomic_read(&fscache_n_op_pend),
-		   atomic_read(&fscache_n_op_run),
-		   atomic_read(&fscache_n_op_enqueue),
-		   atomic_read(&fscache_n_op_cancelled),
-		   atomic_read(&fscache_n_op_rejected));
+		   atomic_read_unchecked(&fscache_n_op_pend),
+		   atomic_read_unchecked(&fscache_n_op_run),
+		   atomic_read_unchecked(&fscache_n_op_enqueue),
+		   atomic_read_unchecked(&fscache_n_op_cancelled),
+		   atomic_read_unchecked(&fscache_n_op_rejected));
 	seq_printf(m, "Ops    : ini=%u dfr=%u rel=%u gc=%u\n",
-		   atomic_read(&fscache_n_op_initialised),
-		   atomic_read(&fscache_n_op_deferred_release),
-		   atomic_read(&fscache_n_op_release),
-		   atomic_read(&fscache_n_op_gc));
+		   atomic_read_unchecked(&fscache_n_op_initialised),
+		   atomic_read_unchecked(&fscache_n_op_deferred_release),
+		   atomic_read_unchecked(&fscache_n_op_release),
+		   atomic_read_unchecked(&fscache_n_op_gc));
 
 	seq_printf(m, "CacheOp: alo=%d luo=%d luc=%d gro=%d\n",
 		   atomic_read(&fscache_n_cop_alloc_object),
diff --git a/fs/fuse/cuse.c b/fs/fuse/cuse.c
index c5b6b7165..527e34707 100644
--- a/fs/fuse/cuse.c
+++ b/fs/fuse/cuse.c
@@ -611,10 +611,12 @@ static int __init cuse_init(void)
 		INIT_LIST_HEAD(&cuse_conntbl[i]);
 
 	/* inherit and extend fuse_dev_operations */
-	cuse_channel_fops		= fuse_dev_operations;
-	cuse_channel_fops.owner		= THIS_MODULE;
-	cuse_channel_fops.open		= cuse_channel_open;
-	cuse_channel_fops.release	= cuse_channel_release;
+	pax_open_kernel();
+	memcpy((void *)&cuse_channel_fops, &fuse_dev_operations, sizeof(fuse_dev_operations));
+	const_cast(cuse_channel_fops.owner)	= THIS_MODULE;
+	const_cast(cuse_channel_fops.open)	= cuse_channel_open;
+	const_cast(cuse_channel_fops.release)	= cuse_channel_release;
+	pax_close_kernel();
 
 	cuse_class = class_create(THIS_MODULE, "cuse");
 	if (IS_ERR(cuse_class))
diff --git a/fs/fuse/dev.c b/fs/fuse/dev.c
index a94d2ed81..80c80603d 100644
--- a/fs/fuse/dev.c
+++ b/fs/fuse/dev.c
@@ -1366,7 +1366,7 @@ static ssize_t fuse_dev_splice_read(struct file *in, loff_t *ppos,
 	ret = 0;
 	pipe_lock(pipe);
 
-	if (!pipe->readers) {
+	if (!atomic_read(&pipe->readers)) {
 		send_sig(SIGPIPE, current, 0);
 		if (!ret)
 			ret = -EPIPE;
@@ -1395,7 +1395,7 @@ static ssize_t fuse_dev_splice_read(struct file *in, loff_t *ppos,
 		page_nr++;
 		ret += buf->len;
 
-		if (pipe->files)
+		if (atomic_read(&pipe->files))
 			do_wakeup = 1;
 	}
 
diff --git a/fs/fuse/file.c b/fs/fuse/file.c
index a621dd98a..1ac40c9e7 100644
--- a/fs/fuse/file.c
+++ b/fs/fuse/file.c
@@ -838,9 +838,9 @@ struct fuse_fill_data {
 	unsigned nr_pages;
 };
 
-static int fuse_readpages_fill(void *_data, struct page *page)
+static int fuse_readpages_fill(struct file *_data, struct page *page)
 {
-	struct fuse_fill_data *data = _data;
+	struct fuse_fill_data *data = (struct fuse_fill_data *)_data;
 	struct fuse_req *req = data->req;
 	struct inode *inode = data->inode;
 	struct fuse_conn *fc = get_fuse_conn(inode);
diff --git a/fs/fuse/inode.c b/fs/fuse/inode.c
index 4e05b5112..36c4e1f3c 100644
--- a/fs/fuse/inode.c
+++ b/fs/fuse/inode.c
@@ -29,7 +29,7 @@ static struct kmem_cache *fuse_inode_cachep;
 struct list_head fuse_conn_list;
 DEFINE_MUTEX(fuse_mutex);
 
-static int set_global_limit(const char *val, struct kernel_param *kp);
+static int set_global_limit(const char *val, const struct kernel_param *kp);
 
 unsigned max_user_bgreq;
 module_param_call(max_user_bgreq, set_global_limit, param_get_uint,
@@ -824,7 +824,7 @@ static void sanitize_global_limit(unsigned *limit)
 		*limit = (1 << 16) - 1;
 }
 
-static int set_global_limit(const char *val, struct kernel_param *kp)
+static int set_global_limit(const char *val, const struct kernel_param *kp)
 {
 	int rv;
 
diff --git a/fs/gfs2/aops.c b/fs/gfs2/aops.c
index 82df36886..00798871c 100644
--- a/fs/gfs2/aops.c
+++ b/fs/gfs2/aops.c
@@ -511,7 +511,7 @@ static int stuffed_readpage(struct gfs2_inode *ip, struct page *page)
  *
  */
 
-static int __gfs2_readpage(void *file, struct page *page)
+static int __gfs2_readpage(struct file *file, struct page *page)
 {
 	struct gfs2_inode *ip = GFS2_I(page->mapping->host);
 	struct gfs2_sbd *sdp = GFS2_SB(page->mapping->host);
diff --git a/fs/gfs2/file.c b/fs/gfs2/file.c
index 320e65e61..7eb400df3 100644
--- a/fs/gfs2/file.c
+++ b/fs/gfs2/file.c
@@ -776,7 +776,7 @@ static void calc_max_reserv(struct gfs2_inode *ip, loff_t *len,
 {
 	loff_t max = *len;
 	const struct gfs2_sbd *sdp = GFS2_SB(&ip->i_inode);
-	unsigned int tmp, max_data = max_blocks - 3 * (sdp->sd_max_height - 1);
+	unsigned int tmp, max_data = max_blocks - 3 * sdp->sd_max_height + 3;
 
 	for (tmp = max_data; tmp > sdp->sd_diptrs;) {
 		tmp = DIV_ROUND_UP(tmp, sdp->sd_inptrs);
diff --git a/fs/gfs2/glock.c b/fs/gfs2/glock.c
index 3a90b2b5b..7335643f9 100644
--- a/fs/gfs2/glock.c
+++ b/fs/gfs2/glock.c
@@ -324,9 +324,9 @@ static void state_change(struct gfs2_glock *gl, unsigned int new_state)
 	if (held1 != held2) {
 		GLOCK_BUG_ON(gl, __lockref_is_dead(&gl->gl_lockref));
 		if (held2)
-			gl->gl_lockref.count++;
+			__lockref_inc(&gl->gl_lockref);
 		else
-			gl->gl_lockref.count--;
+			__lockref_dec(&gl->gl_lockref);
 	}
 	if (held1 && held2 && list_empty(&gl->gl_holders))
 		clear_bit(GLF_QUEUED, &gl->gl_flags);
@@ -560,9 +560,9 @@ out:
 out_sched:
 	clear_bit(GLF_LOCK, &gl->gl_flags);
 	smp_mb__after_atomic();
-	gl->gl_lockref.count++;
+	__lockref_inc(&gl->gl_lockref);
 	if (queue_delayed_work(glock_workqueue, &gl->gl_work, 0) == 0)
-		gl->gl_lockref.count--;
+		__lockref_dec(&gl->gl_lockref);
 	return;
 
 out_unlock:
@@ -690,7 +690,7 @@ int gfs2_glock_get(struct gfs2_sbd *sdp, u64 number,
 	gl->gl_node.next = NULL;
 	gl->gl_flags = 0;
 	gl->gl_name = name;
-	gl->gl_lockref.count = 1;
+	__lockref_set(&gl->gl_lockref, 1);
 	gl->gl_state = LM_ST_UNLOCKED;
 	gl->gl_target = LM_ST_UNLOCKED;
 	gl->gl_demote_state = LM_ST_EXCLUSIVE;
@@ -979,9 +979,9 @@ int gfs2_glock_nq(struct gfs2_holder *gh)
 	if (unlikely((LM_FLAG_NOEXP & gh->gh_flags) &&
 		     test_and_clear_bit(GLF_FROZEN, &gl->gl_flags))) {
 		set_bit(GLF_REPLY_PENDING, &gl->gl_flags);
-		gl->gl_lockref.count++;
+		__lockref_inc(&gl->gl_lockref);
 		if (queue_delayed_work(glock_workqueue, &gl->gl_work, 0) == 0)
-			gl->gl_lockref.count--;
+			__lockref_dec(&gl->gl_lockref);
 	}
 	run_queue(gl, 1);
 	spin_unlock(&gl->gl_lockref.lock);
@@ -1286,7 +1286,7 @@ void gfs2_glock_complete(struct gfs2_glock *gl, int ret)
 		}
 	}
 
-	gl->gl_lockref.count++;
+	__lockref_inc(&gl->gl_lockref);
 	set_bit(GLF_REPLY_PENDING, &gl->gl_flags);
 	spin_unlock(&gl->gl_lockref.lock);
 
@@ -1345,12 +1345,12 @@ add_back_to_lru:
 			goto add_back_to_lru;
 		}
 		clear_bit(GLF_LRU, &gl->gl_flags);
-		gl->gl_lockref.count++;
+		__lockref_inc(&gl->gl_lockref);
 		if (demote_ok(gl))
 			handle_callback(gl, LM_ST_UNLOCKED, 0, false);
 		WARN_ON(!test_and_clear_bit(GLF_LOCK, &gl->gl_flags));
 		if (queue_delayed_work(glock_workqueue, &gl->gl_work, 0) == 0)
-			gl->gl_lockref.count--;
+			__lockref_dec(&gl->gl_lockref);
 		spin_unlock(&gl->gl_lockref.lock);
 		cond_resched_lock(&lru_lock);
 	}
@@ -1677,7 +1677,7 @@ void gfs2_dump_glock(struct seq_file *seq, const struct gfs2_glock *gl)
 		  state2str(gl->gl_demote_state), dtime,
 		  atomic_read(&gl->gl_ail_count),
 		  atomic_read(&gl->gl_revokes),
-		  (int)gl->gl_lockref.count, gl->gl_hold_time);
+		  __lockref_read(&gl->gl_lockref), gl->gl_hold_time);
 
 	list_for_each_entry(gh, &gl->gl_holders, gh_list)
 		dump_holder(seq, gh);
diff --git a/fs/gfs2/glops.c b/fs/gfs2/glops.c
index 5db59d444..817f4eb27 100644
--- a/fs/gfs2/glops.c
+++ b/fs/gfs2/glops.c
@@ -549,9 +549,9 @@ static void iopen_go_callback(struct gfs2_glock *gl, bool remote)
 
 	if (gl->gl_demote_state == LM_ST_UNLOCKED &&
 	    gl->gl_state == LM_ST_SHARED && ip) {
-		gl->gl_lockref.count++;
+		__lockref_inc(&gl->gl_lockref);
 		if (queue_work(gfs2_delete_workqueue, &gl->gl_delete) == 0)
-			gl->gl_lockref.count--;
+			__lockref_dec(&gl->gl_lockref);
 	}
 }
 
diff --git a/fs/gfs2/quota.c b/fs/gfs2/quota.c
index 77930ca25..684c04d52 100644
--- a/fs/gfs2/quota.c
+++ b/fs/gfs2/quota.c
@@ -154,7 +154,7 @@ static enum lru_status gfs2_qd_isolate(struct list_head *item,
 	if (!spin_trylock(&qd->qd_lockref.lock))
 		return LRU_SKIP;
 
-	if (qd->qd_lockref.count == 0) {
+	if (__lockref_read(&qd->qd_lockref) == 0) {
 		lockref_mark_dead(&qd->qd_lockref);
 		list_lru_isolate_move(lru, &qd->qd_lru, dispose);
 	}
@@ -221,7 +221,7 @@ static struct gfs2_quota_data *qd_alloc(unsigned hash, struct gfs2_sbd *sdp, str
 		return NULL;
 
 	qd->qd_sbd = sdp;
-	qd->qd_lockref.count = 1;
+	__lockref_set(&qd->qd_lockref, 1);
 	spin_lock_init(&qd->qd_lockref.lock);
 	qd->qd_id = qid;
 	qd->qd_slot = -1;
@@ -312,7 +312,7 @@ static void qd_put(struct gfs2_quota_data *qd)
 	if (lockref_put_or_lock(&qd->qd_lockref))
 		return;
 
-	qd->qd_lockref.count = 0;
+	__lockref_set(&qd->qd_lockref, 0);
 	list_lru_add(&gfs2_qd_lru, &qd->qd_lru);
 	spin_unlock(&qd->qd_lockref.lock);
 
diff --git a/fs/hugetlbfs/inode.c b/fs/hugetlbfs/inode.c
index 4ea71eba4..19effa716 100644
--- a/fs/hugetlbfs/inode.c
+++ b/fs/hugetlbfs/inode.c
@@ -174,6 +174,7 @@ hugetlb_get_unmapped_area(struct file *file, unsigned long addr,
 	struct mm_struct *mm = current->mm;
 	struct vm_area_struct *vma;
 	struct hstate *h = hstate_file(file);
+	unsigned long offset = gr_rand_threadstack_offset(mm, file, flags);
 	struct vm_unmapped_area_info info;
 
 	if (len & ~huge_page_mask(h))
@@ -187,17 +188,26 @@ hugetlb_get_unmapped_area(struct file *file, unsigned long addr,
 		return addr;
 	}
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		addr = ALIGN(addr, huge_page_size(h));
 		vma = find_vma(mm, addr);
-		if (TASK_SIZE - len >= addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		if (TASK_SIZE - len >= addr && check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
 	info.flags = 0;
 	info.length = len;
 	info.low_limit = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (mm->pax_flags & MF_PAX_RANDMMAP)
+		info.low_limit += mm->delta_mmap;
+#endif
+
 	info.high_limit = TASK_SIZE;
 	info.align_mask = PAGE_MASK & ~huge_page_mask(h);
 	info.align_offset = 0;
@@ -1212,7 +1222,7 @@ static struct file_system_type hugetlbfs_fs_type = {
 	.kill_sb	= kill_litter_super,
 };
 
-static struct vfsmount *hugetlbfs_vfsmount[HUGE_MAX_HSTATE];
+struct vfsmount *hugetlbfs_vfsmount[HUGE_MAX_HSTATE];
 
 static int can_do_hugetlb_shm(void)
 {
diff --git a/fs/inode.c b/fs/inode.c
index 7e3ef3af3..4e28e9521 100644
--- a/fs/inode.c
+++ b/fs/inode.c
@@ -853,19 +853,19 @@ unsigned int get_next_ino(void)
 	unsigned int *p = &get_cpu_var(last_ino);
 	unsigned int res = *p;
 
+start:
+
 #ifdef CONFIG_SMP
 	if (unlikely((res & (LAST_INO_BATCH-1)) == 0)) {
-		static atomic_t shared_last_ino;
-		int next = atomic_add_return(LAST_INO_BATCH, &shared_last_ino);
+		static atomic_unchecked_t shared_last_ino;
+		int next = atomic_add_return_unchecked(LAST_INO_BATCH, &shared_last_ino);
 
 		res = next - LAST_INO_BATCH;
 	}
 #endif
 
-	res++;
-	/* get_next_ino should not provide a 0 inode number */
-	if (unlikely(!res))
-		res++;
+	if (unlikely(!++res))
+		goto start;	/* never zero */
 	*p = res;
 	put_cpu_var(last_ino);
 	return res;
diff --git a/fs/jbd2/commit.c b/fs/jbd2/commit.c
index 5bb565f99..41cbee9db 100644
--- a/fs/jbd2/commit.c
+++ b/fs/jbd2/commit.c
@@ -1077,7 +1077,7 @@ restart_loop:
 	 */
 	stats.ts_tid = commit_transaction->t_tid;
 	stats.run.rs_handle_count =
-		atomic_read(&commit_transaction->t_handle_count);
+		atomic_read_unchecked(&commit_transaction->t_handle_count);
 	trace_jbd2_run_stats(journal->j_fs_dev->bd_dev,
 			     commit_transaction->t_tid, &stats.run);
 	stats.ts_requested = (commit_transaction->t_requested) ? 1 : 0;
diff --git a/fs/jbd2/transaction.c b/fs/jbd2/transaction.c
index e1652665b..0799fc593 100644
--- a/fs/jbd2/transaction.c
+++ b/fs/jbd2/transaction.c
@@ -91,7 +91,7 @@ jbd2_get_transaction(journal_t *journal, transaction_t *transaction)
 	atomic_set(&transaction->t_updates, 0);
 	atomic_set(&transaction->t_outstanding_credits,
 		   atomic_read(&journal->j_reserved_credits));
-	atomic_set(&transaction->t_handle_count, 0);
+	atomic_set_unchecked(&transaction->t_handle_count, 0);
 	INIT_LIST_HEAD(&transaction->t_inode_list);
 	INIT_LIST_HEAD(&transaction->t_private_list);
 
@@ -378,7 +378,7 @@ repeat:
 	handle->h_requested_credits = blocks;
 	handle->h_start_jiffies = jiffies;
 	atomic_inc(&transaction->t_updates);
-	atomic_inc(&transaction->t_handle_count);
+	atomic_inc_unchecked(&transaction->t_handle_count);
 	jbd_debug(4, "Handle %p given %d credits (total %d, free %lu)\n",
 		  handle, blocks,
 		  atomic_read(&transaction->t_outstanding_credits),
diff --git a/fs/jffs2/erase.c b/fs/jffs2/erase.c
index 4a6cf289b..d3a29d3dc 100644
--- a/fs/jffs2/erase.c
+++ b/fs/jffs2/erase.c
@@ -452,7 +452,8 @@ static void jffs2_mark_erased_block(struct jffs2_sb_info *c, struct jffs2_eraseb
 		struct jffs2_unknown_node marker = {
 			.magic =	cpu_to_je16(JFFS2_MAGIC_BITMASK),
 			.nodetype =	cpu_to_je16(JFFS2_NODETYPE_CLEANMARKER),
-			.totlen =	cpu_to_je32(c->cleanmarker_size)
+			.totlen =	cpu_to_je32(c->cleanmarker_size),
+			.hdr_crc =	cpu_to_je32(0)
 		};
 
 		jffs2_prealloc_raw_node_refs(c, jeb, 1);
diff --git a/fs/jffs2/file.c b/fs/jffs2/file.c
index 0e62dec3e..2beac6f8b 100644
--- a/fs/jffs2/file.c
+++ b/fs/jffs2/file.c
@@ -112,8 +112,9 @@ static int jffs2_do_readpage_nolock (struct inode *inode, struct page *pg)
 	return ret;
 }
 
-int jffs2_do_readpage_unlock(struct inode *inode, struct page *pg)
+int jffs2_do_readpage_unlock(struct file *_inode, struct page *pg)
 {
+	struct inode *inode = (struct inode *)_inode;
 	int ret = jffs2_do_readpage_nolock(inode, pg);
 	unlock_page(pg);
 	return ret;
@@ -126,7 +127,7 @@ static int jffs2_readpage (struct file *filp, struct page *pg)
 	int ret;
 
 	mutex_lock(&f->sem);
-	ret = jffs2_do_readpage_unlock(pg->mapping->host, pg);
+	ret = jffs2_do_readpage_unlock((struct file *)pg->mapping->host, pg);
 	mutex_unlock(&f->sem);
 	return ret;
 }
diff --git a/fs/jffs2/fs.c b/fs/jffs2/fs.c
index ae2ebb26b..39becaefd 100644
--- a/fs/jffs2/fs.c
+++ b/fs/jffs2/fs.c
@@ -686,7 +686,7 @@ unsigned char *jffs2_gc_fetch_page(struct jffs2_sb_info *c,
 	struct page *pg;
 
 	pg = read_cache_page(inode->i_mapping, offset >> PAGE_SHIFT,
-			     (void *)jffs2_do_readpage_unlock, inode);
+			     jffs2_do_readpage_unlock, inode);
 	if (IS_ERR(pg))
 		return (void *)pg;
 
diff --git a/fs/jffs2/os-linux.h b/fs/jffs2/os-linux.h
index 824e61ede..2d686a6d7 100644
--- a/fs/jffs2/os-linux.h
+++ b/fs/jffs2/os-linux.h
@@ -154,7 +154,7 @@ extern const struct file_operations jffs2_file_operations;
 extern const struct inode_operations jffs2_file_inode_operations;
 extern const struct address_space_operations jffs2_file_address_operations;
 int jffs2_fsync(struct file *, loff_t, loff_t, int);
-int jffs2_do_readpage_unlock (struct inode *inode, struct page *pg);
+int jffs2_do_readpage_unlock (struct file *_inode, struct page *pg);
 
 /* ioctl.c */
 long jffs2_ioctl(struct file *, unsigned int, unsigned long);
diff --git a/fs/jffs2/wbuf.c b/fs/jffs2/wbuf.c
index b25d28a21..7934a69b1 100644
--- a/fs/jffs2/wbuf.c
+++ b/fs/jffs2/wbuf.c
@@ -1023,7 +1023,8 @@ static const struct jffs2_unknown_node oob_cleanmarker =
 {
 	.magic = constant_cpu_to_je16(JFFS2_MAGIC_BITMASK),
 	.nodetype = constant_cpu_to_je16(JFFS2_NODETYPE_CLEANMARKER),
-	.totlen = constant_cpu_to_je32(8)
+	.totlen = constant_cpu_to_je32(8),
+	.hdr_crc = constant_cpu_to_je32(0)
 };
 
 /*
diff --git a/fs/jfs/super.c b/fs/jfs/super.c
index cec8814a3..daae32fed 100644
--- a/fs/jfs/super.c
+++ b/fs/jfs/super.c
@@ -897,8 +897,10 @@ static int __init init_jfs_fs(void)
 	int rc;
 
 	jfs_inode_cachep =
-	    kmem_cache_create("jfs_ip", sizeof(struct jfs_inode_info), 0,
+	    kmem_cache_create_usercopy("jfs_ip", sizeof(struct jfs_inode_info), 0,
 			    SLAB_RECLAIM_ACCOUNT|SLAB_MEM_SPREAD|SLAB_ACCOUNT,
+			    offsetof(struct jfs_inode_info, i_inline),
+			    sizeof(((struct jfs_inode_info *)0)->i_inline),
 			    init_once);
 	if (jfs_inode_cachep == NULL)
 		return -ENOMEM;
diff --git a/fs/kernfs/dir.c b/fs/kernfs/dir.c
index e57174d43..573ed149c 100644
--- a/fs/kernfs/dir.c
+++ b/fs/kernfs/dir.c
@@ -334,7 +334,7 @@ struct kernfs_node *kernfs_get_parent(struct kernfs_node *kn)
  *
  *	Returns 31 bit hash of ns + name (so it fits in an off_t )
  */
-static unsigned int kernfs_name_hash(const char *name, const void *ns)
+static unsigned int kernfs_name_hash(const unsigned char *name, const void *ns)
 {
 	unsigned long hash = init_name_hash(ns);
 	unsigned int len = strlen(name);
@@ -1074,6 +1074,12 @@ static int kernfs_iop_mkdir(struct inode *dir, struct dentry *dentry,
 	ret = scops->mkdir(parent, dentry->d_name.name, mode);
 
 	kernfs_put_active(parent);
+
+	if (!ret) {
+		struct dentry *dentry_ret = kernfs_iop_lookup(dir, dentry, 0);
+		ret = PTR_ERR_OR_ZERO(dentry_ret);
+	}
+
 	return ret;
 }
 
diff --git a/fs/kernfs/file.c b/fs/kernfs/file.c
index 2bcb86e6e..b9fad5d0f 100644
--- a/fs/kernfs/file.c
+++ b/fs/kernfs/file.c
@@ -34,7 +34,7 @@ static DEFINE_MUTEX(kernfs_open_file_mutex);
 
 struct kernfs_open_node {
 	atomic_t		refcnt;
-	atomic_t		event;
+	atomic_unchecked_t	event;
 	wait_queue_head_t	poll;
 	struct list_head	files; /* goes through kernfs_open_file.list */
 };
@@ -163,7 +163,7 @@ static int kernfs_seq_show(struct seq_file *sf, void *v)
 {
 	struct kernfs_open_file *of = sf->private;
 
-	of->event = atomic_read(&of->kn->attr.open->event);
+	of->event = atomic_read_unchecked(&of->kn->attr.open->event);
 
 	return of->kn->attr.ops->seq_show(sf, v);
 }
@@ -208,7 +208,7 @@ static ssize_t kernfs_file_direct_read(struct kernfs_open_file *of,
 		goto out_free;
 	}
 
-	of->event = atomic_read(&of->kn->attr.open->event);
+	of->event = atomic_read_unchecked(&of->kn->attr.open->event);
 	ops = kernfs_ops(of->kn);
 	if (ops->read)
 		len = ops->read(of, buf, len, *ppos);
@@ -275,7 +275,7 @@ static ssize_t kernfs_fop_write(struct file *file, const char __user *user_buf,
 {
 	struct kernfs_open_file *of = kernfs_of(file);
 	const struct kernfs_ops *ops;
-	size_t len;
+	ssize_t len;
 	char *buf;
 
 	if (of->atomic_write_len) {
@@ -391,12 +391,12 @@ static int kernfs_vma_page_mkwrite(struct vm_area_struct *vma,
 	return ret;
 }
 
-static int kernfs_vma_access(struct vm_area_struct *vma, unsigned long addr,
-			     void *buf, int len, int write)
+static ssize_t kernfs_vma_access(struct vm_area_struct *vma, unsigned long addr,
+			     void *buf, size_t len, int write)
 {
 	struct file *file = vma->vm_file;
 	struct kernfs_open_file *of = kernfs_of(file);
-	int ret;
+	ssize_t ret;
 
 	if (!of->vm_ops)
 		return -EINVAL;
@@ -575,7 +575,7 @@ static int kernfs_get_open_node(struct kernfs_node *kn,
 		return -ENOMEM;
 
 	atomic_set(&new_on->refcnt, 0);
-	atomic_set(&new_on->event, 1);
+	atomic_set_unchecked(&new_on->event, 1);
 	init_waitqueue_head(&new_on->poll);
 	INIT_LIST_HEAD(&new_on->files);
 	goto retry;
@@ -799,7 +799,7 @@ static unsigned int kernfs_fop_poll(struct file *filp, poll_table *wait)
 
 	kernfs_put_active(kn);
 
-	if (of->event != atomic_read(&on->event))
+	if (of->event != atomic_read_unchecked(&on->event))
 		goto trigger;
 
 	return DEFAULT_POLLMASK;
@@ -830,7 +830,7 @@ repeat:
 
 	on = kn->attr.open;
 	if (on) {
-		atomic_inc(&on->event);
+		atomic_inc_unchecked(&on->event);
 		wake_up_interruptible(&on->poll);
 	}
 
diff --git a/fs/lockd/clnt4xdr.c b/fs/lockd/clnt4xdr.c
index d3e40db28..a300f9c89 100644
--- a/fs/lockd/clnt4xdr.c
+++ b/fs/lockd/clnt4xdr.c
@@ -379,10 +379,11 @@ static void encode_nlm4_lock(struct xdr_stream *xdr,
  *		struct nlm4_lock alock;
  *	};
  */
-static void nlm4_xdr_enc_testargs(struct rpc_rqst *req,
+static void nlm4_xdr_enc_testargs(void *req,
 				  struct xdr_stream *xdr,
-				  const struct nlm_args *args)
+				  void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -400,10 +401,11 @@ static void nlm4_xdr_enc_testargs(struct rpc_rqst *req,
  *		int state;
  *	};
  */
-static void nlm4_xdr_enc_lockargs(struct rpc_rqst *req,
+static void nlm4_xdr_enc_lockargs(void *req,
 				  struct xdr_stream *xdr,
-				  const struct nlm_args *args)
+				  void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -422,10 +424,11 @@ static void nlm4_xdr_enc_lockargs(struct rpc_rqst *req,
  *		struct nlm4_lock alock;
  *	};
  */
-static void nlm4_xdr_enc_cancargs(struct rpc_rqst *req,
+static void nlm4_xdr_enc_cancargs(void *req,
 				  struct xdr_stream *xdr,
-				  const struct nlm_args *args)
+				  void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -440,10 +443,11 @@ static void nlm4_xdr_enc_cancargs(struct rpc_rqst *req,
  *		struct nlm4_lock alock;
  *	};
  */
-static void nlm4_xdr_enc_unlockargs(struct rpc_rqst *req,
+static void nlm4_xdr_enc_unlockargs(void *req,
 				    struct xdr_stream *xdr,
-				    const struct nlm_args *args)
+				    void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -456,10 +460,12 @@ static void nlm4_xdr_enc_unlockargs(struct rpc_rqst *req,
  *		nlm4_stat stat;
  *	};
  */
-static void nlm4_xdr_enc_res(struct rpc_rqst *req,
+static void nlm4_xdr_enc_res(void *req,
 			     struct xdr_stream *xdr,
-			     const struct nlm_res *result)
+			     void *_result)
 {
+	const struct nlm_res *result = _result;
+
 	encode_cookie(xdr, &result->cookie);
 	encode_nlm4_stat(xdr, result->status);
 }
@@ -477,10 +483,12 @@ static void nlm4_xdr_enc_res(struct rpc_rqst *req,
  *		nlm4_testrply test_stat;
  *	};
  */
-static void nlm4_xdr_enc_testres(struct rpc_rqst *req,
+static void nlm4_xdr_enc_testres(void *req,
 				 struct xdr_stream *xdr,
-				 const struct nlm_res *result)
+				 void *_result)
 {
+	const struct nlm_res *result = _result;
+
 	encode_cookie(xdr, &result->cookie);
 	encode_nlm4_stat(xdr, result->status);
 	if (result->status == nlm_lck_denied)
@@ -523,10 +531,11 @@ out:
 	return error;
 }
 
-static int nlm4_xdr_dec_testres(struct rpc_rqst *req,
+static int nlm4_xdr_dec_testres(void *req,
 				struct xdr_stream *xdr,
-				struct nlm_res *result)
+				void *_result)
 {
+	struct nlm_res *result = _result;
 	int error;
 
 	error = decode_cookie(xdr, &result->cookie);
@@ -543,10 +552,11 @@ out:
  *		nlm4_stat stat;
  *	};
  */
-static int nlm4_xdr_dec_res(struct rpc_rqst *req,
+static int nlm4_xdr_dec_res(void *req,
 			    struct xdr_stream *xdr,
-			    struct nlm_res *result)
+			    void *_result)
 {
+	struct nlm_res *result = _result;
 	int error;
 
 	error = decode_cookie(xdr, &result->cookie);
@@ -566,8 +576,8 @@ out:
 #define PROC(proc, argtype, restype)					\
 [NLMPROC_##proc] = {							\
 	.p_proc      = NLMPROC_##proc,					\
-	.p_encode    = (kxdreproc_t)nlm4_xdr_enc_##argtype,		\
-	.p_decode    = (kxdrdproc_t)nlm4_xdr_dec_##restype,		\
+	.p_encode    = nlm4_xdr_enc_##argtype,				\
+	.p_decode    = nlm4_xdr_dec_##restype,				\
 	.p_arglen    = NLM4_##argtype##_sz,				\
 	.p_replen    = NLM4_##restype##_sz,				\
 	.p_statidx   = NLMPROC_##proc,					\
diff --git a/fs/lockd/clntproc.c b/fs/lockd/clntproc.c
index 112952037..356aeca98 100644
--- a/fs/lockd/clntproc.c
+++ b/fs/lockd/clntproc.c
@@ -36,11 +36,11 @@ static const struct rpc_call_ops nlmclnt_cancel_ops;
 /*
  * Cookie counter for NLM requests
  */
-static atomic_t	nlm_cookie = ATOMIC_INIT(0x1234);
+static atomic_unchecked_t	nlm_cookie = ATOMIC_INIT(0x1234);
 
 void nlmclnt_next_cookie(struct nlm_cookie *c)
 {
-	u32	cookie = atomic_inc_return(&nlm_cookie);
+	u32	cookie = atomic_inc_return_unchecked(&nlm_cookie);
 
 	memcpy(c->data, &cookie, 4);
 	c->len=4;
diff --git a/fs/lockd/clntxdr.c b/fs/lockd/clntxdr.c
index 3e9f7874b..c2177b8a3 100644
--- a/fs/lockd/clntxdr.c
+++ b/fs/lockd/clntxdr.c
@@ -372,10 +372,11 @@ static void encode_nlm_lock(struct xdr_stream *xdr,
  *		struct nlm_lock alock;
  *	};
  */
-static void nlm_xdr_enc_testargs(struct rpc_rqst *req,
+static void nlm_xdr_enc_testargs(void *req,
 				 struct xdr_stream *xdr,
-				 const struct nlm_args *args)
+				 void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -393,10 +394,11 @@ static void nlm_xdr_enc_testargs(struct rpc_rqst *req,
  *		int state;
  *	};
  */
-static void nlm_xdr_enc_lockargs(struct rpc_rqst *req,
+static void nlm_xdr_enc_lockargs(void *req,
 				 struct xdr_stream *xdr,
-				 const struct nlm_args *args)
+				 void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -415,10 +417,11 @@ static void nlm_xdr_enc_lockargs(struct rpc_rqst *req,
  *		struct nlm_lock alock;
  *	};
  */
-static void nlm_xdr_enc_cancargs(struct rpc_rqst *req,
+static void nlm_xdr_enc_cancargs(void *req,
 				 struct xdr_stream *xdr,
-				 const struct nlm_args *args)
+				 void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -433,10 +436,11 @@ static void nlm_xdr_enc_cancargs(struct rpc_rqst *req,
  *		struct nlm_lock alock;
  *	};
  */
-static void nlm_xdr_enc_unlockargs(struct rpc_rqst *req,
+static void nlm_xdr_enc_unlockargs(void *req,
 				   struct xdr_stream *xdr,
-				   const struct nlm_args *args)
+				   void *_args)
 {
+	const struct nlm_args *args = _args;
 	const struct nlm_lock *lock = &args->lock;
 
 	encode_cookie(xdr, &args->cookie);
@@ -449,10 +453,11 @@ static void nlm_xdr_enc_unlockargs(struct rpc_rqst *req,
  *		nlm_stat stat;
  *	};
  */
-static void nlm_xdr_enc_res(struct rpc_rqst *req,
+static void nlm_xdr_enc_res(void *req,
 			    struct xdr_stream *xdr,
-			    const struct nlm_res *result)
+			    void *_result)
 {
+	const struct nlm_res *result = _result;
 	encode_cookie(xdr, &result->cookie);
 	encode_nlm_stat(xdr, result->status);
 }
@@ -477,10 +482,11 @@ static void encode_nlm_testrply(struct xdr_stream *xdr,
 		encode_nlm_holder(xdr, result);
 }
 
-static void nlm_xdr_enc_testres(struct rpc_rqst *req,
+static void nlm_xdr_enc_testres(void *req,
 				struct xdr_stream *xdr,
-				const struct nlm_res *result)
+				void *_result)
 {
+	const struct nlm_res *result = _result;
 	encode_cookie(xdr, &result->cookie);
 	encode_nlm_stat(xdr, result->status);
 	encode_nlm_testrply(xdr, result);
@@ -521,11 +527,12 @@ out:
 	return error;
 }
 
-static int nlm_xdr_dec_testres(struct rpc_rqst *req,
+static int nlm_xdr_dec_testres(void *req,
 			       struct xdr_stream *xdr,
-			       struct nlm_res *result)
+			       void *_result)
 {
 	int error;
+	struct nlm_res *result = _result;
 
 	error = decode_cookie(xdr, &result->cookie);
 	if (unlikely(error))
@@ -541,11 +548,12 @@ out:
  *		nlm_stat stat;
  *	};
  */
-static int nlm_xdr_dec_res(struct rpc_rqst *req,
+static int nlm_xdr_dec_res(void *req,
 			   struct xdr_stream *xdr,
-			   struct nlm_res *result)
+			   void *_result)
 {
 	int error;
+	struct nlm_res *result = _result;
 
 	error = decode_cookie(xdr, &result->cookie);
 	if (unlikely(error))
@@ -564,8 +572,8 @@ out:
 #define PROC(proc, argtype, restype)	\
 [NLMPROC_##proc] = {							\
 	.p_proc      = NLMPROC_##proc,					\
-	.p_encode    = (kxdreproc_t)nlm_xdr_enc_##argtype,		\
-	.p_decode    = (kxdrdproc_t)nlm_xdr_dec_##restype,		\
+	.p_encode    = nlm_xdr_enc_##argtype,				\
+	.p_decode    = nlm_xdr_dec_##restype,				\
 	.p_arglen    = NLM_##argtype##_sz,				\
 	.p_replen    = NLM_##restype##_sz,				\
 	.p_statidx   = NLMPROC_##proc,					\
diff --git a/fs/lockd/mon.c b/fs/lockd/mon.c
index 19166d4a8..c841d5281 100644
--- a/fs/lockd/mon.c
+++ b/fs/lockd/mon.c
@@ -475,23 +475,22 @@ static void encode_priv(struct xdr_stream *xdr, const struct nsm_args *argp)
 	xdr_encode_opaque_fixed(p, argp->priv->data, SM_PRIV_SIZE);
 }
 
-static void nsm_xdr_enc_mon(struct rpc_rqst *req, struct xdr_stream *xdr,
-			    const struct nsm_args *argp)
+static void nsm_xdr_enc_mon(void *req, struct xdr_stream *xdr, void *argp)
 {
 	encode_mon_id(xdr, argp);
 	encode_priv(xdr, argp);
 }
 
-static void nsm_xdr_enc_unmon(struct rpc_rqst *req, struct xdr_stream *xdr,
-			      const struct nsm_args *argp)
+static void nsm_xdr_enc_unmon(void *req, struct xdr_stream *xdr, void *argp)
 {
 	encode_mon_id(xdr, argp);
 }
 
-static int nsm_xdr_dec_stat_res(struct rpc_rqst *rqstp,
+static int nsm_xdr_dec_stat_res(void *rqstp,
 				struct xdr_stream *xdr,
-				struct nsm_res *resp)
+				void *_resp)
 {
+	struct nsm_res *resp = _resp;
 	__be32 *p;
 
 	p = xdr_inline_decode(xdr, 4 + 4);
@@ -505,10 +504,11 @@ static int nsm_xdr_dec_stat_res(struct rpc_rqst *rqstp,
 	return 0;
 }
 
-static int nsm_xdr_dec_stat(struct rpc_rqst *rqstp,
+static int nsm_xdr_dec_stat(void *rqstp,
 			    struct xdr_stream *xdr,
-			    struct nsm_res *resp)
+			    void *_resp)
 {
+	struct nsm_res *resp = _resp;
 	__be32 *p;
 
 	p = xdr_inline_decode(xdr, 4);
@@ -532,8 +532,8 @@ static int nsm_xdr_dec_stat(struct rpc_rqst *rqstp,
 static struct rpc_procinfo	nsm_procedures[] = {
 [NSMPROC_MON] = {
 		.p_proc		= NSMPROC_MON,
-		.p_encode	= (kxdreproc_t)nsm_xdr_enc_mon,
-		.p_decode	= (kxdrdproc_t)nsm_xdr_dec_stat_res,
+		.p_encode	= nsm_xdr_enc_mon,
+		.p_decode	= nsm_xdr_dec_stat_res,
 		.p_arglen	= SM_mon_sz,
 		.p_replen	= SM_monres_sz,
 		.p_statidx	= NSMPROC_MON,
@@ -541,8 +541,8 @@ static struct rpc_procinfo	nsm_procedures[] = {
 	},
 [NSMPROC_UNMON] = {
 		.p_proc		= NSMPROC_UNMON,
-		.p_encode	= (kxdreproc_t)nsm_xdr_enc_unmon,
-		.p_decode	= (kxdrdproc_t)nsm_xdr_dec_stat,
+		.p_encode	= nsm_xdr_enc_unmon,
+		.p_decode	= nsm_xdr_dec_stat,
 		.p_arglen	= SM_mon_id_sz,
 		.p_replen	= SM_unmonres_sz,
 		.p_statidx	= NSMPROC_UNMON,
diff --git a/fs/lockd/svc.c b/fs/lockd/svc.c
index fc4084ef4..25d725db3 100644
--- a/fs/lockd/svc.c
+++ b/fs/lockd/svc.c
@@ -598,7 +598,7 @@ static struct ctl_table nlm_sysctl_root[] = {
  */
 
 #define param_set_min_max(name, type, which_strtol, min, max)		\
-static int param_set_##name(const char *val, struct kernel_param *kp)	\
+static int param_set_##name(const char *val, const struct kernel_param *kp)\
 {									\
 	char *endp;							\
 	__typeof__(type) num = which_strtol(val, &endp, 0);		\
diff --git a/fs/lockd/svc4proc.c b/fs/lockd/svc4proc.c
index 09c576f26..89b4d3d01 100644
--- a/fs/lockd/svc4proc.c
+++ b/fs/lockd/svc4proc.c
@@ -72,9 +72,10 @@ nlm4svc_proc_null(struct svc_rqst *rqstp, void *argp, void *resp)
  * TEST: Check for conflicting lock
  */
 static __be32
-nlm4svc_proc_test(struct svc_rqst *rqstp, struct nlm_args *argp,
-				         struct nlm_res  *resp)
+nlm4svc_proc_test(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res  *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 	__be32 rc = rpc_success;
@@ -99,9 +100,10 @@ nlm4svc_proc_test(struct svc_rqst *rqstp, struct nlm_args *argp,
 }
 
 static __be32
-nlm4svc_proc_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
-				         struct nlm_res  *resp)
+nlm4svc_proc_lock(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res  *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 	__be32 rc = rpc_success;
@@ -141,9 +143,10 @@ nlm4svc_proc_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
 }
 
 static __be32
-nlm4svc_proc_cancel(struct svc_rqst *rqstp, struct nlm_args *argp,
-				           struct nlm_res  *resp)
+nlm4svc_proc_cancel(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res  *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 
@@ -174,9 +177,10 @@ nlm4svc_proc_cancel(struct svc_rqst *rqstp, struct nlm_args *argp,
  * UNLOCK: release a lock
  */
 static __be32
-nlm4svc_proc_unlock(struct svc_rqst *rqstp, struct nlm_args *argp,
-				           struct nlm_res  *resp)
+nlm4svc_proc_unlock(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res  *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 
@@ -208,9 +212,11 @@ nlm4svc_proc_unlock(struct svc_rqst *rqstp, struct nlm_args *argp,
  * was granted
  */
 static __be32
-nlm4svc_proc_granted(struct svc_rqst *rqstp, struct nlm_args *argp,
-				            struct nlm_res  *resp)
+nlm4svc_proc_granted(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res  *resp = _resp;
+
 	resp->cookie = argp->cookie;
 
 	dprintk("lockd: GRANTED       called\n");
@@ -244,7 +250,7 @@ static const struct rpc_call_ops nlm4svc_callback_ops = {
  * doesn't break any clients.
  */
 static __be32 nlm4svc_callback(struct svc_rqst *rqstp, u32 proc, struct nlm_args *argp,
-		__be32 (*func)(struct svc_rqst *, struct nlm_args *, struct nlm_res  *))
+		__be32 (*func)(struct svc_rqst *, void *, void *))
 {
 	struct nlm_host	*host;
 	struct nlm_rqst	*call;
@@ -273,35 +279,35 @@ static __be32 nlm4svc_callback(struct svc_rqst *rqstp, u32 proc, struct nlm_args
 	return rpc_success;
 }
 
-static __be32 nlm4svc_proc_test_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
+static __be32 nlm4svc_proc_test_msg(struct svc_rqst *rqstp, void *argp,
 					     void	     *resp)
 {
 	dprintk("lockd: TEST_MSG      called\n");
 	return nlm4svc_callback(rqstp, NLMPROC_TEST_RES, argp, nlm4svc_proc_test);
 }
 
-static __be32 nlm4svc_proc_lock_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
+static __be32 nlm4svc_proc_lock_msg(struct svc_rqst *rqstp, void *argp,
 					     void	     *resp)
 {
 	dprintk("lockd: LOCK_MSG      called\n");
 	return nlm4svc_callback(rqstp, NLMPROC_LOCK_RES, argp, nlm4svc_proc_lock);
 }
 
-static __be32 nlm4svc_proc_cancel_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
+static __be32 nlm4svc_proc_cancel_msg(struct svc_rqst *rqstp, void *argp,
 					       void	       *resp)
 {
 	dprintk("lockd: CANCEL_MSG    called\n");
 	return nlm4svc_callback(rqstp, NLMPROC_CANCEL_RES, argp, nlm4svc_proc_cancel);
 }
 
-static __be32 nlm4svc_proc_unlock_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
+static __be32 nlm4svc_proc_unlock_msg(struct svc_rqst *rqstp, void *argp,
                                                void            *resp)
 {
 	dprintk("lockd: UNLOCK_MSG    called\n");
 	return nlm4svc_callback(rqstp, NLMPROC_UNLOCK_RES, argp, nlm4svc_proc_unlock);
 }
 
-static __be32 nlm4svc_proc_granted_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
+static __be32 nlm4svc_proc_granted_msg(struct svc_rqst *rqstp, void *argp,
                                                 void            *resp)
 {
 	dprintk("lockd: GRANTED_MSG   called\n");
@@ -312,9 +318,10 @@ static __be32 nlm4svc_proc_granted_msg(struct svc_rqst *rqstp, struct nlm_args *
  * SHARE: create a DOS share or alter existing share.
  */
 static __be32
-nlm4svc_proc_share(struct svc_rqst *rqstp, struct nlm_args *argp,
-				          struct nlm_res  *resp)
+nlm4svc_proc_share(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res  *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 
@@ -345,9 +352,10 @@ nlm4svc_proc_share(struct svc_rqst *rqstp, struct nlm_args *argp,
  * UNSHARE: Release a DOS share.
  */
 static __be32
-nlm4svc_proc_unshare(struct svc_rqst *rqstp, struct nlm_args *argp,
-				            struct nlm_res  *resp)
+nlm4svc_proc_unshare(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res  *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 
@@ -378,9 +386,10 @@ nlm4svc_proc_unshare(struct svc_rqst *rqstp, struct nlm_args *argp,
  * NM_LOCK: Create an unmonitored lock
  */
 static __be32
-nlm4svc_proc_nm_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
-				            struct nlm_res  *resp)
+nlm4svc_proc_nm_lock(struct svc_rqst *rqstp, void *_argp, void *resp)
 {
+	struct nlm_args *argp = _argp;
+
 	dprintk("lockd: NM_LOCK       called\n");
 
 	argp->monitor = 0;		/* just clean the monitor flag */
@@ -391,8 +400,7 @@ nlm4svc_proc_nm_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
  * FREE_ALL: Release all locks and shares held by client
  */
 static __be32
-nlm4svc_proc_free_all(struct svc_rqst *rqstp, struct nlm_args *argp,
-					     void            *resp)
+nlm4svc_proc_free_all(struct svc_rqst *rqstp, void *argp, void *resp)
 {
 	struct nlm_host	*host;
 
@@ -409,7 +417,7 @@ nlm4svc_proc_free_all(struct svc_rqst *rqstp, struct nlm_args *argp,
  * SM_NOTIFY: private callback from statd (not part of official NLM proto)
  */
 static __be32
-nlm4svc_proc_sm_notify(struct svc_rqst *rqstp, struct nlm_reboot *argp,
+nlm4svc_proc_sm_notify(struct svc_rqst *rqstp, void *argp,
 					      void	        *resp)
 {
 	dprintk("lockd: SM_NOTIFY     called\n");
@@ -429,9 +437,10 @@ nlm4svc_proc_sm_notify(struct svc_rqst *rqstp, struct nlm_reboot *argp,
  * client sent a GRANTED_RES, let's remove the associated block
  */
 static __be32
-nlm4svc_proc_granted_res(struct svc_rqst *rqstp, struct nlm_res  *argp,
-                                                void            *resp)
+nlm4svc_proc_granted_res(struct svc_rqst *rqstp, void *_argp, void *resp)
 {
+	struct nlm_res *argp = _argp;
+
         if (!nlmsvc_ops)
                 return rpc_success;
 
@@ -463,9 +472,9 @@ nlm4svc_proc_granted_res(struct svc_rqst *rqstp, struct nlm_res  *argp,
 struct nlm_void			{ int dummy; };
 
 #define PROC(name, xargt, xrest, argt, rest, respsize)	\
- { .pc_func	= (svc_procfunc) nlm4svc_proc_##name,	\
-   .pc_decode	= (kxdrproc_t) nlm4svc_decode_##xargt,	\
-   .pc_encode	= (kxdrproc_t) nlm4svc_encode_##xrest,	\
+ { .pc_func	= nlm4svc_proc_##name,			\
+   .pc_decode	= nlm4svc_decode_##xargt,		\
+   .pc_encode	= nlm4svc_encode_##xrest,		\
    .pc_release	= NULL,					\
    .pc_argsize	= sizeof(struct nlm_##argt),		\
    .pc_ressize	= sizeof(struct nlm_##rest),		\
diff --git a/fs/lockd/svcproc.c b/fs/lockd/svcproc.c
index fb26b9f52..a6d558266 100644
--- a/fs/lockd/svcproc.c
+++ b/fs/lockd/svcproc.c
@@ -102,9 +102,10 @@ nlmsvc_proc_null(struct svc_rqst *rqstp, void *argp, void *resp)
  * TEST: Check for conflicting lock
  */
 static __be32
-nlmsvc_proc_test(struct svc_rqst *rqstp, struct nlm_args *argp,
-				         struct nlm_res  *resp)
+nlmsvc_proc_test(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 	__be32 rc = rpc_success;
@@ -130,9 +131,10 @@ nlmsvc_proc_test(struct svc_rqst *rqstp, struct nlm_args *argp,
 }
 
 static __be32
-nlmsvc_proc_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
-				         struct nlm_res  *resp)
+nlmsvc_proc_lock(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 	__be32 rc = rpc_success;
@@ -172,9 +174,10 @@ nlmsvc_proc_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
 }
 
 static __be32
-nlmsvc_proc_cancel(struct svc_rqst *rqstp, struct nlm_args *argp,
-				           struct nlm_res  *resp)
+nlmsvc_proc_cancel(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 	struct net *net = SVC_NET(rqstp);
@@ -206,9 +209,10 @@ nlmsvc_proc_cancel(struct svc_rqst *rqstp, struct nlm_args *argp,
  * UNLOCK: release a lock
  */
 static __be32
-nlmsvc_proc_unlock(struct svc_rqst *rqstp, struct nlm_args *argp,
-				           struct nlm_res  *resp)
+nlmsvc_proc_unlock(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 	struct net *net = SVC_NET(rqstp);
@@ -241,9 +245,11 @@ nlmsvc_proc_unlock(struct svc_rqst *rqstp, struct nlm_args *argp,
  * was granted
  */
 static __be32
-nlmsvc_proc_granted(struct svc_rqst *rqstp, struct nlm_args *argp,
-				            struct nlm_res  *resp)
+nlmsvc_proc_granted(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res *resp = _resp;
+
 	resp->cookie = argp->cookie;
 
 	dprintk("lockd: GRANTED       called\n");
@@ -285,7 +291,7 @@ static const struct rpc_call_ops nlmsvc_callback_ops = {
  * doesn't break any clients.
  */
 static __be32 nlmsvc_callback(struct svc_rqst *rqstp, u32 proc, struct nlm_args *argp,
-		__be32 (*func)(struct svc_rqst *, struct nlm_args *, struct nlm_res  *))
+		__be32 (*func)(struct svc_rqst *, void *, void *))
 {
 	struct nlm_host	*host;
 	struct nlm_rqst	*call;
@@ -314,38 +320,33 @@ static __be32 nlmsvc_callback(struct svc_rqst *rqstp, u32 proc, struct nlm_args
 	return rpc_success;
 }
 
-static __be32 nlmsvc_proc_test_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
-					     void	     *resp)
+static __be32 nlmsvc_proc_test_msg(struct svc_rqst *rqstp,void *argp, void *resp)
 {
 	dprintk("lockd: TEST_MSG      called\n");
 	return nlmsvc_callback(rqstp, NLMPROC_TEST_RES, argp, nlmsvc_proc_test);
 }
 
-static __be32 nlmsvc_proc_lock_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
-					     void	     *resp)
+static __be32 nlmsvc_proc_lock_msg(struct svc_rqst *rqstp, void *argp, void *resp)
 {
 	dprintk("lockd: LOCK_MSG      called\n");
 	return nlmsvc_callback(rqstp, NLMPROC_LOCK_RES, argp, nlmsvc_proc_lock);
 }
 
-static __be32 nlmsvc_proc_cancel_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
-					       void	       *resp)
+static __be32 nlmsvc_proc_cancel_msg(struct svc_rqst *rqstp, void *argp, void *resp)
 {
 	dprintk("lockd: CANCEL_MSG    called\n");
 	return nlmsvc_callback(rqstp, NLMPROC_CANCEL_RES, argp, nlmsvc_proc_cancel);
 }
 
 static __be32
-nlmsvc_proc_unlock_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
-                                               void            *resp)
+nlmsvc_proc_unlock_msg(struct svc_rqst *rqstp, void *argp, void *resp)
 {
 	dprintk("lockd: UNLOCK_MSG    called\n");
 	return nlmsvc_callback(rqstp, NLMPROC_UNLOCK_RES, argp, nlmsvc_proc_unlock);
 }
 
 static __be32
-nlmsvc_proc_granted_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
-                                                void            *resp)
+nlmsvc_proc_granted_msg(struct svc_rqst *rqstp, void *argp, void *resp)
 {
 	dprintk("lockd: GRANTED_MSG   called\n");
 	return nlmsvc_callback(rqstp, NLMPROC_GRANTED_RES, argp, nlmsvc_proc_granted);
@@ -355,9 +356,10 @@ nlmsvc_proc_granted_msg(struct svc_rqst *rqstp, struct nlm_args *argp,
  * SHARE: create a DOS share or alter existing share.
  */
 static __be32
-nlmsvc_proc_share(struct svc_rqst *rqstp, struct nlm_args *argp,
-				          struct nlm_res  *resp)
+nlmsvc_proc_share(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 
@@ -388,9 +390,10 @@ nlmsvc_proc_share(struct svc_rqst *rqstp, struct nlm_args *argp,
  * UNSHARE: Release a DOS share.
  */
 static __be32
-nlmsvc_proc_unshare(struct svc_rqst *rqstp, struct nlm_args *argp,
-				            struct nlm_res  *resp)
+nlmsvc_proc_unshare(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nlm_args *argp = _argp;
+	struct nlm_res *resp = _resp;
 	struct nlm_host	*host;
 	struct nlm_file	*file;
 
@@ -421,9 +424,10 @@ nlmsvc_proc_unshare(struct svc_rqst *rqstp, struct nlm_args *argp,
  * NM_LOCK: Create an unmonitored lock
  */
 static __be32
-nlmsvc_proc_nm_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
-				            struct nlm_res  *resp)
+nlmsvc_proc_nm_lock(struct svc_rqst *rqstp, void *_argp, void *resp)
 {
+	struct nlm_args *argp = _argp;
+
 	dprintk("lockd: NM_LOCK       called\n");
 
 	argp->monitor = 0;		/* just clean the monitor flag */
@@ -434,8 +438,7 @@ nlmsvc_proc_nm_lock(struct svc_rqst *rqstp, struct nlm_args *argp,
  * FREE_ALL: Release all locks and shares held by client
  */
 static __be32
-nlmsvc_proc_free_all(struct svc_rqst *rqstp, struct nlm_args *argp,
-					     void            *resp)
+nlmsvc_proc_free_all(struct svc_rqst *rqstp, void *argp, void *resp)
 {
 	struct nlm_host	*host;
 
@@ -452,8 +455,7 @@ nlmsvc_proc_free_all(struct svc_rqst *rqstp, struct nlm_args *argp,
  * SM_NOTIFY: private callback from statd (not part of official NLM proto)
  */
 static __be32
-nlmsvc_proc_sm_notify(struct svc_rqst *rqstp, struct nlm_reboot *argp,
-					      void	        *resp)
+nlmsvc_proc_sm_notify(struct svc_rqst *rqstp, void *argp, void *resp)
 {
 	dprintk("lockd: SM_NOTIFY     called\n");
 
@@ -472,9 +474,10 @@ nlmsvc_proc_sm_notify(struct svc_rqst *rqstp, struct nlm_reboot *argp,
  * client sent a GRANTED_RES, let's remove the associated block
  */
 static __be32
-nlmsvc_proc_granted_res(struct svc_rqst *rqstp, struct nlm_res  *argp,
-                                                void            *resp)
+nlmsvc_proc_granted_res(struct svc_rqst *rqstp, void *_argp, void *resp)
 {
+	struct nlm_res *argp = _argp;
+
 	if (!nlmsvc_ops)
 		return rpc_success;
 
@@ -505,9 +508,9 @@ nlmsvc_proc_granted_res(struct svc_rqst *rqstp, struct nlm_res  *argp,
 struct nlm_void			{ int dummy; };
 
 #define PROC(name, xargt, xrest, argt, rest, respsize)	\
- { .pc_func	= (svc_procfunc) nlmsvc_proc_##name,	\
-   .pc_decode	= (kxdrproc_t) nlmsvc_decode_##xargt,	\
-   .pc_encode	= (kxdrproc_t) nlmsvc_encode_##xrest,	\
+ { .pc_func	= nlmsvc_proc_##name,			\
+   .pc_decode	= nlmsvc_decode_##xargt,		\
+   .pc_encode	= nlmsvc_encode_##xrest,		\
    .pc_release	= NULL,					\
    .pc_argsize	= sizeof(struct nlm_##argt),		\
    .pc_ressize	= sizeof(struct nlm_##rest),		\
diff --git a/fs/lockd/xdr.c b/fs/lockd/xdr.c
index 5b651daad..cfe094400 100644
--- a/fs/lockd/xdr.c
+++ b/fs/lockd/xdr.c
@@ -182,8 +182,9 @@ nlm_encode_testres(__be32 *p, struct nlm_res *resp)
  * First, the server side XDR functions
  */
 int
-nlmsvc_decode_testargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlmsvc_decode_testargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
 	u32	exclusive;
 
 	if (!(p = nlm_decode_cookie(p, &argp->cookie)))
@@ -199,16 +200,19 @@ nlmsvc_decode_testargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlmsvc_encode_testres(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlmsvc_encode_testres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nlm_res *resp = _resp;
+
 	if (!(p = nlm_encode_testres(p, resp)))
 		return 0;
 	return xdr_ressize_check(rqstp, p);
 }
 
 int
-nlmsvc_decode_lockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlmsvc_decode_lockargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
 	u32	exclusive;
 
 	if (!(p = nlm_decode_cookie(p, &argp->cookie)))
@@ -227,8 +231,9 @@ nlmsvc_decode_lockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlmsvc_decode_cancargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlmsvc_decode_cancargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
 	u32	exclusive;
 
 	if (!(p = nlm_decode_cookie(p, &argp->cookie)))
@@ -243,8 +248,10 @@ nlmsvc_decode_cancargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlmsvc_decode_unlockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlmsvc_decode_unlockargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
+
 	if (!(p = nlm_decode_cookie(p, &argp->cookie))
 	 || !(p = nlm_decode_lock(p, &argp->lock)))
 		return 0;
@@ -253,8 +260,10 @@ nlmsvc_decode_unlockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlmsvc_decode_shareargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlmsvc_decode_shareargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
+
 	struct nlm_lock	*lock = &argp->lock;
 
 	memset(lock, 0, sizeof(*lock));
@@ -274,8 +283,10 @@ nlmsvc_decode_shareargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlmsvc_encode_shareres(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlmsvc_encode_shareres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nlm_res *resp = _resp;
+
 	if (!(p = nlm_encode_cookie(p, &resp->cookie)))
 		return 0;
 	*p++ = resp->status;
@@ -284,8 +295,10 @@ nlmsvc_encode_shareres(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
 }
 
 int
-nlmsvc_encode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlmsvc_encode_res(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nlm_res *resp = _resp;
+
 	if (!(p = nlm_encode_cookie(p, &resp->cookie)))
 		return 0;
 	*p++ = resp->status;
@@ -293,8 +306,9 @@ nlmsvc_encode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
 }
 
 int
-nlmsvc_decode_notify(struct svc_rqst *rqstp, __be32 *p, struct nlm_args *argp)
+nlmsvc_decode_notify(void *rqstp, __be32 *p, void *_argp)
 {
+	struct nlm_args *argp = _argp;
 	struct nlm_lock	*lock = &argp->lock;
 
 	if (!(p = xdr_decode_string_inplace(p, &lock->caller,
@@ -305,8 +319,10 @@ nlmsvc_decode_notify(struct svc_rqst *rqstp, __be32 *p, struct nlm_args *argp)
 }
 
 int
-nlmsvc_decode_reboot(struct svc_rqst *rqstp, __be32 *p, struct nlm_reboot *argp)
+nlmsvc_decode_reboot(void *rqstp, __be32 *p, void *_argp)
 {
+	struct nlm_reboot *argp = _argp;
+
 	if (!(p = xdr_decode_string_inplace(p, &argp->mon, &argp->len, SM_MAXSTRLEN)))
 		return 0;
 	argp->state = ntohl(*p++);
@@ -316,8 +332,10 @@ nlmsvc_decode_reboot(struct svc_rqst *rqstp, __be32 *p, struct nlm_reboot *argp)
 }
 
 int
-nlmsvc_decode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlmsvc_decode_res(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nlm_res *resp = _resp;
+
 	if (!(p = nlm_decode_cookie(p, &resp->cookie)))
 		return 0;
 	resp->status = *p++;
@@ -325,13 +343,13 @@ nlmsvc_decode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
 }
 
 int
-nlmsvc_decode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nlmsvc_decode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_argsize_check(rqstp, p);
 }
 
 int
-nlmsvc_encode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nlmsvc_encode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_ressize_check(rqstp, p);
 }
diff --git a/fs/lockd/xdr4.c b/fs/lockd/xdr4.c
index dfa4789cd..be443bd9a 100644
--- a/fs/lockd/xdr4.c
+++ b/fs/lockd/xdr4.c
@@ -179,8 +179,9 @@ nlm4_encode_testres(__be32 *p, struct nlm_res *resp)
  * First, the server side XDR functions
  */
 int
-nlm4svc_decode_testargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlm4svc_decode_testargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
 	u32	exclusive;
 
 	if (!(p = nlm4_decode_cookie(p, &argp->cookie)))
@@ -196,7 +197,7 @@ nlm4svc_decode_testargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlm4svc_encode_testres(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlm4svc_encode_testres(void *rqstp, __be32 *p, void *resp)
 {
 	if (!(p = nlm4_encode_testres(p, resp)))
 		return 0;
@@ -204,8 +205,9 @@ nlm4svc_encode_testres(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
 }
 
 int
-nlm4svc_decode_lockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlm4svc_decode_lockargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
 	u32	exclusive;
 
 	if (!(p = nlm4_decode_cookie(p, &argp->cookie)))
@@ -224,8 +226,9 @@ nlm4svc_decode_lockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlm4svc_decode_cancargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlm4svc_decode_cancargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
 	u32	exclusive;
 
 	if (!(p = nlm4_decode_cookie(p, &argp->cookie)))
@@ -240,8 +243,10 @@ nlm4svc_decode_cancargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlm4svc_decode_unlockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlm4svc_decode_unlockargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
+
 	if (!(p = nlm4_decode_cookie(p, &argp->cookie))
 	 || !(p = nlm4_decode_lock(p, &argp->lock)))
 		return 0;
@@ -250,8 +255,9 @@ nlm4svc_decode_unlockargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlm4svc_decode_shareargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
+nlm4svc_decode_shareargs(void *rqstp, __be32 *p, void *_argp)
 {
+	nlm_args *argp = _argp;
 	struct nlm_lock	*lock = &argp->lock;
 
 	memset(lock, 0, sizeof(*lock));
@@ -271,8 +277,10 @@ nlm4svc_decode_shareargs(struct svc_rqst *rqstp, __be32 *p, nlm_args *argp)
 }
 
 int
-nlm4svc_encode_shareres(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlm4svc_encode_shareres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nlm_res *resp = _resp;
+
 	if (!(p = nlm4_encode_cookie(p, &resp->cookie)))
 		return 0;
 	*p++ = resp->status;
@@ -281,8 +289,10 @@ nlm4svc_encode_shareres(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
 }
 
 int
-nlm4svc_encode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlm4svc_encode_res(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nlm_res *resp = _resp;
+
 	if (!(p = nlm4_encode_cookie(p, &resp->cookie)))
 		return 0;
 	*p++ = resp->status;
@@ -290,8 +300,9 @@ nlm4svc_encode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
 }
 
 int
-nlm4svc_decode_notify(struct svc_rqst *rqstp, __be32 *p, struct nlm_args *argp)
+nlm4svc_decode_notify(void *rqstp, __be32 *p, void *_argp)
 {
+	struct nlm_args *argp = _argp;
 	struct nlm_lock	*lock = &argp->lock;
 
 	if (!(p = xdr_decode_string_inplace(p, &lock->caller,
@@ -302,8 +313,10 @@ nlm4svc_decode_notify(struct svc_rqst *rqstp, __be32 *p, struct nlm_args *argp)
 }
 
 int
-nlm4svc_decode_reboot(struct svc_rqst *rqstp, __be32 *p, struct nlm_reboot *argp)
+nlm4svc_decode_reboot(void *rqstp, __be32 *p, void *_argp)
 {
+	struct nlm_reboot *argp = _argp;
+
 	if (!(p = xdr_decode_string_inplace(p, &argp->mon, &argp->len, SM_MAXSTRLEN)))
 		return 0;
 	argp->state = ntohl(*p++);
@@ -313,8 +326,10 @@ nlm4svc_decode_reboot(struct svc_rqst *rqstp, __be32 *p, struct nlm_reboot *argp
 }
 
 int
-nlm4svc_decode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
+nlm4svc_decode_res(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nlm_res *resp = _resp;
+
 	if (!(p = nlm4_decode_cookie(p, &resp->cookie)))
 		return 0;
 	resp->status = *p++;
@@ -322,13 +337,13 @@ nlm4svc_decode_res(struct svc_rqst *rqstp, __be32 *p, struct nlm_res *resp)
 }
 
 int
-nlm4svc_decode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nlm4svc_decode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_argsize_check(rqstp, p);
 }
 
 int
-nlm4svc_encode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nlm4svc_encode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_ressize_check(rqstp, p);
 }
diff --git a/fs/logfs/dev_bdev.c b/fs/logfs/dev_bdev.c
index a8329cc47..b3d18fbfb 100644
--- a/fs/logfs/dev_bdev.c
+++ b/fs/logfs/dev_bdev.c
@@ -34,9 +34,8 @@ static int sync_request(struct page *page, struct block_device *bdev, int op)
 	return submit_bio_wait(&bio);
 }
 
-static int bdev_readpage(void *_sb, struct page *page)
+static int bdev_readpage(struct super_block *sb, struct page *page)
 {
-	struct super_block *sb = _sb;
 	struct block_device *bdev = logfs_super(sb)->s_bdev;
 	int err;
 
@@ -52,6 +51,11 @@ static int bdev_readpage(void *_sb, struct page *page)
 	return err;
 }
 
+static int bdev_filler(struct file *file, struct page *page)
+{
+	return bdev_readpage((struct super_block *)file, page);
+}
+
 static DECLARE_WAIT_QUEUE_HEAD(wq);
 
 static void writeseg_end_io(struct bio *bio)
@@ -251,7 +255,7 @@ static struct page *bdev_find_first_sb(struct super_block *sb, u64 *ofs)
 {
 	struct logfs_super *super = logfs_super(sb);
 	struct address_space *mapping = super->s_mapping_inode->i_mapping;
-	filler_t *filler = bdev_readpage;
+	filler_t *filler = bdev_filler;
 
 	*ofs = 0;
 	return read_cache_page(mapping, 0, filler, sb);
@@ -261,7 +265,7 @@ static struct page *bdev_find_last_sb(struct super_block *sb, u64 *ofs)
 {
 	struct logfs_super *super = logfs_super(sb);
 	struct address_space *mapping = super->s_mapping_inode->i_mapping;
-	filler_t *filler = bdev_readpage;
+	filler_t *filler = bdev_filler;
 	u64 pos = (super->s_bdev->bd_inode->i_size & ~0xfffULL) - 0x1000;
 	pgoff_t index = pos >> PAGE_SHIFT;
 
@@ -292,6 +296,7 @@ static const struct logfs_device_ops bd_devops = {
 	.find_last_sb	= bdev_find_last_sb,
 	.write_sb	= bdev_write_sb,
 	.readpage	= bdev_readpage,
+	.filler		= bdev_filler,
 	.writeseg	= bdev_writeseg,
 	.erase		= bdev_erase,
 	.can_write_buf	= bdev_can_write_buf,
diff --git a/fs/logfs/dev_mtd.c b/fs/logfs/dev_mtd.c
index b76a62b19..317c6ff41 100644
--- a/fs/logfs/dev_mtd.c
+++ b/fs/logfs/dev_mtd.c
@@ -122,9 +122,8 @@ static void logfs_mtd_sync(struct super_block *sb)
 	mtd_sync(mtd);
 }
 
-static int logfs_mtd_readpage(void *_sb, struct page *page)
+static int logfs_mtd_readpage(struct super_block *sb, struct page *page)
 {
-	struct super_block *sb = _sb;
 	int err;
 
 	err = logfs_mtd_read(sb, page->index << PAGE_SHIFT, PAGE_SIZE,
@@ -145,11 +144,16 @@ static int logfs_mtd_readpage(void *_sb, struct page *page)
 	return err;
 }
 
+static int logfs_mtd_filler(struct file *file, struct page *page)
+{
+	return logfs_mtd_readpage((struct super_block *)file, page);
+}
+
 static struct page *logfs_mtd_find_first_sb(struct super_block *sb, u64 *ofs)
 {
 	struct logfs_super *super = logfs_super(sb);
 	struct address_space *mapping = super->s_mapping_inode->i_mapping;
-	filler_t *filler = logfs_mtd_readpage;
+	filler_t *filler = logfs_mtd_filler;
 	struct mtd_info *mtd = super->s_mtd;
 
 	*ofs = 0;
@@ -166,7 +170,7 @@ static struct page *logfs_mtd_find_last_sb(struct super_block *sb, u64 *ofs)
 {
 	struct logfs_super *super = logfs_super(sb);
 	struct address_space *mapping = super->s_mapping_inode->i_mapping;
-	filler_t *filler = logfs_mtd_readpage;
+	filler_t *filler = logfs_mtd_filler;
 	struct mtd_info *mtd = super->s_mtd;
 
 	*ofs = mtd->size - mtd->erasesize;
@@ -254,6 +258,7 @@ static const struct logfs_device_ops mtd_devops = {
 	.find_first_sb	= logfs_mtd_find_first_sb,
 	.find_last_sb	= logfs_mtd_find_last_sb,
 	.readpage	= logfs_mtd_readpage,
+	.filler		= logfs_mtd_filler,
 	.writeseg	= logfs_mtd_writeseg,
 	.erase		= logfs_mtd_erase,
 	.can_write_buf	= logfs_mtd_can_write_buf,
diff --git a/fs/logfs/dir.c b/fs/logfs/dir.c
index 9568064ec..e188a4682 100644
--- a/fs/logfs/dir.c
+++ b/fs/logfs/dir.c
@@ -174,7 +174,7 @@ static struct page *logfs_get_dd_page(struct inode *dir, struct dentry *dentry)
 		if (!logfs_exist_block(dir, index))
 			continue;
 		page = read_cache_page(dir->i_mapping, index,
-				(filler_t *)logfs_readpage, NULL);
+				logfs_readpage, NULL);
 		if (IS_ERR(page))
 			return page;
 		dd = kmap_atomic(page);
@@ -306,7 +306,7 @@ static int logfs_readdir(struct file *file, struct dir_context *ctx)
 			continue;
 		}
 		page = read_cache_page(dir->i_mapping, pos,
-				(filler_t *)logfs_readpage, NULL);
+				logfs_readpage, NULL);
 		if (IS_ERR(page))
 			return PTR_ERR(page);
 		dd = kmap(page);
diff --git a/fs/logfs/logfs.h b/fs/logfs/logfs.h
index 27d040e35..8959149dc 100644
--- a/fs/logfs/logfs.h
+++ b/fs/logfs/logfs.h
@@ -151,7 +151,8 @@ struct logfs_device_ops {
 	struct page *(*find_first_sb)(struct super_block *sb, u64 *ofs);
 	struct page *(*find_last_sb)(struct super_block *sb, u64 *ofs);
 	int (*write_sb)(struct super_block *sb, struct page *page);
-	int (*readpage)(void *_sb, struct page *page);
+	int (*readpage)(struct super_block *sb, struct page *page);
+	int (*filler)(struct file *file, struct page *page);
 	void (*writeseg)(struct super_block *sb, u64 ofs, size_t len);
 	int (*erase)(struct super_block *sb, loff_t ofs, size_t len,
 			int ensure_write);
@@ -617,8 +618,6 @@ static inline int logfs_buf_recover(struct logfs_area *area, u64 ofs,
 }
 
 /* super.c */
-struct page *emergency_read_begin(struct address_space *mapping, pgoff_t index);
-void emergency_read_end(struct page *page);
 void logfs_crash_dump(struct super_block *sb);
 int logfs_statfs(struct dentry *dentry, struct kstatfs *stats);
 int logfs_check_ds(struct logfs_disk_super *ds);
diff --git a/fs/logfs/readwrite.c b/fs/logfs/readwrite.c
index 3fb8c6d67..83a513355 100644
--- a/fs/logfs/readwrite.c
+++ b/fs/logfs/readwrite.c
@@ -1963,7 +1963,7 @@ int logfs_read_inode(struct inode *inode)
 		return -ENODATA;
 
 	page = read_cache_page(master_inode->i_mapping, ino,
-			(filler_t *)logfs_readpage, NULL);
+			logfs_readpage, NULL);
 	if (IS_ERR(page))
 		return PTR_ERR(page);
 
diff --git a/fs/logfs/segment.c b/fs/logfs/segment.c
index 1efd6055f..d712407be 100644
--- a/fs/logfs/segment.c
+++ b/fs/logfs/segment.c
@@ -54,7 +54,7 @@ static struct page *get_mapping_page(struct super_block *sb, pgoff_t index,
 {
 	struct logfs_super *super = logfs_super(sb);
 	struct address_space *mapping = super->s_mapping_inode->i_mapping;
-	filler_t *filler = super->s_devops->readpage;
+	filler_t *filler = super->s_devops->filler;
 	struct page *page;
 
 	BUG_ON(mapping_gfp_constraint(mapping, __GFP_FS));
diff --git a/fs/logfs/super.c b/fs/logfs/super.c
index 5751082db..7619dac1f 100644
--- a/fs/logfs/super.c
+++ b/fs/logfs/super.c
@@ -18,39 +18,6 @@
 #include <linux/statfs.h>
 #include <linux/buffer_head.h>
 
-static DEFINE_MUTEX(emergency_mutex);
-static struct page *emergency_page;
-
-struct page *emergency_read_begin(struct address_space *mapping, pgoff_t index)
-{
-	filler_t *filler = (filler_t *)mapping->a_ops->readpage;
-	struct page *page;
-	int err;
-
-	page = read_cache_page(mapping, index, filler, NULL);
-	if (page)
-		return page;
-
-	/* No more pages available, switch to emergency page */
-	printk(KERN_INFO"Logfs: Using emergency page\n");
-	mutex_lock(&emergency_mutex);
-	err = filler(NULL, emergency_page);
-	if (err) {
-		mutex_unlock(&emergency_mutex);
-		printk(KERN_EMERG"Logfs: Error reading emergency page\n");
-		return ERR_PTR(err);
-	}
-	return emergency_page;
-}
-
-void emergency_read_end(struct page *page)
-{
-	if (page == emergency_page)
-		mutex_unlock(&emergency_mutex);
-	else
-		put_page(page);
-}
-
 static void dump_segfile(struct super_block *sb)
 {
 	struct logfs_super *super = logfs_super(sb);
@@ -614,10 +581,6 @@ static int __init logfs_init(void)
 {
 	int ret;
 
-	emergency_page = alloc_pages(GFP_KERNEL, 0);
-	if (!emergency_page)
-		return -ENOMEM;
-
 	ret = logfs_compr_init();
 	if (ret)
 		goto out1;
@@ -633,7 +596,6 @@ static int __init logfs_init(void)
 out2:
 	logfs_compr_exit();
 out1:
-	__free_pages(emergency_page, 0);
 	return ret;
 }
 
@@ -642,7 +604,6 @@ static void __exit logfs_exit(void)
 	unregister_filesystem(&logfs_fs_type);
 	logfs_destroy_inode_cache();
 	logfs_compr_exit();
-	__free_pages(emergency_page, 0);
 }
 
 module_init(logfs_init);
diff --git a/fs/mount.h b/fs/mount.h
index 14db05d42..687f6d837 100644
--- a/fs/mount.h
+++ b/fs/mount.h
@@ -13,7 +13,7 @@ struct mnt_namespace {
 	u64			seq;	/* Sequence number to prevent loops */
 	wait_queue_head_t poll;
 	u64 event;
-};
+} __randomize_layout;
 
 struct mnt_pcp {
 	int mnt_count;
@@ -65,7 +65,7 @@ struct mount {
 	struct hlist_head mnt_pins;
 	struct fs_pin mnt_umount;
 	struct dentry *mnt_ex_mountpoint;
-};
+} __randomize_layout;
 
 #define MNT_NS_INTERNAL ERR_PTR(-EINVAL) /* distinct from any mnt_namespace */
 
diff --git a/fs/namei.c b/fs/namei.c
index adb04146d..82da44778 100644
--- a/fs/namei.c
+++ b/fs/namei.c
@@ -338,17 +338,32 @@ int generic_permission(struct inode *inode, int mask)
 	if (ret != -EACCES)
 		return ret;
 
+#ifdef CONFIG_GRKERNSEC
+	/* we'll block if we have to log due to a denied capability use */
+	if (mask & MAY_NOT_BLOCK)
+		return -ECHILD;
+#endif
+
 	if (S_ISDIR(inode->i_mode)) {
 		/* DACs are overridable for directories */
-		if (capable_wrt_inode_uidgid(inode, CAP_DAC_OVERRIDE))
-			return 0;
 		if (!(mask & MAY_WRITE))
-			if (capable_wrt_inode_uidgid(inode,
-						     CAP_DAC_READ_SEARCH))
+			if (capable_wrt_inode_uidgid_nolog(inode, CAP_DAC_OVERRIDE) ||
+			    capable_wrt_inode_uidgid(inode, CAP_DAC_READ_SEARCH))
 				return 0;
+		if (capable_wrt_inode_uidgid(inode, CAP_DAC_OVERRIDE))
+			return 0;
 		return -EACCES;
 	}
 	/*
+	 * Searching includes executable on directories, else just read.
+	 */
+	mask &= MAY_READ | MAY_WRITE | MAY_EXEC;
+	if (mask == MAY_READ)
+		if (capable_wrt_inode_uidgid_nolog(inode, CAP_DAC_OVERRIDE) ||
+		    capable_wrt_inode_uidgid(inode, CAP_DAC_READ_SEARCH))
+			return 0;
+
+	/*
 	 * Read/write DACs are always overridable.
 	 * Executable DACs are overridable when there is
 	 * at least one exec bit set.
@@ -357,14 +372,6 @@ int generic_permission(struct inode *inode, int mask)
 		if (capable_wrt_inode_uidgid(inode, CAP_DAC_OVERRIDE))
 			return 0;
 
-	/*
-	 * Searching includes executable on directories, else just read.
-	 */
-	mask &= MAY_READ | MAY_WRITE | MAY_EXEC;
-	if (mask == MAY_READ)
-		if (capable_wrt_inode_uidgid(inode, CAP_DAC_READ_SEARCH))
-			return 0;
-
 	return -EACCES;
 }
 EXPORT_SYMBOL(generic_permission);
@@ -524,12 +531,35 @@ struct nameidata {
 	struct inode	*link_inode;
 	unsigned	root_seq;
 	int		dfd;
-};
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	struct path	*symlinkown_stack;
+	struct path 	symlinkown_internal[EMBEDDED_LEVELS];
+	unsigned	symlinkown_depth;
+	int		symlinkown_enabled;
+#endif
+} __randomize_layout;
+
+static int gr_handle_nameidata_symlinkowner(const struct nameidata *nd, const struct inode *target)
+{
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	int i;
+
+	for (i = 0; i < nd->symlinkown_depth; i++) {
+		if (gr_handle_symlink_owner(&nd->symlinkown_stack[i], target))
+			return -EACCES;
+	}
+#endif
+	return 0;
+}
 
 static void set_nameidata(struct nameidata *p, int dfd, struct filename *name)
 {
 	struct nameidata *old = current->nameidata;
 	p->stack = p->internal;
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	p->symlinkown_stack = p->symlinkown_internal;
+	p->symlinkown_enabled = -1;
+#endif
 	p->dfd = dfd;
 	p->name = name;
 	p->total_link_count = old ? old->total_link_count : 0;
@@ -546,6 +576,10 @@ static void restore_nameidata(void)
 		old->total_link_count = now->total_link_count;
 	if (now->stack != now->internal)
 		kfree(now->stack);
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	if (now->symlinkown_stack != now->symlinkown_internal)
+		kfree(now->symlinkown_stack);
+#endif
 }
 
 static int __nd_alloc_stack(struct nameidata *nd)
@@ -565,6 +599,7 @@ static int __nd_alloc_stack(struct nameidata *nd)
 	}
 	memcpy(p, nd->internal, sizeof(nd->internal));
 	nd->stack = p;
+
 	return 0;
 }
 
@@ -586,8 +621,32 @@ static bool path_connected(const struct path *path)
 	return is_subdir(path->dentry, mnt->mnt_root);
 }
 
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+static int nd_alloc_symlinkown_stack(struct nameidata *nd)
+{
+	struct path *p;
+
+	if (likely(nd->symlinkown_depth != EMBEDDED_LEVELS))
+		return 0;
+	if (nd->symlinkown_stack != nd->symlinkown_internal)
+		return 0;
+
+	p = kmalloc(MAXSYMLINKS * sizeof(struct path), GFP_KERNEL);
+	if (unlikely(!p))
+		return -ENOMEM;
+	memcpy(p, nd->symlinkown_internal, sizeof(nd->symlinkown_internal));
+	nd->symlinkown_stack = p;
+	return 0;
+}
+#endif
+
 static inline int nd_alloc_stack(struct nameidata *nd)
 {
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	if (nd->flags & LOOKUP_RCU)
+		return -ECHILD;
+#endif
+
 	if (likely(nd->depth != EMBEDDED_LEVELS))
 		return 0;
 	if (likely(nd->stack != nd->internal))
@@ -613,6 +672,14 @@ static void terminate_walk(struct nameidata *nd)
 		path_put(&nd->path);
 		for (i = 0; i < nd->depth; i++)
 			path_put(&nd->stack[i].link);
+
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	/* we'll only ever set our values in ref-walk mode */
+		for (i = 0; i < nd->symlinkown_depth; i++)
+			path_put(&nd->symlinkown_stack[i]);
+		nd->symlinkown_depth = 0;
+#endif
+
 		if (nd->root.mnt && !(nd->flags & LOOKUP_ROOT)) {
 			path_put(&nd->root);
 			nd->root.mnt = NULL;
@@ -1026,6 +1093,9 @@ const char *get_link(struct nameidata *nd)
 	if (unlikely(error))
 		return ERR_PTR(error);
 
+	if (gr_handle_follow_link(dentry, last->link.mnt))
+		return ERR_PTR(-EACCES);
+
 	nd->last_type = LAST_BIND;
 	res = inode->i_link;
 	if (!res) {
@@ -1717,6 +1787,23 @@ static int pick_link(struct nameidata *nd, struct path *link,
 		}
 	}
 
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	if (unlikely(nd->symlinkown_enabled == -1))
+		nd->symlinkown_enabled = gr_get_symlinkown_enabled();
+	if (nd->symlinkown_enabled && gr_is_global_nonroot(inode->i_uid)) {
+		struct path *symlinkownlast;
+		error = nd_alloc_symlinkown_stack(nd);
+		if (unlikely(error)) {
+			path_put(link);
+			return error;
+		}
+		symlinkownlast = nd->symlinkown_stack + nd->symlinkown_depth++;
+		symlinkownlast->dentry = link->dentry;
+		symlinkownlast->mnt = link->mnt;
+		path_get(symlinkownlast);
+	}
+#endif
+
 	last = nd->stack + nd->depth++;
 	last->link = *link;
 	clear_delayed_call(&last->done);
@@ -1931,7 +2018,7 @@ u64 hashlen_string(const void *salt, const char *name)
 {
 	unsigned long a = 0, x = 0, y = (unsigned long)salt;
 	unsigned long adata, mask, len;
-	const struct word_at_a_time constants = WORD_AT_A_TIME_CONSTANTS;
+	static const struct word_at_a_time constants = WORD_AT_A_TIME_CONSTANTS;
 
 	len = 0;
 	goto inside;
@@ -2144,6 +2231,10 @@ static const char *path_init(struct nameidata *nd, unsigned flags)
 	nd->last_type = LAST_ROOT; /* if there are only slashes... */
 	nd->flags = flags | LOOKUP_JUMPED | LOOKUP_PARENT;
 	nd->depth = 0;
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	nd->symlinkown_depth = 0;
+#endif
+
 	if (flags & LOOKUP_ROOT) {
 		struct dentry *root = nd->root.dentry;
 		struct inode *inode = root->d_inode;
@@ -2275,6 +2366,14 @@ static int path_lookupat(struct nameidata *nd, unsigned flags, struct path *path
 	if (!err)
 		err = complete_walk(nd);
 
+	if (!err && !(nd->flags & LOOKUP_PARENT)) {
+		if (!gr_acl_handle_hidden_file(nd->path.dentry, nd->path.mnt))
+			err = -ENOENT;
+		if (!err)
+			err = gr_chroot_pathat(nd->dfd, nd->path.dentry,
+						nd->path.mnt, nd->flags);
+	}
+
 	if (!err && nd->flags & LOOKUP_DIRECTORY)
 		if (!d_can_lookup(nd->path.dentry))
 			err = -ENOTDIR;
@@ -2323,6 +2422,14 @@ static int path_parentat(struct nameidata *nd, unsigned flags,
 	err = link_path_walk(s, nd);
 	if (!err)
 		err = complete_walk(nd);
+
+	if (!err && gr_handle_nameidata_symlinkowner(nd, nd->inode))
+		err = -EACCES;
+
+	if (!err)
+		err = gr_chroot_pathat(nd->dfd, nd->path.dentry,
+					nd->path.mnt, nd->flags);
+
 	if (!err) {
 		*parent = nd->path;
 		nd->path.mnt = NULL;
@@ -2940,6 +3047,13 @@ static int may_open(struct path *path, int acc_mode, int flag)
 	if (flag & O_NOATIME && !inode_owner_or_capable(inode))
 		return -EPERM;
 
+	if (gr_handle_rofs_blockwrite(dentry, path->mnt, acc_mode))
+		return -EPERM;
+	if (gr_handle_rawio(inode))
+		return -EPERM;
+	if (!gr_acl_handle_open(dentry, path->mnt, acc_mode))
+		return -EACCES;
+
 	return 0;
 }
 
@@ -3179,6 +3293,20 @@ no_open:
 
 	/* Negative dentry, just create the file */
 	if (!dentry->d_inode && (open_flag & O_CREAT)) {
+		error = gr_chroot_pathat(nd->dfd, dentry, nd->path.mnt, nd->flags);
+		if (error)
+			goto out_dput;
+
+		if (gr_handle_nameidata_symlinkowner(nd, dir_inode)) {
+			error = -EACCES;
+			goto out_dput;
+		}
+
+		if (!gr_acl_handle_creat(dentry, dir, nd->path.mnt, op->open_flag, op->acc_mode, mode)) {
+			error = -EACCES;
+			goto out_dput;
+		}
+
 		*opened |= FILE_CREATED;
 		audit_inode_child(dir_inode, dentry, AUDIT_TYPE_CHILD_CREATE);
 		if (!dir_inode->i_op->create) {
@@ -3189,6 +3317,7 @@ no_open:
 						open_flag & O_EXCL);
 		if (error)
 			goto out_dput;
+		gr_handle_create(dentry, nd->path.mnt);
 		fsnotify_create(dir_inode, dentry);
 	}
 	if (unlikely(create_error) && !dentry->d_inode) {
@@ -3303,6 +3432,11 @@ static int do_last(struct nameidata *nd,
 		goto finish_open_created;
 	}
 
+	if (!gr_acl_handle_hidden_file(path.dentry, nd->path.mnt)) {
+		path_to_nameidata(&path, nd);
+		return -ENOENT;
+	}
+
 	/*
 	 * If atomic_open() acquired write access it is dropped now due to
 	 * possible mount and symlink following (this might be optimized away if
@@ -3322,6 +3456,13 @@ static int do_last(struct nameidata *nd,
 		return -ENOENT;
 	}
 
+	/* only check if O_CREAT is specified, all other checks need to go
+	   into may_open */
+	if (gr_handle_fifo(path.dentry, path.mnt, dir, open_flag, acc_mode)) {
+		path_to_nameidata(&path, nd);
+		return -EACCES;
+	}
+
 	/*
 	 * create/update audit record if it already exists.
 	 */
@@ -3350,6 +3491,21 @@ finish_open:
 	error = complete_walk(nd);
 	if (error)
 		return error;
+
+	if (!gr_acl_handle_hidden_file(nd->path.dentry, nd->path.mnt)) {
+		error = -ENOENT;
+		goto out;
+	}
+
+	error = gr_chroot_pathat(nd->dfd, nd->path.dentry, nd->path.mnt, nd->flags);
+	if (error)
+		goto out;
+
+	if (gr_handle_nameidata_symlinkowner(nd, nd->inode)) {
+		error = -EACCES;
+		goto out;
+	}
+
 	audit_inode(nd->name, nd->path.dentry, 0);
 	error = -EISDIR;
 	if ((open_flag & O_CREAT) && d_is_dir(nd->path.dentry))
@@ -3606,9 +3762,11 @@ static struct dentry *filename_create(int dfd, struct filename *name,
 		goto unlock;
 
 	error = -EEXIST;
-	if (d_is_positive(dentry))
+	if (d_is_positive(dentry)) {
+		if (!gr_acl_handle_hidden_file(dentry, path->mnt))
+			error = -ENOENT;
 		goto fail;
-
+	}
 	/*
 	 * Special case - lookup gave negative, but... we had foo/bar/
 	 * From the vfs_mknod() POV we just have a negative dentry -
@@ -3662,6 +3820,20 @@ inline struct dentry *user_path_create(int dfd, const char __user *pathname,
 }
 EXPORT_SYMBOL(user_path_create);
 
+static struct dentry *user_path_create_with_name(int dfd, const char __user *pathname, struct path *path, struct filename **to, unsigned int lookup_flags)
+{
+	struct filename *tmp = getname(pathname);
+	struct dentry *res;
+	if (IS_ERR(tmp))
+		return ERR_CAST(tmp);
+	res = kern_path_create(dfd, tmp->name, path, lookup_flags);
+	if (IS_ERR(res))
+		putname(tmp);
+	else
+		*to = tmp;
+	return res;
+}
+
 int vfs_mknod(struct inode *dir, struct dentry *dentry, umode_t mode, dev_t dev)
 {
 	int error = may_create(dir, dentry);
@@ -3725,6 +3897,17 @@ retry:
 
 	if (!IS_POSIXACL(path.dentry->d_inode))
 		mode &= ~current_umask();
+
+	if (gr_handle_chroot_mknod(dentry, path.mnt, mode)) {
+		error = -EPERM;
+		goto out;
+	}
+
+	if (!gr_acl_handle_mknod(dentry, path.dentry, path.mnt, mode)) {
+		error = -EACCES;
+		goto out;
+	}
+
 	error = security_path_mknod(&path, dentry, mode, dev);
 	if (error)
 		goto out;
@@ -3742,6 +3925,8 @@ retry:
 			error = vfs_mknod(path.dentry->d_inode,dentry,mode,0);
 			break;
 	}
+	if (!error)
+		gr_handle_create(dentry, path.mnt);
 out:
 	done_path_create(&path, dentry);
 	if (retry_estale(error, lookup_flags)) {
@@ -3796,9 +3981,16 @@ retry:
 
 	if (!IS_POSIXACL(path.dentry->d_inode))
 		mode &= ~current_umask();
+	if (!gr_acl_handle_mkdir(dentry, path.dentry, path.mnt)) {
+		error = -EACCES;
+		goto out;
+	}
 	error = security_path_mkdir(&path, dentry, mode);
 	if (!error)
 		error = vfs_mkdir(path.dentry->d_inode, dentry, mode);
+	if (!error)
+		gr_handle_create(dentry, path.mnt);
+out:
 	done_path_create(&path, dentry);
 	if (retry_estale(error, lookup_flags)) {
 		lookup_flags |= LOOKUP_REVAL;
@@ -3859,6 +4051,8 @@ static long do_rmdir(int dfd, const char __user *pathname)
 	struct path path;
 	struct qstr last;
 	int type;
+	u64 saved_ino = 0;
+	dev_t saved_dev = 0;
 	unsigned int lookup_flags = 0;
 retry:
 	name = user_path_parent(dfd, pathname,
@@ -3891,10 +4085,20 @@ retry:
 		error = -ENOENT;
 		goto exit3;
 	}
+	saved_ino = gr_get_ino_from_dentry(dentry);
+	saved_dev = gr_get_dev_from_dentry(dentry);
+
+	if (!gr_acl_handle_rmdir(dentry, path.mnt)) {
+		error = -EACCES;
+		goto exit3;
+	}
+
 	error = security_path_rmdir(&path, dentry);
 	if (error)
 		goto exit3;
 	error = vfs_rmdir(path.dentry->d_inode, dentry);
+	if (!error && (saved_dev || saved_ino))
+		gr_handle_delete(saved_ino, saved_dev);
 exit3:
 	dput(dentry);
 exit2:
@@ -3989,6 +4193,8 @@ static long do_unlinkat(int dfd, const char __user *pathname)
 	int type;
 	struct inode *inode = NULL;
 	struct inode *delegated_inode = NULL;
+	u64 saved_ino = 0;
+	dev_t saved_dev = 0;
 	unsigned int lookup_flags = 0;
 retry:
 	name = user_path_parent(dfd, pathname,
@@ -4015,10 +4221,21 @@ retry_deleg:
 		if (d_is_negative(dentry))
 			goto slashes;
 		ihold(inode);
+		if (inode->i_nlink <= 1) {
+			saved_ino = gr_get_ino_from_dentry(dentry);
+			saved_dev = gr_get_dev_from_dentry(dentry);
+		}
+		if (!gr_acl_handle_unlink(dentry, path.mnt)) {
+			error = -EACCES;
+			goto exit2;
+		}
+
 		error = security_path_unlink(&path, dentry);
 		if (error)
 			goto exit2;
 		error = vfs_unlink(path.dentry->d_inode, dentry, &delegated_inode);
+		if (!error && (saved_ino || saved_dev))
+			gr_handle_delete(saved_ino, saved_dev);
 exit2:
 		dput(dentry);
 	}
@@ -4107,9 +4324,17 @@ retry:
 	if (IS_ERR(dentry))
 		goto out_putname;
 
+	if (!gr_acl_handle_symlink(dentry, path.dentry, path.mnt, from)) {
+		error = -EACCES;
+		goto out;
+	}
+
 	error = security_path_symlink(&path, dentry, from->name);
 	if (!error)
 		error = vfs_symlink(path.dentry->d_inode, dentry, from->name);
+	if (!error)
+		gr_handle_create(dentry, path.mnt);
+out:
 	done_path_create(&path, dentry);
 	if (retry_estale(error, lookup_flags)) {
 		lookup_flags |= LOOKUP_REVAL;
@@ -4220,6 +4445,7 @@ SYSCALL_DEFINE5(linkat, int, olddfd, const char __user *, oldname,
 	struct dentry *new_dentry;
 	struct path old_path, new_path;
 	struct inode *delegated_inode = NULL;
+	struct filename *to = NULL;
 	int how = 0;
 	int error;
 
@@ -4243,7 +4469,7 @@ retry:
 	if (error)
 		return error;
 
-	new_dentry = user_path_create(newdfd, newname, &new_path,
+	new_dentry = user_path_create_with_name(newdfd, newname, &new_path, &to,
 					(how & LOOKUP_REVAL));
 	error = PTR_ERR(new_dentry);
 	if (IS_ERR(new_dentry))
@@ -4255,11 +4481,26 @@ retry:
 	error = may_linkat(&old_path);
 	if (unlikely(error))
 		goto out_dput;
+
+	if (gr_handle_hardlink(old_path.dentry, old_path.mnt, to)) {
+		error = -EACCES;
+		goto out_dput;
+	}
+
+	if (!gr_acl_handle_link(new_dentry, new_path.dentry, new_path.mnt,
+				old_path.dentry, old_path.mnt, to)) {
+		error = -EACCES;
+		goto out_dput;
+	}
+
 	error = security_path_link(old_path.dentry, &new_path, new_dentry);
 	if (error)
 		goto out_dput;
 	error = vfs_link(old_path.dentry, new_path.dentry->d_inode, new_dentry, &delegated_inode);
+	if (!error)
+		gr_handle_create(new_dentry, new_path.mnt);
 out_dput:
+	putname(to);
 	done_path_create(&new_path, new_dentry);
 	if (delegated_inode) {
 		error = break_deleg_wait(&delegated_inode);
@@ -4578,6 +4819,20 @@ retry_deleg:
 	if (new_dentry == trap)
 		goto exit5;
 
+	if (gr_bad_chroot_rename(old_dentry, old_path.mnt, new_dentry, new_path.mnt)) {
+		/* use EXDEV error to cause 'mv' to switch to an alternative
+		 * method for usability
+		 */
+		error = -EXDEV;
+		goto exit5;
+	}
+
+	error = gr_acl_handle_rename(new_dentry, new_path.dentry, new_path.mnt,
+				     old_dentry, d_backing_inode(old_path.dentry), old_path.mnt,
+				     to, flags);
+	if (error)
+		goto exit5;
+
 	error = security_path_rename(&old_path, old_dentry,
 				     &new_path, new_dentry, flags);
 	if (error)
@@ -4585,6 +4840,9 @@ retry_deleg:
 	error = vfs_rename(old_path.dentry->d_inode, old_dentry,
 			   new_path.dentry->d_inode, new_dentry,
 			   &delegated_inode, flags);
+	if (!error)
+		gr_handle_rename(d_backing_inode(old_path.dentry), d_backing_inode(new_path.dentry), old_dentry,
+				 new_dentry, old_path.mnt, d_is_positive(new_dentry) ? 1 : 0, flags);
 exit5:
 	dput(new_dentry);
 exit4:
diff --git a/fs/namespace.c b/fs/namespace.c
index 7bb2cda3b..74b3e8fec 100644
--- a/fs/namespace.c
+++ b/fs/namespace.c
@@ -1516,6 +1516,9 @@ static int do_umount(struct mount *mnt, int flags)
 		if (!(sb->s_flags & MS_RDONLY))
 			retval = do_remount_sb(sb, MS_RDONLY, NULL, 0);
 		up_write(&sb->s_umount);
+
+		gr_log_remount(mnt->mnt_devname, retval);
+
 		return retval;
 	}
 
@@ -1538,6 +1541,9 @@ static int do_umount(struct mount *mnt, int flags)
 	}
 	unlock_mount_hash();
 	namespace_unlock();
+
+	gr_log_unmount(mnt->mnt_devname, retval);
+
 	return retval;
 }
 
@@ -1601,7 +1607,7 @@ static inline bool may_mandlock(void)
  * unixes. Our API is identical to OSF/1 to avoid making a mess of AMD
  */
 
-SYSCALL_DEFINE2(umount, char __user *, name, int, flags)
+SYSCALL_DEFINE2(umount, const char __user *, name, int, flags)
 {
 	struct path path;
 	struct mount *mnt;
@@ -1646,7 +1652,7 @@ out:
 /*
  *	The 2.0 compatible umount. No flags.
  */
-SYSCALL_DEFINE1(oldumount, char __user *, name)
+SYSCALL_DEFINE1(oldumount, const char __user *, name)
 {
 	return sys_umount(name, 0);
 }
@@ -2702,6 +2708,16 @@ long do_mount(const char *dev_name, const char __user *dir_name,
 		   MS_NOATIME | MS_NODIRATIME | MS_RELATIME| MS_KERNMOUNT |
 		   MS_STRICTATIME);
 
+	if (gr_handle_rofs_mount(path.dentry, path.mnt, mnt_flags)) {
+		retval = -EPERM;
+		goto dput_out;
+	}
+
+	if (gr_handle_chroot_mount(path.dentry, path.mnt, dev_name)) {
+		retval = -EPERM;
+		goto dput_out;
+	}
+
 	if (flags & MS_REMOUNT)
 		retval = do_remount(&path, flags & ~MS_REMOUNT, mnt_flags,
 				    data_page);
@@ -2715,7 +2731,10 @@ long do_mount(const char *dev_name, const char __user *dir_name,
 		retval = do_new_mount(&path, type_page, flags, mnt_flags,
 				      dev_name, data_page);
 dput_out:
+	gr_log_mount(dev_name, &path, retval);
+
 	path_put(&path);
+
 	return retval;
 }
 
@@ -2733,7 +2752,7 @@ static void free_mnt_ns(struct mnt_namespace *ns)
  * number incrementing at 10Ghz will take 12,427 years to wrap which
  * is effectively never, so we can ignore the possibility.
  */
-static atomic64_t mnt_ns_seq = ATOMIC64_INIT(1);
+static atomic64_unchecked_t mnt_ns_seq = ATOMIC64_INIT(1);
 
 static struct mnt_namespace *alloc_mnt_ns(struct user_namespace *user_ns)
 {
@@ -2749,7 +2768,7 @@ static struct mnt_namespace *alloc_mnt_ns(struct user_namespace *user_ns)
 		return ERR_PTR(ret);
 	}
 	new_ns->ns.ops = &mntns_operations;
-	new_ns->seq = atomic64_add_return(1, &mnt_ns_seq);
+	new_ns->seq = atomic64_add_return_unchecked(1, &mnt_ns_seq);
 	atomic_set(&new_ns->count, 1);
 	new_ns->root = NULL;
 	INIT_LIST_HEAD(&new_ns->list);
@@ -2759,6 +2778,7 @@ static struct mnt_namespace *alloc_mnt_ns(struct user_namespace *user_ns)
 	return new_ns;
 }
 
+__latent_entropy
 struct mnt_namespace *copy_mnt_ns(unsigned long flags, struct mnt_namespace *ns,
 		struct user_namespace *user_ns, struct fs_struct *new_fs)
 {
@@ -2880,8 +2900,8 @@ struct dentry *mount_subtree(struct vfsmount *mnt, const char *name)
 }
 EXPORT_SYMBOL(mount_subtree);
 
-SYSCALL_DEFINE5(mount, char __user *, dev_name, char __user *, dir_name,
-		char __user *, type, unsigned long, flags, void __user *, data)
+SYSCALL_DEFINE5(mount, const char __user *, dev_name, const char __user *, dir_name,
+		const char __user *, type, unsigned long, flags, void __user *, data)
 {
 	int ret;
 	char *kernel_type;
@@ -2987,6 +3007,11 @@ SYSCALL_DEFINE2(pivot_root, const char __user *, new_root,
 	if (error)
 		goto out2;
 
+	if (gr_handle_chroot_pivot()) {
+		error = -EPERM;
+		goto out2;
+	}
+
 	get_fs_root(current->fs, &root);
 	old_mp = lock_mount(&old);
 	error = PTR_ERR(old_mp);
@@ -3326,7 +3351,7 @@ static int mntns_install(struct nsproxy *nsproxy, struct ns_common *ns)
 	    !ns_capable(current_user_ns(), CAP_SYS_ADMIN))
 		return -EPERM;
 
-	if (fs->users != 1)
+	if (atomic_read(&fs->users) != 1)
 		return -EINVAL;
 
 	get_mnt_ns(mnt_ns);
diff --git a/fs/nfs/callback.h b/fs/nfs/callback.h
index 5fe1cecbf..d0f4ac04e 100644
--- a/fs/nfs/callback.h
+++ b/fs/nfs/callback.h
@@ -114,8 +114,8 @@ struct cb_sequenceres {
 	uint32_t			csr_target_highestslotid;
 };
 
-extern __be32 nfs4_callback_sequence(struct cb_sequenceargs *args,
-				       struct cb_sequenceres *res,
+extern __be32 nfs4_callback_sequence(void *_args,
+				       void *_res,
 				       struct cb_process_state *cps);
 
 #define RCA4_TYPE_MASK_RDATA_DLG	0
@@ -134,14 +134,14 @@ struct cb_recallanyargs {
 	uint32_t	craa_type_mask;
 };
 
-extern __be32 nfs4_callback_recallany(struct cb_recallanyargs *args,
+extern __be32 nfs4_callback_recallany(void *_args,
 					void *dummy,
 					struct cb_process_state *cps);
 
 struct cb_recallslotargs {
 	uint32_t	crsa_target_highest_slotid;
 };
-extern __be32 nfs4_callback_recallslot(struct cb_recallslotargs *args,
+extern __be32 nfs4_callback_recallslot(void *_args,
 					 void *dummy,
 					 struct cb_process_state *cps);
 
@@ -160,7 +160,7 @@ struct cb_layoutrecallargs {
 };
 
 extern __be32 nfs4_callback_layoutrecall(
-	struct cb_layoutrecallargs *args,
+	void *_args,
 	void *dummy, struct cb_process_state *cps);
 
 struct cb_devicenotifyitem {
@@ -176,15 +176,15 @@ struct cb_devicenotifyargs {
 };
 
 extern __be32 nfs4_callback_devicenotify(
-	struct cb_devicenotifyargs *args,
+	void *_args,
 	void *dummy, struct cb_process_state *cps);
 
 #endif /* CONFIG_NFS_V4_1 */
 extern int check_gss_callback_principal(struct nfs_client *, struct svc_rqst *);
-extern __be32 nfs4_callback_getattr(struct cb_getattrargs *args,
-				    struct cb_getattrres *res,
+extern __be32 nfs4_callback_getattr(void *args,
+				    void *res,
 				    struct cb_process_state *cps);
-extern __be32 nfs4_callback_recall(struct cb_recallargs *args, void *dummy,
+extern __be32 nfs4_callback_recall(void *args, void *dummy,
 				   struct cb_process_state *cps);
 #if IS_ENABLED(CONFIG_NFS_V4)
 extern int nfs_callback_up(u32 minorversion, struct rpc_xprt *xprt);
diff --git a/fs/nfs/callback_proc.c b/fs/nfs/callback_proc.c
index f953ef6b2..3791d58b6 100644
--- a/fs/nfs/callback_proc.c
+++ b/fs/nfs/callback_proc.c
@@ -19,10 +19,12 @@
 
 #define NFSDBG_FACILITY NFSDBG_CALLBACK
 
-__be32 nfs4_callback_getattr(struct cb_getattrargs *args,
-			     struct cb_getattrres *res,
+__be32 nfs4_callback_getattr(void *_args,
+			     void *_res,
 			     struct cb_process_state *cps)
 {
+	struct cb_getattrargs *args = _args;
+	struct cb_getattrres *res = _res;
 	struct nfs_delegation *delegation;
 	struct nfs_inode *nfsi;
 	struct inode *inode;
@@ -68,9 +70,10 @@ out:
 	return res->status;
 }
 
-__be32 nfs4_callback_recall(struct cb_recallargs *args, void *dummy,
+__be32 nfs4_callback_recall(void *_args, void *dummy,
 			    struct cb_process_state *cps)
 {
+	struct cb_recallargs *args =  _args;
 	struct inode *inode;
 	__be32 res;
 	
@@ -294,7 +297,7 @@ static u32 do_callback_layoutrecall(struct nfs_client *clp,
 
 }
 
-__be32 nfs4_callback_layoutrecall(struct cb_layoutrecallargs *args,
+__be32 nfs4_callback_layoutrecall(void *args,
 				  void *dummy, struct cb_process_state *cps)
 {
 	u32 res;
@@ -321,9 +324,10 @@ static void pnfs_recall_all_layouts(struct nfs_client *clp)
 	do_callback_layoutrecall(clp, &args);
 }
 
-__be32 nfs4_callback_devicenotify(struct cb_devicenotifyargs *args,
+__be32 nfs4_callback_devicenotify(void *_args,
 				  void *dummy, struct cb_process_state *cps)
 {
+	struct cb_devicenotifyargs *args = _args;
 	int i;
 	__be32 res = 0;
 	struct nfs_client *clp = cps->clp;
@@ -465,10 +469,12 @@ out:
 	return status;
 }
 
-__be32 nfs4_callback_sequence(struct cb_sequenceargs *args,
-			      struct cb_sequenceres *res,
+__be32 nfs4_callback_sequence(void *_args,
+			      void *_res,
 			      struct cb_process_state *cps)
 {
+	struct cb_sequenceargs *args = _args;
+	struct cb_sequenceres *res = _res;
 	struct nfs4_slot_table *tbl;
 	struct nfs4_slot *slot;
 	struct nfs_client *clp;
@@ -569,9 +575,10 @@ validate_bitmap_values(unsigned long mask)
 	return (mask & ~RCA4_TYPE_MASK_ALL) == 0;
 }
 
-__be32 nfs4_callback_recallany(struct cb_recallanyargs *args, void *dummy,
+__be32 nfs4_callback_recallany(void *_args, void *dummy,
 			       struct cb_process_state *cps)
 {
+	struct cb_recallanyargs *args = _args;
 	__be32 status;
 	fmode_t flags = 0;
 
@@ -604,9 +611,10 @@ out:
 }
 
 /* Reduce the fore channel's max_slots to the target value */
-__be32 nfs4_callback_recallslot(struct cb_recallslotargs *args, void *dummy,
+__be32 nfs4_callback_recallslot(void *_args, void *dummy,
 				struct cb_process_state *cps)
 {
+	struct cb_recallslotargs *args = _args;
 	struct nfs4_slot_table *fc_tbl;
 	__be32 status;
 
diff --git a/fs/nfs/callback_xdr.c b/fs/nfs/callback_xdr.c
index 656f68f7f..79c002620 100644
--- a/fs/nfs/callback_xdr.c
+++ b/fs/nfs/callback_xdr.c
@@ -53,7 +53,7 @@ struct callback_op {
 	callback_decode_arg_t decode_args;
 	callback_encode_res_t encode_res;
 	long res_maxsize;
-};
+} __do_const;
 
 static struct callback_op callback_ops[];
 
@@ -62,12 +62,12 @@ static __be32 nfs4_callback_null(struct svc_rqst *rqstp, void *argp, void *resp)
 	return htonl(NFS4_OK);
 }
 
-static int nfs4_decode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+static int nfs4_decode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_argsize_check(rqstp, p);
 }
 
-static int nfs4_encode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+static int nfs4_encode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_ressize_check(rqstp, p);
 }
@@ -199,8 +199,9 @@ static __be32 decode_op_hdr(struct xdr_stream *xdr, unsigned int *op)
 	return 0;
 }
 
-static __be32 decode_getattr_args(struct svc_rqst *rqstp, struct xdr_stream *xdr, struct cb_getattrargs *args)
+static __be32 decode_getattr_args(struct svc_rqst *rqstp, struct xdr_stream *xdr, void *_args)
 {
+	struct cb_getattrargs *args = _args;
 	__be32 status;
 
 	status = decode_fh(xdr, &args->fh);
@@ -212,8 +213,9 @@ out:
 	return status;
 }
 
-static __be32 decode_recall_args(struct svc_rqst *rqstp, struct xdr_stream *xdr, struct cb_recallargs *args)
+static __be32 decode_recall_args(struct svc_rqst *rqstp, struct xdr_stream *xdr, void *_args)
 {
+	struct cb_recallargs *args = _args;
 	__be32 *p;
 	__be32 status;
 
@@ -241,8 +243,9 @@ static __be32 decode_layout_stateid(struct xdr_stream *xdr, nfs4_stateid *statei
 
 static __be32 decode_layoutrecall_args(struct svc_rqst *rqstp,
 				       struct xdr_stream *xdr,
-				       struct cb_layoutrecallargs *args)
+				       void *_args)
 {
+	struct cb_layoutrecallargs *args = _args;
 	__be32 *p;
 	__be32 status = 0;
 	uint32_t iomode;
@@ -301,8 +304,9 @@ out:
 static
 __be32 decode_devicenotify_args(struct svc_rqst *rqstp,
 				struct xdr_stream *xdr,
-				struct cb_devicenotifyargs *args)
+				void *_args)
 {
+	struct cb_devicenotifyargs *args = _args;
 	__be32 *p;
 	__be32 status = 0;
 	u32 tmp;
@@ -442,8 +446,9 @@ out:
 
 static __be32 decode_cb_sequence_args(struct svc_rqst *rqstp,
 					struct xdr_stream *xdr,
-					struct cb_sequenceargs *args)
+					void *_args)
 {
+	struct cb_sequenceargs *args = _args;
 	__be32 *p;
 	int i;
 	__be32 status;
@@ -504,8 +509,9 @@ out_free:
 
 static __be32 decode_recallany_args(struct svc_rqst *rqstp,
 				      struct xdr_stream *xdr,
-				      struct cb_recallanyargs *args)
+				      void *_args)
 {
+	struct cb_recallanyargs *args = _args;
 	uint32_t bitmap[2];
 	__be32 *p, status;
 
@@ -523,8 +529,9 @@ static __be32 decode_recallany_args(struct svc_rqst *rqstp,
 
 static __be32 decode_recallslot_args(struct svc_rqst *rqstp,
 					struct xdr_stream *xdr,
-					struct cb_recallslotargs *args)
+					void *_args)
 {
+	struct cb_recallslotargs *args = _args;
 	__be32 *p;
 
 	p = read_buf(xdr, 4);
@@ -659,8 +666,9 @@ static __be32 encode_op_hdr(struct xdr_stream *xdr, uint32_t op, __be32 res)
 	return 0;
 }
 
-static __be32 encode_getattr_res(struct svc_rqst *rqstp, struct xdr_stream *xdr, const struct cb_getattrres *res)
+static __be32 encode_getattr_res(struct svc_rqst *rqstp, struct xdr_stream *xdr, void *_res)
 {
+	const struct cb_getattrres *res = _res;
 	__be32 *savep = NULL;
 	__be32 status = res->status;
 	
@@ -702,8 +710,9 @@ static __be32 encode_sessionid(struct xdr_stream *xdr,
 
 static __be32 encode_cb_sequence_res(struct svc_rqst *rqstp,
 				       struct xdr_stream *xdr,
-				       const struct cb_sequenceres *res)
+				       void *_res)
 {
+	const struct cb_sequenceres *res = _res;
 	__be32 *p;
 	__be32 status = res->csr_status;
 
@@ -967,43 +976,41 @@ static struct callback_op callback_ops[] = {
 		.res_maxsize = CB_OP_HDR_RES_MAXSZ,
 	},
 	[OP_CB_GETATTR] = {
-		.process_op = (callback_process_op_t)nfs4_callback_getattr,
-		.decode_args = (callback_decode_arg_t)decode_getattr_args,
-		.encode_res = (callback_encode_res_t)encode_getattr_res,
+		.process_op = nfs4_callback_getattr,
+		.decode_args = decode_getattr_args,
+		.encode_res = encode_getattr_res,
 		.res_maxsize = CB_OP_GETATTR_RES_MAXSZ,
 	},
 	[OP_CB_RECALL] = {
-		.process_op = (callback_process_op_t)nfs4_callback_recall,
-		.decode_args = (callback_decode_arg_t)decode_recall_args,
+		.process_op = nfs4_callback_recall,
+		.decode_args = decode_recall_args,
 		.res_maxsize = CB_OP_RECALL_RES_MAXSZ,
 	},
 #if defined(CONFIG_NFS_V4_1)
 	[OP_CB_LAYOUTRECALL] = {
-		.process_op = (callback_process_op_t)nfs4_callback_layoutrecall,
-		.decode_args =
-			(callback_decode_arg_t)decode_layoutrecall_args,
+		.process_op = nfs4_callback_layoutrecall,
+		.decode_args = decode_layoutrecall_args,
 		.res_maxsize = CB_OP_LAYOUTRECALL_RES_MAXSZ,
 	},
 	[OP_CB_NOTIFY_DEVICEID] = {
-		.process_op = (callback_process_op_t)nfs4_callback_devicenotify,
-		.decode_args =
-			(callback_decode_arg_t)decode_devicenotify_args,
+		.process_op = nfs4_callback_devicenotify,
+		.decode_args = decode_devicenotify_args,
 		.res_maxsize = CB_OP_DEVICENOTIFY_RES_MAXSZ,
 	},
 	[OP_CB_SEQUENCE] = {
-		.process_op = (callback_process_op_t)nfs4_callback_sequence,
-		.decode_args = (callback_decode_arg_t)decode_cb_sequence_args,
-		.encode_res = (callback_encode_res_t)encode_cb_sequence_res,
+		.process_op = nfs4_callback_sequence,
+		.decode_args = decode_cb_sequence_args,
+		.encode_res = encode_cb_sequence_res,
 		.res_maxsize = CB_OP_SEQUENCE_RES_MAXSZ,
 	},
 	[OP_CB_RECALL_ANY] = {
-		.process_op = (callback_process_op_t)nfs4_callback_recallany,
-		.decode_args = (callback_decode_arg_t)decode_recallany_args,
+		.process_op = nfs4_callback_recallany,
+		.decode_args = decode_recallany_args,
 		.res_maxsize = CB_OP_RECALLANY_RES_MAXSZ,
 	},
 	[OP_CB_RECALL_SLOT] = {
-		.process_op = (callback_process_op_t)nfs4_callback_recallslot,
-		.decode_args = (callback_decode_arg_t)decode_recallslot_args,
+		.process_op = nfs4_callback_recallslot,
+		.decode_args = decode_recallslot_args,
 		.res_maxsize = CB_OP_RECALLSLOT_RES_MAXSZ,
 	},
 #endif /* CONFIG_NFS_V4_1 */
@@ -1015,13 +1022,13 @@ static struct callback_op callback_ops[] = {
 static struct svc_procedure nfs4_callback_procedures1[] = {
 	[CB_NULL] = {
 		.pc_func = nfs4_callback_null,
-		.pc_decode = (kxdrproc_t)nfs4_decode_void,
-		.pc_encode = (kxdrproc_t)nfs4_encode_void,
+		.pc_decode = nfs4_decode_void,
+		.pc_encode = nfs4_encode_void,
 		.pc_xdrressize = 1,
 	},
 	[CB_COMPOUND] = {
 		.pc_func = nfs4_callback_compound,
-		.pc_encode = (kxdrproc_t)nfs4_encode_void,
+		.pc_encode = nfs4_encode_void,
 		.pc_argsize = 256,
 		.pc_ressize = 256,
 		.pc_xdrressize = NFS4_CALLBACK_BUFSIZE,
diff --git a/fs/nfs/dir.c b/fs/nfs/dir.c
index 6bc5a68e3..a7324a1d8 100644
--- a/fs/nfs/dir.c
+++ b/fs/nfs/dir.c
@@ -705,8 +705,9 @@ out:
  * We only need to convert from xdr once so future lookups are much simpler
  */
 static
-int nfs_readdir_filler(nfs_readdir_descriptor_t *desc, struct page* page)
+int nfs_readdir_filler(struct file *_desc, struct page* page)
 {
+	nfs_readdir_descriptor_t *desc = (nfs_readdir_descriptor_t *)_desc;
 	struct inode	*inode = file_inode(desc->file);
 	int ret;
 
@@ -741,7 +742,7 @@ struct page *get_cache_page(nfs_readdir_descriptor_t *desc)
 
 	for (;;) {
 		page = read_cache_page(desc->file->f_mapping,
-			desc->page_index, (filler_t *)nfs_readdir_filler, desc);
+			desc->page_index, nfs_readdir_filler, desc);
 		if (IS_ERR(page) || grab_page(page))
 			break;
 		put_page(page);
diff --git a/fs/nfs/inode.c b/fs/nfs/inode.c
index bf4ec5ecc..39aec950b 100644
--- a/fs/nfs/inode.c
+++ b/fs/nfs/inode.c
@@ -1323,16 +1323,16 @@ static int nfs_check_inode_attributes(struct inode *inode, struct nfs_fattr *fat
 	return 0;
 }
 
-static atomic_long_t nfs_attr_generation_counter;
+static atomic_long_unchecked_t nfs_attr_generation_counter;
 
 static unsigned long nfs_read_attr_generation_counter(void)
 {
-	return atomic_long_read(&nfs_attr_generation_counter);
+	return atomic_long_read_unchecked(&nfs_attr_generation_counter);
 }
 
 unsigned long nfs_inc_attr_generation_counter(void)
 {
-	return atomic_long_inc_return(&nfs_attr_generation_counter);
+	return atomic_long_inc_return_unchecked(&nfs_attr_generation_counter);
 }
 EXPORT_SYMBOL_GPL(nfs_inc_attr_generation_counter);
 
diff --git a/fs/nfs/internal.h b/fs/nfs/internal.h
index 74935a19e..15544e585 100644
--- a/fs/nfs/internal.h
+++ b/fs/nfs/internal.h
@@ -652,9 +652,10 @@ unsigned long nfs_block_size(unsigned long bsize, unsigned char *nrbitsp)
 static inline
 void nfs_super_set_maxbytes(struct super_block *sb, __u64 maxfilesize)
 {
-	sb->s_maxbytes = (loff_t)maxfilesize;
-	if (sb->s_maxbytes > MAX_LFS_FILESIZE || sb->s_maxbytes <= 0)
+	if (maxfilesize > MAX_LFS_FILESIZE || maxfilesize == 0)
 		sb->s_maxbytes = MAX_LFS_FILESIZE;
+	else
+		sb->s_maxbytes = (loff_t)maxfilesize;
 }
 
 /*
diff --git a/fs/nfs/mount_clnt.c b/fs/nfs/mount_clnt.c
index 09b190015..344f4c20c 100644
--- a/fs/nfs/mount_clnt.c
+++ b/fs/nfs/mount_clnt.c
@@ -303,8 +303,8 @@ static void encode_mntdirpath(struct xdr_stream *xdr, const char *pathname)
 	xdr_encode_opaque(p, pathname, pathname_len);
 }
 
-static void mnt_xdr_enc_dirpath(struct rpc_rqst *req, struct xdr_stream *xdr,
-				const char *dirpath)
+static void mnt_xdr_enc_dirpath(void *req, struct xdr_stream *xdr,
+				void *dirpath)
 {
 	encode_mntdirpath(xdr, dirpath);
 }
@@ -355,10 +355,11 @@ static int decode_fhandle(struct xdr_stream *xdr, struct mountres *res)
 	return 0;
 }
 
-static int mnt_xdr_dec_mountres(struct rpc_rqst *req,
+static int mnt_xdr_dec_mountres(void *req,
 				struct xdr_stream *xdr,
-				struct mountres *res)
+				void *_res)
 {
+	struct mountres *res = _res;
 	int status;
 
 	status = decode_status(xdr, res);
@@ -447,10 +448,11 @@ static int decode_auth_flavors(struct xdr_stream *xdr, struct mountres *res)
 	return 0;
 }
 
-static int mnt_xdr_dec_mountres3(struct rpc_rqst *req,
+static int mnt_xdr_dec_mountres3(void *req,
 				 struct xdr_stream *xdr,
-				 struct mountres *res)
+				 void *_res)
 {
+	struct mountres *res = _res;
 	int status;
 
 	status = decode_fhs_status(xdr, res);
@@ -467,8 +469,8 @@ static int mnt_xdr_dec_mountres3(struct rpc_rqst *req,
 static struct rpc_procinfo mnt_procedures[] = {
 	[MOUNTPROC_MNT] = {
 		.p_proc		= MOUNTPROC_MNT,
-		.p_encode	= (kxdreproc_t)mnt_xdr_enc_dirpath,
-		.p_decode	= (kxdrdproc_t)mnt_xdr_dec_mountres,
+		.p_encode	= mnt_xdr_enc_dirpath,
+		.p_decode	= mnt_xdr_dec_mountres,
 		.p_arglen	= MNT_enc_dirpath_sz,
 		.p_replen	= MNT_dec_mountres_sz,
 		.p_statidx	= MOUNTPROC_MNT,
@@ -476,7 +478,7 @@ static struct rpc_procinfo mnt_procedures[] = {
 	},
 	[MOUNTPROC_UMNT] = {
 		.p_proc		= MOUNTPROC_UMNT,
-		.p_encode	= (kxdreproc_t)mnt_xdr_enc_dirpath,
+		.p_encode	= mnt_xdr_enc_dirpath,
 		.p_arglen	= MNT_enc_dirpath_sz,
 		.p_statidx	= MOUNTPROC_UMNT,
 		.p_name		= "UMOUNT",
@@ -486,8 +488,8 @@ static struct rpc_procinfo mnt_procedures[] = {
 static struct rpc_procinfo mnt3_procedures[] = {
 	[MOUNTPROC3_MNT] = {
 		.p_proc		= MOUNTPROC3_MNT,
-		.p_encode	= (kxdreproc_t)mnt_xdr_enc_dirpath,
-		.p_decode	= (kxdrdproc_t)mnt_xdr_dec_mountres3,
+		.p_encode	= mnt_xdr_enc_dirpath,
+		.p_decode	= mnt_xdr_dec_mountres3,
 		.p_arglen	= MNT_enc_dirpath_sz,
 		.p_replen	= MNT_dec_mountres3_sz,
 		.p_statidx	= MOUNTPROC3_MNT,
@@ -495,7 +497,7 @@ static struct rpc_procinfo mnt3_procedures[] = {
 	},
 	[MOUNTPROC3_UMNT] = {
 		.p_proc		= MOUNTPROC3_UMNT,
-		.p_encode	= (kxdreproc_t)mnt_xdr_enc_dirpath,
+		.p_encode	= mnt_xdr_enc_dirpath,
 		.p_arglen	= MNT_enc_dirpath_sz,
 		.p_statidx	= MOUNTPROC3_UMNT,
 		.p_name		= "UMOUNT",
diff --git a/fs/nfs/nfs2xdr.c b/fs/nfs/nfs2xdr.c
index b4e03ed85..6907eb4aa 100644
--- a/fs/nfs/nfs2xdr.c
+++ b/fs/nfs/nfs2xdr.c
@@ -566,9 +566,9 @@ out_default:
  * "NFS: Network File System Protocol Specification".
  */
 
-static void nfs2_xdr_enc_fhandle(struct rpc_rqst *req,
+static void nfs2_xdr_enc_fhandle(void *req,
 				 struct xdr_stream *xdr,
-				 const struct nfs_fh *fh)
+				 void *fh)
 {
 	encode_fhandle(xdr, fh);
 }
@@ -581,25 +581,31 @@ static void nfs2_xdr_enc_fhandle(struct rpc_rqst *req,
  *		sattr attributes;
  *	};
  */
-static void nfs2_xdr_enc_sattrargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_sattrargs(void *req,
 				   struct xdr_stream *xdr,
-				   const struct nfs_sattrargs *args)
+				   void *_args)
 {
+	const struct nfs_sattrargs *args = _args;
+
 	encode_fhandle(xdr, args->fh);
 	encode_sattr(xdr, args->sattr);
 }
 
-static void nfs2_xdr_enc_diropargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_diropargs(void *req,
 				   struct xdr_stream *xdr,
-				   const struct nfs_diropargs *args)
+				   void *_args)
 {
+	const struct nfs_diropargs *args = _args;
+
 	encode_diropargs(xdr, args->fh, args->name, args->len);
 }
 
-static void nfs2_xdr_enc_readlinkargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_readlinkargs(void *req,
 				      struct xdr_stream *xdr,
-				      const struct nfs_readlinkargs *args)
+				      void *_args)
 {
+	const struct nfs_readlinkargs *args = _args;
+
 	encode_fhandle(xdr, args->fh);
 	prepare_reply_buffer(req, args->pages, args->pgbase,
 					args->pglen, NFS_readlinkres_sz);
@@ -630,10 +636,13 @@ static void encode_readargs(struct xdr_stream *xdr,
 	*p = cpu_to_be32(count);
 }
 
-static void nfs2_xdr_enc_readargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_readargs(void *_req,
 				  struct xdr_stream *xdr,
-				  const struct nfs_pgio_args *args)
+				  void *_args)
 {
+	struct rpc_rqst *req = _req;
+	const struct nfs_pgio_args *args = _args;
+
 	encode_readargs(xdr, args);
 	prepare_reply_buffer(req, args->pages, args->pgbase,
 					args->count, NFS_readres_sz);
@@ -670,9 +679,9 @@ static void encode_writeargs(struct xdr_stream *xdr,
 	xdr_write_pages(xdr, args->pages, args->pgbase, count);
 }
 
-static void nfs2_xdr_enc_writeargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_writeargs(void *req,
 				   struct xdr_stream *xdr,
-				   const struct nfs_pgio_args *args)
+				   void *args)
 {
 	encode_writeargs(xdr, args);
 	xdr->buf->flags |= XDRBUF_WRITE;
@@ -686,18 +695,22 @@ static void nfs2_xdr_enc_writeargs(struct rpc_rqst *req,
  *		sattr attributes;
  *	};
  */
-static void nfs2_xdr_enc_createargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_createargs(void *req,
 				    struct xdr_stream *xdr,
-				    const struct nfs_createargs *args)
+				    void *_args)
 {
+	const struct nfs_createargs *args = _args;
+
 	encode_diropargs(xdr, args->fh, args->name, args->len);
 	encode_sattr(xdr, args->sattr);
 }
 
-static void nfs2_xdr_enc_removeargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_removeargs(void *req,
 				    struct xdr_stream *xdr,
-				    const struct nfs_removeargs *args)
+				    void *_args)
 {
+	const struct nfs_removeargs *args = _args;
+
 	encode_diropargs(xdr, args->fh, args->name.name, args->name.len);
 }
 
@@ -709,10 +722,11 @@ static void nfs2_xdr_enc_removeargs(struct rpc_rqst *req,
  *		diropargs to;
  *	};
  */
-static void nfs2_xdr_enc_renameargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_renameargs(void *req,
 				    struct xdr_stream *xdr,
-				    const struct nfs_renameargs *args)
+				    void *_args)
 {
+	const struct nfs_renameargs *args = _args;
 	const struct qstr *old = args->old_name;
 	const struct qstr *new = args->new_name;
 
@@ -728,10 +742,12 @@ static void nfs2_xdr_enc_renameargs(struct rpc_rqst *req,
  *		diropargs to;
  *	};
  */
-static void nfs2_xdr_enc_linkargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_linkargs(void *req,
 				  struct xdr_stream *xdr,
-				  const struct nfs_linkargs *args)
+				  void *_args)
 {
+	const struct nfs_linkargs *args = _args;
+
 	encode_fhandle(xdr, args->fromfh);
 	encode_diropargs(xdr, args->tofh, args->toname, args->tolen);
 }
@@ -745,10 +761,12 @@ static void nfs2_xdr_enc_linkargs(struct rpc_rqst *req,
  *		sattr attributes;
  *	};
  */
-static void nfs2_xdr_enc_symlinkargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_symlinkargs(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs_symlinkargs *args)
+				     void *_args)
 {
+	const struct nfs_symlinkargs *args = _args;
+
 	encode_diropargs(xdr, args->fromfh, args->fromname, args->fromlen);
 	encode_path(xdr, args->pages, args->pathlen);
 	encode_sattr(xdr, args->sattr);
@@ -775,10 +793,12 @@ static void encode_readdirargs(struct xdr_stream *xdr,
 	*p = cpu_to_be32(args->count);
 }
 
-static void nfs2_xdr_enc_readdirargs(struct rpc_rqst *req,
+static void nfs2_xdr_enc_readdirargs(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs_readdirargs *args)
+				     void *_args)
 {
+	const struct nfs_readdirargs *args = _args;
+
 	encode_readdirargs(xdr, args);
 	prepare_reply_buffer(req, args->pages, 0,
 					args->count, NFS_readdirres_sz);
@@ -791,7 +811,7 @@ static void nfs2_xdr_enc_readdirargs(struct rpc_rqst *req,
  * "NFS: Network File System Protocol Specification".
  */
 
-static int nfs2_xdr_dec_stat(struct rpc_rqst *req, struct xdr_stream *xdr,
+static int nfs2_xdr_dec_stat(void *req, struct xdr_stream *xdr,
 			     void *__unused)
 {
 	enum nfs_stat status;
@@ -808,14 +828,14 @@ out_default:
 	return nfs_stat_to_errno(status);
 }
 
-static int nfs2_xdr_dec_attrstat(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 struct nfs_fattr *result)
+static int nfs2_xdr_dec_attrstat(void *req, struct xdr_stream *xdr,
+				 void *result)
 {
 	return decode_attrstat(xdr, result, NULL);
 }
 
-static int nfs2_xdr_dec_diropres(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 struct nfs_diropok *result)
+static int nfs2_xdr_dec_diropres(void *req, struct xdr_stream *xdr,
+				 void *result)
 {
 	return decode_diropres(xdr, result);
 }
@@ -830,7 +850,7 @@ static int nfs2_xdr_dec_diropres(struct rpc_rqst *req, struct xdr_stream *xdr,
  *		void;
  *	};
  */
-static int nfs2_xdr_dec_readlinkres(struct rpc_rqst *req,
+static int nfs2_xdr_dec_readlinkres(void *req,
 				    struct xdr_stream *xdr, void *__unused)
 {
 	enum nfs_stat status;
@@ -859,9 +879,10 @@ out_default:
  *		void;
  *	};
  */
-static int nfs2_xdr_dec_readres(struct rpc_rqst *req, struct xdr_stream *xdr,
-				struct nfs_pgio_res *result)
+static int nfs2_xdr_dec_readres(void *req, struct xdr_stream *xdr,
+				void *_result)
 {
+	struct nfs_pgio_res *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -881,9 +902,11 @@ out_default:
 	return nfs_stat_to_errno(status);
 }
 
-static int nfs2_xdr_dec_writeres(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 struct nfs_pgio_res *result)
+static int nfs2_xdr_dec_writeres(void *req, struct xdr_stream *xdr,
+				 void *_result)
 {
+	struct nfs_pgio_res *result = _result;
+
 	/* All NFSv2 writes are "file sync" writes */
 	result->verf->committed = NFS_FILE_SYNC;
 	return decode_attrstat(xdr, result->fattr, &result->op_status);
@@ -981,7 +1004,7 @@ static int decode_readdirok(struct xdr_stream *xdr)
 	return xdr_read_pages(xdr, xdr->buf->page_len);
 }
 
-static int nfs2_xdr_dec_readdirres(struct rpc_rqst *req,
+static int nfs2_xdr_dec_readdirres(void *req,
 				   struct xdr_stream *xdr, void *__unused)
 {
 	enum nfs_stat status;
@@ -1033,8 +1056,8 @@ out_overflow:
 	return -EIO;
 }
 
-static int nfs2_xdr_dec_statfsres(struct rpc_rqst *req, struct xdr_stream *xdr,
-				  struct nfs2_fsstat *result)
+static int nfs2_xdr_dec_statfsres(void *req, struct xdr_stream *xdr,
+				  void *result)
 {
 	enum nfs_stat status;
 	int error;
@@ -1118,8 +1141,8 @@ static int nfs_stat_to_errno(enum nfs_stat status)
 #define PROC(proc, argtype, restype, timer)				\
 [NFSPROC_##proc] = {							\
 	.p_proc	    =  NFSPROC_##proc,					\
-	.p_encode   =  (kxdreproc_t)nfs2_xdr_enc_##argtype,		\
-	.p_decode   =  (kxdrdproc_t)nfs2_xdr_dec_##restype,		\
+	.p_encode   =  nfs2_xdr_enc_##argtype,				\
+	.p_decode   =  nfs2_xdr_dec_##restype,				\
 	.p_arglen   =  NFS_##argtype##_sz,				\
 	.p_replen   =  NFS_##restype##_sz,				\
 	.p_timer    =  timer,						\
diff --git a/fs/nfs/nfs3xdr.c b/fs/nfs/nfs3xdr.c
index 267126d32..19c97b809 100644
--- a/fs/nfs/nfs3xdr.c
+++ b/fs/nfs/nfs3xdr.c
@@ -844,9 +844,9 @@ static void encode_diropargs3(struct xdr_stream *xdr, const struct nfs_fh *fh,
  *		nfs_fh3  object;
  *	};
  */
-static void nfs3_xdr_enc_getattr3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_getattr3args(void *req,
 				      struct xdr_stream *xdr,
-				      const struct nfs_fh *fh)
+				      void *fh)
 {
 	encode_nfs_fh3(xdr, fh);
 }
@@ -882,10 +882,12 @@ static void encode_sattrguard3(struct xdr_stream *xdr,
 	}
 }
 
-static void nfs3_xdr_enc_setattr3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_setattr3args(void *req,
 				      struct xdr_stream *xdr,
-				      const struct nfs3_sattrargs *args)
+				      void *_args)
 {
+	const struct nfs3_sattrargs *args = _args;
+
 	encode_nfs_fh3(xdr, args->fh);
 	encode_sattr3(xdr, args->sattr);
 	encode_sattrguard3(xdr, args);
@@ -898,10 +900,12 @@ static void nfs3_xdr_enc_setattr3args(struct rpc_rqst *req,
  *		diropargs3  what;
  *	};
  */
-static void nfs3_xdr_enc_lookup3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_lookup3args(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs3_diropargs *args)
+				     void *_args)
 {
+	const struct nfs3_diropargs *args = _args;
+
 	encode_diropargs3(xdr, args->fh, args->name, args->len);
 }
 
@@ -920,9 +924,9 @@ static void encode_access3args(struct xdr_stream *xdr,
 	encode_uint32(xdr, args->access);
 }
 
-static void nfs3_xdr_enc_access3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_access3args(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs3_accessargs *args)
+				     void *args)
 {
 	encode_access3args(xdr, args);
 }
@@ -934,10 +938,11 @@ static void nfs3_xdr_enc_access3args(struct rpc_rqst *req,
  *		nfs_fh3	symlink;
  *	};
  */
-static void nfs3_xdr_enc_readlink3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_readlink3args(void *req,
 				       struct xdr_stream *xdr,
-				       const struct nfs3_readlinkargs *args)
+				       void *_args)
 {
+	const struct nfs3_readlinkargs *args = _args;
 	encode_nfs_fh3(xdr, args->fh);
 	prepare_reply_buffer(req, args->pages, args->pgbase,
 					args->pglen, NFS3_readlinkres_sz);
@@ -964,10 +969,12 @@ static void encode_read3args(struct xdr_stream *xdr,
 	*p = cpu_to_be32(args->count);
 }
 
-static void nfs3_xdr_enc_read3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_read3args(void *_req,
 				   struct xdr_stream *xdr,
-				   const struct nfs_pgio_args *args)
+				   void *_args)
 {
+	struct rpc_rqst *req = _req;
+	const struct nfs_pgio_args *args = _args;
 	encode_read3args(xdr, args);
 	prepare_reply_buffer(req, args->pages, args->pgbase,
 					args->count, NFS3_readres_sz);
@@ -1006,9 +1013,9 @@ static void encode_write3args(struct xdr_stream *xdr,
 	xdr_write_pages(xdr, args->pages, args->pgbase, args->count);
 }
 
-static void nfs3_xdr_enc_write3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_write3args(void *req,
 				    struct xdr_stream *xdr,
-				    const struct nfs_pgio_args *args)
+				    void *args)
 {
 	encode_write3args(xdr, args);
 	xdr->buf->flags |= XDRBUF_WRITE;
@@ -1053,10 +1060,12 @@ static void encode_createhow3(struct xdr_stream *xdr,
 	}
 }
 
-static void nfs3_xdr_enc_create3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_create3args(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs3_createargs *args)
+				     void *_args)
 {
+	const struct nfs3_createargs *args = _args;
+
 	encode_diropargs3(xdr, args->fh, args->name, args->len);
 	encode_createhow3(xdr, args);
 }
@@ -1069,10 +1078,12 @@ static void nfs3_xdr_enc_create3args(struct rpc_rqst *req,
  *		sattr3		attributes;
  *	};
  */
-static void nfs3_xdr_enc_mkdir3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_mkdir3args(void *req,
 				    struct xdr_stream *xdr,
-				    const struct nfs3_mkdirargs *args)
+				    void *_args)
 {
+	const struct nfs3_mkdirargs *args = _args;
+
 	encode_diropargs3(xdr, args->fh, args->name, args->len);
 	encode_sattr3(xdr, args->sattr);
 }
@@ -1097,10 +1108,12 @@ static void encode_symlinkdata3(struct xdr_stream *xdr,
 	encode_nfspath3(xdr, args->pages, args->pathlen);
 }
 
-static void nfs3_xdr_enc_symlink3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_symlink3args(void *req,
 				      struct xdr_stream *xdr,
-				      const struct nfs3_symlinkargs *args)
+				      void *_args)
 {
+	const struct nfs3_symlinkargs *args = _args;
+
 	encode_diropargs3(xdr, args->fromfh, args->fromname, args->fromlen);
 	encode_symlinkdata3(xdr, args);
 	xdr->buf->flags |= XDRBUF_WRITE;
@@ -1158,10 +1171,12 @@ static void encode_mknoddata3(struct xdr_stream *xdr,
 	}
 }
 
-static void nfs3_xdr_enc_mknod3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_mknod3args(void *req,
 				    struct xdr_stream *xdr,
-				    const struct nfs3_mknodargs *args)
+				    void *_args)
 {
+	const struct nfs3_mknodargs *args = _args;
+
 	encode_diropargs3(xdr, args->fh, args->name, args->len);
 	encode_mknoddata3(xdr, args);
 }
@@ -1173,10 +1188,12 @@ static void nfs3_xdr_enc_mknod3args(struct rpc_rqst *req,
  *		diropargs3  object;
  *	};
  */
-static void nfs3_xdr_enc_remove3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_remove3args(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs_removeargs *args)
+				     void *_args)
 {
+	const struct nfs_removeargs *args = _args;
+
 	encode_diropargs3(xdr, args->fh, args->name.name, args->name.len);
 }
 
@@ -1188,10 +1205,11 @@ static void nfs3_xdr_enc_remove3args(struct rpc_rqst *req,
  *		diropargs3	to;
  *	};
  */
-static void nfs3_xdr_enc_rename3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_rename3args(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs_renameargs *args)
+				     void *_args)
 {
+	const struct nfs_renameargs *args = _args;
 	const struct qstr *old = args->old_name;
 	const struct qstr *new = args->new_name;
 
@@ -1207,10 +1225,12 @@ static void nfs3_xdr_enc_rename3args(struct rpc_rqst *req,
  *		diropargs3	link;
  *	};
  */
-static void nfs3_xdr_enc_link3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_link3args(void *req,
 				   struct xdr_stream *xdr,
-				   const struct nfs3_linkargs *args)
+				   void *_args)
 {
+	const struct nfs3_linkargs *args = _args;
+
 	encode_nfs_fh3(xdr, args->fromfh);
 	encode_diropargs3(xdr, args->tofh, args->toname, args->tolen);
 }
@@ -1238,10 +1258,12 @@ static void encode_readdir3args(struct xdr_stream *xdr,
 	*p = cpu_to_be32(args->count);
 }
 
-static void nfs3_xdr_enc_readdir3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_readdir3args(void *req,
 				      struct xdr_stream *xdr,
-				      const struct nfs3_readdirargs *args)
+				      void *_args)
 {
+	const struct nfs3_readdirargs *args = _args;
+
 	encode_readdir3args(xdr, args);
 	prepare_reply_buffer(req, args->pages, 0,
 				args->count, NFS3_readdirres_sz);
@@ -1278,10 +1300,12 @@ static void encode_readdirplus3args(struct xdr_stream *xdr,
 	*p = cpu_to_be32(args->count);
 }
 
-static void nfs3_xdr_enc_readdirplus3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_readdirplus3args(void *req,
 					  struct xdr_stream *xdr,
-					  const struct nfs3_readdirargs *args)
+					  void *_args)
 {
+	const struct nfs3_readdirargs *args = _args;
+
 	encode_readdirplus3args(xdr, args);
 	prepare_reply_buffer(req, args->pages, 0,
 				args->count, NFS3_readdirres_sz);
@@ -1308,19 +1332,21 @@ static void encode_commit3args(struct xdr_stream *xdr,
 	*p = cpu_to_be32(args->count);
 }
 
-static void nfs3_xdr_enc_commit3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_commit3args(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs_commitargs *args)
+				     void *args)
 {
 	encode_commit3args(xdr, args);
 }
 
 #ifdef CONFIG_NFS_V3_ACL
 
-static void nfs3_xdr_enc_getacl3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_getacl3args(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs3_getaclargs *args)
+				     void *_args)
 {
+	const struct nfs3_getaclargs *args = _args;
+
 	encode_nfs_fh3(xdr, args->fh);
 	encode_uint32(xdr, args->mask);
 	if (args->mask & (NFS_ACL | NFS_DFACL))
@@ -1329,10 +1355,12 @@ static void nfs3_xdr_enc_getacl3args(struct rpc_rqst *req,
 					ACL3_getaclres_sz);
 }
 
-static void nfs3_xdr_enc_setacl3args(struct rpc_rqst *req,
+static void nfs3_xdr_enc_setacl3args(void *_req,
 				     struct xdr_stream *xdr,
-				     const struct nfs3_setaclargs *args)
+				     void *_args)
 {
+	struct rpc_rqst *req = _req;
+	const struct nfs3_setaclargs *args = _args;
 	unsigned int base;
 	int error;
 
@@ -1380,9 +1408,9 @@ static void nfs3_xdr_enc_setacl3args(struct rpc_rqst *req,
  *		void;
  *	};
  */
-static int nfs3_xdr_dec_getattr3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_getattr3res(void *req,
 				    struct xdr_stream *xdr,
-				    struct nfs_fattr *result)
+				    void *result)
 {
 	enum nfs_stat status;
 	int error;
@@ -1417,9 +1445,9 @@ out_default:
  *		SETATTR3resfail resfail;
  *	};
  */
-static int nfs3_xdr_dec_setattr3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_setattr3res(void *req,
 				    struct xdr_stream *xdr,
-				    struct nfs_fattr *result)
+				    void *result)
 {
 	enum nfs_stat status;
 	int error;
@@ -1458,10 +1486,11 @@ out_status:
  *		LOOKUP3resfail	resfail;
  *	};
  */
-static int nfs3_xdr_dec_lookup3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_lookup3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs3_diropres *result)
+				   void *_result)
 {
+	struct nfs3_diropres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -1505,10 +1534,11 @@ out_default:
  *		ACCESS3resfail	resfail;
  *	};
  */
-static int nfs3_xdr_dec_access3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_access3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs3_accessres *result)
+				   void *_result)
 {
+	struct nfs3_accessres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -1546,9 +1576,9 @@ out_default:
  *		READLINK3resfail resfail;
  *	};
  */
-static int nfs3_xdr_dec_readlink3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_readlink3res(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs_fattr *result)
+				     void *result)
 {
 	enum nfs_stat status;
 	int error;
@@ -1625,9 +1655,10 @@ out_overflow:
 	return -EIO;
 }
 
-static int nfs3_xdr_dec_read3res(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 struct nfs_pgio_res *result)
+static int nfs3_xdr_dec_read3res(void *req, struct xdr_stream *xdr,
+				 void *_result)
 {
+	struct nfs_pgio_res *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -1698,9 +1729,10 @@ out_eio:
 	return -EIO;
 }
 
-static int nfs3_xdr_dec_write3res(struct rpc_rqst *req, struct xdr_stream *xdr,
-				  struct nfs_pgio_res *result)
+static int nfs3_xdr_dec_write3res(void *req, struct xdr_stream *xdr,
+				  void *_result)
 {
+	struct nfs_pgio_res *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -1762,10 +1794,11 @@ out:
 	return error;
 }
 
-static int nfs3_xdr_dec_create3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_create3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs3_diropres *result)
+				   void *_result)
 {
+	struct nfs3_diropres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -1802,10 +1835,11 @@ out_default:
  *		REMOVE3resfail resfail;
  *	};
  */
-static int nfs3_xdr_dec_remove3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_remove3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs_removeres *result)
+				   void *_result)
 {
+	struct nfs_removeres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -1843,10 +1877,11 @@ out_status:
  *		RENAME3resfail resfail;
  *	};
  */
-static int nfs3_xdr_dec_rename3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_rename3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs_renameres *result)
+				   void *_result)
 {
+	struct nfs_renameres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -1887,9 +1922,10 @@ out_status:
  *		LINK3resfail	resfail;
  *	};
  */
-static int nfs3_xdr_dec_link3res(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 struct nfs3_linkres *result)
+static int nfs3_xdr_dec_link3res(void *req, struct xdr_stream *xdr,
+				 void *_result)
 {
+	struct nfs3_linkres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -2070,10 +2106,11 @@ out:
 	return error;
 }
 
-static int nfs3_xdr_dec_readdir3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_readdir3res(void *req,
 				    struct xdr_stream *xdr,
-				    struct nfs3_readdirres *result)
+				    void *_result)
 {
+	struct nfs3_readdirres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -2138,10 +2175,11 @@ out_overflow:
 	return -EIO;
 }
 
-static int nfs3_xdr_dec_fsstat3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_fsstat3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs_fsstat *result)
+				   void *_result)
 {
+	struct nfs_fsstat *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -2214,10 +2252,11 @@ out_overflow:
 	return -EIO;
 }
 
-static int nfs3_xdr_dec_fsinfo3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_fsinfo3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs_fsinfo *result)
+				   void *_result)
 {
+	struct nfs_fsinfo *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -2277,10 +2316,11 @@ out_overflow:
 	return -EIO;
 }
 
-static int nfs3_xdr_dec_pathconf3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_pathconf3res(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs_pathconf *result)
+				     void *_result)
 {
+	struct nfs_pathconf *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -2318,10 +2358,11 @@ out_status:
  *		COMMIT3resfail	resfail;
  *	};
  */
-static int nfs3_xdr_dec_commit3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_commit3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs_commitres *result)
+				   void *_result)
 {
+	struct nfs_commitres *result = _result;
 	enum nfs_stat status;
 	int error;
 
@@ -2387,9 +2428,9 @@ out:
 	return error;
 }
 
-static int nfs3_xdr_dec_getacl3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_getacl3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs3_getaclres *result)
+				   void *result)
 {
 	enum nfs_stat status;
 	int error;
@@ -2406,9 +2447,9 @@ out_default:
 	return nfs3_stat_to_errno(status);
 }
 
-static int nfs3_xdr_dec_setacl3res(struct rpc_rqst *req,
+static int nfs3_xdr_dec_setacl3res(void *req,
 				   struct xdr_stream *xdr,
-				   struct nfs_fattr *result)
+				   void *result)
 {
 	enum nfs_stat status;
 	int error;
@@ -2495,8 +2536,8 @@ static int nfs3_stat_to_errno(enum nfs_stat status)
 #define PROC(proc, argtype, restype, timer)				\
 [NFS3PROC_##proc] = {							\
 	.p_proc      = NFS3PROC_##proc,					\
-	.p_encode    = (kxdreproc_t)nfs3_xdr_enc_##argtype##3args,	\
-	.p_decode    = (kxdrdproc_t)nfs3_xdr_dec_##restype##3res,	\
+	.p_encode    = nfs3_xdr_enc_##argtype##3args,			\
+	.p_decode    = nfs3_xdr_dec_##restype##3res,			\
 	.p_arglen    = NFS3_##argtype##args_sz,				\
 	.p_replen    = NFS3_##restype##res_sz,				\
 	.p_timer     = timer,						\
@@ -2538,8 +2579,8 @@ const struct rpc_version nfs_version3 = {
 static struct rpc_procinfo	nfs3_acl_procedures[] = {
 	[ACLPROC3_GETACL] = {
 		.p_proc = ACLPROC3_GETACL,
-		.p_encode = (kxdreproc_t)nfs3_xdr_enc_getacl3args,
-		.p_decode = (kxdrdproc_t)nfs3_xdr_dec_getacl3res,
+		.p_encode = nfs3_xdr_enc_getacl3args,
+		.p_decode = nfs3_xdr_dec_getacl3res,
 		.p_arglen = ACL3_getaclargs_sz,
 		.p_replen = ACL3_getaclres_sz,
 		.p_timer = 1,
@@ -2547,8 +2588,8 @@ static struct rpc_procinfo	nfs3_acl_procedures[] = {
 	},
 	[ACLPROC3_SETACL] = {
 		.p_proc = ACLPROC3_SETACL,
-		.p_encode = (kxdreproc_t)nfs3_xdr_enc_setacl3args,
-		.p_decode = (kxdrdproc_t)nfs3_xdr_dec_setacl3res,
+		.p_encode = nfs3_xdr_enc_setacl3args,
+		.p_decode = nfs3_xdr_dec_setacl3res,
 		.p_arglen = ACL3_setaclargs_sz,
 		.p_replen = ACL3_setaclres_sz,
 		.p_timer = 0,
diff --git a/fs/nfs/nfs42xdr.c b/fs/nfs/nfs42xdr.c
index 8b2605882..b31170fee 100644
--- a/fs/nfs/nfs42xdr.c
+++ b/fs/nfs/nfs42xdr.c
@@ -205,10 +205,12 @@ static void encode_clone(struct xdr_stream *xdr,
 /*
  * Encode ALLOCATE request
  */
-static void nfs4_xdr_enc_allocate(struct rpc_rqst *req,
+static void nfs4_xdr_enc_allocate(void *_req,
 				  struct xdr_stream *xdr,
-				  struct nfs42_falloc_args *args)
+				  void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs42_falloc_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -224,10 +226,12 @@ static void nfs4_xdr_enc_allocate(struct rpc_rqst *req,
 /*
  * Encode COPY request
  */
-static void nfs4_xdr_enc_copy(struct rpc_rqst *req,
+static void nfs4_xdr_enc_copy(void *_req,
 			      struct xdr_stream *xdr,
-			      struct nfs42_copy_args *args)
+			      void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs42_copy_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -244,10 +248,12 @@ static void nfs4_xdr_enc_copy(struct rpc_rqst *req,
 /*
  * Encode DEALLOCATE request
  */
-static void nfs4_xdr_enc_deallocate(struct rpc_rqst *req,
+static void nfs4_xdr_enc_deallocate(void *_req,
 				    struct xdr_stream *xdr,
-				    struct nfs42_falloc_args *args)
+				    void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs42_falloc_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -263,10 +269,12 @@ static void nfs4_xdr_enc_deallocate(struct rpc_rqst *req,
 /*
  * Encode SEEK request
  */
-static void nfs4_xdr_enc_seek(struct rpc_rqst *req,
+static void nfs4_xdr_enc_seek(void *_req,
 			      struct xdr_stream *xdr,
-			      struct nfs42_seek_args *args)
+			      void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs42_seek_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -281,10 +289,12 @@ static void nfs4_xdr_enc_seek(struct rpc_rqst *req,
 /*
  * Encode LAYOUTSTATS request
  */
-static void nfs4_xdr_enc_layoutstats(struct rpc_rqst *req,
+static void nfs4_xdr_enc_layoutstats(void *_req,
 				     struct xdr_stream *xdr,
-				     struct nfs42_layoutstat_args *args)
+				     void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs42_layoutstat_args *args = _args;
 	int i;
 
 	struct compound_hdr hdr = {
@@ -303,10 +313,12 @@ static void nfs4_xdr_enc_layoutstats(struct rpc_rqst *req,
 /*
  * Encode CLONE request
  */
-static void nfs4_xdr_enc_clone(struct rpc_rqst *req,
+static void nfs4_xdr_enc_clone(void *_req,
 			       struct xdr_stream *xdr,
-			       struct nfs42_clone_args *args)
+			       void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs42_clone_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -430,10 +442,12 @@ static int decode_clone(struct xdr_stream *xdr)
 /*
  * Decode ALLOCATE request
  */
-static int nfs4_xdr_dec_allocate(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_allocate(void *_rqstp,
 				 struct xdr_stream *xdr,
-				 struct nfs42_falloc_res *res)
+				 void *_res)
 {
+	struct rpc_rqst *rqstp = _rqstp;
+	struct nfs42_falloc_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -457,10 +471,12 @@ out:
 /*
  * Decode COPY response
  */
-static int nfs4_xdr_dec_copy(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_copy(void *_rqstp,
 			     struct xdr_stream *xdr,
-			     struct nfs42_copy_res *res)
+			     void *_res)
 {
+	struct rpc_rqst *rqstp = _rqstp;
+	struct nfs42_copy_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -487,10 +503,12 @@ out:
 /*
  * Decode DEALLOCATE request
  */
-static int nfs4_xdr_dec_deallocate(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_deallocate(void *_rqstp,
 				   struct xdr_stream *xdr,
-				   struct nfs42_falloc_res *res)
+				   void *_res)
 {
+	struct rpc_rqst *rqstp = _rqstp;
+	struct nfs42_falloc_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -514,10 +532,12 @@ out:
 /*
  * Decode SEEK request
  */
-static int nfs4_xdr_dec_seek(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_seek(void *_rqstp,
 			     struct xdr_stream *xdr,
-			     struct nfs42_seek_res *res)
+			     void *_res)
 {
+	struct rpc_rqst *rqstp = _rqstp;
+	struct nfs42_seek_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -538,10 +558,12 @@ out:
 /*
  * Decode LAYOUTSTATS request
  */
-static int nfs4_xdr_dec_layoutstats(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_layoutstats(void *_rqstp,
 				    struct xdr_stream *xdr,
-				    struct nfs42_layoutstat_res *res)
+				    void *_res)
 {
+	struct rpc_rqst *rqstp = _rqstp;
+	struct nfs42_layoutstat_res *res = _res;
 	struct compound_hdr hdr;
 	int status, i;
 
@@ -568,10 +590,12 @@ out:
 /*
  * Decode CLONE request
  */
-static int nfs4_xdr_dec_clone(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_clone(void *_rqstp,
 			      struct xdr_stream *xdr,
-			      struct nfs42_clone_res *res)
+			      void *_res)
 {
+	struct rpc_rqst *rqstp = _rqstp;
+	struct nfs42_clone_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
diff --git a/fs/nfs/nfs4xdr.c b/fs/nfs/nfs4xdr.c
index 7bd3a5c09..0c408e8f8 100644
--- a/fs/nfs/nfs4xdr.c
+++ b/fs/nfs/nfs4xdr.c
@@ -2081,9 +2081,10 @@ static u32 nfs4_xdr_minorversion(const struct nfs4_sequence_args *args)
 /*
  * Encode an ACCESS request
  */
-static void nfs4_xdr_enc_access(struct rpc_rqst *req, struct xdr_stream *xdr,
-				const struct nfs4_accessargs *args)
+static void nfs4_xdr_enc_access(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	const struct nfs4_accessargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2099,9 +2100,10 @@ static void nfs4_xdr_enc_access(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode LOOKUP request
  */
-static void nfs4_xdr_enc_lookup(struct rpc_rqst *req, struct xdr_stream *xdr,
-				const struct nfs4_lookup_arg *args)
+static void nfs4_xdr_enc_lookup(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	const struct nfs4_lookup_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2118,10 +2120,11 @@ static void nfs4_xdr_enc_lookup(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode LOOKUP_ROOT request
  */
-static void nfs4_xdr_enc_lookup_root(struct rpc_rqst *req,
+static void nfs4_xdr_enc_lookup_root(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs4_lookup_root_arg *args)
+				     void *_args)
 {
+	const struct nfs4_lookup_root_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2137,9 +2140,10 @@ static void nfs4_xdr_enc_lookup_root(struct rpc_rqst *req,
 /*
  * Encode REMOVE request
  */
-static void nfs4_xdr_enc_remove(struct rpc_rqst *req, struct xdr_stream *xdr,
-				const struct nfs_removeargs *args)
+static void nfs4_xdr_enc_remove(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	const struct nfs_removeargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2154,9 +2158,10 @@ static void nfs4_xdr_enc_remove(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode RENAME request
  */
-static void nfs4_xdr_enc_rename(struct rpc_rqst *req, struct xdr_stream *xdr,
-				const struct nfs_renameargs *args)
+static void nfs4_xdr_enc_rename(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	const struct nfs_renameargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2173,9 +2178,10 @@ static void nfs4_xdr_enc_rename(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode LINK request
  */
-static void nfs4_xdr_enc_link(struct rpc_rqst *req, struct xdr_stream *xdr,
-			     const struct nfs4_link_arg *args)
+static void nfs4_xdr_enc_link(void *req, struct xdr_stream *xdr,
+			     void *_args)
 {
+	const struct nfs4_link_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2194,9 +2200,10 @@ static void nfs4_xdr_enc_link(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode CREATE request
  */
-static void nfs4_xdr_enc_create(struct rpc_rqst *req, struct xdr_stream *xdr,
-				const struct nfs4_create_arg *args)
+static void nfs4_xdr_enc_create(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	const struct nfs4_create_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2213,8 +2220,8 @@ static void nfs4_xdr_enc_create(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode SYMLINK request
  */
-static void nfs4_xdr_enc_symlink(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 const struct nfs4_create_arg *args)
+static void nfs4_xdr_enc_symlink(void *req, struct xdr_stream *xdr,
+				 void *args)
 {
 	nfs4_xdr_enc_create(req, xdr, args);
 }
@@ -2222,9 +2229,10 @@ static void nfs4_xdr_enc_symlink(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode GETATTR request
  */
-static void nfs4_xdr_enc_getattr(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 const struct nfs4_getattr_arg *args)
+static void nfs4_xdr_enc_getattr(void *req, struct xdr_stream *xdr,
+				 void *_args)
 {
+	const struct nfs4_getattr_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2239,9 +2247,10 @@ static void nfs4_xdr_enc_getattr(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode a CLOSE request
  */
-static void nfs4_xdr_enc_close(struct rpc_rqst *req, struct xdr_stream *xdr,
-			       struct nfs_closeargs *args)
+static void nfs4_xdr_enc_close(void *req, struct xdr_stream *xdr,
+			       void *_args)
 {
+	struct nfs_closeargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2257,9 +2266,10 @@ static void nfs4_xdr_enc_close(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode an OPEN request
  */
-static void nfs4_xdr_enc_open(struct rpc_rqst *req, struct xdr_stream *xdr,
-			      struct nfs_openargs *args)
+static void nfs4_xdr_enc_open(void *req, struct xdr_stream *xdr,
+			      void *_args)
 {
+	struct nfs_openargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2278,10 +2288,11 @@ static void nfs4_xdr_enc_open(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode an OPEN_CONFIRM request
  */
-static void nfs4_xdr_enc_open_confirm(struct rpc_rqst *req,
+static void nfs4_xdr_enc_open_confirm(void *req,
 				      struct xdr_stream *xdr,
-				      struct nfs_open_confirmargs *args)
+				      void *_args)
 {
+	struct nfs_open_confirmargs *args = _args;
 	struct compound_hdr hdr = {
 		.nops   = 0,
 	};
@@ -2295,10 +2306,11 @@ static void nfs4_xdr_enc_open_confirm(struct rpc_rqst *req,
 /*
  * Encode an OPEN request with no attributes.
  */
-static void nfs4_xdr_enc_open_noattr(struct rpc_rqst *req,
+static void nfs4_xdr_enc_open_noattr(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs_openargs *args)
+				     void *_args)
 {
+	struct nfs_openargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2316,10 +2328,11 @@ static void nfs4_xdr_enc_open_noattr(struct rpc_rqst *req,
 /*
  * Encode an OPEN_DOWNGRADE request
  */
-static void nfs4_xdr_enc_open_downgrade(struct rpc_rqst *req,
+static void nfs4_xdr_enc_open_downgrade(void *req,
 					struct xdr_stream *xdr,
-					struct nfs_closeargs *args)
+					void *_args)
 {
+	struct nfs_closeargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2335,9 +2348,10 @@ static void nfs4_xdr_enc_open_downgrade(struct rpc_rqst *req,
 /*
  * Encode a LOCK request
  */
-static void nfs4_xdr_enc_lock(struct rpc_rqst *req, struct xdr_stream *xdr,
-			      struct nfs_lock_args *args)
+static void nfs4_xdr_enc_lock(void *req, struct xdr_stream *xdr,
+			      void *_args)
 {
+	struct nfs_lock_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2352,9 +2366,10 @@ static void nfs4_xdr_enc_lock(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode a LOCKT request
  */
-static void nfs4_xdr_enc_lockt(struct rpc_rqst *req, struct xdr_stream *xdr,
-			       struct nfs_lockt_args *args)
+static void nfs4_xdr_enc_lockt(void *req, struct xdr_stream *xdr,
+			       void *_args)
 {
+	struct nfs_lockt_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2369,9 +2384,10 @@ static void nfs4_xdr_enc_lockt(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode a LOCKU request
  */
-static void nfs4_xdr_enc_locku(struct rpc_rqst *req, struct xdr_stream *xdr,
-			       struct nfs_locku_args *args)
+static void nfs4_xdr_enc_locku(void *req, struct xdr_stream *xdr,
+			       void *_args)
 {
+	struct nfs_locku_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2383,10 +2399,11 @@ static void nfs4_xdr_enc_locku(struct rpc_rqst *req, struct xdr_stream *xdr,
 	encode_nops(&hdr);
 }
 
-static void nfs4_xdr_enc_release_lockowner(struct rpc_rqst *req,
+static void nfs4_xdr_enc_release_lockowner(void *req,
 					   struct xdr_stream *xdr,
-					struct nfs_release_lockowner_args *args)
+					void *_args)
 {
+	struct nfs_release_lockowner_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = 0,
 	};
@@ -2399,9 +2416,11 @@ static void nfs4_xdr_enc_release_lockowner(struct rpc_rqst *req,
 /*
  * Encode a READLINK request
  */
-static void nfs4_xdr_enc_readlink(struct rpc_rqst *req, struct xdr_stream *xdr,
-				  const struct nfs4_readlink *args)
+static void nfs4_xdr_enc_readlink(void *_req, struct xdr_stream *xdr,
+				  void *_args)
 {
+	struct rpc_rqst *req = _req;
+	const struct nfs4_readlink *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2419,9 +2438,11 @@ static void nfs4_xdr_enc_readlink(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode a READDIR request
  */
-static void nfs4_xdr_enc_readdir(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 const struct nfs4_readdir_arg *args)
+static void nfs4_xdr_enc_readdir(void *_req, struct xdr_stream *xdr,
+				 void *_args)
 {
+	struct rpc_rqst *req = _req;
+	const struct nfs4_readdir_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2442,9 +2463,11 @@ static void nfs4_xdr_enc_readdir(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode a READ request
  */
-static void nfs4_xdr_enc_read(struct rpc_rqst *req, struct xdr_stream *xdr,
-			      struct nfs_pgio_args *args)
+static void nfs4_xdr_enc_read(void *_req, struct xdr_stream *xdr,
+			      void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs_pgio_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2463,9 +2486,11 @@ static void nfs4_xdr_enc_read(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode an SETATTR request
  */
-static void nfs4_xdr_enc_setattr(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 struct nfs_setattrargs *args)
+static void nfs4_xdr_enc_setattr(void *_req, struct xdr_stream *xdr,
+				 void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs_setattrargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2481,9 +2506,11 @@ static void nfs4_xdr_enc_setattr(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode a GETACL request
  */
-static void nfs4_xdr_enc_getacl(struct rpc_rqst *req, struct xdr_stream *xdr,
-				struct nfs_getaclargs *args)
+static void nfs4_xdr_enc_getacl(void *_req, struct xdr_stream *xdr,
+				void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs_getaclargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2504,9 +2531,11 @@ static void nfs4_xdr_enc_getacl(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Encode a WRITE request
  */
-static void nfs4_xdr_enc_write(struct rpc_rqst *req, struct xdr_stream *xdr,
-			       struct nfs_pgio_args *args)
+static void nfs4_xdr_enc_write(void *_req, struct xdr_stream *xdr,
+			       void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs_pgio_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2524,9 +2553,10 @@ static void nfs4_xdr_enc_write(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  *  a COMMIT request
  */
-static void nfs4_xdr_enc_commit(struct rpc_rqst *req, struct xdr_stream *xdr,
-				struct nfs_commitargs *args)
+static void nfs4_xdr_enc_commit(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	struct nfs_commitargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2541,9 +2571,10 @@ static void nfs4_xdr_enc_commit(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * FSINFO request
  */
-static void nfs4_xdr_enc_fsinfo(struct rpc_rqst *req, struct xdr_stream *xdr,
-				struct nfs4_fsinfo_arg *args)
+static void nfs4_xdr_enc_fsinfo(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	struct nfs4_fsinfo_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2558,9 +2589,10 @@ static void nfs4_xdr_enc_fsinfo(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * a PATHCONF request
  */
-static void nfs4_xdr_enc_pathconf(struct rpc_rqst *req, struct xdr_stream *xdr,
-				  const struct nfs4_pathconf_arg *args)
+static void nfs4_xdr_enc_pathconf(void *req, struct xdr_stream *xdr,
+				  void *_args)
 {
+	const struct nfs4_pathconf_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2576,9 +2608,10 @@ static void nfs4_xdr_enc_pathconf(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * a STATFS request
  */
-static void nfs4_xdr_enc_statfs(struct rpc_rqst *req, struct xdr_stream *xdr,
-				const struct nfs4_statfs_arg *args)
+static void nfs4_xdr_enc_statfs(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	const struct nfs4_statfs_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2594,10 +2627,11 @@ static void nfs4_xdr_enc_statfs(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * GETATTR_BITMAP request
  */
-static void nfs4_xdr_enc_server_caps(struct rpc_rqst *req,
+static void nfs4_xdr_enc_server_caps(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs4_server_caps_arg *args)
+				     void *_args)
 {
+	struct nfs4_server_caps_arg *args = _args;
 	const u32 *bitmask = args->bitmask;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
@@ -2613,9 +2647,10 @@ static void nfs4_xdr_enc_server_caps(struct rpc_rqst *req,
 /*
  * a RENEW request
  */
-static void nfs4_xdr_enc_renew(struct rpc_rqst *req, struct xdr_stream *xdr,
-			       struct nfs_client *clp)
+static void nfs4_xdr_enc_renew(void *req, struct xdr_stream *xdr,
+			       void *_clp)
 {
+	struct nfs_client *clp = _clp;
 	struct compound_hdr hdr = {
 		.nops	= 0,
 	};
@@ -2628,9 +2663,9 @@ static void nfs4_xdr_enc_renew(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * a SETCLIENTID request
  */
-static void nfs4_xdr_enc_setclientid(struct rpc_rqst *req,
+static void nfs4_xdr_enc_setclientid(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs4_setclientid *sc)
+				     void *sc)
 {
 	struct compound_hdr hdr = {
 		.nops	= 0,
@@ -2644,9 +2679,9 @@ static void nfs4_xdr_enc_setclientid(struct rpc_rqst *req,
 /*
  * a SETCLIENTID_CONFIRM request
  */
-static void nfs4_xdr_enc_setclientid_confirm(struct rpc_rqst *req,
+static void nfs4_xdr_enc_setclientid_confirm(void *req,
 					     struct xdr_stream *xdr,
-					     struct nfs4_setclientid_res *arg)
+					     void *arg)
 {
 	struct compound_hdr hdr = {
 		.nops	= 0,
@@ -2660,10 +2695,11 @@ static void nfs4_xdr_enc_setclientid_confirm(struct rpc_rqst *req,
 /*
  * DELEGRETURN request
  */
-static void nfs4_xdr_enc_delegreturn(struct rpc_rqst *req,
+static void nfs4_xdr_enc_delegreturn(void *req,
 				     struct xdr_stream *xdr,
-				     const struct nfs4_delegreturnargs *args)
+				     void *_args)
 {
+	const struct nfs4_delegreturnargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2679,10 +2715,12 @@ static void nfs4_xdr_enc_delegreturn(struct rpc_rqst *req,
 /*
  * Encode FS_LOCATIONS request
  */
-static void nfs4_xdr_enc_fs_locations(struct rpc_rqst *req,
+static void nfs4_xdr_enc_fs_locations(void *_req,
 				      struct xdr_stream *xdr,
-				      struct nfs4_fs_locations_arg *args)
+				      void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs4_fs_locations_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2712,10 +2750,11 @@ static void nfs4_xdr_enc_fs_locations(struct rpc_rqst *req,
 /*
  * Encode SECINFO request
  */
-static void nfs4_xdr_enc_secinfo(struct rpc_rqst *req,
+static void nfs4_xdr_enc_secinfo(void *req,
 				struct xdr_stream *xdr,
-				struct nfs4_secinfo_arg *args)
+				void *_args)
 {
+	struct nfs4_secinfo_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2730,10 +2769,11 @@ static void nfs4_xdr_enc_secinfo(struct rpc_rqst *req,
 /*
  * Encode FSID_PRESENT request
  */
-static void nfs4_xdr_enc_fsid_present(struct rpc_rqst *req,
+static void nfs4_xdr_enc_fsid_present(void *req,
 				      struct xdr_stream *xdr,
-				      struct nfs4_fsid_present_arg *args)
+				      void *_args)
 {
+	struct nfs4_fsid_present_arg *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2751,10 +2791,11 @@ static void nfs4_xdr_enc_fsid_present(struct rpc_rqst *req,
 /*
  * BIND_CONN_TO_SESSION request
  */
-static void nfs4_xdr_enc_bind_conn_to_session(struct rpc_rqst *req,
+static void nfs4_xdr_enc_bind_conn_to_session(void *req,
 				struct xdr_stream *xdr,
-				struct nfs41_bind_conn_to_session_args *args)
+				void *_args)
 {
+	struct nfs41_bind_conn_to_session_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = args->client->cl_mvops->minor_version,
 	};
@@ -2767,10 +2808,11 @@ static void nfs4_xdr_enc_bind_conn_to_session(struct rpc_rqst *req,
 /*
  * EXCHANGE_ID request
  */
-static void nfs4_xdr_enc_exchange_id(struct rpc_rqst *req,
+static void nfs4_xdr_enc_exchange_id(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs41_exchange_id_args *args)
+				     void *_args)
 {
+	struct nfs41_exchange_id_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = args->client->cl_mvops->minor_version,
 	};
@@ -2783,10 +2825,11 @@ static void nfs4_xdr_enc_exchange_id(struct rpc_rqst *req,
 /*
  * a CREATE_SESSION request
  */
-static void nfs4_xdr_enc_create_session(struct rpc_rqst *req,
+static void nfs4_xdr_enc_create_session(void *req,
 					struct xdr_stream *xdr,
-					struct nfs41_create_session_args *args)
+					void *_args)
 {
+	struct nfs41_create_session_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = args->client->cl_mvops->minor_version,
 	};
@@ -2799,10 +2842,11 @@ static void nfs4_xdr_enc_create_session(struct rpc_rqst *req,
 /*
  * a DESTROY_SESSION request
  */
-static void nfs4_xdr_enc_destroy_session(struct rpc_rqst *req,
+static void nfs4_xdr_enc_destroy_session(void *req,
 					 struct xdr_stream *xdr,
-					 struct nfs4_session *session)
+					 void *_session)
 {
+	struct nfs4_session *session = _session;
 	struct compound_hdr hdr = {
 		.minorversion = session->clp->cl_mvops->minor_version,
 	};
@@ -2815,10 +2859,11 @@ static void nfs4_xdr_enc_destroy_session(struct rpc_rqst *req,
 /*
  * a DESTROY_CLIENTID request
  */
-static void nfs4_xdr_enc_destroy_clientid(struct rpc_rqst *req,
+static void nfs4_xdr_enc_destroy_clientid(void *req,
 					 struct xdr_stream *xdr,
-					 struct nfs_client *clp)
+					 void *_clp)
 {
+	struct nfs_client *clp = _clp;
 	struct compound_hdr hdr = {
 		.minorversion = clp->cl_mvops->minor_version,
 	};
@@ -2831,8 +2876,8 @@ static void nfs4_xdr_enc_destroy_clientid(struct rpc_rqst *req,
 /*
  * a SEQUENCE request
  */
-static void nfs4_xdr_enc_sequence(struct rpc_rqst *req, struct xdr_stream *xdr,
-				  struct nfs4_sequence_args *args)
+static void nfs4_xdr_enc_sequence(void *req, struct xdr_stream *xdr,
+				  void *args)
 {
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(args),
@@ -2846,10 +2891,11 @@ static void nfs4_xdr_enc_sequence(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * a GET_LEASE_TIME request
  */
-static void nfs4_xdr_enc_get_lease_time(struct rpc_rqst *req,
+static void nfs4_xdr_enc_get_lease_time(void *req,
 					struct xdr_stream *xdr,
-					struct nfs4_get_lease_time_args *args)
+					void *_args)
 {
+	struct nfs4_get_lease_time_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->la_seq_args),
 	};
@@ -2865,10 +2911,11 @@ static void nfs4_xdr_enc_get_lease_time(struct rpc_rqst *req,
 /*
  * a RECLAIM_COMPLETE request
  */
-static void nfs4_xdr_enc_reclaim_complete(struct rpc_rqst *req,
+static void nfs4_xdr_enc_reclaim_complete(void *req,
 					  struct xdr_stream *xdr,
-				struct nfs41_reclaim_complete_args *args)
+					  void *_args)
 {
+	struct nfs41_reclaim_complete_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args)
 	};
@@ -2882,10 +2929,12 @@ static void nfs4_xdr_enc_reclaim_complete(struct rpc_rqst *req,
 /*
  * Encode GETDEVICEINFO request
  */
-static void nfs4_xdr_enc_getdeviceinfo(struct rpc_rqst *req,
+static void nfs4_xdr_enc_getdeviceinfo(void *_req,
 				       struct xdr_stream *xdr,
-				       struct nfs4_getdeviceinfo_args *args)
+				       void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs4_getdeviceinfo_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2906,10 +2955,12 @@ static void nfs4_xdr_enc_getdeviceinfo(struct rpc_rqst *req,
 /*
  *  Encode LAYOUTGET request
  */
-static void nfs4_xdr_enc_layoutget(struct rpc_rqst *req,
+static void nfs4_xdr_enc_layoutget(void *_req,
 				   struct xdr_stream *xdr,
-				   struct nfs4_layoutget_args *args)
+				   void *_args)
 {
+	struct rpc_rqst *req = _req;
+	struct nfs4_layoutget_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2928,10 +2979,11 @@ static void nfs4_xdr_enc_layoutget(struct rpc_rqst *req,
 /*
  *  Encode LAYOUTCOMMIT request
  */
-static void nfs4_xdr_enc_layoutcommit(struct rpc_rqst *req,
+static void nfs4_xdr_enc_layoutcommit(void *req,
 				      struct xdr_stream *xdr,
-				      struct nfs4_layoutcommit_args *args)
+				      void *_args)
 {
+	struct nfs4_layoutcommit_args *args = _args;
 	struct nfs4_layoutcommit_data *data =
 		container_of(args, struct nfs4_layoutcommit_data, args);
 	struct compound_hdr hdr = {
@@ -2949,10 +3001,11 @@ static void nfs4_xdr_enc_layoutcommit(struct rpc_rqst *req,
 /*
  * Encode LAYOUTRETURN request
  */
-static void nfs4_xdr_enc_layoutreturn(struct rpc_rqst *req,
+static void nfs4_xdr_enc_layoutreturn(void *req,
 				      struct xdr_stream *xdr,
-				      struct nfs4_layoutreturn_args *args)
+				      void *_args)
 {
+	struct nfs4_layoutreturn_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2967,10 +3020,11 @@ static void nfs4_xdr_enc_layoutreturn(struct rpc_rqst *req,
 /*
  * Encode SECINFO_NO_NAME request
  */
-static int nfs4_xdr_enc_secinfo_no_name(struct rpc_rqst *req,
+static void nfs4_xdr_enc_secinfo_no_name(void *req,
 					struct xdr_stream *xdr,
-					struct nfs41_secinfo_no_name_args *args)
+					void *_args)
 {
+	struct nfs41_secinfo_no_name_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -2980,16 +3034,16 @@ static int nfs4_xdr_enc_secinfo_no_name(struct rpc_rqst *req,
 	encode_putrootfh(xdr, &hdr);
 	encode_secinfo_no_name(xdr, args, &hdr);
 	encode_nops(&hdr);
-	return 0;
 }
 
 /*
  *  Encode TEST_STATEID request
  */
-static void nfs4_xdr_enc_test_stateid(struct rpc_rqst *req,
+static void nfs4_xdr_enc_test_stateid(void *req,
 				      struct xdr_stream *xdr,
-				      struct nfs41_test_stateid_args *args)
+				      void *_args)
 {
+	struct nfs41_test_stateid_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -3003,10 +3057,11 @@ static void nfs4_xdr_enc_test_stateid(struct rpc_rqst *req,
 /*
  *  Encode FREE_STATEID request
  */
-static void nfs4_xdr_enc_free_stateid(struct rpc_rqst *req,
+static void nfs4_xdr_enc_free_stateid(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs41_free_stateid_args *args)
+				     void *_args)
 {
+	struct nfs41_free_stateid_args *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -6096,10 +6151,11 @@ static int decode_free_stateid(struct xdr_stream *xdr,
 /*
  * Decode OPEN_DOWNGRADE response
  */
-static int nfs4_xdr_dec_open_downgrade(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_open_downgrade(void *rqstp,
 				       struct xdr_stream *xdr,
-				       struct nfs_closeres *res)
+				       void *_res)
 {
+	struct nfs_closeres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6123,9 +6179,10 @@ out:
 /*
  * Decode ACCESS response
  */
-static int nfs4_xdr_dec_access(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			       struct nfs4_accessres *res)
+static int nfs4_xdr_dec_access(void *rqstp, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs4_accessres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6149,9 +6206,10 @@ out:
 /*
  * Decode LOOKUP response
  */
-static int nfs4_xdr_dec_lookup(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			       struct nfs4_lookup_res *res)
+static int nfs4_xdr_dec_lookup(void *rqstp, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs4_lookup_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6178,10 +6236,11 @@ out:
 /*
  * Decode LOOKUP_ROOT response
  */
-static int nfs4_xdr_dec_lookup_root(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_lookup_root(void *rqstp,
 				    struct xdr_stream *xdr,
-				    struct nfs4_lookup_res *res)
+				    void *_res)
 {
+	struct nfs4_lookup_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6205,9 +6264,10 @@ out:
 /*
  * Decode REMOVE response
  */
-static int nfs4_xdr_dec_remove(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			       struct nfs_removeres *res)
+static int nfs4_xdr_dec_remove(void *rqstp, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs_removeres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6228,9 +6288,10 @@ out:
 /*
  * Decode RENAME response
  */
-static int nfs4_xdr_dec_rename(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			       struct nfs_renameres *res)
+static int nfs4_xdr_dec_rename(void *rqstp, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs_renameres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6257,9 +6318,10 @@ out:
 /*
  * Decode LINK response
  */
-static int nfs4_xdr_dec_link(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			     struct nfs4_link_res *res)
+static int nfs4_xdr_dec_link(void *rqstp, struct xdr_stream *xdr,
+			     void *_res)
 {
+	struct nfs4_link_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6296,9 +6358,10 @@ out:
 /*
  * Decode CREATE response
  */
-static int nfs4_xdr_dec_create(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			       struct nfs4_create_res *res)
+static int nfs4_xdr_dec_create(void *rqstp, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs4_create_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6325,8 +6388,8 @@ out:
 /*
  * Decode SYMLINK response
  */
-static int nfs4_xdr_dec_symlink(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-				struct nfs4_create_res *res)
+static int nfs4_xdr_dec_symlink(void *rqstp, struct xdr_stream *xdr,
+				void *res)
 {
 	return nfs4_xdr_dec_create(rqstp, xdr, res);
 }
@@ -6334,9 +6397,10 @@ static int nfs4_xdr_dec_symlink(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
 /*
  * Decode GETATTR response
  */
-static int nfs4_xdr_dec_getattr(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-				struct nfs4_getattr_res *res)
+static int nfs4_xdr_dec_getattr(void *rqstp, struct xdr_stream *xdr,
+				void *_res)
 {
+	struct nfs4_getattr_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6357,9 +6421,10 @@ out:
 /*
  * Encode an SETACL request
  */
-static void nfs4_xdr_enc_setacl(struct rpc_rqst *req, struct xdr_stream *xdr,
-				struct nfs_setaclargs *args)
+static void nfs4_xdr_enc_setacl(void *req, struct xdr_stream *xdr,
+				void *_args)
 {
+	struct nfs_setaclargs *args = _args;
 	struct compound_hdr hdr = {
 		.minorversion = nfs4_xdr_minorversion(&args->seq_args),
 	};
@@ -6375,9 +6440,10 @@ static void nfs4_xdr_enc_setacl(struct rpc_rqst *req, struct xdr_stream *xdr,
  * Decode SETACL response
  */
 static int
-nfs4_xdr_dec_setacl(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-		    struct nfs_setaclres *res)
+nfs4_xdr_dec_setacl(void *rqstp, struct xdr_stream *xdr,
+		    void *_res)
 {
+	struct nfs_setaclres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6399,9 +6465,10 @@ out:
  * Decode GETACL response
  */
 static int
-nfs4_xdr_dec_getacl(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-		    struct nfs_getaclres *res)
+nfs4_xdr_dec_getacl(void *rqstp, struct xdr_stream *xdr,
+		    void *_res)
 {
+	struct nfs_getaclres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6427,9 +6494,10 @@ out:
 /*
  * Decode CLOSE response
  */
-static int nfs4_xdr_dec_close(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			      struct nfs_closeres *res)
+static int nfs4_xdr_dec_close(void *rqstp, struct xdr_stream *xdr,
+			      void *_res)
 {
+	struct nfs_closeres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6459,9 +6527,10 @@ out:
 /*
  * Decode OPEN response
  */
-static int nfs4_xdr_dec_open(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			     struct nfs_openres *res)
+static int nfs4_xdr_dec_open(void *rqstp, struct xdr_stream *xdr,
+			     void *_res)
 {
+	struct nfs_openres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6490,9 +6559,9 @@ out:
 /*
  * Decode OPEN_CONFIRM response
  */
-static int nfs4_xdr_dec_open_confirm(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_open_confirm(void *rqstp,
 				     struct xdr_stream *xdr,
-				     struct nfs_open_confirmres *res)
+				     void *res)
 {
 	struct compound_hdr hdr;
 	int status;
@@ -6511,10 +6580,11 @@ out:
 /*
  * Decode OPEN response
  */
-static int nfs4_xdr_dec_open_noattr(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_open_noattr(void *rqstp,
 				    struct xdr_stream *xdr,
-				    struct nfs_openres *res)
+				    void *_res)
 {
+	struct nfs_openres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6540,10 +6610,11 @@ out:
 /*
  * Decode SETATTR response
  */
-static int nfs4_xdr_dec_setattr(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_setattr(void *rqstp,
 				struct xdr_stream *xdr,
-				struct nfs_setattrres *res)
+				void *_res)
 {
+	struct nfs_setattrres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6567,9 +6638,10 @@ out:
 /*
  * Decode LOCK response
  */
-static int nfs4_xdr_dec_lock(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			     struct nfs_lock_res *res)
+static int nfs4_xdr_dec_lock(void *rqstp, struct xdr_stream *xdr,
+			     void *_res)
 {
+	struct nfs_lock_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6590,9 +6662,10 @@ out:
 /*
  * Decode LOCKT response
  */
-static int nfs4_xdr_dec_lockt(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			      struct nfs_lockt_res *res)
+static int nfs4_xdr_dec_lockt(void *rqstp, struct xdr_stream *xdr,
+			      void *_res)
 {
+	struct nfs_lockt_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6613,9 +6686,10 @@ out:
 /*
  * Decode LOCKU response
  */
-static int nfs4_xdr_dec_locku(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			      struct nfs_locku_res *res)
+static int nfs4_xdr_dec_locku(void *rqstp, struct xdr_stream *xdr,
+			      void *_res)
 {
+	struct nfs_locku_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6633,7 +6707,7 @@ out:
 	return status;
 }
 
-static int nfs4_xdr_dec_release_lockowner(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_release_lockowner(void *rqstp,
 					  struct xdr_stream *xdr, void *dummy)
 {
 	struct compound_hdr hdr;
@@ -6648,10 +6722,11 @@ static int nfs4_xdr_dec_release_lockowner(struct rpc_rqst *rqstp,
 /*
  * Decode READLINK response
  */
-static int nfs4_xdr_dec_readlink(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_readlink(void *rqstp,
 				 struct xdr_stream *xdr,
-				 struct nfs4_readlink_res *res)
+				 void *_res)
 {
+	struct nfs4_readlink_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6672,9 +6747,10 @@ out:
 /*
  * Decode READDIR response
  */
-static int nfs4_xdr_dec_readdir(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-				struct nfs4_readdir_res *res)
+static int nfs4_xdr_dec_readdir(void *rqstp, struct xdr_stream *xdr,
+				void *_res)
 {
+	struct nfs4_readdir_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6695,9 +6771,10 @@ out:
 /*
  * Decode Read response
  */
-static int nfs4_xdr_dec_read(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			     struct nfs_pgio_res *res)
+static int nfs4_xdr_dec_read(void *rqstp, struct xdr_stream *xdr,
+			     void *_res)
 {
+	struct nfs_pgio_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6721,9 +6798,10 @@ out:
 /*
  * Decode WRITE response
  */
-static int nfs4_xdr_dec_write(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			      struct nfs_pgio_res *res)
+static int nfs4_xdr_dec_write(void *rqstp, struct xdr_stream *xdr,
+			      void *_res)
 {
+	struct nfs_pgio_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6751,9 +6829,10 @@ out:
 /*
  * Decode COMMIT response
  */
-static int nfs4_xdr_dec_commit(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
-			       struct nfs_commitres *res)
+static int nfs4_xdr_dec_commit(void *rqstp, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs_commitres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6775,9 +6854,10 @@ out:
 /*
  * Decode FSINFO response
  */
-static int nfs4_xdr_dec_fsinfo(struct rpc_rqst *req, struct xdr_stream *xdr,
-			       struct nfs4_fsinfo_res *res)
+static int nfs4_xdr_dec_fsinfo(void *req, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs4_fsinfo_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6794,9 +6874,10 @@ static int nfs4_xdr_dec_fsinfo(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Decode PATHCONF response
  */
-static int nfs4_xdr_dec_pathconf(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 struct nfs4_pathconf_res *res)
+static int nfs4_xdr_dec_pathconf(void *req, struct xdr_stream *xdr,
+				 void *_res)
 {
+	struct nfs4_pathconf_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6813,9 +6894,10 @@ static int nfs4_xdr_dec_pathconf(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Decode STATFS response
  */
-static int nfs4_xdr_dec_statfs(struct rpc_rqst *req, struct xdr_stream *xdr,
-			       struct nfs4_statfs_res *res)
+static int nfs4_xdr_dec_statfs(void *req, struct xdr_stream *xdr,
+			       void *_res)
 {
+	struct nfs4_statfs_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6832,10 +6914,11 @@ static int nfs4_xdr_dec_statfs(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * Decode GETATTR_BITMAP response
  */
-static int nfs4_xdr_dec_server_caps(struct rpc_rqst *req,
+static int nfs4_xdr_dec_server_caps(void *req,
 				    struct xdr_stream *xdr,
-				    struct nfs4_server_caps_res *res)
+				    void *_res)
 {
+	struct nfs4_server_caps_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6856,7 +6939,7 @@ out:
 /*
  * Decode RENEW response
  */
-static int nfs4_xdr_dec_renew(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
+static int nfs4_xdr_dec_renew(void *rqstp, struct xdr_stream *xdr,
 			      void *__unused)
 {
 	struct compound_hdr hdr;
@@ -6871,9 +6954,9 @@ static int nfs4_xdr_dec_renew(struct rpc_rqst *rqstp, struct xdr_stream *xdr,
 /*
  * Decode SETCLIENTID response
  */
-static int nfs4_xdr_dec_setclientid(struct rpc_rqst *req,
+static int nfs4_xdr_dec_setclientid(void *req,
 				    struct xdr_stream *xdr,
-				    struct nfs4_setclientid_res *res)
+				    void *res)
 {
 	struct compound_hdr hdr;
 	int status;
@@ -6887,8 +6970,9 @@ static int nfs4_xdr_dec_setclientid(struct rpc_rqst *req,
 /*
  * Decode SETCLIENTID_CONFIRM response
  */
-static int nfs4_xdr_dec_setclientid_confirm(struct rpc_rqst *req,
-					    struct xdr_stream *xdr)
+static int nfs4_xdr_dec_setclientid_confirm(void *req,
+					    struct xdr_stream *xdr,
+					    void *res)
 {
 	struct compound_hdr hdr;
 	int status;
@@ -6902,10 +6986,11 @@ static int nfs4_xdr_dec_setclientid_confirm(struct rpc_rqst *req,
 /*
  * Decode DELEGRETURN response
  */
-static int nfs4_xdr_dec_delegreturn(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_delegreturn(void *rqstp,
 				    struct xdr_stream *xdr,
-				    struct nfs4_delegreturnres *res)
+				    void *_res)
 {
+	struct nfs4_delegreturnres *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6929,10 +7014,11 @@ out:
 /*
  * Decode FS_LOCATIONS response
  */
-static int nfs4_xdr_dec_fs_locations(struct rpc_rqst *req,
+static int nfs4_xdr_dec_fs_locations(void *req,
 				     struct xdr_stream *xdr,
-				     struct nfs4_fs_locations_res *res)
+				     void *_res)
 {
+	struct nfs4_fs_locations_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6972,10 +7058,11 @@ out:
 /*
  * Decode SECINFO response
  */
-static int nfs4_xdr_dec_secinfo(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_secinfo(void *rqstp,
 				struct xdr_stream *xdr,
-				struct nfs4_secinfo_res *res)
+				void *_res)
 {
+	struct nfs4_secinfo_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -6996,10 +7083,11 @@ out:
 /*
  * Decode FSID_PRESENT response
  */
-static int nfs4_xdr_dec_fsid_present(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_fsid_present(void *rqstp,
 				     struct xdr_stream *xdr,
-				     struct nfs4_fsid_present_res *res)
+				     void *_res)
 {
+	struct nfs4_fsid_present_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7025,7 +7113,7 @@ out:
 /*
  * Decode BIND_CONN_TO_SESSION response
  */
-static int nfs4_xdr_dec_bind_conn_to_session(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_bind_conn_to_session(void *rqstp,
 					struct xdr_stream *xdr,
 					void *res)
 {
@@ -7041,7 +7129,7 @@ static int nfs4_xdr_dec_bind_conn_to_session(struct rpc_rqst *rqstp,
 /*
  * Decode EXCHANGE_ID response
  */
-static int nfs4_xdr_dec_exchange_id(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_exchange_id(void *rqstp,
 				    struct xdr_stream *xdr,
 				    void *res)
 {
@@ -7057,9 +7145,9 @@ static int nfs4_xdr_dec_exchange_id(struct rpc_rqst *rqstp,
 /*
  * Decode CREATE_SESSION response
  */
-static int nfs4_xdr_dec_create_session(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_create_session(void *rqstp,
 				       struct xdr_stream *xdr,
-				       struct nfs41_create_session_res *res)
+				       void *res)
 {
 	struct compound_hdr hdr;
 	int status;
@@ -7073,7 +7161,7 @@ static int nfs4_xdr_dec_create_session(struct rpc_rqst *rqstp,
 /*
  * Decode DESTROY_SESSION response
  */
-static int nfs4_xdr_dec_destroy_session(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_destroy_session(void *rqstp,
 					struct xdr_stream *xdr,
 					void *res)
 {
@@ -7089,7 +7177,7 @@ static int nfs4_xdr_dec_destroy_session(struct rpc_rqst *rqstp,
 /*
  * Decode DESTROY_CLIENTID response
  */
-static int nfs4_xdr_dec_destroy_clientid(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_destroy_clientid(void *rqstp,
 					struct xdr_stream *xdr,
 					void *res)
 {
@@ -7105,9 +7193,9 @@ static int nfs4_xdr_dec_destroy_clientid(struct rpc_rqst *rqstp,
 /*
  * Decode SEQUENCE response
  */
-static int nfs4_xdr_dec_sequence(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_sequence(void *rqstp,
 				 struct xdr_stream *xdr,
-				 struct nfs4_sequence_res *res)
+				 void *res)
 {
 	struct compound_hdr hdr;
 	int status;
@@ -7121,10 +7209,11 @@ static int nfs4_xdr_dec_sequence(struct rpc_rqst *rqstp,
 /*
  * Decode GET_LEASE_TIME response
  */
-static int nfs4_xdr_dec_get_lease_time(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_get_lease_time(void *rqstp,
 				       struct xdr_stream *xdr,
-				       struct nfs4_get_lease_time_res *res)
+				       void *_res)
 {
+	struct nfs4_get_lease_time_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7141,10 +7230,11 @@ static int nfs4_xdr_dec_get_lease_time(struct rpc_rqst *rqstp,
 /*
  * Decode RECLAIM_COMPLETE response
  */
-static int nfs4_xdr_dec_reclaim_complete(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_reclaim_complete(void *rqstp,
 					 struct xdr_stream *xdr,
-					 struct nfs41_reclaim_complete_res *res)
+					 void *_res)
 {
+	struct nfs41_reclaim_complete_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7159,10 +7249,11 @@ static int nfs4_xdr_dec_reclaim_complete(struct rpc_rqst *rqstp,
 /*
  * Decode GETDEVINFO response
  */
-static int nfs4_xdr_dec_getdeviceinfo(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_getdeviceinfo(void *rqstp,
 				      struct xdr_stream *xdr,
-				      struct nfs4_getdeviceinfo_res *res)
+				      void *_res)
 {
+	struct nfs4_getdeviceinfo_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7180,10 +7271,11 @@ out:
 /*
  * Decode LAYOUTGET response
  */
-static int nfs4_xdr_dec_layoutget(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_layoutget(void *rqstp,
 				  struct xdr_stream *xdr,
-				  struct nfs4_layoutget_res *res)
+				  void *_res)
 {
+	struct nfs4_layoutget_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7204,10 +7296,11 @@ out:
 /*
  * Decode LAYOUTRETURN response
  */
-static int nfs4_xdr_dec_layoutreturn(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_layoutreturn(void *rqstp,
 				     struct xdr_stream *xdr,
-				     struct nfs4_layoutreturn_res *res)
+				     void *_res)
 {
+	struct nfs4_layoutreturn_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7228,10 +7321,11 @@ out:
 /*
  * Decode LAYOUTCOMMIT response
  */
-static int nfs4_xdr_dec_layoutcommit(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_layoutcommit(void *rqstp,
 				     struct xdr_stream *xdr,
-				     struct nfs4_layoutcommit_res *res)
+				     void *_res)
 {
+	struct nfs4_layoutcommit_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7255,10 +7349,11 @@ out:
 /*
  * Decode SECINFO_NO_NAME response
  */
-static int nfs4_xdr_dec_secinfo_no_name(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_secinfo_no_name(void *rqstp,
 					struct xdr_stream *xdr,
-					struct nfs4_secinfo_res *res)
+					void *_res)
 {
+	struct nfs4_secinfo_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7279,10 +7374,11 @@ out:
 /*
  * Decode TEST_STATEID response
  */
-static int nfs4_xdr_dec_test_stateid(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_test_stateid(void *rqstp,
 				     struct xdr_stream *xdr,
-				     struct nfs41_test_stateid_res *res)
+				     void *_res)
 {
+	struct nfs41_test_stateid_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7300,10 +7396,11 @@ out:
 /*
  * Decode FREE_STATEID response
  */
-static int nfs4_xdr_dec_free_stateid(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_free_stateid(void *rqstp,
 				     struct xdr_stream *xdr,
-				     struct nfs41_free_stateid_res *res)
+				     void *_res)
 {
+	struct nfs41_free_stateid_res *res = _res;
 	struct compound_hdr hdr;
 	int status;
 
@@ -7468,8 +7565,8 @@ nfs4_stat_to_errno(int stat)
 #define PROC(proc, argtype, restype)				\
 [NFSPROC4_CLNT_##proc] = {					\
 	.p_proc   = NFSPROC4_COMPOUND,				\
-	.p_encode = (kxdreproc_t)nfs4_xdr_##argtype,		\
-	.p_decode = (kxdrdproc_t)nfs4_xdr_##restype,		\
+	.p_encode = nfs4_xdr_##argtype,				\
+	.p_decode = nfs4_xdr_##restype,				\
 	.p_arglen = NFS4_##argtype##_sz,			\
 	.p_replen = NFS4_##restype##_sz,			\
 	.p_statidx = NFSPROC4_CLNT_##proc,			\
diff --git a/fs/nfs/read.c b/fs/nfs/read.c
index 572e5b3b0..5245a0af9 100644
--- a/fs/nfs/read.c
+++ b/fs/nfs/read.c
@@ -346,7 +346,7 @@ struct nfs_readdesc {
 };
 
 static int
-readpage_async_filler(void *data, struct page *page)
+readpage_async_filler(struct file *data, struct page *page)
 {
 	struct nfs_readdesc *desc = (struct nfs_readdesc *)data;
 	struct nfs_page *new;
diff --git a/fs/nfs/symlink.c b/fs/nfs/symlink.c
index 4fe3eead3..8922b2b62 100644
--- a/fs/nfs/symlink.c
+++ b/fs/nfs/symlink.c
@@ -25,9 +25,10 @@
  * and straight-forward than readdir caching.
  */
 
-static int nfs_symlink_filler(struct inode *inode, struct page *page)
+static int nfs_symlink_filler(struct file *_inode, struct page *page)
 {
 	int error;
+	struct inode *inode = (struct inode *)_inode;
 
 	error = NFS_PROTO(inode)->readlink(inode, page, 0, PAGE_SIZE);
 	if (error < 0)
@@ -64,8 +65,7 @@ static const char *nfs_get_link(struct dentry *dentry,
 		err = ERR_PTR(nfs_revalidate_mapping(inode, inode->i_mapping));
 		if (err)
 			return err;
-		page = read_cache_page(&inode->i_data, 0,
-					(filler_t *)nfs_symlink_filler, inode);
+		page = read_cache_page(&inode->i_data, 0, nfs_symlink_filler, inode);
 		if (IS_ERR(page))
 			return ERR_CAST(page);
 	}
diff --git a/fs/nfsd/current_stateid.h b/fs/nfsd/current_stateid.h
index 412355120..813b40388 100644
--- a/fs/nfsd/current_stateid.h
+++ b/fs/nfsd/current_stateid.h
@@ -8,21 +8,21 @@ extern void clear_current_stateid(struct nfsd4_compound_state *cstate);
 /*
  * functions to set current state id
  */
-extern void nfsd4_set_opendowngradestateid(struct nfsd4_compound_state *cstate, struct nfsd4_open_downgrade *);
-extern void nfsd4_set_openstateid(struct nfsd4_compound_state *, struct nfsd4_open *);
-extern void nfsd4_set_lockstateid(struct nfsd4_compound_state *, struct nfsd4_lock *);
-extern void nfsd4_set_closestateid(struct nfsd4_compound_state *, struct nfsd4_close *);
+extern void nfsd4_set_opendowngradestateid(struct nfsd4_compound_state *cstate, void *);
+extern void nfsd4_set_openstateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_set_lockstateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_set_closestateid(struct nfsd4_compound_state *, void *);
 
 /*
  * functions to consume current state id
  */
-extern void nfsd4_get_opendowngradestateid(struct nfsd4_compound_state *cstate, struct nfsd4_open_downgrade *);
-extern void nfsd4_get_delegreturnstateid(struct nfsd4_compound_state *, struct nfsd4_delegreturn *);
-extern void nfsd4_get_freestateid(struct nfsd4_compound_state *, struct nfsd4_free_stateid *);
-extern void nfsd4_get_setattrstateid(struct nfsd4_compound_state *, struct nfsd4_setattr *);
-extern void nfsd4_get_closestateid(struct nfsd4_compound_state *, struct nfsd4_close *);
-extern void nfsd4_get_lockustateid(struct nfsd4_compound_state *, struct nfsd4_locku *);
-extern void nfsd4_get_readstateid(struct nfsd4_compound_state *, struct nfsd4_read *);
-extern void nfsd4_get_writestateid(struct nfsd4_compound_state *, struct nfsd4_write *);
+extern void nfsd4_get_opendowngradestateid(struct nfsd4_compound_state *cstate, void *);
+extern void nfsd4_get_delegreturnstateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_get_freestateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_get_setattrstateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_get_closestateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_get_lockustateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_get_readstateid(struct nfsd4_compound_state *, void *);
+extern void nfsd4_get_writestateid(struct nfsd4_compound_state *, void *);
 
 #endif   /* _NFSD4_CURRENT_STATE_H */
diff --git a/fs/nfsd/nfs2acl.c b/fs/nfsd/nfs2acl.c
index d08cd8815..5d74e5023 100644
--- a/fs/nfsd/nfs2acl.c
+++ b/fs/nfsd/nfs2acl.c
@@ -27,9 +27,10 @@ nfsacld_proc_null(struct svc_rqst *rqstp, void *argp, void *resp)
 /*
  * Get the Access and/or Default ACL of a file.
  */
-static __be32 nfsacld_proc_getacl(struct svc_rqst * rqstp,
-		struct nfsd3_getaclargs *argp, struct nfsd3_getaclres *resp)
+static __be32 nfsacld_proc_getacl(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_getaclargs *argp = _argp;
+	struct nfsd3_getaclres *resp = _resp;
 	struct posix_acl *acl;
 	struct inode *inode;
 	svc_fh *fh;
@@ -87,10 +88,10 @@ fail:
 /*
  * Set the Access and/or Default ACL of a file.
  */
-static __be32 nfsacld_proc_setacl(struct svc_rqst * rqstp,
-		struct nfsd3_setaclargs *argp,
-		struct nfsd_attrstat *resp)
+static __be32 nfsacld_proc_setacl(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_setaclargs *argp = _argp;
+	struct nfsd_attrstat *resp = _resp;
 	struct inode *inode;
 	svc_fh *fh;
 	__be32 nfserr = 0;
@@ -141,9 +142,10 @@ out_errno:
 /*
  * Check file attributes
  */
-static __be32 nfsacld_proc_getattr(struct svc_rqst * rqstp,
-		struct nfsd_fhandle *argp, struct nfsd_attrstat *resp)
+static __be32 nfsacld_proc_getattr(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd_fhandle *argp = _argp;
+	struct nfsd_attrstat *resp = _resp;
 	__be32 nfserr;
 	dprintk("nfsd: GETATTR  %s\n", SVCFH_fmt(&argp->fh));
 
@@ -158,9 +160,10 @@ static __be32 nfsacld_proc_getattr(struct svc_rqst * rqstp,
 /*
  * Check file access
  */
-static __be32 nfsacld_proc_access(struct svc_rqst *rqstp, struct nfsd3_accessargs *argp,
-		struct nfsd3_accessres *resp)
+static __be32 nfsacld_proc_access(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_accessargs *argp = _argp;
+	struct nfsd3_accessres *resp = _resp;
 	__be32 nfserr;
 
 	dprintk("nfsd: ACCESS(2acl)   %s 0x%x\n",
@@ -179,9 +182,10 @@ static __be32 nfsacld_proc_access(struct svc_rqst *rqstp, struct nfsd3_accessarg
 /*
  * XDR decode functions
  */
-static int nfsaclsvc_decode_getaclargs(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_getaclargs *argp)
+static int nfsaclsvc_decode_getaclargs(void *rqstp, __be32 *p, void *_argp)
 {
+	struct nfsd3_getaclargs *argp = _argp;
+
 	p = nfs2svc_decode_fh(p, &argp->fh);
 	if (!p)
 		return 0;
@@ -191,9 +195,10 @@ static int nfsaclsvc_decode_getaclargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 
-static int nfsaclsvc_decode_setaclargs(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_setaclargs *argp)
+static int nfsaclsvc_decode_setaclargs(void *_rqstp, __be32 *p, void *_argp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_setaclargs *argp = _argp;
 	struct kvec *head = rqstp->rq_arg.head;
 	unsigned int base;
 	int n;
@@ -217,18 +222,20 @@ static int nfsaclsvc_decode_setaclargs(struct svc_rqst *rqstp, __be32 *p,
 	return (n > 0);
 }
 
-static int nfsaclsvc_decode_fhandleargs(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd_fhandle *argp)
+static int nfsaclsvc_decode_fhandleargs(void *rqstp, __be32 *p, void *_argp)
 {
+	struct nfsd_fhandle *argp = _argp;
+
 	p = nfs2svc_decode_fh(p, &argp->fh);
 	if (!p)
 		return 0;
 	return xdr_argsize_check(rqstp, p);
 }
 
-static int nfsaclsvc_decode_accessargs(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_accessargs *argp)
+static int nfsaclsvc_decode_accessargs(void *rqstp, __be32 *p, void *_argp)
 {
+	struct nfsd3_accessargs *argp = _argp;
+
 	p = nfs2svc_decode_fh(p, &argp->fh);
 	if (!p)
 		return 0;
@@ -245,15 +252,16 @@ static int nfsaclsvc_decode_accessargs(struct svc_rqst *rqstp, __be32 *p,
  * There must be an encoding function for void results so svc_process
  * will work properly.
  */
-static int nfsaclsvc_encode_voidres(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+static int nfsaclsvc_encode_voidres(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_ressize_check(rqstp, p);
 }
 
 /* GETACL */
-static int nfsaclsvc_encode_getaclres(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_getaclres *resp)
+static int nfsaclsvc_encode_getaclres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_getaclres *resp = _resp;
 	struct dentry *dentry = resp->fh.fh_dentry;
 	struct inode *inode;
 	struct kvec *head = rqstp->rq_res.head;
@@ -296,17 +304,19 @@ static int nfsaclsvc_encode_getaclres(struct svc_rqst *rqstp, __be32 *p,
 	return (n > 0);
 }
 
-static int nfsaclsvc_encode_attrstatres(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd_attrstat *resp)
+static int nfsaclsvc_encode_attrstatres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd_attrstat *resp = _resp;
+
 	p = nfs2svc_encode_fattr(rqstp, p, &resp->fh, &resp->stat);
 	return xdr_ressize_check(rqstp, p);
 }
 
 /* ACCESS */
-static int nfsaclsvc_encode_accessres(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_accessres *resp)
+static int nfsaclsvc_encode_accessres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_accessres *resp = _resp;
+
 	p = nfs2svc_encode_fattr(rqstp, p, &resp->fh, &resp->stat);
 	*p++ = htonl(resp->access);
 	return xdr_ressize_check(rqstp, p);
@@ -315,27 +325,30 @@ static int nfsaclsvc_encode_accessres(struct svc_rqst *rqstp, __be32 *p,
 /*
  * XDR release functions
  */
-static int nfsaclsvc_release_getacl(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_getaclres *resp)
+static int nfsaclsvc_release_getacl(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_getaclres *resp = _resp;
+
 	fh_put(&resp->fh);
 	posix_acl_release(resp->acl_access);
 	posix_acl_release(resp->acl_default);
 	return 1;
 }
 
-static int nfsaclsvc_release_attrstat(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd_attrstat *resp)
+static int nfsaclsvc_release_attrstat(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd_attrstat *resp = _resp;
+
 	fh_put(&resp->fh);
 	return 1;
 }
 
-static int nfsaclsvc_release_access(struct svc_rqst *rqstp, __be32 *p,
-               struct nfsd3_accessres *resp)
+static int nfsaclsvc_release_access(void *rqstp, __be32 *p, void *_resp)
 {
-       fh_put(&resp->fh);
-       return 1;
+	struct nfsd3_accessres *resp = _resp;
+
+	fh_put(&resp->fh);
+	return 1;
 }
 
 #define nfsaclsvc_decode_voidargs	NULL
@@ -346,10 +359,10 @@ static int nfsaclsvc_release_access(struct svc_rqst *rqstp, __be32 *p,
 struct nfsd3_voidargs { int dummy; };
 
 #define PROC(name, argt, rest, relt, cache, respsize)	\
- { (svc_procfunc) nfsacld_proc_##name,		\
-   (kxdrproc_t) nfsaclsvc_decode_##argt##args,	\
-   (kxdrproc_t) nfsaclsvc_encode_##rest##res,	\
-   (kxdrproc_t) nfsaclsvc_release_##relt,		\
+ { nfsacld_proc_##name,				\
+   nfsaclsvc_decode_##argt##args,		\
+   nfsaclsvc_encode_##rest##res,		\
+   nfsaclsvc_release_##relt,			\
    sizeof(struct nfsd3_##argt##args),		\
    sizeof(struct nfsd3_##rest##res),		\
    0,						\
diff --git a/fs/nfsd/nfs3acl.c b/fs/nfsd/nfs3acl.c
index 0c890347c..36a8d7664 100644
--- a/fs/nfsd/nfs3acl.c
+++ b/fs/nfsd/nfs3acl.c
@@ -26,9 +26,10 @@ nfsd3_proc_null(struct svc_rqst *rqstp, void *argp, void *resp)
 /*
  * Get the Access and/or Default ACL of a file.
  */
-static __be32 nfsd3_proc_getacl(struct svc_rqst * rqstp,
-		struct nfsd3_getaclargs *argp, struct nfsd3_getaclres *resp)
+static __be32 nfsd3_proc_getacl(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_getaclargs *argp = _argp;
+	struct nfsd3_getaclres *resp = _resp;
 	struct posix_acl *acl;
 	struct inode *inode;
 	svc_fh *fh;
@@ -80,10 +81,10 @@ fail:
 /*
  * Set the Access and/or Default ACL of a file.
  */
-static __be32 nfsd3_proc_setacl(struct svc_rqst * rqstp,
-		struct nfsd3_setaclargs *argp,
-		struct nfsd3_attrstat *resp)
+static __be32 nfsd3_proc_setacl(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_setaclargs *argp = _argp;
+	struct nfsd3_attrstat *resp = _resp;
 	struct inode *inode;
 	svc_fh *fh;
 	__be32 nfserr = 0;
@@ -123,9 +124,10 @@ out:
 /*
  * XDR decode functions
  */
-static int nfs3svc_decode_getaclargs(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_getaclargs *args)
+static int nfs3svc_decode_getaclargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_getaclargs *args = _args;
+
 	p = nfs3svc_decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -135,9 +137,10 @@ static int nfs3svc_decode_getaclargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 
-static int nfs3svc_decode_setaclargs(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_setaclargs *args)
+static int nfs3svc_decode_setaclargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_setaclargs *args = _args;
 	struct kvec *head = rqstp->rq_arg.head;
 	unsigned int base;
 	int n;
@@ -166,9 +169,10 @@ static int nfs3svc_decode_setaclargs(struct svc_rqst *rqstp, __be32 *p,
  */
 
 /* GETACL */
-static int nfs3svc_encode_getaclres(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_getaclres *resp)
+static int nfs3svc_encode_getaclres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_getaclres *resp = _resp;
 	struct dentry *dentry = resp->fh.fh_dentry;
 
 	p = nfs3svc_encode_post_op_attr(rqstp, p, &resp->fh);
@@ -211,9 +215,10 @@ static int nfs3svc_encode_getaclres(struct svc_rqst *rqstp, __be32 *p,
 }
 
 /* SETACL */
-static int nfs3svc_encode_setaclres(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_attrstat *resp)
+static int nfs3svc_encode_setaclres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_attrstat *resp = _resp;
+
 	p = nfs3svc_encode_post_op_attr(rqstp, p, &resp->fh);
 
 	return xdr_ressize_check(rqstp, p);
@@ -222,9 +227,10 @@ static int nfs3svc_encode_setaclres(struct svc_rqst *rqstp, __be32 *p,
 /*
  * XDR release functions
  */
-static int nfs3svc_release_getacl(struct svc_rqst *rqstp, __be32 *p,
-		struct nfsd3_getaclres *resp)
+static int nfs3svc_release_getacl(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_getaclres *resp = _resp;
+
 	fh_put(&resp->fh);
 	posix_acl_release(resp->acl_access);
 	posix_acl_release(resp->acl_default);
@@ -238,10 +244,10 @@ static int nfs3svc_release_getacl(struct svc_rqst *rqstp, __be32 *p,
 struct nfsd3_voidargs { int dummy; };
 
 #define PROC(name, argt, rest, relt, cache, respsize)	\
- { (svc_procfunc) nfsd3_proc_##name,		\
-   (kxdrproc_t) nfs3svc_decode_##argt##args,	\
-   (kxdrproc_t) nfs3svc_encode_##rest##res,	\
-   (kxdrproc_t) nfs3svc_release_##relt,		\
+ { nfsd3_proc_##name,				\
+   nfs3svc_decode_##argt##args,			\
+   nfs3svc_encode_##rest##res,			\
+   nfs3svc_release_##relt,			\
    sizeof(struct nfsd3_##argt##args),		\
    sizeof(struct nfsd3_##rest##res),		\
    0,						\
diff --git a/fs/nfsd/nfs3proc.c b/fs/nfsd/nfs3proc.c
index d818e4ffd..bb15590ae 100644
--- a/fs/nfsd/nfs3proc.c
+++ b/fs/nfsd/nfs3proc.c
@@ -40,9 +40,10 @@ nfsd3_proc_null(struct svc_rqst *rqstp, void *argp, void *resp)
  * Get a file's attributes
  */
 static __be32
-nfsd3_proc_getattr(struct svc_rqst *rqstp, struct nfsd_fhandle  *argp,
-					   struct nfsd3_attrstat *resp)
+nfsd3_proc_getattr(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd_fhandle *argp = _argp;
+	struct nfsd3_attrstat *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: GETATTR(3)  %s\n",
@@ -63,9 +64,10 @@ nfsd3_proc_getattr(struct svc_rqst *rqstp, struct nfsd_fhandle  *argp,
  * Set a file's attributes
  */
 static __be32
-nfsd3_proc_setattr(struct svc_rqst *rqstp, struct nfsd3_sattrargs *argp,
-					   struct nfsd3_attrstat  *resp)
+nfsd3_proc_setattr(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_sattrargs *argp = _argp;
+	struct nfsd3_attrstat *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: SETATTR(3)  %s\n",
@@ -81,9 +83,10 @@ nfsd3_proc_setattr(struct svc_rqst *rqstp, struct nfsd3_sattrargs *argp,
  * Look up a path name component
  */
 static __be32
-nfsd3_proc_lookup(struct svc_rqst *rqstp, struct nfsd3_diropargs *argp,
-					  struct nfsd3_diropres  *resp)
+nfsd3_proc_lookup(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_diropargs *argp = _argp;
+	struct nfsd3_diropres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: LOOKUP(3)   %s %.*s\n",
@@ -105,9 +108,10 @@ nfsd3_proc_lookup(struct svc_rqst *rqstp, struct nfsd3_diropargs *argp,
  * Check file access
  */
 static __be32
-nfsd3_proc_access(struct svc_rqst *rqstp, struct nfsd3_accessargs *argp,
-					  struct nfsd3_accessres *resp)
+nfsd3_proc_access(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_accessargs *argp = _argp;
+	struct nfsd3_accessres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: ACCESS(3)   %s 0x%x\n",
@@ -124,9 +128,10 @@ nfsd3_proc_access(struct svc_rqst *rqstp, struct nfsd3_accessargs *argp,
  * Read a symlink.
  */
 static __be32
-nfsd3_proc_readlink(struct svc_rqst *rqstp, struct nfsd3_readlinkargs *argp,
-					   struct nfsd3_readlinkres *resp)
+nfsd3_proc_readlink(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_readlinkargs *argp = _argp;
+	struct nfsd3_readlinkres *resp = _resp;
 	__be32 nfserr;
 
 	dprintk("nfsd: READLINK(3) %s\n", SVCFH_fmt(&argp->fh));
@@ -142,9 +147,10 @@ nfsd3_proc_readlink(struct svc_rqst *rqstp, struct nfsd3_readlinkargs *argp,
  * Read a portion of a file.
  */
 static __be32
-nfsd3_proc_read(struct svc_rqst *rqstp, struct nfsd3_readargs *argp,
-				        struct nfsd3_readres  *resp)
+nfsd3_proc_read(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_readargs *argp = _argp;
+	struct nfsd3_readres  *resp = _resp;
 	__be32	nfserr;
 	u32	max_blocksize = svc_max_payload(rqstp);
 	unsigned long cnt = min(argp->count, max_blocksize);
@@ -179,9 +185,10 @@ nfsd3_proc_read(struct svc_rqst *rqstp, struct nfsd3_readargs *argp,
  * Write data to a file
  */
 static __be32
-nfsd3_proc_write(struct svc_rqst *rqstp, struct nfsd3_writeargs *argp,
-					 struct nfsd3_writeres  *resp)
+nfsd3_proc_write(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_writeargs *argp = _argp;
+	struct nfsd3_writeres *resp = _resp;
 	__be32	nfserr;
 	unsigned long cnt = argp->len;
 
@@ -208,9 +215,10 @@ nfsd3_proc_write(struct svc_rqst *rqstp, struct nfsd3_writeargs *argp,
  * first reports about SunOS compatibility problems start to pour in...
  */
 static __be32
-nfsd3_proc_create(struct svc_rqst *rqstp, struct nfsd3_createargs *argp,
-					  struct nfsd3_diropres   *resp)
+nfsd3_proc_create(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_createargs *argp = _argp;
+	struct nfsd3_diropres *resp = _resp;
 	svc_fh		*dirfhp, *newfhp = NULL;
 	struct iattr	*attr;
 	__be32		nfserr;
@@ -245,9 +253,10 @@ nfsd3_proc_create(struct svc_rqst *rqstp, struct nfsd3_createargs *argp,
  * Make directory. This operation is not idempotent.
  */
 static __be32
-nfsd3_proc_mkdir(struct svc_rqst *rqstp, struct nfsd3_createargs *argp,
-					 struct nfsd3_diropres   *resp)
+nfsd3_proc_mkdir(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_createargs *argp = _argp;
+	struct nfsd3_diropres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: MKDIR(3)    %s %.*s\n",
@@ -265,9 +274,10 @@ nfsd3_proc_mkdir(struct svc_rqst *rqstp, struct nfsd3_createargs *argp,
 }
 
 static __be32
-nfsd3_proc_symlink(struct svc_rqst *rqstp, struct nfsd3_symlinkargs *argp,
-					   struct nfsd3_diropres    *resp)
+nfsd3_proc_symlink(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_symlinkargs *argp = _argp;
+	struct nfsd3_diropres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: SYMLINK(3)  %s %.*s -> %.*s\n",
@@ -286,9 +296,10 @@ nfsd3_proc_symlink(struct svc_rqst *rqstp, struct nfsd3_symlinkargs *argp,
  * Make socket/fifo/device.
  */
 static __be32
-nfsd3_proc_mknod(struct svc_rqst *rqstp, struct nfsd3_mknodargs *argp,
-					 struct nfsd3_diropres  *resp)
+nfsd3_proc_mknod(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_mknodargs *argp = _argp;
+	struct nfsd3_diropres *resp = _resp;
 	__be32	nfserr;
 	int type;
 	dev_t	rdev = 0;
@@ -323,9 +334,10 @@ nfsd3_proc_mknod(struct svc_rqst *rqstp, struct nfsd3_mknodargs *argp,
  * Remove file/fifo/socket etc.
  */
 static __be32
-nfsd3_proc_remove(struct svc_rqst *rqstp, struct nfsd3_diropargs *argp,
-					  struct nfsd3_attrstat  *resp)
+nfsd3_proc_remove(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_diropargs *argp = _argp;
+	struct nfsd3_attrstat *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: REMOVE(3)   %s %.*s\n",
@@ -344,9 +356,10 @@ nfsd3_proc_remove(struct svc_rqst *rqstp, struct nfsd3_diropargs *argp,
  * Remove a directory
  */
 static __be32
-nfsd3_proc_rmdir(struct svc_rqst *rqstp, struct nfsd3_diropargs *argp,
-					 struct nfsd3_attrstat  *resp)
+nfsd3_proc_rmdir(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_diropargs *argp = _argp;
+	struct nfsd3_attrstat *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: RMDIR(3)    %s %.*s\n",
@@ -361,9 +374,10 @@ nfsd3_proc_rmdir(struct svc_rqst *rqstp, struct nfsd3_diropargs *argp,
 }
 
 static __be32
-nfsd3_proc_rename(struct svc_rqst *rqstp, struct nfsd3_renameargs *argp,
-					  struct nfsd3_renameres  *resp)
+nfsd3_proc_rename(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_renameargs *argp = _argp;
+	struct nfsd3_renameres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: RENAME(3)   %s %.*s ->\n",
@@ -383,9 +397,10 @@ nfsd3_proc_rename(struct svc_rqst *rqstp, struct nfsd3_renameargs *argp,
 }
 
 static __be32
-nfsd3_proc_link(struct svc_rqst *rqstp, struct nfsd3_linkargs *argp,
-					struct nfsd3_linkres  *resp)
+nfsd3_proc_link(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_linkargs *argp = _argp;
+	struct nfsd3_linkres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: LINK(3)     %s ->\n",
@@ -406,9 +421,10 @@ nfsd3_proc_link(struct svc_rqst *rqstp, struct nfsd3_linkargs *argp,
  * Read a portion of a directory.
  */
 static __be32
-nfsd3_proc_readdir(struct svc_rqst *rqstp, struct nfsd3_readdirargs *argp,
-					   struct nfsd3_readdirres  *resp)
+nfsd3_proc_readdir(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_readdirargs *argp = _argp;
+	struct nfsd3_readdirres  *resp = _resp;
 	__be32		nfserr;
 	int		count;
 
@@ -442,9 +458,10 @@ nfsd3_proc_readdir(struct svc_rqst *rqstp, struct nfsd3_readdirargs *argp,
  * For now, we choose to ignore the dircount parameter.
  */
 static __be32
-nfsd3_proc_readdirplus(struct svc_rqst *rqstp, struct nfsd3_readdirargs *argp,
-					       struct nfsd3_readdirres  *resp)
+nfsd3_proc_readdirplus(struct svc_rqst *rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_readdirargs *argp = _argp;
+	struct nfsd3_readdirres  *resp = _resp;
 	__be32	nfserr;
 	int	count = 0;
 	loff_t	offset;
@@ -509,9 +526,10 @@ nfsd3_proc_readdirplus(struct svc_rqst *rqstp, struct nfsd3_readdirargs *argp,
  * Get file system stats
  */
 static __be32
-nfsd3_proc_fsstat(struct svc_rqst * rqstp, struct nfsd_fhandle    *argp,
-					   struct nfsd3_fsstatres *resp)
+nfsd3_proc_fsstat(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd_fhandle *argp = _argp;
+	struct nfsd3_fsstatres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: FSSTAT(3)   %s\n",
@@ -526,9 +544,10 @@ nfsd3_proc_fsstat(struct svc_rqst * rqstp, struct nfsd_fhandle    *argp,
  * Get file system info
  */
 static __be32
-nfsd3_proc_fsinfo(struct svc_rqst * rqstp, struct nfsd_fhandle    *argp,
-					   struct nfsd3_fsinfores *resp)
+nfsd3_proc_fsinfo(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd_fhandle *argp = _argp;
+	struct nfsd3_fsinfores *resp = _resp;
 	__be32	nfserr;
 	u32	max_blocksize = svc_max_payload(rqstp);
 
@@ -569,9 +588,10 @@ nfsd3_proc_fsinfo(struct svc_rqst * rqstp, struct nfsd_fhandle    *argp,
  * Get pathconf info for the specified file
  */
 static __be32
-nfsd3_proc_pathconf(struct svc_rqst * rqstp, struct nfsd_fhandle      *argp,
-					     struct nfsd3_pathconfres *resp)
+nfsd3_proc_pathconf(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd_fhandle *argp =  _argp;
+	struct nfsd3_pathconfres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: PATHCONF(3) %s\n",
@@ -612,9 +632,10 @@ nfsd3_proc_pathconf(struct svc_rqst * rqstp, struct nfsd_fhandle      *argp,
  * Commit a file (range) to stable storage.
  */
 static __be32
-nfsd3_proc_commit(struct svc_rqst * rqstp, struct nfsd3_commitargs *argp,
-					   struct nfsd3_commitres  *resp)
+nfsd3_proc_commit(struct svc_rqst * rqstp, void *_argp, void *_resp)
 {
+	struct nfsd3_commitargs *argp = _argp;
+	struct nfsd3_commitres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: COMMIT(3)   %s %u@%Lu\n",
@@ -669,213 +690,213 @@ struct nfsd3_voidargs { int dummy; };
 
 static struct svc_procedure		nfsd_procedures3[22] = {
 	[NFS3PROC_NULL] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_null,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_voidres,
+		.pc_func = nfsd3_proc_null,
+		.pc_encode = nfs3svc_encode_voidres,
 		.pc_argsize = sizeof(struct nfsd3_voidargs),
 		.pc_ressize = sizeof(struct nfsd3_voidres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST,
 	},
 	[NFS3PROC_GETATTR] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_getattr,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_fhandleargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_attrstatres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_getattr,
+		.pc_decode = nfs3svc_decode_fhandleargs,
+		.pc_encode = nfs3svc_encode_attrstatres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_fhandleargs),
 		.pc_ressize = sizeof(struct nfsd3_attrstatres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+AT,
 	},
 	[NFS3PROC_SETATTR] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_setattr,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_sattrargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_wccstatres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_setattr,
+		.pc_decode = nfs3svc_decode_sattrargs,
+		.pc_encode = nfs3svc_encode_wccstatres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_sattrargs),
 		.pc_ressize = sizeof(struct nfsd3_wccstatres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+WC,
 	},
 	[NFS3PROC_LOOKUP] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_lookup,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_diropargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_diropres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle2,
+		.pc_func = nfsd3_proc_lookup,
+		.pc_decode = nfs3svc_decode_diropargs,
+		.pc_encode = nfs3svc_encode_diropres,
+		.pc_release = nfs3svc_release_fhandle2,
 		.pc_argsize = sizeof(struct nfsd3_diropargs),
 		.pc_ressize = sizeof(struct nfsd3_diropres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+FH+pAT+pAT,
 	},
 	[NFS3PROC_ACCESS] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_access,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_accessargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_accessres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_access,
+		.pc_decode = nfs3svc_decode_accessargs,
+		.pc_encode = nfs3svc_encode_accessres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_accessargs),
 		.pc_ressize = sizeof(struct nfsd3_accessres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+pAT+1,
 	},
 	[NFS3PROC_READLINK] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_readlink,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_readlinkargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_readlinkres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_readlink,
+		.pc_decode = nfs3svc_decode_readlinkargs,
+		.pc_encode = nfs3svc_encode_readlinkres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_readlinkargs),
 		.pc_ressize = sizeof(struct nfsd3_readlinkres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+pAT+1+NFS3_MAXPATHLEN/4,
 	},
 	[NFS3PROC_READ] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_read,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_readargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_readres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_read,
+		.pc_decode = nfs3svc_decode_readargs,
+		.pc_encode = nfs3svc_encode_readres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_readargs),
 		.pc_ressize = sizeof(struct nfsd3_readres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+pAT+4+NFSSVC_MAXBLKSIZE/4,
 	},
 	[NFS3PROC_WRITE] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_write,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_writeargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_writeres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_write,
+		.pc_decode = nfs3svc_decode_writeargs,
+		.pc_encode = nfs3svc_encode_writeres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_writeargs),
 		.pc_ressize = sizeof(struct nfsd3_writeres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+WC+4,
 	},
 	[NFS3PROC_CREATE] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_create,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_createargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_createres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle2,
+		.pc_func = nfsd3_proc_create,
+		.pc_decode = nfs3svc_decode_createargs,
+		.pc_encode = nfs3svc_encode_createres,
+		.pc_release = nfs3svc_release_fhandle2,
 		.pc_argsize = sizeof(struct nfsd3_createargs),
 		.pc_ressize = sizeof(struct nfsd3_createres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+(1+FH+pAT)+WC,
 	},
 	[NFS3PROC_MKDIR] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_mkdir,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_mkdirargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_createres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle2,
+		.pc_func = nfsd3_proc_mkdir,
+		.pc_decode = nfs3svc_decode_mkdirargs,
+		.pc_encode = nfs3svc_encode_createres,
+		.pc_release = nfs3svc_release_fhandle2,
 		.pc_argsize = sizeof(struct nfsd3_mkdirargs),
 		.pc_ressize = sizeof(struct nfsd3_createres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+(1+FH+pAT)+WC,
 	},
 	[NFS3PROC_SYMLINK] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_symlink,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_symlinkargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_createres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle2,
+		.pc_func = nfsd3_proc_symlink,
+		.pc_decode = nfs3svc_decode_symlinkargs,
+		.pc_encode = nfs3svc_encode_createres,
+		.pc_release = nfs3svc_release_fhandle2,
 		.pc_argsize = sizeof(struct nfsd3_symlinkargs),
 		.pc_ressize = sizeof(struct nfsd3_createres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+(1+FH+pAT)+WC,
 	},
 	[NFS3PROC_MKNOD] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_mknod,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_mknodargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_createres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle2,
+		.pc_func = nfsd3_proc_mknod,
+		.pc_decode = nfs3svc_decode_mknodargs,
+		.pc_encode = nfs3svc_encode_createres,
+		.pc_release = nfs3svc_release_fhandle2,
 		.pc_argsize = sizeof(struct nfsd3_mknodargs),
 		.pc_ressize = sizeof(struct nfsd3_createres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+(1+FH+pAT)+WC,
 	},
 	[NFS3PROC_REMOVE] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_remove,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_diropargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_wccstatres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_remove,
+		.pc_decode = nfs3svc_decode_diropargs,
+		.pc_encode = nfs3svc_encode_wccstatres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_diropargs),
 		.pc_ressize = sizeof(struct nfsd3_wccstatres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+WC,
 	},
 	[NFS3PROC_RMDIR] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_rmdir,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_diropargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_wccstatres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_rmdir,
+		.pc_decode = nfs3svc_decode_diropargs,
+		.pc_encode = nfs3svc_encode_wccstatres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_diropargs),
 		.pc_ressize = sizeof(struct nfsd3_wccstatres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+WC,
 	},
 	[NFS3PROC_RENAME] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_rename,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_renameargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_renameres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle2,
+		.pc_func = nfsd3_proc_rename,
+		.pc_decode = nfs3svc_decode_renameargs,
+		.pc_encode = nfs3svc_encode_renameres,
+		.pc_release = nfs3svc_release_fhandle2,
 		.pc_argsize = sizeof(struct nfsd3_renameargs),
 		.pc_ressize = sizeof(struct nfsd3_renameres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+WC+WC,
 	},
 	[NFS3PROC_LINK] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_link,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_linkargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_linkres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle2,
+		.pc_func = nfsd3_proc_link,
+		.pc_decode = nfs3svc_decode_linkargs,
+		.pc_encode = nfs3svc_encode_linkres,
+		.pc_release = nfs3svc_release_fhandle2,
 		.pc_argsize = sizeof(struct nfsd3_linkargs),
 		.pc_ressize = sizeof(struct nfsd3_linkres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+pAT+WC,
 	},
 	[NFS3PROC_READDIR] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_readdir,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_readdirargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_readdirres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_readdir,
+		.pc_decode = nfs3svc_decode_readdirargs,
+		.pc_encode = nfs3svc_encode_readdirres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_readdirargs),
 		.pc_ressize = sizeof(struct nfsd3_readdirres),
 		.pc_cachetype = RC_NOCACHE,
 	},
 	[NFS3PROC_READDIRPLUS] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_readdirplus,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_readdirplusargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_readdirres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_readdirplus,
+		.pc_decode = nfs3svc_decode_readdirplusargs,
+		.pc_encode = nfs3svc_encode_readdirres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_readdirplusargs),
 		.pc_ressize = sizeof(struct nfsd3_readdirres),
 		.pc_cachetype = RC_NOCACHE,
 	},
 	[NFS3PROC_FSSTAT] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_fsstat,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_fhandleargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_fsstatres,
+		.pc_func = nfsd3_proc_fsstat,
+		.pc_decode = nfs3svc_decode_fhandleargs,
+		.pc_encode = nfs3svc_encode_fsstatres,
 		.pc_argsize = sizeof(struct nfsd3_fhandleargs),
 		.pc_ressize = sizeof(struct nfsd3_fsstatres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+pAT+2*6+1,
 	},
 	[NFS3PROC_FSINFO] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_fsinfo,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_fhandleargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_fsinfores,
+		.pc_func = nfsd3_proc_fsinfo,
+		.pc_decode = nfs3svc_decode_fhandleargs,
+		.pc_encode = nfs3svc_encode_fsinfores,
 		.pc_argsize = sizeof(struct nfsd3_fhandleargs),
 		.pc_ressize = sizeof(struct nfsd3_fsinfores),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+pAT+12,
 	},
 	[NFS3PROC_PATHCONF] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_pathconf,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_fhandleargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_pathconfres,
+		.pc_func = nfsd3_proc_pathconf,
+		.pc_decode = nfs3svc_decode_fhandleargs,
+		.pc_encode = nfs3svc_encode_pathconfres,
 		.pc_argsize = sizeof(struct nfsd3_fhandleargs),
 		.pc_ressize = sizeof(struct nfsd3_pathconfres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+pAT+6,
 	},
 	[NFS3PROC_COMMIT] = {
-		.pc_func = (svc_procfunc) nfsd3_proc_commit,
-		.pc_decode = (kxdrproc_t) nfs3svc_decode_commitargs,
-		.pc_encode = (kxdrproc_t) nfs3svc_encode_commitres,
-		.pc_release = (kxdrproc_t) nfs3svc_release_fhandle,
+		.pc_func = nfsd3_proc_commit,
+		.pc_decode = nfs3svc_decode_commitargs,
+		.pc_encode = nfs3svc_encode_commitres,
+		.pc_release = nfs3svc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd3_commitargs),
 		.pc_ressize = sizeof(struct nfsd3_commitres),
 		.pc_cachetype = RC_NOCACHE,
diff --git a/fs/nfsd/nfs3xdr.c b/fs/nfsd/nfs3xdr.c
index dba2ff8ea..9ac9ebab5 100644
--- a/fs/nfsd/nfs3xdr.c
+++ b/fs/nfsd/nfs3xdr.c
@@ -273,8 +273,10 @@ void fill_post_wcc(struct svc_fh *fhp)
  * XDR decode functions
  */
 int
-nfs3svc_decode_fhandle(struct svc_rqst *rqstp, __be32 *p, struct nfsd_fhandle *args)
+nfs3svc_decode_fhandle(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_fhandle *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -282,9 +284,10 @@ nfs3svc_decode_fhandle(struct svc_rqst *rqstp, __be32 *p, struct nfsd_fhandle *a
 }
 
 int
-nfs3svc_decode_sattrargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_sattrargs *args)
+nfs3svc_decode_sattrargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_sattrargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -300,9 +303,10 @@ nfs3svc_decode_sattrargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_diropargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_diropargs *args)
+nfs3svc_decode_diropargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_diropargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->fh))
 	 || !(p = decode_filename(p, &args->name, &args->len)))
 		return 0;
@@ -311,9 +315,10 @@ nfs3svc_decode_diropargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_accessargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_accessargs *args)
+nfs3svc_decode_accessargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_accessargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -323,9 +328,10 @@ nfs3svc_decode_accessargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_readargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_readargs *args)
+nfs3svc_decode_readargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_readargs *args = _args;
 	unsigned int len;
 	int v;
 	u32 max_blocksize = svc_max_payload(rqstp);
@@ -353,9 +359,10 @@ nfs3svc_decode_readargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_writeargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_writeargs *args)
+nfs3svc_decode_writeargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_writeargs *args = _args;
 	unsigned int len, v, hdr, dlen;
 	u32 max_blocksize = svc_max_payload(rqstp);
 
@@ -410,9 +417,11 @@ nfs3svc_decode_writeargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_createargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_createargs *args)
+nfs3svc_decode_createargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_createargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->fh))
 	 || !(p = decode_filename(p, &args->name, &args->len)))
 		return 0;
@@ -433,9 +442,10 @@ nfs3svc_decode_createargs(struct svc_rqst *rqstp, __be32 *p,
 	return xdr_argsize_check(rqstp, p);
 }
 int
-nfs3svc_decode_mkdirargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_createargs *args)
+nfs3svc_decode_mkdirargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_createargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->fh)) ||
 	    !(p = decode_filename(p, &args->name, &args->len)))
 		return 0;
@@ -445,9 +455,10 @@ nfs3svc_decode_mkdirargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_symlinkargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_symlinkargs *args)
+nfs3svc_decode_symlinkargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_symlinkargs *args = _args;
 	unsigned int len, avail;
 	char *old, *new;
 	struct kvec *vec;
@@ -495,9 +506,10 @@ nfs3svc_decode_symlinkargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_mknodargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_mknodargs *args)
+nfs3svc_decode_mknodargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_mknodargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->fh))
 	 || !(p = decode_filename(p, &args->name, &args->len)))
 		return 0;
@@ -517,9 +529,10 @@ nfs3svc_decode_mknodargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_renameargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_renameargs *args)
+nfs3svc_decode_renameargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_renameargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->ffh))
 	 || !(p = decode_filename(p, &args->fname, &args->flen))
 	 || !(p = decode_fh(p, &args->tfh))
@@ -530,9 +543,11 @@ nfs3svc_decode_renameargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_readlinkargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_readlinkargs *args)
+nfs3svc_decode_readlinkargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_readlinkargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -542,9 +557,10 @@ nfs3svc_decode_readlinkargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_linkargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_linkargs *args)
+nfs3svc_decode_linkargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_linkargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->ffh))
 	 || !(p = decode_fh(p, &args->tfh))
 	 || !(p = decode_filename(p, &args->tname, &args->tlen)))
@@ -554,9 +570,11 @@ nfs3svc_decode_linkargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_readdirargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_readdirargs *args)
+nfs3svc_decode_readdirargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_readdirargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -571,9 +589,10 @@ nfs3svc_decode_readdirargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_readdirplusargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_readdirargs *args)
+nfs3svc_decode_readdirplusargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_readdirargs *args = _args;
 	int len;
 	u32 max_blocksize = svc_max_payload(rqstp);
 
@@ -597,9 +616,10 @@ nfs3svc_decode_readdirplusargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfs3svc_decode_commitargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_commitargs *args)
+nfs3svc_decode_commitargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd3_commitargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -617,16 +637,17 @@ nfs3svc_decode_commitargs(struct svc_rqst *rqstp, __be32 *p,
  * will work properly.
  */
 int
-nfs3svc_encode_voidres(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nfs3svc_encode_voidres(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_ressize_check(rqstp, p);
 }
 
 /* GETATTR */
 int
-nfs3svc_encode_attrstat(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_attrstat *resp)
+nfs3svc_encode_attrstat(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_attrstat *resp = _resp;
+
 	if (resp->status == 0) {
 		lease_get_mtime(d_inode(resp->fh.fh_dentry),
 				&resp->stat.mtime);
@@ -637,18 +658,20 @@ nfs3svc_encode_attrstat(struct svc_rqst *rqstp, __be32 *p,
 
 /* SETATTR, REMOVE, RMDIR */
 int
-nfs3svc_encode_wccstat(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_attrstat *resp)
+nfs3svc_encode_wccstat(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_attrstat *resp = _resp;
+
 	p = encode_wcc_data(rqstp, p, &resp->fh);
 	return xdr_ressize_check(rqstp, p);
 }
 
 /* LOOKUP */
 int
-nfs3svc_encode_diropres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_diropres *resp)
+nfs3svc_encode_diropres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_diropres *resp = _resp;
+
 	if (resp->status == 0) {
 		p = encode_fh(p, &resp->fh);
 		p = encode_post_op_attr(rqstp, p, &resp->fh);
@@ -659,9 +682,10 @@ nfs3svc_encode_diropres(struct svc_rqst *rqstp, __be32 *p,
 
 /* ACCESS */
 int
-nfs3svc_encode_accessres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_accessres *resp)
+nfs3svc_encode_accessres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_accessres *resp = _resp;
+
 	p = encode_post_op_attr(rqstp, p, &resp->fh);
 	if (resp->status == 0)
 		*p++ = htonl(resp->access);
@@ -670,9 +694,11 @@ nfs3svc_encode_accessres(struct svc_rqst *rqstp, __be32 *p,
 
 /* READLINK */
 int
-nfs3svc_encode_readlinkres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_readlinkres *resp)
+nfs3svc_encode_readlinkres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_readlinkres *resp = _resp;
+
 	p = encode_post_op_attr(rqstp, p, &resp->fh);
 	if (resp->status == 0) {
 		*p++ = htonl(resp->len);
@@ -691,9 +717,11 @@ nfs3svc_encode_readlinkres(struct svc_rqst *rqstp, __be32 *p,
 
 /* READ */
 int
-nfs3svc_encode_readres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_readres *resp)
+nfs3svc_encode_readres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_readres *resp = _resp;
+
 	p = encode_post_op_attr(rqstp, p, &resp->fh);
 	if (resp->status == 0) {
 		*p++ = htonl(resp->count);
@@ -715,9 +743,10 @@ nfs3svc_encode_readres(struct svc_rqst *rqstp, __be32 *p,
 
 /* WRITE */
 int
-nfs3svc_encode_writeres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_writeres *resp)
+nfs3svc_encode_writeres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_writeres *resp = _resp;
 	struct nfsd_net *nn = net_generic(SVC_NET(rqstp), nfsd_net_id);
 
 	p = encode_wcc_data(rqstp, p, &resp->fh);
@@ -732,9 +761,10 @@ nfs3svc_encode_writeres(struct svc_rqst *rqstp, __be32 *p,
 
 /* CREATE, MKDIR, SYMLINK, MKNOD */
 int
-nfs3svc_encode_createres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_diropres *resp)
+nfs3svc_encode_createres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_diropres *resp = _resp;
+
 	if (resp->status == 0) {
 		*p++ = xdr_one;
 		p = encode_fh(p, &resp->fh);
@@ -746,9 +776,10 @@ nfs3svc_encode_createres(struct svc_rqst *rqstp, __be32 *p,
 
 /* RENAME */
 int
-nfs3svc_encode_renameres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_renameres *resp)
+nfs3svc_encode_renameres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_renameres *resp = _resp;
+
 	p = encode_wcc_data(rqstp, p, &resp->ffh);
 	p = encode_wcc_data(rqstp, p, &resp->tfh);
 	return xdr_ressize_check(rqstp, p);
@@ -756,9 +787,10 @@ nfs3svc_encode_renameres(struct svc_rqst *rqstp, __be32 *p,
 
 /* LINK */
 int
-nfs3svc_encode_linkres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_linkres *resp)
+nfs3svc_encode_linkres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_linkres *resp = _resp;
+
 	p = encode_post_op_attr(rqstp, p, &resp->fh);
 	p = encode_wcc_data(rqstp, p, &resp->tfh);
 	return xdr_ressize_check(rqstp, p);
@@ -766,9 +798,11 @@ nfs3svc_encode_linkres(struct svc_rqst *rqstp, __be32 *p,
 
 /* READDIR */
 int
-nfs3svc_encode_readdirres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_readdirres *resp)
+nfs3svc_encode_readdirres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_readdirres *resp = _resp;
+
 	p = encode_post_op_attr(rqstp, p, &resp->fh);
 
 	if (resp->status == 0) {
@@ -1016,9 +1050,9 @@ nfs3svc_encode_entry_plus(void *cd, const char *name,
 
 /* FSSTAT */
 int
-nfs3svc_encode_fsstatres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_fsstatres *resp)
+nfs3svc_encode_fsstatres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_fsstatres *resp = _resp;
 	struct kstatfs	*s = &resp->stats;
 	u64		bs = s->f_bsize;
 
@@ -1038,9 +1072,10 @@ nfs3svc_encode_fsstatres(struct svc_rqst *rqstp, __be32 *p,
 
 /* FSINFO */
 int
-nfs3svc_encode_fsinfores(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_fsinfores *resp)
+nfs3svc_encode_fsinfores(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_fsinfores *resp = _resp;
+
 	*p++ = xdr_zero;	/* no post_op_attr */
 
 	if (resp->status == 0) {
@@ -1062,9 +1097,10 @@ nfs3svc_encode_fsinfores(struct svc_rqst *rqstp, __be32 *p,
 
 /* PATHCONF */
 int
-nfs3svc_encode_pathconfres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_pathconfres *resp)
+nfs3svc_encode_pathconfres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_pathconfres *resp = _resp;
+
 	*p++ = xdr_zero;	/* no post_op_attr */
 
 	if (resp->status == 0) {
@@ -1081,9 +1117,10 @@ nfs3svc_encode_pathconfres(struct svc_rqst *rqstp, __be32 *p,
 
 /* COMMIT */
 int
-nfs3svc_encode_commitres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_commitres *resp)
+nfs3svc_encode_commitres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd3_commitres *resp = _resp;
 	struct nfsd_net *nn = net_generic(SVC_NET(rqstp), nfsd_net_id);
 
 	p = encode_wcc_data(rqstp, p, &resp->fh);
@@ -1099,17 +1136,19 @@ nfs3svc_encode_commitres(struct svc_rqst *rqstp, __be32 *p,
  * XDR release functions
  */
 int
-nfs3svc_release_fhandle(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_attrstat *resp)
+nfs3svc_release_fhandle(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_attrstat *resp = _resp;
+
 	fh_put(&resp->fh);
 	return 1;
 }
 
 int
-nfs3svc_release_fhandle2(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd3_fhandle_pair *resp)
+nfs3svc_release_fhandle2(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd3_fhandle_pair *resp = _resp;
+
 	fh_put(&resp->fh1);
 	fh_put(&resp->fh2);
 	return 1;
diff --git a/fs/nfsd/nfs4callback.c b/fs/nfsd/nfs4callback.c
index 04c68d900..cc49866fe 100644
--- a/fs/nfsd/nfs4callback.c
+++ b/fs/nfsd/nfs4callback.c
@@ -470,8 +470,7 @@ static int decode_cb_sequence4res(struct xdr_stream *xdr,
 /*
  * NB: Without this zero space reservation, callbacks over krb5p fail
  */
-static void nfs4_xdr_enc_cb_null(struct rpc_rqst *req, struct xdr_stream *xdr,
-				 void *__unused)
+static void nfs4_xdr_enc_cb_null(void *req, struct xdr_stream *xdr, void *__unused)
 {
 	xdr_reserve_space(xdr, 0);
 }
@@ -479,9 +478,9 @@ static void nfs4_xdr_enc_cb_null(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * 20.2. Operation 4: CB_RECALL - Recall a Delegation
  */
-static void nfs4_xdr_enc_cb_recall(struct rpc_rqst *req, struct xdr_stream *xdr,
-				   const struct nfsd4_callback *cb)
+static void nfs4_xdr_enc_cb_recall(void *req, struct xdr_stream *xdr, void *_cb)
 {
+	const struct nfsd4_callback *cb = _cb;
 	const struct nfs4_delegation *dp = cb_to_delegation(cb);
 	struct nfs4_cb_compound_hdr hdr = {
 		.ident = cb->cb_clp->cl_cb_ident,
@@ -504,8 +503,7 @@ static void nfs4_xdr_enc_cb_recall(struct rpc_rqst *req, struct xdr_stream *xdr,
  * Protocol".
  */
 
-static int nfs4_xdr_dec_cb_null(struct rpc_rqst *req, struct xdr_stream *xdr,
-				void *__unused)
+static int nfs4_xdr_dec_cb_null(void *req, struct xdr_stream *xdr, void *__unused)
 {
 	return 0;
 }
@@ -513,10 +511,11 @@ static int nfs4_xdr_dec_cb_null(struct rpc_rqst *req, struct xdr_stream *xdr,
 /*
  * 20.2. Operation 4: CB_RECALL - Recall a Delegation
  */
-static int nfs4_xdr_dec_cb_recall(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_cb_recall(void *rqstp,
 				  struct xdr_stream *xdr,
-				  struct nfsd4_callback *cb)
+				  void *_cb)
 {
+	struct nfsd4_callback *cb = _cb;
 	struct nfs4_cb_compound_hdr hdr;
 	int status;
 
@@ -586,10 +585,12 @@ static void encode_cb_layout4args(struct xdr_stream *xdr,
 	hdr->nops++;
 }
 
-static void nfs4_xdr_enc_cb_layout(struct rpc_rqst *req,
+static void nfs4_xdr_enc_cb_layout(void *_req,
 				   struct xdr_stream *xdr,
-				   const struct nfsd4_callback *cb)
+				   void *_cb)
 {
+	struct rpc_rqst *req = _req;
+	const struct nfsd4_callback *cb = _cb;
 	const struct nfs4_layout_stateid *ls =
 		container_of(cb, struct nfs4_layout_stateid, ls_recall);
 	struct nfs4_cb_compound_hdr hdr = {
@@ -603,10 +604,12 @@ static void nfs4_xdr_enc_cb_layout(struct rpc_rqst *req,
 	encode_cb_nops(&hdr);
 }
 
-static int nfs4_xdr_dec_cb_layout(struct rpc_rqst *rqstp,
+static int nfs4_xdr_dec_cb_layout(void *_rqstp,
 				  struct xdr_stream *xdr,
-				  struct nfsd4_callback *cb)
+				  void *_cb)
 {
+	struct rpc_rqst *rqstp = _rqstp;
+	struct nfsd4_callback *cb = _cb;
 	struct nfs4_cb_compound_hdr hdr;
 	int status;
 
@@ -629,8 +632,8 @@ static int nfs4_xdr_dec_cb_layout(struct rpc_rqst *rqstp,
 #define PROC(proc, call, argtype, restype)				\
 [NFSPROC4_CLNT_##proc] = {						\
 	.p_proc    = NFSPROC4_CB_##call,				\
-	.p_encode  = (kxdreproc_t)nfs4_xdr_enc_##argtype,		\
-	.p_decode  = (kxdrdproc_t)nfs4_xdr_dec_##restype,		\
+	.p_encode  = nfs4_xdr_enc_##argtype,			\
+	.p_decode  = nfs4_xdr_dec_##restype,			\
 	.p_arglen  = NFS4_enc_##argtype##_sz,				\
 	.p_replen  = NFS4_dec_##restype##_sz,				\
 	.p_statidx = NFSPROC4_CB_##call,				\
diff --git a/fs/nfsd/nfs4proc.c b/fs/nfsd/nfs4proc.c
index 1fb222752..150c1455e 100644
--- a/fs/nfsd/nfs4proc.c
+++ b/fs/nfsd/nfs4proc.c
@@ -358,8 +358,9 @@ copy_clientid(clientid_t *clid, struct nfsd4_session *session)
 
 static __be32
 nfsd4_open(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	   struct nfsd4_open *open)
+	   void *_open)
 {
+	struct nfsd4_open *open = _open;
 	__be32 status;
 	struct svc_fh *resfh = NULL;
 	struct net *net = SVC_NET(rqstp);
@@ -496,8 +497,10 @@ static __be32 nfsd4_open_omfg(struct svc_rqst *rqstp, struct nfsd4_compound_stat
  */
 static __be32
 nfsd4_getfh(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	    struct svc_fh **getfh)
+	    void *_getfh)
 {
+	struct svc_fh **getfh = (struct svc_fh **)_getfh;
+
 	if (!cstate->current_fh.fh_dentry)
 		return nfserr_nofilehandle;
 
@@ -507,8 +510,10 @@ nfsd4_getfh(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_putfh(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	    struct nfsd4_putfh *putfh)
+	    void *_putfh)
 {
+	struct nfsd4_putfh *putfh = _putfh;
+
 	fh_put(&cstate->current_fh);
 	cstate->current_fh.fh_handle.fh_size = putfh->pf_fhlen;
 	memcpy(&cstate->current_fh.fh_handle.fh_base, putfh->pf_fhval,
@@ -562,8 +567,10 @@ nfsd4_savefh(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
  */
 static __be32
 nfsd4_access(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_access *access)
+	     void *_access)
 {
+	struct nfsd4_access *access = _access;
+
 	if (access->ac_req_access & ~NFS3_ACCESS_FULL)
 		return nfserr_inval;
 
@@ -588,8 +595,10 @@ static void gen_boot_verifier(nfs4_verifier *verifier, struct net *net)
 
 static __be32
 nfsd4_commit(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_commit *commit)
+	     void *_commit)
 {
+	struct nfsd4_commit *commit = _commit;
+
 	gen_boot_verifier(&commit->co_verf, SVC_NET(rqstp));
 	return nfsd_commit(rqstp, &cstate->current_fh, commit->co_offset,
 			     commit->co_count);
@@ -597,8 +606,9 @@ nfsd4_commit(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_create(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_create *create)
+	     void *_create)
 {
+	struct nfsd4_create *create = _create;
 	struct svc_fh resfh;
 	__be32 status;
 	dev_t rdev;
@@ -684,8 +694,9 @@ out:
 
 static __be32
 nfsd4_getattr(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	      struct nfsd4_getattr *getattr)
+	      void *_getattr)
 {
+	struct nfsd4_getattr *getattr = _getattr;
 	__be32 status;
 
 	status = fh_verify(rqstp, &cstate->current_fh, 0, NFSD_MAY_NOP);
@@ -705,8 +716,9 @@ nfsd4_getattr(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_link(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	   struct nfsd4_link *link)
+	   void *_link)
 {
+	struct nfsd4_link *link = _link;
 	__be32 status = nfserr_nofilehandle;
 
 	if (!cstate->save_fh.fh_dentry)
@@ -744,8 +756,9 @@ nfsd4_lookupp(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_lookup(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_lookup *lookup)
+	     void *_lookup)
 {
+	struct nfsd4_lookup *lookup = _lookup;
 	return nfsd_lookup(rqstp, &cstate->current_fh,
 			   lookup->lo_name, lookup->lo_len,
 			   &cstate->current_fh);
@@ -753,8 +766,9 @@ nfsd4_lookup(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_read(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	   struct nfsd4_read *read)
+	   void *_read)
 {
+	struct nfsd4_read *read = _read;
 	__be32 status;
 
 	read->rd_filp = NULL;
@@ -789,8 +803,9 @@ out:
 
 static __be32
 nfsd4_readdir(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	      struct nfsd4_readdir *readdir)
+	      void *_readdir)
 {
+	struct nfsd4_readdir *readdir = _readdir;
 	u64 cookie = readdir->rd_cookie;
 	static const nfs4_verifier zeroverf;
 
@@ -814,8 +829,10 @@ nfsd4_readdir(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_readlink(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	       struct nfsd4_readlink *readlink)
+	       void *_readlink)
 {
+	struct nfsd4_readlink *readlink = _readlink;
+
 	readlink->rl_rqstp = rqstp;
 	readlink->rl_fhp = &cstate->current_fh;
 	return nfs_ok;
@@ -823,8 +840,9 @@ nfsd4_readlink(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_remove(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_remove *remove)
+	     void *_remove)
 {
+	struct nfsd4_remove *remove = _remove;
 	__be32 status;
 
 	if (opens_in_grace(SVC_NET(rqstp)))
@@ -840,8 +858,9 @@ nfsd4_remove(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_rename(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_rename *rename)
+	     void *_rename)
 {
+	struct nfsd4_rename *rename = _rename;
 	__be32 status = nfserr_nofilehandle;
 
 	if (!cstate->save_fh.fh_dentry)
@@ -861,8 +880,9 @@ nfsd4_rename(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_secinfo(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	      struct nfsd4_secinfo *secinfo)
+	      void *_secinfo)
 {
+	struct nfsd4_secinfo *secinfo = _secinfo;
 	struct svc_export *exp;
 	struct dentry *dentry;
 	__be32 err;
@@ -890,8 +910,9 @@ nfsd4_secinfo(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_secinfo_no_name(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	      struct nfsd4_secinfo_no_name *sin)
+	      void *_sin)
 {
+	struct nfsd4_secinfo_no_name *sin = _sin;
 	__be32 err;
 
 	switch (sin->sin_style) {
@@ -913,8 +934,9 @@ nfsd4_secinfo_no_name(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstat
 
 static __be32
 nfsd4_setattr(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	      struct nfsd4_setattr *setattr)
+	      void *_setattr)
 {
+	struct nfsd4_setattr *setattr = _setattr;
 	__be32 status = nfs_ok;
 	int err;
 
@@ -974,8 +996,9 @@ static int fill_in_write_vector(struct kvec *vec, struct nfsd4_write *write)
 
 static __be32
 nfsd4_write(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	    struct nfsd4_write *write)
+	    void *_write)
 {
+	struct nfsd4_write *write = _write;
 	stateid_t *stateid = &write->wr_stateid;
 	struct file *filp = NULL;
 	__be32 status = nfs_ok;
@@ -1011,8 +1034,9 @@ nfsd4_write(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_clone(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		struct nfsd4_clone *clone)
+		void *_clone)
 {
+	struct nfsd4_clone *clone = _clone;
 	struct file *src, *dst;
 	__be32 status;
 
@@ -1075,23 +1099,28 @@ nfsd4_fallocate(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_allocate(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	       struct nfsd4_fallocate *fallocate)
+	       void *_fallocate)
 {
+	struct nfsd4_fallocate *fallocate = _fallocate;
+
 	return nfsd4_fallocate(rqstp, cstate, fallocate, 0);
 }
 
 static __be32
 nfsd4_deallocate(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		 struct nfsd4_fallocate *fallocate)
+		 void *_fallocate)
 {
+	struct nfsd4_fallocate *fallocate = _fallocate;
+
 	return nfsd4_fallocate(rqstp, cstate, fallocate,
 			       FALLOC_FL_PUNCH_HOLE | FALLOC_FL_KEEP_SIZE);
 }
 
 static __be32
 nfsd4_seek(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		struct nfsd4_seek *seek)
+		void *_seek)
 {
+	struct nfsd4_seek *seek = (struct nfsd4_seek *)_seek;
 	int whence;
 	__be32 status;
 	struct file *file;
@@ -1138,8 +1167,9 @@ out:
  */
 static __be32
 _nfsd4_verify(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_verify *verify)
+	     void *_verify)
 {
+	struct nfsd4_verify *verify = _verify;
 	__be32 *buf, *p;
 	int count;
 	__be32 status;
@@ -1196,8 +1226,9 @@ out_kfree:
 
 static __be32
 nfsd4_nverify(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	      struct nfsd4_verify *verify)
+	      void *_verify)
 {
+	struct nfsd4_verify *verify = _verify;
 	__be32 status;
 
 	status = _nfsd4_verify(rqstp, cstate, verify);
@@ -1206,8 +1237,9 @@ nfsd4_nverify(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
 
 static __be32
 nfsd4_verify(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	     struct nfsd4_verify *verify)
+	     void *_verify)
 {
+	struct nfsd4_verify *verify = _verify;
 	__be32 status;
 
 	status = _nfsd4_verify(rqstp, cstate, verify);
@@ -1235,8 +1267,9 @@ nfsd4_layout_verify(struct svc_export *exp, unsigned int layout_type)
 static __be32
 nfsd4_getdeviceinfo(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *cstate,
-		struct nfsd4_getdeviceinfo *gdp)
+		void *_gdp)
 {
+	struct nfsd4_getdeviceinfo *gdp = _gdp;
 	const struct nfsd4_layout_ops *ops;
 	struct nfsd4_deviceid_map *map;
 	struct svc_export *exp;
@@ -1281,8 +1314,9 @@ out:
 static __be32
 nfsd4_layoutget(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *cstate,
-		struct nfsd4_layoutget *lgp)
+		void *_lgp)
 {
+	struct nfsd4_layoutget *lgp = _lgp;
 	struct svc_fh *current_fh = &cstate->current_fh;
 	const struct nfsd4_layout_ops *ops;
 	struct nfs4_layout_stateid *ls;
@@ -1361,8 +1395,9 @@ out:
 static __be32
 nfsd4_layoutcommit(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *cstate,
-		struct nfsd4_layoutcommit *lcp)
+		void *_lcp)
 {
+	struct nfsd4_layoutcommit *lcp = _lcp;
 	const struct nfsd4_layout_seg *seg = &lcp->lc_seg;
 	struct svc_fh *current_fh = &cstate->current_fh;
 	const struct nfsd4_layout_ops *ops;
@@ -1425,8 +1460,9 @@ out:
 static __be32
 nfsd4_layoutreturn(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *cstate,
-		struct nfsd4_layoutreturn *lrp)
+		void *_lrp)
 {
+	struct nfsd4_layoutreturn *lrp = _lrp;
 	struct svc_fh *current_fh = &cstate->current_fh;
 	__be32 nfserr;
 
@@ -1528,7 +1564,7 @@ struct nfsd4_operation {
 	nfsd4op_rsize op_rsize_bop;
 	stateid_getter op_get_currentstateid;
 	stateid_setter op_set_currentstateid;
-};
+} __do_const;
 
 static struct nfsd4_operation nfsd4_ops[];
 
@@ -1636,10 +1672,10 @@ static void svcxdr_init_encode(struct svc_rqst *rqstp,
  * COMPOUND call.
  */
 static __be32
-nfsd4_proc_compound(struct svc_rqst *rqstp,
-		    struct nfsd4_compoundargs *args,
-		    struct nfsd4_compoundres *resp)
+nfsd4_proc_compound(struct svc_rqst *rqstp, void *_args, void *_resp)
 {
+	struct nfsd4_compoundargs *args = _args;
+	struct nfsd4_compoundres *resp = _resp;
 	struct nfsd4_op	*op;
 	struct nfsd4_operation *opdesc;
 	struct nfsd4_compound_state *cstate = &resp->cstate;
@@ -1998,338 +2034,338 @@ static inline u32 nfsd4_layoutreturn_rsize(struct svc_rqst *rqstp, struct nfsd4_
 
 static struct nfsd4_operation nfsd4_ops[] = {
 	[OP_ACCESS] = {
-		.op_func = (nfsd4op_func)nfsd4_access,
+		.op_func = nfsd4_access,
 		.op_name = "OP_ACCESS",
 	},
 	[OP_CLOSE] = {
-		.op_func = (nfsd4op_func)nfsd4_close,
+		.op_func = nfsd4_close,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_CLOSE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_status_stateid_rsize,
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_closestateid,
-		.op_set_currentstateid = (stateid_setter)nfsd4_set_closestateid,
+		.op_rsize_bop = nfsd4_status_stateid_rsize,
+		.op_get_currentstateid = nfsd4_get_closestateid,
+		.op_set_currentstateid = nfsd4_set_closestateid,
 	},
 	[OP_COMMIT] = {
-		.op_func = (nfsd4op_func)nfsd4_commit,
+		.op_func = nfsd4_commit,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_COMMIT",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_commit_rsize,
+		.op_rsize_bop = nfsd4_commit_rsize,
 	},
 	[OP_CREATE] = {
-		.op_func = (nfsd4op_func)nfsd4_create,
+		.op_func = nfsd4_create,
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME | OP_CLEAR_STATEID,
 		.op_name = "OP_CREATE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_create_rsize,
+		.op_rsize_bop = nfsd4_create_rsize,
 	},
 	[OP_DELEGRETURN] = {
-		.op_func = (nfsd4op_func)nfsd4_delegreturn,
+		.op_func = nfsd4_delegreturn,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_DELEGRETURN",
 		.op_rsize_bop = nfsd4_only_status_rsize,
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_delegreturnstateid,
+		.op_get_currentstateid = nfsd4_get_delegreturnstateid,
 	},
 	[OP_GETATTR] = {
-		.op_func = (nfsd4op_func)nfsd4_getattr,
+		.op_func = nfsd4_getattr,
 		.op_flags = ALLOWED_ON_ABSENT_FS,
 		.op_rsize_bop = nfsd4_getattr_rsize,
 		.op_name = "OP_GETATTR",
 	},
 	[OP_GETFH] = {
-		.op_func = (nfsd4op_func)nfsd4_getfh,
+		.op_func = nfsd4_getfh,
 		.op_name = "OP_GETFH",
 	},
 	[OP_LINK] = {
-		.op_func = (nfsd4op_func)nfsd4_link,
+		.op_func = nfsd4_link,
 		.op_flags = ALLOWED_ON_ABSENT_FS | OP_MODIFIES_SOMETHING
 				| OP_CACHEME,
 		.op_name = "OP_LINK",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_link_rsize,
+		.op_rsize_bop = nfsd4_link_rsize,
 	},
 	[OP_LOCK] = {
-		.op_func = (nfsd4op_func)nfsd4_lock,
+		.op_func = nfsd4_lock,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_LOCK",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_lock_rsize,
-		.op_set_currentstateid = (stateid_setter)nfsd4_set_lockstateid,
+		.op_rsize_bop = nfsd4_lock_rsize,
+		.op_set_currentstateid = nfsd4_set_lockstateid,
 	},
 	[OP_LOCKT] = {
-		.op_func = (nfsd4op_func)nfsd4_lockt,
+		.op_func = nfsd4_lockt,
 		.op_name = "OP_LOCKT",
 	},
 	[OP_LOCKU] = {
-		.op_func = (nfsd4op_func)nfsd4_locku,
+		.op_func = nfsd4_locku,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_LOCKU",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_status_stateid_rsize,
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_lockustateid,
+		.op_rsize_bop = nfsd4_status_stateid_rsize,
+		.op_get_currentstateid = nfsd4_get_lockustateid,
 	},
 	[OP_LOOKUP] = {
-		.op_func = (nfsd4op_func)nfsd4_lookup,
+		.op_func = nfsd4_lookup,
 		.op_flags = OP_HANDLES_WRONGSEC | OP_CLEAR_STATEID,
 		.op_name = "OP_LOOKUP",
 	},
 	[OP_LOOKUPP] = {
-		.op_func = (nfsd4op_func)nfsd4_lookupp,
+		.op_func = nfsd4_lookupp,
 		.op_flags = OP_HANDLES_WRONGSEC | OP_CLEAR_STATEID,
 		.op_name = "OP_LOOKUPP",
 	},
 	[OP_NVERIFY] = {
-		.op_func = (nfsd4op_func)nfsd4_nverify,
+		.op_func = nfsd4_nverify,
 		.op_name = "OP_NVERIFY",
 	},
 	[OP_OPEN] = {
-		.op_func = (nfsd4op_func)nfsd4_open,
+		.op_func = nfsd4_open,
 		.op_flags = OP_HANDLES_WRONGSEC | OP_MODIFIES_SOMETHING,
 		.op_name = "OP_OPEN",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_open_rsize,
-		.op_set_currentstateid = (stateid_setter)nfsd4_set_openstateid,
+		.op_rsize_bop = nfsd4_open_rsize,
+		.op_set_currentstateid = nfsd4_set_openstateid,
 	},
 	[OP_OPEN_CONFIRM] = {
-		.op_func = (nfsd4op_func)nfsd4_open_confirm,
+		.op_func = nfsd4_open_confirm,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_OPEN_CONFIRM",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_status_stateid_rsize,
+		.op_rsize_bop = nfsd4_status_stateid_rsize,
 	},
 	[OP_OPEN_DOWNGRADE] = {
-		.op_func = (nfsd4op_func)nfsd4_open_downgrade,
+		.op_func = nfsd4_open_downgrade,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_OPEN_DOWNGRADE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_status_stateid_rsize,
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_opendowngradestateid,
-		.op_set_currentstateid = (stateid_setter)nfsd4_set_opendowngradestateid,
+		.op_rsize_bop = nfsd4_status_stateid_rsize,
+		.op_get_currentstateid = nfsd4_get_opendowngradestateid,
+		.op_set_currentstateid = nfsd4_set_opendowngradestateid,
 	},
 	[OP_PUTFH] = {
-		.op_func = (nfsd4op_func)nfsd4_putfh,
+		.op_func = nfsd4_putfh,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_IS_PUTFH_LIKE | OP_CLEAR_STATEID,
 		.op_name = "OP_PUTFH",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_PUTPUBFH] = {
-		.op_func = (nfsd4op_func)nfsd4_putrootfh,
+		.op_func = nfsd4_putrootfh,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_IS_PUTFH_LIKE | OP_CLEAR_STATEID,
 		.op_name = "OP_PUTPUBFH",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_PUTROOTFH] = {
-		.op_func = (nfsd4op_func)nfsd4_putrootfh,
+		.op_func = nfsd4_putrootfh,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_IS_PUTFH_LIKE | OP_CLEAR_STATEID,
 		.op_name = "OP_PUTROOTFH",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_READ] = {
-		.op_func = (nfsd4op_func)nfsd4_read,
+		.op_func = nfsd4_read,
 		.op_name = "OP_READ",
 		.op_rsize_bop = (nfsd4op_rsize)nfsd4_read_rsize,
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_readstateid,
+		.op_get_currentstateid = nfsd4_get_readstateid,
 	},
 	[OP_READDIR] = {
-		.op_func = (nfsd4op_func)nfsd4_readdir,
+		.op_func = nfsd4_readdir,
 		.op_name = "OP_READDIR",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_readdir_rsize,
+		.op_rsize_bop = nfsd4_readdir_rsize,
 	},
 	[OP_READLINK] = {
-		.op_func = (nfsd4op_func)nfsd4_readlink,
+		.op_func = nfsd4_readlink,
 		.op_name = "OP_READLINK",
 	},
 	[OP_REMOVE] = {
-		.op_func = (nfsd4op_func)nfsd4_remove,
+		.op_func = nfsd4_remove,
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_REMOVE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_remove_rsize,
+		.op_rsize_bop = nfsd4_remove_rsize,
 	},
 	[OP_RENAME] = {
-		.op_func = (nfsd4op_func)nfsd4_rename,
+		.op_func = nfsd4_rename,
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_RENAME",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_rename_rsize,
+		.op_rsize_bop = nfsd4_rename_rsize,
 	},
 	[OP_RENEW] = {
-		.op_func = (nfsd4op_func)nfsd4_renew,
+		.op_func = nfsd4_renew,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_MODIFIES_SOMETHING,
 		.op_name = "OP_RENEW",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 
 	},
 	[OP_RESTOREFH] = {
-		.op_func = (nfsd4op_func)nfsd4_restorefh,
+		.op_func = nfsd4_restorefh,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_IS_PUTFH_LIKE | OP_MODIFIES_SOMETHING,
 		.op_name = "OP_RESTOREFH",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_SAVEFH] = {
-		.op_func = (nfsd4op_func)nfsd4_savefh,
+		.op_func = nfsd4_savefh,
 		.op_flags = OP_HANDLES_WRONGSEC | OP_MODIFIES_SOMETHING,
 		.op_name = "OP_SAVEFH",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_SECINFO] = {
-		.op_func = (nfsd4op_func)nfsd4_secinfo,
+		.op_func = nfsd4_secinfo,
 		.op_flags = OP_HANDLES_WRONGSEC,
 		.op_name = "OP_SECINFO",
 	},
 	[OP_SETATTR] = {
-		.op_func = (nfsd4op_func)nfsd4_setattr,
+		.op_func = nfsd4_setattr,
 		.op_name = "OP_SETATTR",
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME,
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_setattr_rsize,
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_setattrstateid,
+		.op_rsize_bop = nfsd4_setattr_rsize,
+		.op_get_currentstateid = nfsd4_get_setattrstateid,
 	},
 	[OP_SETCLIENTID] = {
-		.op_func = (nfsd4op_func)nfsd4_setclientid,
+		.op_func = nfsd4_setclientid,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_SETCLIENTID",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_setclientid_rsize,
+		.op_rsize_bop = nfsd4_setclientid_rsize,
 	},
 	[OP_SETCLIENTID_CONFIRM] = {
-		.op_func = (nfsd4op_func)nfsd4_setclientid_confirm,
+		.op_func = nfsd4_setclientid_confirm,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_SETCLIENTID_CONFIRM",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_VERIFY] = {
-		.op_func = (nfsd4op_func)nfsd4_verify,
+		.op_func = nfsd4_verify,
 		.op_name = "OP_VERIFY",
 	},
 	[OP_WRITE] = {
-		.op_func = (nfsd4op_func)nfsd4_write,
+		.op_func = nfsd4_write,
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_WRITE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_write_rsize,
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_writestateid,
+		.op_rsize_bop = nfsd4_write_rsize,
+		.op_get_currentstateid = nfsd4_get_writestateid,
 	},
 	[OP_RELEASE_LOCKOWNER] = {
-		.op_func = (nfsd4op_func)nfsd4_release_lockowner,
+		.op_func = nfsd4_release_lockowner,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_ON_ABSENT_FS
 				| OP_MODIFIES_SOMETHING,
 		.op_name = "OP_RELEASE_LOCKOWNER",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 
 	/* NFSv4.1 operations */
 	[OP_EXCHANGE_ID] = {
-		.op_func = (nfsd4op_func)nfsd4_exchange_id,
+		.op_func = nfsd4_exchange_id,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_AS_FIRST_OP
 				| OP_MODIFIES_SOMETHING,
 		.op_name = "OP_EXCHANGE_ID",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_exchange_id_rsize,
+		.op_rsize_bop = nfsd4_exchange_id_rsize,
 	},
 	[OP_BACKCHANNEL_CTL] = {
-		.op_func = (nfsd4op_func)nfsd4_backchannel_ctl,
+		.op_func = nfsd4_backchannel_ctl,
 		.op_flags = ALLOWED_WITHOUT_FH | OP_MODIFIES_SOMETHING,
 		.op_name = "OP_BACKCHANNEL_CTL",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_BIND_CONN_TO_SESSION] = {
-		.op_func = (nfsd4op_func)nfsd4_bind_conn_to_session,
+		.op_func = nfsd4_bind_conn_to_session,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_AS_FIRST_OP
 				| OP_MODIFIES_SOMETHING,
 		.op_name = "OP_BIND_CONN_TO_SESSION",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_bind_conn_to_session_rsize,
+		.op_rsize_bop = nfsd4_bind_conn_to_session_rsize,
 	},
 	[OP_CREATE_SESSION] = {
-		.op_func = (nfsd4op_func)nfsd4_create_session,
+		.op_func = nfsd4_create_session,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_AS_FIRST_OP
 				| OP_MODIFIES_SOMETHING,
 		.op_name = "OP_CREATE_SESSION",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_create_session_rsize,
+		.op_rsize_bop = nfsd4_create_session_rsize,
 	},
 	[OP_DESTROY_SESSION] = {
-		.op_func = (nfsd4op_func)nfsd4_destroy_session,
+		.op_func = nfsd4_destroy_session,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_AS_FIRST_OP
 				| OP_MODIFIES_SOMETHING,
 		.op_name = "OP_DESTROY_SESSION",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_SEQUENCE] = {
-		.op_func = (nfsd4op_func)nfsd4_sequence,
+		.op_func = nfsd4_sequence,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_AS_FIRST_OP,
 		.op_name = "OP_SEQUENCE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_sequence_rsize,
+		.op_rsize_bop = nfsd4_sequence_rsize,
 	},
 	[OP_DESTROY_CLIENTID] = {
-		.op_func = (nfsd4op_func)nfsd4_destroy_clientid,
+		.op_func = nfsd4_destroy_clientid,
 		.op_flags = ALLOWED_WITHOUT_FH | ALLOWED_AS_FIRST_OP
 				| OP_MODIFIES_SOMETHING,
 		.op_name = "OP_DESTROY_CLIENTID",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_RECLAIM_COMPLETE] = {
-		.op_func = (nfsd4op_func)nfsd4_reclaim_complete,
+		.op_func = nfsd4_reclaim_complete,
 		.op_flags = ALLOWED_WITHOUT_FH | OP_MODIFIES_SOMETHING,
 		.op_name = "OP_RECLAIM_COMPLETE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_SECINFO_NO_NAME] = {
-		.op_func = (nfsd4op_func)nfsd4_secinfo_no_name,
+		.op_func = nfsd4_secinfo_no_name,
 		.op_flags = OP_HANDLES_WRONGSEC,
 		.op_name = "OP_SECINFO_NO_NAME",
 	},
 	[OP_TEST_STATEID] = {
-		.op_func = (nfsd4op_func)nfsd4_test_stateid,
+		.op_func = nfsd4_test_stateid,
 		.op_flags = ALLOWED_WITHOUT_FH,
 		.op_name = "OP_TEST_STATEID",
 	},
 	[OP_FREE_STATEID] = {
-		.op_func = (nfsd4op_func)nfsd4_free_stateid,
+		.op_func = nfsd4_free_stateid,
 		.op_flags = ALLOWED_WITHOUT_FH | OP_MODIFIES_SOMETHING,
 		.op_name = "OP_FREE_STATEID",
-		.op_get_currentstateid = (stateid_getter)nfsd4_get_freestateid,
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_get_currentstateid = nfsd4_get_freestateid,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 #ifdef CONFIG_NFSD_PNFS
 	[OP_GETDEVICEINFO] = {
-		.op_func = (nfsd4op_func)nfsd4_getdeviceinfo,
+		.op_func = nfsd4_getdeviceinfo,
 		.op_flags = ALLOWED_WITHOUT_FH,
 		.op_name = "OP_GETDEVICEINFO",
 	},
 	[OP_LAYOUTGET] = {
-		.op_func = (nfsd4op_func)nfsd4_layoutget,
+		.op_func = nfsd4_layoutget,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_LAYOUTGET",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_layoutget_rsize,
+		.op_rsize_bop = nfsd4_layoutget_rsize,
 	},
 	[OP_LAYOUTCOMMIT] = {
-		.op_func = (nfsd4op_func)nfsd4_layoutcommit,
+		.op_func = nfsd4_layoutcommit,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_LAYOUTCOMMIT",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_layoutcommit_rsize,
+		.op_rsize_bop = nfsd4_layoutcommit_rsize,
 	},
 	[OP_LAYOUTRETURN] = {
-		.op_func = (nfsd4op_func)nfsd4_layoutreturn,
+		.op_func = nfsd4_layoutreturn,
 		.op_flags = OP_MODIFIES_SOMETHING,
 		.op_name = "OP_LAYOUTRETURN",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_layoutreturn_rsize,
+		.op_rsize_bop = nfsd4_layoutreturn_rsize,
 	},
 #endif /* CONFIG_NFSD_PNFS */
 
 	/* NFSv4.2 operations */
 	[OP_ALLOCATE] = {
-		.op_func = (nfsd4op_func)nfsd4_allocate,
+		.op_func = nfsd4_allocate,
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_ALLOCATE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_DEALLOCATE] = {
-		.op_func = (nfsd4op_func)nfsd4_deallocate,
+		.op_func = nfsd4_deallocate,
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_DEALLOCATE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_CLONE] = {
-		.op_func = (nfsd4op_func)nfsd4_clone,
+		.op_func = nfsd4_clone,
 		.op_flags = OP_MODIFIES_SOMETHING | OP_CACHEME,
 		.op_name = "OP_CLONE",
-		.op_rsize_bop = (nfsd4op_rsize)nfsd4_only_status_rsize,
+		.op_rsize_bop = nfsd4_only_status_rsize,
 	},
 	[OP_SEEK] = {
-		.op_func = (nfsd4op_func)nfsd4_seek,
+		.op_func = nfsd4_seek,
 		.op_name = "OP_SEEK",
 	},
 };
@@ -2406,17 +2442,17 @@ struct nfsd4_voidargs { int dummy; };
 
 static struct svc_procedure		nfsd_procedures4[2] = {
 	[NFSPROC4_NULL] = {
-		.pc_func = (svc_procfunc) nfsd4_proc_null,
-		.pc_encode = (kxdrproc_t) nfs4svc_encode_voidres,
+		.pc_func = nfsd4_proc_null,
+		.pc_encode = nfs4svc_encode_voidres,
 		.pc_argsize = sizeof(struct nfsd4_voidargs),
 		.pc_ressize = sizeof(struct nfsd4_voidres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = 1,
 	},
 	[NFSPROC4_COMPOUND] = {
-		.pc_func = (svc_procfunc) nfsd4_proc_compound,
-		.pc_decode = (kxdrproc_t) nfs4svc_decode_compoundargs,
-		.pc_encode = (kxdrproc_t) nfs4svc_encode_compoundres,
+		.pc_func = nfsd4_proc_compound,
+		.pc_decode = nfs4svc_decode_compoundargs,
+		.pc_encode = nfs4svc_encode_compoundres,
 		.pc_argsize = sizeof(struct nfsd4_compoundargs),
 		.pc_ressize = sizeof(struct nfsd4_compoundres),
 		.pc_release = nfsd4_release_compoundargs,
diff --git a/fs/nfsd/nfs4state.c b/fs/nfsd/nfs4state.c
index 0fe31b4b1..89b42dbb3 100644
--- a/fs/nfsd/nfs4state.c
+++ b/fs/nfsd/nfs4state.c
@@ -2339,8 +2339,9 @@ static bool client_has_state(struct nfs4_client *clp)
 __be32
 nfsd4_exchange_id(struct svc_rqst *rqstp,
 		  struct nfsd4_compound_state *cstate,
-		  struct nfsd4_exchange_id *exid)
+		  void *_exid)
 {
+	struct nfsd4_exchange_id *exid = _exid;
 	struct nfs4_client *conf, *new;
 	struct nfs4_client *unconf = NULL;
 	__be32 status;
@@ -2634,8 +2635,9 @@ static __be32 nfsd4_check_cb_sec(struct nfsd4_cb_sec *cbs)
 __be32
 nfsd4_create_session(struct svc_rqst *rqstp,
 		     struct nfsd4_compound_state *cstate,
-		     struct nfsd4_create_session *cr_ses)
+		     void *_cr_ses)
 {
+	struct nfsd4_create_session *cr_ses = _cr_ses;
 	struct sockaddr *sa = svc_addr(rqstp);
 	struct nfs4_client *conf, *unconf;
 	struct nfs4_client *old = NULL;
@@ -2759,8 +2761,9 @@ static __be32 nfsd4_map_bcts_dir(u32 *dir)
 	return nfserr_inval;
 }
 
-__be32 nfsd4_backchannel_ctl(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate, struct nfsd4_backchannel_ctl *bc)
+__be32 nfsd4_backchannel_ctl(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate, void *_bc)
 {
+	struct nfsd4_backchannel_ctl *bc = _bc;
 	struct nfsd4_session *session = cstate->session;
 	struct nfsd_net *nn = net_generic(SVC_NET(rqstp), nfsd_net_id);
 	__be32 status;
@@ -2780,8 +2783,9 @@ __be32 nfsd4_backchannel_ctl(struct svc_rqst *rqstp, struct nfsd4_compound_state
 
 __be32 nfsd4_bind_conn_to_session(struct svc_rqst *rqstp,
 		     struct nfsd4_compound_state *cstate,
-		     struct nfsd4_bind_conn_to_session *bcts)
+		     void *_bcts)
 {
+	struct nfsd4_bind_conn_to_session *bcts = _bcts;
 	__be32 status;
 	struct nfsd4_conn *conn;
 	struct nfsd4_session *session;
@@ -2823,8 +2827,9 @@ static bool nfsd4_compound_in_session(struct nfsd4_session *session, struct nfs4
 __be32
 nfsd4_destroy_session(struct svc_rqst *r,
 		      struct nfsd4_compound_state *cstate,
-		      struct nfsd4_destroy_session *sessionid)
+		      void *_sessionid)
 {
+	struct nfsd4_destroy_session *sessionid = _sessionid;
 	struct nfsd4_session *ses;
 	__be32 status;
 	int ref_held_by_me = 0;
@@ -2920,8 +2925,9 @@ static bool nfsd4_request_too_big(struct svc_rqst *rqstp,
 __be32
 nfsd4_sequence(struct svc_rqst *rqstp,
 	       struct nfsd4_compound_state *cstate,
-	       struct nfsd4_sequence *seq)
+	       void *_seq)
 {
+	struct nfsd4_sequence *seq = _seq;
 	struct nfsd4_compoundres *resp = rqstp->rq_resp;
 	struct xdr_stream *xdr = &resp->xdr;
 	struct nfsd4_session *session;
@@ -3055,8 +3061,9 @@ nfsd4_sequence_done(struct nfsd4_compoundres *resp)
 }
 
 __be32
-nfsd4_destroy_clientid(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate, struct nfsd4_destroy_clientid *dc)
+nfsd4_destroy_clientid(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate, void *_dc)
 {
+	struct nfsd4_destroy_clientid *dc = _dc;
 	struct nfs4_client *conf, *unconf;
 	struct nfs4_client *clp = NULL;
 	__be32 status = 0;
@@ -3096,8 +3103,9 @@ out:
 }
 
 __be32
-nfsd4_reclaim_complete(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate, struct nfsd4_reclaim_complete *rc)
+nfsd4_reclaim_complete(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate, void *_rc)
 {
+	struct nfsd4_reclaim_complete *rc = _rc;
 	__be32 status = 0;
 
 	if (rc->rca_one_fs) {
@@ -3134,8 +3142,9 @@ out:
 
 __be32
 nfsd4_setclientid(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		  struct nfsd4_setclientid *setclid)
+		  void *_setclid)
 {
+	struct nfsd4_setclientid *setclid = _setclid;
 	struct xdr_netobj 	clname = setclid->se_name;
 	nfs4_verifier		clverifier = setclid->se_verf;
 	struct nfs4_client	*conf, *new;
@@ -3193,8 +3202,9 @@ out:
 __be32
 nfsd4_setclientid_confirm(struct svc_rqst *rqstp,
 			 struct nfsd4_compound_state *cstate,
-			 struct nfsd4_setclientid_confirm *setclientid_confirm)
+			 void *_setclientid_confirm)
 {
+	struct nfsd4_setclientid_confirm *setclientid_confirm = _setclientid_confirm;
 	struct nfs4_client *conf, *unconf;
 	struct nfs4_client *old = NULL;
 	nfs4_verifier confirm = setclientid_confirm->sc_confirm; 
@@ -4438,8 +4448,9 @@ void nfsd4_cleanup_open_state(struct nfsd4_compound_state *cstate,
 
 __be32
 nfsd4_renew(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	    clientid_t *clid)
+	    void *_clid)
 {
+	clientid_t *clid = _clid;
 	struct nfs4_client *clp;
 	__be32 status;
 	struct nfsd_net *nn = net_generic(SVC_NET(rqstp), nfsd_net_id);
@@ -4889,8 +4900,9 @@ out:
  */
 __be32
 nfsd4_test_stateid(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		   struct nfsd4_test_stateid *test_stateid)
+		   void *_test_stateid)
 {
+	struct nfsd4_test_stateid *test_stateid = _test_stateid;
 	struct nfsd4_test_stateid_id *stateid;
 	struct nfs4_client *cl = cstate->session->se_client;
 
@@ -4929,8 +4941,9 @@ out:
 
 __be32
 nfsd4_free_stateid(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		   struct nfsd4_free_stateid *free_stateid)
+		   void *_free_stateid)
 {
+	struct nfsd4_free_stateid *free_stateid = _free_stateid;
 	stateid_t *stateid = &free_stateid->fr_stateid;
 	struct nfs4_stid *s;
 	struct nfs4_delegation *dp;
@@ -5058,8 +5071,9 @@ static __be32 nfs4_preprocess_confirmed_seqid_op(struct nfsd4_compound_state *cs
 
 __be32
 nfsd4_open_confirm(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		   struct nfsd4_open_confirm *oc)
+		   void *_oc)
 {
+	struct nfsd4_open_confirm *oc = _oc;
 	__be32 status;
 	struct nfs4_openowner *oo;
 	struct nfs4_ol_stateid *stp;
@@ -5127,8 +5141,9 @@ static inline void nfs4_stateid_downgrade(struct nfs4_ol_stateid *stp, u32 to_ac
 __be32
 nfsd4_open_downgrade(struct svc_rqst *rqstp,
 		     struct nfsd4_compound_state *cstate,
-		     struct nfsd4_open_downgrade *od)
+		     void *_od)
 {
+	struct nfsd4_open_downgrade *od = _od;
 	__be32 status;
 	struct nfs4_ol_stateid *stp;
 	struct nfsd_net *nn = net_generic(SVC_NET(rqstp), nfsd_net_id);
@@ -5196,8 +5211,9 @@ static void nfsd4_close_open_stateid(struct nfs4_ol_stateid *s)
  */
 __be32
 nfsd4_close(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	    struct nfsd4_close *close)
+	    void *_close)
 {
+	struct nfsd4_close *close = _close;
 	__be32 status;
 	struct nfs4_ol_stateid *stp;
 	struct net *net = SVC_NET(rqstp);
@@ -5226,8 +5242,9 @@ out:
 
 __be32
 nfsd4_delegreturn(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-		  struct nfsd4_delegreturn *dr)
+		  void *_dr)
 {
+	struct nfsd4_delegreturn *dr = _dr;
 	struct nfs4_delegation *dp;
 	stateid_t *stateid = &dr->dr_stateid;
 	struct nfs4_stid *s;
@@ -5578,8 +5595,9 @@ out:
  */
 __be32
 nfsd4_lock(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	   struct nfsd4_lock *lock)
+	   void *_lock)
 {
+	struct nfsd4_lock *lock = _lock;
 	struct nfs4_openowner *open_sop = NULL;
 	struct nfs4_lockowner *lock_sop = NULL;
 	struct nfs4_ol_stateid *lock_stp = NULL;
@@ -5780,8 +5798,9 @@ static __be32 nfsd_test_lock(struct svc_rqst *rqstp, struct svc_fh *fhp, struct
  */
 __be32
 nfsd4_lockt(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	    struct nfsd4_lockt *lockt)
+	    void *_lockt)
 {
+	struct nfsd4_lockt *lockt = _lockt;
 	struct file_lock *file_lock = NULL;
 	struct nfs4_lockowner *lo = NULL;
 	__be32 status;
@@ -5853,8 +5872,9 @@ out:
 
 __be32
 nfsd4_locku(struct svc_rqst *rqstp, struct nfsd4_compound_state *cstate,
-	    struct nfsd4_locku *locku)
+	    void *_locku)
 {
+	struct nfsd4_locku *locku = _locku;
 	struct nfs4_ol_stateid *stp;
 	struct file *filp = NULL;
 	struct file_lock *file_lock = NULL;
@@ -5960,8 +5980,9 @@ check_for_locks(struct nfs4_file *fp, struct nfs4_lockowner *lowner)
 __be32
 nfsd4_release_lockowner(struct svc_rqst *rqstp,
 			struct nfsd4_compound_state *cstate,
-			struct nfsd4_release_lockowner *rlockowner)
+			void *_rlockowner)
 {
+	struct nfsd4_release_lockowner *rlockowner = _rlockowner;
 	clientid_t *clid = &rlockowner->rl_clientid;
 	struct nfs4_stateowner *sop;
 	struct nfs4_lockowner *lo = NULL;
@@ -6920,26 +6941,34 @@ clear_current_stateid(struct nfsd4_compound_state *cstate)
  * functions to set current state id
  */
 void
-nfsd4_set_opendowngradestateid(struct nfsd4_compound_state *cstate, struct nfsd4_open_downgrade *odp)
+nfsd4_set_opendowngradestateid(struct nfsd4_compound_state *cstate, void *_odp)
 {
+	struct nfsd4_open_downgrade *odp = _odp;
+
 	put_stateid(cstate, &odp->od_stateid);
 }
 
 void
-nfsd4_set_openstateid(struct nfsd4_compound_state *cstate, struct nfsd4_open *open)
+nfsd4_set_openstateid(struct nfsd4_compound_state *cstate, void *_open)
 {
+	struct nfsd4_open *open = _open;
+
 	put_stateid(cstate, &open->op_stateid);
 }
 
 void
-nfsd4_set_closestateid(struct nfsd4_compound_state *cstate, struct nfsd4_close *close)
+nfsd4_set_closestateid(struct nfsd4_compound_state *cstate, void *_close)
 {
+	struct nfsd4_close *close = _close;
+
 	put_stateid(cstate, &close->cl_stateid);
 }
 
 void
-nfsd4_set_lockstateid(struct nfsd4_compound_state *cstate, struct nfsd4_lock *lock)
+nfsd4_set_lockstateid(struct nfsd4_compound_state *cstate, void *_lock)
 {
+	struct nfsd4_lock *lock = _lock;
+
 	put_stateid(cstate, &lock->lk_resp_stateid);
 }
 
@@ -6948,49 +6977,65 @@ nfsd4_set_lockstateid(struct nfsd4_compound_state *cstate, struct nfsd4_lock *lo
  */
 
 void
-nfsd4_get_opendowngradestateid(struct nfsd4_compound_state *cstate, struct nfsd4_open_downgrade *odp)
+nfsd4_get_opendowngradestateid(struct nfsd4_compound_state *cstate, void *_odp)
 {
+	struct nfsd4_open_downgrade *odp = _odp;
+
 	get_stateid(cstate, &odp->od_stateid);
 }
 
 void
-nfsd4_get_delegreturnstateid(struct nfsd4_compound_state *cstate, struct nfsd4_delegreturn *drp)
+nfsd4_get_delegreturnstateid(struct nfsd4_compound_state *cstate, void *_drp)
 {
+	struct nfsd4_delegreturn *drp = _drp;
+
 	get_stateid(cstate, &drp->dr_stateid);
 }
 
 void
-nfsd4_get_freestateid(struct nfsd4_compound_state *cstate, struct nfsd4_free_stateid *fsp)
+nfsd4_get_freestateid(struct nfsd4_compound_state *cstate, void *_fsp)
 {
+	struct nfsd4_free_stateid *fsp = _fsp;
+
 	get_stateid(cstate, &fsp->fr_stateid);
 }
 
 void
-nfsd4_get_setattrstateid(struct nfsd4_compound_state *cstate, struct nfsd4_setattr *setattr)
+nfsd4_get_setattrstateid(struct nfsd4_compound_state *cstate, void *_setattr)
 {
+	struct nfsd4_setattr *setattr = _setattr;
+
 	get_stateid(cstate, &setattr->sa_stateid);
 }
 
 void
-nfsd4_get_closestateid(struct nfsd4_compound_state *cstate, struct nfsd4_close *close)
+nfsd4_get_closestateid(struct nfsd4_compound_state *cstate, void *_close)
 {
+	struct nfsd4_close *close = _close;
+
 	get_stateid(cstate, &close->cl_stateid);
 }
 
 void
-nfsd4_get_lockustateid(struct nfsd4_compound_state *cstate, struct nfsd4_locku *locku)
+nfsd4_get_lockustateid(struct nfsd4_compound_state *cstate, void *_locku)
 {
+	struct nfsd4_locku *locku = _locku;
+
 	get_stateid(cstate, &locku->lu_stateid);
 }
 
 void
-nfsd4_get_readstateid(struct nfsd4_compound_state *cstate, struct nfsd4_read *read)
+nfsd4_get_readstateid(struct nfsd4_compound_state *cstate, void *_read)
 {
+	struct nfsd4_read *read = _read;
+
 	get_stateid(cstate, &read->rd_stateid);
 }
 
 void
-nfsd4_get_writestateid(struct nfsd4_compound_state *cstate, struct nfsd4_write *write)
+nfsd4_get_writestateid(struct nfsd4_compound_state *cstate, void *_write)
 {
+	struct nfsd4_write *write = _write;
+
 	get_stateid(cstate, &write->wr_stateid);
 }
diff --git a/fs/nfsd/nfs4xdr.c b/fs/nfsd/nfs4xdr.c
index 0aa0236a1..6381bd75c 100644
--- a/fs/nfsd/nfs4xdr.c
+++ b/fs/nfsd/nfs4xdr.c
@@ -447,8 +447,9 @@ nfsd4_decode_fattr(struct nfsd4_compoundargs *argp, u32 *bmval,
 }
 
 static __be32
-nfsd4_decode_stateid(struct nfsd4_compoundargs *argp, stateid_t *sid)
+nfsd4_decode_stateid(struct nfsd4_compoundargs *argp, void *_sid)
 {
+	stateid_t *sid = _sid;
 	DECODE_HEAD;
 
 	READ_BUF(sizeof(stateid_t));
@@ -459,8 +460,9 @@ nfsd4_decode_stateid(struct nfsd4_compoundargs *argp, stateid_t *sid)
 }
 
 static __be32
-nfsd4_decode_access(struct nfsd4_compoundargs *argp, struct nfsd4_access *access)
+nfsd4_decode_access(struct nfsd4_compoundargs *argp, void *_access)
 {
+	struct nfsd4_access *access = _access;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -469,8 +471,9 @@ nfsd4_decode_access(struct nfsd4_compoundargs *argp, struct nfsd4_access *access
 	DECODE_TAIL;
 }
 
-static __be32 nfsd4_decode_cb_sec(struct nfsd4_compoundargs *argp, struct nfsd4_cb_sec *cbs)
+static __be32 nfsd4_decode_cb_sec(struct nfsd4_compoundargs *argp, void *_cbs)
 {
+	struct nfsd4_cb_sec *cbs = _cbs;
 	DECODE_HEAD;
 	u32 dummy, uid, gid;
 	char *machine_name;
@@ -549,8 +552,9 @@ static __be32 nfsd4_decode_cb_sec(struct nfsd4_compoundargs *argp, struct nfsd4_
 	DECODE_TAIL;
 }
 
-static __be32 nfsd4_decode_backchannel_ctl(struct nfsd4_compoundargs *argp, struct nfsd4_backchannel_ctl *bc)
+static __be32 nfsd4_decode_backchannel_ctl(struct nfsd4_compoundargs *argp, void *_bc)
 {
+	struct nfsd4_backchannel_ctl *bc = _bc;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -560,8 +564,9 @@ static __be32 nfsd4_decode_backchannel_ctl(struct nfsd4_compoundargs *argp, stru
 	DECODE_TAIL;
 }
 
-static __be32 nfsd4_decode_bind_conn_to_session(struct nfsd4_compoundargs *argp, struct nfsd4_bind_conn_to_session *bcts)
+static __be32 nfsd4_decode_bind_conn_to_session(struct nfsd4_compoundargs *argp, void *_bcts)
 {
+	struct nfsd4_bind_conn_to_session *bcts = _bcts;
 	DECODE_HEAD;
 
 	READ_BUF(NFS4_MAX_SESSIONID_LEN + 8);
@@ -573,8 +578,9 @@ static __be32 nfsd4_decode_bind_conn_to_session(struct nfsd4_compoundargs *argp,
 }
 
 static __be32
-nfsd4_decode_close(struct nfsd4_compoundargs *argp, struct nfsd4_close *close)
+nfsd4_decode_close(struct nfsd4_compoundargs *argp, void *_close)
 {
+	struct nfsd4_close *close = _close;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -586,8 +592,9 @@ nfsd4_decode_close(struct nfsd4_compoundargs *argp, struct nfsd4_close *close)
 
 
 static __be32
-nfsd4_decode_commit(struct nfsd4_compoundargs *argp, struct nfsd4_commit *commit)
+nfsd4_decode_commit(struct nfsd4_compoundargs *argp, void *_commit)
 {
+	struct nfsd4_commit *commit = _commit;
 	DECODE_HEAD;
 
 	READ_BUF(12);
@@ -598,8 +605,9 @@ nfsd4_decode_commit(struct nfsd4_compoundargs *argp, struct nfsd4_commit *commit
 }
 
 static __be32
-nfsd4_decode_create(struct nfsd4_compoundargs *argp, struct nfsd4_create *create)
+nfsd4_decode_create(struct nfsd4_compoundargs *argp, void *_create)
 {
+	struct nfsd4_create *create = _create;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -642,20 +650,25 @@ nfsd4_decode_create(struct nfsd4_compoundargs *argp, struct nfsd4_create *create
 }
 
 static inline __be32
-nfsd4_decode_delegreturn(struct nfsd4_compoundargs *argp, struct nfsd4_delegreturn *dr)
+nfsd4_decode_delegreturn(struct nfsd4_compoundargs *argp, void *_dr)
 {
+	struct nfsd4_delegreturn *dr = _dr;
+
 	return nfsd4_decode_stateid(argp, &dr->dr_stateid);
 }
 
 static inline __be32
-nfsd4_decode_getattr(struct nfsd4_compoundargs *argp, struct nfsd4_getattr *getattr)
+nfsd4_decode_getattr(struct nfsd4_compoundargs *argp, void *_getattr)
 {
+	struct nfsd4_getattr *getattr = _getattr;
+
 	return nfsd4_decode_bitmap(argp, getattr->ga_bmval);
 }
 
 static __be32
-nfsd4_decode_link(struct nfsd4_compoundargs *argp, struct nfsd4_link *link)
+nfsd4_decode_link(struct nfsd4_compoundargs *argp, void *_link)
 {
+	struct nfsd4_link *link = _link;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -669,8 +682,9 @@ nfsd4_decode_link(struct nfsd4_compoundargs *argp, struct nfsd4_link *link)
 }
 
 static __be32
-nfsd4_decode_lock(struct nfsd4_compoundargs *argp, struct nfsd4_lock *lock)
+nfsd4_decode_lock(struct nfsd4_compoundargs *argp, void *_lock)
 {
+	struct nfsd4_lock *lock = _lock;
 	DECODE_HEAD;
 
 	/*
@@ -709,8 +723,9 @@ nfsd4_decode_lock(struct nfsd4_compoundargs *argp, struct nfsd4_lock *lock)
 }
 
 static __be32
-nfsd4_decode_lockt(struct nfsd4_compoundargs *argp, struct nfsd4_lockt *lockt)
+nfsd4_decode_lockt(struct nfsd4_compoundargs *argp, void *_lockt)
 {
+	struct nfsd4_lockt *lockt = _lockt;
 	DECODE_HEAD;
 		        
 	READ_BUF(32);
@@ -728,8 +743,9 @@ nfsd4_decode_lockt(struct nfsd4_compoundargs *argp, struct nfsd4_lockt *lockt)
 }
 
 static __be32
-nfsd4_decode_locku(struct nfsd4_compoundargs *argp, struct nfsd4_locku *locku)
+nfsd4_decode_locku(struct nfsd4_compoundargs *argp, void *_locku)
 {
+	struct nfsd4_locku *locku = _locku;
 	DECODE_HEAD;
 
 	READ_BUF(8);
@@ -748,8 +764,9 @@ nfsd4_decode_locku(struct nfsd4_compoundargs *argp, struct nfsd4_locku *locku)
 }
 
 static __be32
-nfsd4_decode_lookup(struct nfsd4_compoundargs *argp, struct nfsd4_lookup *lookup)
+nfsd4_decode_lookup(struct nfsd4_compoundargs *argp, void *_lookup)
 {
+	struct nfsd4_lookup *lookup = _lookup;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -847,8 +864,9 @@ xdr_error:
 }
 
 static __be32
-nfsd4_decode_open(struct nfsd4_compoundargs *argp, struct nfsd4_open *open)
+nfsd4_decode_open(struct nfsd4_compoundargs *argp, void *_open)
 {
+	struct nfsd4_open *open = _open;
 	DECODE_HEAD;
 	u32 dummy;
 
@@ -960,8 +978,9 @@ nfsd4_decode_open(struct nfsd4_compoundargs *argp, struct nfsd4_open *open)
 }
 
 static __be32
-nfsd4_decode_open_confirm(struct nfsd4_compoundargs *argp, struct nfsd4_open_confirm *open_conf)
+nfsd4_decode_open_confirm(struct nfsd4_compoundargs *argp, void *_open_conf)
 {
+	struct nfsd4_open_confirm *open_conf = _open_conf;
 	DECODE_HEAD;
 
 	if (argp->minorversion >= 1)
@@ -977,8 +996,9 @@ nfsd4_decode_open_confirm(struct nfsd4_compoundargs *argp, struct nfsd4_open_con
 }
 
 static __be32
-nfsd4_decode_open_downgrade(struct nfsd4_compoundargs *argp, struct nfsd4_open_downgrade *open_down)
+nfsd4_decode_open_downgrade(struct nfsd4_compoundargs *argp, void *_open_down)
 {
+	struct nfsd4_open_downgrade *open_down = _open_down;
 	DECODE_HEAD;
 		    
 	status = nfsd4_decode_stateid(argp, &open_down->od_stateid);
@@ -997,8 +1017,9 @@ nfsd4_decode_open_downgrade(struct nfsd4_compoundargs *argp, struct nfsd4_open_d
 }
 
 static __be32
-nfsd4_decode_putfh(struct nfsd4_compoundargs *argp, struct nfsd4_putfh *putfh)
+nfsd4_decode_putfh(struct nfsd4_compoundargs *argp, void *_putfh)
 {
+	struct nfsd4_putfh *putfh = _putfh;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -1020,8 +1041,9 @@ nfsd4_decode_putpubfh(struct nfsd4_compoundargs *argp, void *p)
 }
 
 static __be32
-nfsd4_decode_read(struct nfsd4_compoundargs *argp, struct nfsd4_read *read)
+nfsd4_decode_read(struct nfsd4_compoundargs *argp, void *_read)
 {
+	struct nfsd4_read *read = _read;
 	DECODE_HEAD;
 
 	status = nfsd4_decode_stateid(argp, &read->rd_stateid);
@@ -1035,8 +1057,9 @@ nfsd4_decode_read(struct nfsd4_compoundargs *argp, struct nfsd4_read *read)
 }
 
 static __be32
-nfsd4_decode_readdir(struct nfsd4_compoundargs *argp, struct nfsd4_readdir *readdir)
+nfsd4_decode_readdir(struct nfsd4_compoundargs *argp, void *_readdir)
 {
+	struct nfsd4_readdir *readdir = _readdir;
 	DECODE_HEAD;
 
 	READ_BUF(24);
@@ -1051,8 +1074,9 @@ nfsd4_decode_readdir(struct nfsd4_compoundargs *argp, struct nfsd4_readdir *read
 }
 
 static __be32
-nfsd4_decode_remove(struct nfsd4_compoundargs *argp, struct nfsd4_remove *remove)
+nfsd4_decode_remove(struct nfsd4_compoundargs *argp, void *_remove)
 {
+	struct nfsd4_remove *remove = _remove;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -1066,8 +1090,9 @@ nfsd4_decode_remove(struct nfsd4_compoundargs *argp, struct nfsd4_remove *remove
 }
 
 static __be32
-nfsd4_decode_rename(struct nfsd4_compoundargs *argp, struct nfsd4_rename *rename)
+nfsd4_decode_rename(struct nfsd4_compoundargs *argp, void *_rename)
 {
+	struct nfsd4_rename *rename = _rename;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -1087,7 +1112,7 @@ nfsd4_decode_rename(struct nfsd4_compoundargs *argp, struct nfsd4_rename *rename
 }
 
 static __be32
-nfsd4_decode_renew(struct nfsd4_compoundargs *argp, clientid_t *clientid)
+nfsd4_decode_renew(struct nfsd4_compoundargs *argp, void *clientid)
 {
 	DECODE_HEAD;
 
@@ -1102,8 +1127,9 @@ nfsd4_decode_renew(struct nfsd4_compoundargs *argp, clientid_t *clientid)
 
 static __be32
 nfsd4_decode_secinfo(struct nfsd4_compoundargs *argp,
-		     struct nfsd4_secinfo *secinfo)
+		     void *_secinfo)
 {
+	struct nfsd4_secinfo *secinfo = _secinfo;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -1118,8 +1144,9 @@ nfsd4_decode_secinfo(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_secinfo_no_name(struct nfsd4_compoundargs *argp,
-		     struct nfsd4_secinfo_no_name *sin)
+		     void *_sin)
 {
+	struct nfsd4_secinfo_no_name *sin = _sin;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -1128,8 +1155,9 @@ nfsd4_decode_secinfo_no_name(struct nfsd4_compoundargs *argp,
 }
 
 static __be32
-nfsd4_decode_setattr(struct nfsd4_compoundargs *argp, struct nfsd4_setattr *setattr)
+nfsd4_decode_setattr(struct nfsd4_compoundargs *argp, void *_setattr)
 {
+	struct nfsd4_setattr *setattr = _setattr;
 	__be32 status;
 
 	status = nfsd4_decode_stateid(argp, &setattr->sa_stateid);
@@ -1140,8 +1168,9 @@ nfsd4_decode_setattr(struct nfsd4_compoundargs *argp, struct nfsd4_setattr *seta
 }
 
 static __be32
-nfsd4_decode_setclientid(struct nfsd4_compoundargs *argp, struct nfsd4_setclientid *setclientid)
+nfsd4_decode_setclientid(struct nfsd4_compoundargs *argp, void *_setclientid)
 {
+	struct nfsd4_setclientid *setclientid = _setclientid;
 	DECODE_HEAD;
 
 	if (argp->minorversion >= 1)
@@ -1170,8 +1199,9 @@ nfsd4_decode_setclientid(struct nfsd4_compoundargs *argp, struct nfsd4_setclient
 }
 
 static __be32
-nfsd4_decode_setclientid_confirm(struct nfsd4_compoundargs *argp, struct nfsd4_setclientid_confirm *scd_c)
+nfsd4_decode_setclientid_confirm(struct nfsd4_compoundargs *argp, void *_scd_c)
 {
+	struct nfsd4_setclientid_confirm *scd_c = _scd_c;
 	DECODE_HEAD;
 
 	if (argp->minorversion >= 1)
@@ -1186,8 +1216,9 @@ nfsd4_decode_setclientid_confirm(struct nfsd4_compoundargs *argp, struct nfsd4_s
 
 /* Also used for NVERIFY */
 static __be32
-nfsd4_decode_verify(struct nfsd4_compoundargs *argp, struct nfsd4_verify *verify)
+nfsd4_decode_verify(struct nfsd4_compoundargs *argp, void *_verify)
 {
+	struct nfsd4_verify *verify = _verify;
 	DECODE_HEAD;
 
 	if ((status = nfsd4_decode_bitmap(argp, verify->ve_bmval)))
@@ -1205,8 +1236,9 @@ nfsd4_decode_verify(struct nfsd4_compoundargs *argp, struct nfsd4_verify *verify
 }
 
 static __be32
-nfsd4_decode_write(struct nfsd4_compoundargs *argp, struct nfsd4_write *write)
+nfsd4_decode_write(struct nfsd4_compoundargs *argp, void *_write)
 {
+	struct nfsd4_write *write = _write;
 	int avail;
 	int len;
 	DECODE_HEAD;
@@ -1256,8 +1288,9 @@ nfsd4_decode_write(struct nfsd4_compoundargs *argp, struct nfsd4_write *write)
 }
 
 static __be32
-nfsd4_decode_release_lockowner(struct nfsd4_compoundargs *argp, struct nfsd4_release_lockowner *rlockowner)
+nfsd4_decode_release_lockowner(struct nfsd4_compoundargs *argp, void *_rlockowner)
 {
+	struct nfsd4_release_lockowner *rlockowner = _rlockowner;
 	DECODE_HEAD;
 
 	if (argp->minorversion >= 1)
@@ -1276,8 +1309,9 @@ nfsd4_decode_release_lockowner(struct nfsd4_compoundargs *argp, struct nfsd4_rel
 
 static __be32
 nfsd4_decode_exchange_id(struct nfsd4_compoundargs *argp,
-			 struct nfsd4_exchange_id *exid)
+			 void *_exid)
 {
+	struct nfsd4_exchange_id *exid = _exid;
 	int dummy, tmp;
 	DECODE_HEAD;
 
@@ -1378,8 +1412,9 @@ nfsd4_decode_exchange_id(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_create_session(struct nfsd4_compoundargs *argp,
-			    struct nfsd4_create_session *sess)
+			    void *_sess)
 {
+	struct nfsd4_create_session *sess = _sess;
 	DECODE_HEAD;
 	u32 dummy;
 
@@ -1430,8 +1465,9 @@ nfsd4_decode_create_session(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_destroy_session(struct nfsd4_compoundargs *argp,
-			     struct nfsd4_destroy_session *destroy_session)
+			     void *_destroy_session)
 {
+	struct nfsd4_destroy_session *destroy_session = _destroy_session;
 	DECODE_HEAD;
 	READ_BUF(NFS4_MAX_SESSIONID_LEN);
 	COPYMEM(destroy_session->sessionid.data, NFS4_MAX_SESSIONID_LEN);
@@ -1441,8 +1477,9 @@ nfsd4_decode_destroy_session(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_free_stateid(struct nfsd4_compoundargs *argp,
-			  struct nfsd4_free_stateid *free_stateid)
+			  void *_free_stateid)
 {
+	struct nfsd4_free_stateid *free_stateid = _free_stateid;
 	DECODE_HEAD;
 
 	READ_BUF(sizeof(stateid_t));
@@ -1454,8 +1491,9 @@ nfsd4_decode_free_stateid(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_sequence(struct nfsd4_compoundargs *argp,
-		      struct nfsd4_sequence *seq)
+		      void *_seq)
 {
+	struct nfsd4_sequence *seq = _seq;
 	DECODE_HEAD;
 
 	READ_BUF(NFS4_MAX_SESSIONID_LEN + 16);
@@ -1469,8 +1507,9 @@ nfsd4_decode_sequence(struct nfsd4_compoundargs *argp,
 }
 
 static __be32
-nfsd4_decode_test_stateid(struct nfsd4_compoundargs *argp, struct nfsd4_test_stateid *test_stateid)
+nfsd4_decode_test_stateid(struct nfsd4_compoundargs *argp, void *_test_stateid)
 {
+	struct nfsd4_test_stateid *test_stateid = _test_stateid;
 	int i;
 	__be32 *p, status;
 	struct nfsd4_test_stateid_id *stateid;
@@ -1504,8 +1543,9 @@ xdr_error:
 	goto out;
 }
 
-static __be32 nfsd4_decode_destroy_clientid(struct nfsd4_compoundargs *argp, struct nfsd4_destroy_clientid *dc)
+static __be32 nfsd4_decode_destroy_clientid(struct nfsd4_compoundargs *argp, void *_dc)
 {
+	struct nfsd4_destroy_clientid *dc = _dc;
 	DECODE_HEAD;
 
 	READ_BUF(8);
@@ -1514,8 +1554,9 @@ static __be32 nfsd4_decode_destroy_clientid(struct nfsd4_compoundargs *argp, str
 	DECODE_TAIL;
 }
 
-static __be32 nfsd4_decode_reclaim_complete(struct nfsd4_compoundargs *argp, struct nfsd4_reclaim_complete *rc)
+static __be32 nfsd4_decode_reclaim_complete(struct nfsd4_compoundargs *argp, void *_rc)
 {
+	struct nfsd4_reclaim_complete *rc = _rc;
 	DECODE_HEAD;
 
 	READ_BUF(4);
@@ -1527,8 +1568,9 @@ static __be32 nfsd4_decode_reclaim_complete(struct nfsd4_compoundargs *argp, str
 #ifdef CONFIG_NFSD_PNFS
 static __be32
 nfsd4_decode_getdeviceinfo(struct nfsd4_compoundargs *argp,
-		struct nfsd4_getdeviceinfo *gdev)
+		void *_gdev)
 {
+	struct nfsd4_getdeviceinfo *gdev = _gdev;
 	DECODE_HEAD;
 	u32 num, i;
 
@@ -1552,8 +1594,9 @@ nfsd4_decode_getdeviceinfo(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_layoutget(struct nfsd4_compoundargs *argp,
-		struct nfsd4_layoutget *lgp)
+		void *_lgp)
 {
+	struct nfsd4_layoutget *lgp = _lgp;
 	DECODE_HEAD;
 
 	READ_BUF(36);
@@ -1576,8 +1619,9 @@ nfsd4_decode_layoutget(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_layoutcommit(struct nfsd4_compoundargs *argp,
-		struct nfsd4_layoutcommit *lcp)
+		void *_lcp)
 {
+	struct nfsd4_layoutcommit *lcp = _lcp;
 	DECODE_HEAD;
 	u32 timechange;
 
@@ -1624,8 +1668,9 @@ nfsd4_decode_layoutcommit(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_layoutreturn(struct nfsd4_compoundargs *argp,
-		struct nfsd4_layoutreturn *lrp)
+		void *_lrp)
 {
+	struct nfsd4_layoutreturn *lrp = _lrp;
 	DECODE_HEAD;
 
 	READ_BUF(16);
@@ -1659,8 +1704,9 @@ nfsd4_decode_layoutreturn(struct nfsd4_compoundargs *argp,
 
 static __be32
 nfsd4_decode_fallocate(struct nfsd4_compoundargs *argp,
-		       struct nfsd4_fallocate *fallocate)
+		       void *_fallocate)
 {
+	struct nfsd4_fallocate *fallocate = _fallocate;
 	DECODE_HEAD;
 
 	status = nfsd4_decode_stateid(argp, &fallocate->falloc_stateid);
@@ -1675,8 +1721,9 @@ nfsd4_decode_fallocate(struct nfsd4_compoundargs *argp,
 }
 
 static __be32
-nfsd4_decode_clone(struct nfsd4_compoundargs *argp, struct nfsd4_clone *clone)
+nfsd4_decode_clone(struct nfsd4_compoundargs *argp, void *_clone)
 {
+	struct nfsd4_clone *clone = _clone;
 	DECODE_HEAD;
 
 	status = nfsd4_decode_stateid(argp, &clone->cl_src_stateid);
@@ -1694,8 +1741,9 @@ nfsd4_decode_clone(struct nfsd4_compoundargs *argp, struct nfsd4_clone *clone)
 }
 
 static __be32
-nfsd4_decode_seek(struct nfsd4_compoundargs *argp, struct nfsd4_seek *seek)
+nfsd4_decode_seek(struct nfsd4_compoundargs *argp, void *_seek)
 {
+	struct nfsd4_seek *seek = _seek;
 	DECODE_HEAD;
 
 	status = nfsd4_decode_stateid(argp, &seek->seek_stateid);
@@ -1723,88 +1771,88 @@ nfsd4_decode_notsupp(struct nfsd4_compoundargs *argp, void *p)
 
 typedef __be32(*nfsd4_dec)(struct nfsd4_compoundargs *argp, void *);
 
-static nfsd4_dec nfsd4_dec_ops[] = {
-	[OP_ACCESS]		= (nfsd4_dec)nfsd4_decode_access,
-	[OP_CLOSE]		= (nfsd4_dec)nfsd4_decode_close,
-	[OP_COMMIT]		= (nfsd4_dec)nfsd4_decode_commit,
-	[OP_CREATE]		= (nfsd4_dec)nfsd4_decode_create,
-	[OP_DELEGPURGE]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_DELEGRETURN]	= (nfsd4_dec)nfsd4_decode_delegreturn,
-	[OP_GETATTR]		= (nfsd4_dec)nfsd4_decode_getattr,
-	[OP_GETFH]		= (nfsd4_dec)nfsd4_decode_noop,
-	[OP_LINK]		= (nfsd4_dec)nfsd4_decode_link,
-	[OP_LOCK]		= (nfsd4_dec)nfsd4_decode_lock,
-	[OP_LOCKT]		= (nfsd4_dec)nfsd4_decode_lockt,
-	[OP_LOCKU]		= (nfsd4_dec)nfsd4_decode_locku,
-	[OP_LOOKUP]		= (nfsd4_dec)nfsd4_decode_lookup,
-	[OP_LOOKUPP]		= (nfsd4_dec)nfsd4_decode_noop,
-	[OP_NVERIFY]		= (nfsd4_dec)nfsd4_decode_verify,
-	[OP_OPEN]		= (nfsd4_dec)nfsd4_decode_open,
-	[OP_OPENATTR]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_OPEN_CONFIRM]	= (nfsd4_dec)nfsd4_decode_open_confirm,
-	[OP_OPEN_DOWNGRADE]	= (nfsd4_dec)nfsd4_decode_open_downgrade,
-	[OP_PUTFH]		= (nfsd4_dec)nfsd4_decode_putfh,
-	[OP_PUTPUBFH]		= (nfsd4_dec)nfsd4_decode_putpubfh,
-	[OP_PUTROOTFH]		= (nfsd4_dec)nfsd4_decode_noop,
-	[OP_READ]		= (nfsd4_dec)nfsd4_decode_read,
-	[OP_READDIR]		= (nfsd4_dec)nfsd4_decode_readdir,
-	[OP_READLINK]		= (nfsd4_dec)nfsd4_decode_noop,
-	[OP_REMOVE]		= (nfsd4_dec)nfsd4_decode_remove,
-	[OP_RENAME]		= (nfsd4_dec)nfsd4_decode_rename,
-	[OP_RENEW]		= (nfsd4_dec)nfsd4_decode_renew,
-	[OP_RESTOREFH]		= (nfsd4_dec)nfsd4_decode_noop,
-	[OP_SAVEFH]		= (nfsd4_dec)nfsd4_decode_noop,
-	[OP_SECINFO]		= (nfsd4_dec)nfsd4_decode_secinfo,
-	[OP_SETATTR]		= (nfsd4_dec)nfsd4_decode_setattr,
-	[OP_SETCLIENTID]	= (nfsd4_dec)nfsd4_decode_setclientid,
-	[OP_SETCLIENTID_CONFIRM] = (nfsd4_dec)nfsd4_decode_setclientid_confirm,
-	[OP_VERIFY]		= (nfsd4_dec)nfsd4_decode_verify,
-	[OP_WRITE]		= (nfsd4_dec)nfsd4_decode_write,
-	[OP_RELEASE_LOCKOWNER]	= (nfsd4_dec)nfsd4_decode_release_lockowner,
+static const nfsd4_dec nfsd4_dec_ops[] = {
+	[OP_ACCESS]		= nfsd4_decode_access,
+	[OP_CLOSE]		= nfsd4_decode_close,
+	[OP_COMMIT]		= nfsd4_decode_commit,
+	[OP_CREATE]		= nfsd4_decode_create,
+	[OP_DELEGPURGE]		= nfsd4_decode_notsupp,
+	[OP_DELEGRETURN]	= nfsd4_decode_delegreturn,
+	[OP_GETATTR]		= nfsd4_decode_getattr,
+	[OP_GETFH]		= nfsd4_decode_noop,
+	[OP_LINK]		= nfsd4_decode_link,
+	[OP_LOCK]		= nfsd4_decode_lock,
+	[OP_LOCKT]		= nfsd4_decode_lockt,
+	[OP_LOCKU]		= nfsd4_decode_locku,
+	[OP_LOOKUP]		= nfsd4_decode_lookup,
+	[OP_LOOKUPP]		= nfsd4_decode_noop,
+	[OP_NVERIFY]		= nfsd4_decode_verify,
+	[OP_OPEN]		= nfsd4_decode_open,
+	[OP_OPENATTR]		= nfsd4_decode_notsupp,
+	[OP_OPEN_CONFIRM]	= nfsd4_decode_open_confirm,
+	[OP_OPEN_DOWNGRADE]	= nfsd4_decode_open_downgrade,
+	[OP_PUTFH]		= nfsd4_decode_putfh,
+	[OP_PUTPUBFH]		= nfsd4_decode_putpubfh,
+	[OP_PUTROOTFH]		= nfsd4_decode_noop,
+	[OP_READ]		= nfsd4_decode_read,
+	[OP_READDIR]		= nfsd4_decode_readdir,
+	[OP_READLINK]		= nfsd4_decode_noop,
+	[OP_REMOVE]		= nfsd4_decode_remove,
+	[OP_RENAME]		= nfsd4_decode_rename,
+	[OP_RENEW]		= nfsd4_decode_renew,
+	[OP_RESTOREFH]		= nfsd4_decode_noop,
+	[OP_SAVEFH]		= nfsd4_decode_noop,
+	[OP_SECINFO]		= nfsd4_decode_secinfo,
+	[OP_SETATTR]		= nfsd4_decode_setattr,
+	[OP_SETCLIENTID]	= nfsd4_decode_setclientid,
+	[OP_SETCLIENTID_CONFIRM] = nfsd4_decode_setclientid_confirm,
+	[OP_VERIFY]		= nfsd4_decode_verify,
+	[OP_WRITE]		= nfsd4_decode_write,
+	[OP_RELEASE_LOCKOWNER]	= nfsd4_decode_release_lockowner,
 
 	/* new operations for NFSv4.1 */
-	[OP_BACKCHANNEL_CTL]	= (nfsd4_dec)nfsd4_decode_backchannel_ctl,
-	[OP_BIND_CONN_TO_SESSION]= (nfsd4_dec)nfsd4_decode_bind_conn_to_session,
-	[OP_EXCHANGE_ID]	= (nfsd4_dec)nfsd4_decode_exchange_id,
-	[OP_CREATE_SESSION]	= (nfsd4_dec)nfsd4_decode_create_session,
-	[OP_DESTROY_SESSION]	= (nfsd4_dec)nfsd4_decode_destroy_session,
-	[OP_FREE_STATEID]	= (nfsd4_dec)nfsd4_decode_free_stateid,
-	[OP_GET_DIR_DELEGATION]	= (nfsd4_dec)nfsd4_decode_notsupp,
+	[OP_BACKCHANNEL_CTL]	= nfsd4_decode_backchannel_ctl,
+	[OP_BIND_CONN_TO_SESSION]= nfsd4_decode_bind_conn_to_session,
+	[OP_EXCHANGE_ID]	= nfsd4_decode_exchange_id,
+	[OP_CREATE_SESSION]	= nfsd4_decode_create_session,
+	[OP_DESTROY_SESSION]	= nfsd4_decode_destroy_session,
+	[OP_FREE_STATEID]	= nfsd4_decode_free_stateid,
+	[OP_GET_DIR_DELEGATION]	= nfsd4_decode_notsupp,
 #ifdef CONFIG_NFSD_PNFS
-	[OP_GETDEVICEINFO]	= (nfsd4_dec)nfsd4_decode_getdeviceinfo,
-	[OP_GETDEVICELIST]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_LAYOUTCOMMIT]	= (nfsd4_dec)nfsd4_decode_layoutcommit,
-	[OP_LAYOUTGET]		= (nfsd4_dec)nfsd4_decode_layoutget,
-	[OP_LAYOUTRETURN]	= (nfsd4_dec)nfsd4_decode_layoutreturn,
+	[OP_GETDEVICEINFO]	= nfsd4_decode_getdeviceinfo,
+	[OP_GETDEVICELIST]	= nfsd4_decode_notsupp,
+	[OP_LAYOUTCOMMIT]	= nfsd4_decode_layoutcommit,
+	[OP_LAYOUTGET]		= nfsd4_decode_layoutget,
+	[OP_LAYOUTRETURN]	= nfsd4_decode_layoutreturn,
 #else
-	[OP_GETDEVICEINFO]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_GETDEVICELIST]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_LAYOUTCOMMIT]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_LAYOUTGET]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_LAYOUTRETURN]	= (nfsd4_dec)nfsd4_decode_notsupp,
+	[OP_GETDEVICEINFO]	= nfsd4_decode_notsupp,
+	[OP_GETDEVICELIST]	= nfsd4_decode_notsupp,
+	[OP_LAYOUTCOMMIT]	= nfsd4_decode_notsupp,
+	[OP_LAYOUTGET]		= nfsd4_decode_notsupp,
+	[OP_LAYOUTRETURN]	= nfsd4_decode_notsupp,
 #endif
-	[OP_SECINFO_NO_NAME]	= (nfsd4_dec)nfsd4_decode_secinfo_no_name,
-	[OP_SEQUENCE]		= (nfsd4_dec)nfsd4_decode_sequence,
-	[OP_SET_SSV]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_TEST_STATEID]	= (nfsd4_dec)nfsd4_decode_test_stateid,
-	[OP_WANT_DELEGATION]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_DESTROY_CLIENTID]	= (nfsd4_dec)nfsd4_decode_destroy_clientid,
-	[OP_RECLAIM_COMPLETE]	= (nfsd4_dec)nfsd4_decode_reclaim_complete,
+	[OP_SECINFO_NO_NAME]	= nfsd4_decode_secinfo_no_name,
+	[OP_SEQUENCE]		= nfsd4_decode_sequence,
+	[OP_SET_SSV]		= nfsd4_decode_notsupp,
+	[OP_TEST_STATEID]	= nfsd4_decode_test_stateid,
+	[OP_WANT_DELEGATION]	= nfsd4_decode_notsupp,
+	[OP_DESTROY_CLIENTID]	= nfsd4_decode_destroy_clientid,
+	[OP_RECLAIM_COMPLETE]	= nfsd4_decode_reclaim_complete,
 
 	/* new operations for NFSv4.2 */
-	[OP_ALLOCATE]		= (nfsd4_dec)nfsd4_decode_fallocate,
-	[OP_COPY]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_COPY_NOTIFY]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_DEALLOCATE]		= (nfsd4_dec)nfsd4_decode_fallocate,
-	[OP_IO_ADVISE]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_LAYOUTERROR]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_LAYOUTSTATS]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_OFFLOAD_CANCEL]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_OFFLOAD_STATUS]	= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_READ_PLUS]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_SEEK]		= (nfsd4_dec)nfsd4_decode_seek,
-	[OP_WRITE_SAME]		= (nfsd4_dec)nfsd4_decode_notsupp,
-	[OP_CLONE]		= (nfsd4_dec)nfsd4_decode_clone,
+	[OP_ALLOCATE]		= nfsd4_decode_fallocate,
+	[OP_COPY]		= nfsd4_decode_notsupp,
+	[OP_COPY_NOTIFY]	= nfsd4_decode_notsupp,
+	[OP_DEALLOCATE]		= nfsd4_decode_fallocate,
+	[OP_IO_ADVISE]		= nfsd4_decode_notsupp,
+	[OP_LAYOUTERROR]	= nfsd4_decode_notsupp,
+	[OP_LAYOUTSTATS]	= nfsd4_decode_notsupp,
+	[OP_OFFLOAD_CANCEL]	= nfsd4_decode_notsupp,
+	[OP_OFFLOAD_STATUS]	= nfsd4_decode_notsupp,
+	[OP_READ_PLUS]		= nfsd4_decode_notsupp,
+	[OP_SEEK]		= nfsd4_decode_seek,
+	[OP_WRITE_SAME]		= nfsd4_decode_notsupp,
+	[OP_CLONE]		= nfsd4_decode_clone,
 };
 
 static inline bool
@@ -3032,8 +3080,9 @@ nfsd4_encode_stateid(struct xdr_stream *xdr, stateid_t *sid)
 }
 
 static __be32
-nfsd4_encode_access(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_access *access)
+nfsd4_encode_access(struct nfsd4_compoundres *resp, __be32 nfserr, void *_access)
 {
+	struct nfsd4_access *access = _access;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3047,8 +3096,9 @@ nfsd4_encode_access(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_
 	return nfserr;
 }
 
-static __be32 nfsd4_encode_bind_conn_to_session(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_bind_conn_to_session *bcts)
+static __be32 nfsd4_encode_bind_conn_to_session(struct nfsd4_compoundres *resp, __be32 nfserr, void *_bcts)
 {
+	struct nfsd4_bind_conn_to_session *bcts = _bcts;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3066,8 +3116,10 @@ static __be32 nfsd4_encode_bind_conn_to_session(struct nfsd4_compoundres *resp,
 }
 
 static __be32
-nfsd4_encode_close(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_close *close)
+nfsd4_encode_close(struct nfsd4_compoundres *resp, __be32 nfserr, void *_close)
 {
+	struct nfsd4_close *close = _close;
+
 	struct xdr_stream *xdr = &resp->xdr;
 
 	if (!nfserr)
@@ -3078,8 +3130,9 @@ nfsd4_encode_close(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_c
 
 
 static __be32
-nfsd4_encode_commit(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_commit *commit)
+nfsd4_encode_commit(struct nfsd4_compoundres *resp, __be32 nfserr, void *_commit)
 {
+	struct nfsd4_commit *commit = _commit;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3094,8 +3147,9 @@ nfsd4_encode_commit(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_
 }
 
 static __be32
-nfsd4_encode_create(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_create *create)
+nfsd4_encode_create(struct nfsd4_compoundres *resp, __be32 nfserr, void *_create)
 {
+	struct nfsd4_create *create = _create;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3111,8 +3165,9 @@ nfsd4_encode_create(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_
 }
 
 static __be32
-nfsd4_encode_getattr(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_getattr *getattr)
+nfsd4_encode_getattr(struct nfsd4_compoundres *resp, __be32 nfserr, void *_getattr)
 {
+	struct nfsd4_getattr *getattr = _getattr;
 	struct svc_fh *fhp = getattr->ga_fhp;
 	struct xdr_stream *xdr = &resp->xdr;
 
@@ -3126,8 +3181,9 @@ nfsd4_encode_getattr(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4
 }
 
 static __be32
-nfsd4_encode_getfh(struct nfsd4_compoundres *resp, __be32 nfserr, struct svc_fh **fhpp)
+nfsd4_encode_getfh(struct nfsd4_compoundres *resp, __be32 nfserr, void *_fhpp)
 {
+	struct svc_fh **fhpp = (struct svc_fh **)_fhpp;
 	struct xdr_stream *xdr = &resp->xdr;
 	struct svc_fh *fhp = *fhpp;
 	unsigned int len;
@@ -3183,8 +3239,10 @@ again:
 }
 
 static __be32
-nfsd4_encode_lock(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_lock *lock)
+nfsd4_encode_lock(struct nfsd4_compoundres *resp, __be32 nfserr, void *_lock)
 {
+	struct nfsd4_lock *lock = _lock;
+
 	struct xdr_stream *xdr = &resp->xdr;
 
 	if (!nfserr)
@@ -3196,8 +3254,9 @@ nfsd4_encode_lock(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_lo
 }
 
 static __be32
-nfsd4_encode_lockt(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_lockt *lockt)
+nfsd4_encode_lockt(struct nfsd4_compoundres *resp, __be32 nfserr, void *_lockt)
 {
+	struct nfsd4_lockt *lockt = _lockt;
 	struct xdr_stream *xdr = &resp->xdr;
 
 	if (nfserr == nfserr_denied)
@@ -3206,8 +3265,9 @@ nfsd4_encode_lockt(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_l
 }
 
 static __be32
-nfsd4_encode_locku(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_locku *locku)
+nfsd4_encode_locku(struct nfsd4_compoundres *resp, __be32 nfserr, void *_locku)
 {
+	struct nfsd4_locku *locku = _locku;
 	struct xdr_stream *xdr = &resp->xdr;
 
 	if (!nfserr)
@@ -3218,8 +3278,9 @@ nfsd4_encode_locku(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_l
 
 
 static __be32
-nfsd4_encode_link(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_link *link)
+nfsd4_encode_link(struct nfsd4_compoundres *resp, __be32 nfserr, void *_link)
 {
+	struct nfsd4_link *link = _link;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3234,8 +3295,9 @@ nfsd4_encode_link(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_li
 
 
 static __be32
-nfsd4_encode_open(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_open *open)
+nfsd4_encode_open(struct nfsd4_compoundres *resp, __be32 nfserr, void *_open)
 {
+	struct nfsd4_open *open = _open;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3332,8 +3394,10 @@ out:
 }
 
 static __be32
-nfsd4_encode_open_confirm(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_open_confirm *oc)
+nfsd4_encode_open_confirm(struct nfsd4_compoundres *resp, __be32 nfserr, void *_oc)
 {
+	struct nfsd4_open_confirm *oc = _oc;
+
 	struct xdr_stream *xdr = &resp->xdr;
 
 	if (!nfserr)
@@ -3343,8 +3407,10 @@ nfsd4_encode_open_confirm(struct nfsd4_compoundres *resp, __be32 nfserr, struct
 }
 
 static __be32
-nfsd4_encode_open_downgrade(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_open_downgrade *od)
+nfsd4_encode_open_downgrade(struct nfsd4_compoundres *resp, __be32 nfserr, void *_od)
 {
+	struct nfsd4_open_downgrade *od = _od;
+
 	struct xdr_stream *xdr = &resp->xdr;
 
 	if (!nfserr)
@@ -3477,9 +3543,9 @@ static __be32 nfsd4_encode_readv(struct nfsd4_compoundres *resp,
 }
 
 static __be32
-nfsd4_encode_read(struct nfsd4_compoundres *resp, __be32 nfserr,
-		  struct nfsd4_read *read)
+nfsd4_encode_read(struct nfsd4_compoundres *resp, __be32 nfserr, void *_read)
 {
+	struct nfsd4_read *read = _read;
 	unsigned long maxcount;
 	struct xdr_stream *xdr = &resp->xdr;
 	struct file *file = read->rd_filp;
@@ -3531,8 +3597,9 @@ out:
 }
 
 static __be32
-nfsd4_encode_readlink(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_readlink *readlink)
+nfsd4_encode_readlink(struct nfsd4_compoundres *resp, __be32 nfserr, void *_readlink)
 {
+	struct nfsd4_readlink *readlink = _readlink;
 	int maxcount;
 	__be32 wire_count;
 	int zero = 0;
@@ -3576,8 +3643,9 @@ nfsd4_encode_readlink(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd
 }
 
 static __be32
-nfsd4_encode_readdir(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_readdir *readdir)
+nfsd4_encode_readdir(struct nfsd4_compoundres *resp, __be32 nfserr, void *_readdir)
 {
+	struct nfsd4_readdir *readdir = _readdir;
 	int maxcount;
 	int bytes_left;
 	loff_t offset;
@@ -3669,8 +3737,9 @@ err_no_verf:
 }
 
 static __be32
-nfsd4_encode_remove(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_remove *remove)
+nfsd4_encode_remove(struct nfsd4_compoundres *resp, __be32 nfserr, void *_remove)
 {
+	struct nfsd4_remove *remove = _remove;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3684,8 +3753,9 @@ nfsd4_encode_remove(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_
 }
 
 static __be32
-nfsd4_encode_rename(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_rename *rename)
+nfsd4_encode_rename(struct nfsd4_compoundres *resp, __be32 nfserr, void *_rename)
 {
+	struct nfsd4_rename *rename = _rename;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3701,8 +3771,9 @@ nfsd4_encode_rename(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_
 
 static __be32
 nfsd4_do_encode_secinfo(struct xdr_stream *xdr,
-			 __be32 nfserr, struct svc_export *exp)
+			 __be32 nfserr, void *_exp)
 {
+	struct svc_export *exp = _exp;
 	u32 i, nflavs, supported;
 	struct exp_flavor_info *flavs;
 	struct exp_flavor_info def_flavs[2];
@@ -3777,8 +3848,9 @@ out:
 
 static __be32
 nfsd4_encode_secinfo(struct nfsd4_compoundres *resp, __be32 nfserr,
-		     struct nfsd4_secinfo *secinfo)
+		     void *_secinfo)
 {
+	struct nfsd4_secinfo *secinfo = _secinfo;
 	struct xdr_stream *xdr = &resp->xdr;
 
 	return nfsd4_do_encode_secinfo(xdr, nfserr, secinfo->si_exp);
@@ -3786,8 +3858,9 @@ nfsd4_encode_secinfo(struct nfsd4_compoundres *resp, __be32 nfserr,
 
 static __be32
 nfsd4_encode_secinfo_no_name(struct nfsd4_compoundres *resp, __be32 nfserr,
-		     struct nfsd4_secinfo_no_name *secinfo)
+		     void *_secinfo)
 {
+	struct nfsd4_secinfo_no_name *secinfo = _secinfo;
 	struct xdr_stream *xdr = &resp->xdr;
 
 	return nfsd4_do_encode_secinfo(xdr, nfserr, secinfo->sin_exp);
@@ -3798,8 +3871,9 @@ nfsd4_encode_secinfo_no_name(struct nfsd4_compoundres *resp, __be32 nfserr,
  * regardless of the error status.
  */
 static __be32
-nfsd4_encode_setattr(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_setattr *setattr)
+nfsd4_encode_setattr(struct nfsd4_compoundres *resp, __be32 nfserr, void *_setattr)
 {
+	struct nfsd4_setattr *setattr = _setattr;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3822,8 +3896,9 @@ nfsd4_encode_setattr(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4
 }
 
 static __be32
-nfsd4_encode_setclientid(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_setclientid *scd)
+nfsd4_encode_setclientid(struct nfsd4_compoundres *resp, __be32 nfserr, void *_scd)
 {
+	struct nfsd4_setclientid *scd = _scd;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3846,8 +3921,9 @@ nfsd4_encode_setclientid(struct nfsd4_compoundres *resp, __be32 nfserr, struct n
 }
 
 static __be32
-nfsd4_encode_write(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_write *write)
+nfsd4_encode_write(struct nfsd4_compoundres *resp, __be32 nfserr, void *_write)
 {
+	struct nfsd4_write *write = _write;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -3865,8 +3941,9 @@ nfsd4_encode_write(struct nfsd4_compoundres *resp, __be32 nfserr, struct nfsd4_w
 
 static __be32
 nfsd4_encode_exchange_id(struct nfsd4_compoundres *resp, __be32 nfserr,
-			 struct nfsd4_exchange_id *exid)
+			 void *_exid)
 {
+	struct nfsd4_exchange_id *exid = _exid;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 	char *major_id;
@@ -3948,8 +4025,9 @@ out:
 
 static __be32
 nfsd4_encode_create_session(struct nfsd4_compoundres *resp, __be32 nfserr,
-			    struct nfsd4_create_session *sess)
+			    void *_sess)
 {
+	struct nfsd4_create_session *sess = _sess;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -4004,8 +4082,9 @@ nfsd4_encode_create_session(struct nfsd4_compoundres *resp, __be32 nfserr,
 
 static __be32
 nfsd4_encode_sequence(struct nfsd4_compoundres *resp, __be32 nfserr,
-		      struct nfsd4_sequence *seq)
+		      void *_seq)
 {
+	struct nfsd4_sequence *seq = _seq;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -4030,8 +4109,9 @@ nfsd4_encode_sequence(struct nfsd4_compoundres *resp, __be32 nfserr,
 
 static __be32
 nfsd4_encode_test_stateid(struct nfsd4_compoundres *resp, __be32 nfserr,
-			  struct nfsd4_test_stateid *test_stateid)
+			  void *_test_stateid)
 {
+	struct nfsd4_test_stateid *test_stateid = _test_stateid;
 	struct xdr_stream *xdr = &resp->xdr;
 	struct nfsd4_test_stateid_id *stateid, *next;
 	__be32 *p;
@@ -4053,9 +4133,9 @@ nfsd4_encode_test_stateid(struct nfsd4_compoundres *resp, __be32 nfserr,
 
 #ifdef CONFIG_NFSD_PNFS
 static __be32
-nfsd4_encode_getdeviceinfo(struct nfsd4_compoundres *resp, __be32 nfserr,
-		struct nfsd4_getdeviceinfo *gdev)
+nfsd4_encode_getdeviceinfo(struct nfsd4_compoundres *resp, __be32 nfserr, void *_gdev)
 {
+	struct nfsd4_getdeviceinfo *gdev = _gdev;
 	struct xdr_stream *xdr = &resp->xdr;
 	const struct nfsd4_layout_ops *ops =
 		nfsd4_layout_ops[gdev->gd_layout_type];
@@ -4123,9 +4203,9 @@ toosmall:
 }
 
 static __be32
-nfsd4_encode_layoutget(struct nfsd4_compoundres *resp, __be32 nfserr,
-		struct nfsd4_layoutget *lgp)
+nfsd4_encode_layoutget(struct nfsd4_compoundres *resp, __be32 nfserr, void *_lgp)
 {
+	struct nfsd4_layoutget *lgp = _lgp;
 	struct xdr_stream *xdr = &resp->xdr;
 	const struct nfsd4_layout_ops *ops =
 		nfsd4_layout_ops[lgp->lg_layout_type];
@@ -4158,9 +4238,9 @@ out:
 }
 
 static __be32
-nfsd4_encode_layoutcommit(struct nfsd4_compoundres *resp, __be32 nfserr,
-			  struct nfsd4_layoutcommit *lcp)
+nfsd4_encode_layoutcommit(struct nfsd4_compoundres *resp, __be32 nfserr, void *_lcp)
 {
+	struct nfsd4_layoutcommit *lcp = _lcp;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -4182,9 +4262,9 @@ nfsd4_encode_layoutcommit(struct nfsd4_compoundres *resp, __be32 nfserr,
 }
 
 static __be32
-nfsd4_encode_layoutreturn(struct nfsd4_compoundres *resp, __be32 nfserr,
-		struct nfsd4_layoutreturn *lrp)
+nfsd4_encode_layoutreturn(struct nfsd4_compoundres *resp, __be32 nfserr, void *_lrp)
 {
+	struct nfsd4_layoutreturn *lrp = _lrp;
 	struct xdr_stream *xdr = &resp->xdr;
 	__be32 *p;
 
@@ -4203,8 +4283,9 @@ nfsd4_encode_layoutreturn(struct nfsd4_compoundres *resp, __be32 nfserr,
 
 static __be32
 nfsd4_encode_seek(struct nfsd4_compoundres *resp, __be32 nfserr,
-		  struct nfsd4_seek *seek)
+		  void *_seek)
 {
+	struct nfsd4_seek *seek= (struct nfsd4_seek *)_seek;
 	__be32 *p;
 
 	if (nfserr)
@@ -4231,87 +4312,87 @@ typedef __be32(* nfsd4_enc)(struct nfsd4_compoundres *, __be32, void *);
  * done in the decoding phase.
  */
 static nfsd4_enc nfsd4_enc_ops[] = {
-	[OP_ACCESS]		= (nfsd4_enc)nfsd4_encode_access,
-	[OP_CLOSE]		= (nfsd4_enc)nfsd4_encode_close,
-	[OP_COMMIT]		= (nfsd4_enc)nfsd4_encode_commit,
-	[OP_CREATE]		= (nfsd4_enc)nfsd4_encode_create,
-	[OP_DELEGPURGE]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_DELEGRETURN]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_GETATTR]		= (nfsd4_enc)nfsd4_encode_getattr,
-	[OP_GETFH]		= (nfsd4_enc)nfsd4_encode_getfh,
-	[OP_LINK]		= (nfsd4_enc)nfsd4_encode_link,
-	[OP_LOCK]		= (nfsd4_enc)nfsd4_encode_lock,
-	[OP_LOCKT]		= (nfsd4_enc)nfsd4_encode_lockt,
-	[OP_LOCKU]		= (nfsd4_enc)nfsd4_encode_locku,
-	[OP_LOOKUP]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_LOOKUPP]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_NVERIFY]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_OPEN]		= (nfsd4_enc)nfsd4_encode_open,
-	[OP_OPENATTR]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_OPEN_CONFIRM]	= (nfsd4_enc)nfsd4_encode_open_confirm,
-	[OP_OPEN_DOWNGRADE]	= (nfsd4_enc)nfsd4_encode_open_downgrade,
-	[OP_PUTFH]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_PUTPUBFH]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_PUTROOTFH]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_READ]		= (nfsd4_enc)nfsd4_encode_read,
-	[OP_READDIR]		= (nfsd4_enc)nfsd4_encode_readdir,
-	[OP_READLINK]		= (nfsd4_enc)nfsd4_encode_readlink,
-	[OP_REMOVE]		= (nfsd4_enc)nfsd4_encode_remove,
-	[OP_RENAME]		= (nfsd4_enc)nfsd4_encode_rename,
-	[OP_RENEW]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_RESTOREFH]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_SAVEFH]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_SECINFO]		= (nfsd4_enc)nfsd4_encode_secinfo,
-	[OP_SETATTR]		= (nfsd4_enc)nfsd4_encode_setattr,
-	[OP_SETCLIENTID]	= (nfsd4_enc)nfsd4_encode_setclientid,
-	[OP_SETCLIENTID_CONFIRM] = (nfsd4_enc)nfsd4_encode_noop,
-	[OP_VERIFY]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_WRITE]		= (nfsd4_enc)nfsd4_encode_write,
-	[OP_RELEASE_LOCKOWNER]	= (nfsd4_enc)nfsd4_encode_noop,
+	[OP_ACCESS]		= nfsd4_encode_access,
+	[OP_CLOSE]		= nfsd4_encode_close,
+	[OP_COMMIT]		= nfsd4_encode_commit,
+	[OP_CREATE]		= nfsd4_encode_create,
+	[OP_DELEGPURGE]		= nfsd4_encode_noop,
+	[OP_DELEGRETURN]	= nfsd4_encode_noop,
+	[OP_GETATTR]		= nfsd4_encode_getattr,
+	[OP_GETFH]		= nfsd4_encode_getfh,
+	[OP_LINK]		= nfsd4_encode_link,
+	[OP_LOCK]		= nfsd4_encode_lock,
+	[OP_LOCKT]		= nfsd4_encode_lockt,
+	[OP_LOCKU]		= nfsd4_encode_locku,
+	[OP_LOOKUP]		= nfsd4_encode_noop,
+	[OP_LOOKUPP]		= nfsd4_encode_noop,
+	[OP_NVERIFY]		= nfsd4_encode_noop,
+	[OP_OPEN]		= nfsd4_encode_open,
+	[OP_OPENATTR]		= nfsd4_encode_noop,
+	[OP_OPEN_CONFIRM]	= nfsd4_encode_open_confirm,
+	[OP_OPEN_DOWNGRADE]	= nfsd4_encode_open_downgrade,
+	[OP_PUTFH]		= nfsd4_encode_noop,
+	[OP_PUTPUBFH]		= nfsd4_encode_noop,
+	[OP_PUTROOTFH]		= nfsd4_encode_noop,
+	[OP_READ]		= nfsd4_encode_read,
+	[OP_READDIR]		= nfsd4_encode_readdir,
+	[OP_READLINK]		= nfsd4_encode_readlink,
+	[OP_REMOVE]		= nfsd4_encode_remove,
+	[OP_RENAME]		= nfsd4_encode_rename,
+	[OP_RENEW]		= nfsd4_encode_noop,
+	[OP_RESTOREFH]		= nfsd4_encode_noop,
+	[OP_SAVEFH]		= nfsd4_encode_noop,
+	[OP_SECINFO]		= nfsd4_encode_secinfo,
+	[OP_SETATTR]		= nfsd4_encode_setattr,
+	[OP_SETCLIENTID]	= nfsd4_encode_setclientid,
+	[OP_SETCLIENTID_CONFIRM] = nfsd4_encode_noop,
+	[OP_VERIFY]		= nfsd4_encode_noop,
+	[OP_WRITE]		= nfsd4_encode_write,
+	[OP_RELEASE_LOCKOWNER]	= nfsd4_encode_noop,
 
 	/* NFSv4.1 operations */
-	[OP_BACKCHANNEL_CTL]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_BIND_CONN_TO_SESSION] = (nfsd4_enc)nfsd4_encode_bind_conn_to_session,
-	[OP_EXCHANGE_ID]	= (nfsd4_enc)nfsd4_encode_exchange_id,
-	[OP_CREATE_SESSION]	= (nfsd4_enc)nfsd4_encode_create_session,
-	[OP_DESTROY_SESSION]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_FREE_STATEID]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_GET_DIR_DELEGATION]	= (nfsd4_enc)nfsd4_encode_noop,
+	[OP_BACKCHANNEL_CTL]	= nfsd4_encode_noop,
+	[OP_BIND_CONN_TO_SESSION] = nfsd4_encode_bind_conn_to_session,
+	[OP_EXCHANGE_ID]	= nfsd4_encode_exchange_id,
+	[OP_CREATE_SESSION]	= nfsd4_encode_create_session,
+	[OP_DESTROY_SESSION]	= nfsd4_encode_noop,
+	[OP_FREE_STATEID]	= nfsd4_encode_noop,
+	[OP_GET_DIR_DELEGATION]	= nfsd4_encode_noop,
 #ifdef CONFIG_NFSD_PNFS
-	[OP_GETDEVICEINFO]	= (nfsd4_enc)nfsd4_encode_getdeviceinfo,
-	[OP_GETDEVICELIST]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_LAYOUTCOMMIT]	= (nfsd4_enc)nfsd4_encode_layoutcommit,
-	[OP_LAYOUTGET]		= (nfsd4_enc)nfsd4_encode_layoutget,
-	[OP_LAYOUTRETURN]	= (nfsd4_enc)nfsd4_encode_layoutreturn,
+	[OP_GETDEVICEINFO]	= nfsd4_encode_getdeviceinfo,
+	[OP_GETDEVICELIST]	= nfsd4_encode_noop,
+	[OP_LAYOUTCOMMIT]	= nfsd4_encode_layoutcommit,
+	[OP_LAYOUTGET]		= nfsd4_encode_layoutget,
+	[OP_LAYOUTRETURN]	= nfsd4_encode_layoutreturn,
 #else
-	[OP_GETDEVICEINFO]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_GETDEVICELIST]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_LAYOUTCOMMIT]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_LAYOUTGET]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_LAYOUTRETURN]	= (nfsd4_enc)nfsd4_encode_noop,
+	[OP_GETDEVICEINFO]	= nfsd4_encode_noop,
+	[OP_GETDEVICELIST]	= nfsd4_encode_noop,
+	[OP_LAYOUTCOMMIT]	= nfsd4_encode_noop,
+	[OP_LAYOUTGET]		= nfsd4_encode_noop,
+	[OP_LAYOUTRETURN]	= nfsd4_encode_noop,
 #endif
-	[OP_SECINFO_NO_NAME]	= (nfsd4_enc)nfsd4_encode_secinfo_no_name,
-	[OP_SEQUENCE]		= (nfsd4_enc)nfsd4_encode_sequence,
-	[OP_SET_SSV]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_TEST_STATEID]	= (nfsd4_enc)nfsd4_encode_test_stateid,
-	[OP_WANT_DELEGATION]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_DESTROY_CLIENTID]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_RECLAIM_COMPLETE]	= (nfsd4_enc)nfsd4_encode_noop,
+	[OP_SECINFO_NO_NAME]	= nfsd4_encode_secinfo_no_name,
+	[OP_SEQUENCE]		= nfsd4_encode_sequence,
+	[OP_SET_SSV]		= nfsd4_encode_noop,
+	[OP_TEST_STATEID]	= nfsd4_encode_test_stateid,
+	[OP_WANT_DELEGATION]	= nfsd4_encode_noop,
+	[OP_DESTROY_CLIENTID]	= nfsd4_encode_noop,
+	[OP_RECLAIM_COMPLETE]	= nfsd4_encode_noop,
 
 	/* NFSv4.2 operations */
-	[OP_ALLOCATE]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_COPY]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_COPY_NOTIFY]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_DEALLOCATE]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_IO_ADVISE]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_LAYOUTERROR]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_LAYOUTSTATS]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_OFFLOAD_CANCEL]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_OFFLOAD_STATUS]	= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_READ_PLUS]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_SEEK]		= (nfsd4_enc)nfsd4_encode_seek,
-	[OP_WRITE_SAME]		= (nfsd4_enc)nfsd4_encode_noop,
-	[OP_CLONE]		= (nfsd4_enc)nfsd4_encode_noop,
+	[OP_ALLOCATE]		= nfsd4_encode_noop,
+	[OP_COPY]		= nfsd4_encode_noop,
+	[OP_COPY_NOTIFY]	= nfsd4_encode_noop,
+	[OP_DEALLOCATE]		= nfsd4_encode_noop,
+	[OP_IO_ADVISE]		= nfsd4_encode_noop,
+	[OP_LAYOUTERROR]	= nfsd4_encode_noop,
+	[OP_LAYOUTSTATS]	= nfsd4_encode_noop,
+	[OP_OFFLOAD_CANCEL]	= nfsd4_encode_noop,
+	[OP_OFFLOAD_STATUS]	= nfsd4_encode_noop,
+	[OP_READ_PLUS]		= nfsd4_encode_noop,
+	[OP_SEEK]		= nfsd4_encode_seek,
+	[OP_WRITE_SAME]		= nfsd4_encode_noop,
+	[OP_CLONE]		= nfsd4_encode_noop,
 };
 
 /*
@@ -4436,9 +4517,9 @@ nfsd4_encode_replay(struct xdr_stream *xdr, struct nfsd4_op *op)
 }
 
 int
-nfs4svc_encode_voidres(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nfs4svc_encode_voidres(void *rqstp, __be32 *p, void *dummy)
 {
-        return xdr_ressize_check(rqstp, p);
+	return xdr_ressize_check(rqstp, p);
 }
 
 int nfsd4_release_compoundargs(void *rq, __be32 *p, void *resp)
@@ -4461,8 +4542,11 @@ int nfsd4_release_compoundargs(void *rq, __be32 *p, void *resp)
 }
 
 int
-nfs4svc_decode_compoundargs(struct svc_rqst *rqstp, __be32 *p, struct nfsd4_compoundargs *args)
+nfs4svc_decode_compoundargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd4_compoundargs *args = _args;
+
 	if (rqstp->rq_arg.head[0].iov_len % 4) {
 		/* client is nuts */
 		dprintk("%s: compound not properly padded! (peeraddr=%pISc xid=0x%x)",
@@ -4482,11 +4566,13 @@ nfs4svc_decode_compoundargs(struct svc_rqst *rqstp, __be32 *p, struct nfsd4_comp
 }
 
 int
-nfs4svc_encode_compoundres(struct svc_rqst *rqstp, __be32 *p, struct nfsd4_compoundres *resp)
+nfs4svc_encode_compoundres(void *_rqstp, __be32 *p, void *_resp)
 {
 	/*
 	 * All that remains is to write the tag and operation count...
 	 */
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd4_compoundres *resp = _resp;
 	struct xdr_buf *buf = resp->xdr.buf;
 
 	WARN_ON_ONCE(buf->len != buf->head[0].iov_len + buf->page_len +
diff --git a/fs/nfsd/nfscache.c b/fs/nfsd/nfscache.c
index 54cde9a58..ff5756c63 100644
--- a/fs/nfsd/nfscache.c
+++ b/fs/nfsd/nfscache.c
@@ -513,7 +513,7 @@ nfsd_cache_update(struct svc_rqst *rqstp, int cachetype, __be32 *statp)
 	struct kvec	*resv = &rqstp->rq_res.head[0], *cachv;
 	u32		hash;
 	struct nfsd_drc_bucket *b;
-	int		len;
+	long		len;
 	size_t		bufsize = 0;
 
 	if (!rp)
@@ -522,11 +522,14 @@ nfsd_cache_update(struct svc_rqst *rqstp, int cachetype, __be32 *statp)
 	hash = nfsd_cache_hash(rp->c_xid);
 	b = &drc_hashtbl[hash];
 
-	len = resv->iov_len - ((char*)statp - (char*)resv->iov_base);
-	len >>= 2;
+	if (statp) {
+		len = (char*)statp - (char*)resv->iov_base;
+		len = resv->iov_len - len;
+		len >>= 2;
+	}
 
 	/* Don't cache excessive amounts of data and XDR failures */
-	if (!statp || len > (256 >> 2)) {
+	if (!statp || len > (256 >> 2) || len < 0) {
 		nfsd_reply_cache_free(b, rp);
 		return;
 	}
@@ -534,7 +537,7 @@ nfsd_cache_update(struct svc_rqst *rqstp, int cachetype, __be32 *statp)
 	switch (cachetype) {
 	case RC_REPLSTAT:
 		if (len != 1)
-			printk("nfsd: RC_REPLSTAT/reply len %d!\n",len);
+			printk("nfsd: RC_REPLSTAT/reply len %ld!\n",len);
 		rp->c_replstat = *statp;
 		break;
 	case RC_REPLBUFF:
diff --git a/fs/nfsd/nfsproc.c b/fs/nfsd/nfsproc.c
index e9214768c..fcda44c99 100644
--- a/fs/nfsd/nfsproc.c
+++ b/fs/nfsd/nfsproc.c
@@ -39,9 +39,11 @@ nfsd_return_dirop(__be32 err, struct nfsd_diropres *resp)
  * N.B. After this call resp->fh needs an fh_put
  */
 static __be32
-nfsd_proc_getattr(struct svc_rqst *rqstp, struct nfsd_fhandle  *argp,
-					  struct nfsd_attrstat *resp)
+nfsd_proc_getattr(struct svc_rqst *rqstp, void *_argp,
+					  void *_resp)
 {
+	struct nfsd_fhandle *argp = _argp;
+	struct nfsd_attrstat *resp = _resp;
 	__be32 nfserr;
 	dprintk("nfsd: GETATTR  %s\n", SVCFH_fmt(&argp->fh));
 
@@ -56,9 +58,11 @@ nfsd_proc_getattr(struct svc_rqst *rqstp, struct nfsd_fhandle  *argp,
  * N.B. After this call resp->fh needs an fh_put
  */
 static __be32
-nfsd_proc_setattr(struct svc_rqst *rqstp, struct nfsd_sattrargs *argp,
-					  struct nfsd_attrstat  *resp)
+nfsd_proc_setattr(struct svc_rqst *rqstp, void *_argp,
+					  void *_resp)
 {
+	struct nfsd_sattrargs *argp = _argp;
+	struct nfsd_attrstat *resp = _resp;
 	struct iattr *iap = &argp->attrs;
 	struct svc_fh *fhp;
 	__be32 nfserr;
@@ -124,9 +128,11 @@ done:
  * N.B. After this call resp->fh needs an fh_put
  */
 static __be32
-nfsd_proc_lookup(struct svc_rqst *rqstp, struct nfsd_diropargs *argp,
-					 struct nfsd_diropres  *resp)
+nfsd_proc_lookup(struct svc_rqst *rqstp, void *_argp,
+					 void *_resp)
 {
+	struct nfsd_diropargs *argp = _argp;
+	struct nfsd_diropres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: LOOKUP   %s %.*s\n",
@@ -144,9 +150,11 @@ nfsd_proc_lookup(struct svc_rqst *rqstp, struct nfsd_diropargs *argp,
  * Read a symlink.
  */
 static __be32
-nfsd_proc_readlink(struct svc_rqst *rqstp, struct nfsd_readlinkargs *argp,
-					   struct nfsd_readlinkres *resp)
+nfsd_proc_readlink(struct svc_rqst *rqstp, void *_argp,
+					   void *_resp)
 {
+	struct nfsd_readlinkargs *argp = _argp;
+	struct nfsd_readlinkres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: READLINK %s\n", SVCFH_fmt(&argp->fh));
@@ -164,9 +172,11 @@ nfsd_proc_readlink(struct svc_rqst *rqstp, struct nfsd_readlinkargs *argp,
  * N.B. After this call resp->fh needs an fh_put
  */
 static __be32
-nfsd_proc_read(struct svc_rqst *rqstp, struct nfsd_readargs *argp,
-				       struct nfsd_readres  *resp)
+nfsd_proc_read(struct svc_rqst *rqstp, void *_argp,
+				       void *_resp)
 {
+	struct nfsd_readargs *argp = _argp;
+	struct nfsd_readres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: READ    %s %d bytes at %d\n",
@@ -202,9 +212,11 @@ nfsd_proc_read(struct svc_rqst *rqstp, struct nfsd_readargs *argp,
  * N.B. After this call resp->fh needs an fh_put
  */
 static __be32
-nfsd_proc_write(struct svc_rqst *rqstp, struct nfsd_writeargs *argp,
-					struct nfsd_attrstat  *resp)
+nfsd_proc_write(struct svc_rqst *rqstp, void *_argp,
+					void *_resp)
 {
+	struct nfsd_writeargs *argp = _argp;
+	struct nfsd_attrstat *resp = _resp;
 	__be32	nfserr;
 	int	stable = 1;
 	unsigned long cnt = argp->len;
@@ -228,9 +240,11 @@ nfsd_proc_write(struct svc_rqst *rqstp, struct nfsd_writeargs *argp,
  * N.B. After this call _both_ argp->fh and resp->fh need an fh_put
  */
 static __be32
-nfsd_proc_create(struct svc_rqst *rqstp, struct nfsd_createargs *argp,
-					 struct nfsd_diropres   *resp)
+nfsd_proc_create(struct svc_rqst *rqstp, void *_argp,
+					 void *_resp)
 {
+	struct nfsd_createargs *argp = _argp;
+	struct nfsd_diropres  *resp = _resp;
 	svc_fh		*dirfhp = &argp->fh;
 	svc_fh		*newfhp = &resp->fh;
 	struct iattr	*attr = &argp->attrs;
@@ -383,9 +397,10 @@ done:
 }
 
 static __be32
-nfsd_proc_remove(struct svc_rqst *rqstp, struct nfsd_diropargs *argp,
+nfsd_proc_remove(struct svc_rqst *rqstp, void *_argp,
 					 void		       *resp)
 {
+	struct nfsd_diropargs *argp = _argp;
 	__be32	nfserr;
 
 	dprintk("nfsd: REMOVE   %s %.*s\n", SVCFH_fmt(&argp->fh),
@@ -398,9 +413,10 @@ nfsd_proc_remove(struct svc_rqst *rqstp, struct nfsd_diropargs *argp,
 }
 
 static __be32
-nfsd_proc_rename(struct svc_rqst *rqstp, struct nfsd_renameargs *argp,
+nfsd_proc_rename(struct svc_rqst *rqstp, void *_argp,
 				  	 void		        *resp)
 {
+	struct nfsd_renameargs *argp = _argp;
 	__be32	nfserr;
 
 	dprintk("nfsd: RENAME   %s %.*s -> \n",
@@ -416,9 +432,10 @@ nfsd_proc_rename(struct svc_rqst *rqstp, struct nfsd_renameargs *argp,
 }
 
 static __be32
-nfsd_proc_link(struct svc_rqst *rqstp, struct nfsd_linkargs *argp,
+nfsd_proc_link(struct svc_rqst *rqstp, void *_argp,
 				void			    *resp)
 {
+	struct nfsd_linkargs *argp = _argp;
 	__be32	nfserr;
 
 	dprintk("nfsd: LINK     %s ->\n",
@@ -436,9 +453,10 @@ nfsd_proc_link(struct svc_rqst *rqstp, struct nfsd_linkargs *argp,
 }
 
 static __be32
-nfsd_proc_symlink(struct svc_rqst *rqstp, struct nfsd_symlinkargs *argp,
+nfsd_proc_symlink(struct svc_rqst *rqstp, void *_argp,
 				          void			  *resp)
 {
+	struct nfsd_symlinkargs *argp = _argp;
 	struct svc_fh	newfh;
 	__be32		nfserr;
 
@@ -466,9 +484,11 @@ nfsd_proc_symlink(struct svc_rqst *rqstp, struct nfsd_symlinkargs *argp,
  * N.B. After this call resp->fh needs an fh_put
  */
 static __be32
-nfsd_proc_mkdir(struct svc_rqst *rqstp, struct nfsd_createargs *argp,
-					struct nfsd_diropres   *resp)
+nfsd_proc_mkdir(struct svc_rqst *rqstp, void *_argp,
+					void *_resp)
 {
+	struct nfsd_createargs *argp = _argp;
+	struct nfsd_diropres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: MKDIR    %s %.*s\n", SVCFH_fmt(&argp->fh), argp->len, argp->name);
@@ -490,9 +510,10 @@ nfsd_proc_mkdir(struct svc_rqst *rqstp, struct nfsd_createargs *argp,
  * Remove a directory
  */
 static __be32
-nfsd_proc_rmdir(struct svc_rqst *rqstp, struct nfsd_diropargs *argp,
+nfsd_proc_rmdir(struct svc_rqst *rqstp, void *_argp,
 				 	void		      *resp)
 {
+	struct nfsd_diropargs *argp = _argp;
 	__be32	nfserr;
 
 	dprintk("nfsd: RMDIR    %s %.*s\n", SVCFH_fmt(&argp->fh), argp->len, argp->name);
@@ -506,9 +527,11 @@ nfsd_proc_rmdir(struct svc_rqst *rqstp, struct nfsd_diropargs *argp,
  * Read a portion of a directory.
  */
 static __be32
-nfsd_proc_readdir(struct svc_rqst *rqstp, struct nfsd_readdirargs *argp,
-					  struct nfsd_readdirres  *resp)
+nfsd_proc_readdir(struct svc_rqst *rqstp, void *_argp,
+					  void *_resp)
 {
+	struct nfsd_readdirargs *argp = _argp;
+	struct nfsd_readdirres  *resp = _resp;
 	int		count;
 	__be32		nfserr;
 	loff_t		offset;
@@ -546,9 +569,11 @@ nfsd_proc_readdir(struct svc_rqst *rqstp, struct nfsd_readdirargs *argp,
  * Get file system info
  */
 static __be32
-nfsd_proc_statfs(struct svc_rqst * rqstp, struct nfsd_fhandle   *argp,
-					  struct nfsd_statfsres *resp)
+nfsd_proc_statfs(struct svc_rqst * rqstp, void *_argp,
+					  void *_resp)
 {
+	struct nfsd_fhandle *argp = _argp;
+	struct nfsd_statfsres *resp = _resp;
 	__be32	nfserr;
 
 	dprintk("nfsd: STATFS   %s\n", SVCFH_fmt(&argp->fh));
@@ -571,166 +596,166 @@ struct nfsd_void { int dummy; };
 
 static struct svc_procedure		nfsd_procedures2[18] = {
 	[NFSPROC_NULL] = {
-		.pc_func = (svc_procfunc) nfsd_proc_null,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_void,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_func = nfsd_proc_null,
+		.pc_decode = nfssvc_decode_void,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_void),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_GETATTR] = {
-		.pc_func = (svc_procfunc) nfsd_proc_getattr,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_fhandle,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_attrstat,
-		.pc_release = (kxdrproc_t) nfssvc_release_fhandle,
+		.pc_func = nfsd_proc_getattr,
+		.pc_decode = nfssvc_decode_fhandle,
+		.pc_encode = nfssvc_encode_attrstat,
+		.pc_release = nfssvc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd_fhandle),
 		.pc_ressize = sizeof(struct nfsd_attrstat),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+AT,
 	},
 	[NFSPROC_SETATTR] = {
-		.pc_func = (svc_procfunc) nfsd_proc_setattr,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_sattrargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_attrstat,
-		.pc_release = (kxdrproc_t) nfssvc_release_fhandle,
+		.pc_func = nfsd_proc_setattr,
+		.pc_decode = nfssvc_decode_sattrargs,
+		.pc_encode = nfssvc_encode_attrstat,
+		.pc_release = nfssvc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd_sattrargs),
 		.pc_ressize = sizeof(struct nfsd_attrstat),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+AT,
 	},
 	[NFSPROC_ROOT] = {
-		.pc_decode = (kxdrproc_t) nfssvc_decode_void,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_decode = nfssvc_decode_void,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_void),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_LOOKUP] = {
-		.pc_func = (svc_procfunc) nfsd_proc_lookup,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_diropargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_diropres,
-		.pc_release = (kxdrproc_t) nfssvc_release_fhandle,
+		.pc_func = nfsd_proc_lookup,
+		.pc_decode = nfssvc_decode_diropargs,
+		.pc_encode = nfssvc_encode_diropres,
+		.pc_release = nfssvc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd_diropargs),
 		.pc_ressize = sizeof(struct nfsd_diropres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+FH+AT,
 	},
 	[NFSPROC_READLINK] = {
-		.pc_func = (svc_procfunc) nfsd_proc_readlink,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_readlinkargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_readlinkres,
+		.pc_func = nfsd_proc_readlink,
+		.pc_decode = nfssvc_decode_readlinkargs,
+		.pc_encode = nfssvc_encode_readlinkres,
 		.pc_argsize = sizeof(struct nfsd_readlinkargs),
 		.pc_ressize = sizeof(struct nfsd_readlinkres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+1+NFS_MAXPATHLEN/4,
 	},
 	[NFSPROC_READ] = {
-		.pc_func = (svc_procfunc) nfsd_proc_read,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_readargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_readres,
-		.pc_release = (kxdrproc_t) nfssvc_release_fhandle,
+		.pc_func = nfsd_proc_read,
+		.pc_decode = nfssvc_decode_readargs,
+		.pc_encode = nfssvc_encode_readres,
+		.pc_release = nfssvc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd_readargs),
 		.pc_ressize = sizeof(struct nfsd_readres),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST+AT+1+NFSSVC_MAXBLKSIZE_V2/4,
 	},
 	[NFSPROC_WRITECACHE] = {
-		.pc_decode = (kxdrproc_t) nfssvc_decode_void,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_decode = nfssvc_decode_void,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_void),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_NOCACHE,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_WRITE] = {
-		.pc_func = (svc_procfunc) nfsd_proc_write,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_writeargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_attrstat,
-		.pc_release = (kxdrproc_t) nfssvc_release_fhandle,
+		.pc_func = nfsd_proc_write,
+		.pc_decode = nfssvc_decode_writeargs,
+		.pc_encode = nfssvc_encode_attrstat,
+		.pc_release = nfssvc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd_writeargs),
 		.pc_ressize = sizeof(struct nfsd_attrstat),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+AT,
 	},
 	[NFSPROC_CREATE] = {
-		.pc_func = (svc_procfunc) nfsd_proc_create,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_createargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_diropres,
-		.pc_release = (kxdrproc_t) nfssvc_release_fhandle,
+		.pc_func = nfsd_proc_create,
+		.pc_decode = nfssvc_decode_createargs,
+		.pc_encode = nfssvc_encode_diropres,
+		.pc_release = nfssvc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd_createargs),
 		.pc_ressize = sizeof(struct nfsd_diropres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+FH+AT,
 	},
 	[NFSPROC_REMOVE] = {
-		.pc_func = (svc_procfunc) nfsd_proc_remove,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_diropargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_func = nfsd_proc_remove,
+		.pc_decode = nfssvc_decode_diropargs,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_diropargs),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_REPLSTAT,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_RENAME] = {
-		.pc_func = (svc_procfunc) nfsd_proc_rename,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_renameargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_func = nfsd_proc_rename,
+		.pc_decode = nfssvc_decode_renameargs,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_renameargs),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_REPLSTAT,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_LINK] = {
-		.pc_func = (svc_procfunc) nfsd_proc_link,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_linkargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_func = nfsd_proc_link,
+		.pc_decode = nfssvc_decode_linkargs,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_linkargs),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_REPLSTAT,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_SYMLINK] = {
-		.pc_func = (svc_procfunc) nfsd_proc_symlink,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_symlinkargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_func = nfsd_proc_symlink,
+		.pc_decode = nfssvc_decode_symlinkargs,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_symlinkargs),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_REPLSTAT,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_MKDIR] = {
-		.pc_func = (svc_procfunc) nfsd_proc_mkdir,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_createargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_diropres,
-		.pc_release = (kxdrproc_t) nfssvc_release_fhandle,
+		.pc_func = nfsd_proc_mkdir,
+		.pc_decode = nfssvc_decode_createargs,
+		.pc_encode = nfssvc_encode_diropres,
+		.pc_release = nfssvc_release_fhandle,
 		.pc_argsize = sizeof(struct nfsd_createargs),
 		.pc_ressize = sizeof(struct nfsd_diropres),
 		.pc_cachetype = RC_REPLBUFF,
 		.pc_xdrressize = ST+FH+AT,
 	},
 	[NFSPROC_RMDIR] = {
-		.pc_func = (svc_procfunc) nfsd_proc_rmdir,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_diropargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_void,
+		.pc_func = nfsd_proc_rmdir,
+		.pc_decode = nfssvc_decode_diropargs,
+		.pc_encode = nfssvc_encode_void,
 		.pc_argsize = sizeof(struct nfsd_diropargs),
 		.pc_ressize = sizeof(struct nfsd_void),
 		.pc_cachetype = RC_REPLSTAT,
 		.pc_xdrressize = ST,
 	},
 	[NFSPROC_READDIR] = {
-		.pc_func = (svc_procfunc) nfsd_proc_readdir,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_readdirargs,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_readdirres,
+		.pc_func = nfsd_proc_readdir,
+		.pc_decode = nfssvc_decode_readdirargs,
+		.pc_encode = nfssvc_encode_readdirres,
 		.pc_argsize = sizeof(struct nfsd_readdirargs),
 		.pc_ressize = sizeof(struct nfsd_readdirres),
 		.pc_cachetype = RC_NOCACHE,
 	},
 	[NFSPROC_STATFS] = {
-		.pc_func = (svc_procfunc) nfsd_proc_statfs,
-		.pc_decode = (kxdrproc_t) nfssvc_decode_fhandle,
-		.pc_encode = (kxdrproc_t) nfssvc_encode_statfsres,
+		.pc_func = nfsd_proc_statfs,
+		.pc_decode = nfssvc_decode_fhandle,
+		.pc_encode = nfssvc_encode_statfsres,
 		.pc_argsize = sizeof(struct nfsd_fhandle),
 		.pc_ressize = sizeof(struct nfsd_statfsres),
 		.pc_cachetype = RC_NOCACHE,
diff --git a/fs/nfsd/nfsxdr.c b/fs/nfsd/nfsxdr.c
index 41b468a6a..44e3e32a7 100644
--- a/fs/nfsd/nfsxdr.c
+++ b/fs/nfsd/nfsxdr.c
@@ -206,14 +206,16 @@ __be32 *nfs2svc_encode_fattr(struct svc_rqst *rqstp, __be32 *p, struct svc_fh *f
  * XDR decode functions
  */
 int
-nfssvc_decode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nfssvc_decode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_argsize_check(rqstp, p);
 }
 
 int
-nfssvc_decode_fhandle(struct svc_rqst *rqstp, __be32 *p, struct nfsd_fhandle *args)
+nfssvc_decode_fhandle(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_fhandle *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -221,9 +223,10 @@ nfssvc_decode_fhandle(struct svc_rqst *rqstp, __be32 *p, struct nfsd_fhandle *ar
 }
 
 int
-nfssvc_decode_sattrargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_sattrargs *args)
+nfssvc_decode_sattrargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_sattrargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -233,9 +236,10 @@ nfssvc_decode_sattrargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_diropargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_diropargs *args)
+nfssvc_decode_diropargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_diropargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->fh))
 	 || !(p = decode_filename(p, &args->name, &args->len)))
 		return 0;
@@ -244,9 +248,10 @@ nfssvc_decode_diropargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_readargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_readargs *args)
+nfssvc_decode_readargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd_readargs *args = _args;
 	unsigned int len;
 	int v;
 	p = decode_fh(p, &args->fh);
@@ -276,9 +281,10 @@ nfssvc_decode_readargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_writeargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_writeargs *args)
+nfssvc_decode_writeargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd_writeargs *args = _args;
 	unsigned int len, hdr, dlen;
 	int v;
 
@@ -330,9 +336,10 @@ nfssvc_decode_writeargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_createargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_createargs *args)
+nfssvc_decode_createargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_createargs *args = _args;
+
 	if (   !(p = decode_fh(p, &args->fh))
 	    || !(p = decode_filename(p, &args->name, &args->len)))
 		return 0;
@@ -342,9 +349,10 @@ nfssvc_decode_createargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_renameargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_renameargs *args)
+nfssvc_decode_renameargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_renameargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->ffh))
 	 || !(p = decode_filename(p, &args->fname, &args->flen))
 	 || !(p = decode_fh(p, &args->tfh))
@@ -355,8 +363,11 @@ nfssvc_decode_renameargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_readlinkargs(struct svc_rqst *rqstp, __be32 *p, struct nfsd_readlinkargs *args)
+nfssvc_decode_readlinkargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd_readlinkargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -366,9 +377,10 @@ nfssvc_decode_readlinkargs(struct svc_rqst *rqstp, __be32 *p, struct nfsd_readli
 }
 
 int
-nfssvc_decode_linkargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_linkargs *args)
+nfssvc_decode_linkargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_linkargs *args = _args;
+
 	if (!(p = decode_fh(p, &args->ffh))
 	 || !(p = decode_fh(p, &args->tfh))
 	 || !(p = decode_filename(p, &args->tname, &args->tlen)))
@@ -378,9 +390,10 @@ nfssvc_decode_linkargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_symlinkargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_symlinkargs *args)
+nfssvc_decode_symlinkargs(void *rqstp, __be32 *p, void *_args)
 {
+	struct nfsd_symlinkargs *args = _args;
+
 	if (   !(p = decode_fh(p, &args->ffh))
 	    || !(p = decode_filename(p, &args->fname, &args->flen))
 	    || !(p = decode_pathname(p, &args->tname, &args->tlen)))
@@ -391,9 +404,11 @@ nfssvc_decode_symlinkargs(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_decode_readdirargs(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_readdirargs *args)
+nfssvc_decode_readdirargs(void *_rqstp, __be32 *p, void *_args)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd_readdirargs *args = _args;
+
 	p = decode_fh(p, &args->fh);
 	if (!p)
 		return 0;
@@ -409,32 +424,36 @@ nfssvc_decode_readdirargs(struct svc_rqst *rqstp, __be32 *p,
  * XDR encode functions
  */
 int
-nfssvc_encode_void(struct svc_rqst *rqstp, __be32 *p, void *dummy)
+nfssvc_encode_void(void *rqstp, __be32 *p, void *dummy)
 {
 	return xdr_ressize_check(rqstp, p);
 }
 
 int
-nfssvc_encode_attrstat(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_attrstat *resp)
+nfssvc_encode_attrstat(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd_diropres *resp = _resp;
+
 	p = encode_fattr(rqstp, p, &resp->fh, &resp->stat);
 	return xdr_ressize_check(rqstp, p);
 }
 
 int
-nfssvc_encode_diropres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_diropres *resp)
+nfssvc_encode_diropres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd_diropres *resp = _resp;
+
 	p = encode_fh(p, &resp->fh);
 	p = encode_fattr(rqstp, p, &resp->fh, &resp->stat);
 	return xdr_ressize_check(rqstp, p);
 }
 
 int
-nfssvc_encode_readlinkres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_readlinkres *resp)
+nfssvc_encode_readlinkres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp= _rqstp;
+	struct nfsd_readlinkres *resp = _resp;
+
 	*p++ = htonl(resp->len);
 	xdr_ressize_check(rqstp, p);
 	rqstp->rq_res.page_len = resp->len;
@@ -448,9 +467,11 @@ nfssvc_encode_readlinkres(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_encode_readres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_readres *resp)
+nfssvc_encode_readres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd_readres *resp = _resp;
+
 	p = encode_fattr(rqstp, p, &resp->fh, &resp->stat);
 	*p++ = htonl(resp->count);
 	xdr_ressize_check(rqstp, p);
@@ -467,9 +488,11 @@ nfssvc_encode_readres(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_encode_readdirres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_readdirres *resp)
+nfssvc_encode_readdirres(void *_rqstp, __be32 *p, void *_resp)
 {
+	struct svc_rqst *rqstp = _rqstp;
+	struct nfsd_readdirres *resp = _resp;
+
 	xdr_ressize_check(rqstp, p);
 	p = resp->buffer;
 	*p++ = 0;			/* no more entries */
@@ -480,9 +503,9 @@ nfssvc_encode_readdirres(struct svc_rqst *rqstp, __be32 *p,
 }
 
 int
-nfssvc_encode_statfsres(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_statfsres *resp)
+nfssvc_encode_statfsres(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd_statfsres *resp = _resp;
 	struct kstatfs	*stat = &resp->stats;
 
 	*p++ = htonl(NFSSVC_MAXBLKSIZE_V2);	/* max transfer size */
@@ -542,9 +565,10 @@ nfssvc_encode_entry(void *ccdv, const char *name,
  * XDR release functions
  */
 int
-nfssvc_release_fhandle(struct svc_rqst *rqstp, __be32 *p,
-					struct nfsd_fhandle *resp)
+nfssvc_release_fhandle(void *rqstp, __be32 *p, void *_resp)
 {
+	struct nfsd_fhandle *resp = _resp;
+
 	fh_put(&resp->fh);
 	return 1;
 }
diff --git a/fs/nfsd/vfs.c b/fs/nfsd/vfs.c
index ff476e654..08ef36224 100644
--- a/fs/nfsd/vfs.c
+++ b/fs/nfsd/vfs.c
@@ -870,7 +870,7 @@ __be32 nfsd_readv(struct file *file, loff_t offset, struct kvec *vec, int vlen,
 
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
-	host_err = vfs_readv(file, (struct iovec __user *)vec, vlen, &offset, 0);
+	host_err = vfs_readv(file, (struct iovec __force_user *)vec, vlen, &offset, 0);
 	set_fs(oldfs);
 	return nfsd_finish_read(file, count, host_err);
 }
@@ -960,7 +960,7 @@ nfsd_vfs_write(struct svc_rqst *rqstp, struct svc_fh *fhp, struct file *file,
 
 	/* Write the data. */
 	oldfs = get_fs(); set_fs(KERNEL_DS);
-	host_err = vfs_writev(file, (struct iovec __user *)vec, vlen, &pos, flags);
+	host_err = vfs_writev(file, (struct iovec __force_user *)vec, vlen, &pos, flags);
 	set_fs(oldfs);
 	if (host_err < 0)
 		goto out_nfserr;
@@ -1459,7 +1459,7 @@ nfsd_readlink(struct svc_rqst *rqstp, struct svc_fh *fhp, char *buf, int *lenp)
 	 */
 
 	oldfs = get_fs(); set_fs(KERNEL_DS);
-	host_err = inode->i_op->readlink(path.dentry, (char __user *)buf, *lenp);
+	host_err = inode->i_op->readlink(path.dentry, (char __force_user *)buf, *lenp);
 	set_fs(oldfs);
 
 	if (host_err < 0)
diff --git a/fs/nfsd/xdr.h b/fs/nfsd/xdr.h
index 4f0481d63..193c8e74d 100644
--- a/fs/nfsd/xdr.h
+++ b/fs/nfsd/xdr.h
@@ -131,40 +131,30 @@ union nfsd_xdrstore {
 #define NFS2_SVC_XDRSIZE	sizeof(union nfsd_xdrstore)
 
 
-int nfssvc_decode_void(struct svc_rqst *, __be32 *, void *);
-int nfssvc_decode_fhandle(struct svc_rqst *, __be32 *, struct nfsd_fhandle *);
-int nfssvc_decode_sattrargs(struct svc_rqst *, __be32 *,
-				struct nfsd_sattrargs *);
-int nfssvc_decode_diropargs(struct svc_rqst *, __be32 *,
-				struct nfsd_diropargs *);
-int nfssvc_decode_readargs(struct svc_rqst *, __be32 *,
-				struct nfsd_readargs *);
-int nfssvc_decode_writeargs(struct svc_rqst *, __be32 *,
-				struct nfsd_writeargs *);
-int nfssvc_decode_createargs(struct svc_rqst *, __be32 *,
-				struct nfsd_createargs *);
-int nfssvc_decode_renameargs(struct svc_rqst *, __be32 *,
-				struct nfsd_renameargs *);
-int nfssvc_decode_readlinkargs(struct svc_rqst *, __be32 *,
-				struct nfsd_readlinkargs *);
-int nfssvc_decode_linkargs(struct svc_rqst *, __be32 *,
-				struct nfsd_linkargs *);
-int nfssvc_decode_symlinkargs(struct svc_rqst *, __be32 *,
-				struct nfsd_symlinkargs *);
-int nfssvc_decode_readdirargs(struct svc_rqst *, __be32 *,
-				struct nfsd_readdirargs *);
-int nfssvc_encode_void(struct svc_rqst *, __be32 *, void *);
-int nfssvc_encode_attrstat(struct svc_rqst *, __be32 *, struct nfsd_attrstat *);
-int nfssvc_encode_diropres(struct svc_rqst *, __be32 *, struct nfsd_diropres *);
-int nfssvc_encode_readlinkres(struct svc_rqst *, __be32 *, struct nfsd_readlinkres *);
-int nfssvc_encode_readres(struct svc_rqst *, __be32 *, struct nfsd_readres *);
-int nfssvc_encode_statfsres(struct svc_rqst *, __be32 *, struct nfsd_statfsres *);
-int nfssvc_encode_readdirres(struct svc_rqst *, __be32 *, struct nfsd_readdirres *);
+int nfssvc_decode_void(void *, __be32 *, void *);
+int nfssvc_decode_fhandle(void *, __be32 *, void *);
+int nfssvc_decode_sattrargs(void *, __be32 *, void *);
+int nfssvc_decode_diropargs(void *, __be32 *, void *);
+int nfssvc_decode_readargs(void *, __be32 *, void *);
+int nfssvc_decode_writeargs(void *, __be32 *, void *);
+int nfssvc_decode_createargs(void *, __be32 *, void *);
+int nfssvc_decode_renameargs(void *, __be32 *, void *);
+int nfssvc_decode_readlinkargs(void *, __be32 *, void *);
+int nfssvc_decode_linkargs(void *, __be32 *, void *);
+int nfssvc_decode_symlinkargs(void *, __be32 *, void *);
+int nfssvc_decode_readdirargs(void *, __be32 *, void *);
+int nfssvc_encode_void(void *, __be32 *, void *);
+int nfssvc_encode_attrstat(void *, __be32 *, void *);
+int nfssvc_encode_diropres(void *, __be32 *, void *);
+int nfssvc_encode_readlinkres(void *, __be32 *, void *);
+int nfssvc_encode_readres(void *, __be32 *, void *);
+int nfssvc_encode_statfsres(void *, __be32 *, void *);
+int nfssvc_encode_readdirres(void *, __be32 *, void *);
 
 int nfssvc_encode_entry(void *, const char *name,
 			int namlen, loff_t offset, u64 ino, unsigned int);
 
-int nfssvc_release_fhandle(struct svc_rqst *, __be32 *, struct nfsd_fhandle *);
+int nfssvc_release_fhandle(void *, __be32 *, void *);
 
 /* Helper functions for NFSv2 ACL code */
 __be32 *nfs2svc_encode_fattr(struct svc_rqst *rqstp, __be32 *p, struct svc_fh *fhp, struct kstat *stat);
diff --git a/fs/nfsd/xdr3.h b/fs/nfsd/xdr3.h
index 335e04aaf..d77a9c91c 100644
--- a/fs/nfsd/xdr3.h
+++ b/fs/nfsd/xdr3.h
@@ -269,71 +269,41 @@ union nfsd3_xdrstore {
 
 #define NFS3_SVC_XDRSIZE		sizeof(union nfsd3_xdrstore)
 
-int nfs3svc_decode_fhandle(struct svc_rqst *, __be32 *, struct nfsd_fhandle *);
-int nfs3svc_decode_sattrargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_sattrargs *);
-int nfs3svc_decode_diropargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_diropargs *);
-int nfs3svc_decode_accessargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_accessargs *);
-int nfs3svc_decode_readargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_readargs *);
-int nfs3svc_decode_writeargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_writeargs *);
-int nfs3svc_decode_createargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_createargs *);
-int nfs3svc_decode_mkdirargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_createargs *);
-int nfs3svc_decode_mknodargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_mknodargs *);
-int nfs3svc_decode_renameargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_renameargs *);
-int nfs3svc_decode_readlinkargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_readlinkargs *);
-int nfs3svc_decode_linkargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_linkargs *);
-int nfs3svc_decode_symlinkargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_symlinkargs *);
-int nfs3svc_decode_readdirargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_readdirargs *);
-int nfs3svc_decode_readdirplusargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_readdirargs *);
-int nfs3svc_decode_commitargs(struct svc_rqst *, __be32 *,
-				struct nfsd3_commitargs *);
-int nfs3svc_encode_voidres(struct svc_rqst *, __be32 *, void *);
-int nfs3svc_encode_attrstat(struct svc_rqst *, __be32 *,
-				struct nfsd3_attrstat *);
-int nfs3svc_encode_wccstat(struct svc_rqst *, __be32 *,
-				struct nfsd3_attrstat *);
-int nfs3svc_encode_diropres(struct svc_rqst *, __be32 *,
-				struct nfsd3_diropres *);
-int nfs3svc_encode_accessres(struct svc_rqst *, __be32 *,
-				struct nfsd3_accessres *);
-int nfs3svc_encode_readlinkres(struct svc_rqst *, __be32 *,
-				struct nfsd3_readlinkres *);
-int nfs3svc_encode_readres(struct svc_rqst *, __be32 *, struct nfsd3_readres *);
-int nfs3svc_encode_writeres(struct svc_rqst *, __be32 *, struct nfsd3_writeres *);
-int nfs3svc_encode_createres(struct svc_rqst *, __be32 *,
-				struct nfsd3_diropres *);
-int nfs3svc_encode_renameres(struct svc_rqst *, __be32 *,
-				struct nfsd3_renameres *);
-int nfs3svc_encode_linkres(struct svc_rqst *, __be32 *,
-				struct nfsd3_linkres *);
-int nfs3svc_encode_readdirres(struct svc_rqst *, __be32 *,
-				struct nfsd3_readdirres *);
-int nfs3svc_encode_fsstatres(struct svc_rqst *, __be32 *,
-				struct nfsd3_fsstatres *);
-int nfs3svc_encode_fsinfores(struct svc_rqst *, __be32 *,
-				struct nfsd3_fsinfores *);
-int nfs3svc_encode_pathconfres(struct svc_rqst *, __be32 *,
-				struct nfsd3_pathconfres *);
-int nfs3svc_encode_commitres(struct svc_rqst *, __be32 *,
-				struct nfsd3_commitres *);
-
-int nfs3svc_release_fhandle(struct svc_rqst *, __be32 *,
-				struct nfsd3_attrstat *);
-int nfs3svc_release_fhandle2(struct svc_rqst *, __be32 *,
-				struct nfsd3_fhandle_pair *);
+int nfs3svc_decode_fhandle(void *, __be32 *, void *);
+int nfs3svc_decode_sattrargs(void *, __be32 *, void *);
+int nfs3svc_decode_diropargs(void *, __be32 *, void *);
+int nfs3svc_decode_accessargs(void *, __be32 *, void *);
+int nfs3svc_decode_readargs(void *, __be32 *, void *);
+int nfs3svc_decode_writeargs(void *, __be32 *, void *);
+int nfs3svc_decode_createargs(void *, __be32 *, void *);
+int nfs3svc_decode_mkdirargs(void *, __be32 *, void *);
+int nfs3svc_decode_mknodargs(void *, __be32 *, void *);
+int nfs3svc_decode_renameargs(void *, __be32 *, void *);
+int nfs3svc_decode_readlinkargs(void *, __be32 *, void *);
+int nfs3svc_decode_linkargs(void *, __be32 *, void *);
+int nfs3svc_decode_symlinkargs(void *, __be32 *, void *);
+int nfs3svc_decode_readdirargs(void *, __be32 *, void *);
+int nfs3svc_decode_readdirplusargs(void *, __be32 *, void *);
+int nfs3svc_decode_commitargs(void *, __be32 *, void *);
+int nfs3svc_encode_voidres(void *, __be32 *, void *);
+int nfs3svc_encode_attrstat(void *, __be32 *, void *);
+int nfs3svc_encode_wccstat(void *, __be32 *, void *);
+int nfs3svc_encode_diropres(void *, __be32 *, void *);
+int nfs3svc_encode_accessres(void *, __be32 *, void *);
+int nfs3svc_encode_readlinkres(void *, __be32 *, void *);
+int nfs3svc_encode_readres(void *, __be32 *, void *);
+int nfs3svc_encode_writeres(void *, __be32 *, void *);
+int nfs3svc_encode_createres(void *, __be32 *, void *);
+int nfs3svc_encode_renameres(void *, __be32 *, void *);
+int nfs3svc_encode_linkres(void *, __be32 *, void *);
+int nfs3svc_encode_readdirres(void *, __be32 *, void *);
+int nfs3svc_encode_fsstatres(void *, __be32 *, void *);
+int nfs3svc_encode_fsinfores(void *, __be32 *, void *);
+int nfs3svc_encode_pathconfres(void *, __be32 *, void *);
+int nfs3svc_encode_commitres(void *, __be32 *, void *);
+
+int nfs3svc_release_fhandle(void *, __be32 *, void *);
+int nfs3svc_release_fhandle2(void *, __be32 *, void *);
 int nfs3svc_encode_entry(void *, const char *name,
 				int namlen, loff_t offset, u64 ino,
 				unsigned int);
diff --git a/fs/nfsd/xdr4.h b/fs/nfsd/xdr4.h
index beea0c5ed..7f3699d8f 100644
--- a/fs/nfsd/xdr4.h
+++ b/fs/nfsd/xdr4.h
@@ -659,11 +659,9 @@ set_change_info(struct nfsd4_change_info *cinfo, struct svc_fh *fhp)
 
 
 bool nfsd4_mach_creds_match(struct nfs4_client *cl, struct svc_rqst *rqstp);
-int nfs4svc_encode_voidres(struct svc_rqst *, __be32 *, void *);
-int nfs4svc_decode_compoundargs(struct svc_rqst *, __be32 *,
-		struct nfsd4_compoundargs *);
-int nfs4svc_encode_compoundres(struct svc_rqst *, __be32 *,
-		struct nfsd4_compoundres *);
+int nfs4svc_encode_voidres(void *, __be32 *, void *);
+int nfs4svc_decode_compoundargs(void *, __be32 *, void *);
+int nfs4svc_encode_compoundres(void *, __be32 *, void *);
 __be32 nfsd4_check_resp_size(struct nfsd4_compoundres *, u32);
 void nfsd4_encode_operation(struct nfsd4_compoundres *, struct nfsd4_op *);
 void nfsd4_encode_replay(struct xdr_stream *xdr, struct nfsd4_op *op);
@@ -673,26 +671,26 @@ __be32 nfsd4_encode_fattr_to_buf(__be32 **p, int words,
 		u32 *bmval, struct svc_rqst *, int ignore_crossmnt);
 extern __be32 nfsd4_setclientid(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *,
-		struct nfsd4_setclientid *setclid);
+		void *setclid);
 extern __be32 nfsd4_setclientid_confirm(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *,
-		struct nfsd4_setclientid_confirm *setclientid_confirm);
+		void *setclientid_confirm);
 extern __be32 nfsd4_exchange_id(struct svc_rqst *rqstp,
-		struct nfsd4_compound_state *, struct nfsd4_exchange_id *);
-extern __be32 nfsd4_backchannel_ctl(struct svc_rqst *, struct nfsd4_compound_state *, struct nfsd4_backchannel_ctl *);
-extern __be32 nfsd4_bind_conn_to_session(struct svc_rqst *, struct nfsd4_compound_state *, struct nfsd4_bind_conn_to_session *);
+		struct nfsd4_compound_state *, void *);
+extern __be32 nfsd4_backchannel_ctl(struct svc_rqst *, struct nfsd4_compound_state *, void *);
+extern __be32 nfsd4_bind_conn_to_session(struct svc_rqst *, struct nfsd4_compound_state *, void *);
 extern __be32 nfsd4_create_session(struct svc_rqst *,
 		struct nfsd4_compound_state *,
-		struct nfsd4_create_session *);
+		void *);
 extern __be32 nfsd4_sequence(struct svc_rqst *,
 		struct nfsd4_compound_state *,
-		struct nfsd4_sequence *);
+		void *);
 extern void nfsd4_sequence_done(struct nfsd4_compoundres *resp);
 extern __be32 nfsd4_destroy_session(struct svc_rqst *,
 		struct nfsd4_compound_state *,
-		struct nfsd4_destroy_session *);
-extern __be32 nfsd4_destroy_clientid(struct svc_rqst *, struct nfsd4_compound_state *, struct nfsd4_destroy_clientid *);
-__be32 nfsd4_reclaim_complete(struct svc_rqst *, struct nfsd4_compound_state *, struct nfsd4_reclaim_complete *);
+		void *);
+extern __be32 nfsd4_destroy_clientid(struct svc_rqst *, struct nfsd4_compound_state *, void *);
+__be32 nfsd4_reclaim_complete(struct svc_rqst *, struct nfsd4_compound_state *, void *);
 extern __be32 nfsd4_process_open1(struct nfsd4_compound_state *,
 		struct nfsd4_open *open, struct nfsd_net *nn);
 extern __be32 nfsd4_process_open2(struct svc_rqst *rqstp,
@@ -701,34 +699,34 @@ extern void nfsd4_cstate_clear_replay(struct nfsd4_compound_state *cstate);
 extern void nfsd4_cleanup_open_state(struct nfsd4_compound_state *cstate,
 		struct nfsd4_open *open);
 extern __be32 nfsd4_open_confirm(struct svc_rqst *rqstp,
-		struct nfsd4_compound_state *, struct nfsd4_open_confirm *oc);
+		struct nfsd4_compound_state *, void *oc);
 extern __be32 nfsd4_close(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *,
-		struct nfsd4_close *close);
+		void *close);
 extern __be32 nfsd4_open_downgrade(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *,
-		struct nfsd4_open_downgrade *od);
+		void *od);
 extern __be32 nfsd4_lock(struct svc_rqst *rqstp, struct nfsd4_compound_state *,
-		struct nfsd4_lock *lock);
+		void *lock);
 extern __be32 nfsd4_lockt(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *,
-		struct nfsd4_lockt *lockt);
+		void *lockt);
 extern __be32 nfsd4_locku(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *,
-		struct nfsd4_locku *locku);
+		void *locku);
 extern __be32
 nfsd4_release_lockowner(struct svc_rqst *rqstp,
 		struct nfsd4_compound_state *,
-		struct nfsd4_release_lockowner *rlockowner);
+		void *rlockowner);
 extern int nfsd4_release_compoundargs(void *rq, __be32 *p, void *resp);
 extern __be32 nfsd4_delegreturn(struct svc_rqst *rqstp,
-		struct nfsd4_compound_state *, struct nfsd4_delegreturn *dr);
+		struct nfsd4_compound_state *, void *dr);
 extern __be32 nfsd4_renew(struct svc_rqst *rqstp,
-			  struct nfsd4_compound_state *, clientid_t *clid);
+			  struct nfsd4_compound_state *, void *clid);
 extern __be32 nfsd4_test_stateid(struct svc_rqst *rqstp,
-		struct nfsd4_compound_state *, struct nfsd4_test_stateid *test_stateid);
+		struct nfsd4_compound_state *, void *test_stateid);
 extern __be32 nfsd4_free_stateid(struct svc_rqst *rqstp,
-		struct nfsd4_compound_state *, struct nfsd4_free_stateid *free_stateid);
+		struct nfsd4_compound_state *, void *free_stateid);
 extern void nfsd4_bump_seqid(struct nfsd4_compound_state *, __be32 nfserr);
 
 #endif
diff --git a/fs/nls/nls_base.c b/fs/nls/nls_base.c
index 52ccd34b1..a16650164 100644
--- a/fs/nls/nls_base.c
+++ b/fs/nls/nls_base.c
@@ -234,21 +234,25 @@ EXPORT_SYMBOL(utf16s_to_utf8s);
 
 int __register_nls(struct nls_table *nls, struct module *owner)
 {
-	struct nls_table ** tmp = &tables;
+	struct nls_table *tmp = tables;
 
 	if (nls->next)
 		return -EBUSY;
 
-	nls->owner = owner;
+	pax_open_kernel();
+	const_cast(nls->owner) = owner;
+	pax_close_kernel();
 	spin_lock(&nls_lock);
-	while (*tmp) {
-		if (nls == *tmp) {
+	while (tmp) {
+		if (nls == tmp) {
 			spin_unlock(&nls_lock);
 			return -EBUSY;
 		}
-		tmp = &(*tmp)->next;
+		tmp = tmp->next;
 	}
-	nls->next = tables;
+	pax_open_kernel();
+	const_cast(nls->next) = tables;
+	pax_close_kernel();
 	tables = nls;
 	spin_unlock(&nls_lock);
 	return 0;	
@@ -257,12 +261,14 @@ EXPORT_SYMBOL(__register_nls);
 
 int unregister_nls(struct nls_table * nls)
 {
-	struct nls_table ** tmp = &tables;
+	struct nls_table * const * tmp = &tables;
 
 	spin_lock(&nls_lock);
 	while (*tmp) {
 		if (nls == *tmp) {
-			*tmp = nls->next;
+			pax_open_kernel();
+			*(struct nls_table **)tmp = nls->next;
+			pax_close_kernel();
 			spin_unlock(&nls_lock);
 			return 0;
 		}
@@ -272,7 +278,7 @@ int unregister_nls(struct nls_table * nls)
 	return -EINVAL;
 }
 
-static struct nls_table *find_nls(char *charset)
+static struct nls_table *find_nls(const char *charset)
 {
 	struct nls_table *nls;
 	spin_lock(&nls_lock);
@@ -288,7 +294,7 @@ static struct nls_table *find_nls(char *charset)
 	return nls;
 }
 
-struct nls_table *load_nls(char *charset)
+struct nls_table *load_nls(const char *charset)
 {
 	return try_then_request_module(find_nls(charset), "nls_%s", charset);
 }
diff --git a/fs/nls/nls_cp932.c b/fs/nls/nls_cp932.c
index 67b7398e8..38622e833 100644
--- a/fs/nls/nls_cp932.c
+++ b/fs/nls/nls_cp932.c
@@ -7834,7 +7834,7 @@ static const unsigned char charset2upper[256] = {
 	0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff, /* 0xf8-0xff */
 };
 
-static int uni2char(const wchar_t uni,
+static int uni2char(wchar_t uni,
 		    unsigned char *out, int boundlen)
 {
 	const unsigned char *uni2charset;
diff --git a/fs/nls/nls_cp936.c b/fs/nls/nls_cp936.c
index c96546cfe..d5dfe9464 100644
--- a/fs/nls/nls_cp936.c
+++ b/fs/nls/nls_cp936.c
@@ -10997,7 +10997,7 @@ static const unsigned char charset2upper[256] = {
 	0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff, /* 0xf8-0xff */
 };
 
-static int uni2char(const wchar_t uni,
+static int uni2char(wchar_t uni,
 			unsigned char *out, int boundlen)
 {
 	const unsigned char *uni2charset;
diff --git a/fs/nls/nls_cp949.c b/fs/nls/nls_cp949.c
index 199171e97..709af9acb 100644
--- a/fs/nls/nls_cp949.c
+++ b/fs/nls/nls_cp949.c
@@ -13858,7 +13858,7 @@ static const unsigned char charset2upper[256] = {
 	0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff, /* 0xf8-0xff */
 };
 
-static int uni2char(const wchar_t uni,
+static int uni2char(wchar_t uni,
 			unsigned char *out, int boundlen)
 {
 	const unsigned char *uni2charset;
diff --git a/fs/nls/nls_cp950.c b/fs/nls/nls_cp950.c
index 8e1418708..d9cec2f02 100644
--- a/fs/nls/nls_cp950.c
+++ b/fs/nls/nls_cp950.c
@@ -9394,7 +9394,7 @@ static const unsigned char charset2upper[256] = {
 	0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff, /* 0xf8-0xff */
 };
 
-static int uni2char(const wchar_t uni,
+static int uni2char(wchar_t uni,
 			unsigned char *out, int boundlen)
 {
 	const unsigned char *uni2charset;
diff --git a/fs/nls/nls_euc-jp.c b/fs/nls/nls_euc-jp.c
index 162b3f160..b9121f8df 100644
--- a/fs/nls/nls_euc-jp.c
+++ b/fs/nls/nls_euc-jp.c
@@ -406,7 +406,7 @@ static inline int sjisnec2sjisibm(unsigned char *sjisibm,
 	return 2;
 }
 
-static int uni2char(const wchar_t uni,
+static int uni2char(wchar_t uni,
 		    unsigned char *out, int boundlen)
 {
 	int n;
@@ -560,8 +560,10 @@ static int __init init_nls_euc_jp(void)
 	p_nls = load_nls("cp932");
 
 	if (p_nls) {
-		table.charset2upper = p_nls->charset2upper;
-		table.charset2lower = p_nls->charset2lower;
+		pax_open_kernel();
+		const_cast(table.charset2upper) = p_nls->charset2upper;
+		const_cast(table.charset2lower) = p_nls->charset2lower;
+		pax_close_kernel();
 		return register_nls(&table);
 	}
 
diff --git a/fs/nls/nls_koi8-ru.c b/fs/nls/nls_koi8-ru.c
index a80a741a8..f28c9c93f 100644
--- a/fs/nls/nls_koi8-ru.c
+++ b/fs/nls/nls_koi8-ru.c
@@ -13,7 +13,7 @@
 
 static struct nls_table *p_nls;
 
-static int uni2char(const wchar_t uni,
+static int uni2char(wchar_t uni,
 		    unsigned char *out, int boundlen)
 {
 	if (boundlen <= 0)
@@ -62,8 +62,10 @@ static int __init init_nls_koi8_ru(void)
 	p_nls = load_nls("koi8-u");
 
 	if (p_nls) {
-		table.charset2upper = p_nls->charset2upper;
-		table.charset2lower = p_nls->charset2lower;
+		pax_open_kernel();
+		const_cast(table.charset2upper) = p_nls->charset2upper;
+		const_cast(table.charset2lower) = p_nls->charset2lower;
+		pax_close_kernel();
 		return register_nls(&table);
 	}
 
diff --git a/fs/notify/fanotify/fanotify_user.c b/fs/notify/fanotify/fanotify_user.c
index a64313868..4b88993ab 100644
--- a/fs/notify/fanotify/fanotify_user.c
+++ b/fs/notify/fanotify/fanotify_user.c
@@ -216,8 +216,8 @@ static ssize_t copy_event_to_user(struct fsnotify_group *group,
 
 	fd = fanotify_event_metadata.fd;
 	ret = -EFAULT;
-	if (copy_to_user(buf, &fanotify_event_metadata,
-			 fanotify_event_metadata.event_len))
+	if (fanotify_event_metadata.event_len > sizeof fanotify_event_metadata ||
+	    copy_to_user(buf, &fanotify_event_metadata, fanotify_event_metadata.event_len))
 		goto out_close_fd;
 
 #ifdef CONFIG_FANOTIFY_ACCESS_PERMISSIONS
diff --git a/fs/notify/notification.c b/fs/notify/notification.c
index e455e83ce..6e2b73223 100644
--- a/fs/notify/notification.c
+++ b/fs/notify/notification.c
@@ -48,7 +48,7 @@
 #include <linux/fsnotify_backend.h>
 #include "fsnotify.h"
 
-static atomic_t fsnotify_sync_cookie = ATOMIC_INIT(0);
+static atomic_unchecked_t fsnotify_sync_cookie = ATOMIC_INIT(0);
 
 /**
  * fsnotify_get_cookie - return a unique cookie for use in synchronizing events.
@@ -56,7 +56,7 @@ static atomic_t fsnotify_sync_cookie = ATOMIC_INIT(0);
  */
 u32 fsnotify_get_cookie(void)
 {
-	return atomic_inc_return(&fsnotify_sync_cookie);
+	return atomic_inc_return_unchecked(&fsnotify_sync_cookie);
 }
 EXPORT_SYMBOL_GPL(fsnotify_get_cookie);
 
diff --git a/fs/ntfs/debug.h b/fs/ntfs/debug.h
index 61bf091e3..6ac561943 100644
--- a/fs/ntfs/debug.h
+++ b/fs/ntfs/debug.h
@@ -30,7 +30,7 @@
 
 extern int debug_msgs;
 
-extern __printf(4, 5)
+extern __printf(4, 5) __nocapture(3)
 void __ntfs_debug(const char *file, int line, const char *function,
 		  const char *format, ...);
 /**
@@ -58,12 +58,12 @@ do {									\
 
 #endif	/* !DEBUG */
 
-extern  __printf(3, 4)
+extern  __printf(3, 4) __nocapture(1)
 void __ntfs_warning(const char *function, const struct super_block *sb,
 		    const char *fmt, ...);
 #define ntfs_warning(sb, f, a...)	__ntfs_warning(__func__, sb, f, ##a)
 
-extern  __printf(3, 4)
+extern  __printf(3, 4) __nocapture(1)
 void __ntfs_error(const char *function, const struct super_block *sb,
 		  const char *fmt, ...);
 #define ntfs_error(sb, f, a...)		__ntfs_error(__func__, sb, f, ##a)
diff --git a/fs/ntfs/dir.c b/fs/ntfs/dir.c
index a18613579..31eb35840 100644
--- a/fs/ntfs/dir.c
+++ b/fs/ntfs/dir.c
@@ -1310,7 +1310,7 @@ find_next_index_buffer:
 	ia = (INDEX_ALLOCATION*)(kaddr + (ia_pos & ~PAGE_MASK &
 					  ~(s64)(ndir->itype.index.block_size - 1)));
 	/* Bounds checks. */
-	if (unlikely((u8*)ia < kaddr || (u8*)ia > kaddr + PAGE_SIZE)) {
+	if (unlikely(!kaddr || (u8*)ia < kaddr || (u8*)ia > kaddr + PAGE_SIZE)) {
 		ntfs_error(sb, "Out of bounds check failed. Corrupt directory "
 				"inode 0x%lx or driver bug.", vdir->i_ino);
 		goto err_out;
@@ -1517,7 +1517,7 @@ static int ntfs_dir_fsync(struct file *filp, loff_t start, loff_t end,
 	na.type = AT_BITMAP;
 	na.name = I30;
 	na.name_len = 4;
-	bmp_vi = ilookup5(vi->i_sb, vi->i_ino, (test_t)ntfs_test_inode, &na);
+	bmp_vi = ilookup5(vi->i_sb, vi->i_ino, ntfs_test_inode, &na);
 	if (bmp_vi) {
  		write_inode_now(bmp_vi, !datasync);
 		iput(bmp_vi);
diff --git a/fs/ntfs/inode.c b/fs/ntfs/inode.c
index e01287c96..9939db206 100644
--- a/fs/ntfs/inode.c
+++ b/fs/ntfs/inode.c
@@ -57,8 +57,9 @@
  * NOTE: This function runs with the inode_hash_lock spin lock held so it is not
  * allowed to sleep.
  */
-int ntfs_test_inode(struct inode *vi, ntfs_attr *na)
+int ntfs_test_inode(struct inode *vi, void *_na)
 {
+	ntfs_attr *na = _na;
 	ntfs_inode *ni;
 
 	if (vi->i_ino != na->mft_no)
@@ -101,8 +102,9 @@ int ntfs_test_inode(struct inode *vi, ntfs_attr *na)
  * NOTE: This function runs with the inode->i_lock spin lock held so it is not
  * allowed to sleep. (Hence the GFP_ATOMIC allocation.)
  */
-static int ntfs_init_locked_inode(struct inode *vi, ntfs_attr *na)
+static int ntfs_init_locked_inode(struct inode *vi, void *_na)
 {
+	ntfs_attr *na = _na;
 	ntfs_inode *ni = NTFS_I(vi);
 
 	vi->i_ino = na->mft_no;
@@ -145,7 +147,6 @@ static int ntfs_init_locked_inode(struct inode *vi, ntfs_attr *na)
 	return 0;
 }
 
-typedef int (*set_t)(struct inode *, void *);
 static int ntfs_read_locked_inode(struct inode *vi);
 static int ntfs_read_locked_attr_inode(struct inode *base_vi, struct inode *vi);
 static int ntfs_read_locked_index_inode(struct inode *base_vi,
@@ -178,8 +179,8 @@ struct inode *ntfs_iget(struct super_block *sb, unsigned long mft_no)
 	na.name = NULL;
 	na.name_len = 0;
 
-	vi = iget5_locked(sb, mft_no, (test_t)ntfs_test_inode,
-			(set_t)ntfs_init_locked_inode, &na);
+	vi = iget5_locked(sb, mft_no, ntfs_test_inode,
+			ntfs_init_locked_inode, &na);
 	if (unlikely(!vi))
 		return ERR_PTR(-ENOMEM);
 
@@ -239,8 +240,8 @@ struct inode *ntfs_attr_iget(struct inode *base_vi, ATTR_TYPE type,
 	na.name = name;
 	na.name_len = name_len;
 
-	vi = iget5_locked(base_vi->i_sb, na.mft_no, (test_t)ntfs_test_inode,
-			(set_t)ntfs_init_locked_inode, &na);
+	vi = iget5_locked(base_vi->i_sb, na.mft_no, ntfs_test_inode,
+			ntfs_init_locked_inode, &na);
 	if (unlikely(!vi))
 		return ERR_PTR(-ENOMEM);
 
@@ -294,8 +295,8 @@ struct inode *ntfs_index_iget(struct inode *base_vi, ntfschar *name,
 	na.name = name;
 	na.name_len = name_len;
 
-	vi = iget5_locked(base_vi->i_sb, na.mft_no, (test_t)ntfs_test_inode,
-			(set_t)ntfs_init_locked_inode, &na);
+	vi = iget5_locked(base_vi->i_sb, na.mft_no, ntfs_test_inode,
+			ntfs_init_locked_inode, &na);
 	if (unlikely(!vi))
 		return ERR_PTR(-ENOMEM);
 
diff --git a/fs/ntfs/inode.h b/fs/ntfs/inode.h
index b3c3469de..17208ad46 100644
--- a/fs/ntfs/inode.h
+++ b/fs/ntfs/inode.h
@@ -267,9 +267,7 @@ typedef struct {
 	ATTR_TYPE type;
 } ntfs_attr;
 
-typedef int (*test_t)(struct inode *, void *);
-
-extern int ntfs_test_inode(struct inode *vi, ntfs_attr *na);
+extern int ntfs_test_inode(struct inode *vi, void *_na);
 
 extern struct inode *ntfs_iget(struct super_block *sb, unsigned long mft_no);
 extern struct inode *ntfs_attr_iget(struct inode *base_vi, ATTR_TYPE type,
diff --git a/fs/ntfs/mft.c b/fs/ntfs/mft.c
index d15d492ce..c75f95adc 100644
--- a/fs/ntfs/mft.c
+++ b/fs/ntfs/mft.c
@@ -963,7 +963,7 @@ bool ntfs_may_write_mft_record(ntfs_volume *vol, const unsigned long mft_no,
 		 * dirty code path of the inode dirty code path when writing
 		 * $MFT occurs.
 		 */
-		vi = ilookup5_nowait(sb, mft_no, (test_t)ntfs_test_inode, &na);
+		vi = ilookup5_nowait(sb, mft_no, ntfs_test_inode, &na);
 	}
 	if (vi) {
 		ntfs_debug("Base inode 0x%lx is in icache.", mft_no);
@@ -1024,7 +1024,7 @@ bool ntfs_may_write_mft_record(ntfs_volume *vol, const unsigned long mft_no,
 		vi = igrab(mft_vi);
 		BUG_ON(vi != mft_vi);
 	} else
-		vi = ilookup5_nowait(sb, na.mft_no, (test_t)ntfs_test_inode,
+		vi = ilookup5_nowait(sb, na.mft_no, ntfs_test_inode,
 				&na);
 	if (!vi) {
 		/*
diff --git a/fs/ntfs/super.c b/fs/ntfs/super.c
index ecb49870a..c723ded3d 100644
--- a/fs/ntfs/super.c
+++ b/fs/ntfs/super.c
@@ -688,7 +688,7 @@ static struct buffer_head *read_ntfs_boot_sector(struct super_block *sb,
 		if (!silent)
 			ntfs_error(sb, "Primary boot sector is invalid.");
 	} else if (!silent)
-		ntfs_error(sb, read_err_str, "primary");
+		ntfs_error(sb, read_err_str, "%s", "primary");
 	if (!(NTFS_SB(sb)->on_errors & ON_ERRORS_RECOVER)) {
 		if (bh_primary)
 			brelse(bh_primary);
@@ -704,7 +704,7 @@ static struct buffer_head *read_ntfs_boot_sector(struct super_block *sb,
 			goto hotfix_primary_boot_sector;
 		brelse(bh_backup);
 	} else if (!silent)
-		ntfs_error(sb, read_err_str, "backup");
+		ntfs_error(sb, read_err_str, "%s", "backup");
 	/* Try to read NT3.51- backup boot sector. */
 	if ((bh_backup = sb_bread(sb, nr_blocks >> 1))) {
 		if (is_boot_sector_ntfs(sb, (NTFS_BOOT_SECTOR*)
@@ -715,7 +715,7 @@ static struct buffer_head *read_ntfs_boot_sector(struct super_block *sb,
 					"sector.");
 		brelse(bh_backup);
 	} else if (!silent)
-		ntfs_error(sb, read_err_str, "backup");
+		ntfs_error(sb, read_err_str, "%s", "backup");
 	/* We failed. Cleanup and return. */
 	if (bh_primary)
 		brelse(bh_primary);
@@ -2711,7 +2711,7 @@ static const struct super_operations ntfs_sops = {
  *
  * NOTE: @sb->s_flags contains the mount options flags.
  */
-static int ntfs_fill_super(struct super_block *sb, void *opt, const int silent)
+static int ntfs_fill_super(struct super_block *sb, void *opt, int silent)
 {
 	ntfs_volume *vol;
 	struct buffer_head *bh;
diff --git a/fs/ocfs2/cluster/masklog.h b/fs/ocfs2/cluster/masklog.h
index 308ea0eb3..3c16da696 100644
--- a/fs/ocfs2/cluster/masklog.h
+++ b/fs/ocfs2/cluster/masklog.h
@@ -162,7 +162,7 @@ extern struct mlog_bits mlog_and_bits, mlog_not_bits;
 
 #endif
 
-__printf(4, 5)
+__printf(4, 5) __nocapture(2)
 void __mlog_printk(const u64 *m, const char *func, int line,
 		   const char *fmt, ...);
 
diff --git a/fs/ocfs2/dlm/dlmcommon.h b/fs/ocfs2/dlm/dlmcommon.h
index e9f3705c4..8e53eb12b 100644
--- a/fs/ocfs2/dlm/dlmcommon.h
+++ b/fs/ocfs2/dlm/dlmcommon.h
@@ -151,9 +151,9 @@ struct dlm_ctxt
 	struct list_head mle_hb_events;
 
 	/* these give a really vague idea of the system load */
-	atomic_t mle_tot_count[DLM_MLE_NUM_TYPES];
+	atomic_unchecked_t mle_tot_count[DLM_MLE_NUM_TYPES];
 	atomic_t mle_cur_count[DLM_MLE_NUM_TYPES];
-	atomic_t res_tot_count;
+	atomic_unchecked_t res_tot_count;
 	atomic_t res_cur_count;
 
 	struct dlm_debug_ctxt *dlm_debug_ctxt;
diff --git a/fs/ocfs2/dlm/dlmdebug.c b/fs/ocfs2/dlm/dlmdebug.c
index e7b760dee..f8cd0ad00 100644
--- a/fs/ocfs2/dlm/dlmdebug.c
+++ b/fs/ocfs2/dlm/dlmdebug.c
@@ -735,10 +735,10 @@ static int debug_state_print(struct dlm_ctxt *dlm, char *buf, int len)
 	out += snprintf(buf + out, len - out,
 			"Lock Resources: %d (%d)\n",
 			atomic_read(&dlm->res_cur_count),
-			atomic_read(&dlm->res_tot_count));
+			atomic_read_unchecked(&dlm->res_tot_count));
 
 	for (i = 0; i < DLM_MLE_NUM_TYPES; ++i)
-		tot_mles += atomic_read(&dlm->mle_tot_count[i]);
+		tot_mles += atomic_read_unchecked(&dlm->mle_tot_count[i]);
 
 	for (i = 0; i < DLM_MLE_NUM_TYPES; ++i)
 		cur_mles += atomic_read(&dlm->mle_cur_count[i]);
@@ -751,19 +751,19 @@ static int debug_state_print(struct dlm_ctxt *dlm, char *buf, int len)
 	out += snprintf(buf + out, len - out,
 			"  Blocking: %d (%d)\n",
 			atomic_read(&dlm->mle_cur_count[DLM_MLE_BLOCK]),
-			atomic_read(&dlm->mle_tot_count[DLM_MLE_BLOCK]));
+			atomic_read_unchecked(&dlm->mle_tot_count[DLM_MLE_BLOCK]));
 
 	/*  Mastery: xxx (xxx) */
 	out += snprintf(buf + out, len - out,
 			"  Mastery: %d (%d)\n",
 			atomic_read(&dlm->mle_cur_count[DLM_MLE_MASTER]),
-			atomic_read(&dlm->mle_tot_count[DLM_MLE_MASTER]));
+			atomic_read_unchecked(&dlm->mle_tot_count[DLM_MLE_MASTER]));
 
 	/*  Migration: xxx (xxx) */
 	out += snprintf(buf + out, len - out,
 			"  Migration: %d (%d)\n",
 			atomic_read(&dlm->mle_cur_count[DLM_MLE_MIGRATION]),
-			atomic_read(&dlm->mle_tot_count[DLM_MLE_MIGRATION]));
+			atomic_read_unchecked(&dlm->mle_tot_count[DLM_MLE_MIGRATION]));
 
 	/* Lists: Dirty=Empty  Purge=InUse  PendingASTs=Empty  ... */
 	out += snprintf(buf + out, len - out,
diff --git a/fs/ocfs2/dlm/dlmdomain.c b/fs/ocfs2/dlm/dlmdomain.c
index 533bd524e..3a9d64a16 100644
--- a/fs/ocfs2/dlm/dlmdomain.c
+++ b/fs/ocfs2/dlm/dlmdomain.c
@@ -2055,10 +2055,10 @@ static struct dlm_ctxt *dlm_alloc_ctxt(const char *domain,
 	dlm->reco.new_master = O2NM_INVALID_NODE_NUM;
 	dlm->reco.dead_node = O2NM_INVALID_NODE_NUM;
 
-	atomic_set(&dlm->res_tot_count, 0);
+	atomic_set_unchecked(&dlm->res_tot_count, 0);
 	atomic_set(&dlm->res_cur_count, 0);
 	for (i = 0; i < DLM_MLE_NUM_TYPES; ++i) {
-		atomic_set(&dlm->mle_tot_count[i], 0);
+		atomic_set_unchecked(&dlm->mle_tot_count[i], 0);
 		atomic_set(&dlm->mle_cur_count[i], 0);
 	}
 
diff --git a/fs/ocfs2/dlm/dlmmaster.c b/fs/ocfs2/dlm/dlmmaster.c
index 6ea06f8a7..67897160a 100644
--- a/fs/ocfs2/dlm/dlmmaster.c
+++ b/fs/ocfs2/dlm/dlmmaster.c
@@ -303,7 +303,7 @@ static void dlm_init_mle(struct dlm_master_list_entry *mle,
 		mle->mnamehash = dlm_lockid_hash(name, namelen);
 	}
 
-	atomic_inc(&dlm->mle_tot_count[mle->type]);
+	atomic_inc_unchecked(&dlm->mle_tot_count[mle->type]);
 	atomic_inc(&dlm->mle_cur_count[mle->type]);
 
 	/* copy off the node_map and register hb callbacks on our copy */
@@ -577,7 +577,7 @@ static void dlm_init_lockres(struct dlm_ctxt *dlm,
 
 	kref_init(&res->refs);
 
-	atomic_inc(&dlm->res_tot_count);
+	atomic_inc_unchecked(&dlm->res_tot_count);
 	atomic_inc(&dlm->res_cur_count);
 
 	/* just for consistency */
diff --git a/fs/ocfs2/dlmfs/dlmfs.c b/fs/ocfs2/dlmfs/dlmfs.c
index ef474cdd6..a5cc6a6ba 100644
--- a/fs/ocfs2/dlmfs/dlmfs.c
+++ b/fs/ocfs2/dlmfs/dlmfs.c
@@ -88,13 +88,13 @@ struct workqueue_struct *user_dlm_worker;
  */
 #define DLMFS_CAPABILITIES "bast stackglue"
 static int param_set_dlmfs_capabilities(const char *val,
-					struct kernel_param *kp)
+					const struct kernel_param *kp)
 {
 	printk(KERN_ERR "%s: readonly parameter\n", kp->name);
 	return -EINVAL;
 }
 static int param_get_dlmfs_capabilities(char *buffer,
-					struct kernel_param *kp)
+					const struct kernel_param *kp)
 {
 	return strlcpy(buffer, DLMFS_CAPABILITIES,
 		       strlen(DLMFS_CAPABILITIES) + 1);
diff --git a/fs/ocfs2/filecheck.c b/fs/ocfs2/filecheck.c
index 2cabbcf2f..93edf3388 100644
--- a/fs/ocfs2/filecheck.c
+++ b/fs/ocfs2/filecheck.c
@@ -217,7 +217,7 @@ int ocfs2_filecheck_create_sysfs(struct super_block *sb)
 	struct ocfs2_filecheck *fcheck = NULL;
 	struct ocfs2_filecheck_sysfs_entry *entry = NULL;
 	struct attribute **attrs = NULL;
-	struct attribute_group attrgp;
+	attribute_group_no_const attrgp;
 
 	if (!ocfs2_kset)
 		return -ENOMEM;
diff --git a/fs/ocfs2/localalloc.c b/fs/ocfs2/localalloc.c
index fe0d1f957..7ec86591b 100644
--- a/fs/ocfs2/localalloc.c
+++ b/fs/ocfs2/localalloc.c
@@ -1317,7 +1317,7 @@ static int ocfs2_local_alloc_slide_window(struct ocfs2_super *osb,
 		goto bail;
 	}
 
-	atomic_inc(&osb->alloc_stats.moves);
+	atomic_inc_unchecked(&osb->alloc_stats.moves);
 
 bail:
 	if (handle)
diff --git a/fs/ocfs2/ocfs2.h b/fs/ocfs2/ocfs2.h
index e63af7ddf..2a8a83aa0 100644
--- a/fs/ocfs2/ocfs2.h
+++ b/fs/ocfs2/ocfs2.h
@@ -247,11 +247,11 @@ enum ocfs2_vol_state
 
 struct ocfs2_alloc_stats
 {
-	atomic_t moves;
-	atomic_t local_data;
-	atomic_t bitmap_data;
-	atomic_t bg_allocs;
-	atomic_t bg_extends;
+	atomic_unchecked_t moves;
+	atomic_unchecked_t local_data;
+	atomic_unchecked_t bitmap_data;
+	atomic_unchecked_t bg_allocs;
+	atomic_unchecked_t bg_extends;
 };
 
 enum ocfs2_local_alloc_state
diff --git a/fs/ocfs2/suballoc.c b/fs/ocfs2/suballoc.c
index 6ad353394..053f29d48 100644
--- a/fs/ocfs2/suballoc.c
+++ b/fs/ocfs2/suballoc.c
@@ -851,7 +851,7 @@ static int ocfs2_reserve_suballoc_bits(struct ocfs2_super *osb,
 				mlog_errno(status);
 			goto bail;
 		}
-		atomic_inc(&osb->alloc_stats.bg_extends);
+		atomic_inc_unchecked(&osb->alloc_stats.bg_extends);
 
 		/* You should never ask for this much metadata */
 		BUG_ON(bits_wanted >
@@ -2026,7 +2026,7 @@ int ocfs2_claim_metadata(handle_t *handle,
 		mlog_errno(status);
 		goto bail;
 	}
-	atomic_inc(&OCFS2_SB(ac->ac_inode->i_sb)->alloc_stats.bg_allocs);
+	atomic_inc_unchecked(&OCFS2_SB(ac->ac_inode->i_sb)->alloc_stats.bg_allocs);
 
 	*suballoc_loc = res.sr_bg_blkno;
 	*suballoc_bit_start = res.sr_bit_offset;
@@ -2192,7 +2192,7 @@ int ocfs2_claim_new_inode_at_loc(handle_t *handle,
 	trace_ocfs2_claim_new_inode_at_loc((unsigned long long)di_blkno,
 					   res->sr_bits);
 
-	atomic_inc(&OCFS2_SB(ac->ac_inode->i_sb)->alloc_stats.bg_allocs);
+	atomic_inc_unchecked(&OCFS2_SB(ac->ac_inode->i_sb)->alloc_stats.bg_allocs);
 
 	BUG_ON(res->sr_bits != 1);
 
@@ -2234,7 +2234,7 @@ int ocfs2_claim_new_inode(handle_t *handle,
 		mlog_errno(status);
 		goto bail;
 	}
-	atomic_inc(&OCFS2_SB(ac->ac_inode->i_sb)->alloc_stats.bg_allocs);
+	atomic_inc_unchecked(&OCFS2_SB(ac->ac_inode->i_sb)->alloc_stats.bg_allocs);
 
 	BUG_ON(res.sr_bits != 1);
 
@@ -2338,7 +2338,7 @@ int __ocfs2_claim_clusters(handle_t *handle,
 						      cluster_start,
 						      num_clusters);
 		if (!status)
-			atomic_inc(&osb->alloc_stats.local_data);
+			atomic_inc_unchecked(&osb->alloc_stats.local_data);
 	} else {
 		if (min_clusters > (osb->bitmap_cpg - 1)) {
 			/* The only paths asking for contiguousness
@@ -2364,7 +2364,7 @@ int __ocfs2_claim_clusters(handle_t *handle,
 				ocfs2_desc_bitmap_to_cluster_off(ac->ac_inode,
 								 res.sr_bg_blkno,
 								 res.sr_bit_offset);
-			atomic_inc(&osb->alloc_stats.bitmap_data);
+			atomic_inc_unchecked(&osb->alloc_stats.bitmap_data);
 			*num_clusters = res.sr_bits;
 		}
 	}
diff --git a/fs/ocfs2/super.c b/fs/ocfs2/super.c
index 603b28d6f..a9818bd04 100644
--- a/fs/ocfs2/super.c
+++ b/fs/ocfs2/super.c
@@ -306,11 +306,11 @@ static int ocfs2_osb_dump(struct ocfs2_super *osb, char *buf, int len)
 			"%10s => GlobalAllocs: %d  LocalAllocs: %d  "
 			"SubAllocs: %d  LAWinMoves: %d  SAExtends: %d\n",
 			"Stats",
-			atomic_read(&osb->alloc_stats.bitmap_data),
-			atomic_read(&osb->alloc_stats.local_data),
-			atomic_read(&osb->alloc_stats.bg_allocs),
-			atomic_read(&osb->alloc_stats.moves),
-			atomic_read(&osb->alloc_stats.bg_extends));
+			atomic_read_unchecked(&osb->alloc_stats.bitmap_data),
+			atomic_read_unchecked(&osb->alloc_stats.local_data),
+			atomic_read_unchecked(&osb->alloc_stats.bg_allocs),
+			atomic_read_unchecked(&osb->alloc_stats.moves),
+			atomic_read_unchecked(&osb->alloc_stats.bg_extends));
 
 	out += snprintf(buf + out, len - out,
 			"%10s => State: %u  Descriptor: %llu  Size: %u bits  "
@@ -2087,11 +2087,11 @@ static int ocfs2_initialize_super(struct super_block *sb,
 
 	mutex_init(&osb->system_file_mutex);
 
-	atomic_set(&osb->alloc_stats.moves, 0);
-	atomic_set(&osb->alloc_stats.local_data, 0);
-	atomic_set(&osb->alloc_stats.bitmap_data, 0);
-	atomic_set(&osb->alloc_stats.bg_allocs, 0);
-	atomic_set(&osb->alloc_stats.bg_extends, 0);
+	atomic_set_unchecked(&osb->alloc_stats.moves, 0);
+	atomic_set_unchecked(&osb->alloc_stats.local_data, 0);
+	atomic_set_unchecked(&osb->alloc_stats.bitmap_data, 0);
+	atomic_set_unchecked(&osb->alloc_stats.bg_allocs, 0);
+	atomic_set_unchecked(&osb->alloc_stats.bg_extends, 0);
 
 	/* Copy the blockcheck stats from the superblock probe */
 	osb->osb_ecc_stats = *stats;
diff --git a/fs/open.c b/fs/open.c
index 4fd6e256f..fff35d4c7 100644
--- a/fs/open.c
+++ b/fs/open.c
@@ -32,6 +32,8 @@
 #include <linux/dnotify.h>
 #include <linux/compat.h>
 
+#define CREATE_TRACE_POINTS
+#include <trace/events/fs.h>
 #include "internal.h"
 
 int do_truncate(struct dentry *dentry, loff_t length, unsigned int time_attrs,
@@ -105,6 +107,8 @@ long vfs_truncate(const struct path *path, loff_t length)
 	error = locks_verify_truncate(inode, NULL, length);
 	if (!error)
 		error = security_path_truncate(path);
+	if (!error && !gr_acl_handle_truncate(path->dentry, path->mnt))
+		error = -EACCES;
 	if (!error)
 		error = do_truncate(path->dentry, length, 0, NULL);
 
@@ -189,6 +193,8 @@ static long do_sys_ftruncate(unsigned int fd, loff_t length, int small)
 	error = locks_verify_truncate(inode, f.file, length);
 	if (!error)
 		error = security_path_truncate(&f.file->f_path);
+	if (!error && !gr_acl_handle_truncate(f.file->f_path.dentry, f.file->f_path.mnt))
+		error = -EACCES;
 	if (!error)
 		error = do_truncate(dentry, length, ATTR_MTIME|ATTR_CTIME, f.file);
 	sb_end_write(inode->i_sb);
@@ -398,6 +404,9 @@ retry:
 	if (__mnt_is_readonly(path.mnt))
 		res = -EROFS;
 
+	if (!res && !gr_acl_handle_access(path.dentry, path.mnt, mode))
+		res = -EACCES;
+
 out_path_release:
 	path_put(&path);
 	if (retry_estale(res, lookup_flags)) {
@@ -429,6 +438,8 @@ retry:
 	if (error)
 		goto dput_and_out;
 
+	gr_log_chdir(path.dentry, path.mnt);
+
 	set_fs_pwd(current->fs, &path);
 
 dput_and_out:
@@ -458,6 +469,13 @@ SYSCALL_DEFINE1(fchdir, unsigned int, fd)
 		goto out_putf;
 
 	error = inode_permission(inode, MAY_EXEC | MAY_CHDIR);
+
+	if (!error && !gr_chroot_fchdir(f.file->f_path.dentry, f.file->f_path.mnt))
+		error = -EPERM;
+
+	if (!error)
+		gr_log_chdir(f.file->f_path.dentry, f.file->f_path.mnt);
+
 	if (!error)
 		set_fs_pwd(current->fs, &f.file->f_path);
 out_putf:
@@ -487,7 +505,13 @@ retry:
 	if (error)
 		goto dput_and_out;
 
+	if (gr_handle_chroot_chroot(path.dentry, path.mnt))
+		goto dput_and_out;
+
 	set_fs_root(current->fs, &path);
+
+	gr_handle_chroot_chdir(&path);
+
 	error = 0;
 dput_and_out:
 	path_put(&path);
@@ -511,6 +535,16 @@ static int chmod_common(const struct path *path, umode_t mode)
 		return error;
 retry_deleg:
 	inode_lock(inode);
+
+	if (!gr_acl_handle_chmod(path->dentry, path->mnt, &mode)) {
+		error = -EACCES;
+		goto out_unlock;
+	}
+	if (gr_handle_chroot_chmod(path->dentry, path->mnt, mode)) {
+		error = -EACCES;
+		goto out_unlock;
+	}
+
 	error = security_path_chmod(path, mode);
 	if (error)
 		goto out_unlock;
@@ -576,6 +610,9 @@ static int chown_common(const struct path *path, uid_t user, gid_t group)
 	uid = make_kuid(current_user_ns(), user);
 	gid = make_kgid(current_user_ns(), group);
 
+	if (!gr_acl_handle_chown(path->dentry, path->mnt))
+		return -EACCES;
+
 retry_deleg:
 	newattrs.ia_valid =  ATTR_CTIME;
 	if (user != (uid_t) -1) {
@@ -1040,6 +1077,7 @@ long do_sys_open(int dfd, const char __user *filename, int flags, umode_t mode)
 		} else {
 			fsnotify_open(f);
 			fd_install(fd, f);
+			trace_do_sys_open(tmp->name, flags, mode);
 		}
 	}
 	putname(tmp);
diff --git a/fs/orangefs/super.c b/fs/orangefs/super.c
index b9da9a028..e14675802 100644
--- a/fs/orangefs/super.c
+++ b/fs/orangefs/super.c
@@ -539,10 +539,12 @@ void orangefs_kill_sb(struct super_block *sb)
 
 int orangefs_inode_cache_initialize(void)
 {
-	orangefs_inode_cache = kmem_cache_create("orangefs_inode_cache",
+	orangefs_inode_cache = kmem_cache_create_usercopy("orangefs_inode_cache",
 					      sizeof(struct orangefs_inode_s),
 					      0,
 					      ORANGEFS_CACHE_CREATE_FLAGS,
+					      offsetof(struct orangefs_inode_s, link_target),
+					      sizeof(((struct orangefs_inode_s *)0)->link_target),
 					      orangefs_inode_cache_ctor);
 
 	if (!orangefs_inode_cache) {
diff --git a/fs/overlayfs/copy_up.c b/fs/overlayfs/copy_up.c
index 767377e52..2e4b2e828 100644
--- a/fs/overlayfs/copy_up.c
+++ b/fs/overlayfs/copy_up.c
@@ -199,7 +199,7 @@ static char *ovl_read_symlink(struct dentry *realdentry)
 	set_fs(get_ds());
 	/* The cast to a user pointer is valid due to the set_fs() */
 	res = inode->i_op->readlink(realdentry,
-				    (char __user *)buf, PAGE_SIZE - 1);
+				    (char __force_user *)buf, PAGE_SIZE - 1);
 	set_fs(old_fs);
 	if (res < 0) {
 		free_page((unsigned long) buf);
diff --git a/fs/overlayfs/super.c b/fs/overlayfs/super.c
index 78be4aee7..37a3935de 100644
--- a/fs/overlayfs/super.c
+++ b/fs/overlayfs/super.c
@@ -148,8 +148,8 @@ struct dentry *ovl_dentry_real(struct dentry *dentry)
 static void ovl_inode_init(struct inode *inode, struct inode *realinode,
 			   bool is_upper)
 {
-	WRITE_ONCE(inode->i_private, (unsigned long) realinode |
-		   (is_upper ? OVL_ISUPPER_MASK : 0));
+	WRITE_ONCE(inode->i_private, (void *)((unsigned long) realinode |
+		   (is_upper ? OVL_ISUPPER_MASK : 0)));
 }
 
 struct vfsmount *ovl_entry_mnt_real(struct ovl_entry *oe, struct inode *inode,
@@ -182,7 +182,7 @@ void ovl_path_lower(struct dentry *dentry, struct path *path)
 {
 	struct ovl_entry *oe = dentry->d_fsdata;
 
-	*path = oe->numlower ? oe->lowerstack[0] : (struct path) { NULL, NULL };
+	*path = oe->numlower ? oe->lowerstack[0] : (struct path) { .dentry = NULL, .mnt = NULL };
 }
 
 int ovl_want_write(struct dentry *dentry)
@@ -234,7 +234,7 @@ void ovl_inode_update(struct inode *inode, struct inode *upperinode)
 	WARN_ON(!upperinode);
 	WARN_ON(!inode_unhashed(inode));
 	WRITE_ONCE(inode->i_private,
-		   (unsigned long) upperinode | OVL_ISUPPER_MASK);
+		   (void *)((unsigned long) upperinode | OVL_ISUPPER_MASK));
 	if (!S_ISDIR(upperinode->i_mode))
 		__insert_inode_hash(inode, (unsigned long) upperinode);
 }
@@ -1122,8 +1122,8 @@ static const struct xattr_handler *ovl_xattr_handlers[] = {
 
 static int ovl_fill_super(struct super_block *sb, void *data, int silent)
 {
-	struct path upperpath = { NULL, NULL };
-	struct path workpath = { NULL, NULL };
+	struct path upperpath = { .dentry = NULL, .mnt = NULL };
+	struct path workpath = { .dentry = NULL, .mnt = NULL };
 	struct dentry *root_dentry;
 	struct inode *realinode;
 	struct ovl_entry *oe;
diff --git a/fs/pipe.c b/fs/pipe.c
index 4ebe6b2e5..b3752f288 100644
--- a/fs/pipe.c
+++ b/fs/pipe.c
@@ -37,7 +37,7 @@ unsigned int pipe_max_size = 1048576;
 /*
  * Minimum pipe size, as required by POSIX
  */
-unsigned int pipe_min_size = PAGE_SIZE;
+unsigned int pipe_min_size __read_only = PAGE_SIZE;
 
 /* Maximum allocatable pages per user. Hard limit is unset by default, soft
  * matches default values.
@@ -62,7 +62,7 @@ unsigned long pipe_user_pages_soft = PIPE_DEF_BUFFERS * INR_OPEN_CUR;
 
 static void pipe_lock_nested(struct pipe_inode_info *pipe, int subclass)
 {
-	if (pipe->files)
+	if (atomic_read(&pipe->files))
 		mutex_lock_nested(&pipe->mutex, subclass);
 }
 
@@ -77,7 +77,7 @@ EXPORT_SYMBOL(pipe_lock);
 
 void pipe_unlock(struct pipe_inode_info *pipe)
 {
-	if (pipe->files)
+	if (atomic_read(&pipe->files))
 		mutex_unlock(&pipe->mutex);
 }
 EXPORT_SYMBOL(pipe_unlock);
@@ -312,9 +312,9 @@ pipe_read(struct kiocb *iocb, struct iov_iter *to)
 		}
 		if (bufs)	/* More to do? */
 			continue;
-		if (!pipe->writers)
+		if (!atomic_read(&pipe->writers))
 			break;
-		if (!pipe->waiting_writers) {
+		if (!atomic_read(&pipe->waiting_writers)) {
 			/* syscall merging: Usually we must not sleep
 			 * if O_NONBLOCK is set, or if we got some data.
 			 * But if a writer sleeps in kernel space, then
@@ -371,7 +371,7 @@ pipe_write(struct kiocb *iocb, struct iov_iter *from)
 
 	__pipe_lock(pipe);
 
-	if (!pipe->readers) {
+	if (!atomic_read(&pipe->readers)) {
 		send_sig(SIGPIPE, current, 0);
 		ret = -EPIPE;
 		goto out;
@@ -406,7 +406,7 @@ pipe_write(struct kiocb *iocb, struct iov_iter *from)
 	for (;;) {
 		int bufs;
 
-		if (!pipe->readers) {
+		if (!atomic_read(&pipe->readers)) {
 			send_sig(SIGPIPE, current, 0);
 			if (!ret)
 				ret = -EPIPE;
@@ -474,9 +474,9 @@ pipe_write(struct kiocb *iocb, struct iov_iter *from)
 			kill_fasync(&pipe->fasync_readers, SIGIO, POLL_IN);
 			do_wakeup = 0;
 		}
-		pipe->waiting_writers++;
+		atomic_inc(&pipe->waiting_writers);
 		pipe_wait(pipe);
-		pipe->waiting_writers--;
+		atomic_dec(&pipe->waiting_writers);
 	}
 out:
 	__pipe_unlock(pipe);
@@ -531,7 +531,7 @@ pipe_poll(struct file *filp, poll_table *wait)
 	mask = 0;
 	if (filp->f_mode & FMODE_READ) {
 		mask = (nrbufs > 0) ? POLLIN | POLLRDNORM : 0;
-		if (!pipe->writers && filp->f_version != pipe->w_counter)
+		if (!atomic_read(&pipe->writers) && filp->f_version != pipe->w_counter)
 			mask |= POLLHUP;
 	}
 
@@ -541,7 +541,7 @@ pipe_poll(struct file *filp, poll_table *wait)
 		 * Most Unices do not set POLLERR for FIFOs but on Linux they
 		 * behave exactly like pipes for poll().
 		 */
-		if (!pipe->readers)
+		if (!atomic_read(&pipe->readers))
 			mask |= POLLERR;
 	}
 
@@ -553,7 +553,7 @@ static void put_pipe_info(struct inode *inode, struct pipe_inode_info *pipe)
 	int kill = 0;
 
 	spin_lock(&inode->i_lock);
-	if (!--pipe->files) {
+	if (atomic_dec_and_test(&pipe->files)) {
 		inode->i_pipe = NULL;
 		kill = 1;
 	}
@@ -570,11 +570,11 @@ pipe_release(struct inode *inode, struct file *file)
 
 	__pipe_lock(pipe);
 	if (file->f_mode & FMODE_READ)
-		pipe->readers--;
+		atomic_dec(&pipe->readers);
 	if (file->f_mode & FMODE_WRITE)
-		pipe->writers--;
+		atomic_dec(&pipe->writers);
 
-	if (pipe->readers || pipe->writers) {
+	if (atomic_read(&pipe->readers) || atomic_read(&pipe->writers)) {
 		wake_up_interruptible_sync_poll(&pipe->wait, POLLIN | POLLOUT | POLLRDNORM | POLLWRNORM | POLLERR | POLLHUP);
 		kill_fasync(&pipe->fasync_readers, SIGIO, POLL_IN);
 		kill_fasync(&pipe->fasync_writers, SIGIO, POLL_OUT);
@@ -672,7 +672,7 @@ void free_pipe_info(struct pipe_inode_info *pipe)
 	kfree(pipe);
 }
 
-static struct vfsmount *pipe_mnt __read_mostly;
+struct vfsmount *pipe_mnt __read_mostly;
 
 /*
  * pipefs_dname() is called from d_path().
@@ -702,8 +702,9 @@ static struct inode * get_pipe_inode(void)
 		goto fail_iput;
 
 	inode->i_pipe = pipe;
-	pipe->files = 2;
-	pipe->readers = pipe->writers = 1;
+	atomic_set(&pipe->files, 2);
+	atomic_set(&pipe->readers, 1);
+	atomic_set(&pipe->writers, 1);
 	inode->i_fop = &pipefifo_fops;
 
 	/*
@@ -885,17 +886,17 @@ static int fifo_open(struct inode *inode, struct file *filp)
 	spin_lock(&inode->i_lock);
 	if (inode->i_pipe) {
 		pipe = inode->i_pipe;
-		pipe->files++;
+		atomic_inc(&pipe->files);
 		spin_unlock(&inode->i_lock);
 	} else {
 		spin_unlock(&inode->i_lock);
 		pipe = alloc_pipe_info();
 		if (!pipe)
 			return -ENOMEM;
-		pipe->files = 1;
+		atomic_set(&pipe->files, 1);
 		spin_lock(&inode->i_lock);
 		if (unlikely(inode->i_pipe)) {
-			inode->i_pipe->files++;
+			atomic_inc(&inode->i_pipe->files);
 			spin_unlock(&inode->i_lock);
 			free_pipe_info(pipe);
 			pipe = inode->i_pipe;
@@ -920,10 +921,10 @@ static int fifo_open(struct inode *inode, struct file *filp)
 	 *  opened, even when there is no process writing the FIFO.
 	 */
 		pipe->r_counter++;
-		if (pipe->readers++ == 0)
+		if (atomic_inc_return(&pipe->readers) == 1)
 			wake_up_partner(pipe);
 
-		if (!is_pipe && !pipe->writers) {
+		if (!is_pipe && !atomic_read(&pipe->writers)) {
 			if ((filp->f_flags & O_NONBLOCK)) {
 				/* suppress POLLHUP until we have
 				 * seen a writer */
@@ -942,14 +943,14 @@ static int fifo_open(struct inode *inode, struct file *filp)
 	 *  errno=ENXIO when there is no process reading the FIFO.
 	 */
 		ret = -ENXIO;
-		if (!is_pipe && (filp->f_flags & O_NONBLOCK) && !pipe->readers)
+		if (!is_pipe && (filp->f_flags & O_NONBLOCK) && !atomic_read(&pipe->readers))
 			goto err;
 
 		pipe->w_counter++;
-		if (!pipe->writers++)
+		if (atomic_inc_return(&pipe->writers) == 1)
 			wake_up_partner(pipe);
 
-		if (!is_pipe && !pipe->readers) {
+		if (!is_pipe && !atomic_read(&pipe->readers)) {
 			if (wait_for_partner(pipe, &pipe->r_counter))
 				goto err_wr;
 		}
@@ -963,11 +964,11 @@ static int fifo_open(struct inode *inode, struct file *filp)
 	 *  the process can at least talk to itself.
 	 */
 
-		pipe->readers++;
-		pipe->writers++;
+		atomic_inc(&pipe->readers);
+		atomic_inc(&pipe->writers);
 		pipe->r_counter++;
 		pipe->w_counter++;
-		if (pipe->readers == 1 || pipe->writers == 1)
+		if (atomic_read(&pipe->readers) == 1 || atomic_read(&pipe->writers) == 1)
 			wake_up_partner(pipe);
 		break;
 
@@ -981,13 +982,13 @@ static int fifo_open(struct inode *inode, struct file *filp)
 	return 0;
 
 err_rd:
-	if (!--pipe->readers)
+	if (atomic_dec_and_test(&pipe->readers))
 		wake_up_interruptible(&pipe->wait);
 	ret = -ERESTARTSYS;
 	goto err;
 
 err_wr:
-	if (!--pipe->writers)
+	if (atomic_dec_and_test(&pipe->writers))
 		wake_up_interruptible(&pipe->wait);
 	ret = -ERESTARTSYS;
 	goto err;
@@ -1065,7 +1066,7 @@ static long pipe_set_size(struct pipe_inode_info *pipe, unsigned long nr_pages)
  * Currently we rely on the pipe array holding a power-of-2 number
  * of pages.
  */
-static inline unsigned int round_pipe_size(unsigned int size)
+static inline unsigned long round_pipe_size(unsigned long size)
 {
 	unsigned long nr_pages;
 
@@ -1113,13 +1114,16 @@ long pipe_fcntl(struct file *file, unsigned int cmd, unsigned long arg)
 
 	switch (cmd) {
 	case F_SETPIPE_SZ: {
-		unsigned int size, nr_pages;
+		unsigned long size, nr_pages;
+
+		ret = -EINVAL;
+		if (arg < pipe_min_size)
+			goto out;
 
 		size = round_pipe_size(arg);
 		nr_pages = size >> PAGE_SHIFT;
 
-		ret = -EINVAL;
-		if (!nr_pages)
+		if (size < pipe_min_size)
 			goto out;
 
 		if (!capable(CAP_SYS_RESOURCE) && size > pipe_max_size) {
diff --git a/fs/posix_acl.c b/fs/posix_acl.c
index bfc3ec388..f37d85d0a 100644
--- a/fs/posix_acl.c
+++ b/fs/posix_acl.c
@@ -20,6 +20,7 @@
 #include <linux/xattr.h>
 #include <linux/export.h>
 #include <linux/user_namespace.h>
+#include <linux/grsecurity.h>
 
 static struct posix_acl **acl_by_type(struct inode *inode, int type)
 {
@@ -311,7 +312,7 @@ posix_acl_equiv_mode(const struct posix_acl *acl, umode_t *mode_p)
 		}
 	}
         if (mode_p)
-                *mode_p = (*mode_p & ~S_IRWXUGO) | mode;
+                *mode_p = ((*mode_p & ~S_IRWXUGO) | mode) & ~gr_acl_umask();
         return not_equiv;
 }
 EXPORT_SYMBOL(posix_acl_equiv_mode);
@@ -461,7 +462,7 @@ static int posix_acl_create_masq(struct posix_acl *acl, umode_t *mode_p)
 		mode &= (group_obj->e_perm << 3) | ~S_IRWXG;
 	}
 
-	*mode_p = (*mode_p & ~S_IRWXUGO) | mode;
+	*mode_p = ((*mode_p & ~S_IRWXUGO) | mode) & ~gr_acl_umask();
         return not_equiv;
 }
 
@@ -519,6 +520,8 @@ __posix_acl_create(struct posix_acl **acl, gfp_t gfp, umode_t *mode_p)
 	struct posix_acl *clone = posix_acl_clone(*acl, gfp);
 	int err = -ENOMEM;
 	if (clone) {
+		*mode_p &= ~gr_acl_umask();
+
 		err = posix_acl_create_masq(clone, mode_p);
 		if (err < 0) {
 			posix_acl_release(clone);
@@ -722,11 +725,12 @@ struct posix_acl *
 posix_acl_from_xattr(struct user_namespace *user_ns,
 		     const void *value, size_t size)
 {
-	posix_acl_xattr_header *header = (posix_acl_xattr_header *)value;
-	posix_acl_xattr_entry *entry = (posix_acl_xattr_entry *)(header+1), *end;
+	const posix_acl_xattr_header *header = (const posix_acl_xattr_header *)value;
+	const posix_acl_xattr_entry *entry = (const posix_acl_xattr_entry *)(header+1), *end;
 	int count;
 	struct posix_acl *acl;
 	struct posix_acl_entry *acl_e;
+	umode_t umask = gr_acl_umask();
 
 	if (!value)
 		return NULL;
@@ -752,12 +756,18 @@ posix_acl_from_xattr(struct user_namespace *user_ns,
 
 		switch(acl_e->e_tag) {
 			case ACL_USER_OBJ:
+				acl_e->e_perm &= ~((umask & S_IRWXU) >> 6);
+				break;
 			case ACL_GROUP_OBJ:
 			case ACL_MASK:
+				acl_e->e_perm &= ~((umask & S_IRWXG) >> 3);
+				break;
 			case ACL_OTHER:
+				acl_e->e_perm &= ~(umask & S_IRWXO);
 				break;
 
 			case ACL_USER:
+				acl_e->e_perm &= ~((umask & S_IRWXU) >> 6);
 				acl_e->e_uid =
 					make_kuid(user_ns,
 						  le32_to_cpu(entry->e_id));
@@ -765,6 +775,7 @@ posix_acl_from_xattr(struct user_namespace *user_ns,
 					goto fail;
 				break;
 			case ACL_GROUP:
+				acl_e->e_perm &= ~((umask & S_IRWXG) >> 3);
 				acl_e->e_gid =
 					make_kgid(user_ns,
 						  le32_to_cpu(entry->e_id));
diff --git a/fs/proc/Kconfig b/fs/proc/Kconfig
index 1ade1206b..a86f1a2a3 100644
--- a/fs/proc/Kconfig
+++ b/fs/proc/Kconfig
@@ -30,7 +30,7 @@ config PROC_FS
 
 config PROC_KCORE
 	bool "/proc/kcore support" if !ARM
-	depends on PROC_FS && MMU
+	depends on PROC_FS && MMU && !GRKERNSEC_PROC_ADD
 	help
 	  Provides a virtual ELF core file of the live kernel.  This can
 	  be read with gdb and other ELF tools.  No modifications can be
@@ -38,8 +38,8 @@ config PROC_KCORE
 
 config PROC_VMCORE
 	bool "/proc/vmcore support"
-	depends on PROC_FS && CRASH_DUMP
-	default y
+	depends on PROC_FS && CRASH_DUMP && !GRKERNSEC
+	default n
         help
         Exports the dump image of crashed kernel in ELF format.
 
@@ -63,8 +63,8 @@ config PROC_SYSCTL
 	  limited in memory.
 
 config PROC_PAGE_MONITOR
- 	default y
-	depends on PROC_FS && MMU
+ 	default n
+	depends on PROC_FS && MMU && !GRKERNSEC
 	bool "Enable /proc page monitoring" if EXPERT
  	help
 	  Various /proc files exist to monitor process memory utilization:
diff --git a/fs/proc/array.c b/fs/proc/array.c
index 88c7de121..3e4b51063 100644
--- a/fs/proc/array.c
+++ b/fs/proc/array.c
@@ -60,6 +60,7 @@
 #include <linux/tty.h>
 #include <linux/string.h>
 #include <linux/mman.h>
+#include <linux/grsecurity.h>
 #include <linux/proc_fs.h>
 #include <linux/ioport.h>
 #include <linux/uaccess.h>
@@ -369,6 +370,21 @@ static void task_cpus_allowed(struct seq_file *m, struct task_struct *task)
 		   cpumask_pr_args(&task->cpus_allowed));
 }
 
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+static inline void task_pax(struct seq_file *m, struct task_struct *p)
+{
+	if (p->mm)
+		seq_printf(m, "PaX:\t%c%c%c%c%c\n",
+			   p->mm->pax_flags & MF_PAX_PAGEEXEC ? 'P' : 'p',
+			   p->mm->pax_flags & MF_PAX_EMUTRAMP ? 'E' : 'e',
+			   p->mm->pax_flags & MF_PAX_MPROTECT ? 'M' : 'm',
+			   p->mm->pax_flags & MF_PAX_RANDMMAP ? 'R' : 'r',
+			   p->mm->pax_flags & MF_PAX_SEGMEXEC ? 'S' : 's');
+	else
+		seq_printf(m, "PaX:\t-----\n");
+}
+#endif
+
 int proc_pid_status(struct seq_file *m, struct pid_namespace *ns,
 			struct pid *pid, struct task_struct *task)
 {
@@ -387,9 +403,24 @@ int proc_pid_status(struct seq_file *m, struct pid_namespace *ns,
 	task_cpus_allowed(m, task);
 	cpuset_task_status_allowed(m, task);
 	task_context_switch_counts(m, task);
+
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+	task_pax(m, task);
+#endif
+
+#if defined(CONFIG_GRKERNSEC) && !defined(CONFIG_GRKERNSEC_NO_RBAC)
+	task_grsec_rbac(m, task);
+#endif
+
 	return 0;
 }
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+#define PAX_RAND_FLAGS(_mm) (_mm != NULL && _mm != current->mm && \
+			     (_mm->pax_flags & MF_PAX_RANDMMAP || \
+			      _mm->pax_flags & MF_PAX_SEGMEXEC))
+#endif
+
 static int do_task_stat(struct seq_file *m, struct pid_namespace *ns,
 			struct pid *pid, struct task_struct *task, int whole)
 {
@@ -411,6 +442,13 @@ static int do_task_stat(struct seq_file *m, struct pid_namespace *ns,
 	char tcomm[sizeof(task->comm)];
 	unsigned long flags;
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (current->exec_id != m->exec_id) {
+		gr_log_badprocpid("stat");
+		return 0;
+	}
+#endif
+
 	state = *get_task_state(task);
 	vsize = eip = esp = 0;
 	permitted = ptrace_may_access(task, PTRACE_MODE_READ_FSCREDS | PTRACE_MODE_NOAUDIT);
@@ -481,6 +519,19 @@ static int do_task_stat(struct seq_file *m, struct pid_namespace *ns,
 		gtime = task_gtime(task);
 	}
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (PAX_RAND_FLAGS(mm)) {
+		eip = 0;
+		esp = 0;
+		wchan = 0;
+	}
+#endif
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	wchan = 0;
+	eip =0;
+	esp =0;
+#endif
+
 	/* scale priority and nice values from timeslices to -20..20 */
 	/* to make it look like a "normal" Unix priority/nice value  */
 	priority = task_prio(task);
@@ -512,9 +563,15 @@ static int do_task_stat(struct seq_file *m, struct pid_namespace *ns,
 	seq_put_decimal_ull(m, ' ', vsize);
 	seq_put_decimal_ull(m, ' ', mm ? get_mm_rss(mm) : 0);
 	seq_put_decimal_ull(m, ' ', rsslim);
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	seq_put_decimal_ull(m, ' ', PAX_RAND_FLAGS(mm) ? 1 : (mm ? (permitted ? mm->start_code : 1) : 0));
+	seq_put_decimal_ull(m, ' ', PAX_RAND_FLAGS(mm) ? 1 : (mm ? (permitted ? mm->end_code : 1) : 0));
+	seq_put_decimal_ull(m, ' ', PAX_RAND_FLAGS(mm) ? 0 : ((permitted && mm) ? mm->start_stack : 0));
+#else
 	seq_put_decimal_ull(m, ' ', mm ? (permitted ? mm->start_code : 1) : 0);
 	seq_put_decimal_ull(m, ' ', mm ? (permitted ? mm->end_code : 1) : 0);
 	seq_put_decimal_ull(m, ' ', (permitted && mm) ? mm->start_stack : 0);
+#endif
 	seq_put_decimal_ull(m, ' ', esp);
 	seq_put_decimal_ull(m, ' ', eip);
 	/* The signal information here is obsolete.
@@ -548,7 +605,11 @@ static int do_task_stat(struct seq_file *m, struct pid_namespace *ns,
 	seq_put_decimal_ull(m, ' ', cputime_to_clock_t(gtime));
 	seq_put_decimal_ll(m, ' ', cputime_to_clock_t(cgtime));
 
-	if (mm && permitted) {
+	if (mm && permitted
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+		&& !PAX_RAND_FLAGS(mm)
+#endif
+	   ) {
 		seq_put_decimal_ull(m, ' ', mm->start_data);
 		seq_put_decimal_ull(m, ' ', mm->end_data);
 		seq_put_decimal_ull(m, ' ', mm->start_brk);
@@ -586,8 +647,15 @@ int proc_pid_statm(struct seq_file *m, struct pid_namespace *ns,
 			struct pid *pid, struct task_struct *task)
 {
 	unsigned long size = 0, resident = 0, shared = 0, text = 0, data = 0;
-	struct mm_struct *mm = get_task_mm(task);
+	struct mm_struct *mm;
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (current->exec_id != m->exec_id) {
+		gr_log_badprocpid("statm");
+		return 0;
+	}
+#endif
+	mm = get_task_mm(task);
 	if (mm) {
 		size = task_statm(mm, &shared, &text, &data, &resident);
 		mmput(mm);
@@ -610,6 +678,21 @@ int proc_pid_statm(struct seq_file *m, struct pid_namespace *ns,
 	return 0;
 }
 
+#ifdef CONFIG_GRKERNSEC_PROC_IPADDR
+int proc_pid_ipaddr(struct seq_file *m, struct pid_namespace *ns, struct pid *pid, struct task_struct *task)
+{
+	unsigned long flags;
+	u32 curr_ip = 0;
+
+	if (lock_task_sighand(task, &flags)) {
+		curr_ip = task->signal->curr_ip;
+		unlock_task_sighand(task, &flags);
+	}
+	seq_printf(m, "%pI4\n", &curr_ip);
+	return 0;
+}
+#endif
+
 #ifdef CONFIG_PROC_CHILDREN
 static struct pid *
 get_children_pid(struct inode *inode, struct pid *pid_prev, loff_t pos)
diff --git a/fs/proc/base.c b/fs/proc/base.c
index ac0df4dde..5be5b93fd 100644
--- a/fs/proc/base.c
+++ b/fs/proc/base.c
@@ -113,6 +113,14 @@ struct pid_entry {
 	union proc_op op;
 };
 
+struct getdents_callback {
+	struct linux_dirent __user * current_dir;
+	struct linux_dirent __user * previous;
+	struct file * file;
+	int count;
+	int error;
+};
+
 #define NOD(NAME, MODE, IOP, FOP, OP) {			\
 	.name = (NAME),					\
 	.len  = sizeof(NAME) - 1,			\
@@ -224,6 +232,11 @@ static ssize_t proc_pid_cmdline_read(struct file *file, char __user *buf,
 		goto out_mmput;
 	}
 
+	if (gr_acl_handle_procpidmem(tsk)) {
+		rv = 0;
+		goto out_mmput;
+	}
+
 	page = (char *)__get_free_page(GFP_TEMPORARY);
 	if (!page) {
 		rv = -ENOMEM;
@@ -400,12 +413,28 @@ static const struct file_operations proc_pid_cmdline_ops = {
 	.llseek	= generic_file_llseek,
 };
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+#define PAX_RAND_FLAGS(_mm) (_mm != NULL && _mm != current->mm && \
+			     (_mm->pax_flags & MF_PAX_RANDMMAP || \
+			      _mm->pax_flags & MF_PAX_SEGMEXEC))
+#endif
+
 static int proc_pid_auxv(struct seq_file *m, struct pid_namespace *ns,
 			 struct pid *pid, struct task_struct *task)
 {
 	struct mm_struct *mm = mm_access(task, PTRACE_MODE_READ_FSCREDS);
 	if (mm && !IS_ERR(mm)) {
 		unsigned int nwords = 0;
+
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+		/* allow if we're currently ptracing this task */
+		if (PAX_RAND_FLAGS(mm) &&
+		    (!(task->ptrace & PT_PTRACED) || (task->parent != current))) {
+			mmput(mm);
+			return 0;
+		}
+#endif
+
 		do {
 			nwords += 2;
 		} while (mm->saved_auxv[nwords - 2] != 0); /* AT_NULL */
@@ -417,7 +446,7 @@ static int proc_pid_auxv(struct seq_file *m, struct pid_namespace *ns,
 }
 
 
-#ifdef CONFIG_KALLSYMS
+#if defined(CONFIG_KALLSYMS) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 /*
  * Provides a wchan file via kallsyms in a proper one-value-per-file format.
  * Returns the resolved symbol.  If that fails, simply return the address.
@@ -430,8 +459,8 @@ static int proc_pid_wchan(struct seq_file *m, struct pid_namespace *ns,
 
 	wchan = get_wchan(task);
 
-	if (wchan && ptrace_may_access(task, PTRACE_MODE_READ_FSCREDS)
-			&& !lookup_symbol_name(wchan, symname))
+	if (wchan && !lookup_symbol_name(wchan, symname)
+	    		&& ptrace_may_access(task, PTRACE_MODE_READ_FSCREDS))
 		seq_printf(m, "%s", symname);
 	else
 		seq_putc(m, '0');
@@ -457,7 +486,7 @@ static void unlock_trace(struct task_struct *task)
 	mutex_unlock(&task->signal->cred_guard_mutex);
 }
 
-#ifdef CONFIG_STACKTRACE
+#if defined(CONFIG_STACKTRACE) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 
 #define MAX_STACK_TRACE_DEPTH	64
 
@@ -652,7 +681,7 @@ static int proc_pid_limits(struct seq_file *m, struct pid_namespace *ns,
 	return 0;
 }
 
-#ifdef CONFIG_HAVE_ARCH_TRACEHOOK
+#if defined(CONFIG_HAVE_ARCH_TRACEHOOK) && !defined(CONFIG_GRKERNSEC_PROC_MEMMAP)
 static int proc_pid_syscall(struct seq_file *m, struct pid_namespace *ns,
 			    struct pid *pid, struct task_struct *task)
 {
@@ -685,7 +714,7 @@ static int proc_pid_syscall(struct seq_file *m, struct pid_namespace *ns,
 /************************************************************************/
 
 /* permission checks */
-static int proc_fd_access_allowed(struct inode *inode)
+static int proc_fd_access_allowed(struct inode *inode, unsigned int log)
 {
 	struct task_struct *task;
 	int allowed = 0;
@@ -695,7 +724,10 @@ static int proc_fd_access_allowed(struct inode *inode)
 	 */
 	task = get_proc_task(inode);
 	if (task) {
-		allowed = ptrace_may_access(task, PTRACE_MODE_READ_FSCREDS);
+		if (log)
+			allowed = ptrace_may_access(task, PTRACE_MODE_READ_FSCREDS);
+		else
+			allowed = ptrace_may_access(task, PTRACE_MODE_READ_FSCREDS | PTRACE_MODE_NOAUDIT);
 		put_task_struct(task);
 	}
 	return allowed;
@@ -726,6 +758,30 @@ static bool has_pid_permissions(struct pid_namespace *pid,
 				 struct task_struct *task,
 				 int hide_pid_min)
 {
+	if (gr_pid_is_chrooted(task) || gr_check_hidden_task(task))
+		return false;
+
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	rcu_read_lock();
+	{
+		const struct cred *tmpcred = current_cred();
+		const struct cred *cred = __task_cred(task);
+
+		if (uid_eq(tmpcred->uid, GLOBAL_ROOT_UID) || uid_eq(tmpcred->uid, cred->uid)
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+			|| in_group_p(grsec_proc_gid)
+#endif
+		) {
+			rcu_read_unlock();
+			return true;
+		}
+	}
+	rcu_read_unlock();
+
+	if (!pid->hide_pid)
+		return ptrace_may_access(task, PTRACE_MODE_READ_FSCREDS | PTRACE_MODE_NOAUDIT);
+#endif
+
 	if (pid->hide_pid < hide_pid_min)
 		return true;
 	if (in_group_p(pid->pid_gid))
@@ -747,7 +803,11 @@ static int proc_pid_permission(struct inode *inode, int mask)
 	put_task_struct(task);
 
 	if (!has_perms) {
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+		{
+#else
 		if (pid->hide_pid == 2) {
+#endif
 			/*
 			 * Let's make getdents(), stat(), and open()
 			 * consistent with each other.  If a process
@@ -801,13 +861,24 @@ static const struct file_operations proc_single_file_operations = {
 };
 
 
-struct mm_struct *proc_mem_open(struct inode *inode, unsigned int mode)
+struct mm_struct *proc_mem_open(struct inode *inode, unsigned int mode, u64 *ptracer_exec_id)
 {
 	struct task_struct *task = get_proc_task(inode);
 	struct mm_struct *mm = ERR_PTR(-ESRCH);
 
+	if (ptracer_exec_id)
+		*ptracer_exec_id = 0;
+
 	if (task) {
 		mm = mm_access(task, mode | PTRACE_MODE_FSCREDS);
+		if (!IS_ERR_OR_NULL(mm) && gr_acl_handle_procpidmem(task)) {
+			mmput(mm);
+			mm = ERR_PTR(-EPERM);
+		}
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+		if (ptracer_exec_id)
+			current_is_ptracer(task, ptracer_exec_id);
+#endif
 		put_task_struct(task);
 
 		if (!IS_ERR_OR_NULL(mm)) {
@@ -823,12 +894,17 @@ struct mm_struct *proc_mem_open(struct inode *inode, unsigned int mode)
 
 static int __mem_open(struct inode *inode, struct file *file, unsigned int mode)
 {
-	struct mm_struct *mm = proc_mem_open(inode, mode);
+	struct mm_struct *mm = proc_mem_open(inode, mode, NULL);
 
 	if (IS_ERR(mm))
 		return PTR_ERR(mm);
 
 	file->private_data = mm;
+
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	file->f_version = current->exec_id;
+#endif
+
 	return 0;
 }
 
@@ -850,6 +926,26 @@ static ssize_t mem_rw(struct file *file, char __user *buf,
 	ssize_t copied;
 	char *page;
 
+#ifdef CONFIG_GRKERNSEC
+	struct task_struct *task = get_proc_task(file_inode(file));
+	bool is_by_ptracer = false;
+
+	if (task) {
+		is_by_ptracer = current_is_ptracer(task, NULL);
+		put_task_struct(task);
+	}
+
+	if (write && !is_by_ptracer)
+		return -EPERM;
+
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (file->f_version != current->exec_id && !is_by_ptracer) {
+		gr_log_badprocpid("mem");
+		return 0;
+	}
+#endif
+#endif
+
 	if (!mm)
 		return 0;
 
@@ -862,7 +958,7 @@ static ssize_t mem_rw(struct file *file, char __user *buf,
 		goto free;
 
 	while (count > 0) {
-		int this_len = min_t(int, count, PAGE_SIZE);
+		ssize_t this_len = min_t(ssize_t, count, PAGE_SIZE);
 
 		if (write && copy_from_user(page, buf, this_len)) {
 			copied = -EFAULT;
@@ -956,6 +1052,13 @@ static ssize_t environ_read(struct file *file, char __user *buf,
 	if (!mm || !mm->env_end)
 		return 0;
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (file->f_version != current->exec_id) {
+		gr_log_badprocpid("environ");
+		return 0;
+	}
+#endif
+
 	page = (char *)__get_free_page(GFP_TEMPORARY);
 	if (!page)
 		return -ENOMEM;
@@ -969,9 +1072,12 @@ static ssize_t environ_read(struct file *file, char __user *buf,
 	env_end = mm->env_end;
 	up_read(&mm->mmap_sem);
 
+	if (!env_end)
+		goto free;
+
 	while (count > 0) {
 		size_t this_len, max_len;
-		int retval;
+		ssize_t retval;
 
 		if (src >= (env_end - env_start))
 			break;
@@ -1583,7 +1689,7 @@ static const char *proc_pid_get_link(struct dentry *dentry,
 		return ERR_PTR(-ECHILD);
 
 	/* Are we allowed to snoop on the tasks file descriptors? */
-	if (!proc_fd_access_allowed(inode))
+	if (!proc_fd_access_allowed(inode, 0))
 		goto out;
 
 	error = PROC_I(inode)->op.proc_get_link(dentry, &path);
@@ -1627,8 +1733,18 @@ static int proc_pid_readlink(struct dentry * dentry, char __user * buffer, int b
 	struct path path;
 
 	/* Are we allowed to snoop on the tasks file descriptors? */
-	if (!proc_fd_access_allowed(inode))
-		goto out;
+	/* logging this is needed for learning on chromium to work properly,
+	   but we don't want to flood the logs from 'ps' which does a readlink
+	   on /proc/fd/2 of tasks in the listing, nor do we want 'ps' to learn
+	   CAP_SYS_PTRACE as it's not necessary for its basic functionality
+	 */
+	if (dentry->d_name.name[0] == '2' && dentry->d_name.name[1] == '\0') {
+		if (!proc_fd_access_allowed(inode,0))
+			goto out;
+	} else {
+		if (!proc_fd_access_allowed(inode,1))
+			goto out;
+	}
 
 	error = PROC_I(inode)->op.proc_get_link(dentry, &path);
 	if (error)
@@ -1678,7 +1794,11 @@ struct inode *proc_pid_make_inode(struct super_block * sb, struct task_struct *t
 		rcu_read_lock();
 		cred = __task_cred(task);
 		inode->i_uid = cred->euid;
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+		inode->i_gid = grsec_proc_gid;
+#else
 		inode->i_gid = cred->egid;
+#endif
 		rcu_read_unlock();
 	}
 	security_task_to_inode(task, inode);
@@ -1714,10 +1834,19 @@ int pid_getattr(struct vfsmount *mnt, struct dentry *dentry, struct kstat *stat)
 			return -ENOENT;
 		}
 		if ((inode->i_mode == (S_IFDIR|S_IRUGO|S_IXUGO)) ||
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+		    (inode->i_mode == (S_IFDIR|S_IRUSR|S_IXUSR)) ||
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+		    (inode->i_mode == (S_IFDIR|S_IRUSR|S_IRGRP|S_IXUSR|S_IXGRP)) ||
+#endif
 		    task_dumpable(task)) {
 			cred = __task_cred(task);
 			stat->uid = cred->euid;
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+			stat->gid = grsec_proc_gid;
+#else
 			stat->gid = cred->egid;
+#endif
 		}
 	}
 	rcu_read_unlock();
@@ -1755,11 +1884,20 @@ int pid_revalidate(struct dentry *dentry, unsigned int flags)
 
 	if (task) {
 		if ((inode->i_mode == (S_IFDIR|S_IRUGO|S_IXUGO)) ||
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+		    (inode->i_mode == (S_IFDIR|S_IRUSR|S_IXUSR)) ||
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+		    (inode->i_mode == (S_IFDIR|S_IRUSR|S_IRGRP|S_IXUSR|S_IXGRP)) ||
+#endif
 		    task_dumpable(task)) {
 			rcu_read_lock();
 			cred = __task_cred(task);
 			inode->i_uid = cred->euid;
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+			inode->i_gid = grsec_proc_gid;
+#else
 			inode->i_gid = cred->egid;
+#endif
 			rcu_read_unlock();
 		} else {
 			inode->i_uid = GLOBAL_ROOT_UID;
@@ -2373,6 +2511,9 @@ static struct dentry *proc_pident_lookup(struct inode *dir,
 	if (!task)
 		goto out_no_task;
 
+	if (gr_pid_is_chrooted(task) || gr_check_hidden_task(task))
+		goto out;
+
 	/*
 	 * Yes, it does not scale. And it should not. Don't add
 	 * new entries into /proc/<tgid>/ without very good reasons.
@@ -2403,6 +2544,9 @@ static int proc_pident_readdir(struct file *file, struct dir_context *ctx,
 	if (!task)
 		return -ENOENT;
 
+	if (gr_pid_is_chrooted(task) || gr_check_hidden_task(task))
+		goto out;
+
 	if (!dir_emit_dots(file, ctx))
 		goto out;
 
@@ -2815,7 +2959,9 @@ static const struct inode_operations proc_task_inode_operations;
 static const struct pid_entry tgid_base_stuff[] = {
 	DIR("task",       S_IRUGO|S_IXUGO, proc_task_inode_operations, proc_task_operations),
 	DIR("fd",         S_IRUSR|S_IXUSR, proc_fd_inode_operations, proc_fd_operations),
+#ifndef CONFIG_GRKERNSEC
 	DIR("map_files",  S_IRUSR|S_IXUSR, proc_map_files_inode_operations, proc_map_files_operations),
+#endif
 	DIR("fdinfo",     S_IRUSR|S_IXUSR, proc_fdinfo_inode_operations, proc_fdinfo_operations),
 	DIR("ns",	  S_IRUSR|S_IXUGO, proc_ns_dir_inode_operations, proc_ns_dir_operations),
 #ifdef CONFIG_NET
@@ -2833,7 +2979,7 @@ static const struct pid_entry tgid_base_stuff[] = {
 	REG("autogroup",  S_IRUGO|S_IWUSR, proc_pid_sched_autogroup_operations),
 #endif
 	REG("comm",      S_IRUGO|S_IWUSR, proc_pid_set_comm_operations),
-#ifdef CONFIG_HAVE_ARCH_TRACEHOOK
+#if defined(CONFIG_HAVE_ARCH_TRACEHOOK) && !defined(CONFIG_GRKERNSEC_PROC_MEMMAP)
 	ONE("syscall",    S_IRUSR, proc_pid_syscall),
 #endif
 	REG("cmdline",    S_IRUGO, proc_pid_cmdline_ops),
@@ -2858,10 +3004,10 @@ static const struct pid_entry tgid_base_stuff[] = {
 #ifdef CONFIG_SECURITY
 	DIR("attr",       S_IRUGO|S_IXUGO, proc_attr_dir_inode_operations, proc_attr_dir_operations),
 #endif
-#ifdef CONFIG_KALLSYMS
+#if defined(CONFIG_KALLSYMS) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 	ONE("wchan",      S_IRUGO, proc_pid_wchan),
 #endif
-#ifdef CONFIG_STACKTRACE
+#if defined(CONFIG_STACKTRACE) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 	ONE("stack",      S_IRUSR, proc_pid_stack),
 #endif
 #ifdef CONFIG_SCHED_INFO
@@ -2895,6 +3041,9 @@ static const struct pid_entry tgid_base_stuff[] = {
 #ifdef CONFIG_HARDWALL
 	ONE("hardwall",   S_IRUGO, proc_pid_hardwall),
 #endif
+#ifdef CONFIG_GRKERNSEC_PROC_IPADDR
+	ONE("ipaddr",     S_IRUSR, proc_pid_ipaddr),
+#endif
 #ifdef CONFIG_USER_NS
 	REG("uid_map",    S_IRUGO|S_IWUSR, proc_uid_map_operations),
 	REG("gid_map",    S_IRUGO|S_IWUSR, proc_gid_map_operations),
@@ -3028,7 +3177,14 @@ static int proc_pid_instantiate(struct inode *dir,
 	if (!inode)
 		goto out;
 
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	inode->i_mode = S_IFDIR|S_IRUSR|S_IXUSR;
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	inode->i_gid = grsec_proc_gid;
+	inode->i_mode = S_IFDIR|S_IRUSR|S_IRGRP|S_IXUSR|S_IXGRP;
+#else
 	inode->i_mode = S_IFDIR|S_IRUGO|S_IXUGO;
+#endif
 	inode->i_op = &proc_tgid_base_inode_operations;
 	inode->i_fop = &proc_tgid_base_operations;
 	inode->i_flags|=S_IMMUTABLE;
@@ -3066,7 +3222,11 @@ struct dentry *proc_pid_lookup(struct inode *dir, struct dentry * dentry, unsign
 	if (!task)
 		goto out;
 
+	if (gr_pid_is_chrooted(task) || gr_check_hidden_task(task))
+		goto out_put_task;
+
 	result = proc_pid_instantiate(dir, dentry, task, NULL);
+out_put_task:
 	put_task_struct(task);
 out:
 	return ERR_PTR(result);
@@ -3220,7 +3380,7 @@ static const struct pid_entry tid_base_stuff[] = {
 	NOD("comm",      S_IFREG|S_IRUGO|S_IWUSR,
 			 &proc_tid_comm_inode_operations,
 			 &proc_pid_set_comm_operations, {}),
-#ifdef CONFIG_HAVE_ARCH_TRACEHOOK
+#if defined(CONFIG_HAVE_ARCH_TRACEHOOK) && !defined(CONFIG_GRKERNSEC_PROC_MEMMAP)
 	ONE("syscall",   S_IRUSR, proc_pid_syscall),
 #endif
 	REG("cmdline",   S_IRUGO, proc_pid_cmdline_ops),
@@ -3247,10 +3407,10 @@ static const struct pid_entry tid_base_stuff[] = {
 #ifdef CONFIG_SECURITY
 	DIR("attr",      S_IRUGO|S_IXUGO, proc_attr_dir_inode_operations, proc_attr_dir_operations),
 #endif
-#ifdef CONFIG_KALLSYMS
+#if defined(CONFIG_KALLSYMS) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 	ONE("wchan",     S_IRUGO, proc_pid_wchan),
 #endif
-#ifdef CONFIG_STACKTRACE
+#if defined(CONFIG_STACKTRACE) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 	ONE("stack",      S_IRUSR, proc_pid_stack),
 #endif
 #ifdef CONFIG_SCHED_INFO
diff --git a/fs/proc/cmdline.c b/fs/proc/cmdline.c
index cbd82dff7..c0407d23e 100644
--- a/fs/proc/cmdline.c
+++ b/fs/proc/cmdline.c
@@ -23,7 +23,11 @@ static const struct file_operations cmdline_proc_fops = {
 
 static int __init proc_cmdline_init(void)
 {
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+	proc_create_grsec("cmdline", 0, NULL, &cmdline_proc_fops);
+#else
 	proc_create("cmdline", 0, NULL, &cmdline_proc_fops);
+#endif
 	return 0;
 }
 fs_initcall(proc_cmdline_init);
diff --git a/fs/proc/devices.c b/fs/proc/devices.c
index 50493edc3..248166b06 100644
--- a/fs/proc/devices.c
+++ b/fs/proc/devices.c
@@ -64,7 +64,11 @@ static const struct file_operations proc_devinfo_operations = {
 
 static int __init proc_devices_init(void)
 {
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+	proc_create_grsec("devices", 0, NULL, &proc_devinfo_operations);
+#else
 	proc_create("devices", 0, NULL, &proc_devinfo_operations);
+#endif
 	return 0;
 }
 fs_initcall(proc_devices_init);
diff --git a/fs/proc/fd.c b/fs/proc/fd.c
index 01df23cc8..9b6c8f993 100644
--- a/fs/proc/fd.c
+++ b/fs/proc/fd.c
@@ -27,7 +27,8 @@ static int seq_show(struct seq_file *m, void *v)
 	if (!task)
 		return -ENOENT;
 
-	files = get_files_struct(task);
+	if (!gr_acl_handle_procpidmem(task))
+		files = get_files_struct(task);
 	put_task_struct(task);
 
 	if (files) {
@@ -296,13 +297,15 @@ int proc_fd_permission(struct inode *inode, int mask)
 	int rv;
 
 	rv = generic_permission(inode, mask);
-	if (rv == 0)
-		return rv;
 
 	rcu_read_lock();
 	p = pid_task(proc_pid(inode), PIDTYPE_PID);
-	if (p && same_thread_group(p, current))
-		rv = 0;
+	if (p) {
+		if (same_thread_group(p, current))
+			rv = 0;
+		if (gr_acl_handle_procpidmem(p))
+			rv = -EACCES;
+	}
 	rcu_read_unlock();
 
 	return rv;
diff --git a/fs/proc/generic.c b/fs/proc/generic.c
index c63347661..881fce890 100644
--- a/fs/proc/generic.c
+++ b/fs/proc/generic.c
@@ -22,6 +22,7 @@
 #include <linux/bitops.h>
 #include <linux/spinlock.h>
 #include <linux/completion.h>
+#include <linux/grsecurity.h>
 #include <asm/uaccess.h>
 
 #include "internal.h"
@@ -253,6 +254,15 @@ struct dentry *proc_lookup(struct inode *dir, struct dentry *dentry,
 	return proc_lookup_de(PDE(dir), dir, dentry);
 }
 
+struct dentry *proc_lookup_restrict(struct inode *dir, struct dentry *dentry,
+		unsigned int flags)
+{
+	if (gr_proc_is_restricted())
+		return ERR_PTR(-EACCES);
+
+	return proc_lookup_de(PDE(dir), dir, dentry);
+}
+
 /*
  * This returns non-zero if at EOF, so that the /proc
  * root directory can use this and check if it should
@@ -310,6 +320,16 @@ int proc_readdir(struct file *file, struct dir_context *ctx)
 	return proc_readdir_de(PDE(inode), file, ctx);
 }
 
+int proc_readdir_restrict(struct file *file, struct dir_context *ctx)
+{
+	struct inode *inode = file_inode(file);
+
+	if (gr_proc_is_restricted())
+		return -EACCES;
+
+	return proc_readdir_de(PDE(inode), file, ctx);
+}
+
 /*
  * These are the generic /proc directory operations. They
  * use the in-memory "struct proc_dir_entry" tree to parse
@@ -321,6 +341,12 @@ static const struct file_operations proc_dir_operations = {
 	.iterate_shared		= proc_readdir,
 };
 
+static const struct file_operations proc_dir_restricted_operations = {
+	.llseek			= generic_file_llseek,
+	.read			= generic_read_dir,
+	.iterate		= proc_readdir_restrict,
+};
+
 /*
  * proc directories can do almost nothing..
  */
@@ -330,6 +356,12 @@ static const struct inode_operations proc_dir_inode_operations = {
 	.setattr	= proc_notify_change,
 };
 
+static const struct inode_operations proc_dir_restricted_inode_operations = {
+	.lookup		= proc_lookup_restrict,
+	.getattr	= proc_getattr,
+	.setattr	= proc_notify_change,
+};
+
 static int proc_register(struct proc_dir_entry * dir, struct proc_dir_entry * dp)
 {
 	int ret;
@@ -445,6 +477,31 @@ struct proc_dir_entry *proc_mkdir_data(const char *name, umode_t mode,
 }
 EXPORT_SYMBOL_GPL(proc_mkdir_data);
 
+struct proc_dir_entry *proc_mkdir_data_restrict(const char *name, umode_t mode,
+		struct proc_dir_entry *parent, void *data)
+{
+	struct proc_dir_entry *ent;
+
+	if (mode == 0)
+		mode = S_IRUGO | S_IXUGO;
+
+	ent = __proc_create(&parent, name, S_IFDIR | mode, 2);
+	if (ent) {
+		ent->data = data;
+		ent->restricted = 1;
+		ent->proc_fops = &proc_dir_restricted_operations;
+		ent->proc_iops = &proc_dir_restricted_inode_operations;
+		parent->nlink++;
+		if (proc_register(parent, ent) < 0) {
+			kfree(ent);
+			parent->nlink--;
+			ent = NULL;
+		}
+	}
+	return ent;
+}
+EXPORT_SYMBOL_GPL(proc_mkdir_data_restrict);
+
 struct proc_dir_entry *proc_mkdir_mode(const char *name, umode_t mode,
 				       struct proc_dir_entry *parent)
 {
@@ -459,6 +516,13 @@ struct proc_dir_entry *proc_mkdir(const char *name,
 }
 EXPORT_SYMBOL(proc_mkdir);
 
+struct proc_dir_entry *proc_mkdir_restrict(const char *name,
+		struct proc_dir_entry *parent)
+{
+	return proc_mkdir_data_restrict(name, 0, parent, NULL);
+}
+EXPORT_SYMBOL(proc_mkdir_restrict);
+
 struct proc_dir_entry *proc_create_mount_point(const char *name)
 {
 	umode_t mode = S_IFDIR | S_IRUGO | S_IXUGO;
diff --git a/fs/proc/inode.c b/fs/proc/inode.c
index c1b72388e..290c70766 100644
--- a/fs/proc/inode.c
+++ b/fs/proc/inode.c
@@ -23,11 +23,17 @@
 #include <linux/slab.h>
 #include <linux/mount.h>
 #include <linux/magic.h>
+#include <linux/grsecurity.h>
 
 #include <asm/uaccess.h>
 
 #include "internal.h"
 
+#ifdef CONFIG_PROC_SYSCTL
+extern const struct inode_operations proc_sys_inode_operations;
+extern const struct inode_operations proc_sys_dir_operations;
+#endif
+
 static void proc_evict_inode(struct inode *inode)
 {
 	struct proc_dir_entry *de;
@@ -48,6 +54,13 @@ static void proc_evict_inode(struct inode *inode)
 		RCU_INIT_POINTER(PROC_I(inode)->sysctl, NULL);
 		sysctl_head_put(head);
 	}
+
+#ifdef CONFIG_PROC_SYSCTL
+	if (inode->i_op == &proc_sys_inode_operations ||
+	    inode->i_op == &proc_sys_dir_operations)
+		gr_handle_delete(inode->i_ino, inode->i_sb->s_dev);
+#endif
+
 }
 
 static struct kmem_cache * proc_inode_cachep;
@@ -431,7 +444,11 @@ struct inode *proc_get_inode(struct super_block *sb, struct proc_dir_entry *de)
 		if (de->mode) {
 			inode->i_mode = de->mode;
 			inode->i_uid = de->uid;
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+			inode->i_gid = grsec_proc_gid;
+#else
 			inode->i_gid = de->gid;
+#endif
 		}
 		if (de->size)
 			inode->i_size = de->size;
diff --git a/fs/proc/internal.h b/fs/proc/internal.h
index 7931c558c..7db5ad167 100644
--- a/fs/proc/internal.h
+++ b/fs/proc/internal.h
@@ -47,9 +47,10 @@ struct proc_dir_entry {
 	struct completion *pde_unload_completion;
 	struct list_head pde_openers;	/* who did ->open, but not ->release */
 	spinlock_t pde_unload_lock; /* proc_fops checks and pde_users bumps */
+	u8 restricted; /* a directory in /proc/net that should be restricted via GRKERNSEC_PROC */
 	u8 namelen;
 	char name[];
-};
+} __randomize_layout;
 
 union proc_op {
 	int (*proc_get_link)(struct dentry *, struct path *);
@@ -67,7 +68,7 @@ struct proc_inode {
 	struct ctl_table *sysctl_entry;
 	const struct proc_ns_operations *ns_ops;
 	struct inode vfs_inode;
-};
+} __randomize_layout;
 
 /*
  * General functions
@@ -155,6 +156,10 @@ extern int proc_pid_status(struct seq_file *, struct pid_namespace *,
 			   struct pid *, struct task_struct *);
 extern int proc_pid_statm(struct seq_file *, struct pid_namespace *,
 			  struct pid *, struct task_struct *);
+#ifdef CONFIG_GRKERNSEC_PROC_IPADDR
+extern int proc_pid_ipaddr(struct seq_file *, struct pid_namespace *,
+			  struct pid *, struct task_struct *);
+#endif
 
 /*
  * base.c
@@ -179,9 +184,11 @@ extern bool proc_fill_cache(struct file *, struct dir_context *, const char *, i
  * generic.c
  */
 extern struct dentry *proc_lookup(struct inode *, struct dentry *, unsigned int);
+extern struct dentry *proc_lookup_restrict(struct inode *, struct dentry *, unsigned int);
 extern struct dentry *proc_lookup_de(struct proc_dir_entry *, struct inode *,
 				     struct dentry *);
 extern int proc_readdir(struct file *, struct dir_context *);
+extern int proc_readdir_restrict(struct file *, struct dir_context *);
 extern int proc_readdir_de(struct proc_dir_entry *, struct file *, struct dir_context *);
 
 static inline struct proc_dir_entry *pde_get(struct proc_dir_entry *pde)
@@ -286,9 +293,12 @@ struct proc_maps_private {
 #ifdef CONFIG_NUMA
 	struct mempolicy *task_mempolicy;
 #endif
-};
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	u64 ptracer_exec_id;
+#endif
+} __randomize_layout;
 
-struct mm_struct *proc_mem_open(struct inode *inode, unsigned int mode);
+struct mm_struct *proc_mem_open(struct inode *inode, unsigned int mode, u64 *ptracer_exec_id);
 
 extern const struct file_operations proc_pid_maps_operations;
 extern const struct file_operations proc_tid_maps_operations;
diff --git a/fs/proc/interrupts.c b/fs/proc/interrupts.c
index a352d5703..cb94a5cc1 100644
--- a/fs/proc/interrupts.c
+++ b/fs/proc/interrupts.c
@@ -47,7 +47,11 @@ static const struct file_operations proc_interrupts_operations = {
 
 static int __init proc_interrupts_init(void)
 {
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+	proc_create_grsec("interrupts", 0, NULL, &proc_interrupts_operations);
+#else
 	proc_create("interrupts", 0, NULL, &proc_interrupts_operations);
+#endif
 	return 0;
 }
 fs_initcall(proc_interrupts_init);
diff --git a/fs/proc/kcore.c b/fs/proc/kcore.c
index 5c89a07e3..1749d0652 100644
--- a/fs/proc/kcore.c
+++ b/fs/proc/kcore.c
@@ -316,7 +316,7 @@ static char *storenote(struct memelfnote *men, char *bufp)
  * store an ELF coredump header in the supplied buffer
  * nphdr is the number of elf_phdr to insert
  */
-static void elf_kcore_store_hdr(char *bufp, int nphdr, int dataoff)
+static void elf_kcore_store_hdr(char *bufp, int nphdr, size_t dataoff)
 {
 	struct elf_prstatus prstatus;	/* NT_PRSTATUS */
 	struct elf_prpsinfo prpsinfo;	/* NT_PRPSINFO */
@@ -484,9 +484,10 @@ read_kcore(struct file *file, char __user *buffer, size_t buflen, loff_t *fpos)
 	 * the addresses in the elf_phdr on our list.
 	 */
 	start = kc_offset_to_vaddr(*fpos - elf_buflen);
-	if ((tsz = (PAGE_SIZE - (start & ~PAGE_MASK))) > buflen)
+	tsz = PAGE_SIZE - (start & ~PAGE_MASK);
+	if (tsz > buflen)
 		tsz = buflen;
-		
+
 	while (buflen) {
 		struct kcore_list *m;
 
@@ -508,24 +509,22 @@ read_kcore(struct file *file, char __user *buffer, size_t buflen, loff_t *fpos)
 		} else {
 			if (kern_addr_valid(start)) {
 				unsigned long n;
+				mm_segment_t oldfs;
 
 				/*
 				 * Using bounce buffer to bypass the
 				 * hardened user copy kernel text checks.
 				 */
-				memcpy(buf, (char *) start, tsz);
-				n = copy_to_user(buffer, buf, tsz);
-				/*
-				 * We cannot distinguish between fault on source
-				 * and fault on destination. When this happens
-				 * we clear too and hope it will trigger the
-				 * EFAULT again.
-				 */
-				if (n) { 
-					if (clear_user(buffer + tsz - n,
-								n))
-						return -EFAULT;
-				}
+				oldfs = get_fs();
+				set_fs(KERNEL_DS);
+				n = __copy_from_user(buf, (const void __user *)start, tsz);
+				set_fs(oldfs);
+				if (n)
+					n = clear_user(buffer, tsz);
+				else
+					n = copy_to_user(buffer, buf, tsz);
+				if (n)
+					return -EFAULT;
 			} else {
 				if (clear_user(buffer, tsz))
 					return -EFAULT;
@@ -545,10 +544,13 @@ read_kcore(struct file *file, char __user *buffer, size_t buflen, loff_t *fpos)
 
 static int open_kcore(struct inode *inode, struct file *filp)
 {
+#if defined(CONFIG_GRKERNSEC_PROC_ADD) || defined(CONFIG_GRKERNSEC_HIDESYM)
+	return -EPERM;
+#endif
 	if (!capable(CAP_SYS_RAWIO))
 		return -EPERM;
 
-	filp->private_data = kmalloc(PAGE_SIZE, GFP_KERNEL);
+	filp->private_data = kmalloc(PAGE_SIZE, GFP_KERNEL|GFP_USERCOPY);
 	if (!filp->private_data)
 		return -ENOMEM;
 
@@ -589,7 +591,7 @@ static int __meminit kcore_callback(struct notifier_block *self,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block kcore_callback_nb __meminitdata = {
+static struct notifier_block kcore_callback_nb = {
 	.notifier_call = kcore_callback,
 	.priority = 0,
 };
diff --git a/fs/proc/meminfo.c b/fs/proc/meminfo.c
index b9a8c813e..936ca0668 100644
--- a/fs/proc/meminfo.c
+++ b/fs/proc/meminfo.c
@@ -161,7 +161,7 @@ static int meminfo_proc_show(struct seq_file *m, void *v)
 		0ul, // used to be vmalloc 'used'
 		0ul  // used to be vmalloc 'largest_chunk'
 #ifdef CONFIG_MEMORY_FAILURE
-		, atomic_long_read(&num_poisoned_pages) << (PAGE_SHIFT - 10)
+		, atomic_long_read_unchecked(&num_poisoned_pages) << (PAGE_SHIFT - 10)
 #endif
 #ifdef CONFIG_TRANSPARENT_HUGEPAGE
 		, K(global_node_page_state(NR_ANON_THPS) * HPAGE_PMD_NR)
diff --git a/fs/proc/nommu.c b/fs/proc/nommu.c
index f8595e8b5..e0d13cbdc 100644
--- a/fs/proc/nommu.c
+++ b/fs/proc/nommu.c
@@ -64,7 +64,7 @@ static int nommu_region_show(struct seq_file *m, struct vm_region *region)
 
 	if (file) {
 		seq_pad(m, ' ');
-		seq_file_path(m, file, "");
+		seq_file_path(m, file, "\n\\");
 	}
 
 	seq_putc(m, '\n');
diff --git a/fs/proc/proc_net.c b/fs/proc/proc_net.c
index c8bbc68cd..d0f82d537 100644
--- a/fs/proc/proc_net.c
+++ b/fs/proc/proc_net.c
@@ -23,9 +23,27 @@
 #include <linux/nsproxy.h>
 #include <net/net_namespace.h>
 #include <linux/seq_file.h>
+#include <linux/grsecurity.h>
 
 #include "internal.h"
 
+#if defined(CONFIG_IPV6) || defined(CONFIG_IPV6_MODULE)
+static struct seq_operations *ipv6_seq_ops_addr;
+
+void register_ipv6_seq_ops_addr(struct seq_operations *addr)
+{
+	ipv6_seq_ops_addr = addr;
+}
+
+void unregister_ipv6_seq_ops_addr(void)
+{
+	ipv6_seq_ops_addr = NULL;
+}
+
+EXPORT_SYMBOL_GPL(register_ipv6_seq_ops_addr);
+EXPORT_SYMBOL_GPL(unregister_ipv6_seq_ops_addr);
+#endif
+
 static inline struct net *PDE_NET(struct proc_dir_entry *pde)
 {
 	return pde->parent->data;
@@ -36,6 +54,8 @@ static struct net *get_proc_net(const struct inode *inode)
 	return maybe_get_net(PDE_NET(PDE(inode)));
 }
 
+extern const struct seq_operations dev_seq_ops;
+
 int seq_open_net(struct inode *ino, struct file *f,
 		 const struct seq_operations *ops, int size)
 {
@@ -44,6 +64,14 @@ int seq_open_net(struct inode *ino, struct file *f,
 
 	BUG_ON(size < sizeof(*p));
 
+	/* only permit access to /proc/net/dev */
+	if (
+#if defined(CONFIG_IPV6) || defined(CONFIG_IPV6_MODULE)
+	    ops != ipv6_seq_ops_addr && 
+#endif
+	    ops != &dev_seq_ops && gr_proc_is_restricted())
+		return -EACCES;
+
 	net = get_proc_net(ino);
 	if (net == NULL)
 		return -ENXIO;
@@ -66,6 +94,9 @@ int single_open_net(struct inode *inode, struct file *file,
 	int err;
 	struct net *net;
 
+	if (gr_proc_is_restricted())
+		return -EACCES;
+
 	err = -ENXIO;
 	net = get_proc_net(inode);
 	if (net == NULL)
@@ -220,7 +251,7 @@ static __net_exit void proc_net_ns_exit(struct net *net)
 	kfree(net->proc_net);
 }
 
-static struct pernet_operations __net_initdata proc_net_ns_ops = {
+static struct pernet_operations __net_initconst proc_net_ns_ops = {
 	.init = proc_net_ns_init,
 	.exit = proc_net_ns_exit,
 };
diff --git a/fs/proc/proc_sysctl.c b/fs/proc/proc_sysctl.c
index 1b93650dd..49c54f2a4 100644
--- a/fs/proc/proc_sysctl.c
+++ b/fs/proc/proc_sysctl.c
@@ -11,13 +11,21 @@
 #include <linux/namei.h>
 #include <linux/mm.h>
 #include <linux/module.h>
+#include <linux/nsproxy.h>
+#ifdef CONFIG_GRKERNSEC
+#include <net/net_namespace.h>
+#endif
 #include "internal.h"
 
+extern int gr_handle_chroot_sysctl(const int op);
+extern int gr_handle_sysctl_mod(const char *dirname, const char *name,
+				const int op);
+
 static const struct dentry_operations proc_sys_dentry_operations;
 static const struct file_operations proc_sys_file_operations;
-static const struct inode_operations proc_sys_inode_operations;
+const struct inode_operations proc_sys_inode_operations;
 static const struct file_operations proc_sys_dir_file_operations;
-static const struct inode_operations proc_sys_dir_operations;
+const struct inode_operations proc_sys_dir_operations;
 
 /* Support for permanently empty directories */
 
@@ -32,13 +40,17 @@ static bool is_empty_dir(struct ctl_table_header *head)
 
 static void set_empty_dir(struct ctl_dir *dir)
 {
-	dir->header.ctl_table[0].child = sysctl_mount_point;
+	pax_open_kernel();
+	const_cast(dir->header.ctl_table[0].child) = sysctl_mount_point;
+	pax_close_kernel();
 }
 
 static void clear_empty_dir(struct ctl_dir *dir)
 
 {
-	dir->header.ctl_table[0].child = NULL;
+	pax_open_kernel();
+	const_cast(dir->header.ctl_table[0].child) = NULL;
+	pax_close_kernel();
 }
 
 void proc_sys_poll_notify(struct ctl_table_poll *poll)
@@ -504,6 +516,9 @@ static struct dentry *proc_sys_lookup(struct inode *dir, struct dentry *dentry,
 
 	err = NULL;
 	d_set_d_op(dentry, &proc_sys_dentry_operations);
+
+	gr_handle_proc_create(dentry, inode);
+
 	d_add(dentry, inode);
 
 out:
@@ -519,6 +534,7 @@ static ssize_t proc_sys_call_handler(struct file *filp, void __user *buf,
 	struct inode *inode = file_inode(filp);
 	struct ctl_table_header *head = grab_header(inode);
 	struct ctl_table *table = PROC_I(inode)->sysctl_entry;
+	int op = write ? MAY_WRITE : MAY_READ;
 	ssize_t error;
 	size_t res;
 
@@ -530,7 +546,7 @@ static ssize_t proc_sys_call_handler(struct file *filp, void __user *buf,
 	 * and won't be until we finish.
 	 */
 	error = -EPERM;
-	if (sysctl_perm(head, table, write ? MAY_WRITE : MAY_READ))
+	if (sysctl_perm(head, table, op))
 		goto out;
 
 	/* if that can happen at all, it should be -EINVAL, not -EISDIR */
@@ -538,6 +554,27 @@ static ssize_t proc_sys_call_handler(struct file *filp, void __user *buf,
 	if (!table->proc_handler)
 		goto out;
 
+#ifdef CONFIG_GRKERNSEC
+	error = -EPERM;
+	if (gr_handle_chroot_sysctl(op))
+		goto out;
+	dget(filp->f_path.dentry);
+	if (gr_handle_sysctl_mod((const char *)filp->f_path.dentry->d_parent->d_name.name, table->procname, op)) {
+		dput(filp->f_path.dentry);
+		goto out;
+	}
+	dput(filp->f_path.dentry);
+	if (!gr_acl_handle_open(filp->f_path.dentry, filp->f_path.mnt, op))
+		goto out;
+	if (write) {
+		if (current->nsproxy->net_ns != table->extra2) {
+			if (!capable(CAP_SYS_ADMIN))
+				goto out;
+		} else if (!ns_capable(current->nsproxy->net_ns->user_ns, CAP_NET_ADMIN))
+			goto out;
+	}
+#endif
+
 	/* careful: calling conventions are nasty here */
 	res = count;
 	error = table->proc_handler(table, write, buf, &res, ppos);
@@ -639,6 +676,7 @@ static bool proc_sys_fill_cache(struct file *file,
 				return false;
 			}
 			d_set_d_op(child, &proc_sys_dentry_operations);
+			gr_handle_proc_create(child, inode);
 			d_add(child, inode);
 		}
 	}
@@ -679,6 +717,9 @@ static int scan(struct ctl_table_header *head, struct ctl_table *table,
 	if ((*pos)++ < ctx->pos)
 		return true;
 
+	if (!gr_acl_handle_hidden_file(file->f_path.dentry, file->f_path.mnt))
+		return 0;
+
 	if (unlikely(S_ISLNK(table->mode)))
 		res = proc_sys_link_fill_cache(file, ctx, head, table);
 	else
@@ -772,6 +813,9 @@ static int proc_sys_getattr(struct vfsmount *mnt, struct dentry *dentry, struct
 	if (IS_ERR(head))
 		return PTR_ERR(head);
 
+	if (table && !gr_acl_handle_hidden_file(dentry, mnt))
+		return -ENOENT;
+
 	generic_fillattr(inode, stat);
 	if (table)
 		stat->mode = (stat->mode & S_IFMT) | table->mode;
@@ -794,13 +838,13 @@ static const struct file_operations proc_sys_dir_file_operations = {
 	.llseek		= generic_file_llseek,
 };
 
-static const struct inode_operations proc_sys_inode_operations = {
+const struct inode_operations proc_sys_inode_operations = {
 	.permission	= proc_sys_permission,
 	.setattr	= proc_sys_setattr,
 	.getattr	= proc_sys_getattr,
 };
 
-static const struct inode_operations proc_sys_dir_operations = {
+const struct inode_operations proc_sys_dir_operations = {
 	.lookup		= proc_sys_lookup,
 	.permission	= proc_sys_permission,
 	.setattr	= proc_sys_setattr,
@@ -877,7 +921,7 @@ static struct ctl_dir *find_subdir(struct ctl_dir *dir,
 static struct ctl_dir *new_dir(struct ctl_table_set *set,
 			       const char *name, int namelen)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 	struct ctl_dir *new;
 	struct ctl_node *node;
 	char *new_name;
@@ -889,7 +933,7 @@ static struct ctl_dir *new_dir(struct ctl_table_set *set,
 		return NULL;
 
 	node = (struct ctl_node *)(new + 1);
-	table = (struct ctl_table *)(node + 1);
+	table = (ctl_table_no_const *)(node + 1);
 	new_name = (char *)(table + 2);
 	memcpy(new_name, name, namelen);
 	new_name[namelen] = '\0';
@@ -1058,7 +1102,8 @@ static int sysctl_check_table(const char *path, struct ctl_table *table)
 static struct ctl_table_header *new_links(struct ctl_dir *dir, struct ctl_table *table,
 	struct ctl_table_root *link_root)
 {
-	struct ctl_table *link_table, *entry, *link;
+	ctl_table_no_const *link_table, *link;
+	struct ctl_table *entry;
 	struct ctl_table_header *links;
 	struct ctl_node *node;
 	char *link_name;
@@ -1081,7 +1126,7 @@ static struct ctl_table_header *new_links(struct ctl_dir *dir, struct ctl_table
 		return NULL;
 
 	node = (struct ctl_node *)(links + 1);
-	link_table = (struct ctl_table *)(node + nr_entries);
+	link_table = (ctl_table_no_const *)(node + nr_entries);
 	link_name = (char *)&link_table[nr_entries + 1];
 
 	for (link = link_table, entry = table; entry->procname; link++, entry++) {
@@ -1329,8 +1374,8 @@ static int register_leaf_sysctl_tables(const char *path, char *pos,
 	struct ctl_table_header ***subheader, struct ctl_table_set *set,
 	struct ctl_table *table)
 {
-	struct ctl_table *ctl_table_arg = NULL;
-	struct ctl_table *entry, *files;
+	ctl_table_no_const *ctl_table_arg = NULL, *files = NULL;
+	struct ctl_table *entry;
 	int nr_files = 0;
 	int nr_dirs = 0;
 	int err = -ENOMEM;
@@ -1342,10 +1387,9 @@ static int register_leaf_sysctl_tables(const char *path, char *pos,
 			nr_files++;
 	}
 
-	files = table;
 	/* If there are mixed files and directories we need a new table */
 	if (nr_dirs && nr_files) {
-		struct ctl_table *new;
+		ctl_table_no_const *new;
 		files = kzalloc(sizeof(struct ctl_table) * (nr_files + 1),
 				GFP_KERNEL);
 		if (!files)
@@ -1363,7 +1407,7 @@ static int register_leaf_sysctl_tables(const char *path, char *pos,
 	/* Register everything except a directory full of subdirectories */
 	if (nr_files || !nr_dirs) {
 		struct ctl_table_header *header;
-		header = __register_sysctl_table(set, path, files);
+		header = __register_sysctl_table(set, path, files ? files : table);
 		if (!header) {
 			kfree(ctl_table_arg);
 			goto out;
diff --git a/fs/proc/root.c b/fs/proc/root.c
index 8d3e48405..5fc5ce269 100644
--- a/fs/proc/root.c
+++ b/fs/proc/root.c
@@ -143,7 +143,15 @@ void __init proc_root_init(void)
 	proc_create_mount_point("openprom");
 #endif
 	proc_tty_init();
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	proc_mkdir_mode("bus", S_IRUSR | S_IXUSR, NULL);
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	proc_mkdir_mode("bus", S_IRUSR | S_IXUSR | S_IRGRP | S_IXGRP, NULL);
+#endif
+#else
 	proc_mkdir("bus", NULL);
+#endif
 	proc_sys_init();
 }
 
diff --git a/fs/proc/stat.c b/fs/proc/stat.c
index 7907e456a..027fceb5e 100644
--- a/fs/proc/stat.c
+++ b/fs/proc/stat.c
@@ -11,6 +11,7 @@
 #include <linux/irqnr.h>
 #include <linux/cputime.h>
 #include <linux/tick.h>
+#include <linux/grsecurity.h>
 
 #ifndef arch_irq_stat_cpu
 #define arch_irq_stat_cpu(cpu) 0
@@ -86,6 +87,18 @@ static int show_stat(struct seq_file *p, void *v)
 	u64 sum_softirq = 0;
 	unsigned int per_softirq_sums[NR_SOFTIRQS] = {0};
 	struct timespec64 boottime;
+	int unrestricted = 1;
+
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	if (!uid_eq(current_uid(), GLOBAL_ROOT_UID)
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+		&& !in_group_p(grsec_proc_gid)
+#endif
+	)
+		unrestricted = 0;
+#endif
+#endif
 
 	user = nice = system = idle = iowait =
 		irq = softirq = steal = 0;
@@ -97,23 +110,25 @@ static int show_stat(struct seq_file *p, void *v)
 		nice += kcpustat_cpu(i).cpustat[CPUTIME_NICE];
 		system += kcpustat_cpu(i).cpustat[CPUTIME_SYSTEM];
 		idle += get_idle_time(i);
-		iowait += get_iowait_time(i);
-		irq += kcpustat_cpu(i).cpustat[CPUTIME_IRQ];
-		softirq += kcpustat_cpu(i).cpustat[CPUTIME_SOFTIRQ];
-		steal += kcpustat_cpu(i).cpustat[CPUTIME_STEAL];
-		guest += kcpustat_cpu(i).cpustat[CPUTIME_GUEST];
-		guest_nice += kcpustat_cpu(i).cpustat[CPUTIME_GUEST_NICE];
-		sum += kstat_cpu_irqs_sum(i);
-		sum += arch_irq_stat_cpu(i);
-
-		for (j = 0; j < NR_SOFTIRQS; j++) {
-			unsigned int softirq_stat = kstat_softirqs_cpu(j, i);
-
-			per_softirq_sums[j] += softirq_stat;
-			sum_softirq += softirq_stat;
+		if (unrestricted) {
+			iowait += get_iowait_time(i);
+			irq += kcpustat_cpu(i).cpustat[CPUTIME_IRQ];
+			softirq += kcpustat_cpu(i).cpustat[CPUTIME_SOFTIRQ];
+			steal += kcpustat_cpu(i).cpustat[CPUTIME_STEAL];
+			guest += kcpustat_cpu(i).cpustat[CPUTIME_GUEST];
+			guest_nice += kcpustat_cpu(i).cpustat[CPUTIME_GUEST_NICE];
+			sum += kstat_cpu_irqs_sum(i);
+			sum += arch_irq_stat_cpu(i);
+			for (j = 0; j < NR_SOFTIRQS; j++) {
+				unsigned int softirq_stat = kstat_softirqs_cpu(j, i);
+
+				per_softirq_sums[j] += softirq_stat;
+				sum_softirq += softirq_stat;
+			}
 		}
 	}
-	sum += arch_irq_stat();
+	if (unrestricted)
+		sum += arch_irq_stat();
 
 	seq_puts(p, "cpu ");
 	seq_put_decimal_ull(p, ' ', cputime64_to_clock_t(user));
@@ -134,12 +149,14 @@ static int show_stat(struct seq_file *p, void *v)
 		nice = kcpustat_cpu(i).cpustat[CPUTIME_NICE];
 		system = kcpustat_cpu(i).cpustat[CPUTIME_SYSTEM];
 		idle = get_idle_time(i);
-		iowait = get_iowait_time(i);
-		irq = kcpustat_cpu(i).cpustat[CPUTIME_IRQ];
-		softirq = kcpustat_cpu(i).cpustat[CPUTIME_SOFTIRQ];
-		steal = kcpustat_cpu(i).cpustat[CPUTIME_STEAL];
-		guest = kcpustat_cpu(i).cpustat[CPUTIME_GUEST];
-		guest_nice = kcpustat_cpu(i).cpustat[CPUTIME_GUEST_NICE];
+		if (unrestricted) {
+			iowait = get_iowait_time(i);
+			irq = kcpustat_cpu(i).cpustat[CPUTIME_IRQ];
+			softirq = kcpustat_cpu(i).cpustat[CPUTIME_SOFTIRQ];
+			steal = kcpustat_cpu(i).cpustat[CPUTIME_STEAL];
+			guest = kcpustat_cpu(i).cpustat[CPUTIME_GUEST];
+			guest_nice = kcpustat_cpu(i).cpustat[CPUTIME_GUEST_NICE];
+		}
 		seq_printf(p, "cpu%d", i);
 		seq_put_decimal_ull(p, ' ', cputime64_to_clock_t(user));
 		seq_put_decimal_ull(p, ' ', cputime64_to_clock_t(nice));
@@ -157,7 +174,7 @@ static int show_stat(struct seq_file *p, void *v)
 
 	/* sum again ? it could be updated? */
 	for_each_irq_nr(j)
-		seq_put_decimal_ull(p, ' ', kstat_irqs_usr(j));
+		seq_put_decimal_ull(p, ' ', unrestricted ? kstat_irqs_usr(j) : 0ULL);
 
 	seq_printf(p,
 		"\nctxt %llu\n"
@@ -165,11 +182,11 @@ static int show_stat(struct seq_file *p, void *v)
 		"processes %lu\n"
 		"procs_running %lu\n"
 		"procs_blocked %lu\n",
-		nr_context_switches(),
+		unrestricted ? nr_context_switches() : 0ULL,
 		(unsigned long long)boottime.tv_sec,
-		total_forks,
-		nr_running(),
-		nr_iowait());
+		unrestricted ? total_forks : 0UL,
+		unrestricted ? nr_running() : 0UL,
+		unrestricted ? nr_iowait() : 0UL);
 
 	seq_printf(p, "softirq %llu", (unsigned long long)sum_softirq);
 
diff --git a/fs/proc/task_mmu.c b/fs/proc/task_mmu.c
index f6fa99eca..ea67f46eb 100644
--- a/fs/proc/task_mmu.c
+++ b/fs/proc/task_mmu.c
@@ -15,12 +15,19 @@
 #include <linux/mmu_notifier.h>
 #include <linux/page_idle.h>
 #include <linux/shmem_fs.h>
+#include <linux/grsecurity.h>
 
 #include <asm/elf.h>
 #include <asm/uaccess.h>
 #include <asm/tlbflush.h>
 #include "internal.h"
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+#define PAX_RAND_FLAGS(_mm) (_mm != NULL && _mm != current->mm && \
+			     (_mm->pax_flags & MF_PAX_RANDMMAP || \
+			      _mm->pax_flags & MF_PAX_SEGMEXEC))
+#endif
+
 void task_mem(struct seq_file *m, struct mm_struct *mm)
 {
 	unsigned long text, lib, swap, ptes, pmds, anon, file, shmem;
@@ -65,8 +72,13 @@ void task_mem(struct seq_file *m, struct mm_struct *mm)
 		"VmLib:\t%8lu kB\n"
 		"VmPTE:\t%8lu kB\n"
 		"VmPMD:\t%8lu kB\n"
-		"VmSwap:\t%8lu kB\n",
-		hiwater_vm << (PAGE_SHIFT-10),
+		"VmSwap:\t%8lu kB\n"
+
+#ifdef CONFIG_ARCH_TRACK_EXEC_LIMIT
+		"CsBase:\t%8lx\nCsLim:\t%8lx\n"
+#endif
+
+		,hiwater_vm << (PAGE_SHIFT-10),
 		total_vm << (PAGE_SHIFT-10),
 		mm->locked_vm << (PAGE_SHIFT-10),
 		mm->pinned_vm << (PAGE_SHIFT-10),
@@ -79,7 +91,19 @@ void task_mem(struct seq_file *m, struct mm_struct *mm)
 		mm->stack_vm << (PAGE_SHIFT-10), text, lib,
 		ptes >> 10,
 		pmds >> 10,
-		swap << (PAGE_SHIFT-10));
+		swap << (PAGE_SHIFT-10)
+
+#ifdef CONFIG_ARCH_TRACK_EXEC_LIMIT
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+		, PAX_RAND_FLAGS(mm) ? 0 : mm->context.user_cs_base
+		, PAX_RAND_FLAGS(mm) ? 0 : mm->context.user_cs_limit
+#else
+		, mm->context.user_cs_base
+		, mm->context.user_cs_limit
+#endif
+#endif
+
+	);
 	hugetlb_report_usage(m, mm);
 }
 
@@ -230,7 +254,11 @@ static int proc_maps_open(struct inode *inode, struct file *file,
 		return -ENOMEM;
 
 	priv->inode = inode;
-	priv->mm = proc_mem_open(inode, PTRACE_MODE_READ);
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	priv->mm = proc_mem_open(inode, PTRACE_MODE_READ, &priv->ptracer_exec_id);
+#else
+	priv->mm = proc_mem_open(inode, PTRACE_MODE_READ, NULL);
+#endif
 	if (IS_ERR(priv->mm)) {
 		int err = PTR_ERR(priv->mm);
 
@@ -285,7 +313,7 @@ static int is_stack(struct proc_maps_private *priv,
 }
 
 static void
-show_map_vma(struct seq_file *m, struct vm_area_struct *vma, int is_pid)
+show_map_vma(struct seq_file *m, struct vm_area_struct *vma, int is_pid, bool restrict)
 {
 	struct mm_struct *mm = vma->vm_mm;
 	struct file *file = vma->vm_file;
@@ -304,13 +332,8 @@ show_map_vma(struct seq_file *m, struct vm_area_struct *vma, int is_pid)
 		pgoff = ((loff_t)vma->vm_pgoff) << PAGE_SHIFT;
 	}
 
-	/* We don't show the stack guard page in /proc/maps */
-	start = vma->vm_start;
-	if (stack_guard_page_start(vma, start))
-		start += PAGE_SIZE;
-	end = vma->vm_end;
-	if (stack_guard_page_end(vma, end))
-		end -= PAGE_SIZE;
+	start = restrict ? 0UL : vma->vm_start;
+	end = restrict ? 0UL : vma->vm_end;
 
 	seq_setwidth(m, 25 + sizeof(void *) * 6 - 1);
 	seq_printf(m, "%08lx-%08lx %c%c%c%c %08llx %02x:%02x %lu ",
@@ -320,7 +343,7 @@ show_map_vma(struct seq_file *m, struct vm_area_struct *vma, int is_pid)
 			flags & VM_WRITE ? 'w' : '-',
 			flags & VM_EXEC ? 'x' : '-',
 			flags & VM_MAYSHARE ? 's' : 'p',
-			pgoff,
+			restrict ? 0UL : pgoff,
 			MAJOR(dev), MINOR(dev), ino);
 
 	/*
@@ -329,7 +352,7 @@ show_map_vma(struct seq_file *m, struct vm_area_struct *vma, int is_pid)
 	 */
 	if (file) {
 		seq_pad(m, ' ');
-		seq_file_path(m, file, "\n");
+		seq_file_path(m, file, "\n\\");
 		goto done;
 	}
 
@@ -366,7 +389,20 @@ done:
 
 static int show_map(struct seq_file *m, void *v, int is_pid)
 {
-	show_map_vma(m, v, is_pid);
+	bool restrict = false;
+
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	struct vm_area_struct *vma = (struct vm_area_struct *)v;
+	struct proc_maps_private *priv = m->private;
+	restrict = current->exec_id != priv->ptracer_exec_id;
+	if (current->exec_id != m->exec_id && restrict) {
+		gr_log_badprocpid("maps");
+		return 0;
+	}
+	if (restrict)
+		restrict = PAX_RAND_FLAGS(vma->vm_mm);
+#endif
+	show_map_vma(m, v, is_pid, restrict);
 	m_cache_vma(m, v);
 	return 0;
 }
@@ -654,6 +690,9 @@ static void show_smap_vma_flags(struct seq_file *m, struct vm_area_struct *vma)
 		[ilog2(VM_RAND_READ)]	= "rr",
 		[ilog2(VM_DONTCOPY)]	= "dc",
 		[ilog2(VM_DONTEXPAND)]	= "de",
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_X86_32)
+		[ilog2(VM_PAGEEXEC)]	= "px",
+#endif
 		[ilog2(VM_ACCOUNT)]	= "ac",
 		[ilog2(VM_NORESERVE)]	= "nr",
 		[ilog2(VM_HUGETLB)]	= "ht",
@@ -735,7 +774,14 @@ static int show_smap(struct seq_file *m, void *v, int is_pid)
 		.mm = vma->vm_mm,
 		.private = &mss,
 	};
+	bool restrict = false;
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (current->exec_id != m->exec_id) {
+		gr_log_badprocpid("smaps");
+		return 0;
+	}
+#endif
 	memset(&mss, 0, sizeof mss);
 
 #ifdef CONFIG_SHMEM
@@ -762,10 +808,15 @@ static int show_smap(struct seq_file *m, void *v, int is_pid)
 	}
 #endif
 
-	/* mmap_sem is held in m_start */
-	walk_page_vma(vma, &smaps_walk);
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (PAX_RAND_FLAGS(vma->vm_mm))
+		restrict = true;
+	else
+#endif
+		/* mmap_sem is held in m_start */
+		walk_page_vma(vma, &smaps_walk);
 
-	show_map_vma(m, vma, is_pid);
+	show_map_vma(m, vma, is_pid, restrict);
 
 	seq_printf(m,
 		   "Size:           %8lu kB\n"
@@ -786,7 +837,7 @@ static int show_smap(struct seq_file *m, void *v, int is_pid)
 		   "KernelPageSize: %8lu kB\n"
 		   "MMUPageSize:    %8lu kB\n"
 		   "Locked:         %8lu kB\n",
-		   (vma->vm_end - vma->vm_start) >> 10,
+		   restrict ? 0UL : (vma->vm_end - vma->vm_start) >> 10,
 		   mss.resident >> 10,
 		   (unsigned long)(mss.pss >> (10 + PSS_SHIFT)),
 		   mss.shared_clean  >> 10,
@@ -1443,7 +1494,7 @@ static int pagemap_open(struct inode *inode, struct file *file)
 {
 	struct mm_struct *mm;
 
-	mm = proc_mem_open(inode, PTRACE_MODE_READ);
+	mm = proc_mem_open(inode, PTRACE_MODE_READ, NULL);
 	if (IS_ERR(mm))
 		return PTR_ERR(mm);
 	file->private_data = mm;
@@ -1646,6 +1697,13 @@ static int show_numa_map(struct seq_file *m, void *v, int is_pid)
 	char buffer[64];
 	int nid;
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (current->exec_id != m->exec_id) {
+		gr_log_badprocpid("numa_maps");
+		return 0;
+	}
+#endif
+
 	if (!mm)
 		return 0;
 
@@ -1660,11 +1718,15 @@ static int show_numa_map(struct seq_file *m, void *v, int is_pid)
 		mpol_to_str(buffer, sizeof(buffer), proc_priv->task_mempolicy);
 	}
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	seq_printf(m, "%08lx %s", PAX_RAND_FLAGS(vma->vm_mm) ? 0UL : vma->vm_start, buffer);
+#else
 	seq_printf(m, "%08lx %s", vma->vm_start, buffer);
+#endif
 
 	if (file) {
 		seq_puts(m, " file=");
-		seq_file_path(m, file, "\n\t= ");
+		seq_file_path(m, file, "\n\t\\= ");
 	} else if (vma->vm_start <= mm->brk && vma->vm_end >= mm->start_brk) {
 		seq_puts(m, " heap");
 	} else if (is_stack(proc_priv, vma, is_pid)) {
diff --git a/fs/proc/task_nommu.c b/fs/proc/task_nommu.c
index faacb0c0d..b18557585 100644
--- a/fs/proc/task_nommu.c
+++ b/fs/proc/task_nommu.c
@@ -51,7 +51,7 @@ void task_mem(struct seq_file *m, struct mm_struct *mm)
 	else
 		bytes += kobjsize(mm);
 	
-	if (current->fs && current->fs->users > 1)
+	if (current->fs && atomic_read(&current->fs->users) > 1)
 		sbytes += kobjsize(current->fs);
 	else
 		bytes += kobjsize(current->fs);
@@ -142,7 +142,7 @@ static int is_stack(struct proc_maps_private *priv,
 			stack = vma_is_stack_for_task(vma, task);
 		rcu_read_unlock();
 	}
-	return stack;
+	return stack || (vma->vm_flags & (VM_GROWSDOWN | VM_GROWSUP));
 }
 
 /*
@@ -183,7 +183,7 @@ static int nommu_vma_show(struct seq_file *m, struct vm_area_struct *vma,
 
 	if (file) {
 		seq_pad(m, ' ');
-		seq_file_path(m, file, "");
+		seq_file_path(m, file, "\n\\");
 	} else if (mm && is_stack(priv, vma, is_pid)) {
 		seq_pad(m, ' ');
 		seq_printf(m, "[stack]");
@@ -287,7 +287,7 @@ static int maps_open(struct inode *inode, struct file *file,
 		return -ENOMEM;
 
 	priv->inode = inode;
-	priv->mm = proc_mem_open(inode, PTRACE_MODE_READ);
+	priv->mm = proc_mem_open(inode, PTRACE_MODE_READ, NULL);
 	if (IS_ERR(priv->mm)) {
 		int err = PTR_ERR(priv->mm);
 
diff --git a/fs/proc/vmcore.c b/fs/proc/vmcore.c
index 8ab782d8b..ef5bcbd94 100644
--- a/fs/proc/vmcore.c
+++ b/fs/proc/vmcore.c
@@ -105,9 +105,13 @@ static ssize_t read_from_oldmem(char *buf, size_t count,
 			nr_bytes = count;
 
 		/* If pfn is not ram, return zeros for sparse dump files */
-		if (pfn_is_ram(pfn) == 0)
-			memset(buf, 0, nr_bytes);
-		else {
+		if (pfn_is_ram(pfn) == 0) {
+			if (userbuf) {
+				if (clear_user((char __force_user *)buf, nr_bytes))
+					return -EFAULT;
+			} else
+				memset(buf, 0, nr_bytes);
+		} else {
 			tmp = copy_oldmem_page(pfn, buf, nr_bytes,
 						offset, userbuf);
 			if (tmp < 0)
@@ -170,7 +174,7 @@ int __weak remap_oldmem_pfn_range(struct vm_area_struct *vma,
 static int copy_to(void *target, void *src, size_t size, int userbuf)
 {
 	if (userbuf) {
-		if (copy_to_user((char __user *) target, src, size))
+		if (copy_to_user((char __force_user *) target, src, size))
 			return -EFAULT;
 	} else {
 		memcpy(target, src, size);
@@ -235,7 +239,7 @@ static ssize_t __read_vmcore(char *buffer, size_t buflen, loff_t *fpos,
 					    m->offset + m->size - *fpos,
 					    buflen);
 			start = m->paddr + *fpos - m->offset;
-			tmp = read_from_oldmem(buffer, tsz, &start, userbuf);
+			tmp = read_from_oldmem((char __force_kernel *)buffer, tsz, &start, userbuf);
 			if (tmp < 0)
 				return tmp;
 			buflen -= tsz;
@@ -255,7 +259,7 @@ static ssize_t __read_vmcore(char *buffer, size_t buflen, loff_t *fpos,
 static ssize_t read_vmcore(struct file *file, char __user *buffer,
 			   size_t buflen, loff_t *fpos)
 {
-	return __read_vmcore((__force char *) buffer, buflen, fpos, 1);
+	return __read_vmcore((__force_kernel char *) buffer, buflen, fpos, 1);
 }
 
 /*
diff --git a/fs/pstore/ftrace.c b/fs/pstore/ftrace.c
index d4887705b..10f088f22 100644
--- a/fs/pstore/ftrace.c
+++ b/fs/pstore/ftrace.c
@@ -13,6 +13,7 @@
 
 #include <linux/kernel.h>
 #include <linux/compiler.h>
+#include <linux/bug.h>
 #include <linux/irqflags.h>
 #include <linux/percpu.h>
 #include <linux/smp.h>
diff --git a/fs/qnx6/qnx6.h b/fs/qnx6/qnx6.h
index f23b5c4a6..da5d2f37d 100644
--- a/fs/qnx6/qnx6.h
+++ b/fs/qnx6/qnx6.h
@@ -74,7 +74,7 @@ enum {
 	BYTESEX_BE,
 };
 
-static inline __u64 fs64_to_cpu(struct qnx6_sb_info *sbi, __fs64 n)
+static inline __u64 __intentional_overflow(-1) fs64_to_cpu(struct qnx6_sb_info *sbi, __fs64 n)
 {
 	if (sbi->s_bytesex == BYTESEX_LE)
 		return le64_to_cpu((__force __le64)n);
@@ -90,7 +90,7 @@ static inline __fs64 cpu_to_fs64(struct qnx6_sb_info *sbi, __u64 n)
 		return (__force __fs64)cpu_to_be64(n);
 }
 
-static inline __u32 fs32_to_cpu(struct qnx6_sb_info *sbi, __fs32 n)
+static inline __u32 __intentional_overflow(-1) fs32_to_cpu(struct qnx6_sb_info *sbi, __fs32 n)
 {
 	if (sbi->s_bytesex == BYTESEX_LE)
 		return le32_to_cpu((__force __le32)n);
diff --git a/fs/quota/netlink.c b/fs/quota/netlink.c
index 8b252673d..0706a9330 100644
--- a/fs/quota/netlink.c
+++ b/fs/quota/netlink.c
@@ -42,7 +42,7 @@ static struct genl_family quota_genl_family = {
 void quota_send_warning(struct kqid qid, dev_t dev,
 			const char warntype)
 {
-	static atomic_t seq;
+	static atomic_unchecked_t seq;
 	struct sk_buff *skb;
 	void *msg_head;
 	int ret;
@@ -58,7 +58,7 @@ void quota_send_warning(struct kqid qid, dev_t dev,
 		  "VFS: Not enough memory to send quota warning.\n");
 		return;
 	}
-	msg_head = genlmsg_put(skb, 0, atomic_add_return(1, &seq),
+	msg_head = genlmsg_put(skb, 0, atomic_add_return_unchecked(1, &seq),
 			&quota_genl_family, 0, QUOTA_NL_C_WARNING);
 	if (!msg_head) {
 		printk(KERN_ERR
diff --git a/fs/read_write.c b/fs/read_write.c
index 66215a7b1..7d66f6210 100644
--- a/fs/read_write.c
+++ b/fs/read_write.c
@@ -23,7 +23,8 @@
 #include <asm/uaccess.h>
 #include <asm/unistd.h>
 
-typedef ssize_t (*io_fn_t)(struct file *, char __user *, size_t, loff_t *);
+typedef ssize_t (*io_fnr_t)(struct file *, char __user *, size_t, loff_t *);
+typedef ssize_t (*io_fnw_t)(struct file *, const char __user *, size_t, loff_t *);
 typedef ssize_t (*iter_fn_t)(struct kiocb *, struct iov_iter *);
 
 const struct file_operations generic_ro_fops = {
@@ -526,7 +527,7 @@ ssize_t __kernel_write(struct file *file, const char *buf, size_t count, loff_t
 
 	old_fs = get_fs();
 	set_fs(get_ds());
-	p = (__force const char __user *)buf;
+	p = (const char __force_user *)buf;
 	if (count > MAX_RW_COUNT)
 		count =  MAX_RW_COUNT;
 	ret = __vfs_write(file, p, count, pos);
@@ -700,7 +701,7 @@ static ssize_t do_iter_readv_writev(struct file *filp, struct iov_iter *iter,
 
 /* Do it by hand, with file-ops */
 static ssize_t do_loop_readv_writev(struct file *filp, struct iov_iter *iter,
-		loff_t *ppos, io_fn_t fn, int flags)
+		loff_t *ppos, io_fnr_t fnr, io_fnw_t fnw, int flags)
 {
 	ssize_t ret = 0;
 
@@ -711,7 +712,10 @@ static ssize_t do_loop_readv_writev(struct file *filp, struct iov_iter *iter,
 		struct iovec iovec = iov_iter_iovec(iter);
 		ssize_t nr;
 
-		nr = fn(filp, iovec.iov_base, iovec.iov_len, ppos);
+		if (fnr)
+			nr = fnr(filp, iovec.iov_base, iovec.iov_len, ppos);
+		else
+			nr = fnw(filp, iovec.iov_base, iovec.iov_len, ppos);
 
 		if (nr < 0) {
 			if (!ret)
@@ -815,7 +819,8 @@ static ssize_t do_readv_writev(int type, struct file *file,
 	struct iovec *iov = iovstack;
 	struct iov_iter iter;
 	ssize_t ret;
-	io_fn_t fn;
+	io_fnr_t fnr;
+	io_fnw_t fnw;
 	iter_fn_t iter_fn;
 
 	ret = import_iovec(type, uvector, nr_segs,
@@ -831,10 +836,12 @@ static ssize_t do_readv_writev(int type, struct file *file,
 		goto out;
 
 	if (type == READ) {
-		fn = file->f_op->read;
+		fnr = file->f_op->read;
+		fnw = NULL;
 		iter_fn = file->f_op->read_iter;
 	} else {
-		fn = (io_fn_t)file->f_op->write;
+		fnr = NULL;
+		fnw = file->f_op->write;
 		iter_fn = file->f_op->write_iter;
 		file_start_write(file);
 	}
@@ -842,7 +849,7 @@ static ssize_t do_readv_writev(int type, struct file *file,
 	if (iter_fn)
 		ret = do_iter_readv_writev(file, &iter, pos, iter_fn, flags);
 	else
-		ret = do_loop_readv_writev(file, &iter, pos, fn, flags);
+		ret = do_loop_readv_writev(file, &iter, pos, fnr, fnw, flags);
 
 	if (type != READ)
 		file_end_write(file);
@@ -1040,7 +1047,8 @@ static ssize_t compat_do_readv_writev(int type, struct file *file,
 	struct iovec *iov = iovstack;
 	struct iov_iter iter;
 	ssize_t ret;
-	io_fn_t fn;
+	io_fnr_t fnr;
+	io_fnw_t fnw;
 	iter_fn_t iter_fn;
 
 	ret = compat_import_iovec(type, uvector, nr_segs,
@@ -1056,10 +1064,12 @@ static ssize_t compat_do_readv_writev(int type, struct file *file,
 		goto out;
 
 	if (type == READ) {
-		fn = file->f_op->read;
+		fnr = file->f_op->read;
+		fnw = NULL;
 		iter_fn = file->f_op->read_iter;
 	} else {
-		fn = (io_fn_t)file->f_op->write;
+		fnr = NULL;
+		fnw = file->f_op->write;
 		iter_fn = file->f_op->write_iter;
 		file_start_write(file);
 	}
@@ -1067,7 +1077,7 @@ static ssize_t compat_do_readv_writev(int type, struct file *file,
 	if (iter_fn)
 		ret = do_iter_readv_writev(file, &iter, pos, iter_fn, flags);
 	else
-		ret = do_loop_readv_writev(file, &iter, pos, fn, flags);
+		ret = do_loop_readv_writev(file, &iter, pos, fnr, fnw, flags);
 
 	if (type != READ)
 		file_end_write(file);
diff --git a/fs/readdir.c b/fs/readdir.c
index 9d0212c37..da1afd12c 100644
--- a/fs/readdir.c
+++ b/fs/readdir.c
@@ -18,6 +18,7 @@
 #include <linux/security.h>
 #include <linux/syscalls.h>
 #include <linux/unistd.h>
+#include <linux/namei.h>
 
 #include <asm/uaccess.h>
 
@@ -84,6 +85,7 @@ struct old_linux_dirent {
 struct readdir_callback {
 	struct dir_context ctx;
 	struct old_linux_dirent __user * dirent;
+	struct file * file;
 	int result;
 };
 
@@ -102,6 +104,10 @@ static int fillonedir(struct dir_context *ctx, const char *name, int namlen,
 		buf->result = -EOVERFLOW;
 		return -EOVERFLOW;
 	}
+
+	if (!gr_acl_handle_filldir(buf->file, name, namlen, ino))
+		return 0;
+
 	buf->result++;
 	dirent = buf->dirent;
 	if (!access_ok(VERIFY_WRITE, dirent,
@@ -133,6 +139,7 @@ SYSCALL_DEFINE3(old_readdir, unsigned int, fd,
 	if (!f.file)
 		return -EBADF;
 
+	buf.file = f.file;
 	error = iterate_dir(f.file, &buf.ctx);
 	if (buf.result)
 		error = buf.result;
@@ -158,6 +165,7 @@ struct getdents_callback {
 	struct dir_context ctx;
 	struct linux_dirent __user * current_dir;
 	struct linux_dirent __user * previous;
+	struct file * file;
 	int count;
 	int error;
 };
@@ -180,6 +188,10 @@ static int filldir(struct dir_context *ctx, const char *name, int namlen,
 		buf->error = -EOVERFLOW;
 		return -EOVERFLOW;
 	}
+
+	if (!gr_acl_handle_filldir(buf->file, name, namlen, ino))
+		return 0;
+
 	dirent = buf->previous;
 	if (dirent) {
 		if (signal_pending(current))
@@ -227,6 +239,7 @@ SYSCALL_DEFINE3(getdents, unsigned int, fd,
 	if (!f.file)
 		return -EBADF;
 
+	buf.file = f.file;
 	error = iterate_dir(f.file, &buf.ctx);
 	if (error >= 0)
 		error = buf.error;
@@ -245,6 +258,7 @@ struct getdents_callback64 {
 	struct dir_context ctx;
 	struct linux_dirent64 __user * current_dir;
 	struct linux_dirent64 __user * previous;
+	struct file *file;
 	int count;
 	int error;
 };
@@ -261,6 +275,10 @@ static int filldir64(struct dir_context *ctx, const char *name, int namlen,
 	buf->error = -EINVAL;	/* only used if we fail.. */
 	if (reclen > buf->count)
 		return -EINVAL;
+
+	if (!gr_acl_handle_filldir(buf->file, name, namlen, ino))
+		return 0;
+
 	dirent = buf->previous;
 	if (dirent) {
 		if (signal_pending(current))
@@ -310,13 +328,13 @@ SYSCALL_DEFINE3(getdents64, unsigned int, fd,
 	if (!f.file)
 		return -EBADF;
 
+	buf.file = f.file;
 	error = iterate_dir(f.file, &buf.ctx);
 	if (error >= 0)
 		error = buf.error;
 	lastdirent = buf.previous;
 	if (lastdirent) {
-		typeof(lastdirent->d_off) d_off = buf.ctx.pos;
-		if (__put_user(d_off, &lastdirent->d_off))
+		if (__put_user(buf.ctx.pos, &lastdirent->d_off))
 			error = -EFAULT;
 		else
 			error = count - buf.count;
diff --git a/fs/reiserfs/do_balan.c b/fs/reiserfs/do_balan.c
index 9c02d96d3..6562c1082 100644
--- a/fs/reiserfs/do_balan.c
+++ b/fs/reiserfs/do_balan.c
@@ -1887,7 +1887,7 @@ void do_balance(struct tree_balance *tb, struct item_head *ih,
 		return;
 	}
 
-	atomic_inc(&fs_generation(tb->tb_sb));
+	atomic_inc_unchecked(&fs_generation(tb->tb_sb));
 	do_balance_starts(tb);
 
 	/*
diff --git a/fs/reiserfs/item_ops.c b/fs/reiserfs/item_ops.c
index aca73dd73..e3c558d1b 100644
--- a/fs/reiserfs/item_ops.c
+++ b/fs/reiserfs/item_ops.c
@@ -724,18 +724,18 @@ static void errcatch_print_vi(struct virtual_item *vi)
 }
 
 static struct item_operations errcatch_ops = {
-	errcatch_bytes_number,
-	errcatch_decrement_key,
-	errcatch_is_left_mergeable,
-	errcatch_print_item,
-	errcatch_check_item,
-
-	errcatch_create_vi,
-	errcatch_check_left,
-	errcatch_check_right,
-	errcatch_part_size,
-	errcatch_unit_num,
-	errcatch_print_vi
+	.bytes_number = errcatch_bytes_number,
+	.decrement_key = errcatch_decrement_key,
+	.is_left_mergeable = errcatch_is_left_mergeable,
+	.print_item = errcatch_print_item,
+	.check_item = errcatch_check_item,
+
+	.create_vi = errcatch_create_vi,
+	.check_left = errcatch_check_left,
+	.check_right = errcatch_check_right,
+	.part_size = errcatch_part_size,
+	.unit_num = errcatch_unit_num,
+	.print_vi = errcatch_print_vi
 };
 
 #if ! (TYPE_STAT_DATA == 0 && TYPE_INDIRECT == 1 && TYPE_DIRECT == 2 && TYPE_DIRENTRY == 3)
diff --git a/fs/reiserfs/procfs.c b/fs/reiserfs/procfs.c
index fe999157d..24fd9bd39 100644
--- a/fs/reiserfs/procfs.c
+++ b/fs/reiserfs/procfs.c
@@ -114,7 +114,7 @@ static int show_super(struct seq_file *m, void *unused)
 		   "SMALL_TAILS " : "NO_TAILS ",
 		   replay_only(sb) ? "REPLAY_ONLY " : "",
 		   convert_reiserfs(sb) ? "CONV " : "",
-		   atomic_read(&r->s_generation_counter),
+		   atomic_read_unchecked(&r->s_generation_counter),
 		   SF(s_disk_reads), SF(s_disk_writes), SF(s_fix_nodes),
 		   SF(s_do_balance), SF(s_unneeded_left_neighbor),
 		   SF(s_good_search_by_key_reada), SF(s_bmaps),
diff --git a/fs/reiserfs/reiserfs.h b/fs/reiserfs/reiserfs.h
index 2adcde137..7d27bc8e3 100644
--- a/fs/reiserfs/reiserfs.h
+++ b/fs/reiserfs/reiserfs.h
@@ -580,7 +580,7 @@ struct reiserfs_sb_info {
 	/* Comment? -Hans */
 	wait_queue_head_t s_wait;
 	/* increased by one every time the  tree gets re-balanced */
-	atomic_t s_generation_counter;
+	atomic_unchecked_t s_generation_counter;
 
 	/* File system properties. Currently holds on-disk FS format */
 	unsigned long s_properties;
@@ -2300,7 +2300,7 @@ static inline loff_t max_reiserfs_offset(struct inode *inode)
 #define REISERFS_USER_MEM		1	/* user memory mode */
 
 #define fs_generation(s) (REISERFS_SB(s)->s_generation_counter)
-#define get_generation(s) atomic_read (&fs_generation(s))
+#define get_generation(s) atomic_read_unchecked (&fs_generation(s))
 #define FILESYSTEM_CHANGED_TB(tb)  (get_generation((tb)->tb_sb) != (tb)->fs_gen)
 #define __fs_changed(gen,s) (gen != get_generation (s))
 #define fs_changed(gen,s)		\
diff --git a/fs/reiserfs/super.c b/fs/reiserfs/super.c
index 74d5ddd26..0ce3ad941 100644
--- a/fs/reiserfs/super.c
+++ b/fs/reiserfs/super.c
@@ -1887,6 +1887,10 @@ static int reiserfs_fill_super(struct super_block *s, void *data, int silent)
 	sbi->s_mount_opt |= (1 << REISERFS_SMALLTAIL);
 	sbi->s_mount_opt |= (1 << REISERFS_ERROR_RO);
 	sbi->s_mount_opt |= (1 << REISERFS_BARRIER_FLUSH);
+#ifdef CONFIG_REISERFS_FS_XATTR
+	/* turn on user xattrs by default */
+	sbi->s_mount_opt |= (1 << REISERFS_XATTRS_USER);
+#endif
 	/* no preallocation minimum, be smart in reiserfs_file_write instead */
 	sbi->s_alloc_options.preallocmin = 0;
 	/* Preallocate by 16 blocks (17-1) at once */
diff --git a/fs/select.c b/fs/select.c
index 8ed9da508..4ee3bb4fc 100644
--- a/fs/select.c
+++ b/fs/select.c
@@ -20,6 +20,7 @@
 #include <linux/export.h>
 #include <linux/slab.h>
 #include <linux/poll.h>
+#include <linux/security.h>
 #include <linux/personality.h> /* for STICKY_TIMEOUTS */
 #include <linux/file.h>
 #include <linux/fdtable.h>
@@ -723,7 +724,7 @@ SYSCALL_DEFINE6(pselect6, int, n, fd_set __user *, inp, fd_set __user *, outp,
 
 #ifdef __ARCH_WANT_SYS_OLD_SELECT
 struct sel_arg_struct {
-	unsigned long n;
+	long n;
 	fd_set __user *inp, *outp, *exp;
 	struct timeval __user *tvp;
 };
@@ -886,6 +887,7 @@ int do_sys_poll(struct pollfd __user *ufds, unsigned int nfds,
  	struct poll_list *walk = head;
  	unsigned long todo = nfds;
 
+	gr_learn_resource(current, RLIMIT_NOFILE, nfds, 1);
 	if (nfds > rlimit(RLIMIT_NOFILE))
 		return -EINVAL;
 
diff --git a/fs/seq_file.c b/fs/seq_file.c
index 6dc4296ee..cfdaf8eca 100644
--- a/fs/seq_file.c
+++ b/fs/seq_file.c
@@ -14,6 +14,8 @@
 #include <linux/mm.h>
 #include <linux/printk.h>
 #include <linux/string_helpers.h>
+#include <linux/sched.h>
+#include <linux/grsecurity.h>
 
 #include <asm/uaccess.h>
 #include <asm/page.h>
@@ -26,7 +28,7 @@ static void seq_set_overflow(struct seq_file *m)
 static void *seq_buf_alloc(unsigned long size)
 {
 	void *buf;
-	gfp_t gfp = GFP_KERNEL;
+	gfp_t gfp = GFP_KERNEL | GFP_USERCOPY;
 
 	/*
 	 * For high order allocations, use __GFP_NORETRY to avoid oom-killing -
@@ -38,7 +40,7 @@ static void *seq_buf_alloc(unsigned long size)
 		gfp |= __GFP_NORETRY | __GFP_NOWARN;
 	buf = kmalloc(size, gfp);
 	if (!buf && size > PAGE_SIZE)
-		buf = vmalloc(size);
+		buf = vmalloc_usercopy(size);
 	return buf;
 }
 
@@ -77,6 +79,10 @@ int seq_open(struct file *file, const struct seq_operations *op)
 	// to the lifetime of the file.
 	p->file = file;
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	p->exec_id = current->exec_id;
+#endif
+
 	/*
 	 * Wrappers around seq_open(e.g. swaps_open) need to be
 	 * aware of this. If they set f_version themselves, they
@@ -98,6 +104,16 @@ int seq_open(struct file *file, const struct seq_operations *op)
 }
 EXPORT_SYMBOL(seq_open);
 
+
+int seq_open_restrict(struct file *file, const struct seq_operations *op)
+{
+	if (gr_proc_is_restricted())
+		return -EACCES;
+
+	return seq_open(file, op);
+}
+EXPORT_SYMBOL(seq_open_restrict);
+
 static int traverse(struct seq_file *m, loff_t offset)
 {
 	loff_t pos = 0, index;
@@ -169,7 +185,7 @@ Eoverflow:
 ssize_t seq_read(struct file *file, char __user *buf, size_t size, loff_t *ppos)
 {
 	struct seq_file *m = file->private_data;
-	size_t copied = 0;
+	ssize_t copied = 0;
 	loff_t pos;
 	size_t n;
 	void *p;
@@ -566,7 +582,7 @@ static void single_stop(struct seq_file *p, void *v)
 int single_open(struct file *file, int (*show)(struct seq_file *, void *),
 		void *data)
 {
-	struct seq_operations *op = kmalloc(sizeof(*op), GFP_KERNEL);
+	seq_operations_no_const *op = kzalloc(sizeof(*op), GFP_KERNEL);
 	int res = -ENOMEM;
 
 	if (op) {
@@ -602,6 +618,17 @@ int single_open_size(struct file *file, int (*show)(struct seq_file *, void *),
 }
 EXPORT_SYMBOL(single_open_size);
 
+int single_open_restrict(struct file *file, int (*show)(struct seq_file *, void *),
+		void *data)
+{
+	if (gr_proc_is_restricted())
+		return -EACCES;
+
+	return single_open(file, show, data);
+}
+EXPORT_SYMBOL(single_open_restrict);
+
+
 int single_release(struct inode *inode, struct file *file)
 {
 	const struct seq_operations *op = ((struct seq_file *)file->private_data)->op;
diff --git a/fs/splice.c b/fs/splice.c
index dd9bf7e41..3d55c3e06 100644
--- a/fs/splice.c
+++ b/fs/splice.c
@@ -195,7 +195,7 @@ ssize_t splice_to_pipe(struct pipe_inode_info *pipe,
 	pipe_lock(pipe);
 
 	for (;;) {
-		if (!pipe->readers) {
+		if (!atomic_read(&pipe->readers)) {
 			send_sig(SIGPIPE, current, 0);
 			if (!ret)
 				ret = -EPIPE;
@@ -218,7 +218,7 @@ ssize_t splice_to_pipe(struct pipe_inode_info *pipe,
 			page_nr++;
 			ret += buf->len;
 
-			if (pipe->files)
+			if (atomic_read(&pipe->files))
 				do_wakeup = 1;
 
 			if (!--spd->nr_pages)
@@ -249,9 +249,9 @@ ssize_t splice_to_pipe(struct pipe_inode_info *pipe,
 			do_wakeup = 0;
 		}
 
-		pipe->waiting_writers++;
+		atomic_inc(&pipe->waiting_writers);
 		pipe_wait(pipe);
-		pipe->waiting_writers--;
+		atomic_dec(&pipe->waiting_writers);
 	}
 
 	pipe_unlock(pipe);
@@ -580,7 +580,7 @@ static ssize_t kernel_readv(struct file *file, const struct iovec *vec,
 	old_fs = get_fs();
 	set_fs(get_ds());
 	/* The cast to a user pointer is valid due to the set_fs() */
-	res = vfs_readv(file, (const struct iovec __user *)vec, vlen, &pos, 0);
+	res = vfs_readv(file, (const struct iovec __force_user *)vec, vlen, &pos, 0);
 	set_fs(old_fs);
 
 	return res;
@@ -595,7 +595,7 @@ ssize_t kernel_write(struct file *file, const char *buf, size_t count,
 	old_fs = get_fs();
 	set_fs(get_ds());
 	/* The cast to a user pointer is valid due to the set_fs() */
-	res = vfs_write(file, (__force const char __user *)buf, count, &pos);
+	res = vfs_write(file, (const char __force_user *)buf, count, &pos);
 	set_fs(old_fs);
 
 	return res;
@@ -648,7 +648,7 @@ ssize_t default_file_splice_read(struct file *in, loff_t *ppos,
 			goto err;
 
 		this_len = min_t(size_t, len, PAGE_SIZE - offset);
-		vec[i].iov_base = (void __user *) page_address(page);
+		vec[i].iov_base = (void __force_user *) page_address(page);
 		vec[i].iov_len = this_len;
 		spd.pages[i] = page;
 		spd.nr_pages++;
@@ -787,7 +787,7 @@ static int splice_from_pipe_feed(struct pipe_inode_info *pipe, struct splice_des
 			ops->release(pipe, buf);
 			pipe->curbuf = (pipe->curbuf + 1) & (pipe->buffers - 1);
 			pipe->nrbufs--;
-			if (pipe->files)
+			if (atomic_read(&pipe->files))
 				sd->need_wakeup = true;
 		}
 
@@ -818,10 +818,10 @@ static int splice_from_pipe_next(struct pipe_inode_info *pipe, struct splice_des
 		return -ERESTARTSYS;
 
 	while (!pipe->nrbufs) {
-		if (!pipe->writers)
+		if (!atomic_read(&pipe->writers))
 			return 0;
 
-		if (!pipe->waiting_writers && sd->num_spliced)
+		if (!atomic_read(&pipe->waiting_writers) && sd->num_spliced)
 			return 0;
 
 		if (sd->flags & SPLICE_F_NONBLOCK)
@@ -1037,7 +1037,7 @@ iter_file_splice_write(struct pipe_inode_info *pipe, struct file *out,
 				ops->release(pipe, buf);
 				pipe->curbuf = (pipe->curbuf + 1) & (pipe->buffers - 1);
 				pipe->nrbufs--;
-				if (pipe->files)
+				if (atomic_read(&pipe->files))
 					sd.need_wakeup = true;
 			} else {
 				buf->offset += ret;
@@ -1200,7 +1200,7 @@ ssize_t splice_direct_to_actor(struct file *in, struct splice_desc *sd,
 		 * out of the pipe right after the splice_to_pipe(). So set
 		 * PIPE_READERS appropriately.
 		 */
-		pipe->readers = 1;
+		atomic_set(&pipe->readers, 1);
 
 		current->splice_pipe = pipe;
 	}
@@ -1507,6 +1507,7 @@ static int get_iovec_page_array(const struct iovec __user *iov,
 
 			partial[buffers].offset = off;
 			partial[buffers].len = plen;
+			partial[buffers].private = 0;
 
 			off = 0;
 			len -= plen;
@@ -1738,9 +1739,9 @@ static int ipipe_prep(struct pipe_inode_info *pipe, unsigned int flags)
 			ret = -ERESTARTSYS;
 			break;
 		}
-		if (!pipe->writers)
+		if (!atomic_read(&pipe->writers))
 			break;
-		if (!pipe->waiting_writers) {
+		if (!atomic_read(&pipe->waiting_writers)) {
 			if (flags & SPLICE_F_NONBLOCK) {
 				ret = -EAGAIN;
 				break;
@@ -1772,7 +1773,7 @@ static int opipe_prep(struct pipe_inode_info *pipe, unsigned int flags)
 	pipe_lock(pipe);
 
 	while (pipe->nrbufs >= pipe->buffers) {
-		if (!pipe->readers) {
+		if (!atomic_read(&pipe->readers)) {
 			send_sig(SIGPIPE, current, 0);
 			ret = -EPIPE;
 			break;
@@ -1785,9 +1786,9 @@ static int opipe_prep(struct pipe_inode_info *pipe, unsigned int flags)
 			ret = -ERESTARTSYS;
 			break;
 		}
-		pipe->waiting_writers++;
+		atomic_inc(&pipe->waiting_writers);
 		pipe_wait(pipe);
-		pipe->waiting_writers--;
+		atomic_dec(&pipe->waiting_writers);
 	}
 
 	pipe_unlock(pipe);
@@ -1823,14 +1824,14 @@ retry:
 	pipe_double_lock(ipipe, opipe);
 
 	do {
-		if (!opipe->readers) {
+		if (!atomic_read(&opipe->readers)) {
 			send_sig(SIGPIPE, current, 0);
 			if (!ret)
 				ret = -EPIPE;
 			break;
 		}
 
-		if (!ipipe->nrbufs && !ipipe->writers)
+		if (!ipipe->nrbufs && !atomic_read(&ipipe->writers))
 			break;
 
 		/*
@@ -1927,7 +1928,7 @@ static int link_pipe(struct pipe_inode_info *ipipe,
 	pipe_double_lock(ipipe, opipe);
 
 	do {
-		if (!opipe->readers) {
+		if (!atomic_read(&opipe->readers)) {
 			send_sig(SIGPIPE, current, 0);
 			if (!ret)
 				ret = -EPIPE;
@@ -1972,7 +1973,7 @@ static int link_pipe(struct pipe_inode_info *ipipe,
 	 * return EAGAIN if we have the potential of some data in the
 	 * future, otherwise just return 0
 	 */
-	if (!ret && ipipe->waiting_writers && (flags & SPLICE_F_NONBLOCK))
+	if (!ret && atomic_read(&ipipe->waiting_writers) && (flags & SPLICE_F_NONBLOCK))
 		ret = -EAGAIN;
 
 	pipe_unlock(ipipe);
diff --git a/fs/squashfs/xattr.c b/fs/squashfs/xattr.c
index 1548b3784..062486967 100644
--- a/fs/squashfs/xattr.c
+++ b/fs/squashfs/xattr.c
@@ -46,8 +46,8 @@ ssize_t squashfs_listxattr(struct dentry *d, char *buffer,
 						 + msblk->xattr_table;
 	int offset = SQUASHFS_XATTR_OFFSET(squashfs_i(inode)->xattr);
 	int count = squashfs_i(inode)->xattr_count;
-	size_t rest = buffer_size;
-	int err;
+	size_t used = 0;
+	ssize_t err;
 
 	/* check that the file system has xattrs */
 	if (msblk->xattr_id_table == NULL)
@@ -72,7 +72,7 @@ ssize_t squashfs_listxattr(struct dentry *d, char *buffer,
 			size_t prefix_size = strlen(prefix);
 
 			if (buffer) {
-				if (prefix_size + name_size + 1 > rest) {
+				if (prefix_size + name_size + 1 > buffer_size - used) {
 					err = -ERANGE;
 					goto failed;
 				}
@@ -87,7 +87,7 @@ ssize_t squashfs_listxattr(struct dentry *d, char *buffer,
 				buffer[name_size] = '\0';
 				buffer += name_size + 1;
 			}
-			rest -= prefix_size + name_size + 1;
+			used += prefix_size + name_size + 1;
 		} else  {
 			/* no handler or insuffficient privileges, so skip */
 			err = squashfs_read_metadata(sb, NULL, &start,
@@ -108,7 +108,7 @@ ssize_t squashfs_listxattr(struct dentry *d, char *buffer,
 		if (err < 0)
 			goto failed;
 	}
-	err = buffer_size - rest;
+	err = used;
 
 failed:
 	return err;
diff --git a/fs/stat.c b/fs/stat.c
index bc045c799..68725c142 100644
--- a/fs/stat.c
+++ b/fs/stat.c
@@ -28,8 +28,13 @@ void generic_fillattr(struct inode *inode, struct kstat *stat)
 	stat->gid = inode->i_gid;
 	stat->rdev = inode->i_rdev;
 	stat->size = i_size_read(inode);
-	stat->atime = inode->i_atime;
-	stat->mtime = inode->i_mtime;
+	if (is_sidechannel_device(inode) && !capable_nolog(CAP_MKNOD)) {
+		stat->atime = inode->i_ctime;
+		stat->mtime = inode->i_ctime;
+	} else {
+		stat->atime = inode->i_atime;
+		stat->mtime = inode->i_mtime;
+	}
 	stat->ctime = inode->i_ctime;
 	stat->blksize = (1 << inode->i_blkbits);
 	stat->blocks = inode->i_blocks;
@@ -52,9 +57,16 @@ EXPORT_SYMBOL(generic_fillattr);
 int vfs_getattr_nosec(struct path *path, struct kstat *stat)
 {
 	struct inode *inode = d_backing_inode(path->dentry);
+	int retval;
 
-	if (inode->i_op->getattr)
-		return inode->i_op->getattr(path->mnt, path->dentry, stat);
+	if (inode->i_op->getattr) {
+		retval = inode->i_op->getattr(path->mnt, path->dentry, stat);
+		if (!retval && is_sidechannel_device(inode) && !capable_nolog(CAP_MKNOD)) {
+			stat->atime = stat->ctime;
+			stat->mtime = stat->ctime;
+		}
+		return retval;
+	}
 
 	generic_fillattr(inode, stat);
 	return 0;
diff --git a/fs/super.c b/fs/super.c
index 47d11e046..31ae978c0 100644
--- a/fs/super.c
+++ b/fs/super.c
@@ -357,7 +357,8 @@ EXPORT_SYMBOL(deactivate_super);
  *	called for superblocks not in rundown mode (== ones still on ->fs_supers
  *	of their type), so increment of ->s_count is OK here.
  */
-static int grab_super(struct super_block *s) __releases(sb_lock)
+static int grab_super(struct super_block *s) __releases(&sb_lock);
+static int grab_super(struct super_block *s)
 {
 	s->s_count++;
 	spin_unlock(&sb_lock);
diff --git a/fs/sysfs/dir.c b/fs/sysfs/dir.c
index 94374e435..b5da3a197 100644
--- a/fs/sysfs/dir.c
+++ b/fs/sysfs/dir.c
@@ -33,6 +33,10 @@ void sysfs_warn_dup(struct kernfs_node *parent, const char *name)
 	kfree(buf);
 }
 
+#ifdef CONFIG_GRKERNSEC_SYSFS_RESTRICT
+extern int grsec_enable_sysfs_restrict;
+#endif
+
 /**
  * sysfs_create_dir_ns - create a directory for an object with a namespace tag
  * @kobj: object we're creating directory for
@@ -41,9 +45,16 @@ void sysfs_warn_dup(struct kernfs_node *parent, const char *name)
 int sysfs_create_dir_ns(struct kobject *kobj, const void *ns)
 {
 	struct kernfs_node *parent, *kn;
+	const char *name;
+	umode_t mode = S_IRWXU | S_IRUGO | S_IXUGO;
+#ifdef CONFIG_GRKERNSEC_SYSFS_RESTRICT
+	const char *parent_name;
+#endif
 
 	BUG_ON(!kobj);
 
+	name = kobject_name(kobj);
+
 	if (kobj->parent)
 		parent = kobj->parent->sd;
 	else
@@ -52,11 +63,24 @@ int sysfs_create_dir_ns(struct kobject *kobj, const void *ns)
 	if (!parent)
 		return -ENOENT;
 
-	kn = kernfs_create_dir_ns(parent, kobject_name(kobj),
-				  S_IRWXU | S_IRUGO | S_IXUGO, kobj, ns);
+#ifdef CONFIG_GRKERNSEC_SYSFS_RESTRICT
+	parent_name = parent->name;
+	mode = S_IRWXU;
+
+	if ((!strcmp(parent_name, "") && (!strcmp(name, "devices") || !strcmp(name, "fs"))) ||
+	    (!strcmp(parent_name, "devices") && !strcmp(name, "system")) ||
+	    (!strcmp(parent_name, "fs") && (!strcmp(name, "selinux") || !strcmp(name, "fuse") || !strcmp(name, "ecryptfs"))) ||
+	    (!strcmp(parent_name, "system") && !strcmp(name, "cpu")))
+		mode = S_IRWXU | S_IRUGO | S_IXUGO;
+	if (!grsec_enable_sysfs_restrict)
+		mode = S_IRWXU | S_IRUGO | S_IXUGO;
+#endif
+
+	kn = kernfs_create_dir_ns(parent, name,
+				  mode, kobj, ns);
 	if (IS_ERR(kn)) {
 		if (PTR_ERR(kn) == -EEXIST)
-			sysfs_warn_dup(parent, kobject_name(kobj));
+			sysfs_warn_dup(parent, name);
 		return PTR_ERR(kn);
 	}
 
diff --git a/fs/sysv/sysv.h b/fs/sysv/sysv.h
index 6c212288a..9afd5fe05 100644
--- a/fs/sysv/sysv.h
+++ b/fs/sysv/sysv.h
@@ -187,7 +187,7 @@ static inline u32 PDP_swab(u32 x)
 #endif
 }
 
-static inline __u32 fs32_to_cpu(struct sysv_sb_info *sbi, __fs32 n)
+static inline __u32 __intentional_overflow(-1) fs32_to_cpu(struct sysv_sb_info *sbi, __fs32 n)
 {
 	if (sbi->s_bytesex == BYTESEX_PDP)
 		return PDP_swab((__force __u32)n);
diff --git a/fs/tracefs/inode.c b/fs/tracefs/inode.c
index ad40b64c5..9892e729a 100644
--- a/fs/tracefs/inode.c
+++ b/fs/tracefs/inode.c
@@ -53,7 +53,7 @@ static const struct file_operations tracefs_file_operations = {
 static struct tracefs_dir_ops {
 	int (*mkdir)(const char *name);
 	int (*rmdir)(const char *name);
-} tracefs_ops;
+} __no_const tracefs_ops __read_only;
 
 static char *get_dname(struct dentry *dentry)
 {
@@ -494,8 +494,10 @@ struct dentry *tracefs_create_instance_dir(const char *name, struct dentry *pare
 	if (!dentry)
 		return NULL;
 
-	tracefs_ops.mkdir = mkdir;
-	tracefs_ops.rmdir = rmdir;
+	pax_open_kernel();
+	const_cast(tracefs_ops.mkdir) = mkdir;
+	const_cast(tracefs_ops.rmdir) = rmdir;
+	pax_close_kernel();
 
 	return dentry;
 }
diff --git a/fs/ubifs/find.c b/fs/ubifs/find.c
index 2dcf3d473..fa1e496c6 100644
--- a/fs/ubifs/find.c
+++ b/fs/ubifs/find.c
@@ -94,8 +94,9 @@ static int valuable(struct ubifs_info *c, const struct ubifs_lprops *lprops)
  */
 static int scan_for_dirty_cb(struct ubifs_info *c,
 			     const struct ubifs_lprops *lprops, int in_tree,
-			     struct scan_data *data)
+			     void *_data)
 {
+	struct scan_data *data = _data;
 	int ret = LPT_SCAN_CONTINUE;
 
 	/* Exclude LEBs that are currently in use */
@@ -179,7 +180,7 @@ static const struct ubifs_lprops *scan_for_dirty(struct ubifs_info *c,
 	data.lnum = -1;
 	data.exclude_index = exclude_index;
 	err = ubifs_lpt_scan_nolock(c, -1, c->lscan_lnum,
-				    (ubifs_lpt_scan_callback)scan_for_dirty_cb,
+				    scan_for_dirty_cb,
 				    &data);
 	if (err)
 		return ERR_PTR(err);
@@ -361,8 +362,9 @@ out:
  */
 static int scan_for_free_cb(struct ubifs_info *c,
 			    const struct ubifs_lprops *lprops, int in_tree,
-			    struct scan_data *data)
+			    void *_data)
 {
+	struct scan_data *data = _data;
 	int ret = LPT_SCAN_CONTINUE;
 
 	/* Exclude LEBs that are currently in use */
@@ -458,7 +460,7 @@ const struct ubifs_lprops *do_find_free_space(struct ubifs_info *c,
 	data.pick_free = pick_free;
 	data.lnum = -1;
 	err = ubifs_lpt_scan_nolock(c, -1, c->lscan_lnum,
-				    (ubifs_lpt_scan_callback)scan_for_free_cb,
+				    scan_for_free_cb,
 				    &data);
 	if (err)
 		return ERR_PTR(err);
@@ -601,8 +603,9 @@ out:
  */
 static int scan_for_idx_cb(struct ubifs_info *c,
 			   const struct ubifs_lprops *lprops, int in_tree,
-			   struct scan_data *data)
+			   void *_data)
 {
+	struct scan_data *data = _data;
 	int ret = LPT_SCAN_CONTINUE;
 
 	/* Exclude LEBs that are currently in use */
@@ -638,7 +641,7 @@ static const struct ubifs_lprops *scan_for_leb_for_idx(struct ubifs_info *c)
 
 	data.lnum = -1;
 	err = ubifs_lpt_scan_nolock(c, -1, c->lscan_lnum,
-				    (ubifs_lpt_scan_callback)scan_for_idx_cb,
+				    scan_for_idx_cb,
 				    &data);
 	if (err)
 		return ERR_PTR(err);
@@ -738,18 +741,21 @@ out:
 	return err;
 }
 
-static int cmp_dirty_idx(const struct ubifs_lprops **a,
-			 const struct ubifs_lprops **b)
+static int cmp_dirty_idx(const void *_a,
+			 const void *_b)
 {
+	const struct ubifs_lprops **a = (const struct ubifs_lprops **)_a;
+	const struct ubifs_lprops **b = (const struct ubifs_lprops **)_b;
 	const struct ubifs_lprops *lpa = *a;
 	const struct ubifs_lprops *lpb = *b;
 
 	return lpa->dirty + lpa->free - lpb->dirty - lpb->free;
 }
 
-static void swap_dirty_idx(struct ubifs_lprops **a, struct ubifs_lprops **b,
-			   int size)
+static void swap_dirty_idx(void *_a, void *_b, int size)
 {
+	struct ubifs_lprops **a = (struct ubifs_lprops **)_a;
+	struct ubifs_lprops **b = (struct ubifs_lprops **)_b;
 	struct ubifs_lprops *t = *a;
 
 	*a = *b;
@@ -775,8 +781,7 @@ int ubifs_save_dirty_idx_lnums(struct ubifs_info *c)
 	       sizeof(void *) * c->dirty_idx.cnt);
 	/* Sort it so that the dirtiest is now at the end */
 	sort(c->dirty_idx.arr, c->dirty_idx.cnt, sizeof(void *),
-	     (int (*)(const void *, const void *))cmp_dirty_idx,
-	     (void (*)(void *, void *, int))swap_dirty_idx);
+	     cmp_dirty_idx, swap_dirty_idx);
 	dbg_find("found %d dirty index LEBs", c->dirty_idx.cnt);
 	if (c->dirty_idx.cnt)
 		dbg_find("dirtiest index LEB is %d with dirty %d and free %d",
@@ -804,8 +809,9 @@ int ubifs_save_dirty_idx_lnums(struct ubifs_info *c)
  */
 static int scan_dirty_idx_cb(struct ubifs_info *c,
 			   const struct ubifs_lprops *lprops, int in_tree,
-			   struct scan_data *data)
+			   void *_data)
 {
+	struct scan_data *data = _data;
 	int ret = LPT_SCAN_CONTINUE;
 
 	/* Exclude LEBs that are currently in use */
@@ -865,7 +871,7 @@ static int find_dirty_idx_leb(struct ubifs_info *c)
 		/* All pnodes are in memory, so skip scan */
 		return -ENOSPC;
 	err = ubifs_lpt_scan_nolock(c, -1, c->lscan_lnum,
-				    (ubifs_lpt_scan_callback)scan_dirty_idx_cb,
+				    scan_dirty_idx_cb,
 				    &data);
 	if (err)
 		return err;
diff --git a/fs/ubifs/lprops.c b/fs/ubifs/lprops.c
index a0011aa3a..c8cf70940 100644
--- a/fs/ubifs/lprops.c
+++ b/fs/ubifs/lprops.c
@@ -1028,8 +1028,9 @@ out:
  */
 static int scan_check_cb(struct ubifs_info *c,
 			 const struct ubifs_lprops *lp, int in_tree,
-			 struct ubifs_lp_stats *lst)
+			 void *_lst)
 {
+	struct ubifs_lp_stats *lst = _lst;
 	struct ubifs_scan_leb *sleb;
 	struct ubifs_scan_node *snod;
 	int cat, lnum = lp->lnum, is_idx = 0, used = 0, free, dirty, ret;
@@ -1283,7 +1284,7 @@ int dbg_check_lprops(struct ubifs_info *c)
 
 	memset(&lst, 0, sizeof(struct ubifs_lp_stats));
 	err = ubifs_lpt_scan_nolock(c, c->main_first, c->leb_cnt - 1,
-				    (ubifs_lpt_scan_callback)scan_check_cb,
+				    scan_check_cb,
 				    &lst);
 	if (err && err != -ENOSPC)
 		goto out;
diff --git a/fs/udf/misc.c b/fs/udf/misc.c
index 71d1c25f3..084e2ad67 100644
--- a/fs/udf/misc.c
+++ b/fs/udf/misc.c
@@ -288,7 +288,7 @@ void udf_new_tag(char *data, uint16_t ident, uint16_t version, uint16_t snum,
 
 u8 udf_tag_checksum(const struct tag *t)
 {
-	u8 *data = (u8 *)t;
+	const u8 *data = (const u8 *)t;
 	u8 checksum = 0;
 	int i;
 	for (i = 0; i < sizeof(struct tag); ++i)
diff --git a/fs/ufs/super.c b/fs/ufs/super.c
index f04ab232d..b26fff4f2 100644
--- a/fs/ufs/super.c
+++ b/fs/ufs/super.c
@@ -1424,10 +1424,12 @@ static void init_once(void *foo)
 
 static int __init init_inodecache(void)
 {
-	ufs_inode_cachep = kmem_cache_create("ufs_inode_cache",
+	ufs_inode_cachep = kmem_cache_create_usercopy("ufs_inode_cache",
 					     sizeof(struct ufs_inode_info),
 					     0, (SLAB_RECLAIM_ACCOUNT|
 						SLAB_MEM_SPREAD|SLAB_ACCOUNT),
+					     offsetof(struct ufs_inode_info, i_u1.i_symlink),
+					     sizeof(((struct ufs_inode_info *)0)->i_u1.i_symlink),
 					     init_once);
 	if (ufs_inode_cachep == NULL)
 		return -ENOMEM;
diff --git a/fs/ufs/swab.h b/fs/ufs/swab.h
index 8d974c4fd..b82f6ecca 100644
--- a/fs/ufs/swab.h
+++ b/fs/ufs/swab.h
@@ -22,7 +22,7 @@ enum {
 	BYTESEX_BE
 };
 
-static inline u64
+static inline u64 __intentional_overflow(-1)
 fs64_to_cpu(struct super_block *sbp, __fs64 n)
 {
 	if (UFS_SB(sbp)->s_bytesex == BYTESEX_LE)
@@ -40,7 +40,7 @@ cpu_to_fs64(struct super_block *sbp, u64 n)
 		return (__force __fs64)cpu_to_be64(n);
 }
 
-static inline u32
+static inline u32 __intentional_overflow(-1)
 fs32_to_cpu(struct super_block *sbp, __fs32 n)
 {
 	if (UFS_SB(sbp)->s_bytesex == BYTESEX_LE)
diff --git a/fs/userfaultfd.c b/fs/userfaultfd.c
index 85959d832..6e511a70e 100644
--- a/fs/userfaultfd.c
+++ b/fs/userfaultfd.c
@@ -432,7 +432,7 @@ static int userfaultfd_release(struct inode *inode, struct file *file)
 	struct userfaultfd_wake_range range = { .len = 0, };
 	unsigned long new_flags;
 
-	ACCESS_ONCE(ctx->released) = true;
+	ACCESS_ONCE_RW(ctx->released) = true;
 
 	if (!mmget_not_zero(mm))
 		goto wakeup;
diff --git a/fs/utimes.c b/fs/utimes.c
index ba54b9e64..49fc4d861 100644
--- a/fs/utimes.c
+++ b/fs/utimes.c
@@ -1,6 +1,7 @@
 #include <linux/compiler.h>
 #include <linux/file.h>
 #include <linux/fs.h>
+#include <linux/security.h>
 #include <linux/linkage.h>
 #include <linux/mount.h>
 #include <linux/namei.h>
@@ -90,6 +91,12 @@ static int utimes_common(struct path *path, struct timespec *times)
 		newattrs.ia_valid |= ATTR_TOUCH;
 	}
 retry_deleg:
+
+	if (!gr_acl_handle_utime(path->dentry, path->mnt)) {
+		error = -EACCES;
+		goto mnt_drop_write_and_out;
+	}
+
 	inode_lock(inode);
 	error = notify_change(path->dentry, &newattrs, &delegated_inode);
 	inode_unlock(inode);
@@ -99,6 +106,7 @@ retry_deleg:
 			goto retry_deleg;
 	}
 
+mnt_drop_write_and_out:
 	mnt_drop_write(path->mnt);
 out:
 	return error;
diff --git a/fs/xattr.c b/fs/xattr.c
index c24390583..6f99cc750 100644
--- a/fs/xattr.c
+++ b/fs/xattr.c
@@ -215,6 +215,27 @@ vfs_getxattr_alloc(struct dentry *dentry, const char *name, char **xattr_value,
 	return error;
 }
 
+#ifdef CONFIG_PAX_XATTR_PAX_FLAGS
+ssize_t
+pax_getxattr(struct dentry *dentry, void *value, size_t size)
+{
+	struct inode *inode = dentry->d_inode;
+	ssize_t error;
+
+	error = inode_permission(inode, MAY_EXEC);
+	if (error)
+		return error;
+
+	if (inode->i_op->getxattr)
+		error = inode->i_op->getxattr(dentry, inode, XATTR_NAME_USER_PAX_FLAGS, value, size);
+	else
+		error = -EOPNOTSUPP;
+
+	return error;
+}
+EXPORT_SYMBOL(pax_getxattr);
+#endif
+
 ssize_t
 vfs_getxattr(struct dentry *dentry, const char *name, void *value, size_t size)
 {
@@ -307,7 +328,7 @@ EXPORT_SYMBOL_GPL(vfs_removexattr);
  * Extended attribute SET operations
  */
 static long
-setxattr(struct dentry *d, const char __user *name, const void __user *value,
+setxattr(struct path *path, const char __user *name, const void __user *value,
 	 size_t size, int flags)
 {
 	int error;
@@ -341,7 +362,12 @@ setxattr(struct dentry *d, const char __user *name, const void __user *value,
 			posix_acl_fix_xattr_from_user(kvalue, size);
 	}
 
-	error = vfs_setxattr(d, kname, kvalue, size, flags);
+	if (!gr_acl_handle_setxattr(path->dentry, path->mnt)) {
+		error = -EACCES;
+		goto out;
+	}
+
+	error = vfs_setxattr(path->dentry, kname, kvalue, size, flags);
 out:
 	kvfree(kvalue);
 
@@ -360,7 +386,7 @@ retry:
 		return error;
 	error = mnt_want_write(path.mnt);
 	if (!error) {
-		error = setxattr(path.dentry, name, value, size, flags);
+		error = setxattr(&path, name, value, size, flags);
 		mnt_drop_write(path.mnt);
 	}
 	path_put(&path);
@@ -396,7 +422,7 @@ SYSCALL_DEFINE5(fsetxattr, int, fd, const char __user *, name,
 	audit_file(f.file);
 	error = mnt_want_write_file(f.file);
 	if (!error) {
-		error = setxattr(f.file->f_path.dentry, name, value, size, flags);
+		error = setxattr(&f.file->f_path, name, value, size, flags);
 		mnt_drop_write_file(f.file);
 	}
 	fdput(f);
@@ -576,7 +602,7 @@ SYSCALL_DEFINE3(flistxattr, int, fd, char __user *, list, size_t, size)
  * Extended attribute REMOVE operations
  */
 static long
-removexattr(struct dentry *d, const char __user *name)
+removexattr(struct path *path, const char __user *name)
 {
 	int error;
 	char kname[XATTR_NAME_MAX + 1];
@@ -587,7 +613,10 @@ removexattr(struct dentry *d, const char __user *name)
 	if (error < 0)
 		return error;
 
-	return vfs_removexattr(d, kname);
+	if (!gr_acl_handle_removexattr(path->dentry, path->mnt))
+		return -EACCES;
+
+	return vfs_removexattr(path->dentry, kname);
 }
 
 static int path_removexattr(const char __user *pathname,
@@ -601,7 +630,7 @@ retry:
 		return error;
 	error = mnt_want_write(path.mnt);
 	if (!error) {
-		error = removexattr(path.dentry, name);
+		error = removexattr(&path, name);
 		mnt_drop_write(path.mnt);
 	}
 	path_put(&path);
@@ -627,14 +656,16 @@ SYSCALL_DEFINE2(lremovexattr, const char __user *, pathname,
 SYSCALL_DEFINE2(fremovexattr, int, fd, const char __user *, name)
 {
 	struct fd f = fdget(fd);
+	struct path *path;
 	int error = -EBADF;
 
 	if (!f.file)
 		return error;
+	path = &f.file->f_path;
 	audit_file(f.file);
 	error = mnt_want_write_file(f.file);
 	if (!error) {
-		error = removexattr(f.file->f_path.dentry, name);
+		error = removexattr(path, name);
 		mnt_drop_write_file(f.file);
 	}
 	fdput(f);
diff --git a/fs/xfs/kmem.h b/fs/xfs/kmem.h
index 689f74622..3e200fc90 100644
--- a/fs/xfs/kmem.h
+++ b/fs/xfs/kmem.h
@@ -102,6 +102,14 @@ kmem_zone_init_flags(int size, char *zone_name, unsigned long flags,
 	return kmem_cache_create(zone_name, size, 0, flags, construct);
 }
 
+static inline kmem_zone_t *
+kmem_zone_init_flags_usercopy(int size, char *zone_name, unsigned long flags,
+			      size_t useroffset, size_t usersize,
+			      void (*construct)(void *))
+{
+	return kmem_cache_create_usercopy(zone_name, size, 0, flags, useroffset, usersize, construct);
+}
+
 static inline void
 kmem_zone_free(kmem_zone_t *zone, void *ptr)
 {
diff --git a/fs/xfs/libxfs/xfs_bmap.c b/fs/xfs/libxfs/xfs_bmap.c
index b060bca93..bfd7974a5 100644
--- a/fs/xfs/libxfs/xfs_bmap.c
+++ b/fs/xfs/libxfs/xfs_bmap.c
@@ -559,7 +559,7 @@ xfs_bmap_validate_ret(
 
 #else
 #define xfs_bmap_check_leaf_extents(cur, ip, whichfork)		do { } while (0)
-#define	xfs_bmap_validate_ret(bno,len,flags,mval,onmap,nmap)
+#define	xfs_bmap_validate_ret(bno,len,flags,mval,onmap,nmap)	do { } while (0)
 #endif /* DEBUG */
 
 /*
diff --git a/fs/xfs/libxfs/xfs_da_btree.c b/fs/xfs/libxfs/xfs_da_btree.c
index f2dc1a950..5677aa5d7 100644
--- a/fs/xfs/libxfs/xfs_da_btree.c
+++ b/fs/xfs/libxfs/xfs_da_btree.c
@@ -2011,6 +2011,7 @@ xfs_da_grow_inode_int(
 	struct xfs_inode	*dp = args->dp;
 	int			w = args->whichfork;
 	xfs_rfsblock_t		nblks = dp->i_d.di_nblocks;
+	xfs_rfsblock_t		nblocks;
 	struct xfs_bmbt_irec	map, *mapp;
 	int			nmap, error, got, i, mapi;
 
@@ -2079,7 +2080,8 @@ xfs_da_grow_inode_int(
 	}
 
 	/* account for newly allocated blocks in reserved blocks total */
-	args->total -= dp->i_d.di_nblocks - nblks;
+	nblocks = dp->i_d.di_nblocks - nblks;
+	args->total -= nblocks;
 
 out_free_map:
 	if (mapp != &map)
diff --git a/fs/xfs/xfs_ioctl.c b/fs/xfs/xfs_ioctl.c
index 96a70fd1f..de3d84c2d 100644
--- a/fs/xfs/xfs_ioctl.c
+++ b/fs/xfs/xfs_ioctl.c
@@ -121,7 +121,7 @@ xfs_find_handle(
 	}
 
 	error = -EFAULT;
-	if (copy_to_user(hreq->ohandle, &handle, hsize) ||
+	if (hsize > sizeof handle || copy_to_user(hreq->ohandle, &handle, hsize) ||
 	    copy_to_user(hreq->ohandlen, &hsize, sizeof(__s32)))
 		goto out_put;
 
@@ -1590,6 +1590,12 @@ xfs_ioc_swapext(
 		goto out_put_tmp_file;
 	}
 
+	if (f.file->f_op != &xfs_file_operations ||
+	    tmp.file->f_op != &xfs_file_operations) {
+		error = -EINVAL;
+		goto out_put_tmp_file;
+	}
+
 	ip = XFS_I(file_inode(f.file));
 	tip = XFS_I(file_inode(tmp.file));
 
diff --git a/fs/xfs/xfs_linux.h b/fs/xfs/xfs_linux.h
index b8d64d520..3e8762672 100644
--- a/fs/xfs/xfs_linux.h
+++ b/fs/xfs/xfs_linux.h
@@ -218,7 +218,7 @@ static inline kgid_t xfs_gid_to_kgid(__uint32_t gid)
  * of the compiler which do not like us using do_div in the middle
  * of large functions.
  */
-static inline __u32 xfs_do_div(void *a, __u32 b, int n)
+static inline __u32 __intentional_overflow(-1) xfs_do_div(void *a, __u32 b, int n)
 {
 	__u32	mod;
 
@@ -274,7 +274,7 @@ static inline __u32 xfs_do_mod(void *a, __u32 b, int n)
 	return 0;
 }
 #else
-static inline __u32 xfs_do_div(void *a, __u32 b, int n)
+static inline __u32 __intentional_overflow(-1) xfs_do_div(void *a, __u32 b, int n)
 {
 	__u32	mod;
 
diff --git a/fs/xfs/xfs_super.c b/fs/xfs/xfs_super.c
index fd6be45b3..6be65422e 100644
--- a/fs/xfs/xfs_super.c
+++ b/fs/xfs/xfs_super.c
@@ -1761,9 +1761,11 @@ xfs_init_zones(void)
 		goto out_destroy_efd_zone;
 
 	xfs_inode_zone =
-		kmem_zone_init_flags(sizeof(xfs_inode_t), "xfs_inode",
-			KM_ZONE_HWALIGN | KM_ZONE_RECLAIM | KM_ZONE_SPREAD |
-			KM_ZONE_ACCOUNT, xfs_fs_inode_init_once);
+		kmem_zone_init_flags_usercopy(sizeof(xfs_inode_t), "xfs_inode",
+			KM_ZONE_HWALIGN | KM_ZONE_RECLAIM | KM_ZONE_SPREAD | KM_ZONE_ACCOUNT,
+			offsetof(xfs_inode_t, i_df.if_u2.if_inline_data),
+			sizeof(((xfs_inode_t *)0)->i_df.if_u2.if_inline_data),
+			xfs_fs_inode_init_once);
 	if (!xfs_inode_zone)
 		goto out_destroy_efi_zone;
 
diff --git b/grsecurity/Kconfig b/grsecurity/Kconfig
new file mode 100644
index 000000000..f1c1ee284
--- /dev/null
+++ b/grsecurity/Kconfig
@@ -0,0 +1,1206 @@
+#
+# grecurity configuration
+#
+menu "Memory Protections"
+depends on GRKERNSEC
+
+config GRKERNSEC_KMEM
+	bool "Deny reading/writing to /dev/kmem, /dev/mem, and /dev/port"
+	default y if GRKERNSEC_CONFIG_AUTO
+	select STRICT_DEVMEM if (X86 || ARM || TILE || S390)
+	help
+	  If you say Y here, /dev/kmem and /dev/mem won't be allowed to
+	  be written to or read from to modify or leak the contents of the running
+	  kernel.  /dev/port will also not be allowed to be opened, writing to
+	  /dev/cpu/*/msr will be prevented, and support for kexec will be removed.
+	  If you have module support disabled, enabling this will close up several
+	  ways that are currently used to insert malicious code into the running
+	  kernel.
+
+	  Even with this feature enabled, we still highly recommend that
+	  you use the RBAC system, as it is still possible for an attacker to
+	  modify the running kernel through other more obscure methods.
+
+	  Enabling this feature will prevent the "cpupower" and "powertop" tools
+	  from working and excludes debugfs from being compiled into the kernel.
+
+	  It is highly recommended that you say Y here if you meet all the
+	  conditions above.
+
+config GRKERNSEC_VM86
+	bool "Restrict VM86 mode"
+	default y if (GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_SERVER)
+	depends on X86_32
+
+	help
+	  If you say Y here, only processes with CAP_SYS_RAWIO will be able to
+	  make use of a special execution mode on 32bit x86 processors called
+	  Virtual 8086 (VM86) mode.  XFree86 may need vm86 mode for certain
+	  video cards and will still work with this option enabled.  The purpose
+	  of the option is to prevent exploitation of emulation errors in
+	  virtualization of vm86 mode like the one discovered in VMWare in 2009.
+	  Nearly all users should be able to enable this option.
+
+config GRKERNSEC_IO
+	bool "Disable privileged I/O"
+	default y if (GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_SERVER)
+	depends on X86
+	select RTC_CLASS
+	select RTC_INTF_DEV
+	select RTC_DRV_CMOS
+
+	help
+	  If you say Y here, all ioperm and iopl calls will return an error.
+	  Ioperm and iopl can be used to modify the running kernel.
+	  Unfortunately, some programs need this access to operate properly,
+	  the most notable of which are XFree86 and hwclock.  hwclock can be
+	  remedied by having RTC support in the kernel, so real-time 
+	  clock support is enabled if this option is enabled, to ensure 
+	  that hwclock operates correctly.  If hwclock still does not work,
+	  either update udev or symlink /dev/rtc to /dev/rtc0.
+
+	  If you're using XFree86 or a version of Xorg from 2012 or earlier,
+	  you may not be able to boot into a graphical environment with this
+	  option enabled.  In this case, you should use the RBAC system instead.
+
+config GRKERNSEC_BPF_HARDEN
+	bool "Harden BPF interpreter"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  Unlike previous versions of grsecurity that hardened both the BPF
+	  interpreted code against corruption at rest as well as the JIT code
+	  against JIT-spray attacks and attacker-controlled immediate values
+	  for ROP, this feature will enforce disabling of the new eBPF JIT engine
+	  and will ensure the interpreted code is read-only at rest.  This feature
+	  may be removed at a later time when eBPF stabilizes to entirely revert
+	  back to the more secure pre-3.16 BPF interpreter/JIT.
+
+	  If you're using KERNEXEC, it's recommended that you enable this option
+	  to supplement the hardening of the kernel.
+  
+config GRKERNSEC_PERF_HARDEN
+	bool "Disable unprivileged PERF_EVENTS usage by default"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on PERF_EVENTS
+	help
+	  If you say Y here, the range of acceptable values for the
+	  /proc/sys/kernel/perf_event_paranoid sysctl will be expanded to allow and
+	  default to a new value: 3.  When the sysctl is set to this value, no
+	  unprivileged use of the PERF_EVENTS syscall interface will be permitted.
+
+	  Though PERF_EVENTS can be used legitimately for performance monitoring
+	  and low-level application profiling, it is forced on regardless of
+	  configuration, has been at fault for several vulnerabilities, and
+	  creates new opportunities for side channels and other information leaks.
+
+	  This feature puts PERF_EVENTS into a secure default state and permits
+	  the administrator to change out of it temporarily if unprivileged
+	  application profiling is needed.
+
+config GRKERNSEC_RAND_THREADSTACK
+	bool "Insert random gaps between thread stacks"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on PAX_RANDMMAP && !PPC
+	help
+	  If you say Y here, a random-sized gap will be enforced between allocated
+	  thread stacks.  Glibc's NPTL and other threading libraries that
+	  pass MAP_STACK to the kernel for thread stack allocation are supported.
+	  The implementation currently provides 8 bits of entropy for the gap.
+
+	  Many distributions do not compile threaded remote services with the
+	  -fstack-check argument to GCC, causing the variable-sized stack-based
+	  allocator, alloca(), to not probe the stack on allocation.  This
+	  permits an unbounded alloca() to skip over any guard page and potentially
+	  modify another thread's stack reliably.  An enforced random gap
+	  reduces the reliability of such an attack and increases the chance
+	  that such a read/write to another thread's stack instead lands in
+	  an unmapped area, causing a crash and triggering grsecurity's
+	  anti-bruteforcing logic.
+
+config GRKERNSEC_PROC_MEMMAP
+	bool "Harden ASLR against information leaks and entropy reduction"
+	default y if (GRKERNSEC_CONFIG_AUTO || PAX_NOEXEC || PAX_ASLR)
+	depends on PAX_NOEXEC || PAX_ASLR
+	help
+	  If you say Y here, the /proc/<pid>/maps and /proc/<pid>/stat files will
+	  give no information about the addresses of its mappings if
+	  PaX features that rely on random addresses are enabled on the task.
+	  In addition to sanitizing this information and disabling other
+	  dangerous sources of information, this option causes reads of sensitive
+	  /proc/<pid> entries where the file descriptor was opened in a different
+	  task than the one performing the read.  Such attempts are logged.
+	  This option also limits argv/env strings for suid/sgid binaries
+	  to 512KB to prevent a complete exhaustion of the stack entropy provided
+	  by ASLR.  Finally, it places an 8MB stack resource limit on suid/sgid
+	  binaries to prevent alternative mmap layouts from being abused.
+
+	  If you use PaX it is essential that you say Y here as it closes up
+	  several holes that make full ASLR useless locally.
+
+
+config GRKERNSEC_KSTACKOVERFLOW
+	bool "Prevent kernel stack overflows"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on X86_64
+	help
+	  If you say Y here, the kernel's process stacks will be allocated
+	  with vmalloc instead of the kernel's default allocator.  This
+	  introduces guard pages that in combination with the alloca checking
+	  of the STACKLEAK feature and removal of thread_info from the kernel
+	  stack prevents all forms of kernel process stack overflow abuse.
+          Note that this is different from kernel stack buffer overflows.
+
+config GRKERNSEC_BRUTE
+	bool "Deter exploit bruteforcing"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, attempts to bruteforce exploits against forking
+	  daemons such as apache or sshd, as well as against suid/sgid binaries
+	  will be deterred.  When a child of a forking daemon is killed by PaX
+	  or crashes due to an illegal instruction or other suspicious signal,
+	  the parent process will be delayed 30 seconds upon every subsequent
+	  fork until the administrator is able to assess the situation and
+	  restart the daemon.
+	  In the suid/sgid case, the attempt is logged, the user has all their
+	  existing instances of the suid/sgid binary terminated and will
+	  be unable to execute any suid/sgid binaries for 15 minutes.
+
+	  It is recommended that you also enable signal logging in the auditing
+	  section so that logs are generated when a process triggers a suspicious
+	  signal.
+	  If the sysctl option is enabled, a sysctl option with name
+	  "deter_bruteforce" is created.
+
+config GRKERNSEC_MODHARDEN
+	bool "Harden module auto-loading"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on MODULES
+	help
+	  If you say Y here, module auto-loading in response to use of some
+	  feature implemented by an unloaded module will be restricted to
+	  root users.  Enabling this option helps defend against attacks 
+	  by unprivileged users who abuse the auto-loading behavior to 
+	  cause a vulnerable module to load that is then exploited.
+
+	  If this option prevents a legitimate use of auto-loading for a 
+	  non-root user, the administrator can execute modprobe manually 
+	  with the exact name of the module mentioned in the alert log.
+	  Alternatively, the administrator can add the module to the list
+	  of modules loaded at boot by modifying init scripts.
+
+	  Modification of init scripts will most likely be needed on 
+	  Ubuntu servers with encrypted home directory support enabled,
+	  as the first non-root user logging in will cause the ecb(aes),
+	  ecb(aes)-all, cbc(aes), and cbc(aes)-all  modules to be loaded.
+
+config GRKERNSEC_HIDESYM
+	bool "Hide kernel symbols"
+	default y if GRKERNSEC_CONFIG_AUTO
+	select PAX_USERCOPY
+	help
+	  If you say Y here, getting information on loaded modules, and
+	  displaying all kernel symbols through a syscall will be restricted
+	  to users with CAP_SYS_MODULE.  For software compatibility reasons,
+	  /proc/kallsyms will be restricted to the root user.  The RBAC
+	  system can hide that entry even from root.
+
+	  This option also prevents leaking of kernel addresses through
+	  several /proc entries.
+
+	  Note that this option is only effective provided the following
+	  conditions are met:
+	  1) The kernel using grsecurity is not precompiled by some distribution
+	  2) You have also enabled GRKERNSEC_DMESG
+	  3) You are using the RBAC system and hiding other files such as your
+	     kernel image and System.map.  Alternatively, enabling this option
+	     causes the permissions on /boot, /lib/modules, and the kernel
+	     source directory to change at compile time to prevent 
+	     reading by non-root users.
+	  If the above conditions are met, this option will aid in providing a
+	  useful protection against local kernel exploitation of overflows
+	  and arbitrary read/write vulnerabilities.
+
+	  It is highly recommended that you enable GRKERNSEC_PERF_HARDEN
+	  in addition to this feature.
+
+config GRKERNSEC_RANDSTRUCT
+	bool "Randomize layout of sensitive kernel structures"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GCC_PLUGINS
+	select GRKERNSEC_HIDESYM
+	select MODVERSIONS if MODULES
+	help
+	  If you say Y here, the layouts of a number of sensitive kernel
+	  structures (task, fs, cred, etc) and all structures composed entirely
+	  of function pointers (aka "ops" structs) will be randomized at compile-time.
+	  This can introduce the requirement of an additional infoleak
+	  vulnerability for exploits targeting these structure types.
+
+	  Enabling this feature will introduce some performance impact, slightly
+	  increase memory usage, and prevent the use of forensic tools like
+	  Volatility against the system (unless the kernel source tree isn't
+	  cleaned after kernel installation).
+
+	  The seed used for compilation is located at tools/gcc/randomize_layout_seed.h.
+	  It remains after a make clean to allow for external modules to be compiled
+	  with the existing seed and will be removed by a make mrproper or
+	  make distclean.
+
+          Note that the implementation requires gcc 4.6.4. or newer.  You may need
+	  to install the supporting headers explicitly in addition to the normal
+	  gcc package.
+
+config GRKERNSEC_RANDSTRUCT_PERFORMANCE
+	bool "Use cacheline-aware structure randomization"
+	depends on GRKERNSEC_RANDSTRUCT
+	default y if GRKERNSEC_CONFIG_PRIORITY_PERF
+	help
+	  If you say Y here, the RANDSTRUCT randomization will make a best effort
+	  at restricting randomization to cacheline-sized groups of elements.  It
+	  will further not randomize bitfields in structures.  This reduces the
+	  performance hit of RANDSTRUCT at the cost of weakened randomization.
+
+config GRKERNSEC_KERN_LOCKOUT
+	bool "Active kernel exploit response"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on X86 || ARM || PPC || SPARC
+	help
+	  If you say Y here, when a PaX alert is triggered due to suspicious
+	  activity in the kernel (from KERNEXEC/UDEREF/USERCOPY)
+	  or an OOPS occurs due to bad memory accesses, instead of just
+	  terminating the offending process (and potentially allowing
+	  a subsequent exploit from the same user), we will take one of two
+	  actions:
+	   If the user was root, we will panic the system
+	   If the user was non-root, we will log the attempt, terminate
+	   all processes owned by the user, then prevent them from creating
+	   any new processes until the system is restarted
+	  This deters repeated kernel exploitation/bruteforcing attempts
+	  and is useful for later forensics.
+
+config GRKERNSEC_OLD_ARM_USERLAND
+	bool "Old ARM userland compatibility"
+	depends on ARM && (CPU_V6 || CPU_V6K || CPU_V7)
+	help
+	  If you say Y here, stubs of executable code to perform such operations
+	  as "compare-exchange" will be placed at fixed locations in the ARM vector
+	  table.  This is unfortunately needed for old ARM userland meant to run
+	  across a wide range of processors.  Without this option enabled,
+	  the get_tls and data memory barrier stubs will be emulated by the kernel,
+	  which is enough for Linaro userlands or other userlands designed for v6
+	  and newer ARM CPUs.  It's recommended that you try without this option enabled
+	  first, and only enable it if your userland does not boot (it will likely fail
+	  at init time).
+
+endmenu
+menu "Role Based Access Control Options"
+depends on GRKERNSEC
+
+config GRKERNSEC_RBAC_DEBUG
+	bool
+
+config GRKERNSEC_NO_RBAC
+	bool "Disable RBAC system"
+	help
+	  If you say Y here, the /dev/grsec device will be removed from the kernel,
+	  preventing the RBAC system from being enabled.  You should only say Y
+	  here if you have no intention of using the RBAC system, so as to prevent
+	  an attacker with root access from misusing the RBAC system to hide files
+	  and processes when loadable module support and /dev/[k]mem have been
+	  locked down.
+
+config GRKERNSEC_ACL_HIDEKERN
+	bool "Hide kernel processes"
+	help
+	  If you say Y here, all kernel threads will be hidden to all
+	  processes but those whose subject has the "view hidden processes"
+	  flag.
+
+config GRKERNSEC_ACL_MAXTRIES
+	int "Maximum tries before password lockout"
+	default 3
+	help
+	  This option enforces the maximum number of times a user can attempt
+	  to authorize themselves with the grsecurity RBAC system before being
+	  denied the ability to attempt authorization again for a specified time.
+	  The lower the number, the harder it will be to brute-force a password.
+
+config GRKERNSEC_ACL_TIMEOUT
+	int "Time to wait after max password tries, in seconds"
+	default 30
+	help
+	  This option specifies the time the user must wait after attempting to
+	  authorize to the RBAC system with the maximum number of invalid
+	  passwords.  The higher the number, the harder it will be to brute-force
+	  a password.
+
+endmenu
+menu "Filesystem Protections"
+depends on GRKERNSEC
+
+config GRKERNSEC_PROC
+	bool "Proc restrictions"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, the permissions of the /proc filesystem
+	  will be altered to enhance system security and privacy.  You MUST
+  	  choose either a user only restriction or a user and group restriction.
+	  Depending upon the option you choose, you can either restrict users to
+	  see only the processes they themselves run, or choose a group that can
+	  view all processes and files normally restricted to root if you choose
+	  the "restrict to user only" option.  NOTE: If you're running identd or
+	  ntpd as a non-root user, you will have to run it as the group you
+	  specify here.
+
+config GRKERNSEC_PROC_USER
+	bool "Restrict /proc to user only"
+	depends on GRKERNSEC_PROC
+	help
+	  If you say Y here, non-root users will only be able to view their own
+	  processes, and restricts them from viewing network-related information,
+	  and viewing kernel symbol and module information.
+
+config GRKERNSEC_PROC_USERGROUP
+	bool "Allow special group"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_PROC && !GRKERNSEC_PROC_USER
+	help
+	  If you say Y here, you will be able to select a group that will be
+	  able to view all processes and network-related information.  If you've
+	  enabled GRKERNSEC_HIDESYM, kernel and symbol information may still
+	  remain hidden.  This option is useful if you want to run identd as
+	  a non-root user.  The group you select may also be chosen at boot time
+	  via "grsec_proc_gid=" on the kernel commandline.
+
+config GRKERNSEC_PROC_GID
+	int "GID for special group"
+	depends on GRKERNSEC_PROC_USERGROUP
+	default 1001
+
+config GRKERNSEC_PROC_ADD
+	bool "Additional restrictions"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_PROC_USER || GRKERNSEC_PROC_USERGROUP
+	help
+	  If you say Y here, additional restrictions will be placed on
+	  /proc that keep normal users from viewing device information and 
+	  slabinfo information that could be useful for exploits.
+
+config GRKERNSEC_LINK
+	bool "Linking restrictions"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, /tmp race exploits will be prevented, since users
+	  will no longer be able to follow symlinks owned by other users in
+	  world-writable +t directories (e.g. /tmp), unless the owner of the
+	  symlink is the owner of the directory. users will also not be
+	  able to hardlink to files they do not own.  If the sysctl option is
+	  enabled, a sysctl option with name "linking_restrictions" is created.
+
+config GRKERNSEC_SYMLINKOWN
+	bool "Kernel-enforced SymlinksIfOwnerMatch"
+	default y if GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_SERVER
+	help
+	  Apache's SymlinksIfOwnerMatch option has an inherent race condition
+	  that prevents it from being used as a security feature.  As Apache
+	  verifies the symlink by performing a stat() against the target of
+	  the symlink before it is followed, an attacker can setup a symlink
+	  to point to a same-owned file, then replace the symlink with one
+	  that targets another user's file just after Apache "validates" the
+	  symlink -- a classic TOCTOU race.  If you say Y here, a complete,
+	  race-free replacement for Apache's "SymlinksIfOwnerMatch" option
+	  will be in place for the group you specify. If the sysctl option
+	  is enabled, a sysctl option with name "enforce_symlinksifowner" is
+	  created.
+
+config GRKERNSEC_SYMLINKOWN_GID
+	int "GID for users with kernel-enforced SymlinksIfOwnerMatch"
+	depends on GRKERNSEC_SYMLINKOWN
+	default 1006
+	help
+	  Setting this GID determines what group kernel-enforced
+	  SymlinksIfOwnerMatch will be enabled for.  If the sysctl option
+	  is enabled, a sysctl option with name "symlinkown_gid" is created.
+
+config GRKERNSEC_FIFO
+	bool "FIFO restrictions"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, users will not be able to write to FIFOs they don't
+	  own in world-writable +t directories (e.g. /tmp), unless the owner of
+	  the FIFO is the same owner of the directory it's held in.  If the sysctl
+	  option is enabled, a sysctl option with name "fifo_restrictions" is
+	  created.
+
+config GRKERNSEC_SYSFS_RESTRICT
+	bool "Sysfs/debugfs restriction"
+	default y if (GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_SERVER)
+	depends on SYSFS
+	help
+	  If you say Y here, sysfs (the pseudo-filesystem mounted at /sys) and
+	  any filesystem normally mounted under it (e.g. debugfs) will be
+	  mostly accessible only by root.  These filesystems generally provide access
+	  to hardware and debug information that isn't appropriate for unprivileged
+	  users of the system.  Sysfs and debugfs have also become a large source
+	  of new vulnerabilities, ranging from infoleaks to local compromise.
+	  There has been very little oversight with an eye toward security involved
+	  in adding new exporters of information to these filesystems, so their
+	  use is discouraged.
+	  For reasons of compatibility, a few directories have been whitelisted
+	  for access by non-root users:
+	  /sys/fs/selinux
+	  /sys/fs/fuse
+	  /sys/devices/system/cpu
+
+config GRKERNSEC_ROFS
+	bool "Runtime read-only mount protection"
+	depends on SYSCTL
+	help
+	  If you say Y here, a sysctl option with name "romount_protect" will
+	  be created.  By setting this option to 1 at runtime, filesystems
+	  will be protected in the following ways:
+	  * No new writable mounts will be allowed
+	  * Existing read-only mounts won't be able to be remounted read/write
+	  * Write operations will be denied on all block devices
+	  This option acts independently of grsec_lock: once it is set to 1,
+	  it cannot be turned off.  Therefore, please be mindful of the resulting
+	  behavior if this option is enabled in an init script on a read-only
+	  filesystem.
+	  Also be aware that as with other root-focused features, GRKERNSEC_KMEM
+	  and GRKERNSEC_IO should be enabled and module loading disabled via
+	  config or at runtime.
+	  This feature is mainly intended for secure embedded systems.
+	  
+
+config GRKERNSEC_DEVICE_SIDECHANNEL
+	bool "Eliminate stat/notify-based device sidechannels"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, timing analyses on block or character
+	  devices like /dev/ptmx using stat or inotify/dnotify/fanotify
+	  will be thwarted for unprivileged users.  If a process without
+	  CAP_MKNOD stats such a device, the last access and last modify times
+	  will match the device's create time.  No access or modify events
+	  will be triggered through inotify/dnotify/fanotify for such devices.
+	  This feature will prevent attacks that may at a minimum
+	  allow an attacker to determine the administrator's password length.
+
+config GRKERNSEC_CHROOT
+	bool "Chroot jail restrictions"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, you will be able to choose several options that will
+	  make breaking out of a chrooted jail much more difficult.  If you
+	  encounter no software incompatibilities with the following options, it
+	  is recommended that you enable each one.
+
+	  Note that the chroot restrictions are not intended to apply to "chroots"
+	  to directories that are simple bind mounts of the global root filesystem.
+	  For several other reasons, a user shouldn't expect any significant
+	  security by performing such a chroot.
+
+config GRKERNSEC_CHROOT_MOUNT
+	bool "Deny mounts"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to
+	  mount or remount filesystems.  If the sysctl option is enabled, a
+	  sysctl option with name "chroot_deny_mount" is created.
+
+config GRKERNSEC_CHROOT_DOUBLE
+	bool "Deny double-chroots"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to chroot
+	  again outside the chroot.  This is a widely used method of breaking
+	  out of a chroot jail and should not be allowed.  If the sysctl 
+	  option is enabled, a sysctl option with name 
+	  "chroot_deny_chroot" is created.
+
+config GRKERNSEC_CHROOT_PIVOT
+	bool "Deny pivot_root in chroot"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to use
+	  a function called pivot_root() that was introduced in Linux 2.3.41.  It
+	  works similar to chroot in that it changes the root filesystem.  This
+	  function could be misused in a chrooted process to attempt to break out
+	  of the chroot, and therefore should not be allowed.  If the sysctl
+	  option is enabled, a sysctl option with name "chroot_deny_pivot" is
+	  created.
+
+config GRKERNSEC_CHROOT_CHDIR
+	bool "Enforce chdir(\"/\") on all chroots"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, the current working directory of all newly-chrooted
+	  applications will be set to the the root directory of the chroot.
+	  The man page on chroot(2) states:
+	  Note that this call does not change  the  current  working
+	  directory,  so  that `.' can be outside the tree rooted at
+	  `/'.  In particular, the  super-user  can  escape  from  a
+	  `chroot jail' by doing `mkdir foo; chroot foo; cd ..'.
+
+	  It is recommended that you say Y here, since it's not known to break
+	  any software.  If the sysctl option is enabled, a sysctl option with
+	  name "chroot_enforce_chdir" is created.
+
+config GRKERNSEC_CHROOT_CHMOD
+	bool "Deny (f)chmod +s"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to chmod
+	  or fchmod files to make them have suid or sgid bits.  This protects
+	  against another published method of breaking a chroot.  If the sysctl
+	  option is enabled, a sysctl option with name "chroot_deny_chmod" is
+	  created.
+
+config GRKERNSEC_CHROOT_FCHDIR
+	bool "Deny fchdir and fhandle out of chroot"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, a well-known method of breaking chroots by fchdir'ing
+	  to a file descriptor of the chrooting process that points to a directory
+	  outside the filesystem will be stopped.  This option also prevents use of
+	  the recently-created syscall for opening files by a guessable "file handle"
+	  inside a chroot, as well as accessing relative paths outside of a
+	  directory passed in via file descriptor with openat and similar syscalls.
+	  If the sysctl option is enabled, a sysctl option with name "chroot_deny_fchdir"
+	  is created.
+
+config GRKERNSEC_CHROOT_MKNOD
+	bool "Deny mknod"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be allowed to
+	  mknod.  The problem with using mknod inside a chroot is that it
+	  would allow an attacker to create a device entry that is the same
+	  as one on the physical root of your system, which could range from
+	  anything from the console device to a device for your harddrive (which
+	  they could then use to wipe the drive or steal data).  It is recommended
+	  that you say Y here, unless you run into software incompatibilities.
+	  If the sysctl option is enabled, a sysctl option with name
+	  "chroot_deny_mknod" is created.
+
+config GRKERNSEC_CHROOT_SHMAT
+	bool "Deny shmat() out of chroot"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to attach
+	  to shared memory segments that were created outside of the chroot jail.
+	  It is recommended that you say Y here.  If the sysctl option is enabled,
+	  a sysctl option with name "chroot_deny_shmat" is created.
+
+config GRKERNSEC_CHROOT_UNIX
+	bool "Deny access to abstract AF_UNIX sockets out of chroot"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to
+	  connect to abstract (meaning not belonging to a filesystem) Unix
+	  domain sockets that were bound outside of a chroot.  It is recommended
+	  that you say Y here.  If the sysctl option is enabled, a sysctl option
+	  with name "chroot_deny_unix" is created.
+
+config GRKERNSEC_CHROOT_FINDTASK
+	bool "Protect outside processes"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to
+	  kill, send signals with fcntl, ptrace, capget, getpgid, setpgid, 
+	  getsid, or view any process outside of the chroot.  If the sysctl
+	  option is enabled, a sysctl option with name "chroot_findtask" is
+	  created.
+
+config GRKERNSEC_CHROOT_NICE
+	bool "Restrict priority changes"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, processes inside a chroot will not be able to raise
+	  the priority of processes in the chroot, or alter the priority of
+	  processes outside the chroot.  This provides more security than simply
+	  removing CAP_SYS_NICE from the process' capability set.  If the
+	  sysctl option is enabled, a sysctl option with name "chroot_restrict_nice"
+	  is created.
+
+config GRKERNSEC_CHROOT_SYSCTL
+	bool "Deny sysctl writes"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, an attacker in a chroot will not be able to
+	  write to sysctl entries, either by sysctl(2) or through a /proc
+	  interface.  It is strongly recommended that you say Y here. If the
+	  sysctl option is enabled, a sysctl option with name
+	  "chroot_deny_sysctl" is created.
+
+config GRKERNSEC_CHROOT_RENAME
+	bool "Deny bad renames"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, an attacker in a chroot will not be able to
+	  abuse the ability to create double chroots to break out of the
+	  chroot by exploiting a race condition between a rename of a directory
+	  within a chroot against an open of a symlink with relative path
+	  components.  This feature will likewise prevent an accomplice outside
+	  a chroot from enabling a user inside the chroot to break out and make
+	  use of their credentials on the global filesystem.  Enabling this
+	  feature is essential to prevent root users from breaking out of a
+	  chroot. If the sysctl option is enabled, a sysctl option with name
+	  "chroot_deny_bad_rename" is created.
+
+config GRKERNSEC_CHROOT_CAPS
+	bool "Capability restrictions"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT
+	help
+	  If you say Y here, the capabilities on all processes within a
+	  chroot jail will be lowered to stop module insertion, raw i/o,
+	  system and net admin tasks, rebooting the system, modifying immutable
+	  files, modifying IPC owned by another, and changing the system time.
+	  This is left an option because it can break some apps.  Disable this
+	  if your chrooted apps are having problems performing those kinds of
+	  tasks.  If the sysctl option is enabled, a sysctl option with
+	  name "chroot_caps" is created.
+
+config GRKERNSEC_CHROOT_INITRD
+	bool "Exempt initrd tasks from restrictions"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_CHROOT && BLK_DEV_INITRD
+	help
+	  If you say Y here, tasks started prior to init will be exempted from
+	  grsecurity's chroot restrictions.  This option is mainly meant to
+	  resolve Plymouth's performing privileged operations unnecessarily
+	  in a chroot.
+
+endmenu
+menu "Kernel Auditing"
+depends on GRKERNSEC
+
+config GRKERNSEC_AUDIT_GROUP
+	bool "Single group for auditing"
+	help
+	  If you say Y here, the exec and chdir logging features will only operate
+	  on a group you specify.  This option is recommended if you only want to
+	  watch certain users instead of having a large amount of logs from the
+	  entire system.  If the sysctl option is enabled, a sysctl option with
+	  name "audit_group" is created.
+
+config GRKERNSEC_AUDIT_GID
+	int "GID for auditing"
+	depends on GRKERNSEC_AUDIT_GROUP
+	default 1007
+
+config GRKERNSEC_EXECLOG
+	bool "Exec logging"
+	help
+	  If you say Y here, all execve() calls will be logged (since the
+	  other exec*() calls are frontends to execve(), all execution
+	  will be logged).  Useful for shell-servers that like to keep track
+	  of their users.  If the sysctl option is enabled, a sysctl option with
+	  name "exec_logging" is created.
+	  WARNING: This option when enabled will produce a LOT of logs, especially
+	  on an active system.
+
+config GRKERNSEC_RESLOG
+	bool "Resource logging"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, all attempts to overstep resource limits will
+	  be logged with the resource name, the requested size, and the current
+	  limit.  It is highly recommended that you say Y here.  If the sysctl
+	  option is enabled, a sysctl option with name "resource_logging" is
+	  created.  If the RBAC system is enabled, the sysctl value is ignored.
+
+config GRKERNSEC_CHROOT_EXECLOG
+	bool "Log execs within chroot"
+	help
+	  If you say Y here, all executions inside a chroot jail will be logged
+	  to syslog.  This can cause a large amount of logs if certain
+	  applications (eg. djb's daemontools) are installed on the system, and
+	  is therefore left as an option.  If the sysctl option is enabled, a
+	  sysctl option with name "chroot_execlog" is created.
+
+config GRKERNSEC_AUDIT_PTRACE
+	bool "Ptrace logging"
+	help
+	  If you say Y here, all attempts to attach to a process via ptrace
+	  will be logged.  If the sysctl option is enabled, a sysctl option
+	  with name "audit_ptrace" is created.
+
+config GRKERNSEC_AUDIT_CHDIR
+	bool "Chdir logging"
+	help
+	  If you say Y here, all chdir() calls will be logged.  If the sysctl
+ 	  option is enabled, a sysctl option with name "audit_chdir" is created.
+
+config GRKERNSEC_AUDIT_MOUNT
+	bool "(Un)Mount logging"
+	help
+	  If you say Y here, all mounts and unmounts will be logged.  If the
+	  sysctl option is enabled, a sysctl option with name "audit_mount" is
+	  created.
+
+config GRKERNSEC_SIGNAL
+	bool "Signal logging"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, certain important signals will be logged, such as
+	  SIGSEGV, which will as a result inform you of when a error in a program
+	  occurred, which in some cases could mean a possible exploit attempt.
+	  If the sysctl option is enabled, a sysctl option with name
+	  "signal_logging" is created.
+
+config GRKERNSEC_FORKFAIL
+	bool "Fork failure logging"
+	help
+	  If you say Y here, all failed fork() attempts will be logged.
+	  This could suggest a fork bomb, or someone attempting to overstep
+	  their process limit.  If the sysctl option is enabled, a sysctl option
+	  with name "forkfail_logging" is created.
+
+config GRKERNSEC_TIME
+	bool "Time change logging"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, any changes of the system clock will be logged.
+	  If the sysctl option is enabled, a sysctl option with name
+	  "timechange_logging" is created.
+
+config GRKERNSEC_PROC_IPADDR
+	bool "/proc/<pid>/ipaddr support"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, a new entry will be added to each /proc/<pid>
+	  directory that contains the IP address of the person using the task.
+	  The IP is carried across local TCP and AF_UNIX stream sockets.
+	  This information can be useful for IDS/IPSes to perform remote response
+	  to a local attack.  The entry is readable by only the owner of the
+	  process (and root if he has CAP_DAC_OVERRIDE, which can be removed via
+	  the RBAC system), and thus does not create privacy concerns.
+
+config GRKERNSEC_RWXMAP_LOG
+	bool 'Denied RWX mmap/mprotect logging'
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on PAX_MPROTECT && !PAX_EMUPLT && !PAX_EMUSIGRT
+	help
+	  If you say Y here, calls to mmap() and mprotect() with explicit
+	  usage of PROT_WRITE and PROT_EXEC together will be logged when
+	  denied by the PAX_MPROTECT feature.  This feature will also
+	  log other problematic scenarios that can occur when PAX_MPROTECT
+	  is enabled on a binary, like textrels and PT_GNU_STACK.  If the 
+          sysctl option is enabled, a sysctl option with name "rwxmap_logging"
+	  is created.
+
+endmenu
+
+menu "Executable Protections"
+depends on GRKERNSEC
+
+config GRKERNSEC_DMESG
+	bool "Dmesg(8) restriction"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, non-root users will not be able to use dmesg(8)
+	  to view the contents of the kernel's circular log buffer.
+	  The kernel's log buffer often contains kernel addresses and other
+	  identifying information useful to an attacker in fingerprinting a
+	  system for a targeted exploit.
+	  If the sysctl option is enabled, a sysctl option with name "dmesg" is
+	  created.
+
+config GRKERNSEC_HARDEN_PTRACE
+	bool "Deter ptrace-based process snooping"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, TTY sniffers and other malicious monitoring
+	  programs implemented through ptrace will be defeated.  If you
+	  have been using the RBAC system, this option has already been
+	  enabled for several years for all users, with the ability to make
+	  fine-grained exceptions.
+
+	  This option only affects the ability of non-root users to ptrace
+	  processes that are not a descendent of the ptracing process.
+	  This means that strace ./binary and gdb ./binary will still work,
+	  but attaching to arbitrary processes will not.  If the sysctl
+	  option is enabled, a sysctl option with name "harden_ptrace" is
+	  created.
+
+config GRKERNSEC_PTRACE_READEXEC
+	bool "Require read access to ptrace sensitive binaries"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, unprivileged users will not be able to ptrace unreadable
+	  binaries.  This option is useful in environments that
+	  remove the read bits (e.g. file mode 4711) from suid binaries to
+	  prevent infoleaking of their contents.  This option adds
+	  consistency to the use of that file mode, as the binary could normally
+	  be read out when run without privileges while ptracing.
+
+	  If the sysctl option is enabled, a sysctl option with name "ptrace_readexec"
+	  is created.
+
+config GRKERNSEC_SETXID
+	bool "Enforce consistent multithreaded privileges"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on (X86 || SPARC64 || PPC || ARM || MIPS)
+	help
+	  If you say Y here, a change from a root uid to a non-root uid
+	  in a multithreaded application will cause the resulting uids,
+	  gids, supplementary groups, and capabilities in that thread
+	  to be propagated to the other threads of the process.  In most
+	  cases this is unnecessary, as glibc will emulate this behavior
+	  on behalf of the application.  Other libcs do not act in the
+	  same way, allowing the other threads of the process to continue
+	  running with root privileges.  If the sysctl option is enabled,
+	  a sysctl option with name "consistent_setxid" is created.
+
+config GRKERNSEC_HARDEN_IPC
+	bool "Disallow access to overly-permissive IPC objects"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on SYSVIPC
+	help
+	  If you say Y here, access to overly-permissive IPC objects (shared
+	  memory, message queues, and semaphores) will be denied for processes
+	  given the following criteria beyond normal permission checks:
+	  1) If the IPC object is world-accessible and the euid doesn't match
+	     that of the creator or current uid for the IPC object
+	  2) If the IPC object is group-accessible and the egid doesn't
+	     match that of the creator or current gid for the IPC object
+	  It's a common error to grant too much permission to these objects,
+	  with impact ranging from denial of service and information leaking to
+	  privilege escalation.  This feature was developed in response to
+	  research by Tim Brown:
+	  http://labs.portcullis.co.uk/whitepapers/memory-squatting-attacks-on-system-v-shared-memory/
+	  who found hundreds of such insecure usages.  Processes with
+	  CAP_IPC_OWNER are still permitted to access these IPC objects.
+	  If the sysctl option is enabled, a sysctl option with name
+	  "harden_ipc" is created.
+
+config GRKERNSEC_HARDEN_TTY
+	bool "Disallow unprivileged use of command injection"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, the ability to use the TIOCSTI ioctl for
+	  terminal command injection will be denied for unprivileged users.
+	  There are very few legitimate uses for this functionality and it
+	  has made vulnerabilities in several 'su'-like programs possible in
+	  the past.  Even without these vulnerabilities, it provides an
+	  attacker with an easy mechanism to move laterally among other
+	  processes within the same user's compromised session.
+	  By default, Linux allows unprivileged use of command injection as
+	  long as the injection is being performed into the same tty session.
+	  This feature makes that case the same as attempting to inject into
+	  another session, making any TIOCSTI use require CAP_SYS_ADMIN.
+	  If the sysctl option is enabled, a sysctl option with name
+	  "harden_tty" is created.
+
+config GRKERNSEC_TPE
+	bool "Trusted Path Execution (TPE)"
+	default y if GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_SERVER
+	help
+	  If you say Y here, you will be able to choose a gid to add to the
+	  supplementary groups of users you want to mark as "untrusted."
+	  These users will not be able to execute any files that are not in
+	  root-owned directories writable only by root.  If the sysctl option
+	  is enabled, a sysctl option with name "tpe" is created.
+
+config GRKERNSEC_TPE_ALL
+	bool "Partially restrict all non-root users"
+	depends on GRKERNSEC_TPE
+	help
+	  If you say Y here, all non-root users will be covered under
+	  a weaker TPE restriction.  This is separate from, and in addition to,
+	  the main TPE options that you have selected elsewhere.  Thus, if a
+	  "trusted" GID is chosen, this restriction applies to even that GID.
+	  Under this restriction, all non-root users will only be allowed to
+	  execute files in directories they own that are not group or
+	  world-writable, or in directories owned by root and writable only by
+	  root.  If the sysctl option is enabled, a sysctl option with name
+	  "tpe_restrict_all" is created.
+
+config GRKERNSEC_TPE_INVERT
+	bool "Invert GID option"
+	depends on GRKERNSEC_TPE
+	help
+	  If you say Y here, the group you specify in the TPE configuration will
+	  decide what group TPE restrictions will be *disabled* for.  This
+	  option is useful if you want TPE restrictions to be applied to most
+	  users on the system.  If the sysctl option is enabled, a sysctl option
+	  with name "tpe_invert" is created.  Unlike other sysctl options, this
+	  entry will default to on for backward-compatibility.
+
+config GRKERNSEC_TPE_GID
+	int
+	default GRKERNSEC_TPE_UNTRUSTED_GID if (GRKERNSEC_TPE && !GRKERNSEC_TPE_INVERT)
+	default GRKERNSEC_TPE_TRUSTED_GID if (GRKERNSEC_TPE && GRKERNSEC_TPE_INVERT)
+	
+config GRKERNSEC_TPE_UNTRUSTED_GID
+	int "GID for TPE-untrusted users"
+	depends on GRKERNSEC_TPE && !GRKERNSEC_TPE_INVERT
+	default 1005
+	help
+	  Setting this GID determines what group TPE restrictions will be
+	  *enabled* for.  If the sysctl option is enabled, a sysctl option
+	  with name "tpe_gid" is created.
+
+config GRKERNSEC_TPE_TRUSTED_GID
+	int "GID for TPE-trusted users"
+	depends on GRKERNSEC_TPE && GRKERNSEC_TPE_INVERT
+	default 1005
+	help
+	  Setting this GID determines what group TPE restrictions will be
+	  *disabled* for.  If the sysctl option is enabled, a sysctl option
+	  with name "tpe_gid" is created.
+
+endmenu
+menu "Network Protections"
+depends on GRKERNSEC
+
+config GRKERNSEC_BLACKHOLE
+	bool "TCP/UDP blackhole and LAST_ACK DoS prevention"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on NET
+	help
+	  If you say Y here, neither TCP resets nor ICMP
+	  destination-unreachable packets will be sent in response to packets
+	  sent to ports for which no associated listening process exists.
+	  It will also prevent the sending of ICMP protocol unreachable packets
+	  in response to packets with unknown protocols.
+	  This feature supports both IPV4 and IPV6 and exempts the 
+	  loopback interface from blackholing.  Enabling this feature 
+	  makes a host more resilient to DoS attacks and reduces network
+	  visibility against scanners.
+
+	  The blackhole feature as-implemented is equivalent to the FreeBSD
+	  blackhole feature, as it prevents RST responses to all packets, not
+	  just SYNs.  Under most application behavior this causes no
+	  problems, but applications (like haproxy) may not close certain
+	  connections in a way that cleanly terminates them on the remote
+	  end, leaving the remote host in LAST_ACK state.  Because of this
+	  side-effect and to prevent intentional LAST_ACK DoSes, this
+	  feature also adds automatic mitigation against such attacks.
+	  The mitigation drastically reduces the amount of time a socket
+	  can spend in LAST_ACK state.  If you're using haproxy and not
+	  all servers it connects to have this option enabled, consider
+	  disabling this feature on the haproxy host.
+
+	  If the sysctl option is enabled, two sysctl options with names
+	  "ip_blackhole" and "lastack_retries" will be created.
+	  While "ip_blackhole" takes the standard zero/non-zero on/off
+	  toggle, "lastack_retries" uses the same kinds of values as
+	  "tcp_retries1" and "tcp_retries2".  The default value of 4
+	  prevents a socket from lasting more than 45 seconds in LAST_ACK
+	  state.
+
+config GRKERNSEC_NO_SIMULT_CONNECT
+	bool "Disable TCP Simultaneous Connect"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on NET
+	help
+	  If you say Y here, a feature by Willy Tarreau will be enabled that
+	  removes a weakness in Linux's strict implementation of TCP that
+	  allows two clients to connect to each other without either entering
+	  a listening state.  The weakness allows an attacker to easily prevent
+	  a client from connecting to a known server provided the source port
+	  for the connection is guessed correctly.
+
+	  As the weakness could be used to prevent an antivirus or IPS from
+	  fetching updates, or prevent an SSL gateway from fetching a CRL,
+	  it should be eliminated by enabling this option.  Though Linux is
+	  one of few operating systems supporting simultaneous connect, it
+	  has no legitimate use in practice and is rarely supported by firewalls.
+	
+config GRKERNSEC_SOCKET
+	bool "Socket restrictions"
+	depends on NET
+	help
+	  If you say Y here, you will be able to choose from several options.
+	  If you assign a GID on your system and add it to the supplementary
+	  groups of users you want to restrict socket access to, this patch
+	  will perform up to three things, based on the option(s) you choose.
+
+config GRKERNSEC_SOCKET_ALL
+	bool "Deny any sockets to group"
+	depends on GRKERNSEC_SOCKET
+	help
+	  If you say Y here, you will be able to choose a GID of whose users will
+	  be unable to connect to other hosts from your machine or run server
+	  applications from your machine.  If the sysctl option is enabled, a
+	  sysctl option with name "socket_all" is created.
+
+config GRKERNSEC_SOCKET_ALL_GID
+	int "GID to deny all sockets for"
+	depends on GRKERNSEC_SOCKET_ALL
+	default 1004
+	help
+	  Here you can choose the GID to disable socket access for. Remember to
+	  add the users you want socket access disabled for to the GID
+	  specified here.  If the sysctl option is enabled, a sysctl option
+	  with name "socket_all_gid" is created.
+
+config GRKERNSEC_SOCKET_CLIENT
+	bool "Deny client sockets to group"
+	depends on GRKERNSEC_SOCKET
+	help
+	  If you say Y here, you will be able to choose a GID of whose users will
+	  be unable to connect to other hosts from your machine, but will be
+	  able to run servers.  If this option is enabled, all users in the group
+	  you specify will have to use passive mode when initiating ftp transfers
+	  from the shell on your machine.  If the sysctl option is enabled, a
+	  sysctl option with name "socket_client" is created.
+
+config GRKERNSEC_SOCKET_CLIENT_GID
+	int "GID to deny client sockets for"
+	depends on GRKERNSEC_SOCKET_CLIENT
+	default 1003
+	help
+	  Here you can choose the GID to disable client socket access for.
+	  Remember to add the users you want client socket access disabled for to
+	  the GID specified here.  If the sysctl option is enabled, a sysctl
+	  option with name "socket_client_gid" is created.
+
+config GRKERNSEC_SOCKET_SERVER
+	bool "Deny server sockets to group"
+	depends on GRKERNSEC_SOCKET
+	help
+	  If you say Y here, you will be able to choose a GID of whose users will
+	  be unable to run server applications from your machine.  If the sysctl
+	  option is enabled, a sysctl option with name "socket_server" is created.
+
+config GRKERNSEC_SOCKET_SERVER_GID
+	int "GID to deny server sockets for"
+	depends on GRKERNSEC_SOCKET_SERVER
+	default 1002
+	help
+	  Here you can choose the GID to disable server socket access for.
+	  Remember to add the users you want server socket access disabled for to
+	  the GID specified here.  If the sysctl option is enabled, a sysctl
+	  option with name "socket_server_gid" is created.
+
+endmenu
+
+menu "Physical Protections"
+depends on GRKERNSEC
+
+config GRKERNSEC_DENYUSB
+	bool "Deny new USB connections after toggle"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on SYSCTL && USB_SUPPORT
+	help
+	  If you say Y here, a new sysctl option with name "deny_new_usb"
+	  will be created.  Setting its value to 1 will prevent any new
+	  USB devices from being recognized by the OS.  Any attempted USB
+	  device insertion will be logged.  This option is intended to be
+	  used against custom USB devices designed to exploit vulnerabilities
+	  in various USB device drivers.
+
+	  For greatest effectiveness, this sysctl should be set after any
+	  relevant init scripts.  This option is safe to enable in distros
+	  as each user can choose whether or not to toggle the sysctl.
+
+config GRKERNSEC_DENYUSB_FORCE
+	bool "Reject all USB devices not connected at boot"
+	select USB
+	depends on GRKERNSEC_DENYUSB
+	help
+	  If you say Y here, a variant of GRKERNSEC_DENYUSB will be enabled
+	  that doesn't involve a sysctl entry.  This option should only be
+	  enabled if you're sure you want to deny all new USB connections
+	  at runtime and don't want to modify init scripts.  This should not
+	  be enabled by distros.  It forces the core USB code to be built
+	  into the kernel image so that all devices connected at boot time
+	  can be recognized and new USB device connections can be prevented
+	  prior to init running.
+
+endmenu
+
+menu "Sysctl Support"
+depends on GRKERNSEC && SYSCTL
+
+config GRKERNSEC_SYSCTL
+	bool "Sysctl support"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  If you say Y here, you will be able to change the options that
+	  grsecurity runs with at bootup, without having to recompile your
+	  kernel.  You can echo values to files in /proc/sys/kernel/grsecurity
+	  to enable (1) or disable (0) various features.  All the sysctl entries
+	  are mutable until the "grsec_lock" entry is set to a non-zero value.
+	  All features enabled in the kernel configuration are disabled at boot
+	  if you do not say Y to the "Turn on features by default" option.
+	  All options should be set at startup, and the grsec_lock entry should
+	  be set to a non-zero value after all the options are set.
+	  *THIS IS EXTREMELY IMPORTANT*
+
+config GRKERNSEC_SYSCTL_DISTRO
+	bool "Extra sysctl support for distro makers (READ HELP)"
+	depends on GRKERNSEC_SYSCTL && GRKERNSEC_IO
+	help
+	  If you say Y here, additional sysctl options will be created
+	  for features that affect processes running as root.  Therefore,
+	  it is critical when using this option that the grsec_lock entry be
+	  enabled after boot.  Only distros with prebuilt kernel packages
+	  with this option enabled that can ensure grsec_lock is enabled
+	  after boot should use this option.
+	  *Failure to set grsec_lock after boot makes all grsec features
+	  this option covers useless*
+
+	  Currently this option creates the following sysctl entries:
+	  "Disable Privileged I/O": "disable_priv_io"	
+
+config GRKERNSEC_SYSCTL_ON
+	bool "Turn on features by default"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC_SYSCTL
+	help
+	  If you say Y here, instead of having all features enabled in the
+	  kernel configuration disabled at boot time, the features will be
+	  enabled at boot time.  It is recommended you say Y here unless
+	  there is some reason you would want all sysctl-tunable features to
+	  be disabled by default.  As mentioned elsewhere, it is important
+	  to enable the grsec_lock entry once you have finished modifying
+	  the sysctl entries.
+
+endmenu
+menu "Logging Options"
+depends on GRKERNSEC
+
+config GRKERNSEC_FLOODTIME
+	int "Seconds in between log messages (minimum)"
+	default 10
+	help
+	  This option allows you to enforce the number of seconds between
+	  grsecurity log messages.  The default should be suitable for most
+	  people, however, if you choose to change it, choose a value small enough
+	  to allow informative logs to be produced, but large enough to
+	  prevent flooding.
+
+	  Setting both this value and GRKERNSEC_FLOODBURST to 0 will disable
+	  any rate limiting on grsecurity log messages.
+
+config GRKERNSEC_FLOODBURST
+	int "Number of messages in a burst (maximum)"
+	default 6
+	help
+	  This option allows you to choose the maximum number of messages allowed
+	  within the flood time interval you chose in a separate option.  The
+	  default should be suitable for most people, however if you find that
+	  many of your logs are being interpreted as flooding, you may want to
+	  raise this value.
+
+	  Setting both this value and GRKERNSEC_FLOODTIME to 0 will disable
+	  any rate limiting on grsecurity log messages.
+
+endmenu
diff --git b/grsecurity/Makefile b/grsecurity/Makefile
new file mode 100644
index 000000000..e136e5fd7
--- /dev/null
+++ b/grsecurity/Makefile
@@ -0,0 +1,54 @@
+# grsecurity - access control and security hardening for Linux
+# All code in this directory and various hooks located throughout the Linux kernel are
+# Copyright (C) 2001-2014 Bradley Spengler, Open Source Security, Inc.
+# http://www.grsecurity.net spender@grsecurity.net
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License version 2
+# as published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+
+KBUILD_CFLAGS += -Werror
+
+obj-y = grsec_chdir.o grsec_chroot.o grsec_exec.o grsec_fifo.o grsec_fork.o \
+	grsec_mount.o grsec_sig.o grsec_sysctl.o \
+	grsec_time.o grsec_tpe.o grsec_link.o grsec_pax.o grsec_ptrace.o \
+	grsec_usb.o grsec_ipc.o grsec_proc.o grsec_tty.o
+
+obj-$(CONFIG_GRKERNSEC) += grsec_init.o grsum.o gracl.o gracl_segv.o \
+	gracl_cap.o gracl_alloc.o gracl_shm.o grsec_mem.o gracl_fs.o \
+	gracl_learn.o grsec_log.o gracl_policy.o
+ifdef CONFIG_COMPAT
+obj-$(CONFIG_GRKERNSEC) += gracl_compat.o
+endif
+
+obj-$(CONFIG_GRKERNSEC_RESLOG) += gracl_res.o
+
+ifdef CONFIG_NET
+obj-y += grsec_sock.o
+obj-$(CONFIG_GRKERNSEC) += gracl_ip.o
+endif
+
+ifndef CONFIG_GRKERNSEC
+obj-y += grsec_disabled.o
+endif
+
+ifdef CONFIG_GRKERNSEC_HIDESYM
+extra-y := grsec_hidesym.o
+$(obj)/grsec_hidesym.o:
+	@-chmod -f 500 /boot
+	@-chmod -f 500 /lib/modules
+	@-chmod -f 500 /lib64/modules
+	@-chmod -f 500 /lib32/modules
+	@-chmod -f 700 .
+	@-chmod -f 700 $(objtree)
+	@echo '  grsec: protected kernel image paths'
+endif
diff --git b/grsecurity/gracl.c b/grsecurity/gracl.c
new file mode 100644
index 000000000..1bbe70eee
--- /dev/null
+++ b/grsecurity/gracl.c
@@ -0,0 +1,2773 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/namei.h>
+#include <linux/mount.h>
+#include <linux/tty.h>
+#include <linux/proc_fs.h>
+#include <linux/lglock.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <linux/types.h>
+#include <linux/sysctl.h>
+#include <linux/netdevice.h>
+#include <linux/ptrace.h>
+#include <linux/gracl.h>
+#include <linux/gralloc.h>
+#include <linux/security.h>
+#include <linux/grinternal.h>
+#include <linux/pid_namespace.h>
+#include <linux/stop_machine.h>
+#include <linux/fdtable.h>
+#include <linux/percpu.h>
+#include <linux/lglock.h>
+#include <linux/hugetlb.h>
+#include <linux/posix-timers.h>
+#include <linux/prefetch.h>
+#if defined(CONFIG_BTRFS_FS) || defined(CONFIG_BTRFS_FS_MODULE)
+#include <linux/magic.h>
+#include <linux/pagemap.h>
+#include "../fs/btrfs/async-thread.h"
+#include "../fs/btrfs/ctree.h"
+#include "../fs/btrfs/btrfs_inode.h"
+#endif
+#include "../fs/mount.h"
+
+#include <asm/uaccess.h>
+#include <asm/errno.h>
+#include <asm/mman.h>
+
+#define FOR_EACH_ROLE_START(role) \
+	role = running_polstate.role_list; \
+	while (role) {
+
+#define FOR_EACH_ROLE_END(role) \
+		role = role->prev; \
+	}
+
+extern struct path gr_real_root;
+
+static struct gr_policy_state running_polstate;
+struct gr_policy_state *polstate = &running_polstate;
+extern struct gr_alloc_state *current_alloc_state;
+
+extern char *gr_shared_page[4];
+DEFINE_RWLOCK(gr_inode_lock);
+
+static unsigned int gr_status __read_only = GR_STATUS_INIT;
+
+#ifdef CONFIG_NET
+extern struct vfsmount *sock_mnt;
+#endif
+
+extern struct vfsmount *pipe_mnt;
+extern struct vfsmount *shm_mnt;
+
+#ifdef CONFIG_HUGETLBFS
+extern struct vfsmount *hugetlbfs_vfsmount[HUGE_MAX_HSTATE];
+#endif
+
+extern u16 acl_sp_role_value;
+extern struct acl_object_label *fakefs_obj_rw;
+extern struct acl_object_label *fakefs_obj_rwx;
+
+int gr_acl_is_enabled(void)
+{
+	return (gr_status & GR_READY);
+}
+
+void gr_enable_rbac_system(void)
+{
+	pax_open_kernel();
+	gr_status |= GR_READY;
+	pax_close_kernel();
+}
+
+int gr_rbac_disable(void *unused)
+{
+	pax_open_kernel();
+	gr_status &= ~GR_READY;
+	pax_close_kernel();
+
+	return 0;
+}
+
+static inline dev_t __get_dev(const struct dentry *dentry)
+{
+	struct dentry *ldentry = d_backing_dentry((struct dentry *)dentry);
+
+#if defined(CONFIG_BTRFS_FS) || defined(CONFIG_BTRFS_FS_MODULE)
+	if (ldentry->d_sb->s_magic == BTRFS_SUPER_MAGIC)
+		return BTRFS_I(d_inode(ldentry))->root->anon_dev;
+	else
+#endif
+		return d_inode(ldentry)->i_sb->s_dev;
+}
+
+static inline u64 __get_ino(const struct dentry *dentry)
+{
+	struct dentry *ldentry = d_backing_dentry((struct dentry *)dentry);
+
+#if defined(CONFIG_BTRFS_FS) || defined(CONFIG_BTRFS_FS_MODULE)
+	if (ldentry->d_sb->s_magic == BTRFS_SUPER_MAGIC)
+		return btrfs_ino(d_inode(dentry));
+	else
+#endif
+		return d_inode(ldentry)->i_ino;
+}
+
+dev_t gr_get_dev_from_dentry(struct dentry *dentry)
+{
+	return __get_dev(dentry);
+}
+
+u64 gr_get_ino_from_dentry(struct dentry *dentry)
+{
+	return __get_ino(dentry);
+}
+
+static char gr_task_roletype_to_char(struct task_struct *task)
+{
+	switch (task->role->roletype &
+		(GR_ROLE_DEFAULT | GR_ROLE_USER | GR_ROLE_GROUP |
+		 GR_ROLE_SPECIAL)) {
+	case GR_ROLE_DEFAULT:
+		return 'D';
+	case GR_ROLE_USER:
+		return 'U';
+	case GR_ROLE_GROUP:
+		return 'G';
+	case GR_ROLE_SPECIAL:
+		return 'S';
+	}
+
+	return 'X';
+}
+
+char gr_roletype_to_char(void)
+{
+	return gr_task_roletype_to_char(current);
+}
+
+int
+gr_acl_tpe_check(void)
+{
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+	if (current->role->roletype & GR_ROLE_TPE)
+		return 1;
+	else
+		return 0;
+}
+
+int
+gr_handle_rawio(const struct inode *inode)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_CAPS
+	if (inode && (S_ISBLK(inode->i_mode) || (S_ISCHR(inode->i_mode) && imajor(inode) == RAW_MAJOR)) &&
+	    grsec_enable_chroot_caps && proc_is_chrooted(current) &&
+	    !capable(CAP_SYS_RAWIO))
+		return 1;
+#endif
+	return 0;
+}
+
+int
+gr_streq(const char *a, const char *b, const unsigned int lena, const unsigned int lenb)
+{
+	if (likely(lena != lenb))
+		return 0;
+
+	return !memcmp(a, b, lena);
+}
+
+static int prepend(char **buffer, int *buflen, const char *str, int namelen)
+{
+	*buflen -= namelen;
+	if (*buflen < 0)
+		return -ENAMETOOLONG;
+	*buffer -= namelen;
+	memcpy(*buffer, str, namelen);
+	return 0;
+}
+
+static int prepend_name(char **buffer, int *buflen, struct qstr *name)
+{
+	return prepend(buffer, buflen, (const char *)name->name, name->len);
+}
+
+static int prepend_path(const struct path *path, struct path *root,
+			char **buffer, int *buflen)
+{
+	struct dentry *dentry = path->dentry;
+	struct vfsmount *vfsmnt = path->mnt;
+	struct mount *mnt = real_mount(vfsmnt);
+	bool slash = false;
+	int error = 0;
+
+	while (dentry != root->dentry || vfsmnt != root->mnt) {
+		struct dentry * parent;
+
+		if (dentry == vfsmnt->mnt_root || IS_ROOT(dentry)) {
+			/* Global root? */
+			if (!mnt_has_parent(mnt)) {
+				goto out;
+			}
+			dentry = mnt->mnt_mountpoint;
+			mnt = mnt->mnt_parent;
+			vfsmnt = &mnt->mnt;
+			continue;
+		}
+		parent = dentry->d_parent;
+		prefetch(parent);
+		spin_lock(&dentry->d_lock);
+		error = prepend_name(buffer, buflen, &dentry->d_name);
+		spin_unlock(&dentry->d_lock);
+		if (!error)
+			error = prepend(buffer, buflen, "/", 1);
+		if (error)
+			break;
+
+		slash = true;
+		dentry = parent;
+	}
+
+out:
+	if (!error && !slash)
+		error = prepend(buffer, buflen, "/", 1);
+
+	return error;
+}
+
+/* this must be called with mount_lock and rename_lock held */
+
+static char *__our_d_path(const struct path *path, struct path *root,
+			char *buf, int buflen)
+{
+	char *res = buf + buflen;
+	int error;
+
+	prepend(&res, &buflen, "\0", 1);
+	error = prepend_path(path, root, &res, &buflen);
+	if (error)
+		return ERR_PTR(error);
+
+	return res;
+}
+
+static char *
+gen_full_path(struct path *path, struct path *root, char *buf, int buflen)
+{
+	char *retval;
+
+	retval = __our_d_path(path, root, buf, buflen);
+	if (unlikely(IS_ERR(retval)))
+		retval = strcpy(buf, "<path too long>");
+	else if (unlikely(retval[1] == '/' && retval[2] == '\0'))
+		retval[1] = '\0';
+
+	return retval;
+}
+
+static char *
+__d_real_path(const struct dentry *dentry, const struct vfsmount *vfsmnt,
+		char *buf, int buflen)
+{
+	struct path path;
+	char *res;
+
+	path.dentry = (struct dentry *)dentry;
+	path.mnt = (struct vfsmount *)vfsmnt;
+
+	/* we can use gr_real_root.dentry, gr_real_root.mnt, because this is only called
+	   by the RBAC system */
+	res = gen_full_path(&path, &gr_real_root, buf, buflen);
+
+	return res;
+}
+
+static char *
+d_real_path(const struct dentry *dentry, const struct vfsmount *vfsmnt,
+	    char *buf, int buflen)
+{
+	char *res;
+	struct path path;
+	struct path root;
+	struct task_struct *reaper = init_pid_ns.child_reaper;
+
+	path.dentry = (struct dentry *)dentry;
+	path.mnt = (struct vfsmount *)vfsmnt;
+
+	/* we can't use gr_real_root.dentry, gr_real_root.mnt, because they belong only to the RBAC system */
+	get_fs_root(reaper->fs, &root);
+
+	read_seqlock_excl(&mount_lock);
+	write_seqlock(&rename_lock);
+	res = gen_full_path(&path, &root, buf, buflen);
+	write_sequnlock(&rename_lock);
+	read_sequnlock_excl(&mount_lock);
+
+	path_put(&root);
+	return res;
+}
+
+char *
+gr_to_filename_rbac(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	char *ret;
+	read_seqlock_excl(&mount_lock);
+	write_seqlock(&rename_lock);
+	ret = __d_real_path(dentry, mnt, per_cpu_ptr(gr_shared_page[0],smp_processor_id()),
+			     PAGE_SIZE);
+	write_sequnlock(&rename_lock);
+	read_sequnlock_excl(&mount_lock);
+	return ret;
+}
+
+static char *
+gr_to_proc_filename_rbac(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	char *ret;
+	char *buf;
+	int buflen;
+
+	read_seqlock_excl(&mount_lock);
+	write_seqlock(&rename_lock);
+	buf = per_cpu_ptr(gr_shared_page[0], smp_processor_id());
+	ret = __d_real_path(dentry, mnt, buf, PAGE_SIZE - 6);
+	buflen = (int)(ret - buf);
+	if (buflen >= 5)
+		prepend(&ret, &buflen, "/proc", 5);
+	else
+		ret = strcpy(buf, "<path too long>");
+	write_sequnlock(&rename_lock);
+	read_sequnlock_excl(&mount_lock);
+	return ret;
+}
+
+char *
+gr_to_filename_nolock(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return __d_real_path(dentry, mnt, per_cpu_ptr(gr_shared_page[0],smp_processor_id()),
+			     PAGE_SIZE);
+}
+
+char *
+gr_to_filename(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return d_real_path(dentry, mnt, per_cpu_ptr(gr_shared_page[0], smp_processor_id()),
+			   PAGE_SIZE);
+}
+
+char *
+gr_to_filename1(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return d_real_path(dentry, mnt, per_cpu_ptr(gr_shared_page[1], smp_processor_id()),
+			   PAGE_SIZE);
+}
+
+char *
+gr_to_filename2(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return d_real_path(dentry, mnt, per_cpu_ptr(gr_shared_page[2], smp_processor_id()),
+			   PAGE_SIZE);
+}
+
+char *
+gr_to_filename3(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return d_real_path(dentry, mnt, per_cpu_ptr(gr_shared_page[3], smp_processor_id()),
+			   PAGE_SIZE);
+}
+
+__u32
+to_gr_audit(const __u32 reqmode)
+{
+	/* masks off auditable permission flags, then shifts them to create
+	   auditing flags, and adds the special case of append auditing if
+	   we're requesting write */
+	return (((reqmode & ~GR_AUDITS) << 10) | ((reqmode & GR_WRITE) ? GR_AUDIT_APPEND : 0));
+}
+
+struct acl_role_label *
+__lookup_acl_role_label(const struct gr_policy_state *state, const struct task_struct *task, const uid_t uid,
+		      const gid_t gid)
+{
+	unsigned int index = gr_rhash(uid, GR_ROLE_USER, state->acl_role_set.r_size);
+	struct acl_role_label *match;
+	struct role_allowed_ip *ipp;
+	unsigned int x;
+	u32 curr_ip = task->signal->saved_ip;
+
+	match = state->acl_role_set.r_hash[index];
+
+	while (match) {
+		if ((match->roletype & (GR_ROLE_DOMAIN | GR_ROLE_USER)) == (GR_ROLE_DOMAIN | GR_ROLE_USER)) {
+			for (x = 0; x < match->domain_child_num; x++) {
+				if (match->domain_children[x] == uid)
+					goto found;
+			}
+		} else if (match->uidgid == uid && match->roletype & GR_ROLE_USER)
+			break;
+		match = match->next;
+	}
+found:
+	if (match == NULL) {
+	      try_group:
+		index = gr_rhash(gid, GR_ROLE_GROUP, state->acl_role_set.r_size);
+		match = state->acl_role_set.r_hash[index];
+
+		while (match) {
+			if ((match->roletype & (GR_ROLE_DOMAIN | GR_ROLE_GROUP)) == (GR_ROLE_DOMAIN | GR_ROLE_GROUP)) {
+				for (x = 0; x < match->domain_child_num; x++) {
+					if (match->domain_children[x] == gid)
+						goto found2;
+				}
+			} else if (match->uidgid == gid && match->roletype & GR_ROLE_GROUP)
+				break;
+			match = match->next;
+		}
+found2:
+		if (match == NULL)
+			match = state->default_role;
+		if (match->allowed_ips == NULL)
+			return match;
+		else {
+			for (ipp = match->allowed_ips; ipp; ipp = ipp->next) {
+				if (likely
+				    ((ntohl(curr_ip) & ipp->netmask) ==
+				     (ntohl(ipp->addr) & ipp->netmask)))
+					return match;
+			}
+			match = state->default_role;
+		}
+	} else if (match->allowed_ips == NULL) {
+		return match;
+	} else {
+		for (ipp = match->allowed_ips; ipp; ipp = ipp->next) {
+			if (likely
+			    ((ntohl(curr_ip) & ipp->netmask) ==
+			     (ntohl(ipp->addr) & ipp->netmask)))
+				return match;
+		}
+		goto try_group;
+	}
+
+	return match;
+}
+
+static struct acl_role_label *
+lookup_acl_role_label(const struct task_struct *task, const uid_t uid,
+		      const gid_t gid)
+{
+	return __lookup_acl_role_label(&running_polstate, task, uid, gid);
+}
+
+struct acl_subject_label *
+lookup_acl_subj_label(const u64 ino, const dev_t dev,
+		      const struct acl_role_label *role)
+{
+	unsigned int index = gr_fhash(ino, dev, role->subj_hash_size);
+	struct acl_subject_label *match;
+
+	match = role->subj_hash[index];
+
+	while (match && (match->inode != ino || match->device != dev ||
+	       (match->mode & GR_DELETED))) {
+		match = match->next;
+	}
+
+	if (match && !(match->mode & GR_DELETED))
+		return match;
+	else
+		return NULL;
+}
+
+struct acl_subject_label *
+lookup_acl_subj_label_deleted(const u64 ino, const dev_t dev,
+			  const struct acl_role_label *role)
+{
+	unsigned int index = gr_fhash(ino, dev, role->subj_hash_size);
+	struct acl_subject_label *match;
+
+	match = role->subj_hash[index];
+
+	while (match && (match->inode != ino || match->device != dev ||
+	       !(match->mode & GR_DELETED))) {
+		match = match->next;
+	}
+
+	if (match && (match->mode & GR_DELETED))
+		return match;
+	else
+		return NULL;
+}
+
+static struct acl_object_label *
+lookup_acl_obj_label(const u64 ino, const dev_t dev,
+		     const struct acl_subject_label *subj)
+{
+	unsigned int index = gr_fhash(ino, dev, subj->obj_hash_size);
+	struct acl_object_label *match;
+
+	match = subj->obj_hash[index];
+
+	while (match && (match->inode != ino || match->device != dev ||
+	       (match->mode & GR_DELETED))) {
+		match = match->next;
+	}
+
+	if (match && !(match->mode & GR_DELETED))
+		return match;
+	else
+		return NULL;
+}
+
+static struct acl_object_label *
+lookup_acl_obj_label_create(const u64 ino, const dev_t dev,
+		     const struct acl_subject_label *subj)
+{
+	unsigned int index = gr_fhash(ino, dev, subj->obj_hash_size);
+	struct acl_object_label *match;
+
+	match = subj->obj_hash[index];
+
+	while (match && (match->inode != ino || match->device != dev ||
+	       !(match->mode & GR_DELETED))) {
+		match = match->next;
+	}
+
+	if (match && (match->mode & GR_DELETED))
+		return match;
+
+	match = subj->obj_hash[index];
+
+	while (match && (match->inode != ino || match->device != dev ||
+	       (match->mode & GR_DELETED))) {
+		match = match->next;
+	}
+
+	if (match && !(match->mode & GR_DELETED))
+		return match;
+	else
+		return NULL;
+}
+
+struct name_entry *
+__lookup_name_entry(const struct gr_policy_state *state, const char *name)
+{
+	unsigned int len = strlen(name);
+	unsigned int key = full_name_hash(NULL, (const unsigned char *)name, len);
+	unsigned int index = key % state->name_set.n_size;
+	struct name_entry *match;
+
+	match = state->name_set.n_hash[index];
+
+	while (match && (match->key != key || !gr_streq(match->name, name, match->len, len)))
+		match = match->next;
+
+	return match;
+}
+
+static struct name_entry *
+lookup_name_entry(const char *name)
+{
+	return __lookup_name_entry(&running_polstate, name);
+}
+
+static struct name_entry *
+lookup_name_entry_create(const char *name)
+{
+	unsigned int len = strlen(name);
+	unsigned int key = full_name_hash(NULL, (const unsigned char *)name, len);
+	unsigned int index = key % running_polstate.name_set.n_size;
+	struct name_entry *match;
+
+	match = running_polstate.name_set.n_hash[index];
+
+	while (match && (match->key != key || !gr_streq(match->name, name, match->len, len) ||
+			 !match->deleted))
+		match = match->next;
+
+	if (match && match->deleted)
+		return match;
+
+	match = running_polstate.name_set.n_hash[index];
+
+	while (match && (match->key != key || !gr_streq(match->name, name, match->len, len) ||
+			 match->deleted))
+		match = match->next;
+
+	if (match && !match->deleted)
+		return match;
+	else
+		return NULL;
+}
+
+static struct inodev_entry *
+lookup_inodev_entry(const u64 ino, const dev_t dev)
+{
+	unsigned int index = gr_fhash(ino, dev, running_polstate.inodev_set.i_size);
+	struct inodev_entry *match;
+
+	match = running_polstate.inodev_set.i_hash[index];
+
+	while (match && (match->nentry->inode != ino || match->nentry->device != dev))
+		match = match->next;
+
+	return match;
+}
+
+void
+__insert_inodev_entry(const struct gr_policy_state *state, struct inodev_entry *entry)
+{
+	unsigned int index = gr_fhash(entry->nentry->inode, entry->nentry->device,
+				    state->inodev_set.i_size);
+	struct inodev_entry **curr;
+
+	entry->prev = NULL;
+
+	curr = &state->inodev_set.i_hash[index];
+	if (*curr != NULL)
+		(*curr)->prev = entry;
+	
+	entry->next = *curr;
+	*curr = entry;
+
+	return;
+}
+
+static void
+insert_inodev_entry(struct inodev_entry *entry)
+{
+	__insert_inodev_entry(&running_polstate, entry);
+}
+
+void
+insert_acl_obj_label(struct acl_object_label *obj,
+		     struct acl_subject_label *subj)
+{
+	unsigned int index =
+	    gr_fhash(obj->inode, obj->device, subj->obj_hash_size);
+	struct acl_object_label **curr;
+
+	obj->prev = NULL;
+
+	curr = &subj->obj_hash[index];
+	if (*curr != NULL)
+		(*curr)->prev = obj;
+
+	obj->next = *curr;
+	*curr = obj;
+
+	return;
+}
+
+void
+insert_acl_subj_label(struct acl_subject_label *obj,
+		      struct acl_role_label *role)
+{
+	unsigned int index = gr_fhash(obj->inode, obj->device, role->subj_hash_size);
+	struct acl_subject_label **curr;
+
+	obj->prev = NULL;
+
+	curr = &role->subj_hash[index];
+	if (*curr != NULL)
+		(*curr)->prev = obj;
+
+	obj->next = *curr;
+	*curr = obj;
+
+	return;
+}
+
+/* derived from glibc fnmatch() 0: match, 1: no match*/
+
+static int
+glob_match(const char *p, const char *n)
+{
+	char c;
+
+	while ((c = *p++) != '\0') {
+	switch (c) {
+		case '?':
+			if (*n == '\0')
+				return 1;
+			else if (*n == '/')
+				return 1;
+			break;
+		case '\\':
+			if (*n != c)
+				return 1;
+			break;
+		case '*':
+			for (c = *p++; c == '?' || c == '*'; c = *p++) {
+				if (*n == '/')
+					return 1;
+				else if (c == '?') {
+					if (*n == '\0')
+						return 1;
+					else
+						++n;
+				}
+			}
+			if (c == '\0') {
+				return 0;
+			} else {
+				const char *endp;
+
+				if ((endp = strchr(n, '/')) == NULL)
+					endp = n + strlen(n);
+
+				if (c == '[') {
+					for (--p; n < endp; ++n)
+						if (!glob_match(p, n))
+							return 0;
+				} else if (c == '/') {
+					while (*n != '\0' && *n != '/')
+						++n;
+					if (*n == '/' && !glob_match(p, n + 1))
+						return 0;
+				} else {
+					for (--p; n < endp; ++n)
+						if (*n == c && !glob_match(p, n))
+							return 0;
+				}
+
+				return 1;
+			}
+		case '[':
+			{
+			int not;
+			char cold;
+
+			if (*n == '\0' || *n == '/')
+				return 1;
+
+			not = (*p == '!' || *p == '^');
+			if (not)
+				++p;
+
+			c = *p++;
+			for (;;) {
+				unsigned char fn = (unsigned char)*n;
+
+				if (c == '\0')
+					return 1;
+				else {
+					if (c == fn)
+						goto matched;
+					cold = c;
+					c = *p++;
+
+					if (c == '-' && *p != ']') {
+						unsigned char cend = *p++;
+
+						if (cend == '\0')
+							return 1;
+
+						if (cold <= fn && fn <= cend)
+							goto matched;
+
+						c = *p++;
+					}
+				}
+
+				if (c == ']')
+					break;
+			}
+			if (!not)
+				return 1;
+			break;
+		matched:
+			while (c != ']') {
+				if (c == '\0')
+					return 1;
+
+				c = *p++;
+			}
+			if (not)
+				return 1;
+		}
+		break;
+	default:
+		if (c != *n)
+			return 1;
+	}
+
+	++n;
+	}
+
+	if (*n == '\0')
+		return 0;
+
+	if (*n == '/')
+		return 0;
+
+	return 1;
+}
+
+static struct acl_object_label *
+chk_glob_label(struct acl_object_label *globbed,
+	const struct dentry *dentry, const struct vfsmount *mnt, char **path)
+{
+	struct acl_object_label *tmp;
+
+	if (*path == NULL)
+		*path = gr_to_filename_nolock(dentry, mnt);
+
+	tmp = globbed;
+
+	while (tmp) {
+		if (!glob_match(tmp->filename, *path))
+			return tmp;
+		tmp = tmp->next;
+	}
+
+	return NULL;
+}
+
+static struct acl_object_label *
+__full_lookup(const struct dentry *orig_dentry, const struct vfsmount *orig_mnt,
+	    const u64 curr_ino, const dev_t curr_dev,
+	    const struct acl_subject_label *subj, char **path, const int checkglob)
+{
+	struct acl_subject_label *tmpsubj;
+	struct acl_object_label *retval;
+	struct acl_object_label *retval2;
+
+	tmpsubj = (struct acl_subject_label *) subj;
+	read_lock(&gr_inode_lock);
+	do {
+		retval = lookup_acl_obj_label(curr_ino, curr_dev, tmpsubj);
+		if (retval) {
+			if (checkglob && retval->globbed) {
+				retval2 = chk_glob_label(retval->globbed, orig_dentry, orig_mnt, path);
+				if (retval2)
+					retval = retval2;
+			}
+			break;
+		}
+	} while ((tmpsubj = tmpsubj->parent_subject));
+	read_unlock(&gr_inode_lock);
+
+	return retval;
+}
+
+static struct acl_object_label *
+full_lookup(const struct dentry *orig_dentry, const struct vfsmount *orig_mnt,
+	    struct dentry *curr_dentry,
+	    const struct acl_subject_label *subj, char **path, const int checkglob)
+{
+	int newglob = checkglob;
+	u64 inode;
+	dev_t device;
+
+	/* if we aren't checking a subdirectory of the original path yet, don't do glob checking
+	   as we don't want a / * rule to match instead of the / object
+	   don't do this for create lookups that call this function though, since they're looking up
+	   on the parent and thus need globbing checks on all paths
+	*/
+	if (orig_dentry == curr_dentry && newglob != GR_CREATE_GLOB)
+		newglob = GR_NO_GLOB;
+
+	spin_lock(&curr_dentry->d_lock);
+	inode = __get_ino(curr_dentry);
+	device = __get_dev(curr_dentry);
+	spin_unlock(&curr_dentry->d_lock);
+
+	return __full_lookup(orig_dentry, orig_mnt, inode, device, subj, path, newglob);
+}
+
+#ifdef CONFIG_HUGETLBFS
+static inline bool
+is_hugetlbfs_mnt(const struct vfsmount *mnt)
+{
+	int i;
+	for (i = 0; i < HUGE_MAX_HSTATE; i++) {
+		if (unlikely(hugetlbfs_vfsmount[i] == mnt))
+			return true;
+	}
+
+	return false;
+}
+#endif
+
+static struct acl_object_label *
+__chk_obj_label(const struct dentry *l_dentry, const struct vfsmount *l_mnt,
+	      const struct acl_subject_label *subj, char *path, const int checkglob)
+{
+	struct dentry *dentry = (struct dentry *) l_dentry;
+	struct vfsmount *mnt = (struct vfsmount *) l_mnt;
+	struct inode * inode = d_backing_inode(dentry);
+	struct mount *real_mnt = real_mount(mnt);
+	struct acl_object_label *retval;
+	struct dentry *parent;
+
+	read_seqlock_excl(&mount_lock);
+	write_seqlock(&rename_lock);
+
+	if (unlikely((mnt == shm_mnt && inode->i_nlink == 0) || mnt == pipe_mnt ||
+#ifdef CONFIG_NET
+	    mnt == sock_mnt ||
+#endif
+#ifdef CONFIG_HUGETLBFS
+	    (is_hugetlbfs_mnt(mnt) && inode->i_nlink == 0) ||
+#endif
+		/* ignore Eric Biederman */
+	    IS_PRIVATE(inode))) {
+		retval = (subj->mode & GR_SHMEXEC) ? fakefs_obj_rwx : fakefs_obj_rw;
+		goto out;
+	}
+
+	for (;;) {
+		if (dentry == gr_real_root.dentry && mnt == gr_real_root.mnt)
+			break;
+
+		if (dentry == mnt->mnt_root || IS_ROOT(dentry)) {
+			if (!mnt_has_parent(real_mnt))
+				break;
+
+			retval = full_lookup(l_dentry, l_mnt, dentry, subj, &path, checkglob);
+			if (retval != NULL)
+				goto out;
+
+			dentry = real_mnt->mnt_mountpoint;
+			real_mnt = real_mnt->mnt_parent;
+			mnt = &real_mnt->mnt;
+			continue;
+		}
+
+		parent = dentry->d_parent;
+		retval = full_lookup(l_dentry, l_mnt, dentry, subj, &path, checkglob);
+		if (retval != NULL)
+			goto out;
+
+		dentry = parent;
+	}
+
+	retval = full_lookup(l_dentry, l_mnt, dentry, subj, &path, checkglob);
+
+	/* gr_real_root is pinned so we don't have to hold a reference */
+	if (retval == NULL)
+		retval = full_lookup(l_dentry, l_mnt, gr_real_root.dentry, subj, &path, checkglob);
+out:
+	write_sequnlock(&rename_lock);
+	read_sequnlock_excl(&mount_lock);
+
+	BUG_ON(retval == NULL);
+
+	return retval;
+}
+
+static struct acl_object_label *
+chk_obj_label(const struct dentry *l_dentry, const struct vfsmount *l_mnt,
+	      const struct acl_subject_label *subj)
+{
+	char *path = NULL;
+	return __chk_obj_label(l_dentry, l_mnt, subj, path, GR_REG_GLOB);
+}
+
+static struct acl_object_label *
+chk_obj_label_noglob(const struct dentry *l_dentry, const struct vfsmount *l_mnt,
+	      const struct acl_subject_label *subj)
+{
+	char *path = NULL;
+	return __chk_obj_label(l_dentry, l_mnt, subj, path, GR_NO_GLOB);
+}
+
+static struct acl_object_label *
+chk_obj_create_label(const struct dentry *l_dentry, const struct vfsmount *l_mnt,
+		     const struct acl_subject_label *subj, char *path)
+{
+	return __chk_obj_label(l_dentry, l_mnt, subj, path, GR_CREATE_GLOB);
+}
+
+struct acl_subject_label *
+chk_subj_label(const struct dentry *l_dentry, const struct vfsmount *l_mnt,
+	       const struct acl_role_label *role)
+{
+	struct dentry *dentry = (struct dentry *) l_dentry;
+	struct vfsmount *mnt = (struct vfsmount *) l_mnt;
+	struct mount *real_mnt = real_mount(mnt);
+	struct acl_subject_label *retval;
+	struct dentry *parent;
+
+	read_seqlock_excl(&mount_lock);
+	write_seqlock(&rename_lock);
+
+	for (;;) {
+		if (dentry == gr_real_root.dentry && mnt == gr_real_root.mnt)
+			break;
+		if (dentry == mnt->mnt_root || IS_ROOT(dentry)) {
+			if (!mnt_has_parent(real_mnt))
+				break;
+
+			spin_lock(&dentry->d_lock);
+			read_lock(&gr_inode_lock);
+			retval =
+				lookup_acl_subj_label(__get_ino(dentry),
+						__get_dev(dentry), role);
+			read_unlock(&gr_inode_lock);
+			spin_unlock(&dentry->d_lock);
+			if (retval != NULL)
+				goto out;
+
+			dentry = real_mnt->mnt_mountpoint;
+			real_mnt = real_mnt->mnt_parent;
+			mnt = &real_mnt->mnt;
+			continue;
+		}
+
+		spin_lock(&dentry->d_lock);
+		read_lock(&gr_inode_lock);
+		retval = lookup_acl_subj_label(__get_ino(dentry),
+					  __get_dev(dentry), role);
+		read_unlock(&gr_inode_lock);
+		parent = dentry->d_parent;
+		spin_unlock(&dentry->d_lock);
+
+		if (retval != NULL)
+			goto out;
+
+		dentry = parent;
+	}
+
+	spin_lock(&dentry->d_lock);
+	read_lock(&gr_inode_lock);
+	retval = lookup_acl_subj_label(__get_ino(dentry),
+				  __get_dev(dentry), role);
+	read_unlock(&gr_inode_lock);
+	spin_unlock(&dentry->d_lock);
+
+	if (unlikely(retval == NULL)) {
+		/* gr_real_root is pinned, we don't need to hold a reference */
+		read_lock(&gr_inode_lock);
+		retval = lookup_acl_subj_label(__get_ino(gr_real_root.dentry),
+					  __get_dev(gr_real_root.dentry), role);
+		read_unlock(&gr_inode_lock);
+	}
+out:
+	write_sequnlock(&rename_lock);
+	read_sequnlock_excl(&mount_lock);
+
+	BUG_ON(retval == NULL);
+
+	return retval;
+}
+
+void
+assign_special_role(const char *rolename)
+{
+	struct acl_object_label *obj;
+	struct acl_role_label *r;
+	struct acl_role_label *assigned = NULL;
+	struct task_struct *tsk;
+	struct file *filp;
+
+	FOR_EACH_ROLE_START(r)
+		if (!strcmp(rolename, r->rolename) &&
+		    (r->roletype & GR_ROLE_SPECIAL)) {
+			assigned = r;
+			break;
+		}
+	FOR_EACH_ROLE_END(r)
+
+	if (!assigned)
+		return;
+
+	read_lock(&tasklist_lock);
+	read_lock(&grsec_exec_file_lock);
+
+	tsk = current->real_parent;
+	if (tsk == NULL)
+		goto out_unlock;
+
+	filp = tsk->exec_file;
+	if (filp == NULL)
+		goto out_unlock;
+
+	tsk->is_writable = 0;
+	tsk->inherited = 0;
+
+	tsk->acl_sp_role = 1;
+	tsk->acl_role_id = ++acl_sp_role_value;
+	tsk->role = assigned;
+	tsk->acl = chk_subj_label(filp->f_path.dentry, filp->f_path.mnt, tsk->role);
+
+	/* ignore additional mmap checks for processes that are writable
+	   by the default ACL */
+	obj = chk_obj_label(filp->f_path.dentry, filp->f_path.mnt, running_polstate.default_role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		tsk->is_writable = 1;
+	obj = chk_obj_label(filp->f_path.dentry, filp->f_path.mnt, tsk->role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		tsk->is_writable = 1;
+
+#ifdef CONFIG_GRKERNSEC_RBAC_DEBUG
+	printk(KERN_ALERT "Assigning special role:%s subject:%s to process (%s:%d)\n", tsk->role->rolename,
+			tsk->acl->filename, tsk->comm, task_pid_nr(tsk));
+#endif
+
+out_unlock:
+	read_unlock(&grsec_exec_file_lock);
+	read_unlock(&tasklist_lock);
+	return;
+}
+
+
+static void
+gr_log_learn(const struct dentry *dentry, const struct vfsmount *mnt, const __u32 mode)
+{
+	struct task_struct *task = current;
+	const struct cred *cred = current_cred();
+
+	security_learn(GR_LEARN_AUDIT_MSG, task->role->rolename, task->role->roletype,
+		       GR_GLOBAL_UID(cred->uid), GR_GLOBAL_GID(cred->gid), task->exec_file ? gr_to_filename1(task->exec_file->f_path.dentry,
+		       task->exec_file->f_path.mnt) : task->acl->filename, task->acl->filename,
+		       1UL, 1UL, gr_to_filename(dentry, mnt), (unsigned long) mode, &task->signal->saved_ip);
+
+	return;
+}
+
+static void
+gr_log_learn_uid_change(const kuid_t real, const kuid_t effective, const kuid_t fs)
+{
+	struct task_struct *task = current;
+	const struct cred *cred = current_cred();
+
+	security_learn(GR_ID_LEARN_MSG, task->role->rolename, task->role->roletype,
+		       GR_GLOBAL_UID(cred->uid), GR_GLOBAL_GID(cred->gid), task->exec_file ? gr_to_filename1(task->exec_file->f_path.dentry,
+		       task->exec_file->f_path.mnt) : task->acl->filename, task->acl->filename,
+		       'u', GR_GLOBAL_UID(real), GR_GLOBAL_UID(effective), GR_GLOBAL_UID(fs), &task->signal->saved_ip);
+
+	return;
+}
+
+static void
+gr_log_learn_gid_change(const kgid_t real, const kgid_t effective, const kgid_t fs)
+{
+	struct task_struct *task = current;
+	const struct cred *cred = current_cred();
+
+	security_learn(GR_ID_LEARN_MSG, task->role->rolename, task->role->roletype,
+		       GR_GLOBAL_UID(cred->uid), GR_GLOBAL_GID(cred->gid), task->exec_file ? gr_to_filename1(task->exec_file->f_path.dentry,
+		       task->exec_file->f_path.mnt) : task->acl->filename, task->acl->filename,
+		       'g', GR_GLOBAL_GID(real), GR_GLOBAL_GID(effective), GR_GLOBAL_GID(fs), &task->signal->saved_ip);
+
+	return;
+}
+
+static void
+gr_set_proc_res(struct task_struct *task)
+{
+	struct acl_subject_label *proc;
+	unsigned short i;
+
+	proc = task->acl;
+
+	if (proc->mode & (GR_LEARN | GR_INHERITLEARN))
+		return;
+
+	for (i = 0; i < RLIM_NLIMITS; i++) {
+		unsigned long rlim_cur, rlim_max;
+
+		if (!(proc->resmask & (1U << i)))
+			continue;
+
+		rlim_cur = proc->res[i].rlim_cur;
+		rlim_max = proc->res[i].rlim_max;
+
+		if (i == RLIMIT_NOFILE) {
+			unsigned long saved_sysctl_nr_open = sysctl_nr_open;
+			if (rlim_cur > saved_sysctl_nr_open)
+				rlim_cur = saved_sysctl_nr_open;
+			if (rlim_max > saved_sysctl_nr_open)
+				rlim_max = saved_sysctl_nr_open;
+		}
+
+		task->signal->rlim[i].rlim_cur = rlim_cur;
+		task->signal->rlim[i].rlim_max = rlim_max;
+
+		if (i == RLIMIT_CPU)
+			update_rlimit_cpu(task, rlim_cur);
+	}
+
+	return;
+}
+
+/* both of the below must be called with
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+	read_lock(&grsec_exec_file_lock);
+   except in the case of gr_set_role_label() (for __gr_get_subject_for_task)
+*/
+
+struct acl_subject_label *__gr_get_subject_for_task(const struct gr_policy_state *state, struct task_struct *task, const char *filename, int fallback)
+{
+	char *tmpname;
+	struct acl_subject_label *tmpsubj;
+	struct file *filp;
+	struct name_entry *nmatch;
+
+	filp = task->exec_file;
+	if (filp == NULL)
+		return NULL;
+
+	/* the following is to apply the correct subject
+	   on binaries running when the RBAC system
+	   is enabled, when the binaries have been
+	   replaced or deleted since their execution
+	   -----
+	   when the RBAC system starts, the inode/dev
+	   from exec_file will be one the RBAC system
+	   is unaware of.  It only knows the inode/dev
+	   of the present file on disk, or the absence
+	   of it.
+	*/
+
+	if (filename)
+		nmatch = __lookup_name_entry(state, filename);
+	else {
+		preempt_disable();
+		tmpname = gr_to_filename_rbac(filp->f_path.dentry, filp->f_path.mnt);
+
+		nmatch = __lookup_name_entry(state, tmpname);
+		preempt_enable();
+	}
+	tmpsubj = NULL;
+	if (nmatch) {
+		if (nmatch->deleted)
+			tmpsubj = lookup_acl_subj_label_deleted(nmatch->inode, nmatch->device, task->role);
+		else
+			tmpsubj = lookup_acl_subj_label(nmatch->inode, nmatch->device, task->role);
+	}
+	/* this also works for the reload case -- if we don't match a potentially inherited subject
+	   then we fall back to a normal lookup based on the binary's ino/dev
+	*/
+	if (tmpsubj == NULL && fallback)
+		tmpsubj = chk_subj_label(filp->f_path.dentry, filp->f_path.mnt, task->role);
+
+	return tmpsubj;
+}
+
+static struct acl_subject_label *gr_get_subject_for_task(struct task_struct *task, const char *filename, int fallback)
+{
+	return __gr_get_subject_for_task(&running_polstate, task, filename, fallback);
+}
+
+void __gr_apply_subject_to_task(const struct gr_policy_state *state, struct task_struct *task, struct acl_subject_label *subj)
+{
+	struct acl_object_label *obj;
+	struct file *filp;
+
+	filp = task->exec_file;
+
+	task->acl = subj;
+	task->is_writable = 0;
+	/* ignore additional mmap checks for processes that are writable 
+	   by the default ACL */
+	obj = chk_obj_label(filp->f_path.dentry, filp->f_path.mnt, state->default_role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		task->is_writable = 1;
+	obj = chk_obj_label(filp->f_path.dentry, filp->f_path.mnt, task->role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		task->is_writable = 1;
+
+	gr_set_proc_res(task);
+
+#ifdef CONFIG_GRKERNSEC_RBAC_DEBUG
+	printk(KERN_ALERT "gr_set_acls for (%s:%d): role:%s, subject:%s\n", task->comm, task_pid_nr(task), task->role->rolename, task->acl->filename);
+#endif
+}
+
+static void gr_apply_subject_to_task(struct task_struct *task, struct acl_subject_label *subj)
+{
+	__gr_apply_subject_to_task(&running_polstate, task, subj);
+}
+
+__u32
+gr_search_file(const struct dentry * dentry, const __u32 mode,
+	       const struct vfsmount * mnt)
+{
+	__u32 retval = mode;
+	struct acl_subject_label *curracl;
+	struct acl_object_label *currobj;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return (mode & ~GR_AUDITS);
+
+	curracl = current->acl;
+
+	currobj = chk_obj_label(dentry, mnt, curracl);
+	retval = currobj->mode & mode;
+
+	/* if we're opening a specified transfer file for writing
+	   (e.g. /dev/initctl), then transfer our role to init
+	*/
+	if (unlikely(currobj->mode & GR_INIT_TRANSFER && retval & GR_WRITE &&
+		     current->role->roletype & GR_ROLE_PERSIST)) {
+		struct task_struct *task = init_pid_ns.child_reaper;
+
+		if (task->role != current->role) {
+			struct acl_subject_label *subj;
+
+			task->acl_sp_role = 0;
+			task->acl_role_id = current->acl_role_id;
+			task->role = current->role;
+			rcu_read_lock();
+			read_lock(&grsec_exec_file_lock);
+			subj = gr_get_subject_for_task(task, NULL, 1);
+			gr_apply_subject_to_task(task, subj);
+			read_unlock(&grsec_exec_file_lock);
+			rcu_read_unlock();
+			gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_INIT_TRANSFER_MSG);
+		}
+	}
+
+	if (unlikely
+	    ((curracl->mode & (GR_LEARN | GR_INHERITLEARN)) && !(mode & GR_NOPTRACE)
+	     && (retval != (mode & ~(GR_AUDITS | GR_SUPPRESS))))) {
+		__u32 new_mode = mode;
+
+		new_mode &= ~(GR_AUDITS | GR_SUPPRESS);
+
+		retval = new_mode;
+
+		if (new_mode & GR_EXEC && curracl->mode & GR_INHERITLEARN)
+			new_mode |= GR_INHERIT;
+
+		if (!(mode & GR_NOLEARN))
+			gr_log_learn(dentry, mnt, new_mode);
+	}
+
+	return retval;
+}
+
+struct acl_object_label *gr_get_create_object(const struct dentry *new_dentry,
+					      const struct dentry *parent,
+					      const struct vfsmount *mnt)
+{
+	struct name_entry *match;
+	struct acl_object_label *matchpo;
+	struct acl_subject_label *curracl;
+	char *path;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return NULL;
+
+	preempt_disable();
+	path = gr_to_filename_rbac(new_dentry, mnt);
+	match = lookup_name_entry_create(path);
+
+	curracl = current->acl;
+
+	if (match) {
+		read_lock(&gr_inode_lock);
+		matchpo = lookup_acl_obj_label_create(match->inode, match->device, curracl);
+		read_unlock(&gr_inode_lock);
+
+		if (matchpo) {
+			preempt_enable();
+			return matchpo;
+		}
+	}
+
+	// lookup parent
+
+	matchpo = chk_obj_create_label(parent, mnt, curracl, path);
+
+	preempt_enable();
+	return matchpo;
+}
+
+__u32
+gr_check_create(const struct dentry * new_dentry, const struct dentry * parent,
+		const struct vfsmount * mnt, const __u32 mode)
+{
+	struct acl_object_label *matchpo;
+	__u32 retval;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return (mode & ~GR_AUDITS);
+
+	matchpo = gr_get_create_object(new_dentry, parent, mnt);
+
+	retval = matchpo->mode & mode;
+
+	if ((retval != (mode & ~(GR_AUDITS | GR_SUPPRESS)))
+	    && (current->acl->mode & (GR_LEARN | GR_INHERITLEARN))) {
+		__u32 new_mode = mode;
+
+		new_mode &= ~(GR_AUDITS | GR_SUPPRESS);
+
+		gr_log_learn(new_dentry, mnt, new_mode);
+		return new_mode;
+	}
+
+	return retval;
+}
+
+__u32
+gr_check_link(const struct dentry * new_dentry,
+	      const struct dentry * parent_dentry,
+	      const struct vfsmount * parent_mnt,
+	      const struct dentry * old_dentry, const struct vfsmount * old_mnt)
+{
+	struct acl_object_label *obj;
+	__u32 oldmode, newmode;
+	__u32 needmode;
+	__u32 checkmodes = GR_FIND | GR_APPEND | GR_WRITE | GR_EXEC | GR_SETID | GR_READ |
+			   GR_DELETE | GR_INHERIT;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return (GR_CREATE | GR_LINK);
+
+	obj = chk_obj_label(old_dentry, old_mnt, current->acl);
+	oldmode = obj->mode;
+
+	obj = gr_get_create_object(new_dentry, parent_dentry, parent_mnt);
+	newmode = obj->mode;
+
+	needmode = newmode & checkmodes;
+
+	// old name for hardlink must have at least the permissions of the new name
+	if ((oldmode & needmode) != needmode)
+		goto bad;
+
+	// if old name had restrictions/auditing, make sure the new name does as well
+	needmode = oldmode & (GR_NOPTRACE | GR_PTRACERD | GR_INHERIT | GR_AUDITS);
+
+	// don't allow hardlinking of suid/sgid/fcapped files without permission
+	if (is_privileged_binary(old_dentry))
+		needmode |= GR_SETID;
+
+	if ((newmode & needmode) != needmode)
+		goto bad;
+
+	// enforce minimum permissions
+	if ((newmode & (GR_CREATE | GR_LINK)) == (GR_CREATE | GR_LINK))
+		return newmode;
+bad:
+	needmode = oldmode;
+	if (is_privileged_binary(old_dentry))
+		needmode |= GR_SETID;
+	
+	if (current->acl->mode & (GR_LEARN | GR_INHERITLEARN)) {
+		gr_log_learn(old_dentry, old_mnt, needmode | GR_CREATE | GR_LINK);
+		return (GR_CREATE | GR_LINK);
+	} else if (newmode & GR_SUPPRESS)
+		return GR_SUPPRESS;
+	else
+		return 0;
+}
+
+int
+gr_check_hidden_task(const struct task_struct *task)
+{
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+
+	if (!(task->acl->mode & GR_PROCFIND) && !(current->acl->mode & GR_VIEW))
+		return 1;
+
+	return 0;
+}
+
+int
+gr_check_protected_task(const struct task_struct *task)
+{
+	if (unlikely(!(gr_status & GR_READY) || !task))
+		return 0;
+
+	if ((task->acl->mode & GR_PROTECTED) && !(current->acl->mode & GR_KILL) &&
+	    task->acl != current->acl)
+		return 1;
+
+	return 0;
+}
+
+int
+gr_check_protected_task_fowner(struct pid *pid, enum pid_type type)
+{
+	struct task_struct *p;
+	int ret = 0;
+
+	if (unlikely(!(gr_status & GR_READY) || !pid))
+		return ret;
+
+	read_lock(&tasklist_lock);
+	do_each_pid_task(pid, type, p) {
+		if ((p->acl->mode & GR_PROTECTED) && !(current->acl->mode & GR_KILL) &&
+		    p->acl != current->acl) {
+			ret = 1;
+			goto out;
+		}
+	} while_each_pid_task(pid, type, p);
+out:
+	read_unlock(&tasklist_lock);
+
+	return ret;
+}
+
+void
+gr_copy_label(struct task_struct *tsk)
+{
+	struct task_struct *p = current;
+
+	tsk->inherited = p->inherited;
+	tsk->acl_sp_role = 0;
+	tsk->acl_role_id = p->acl_role_id;
+	tsk->acl = p->acl;
+	tsk->role = p->role;
+	tsk->signal->used_accept = 0;
+	tsk->signal->curr_ip = p->signal->curr_ip;
+	tsk->signal->saved_ip = p->signal->saved_ip;
+	if (p->exec_file)
+		get_file(p->exec_file);
+	tsk->exec_file = p->exec_file;
+	tsk->is_writable = p->is_writable;
+	if (unlikely(p->signal->used_accept)) {
+		p->signal->curr_ip = 0;
+		p->signal->saved_ip = 0;
+	}
+
+	return;
+}
+
+extern int gr_process_kernel_setuid_ban(struct user_struct *user);
+
+int
+gr_check_user_change(kuid_t real, kuid_t effective, kuid_t fs)
+{
+	unsigned int i;
+	__u16 num;
+	uid_t *uidlist;
+	uid_t curuid;
+	int realok = 0;
+	int effectiveok = 0;
+	int fsok = 0;
+	uid_t globalreal, globaleffective, globalfs;
+
+#if defined(CONFIG_GRKERNSEC_KERN_LOCKOUT)
+	struct user_struct *user;
+
+	if (!uid_valid(real))
+		goto skipit;
+
+	/* find user based on global namespace */
+
+	globalreal = GR_GLOBAL_UID(real);
+
+	user = find_user(make_kuid(&init_user_ns, globalreal));
+	if (user == NULL)
+		goto skipit;
+
+	if (gr_process_kernel_setuid_ban(user)) {
+		/* for find_user */
+		free_uid(user);
+		return 1;
+	}
+
+	/* for find_user */
+	free_uid(user);
+
+skipit:
+#endif
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+
+	if (current->acl->mode & (GR_LEARN | GR_INHERITLEARN))
+		gr_log_learn_uid_change(real, effective, fs);
+
+	num = current->acl->user_trans_num;
+	uidlist = current->acl->user_transitions;
+
+	if (uidlist == NULL)
+		return 0;
+
+	if (!uid_valid(real)) {
+		realok = 1;
+		globalreal = (uid_t)-1;		
+	} else {
+		globalreal = GR_GLOBAL_UID(real);		
+	}
+	if (!uid_valid(effective)) {
+		effectiveok = 1;
+		globaleffective = (uid_t)-1;
+	} else {
+		globaleffective = GR_GLOBAL_UID(effective);
+	}
+	if (!uid_valid(fs)) {
+		fsok = 1;
+		globalfs = (uid_t)-1;
+	} else {
+		globalfs = GR_GLOBAL_UID(fs);
+	}
+
+	if (current->acl->user_trans_type & GR_ID_ALLOW) {
+		for (i = 0; i < num; i++) {
+			curuid = uidlist[i];
+			if (globalreal == curuid)
+				realok = 1;
+			if (globaleffective == curuid)
+				effectiveok = 1;
+			if (globalfs == curuid)
+				fsok = 1;
+		}
+	} else if (current->acl->user_trans_type & GR_ID_DENY) {
+		for (i = 0; i < num; i++) {
+			curuid = uidlist[i];
+			if (globalreal == curuid)
+				break;
+			if (globaleffective == curuid)
+				break;
+			if (globalfs == curuid)
+				break;
+		}
+		/* not in deny list */
+		if (i == num) {
+			realok = 1;
+			effectiveok = 1;
+			fsok = 1;
+		}
+	}
+
+	if (realok && effectiveok && fsok)
+		return 0;
+	else {
+		gr_log_int(GR_DONT_AUDIT, GR_USRCHANGE_ACL_MSG, realok ? (effectiveok ? (fsok ? 0 : globalfs) : globaleffective) : globalreal);
+		return 1;
+	}
+}
+
+int
+gr_check_group_change(kgid_t real, kgid_t effective, kgid_t fs)
+{
+	unsigned int i;
+	__u16 num;
+	gid_t *gidlist;
+	gid_t curgid;
+	int realok = 0;
+	int effectiveok = 0;
+	int fsok = 0;
+	gid_t globalreal, globaleffective, globalfs;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+
+	if (current->acl->mode & (GR_LEARN | GR_INHERITLEARN))
+		gr_log_learn_gid_change(real, effective, fs);
+
+	num = current->acl->group_trans_num;
+	gidlist = current->acl->group_transitions;
+
+	if (gidlist == NULL)
+		return 0;
+
+	if (!gid_valid(real)) {
+		realok = 1;
+		globalreal = (gid_t)-1;		
+	} else {
+		globalreal = GR_GLOBAL_GID(real);
+	}
+	if (!gid_valid(effective)) {
+		effectiveok = 1;
+		globaleffective = (gid_t)-1;		
+	} else {
+		globaleffective = GR_GLOBAL_GID(effective);
+	}
+	if (!gid_valid(fs)) {
+		fsok = 1;
+		globalfs = (gid_t)-1;		
+	} else {
+		globalfs = GR_GLOBAL_GID(fs);
+	}
+
+	if (current->acl->group_trans_type & GR_ID_ALLOW) {
+		for (i = 0; i < num; i++) {
+			curgid = gidlist[i];
+			if (globalreal == curgid)
+				realok = 1;
+			if (globaleffective == curgid)
+				effectiveok = 1;
+			if (globalfs == curgid)
+				fsok = 1;
+		}
+	} else if (current->acl->group_trans_type & GR_ID_DENY) {
+		for (i = 0; i < num; i++) {
+			curgid = gidlist[i];
+			if (globalreal == curgid)
+				break;
+			if (globaleffective == curgid)
+				break;
+			if (globalfs == curgid)
+				break;
+		}
+		/* not in deny list */
+		if (i == num) {
+			realok = 1;
+			effectiveok = 1;
+			fsok = 1;
+		}
+	}
+
+	if (realok && effectiveok && fsok)
+		return 0;
+	else {
+		gr_log_int(GR_DONT_AUDIT, GR_GRPCHANGE_ACL_MSG, realok ? (effectiveok ? (fsok ? 0 : globalfs) : globaleffective) : globalreal);
+		return 1;
+	}
+}
+
+extern int gr_acl_is_capable(const int cap);
+
+void
+gr_set_role_label(struct task_struct *task, const kuid_t kuid, const kgid_t kgid)
+{
+	struct acl_role_label *role = task->role;
+	struct acl_role_label *origrole = role;
+	struct acl_subject_label *subj = NULL;
+	struct acl_object_label *obj;
+	struct file *filp;
+	uid_t uid;
+	gid_t gid;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return;
+
+	uid = GR_GLOBAL_UID(kuid);
+	gid = GR_GLOBAL_GID(kgid);
+
+	filp = task->exec_file;
+
+	/* kernel process, we'll give them the kernel role */
+	if (unlikely(!filp)) {
+		task->role = running_polstate.kernel_role;
+		task->acl = running_polstate.kernel_role->root_label;
+		return;
+	} else if (!task->role || !(task->role->roletype & GR_ROLE_SPECIAL)) {
+		/* save the current ip at time of role lookup so that the proper
+		   IP will be learned for role_allowed_ip */
+		task->signal->saved_ip = task->signal->curr_ip;
+		role = lookup_acl_role_label(task, uid, gid);
+	}
+
+	/* don't change the role if we're not a privileged process */
+	if (role && task->role != role &&
+	    (((role->roletype & GR_ROLE_USER) && !gr_acl_is_capable(CAP_SETUID)) ||
+	     ((role->roletype & GR_ROLE_GROUP) && !gr_acl_is_capable(CAP_SETGID))))
+		return;
+
+	task->role = role;
+
+	if (task->inherited) {
+		/* if we reached our subject through inheritance, then first see
+		   if there's a subject of the same name in the new role that has
+		   an object that would result in the same inherited subject
+		*/
+		subj = gr_get_subject_for_task(task, task->acl->filename, 0);
+		if (subj) {
+			obj = chk_obj_label(filp->f_path.dentry, filp->f_path.mnt, subj);
+			if (!(obj->mode & GR_INHERIT))
+				subj = NULL;
+		}
+		
+	}
+	if (subj == NULL) {
+		/* otherwise:
+		   perform subject lookup in possibly new role
+		   we can use this result below in the case where role == task->role
+		*/
+		subj = chk_subj_label(filp->f_path.dentry, filp->f_path.mnt, role);
+	}
+
+	/* if we changed uid/gid, but result in the same role
+	   and are using inheritance, don't lose the inherited subject
+	   if current subject is other than what normal lookup
+	   would result in, we arrived via inheritance, don't
+	   lose subject
+	*/
+	if (role != origrole || (!(task->acl->mode & GR_INHERITLEARN) &&
+				   (subj == task->acl)))
+		task->acl = subj;
+
+	/* leave task->inherited unaffected */
+
+	task->is_writable = 0;
+
+	/* ignore additional mmap checks for processes that are writable 
+	   by the default ACL */
+	obj = chk_obj_label(filp->f_path.dentry, filp->f_path.mnt, running_polstate.default_role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		task->is_writable = 1;
+	obj = chk_obj_label(filp->f_path.dentry, filp->f_path.mnt, task->role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		task->is_writable = 1;
+
+#ifdef CONFIG_GRKERNSEC_RBAC_DEBUG
+	printk(KERN_ALERT "Set role label for (%s:%d): role:%s, subject:%s\n", task->comm, task_pid_nr(task), task->role->rolename, task->acl->filename);
+#endif
+
+	gr_set_proc_res(task);
+
+	return;
+}
+
+int
+gr_set_proc_label(const struct dentry *dentry, const struct vfsmount *mnt,
+		  const int unsafe_flags)
+{
+	struct task_struct *task = current;
+	struct acl_subject_label *newacl;
+	struct acl_object_label *obj;
+	__u32 retmode;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+
+	newacl = chk_subj_label(dentry, mnt, task->role);
+
+	/* special handling for if we did an strace -f -p <pid> from an admin role, where pid then
+	   did an exec
+	*/
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+	if (task->ptrace && task->parent && ((task->parent->role->roletype & GR_ROLE_GOD) ||
+	    (task->parent->acl->mode & GR_POVERRIDE))) {
+		read_unlock(&tasklist_lock);
+		rcu_read_unlock();
+		goto skip_check;
+	}
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+
+	if (unsafe_flags && !(task->acl->mode & GR_POVERRIDE) && (task->acl != newacl) &&
+	     !(task->role->roletype & GR_ROLE_GOD) &&
+	     !gr_search_file(dentry, GR_PTRACERD, mnt) &&
+	     !(task->acl->mode & (GR_LEARN | GR_INHERITLEARN))) {
+		if (unsafe_flags & LSM_UNSAFE_SHARE)
+			gr_log_fs_generic(GR_DONT_AUDIT, GR_UNSAFESHARE_EXEC_ACL_MSG, dentry, mnt);
+		else
+			gr_log_fs_generic(GR_DONT_AUDIT, GR_PTRACE_EXEC_ACL_MSG, dentry, mnt);
+		return -EACCES;
+	}
+
+skip_check:
+
+	obj = chk_obj_label(dentry, mnt, task->acl);
+	retmode = obj->mode & (GR_INHERIT | GR_AUDIT_INHERIT);
+
+	if (!(task->acl->mode & GR_INHERITLEARN) &&
+	    ((newacl->mode & GR_LEARN) || !(retmode & GR_INHERIT))) {
+		if (obj->nested)
+			task->acl = obj->nested;
+		else
+			task->acl = newacl;
+		task->inherited = 0;
+	} else {
+		task->inherited = 1;
+		if (retmode & GR_INHERIT && retmode & GR_AUDIT_INHERIT)
+			gr_log_str_fs(GR_DO_AUDIT, GR_INHERIT_ACL_MSG, task->acl->filename, dentry, mnt);
+	}
+
+	task->is_writable = 0;
+
+	/* ignore additional mmap checks for processes that are writable 
+	   by the default ACL */
+	obj = chk_obj_label(dentry, mnt, running_polstate.default_role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		task->is_writable = 1;
+	obj = chk_obj_label(dentry, mnt, task->role->root_label);
+	if (unlikely(obj->mode & GR_WRITE))
+		task->is_writable = 1;
+
+	gr_set_proc_res(task);
+
+#ifdef CONFIG_GRKERNSEC_RBAC_DEBUG
+	printk(KERN_ALERT "Set subject label for (%s:%d): role:%s, subject:%s\n", task->comm, task_pid_nr(task), task->role->rolename, task->acl->filename);
+#endif
+	return 0;
+}
+
+/* always called with valid inodev ptr */
+static void
+do_handle_delete(struct inodev_entry *inodev, const u64 ino, const dev_t dev)
+{
+	struct acl_object_label *matchpo;
+	struct acl_subject_label *matchps;
+	struct acl_subject_label *subj;
+	struct acl_role_label *role;
+	unsigned int x;
+
+	FOR_EACH_ROLE_START(role)
+		FOR_EACH_SUBJECT_START(role, subj, x)
+			if ((matchpo = lookup_acl_obj_label(ino, dev, subj)) != NULL)
+				matchpo->mode |= GR_DELETED;
+		FOR_EACH_SUBJECT_END(subj,x)
+		FOR_EACH_NESTED_SUBJECT_START(role, subj)
+			/* nested subjects aren't in the role's subj_hash table */
+			if ((matchpo = lookup_acl_obj_label(ino, dev, subj)) != NULL)
+				matchpo->mode |= GR_DELETED;
+		FOR_EACH_NESTED_SUBJECT_END(subj)
+		if ((matchps = lookup_acl_subj_label(ino, dev, role)) != NULL)
+			matchps->mode |= GR_DELETED;
+	FOR_EACH_ROLE_END(role)
+
+	inodev->nentry->deleted = 1;
+
+	return;
+}
+
+void
+gr_handle_delete(const u64 ino, const dev_t dev)
+{
+	struct inodev_entry *inodev;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return;
+
+	write_lock(&gr_inode_lock);
+	inodev = lookup_inodev_entry(ino, dev);
+	if (inodev != NULL)
+		do_handle_delete(inodev, ino, dev);
+	write_unlock(&gr_inode_lock);
+
+	return;
+}
+
+static void
+update_acl_obj_label(const u64 oldinode, const dev_t olddevice,
+		     const u64 newinode, const dev_t newdevice,
+		     struct acl_subject_label *subj)
+{
+	unsigned int index = gr_fhash(oldinode, olddevice, subj->obj_hash_size);
+	struct acl_object_label *match;
+
+	match = subj->obj_hash[index];
+
+	while (match && (match->inode != oldinode ||
+	       match->device != olddevice ||
+	       !(match->mode & GR_DELETED)))
+		match = match->next;
+
+	if (match && (match->inode == oldinode)
+	    && (match->device == olddevice)
+	    && (match->mode & GR_DELETED)) {
+		if (match->prev == NULL) {
+			subj->obj_hash[index] = match->next;
+			if (match->next != NULL)
+				match->next->prev = NULL;
+		} else {
+			match->prev->next = match->next;
+			if (match->next != NULL)
+				match->next->prev = match->prev;
+		}
+		match->prev = NULL;
+		match->next = NULL;
+		match->inode = newinode;
+		match->device = newdevice;
+		match->mode &= ~GR_DELETED;
+
+		insert_acl_obj_label(match, subj);
+	}
+
+	return;
+}
+
+static void
+update_acl_subj_label(const u64 oldinode, const dev_t olddevice,
+		      const u64 newinode, const dev_t newdevice,
+		      struct acl_role_label *role)
+{
+	unsigned int index = gr_fhash(oldinode, olddevice, role->subj_hash_size);
+	struct acl_subject_label *match;
+
+	match = role->subj_hash[index];
+
+	while (match && (match->inode != oldinode ||
+	       match->device != olddevice ||
+	       !(match->mode & GR_DELETED)))
+		match = match->next;
+
+	if (match && (match->inode == oldinode)
+	    && (match->device == olddevice)
+	    && (match->mode & GR_DELETED)) {
+		if (match->prev == NULL) {
+			role->subj_hash[index] = match->next;
+			if (match->next != NULL)
+				match->next->prev = NULL;
+		} else {
+			match->prev->next = match->next;
+			if (match->next != NULL)
+				match->next->prev = match->prev;
+		}
+		match->prev = NULL;
+		match->next = NULL;
+		match->inode = newinode;
+		match->device = newdevice;
+		match->mode &= ~GR_DELETED;
+
+		insert_acl_subj_label(match, role);
+	}
+
+	return;
+}
+
+static void
+update_inodev_entry(const u64 oldinode, const dev_t olddevice,
+		    const u64 newinode, const dev_t newdevice)
+{
+	unsigned int index = gr_fhash(oldinode, olddevice, running_polstate.inodev_set.i_size);
+	struct inodev_entry *match;
+
+	match = running_polstate.inodev_set.i_hash[index];
+
+	while (match && (match->nentry->inode != oldinode ||
+	       match->nentry->device != olddevice || !match->nentry->deleted))
+		match = match->next;
+
+	if (match && (match->nentry->inode == oldinode)
+	    && (match->nentry->device == olddevice) &&
+	    match->nentry->deleted) {
+		if (match->prev == NULL) {
+			running_polstate.inodev_set.i_hash[index] = match->next;
+			if (match->next != NULL)
+				match->next->prev = NULL;
+		} else {
+			match->prev->next = match->next;
+			if (match->next != NULL)
+				match->next->prev = match->prev;
+		}
+		match->prev = NULL;
+		match->next = NULL;
+		match->nentry->inode = newinode;
+		match->nentry->device = newdevice;
+		match->nentry->deleted = 0;
+
+		insert_inodev_entry(match);
+	}
+
+	return;
+}
+
+static void
+__do_handle_create(const struct name_entry *matchn, u64 ino, dev_t dev)
+{
+	struct acl_subject_label *subj;
+	struct acl_role_label *role;
+	unsigned int x;
+
+	FOR_EACH_ROLE_START(role)
+		update_acl_subj_label(matchn->inode, matchn->device, ino, dev, role);
+
+		FOR_EACH_NESTED_SUBJECT_START(role, subj)
+			if ((subj->inode == ino) && (subj->device == dev)) {
+				subj->inode = ino;
+				subj->device = dev;
+			}
+			/* nested subjects aren't in the role's subj_hash table */
+			update_acl_obj_label(matchn->inode, matchn->device,
+					     ino, dev, subj);
+		FOR_EACH_NESTED_SUBJECT_END(subj)
+		FOR_EACH_SUBJECT_START(role, subj, x)
+			update_acl_obj_label(matchn->inode, matchn->device,
+					     ino, dev, subj);
+		FOR_EACH_SUBJECT_END(subj,x)
+	FOR_EACH_ROLE_END(role)
+
+	update_inodev_entry(matchn->inode, matchn->device, ino, dev);
+
+	return;
+}
+
+static void
+do_handle_create(const struct name_entry *matchn, const struct dentry *dentry,
+		 const struct vfsmount *mnt)
+{
+	u64 ino = __get_ino(dentry);
+	dev_t dev = __get_dev(dentry);
+
+	__do_handle_create(matchn, ino, dev);	
+
+	return;
+}
+
+void
+gr_handle_create(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	struct name_entry *matchn;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return;
+
+	preempt_disable();
+	matchn = lookup_name_entry(gr_to_filename_rbac(dentry, mnt));
+
+	if (unlikely((unsigned long)matchn)) {
+		write_lock(&gr_inode_lock);
+		do_handle_create(matchn, dentry, mnt);
+		write_unlock(&gr_inode_lock);
+	}
+	preempt_enable();
+
+	return;
+}
+
+void
+gr_handle_proc_create(const struct dentry *dentry, const struct inode *inode)
+{
+	struct name_entry *matchn;
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return;
+
+	preempt_disable();
+	matchn = lookup_name_entry(gr_to_proc_filename_rbac(dentry, init_pid_ns.proc_mnt));
+
+	if (unlikely((unsigned long)matchn)) {
+		write_lock(&gr_inode_lock);
+		__do_handle_create(matchn, inode->i_ino, inode->i_sb->s_dev);
+		write_unlock(&gr_inode_lock);
+	}
+	preempt_enable();
+
+	return;
+}
+
+void
+gr_handle_rename(struct inode *old_dir, struct inode *new_dir,
+		 struct dentry *old_dentry,
+		 struct dentry *new_dentry,
+		 struct vfsmount *mnt, const __u8 replace, unsigned int flags)
+{
+	struct name_entry *matchn;
+	struct name_entry *matchn2 = NULL;
+	struct inodev_entry *inodev;
+	struct inode *inode = d_backing_inode(new_dentry);
+	struct inode *old_inode = d_backing_inode(old_dentry);
+	u64 old_ino = __get_ino(old_dentry);
+	dev_t old_dev = __get_dev(old_dentry);
+	unsigned int exchange = flags & RENAME_EXCHANGE;
+
+	/* vfs_rename swaps the name and parent link for old_dentry and
+	   new_dentry
+	   at this point, old_dentry has the new name, parent link, and inode
+	   for the renamed file
+	   if a file is being replaced by a rename, new_dentry has the inode
+	   and name for the replaced file
+	*/
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return;
+
+	preempt_disable();
+	matchn = lookup_name_entry(gr_to_filename_rbac(old_dentry, mnt));
+
+	/* exchange cases:
+	   a filename exists for the source, but not dest
+		do a recreate on source
+	   a filename exists for the dest, but not source
+		do a recreate on dest
+	   a filename exists for both source and dest
+		delete source and dest, then create source and dest
+	   a filename exists for neither source nor dest
+		no updates needed
+
+	   the name entry lookups get us the old inode/dev associated with
+	   each name, so do the deletes first (if possible) so that when
+	   we do the create, we pick up on the right entries
+	*/
+
+	if (exchange)
+		matchn2 = lookup_name_entry(gr_to_filename_rbac(new_dentry, mnt));
+
+	/* we wouldn't have to check d_inode if it weren't for
+	   NFS silly-renaming
+	 */
+
+	write_lock(&gr_inode_lock);
+	if (unlikely((replace || exchange) && inode)) {
+		u64 new_ino = __get_ino(new_dentry);
+		dev_t new_dev = __get_dev(new_dentry);
+
+		inodev = lookup_inodev_entry(new_ino, new_dev);
+		if (inodev != NULL && ((inode->i_nlink <= 1) || d_is_dir(new_dentry)))
+			do_handle_delete(inodev, new_ino, new_dev);
+	}
+
+	inodev = lookup_inodev_entry(old_ino, old_dev);
+	if (inodev != NULL && ((old_inode->i_nlink <= 1) || d_is_dir(old_dentry)))
+		do_handle_delete(inodev, old_ino, old_dev);
+
+	if (unlikely(matchn != NULL))
+		do_handle_create(matchn, old_dentry, mnt);
+
+	if (unlikely(matchn2 != NULL))
+		do_handle_create(matchn2, new_dentry, mnt);
+
+	write_unlock(&gr_inode_lock);
+	preempt_enable();
+
+	return;
+}
+
+#if defined(CONFIG_GRKERNSEC_RESLOG) || !defined(CONFIG_GRKERNSEC_NO_RBAC)
+static const unsigned long res_learn_bumps[GR_NLIMITS] = {
+	[RLIMIT_CPU] = GR_RLIM_CPU_BUMP,
+	[RLIMIT_FSIZE] = GR_RLIM_FSIZE_BUMP,
+	[RLIMIT_DATA] = GR_RLIM_DATA_BUMP,
+	[RLIMIT_STACK] = GR_RLIM_STACK_BUMP,
+	[RLIMIT_CORE] = GR_RLIM_CORE_BUMP,
+	[RLIMIT_RSS] = GR_RLIM_RSS_BUMP,
+	[RLIMIT_NPROC] = GR_RLIM_NPROC_BUMP,
+	[RLIMIT_NOFILE] = GR_RLIM_NOFILE_BUMP,
+	[RLIMIT_MEMLOCK] = GR_RLIM_MEMLOCK_BUMP,
+	[RLIMIT_AS] = GR_RLIM_AS_BUMP,
+	[RLIMIT_LOCKS] = GR_RLIM_LOCKS_BUMP,
+	[RLIMIT_SIGPENDING] = GR_RLIM_SIGPENDING_BUMP,
+	[RLIMIT_MSGQUEUE] = GR_RLIM_MSGQUEUE_BUMP,
+	[RLIMIT_NICE] = GR_RLIM_NICE_BUMP,
+	[RLIMIT_RTPRIO] = GR_RLIM_RTPRIO_BUMP,
+	[RLIMIT_RTTIME] = GR_RLIM_RTTIME_BUMP
+};
+
+void
+gr_learn_resource(const struct task_struct *task,
+		  const int res, const unsigned long wanted, const int gt)
+{
+	struct acl_subject_label *acl;
+	const struct cred *cred;
+
+	if (unlikely((gr_status & GR_READY) &&
+		     task->acl && (task->acl->mode & (GR_LEARN | GR_INHERITLEARN))))
+		goto skip_reslog;
+
+	gr_log_resource(task, res, wanted, gt);
+skip_reslog:
+
+	if (unlikely(!(gr_status & GR_READY) || !wanted || res >= GR_NLIMITS))
+		return;
+
+	acl = task->acl;
+
+	if (likely(!acl || !(acl->mode & (GR_LEARN | GR_INHERITLEARN)) ||
+		   !(acl->resmask & (1U << (unsigned short) res))))
+		return;
+
+	if (wanted >= acl->res[res].rlim_cur) {
+		unsigned long res_add;
+
+		res_add = wanted + res_learn_bumps[res];
+
+		acl->res[res].rlim_cur = res_add;
+
+		if (wanted > acl->res[res].rlim_max)
+			acl->res[res].rlim_max = res_add;
+
+		/* only log the subject filename, since resource logging is supported for
+		   single-subject learning only */
+		rcu_read_lock();
+		cred = __task_cred(task);
+		security_learn(GR_LEARN_AUDIT_MSG, task->role->rolename,
+			       task->role->roletype, GR_GLOBAL_UID(cred->uid), GR_GLOBAL_GID(cred->gid), acl->filename,
+			       acl->filename, acl->res[res].rlim_cur, acl->res[res].rlim_max,
+			       "", (unsigned long) res, &task->signal->saved_ip);
+		rcu_read_unlock();
+	}
+
+	return;
+}
+EXPORT_SYMBOL_GPL(gr_learn_resource);
+#endif
+
+#if defined(CONFIG_PAX_HAVE_ACL_FLAGS) && (defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR))
+void
+pax_set_initial_flags(struct linux_binprm *bprm)
+{
+	struct task_struct *task = current;
+        struct acl_subject_label *proc;
+	unsigned long flags;
+
+        if (unlikely(!(gr_status & GR_READY)))
+                return;
+
+	flags = pax_get_flags(task);
+
+        proc = task->acl;
+
+	if (proc->pax_flags & GR_PAX_DISABLE_PAGEEXEC)
+		flags &= ~MF_PAX_PAGEEXEC;
+	if (proc->pax_flags & GR_PAX_DISABLE_SEGMEXEC)
+		flags &= ~MF_PAX_SEGMEXEC;
+	if (proc->pax_flags & GR_PAX_DISABLE_RANDMMAP)
+		flags &= ~MF_PAX_RANDMMAP;
+	if (proc->pax_flags & GR_PAX_DISABLE_EMUTRAMP)
+		flags &= ~MF_PAX_EMUTRAMP;
+	if (proc->pax_flags & GR_PAX_DISABLE_MPROTECT)
+		flags &= ~MF_PAX_MPROTECT;
+
+	if (proc->pax_flags & GR_PAX_ENABLE_PAGEEXEC)
+		flags |= MF_PAX_PAGEEXEC;
+	if (proc->pax_flags & GR_PAX_ENABLE_SEGMEXEC)
+		flags |= MF_PAX_SEGMEXEC;
+	if (proc->pax_flags & GR_PAX_ENABLE_RANDMMAP)
+		flags |= MF_PAX_RANDMMAP;
+	if (proc->pax_flags & GR_PAX_ENABLE_EMUTRAMP)
+		flags |= MF_PAX_EMUTRAMP;
+	if (proc->pax_flags & GR_PAX_ENABLE_MPROTECT)
+		flags |= MF_PAX_MPROTECT;
+
+	pax_set_flags(task, flags);
+
+        return;
+}
+#endif
+
+int
+gr_handle_proc_ptrace(struct task_struct *task)
+{
+	struct file *filp;
+	struct task_struct *tmp = task;
+	struct task_struct *curtemp = current;
+	__u32 retmode;
+
+#ifndef CONFIG_GRKERNSEC_HARDEN_PTRACE
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+#endif
+
+	read_lock(&tasklist_lock);
+	read_lock(&grsec_exec_file_lock);
+	filp = task->exec_file;
+
+	while (task_pid_nr(tmp) > 0) {
+		if (tmp == curtemp)
+			break;
+		tmp = tmp->real_parent;
+	}
+
+	if (!filp || (task_pid_nr(tmp) == 0 && ((grsec_enable_harden_ptrace && gr_is_global_nonroot(current_uid()) && !(gr_status & GR_READY)) ||
+				((gr_status & GR_READY)	&& !(current->acl->mode & GR_RELAXPTRACE))))) {
+		read_unlock(&grsec_exec_file_lock);
+		read_unlock(&tasklist_lock);
+		return 1;
+	}
+
+#ifdef CONFIG_GRKERNSEC_HARDEN_PTRACE
+	if (!(gr_status & GR_READY)) {
+		read_unlock(&grsec_exec_file_lock);
+		read_unlock(&tasklist_lock);
+		return 0;
+	}
+#endif
+
+	retmode = gr_search_file(filp->f_path.dentry, GR_NOPTRACE, filp->f_path.mnt);
+	read_unlock(&grsec_exec_file_lock);
+	read_unlock(&tasklist_lock);
+
+	if (retmode & GR_NOPTRACE)
+		return 1;
+
+	if (!(current->acl->mode & GR_POVERRIDE) && !(current->role->roletype & GR_ROLE_GOD)
+	    && (current->acl != task->acl || (current->acl != current->role->root_label
+	    && task_pid_nr(current) != task_pid_nr(task))))
+		return 1;
+
+	return 0;
+}
+
+void task_grsec_rbac(struct seq_file *m, struct task_struct *p)
+{
+	if (unlikely(!(gr_status & GR_READY)))
+		return;
+
+	if (!(current->role->roletype & GR_ROLE_GOD))
+		return;
+
+	seq_printf(m, "RBAC:\t%.64s:%c:%.950s\n",
+			p->role->rolename, gr_task_roletype_to_char(p),
+			p->acl->filename);
+}
+
+int
+gr_handle_ptrace(struct task_struct *task, const long request)
+{
+	struct task_struct *tmp = task;
+	struct task_struct *curtemp = current;
+	__u32 retmode;
+
+#ifndef CONFIG_GRKERNSEC_HARDEN_PTRACE
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+#endif
+	if (request == PTRACE_ATTACH || request == PTRACE_SEIZE) {
+		read_lock(&tasklist_lock);
+		while (task_pid_nr(tmp) > 0) {
+			if (tmp == curtemp)
+				break;
+			tmp = tmp->real_parent;
+		}
+
+		if (task_pid_nr(tmp) == 0 && ((grsec_enable_harden_ptrace && gr_is_global_nonroot(current_uid()) && !(gr_status & GR_READY)) ||
+					((gr_status & GR_READY)	&& !(current->acl->mode & GR_RELAXPTRACE)))) {
+			read_unlock(&tasklist_lock);
+			gr_log_ptrace(GR_DONT_AUDIT, GR_PTRACE_ACL_MSG, task);
+			return 1;
+		}
+		read_unlock(&tasklist_lock);
+	}
+
+#ifdef CONFIG_GRKERNSEC_HARDEN_PTRACE
+	if (!(gr_status & GR_READY))
+		return 0;
+#endif
+
+	read_lock(&grsec_exec_file_lock);
+	if (unlikely(!task->exec_file)) {
+		read_unlock(&grsec_exec_file_lock);
+		return 0;
+	}
+
+	retmode = gr_search_file(task->exec_file->f_path.dentry, GR_PTRACERD | GR_NOPTRACE, task->exec_file->f_path.mnt);
+	read_unlock(&grsec_exec_file_lock);
+
+	if (retmode & GR_NOPTRACE) {
+		gr_log_ptrace(GR_DONT_AUDIT, GR_PTRACE_ACL_MSG, task);
+		return 1;
+	}
+		
+	if (retmode & GR_PTRACERD) {
+		switch (request) {
+		case PTRACE_SEIZE:
+		case PTRACE_POKETEXT:
+		case PTRACE_POKEDATA:
+		case PTRACE_POKEUSR:
+#if !defined(CONFIG_PPC32) && !defined(CONFIG_PPC64) && !defined(CONFIG_PARISC) && !defined(CONFIG_ALPHA) && !defined(CONFIG_IA64) && !defined(CONFIG_ARM64)
+		case PTRACE_SETREGS:
+		case PTRACE_SETFPREGS:
+#endif
+#ifdef CONFIG_COMPAT
+#ifdef CONFIG_ARM64
+		case COMPAT_PTRACE_SETREGS:
+		case COMPAT_PTRACE_SETVFPREGS:
+#ifdef CONFIG_HAVE_HW_BREAKPOINT
+		case COMPAT_PTRACE_SETHBPREGS:
+#endif
+#endif
+#endif
+#ifdef CONFIG_X86
+		case PTRACE_SETFPXREGS:
+#endif
+#ifdef CONFIG_ALTIVEC
+		case PTRACE_SETVRREGS:
+#endif
+#ifdef CONFIG_ARM
+		case PTRACE_SET_SYSCALL:
+		case PTRACE_SETVFPREGS:
+#ifdef CONFIG_HAVE_HW_BREAKPOINT
+		case PTRACE_SETHBPREGS:
+#endif
+#endif
+			return 1;
+		default:
+			return 0;
+		}
+	} else if (!(current->acl->mode & GR_POVERRIDE) &&
+		   !(current->role->roletype & GR_ROLE_GOD) &&
+		   (current->acl != task->acl)) {
+		gr_log_ptrace(GR_DONT_AUDIT, GR_PTRACE_ACL_MSG, task);
+		return 1;
+	}
+
+	return 0;
+}
+
+static int is_writable_mmap(const struct file *filp)
+{
+	struct task_struct *task = current;
+	struct acl_object_label *obj, *obj2;
+	struct dentry *dentry = filp->f_path.dentry;
+	struct vfsmount *mnt = filp->f_path.mnt;
+	struct inode *inode = d_backing_inode(dentry);
+
+	if (gr_status & GR_READY && !(task->acl->mode & GR_OVERRIDE) &&
+	    !task->is_writable && d_is_reg(dentry) && (mnt != shm_mnt || (inode->i_nlink > 0))) {
+		obj = chk_obj_label(dentry, mnt, running_polstate.default_role->root_label);
+		obj2 = chk_obj_label(dentry, mnt, task->role->root_label);
+		if (unlikely((obj->mode & GR_WRITE) || (obj2->mode & GR_WRITE))) {
+			gr_log_fs_generic(GR_DONT_AUDIT, GR_WRITLIB_ACL_MSG, dentry, mnt);
+			return 1;
+		}
+	}
+	return 0;
+}
+
+int
+gr_acl_handle_mmap(const struct file *file, const unsigned long prot)
+{
+	__u32 mode;
+
+	if (unlikely(!file || !(prot & PROT_EXEC)))
+		return 1;
+
+	if (is_writable_mmap(file))
+		return 0;
+
+	mode =
+	    gr_search_file(file->f_path.dentry,
+			   GR_EXEC | GR_AUDIT_EXEC | GR_SUPPRESS,
+			   file->f_path.mnt);
+
+	if (!gr_tpe_allow(file))
+		return 0;
+
+	if (unlikely(!(mode & GR_EXEC) && !(mode & GR_SUPPRESS))) {
+		gr_log_fs_rbac_generic(GR_DONT_AUDIT, GR_MMAP_ACL_MSG, file->f_path.dentry, file->f_path.mnt);
+		return 0;
+	} else if (unlikely(!(mode & GR_EXEC))) {
+		return 0;
+	} else if (unlikely(mode & GR_EXEC && mode & GR_AUDIT_EXEC)) {
+		gr_log_fs_rbac_generic(GR_DO_AUDIT, GR_MMAP_ACL_MSG, file->f_path.dentry, file->f_path.mnt);
+		return 1;
+	}
+
+	return 1;
+}
+
+int
+gr_acl_handle_mprotect(const struct file *file, const unsigned long prot)
+{
+	__u32 mode;
+
+	if (unlikely(!file || !(prot & PROT_EXEC)))
+		return 1;
+
+	if (is_writable_mmap(file))
+		return 0;
+
+	mode =
+	    gr_search_file(file->f_path.dentry,
+			   GR_EXEC | GR_AUDIT_EXEC | GR_SUPPRESS,
+			   file->f_path.mnt);
+
+	if (!gr_tpe_allow(file))
+		return 0;
+
+	if (unlikely(!(mode & GR_EXEC) && !(mode & GR_SUPPRESS))) {
+		gr_log_fs_rbac_generic(GR_DONT_AUDIT, GR_MPROTECT_ACL_MSG, file->f_path.dentry, file->f_path.mnt);
+		return 0;
+	} else if (unlikely(!(mode & GR_EXEC))) {
+		return 0;
+	} else if (unlikely(mode & GR_EXEC && mode & GR_AUDIT_EXEC)) {
+		gr_log_fs_rbac_generic(GR_DO_AUDIT, GR_MPROTECT_ACL_MSG, file->f_path.dentry, file->f_path.mnt);
+		return 1;
+	}
+
+	return 1;
+}
+
+void
+gr_acl_handle_psacct(struct task_struct *task, const long code)
+{
+	unsigned long runtime, cputime;
+	cputime_t utime, stime;
+	unsigned int wday, cday;
+	__u8 whr, chr;
+	__u8 wmin, cmin;
+	__u8 wsec, csec;
+	struct timespec curtime, starttime;
+
+	if (unlikely(!(gr_status & GR_READY) || !task->acl ||
+		     !(task->acl->mode & GR_PROCACCT)))
+		return;
+	
+	curtime = ns_to_timespec(ktime_get_ns());
+	starttime = ns_to_timespec(task->start_time);
+	runtime = curtime.tv_sec - starttime.tv_sec;
+	wday = runtime / (60 * 60 * 24);
+	runtime -= wday * (60 * 60 * 24);
+	whr = runtime / (60 * 60);
+	runtime -= whr * (60 * 60);
+	wmin = runtime / 60;
+	runtime -= wmin * 60;
+	wsec = runtime;
+
+	task_cputime(task, &utime, &stime);
+	cputime = cputime_to_secs(utime + stime);
+	cday = cputime / (60 * 60 * 24);
+	cputime -= cday * (60 * 60 * 24);
+	chr = cputime / (60 * 60);
+	cputime -= chr * (60 * 60);
+	cmin = cputime / 60;
+	cputime -= cmin * 60;
+	csec = cputime;
+
+	gr_log_procacct(GR_DO_AUDIT, GR_ACL_PROCACCT_MSG, task, wday, whr, wmin, wsec, cday, chr, cmin, csec, code);
+
+	return;
+}
+
+#ifdef CONFIG_TASKSTATS
+int gr_is_taskstats_denied(int pid)
+{
+	struct task_struct *task;
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	const struct cred *cred;
+#endif
+	int ret = 0;
+
+	/* restrict taskstats viewing to un-chrooted root users
+	   who have the 'view' subject flag if the RBAC system is enabled
+	*/
+
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+	task = find_task_by_vpid(pid);
+	if (task) {
+#ifdef CONFIG_GRKERNSEC_CHROOT
+		if (proc_is_chrooted(task))
+			ret = -EACCES;
+#endif
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+		cred = __task_cred(task);
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+		if (gr_is_global_nonroot(cred->uid))
+			ret = -EACCES;
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+		if (gr_is_global_nonroot(cred->uid) && !groups_search(cred->group_info, grsec_proc_gid))
+			ret = -EACCES;
+#endif
+#endif
+		if (gr_status & GR_READY) {
+			if (!(task->acl->mode & GR_VIEW))
+				ret = -EACCES;
+		}
+	} else
+		ret = -ENOENT;
+
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+
+	return ret;
+}
+#endif
+
+/* AUXV entries are filled via a descendant of search_binary_handler
+   after we've already applied the subject for the target
+*/
+int gr_acl_enable_at_secure(void)
+{
+	if (unlikely(!(gr_status & GR_READY)))
+		return 0;
+
+	if (current->acl->mode & GR_ATSECURE)
+		return 1;
+
+	return 0;
+}
+	
+int gr_acl_handle_filldir(const struct file *file, const char *name, const unsigned int namelen, const u64 ino)
+{
+	struct task_struct *task = current;
+	struct dentry *dentry = file->f_path.dentry;
+	struct vfsmount *mnt = file->f_path.mnt;
+	struct acl_object_label *obj, *tmp;
+	struct acl_subject_label *subj;
+	unsigned int bufsize;
+	int is_not_root;
+	char *path;
+	dev_t dev = __get_dev(dentry);
+
+	if (unlikely(!(gr_status & GR_READY)))
+		return 1;
+
+	if (task->acl->mode & (GR_LEARN | GR_INHERITLEARN))
+		return 1;
+
+	/* ignore Eric Biederman */
+	if (IS_PRIVATE(d_backing_inode(dentry)))
+		return 1;
+
+	subj = task->acl;
+	read_lock(&gr_inode_lock);
+	do {
+		obj = lookup_acl_obj_label(ino, dev, subj);
+		if (obj != NULL) {
+			read_unlock(&gr_inode_lock);
+			return (obj->mode & GR_FIND) ? 1 : 0;
+		}
+	} while ((subj = subj->parent_subject));
+	read_unlock(&gr_inode_lock);
+	
+	/* this is purely an optimization since we're looking for an object
+	   for the directory we're doing a readdir on
+	   if it's possible for any globbed object to match the entry we're
+	   filling into the directory, then the object we find here will be
+	   an anchor point with attached globbed objects
+	*/
+	obj = chk_obj_label_noglob(dentry, mnt, task->acl);
+	if (obj->globbed == NULL)
+		return (obj->mode & GR_FIND) ? 1 : 0;
+
+	is_not_root = ((obj->filename[0] == '/') &&
+		   (obj->filename[1] == '\0')) ? 0 : 1;
+	bufsize = PAGE_SIZE - namelen - is_not_root;
+
+	/* check bufsize > PAGE_SIZE || bufsize == 0 */
+	if (unlikely((bufsize - 1) > (PAGE_SIZE - 1)))
+		return 1;
+
+	preempt_disable();
+	path = d_real_path(dentry, mnt, per_cpu_ptr(gr_shared_page[0], smp_processor_id()),
+			   bufsize);
+
+	bufsize = strlen(path);
+
+	/* if base is "/", don't append an additional slash */
+	if (is_not_root)
+		*(path + bufsize) = '/';
+	memcpy(path + bufsize + is_not_root, name, namelen);
+	*(path + bufsize + namelen + is_not_root) = '\0';
+
+	tmp = obj->globbed;
+	while (tmp) {
+		if (!glob_match(tmp->filename, path)) {
+			preempt_enable();
+			return (tmp->mode & GR_FIND) ? 1 : 0;
+		}
+		tmp = tmp->next;
+	}
+	preempt_enable();
+	return (obj->mode & GR_FIND) ? 1 : 0;
+}
+
+void gr_put_exec_file(struct task_struct *task)
+{
+	struct file *filp;  
+
+	write_lock(&grsec_exec_file_lock);
+	filp = task->exec_file;   
+	task->exec_file = NULL;
+	write_unlock(&grsec_exec_file_lock);
+
+	if (filp)
+		fput(filp);
+
+	return;
+}
+
+
+#ifdef CONFIG_NETFILTER_XT_MATCH_GRADM_MODULE
+EXPORT_SYMBOL_GPL(gr_acl_is_enabled);
+#endif
+#ifdef CONFIG_SECURITY
+EXPORT_SYMBOL_GPL(gr_check_user_change);
+EXPORT_SYMBOL_GPL(gr_check_group_change);
+#endif
+
diff --git b/grsecurity/gracl_alloc.c b/grsecurity/gracl_alloc.c
new file mode 100644
index 000000000..9adc75c94
--- /dev/null
+++ b/grsecurity/gracl_alloc.c
@@ -0,0 +1,105 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <linux/gracl.h>
+#include <linux/grsecurity.h>
+
+static struct gr_alloc_state __current_alloc_state = { 1, 1, NULL };
+struct gr_alloc_state *current_alloc_state = &__current_alloc_state;
+
+static int
+alloc_pop(void)
+{
+	if (current_alloc_state->alloc_stack_next == 1)
+		return 0;
+
+	kfree(current_alloc_state->alloc_stack[current_alloc_state->alloc_stack_next - 2]);
+
+	current_alloc_state->alloc_stack_next--;
+
+	return 1;
+}
+
+static int
+alloc_push(void *buf)
+{
+	if (current_alloc_state->alloc_stack_next >= current_alloc_state->alloc_stack_size)
+		return 1;
+
+	current_alloc_state->alloc_stack[current_alloc_state->alloc_stack_next - 1] = buf;
+
+	current_alloc_state->alloc_stack_next++;
+
+	return 0;
+}
+
+void *
+acl_alloc(unsigned long len)
+{
+	void *ret = NULL;
+
+	if (!len || len > PAGE_SIZE)
+		goto out;
+
+	ret = kmalloc(len, GFP_KERNEL);
+
+	if (ret) {
+		if (alloc_push(ret)) {
+			kfree(ret);
+			ret = NULL;
+		}
+	}
+
+out:
+	return ret;
+}
+
+void *
+acl_alloc_num(unsigned long num, unsigned long len)
+{
+	if (!len || (num > (PAGE_SIZE / len)))
+		return NULL;
+
+	return acl_alloc(num * len);
+}
+
+void
+acl_free_all(void)
+{
+	if (!current_alloc_state->alloc_stack)
+		return;
+
+	while (alloc_pop()) ;
+
+	if (current_alloc_state->alloc_stack) {
+		if ((current_alloc_state->alloc_stack_size * sizeof (void *)) <= PAGE_SIZE)
+			kfree(current_alloc_state->alloc_stack);
+		else
+			vfree(current_alloc_state->alloc_stack);
+	}
+
+	current_alloc_state->alloc_stack = NULL;
+	current_alloc_state->alloc_stack_size = 1;
+	current_alloc_state->alloc_stack_next = 1;
+
+	return;
+}
+
+int
+acl_alloc_stack_init(unsigned long size)
+{
+	if ((size * sizeof (void *)) <= PAGE_SIZE)
+		current_alloc_state->alloc_stack =
+		    (void **) kmalloc(size * sizeof (void *), GFP_KERNEL);
+	else
+		current_alloc_state->alloc_stack = (void **) vmalloc(size * sizeof (void *));
+
+	current_alloc_state->alloc_stack_size = size;
+	current_alloc_state->alloc_stack_next = 1;
+
+	if (!current_alloc_state->alloc_stack)
+		return 0;
+	else
+		return 1;
+}
diff --git b/grsecurity/gracl_cap.c b/grsecurity/gracl_cap.c
new file mode 100644
index 000000000..8747091f6
--- /dev/null
+++ b/grsecurity/gracl_cap.c
@@ -0,0 +1,96 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/gracl.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+extern const char *captab_log[];
+extern int captab_log_entries;
+
+int gr_learn_cap(const struct task_struct *task, const struct cred *cred, const int cap, bool log)
+{
+	struct acl_subject_label *curracl;
+
+	if (!gr_acl_is_enabled())
+		return 1;
+
+	curracl = task->acl;
+
+	if (curracl->mode & (GR_LEARN | GR_INHERITLEARN)) {
+		if (log)
+			security_learn(GR_LEARN_AUDIT_MSG, task->role->rolename,
+			       task->role->roletype, GR_GLOBAL_UID(cred->uid),
+			       GR_GLOBAL_GID(cred->gid), task->exec_file ?
+			       gr_to_filename(task->exec_file->f_path.dentry,
+			       task->exec_file->f_path.mnt) : curracl->filename,
+			       curracl->filename, 0UL,
+			       0UL, "", (unsigned long) cap, &task->signal->saved_ip);
+		return 1;
+	}
+
+	return 0;
+}
+
+int gr_task_acl_is_capable(const struct task_struct *task, const struct cred *cred, const int cap, bool log)
+{
+	struct acl_subject_label *curracl;
+	kernel_cap_t cap_drop = __cap_empty_set, cap_mask = __cap_empty_set;
+	kernel_cap_t cap_audit = __cap_empty_set;
+
+	if (!gr_acl_is_enabled())
+		return 1;
+
+	curracl = task->acl;
+
+	cap_drop = curracl->cap_lower;
+	cap_mask = curracl->cap_mask;
+	cap_audit = curracl->cap_invert_audit;
+
+	while ((curracl = curracl->parent_subject)) {
+		/* if the cap isn't specified in the current computed mask but is specified in the
+		   current level subject, and is lowered in the current level subject, then add
+		   it to the set of dropped capabilities
+		   otherwise, add the current level subject's mask to the current computed mask
+		 */
+		if (!cap_raised(cap_mask, cap) && cap_raised(curracl->cap_mask, cap)) {
+			cap_raise(cap_mask, cap);
+			if (cap_raised(curracl->cap_lower, cap))
+				cap_raise(cap_drop, cap);
+			if (cap_raised(curracl->cap_invert_audit, cap))
+				cap_raise(cap_audit, cap);
+		}
+	}
+
+	if (!cap_raised(cap_drop, cap)) {
+		if (log && cap_raised(cap_audit, cap))
+			gr_log_cap(GR_DO_AUDIT, GR_CAP_ACL_MSG2, task, captab_log[cap]);
+		return 1;
+	}
+
+	/* only learn the capability use if the process has the capability in the
+	   general case, the two uses in sys.c of gr_learn_cap are an exception
+	   to this rule to ensure any role transition involves what the full-learned
+	   policy believes in a privileged process
+	*/
+	if (cap_raised(cred->cap_effective, cap) && gr_learn_cap(task, cred, cap, log))
+		return 1;
+
+	if (log && (cap >= 0) && (cap < captab_log_entries) && cap_raised(cred->cap_effective, cap) && !cap_raised(cap_audit, cap))
+		gr_log_cap(GR_DONT_AUDIT, GR_CAP_ACL_MSG, task, captab_log[cap]);
+
+	return 0;
+}
+
+int
+gr_acl_is_capable(const int cap)
+{
+	return gr_task_acl_is_capable(current, current_cred(), cap, true);
+}
+
+int
+gr_acl_is_capable_nolog(const int cap)
+{
+	return gr_task_acl_is_capable(current, current_cred(), cap, false);
+}
+
diff --git b/grsecurity/gracl_compat.c b/grsecurity/gracl_compat.c
new file mode 100644
index 000000000..a43dd06a2
--- /dev/null
+++ b/grsecurity/gracl_compat.c
@@ -0,0 +1,269 @@
+#include <linux/kernel.h>
+#include <linux/gracl.h>
+#include <linux/compat.h>
+#include <linux/gracl_compat.h>
+
+#include <asm/uaccess.h>
+
+int copy_gr_arg_wrapper_compat(const char *buf, struct gr_arg_wrapper *uwrap)
+{
+	struct gr_arg_wrapper_compat uwrapcompat;
+
+        if (copy_from_user(&uwrapcompat, buf, sizeof(uwrapcompat)))
+                return -EFAULT;
+
+        if ((uwrapcompat.version != GRSECURITY_VERSION) ||
+	    (uwrapcompat.size != sizeof(struct gr_arg_compat)))  
+                return -EINVAL;
+
+	uwrap->arg = compat_ptr(uwrapcompat.arg);
+	uwrap->version = uwrapcompat.version;
+	uwrap->size = sizeof(struct gr_arg);
+
+        return 0;
+}
+
+int copy_gr_arg_compat(const struct gr_arg __user *buf, struct gr_arg *arg)
+{
+	struct gr_arg_compat argcompat;
+
+        if (copy_from_user(&argcompat, buf, sizeof(argcompat)))
+                return -EFAULT;
+
+	arg->role_db.r_table = compat_ptr(argcompat.role_db.r_table);
+	arg->role_db.num_pointers = argcompat.role_db.num_pointers;
+	arg->role_db.num_roles = argcompat.role_db.num_roles;
+	arg->role_db.num_domain_children = argcompat.role_db.num_domain_children;
+	arg->role_db.num_subjects = argcompat.role_db.num_subjects;
+	arg->role_db.num_objects = argcompat.role_db.num_objects;
+
+	memcpy(&arg->pw, &argcompat.pw, sizeof(arg->pw));
+	memcpy(&arg->salt, &argcompat.salt, sizeof(arg->salt));
+	memcpy(&arg->sum, &argcompat.sum, sizeof(arg->sum));
+	memcpy(&arg->sp_role, &argcompat.sp_role, sizeof(arg->sp_role));
+	arg->sprole_pws = compat_ptr(argcompat.sprole_pws);
+	arg->segv_device = argcompat.segv_device;
+	arg->segv_inode = argcompat.segv_inode;
+	arg->segv_uid = argcompat.segv_uid;
+	arg->num_sprole_pws = argcompat.num_sprole_pws;
+	arg->mode = argcompat.mode;
+
+	return 0;
+}
+
+int copy_acl_object_label_compat(struct acl_object_label *obj, const struct acl_object_label *userp)
+{
+	struct acl_object_label_compat objcompat;
+
+	if (copy_from_user(&objcompat, userp, sizeof(objcompat)))
+                return -EFAULT;
+
+	obj->filename = compat_ptr(objcompat.filename);
+	obj->inode = objcompat.inode;
+	obj->device = objcompat.device;
+	obj->mode = objcompat.mode;
+
+	obj->nested = compat_ptr(objcompat.nested);
+	obj->globbed = compat_ptr(objcompat.globbed);
+
+	obj->prev = compat_ptr(objcompat.prev);
+	obj->next = compat_ptr(objcompat.next);
+
+	return 0;
+}
+
+int copy_acl_subject_label_compat(struct acl_subject_label *subj, const struct acl_subject_label *userp)
+{
+	unsigned int i;
+	struct acl_subject_label_compat subjcompat;
+
+	if (copy_from_user(&subjcompat, userp, sizeof(subjcompat)))
+                return -EFAULT;
+
+	subj->filename = compat_ptr(subjcompat.filename);
+	subj->inode = subjcompat.inode;
+	subj->device = subjcompat.device;
+	subj->mode = subjcompat.mode;
+	subj->cap_mask = subjcompat.cap_mask;
+	subj->cap_lower = subjcompat.cap_lower;
+	subj->cap_invert_audit = subjcompat.cap_invert_audit;
+
+	for (i = 0; i < GR_NLIMITS; i++) {
+		if (subjcompat.res[i].rlim_cur == COMPAT_RLIM_INFINITY)
+			subj->res[i].rlim_cur = RLIM_INFINITY;
+		else
+			subj->res[i].rlim_cur = subjcompat.res[i].rlim_cur;
+		if (subjcompat.res[i].rlim_max == COMPAT_RLIM_INFINITY)
+			subj->res[i].rlim_max = RLIM_INFINITY;
+		else
+			subj->res[i].rlim_max = subjcompat.res[i].rlim_max;
+	}
+	subj->resmask = subjcompat.resmask;
+
+	subj->user_trans_type = subjcompat.user_trans_type;
+	subj->group_trans_type = subjcompat.group_trans_type;
+	subj->user_transitions = compat_ptr(subjcompat.user_transitions);
+	subj->group_transitions = compat_ptr(subjcompat.group_transitions);
+	subj->user_trans_num = subjcompat.user_trans_num;
+	subj->group_trans_num = subjcompat.group_trans_num;
+
+	memcpy(&subj->sock_families, &subjcompat.sock_families, sizeof(subj->sock_families));
+	memcpy(&subj->ip_proto, &subjcompat.ip_proto, sizeof(subj->ip_proto));
+	subj->ip_type = subjcompat.ip_type;
+	subj->ips = compat_ptr(subjcompat.ips);
+	subj->ip_num = subjcompat.ip_num;
+	subj->inaddr_any_override = subjcompat.inaddr_any_override;
+
+	subj->crashes = subjcompat.crashes;
+	subj->expires = subjcompat.expires;
+
+	subj->parent_subject = compat_ptr(subjcompat.parent_subject);
+	subj->hash = compat_ptr(subjcompat.hash);
+	subj->prev = compat_ptr(subjcompat.prev);
+	subj->next = compat_ptr(subjcompat.next);
+
+	subj->obj_hash = compat_ptr(subjcompat.obj_hash);
+	subj->obj_hash_size = subjcompat.obj_hash_size;
+	subj->pax_flags = subjcompat.pax_flags;
+
+	return 0;
+}
+
+int copy_acl_role_label_compat(struct acl_role_label *role, const struct acl_role_label *userp)
+{
+	struct acl_role_label_compat rolecompat;
+
+	if (copy_from_user(&rolecompat, userp, sizeof(rolecompat)))
+                return -EFAULT;
+
+	role->rolename = compat_ptr(rolecompat.rolename);
+	role->uidgid = rolecompat.uidgid;
+	role->roletype = rolecompat.roletype;
+
+	role->auth_attempts = rolecompat.auth_attempts;
+	role->expires = rolecompat.expires;
+
+	role->root_label = compat_ptr(rolecompat.root_label);
+	role->hash = compat_ptr(rolecompat.hash);
+
+	role->prev = compat_ptr(rolecompat.prev);
+	role->next = compat_ptr(rolecompat.next);
+
+	role->transitions = compat_ptr(rolecompat.transitions);
+	role->allowed_ips = compat_ptr(rolecompat.allowed_ips);
+	role->domain_children = compat_ptr(rolecompat.domain_children);
+	role->domain_child_num = rolecompat.domain_child_num;
+
+	role->umask = rolecompat.umask;
+
+	role->subj_hash = compat_ptr(rolecompat.subj_hash);
+	role->subj_hash_size = rolecompat.subj_hash_size;
+
+	return 0;
+}
+
+int copy_role_allowed_ip_compat(struct role_allowed_ip *roleip, const struct role_allowed_ip *userp)
+{
+	struct role_allowed_ip_compat roleip_compat;
+
+	if (copy_from_user(&roleip_compat, userp, sizeof(roleip_compat)))
+                return -EFAULT;
+
+	roleip->addr = roleip_compat.addr;
+	roleip->netmask = roleip_compat.netmask;
+
+	roleip->prev = compat_ptr(roleip_compat.prev);
+	roleip->next = compat_ptr(roleip_compat.next);
+
+	return 0;
+}
+
+int copy_role_transition_compat(struct role_transition *trans, const struct role_transition *userp)
+{
+	struct role_transition_compat trans_compat;
+
+	if (copy_from_user(&trans_compat, userp, sizeof(trans_compat)))
+                return -EFAULT;
+
+	trans->rolename = compat_ptr(trans_compat.rolename);
+
+	trans->prev = compat_ptr(trans_compat.prev);
+	trans->next = compat_ptr(trans_compat.next);
+
+	return 0;
+
+}
+
+int copy_gr_hash_struct_compat(struct gr_hash_struct *hash, const struct gr_hash_struct *userp)
+{
+	struct gr_hash_struct_compat hash_compat;
+
+	if (copy_from_user(&hash_compat, userp, sizeof(hash_compat)))
+                return -EFAULT;
+
+	hash->table = compat_ptr(hash_compat.table);
+	hash->nametable = compat_ptr(hash_compat.nametable);
+	hash->first = compat_ptr(hash_compat.first);
+
+	hash->table_size = hash_compat.table_size;
+	hash->used_size = hash_compat.used_size;
+
+	hash->type = hash_compat.type;
+
+	return 0;
+}
+
+int copy_pointer_from_array_compat(void *ptr, unsigned long idx, const void *userp)
+{
+	compat_uptr_t ptrcompat;
+
+	if (copy_from_user(&ptrcompat, userp + (idx * sizeof(ptrcompat)), sizeof(ptrcompat)))
+                return -EFAULT;
+
+	*(void **)ptr = compat_ptr(ptrcompat);
+
+	return 0;
+}
+
+int copy_acl_ip_label_compat(struct acl_ip_label *ip, const struct acl_ip_label *userp)
+{
+	struct acl_ip_label_compat ip_compat;
+
+	if (copy_from_user(&ip_compat, userp, sizeof(ip_compat)))
+                return -EFAULT;
+
+	ip->iface = compat_ptr(ip_compat.iface);
+	ip->addr = ip_compat.addr;
+	ip->netmask = ip_compat.netmask;
+	ip->low = ip_compat.low;
+	ip->high = ip_compat.high;
+	ip->mode = ip_compat.mode;
+	ip->type = ip_compat.type;
+
+	memcpy(&ip->proto, &ip_compat.proto, sizeof(ip->proto));
+
+	ip->prev = compat_ptr(ip_compat.prev);
+	ip->next = compat_ptr(ip_compat.next);
+
+	return 0;
+}
+
+int copy_sprole_pw_compat(struct sprole_pw *pw, unsigned long idx, const struct sprole_pw *userp)
+{
+	struct sprole_pw_compat pw_compat;
+
+	if (copy_from_user(&pw_compat, (const void *)userp + (sizeof(pw_compat) * idx), sizeof(pw_compat)))
+                return -EFAULT;
+
+	pw->rolename = compat_ptr(pw_compat.rolename);
+	memcpy(&pw->salt, pw_compat.salt, sizeof(pw->salt));
+	memcpy(&pw->sum, pw_compat.sum, sizeof(pw->sum));
+
+	return 0;
+}
+
+size_t get_gr_arg_wrapper_size_compat(void)
+{
+	return sizeof(struct gr_arg_wrapper_compat);
+}
+
diff --git b/grsecurity/gracl_fs.c b/grsecurity/gracl_fs.c
new file mode 100644
index 000000000..fce7f71fb
--- /dev/null
+++ b/grsecurity/gracl_fs.c
@@ -0,0 +1,448 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/types.h>
+#include <linux/fs.h>
+#include <linux/file.h>
+#include <linux/stat.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+#include <linux/gracl.h>
+
+umode_t
+gr_acl_umask(void)
+{
+	if (unlikely(!gr_acl_is_enabled()))
+		return 0;
+
+	return current->role->umask;
+}
+
+__u32
+gr_acl_handle_hidden_file(const struct dentry * dentry,
+			  const struct vfsmount * mnt)
+{
+	__u32 mode;
+
+	if (unlikely(d_is_negative(dentry)))
+		return GR_FIND;
+
+	mode =
+	    gr_search_file(dentry, GR_FIND | GR_AUDIT_FIND | GR_SUPPRESS, mnt);
+
+	if (unlikely(mode & GR_FIND && mode & GR_AUDIT_FIND)) {
+		gr_log_fs_rbac_generic(GR_DO_AUDIT, GR_HIDDEN_ACL_MSG, dentry, mnt);
+		return mode;
+	} else if (unlikely(!(mode & GR_FIND) && !(mode & GR_SUPPRESS))) {
+		gr_log_fs_rbac_generic(GR_DONT_AUDIT, GR_HIDDEN_ACL_MSG, dentry, mnt);
+		return 0;
+	} else if (unlikely(!(mode & GR_FIND)))
+		return 0;
+
+	return GR_FIND;
+}
+
+__u32
+gr_acl_handle_open(const struct dentry * dentry, const struct vfsmount * mnt,
+		   int acc_mode)
+{
+	__u32 reqmode = GR_FIND;
+	__u32 mode;
+
+	if (unlikely(d_is_negative(dentry)))
+		return reqmode;
+
+	if (acc_mode & MAY_APPEND)
+		reqmode |= GR_APPEND;
+	else if (acc_mode & MAY_WRITE)
+		reqmode |= GR_WRITE;
+	if ((acc_mode & MAY_READ) && !d_is_dir(dentry))
+		reqmode |= GR_READ;
+
+	mode =
+	    gr_search_file(dentry, reqmode | to_gr_audit(reqmode) | GR_SUPPRESS,
+			   mnt);
+
+	if (unlikely(((mode & reqmode) == reqmode) && mode & GR_AUDITS)) {
+		gr_log_fs_rbac_mode2(GR_DO_AUDIT, GR_OPEN_ACL_MSG, dentry, mnt,
+			       reqmode & GR_READ ? " reading" : "",
+			       reqmode & GR_WRITE ? " writing" : reqmode &
+			       GR_APPEND ? " appending" : "");
+		return reqmode;
+	} else
+	    if (unlikely((mode & reqmode) != reqmode && !(mode & GR_SUPPRESS)))
+	{
+		gr_log_fs_rbac_mode2(GR_DONT_AUDIT, GR_OPEN_ACL_MSG, dentry, mnt,
+			       reqmode & GR_READ ? " reading" : "",
+			       reqmode & GR_WRITE ? " writing" : reqmode &
+			       GR_APPEND ? " appending" : "");
+		return 0;
+	} else if (unlikely((mode & reqmode) != reqmode))
+		return 0;
+
+	return reqmode;
+}
+
+__u32
+gr_acl_handle_creat(const struct dentry * dentry,
+		    const struct dentry * p_dentry,
+		    const struct vfsmount * p_mnt, int open_flags, int acc_mode,
+		    const int imode)
+{
+	__u32 reqmode = GR_WRITE | GR_CREATE;
+	__u32 mode;
+
+	if (acc_mode & MAY_APPEND)
+		reqmode |= GR_APPEND;
+	// if a directory was required or the directory already exists, then
+	// don't count this open as a read
+	if ((acc_mode & MAY_READ) &&
+	    !((open_flags & O_DIRECTORY) || d_is_dir(dentry)))
+		reqmode |= GR_READ;
+	if ((open_flags & O_CREAT) &&
+	    ((imode & S_ISUID) || ((imode & (S_ISGID | S_IXGRP)) == (S_ISGID | S_IXGRP))))
+		reqmode |= GR_SETID;
+
+	mode =
+	    gr_check_create(dentry, p_dentry, p_mnt,
+			    reqmode | to_gr_audit(reqmode) | GR_SUPPRESS);
+
+	if (unlikely(((mode & reqmode) == reqmode) && mode & GR_AUDITS)) {
+		gr_log_fs_rbac_mode2(GR_DO_AUDIT, GR_CREATE_ACL_MSG, dentry, p_mnt,
+			       reqmode & GR_READ ? " reading" : "",
+			       reqmode & GR_WRITE ? " writing" : reqmode &
+			       GR_APPEND ? " appending" : "");
+		return reqmode;
+	} else
+	    if (unlikely((mode & reqmode) != reqmode && !(mode & GR_SUPPRESS)))
+	{
+		gr_log_fs_rbac_mode2(GR_DONT_AUDIT, GR_CREATE_ACL_MSG, dentry, p_mnt,
+			       reqmode & GR_READ ? " reading" : "",
+			       reqmode & GR_WRITE ? " writing" : reqmode &
+			       GR_APPEND ? " appending" : "");
+		return 0;
+	} else if (unlikely((mode & reqmode) != reqmode))
+		return 0;
+
+	return reqmode;
+}
+
+__u32
+gr_acl_handle_access(const struct dentry * dentry, const struct vfsmount * mnt,
+		     const int fmode)
+{
+	__u32 mode, reqmode = GR_FIND;
+
+	if ((fmode & S_IXOTH) && !d_is_dir(dentry))
+		reqmode |= GR_EXEC;
+	if (fmode & S_IWOTH)
+		reqmode |= GR_WRITE;
+	if (fmode & S_IROTH)
+		reqmode |= GR_READ;
+
+	mode =
+	    gr_search_file(dentry, reqmode | to_gr_audit(reqmode) | GR_SUPPRESS,
+			   mnt);
+
+	if (unlikely(((mode & reqmode) == reqmode) && mode & GR_AUDITS)) {
+		gr_log_fs_rbac_mode3(GR_DO_AUDIT, GR_ACCESS_ACL_MSG, dentry, mnt,
+			       reqmode & GR_READ ? " reading" : "",
+			       reqmode & GR_WRITE ? " writing" : "",
+			       reqmode & GR_EXEC ? " executing" : "");
+		return reqmode;
+	} else
+	    if (unlikely((mode & reqmode) != reqmode && !(mode & GR_SUPPRESS)))
+	{
+		gr_log_fs_rbac_mode3(GR_DONT_AUDIT, GR_ACCESS_ACL_MSG, dentry, mnt,
+			       reqmode & GR_READ ? " reading" : "",
+			       reqmode & GR_WRITE ? " writing" : "",
+			       reqmode & GR_EXEC ? " executing" : "");
+		return 0;
+	} else if (unlikely((mode & reqmode) != reqmode))
+		return 0;
+
+	return reqmode;
+}
+
+static __u32 generic_fs_handler(const struct dentry *dentry, const struct vfsmount *mnt, __u32 reqmode, const char *fmt)
+{
+	__u32 mode;
+
+	mode = gr_search_file(dentry, reqmode | to_gr_audit(reqmode) | GR_SUPPRESS, mnt);
+
+	if (unlikely(((mode & (reqmode)) == (reqmode)) && mode & GR_AUDITS)) {
+		gr_log_fs_rbac_generic(GR_DO_AUDIT, fmt, dentry, mnt);
+		return mode;
+	} else if (unlikely((mode & (reqmode)) != (reqmode) && !(mode & GR_SUPPRESS))) {
+		gr_log_fs_rbac_generic(GR_DONT_AUDIT, fmt, dentry, mnt);
+		return 0;
+	} else if (unlikely((mode & (reqmode)) != (reqmode)))
+		return 0;
+
+	return (reqmode);
+}
+
+__u32
+gr_acl_handle_rmdir(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_WRITE | GR_DELETE , GR_RMDIR_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_unlink(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_WRITE | GR_DELETE , GR_UNLINK_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_truncate(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_WRITE, GR_TRUNCATE_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_utime(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_WRITE, GR_ATIME_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_chmod(const struct dentry *dentry, const struct vfsmount *mnt,
+		     umode_t *modeptr)
+{
+	umode_t mode;
+	struct inode *inode = d_backing_inode(dentry);
+
+	*modeptr &= ~gr_acl_umask();
+	mode = *modeptr;
+
+	if (unlikely(inode && S_ISSOCK(inode->i_mode)))
+		return 1;
+
+	if (unlikely(!d_is_dir(dentry) &&
+		     ((mode & S_ISUID) || ((mode & (S_ISGID | S_IXGRP)) == (S_ISGID | S_IXGRP))))) {
+		return generic_fs_handler(dentry, mnt, GR_WRITE | GR_SETID,
+				   GR_CHMOD_ACL_MSG);
+	} else {
+		return generic_fs_handler(dentry, mnt, GR_WRITE, GR_CHMOD_ACL_MSG);
+	}
+}
+
+__u32
+gr_acl_handle_chown(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_WRITE, GR_CHOWN_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_setxattr(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_WRITE, GR_SETXATTR_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_removexattr(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_WRITE, GR_REMOVEXATTR_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_execve(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_EXEC, GR_EXEC_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_unix(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return generic_fs_handler(dentry, mnt, GR_READ | GR_WRITE,
+			   GR_UNIXCONNECT_ACL_MSG);
+}
+
+/* hardlinks require at minimum create and link permission,
+   any additional privilege required is based on the
+   privilege of the file being linked to
+*/
+__u32
+gr_acl_handle_link(const struct dentry * new_dentry,
+		   const struct dentry * parent_dentry,
+		   const struct vfsmount * parent_mnt,
+		   const struct dentry * old_dentry,
+		   const struct vfsmount * old_mnt, const struct filename *to)
+{
+	__u32 mode;
+	__u32 needmode = GR_CREATE | GR_LINK;
+	__u32 needaudit = GR_AUDIT_CREATE | GR_AUDIT_LINK;
+
+	mode =
+	    gr_check_link(new_dentry, parent_dentry, parent_mnt, old_dentry,
+			  old_mnt);
+
+	if (unlikely(((mode & needmode) == needmode) && (mode & needaudit))) {
+		gr_log_fs_rbac_str(GR_DO_AUDIT, GR_LINK_ACL_MSG, old_dentry, old_mnt, to->name);
+		return mode;
+	} else if (unlikely(((mode & needmode) != needmode) && !(mode & GR_SUPPRESS))) {
+		gr_log_fs_rbac_str(GR_DONT_AUDIT, GR_LINK_ACL_MSG, old_dentry, old_mnt, to->name);
+		return 0;
+	} else if (unlikely((mode & needmode) != needmode))
+		return 0;
+
+	return 1;
+}
+
+__u32
+gr_acl_handle_symlink(const struct dentry * new_dentry,
+		      const struct dentry * parent_dentry,
+		      const struct vfsmount * parent_mnt, const struct filename *from)
+{
+	__u32 needmode = GR_WRITE | GR_CREATE;
+	__u32 mode;
+
+	mode =
+	    gr_check_create(new_dentry, parent_dentry, parent_mnt,
+			    GR_CREATE | GR_AUDIT_CREATE |
+			    GR_WRITE | GR_AUDIT_WRITE | GR_SUPPRESS);
+
+	if (unlikely(mode & GR_WRITE && mode & GR_AUDITS)) {
+		gr_log_fs_str_rbac(GR_DO_AUDIT, GR_SYMLINK_ACL_MSG, from->name, new_dentry, parent_mnt);
+		return mode;
+	} else if (unlikely(((mode & needmode) != needmode) && !(mode & GR_SUPPRESS))) {
+		gr_log_fs_str_rbac(GR_DONT_AUDIT, GR_SYMLINK_ACL_MSG, from->name, new_dentry, parent_mnt);
+		return 0;
+	} else if (unlikely((mode & needmode) != needmode))
+		return 0;
+
+	return (GR_WRITE | GR_CREATE);
+}
+
+static __u32 generic_fs_create_handler(const struct dentry *new_dentry, const struct dentry *parent_dentry, const struct vfsmount *parent_mnt, __u32 reqmode, const char *fmt)
+{
+	__u32 mode;
+
+	mode = gr_check_create(new_dentry, parent_dentry, parent_mnt, reqmode | to_gr_audit(reqmode) | GR_SUPPRESS);
+
+	if (unlikely(((mode & (reqmode)) == (reqmode)) && mode & GR_AUDITS)) {
+		gr_log_fs_rbac_generic(GR_DO_AUDIT, fmt, new_dentry, parent_mnt);
+		return mode;
+	} else if (unlikely((mode & (reqmode)) != (reqmode) && !(mode & GR_SUPPRESS))) {
+		gr_log_fs_rbac_generic(GR_DONT_AUDIT, fmt, new_dentry, parent_mnt);
+		return 0;
+	} else if (unlikely((mode & (reqmode)) != (reqmode)))
+		return 0;
+
+	return (reqmode);
+}
+
+__u32
+gr_acl_handle_mknod(const struct dentry * new_dentry,
+		    const struct dentry * parent_dentry,
+		    const struct vfsmount * parent_mnt,
+		    const int mode)
+{
+	__u32 reqmode = GR_WRITE | GR_CREATE;
+	if (unlikely((mode & S_ISUID) || ((mode & (S_ISGID | S_IXGRP)) == (S_ISGID | S_IXGRP))))
+		reqmode |= GR_SETID;
+
+	return generic_fs_create_handler(new_dentry, parent_dentry, parent_mnt,
+				  reqmode, GR_MKNOD_ACL_MSG);
+}
+
+__u32
+gr_acl_handle_mkdir(const struct dentry *new_dentry,
+		    const struct dentry *parent_dentry,
+		    const struct vfsmount *parent_mnt)
+{
+	return generic_fs_create_handler(new_dentry, parent_dentry, parent_mnt,
+				  GR_WRITE | GR_CREATE, GR_MKDIR_ACL_MSG);
+}
+
+#define RENAME_CHECK_SUCCESS(old, new) \
+	(((old & (GR_WRITE | GR_READ)) == (GR_WRITE | GR_READ)) && \
+	 ((new & (GR_WRITE | GR_READ)) == (GR_WRITE | GR_READ)))
+
+int
+gr_acl_handle_rename(struct dentry *new_dentry,
+		     struct dentry *parent_dentry,
+		     const struct vfsmount *parent_mnt,
+		     struct dentry *old_dentry,
+		     struct inode *old_parent_inode,
+		     struct vfsmount *old_mnt, const struct filename *newname, unsigned int flags)
+{
+	__u32 comp1, comp2;
+	int error = 0;
+
+	if (unlikely(!gr_acl_is_enabled()))
+		return 0;
+
+	if (flags & RENAME_EXCHANGE) {
+		comp1 = gr_search_file(new_dentry, GR_READ | GR_WRITE |
+				       GR_AUDIT_READ | GR_AUDIT_WRITE |
+				       GR_SUPPRESS, parent_mnt);
+		comp2 =
+		    gr_search_file(old_dentry,
+				   GR_READ | GR_WRITE | GR_AUDIT_READ |
+				   GR_AUDIT_WRITE | GR_SUPPRESS, old_mnt);
+	} else if (d_is_negative(new_dentry)) {
+		comp1 = gr_check_create(new_dentry, parent_dentry, parent_mnt,
+					GR_READ | GR_WRITE | GR_CREATE | GR_AUDIT_READ |
+					GR_AUDIT_WRITE | GR_AUDIT_CREATE | GR_SUPPRESS);
+		comp2 = gr_search_file(old_dentry, GR_READ | GR_WRITE |
+				       GR_DELETE | GR_AUDIT_DELETE |
+				       GR_AUDIT_READ | GR_AUDIT_WRITE |
+				       GR_SUPPRESS, old_mnt);
+	} else {
+		comp1 = gr_search_file(new_dentry, GR_READ | GR_WRITE |
+				       GR_CREATE | GR_DELETE |
+				       GR_AUDIT_CREATE | GR_AUDIT_DELETE |
+				       GR_AUDIT_READ | GR_AUDIT_WRITE |
+				       GR_SUPPRESS, parent_mnt);
+		comp2 =
+		    gr_search_file(old_dentry,
+				   GR_READ | GR_WRITE | GR_AUDIT_READ |
+				   GR_DELETE | GR_AUDIT_DELETE |
+				   GR_AUDIT_WRITE | GR_SUPPRESS, old_mnt);
+	}
+
+	if (RENAME_CHECK_SUCCESS(comp1, comp2) &&
+	    ((comp1 & GR_AUDITS) || (comp2 & GR_AUDITS)))
+		gr_log_fs_rbac_str(GR_DO_AUDIT, GR_RENAME_ACL_MSG, old_dentry, old_mnt, newname->name);
+	else if (!RENAME_CHECK_SUCCESS(comp1, comp2) && !(comp1 & GR_SUPPRESS)
+		 && !(comp2 & GR_SUPPRESS)) {
+		gr_log_fs_rbac_str(GR_DONT_AUDIT, GR_RENAME_ACL_MSG, old_dentry, old_mnt, newname->name);
+		error = -EACCES;
+	} else if (unlikely(!RENAME_CHECK_SUCCESS(comp1, comp2)))
+		error = -EACCES;
+
+	return error;
+}
+
+void
+gr_acl_handle_exit(void)
+{
+	u16 id;
+	char *rolename;
+
+	if (unlikely(current->acl_sp_role && gr_acl_is_enabled() &&
+	    !(current->role->roletype & GR_ROLE_PERSIST))) {
+		id = current->acl_role_id;
+		rolename = current->role->rolename;
+		gr_set_acls(1);
+		gr_log_str_int(GR_DONT_AUDIT_GOOD, GR_SPROLEL_ACL_MSG, rolename, id);
+	}
+
+	gr_put_exec_file(current);
+	return;
+}
+
+int
+gr_acl_handle_procpidmem(const struct task_struct *task)
+{
+	if (unlikely(!gr_acl_is_enabled()))
+		return 0;
+
+	if (task != current && (task->acl->mode & GR_PROTPROCFD) &&
+	    !(current->acl->mode & GR_POVERRIDE) &&
+	    !(current->role->roletype & GR_ROLE_GOD))
+		return -EACCES;
+
+	return 0;
+}
diff --git b/grsecurity/gracl_ip.c b/grsecurity/gracl_ip.c
new file mode 100644
index 000000000..d877c3879
--- /dev/null
+++ b/grsecurity/gracl_ip.c
@@ -0,0 +1,387 @@
+#include <linux/kernel.h>
+#include <asm/uaccess.h>
+#include <asm/errno.h>
+#include <net/sock.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/net.h>
+#include <linux/in.h>
+#include <linux/skbuff.h>
+#include <linux/ip.h>
+#include <linux/udp.h>
+#include <linux/types.h>
+#include <linux/sched.h>
+#include <linux/netdevice.h>
+#include <linux/inetdevice.h>
+#include <linux/gracl.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+#define GR_BIND			0x01
+#define GR_CONNECT		0x02
+#define GR_INVERT		0x04
+#define GR_BINDOVERRIDE		0x08
+#define GR_CONNECTOVERRIDE	0x10
+#define GR_SOCK_FAMILY		0x20
+
+static const char * gr_protocols[IPPROTO_MAX] = {
+	"ip", "icmp", "igmp", "ggp", "ipencap", "st", "tcp", "cbt",
+	"egp", "igp", "bbn-rcc", "nvp", "pup", "argus", "emcon", "xnet",
+	"chaos", "udp", "mux", "dcn", "hmp", "prm", "xns-idp", "trunk-1",
+	"trunk-2", "leaf-1", "leaf-2", "rdp", "irtp", "iso-tp4", "netblt", "mfe-nsp",
+	"merit-inp", "sep", "3pc", "idpr", "xtp", "ddp", "idpr-cmtp", "tp++",
+	"il", "ipv6", "sdrp", "ipv6-route", "ipv6-frag", "idrp", "rsvp", "gre",
+	"mhrp", "bna", "ipv6-crypt", "ipv6-auth", "i-nlsp", "swipe", "narp", "mobile",
+	"tlsp", "skip", "ipv6-icmp", "ipv6-nonxt", "ipv6-opts", "unknown:61", "cftp", "unknown:63",
+	"sat-expak", "kryptolan", "rvd", "ippc", "unknown:68", "sat-mon", "visa", "ipcv",
+	"cpnx", "cphb", "wsn", "pvp", "br-sat-mon", "sun-nd", "wb-mon", "wb-expak", 
+	"iso-ip", "vmtp", "secure-vmtp", "vines", "ttp", "nfsnet-igp", "dgp", "tcf", 
+	"eigrp", "ospf", "sprite-rpc", "larp", "mtp", "ax.25", "ipip", "micp",
+	"scc-sp", "etherip", "encap", "unknown:99", "gmtp", "ifmp", "pnni", "pim",
+	"aris", "scps", "qnx", "a/n", "ipcomp", "snp", "compaq-peer", "ipx-in-ip",
+	"vrrp", "pgm", "unknown:114", "l2tp", "ddx", "iatp", "stp", "srp",
+	"uti", "smp", "sm", "ptp", "isis", "fire", "crtp", "crdup",
+	"sscopmce", "iplt", "sps", "pipe", "sctp", "fc", "unkown:134", "unknown:135",
+	"unknown:136", "unknown:137", "unknown:138", "unknown:139", "unknown:140", "unknown:141", "unknown:142", "unknown:143",
+	"unknown:144", "unknown:145", "unknown:146", "unknown:147", "unknown:148", "unknown:149", "unknown:150", "unknown:151",
+	"unknown:152", "unknown:153", "unknown:154", "unknown:155", "unknown:156", "unknown:157", "unknown:158", "unknown:159",
+	"unknown:160", "unknown:161", "unknown:162", "unknown:163", "unknown:164", "unknown:165", "unknown:166", "unknown:167",
+	"unknown:168", "unknown:169", "unknown:170", "unknown:171", "unknown:172", "unknown:173", "unknown:174", "unknown:175",
+	"unknown:176", "unknown:177", "unknown:178", "unknown:179", "unknown:180", "unknown:181", "unknown:182", "unknown:183",
+	"unknown:184", "unknown:185", "unknown:186", "unknown:187", "unknown:188", "unknown:189", "unknown:190", "unknown:191",
+	"unknown:192", "unknown:193", "unknown:194", "unknown:195", "unknown:196", "unknown:197", "unknown:198", "unknown:199",
+	"unknown:200", "unknown:201", "unknown:202", "unknown:203", "unknown:204", "unknown:205", "unknown:206", "unknown:207",
+	"unknown:208", "unknown:209", "unknown:210", "unknown:211", "unknown:212", "unknown:213", "unknown:214", "unknown:215",
+	"unknown:216", "unknown:217", "unknown:218", "unknown:219", "unknown:220", "unknown:221", "unknown:222", "unknown:223",
+	"unknown:224", "unknown:225", "unknown:226", "unknown:227", "unknown:228", "unknown:229", "unknown:230", "unknown:231",
+	"unknown:232", "unknown:233", "unknown:234", "unknown:235", "unknown:236", "unknown:237", "unknown:238", "unknown:239",
+	"unknown:240", "unknown:241", "unknown:242", "unknown:243", "unknown:244", "unknown:245", "unknown:246", "unknown:247",
+	"unknown:248", "unknown:249", "unknown:250", "unknown:251", "unknown:252", "unknown:253", "unknown:254", "unknown:255",
+	};
+
+static const char * gr_socktypes[SOCK_MAX] = {
+	"unknown:0", "stream", "dgram", "raw", "rdm", "seqpacket", "unknown:6", 
+	"unknown:7", "unknown:8", "unknown:9", "packet"
+	};
+
+static const char * gr_sockfamilies[AF_MAX] = {
+	"unspec", "unix", "inet", "ax25", "ipx", "appletalk", "netrom", "bridge", "atmpvc", "x25",
+	"inet6", "rose", "decnet", "netbeui", "security", "key", "netlink", "packet", "ash",
+	"econet", "atmsvc", "rds", "sna", "irda", "ppox", "wanpipe", "llc", "ib", "mpls", "can",
+	"tipc", "bluetooth", "iucv", "rxrpc", "isdn", "phonet", "ieee802154", "ciaf", "alg",
+	"nfc", "vsock", "kcm", "qipcrtr"
+	};
+
+const char *
+gr_proto_to_name(unsigned char proto)
+{
+	return gr_protocols[proto];
+}
+
+const char *
+gr_socktype_to_name(unsigned char type)
+{
+	return gr_socktypes[type];
+}
+
+const char *
+gr_sockfamily_to_name(unsigned char family)
+{
+	return gr_sockfamilies[family];
+}
+
+extern const struct net_proto_family __rcu *net_families[NPROTO] __read_mostly;
+
+int
+gr_search_socket(const int domain, const int type, const int protocol)
+{
+	struct acl_subject_label *curr;
+	const struct cred *cred = current_cred();
+
+	if (unlikely(!gr_acl_is_enabled()))
+		goto exit;
+
+	if ((domain < 0) || (type < 0) || (protocol < 0) ||
+	    (domain >= AF_MAX) || (type >= SOCK_MAX) || (protocol >= IPPROTO_MAX))
+		goto exit;	// let the kernel handle it
+
+	curr = current->acl;
+
+	if (curr->sock_families[domain / 32] & (1U << (domain % 32))) {
+		/* the family is allowed, if this is PF_INET allow it only if
+		   the extra sock type/protocol checks pass */
+		if (domain == PF_INET)
+			goto inet_check;
+		goto exit;
+	} else {
+		if (curr->mode & (GR_LEARN | GR_INHERITLEARN)) {
+			__u32 fakeip = 0;
+			security_learn(GR_IP_LEARN_MSG, current->role->rolename,
+				       current->role->roletype, GR_GLOBAL_UID(cred->uid),
+				       GR_GLOBAL_GID(cred->gid), current->exec_file ?
+				       gr_to_filename(current->exec_file->f_path.dentry,
+				       current->exec_file->f_path.mnt) :
+				       curr->filename, curr->filename,
+				       &fakeip, domain, 0, 0, GR_SOCK_FAMILY,
+				       &current->signal->saved_ip);
+			goto exit;
+		}
+		goto exit_fail;
+	}
+
+inet_check:
+	/* the rest of this checking is for IPv4 only */
+	if (!curr->ips)
+		goto exit;
+
+	if ((curr->ip_type & (1U << type)) &&
+	    (curr->ip_proto[protocol / 32] & (1U << (protocol % 32))))
+		goto exit;
+
+	if (curr->mode & (GR_LEARN | GR_INHERITLEARN)) {
+		/* we don't place acls on raw sockets , and sometimes
+		   dgram/ip sockets are opened for ioctl and not
+		   bind/connect, so we'll fake a bind learn log */
+		if (type == SOCK_RAW || type == SOCK_PACKET) {
+			__u32 fakeip = 0;
+			security_learn(GR_IP_LEARN_MSG, current->role->rolename,
+				       current->role->roletype, GR_GLOBAL_UID(cred->uid),
+				       GR_GLOBAL_GID(cred->gid), current->exec_file ?
+				       gr_to_filename(current->exec_file->f_path.dentry,
+				       current->exec_file->f_path.mnt) :
+				       curr->filename, curr->filename,
+				       &fakeip, 0, type,
+				       protocol, GR_CONNECT, &current->signal->saved_ip);
+		} else if ((type == SOCK_DGRAM) && (protocol == IPPROTO_IP)) {
+			__u32 fakeip = 0;
+			security_learn(GR_IP_LEARN_MSG, current->role->rolename,
+				       current->role->roletype, GR_GLOBAL_UID(cred->uid),
+				       GR_GLOBAL_GID(cred->gid), current->exec_file ?
+				       gr_to_filename(current->exec_file->f_path.dentry,
+				       current->exec_file->f_path.mnt) :
+				       curr->filename, curr->filename,
+				       &fakeip, 0, type,
+				       protocol, GR_BIND, &current->signal->saved_ip);
+		}
+		/* we'll log when they use connect or bind */
+		goto exit;
+	}
+
+exit_fail:
+	if (domain == PF_INET)
+		gr_log_str3(GR_DONT_AUDIT, GR_SOCK_MSG, gr_sockfamily_to_name(domain), 
+			    gr_socktype_to_name(type), gr_proto_to_name(protocol));
+	else if (rcu_access_pointer(net_families[domain]) != NULL)
+		gr_log_str2_int(GR_DONT_AUDIT, GR_SOCK_NOINET_MSG, gr_sockfamily_to_name(domain), 
+			    gr_socktype_to_name(type), protocol);
+
+	return 0;
+exit:
+	return 1;
+}
+
+int check_ip_policy(struct acl_ip_label *ip, __u32 ip_addr, __u16 ip_port, __u8 protocol, const int mode, const int type, __u32 our_addr, __u32 our_netmask)
+{
+	if ((ip->mode & mode) &&
+	    (ip_port >= ip->low) &&
+	    (ip_port <= ip->high) &&
+	    ((ntohl(ip_addr) & our_netmask) ==
+	     (ntohl(our_addr) & our_netmask))
+	    && (ip->proto[protocol / 32] & (1U << (protocol % 32)))
+	    && (ip->type & (1U << type))) {
+		if (ip->mode & GR_INVERT)
+			return 2; // specifically denied
+		else
+			return 1; // allowed
+	}
+
+	return 0; // not specifically allowed, may continue parsing
+}
+
+static int
+gr_search_connectbind(const int full_mode, struct sock *sk,
+		      struct sockaddr_in *addr, const int type)
+{
+	char iface[IFNAMSIZ] = {0};
+	struct acl_subject_label *curr;
+	struct acl_ip_label *ip;
+	struct inet_sock *isk;
+	struct net_device *dev;
+	struct in_device *idev;
+	unsigned long i;
+	int ret;
+	int mode = full_mode & (GR_BIND | GR_CONNECT);
+	__u32 ip_addr = 0;
+	__u32 our_addr;
+	__u32 our_netmask;
+	char *p;
+	__u16 ip_port = 0;
+	const struct cred *cred = current_cred();
+
+	if (unlikely(!gr_acl_is_enabled() || sk->sk_family != PF_INET))
+		return 0;
+
+	curr = current->acl;
+	isk = inet_sk(sk);
+
+	/* INADDR_ANY overriding for binds, inaddr_any_override is already in network order */
+	if ((full_mode & GR_BINDOVERRIDE) && addr->sin_addr.s_addr == htonl(INADDR_ANY) && curr->inaddr_any_override != 0)
+		addr->sin_addr.s_addr = curr->inaddr_any_override;
+	if ((full_mode & GR_CONNECT) && isk->inet_saddr == htonl(INADDR_ANY) && curr->inaddr_any_override != 0) {
+		struct sockaddr_in saddr;
+		int err;
+
+		saddr.sin_family = AF_INET;
+		saddr.sin_addr.s_addr = curr->inaddr_any_override;
+		saddr.sin_port = isk->inet_sport;
+
+		err = security_socket_bind(sk->sk_socket, (struct sockaddr *)&saddr, sizeof(struct sockaddr_in));
+		if (err)
+			return err;
+
+		err = sk->sk_socket->ops->bind(sk->sk_socket, (struct sockaddr *)&saddr, sizeof(struct sockaddr_in));
+		if (err)
+			return err;
+	}
+
+	if (!curr->ips)
+		return 0;
+
+	ip_addr = addr->sin_addr.s_addr;
+	ip_port = ntohs(addr->sin_port);
+
+	if (curr->mode & (GR_LEARN | GR_INHERITLEARN)) {
+		security_learn(GR_IP_LEARN_MSG, current->role->rolename,
+			       current->role->roletype, GR_GLOBAL_UID(cred->uid),
+			       GR_GLOBAL_GID(cred->gid), current->exec_file ?
+			       gr_to_filename(current->exec_file->f_path.dentry,
+			       current->exec_file->f_path.mnt) :
+			       curr->filename, curr->filename,
+			       &ip_addr, ip_port, type,
+			       sk->sk_protocol, mode, &current->signal->saved_ip);
+		return 0;
+	}
+
+	for (i = 0; i < curr->ip_num; i++) {
+		ip = *(curr->ips + i);
+		if (ip->iface != NULL) {
+			strncpy(iface, ip->iface, IFNAMSIZ - 1);
+			p = strchr(iface, ':');
+			if (p != NULL)
+				*p = '\0';
+			dev = dev_get_by_name(sock_net(sk), iface);
+			if (dev == NULL)
+				continue;
+			idev = in_dev_get(dev);
+			if (idev == NULL) {
+				dev_put(dev);
+				continue;
+			}
+			rcu_read_lock();
+			for_ifa(idev) {
+				if (!strcmp(ip->iface, ifa->ifa_label)) {
+					our_addr = ifa->ifa_address;
+					our_netmask = 0xffffffff;
+					ret = check_ip_policy(ip, ip_addr, ip_port, sk->sk_protocol, mode, type, our_addr, our_netmask);
+					if (ret == 1) {
+						rcu_read_unlock();
+						in_dev_put(idev);
+						dev_put(dev);
+						return 0;
+					} else if (ret == 2) {
+						rcu_read_unlock();
+						in_dev_put(idev);
+						dev_put(dev);
+						goto denied;
+					}
+				}
+			} endfor_ifa(idev);
+			rcu_read_unlock();
+			in_dev_put(idev);
+			dev_put(dev);
+		} else {
+			our_addr = ip->addr;
+			our_netmask = ip->netmask;
+			ret = check_ip_policy(ip, ip_addr, ip_port, sk->sk_protocol, mode, type, our_addr, our_netmask);
+			if (ret == 1)
+				return 0;
+			else if (ret == 2)
+				goto denied;
+		}
+	}
+
+denied:
+	if (mode == GR_BIND)
+		gr_log_int5_str2(GR_DONT_AUDIT, GR_BIND_ACL_MSG, &ip_addr, ip_port, gr_socktype_to_name(type), gr_proto_to_name(sk->sk_protocol));
+	else if (mode == GR_CONNECT)
+		gr_log_int5_str2(GR_DONT_AUDIT, GR_CONNECT_ACL_MSG, &ip_addr, ip_port, gr_socktype_to_name(type), gr_proto_to_name(sk->sk_protocol));
+
+	return -EACCES;
+}
+
+int
+gr_search_connect(struct socket *sock, struct sockaddr_in *addr)
+{
+	/* always allow disconnection of dgram sockets with connect */
+	if (addr->sin_family == AF_UNSPEC)
+		return 0;
+	return gr_search_connectbind(GR_CONNECT | GR_CONNECTOVERRIDE, sock->sk, addr, sock->type);
+}
+
+int
+gr_search_bind(struct socket *sock, struct sockaddr_in *addr)
+{
+	return gr_search_connectbind(GR_BIND | GR_BINDOVERRIDE, sock->sk, addr, sock->type);
+}
+
+int gr_search_listen(struct socket *sock)
+{
+	struct sock *sk = sock->sk;
+	struct sockaddr_in addr;
+
+	addr.sin_addr.s_addr = inet_sk(sk)->inet_saddr;
+	addr.sin_port = inet_sk(sk)->inet_sport;
+
+	return gr_search_connectbind(GR_BIND | GR_CONNECTOVERRIDE, sock->sk, &addr, sock->type);
+}
+
+int gr_search_accept(struct socket *sock)
+{
+	struct sock *sk = sock->sk;
+	struct sockaddr_in addr;
+
+	addr.sin_addr.s_addr = inet_sk(sk)->inet_saddr;
+	addr.sin_port = inet_sk(sk)->inet_sport;
+
+	return gr_search_connectbind(GR_BIND | GR_CONNECTOVERRIDE, sock->sk, &addr, sock->type);
+}
+
+int
+gr_search_udp_sendmsg(struct sock *sk, struct sockaddr_in *addr)
+{
+	if (addr)
+		return gr_search_connectbind(GR_CONNECT, sk, addr, SOCK_DGRAM);
+	else {
+		struct sockaddr_in sin;
+		const struct inet_sock *inet = inet_sk(sk);
+
+		sin.sin_addr.s_addr = inet->inet_daddr;
+		sin.sin_port = inet->inet_dport;
+
+		return gr_search_connectbind(GR_CONNECT | GR_CONNECTOVERRIDE, sk, &sin, SOCK_DGRAM);
+	}
+}
+
+int
+gr_search_udp_recvmsg(struct sock *sk, const struct sk_buff *skb)
+{
+	struct sockaddr_in sin;
+
+	if (unlikely(skb->len < sizeof (struct udphdr)))
+		return 0;	// skip this packet
+
+	sin.sin_addr.s_addr = ip_hdr(skb)->saddr;
+	sin.sin_port = udp_hdr(skb)->source;
+
+	return gr_search_connectbind(GR_CONNECT | GR_CONNECTOVERRIDE, sk, &sin, SOCK_DGRAM);
+}
diff --git b/grsecurity/gracl_learn.c b/grsecurity/gracl_learn.c
new file mode 100644
index 000000000..c5abda5c8
--- /dev/null
+++ b/grsecurity/gracl_learn.c
@@ -0,0 +1,209 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/sched.h>
+#include <linux/poll.h>
+#include <linux/string.h>
+#include <linux/file.h>
+#include <linux/types.h>
+#include <linux/vmalloc.h>
+#include <linux/grinternal.h>
+
+extern ssize_t write_grsec_handler(struct file * file, const char __user * buf,
+				   size_t count, loff_t *ppos);
+extern int gr_acl_is_enabled(void);
+
+static DECLARE_WAIT_QUEUE_HEAD(learn_wait);
+static int gr_learn_attached;
+
+/* use a 512k buffer */
+#define LEARN_BUFFER_SIZE (512 * 1024)
+
+static DEFINE_SPINLOCK(gr_learn_lock);
+static DEFINE_MUTEX(gr_learn_user_mutex);
+
+/* we need to maintain two buffers, so that the kernel context of grlearn
+   uses a semaphore around the userspace copying, and the other kernel contexts
+   use a spinlock when copying into the buffer, since they cannot sleep
+*/
+static char *learn_buffer;
+static char *learn_buffer_user;
+static int learn_buffer_len;
+static int learn_buffer_user_len;
+
+static ssize_t
+read_learn(struct file *file, char __user * buf, size_t count, loff_t * ppos)
+{
+	DECLARE_WAITQUEUE(wait, current);
+	ssize_t retval = 0;
+
+	add_wait_queue(&learn_wait, &wait);
+	do {
+		mutex_lock(&gr_learn_user_mutex);
+		set_current_state(TASK_INTERRUPTIBLE);
+		spin_lock(&gr_learn_lock);
+		if (learn_buffer_len) {
+			set_current_state(TASK_RUNNING);
+			break;
+		}
+		spin_unlock(&gr_learn_lock);
+		mutex_unlock(&gr_learn_user_mutex);
+		if (file->f_flags & O_NONBLOCK) {
+			retval = -EAGAIN;
+			goto out;
+		}
+		if (signal_pending(current)) {
+			retval = -ERESTARTSYS;
+			goto out;
+		}
+
+		schedule();
+	} while (1);
+
+	memcpy(learn_buffer_user, learn_buffer, learn_buffer_len);
+	learn_buffer_user_len = learn_buffer_len;
+	retval = learn_buffer_len;
+	learn_buffer_len = 0;
+
+	spin_unlock(&gr_learn_lock);
+
+	if (copy_to_user(buf, learn_buffer_user, learn_buffer_user_len))
+		retval = -EFAULT;
+
+	mutex_unlock(&gr_learn_user_mutex);
+out:
+	set_current_state(TASK_RUNNING);
+	remove_wait_queue(&learn_wait, &wait);
+	return retval;
+}
+
+static unsigned int
+poll_learn(struct file * file, poll_table * wait)
+{
+	poll_wait(file, &learn_wait, wait);
+
+	if (learn_buffer_len)
+		return (POLLIN | POLLRDNORM);
+
+	return 0;
+}
+
+void
+gr_clear_learn_entries(void)
+{
+	char *tmp;
+
+	mutex_lock(&gr_learn_user_mutex);
+	spin_lock(&gr_learn_lock);
+	tmp = learn_buffer;
+	learn_buffer = NULL;
+	spin_unlock(&gr_learn_lock);
+	if (tmp)
+		vfree(tmp);
+	if (learn_buffer_user != NULL) {
+		vfree(learn_buffer_user);
+		learn_buffer_user = NULL;
+	}
+	learn_buffer_len = 0;
+	mutex_unlock(&gr_learn_user_mutex);
+
+	return;
+}
+
+void
+gr_add_learn_entry(const char *fmt, ...)
+{
+	va_list args;
+	unsigned int len;
+
+	if (!gr_learn_attached)
+		return;
+
+	spin_lock(&gr_learn_lock);
+
+	/* leave a gap at the end so we know when it's "full" but don't have to
+	   compute the exact length of the string we're trying to append
+	*/
+	if (learn_buffer_len > LEARN_BUFFER_SIZE - 16384) {
+		spin_unlock(&gr_learn_lock);
+		wake_up_interruptible(&learn_wait);
+		return;
+	}
+	if (learn_buffer == NULL) {
+		spin_unlock(&gr_learn_lock);
+		return;
+	}
+
+	va_start(args, fmt);
+	len = vsnprintf(learn_buffer + learn_buffer_len, LEARN_BUFFER_SIZE - learn_buffer_len, fmt, args);
+	va_end(args);
+
+	learn_buffer_len += len + 1;
+
+	spin_unlock(&gr_learn_lock);
+	wake_up_interruptible(&learn_wait);
+
+	return;
+}
+
+static int
+open_learn(struct inode *inode, struct file *file)
+{
+	if (file->f_mode & FMODE_READ && gr_learn_attached)
+		return -EBUSY;
+	if (file->f_mode & FMODE_READ) {
+		int retval = 0;
+		mutex_lock(&gr_learn_user_mutex);
+		if (learn_buffer == NULL)
+			learn_buffer = vmalloc(LEARN_BUFFER_SIZE);
+		if (learn_buffer_user == NULL)
+			learn_buffer_user = vmalloc(LEARN_BUFFER_SIZE);
+		if (learn_buffer == NULL) {
+			retval = -ENOMEM;
+			goto out_error;
+		}
+		if (learn_buffer_user == NULL) {
+			retval = -ENOMEM;
+			goto out_error;
+		}
+		learn_buffer_len = 0;
+		learn_buffer_user_len = 0;
+		gr_learn_attached = 1;
+out_error:
+		mutex_unlock(&gr_learn_user_mutex);
+		return retval;
+	}
+	return 0;
+}
+
+static int
+close_learn(struct inode *inode, struct file *file)
+{
+	if (file->f_mode & FMODE_READ) {
+		char *tmp = NULL;
+		mutex_lock(&gr_learn_user_mutex);
+		spin_lock(&gr_learn_lock);
+		tmp = learn_buffer;
+		learn_buffer = NULL;
+		spin_unlock(&gr_learn_lock);
+		if (tmp)
+			vfree(tmp);
+		if (learn_buffer_user != NULL) {
+			vfree(learn_buffer_user);
+			learn_buffer_user = NULL;
+		}
+		learn_buffer_len = 0;
+		learn_buffer_user_len = 0;
+		gr_learn_attached = 0;
+		mutex_unlock(&gr_learn_user_mutex);
+	}
+
+	return 0;
+}
+		
+const struct file_operations grsec_fops = {
+	.read		= read_learn,
+	.write		= write_grsec_handler,
+	.open		= open_learn,
+	.release	= close_learn,
+	.poll		= poll_learn,
+};
diff --git b/grsecurity/gracl_policy.c b/grsecurity/gracl_policy.c
new file mode 100644
index 000000000..d943ba92f
--- /dev/null
+++ b/grsecurity/gracl_policy.c
@@ -0,0 +1,1784 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/namei.h>
+#include <linux/mount.h>
+#include <linux/tty.h>
+#include <linux/proc_fs.h>
+#include <linux/lglock.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <linux/types.h>
+#include <linux/sysctl.h>
+#include <linux/netdevice.h>
+#include <linux/ptrace.h>
+#include <linux/gracl.h>
+#include <linux/gralloc.h>
+#include <linux/security.h>
+#include <linux/grinternal.h>
+#include <linux/pid_namespace.h>
+#include <linux/stop_machine.h>
+#include <linux/fdtable.h>
+#include <linux/percpu.h>
+#include <linux/lglock.h>
+#include <linux/hugetlb.h>
+#include <linux/posix-timers.h>
+#include "../fs/mount.h"
+
+#include <asm/uaccess.h>
+#include <asm/errno.h>
+#include <asm/mman.h>
+
+extern struct gr_policy_state *polstate;
+
+#define FOR_EACH_ROLE_START(role) \
+	role = polstate->role_list; \
+	while (role) {
+
+#define FOR_EACH_ROLE_END(role) \
+		role = role->prev; \
+	}
+
+struct path gr_real_root;
+
+extern struct gr_alloc_state *current_alloc_state;
+
+u16 acl_sp_role_value;
+
+static DEFINE_MUTEX(gr_dev_mutex);
+
+extern int chkpw(struct gr_arg *entry, unsigned char *salt, unsigned char *sum);
+extern void gr_clear_learn_entries(void);
+
+struct gr_arg *gr_usermode __read_only;
+unsigned char *gr_system_salt __read_only;
+unsigned char *gr_system_sum __read_only;
+
+static unsigned int gr_auth_attempts = 0;
+static unsigned long gr_auth_expires = 0UL;
+
+struct acl_object_label *fakefs_obj_rw;
+struct acl_object_label *fakefs_obj_rwx;
+
+extern int gr_init_uidset(void);
+extern void gr_free_uidset(void);
+extern int gr_find_and_remove_uid(uid_t uid);
+
+extern struct acl_subject_label *__gr_get_subject_for_task(const struct gr_policy_state *state, struct task_struct *task, const char *filename, int fallback);
+extern void __gr_apply_subject_to_task(const struct gr_policy_state *state, struct task_struct *task, struct acl_subject_label *subj);
+extern int gr_streq(const char *a, const char *b, const unsigned int lena, const unsigned int lenb);
+extern void __insert_inodev_entry(const struct gr_policy_state *state, struct inodev_entry *entry);
+extern struct acl_role_label *__lookup_acl_role_label(const struct gr_policy_state *state, const struct task_struct *task, const uid_t uid, const gid_t gid);
+extern void insert_acl_obj_label(struct acl_object_label *obj, struct acl_subject_label *subj);
+extern void insert_acl_subj_label(struct acl_subject_label *obj, struct acl_role_label *role);
+extern struct name_entry * __lookup_name_entry(const struct gr_policy_state *state, const char *name);
+extern char *gr_to_filename_rbac(const struct dentry *dentry, const struct vfsmount *mnt);
+extern struct acl_subject_label *lookup_acl_subj_label(const u64 ino, const dev_t dev, const struct acl_role_label *role);
+extern struct acl_subject_label *lookup_acl_subj_label_deleted(const u64 ino, const dev_t dev, const struct acl_role_label *role);
+extern void assign_special_role(const char *rolename);
+extern struct acl_subject_label *chk_subj_label(const struct dentry *l_dentry, const struct vfsmount *l_mnt, const struct acl_role_label *role);
+extern int gr_rbac_disable(void *unused);
+extern void gr_enable_rbac_system(void);
+
+static int copy_acl_object_label_normal(struct acl_object_label *obj, const struct acl_object_label *userp)
+{
+	if (copy_from_user(obj, userp, sizeof(struct acl_object_label)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_acl_ip_label_normal(struct acl_ip_label *ip, const struct acl_ip_label *userp)
+{
+	if (copy_from_user(ip, userp, sizeof(struct acl_ip_label)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_acl_subject_label_normal(struct acl_subject_label *subj, const struct acl_subject_label *userp)
+{
+	if (copy_from_user(subj, userp, sizeof(struct acl_subject_label)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_acl_role_label_normal(struct acl_role_label *role, const struct acl_role_label *userp)
+{
+	if (copy_from_user(role, userp, sizeof(struct acl_role_label)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_role_allowed_ip_normal(struct role_allowed_ip *roleip, const struct role_allowed_ip *userp)
+{
+	if (copy_from_user(roleip, userp, sizeof(struct role_allowed_ip)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_sprole_pw_normal(struct sprole_pw *pw, unsigned long idx, const struct sprole_pw *userp)
+{
+	if (copy_from_user(pw, userp + idx, sizeof(struct sprole_pw)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_gr_hash_struct_normal(struct gr_hash_struct *hash, const struct gr_hash_struct *userp)
+{
+	if (copy_from_user(hash, userp, sizeof(struct gr_hash_struct)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_role_transition_normal(struct role_transition *trans, const struct role_transition *userp)
+{
+	if (copy_from_user(trans, userp, sizeof(struct role_transition)))
+		return -EFAULT;
+
+	return 0;
+}
+
+int copy_pointer_from_array_normal(void *ptr, unsigned long idx, const void *userp)
+{
+	if (copy_from_user(ptr, userp + (idx * sizeof(void *)), sizeof(void *)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static int copy_gr_arg_wrapper_normal(const char __user *buf, struct gr_arg_wrapper *uwrap)
+{
+	if (copy_from_user(uwrap, buf, sizeof (struct gr_arg_wrapper)))
+		return -EFAULT;
+
+	if ((uwrap->version != GRSECURITY_VERSION) ||
+	    (uwrap->size != sizeof(struct gr_arg)))
+		return -EINVAL;
+
+	return 0;
+}
+
+static int copy_gr_arg_normal(const struct gr_arg __user *buf, struct gr_arg *arg)
+{
+	if (copy_from_user(arg, buf, sizeof (struct gr_arg)))
+		return -EFAULT;
+
+	return 0;
+}
+
+static size_t get_gr_arg_wrapper_size_normal(void)
+{
+	return sizeof(struct gr_arg_wrapper);
+}
+
+#ifdef CONFIG_COMPAT
+extern int copy_gr_arg_wrapper_compat(const char *buf, struct gr_arg_wrapper *uwrap);
+extern int copy_gr_arg_compat(const struct gr_arg __user *buf, struct gr_arg *arg);
+extern int copy_acl_object_label_compat(struct acl_object_label *obj, const struct acl_object_label *userp);
+extern int copy_acl_subject_label_compat(struct acl_subject_label *subj, const struct acl_subject_label *userp);
+extern int copy_acl_role_label_compat(struct acl_role_label *role, const struct acl_role_label *userp);
+extern int copy_role_allowed_ip_compat(struct role_allowed_ip *roleip, const struct role_allowed_ip *userp);
+extern int copy_role_transition_compat(struct role_transition *trans, const struct role_transition *userp);
+extern int copy_gr_hash_struct_compat(struct gr_hash_struct *hash, const struct gr_hash_struct *userp);
+extern int copy_pointer_from_array_compat(void *ptr, unsigned long idx, const void *userp);
+extern int copy_acl_ip_label_compat(struct acl_ip_label *ip, const struct acl_ip_label *userp);
+extern int copy_sprole_pw_compat(struct sprole_pw *pw, unsigned long idx, const struct sprole_pw *userp);
+extern size_t get_gr_arg_wrapper_size_compat(void);
+
+int (* copy_gr_arg_wrapper)(const char *buf, struct gr_arg_wrapper *uwrap) __read_only;
+int (* copy_gr_arg)(const struct gr_arg *buf, struct gr_arg *arg) __read_only;
+int (* copy_acl_object_label)(struct acl_object_label *obj, const struct acl_object_label *userp) __read_only;
+int (* copy_acl_subject_label)(struct acl_subject_label *subj, const struct acl_subject_label *userp) __read_only;
+int (* copy_acl_role_label)(struct acl_role_label *role, const struct acl_role_label *userp) __read_only;
+int (* copy_acl_ip_label)(struct acl_ip_label *ip, const struct acl_ip_label *userp) __read_only;
+int (* copy_pointer_from_array)(void *ptr, unsigned long idx, const void *userp) __read_only;
+int (* copy_sprole_pw)(struct sprole_pw *pw, unsigned long idx, const struct sprole_pw *userp) __read_only;
+int (* copy_gr_hash_struct)(struct gr_hash_struct *hash, const struct gr_hash_struct *userp) __read_only;
+int (* copy_role_transition)(struct role_transition *trans, const struct role_transition *userp) __read_only;
+int (* copy_role_allowed_ip)(struct role_allowed_ip *roleip, const struct role_allowed_ip *userp) __read_only;
+size_t (* get_gr_arg_wrapper_size)(void) __read_only;
+
+#else
+#define copy_gr_arg_wrapper copy_gr_arg_wrapper_normal
+#define copy_gr_arg copy_gr_arg_normal
+#define copy_gr_hash_struct copy_gr_hash_struct_normal
+#define copy_acl_object_label copy_acl_object_label_normal
+#define copy_acl_subject_label copy_acl_subject_label_normal
+#define copy_acl_role_label copy_acl_role_label_normal
+#define copy_acl_ip_label copy_acl_ip_label_normal
+#define copy_pointer_from_array copy_pointer_from_array_normal
+#define copy_sprole_pw copy_sprole_pw_normal
+#define copy_role_transition copy_role_transition_normal
+#define copy_role_allowed_ip copy_role_allowed_ip_normal
+#define get_gr_arg_wrapper_size get_gr_arg_wrapper_size_normal
+#endif
+
+static struct acl_subject_label *
+lookup_subject_map(const struct acl_subject_label *userp)
+{
+	unsigned int index = gr_shash(userp, polstate->subj_map_set.s_size);
+	struct subject_map *match;
+
+	match = polstate->subj_map_set.s_hash[index];
+
+	while (match && match->user != userp)
+		match = match->next;
+
+	if (match != NULL)
+		return match->kernel;
+	else
+		return NULL;
+}
+
+static void
+insert_subj_map_entry(struct subject_map *subjmap)
+{
+	unsigned int index = gr_shash(subjmap->user, polstate->subj_map_set.s_size);
+	struct subject_map **curr;
+
+	subjmap->prev = NULL;
+
+	curr = &polstate->subj_map_set.s_hash[index];
+	if (*curr != NULL)
+		(*curr)->prev = subjmap;
+
+	subjmap->next = *curr;
+	*curr = subjmap;
+
+	return;
+}
+
+static void
+__insert_acl_role_label(struct acl_role_label *role, uid_t uidgid)
+{
+	unsigned int index =
+	    gr_rhash(uidgid, role->roletype & (GR_ROLE_USER | GR_ROLE_GROUP), polstate->acl_role_set.r_size);
+	struct acl_role_label **curr;
+	struct acl_role_label *tmp, *tmp2;
+
+	curr = &polstate->acl_role_set.r_hash[index];
+
+	/* simple case, slot is empty, just set it to our role */
+	if (*curr == NULL) {
+		*curr = role;
+	} else {
+		/* example:
+		   1 -> 2 -> 3 (adding 2 -> 3 to here)
+		   2 -> 3
+		*/
+		/* first check to see if we can already be reached via this slot */
+		tmp = *curr;
+		while (tmp && tmp != role)
+			tmp = tmp->next;
+		if (tmp == role) {
+			/* we don't need to add ourselves to this slot's chain */
+			return;
+		}
+		/* we need to add ourselves to this chain, two cases */
+		if (role->next == NULL) {
+			/* simple case, append the current chain to our role */
+			role->next = *curr;
+			*curr = role;
+		} else {
+			/* 1 -> 2 -> 3 -> 4
+			   2 -> 3 -> 4
+			   3 -> 4 (adding 1 -> 2 -> 3 -> 4 to here)
+			*/			   
+			/* trickier case: walk our role's chain until we find
+			   the role for the start of the current slot's chain */
+			tmp = role;
+			tmp2 = *curr;
+			while (tmp->next && tmp->next != tmp2)
+				tmp = tmp->next;
+			if (tmp->next == tmp2) {
+				/* from example above, we found 3, so just
+				   replace this slot's chain with ours */
+				*curr = role;
+			} else {
+				/* we didn't find a subset of our role's chain
+				   in the current slot's chain, so append their
+				   chain to ours, and set us as the first role in
+				   the slot's chain
+
+				   we could fold this case with the case above,
+				   but making it explicit for clarity
+				*/
+				tmp->next = tmp2;
+				*curr = role;
+			}
+		}
+	}
+
+	return;
+}
+
+static void
+insert_acl_role_label(struct acl_role_label *role)
+{
+	int i;
+
+	if (polstate->role_list == NULL) {
+		polstate->role_list = role;
+		role->prev = NULL;
+	} else {
+		role->prev = polstate->role_list;
+		polstate->role_list = role;
+	}
+	
+	/* used for hash chains */
+	role->next = NULL;
+
+	if (role->roletype & GR_ROLE_DOMAIN) {
+		for (i = 0; i < role->domain_child_num; i++)
+			__insert_acl_role_label(role, role->domain_children[i]);
+	} else
+		__insert_acl_role_label(role, role->uidgid);
+}
+					
+static int
+insert_name_entry(char *name, const u64 inode, const dev_t device, __u8 deleted)
+{
+	struct name_entry **curr, *nentry;
+	struct inodev_entry *ientry;
+	unsigned int len = strlen(name);
+	unsigned int key = full_name_hash(NULL, (const unsigned char *)name, len);
+	unsigned int index = key % polstate->name_set.n_size;
+
+	curr = &polstate->name_set.n_hash[index];
+
+	while (*curr && ((*curr)->key != key || !gr_streq((*curr)->name, name, (*curr)->len, len)))
+		curr = &((*curr)->next);
+
+	if (*curr != NULL)
+		return 1;
+
+	nentry = acl_alloc(sizeof (struct name_entry));
+	if (nentry == NULL)
+		return 0;
+	ientry = acl_alloc(sizeof (struct inodev_entry));
+	if (ientry == NULL)
+		return 0;
+	ientry->nentry = nentry;
+
+	nentry->key = key;
+	nentry->name = name;
+	nentry->inode = inode;
+	nentry->device = device;
+	nentry->len = len;
+	nentry->deleted = deleted;
+
+	nentry->prev = NULL;
+	curr = &polstate->name_set.n_hash[index];
+	if (*curr != NULL)
+		(*curr)->prev = nentry;
+	nentry->next = *curr;
+	*curr = nentry;
+
+	/* insert us into the table searchable by inode/dev */
+	__insert_inodev_entry(polstate, ientry);
+
+	return 1;
+}
+
+/* allocating chained hash tables, so optimal size is where lambda ~ 1 */
+
+static void *
+create_table(__u32 * len, int elementsize)
+{
+	unsigned int table_sizes[] = {
+		7, 13, 31, 61, 127, 251, 509, 1021, 2039, 4093, 8191, 16381,
+		32749, 65521, 131071, 262139, 524287, 1048573, 2097143,
+		4194301, 8388593, 16777213, 33554393, 67108859
+	};
+	void *newtable = NULL;
+	unsigned int pwr = 0;
+
+	while ((pwr < ((sizeof (table_sizes) / sizeof (table_sizes[0])) - 1)) &&
+	       table_sizes[pwr] <= *len)
+		pwr++;
+
+	if (table_sizes[pwr] <= *len || (table_sizes[pwr] > ULONG_MAX / elementsize))
+		return newtable;
+
+	if ((table_sizes[pwr] * elementsize) <= PAGE_SIZE)
+		newtable =
+		    kmalloc(table_sizes[pwr] * elementsize, GFP_KERNEL);
+	else
+		newtable = vmalloc(table_sizes[pwr] * elementsize);
+
+	*len = table_sizes[pwr];
+
+	return newtable;
+}
+
+static int
+init_variables(const struct gr_arg *arg, bool reload)
+{
+	struct task_struct *reaper = init_pid_ns.child_reaper;
+	unsigned int stacksize;
+
+	polstate->subj_map_set.s_size = arg->role_db.num_subjects;
+	polstate->acl_role_set.r_size = arg->role_db.num_roles + arg->role_db.num_domain_children;
+	polstate->name_set.n_size = arg->role_db.num_objects;
+	polstate->inodev_set.i_size = arg->role_db.num_objects;
+
+	if (!polstate->subj_map_set.s_size || !polstate->acl_role_set.r_size ||
+	    !polstate->name_set.n_size || !polstate->inodev_set.i_size)
+		return 1;
+
+	if (!reload) {
+		if (!gr_init_uidset())
+			return 1;
+	}
+
+	/* set up the stack that holds allocation info */
+
+	stacksize = arg->role_db.num_pointers + 5;
+
+	if (!acl_alloc_stack_init(stacksize))
+		return 1;
+
+	if (!reload) {
+		/* grab reference for the real root dentry and vfsmount */
+		get_fs_root(reaper->fs, &gr_real_root);
+	
+#ifdef CONFIG_GRKERNSEC_RBAC_DEBUG
+	printk(KERN_ALERT "Obtained real root device=%d, inode=%lu\n", gr_get_dev_from_dentry(gr_real_root.dentry), gr_get_ino_from_dentry(gr_real_root.dentry));
+#endif
+
+		fakefs_obj_rw = kzalloc(sizeof(struct acl_object_label), GFP_KERNEL);
+		if (fakefs_obj_rw == NULL)
+			return 1;
+		fakefs_obj_rw->mode = GR_FIND | GR_READ | GR_WRITE;
+	
+		fakefs_obj_rwx = kzalloc(sizeof(struct acl_object_label), GFP_KERNEL);
+		if (fakefs_obj_rwx == NULL)
+			return 1;
+		fakefs_obj_rwx->mode = GR_FIND | GR_READ | GR_WRITE | GR_EXEC;
+	}
+
+	polstate->subj_map_set.s_hash =
+	    (struct subject_map **) create_table(&polstate->subj_map_set.s_size, sizeof(void *));
+	polstate->acl_role_set.r_hash =
+	    (struct acl_role_label **) create_table(&polstate->acl_role_set.r_size, sizeof(void *));
+	polstate->name_set.n_hash = (struct name_entry **) create_table(&polstate->name_set.n_size, sizeof(void *));
+	polstate->inodev_set.i_hash =
+	    (struct inodev_entry **) create_table(&polstate->inodev_set.i_size, sizeof(void *));
+
+	if (!polstate->subj_map_set.s_hash || !polstate->acl_role_set.r_hash ||
+	    !polstate->name_set.n_hash || !polstate->inodev_set.i_hash)
+		return 1;
+
+	memset(polstate->subj_map_set.s_hash, 0,
+	       sizeof(struct subject_map *) * polstate->subj_map_set.s_size);
+	memset(polstate->acl_role_set.r_hash, 0,
+	       sizeof (struct acl_role_label *) * polstate->acl_role_set.r_size);
+	memset(polstate->name_set.n_hash, 0,
+	       sizeof (struct name_entry *) * polstate->name_set.n_size);
+	memset(polstate->inodev_set.i_hash, 0,
+	       sizeof (struct inodev_entry *) * polstate->inodev_set.i_size);
+
+	return 0;
+}
+
+/* free information not needed after startup
+   currently contains user->kernel pointer mappings for subjects
+*/
+
+static void
+free_init_variables(void)
+{
+	__u32 i;
+
+	if (polstate->subj_map_set.s_hash) {
+		for (i = 0; i < polstate->subj_map_set.s_size; i++) {
+			if (polstate->subj_map_set.s_hash[i]) {
+				kfree(polstate->subj_map_set.s_hash[i]);
+				polstate->subj_map_set.s_hash[i] = NULL;
+			}
+		}
+
+		if ((polstate->subj_map_set.s_size * sizeof (struct subject_map *)) <=
+		    PAGE_SIZE)
+			kfree(polstate->subj_map_set.s_hash);
+		else
+			vfree(polstate->subj_map_set.s_hash);
+	}
+
+	return;
+}
+
+static void
+free_variables(bool reload)
+{
+	struct acl_subject_label *s;
+	struct acl_role_label *r;
+	struct task_struct *task, *task2;
+	unsigned int x;
+
+	if (!reload) {
+		gr_clear_learn_entries();
+
+		read_lock(&tasklist_lock);
+		do_each_thread(task2, task) {
+			task->acl_sp_role = 0;
+			task->acl_role_id = 0;
+			task->inherited = 0;
+			task->acl = NULL;
+			task->role = NULL;
+		} while_each_thread(task2, task);
+		read_unlock(&tasklist_lock);
+
+		kfree(fakefs_obj_rw);
+		fakefs_obj_rw = NULL;
+		kfree(fakefs_obj_rwx);
+		fakefs_obj_rwx = NULL;
+
+		/* release the reference to the real root dentry and vfsmount */
+		path_put(&gr_real_root);
+		memset(&gr_real_root, 0, sizeof(gr_real_root));
+	}
+
+	/* free all object hash tables */
+
+	FOR_EACH_ROLE_START(r)
+		if (r->subj_hash == NULL)
+			goto next_role;
+		FOR_EACH_SUBJECT_START(r, s, x)
+			if (s->obj_hash == NULL)
+				break;
+			if ((s->obj_hash_size * sizeof (struct acl_object_label *)) <= PAGE_SIZE)
+				kfree(s->obj_hash);
+			else
+				vfree(s->obj_hash);
+		FOR_EACH_SUBJECT_END(s, x)
+		FOR_EACH_NESTED_SUBJECT_START(r, s)
+			if (s->obj_hash == NULL)
+				break;
+			if ((s->obj_hash_size * sizeof (struct acl_object_label *)) <= PAGE_SIZE)
+				kfree(s->obj_hash);
+			else
+				vfree(s->obj_hash);
+		FOR_EACH_NESTED_SUBJECT_END(s)
+		if ((r->subj_hash_size * sizeof (struct acl_subject_label *)) <= PAGE_SIZE)
+			kfree(r->subj_hash);
+		else
+			vfree(r->subj_hash);
+		r->subj_hash = NULL;
+next_role:
+	FOR_EACH_ROLE_END(r)
+
+	acl_free_all();
+
+	if (polstate->acl_role_set.r_hash) {
+		if ((polstate->acl_role_set.r_size * sizeof (struct acl_role_label *)) <=
+		    PAGE_SIZE)
+			kfree(polstate->acl_role_set.r_hash);
+		else
+			vfree(polstate->acl_role_set.r_hash);
+	}
+	if (polstate->name_set.n_hash) {
+		if ((polstate->name_set.n_size * sizeof (struct name_entry *)) <=
+		    PAGE_SIZE)
+			kfree(polstate->name_set.n_hash);
+		else
+			vfree(polstate->name_set.n_hash);
+	}
+
+	if (polstate->inodev_set.i_hash) {
+		if ((polstate->inodev_set.i_size * sizeof (struct inodev_entry *)) <=
+		    PAGE_SIZE)
+			kfree(polstate->inodev_set.i_hash);
+		else
+			vfree(polstate->inodev_set.i_hash);
+	}
+
+	if (!reload)
+		gr_free_uidset();
+
+	memset(&polstate->name_set, 0, sizeof (struct name_db));
+	memset(&polstate->inodev_set, 0, sizeof (struct inodev_db));
+	memset(&polstate->acl_role_set, 0, sizeof (struct acl_role_db));
+	memset(&polstate->subj_map_set, 0, sizeof (struct acl_subj_map_db));
+
+	polstate->default_role = NULL;
+	polstate->kernel_role = NULL;
+	polstate->role_list = NULL;
+
+	return;
+}
+
+static struct acl_subject_label *
+do_copy_user_subj(struct acl_subject_label *userp, struct acl_role_label *role, int *already_copied);
+
+static int alloc_and_copy_string(char **name, unsigned int maxlen)
+{
+	unsigned int len = strnlen_user(*name, maxlen);
+	char *tmp;
+
+	if (!len || len >= maxlen)
+		return -EINVAL;
+
+	if ((tmp = (char *) acl_alloc(len)) == NULL)
+		return -ENOMEM;
+
+	if (copy_from_user(tmp, *name, len))
+		return -EFAULT;
+
+	tmp[len-1] = '\0';
+	*name = tmp;
+
+	return 0;
+}
+
+static int
+copy_user_glob(struct acl_object_label *obj)
+{
+	struct acl_object_label *g_tmp, **guser;
+	int error;
+
+	if (obj->globbed == NULL)
+		return 0;
+
+	guser = &obj->globbed;
+	while (*guser) {
+		g_tmp = (struct acl_object_label *)
+			acl_alloc(sizeof (struct acl_object_label));
+		if (g_tmp == NULL)
+			return -ENOMEM;
+
+		if (copy_acl_object_label(g_tmp, *guser))
+			return -EFAULT;
+
+		error = alloc_and_copy_string(&g_tmp->filename, PATH_MAX);
+		if (error)
+			return error;
+
+		*guser = g_tmp;
+		guser = &(g_tmp->next);
+	}
+
+	return 0;
+}
+
+static int
+copy_user_objs(struct acl_object_label *userp, struct acl_subject_label *subj,
+	       struct acl_role_label *role)
+{
+	struct acl_object_label *o_tmp;
+	int ret;
+
+	while (userp) {
+		if ((o_tmp = (struct acl_object_label *)
+		     acl_alloc(sizeof (struct acl_object_label))) == NULL)
+			return -ENOMEM;
+
+		if (copy_acl_object_label(o_tmp, userp))
+			return -EFAULT;
+
+		userp = o_tmp->prev;
+
+		ret = alloc_and_copy_string(&o_tmp->filename, PATH_MAX);
+		if (ret)
+			return ret;
+
+		insert_acl_obj_label(o_tmp, subj);
+		if (!insert_name_entry(o_tmp->filename, o_tmp->inode,
+				       o_tmp->device, (o_tmp->mode & GR_DELETED) ? 1 : 0))
+			return -ENOMEM;
+
+		ret = copy_user_glob(o_tmp);
+		if (ret)
+			return ret;
+
+		if (o_tmp->nested) {
+			int already_copied;
+
+			o_tmp->nested = do_copy_user_subj(o_tmp->nested, role, &already_copied);
+			if (IS_ERR(o_tmp->nested))
+				return PTR_ERR(o_tmp->nested);
+
+			/* insert into nested subject list if we haven't copied this one yet
+			   to prevent duplicate entries */
+			if (!already_copied) {
+				o_tmp->nested->next = role->hash->first;
+				role->hash->first = o_tmp->nested;
+			}
+		}
+	}
+
+	return 0;
+}
+
+static __u32
+count_user_subjs(struct acl_subject_label *userp)
+{
+	struct acl_subject_label s_tmp;
+	__u32 num = 0;
+
+	while (userp) {
+		if (copy_acl_subject_label(&s_tmp, userp))
+			break;
+
+		userp = s_tmp.prev;
+	}
+
+	return num;
+}
+
+static int
+copy_user_allowedips(struct acl_role_label *rolep)
+{
+	struct role_allowed_ip *ruserip, *rtmp = NULL, *rlast;
+
+	ruserip = rolep->allowed_ips;
+
+	while (ruserip) {
+		rlast = rtmp;
+
+		if ((rtmp = (struct role_allowed_ip *)
+		     acl_alloc(sizeof (struct role_allowed_ip))) == NULL)
+			return -ENOMEM;
+
+		if (copy_role_allowed_ip(rtmp, ruserip))
+			return -EFAULT;
+
+		ruserip = rtmp->prev;
+
+		if (!rlast) {
+			rtmp->prev = NULL;
+			rolep->allowed_ips = rtmp;
+		} else {
+			rlast->next = rtmp;
+			rtmp->prev = rlast;
+		}
+
+		if (!ruserip)
+			rtmp->next = NULL;
+	}
+
+	return 0;
+}
+
+static int
+copy_user_transitions(struct acl_role_label *rolep)
+{
+	struct role_transition *rusertp, *rtmp = NULL, *rlast;
+	int error;
+
+	rusertp = rolep->transitions;
+
+	while (rusertp) {
+		rlast = rtmp;
+
+		if ((rtmp = (struct role_transition *)
+		     acl_alloc(sizeof (struct role_transition))) == NULL)
+			return -ENOMEM;
+
+		if (copy_role_transition(rtmp, rusertp))
+			return -EFAULT;
+
+		rusertp = rtmp->prev;
+
+		error = alloc_and_copy_string(&rtmp->rolename, GR_SPROLE_LEN);
+		if (error)
+			return error;
+
+		if (!rlast) {
+			rtmp->prev = NULL;
+			rolep->transitions = rtmp;
+		} else {
+			rlast->next = rtmp;
+			rtmp->prev = rlast;
+		}
+
+		if (!rusertp)
+			rtmp->next = NULL;
+	}
+
+	return 0;
+}
+
+static __u32 count_user_objs(const struct acl_object_label __user *userp)
+{
+	struct acl_object_label o_tmp;
+	__u32 num = 0;
+
+	while (userp) {
+		if (copy_acl_object_label(&o_tmp, userp))
+			break;
+
+		userp = o_tmp.prev;
+		num++;
+	}
+
+	return num;
+}
+
+static struct acl_subject_label *
+do_copy_user_subj(struct acl_subject_label *userp, struct acl_role_label *role, int *already_copied)
+{
+	struct acl_subject_label *s_tmp = NULL, *s_tmp2;
+	__u32 num_objs;
+	struct acl_ip_label **i_tmp, *i_utmp2;
+	struct gr_hash_struct ghash;
+	struct subject_map *subjmap;
+	unsigned int i_num;
+	int err;
+
+	if (already_copied != NULL)
+		*already_copied = 0;
+
+	s_tmp = lookup_subject_map(userp);
+
+	/* we've already copied this subject into the kernel, just return
+	   the reference to it, and don't copy it over again
+	*/
+	if (s_tmp) {
+		if (already_copied != NULL)
+			*already_copied = 1;
+		return(s_tmp);
+	}
+
+	if ((s_tmp = (struct acl_subject_label *)
+	    acl_alloc(sizeof (struct acl_subject_label))) == NULL)
+		return ERR_PTR(-ENOMEM);
+
+	subjmap = (struct subject_map *)kmalloc(sizeof (struct subject_map), GFP_KERNEL);
+	if (subjmap == NULL)
+		return ERR_PTR(-ENOMEM);
+
+	subjmap->user = userp;
+	subjmap->kernel = s_tmp;
+	insert_subj_map_entry(subjmap);
+
+	if (copy_acl_subject_label(s_tmp, userp))
+		return ERR_PTR(-EFAULT);
+
+	err = alloc_and_copy_string(&s_tmp->filename, PATH_MAX);
+	if (err)
+		return ERR_PTR(err);
+
+	if (!strcmp(s_tmp->filename, "/"))
+		role->root_label = s_tmp;
+
+	if (copy_gr_hash_struct(&ghash, s_tmp->hash))
+		return ERR_PTR(-EFAULT);
+
+	/* copy user and group transition tables */
+
+	if (s_tmp->user_trans_num) {
+		uid_t *uidlist;
+
+		uidlist = (uid_t *)acl_alloc_num(s_tmp->user_trans_num, sizeof(uid_t));
+		if (uidlist == NULL)
+			return ERR_PTR(-ENOMEM);
+		if (copy_from_user(uidlist, s_tmp->user_transitions, s_tmp->user_trans_num * sizeof(uid_t)))
+			return ERR_PTR(-EFAULT);
+
+		s_tmp->user_transitions = uidlist;
+	}
+
+	if (s_tmp->group_trans_num) {
+		gid_t *gidlist;
+
+		gidlist = (gid_t *)acl_alloc_num(s_tmp->group_trans_num, sizeof(gid_t));
+		if (gidlist == NULL)
+			return ERR_PTR(-ENOMEM);
+		if (copy_from_user(gidlist, s_tmp->group_transitions, s_tmp->group_trans_num * sizeof(gid_t)))
+			return ERR_PTR(-EFAULT);
+
+		s_tmp->group_transitions = gidlist;
+	}
+
+	/* set up object hash table */
+	num_objs = count_user_objs(ghash.first);
+
+	s_tmp->obj_hash_size = num_objs;
+	s_tmp->obj_hash =
+	    (struct acl_object_label **)
+	    create_table(&(s_tmp->obj_hash_size), sizeof(void *));
+
+	if (!s_tmp->obj_hash)
+		return ERR_PTR(-ENOMEM);
+
+	memset(s_tmp->obj_hash, 0,
+	       s_tmp->obj_hash_size *
+	       sizeof (struct acl_object_label *));
+
+	/* add in objects */
+	err = copy_user_objs(ghash.first, s_tmp, role);
+
+	if (err)
+		return ERR_PTR(err);
+
+	/* set pointer for parent subject */
+	if (s_tmp->parent_subject) {
+		s_tmp2 = do_copy_user_subj(s_tmp->parent_subject, role, NULL);
+
+		if (IS_ERR(s_tmp2))
+			return s_tmp2;
+
+		s_tmp->parent_subject = s_tmp2;
+	}
+
+	/* add in ip acls */
+
+	if (!s_tmp->ip_num) {
+		s_tmp->ips = NULL;
+		goto insert;
+	}
+
+	i_tmp =
+	    (struct acl_ip_label **) acl_alloc_num(s_tmp->ip_num,
+					       sizeof (struct acl_ip_label *));
+
+	if (!i_tmp)
+		return ERR_PTR(-ENOMEM);
+
+	for (i_num = 0; i_num < s_tmp->ip_num; i_num++) {
+		*(i_tmp + i_num) =
+		    (struct acl_ip_label *)
+		    acl_alloc(sizeof (struct acl_ip_label));
+		if (!*(i_tmp + i_num))
+			return ERR_PTR(-ENOMEM);
+
+		if (copy_pointer_from_array(&i_utmp2, i_num, s_tmp->ips))
+			return ERR_PTR(-EFAULT);
+
+		if (copy_acl_ip_label(*(i_tmp + i_num), i_utmp2))
+			return ERR_PTR(-EFAULT);
+		
+		if ((*(i_tmp + i_num))->iface == NULL)
+			continue;
+
+		err = alloc_and_copy_string(&(*(i_tmp + i_num))->iface, IFNAMSIZ);
+		if (err)
+			return ERR_PTR(err);
+	}
+
+	s_tmp->ips = i_tmp;
+
+insert:
+	if (!insert_name_entry(s_tmp->filename, s_tmp->inode,
+			       s_tmp->device, (s_tmp->mode & GR_DELETED) ? 1 : 0))
+		return ERR_PTR(-ENOMEM);
+
+	return s_tmp;
+}
+
+static int
+copy_user_subjs(struct acl_subject_label *userp, struct acl_role_label *role)
+{
+	struct acl_subject_label s_pre;
+	struct acl_subject_label * ret;
+	int err;
+
+	while (userp) {
+		if (copy_acl_subject_label(&s_pre, userp))
+			return -EFAULT;
+		
+		ret = do_copy_user_subj(userp, role, NULL);
+
+		err = PTR_ERR(ret);
+		if (IS_ERR(ret))
+			return err;
+
+		insert_acl_subj_label(ret, role);
+
+		userp = s_pre.prev;
+	}
+
+	return 0;
+}
+
+static int
+copy_user_acl(struct gr_arg *arg)
+{
+	struct acl_role_label *r_tmp = NULL, **r_utmp, *r_utmp2;
+	struct acl_subject_label *subj_list;
+	struct sprole_pw *sptmp;
+	struct gr_hash_struct *ghash;
+	uid_t *domainlist;
+	unsigned int r_num;
+	int err = 0;
+	__u16 i;
+	__u32 num_subjs;
+
+	/* we need a default and kernel role */
+	if (arg->role_db.num_roles < 2)
+		return -EINVAL;
+
+	/* copy special role authentication info from userspace */
+
+	polstate->num_sprole_pws = arg->num_sprole_pws;
+	polstate->acl_special_roles = (struct sprole_pw **) acl_alloc_num(polstate->num_sprole_pws, sizeof(struct sprole_pw *));
+
+	if (!polstate->acl_special_roles && polstate->num_sprole_pws)
+		return -ENOMEM;
+
+	for (i = 0; i < polstate->num_sprole_pws; i++) {
+		sptmp = (struct sprole_pw *) acl_alloc(sizeof(struct sprole_pw));
+		if (!sptmp)
+			return -ENOMEM;
+		if (copy_sprole_pw(sptmp, i, arg->sprole_pws))
+			return -EFAULT;
+
+		err = alloc_and_copy_string((char **)&sptmp->rolename, GR_SPROLE_LEN);
+		if (err)
+			return err;
+
+#ifdef CONFIG_GRKERNSEC_RBAC_DEBUG
+		printk(KERN_ALERT "Copying special role %s\n", sptmp->rolename);
+#endif
+
+		polstate->acl_special_roles[i] = sptmp;
+	}
+
+	r_utmp = (struct acl_role_label **) arg->role_db.r_table;
+
+	for (r_num = 0; r_num < arg->role_db.num_roles; r_num++) {
+		r_tmp = acl_alloc(sizeof (struct acl_role_label));
+
+		if (!r_tmp)
+			return -ENOMEM;
+
+		if (copy_pointer_from_array(&r_utmp2, r_num, r_utmp))
+			return -EFAULT;
+
+		if (copy_acl_role_label(r_tmp, r_utmp2))
+			return -EFAULT;
+
+		err = alloc_and_copy_string(&r_tmp->rolename, GR_SPROLE_LEN);
+		if (err)
+			return err;
+
+		if (!strcmp(r_tmp->rolename, "default")
+		    && (r_tmp->roletype & GR_ROLE_DEFAULT)) {
+			polstate->default_role = r_tmp;
+		} else if (!strcmp(r_tmp->rolename, ":::kernel:::")) {
+			polstate->kernel_role = r_tmp;
+		}
+
+		if ((ghash = (struct gr_hash_struct *) acl_alloc(sizeof(struct gr_hash_struct))) == NULL)
+			return -ENOMEM;
+
+		if (copy_gr_hash_struct(ghash, r_tmp->hash))
+			return -EFAULT;
+
+		r_tmp->hash = ghash;
+
+		num_subjs = count_user_subjs(r_tmp->hash->first);
+
+		r_tmp->subj_hash_size = num_subjs;
+		r_tmp->subj_hash =
+		    (struct acl_subject_label **)
+		    create_table(&(r_tmp->subj_hash_size), sizeof(void *));
+
+		if (!r_tmp->subj_hash)
+			return -ENOMEM;
+
+		err = copy_user_allowedips(r_tmp);
+		if (err)
+			return err;
+
+		/* copy domain info */
+		if (r_tmp->domain_children != NULL) {
+			domainlist = acl_alloc_num(r_tmp->domain_child_num, sizeof(uid_t));
+			if (domainlist == NULL)
+				return -ENOMEM;
+
+			if (copy_from_user(domainlist, r_tmp->domain_children, r_tmp->domain_child_num * sizeof(uid_t)))
+				return -EFAULT;
+
+			r_tmp->domain_children = domainlist;
+		}
+
+		err = copy_user_transitions(r_tmp);
+		if (err)
+			return err;
+
+		memset(r_tmp->subj_hash, 0,
+		       r_tmp->subj_hash_size *
+		       sizeof (struct acl_subject_label *));
+
+		/* acquire the list of subjects, then NULL out
+		   the list prior to parsing the subjects for this role,
+		   as during this parsing the list is replaced with a list
+		   of *nested* subjects for the role
+		*/
+		subj_list = r_tmp->hash->first;
+
+		/* set nested subject list to null */
+		r_tmp->hash->first = NULL;
+
+		err = copy_user_subjs(subj_list, r_tmp);
+
+		if (err)
+			return err;
+
+		insert_acl_role_label(r_tmp);
+	}
+
+	if (polstate->default_role == NULL || polstate->kernel_role == NULL)
+		return -EINVAL;
+
+	return err;
+}
+
+static int gracl_reload_apply_policies(void *reload)
+{
+	struct gr_reload_state *reload_state = (struct gr_reload_state *)reload;
+	struct task_struct *task, *task2;
+	struct acl_role_label *role, *rtmp;
+	struct acl_subject_label *subj;
+	const struct cred *cred;
+	int role_applied;
+	int ret = 0;
+
+	memcpy(&reload_state->oldpolicy, reload_state->oldpolicy_ptr, sizeof(struct gr_policy_state));
+	memcpy(&reload_state->oldalloc, reload_state->oldalloc_ptr, sizeof(struct gr_alloc_state));
+
+	/* first make sure we'll be able to apply the new policy cleanly */
+	do_each_thread(task2, task) {
+		if (task->exec_file == NULL)
+			continue;
+		role_applied = 0;
+		if (!reload_state->oldmode && task->role->roletype & GR_ROLE_SPECIAL) {
+			/* preserve special roles */
+			FOR_EACH_ROLE_START(role)
+				if ((role->roletype & GR_ROLE_SPECIAL) && !strcmp(task->role->rolename, role->rolename)) {
+					rtmp = task->role;
+					task->role = role;
+					role_applied = 1;
+					break;
+				}
+			FOR_EACH_ROLE_END(role)
+		}
+		if (!role_applied) {
+			cred = __task_cred(task);
+			rtmp = task->role;
+			task->role = __lookup_acl_role_label(polstate, task, GR_GLOBAL_UID(cred->uid), GR_GLOBAL_GID(cred->gid));
+		}
+		/* this handles non-nested inherited subjects, nested subjects will still
+		   be dropped currently */
+		subj = __gr_get_subject_for_task(polstate, task, task->acl->filename, 1);
+		task->tmpacl = __gr_get_subject_for_task(polstate, task, NULL, 1);
+		/* change the role back so that we've made no modifications to the policy */
+		task->role = rtmp;
+
+		if (subj == NULL || task->tmpacl == NULL) {
+			ret = -EINVAL;
+			goto out;
+		}
+	} while_each_thread(task2, task);
+
+	/* now actually apply the policy */
+
+	do_each_thread(task2, task) {
+		if (task->exec_file) {
+			role_applied = 0;
+			if (!reload_state->oldmode && task->role->roletype & GR_ROLE_SPECIAL) {
+				/* preserve special roles */
+				FOR_EACH_ROLE_START(role)
+					if ((role->roletype & GR_ROLE_SPECIAL) && !strcmp(task->role->rolename, role->rolename)) {
+						task->role = role;
+						role_applied = 1;
+						break;
+					}
+				FOR_EACH_ROLE_END(role)
+			}
+			if (!role_applied) {
+				cred = __task_cred(task);
+				task->role = __lookup_acl_role_label(polstate, task, GR_GLOBAL_UID(cred->uid), GR_GLOBAL_GID(cred->gid));
+			}
+			/* this handles non-nested inherited subjects, nested subjects will still
+			   be dropped currently */
+			if (!reload_state->oldmode && task->inherited)
+				subj = __gr_get_subject_for_task(polstate, task, task->acl->filename, 1);
+			else {
+				/* looked up and tagged to the task previously */
+				subj = task->tmpacl;
+			}
+			/* subj will be non-null */
+			__gr_apply_subject_to_task(polstate, task, subj);
+			if (reload_state->oldmode) {
+				task->acl_role_id = 0;
+				task->acl_sp_role = 0;
+				task->inherited = 0;
+			}
+		} else {
+			// it's a kernel process
+			task->role = polstate->kernel_role;
+			task->acl = polstate->kernel_role->root_label;
+#ifdef CONFIG_GRKERNSEC_ACL_HIDEKERN
+			task->acl->mode &= ~GR_PROCFIND;
+#endif
+		}
+	} while_each_thread(task2, task);
+
+	memcpy(reload_state->oldpolicy_ptr, &reload_state->newpolicy, sizeof(struct gr_policy_state));
+	memcpy(reload_state->oldalloc_ptr, &reload_state->newalloc, sizeof(struct gr_alloc_state));
+
+out:
+
+	return ret;
+}
+
+static int gracl_reload(struct gr_arg *args, unsigned char oldmode)
+{
+	struct gr_reload_state new_reload_state = { };
+	int err;
+
+	new_reload_state.oldpolicy_ptr = polstate;
+	new_reload_state.oldalloc_ptr = current_alloc_state;
+	new_reload_state.oldmode = oldmode;
+
+	current_alloc_state = &new_reload_state.newalloc;
+	polstate = &new_reload_state.newpolicy;
+
+	/* everything relevant is now saved off, copy in the new policy */
+	if (init_variables(args, true)) {
+		gr_log_str(GR_DONT_AUDIT_GOOD, GR_INITF_ACL_MSG, GR_VERSION);
+		err = -ENOMEM;
+		goto error;
+	}
+
+	err = copy_user_acl(args);
+	free_init_variables();
+	if (err)
+		goto error;
+	/* the new policy is copied in, with the old policy available via saved_state
+	   first go through applying roles, making sure to preserve special roles
+	   then apply new subjects, making sure to preserve inherited and nested subjects,
+	   though currently only inherited subjects will be preserved
+	*/
+	err = stop_machine(gracl_reload_apply_policies, &new_reload_state, NULL);
+	if (err)
+		goto error;
+
+	/* we've now applied the new policy, so restore the old policy state to free it */
+	polstate = &new_reload_state.oldpolicy;
+	current_alloc_state = &new_reload_state.oldalloc;
+	free_variables(true);
+
+	/* oldpolicy/oldalloc_ptr point to the new policy/alloc states as they were copied
+	   to running_polstate/current_alloc_state inside stop_machine
+	*/
+	err = 0;
+	goto out;
+error:
+	/* on error of loading the new policy, we'll just keep the previous
+	   policy set around
+	*/
+	free_variables(true);
+
+	/* doesn't affect runtime, but maintains consistent state */
+out:
+	polstate = new_reload_state.oldpolicy_ptr;
+	current_alloc_state = new_reload_state.oldalloc_ptr;
+
+	return err;
+}
+
+static int
+gracl_init(struct gr_arg *args)
+{
+	int error = 0;
+
+	memcpy(gr_system_salt, args->salt, GR_SALT_LEN);
+	memcpy(gr_system_sum, args->sum, GR_SHA_LEN);
+
+	if (init_variables(args, false)) {
+		gr_log_str(GR_DONT_AUDIT_GOOD, GR_INITF_ACL_MSG, GR_VERSION);
+		error = -ENOMEM;
+		goto out;
+	}
+
+	error = copy_user_acl(args);
+	free_init_variables();
+	if (error)
+		goto out;
+
+	error = gr_set_acls(0);
+	if (error)
+		goto out;
+
+	gr_enable_rbac_system();
+
+	return 0;
+
+out:
+	free_variables(false);
+	return error;
+}
+
+static int
+lookup_special_role_auth(__u16 mode, const char *rolename, unsigned char **salt,
+			 unsigned char **sum)
+{
+	struct acl_role_label *r;
+	struct role_allowed_ip *ipp;
+	struct role_transition *trans;
+	unsigned int i;
+	int found = 0;
+	u32 curr_ip = current->signal->curr_ip;
+
+	current->signal->saved_ip = curr_ip;
+
+	/* check transition table */
+
+	for (trans = current->role->transitions; trans; trans = trans->next) {
+		if (!strcmp(rolename, trans->rolename)) {
+			found = 1;
+			break;
+		}
+	}
+
+	if (!found)
+		return 0;
+
+	/* handle special roles that do not require authentication
+	   and check ip */
+
+	FOR_EACH_ROLE_START(r)
+		if (!strcmp(rolename, r->rolename) &&
+		    (r->roletype & GR_ROLE_SPECIAL)) {
+			found = 0;
+			if (r->allowed_ips != NULL) {
+				for (ipp = r->allowed_ips; ipp; ipp = ipp->next) {
+					if ((ntohl(curr_ip) & ipp->netmask) ==
+					     (ntohl(ipp->addr) & ipp->netmask))
+						found = 1;
+				}
+			} else
+				found = 2;
+			if (!found)
+				return 0;
+
+			if (((mode == GR_SPROLE) && (r->roletype & GR_ROLE_NOPW)) ||
+			    ((mode == GR_SPROLEPAM) && (r->roletype & GR_ROLE_PAM))) {
+				*salt = NULL;
+				*sum = NULL;
+				return 1;
+			}
+		}
+	FOR_EACH_ROLE_END(r)
+
+	for (i = 0; i < polstate->num_sprole_pws; i++) {
+		if (!strcmp(rolename, (const char *)polstate->acl_special_roles[i]->rolename)) {
+			*salt = polstate->acl_special_roles[i]->salt;
+			*sum = polstate->acl_special_roles[i]->sum;
+			return 1;
+		}
+	}
+
+	return 0;
+}
+
+int gr_check_secure_terminal(struct task_struct *task)
+{
+	struct task_struct *p, *p2, *p3;
+	struct files_struct *files;
+	struct fdtable *fdt;
+	struct file *our_file = NULL, *file;
+	struct inode *our_inode = NULL;
+	int i;
+
+	if (task->signal->tty == NULL)
+		return 1;
+
+	files = get_files_struct(task);
+	if (files != NULL) {
+		rcu_read_lock();
+		fdt = files_fdtable(files);
+		for (i=0; i < fdt->max_fds; i++) {
+			file = fcheck_files(files, i);
+			if (file && (our_file == NULL) && (file->private_data == task->signal->tty)) {
+				get_file(file);
+				our_file = file;
+			}
+		}
+		rcu_read_unlock();
+		put_files_struct(files);
+	}
+
+	if (our_file == NULL)
+		return 1;
+
+	our_inode = d_backing_inode(our_file->f_path.dentry);
+
+	read_lock(&tasklist_lock);
+	do_each_thread(p2, p) {
+		files = get_files_struct(p);
+		if (files == NULL ||
+		    (p->signal && p->signal->tty == task->signal->tty)) {
+			if (files != NULL)
+				put_files_struct(files);
+			continue;
+		}
+		rcu_read_lock();
+		fdt = files_fdtable(files);
+		for (i=0; i < fdt->max_fds; i++) {
+			struct inode *inode = NULL;
+			file = fcheck_files(files, i);
+			if (file)
+				inode = d_backing_inode(file->f_path.dentry);
+			if (inode && S_ISCHR(inode->i_mode) && inode->i_rdev == our_inode->i_rdev) {
+				p3 = task;
+				while (task_pid_nr(p3) > 0) {
+					if (p3 == p)
+						break;
+					p3 = p3->real_parent;
+				}
+				if (p3 == p)
+					break;
+				gr_log_ttysniff(GR_DONT_AUDIT_GOOD, GR_TTYSNIFF_ACL_MSG, p);
+				gr_handle_alertkill(p);
+				rcu_read_unlock();
+				put_files_struct(files);
+				read_unlock(&tasklist_lock);
+				fput(our_file);
+				return 0;
+			}
+		}
+		rcu_read_unlock();
+		put_files_struct(files);
+	} while_each_thread(p2, p);
+	read_unlock(&tasklist_lock);
+
+	fput(our_file);
+	return 1;
+}
+
+ssize_t
+write_grsec_handler(struct file *file, const char __user * buf, size_t count, loff_t *ppos)
+{
+	struct gr_arg_wrapper uwrap;
+	unsigned char *sprole_salt = NULL;
+	unsigned char *sprole_sum = NULL;
+	int error = 0;
+	int error2 = 0;
+	size_t req_count = 0;
+	unsigned char oldmode = 0;
+
+	mutex_lock(&gr_dev_mutex);
+
+	if (gr_acl_is_enabled() && !(current->acl->mode & GR_KERNELAUTH)) {
+		error = -EPERM;
+		goto out;
+	}
+
+#ifdef CONFIG_COMPAT
+	pax_open_kernel();
+	if (in_compat_syscall()) {
+		copy_gr_arg_wrapper = &copy_gr_arg_wrapper_compat;
+		copy_gr_arg = &copy_gr_arg_compat;
+		copy_acl_object_label = &copy_acl_object_label_compat;
+		copy_acl_subject_label = &copy_acl_subject_label_compat;
+		copy_acl_role_label = &copy_acl_role_label_compat;
+		copy_acl_ip_label = &copy_acl_ip_label_compat;
+		copy_role_allowed_ip = &copy_role_allowed_ip_compat;
+		copy_role_transition = &copy_role_transition_compat;
+		copy_sprole_pw = &copy_sprole_pw_compat;
+		copy_gr_hash_struct = &copy_gr_hash_struct_compat;
+		copy_pointer_from_array = &copy_pointer_from_array_compat;
+		get_gr_arg_wrapper_size = &get_gr_arg_wrapper_size_compat;
+	} else {
+		copy_gr_arg_wrapper = &copy_gr_arg_wrapper_normal;
+		copy_gr_arg = &copy_gr_arg_normal;
+		copy_acl_object_label = &copy_acl_object_label_normal;
+		copy_acl_subject_label = &copy_acl_subject_label_normal;
+		copy_acl_role_label = &copy_acl_role_label_normal;
+		copy_acl_ip_label = &copy_acl_ip_label_normal;
+		copy_role_allowed_ip = &copy_role_allowed_ip_normal;
+		copy_role_transition = &copy_role_transition_normal;
+		copy_sprole_pw = &copy_sprole_pw_normal;
+		copy_gr_hash_struct = &copy_gr_hash_struct_normal;
+		copy_pointer_from_array = &copy_pointer_from_array_normal;
+		get_gr_arg_wrapper_size = &get_gr_arg_wrapper_size_normal;
+	}
+	pax_close_kernel();
+#endif
+
+	req_count = get_gr_arg_wrapper_size();
+
+	if (count != req_count) {
+		gr_log_int_int(GR_DONT_AUDIT_GOOD, GR_DEV_ACL_MSG, (int)count, (int)req_count);
+		error = -EINVAL;
+		goto out;
+	}
+
+	
+	if (gr_auth_expires && time_after_eq(get_seconds(), gr_auth_expires)) {
+		gr_auth_expires = 0;
+		gr_auth_attempts = 0;
+	}
+
+	error = copy_gr_arg_wrapper(buf, &uwrap);
+	if (error)
+		goto out;
+
+	error = copy_gr_arg(uwrap.arg, gr_usermode);
+	if (error)
+		goto out;
+
+	if (gr_usermode->mode != GR_SPROLE && gr_usermode->mode != GR_SPROLEPAM &&
+	    gr_auth_attempts >= CONFIG_GRKERNSEC_ACL_MAXTRIES &&
+	    time_after(gr_auth_expires, get_seconds())) {
+		error = -EBUSY;
+		goto out;
+	}
+
+	/* if non-root trying to do anything other than use a special role,
+	   do not attempt authentication, do not count towards authentication
+	   locking
+	 */
+
+	if (gr_usermode->mode != GR_SPROLE && gr_usermode->mode != GR_STATUS &&
+	    gr_usermode->mode != GR_UNSPROLE && gr_usermode->mode != GR_SPROLEPAM &&
+	    gr_is_global_nonroot(current_uid())) {
+		error = -EPERM;
+		goto out;
+	}
+
+	/* ensure pw and special role name are null terminated */
+
+	gr_usermode->pw[GR_PW_LEN - 1] = '\0';
+	gr_usermode->sp_role[GR_SPROLE_LEN - 1] = '\0';
+
+	/* Okay. 
+	 * We have our enough of the argument structure..(we have yet
+	 * to copy_from_user the tables themselves) . Copy the tables
+	 * only if we need them, i.e. for loading operations. */
+
+	switch (gr_usermode->mode) {
+	case GR_STATUS:
+			if (gr_acl_is_enabled()) {
+				error = 1;
+				if (!gr_check_secure_terminal(current))
+					error = 3;
+			} else
+				error = 2;
+			goto out;
+	case GR_SHUTDOWN:
+		if (gr_acl_is_enabled() && !(chkpw(gr_usermode, gr_system_salt, gr_system_sum))) {
+			stop_machine(gr_rbac_disable, NULL, NULL);
+			free_variables(false);
+			memset(gr_usermode, 0, sizeof(struct gr_arg));
+			memset(gr_system_salt, 0, GR_SALT_LEN);
+			memset(gr_system_sum, 0, GR_SHA_LEN);
+			gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_SHUTS_ACL_MSG);
+		} else if (gr_acl_is_enabled()) {
+			gr_log_noargs(GR_DONT_AUDIT, GR_SHUTF_ACL_MSG);
+			error = -EPERM;
+		} else {
+			gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_SHUTI_ACL_MSG);
+			error = -EAGAIN;
+		}
+		break;
+	case GR_ENABLE:
+		if (!gr_acl_is_enabled() && !(error2 = gracl_init(gr_usermode)))
+			gr_log_str(GR_DONT_AUDIT_GOOD, GR_ENABLE_ACL_MSG, GR_VERSION);
+		else {
+			if (gr_acl_is_enabled())
+				error = -EAGAIN;
+			else
+				error = error2;
+			gr_log_str(GR_DONT_AUDIT, GR_ENABLEF_ACL_MSG, GR_VERSION);
+		}
+		break;
+	case GR_OLDRELOAD:
+		oldmode = 1;
+	case GR_RELOAD:
+		if (!gr_acl_is_enabled()) {
+			gr_log_str(GR_DONT_AUDIT_GOOD, GR_RELOADI_ACL_MSG, GR_VERSION);
+			error = -EAGAIN;
+		} else if (!(chkpw(gr_usermode, gr_system_salt, gr_system_sum))) {
+			error2 = gracl_reload(gr_usermode, oldmode);
+			if (!error2)
+				gr_log_str(GR_DONT_AUDIT_GOOD, GR_RELOAD_ACL_MSG, GR_VERSION);
+			else {
+				gr_log_str(GR_DONT_AUDIT, GR_RELOADF_ACL_MSG, GR_VERSION);
+				error = error2;
+			}
+		} else {
+			gr_log_str(GR_DONT_AUDIT, GR_RELOADF_ACL_MSG, GR_VERSION);
+			error = -EPERM;
+		}
+		break;
+	case GR_SEGVMOD:
+		if (unlikely(!gr_acl_is_enabled())) {
+			gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_SEGVMODI_ACL_MSG);
+			error = -EAGAIN;
+			break;
+		}
+
+		if (!(chkpw(gr_usermode, gr_system_salt, gr_system_sum))) {
+			gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_SEGVMODS_ACL_MSG);
+			if (gr_usermode->segv_device && gr_usermode->segv_inode) {
+				struct acl_subject_label *segvacl;
+				segvacl =
+				    lookup_acl_subj_label(gr_usermode->segv_inode,
+							  gr_usermode->segv_device,
+							  current->role);
+				if (segvacl) {
+					segvacl->crashes = 0;
+					segvacl->expires = 0;
+				}
+			} else
+				gr_find_and_remove_uid(gr_usermode->segv_uid);
+		} else {
+			gr_log_noargs(GR_DONT_AUDIT, GR_SEGVMODF_ACL_MSG);
+			error = -EPERM;
+		}
+		break;
+	case GR_SPROLE:
+	case GR_SPROLEPAM:
+		if (unlikely(!gr_acl_is_enabled())) {
+			gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_SPROLEI_ACL_MSG);
+			error = -EAGAIN;
+			break;
+		}
+
+		if (current->role->expires && time_after_eq(get_seconds(), current->role->expires)) {
+			current->role->expires = 0;
+			current->role->auth_attempts = 0;
+		}
+
+		if (current->role->auth_attempts >= CONFIG_GRKERNSEC_ACL_MAXTRIES &&
+		    time_after(current->role->expires, get_seconds())) {
+			error = -EBUSY;
+			goto out;
+		}
+
+		if (lookup_special_role_auth
+		    (gr_usermode->mode, (const char *)gr_usermode->sp_role, &sprole_salt, &sprole_sum)
+		    && ((!sprole_salt && !sprole_sum)
+			|| !(chkpw(gr_usermode, sprole_salt, sprole_sum)))) {
+			char *p = "";
+			assign_special_role((const char *)gr_usermode->sp_role);
+			read_lock(&tasklist_lock);
+			if (current->real_parent)
+				p = current->real_parent->role->rolename;
+			read_unlock(&tasklist_lock);
+			gr_log_str_int(GR_DONT_AUDIT_GOOD, GR_SPROLES_ACL_MSG,
+					p, acl_sp_role_value);
+		} else {
+			gr_log_str(GR_DONT_AUDIT, GR_SPROLEF_ACL_MSG, gr_usermode->sp_role);
+			error = -EPERM;
+			if(!(current->role->auth_attempts++))
+				current->role->expires = get_seconds() + CONFIG_GRKERNSEC_ACL_TIMEOUT;
+
+			goto out;
+		}
+		break;
+	case GR_UNSPROLE:
+		if (unlikely(!gr_acl_is_enabled())) {
+			gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_UNSPROLEI_ACL_MSG);
+			error = -EAGAIN;
+			break;
+		}
+
+		if (current->role->roletype & GR_ROLE_SPECIAL) {
+			char *p = "";
+			int i = 0;
+
+			read_lock(&tasklist_lock);
+			if (current->real_parent) {
+				p = current->real_parent->role->rolename;
+				i = current->real_parent->acl_role_id;
+			}
+			read_unlock(&tasklist_lock);
+
+			gr_log_str_int(GR_DONT_AUDIT_GOOD, GR_UNSPROLES_ACL_MSG, p, i);
+			gr_set_acls(1);
+		} else {
+			error = -EPERM;
+			goto out;
+		}
+		break;
+	default:
+		gr_log_int(GR_DONT_AUDIT, GR_INVMODE_ACL_MSG, gr_usermode->mode);
+		error = -EINVAL;
+		break;
+	}
+
+	if (error != -EPERM)
+		goto out;
+
+	if(!(gr_auth_attempts++))
+		gr_auth_expires = get_seconds() + CONFIG_GRKERNSEC_ACL_TIMEOUT;
+
+      out:
+	mutex_unlock(&gr_dev_mutex);
+
+	if (!error)
+		error = req_count;
+
+	return error;
+}
+
+int
+gr_set_acls(const int type)
+{
+	struct task_struct *task, *task2;
+	struct acl_role_label *role = current->role;
+	struct acl_subject_label *subj;
+	__u16 acl_role_id = current->acl_role_id;
+	const struct cred *cred;
+	int ret;
+
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+	read_lock(&grsec_exec_file_lock);
+	do_each_thread(task2, task) {
+		/* check to see if we're called from the exit handler,
+		   if so, only replace ACLs that have inherited the admin
+		   ACL */
+
+		if (type && (task->role != role ||
+			     task->acl_role_id != acl_role_id))
+			continue;
+
+		task->acl_role_id = 0;
+		task->acl_sp_role = 0;
+		task->inherited = 0;
+
+		if (task->exec_file) {
+			cred = __task_cred(task);
+			task->role = __lookup_acl_role_label(polstate, task, GR_GLOBAL_UID(cred->uid), GR_GLOBAL_GID(cred->gid));
+			subj = __gr_get_subject_for_task(polstate, task, NULL, 1);
+			if (subj == NULL) {
+				ret = -EINVAL;
+				read_unlock(&grsec_exec_file_lock);
+				read_unlock(&tasklist_lock);
+				rcu_read_unlock();
+				gr_log_str_int(GR_DONT_AUDIT_GOOD, GR_DEFACL_MSG, task->comm, task_pid_nr(task));
+				return ret;
+			}
+			__gr_apply_subject_to_task(polstate, task, subj);
+		} else {
+			// it's a kernel process
+			task->role = polstate->kernel_role;
+			task->acl = polstate->kernel_role->root_label;
+#ifdef CONFIG_GRKERNSEC_ACL_HIDEKERN
+			task->acl->mode &= ~GR_PROCFIND;
+#endif
+		}
+	} while_each_thread(task2, task);
+	read_unlock(&grsec_exec_file_lock);
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+
+	return 0;
+}
diff --git b/grsecurity/gracl_res.c b/grsecurity/gracl_res.c
new file mode 100644
index 000000000..dfba8fd4b
--- /dev/null
+++ b/grsecurity/gracl_res.c
@@ -0,0 +1,74 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/gracl.h>
+#include <linux/grinternal.h>
+
+static const char *restab_log[] = {
+	[RLIMIT_CPU] = "RLIMIT_CPU",
+	[RLIMIT_FSIZE] = "RLIMIT_FSIZE",
+	[RLIMIT_DATA] = "RLIMIT_DATA",
+	[RLIMIT_STACK] = "RLIMIT_STACK",
+	[RLIMIT_CORE] = "RLIMIT_CORE",
+	[RLIMIT_RSS] = "RLIMIT_RSS",
+	[RLIMIT_NPROC] = "RLIMIT_NPROC",
+	[RLIMIT_NOFILE] = "RLIMIT_NOFILE",
+	[RLIMIT_MEMLOCK] = "RLIMIT_MEMLOCK",
+	[RLIMIT_AS] = "RLIMIT_AS",
+	[RLIMIT_LOCKS] = "RLIMIT_LOCKS",
+	[RLIMIT_SIGPENDING] = "RLIMIT_SIGPENDING",
+	[RLIMIT_MSGQUEUE] = "RLIMIT_MSGQUEUE",
+	[RLIMIT_NICE] = "RLIMIT_NICE",
+	[RLIMIT_RTPRIO] = "RLIMIT_RTPRIO",
+	[RLIMIT_RTTIME] = "RLIMIT_RTTIME",
+	[GR_CRASH_RES] = "RLIMIT_CRASH"
+};
+
+void
+gr_log_resource(const struct task_struct *task,
+		const int res, const unsigned long wanted, const int gt)
+{
+	const struct cred *cred;
+	unsigned long rlim;
+
+	if (!gr_acl_is_enabled() && !grsec_resource_logging)
+		return;
+
+	// not yet supported resource
+	if (unlikely(!restab_log[res]))
+		return;
+
+	/*
+	 * not really security relevant, too much userland code shared
+	 * from pulseaudio that blindly attempts to violate limits in a loop,
+	 * resulting in log spam
+	 */
+	if (res == RLIMIT_NICE)
+		return;
+
+	if (res == RLIMIT_CPU || res == RLIMIT_RTTIME)
+		rlim = task_rlimit_max(task, res);
+	else
+		rlim = task_rlimit(task, res);
+
+	if (likely((rlim == RLIM_INFINITY) || (gt && wanted <= rlim) || (!gt && wanted < rlim)))
+		return;
+
+	rcu_read_lock();
+	cred = __task_cred(task);
+
+	if (res == RLIMIT_NPROC && 
+	    (cap_raised(cred->cap_effective, CAP_SYS_ADMIN) || 
+	     cap_raised(cred->cap_effective, CAP_SYS_RESOURCE)))
+		goto out_rcu_unlock;
+	else if (res == RLIMIT_MEMLOCK &&
+		 cap_raised(cred->cap_effective, CAP_IPC_LOCK))
+		goto out_rcu_unlock;
+	rcu_read_unlock();
+
+	gr_log_res_ulong2_str(GR_DONT_AUDIT, GR_RESOURCE_MSG, task, wanted, restab_log[res], rlim);
+
+	return;
+out_rcu_unlock:
+	rcu_read_unlock();
+	return;
+}
diff --git b/grsecurity/gracl_segv.c b/grsecurity/gracl_segv.c
new file mode 100644
index 000000000..02c5a2bb9
--- /dev/null
+++ b/grsecurity/gracl_segv.c
@@ -0,0 +1,306 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <asm/uaccess.h>
+#include <asm/errno.h>
+#include <asm/mman.h>
+#include <net/sock.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/net.h>
+#include <linux/in.h>
+#include <linux/slab.h>
+#include <linux/types.h>
+#include <linux/sched.h>
+#include <linux/timer.h>
+#include <linux/gracl.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+#if defined(CONFIG_BTRFS_FS) || defined(CONFIG_BTRFS_FS_MODULE)
+#include <linux/magic.h>
+#include <linux/pagemap.h>
+#include "../fs/btrfs/async-thread.h"
+#include "../fs/btrfs/ctree.h"
+#include "../fs/btrfs/btrfs_inode.h"
+#endif
+
+static struct crash_uid *uid_set;
+static unsigned short uid_used;
+static DEFINE_SPINLOCK(gr_uid_lock);
+extern rwlock_t gr_inode_lock;
+extern struct acl_subject_label *
+	lookup_acl_subj_label(const u64 inode, const dev_t dev,
+			      const struct acl_role_label *role);
+
+int
+gr_init_uidset(void)
+{
+	uid_set =
+	    kmalloc(GR_UIDTABLE_MAX * sizeof (struct crash_uid), GFP_KERNEL);
+	uid_used = 0;
+
+	return uid_set ? 1 : 0;
+}
+
+void
+gr_free_uidset(void)
+{
+	if (uid_set) {
+		struct crash_uid *tmpset;
+		spin_lock(&gr_uid_lock);
+		tmpset = uid_set;
+		uid_set = NULL;
+		uid_used = 0;
+		spin_unlock(&gr_uid_lock);
+		if (tmpset)
+			kfree(tmpset);
+	}
+
+	return;
+}
+
+int
+gr_find_uid(const uid_t uid)
+{
+	struct crash_uid *tmp = uid_set;
+	uid_t buid;
+	int low = 0, high = uid_used - 1, mid;
+
+	while (high >= low) {
+		mid = (low + high) >> 1;
+		buid = tmp[mid].uid;
+		if (buid == uid)
+			return mid;
+		if (buid > uid)
+			high = mid - 1;
+		if (buid < uid)
+			low = mid + 1;
+	}
+
+	return -1;
+}
+
+static void
+gr_insertsort(void)
+{
+	unsigned short i, j;
+	struct crash_uid index;
+
+	for (i = 1; i < uid_used; i++) {
+		index = uid_set[i];
+		j = i;
+		while ((j > 0) && uid_set[j - 1].uid > index.uid) {
+			uid_set[j] = uid_set[j - 1];
+			j--;
+		}
+		uid_set[j] = index;
+	}
+
+	return;
+}
+
+static void
+gr_insert_uid(const kuid_t kuid, const unsigned long expires)
+{
+	int loc;
+	uid_t uid = GR_GLOBAL_UID(kuid);
+
+	if (uid_used == GR_UIDTABLE_MAX)
+		return;
+
+	loc = gr_find_uid(uid);
+
+	if (loc >= 0) {
+		uid_set[loc].expires = expires;
+		return;
+	}
+
+	uid_set[uid_used].uid = uid;
+	uid_set[uid_used].expires = expires;
+	uid_used++;
+
+	gr_insertsort();
+
+	return;
+}
+
+void
+gr_remove_uid(const unsigned short loc)
+{
+	unsigned short i;
+
+	for (i = loc + 1; i < uid_used; i++)
+		uid_set[i - 1] = uid_set[i];
+
+	uid_used--;
+
+	return;
+}
+
+int gr_find_and_remove_uid(uid_t uid)
+{
+	int loc;
+
+	spin_lock(&gr_uid_lock);
+	loc = gr_find_uid(uid);
+	if (loc >= 0)
+		gr_remove_uid(loc);
+	spin_unlock(&gr_uid_lock);
+
+	return loc >= 0 ? 1 : 0;
+}
+
+int
+gr_check_crash_uid(const kuid_t kuid)
+{
+	int loc;
+	int ret = 0;
+	uid_t uid;
+
+	if (unlikely(!gr_acl_is_enabled()))
+		return 0;
+
+	uid = GR_GLOBAL_UID(kuid);
+
+	spin_lock(&gr_uid_lock);
+	loc = gr_find_uid(uid);
+
+	if (loc < 0)
+		goto out_unlock;
+
+	if (time_before_eq(uid_set[loc].expires, get_seconds()))
+		gr_remove_uid(loc);
+	else
+		ret = 1;
+
+out_unlock:
+	spin_unlock(&gr_uid_lock);
+	return ret;
+}
+
+extern int gr_fake_force_sig(int sig, struct task_struct *t);
+
+void
+gr_handle_crash(struct task_struct *task, const int sig)
+{
+	struct acl_subject_label *curr;
+	struct task_struct *tsk, *tsk2;
+	const struct cred *cred;
+	const struct cred *cred2;
+
+	if (sig != SIGSEGV && sig != SIGKILL && sig != SIGBUS && sig != SIGILL)
+		return;
+
+	if (unlikely(!gr_acl_is_enabled()))
+		return;
+
+	curr = task->acl;
+
+	if (!(curr->resmask & (1U << GR_CRASH_RES)))
+		return;
+
+	if (time_before_eq(curr->expires, get_seconds())) {
+		curr->expires = 0;
+		curr->crashes = 0;
+	}
+
+	curr->crashes++;
+
+	if (!curr->expires)
+		curr->expires = get_seconds() + curr->res[GR_CRASH_RES].rlim_max;
+
+	if ((curr->crashes >= curr->res[GR_CRASH_RES].rlim_cur) &&
+	    time_after(curr->expires, get_seconds())) {
+		int is_priv = is_privileged_binary(task->mm->exe_file->f_path.dentry);
+
+		rcu_read_lock();
+		cred = __task_cred(task);
+		if (gr_is_global_nonroot(cred->uid) && is_priv) {
+			gr_log_crash1(GR_DONT_AUDIT, GR_SEGVSTART_ACL_MSG, task, curr->res[GR_CRASH_RES].rlim_max);
+			spin_lock(&gr_uid_lock);
+			gr_insert_uid(cred->uid, curr->expires);
+			spin_unlock(&gr_uid_lock);
+			curr->expires = 0;
+			curr->crashes = 0;
+			read_lock(&tasklist_lock);
+			do_each_thread(tsk2, tsk) {
+				cred2 = __task_cred(tsk);
+				if (tsk != task && uid_eq(cred2->uid, cred->uid))
+					gr_fake_force_sig(SIGKILL, tsk);
+			} while_each_thread(tsk2, tsk);
+			read_unlock(&tasklist_lock);
+		} else {
+			gr_log_crash2(GR_DONT_AUDIT, GR_SEGVNOSUID_ACL_MSG, task, curr->res[GR_CRASH_RES].rlim_max);
+			read_lock(&tasklist_lock);
+			read_lock(&grsec_exec_file_lock);
+			do_each_thread(tsk2, tsk) {
+				if (likely(tsk != task)) {
+					// if this thread has the same subject as the one that triggered
+					// RES_CRASH and it's the same binary, kill it
+					if (tsk->acl == task->acl && gr_is_same_file(tsk->exec_file, task->exec_file))
+						gr_fake_force_sig(SIGKILL, tsk);
+				}
+			} while_each_thread(tsk2, tsk);
+			read_unlock(&grsec_exec_file_lock);
+			read_unlock(&tasklist_lock);
+		}
+		rcu_read_unlock();
+	}
+
+	return;
+}
+
+int
+gr_check_crash_exec(const struct file *filp)
+{
+	struct acl_subject_label *curr;
+	struct dentry *dentry;
+
+	if (unlikely(!gr_acl_is_enabled()))
+		return 0;
+
+	read_lock(&gr_inode_lock);
+	dentry = filp->f_path.dentry;
+	curr = lookup_acl_subj_label(gr_get_ino_from_dentry(dentry), gr_get_dev_from_dentry(dentry),
+				     current->role);
+	read_unlock(&gr_inode_lock);
+
+	if (!curr || !(curr->resmask & (1U << GR_CRASH_RES)) ||
+	    (!curr->crashes && !curr->expires))
+		return 0;
+
+	if ((curr->crashes >= curr->res[GR_CRASH_RES].rlim_cur) &&
+	    time_after(curr->expires, get_seconds()))
+		return 1;
+	else if (time_before_eq(curr->expires, get_seconds())) {
+		curr->crashes = 0;
+		curr->expires = 0;
+	}
+
+	return 0;
+}
+
+void
+gr_handle_alertkill(struct task_struct *task)
+{
+	struct acl_subject_label *curracl;
+	__u32 curr_ip;
+	struct task_struct *p, *p2;
+
+	if (unlikely(!gr_acl_is_enabled()))
+		return;
+
+	curracl = task->acl;
+	curr_ip = task->signal->curr_ip;
+
+	if ((curracl->mode & GR_KILLIPPROC) && curr_ip) {
+		read_lock(&tasklist_lock);
+		do_each_thread(p2, p) {
+			if (p->signal->curr_ip == curr_ip)
+				gr_fake_force_sig(SIGKILL, p);
+		} while_each_thread(p2, p);
+		read_unlock(&tasklist_lock);
+	} else if (curracl->mode & GR_KILLPROC)
+		gr_fake_force_sig(SIGKILL, task);
+
+	return;
+}
diff --git b/grsecurity/gracl_shm.c b/grsecurity/gracl_shm.c
new file mode 100644
index 000000000..6b0c9cc64
--- /dev/null
+++ b/grsecurity/gracl_shm.c
@@ -0,0 +1,40 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/ipc.h>
+#include <linux/gracl.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+int
+gr_handle_shmat(const pid_t shm_cprid, const pid_t shm_lapid,
+		const u64 shm_createtime, const kuid_t cuid, const int shmid)
+{
+	struct task_struct *task;
+
+	if (!gr_acl_is_enabled())
+		return 1;
+
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+
+	task = find_task_by_vpid(shm_cprid);
+
+	if (unlikely(!task))
+		task = find_task_by_vpid(shm_lapid);
+
+	if (unlikely(task && (time_before_eq64(task->start_time, shm_createtime) ||
+			      (task_pid_nr(task) == shm_lapid)) &&
+		     (task->acl->mode & GR_PROTSHM) &&
+		     (task->acl != current->acl))) {
+		read_unlock(&tasklist_lock);
+		rcu_read_unlock();
+		gr_log_int3(GR_DONT_AUDIT, GR_SHMAT_ACL_MSG, GR_GLOBAL_UID(cuid), shm_cprid, shmid);
+		return 0;
+	}
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+
+	return 1;
+}
diff --git b/grsecurity/grsec_chdir.c b/grsecurity/grsec_chdir.c
new file mode 100644
index 000000000..bc0be01b0
--- /dev/null
+++ b/grsecurity/grsec_chdir.c
@@ -0,0 +1,19 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/file.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+void
+gr_log_chdir(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+#ifdef CONFIG_GRKERNSEC_AUDIT_CHDIR
+	if ((grsec_enable_chdir && grsec_enable_group &&
+	     in_group_p(grsec_audit_gid)) || (grsec_enable_chdir &&
+					      !grsec_enable_group)) {
+		gr_log_fs_generic(GR_DO_AUDIT, GR_CHDIR_AUDIT_MSG, dentry, mnt);
+	}
+#endif
+	return;
+}
diff --git b/grsecurity/grsec_chroot.c b/grsecurity/grsec_chroot.c
new file mode 100644
index 000000000..1964ab1c8
--- /dev/null
+++ b/grsecurity/grsec_chroot.c
@@ -0,0 +1,506 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/mount.h>
+#include <linux/types.h>
+#include <linux/namei.h>
+#include "../fs/mount.h"
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+#ifdef CONFIG_GRKERNSEC_CHROOT_INITRD
+int gr_init_ran;
+#endif
+
+void gr_inc_chroot_refcnts(struct dentry *dentry, struct vfsmount *mnt)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+	struct dentry *tmpd = dentry;
+
+	read_seqlock_excl(&mount_lock);
+	write_seqlock(&rename_lock);
+
+	while (tmpd != mnt->mnt_root) {
+		atomic_inc(&tmpd->chroot_refcnt);
+		tmpd = tmpd->d_parent;
+	}
+	atomic_inc(&tmpd->chroot_refcnt);
+
+	write_sequnlock(&rename_lock);
+	read_sequnlock_excl(&mount_lock);
+#endif
+}
+
+void gr_dec_chroot_refcnts(struct dentry *dentry, struct vfsmount *mnt)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+	struct dentry *tmpd = dentry;
+
+	read_seqlock_excl(&mount_lock);
+	write_seqlock(&rename_lock);
+
+	while (tmpd != mnt->mnt_root) {
+		atomic_dec(&tmpd->chroot_refcnt);
+		tmpd = tmpd->d_parent;
+	}
+	atomic_dec(&tmpd->chroot_refcnt);
+
+	write_sequnlock(&rename_lock);
+	read_sequnlock_excl(&mount_lock);
+#endif
+}
+
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+static struct dentry *get_closest_chroot(struct dentry *dentry)
+{
+	write_seqlock(&rename_lock);
+	do {
+		if (atomic_read(&dentry->chroot_refcnt)) {
+			write_sequnlock(&rename_lock);
+			return dentry;
+		}
+		dentry = dentry->d_parent;
+	} while (!IS_ROOT(dentry));
+	write_sequnlock(&rename_lock);
+	return NULL;
+}
+#endif
+
+int gr_bad_chroot_rename(struct dentry *olddentry, struct vfsmount *oldmnt,
+			 struct dentry *newdentry, struct vfsmount *newmnt)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+	struct dentry *chroot;
+
+	if (unlikely(!grsec_enable_chroot_rename))
+		return 0;
+
+	if (likely(!proc_is_chrooted(current) && gr_is_global_root(current_uid())))
+		return 0;
+
+	chroot = get_closest_chroot(olddentry);
+
+	if (chroot == NULL)
+		return 0;
+
+	if (is_subdir(newdentry, chroot))
+		return 0;
+
+	gr_log_fs_generic(GR_DONT_AUDIT, GR_CHROOT_RENAME_MSG, olddentry, oldmnt);
+
+	return 1;
+#else
+	return 0;
+#endif
+}
+
+void gr_set_chroot_entries(struct task_struct *task, const struct path *path)
+{
+#ifdef CONFIG_GRKERNSEC
+	if (task_pid_nr(task) > 1 && path->dentry != init_task.fs->root.dentry &&
+	    		     path->dentry != task->nsproxy->mnt_ns->root->mnt.mnt_root
+#ifdef CONFIG_GRKERNSEC_CHROOT_INITRD
+			     && gr_init_ran
+#endif
+	   )
+		task->gr_is_chrooted = 1;
+	else {
+#ifdef CONFIG_GRKERNSEC_CHROOT_INITRD
+		if (task_pid_nr(task) == 1 && !gr_init_ran)
+			gr_init_ran = 1;
+#endif
+		task->gr_is_chrooted = 0;
+	}
+
+	task->gr_chroot_dentry = path->dentry;
+#endif
+	return;
+}
+
+void gr_clear_chroot_entries(struct task_struct *task)
+{
+#ifdef CONFIG_GRKERNSEC
+	task->gr_is_chrooted = 0;
+	task->gr_chroot_dentry = NULL;
+#endif
+	return;
+}	
+
+int
+gr_handle_chroot_unix(const pid_t pid)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_UNIX
+	struct task_struct *p;
+
+	if (unlikely(!grsec_enable_chroot_unix))
+		return 1;
+
+	if (likely(!proc_is_chrooted(current)))
+		return 1;
+
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+	p = find_task_by_vpid_unrestricted(pid);
+	if (unlikely(p && !have_same_root(current, p))) {
+		read_unlock(&tasklist_lock);
+		rcu_read_unlock();
+		gr_log_noargs(GR_DONT_AUDIT, GR_UNIX_CHROOT_MSG);
+		return 0;
+	}
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+#endif
+	return 1;
+}
+
+int
+gr_handle_chroot_nice(void)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_NICE
+	if (grsec_enable_chroot_nice && proc_is_chrooted(current)) {
+		gr_log_noargs(GR_DONT_AUDIT, GR_NICE_CHROOT_MSG);
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_chroot_setpriority(struct task_struct *p, const int niceval)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_NICE
+	if (grsec_enable_chroot_nice && (niceval < task_nice(p))
+			&& proc_is_chrooted(current)) {
+		gr_log_str_int(GR_DONT_AUDIT, GR_PRIORITY_CHROOT_MSG, p->comm, task_pid_nr(p));
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_chroot_fowner(struct pid *pid, enum pid_type type)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_FINDTASK
+	struct task_struct *p;
+	int ret = 0;
+	if (!grsec_enable_chroot_findtask || !proc_is_chrooted(current) || !pid)
+		return ret;
+
+	read_lock(&tasklist_lock);
+	do_each_pid_task(pid, type, p) {
+		if (!have_same_root(current, p)) {
+			ret = 1;
+			goto out;
+		}
+	} while_each_pid_task(pid, type, p);
+out:
+	read_unlock(&tasklist_lock);
+	return ret;
+#endif
+	return 0;
+}
+
+int
+gr_pid_is_chrooted(struct task_struct *p)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_FINDTASK
+	if (!grsec_enable_chroot_findtask || !proc_is_chrooted(current) || p == NULL)
+		return 0;
+
+	if ((p->exit_state & (EXIT_ZOMBIE | EXIT_DEAD)) ||
+	    !have_same_root(current, p)) {
+		return 1;
+	}
+#endif
+	return 0;
+}
+
+EXPORT_SYMBOL_GPL(gr_pid_is_chrooted);
+
+#if defined(CONFIG_GRKERNSEC_CHROOT_DOUBLE) || defined(CONFIG_GRKERNSEC_CHROOT_FCHDIR)
+int gr_is_outside_chroot(const struct dentry *u_dentry, const struct vfsmount *u_mnt)
+{
+	struct path path, currentroot;
+	int ret = 0;
+
+	path.dentry = (struct dentry *)u_dentry;
+	path.mnt = (struct vfsmount *)u_mnt;
+	get_fs_root(current->fs, &currentroot);
+	if (path_is_under(&path, &currentroot))
+		ret = 1;
+	path_put(&currentroot);
+
+	return ret;
+}
+#endif
+
+int
+gr_chroot_fchdir(struct dentry *u_dentry, struct vfsmount *u_mnt)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_FCHDIR
+	if (!grsec_enable_chroot_fchdir)
+		return 1;
+
+	if (!proc_is_chrooted(current))
+		return 1;
+	else if (!gr_is_outside_chroot(u_dentry, u_mnt)) {
+		gr_log_fs_generic(GR_DONT_AUDIT, GR_CHROOT_FCHDIR_MSG, u_dentry, u_mnt);
+		return 0;
+	}
+#endif
+	return 1;
+}
+
+int
+gr_chroot_pathat(int dfd, struct dentry *u_dentry, struct vfsmount *u_mnt, unsigned flags)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_FCHDIR
+	struct fd f;
+	struct path fd_path;
+	struct path file_path;
+
+	if (!grsec_enable_chroot_fchdir)
+		return 0;
+
+	if (!proc_is_chrooted(current) || dfd == -1 || dfd == AT_FDCWD)
+		return 0;
+
+	if (flags & LOOKUP_RCU)
+		return -ECHILD;
+
+	f = fdget_raw(dfd);
+	if (!f.file)
+		return 0;
+
+	fd_path = f.file->f_path;
+	path_get(&fd_path);
+	fdput(f);
+
+	file_path.dentry = u_dentry;
+	file_path.mnt = u_mnt;
+
+	if (!gr_is_outside_chroot(u_dentry, u_mnt) && !path_is_under(&file_path, &fd_path)) {
+		path_put(&fd_path);
+		gr_log_fs_generic(GR_DONT_AUDIT, GR_CHROOT_PATHAT_MSG, u_dentry, u_mnt);
+		return -ENOENT;
+	}
+	path_put(&fd_path);
+#endif
+	return 0;
+}
+
+int
+gr_chroot_fhandle(void)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_FCHDIR
+	if (!grsec_enable_chroot_fchdir)
+		return 1;
+
+	if (!proc_is_chrooted(current))
+		return 1;
+	else {
+		gr_log_noargs(GR_DONT_AUDIT, GR_CHROOT_FHANDLE_MSG);
+		return 0;
+	}
+#endif
+	return 1;
+}
+
+int
+gr_chroot_shmat(const pid_t shm_cprid, const pid_t shm_lapid,
+		const u64 shm_createtime)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_SHMAT
+	struct task_struct *p;
+
+	if (unlikely(!grsec_enable_chroot_shmat))
+		return 1;
+
+	if (likely(!proc_is_chrooted(current)))
+		return 1;
+
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+
+	if ((p = find_task_by_vpid_unrestricted(shm_cprid))) {
+		if (time_before_eq64(p->start_time, shm_createtime)) {
+			if (have_same_root(current, p)) {
+				goto allow;
+			} else {
+				read_unlock(&tasklist_lock);
+				rcu_read_unlock();
+				gr_log_noargs(GR_DONT_AUDIT, GR_SHMAT_CHROOT_MSG);
+				return 0;
+			}
+		}
+		/* creator exited, pid reuse, fall through to next check */
+	}
+	if ((p = find_task_by_vpid_unrestricted(shm_lapid))) {
+		if (unlikely(!have_same_root(current, p))) {
+			read_unlock(&tasklist_lock);
+			rcu_read_unlock();
+			gr_log_noargs(GR_DONT_AUDIT, GR_SHMAT_CHROOT_MSG);
+			return 0;
+		}
+	}
+
+allow:
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+#endif
+	return 1;
+}
+
+void
+gr_log_chroot_exec(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_EXECLOG
+	if (grsec_enable_chroot_execlog && proc_is_chrooted(current))
+		gr_log_fs_generic(GR_DO_AUDIT, GR_EXEC_CHROOT_MSG, dentry, mnt);
+#endif
+	return;
+}
+
+int
+gr_handle_chroot_mknod(const struct dentry *dentry,
+		       const struct vfsmount *mnt, const int mode)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_MKNOD
+	if (grsec_enable_chroot_mknod && !S_ISFIFO(mode) && !S_ISREG(mode) && 
+	    proc_is_chrooted(current)) {
+		gr_log_fs_generic(GR_DONT_AUDIT, GR_MKNOD_CHROOT_MSG, dentry, mnt);
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_chroot_mount(const struct dentry *dentry,
+		       const struct vfsmount *mnt, const char *dev_name)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_MOUNT
+	if (grsec_enable_chroot_mount && proc_is_chrooted(current)) {
+		gr_log_str_fs(GR_DONT_AUDIT, GR_MOUNT_CHROOT_MSG, dev_name ? dev_name : "none", dentry, mnt);
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_chroot_pivot(void)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_PIVOT
+	if (grsec_enable_chroot_pivot && proc_is_chrooted(current)) {
+		gr_log_noargs(GR_DONT_AUDIT, GR_PIVOT_CHROOT_MSG);
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_chroot_chroot(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_DOUBLE
+	if (grsec_enable_chroot_double && proc_is_chrooted(current) &&
+	    !gr_is_outside_chroot(dentry, mnt)) {
+		gr_log_fs_generic(GR_DONT_AUDIT, GR_CHROOT_CHROOT_MSG, dentry, mnt);
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
+
+extern const char *captab_log[];
+extern int captab_log_entries;
+
+int
+gr_task_chroot_is_capable(const struct task_struct *task, const struct cred *cred, const int cap)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_CAPS
+	if (grsec_enable_chroot_caps && proc_is_chrooted(task)) {
+		kernel_cap_t chroot_caps = GR_CHROOT_CAPS;
+		if (cap_raised(chroot_caps, cap)) {
+			if (cap_raised(cred->cap_effective, cap) && cap < captab_log_entries) {
+				gr_log_cap(GR_DONT_AUDIT, GR_CAP_CHROOT_MSG, task, captab_log[cap]);
+			}
+			return 0;
+		}
+	}
+#endif
+	return 1;
+}
+
+int
+gr_chroot_is_capable(const int cap)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_CAPS
+	return gr_task_chroot_is_capable(current, current_cred(), cap);
+#endif
+	return 1;
+}
+
+int
+gr_task_chroot_is_capable_nolog(const struct task_struct *task, const int cap)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_CAPS
+	if (grsec_enable_chroot_caps && proc_is_chrooted(task)) {
+		kernel_cap_t chroot_caps = GR_CHROOT_CAPS;
+		if (cap_raised(chroot_caps, cap)) {
+			return 0;
+		}
+	}
+#endif
+	return 1;
+}
+
+int
+gr_chroot_is_capable_nolog(const int cap)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_CAPS
+	return gr_task_chroot_is_capable_nolog(current, cap);
+#endif
+	return 1;
+}
+
+int
+gr_handle_chroot_sysctl(const int op)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_SYSCTL
+	if (grsec_enable_chroot_sysctl && (op & MAY_WRITE) &&
+	    proc_is_chrooted(current))
+		return -EACCES;
+#endif
+	return 0;
+}
+
+void
+gr_handle_chroot_chdir(const struct path *path)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_CHDIR
+	if (grsec_enable_chroot_chdir)
+		set_fs_pwd(current->fs, path);
+#endif
+	return;
+}
+
+int
+gr_handle_chroot_chmod(const struct dentry *dentry,
+		       const struct vfsmount *mnt, const int mode)
+{
+#ifdef CONFIG_GRKERNSEC_CHROOT_CHMOD
+	/* allow chmod +s on directories, but not files */
+	if (grsec_enable_chroot_chmod && !d_is_dir(dentry) &&
+	    ((mode & S_ISUID) || ((mode & (S_ISGID | S_IXGRP)) == (S_ISGID | S_IXGRP))) &&
+	    proc_is_chrooted(current)) {
+		gr_log_fs_generic(GR_DONT_AUDIT, GR_CHMOD_CHROOT_MSG, dentry, mnt);
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_disabled.c b/grsecurity/grsec_disabled.c
new file mode 100644
index 000000000..ba8d9971e
--- /dev/null
+++ b/grsecurity/grsec_disabled.c
@@ -0,0 +1,445 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/kdev_t.h>
+#include <linux/net.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#include <linux/skbuff.h>
+#include <linux/sysctl.h>
+
+#ifdef CONFIG_PAX_HAVE_ACL_FLAGS
+void
+pax_set_initial_flags(struct linux_binprm *bprm)
+{
+	return;
+}
+#endif
+
+#ifdef CONFIG_SYSCTL
+__u32
+gr_handle_sysctl(const struct ctl_table * table, const int op)
+{
+	return 0;
+}
+#endif
+
+#ifdef CONFIG_TASKSTATS
+int gr_is_taskstats_denied(int pid)
+{
+	return 0;
+}
+#endif
+
+int
+gr_acl_is_enabled(void)
+{
+	return 0;
+}
+
+int
+gr_learn_cap(const struct task_struct *task, const struct cred *cred, const int cap, bool log)
+{
+	return 0;
+}
+
+void
+gr_handle_proc_create(const struct dentry *dentry, const struct inode *inode) 
+{
+	return;
+}
+
+int
+gr_handle_rawio(const struct inode *inode)
+{
+	return 0;
+}
+
+void
+gr_acl_handle_psacct(struct task_struct *task, const long code)
+{
+	return;
+}
+
+int
+gr_handle_ptrace(struct task_struct *task, const long request)
+{
+	return 0;
+}
+
+int
+gr_handle_proc_ptrace(struct task_struct *task)
+{
+	return 0;
+}
+
+int
+gr_set_acls(const int type)
+{
+	return 0;
+}
+
+int
+gr_check_hidden_task(const struct task_struct *tsk)
+{
+	return 0;
+}
+
+int
+gr_check_protected_task(const struct task_struct *task)
+{
+	return 0;
+}
+
+int
+gr_check_protected_task_fowner(struct pid *pid, enum pid_type type)
+{
+	return 0;
+}
+
+void
+gr_copy_label(struct task_struct *tsk)
+{
+	return;
+}
+
+void
+gr_set_pax_flags(struct task_struct *task)
+{
+	return;
+}
+
+int
+gr_set_proc_label(const struct dentry *dentry, const struct vfsmount *mnt,
+		  const int unsafe_share)
+{
+	return 0;
+}
+
+void
+gr_handle_delete(const u64 ino, const dev_t dev)
+{
+	return;
+}
+
+void
+gr_handle_create(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+	return;
+}
+
+void
+gr_handle_crash(struct task_struct *task, const int sig)
+{
+	return;
+}
+
+int
+gr_check_crash_exec(const struct file *filp)
+{
+	return 0;
+}
+
+int
+gr_check_crash_uid(const kuid_t uid)
+{
+	return 0;
+}
+
+void
+gr_handle_rename(struct inode *old_dir, struct inode *new_dir,
+		 struct dentry *old_dentry,
+		 struct dentry *new_dentry,
+		 struct vfsmount *mnt, const __u8 replace, unsigned int flags)
+{
+	return;
+}
+
+int
+gr_search_socket(const int family, const int type, const int protocol)
+{
+	return 1;
+}
+
+int
+gr_search_connectbind(const int mode, const struct socket *sock,
+		      const struct sockaddr_in *addr)
+{
+	return 0;
+}
+
+void
+gr_handle_alertkill(struct task_struct *task)
+{
+	return;
+}
+
+__u32
+gr_acl_handle_execve(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_hidden_file(const struct dentry * dentry,
+			  const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_open(const struct dentry * dentry, const struct vfsmount * mnt,
+		   int acc_mode)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_rmdir(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_unlink(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+int
+gr_acl_handle_mmap(const struct file *file, const unsigned long prot,
+		   unsigned int *vm_flags)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_truncate(const struct dentry * dentry,
+		       const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_utime(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_access(const struct dentry * dentry,
+		     const struct vfsmount * mnt, const int fmode)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_chmod(const struct dentry * dentry, const struct vfsmount * mnt,
+		    umode_t *mode)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_chown(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_setxattr(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_removexattr(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+void
+grsecurity_init(void)
+{
+	return;
+}
+
+umode_t gr_acl_umask(void)
+{
+	return 0;
+}
+
+__u32
+gr_acl_handle_mknod(const struct dentry * new_dentry,
+		    const struct dentry * parent_dentry,
+		    const struct vfsmount * parent_mnt,
+		    const int mode)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_mkdir(const struct dentry * new_dentry,
+		    const struct dentry * parent_dentry,
+		    const struct vfsmount * parent_mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_symlink(const struct dentry * new_dentry,
+		      const struct dentry * parent_dentry,
+		      const struct vfsmount * parent_mnt, const struct filename *from)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_link(const struct dentry * new_dentry,
+		   const struct dentry * parent_dentry,
+		   const struct vfsmount * parent_mnt,
+		   const struct dentry * old_dentry,
+		   const struct vfsmount * old_mnt, const struct filename *to)
+{
+	return 1;
+}
+
+int
+gr_acl_handle_rename(const struct dentry *new_dentry,
+		     const struct dentry *parent_dentry,
+		     const struct vfsmount *parent_mnt,
+		     const struct dentry *old_dentry,
+		     const struct inode *old_parent_inode,
+		     const struct vfsmount *old_mnt, const struct filename *newname,
+		     unsigned int flags)
+{
+	return 0;
+}
+
+int
+gr_acl_handle_filldir(const struct file *file, const char *name,
+		      const int namelen, const u64 ino)
+{
+	return 1;
+}
+
+int
+gr_handle_shmat(const pid_t shm_cprid, const pid_t shm_lapid,
+		const u64 shm_createtime, const kuid_t cuid, const int shmid)
+{
+	return 1;
+}
+
+int
+gr_search_bind(const struct socket *sock, const struct sockaddr_in *addr)
+{
+	return 0;
+}
+
+int
+gr_search_accept(const struct socket *sock)
+{
+	return 0;
+}
+
+int
+gr_search_listen(const struct socket *sock)
+{
+	return 0;
+}
+
+int
+gr_search_connect(const struct socket *sock, const struct sockaddr_in *addr)
+{
+	return 0;
+}
+
+__u32
+gr_acl_handle_unix(const struct dentry * dentry, const struct vfsmount * mnt)
+{
+	return 1;
+}
+
+__u32
+gr_acl_handle_creat(const struct dentry * dentry,
+		    const struct dentry * p_dentry,
+		    const struct vfsmount * p_mnt, int open_flags, int acc_mode,
+		    const int imode)
+{
+	return 1;
+}
+
+void
+gr_acl_handle_exit(void)
+{
+	return;
+}
+
+int
+gr_acl_handle_mprotect(const struct file *file, const unsigned long prot)
+{
+	return 1;
+}
+
+void
+gr_set_role_label(const kuid_t uid, const kgid_t gid)
+{
+	return;
+}
+
+int
+gr_acl_handle_procpidmem(const struct task_struct *task)
+{
+	return 0;
+}
+
+int
+gr_search_udp_recvmsg(struct sock *sk, const struct sk_buff *skb)
+{
+	return 0;
+}
+
+int
+gr_search_udp_sendmsg(struct sock *sk, struct sockaddr_in *addr)
+{
+	return 0;
+}
+
+int
+gr_check_user_change(kuid_t real, kuid_t effective, kuid_t fs)
+{
+	return 0;
+}
+
+int
+gr_check_group_change(kgid_t real, kgid_t effective, kgid_t fs)
+{
+	return 0;
+}
+
+int gr_acl_enable_at_secure(void)
+{
+	return 0;
+}
+
+dev_t gr_get_dev_from_dentry(struct dentry *dentry)
+{
+	return d_backing_inode(dentry)->i_sb->s_dev;
+}
+
+u64 gr_get_ino_from_dentry(struct dentry *dentry)
+{
+	return d_backing_inode(dentry)->i_ino;
+}
+
+void gr_put_exec_file(struct task_struct *task)
+{
+	return;
+}
+
+#ifdef CONFIG_SECURITY
+EXPORT_SYMBOL_GPL(gr_check_user_change);
+EXPORT_SYMBOL_GPL(gr_check_group_change);
+#endif
diff --git b/grsecurity/grsec_exec.c b/grsecurity/grsec_exec.c
new file mode 100644
index 000000000..808006ec2
--- /dev/null
+++ b/grsecurity/grsec_exec.c
@@ -0,0 +1,188 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/binfmts.h>
+#include <linux/fs.h>
+#include <linux/types.h>
+#include <linux/grdefs.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+#include <linux/capability.h>
+#include <linux/module.h>
+#include <linux/compat.h>
+
+#include <asm/uaccess.h>
+
+#ifdef CONFIG_GRKERNSEC_EXECLOG
+static char gr_exec_arg_buf[132];
+static DEFINE_MUTEX(gr_exec_arg_mutex);
+#endif
+
+struct user_arg_ptr {
+#ifdef CONFIG_COMPAT
+	bool is_compat;
+#endif
+	union {
+		const char __user *const __user *native;
+#ifdef CONFIG_COMPAT
+		const compat_uptr_t __user *compat;
+#endif
+	} ptr;
+};
+
+extern const char __user *get_user_arg_ptr(struct user_arg_ptr argv, int nr);
+
+void
+gr_handle_exec_args(struct linux_binprm *bprm, struct user_arg_ptr argv)
+{
+#ifdef CONFIG_GRKERNSEC_EXECLOG
+	char *grarg = gr_exec_arg_buf;
+	unsigned int i, x, execlen = 0;
+	char c;
+
+	if (!((grsec_enable_execlog && grsec_enable_group &&
+	       in_group_p(grsec_audit_gid))
+	      || (grsec_enable_execlog && !grsec_enable_group)))
+		return;
+
+	mutex_lock(&gr_exec_arg_mutex);
+	memset(grarg, 0, sizeof(gr_exec_arg_buf));
+
+	for (i = 0; i < bprm->argc && execlen < 128; i++) {
+		const char __user *p;
+		unsigned int len;
+
+		p = get_user_arg_ptr(argv, i);
+		if (IS_ERR(p))
+			goto log;
+
+		len = strnlen_user(p, 128 - execlen);
+		if (len > 128 - execlen)
+			len = 128 - execlen;
+		else if (len > 0)
+			len--;
+		if (copy_from_user(grarg + execlen, p, len))
+			goto log;
+
+		/* rewrite unprintable characters */
+		for (x = 0; x < len; x++) {
+			c = *(grarg + execlen + x);
+			if (c < 32 || c > 126)
+				*(grarg + execlen + x) = ' ';
+		}
+
+		execlen += len;
+		*(grarg + execlen) = ' ';
+		*(grarg + execlen + 1) = '\0';
+		execlen++;
+	}
+
+      log:
+	gr_log_fs_str(GR_DO_AUDIT, GR_EXEC_AUDIT_MSG, bprm->file->f_path.dentry,
+			bprm->file->f_path.mnt, grarg);
+	mutex_unlock(&gr_exec_arg_mutex);
+#endif
+	return;
+}
+
+#ifdef CONFIG_GRKERNSEC
+extern int gr_acl_is_capable(const int cap);
+extern int gr_acl_is_capable_nolog(const int cap);
+extern int gr_task_acl_is_capable(const struct task_struct *task, const struct cred *cred, const int cap, bool log);
+extern int gr_chroot_is_capable(const int cap);
+extern int gr_chroot_is_capable_nolog(const int cap);
+extern int gr_task_chroot_is_capable(const struct task_struct *task, const struct cred *cred, const int cap);
+extern int gr_task_chroot_is_capable_nolog(const struct task_struct *task, const int cap);
+#endif
+
+const char *captab_log[] = {
+	"CAP_CHOWN",
+	"CAP_DAC_OVERRIDE",
+	"CAP_DAC_READ_SEARCH",
+	"CAP_FOWNER",
+	"CAP_FSETID",
+	"CAP_KILL",
+	"CAP_SETGID",
+	"CAP_SETUID",
+	"CAP_SETPCAP",
+	"CAP_LINUX_IMMUTABLE",
+	"CAP_NET_BIND_SERVICE",
+	"CAP_NET_BROADCAST",
+	"CAP_NET_ADMIN",
+	"CAP_NET_RAW",
+	"CAP_IPC_LOCK",
+	"CAP_IPC_OWNER",
+	"CAP_SYS_MODULE",
+	"CAP_SYS_RAWIO",
+	"CAP_SYS_CHROOT",
+	"CAP_SYS_PTRACE",
+	"CAP_SYS_PACCT",
+	"CAP_SYS_ADMIN",
+	"CAP_SYS_BOOT",
+	"CAP_SYS_NICE",
+	"CAP_SYS_RESOURCE",
+	"CAP_SYS_TIME",
+	"CAP_SYS_TTY_CONFIG",
+	"CAP_MKNOD",
+	"CAP_LEASE",
+	"CAP_AUDIT_WRITE",
+	"CAP_AUDIT_CONTROL",
+	"CAP_SETFCAP",
+	"CAP_MAC_OVERRIDE",
+	"CAP_MAC_ADMIN",
+	"CAP_SYSLOG",
+	"CAP_WAKE_ALARM",
+	"CAP_BLOCK_SUSPEND",
+	"CAP_AUDIT_READ"
+};
+
+int captab_log_entries = sizeof(captab_log)/sizeof(captab_log[0]);
+
+int gr_is_capable(const int cap)
+{
+#ifdef CONFIG_GRKERNSEC
+	if (gr_acl_is_capable(cap) && gr_chroot_is_capable(cap))
+		return 1;
+	return 0;
+#else
+	return 1;
+#endif
+}
+
+int gr_task_is_capable(const struct task_struct *task, const struct cred *cred, const int cap)
+{
+#ifdef CONFIG_GRKERNSEC
+	if (gr_task_acl_is_capable(task, cred, cap, true) && gr_task_chroot_is_capable(task, cred, cap))
+		return 1;
+	return 0;
+#else
+	return 1;
+#endif
+}
+
+int gr_is_capable_nolog(const int cap)
+{
+#ifdef CONFIG_GRKERNSEC
+	if (gr_acl_is_capable_nolog(cap) && gr_chroot_is_capable_nolog(cap))
+		return 1;
+	return 0;
+#else
+	return 1;
+#endif
+}
+
+int gr_task_is_capable_nolog(const struct task_struct *task, const struct cred *cred, const int cap)
+{
+#ifdef CONFIG_GRKERNSEC
+	if (gr_task_acl_is_capable(task, cred, cap, false) && gr_task_chroot_is_capable_nolog(task, cap))
+		return 1;
+	return 0;
+#else
+	return 1;
+#endif
+}
+
+EXPORT_SYMBOL_GPL(gr_is_capable);
+EXPORT_SYMBOL_GPL(gr_is_capable_nolog);
+EXPORT_SYMBOL_GPL(gr_task_is_capable);
+EXPORT_SYMBOL_GPL(gr_task_is_capable_nolog);
diff --git b/grsecurity/grsec_fifo.c b/grsecurity/grsec_fifo.c
new file mode 100644
index 000000000..cdec49b4f
--- /dev/null
+++ b/grsecurity/grsec_fifo.c
@@ -0,0 +1,26 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/file.h>
+#include <linux/grinternal.h>
+
+int
+gr_handle_fifo(const struct dentry *dentry, const struct vfsmount *mnt,
+	       const struct dentry *dir, const int flag, const int acc_mode)
+{
+#ifdef CONFIG_GRKERNSEC_FIFO
+	const struct cred *cred = current_cred();
+	struct inode *inode = d_backing_inode(dentry);
+	struct inode *dir_inode = d_backing_inode(dir);
+
+	if (grsec_enable_fifo && S_ISFIFO(inode->i_mode) &&
+	    !(flag & O_EXCL) && (dir_inode->i_mode & S_ISVTX) &&
+	    !uid_eq(inode->i_uid, dir_inode->i_uid) &&
+	    !uid_eq(cred->fsuid, inode->i_uid)) {
+		if (!inode_permission(inode, acc_mode))
+			gr_log_fs_int2(GR_DONT_AUDIT, GR_FIFO_MSG, dentry, mnt, GR_GLOBAL_UID(inode->i_uid), GR_GLOBAL_GID(inode->i_gid));
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_fork.c b/grsecurity/grsec_fork.c
new file mode 100644
index 000000000..8ca18bfaf
--- /dev/null
+++ b/grsecurity/grsec_fork.c
@@ -0,0 +1,23 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+#include <linux/errno.h>
+
+void
+gr_log_forkfail(const int retval)
+{
+#ifdef CONFIG_GRKERNSEC_FORKFAIL
+	if (grsec_enable_forkfail && (retval == -EAGAIN || retval == -ENOMEM)) {
+		switch (retval) {
+			case -EAGAIN:
+				gr_log_str(GR_DONT_AUDIT, GR_FAILFORK_MSG, "EAGAIN");
+				break;
+			case -ENOMEM:
+				gr_log_str(GR_DONT_AUDIT, GR_FAILFORK_MSG, "ENOMEM");
+				break;
+		}
+	}
+#endif
+	return;
+}
diff --git b/grsecurity/grsec_init.c b/grsecurity/grsec_init.c
new file mode 100644
index 000000000..68222080f
--- /dev/null
+++ b/grsecurity/grsec_init.c
@@ -0,0 +1,294 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/gracl.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <linux/percpu.h>
+#include <linux/module.h>
+
+int grsec_enable_ptrace_readexec __read_only;
+int grsec_enable_setxid __read_only;
+int grsec_enable_symlinkown __read_only;
+kgid_t grsec_symlinkown_gid __read_only;
+int grsec_enable_brute __read_only;
+int grsec_enable_link __read_only;
+int grsec_enable_dmesg __read_only;
+int grsec_enable_harden_ptrace __read_only;
+int grsec_enable_harden_ipc __read_only;
+int grsec_enable_fifo __read_only;
+int grsec_enable_execlog __read_only;
+int grsec_enable_signal __read_only;
+int grsec_enable_forkfail __read_only;
+int grsec_enable_audit_ptrace __read_only;
+int grsec_enable_time __read_only;
+int grsec_enable_group __read_only;
+kgid_t grsec_audit_gid __read_only;
+int grsec_enable_chdir __read_only;
+int grsec_enable_mount __read_only;
+int grsec_enable_rofs __read_only;
+int grsec_deny_new_usb __read_only;
+int grsec_enable_chroot_findtask __read_only;
+int grsec_enable_chroot_mount __read_only;
+int grsec_enable_chroot_shmat __read_only;
+int grsec_enable_chroot_fchdir __read_only;
+int grsec_enable_chroot_double __read_only;
+int grsec_enable_chroot_pivot __read_only;
+int grsec_enable_chroot_chdir __read_only;
+int grsec_enable_chroot_chmod __read_only;
+int grsec_enable_chroot_mknod __read_only;
+int grsec_enable_chroot_nice __read_only;
+int grsec_enable_chroot_execlog __read_only;
+int grsec_enable_chroot_caps __read_only;
+int grsec_enable_chroot_rename __read_only;
+int grsec_enable_chroot_sysctl __read_only;
+int grsec_enable_chroot_unix __read_only;
+int grsec_enable_tpe __read_only;
+kgid_t grsec_tpe_gid __read_only;
+int grsec_enable_blackhole __read_only;
+#ifdef CONFIG_IPV6_MODULE
+EXPORT_SYMBOL_GPL(grsec_enable_blackhole);
+#endif
+int grsec_lastack_retries __read_only;
+int grsec_enable_tpe_all __read_only;
+int grsec_enable_tpe_invert __read_only;
+int grsec_enable_socket_all __read_only;
+kgid_t grsec_socket_all_gid __read_only;
+int grsec_enable_socket_client __read_only;
+kgid_t grsec_socket_client_gid __read_only;
+int grsec_enable_socket_server __read_only;
+kgid_t grsec_socket_server_gid __read_only;
+int grsec_resource_logging __read_only;
+int grsec_disable_privio __read_only;
+int grsec_enable_log_rwxmaps __read_only;
+int grsec_enable_harden_tty __read_only;
+int grsec_lock __read_only;
+
+DEFINE_SPINLOCK(grsec_alert_lock);
+unsigned long grsec_alert_wtime = 0;
+unsigned long grsec_alert_fyet = 0;
+
+DEFINE_SPINLOCK(grsec_audit_lock);
+
+DEFINE_RWLOCK(grsec_exec_file_lock);
+
+char *gr_shared_page[4];
+
+char *gr_alert_log_fmt;
+char *gr_audit_log_fmt;
+char *gr_alert_log_buf;
+char *gr_audit_log_buf;
+
+extern struct gr_arg *gr_usermode;
+extern unsigned char *gr_system_salt;
+extern unsigned char *gr_system_sum;
+
+void __init
+grsecurity_init(void)
+{
+	int j;
+	/* create the per-cpu shared pages */
+
+#ifdef CONFIG_X86
+	memset((char *)(0x41a + PAGE_OFFSET), 0, 36);
+#endif
+
+	for (j = 0; j < 4; j++) {
+		gr_shared_page[j] = (char *)__alloc_percpu(PAGE_SIZE, __alignof__(unsigned long long));
+		if (gr_shared_page[j] == NULL) {
+			panic("Unable to allocate grsecurity shared page");
+			return;
+		}
+	}
+
+	/* allocate log buffers */
+	gr_alert_log_fmt = kmalloc(512, GFP_KERNEL);
+	if (!gr_alert_log_fmt) {
+		panic("Unable to allocate grsecurity alert log format buffer");
+		return;
+	}
+	gr_audit_log_fmt = kmalloc(512, GFP_KERNEL);
+	if (!gr_audit_log_fmt) {
+		panic("Unable to allocate grsecurity audit log format buffer");
+		return;
+	}
+	gr_alert_log_buf = (char *) get_zeroed_page(GFP_KERNEL);
+	if (!gr_alert_log_buf) {
+		panic("Unable to allocate grsecurity alert log buffer");
+		return;
+	}
+	gr_audit_log_buf = (char *) get_zeroed_page(GFP_KERNEL);
+	if (!gr_audit_log_buf) {
+		panic("Unable to allocate grsecurity audit log buffer");
+		return;
+	}
+
+	/* allocate memory for authentication structure */
+	gr_usermode = kmalloc(sizeof(struct gr_arg), GFP_KERNEL);
+	gr_system_salt = kmalloc(GR_SALT_LEN, GFP_KERNEL);
+	gr_system_sum = kmalloc(GR_SHA_LEN, GFP_KERNEL);
+
+	if (!gr_usermode || !gr_system_salt || !gr_system_sum) {
+		panic("Unable to allocate grsecurity authentication structure");
+		return;
+	}
+
+#ifdef CONFIG_GRKERNSEC_IO
+#if !defined(CONFIG_GRKERNSEC_SYSCTL_DISTRO)
+	grsec_disable_privio = 1;
+#elif defined(CONFIG_GRKERNSEC_SYSCTL_ON)
+	grsec_disable_privio = 1;
+#else
+	grsec_disable_privio = 0;
+#endif
+#endif
+
+#ifdef CONFIG_GRKERNSEC_TPE_INVERT
+	/* for backward compatibility, tpe_invert always defaults to on if
+	   enabled in the kernel
+	*/
+	grsec_enable_tpe_invert = 1;
+#endif
+
+#if !defined(CONFIG_GRKERNSEC_SYSCTL) || defined(CONFIG_GRKERNSEC_SYSCTL_ON)
+#ifndef CONFIG_GRKERNSEC_SYSCTL
+	grsec_lock = 1;
+#endif
+
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+	grsec_enable_log_rwxmaps = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_GROUP
+	grsec_enable_group = 1;
+	grsec_audit_gid = KGIDT_INIT(CONFIG_GRKERNSEC_AUDIT_GID);
+#endif
+#ifdef CONFIG_GRKERNSEC_PTRACE_READEXEC
+	grsec_enable_ptrace_readexec = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_CHDIR
+	grsec_enable_chdir = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_HARDEN_PTRACE
+	grsec_enable_harden_ptrace = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_HARDEN_IPC
+	grsec_enable_harden_ipc = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_HARDEN_TTY
+	grsec_enable_harden_tty = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_MOUNT
+	grsec_enable_mount = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_LINK
+	grsec_enable_link = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_BRUTE
+	grsec_enable_brute = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_DMESG
+	grsec_enable_dmesg = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	grsec_enable_blackhole = 1;
+	grsec_lastack_retries = 4;
+#endif
+#ifdef CONFIG_GRKERNSEC_FIFO
+	grsec_enable_fifo = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_EXECLOG
+	grsec_enable_execlog = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_SETXID
+	grsec_enable_setxid = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_SIGNAL
+	grsec_enable_signal = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_FORKFAIL
+	grsec_enable_forkfail = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_TIME
+	grsec_enable_time = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_RESLOG
+	grsec_resource_logging = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_FINDTASK
+	grsec_enable_chroot_findtask = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_UNIX
+	grsec_enable_chroot_unix = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_MOUNT
+	grsec_enable_chroot_mount = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_FCHDIR
+	grsec_enable_chroot_fchdir = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_SHMAT
+	grsec_enable_chroot_shmat = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_PTRACE
+	grsec_enable_audit_ptrace = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_DOUBLE
+	grsec_enable_chroot_double = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_PIVOT
+	grsec_enable_chroot_pivot = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_CHDIR
+	grsec_enable_chroot_chdir = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_CHMOD
+	grsec_enable_chroot_chmod = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_MKNOD
+	grsec_enable_chroot_mknod = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_NICE
+	grsec_enable_chroot_nice = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_EXECLOG
+	grsec_enable_chroot_execlog = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_CAPS
+	grsec_enable_chroot_caps = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+	grsec_enable_chroot_rename = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_SYSCTL
+	grsec_enable_chroot_sysctl = 1;
+#endif
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	grsec_enable_symlinkown = 1;
+	grsec_symlinkown_gid = KGIDT_INIT(CONFIG_GRKERNSEC_SYMLINKOWN_GID);
+#endif
+#ifdef CONFIG_GRKERNSEC_TPE
+	grsec_enable_tpe = 1;
+	grsec_tpe_gid = KGIDT_INIT(CONFIG_GRKERNSEC_TPE_GID);
+#ifdef CONFIG_GRKERNSEC_TPE_ALL
+	grsec_enable_tpe_all = 1;
+#endif
+#endif
+#ifdef CONFIG_GRKERNSEC_SOCKET_ALL
+	grsec_enable_socket_all = 1;
+	grsec_socket_all_gid = KGIDT_INIT(CONFIG_GRKERNSEC_SOCKET_ALL_GID);
+#endif
+#ifdef CONFIG_GRKERNSEC_SOCKET_CLIENT
+	grsec_enable_socket_client = 1;
+	grsec_socket_client_gid = KGIDT_INIT(CONFIG_GRKERNSEC_SOCKET_CLIENT_GID);
+#endif
+#ifdef CONFIG_GRKERNSEC_SOCKET_SERVER
+	grsec_enable_socket_server = 1;
+	grsec_socket_server_gid = KGIDT_INIT(CONFIG_GRKERNSEC_SOCKET_SERVER_GID);
+#endif
+#endif
+#ifdef CONFIG_GRKERNSEC_DENYUSB_FORCE
+	grsec_deny_new_usb = 1;
+#endif
+
+	return;
+}
diff --git b/grsecurity/grsec_ipc.c b/grsecurity/grsec_ipc.c
new file mode 100644
index 000000000..6a8ed6905
--- /dev/null
+++ b/grsecurity/grsec_ipc.c
@@ -0,0 +1,48 @@
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/ipc.h>
+#include <linux/ipc_namespace.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+int
+gr_ipc_permitted(struct ipc_namespace *ns, struct kern_ipc_perm *ipcp, int requested_mode, int granted_mode)
+{
+#ifdef CONFIG_GRKERNSEC_HARDEN_IPC
+	int write;
+	int orig_granted_mode;
+	kuid_t euid;
+	kgid_t egid;
+
+	if (!grsec_enable_harden_ipc)
+		return 1;
+
+	euid = current_euid();
+	egid = current_egid();
+
+	write = requested_mode & 00002;
+	orig_granted_mode = ipcp->mode;
+
+	if (uid_eq(euid, ipcp->cuid) || uid_eq(euid, ipcp->uid))
+		orig_granted_mode >>= 6;
+	else {
+		/* if likely wrong permissions, lock to user */
+		if (orig_granted_mode & 0007)
+			orig_granted_mode = 0;
+		/* otherwise do a egid-only check */
+		else if (gid_eq(egid, ipcp->cgid) || gid_eq(egid, ipcp->gid))
+			orig_granted_mode >>= 3;
+		/* otherwise, no access */
+		else
+			orig_granted_mode = 0;
+	}
+	if (!(requested_mode & ~granted_mode & 0007) && (requested_mode & ~orig_granted_mode & 0007) &&
+	    !ns_capable_noaudit(ns->user_ns, CAP_IPC_OWNER)) {
+		gr_log_str_int(GR_DONT_AUDIT, GR_IPC_DENIED_MSG, write ? "write" : "read", GR_GLOBAL_UID(ipcp->cuid));
+		return 0;
+	}
+#endif
+	return 1;
+}
diff --git b/grsecurity/grsec_link.c b/grsecurity/grsec_link.c
new file mode 100644
index 000000000..84c44a03c
--- /dev/null
+++ b/grsecurity/grsec_link.c
@@ -0,0 +1,65 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/file.h>
+#include <linux/grinternal.h>
+
+int gr_get_symlinkown_enabled(void)
+{
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	if (grsec_enable_symlinkown && in_group_p(grsec_symlinkown_gid))
+		return 1;
+#endif
+	return 0;
+}
+
+int gr_handle_symlink_owner(const struct path *link, const struct inode *target)
+{
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	const struct inode *link_inode = d_backing_inode(link->dentry);
+
+	if (target && !uid_eq(link_inode->i_uid, target->i_uid)) {
+		gr_log_fs_int2(GR_DONT_AUDIT, GR_SYMLINKOWNER_MSG, link->dentry, link->mnt, GR_GLOBAL_UID(link_inode->i_uid), GR_GLOBAL_UID(target->i_uid));
+		return 1;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_follow_link(const struct dentry *dentry, const struct vfsmount *mnt)
+{
+#ifdef CONFIG_GRKERNSEC_LINK
+	struct inode *inode = d_backing_inode(dentry);
+	struct inode *parent = d_backing_inode(dentry->d_parent);
+	const struct cred *cred = current_cred();
+
+	if (grsec_enable_link && d_is_symlink(dentry) &&
+	    (parent->i_mode & S_ISVTX) && !uid_eq(parent->i_uid, inode->i_uid) &&
+	    (parent->i_mode & S_IWOTH) && !uid_eq(cred->fsuid, inode->i_uid)) {
+		gr_log_fs_int2(GR_DONT_AUDIT, GR_SYMLINK_MSG, dentry, mnt, GR_GLOBAL_UID(inode->i_uid), GR_GLOBAL_GID(inode->i_gid));
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_hardlink(const struct dentry *dentry,
+		   const struct vfsmount *mnt,
+		   const struct filename *to)
+{
+#ifdef CONFIG_GRKERNSEC_LINK
+	struct inode *inode = d_backing_inode(dentry);
+	const struct cred *cred = current_cred();
+
+	if (grsec_enable_link && !uid_eq(cred->fsuid, inode->i_uid) &&
+	    (!d_is_reg(dentry) || is_privileged_binary(dentry) || 
+	     (inode_permission(inode, MAY_READ | MAY_WRITE))) &&
+	    !capable(CAP_FOWNER) && gr_is_global_nonroot(cred->uid)) {
+		gr_log_fs_int2_str(GR_DONT_AUDIT, GR_HARDLINK_MSG, dentry, mnt, GR_GLOBAL_UID(inode->i_uid), GR_GLOBAL_GID(inode->i_gid), to->name);
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_log.c b/grsecurity/grsec_log.c
new file mode 100644
index 000000000..a24b3385d
--- /dev/null
+++ b/grsecurity/grsec_log.c
@@ -0,0 +1,340 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/tty.h>
+#include <linux/fs.h>
+#include <linux/mm.h>
+#include <linux/grinternal.h>
+
+#ifdef CONFIG_TREE_PREEMPT_RCU
+#define DISABLE_PREEMPT() preempt_disable()
+#define ENABLE_PREEMPT() preempt_enable()
+#else
+#define DISABLE_PREEMPT()
+#define ENABLE_PREEMPT()
+#endif
+
+#define BEGIN_LOCKS(x) \
+	DISABLE_PREEMPT(); \
+	rcu_read_lock(); \
+	read_lock(&tasklist_lock); \
+	read_lock(&grsec_exec_file_lock); \
+	if (x != GR_DO_AUDIT) \
+		spin_lock(&grsec_alert_lock); \
+	else \
+		spin_lock(&grsec_audit_lock)
+
+#define END_LOCKS(x) \
+	if (x != GR_DO_AUDIT) \
+		spin_unlock(&grsec_alert_lock); \
+	else \
+		spin_unlock(&grsec_audit_lock); \
+	read_unlock(&grsec_exec_file_lock); \
+	read_unlock(&tasklist_lock); \
+	rcu_read_unlock(); \
+	ENABLE_PREEMPT(); \
+	if (x == GR_DONT_AUDIT) \
+		gr_handle_alertkill(current)
+
+enum {
+	FLOODING,
+	NO_FLOODING
+};
+
+extern char *gr_alert_log_fmt;
+extern char *gr_audit_log_fmt;
+extern char *gr_alert_log_buf;
+extern char *gr_audit_log_buf;
+
+static int gr_log_start(int audit)
+{
+	char *loglevel = (audit == GR_DO_AUDIT) ? KERN_INFO : KERN_ALERT;
+	char *fmt = (audit == GR_DO_AUDIT) ? gr_audit_log_fmt : gr_alert_log_fmt;
+	char *buf = (audit == GR_DO_AUDIT) ? gr_audit_log_buf : gr_alert_log_buf;
+#if (CONFIG_GRKERNSEC_FLOODTIME > 0 && CONFIG_GRKERNSEC_FLOODBURST > 0)
+	unsigned long curr_secs = get_seconds();
+
+	if (audit == GR_DO_AUDIT)
+		goto set_fmt;
+
+	if (!grsec_alert_wtime || time_after(curr_secs, grsec_alert_wtime + CONFIG_GRKERNSEC_FLOODTIME)) {
+		grsec_alert_wtime = curr_secs;
+		grsec_alert_fyet = 0;
+	} else if (time_before_eq(curr_secs, grsec_alert_wtime + CONFIG_GRKERNSEC_FLOODTIME)
+		    && (grsec_alert_fyet < CONFIG_GRKERNSEC_FLOODBURST)) {
+		grsec_alert_fyet++;
+	} else if (grsec_alert_fyet == CONFIG_GRKERNSEC_FLOODBURST) {
+		grsec_alert_wtime = curr_secs;
+		grsec_alert_fyet++;
+		printk(KERN_ALERT "grsec: more alerts, logging disabled for %d seconds\n", CONFIG_GRKERNSEC_FLOODTIME);
+		return FLOODING;
+	}
+	else return FLOODING;
+
+set_fmt:
+#endif
+	memset(buf, 0, PAGE_SIZE);
+	if (current->signal->curr_ip && gr_acl_is_enabled()) {
+		sprintf(fmt, "%s%s", loglevel, "grsec: From %pI4: (%.64s:%c:%.950s) ");
+		snprintf(buf, PAGE_SIZE - 1, fmt, &current->signal->curr_ip, current->role->rolename, gr_roletype_to_char(), current->acl->filename);
+	} else if (current->signal->curr_ip) {
+		sprintf(fmt, "%s%s", loglevel, "grsec: From %pI4: ");
+		snprintf(buf, PAGE_SIZE - 1, fmt, &current->signal->curr_ip);
+	} else if (gr_acl_is_enabled()) {
+		sprintf(fmt, "%s%s", loglevel, "grsec: (%.64s:%c:%.950s) ");
+		snprintf(buf, PAGE_SIZE - 1, fmt, current->role->rolename, gr_roletype_to_char(), current->acl->filename);
+	} else {
+		sprintf(fmt, "%s%s", loglevel, "grsec: ");
+		strcpy(buf, fmt);
+	}
+
+	return NO_FLOODING;
+}
+
+static void gr_log_middle(int audit, const char *msg, va_list ap)
+	__attribute__ ((format (printf, 2, 0)));
+
+static void gr_log_middle(int audit, const char *msg, va_list ap)
+{
+	char *buf = (audit == GR_DO_AUDIT) ? gr_audit_log_buf : gr_alert_log_buf;
+	unsigned int len = strlen(buf);
+
+	vsnprintf(buf + len, PAGE_SIZE - len - 1, msg, ap);
+
+	return;
+}
+
+static void gr_log_middle_varargs(int audit, const char *msg, ...)
+	__attribute__ ((format (printf, 2, 3)));
+
+static void gr_log_middle_varargs(int audit, const char *msg, ...)
+{
+	char *buf = (audit == GR_DO_AUDIT) ? gr_audit_log_buf : gr_alert_log_buf;
+	unsigned int len = strlen(buf);
+	va_list ap;
+
+	va_start(ap, msg);
+	vsnprintf(buf + len, PAGE_SIZE - len - 1, msg, ap);
+	va_end(ap);
+
+	return;
+}
+
+static void gr_log_end(int audit, int append_default)
+{
+	char *buf = (audit == GR_DO_AUDIT) ? gr_audit_log_buf : gr_alert_log_buf;
+	if (append_default) {
+		struct task_struct *task = current;
+		struct task_struct *parent = task->real_parent;
+		const struct cred *cred = __task_cred(task);
+		const struct cred *pcred = __task_cred(parent);
+		unsigned int len = strlen(buf);
+
+		snprintf(buf + len, PAGE_SIZE - len - 1, DEFAULTSECMSG, gr_task_fullpath(task), task->comm, task_pid_nr(task), GR_GLOBAL_UID(cred->uid), GR_GLOBAL_UID(cred->euid), GR_GLOBAL_GID(cred->gid), GR_GLOBAL_GID(cred->egid), gr_parent_task_fullpath(task), parent->comm, task_pid_nr(task->real_parent), GR_GLOBAL_UID(pcred->uid), GR_GLOBAL_UID(pcred->euid), GR_GLOBAL_GID(pcred->gid), GR_GLOBAL_GID(pcred->egid));
+	}
+
+	printk("%s\n", buf);
+
+	return;
+}
+
+void gr_log_varargs(int audit, const char *msg, int argtypes, ...)
+{
+	int logtype;
+	char *result = (audit == GR_DO_AUDIT) ? "successful" : "denied";
+	char *str1 = NULL, *str2 = NULL, *str3 = NULL;
+	void *voidptr = NULL;
+	int num1 = 0, num2 = 0;
+	unsigned long ulong1 = 0, ulong2 = 0;
+	struct dentry *dentry = NULL;
+	struct vfsmount *mnt = NULL;
+	struct file *file = NULL;
+	struct task_struct *task = NULL;
+	struct vm_area_struct *vma = NULL;
+	const struct cred *cred, *pcred;
+	va_list ap;
+
+	BEGIN_LOCKS(audit);
+	logtype = gr_log_start(audit);
+	if (logtype == FLOODING) {
+		END_LOCKS(audit);
+		return;
+	}
+	va_start(ap, argtypes);
+	switch (argtypes) {
+	case GR_TTYSNIFF:
+		task = va_arg(ap, struct task_struct *);
+		gr_log_middle_varargs(audit, msg, &task->signal->curr_ip, gr_task_fullpath0(task), task->comm, task_pid_nr(task), gr_parent_task_fullpath0(task), task->real_parent->comm, task_pid_nr(task->real_parent));
+		break;
+	case GR_SYSCTL_HIDDEN:
+		str1 = va_arg(ap, char *);
+		gr_log_middle_varargs(audit, msg, result, str1);
+		break;
+	case GR_RBAC:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		gr_log_middle_varargs(audit, msg, result, gr_to_filename(dentry, mnt));
+		break;
+	case GR_RBAC_STR:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		str1 = va_arg(ap, char *);
+		gr_log_middle_varargs(audit, msg, result, gr_to_filename(dentry, mnt), str1);
+		break;
+	case GR_STR_RBAC:
+		str1 = va_arg(ap, char *);
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		gr_log_middle_varargs(audit, msg, result, str1, gr_to_filename(dentry, mnt));
+		break;
+	case GR_RBAC_MODE2:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		str1 = va_arg(ap, char *);
+		str2 = va_arg(ap, char *);
+		gr_log_middle_varargs(audit, msg, result, gr_to_filename(dentry, mnt), str1, str2);
+		break;
+	case GR_RBAC_MODE3:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		str1 = va_arg(ap, char *);
+		str2 = va_arg(ap, char *);
+		str3 = va_arg(ap, char *);
+		gr_log_middle_varargs(audit, msg, result, gr_to_filename(dentry, mnt), str1, str2, str3);
+		break;
+	case GR_FILENAME:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		gr_log_middle_varargs(audit, msg, gr_to_filename(dentry, mnt));
+		break;
+	case GR_STR_FILENAME:
+		str1 = va_arg(ap, char *);
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		gr_log_middle_varargs(audit, msg, str1, gr_to_filename(dentry, mnt));
+		break;
+	case GR_FILENAME_STR:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		str1 = va_arg(ap, char *);
+		gr_log_middle_varargs(audit, msg, gr_to_filename(dentry, mnt), str1);
+		break;
+	case GR_FILENAME_TWO_INT:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		num1 = va_arg(ap, int);
+		num2 = va_arg(ap, int);
+		gr_log_middle_varargs(audit, msg, gr_to_filename(dentry, mnt), num1, num2);
+		break;
+	case GR_FILENAME_TWO_INT_STR:
+		dentry = va_arg(ap, struct dentry *);
+		mnt = va_arg(ap, struct vfsmount *);
+		num1 = va_arg(ap, int);
+		num2 = va_arg(ap, int);
+		str1 = va_arg(ap, char *);
+		gr_log_middle_varargs(audit, msg, gr_to_filename(dentry, mnt), num1, num2, str1);
+		break;
+	case GR_TEXTREL:
+		str1 = va_arg(ap, char *);
+		file = va_arg(ap, struct file *);
+		ulong1 = va_arg(ap, unsigned long);
+		ulong2 = va_arg(ap, unsigned long);
+		gr_log_middle_varargs(audit, msg, str1, file ? gr_to_filename(file->f_path.dentry, file->f_path.mnt) : "<anonymous mapping>", ulong1, ulong2);
+		break;
+	case GR_PTRACE:
+		task = va_arg(ap, struct task_struct *);
+		gr_log_middle_varargs(audit, msg, task->exec_file ? gr_to_filename(task->exec_file->f_path.dentry, task->exec_file->f_path.mnt) : "(none)", task->comm, task_pid_nr(task));
+		break;
+	case GR_RESOURCE:
+		task = va_arg(ap, struct task_struct *);
+		cred = __task_cred(task);
+		pcred = __task_cred(task->real_parent);
+		ulong1 = va_arg(ap, unsigned long);
+		str1 = va_arg(ap, char *);
+		ulong2 = va_arg(ap, unsigned long);
+		gr_log_middle_varargs(audit, msg, ulong1, str1, ulong2, gr_task_fullpath(task), task->comm, task_pid_nr(task), GR_GLOBAL_UID(cred->uid), GR_GLOBAL_UID(cred->euid), GR_GLOBAL_GID(cred->gid), GR_GLOBAL_GID(cred->egid), gr_parent_task_fullpath(task), task->real_parent->comm, task_pid_nr(task->real_parent), GR_GLOBAL_UID(pcred->uid), GR_GLOBAL_UID(pcred->euid), GR_GLOBAL_GID(pcred->gid), GR_GLOBAL_GID(pcred->egid));
+		break;
+	case GR_CAP:
+		task = va_arg(ap, struct task_struct *);
+		cred = __task_cred(task);
+		pcred = __task_cred(task->real_parent);
+		str1 = va_arg(ap, char *);
+		gr_log_middle_varargs(audit, msg, str1, gr_task_fullpath(task), task->comm, task_pid_nr(task), GR_GLOBAL_UID(cred->uid), GR_GLOBAL_UID(cred->euid), GR_GLOBAL_GID(cred->gid), GR_GLOBAL_GID(cred->egid), gr_parent_task_fullpath(task), task->real_parent->comm, task_pid_nr(task->real_parent), GR_GLOBAL_UID(pcred->uid), GR_GLOBAL_UID(pcred->euid), GR_GLOBAL_GID(pcred->gid), GR_GLOBAL_GID(pcred->egid));
+		break;
+	case GR_SIG:
+		str1 = va_arg(ap, char *);
+		voidptr = va_arg(ap, void *);
+		gr_log_middle_varargs(audit, msg, str1, voidptr);
+		break;
+	case GR_SIG2:
+		task = va_arg(ap, struct task_struct *);
+		cred = __task_cred(task);
+		pcred = __task_cred(task->real_parent);
+		num1 = va_arg(ap, int);
+		gr_log_middle_varargs(audit, msg, num1, gr_task_fullpath0(task), task->comm, task_pid_nr(task), GR_GLOBAL_UID(cred->uid), GR_GLOBAL_UID(cred->euid), GR_GLOBAL_GID(cred->gid), GR_GLOBAL_GID(cred->egid), gr_parent_task_fullpath0(task), task->real_parent->comm, task_pid_nr(task->real_parent), GR_GLOBAL_UID(pcred->uid), GR_GLOBAL_UID(pcred->euid), GR_GLOBAL_GID(pcred->gid), GR_GLOBAL_GID(pcred->egid));
+		break;
+	case GR_CRASH1:
+		task = va_arg(ap, struct task_struct *);
+		cred = __task_cred(task);
+		pcred = __task_cred(task->real_parent);
+		ulong1 = va_arg(ap, unsigned long);
+		gr_log_middle_varargs(audit, msg, gr_task_fullpath(task), task->comm, task_pid_nr(task), GR_GLOBAL_UID(cred->uid), GR_GLOBAL_UID(cred->euid), GR_GLOBAL_GID(cred->gid), GR_GLOBAL_GID(cred->egid), gr_parent_task_fullpath(task), task->real_parent->comm, task_pid_nr(task->real_parent), GR_GLOBAL_UID(pcred->uid), GR_GLOBAL_UID(pcred->euid), GR_GLOBAL_GID(pcred->gid), GR_GLOBAL_GID(pcred->egid), GR_GLOBAL_UID(cred->uid), ulong1);
+		break;
+	case GR_CRASH2:
+		task = va_arg(ap, struct task_struct *);
+		cred = __task_cred(task);
+		pcred = __task_cred(task->real_parent);
+		ulong1 = va_arg(ap, unsigned long);
+		gr_log_middle_varargs(audit, msg, gr_task_fullpath(task), task->comm, task_pid_nr(task), GR_GLOBAL_UID(cred->uid), GR_GLOBAL_UID(cred->euid), GR_GLOBAL_GID(cred->gid), GR_GLOBAL_GID(cred->egid), gr_parent_task_fullpath(task), task->real_parent->comm, task_pid_nr(task->real_parent), GR_GLOBAL_UID(pcred->uid), GR_GLOBAL_UID(pcred->euid), GR_GLOBAL_GID(pcred->gid), GR_GLOBAL_GID(pcred->egid), ulong1);
+		break;
+	case GR_RWXMAP:
+		file = va_arg(ap, struct file *);
+		gr_log_middle_varargs(audit, msg, file ? gr_to_filename(file->f_path.dentry, file->f_path.mnt) : "<anonymous mapping>");
+		break;
+	case GR_RWXMAPVMA:
+		vma = va_arg(ap, struct vm_area_struct *);
+		if (vma->vm_file)
+			str1 = gr_to_filename(vma->vm_file->f_path.dentry, vma->vm_file->f_path.mnt);
+		else if (vma->vm_flags & (VM_GROWSDOWN | VM_GROWSUP))
+			str1 = "<stack>";
+		else if (vma->vm_start <= current->mm->brk &&
+			 vma->vm_end >= current->mm->start_brk)
+			str1 = "<heap>";
+		else
+			str1 = "<anonymous mapping>";
+		gr_log_middle_varargs(audit, msg, str1);
+		break;
+	case GR_PSACCT:
+		{
+			unsigned int wday, cday;
+			__u8 whr, chr;
+			__u8 wmin, cmin;
+			__u8 wsec, csec;
+
+			task = va_arg(ap, struct task_struct *);
+			wday = va_arg(ap, unsigned int);
+			cday = va_arg(ap, unsigned int);
+			whr = va_arg(ap, int);
+			chr = va_arg(ap, int);
+			wmin = va_arg(ap, int);
+			cmin = va_arg(ap, int);
+			wsec = va_arg(ap, int);
+			csec = va_arg(ap, int);
+			ulong1 = va_arg(ap, unsigned long);
+			cred = __task_cred(task);
+			pcred = __task_cred(task->real_parent);
+
+			gr_log_middle_varargs(audit, msg, gr_task_fullpath(task), task->comm, task_pid_nr(task), &task->signal->curr_ip, tty_name(task->signal->tty), GR_GLOBAL_UID(cred->uid), GR_GLOBAL_UID(cred->euid), GR_GLOBAL_GID(cred->gid), GR_GLOBAL_GID(cred->egid), wday, whr, wmin, wsec, cday, chr, cmin, csec, (task->flags & PF_SIGNALED) ? "killed by signal" : "exited", ulong1, gr_parent_task_fullpath(task), task->real_parent->comm, task_pid_nr(task->real_parent), &task->real_parent->signal->curr_ip, tty_name(task->real_parent->signal->tty), GR_GLOBAL_UID(pcred->uid), GR_GLOBAL_UID(pcred->euid), GR_GLOBAL_GID(pcred->gid), GR_GLOBAL_GID(pcred->egid));
+		}
+		break;
+	default:
+		gr_log_middle(audit, msg, ap);
+	}
+	va_end(ap);
+	// these don't need DEFAULTSECARGS printed on the end
+	if (argtypes == GR_CRASH1 || argtypes == GR_CRASH2)
+		gr_log_end(audit, 0);
+	else
+		gr_log_end(audit, 1);
+	END_LOCKS(audit);
+}
diff --git b/grsecurity/grsec_mem.c b/grsecurity/grsec_mem.c
new file mode 100644
index 000000000..0e39d8c70
--- /dev/null
+++ b/grsecurity/grsec_mem.c
@@ -0,0 +1,48 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/mman.h>
+#include <linux/module.h>
+#include <linux/grinternal.h>
+
+void gr_handle_msr_write(void)
+{
+	gr_log_noargs(GR_DONT_AUDIT, GR_MSRWRITE_MSG);
+	return;
+}
+EXPORT_SYMBOL_GPL(gr_handle_msr_write);
+
+void
+gr_handle_ioperm(void)
+{
+	gr_log_noargs(GR_DONT_AUDIT, GR_IOPERM_MSG);
+	return;
+}
+
+void
+gr_handle_iopl(void)
+{
+	gr_log_noargs(GR_DONT_AUDIT, GR_IOPL_MSG);
+	return;
+}
+
+void
+gr_handle_mem_readwrite(u64 from, u64 to)
+{
+	gr_log_two_u64(GR_DONT_AUDIT, GR_MEM_READWRITE_MSG, from, to);
+	return;
+}
+
+void
+gr_handle_vm86(void)
+{
+	gr_log_noargs(GR_DONT_AUDIT, GR_VM86_MSG);
+	return;
+}
+
+void
+gr_log_badprocpid(const char *entry)
+{
+	gr_log_str(GR_DONT_AUDIT, GR_BADPROCPID_MSG, entry);
+	return;
+}
diff --git b/grsecurity/grsec_mount.c b/grsecurity/grsec_mount.c
new file mode 100644
index 000000000..fe02bf495
--- /dev/null
+++ b/grsecurity/grsec_mount.c
@@ -0,0 +1,65 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/mount.h>
+#include <linux/major.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+void
+gr_log_remount(const char *devname, const int retval)
+{
+#ifdef CONFIG_GRKERNSEC_AUDIT_MOUNT
+	if (grsec_enable_mount && (retval >= 0))
+		gr_log_str(GR_DO_AUDIT, GR_REMOUNT_AUDIT_MSG, devname ? devname : "none");
+#endif
+	return;
+}
+
+void
+gr_log_unmount(const char *devname, const int retval)
+{
+#ifdef CONFIG_GRKERNSEC_AUDIT_MOUNT
+	if (grsec_enable_mount && (retval >= 0))
+		gr_log_str(GR_DO_AUDIT, GR_UNMOUNT_AUDIT_MSG, devname ? devname : "none");
+#endif
+	return;
+}
+
+void
+gr_log_mount(const char *from, struct path *to, const int retval)
+{
+#ifdef CONFIG_GRKERNSEC_AUDIT_MOUNT
+	if (grsec_enable_mount && (retval >= 0))
+		gr_log_str_fs(GR_DO_AUDIT, GR_MOUNT_AUDIT_MSG, from ? from : "none", to->dentry, to->mnt);
+#endif
+	return;
+}
+
+int
+gr_handle_rofs_mount(struct dentry *dentry, struct vfsmount *mnt, int mnt_flags)
+{
+#ifdef CONFIG_GRKERNSEC_ROFS
+	if (grsec_enable_rofs && !(mnt_flags & MNT_READONLY)) {
+		gr_log_fs_generic(GR_DO_AUDIT, GR_ROFS_MOUNT_MSG, dentry, mnt);
+		return -EPERM;
+	} else
+		return 0;
+#endif
+	return 0;
+}
+
+int
+gr_handle_rofs_blockwrite(struct dentry *dentry, struct vfsmount *mnt, int acc_mode)
+{
+#ifdef CONFIG_GRKERNSEC_ROFS
+	struct inode *inode = d_backing_inode(dentry);
+
+	if (grsec_enable_rofs && (acc_mode & MAY_WRITE) &&
+	    inode && (S_ISBLK(inode->i_mode) || (S_ISCHR(inode->i_mode) && imajor(inode) == RAW_MAJOR))) {
+		gr_log_fs_generic(GR_DO_AUDIT, GR_ROFS_BLOCKWRITE_MSG, dentry, mnt);
+		return -EPERM;
+	} else
+		return 0;
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_pax.c b/grsecurity/grsec_pax.c
new file mode 100644
index 000000000..2ad7b964a
--- /dev/null
+++ b/grsecurity/grsec_pax.c
@@ -0,0 +1,47 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/file.h>
+#include <linux/grinternal.h>
+#include <linux/grsecurity.h>
+
+void
+gr_log_textrel(struct vm_area_struct * vma, bool is_textrel_rw)
+{
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+	if (grsec_enable_log_rwxmaps)
+		gr_log_textrel_ulong_ulong(GR_DONT_AUDIT, GR_TEXTREL_AUDIT_MSG,
+			is_textrel_rw ? "executable to writable" : "writable to executable",
+			vma->vm_file, vma->vm_start, vma->vm_pgoff);
+#endif
+	return;
+}
+
+void gr_log_ptgnustack(struct file *file)
+{
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+	if (grsec_enable_log_rwxmaps)
+		gr_log_rwxmap(GR_DONT_AUDIT, GR_PTGNUSTACK_MSG, file);
+#endif
+	return;
+}
+
+void
+gr_log_rwxmmap(struct file *file)
+{
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+	if (grsec_enable_log_rwxmaps)
+		gr_log_rwxmap(GR_DONT_AUDIT, GR_RWXMMAP_MSG, file);
+#endif
+	return;
+}
+
+void
+gr_log_rwxmprotect(struct vm_area_struct *vma)
+{
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+	if (grsec_enable_log_rwxmaps)
+		gr_log_rwxmap_vma(GR_DONT_AUDIT, GR_RWXMPROTECT_MSG, vma);
+#endif
+	return;
+}
diff --git b/grsecurity/grsec_proc.c b/grsecurity/grsec_proc.c
new file mode 100644
index 000000000..2005a3a32
--- /dev/null
+++ b/grsecurity/grsec_proc.c
@@ -0,0 +1,20 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+int gr_proc_is_restricted(void)
+{
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	const struct cred *cred = current_cred();
+#endif
+
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	if (!uid_eq(cred->fsuid, GLOBAL_ROOT_UID))
+		return -EACCES;
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	if (!uid_eq(cred->fsuid, GLOBAL_ROOT_UID) && !in_group_p(grsec_proc_gid))
+		return -EACCES;
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_ptrace.c b/grsecurity/grsec_ptrace.c
new file mode 100644
index 000000000..304c5180b
--- /dev/null
+++ b/grsecurity/grsec_ptrace.c
@@ -0,0 +1,30 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/grinternal.h>
+#include <linux/security.h>
+
+void
+gr_audit_ptrace(struct task_struct *task)
+{
+#ifdef CONFIG_GRKERNSEC_AUDIT_PTRACE
+	if (grsec_enable_audit_ptrace)
+		gr_log_ptrace(GR_DO_AUDIT, GR_PTRACE_AUDIT_MSG, task);
+#endif
+	return;
+}
+
+int
+gr_ptrace_readexec(struct file *file, int unsafe_flags)
+{
+#ifdef CONFIG_GRKERNSEC_PTRACE_READEXEC
+	const struct dentry *dentry = file->f_path.dentry;
+	const struct vfsmount *mnt = file->f_path.mnt;
+
+	if (grsec_enable_ptrace_readexec && (unsafe_flags & LSM_UNSAFE_PTRACE) && 
+	    (inode_permission(d_backing_inode(dentry), MAY_READ) || !gr_acl_handle_open(dentry, mnt, MAY_READ))) {
+		gr_log_fs_generic(GR_DONT_AUDIT, GR_PTRACE_READEXEC_MSG, dentry, mnt);
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_sig.c b/grsecurity/grsec_sig.c
new file mode 100644
index 000000000..f072c9d42
--- /dev/null
+++ b/grsecurity/grsec_sig.c
@@ -0,0 +1,248 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/fs.h>
+#include <linux/delay.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+#include <linux/hardirq.h>
+#include <asm/pgtable.h>
+
+char *signames[] = {
+	[SIGSEGV] = "Segmentation fault",
+	[SIGILL] = "Illegal instruction",
+	[SIGABRT] = "Abort",
+	[SIGBUS] = "Invalid alignment/Bus error"
+};
+
+void
+gr_log_signal(const int sig, const void *addr, const struct task_struct *t)
+{
+#ifdef CONFIG_GRKERNSEC_SIGNAL
+	if (grsec_enable_signal && ((sig == SIGSEGV) || (sig == SIGILL) ||
+				    (sig == SIGABRT) || (sig == SIGBUS))) {
+		if (task_pid_nr(t) == task_pid_nr(current)) {
+			gr_log_sig_addr(GR_DONT_AUDIT_GOOD, GR_UNISIGLOG_MSG, signames[sig], addr);
+		} else {
+			gr_log_sig_task(GR_DONT_AUDIT_GOOD, GR_DUALSIGLOG_MSG, t, sig);
+		}
+	}
+#endif
+	return;
+}
+
+int
+gr_handle_signal(const struct task_struct *p, const int sig)
+{
+#ifdef CONFIG_GRKERNSEC
+	/* ignore the 0 signal for protected task checks */
+	if (task_pid_nr(current) > 1 && sig && gr_check_protected_task(p)) {
+		gr_log_sig_task(GR_DONT_AUDIT, GR_SIG_ACL_MSG, p, sig);
+		return -EPERM;
+	} else if (gr_pid_is_chrooted((struct task_struct *)p)) {
+		return -EPERM;
+	}
+#endif
+	return 0;
+}
+
+#ifdef CONFIG_GRKERNSEC
+extern int specific_send_sig_info(int sig, struct siginfo *info, struct task_struct *t);
+
+int gr_fake_force_sig(int sig, struct task_struct *t)
+{
+	unsigned long int flags;
+	int ret, blocked, ignored;
+	struct k_sigaction *action;
+
+	spin_lock_irqsave(&t->sighand->siglock, flags);
+	action = &t->sighand->action[sig-1];
+	ignored = action->sa.sa_handler == SIG_IGN;
+	blocked = sigismember(&t->blocked, sig);
+	if (blocked || ignored) {
+		action->sa.sa_handler = SIG_DFL;
+		if (blocked) {
+			sigdelset(&t->blocked, sig);
+			recalc_sigpending_and_wake(t);
+		}
+	}
+	if (action->sa.sa_handler == SIG_DFL)
+		t->signal->flags &= ~SIGNAL_UNKILLABLE;
+	ret = specific_send_sig_info(sig, SEND_SIG_PRIV, t);
+
+	spin_unlock_irqrestore(&t->sighand->siglock, flags);
+
+	return ret;
+}
+#endif
+
+#define GR_USER_BAN_TIME (15 * 60)
+#define GR_DAEMON_BRUTE_TIME (30 * 60)
+
+void gr_handle_brute_attach(int dumpable)
+{
+#ifdef CONFIG_GRKERNSEC_BRUTE
+	struct task_struct *p = current;
+	kuid_t uid = GLOBAL_ROOT_UID;
+	int is_priv = 0;
+	int daemon = 0;
+
+	if (!grsec_enable_brute)
+		return;
+
+	if (is_privileged_binary(p->mm->exe_file->f_path.dentry))
+		is_priv = 1;
+
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+	read_lock(&grsec_exec_file_lock);
+	if (!is_priv && p->real_parent && gr_is_same_file(p->real_parent->exec_file, p->exec_file)) {
+		p->real_parent->brute_expires = get_seconds() + GR_DAEMON_BRUTE_TIME;
+		p->real_parent->brute = 1;
+		daemon = 1;
+	} else {
+		const struct cred *cred = __task_cred(p), *cred2;
+		struct task_struct *tsk, *tsk2;
+
+		if (dumpable != SUID_DUMP_USER && gr_is_global_nonroot(cred->uid)) {
+			struct user_struct *user;
+
+			uid = cred->uid;
+
+			/* this is put upon execution past expiration */
+			user = find_user(uid);
+			if (user == NULL)
+				goto unlock;
+			user->sugid_banned = 1;
+			user->sugid_ban_expires = get_seconds() + GR_USER_BAN_TIME;
+			if (user->sugid_ban_expires == ~0UL)
+				user->sugid_ban_expires--;
+
+			/* only kill other threads of the same binary, from the same user */
+			do_each_thread(tsk2, tsk) {
+				cred2 = __task_cred(tsk);
+				if (tsk != p && uid_eq(cred2->uid, uid) && gr_is_same_file(tsk->exec_file, p->exec_file))
+					gr_fake_force_sig(SIGKILL, tsk);
+			} while_each_thread(tsk2, tsk);
+		}
+	}
+unlock:
+	read_unlock(&grsec_exec_file_lock);
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+
+	if (gr_is_global_nonroot(uid))
+		gr_log_fs_int2(GR_DONT_AUDIT, GR_BRUTE_SUID_MSG, p->exec_file->f_path.dentry, p->exec_file->f_path.mnt, GR_GLOBAL_UID(uid), GR_USER_BAN_TIME / 60);
+	else if (daemon)
+		gr_log_noargs(GR_DONT_AUDIT, GR_BRUTE_DAEMON_MSG);
+
+#endif
+	return;
+}
+
+void gr_handle_brute_check(void)
+{
+#ifdef CONFIG_GRKERNSEC_BRUTE
+	struct task_struct *p = current;
+
+	if (unlikely(p->brute)) {
+		if (!grsec_enable_brute)
+			p->brute = 0;
+		else if (time_before(get_seconds(), p->brute_expires))
+			msleep(30 * 1000);
+	}
+#endif
+	return;
+}
+
+void gr_handle_kernel_exploit(void)
+{
+#ifdef CONFIG_GRKERNSEC_KERN_LOCKOUT
+	static unsigned int num_banned_users __read_only;
+	const struct cred *cred;
+	struct task_struct *tsk, *tsk2;
+	struct user_struct *user;
+	kuid_t uid;
+
+	if (in_irq() || in_serving_softirq() || in_nmi())
+		panic("grsec: halting the system due to suspicious kernel crash caused in interrupt context");
+
+	uid = current_uid();
+
+	if (gr_is_global_root(uid))
+		panic("grsec: halting the system due to suspicious kernel crash caused by root");
+	else {
+		pax_open_kernel();
+		num_banned_users++;
+		pax_close_kernel();
+		if (num_banned_users > 8)
+			panic("grsec: halting the system due to suspicious kernel crash caused by a large number of different users");
+
+		/* kill all the processes of this user, hold a reference
+		   to their creds struct, and prevent them from creating
+		   another process until system reset
+		*/
+		printk(KERN_ALERT "grsec: banning user with uid %u until system restart for suspicious kernel crash\n",
+			GR_GLOBAL_UID(uid));
+		/* we intentionally leak this ref */
+		user = get_uid(current->cred->user);
+		if (user)
+			user->kernel_banned = 1;
+
+		/* kill all processes of this user */
+		read_lock(&tasklist_lock);
+		do_each_thread(tsk2, tsk) {
+			cred = __task_cred(tsk);
+			if (uid_eq(cred->uid, uid))
+				gr_fake_force_sig(SIGKILL, tsk);
+		} while_each_thread(tsk2, tsk);
+		read_unlock(&tasklist_lock); 
+	}
+#endif
+}
+
+#ifdef CONFIG_GRKERNSEC_BRUTE
+static bool sugid_ban_expired(struct user_struct *user)
+{
+	if (user->sugid_ban_expires != ~0UL && time_after_eq(get_seconds(), user->sugid_ban_expires)) {
+		user->sugid_banned = 0;
+		user->sugid_ban_expires = 0;
+		free_uid(user);
+		return true;
+	}
+
+	return false;
+}
+#endif
+
+int gr_process_kernel_exec_ban(void)
+{
+#ifdef CONFIG_GRKERNSEC_KERN_LOCKOUT
+	if (unlikely(current->cred->user->kernel_banned))
+		return -EPERM;
+#endif
+	return 0;
+}
+
+int gr_process_kernel_setuid_ban(struct user_struct *user)
+{
+#ifdef CONFIG_GRKERNSEC_KERN_LOCKOUT
+	if (unlikely(user->kernel_banned))
+		gr_fake_force_sig(SIGKILL, current);
+#endif
+	return 0;
+}
+
+int gr_process_sugid_exec_ban(const struct linux_binprm *bprm)
+{
+#ifdef CONFIG_GRKERNSEC_BRUTE
+	struct user_struct *user = current->cred->user;
+	if (unlikely(user->sugid_banned)) {
+		if (sugid_ban_expired(user))
+			return 0;
+		/* disallow execution of suid/sgid binaries only */
+		else if (is_privileged_binary(bprm->file->f_path.dentry))
+			return -EPERM;
+	}
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_sock.c b/grsecurity/grsec_sock.c
new file mode 100644
index 000000000..3cdd9461f
--- /dev/null
+++ b/grsecurity/grsec_sock.c
@@ -0,0 +1,244 @@
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/net.h>
+#include <linux/in.h>
+#include <linux/ip.h>
+#include <net/sock.h>
+#include <net/inet_sock.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+#include <linux/gracl.h>
+
+extern int gr_search_udp_recvmsg(struct sock *sk, const struct sk_buff *skb);
+extern int gr_search_udp_sendmsg(struct sock *sk, struct sockaddr_in *addr);
+
+EXPORT_SYMBOL_GPL(gr_search_udp_recvmsg);
+EXPORT_SYMBOL_GPL(gr_search_udp_sendmsg);
+
+#ifdef CONFIG_UNIX_MODULE
+EXPORT_SYMBOL_GPL(gr_acl_handle_unix);
+EXPORT_SYMBOL_GPL(gr_acl_handle_mknod);
+EXPORT_SYMBOL_GPL(gr_handle_chroot_unix);
+EXPORT_SYMBOL_GPL(gr_handle_create);
+#endif
+
+#ifdef CONFIG_GRKERNSEC
+#define gr_conn_table_size 32749
+struct conn_table_entry {
+	struct conn_table_entry *next;
+	struct signal_struct *sig;
+};
+
+struct conn_table_entry *gr_conn_table[gr_conn_table_size];
+DEFINE_SPINLOCK(gr_conn_table_lock);
+
+extern const char * gr_socktype_to_name(unsigned char type);
+extern const char * gr_proto_to_name(unsigned char proto);
+extern const char * gr_sockfamily_to_name(unsigned char family);
+
+static int 
+conn_hash(__u32 saddr, __u32 daddr, __u16 sport, __u16 dport, unsigned int size)
+{
+	return ((daddr + saddr + (sport << 8) + (dport << 16)) % size);
+}
+
+static int
+conn_match(const struct signal_struct *sig, __u32 saddr, __u32 daddr, 
+	   __u16 sport, __u16 dport)
+{
+	if (unlikely(sig->gr_saddr == saddr && sig->gr_daddr == daddr &&
+		     sig->gr_sport == sport && sig->gr_dport == dport))
+		return 1;
+	else
+		return 0;
+}
+
+static void gr_add_to_task_ip_table_nolock(struct signal_struct *sig, struct conn_table_entry *newent)
+{
+	struct conn_table_entry **match;
+	unsigned int index;
+
+	index = conn_hash(sig->gr_saddr, sig->gr_daddr, 
+			  sig->gr_sport, sig->gr_dport, 
+			  gr_conn_table_size);
+
+	newent->sig = sig;
+	
+	match = &gr_conn_table[index];
+	newent->next = *match;
+	*match = newent;
+
+	return;
+}
+
+static void gr_del_task_from_ip_table_nolock(struct signal_struct *sig)
+{
+	struct conn_table_entry *match, *last = NULL;
+	unsigned int index;
+
+	index = conn_hash(sig->gr_saddr, sig->gr_daddr, 
+			  sig->gr_sport, sig->gr_dport, 
+			  gr_conn_table_size);
+
+	match = gr_conn_table[index];
+	while (match && !conn_match(match->sig, 
+		sig->gr_saddr, sig->gr_daddr, sig->gr_sport, 
+		sig->gr_dport)) {
+		last = match;
+		match = match->next;
+	}
+
+	if (match) {
+		if (last)
+			last->next = match->next;
+		else
+			gr_conn_table[index] = NULL;
+		kfree(match);
+	}
+
+	return;
+}
+
+static struct signal_struct * gr_lookup_task_ip_table(__u32 saddr, __u32 daddr,
+					     __u16 sport, __u16 dport)
+{
+	struct conn_table_entry *match;
+	unsigned int index;
+
+	index = conn_hash(saddr, daddr, sport, dport, gr_conn_table_size);
+
+	match = gr_conn_table[index];
+	while (match && !conn_match(match->sig, saddr, daddr, sport, dport))
+		match = match->next;
+
+	if (match)
+		return match->sig;
+	else
+		return NULL;
+}
+
+#endif
+
+void gr_update_task_in_ip_table(const struct inet_sock *inet)
+{
+#ifdef CONFIG_GRKERNSEC
+	struct signal_struct *sig = current->signal;
+	struct conn_table_entry *newent;
+
+	newent = kmalloc(sizeof(struct conn_table_entry), GFP_ATOMIC);
+	if (newent == NULL)
+		return;
+	/* no bh lock needed since we are called with bh disabled */
+	spin_lock(&gr_conn_table_lock);
+	gr_del_task_from_ip_table_nolock(sig);
+	sig->gr_saddr = inet->inet_rcv_saddr;
+	sig->gr_daddr = inet->inet_daddr;
+	sig->gr_sport = inet->inet_sport;
+	sig->gr_dport = inet->inet_dport;
+	gr_add_to_task_ip_table_nolock(sig, newent);
+	spin_unlock(&gr_conn_table_lock);
+#endif
+	return;
+}
+
+void gr_del_task_from_ip_table(struct task_struct *task)
+{
+#ifdef CONFIG_GRKERNSEC
+	spin_lock_bh(&gr_conn_table_lock);
+	gr_del_task_from_ip_table_nolock(task->signal);
+	spin_unlock_bh(&gr_conn_table_lock);
+#endif
+	return;
+}
+
+void
+gr_attach_curr_ip(const struct sock *sk)
+{
+#ifdef CONFIG_GRKERNSEC
+	struct signal_struct *p, *set;
+	const struct inet_sock *inet = inet_sk(sk);	
+
+	if (unlikely(sk->sk_protocol != IPPROTO_TCP))
+		return;
+
+	set = current->signal;
+
+	spin_lock_bh(&gr_conn_table_lock);
+	p = gr_lookup_task_ip_table(inet->inet_daddr, inet->inet_rcv_saddr,
+				    inet->inet_dport, inet->inet_sport);
+	if (unlikely(p != NULL)) {
+		set->curr_ip = p->curr_ip;
+		set->used_accept = 1;
+		gr_del_task_from_ip_table_nolock(p);
+		spin_unlock_bh(&gr_conn_table_lock);
+		return;
+	}
+	spin_unlock_bh(&gr_conn_table_lock);
+
+	set->curr_ip = inet->inet_daddr;
+	set->used_accept = 1;
+#endif
+	return;
+}
+
+int
+gr_handle_sock_all(const int family, const int type, const int protocol)
+{
+#ifdef CONFIG_GRKERNSEC_SOCKET_ALL
+	if (grsec_enable_socket_all && in_group_p(grsec_socket_all_gid) &&
+	    (family != AF_UNIX)) {
+		if (family == AF_INET)
+			gr_log_str3(GR_DONT_AUDIT, GR_SOCK_MSG, gr_sockfamily_to_name(family), gr_socktype_to_name(type), gr_proto_to_name(protocol));
+		else
+			gr_log_str2_int(GR_DONT_AUDIT, GR_SOCK_NOINET_MSG, gr_sockfamily_to_name(family), gr_socktype_to_name(type), protocol);
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_sock_server(const struct sockaddr *sck)
+{
+#ifdef CONFIG_GRKERNSEC_SOCKET_SERVER
+	if (grsec_enable_socket_server &&
+	    in_group_p(grsec_socket_server_gid) &&
+	    sck && (sck->sa_family != AF_UNIX) &&
+	    (sck->sa_family != AF_LOCAL)) {
+		gr_log_noargs(GR_DONT_AUDIT, GR_BIND_MSG);
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_sock_server_other(const struct sock *sck)
+{
+#ifdef CONFIG_GRKERNSEC_SOCKET_SERVER
+	if (grsec_enable_socket_server &&
+	    in_group_p(grsec_socket_server_gid) &&
+	    sck && (sck->sk_family != AF_UNIX) &&
+	    (sck->sk_family != AF_LOCAL)) {
+		gr_log_noargs(GR_DONT_AUDIT, GR_BIND_MSG);
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
+
+int
+gr_handle_sock_client(const struct sockaddr *sck)
+{
+#ifdef CONFIG_GRKERNSEC_SOCKET_CLIENT
+	if (grsec_enable_socket_client && in_group_p(grsec_socket_client_gid) &&
+	    sck && (sck->sa_family != AF_UNIX) &&
+	    (sck->sa_family != AF_LOCAL)) {
+		gr_log_noargs(GR_DONT_AUDIT, GR_CONNECT_MSG);
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_sysctl.c b/grsecurity/grsec_sysctl.c
new file mode 100644
index 000000000..4f673f8c2
--- /dev/null
+++ b/grsecurity/grsec_sysctl.c
@@ -0,0 +1,497 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/sysctl.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+
+int
+gr_handle_sysctl_mod(const char *dirname, const char *name, const int op)
+{
+#ifdef CONFIG_GRKERNSEC_SYSCTL
+	if (dirname == NULL || name == NULL)
+		return 0;
+	if (!strcmp(dirname, "grsecurity") && grsec_lock && (op & MAY_WRITE)) {
+		gr_log_str(GR_DONT_AUDIT, GR_SYSCTL_MSG, name);
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
+
+#if defined(CONFIG_GRKERNSEC_ROFS) || defined(CONFIG_GRKERNSEC_DENYUSB)
+static int __maybe_unused __read_only one = 1;
+#endif
+
+#if defined(CONFIG_GRKERNSEC_SYSCTL) || defined(CONFIG_GRKERNSEC_ROFS) || \
+	defined(CONFIG_GRKERNSEC_DENYUSB)
+struct ctl_table grsecurity_table[] = {
+#ifdef CONFIG_GRKERNSEC_SYSCTL
+#ifdef CONFIG_GRKERNSEC_SYSCTL_DISTRO
+#ifdef CONFIG_GRKERNSEC_IO
+	{
+		.procname	= "disable_priv_io",
+		.data		= &grsec_disable_privio,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#endif
+#ifdef CONFIG_GRKERNSEC_LINK
+	{
+		.procname	= "linking_restrictions",
+		.data		= &grsec_enable_link,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_SYMLINKOWN
+	{
+		.procname	= "enforce_symlinksifowner",
+		.data		= &grsec_enable_symlinkown,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+	{
+		.procname	= "symlinkown_gid",
+		.data		= &grsec_symlinkown_gid,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_BRUTE
+	{
+		.procname	= "deter_bruteforce",
+		.data		= &grsec_enable_brute,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_FIFO
+	{
+		.procname	= "fifo_restrictions",
+		.data		= &grsec_enable_fifo,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_PTRACE_READEXEC
+	{
+		.procname	= "ptrace_readexec",
+		.data		= &grsec_enable_ptrace_readexec,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_SETXID
+	{
+		.procname	= "consistent_setxid",
+		.data		= &grsec_enable_setxid,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	{
+		.procname	= "ip_blackhole",
+		.data		= &grsec_enable_blackhole,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+	{
+		.procname	= "lastack_retries",
+		.data		= &grsec_lastack_retries,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_EXECLOG
+	{
+		.procname	= "exec_logging",
+		.data		= &grsec_enable_execlog,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+	{
+		.procname	= "rwxmap_logging",
+		.data		= &grsec_enable_log_rwxmaps,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_SIGNAL
+	{
+		.procname	= "signal_logging",
+		.data		= &grsec_enable_signal,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_FORKFAIL
+	{
+		.procname	= "forkfail_logging",
+		.data		= &grsec_enable_forkfail,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_TIME
+	{
+		.procname	= "timechange_logging",
+		.data		= &grsec_enable_time,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_SHMAT
+	{
+		.procname	= "chroot_deny_shmat",
+		.data		= &grsec_enable_chroot_shmat,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_UNIX
+	{
+		.procname	= "chroot_deny_unix",
+		.data		= &grsec_enable_chroot_unix,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_MOUNT
+	{
+		.procname	= "chroot_deny_mount",
+		.data		= &grsec_enable_chroot_mount,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_FCHDIR
+	{
+		.procname	= "chroot_deny_fchdir",
+		.data		= &grsec_enable_chroot_fchdir,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_DOUBLE
+	{
+		.procname	= "chroot_deny_chroot",
+		.data		= &grsec_enable_chroot_double,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_PIVOT
+	{
+		.procname	= "chroot_deny_pivot",
+		.data		= &grsec_enable_chroot_pivot,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_CHDIR
+	{
+		.procname	= "chroot_enforce_chdir",
+		.data		= &grsec_enable_chroot_chdir,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_CHMOD
+	{
+		.procname	= "chroot_deny_chmod",
+		.data		= &grsec_enable_chroot_chmod,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_MKNOD
+	{
+		.procname	= "chroot_deny_mknod",
+		.data		= &grsec_enable_chroot_mknod,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_NICE
+	{
+		.procname	= "chroot_restrict_nice",
+		.data		= &grsec_enable_chroot_nice,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_EXECLOG
+	{
+		.procname	= "chroot_execlog",
+		.data		= &grsec_enable_chroot_execlog,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_CAPS
+	{
+		.procname	= "chroot_caps",
+		.data		= &grsec_enable_chroot_caps,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+	{
+		.procname	= "chroot_deny_bad_rename",
+		.data		= &grsec_enable_chroot_rename,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_SYSCTL
+	{
+		.procname	= "chroot_deny_sysctl",
+		.data		= &grsec_enable_chroot_sysctl,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_TPE
+	{
+		.procname	= "tpe",
+		.data		= &grsec_enable_tpe,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+	{
+		.procname	= "tpe_gid",
+		.data		= &grsec_tpe_gid,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_TPE_INVERT
+	{
+		.procname	= "tpe_invert",
+		.data		= &grsec_enable_tpe_invert,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_TPE_ALL
+	{
+		.procname	= "tpe_restrict_all",
+		.data		= &grsec_enable_tpe_all,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_SOCKET_ALL
+	{
+		.procname	= "socket_all",
+		.data		= &grsec_enable_socket_all,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+	{
+		.procname	= "socket_all_gid",
+		.data		= &grsec_socket_all_gid,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_SOCKET_CLIENT
+	{
+		.procname	= "socket_client",
+		.data		= &grsec_enable_socket_client,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+	{
+		.procname	= "socket_client_gid",
+		.data		= &grsec_socket_client_gid,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_SOCKET_SERVER
+	{
+		.procname	= "socket_server",
+		.data		= &grsec_enable_socket_server,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+	{
+		.procname	= "socket_server_gid",
+		.data		= &grsec_socket_server_gid,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_GROUP
+	{
+		.procname	= "audit_group",
+		.data		= &grsec_enable_group,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+	{
+		.procname	= "audit_gid",
+		.data		= &grsec_audit_gid,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_CHDIR
+	{
+		.procname	= "audit_chdir",
+		.data		= &grsec_enable_chdir,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_MOUNT
+	{
+		.procname	= "audit_mount",
+		.data		= &grsec_enable_mount,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_DMESG
+	{
+		.procname	= "dmesg",
+		.data		= &grsec_enable_dmesg,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_CHROOT_FINDTASK
+	{
+		.procname	= "chroot_findtask",
+		.data		= &grsec_enable_chroot_findtask,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_RESLOG
+	{
+		.procname	= "resource_logging",
+		.data		= &grsec_resource_logging,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_AUDIT_PTRACE
+	{
+		.procname	= "audit_ptrace",
+		.data		= &grsec_enable_audit_ptrace,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_HARDEN_PTRACE
+	{
+		.procname	= "harden_ptrace",
+		.data		= &grsec_enable_harden_ptrace,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_HARDEN_IPC
+	{
+		.procname	= "harden_ipc",
+		.data		= &grsec_enable_harden_ipc,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_HARDEN_TTY
+	{
+		.procname	= "harden_tty",
+		.data		= &grsec_enable_harden_tty,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+	{
+		.procname	= "grsec_lock",
+		.data		= &grsec_lock,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+#ifdef CONFIG_GRKERNSEC_ROFS
+	{
+		.procname	= "romount_protect",
+		.data		= &grsec_enable_rofs,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_minmax_secure,
+		.extra1		= &one,
+		.extra2		= &one,
+	},
+#endif
+#if defined(CONFIG_GRKERNSEC_DENYUSB) && !defined(CONFIG_GRKERNSEC_DENYUSB_FORCE)
+	{
+		.procname	= "deny_new_usb",
+		.data		= &grsec_deny_new_usb,
+		.maxlen		= sizeof(int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec_secure,
+	},
+#endif
+	{ }
+};
+#endif
diff --git b/grsecurity/grsec_time.c b/grsecurity/grsec_time.c
new file mode 100644
index 000000000..61b514e0d
--- /dev/null
+++ b/grsecurity/grsec_time.c
@@ -0,0 +1,16 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/grinternal.h>
+#include <linux/module.h>
+
+void
+gr_log_timechange(void)
+{
+#ifdef CONFIG_GRKERNSEC_TIME
+	if (grsec_enable_time)
+		gr_log_noargs(GR_DONT_AUDIT_GOOD, GR_TIME_MSG);
+#endif
+	return;
+}
+
+EXPORT_SYMBOL_GPL(gr_log_timechange);
diff --git b/grsecurity/grsec_tpe.c b/grsecurity/grsec_tpe.c
new file mode 100644
index 000000000..cbd277622
--- /dev/null
+++ b/grsecurity/grsec_tpe.c
@@ -0,0 +1,78 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/grinternal.h>
+
+extern int gr_acl_tpe_check(void);
+
+int
+gr_tpe_allow(const struct file *file)
+{
+#ifdef CONFIG_GRKERNSEC
+	struct inode *inode = d_backing_inode(file->f_path.dentry->d_parent);
+	struct inode *file_inode = d_backing_inode(file->f_path.dentry);
+	const struct cred *cred = current_cred();
+	char *msg = NULL;
+	char *msg2 = NULL;
+
+	// never restrict root
+	if (gr_is_global_root(cred->uid))
+		return 1;
+
+	if (grsec_enable_tpe) {
+#ifdef CONFIG_GRKERNSEC_TPE_INVERT
+		if (grsec_enable_tpe_invert && !in_group_p(grsec_tpe_gid))
+			msg = "not being in trusted group";
+		else if (!grsec_enable_tpe_invert && in_group_p(grsec_tpe_gid))
+			msg = "being in untrusted group";
+#else
+		if (in_group_p(grsec_tpe_gid))
+			msg = "being in untrusted group";
+#endif
+	}
+	if (!msg && gr_acl_tpe_check())
+		msg = "being in untrusted role";
+
+	// not in any affected group/role
+	if (!msg)
+		goto next_check;
+
+	if (gr_is_global_nonroot(inode->i_uid))
+		msg2 = "file in non-root-owned directory";
+	else if (inode->i_mode & S_IWOTH)
+		msg2 = "file in world-writable directory";
+	else if ((inode->i_mode & S_IWGRP) && gr_is_global_nonroot_gid(inode->i_gid))
+		msg2 = "file in group-writable directory";
+	else if (file_inode->i_mode & S_IWOTH)
+		msg2 = "file is world-writable";
+
+	if (msg && msg2) {
+		char fullmsg[70] = {0};
+		snprintf(fullmsg, sizeof(fullmsg)-1, "%s and %s", msg, msg2);
+		gr_log_str_fs(GR_DONT_AUDIT, GR_EXEC_TPE_MSG, fullmsg, file->f_path.dentry, file->f_path.mnt);
+		return 0;
+	}
+	msg = NULL;
+next_check:
+#ifdef CONFIG_GRKERNSEC_TPE_ALL
+	if (!grsec_enable_tpe || !grsec_enable_tpe_all)
+		return 1;
+
+	if (gr_is_global_nonroot(inode->i_uid) && !uid_eq(inode->i_uid, cred->uid))
+		msg = "directory not owned by user";
+	else if (inode->i_mode & S_IWOTH)
+		msg = "file in world-writable directory";
+	else if ((inode->i_mode & S_IWGRP) && gr_is_global_nonroot_gid(inode->i_gid))
+		msg = "file in group-writable directory";
+	else if (file_inode->i_mode & S_IWOTH)
+		msg = "file is world-writable";
+
+	if (msg) {
+		gr_log_str_fs(GR_DONT_AUDIT, GR_EXEC_TPE_MSG, msg, file->f_path.dentry, file->f_path.mnt);
+		return 0;
+	}
+#endif
+#endif
+	return 1;
+}
diff --git b/grsecurity/grsec_tty.c b/grsecurity/grsec_tty.c
new file mode 100644
index 000000000..ad8b9c542
--- /dev/null
+++ b/grsecurity/grsec_tty.c
@@ -0,0 +1,18 @@
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/grsecurity.h>
+#include <linux/grinternal.h>
+#include <linux/capability.h>
+#include <linux/tty.h>
+
+int gr_handle_tiocsti(struct tty_struct *tty)
+{
+#ifdef CONFIG_GRKERNSEC_HARDEN_TTY
+	if (grsec_enable_harden_tty && (current->signal->tty == tty) &&
+	    !capable(CAP_SYS_ADMIN)) {
+		gr_log_noargs(GR_DONT_AUDIT, GR_TIOCSTI_MSG);
+		return 1;
+	}
+#endif
+	return 0;
+}
diff --git b/grsecurity/grsec_usb.c b/grsecurity/grsec_usb.c
new file mode 100644
index 000000000..ae02d8e05
--- /dev/null
+++ b/grsecurity/grsec_usb.c
@@ -0,0 +1,15 @@
+#include <linux/kernel.h>
+#include <linux/grinternal.h>
+#include <linux/module.h>
+
+int gr_handle_new_usb(void)
+{
+#ifdef CONFIG_GRKERNSEC_DENYUSB
+	if (grsec_deny_new_usb) {
+		printk(KERN_ALERT "grsec: denied insert of new USB device\n");
+		return 1;
+	}
+#endif
+	return 0;
+}
+EXPORT_SYMBOL_GPL(gr_handle_new_usb);
diff --git b/grsecurity/grsum.c b/grsecurity/grsum.c
new file mode 100644
index 000000000..1af1e63a3
--- /dev/null
+++ b/grsecurity/grsum.c
@@ -0,0 +1,56 @@
+#include <linux/err.h>
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/scatterlist.h>
+#include <linux/crypto.h>
+#include <linux/gracl.h>
+#include <crypto/algapi.h>
+#include <crypto/hash.h>
+
+#if !defined(CONFIG_CRYPTO) || defined(CONFIG_CRYPTO_MODULE) || !defined(CONFIG_CRYPTO_SHA256) || defined(CONFIG_CRYPTO_SHA256_MODULE)
+#error "crypto and sha256 must be built into the kernel"
+#endif
+
+int
+chkpw(struct gr_arg *entry, unsigned char *salt, unsigned char *sum)
+{
+	struct crypto_ahash *tfm;
+	struct ahash_request *req;
+	struct scatterlist sg[2];
+	unsigned char temp_sum[GR_SHA_LEN];
+	unsigned long *tmpsumptr = (unsigned long *)temp_sum;
+	unsigned long *sumptr = (unsigned long *)sum;
+	int retval = 1;
+
+	tfm = crypto_alloc_ahash("sha256", 0, CRYPTO_ALG_ASYNC);
+	if (IS_ERR(tfm))
+		goto out_wipe;
+
+	sg_init_table(sg, 2);
+	sg_set_buf(&sg[0], salt, GR_SALT_LEN);
+	sg_set_buf(&sg[1], entry->pw, strlen((const char *)entry->pw));
+
+	req = ahash_request_alloc(tfm, GFP_KERNEL);
+	if (!req) {
+		crypto_free_ahash(tfm);
+		goto out_wipe;
+	}
+
+	ahash_request_set_callback(req, 0, NULL, NULL);
+	ahash_request_set_crypt(req, sg, temp_sum, GR_SALT_LEN + strlen((const char *)entry->pw));
+
+	if (crypto_ahash_digest(req))
+		goto out_free;
+
+	if (!crypto_memneq(sumptr, tmpsumptr, GR_SHA_LEN))
+		retval = 0;
+
+out_free:
+	ahash_request_free(req);
+	crypto_free_ahash(tfm);
+out_wipe:
+	memset(entry->pw, 0, GR_PW_LEN);
+
+	return retval;
+}
diff --git a/include/acpi/acpiosxf.h b/include/acpi/acpiosxf.h
index 562603d7a..7ee447562 100644
--- a/include/acpi/acpiosxf.h
+++ b/include/acpi/acpiosxf.h
@@ -337,11 +337,12 @@ acpi_status acpi_os_signal(u32 function, void *info);
  * Debug print routines
  */
 #ifndef ACPI_USE_ALTERNATE_PROTOTYPE_acpi_os_printf
+__printf(1, 2)
 void ACPI_INTERNAL_VAR_XFACE acpi_os_printf(const char *format, ...);
 #endif
 
 #ifndef ACPI_USE_ALTERNATE_PROTOTYPE_acpi_os_vprintf
-void acpi_os_vprintf(const char *format, va_list args);
+__printf(1, 0) void acpi_os_vprintf(const char *format, va_list args);
 #endif
 
 #ifndef ACPI_USE_ALTERNATE_PROTOTYPE_acpi_os_redirect_output
diff --git a/include/acpi/acpixf.h b/include/acpi/acpixf.h
index 1ff3a76c2..c52f3b47b 100644
--- a/include/acpi/acpixf.h
+++ b/include/acpi/acpixf.h
@@ -914,7 +914,7 @@ ACPI_MSG_DEPENDENT_RETURN_VOID(ACPI_PRINTF_LIKE(3)
 /*
  * Debug output
  */
-ACPI_DBG_DEPENDENT_RETURN_VOID(ACPI_PRINTF_LIKE(6)
+ACPI_DBG_DEPENDENT_RETURN_VOID(ACPI_PRINTF_LIKE(6) __nocapture(3)
 			       void ACPI_INTERNAL_VAR_XFACE
 			       acpi_debug_print(u32 requested_debug_level,
 						u32 line_number,
diff --git a/include/acpi/ghes.h b/include/acpi/ghes.h
index 720446cb2..f32baee50 100644
--- a/include/acpi/ghes.h
+++ b/include/acpi/ghes.h
@@ -32,7 +32,7 @@ struct ghes_estatus_node {
 
 struct ghes_estatus_cache {
 	u32 estatus_len;
-	atomic_t count;
+	atomic_unchecked_t count;
 	struct acpi_hest_generic *generic;
 	unsigned long long time_in;
 	struct rcu_head rcu;
diff --git a/include/asm-generic/4level-fixup.h b/include/asm-generic/4level-fixup.h
index 5bdab6bff..9ae82fe8e 100644
--- a/include/asm-generic/4level-fixup.h
+++ b/include/asm-generic/4level-fixup.h
@@ -14,8 +14,10 @@
 #define pmd_alloc(mm, pud, address) \
 	((unlikely(pgd_none(*(pud))) && __pmd_alloc(mm, pud, address))? \
  		NULL: pmd_offset(pud, address))
+#define pmd_alloc_kernel(mm, pud, address) pmd_alloc((mm), (pud), (address))
 
 #define pud_alloc(mm, pgd, address)	(pgd)
+#define pud_alloc_kernel(mm, pgd, address)	pud_alloc((mm), (pgd), (address))
 #define pud_offset(pgd, start)		(pgd)
 #define pud_none(pud)			0
 #define pud_bad(pud)			0
diff --git a/include/asm-generic/atomic-long.h b/include/asm-generic/atomic-long.h
index 288cc9e96..714fd1467 100644
--- a/include/asm-generic/atomic-long.h
+++ b/include/asm-generic/atomic-long.h
@@ -22,6 +22,12 @@
 
 typedef atomic64_t atomic_long_t;
 
+#ifdef CONFIG_PAX_REFCOUNT
+typedef atomic64_unchecked_t atomic_long_unchecked_t;
+#else
+typedef atomic64_t atomic_long_unchecked_t;
+#endif
+
 #define ATOMIC_LONG_INIT(i)	ATOMIC64_INIT(i)
 #define ATOMIC_LONG_PFX(x)	atomic64 ## x
 
@@ -29,51 +35,61 @@ typedef atomic64_t atomic_long_t;
 
 typedef atomic_t atomic_long_t;
 
+#ifdef CONFIG_PAX_REFCOUNT
+typedef atomic_unchecked_t atomic_long_unchecked_t;
+#else
+typedef atomic_t atomic_long_unchecked_t;
+#endif
+
 #define ATOMIC_LONG_INIT(i)	ATOMIC_INIT(i)
 #define ATOMIC_LONG_PFX(x)	atomic ## x
 
 #endif
 
-#define ATOMIC_LONG_READ_OP(mo)						\
-static inline long atomic_long_read##mo(const atomic_long_t *l)		\
+#define ATOMIC_LONG_READ_OP(mo, suffix)					\
+static inline long atomic_long_read##mo##suffix(const atomic_long##suffix##_t *l)\
 {									\
-	ATOMIC_LONG_PFX(_t) *v = (ATOMIC_LONG_PFX(_t) *)l;		\
+	ATOMIC_LONG_PFX(suffix##_t) *v = (ATOMIC_LONG_PFX(suffix##_t) *)l;\
 									\
-	return (long)ATOMIC_LONG_PFX(_read##mo)(v);			\
+	return (long)ATOMIC_LONG_PFX(_read##mo##suffix)(v);		\
 }
-ATOMIC_LONG_READ_OP()
-ATOMIC_LONG_READ_OP(_acquire)
+ATOMIC_LONG_READ_OP(,)
+ATOMIC_LONG_READ_OP(,_unchecked)
+ATOMIC_LONG_READ_OP(_acquire,)
 
 #undef ATOMIC_LONG_READ_OP
 
-#define ATOMIC_LONG_SET_OP(mo)						\
-static inline void atomic_long_set##mo(atomic_long_t *l, long i)	\
+#define ATOMIC_LONG_SET_OP(mo, suffix)					\
+static inline void atomic_long_set##mo##suffix(atomic_long##suffix##_t *l, long i)\
 {									\
-	ATOMIC_LONG_PFX(_t) *v = (ATOMIC_LONG_PFX(_t) *)l;		\
+	ATOMIC_LONG_PFX(suffix##_t) *v = (ATOMIC_LONG_PFX(suffix##_t) *)l;\
 									\
-	ATOMIC_LONG_PFX(_set##mo)(v, i);				\
+	ATOMIC_LONG_PFX(_set##mo##suffix)(v, i);			\
 }
-ATOMIC_LONG_SET_OP()
-ATOMIC_LONG_SET_OP(_release)
+ATOMIC_LONG_SET_OP(,)
+ATOMIC_LONG_SET_OP(,_unchecked)
+ATOMIC_LONG_SET_OP(_release,)
 
 #undef ATOMIC_LONG_SET_OP
 
-#define ATOMIC_LONG_ADD_SUB_OP(op, mo)					\
+#define ATOMIC_LONG_ADD_SUB_OP(op, mo, suffix)				\
 static inline long							\
-atomic_long_##op##_return##mo(long i, atomic_long_t *l)			\
+atomic_long_##op##_return##mo##suffix(long i, atomic_long##suffix##_t *l)\
 {									\
-	ATOMIC_LONG_PFX(_t) *v = (ATOMIC_LONG_PFX(_t) *)l;		\
+	ATOMIC_LONG_PFX(suffix##_t) *v = (ATOMIC_LONG_PFX(suffix##_t) *)l;\
 									\
-	return (long)ATOMIC_LONG_PFX(_##op##_return##mo)(i, v);		\
+	return (long)ATOMIC_LONG_PFX(_##op##_return##mo##suffix)(i, v);	\
 }
-ATOMIC_LONG_ADD_SUB_OP(add,)
-ATOMIC_LONG_ADD_SUB_OP(add, _relaxed)
-ATOMIC_LONG_ADD_SUB_OP(add, _acquire)
-ATOMIC_LONG_ADD_SUB_OP(add, _release)
-ATOMIC_LONG_ADD_SUB_OP(sub,)
-ATOMIC_LONG_ADD_SUB_OP(sub, _relaxed)
-ATOMIC_LONG_ADD_SUB_OP(sub, _acquire)
-ATOMIC_LONG_ADD_SUB_OP(sub, _release)
+ATOMIC_LONG_ADD_SUB_OP(add,,)
+ATOMIC_LONG_ADD_SUB_OP(add,,_unchecked)
+ATOMIC_LONG_ADD_SUB_OP(add, _relaxed,)
+ATOMIC_LONG_ADD_SUB_OP(add, _acquire,)
+ATOMIC_LONG_ADD_SUB_OP(add, _release,)
+ATOMIC_LONG_ADD_SUB_OP(sub,,)
+//ATOMIC_LONG_ADD_SUB_OP(sub,,_unchecked)
+ATOMIC_LONG_ADD_SUB_OP(sub, _relaxed,)
+ATOMIC_LONG_ADD_SUB_OP(sub, _acquire,)
+ATOMIC_LONG_ADD_SUB_OP(sub, _release,)
 
 #undef ATOMIC_LONG_ADD_SUB_OP
 
@@ -98,6 +114,11 @@ ATOMIC_LONG_ADD_SUB_OP(sub, _release)
 #define atomic_long_xchg(v, new) \
 	(ATOMIC_LONG_PFX(_xchg)((ATOMIC_LONG_PFX(_t) *)(v), (new)))
 
+#ifdef CONFIG_PAX_REFCOUNT
+#define atomic_long_xchg_unchecked(v, new) \
+	(ATOMIC_LONG_PFX(_xchg_unchecked)((ATOMIC_LONG_PFX(_unchecked_t) *)(v), (new)))
+#endif
+
 static __always_inline void atomic_long_inc(atomic_long_t *l)
 {
 	ATOMIC_LONG_PFX(_t) *v = (ATOMIC_LONG_PFX(_t) *)l;
@@ -105,6 +126,15 @@ static __always_inline void atomic_long_inc(atomic_long_t *l)
 	ATOMIC_LONG_PFX(_inc)(v);
 }
 
+#ifdef CONFIG_PAX_REFCOUNT
+static __always_inline void atomic_long_inc_unchecked(atomic_long_unchecked_t *l)
+{
+	ATOMIC_LONG_PFX(_unchecked_t) *v = (ATOMIC_LONG_PFX(_unchecked_t) *)l;
+
+	ATOMIC_LONG_PFX(_inc_unchecked)(v);
+}
+#endif
+
 static __always_inline void atomic_long_dec(atomic_long_t *l)
 {
 	ATOMIC_LONG_PFX(_t) *v = (ATOMIC_LONG_PFX(_t) *)l;
@@ -168,21 +198,32 @@ ATOMIC_LONG_FETCH_INC_DEC_OP(dec, _release)
 
 #undef ATOMIC_LONG_FETCH_INC_DEC_OP
 
-#define ATOMIC_LONG_OP(op)						\
+#ifdef CONFIG_PAX_REFCOUNT
+static __always_inline void atomic_long_dec_unchecked(atomic_long_unchecked_t *l)
+{
+	ATOMIC_LONG_PFX(_unchecked_t) *v = (ATOMIC_LONG_PFX(_unchecked_t) *)l;
+
+	ATOMIC_LONG_PFX(_dec_unchecked)(v);
+}
+#endif
+
+#define ATOMIC_LONG_OP(op, suffix)					\
 static __always_inline void						\
-atomic_long_##op(long i, atomic_long_t *l)				\
+atomic_long_##op##suffix(long i, atomic_long##suffix##_t *l)		\
 {									\
-	ATOMIC_LONG_PFX(_t) *v = (ATOMIC_LONG_PFX(_t) *)l;		\
+	ATOMIC_LONG_PFX(suffix##_t) *v = (ATOMIC_LONG_PFX(suffix##_t) *)l;\
 									\
-	ATOMIC_LONG_PFX(_##op)(i, v);					\
+	ATOMIC_LONG_PFX(_##op##suffix)(i, v);				\
 }
 
-ATOMIC_LONG_OP(add)
-ATOMIC_LONG_OP(sub)
-ATOMIC_LONG_OP(and)
-ATOMIC_LONG_OP(andnot)
-ATOMIC_LONG_OP(or)
-ATOMIC_LONG_OP(xor)
+ATOMIC_LONG_OP(add,)
+ATOMIC_LONG_OP(add,_unchecked)
+ATOMIC_LONG_OP(sub,)
+ATOMIC_LONG_OP(sub,_unchecked)
+ATOMIC_LONG_OP(and,)
+ATOMIC_LONG_OP(andnot,)
+ATOMIC_LONG_OP(or,)
+ATOMIC_LONG_OP(xor,)
 
 #undef ATOMIC_LONG_OP
 
@@ -214,22 +255,23 @@ static inline int atomic_long_add_negative(long i, atomic_long_t *l)
 	return ATOMIC_LONG_PFX(_add_negative)(i, v);
 }
 
-#define ATOMIC_LONG_INC_DEC_OP(op, mo)					\
+#define ATOMIC_LONG_INC_DEC_OP(op, mo, suffix)				\
 static inline long							\
-atomic_long_##op##_return##mo(atomic_long_t *l)				\
+atomic_long_##op##_return##mo##suffix(atomic_long##suffix##_t *l)	\
 {									\
-	ATOMIC_LONG_PFX(_t) *v = (ATOMIC_LONG_PFX(_t) *)l;		\
+	ATOMIC_LONG_PFX(suffix##_t) *v = (ATOMIC_LONG_PFX(suffix##_t) *)l;\
 									\
-	return (long)ATOMIC_LONG_PFX(_##op##_return##mo)(v);		\
+	return (long)ATOMIC_LONG_PFX(_##op##_return##mo##suffix)(v);	\
 }
-ATOMIC_LONG_INC_DEC_OP(inc,)
-ATOMIC_LONG_INC_DEC_OP(inc, _relaxed)
-ATOMIC_LONG_INC_DEC_OP(inc, _acquire)
-ATOMIC_LONG_INC_DEC_OP(inc, _release)
-ATOMIC_LONG_INC_DEC_OP(dec,)
-ATOMIC_LONG_INC_DEC_OP(dec, _relaxed)
-ATOMIC_LONG_INC_DEC_OP(dec, _acquire)
-ATOMIC_LONG_INC_DEC_OP(dec, _release)
+ATOMIC_LONG_INC_DEC_OP(inc,,)
+ATOMIC_LONG_INC_DEC_OP(inc,,_unchecked)
+ATOMIC_LONG_INC_DEC_OP(inc, _relaxed,)
+ATOMIC_LONG_INC_DEC_OP(inc, _acquire,)
+ATOMIC_LONG_INC_DEC_OP(inc, _release,)
+ATOMIC_LONG_INC_DEC_OP(dec,,)
+ATOMIC_LONG_INC_DEC_OP(dec, _relaxed,)
+ATOMIC_LONG_INC_DEC_OP(dec, _acquire,)
+ATOMIC_LONG_INC_DEC_OP(dec, _release,)
 
 #undef ATOMIC_LONG_INC_DEC_OP
 
@@ -243,4 +285,62 @@ static inline long atomic_long_add_unless(atomic_long_t *l, long a, long u)
 #define atomic_long_inc_not_zero(l) \
 	ATOMIC_LONG_PFX(_inc_not_zero)((ATOMIC_LONG_PFX(_t) *)(l))
 
+#ifdef CONFIG_PAX_REFCOUNT
+static inline void pax_refcount_needs_these_functions(void)
+{
+	atomic_read_unchecked((atomic_unchecked_t *)NULL);
+	atomic_set_unchecked((atomic_unchecked_t *)NULL, 0);
+	atomic_add_unchecked(0, (atomic_unchecked_t *)NULL);
+	atomic_sub_unchecked(0, (atomic_unchecked_t *)NULL);
+	atomic_inc_unchecked((atomic_unchecked_t *)NULL);
+	(void)atomic_inc_and_test_unchecked((atomic_unchecked_t *)NULL);
+	atomic_inc_return_unchecked((atomic_unchecked_t *)NULL);
+	atomic_add_return_unchecked(0, (atomic_unchecked_t *)NULL);
+	atomic_dec_unchecked((atomic_unchecked_t *)NULL);
+	atomic_cmpxchg_unchecked((atomic_unchecked_t *)NULL, 0, 0);
+	(void)atomic_xchg_unchecked((atomic_unchecked_t *)NULL, 0);
+
+	atomic_long_read_unchecked((atomic_long_unchecked_t *)NULL);
+	atomic_long_set_unchecked((atomic_long_unchecked_t *)NULL, 0);
+	atomic_long_add_unchecked(0, (atomic_long_unchecked_t *)NULL);
+	atomic_long_sub_unchecked(0, (atomic_long_unchecked_t *)NULL);
+	atomic_long_inc_unchecked((atomic_long_unchecked_t *)NULL);
+	atomic_long_add_return_unchecked(0, (atomic_long_unchecked_t *)NULL);
+	atomic_long_inc_return_unchecked((atomic_long_unchecked_t *)NULL);
+	atomic_long_dec_unchecked((atomic_long_unchecked_t *)NULL);
+}
+#else
+#define atomic_read_unchecked(v) atomic_read(v)
+#define atomic_set_unchecked(v, i) atomic_set((v), (i))
+#define atomic_add_unchecked(i, v) atomic_add((i), (v))
+#define atomic_sub_unchecked(i, v) atomic_sub((i), (v))
+#define atomic_inc_unchecked(v) atomic_inc(v)
+#ifndef atomic_inc_and_test_unchecked
+#define atomic_inc_and_test_unchecked(v) atomic_inc_and_test(v)
+#endif
+#ifndef atomic_inc_return_unchecked
+#define atomic_inc_return_unchecked(v) atomic_inc_return(v)
+#endif
+#ifndef atomic_add_return_unchecked
+#define atomic_add_return_unchecked(i, v) atomic_add_return((i), (v))
+#endif
+#define atomic_dec_unchecked(v) atomic_dec(v)
+#define atomic_cmpxchg_unchecked(v, o, n) atomic_cmpxchg((v), (o), (n))
+#ifndef atomic_xchg_unchecked
+#define atomic_xchg_unchecked(v, i) atomic_xchg((v), (i))
+#endif
+
+#define atomic_long_read_unchecked(v) atomic_long_read(v)
+#define atomic_long_set_unchecked(v, i) atomic_long_set((v), (i))
+#define atomic_long_add_unchecked(i, v) atomic_long_add((i), (v))
+#define atomic_long_sub_unchecked(i, v) atomic_long_sub((i), (v))
+#define atomic_long_inc_unchecked(v) atomic_long_inc(v)
+#define atomic_long_add_return_unchecked(i, v) atomic_long_add_return((i), (v))
+#define atomic_long_inc_return_unchecked(v) atomic_long_inc_return(v)
+#define atomic_long_dec_unchecked(v) atomic_long_dec(v)
+#ifndef atomic_long_xchg_unchecked
+#define atomic_long_xchg_unchecked(v, i) atomic_long_xchg((v), (i))
+#endif
+#endif
+
 #endif  /*  _ASM_GENERIC_ATOMIC_LONG_H  */
diff --git a/include/asm-generic/atomic64.h b/include/asm-generic/atomic64.h
index dad68bf46..cadcc641e 100644
--- a/include/asm-generic/atomic64.h
+++ b/include/asm-generic/atomic64.h
@@ -16,6 +16,8 @@ typedef struct {
 	long long counter;
 } atomic64_t;
 
+typedef atomic64_t atomic64_unchecked_t;
+
 #define ATOMIC64_INIT(i)	{ (i) }
 
 extern long long atomic64_read(const atomic64_t *v);
@@ -62,4 +64,15 @@ extern int	 atomic64_add_unless(atomic64_t *v, long long a, long long u);
 #define atomic64_dec_and_test(v)	(atomic64_dec_return((v)) == 0)
 #define atomic64_inc_not_zero(v) 	atomic64_add_unless((v), 1LL, 0LL)
 
+#define atomic64_read_unchecked(v) atomic64_read(v)
+#define atomic64_set_unchecked(v, i) atomic64_set((v), (i))
+#define atomic64_add_unchecked(a, v) atomic64_add((a), (v))
+#define atomic64_add_return_unchecked(a, v) atomic64_add_return((a), (v))
+#define atomic64_sub_unchecked(a, v) atomic64_sub((a), (v))
+#define atomic64_inc_unchecked(v) atomic64_inc(v)
+#define atomic64_inc_return_unchecked(v) atomic64_inc_return(v)
+#define atomic64_dec_unchecked(v) atomic64_dec(v)
+#define atomic64_cmpxchg_unchecked(v, o, n) atomic64_cmpxchg((v), (o), (n))
+#define atomic64_xchg_unchecked(v, n) atomic64_xchg((v), (n))
+
 #endif  /*  _ASM_GENERIC_ATOMIC64_H  */
diff --git a/include/asm-generic/bitops/__fls.h b/include/asm-generic/bitops/__fls.h
index a60a7ccb6..0fe12f27b 100644
--- a/include/asm-generic/bitops/__fls.h
+++ b/include/asm-generic/bitops/__fls.h
@@ -9,7 +9,7 @@
  *
  * Undefined if no set bit exists, so code should check against 0 first.
  */
-static __always_inline unsigned long __fls(unsigned long word)
+static __always_inline unsigned long __intentional_overflow(-1) __fls(unsigned long word)
 {
 	int num = BITS_PER_LONG - 1;
 
diff --git a/include/asm-generic/bitops/fls.h b/include/asm-generic/bitops/fls.h
index 0576d1f42..dad6c713e 100644
--- a/include/asm-generic/bitops/fls.h
+++ b/include/asm-generic/bitops/fls.h
@@ -9,7 +9,7 @@
  * Note fls(0) = 0, fls(1) = 1, fls(0x80000000) = 32.
  */
 
-static __always_inline int fls(int x)
+static __always_inline int __intentional_overflow(-1) fls(int x)
 {
 	int r = 32;
 
diff --git a/include/asm-generic/bitops/fls64.h b/include/asm-generic/bitops/fls64.h
index b097cf844..3d40e14aa 100644
--- a/include/asm-generic/bitops/fls64.h
+++ b/include/asm-generic/bitops/fls64.h
@@ -15,7 +15,7 @@
  * at position 64.
  */
 #if BITS_PER_LONG == 32
-static __always_inline int fls64(__u64 x)
+static __always_inline int __intentional_overflow(-1) fls64(__u64 x)
 {
 	__u32 h = x >> 32;
 	if (h)
@@ -23,7 +23,7 @@ static __always_inline int fls64(__u64 x)
 	return fls(x);
 }
 #elif BITS_PER_LONG == 64
-static __always_inline int fls64(__u64 x)
+static __always_inline int __intentional_overflow(-1) fls64(__u64 x)
 {
 	if (x == 0)
 		return 0;
diff --git a/include/asm-generic/bug.h b/include/asm-generic/bug.h
index 6f9624722..ca2764127 100644
--- a/include/asm-generic/bug.h
+++ b/include/asm-generic/bug.h
@@ -62,13 +62,13 @@ struct bug_entry {
  * to provide better diagnostics.
  */
 #ifndef __WARN_TAINT
-extern __printf(3, 4)
+extern __printf(3, 4) __nocapture(1)
 void warn_slowpath_fmt(const char *file, const int line,
 		       const char *fmt, ...);
-extern __printf(4, 5)
+extern __printf(4, 5) __nocapture(1)
 void warn_slowpath_fmt_taint(const char *file, const int line, unsigned taint,
 			     const char *fmt, ...);
-extern void warn_slowpath_null(const char *file, const int line);
+extern __nocapture(1) void warn_slowpath_null(const char *file, const int line);
 #define WANT_WARN_ON_SLOWPATH
 #define __WARN()		warn_slowpath_null(__FILE__, __LINE__)
 #define __WARN_printf(arg...)	warn_slowpath_fmt(__FILE__, __LINE__, arg)
@@ -84,6 +84,7 @@ extern void warn_slowpath_null(const char *file, const int line);
 /* used internally by panic.c */
 struct warn_args;
 
+__nocapture(1, 0)
 void __warn(const char *file, int line, void *caller, unsigned taint,
 	    struct pt_regs *regs, struct warn_args *args);
 
@@ -151,7 +152,7 @@ void __warn(const char *file, int line, void *caller, unsigned taint,
 #endif
 
 #ifndef HAVE_ARCH_BUG_ON
-#define BUG_ON(condition) do { if (condition) BUG(); } while (0)
+#define BUG_ON(condition) do { if (unlikely(condition)) BUG(); } while (0)
 #endif
 
 #ifndef HAVE_ARCH_WARN_ON
diff --git a/include/asm-generic/cache.h b/include/asm-generic/cache.h
index 1bfcfe5c2..e04c5c949 100644
--- a/include/asm-generic/cache.h
+++ b/include/asm-generic/cache.h
@@ -6,7 +6,7 @@
  * cache lines need to provide their own cache.h.
  */
 
-#define L1_CACHE_SHIFT		5
-#define L1_CACHE_BYTES		(1 << L1_CACHE_SHIFT)
+#define L1_CACHE_SHIFT		5UL
+#define L1_CACHE_BYTES		(1UL << L1_CACHE_SHIFT)
 
 #endif /* __ASM_GENERIC_CACHE_H */
diff --git a/include/asm-generic/emergency-restart.h b/include/asm-generic/emergency-restart.h
index 0d68a1eae..b74a761ca 100644
--- a/include/asm-generic/emergency-restart.h
+++ b/include/asm-generic/emergency-restart.h
@@ -1,7 +1,7 @@
 #ifndef _ASM_GENERIC_EMERGENCY_RESTART_H
 #define _ASM_GENERIC_EMERGENCY_RESTART_H
 
-static inline void machine_emergency_restart(void)
+static inline __noreturn void machine_emergency_restart(void)
 {
 	machine_restart(NULL);
 }
diff --git a/include/asm-generic/kmap_types.h b/include/asm-generic/kmap_types.h
index 90f99c74d..00ce23626 100644
--- a/include/asm-generic/kmap_types.h
+++ b/include/asm-generic/kmap_types.h
@@ -2,9 +2,9 @@
 #define _ASM_GENERIC_KMAP_TYPES_H
 
 #ifdef __WITH_KM_FENCE
-# define KM_TYPE_NR 41
+# define KM_TYPE_NR 42
 #else
-# define KM_TYPE_NR 20
+# define KM_TYPE_NR 21
 #endif
 
 #endif
diff --git a/include/asm-generic/local.h b/include/asm-generic/local.h
index 9ceb03b4f..62b0b8f1e 100644
--- a/include/asm-generic/local.h
+++ b/include/asm-generic/local.h
@@ -23,24 +23,37 @@ typedef struct
 	atomic_long_t a;
 } local_t;
 
+typedef struct {
+	atomic_long_unchecked_t a;
+} local_unchecked_t;
+
 #define LOCAL_INIT(i)	{ ATOMIC_LONG_INIT(i) }
 
 #define local_read(l)	atomic_long_read(&(l)->a)
+#define local_read_unchecked(l)	atomic_long_read_unchecked(&(l)->a)
 #define local_set(l,i)	atomic_long_set((&(l)->a),(i))
+#define local_set_unchecked(l,i)	atomic_long_set_unchecked((&(l)->a),(i))
 #define local_inc(l)	atomic_long_inc(&(l)->a)
+#define local_inc_unchecked(l)	atomic_long_inc_unchecked(&(l)->a)
 #define local_dec(l)	atomic_long_dec(&(l)->a)
+#define local_dec_unchecked(l)	atomic_long_dec_unchecked(&(l)->a)
 #define local_add(i,l)	atomic_long_add((i),(&(l)->a))
+#define local_add_unchecked(i,l)	atomic_long_add_unchecked((i),(&(l)->a))
 #define local_sub(i,l)	atomic_long_sub((i),(&(l)->a))
+#define local_sub_unchecked(i,l)	atomic_long_sub_unchecked((i),(&(l)->a))
 
 #define local_sub_and_test(i, l) atomic_long_sub_and_test((i), (&(l)->a))
 #define local_dec_and_test(l) atomic_long_dec_and_test(&(l)->a)
 #define local_inc_and_test(l) atomic_long_inc_and_test(&(l)->a)
 #define local_add_negative(i, l) atomic_long_add_negative((i), (&(l)->a))
 #define local_add_return(i, l) atomic_long_add_return((i), (&(l)->a))
+#define local_add_return_unchecked(i, l) atomic_long_add_return_unchecked((i), (&(l)->a))
 #define local_sub_return(i, l) atomic_long_sub_return((i), (&(l)->a))
 #define local_inc_return(l) atomic_long_inc_return(&(l)->a)
+#define local_dec_return(l) atomic_long_dec_return(&(l)->a)
 
 #define local_cmpxchg(l, o, n) atomic_long_cmpxchg((&(l)->a), (o), (n))
+#define local_cmpxchg_unchecked(l, o, n) atomic_long_cmpxchg((&(l)->a), (o), (n))
 #define local_xchg(l, n) atomic_long_xchg((&(l)->a), (n))
 #define local_add_unless(l, _a, u) atomic_long_add_unless((&(l)->a), (_a), (u))
 #define local_inc_not_zero(l) atomic_long_inc_not_zero(&(l)->a)
diff --git a/include/asm-generic/pgtable-nopmd.h b/include/asm-generic/pgtable-nopmd.h
index 725612b79..8458d850f 100644
--- a/include/asm-generic/pgtable-nopmd.h
+++ b/include/asm-generic/pgtable-nopmd.h
@@ -1,14 +1,19 @@
 #ifndef _PGTABLE_NOPMD_H
 #define _PGTABLE_NOPMD_H
 
-#ifndef __ASSEMBLY__
-
 #include <asm-generic/pgtable-nopud.h>
 
-struct mm_struct;
-
 #define __PAGETABLE_PMD_FOLDED
 
+#define PMD_SHIFT	PUD_SHIFT
+#define PTRS_PER_PMD	1
+#define PMD_SIZE  	(_AC(1,UL) << PMD_SHIFT)
+#define PMD_MASK  	(~(PMD_SIZE-1))
+
+#ifndef __ASSEMBLY__
+
+struct mm_struct;
+
 /*
  * Having the pmd type consist of a pud gets the size right, and allows
  * us to conceptually access the pud entry that this pmd is folded into
@@ -16,11 +21,6 @@ struct mm_struct;
  */
 typedef struct { pud_t pud; } pmd_t;
 
-#define PMD_SHIFT	PUD_SHIFT
-#define PTRS_PER_PMD	1
-#define PMD_SIZE  	(1UL << PMD_SHIFT)
-#define PMD_MASK  	(~(PMD_SIZE-1))
-
 /*
  * The "pud_xxx()" functions here are trivial for a folded two-level
  * setup: the pmd is never bad, and a pmd always exists (as it's folded
@@ -33,6 +33,7 @@ static inline void pud_clear(pud_t *pud)	{ }
 #define pmd_ERROR(pmd)				(pud_ERROR((pmd).pud))
 
 #define pud_populate(mm, pmd, pte)		do { } while (0)
+#define pud_populate_kernel(mm, pmd, pte)	do { } while (0)
 
 /*
  * (pmds are folded into puds so this doesn't get actually called,
diff --git a/include/asm-generic/pgtable-nopud.h b/include/asm-generic/pgtable-nopud.h
index 810431d83..0ec4804f4 100644
--- a/include/asm-generic/pgtable-nopud.h
+++ b/include/asm-generic/pgtable-nopud.h
@@ -1,10 +1,15 @@
 #ifndef _PGTABLE_NOPUD_H
 #define _PGTABLE_NOPUD_H
 
-#ifndef __ASSEMBLY__
-
 #define __PAGETABLE_PUD_FOLDED
 
+#define PUD_SHIFT	PGDIR_SHIFT
+#define PTRS_PER_PUD	1
+#define PUD_SIZE  	(_AC(1,UL) << PUD_SHIFT)
+#define PUD_MASK  	(~(PUD_SIZE-1))
+
+#ifndef __ASSEMBLY__
+
 /*
  * Having the pud type consist of a pgd gets the size right, and allows
  * us to conceptually access the pgd entry that this pud is folded into
@@ -12,11 +17,6 @@
  */
 typedef struct { pgd_t pgd; } pud_t;
 
-#define PUD_SHIFT	PGDIR_SHIFT
-#define PTRS_PER_PUD	1
-#define PUD_SIZE  	(1UL << PUD_SHIFT)
-#define PUD_MASK  	(~(PUD_SIZE-1))
-
 /*
  * The "pgd_xxx()" functions here are trivial for a folded two-level
  * setup: the pud is never bad, and a pud always exists (as it's folded
@@ -29,6 +29,7 @@ static inline void pgd_clear(pgd_t *pgd)	{ }
 #define pud_ERROR(pud)				(pgd_ERROR((pud).pgd))
 
 #define pgd_populate(mm, pgd, pud)		do { } while (0)
+#define pgd_populate_kernel(mm, pgd, pud)	do { } while (0)
 /*
  * (puds are folded into pgds so this doesn't get actually called,
  * but the define is needed for a generic inline function.)
diff --git a/include/asm-generic/pgtable.h b/include/asm-generic/pgtable.h
index d4458b6db..34e3f4683 100644
--- a/include/asm-generic/pgtable.h
+++ b/include/asm-generic/pgtable.h
@@ -757,6 +757,22 @@ static inline int pmd_protnone(pmd_t pmd)
 }
 #endif /* CONFIG_NUMA_BALANCING */
 
+#ifndef __HAVE_ARCH_PAX_OPEN_KERNEL
+#ifdef CONFIG_PAX_KERNEXEC
+#error KERNEXEC requires pax_open_kernel
+#else
+static inline unsigned long pax_open_kernel(void) { return 0; }
+#endif
+#endif
+
+#ifndef __HAVE_ARCH_PAX_CLOSE_KERNEL
+#ifdef CONFIG_PAX_KERNEXEC
+#error KERNEXEC requires pax_close_kernel
+#else
+static inline unsigned long pax_close_kernel(void) { return 0; }
+#endif
+#endif
+
 #endif /* CONFIG_MMU */
 
 #ifdef CONFIG_HAVE_ARCH_HUGE_VMAP
diff --git a/include/asm-generic/sections.h b/include/asm-generic/sections.h
index af0254c09..a4e4da3e9 100644
--- a/include/asm-generic/sections.h
+++ b/include/asm-generic/sections.h
@@ -31,6 +31,7 @@ extern char _data[], _sdata[], _edata[];
 extern char __bss_start[], __bss_stop[];
 extern char __init_begin[], __init_end[];
 extern char _sinittext[], _einittext[];
+extern char _sinitdata[], _einitdata[];
 extern char _end[];
 extern char __per_cpu_load[], __per_cpu_start[], __per_cpu_end[];
 extern char __kprobes_text_start[], __kprobes_text_end[];
diff --git a/include/asm-generic/uaccess.h b/include/asm-generic/uaccess.h
index 6df9b0749..8b07d2ff2 100644
--- a/include/asm-generic/uaccess.h
+++ b/include/asm-generic/uaccess.h
@@ -352,4 +352,20 @@ clear_user(void __user *to, unsigned long n)
 	return __clear_user(to, n);
 }
 
+#ifndef __HAVE_ARCH_PAX_OPEN_USERLAND
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+#error UDEREF requires pax_open_userland
+#else
+static inline unsigned long pax_open_userland(void) { return 0; }
+#endif
+#endif
+
+#ifndef __HAVE_ARCH_PAX_CLOSE_USERLAND
+#ifdef CONFIG_PAX_MEMORY_UDEREF
+#error UDEREF requires pax_close_userland
+#else
+static inline unsigned long pax_close_userland(void) { return 0; }
+#endif
+#endif
+
 #endif /* __ASM_GENERIC_UACCESS_H */
diff --git a/include/asm-generic/vmlinux.lds.h b/include/asm-generic/vmlinux.lds.h
index 24563970f..85deae003 100644
--- a/include/asm-generic/vmlinux.lds.h
+++ b/include/asm-generic/vmlinux.lds.h
@@ -266,6 +266,7 @@
 		VMLINUX_SYMBOL(__start_rodata) = .;			\
 		*(.rodata) *(.rodata.*)					\
 		RO_AFTER_INIT_DATA	/* Read only after init */	\
+		*(.data..read_only)					\
 		*(__vermagic)		/* Kernel version magic */	\
 		. = ALIGN(8);						\
 		VMLINUX_SYMBOL(__start___tracepoints_ptrs) = .;		\
@@ -434,9 +435,20 @@
 		ALIGN_FUNCTION();					\
 		*(.text.hot .text .text.fixup .text.unlikely)		\
 		*(.ref.text)						\
+		REFCOUNT_TEXT						\
 	MEM_KEEP(init.text)						\
 	MEM_KEEP(exit.text)						\
 
+#define __REFCOUNT_TEXT(section)					\
+		VMLINUX_SYMBOL(__##section##_start) = .;		\
+		*(.text.##section)					\
+		VMLINUX_SYMBOL(__##section##_end) = .;
+
+#define REFCOUNT_TEXT							\
+	__REFCOUNT_TEXT(refcount_overflow)				\
+	__REFCOUNT_TEXT(refcount64_overflow)				\
+	__REFCOUNT_TEXT(refcount_underflow)				\
+	__REFCOUNT_TEXT(refcount64_underflow)				\
 
 /* sched.text is aling to function alignment to secure we have same
  * address even at second ld pass when generating System.map */
@@ -531,7 +543,9 @@
 	MEM_DISCARD(init.data)						\
 	KERNEL_CTORS()							\
 	MCOUNT_REC()							\
+	*(.init.rodata.str)						\
 	*(.init.rodata)							\
+	*(.init.rodata.*)						\
 	FTRACE_EVENTS()							\
 	TRACE_SYSCALLS()						\
 	KPROBE_BLACKLIST()						\
@@ -555,9 +569,12 @@
 
 #define EXIT_DATA							\
 	*(.exit.data)							\
+	*(.exit.rodata)							\
+	*(.exit.rodata.*)						\
 	*(.fini_array)							\
 	*(.dtors)							\
 	MEM_DISCARD(exit.data)						\
+	*(.exit.rodata.str)						\
 	MEM_DISCARD(exit.rodata)
 
 #define EXIT_TEXT							\
@@ -774,17 +791,18 @@
  * section in the linker script will go there too.  @phdr should have
  * a leading colon.
  *
- * Note that this macros defines __per_cpu_load as an absolute symbol.
+ * Note that this macros defines per_cpu_load as an absolute symbol.
  * If there is no need to put the percpu section at a predetermined
  * address, use PERCPU_SECTION.
  */
 #define PERCPU_VADDR(cacheline, vaddr, phdr)				\
-	VMLINUX_SYMBOL(__per_cpu_load) = .;				\
-	.data..percpu vaddr : AT(VMLINUX_SYMBOL(__per_cpu_load)		\
+	per_cpu_load = .;						\
+	.data..percpu vaddr : AT(VMLINUX_SYMBOL(per_cpu_load)		\
 				- LOAD_OFFSET) {			\
+		VMLINUX_SYMBOL(__per_cpu_load) = . + per_cpu_load;	\
 		PERCPU_INPUT(cacheline)					\
 	} phdr								\
-	. = VMLINUX_SYMBOL(__per_cpu_load) + SIZEOF(.data..percpu);
+	. = VMLINUX_SYMBOL(per_cpu_load) + SIZEOF(.data..percpu);
 
 /**
  * PERCPU_SECTION - define output section for percpu area, simple version
@@ -846,12 +864,14 @@
 
 #define INIT_DATA_SECTION(initsetup_align)				\
 	.init.data : AT(ADDR(.init.data) - LOAD_OFFSET) {		\
+		VMLINUX_SYMBOL(_sinitdata) = .;				\
 		INIT_DATA						\
 		INIT_SETUP(initsetup_align)				\
 		INIT_CALLS						\
 		CON_INITCALL						\
 		SECURITY_INITCALL					\
 		INIT_RAM_FS						\
+		VMLINUX_SYMBOL(_einitdata) = .;				\
 	}
 
 #define BSS_SECTION(sbss_align, bss_align, stop_align)			\
diff --git a/include/crypto/algapi.h b/include/crypto/algapi.h
index 8637cdfe3..19076236a 100644
--- a/include/crypto/algapi.h
+++ b/include/crypto/algapi.h
@@ -38,7 +38,7 @@ struct crypto_type {
 	unsigned int maskclear;
 	unsigned int maskset;
 	unsigned int tfmsize;
-};
+} __do_const;
 
 struct crypto_instance {
 	struct crypto_alg alg;
diff --git a/include/crypto/cast6.h b/include/crypto/cast6.h
index 32b60eb8b..1a592df2f 100644
--- a/include/crypto/cast6.h
+++ b/include/crypto/cast6.h
@@ -18,7 +18,7 @@ int __cast6_setkey(struct cast6_ctx *ctx, const u8 *key,
 		   unsigned int keylen, u32 *flags);
 int cast6_setkey(struct crypto_tfm *tfm, const u8 *key, unsigned int keylen);
 
-void __cast6_encrypt(struct cast6_ctx *ctx, u8 *dst, const u8 *src);
-void __cast6_decrypt(struct cast6_ctx *ctx, u8 *dst, const u8 *src);
+void __cast6_encrypt(void *ctx, u8 *dst, const u8 *src);
+void __cast6_decrypt(void *ctx, u8 *dst, const u8 *src);
 
 #endif
diff --git a/include/crypto/serpent.h b/include/crypto/serpent.h
index b7e0941eb..1a1f67fcc 100644
--- a/include/crypto/serpent.h
+++ b/include/crypto/serpent.h
@@ -21,7 +21,7 @@ int __serpent_setkey(struct serpent_ctx *ctx, const u8 *key,
 		     unsigned int keylen);
 int serpent_setkey(struct crypto_tfm *tfm, const u8 *key, unsigned int keylen);
 
-void __serpent_encrypt(struct serpent_ctx *ctx, u8 *dst, const u8 *src);
-void __serpent_decrypt(struct serpent_ctx *ctx, u8 *dst, const u8 *src);
+void __serpent_encrypt(void *ctx, u8 *dst, const u8 *src);
+void __serpent_decrypt(void *ctx, u8 *dst, const u8 *src);
 
 #endif
diff --git a/include/crypto/xts.h b/include/crypto/xts.h
index ede6b97b2..1f5b11fe8 100644
--- a/include/crypto/xts.h
+++ b/include/crypto/xts.h
@@ -21,7 +21,7 @@ struct xts_crypt_req {
 	void (*crypt_fn)(void *ctx, u8 *blks, unsigned int nbytes);
 };
 
-#define XTS_TWEAK_CAST(x) ((void (*)(void *, u8*, const u8*))(x))
+#define XTS_TWEAK_CAST(x) (x)
 
 int xts_crypt(struct blkcipher_desc *desc, struct scatterlist *dst,
 	      struct scatterlist *src, unsigned int nbytes,
diff --git a/include/drm/drmP.h b/include/drm/drmP.h
index 988903a59..88e688310 100644
--- a/include/drm/drmP.h
+++ b/include/drm/drmP.h
@@ -60,6 +60,7 @@
 
 #include <asm/mman.h>
 #include <asm/pgalloc.h>
+#include <asm/local.h>
 #include <asm/uaccess.h>
 
 #include <uapi/drm/drm.h>
@@ -134,7 +135,7 @@ struct dma_buf_attachment;
 #define DRM_UT_ATOMIC		0x10
 #define DRM_UT_VBL		0x20
 
-extern __printf(2, 3)
+extern __printf(2, 3) __nocapture(1)
 void drm_ut_debug_printk(const char *function_name,
 			 const char *format, ...);
 extern __printf(1, 2)
@@ -247,10 +248,12 @@ void drm_err(const char *format, ...);
  * \param cmd command.
  * \param arg argument.
  */
-typedef int drm_ioctl_t(struct drm_device *dev, void *data,
+typedef int (* const drm_ioctl_t)(struct drm_device *dev, void *data,
+			struct drm_file *file_priv);
+typedef int (* drm_ioctl_no_const_t)(struct drm_device *dev, void *data,
 			struct drm_file *file_priv);
 
-typedef int drm_ioctl_compat_t(struct file *filp, unsigned int cmd,
+typedef int (* const drm_ioctl_compat_t)(struct file *filp, unsigned int cmd,
 			       unsigned long arg);
 
 #define DRM_IOCTL_NR(n)                _IOC_NR(n)
@@ -266,9 +269,9 @@ typedef int drm_ioctl_compat_t(struct file *filp, unsigned int cmd,
 struct drm_ioctl_desc {
 	unsigned int cmd;
 	int flags;
-	drm_ioctl_t *func;
+	drm_ioctl_t func;
 	const char *name;
-};
+} __do_const;
 
 /**
  * Creates a driver or general drm_ioctl_desc array entry for the given
@@ -639,7 +642,8 @@ struct drm_driver {
 
 	/* List of devices hanging off this driver with stealth attach. */
 	struct list_head legacy_dev_list;
-};
+} __do_const;
+typedef struct drm_driver __no_const drm_driver_no_const;
 
 enum drm_minor_type {
 	DRM_MINOR_LEGACY,
@@ -657,7 +661,8 @@ struct drm_info_list {
 	int (*show)(struct seq_file*, void*); /** show callback */
 	u32 driver_features; /**< Required driver features for this entry */
 	void *data;
-};
+} __do_const;
+typedef struct drm_info_list __no_const drm_info_list_no_const;
 
 /**
  * debugfs node structure. This structure represents a debugfs file.
@@ -718,7 +723,7 @@ struct drm_device {
 
 	/** \name Usage Counters */
 	/*@{ */
-	int open_count;			/**< Outstanding files open, protected by drm_global_mutex. */
+	local_t open_count;		/**< Outstanding files open, protected by drm_global_mutex. */
 	spinlock_t buf_lock;		/**< For drm_device::buf_use and a few other things. */
 	int buf_use;			/**< Buffers in use -- cannot alloc */
 	atomic_t buf_alloc;		/**< Buffer allocation in progress */
diff --git a/include/drm/drm_mm.h b/include/drm/drm_mm.h
index fc65118e5..7d80068f4 100644
--- a/include/drm/drm_mm.h
+++ b/include/drm/drm_mm.h
@@ -291,7 +291,7 @@ void drm_mm_remove_node(struct drm_mm_node *node);
 void drm_mm_replace_node(struct drm_mm_node *old, struct drm_mm_node *new);
 void drm_mm_init(struct drm_mm *mm,
 		 u64 start,
-		 u64 size);
+		 u64 size) __intentional_overflow(3);
 void drm_mm_takedown(struct drm_mm *mm);
 bool drm_mm_clean(struct drm_mm *mm);
 
diff --git a/include/drm/drm_modeset_helper_vtables.h b/include/drm/drm_modeset_helper_vtables.h
index b55f21857..0fe15f5d3 100644
--- a/include/drm/drm_modeset_helper_vtables.h
+++ b/include/drm/drm_modeset_helper_vtables.h
@@ -638,7 +638,7 @@ struct drm_encoder_helper_funcs {
 	int (*atomic_check)(struct drm_encoder *encoder,
 			    struct drm_crtc_state *crtc_state,
 			    struct drm_connector_state *conn_state);
-};
+} __no_const;
 
 /**
  * drm_encoder_helper_add - sets the helper vtable for an encoder
@@ -778,6 +778,7 @@ struct drm_connector_helper_funcs {
 	struct drm_encoder *(*atomic_best_encoder)(struct drm_connector *connector,
 						   struct drm_connector_state *connector_state);
 };
+typedef struct drm_connector_helper_funcs __no_const drm_connector_helper_funcs_no_const;
 
 /**
  * drm_connector_helper_add - sets the helper vtable for a connector
diff --git a/include/drm/i915_pciids.h b/include/drm/i915_pciids.h
index 33466bfc6..3c530076e 100644
--- a/include/drm/i915_pciids.h
+++ b/include/drm/i915_pciids.h
@@ -37,7 +37,7 @@
  */
 #define INTEL_VGA_DEVICE(id, info) {		\
 	0x8086,	id,				\
-	~0, ~0,					\
+	PCI_ANY_ID, PCI_ANY_ID,			\
 	0x030000, 0xff0000,			\
 	(unsigned long) info }
 
diff --git a/include/drm/intel-gtt.h b/include/drm/intel-gtt.h
index f49edecd6..e47b019f8 100644
--- a/include/drm/intel-gtt.h
+++ b/include/drm/intel-gtt.h
@@ -3,8 +3,8 @@
 #ifndef _DRM_INTEL_GTT_H
 #define	_DRM_INTEL_GTT_H
 
-void intel_gtt_get(u64 *gtt_total, size_t *stolen_size,
-		   phys_addr_t *mappable_base, u64 *mappable_end);
+void intel_gtt_get(u64 *gtt_total, u64 *stolen_size,
+		   u64 *mappable_base, u64 *mappable_end);
 
 int intel_gmch_probe(struct pci_dev *bridge_pdev, struct pci_dev *gpu_pdev,
 		     struct agp_bridge_data *bridge);
diff --git a/include/drm/ttm/ttm_memory.h b/include/drm/ttm/ttm_memory.h
index 72dcbe81d..8db58d726 100644
--- a/include/drm/ttm/ttm_memory.h
+++ b/include/drm/ttm/ttm_memory.h
@@ -48,7 +48,7 @@
 
 struct ttm_mem_shrink {
 	int (*do_shrink) (struct ttm_mem_shrink *);
-};
+} __no_const;
 
 /**
  * struct ttm_mem_global - Global memory accounting structure.
diff --git a/include/drm/ttm/ttm_page_alloc.h b/include/drm/ttm/ttm_page_alloc.h
index 49a828425..9643967eb 100644
--- a/include/drm/ttm/ttm_page_alloc.h
+++ b/include/drm/ttm/ttm_page_alloc.h
@@ -80,6 +80,7 @@ void ttm_dma_page_alloc_fini(void);
  */
 extern int ttm_dma_page_alloc_debugfs(struct seq_file *m, void *data);
 
+struct device;
 extern int ttm_dma_populate(struct ttm_dma_tt *ttm_dma, struct device *dev);
 extern void ttm_dma_unpopulate(struct ttm_dma_tt *ttm_dma, struct device *dev);
 
diff --git a/include/keys/asymmetric-subtype.h b/include/keys/asymmetric-subtype.h
index 2480469ce..afcbfd4ba 100644
--- a/include/keys/asymmetric-subtype.h
+++ b/include/keys/asymmetric-subtype.h
@@ -37,7 +37,7 @@ struct asymmetric_key_subtype {
 	/* Verify the signature on a key of this subtype (optional) */
 	int (*verify_signature)(const struct key *key,
 				const struct public_key_signature *sig);
-};
+} __do_const;
 
 /**
  * asymmetric_key_subtype - Get the subtype from an asymmetric key
diff --git a/include/keys/encrypted-type.h b/include/keys/encrypted-type.h
index 1d4541370..377bc278b 100644
--- a/include/keys/encrypted-type.h
+++ b/include/keys/encrypted-type.h
@@ -15,7 +15,7 @@
 #ifndef _KEYS_ENCRYPTED_TYPE_H
 #define _KEYS_ENCRYPTED_TYPE_H
 
-#include <linux/key.h>
+#include <linux/key-type.h>
 #include <linux/rcupdate.h>
 
 struct encrypted_key_payload {
diff --git a/include/keys/rxrpc-type.h b/include/keys/rxrpc-type.h
index 5de0673f3..5e8f2c5f3 100644
--- a/include/keys/rxrpc-type.h
+++ b/include/keys/rxrpc-type.h
@@ -12,7 +12,7 @@
 #ifndef _KEYS_RXRPC_TYPE_H
 #define _KEYS_RXRPC_TYPE_H
 
-#include <linux/key.h>
+#include <linux/key-type.h>
 
 /*
  * key type for AF_RXRPC keys
diff --git a/include/keys/user-type.h b/include/keys/user-type.h
index c56fef40f..c9ebdc7b9 100644
--- a/include/keys/user-type.h
+++ b/include/keys/user-type.h
@@ -12,7 +12,7 @@
 #ifndef _KEYS_USER_TYPE_H
 #define _KEYS_USER_TYPE_H
 
-#include <linux/key.h>
+#include <linux/key-type.h>
 #include <linux/rcupdate.h>
 
 #ifdef CONFIG_KEYS
diff --git a/include/linux/atmdev.h b/include/linux/atmdev.h
index c1da539f5..1dcec5522 100644
--- a/include/linux/atmdev.h
+++ b/include/linux/atmdev.h
@@ -28,7 +28,7 @@ struct compat_atm_iobuf {
 #endif
 
 struct k_atm_aal_stats {
-#define __HANDLE_ITEM(i) atomic_t i
+#define __HANDLE_ITEM(i) atomic_unchecked_t i
 	__AAL_STAT_ITEMS
 #undef __HANDLE_ITEM
 };
@@ -200,7 +200,7 @@ struct atmdev_ops { /* only send is required */
 	int (*change_qos)(struct atm_vcc *vcc,struct atm_qos *qos,int flags);
 	int (*proc_read)(struct atm_dev *dev,loff_t *pos,char *page);
 	struct module *owner;
-};
+} __do_const ;
 
 struct atmphy_ops {
 	int (*start)(struct atm_dev *dev);
diff --git a/include/linux/atomic.h b/include/linux/atomic.h
index e71835bf6..957f2d63e 100644
--- a/include/linux/atomic.h
+++ b/include/linux/atomic.h
@@ -72,6 +72,7 @@
 #define  atomic_add_return_relaxed	atomic_add_return
 #define  atomic_add_return_acquire	atomic_add_return
 #define  atomic_add_return_release	atomic_add_return
+#define atomic_add_return_unchecked_relaxed	atomic_add_return_unchecked
 
 #else /* atomic_add_return_relaxed */
 
@@ -89,6 +90,11 @@
 #define  atomic_add_return(...)						\
 	__atomic_op_fence(atomic_add_return, __VA_ARGS__)
 #endif
+
+#ifndef atomic_add_return_unchecked
+#define  atomic_add_return_unchecked(...)				\
+	__atomic_op_fence(atomic_add_return_unchecked, __VA_ARGS__)
+#endif
 #endif /* atomic_add_return_relaxed */
 
 /* atomic_inc_return_relaxed */
@@ -113,6 +119,11 @@
 #define  atomic_inc_return(...)						\
 	__atomic_op_fence(atomic_inc_return, __VA_ARGS__)
 #endif
+
+#ifndef atomic_inc_return_unchecked
+#define  atomic_inc_return_unchecked(...)				\
+	__atomic_op_fence(atomic_inc_return_unchecked, __VA_ARGS__)
+#endif
 #endif /* atomic_inc_return_relaxed */
 
 /* atomic_sub_return_relaxed */
@@ -490,6 +501,10 @@
 #ifndef xchg
 #define  xchg(...)			__atomic_op_fence(xchg, __VA_ARGS__)
 #endif
+
+#ifndef xchg_unchecked
+#define  xchg_unchecked(...)		__atomic_op_fence(xchg_unchecked, __VA_ARGS__)
+#endif
 #endif /* xchg_relaxed */
 
 /**
@@ -501,7 +516,7 @@
  * Atomically adds @a to @v, so long as @v was not already @u.
  * Returns non-zero if @v was not @u, and zero otherwise.
  */
-static inline int atomic_add_unless(atomic_t *v, int a, int u)
+static inline int __intentional_overflow(-1) atomic_add_unless(atomic_t *v, int a, int u)
 {
 	return __atomic_add_unless(v, a, u) != u;
 }
@@ -618,7 +633,7 @@ static inline int atomic_dec_if_positive(atomic_t *v)
 		dec = c - 1;
 		if (unlikely(dec < 0))
 			break;
-		old = atomic_cmpxchg((v), c, dec);
+		old = atomic_cmpxchg(v, c, dec);
 		if (likely(old == c))
 			break;
 		c = old;
@@ -661,6 +676,11 @@ static inline int atomic_dec_if_positive(atomic_t *v)
 #define  atomic64_add_return(...)					\
 	__atomic_op_fence(atomic64_add_return, __VA_ARGS__)
 #endif
+
+#ifndef atomic64_add_return_unchecked
+#define  atomic64_add_return_unchecked(...)				\
+	__atomic_op_fence(atomic64_add_return_unchecked, __VA_ARGS__)
+#endif
 #endif /* atomic64_add_return_relaxed */
 
 /* atomic64_inc_return_relaxed */
@@ -685,6 +705,11 @@ static inline int atomic_dec_if_positive(atomic_t *v)
 #define  atomic64_inc_return(...)					\
 	__atomic_op_fence(atomic64_inc_return, __VA_ARGS__)
 #endif
+
+#ifndef atomic64_inc_return_unchecked
+#define  atomic64_inc_return_unchecked(...)				\
+	__atomic_op_fence(atomic64_inc_return_unchecked, __VA_ARGS__)
+#endif
 #endif /* atomic64_inc_return_relaxed */
 
 
@@ -970,6 +995,11 @@ static inline int atomic_dec_if_positive(atomic_t *v)
 #define  atomic64_xchg(...)						\
 	__atomic_op_fence(atomic64_xchg, __VA_ARGS__)
 #endif
+
+#ifndef atomic64_xchg_unchecked
+#define  atomic64_xchg_unchecked(...)					\
+	__atomic_op_fence(atomic64_xchg_unchecked, __VA_ARGS__)
+#endif
 #endif /* atomic64_xchg_relaxed */
 
 /* atomic64_cmpxchg_relaxed */
@@ -994,6 +1024,11 @@ static inline int atomic_dec_if_positive(atomic_t *v)
 #define  atomic64_cmpxchg(...)						\
 	__atomic_op_fence(atomic64_cmpxchg, __VA_ARGS__)
 #endif
+
+#ifndef atomic64_cmpxchg_unchecked
+#define  atomic64_cmpxchg_unchecked(...)				\
+	__atomic_op_fence(atomic64_cmpxchg_unchecked, __VA_ARGS__)
+#endif
 #endif /* atomic64_cmpxchg_relaxed */
 
 #ifndef atomic64_andnot
diff --git a/include/linux/audit.h b/include/linux/audit.h
index 9d4443f93..b0b3fef02 100644
--- a/include/linux/audit.h
+++ b/include/linux/audit.h
@@ -135,7 +135,7 @@ extern void		    audit_log_n_hex(struct audit_buffer *ab,
 					  size_t len);
 extern void		    audit_log_n_string(struct audit_buffer *ab,
 					       const char *buf,
-					       size_t n);
+					       size_t n) __nocapture(2);
 extern void		    audit_log_n_untrustedstring(struct audit_buffer *ab,
 							const char *string,
 							size_t n);
@@ -333,7 +333,7 @@ static inline void audit_ptrace(struct task_struct *t)
 extern unsigned int audit_serial(void);
 extern int auditsc_get_stamp(struct audit_context *ctx,
 			      struct timespec *t, unsigned int *serial);
-extern int audit_set_loginuid(kuid_t loginuid);
+extern int __intentional_overflow(-1) audit_set_loginuid(kuid_t loginuid);
 
 static inline kuid_t audit_get_loginuid(struct task_struct *tsk)
 {
@@ -552,7 +552,8 @@ static inline bool audit_loginuid_set(struct task_struct *tsk)
 	return uid_valid(audit_get_loginuid(tsk));
 }
 
-static inline void audit_log_string(struct audit_buffer *ab, const char *buf)
+static inline __nocapture(2)
+void audit_log_string(struct audit_buffer *ab, const char *buf)
 {
 	audit_log_n_string(ab, buf, strlen(buf));
 }
diff --git a/include/linux/average.h b/include/linux/average.h
index d04aa5828..3de0da882 100644
--- a/include/linux/average.h
+++ b/include/linux/average.h
@@ -36,7 +36,7 @@
 		BUILD_BUG_ON_NOT_POWER_OF_2(_factor);			\
 		BUILD_BUG_ON_NOT_POWER_OF_2(_weight);			\
 									\
-		ACCESS_ONCE(e->internal) = internal ?			\
+		ACCESS_ONCE_RW(e->internal) = internal ?		\
 			(((internal << weight) - internal) +		\
 				(val << factor)) >> weight :		\
 			(val << factor);				\
diff --git a/include/linux/binfmts.h b/include/linux/binfmts.h
index 1303b570b..c8196d805 100644
--- a/include/linux/binfmts.h
+++ b/include/linux/binfmts.h
@@ -44,7 +44,7 @@ struct linux_binprm {
 	unsigned interp_flags;
 	unsigned interp_data;
 	unsigned long loader, exec;
-};
+} __randomize_layout;
 
 #define BINPRM_FLAGS_ENFORCE_NONDUMP_BIT 0
 #define BINPRM_FLAGS_ENFORCE_NONDUMP (1 << BINPRM_FLAGS_ENFORCE_NONDUMP_BIT)
@@ -78,8 +78,10 @@ struct linux_binfmt {
 	int (*load_binary)(struct linux_binprm *);
 	int (*load_shlib)(struct file *);
 	int (*core_dump)(struct coredump_params *cprm);
+	void (*handle_mprotect)(struct vm_area_struct *vma, unsigned long newflags);
+	void (*handle_mmap)(struct file *);
 	unsigned long min_coredump;	/* minimal dump size */
-};
+} __do_const __randomize_layout;
 
 extern void __register_binfmt(struct linux_binfmt *fmt, int insert);
 
diff --git a/include/linux/bio.h b/include/linux/bio.h
index 23ddf4b46..9115ce034 100644
--- a/include/linux/bio.h
+++ b/include/linux/bio.h
@@ -354,7 +354,7 @@ static inline void bip_set_seed(struct bio_integrity_payload *bip,
 #endif /* CONFIG_BLK_DEV_INTEGRITY */
 
 extern void bio_trim(struct bio *bio, int offset, int size);
-extern struct bio *bio_split(struct bio *bio, int sectors,
+extern struct bio *bio_split(struct bio *bio, unsigned int sectors,
 			     gfp_t gfp, struct bio_set *bs);
 
 /**
@@ -367,7 +367,7 @@ extern struct bio *bio_split(struct bio *bio, int sectors,
  * Returns a bio representing the next @sectors of @bio - if the bio is smaller
  * than @sectors, returns the original bio unchanged.
  */
-static inline struct bio *bio_next_split(struct bio *bio, int sectors,
+static inline struct bio *bio_next_split(struct bio *bio, unsigned int sectors,
 					 gfp_t gfp, struct bio_set *bs)
 {
 	if (sectors >= bio_sectors(bio))
diff --git a/include/linux/bitmap.h b/include/linux/bitmap.h
index 598bc999f..bb8f339f3 100644
--- a/include/linux/bitmap.h
+++ b/include/linux/bitmap.h
@@ -308,7 +308,7 @@ static inline int bitmap_full(const unsigned long *src, unsigned int nbits)
 	return find_first_zero_bit(src, nbits) == nbits;
 }
 
-static __always_inline int bitmap_weight(const unsigned long *src, unsigned int nbits)
+static __always_inline int __intentional_overflow(-1) bitmap_weight(const unsigned long *src, unsigned int nbits)
 {
 	if (small_const_nbits(nbits))
 		return hweight_long(*src & BITMAP_LAST_WORD_MASK(nbits));
diff --git a/include/linux/bitops.h b/include/linux/bitops.h
index 299e76b59..ef972c1dc 100644
--- a/include/linux/bitops.h
+++ b/include/linux/bitops.h
@@ -75,7 +75,7 @@ static inline int get_count_order(unsigned int count)
 	return order;
 }
 
-static __always_inline unsigned long hweight_long(unsigned long w)
+static __always_inline unsigned long __intentional_overflow(-1) hweight_long(unsigned long w)
 {
 	return sizeof(w) == 4 ? hweight32(w) : hweight64(w);
 }
@@ -105,7 +105,7 @@ static inline __u64 ror64(__u64 word, unsigned int shift)
  * @word: value to rotate
  * @shift: bits to roll
  */
-static inline __u32 rol32(__u32 word, unsigned int shift)
+static inline __u32 __intentional_overflow(-1) rol32(__u32 word, unsigned int shift)
 {
 	return (word << shift) | (word >> ((-shift) & 31));
 }
@@ -115,7 +115,7 @@ static inline __u32 rol32(__u32 word, unsigned int shift)
  * @word: value to rotate
  * @shift: bits to roll
  */
-static inline __u32 ror32(__u32 word, unsigned int shift)
+static inline __u32 __intentional_overflow(-1) ror32(__u32 word, unsigned int shift)
 {
 	return (word >> shift) | (word << (32 - shift));
 }
@@ -184,7 +184,7 @@ static inline __s64 sign_extend64(__u64 value, int index)
 	return (__s64)(value << shift) >> shift;
 }
 
-static inline unsigned fls_long(unsigned long l)
+static inline unsigned __intentional_overflow(-1) fls_long(unsigned long l)
 {
 	if (sizeof(l) == 4)
 		return fls(l);
diff --git a/include/linux/blk-cgroup.h b/include/linux/blk-cgroup.h
index 10648e300..a230bec50 100644
--- a/include/linux/blk-cgroup.h
+++ b/include/linux/blk-cgroup.h
@@ -63,12 +63,12 @@ struct blkcg {
  */
 struct blkg_stat {
 	struct percpu_counter		cpu_cnt;
-	atomic64_t			aux_cnt;
+	atomic64_unchecked_t		aux_cnt;
 };
 
 struct blkg_rwstat {
 	struct percpu_counter		cpu_cnt[BLKG_RWSTAT_NR];
-	atomic64_t			aux_cnt[BLKG_RWSTAT_NR];
+	atomic64_unchecked_t		aux_cnt[BLKG_RWSTAT_NR];
 };
 
 /*
@@ -508,7 +508,7 @@ static inline int blkg_stat_init(struct blkg_stat *stat, gfp_t gfp)
 	if (ret)
 		return ret;
 
-	atomic64_set(&stat->aux_cnt, 0);
+	atomic64_set_unchecked(&stat->aux_cnt, 0);
 	return 0;
 }
 
@@ -546,7 +546,7 @@ static inline uint64_t blkg_stat_read(struct blkg_stat *stat)
 static inline void blkg_stat_reset(struct blkg_stat *stat)
 {
 	percpu_counter_set(&stat->cpu_cnt, 0);
-	atomic64_set(&stat->aux_cnt, 0);
+	atomic64_set_unchecked(&stat->aux_cnt, 0);
 }
 
 /**
@@ -559,7 +559,7 @@ static inline void blkg_stat_reset(struct blkg_stat *stat)
 static inline void blkg_stat_add_aux(struct blkg_stat *to,
 				     struct blkg_stat *from)
 {
-	atomic64_add(blkg_stat_read(from) + atomic64_read(&from->aux_cnt),
+	atomic64_add_unchecked(blkg_stat_read(from) + atomic64_read_unchecked(&from->aux_cnt),
 		     &to->aux_cnt);
 }
 
@@ -574,7 +574,7 @@ static inline int blkg_rwstat_init(struct blkg_rwstat *rwstat, gfp_t gfp)
 				percpu_counter_destroy(&rwstat->cpu_cnt[i]);
 			return ret;
 		}
-		atomic64_set(&rwstat->aux_cnt[i], 0);
+		atomic64_set_unchecked(&rwstat->aux_cnt[i], 0);
 	}
 	return 0;
 }
@@ -629,7 +629,7 @@ static inline struct blkg_rwstat blkg_rwstat_read(struct blkg_rwstat *rwstat)
 	int i;
 
 	for (i = 0; i < BLKG_RWSTAT_NR; i++)
-		atomic64_set(&result.aux_cnt[i],
+		atomic64_set_unchecked(&result.aux_cnt[i],
 			     percpu_counter_sum_positive(&rwstat->cpu_cnt[i]));
 	return result;
 }
@@ -646,8 +646,8 @@ static inline uint64_t blkg_rwstat_total(struct blkg_rwstat *rwstat)
 {
 	struct blkg_rwstat tmp = blkg_rwstat_read(rwstat);
 
-	return atomic64_read(&tmp.aux_cnt[BLKG_RWSTAT_READ]) +
-		atomic64_read(&tmp.aux_cnt[BLKG_RWSTAT_WRITE]);
+	return atomic64_read_unchecked(&tmp.aux_cnt[BLKG_RWSTAT_READ]) +
+		atomic64_read_unchecked(&tmp.aux_cnt[BLKG_RWSTAT_WRITE]);
 }
 
 /**
@@ -660,7 +660,7 @@ static inline void blkg_rwstat_reset(struct blkg_rwstat *rwstat)
 
 	for (i = 0; i < BLKG_RWSTAT_NR; i++) {
 		percpu_counter_set(&rwstat->cpu_cnt[i], 0);
-		atomic64_set(&rwstat->aux_cnt[i], 0);
+		atomic64_set_unchecked(&rwstat->aux_cnt[i], 0);
 	}
 }
 
@@ -678,8 +678,8 @@ static inline void blkg_rwstat_add_aux(struct blkg_rwstat *to,
 	int i;
 
 	for (i = 0; i < BLKG_RWSTAT_NR; i++)
-		atomic64_add(atomic64_read(&v.aux_cnt[i]) +
-			     atomic64_read(&from->aux_cnt[i]),
+		atomic64_add_unchecked(atomic64_read_unchecked(&v.aux_cnt[i]) +
+			     atomic64_read_unchecked(&from->aux_cnt[i]),
 			     &to->aux_cnt[i]);
 }
 
diff --git a/include/linux/blkdev.h b/include/linux/blkdev.h
index e79055c8b..262f1ba45 100644
--- a/include/linux/blkdev.h
+++ b/include/linux/blkdev.h
@@ -1690,7 +1690,7 @@ struct block_device_operations {
 	void (*swap_slot_free_notify) (struct block_device *, unsigned long);
 	struct module *owner;
 	const struct pr_ops *pr_ops;
-};
+} __do_const;
 
 extern int __blkdev_driver_ioctl(struct block_device *, fmode_t, unsigned int,
 				 unsigned long);
diff --git a/include/linux/blktrace_api.h b/include/linux/blktrace_api.h
index cceb72f9e..c9f287a26 100644
--- a/include/linux/blktrace_api.h
+++ b/include/linux/blktrace_api.h
@@ -25,7 +25,7 @@ struct blk_trace {
 	struct dentry *dropped_file;
 	struct dentry *msg_file;
 	struct list_head running_list;
-	atomic_t dropped;
+	atomic_unchecked_t dropped;
 };
 
 extern int blk_trace_ioctl(struct block_device *, unsigned, char __user *);
diff --git a/include/linux/cache.h b/include/linux/cache.h
index 1be04f8c5..9c2d3e2d6 100644
--- a/include/linux/cache.h
+++ b/include/linux/cache.h
@@ -26,6 +26,15 @@
  * after mark_rodata_ro() has been called). These are effectively read-only,
  * but may get written to during init, so can't live in .rodata (via "const").
  */
+#ifdef CONFIG_PAX_KERNEXEC
+# ifdef __ro_after_init
+#  error KERNEXEC requires __read_only
+# endif
+# define __read_only __attribute__((__section__(".data..read_only")))
+#else
+# define __read_only __read_mostly
+#endif
+
 #ifndef __ro_after_init
 #define __ro_after_init __attribute__((__section__(".data..ro_after_init")))
 #endif
diff --git a/include/linux/capability.h b/include/linux/capability.h
index 6ffb67e10..ef1ec2aa0 100644
--- a/include/linux/capability.h
+++ b/include/linux/capability.h
@@ -231,6 +231,10 @@ static inline bool capable(int cap)
 {
 	return true;
 }
+static inline bool capable_nolog(int cap)
+{
+	return true;
+}
 static inline bool ns_capable(struct user_namespace *ns, int cap)
 {
 	return true;
@@ -242,10 +246,14 @@ static inline bool ns_capable_noaudit(struct user_namespace *ns, int cap)
 #endif /* CONFIG_MULTIUSER */
 extern bool privileged_wrt_inode_uidgid(struct user_namespace *ns, const struct inode *inode);
 extern bool capable_wrt_inode_uidgid(const struct inode *inode, int cap);
+extern bool capable_wrt_inode_uidgid_nolog(const struct inode *inode, int cap);
 extern bool file_ns_capable(const struct file *file, struct user_namespace *ns, int cap);
+extern bool capable_nolog(int cap);
 extern bool ptracer_capable(struct task_struct *tsk, struct user_namespace *ns);
 
 /* audit system wants to get cap info from files as well */
 extern int get_vfs_caps_from_disk(const struct dentry *dentry, struct cpu_vfs_cap_data *cpu_caps);
 
+extern int is_privileged_binary(const struct dentry *dentry);
+
 #endif /* !_LINUX_CAPABILITY_H */
diff --git a/include/linux/cdev.h b/include/linux/cdev.h
index f8763615a..7c05fd9dd 100644
--- a/include/linux/cdev.h
+++ b/include/linux/cdev.h
@@ -16,7 +16,7 @@ struct cdev {
 	struct list_head list;
 	dev_t dev;
 	unsigned int count;
-};
+} __randomize_layout;
 
 void cdev_init(struct cdev *, const struct file_operations *);
 
diff --git a/include/linux/cdrom.h b/include/linux/cdrom.h
index 8609d577b..86e4d795e 100644
--- a/include/linux/cdrom.h
+++ b/include/linux/cdrom.h
@@ -87,7 +87,6 @@ struct cdrom_device_ops {
 
 /* driver specifications */
 	const int capability;   /* capability flags */
-	int n_minors;           /* number of active minor devices */
 	/* handle uniform packets for scsi type devices (scsi,atapi) */
 	int (*generic_packet) (struct cdrom_device_info *,
 			       struct packet_command *);
diff --git a/include/linux/cgroup-defs.h b/include/linux/cgroup-defs.h
index 5b17de62c..d75785bc6 100644
--- a/include/linux/cgroup-defs.h
+++ b/include/linux/cgroup-defs.h
@@ -427,7 +427,7 @@ struct cftype {
 #ifdef CONFIG_DEBUG_LOCK_ALLOC
 	struct lock_class_key	lockdep_key;
 #endif
-};
+} __do_const;
 
 /*
  * Control Group subsystem type.
diff --git a/include/linux/cleancache.h b/include/linux/cleancache.h
index fccf7f441..1d5925e99 100644
--- a/include/linux/cleancache.h
+++ b/include/linux/cleancache.h
@@ -35,7 +35,7 @@ struct cleancache_ops {
 	void (*invalidate_page)(int, struct cleancache_filekey, pgoff_t);
 	void (*invalidate_inode)(int, struct cleancache_filekey);
 	void (*invalidate_fs)(int);
-};
+} __no_const;
 
 extern int cleancache_register_ops(const struct cleancache_ops *ops);
 extern void __cleancache_init_fs(struct super_block *);
diff --git a/include/linux/clk-provider.h b/include/linux/clk-provider.h
index a39c0c530..1518828a2 100644
--- a/include/linux/clk-provider.h
+++ b/include/linux/clk-provider.h
@@ -218,6 +218,7 @@ struct clk_ops {
 	void		(*init)(struct clk_hw *hw);
 	int		(*debug_init)(struct clk_hw *hw, struct dentry *dentry);
 };
+typedef struct clk_ops __no_const clk_ops_no_const;
 
 /**
  * struct clk_init_data - holds init data that's common to all clocks and is
diff --git a/include/linux/compat.h b/include/linux/compat.h
index f964ef79e..0679632fc 100644
--- a/include/linux/compat.h
+++ b/include/linux/compat.h
@@ -47,14 +47,15 @@
 	COMPAT_SYSCALL_DEFINEx(6, _##name, __VA_ARGS__)
 
 #define COMPAT_SYSCALL_DEFINEx(x, name, ...)				\
-	asmlinkage long compat_sys##name(__MAP(x,__SC_DECL,__VA_ARGS__))\
-		__attribute__((alias(__stringify(compat_SyS##name))));  \
 	static inline long C_SYSC##name(__MAP(x,__SC_DECL,__VA_ARGS__));\
-	asmlinkage long compat_SyS##name(__MAP(x,__SC_LONG,__VA_ARGS__));\
-	asmlinkage long compat_SyS##name(__MAP(x,__SC_LONG,__VA_ARGS__))\
+	static inline asmlinkage long compat_SyS##name(__MAP(x,__SC_LONG,__VA_ARGS__))\
 	{								\
 		return C_SYSC##name(__MAP(x,__SC_DELOUSE,__VA_ARGS__));	\
 	}								\
+	asmlinkage long compat_sys##name(__MAP(x,__SC_DECL,__VA_ARGS__))\
+	{								\
+		return compat_SyS##name(__MAP(x,__SC_ARGS,__VA_ARGS__));\
+	}								\
 	static inline long C_SYSC##name(__MAP(x,__SC_DECL,__VA_ARGS__))
 
 #ifndef compat_user_stack_pointer
@@ -318,7 +319,7 @@ compat_sys_get_robust_list(int pid, compat_uptr_t __user *head_ptr,
 			   compat_size_t __user *len_ptr);
 
 asmlinkage long compat_sys_ipc(u32, int, int, u32, compat_uptr_t, u32);
-asmlinkage long compat_sys_shmat(int shmid, compat_uptr_t shmaddr, int shmflg);
+asmlinkage long compat_sys_shmat(int shmid, compat_uptr_t shmaddr, int shmflg) __intentional_overflow(0);
 asmlinkage long compat_sys_semctl(int semid, int semnum, int cmd, int arg);
 asmlinkage long compat_sys_msgsnd(int msqid, compat_uptr_t msgp,
 		compat_ssize_t msgsz, int msgflg);
@@ -327,7 +328,7 @@ asmlinkage long compat_sys_msgrcv(int msqid, compat_uptr_t msgp,
 long compat_sys_msgctl(int first, int second, void __user *uptr);
 long compat_sys_shmctl(int first, int second, void __user *uptr);
 long compat_sys_semtimedop(int semid, struct sembuf __user *tsems,
-		unsigned nsems, const struct compat_timespec __user *timeout);
+		compat_long_t nsems, const struct compat_timespec __user *timeout);
 asmlinkage long compat_sys_keyctl(u32 option,
 			      u32 arg2, u32 arg3, u32 arg4, u32 arg5);
 asmlinkage long compat_sys_ustat(unsigned dev, struct compat_ustat __user *u32);
@@ -447,7 +448,7 @@ extern int compat_ptrace_request(struct task_struct *child,
 extern long compat_arch_ptrace(struct task_struct *child, compat_long_t request,
 			       compat_ulong_t addr, compat_ulong_t data);
 asmlinkage long compat_sys_ptrace(compat_long_t request, compat_long_t pid,
-				  compat_long_t addr, compat_long_t data);
+				  compat_ulong_t addr, compat_ulong_t data);
 
 asmlinkage long compat_sys_lookup_dcookie(u32, u32, char __user *, compat_size_t);
 /*
diff --git a/include/linux/compiler-gcc.h b/include/linux/compiler-gcc.h
index 0a0b2d514..3ae2773b0 100644
--- a/include/linux/compiler-gcc.h
+++ b/include/linux/compiler-gcc.h
@@ -116,9 +116,9 @@
  */
 #define __pure			__attribute__((pure))
 #define __aligned(x)		__attribute__((aligned(x)))
-#define __printf(a, b)		__attribute__((format(printf, a, b)))
-#define __scanf(a, b)		__attribute__((format(scanf, a, b)))
-#define __attribute_const__	__attribute__((__const__))
+#define __printf(a, b)		__attribute__((format(printf, a, b))) __nocapture(a, b)
+#define __scanf(a, b)		__attribute__((format(scanf, a, b))) __nocapture(a, b)
+#define __attribute_const__	__attribute__((const))
 #define __maybe_unused		__attribute__((unused))
 #define __always_unused		__attribute__((unused))
 
@@ -185,9 +185,56 @@
 # define __compiletime_warning(message) __attribute__((warning(message)))
 # define __compiletime_error(message) __attribute__((error(message)))
 #endif /* __CHECKER__ */
+
+#define __alloc_size(...)	__attribute((alloc_size(__VA_ARGS__)))
+#define __bos(ptr, arg)		__builtin_object_size((ptr), (arg))
+#define __bos0(ptr)		__bos((ptr), 0)
+#define __bos1(ptr)		__bos((ptr), 1)
 #endif /* GCC_VERSION >= 40300 */
 
 #if GCC_VERSION >= 40500
+
+#ifdef RANDSTRUCT_PLUGIN
+#define __randomize_layout __attribute__((randomize_layout))
+#define __no_randomize_layout __attribute__((no_randomize_layout))
+#endif
+
+#ifdef CONSTIFY_PLUGIN
+#define __no_const __attribute__((no_const))
+#define __do_const __attribute__((do_const))
+#define const_cast(x) (*(typeof((typeof(x))0) *)&(x))
+#endif
+
+#ifdef SIZE_OVERFLOW_PLUGIN
+#define __size_overflow(...) __attribute__((size_overflow(__VA_ARGS__)))
+#define __intentional_overflow(...) __attribute__((intentional_overflow(__VA_ARGS__)))
+#endif
+
+#ifndef __CHECKER__
+#ifdef LATENT_ENTROPY_PLUGIN
+#define __latent_entropy __attribute__((latent_entropy))
+#endif
+#endif
+
+#ifdef INITIFY_PLUGIN
+#define __nocapture(...) __attribute__((nocapture(__VA_ARGS__)))
+#endif
+
+/*
+ * The initify gcc-plugin attempts to identify const arguments that are only
+ * used during init (see __init and __exit), so they can be moved to the
+ * .init.rodata/.exit.rodata section. If an argument is passed to a non-init
+ * function, it must normally be assumed that such an argument has been
+ * captured by that function and may be used in the future when .init/.exit has
+ * been unmapped from memory. In order to identify functions that are confirmed
+ * to not capture their arguments, the __nocapture() attribute is used so that
+ * initify can better identify candidate variables.
+ */
+#ifdef INITIFY_PLUGIN
+#define __nocapture(...) __attribute__((nocapture(__VA_ARGS__)))
+#define __unverified_nocapture(...) __attribute__((unverified_nocapture(__VA_ARGS__)))
+#endif
+
 /*
  * Mark a position in code as unreachable.  This can be used to
  * suppress control flow warnings after asm blocks that transfer
diff --git a/include/linux/compiler.h b/include/linux/compiler.h
index 668569844..688714d7a 100644
--- a/include/linux/compiler.h
+++ b/include/linux/compiler.h
@@ -5,11 +5,14 @@
 
 #ifdef __CHECKER__
 # define __user		__attribute__((noderef, address_space(1)))
+# define __force_user	__force __user
 # define __kernel	__attribute__((address_space(0)))
+# define __force_kernel	__force __kernel
 # define __safe		__attribute__((safe))
 # define __force	__attribute__((force))
 # define __nocast	__attribute__((nocast))
 # define __iomem	__attribute__((noderef, address_space(2)))
+# define __force_iomem	__force __iomem
 # define __must_hold(x)	__attribute__((context(x,1,1)))
 # define __acquires(x)	__attribute__((context(x,0,1)))
 # define __releases(x)	__attribute__((context(x,1,0)))
@@ -17,33 +20,76 @@
 # define __release(x)	__context__(x,-1)
 # define __cond_lock(x,c)	((c) ? ({ __acquire(x); 1; }) : 0)
 # define __percpu	__attribute__((noderef, address_space(3)))
+# define __force_percpu	__force __percpu
 #ifdef CONFIG_SPARSE_RCU_POINTER
 # define __rcu		__attribute__((noderef, address_space(4)))
+# define __force_rcu	__force __rcu
 #else /* CONFIG_SPARSE_RCU_POINTER */
 # define __rcu
+# define __force_rcu
 #endif /* CONFIG_SPARSE_RCU_POINTER */
 # define __private	__attribute__((noderef))
 extern void __chk_user_ptr(const volatile void __user *);
 extern void __chk_io_ptr(const volatile void __iomem *);
 # define ACCESS_PRIVATE(p, member) (*((typeof((p)->member) __force *) &(p)->member))
 #else /* __CHECKER__ */
-# define __user
-# define __kernel
+# ifdef CHECKER_PLUGIN
+#  ifdef CHECKER_PLUGIN_USER
+//#  define __user
+//#  define __force_user
+//#  define __kernel
+//#  define __force_kernel
+#  else
+#  define __user
+#  define __force_user
+#  define __kernel
+#  define __force_kernel
+#  endif
+#  ifdef CHECKER_PLUGIN_CONTEXT
+#  define __must_hold(x)	__attribute__((context(#x,1,1)))
+#  define __acquires(x)	__attribute__((context(#x,0,1)))
+#  define __releases(x)	__attribute__((context(#x,1,0)))
+#  define __acquire(x)	__context__(#x,1)
+#  define __release(x)	__context__(#x,-1)
+#  define __cond_lock(x,c)	((c) ? ({ __acquire(x); 1; }) : 0)
+#  define __cond_unlock(x,c)	((c) ? ({ __release(x); 1; }) : 0)
+#  else
+#  define __must_hold(x)
+#  define __acquires(x)
+#  define __releases(x)
+#  define __acquire(x) (void)0
+#  define __release(x) (void)0
+#  define __cond_lock(x,c) (c)
+#  define __cond_unlock(x,c) (c)
+#  endif
+# else
+#  ifdef STRUCTLEAK_PLUGIN
+#   define __user __attribute__((user))
+#  else
+#   define __user
+#  endif
+#  define __force_user
+#  define __kernel
+#  define __force_kernel
+#  define __must_hold(x)
+#  define __acquires(x)
+#  define __releases(x)
+#  define __acquire(x) (void)0
+#  define __release(x) (void)0
+#  define __cond_lock(x,c) (c)
+# endif
 # define __safe
 # define __force
 # define __nocast
 # define __iomem
+# define __force_iomem
 # define __chk_user_ptr(x) (void)0
 # define __chk_io_ptr(x) (void)0
 # define __builtin_warning(x, y...) (1)
-# define __must_hold(x)
-# define __acquires(x)
-# define __releases(x)
-# define __acquire(x) (void)0
-# define __release(x) (void)0
-# define __cond_lock(x,c) (c)
 # define __percpu
+# define __force_percpu
 # define __rcu
+# define __force_rcu
 # define __private
 # define ACCESS_PRIVATE(p, member) ((p)->member)
 #endif /* __CHECKER__ */
@@ -200,29 +246,20 @@ void ftrace_likely_update(struct ftrace_branch_data *f, int val, int expect);
 
 #include <uapi/linux/types.h>
 
-#define __READ_ONCE_SIZE						\
-({									\
-	switch (size) {							\
-	case 1: *(__u8 *)res = *(volatile __u8 *)p; break;		\
-	case 2: *(__u16 *)res = *(volatile __u16 *)p; break;		\
-	case 4: *(__u32 *)res = *(volatile __u32 *)p; break;		\
-	case 8: *(__u64 *)res = *(volatile __u64 *)p; break;		\
-	default:							\
-		barrier();						\
-		__builtin_memcpy((void *)res, (const void *)p, size);	\
-		barrier();						\
-	}								\
+#ifdef CONFIG_KASAN
+/*
+ * Use READ_ONCE_NOCHECK() instead of READ_ONCE() if you need
+ * to hide memory access from KASAN.
+ */
+#define READ_ONCE_NOCHECK(x)					\
+({								\
+	union { typeof(x) __val; char __c[sizeof(x)]; } __u;	\
+	__read_once_size_nocheck(&(x), __u.__c, sizeof(x));	\
+	__u.__val;						\
 })
 
-static __always_inline
-void __read_once_size(const volatile void *p, void *res, int size)
-{
-	__READ_ONCE_SIZE;
-}
-
-#ifdef CONFIG_KASAN
 /*
- * This function is not 'inline' because __no_sanitize_address confilcts
+ * This function is not 'inline' because __no_sanitize_address conflicts
  * with inlining. Attempt to inline it may cause a build failure.
  * 	https://gcc.gnu.org/bugzilla/show_bug.cgi?id=67368
  * '__maybe_unused' allows us to avoid defined-but-not-used warnings.
@@ -230,29 +267,20 @@ void __read_once_size(const volatile void *p, void *res, int size)
 static __no_sanitize_address __maybe_unused
 void __read_once_size_nocheck(const volatile void *p, void *res, int size)
 {
-	__READ_ONCE_SIZE;
-}
-#else
-static __always_inline
-void __read_once_size_nocheck(const volatile void *p, void *res, int size)
-{
-	__READ_ONCE_SIZE;
-}
-#endif
-
-static __always_inline void __write_once_size(volatile void *p, void *res, int size)
-{
 	switch (size) {
-	case 1: *(volatile __u8 *)p = *(__u8 *)res; break;
-	case 2: *(volatile __u16 *)p = *(__u16 *)res; break;
-	case 4: *(volatile __u32 *)p = *(__u32 *)res; break;
-	case 8: *(volatile __u64 *)p = *(__u64 *)res; break;
+	case 1: *(__u8 *)res = *(const volatile __u8 *)p; break;
+	case 2: *(__u16 *)res = *(const volatile __u16 *)p; break;
+	case 4: *(__u32 *)res = *(const volatile __u32 *)p; break;
+	case 8: *(__u64 *)res = *(const volatile __u64 *)p; break;
 	default:
 		barrier();
-		__builtin_memcpy((void *)p, (const void *)res, size);
+		__builtin_memcpy(res, (const void *)p, size);
 		barrier();
 	}
 }
+#else
+#define READ_ONCE_NOCHECK(x) READ_ONCE(x)
+#endif
 
 /*
  * Prevent the compiler from merging or refetching reads or writes. The
@@ -277,29 +305,15 @@ static __always_inline void __write_once_size(volatile void *p, void *res, int s
  * required ordering.
  */
 
-#define __READ_ONCE(x, check)						\
-({									\
-	union { typeof(x) __val; char __c[1]; } __u;			\
-	if (check)							\
-		__read_once_size(&(x), __u.__c, sizeof(x));		\
-	else								\
-		__read_once_size_nocheck(&(x), __u.__c, sizeof(x));	\
-	__u.__val;							\
+#define READ_ONCE(x) ({					\
+	typeof(x) __val = *(volatile typeof(x) *)&(x);	\
+	__val;						\
 })
-#define READ_ONCE(x) __READ_ONCE(x, 1)
 
-/*
- * Use READ_ONCE_NOCHECK() instead of READ_ONCE() if you need
- * to hide memory access from KASAN.
- */
-#define READ_ONCE_NOCHECK(x) __READ_ONCE(x, 0)
-
-#define WRITE_ONCE(x, val) \
-({							\
-	union { typeof(x) __val; char __c[1]; } __u =	\
-		{ .__val = (__force typeof(x)) (val) }; \
-	__write_once_size(&(x), __u.__c, sizeof(x));	\
-	__u.__val;					\
+#define WRITE_ONCE(x, val) ({				\
+	typeof(x) __val = (val);			\
+	(x) = *(volatile typeof(x) *)&__val;		\
+	__val;						\
 })
 
 #endif /* __KERNEL__ */
@@ -406,6 +420,50 @@ static __always_inline void __write_once_size(volatile void *p, void *res, int s
 # define __attribute_const__	/* unimplemented */
 #endif
 
+#ifndef __randomize_layout
+# define __randomize_layout
+#endif
+
+#ifndef __no_randomize_layout
+# define __no_randomize_layout
+#endif
+
+#ifndef __no_const
+# define __no_const
+#endif
+
+#ifndef __do_const
+# define __do_const
+#endif
+
+#ifndef __size_overflow
+# define __size_overflow(...)
+#endif
+
+#ifndef __intentional_overflow
+# define __intentional_overflow(...)
+#endif
+
+#ifndef __latent_entropy
+# define __latent_entropy
+#endif
+
+#ifndef __nocapture
+# define __nocapture(...)
+#endif
+
+#ifndef const_cast
+# define const_cast(x)	(x)
+#endif
+
+#ifndef __nocapture
+# define __nocapture(...)
+#endif
+
+#ifndef __unverified_nocapture
+# define __unverified_nocapture(...)
+#endif
+
 /*
  * Tell gcc if a function is cold. The compiler will assume any path
  * directly leading to the call is unlikely.
@@ -415,6 +473,22 @@ static __always_inline void __write_once_size(volatile void *p, void *res, int s
 #define __cold
 #endif
 
+#ifndef __alloc_size
+#define __alloc_size(...)
+#endif
+
+#ifndef __bos
+#define __bos(ptr, arg)
+#endif
+
+#ifndef __bos0
+#define __bos0(ptr)
+#endif
+
+#ifndef __bos1
+#define __bos1(ptr)
+#endif
+
 /* Simple shorthand for a section definition */
 #ifndef __section
 # define __section(S) __attribute__ ((__section__(#S)))
@@ -437,6 +511,8 @@ static __always_inline void __write_once_size(volatile void *p, void *res, int s
 # define __same_type(a, b) __builtin_types_compatible_p(typeof(a), typeof(b))
 #endif
 
+#define __type_is_unsigned(t) (__same_type((t)0, 0UL) || __same_type((t)0, 0U) || __same_type((t)0, (unsigned short)0) || __same_type((t)0, (unsigned char)0))
+
 /* Is this type a native word size -- useful for atomic operations */
 #ifndef __native_word
 # define __native_word(t) (sizeof(t) == sizeof(char) || sizeof(t) == sizeof(short) || sizeof(t) == sizeof(int) || sizeof(t) == sizeof(long))
@@ -516,8 +592,9 @@ static __always_inline void __write_once_size(volatile void *p, void *res, int s
  */
 #define __ACCESS_ONCE(x) ({ \
 	 __maybe_unused typeof(x) __var = (__force typeof(x)) 0; \
-	(volatile typeof(x) *)&(x); })
+	(volatile const typeof(x) *)&(x); })
 #define ACCESS_ONCE(x) (*__ACCESS_ONCE(x))
+#define ACCESS_ONCE_RW(x) (*(volatile typeof(x) *)&(x))
 
 /**
  * lockless_dereference() - safely load a pointer for later dereference
diff --git a/include/linux/configfs.h b/include/linux/configfs.h
index d9d6a9d77..489772cc1 100644
--- a/include/linux/configfs.h
+++ b/include/linux/configfs.h
@@ -136,7 +136,7 @@ struct configfs_attribute {
 	umode_t			ca_mode;
 	ssize_t (*show)(struct config_item *, char *);
 	ssize_t (*store)(struct config_item *, const char *, size_t);
-};
+} __do_const;
 
 #define CONFIGFS_ATTR(_pfx, _name)			\
 static struct configfs_attribute _pfx##attr_##_name = {	\
diff --git a/include/linux/cpufreq.h b/include/linux/cpufreq.h
index 32dc0cbd5..6e1858349 100644
--- a/include/linux/cpufreq.h
+++ b/include/linux/cpufreq.h
@@ -237,10 +237,11 @@ __ATTR(_name, 0644, show_##_name, store_##_name)
 struct global_attr {
 	struct attribute attr;
 	ssize_t (*show)(struct kobject *kobj,
-			struct attribute *attr, char *buf);
-	ssize_t (*store)(struct kobject *a, struct attribute *b,
+			struct kobj_attribute *attr, char *buf);
+	ssize_t (*store)(struct kobject *a, struct kobj_attribute *b,
 			 const char *c, size_t count);
 };
+typedef struct global_attr __no_const global_attr_no_const;
 
 #define define_one_global_ro(_name)		\
 static struct global_attr _name =		\
@@ -323,7 +324,7 @@ struct cpufreq_driver {
 	/* platform specific boost support code */
 	bool		boost_enabled;
 	int		(*set_boost)(int state);
-};
+} __do_const;
 
 /* flags */
 #define CPUFREQ_STICKY		(1 << 0)	/* driver isn't removed even if
diff --git a/include/linux/cpuidle.h b/include/linux/cpuidle.h
index bb31373c3..e85eb5fb0 100644
--- a/include/linux/cpuidle.h
+++ b/include/linux/cpuidle.h
@@ -59,7 +59,8 @@ struct cpuidle_state {
 	void (*enter_freeze) (struct cpuidle_device *dev,
 			      struct cpuidle_driver *drv,
 			      int index);
-};
+} __do_const;
+typedef struct cpuidle_state __no_const cpuidle_state_no_const;
 
 /* Idle State Flags */
 #define CPUIDLE_FLAG_COUPLED	(0x02) /* state applies to multiple cpus */
@@ -237,7 +238,7 @@ struct cpuidle_governor {
 	void (*reflect)		(struct cpuidle_device *dev, int index);
 
 	struct module 		*owner;
-};
+} __do_const;
 
 #ifdef CONFIG_CPU_IDLE
 extern int cpuidle_register_governor(struct cpuidle_governor *gov);
diff --git a/include/linux/cpumask.h b/include/linux/cpumask.h
index da7fbf1cd..c2a221b6c 100644
--- a/include/linux/cpumask.h
+++ b/include/linux/cpumask.h
@@ -131,17 +131,17 @@ static inline unsigned int cpumask_first(const struct cpumask *srcp)
 }
 
 /* Valid inputs for n are -1 and 0. */
-static inline unsigned int cpumask_next(int n, const struct cpumask *srcp)
+static inline unsigned int __intentional_overflow(-1) cpumask_next(int n, const struct cpumask *srcp)
 {
 	return n+1;
 }
 
-static inline unsigned int cpumask_next_zero(int n, const struct cpumask *srcp)
+static inline unsigned int __intentional_overflow(-1) cpumask_next_zero(int n, const struct cpumask *srcp)
 {
 	return n+1;
 }
 
-static inline unsigned int cpumask_next_and(int n,
+static inline unsigned int __intentional_overflow(-1) cpumask_next_and(int n,
 					    const struct cpumask *srcp,
 					    const struct cpumask *andp)
 {
@@ -185,7 +185,7 @@ static inline unsigned int cpumask_first(const struct cpumask *srcp)
  *
  * Returns >= nr_cpu_ids if no further cpus set.
  */
-static inline unsigned int cpumask_next(int n, const struct cpumask *srcp)
+static inline unsigned int __intentional_overflow(-1) cpumask_next(int n, const struct cpumask *srcp)
 {
 	/* -1 is a legal arg here. */
 	if (n != -1)
@@ -200,7 +200,7 @@ static inline unsigned int cpumask_next(int n, const struct cpumask *srcp)
  *
  * Returns >= nr_cpu_ids if no further cpus unset.
  */
-static inline unsigned int cpumask_next_zero(int n, const struct cpumask *srcp)
+static inline unsigned int __intentional_overflow(-1) cpumask_next_zero(int n, const struct cpumask *srcp)
 {
 	/* -1 is a legal arg here. */
 	if (n != -1)
@@ -208,7 +208,7 @@ static inline unsigned int cpumask_next_zero(int n, const struct cpumask *srcp)
 	return find_next_zero_bit(cpumask_bits(srcp), nr_cpumask_bits, n+1);
 }
 
-int cpumask_next_and(int n, const struct cpumask *, const struct cpumask *);
+int cpumask_next_and(int n, const struct cpumask *, const struct cpumask *) __intentional_overflow(-1);
 int cpumask_any_but(const struct cpumask *mask, unsigned int cpu);
 unsigned int cpumask_local_spread(unsigned int i, int node);
 
@@ -475,7 +475,7 @@ static inline bool cpumask_full(const struct cpumask *srcp)
  * cpumask_weight - Count of bits in *srcp
  * @srcp: the cpumask to count bits (< nr_cpu_ids) in.
  */
-static inline unsigned int cpumask_weight(const struct cpumask *srcp)
+static inline unsigned int __intentional_overflow(-1) cpumask_weight(const struct cpumask *srcp)
 {
 	return bitmap_weight(cpumask_bits(srcp), nr_cpumask_bits);
 }
diff --git a/include/linux/cred.h b/include/linux/cred.h
index 257db6456..a73cf86c5 100644
--- a/include/linux/cred.h
+++ b/include/linux/cred.h
@@ -35,7 +35,7 @@ struct group_info {
 	int		nblocks;
 	kgid_t		small_block[NGROUPS_SMALL];
 	kgid_t		*blocks[0];
-};
+} __randomize_layout;
 
 /**
  * get_group_info - Get a reference to a group info structure
@@ -153,7 +153,7 @@ struct cred {
 	struct user_namespace *user_ns; /* user_ns the caps and keyrings are relative to. */
 	struct group_info *group_info;	/* supplementary groups for euid/fsgid */
 	struct rcu_head	rcu;		/* RCU deletion hook */
-};
+} __randomize_layout;
 
 extern void __put_cred(struct cred *);
 extern void exit_creds(struct task_struct *);
@@ -211,6 +211,9 @@ static inline void validate_creds_for_do_exit(struct task_struct *tsk)
 static inline void validate_process_creds(void)
 {
 }
+static inline void validate_task_creds(struct task_struct *task)
+{
+}
 #endif
 
 static inline bool cap_ambient_invariant_ok(const struct cred *cred)
@@ -355,6 +358,7 @@ static inline void put_cred(const struct cred *_cred)
 
 #define task_uid(task)		(task_cred_xxx((task), uid))
 #define task_euid(task)		(task_cred_xxx((task), euid))
+#define task_securebits(task)	(task_cred_xxx((task), securebits))
 
 #define current_cred_xxx(xxx)			\
 ({						\
diff --git a/include/linux/crypto.h b/include/linux/crypto.h
index 7cee55516..65ead504d 100644
--- a/include/linux/crypto.h
+++ b/include/linux/crypto.h
@@ -510,7 +510,7 @@ struct cipher_tfm {
 	                  const u8 *key, unsigned int keylen);
 	void (*cit_encrypt_one)(struct crypto_tfm *tfm, u8 *dst, const u8 *src);
 	void (*cit_decrypt_one)(struct crypto_tfm *tfm, u8 *dst, const u8 *src);
-};
+} __no_const;
 
 struct compress_tfm {
 	int (*cot_compress)(struct crypto_tfm *tfm,
@@ -519,7 +519,7 @@ struct compress_tfm {
 	int (*cot_decompress)(struct crypto_tfm *tfm,
 	                      const u8 *src, unsigned int slen,
 	                      u8 *dst, unsigned int *dlen);
-};
+} __no_const;
 
 #define crt_ablkcipher	crt_u.ablkcipher
 #define crt_blkcipher	crt_u.blkcipher
diff --git a/include/linux/ctype.h b/include/linux/ctype.h
index 653589e3e..4ef254a8f 100644
--- a/include/linux/ctype.h
+++ b/include/linux/ctype.h
@@ -56,7 +56,7 @@ static inline unsigned char __toupper(unsigned char c)
  * Fast implementation of tolower() for internal usage. Do not use in your
  * code.
  */
-static inline char _tolower(const char c)
+static inline unsigned char _tolower(const unsigned char c)
 {
 	return c | 0x20;
 }
diff --git a/include/linux/dcache.h b/include/linux/dcache.h
index 5ff3e9a4f..fc6b87281 100644
--- a/include/linux/dcache.h
+++ b/include/linux/dcache.h
@@ -102,6 +102,9 @@ struct dentry {
 		struct list_head d_lru;		/* LRU list */
 		wait_queue_head_t *d_wait;	/* in-lookup ones only */
 	};
+#ifdef CONFIG_GRKERNSEC_CHROOT_RENAME
+	atomic_t chroot_refcnt;		/* tracks use of directory in chroot */
+#endif
 	struct list_head d_child;	/* child of parent list */
 	struct list_head d_subdirs;	/* our children */
 	/*
@@ -112,7 +115,7 @@ struct dentry {
 		struct hlist_bl_node d_in_lookup_hash;	/* only for in-lookup ones */
 	 	struct rcu_head d_rcu;
 	} d_u;
-};
+} __randomize_layout;
 
 /*
  * dentry->d_lock spinlock nesting subclasses:
@@ -279,7 +282,7 @@ extern struct dentry *__d_lookup_rcu(const struct dentry *parent,
 
 static inline unsigned d_count(const struct dentry *dentry)
 {
-	return dentry->d_lockref.count;
+	return __lockref_read(&dentry->d_lockref);
 }
 
 /*
@@ -308,7 +311,7 @@ extern char *dentry_path(struct dentry *, char *, int);
 static inline struct dentry *dget_dlock(struct dentry *dentry)
 {
 	if (dentry)
-		dentry->d_lockref.count++;
+		__lockref_inc(&dentry->d_lockref);
 	return dentry;
 }
 
diff --git a/include/linux/debugfs.h b/include/linux/debugfs.h
index 4d3f0d1ae..7713e0a19 100644
--- a/include/linux/debugfs.h
+++ b/include/linux/debugfs.h
@@ -139,6 +139,8 @@ struct dentry *debugfs_create_size_t(const char *name, umode_t mode,
 				     struct dentry *parent, size_t *value);
 struct dentry *debugfs_create_atomic_t(const char *name, umode_t mode,
 				     struct dentry *parent, atomic_t *value);
+struct dentry *debugfs_create_atomic_unchecked_t(const char *name, umode_t mode,
+				     struct dentry *parent, atomic_unchecked_t *value);
 struct dentry *debugfs_create_bool(const char *name, umode_t mode,
 				  struct dentry *parent, bool *value);
 
@@ -234,7 +236,7 @@ static inline void debugfs_use_file_finish(int srcu_idx)
 { }
 
 #define DEFINE_DEBUGFS_ATTRIBUTE(__fops, __get, __set, __fmt)	\
-	static const struct file_operations __fops = { 0 }
+	static const struct file_operations __fops = { }
 
 static inline struct dentry *debugfs_rename(struct dentry *old_dir, struct dentry *old_dentry,
                 struct dentry *new_dir, char *new_name)
@@ -311,6 +313,12 @@ static inline struct dentry *debugfs_create_atomic_t(const char *name, umode_t m
 	return ERR_PTR(-ENODEV);
 }
 
+static inline struct dentry *debugfs_create_atomic_unchecked_t(const char *name, umode_t mode,
+				     struct dentry *parent, atomic_unchecked_t *value)
+{
+	return ERR_PTR(-ENODEV);
+}
+
 static inline struct dentry *debugfs_create_bool(const char *name, umode_t mode,
 						 struct dentry *parent,
 						 bool *value)
diff --git a/include/linux/decompress/mm.h b/include/linux/decompress/mm.h
index 7925bf0ee..d5143d2fb 100644
--- a/include/linux/decompress/mm.h
+++ b/include/linux/decompress/mm.h
@@ -77,7 +77,7 @@ static void free(void *where)
  * warnings when not needed (indeed large_malloc / large_free are not
  * needed by inflate */
 
-#define malloc(a) kmalloc(a, GFP_KERNEL)
+#define malloc(a) kmalloc((a), GFP_KERNEL)
 #define free(a) kfree(a)
 
 #define large_malloc(a) vmalloc(a)
diff --git a/include/linux/devfreq.h b/include/linux/devfreq.h
index 2de4e2eea..510a09b85 100644
--- a/include/linux/devfreq.h
+++ b/include/linux/devfreq.h
@@ -124,7 +124,7 @@ struct devfreq_governor {
 	int (*get_target_freq)(struct devfreq *this, unsigned long *freq);
 	int (*event_handler)(struct devfreq *devfreq,
 				unsigned int event, void *data);
-};
+} __do_const;
 
 /**
  * struct devfreq - Device devfreq structure
diff --git a/include/linux/device.h b/include/linux/device.h
index 38f02814d..72e7b7016 100644
--- a/include/linux/device.h
+++ b/include/linux/device.h
@@ -346,7 +346,7 @@ struct subsys_interface {
 	struct list_head node;
 	int (*add_dev)(struct device *dev, struct subsys_interface *sif);
 	void (*remove_dev)(struct device *dev, struct subsys_interface *sif);
-};
+} __do_const;
 
 int subsys_interface_register(struct subsys_interface *sif);
 void subsys_interface_unregister(struct subsys_interface *sif);
@@ -542,7 +542,7 @@ struct device_type {
 	void (*release)(struct device *dev);
 
 	const struct dev_pm_ops *pm;
-};
+} __do_const;
 
 /* interface for exporting device attributes */
 struct device_attribute {
@@ -552,11 +552,12 @@ struct device_attribute {
 	ssize_t (*store)(struct device *dev, struct device_attribute *attr,
 			 const char *buf, size_t count);
 };
+typedef struct device_attribute __no_const device_attribute_no_const;
 
 struct dev_ext_attribute {
 	struct device_attribute attr;
 	void *var;
-};
+} __do_const;
 
 ssize_t device_show_ulong(struct device *dev, struct device_attribute *attr,
 			  char *buf);
diff --git a/include/linux/dma-mapping.h b/include/linux/dma-mapping.h
index dc69df04a..d8db6b808 100644
--- a/include/linux/dma-mapping.h
+++ b/include/linux/dma-mapping.h
@@ -114,7 +114,7 @@ struct dma_map_ops {
 	u64 (*get_required_mask)(struct device *dev);
 #endif
 	int is_phys;
-};
+} __do_const;
 
 extern struct dma_map_ops dma_noop_ops;
 
diff --git a/include/linux/efi.h b/include/linux/efi.h
index 0148a3046..6f9e49470 100644
--- a/include/linux/efi.h
+++ b/include/linux/efi.h
@@ -1134,6 +1134,7 @@ struct efivar_operations {
 	efi_set_variable_t *set_variable_nonblocking;
 	efi_query_variable_store_t *query_variable_store;
 };
+typedef struct efivar_operations __no_const efivar_operations_no_const;
 
 struct efivars {
 	/*
diff --git a/include/linux/elf.h b/include/linux/elf.h
index 20fa8d8ae..3d0dd189a 100644
--- a/include/linux/elf.h
+++ b/include/linux/elf.h
@@ -29,6 +29,7 @@ extern Elf32_Dyn _DYNAMIC [];
 #define elf_note	elf32_note
 #define elf_addr_t	Elf32_Off
 #define Elf_Half	Elf32_Half
+#define elf_dyn		Elf32_Dyn
 
 #else
 
@@ -39,6 +40,7 @@ extern Elf64_Dyn _DYNAMIC [];
 #define elf_note	elf64_note
 #define elf_addr_t	Elf64_Off
 #define Elf_Half	Elf64_Half
+#define elf_dyn		Elf64_Dyn
 
 #endif
 
diff --git a/include/linux/err.h b/include/linux/err.h
index 1e3558845..ce9721b12 100644
--- a/include/linux/err.h
+++ b/include/linux/err.h
@@ -20,12 +20,12 @@
 
 #define IS_ERR_VALUE(x) unlikely((unsigned long)(void *)(x) >= (unsigned long)-MAX_ERRNO)
 
-static inline void * __must_check ERR_PTR(long error)
+static inline void * __must_check __intentional_overflow(-1) ERR_PTR(long error)
 {
 	return (void *) error;
 }
 
-static inline long __must_check PTR_ERR(__force const void *ptr)
+static inline long __must_check __intentional_overflow(-1) PTR_ERR(__force const void *ptr)
 {
 	return (long) ptr;
 }
diff --git a/include/linux/ethtool.h b/include/linux/ethtool.h
index 9ded8c6d8..e11a24571 100644
--- a/include/linux/ethtool.h
+++ b/include/linux/ethtool.h
@@ -373,4 +373,5 @@ struct ethtool_ops {
 	int	(*set_link_ksettings)(struct net_device *,
 				      const struct ethtool_link_ksettings *);
 };
+typedef struct ethtool_ops __no_const ethtool_ops_no_const;
 #endif /* _LINUX_ETHTOOL_H */
diff --git a/include/linux/extcon.h b/include/linux/extcon.h
index 61004413d..15b9e728e 100644
--- a/include/linux/extcon.h
+++ b/include/linux/extcon.h
@@ -123,7 +123,7 @@ struct extcon_dev {
 	/* /sys/class/extcon/.../mutually_exclusive/... */
 	struct attribute_group attr_g_muex;
 	struct attribute **attrs_muex;
-	struct device_attribute *d_attrs_muex;
+	device_attribute_no_const *d_attrs_muex;
 };
 
 #if IS_ENABLED(CONFIG_EXTCON)
diff --git a/include/linux/fb.h b/include/linux/fb.h
index a964d076b..09bf71f03 100644
--- a/include/linux/fb.h
+++ b/include/linux/fb.h
@@ -320,7 +320,8 @@ struct fb_ops {
 	/* called at KDB enter and leave time to prepare the console */
 	int (*fb_debug_enter)(struct fb_info *info);
 	int (*fb_debug_leave)(struct fb_info *info);
-};
+} __do_const;
+typedef struct fb_ops __no_const fb_ops_no_const;
 
 #ifdef CONFIG_FB_TILEBLITTING
 #define FB_TILE_CURSOR_NONE        0
diff --git a/include/linux/fdtable.h b/include/linux/fdtable.h
index 5295535b6..9852c7e33 100644
--- a/include/linux/fdtable.h
+++ b/include/linux/fdtable.h
@@ -105,7 +105,7 @@ struct files_struct *get_files_struct(struct task_struct *);
 void put_files_struct(struct files_struct *fs);
 void reset_files_struct(struct files_struct *);
 int unshare_files(struct files_struct **);
-struct files_struct *dup_fd(struct files_struct *, int *);
+struct files_struct *dup_fd(struct files_struct *, int *) __latent_entropy;
 void do_close_on_exec(struct files_struct *);
 int iterate_fd(struct files_struct *, unsigned,
 		int (*)(const void *, struct file *, unsigned),
diff --git a/include/linux/firewire.h b/include/linux/firewire.h
index d4b7683c7..9feb06672 100644
--- a/include/linux/firewire.h
+++ b/include/linux/firewire.h
@@ -451,7 +451,7 @@ struct fw_iso_context {
 
 struct fw_iso_context *fw_iso_context_create(struct fw_card *card,
 		int type, int channel, int speed, size_t header_size,
-		fw_iso_callback_t callback, void *callback_data);
+		void *callback, void *callback_data);
 int fw_iso_context_set_channels(struct fw_iso_context *ctx, u64 *channels);
 int fw_iso_context_queue(struct fw_iso_context *ctx,
 			 struct fw_iso_packet *packet,
diff --git a/include/linux/fs.h b/include/linux/fs.h
index 7c391366f..69c438a01 100644
--- a/include/linux/fs.h
+++ b/include/linux/fs.h
@@ -328,7 +328,7 @@ struct kiocb {
 	void (*ki_complete)(struct kiocb *iocb, long ret, long ret2);
 	void			*private;
 	int			ki_flags;
-};
+} __randomize_layout;
 
 static inline bool is_sync_kiocb(struct kiocb *kiocb)
 {
@@ -444,7 +444,7 @@ struct address_space {
 	spinlock_t		private_lock;	/* for use by the address_space */
 	struct list_head	private_list;	/* ditto */
 	void			*private_data;	/* ditto */
-} __attribute__((aligned(sizeof(long))));
+} __attribute__((aligned(sizeof(long)))) __randomize_layout;
 	/*
 	 * On most architectures that alignment is already the case; but
 	 * must be enforced here for CRIS, to let the least significant bit
@@ -486,7 +486,7 @@ struct block_device {
 	int			bd_fsfreeze_count;
 	/* Mutex for freeze */
 	struct mutex		bd_fsfreeze_mutex;
-};
+} __randomize_layout;
 
 /*
  * Radix-tree tags, for tagging dirty and writeback pages within the pagecache
@@ -700,7 +700,7 @@ struct inode {
 #endif
 
 	void			*i_private; /* fs or device private pointer */
-};
+} __randomize_layout;
 
 static inline int inode_unhashed(struct inode *inode)
 {
@@ -910,7 +910,7 @@ struct file {
 	struct list_head	f_tfile_llink;
 #endif /* #ifdef CONFIG_EPOLL */
 	struct address_space	*f_mapping;
-} __attribute__((aligned(4)));	/* lest something weird decides that 2 is OK */
+} __attribute__((aligned(4))) __randomize_layout;	/* lest something weird decides that 2 is OK */
 
 struct file_handle {
 	__u32 handle_bytes;
@@ -1045,7 +1045,7 @@ struct file_lock {
 			int state;		/* state of grant or error if -ve */
 		} afs;
 	} fl_u;
-};
+} __randomize_layout;
 
 struct file_lock_context {
 	spinlock_t		flc_lock;
@@ -1432,7 +1432,7 @@ struct super_block {
 
 	spinlock_t		s_inode_wblist_lock;
 	struct list_head	s_inodes_wb;	/* writeback inodes */
-};
+} __randomize_layout;
 
 /* Helper functions so that in most cases filesystems will
  * not need to deal directly with kuid_t and kgid_t and can
@@ -1716,7 +1716,8 @@ struct file_operations {
 			u64);
 	ssize_t (*dedupe_file_range)(struct file *, u64, u64, struct file *,
 			u64);
-};
+} __do_const __randomize_layout;
+typedef struct file_operations __no_const file_operations_no_const;
 
 struct inode_operations {
 	struct dentry * (*lookup) (struct inode *,struct dentry *, unsigned int);
@@ -2440,12 +2441,12 @@ static inline void bd_unlink_disk_holder(struct block_device *bdev,
 #define CHRDEV_MAJOR_HASH_SIZE	255
 /* Marks the bottom of the first segment of free char majors */
 #define CHRDEV_MAJOR_DYN_END 234
-extern int alloc_chrdev_region(dev_t *, unsigned, unsigned, const char *);
+extern __nocapture(4) int alloc_chrdev_region(dev_t *, unsigned, unsigned, const char *);
 extern int register_chrdev_region(dev_t, unsigned, const char *);
 extern int __register_chrdev(unsigned int major, unsigned int baseminor,
 			     unsigned int count, const char *name,
 			     const struct file_operations *fops);
-extern void __unregister_chrdev(unsigned int major, unsigned int baseminor,
+extern __nocapture(4) void __unregister_chrdev(unsigned int major, unsigned int baseminor,
 				unsigned int count, const char *name);
 extern void unregister_chrdev_region(dev_t, unsigned);
 extern void chrdev_show(struct seq_file *,off_t);
@@ -3193,4 +3194,14 @@ static inline bool dir_relax_shared(struct inode *inode)
 extern bool path_noexec(const struct path *path);
 extern void inode_nohighmem(struct inode *inode);
 
+static inline bool is_sidechannel_device(const struct inode *inode)
+{
+#ifdef CONFIG_GRKERNSEC_DEVICE_SIDECHANNEL
+	umode_t mode = inode->i_mode;
+	return ((S_ISCHR(mode) || S_ISBLK(mode)) && (mode & (S_IROTH | S_IWOTH)));
+#else
+	return false;
+#endif
+}
+
 #endif /* _LINUX_FS_H */
diff --git a/include/linux/fs_struct.h b/include/linux/fs_struct.h
index 0efc3e628..fd236105c 100644
--- a/include/linux/fs_struct.h
+++ b/include/linux/fs_struct.h
@@ -6,13 +6,13 @@
 #include <linux/seqlock.h>
 
 struct fs_struct {
-	int users;
+	atomic_t users;
 	spinlock_t lock;
 	seqcount_t seq;
 	int umask;
 	int in_exec;
 	struct path root, pwd;
-};
+} __randomize_layout;
 
 extern struct kmem_cache *fs_cachep;
 
diff --git a/include/linux/fscache-cache.h b/include/linux/fscache-cache.h
index 13ba552e6..c4db7606b 100644
--- a/include/linux/fscache-cache.h
+++ b/include/linux/fscache-cache.h
@@ -117,7 +117,7 @@ struct fscache_operation {
 	fscache_operation_release_t release;
 };
 
-extern atomic_t fscache_op_debug_id;
+extern atomic_unchecked_t fscache_op_debug_id;
 extern void fscache_op_work_func(struct work_struct *work);
 
 extern void fscache_enqueue_operation(struct fscache_operation *);
diff --git a/include/linux/fscache.h b/include/linux/fscache.h
index 115bb8191..e7b812b95 100644
--- a/include/linux/fscache.h
+++ b/include/linux/fscache.h
@@ -152,7 +152,7 @@ struct fscache_cookie_def {
 	 * - this is mandatory for any object that may have data
 	 */
 	void (*now_uncached)(void *cookie_netfs_data);
-};
+} __do_const;
 
 /*
  * fscache cached network filesystem type
diff --git a/include/linux/fsnotify.h b/include/linux/fsnotify.h
index eed9e853a..21238dbab 100644
--- a/include/linux/fsnotify.h
+++ b/include/linux/fsnotify.h
@@ -176,6 +176,9 @@ static inline void fsnotify_access(struct file *file)
 	struct inode *inode = file_inode(file);
 	__u32 mask = FS_ACCESS;
 
+	if (is_sidechannel_device(inode))
+		return;
+
 	if (S_ISDIR(inode->i_mode))
 		mask |= FS_ISDIR;
 
@@ -194,6 +197,9 @@ static inline void fsnotify_modify(struct file *file)
 	struct inode *inode = file_inode(file);
 	__u32 mask = FS_MODIFY;
 
+	if (is_sidechannel_device(inode))
+		return;
+
 	if (S_ISDIR(inode->i_mode))
 		mask |= FS_ISDIR;
 
@@ -296,7 +302,7 @@ static inline void fsnotify_change(struct dentry *dentry, unsigned int ia_valid)
  */
 static inline const unsigned char *fsnotify_oldname_init(const unsigned char *name)
 {
-	return kstrdup(name, GFP_KERNEL);
+	return (const unsigned char *)kstrdup((const char *)name, GFP_KERNEL);
 }
 
 /*
diff --git a/include/linux/genhd.h b/include/linux/genhd.h
index 1dbf52f9c..b698a758b 100644
--- a/include/linux/genhd.h
+++ b/include/linux/genhd.h
@@ -208,7 +208,7 @@ struct gendisk {
 	struct kobject *slave_dir;
 
 	struct timer_rand_state *random;
-	atomic_t sync_io;		/* RAID */
+	atomic_unchecked_t sync_io;	/* RAID */
 	struct disk_events *ev;
 #ifdef  CONFIG_BLK_DEV_INTEGRITY
 	struct kobject integrity_kobj;
@@ -437,7 +437,7 @@ extern void disk_flush_events(struct gendisk *disk, unsigned int mask);
 extern unsigned int disk_clear_events(struct gendisk *disk, unsigned int mask);
 
 /* drivers/char/random.c */
-extern void add_disk_randomness(struct gendisk *disk);
+extern void add_disk_randomness(struct gendisk *disk) __latent_entropy;
 extern void rand_initialize_disk(struct gendisk *disk);
 
 static inline sector_t get_start_sect(struct block_device *bdev)
diff --git a/include/linux/genl_magic_func.h b/include/linux/genl_magic_func.h
index 667c31101..abac2a74a 100644
--- a/include/linux/genl_magic_func.h
+++ b/include/linux/genl_magic_func.h
@@ -246,7 +246,7 @@ const char *CONCAT_(GENL_MAGIC_FAMILY, _genl_cmd_to_str)(__u8 cmd)
 },
 
 #define ZZZ_genl_ops		CONCAT_(GENL_MAGIC_FAMILY, _genl_ops)
-static struct genl_ops ZZZ_genl_ops[] __read_mostly = {
+static struct genl_ops ZZZ_genl_ops[] = {
 #include GENL_MAGIC_INCLUDE_FILE
 };
 
diff --git a/include/linux/genl_magic_struct.h b/include/linux/genl_magic_struct.h
index 6270a56e5..ddda3ac06 100644
--- a/include/linux/genl_magic_struct.h
+++ b/include/linux/genl_magic_struct.h
@@ -81,8 +81,8 @@ static inline int nla_put_u64_0pad(struct sk_buff *skb, int attrtype, u64 value)
 	__field(attr_nr, attr_flag, name, NLA_U32, __u32, \
 			nla_get_u32, nla_put_u32, false)
 #define __s32_field(attr_nr, attr_flag, name)	\
-	__field(attr_nr, attr_flag, name, NLA_U32, __s32, \
-			nla_get_u32, nla_put_u32, true)
+	__field(attr_nr, attr_flag, name, NLA_S32, __s32, \
+			nla_get_s32, nla_put_s32, true)
 #define __u64_field(attr_nr, attr_flag, name)	\
 	__field(attr_nr, attr_flag, name, NLA_U64, __u64, \
 			nla_get_u64, nla_put_u64_0pad, false)
diff --git a/include/linux/gfp.h b/include/linux/gfp.h
index f8041f9de..593a07b92 100644
--- a/include/linux/gfp.h
+++ b/include/linux/gfp.h
@@ -41,6 +41,13 @@ struct vm_area_struct;
 #define ___GFP_OTHER_NODE	0x800000u
 #define ___GFP_WRITE		0x1000000u
 #define ___GFP_KSWAPD_RECLAIM	0x2000000u
+
+#ifdef CONFIG_PAX_USERCOPY
+#define ___GFP_USERCOPY		0x4000000u
+#else
+#define ___GFP_USERCOPY		0
+#endif
+
 /* If the above are modified, __GFP_BITS_SHIFT may need updating */
 
 /*
@@ -79,12 +86,15 @@ struct vm_area_struct;
  *   node with no fallbacks or placement policy enforcements.
  *
  * __GFP_ACCOUNT causes the allocation to be accounted to kmemcg.
+ *
+ * __GFP_USERCOPY indicates that the page will be copied to/from userland
  */
 #define __GFP_RECLAIMABLE ((__force gfp_t)___GFP_RECLAIMABLE)
 #define __GFP_WRITE	((__force gfp_t)___GFP_WRITE)
 #define __GFP_HARDWALL   ((__force gfp_t)___GFP_HARDWALL)
 #define __GFP_THISNODE	((__force gfp_t)___GFP_THISNODE)
 #define __GFP_ACCOUNT	((__force gfp_t)___GFP_ACCOUNT)
+#define __GFP_USERCOPY	((__force gfp_t)___GFP_USERCOPY)
 
 /*
  * Watermark modifiers -- controls access to emergency reserves
@@ -187,7 +197,7 @@ struct vm_area_struct;
 #define __GFP_OTHER_NODE ((__force gfp_t)___GFP_OTHER_NODE)
 
 /* Room for N __GFP_FOO bits */
-#define __GFP_BITS_SHIFT 26
+#define __GFP_BITS_SHIFT 27
 #define __GFP_BITS_MASK ((__force gfp_t)((1 << __GFP_BITS_SHIFT) - 1))
 
 /*
@@ -260,6 +270,8 @@ struct vm_area_struct;
 			 __GFP_NOMEMALLOC | __GFP_NOWARN) & ~__GFP_RECLAIM)
 #define GFP_TRANSHUGE	(GFP_TRANSHUGE_LIGHT | __GFP_DIRECT_RECLAIM)
 
+#define GFP_USERCOPY	__GFP_USERCOPY
+
 /* Convert GFP flags to their corresponding migrate type */
 #define GFP_MOVABLE_MASK (__GFP_RECLAIMABLE|__GFP_MOVABLE)
 #define GFP_MOVABLE_SHIFT 3
@@ -516,7 +528,7 @@ extern void __free_page_frag(void *addr);
 void page_alloc_init(void);
 void drain_zone_pages(struct zone *zone, struct per_cpu_pages *pcp);
 void drain_all_pages(struct zone *zone);
-void drain_local_pages(struct zone *zone);
+void drain_local_pages(void *zone);
 
 void page_alloc_init_late(void);
 
diff --git b/include/linux/gracl.h b/include/linux/gracl.h
new file mode 100644
index 000000000..a3c4df76d
--- /dev/null
+++ b/include/linux/gracl.h
@@ -0,0 +1,342 @@
+#ifndef GR_ACL_H
+#define GR_ACL_H
+
+#include <linux/grdefs.h>
+#include <linux/resource.h>
+#include <linux/capability.h>
+#include <linux/dcache.h>
+#include <asm/resource.h>
+
+/* Major status information */
+
+#define GR_VERSION  "grsecurity 3.1"
+#define GRSECURITY_VERSION 0x3100
+
+enum {
+	GR_SHUTDOWN = 0,
+	GR_ENABLE = 1,
+	GR_SPROLE = 2,
+	GR_OLDRELOAD = 3,
+	GR_SEGVMOD = 4,
+	GR_STATUS = 5,
+	GR_UNSPROLE = 6,
+	GR_PASSSET = 7,
+	GR_SPROLEPAM = 8,
+	GR_RELOAD = 9,
+};
+
+/* Password setup definitions
+ * kernel/grhash.c */
+enum {
+	GR_PW_LEN = 128,
+	GR_SALT_LEN = 16,
+	GR_SHA_LEN = 32,
+};
+
+enum {
+	GR_SPROLE_LEN = 64,
+};
+
+enum {
+	GR_NO_GLOB = 0,
+	GR_REG_GLOB,
+	GR_CREATE_GLOB
+};
+
+#define GR_NLIMITS 32
+
+/* Begin Data Structures */
+
+struct sprole_pw {
+	unsigned char *rolename;
+	unsigned char salt[GR_SALT_LEN];
+	unsigned char sum[GR_SHA_LEN];	/* 256-bit SHA hash of the password */
+};
+
+struct name_entry {
+	__u32 key;
+	u64 inode;
+	dev_t device;
+	char *name;
+	__u16 len;
+	__u8 deleted;
+	struct name_entry *prev;
+	struct name_entry *next;
+};
+
+struct inodev_entry {
+	struct name_entry *nentry;
+	struct inodev_entry *prev;
+	struct inodev_entry *next;
+};
+
+struct acl_role_db {
+	struct acl_role_label **r_hash;
+	__u32 r_size;
+};
+
+struct inodev_db {
+	struct inodev_entry **i_hash;
+	__u32 i_size;
+};
+
+struct name_db {
+	struct name_entry **n_hash;
+	__u32 n_size;
+};
+
+struct crash_uid {
+	uid_t uid;
+	unsigned long expires;
+};
+
+struct gr_hash_struct {
+	void **table;
+	void **nametable;
+	void *first;
+	__u32 table_size;
+	__u32 used_size;
+	int type;
+};
+
+/* Userspace Grsecurity ACL data structures */
+
+struct acl_subject_label {
+	char *filename;
+	u64 inode;
+	dev_t device;
+	__u32 mode;
+	kernel_cap_t cap_mask;
+	kernel_cap_t cap_lower;
+	kernel_cap_t cap_invert_audit;
+
+	struct rlimit res[GR_NLIMITS];
+	__u32 resmask;
+
+	__u8 user_trans_type;
+	__u8 group_trans_type;
+	uid_t *user_transitions;
+	gid_t *group_transitions;
+	__u16 user_trans_num;
+	__u16 group_trans_num;
+
+	__u32 sock_families[2];
+	__u32 ip_proto[8];
+	__u32 ip_type;
+	struct acl_ip_label **ips;
+	__u32 ip_num;
+	__u32 inaddr_any_override;
+
+	__u32 crashes;
+	unsigned long expires;
+
+	struct acl_subject_label *parent_subject;
+	struct gr_hash_struct *hash;
+	struct acl_subject_label *prev;
+	struct acl_subject_label *next;
+
+	struct acl_object_label **obj_hash;
+	__u32 obj_hash_size;
+	__u16 pax_flags;
+};
+
+struct role_allowed_ip {
+	__u32 addr;
+	__u32 netmask;
+
+	struct role_allowed_ip *prev;
+	struct role_allowed_ip *next;
+};
+
+struct role_transition {
+	char *rolename;
+
+	struct role_transition *prev;
+	struct role_transition *next;
+};
+
+struct acl_role_label {
+	char *rolename;
+	uid_t uidgid;
+	__u16 roletype;
+
+	__u16 auth_attempts;
+	unsigned long expires;
+
+	struct acl_subject_label *root_label;
+	struct gr_hash_struct *hash;
+
+	struct acl_role_label *prev;
+	struct acl_role_label *next;
+
+	struct role_transition *transitions;
+	struct role_allowed_ip *allowed_ips;
+	uid_t *domain_children;
+	__u16 domain_child_num;
+
+	umode_t umask;
+
+	struct acl_subject_label **subj_hash;
+	__u32 subj_hash_size;
+};
+
+struct user_acl_role_db {
+	struct acl_role_label **r_table;
+	__u32 num_pointers;		/* Number of allocations to track */
+	__u32 num_roles;		/* Number of roles */
+	__u32 num_domain_children;	/* Number of domain children */
+	__u32 num_subjects;		/* Number of subjects */
+	__u32 num_objects;		/* Number of objects */
+};
+
+struct acl_object_label {
+	char *filename;
+	u64 inode;
+	dev_t device;
+	__u32 mode;
+
+	struct acl_subject_label *nested;
+	struct acl_object_label *globbed;
+
+	/* next two structures not used */
+
+	struct acl_object_label *prev;
+	struct acl_object_label *next;
+};
+
+struct acl_ip_label {
+	char *iface;
+	__u32 addr;
+	__u32 netmask;
+	__u16 low, high;
+	__u8 mode;
+	__u32 type;
+	__u32 proto[8];
+
+	/* next two structures not used */
+
+	struct acl_ip_label *prev;
+	struct acl_ip_label *next;
+};
+
+struct gr_arg {
+	struct user_acl_role_db role_db;
+	unsigned char pw[GR_PW_LEN];
+	unsigned char salt[GR_SALT_LEN];
+	unsigned char sum[GR_SHA_LEN];
+	unsigned char sp_role[GR_SPROLE_LEN];
+	struct sprole_pw *sprole_pws;
+	dev_t segv_device;
+	u64 segv_inode;
+	uid_t segv_uid;
+	__u16 num_sprole_pws;
+	__u16 mode;
+};
+
+struct gr_arg_wrapper {
+	struct gr_arg *arg;
+	__u32 version;
+	__u32 size;
+};
+
+struct subject_map {
+	struct acl_subject_label *user;
+	struct acl_subject_label *kernel;
+	struct subject_map *prev;
+	struct subject_map *next;
+};
+
+struct acl_subj_map_db {
+	struct subject_map **s_hash;
+	__u32 s_size;
+};
+
+struct gr_policy_state {
+	struct sprole_pw **acl_special_roles;
+	__u16 num_sprole_pws;
+	struct acl_role_label *kernel_role;
+	struct acl_role_label *role_list;
+	struct acl_role_label *default_role;
+	struct acl_role_db acl_role_set;
+	struct acl_subj_map_db subj_map_set;
+	struct name_db name_set;
+	struct inodev_db inodev_set;
+};
+
+struct gr_alloc_state {
+	unsigned long alloc_stack_next;
+	unsigned long alloc_stack_size;
+	void **alloc_stack;
+};
+
+struct gr_reload_state {
+	struct gr_policy_state oldpolicy;
+	struct gr_alloc_state oldalloc;
+	struct gr_policy_state newpolicy;
+	struct gr_alloc_state newalloc;
+	struct gr_policy_state *oldpolicy_ptr;
+	struct gr_alloc_state *oldalloc_ptr;
+	unsigned char oldmode;
+};
+
+/* End Data Structures Section */
+
+/* Hash functions generated by empirical testing by Brad Spengler
+   Makes good use of the low bits of the inode.  Generally 0-1 times
+   in loop for successful match.  0-3 for unsuccessful match.
+   Shift/add algorithm with modulus of table size and an XOR*/
+
+static __inline__ unsigned int
+gr_rhash(const uid_t uid, const __u16 type, const unsigned int sz)
+{
+	return ((((uid + type) << (16 + type)) ^ uid) % sz);
+}
+
+ static __inline__ unsigned int
+gr_shash(const struct acl_subject_label *userp, const unsigned int sz)
+{
+	return ((const unsigned long)userp % sz);
+}
+
+static __inline__ unsigned int
+gr_fhash(const u64 ino, const dev_t dev, const unsigned int sz)
+{
+	unsigned int rem;
+	div_u64_rem((ino + dev) ^ ((ino << 13) + (ino << 23) + (dev << 9)), sz, &rem);
+	return rem;
+}
+
+static __inline__ unsigned int
+gr_nhash(const char *name, const __u16 len, const unsigned int sz)
+{
+	return full_name_hash(NULL, (const unsigned char *)name, len) % sz;
+}
+
+#define FOR_EACH_SUBJECT_START(role,subj,iter) \
+	subj = NULL; \
+	iter = 0; \
+	while (iter < role->subj_hash_size) { \
+		if (subj == NULL) \
+			subj = role->subj_hash[iter]; \
+		if (subj == NULL) { \
+			iter++; \
+			continue; \
+		}
+
+#define FOR_EACH_SUBJECT_END(subj,iter) \
+		subj = subj->next; \
+		if (subj == NULL) \
+			iter++; \
+	}
+
+
+#define FOR_EACH_NESTED_SUBJECT_START(role,subj) \
+	subj = role->hash->first; \
+	while (subj != NULL) {
+
+#define FOR_EACH_NESTED_SUBJECT_END(subj) \
+		subj = subj->next; \
+	}
+
+#endif
+
diff --git b/include/linux/gracl_compat.h b/include/linux/gracl_compat.h
new file mode 100644
index 000000000..af640920c
--- /dev/null
+++ b/include/linux/gracl_compat.h
@@ -0,0 +1,156 @@
+#ifndef GR_ACL_COMPAT_H
+#define GR_ACL_COMPAT_H
+
+#include <linux/resource.h>
+#include <asm/resource.h>
+
+struct sprole_pw_compat {
+	compat_uptr_t rolename;
+	unsigned char salt[GR_SALT_LEN];
+	unsigned char sum[GR_SHA_LEN];
+};
+
+struct gr_hash_struct_compat {
+	compat_uptr_t table;
+	compat_uptr_t nametable;
+	compat_uptr_t first;
+	__u32 table_size;
+	__u32 used_size;
+	int type;
+};
+
+struct acl_subject_label_compat {
+	compat_uptr_t filename;
+	compat_u64 inode;
+	__u32 device;
+	__u32 mode;
+	kernel_cap_t cap_mask;
+	kernel_cap_t cap_lower;
+	kernel_cap_t cap_invert_audit;
+
+	struct compat_rlimit res[GR_NLIMITS];
+	__u32 resmask;
+
+	__u8 user_trans_type;
+	__u8 group_trans_type;
+	compat_uptr_t user_transitions;
+	compat_uptr_t group_transitions;
+	__u16 user_trans_num;
+	__u16 group_trans_num;
+
+	__u32 sock_families[2];
+	__u32 ip_proto[8];
+	__u32 ip_type;
+	compat_uptr_t ips;
+	__u32 ip_num;
+	__u32 inaddr_any_override;
+
+	__u32 crashes;
+	compat_ulong_t expires;
+
+	compat_uptr_t parent_subject;
+	compat_uptr_t hash;
+	compat_uptr_t prev;
+	compat_uptr_t next;
+
+	compat_uptr_t obj_hash;
+	__u32 obj_hash_size;
+	__u16 pax_flags;
+};
+
+struct role_allowed_ip_compat {
+	__u32 addr;
+	__u32 netmask;
+
+	compat_uptr_t prev;
+	compat_uptr_t next;
+};
+
+struct role_transition_compat {
+	compat_uptr_t rolename;
+
+	compat_uptr_t prev;
+	compat_uptr_t next;
+};
+
+struct acl_role_label_compat {
+	compat_uptr_t rolename;
+	uid_t uidgid;
+	__u16 roletype;
+
+	__u16 auth_attempts;
+	compat_ulong_t expires;
+
+	compat_uptr_t root_label;
+	compat_uptr_t hash;
+
+	compat_uptr_t prev;
+	compat_uptr_t next;
+
+	compat_uptr_t transitions;
+	compat_uptr_t allowed_ips;
+	compat_uptr_t domain_children;
+	__u16 domain_child_num;
+
+	umode_t umask;
+
+	compat_uptr_t subj_hash;
+	__u32 subj_hash_size;
+};
+
+struct user_acl_role_db_compat {
+	compat_uptr_t r_table;
+	__u32 num_pointers;
+	__u32 num_roles;
+	__u32 num_domain_children;
+	__u32 num_subjects;
+	__u32 num_objects;
+};
+
+struct acl_object_label_compat {
+	compat_uptr_t filename;
+	compat_u64 inode;
+	__u32 device;
+	__u32 mode;
+
+	compat_uptr_t nested;
+	compat_uptr_t globbed;
+
+	compat_uptr_t prev;
+	compat_uptr_t next;
+};
+
+struct acl_ip_label_compat {
+	compat_uptr_t iface;
+	__u32 addr;
+	__u32 netmask;
+	__u16 low, high;
+	__u8 mode;
+	__u32 type;
+	__u32 proto[8];
+
+	compat_uptr_t prev;
+	compat_uptr_t next;
+};
+
+struct gr_arg_compat {
+	struct user_acl_role_db_compat role_db;
+	unsigned char pw[GR_PW_LEN];
+	unsigned char salt[GR_SALT_LEN];
+	unsigned char sum[GR_SHA_LEN];
+	unsigned char sp_role[GR_SPROLE_LEN];
+	compat_uptr_t sprole_pws;
+	__u32 segv_device;
+	compat_u64 segv_inode;
+	uid_t segv_uid;
+	__u16 num_sprole_pws;
+	__u16 mode;
+};
+
+struct gr_arg_wrapper_compat {
+	compat_uptr_t arg;
+	__u32 version;
+	__u32 size;
+};
+
+#endif
diff --git b/include/linux/gralloc.h b/include/linux/gralloc.h
new file mode 100644
index 000000000..323ecf280
--- /dev/null
+++ b/include/linux/gralloc.h
@@ -0,0 +1,9 @@
+#ifndef __GRALLOC_H
+#define __GRALLOC_H
+
+void acl_free_all(void);
+int acl_alloc_stack_init(unsigned long size);
+void *acl_alloc(unsigned long len);
+void *acl_alloc_num(unsigned long num, unsigned long len);
+
+#endif
diff --git b/include/linux/grdefs.h b/include/linux/grdefs.h
new file mode 100644
index 000000000..be66033e6
--- /dev/null
+++ b/include/linux/grdefs.h
@@ -0,0 +1,140 @@
+#ifndef GRDEFS_H
+#define GRDEFS_H
+
+/* Begin grsecurity status declarations */
+
+enum {
+	GR_READY = 0x01,
+	GR_STATUS_INIT = 0x00	// disabled state
+};
+
+/* Begin  ACL declarations */
+
+/* Role flags */
+
+enum {
+	GR_ROLE_USER = 0x0001,
+	GR_ROLE_GROUP = 0x0002,
+	GR_ROLE_DEFAULT = 0x0004,
+	GR_ROLE_SPECIAL = 0x0008,
+	GR_ROLE_AUTH = 0x0010,
+	GR_ROLE_NOPW = 0x0020,
+	GR_ROLE_GOD = 0x0040,
+	GR_ROLE_LEARN = 0x0080,
+	GR_ROLE_TPE = 0x0100,
+	GR_ROLE_DOMAIN = 0x0200,
+	GR_ROLE_PAM = 0x0400,
+	GR_ROLE_PERSIST = 0x0800
+};
+
+/* ACL Subject and Object mode flags */
+enum {
+	GR_DELETED = 0x80000000
+};
+
+/* ACL Object-only mode flags */
+enum {
+	GR_READ 	= 0x00000001,
+	GR_APPEND 	= 0x00000002,
+	GR_WRITE 	= 0x00000004,
+	GR_EXEC 	= 0x00000008,
+	GR_FIND 	= 0x00000010,
+	GR_INHERIT 	= 0x00000020,
+	GR_SETID 	= 0x00000040,
+	GR_CREATE 	= 0x00000080,
+	GR_DELETE 	= 0x00000100,
+	GR_LINK		= 0x00000200,
+	GR_AUDIT_READ 	= 0x00000400,
+	GR_AUDIT_APPEND = 0x00000800,
+	GR_AUDIT_WRITE 	= 0x00001000,
+	GR_AUDIT_EXEC 	= 0x00002000,
+	GR_AUDIT_FIND 	= 0x00004000,
+	GR_AUDIT_INHERIT= 0x00008000,
+	GR_AUDIT_SETID 	= 0x00010000,
+	GR_AUDIT_CREATE = 0x00020000,
+	GR_AUDIT_DELETE = 0x00040000,
+	GR_AUDIT_LINK	= 0x00080000,
+	GR_PTRACERD 	= 0x00100000,
+	GR_NOPTRACE	= 0x00200000,
+	GR_SUPPRESS 	= 0x00400000,
+	GR_NOLEARN 	= 0x00800000,
+	GR_INIT_TRANSFER= 0x01000000
+};
+
+#define GR_AUDITS (GR_AUDIT_READ | GR_AUDIT_WRITE | GR_AUDIT_APPEND | GR_AUDIT_EXEC | \
+		   GR_AUDIT_FIND | GR_AUDIT_INHERIT | GR_AUDIT_SETID | \
+		   GR_AUDIT_CREATE | GR_AUDIT_DELETE | GR_AUDIT_LINK)
+
+/* ACL subject-only mode flags */
+enum {
+	GR_KILL 	= 0x00000001,
+	GR_VIEW 	= 0x00000002,
+	GR_PROTECTED 	= 0x00000004,
+	GR_LEARN 	= 0x00000008,
+	GR_OVERRIDE 	= 0x00000010,
+	/* just a placeholder, this mode is only used in userspace */
+	GR_DUMMY 	= 0x00000020,
+	GR_PROTSHM	= 0x00000040,
+	GR_KILLPROC	= 0x00000080,
+	GR_KILLIPPROC	= 0x00000100,
+	/* just a placeholder, this mode is only used in userspace */
+	GR_NOTROJAN	= 0x00000200,
+	GR_PROTPROCFD	= 0x00000400,
+	GR_PROCACCT	= 0x00000800,
+	GR_RELAXPTRACE	= 0x00001000,
+	//GR_NESTED	= 0x00002000,
+	GR_INHERITLEARN	= 0x00004000,
+	GR_PROCFIND	= 0x00008000,
+	GR_POVERRIDE	= 0x00010000,
+	GR_KERNELAUTH	= 0x00020000,
+	GR_ATSECURE	= 0x00040000,
+	GR_SHMEXEC	= 0x00080000
+};
+
+enum {
+	GR_PAX_ENABLE_SEGMEXEC	= 0x0001,
+	GR_PAX_ENABLE_PAGEEXEC	= 0x0002,
+	GR_PAX_ENABLE_MPROTECT	= 0x0004,
+	GR_PAX_ENABLE_RANDMMAP	= 0x0008,
+	GR_PAX_ENABLE_EMUTRAMP	= 0x0010,
+	GR_PAX_DISABLE_SEGMEXEC	= 0x0100,
+	GR_PAX_DISABLE_PAGEEXEC	= 0x0200,
+	GR_PAX_DISABLE_MPROTECT	= 0x0400,
+	GR_PAX_DISABLE_RANDMMAP	= 0x0800,
+	GR_PAX_DISABLE_EMUTRAMP	= 0x1000,
+};
+
+enum {
+	GR_ID_USER	= 0x01,
+	GR_ID_GROUP	= 0x02,
+};
+
+enum {
+	GR_ID_ALLOW	= 0x01,
+	GR_ID_DENY	= 0x02,
+};
+
+#define GR_CRASH_RES	31
+#define GR_UIDTABLE_MAX 500
+
+/* begin resource learning section */
+enum {
+	GR_RLIM_CPU_BUMP = 60,
+	GR_RLIM_FSIZE_BUMP = 50000,
+	GR_RLIM_DATA_BUMP = 10000,
+	GR_RLIM_STACK_BUMP = 1000,
+	GR_RLIM_CORE_BUMP = 10000,
+	GR_RLIM_RSS_BUMP = 500000,
+	GR_RLIM_NPROC_BUMP = 1,
+	GR_RLIM_NOFILE_BUMP = 5,
+	GR_RLIM_MEMLOCK_BUMP = 50000,
+	GR_RLIM_AS_BUMP = 500000,
+	GR_RLIM_LOCKS_BUMP = 2,
+	GR_RLIM_SIGPENDING_BUMP = 5,
+	GR_RLIM_MSGQUEUE_BUMP = 10000,
+	GR_RLIM_NICE_BUMP = 1,
+	GR_RLIM_RTPRIO_BUMP = 1,
+	GR_RLIM_RTTIME_BUMP = 1000000
+};
+
+#endif
diff --git b/include/linux/grinternal.h b/include/linux/grinternal.h
new file mode 100644
index 000000000..1dbf9c871
--- /dev/null
+++ b/include/linux/grinternal.h
@@ -0,0 +1,231 @@
+#ifndef __GRINTERNAL_H
+#define __GRINTERNAL_H
+
+#ifdef CONFIG_GRKERNSEC
+
+#include <linux/fs.h>
+#include <linux/mnt_namespace.h>
+#include <linux/nsproxy.h>
+#include <linux/gracl.h>
+#include <linux/grdefs.h>
+#include <linux/grmsg.h>
+
+void gr_add_learn_entry(const char *fmt, ...)
+	__attribute__ ((format (printf, 1, 2)));
+__u32 gr_search_file(const struct dentry *dentry, const __u32 mode,
+			    const struct vfsmount *mnt);
+__u32 gr_check_create(const struct dentry *new_dentry,
+			     const struct dentry *parent,
+			     const struct vfsmount *mnt, const __u32 mode);
+int gr_check_protected_task(const struct task_struct *task);
+__u32 to_gr_audit(const __u32 reqmode);
+int gr_set_acls(const int type);
+int gr_acl_is_enabled(void);
+char gr_roletype_to_char(void);
+
+void gr_handle_alertkill(struct task_struct *task);
+char *gr_to_filename(const struct dentry *dentry,
+			    const struct vfsmount *mnt);
+char *gr_to_filename1(const struct dentry *dentry,
+			    const struct vfsmount *mnt);
+char *gr_to_filename2(const struct dentry *dentry,
+			    const struct vfsmount *mnt);
+char *gr_to_filename3(const struct dentry *dentry,
+			    const struct vfsmount *mnt);
+
+extern int grsec_enable_ptrace_readexec;
+extern int grsec_enable_harden_ptrace;
+extern int grsec_enable_link;
+extern int grsec_enable_fifo;
+extern int grsec_enable_execve;
+extern int grsec_enable_shm;
+extern int grsec_enable_execlog;
+extern int grsec_enable_signal;
+extern int grsec_enable_audit_ptrace;
+extern int grsec_enable_forkfail;
+extern int grsec_enable_time;
+extern int grsec_enable_rofs;
+extern int grsec_deny_new_usb;
+extern int grsec_enable_chroot_shmat;
+extern int grsec_enable_chroot_mount;
+extern int grsec_enable_chroot_double;
+extern int grsec_enable_chroot_pivot;
+extern int grsec_enable_chroot_chdir;
+extern int grsec_enable_chroot_chmod;
+extern int grsec_enable_chroot_mknod;
+extern int grsec_enable_chroot_fchdir;
+extern int grsec_enable_chroot_nice;
+extern int grsec_enable_chroot_execlog;
+extern int grsec_enable_chroot_caps;
+extern int grsec_enable_chroot_rename;
+extern int grsec_enable_chroot_sysctl;
+extern int grsec_enable_chroot_unix;
+extern int grsec_enable_symlinkown;
+extern kgid_t grsec_symlinkown_gid;
+extern int grsec_enable_tpe;
+extern kgid_t grsec_tpe_gid;
+extern int grsec_enable_tpe_all;
+extern int grsec_enable_tpe_invert;
+extern int grsec_enable_socket_all;
+extern kgid_t grsec_socket_all_gid;
+extern int grsec_enable_socket_client;
+extern kgid_t grsec_socket_client_gid;
+extern int grsec_enable_socket_server;
+extern kgid_t grsec_socket_server_gid;
+extern kgid_t grsec_audit_gid;
+extern int grsec_enable_group;
+extern int grsec_enable_log_rwxmaps;
+extern int grsec_enable_mount;
+extern int grsec_enable_chdir;
+extern int grsec_resource_logging;
+extern int grsec_enable_blackhole;
+extern int grsec_lastack_retries;
+extern int grsec_enable_brute;
+extern int grsec_enable_harden_ipc;
+extern int grsec_enable_harden_tty;
+extern int grsec_lock;
+
+extern spinlock_t grsec_alert_lock;
+extern unsigned long grsec_alert_wtime;
+extern unsigned long grsec_alert_fyet;
+
+extern spinlock_t grsec_audit_lock;
+
+extern rwlock_t grsec_exec_file_lock;
+
+#define gr_task_fullpath(tsk) ((tsk)->exec_file ? \
+			gr_to_filename2((tsk)->exec_file->f_path.dentry, \
+			(tsk)->exec_file->f_path.mnt) : "/")
+
+#define gr_parent_task_fullpath(tsk) ((tsk)->real_parent->exec_file ? \
+			gr_to_filename3((tsk)->real_parent->exec_file->f_path.dentry, \
+			(tsk)->real_parent->exec_file->f_path.mnt) : "/")
+
+#define gr_task_fullpath0(tsk) ((tsk)->exec_file ? \
+			gr_to_filename((tsk)->exec_file->f_path.dentry, \
+			(tsk)->exec_file->f_path.mnt) : "/")
+
+#define gr_parent_task_fullpath0(tsk) ((tsk)->real_parent->exec_file ? \
+			gr_to_filename1((tsk)->real_parent->exec_file->f_path.dentry, \
+			(tsk)->real_parent->exec_file->f_path.mnt) : "/")
+
+#define proc_is_chrooted(tsk_a)  ((tsk_a)->gr_is_chrooted)
+
+#define have_same_root(tsk_a,tsk_b) ((tsk_a)->gr_chroot_dentry == (tsk_b)->gr_chroot_dentry)
+
+static inline bool gr_is_same_file(const struct file *file1, const struct file *file2)
+{
+	if (file1 && file2) {
+		const struct inode *inode1 = file1->f_path.dentry->d_inode;
+		const struct inode *inode2 = file2->f_path.dentry->d_inode;
+		if (inode1->i_ino == inode2->i_ino && inode1->i_sb->s_dev == inode2->i_sb->s_dev)
+			return true;
+	}
+
+	return false;
+}
+
+#define GR_CHROOT_CAPS {{ \
+	CAP_TO_MASK(CAP_LINUX_IMMUTABLE) | CAP_TO_MASK(CAP_NET_ADMIN) | \
+	CAP_TO_MASK(CAP_SYS_MODULE) | CAP_TO_MASK(CAP_SYS_RAWIO) | \
+	CAP_TO_MASK(CAP_SYS_PACCT) | CAP_TO_MASK(CAP_SYS_ADMIN) | \
+	CAP_TO_MASK(CAP_SYS_BOOT) | CAP_TO_MASK(CAP_SYS_TIME) | \
+	CAP_TO_MASK(CAP_NET_RAW) | CAP_TO_MASK(CAP_SYS_TTY_CONFIG) | \
+	CAP_TO_MASK(CAP_IPC_OWNER) | CAP_TO_MASK(CAP_SETFCAP), \
+	CAP_TO_MASK(CAP_SYSLOG) | CAP_TO_MASK(CAP_MAC_ADMIN) }}
+
+#define security_learn(normal_msg,args...) \
+({ \
+	read_lock(&grsec_exec_file_lock); \
+	gr_add_learn_entry(normal_msg "\n", ## args); \
+	read_unlock(&grsec_exec_file_lock); \
+})
+
+enum {
+	GR_DO_AUDIT,
+	GR_DONT_AUDIT,
+	/* used for non-audit messages that we shouldn't kill the task on */
+	GR_DONT_AUDIT_GOOD
+};
+
+enum {
+	GR_TTYSNIFF,
+	GR_RBAC,
+	GR_RBAC_STR,
+	GR_STR_RBAC,
+	GR_RBAC_MODE2,
+	GR_RBAC_MODE3,
+	GR_FILENAME,
+	GR_SYSCTL_HIDDEN,
+	GR_NOARGS,
+	GR_ONE_INT,
+	GR_ONE_INT_TWO_STR,
+	GR_ONE_STR,
+	GR_STR_INT,
+	GR_TWO_STR_INT,
+	GR_TWO_INT,
+	GR_TWO_U64,
+	GR_THREE_INT,
+	GR_FIVE_INT_TWO_STR,
+	GR_TWO_STR,
+	GR_THREE_STR,
+	GR_FOUR_STR,
+	GR_STR_FILENAME,
+	GR_FILENAME_STR,
+	GR_FILENAME_TWO_INT,
+	GR_FILENAME_TWO_INT_STR,
+	GR_TEXTREL,
+	GR_PTRACE,
+	GR_RESOURCE,
+	GR_CAP,
+	GR_SIG,
+	GR_SIG2,
+	GR_CRASH1,
+	GR_CRASH2,
+	GR_PSACCT,
+	GR_RWXMAP,
+	GR_RWXMAPVMA
+};
+
+#define gr_log_hidden_sysctl(audit, msg, str) gr_log_varargs(audit, msg, GR_SYSCTL_HIDDEN, str)
+#define gr_log_ttysniff(audit, msg, task) gr_log_varargs(audit, msg, GR_TTYSNIFF, task)
+#define gr_log_fs_rbac_generic(audit, msg, dentry, mnt) gr_log_varargs(audit, msg, GR_RBAC, dentry, mnt)
+#define gr_log_fs_rbac_str(audit, msg, dentry, mnt, str) gr_log_varargs(audit, msg, GR_RBAC_STR, dentry, mnt, str)
+#define gr_log_fs_str_rbac(audit, msg, str, dentry, mnt) gr_log_varargs(audit, msg, GR_STR_RBAC, str, dentry, mnt)
+#define gr_log_fs_rbac_mode2(audit, msg, dentry, mnt, str1, str2) gr_log_varargs(audit, msg, GR_RBAC_MODE2, dentry, mnt, str1, str2)
+#define gr_log_fs_rbac_mode3(audit, msg, dentry, mnt, str1, str2, str3) gr_log_varargs(audit, msg, GR_RBAC_MODE3, dentry, mnt, str1, str2, str3)
+#define gr_log_fs_generic(audit, msg, dentry, mnt) gr_log_varargs(audit, msg, GR_FILENAME, dentry, mnt)
+#define gr_log_noargs(audit, msg) gr_log_varargs(audit, msg, GR_NOARGS)
+#define gr_log_int(audit, msg, num) gr_log_varargs(audit, msg, GR_ONE_INT, num)
+#define gr_log_int_str2(audit, msg, num, str1, str2) gr_log_varargs(audit, msg, GR_ONE_INT_TWO_STR, num, str1, str2)
+#define gr_log_str(audit, msg, str) gr_log_varargs(audit, msg, GR_ONE_STR, str)
+#define gr_log_str_int(audit, msg, str, num) gr_log_varargs(audit, msg, GR_STR_INT, str, num)
+#define gr_log_int_int(audit, msg, num1, num2) gr_log_varargs(audit, msg, GR_TWO_INT, num1, num2)
+#define gr_log_two_u64(audit, msg, num1, num2) gr_log_varargs(audit, msg, GR_TWO_U64, num1, num2)
+#define gr_log_int3(audit, msg, num1, num2, num3) gr_log_varargs(audit, msg, GR_THREE_INT, num1, num2, num3)
+#define gr_log_int5_str2(audit, msg, num1, num2, str1, str2) gr_log_varargs(audit, msg, GR_FIVE_INT_TWO_STR, num1, num2, str1, str2)
+#define gr_log_str_str(audit, msg, str1, str2) gr_log_varargs(audit, msg, GR_TWO_STR, str1, str2)
+#define gr_log_str2_int(audit, msg, str1, str2, num) gr_log_varargs(audit, msg, GR_TWO_STR_INT, str1, str2, num)
+#define gr_log_str3(audit, msg, str1, str2, str3) gr_log_varargs(audit, msg, GR_THREE_STR, str1, str2, str3)
+#define gr_log_str4(audit, msg, str1, str2, str3, str4) gr_log_varargs(audit, msg, GR_FOUR_STR, str1, str2, str3, str4)
+#define gr_log_str_fs(audit, msg, str, dentry, mnt) gr_log_varargs(audit, msg, GR_STR_FILENAME, str, dentry, mnt)
+#define gr_log_fs_str(audit, msg, dentry, mnt, str) gr_log_varargs(audit, msg, GR_FILENAME_STR, dentry, mnt, str)
+#define gr_log_fs_int2(audit, msg, dentry, mnt, num1, num2) gr_log_varargs(audit, msg, GR_FILENAME_TWO_INT, dentry, mnt, num1, num2)
+#define gr_log_fs_int2_str(audit, msg, dentry, mnt, num1, num2, str) gr_log_varargs(audit, msg, GR_FILENAME_TWO_INT_STR, dentry, mnt, num1, num2, str)
+#define gr_log_textrel_ulong_ulong(audit, msg, str, file, ulong1, ulong2) gr_log_varargs(audit, msg, GR_TEXTREL, str, file, ulong1, ulong2)
+#define gr_log_ptrace(audit, msg, task) gr_log_varargs(audit, msg, GR_PTRACE, task)
+#define gr_log_res_ulong2_str(audit, msg, task, ulong1, str, ulong2) gr_log_varargs(audit, msg, GR_RESOURCE, task, ulong1, str, ulong2)
+#define gr_log_cap(audit, msg, task, str) gr_log_varargs(audit, msg, GR_CAP, task, str)
+#define gr_log_sig_addr(audit, msg, str, addr) gr_log_varargs(audit, msg, GR_SIG, str, addr)
+#define gr_log_sig_task(audit, msg, task, num) gr_log_varargs(audit, msg, GR_SIG2, task, num)
+#define gr_log_crash1(audit, msg, task, ulong) gr_log_varargs(audit, msg, GR_CRASH1, task, ulong)
+#define gr_log_crash2(audit, msg, task, ulong1) gr_log_varargs(audit, msg, GR_CRASH2, task, ulong1)
+#define gr_log_procacct(audit, msg, task, num1, num2, num3, num4, num5, num6, num7, num8, num9) gr_log_varargs(audit, msg, GR_PSACCT, task, num1, num2, num3, num4, num5, num6, num7, num8, num9)
+#define gr_log_rwxmap(audit, msg, str) gr_log_varargs(audit, msg, GR_RWXMAP, str)
+#define gr_log_rwxmap_vma(audit, msg, str) gr_log_varargs(audit, msg, GR_RWXMAPVMA, str)
+
+void gr_log_varargs(int audit, const char *msg, int argtypes, ...);
+
+#endif
+
+#endif
diff --git b/include/linux/grmsg.h b/include/linux/grmsg.h
new file mode 100644
index 000000000..94ac4d220
--- /dev/null
+++ b/include/linux/grmsg.h
@@ -0,0 +1,120 @@
+#define DEFAULTSECMSG "%.256s[%.16s:%d] uid/euid:%u/%u gid/egid:%u/%u, parent %.256s[%.16s:%d] uid/euid:%u/%u gid/egid:%u/%u"
+#define GR_ACL_PROCACCT_MSG "%.256s[%.16s:%d] IP:%pI4 TTY:%.64s uid/euid:%u/%u gid/egid:%u/%u run time:[%ud %uh %um %us] cpu time:[%ud %uh %um %us] %s with exit code %ld, parent %.256s[%.16s:%d] IP:%pI4 TTY:%.64s uid/euid:%u/%u gid/egid:%u/%u"
+#define GR_PTRACE_ACL_MSG "denied ptrace of %.950s(%.16s:%d) by "
+#define GR_STOPMOD_MSG "denied modification of module state by "
+#define GR_ROFS_BLOCKWRITE_MSG "denied write to block device %.950s by "
+#define GR_ROFS_MOUNT_MSG "denied writable mount of %.950s by "
+#define GR_IOPERM_MSG "denied use of ioperm() by "
+#define GR_IOPL_MSG "denied use of iopl() by "
+#define GR_SHMAT_ACL_MSG "denied attach of shared memory of UID %u, PID %d, ID %u by "
+#define GR_UNIX_CHROOT_MSG "denied connect() to abstract AF_UNIX socket outside of chroot by "
+#define GR_SHMAT_CHROOT_MSG "denied attach of shared memory outside of chroot by "
+#define GR_MEM_READWRITE_MSG "denied access of range %Lx -> %Lx in /dev/mem by "
+#define GR_SYMLINK_MSG "not following symlink %.950s owned by %d.%d by "
+#define GR_LEARN_AUDIT_MSG "%s\t%u\t%u\t%u\t%.4095s\t%.4095s\t%lu\t%lu\t%.4095s\t%lu\t%pI4"
+#define GR_ID_LEARN_MSG "%s\t%u\t%u\t%u\t%.4095s\t%.4095s\t%c\t%d\t%d\t%d\t%pI4"
+#define GR_HIDDEN_ACL_MSG "%s access to hidden file %.950s by "
+#define GR_OPEN_ACL_MSG "%s open of %.950s for%s%s by "
+#define GR_CREATE_ACL_MSG "%s create of %.950s for%s%s by "
+#define GR_FIFO_MSG "denied writing FIFO %.950s of %d.%d by "
+#define GR_MKNOD_CHROOT_MSG "denied mknod of %.950s from chroot by "
+#define GR_MKNOD_ACL_MSG "%s mknod of %.950s by "
+#define GR_UNIXCONNECT_ACL_MSG "%s connect() to the unix domain socket %.950s by "
+#define GR_TTYSNIFF_ACL_MSG "terminal being sniffed by IP:%pI4 %.480s[%.16s:%d], parent %.480s[%.16s:%d] against "
+#define GR_MKDIR_ACL_MSG "%s mkdir of %.950s by "
+#define GR_RMDIR_ACL_MSG "%s rmdir of %.950s by "
+#define GR_UNLINK_ACL_MSG "%s unlink of %.950s by "
+#define GR_SYMLINK_ACL_MSG "%s symlink from %.480s to %.480s by "
+#define GR_HARDLINK_MSG "denied hardlink of %.930s (owned by %d.%d) to %.30s for "
+#define GR_LINK_ACL_MSG "%s link of %.480s to %.480s by "
+#define GR_INHERIT_ACL_MSG "successful inherit of %.480s's ACL for %.480s by "
+#define GR_RENAME_ACL_MSG "%s rename of %.480s to %.480s by "
+#define GR_UNSAFESHARE_EXEC_ACL_MSG "denied exec with cloned fs of %.950s by "
+#define GR_PTRACE_EXEC_ACL_MSG "denied ptrace of %.950s by "
+#define GR_EXEC_ACL_MSG "%s execution of %.950s by "
+#define GR_EXEC_TPE_MSG "denied untrusted exec (due to %.70s) of %.950s by "
+#define GR_SEGVSTART_ACL_MSG "possible exploit bruteforcing on " DEFAULTSECMSG " banning uid %u from login for %lu seconds"
+#define GR_SEGVNOSUID_ACL_MSG "possible exploit bruteforcing on " DEFAULTSECMSG " banning execution for %lu seconds"
+#define GR_MOUNT_CHROOT_MSG "denied mount of %.256s as %.930s from chroot by "
+#define GR_PIVOT_CHROOT_MSG "denied pivot_root from chroot by "
+#define GR_TRUNCATE_ACL_MSG "%s truncate of %.950s by "
+#define GR_ATIME_ACL_MSG "%s access time change of %.950s by "
+#define GR_ACCESS_ACL_MSG "%s access of %.950s for%s%s%s by "
+#define GR_CHROOT_CHROOT_MSG "denied double chroot to %.950s by "
+#define GR_CHROOT_RENAME_MSG "denied bad rename of %.950s out of a chroot by "
+#define GR_CHMOD_CHROOT_MSG "denied chmod +s of %.950s by "
+#define GR_CHMOD_ACL_MSG "%s chmod of %.950s by "
+#define GR_CHROOT_FCHDIR_MSG "denied fchdir outside of chroot to %.950s by "
+#define GR_CHROOT_PATHAT_MSG "denied relative path access outside of chroot to %.950s by "
+#define GR_CHROOT_FHANDLE_MSG "denied use of file handles inside chroot by "
+#define GR_CHOWN_ACL_MSG "%s chown of %.950s by "
+#define GR_SETXATTR_ACL_MSG "%s setting extended attribute of %.950s by "
+#define GR_REMOVEXATTR_ACL_MSG "%s removing extended attribute of %.950s by "
+#define GR_WRITLIB_ACL_MSG "denied load of writable library %.950s by "
+#define GR_INITF_ACL_MSG "init_variables() failed %s by "
+#define GR_DISABLED_ACL_MSG "Error loading %s, trying to run kernel with acls disabled. To disable acls at startup use <kernel image name> gracl=off from your boot loader"
+#define GR_DEV_ACL_MSG "/dev/grsec: %d bytes sent %d required, being fed garbage by "
+#define GR_SHUTS_ACL_MSG "shutdown auth success for "
+#define GR_SHUTF_ACL_MSG "shutdown auth failure for "
+#define GR_SHUTI_ACL_MSG "ignoring shutdown for disabled RBAC system for "
+#define GR_SEGVMODS_ACL_MSG "segvmod auth success for "
+#define GR_SEGVMODF_ACL_MSG "segvmod auth failure for "
+#define GR_SEGVMODI_ACL_MSG "ignoring segvmod for disabled RBAC system for "
+#define GR_ENABLE_ACL_MSG "%s RBAC system loaded by "
+#define GR_ENABLEF_ACL_MSG "unable to load %s for "
+#define GR_RELOADI_ACL_MSG "ignoring reload request for disabled RBAC system"
+#define GR_RELOAD_ACL_MSG "%s RBAC system reloaded by "
+#define GR_RELOADF_ACL_MSG "failed reload of %s for "
+#define GR_SPROLEI_ACL_MSG "ignoring change to special role for disabled RBAC system for "
+#define GR_SPROLES_ACL_MSG "successful change to special role %s (id %d) by "
+#define GR_SPROLEL_ACL_MSG "special role %s (id %d) exited by "
+#define GR_SPROLEF_ACL_MSG "special role %s failure for "
+#define GR_UNSPROLEI_ACL_MSG "ignoring unauth of special role for disabled RBAC system for "
+#define GR_UNSPROLES_ACL_MSG "successful unauth of special role %s (id %d) by "
+#define GR_INVMODE_ACL_MSG "invalid mode %d by "
+#define GR_PRIORITY_CHROOT_MSG "denied priority change of process (%.16s:%d) by "
+#define GR_FAILFORK_MSG "failed fork with errno %s by "
+#define GR_NICE_CHROOT_MSG "denied priority change by "
+#define GR_UNISIGLOG_MSG "%.32s occurred at %p in "
+#define GR_DUALSIGLOG_MSG "signal %d sent to " DEFAULTSECMSG " by "
+#define GR_SIG_ACL_MSG "denied send of signal %d to protected task " DEFAULTSECMSG " by "
+#define GR_SYSCTL_MSG "denied modification of grsecurity sysctl value : %.32s by "
+#define GR_SYSCTL_ACL_MSG "%s sysctl of %.950s for%s%s by "
+#define GR_TIME_MSG "time set by "
+#define GR_DEFACL_MSG "fatal: unable to find subject for (%.16s:%d), loaded by "
+#define GR_MMAP_ACL_MSG "%s executable mmap of %.950s by "
+#define GR_MPROTECT_ACL_MSG "%s executable mprotect of %.950s by "
+#define GR_SOCK_MSG "denied socket(%.16s,%.16s,%.16s) by "
+#define GR_SOCK_NOINET_MSG "denied socket(%.16s,%.16s,%d) by "
+#define GR_BIND_MSG "denied bind() by "
+#define GR_CONNECT_MSG "denied connect() by "
+#define GR_BIND_ACL_MSG "denied bind() to %pI4 port %u sock type %.16s protocol %.16s by "
+#define GR_CONNECT_ACL_MSG "denied connect() to %pI4 port %u sock type %.16s protocol %.16s by "
+#define GR_IP_LEARN_MSG "%s\t%u\t%u\t%u\t%.4095s\t%.4095s\t%pI4\t%u\t%u\t%u\t%u\t%pI4"
+#define GR_EXEC_CHROOT_MSG "exec of %.980s within chroot by process "
+#define GR_CAP_ACL_MSG "use of %s denied for "
+#define GR_CAP_CHROOT_MSG "use of %s in chroot denied for "
+#define GR_CAP_ACL_MSG2 "use of %s permitted for "
+#define GR_USRCHANGE_ACL_MSG "change to uid %u denied for "
+#define GR_GRPCHANGE_ACL_MSG "change to gid %u denied for "
+#define GR_REMOUNT_AUDIT_MSG "remount of %.256s by "
+#define GR_UNMOUNT_AUDIT_MSG "unmount of %.256s by "
+#define GR_MOUNT_AUDIT_MSG "mount of %.256s to %.256s by "
+#define GR_CHDIR_AUDIT_MSG "chdir to %.980s by "
+#define GR_EXEC_AUDIT_MSG "exec of %.930s (%.128s) by "
+#define GR_RESOURCE_MSG "denied resource overstep by requesting %lu for %.16s against limit %lu for "
+#define GR_RWXMMAP_MSG "denied RWX mmap of %.950s by "
+#define GR_RWXMPROTECT_MSG "denied RWX mprotect of %.950s by "
+#define GR_TEXTREL_AUDIT_MSG "allowed %s text relocation transition in %.950s, VMA:0x%08lx 0x%08lx by "
+#define GR_PTGNUSTACK_MSG "denied marking stack executable as requested by PT_GNU_STACK marking in %.950s by "
+#define GR_VM86_MSG "denied use of vm86 by "
+#define GR_PTRACE_AUDIT_MSG "process %.950s(%.16s:%d) attached to via ptrace by "
+#define GR_PTRACE_READEXEC_MSG "denied ptrace of unreadable binary %.950s by "
+#define GR_INIT_TRANSFER_MSG "persistent special role transferred privilege to init by "
+#define GR_BADPROCPID_MSG "denied read of sensitive /proc/pid/%s entry via fd passed across exec by "
+#define GR_SYMLINKOWNER_MSG "denied following symlink %.950s since symlink owner %u does not match target owner %u, by "
+#define GR_BRUTE_DAEMON_MSG "bruteforce prevention initiated for the next 30 minutes or until service restarted, stalling each fork 30 seconds.  Please investigate the crash report for "
+#define GR_BRUTE_SUID_MSG "bruteforce prevention initiated due to crash of %.950s against uid %u, banning suid/sgid execs for %u minutes.  Please investigate the crash report for "
+#define GR_IPC_DENIED_MSG "denied %s of overly-permissive IPC object with creator uid %u by "
+#define GR_TIOCSTI_MSG "denied unprivileged use of TIOCSTI by "
+#define GR_MSRWRITE_MSG "denied write to CPU MSR by "
diff --git b/include/linux/grsecurity.h b/include/linux/grsecurity.h
new file mode 100644
index 000000000..749b91501
--- /dev/null
+++ b/include/linux/grsecurity.h
@@ -0,0 +1,259 @@
+#ifndef GR_SECURITY_H
+#define GR_SECURITY_H
+#include <linux/fs.h>
+#include <linux/fs_struct.h>
+#include <linux/binfmts.h>
+#include <linux/tty.h>
+#include <linux/gracl.h>
+
+/* notify of brain-dead configs */
+#if defined(CONFIG_DEBUG_FS) && defined(CONFIG_GRKERNSEC_KMEM)
+#error "CONFIG_DEBUG_FS being enabled is a security risk when CONFIG_GRKERNSEC_KMEM is enabled"
+#endif
+#if defined(CONFIG_PROC_PAGE_MONITOR) && defined(CONFIG_GRKERNSEC)
+#error "CONFIG_PROC_PAGE_MONITOR is a security risk"
+#endif
+#if defined(CONFIG_GRKERNSEC_PROC_USER) && defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+#error "CONFIG_GRKERNSEC_PROC_USER and CONFIG_GRKERNSEC_PROC_USERGROUP cannot both be enabled."
+#endif
+#if defined(CONFIG_GRKERNSEC_PROC) && !defined(CONFIG_GRKERNSEC_PROC_USER) && !defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+#error "CONFIG_GRKERNSEC_PROC enabled, but neither CONFIG_GRKERNSEC_PROC_USER nor CONFIG_GRKERNSEC_PROC_USERGROUP enabled"
+#endif
+#if defined(CONFIG_PAX_NOEXEC) && !defined(CONFIG_PAX_PAGEEXEC) && !defined(CONFIG_PAX_SEGMEXEC) && !defined(CONFIG_PAX_KERNEXEC)
+#error "CONFIG_PAX_NOEXEC enabled, but PAGEEXEC, SEGMEXEC, and KERNEXEC are disabled."
+#endif
+#if defined(CONFIG_PAX_ASLR) && !defined(CONFIG_PAX_RANDKSTACK) && !defined(CONFIG_PAX_RANDUSTACK) && !defined(CONFIG_PAX_RANDMMAP)
+#error "CONFIG_PAX_ASLR enabled, but RANDKSTACK, RANDUSTACK, and RANDMMAP are disabled."
+#endif
+#if defined(CONFIG_PAX) && !defined(CONFIG_PAX_NOEXEC) && !defined(CONFIG_PAX_ASLR)
+#error "CONFIG_PAX enabled, but no PaX options are enabled."
+#endif
+
+int gr_handle_new_usb(void);
+
+void gr_handle_brute_attach(int dumpable);
+void gr_handle_brute_check(void);
+void gr_handle_kernel_exploit(void);
+
+char gr_roletype_to_char(void);
+
+int gr_proc_is_restricted(void);
+
+int gr_acl_enable_at_secure(void);
+
+int gr_check_user_change(kuid_t real, kuid_t effective, kuid_t fs);
+int gr_check_group_change(kgid_t real, kgid_t effective, kgid_t fs);
+
+int gr_learn_cap(const struct task_struct *task, const struct cred *cred, const int cap, bool log);
+
+void gr_del_task_from_ip_table(struct task_struct *p);
+
+int gr_pid_is_chrooted(struct task_struct *p);
+int gr_handle_chroot_fowner(struct pid *pid, enum pid_type type);
+int gr_handle_chroot_nice(void);
+int gr_handle_chroot_sysctl(const int op);
+int gr_handle_chroot_setpriority(struct task_struct *p,
+					const int niceval);
+int gr_chroot_fchdir(struct dentry *u_dentry, struct vfsmount *u_mnt);
+int gr_chroot_pathat(int dfd, struct dentry *u_dentry, struct vfsmount *u_mnt, unsigned flags);
+int gr_chroot_fhandle(void);
+int gr_handle_chroot_chroot(const struct dentry *dentry,
+				   const struct vfsmount *mnt);
+void gr_handle_chroot_chdir(const struct path *path);
+int gr_handle_chroot_chmod(const struct dentry *dentry,
+				  const struct vfsmount *mnt, const int mode);
+int gr_handle_chroot_mknod(const struct dentry *dentry,
+				  const struct vfsmount *mnt, const int mode);
+int gr_handle_chroot_mount(const struct dentry *dentry,
+				  const struct vfsmount *mnt,
+				  const char *dev_name);
+int gr_handle_chroot_pivot(void);
+int gr_handle_chroot_unix(const pid_t pid);
+
+int gr_handle_rawio(const struct inode *inode);
+
+void gr_handle_ioperm(void);
+void gr_handle_iopl(void);
+void gr_handle_msr_write(void);
+
+umode_t gr_acl_umask(void);
+
+int gr_tpe_allow(const struct file *file);
+
+void gr_set_chroot_entries(struct task_struct *task, const struct path *path);
+void gr_clear_chroot_entries(struct task_struct *task);
+
+void gr_log_forkfail(const int retval);
+void gr_log_timechange(void);
+void gr_log_signal(const int sig, const void *addr, const struct task_struct *t);
+void gr_log_chdir(const struct dentry *dentry,
+			 const struct vfsmount *mnt);
+void gr_log_chroot_exec(const struct dentry *dentry,
+			       const struct vfsmount *mnt);
+void gr_log_remount(const char *devname, const int retval);
+void gr_log_unmount(const char *devname, const int retval);
+void gr_log_mount(const char *from, struct path *to, const int retval);
+void gr_log_textrel(struct vm_area_struct *vma, bool is_textrel_rw);
+void gr_log_ptgnustack(struct file *file);
+void gr_log_rwxmmap(struct file *file);
+void gr_log_rwxmprotect(struct vm_area_struct *vma);
+
+int gr_handle_follow_link(const struct dentry *dentry,
+				 const struct vfsmount *mnt);
+int gr_handle_fifo(const struct dentry *dentry,
+			  const struct vfsmount *mnt,
+			  const struct dentry *dir, const int flag,
+			  const int acc_mode);
+int gr_handle_hardlink(const struct dentry *dentry,
+			      const struct vfsmount *mnt,
+			      const struct filename *to);
+
+int gr_is_capable(const int cap);
+int gr_is_capable_nolog(const int cap);
+int gr_task_is_capable(const struct task_struct *task, const struct cred *cred, const int cap);
+int gr_task_is_capable_nolog(const struct task_struct *task, const struct cred *cred, const int cap);
+
+void gr_copy_label(struct task_struct *tsk);
+void gr_handle_crash(struct task_struct *task, const int sig);
+int gr_handle_signal(const struct task_struct *p, const int sig);
+int gr_check_crash_uid(const kuid_t uid);
+int gr_check_protected_task(const struct task_struct *task);
+int gr_check_protected_task_fowner(struct pid *pid, enum pid_type type);
+int gr_acl_handle_mmap(const struct file *file,
+			      const unsigned long prot);
+int gr_acl_handle_mprotect(const struct file *file,
+				  const unsigned long prot);
+int gr_check_hidden_task(const struct task_struct *tsk);
+__u32 gr_acl_handle_truncate(const struct dentry *dentry,
+				    const struct vfsmount *mnt);
+__u32 gr_acl_handle_utime(const struct dentry *dentry,
+				 const struct vfsmount *mnt);
+__u32 gr_acl_handle_access(const struct dentry *dentry,
+				  const struct vfsmount *mnt, const int fmode);
+__u32 gr_acl_handle_chmod(const struct dentry *dentry,
+				 const struct vfsmount *mnt, umode_t *mode);
+__u32 gr_acl_handle_chown(const struct dentry *dentry,
+				 const struct vfsmount *mnt);
+__u32 gr_acl_handle_setxattr(const struct dentry *dentry,
+				 const struct vfsmount *mnt);
+__u32 gr_acl_handle_removexattr(const struct dentry *dentry,
+				 const struct vfsmount *mnt);
+int gr_handle_ptrace(struct task_struct *task, const long request);
+int gr_handle_proc_ptrace(struct task_struct *task);
+__u32 gr_acl_handle_execve(const struct dentry *dentry,
+				  const struct vfsmount *mnt);
+int gr_check_crash_exec(const struct file *filp);
+int gr_acl_is_enabled(void);
+void gr_set_role_label(struct task_struct *task, const kuid_t uid,
+			      const kgid_t gid);
+int gr_set_proc_label(const struct dentry *dentry,
+			const struct vfsmount *mnt,
+			const int unsafe_flags);
+__u32 gr_acl_handle_hidden_file(const struct dentry *dentry,
+				const struct vfsmount *mnt);
+__u32 gr_acl_handle_open(const struct dentry *dentry,
+				const struct vfsmount *mnt, int acc_mode);
+__u32 gr_acl_handle_creat(const struct dentry *dentry,
+				 const struct dentry *p_dentry,
+				 const struct vfsmount *p_mnt,
+				 int open_flags, int acc_mode, const int imode);
+void gr_handle_create(const struct dentry *dentry,
+			     const struct vfsmount *mnt);
+void gr_handle_proc_create(const struct dentry *dentry,
+			   const struct inode *inode);
+__u32 gr_acl_handle_mknod(const struct dentry *new_dentry,
+				 const struct dentry *parent_dentry,
+				 const struct vfsmount *parent_mnt,
+				 const int mode);
+__u32 gr_acl_handle_mkdir(const struct dentry *new_dentry,
+				 const struct dentry *parent_dentry,
+				 const struct vfsmount *parent_mnt);
+__u32 gr_acl_handle_rmdir(const struct dentry *dentry,
+				 const struct vfsmount *mnt);
+void gr_handle_delete(const u64 ino, const dev_t dev);
+__u32 gr_acl_handle_unlink(const struct dentry *dentry,
+				  const struct vfsmount *mnt);
+__u32 gr_acl_handle_symlink(const struct dentry *new_dentry,
+				   const struct dentry *parent_dentry,
+				   const struct vfsmount *parent_mnt,
+				   const struct filename *from);
+__u32 gr_acl_handle_link(const struct dentry *new_dentry,
+				const struct dentry *parent_dentry,
+				const struct vfsmount *parent_mnt,
+				const struct dentry *old_dentry,
+				const struct vfsmount *old_mnt, const struct filename *to);
+int gr_handle_symlink_owner(const struct path *link, const struct inode *target);
+int gr_acl_handle_rename(struct dentry *new_dentry,
+				struct dentry *parent_dentry,
+				const struct vfsmount *parent_mnt,
+				struct dentry *old_dentry,
+				struct inode *old_parent_inode,
+				struct vfsmount *old_mnt, const struct filename *newname, unsigned int flags);
+void gr_handle_rename(struct inode *old_dir, struct inode *new_dir,
+				struct dentry *old_dentry,
+				struct dentry *new_dentry,
+				struct vfsmount *mnt, const __u8 replace, unsigned int flags);
+__u32 gr_check_link(const struct dentry *new_dentry,
+			   const struct dentry *parent_dentry,
+			   const struct vfsmount *parent_mnt,
+			   const struct dentry *old_dentry,
+			   const struct vfsmount *old_mnt);
+int gr_acl_handle_filldir(const struct file *file, const char *name,
+				 const unsigned int namelen, const u64 ino);
+
+__u32 gr_acl_handle_unix(const struct dentry *dentry,
+				const struct vfsmount *mnt);
+void gr_acl_handle_exit(void);
+void gr_acl_handle_psacct(struct task_struct *task, const long code);
+int gr_acl_handle_procpidmem(const struct task_struct *task);
+int gr_handle_rofs_mount(struct dentry *dentry, struct vfsmount *mnt, int mnt_flags);
+int gr_handle_rofs_blockwrite(struct dentry *dentry, struct vfsmount *mnt, int acc_mode);
+void gr_audit_ptrace(struct task_struct *task);
+dev_t gr_get_dev_from_dentry(struct dentry *dentry);
+u64 gr_get_ino_from_dentry(struct dentry *dentry);
+void gr_put_exec_file(struct task_struct *task);
+
+int gr_get_symlinkown_enabled(void);
+
+int gr_ptrace_readexec(struct file *file, int unsafe_flags);
+
+int gr_handle_tiocsti(struct tty_struct *tty);
+
+void gr_inc_chroot_refcnts(struct dentry *dentry, struct vfsmount *mnt);
+void gr_dec_chroot_refcnts(struct dentry *dentry, struct vfsmount *mnt);
+int gr_bad_chroot_rename(struct dentry *olddentry, struct vfsmount *oldmnt,
+			 struct dentry *newdentry, struct vfsmount *newmnt);
+
+#ifdef CONFIG_GRKERNSEC_RESLOG
+extern void gr_log_resource(const struct task_struct *task, const int res,
+				   const unsigned long wanted, const int gt);
+#else
+static inline void gr_log_resource(const struct task_struct *task, const int res,
+				   const unsigned long wanted, const int gt)
+{
+}
+#endif
+
+#ifdef CONFIG_GRKERNSEC
+void task_grsec_rbac(struct seq_file *m, struct task_struct *p);
+void gr_handle_vm86(void);
+void gr_handle_mem_readwrite(u64 from, u64 to);
+
+void gr_log_badprocpid(const char *entry);
+
+extern int grsec_enable_dmesg;
+extern int grsec_disable_privio;
+
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+extern kgid_t grsec_proc_gid;
+#endif
+
+#ifdef CONFIG_GRKERNSEC_CHROOT_FINDTASK
+extern int grsec_enable_chroot_findtask;
+#endif
+#ifdef CONFIG_GRKERNSEC_SETXID
+extern int grsec_enable_setxid;
+#endif
+#endif
+
+#endif
diff --git b/include/linux/grsock.h b/include/linux/grsock.h
new file mode 100644
index 000000000..e7ffaafc5
--- /dev/null
+++ b/include/linux/grsock.h
@@ -0,0 +1,19 @@
+#ifndef __GRSOCK_H
+#define __GRSOCK_H
+
+extern void gr_attach_curr_ip(const struct sock *sk);
+extern int gr_handle_sock_all(const int family, const int type,
+			      const int protocol);
+extern int gr_handle_sock_server(const struct sockaddr *sck);
+extern int gr_handle_sock_server_other(const struct sock *sck);
+extern int gr_handle_sock_client(const struct sockaddr *sck);
+extern int gr_search_connect(struct socket * sock,
+			     struct sockaddr_in * addr);
+extern int gr_search_bind(struct socket * sock,
+			  struct sockaddr_in * addr);
+extern int gr_search_listen(struct socket * sock);
+extern int gr_search_accept(struct socket * sock);
+extern int gr_search_socket(const int domain, const int type,
+			    const int protocol);
+
+#endif
diff --git a/include/linux/highmem.h b/include/linux/highmem.h
index bb3f32970..9daed5506 100644
--- a/include/linux/highmem.h
+++ b/include/linux/highmem.h
@@ -190,6 +190,18 @@ static inline void clear_highpage(struct page *page)
 	kunmap_atomic(kaddr);
 }
 
+static inline void sanitize_highpage(struct page *page)
+{
+	void *kaddr;
+	unsigned long flags;
+
+	local_irq_save(flags);
+	kaddr = kmap_atomic(page);
+	clear_page(kaddr);
+	kunmap_atomic(kaddr);
+	local_irq_restore(flags);
+}
+
 static inline void zero_user_segments(struct page *page,
 	unsigned start1, unsigned end1,
 	unsigned start2, unsigned end2)
diff --git a/include/linux/hugetlb.h b/include/linux/hugetlb.h
index fe99e6f95..b2e62ec78 100644
--- a/include/linux/hugetlb.h
+++ b/include/linux/hugetlb.h
@@ -314,7 +314,7 @@ struct hstate {
 	unsigned int surplus_huge_pages_node[MAX_NUMNODES];
 #ifdef CONFIG_CGROUP_HUGETLB
 	/* cgroup control files */
-	struct cftype cgroup_files[5];
+	struct cftype (*cgroup_files)[5];
 #endif
 	char name[HSTATE_NAME_LEN];
 };
diff --git a/include/linux/hugetlb_cgroup.h b/include/linux/hugetlb_cgroup.h
index 063962f6d..d34f2daf7 100644
--- a/include/linux/hugetlb_cgroup.h
+++ b/include/linux/hugetlb_cgroup.h
@@ -26,6 +26,13 @@ struct hugetlb_cgroup;
 
 #ifdef CONFIG_CGROUP_HUGETLB
 
+enum {
+	RES_USAGE,
+	RES_LIMIT,
+	RES_MAX_USAGE,
+	RES_FAILCNT,
+};
+
 static inline struct hugetlb_cgroup *hugetlb_cgroup_from_page(struct page *page)
 {
 	VM_BUG_ON_PAGE(!PageHuge(page), page);
@@ -64,6 +71,10 @@ extern void hugetlb_cgroup_file_init(void) __init;
 extern void hugetlb_cgroup_migrate(struct page *oldhpage,
 				   struct page *newhpage);
 
+ssize_t hugetlb_cgroup_reset(struct kernfs_open_file *of, char *buf, size_t nbytes, loff_t off);
+ssize_t hugetlb_cgroup_write(struct kernfs_open_file *of, char *buf, size_t nbytes, loff_t off);
+u64 hugetlb_cgroup_read_u64(struct cgroup_subsys_state *css, struct cftype *cft);
+
 #else
 static inline struct hugetlb_cgroup *hugetlb_cgroup_from_page(struct page *page)
 {
diff --git a/include/linux/hwmon-sysfs.h b/include/linux/hwmon-sysfs.h
index 1c7b89ae6..7dda4003a 100644
--- a/include/linux/hwmon-sysfs.h
+++ b/include/linux/hwmon-sysfs.h
@@ -25,7 +25,8 @@
 struct sensor_device_attribute{
 	struct device_attribute dev_attr;
 	int index;
-};
+} __do_const;
+typedef struct sensor_device_attribute __no_const sensor_device_attribute_no_const;
 #define to_sensor_dev_attr(_dev_attr) \
 	container_of(_dev_attr, struct sensor_device_attribute, dev_attr)
 
@@ -41,7 +42,8 @@ struct sensor_device_attribute_2 {
 	struct device_attribute dev_attr;
 	u8 index;
 	u8 nr;
-};
+} __do_const;
+typedef struct sensor_device_attribute_2 __no_const sensor_device_attribute_2_no_const;
 #define to_sensor_dev_attr_2(_dev_attr) \
 	container_of(_dev_attr, struct sensor_device_attribute_2, dev_attr)
 
diff --git a/include/linux/i2c.h b/include/linux/i2c.h
index fffdc270c..122364f1c 100644
--- a/include/linux/i2c.h
+++ b/include/linux/i2c.h
@@ -425,6 +425,7 @@ struct i2c_algorithm {
 	int (*unreg_slave)(struct i2c_client *client);
 #endif
 };
+typedef struct i2c_algorithm __no_const i2c_algorithm_no_const;
 
 /**
  * struct i2c_timings - I2C timing information
diff --git a/include/linux/if_pppox.h b/include/linux/if_pppox.h
index ba7a9b0c7..33a023736 100644
--- a/include/linux/if_pppox.h
+++ b/include/linux/if_pppox.h
@@ -78,7 +78,7 @@ struct pppox_proto {
 	int		(*ioctl)(struct socket *sock, unsigned int cmd,
 				 unsigned long arg);
 	struct module	*owner;
-};
+} __do_const;
 
 extern int register_pppox_proto(int proto_num, const struct pppox_proto *pp);
 extern void unregister_pppox_proto(int proto_num);
diff --git a/include/linux/init.h b/include/linux/init.h
index 6935d0247..5e3f46eb6 100644
--- a/include/linux/init.h
+++ b/include/linux/init.h
@@ -39,7 +39,7 @@
 
 /* These are for everybody (although not all archs will actually
    discard it in modules) */
-#define __init		__section(.init.text) __cold notrace
+#define __init		__section(.init.text) __cold notrace __latent_entropy
 #define __initdata	__section(.init.data)
 #define __initconst	__constsection(.init.rodata)
 #define __exitdata	__section(.exit.data)
@@ -86,7 +86,7 @@
 #define __exit          __section(.exit.text) __exitused __cold notrace
 
 /* Used for MEMORY_HOTPLUG */
-#define __meminit        __section(.meminit.text) __cold notrace
+#define __meminit        __section(.meminit.text) __cold notrace __latent_entropy
 #define __meminitdata    __section(.meminit.data)
 #define __meminitconst   __constsection(.meminit.rodata)
 #define __memexit        __section(.memexit.text) __exitused __cold notrace
@@ -111,6 +111,12 @@
 #define __REFDATA        .section       ".ref.data", "aw"
 #define __REFCONST       .section       ".ref.rodata", "a"
 
+#ifdef CONFIG_PAX_KERNEXEC
+#define __READ_ONLY	.section	".data..read_only","a",%progbits
+#else
+#define __READ_ONLY	.section	".data..mostly","aw",%progbits
+#endif
+
 #ifndef __ASSEMBLY__
 /*
  * Used for initialization calls..
diff --git a/include/linux/init_task.h b/include/linux/init_task.h
index f8834f820..9884265bf 100644
--- a/include/linux/init_task.h
+++ b/include/linux/init_task.h
@@ -159,6 +159,12 @@ extern struct task_group root_task_group;
 
 #define INIT_TASK_COMM "swapper"
 
+#ifdef CONFIG_X86
+#define INIT_TASK_THREAD_INFO .tinfo = INIT_THREAD_INFO,
+#else
+#define INIT_TASK_THREAD_INFO
+#endif
+
 #ifdef CONFIG_RT_MUTEXES
 # define INIT_RT_MUTEXES(tsk)						\
 	.pi_waiters = RB_ROOT,						\
@@ -225,6 +231,7 @@ extern struct task_group root_task_group;
 	RCU_POINTER_INITIALIZER(cred, &init_cred),			\
 	.comm		= INIT_TASK_COMM,				\
 	.thread		= INIT_THREAD,					\
+	INIT_TASK_THREAD_INFO						\
 	.fs		= &init_fs,					\
 	.files		= &init_files,					\
 	.signal		= &init_signals,				\
@@ -233,7 +240,6 @@ extern struct task_group root_task_group;
 	.pending	= {						\
 		.list = LIST_HEAD_INIT(tsk.pending.list),		\
 		.signal = {{0}}},					\
-	.blocked	= {{0}},					\
 	.alloc_lock	= __SPIN_LOCK_UNLOCKED(tsk.alloc_lock),		\
 	.journal_info	= NULL,						\
 	.cpu_timers	= INIT_CPU_TIMERS(tsk.cpu_timers),		\
diff --git a/include/linux/interrupt.h b/include/linux/interrupt.h
index b6683f0ff..9c8f3914e 100644
--- a/include/linux/interrupt.h
+++ b/include/linux/interrupt.h
@@ -454,8 +454,8 @@ extern const char * const softirq_to_name[NR_SOFTIRQS];
 
 struct softirq_action
 {
-	void	(*action)(struct softirq_action *);
-};
+	void	(*action)(void);
+} __no_const;
 
 asmlinkage void do_softirq(void);
 asmlinkage void __do_softirq(void);
@@ -469,7 +469,7 @@ static inline void do_softirq_own_stack(void)
 }
 #endif
 
-extern void open_softirq(int nr, void (*action)(struct softirq_action *));
+extern void open_softirq(int nr, void (*action)(void));
 extern void softirq_init(void);
 extern void __raise_softirq_irqoff(unsigned int nr);
 
diff --git a/include/linux/iommu.h b/include/linux/iommu.h
index a35fb8b42..bceb84fa5 100644
--- a/include/linux/iommu.h
+++ b/include/linux/iommu.h
@@ -202,7 +202,7 @@ struct iommu_ops {
 	int (*of_xlate)(struct device *dev, struct of_phandle_args *args);
 
 	unsigned long pgsize_bitmap;
-};
+} __do_const;
 
 #define IOMMU_GROUP_NOTIFY_ADD_DEVICE		1 /* Device added */
 #define IOMMU_GROUP_NOTIFY_DEL_DEVICE		2 /* Pre Device removed */
diff --git a/include/linux/ioport.h b/include/linux/ioport.h
index 6230064d7..1ccafa4df 100644
--- a/include/linux/ioport.h
+++ b/include/linux/ioport.h
@@ -190,7 +190,7 @@ struct resource *lookup_resource(struct resource *root, resource_size_t start);
 int adjust_resource(struct resource *res, resource_size_t start,
 		    resource_size_t size);
 resource_size_t resource_alignment(struct resource *res);
-static inline resource_size_t resource_size(const struct resource *res)
+static inline resource_size_t __intentional_overflow(-1) resource_size(const struct resource *res)
 {
 	return res->end - res->start + 1;
 }
diff --git a/include/linux/ipc.h b/include/linux/ipc.h
index 9d84942ae..12d5bdf5b 100644
--- a/include/linux/ipc.h
+++ b/include/linux/ipc.h
@@ -19,8 +19,8 @@ struct kern_ipc_perm
 	kuid_t		cuid;
 	kgid_t		cgid;
 	umode_t		mode; 
-	unsigned long	seq;
+	unsigned long	seq __intentional_overflow(-1);
 	void		*security;
-};
+} __randomize_layout;
 
 #endif /* _LINUX_IPC_H */
diff --git a/include/linux/ipc_namespace.h b/include/linux/ipc_namespace.h
index d10e54f03..c68f8af9e 100644
--- a/include/linux/ipc_namespace.h
+++ b/include/linux/ipc_namespace.h
@@ -60,7 +60,7 @@ struct ipc_namespace {
 	struct user_namespace *user_ns;
 
 	struct ns_common ns;
-};
+} __randomize_layout;
 
 extern struct ipc_namespace init_ipc_ns;
 extern spinlock_t mq_lock;
diff --git a/include/linux/irq.h b/include/linux/irq.h
index 0ac26c892..3bb92a39d 100644
--- a/include/linux/irq.h
+++ b/include/linux/irq.h
@@ -408,7 +408,10 @@ struct irq_chip {
 	void		(*ipi_send_mask)(struct irq_data *data, const struct cpumask *dest);
 
 	unsigned long	flags;
-};
+} __do_const;
+#ifndef _LINUX_IRQDOMAIN_H
+typedef struct irq_chip __no_const irq_chip_no_const;
+#endif
 
 /*
  * irq_chip specific flags
diff --git a/include/linux/irqchip/mmp.h b/include/linux/irqchip/mmp.h
index c78a89211..124e0b786 100644
--- a/include/linux/irqchip/mmp.h
+++ b/include/linux/irqchip/mmp.h
@@ -1,6 +1,6 @@
 #ifndef	__IRQCHIP_MMP_H
 #define	__IRQCHIP_MMP_H
 
-extern struct irq_chip icu_irq_chip;
+extern irq_chip_no_const icu_irq_chip;
 
 #endif	/* __IRQCHIP_MMP_H */
diff --git a/include/linux/irqdesc.h b/include/linux/irqdesc.h
index b51beebf9..72974cf09 100644
--- a/include/linux/irqdesc.h
+++ b/include/linux/irqdesc.h
@@ -62,7 +62,7 @@ struct irq_desc {
 	unsigned int		irq_count;	/* For detecting broken IRQs */
 	unsigned long		last_unhandled;	/* Aging timer for unhandled count */
 	unsigned int		irqs_unhandled;
-	atomic_t		threads_handled;
+	atomic_unchecked_t	threads_handled;
 	int			threads_handled_last;
 	raw_spinlock_t		lock;
 	struct cpumask		*percpu_enabled;
diff --git a/include/linux/irqdomain.h b/include/linux/irqdomain.h
index ffb84604c..1ef103158 100644
--- a/include/linux/irqdomain.h
+++ b/include/linux/irqdomain.h
@@ -38,6 +38,9 @@ struct device_node;
 struct irq_domain;
 struct of_device_id;
 struct irq_chip;
+#ifndef _LINUX_IRQ_H
+typedef struct irq_chip __no_const irq_chip_no_const;
+#endif
 struct irq_data;
 struct cpumask;
 
diff --git a/include/linux/jbd2.h b/include/linux/jbd2.h
index dfaa1f4dc..a66f30d2d 100644
--- a/include/linux/jbd2.h
+++ b/include/linux/jbd2.h
@@ -676,7 +676,7 @@ struct transaction_s
 	/*
 	 * How many handles used this transaction? [t_handle_lock]
 	 */
-	atomic_t		t_handle_count;
+	atomic_unchecked_t	t_handle_count;
 
 	/*
 	 * This transaction is being forced and some process is
diff --git a/include/linux/jiffies.h b/include/linux/jiffies.h
index 5fdc55312..766e16912 100644
--- a/include/linux/jiffies.h
+++ b/include/linux/jiffies.h
@@ -284,19 +284,19 @@ extern unsigned long preset_lpj;
 extern unsigned int jiffies_to_msecs(const unsigned long j);
 extern unsigned int jiffies_to_usecs(const unsigned long j);
 
-static inline u64 jiffies_to_nsecs(const unsigned long j)
+static inline u64 __intentional_overflow(-1) jiffies_to_nsecs(const unsigned long j)
 {
 	return (u64)jiffies_to_usecs(j) * NSEC_PER_USEC;
 }
 
-extern unsigned long __msecs_to_jiffies(const unsigned int m);
+extern unsigned long __msecs_to_jiffies(const unsigned int m) __intentional_overflow(-1);
 #if HZ <= MSEC_PER_SEC && !(MSEC_PER_SEC % HZ)
 /*
  * HZ is equal to or smaller than 1000, and 1000 is a nice round
  * multiple of HZ, divide with the factor between them, but round
  * upwards:
  */
-static inline unsigned long _msecs_to_jiffies(const unsigned int m)
+static inline unsigned long __intentional_overflow(-1) _msecs_to_jiffies(const unsigned int m)
 {
 	return (m + (MSEC_PER_SEC / HZ) - 1) / (MSEC_PER_SEC / HZ);
 }
@@ -307,7 +307,7 @@ static inline unsigned long _msecs_to_jiffies(const unsigned int m)
  *
  * But first make sure the multiplication result cannot overflow:
  */
-static inline unsigned long _msecs_to_jiffies(const unsigned int m)
+static inline unsigned long __intentional_overflow(-1) _msecs_to_jiffies(const unsigned int m)
 {
 	if (m > jiffies_to_msecs(MAX_JIFFY_OFFSET))
 		return MAX_JIFFY_OFFSET;
@@ -318,7 +318,7 @@ static inline unsigned long _msecs_to_jiffies(const unsigned int m)
  * Generic case - multiply, round and divide. But first check that if
  * we are doing a net multiplication, that we wouldn't overflow:
  */
-static inline unsigned long _msecs_to_jiffies(const unsigned int m)
+static inline unsigned long __intentional_overflow(-1) _msecs_to_jiffies(const unsigned int m)
 {
 	if (HZ > MSEC_PER_SEC && m > jiffies_to_msecs(MAX_JIFFY_OFFSET))
 		return MAX_JIFFY_OFFSET;
@@ -362,14 +362,14 @@ static __always_inline unsigned long msecs_to_jiffies(const unsigned int m)
 	}
 }
 
-extern unsigned long __usecs_to_jiffies(const unsigned int u);
+extern unsigned long __usecs_to_jiffies(const unsigned int u) __intentional_overflow(-1);
 #if !(USEC_PER_SEC % HZ)
-static inline unsigned long _usecs_to_jiffies(const unsigned int u)
+static inline unsigned long __intentional_overflow(-1) _usecs_to_jiffies(const unsigned int u)
 {
 	return (u + (USEC_PER_SEC / HZ) - 1) / (USEC_PER_SEC / HZ);
 }
 #else
-static inline unsigned long _usecs_to_jiffies(const unsigned int u)
+static inline unsigned long __intentional_overflow(-1) _usecs_to_jiffies(const unsigned int u)
 {
 	return (USEC_TO_HZ_MUL32 * u + USEC_TO_HZ_ADJ32)
 		>> USEC_TO_HZ_SHR32;
diff --git a/include/linux/kallsyms.h b/include/linux/kallsyms.h
index 6883e197a..d2c774623 100644
--- a/include/linux/kallsyms.h
+++ b/include/linux/kallsyms.h
@@ -15,7 +15,8 @@
 
 struct module;
 
-#ifdef CONFIG_KALLSYMS
+#if !defined(__INCLUDED_BY_HIDESYM) || !defined(CONFIG_KALLSYMS)
+#if defined(CONFIG_KALLSYMS) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 /* Lookup the address for a symbol. Returns 0 if not found. */
 unsigned long kallsyms_lookup_name(const char *name);
 
@@ -40,7 +41,7 @@ extern int sprint_symbol_no_offset(char *buffer, unsigned long address);
 extern int sprint_backtrace(char *buffer, unsigned long address);
 
 /* Look up a kernel symbol and print it to the kernel messages. */
-extern void __print_symbol(const char *fmt, unsigned long address);
+extern __printf(1, 3) void __print_symbol(const char *fmt, unsigned long address, ...);
 
 int lookup_symbol_name(unsigned long addr, char *symname);
 int lookup_symbol_attrs(unsigned long addr, unsigned long *size, unsigned long *offset, char *modname, char *name);
@@ -104,21 +105,26 @@ static inline int lookup_symbol_attrs(unsigned long addr, unsigned long *size, u
 }
 
 /* Stupid that this does nothing, but I didn't create this mess. */
-#define __print_symbol(fmt, addr)
+#define __print_symbol(fmt, addr, args...)
 #endif /*CONFIG_KALLSYMS*/
+#else /* when included by kallsyms.c, vsnprintf.c, kprobes.c, or
+	arch/x86/kernel/dumpstack.c, with HIDESYM enabled */
+extern unsigned long kallsyms_lookup_name(const char *name);
+extern __printf(1, 3) void __print_symbol(const char *fmt, unsigned long address, ...);
+extern int sprint_backtrace(char *buffer, unsigned long address);
+extern int sprint_symbol(char *buffer, unsigned long address);
+extern int sprint_symbol_no_offset(char *buffer, unsigned long address);
+const char *kallsyms_lookup(unsigned long addr,
+			    unsigned long *symbolsize,
+			    unsigned long *offset,
+			    char **modname, char *namebuf);
+extern int kallsyms_lookup_size_offset(unsigned long addr,
+				  unsigned long *symbolsize,
+				  unsigned long *offset);
+#endif
 
-/* This macro allows us to keep printk typechecking */
-static __printf(1, 2)
-void __check_printsym_format(const char *fmt, ...)
-{
-}
-
-static inline void print_symbol(const char *fmt, unsigned long addr)
-{
-	__check_printsym_format(fmt, "");
-	__print_symbol(fmt, (unsigned long)
-		       __builtin_extract_return_addr((void *)addr));
-}
+#define print_symbol(fmt, addr) \
+	__print_symbol(fmt, addr, "")
 
 static inline void print_ip_sym(unsigned long ip)
 {
diff --git a/include/linux/key-type.h b/include/linux/key-type.h
index eaee981c5..d1d24c37f 100644
--- a/include/linux/key-type.h
+++ b/include/linux/key-type.h
@@ -45,7 +45,7 @@ struct key_preparsed_payload {
 	size_t		datalen;	/* Raw datalen */
 	size_t		quotalen;	/* Quota length for proposed payload */
 	time_t		expiry;		/* Expiry time of key */
-};
+} __randomize_layout;
 
 typedef int (*request_key_actor_t)(struct key_construction *key,
 				   const char *op, void *aux);
@@ -150,7 +150,7 @@ struct key_type {
 	/* internal fields */
 	struct list_head	link;		/* link in types list */
 	struct lock_class_key	lock_class;	/* key->sem lock class */
-};
+} __do_const __randomize_layout;
 
 extern struct key_type key_type_keyring;
 
diff --git a/include/linux/kgdb.h b/include/linux/kgdb.h
index e465bb159..19f605fd2 100644
--- a/include/linux/kgdb.h
+++ b/include/linux/kgdb.h
@@ -52,7 +52,7 @@ extern int kgdb_connected;
 extern int kgdb_io_module_registered;
 
 extern atomic_t			kgdb_setting_breakpoint;
-extern atomic_t			kgdb_cpu_doing_single_step;
+extern atomic_unchecked_t	kgdb_cpu_doing_single_step;
 
 extern struct task_struct	*kgdb_usethread;
 extern struct task_struct	*kgdb_contthread;
@@ -254,7 +254,7 @@ struct kgdb_arch {
 	void	(*correct_hw_break)(void);
 
 	void	(*enable_nmi)(bool on);
-};
+} __do_const;
 
 /**
  * struct kgdb_io - Describe the interface for an I/O driver to talk with KGDB.
@@ -279,7 +279,7 @@ struct kgdb_io {
 	void			(*pre_exception) (void);
 	void			(*post_exception) (void);
 	int			is_console;
-};
+} __do_const;
 
 extern struct kgdb_arch		arch_kgdb_ops;
 
diff --git a/include/linux/kmemleak.h b/include/linux/kmemleak.h
index 4894c6888..7824e6ac6 100644
--- a/include/linux/kmemleak.h
+++ b/include/linux/kmemleak.h
@@ -27,7 +27,7 @@
 
 extern void kmemleak_init(void) __init;
 extern void kmemleak_alloc(const void *ptr, size_t size, int min_count,
-			   gfp_t gfp) __ref;
+			   gfp_t gfp) __ref __size_overflow(2);
 extern void kmemleak_alloc_percpu(const void __percpu *ptr, size_t size,
 				  gfp_t gfp) __ref;
 extern void kmemleak_free(const void *ptr) __ref;
@@ -63,7 +63,7 @@ static inline void kmemleak_erase(void **ptr)
 static inline void kmemleak_init(void)
 {
 }
-static inline void kmemleak_alloc(const void *ptr, size_t size, int min_count,
+static inline void __size_overflow(2) kmemleak_alloc(const void *ptr, size_t size, int min_count,
 				  gfp_t gfp)
 {
 }
diff --git a/include/linux/kmod.h b/include/linux/kmod.h
index fcfd2bf14..e4f5edba0 100644
--- a/include/linux/kmod.h
+++ b/include/linux/kmod.h
@@ -34,6 +34,8 @@ extern char modprobe_path[]; /* for sysctl */
  * usually useless though. */
 extern __printf(2, 3)
 int __request_module(bool wait, const char *name, ...);
+extern __printf(3, 4)
+int ___request_module(bool wait, char *param_name, const char *name, ...);
 #define request_module(mod...) __request_module(true, mod)
 #define request_module_nowait(mod...) __request_module(false, mod)
 #define try_then_request_module(x, mod...) \
@@ -57,6 +59,9 @@ struct subprocess_info {
 	struct work_struct work;
 	struct completion *complete;
 	char *path;
+#ifdef CONFIG_GRKERNSEC
+	char *origpath;
+#endif
 	char **argv;
 	char **envp;
 	int wait;
@@ -64,7 +69,7 @@ struct subprocess_info {
 	int (*init)(struct subprocess_info *info, struct cred *new);
 	void (*cleanup)(struct subprocess_info *info);
 	void *data;
-};
+} __randomize_layout;
 
 extern int
 call_usermodehelper(char *path, char **argv, char **envp, int wait);
diff --git a/include/linux/kobject.h b/include/linux/kobject.h
index e62845915..9d45d56c5 100644
--- a/include/linux/kobject.h
+++ b/include/linux/kobject.h
@@ -119,7 +119,7 @@ struct kobj_type {
 	struct attribute **default_attrs;
 	const struct kobj_ns_type_operations *(*child_ns_type)(struct kobject *kobj);
 	const void *(*namespace)(struct kobject *kobj);
-};
+} __do_const;
 
 struct kobj_uevent_env {
 	char *argv[3];
@@ -143,6 +143,14 @@ struct kobj_attribute {
 	ssize_t (*store)(struct kobject *kobj, struct kobj_attribute *attr,
 			 const char *buf, size_t count);
 };
+typedef struct kobj_attribute __no_const kobj_attribute_no_const;
+
+#define KOBJECT_ATTR(_name, _mode, _show, _store) \
+	struct kobj_attribute dev_attr_##_name = __ATTR(_name, _mode, _show, _store)
+#define KOBJECT_ATTR_RW(_name) \
+	struct kobj_attribute dev_attr_##_name = __ATTR_RW(_name)
+#define KOBJECT_ATTR_RO(_name) \
+	struct kobj_attribute dev_attr_##_name = __ATTR_RO(_name)
 
 extern const struct sysfs_ops kobj_sysfs_ops;
 
@@ -170,7 +178,7 @@ struct kset {
 	spinlock_t list_lock;
 	struct kobject kobj;
 	const struct kset_uevent_ops *uevent_ops;
-};
+} __randomize_layout;
 
 extern void kset_init(struct kset *kset);
 extern int __must_check kset_register(struct kset *kset);
diff --git a/include/linux/kobject_ns.h b/include/linux/kobject_ns.h
index df32d2508..fb52e27d5 100644
--- a/include/linux/kobject_ns.h
+++ b/include/linux/kobject_ns.h
@@ -44,7 +44,7 @@ struct kobj_ns_type_operations {
 	const void *(*netlink_ns)(struct sock *sk);
 	const void *(*initial_ns)(void);
 	void (*drop_ns)(void *);
-};
+} __do_const;
 
 int kobj_ns_type_register(const struct kobj_ns_type_operations *ops);
 int kobj_ns_type_registered(enum kobj_ns_type type);
diff --git a/include/linux/kref.h b/include/linux/kref.h
index e15828fd7..531fd0a59 100644
--- a/include/linux/kref.h
+++ b/include/linux/kref.h
@@ -67,7 +67,7 @@ static inline void kref_get(struct kref *kref)
 static inline int kref_sub(struct kref *kref, unsigned int count,
 	     void (*release)(struct kref *kref))
 {
-	WARN_ON(release == NULL);
+	BUG_ON(release == NULL);
 
 	if (atomic_sub_and_test((int) count, &kref->refcount)) {
 		release(kref);
diff --git a/include/linux/libata.h b/include/linux/libata.h
index e37d4f99f..0a2456901 100644
--- a/include/linux/libata.h
+++ b/include/linux/libata.h
@@ -997,7 +997,7 @@ struct ata_port_operations {
 	 * fields must be pointers.
 	 */
 	const struct ata_port_operations	*inherits;
-};
+} __do_const;
 
 struct ata_port_info {
 	unsigned long		flags;
diff --git a/include/linux/linkage.h b/include/linux/linkage.h
index a6a42dd02..97874038a 100644
--- a/include/linux/linkage.h
+++ b/include/linux/linkage.h
@@ -5,6 +5,7 @@
 #include <linux/stringify.h>
 #include <linux/export.h>
 #include <asm/linkage.h>
+#include <asm/bitsperlong.h>
 
 /* Some toolchains use other characters (e.g. '`') to mark new line in macro */
 #ifndef ASM_NL
@@ -36,6 +37,7 @@
 #endif
 
 #define __page_aligned_data	__section(.data..page_aligned) __aligned(PAGE_SIZE)
+#define __page_aligned_rodata	__read_only __aligned(PAGE_SIZE)
 #define __page_aligned_bss	__section(.bss..page_aligned) __aligned(PAGE_SIZE)
 
 /*
@@ -79,17 +81,40 @@
 #define ALIGN_STR __ALIGN_STR
 
 #ifndef ENTRY
-#define ENTRY(name) \
+#define __ENTRY(name, rap_hash) \
 	.globl name ASM_NL \
 	ALIGN ASM_NL \
+	rap_hash \
 	name:
+
+#define ENTRY(name) __ENTRY(name,)
+
 #endif
+
 #endif /* LINKER_SCRIPT */
 
 #ifndef WEAK
-#define WEAK(name)	   \
-	.weak name ASM_NL   \
+#define __WEAK(name, rap_hash) \
+	.weak name ASM_NL \
+	rap_hash \
 	name:
+
+#define WEAK(name) __WEAK(name, )
+#endif
+
+#ifdef CONFIG_PAX_RAP
+#if BITS_PER_LONG == 64
+#define __ASM_RAP_HASH(hash) .quad 0, hash ASM_NL
+#elif BITS_PER_LONG == 32
+#define __ASM_RAP_HASH(hash) .long 0, 0, 0, hash ASM_NL
+#else
+#error incompatible BITS_PER_LONG
+#endif
+#define RAP_ENTRY(name) __ENTRY(name, __ASM_RAP_HASH(__rap_hash_##name))
+#define RAP_WEAK(name) __WEAK(name, __ASM_RAP_HASH(__rap_hash_##name))
+#else
+#define RAP_ENTRY(name) ENTRY(name)
+#define RAP_WEAK(name) WEAK(name)
 #endif
 
 #ifndef END
diff --git a/include/linux/list.h b/include/linux/list.h
index 5183138aa..645f33dec 100644
--- a/include/linux/list.h
+++ b/include/linux/list.h
@@ -113,6 +113,19 @@ extern void __list_del_entry(struct list_head *entry);
 extern void list_del(struct list_head *entry);
 #endif
 
+extern void __pax_list_add(struct list_head *new,
+			      struct list_head *prev,
+			      struct list_head *next);
+static inline void pax_list_add(struct list_head *new, struct list_head *head)
+{
+	__pax_list_add(new, head, head->next);
+}
+static inline void pax_list_add_tail(struct list_head *new, struct list_head *head)
+{
+	__pax_list_add(new, head->prev, head);
+}
+extern void pax_list_del(struct list_head *entry);
+
 /**
  * list_replace - replace old entry by new one
  * @old : the element to be replaced
@@ -146,6 +159,8 @@ static inline void list_del_init(struct list_head *entry)
 	INIT_LIST_HEAD(entry);
 }
 
+extern void pax_list_del_init(struct list_head *entry);
+
 /**
  * list_move - delete from one list and add as another's head
  * @list: the entry to move
diff --git a/include/linux/llist.h b/include/linux/llist.h
index fd4ca0b4f..d77d4a87b 100644
--- a/include/linux/llist.h
+++ b/include/linux/llist.h
@@ -168,6 +168,10 @@ static inline struct llist_node *llist_next(struct llist_node *node)
 extern bool llist_add_batch(struct llist_node *new_first,
 			    struct llist_node *new_last,
 			    struct llist_head *head);
+
+extern bool pax_llist_add_batch(struct llist_node *new_first,
+				struct llist_node *new_last,
+				struct llist_head *head);
 /**
  * llist_add - add a new entry
  * @new:	new entry to be added
@@ -180,6 +184,11 @@ static inline bool llist_add(struct llist_node *new, struct llist_head *head)
 	return llist_add_batch(new, new, head);
 }
 
+static inline bool pax_llist_add(struct llist_node *new, struct llist_head *head)
+{
+	return pax_llist_add_batch(new, new, head);
+}
+
 /**
  * llist_del_all - delete all entries from lock-less list
  * @head:	the head of lock-less list to delete all entries
diff --git a/include/linux/lockd/xdr.h b/include/linux/lockd/xdr.h
index d39ed1cc5..8b5d98f26 100644
--- a/include/linux/lockd/xdr.h
+++ b/include/linux/lockd/xdr.h
@@ -95,24 +95,24 @@ struct nlm_reboot {
  */
 #define NLMSVC_XDRSIZE		sizeof(struct nlm_args)
 
-int	nlmsvc_decode_testargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlmsvc_encode_testres(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlmsvc_decode_lockargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlmsvc_decode_cancargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlmsvc_decode_unlockargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlmsvc_encode_res(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlmsvc_decode_res(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlmsvc_encode_void(struct svc_rqst *, __be32 *, void *);
-int	nlmsvc_decode_void(struct svc_rqst *, __be32 *, void *);
-int	nlmsvc_decode_shareargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlmsvc_encode_shareres(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlmsvc_decode_notify(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlmsvc_decode_reboot(struct svc_rqst *, __be32 *, struct nlm_reboot *);
+int	nlmsvc_decode_testargs(void *, __be32 *, void *);
+int	nlmsvc_encode_testres(void *, __be32 *, void *);
+int	nlmsvc_decode_lockargs(void *, __be32 *, void *);
+int	nlmsvc_decode_cancargs(void *, __be32 *, void *);
+int	nlmsvc_decode_unlockargs(void *, __be32 *, void *);
+int	nlmsvc_encode_res(void *, __be32 *, void *);
+int	nlmsvc_decode_res(void *, __be32 *, void *);
+int	nlmsvc_encode_void(void *, __be32 *p, void *);
+int	nlmsvc_decode_void(void *, __be32 *, void *);
+int	nlmsvc_decode_shareargs(void *, __be32 *, void *);
+int	nlmsvc_encode_shareres(void *, __be32 *, void *);
+int	nlmsvc_decode_notify(void *, __be32 *, void *);
+int	nlmsvc_decode_reboot(void *, __be32 *, void *);
 /*
-int	nlmclt_encode_testargs(struct rpc_rqst *, u32 *, struct nlm_args *);
-int	nlmclt_encode_lockargs(struct rpc_rqst *, u32 *, struct nlm_args *);
-int	nlmclt_encode_cancargs(struct rpc_rqst *, u32 *, struct nlm_args *);
-int	nlmclt_encode_unlockargs(struct rpc_rqst *, u32 *, struct nlm_args *);
+int	nlmclt_encode_testargs(void *, u32 *, void *);
+int	nlmclt_encode_lockargs(void *, u32 *, void *);
+int	nlmclt_encode_cancargs(void *, u32 *, void *);
+int	nlmclt_encode_unlockargs(void *, u32 *, void *);
  */
 
 #endif /* LOCKD_XDR_H */
diff --git a/include/linux/lockd/xdr4.h b/include/linux/lockd/xdr4.h
index e58c88b52..759ca71d6 100644
--- a/include/linux/lockd/xdr4.h
+++ b/include/linux/lockd/xdr4.h
@@ -23,24 +23,24 @@
 
 
 
-int	nlm4svc_decode_testargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlm4svc_encode_testres(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlm4svc_decode_lockargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlm4svc_decode_cancargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlm4svc_decode_unlockargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlm4svc_encode_res(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlm4svc_decode_res(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlm4svc_encode_void(struct svc_rqst *, __be32 *, void *);
-int	nlm4svc_decode_void(struct svc_rqst *, __be32 *, void *);
-int	nlm4svc_decode_shareargs(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlm4svc_encode_shareres(struct svc_rqst *, __be32 *, struct nlm_res *);
-int	nlm4svc_decode_notify(struct svc_rqst *, __be32 *, struct nlm_args *);
-int	nlm4svc_decode_reboot(struct svc_rqst *, __be32 *, struct nlm_reboot *);
+int	nlm4svc_decode_testargs(void *, __be32 *, void *);
+int	nlm4svc_encode_testres(void *, __be32 *, void *);
+int	nlm4svc_decode_lockargs(void *, __be32 *, void *);
+int	nlm4svc_decode_cancargs(void *, __be32 *, void *);
+int	nlm4svc_decode_unlockargs(void *, __be32 *, void *);
+int	nlm4svc_encode_res(void *, __be32 *, void *);
+int	nlm4svc_decode_res(void *, __be32 *, void *);
+int	nlm4svc_encode_void(void *, __be32 *, void *);
+int	nlm4svc_decode_void(void *, __be32 *, void *);
+int	nlm4svc_decode_shareargs(void *, __be32 *, void *);
+int	nlm4svc_encode_shareres(void *, __be32 *, void *);
+int	nlm4svc_decode_notify(void *, __be32 *, void *);
+int	nlm4svc_decode_reboot(void *, __be32 *, void *);
 /*
-int	nlmclt_encode_testargs(struct rpc_rqst *, u32 *, struct nlm_args *);
-int	nlmclt_encode_lockargs(struct rpc_rqst *, u32 *, struct nlm_args *);
-int	nlmclt_encode_cancargs(struct rpc_rqst *, u32 *, struct nlm_args *);
-int	nlmclt_encode_unlockargs(struct rpc_rqst *, u32 *, struct nlm_args *);
+int	nlmclt_encode_testargs(void *, u32 *, void *);
+int	nlmclt_encode_lockargs(void *, u32 *, void *);
+int	nlmclt_encode_cancargs(void *, u32 *, void *);
+int	nlmclt_encode_unlockargs(void *, u32 *, void *);
  */
 extern const struct rpc_version nlm_version4;
 
diff --git a/include/linux/lockref.h b/include/linux/lockref.h
index b10b122dd..d37b3dec4 100644
--- a/include/linux/lockref.h
+++ b/include/linux/lockref.h
@@ -28,7 +28,7 @@ struct lockref {
 #endif
 		struct {
 			spinlock_t lock;
-			int count;
+			atomic_t count;
 		};
 	};
 };
@@ -43,9 +43,29 @@ extern void lockref_mark_dead(struct lockref *);
 extern int lockref_get_not_dead(struct lockref *);
 
 /* Must be called under spinlock for reliable results */
-static inline int __lockref_is_dead(const struct lockref *l)
+static inline int __lockref_is_dead(const struct lockref *lockref)
 {
-	return ((int)l->count < 0);
+	return atomic_read(&lockref->count) < 0;
+}
+
+static inline int __lockref_read(const struct lockref *lockref)
+{
+	return atomic_read(&lockref->count);
+}
+
+static inline void __lockref_set(struct lockref *lockref, int count)
+{
+	atomic_set(&lockref->count, count);
+}
+
+static inline void __lockref_inc(struct lockref *lockref)
+{
+	atomic_inc(&lockref->count);
+}
+
+static inline void __lockref_dec(struct lockref *lockref)
+{
+	atomic_dec(&lockref->count);
 }
 
 #endif /* __LINUX_LOCKREF_H */
diff --git a/include/linux/lsm_hooks.h b/include/linux/lsm_hooks.h
index 101bf19c0..feb307e28 100644
--- a/include/linux/lsm_hooks.h
+++ b/include/linux/lsm_hooks.h
@@ -1831,7 +1831,7 @@ struct security_hook_heads {
 	struct list_head audit_rule_match;
 	struct list_head audit_rule_free;
 #endif /* CONFIG_AUDIT */
-};
+} __randomize_layout;
 
 /*
  * Security module hook list structure.
@@ -1841,7 +1841,7 @@ struct security_hook_list {
 	struct list_head		list;
 	struct list_head		*head;
 	union security_list_options	hook;
-};
+} __randomize_layout;
 
 /*
  * Initializing a security_hook_list structure takes
diff --git a/include/linux/math64.h b/include/linux/math64.h
index 6e8b5b270..8e8a37d10 100644
--- a/include/linux/math64.h
+++ b/include/linux/math64.h
@@ -15,7 +15,7 @@
  * This is commonly provided by 32bit archs to provide an optimized 64bit
  * divide.
  */
-static inline u64 div_u64_rem(u64 dividend, u32 divisor, u32 *remainder)
+static inline u64 __intentional_overflow(-1) div_u64_rem(u64 dividend, u32 divisor, u32 *remainder)
 {
 	*remainder = dividend % divisor;
 	return dividend / divisor;
@@ -42,7 +42,7 @@ static inline u64 div64_u64_rem(u64 dividend, u64 divisor, u64 *remainder)
 /**
  * div64_u64 - unsigned 64bit divide with 64bit divisor
  */
-static inline u64 div64_u64(u64 dividend, u64 divisor)
+static inline u64 __intentional_overflow(-1) div64_u64(u64 dividend, u64 divisor)
 {
 	return dividend / divisor;
 }
@@ -61,7 +61,7 @@ static inline s64 div64_s64(s64 dividend, s64 divisor)
 #define div64_ul(x, y)   div_u64((x), (y))
 
 #ifndef div_u64_rem
-static inline u64 div_u64_rem(u64 dividend, u32 divisor, u32 *remainder)
+static inline u64 __intentional_overflow(-1) div_u64_rem(u64 dividend, u32 divisor, u32 *remainder)
 {
 	*remainder = do_div(dividend, divisor);
 	return dividend;
@@ -77,7 +77,7 @@ extern u64 div64_u64_rem(u64 dividend, u64 divisor, u64 *remainder);
 #endif
 
 #ifndef div64_u64
-extern u64 div64_u64(u64 dividend, u64 divisor);
+extern u64 __intentional_overflow(-1) div64_u64(u64 dividend, u64 divisor);
 #endif
 
 #ifndef div64_s64
@@ -94,7 +94,7 @@ extern s64 div64_s64(s64 dividend, s64 divisor);
  * divide.
  */
 #ifndef div_u64
-static inline u64 div_u64(u64 dividend, u32 divisor)
+static inline u64 __intentional_overflow(-1) div_u64(u64 dividend, u32 divisor)
 {
 	u32 remainder;
 	return div_u64_rem(dividend, divisor, &remainder);
diff --git a/include/linux/memcontrol.h b/include/linux/memcontrol.h
index 5d8ca6e02..0b2174bb5 100644
--- a/include/linux/memcontrol.h
+++ b/include/linux/memcontrol.h
@@ -258,7 +258,7 @@ struct mem_cgroup {
 	int last_scanned_node;
 #if MAX_NUMNODES > 1
 	nodemask_t	scan_nodes;
-	atomic_t	numainfo_events;
+	atomic64_t	numainfo_events;
 	atomic_t	numainfo_updating;
 #endif
 
diff --git a/include/linux/memory.h b/include/linux/memory.h
index 093607f90..97172279c 100644
--- a/include/linux/memory.h
+++ b/include/linux/memory.h
@@ -126,7 +126,7 @@ extern struct memory_block *find_memory_block(struct mem_section *);
 
 #ifdef CONFIG_MEMORY_HOTPLUG
 #define hotplug_memory_notifier(fn, pri) ({		\
-	static __meminitdata struct notifier_block fn##_mem_nb =\
+	static __meminitconst struct notifier_block fn##_mem_nb =\
 		{ .notifier_call = fn, .priority = pri };\
 	register_memory_notifier(&fn##_mem_nb);			\
 })
diff --git a/include/linux/mempolicy.h b/include/linux/mempolicy.h
index 5e5b2969d..629113f06 100644
--- a/include/linux/mempolicy.h
+++ b/include/linux/mempolicy.h
@@ -91,6 +91,10 @@ static inline struct mempolicy *mpol_dup(struct mempolicy *pol)
 }
 
 #define vma_policy(vma) ((vma)->vm_policy)
+static inline void set_vma_policy(struct vm_area_struct *vma, struct mempolicy *pol)
+{
+	vma->vm_policy = pol;
+}
 
 static inline void mpol_get(struct mempolicy *pol)
 {
@@ -236,6 +240,9 @@ mpol_shared_policy_lookup(struct shared_policy *sp, unsigned long idx)
 }
 
 #define vma_policy(vma) NULL
+static inline void set_vma_policy(struct vm_area_struct *vma, struct mempolicy *pol)
+{
+}
 
 static inline int
 vma_dup_policy(struct vm_area_struct *src, struct vm_area_struct *dst)
diff --git a/include/linux/mm.h b/include/linux/mm.h
index 277cd39a6..27ecb26a1 100644
--- a/include/linux/mm.h
+++ b/include/linux/mm.h
@@ -107,6 +107,7 @@ extern int mmap_rnd_compat_bits __read_mostly;
 #define DEFAULT_MAX_MAP_COUNT	(USHRT_MAX - MAPCOUNT_ELF_CORE_MARGIN)
 
 extern int sysctl_max_map_count;
+extern unsigned long sysctl_heap_stack_gap;
 
 extern unsigned long sysctl_user_reserve_kbytes;
 extern unsigned long sysctl_admin_reserve_kbytes;
@@ -182,6 +183,11 @@ extern unsigned int kobjsize(const void *objp);
 #define VM_ACCOUNT	0x00100000	/* Is a VM accounted object */
 #define VM_NORESERVE	0x00200000	/* should the VM suppress accounting */
 #define VM_HUGETLB	0x00400000	/* Huge TLB Page VM */
+
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_X86_32)
+#define VM_PAGEEXEC	0x00800000	/* vma->vm_page_prot needs special handling */
+#endif
+
 #define VM_ARCH_1	0x01000000	/* Architecture-specific flag */
 #define VM_ARCH_2	0x02000000
 #define VM_DONTDUMP	0x04000000	/* Do not include in the core dump */
@@ -364,8 +370,8 @@ struct vm_operations_struct {
 	/* called by access_process_vm when get_user_pages() fails, typically
 	 * for use by special VMAs that can switch between memory and hardware
 	 */
-	int (*access)(struct vm_area_struct *vma, unsigned long addr,
-		      void *buf, int len, int write);
+	ssize_t (*access)(struct vm_area_struct *vma, unsigned long addr,
+		      void *buf, size_t len, int write);
 
 	/* Called by the /proc/PID/maps code to ask the vma whether it
 	 * has a special name.  Returning non-NULL will also cause this
@@ -403,6 +409,7 @@ struct vm_operations_struct {
 	struct page *(*find_special_page)(struct vm_area_struct *vma,
 					  unsigned long addr);
 };
+typedef struct vm_operations_struct __no_const vm_operations_struct_no_const;
 
 struct mmu_gather;
 struct inode;
@@ -1237,8 +1244,8 @@ int follow_pfn(struct vm_area_struct *vma, unsigned long address,
 	unsigned long *pfn);
 int follow_phys(struct vm_area_struct *vma, unsigned long address,
 		unsigned int flags, unsigned long *prot, resource_size_t *phys);
-int generic_access_phys(struct vm_area_struct *vma, unsigned long addr,
-			void *buf, int len, int write);
+ssize_t generic_access_phys(struct vm_area_struct *vma, unsigned long addr,
+			void *buf, size_t len, int write);
 
 static inline void unmap_shared_mapping_range(struct address_space *mapping,
 		loff_t const holebegin, loff_t const holelen)
@@ -1278,9 +1285,9 @@ static inline int fixup_user_fault(struct task_struct *tsk,
 }
 #endif
 
-extern int access_process_vm(struct task_struct *tsk, unsigned long addr, void *buf, int len, int write);
-extern int access_remote_vm(struct mm_struct *mm, unsigned long addr,
-		void *buf, int len, int write);
+extern ssize_t access_process_vm(struct task_struct *tsk, unsigned long addr, void *buf, size_t len, int write);
+extern ssize_t access_remote_vm(struct mm_struct *mm, unsigned long addr,
+		void *buf, size_t len, int write);
 
 long __get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
 		      unsigned long start, unsigned long nr_pages,
@@ -1370,39 +1377,11 @@ int clear_page_dirty_for_io(struct page *page);
 
 int get_cmdline(struct task_struct *task, char *buffer, int buflen);
 
-/* Is the vma a continuation of the stack vma above it? */
-static inline int vma_growsdown(struct vm_area_struct *vma, unsigned long addr)
-{
-	return vma && (vma->vm_end == addr) && (vma->vm_flags & VM_GROWSDOWN);
-}
-
 static inline bool vma_is_anonymous(struct vm_area_struct *vma)
 {
 	return !vma->vm_ops;
 }
 
-static inline int stack_guard_page_start(struct vm_area_struct *vma,
-					     unsigned long addr)
-{
-	return (vma->vm_flags & VM_GROWSDOWN) &&
-		(vma->vm_start == addr) &&
-		!vma_growsdown(vma->vm_prev, addr);
-}
-
-/* Is the vma a continuation of the stack vma below it? */
-static inline int vma_growsup(struct vm_area_struct *vma, unsigned long addr)
-{
-	return vma && (vma->vm_start == addr) && (vma->vm_flags & VM_GROWSUP);
-}
-
-static inline int stack_guard_page_end(struct vm_area_struct *vma,
-					   unsigned long addr)
-{
-	return (vma->vm_flags & VM_GROWSUP) &&
-		(vma->vm_end == addr) &&
-		!vma_growsup(vma->vm_next, addr);
-}
-
 int vma_is_stack_for_task(struct vm_area_struct *vma, struct task_struct *t);
 
 extern unsigned long move_page_tables(struct vm_area_struct *vma,
@@ -1547,8 +1526,15 @@ static inline int __pud_alloc(struct mm_struct *mm, pgd_t *pgd,
 {
 	return 0;
 }
+
+static inline int __pud_alloc_kernel(struct mm_struct *mm, pgd_t *pgd,
+						unsigned long address)
+{
+	return 0;
+}
 #else
 int __pud_alloc(struct mm_struct *mm, pgd_t *pgd, unsigned long address);
+int __pud_alloc_kernel(struct mm_struct *mm, pgd_t *pgd, unsigned long address);
 #endif
 
 #if defined(__PAGETABLE_PMD_FOLDED) || !defined(CONFIG_MMU)
@@ -1558,6 +1544,12 @@ static inline int __pmd_alloc(struct mm_struct *mm, pud_t *pud,
 	return 0;
 }
 
+static inline int __pmd_alloc_kernel(struct mm_struct *mm, pud_t *pud,
+						unsigned long address)
+{
+	return 0;
+}
+
 static inline void mm_nr_pmds_init(struct mm_struct *mm) {}
 
 static inline unsigned long mm_nr_pmds(struct mm_struct *mm)
@@ -1570,6 +1562,7 @@ static inline void mm_dec_nr_pmds(struct mm_struct *mm) {}
 
 #else
 int __pmd_alloc(struct mm_struct *mm, pud_t *pud, unsigned long address);
+int __pmd_alloc_kernel(struct mm_struct *mm, pud_t *pud, unsigned long address);
 
 static inline void mm_nr_pmds_init(struct mm_struct *mm)
 {
@@ -1606,11 +1599,23 @@ static inline pud_t *pud_alloc(struct mm_struct *mm, pgd_t *pgd, unsigned long a
 		NULL: pud_offset(pgd, address);
 }
 
+static inline pud_t *pud_alloc_kernel(struct mm_struct *mm, pgd_t *pgd, unsigned long address)
+{
+	return (unlikely(pgd_none(*pgd)) && __pud_alloc_kernel(mm, pgd, address))?
+		NULL: pud_offset(pgd, address);
+}
+
 static inline pmd_t *pmd_alloc(struct mm_struct *mm, pud_t *pud, unsigned long address)
 {
 	return (unlikely(pud_none(*pud)) && __pmd_alloc(mm, pud, address))?
 		NULL: pmd_offset(pud, address);
 }
+
+static inline pmd_t *pmd_alloc_kernel(struct mm_struct *mm, pud_t *pud, unsigned long address)
+{
+	return (unlikely(pud_none(*pud)) && __pmd_alloc_kernel(mm, pud, address))?
+		NULL: pmd_offset(pud, address);
+}
 #endif /* CONFIG_MMU && !__ARCH_HAS_4LEVEL_HACK */
 
 #if USE_SPLIT_PTE_PTLOCKS
@@ -1995,12 +2000,23 @@ extern struct vm_area_struct *copy_vma(struct vm_area_struct **,
 	bool *need_rmap_locks);
 extern void exit_mmap(struct mm_struct *);
 
+#if defined(CONFIG_GRKERNSEC) && (defined(CONFIG_GRKERNSEC_RESLOG) || !defined(CONFIG_GRKERNSEC_NO_RBAC))
+extern void gr_learn_resource(const struct task_struct *task, const int res,
+			      const unsigned long wanted, const int gt);
+#else
+static inline void gr_learn_resource(const struct task_struct *task, const int res,
+				     const unsigned long wanted, const int gt)
+{
+}
+#endif
+
 static inline int check_data_rlimit(unsigned long rlim,
 				    unsigned long new,
 				    unsigned long start,
 				    unsigned long end_data,
 				    unsigned long start_data)
 {
+	gr_learn_resource(current, RLIMIT_DATA, (new - start) + (end_data - start_data), 1);
 	if (rlim < RLIM_INFINITY) {
 		if (((new - start) + (end_data - start_data)) > rlim)
 			return -ENOSPC;
@@ -2036,6 +2052,7 @@ extern unsigned long do_mmap(struct file *file, unsigned long addr,
 	unsigned long len, unsigned long prot, unsigned long flags,
 	vm_flags_t vm_flags, unsigned long pgoff, unsigned long *populate);
 extern int do_munmap(struct mm_struct *, unsigned long, size_t);
+extern int __do_munmap(struct mm_struct *, unsigned long, size_t);
 
 static inline unsigned long
 do_mmap_pgoff(struct file *file, unsigned long addr,
@@ -2072,10 +2089,11 @@ struct vm_unmapped_area_info {
 	unsigned long high_limit;
 	unsigned long align_mask;
 	unsigned long align_offset;
+	unsigned long threadstack_offset;
 };
 
-extern unsigned long unmapped_area(struct vm_unmapped_area_info *info);
-extern unsigned long unmapped_area_topdown(struct vm_unmapped_area_info *info);
+extern unsigned long unmapped_area(const struct vm_unmapped_area_info *info);
+extern unsigned long unmapped_area_topdown(const struct vm_unmapped_area_info *info);
 
 /*
  * Search for an unmapped address range.
@@ -2087,7 +2105,7 @@ extern unsigned long unmapped_area_topdown(struct vm_unmapped_area_info *info);
  * - satisfies (begin_addr & align_mask) == (align_offset & align_mask)
  */
 static inline unsigned long
-vm_unmapped_area(struct vm_unmapped_area_info *info)
+vm_unmapped_area(const struct vm_unmapped_area_info *info)
 {
 	if (info->flags & VM_UNMAPPED_AREA_TOPDOWN)
 		return unmapped_area_topdown(info);
@@ -2148,6 +2166,9 @@ extern struct vm_area_struct * find_vma(struct mm_struct * mm, unsigned long add
 extern struct vm_area_struct * find_vma_prev(struct mm_struct * mm, unsigned long addr,
 					     struct vm_area_struct **pprev);
 
+extern struct vm_area_struct *pax_find_mirror_vma(struct vm_area_struct *vma);
+extern __must_check long pax_mirror_vma(struct vm_area_struct *vma_m, struct vm_area_struct *vma);
+
 /* Look up the first VMA which intersects the interval start_addr..end_addr-1,
    NULL if none.  Assume start_addr < end_addr. */
 static inline struct vm_area_struct * find_vma_intersection(struct mm_struct * mm, unsigned long start_addr, unsigned long end_addr)
@@ -2177,10 +2198,10 @@ static inline struct vm_area_struct *find_exact_vma(struct mm_struct *mm,
 }
 
 #ifdef CONFIG_MMU
-pgprot_t vm_get_page_prot(unsigned long vm_flags);
+pgprot_t vm_get_page_prot(vm_flags_t vm_flags);
 void vma_set_page_prot(struct vm_area_struct *vma);
 #else
-static inline pgprot_t vm_get_page_prot(unsigned long vm_flags)
+static inline pgprot_t vm_get_page_prot(vm_flags_t vm_flags)
 {
 	return __pgprot(0);
 }
@@ -2366,7 +2387,7 @@ extern int get_hwpoison_page(struct page *page);
 extern int sysctl_memory_failure_early_kill;
 extern int sysctl_memory_failure_recovery;
 extern void shake_page(struct page *p, int access);
-extern atomic_long_t num_poisoned_pages;
+extern atomic_long_unchecked_t num_poisoned_pages;
 extern int soft_offline_page(struct page *page, int flags);
 
 
@@ -2454,5 +2475,11 @@ void __init setup_nr_node_ids(void);
 static inline void setup_nr_node_ids(void) {}
 #endif
 
+#ifdef CONFIG_ARCH_TRACK_EXEC_LIMIT
+extern void track_exec_limit(struct mm_struct *mm, unsigned long start, unsigned long end, unsigned long prot);
+#else
+static inline void track_exec_limit(struct mm_struct *mm, unsigned long start, unsigned long end, unsigned long prot) {}
+#endif
+
 #endif /* __KERNEL__ */
 #endif /* _LINUX_MM_H */
diff --git a/include/linux/mm_types.h b/include/linux/mm_types.h
index 39820082c..bd7e217c3 100644
--- a/include/linux/mm_types.h
+++ b/include/linux/mm_types.h
@@ -358,7 +358,9 @@ struct vm_area_struct {
 	struct mempolicy *vm_policy;	/* NUMA policy for the VMA */
 #endif
 	struct vm_userfaultfd_ctx vm_userfaultfd_ctx;
-};
+
+	struct vm_area_struct *vm_mirror;/* PaX: mirror vma or NULL */
+} __randomize_layout;
 
 struct core_thread {
 	struct task_struct *task;
@@ -519,7 +521,25 @@ struct mm_struct {
 #ifdef CONFIG_MMU
 	struct work_struct async_put_work;
 #endif
-};
+
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+	unsigned long pax_flags;
+#endif
+
+#ifdef CONFIG_PAX_DLRESOLVE
+	unsigned long call_dl_resolve;
+#endif
+
+#if defined(CONFIG_PPC32) && defined(CONFIG_PAX_EMUSIGRT)
+	unsigned long call_syscall;
+#endif
+
+#ifdef CONFIG_PAX_ASLR
+	unsigned long delta_mmap;		/* randomized offset */
+	unsigned long delta_stack;		/* randomized offset */
+#endif
+
+} __randomize_layout;
 
 static inline void mm_init_cpumask(struct mm_struct *mm)
 {
diff --git a/include/linux/mmiotrace.h b/include/linux/mmiotrace.h
index 3ba327af0..85cd5ce08 100644
--- a/include/linux/mmiotrace.h
+++ b/include/linux/mmiotrace.h
@@ -46,7 +46,7 @@ extern int kmmio_handler(struct pt_regs *regs, unsigned long addr);
 /* Called from ioremap.c */
 extern void mmiotrace_ioremap(resource_size_t offset, unsigned long size,
 							void __iomem *addr);
-extern void mmiotrace_iounmap(volatile void __iomem *addr);
+extern void mmiotrace_iounmap(const volatile void __iomem *addr);
 
 /* For anyone to insert markers. Remember trailing newline. */
 extern __printf(1, 2) int mmiotrace_printk(const char *fmt, ...);
@@ -66,7 +66,7 @@ static inline void mmiotrace_ioremap(resource_size_t offset,
 {
 }
 
-static inline void mmiotrace_iounmap(volatile void __iomem *addr)
+static inline void mmiotrace_iounmap(const volatile void __iomem *addr)
 {
 }
 
diff --git a/include/linux/mmzone.h b/include/linux/mmzone.h
index 7f2ae99e5..27ca9cffd 100644
--- a/include/linux/mmzone.h
+++ b/include/linux/mmzone.h
@@ -517,7 +517,7 @@ struct zone {
 
 	ZONE_PADDING(_pad3_)
 	/* Zone statistics */
-	atomic_long_t		vm_stat[NR_VM_ZONE_STAT_ITEMS];
+	atomic_long_unchecked_t	vm_stat[NR_VM_ZONE_STAT_ITEMS];
 } ____cacheline_internodealigned_in_smp;
 
 enum pgdat_flags {
@@ -721,7 +721,7 @@ typedef struct pglist_data {
 
 	/* Per-node vmstats */
 	struct per_cpu_nodestat __percpu *per_cpu_nodestats;
-	atomic_long_t		vm_stat[NR_VM_NODE_STAT_ITEMS];
+	atomic_long_unchecked_t	vm_stat[NR_VM_NODE_STAT_ITEMS];
 } pg_data_t;
 
 #define node_present_pages(nid)	(NODE_DATA(nid)->node_present_pages)
diff --git a/include/linux/mod_devicetable.h b/include/linux/mod_devicetable.h
index ed84c07f6..c29bce453 100644
--- a/include/linux/mod_devicetable.h
+++ b/include/linux/mod_devicetable.h
@@ -139,7 +139,7 @@ struct usb_device_id {
 #define USB_DEVICE_ID_MATCH_INT_PROTOCOL	0x0200
 #define USB_DEVICE_ID_MATCH_INT_NUMBER		0x0400
 
-#define HID_ANY_ID				(~0)
+#define HID_ANY_ID				(~0U)
 #define HID_BUS_ANY				0xffff
 #define HID_GROUP_ANY				0x0000
 
@@ -480,7 +480,7 @@ struct dmi_system_id {
 	const char *ident;
 	struct dmi_strmatch matches[4];
 	void *driver_data;
-};
+} __do_const;
 /*
  * struct dmi_device_id appears during expansion of
  * "MODULE_DEVICE_TABLE(dmi, x)". Compiler doesn't look inside it
diff --git a/include/linux/module.h b/include/linux/module.h
index 0c3207d26..18808a587 100644
--- a/include/linux/module.h
+++ b/include/linux/module.h
@@ -20,9 +20,11 @@
 #include <linux/export.h>
 #include <linux/extable.h>	/* only as arch move module.h -> extable.h */
 #include <linux/rbtree_latch.h>
+#include <linux/fs.h>
 
 #include <linux/percpu.h>
 #include <asm/module.h>
+#include <asm/pgtable.h>
 
 /* In stripped ARM and x86-64 modules, ~ is surprisingly rare. */
 #define MODULE_SIG_STRING "~Module signature appended~\n"
@@ -46,7 +48,7 @@ struct module_kobject {
 	struct kobject *drivers_dir;
 	struct module_param_attrs *mp;
 	struct completion *kobj_completion;
-};
+} __randomize_layout;
 
 struct module_attribute {
 	struct attribute attr;
@@ -58,12 +60,13 @@ struct module_attribute {
 	int (*test)(struct module *);
 	void (*free)(struct module *);
 };
+typedef struct module_attribute __no_const module_attribute_no_const;
 
 struct module_version_attribute {
 	struct module_attribute mattr;
 	const char *module_name;
 	const char *version;
-} __attribute__ ((__aligned__(sizeof(void *))));
+} __do_const __attribute__ ((__aligned__(sizeof(void *))));
 
 extern ssize_t __modver_version_show(struct module_attribute *,
 				     struct module_kobject *, char *);
@@ -290,19 +293,18 @@ struct mod_tree_node {
 };
 
 struct module_layout {
-	/* The actual code + data. */
-	void *base;
-	/* Total size. */
-	unsigned int size;
-	/* The size of the executable code.  */
-	unsigned int text_size;
-	/* Size of RO section of the module (text+rodata) */
-	unsigned int ro_size;
-	/* Size of RO after init section */
-	unsigned int ro_after_init_size;
+	/* The actual code. */
+	void *base_rx;
+	/* The actual data. */
+	void *base_rw;
+	/* Code size. */
+	unsigned int size_rx;
+	/* Data size. */
+	unsigned int size_rw;
 
 #ifdef CONFIG_MODULES_TREE_LOOKUP
-	struct mod_tree_node mtn;
+	struct mod_tree_node mtn_rx;
+	struct mod_tree_node mtn_rw;
 #endif
 };
 
@@ -339,7 +341,7 @@ struct module {
 
 	/* Sysfs stuff. */
 	struct module_kobject mkobj;
-	struct module_attribute *modinfo_attrs;
+	module_attribute_no_const *modinfo_attrs;
 	const char *version;
 	const char *srcversion;
 	struct kobject *holders_dir;
@@ -447,6 +449,10 @@ struct module {
 	unsigned int num_trace_events;
 	struct trace_enum_map **trace_enums;
 	unsigned int num_trace_enums;
+	struct file_operations trace_id;
+	struct file_operations trace_enable;
+	struct file_operations trace_format;
+	struct file_operations trace_filter;
 #endif
 #ifdef CONFIG_FTRACE_MCOUNT_RECORD
 	unsigned int num_ftrace_callsites;
@@ -478,7 +484,8 @@ struct module {
 	ctor_fn_t *ctors;
 	unsigned int num_ctors;
 #endif
-} ____cacheline_aligned;
+} ____cacheline_aligned __randomize_layout;
+
 #ifndef MODULE_ARCH_INIT
 #define MODULE_ARCH_INIT {}
 #endif
@@ -499,18 +506,38 @@ bool is_module_address(unsigned long addr);
 bool is_module_percpu_address(unsigned long addr);
 bool is_module_text_address(unsigned long addr);
 
+static inline int within_module_range(unsigned long addr, void *start, unsigned long size)
+{
+
+#ifdef CONFIG_PAX_KERNEXEC
+	if (ktla_ktva(addr) >= (unsigned long)start &&
+	    ktla_ktva(addr) < (unsigned long)start + size)
+		return 1;
+#endif
+
+	return ((void *)addr >= start && (void *)addr < start + size);
+}
+
+static inline int within_module_rx(unsigned long addr, const struct module_layout *layout)
+{
+	return within_module_range(addr, layout->base_rx, layout->size_rx);
+}
+
+static inline int within_module_rw(unsigned long addr, const struct module_layout *layout)
+{
+	return within_module_range(addr, layout->base_rw, layout->size_rw);
+}
+
 static inline bool within_module_core(unsigned long addr,
 				      const struct module *mod)
 {
-	return (unsigned long)mod->core_layout.base <= addr &&
-	       addr < (unsigned long)mod->core_layout.base + mod->core_layout.size;
+	return within_module_rx(addr, &mod->core_layout) || within_module_rw(addr, &mod->core_layout);
 }
 
 static inline bool within_module_init(unsigned long addr,
 				      const struct module *mod)
 {
-	return (unsigned long)mod->init_layout.base <= addr &&
-	       addr < (unsigned long)mod->init_layout.base + mod->init_layout.size;
+	return within_module_rx(addr, &mod->init_layout) || within_module_rw(addr, &mod->init_layout);
 }
 
 static inline bool within_module(unsigned long addr, const struct module *mod)
diff --git a/include/linux/moduleloader.h b/include/linux/moduleloader.h
index 4d0cb9bba..3169ac7c6 100644
--- a/include/linux/moduleloader.h
+++ b/include/linux/moduleloader.h
@@ -25,9 +25,21 @@ unsigned int arch_mod_section_prepend(struct module *mod, unsigned int section);
    sections.  Returns NULL on failure. */
 void *module_alloc(unsigned long size);
 
+#ifdef CONFIG_PAX_KERNEXEC
+void *module_alloc_exec(unsigned long size);
+#else
+#define module_alloc_exec(x) module_alloc(x)
+#endif
+
 /* Free memory returned from module_alloc. */
 void module_memfree(void *module_region);
 
+#ifdef CONFIG_PAX_KERNEXEC
+void module_memfree_exec(void *module_region);
+#else
+#define module_memfree_exec(x) module_memfree((x))
+#endif
+
 /*
  * Apply the given relocation to the (simplified) ELF.  Return -error
  * or 0.
@@ -45,8 +57,10 @@ static inline int apply_relocate(Elf_Shdr *sechdrs,
 				 unsigned int relsec,
 				 struct module *me)
 {
+#ifdef CONFIG_MODULES
 	printk(KERN_ERR "module %s: REL relocation unsupported\n",
 	       module_name(me));
+#endif
 	return -ENOEXEC;
 }
 #endif
@@ -68,8 +82,10 @@ static inline int apply_relocate_add(Elf_Shdr *sechdrs,
 				     unsigned int relsec,
 				     struct module *me)
 {
+#ifdef CONFIG_MODULES
 	printk(KERN_ERR "module %s: REL relocation unsupported\n",
 	       module_name(me));
+#endif
 	return -ENOEXEC;
 }
 #endif
diff --git a/include/linux/moduleparam.h b/include/linux/moduleparam.h
index 52666d90c..f10563b7e 100644
--- a/include/linux/moduleparam.h
+++ b/include/linux/moduleparam.h
@@ -54,7 +54,7 @@ struct kernel_param_ops {
 	int (*get)(char *buffer, const struct kernel_param *kp);
 	/* Optional function to free kp->arg when module unloaded. */
 	void (*free)(void *arg);
-};
+} __do_const;
 
 /*
  * Flags available for kernel_param
@@ -226,15 +226,15 @@ struct kparam_array
 
 /* Obsolete - use module_param_cb() */
 #define module_param_call(name, set, get, arg, perm)			\
-	static const struct kernel_param_ops __param_ops_##name =		\
-		{ .flags = 0, (void *)set, (void *)get };		\
+	static const struct kernel_param_ops __param_ops_##name =	\
+		{ .flags = 0, set, get };				\
 	__module_param_call(MODULE_PARAM_PREFIX,			\
 			    name, &__param_ops_##name, arg,		\
 			    (perm) + sizeof(__check_old_set_param(set))*0, -1, 0)
 
 /* We don't get oldget: it's often a new-style param_get_uint, etc. */
 static inline int
-__check_old_set_param(int (*oldset)(const char *, struct kernel_param *))
+__check_old_set_param(int (*oldset)(const char *, const struct kernel_param *))
 {
 	return 0;
 }
@@ -289,7 +289,7 @@ static inline void kernel_param_unlock(struct module *mod)
  * @len is usually just sizeof(string).
  */
 #define module_param_string(name, string, len, perm)			\
-	static const struct kparam_string __param_string_##name		\
+	static const struct kparam_string __param_string_##name __used	\
 		= { len, string };					\
 	__module_param_call(MODULE_PARAM_PREFIX, name,			\
 			    &param_ops_string,				\
@@ -441,7 +441,7 @@ extern int param_set_bint(const char *val, const struct kernel_param *kp);
  */
 #define module_param_array_named(name, array, type, nump, perm)		\
 	param_check_##type(name, &(array)[0]);				\
-	static const struct kparam_array __param_arr_##name		\
+	static const struct kparam_array __param_arr_##name __used	\
 	= { .max = ARRAY_SIZE(array), .num = nump,                      \
 	    .ops = &param_ops_##type,					\
 	    .elemsize = sizeof(array[0]), .elem = array };		\
diff --git a/include/linux/mount.h b/include/linux/mount.h
index 54a594d49..1f7fa029b 100644
--- a/include/linux/mount.h
+++ b/include/linux/mount.h
@@ -67,7 +67,7 @@ struct vfsmount {
 	struct dentry *mnt_root;	/* root of the mounted tree */
 	struct super_block *mnt_sb;	/* pointer to superblock */
 	int mnt_flags;
-};
+} __randomize_layout;
 
 struct file; /* forward dec */
 struct path;
diff --git a/include/linux/msg.h b/include/linux/msg.h
index f3f302f9c..a001305f5 100644
--- a/include/linux/msg.h
+++ b/include/linux/msg.h
@@ -29,7 +29,7 @@ struct msg_queue {
 	struct list_head q_messages;
 	struct list_head q_receivers;
 	struct list_head q_senders;
-};
+} __randomize_layout;
 
 /* Helper routines for sys_msgsnd and sys_msgrcv */
 extern long do_msgsnd(int msqid, long mtype, void __user *mtext,
diff --git a/include/linux/net.h b/include/linux/net.h
index b9f0ff4d4..fd3f50189 100644
--- a/include/linux/net.h
+++ b/include/linux/net.h
@@ -196,7 +196,7 @@ struct net_proto_family {
 	int		(*create)(struct net *net, struct socket *sock,
 				  int protocol, int kern);
 	struct module	*owner;
-};
+} __do_const;
 
 struct iovec;
 struct kvec;
diff --git a/include/linux/netdevice.h b/include/linux/netdevice.h
index e942c67ea..61331472d 100644
--- a/include/linux/netdevice.h
+++ b/include/linux/netdevice.h
@@ -1307,6 +1307,7 @@ struct net_device_ops {
 	int			(*ndo_xdp)(struct net_device *dev,
 					   struct netdev_xdp *xdp);
 };
+typedef struct net_device_ops __no_const net_device_ops_no_const;
 
 /**
  * enum net_device_priv_flags - &struct net_device priv_flags
@@ -1636,7 +1637,7 @@ struct net_device {
 	unsigned long		base_addr;
 	int			irq;
 
-	atomic_t		carrier_changes;
+	atomic_unchecked_t	carrier_changes;
 
 	/*
 	 *	Some hardware also needs these fields (state,dev_list,
@@ -1676,9 +1677,9 @@ struct net_device {
 
 	struct net_device_stats	stats;
 
-	atomic_long_t		rx_dropped;
-	atomic_long_t		tx_dropped;
-	atomic_long_t		rx_nohandler;
+	atomic_long_unchecked_t	rx_dropped;
+	atomic_long_unchecked_t	tx_dropped;
+	atomic_long_unchecked_t	rx_nohandler;
 
 #ifdef CONFIG_WIRELESS_EXT
 	const struct iw_handler_def *wireless_handlers;
@@ -4255,7 +4256,7 @@ static inline bool netif_reduces_vlan_mtu(struct net_device *dev)
 	return dev->priv_flags & IFF_MACSEC;
 }
 
-extern struct pernet_operations __net_initdata loopback_net_ops;
+extern struct pernet_operations __net_initconst loopback_net_ops;
 
 /* Logging, debugging and troubleshooting/diagnostic helpers. */
 
diff --git a/include/linux/netfilter/ipset/ip_set.h b/include/linux/netfilter/ipset/ip_set.h
index 83b9a2e0d..5266f3bf4 100644
--- a/include/linux/netfilter/ipset/ip_set.h
+++ b/include/linux/netfilter/ipset/ip_set.h
@@ -104,8 +104,8 @@ struct ip_set_ext {
 };
 
 struct ip_set_counter {
-	atomic64_t bytes;
-	atomic64_t packets;
+	atomic64_unchecked_t bytes;
+	atomic64_unchecked_t packets;
 };
 
 struct ip_set_comment_rcu {
@@ -297,25 +297,25 @@ ip_set_put_flags(struct sk_buff *skb, struct ip_set *set)
 static inline void
 ip_set_add_bytes(u64 bytes, struct ip_set_counter *counter)
 {
-	atomic64_add((long long)bytes, &(counter)->bytes);
+	atomic64_add_unchecked((long long)bytes, &(counter)->bytes);
 }
 
 static inline void
 ip_set_add_packets(u64 packets, struct ip_set_counter *counter)
 {
-	atomic64_add((long long)packets, &(counter)->packets);
+	atomic64_add_unchecked((long long)packets, &(counter)->packets);
 }
 
 static inline u64
 ip_set_get_bytes(const struct ip_set_counter *counter)
 {
-	return (u64)atomic64_read(&(counter)->bytes);
+	return (u64)atomic64_read_unchecked(&(counter)->bytes);
 }
 
 static inline u64
 ip_set_get_packets(const struct ip_set_counter *counter)
 {
-	return (u64)atomic64_read(&(counter)->packets);
+	return (u64)atomic64_read_unchecked(&(counter)->packets);
 }
 
 static inline void
@@ -387,9 +387,9 @@ ip_set_init_counter(struct ip_set_counter *counter,
 		    const struct ip_set_ext *ext)
 {
 	if (ext->bytes != ULLONG_MAX)
-		atomic64_set(&(counter)->bytes, (long long)(ext->bytes));
+		atomic64_set_unchecked(&(counter)->bytes, (long long)(ext->bytes));
 	if (ext->packets != ULLONG_MAX)
-		atomic64_set(&(counter)->packets, (long long)(ext->packets));
+		atomic64_set_unchecked(&(counter)->packets, (long long)(ext->packets));
 }
 
 /* Netlink CB args */
diff --git a/include/linux/netfilter/ipset/ip_set_comment.h b/include/linux/netfilter/ipset/ip_set_comment.h
index 8d0248525..a1e1aa5a5 100644
--- a/include/linux/netfilter/ipset/ip_set_comment.h
+++ b/include/linux/netfilter/ipset/ip_set_comment.h
@@ -58,8 +58,9 @@ ip_set_put_comment(struct sk_buff *skb, struct ip_set_comment *comment)
  * of the set data anymore.
  */
 static inline void
-ip_set_comment_free(struct ip_set_comment *comment)
+ip_set_comment_free(void *_comment)
 {
+	struct ip_set_comment *comment = _comment;
 	struct ip_set_comment_rcu *c;
 
 	c = rcu_dereference_protected(comment->c, 1);
diff --git a/include/linux/netfilter/nfnetlink.h b/include/linux/netfilter/nfnetlink.h
index 1d82dd5e9..d6b384c9d 100644
--- a/include/linux/netfilter/nfnetlink.h
+++ b/include/linux/netfilter/nfnetlink.h
@@ -19,7 +19,7 @@ struct nfnl_callback {
 			  const struct nlattr * const cda[]);
 	const struct nla_policy *policy;	/* netlink attribute policy */
 	const u_int16_t attr_count;		/* number of nlattr's */
-};
+} __do_const;
 
 struct nfnetlink_subsystem {
 	const char *name;
diff --git b/include/linux/netfilter/xt_gradm.h b/include/linux/netfilter/xt_gradm.h
new file mode 100644
index 000000000..33f4af893
--- /dev/null
+++ b/include/linux/netfilter/xt_gradm.h
@@ -0,0 +1,9 @@
+#ifndef _LINUX_NETFILTER_XT_GRADM_H
+#define _LINUX_NETFILTER_XT_GRADM_H 1
+
+struct xt_gradm_mtinfo {
+	__u16 flags;
+	__u16 invflags;
+};
+
+#endif
diff --git a/include/linux/netfilter.h b/include/linux/netfilter.h
index 9230f9aee..065b8f886 100644
--- a/include/linux/netfilter.h
+++ b/include/linux/netfilter.h
@@ -119,7 +119,7 @@ struct nf_sockopt_ops {
 #endif
 	/* Use the module struct to lock set/get code in place */
 	struct module *owner;
-};
+} __do_const;
 
 /* Function to register/unregister hook points. */
 int nf_register_net_hook(struct net *net, const struct nf_hook_ops *ops);
diff --git a/include/linux/netlink.h b/include/linux/netlink.h
index da14ab61f..874abff86 100644
--- a/include/linux/netlink.h
+++ b/include/linux/netlink.h
@@ -150,19 +150,19 @@ struct netlink_dump_control {
 	void *data;
 	struct module *module;
 	u16 min_dump_alloc;
-};
+} __do_const;
+typedef struct netlink_dump_control __no_const netlink_dump_control_no_const;
 
 extern int __netlink_dump_start(struct sock *ssk, struct sk_buff *skb,
 				const struct nlmsghdr *nlh,
-				struct netlink_dump_control *control);
+				struct netlink_dump_control *control,
+				void *data,
+				struct module *module);
 static inline int netlink_dump_start(struct sock *ssk, struct sk_buff *skb,
 				     const struct nlmsghdr *nlh,
 				     struct netlink_dump_control *control)
 {
-	if (!control->module)
-		control->module = THIS_MODULE;
-
-	return __netlink_dump_start(ssk, skb, nlh, control);
+	return __netlink_dump_start(ssk, skb, nlh, control, control->data, control->module ? : THIS_MODULE);
 }
 
 struct netlink_tap {
diff --git a/include/linux/nls.h b/include/linux/nls.h
index 520681b68..2b7fabb99 100644
--- a/include/linux/nls.h
+++ b/include/linux/nls.h
@@ -31,7 +31,7 @@ struct nls_table {
 	const unsigned char *charset2upper;
 	struct module *owner;
 	struct nls_table *next;
-};
+} __do_const;
 
 /* this value hold the maximum octet of charset */
 #define NLS_MAX_CHARSET_SIZE 6 /* for UTF-8 */
@@ -46,7 +46,7 @@ enum utf16_endian {
 /* nls_base.c */
 extern int __register_nls(struct nls_table *, struct module *);
 extern int unregister_nls(struct nls_table *);
-extern struct nls_table *load_nls(char *);
+extern struct nls_table *load_nls(const char *);
 extern void unload_nls(struct nls_table *);
 extern struct nls_table *load_nls_default(void);
 #define register_nls(nls) __register_nls((nls), THIS_MODULE)
diff --git a/include/linux/notifier.h b/include/linux/notifier.h
index 4149868de..0971cea9f 100644
--- a/include/linux/notifier.h
+++ b/include/linux/notifier.h
@@ -56,7 +56,8 @@ struct notifier_block {
 	notifier_fn_t notifier_call;
 	struct notifier_block __rcu *next;
 	int priority;
-};
+} __do_const;
+typedef struct notifier_block __no_const notifier_block_no_const;
 
 struct atomic_notifier_head {
 	spinlock_t lock;
diff --git a/include/linux/oprofile.h b/include/linux/oprofile.h
index b2a0f15f1..4d7da327e 100644
--- a/include/linux/oprofile.h
+++ b/include/linux/oprofile.h
@@ -138,9 +138,9 @@ int oprofilefs_create_ulong(struct dentry * root,
 int oprofilefs_create_ro_ulong(struct dentry * root,
 	char const * name, ulong * val);
  
-/** Create a file for read-only access to an atomic_t. */
+/** Create a file for read-only access to an atomic_unchecked_t. */
 int oprofilefs_create_ro_atomic(struct dentry * root,
-	char const * name, atomic_t * val);
+	char const * name, atomic_unchecked_t * val);
  
 /** create a directory */
 struct dentry *oprofilefs_mkdir(struct dentry *parent, char const *name);
diff --git a/include/linux/padata.h b/include/linux/padata.h
index 113ee626a..70198a786 100644
--- a/include/linux/padata.h
+++ b/include/linux/padata.h
@@ -129,7 +129,7 @@ struct parallel_data {
 	struct padata_serial_queue	__percpu *squeue;
 	atomic_t			reorder_objects;
 	atomic_t			refcnt;
-	atomic_t			seq_nr;
+	atomic_unchecked_t		seq_nr;
 	struct padata_cpumask		cpumask;
 	spinlock_t                      lock ____cacheline_aligned;
 	unsigned int			processed;
diff --git a/include/linux/pagemap.h b/include/linux/pagemap.h
index d47cc4ab7..e1c38867d 100644
--- a/include/linux/pagemap.h
+++ b/include/linux/pagemap.h
@@ -215,7 +215,7 @@ static inline gfp_t readahead_gfp_mask(struct address_space *x)
 				  __GFP_COLD | __GFP_NORETRY | __GFP_NOWARN;
 }
 
-typedef int filler_t(void *, struct page *);
+typedef int filler_t(struct file *, struct page *);
 
 pgoff_t page_cache_next_hole(struct address_space *mapping,
 			     pgoff_t index, unsigned long max_scan);
@@ -359,7 +359,7 @@ extern int read_cache_pages(struct address_space *mapping,
 static inline struct page *read_mapping_page(struct address_space *mapping,
 				pgoff_t index, void *data)
 {
-	filler_t *filler = (filler_t *)mapping->a_ops->readpage;
+	filler_t *filler = mapping->a_ops->readpage;
 	return read_cache_page(mapping, index, filler, data);
 }
 
diff --git a/include/linux/path.h b/include/linux/path.h
index d1372186f..be0c176b2 100644
--- a/include/linux/path.h
+++ b/include/linux/path.h
@@ -1,13 +1,15 @@
 #ifndef _LINUX_PATH_H
 #define _LINUX_PATH_H
 
+#include <linux/compiler.h>
+
 struct dentry;
 struct vfsmount;
 
 struct path {
 	struct vfsmount *mnt;
 	struct dentry *dentry;
-};
+} __randomize_layout;
 
 extern void path_get(const struct path *);
 extern void path_put(const struct path *);
diff --git a/include/linux/pci_hotplug.h b/include/linux/pci_hotplug.h
index 8c7895061..0d74ed91f 100644
--- a/include/linux/pci_hotplug.h
+++ b/include/linux/pci_hotplug.h
@@ -71,7 +71,8 @@ struct hotplug_slot_ops {
 	int (*get_latch_status)		(struct hotplug_slot *slot, u8 *value);
 	int (*get_adapter_status)	(struct hotplug_slot *slot, u8 *value);
 	int (*reset_slot)		(struct hotplug_slot *slot, int probe);
-};
+} __do_const;
+typedef struct hotplug_slot_ops __no_const hotplug_slot_ops_no_const;
 
 /**
  * struct hotplug_slot_info - used to notify the hotplug pci core of the state of the slot
diff --git a/include/linux/percpu.h b/include/linux/percpu.h
index 56939d3f6..7fb18e311 100644
--- a/include/linux/percpu.h
+++ b/include/linux/percpu.h
@@ -28,7 +28,7 @@
  * preallocate for this.  Keep PERCPU_DYNAMIC_RESERVE equal to or
  * larger than PERCPU_DYNAMIC_EARLY_SIZE.
  */
-#define PERCPU_DYNAMIC_EARLY_SLOTS	128
+#define PERCPU_DYNAMIC_EARLY_SLOTS	256
 #define PERCPU_DYNAMIC_EARLY_SIZE	(12 << 10)
 
 /*
diff --git a/include/linux/perf_event.h b/include/linux/perf_event.h
index 2b6b43cc0..70211156a 100644
--- a/include/linux/perf_event.h
+++ b/include/linux/perf_event.h
@@ -575,8 +575,8 @@ struct perf_event {
 
 	enum perf_event_active_state	state;
 	unsigned int			attach_state;
-	local64_t			count;
-	atomic64_t			child_count;
+	local64_t			count; /* PaX: fix it one day */
+	atomic64_unchecked_t		child_count;
 
 	/*
 	 * These are the total time in nanoseconds that the event
@@ -627,8 +627,8 @@ struct perf_event {
 	 * These accumulate total time (in nanoseconds) that children
 	 * events have been enabled and running, respectively.
 	 */
-	atomic64_t			child_total_time_enabled;
-	atomic64_t			child_total_time_running;
+	atomic64_unchecked_t		child_total_time_enabled;
+	atomic64_unchecked_t		child_total_time_running;
 
 	/*
 	 * Protect attach/detach and child_list:
@@ -1077,7 +1077,7 @@ static inline void perf_event_task_sched_out(struct task_struct *prev,
 
 static inline u64 __perf_event_count(struct perf_event *event)
 {
-	return local64_read(&event->count) + atomic64_read(&event->child_count);
+	return local64_read(&event->count) + atomic64_read_unchecked(&event->child_count);
 }
 
 extern void perf_event_mmap(struct vm_area_struct *vma);
@@ -1128,7 +1128,7 @@ static inline int perf_callchain_store(struct perf_callchain_entry_ctx *ctx, u64
 	}
 }
 
-extern int sysctl_perf_event_paranoid;
+extern int sysctl_perf_event_legitimately_concerned;
 extern int sysctl_perf_event_mlock;
 extern int sysctl_perf_event_sample_rate;
 extern int sysctl_perf_cpu_time_max_percent;
@@ -1145,19 +1145,24 @@ extern int perf_cpu_time_max_percent_handler(struct ctl_table *table, int write,
 int perf_event_max_stack_handler(struct ctl_table *table, int write,
 				 void __user *buffer, size_t *lenp, loff_t *ppos);
 
+static inline bool perf_paranoid_any(void)
+{
+	return sysctl_perf_event_legitimately_concerned > 2;
+}
+
 static inline bool perf_paranoid_tracepoint_raw(void)
 {
-	return sysctl_perf_event_paranoid > -1;
+	return sysctl_perf_event_legitimately_concerned > -1;
 }
 
 static inline bool perf_paranoid_cpu(void)
 {
-	return sysctl_perf_event_paranoid > 0;
+	return sysctl_perf_event_legitimately_concerned > 0;
 }
 
 static inline bool perf_paranoid_kernel(void)
 {
-	return sysctl_perf_event_paranoid > 1;
+	return sysctl_perf_event_legitimately_concerned > 1;
 }
 
 extern void perf_event_init(void);
@@ -1317,7 +1322,7 @@ struct perf_pmu_events_attr {
 	struct device_attribute attr;
 	u64 id;
 	const char *event_str;
-};
+} __do_const;
 
 struct perf_pmu_events_ht_attr {
 	struct device_attribute			attr;
diff --git a/include/linux/pid.h b/include/linux/pid.h
index 23705a53a..af2bfb481 100644
--- a/include/linux/pid.h
+++ b/include/linux/pid.h
@@ -169,8 +169,8 @@ static inline pid_t pid_nr(struct pid *pid)
 	return nr;
 }
 
-pid_t pid_nr_ns(struct pid *pid, struct pid_namespace *ns);
-pid_t pid_vnr(struct pid *pid);
+pid_t pid_nr_ns(const struct pid *pid, const struct pid_namespace *ns);
+pid_t pid_vnr(const struct pid *pid);
 
 #define do_each_pid_task(pid, type, task)				\
 	do {								\
diff --git a/include/linux/pid_namespace.h b/include/linux/pid_namespace.h
index 918b117a7..7af374b76 100644
--- a/include/linux/pid_namespace.h
+++ b/include/linux/pid_namespace.h
@@ -45,7 +45,7 @@ struct pid_namespace {
 	int hide_pid;
 	int reboot;	/* group exit code if this pidns was rebooted */
 	struct ns_common ns;
-};
+} __randomize_layout;
 
 extern struct pid_namespace init_pid_ns;
 
diff --git a/include/linux/pipe_fs_i.h b/include/linux/pipe_fs_i.h
index 24f5470d3..deb60897a 100644
--- a/include/linux/pipe_fs_i.h
+++ b/include/linux/pipe_fs_i.h
@@ -48,10 +48,10 @@ struct pipe_inode_info {
 	struct mutex mutex;
 	wait_queue_head_t wait;
 	unsigned int nrbufs, curbuf, buffers;
-	unsigned int readers;
-	unsigned int writers;
-	unsigned int files;
-	unsigned int waiting_writers;
+	atomic_t readers;
+	atomic_t writers;
+	atomic_t files;
+	atomic_t waiting_writers;
 	unsigned int r_counter;
 	unsigned int w_counter;
 	struct page *tmp_page;
diff --git a/include/linux/pm.h b/include/linux/pm.h
index 06eb35318..dbf4a341b 100644
--- a/include/linux/pm.h
+++ b/include/linux/pm.h
@@ -631,6 +631,7 @@ struct dev_pm_domain {
 	void (*sync)(struct device *dev);
 	void (*dismiss)(struct device *dev);
 };
+typedef struct dev_pm_domain __no_const dev_pm_domain_no_const;
 
 /*
  * The PM_EVENT_ messages are also used by drivers implementing the legacy
diff --git a/include/linux/pm_domain.h b/include/linux/pm_domain.h
index 31fec8580..97f390608 100644
--- a/include/linux/pm_domain.h
+++ b/include/linux/pm_domain.h
@@ -35,7 +35,7 @@ struct gpd_dev_ops {
 	int (*start)(struct device *dev);
 	int (*stop)(struct device *dev);
 	bool (*active_wakeup)(struct device *dev);
-};
+} __no_const;
 
 struct genpd_power_state {
 	s64 power_off_latency_ns;
diff --git a/include/linux/pm_runtime.h b/include/linux/pm_runtime.h
index 2e14d2667..aed7c639c 100644
--- a/include/linux/pm_runtime.h
+++ b/include/linux/pm_runtime.h
@@ -116,7 +116,7 @@ static inline bool pm_runtime_callbacks_present(struct device *dev)
 
 static inline void pm_runtime_mark_last_busy(struct device *dev)
 {
-	ACCESS_ONCE(dev->power.last_busy) = jiffies;
+	ACCESS_ONCE_RW(dev->power.last_busy) = jiffies;
 }
 
 static inline bool pm_runtime_is_irq_safe(struct device *dev)
diff --git a/include/linux/pnp.h b/include/linux/pnp.h
index 2588ca6a9..b705409b7 100644
--- a/include/linux/pnp.h
+++ b/include/linux/pnp.h
@@ -298,7 +298,7 @@ static inline void pnp_set_drvdata(struct pnp_dev *pdev, void *data)
 struct pnp_fixup {
 	char id[7];
 	void (*quirk_function) (struct pnp_dev * dev);	/* fixup function */
-};
+} __do_const;
 
 /* config parameters */
 #define PNP_CONFIG_NORMAL	0x0001
diff --git a/include/linux/poison.h b/include/linux/poison.h
index 51334edec..7fda393eb 100644
--- a/include/linux/poison.h
+++ b/include/linux/poison.h
@@ -19,8 +19,8 @@
  * under normal circumstances, used to verify that nobody uses
  * non-initialized list entries.
  */
-#define LIST_POISON1  ((void *) 0x100 + POISON_POINTER_DELTA)
-#define LIST_POISON2  ((void *) 0x200 + POISON_POINTER_DELTA)
+#define LIST_POISON1  ((void *) (long)0xFFFFFF02)
+#define LIST_POISON2  ((void *) (long)0xFFFFFF04)
 
 /********** include/linux/timer.h **********/
 /*
diff --git a/include/linux/power/smartreflex.h b/include/linux/power/smartreflex.h
index d8b187c39..9a9257ac2 100644
--- a/include/linux/power/smartreflex.h
+++ b/include/linux/power/smartreflex.h
@@ -238,7 +238,7 @@ struct omap_sr_class_data {
 	int (*notify)(struct omap_sr *sr, u32 status);
 	u8 notify_flags;
 	u8 class_type;
-};
+} __do_const;
 
 /**
  * struct omap_sr_nvalue_table	- Smartreflex n-target value info
diff --git a/include/linux/ppp-comp.h b/include/linux/ppp-comp.h
index 4ea1d377e..80f4b335e 100644
--- a/include/linux/ppp-comp.h
+++ b/include/linux/ppp-comp.h
@@ -84,7 +84,7 @@ struct compressor {
 	struct module *owner;
 	/* Extra skb space needed by the compressor algorithm */
 	unsigned int comp_extra;
-};
+} __do_const;
 
 /*
  * The return value from decompress routine is the length of the
diff --git a/include/linux/preempt.h b/include/linux/preempt.h
index 75e4e3067..fcfde15ae 100644
--- a/include/linux/preempt.h
+++ b/include/linux/preempt.h
@@ -134,11 +134,16 @@ extern void preempt_count_sub(int val);
 #define preempt_count_dec_and_test() __preempt_count_dec_and_test()
 #endif
 
+#define raw_preempt_count_add(val)	__preempt_count_add(val)
+#define raw_preempt_count_sub(val)	__preempt_count_sub(val)
+
 #define __preempt_count_inc() __preempt_count_add(1)
 #define __preempt_count_dec() __preempt_count_sub(1)
 
 #define preempt_count_inc() preempt_count_add(1)
+#define raw_preempt_count_inc() raw_preempt_count_add(1)
 #define preempt_count_dec() preempt_count_sub(1)
+#define raw_preempt_count_dec() raw_preempt_count_sub(1)
 
 #ifdef CONFIG_PREEMPT_COUNT
 
@@ -148,6 +153,12 @@ do { \
 	barrier(); \
 } while (0)
 
+#define raw_preempt_disable() \
+do { \
+	raw_preempt_count_inc(); \
+	barrier(); \
+} while (0)
+
 #define sched_preempt_enable_no_resched() \
 do { \
 	barrier(); \
@@ -156,6 +167,12 @@ do { \
 
 #define preempt_enable_no_resched() sched_preempt_enable_no_resched()
 
+#define raw_preempt_enable_no_resched() \
+do { \
+	barrier(); \
+	raw_preempt_count_dec(); \
+} while (0)
+
 #define preemptible()	(preempt_count() == 0 && !irqs_disabled())
 
 #ifdef CONFIG_PREEMPT
@@ -216,8 +233,10 @@ do { \
  * region.
  */
 #define preempt_disable()			barrier()
+#define raw_preempt_disable()			barrier()
 #define sched_preempt_enable_no_resched()	barrier()
 #define preempt_enable_no_resched()		barrier()
+#define raw_preempt_enable_no_resched()		barrier()
 #define preempt_enable()			barrier()
 #define preempt_check_resched()			do { } while (0)
 
@@ -232,11 +251,13 @@ do { \
 /*
  * Modules have no business playing preemption tricks.
  */
+#ifndef CONFIG_PAX_KERNEXEC
 #undef sched_preempt_enable_no_resched
 #undef preempt_enable_no_resched
 #undef preempt_enable_no_resched_notrace
 #undef preempt_check_resched
 #endif
+#endif
 
 #define preempt_set_need_resched() \
 do { \
diff --git a/include/linux/printk.h b/include/linux/printk.h
index 696a56be7..c7cff385d 100644
--- a/include/linux/printk.h
+++ b/include/linux/printk.h
@@ -43,7 +43,7 @@ static inline const char *printk_skip_level(const char *buffer)
 #define CONSOLE_LOGLEVEL_DEBUG	10 /* issue debug messages */
 #define CONSOLE_LOGLEVEL_MOTORMOUTH 15	/* You can't shut this one up */
 
-extern int console_printk[];
+extern int console_printk[4];
 
 #define console_loglevel (console_printk[0])
 #define default_message_loglevel (console_printk[1])
@@ -144,6 +144,8 @@ static inline void printk_nmi_flush(void) { }
 static inline void printk_nmi_flush_on_panic(void) { }
 #endif /* PRINTK_NMI */
 
+extern int kptr_restrict;
+
 #ifdef CONFIG_PRINTK
 asmlinkage __printf(5, 0)
 int vprintk_emit(int facility, int level,
@@ -171,14 +173,13 @@ __printf(1, 2) __cold int printk_deferred(const char *fmt, ...);
  * with all other unrelated printk_ratelimit() callsites.  Instead use
  * printk_ratelimited() or plain old __ratelimit().
  */
-extern int __printk_ratelimit(const char *func);
+extern int __printk_ratelimit(const char *func) __nocapture(1);
 #define printk_ratelimit() __printk_ratelimit(__func__)
 extern bool printk_timed_ratelimit(unsigned long *caller_jiffies,
 				   unsigned int interval_msec);
 
 extern int printk_delay_msec;
 extern int dmesg_restrict;
-extern int kptr_restrict;
 
 extern int
 devkmsg_sysctl_set_loglvl(struct ctl_table *table, int write, void __user *buf,
diff --git a/include/linux/proc_fs.h b/include/linux/proc_fs.h
index b97bf2ef9..f14c92d4c 100644
--- a/include/linux/proc_fs.h
+++ b/include/linux/proc_fs.h
@@ -17,8 +17,11 @@ extern void proc_flush_task(struct task_struct *);
 extern struct proc_dir_entry *proc_symlink(const char *,
 		struct proc_dir_entry *, const char *);
 extern struct proc_dir_entry *proc_mkdir(const char *, struct proc_dir_entry *);
+extern struct proc_dir_entry *proc_mkdir_restrict(const char *, struct proc_dir_entry *);
 extern struct proc_dir_entry *proc_mkdir_data(const char *, umode_t,
 					      struct proc_dir_entry *, void *);
+extern struct proc_dir_entry *proc_mkdir_data_restrict(const char *, umode_t,
+					      struct proc_dir_entry *, void *);
 extern struct proc_dir_entry *proc_mkdir_mode(const char *, umode_t,
 					      struct proc_dir_entry *);
  
@@ -34,6 +37,19 @@ static inline struct proc_dir_entry *proc_create(
 	return proc_create_data(name, mode, parent, proc_fops, NULL);
 }
 
+static inline struct proc_dir_entry *proc_create_grsec(const char *name, umode_t mode,
+	struct proc_dir_entry *parent, const struct file_operations *proc_fops)
+{
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	return proc_create_data(name, S_IRUSR, parent, proc_fops, NULL);
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	return proc_create_data(name, S_IRUSR | S_IRGRP, parent, proc_fops, NULL);
+#else
+	return proc_create_data(name, mode, parent, proc_fops, NULL);
+#endif
+}
+
+
 extern void proc_set_size(struct proc_dir_entry *, loff_t);
 extern void proc_set_user(struct proc_dir_entry *, kuid_t, kgid_t);
 extern void *PDE_DATA(const struct inode *);
@@ -56,8 +72,12 @@ static inline struct proc_dir_entry *proc_symlink(const char *name,
 		struct proc_dir_entry *parent,const char *dest) { return NULL;}
 static inline struct proc_dir_entry *proc_mkdir(const char *name,
 	struct proc_dir_entry *parent) {return NULL;}
+static inline struct proc_dir_entry *proc_mkdir_restrict(const char *name,
+	struct proc_dir_entry *parent) { return NULL; }
 static inline struct proc_dir_entry *proc_mkdir_data(const char *name,
 	umode_t mode, struct proc_dir_entry *parent, void *data) { return NULL; }
+static inline  struct proc_dir_entry *proc_mkdir_data_restrict(const char *name,
+	umode_t mode, struct proc_dir_entry *parent, void *data) { return NULL; }
 static inline struct proc_dir_entry *proc_mkdir_mode(const char *name,
 	umode_t mode, struct proc_dir_entry *parent) { return NULL; }
 #define proc_create(name, mode, parent, proc_fops) ({NULL;})
@@ -79,7 +99,7 @@ struct net;
 static inline struct proc_dir_entry *proc_net_mkdir(
 	struct net *net, const char *name, struct proc_dir_entry *parent)
 {
-	return proc_mkdir_data(name, 0, parent, net);
+	return proc_mkdir_data_restrict(name, 0, parent, net);
 }
 
 #endif /* _LINUX_PROC_FS_H */
diff --git a/include/linux/proc_ns.h b/include/linux/proc_ns.h
index de0e7719d..9e746e9e4 100644
--- a/include/linux/proc_ns.h
+++ b/include/linux/proc_ns.h
@@ -18,7 +18,7 @@ struct proc_ns_operations {
 	struct ns_common *(*get)(struct task_struct *task);
 	void (*put)(struct ns_common *ns);
 	int (*install)(struct nsproxy *nsproxy, struct ns_common *ns);
-};
+} __do_const __randomize_layout;
 
 extern const struct proc_ns_operations netns_operations;
 extern const struct proc_ns_operations utsns_operations;
diff --git a/include/linux/psci.h b/include/linux/psci.h
index bdea1cb5e..a094b75ec 100644
--- a/include/linux/psci.h
+++ b/include/linux/psci.h
@@ -33,7 +33,7 @@ struct psci_operations {
 	int (*affinity_info)(unsigned long target_affinity,
 			unsigned long lowest_affinity_level);
 	int (*migrate_info_type)(void);
-};
+} __no_const;
 
 extern struct psci_operations psci_ops;
 
diff --git a/include/linux/quota.h b/include/linux/quota.h
index 55107a8ff..eb061784c 100644
--- a/include/linux/quota.h
+++ b/include/linux/quota.h
@@ -76,7 +76,7 @@ struct kqid {			/* Type in which we store the quota identifier */
 
 extern bool qid_eq(struct kqid left, struct kqid right);
 extern bool qid_lt(struct kqid left, struct kqid right);
-extern qid_t from_kqid(struct user_namespace *to, struct kqid qid);
+extern qid_t from_kqid(struct user_namespace *to, struct kqid qid) __intentional_overflow(-1);
 extern qid_t from_kqid_munged(struct user_namespace *to, struct kqid qid);
 extern bool qid_valid(struct kqid qid);
 
diff --git a/include/linux/random.h b/include/linux/random.h
index 3d6e9815c..4925f178c 100644
--- a/include/linux/random.h
+++ b/include/linux/random.h
@@ -18,9 +18,19 @@ struct random_ready_callback {
 };
 
 extern void add_device_randomness(const void *, unsigned int);
+
+#if defined(LATENT_ENTROPY_PLUGIN) && !defined(__CHECKER__)
+static inline void add_latent_entropy(void)
+{
+	add_device_randomness((const void *)&latent_entropy, sizeof(latent_entropy));
+}
+#else
+static inline void add_latent_entropy(void) {}
+#endif
+
 extern void add_input_randomness(unsigned int type, unsigned int code,
-				 unsigned int value);
-extern void add_interrupt_randomness(int irq, int irq_flags);
+				 unsigned int value) __latent_entropy;
+extern void add_interrupt_randomness(int irq, int irq_flags) __latent_entropy;
 
 extern void get_random_bytes(void *buf, int nbytes);
 extern int add_random_ready_callback(struct random_ready_callback *rdy);
@@ -52,6 +62,11 @@ void prandom_seed_full_state(struct rnd_state __percpu *pcpu_state);
 #define prandom_init_once(pcpu_state)			\
 	DO_ONCE(prandom_seed_full_state, (pcpu_state))
 
+static inline unsigned long __intentional_overflow(-1) pax_get_random_long(void)
+{
+	return prandom_u32() + (sizeof(long) > 4 ? (unsigned long)prandom_u32() << 32 : 0);
+}
+
 /**
  * prandom_u32_max - returns a pseudo-random number in interval [0, ep_ro)
  * @ep_ro: right open interval endpoint
@@ -64,7 +79,7 @@ void prandom_seed_full_state(struct rnd_state __percpu *pcpu_state);
  *
  * Returns: pseudo-random number in interval [0, ep_ro)
  */
-static inline u32 prandom_u32_max(u32 ep_ro)
+static inline u32 __intentional_overflow(-1) prandom_u32_max(u32 ep_ro)
 {
 	return (u32)(((u64) prandom_u32() * ep_ro) >> 32);
 }
diff --git a/include/linux/ratelimit.h b/include/linux/ratelimit.h
index 57c9e0622..fe141261a 100644
--- a/include/linux/ratelimit.h
+++ b/include/linux/ratelimit.h
@@ -72,7 +72,8 @@ ratelimit_set_flags(struct ratelimit_state *rs, unsigned long flags)
 
 extern struct ratelimit_state printk_ratelimit_state;
 
-extern int ___ratelimit(struct ratelimit_state *rs, const char *func);
+extern __nocapture(2)
+int ___ratelimit(struct ratelimit_state *rs, const char *func);
 #define __ratelimit(state) ___ratelimit(state, __func__)
 
 #ifdef CONFIG_PRINTK
diff --git a/include/linux/rbtree_augmented.h b/include/linux/rbtree_augmented.h
index d076183e4..9702b6e18 100644
--- a/include/linux/rbtree_augmented.h
+++ b/include/linux/rbtree_augmented.h
@@ -90,7 +90,9 @@ rbname ## _rotate(struct rb_node *rb_old, struct rb_node *rb_new)	\
 	old->rbaugmented = rbcompute(old);				\
 }									\
 rbstatic const struct rb_augment_callbacks rbname = {			\
-	rbname ## _propagate, rbname ## _copy, rbname ## _rotate	\
+	.propagate = rbname ## _propagate,				\
+	.copy = rbname ## _copy,					\
+	.rotate = rbname ## _rotate					\
 };
 
 
diff --git a/include/linux/rculist.h b/include/linux/rculist.h
index 8beb98dcf..c515d454b 100644
--- a/include/linux/rculist.h
+++ b/include/linux/rculist.h
@@ -59,6 +59,9 @@ void __list_add_rcu(struct list_head *new,
 		    struct list_head *prev, struct list_head *next);
 #endif
 
+void __pax_list_add_rcu(struct list_head *new,
+			struct list_head *prev, struct list_head *next);
+
 /**
  * list_add_rcu - add a new entry to rcu-protected list
  * @new: new entry to be added
@@ -80,6 +83,11 @@ static inline void list_add_rcu(struct list_head *new, struct list_head *head)
 	__list_add_rcu(new, head, head->next);
 }
 
+static inline void pax_list_add_rcu(struct list_head *new, struct list_head *head)
+{
+	__pax_list_add_rcu(new, head, head->next);
+}
+
 /**
  * list_add_tail_rcu - add a new entry to rcu-protected list
  * @new: new entry to be added
@@ -102,6 +110,12 @@ static inline void list_add_tail_rcu(struct list_head *new,
 	__list_add_rcu(new, head->prev, head);
 }
 
+static inline void pax_list_add_tail_rcu(struct list_head *new,
+					struct list_head *head)
+{
+	__pax_list_add_rcu(new, head->prev, head);
+}
+
 /**
  * list_del_rcu - deletes entry from list without re-initialization
  * @entry: the element to delete from the list.
@@ -132,6 +146,8 @@ static inline void list_del_rcu(struct list_head *entry)
 	entry->prev = LIST_POISON2;
 }
 
+extern void pax_list_del_rcu(struct list_head *entry);
+
 /**
  * hlist_del_init_rcu - deletes entry from hash list with re-initialization
  * @n: the element to delete from the hash list.
diff --git a/include/linux/rcupdate.h b/include/linux/rcupdate.h
index 1aa62e1a7..8f6733786 100644
--- a/include/linux/rcupdate.h
+++ b/include/linux/rcupdate.h
@@ -863,6 +863,7 @@ static inline void rcu_preempt_sleep_check(void)
  * read-side critical sections may be preempted and they may also block, but
  * only when acquiring spinlocks that are subject to priority inheritance.
  */
+static inline void rcu_read_lock(void) __acquires(RCU);
 static inline void rcu_read_lock(void)
 {
 	__rcu_read_lock();
@@ -917,6 +918,7 @@ static inline void rcu_read_lock(void)
  *
  * See rcu_read_lock() for more information.
  */
+static inline void rcu_read_unlock(void) __releases(RCU);
 static inline void rcu_read_unlock(void)
 {
 	RCU_LOCKDEP_WARN(!rcu_is_watching(),
@@ -943,6 +945,7 @@ static inline void rcu_read_unlock(void)
  * rcu_read_unlock_bh() from one task if the matching rcu_read_lock_bh()
  * was invoked from some other task.
  */
+static inline void rcu_read_lock_bh(void) __acquires(RCU_BH);
 static inline void rcu_read_lock_bh(void)
 {
 	local_bh_disable();
@@ -957,6 +960,7 @@ static inline void rcu_read_lock_bh(void)
  *
  * See rcu_read_lock_bh() for more information.
  */
+static inline void rcu_read_unlock_bh(void) __releases(RCU_BH);
 static inline void rcu_read_unlock_bh(void)
 {
 	RCU_LOCKDEP_WARN(!rcu_is_watching(),
@@ -979,6 +983,7 @@ static inline void rcu_read_unlock_bh(void)
  * rcu_read_unlock_sched() from process context if the matching
  * rcu_read_lock_sched() was invoked from an NMI handler.
  */
+static inline void rcu_read_lock_sched(void) __acquires(RCU_SCHED);
 static inline void rcu_read_lock_sched(void)
 {
 	preempt_disable();
@@ -989,6 +994,7 @@ static inline void rcu_read_lock_sched(void)
 }
 
 /* Used by lockdep and tracing: cannot be traced, cannot call lockdep. */
+static inline notrace void rcu_read_lock_sched_notrace(void) __acquires(RCU_SCHED);
 static inline notrace void rcu_read_lock_sched_notrace(void)
 {
 	preempt_disable_notrace();
@@ -1000,6 +1006,7 @@ static inline notrace void rcu_read_lock_sched_notrace(void)
  *
  * See rcu_read_lock_sched for more information.
  */
+static inline void rcu_read_unlock_sched(void) __releases(RCU_SCHED);
 static inline void rcu_read_unlock_sched(void)
 {
 	RCU_LOCKDEP_WARN(!rcu_is_watching(),
@@ -1010,6 +1017,7 @@ static inline void rcu_read_unlock_sched(void)
 }
 
 /* Used by lockdep and tracing: cannot be traced, cannot call lockdep. */
+static inline notrace void rcu_read_unlock_sched_notrace(void) __releases(RCU_SCHED);
 static inline notrace void rcu_read_unlock_sched_notrace(void)
 {
 	__release(RCU_SCHED);
diff --git a/include/linux/reboot.h b/include/linux/reboot.h
index a7ff409f3..03e2fa8e7 100644
--- a/include/linux/reboot.h
+++ b/include/linux/reboot.h
@@ -47,9 +47,9 @@ extern void do_kernel_restart(char *cmd);
  */
 
 extern void migrate_to_reboot_cpu(void);
-extern void machine_restart(char *cmd);
-extern void machine_halt(void);
-extern void machine_power_off(void);
+extern void machine_restart(char *cmd) __noreturn;
+extern void machine_halt(void) __noreturn;
+extern void machine_power_off(void) __noreturn;
 
 extern void machine_shutdown(void);
 struct pt_regs;
@@ -60,9 +60,9 @@ extern void machine_crash_shutdown(struct pt_regs *);
  */
 
 extern void kernel_restart_prepare(char *cmd);
-extern void kernel_restart(char *cmd);
-extern void kernel_halt(void);
-extern void kernel_power_off(void);
+extern void kernel_restart(char *cmd) __noreturn;
+extern void kernel_halt(void) __noreturn;
+extern void kernel_power_off(void) __noreturn;
 
 extern int C_A_D; /* for sysctl */
 void ctrl_alt_del(void);
@@ -77,7 +77,7 @@ extern void orderly_reboot(void);
  * Emergency restart, callable from an interrupt handler.
  */
 
-extern void emergency_restart(void);
+extern void emergency_restart(void) __noreturn;
 #include <asm/emergency-restart.h>
 
 #endif /* _LINUX_REBOOT_H */
diff --git a/include/linux/regset.h b/include/linux/regset.h
index 8e0c9febf..ac4d22149 100644
--- a/include/linux/regset.h
+++ b/include/linux/regset.h
@@ -161,7 +161,8 @@ struct user_regset {
 	unsigned int 			align;
 	unsigned int 			bias;
 	unsigned int 			core_note_type;
-};
+} __do_const;
+typedef struct user_regset __no_const user_regset_no_const;
 
 /**
  * struct user_regset_view - available regsets
diff --git a/include/linux/relay.h b/include/linux/relay.h
index d7c835969..818daf53e 100644
--- a/include/linux/relay.h
+++ b/include/linux/relay.h
@@ -157,7 +157,7 @@ struct rchan_callbacks
 	 * The callback should return 0 if successful, negative if not.
 	 */
 	int (*remove_buf_file)(struct dentry *dentry);
-};
+} __no_const;
 
 /*
  * CONFIG_RELAY kernel API, kernel/relay.c
diff --git a/include/linux/rio.h b/include/linux/rio.h
index 37b95c4af..2457ca925 100644
--- a/include/linux/rio.h
+++ b/include/linux/rio.h
@@ -429,7 +429,7 @@ struct rio_ops {
 	int (*map_outb)(struct rio_mport *mport, u16 destid, u64 rstart,
 			u32 size, u32 flags, dma_addr_t *laddr);
 	void (*unmap_outb)(struct rio_mport *mport, u16 destid, u64 rstart);
-};
+} __no_const;
 
 #define RIO_RESOURCE_MEM	0x00000100
 #define RIO_RESOURCE_DOORBELL	0x00000200
diff --git a/include/linux/rmap.h b/include/linux/rmap.h
index b46bb5620..f5a474863 100644
--- a/include/linux/rmap.h
+++ b/include/linux/rmap.h
@@ -139,8 +139,8 @@ static inline void anon_vma_unlock_read(struct anon_vma *anon_vma)
 void anon_vma_init(void);	/* create anon_vma_cachep */
 int  anon_vma_prepare(struct vm_area_struct *);
 void unlink_anon_vmas(struct vm_area_struct *);
-int anon_vma_clone(struct vm_area_struct *, struct vm_area_struct *);
-int anon_vma_fork(struct vm_area_struct *, struct vm_area_struct *);
+int anon_vma_clone(struct vm_area_struct *, const struct vm_area_struct *);
+int anon_vma_fork(struct vm_area_struct *, const struct vm_area_struct *);
 
 static inline void anon_vma_merge(struct vm_area_struct *vma,
 				  struct vm_area_struct *next)
diff --git a/include/linux/scatterlist.h b/include/linux/scatterlist.h
index cb3c8fe6a..85365ba92 100644
--- a/include/linux/scatterlist.h
+++ b/include/linux/scatterlist.h
@@ -1,6 +1,7 @@
 #ifndef _LINUX_SCATTERLIST_H
 #define _LINUX_SCATTERLIST_H
 
+#include <linux/sched.h>
 #include <linux/string.h>
 #include <linux/types.h>
 #include <linux/bug.h>
@@ -136,10 +137,17 @@ static inline struct page *sg_page(struct scatterlist *sg)
 static inline void sg_set_buf(struct scatterlist *sg, const void *buf,
 			      unsigned int buflen)
 {
+	const void *realbuf = buf;
+
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	if (object_starts_on_stack(buf))
+		realbuf = buf - current->stack + current->lowmem_stack;
+#endif
+
 #ifdef CONFIG_DEBUG_SG
-	BUG_ON(!virt_addr_valid(buf));
+	BUG_ON(!virt_addr_valid(realbuf));
 #endif
-	sg_set_page(sg, virt_to_page(buf), buflen, offset_in_page(buf));
+	sg_set_page(sg, virt_to_page(realbuf), buflen, offset_in_page(realbuf));
 }
 
 /*
diff --git a/include/linux/sched.h b/include/linux/sched.h
index f52d4cc97..f20b8f555 100644
--- a/include/linux/sched.h
+++ b/include/linux/sched.h
@@ -7,7 +7,7 @@
 
 
 struct sched_param {
-	int sched_priority;
+	unsigned int sched_priority;
 };
 
 #include <asm/param.h>	/* for HZ */
@@ -134,6 +134,7 @@ struct perf_event_context;
 struct blk_plug;
 struct filename;
 struct nameidata;
+struct linux_binprm;
 
 #define VMACACHE_BITS 2
 #define VMACACHE_SIZE (1U << VMACACHE_BITS)
@@ -452,6 +453,18 @@ struct nsproxy;
 struct user_namespace;
 
 #ifdef CONFIG_MMU
+
+#ifdef CONFIG_GRKERNSEC_RAND_THREADSTACK
+extern unsigned long gr_rand_threadstack_offset(const struct mm_struct *mm, const struct file *filp, unsigned long flags);
+#else
+static inline unsigned long gr_rand_threadstack_offset(const struct mm_struct *mm, const struct file *filp, unsigned long flags)
+{
+	return 0;
+}
+#endif
+
+extern bool check_heap_stack_gap(const struct vm_area_struct *vma, unsigned long addr, unsigned long len, unsigned long offset);
+
 extern void arch_pick_mmap_layout(struct mm_struct *mm);
 extern unsigned long
 arch_get_unmapped_area(struct file *, unsigned long, unsigned long,
@@ -791,6 +804,17 @@ struct signal_struct {
 #ifdef CONFIG_TASKSTATS
 	struct taskstats *stats;
 #endif
+
+#ifdef CONFIG_GRKERNSEC
+	u32 curr_ip;
+	u32 saved_ip;
+	u32 gr_saddr;
+	u32 gr_daddr;
+	u16 gr_sport;
+	u16 gr_dport;
+	u8 used_accept:1;
+#endif
+
 #ifdef CONFIG_AUDIT
 	unsigned audit_tty;
 	struct tty_audit_buf *tty_audit_buf;
@@ -808,7 +832,7 @@ struct signal_struct {
 	struct mutex cred_guard_mutex;	/* guard against foreign influences on
 					 * credential calculations
 					 * (notably. ptrace) */
-};
+} __randomize_layout;
 
 /*
  * Bits in flags field of signal_struct.
@@ -863,6 +887,14 @@ struct user_struct {
 	struct key *session_keyring;	/* UID's default session keyring */
 #endif
 
+#ifdef CONFIG_GRKERNSEC_KERN_LOCKOUT
+	unsigned char kernel_banned;
+#endif
+#ifdef CONFIG_GRKERNSEC_BRUTE
+	unsigned char sugid_banned;
+	unsigned long sugid_ban_expires;
+#endif
+
 	/* Hash table maintenance information */
 	struct hlist_node uidhash_node;
 	kuid_t uid;
@@ -870,7 +902,7 @@ struct user_struct {
 #if defined(CONFIG_PERF_EVENTS) || defined(CONFIG_BPF_SYSCALL)
 	atomic_long_t locked_vm;
 #endif
-};
+} __randomize_layout;
 
 extern int uids_sysfs_init(void);
 
@@ -1460,6 +1492,9 @@ struct tlbflush_unmap_batch {
 struct task_struct {
 	volatile long state;	/* -1 unrunnable, 0 runnable, >0 stopped */
 	void *stack;
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	void *lowmem_stack;
+#endif
 	atomic_t usage;
 	unsigned int flags;	/* per process flags, defined below */
 	unsigned int ptrace;
@@ -1599,8 +1634,8 @@ struct task_struct {
 	struct list_head thread_node;
 
 	struct completion *vfork_done;		/* for vfork() */
-	int __user *set_child_tid;		/* CLONE_CHILD_SETTID */
-	int __user *clear_child_tid;		/* CLONE_CHILD_CLEARTID */
+	pid_t __user *set_child_tid;		/* CLONE_CHILD_SETTID */
+	pid_t __user *clear_child_tid;		/* CLONE_CHILD_CLEARTID */
 
 	cputime_t utime, stime, utimescaled, stimescaled;
 	cputime_t gtime;
@@ -1630,12 +1665,6 @@ struct task_struct {
 	struct task_cputime cputime_expires;
 	struct list_head cpu_timers[3];
 
-/* process credentials */
-	const struct cred __rcu *ptracer_cred; /* Tracer's credentials at attach */
-	const struct cred __rcu *real_cred; /* objective and real subjective task
-					 * credentials (COW) */
-	const struct cred __rcu *cred;	/* effective (overridable) subjective task
-					 * credentials (COW) */
 	char comm[TASK_COMM_LEN]; /* executable name excluding path
 				     - access with [gs]et_task_comm (which lock
 				       it with task_lock())
@@ -1651,6 +1680,8 @@ struct task_struct {
 /* hung task detection */
 	unsigned long last_switch_count;
 #endif
+/* CPU-specific state of this task */
+	struct thread_struct thread;
 /* filesystem information */
 	struct fs_struct *fs;
 /* open file information */
@@ -1661,8 +1692,11 @@ struct task_struct {
 	struct signal_struct *signal;
 	struct sighand_struct *sighand;
 
-	sigset_t blocked, real_blocked;
-	sigset_t saved_sigmask;	/* restored if set_restore_sigmask() was used */
+	sigset_t real_blocked;
+	struct {
+		sigset_t blocked;
+		sigset_t saved_sigmask;	/* restored if set_restore_sigmask() was used */
+	};
 	struct sigpending pending;
 
 	unsigned long sas_ss_sp;
@@ -1698,6 +1732,8 @@ struct task_struct {
 	struct rt_mutex_waiter *pi_blocked_on;
 #endif
 
+	const struct cred __rcu *ptracer_cred; /* Tracer's credentials at attach */
+
 #ifdef CONFIG_DEBUG_MUTEXES
 	/* mutex deadlock detection */
 	struct mutex_waiter *blocked_on;
@@ -1729,6 +1765,10 @@ struct task_struct {
 	unsigned int in_ubsan;
 #endif
 
+/* process credentials */
+	const struct cred __rcu *real_cred; /* objective and real subjective task
+					 * credentials (COW) */
+
 /* journalling filesystem info */
 	void *journal_info;
 
@@ -1767,6 +1807,10 @@ struct task_struct {
 	/* cg_list protected by css_set_lock and tsk->alloc_lock */
 	struct list_head cg_list;
 #endif
+
+	const struct cred __rcu *cred;	/* effective (overridable) subjective task
+					 * credentials (COW) */
+
 #ifdef CONFIG_FUTEX
 	struct robust_list_head __user *robust_list;
 #ifdef CONFIG_COMPAT
@@ -1882,7 +1926,7 @@ struct task_struct {
 	 * Number of functions that haven't been traced
 	 * because of depth overrun.
 	 */
-	atomic_t trace_overrun;
+	atomic_unchecked_t trace_overrun;
 	/* Pause for the tracing */
 	atomic_t tracing_graph_pause;
 #endif
@@ -1924,22 +1968,93 @@ struct task_struct {
 #ifdef CONFIG_MMU
 	struct task_struct *oom_reaper_list;
 #endif
-/* CPU-specific state of this task */
-	struct thread_struct thread;
-/*
- * WARNING: on x86, 'thread_struct' contains a variable-sized
- * structure.  It *MUST* be at the end of 'task_struct'.
- *
- * Do not put anything below here!
- */
-};
+
+#ifdef CONFIG_GRKERNSEC
+	/* grsecurity */
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	u64 exec_id;
+#endif
+#ifdef CONFIG_GRKERNSEC_SETXID
+	const struct cred *delayed_cred;
+#endif
+	struct dentry *gr_chroot_dentry;
+	struct acl_subject_label *acl;
+	struct acl_subject_label *tmpacl;
+	struct acl_role_label *role;
+	struct file *exec_file;
+	unsigned long brute_expires;
+	u16 acl_role_id;
+	u8 inherited;
+	/* is this the task that authenticated to the special role */
+	u8 acl_sp_role;
+	u8 is_writable;
+	u8 brute;
+	u8 gr_is_chrooted;
+#endif
+
+/* thread_info moved to task_struct */
+#ifdef CONFIG_X86
+	struct thread_info tinfo;
+#endif
+} __randomize_layout;
 
 #ifdef CONFIG_ARCH_WANTS_DYNAMIC_TASK_STRUCT
-extern int arch_task_struct_size __read_mostly;
+extern size_t arch_task_struct_size __read_mostly;
 #else
 # define arch_task_struct_size (sizeof(struct task_struct))
 #endif
 
+#define MF_PAX_PAGEEXEC		0x01000000	/* Paging based non-executable pages */
+#define MF_PAX_EMUTRAMP		0x02000000	/* Emulate trampolines */
+#define MF_PAX_MPROTECT		0x04000000	/* Restrict mprotect() */
+#define MF_PAX_RANDMMAP		0x08000000	/* Randomize mmap() base */
+/*#define MF_PAX_RANDEXEC		0x10000000*/	/* Randomize ET_EXEC base */
+#define MF_PAX_SEGMEXEC		0x20000000	/* Segmentation based non-executable pages */
+
+#ifdef CONFIG_PAX_SOFTMODE
+extern int pax_softmode;
+#endif
+
+extern int pax_check_flags(unsigned long *);
+#define PAX_PARSE_FLAGS_FALLBACK	(~0UL)
+
+/* if tsk != current then task_lock must be held on it */
+#if defined(CONFIG_PAX_NOEXEC) || defined(CONFIG_PAX_ASLR)
+static inline unsigned long pax_get_flags(struct task_struct *tsk)
+{
+	if (likely(tsk->mm))
+		return tsk->mm->pax_flags;
+	else
+		return 0UL;
+}
+
+/* if tsk != current then task_lock must be held on it */
+static inline long pax_set_flags(struct task_struct *tsk, unsigned long flags)
+{
+	if (likely(tsk->mm)) {
+		tsk->mm->pax_flags = flags;
+		return 0;
+	}
+	return -EINVAL;
+}
+#endif
+
+#ifdef CONFIG_PAX_HAVE_ACL_FLAGS
+extern void pax_set_initial_flags(struct linux_binprm *bprm);
+#elif defined(CONFIG_PAX_HOOK_ACL_FLAGS)
+extern void (*pax_set_initial_flags_func)(struct linux_binprm *bprm);
+#endif
+
+#ifdef CONFIG_PAX_SIZE_OVERFLOW
+extern bool pax_size_overflow_report_only;
+#endif
+
+struct path;
+extern char *pax_get_path(const struct path *path, char *buf, int buflen);
+extern void pax_report_fault(struct pt_regs *regs, void *pc, void *sp);
+extern void pax_report_insns(struct pt_regs *regs, void *pc, void *sp);
+extern void pax_report_refcount_error(struct pt_regs *regs, const char *kind);
+
 /* Future-safe accessor for struct task_struct's cpus_allowed. */
 #define tsk_cpus_allowed(tsk) (&(tsk)->cpus_allowed)
 
@@ -2052,7 +2167,7 @@ struct pid_namespace;
 pid_t __task_pid_nr_ns(struct task_struct *task, enum pid_type type,
 			struct pid_namespace *ns);
 
-static inline pid_t task_pid_nr(struct task_struct *tsk)
+static inline pid_t task_pid_nr(const struct task_struct *tsk)
 {
 	return tsk->pid;
 }
@@ -2419,6 +2534,48 @@ extern u64 sched_clock_cpu(int cpu);
 
 extern void sched_clock_init(void);
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+static inline void populate_stack(void *stack, unsigned int size)
+{
+	int c;
+	int *ptr = stack;
+	int *end = stack + size;
+
+	while (ptr < end) {
+		c = *(volatile int *)ptr;
+		(void)c;
+		ptr += PAGE_SIZE/sizeof(int);
+	}
+}
+#else
+static inline void populate_stack(void *stack, unsigned int size)
+{
+}
+#endif
+
+#ifdef CONFIG_GRKERNSEC
+static inline bool current_is_ptracer(struct task_struct *task, u64 *exec_id)
+{
+	bool ret = false;
+        if (!task->ptrace)
+		return ret;
+
+	rcu_read_lock();
+	read_lock(&tasklist_lock);
+	if (task->parent && task->parent == current) {
+		ret = true;
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+		if (exec_id)
+			*exec_id = task->parent->exec_id;
+#endif
+	}
+	read_unlock(&tasklist_lock);
+	rcu_read_unlock();
+
+	return ret;
+}
+#endif
+
 #ifndef CONFIG_HAVE_UNSTABLE_SCHED_CLOCK
 static inline void sched_clock_tick(void)
 {
@@ -2574,7 +2731,9 @@ extern void set_curr_task(int cpu, struct task_struct *p);
 void yield(void);
 
 union thread_union {
+#ifndef CONFIG_X86
 	struct thread_info thread_info;
+#endif
 	unsigned long stack[THREAD_SIZE/sizeof(long)];
 };
 
@@ -2607,6 +2766,7 @@ extern struct pid_namespace init_pid_ns;
  */
 
 extern struct task_struct *find_task_by_vpid(pid_t nr);
+extern struct task_struct *find_task_by_vpid_unrestricted(pid_t nr);
 extern struct task_struct *find_task_by_pid_ns(pid_t nr,
 		struct pid_namespace *ns);
 
@@ -2638,7 +2798,7 @@ extern void proc_caches_init(void);
 extern void flush_signals(struct task_struct *);
 extern void ignore_signals(struct task_struct *);
 extern void flush_signal_handlers(struct task_struct *, int force_default);
-extern int dequeue_signal(struct task_struct *tsk, sigset_t *mask, siginfo_t *info);
+extern int dequeue_signal(struct task_struct *tsk, sigset_t *mask, siginfo_t *info) __must_hold(&tsk->sighand->siglock);
 
 static inline int kernel_dequeue_signal(siginfo_t *info)
 {
@@ -2890,7 +3050,7 @@ extern void __cleanup_sighand(struct sighand_struct *);
 extern void exit_itimers(struct signal_struct *);
 extern void flush_itimer_signals(void);
 
-extern void do_group_exit(int);
+extern __noreturn void do_group_exit(int);
 
 extern int do_execve(struct filename *,
 		     const char __user * const __user *,
@@ -3005,11 +3165,13 @@ static inline int thread_group_empty(struct task_struct *p)
  * It must not be nested with write_lock_irq(&tasklist_lock),
  * neither inside nor outside.
  */
+static inline void task_lock(struct task_struct *p) __acquires(&p->alloc_lock);
 static inline void task_lock(struct task_struct *p)
 {
 	spin_lock(&p->alloc_lock);
 }
 
+static inline void task_unlock(struct task_struct *p) __releases(&p->alloc_lock);
 static inline void task_unlock(struct task_struct *p)
 {
 	spin_unlock(&p->alloc_lock);
@@ -3095,9 +3257,9 @@ static inline unsigned long *end_of_stack(struct task_struct *p)
 #define task_stack_end_corrupted(task) \
 		(*(end_of_stack(task)) != STACK_END_MAGIC)
 
-static inline int object_is_on_stack(void *obj)
+static inline int object_starts_on_stack(const void *obj)
 {
-	void *stack = task_stack_page(current);
+	const void *stack = task_stack_page(current);
 
 	return (obj >= stack) && (obj < (stack + THREAD_SIZE));
 }
@@ -3474,7 +3636,7 @@ static inline unsigned long rlimit_max(unsigned int limit)
 struct update_util_data {
 	void (*func)(struct update_util_data *data,
 		     u64 time, unsigned long util, unsigned long max);
-};
+} __no_const;
 
 void cpufreq_add_update_util_hook(int cpu, struct update_util_data *data,
 			void (*func)(struct update_util_data *data, u64 time,
diff --git a/include/linux/scif.h b/include/linux/scif.h
index 49a35d6ed..c6209dd8b 100644
--- a/include/linux/scif.h
+++ b/include/linux/scif.h
@@ -156,7 +156,7 @@ struct scif_client {
 	void (*probe)(struct scif_peer_dev *spdev);
 	void (*remove)(struct scif_peer_dev *spdev);
 	struct subsys_interface si;
-};
+} __do_const;
 
 #define SCIF_OPEN_FAILED ((scif_epd_t)-1)
 #define SCIF_REGISTER_FAILED ((off_t)-1)
diff --git a/include/linux/security.h b/include/linux/security.h
index 7831cd57b..9e8289699 100644
--- a/include/linux/security.h
+++ b/include/linux/security.h
@@ -30,6 +30,7 @@
 #include <linux/string.h>
 #include <linux/mm.h>
 #include <linux/fs.h>
+#include <linux/grsecurity.h>
 
 struct linux_binprm;
 struct cred;
diff --git a/include/linux/sem.h b/include/linux/sem.h
index d0efd6e6c..c68948cac 100644
--- a/include/linux/sem.h
+++ b/include/linux/sem.h
@@ -22,7 +22,7 @@ struct sem_array {
 	int			sem_nsems;	/* no. of semaphores in array */
 	int			complex_count;	/* pending complex operations */
 	bool			complex_mode;	/* no parallel simple ops */
-};
+} __randomize_layout;
 
 #ifdef CONFIG_SYSVIPC
 
diff --git a/include/linux/semaphore.h b/include/linux/semaphore.h
index dc368b8ce..e8952092d 100644
--- a/include/linux/semaphore.h
+++ b/include/linux/semaphore.h
@@ -37,7 +37,7 @@ static inline void sema_init(struct semaphore *sem, int val)
 }
 
 extern void down(struct semaphore *sem);
-extern int __must_check down_interruptible(struct semaphore *sem);
+extern int __must_check down_interruptible(struct semaphore *sem) __intentional_overflow(-1);
 extern int __must_check down_killable(struct semaphore *sem);
 extern int __must_check down_trylock(struct semaphore *sem);
 extern int __must_check down_timeout(struct semaphore *sem, long jiffies);
diff --git a/include/linux/seq_buf.h b/include/linux/seq_buf.h
index fb7eb9ccb..fcfd1023f 100644
--- a/include/linux/seq_buf.h
+++ b/include/linux/seq_buf.h
@@ -16,7 +16,7 @@
  * @readpos:	The next position to read in the buffer.
  */
 struct seq_buf {
-	char			*buffer;
+	unsigned char		*buffer;
 	size_t			size;
 	size_t			len;
 	loff_t			readpos;
@@ -78,7 +78,7 @@ static inline unsigned int seq_buf_used(struct seq_buf *s)
  * Return the number of bytes available in the buffer, or zero if
  * there's no space.
  */
-static inline size_t seq_buf_get_buf(struct seq_buf *s, char **bufp)
+static inline size_t seq_buf_get_buf(struct seq_buf *s, unsigned char **bufp)
 {
 	WARN_ON(s->len > s->size + 1);
 
diff --git a/include/linux/seq_file.h b/include/linux/seq_file.h
index f3d45dd42..4539816b0 100644
--- a/include/linux/seq_file.h
+++ b/include/linux/seq_file.h
@@ -25,6 +25,9 @@ struct seq_file {
 	const struct seq_operations *op;
 	int poll_event;
 	const struct file *file;
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	u64 exec_id;
+#endif
 	void *private;
 };
 
@@ -34,6 +37,7 @@ struct seq_operations {
 	void * (*next) (struct seq_file *m, void *v, loff_t *pos);
 	int (*show) (struct seq_file *m, void *v);
 };
+typedef struct seq_operations __no_const seq_operations_no_const;
 
 #define SEQ_SKIP 1
 
@@ -106,6 +110,7 @@ void seq_pad(struct seq_file *m, char c);
 
 char *mangle_path(char *s, const char *p, const char *esc);
 int seq_open(struct file *, const struct seq_operations *);
+int seq_open_restrict(struct file *, const struct seq_operations *);
 ssize_t seq_read(struct file *, char __user *, size_t, loff_t *);
 loff_t seq_lseek(struct file *, loff_t, int);
 int seq_release(struct inode *, struct file *);
@@ -133,6 +138,7 @@ int seq_path_root(struct seq_file *m, const struct path *path,
 		  const struct path *root, const char *esc);
 
 int single_open(struct file *, int (*)(struct seq_file *, void *), void *);
+int single_open_restrict(struct file *, int (*)(struct seq_file *, void *), void *);
 int single_open_size(struct file *, int (*)(struct seq_file *, void *), void *, size_t);
 int single_release(struct inode *, struct file *);
 void *__seq_open_private(struct file *, const struct seq_operations *, int);
diff --git a/include/linux/seqlock.h b/include/linux/seqlock.h
index ead97654c..2379f94b2 100644
--- a/include/linux/seqlock.h
+++ b/include/linux/seqlock.h
@@ -443,42 +443,49 @@ static inline unsigned read_seqretry(const seqlock_t *sl, unsigned start)
  * Acts like a normal spin_lock/unlock.
  * Don't need preempt_disable() because that is in the spin_lock already.
  */
+static inline void write_seqlock(seqlock_t *sl) __acquires(sl);
 static inline void write_seqlock(seqlock_t *sl)
 {
 	spin_lock(&sl->lock);
 	write_seqcount_begin(&sl->seqcount);
 }
 
+static inline void write_sequnlock(seqlock_t *sl) __releases(sl);
 static inline void write_sequnlock(seqlock_t *sl)
 {
 	write_seqcount_end(&sl->seqcount);
 	spin_unlock(&sl->lock);
 }
 
+static inline void write_seqlock_bh(seqlock_t *sl) __acquires(sl);
 static inline void write_seqlock_bh(seqlock_t *sl)
 {
 	spin_lock_bh(&sl->lock);
 	write_seqcount_begin(&sl->seqcount);
 }
 
+static inline void write_sequnlock_bh(seqlock_t *sl) __releases(sl);
 static inline void write_sequnlock_bh(seqlock_t *sl)
 {
 	write_seqcount_end(&sl->seqcount);
 	spin_unlock_bh(&sl->lock);
 }
 
+static inline void write_seqlock_irq(seqlock_t *sl) __acquires(sl);
 static inline void write_seqlock_irq(seqlock_t *sl)
 {
 	spin_lock_irq(&sl->lock);
 	write_seqcount_begin(&sl->seqcount);
 }
 
+static inline void write_sequnlock_irq(seqlock_t *sl) __releases(sl);
 static inline void write_sequnlock_irq(seqlock_t *sl)
 {
 	write_seqcount_end(&sl->seqcount);
 	spin_unlock_irq(&sl->lock);
 }
 
+static inline unsigned long __write_seqlock_irqsave(seqlock_t *sl) __acquires(sl);
 static inline unsigned long __write_seqlock_irqsave(seqlock_t *sl)
 {
 	unsigned long flags;
@@ -491,6 +498,7 @@ static inline unsigned long __write_seqlock_irqsave(seqlock_t *sl)
 #define write_seqlock_irqsave(lock, flags)				\
 	do { flags = __write_seqlock_irqsave(lock); } while (0)
 
+static inline void write_sequnlock_irqrestore(seqlock_t *sl, unsigned long flags) __releases(sl);
 static inline void
 write_sequnlock_irqrestore(seqlock_t *sl, unsigned long flags)
 {
@@ -503,11 +511,13 @@ write_sequnlock_irqrestore(seqlock_t *sl, unsigned long flags)
  * but doesn't update the sequence number. Acts like a normal spin_lock/unlock.
  * Don't need preempt_disable() because that is in the spin_lock already.
  */
+static inline void read_seqlock_excl(seqlock_t *sl) __acquires(sl);
 static inline void read_seqlock_excl(seqlock_t *sl)
 {
 	spin_lock(&sl->lock);
 }
 
+static inline void read_sequnlock_excl(seqlock_t *sl) __releases(sl);
 static inline void read_sequnlock_excl(seqlock_t *sl)
 {
 	spin_unlock(&sl->lock);
diff --git a/include/linux/shm.h b/include/linux/shm.h
index 04e881829..af8580566 100644
--- a/include/linux/shm.h
+++ b/include/linux/shm.h
@@ -22,7 +22,11 @@ struct shmid_kernel /* private to the kernel */
 	/* The task created the shm object.  NULL if the task is dead. */
 	struct task_struct	*shm_creator;
 	struct list_head	shm_clist;	/* list by creator */
-};
+#ifdef CONFIG_GRKERNSEC
+	u64			shm_createtime;
+	pid_t			shm_lapid;
+#endif
+} __randomize_layout;
 
 /* shm_mode upper byte flags */
 #define	SHM_DEST	01000	/* segment will be destroyed on last detach */
diff --git a/include/linux/signal.h b/include/linux/signal.h
index b63f63eaa..fe39718ba 100644
--- a/include/linux/signal.h
+++ b/include/linux/signal.h
@@ -303,7 +303,7 @@ static inline void allow_signal(int sig)
 	 * know it'll be handled, so that they don't get converted to
 	 * SIGKILL or just silently dropped.
 	 */
-	kernel_sigaction(sig, (__force __sighandler_t)2);
+	kernel_sigaction(sig, (__force_user __sighandler_t)2);
 }
 
 static inline void disallow_signal(int sig)
diff --git a/include/linux/skbuff.h b/include/linux/skbuff.h
index 0f665cb26..fa26c213e 100644
--- a/include/linux/skbuff.h
+++ b/include/linux/skbuff.h
@@ -906,7 +906,7 @@ struct sk_buff *__alloc_skb(unsigned int size, gfp_t priority, int flags,
 			    int node);
 struct sk_buff *__build_skb(void *data, unsigned int frag_size);
 struct sk_buff *build_skb(void *data, unsigned int frag_size);
-static inline struct sk_buff *alloc_skb(unsigned int size,
+static inline struct sk_buff * __intentional_overflow(0) alloc_skb(unsigned int size,
 					gfp_t priority)
 {
 	return __alloc_skb(size, priority, 0, NUMA_NO_NODE);
@@ -2215,7 +2215,7 @@ static inline unsigned char *skb_checksum_start(const struct sk_buff *skb)
 	return skb->head + skb->csum_start;
 }
 
-static inline int skb_transport_offset(const struct sk_buff *skb)
+static inline int __intentional_overflow(0) skb_transport_offset(const struct sk_buff *skb)
 {
 	return skb_transport_header(skb) - skb->data;
 }
@@ -2230,7 +2230,7 @@ static inline u32 skb_inner_network_header_len(const struct sk_buff *skb)
 	return skb->inner_transport_header - skb->inner_network_header;
 }
 
-static inline int skb_network_offset(const struct sk_buff *skb)
+static inline int __intentional_overflow(0) skb_network_offset(const struct sk_buff *skb)
 {
 	return skb_network_header(skb) - skb->data;
 }
@@ -2290,7 +2290,7 @@ static inline int pskb_network_may_pull(struct sk_buff *skb, unsigned int len)
  * NET_IP_ALIGN(2) + ethernet_header(14) + IP_header(20/40) + ports(8)
  */
 #ifndef NET_SKB_PAD
-#define NET_SKB_PAD	max(32, L1_CACHE_BYTES)
+#define NET_SKB_PAD	max(_AC(32,UL), L1_CACHE_BYTES)
 #endif
 
 int ___pskb_trim(struct sk_buff *skb, unsigned int len);
@@ -2997,9 +2997,9 @@ struct sk_buff *skb_recv_datagram(struct sock *sk, unsigned flags, int noblock,
 				  int *err);
 unsigned int datagram_poll(struct file *file, struct socket *sock,
 			   struct poll_table_struct *wait);
-int skb_copy_datagram_iter(const struct sk_buff *from, int offset,
+int __intentional_overflow(0) skb_copy_datagram_iter(const struct sk_buff *from, int offset,
 			   struct iov_iter *to, int size);
-static inline int skb_copy_datagram_msg(const struct sk_buff *from, int offset,
+static inline int __intentional_overflow(2,4) skb_copy_datagram_msg(const struct sk_buff *from, int offset,
 					struct msghdr *msg, int size)
 {
 	return skb_copy_datagram_iter(from, offset, &msg->msg_iter, size);
@@ -3536,6 +3536,9 @@ static inline void nf_reset(struct sk_buff *skb)
 	nf_bridge_put(skb->nf_bridge);
 	skb->nf_bridge = NULL;
 #endif
+#if IS_ENABLED(CONFIG_NETFILTER_XT_TARGET_TRACE)
+	skb->nf_trace = 0;
+#endif
 }
 
 static inline void nf_reset_trace(struct sk_buff *skb)
diff --git a/include/linux/slab.h b/include/linux/slab.h
index 4293808d8..9bdcc4e3c 100644
--- a/include/linux/slab.h
+++ b/include/linux/slab.h
@@ -15,14 +15,29 @@
 #include <linux/types.h>
 #include <linux/workqueue.h>
 
+#include <linux/err.h>
 
 /*
  * Flags to pass to kmem_cache_create().
  * The ones marked DEBUG are only valid if CONFIG_DEBUG_SLAB is set.
  */
 #define SLAB_CONSISTENCY_CHECKS	0x00000100UL	/* DEBUG: Perform (expensive) checks on alloc/free */
+
+#ifdef CONFIG_PAX_USERCOPY
+#define SLAB_USERCOPY		0x00000200UL	/* PaX: Allow copying objs to/from userland */
+#else
+#define SLAB_USERCOPY		0x00000000UL
+#endif
+
 #define SLAB_RED_ZONE		0x00000400UL	/* DEBUG: Red zone objs in a cache */
 #define SLAB_POISON		0x00000800UL	/* DEBUG: Poison objects */
+
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+#define SLAB_NO_SANITIZE	0x00001000UL	/* PaX: Do not sanitize objs on free */
+#else
+#define SLAB_NO_SANITIZE	0x00000000UL
+#endif
+
 #define SLAB_HWCACHE_ALIGN	0x00002000UL	/* Align objs on cache lines */
 #define SLAB_CACHE_DMA		0x00004000UL	/* Use GFP_DMA memory */
 #define SLAB_STORE_USER		0x00010000UL	/* DEBUG: Store the last owner for bug hunting */
@@ -109,10 +124,13 @@
  * ZERO_SIZE_PTR can be passed to kfree though in the same way that NULL can.
  * Both make kfree a no-op.
  */
-#define ZERO_SIZE_PTR ((void *)16)
+#define ZERO_SIZE_PTR				\
+({						\
+	BUILD_BUG_ON(!(MAX_ERRNO & ~PAGE_MASK));\
+	(void *)(-MAX_ERRNO-1L);		\
+})
 
-#define ZERO_OR_NULL_PTR(x) ((unsigned long)(x) <= \
-				(unsigned long)ZERO_SIZE_PTR)
+#define ZERO_OR_NULL_PTR(x) ((unsigned long)(x) - 1 >= (unsigned long)ZERO_SIZE_PTR - 1)
 
 #include <linux/kmemleak.h>
 #include <linux/kasan.h>
@@ -127,6 +145,9 @@ bool slab_is_available(void);
 struct kmem_cache *kmem_cache_create(const char *, size_t, size_t,
 			unsigned long,
 			void (*)(void *));
+struct kmem_cache *kmem_cache_create_usercopy(const char *, size_t, size_t,
+			unsigned long, size_t, size_t,
+			void (*)(void *));
 void kmem_cache_destroy(struct kmem_cache *);
 int kmem_cache_shrink(struct kmem_cache *);
 
@@ -146,6 +167,11 @@ void memcg_destroy_kmem_caches(struct mem_cgroup *);
 		sizeof(struct __struct), __alignof__(struct __struct),\
 		(__flags), NULL)
 
+#define KMEM_CACHE_USERCOPY(__struct, __flags, __field) kmem_cache_create_usercopy(#__struct,\
+		sizeof(struct __struct), __alignof__(struct __struct),\
+		(__flags), offsetof(struct __struct, __field),\
+		sizeof(((struct __struct *)0)->__field), NULL)
+
 /*
  * Common kmalloc functions provided by all allocators
  */
@@ -154,18 +180,10 @@ void * __must_check krealloc(const void *, size_t, gfp_t);
 void kfree(const void *);
 void kzfree(const void *);
 size_t ksize(const void *);
+bool is_usercopy_object(const void *ptr);
 
-#ifdef CONFIG_HAVE_HARDENED_USERCOPY_ALLOCATOR
 const char *__check_heap_object(const void *ptr, unsigned long n,
 				struct page *page);
-#else
-static inline const char *__check_heap_object(const void *ptr,
-					      unsigned long n,
-					      struct page *page)
-{
-	return NULL;
-}
-#endif
 
 /*
  * Some archs want to perform DMA into kmalloc caches and need a guaranteed
@@ -276,6 +294,10 @@ extern struct kmem_cache *kmalloc_caches[KMALLOC_SHIFT_HIGH + 1];
 extern struct kmem_cache *kmalloc_dma_caches[KMALLOC_SHIFT_HIGH + 1];
 #endif
 
+#ifdef CONFIG_PAX_USERCOPY
+extern struct kmem_cache *kmalloc_usercopy_caches[KMALLOC_SHIFT_HIGH + 1];
+#endif
+
 /*
  * Figure out which kmalloc slab an allocation of a certain size
  * belongs to.
@@ -284,7 +306,7 @@ extern struct kmem_cache *kmalloc_dma_caches[KMALLOC_SHIFT_HIGH + 1];
  * 2 = 129 .. 192 bytes
  * n = 2^(n-1)+1 .. 2^n
  */
-static __always_inline int kmalloc_index(size_t size)
+static __always_inline __size_overflow(1) int kmalloc_index(size_t size)
 {
 	if (!size)
 		return 0;
@@ -327,7 +349,7 @@ static __always_inline int kmalloc_index(size_t size)
 }
 #endif /* !CONFIG_SLOB */
 
-void *__kmalloc(size_t size, gfp_t flags) __assume_kmalloc_alignment __malloc;
+void *__kmalloc(size_t size, gfp_t flags) __assume_kmalloc_alignment __malloc __alloc_size(1) __size_overflow(1);
 void *kmem_cache_alloc(struct kmem_cache *, gfp_t flags) __assume_slab_alignment __malloc;
 void kmem_cache_free(struct kmem_cache *, void *);
 
@@ -351,10 +373,10 @@ static __always_inline void kfree_bulk(size_t size, void **p)
 }
 
 #ifdef CONFIG_NUMA
-void *__kmalloc_node(size_t size, gfp_t flags, int node) __assume_kmalloc_alignment __malloc;
+void *__kmalloc_node(size_t size, gfp_t flags, int node) __assume_kmalloc_alignment __malloc __alloc_size(1) __size_overflow(1);
 void *kmem_cache_alloc_node(struct kmem_cache *, gfp_t flags, int node) __assume_slab_alignment __malloc;
 #else
-static __always_inline void *__kmalloc_node(size_t size, gfp_t flags, int node)
+static __always_inline void * __alloc_size(1) __size_overflow(1) __kmalloc_node(size_t size, gfp_t flags, int node)
 {
 	return __kmalloc(size, flags);
 }
diff --git a/include/linux/slab_def.h b/include/linux/slab_def.h
index 4ad2c5a26..ebff702ff 100644
--- a/include/linux/slab_def.h
+++ b/include/linux/slab_def.h
@@ -40,7 +40,7 @@ struct kmem_cache {
 /* 4) cache creation/removal */
 	const char *name;
 	struct list_head list;
-	int refcount;
+	atomic_t refcount;
 	int object_size;
 	int align;
 
@@ -56,10 +56,14 @@ struct kmem_cache {
 	unsigned long node_allocs;
 	unsigned long node_frees;
 	unsigned long node_overflow;
-	atomic_t allochit;
-	atomic_t allocmiss;
-	atomic_t freehit;
-	atomic_t freemiss;
+	atomic_unchecked_t allochit;
+	atomic_unchecked_t allocmiss;
+	atomic_unchecked_t freehit;
+	atomic_unchecked_t freemiss;
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	atomic_unchecked_t sanitized;
+	atomic_unchecked_t not_sanitized;
+#endif
 #ifdef CONFIG_DEBUG_SLAB_LEAK
 	atomic_t store_user_clean;
 #endif
@@ -84,6 +88,9 @@ struct kmem_cache {
 	unsigned int *random_seq;
 #endif
 
+	size_t useroffset;	/* USERCOPY region offset */
+	size_t usersize;	/* USERCOPY region size */
+
 	struct kmem_cache_node *node[MAX_NUMNODES];
 };
 
diff --git a/include/linux/slub_def.h b/include/linux/slub_def.h
index 75f56c2ef..97880d2df 100644
--- a/include/linux/slub_def.h
+++ b/include/linux/slub_def.h
@@ -74,7 +74,7 @@ struct kmem_cache {
 	struct kmem_cache_order_objects max;
 	struct kmem_cache_order_objects min;
 	gfp_t allocflags;	/* gfp flags to use on each alloc */
-	int refcount;		/* Refcount for slab cache destroy */
+	atomic_t refcount;	/* Refcount for slab cache destroy */
 	void (*ctor)(void *);
 	int inuse;		/* Offset to metadata */
 	int align;		/* Alignment */
@@ -108,6 +108,9 @@ struct kmem_cache {
 	struct kasan_cache kasan_info;
 #endif
 
+	size_t useroffset;	/* USERCOPY region offset */
+	size_t usersize;	/* USERCOPY region size */
+
 	struct kmem_cache_node *node[MAX_NUMNODES];
 };
 
diff --git a/include/linux/smp.h b/include/linux/smp.h
index eccae4690..58e69b812 100644
--- a/include/linux/smp.h
+++ b/include/linux/smp.h
@@ -183,7 +183,9 @@ static inline void smp_init(void) { }
 #endif
 
 #define get_cpu()		({ preempt_disable(); smp_processor_id(); })
+#define raw_get_cpu()		({ raw_preempt_disable(); raw_smp_processor_id(); })
 #define put_cpu()		preempt_enable()
+#define raw_put_cpu_no_resched()	raw_preempt_enable_no_resched()
 
 /*
  * Callback to arch code if there's nosmp or maxcpus=0 on the
diff --git a/include/linux/sock_diag.h b/include/linux/sock_diag.h
index a0596ca0e..6c9245f32 100644
--- a/include/linux/sock_diag.h
+++ b/include/linux/sock_diag.h
@@ -16,7 +16,7 @@ struct sock_diag_handler {
 	int (*dump)(struct sk_buff *skb, struct nlmsghdr *nlh);
 	int (*get_info)(struct sk_buff *skb, struct sock *sk);
 	int (*destroy)(struct sk_buff *skb, struct nlmsghdr *nlh);
-};
+} __do_const;
 
 int sock_diag_register(const struct sock_diag_handler *h);
 void sock_diag_unregister(const struct sock_diag_handler *h);
diff --git a/include/linux/sonet.h b/include/linux/sonet.h
index 680f9a31d..f13aeb043 100644
--- a/include/linux/sonet.h
+++ b/include/linux/sonet.h
@@ -7,7 +7,7 @@
 #include <uapi/linux/sonet.h>
 
 struct k_sonet_stats {
-#define __HANDLE_ITEM(i) atomic_t i
+#define __HANDLE_ITEM(i) atomic_unchecked_t i
 	__SONET_ITEMS
 #undef __HANDLE_ITEM
 };
diff --git a/include/linux/spinlock.h b/include/linux/spinlock.h
index 47dd0cebd..3275f16a5 100644
--- a/include/linux/spinlock.h
+++ b/include/linux/spinlock.h
@@ -142,14 +142,17 @@ do {								\
  extern int do_raw_spin_trylock(raw_spinlock_t *lock);
  extern void do_raw_spin_unlock(raw_spinlock_t *lock) __releases(lock);
 #else
-static inline void do_raw_spin_lock(raw_spinlock_t *lock) __acquires(lock)
+static inline void do_raw_spin_lock(raw_spinlock_t *lock) __acquires(lock);
+static inline void do_raw_spin_lock(raw_spinlock_t *lock)
 {
 	__acquire(lock);
 	arch_spin_lock(&lock->raw_lock);
 }
 
 static inline void
-do_raw_spin_lock_flags(raw_spinlock_t *lock, unsigned long *flags) __acquires(lock)
+do_raw_spin_lock_flags(raw_spinlock_t *lock, unsigned long *flags) __acquires(lock);
+static inline void
+do_raw_spin_lock_flags(raw_spinlock_t *lock, unsigned long *flags)
 {
 	__acquire(lock);
 	arch_spin_lock_flags(&lock->raw_lock, *flags);
@@ -160,7 +163,8 @@ static inline int do_raw_spin_trylock(raw_spinlock_t *lock)
 	return arch_spin_trylock(&(lock)->raw_lock);
 }
 
-static inline void do_raw_spin_unlock(raw_spinlock_t *lock) __releases(lock)
+static inline void do_raw_spin_unlock(raw_spinlock_t *lock) __releases(lock);
+static inline void do_raw_spin_unlock(raw_spinlock_t *lock)
 {
 	arch_spin_unlock(&lock->raw_lock);
 	__release(lock);
@@ -297,11 +301,13 @@ do {							\
 	raw_spin_lock_init(&(_lock)->rlock);		\
 } while (0)
 
+static __always_inline void spin_lock(spinlock_t *lock) __acquires(lock);
 static __always_inline void spin_lock(spinlock_t *lock)
 {
 	raw_spin_lock(&lock->rlock);
 }
 
+static __always_inline void spin_lock_bh(spinlock_t *lock) __acquires(lock);
 static __always_inline void spin_lock_bh(spinlock_t *lock)
 {
 	raw_spin_lock_bh(&lock->rlock);
@@ -327,6 +333,7 @@ do {									\
 	raw_spin_lock_nest_lock(spinlock_check(lock), nest_lock);	\
 } while (0)
 
+static __always_inline void spin_lock_irq(spinlock_t *lock) __acquires(lock);
 static __always_inline void spin_lock_irq(spinlock_t *lock)
 {
 	raw_spin_lock_irq(&lock->rlock);
@@ -342,21 +349,25 @@ do {									\
 	raw_spin_lock_irqsave_nested(spinlock_check(lock), flags, subclass); \
 } while (0)
 
+static __always_inline void spin_unlock(spinlock_t *lock) __releases(lock);
 static __always_inline void spin_unlock(spinlock_t *lock)
 {
 	raw_spin_unlock(&lock->rlock);
 }
 
+static __always_inline void spin_unlock_bh(spinlock_t *lock) __releases(lock);
 static __always_inline void spin_unlock_bh(spinlock_t *lock)
 {
 	raw_spin_unlock_bh(&lock->rlock);
 }
 
+static __always_inline void spin_unlock_irq(spinlock_t *lock) __releases(lock);
 static __always_inline void spin_unlock_irq(spinlock_t *lock)
 {
 	raw_spin_unlock_irq(&lock->rlock);
 }
 
+static __always_inline void spin_unlock_irqrestore(spinlock_t *lock, unsigned long flags) __releases(lock);
 static __always_inline void spin_unlock_irqrestore(spinlock_t *lock, unsigned long flags)
 {
 	raw_spin_unlock_irqrestore(&lock->rlock, flags);
diff --git a/include/linux/srcu.h b/include/linux/srcu.h
index dc8eb63c6..b4b9482cf 100644
--- a/include/linux/srcu.h
+++ b/include/linux/srcu.h
@@ -228,7 +228,8 @@ static inline int srcu_read_lock_held(struct srcu_struct *sp)
  * srcu_read_unlock() in an irq handler if the matching srcu_read_lock()
  * was invoked in process context.
  */
-static inline int srcu_read_lock(struct srcu_struct *sp) __acquires(sp)
+static inline int srcu_read_lock(struct srcu_struct *sp) __acquires(sp);
+static inline int srcu_read_lock(struct srcu_struct *sp)
 {
 	int retval;
 
@@ -246,8 +247,8 @@ static inline int srcu_read_lock(struct srcu_struct *sp) __acquires(sp)
  *
  * Exit an SRCU read-side critical section.
  */
+static inline void srcu_read_unlock(struct srcu_struct *sp, int idx) __releases(sp);
 static inline void srcu_read_unlock(struct srcu_struct *sp, int idx)
-	__releases(sp)
 {
 	rcu_lock_release(&(sp)->dep_map);
 	__srcu_read_unlock(sp, idx);
diff --git a/include/linux/string.h b/include/linux/string.h
index 26b6f6a66..434ee17cc 100644
--- a/include/linux/string.h
+++ b/include/linux/string.h
@@ -18,51 +18,51 @@ extern void *memdup_user_nul(const void __user *, size_t);
 #include <asm/string.h>
 
 #ifndef __HAVE_ARCH_STRCPY
-extern char * strcpy(char *,const char *);
+extern char * strcpy(char *,const char *) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRNCPY
-extern char * strncpy(char *,const char *, __kernel_size_t);
+extern char * strncpy(char *,const char *, __kernel_size_t) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRLCPY
-size_t strlcpy(char *, const char *, size_t);
+size_t strlcpy(char *, const char *, size_t) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRSCPY
-ssize_t __must_check strscpy(char *, const char *, size_t);
+ssize_t __must_check strscpy(char *, const char *, size_t) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRCAT
-extern char * strcat(char *, const char *);
+extern char * strcat(char *, const char *) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRNCAT
-extern char * strncat(char *, const char *, __kernel_size_t);
+extern char * strncat(char *, const char *, __kernel_size_t) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRLCAT
-extern size_t strlcat(char *, const char *, __kernel_size_t);
+extern size_t strlcat(char *, const char *, __kernel_size_t) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRCMP
-extern int strcmp(const char *,const char *);
+extern int strcmp(const char *,const char *) __nocapture();
 #endif
 #ifndef __HAVE_ARCH_STRNCMP
-extern int strncmp(const char *,const char *,__kernel_size_t);
+extern int strncmp(const char *,const char *,__kernel_size_t) __nocapture(1, 2);
 #endif
 #ifndef __HAVE_ARCH_STRCASECMP
-extern int strcasecmp(const char *s1, const char *s2);
+extern int strcasecmp(const char *s1, const char *s2) __nocapture();
 #endif
 #ifndef __HAVE_ARCH_STRNCASECMP
-extern int strncasecmp(const char *s1, const char *s2, size_t n);
+extern int strncasecmp(const char *s1, const char *s2, size_t n) __nocapture(1, 2);
 #endif
 #ifndef __HAVE_ARCH_STRCHR
-extern char * strchr(const char *,int);
+extern char * strchr(const char *,int) __nocapture(-1);
 #endif
 #ifndef __HAVE_ARCH_STRCHRNUL
-extern char * strchrnul(const char *,int);
+extern char * strchrnul(const char *,int) __nocapture(-1);
 #endif
 #ifndef __HAVE_ARCH_STRNCHR
-extern char * strnchr(const char *, size_t, int);
+extern char * strnchr(const char *, size_t, int) __nocapture(-1);
 #endif
 #ifndef __HAVE_ARCH_STRRCHR
-extern char * strrchr(const char *,int);
+extern char * strrchr(const char *,int) __nocapture(-1);
 #endif
-extern char * __must_check skip_spaces(const char *);
+extern char * __must_check skip_spaces(const char *) __nocapture(-1);
 
 extern char *strim(char *);
 
@@ -72,63 +72,63 @@ static inline __must_check char *strstrip(char *str)
 }
 
 #ifndef __HAVE_ARCH_STRSTR
-extern char * strstr(const char *, const char *);
+extern char * strstr(const char *, const char *) __nocapture(-1, 2);
 #endif
 #ifndef __HAVE_ARCH_STRNSTR
 extern char * strnstr(const char *, const char *, size_t);
 #endif
 #ifndef __HAVE_ARCH_STRLEN
-extern __kernel_size_t strlen(const char *);
+extern __kernel_size_t strlen(const char *) __nocapture(1);
 #endif
 #ifndef __HAVE_ARCH_STRNLEN
-extern __kernel_size_t strnlen(const char *,__kernel_size_t);
+extern __kernel_size_t strnlen(const char *,__kernel_size_t) __nocapture(1);
 #endif
 #ifndef __HAVE_ARCH_STRPBRK
-extern char * strpbrk(const char *,const char *);
+extern char * strpbrk(const char *,const char *) __nocapture(-1, 2);
 #endif
 #ifndef __HAVE_ARCH_STRSEP
-extern char * strsep(char **,const char *);
+extern char * strsep(char **,const char *) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_STRSPN
-extern __kernel_size_t strspn(const char *,const char *);
+extern __kernel_size_t strspn(const char *,const char *) __nocapture();
 #endif
 #ifndef __HAVE_ARCH_STRCSPN
-extern __kernel_size_t strcspn(const char *,const char *);
+extern __kernel_size_t strcspn(const char *,const char *) __nocapture();
 #endif
 
 #ifndef __HAVE_ARCH_MEMSET
 extern void * memset(void *,int,__kernel_size_t);
 #endif
 #ifndef __HAVE_ARCH_MEMCPY
-extern void * memcpy(void *,const void *,__kernel_size_t);
+extern void * memcpy(void *,const void *,__kernel_size_t) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_MEMMOVE
-extern void * memmove(void *,const void *,__kernel_size_t);
+extern void * memmove(void *,const void *,__kernel_size_t) __nocapture(2);
 #endif
 #ifndef __HAVE_ARCH_MEMSCAN
 extern void * memscan(void *,int,__kernel_size_t);
 #endif
 #ifndef __HAVE_ARCH_MEMCMP
-extern int memcmp(const void *,const void *,__kernel_size_t);
+extern int memcmp(const void *,const void *,__kernel_size_t) __nocapture(1, 2);
 #endif
 #ifndef __HAVE_ARCH_MEMCHR
-extern void * memchr(const void *,int,__kernel_size_t);
+extern void * memchr(const void *,int,__kernel_size_t) __nocapture(-1);
 #endif
-void *memchr_inv(const void *s, int c, size_t n);
+void *memchr_inv(const void *s, int c, size_t n) __nocapture(-1);
 char *strreplace(char *s, char old, char new);
 
 extern void kfree_const(const void *x);
 
-extern char *kstrdup(const char *s, gfp_t gfp) __malloc;
-extern const char *kstrdup_const(const char *s, gfp_t gfp);
-extern char *kstrndup(const char *s, size_t len, gfp_t gfp);
-extern void *kmemdup(const void *src, size_t len, gfp_t gfp);
+extern char *kstrdup(const char *s, gfp_t gfp) __malloc __nocapture(1);
+extern const char *kstrdup_const(const char *s, gfp_t gfp) __nocapture(1);
+extern char *kstrndup(const char *s, size_t len, gfp_t gfp) __nocapture(1);
+extern void *kmemdup(const void *src, size_t len, gfp_t gfp) __nocapture(1);
 
 extern char **argv_split(gfp_t gfp, const char *str, int *argcp);
 extern void argv_free(char **argv);
 
-extern bool sysfs_streq(const char *s1, const char *s2);
-extern int kstrtobool(const char *s, bool *res);
+extern bool sysfs_streq(const char *s1, const char *s2) __nocapture();
+extern int kstrtobool(const char *s, bool *res) __nocapture(1);
 static inline int strtobool(const char *s, bool *res)
 {
 	return kstrtobool(s, res);
@@ -137,8 +137,8 @@ static inline int strtobool(const char *s, bool *res)
 int match_string(const char * const *array, size_t n, const char *string);
 
 #ifdef CONFIG_BINARY_PRINTF
-int vbin_printf(u32 *bin_buf, size_t size, const char *fmt, va_list args);
-int bstr_printf(char *buf, size_t size, const char *fmt, const u32 *bin_buf);
+int vbin_printf(u32 *bin_buf, size_t size, const char *fmt, va_list args) __nocapture(3);
+int bstr_printf(char *buf, size_t size, const char *fmt, const u32 *bin_buf) __nocapture(3);
 int bprintf(u32 *bin_buf, size_t size, const char *fmt, ...) __printf(3, 4);
 #endif
 
diff --git a/include/linux/sunrpc/addr.h b/include/linux/sunrpc/addr.h
index 5c9c6cd08..f16c5c90b 100644
--- a/include/linux/sunrpc/addr.h
+++ b/include/linux/sunrpc/addr.h
@@ -23,9 +23,9 @@ static inline unsigned short rpc_get_port(const struct sockaddr *sap)
 {
 	switch (sap->sa_family) {
 	case AF_INET:
-		return ntohs(((struct sockaddr_in *)sap)->sin_port);
+		return ntohs(((const struct sockaddr_in *)sap)->sin_port);
 	case AF_INET6:
-		return ntohs(((struct sockaddr_in6 *)sap)->sin6_port);
+		return ntohs(((const struct sockaddr_in6 *)sap)->sin6_port);
 	}
 	return 0;
 }
@@ -58,7 +58,7 @@ static inline bool rpc_cmp_addr4(const struct sockaddr *sap1,
 static inline bool __rpc_copy_addr4(struct sockaddr *dst,
 				    const struct sockaddr *src)
 {
-	const struct sockaddr_in *ssin = (struct sockaddr_in *) src;
+	const struct sockaddr_in *ssin = (const struct sockaddr_in *) src;
 	struct sockaddr_in *dsin = (struct sockaddr_in *) dst;
 
 	dsin->sin_family = ssin->sin_family;
@@ -177,7 +177,7 @@ static inline u32 rpc_get_scope_id(const struct sockaddr *sa)
 	if (sa->sa_family != AF_INET6)
 		return 0;
 
-	return ((struct sockaddr_in6 *) sa)->sin6_scope_id;
+	return ((const struct sockaddr_in6 *) sa)->sin6_scope_id;
 }
 
 #endif /* _LINUX_SUNRPC_ADDR_H */
diff --git a/include/linux/sunrpc/clnt.h b/include/linux/sunrpc/clnt.h
index 5c02b0691..93e07c56b 100644
--- a/include/linux/sunrpc/clnt.h
+++ b/include/linux/sunrpc/clnt.h
@@ -103,7 +103,7 @@ struct rpc_procinfo {
 	unsigned int		p_timer;	/* Which RTT timer to use */
 	u32			p_statidx;	/* Which procedure to account */
 	const char *		p_name;		/* name of procedure */
-};
+} __do_const;
 
 #ifdef __KERNEL__
 
diff --git a/include/linux/sunrpc/svc.h b/include/linux/sunrpc/svc.h
index 7321ae933..f37a11eb7 100644
--- a/include/linux/sunrpc/svc.h
+++ b/include/linux/sunrpc/svc.h
@@ -426,7 +426,7 @@ struct svc_procedure {
 	unsigned int		pc_count;	/* call count */
 	unsigned int		pc_cachetype;	/* cache info (NFS) */
 	unsigned int		pc_xdrressize;	/* maximum size of XDR reply */
-};
+} __do_const;
 
 /*
  * Mode for mapping cpus to pools.
diff --git a/include/linux/sunrpc/svc_rdma.h b/include/linux/sunrpc/svc_rdma.h
index 3584bc886..0c8ec4c41 100644
--- a/include/linux/sunrpc/svc_rdma.h
+++ b/include/linux/sunrpc/svc_rdma.h
@@ -54,15 +54,15 @@ extern unsigned int svcrdma_max_requests;
 extern unsigned int svcrdma_max_bc_requests;
 extern unsigned int svcrdma_max_req_size;
 
-extern atomic_t rdma_stat_recv;
-extern atomic_t rdma_stat_read;
-extern atomic_t rdma_stat_write;
-extern atomic_t rdma_stat_sq_starve;
-extern atomic_t rdma_stat_rq_starve;
-extern atomic_t rdma_stat_rq_poll;
-extern atomic_t rdma_stat_rq_prod;
-extern atomic_t rdma_stat_sq_poll;
-extern atomic_t rdma_stat_sq_prod;
+extern atomic_unchecked_t rdma_stat_recv;
+extern atomic_unchecked_t rdma_stat_read;
+extern atomic_unchecked_t rdma_stat_write;
+extern atomic_unchecked_t rdma_stat_sq_starve;
+extern atomic_unchecked_t rdma_stat_rq_starve;
+extern atomic_unchecked_t rdma_stat_rq_poll;
+extern atomic_unchecked_t rdma_stat_rq_prod;
+extern atomic_unchecked_t rdma_stat_sq_poll;
+extern atomic_unchecked_t rdma_stat_sq_prod;
 
 /*
  * Contexts are built when an RDMA request is created and are a
diff --git a/include/linux/sunrpc/svcauth.h b/include/linux/sunrpc/svcauth.h
index d03932055..035edad0a 100644
--- a/include/linux/sunrpc/svcauth.h
+++ b/include/linux/sunrpc/svcauth.h
@@ -128,7 +128,7 @@ struct auth_ops {
 	int	(*release)(struct svc_rqst *rq);
 	void	(*domain_release)(struct auth_domain *);
 	int	(*set_client)(struct svc_rqst *rq);
-};
+} __do_const;
 
 #define	SVC_GARBAGE	1
 #define	SVC_SYSERR	2
diff --git a/include/linux/swapops.h b/include/linux/swapops.h
index 5c3a5f3e7..84a8bef09 100644
--- a/include/linux/swapops.h
+++ b/include/linux/swapops.h
@@ -165,7 +165,7 @@ static inline int is_write_migration_entry(swp_entry_t entry)
 
 #ifdef CONFIG_MEMORY_FAILURE
 
-extern atomic_long_t num_poisoned_pages __read_mostly;
+extern atomic_long_unchecked_t num_poisoned_pages __read_mostly;
 
 /*
  * Support for hardware poisoned pages
@@ -188,22 +188,22 @@ static inline bool test_set_page_hwpoison(struct page *page)
 
 static inline void num_poisoned_pages_inc(void)
 {
-	atomic_long_inc(&num_poisoned_pages);
+	atomic_long_inc_unchecked(&num_poisoned_pages);
 }
 
 static inline void num_poisoned_pages_dec(void)
 {
-	atomic_long_dec(&num_poisoned_pages);
+	atomic_long_dec_unchecked(&num_poisoned_pages);
 }
 
 static inline void num_poisoned_pages_add(long num)
 {
-	atomic_long_add(num, &num_poisoned_pages);
+	atomic_long_add_unchecked(num, &num_poisoned_pages);
 }
 
 static inline void num_poisoned_pages_sub(long num)
 {
-	atomic_long_sub(num, &num_poisoned_pages);
+	atomic_long_sub_unchecked(num, &num_poisoned_pages);
 }
 #else
 
diff --git a/include/linux/syscalls.h b/include/linux/syscalls.h
index d02239022..80f9811bd 100644
--- a/include/linux/syscalls.h
+++ b/include/linux/syscalls.h
@@ -102,7 +102,14 @@ union bpf_attr;
 #define __TYPE_IS_L(t)	(__same_type((t)0, 0L))
 #define __TYPE_IS_UL(t)	(__same_type((t)0, 0UL))
 #define __TYPE_IS_LL(t) (__same_type((t)0, 0LL) || __same_type((t)0, 0ULL))
-#define __SC_LONG(t, a) __typeof(__builtin_choose_expr(__TYPE_IS_LL(t), 0LL, 0L)) a
+#define __SC_TYPE(t) __typeof__(				\
+	__builtin_choose_expr(					\
+		sizeof(t) > sizeof(int),			\
+		(t) 0,						\
+		__builtin_choose_expr(__type_is_unsigned(t), 0UL, 0L)	\
+	))
+#define __SC_LONG(t, a)	__SC_TYPE(t) a
+#define __SC_WRAP(t, a)	(__SC_TYPE(t)) a
 #define __SC_CAST(t, a)	(t) a
 #define __SC_ARGS(t, a)	a
 #define __SC_TEST(t, a) (void)BUILD_BUG_ON_ZERO(!__TYPE_IS_LL(t) && sizeof(t) > sizeof(long))
@@ -192,17 +199,18 @@ extern struct trace_event_functions exit_syscall_print_funcs;
 
 #define __PROTECT(...) asmlinkage_protect(__VA_ARGS__)
 #define __SYSCALL_DEFINEx(x, name, ...)					\
-	asmlinkage long sys##name(__MAP(x,__SC_DECL,__VA_ARGS__))	\
-		__attribute__((alias(__stringify(SyS##name))));		\
 	static inline long SYSC##name(__MAP(x,__SC_DECL,__VA_ARGS__));	\
-	asmlinkage long SyS##name(__MAP(x,__SC_LONG,__VA_ARGS__));	\
-	asmlinkage long SyS##name(__MAP(x,__SC_LONG,__VA_ARGS__))	\
+	static inline asmlinkage long SyS##name(__MAP(x,__SC_LONG,__VA_ARGS__))	\
 	{								\
 		long ret = SYSC##name(__MAP(x,__SC_CAST,__VA_ARGS__));	\
 		__MAP(x,__SC_TEST,__VA_ARGS__);				\
 		__PROTECT(x, ret,__MAP(x,__SC_ARGS,__VA_ARGS__));	\
 		return ret;						\
 	}								\
+	asmlinkage long sys##name(__MAP(x,__SC_DECL,__VA_ARGS__))	\
+	{								\
+		return SyS##name(__MAP(x,__SC_WRAP,__VA_ARGS__));	\
+	}								\
 	static inline long SYSC##name(__MAP(x,__SC_DECL,__VA_ARGS__))
 
 asmlinkage long sys32_quotactl(unsigned int cmd, const char __user *special,
@@ -384,11 +392,11 @@ asmlinkage long sys_sync(void);
 asmlinkage long sys_fsync(unsigned int fd);
 asmlinkage long sys_fdatasync(unsigned int fd);
 asmlinkage long sys_bdflush(int func, long data);
-asmlinkage long sys_mount(char __user *dev_name, char __user *dir_name,
-				char __user *type, unsigned long flags,
+asmlinkage long sys_mount(const char __user *dev_name, const char __user *dir_name,
+				const char __user *type, unsigned long flags,
 				void __user *data);
-asmlinkage long sys_umount(char __user *name, int flags);
-asmlinkage long sys_oldumount(char __user *name);
+asmlinkage long sys_umount(const char __user *name, int flags);
+asmlinkage long sys_oldumount(const char __user *name);
 asmlinkage long sys_truncate(const char __user *path, long length);
 asmlinkage long sys_ftruncate(unsigned int fd, unsigned long length);
 asmlinkage long sys_stat(const char __user *filename,
@@ -457,7 +465,7 @@ asmlinkage long sys_remap_file_pages(unsigned long start, unsigned long size,
 			unsigned long prot, unsigned long pgoff,
 			unsigned long flags);
 asmlinkage long sys_msync(unsigned long start, size_t len, int flags);
-asmlinkage long sys_fadvise64(int fd, loff_t offset, size_t len, int advice);
+asmlinkage long sys_fadvise64(int fd, loff_t offset, loff_t len, int advice);
 asmlinkage long sys_fadvise64_64(int fd, loff_t offset, loff_t len, int advice);
 asmlinkage long sys_munmap(unsigned long addr, size_t len);
 asmlinkage long sys_mlock(unsigned long start, size_t len);
@@ -610,7 +618,7 @@ asmlinkage long sys_getsockname(int, struct sockaddr __user *, int __user *);
 asmlinkage long sys_getpeername(int, struct sockaddr __user *, int __user *);
 asmlinkage long sys_send(int, void __user *, size_t, unsigned);
 asmlinkage long sys_sendto(int, void __user *, size_t, unsigned,
-				struct sockaddr __user *, int);
+				struct sockaddr __user *, int) __intentional_overflow(0);
 asmlinkage long sys_sendmsg(int fd, struct user_msghdr __user *msg, unsigned flags);
 asmlinkage long sys_sendmmsg(int fd, struct mmsghdr __user *msg,
 			     unsigned int vlen, unsigned flags);
@@ -669,10 +677,10 @@ asmlinkage long sys_msgctl(int msqid, int cmd, struct msqid_ds __user *buf);
 
 asmlinkage long sys_semget(key_t key, int nsems, int semflg);
 asmlinkage long sys_semop(int semid, struct sembuf __user *sops,
-				unsigned nsops);
+				long nsops);
 asmlinkage long sys_semctl(int semid, int semnum, int cmd, unsigned long arg);
 asmlinkage long sys_semtimedop(int semid, struct sembuf __user *sops,
-				unsigned nsops,
+				long nsops,
 				const struct timespec __user *timeout);
 asmlinkage long sys_shmat(int shmid, char __user *shmaddr, int shmflg);
 asmlinkage long sys_shmget(key_t key, size_t size, int flag);
@@ -706,7 +714,7 @@ asmlinkage long sys_sysfs(int option,
 				unsigned long arg1, unsigned long arg2);
 asmlinkage long sys_syslog(int type, char __user *buf, int len);
 asmlinkage long sys_uselib(const char __user *library);
-asmlinkage long sys_ni_syscall(void);
+asmlinkage long sys_ni_syscall(unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long);
 asmlinkage long sys_ptrace(long request, long pid, unsigned long addr,
 			   unsigned long data);
 
@@ -885,7 +893,7 @@ asmlinkage long sys_seccomp(unsigned int op, unsigned int flags,
 			    const char __user *uargs);
 asmlinkage long sys_getrandom(char __user *buf, size_t count,
 			      unsigned int flags);
-asmlinkage long sys_bpf(int cmd, union bpf_attr *attr, unsigned int size);
+asmlinkage long sys_bpf(int cmd, union bpf_attr __user *attr, unsigned int size);
 
 asmlinkage long sys_execveat(int dfd, const char __user *filename,
 			const char __user *const __user *argv,
diff --git a/include/linux/syscore_ops.h b/include/linux/syscore_ops.h
index 27b3b0bc4..e093dd979 100644
--- a/include/linux/syscore_ops.h
+++ b/include/linux/syscore_ops.h
@@ -16,7 +16,7 @@ struct syscore_ops {
 	int (*suspend)(void);
 	void (*resume)(void);
 	void (*shutdown)(void);
-};
+} __do_const;
 
 extern void register_syscore_ops(struct syscore_ops *ops);
 extern void unregister_syscore_ops(struct syscore_ops *ops);
diff --git a/include/linux/sysctl.h b/include/linux/sysctl.h
index a4f7203a9..dcad65f9b 100644
--- a/include/linux/sysctl.h
+++ b/include/linux/sysctl.h
@@ -40,12 +40,18 @@ typedef int proc_handler (struct ctl_table *ctl, int write,
 
 extern int proc_dostring(struct ctl_table *, int,
 			 void __user *, size_t *, loff_t *);
+extern int proc_dostring_modpriv(struct ctl_table *, int,
+			 void __user *, size_t *, loff_t *);
 extern int proc_dointvec(struct ctl_table *, int,
 			 void __user *, size_t *, loff_t *);
+extern int proc_dointvec_secure(struct ctl_table *, int,
+                     		void __user *, size_t *, loff_t *);
 extern int proc_douintvec(struct ctl_table *, int,
 			 void __user *, size_t *, loff_t *);
 extern int proc_dointvec_minmax(struct ctl_table *, int,
 				void __user *, size_t *, loff_t *);
+extern int proc_dointvec_minmax_secure(struct ctl_table *, int,
+				       void __user *, size_t *, loff_t *);
 extern int proc_dointvec_jiffies(struct ctl_table *, int,
 				 void __user *, size_t *, loff_t *);
 extern int proc_dointvec_userhz_jiffies(struct ctl_table *, int,
@@ -116,7 +122,8 @@ struct ctl_table
 	struct ctl_table_poll *poll;
 	void *extra1;
 	void *extra2;
-};
+} __do_const __randomize_layout;
+typedef struct ctl_table __no_const ctl_table_no_const;
 
 struct ctl_node {
 	struct rb_node node;
diff --git a/include/linux/sysfs.h b/include/linux/sysfs.h
index c6f0f0d0e..e6635671b 100644
--- a/include/linux/sysfs.h
+++ b/include/linux/sysfs.h
@@ -34,7 +34,8 @@ struct attribute {
 	struct lock_class_key	*key;
 	struct lock_class_key	skey;
 #endif
-};
+} __do_const;
+typedef struct attribute __no_const attribute_no_const;
 
 /**
  *	sysfs_attr_init - initialize a dynamically allocated sysfs attribute
@@ -88,7 +89,8 @@ struct attribute_group {
 						  struct bin_attribute *, int);
 	struct attribute	**attrs;
 	struct bin_attribute	**bin_attrs;
-};
+} __do_const;
+typedef struct attribute_group __no_const attribute_group_no_const;
 
 /**
  * Use these macros to make defining attributes easier. See include/linux/device.h
@@ -162,7 +164,8 @@ struct bin_attribute {
 			 char *, loff_t, size_t);
 	int (*mmap)(struct file *, struct kobject *, struct bin_attribute *attr,
 		    struct vm_area_struct *vma);
-};
+} __do_const;
+typedef struct bin_attribute __no_const bin_attribute_no_const;
 
 /**
  *	sysfs_bin_attr_init - initialize a dynamically allocated bin_attribute
@@ -512,7 +515,7 @@ static inline void sysfs_notify_dirent(struct kernfs_node *kn)
 }
 
 static inline struct kernfs_node *sysfs_get_dirent(struct kernfs_node *parent,
-						   const unsigned char *name)
+						   const char *name)
 {
 	return kernfs_find_and_get(parent, name);
 }
diff --git a/include/linux/sysrq.h b/include/linux/sysrq.h
index 387fa7d05..3fcde6b84 100644
--- a/include/linux/sysrq.h
+++ b/include/linux/sysrq.h
@@ -16,6 +16,7 @@
 
 #include <linux/errno.h>
 #include <linux/types.h>
+#include <linux/compiler.h>
 
 /* Possible values of bitmask for enabling sysrq functions */
 /* 0x0001 is reserved for enable everything */
@@ -33,7 +34,7 @@ struct sysrq_key_op {
 	char *help_msg;
 	char *action_msg;
 	int enable_mask;
-};
+} __do_const;
 
 #ifdef CONFIG_MAGIC_SYSRQ
 
diff --git a/include/linux/tcp.h b/include/linux/tcp.h
index 7be9b1242..66bf0a839 100644
--- a/include/linux/tcp.h
+++ b/include/linux/tcp.h
@@ -68,13 +68,13 @@ struct tcp_fastopen_cookie {
 
 /* This defines a selective acknowledgement block. */
 struct tcp_sack_block_wire {
-	__be32	start_seq;
-	__be32	end_seq;
+	__be32	start_seq __intentional_overflow(-1);
+	__be32	end_seq __intentional_overflow(-1);
 };
 
 struct tcp_sack_block {
-	u32	start_seq;
-	u32	end_seq;
+	u32	start_seq __intentional_overflow(-1);
+	u32	end_seq __intentional_overflow(-1);
 };
 
 /*These are used to set the sack_ok field in struct tcp_options_received */
@@ -162,7 +162,7 @@ struct tcp_sock {
 				 * total number of data segments in.
 				 */
  	u32	rcv_nxt;	/* What we want to receive next 	*/
-	u32	copied_seq;	/* Head of yet unread data		*/
+	u32	copied_seq __intentional_overflow(-1);	/* Head of yet unread data		*/
 	u32	rcv_wup;	/* rcv_nxt on last window update sent	*/
  	u32	snd_nxt;	/* Next sequence we send		*/
 	u32	segs_out;	/* RFC4898 tcpEStatsPerfSegsOut
@@ -270,7 +270,7 @@ struct tcp_sock {
 	u32	delivered;	/* Total data packets delivered incl. rexmits */
 
  	u32	rcv_wnd;	/* Current receiver window		*/
-	u32	write_seq;	/* Tail(+1) of data held in tcp send buffer */
+	u32	write_seq __intentional_overflow(-1);	/* Tail(+1) of data held in tcp send buffer */
 	u32	notsent_lowat;	/* TCP_NOTSENT_LOWAT */
 	u32	pushed_seq;	/* Last pushed seq, required to talk to windows */
 	u32	lost_out;	/* Lost packets			*/
@@ -311,7 +311,7 @@ struct tcp_sock {
 	int	undo_retrans;	/* number of undoable retransmissions. */
 	u32	total_retrans;	/* Total retransmits for entire connection */
 
-	u32	urg_seq;	/* Seq of received urgent pointer */
+	u32	urg_seq __intentional_overflow(-1);	/* Seq of received urgent pointer */
 	unsigned int		keepalive_time;	  /* time before keep alive takes place */
 	unsigned int		keepalive_intvl;  /* time interval between keep alive probes */
 
diff --git a/include/linux/thread_info.h b/include/linux/thread_info.h
index 2b5b10eed..37b4c2c88 100644
--- a/include/linux/thread_info.h
+++ b/include/linux/thread_info.h
@@ -50,6 +50,13 @@ struct restart_block {
 
 extern long do_no_restart_syscall(struct restart_block *parm);
 
+enum {
+	BAD_STACK = -1,
+	NOT_STACK = 0,
+	GOOD_STACK,
+	GOOD_FRAME,
+};
+
 #include <linux/bitops.h>
 #include <asm/thread_info.h>
 
@@ -106,11 +113,11 @@ static inline int test_ti_thread_flag(struct thread_info *ti, int flag)
 #define tif_need_resched() test_thread_flag(TIF_NEED_RESCHED)
 
 #ifndef CONFIG_HAVE_ARCH_WITHIN_STACK_FRAMES
-static inline int arch_within_stack_frames(const void * const stack,
-					   const void * const stackend,
-					   const void *obj, unsigned long len)
+static inline int arch_within_stack_frames(unsigned long stack,
+					   unsigned long stackend,
+					   unsigned long obj, unsigned long len)
 {
-	return 0;
+	return GOOD_STACK;
 }
 #endif
 
diff --git a/include/linux/tty.h b/include/linux/tty.h
index 40144f382..610732a17 100644
--- a/include/linux/tty.h
+++ b/include/linux/tty.h
@@ -225,7 +225,7 @@ struct tty_port {
 	const struct tty_port_operations *ops;	/* Port operations */
 	spinlock_t		lock;		/* Lock protecting tty field */
 	int			blocked_open;	/* Waiting to open */
-	int			count;		/* Usage count */
+	atomic_t		count;		/* Usage count */
 	wait_queue_head_t	open_wait;	/* Open waiters */
 	wait_queue_head_t	delta_msr_wait;	/* Modem status change */
 	unsigned long		flags;		/* User TTY flags ASYNC_ */
@@ -326,7 +326,7 @@ struct tty_struct {
 	/* If the tty has a pending do_SAK, queue it here - akpm */
 	struct work_struct SAK_work;
 	struct tty_port *port;
-};
+} __randomize_layout;
 
 /* Each of a tty's open files has private_data pointing to tty_file_private */
 struct tty_file_private {
@@ -646,7 +646,7 @@ extern int tty_port_open(struct tty_port *port,
 				struct tty_struct *tty, struct file *filp);
 static inline int tty_port_users(struct tty_port *port)
 {
-	return port->count + port->blocked_open;
+	return atomic_read(&port->count) + port->blocked_open;
 }
 
 extern int tty_register_ldisc(int disc, struct tty_ldisc_ops *new_ldisc);
diff --git a/include/linux/tty_driver.h b/include/linux/tty_driver.h
index b742b5e47..76dc1fa82 100644
--- a/include/linux/tty_driver.h
+++ b/include/linux/tty_driver.h
@@ -291,7 +291,7 @@ struct tty_operations {
 	void (*poll_put_char)(struct tty_driver *driver, int line, char ch);
 #endif
 	const struct file_operations *proc_fops;
-};
+} __do_const __randomize_layout;
 
 struct tty_driver {
 	int	magic;		/* magic number for this structure */
@@ -325,7 +325,7 @@ struct tty_driver {
 
 	const struct tty_operations *ops;
 	struct list_head tty_drivers;
-};
+} __randomize_layout;
 
 extern struct list_head tty_drivers;
 
diff --git a/include/linux/tty_ldisc.h b/include/linux/tty_ldisc.h
index 3971cf0eb..7704c4834 100644
--- a/include/linux/tty_ldisc.h
+++ b/include/linux/tty_ldisc.h
@@ -202,7 +202,7 @@ struct tty_ldisc_ops {
 
 	struct  module *owner;
 
-	int refcount;
+	atomic_t refcount;
 };
 
 struct tty_ldisc {
diff --git a/include/linux/types.h b/include/linux/types.h
index baf718324..161f20fa0 100644
--- a/include/linux/types.h
+++ b/include/linux/types.h
@@ -159,8 +159,10 @@ typedef unsigned __bitwise__ fmode_t;
 
 #ifdef CONFIG_PHYS_ADDR_T_64BIT
 typedef u64 phys_addr_t;
+#define RESOURCE_SIZE_MAX ULLONG_MAX
 #else
 typedef u32 phys_addr_t;
+#define RESOURCE_SIZE_MAX ULONG_MAX
 #endif
 
 typedef phys_addr_t resource_size_t;
@@ -175,10 +177,26 @@ typedef struct {
 	int counter;
 } atomic_t;
 
+#ifdef CONFIG_PAX_REFCOUNT
+typedef struct {
+	int counter;
+} atomic_unchecked_t;
+#else
+typedef atomic_t atomic_unchecked_t;
+#endif
+
 #ifdef CONFIG_64BIT
 typedef struct {
 	long counter;
 } atomic64_t;
+
+#ifdef CONFIG_PAX_REFCOUNT
+typedef struct {
+	long counter;
+} atomic64_unchecked_t;
+#else
+typedef atomic64_t atomic64_unchecked_t;
+#endif
 #endif
 
 struct list_head {
diff --git a/include/linux/uaccess.h b/include/linux/uaccess.h
index f30c187ed..d2b4ce20f 100644
--- a/include/linux/uaccess.h
+++ b/include/linux/uaccess.h
@@ -109,7 +109,7 @@ extern long strncpy_from_unsafe(char *dst, const void *unsafe_addr, long count);
  * Returns 0 on success, or -EFAULT.
  */
 #define probe_kernel_address(addr, retval)		\
-	probe_kernel_read(&retval, addr, sizeof(retval))
+	probe_kernel_read(&(retval), addr, sizeof(retval))
 
 #ifndef user_access_begin
 #define user_access_begin() do { } while (0)
diff --git a/include/linux/uidgid.h b/include/linux/uidgid.h
index 25e9d9216..1b34fffb9 100644
--- a/include/linux/uidgid.h
+++ b/include/linux/uidgid.h
@@ -187,4 +187,10 @@ static inline bool kgid_has_mapping(struct user_namespace *ns, kgid_t gid)
 
 #endif /* CONFIG_USER_NS */
 
+#define GR_GLOBAL_UID(x) from_kuid_munged(&init_user_ns, (x))
+#define GR_GLOBAL_GID(x) from_kgid_munged(&init_user_ns, (x))
+#define gr_is_global_root(x) uid_eq((x), GLOBAL_ROOT_UID)
+#define gr_is_global_nonroot(x) (!uid_eq((x), GLOBAL_ROOT_UID))
+#define gr_is_global_nonroot_gid(x) (!gid_eq((x), GLOBAL_ROOT_GID))
+
 #endif /* _LINUX_UIDGID_H */
diff --git a/include/linux/uio_driver.h b/include/linux/uio_driver.h
index 32c0e83d6..671eb3518 100644
--- a/include/linux/uio_driver.h
+++ b/include/linux/uio_driver.h
@@ -67,7 +67,7 @@ struct uio_device {
         struct module           *owner;
         struct device           *dev;
         int                     minor;
-        atomic_t                event;
+        atomic_unchecked_t      event;
         struct fasync_struct    *async_queue;
         wait_queue_head_t       wait;
         struct uio_info         *info;
diff --git a/include/linux/unaligned/access_ok.h b/include/linux/unaligned/access_ok.h
index 33383ca23..44211d60f 100644
--- a/include/linux/unaligned/access_ok.h
+++ b/include/linux/unaligned/access_ok.h
@@ -4,34 +4,34 @@
 #include <linux/kernel.h>
 #include <asm/byteorder.h>
 
-static __always_inline u16 get_unaligned_le16(const void *p)
+static __always_inline u16 __intentional_overflow(-1) get_unaligned_le16(const void *p)
 {
-	return le16_to_cpup((__le16 *)p);
+	return le16_to_cpup((const __le16 *)p);
 }
 
-static __always_inline u32 get_unaligned_le32(const void *p)
+static __always_inline u32 __intentional_overflow(-1) get_unaligned_le32(const void *p)
 {
-	return le32_to_cpup((__le32 *)p);
+	return le32_to_cpup((const __le32 *)p);
 }
 
-static __always_inline u64 get_unaligned_le64(const void *p)
+static __always_inline u64 __intentional_overflow(-1) get_unaligned_le64(const void *p)
 {
-	return le64_to_cpup((__le64 *)p);
+	return le64_to_cpup((const __le64 *)p);
 }
 
-static __always_inline u16 get_unaligned_be16(const void *p)
+static __always_inline u16 __intentional_overflow(-1) get_unaligned_be16(const void *p)
 {
-	return be16_to_cpup((__be16 *)p);
+	return be16_to_cpup((const __be16 *)p);
 }
 
-static __always_inline u32 get_unaligned_be32(const void *p)
+static __always_inline u32 __intentional_overflow(-1) get_unaligned_be32(const void *p)
 {
-	return be32_to_cpup((__be32 *)p);
+	return be32_to_cpup((const __be32 *)p);
 }
 
-static __always_inline u64 get_unaligned_be64(const void *p)
+static __always_inline u64 __intentional_overflow(-1) get_unaligned_be64(const void *p)
 {
-	return be64_to_cpup((__be64 *)p);
+	return be64_to_cpup((const __be64 *)p);
 }
 
 static __always_inline void put_unaligned_le16(u16 val, void *p)
diff --git a/include/linux/usb/hcd.h b/include/linux/usb/hcd.h
index 66fc13705..9602956bb 100644
--- a/include/linux/usb/hcd.h
+++ b/include/linux/usb/hcd.h
@@ -24,6 +24,7 @@
 #include <linux/rwsem.h>
 #include <linux/interrupt.h>
 #include <linux/idr.h>
+#include <scsi/scsi_host.h>
 
 #define MAX_TOPO_LEVEL		6
 
diff --git a/include/linux/usb/renesas_usbhs.h b/include/linux/usb/renesas_usbhs.h
index 00a47d058..ed482765f 100644
--- a/include/linux/usb/renesas_usbhs.h
+++ b/include/linux/usb/renesas_usbhs.h
@@ -39,7 +39,7 @@ enum {
  */
 struct renesas_usbhs_driver_callback {
 	int (*notify_hotplug)(struct platform_device *pdev);
-};
+} __no_const;
 
 /*
  * callback functions for platform
diff --git a/include/linux/usb.h b/include/linux/usb.h
index eba1f10e8..94c966fa1 100644
--- a/include/linux/usb.h
+++ b/include/linux/usb.h
@@ -370,7 +370,7 @@ struct usb_bus {
 					 * with the URB_SHORT_NOT_OK flag set.
 					 */
 	unsigned no_sg_constraint:1;	/* no sg constraint */
-	unsigned sg_tablesize;		/* 0 or largest number of sg list entries */
+	unsigned short sg_tablesize;	/* 0 or largest number of sg list entries */
 
 	int devnum_next;		/* Next open device number in
 					 * round-robin allocation */
@@ -599,7 +599,7 @@ struct usb_device {
 	int maxchild;
 
 	u32 quirks;
-	atomic_t urbnum;
+	atomic_unchecked_t urbnum;
 
 	unsigned long active_duration;
 
@@ -1793,10 +1793,10 @@ void usb_sg_wait(struct usb_sg_request *io);
 
 /* NOTE:  these are not the standard USB_ENDPOINT_XFER_* values!! */
 /* (yet ... they're the values used by usbfs) */
-#define PIPE_ISOCHRONOUS		0
-#define PIPE_INTERRUPT			1
-#define PIPE_CONTROL			2
-#define PIPE_BULK			3
+#define PIPE_ISOCHRONOUS		0U
+#define PIPE_INTERRUPT			1U
+#define PIPE_CONTROL			2U
+#define PIPE_BULK			3U
 
 #define usb_pipein(pipe)	((pipe) & USB_DIR_IN)
 #define usb_pipeout(pipe)	(!usb_pipein(pipe))
diff --git a/include/linux/user_namespace.h b/include/linux/user_namespace.h
index 9217169c6..61e5eebb2 100644
--- a/include/linux/user_namespace.h
+++ b/include/linux/user_namespace.h
@@ -39,7 +39,7 @@ struct user_namespace {
 	struct key		*persistent_keyring_register;
 	struct rw_semaphore	persistent_keyring_register_sem;
 #endif
-};
+} __randomize_layout;
 
 extern struct user_namespace init_user_ns;
 
diff --git a/include/linux/utsname.h b/include/linux/utsname.h
index 5093f58ae..c103e58bc 100644
--- a/include/linux/utsname.h
+++ b/include/linux/utsname.h
@@ -25,7 +25,7 @@ struct uts_namespace {
 	struct new_utsname name;
 	struct user_namespace *user_ns;
 	struct ns_common ns;
-};
+} __randomize_layout;
 extern struct uts_namespace init_uts_ns;
 
 #ifdef CONFIG_UTS_NS
diff --git a/include/linux/vermagic.h b/include/linux/vermagic.h
index 6f8fbcf10..4efc177ca 100644
--- a/include/linux/vermagic.h
+++ b/include/linux/vermagic.h
@@ -25,9 +25,42 @@
 #define MODULE_ARCH_VERMAGIC ""
 #endif
 
+#ifdef CONFIG_PAX_REFCOUNT
+#define MODULE_PAX_REFCOUNT "REFCOUNT "
+#else
+#define MODULE_PAX_REFCOUNT ""
+#endif
+
+#ifdef CONSTIFY_PLUGIN
+#define MODULE_CONSTIFY_PLUGIN "CONSTIFY_PLUGIN "
+#else
+#define MODULE_CONSTIFY_PLUGIN ""
+#endif
+
+#ifdef STACKLEAK_PLUGIN
+#define MODULE_STACKLEAK_PLUGIN "STACKLEAK_PLUGIN "
+#else
+#define MODULE_STACKLEAK_PLUGIN ""
+#endif
+
+#ifdef RANDSTRUCT_PLUGIN
+#include <generated/randomize_layout_hash.h>
+#define MODULE_RANDSTRUCT_PLUGIN "RANDSTRUCT_PLUGIN_" RANDSTRUCT_HASHED_SEED
+#else
+#define MODULE_RANDSTRUCT_PLUGIN
+#endif
+
+#ifdef CONFIG_GRKERNSEC
+#define MODULE_GRSEC "GRSEC "
+#else
+#define MODULE_GRSEC ""
+#endif
+
 #define VERMAGIC_STRING 						\
 	UTS_RELEASE " "							\
 	MODULE_VERMAGIC_SMP MODULE_VERMAGIC_PREEMPT 			\
 	MODULE_VERMAGIC_MODULE_UNLOAD MODULE_VERMAGIC_MODVERSIONS	\
-	MODULE_ARCH_VERMAGIC
+	MODULE_ARCH_VERMAGIC						\
+	MODULE_PAX_REFCOUNT MODULE_CONSTIFY_PLUGIN MODULE_STACKLEAK_PLUGIN \
+	MODULE_GRSEC MODULE_RANDSTRUCT_PLUGIN
 
diff --git a/include/linux/vga_switcheroo.h b/include/linux/vga_switcheroo.h
index 960bedbde..161604386 100644
--- a/include/linux/vga_switcheroo.h
+++ b/include/linux/vga_switcheroo.h
@@ -170,9 +170,9 @@ enum vga_switcheroo_state vga_switcheroo_get_client_state(struct pci_dev *dev);
 
 void vga_switcheroo_set_dynamic_switch(struct pci_dev *pdev, enum vga_switcheroo_state dynamic);
 
-int vga_switcheroo_init_domain_pm_ops(struct device *dev, struct dev_pm_domain *domain);
+int vga_switcheroo_init_domain_pm_ops(struct device *dev, dev_pm_domain_no_const *domain);
 void vga_switcheroo_fini_domain_pm_ops(struct device *dev);
-int vga_switcheroo_init_domain_pm_optimus_hdmi_audio(struct device *dev, struct dev_pm_domain *domain);
+int vga_switcheroo_init_domain_pm_optimus_hdmi_audio(struct device *dev, dev_pm_domain_no_const *domain);
 #else
 
 static inline void vga_switcheroo_unregister_client(struct pci_dev *dev) {}
@@ -194,9 +194,9 @@ static inline enum vga_switcheroo_state vga_switcheroo_get_client_state(struct p
 
 static inline void vga_switcheroo_set_dynamic_switch(struct pci_dev *pdev, enum vga_switcheroo_state dynamic) {}
 
-static inline int vga_switcheroo_init_domain_pm_ops(struct device *dev, struct dev_pm_domain *domain) { return -EINVAL; }
+static inline int vga_switcheroo_init_domain_pm_ops(struct device *dev, dev_pm_domain_no_const *domain) { return -EINVAL; }
 static inline void vga_switcheroo_fini_domain_pm_ops(struct device *dev) {}
-static inline int vga_switcheroo_init_domain_pm_optimus_hdmi_audio(struct device *dev, struct dev_pm_domain *domain) { return -EINVAL; }
+static inline int vga_switcheroo_init_domain_pm_optimus_hdmi_audio(struct device *dev, dev_pm_domain_no_const *domain) { return -EINVAL; }
 
 #endif
 #endif /* _LINUX_VGA_SWITCHEROO_H_ */
diff --git a/include/linux/vmalloc.h b/include/linux/vmalloc.h
index 3d9d786a9..b7e5717d7 100644
--- a/include/linux/vmalloc.h
+++ b/include/linux/vmalloc.h
@@ -19,6 +19,14 @@ struct notifier_block;		/* in notifier.h */
 #define VM_UNINITIALIZED	0x00000020	/* vm_struct is not fully initialized */
 #define VM_NO_GUARD		0x00000040      /* don't add guard page */
 #define VM_KASAN		0x00000080      /* has allocated kasan shadow memory */
+
+#if defined(CONFIG_X86) && defined(CONFIG_PAX_KERNEXEC)
+#define VM_KERNEXEC		0x00000100	/* allocate from executable kernel memory range */
+#endif
+
+#define VM_USERCOPY		0x00000200	/* allocation intended for copies to userland */
+
+
 /* bits [20..32] reserved for arch specific ioremap internals */
 
 /*
@@ -67,7 +75,11 @@ static inline void vmalloc_init(void)
 }
 #endif
 
+#if defined(CONFIG_GRKERNSEC_KSTACKOVERFLOW) && defined(CONFIG_X86_64)
+extern void *vzalloc_irq_stack(void);
+#endif
 extern void *vmalloc(unsigned long size);
+extern void *vmalloc_usercopy(unsigned long size);
 extern void *vzalloc(unsigned long size);
 extern void *vmalloc_user(unsigned long size);
 extern void *vmalloc_node(unsigned long size, int node);
@@ -87,6 +99,10 @@ extern void *vmap(struct page **pages, unsigned int count,
 			unsigned long flags, pgprot_t prot);
 extern void vunmap(const void *addr);
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+extern void unmap_process_stacks(struct task_struct *task);
+#endif
+
 extern int remap_vmalloc_range_partial(struct vm_area_struct *vma,
 				       unsigned long uaddr, void *kaddr,
 				       unsigned long size);
@@ -151,7 +167,7 @@ extern void free_vm_area(struct vm_struct *area);
 
 /* for /dev/kmem */
 extern long vread(char *buf, char *addr, unsigned long count);
-extern long vwrite(char *buf, char *addr, unsigned long count);
+extern long vwrite(char *buf, char *addr, unsigned long count) __size_overflow(3);
 
 /*
  *	Internals.  Dont't use..
diff --git a/include/linux/vmstat.h b/include/linux/vmstat.h
index 613771909..f925b2f58 100644
--- a/include/linux/vmstat.h
+++ b/include/linux/vmstat.h
@@ -107,26 +107,26 @@ static inline void vm_events_fold_cpu(int cpu)
 /*
  * Zone and node-based page accounting with per cpu differentials.
  */
-extern atomic_long_t vm_zone_stat[NR_VM_ZONE_STAT_ITEMS];
-extern atomic_long_t vm_node_stat[NR_VM_NODE_STAT_ITEMS];
+extern atomic_long_unchecked_t vm_zone_stat[NR_VM_ZONE_STAT_ITEMS];
+extern atomic_long_unchecked_t vm_node_stat[NR_VM_NODE_STAT_ITEMS];
 
 static inline void zone_page_state_add(long x, struct zone *zone,
 				 enum zone_stat_item item)
 {
-	atomic_long_add(x, &zone->vm_stat[item]);
-	atomic_long_add(x, &vm_zone_stat[item]);
+	atomic_long_add_unchecked(x, &zone->vm_stat[item]);
+	atomic_long_add_unchecked(x, &vm_zone_stat[item]);
 }
 
 static inline void node_page_state_add(long x, struct pglist_data *pgdat,
 				 enum node_stat_item item)
 {
-	atomic_long_add(x, &pgdat->vm_stat[item]);
-	atomic_long_add(x, &vm_node_stat[item]);
+	atomic_long_add_unchecked(x, &pgdat->vm_stat[item]);
+	atomic_long_add_unchecked(x, &vm_node_stat[item]);
 }
 
 static inline unsigned long global_page_state(enum zone_stat_item item)
 {
-	long x = atomic_long_read(&vm_zone_stat[item]);
+	long x = atomic_long_read_unchecked(&vm_zone_stat[item]);
 #ifdef CONFIG_SMP
 	if (x < 0)
 		x = 0;
@@ -136,7 +136,7 @@ static inline unsigned long global_page_state(enum zone_stat_item item)
 
 static inline unsigned long global_node_page_state(enum node_stat_item item)
 {
-	long x = atomic_long_read(&vm_node_stat[item]);
+	long x = atomic_long_read_unchecked(&vm_node_stat[item]);
 #ifdef CONFIG_SMP
 	if (x < 0)
 		x = 0;
@@ -144,10 +144,10 @@ static inline unsigned long global_node_page_state(enum node_stat_item item)
 	return x;
 }
 
-static inline unsigned long zone_page_state(struct zone *zone,
+static inline unsigned long __intentional_overflow(-1) zone_page_state(struct zone *zone,
 					enum zone_stat_item item)
 {
-	long x = atomic_long_read(&zone->vm_stat[item]);
+	long x = atomic_long_read_unchecked(&zone->vm_stat[item]);
 #ifdef CONFIG_SMP
 	if (x < 0)
 		x = 0;
@@ -164,7 +164,7 @@ static inline unsigned long zone_page_state(struct zone *zone,
 static inline unsigned long zone_page_state_snapshot(struct zone *zone,
 					enum zone_stat_item item)
 {
-	long x = atomic_long_read(&zone->vm_stat[item]);
+	long x = atomic_long_read_unchecked(&zone->vm_stat[item]);
 
 #ifdef CONFIG_SMP
 	int cpu;
@@ -180,7 +180,7 @@ static inline unsigned long zone_page_state_snapshot(struct zone *zone,
 static inline unsigned long node_page_state_snapshot(pg_data_t *pgdat,
 					enum node_stat_item item)
 {
-	long x = atomic_long_read(&pgdat->vm_stat[item]);
+	long x = atomic_long_read_unchecked(&pgdat->vm_stat[item]);
 
 #ifdef CONFIG_SMP
 	int cpu;
@@ -267,26 +267,26 @@ static inline void __mod_node_page_state(struct pglist_data *pgdat,
 
 static inline void __inc_zone_state(struct zone *zone, enum zone_stat_item item)
 {
-	atomic_long_inc(&zone->vm_stat[item]);
-	atomic_long_inc(&vm_zone_stat[item]);
+	atomic_long_inc_unchecked(&zone->vm_stat[item]);
+	atomic_long_inc_unchecked(&vm_zone_stat[item]);
 }
 
 static inline void __inc_node_state(struct pglist_data *pgdat, enum node_stat_item item)
 {
-	atomic_long_inc(&pgdat->vm_stat[item]);
-	atomic_long_inc(&vm_node_stat[item]);
+	atomic_long_inc_unchecked(&pgdat->vm_stat[item]);
+	atomic_long_inc_unchecked(&vm_node_stat[item]);
 }
 
 static inline void __dec_zone_state(struct zone *zone, enum zone_stat_item item)
 {
-	atomic_long_dec(&zone->vm_stat[item]);
-	atomic_long_dec(&vm_zone_stat[item]);
+	atomic_long_dec_unchecked(&zone->vm_stat[item]);
+	atomic_long_dec_unchecked(&vm_zone_stat[item]);
 }
 
 static inline void __dec_node_state(struct pglist_data *pgdat, enum node_stat_item item)
 {
-	atomic_long_dec(&pgdat->vm_stat[item]);
-	atomic_long_dec(&vm_node_stat[item]);
+	atomic_long_dec_unchecked(&pgdat->vm_stat[item]);
+	atomic_long_dec_unchecked(&vm_node_stat[item]);
 }
 
 static inline void __inc_zone_page_state(struct page *page,
diff --git a/include/linux/writeback.h b/include/linux/writeback.h
index fc1e16c25..73b1d3688 100644
--- a/include/linux/writeback.h
+++ b/include/linux/writeback.h
@@ -278,8 +278,9 @@ static inline void inode_detach_wb(struct inode *inode)
 }
 
 static inline void wbc_attach_and_unlock_inode(struct writeback_control *wbc,
+					       struct inode *inode) __releases(&inode->i_lock);
+static inline void wbc_attach_and_unlock_inode(struct writeback_control *wbc,
 					       struct inode *inode)
-	__releases(&inode->i_lock)
 {
 	spin_unlock(&inode->i_lock);
 }
diff --git a/include/linux/xattr.h b/include/linux/xattr.h
index 94079bab9..ae4c218d7 100644
--- a/include/linux/xattr.h
+++ b/include/linux/xattr.h
@@ -35,7 +35,7 @@ struct xattr_handler {
 	int (*set)(const struct xattr_handler *, struct dentry *dentry,
 		   struct inode *inode, const char *name, const void *buffer,
 		   size_t size, int flags);
-};
+} __do_const;
 
 const char *xattr_full_name(const struct xattr_handler *, const char *);
 
@@ -46,6 +46,9 @@ struct xattr {
 };
 
 ssize_t xattr_getsecurity(struct inode *, const char *, void *, size_t);
+#ifdef CONFIG_PAX_XATTR_PAX_FLAGS
+ssize_t pax_getxattr(struct dentry *, void *, size_t);
+#endif
 ssize_t vfs_getxattr(struct dentry *, const char *, void *, size_t);
 ssize_t vfs_listxattr(struct dentry *d, char *list, size_t size);
 int __vfs_setxattr_noperm(struct dentry *, const char *, const void *, size_t, int);
diff --git a/include/linux/zlib.h b/include/linux/zlib.h
index 92dbbd3f6..13ab0b389 100644
--- a/include/linux/zlib.h
+++ b/include/linux/zlib.h
@@ -31,6 +31,7 @@
 #define _ZLIB_H
 
 #include <linux/zconf.h>
+#include <linux/compiler.h>
 
 /* zlib deflate based on ZLIB_VERSION "1.1.3" */
 /* zlib inflate based on ZLIB_VERSION "1.2.3" */
@@ -179,7 +180,7 @@ typedef z_stream *z_streamp;
 
                         /* basic functions */
 
-extern int zlib_deflate_workspacesize (int windowBits, int memLevel);
+extern int zlib_deflate_workspacesize (int windowBits, int memLevel) __intentional_overflow(0);
 /*
    Returns the number of bytes that needs to be allocated for a per-
    stream workspace with the specified parameters.  A pointer to this
diff --git a/include/media/v4l2-dev.h b/include/media/v4l2-dev.h
index a122b1bd4..bcb7940b9 100644
--- a/include/media/v4l2-dev.h
+++ b/include/media/v4l2-dev.h
@@ -160,7 +160,7 @@ struct v4l2_file_operations {
 	int (*mmap) (struct file *, struct vm_area_struct *);
 	int (*open) (struct file *);
 	int (*release) (struct file *);
-};
+} __do_const;
 
 /*
  * Newer version of video_device, handled by videodev2.c
diff --git a/include/media/v4l2-device.h b/include/media/v4l2-device.h
index a9d6aa417..124a82235 100644
--- a/include/media/v4l2-device.h
+++ b/include/media/v4l2-device.h
@@ -139,7 +139,7 @@ int __must_check v4l2_device_register(struct device *dev,
  * then the name will be set to cx18-0 since cx180 would look really odd.
  */
 int v4l2_device_set_name(struct v4l2_device *v4l2_dev, const char *basename,
-			 atomic_t *instance);
+			 atomic_unchecked_t *instance);
 
 /**
  * v4l2_device_disconnect - Change V4L2 device state to disconnected.
diff --git a/include/net/9p/transport.h b/include/net/9p/transport.h
index 5122b5e40..598b440cf 100644
--- a/include/net/9p/transport.h
+++ b/include/net/9p/transport.h
@@ -62,7 +62,7 @@ struct p9_trans_module {
 	int (*cancelled)(struct p9_client *, struct p9_req_t *req);
 	int (*zc_request)(struct p9_client *, struct p9_req_t *,
 			  struct iov_iter *, struct iov_iter *, int , int, int);
-};
+} __do_const;
 
 void v9fs_register_trans(struct p9_trans_module *m);
 void v9fs_unregister_trans(struct p9_trans_module *m);
diff --git a/include/net/af_unix.h b/include/net/af_unix.h
index fd60eccb5..64e2a1e24 100644
--- a/include/net/af_unix.h
+++ b/include/net/af_unix.h
@@ -36,7 +36,7 @@ struct unix_skb_parms {
 	u32			secid;		/* Security ID		*/
 #endif
 	u32			consumed;
-};
+} __randomize_layout;
 
 #define UNIXCB(skb) 	(*(struct unix_skb_parms *)&((skb)->cb))
 
diff --git a/include/net/bluetooth/l2cap.h b/include/net/bluetooth/l2cap.h
index 5ee3c689c..54f883a3a 100644
--- a/include/net/bluetooth/l2cap.h
+++ b/include/net/bluetooth/l2cap.h
@@ -619,7 +619,7 @@ struct l2cap_ops {
 	struct sk_buff		*(*alloc_skb) (struct l2cap_chan *chan,
 					       unsigned long hdr_len,
 					       unsigned long len, int nb);
-};
+} __do_const;
 
 struct l2cap_conn {
 	struct hci_conn		*hcon;
diff --git a/include/net/bonding.h b/include/net/bonding.h
index 6360c259d..6eb51ef30 100644
--- a/include/net/bonding.h
+++ b/include/net/bonding.h
@@ -707,7 +707,7 @@ extern struct rtnl_link_ops bond_link_ops;
 
 static inline void bond_tx_drop(struct net_device *dev, struct sk_buff *skb)
 {
-	atomic_long_inc(&dev->tx_dropped);
+	atomic_long_inc_unchecked(&dev->tx_dropped);
 	dev_kfree_skb_any(skb);
 }
 
diff --git a/include/net/caif/cfctrl.h b/include/net/caif/cfctrl.h
index f2ae33d23..c457cf08b 100644
--- a/include/net/caif/cfctrl.h
+++ b/include/net/caif/cfctrl.h
@@ -52,7 +52,7 @@ struct cfctrl_rsp {
 	void (*radioset_rsp)(void);
 	void (*reject_rsp)(struct cflayer *layer, u8 linkid,
 				struct cflayer *client_layer);
-};
+} __no_const;
 
 /* Link Setup Parameters for CAIF-Links. */
 struct cfctrl_link_param {
@@ -101,8 +101,8 @@ struct cfctrl_request_info {
 struct cfctrl {
 	struct cfsrvl serv;
 	struct cfctrl_rsp res;
-	atomic_t req_seq_no;
-	atomic_t rsp_seq_no;
+	atomic_unchecked_t req_seq_no;
+	atomic_unchecked_t rsp_seq_no;
 	struct list_head list;
 	/* Protects from simultaneous access to first_req list */
 	spinlock_t info_list_lock;
diff --git a/include/net/cfg80211-wext.h b/include/net/cfg80211-wext.h
index 25baddc4f..f9a13749a 100644
--- a/include/net/cfg80211-wext.h
+++ b/include/net/cfg80211-wext.h
@@ -22,34 +22,34 @@
  */
 int cfg80211_wext_giwname(struct net_device *dev,
 			  struct iw_request_info *info,
-			  char *name, char *extra);
+			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_siwmode(struct net_device *dev, struct iw_request_info *info,
-			  u32 *mode, char *extra);
+			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_giwmode(struct net_device *dev, struct iw_request_info *info,
-			  u32 *mode, char *extra);
+			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_siwscan(struct net_device *dev,
 			  struct iw_request_info *info,
 			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_giwscan(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *data, char *extra);
+			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_giwrange(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *data, char *extra);
+			   union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_siwrts(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *rts, char *extra);
+			 union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_giwrts(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *rts, char *extra);
+			 union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_siwfrag(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *frag, char *extra);
+			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_giwfrag(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *frag, char *extra);
+			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_giwretry(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_param *retry, char *extra);
+			   union iwreq_data *wrqu, char *extra);
 
 #endif /* __NET_CFG80211_WEXT_H */
diff --git a/include/net/cfg802154.h b/include/net/cfg802154.h
index 795ca4008..97964b20c 100644
--- a/include/net/cfg802154.h
+++ b/include/net/cfg802154.h
@@ -354,7 +354,7 @@ struct wpan_dev {
 	/* MAC BSN field */
 	atomic_t bsn;
 	/* MAC DSN field */
-	atomic_t dsn;
+	atomic_unchecked_t dsn;
 
 	u8 min_be;
 	u8 max_be;
diff --git a/include/net/fib_rules.h b/include/net/fib_rules.h
index 456e4a600..32ce9c450 100644
--- a/include/net/fib_rules.h
+++ b/include/net/fib_rules.h
@@ -33,8 +33,12 @@ struct fib_rule {
 	struct rcu_head		rcu;
 };
 
+typedef struct rt6_info *(*pol_lookup_t)(struct net *,
+					 struct fib6_table *,
+					 struct flowi6 *, int);
+
 struct fib_lookup_arg {
-	void			*lookup_ptr;
+	pol_lookup_t		lookup_ptr;
 	void			*result;
 	struct fib_rule		*rule;
 	u32			table;
diff --git a/include/net/flow.h b/include/net/flow.h
index d47ef4bb5..ab39dc57b 100644
--- a/include/net/flow.h
+++ b/include/net/flow.h
@@ -243,7 +243,7 @@ void flow_cache_fini(struct net *net);
 
 void flow_cache_flush(struct net *net);
 void flow_cache_flush_deferred(struct net *net);
-extern atomic_t flow_cache_genid;
+extern atomic_unchecked_t flow_cache_genid;
 
 __u32 __get_hash_from_flowi6(const struct flowi6 *fl6, struct flow_keys *keys);
 
diff --git a/include/net/genetlink.h b/include/net/genetlink.h
index 8d4608ce8..460372d2e 100644
--- a/include/net/genetlink.h
+++ b/include/net/genetlink.h
@@ -128,7 +128,7 @@ struct genl_ops {
 	u8			cmd;
 	u8			internal_flags;
 	u8			flags;
-};
+} __do_const;
 
 int __genl_register_family(struct genl_family *family);
 
diff --git a/include/net/gro_cells.h b/include/net/gro_cells.h
index 2a1abbf8d..93305b8fd 100644
--- a/include/net/gro_cells.h
+++ b/include/net/gro_cells.h
@@ -25,7 +25,7 @@ static inline int gro_cells_receive(struct gro_cells *gcells, struct sk_buff *sk
 	cell = this_cpu_ptr(gcells->cells);
 
 	if (skb_queue_len(&cell->napi_skbs) > netdev_max_backlog) {
-		atomic_long_inc(&dev->rx_dropped);
+		atomic_long_inc_unchecked(&dev->rx_dropped);
 		kfree_skb(skb);
 		return NET_RX_DROP;
 	}
diff --git a/include/net/inet_connection_sock.h b/include/net/inet_connection_sock.h
index 49dcad4fe..6d2c70844 100644
--- a/include/net/inet_connection_sock.h
+++ b/include/net/inet_connection_sock.h
@@ -65,7 +65,7 @@ struct inet_connection_sock_af_ops {
 	int	    (*bind_conflict)(const struct sock *sk,
 				     const struct inet_bind_bucket *tb, bool relax);
 	void	    (*mtu_reduced)(struct sock *sk);
-};
+} __do_const;
 
 /** inet_connection_sock - INET connection oriented sock
  *
diff --git a/include/net/inet_sock.h b/include/net/inet_sock.h
index 236a81034..0dae46913 100644
--- a/include/net/inet_sock.h
+++ b/include/net/inet_sock.h
@@ -44,7 +44,7 @@
 struct ip_options {
 	__be32		faddr;
 	__be32		nexthop;
-	unsigned char	optlen;
+	unsigned char	optlen __intentional_overflow(0);
 	unsigned char	srr;
 	unsigned char	rr;
 	unsigned char	ts;
diff --git a/include/net/inetpeer.h b/include/net/inetpeer.h
index 235c7811a..160d4a38a 100644
--- a/include/net/inetpeer.h
+++ b/include/net/inetpeer.h
@@ -52,7 +52,7 @@ struct inet_peer {
 	 */
 	union {
 		struct {
-			atomic_t			rid;		/* Frag reception counter */
+			atomic_unchecked_t		rid;		/* Frag reception counter */
 		};
 		struct rcu_head         rcu;
 		struct inet_peer	*gc_next;
diff --git a/include/net/ip.h b/include/net/ip.h
index 0ccf6daf6..5f0319dbe 100644
--- a/include/net/ip.h
+++ b/include/net/ip.h
@@ -325,7 +325,7 @@ static inline unsigned int ip_skb_dst_mtu(struct sock *sk,
 	return min(skb_dst(skb)->dev->mtu, IP_MAX_MTU);
 }
 
-u32 ip_idents_reserve(u32 hash, int segs);
+u32 ip_idents_reserve(u32 hash, int segs) __intentional_overflow(-1);
 void __ip_select_ident(struct net *net, struct iphdr *iph, int segs);
 
 static inline void ip_select_ident_segs(struct net *net, struct sk_buff *skb,
diff --git a/include/net/ip6_fib.h b/include/net/ip6_fib.h
index fb961a576..754f4432a 100644
--- a/include/net/ip6_fib.h
+++ b/include/net/ip6_fib.h
@@ -248,10 +248,6 @@ struct fib6_table {
 #define RT6_TABLE_LOCAL		RT6_TABLE_MAIN
 #endif
 
-typedef struct rt6_info *(*pol_lookup_t)(struct net *,
-					 struct fib6_table *,
-					 struct flowi6 *, int);
-
 /*
  *	exported functions
  */
diff --git a/include/net/ip_fib.h b/include/net/ip_fib.h
index 7d4a72e75..f4ec4993d 100644
--- a/include/net/ip_fib.h
+++ b/include/net/ip_fib.h
@@ -175,7 +175,7 @@ __be32 fib_info_update_nh_saddr(struct net *net, struct fib_nh *nh);
 
 #define FIB_RES_SADDR(net, res)				\
 	((FIB_RES_NH(res).nh_saddr_genid ==		\
-	  atomic_read(&(net)->ipv4.dev_addr_genid)) ?	\
+	  atomic_read_unchecked(&(net)->ipv4.dev_addr_genid)) ?	\
 	 FIB_RES_NH(res).nh_saddr :			\
 	 fib_info_update_nh_saddr((net), &FIB_RES_NH(res)))
 #define FIB_RES_GW(res)			(FIB_RES_NH(res).nh_gw)
diff --git a/include/net/ip_vs.h b/include/net/ip_vs.h
index cd6018a9e..996671f8c 100644
--- a/include/net/ip_vs.h
+++ b/include/net/ip_vs.h
@@ -543,7 +543,7 @@ struct ip_vs_conn {
 	struct ip_vs_conn       *control;       /* Master control connection */
 	atomic_t                n_control;      /* Number of controlled ones */
 	struct ip_vs_dest       *dest;          /* real server */
-	atomic_t                in_pkts;        /* incoming packet counter */
+	atomic_unchecked_t      in_pkts;        /* incoming packet counter */
 
 	/* Packet transmitter for different forwarding methods.  If it
 	 * mangles the packet, it must return NF_DROP or better NF_STOLEN,
@@ -664,7 +664,7 @@ struct ip_vs_dest {
 	__be16			port;		/* port number of the server */
 	union nf_inet_addr	addr;		/* IP address of the server */
 	volatile unsigned int	flags;		/* dest status flags */
-	atomic_t		conn_flags;	/* flags to copy to conn */
+	atomic_unchecked_t	conn_flags;	/* flags to copy to conn */
 	atomic_t		weight;		/* server weight */
 
 	atomic_t		refcnt;		/* reference counter */
@@ -931,11 +931,11 @@ struct netns_ipvs {
 	/* ip_vs_lblc */
 	int			sysctl_lblc_expiration;
 	struct ctl_table_header	*lblc_ctl_header;
-	struct ctl_table	*lblc_ctl_table;
+	ctl_table_no_const	*lblc_ctl_table;
 	/* ip_vs_lblcr */
 	int			sysctl_lblcr_expiration;
 	struct ctl_table_header	*lblcr_ctl_header;
-	struct ctl_table	*lblcr_ctl_table;
+	ctl_table_no_const	*lblcr_ctl_table;
 	/* ip_vs_est */
 	struct list_head	est_list;	/* estimator list */
 	spinlock_t		est_lock;
diff --git a/include/net/ipv6.h b/include/net/ipv6.h
index 8fed1cd78..3ac5db942 100644
--- a/include/net/ipv6.h
+++ b/include/net/ipv6.h
@@ -788,7 +788,7 @@ static inline __be32 ip6_make_flowlabel(struct net *net, struct sk_buff *skb,
 	 * to minimize possbility that any useful information to an
 	 * attacker is leaked. Only lower 20 bits are relevant.
 	 */
-	rol32(hash, 16);
+	hash = rol32(hash, 16);
 
 	flowlabel = (__force __be32)hash & IPV6_FLOWLABEL_MASK;
 
diff --git a/include/net/irda/ircomm_tty.h b/include/net/irda/ircomm_tty.h
index 8d4f58897..2e37ad215 100644
--- a/include/net/irda/ircomm_tty.h
+++ b/include/net/irda/ircomm_tty.h
@@ -33,6 +33,7 @@
 #include <linux/termios.h>
 #include <linux/timer.h>
 #include <linux/tty.h>		/* struct tty_struct */
+#include <asm/local.h>
 
 #include <net/irda/irias_object.h>
 #include <net/irda/ircomm_core.h>
diff --git a/include/net/irda/irias_object.h b/include/net/irda/irias_object.h
index 83f780817..a925cf8cf 100644
--- a/include/net/irda/irias_object.h
+++ b/include/net/irda/irias_object.h
@@ -83,7 +83,7 @@ void irias_insert_object(struct ias_object *obj);
 int  irias_delete_object(struct ias_object *obj);
 int  irias_delete_attrib(struct ias_object *obj, struct ias_attrib *attrib,
 			 int cleanobject);
-void __irias_delete_object(struct ias_object *obj);
+void __irias_delete_object(void *_obj);
 
 void irias_add_integer_attrib(struct ias_object *obj, char *name, int value,
 			      int user);
diff --git a/include/net/irda/irlmp.h b/include/net/irda/irlmp.h
index f132924cc..f80b01d71 100644
--- a/include/net/irda/irlmp.h
+++ b/include/net/irda/irlmp.h
@@ -194,6 +194,7 @@ struct irlmp_cb {
 /* Prototype declarations */
 int  irlmp_init(void);
 void irlmp_cleanup(void);
+void irlmp_kfree(void *arg);
 struct lsap_cb *irlmp_open_lsap(__u8 slsap, notify_t *notify, __u8 pid);
 void irlmp_close_lsap( struct lsap_cb *self);
 
diff --git a/include/net/irda/irlmp_event.h b/include/net/irda/irlmp_event.h
index 9e4ec17a7..c3247bb42 100644
--- a/include/net/irda/irlmp_event.h
+++ b/include/net/irda/irlmp_event.h
@@ -82,9 +82,9 @@ typedef enum {
 extern const char *const irlmp_state[];
 extern const char *const irlsap_state[];
 
-void irlmp_watchdog_timer_expired(void *data);
-void irlmp_discovery_timer_expired(void *data);
-void irlmp_idle_timer_expired(void *data);
+void irlmp_watchdog_timer_expired(unsigned long data);
+void irlmp_discovery_timer_expired(unsigned long data);
+void irlmp_idle_timer_expired(unsigned long data);
 
 void irlmp_do_lap_event(struct lap_cb *self, IRLMP_EVENT event, 
 			struct sk_buff *skb);
diff --git a/include/net/irda/timer.h b/include/net/irda/timer.h
index cb2615ccf..8223ae779 100644
--- a/include/net/irda/timer.h
+++ b/include/net/irda/timer.h
@@ -72,12 +72,10 @@ struct lap_cb;
 
 #define WATCHDOG_TIMEOUT        (20*HZ)       /* 20 sec */
 
-typedef void (*TIMER_CALLBACK)(void *);
-
 static inline void irda_start_timer(struct timer_list *ptimer, int timeout, 
-				    void* data, TIMER_CALLBACK callback)
+				    void* data, void (*callback)(unsigned long))
 {
-	ptimer->function = (void (*)(unsigned long)) callback;
+	ptimer->function = callback;
 	ptimer->data = (unsigned long) data;
 	
 	/* Set new value for timer (update or add timer).
diff --git a/include/net/iucv/af_iucv.h b/include/net/iucv/af_iucv.h
index 714cc9a54..ea05f3e9a 100644
--- a/include/net/iucv/af_iucv.h
+++ b/include/net/iucv/af_iucv.h
@@ -149,7 +149,7 @@ struct iucv_skb_cb {
 struct iucv_sock_list {
 	struct hlist_head head;
 	rwlock_t	  lock;
-	atomic_t	  autobind_name;
+	atomic_unchecked_t autobind_name;
 };
 
 unsigned int iucv_sock_poll(struct file *file, struct socket *sock,
diff --git a/include/net/llc_c_ac.h b/include/net/llc_c_ac.h
index f3be818e7..bf4619648 100644
--- a/include/net/llc_c_ac.h
+++ b/include/net/llc_c_ac.h
@@ -87,7 +87,7 @@
 #define LLC_CONN_AC_STOP_SENDACK_TMR			70
 #define LLC_CONN_AC_START_SENDACK_TMR_IF_NOT_RUNNING	71
 
-typedef int (*llc_conn_action_t)(struct sock *sk, struct sk_buff *skb);
+typedef int (* const llc_conn_action_t)(struct sock *sk, struct sk_buff *skb);
 
 int llc_conn_ac_clear_remote_busy(struct sock *sk, struct sk_buff *skb);
 int llc_conn_ac_conn_ind(struct sock *sk, struct sk_buff *skb);
diff --git a/include/net/llc_c_ev.h b/include/net/llc_c_ev.h
index 3948cf111..83b28c48c 100644
--- a/include/net/llc_c_ev.h
+++ b/include/net/llc_c_ev.h
@@ -125,8 +125,8 @@ static __inline__ struct llc_conn_state_ev *llc_conn_ev(struct sk_buff *skb)
 	return (struct llc_conn_state_ev *)skb->cb;
 }
 
-typedef int (*llc_conn_ev_t)(struct sock *sk, struct sk_buff *skb);
-typedef int (*llc_conn_ev_qfyr_t)(struct sock *sk, struct sk_buff *skb);
+typedef int (* const llc_conn_ev_t)(struct sock *sk, struct sk_buff *skb);
+typedef int (* const llc_conn_ev_qfyr_t)(struct sock *sk, struct sk_buff *skb);
 
 int llc_conn_ev_conn_req(struct sock *sk, struct sk_buff *skb);
 int llc_conn_ev_data_req(struct sock *sk, struct sk_buff *skb);
diff --git a/include/net/llc_c_st.h b/include/net/llc_c_st.h
index 48f3f891b..0e92c50d3 100644
--- a/include/net/llc_c_st.h
+++ b/include/net/llc_c_st.h
@@ -37,7 +37,7 @@ struct llc_conn_state_trans {
 	u8		   next_state;
 	const llc_conn_ev_qfyr_t *ev_qualifiers;
 	const llc_conn_action_t  *ev_actions;
-};
+} __do_const;
 
 struct llc_conn_state {
 	u8			    current_state;
diff --git a/include/net/llc_s_ac.h b/include/net/llc_s_ac.h
index a61b98c10..aade1eb04 100644
--- a/include/net/llc_s_ac.h
+++ b/include/net/llc_s_ac.h
@@ -23,7 +23,7 @@
 #define SAP_ACT_TEST_IND	9
 
 /* All action functions must look like this */
-typedef int (*llc_sap_action_t)(struct llc_sap *sap, struct sk_buff *skb);
+typedef int (* const llc_sap_action_t)(struct llc_sap *sap, struct sk_buff *skb);
 
 int llc_sap_action_unitdata_ind(struct llc_sap *sap, struct sk_buff *skb);
 int llc_sap_action_send_ui(struct llc_sap *sap, struct sk_buff *skb);
diff --git a/include/net/llc_s_st.h b/include/net/llc_s_st.h
index c4359e203..76dbc4a28 100644
--- a/include/net/llc_s_st.h
+++ b/include/net/llc_s_st.h
@@ -20,7 +20,7 @@ struct llc_sap_state_trans {
 	llc_sap_ev_t	  ev;
 	u8		  next_state;
 	const llc_sap_action_t *ev_actions;
-};
+} __do_const;
 
 struct llc_sap_state {
 	u8			   curr_state;
diff --git a/include/net/mac80211.h b/include/net/mac80211.h
index cca510a58..04adc848a 100644
--- a/include/net/mac80211.h
+++ b/include/net/mac80211.h
@@ -1567,7 +1567,7 @@ enum ieee80211_key_flags {
  * @iv_len: The IV length for this key type
  */
 struct ieee80211_key_conf {
-	atomic64_t tx_pn;
+	atomic64_unchecked_t tx_pn;
 	u32 cipher;
 	u8 icv_len;
 	u8 iv_len;
@@ -5358,7 +5358,7 @@ struct ieee80211_tx_rate_control {
 	struct sk_buff *skb;
 	struct ieee80211_tx_rate reported_rate;
 	bool rts, short_preamble;
-	u8 max_rate_idx;
+	s8 max_rate_idx;
 	u32 rate_idx_mask;
 	u8 *rate_idx_mcs_mask;
 	bool bss;
@@ -5395,7 +5395,7 @@ struct rate_control_ops {
 	void (*remove_sta_debugfs)(void *priv, void *priv_sta);
 
 	u32 (*get_expected_throughput)(void *priv_sta);
-};
+} __do_const;
 
 static inline int rate_supported(struct ieee80211_sta *sta,
 				 enum nl80211_band band,
diff --git a/include/net/neighbour.h b/include/net/neighbour.h
index 8b683841e..48fe40e38 100644
--- a/include/net/neighbour.h
+++ b/include/net/neighbour.h
@@ -142,7 +142,7 @@ struct neighbour {
 	unsigned int		arp_queue_len_bytes;
 	struct timer_list	timer;
 	unsigned long		used;
-	atomic_t		probes;
+	atomic_unchecked_t	probes;
 	__u8			flags;
 	__u8			nud_state;
 	__u8			type;
@@ -163,7 +163,7 @@ struct neigh_ops {
 	void			(*error_report)(struct neighbour *, struct sk_buff *);
 	int			(*output)(struct neighbour *, struct sk_buff *);
 	int			(*connected_output)(struct neighbour *, struct sk_buff *);
-};
+} __do_const;
 
 struct pneigh_entry {
 	struct pneigh_entry	*next;
@@ -217,7 +217,7 @@ struct neigh_table {
 	struct neigh_statistics	__percpu *stats;
 	struct neigh_hash_table __rcu *nht;
 	struct pneigh_entry	**phash_buckets;
-};
+} __randomize_layout;
 
 enum {
 	NEIGH_ARP_TABLE = 0,
diff --git a/include/net/net_namespace.h b/include/net/net_namespace.h
index 0933c7455..11d12501d 100644
--- a/include/net/net_namespace.h
+++ b/include/net/net_namespace.h
@@ -53,7 +53,7 @@ struct net {
 						 */
 	spinlock_t		rules_mod_lock;
 
-	atomic64_t		cookie_gen;
+	atomic64_unchecked_t	cookie_gen;
 
 	struct list_head	list;		/* list of network namespaces */
 	struct list_head	cleanup_list;	/* namespaces on death row */
@@ -141,8 +141,8 @@ struct net {
 	struct netns_mpls	mpls;
 #endif
 	struct sock		*diag_nlsk;
-	atomic_t		fnhe_genid;
-};
+	atomic_unchecked_t	fnhe_genid;
+} __randomize_layout;
 
 #include <linux/seq_file_net.h>
 
@@ -277,7 +277,11 @@ static inline struct net *read_pnet(const possible_net_t *pnet)
 #define __net_init	__init
 #define __net_exit	__ref
 #define __net_initdata	__initdata
+#ifdef CONSTIFY_PLUGIN
 #define __net_initconst	__initconst
+#else
+#define __net_initconst	__initdata
+#endif
 #endif
 
 int peernet2id_alloc(struct net *net, struct net *peer);
@@ -292,7 +296,7 @@ struct pernet_operations {
 	void (*exit_batch)(struct list_head *net_exit_list);
 	int *id;
 	size_t size;
-};
+} __do_const;
 
 /*
  * Use these carefully.  If you implement a network device and it
@@ -340,12 +344,12 @@ static inline void unregister_net_sysctl_table(struct ctl_table_header *header)
 
 static inline int rt_genid_ipv4(struct net *net)
 {
-	return atomic_read(&net->ipv4.rt_genid);
+	return atomic_read_unchecked(&net->ipv4.rt_genid);
 }
 
 static inline void rt_genid_bump_ipv4(struct net *net)
 {
-	atomic_inc(&net->ipv4.rt_genid);
+	atomic_inc_unchecked(&net->ipv4.rt_genid);
 }
 
 extern void (*__fib6_flush_trees)(struct net *net);
@@ -372,12 +376,12 @@ static inline void rt_genid_bump_all(struct net *net)
 
 static inline int fnhe_genid(struct net *net)
 {
-	return atomic_read(&net->fnhe_genid);
+	return atomic_read_unchecked(&net->fnhe_genid);
 }
 
 static inline void fnhe_genid_bump(struct net *net)
 {
-	atomic_inc(&net->fnhe_genid);
+	atomic_inc_unchecked(&net->fnhe_genid);
 }
 
 #endif /* __NET_NET_NAMESPACE_H */
diff --git a/include/net/netfilter/nf_conntrack.h b/include/net/netfilter/nf_conntrack.h
index de45666f9..6e17c45de 100644
--- a/include/net/netfilter/nf_conntrack.h
+++ b/include/net/netfilter/nf_conntrack.h
@@ -297,7 +297,7 @@ static inline unsigned long nf_ct_expires(const struct nf_conn *ct)
 
 struct kernel_param;
 
-int nf_conntrack_set_hashsize(const char *val, struct kernel_param *kp);
+int nf_conntrack_set_hashsize(const char *val, const struct kernel_param *kp);
 int nf_conntrack_hash_resize(unsigned int hashsize);
 extern unsigned int nf_conntrack_htable_size;
 extern unsigned int nf_conntrack_max;
diff --git a/include/net/netlabel.h b/include/net/netlabel.h
index efe980688..bec155a74 100644
--- a/include/net/netlabel.h
+++ b/include/net/netlabel.h
@@ -669,6 +669,7 @@ static inline int netlbl_skbuff_getattr(const struct sk_buff *skb,
 	return -ENOSYS;
 }
 static inline void netlbl_skbuff_err(struct sk_buff *skb,
+				     u16 family,
 				     int error,
 				     int gateway)
 {
diff --git a/include/net/netlink.h b/include/net/netlink.h
index 254a0fc01..040f766b7 100644
--- a/include/net/netlink.h
+++ b/include/net/netlink.h
@@ -532,7 +532,7 @@ static inline void nlmsg_trim(struct sk_buff *skb, const void *mark)
 {
 	if (mark) {
 		WARN_ON((unsigned char *) mark < skb->data);
-		skb_trim(skb, (unsigned char *) mark - skb->data);
+		skb_trim(skb, (const unsigned char *) mark - skb->data);
 	}
 }
 
diff --git a/include/net/netns/conntrack.h b/include/net/netns/conntrack.h
index 38b1a8051..c2d91f11f 100644
--- a/include/net/netns/conntrack.h
+++ b/include/net/netns/conntrack.h
@@ -14,10 +14,10 @@ struct nf_conntrack_ecache;
 struct nf_proto_net {
 #ifdef CONFIG_SYSCTL
 	struct ctl_table_header *ctl_table_header;
-	struct ctl_table        *ctl_table;
+	ctl_table_no_const      *ctl_table;
 #ifdef CONFIG_NF_CONNTRACK_PROC_COMPAT
 	struct ctl_table_header *ctl_compat_header;
-	struct ctl_table        *ctl_compat_table;
+	ctl_table_no_const      *ctl_compat_table;
 #endif
 #endif
 	unsigned int		users;
@@ -60,7 +60,7 @@ struct nf_ip_net {
 	struct nf_icmp_net	icmpv6;
 #if defined(CONFIG_SYSCTL) && defined(CONFIG_NF_CONNTRACK_PROC_COMPAT)
 	struct ctl_table_header *ctl_table_header;
-	struct ctl_table	*ctl_table;
+	ctl_table_no_const	*ctl_table;
 #endif
 };
 
diff --git a/include/net/netns/ipv4.h b/include/net/netns/ipv4.h
index d061ffeb1..cc6cdb96b 100644
--- a/include/net/netns/ipv4.h
+++ b/include/net/netns/ipv4.h
@@ -119,7 +119,7 @@ struct netns_ipv4 {
 
 	struct ping_group_range ping_group_range;
 
-	atomic_t dev_addr_genid;
+	atomic_unchecked_t dev_addr_genid;
 
 #ifdef CONFIG_SYSCTL
 	unsigned long *sysctl_local_reserved_ports;
@@ -136,6 +136,6 @@ struct netns_ipv4 {
 #ifdef CONFIG_IP_ROUTE_MULTIPATH
 	int sysctl_fib_multipath_use_neigh;
 #endif
-	atomic_t	rt_genid;
+	atomic_unchecked_t	rt_genid;
 };
 #endif
diff --git a/include/net/netns/ipv6.h b/include/net/netns/ipv6.h
index 10d0848f5..68bc2daeb 100644
--- a/include/net/netns/ipv6.h
+++ b/include/net/netns/ipv6.h
@@ -83,8 +83,8 @@ struct netns_ipv6 {
 	struct fib_rules_ops	*mr6_rules_ops;
 #endif
 #endif
-	atomic_t		dev_addr_genid;
-	atomic_t		fib6_sernum;
+	atomic_unchecked_t	dev_addr_genid;
+	atomic_unchecked_t	fib6_sernum;
 };
 
 #if IS_ENABLED(CONFIG_NF_DEFRAG_IPV6)
diff --git a/include/net/netns/xfrm.h b/include/net/netns/xfrm.h
index 24cd3949a..8310b26af 100644
--- a/include/net/netns/xfrm.h
+++ b/include/net/netns/xfrm.h
@@ -78,7 +78,7 @@ struct netns_xfrm {
 
 	/* flow cache part */
 	struct flow_cache	flow_cache_global;
-	atomic_t		flow_cache_genid;
+	atomic_unchecked_t	flow_cache_genid;
 	struct list_head	flow_cache_gc_list;
 	atomic_t		flow_cache_gc_count;
 	spinlock_t		flow_cache_gc_lock;
diff --git a/include/net/ping.h b/include/net/ping.h
index 4cd90d6b5..49473115b 100644
--- a/include/net/ping.h
+++ b/include/net/ping.h
@@ -54,7 +54,7 @@ struct ping_iter_state {
 
 extern struct proto ping_prot;
 #if IS_ENABLED(CONFIG_IPV6)
-extern struct pingv6_ops pingv6_ops;
+extern struct pingv6_ops *pingv6_ops;
 #endif
 
 struct pingfakehdr {
diff --git a/include/net/protocol.h b/include/net/protocol.h
index bf36ca34a..c29da79c5 100644
--- a/include/net/protocol.h
+++ b/include/net/protocol.h
@@ -49,7 +49,7 @@ struct net_protocol {
 				 * socket lookup?
 				 */
 				icmp_strict_tag_validation:1;
-};
+} __do_const;
 
 #if IS_ENABLED(CONFIG_IPV6)
 struct inet6_protocol {
@@ -62,7 +62,7 @@ struct inet6_protocol {
 			       u8 type, u8 code, int offset,
 			       __be32 info);
 	unsigned int	flags;	/* INET6_PROTO_xxx */
-};
+} __do_const;
 
 #define INET6_PROTO_NOPOLICY	0x1
 #define INET6_PROTO_FINAL	0x2
diff --git a/include/net/rtnetlink.h b/include/net/rtnetlink.h
index 4113916cc..afa5d60f4 100644
--- a/include/net/rtnetlink.h
+++ b/include/net/rtnetlink.h
@@ -103,7 +103,7 @@ struct rtnl_link_ops {
 	int			(*fill_linkxstats)(struct sk_buff *skb,
 						   const struct net_device *dev,
 						   int *prividx, int attr);
-};
+} __do_const;
 
 int __rtnl_link_register(struct rtnl_link_ops *ops);
 void __rtnl_link_unregister(struct rtnl_link_ops *ops);
diff --git a/include/net/sctp/checksum.h b/include/net/sctp/checksum.h
index 4a5b9a306..ca27d7364 100644
--- a/include/net/sctp/checksum.h
+++ b/include/net/sctp/checksum.h
@@ -61,8 +61,8 @@ static inline __le32 sctp_compute_cksum(const struct sk_buff *skb,
 					unsigned int offset)
 {
 	struct sctphdr *sh = sctp_hdr(skb);
-        __le32 ret, old = sh->checksum;
-	const struct skb_checksum_ops ops = {
+	__le32 ret, old = sh->checksum;
+	static const struct skb_checksum_ops ops = {
 		.update  = sctp_csum_update,
 		.combine = sctp_csum_combine,
 	};
diff --git a/include/net/sctp/sm.h b/include/net/sctp/sm.h
index bafe2a0ab..f27e53cae 100644
--- a/include/net/sctp/sm.h
+++ b/include/net/sctp/sm.h
@@ -80,7 +80,7 @@ typedef void (sctp_timer_event_t) (unsigned long);
 typedef struct {
 	sctp_state_fn_t *fn;
 	const char *name;
-} sctp_sm_table_entry_t;
+} __do_const sctp_sm_table_entry_t;
 
 /* A naming convention of "sctp_sf_xxx" applies to all the state functions
  * currently in use.
@@ -292,7 +292,7 @@ __u32 sctp_generate_tag(const struct sctp_endpoint *);
 __u32 sctp_generate_tsn(const struct sctp_endpoint *);
 
 /* Extern declarations for major data structures.  */
-extern sctp_timer_event_t *sctp_timer_events[SCTP_NUM_TIMEOUT_TYPES];
+extern sctp_timer_event_t * const sctp_timer_events[SCTP_NUM_TIMEOUT_TYPES];
 
 
 /* Get the size of a DATA chunk payload. */
diff --git a/include/net/sctp/structs.h b/include/net/sctp/structs.h
index ced0df374..5d024064a 100644
--- a/include/net/sctp/structs.h
+++ b/include/net/sctp/structs.h
@@ -514,7 +514,7 @@ struct sctp_pf {
 	void (*to_sk_saddr)(union sctp_addr *, struct sock *sk);
 	void (*to_sk_daddr)(union sctp_addr *, struct sock *sk);
 	struct sctp_af *af;
-};
+} __do_const;
 
 
 /* Structure to track chunk fragments that have been acked, but peer
diff --git a/include/net/snmp.h b/include/net/snmp.h
index c9228ad7e..5543dfb1f 100644
--- a/include/net/snmp.h
+++ b/include/net/snmp.h
@@ -67,7 +67,7 @@ struct icmp_mib {
 
 #define ICMPMSG_MIB_MAX	__ICMPMSG_MIB_MAX
 struct icmpmsg_mib {
-	atomic_long_t	mibs[ICMPMSG_MIB_MAX];
+	atomic_long_unchecked_t	mibs[ICMPMSG_MIB_MAX];
 };
 
 /* ICMP6 (IPv6-ICMP) */
@@ -78,17 +78,17 @@ struct icmpv6_mib {
 };
 /* per device counters, (shared on all cpus) */
 struct icmpv6_mib_device {
-	atomic_long_t	mibs[ICMP6_MIB_MAX];
+	atomic_long_unchecked_t	mibs[ICMP6_MIB_MAX];
 };
 
 #define ICMP6MSG_MIB_MAX  __ICMP6MSG_MIB_MAX
 /* per network ns counters */
 struct icmpv6msg_mib {
-	atomic_long_t	mibs[ICMP6MSG_MIB_MAX];
+	atomic_long_unchecked_t	mibs[ICMP6MSG_MIB_MAX];
 };
 /* per device counters, (shared on all cpus) */
 struct icmpv6msg_mib_device {
-	atomic_long_t	mibs[ICMP6MSG_MIB_MAX];
+	atomic_long_unchecked_t	mibs[ICMP6MSG_MIB_MAX];
 };
 
 
@@ -127,7 +127,7 @@ struct linux_xfrm_mib {
 			__this_cpu_inc(mib->mibs[field])
 
 #define SNMP_INC_STATS_ATOMIC_LONG(mib, field)	\
-			atomic_long_inc(&mib->mibs[field])
+			atomic_long_inc_unchecked(&mib->mibs[field])
 
 #define SNMP_INC_STATS(mib, field)	\
 			this_cpu_inc(mib->mibs[field])
diff --git a/include/net/sock.h b/include/net/sock.h
index c26eab962..7f3122898 100644
--- a/include/net/sock.h
+++ b/include/net/sock.h
@@ -188,7 +188,7 @@ struct sock_common {
 	struct in6_addr		skc_v6_rcv_saddr;
 #endif
 
-	atomic64_t		skc_cookie;
+	atomic64_unchecked_t	skc_cookie;
 
 	/* following fields are padding to force
 	 * offset(struct sock, sk_refcnt) == 128 on 64bit arches
@@ -364,7 +364,7 @@ struct sock {
 	unsigned int		sk_napi_id;
 	unsigned int		sk_ll_usec;
 #endif
-	atomic_t		sk_drops;
+	atomic_unchecked_t	sk_drops;
 	int			sk_rcvbuf;
 
 	struct sk_filter __rcu	*sk_filter;
@@ -1069,7 +1069,7 @@ struct proto {
 	atomic_t		socks;
 #endif
 	int			(*diag_destroy)(struct sock *sk, int err);
-};
+} __randomize_layout;
 
 int proto_register(struct proto *prot, int alloc_slab);
 void proto_unregister(struct proto *prot);
@@ -1156,7 +1156,7 @@ static inline long sk_prot_mem_limits(const struct sock *sk, int index)
 	return sk->sk_prot->sysctl_mem[index];
 }
 
-static inline long
+static inline long __intentional_overflow(-1)
 sk_memory_allocated(const struct sock *sk)
 {
 	return atomic_long_read(sk->sk_prot->memory_allocated);
@@ -1769,7 +1769,7 @@ static inline bool sk_check_csum_caps(struct sock *sk)
 }
 
 static inline int skb_do_copy_data_nocache(struct sock *sk, struct sk_buff *skb,
-					   struct iov_iter *from, char *to,
+					   struct iov_iter *from, unsigned char *to,
 					   int copy, int offset)
 {
 	if (skb->ip_summed == CHECKSUM_NONE) {
@@ -2023,7 +2023,7 @@ static inline void sk_stream_moderate_sndbuf(struct sock *sk)
 	}
 }
 
-struct sk_buff *sk_stream_alloc_skb(struct sock *sk, int size, gfp_t gfp,
+struct sk_buff * __intentional_overflow(0) sk_stream_alloc_skb(struct sock *sk, int size, gfp_t gfp,
 				    bool force_schedule);
 
 /**
@@ -2099,14 +2099,14 @@ struct sock_skb_cb {
 static inline void
 sock_skb_set_dropcount(const struct sock *sk, struct sk_buff *skb)
 {
-	SOCK_SKB_CB(skb)->dropcount = atomic_read(&sk->sk_drops);
+	SOCK_SKB_CB(skb)->dropcount = atomic_read_unchecked(&sk->sk_drops);
 }
 
 static inline void sk_drops_add(struct sock *sk, const struct sk_buff *skb)
 {
 	int segs = max_t(u16, 1, skb_shinfo(skb)->gso_segs);
 
-	atomic_add(segs, &sk->sk_drops);
+	atomic_add_unchecked(segs, &sk->sk_drops);
 }
 
 void __sock_recv_timestamp(struct msghdr *msg, struct sock *sk,
diff --git a/include/net/tcp.h b/include/net/tcp.h
index 0de698940..9846ad037 100644
--- a/include/net/tcp.h
+++ b/include/net/tcp.h
@@ -543,7 +543,7 @@ void tcp_retransmit_timer(struct sock *sk);
 void tcp_xmit_retransmit_queue(struct sock *);
 void tcp_simple_retransmit(struct sock *);
 int tcp_trim_head(struct sock *, struct sk_buff *, u32);
-int tcp_fragment(struct sock *, struct sk_buff *, u32, unsigned int, gfp_t);
+int tcp_fragment(struct sock *, struct sk_buff *, u32, unsigned int, gfp_t) __intentional_overflow(3);
 
 void tcp_send_probe0(struct sock *);
 void tcp_send_partial(struct sock *);
@@ -732,8 +732,8 @@ static inline u32 tcp_skb_timestamp(const struct sk_buff *skb)
  * If this grows please adjust skbuff.h:skbuff->cb[xxx] size appropriately.
  */
 struct tcp_skb_cb {
-	__u32		seq;		/* Starting sequence number	*/
-	__u32		end_seq;	/* SEQ + FIN + SYN + datalen	*/
+	__u32		seq __intentional_overflow(-1);	/* Starting sequence number	*/
+	__u32		end_seq __intentional_overflow(-1);	/* SEQ + FIN + SYN + datalen	*/
 	union {
 		/* Note : tcp_tw_isn is used in input path only
 		 *	  (isn chosen by tcp_timewait_state_process())
@@ -763,7 +763,7 @@ struct tcp_skb_cb {
 	__u8		txstamp_ack:1,	/* Record TX timestamp for ack? */
 			eor:1,		/* Is skb MSG_EOR marked? */
 			unused:6;
-	__u32		ack_seq;	/* Sequence number ACK'd	*/
+	__u32		ack_seq __intentional_overflow(-1);	/* Sequence number ACK'd	*/
 	union {
 		struct {
 			/* There is space for up to 20 bytes */
@@ -1873,7 +1873,7 @@ static inline void tcp_segs_in(struct tcp_sock *tp, const struct sk_buff *skb)
  */
 static inline void tcp_listendrop(const struct sock *sk)
 {
-	atomic_inc(&((struct sock *)sk)->sk_drops);
+	atomic_inc_unchecked(&((struct sock *)sk)->sk_drops);
 	__NET_INC_STATS(sock_net(sk), LINUX_MIB_LISTENDROPS);
 }
 
diff --git a/include/net/xfrm.h b/include/net/xfrm.h
index 17934312e..2feaff288 100644
--- a/include/net/xfrm.h
+++ b/include/net/xfrm.h
@@ -280,7 +280,6 @@ struct xfrm_dst;
 struct xfrm_policy_afinfo {
 	unsigned short		family;
 	struct dst_ops		*dst_ops;
-	void			(*garbage_collect)(struct net *net);
 	struct dst_entry	*(*dst_lookup)(struct net *net,
 					       int tos, int oif,
 					       const xfrm_address_t *saddr,
@@ -299,7 +298,7 @@ struct xfrm_policy_afinfo {
 					    struct net_device *dev,
 					    const struct flowi *fl);
 	struct dst_entry	*(*blackhole_route)(struct net *net, struct dst_entry *orig);
-};
+} __do_const;
 
 int xfrm_policy_register_afinfo(struct xfrm_policy_afinfo *afinfo);
 int xfrm_policy_unregister_afinfo(struct xfrm_policy_afinfo *afinfo);
@@ -338,7 +337,7 @@ struct xfrm_state_afinfo {
 	int			(*transport_finish)(struct sk_buff *skb,
 						    int async);
 	void			(*local_error)(struct sk_buff *skb, u32 mtu);
-};
+} __do_const;
 
 int xfrm_state_register_afinfo(struct xfrm_state_afinfo *afinfo);
 int xfrm_state_unregister_afinfo(struct xfrm_state_afinfo *afinfo);
@@ -433,7 +432,7 @@ struct xfrm_mode {
 	struct module *owner;
 	unsigned int encap;
 	int flags;
-};
+} __do_const;
 
 /* Flags for xfrm_mode. */
 enum {
@@ -528,7 +527,7 @@ struct xfrm_policy {
 	struct timer_list	timer;
 
 	struct flow_cache_object flo;
-	atomic_t		genid;
+	atomic_unchecked_t	genid;
 	u32			priority;
 	u32			index;
 	struct xfrm_mark	mark;
@@ -599,7 +598,7 @@ struct xfrm_mgr {
 					   int num_bundles,
 					   const struct xfrm_kmaddress *k);
 	bool			(*is_alive)(const struct km_event *c);
-};
+} __do_const;
 
 int xfrm_register_km(struct xfrm_mgr *km);
 int xfrm_unregister_km(struct xfrm_mgr *km);
@@ -1168,6 +1167,7 @@ static inline void xfrm_sk_free_policy(struct sock *sk)
 }
 
 void xfrm_garbage_collect(struct net *net);
+void xfrm_garbage_collect_deferred(struct net *net);
 
 #else
 
@@ -1206,6 +1206,9 @@ static inline int xfrm6_policy_check_reverse(struct sock *sk, int dir,
 static inline void xfrm_garbage_collect(struct net *net)
 {
 }
+static inline void xfrm_garbage_collect_deferred(struct net *net)
+{
+}
 #endif
 
 static __inline__
diff --git a/include/rdma/ib_cm.h b/include/rdma/ib_cm.h
index 92a7d8591..177957041 100644
--- a/include/rdma/ib_cm.h
+++ b/include/rdma/ib_cm.h
@@ -486,8 +486,8 @@ int ib_cm_notify(struct ib_cm_id *cm_id, enum ib_event_type event);
  * @private_data_len: Size of the private data buffer, in bytes.
  */
 int ib_send_cm_rej(struct ib_cm_id *cm_id,
-		   enum ib_cm_rej_reason reason,
-		   void *ari,
+		   int reason,
+		   const void *ari,
 		   u8 ari_length,
 		   const void *private_data,
 		   u8 private_data_len);
@@ -558,8 +558,8 @@ int ib_cm_init_qp_attr(struct ib_cm_id *cm_id,
  * @private_data_len: Size of the private data buffer, in bytes.
  */
 int ib_send_cm_apr(struct ib_cm_id *cm_id,
-		   enum ib_cm_apr_status status,
-		   void *info,
+		   int status,
+		   const void *info,
 		   u8 info_length,
 		   const void *private_data,
 		   u8 private_data_len);
diff --git a/include/rdma/ib_verbs.h b/include/rdma/ib_verbs.h
index e1f96737c..138c39f0b 100644
--- a/include/rdma/ib_verbs.h
+++ b/include/rdma/ib_verbs.h
@@ -1190,7 +1190,7 @@ struct ib_sge {
 
 struct ib_cqe {
 	void (*done)(struct ib_cq *cq, struct ib_wc *wc);
-};
+} __no_const;
 
 struct ib_send_wr {
 	struct ib_send_wr      *next;
diff --git a/include/scsi/libfc.h b/include/scsi/libfc.h
index 7428a5325..9d6aaef33 100644
--- a/include/scsi/libfc.h
+++ b/include/scsi/libfc.h
@@ -771,6 +771,7 @@ struct libfc_function_template {
 	 */
 	void (*disc_stop_final) (struct fc_lport *);
 };
+typedef struct libfc_function_template __no_const libfc_function_template_no_const;
 
 /**
  * struct fc_disc - Discovery context
@@ -875,7 +876,7 @@ struct fc_lport {
 	struct fc_vport		       *vport;
 
 	/* Operational Information */
-	struct libfc_function_template tt;
+	libfc_function_template_no_const tt;
 	u8			       link_up;
 	u8			       qfull;
 	u16			       vlan;
diff --git a/include/scsi/scsi_device.h b/include/scsi/scsi_device.h
index 8a9563144..bd0f3e584 100644
--- a/include/scsi/scsi_device.h
+++ b/include/scsi/scsi_device.h
@@ -193,9 +193,9 @@ struct scsi_device {
 	unsigned int max_device_blocked; /* what device_blocked counts down from  */
 #define SCSI_DEFAULT_DEVICE_BLOCKED	3
 
-	atomic_t iorequest_cnt;
-	atomic_t iodone_cnt;
-	atomic_t ioerr_cnt;
+	atomic_unchecked_t iorequest_cnt;
+	atomic_unchecked_t iodone_cnt;
+	atomic_unchecked_t ioerr_cnt;
 
 	struct device		sdev_gendev,
 				sdev_dev;
diff --git a/include/scsi/scsi_driver.h b/include/scsi/scsi_driver.h
index 891a658aa..fcd68df87 100644
--- a/include/scsi/scsi_driver.h
+++ b/include/scsi/scsi_driver.h
@@ -14,7 +14,7 @@ struct scsi_driver {
 	void (*rescan)(struct device *);
 	int (*init_command)(struct scsi_cmnd *);
 	void (*uninit_command)(struct scsi_cmnd *);
-	int (*done)(struct scsi_cmnd *);
+	unsigned int (*done)(struct scsi_cmnd *);
 	int (*eh_action)(struct scsi_cmnd *, int);
 };
 #define to_scsi_driver(drv) \
diff --git a/include/scsi/scsi_transport_fc.h b/include/scsi/scsi_transport_fc.h
index bf66ea6be..1c719d83f 100644
--- a/include/scsi/scsi_transport_fc.h
+++ b/include/scsi/scsi_transport_fc.h
@@ -758,7 +758,8 @@ struct fc_function_template {
 	unsigned long	show_host_system_hostname:1;
 
 	unsigned long	disable_target_scan:1;
-};
+} __do_const;
+typedef struct fc_function_template __no_const fc_function_template_no_const;
 
 
 /**
diff --git a/include/scsi/sg.h b/include/scsi/sg.h
index 3afec7032..b196b43ad 100644
--- a/include/scsi/sg.h
+++ b/include/scsi/sg.h
@@ -52,7 +52,7 @@ typedef struct sg_io_hdr
 					      or scatter gather list */
     unsigned char __user *cmdp; /* [i], [*i] points to command to perform */
     void __user *sbp;		/* [i], [*o] points to sense_buffer memory */
-    unsigned int timeout;       /* [i] MAX_UINT->no timeout (unit: millisec) */
+    unsigned int timeout __intentional_overflow(-1);       /* [i] MAX_UINT->no timeout (unit: millisec) */
     unsigned int flags;         /* [i] 0 -> default, see SG_FLAG... */
     int pack_id;                /* [i->o] unused internally (normally) */
     void __user * usr_ptr;      /* [i->o] unused internally */
diff --git a/include/sound/compress_driver.h b/include/sound/compress_driver.h
index cee8c00f3..0ee183479 100644
--- a/include/sound/compress_driver.h
+++ b/include/sound/compress_driver.h
@@ -132,7 +132,7 @@ struct snd_compr_ops {
 			struct snd_compr_caps *caps);
 	int (*get_codec_caps) (struct snd_compr_stream *stream,
 			struct snd_compr_codec_caps *codec);
-};
+} __no_const;
 
 /**
  * struct snd_compr: Compressed device
diff --git a/include/sound/control.h b/include/sound/control.h
index 21d047f22..957346247 100644
--- a/include/sound/control.h
+++ b/include/sound/control.h
@@ -214,8 +214,10 @@ int _snd_ctl_add_slave(struct snd_kcontrol *master, struct snd_kcontrol *slave,
  * Return: Zero if successful or a negative error code.
  */
 static inline int
-snd_ctl_add_slave(struct snd_kcontrol *master, struct snd_kcontrol *slave)
+snd_ctl_add_slave(void *_master, struct snd_kcontrol *slave)
 {
+	struct snd_kcontrol *master = _master;
+
 	return _snd_ctl_add_slave(master, slave, 0);
 }
 
diff --git a/include/sound/pcm.h b/include/sound/pcm.h
index af1fb37c6..043286329 100644
--- a/include/sound/pcm.h
+++ b/include/sound/pcm.h
@@ -1075,7 +1075,7 @@ int snd_pcm_update_state(struct snd_pcm_substream *substream,
 			 struct snd_pcm_runtime *runtime);
 int snd_pcm_update_hw_ptr(struct snd_pcm_substream *substream);
 void snd_pcm_playback_silence(struct snd_pcm_substream *substream, snd_pcm_uframes_t new_hw_ptr);
-void snd_pcm_period_elapsed(struct snd_pcm_substream *substream);
+void snd_pcm_period_elapsed(void *_substream);
 snd_pcm_sframes_t snd_pcm_lib_write(struct snd_pcm_substream *substream,
 				    const void __user *buf,
 				    snd_pcm_uframes_t frames);
diff --git a/include/sound/rawmidi.h b/include/sound/rawmidi.h
index f730b91e4..007954430 100644
--- a/include/sound/rawmidi.h
+++ b/include/sound/rawmidi.h
@@ -159,8 +159,7 @@ void snd_rawmidi_set_ops(struct snd_rawmidi *rmidi, int stream,
 
 /* callbacks */
 
-int snd_rawmidi_receive(struct snd_rawmidi_substream *substream,
-			const unsigned char *buffer, int count);
+int snd_rawmidi_receive(void *_substream, const void *_buffer, int count);
 int snd_rawmidi_transmit_empty(struct snd_rawmidi_substream *substream);
 int snd_rawmidi_transmit_peek(struct snd_rawmidi_substream *substream,
 			      unsigned char *buffer, int count);
diff --git a/include/sound/seq_kernel.h b/include/sound/seq_kernel.h
index feb58d455..9ce81c1da 100644
--- a/include/sound/seq_kernel.h
+++ b/include/sound/seq_kernel.h
@@ -80,7 +80,7 @@ int snd_seq_kernel_client_ctl(int client, unsigned int cmd, void *arg);
 #define SNDRV_SEQ_EXT_USRPTR	0x80000000
 #define SNDRV_SEQ_EXT_CHAINED	0x40000000
 
-typedef int (*snd_seq_dump_func_t)(void *ptr, void *buf, int count);
+typedef int (*snd_seq_dump_func_t)(void *ptr, const void *buf, int count);
 int snd_seq_expand_var_event(const struct snd_seq_event *event, int count, char *buf,
 			     int in_kernel, int size_aligned);
 int snd_seq_dump_var_event(const struct snd_seq_event *event,
diff --git a/include/sound/soc.h b/include/sound/soc.h
index 6144882cc..abe63c167 100644
--- a/include/sound/soc.h
+++ b/include/sound/soc.h
@@ -931,7 +931,7 @@ struct snd_soc_codec_driver {
 			     enum snd_soc_dapm_type, int);
 
 	bool ignore_pmdown_time;  /* Doesn't benefit from pmdown delay */
-};
+} __do_const;
 
 /* SoC platform interface */
 struct snd_soc_platform_driver {
@@ -958,7 +958,7 @@ struct snd_soc_platform_driver {
 	const struct snd_compr_ops *compr_ops;
 
 	int (*bespoke_trigger)(struct snd_pcm_substream *, int);
-};
+} __do_const;
 
 struct snd_soc_dai_link_component {
 	const char *name;
diff --git b/include/trace/events/fs.h b/include/trace/events/fs.h
new file mode 100644
index 000000000..fb634b74a
--- /dev/null
+++ b/include/trace/events/fs.h
@@ -0,0 +1,53 @@
+#undef TRACE_SYSTEM
+#define TRACE_SYSTEM fs
+
+#if !defined(_TRACE_FS_H) || defined(TRACE_HEADER_MULTI_READ)
+#define _TRACE_FS_H
+
+#include <linux/fs.h>
+#include <linux/tracepoint.h>
+
+TRACE_EVENT(do_sys_open,
+
+	TP_PROTO(const char *filename, int flags, int mode),
+
+	TP_ARGS(filename, flags, mode),
+
+	TP_STRUCT__entry(
+		__string(	filename, filename		)
+		__field(	int, flags			)
+		__field(	int, mode			)
+	),
+
+	TP_fast_assign(
+		__assign_str(filename, filename);
+		__entry->flags = flags;
+		__entry->mode = mode;
+	),
+
+	TP_printk("\"%s\" %x %o",
+		  __get_str(filename), __entry->flags, __entry->mode)
+);
+
+TRACE_EVENT(open_exec,
+
+	TP_PROTO(const char *filename),
+
+	TP_ARGS(filename),
+
+	TP_STRUCT__entry(
+		__string(	filename, filename		)
+	),
+
+	TP_fast_assign(
+		__assign_str(filename, filename);
+	),
+
+	TP_printk("\"%s\"",
+		  __get_str(filename))
+);
+
+#endif /* _TRACE_FS_H */
+
+/* This part must be outside protection */
+#include <trace/define_trace.h>
diff --git a/include/trace/events/irq.h b/include/trace/events/irq.h
index f95f25e78..87ed4488e 100644
--- a/include/trace/events/irq.h
+++ b/include/trace/events/irq.h
@@ -51,7 +51,7 @@ SOFTIRQ_NAME_LIST
  */
 TRACE_EVENT(irq_handler_entry,
 
-	TP_PROTO(int irq, struct irqaction *action),
+	TP_PROTO(int irq, const struct irqaction *action),
 
 	TP_ARGS(irq, action),
 
@@ -81,7 +81,7 @@ TRACE_EVENT(irq_handler_entry,
  */
 TRACE_EVENT(irq_handler_exit,
 
-	TP_PROTO(int irq, struct irqaction *action, int ret),
+	TP_PROTO(int irq, const struct irqaction *action, int ret),
 
 	TP_ARGS(irq, action, ret),
 
diff --git a/include/trace/events/mmflags.h b/include/trace/events/mmflags.h
index 5a81ab48a..7b68dc716 100644
--- a/include/trace/events/mmflags.h
+++ b/include/trace/events/mmflags.h
@@ -135,6 +135,12 @@ IF_HAVE_PG_IDLE(PG_idle,		"idle"		)
 #define IF_HAVE_VM_SOFTDIRTY(flag,name)
 #endif
 
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_X86_32)
+#define IF_HAVE_VM_PAGEEXEC(flag,name) {flag, name },
+#else
+#define IF_HAVE_VM_PAGEEXEC(flag,name)
+#endif
+
 #define __def_vmaflag_names						\
 	{VM_READ,			"read"		},		\
 	{VM_WRITE,			"write"		},		\
@@ -159,6 +165,7 @@ IF_HAVE_PG_IDLE(PG_idle,		"idle"		)
 	{VM_ACCOUNT,			"account"	},		\
 	{VM_NORESERVE,			"noreserve"	},		\
 	{VM_HUGETLB,			"hugetlb"	},		\
+IF_HAVE_VM_PAGEEXEC(VM_PAGEEXEC,	"pageexec"	)		\
 	__VM_ARCH_SPECIFIC_1				,		\
 	__VM_ARCH_SPECIFIC_2				,		\
 	{VM_DONTDUMP,			"dontdump"	},		\
diff --git a/include/uapi/linux/a.out.h b/include/uapi/linux/a.out.h
index 7caf44c7f..23c6f274a 100644
--- a/include/uapi/linux/a.out.h
+++ b/include/uapi/linux/a.out.h
@@ -39,6 +39,14 @@ enum machine_type {
   M_MIPS2 = 152		/* MIPS R6000/R4000 binary */
 };
 
+/* Constants for the N_FLAGS field */
+#define F_PAX_PAGEEXEC	1	/* Paging based non-executable pages */
+#define F_PAX_EMUTRAMP	2	/* Emulate trampolines */
+#define F_PAX_MPROTECT	4	/* Restrict mprotect() */
+#define F_PAX_RANDMMAP	8	/* Randomize mmap() base */
+/*#define F_PAX_RANDEXEC	16*/	/* Randomize ET_EXEC base */
+#define F_PAX_SEGMEXEC	32	/* Segmentation based non-executable pages */
+
 #if !defined (N_MAGIC)
 #define N_MAGIC(exec) ((exec).a_info & 0xffff)
 #endif
diff --git a/include/uapi/linux/bcache.h b/include/uapi/linux/bcache.h
index 22b6ad31c..aeba37ee6 100644
--- a/include/uapi/linux/bcache.h
+++ b/include/uapi/linux/bcache.h
@@ -5,6 +5,7 @@
  * Bcache on disk data structures
  */
 
+#include <linux/compiler.h>
 #include <asm/types.h>
 
 #define BITMASK(name, type, field, offset, size)		\
@@ -20,8 +21,8 @@ static inline void SET_##name(type *k, __u64 v)			\
 /* Btree keys - all units are in sectors */
 
 struct bkey {
-	__u64	high;
-	__u64	low;
+	__u64	high __intentional_overflow(-1);
+	__u64	low __intentional_overflow(-1);
 	__u64	ptr[];
 };
 
diff --git a/include/uapi/linux/byteorder/little_endian.h b/include/uapi/linux/byteorder/little_endian.h
index 4b93f2b26..ffa1302bc 100644
--- a/include/uapi/linux/byteorder/little_endian.h
+++ b/include/uapi/linux/byteorder/little_endian.h
@@ -42,51 +42,51 @@
 
 static __always_inline __le64 __cpu_to_le64p(const __u64 *p)
 {
-	return (__force __le64)*p;
+	return (__force const __le64)*p;
 }
-static __always_inline __u64 __le64_to_cpup(const __le64 *p)
+static __always_inline __u64 __intentional_overflow(-1) __le64_to_cpup(const __le64 *p)
 {
-	return (__force __u64)*p;
+	return (__force const __u64)*p;
 }
 static __always_inline __le32 __cpu_to_le32p(const __u32 *p)
 {
-	return (__force __le32)*p;
+	return (__force const __le32)*p;
 }
 static __always_inline __u32 __le32_to_cpup(const __le32 *p)
 {
-	return (__force __u32)*p;
+	return (__force const __u32)*p;
 }
 static __always_inline __le16 __cpu_to_le16p(const __u16 *p)
 {
-	return (__force __le16)*p;
+	return (__force const __le16)*p;
 }
 static __always_inline __u16 __le16_to_cpup(const __le16 *p)
 {
-	return (__force __u16)*p;
+	return (__force const __u16)*p;
 }
 static __always_inline __be64 __cpu_to_be64p(const __u64 *p)
 {
-	return (__force __be64)__swab64p(p);
+	return (__force const __be64)__swab64p(p);
 }
 static __always_inline __u64 __be64_to_cpup(const __be64 *p)
 {
-	return __swab64p((__u64 *)p);
+	return __swab64p((const __u64 *)p);
 }
 static __always_inline __be32 __cpu_to_be32p(const __u32 *p)
 {
-	return (__force __be32)__swab32p(p);
+	return (__force const __be32)__swab32p(p);
 }
-static __always_inline __u32 __be32_to_cpup(const __be32 *p)
+static __always_inline __u32 __intentional_overflow(-1) __be32_to_cpup(const __be32 *p)
 {
-	return __swab32p((__u32 *)p);
+	return __swab32p((const __u32 *)p);
 }
 static __always_inline __be16 __cpu_to_be16p(const __u16 *p)
 {
-	return (__force __be16)__swab16p(p);
+	return (__force const __be16)__swab16p(p);
 }
 static __always_inline __u16 __be16_to_cpup(const __be16 *p)
 {
-	return __swab16p((__u16 *)p);
+	return __swab16p((const __u16 *)p);
 }
 #define __cpu_to_le64s(x) do { (void)(x); } while (0)
 #define __le64_to_cpus(x) do { (void)(x); } while (0)
diff --git a/include/uapi/linux/connector.h b/include/uapi/linux/connector.h
index 4cb283505..cfbc4e28b 100644
--- a/include/uapi/linux/connector.h
+++ b/include/uapi/linux/connector.h
@@ -69,7 +69,7 @@ struct cb_id {
 struct cn_msg {
 	struct cb_id id;
 
-	__u32 seq;
+	__u32 seq __intentional_overflow(-1);
 	__u32 ack;
 
 	__u16 len;		/* Length of the following data */
diff --git a/include/uapi/linux/elf.h b/include/uapi/linux/elf.h
index b59ee077a..acfaf4ca1 100644
--- a/include/uapi/linux/elf.h
+++ b/include/uapi/linux/elf.h
@@ -37,6 +37,17 @@ typedef __s64	Elf64_Sxword;
 #define PT_GNU_EH_FRAME		0x6474e550
 
 #define PT_GNU_STACK	(PT_LOOS + 0x474e551)
+#define PT_GNU_RELRO	(PT_LOOS + 0x474e552)
+
+#define PT_PAX_FLAGS	(PT_LOOS + 0x5041580)
+
+/* Constants for the e_flags field */
+#define EF_PAX_PAGEEXEC		1	/* Paging based non-executable pages */
+#define EF_PAX_EMUTRAMP		2	/* Emulate trampolines */
+#define EF_PAX_MPROTECT		4	/* Restrict mprotect() */
+#define EF_PAX_RANDMMAP		8	/* Randomize mmap() base */
+/*#define EF_PAX_RANDEXEC		16*/	/* Randomize ET_EXEC base */
+#define EF_PAX_SEGMEXEC		32	/* Segmentation based non-executable pages */
 
 /*
  * Extended Numbering
@@ -94,6 +105,8 @@ typedef __s64	Elf64_Sxword;
 #define DT_DEBUG	21
 #define DT_TEXTREL	22
 #define DT_JMPREL	23
+#define DT_FLAGS	30
+  #define DF_TEXTREL  0x00000004
 #define DT_ENCODING	32
 #define OLD_DT_LOOS	0x60000000
 #define DT_LOOS		0x6000000d
@@ -240,6 +253,19 @@ typedef struct elf64_hdr {
 #define PF_W		0x2
 #define PF_X		0x1
 
+#define PF_PAGEEXEC	(1U << 4)	/* Enable  PAGEEXEC */
+#define PF_NOPAGEEXEC	(1U << 5)	/* Disable PAGEEXEC */
+#define PF_SEGMEXEC	(1U << 6)	/* Enable  SEGMEXEC */
+#define PF_NOSEGMEXEC	(1U << 7)	/* Disable SEGMEXEC */
+#define PF_MPROTECT	(1U << 8)	/* Enable  MPROTECT */
+#define PF_NOMPROTECT	(1U << 9)	/* Disable MPROTECT */
+/*#define PF_RANDEXEC	(1U << 10)*/	/* Enable  RANDEXEC */
+/*#define PF_NORANDEXEC	(1U << 11)*/	/* Disable RANDEXEC */
+#define PF_EMUTRAMP	(1U << 12)	/* Enable  EMUTRAMP */
+#define PF_NOEMUTRAMP	(1U << 13)	/* Disable EMUTRAMP */
+#define PF_RANDMMAP	(1U << 14)	/* Enable  RANDMMAP */
+#define PF_NORANDMMAP	(1U << 15)	/* Disable RANDMMAP */
+
 typedef struct elf32_phdr{
   Elf32_Word	p_type;
   Elf32_Off	p_offset;
@@ -335,6 +361,8 @@ typedef struct elf64_shdr {
 #define	EI_OSABI	7
 #define	EI_PAD		8
 
+#define	EI_PAX		14
+
 #define	ELFMAG0		0x7f		/* EI_MAG */
 #define	ELFMAG1		'E'
 #define	ELFMAG2		'L'
diff --git a/include/uapi/linux/personality.h b/include/uapi/linux/personality.h
index aa169c433..6a2771dbb 100644
--- a/include/uapi/linux/personality.h
+++ b/include/uapi/linux/personality.h
@@ -30,6 +30,7 @@ enum {
 #define PER_CLEAR_ON_SETID (READ_IMPLIES_EXEC  | \
 			    ADDR_NO_RANDOMIZE  | \
 			    ADDR_COMPAT_LAYOUT | \
+			    ADDR_LIMIT_3GB     | \
 			    MMAP_PAGE_ZERO)
 
 /*
diff --git a/include/uapi/linux/screen_info.h b/include/uapi/linux/screen_info.h
index 8b8d39dfb..1ca6c0795 100644
--- a/include/uapi/linux/screen_info.h
+++ b/include/uapi/linux/screen_info.h
@@ -44,7 +44,7 @@ struct screen_info {
 	__u16 vesa_attributes;	/* 0x34 */
 	__u32 capabilities;     /* 0x36 */
 	__u32 ext_lfb_base;	/* 0x3a */
-	__u8  _reserved[2];	/* 0x3e */
+	__u16 vesapm_size;	/* 0x3e */
 } __attribute__((packed));
 
 #define VIDEO_TYPE_MDA		0x10	/* Monochrome Text Display	*/
diff --git a/include/uapi/linux/swab.h b/include/uapi/linux/swab.h
index 8f3a8f606..736a5428e 100644
--- a/include/uapi/linux/swab.h
+++ b/include/uapi/linux/swab.h
@@ -43,7 +43,7 @@
  * ___swab16, ___swab32, ___swab64, ___swahw32, ___swahb32
  */
 
-static inline __attribute_const__ __u16 __fswab16(__u16 val)
+static inline __intentional_overflow(0) __attribute_const__ __u16 __fswab16(__u16 val)
 {
 #if defined (__arch_swab16)
 	return __arch_swab16(val);
@@ -52,7 +52,7 @@ static inline __attribute_const__ __u16 __fswab16(__u16 val)
 #endif
 }
 
-static inline __attribute_const__ __u32 __fswab32(__u32 val)
+static inline __intentional_overflow(0) __attribute_const__ __u32 __fswab32(__u32 val)
 {
 #if defined(__arch_swab32)
 	return __arch_swab32(val);
@@ -61,7 +61,7 @@ static inline __attribute_const__ __u32 __fswab32(__u32 val)
 #endif
 }
 
-static inline __attribute_const__ __u64 __fswab64(__u64 val)
+static inline __intentional_overflow(0) __attribute_const__ __u64 __fswab64(__u64 val)
 {
 #if defined (__arch_swab64)
 	return __arch_swab64(val);
diff --git a/include/uapi/linux/xattr.h b/include/uapi/linux/xattr.h
index 1590c49ca..6977e11c1 100644
--- a/include/uapi/linux/xattr.h
+++ b/include/uapi/linux/xattr.h
@@ -73,5 +73,10 @@
 #define XATTR_POSIX_ACL_DEFAULT  "posix_acl_default"
 #define XATTR_NAME_POSIX_ACL_DEFAULT XATTR_SYSTEM_PREFIX XATTR_POSIX_ACL_DEFAULT
 
+/* User namespace */
+#define XATTR_PAX_PREFIX "pax."
+#define XATTR_PAX_FLAGS_SUFFIX "flags"
+#define XATTR_NAME_USER_PAX_FLAGS XATTR_USER_PREFIX XATTR_PAX_PREFIX XATTR_PAX_FLAGS_SUFFIX
+#define XATTR_NAME_PAX_FLAGS XATTR_PAX_PREFIX XATTR_PAX_FLAGS_SUFFIX
 
 #endif /* _UAPI_LINUX_XATTR_H */
diff --git a/include/video/udlfb.h b/include/video/udlfb.h
index f9466fa54..f4e2b818f 100644
--- a/include/video/udlfb.h
+++ b/include/video/udlfb.h
@@ -53,10 +53,10 @@ struct dlfb_data {
 	u32 pseudo_palette[256];
 	int blank_mode; /*one of FB_BLANK_ */
 	/* blit-only rendering path metrics, exposed through sysfs */
-	atomic_t bytes_rendered; /* raw pixel-bytes driver asked to render */
-	atomic_t bytes_identical; /* saved effort with backbuffer comparison */
-	atomic_t bytes_sent; /* to usb, after compression including overhead */
-	atomic_t cpu_kcycles_used; /* transpired during pixel processing */
+	atomic_unchecked_t bytes_rendered; /* raw pixel-bytes driver asked to render */
+	atomic_unchecked_t bytes_identical; /* saved effort with backbuffer comparison */
+	atomic_unchecked_t bytes_sent; /* to usb, after compression including overhead */
+	atomic_unchecked_t cpu_kcycles_used; /* transpired during pixel processing */
 };
 
 #define NR_USB_REQUEST_I2C_SUB_IO 0x02
diff --git a/include/video/uvesafb.h b/include/video/uvesafb.h
index 30f536254..8ed8ac982 100644
--- a/include/video/uvesafb.h
+++ b/include/video/uvesafb.h
@@ -122,6 +122,7 @@ struct uvesafb_par {
 	u8 ypan;			/* 0 - nothing, 1 - ypan, 2 - ywrap */
 	u8 pmi_setpal;			/* PMI for palette changes */
 	u16 *pmi_base;			/* protected mode interface location */
+	u8 *pmi_code;			/* protected mode code location */
 	void *pmi_start;
 	void *pmi_pal;
 	u8 *vbe_state_orig;		/*
diff --git a/init/Kconfig b/init/Kconfig
index cac3f0960..fcf4fa4f9 100644
--- a/init/Kconfig
+++ b/init/Kconfig
@@ -31,6 +31,9 @@ menu "General setup"
 config BROKEN
 	bool
 
+config BROKEN_SECURITY
+	bool
+
 config BROKEN_ON_SMP
 	bool
 	depends on BROKEN || !SMP
@@ -288,7 +291,8 @@ config FHANDLE
 
 config USELIB
 	bool "uselib syscall"
-	def_bool ALPHA || M68K || SPARC || X86_32 || IA32_EMULATION
+	default n
+	depends on !GRKERNSEC
 	help
 	  This option enables the uselib syscall, a system call used in the
 	  dynamic linker from libc5 and earlier.  glibc does not use this
@@ -632,6 +636,7 @@ config RCU_FAST_NO_HZ
 config TREE_RCU_TRACE
 	def_bool RCU_TRACE && ( TREE_RCU || PREEMPT_RCU )
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	help
 	  This option provides tracing for the TREE_RCU and
 	  PREEMPT_RCU implementations, permitting Makefile to
@@ -1158,6 +1163,7 @@ endif # CGROUPS
 config CHECKPOINT_RESTORE
 	bool "Checkpoint/restore support" if EXPERT
 	select PROC_CHILDREN
+	depends on !GRKERNSEC
 	default n
 	help
 	  Enables additional kernel features in a sake of checkpoint/restore.
@@ -1630,7 +1636,7 @@ config ADVISE_SYSCALLS
 config USERFAULTFD
 	bool "Enable userfaultfd() system call"
 	select ANON_INODES
-	depends on MMU
+	depends on MMU && !GRKERNSEC
 	help
 	  Enable the userfaultfd() system call that allows to intercept and
 	  handle page faults in userland.
@@ -1743,7 +1749,7 @@ config SLUB_DEBUG
 
 config COMPAT_BRK
 	bool "Disable heap randomization"
-	default y
+	default n
 	help
 	  Randomizing heap placement makes heap exploits harder, but it
 	  also breaks ancient binaries (including anything libc5 based).
@@ -1761,7 +1767,6 @@ choice
 
 config SLAB
 	bool "SLAB"
-	select HAVE_HARDENED_USERCOPY_ALLOCATOR
 	help
 	  The regular slab allocator that is established and known to work
 	  well in all environments. It organizes cache hot objects in
@@ -1769,7 +1774,6 @@ config SLAB
 
 config SLUB
 	bool "SLUB (Unqueued Allocator)"
-	select HAVE_HARDENED_USERCOPY_ALLOCATOR
 	help
 	   SLUB is a slab allocator that minimizes cache line usage
 	   instead of managing queues of cached objects (SLAB approach).
diff --git a/init/do_mounts.c b/init/do_mounts.c
index dea5de95c..497f996d8 100644
--- a/init/do_mounts.c
+++ b/init/do_mounts.c
@@ -363,11 +363,11 @@ static void __init get_fs_names(char *page)
 static int __init do_mount_root(char *name, char *fs, int flags, void *data)
 {
 	struct super_block *s;
-	int err = sys_mount(name, "/root", fs, flags, data);
+	int err = sys_mount((char __force_user *)name, (char __force_user *)"/root", (char __force_user *)fs, flags, (void __force_user *)data);
 	if (err)
 		return err;
 
-	sys_chdir("/root");
+	sys_chdir((const char __force_user *)"/root");
 	s = current->fs->pwd.dentry->d_sb;
 	ROOT_DEV = s->s_dev;
 	printk(KERN_INFO
@@ -490,18 +490,18 @@ void __init change_floppy(char *fmt, ...)
 	va_start(args, fmt);
 	vsprintf(buf, fmt, args);
 	va_end(args);
-	fd = sys_open("/dev/root", O_RDWR | O_NDELAY, 0);
+	fd = sys_open((char __user *)"/dev/root", O_RDWR | O_NDELAY, 0);
 	if (fd >= 0) {
 		sys_ioctl(fd, FDEJECT, 0);
 		sys_close(fd);
 	}
 	printk(KERN_NOTICE "VFS: Insert %s and press ENTER\n", buf);
-	fd = sys_open("/dev/console", O_RDWR, 0);
+	fd = sys_open((__force const char __user *)"/dev/console", O_RDWR, 0);
 	if (fd >= 0) {
 		sys_ioctl(fd, TCGETS, (long)&termios);
 		termios.c_lflag &= ~ICANON;
 		sys_ioctl(fd, TCSETSF, (long)&termios);
-		sys_read(fd, &c, 1);
+		sys_read(fd, (char __user *)&c, 1);
 		termios.c_lflag |= ICANON;
 		sys_ioctl(fd, TCSETSF, (long)&termios);
 		sys_close(fd);
@@ -600,8 +600,8 @@ void __init prepare_namespace(void)
 	mount_root();
 out:
 	devtmpfs_mount("dev");
-	sys_mount(".", "/", NULL, MS_MOVE, NULL);
-	sys_chroot(".");
+	sys_mount((char __force_user *)".", (char __force_user *)"/", NULL, MS_MOVE, NULL);
+	sys_chroot((const char __force_user *)".");
 }
 
 static bool is_tmpfs;
@@ -609,7 +609,7 @@ static struct dentry *rootfs_mount(struct file_system_type *fs_type,
 	int flags, const char *dev_name, void *data)
 {
 	static unsigned long once;
-	void *fill = ramfs_fill_super;
+	int (*fill)(struct super_block *, void *, int) = ramfs_fill_super;
 
 	if (test_and_set_bit(0, &once))
 		return ERR_PTR(-ENODEV);
diff --git a/init/do_mounts.h b/init/do_mounts.h
index 067af1d9e..b535547af 100644
--- a/init/do_mounts.h
+++ b/init/do_mounts.h
@@ -15,15 +15,15 @@ extern int root_mountflags;
 
 static inline int create_dev(char *name, dev_t dev)
 {
-	sys_unlink(name);
-	return sys_mknod(name, S_IFBLK|0600, new_encode_dev(dev));
+	sys_unlink((char __force_user *)name);
+	return sys_mknod((char __force_user *)name, S_IFBLK|0600, new_encode_dev(dev));
 }
 
 #if BITS_PER_LONG == 32
 static inline u32 bstat(char *name)
 {
 	struct stat64 stat;
-	if (sys_stat64(name, &stat) != 0)
+	if (sys_stat64((char __force_user *)name, (struct stat64 __force_user *)&stat) != 0)
 		return 0;
 	if (!S_ISBLK(stat.st_mode))
 		return 0;
@@ -35,7 +35,7 @@ static inline u32 bstat(char *name)
 static inline u32 bstat(char *name)
 {
 	struct stat stat;
-	if (sys_newstat(name, &stat) != 0)
+	if (sys_newstat((const char __force_user *)name, (struct stat __force_user *)&stat) != 0)
 		return 0;
 	if (!S_ISBLK(stat.st_mode))
 		return 0;
diff --git a/init/do_mounts_initrd.c b/init/do_mounts_initrd.c
index a1000ca29..3137150b2 100644
--- a/init/do_mounts_initrd.c
+++ b/init/do_mounts_initrd.c
@@ -37,13 +37,13 @@ static int init_linuxrc(struct subprocess_info *info, struct cred *new)
 {
 	sys_unshare(CLONE_FS | CLONE_FILES);
 	/* stdin/stdout/stderr for /linuxrc */
-	sys_open("/dev/console", O_RDWR, 0);
+	sys_open((const char __force_user *)"/dev/console", O_RDWR, 0);
 	sys_dup(0);
 	sys_dup(0);
 	/* move initrd over / and chdir/chroot in initrd root */
-	sys_chdir("/root");
-	sys_mount(".", "/", NULL, MS_MOVE, NULL);
-	sys_chroot(".");
+	sys_chdir((const char __force_user *)"/root");
+	sys_mount((char __force_user *)".", (char __force_user *)"/", NULL, MS_MOVE, NULL);
+	sys_chroot((const char __force_user *)".");
 	sys_setsid();
 	return 0;
 }
@@ -59,8 +59,8 @@ static void __init handle_initrd(void)
 	create_dev("/dev/root.old", Root_RAM0);
 	/* mount initrd on rootfs' /root */
 	mount_block_root("/dev/root.old", root_mountflags & ~MS_RDONLY);
-	sys_mkdir("/old", 0700);
-	sys_chdir("/old");
+	sys_mkdir((const char __force_user *)"/old", 0700);
+	sys_chdir((const char __force_user *)"/old");
 
 	/* try loading default modules from initrd */
 	load_default_modules();
@@ -80,31 +80,31 @@ static void __init handle_initrd(void)
 	current->flags &= ~PF_FREEZER_SKIP;
 
 	/* move initrd to rootfs' /old */
-	sys_mount("..", ".", NULL, MS_MOVE, NULL);
+	sys_mount((char __force_user *)"..", (char __force_user *)".", NULL, MS_MOVE, NULL);
 	/* switch root and cwd back to / of rootfs */
-	sys_chroot("..");
+	sys_chroot((const char __force_user *)"..");
 
 	if (new_decode_dev(real_root_dev) == Root_RAM0) {
-		sys_chdir("/old");
+		sys_chdir((const char __force_user *)"/old");
 		return;
 	}
 
-	sys_chdir("/");
+	sys_chdir((const char __force_user *)"/");
 	ROOT_DEV = new_decode_dev(real_root_dev);
 	mount_root();
 
 	printk(KERN_NOTICE "Trying to move old root to /initrd ... ");
-	error = sys_mount("/old", "/root/initrd", NULL, MS_MOVE, NULL);
+	error = sys_mount((char __force_user *)"/old", (char __force_user *)"/root/initrd", NULL, MS_MOVE, NULL);
 	if (!error)
 		printk("okay\n");
 	else {
-		int fd = sys_open("/dev/root.old", O_RDWR, 0);
+		int fd = sys_open((const char __force_user *)"/dev/root.old", O_RDWR, 0);
 		if (error == -ENOENT)
 			printk("/initrd does not exist. Ignored.\n");
 		else
 			printk("failed\n");
 		printk(KERN_NOTICE "Unmounting old root\n");
-		sys_umount("/old", MNT_DETACH);
+		sys_umount((char __force_user *)"/old", MNT_DETACH);
 		printk(KERN_NOTICE "Trying to free ramdisk memory ... ");
 		if (fd < 0) {
 			error = fd;
@@ -127,11 +127,11 @@ bool __init initrd_load(void)
 		 * mounted in the normal path.
 		 */
 		if (rd_load_image("/initrd.image") && ROOT_DEV != Root_RAM0) {
-			sys_unlink("/initrd.image");
+			sys_unlink((const char __force_user *)"/initrd.image");
 			handle_initrd();
 			return true;
 		}
 	}
-	sys_unlink("/initrd.image");
+	sys_unlink((const char __force_user *)"/initrd.image");
 	return false;
 }
diff --git a/init/do_mounts_md.c b/init/do_mounts_md.c
index 8cb6db542..d729f501b 100644
--- a/init/do_mounts_md.c
+++ b/init/do_mounts_md.c
@@ -180,7 +180,7 @@ static void __init md_setup_drive(void)
 			partitioned ? "_d" : "", minor,
 			md_setup_args[ent].device_names);
 
-		fd = sys_open(name, 0, 0);
+		fd = sys_open((char __force_user *)name, 0, 0);
 		if (fd < 0) {
 			printk(KERN_ERR "md: open failed - cannot start "
 					"array %s\n", name);
@@ -243,7 +243,7 @@ static void __init md_setup_drive(void)
 			 * array without it
 			 */
 			sys_close(fd);
-			fd = sys_open(name, 0, 0);
+			fd = sys_open((char __force_user *)name, 0, 0);
 			sys_ioctl(fd, BLKRRPART, 0);
 		}
 		sys_close(fd);
@@ -293,7 +293,7 @@ static void __init autodetect_raid(void)
 
 	wait_for_device_probe();
 
-	fd = sys_open("/dev/md0", 0, 0);
+	fd = sys_open((const char __force_user *) "/dev/md0", 0, 0);
 	if (fd >= 0) {
 		sys_ioctl(fd, RAID_AUTORUN, raid_autopart);
 		sys_close(fd);
diff --git a/init/init_task.c b/init/init_task.c
index ba0a7f362..a7b3aaa74 100644
--- a/init/init_task.c
+++ b/init/init_task.c
@@ -23,4 +23,8 @@ EXPORT_SYMBOL(init_task);
  * linker map entry.
  */
 union thread_union init_thread_union __init_task_data =
+#ifdef CONFIG_X86
+	{ .stack[0] = ~0xabcd1234, };
+#else
 	{ INIT_THREAD_INFO(init_task) };
+#endif
diff --git a/init/initramfs.c b/init/initramfs.c
index b32ad7d97..05f642080 100644
--- a/init/initramfs.c
+++ b/init/initramfs.c
@@ -25,7 +25,7 @@ static ssize_t __init xwrite(int fd, const char *p, size_t count)
 
 	/* sys_write only can write MAX_RW_COUNT aka 2G-4K bytes at most */
 	while (count) {
-		ssize_t rv = sys_write(fd, p, count);
+		ssize_t rv = sys_write(fd, (char __force_user *)p, count);
 
 		if (rv < 0) {
 			if (rv == -EINTR || rv == -EAGAIN)
@@ -107,7 +107,7 @@ static void __init free_hash(void)
 	}
 }
 
-static long __init do_utime(char *filename, time_t mtime)
+static long __init do_utime(char __force_user *filename, time_t mtime)
 {
 	struct timespec t[2];
 
@@ -142,7 +142,7 @@ static void __init dir_utime(void)
 	struct dir_entry *de, *tmp;
 	list_for_each_entry_safe(de, tmp, &dir_list, list) {
 		list_del(&de->list);
-		do_utime(de->name, de->mtime);
+		do_utime((char __force_user *)de->name, de->mtime);
 		kfree(de->name);
 		kfree(de);
 	}
@@ -304,7 +304,7 @@ static int __init maybe_link(void)
 	if (nlink >= 2) {
 		char *old = find_link(major, minor, ino, mode, collected);
 		if (old)
-			return (sys_link(old, collected) < 0) ? -1 : 1;
+			return (sys_link((char __force_user *)old, (char __force_user *)collected) < 0) ? -1 : 1;
 	}
 	return 0;
 }
@@ -313,11 +313,11 @@ static void __init clean_path(char *path, umode_t fmode)
 {
 	struct stat st;
 
-	if (!sys_newlstat(path, &st) && (st.st_mode ^ fmode) & S_IFMT) {
+	if (!sys_newlstat((char __force_user *)path, (struct stat __force_user *)&st) && (st.st_mode ^ fmode) & S_IFMT) {
 		if (S_ISDIR(st.st_mode))
-			sys_rmdir(path);
+			sys_rmdir((char __force_user *)path);
 		else
-			sys_unlink(path);
+			sys_unlink((char __force_user *)path);
 	}
 }
 
@@ -338,7 +338,7 @@ static int __init do_name(void)
 			int openflags = O_WRONLY|O_CREAT;
 			if (ml != 1)
 				openflags |= O_TRUNC;
-			wfd = sys_open(collected, openflags, mode);
+			wfd = sys_open((char __force_user *)collected, openflags, mode);
 
 			if (wfd >= 0) {
 				sys_fchown(wfd, uid, gid);
@@ -350,17 +350,17 @@ static int __init do_name(void)
 			}
 		}
 	} else if (S_ISDIR(mode)) {
-		sys_mkdir(collected, mode);
-		sys_chown(collected, uid, gid);
-		sys_chmod(collected, mode);
+		sys_mkdir((char __force_user *)collected, mode);
+		sys_chown((char __force_user *)collected, uid, gid);
+		sys_chmod((char __force_user *)collected, mode);
 		dir_add(collected, mtime);
 	} else if (S_ISBLK(mode) || S_ISCHR(mode) ||
 		   S_ISFIFO(mode) || S_ISSOCK(mode)) {
 		if (maybe_link() == 0) {
-			sys_mknod(collected, mode, rdev);
-			sys_chown(collected, uid, gid);
-			sys_chmod(collected, mode);
-			do_utime(collected, mtime);
+			sys_mknod((char __force_user *)collected, mode, rdev);
+			sys_chown((char __force_user *)collected, uid, gid);
+			sys_chmod((char __force_user *)collected, mode);
+			do_utime((char __force_user *)collected, mtime);
 		}
 	}
 	return 0;
@@ -372,7 +372,7 @@ static int __init do_copy(void)
 		if (xwrite(wfd, victim, body_len) != body_len)
 			error("write error");
 		sys_close(wfd);
-		do_utime(vcollected, mtime);
+		do_utime((char __force_user *)vcollected, mtime);
 		kfree(vcollected);
 		eat(body_len);
 		state = SkipIt;
@@ -390,9 +390,9 @@ static int __init do_symlink(void)
 {
 	collected[N_ALIGN(name_len) + body_len] = '\0';
 	clean_path(collected, 0);
-	sys_symlink(collected + N_ALIGN(name_len), collected);
-	sys_lchown(collected, uid, gid);
-	do_utime(collected, mtime);
+	sys_symlink((char __force_user *)collected + N_ALIGN(name_len), (char __force_user *)collected);
+	sys_lchown((char __force_user *)collected, uid, gid);
+	do_utime((char __force_user *)collected, mtime);
 	state = SkipIt;
 	next_state = Reset;
 	return 0;
diff --git a/init/main.c b/init/main.c
index a8a58e279..75fba2eba 100644
--- a/init/main.c
+++ b/init/main.c
@@ -11,6 +11,10 @@
 
 #define DEBUG		/* Enable initcall_debug */
 
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+#define __INCLUDED_BY_HIDESYM 1
+#endif
+
 #include <linux/types.h>
 #include <linux/module.h>
 #include <linux/proc_fs.h>
@@ -94,6 +98,8 @@ extern void init_IRQ(void);
 extern void fork_init(void);
 extern void radix_tree_init(void);
 
+extern void grsecurity_init(void);
+
 /*
  * Debug helper: via this flag we know that we are in 'early bootup code'
  * where only the boot processor is running with IRQ disabled.  This means
@@ -155,6 +161,48 @@ static int __init set_reset_devices(char *str)
 
 __setup("reset_devices", set_reset_devices);
 
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+kgid_t grsec_proc_gid = KGIDT_INIT(CONFIG_GRKERNSEC_PROC_GID);
+static int __init setup_grsec_proc_gid(char *str)
+{
+	grsec_proc_gid = KGIDT_INIT(simple_strtol(str, NULL, 0));
+	return 1;
+}
+__setup("grsec_proc_gid=", setup_grsec_proc_gid);
+#endif
+#ifdef CONFIG_GRKERNSEC_SYSFS_RESTRICT
+int grsec_enable_sysfs_restrict = 1;
+static int __init setup_grsec_sysfs_restrict(char *str)
+{
+	if (!simple_strtol(str, NULL, 0))
+		grsec_enable_sysfs_restrict = 0;
+	return 1;
+}
+__setup("grsec_sysfs_restrict", setup_grsec_sysfs_restrict);
+#endif
+
+#ifdef CONFIG_PAX_SOFTMODE
+int pax_softmode;
+
+static int __init setup_pax_softmode(char *str)
+{
+	get_option(&str, &pax_softmode);
+	return 1;
+}
+__setup("pax_softmode=", setup_pax_softmode);
+#endif
+
+#ifdef CONFIG_PAX_SIZE_OVERFLOW
+bool pax_size_overflow_report_only __read_only;
+
+static int __init setup_pax_size_overflow_report_only(char *str)
+{
+	pax_size_overflow_report_only = true;
+	return 0;
+}
+early_param("pax_size_overflow_report_only", setup_pax_size_overflow_report_only);
+#endif
+
 static const char *argv_init[MAX_INIT_ARGS+2] = { "init", NULL, };
 const char *envp_init[MAX_INIT_ENVS+2] = { "HOME=/", "TERM=linux", NULL, };
 static const char *panic_later, *panic_param;
@@ -767,7 +815,7 @@ int __init_or_module do_one_initcall(initcall_t fn)
 {
 	int count = preempt_count();
 	int ret;
-	char msgbuf[64];
+	const char *msg1 = "", *msg2 = "";
 
 	if (initcall_blacklisted(fn))
 		return -EPERM;
@@ -777,18 +825,17 @@ int __init_or_module do_one_initcall(initcall_t fn)
 	else
 		ret = fn();
 
-	msgbuf[0] = 0;
-
 	if (preempt_count() != count) {
-		sprintf(msgbuf, "preemption imbalance ");
+		msg1 = " preemption imbalance";
 		preempt_count_set(count);
 	}
 	if (irqs_disabled()) {
-		strlcat(msgbuf, "disabled interrupts ", sizeof(msgbuf));
+		msg2 = " disabled interrupts";
 		local_irq_enable();
 	}
-	WARN(msgbuf[0], "initcall %pF returned with %s\n", fn, msgbuf);
+	WARN(*msg1 || *msg2, "initcall %pF returned with%s%s\n", fn, msg1, msg2);
 
+	add_latent_entropy();
 	return ret;
 }
 
@@ -893,8 +940,8 @@ static int run_init_process(const char *init_filename)
 {
 	argv_init[0] = init_filename;
 	return do_execve(getname_kernel(init_filename),
-		(const char __user *const __user *)argv_init,
-		(const char __user *const __user *)envp_init);
+		(const char __user *const __force_user *)argv_init,
+		(const char __user *const __force_user *)envp_init);
 }
 
 static int try_to_run_init_process(const char *init_filename)
@@ -911,6 +958,10 @@ static int try_to_run_init_process(const char *init_filename)
 	return ret;
 }
 
+#ifdef CONFIG_GRKERNSEC_CHROOT_INITRD
+extern int gr_init_ran;
+#endif
+
 static noinline void __init kernel_init_freeable(void);
 
 #ifdef CONFIG_DEBUG_RODATA
@@ -959,6 +1010,11 @@ static int __ref kernel_init(void *unused)
 		       ramdisk_execute_command, ret);
 	}
 
+#ifdef CONFIG_GRKERNSEC_CHROOT_INITRD
+	/* if no initrd was used, be extra sure we enforce chroot restrictions */
+	gr_init_ran = 1;
+#endif
+
 	/*
 	 * We try each of these until one succeeds.
 	 *
@@ -1016,7 +1072,7 @@ static noinline void __init kernel_init_freeable(void)
 	do_basic_setup();
 
 	/* Open the /dev/console on the rootfs, this should never fail */
-	if (sys_open((const char __user *) "/dev/console", O_RDWR, 0) < 0)
+	if (sys_open((const char __force_user *) "/dev/console", O_RDWR, 0) < 0)
 		pr_err("Warning: unable to open an initial console.\n");
 
 	(void) sys_dup(0);
@@ -1029,11 +1085,13 @@ static noinline void __init kernel_init_freeable(void)
 	if (!ramdisk_execute_command)
 		ramdisk_execute_command = "/init";
 
-	if (sys_access((const char __user *) ramdisk_execute_command, 0) != 0) {
+	if (sys_access((const char __force_user *) ramdisk_execute_command, 0) != 0) {
 		ramdisk_execute_command = NULL;
 		prepare_namespace();
 	}
 
+	grsecurity_init();
+
 	/*
 	 * Ok, we have completed the initial bootup, and
 	 * we're essentially up and running. Get rid of the
diff --git a/ipc/compat.c b/ipc/compat.c
index 9b3c85f8a..5266b0f87 100644
--- a/ipc/compat.c
+++ b/ipc/compat.c
@@ -396,7 +396,7 @@ COMPAT_SYSCALL_DEFINE6(ipc, u32, call, int, first, int, second,
 			       COMPAT_SHMLBA);
 		if (err < 0)
 			return err;
-		return put_user(raddr, (compat_ulong_t *)compat_ptr(third));
+		return put_user(raddr, (compat_ulong_t __user *)compat_ptr(third));
 	}
 	case SHMDT:
 		return sys_shmdt(compat_ptr(ptr));
@@ -747,7 +747,7 @@ COMPAT_SYSCALL_DEFINE3(shmctl, int, first, int, second, void __user *, uptr)
 }
 
 COMPAT_SYSCALL_DEFINE4(semtimedop, int, semid, struct sembuf __user *, tsems,
-		       unsigned, nsops,
+		       compat_long_t, nsops,
 		       const struct compat_timespec __user *, timeout)
 {
 	struct timespec __user *ts64;
diff --git a/ipc/ipc_sysctl.c b/ipc/ipc_sysctl.c
index 8ad93c29f..54036e1f2 100644
--- a/ipc/ipc_sysctl.c
+++ b/ipc/ipc_sysctl.c
@@ -30,7 +30,7 @@ static void *get_ipc(struct ctl_table *table)
 static int proc_ipc_dointvec(struct ctl_table *table, int write,
 	void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table ipc_table;
+	ctl_table_no_const ipc_table;
 
 	memcpy(&ipc_table, table, sizeof(ipc_table));
 	ipc_table.data = get_ipc(table);
@@ -41,7 +41,7 @@ static int proc_ipc_dointvec(struct ctl_table *table, int write,
 static int proc_ipc_dointvec_minmax(struct ctl_table *table, int write,
 	void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table ipc_table;
+	ctl_table_no_const ipc_table;
 
 	memcpy(&ipc_table, table, sizeof(ipc_table));
 	ipc_table.data = get_ipc(table);
@@ -65,7 +65,7 @@ static int proc_ipc_dointvec_minmax_orphans(struct ctl_table *table, int write,
 static int proc_ipc_doulongvec_minmax(struct ctl_table *table, int write,
 	void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table ipc_table;
+	ctl_table_no_const ipc_table;
 	memcpy(&ipc_table, table, sizeof(ipc_table));
 	ipc_table.data = get_ipc(table);
 
@@ -76,7 +76,7 @@ static int proc_ipc_doulongvec_minmax(struct ctl_table *table, int write,
 static int proc_ipc_auto_msgmni(struct ctl_table *table, int write,
 	void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table ipc_table;
+	ctl_table_no_const ipc_table;
 	int dummy = 0;
 
 	memcpy(&ipc_table, table, sizeof(ipc_table));
@@ -99,6 +99,8 @@ static int proc_ipc_auto_msgmni(struct ctl_table *table, int write,
 static int zero;
 static int one = 1;
 static int int_max = INT_MAX;
+static unsigned long long_zero = 0;
+static unsigned long long_max = LONG_MAX;
 
 static struct ctl_table ipc_kern_table[] = {
 	{
@@ -107,6 +109,8 @@ static struct ctl_table ipc_kern_table[] = {
 		.maxlen		= sizeof(init_ipc_ns.shm_ctlmax),
 		.mode		= 0644,
 		.proc_handler	= proc_ipc_doulongvec_minmax,
+		.extra1		= &long_zero,
+		.extra2		= &long_max,
 	},
 	{
 		.procname	= "shmall",
@@ -114,6 +118,8 @@ static struct ctl_table ipc_kern_table[] = {
 		.maxlen		= sizeof(init_ipc_ns.shm_ctlall),
 		.mode		= 0644,
 		.proc_handler	= proc_ipc_doulongvec_minmax,
+		.extra1		= &long_zero,
+		.extra2		= &long_max,
 	},
 	{
 		.procname	= "shmmni",
diff --git a/ipc/mq_sysctl.c b/ipc/mq_sysctl.c
index 68d4e9537..1477dedfe 100644
--- a/ipc/mq_sysctl.c
+++ b/ipc/mq_sysctl.c
@@ -25,7 +25,7 @@ static void *get_mq(struct ctl_table *table)
 static int proc_mq_dointvec(struct ctl_table *table, int write,
 			    void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table mq_table;
+	ctl_table_no_const mq_table;
 	memcpy(&mq_table, table, sizeof(mq_table));
 	mq_table.data = get_mq(table);
 
@@ -35,7 +35,7 @@ static int proc_mq_dointvec(struct ctl_table *table, int write,
 static int proc_mq_dointvec_minmax(struct ctl_table *table, int write,
 	void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table mq_table;
+	ctl_table_no_const mq_table;
 	memcpy(&mq_table, table, sizeof(mq_table));
 	mq_table.data = get_mq(table);
 
diff --git a/ipc/mqueue.c b/ipc/mqueue.c
index 0b13ace26..2b586ea2f 100644
--- a/ipc/mqueue.c
+++ b/ipc/mqueue.c
@@ -274,6 +274,7 @@ static struct inode *mqueue_get_inode(struct super_block *sb,
 		mq_bytes = mq_treesize + (info->attr.mq_maxmsg *
 					  info->attr.mq_msgsize);
 
+		gr_learn_resource(current, RLIMIT_MSGQUEUE, u->mq_bytes + mq_bytes, 1);
 		spin_lock(&mq_lock);
 		if (u->mq_bytes + mq_bytes < u->mq_bytes ||
 		    u->mq_bytes + mq_bytes > rlimit(RLIMIT_MSGQUEUE)) {
diff --git a/ipc/msg.c b/ipc/msg.c
index c6521c205..4e2379d2f 100644
--- a/ipc/msg.c
+++ b/ipc/msg.c
@@ -1041,7 +1041,8 @@ void msg_exit_ns(struct ipc_namespace *ns)
 static int sysvipc_msg_proc_show(struct seq_file *s, void *it)
 {
 	struct user_namespace *user_ns = seq_user_ns(s);
-	struct msg_queue *msq = it;
+	struct kern_ipc_perm *perm = it;
+	struct msg_queue *msq = container_of(perm, struct msg_queue, q_perm);
 
 	seq_printf(s,
 		   "%10d %10d  %4o  %10lu %10lu %5u %5u %5u %5u %5u %5u %10lu %10lu %10lu\n",
diff --git a/ipc/msgutil.c b/ipc/msgutil.c
index a521999de..6259e10c4 100644
--- a/ipc/msgutil.c
+++ b/ipc/msgutil.c
@@ -53,7 +53,7 @@ static struct msg_msg *alloc_msg(size_t len)
 	size_t alen;
 
 	alen = min(len, DATALEN_MSG);
-	msg = kmalloc(sizeof(*msg) + alen, GFP_KERNEL);
+	msg = kmalloc(sizeof(*msg) + alen, GFP_KERNEL|GFP_USERCOPY);
 	if (msg == NULL)
 		return NULL;
 
@@ -65,7 +65,7 @@ static struct msg_msg *alloc_msg(size_t len)
 	while (len > 0) {
 		struct msg_msgseg *seg;
 		alen = min(len, DATALEN_SEG);
-		seg = kmalloc(sizeof(*seg) + alen, GFP_KERNEL);
+		seg = kmalloc(sizeof(*seg) + alen, GFP_KERNEL|GFP_USERCOPY);
 		if (seg == NULL)
 			goto out_err;
 		*pseg = seg;
diff --git a/ipc/sem.c b/ipc/sem.c
index 5e318c5f7..235b6b07a 100644
--- a/ipc/sem.c
+++ b/ipc/sem.c
@@ -1814,7 +1814,7 @@ static int get_queue_result(struct sem_queue *q)
 }
 
 SYSCALL_DEFINE4(semtimedop, int, semid, struct sembuf __user *, tsops,
-		unsigned, nsops, const struct timespec __user *, timeout)
+		long, nsops, const struct timespec __user *, timeout)
 {
 	int error = -EINVAL;
 	struct sem_array *sma;
@@ -2049,7 +2049,7 @@ out_free:
 }
 
 SYSCALL_DEFINE3(semop, int, semid, struct sembuf __user *, tsops,
-		unsigned, nsops)
+		long, nsops)
 {
 	return sys_semtimedop(semid, tsops, nsops, NULL);
 }
@@ -2204,7 +2204,8 @@ void exit_sem(struct task_struct *tsk)
 static int sysvipc_sem_proc_show(struct seq_file *s, void *it)
 {
 	struct user_namespace *user_ns = seq_user_ns(s);
-	struct sem_array *sma = it;
+	struct kern_ipc_perm *perm = it;
+	struct sem_array *sma = container_of(perm, struct sem_array, sem_perm);
 	time_t sem_otime;
 
 	/*
diff --git a/ipc/shm.c b/ipc/shm.c
index dbac8860c..ef5e42dff 100644
--- a/ipc/shm.c
+++ b/ipc/shm.c
@@ -72,9 +72,17 @@ static void shm_destroy(struct ipc_namespace *ns, struct shmid_kernel *shp);
 static int sysvipc_shm_proc_show(struct seq_file *s, void *it);
 #endif
 
+#ifdef CONFIG_GRKERNSEC
+extern int gr_handle_shmat(const pid_t shm_cprid, const pid_t shm_lapid,
+			   const u64 shm_createtime, const kuid_t cuid,
+			   const int shmid);
+extern int gr_chroot_shmat(const pid_t shm_cprid, const pid_t shm_lapid,
+			   const u64 shm_createtime);
+#endif
+
 void shm_init_ns(struct ipc_namespace *ns)
 {
-	ns->shm_ctlmax = SHMMAX;
+	ns->shm_ctlmax = BITS_PER_LONG == 32 ? SHMMAX : LONG_MAX;
 	ns->shm_ctlall = SHMALL;
 	ns->shm_ctlmni = SHMMNI;
 	ns->shm_rmid_forced = 0;
@@ -590,6 +598,9 @@ static int newseg(struct ipc_namespace *ns, struct ipc_params *params)
 	shp->shm_lprid = 0;
 	shp->shm_atim = shp->shm_dtim = 0;
 	shp->shm_ctim = get_seconds();
+#ifdef CONFIG_GRKERNSEC
+	shp->shm_createtime = ktime_get_ns();
+#endif
 	shp->shm_segsz = size;
 	shp->shm_nattch = 0;
 	shp->shm_file = file;
@@ -1133,6 +1144,12 @@ long do_shmat(int shmid, char __user *shmaddr, int shmflg, ulong *raddr,
 		f_mode = FMODE_READ | FMODE_WRITE;
 	}
 	if (shmflg & SHM_EXEC) {
+
+#ifdef CONFIG_PAX_MPROTECT
+		if (current->mm->pax_flags & MF_PAX_MPROTECT)
+			goto out;
+#endif
+
 		prot |= PROT_EXEC;
 		acc_mode |= S_IXUGO;
 	}
@@ -1157,6 +1174,15 @@ long do_shmat(int shmid, char __user *shmaddr, int shmflg, ulong *raddr,
 	if (err)
 		goto out_unlock;
 
+#ifdef CONFIG_GRKERNSEC
+	if (!gr_handle_shmat(shp->shm_cprid, shp->shm_lapid, shp->shm_createtime,
+			     shp->shm_perm.cuid, shmid) ||
+	    !gr_chroot_shmat(shp->shm_cprid, shp->shm_lapid, shp->shm_createtime)) {
+		err = -EACCES;
+		goto out_unlock;
+	}
+#endif
+
 	ipc_lock_object(&shp->shm_perm);
 
 	/* check if shm_destroy() is tearing down shp */
@@ -1169,6 +1195,9 @@ long do_shmat(int shmid, char __user *shmaddr, int shmflg, ulong *raddr,
 	path = shp->shm_file->f_path;
 	path_get(&path);
 	shp->shm_nattch++;
+#ifdef CONFIG_GRKERNSEC
+	shp->shm_lapid = current->pid;
+#endif
 	size = i_size_read(d_inode(path.dentry));
 	ipc_unlock_object(&shp->shm_perm);
 	rcu_read_unlock();
@@ -1372,7 +1401,8 @@ SYSCALL_DEFINE1(shmdt, char __user *, shmaddr)
 static int sysvipc_shm_proc_show(struct seq_file *s, void *it)
 {
 	struct user_namespace *user_ns = seq_user_ns(s);
-	struct shmid_kernel *shp = it;
+	struct kern_ipc_perm *perm = it;
+	struct shmid_kernel *shp = container_of(perm, struct shmid_kernel, shm_perm);
 	unsigned long rss = 0, swp = 0;
 
 	shm_add_rss_swap(shp, &rss, &swp);
diff --git a/ipc/util.c b/ipc/util.c
index 798cad18d..d6ffc17c6 100644
--- a/ipc/util.c
+++ b/ipc/util.c
@@ -71,6 +71,8 @@ struct ipc_proc_iface {
 	int (*show)(struct seq_file *, void *);
 };
 
+extern int gr_ipc_permitted(struct ipc_namespace *ns, struct kern_ipc_perm *ipcp, int requested_mode, int granted_mode);
+
 /**
  * ipc_init - initialise ipc subsystem
  *
@@ -489,6 +491,10 @@ int ipcperms(struct ipc_namespace *ns, struct kern_ipc_perm *ipcp, short flag)
 		granted_mode >>= 6;
 	else if (in_group_p(ipcp->cgid) || in_group_p(ipcp->gid))
 		granted_mode >>= 3;
+
+	if (!gr_ipc_permitted(ns, ipcp, requested_mode, granted_mode))
+		return -1;
+
 	/* is there some bit set in requested_mode but not in granted_mode? */
 	if ((requested_mode & ~granted_mode & 0007) &&
 	    !ns_capable(ns->user_ns, CAP_IPC_OWNER))
diff --git a/kernel/audit.c b/kernel/audit.c
index a8a91bd2b..b8f39335a 100644
--- a/kernel/audit.c
+++ b/kernel/audit.c
@@ -122,7 +122,7 @@ u32		audit_sig_sid = 0;
    3) suppressed due to audit_rate_limit
    4) suppressed due to audit_backlog_limit
 */
-static atomic_t    audit_lost = ATOMIC_INIT(0);
+static atomic_unchecked_t    audit_lost = ATOMIC_INIT(0);
 
 /* The netlink socket. */
 static struct sock *audit_sock;
@@ -256,7 +256,7 @@ void audit_log_lost(const char *message)
 	unsigned long		now;
 	int			print;
 
-	atomic_inc(&audit_lost);
+	atomic_inc_unchecked(&audit_lost);
 
 	print = (audit_failure == AUDIT_FAIL_PANIC || !audit_rate_limit);
 
@@ -273,7 +273,7 @@ void audit_log_lost(const char *message)
 	if (print) {
 		if (printk_ratelimit())
 			pr_warn("audit_lost=%u audit_rate_limit=%u audit_backlog_limit=%u\n",
-				atomic_read(&audit_lost),
+				atomic_read_unchecked(&audit_lost),
 				audit_rate_limit,
 				audit_backlog_limit);
 		audit_panic(message);
@@ -854,7 +854,7 @@ static int audit_receive_msg(struct sk_buff *skb, struct nlmsghdr *nlh)
 		s.pid			= audit_pid;
 		s.rate_limit		= audit_rate_limit;
 		s.backlog_limit		= audit_backlog_limit;
-		s.lost			= atomic_read(&audit_lost);
+		s.lost			= atomic_read_unchecked(&audit_lost);
 		s.backlog		= skb_queue_len(&audit_skb_queue);
 		s.feature_bitmap	= AUDIT_FEATURE_BITMAP_ALL;
 		s.backlog_wait_time	= audit_backlog_wait_time_master;
@@ -1171,7 +1171,7 @@ static void __net_exit audit_net_exit(struct net *net)
 	netlink_kernel_release(sock);
 }
 
-static struct pernet_operations audit_net_ops __net_initdata = {
+static struct pernet_operations audit_net_ops __net_initconst = {
 	.init = audit_net_init,
 	.exit = audit_net_exit,
 	.id = &audit_net_id,
diff --git a/kernel/auditsc.c b/kernel/auditsc.c
index 5abf1dc1f..78861f761 100644
--- a/kernel/auditsc.c
+++ b/kernel/auditsc.c
@@ -1954,7 +1954,7 @@ int auditsc_get_stamp(struct audit_context *ctx,
 }
 
 /* global counter which is incremented every time something logs in */
-static atomic_t session_id = ATOMIC_INIT(0);
+static atomic_unchecked_t session_id = ATOMIC_INIT(0);
 
 static int audit_set_loginuid_perm(kuid_t loginuid)
 {
@@ -2026,7 +2026,7 @@ int audit_set_loginuid(kuid_t loginuid)
 
 	/* are we setting or clearing? */
 	if (uid_valid(loginuid))
-		sessionid = (unsigned int)atomic_inc_return(&session_id);
+		sessionid = (unsigned int)atomic_inc_return_unchecked(&session_id);
 
 	task->sessionid = sessionid;
 	task->loginuid = loginuid;
diff --git a/kernel/bpf/core.c b/kernel/bpf/core.c
index 03fd23d4d..4b2832f02 100644
--- a/kernel/bpf/core.c
+++ b/kernel/bpf/core.c
@@ -208,6 +208,8 @@ struct bpf_prog *bpf_patch_insn_single(struct bpf_prog *prog, u32 off,
 }
 
 #ifdef CONFIG_BPF_JIT
+extern long __rap_hash___bpf_prog_run;
+
 struct bpf_binary_header *
 bpf_jit_binary_alloc(unsigned int proglen, u8 **image_ptr,
 		     unsigned int alignment,
@@ -221,27 +223,45 @@ bpf_jit_binary_alloc(unsigned int proglen, u8 **image_ptr,
 	 * random section of illegal instructions.
 	 */
 	size = round_up(proglen + sizeof(*hdr) + 128, PAGE_SIZE);
-	hdr = module_alloc(size);
+	hdr = module_alloc_exec(size);
 	if (hdr == NULL)
 		return NULL;
 
 	/* Fill space with illegal/arch-dep instructions. */
 	bpf_fill_ill_insns(hdr, size);
 
+	pax_open_kernel();
 	hdr->pages = size / PAGE_SIZE;
+	pax_close_kernel();
+
 	hole = min_t(unsigned int, size - (proglen + sizeof(*hdr)),
 		     PAGE_SIZE - sizeof(*hdr));
+
+#ifdef CONFIG_PAX_RAP
+	hole -= 8;
+#endif
+
 	start = (get_random_int() % hole) & ~(alignment - 1);
 
+#ifdef CONFIG_PAX_RAP
+	start += 8;
+#endif
+
 	/* Leave a random number of instructions before BPF code. */
 	*image_ptr = &hdr->image[start];
 
+#ifdef CONFIG_PAX_RAP
+	pax_open_kernel();
+	*(long *)(*image_ptr - 8) = (long)&__rap_hash___bpf_prog_run;
+	pax_close_kernel();
+#endif
+
 	return hdr;
 }
 
 void bpf_jit_binary_free(struct bpf_binary_header *hdr)
 {
-	module_memfree(hdr);
+	module_memfree_exec(hdr);
 }
 
 int bpf_jit_harden __read_mostly;
@@ -465,7 +485,7 @@ EXPORT_SYMBOL_GPL(__bpf_call_base);
  *
  * Decode and execute eBPF instructions.
  */
-static unsigned int __bpf_prog_run(void *ctx, const struct bpf_insn *insn)
+unsigned int __bpf_prog_run(const struct sk_buff *ctx, const struct bpf_insn *insn)
 {
 	u64 stack[MAX_BPF_STACK / sizeof(u64)];
 	u64 regs[MAX_BPF_REG], tmp;
@@ -970,7 +990,7 @@ static int bpf_check_tail_call(const struct bpf_prog *fp)
  */
 struct bpf_prog *bpf_prog_select_runtime(struct bpf_prog *fp, int *err)
 {
-	fp->bpf_func = (void *) __bpf_prog_run;
+	fp->bpf_func = __bpf_prog_run;
 
 	/* eBPF JITs can rewrite the program in case constant
 	 * blinding is active. However, in case of error during
diff --git a/kernel/bpf/syscall.c b/kernel/bpf/syscall.c
index 228f96244..ebef033c0 100644
--- a/kernel/bpf/syscall.c
+++ b/kernel/bpf/syscall.c
@@ -827,8 +827,16 @@ SYSCALL_DEFINE3(bpf, int, cmd, union bpf_attr __user *, uattr, unsigned int, siz
 	union bpf_attr attr = {};
 	int err;
 
-	if (!capable(CAP_SYS_ADMIN) && sysctl_unprivileged_bpf_disabled)
+	/* the syscall is limited to root temporarily. This restriction will be
+	 * lifted by upstream when a half-assed security audit is clean. Note
+	 * that eBPF+tracing must have this restriction, since it may pass
+	 * kernel data to user space
+	 */
+	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
+#ifdef CONFIG_GRKERNSEC
+	return -EPERM;
+#endif
 
 	if (!access_ok(VERIFY_READ, uattr, 1))
 		return -EFAULT;
diff --git a/kernel/capability.c b/kernel/capability.c
index 4984e1f55..6ca927cfe 100644
--- a/kernel/capability.c
+++ b/kernel/capability.c
@@ -193,6 +193,9 @@ SYSCALL_DEFINE2(capget, cap_user_header_t, header, cap_user_data_t, dataptr)
 		 * before modification is attempted and the application
 		 * fails.
 		 */
+		if (tocopy > ARRAY_SIZE(kdata))
+			return -EFAULT;
+
 		if (copy_to_user(dataptr, kdata, tocopy
 				 * sizeof(struct __user_cap_data_struct))) {
 			return -EFAULT;
@@ -298,10 +301,11 @@ bool has_ns_capability(struct task_struct *t,
 	int ret;
 
 	rcu_read_lock();
-	ret = security_capable(__task_cred(t), ns, cap);
+	ret = security_capable(__task_cred(t), ns, cap) == 0 &&
+		gr_task_is_capable(t, __task_cred(t), cap);
 	rcu_read_unlock();
 
-	return (ret == 0);
+	return ret;
 }
 
 /**
@@ -338,10 +342,10 @@ bool has_ns_capability_noaudit(struct task_struct *t,
 	int ret;
 
 	rcu_read_lock();
-	ret = security_capable_noaudit(__task_cred(t), ns, cap);
+	ret = security_capable_noaudit(__task_cred(t), ns, cap) == 0 && gr_task_is_capable_nolog(t, __task_cred(t), cap);
 	rcu_read_unlock();
 
-	return (ret == 0);
+	return ret;
 }
 
 /**
@@ -370,9 +374,9 @@ static bool ns_capable_common(struct user_namespace *ns, int cap, bool audit)
 		BUG();
 	}
 
-	capable = audit ? security_capable(current_cred(), ns, cap) :
-			  security_capable_noaudit(current_cred(), ns, cap);
-	if (capable == 0) {
+	capable = audit ? (security_capable(current_cred(), ns, cap) == 0 && gr_is_capable(cap)) :
+			  (security_capable_noaudit(current_cred(), ns, cap) == 0 && gr_is_capable_nolog(cap)) ;
+	if (capable) {
 		current->flags |= PF_SUPERPRIV;
 		return true;
 	}
@@ -429,6 +433,13 @@ bool capable(int cap)
 	return ns_capable(&init_user_ns, cap);
 }
 EXPORT_SYMBOL(capable);
+
+bool capable_nolog(int cap)
+{
+	return ns_capable_noaudit(&init_user_ns, cap);
+}
+EXPORT_SYMBOL(capable_nolog);
+
 #endif /* CONFIG_MULTIUSER */
 
 /**
@@ -486,6 +497,15 @@ bool capable_wrt_inode_uidgid(const struct inode *inode, int cap)
 }
 EXPORT_SYMBOL(capable_wrt_inode_uidgid);
 
+bool capable_wrt_inode_uidgid_nolog(const struct inode *inode, int cap)
+{
+	struct user_namespace *ns = current_user_ns();
+
+	return ns_capable_noaudit(ns, cap) && kuid_has_mapping(ns, inode->i_uid) &&
+		kgid_has_mapping(ns, inode->i_gid);
+}
+EXPORT_SYMBOL(capable_wrt_inode_uidgid_nolog);
+
 /**
  * ptracer_capable - Determine if the ptracer holds CAP_SYS_PTRACE in the namespace
  * @tsk: The task that may be ptraced
diff --git a/kernel/cgroup.c b/kernel/cgroup.c
index d6b729beb..f78716c70 100644
--- a/kernel/cgroup.c
+++ b/kernel/cgroup.c
@@ -3645,7 +3645,7 @@ static int cgroup_add_file(struct cgroup_subsys_state *css, struct cgroup *cgrp,
 	key = &cft->lockdep_key;
 #endif
 	kn = __kernfs_create_file(cgrp->kn, cgroup_file_name(cgrp, cft, name),
-				  cgroup_file_mode(cft), 0, cft->kf_ops, cft,
+				  cgroup_file_mode(cft), 0, cft->kf_ops, (void *)cft,
 				  NULL, key);
 	if (IS_ERR(kn))
 		return PTR_ERR(kn);
@@ -3749,11 +3749,14 @@ static void cgroup_exit_cftypes(struct cftype *cfts)
 		/* free copy for custom atomic_write_len, see init_cftypes() */
 		if (cft->max_write_len && cft->max_write_len != PAGE_SIZE)
 			kfree(cft->kf_ops);
-		cft->kf_ops = NULL;
-		cft->ss = NULL;
+
+		pax_open_kernel();
+		const_cast(cft->kf_ops) = NULL;
+		const_cast(cft->ss) = NULL;
 
 		/* revert flags set by cgroup core while adding @cfts */
-		cft->flags &= ~(__CFTYPE_ONLY_ON_DFL | __CFTYPE_NOT_ON_DFL);
+		const_cast(cft->flags) &= ~(__CFTYPE_ONLY_ON_DFL | __CFTYPE_NOT_ON_DFL);
+		pax_close_kernel();
 	}
 }
 
@@ -3784,8 +3787,10 @@ static int cgroup_init_cftypes(struct cgroup_subsys *ss, struct cftype *cfts)
 			kf_ops->atomic_write_len = cft->max_write_len;
 		}
 
-		cft->kf_ops = kf_ops;
-		cft->ss = ss;
+		pax_open_kernel();
+		const_cast(cft->kf_ops) = kf_ops;
+		const_cast(cft->ss) = ss;
+		pax_close_kernel();
 	}
 
 	return 0;
@@ -3798,7 +3803,7 @@ static int cgroup_rm_cftypes_locked(struct cftype *cfts)
 	if (!cfts || !cfts[0].ss)
 		return -ENOENT;
 
-	list_del(&cfts->node);
+	pax_list_del((struct list_head *)&cfts->node);
 	cgroup_apply_cftypes(cfts, false);
 	cgroup_exit_cftypes(cfts);
 	return 0;
@@ -3855,7 +3860,7 @@ static int cgroup_add_cftypes(struct cgroup_subsys *ss, struct cftype *cfts)
 
 	mutex_lock(&cgroup_mutex);
 
-	list_add_tail(&cfts->node, &ss->cfts);
+	pax_list_add_tail((struct list_head *)&cfts->node, &ss->cfts);
 	ret = cgroup_apply_cftypes(cfts, true);
 	if (ret)
 		cgroup_rm_cftypes_locked(cfts);
@@ -3876,8 +3881,10 @@ int cgroup_add_dfl_cftypes(struct cgroup_subsys *ss, struct cftype *cfts)
 {
 	struct cftype *cft;
 
+	pax_open_kernel();
 	for (cft = cfts; cft && cft->name[0] != '\0'; cft++)
-		cft->flags |= __CFTYPE_ONLY_ON_DFL;
+		const_cast(cft->flags) |= __CFTYPE_ONLY_ON_DFL;
+	pax_close_kernel();
 	return cgroup_add_cftypes(ss, cfts);
 }
 
@@ -3893,8 +3900,10 @@ int cgroup_add_legacy_cftypes(struct cgroup_subsys *ss, struct cftype *cfts)
 {
 	struct cftype *cft;
 
+	pax_open_kernel();
 	for (cft = cfts; cft && cft->name[0] != '\0'; cft++)
-		cft->flags |= __CFTYPE_NOT_ON_DFL;
+		const_cast(cft->flags) |= __CFTYPE_NOT_ON_DFL;
+	pax_close_kernel();
 	return cgroup_add_cftypes(ss, cfts);
 }
 
@@ -6066,6 +6075,9 @@ static void cgroup_release_agent(struct work_struct *work)
 	if (!pathbuf || !agentbuf)
 		goto out;
 
+	if (agentbuf[0] == '\0')
+		goto out;
+
 	spin_lock_irq(&css_set_lock);
 	path = cgroup_path_ns_locked(cgrp, pathbuf, PATH_MAX, &init_cgroup_ns);
 	spin_unlock_irq(&css_set_lock);
@@ -6522,7 +6534,7 @@ static int cgroup_css_links_read(struct seq_file *seq, void *v)
 		struct task_struct *task;
 		int count = 0;
 
-		seq_printf(seq, "css_set %p\n", cset);
+		seq_printf(seq, "css_set %pK\n", cset);
 
 		list_for_each_entry(task, &cset->tasks, cg_list) {
 			if (count++ > MAX_TASKS_SHOWN_PER_CSS)
diff --git a/kernel/cgroup_pids.c b/kernel/cgroup_pids.c
index 2bd673783..9b0ddd4bb 100644
--- a/kernel/cgroup_pids.c
+++ b/kernel/cgroup_pids.c
@@ -54,7 +54,7 @@ struct pids_cgroup {
 	struct cgroup_file		events_file;
 
 	/* Number of times fork failed because limit was hit. */
-	atomic64_t			events_limit;
+	atomic64_unchecked_t		events_limit;
 };
 
 static struct pids_cgroup *css_pids(struct cgroup_subsys_state *css)
@@ -78,7 +78,7 @@ pids_css_alloc(struct cgroup_subsys_state *parent)
 
 	pids->limit = PIDS_MAX;
 	atomic64_set(&pids->counter, 0);
-	atomic64_set(&pids->events_limit, 0);
+	atomic64_set_unchecked(&pids->events_limit, 0);
 	return &pids->css;
 }
 
@@ -227,7 +227,7 @@ static int pids_can_fork(struct task_struct *task)
 	err = pids_try_charge(pids, 1);
 	if (err) {
 		/* Only log the first time events_limit is incremented. */
-		if (atomic64_inc_return(&pids->events_limit) == 1) {
+		if (atomic64_inc_return_unchecked(&pids->events_limit) == 1) {
 			pr_info("cgroup: fork rejected by pids controller in ");
 			pr_cont_cgroup_path(task_cgroup(current, pids_cgrp_id));
 			pr_cont("\n");
@@ -310,7 +310,7 @@ static int pids_events_show(struct seq_file *sf, void *v)
 {
 	struct pids_cgroup *pids = css_pids(seq_css(sf));
 
-	seq_printf(sf, "max %lld\n", (s64)atomic64_read(&pids->events_limit));
+	seq_printf(sf, "max %lld\n", (s64)atomic64_read_unchecked(&pids->events_limit));
 	return 0;
 }
 
diff --git a/kernel/compat.c b/kernel/compat.c
index 333d364be..762ec0070 100644
--- a/kernel/compat.c
+++ b/kernel/compat.c
@@ -13,6 +13,7 @@
 
 #include <linux/linkage.h>
 #include <linux/compat.h>
+#include <linux/module.h>
 #include <linux/errno.h>
 #include <linux/time.h>
 #include <linux/signal.h>
@@ -220,7 +221,7 @@ static long compat_nanosleep_restart(struct restart_block *restart)
 	mm_segment_t oldfs;
 	long ret;
 
-	restart->nanosleep.rmtp = (struct timespec __user *) &rmt;
+	restart->nanosleep.rmtp = (struct timespec __force_user *) &rmt;
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	ret = hrtimer_nanosleep_restart(restart);
@@ -252,7 +253,7 @@ COMPAT_SYSCALL_DEFINE2(nanosleep, struct compat_timespec __user *, rqtp,
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	ret = hrtimer_nanosleep(&tu,
-				rmtp ? (struct timespec __user *)&rmt : NULL,
+				rmtp ? (struct timespec __force_user *)&rmt : NULL,
 				HRTIMER_MODE_REL, CLOCK_MONOTONIC);
 	set_fs(oldfs);
 
@@ -378,7 +379,7 @@ COMPAT_SYSCALL_DEFINE1(sigpending, compat_old_sigset_t __user *, set)
 	mm_segment_t old_fs = get_fs();
 
 	set_fs(KERNEL_DS);
-	ret = sys_sigpending((old_sigset_t __user *) &s);
+	ret = sys_sigpending((old_sigset_t __force_user *) &s);
 	set_fs(old_fs);
 	if (ret == 0)
 		ret = put_user(s, set);
@@ -468,7 +469,7 @@ COMPAT_SYSCALL_DEFINE2(old_getrlimit, unsigned int, resource,
 	mm_segment_t old_fs = get_fs();
 
 	set_fs(KERNEL_DS);
-	ret = sys_old_getrlimit(resource, (struct rlimit __user *)&r);
+	ret = sys_old_getrlimit(resource, (struct rlimit __force_user *)&r);
 	set_fs(old_fs);
 
 	if (!ret) {
@@ -550,8 +551,8 @@ COMPAT_SYSCALL_DEFINE4(wait4,
 		set_fs (KERNEL_DS);
 		ret = sys_wait4(pid,
 				(stat_addr ?
-				 (unsigned int __user *) &status : NULL),
-				options, (struct rusage __user *) &r);
+				 (unsigned int __force_user *) &status : NULL),
+				options, (struct rusage __force_user *) &r);
 		set_fs (old_fs);
 
 		if (ret > 0) {
@@ -577,8 +578,8 @@ COMPAT_SYSCALL_DEFINE5(waitid,
 	memset(&info, 0, sizeof(info));
 
 	set_fs(KERNEL_DS);
-	ret = sys_waitid(which, pid, (siginfo_t __user *)&info, options,
-			 uru ? (struct rusage __user *)&ru : NULL);
+	ret = sys_waitid(which, pid, (siginfo_t __force_user *)&info, options,
+			 uru ? (struct rusage __force_user *)&ru : NULL);
 	set_fs(old_fs);
 
 	if ((ret < 0) || (info.si_signo == 0))
@@ -712,8 +713,8 @@ COMPAT_SYSCALL_DEFINE4(timer_settime, timer_t, timer_id, int, flags,
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_timer_settime(timer_id, flags,
-				(struct itimerspec __user *) &newts,
-				(struct itimerspec __user *) &oldts);
+				(struct itimerspec __force_user *) &newts,
+				(struct itimerspec __force_user *) &oldts);
 	set_fs(oldfs);
 	if (!err && old && put_compat_itimerspec(old, &oldts))
 		return -EFAULT;
@@ -730,7 +731,7 @@ COMPAT_SYSCALL_DEFINE2(timer_gettime, timer_t, timer_id,
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_timer_gettime(timer_id,
-				(struct itimerspec __user *) &ts);
+				(struct itimerspec __force_user *) &ts);
 	set_fs(oldfs);
 	if (!err && put_compat_itimerspec(setting, &ts))
 		return -EFAULT;
@@ -749,7 +750,7 @@ COMPAT_SYSCALL_DEFINE2(clock_settime, clockid_t, which_clock,
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_clock_settime(which_clock,
-				(struct timespec __user *) &ts);
+				(struct timespec __force_user *) &ts);
 	set_fs(oldfs);
 	return err;
 }
@@ -764,7 +765,7 @@ COMPAT_SYSCALL_DEFINE2(clock_gettime, clockid_t, which_clock,
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_clock_gettime(which_clock,
-				(struct timespec __user *) &ts);
+				(struct timespec __force_user *) &ts);
 	set_fs(oldfs);
 	if (!err && compat_put_timespec(&ts, tp))
 		return -EFAULT;
@@ -784,7 +785,7 @@ COMPAT_SYSCALL_DEFINE2(clock_adjtime, clockid_t, which_clock,
 
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
-	ret = sys_clock_adjtime(which_clock, (struct timex __user *) &txc);
+	ret = sys_clock_adjtime(which_clock, (struct timex __force_user *) &txc);
 	set_fs(oldfs);
 
 	err = compat_put_timex(utp, &txc);
@@ -804,7 +805,7 @@ COMPAT_SYSCALL_DEFINE2(clock_getres, clockid_t, which_clock,
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_clock_getres(which_clock,
-			       (struct timespec __user *) &ts);
+			       (struct timespec __force_user *) &ts);
 	set_fs(oldfs);
 	if (!err && tp && compat_put_timespec(&ts, tp))
 		return -EFAULT;
@@ -818,7 +819,7 @@ static long compat_clock_nanosleep_restart(struct restart_block *restart)
 	struct timespec tu;
 	struct compat_timespec __user *rmtp = restart->nanosleep.compat_rmtp;
 
-	restart->nanosleep.rmtp = (struct timespec __user *) &tu;
+	restart->nanosleep.rmtp = (struct timespec __force_user *) &tu;
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = clock_nanosleep_restart(restart);
@@ -850,8 +851,8 @@ COMPAT_SYSCALL_DEFINE4(clock_nanosleep, clockid_t, which_clock, int, flags,
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_clock_nanosleep(which_clock, flags,
-				  (struct timespec __user *) &in,
-				  (struct timespec __user *) &out);
+				  (struct timespec __force_user *) &in,
+				  (struct timespec __force_user *) &out);
 	set_fs(oldfs);
 
 	if ((err == -ERESTART_RESTARTBLOCK) && rmtp &&
@@ -1147,7 +1148,7 @@ COMPAT_SYSCALL_DEFINE2(sched_rr_get_interval,
 	mm_segment_t old_fs = get_fs();
 
 	set_fs(KERNEL_DS);
-	ret = sys_sched_rr_get_interval(pid, (struct timespec __user *)&t);
+	ret = sys_sched_rr_get_interval(pid, (struct timespec __force_user *)&t);
 	set_fs(old_fs);
 	if (compat_put_timespec(&t, interval))
 		return -EFAULT;
diff --git a/kernel/configs.c b/kernel/configs.c
index c18b1f1ae..b9a013221 100644
--- a/kernel/configs.c
+++ b/kernel/configs.c
@@ -74,8 +74,19 @@ static int __init ikconfig_init(void)
 	struct proc_dir_entry *entry;
 
 	/* create the current config file */
+#if defined(CONFIG_GRKERNSEC_PROC_ADD) || defined(CONFIG_GRKERNSEC_HIDESYM)
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_HIDESYM)
+	entry = proc_create("config.gz", S_IFREG | S_IRUSR, NULL,
+			    &ikconfig_file_ops);
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	entry = proc_create("config.gz", S_IFREG | S_IRUSR | S_IRGRP, NULL,
+			    &ikconfig_file_ops);
+#endif
+#else
 	entry = proc_create("config.gz", S_IFREG | S_IRUGO, NULL,
 			    &ikconfig_file_ops);
+#endif
+
 	if (!entry)
 		return -ENOMEM;
 
diff --git a/kernel/cred.c b/kernel/cred.c
index 5f264fb57..8fc856b49 100644
--- a/kernel/cred.c
+++ b/kernel/cred.c
@@ -172,6 +172,15 @@ void exit_creds(struct task_struct *tsk)
 	validate_creds(cred);
 	alter_cred_subscribers(cred, -1);
 	put_cred(cred);
+
+#ifdef CONFIG_GRKERNSEC_SETXID
+	cred = (struct cred *) tsk->delayed_cred;
+	if (cred != NULL) {
+		tsk->delayed_cred = NULL;
+		validate_creds(cred);
+		put_cred(cred);
+	}
+#endif
 }
 
 /**
@@ -419,7 +428,7 @@ static bool cred_cap_issubset(const struct cred *set, const struct cred *subset)
  * Always returns 0 thus allowing this function to be tail-called at the end
  * of, say, sys_setgid().
  */
-int commit_creds(struct cred *new)
+static int __commit_creds(struct cred *new)
 {
 	struct task_struct *task = current;
 	const struct cred *old = task->real_cred;
@@ -438,6 +447,8 @@ int commit_creds(struct cred *new)
 
 	get_cred(new); /* we will require a ref for the subj creds too */
 
+	gr_set_role_label(task, new->uid, new->gid);
+
 	/* dumpability changes */
 	if (!uid_eq(old->euid, new->euid) ||
 	    !gid_eq(old->egid, new->egid) ||
@@ -487,6 +498,105 @@ int commit_creds(struct cred *new)
 	put_cred(old);
 	return 0;
 }
+#ifdef CONFIG_GRKERNSEC_SETXID
+extern int set_user(struct cred *new);
+
+void gr_delayed_cred_worker(void)
+{
+	const struct cred *new = current->delayed_cred;
+	struct cred *ncred;
+
+	current->delayed_cred = NULL;
+
+	if (!uid_eq(current_uid(), GLOBAL_ROOT_UID) && new != NULL) {
+		// from doing get_cred on it when queueing this
+		put_cred(new);
+		return;
+	} else if (new == NULL)
+		return;
+
+	ncred = prepare_creds();
+	if (!ncred)
+		goto die;
+	// uids
+	ncred->uid = new->uid;
+	ncred->euid = new->euid;
+	ncred->suid = new->suid;
+	ncred->fsuid = new->fsuid;
+	// gids
+	ncred->gid = new->gid;
+	ncred->egid = new->egid;
+	ncred->sgid = new->sgid;
+	ncred->fsgid = new->fsgid;
+	// groups
+	set_groups(ncred, new->group_info);
+	// caps
+	ncred->securebits = new->securebits;
+	ncred->cap_inheritable = new->cap_inheritable;
+	ncred->cap_permitted = new->cap_permitted;
+	ncred->cap_effective = new->cap_effective;
+	ncred->cap_bset = new->cap_bset;
+
+	if (set_user(ncred)) {
+		abort_creds(ncred);
+		goto die;
+	}
+
+	// from doing get_cred on it when queueing this
+	put_cred(new);
+
+	__commit_creds(ncred);
+	return;
+die:
+	// from doing get_cred on it when queueing this
+	put_cred(new);
+	do_group_exit(SIGKILL);
+}
+#endif
+
+int commit_creds(struct cred *new)
+{
+#ifdef CONFIG_GRKERNSEC_SETXID
+	int ret;
+	int schedule_it = 0;
+	struct task_struct *t;
+	unsigned oldsecurebits = current_cred()->securebits;
+
+	/* we won't get called with tasklist_lock held for writing
+	   and interrupts disabled as the cred struct in that case is
+	   init_cred
+	*/
+	if (grsec_enable_setxid && !current_is_single_threaded() &&
+	    uid_eq(current_uid(), GLOBAL_ROOT_UID) &&
+	    !uid_eq(new->uid, GLOBAL_ROOT_UID)) {
+		schedule_it = 1;
+	}
+	ret = __commit_creds(new);
+	if (schedule_it) {
+		rcu_read_lock();
+		read_lock(&tasklist_lock);
+		for (t = next_thread(current); t != current;
+		     t = next_thread(t)) {
+			/* we'll check if the thread has uid 0 in
+			 * the delayed worker routine
+			 */
+			if (task_securebits(t) == oldsecurebits &&
+			    t->delayed_cred == NULL) {
+				t->delayed_cred = get_cred(new);
+				set_tsk_thread_flag(t, TIF_GRSEC_SETXID);
+				set_tsk_need_resched(t);
+			}
+		}
+		read_unlock(&tasklist_lock);
+		rcu_read_unlock();
+	}
+
+	return ret;
+#else
+	return __commit_creds(new);
+#endif
+}
+
 EXPORT_SYMBOL(commit_creds);
 
 /**
diff --git a/kernel/debug/debug_core.c b/kernel/debug/debug_core.c
index 79517e554..a4e120b24 100644
--- a/kernel/debug/debug_core.c
+++ b/kernel/debug/debug_core.c
@@ -127,7 +127,7 @@ static DEFINE_RAW_SPINLOCK(dbg_slave_lock);
  */
 static atomic_t			masters_in_kgdb;
 static atomic_t			slaves_in_kgdb;
-static atomic_t			kgdb_break_tasklet_var;
+static atomic_unchecked_t	kgdb_break_tasklet_var;
 atomic_t			kgdb_setting_breakpoint;
 
 struct task_struct		*kgdb_usethread;
@@ -137,7 +137,7 @@ int				kgdb_single_step;
 static pid_t			kgdb_sstep_pid;
 
 /* to keep track of the CPU which is doing the single stepping*/
-atomic_t			kgdb_cpu_doing_single_step = ATOMIC_INIT(-1);
+atomic_unchecked_t		kgdb_cpu_doing_single_step = ATOMIC_INIT(-1);
 
 /*
  * If you are debugging a problem where roundup (the collection of
@@ -552,7 +552,7 @@ return_normal:
 	 * kernel will only try for the value of sstep_tries before
 	 * giving up and continuing on.
 	 */
-	if (atomic_read(&kgdb_cpu_doing_single_step) != -1 &&
+	if (atomic_read_unchecked(&kgdb_cpu_doing_single_step) != -1 &&
 	    (kgdb_info[cpu].task &&
 	     kgdb_info[cpu].task->pid != kgdb_sstep_pid) && --sstep_tries) {
 		atomic_set(&kgdb_active, -1);
@@ -654,8 +654,8 @@ cpu_master_loop:
 	}
 
 kgdb_restore:
-	if (atomic_read(&kgdb_cpu_doing_single_step) != -1) {
-		int sstep_cpu = atomic_read(&kgdb_cpu_doing_single_step);
+	if (atomic_read_unchecked(&kgdb_cpu_doing_single_step) != -1) {
+		int sstep_cpu = atomic_read_unchecked(&kgdb_cpu_doing_single_step);
 		if (kgdb_info[sstep_cpu].task)
 			kgdb_sstep_pid = kgdb_info[sstep_cpu].task->pid;
 		else
@@ -949,18 +949,18 @@ static void kgdb_unregister_callbacks(void)
 static void kgdb_tasklet_bpt(unsigned long ing)
 {
 	kgdb_breakpoint();
-	atomic_set(&kgdb_break_tasklet_var, 0);
+	atomic_set_unchecked(&kgdb_break_tasklet_var, 0);
 }
 
 static DECLARE_TASKLET(kgdb_tasklet_breakpoint, kgdb_tasklet_bpt, 0);
 
 void kgdb_schedule_breakpoint(void)
 {
-	if (atomic_read(&kgdb_break_tasklet_var) ||
+	if (atomic_read_unchecked(&kgdb_break_tasklet_var) ||
 		atomic_read(&kgdb_active) != -1 ||
 		atomic_read(&kgdb_setting_breakpoint))
 		return;
-	atomic_inc(&kgdb_break_tasklet_var);
+	atomic_inc_unchecked(&kgdb_break_tasklet_var);
 	tasklet_schedule(&kgdb_tasklet_breakpoint);
 }
 EXPORT_SYMBOL_GPL(kgdb_schedule_breakpoint);
diff --git a/kernel/debug/kdb/kdb_main.c b/kernel/debug/kdb/kdb_main.c
index 2a20c0dfd..3eb7d0351 100644
--- a/kernel/debug/kdb/kdb_main.c
+++ b/kernel/debug/kdb/kdb_main.c
@@ -2021,7 +2021,7 @@ static int kdb_lsmod(int argc, const char **argv)
 			continue;
 
 		kdb_printf("%-20s%8u  0x%p ", mod->name,
-			   mod->core_layout.size, (void *)mod);
+			   mod->core_layout.size_rx + mod->core_layout.size_rw, (void *)mod);
 #ifdef CONFIG_MODULE_UNLOAD
 		kdb_printf("%4d ", module_refcount(mod));
 #endif
@@ -2031,7 +2031,7 @@ static int kdb_lsmod(int argc, const char **argv)
 			kdb_printf(" (Loading)");
 		else
 			kdb_printf(" (Live)");
-		kdb_printf(" 0x%p", mod->core_layout.base);
+		kdb_printf(" 0x%p 0x%p", mod->core_layout.base_rx, mod->core_layout.base_rw);
 
 #ifdef CONFIG_MODULE_UNLOAD
 		{
diff --git a/kernel/events/callchain.c b/kernel/events/callchain.c
index e9fdb5203..cfb547da1 100644
--- a/kernel/events/callchain.c
+++ b/kernel/events/callchain.c
@@ -251,7 +251,7 @@ int perf_event_max_stack_handler(struct ctl_table *table, int write,
 {
 	int *value = table->data;
 	int new_value = *value, ret;
-	struct ctl_table new_table = *table;
+	ctl_table_no_const new_table = *table;
 
 	new_table.data = &new_value;
 	ret = proc_dointvec_minmax(&new_table, write, buffer, lenp, ppos);
diff --git a/kernel/events/core.c b/kernel/events/core.c
index f8c5f5ec6..00671d292 100644
--- a/kernel/events/core.c
+++ b/kernel/events/core.c
@@ -389,8 +389,15 @@ static struct srcu_struct pmus_srcu;
  *   0 - disallow raw tracepoint access for unpriv
  *   1 - disallow cpu events for unpriv
  *   2 - disallow kernel profiling for unpriv
+ *   3 - disallow all unpriv perf event use
  */
-int sysctl_perf_event_paranoid __read_mostly = 2;
+#ifdef CONFIG_GRKERNSEC_PERF_HARDEN
+int sysctl_perf_event_legitimately_concerned __read_only = 3;
+#elif defined(CONFIG_GRKERNSEC_HIDESYM)
+int sysctl_perf_event_legitimately_concerned __read_only = 2;
+#else
+int sysctl_perf_event_legitimately_concerned __read_only = 2;
+#endif
 
 /* Minimum for 512 kiB + 1 user control page */
 int sysctl_perf_event_mlock __read_mostly = 512 + (PAGE_SIZE / 1024); /* 'free' kiB per user */
@@ -545,7 +552,7 @@ void perf_sample_event_took(u64 sample_len_ns)
 	}
 }
 
-static atomic64_t perf_event_id;
+static atomic64_unchecked_t perf_event_id;
 
 static void cpu_ctx_sched_out(struct perf_cpu_context *cpuctx,
 			      enum event_type_t event_type);
@@ -1044,8 +1051,9 @@ static void __perf_mux_hrtimer_init(struct perf_cpu_context *cpuctx, int cpu)
 	timer->function = perf_mux_hrtimer_handler;
 }
 
-static int perf_mux_hrtimer_restart(struct perf_cpu_context *cpuctx)
+static int perf_mux_hrtimer_restart(void *_cpuctx)
 {
+	struct perf_cpu_context *cpuctx = _cpuctx;
 	struct hrtimer *timer = &cpuctx->hrtimer;
 	struct pmu *pmu = cpuctx->ctx.pmu;
 	unsigned long flags;
@@ -3111,7 +3119,7 @@ void __perf_event_task_sched_in(struct task_struct *prev,
 		perf_pmu_sched_task(prev, task, true);
 }
 
-static u64 perf_calculate_period(struct perf_event *event, u64 nsec, u64 count)
+static u64 perf_calculate_period(const struct perf_event *event, u64 nsec, u64 count)
 {
 	u64 frequency = event->attr.sample_freq;
 	u64 sec = NSEC_PER_SEC;
@@ -4201,9 +4209,9 @@ u64 perf_event_read_value(struct perf_event *event, u64 *enabled, u64 *running)
 	total += perf_event_count(event);
 
 	*enabled += event->total_time_enabled +
-			atomic64_read(&event->child_total_time_enabled);
+			atomic64_read_unchecked(&event->child_total_time_enabled);
 	*running += event->total_time_running +
-			atomic64_read(&event->child_total_time_running);
+			atomic64_read_unchecked(&event->child_total_time_running);
 
 	list_for_each_entry(child, &event->child_list, child_list) {
 		(void)perf_event_read(child, false);
@@ -4235,12 +4243,12 @@ static int __perf_read_group_add(struct perf_event *leader,
 	 */
 	if (read_format & PERF_FORMAT_TOTAL_TIME_ENABLED) {
 		values[n++] += leader->total_time_enabled +
-			atomic64_read(&leader->child_total_time_enabled);
+			atomic64_read_unchecked(&leader->child_total_time_enabled);
 	}
 
 	if (read_format & PERF_FORMAT_TOTAL_TIME_RUNNING) {
 		values[n++] += leader->total_time_running +
-			atomic64_read(&leader->child_total_time_running);
+			atomic64_read_unchecked(&leader->child_total_time_running);
 	}
 
 	/*
@@ -4763,10 +4771,10 @@ void perf_event_update_userpage(struct perf_event *event)
 		userpg->offset -= local64_read(&event->hw.prev_count);
 
 	userpg->time_enabled = enabled +
-			atomic64_read(&event->child_total_time_enabled);
+			atomic64_read_unchecked(&event->child_total_time_enabled);
 
 	userpg->time_running = running +
-			atomic64_read(&event->child_total_time_running);
+			atomic64_read_unchecked(&event->child_total_time_running);
 
 	arch_perf_update_userpage(event, userpg, now);
 
@@ -5468,7 +5476,7 @@ perf_output_sample_ustack(struct perf_output_handle *handle, u64 dump_size,
 
 		/* Data. */
 		sp = perf_user_stack_pointer(regs);
-		rem = __output_copy_user(handle, (void *) sp, dump_size);
+		rem = __output_copy_user(handle, (void __user *) sp, dump_size);
 		dyn_size = dump_size - rem;
 
 		perf_output_skip(handle, rem);
@@ -5559,11 +5567,11 @@ static void perf_output_read_one(struct perf_output_handle *handle,
 	values[n++] = perf_event_count(event);
 	if (read_format & PERF_FORMAT_TOTAL_TIME_ENABLED) {
 		values[n++] = enabled +
-			atomic64_read(&event->child_total_time_enabled);
+			atomic64_read_unchecked(&event->child_total_time_enabled);
 	}
 	if (read_format & PERF_FORMAT_TOTAL_TIME_RUNNING) {
 		values[n++] = running +
-			atomic64_read(&event->child_total_time_running);
+			atomic64_read_unchecked(&event->child_total_time_running);
 	}
 	if (read_format & PERF_FORMAT_ID)
 		values[n++] = primary_event_id(event);
@@ -8564,8 +8572,7 @@ perf_event_mux_interval_ms_store(struct device *dev,
 		cpuctx = per_cpu_ptr(pmu->pmu_cpu_context, cpu);
 		cpuctx->hrtimer_interval = ns_to_ktime(NSEC_PER_MSEC * timer);
 
-		cpu_function_call(cpu,
-			(remote_function_f)perf_mux_hrtimer_restart, cpuctx);
+		cpu_function_call(cpu, perf_mux_hrtimer_restart, cpuctx);
 	}
 	put_online_cpus();
 	mutex_unlock(&mux_interval_mutex);
@@ -9006,7 +9013,7 @@ perf_event_alloc(struct perf_event_attr *attr, int cpu,
 	event->parent		= parent_event;
 
 	event->ns		= get_pid_ns(task_active_pid_ns(current));
-	event->id		= atomic64_inc_return(&perf_event_id);
+	event->id		= atomic64_inc_return_unchecked(&perf_event_id);
 
 	event->state		= PERF_EVENT_STATE_INACTIVE;
 
@@ -9397,6 +9404,11 @@ SYSCALL_DEFINE5(perf_event_open,
 	if (flags & ~PERF_FLAG_ALL)
 		return -EINVAL;
 
+#ifdef CONFIG_GRKERNSEC_PERF_HARDEN
+	if (perf_paranoid_any() && !capable(CAP_SYS_ADMIN))
+		return -EACCES;
+#endif
+
 	err = perf_copy_attr(attr_uptr, &attr);
 	if (err)
 		return err;
@@ -9914,10 +9926,10 @@ static void sync_child_event(struct perf_event *child_event,
 	/*
 	 * Add back the child's count to the parent's count:
 	 */
-	atomic64_add(child_val, &parent_event->child_count);
-	atomic64_add(child_event->total_time_enabled,
+	atomic64_add_unchecked(child_val, &parent_event->child_count);
+	atomic64_add_unchecked(child_event->total_time_enabled,
 		     &parent_event->child_total_time_enabled);
-	atomic64_add(child_event->total_time_running,
+	atomic64_add_unchecked(child_event->total_time_running,
 		     &parent_event->child_total_time_running);
 }
 
diff --git a/kernel/events/hw_breakpoint.c b/kernel/events/hw_breakpoint.c
index 3f8cb1e14..83f043852 100644
--- a/kernel/events/hw_breakpoint.c
+++ b/kernel/events/hw_breakpoint.c
@@ -30,6 +30,7 @@
  * This file contains the arch-independent routines.
  */
 
+#include <linux/bug.h>
 #include <linux/irqflags.h>
 #include <linux/kallsyms.h>
 #include <linux/notifier.h>
diff --git a/kernel/events/internal.h b/kernel/events/internal.h
index 486fd78eb..96062d7f0 100644
--- a/kernel/events/internal.h
+++ b/kernel/events/internal.h
@@ -150,10 +150,10 @@ static inline unsigned long perf_aux_size(struct ring_buffer *rb)
 	return len;							\
 }
 
-#define DEFINE_OUTPUT_COPY(func_name, memcpy_func)			\
+#define DEFINE_OUTPUT_COPY(func_name, memcpy_func, user)		\
 static inline unsigned long						\
 func_name(struct perf_output_handle *handle,				\
-	  const void *buf, unsigned long len)				\
+	  const void user *buf, unsigned long len)			\
 __DEFINE_OUTPUT_COPY_BODY(true, memcpy_func, handle->addr, buf, size)
 
 static inline unsigned long
@@ -172,7 +172,7 @@ memcpy_common(void *dst, const void *src, unsigned long n)
 	return 0;
 }
 
-DEFINE_OUTPUT_COPY(__output_copy, memcpy_common)
+DEFINE_OUTPUT_COPY(__output_copy, memcpy_common, )
 
 static inline unsigned long
 memcpy_skip(void *dst, const void *src, unsigned long n)
@@ -180,7 +180,7 @@ memcpy_skip(void *dst, const void *src, unsigned long n)
 	return 0;
 }
 
-DEFINE_OUTPUT_COPY(__output_skip, memcpy_skip)
+DEFINE_OUTPUT_COPY(__output_skip, memcpy_skip, )
 
 #ifndef arch_perf_out_copy_user
 #define arch_perf_out_copy_user arch_perf_out_copy_user
@@ -198,7 +198,7 @@ arch_perf_out_copy_user(void *dst, const void *src, unsigned long n)
 }
 #endif
 
-DEFINE_OUTPUT_COPY(__output_copy_user, arch_perf_out_copy_user)
+DEFINE_OUTPUT_COPY(__output_copy_user, arch_perf_out_copy_user, __user)
 
 /* Callchain handling */
 extern struct perf_callchain_entry *
diff --git a/kernel/events/uprobes.c b/kernel/events/uprobes.c
index 8c50276b6..457c5997c 100644
--- a/kernel/events/uprobes.c
+++ b/kernel/events/uprobes.c
@@ -1695,7 +1695,7 @@ static int is_trap_at_addr(struct mm_struct *mm, unsigned long vaddr)
 {
 	struct page *page;
 	uprobe_opcode_t opcode;
-	int result;
+	long result;
 
 	pagefault_disable();
 	result = __get_user(opcode, (uprobe_opcode_t __user *)vaddr);
diff --git a/kernel/exit.c b/kernel/exit.c
index 091a78be3..7d6001bc0 100644
--- a/kernel/exit.c
+++ b/kernel/exit.c
@@ -170,6 +170,10 @@ void release_task(struct task_struct *p)
 	struct task_struct *leader;
 	int zap_leader;
 repeat:
+#ifdef CONFIG_NET
+	gr_del_task_from_ip_table(p);
+#endif
+
 	/* don't need to get the RCU readlock here - the process is dead and
 	 * can't be modifying its own credentials. But shut RCU-lockdep up */
 	rcu_read_lock();
@@ -525,9 +529,8 @@ static struct task_struct *find_alive_thread(struct task_struct *p)
 	return NULL;
 }
 
+static struct task_struct *find_child_reaper(struct task_struct *father) __must_hold(&tasklist_lock);
 static struct task_struct *find_child_reaper(struct task_struct *father)
-	__releases(&tasklist_lock)
-	__acquires(&tasklist_lock)
 {
 	struct pid_namespace *pid_ns = task_active_pid_ns(father);
 	struct task_struct *reaper = pid_ns->child_reaper;
@@ -624,6 +627,8 @@ static void reparent_leader(struct task_struct *father, struct task_struct *p,
  *	jobs, send them a SIGHUP and then a SIGCONT.  (POSIX 3.2.2.2)
  */
 static void forget_original_parent(struct task_struct *father,
+					struct list_head *dead) __must_hold(&tasklist_lock);
+static void forget_original_parent(struct task_struct *father,
 					struct list_head *dead)
 {
 	struct task_struct *p, *t, *reaper;
@@ -731,6 +736,15 @@ void do_exit(long code)
 	int group_dead;
 	TASKS_RCU(int tasks_rcu_i);
 
+	/*
+	 * If do_exit is called because this processes oopsed, it's possible
+	 * that get_fs() was left as KERNEL_DS, so reset it to USER_DS before
+	 * continuing. Amongst other possible reasons, this is to prevent
+	 * mm_release()->clear_child_tid() from writing to a user-controlled
+	 * kernel address.
+	 */
+	set_fs(USER_DS);
+
 	profile_task_exit(tsk);
 	kcov_task_exit(tsk);
 
@@ -741,15 +755,6 @@ void do_exit(long code)
 	if (unlikely(!tsk->pid))
 		panic("Attempted to kill the idle task!");
 
-	/*
-	 * If do_exit is called because this processes oopsed, it's possible
-	 * that get_fs() was left as KERNEL_DS, so reset it to USER_DS before
-	 * continuing. Amongst other possible reasons, this is to prevent
-	 * mm_release()->clear_child_tid() from writing to a user-controlled
-	 * kernel address.
-	 */
-	set_fs(USER_DS);
-
 	ptrace_event(PTRACE_EVENT_EXIT, code);
 
 	validate_creds_for_do_exit(tsk);
@@ -812,6 +817,9 @@ void do_exit(long code)
 	tsk->exit_code = code;
 	taskstats_exit(tsk, group_dead);
 
+	gr_acl_handle_psacct(tsk, code);
+	gr_acl_handle_exit();
+
 	exit_mm(tsk);
 
 	if (group_dead)
@@ -926,7 +934,7 @@ SYSCALL_DEFINE1(exit, int, error_code)
  * Take down every thread in the group.  This is called by fatal signals
  * as well as by sys_exit_group (below).
  */
-void
+__noreturn void
 do_group_exit(int exit_code)
 {
 	struct signal_struct *sig = current->signal;
@@ -1054,6 +1062,7 @@ static int wait_noreap_copyout(struct wait_opts *wo, struct task_struct *p,
  * the lock and this task is uninteresting.  If we return nonzero, we have
  * released the lock and the system call should return.
  */
+static int wait_task_zombie(struct wait_opts *wo, struct task_struct *p) __must_hold(&tasklist_lock);
 static int wait_task_zombie(struct wait_opts *wo, struct task_struct *p)
 {
 	int state, retval, status;
@@ -1070,6 +1079,7 @@ static int wait_task_zombie(struct wait_opts *wo, struct task_struct *p)
 
 		get_task_struct(p);
 		read_unlock(&tasklist_lock);
+		__acquire(&tasklist_lock); // XXX sparse can't model conditional release
 		sched_annotate_sleep();
 
 		if ((exit_code & 0x7f) == 0) {
@@ -1092,6 +1102,7 @@ static int wait_task_zombie(struct wait_opts *wo, struct task_struct *p)
 	 * We own this thread, nobody else can reap it.
 	 */
 	read_unlock(&tasklist_lock);
+	__acquire(&tasklist_lock); // XXX sparse can't model conditional release
 	sched_annotate_sleep();
 
 	/*
@@ -1234,6 +1245,8 @@ static int *task_stopped_code(struct task_struct *p, bool ptrace)
  * search should terminate.
  */
 static int wait_task_stopped(struct wait_opts *wo,
+				int ptrace, struct task_struct *p) __must_hold(&tasklist_lock);
+static int wait_task_stopped(struct wait_opts *wo,
 				int ptrace, struct task_struct *p)
 {
 	struct siginfo __user *infop;
@@ -1281,6 +1294,7 @@ unlock_sig:
 	pid = task_pid_vnr(p);
 	why = ptrace ? CLD_TRAPPED : CLD_STOPPED;
 	read_unlock(&tasklist_lock);
+	__acquire(&tasklist_lock); // XXX sparse can't model conditional release
 	sched_annotate_sleep();
 
 	if (unlikely(wo->wo_flags & WNOWAIT))
@@ -1318,6 +1332,7 @@ unlock_sig:
  * the lock and this task is uninteresting.  If we return nonzero, we have
  * released the lock and the system call should return.
  */
+static int wait_task_continued(struct wait_opts *wo, struct task_struct *p) __must_hold(&tasklist_lock);
 static int wait_task_continued(struct wait_opts *wo, struct task_struct *p)
 {
 	int retval;
@@ -1344,6 +1359,7 @@ static int wait_task_continued(struct wait_opts *wo, struct task_struct *p)
 	pid = task_pid_vnr(p);
 	get_task_struct(p);
 	read_unlock(&tasklist_lock);
+	__acquire(&tasklist_lock); // XXX sparse can't model conditional release
 	sched_annotate_sleep();
 
 	if (!wo->wo_info) {
@@ -1373,6 +1389,8 @@ static int wait_task_continued(struct wait_opts *wo, struct task_struct *p)
  * or another error from security_task_wait(), or still -ECHILD.
  */
 static int wait_consider_task(struct wait_opts *wo, int ptrace,
+				struct task_struct *p) __must_hold(&tasklist_lock);
+static int wait_consider_task(struct wait_opts *wo, int ptrace,
 				struct task_struct *p)
 {
 	/*
@@ -1498,6 +1516,7 @@ static int wait_consider_task(struct wait_opts *wo, int ptrace,
  * ->notask_error is 0 if there were any eligible children,
  * or another error from security_task_wait(), or still -ECHILD.
  */
+static int do_wait_thread(struct wait_opts *wo, struct task_struct *tsk) __must_hold(&tasklist_lock);
 static int do_wait_thread(struct wait_opts *wo, struct task_struct *tsk)
 {
 	struct task_struct *p;
@@ -1512,6 +1531,7 @@ static int do_wait_thread(struct wait_opts *wo, struct task_struct *tsk)
 	return 0;
 }
 
+static int ptrace_do_wait(struct wait_opts *wo, struct task_struct *tsk) __must_hold(&tasklist_lock);
 static int ptrace_do_wait(struct wait_opts *wo, struct task_struct *tsk)
 {
 	struct task_struct *p;
@@ -1575,12 +1595,16 @@ repeat:
 	tsk = current;
 	do {
 		retval = do_wait_thread(wo, tsk);
-		if (retval)
+		if (retval) {
+			__release(&tasklist_lock); // XXX sparse can't model conditional release
 			goto end;
+		}
 
 		retval = ptrace_do_wait(wo, tsk);
-		if (retval)
+		if (retval) {
+			__release(&tasklist_lock); // XXX sparse can't model conditional release
 			goto end;
+		}
 
 		if (wo->wo_flags & __WNOTHREAD)
 			break;
diff --git a/kernel/extable.c b/kernel/extable.c
index e820ccee9..72195de98 100644
--- a/kernel/extable.c
+++ b/kernel/extable.c
@@ -23,6 +23,7 @@
 
 #include <asm/sections.h>
 #include <asm/uaccess.h>
+#include <asm/setup.h>
 
 /*
  * mutex protecting text section modification (dynamic code patching).
@@ -41,10 +42,22 @@ u32 __initdata __visible main_extable_sort_needed = 1;
 /* Sort the kernel's built-in exception table */
 void __init sort_main_extable(void)
 {
-	if (main_extable_sort_needed && __stop___ex_table > __start___ex_table) {
+	struct exception_table_entry *start = __start___ex_table;
+
+	if (main_extable_sort_needed && __stop___ex_table > start) {
 		pr_notice("Sorting __ex_table...\n");
-		sort_extable(__start___ex_table, __stop___ex_table);
+		sort_extable(start, __stop___ex_table);
+	}
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	while (start < __stop___ex_table) {
+		start->insn -= kaslr_offset();
+		start->fixup -= kaslr_offset();
+		start->handler -= kaslr_offset();
+		start++;
 	}
+#endif
+
 }
 
 /* Given an address, look for it in the exception tables. */
diff --git a/kernel/fork.c b/kernel/fork.c
index 9f8dae785..ead3c277d 100644
--- a/kernel/fork.c
+++ b/kernel/fork.c
@@ -188,13 +188,56 @@ static void free_thread_stack(unsigned long *stack)
 
 void thread_stack_cache_init(void)
 {
-	thread_stack_cache = kmem_cache_create("thread_stack", THREAD_SIZE,
-					      THREAD_SIZE, 0, NULL);
+	thread_stack_cache = kmem_cache_create_usercopy("thread_stack", THREAD_SIZE,
+					      THREAD_SIZE, 0, 0, THREAD_SIZE, NULL);
 	BUG_ON(thread_stack_cache == NULL);
 }
 # endif
 #endif
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+static inline unsigned long *gr_alloc_thread_stack_node(struct task_struct *tsk,
+						  int node, void **lowmem_stack)
+{
+	struct page *pages[THREAD_SIZE / PAGE_SIZE];
+	void *ret = NULL;
+	unsigned int i;
+
+	*lowmem_stack = alloc_thread_stack_node(tsk, node);
+	if (*lowmem_stack == NULL)
+		goto out;
+
+	for (i = 0; i < THREAD_SIZE / PAGE_SIZE; i++)
+		pages[i] = virt_to_page(*lowmem_stack + (i * PAGE_SIZE));
+	
+	/* use VM_IOREMAP to gain THREAD_SIZE alignment */
+	ret = vmap(pages, THREAD_SIZE / PAGE_SIZE, VM_IOREMAP, PAGE_KERNEL);
+	if (ret == NULL) {
+		free_thread_stack(*lowmem_stack);
+		*lowmem_stack = NULL;
+	} else
+		populate_stack(ret, THREAD_SIZE);
+
+out:
+	return ret;
+}
+
+static inline void gr_free_thread_stack(struct task_struct *tsk, unsigned long *stack)
+{
+	unmap_process_stacks(tsk);
+}
+#else
+static inline unsigned long *gr_alloc_thread_stack_node(struct task_struct *tsk,
+						  int node, void **lowmem_stack)
+{
+	return alloc_thread_stack_node(tsk, node);
+}
+static inline void gr_free_thread_stack(struct task_struct *tsk, unsigned long *stack)
+{
+	free_thread_stack(stack);
+}
+#endif
+
 /* SLAB cache for signal_struct structures (tsk->signal) */
 static struct kmem_cache *signal_cachep;
 
@@ -213,10 +256,14 @@ struct kmem_cache *vm_area_cachep;
 /* SLAB cache for mm_struct structures (tsk->mm) */
 static struct kmem_cache *mm_cachep;
 
-static void account_kernel_stack(unsigned long *stack, int account)
+static void account_kernel_stack(struct task_struct *tsk, unsigned long *stack, int account)
 {
 	/* All stack pages are in the same zone and belong to the same memcg. */
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	struct page *first_page = virt_to_page(tsk->lowmem_stack);
+#else
 	struct page *first_page = virt_to_page(stack);
+#endif
 
 	mod_zone_page_state(page_zone(first_page), NR_KERNEL_STACK_KB,
 			    THREAD_SIZE / 1024 * account);
@@ -228,9 +275,9 @@ static void account_kernel_stack(unsigned long *stack, int account)
 
 void free_task(struct task_struct *tsk)
 {
-	account_kernel_stack(tsk->stack, -1);
+	account_kernel_stack(tsk, tsk->stack, -1);
 	arch_release_thread_stack(tsk->stack);
-	free_thread_stack(tsk->stack);
+	gr_free_thread_stack(tsk, tsk->stack);
 	rt_mutex_debug_task_free(tsk);
 	ftrace_graph_exit_task(tsk);
 	put_seccomp_filter(tsk);
@@ -297,7 +344,7 @@ static void set_max_threads(unsigned int max_threads_suggested)
 
 #ifdef CONFIG_ARCH_WANTS_DYNAMIC_TASK_STRUCT
 /* Initialized by the architecture: */
-int arch_task_struct_size __read_mostly;
+size_t arch_task_struct_size __read_mostly;
 #endif
 
 void __init fork_init(void)
@@ -307,9 +354,12 @@ void __init fork_init(void)
 #define ARCH_MIN_TASKALIGN	L1_CACHE_BYTES
 #endif
 	/* create a slab on which task_structs can be allocated */
-	task_struct_cachep = kmem_cache_create("task_struct",
+	task_struct_cachep = kmem_cache_create_usercopy("task_struct",
 			arch_task_struct_size, ARCH_MIN_TASKALIGN,
-			SLAB_PANIC|SLAB_NOTRACK|SLAB_ACCOUNT, NULL);
+			SLAB_PANIC|SLAB_NOTRACK|SLAB_ACCOUNT,
+			offsetof(struct task_struct, blocked),
+			sizeof(init_task.blocked) + sizeof(init_task.saved_sigmask),
+			NULL);
 #endif
 
 	/* do the arch specific task caches init */
@@ -342,6 +392,7 @@ static struct task_struct *dup_task_struct(struct task_struct *orig, int node)
 {
 	struct task_struct *tsk;
 	unsigned long *stack;
+	void *lowmem_stack;
 	int err;
 
 	if (node == NUMA_NO_NODE)
@@ -350,7 +401,7 @@ static struct task_struct *dup_task_struct(struct task_struct *orig, int node)
 	if (!tsk)
 		return NULL;
 
-	stack = alloc_thread_stack_node(tsk, node);
+	stack = gr_alloc_thread_stack_node(tsk, node, &lowmem_stack);
 	if (!stack)
 		goto free_tsk;
 
@@ -359,6 +410,10 @@ static struct task_struct *dup_task_struct(struct task_struct *orig, int node)
 		goto free_stack;
 
 	tsk->stack = stack;
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	tsk->lowmem_stack = lowmem_stack;
+#endif
+
 #ifdef CONFIG_SECCOMP
 	/*
 	 * We must handle setting up seccomp filters once we're under
@@ -375,7 +430,7 @@ static struct task_struct *dup_task_struct(struct task_struct *orig, int node)
 	set_task_stack_end_magic(tsk);
 
 #ifdef CONFIG_CC_STACKPROTECTOR
-	tsk->stack_canary = get_random_int();
+	tsk->stack_canary = pax_get_random_long();
 #endif
 
 	/*
@@ -390,26 +445,92 @@ static struct task_struct *dup_task_struct(struct task_struct *orig, int node)
 	tsk->task_frag.page = NULL;
 	tsk->wake_q.next = NULL;
 
-	account_kernel_stack(stack, 1);
+	account_kernel_stack(tsk, stack, 1);
 
 	kcov_task_init(tsk);
 
 	return tsk;
 
 free_stack:
-	free_thread_stack(stack);
+	gr_free_thread_stack(tsk, stack);
 free_tsk:
 	free_task_struct(tsk);
 	return NULL;
 }
 
 #ifdef CONFIG_MMU
-static int dup_mmap(struct mm_struct *mm, struct mm_struct *oldmm)
+static struct vm_area_struct *dup_vma(struct mm_struct *mm, struct mm_struct *oldmm, struct vm_area_struct *mpnt)
+{
+	struct vm_area_struct *tmp;
+	unsigned long charge;
+	struct file *file;
+	int retval;
+
+	charge = 0;
+	if (mpnt->vm_flags & VM_ACCOUNT) {
+		unsigned long len = vma_pages(mpnt);
+
+		if (security_vm_enough_memory_mm(oldmm, len)) /* sic */
+			goto fail_nomem;
+		charge = len;
+	}
+	tmp = kmem_cache_alloc(vm_area_cachep, GFP_KERNEL);
+	if (!tmp)
+		goto fail_nomem;
+	*tmp = *mpnt;
+	tmp->vm_mm = mm;
+	INIT_LIST_HEAD(&tmp->anon_vma_chain);
+	retval = vma_dup_policy(mpnt, tmp);
+	if (retval)
+		goto fail_nomem_policy;
+	if (anon_vma_fork(tmp, mpnt))
+		goto fail_nomem_anon_vma_fork;
+	tmp->vm_flags &= ~(VM_LOCKED|VM_LOCKONFAULT|VM_UFFD_MISSING|VM_UFFD_WP);
+	tmp->vm_next = tmp->vm_prev = NULL;
+	tmp->vm_mirror = NULL;
+	tmp->vm_userfaultfd_ctx = NULL_VM_UFFD_CTX;
+	file = tmp->vm_file;
+	if (file) {
+		struct inode *inode = file_inode(file);
+		struct address_space *mapping = file->f_mapping;
+
+		get_file(file);
+		if (tmp->vm_flags & VM_DENYWRITE)
+			atomic_dec(&inode->i_writecount);
+		i_mmap_lock_write(mapping);
+		if (tmp->vm_flags & VM_SHARED)
+			atomic_inc(&mapping->i_mmap_writable);
+		flush_dcache_mmap_lock(mapping);
+		/* insert tmp into the share list, just after mpnt */
+		vma_interval_tree_insert_after(tmp, mpnt, &mapping->i_mmap);
+		flush_dcache_mmap_unlock(mapping);
+		i_mmap_unlock_write(mapping);
+	}
+
+	/*
+	 * Clear hugetlb-related page reserves for children. This only
+	 * affects MAP_PRIVATE mappings. Faults generated by the child
+	 * are not guaranteed to succeed, even if read-only
+	 */
+	if (is_vm_hugetlb_page(tmp))
+		reset_vma_resv_huge_pages(tmp);
+
+	return tmp;
+
+fail_nomem_anon_vma_fork:
+	mpol_put(vma_policy(tmp));
+fail_nomem_policy:
+	kmem_cache_free(vm_area_cachep, tmp);
+fail_nomem:
+	vm_unacct_memory(charge);
+	return NULL;
+}
+
+static __latent_entropy int dup_mmap(struct mm_struct *mm, struct mm_struct *oldmm)
 {
 	struct vm_area_struct *mpnt, *tmp, *prev, **pprev;
 	struct rb_node **rb_link, *rb_parent;
 	int retval;
-	unsigned long charge;
 
 	uprobe_start_dup_mmap();
 	if (down_write_killable(&oldmm->mmap_sem)) {
@@ -443,52 +564,14 @@ static int dup_mmap(struct mm_struct *mm, struct mm_struct *oldmm)
 
 	prev = NULL;
 	for (mpnt = oldmm->mmap; mpnt; mpnt = mpnt->vm_next) {
-		struct file *file;
-
 		if (mpnt->vm_flags & VM_DONTCOPY) {
 			vm_stat_account(mm, mpnt->vm_flags, -vma_pages(mpnt));
 			continue;
 		}
-		charge = 0;
-		if (mpnt->vm_flags & VM_ACCOUNT) {
-			unsigned long len = vma_pages(mpnt);
-
-			if (security_vm_enough_memory_mm(oldmm, len)) /* sic */
-				goto fail_nomem;
-			charge = len;
-		}
-		tmp = kmem_cache_alloc(vm_area_cachep, GFP_KERNEL);
-		if (!tmp)
-			goto fail_nomem;
-		*tmp = *mpnt;
-		INIT_LIST_HEAD(&tmp->anon_vma_chain);
-		retval = vma_dup_policy(mpnt, tmp);
-		if (retval)
-			goto fail_nomem_policy;
-		tmp->vm_mm = mm;
-		if (anon_vma_fork(tmp, mpnt))
-			goto fail_nomem_anon_vma_fork;
-		tmp->vm_flags &=
-			~(VM_LOCKED|VM_LOCKONFAULT|VM_UFFD_MISSING|VM_UFFD_WP);
-		tmp->vm_next = tmp->vm_prev = NULL;
-		tmp->vm_userfaultfd_ctx = NULL_VM_UFFD_CTX;
-		file = tmp->vm_file;
-		if (file) {
-			struct inode *inode = file_inode(file);
-			struct address_space *mapping = file->f_mapping;
-
-			get_file(file);
-			if (tmp->vm_flags & VM_DENYWRITE)
-				atomic_dec(&inode->i_writecount);
-			i_mmap_lock_write(mapping);
-			if (tmp->vm_flags & VM_SHARED)
-				atomic_inc(&mapping->i_mmap_writable);
-			flush_dcache_mmap_lock(mapping);
-			/* insert tmp into the share list, just after mpnt */
-			vma_interval_tree_insert_after(tmp, mpnt,
-					&mapping->i_mmap);
-			flush_dcache_mmap_unlock(mapping);
-			i_mmap_unlock_write(mapping);
+		tmp = dup_vma(mm, oldmm, mpnt);
+		if (!tmp) {
+			retval = -ENOMEM;
+			goto out;
 		}
 
 		/*
@@ -520,6 +603,38 @@ static int dup_mmap(struct mm_struct *mm, struct mm_struct *oldmm)
 		if (retval)
 			goto out;
 	}
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (oldmm->pax_flags & MF_PAX_SEGMEXEC) {
+		struct vm_area_struct *mpnt_m;
+
+		for (mpnt = oldmm->mmap, mpnt_m = mm->mmap; mpnt; mpnt = mpnt->vm_next) {
+			if (mpnt->vm_flags & VM_DONTCOPY)
+				continue;
+
+			BUG_ON(!mpnt_m || mpnt_m->vm_mirror || mpnt->vm_mm != oldmm || mpnt_m->vm_mm != mm);
+
+			if (!mpnt->vm_mirror) {
+				mpnt_m = mpnt_m->vm_next;
+				continue;
+			}
+
+			if (mpnt->vm_end <= SEGMEXEC_TASK_SIZE) {
+				BUG_ON(mpnt->vm_mirror->vm_mirror != mpnt);
+				mpnt->vm_mirror = mpnt_m;
+			} else {
+				BUG_ON(mpnt->vm_mirror->vm_mirror == mpnt || mpnt->vm_mirror->vm_mirror->vm_mm != mm);
+				mpnt_m->vm_mirror = mpnt->vm_mirror->vm_mirror;
+				mpnt_m->vm_mirror->vm_mirror = mpnt_m;
+				mpnt->vm_mirror->vm_mirror = mpnt;
+			}
+
+			mpnt_m = mpnt_m->vm_next;
+		}
+		BUG_ON(mpnt_m);
+	}
+#endif
+
 	/* a new mm has just been created */
 	arch_dup_mmap(oldmm, mm);
 	retval = 0;
@@ -530,14 +645,6 @@ out:
 fail_uprobe_end:
 	uprobe_end_dup_mmap();
 	return retval;
-fail_nomem_anon_vma_fork:
-	mpol_put(vma_policy(tmp));
-fail_nomem_policy:
-	kmem_cache_free(vm_area_cachep, tmp);
-fail_nomem:
-	retval = -ENOMEM;
-	vm_unacct_memory(charge);
-	goto out;
 }
 
 static inline int mm_alloc_pgd(struct mm_struct *mm)
@@ -860,8 +967,8 @@ struct mm_struct *mm_access(struct task_struct *task, unsigned int mode)
 		return ERR_PTR(err);
 
 	mm = get_task_mm(task);
-	if (mm && mm != current->mm &&
-			!ptrace_may_access(task, mode)) {
+	if (mm && ((mm != current->mm && !ptrace_may_access(task, mode)) ||
+		  ((mode & PTRACE_MODE_ATTACH) && (gr_handle_proc_ptrace(task) || gr_acl_handle_procpidmem(task))))) {
 		mmput(mm);
 		mm = ERR_PTR(-EACCES);
 	}
@@ -1060,13 +1167,20 @@ static int copy_fs(unsigned long clone_flags, struct task_struct *tsk)
 			spin_unlock(&fs->lock);
 			return -EAGAIN;
 		}
-		fs->users++;
+		atomic_inc(&fs->users);
 		spin_unlock(&fs->lock);
 		return 0;
 	}
 	tsk->fs = copy_fs_struct(fs);
 	if (!tsk->fs)
 		return -ENOMEM;
+	/* Carry through gr_chroot_dentry and is_chrooted instead
+	   of recomputing it here.  Already copied when the task struct
+	   is duplicated.  This allows pivot_root to not be treated as
+	   a chroot
+	*/
+	//gr_set_chroot_entries(tsk, &tsk->fs->root);
+
 	return 0;
 }
 
@@ -1299,7 +1413,7 @@ init_task_pid(struct task_struct *task, enum pid_type type, struct pid *pid)
  * parts of the process environment (as per the clone
  * flags). The actual kick-off is left to the caller.
  */
-static struct task_struct *copy_process(unsigned long clone_flags,
+static __latent_entropy struct task_struct *copy_process(unsigned long clone_flags,
 					unsigned long stack_start,
 					unsigned long stack_size,
 					int __user *child_tidptr,
@@ -1371,6 +1485,9 @@ static struct task_struct *copy_process(unsigned long clone_flags,
 	DEBUG_LOCKS_WARN_ON(!p->softirqs_enabled);
 #endif
 	retval = -EAGAIN;
+
+	gr_learn_resource(p, RLIMIT_NPROC, atomic_read(&p->real_cred->user->processes), 0);
+
 	if (atomic_read(&p->real_cred->user->processes) >=
 			task_rlimit(p, RLIMIT_NPROC)) {
 		if (p->real_cred->user != INIT_USER &&
@@ -1629,6 +1746,16 @@ static struct task_struct *copy_process(unsigned long clone_flags,
 		goto bad_fork_cancel_cgroup;
 	}
 
+	/* synchronizes with gr_set_acls()
+	   we need to call this past the point of no return for fork()
+	*/
+	gr_copy_label(p);
+
+#ifdef CONFIG_GRKERNSEC_SETXID
+	if (p->delayed_cred)
+		get_cred(p->delayed_cred);
+#endif
+
 	if (likely(p->pid)) {
 		ptrace_init_task(p, (clone_flags & CLONE_PTRACE) || trace);
 
@@ -1720,6 +1847,8 @@ bad_fork_cleanup_count:
 bad_fork_free:
 	free_task(p);
 fork_out:
+	gr_log_forkfail(retval);
+
 	return ERR_PTR(retval);
 }
 
@@ -1783,6 +1912,7 @@ long _do_fork(unsigned long clone_flags,
 
 	p = copy_process(clone_flags, stack_start, stack_size,
 			 child_tidptr, NULL, trace, tls, NUMA_NO_NODE);
+	add_latent_entropy();
 	/*
 	 * Do this prior waking up the new thread - the thread pointer
 	 * might get invalid after that point, if the thread exits quickly.
@@ -1799,6 +1929,8 @@ long _do_fork(unsigned long clone_flags,
 		if (clone_flags & CLONE_PARENT_SETTID)
 			put_user(nr, parent_tidptr);
 
+		gr_handle_brute_check();
+
 		if (clone_flags & CLONE_VFORK) {
 			p->vfork_done = &vfork;
 			init_completion(&vfork);
@@ -1931,11 +2063,12 @@ void __init proc_caches_init(void)
 	 * maximum number of CPU's we can ever have.  The cpumask_allocation
 	 * is at the end of the structure, exactly for that reason.
 	 */
-	mm_cachep = kmem_cache_create("mm_struct",
+	mm_cachep = kmem_cache_create_usercopy("mm_struct",
 			sizeof(struct mm_struct), ARCH_MIN_MMSTRUCT_ALIGN,
 			SLAB_HWCACHE_ALIGN|SLAB_PANIC|SLAB_NOTRACK|SLAB_ACCOUNT,
+			offsetof(struct mm_struct, saved_auxv), sizeof(init_mm.saved_auxv),
 			NULL);
-	vm_area_cachep = KMEM_CACHE(vm_area_struct, SLAB_PANIC|SLAB_ACCOUNT);
+	vm_area_cachep = KMEM_CACHE(vm_area_struct, SLAB_PANIC|SLAB_ACCOUNT|SLAB_NO_SANITIZE);
 	mmap_init();
 	nsproxy_cache_init();
 }
@@ -1983,7 +2116,7 @@ static int unshare_fs(unsigned long unshare_flags, struct fs_struct **new_fsp)
 		return 0;
 
 	/* don't need lock here; in the worst case we'll do useless copy */
-	if (fs->users == 1)
+	if (atomic_read(&fs->users) == 1)
 		return 0;
 
 	*new_fsp = copy_fs_struct(fs);
@@ -2096,7 +2229,8 @@ SYSCALL_DEFINE1(unshare, unsigned long, unshare_flags)
 			fs = current->fs;
 			spin_lock(&fs->lock);
 			current->fs = new_fs;
-			if (--fs->users)
+			gr_set_chroot_entries(current, &current->fs->root);
+			if (atomic_dec_return(&fs->users))
 				new_fs = NULL;
 			else
 				new_fs = fs;
@@ -2160,7 +2294,7 @@ int unshare_files(struct files_struct **displaced)
 int sysctl_max_threads(struct ctl_table *table, int write,
 		       void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table t;
+	ctl_table_no_const t;
 	int ret;
 	int threads = max_threads;
 	int min = MIN_THREADS;
diff --git a/kernel/futex.c b/kernel/futex.c
index 46cb3a301..96207f8ef 100644
--- a/kernel/futex.c
+++ b/kernel/futex.c
@@ -210,7 +210,7 @@ struct futex_pi_state {
 	atomic_t refcount;
 
 	union futex_key key;
-};
+} __randomize_layout;
 
 /**
  * struct futex_q - The hashed futex queue entry, one per waiting task
@@ -244,7 +244,7 @@ struct futex_q {
 	struct rt_mutex_waiter *rt_waiter;
 	union futex_key *requeue_pi_key;
 	u32 bitset;
-};
+} __randomize_layout;
 
 static const struct futex_q futex_q_init = {
 	/* list gets initialized in queue_me()*/
@@ -494,6 +494,11 @@ get_futex_key(u32 __user *uaddr, int fshared, union futex_key *key, int rw)
 	struct address_space *mapping;
 	int err, ro = 0;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((mm->pax_flags & MF_PAX_SEGMEXEC) && address >= SEGMEXEC_TASK_SIZE)
+		return -EFAULT;
+#endif
+
 	/*
 	 * The futex address must be "naturally" aligned.
 	 */
@@ -3270,6 +3275,7 @@ static void __init futex_detect_cmpxchg(void)
 {
 #ifndef CONFIG_HAVE_FUTEX_CMPXCHG
 	u32 curval;
+	mm_segment_t oldfs;
 
 	/*
 	 * This will fail and we want it. Some arch implementations do
@@ -3281,8 +3287,11 @@ static void __init futex_detect_cmpxchg(void)
 	 * implementation, the non-functional ones will return
 	 * -ENOSYS.
 	 */
+	oldfs = get_fs();
+	set_fs(USER_DS);
 	if (cmpxchg_futex_value_locked(&curval, NULL, 0, 0) == -EFAULT)
 		futex_cmpxchg_enabled = 1;
+	set_fs(oldfs);
 #endif
 }
 
diff --git a/kernel/futex_compat.c b/kernel/futex_compat.c
index 4ae3232e7..5adee0251 100644
--- a/kernel/futex_compat.c
+++ b/kernel/futex_compat.c
@@ -32,7 +32,7 @@ fetch_robust_entry(compat_uptr_t *uentry, struct robust_list __user **entry,
 	return 0;
 }
 
-static void __user *futex_uaddr(struct robust_list __user *entry,
+static void __user __intentional_overflow(-1) *futex_uaddr(struct robust_list __user *entry,
 				compat_long_t futex_offset)
 {
 	compat_uptr_t base = ptr_to_compat(entry);
diff --git a/kernel/irq/manage.c b/kernel/irq/manage.c
index 9d592c66f..9f6bd5e0b 100644
--- a/kernel/irq/manage.c
+++ b/kernel/irq/manage.c
@@ -972,7 +972,7 @@ static int irq_thread(void *data)
 
 		action_ret = handler_fn(desc, action);
 		if (action_ret == IRQ_HANDLED)
-			atomic_inc(&desc->threads_handled);
+			atomic_inc_unchecked(&desc->threads_handled);
 		if (action_ret == IRQ_WAKE_THREAD)
 			irq_wake_secondary(desc, action);
 
diff --git a/kernel/irq/msi.c b/kernel/irq/msi.c
index 19e9dfbe9..0766454e6 100644
--- a/kernel/irq/msi.c
+++ b/kernel/irq/msi.c
@@ -214,16 +214,18 @@ static void msi_domain_update_dom_ops(struct msi_domain_info *info)
 		return;
 	}
 
+	pax_open_kernel();
 	if (ops->get_hwirq == NULL)
-		ops->get_hwirq = msi_domain_ops_default.get_hwirq;
+		const_cast(ops->get_hwirq) = msi_domain_ops_default.get_hwirq;
 	if (ops->msi_init == NULL)
-		ops->msi_init = msi_domain_ops_default.msi_init;
+		const_cast(ops->msi_init) = msi_domain_ops_default.msi_init;
 	if (ops->msi_check == NULL)
-		ops->msi_check = msi_domain_ops_default.msi_check;
+		const_cast(ops->msi_check) = msi_domain_ops_default.msi_check;
 	if (ops->msi_prepare == NULL)
-		ops->msi_prepare = msi_domain_ops_default.msi_prepare;
+		const_cast(ops->msi_prepare) = msi_domain_ops_default.msi_prepare;
 	if (ops->set_desc == NULL)
-		ops->set_desc = msi_domain_ops_default.set_desc;
+		const_cast(ops->set_desc) = msi_domain_ops_default.set_desc;
+	pax_close_kernel();
 }
 
 static void msi_domain_update_chip_ops(struct msi_domain_info *info)
@@ -231,8 +233,11 @@ static void msi_domain_update_chip_ops(struct msi_domain_info *info)
 	struct irq_chip *chip = info->chip;
 
 	BUG_ON(!chip || !chip->irq_mask || !chip->irq_unmask);
-	if (!chip->irq_set_affinity)
-		chip->irq_set_affinity = msi_domain_set_affinity;
+	if (!chip->irq_set_affinity) {
+		pax_open_kernel();
+		const_cast(chip->irq_set_affinity) = msi_domain_set_affinity;
+		pax_close_kernel();
+	}
 }
 
 /**
diff --git a/kernel/irq/spurious.c b/kernel/irq/spurious.c
index 5707f97a3..d526a3d7c 100644
--- a/kernel/irq/spurious.c
+++ b/kernel/irq/spurious.c
@@ -334,7 +334,7 @@ void note_interrupt(struct irq_desc *desc, irqreturn_t action_ret)
 			 * count. We just care about the count being
 			 * different than the one we saw before.
 			 */
-			handled = atomic_read(&desc->threads_handled);
+			handled = atomic_read_unchecked(&desc->threads_handled);
 			handled |= SPURIOUS_DEFERRED;
 			if (handled != desc->threads_handled_last) {
 				action_ret = IRQ_HANDLED;
diff --git a/kernel/jump_label.c b/kernel/jump_label.c
index 93ad6c1fb..139ea2a92 100644
--- a/kernel/jump_label.c
+++ b/kernel/jump_label.c
@@ -15,6 +15,7 @@
 #include <linux/static_key.h>
 #include <linux/jump_label_ratelimit.h>
 #include <linux/bug.h>
+#include <linux/mm.h>
 
 #ifdef HAVE_JUMP_LABEL
 
@@ -52,7 +53,9 @@ jump_label_sort_entries(struct jump_entry *start, struct jump_entry *stop)
 
 	size = (((unsigned long)stop - (unsigned long)start)
 					/ sizeof(struct jump_entry));
+	pax_open_kernel();
 	sort(start, size, sizeof(struct jump_entry), jump_label_cmp, NULL);
+	pax_close_kernel();
 }
 
 static void jump_label_update(struct static_key *key);
@@ -475,10 +478,12 @@ static void jump_label_invalidate_module_init(struct module *mod)
 	struct jump_entry *iter_stop = iter_start + mod->num_jump_entries;
 	struct jump_entry *iter;
 
+	pax_open_kernel();
 	for (iter = iter_start; iter < iter_stop; iter++) {
 		if (within_module_init(iter->code, mod))
 			iter->code = 0;
 	}
+	pax_close_kernel();
 }
 
 static int
diff --git a/kernel/kallsyms.c b/kernel/kallsyms.c
index fafd1a3ef..316983eb6 100644
--- a/kernel/kallsyms.c
+++ b/kernel/kallsyms.c
@@ -11,6 +11,9 @@
  *      Changed the compression method from stem compression to "table lookup"
  *      compression (see scripts/kallsyms.c for a more complete description)
  */
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+#define __INCLUDED_BY_HIDESYM 1
+#endif
 #include <linux/kallsyms.h>
 #include <linux/module.h>
 #include <linux/init.h>
@@ -58,12 +61,33 @@ extern const unsigned long kallsyms_markers[] __weak;
 
 static inline int is_kernel_inittext(unsigned long addr)
 {
+	if (system_state != SYSTEM_BOOTING)
+		return 0;
+
 	if (addr >= (unsigned long)_sinittext
 	    && addr <= (unsigned long)_einittext)
 		return 1;
 	return 0;
 }
 
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+#ifdef CONFIG_MODULES
+static inline int is_module_text(unsigned long addr)
+{
+	if ((unsigned long)MODULES_EXEC_VADDR <= addr && addr <= (unsigned long)MODULES_EXEC_END)
+		return 1;
+
+	addr = ktla_ktva(addr);
+	return (unsigned long)MODULES_EXEC_VADDR <= addr && addr <= (unsigned long)MODULES_EXEC_END;
+}
+#else
+static inline int is_module_text(unsigned long addr)
+{
+	return 0;
+}
+#endif
+#endif
+
 static inline int is_kernel_text(unsigned long addr)
 {
 	if ((addr >= (unsigned long)_stext && addr <= (unsigned long)_etext) ||
@@ -74,13 +98,28 @@ static inline int is_kernel_text(unsigned long addr)
 
 static inline int is_kernel(unsigned long addr)
 {
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	if (is_kernel_text(addr) || is_kernel_inittext(addr))
+		return 1;
+
+	if (ktla_ktva((unsigned long)_text) <= addr && addr < (unsigned long)_end)
+#else
 	if (addr >= (unsigned long)_stext && addr <= (unsigned long)_end)
+#endif
+
 		return 1;
 	return in_gate_area_no_mm(addr);
 }
 
 static int is_ksym_addr(unsigned long addr)
 {
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	if (is_module_text(addr))
+		return 0;
+#endif
+
 	if (all_var)
 		return is_kernel(addr);
 
@@ -458,10 +497,11 @@ int sprint_backtrace(char *buffer, unsigned long address)
 }
 
 /* Look up a kernel symbol and print it to the kernel messages. */
-void __print_symbol(const char *fmt, unsigned long address)
+void __print_symbol(const char *fmt, unsigned long address, ...)
 {
 	char buffer[KSYM_SYMBOL_LEN];
 
+	address = (unsigned long)__builtin_extract_return_addr((void *)address);
 	sprint_symbol(buffer, address);
 
 	printk(fmt, buffer);
@@ -505,7 +545,6 @@ static unsigned long get_ksymbol_core(struct kallsym_iter *iter)
 
 static void reset_iter(struct kallsym_iter *iter, loff_t new_pos)
 {
-	iter->name[0] = '\0';
 	iter->nameoff = get_symbol_offset(new_pos);
 	iter->pos = new_pos;
 }
@@ -553,6 +592,11 @@ static int s_show(struct seq_file *m, void *p)
 {
 	struct kallsym_iter *iter = m->private;
 
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	if (!uid_eq(current_uid(), GLOBAL_ROOT_UID))
+		return 0;
+#endif
+
 	/* Some debugging symbols have no name.  Ignore them. */
 	if (!iter->name[0])
 		return 0;
@@ -566,6 +610,7 @@ static int s_show(struct seq_file *m, void *p)
 		 */
 		type = iter->exported ? toupper(iter->type) :
 					tolower(iter->type);
+
 		seq_printf(m, "%pK %c %s\t[%s]\n", (void *)iter->value,
 			   type, iter->name, iter->module_name);
 	} else
diff --git a/kernel/kcmp.c b/kernel/kcmp.c
index 3a47fa998..bcb17e3f0 100644
--- a/kernel/kcmp.c
+++ b/kernel/kcmp.c
@@ -100,6 +100,10 @@ SYSCALL_DEFINE5(kcmp, pid_t, pid1, pid_t, pid2, int, type,
 	struct task_struct *task1, *task2;
 	int ret;
 
+#ifdef CONFIG_GRKERNSEC
+	return -ENOSYS;
+#endif
+
 	rcu_read_lock();
 
 	/*
diff --git a/kernel/kexec.c b/kernel/kexec.c
index 980936a90..81408fd01 100644
--- a/kernel/kexec.c
+++ b/kernel/kexec.c
@@ -236,7 +236,8 @@ COMPAT_SYSCALL_DEFINE4(kexec_load, compat_ulong_t, entry,
 		       compat_ulong_t, flags)
 {
 	struct compat_kexec_segment in;
-	struct kexec_segment out, __user *ksegments;
+	struct kexec_segment out;
+	struct kexec_segment __user *ksegments;
 	unsigned long i, result;
 
 	/* Don't allow clients that don't understand the native
diff --git a/kernel/kexec_core.c b/kernel/kexec_core.c
index 561675589..0affaae51 100644
--- a/kernel/kexec_core.c
+++ b/kernel/kexec_core.c
@@ -871,7 +871,7 @@ int kimage_load_segment(struct kimage *image,
 
 struct kimage *kexec_image;
 struct kimage *kexec_crash_image;
-int kexec_load_disabled;
+int kexec_load_disabled __read_only;
 
 /*
  * No panic_cpu check version of crash_kexec().  This function is called
diff --git a/kernel/kmod.c b/kernel/kmod.c
index 0277d1216..2d2899cf7 100644
--- a/kernel/kmod.c
+++ b/kernel/kmod.c
@@ -66,7 +66,7 @@ static void free_modprobe_argv(struct subprocess_info *info)
 	kfree(info->argv);
 }
 
-static int call_modprobe(char *module_name, int wait)
+static int call_modprobe(char *module_name, char *module_param, int wait)
 {
 	struct subprocess_info *info;
 	static char *envp[] = {
@@ -76,7 +76,7 @@ static int call_modprobe(char *module_name, int wait)
 		NULL
 	};
 
-	char **argv = kmalloc(sizeof(char *[5]), GFP_KERNEL);
+	char **argv = kmalloc(sizeof(char *[6]), GFP_KERNEL);
 	if (!argv)
 		goto out;
 
@@ -88,7 +88,8 @@ static int call_modprobe(char *module_name, int wait)
 	argv[1] = "-q";
 	argv[2] = "--";
 	argv[3] = module_name;	/* check free_modprobe_argv() */
-	argv[4] = NULL;
+	argv[4] = module_param;
+	argv[5] = NULL;
 
 	info = call_usermodehelper_setup(modprobe_path, argv, envp, GFP_KERNEL,
 					 NULL, free_modprobe_argv, NULL);
@@ -121,9 +122,8 @@ out:
  * If module auto-loading support is disabled then this function
  * becomes a no-operation.
  */
-int __request_module(bool wait, const char *fmt, ...)
+static int ____request_module(bool wait, char *module_param, const char *fmt, va_list ap)
 {
-	va_list args;
 	char module_name[MODULE_NAME_LEN];
 	unsigned int max_modprobes;
 	int ret;
@@ -142,9 +142,7 @@ int __request_module(bool wait, const char *fmt, ...)
 	if (!modprobe_path[0])
 		return 0;
 
-	va_start(args, fmt);
-	ret = vsnprintf(module_name, MODULE_NAME_LEN, fmt, args);
-	va_end(args);
+	ret = vsnprintf(module_name, MODULE_NAME_LEN, fmt, ap);
 	if (ret >= MODULE_NAME_LEN)
 		return -ENAMETOOLONG;
 
@@ -152,6 +150,20 @@ int __request_module(bool wait, const char *fmt, ...)
 	if (ret)
 		return ret;
 
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+	if (uid_eq(current_uid(), GLOBAL_ROOT_UID)) {
+		/* hack to workaround consolekit/udisks stupidity */
+		read_lock(&tasklist_lock);
+		if (!strcmp(current->comm, "mount") &&
+		    current->real_parent && !strncmp(current->real_parent->comm, "udisk", 5)) {
+			read_unlock(&tasklist_lock);
+			printk(KERN_ALERT "grsec: denied attempt to auto-load fs module %.64s by udisks\n", module_name);
+			return -EPERM;
+		}
+		read_unlock(&tasklist_lock);
+	}
+#endif
+
 	/* If modprobe needs a service that is in a module, we get a recursive
 	 * loop.  Limit the number of running kmod threads to max_threads/2 or
 	 * MAX_KMOD_CONCURRENT, whichever is the smaller.  A cleaner method
@@ -180,16 +192,61 @@ int __request_module(bool wait, const char *fmt, ...)
 
 	trace_module_request(module_name, wait, _RET_IP_);
 
-	ret = call_modprobe(module_name, wait ? UMH_WAIT_PROC : UMH_WAIT_EXEC);
+	ret = call_modprobe(module_name, module_param, wait ? UMH_WAIT_PROC : UMH_WAIT_EXEC);
 
 	atomic_dec(&kmod_concurrent);
 	return ret;
 }
+
+int ___request_module(bool wait, char *module_param, const char *fmt, ...)
+{
+	va_list args;
+	int ret;
+
+	va_start(args, fmt);
+	ret = ____request_module(wait, module_param, fmt, args);
+	va_end(args);
+
+	return ret;
+}
+
+int __request_module(bool wait, const char *fmt, ...)
+{
+	va_list args;
+	int ret;
+
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+	if (!uid_eq(current_uid(), GLOBAL_ROOT_UID)) {
+		char module_param[MODULE_NAME_LEN];
+
+		memset(module_param, 0, sizeof(module_param));
+
+		snprintf(module_param, sizeof(module_param) - 1, "grsec_modharden_normal%u_", GR_GLOBAL_UID(current_uid()));
+
+		va_start(args, fmt);
+		ret = ____request_module(wait, module_param, fmt, args);
+		va_end(args);
+
+		return ret;
+	}
+#endif
+
+	va_start(args, fmt);
+	ret = ____request_module(wait, NULL, fmt, args);
+	va_end(args);
+
+	return ret;
+}
+
 EXPORT_SYMBOL(__request_module);
 #endif /* CONFIG_MODULES */
 
 static void call_usermodehelper_freeinfo(struct subprocess_info *info)
 {
+#ifdef CONFIG_GRKERNSEC
+	kfree(info->path);
+	info->path = info->origpath;
+#endif
 	if (info->cleanup)
 		(*info->cleanup)(info);
 	kfree(info);
@@ -228,6 +285,22 @@ static int call_usermodehelper_exec_async(void *data)
 	 */
 	set_user_nice(current, 0);
 
+#ifdef CONFIG_GRKERNSEC
+	/* this is race-free as far as userland is concerned as we copied
+	   out the path to be used prior to this point and are now operating
+	   on that copy
+	*/
+	if ((strncmp(sub_info->path, "/sbin/", 6) && strncmp(sub_info->path, "/usr/lib/", 9) &&
+	     strncmp(sub_info->path, "/lib/", 5) && strncmp(sub_info->path, "/lib64/", 7) &&
+	     strncmp(sub_info->path, "/usr/libexec/", 13) && strncmp(sub_info->path, "/usr/bin/", 9) &&
+	     strncmp(sub_info->path, "/usr/sbin/", 10) && strcmp(sub_info->path, "/bin/false") && 
+	     strcmp(sub_info->path, "/usr/share/apport/apport")) || strstr(sub_info->path, "..")) {
+		printk(KERN_ALERT "grsec: denied exec of usermode helper binary %.950s located outside of permitted system paths\n", sub_info->path);
+		retval = -EPERM;
+		goto out;
+	}
+#endif
+
 	retval = -ENOMEM;
 	new = prepare_kernel_cred(current);
 	if (!new)
@@ -250,8 +323,8 @@ static int call_usermodehelper_exec_async(void *data)
 	commit_creds(new);
 
 	retval = do_execve(getname_kernel(sub_info->path),
-			   (const char __user *const __user *)sub_info->argv,
-			   (const char __user *const __user *)sub_info->envp);
+			   (const char __user *const __force_user *)sub_info->argv,
+			   (const char __user *const __force_user *)sub_info->envp);
 out:
 	sub_info->retval = retval;
 	/*
@@ -287,7 +360,7 @@ static void call_usermodehelper_exec_sync(struct subprocess_info *sub_info)
 		 *
 		 * Thus the __user pointer cast is valid here.
 		 */
-		sys_wait4(pid, (int __user *)&ret, 0, NULL);
+		sys_wait4(pid, (int __force_user *)&ret, 0, NULL);
 
 		/*
 		 * If ret is 0, either call_usermodehelper_exec_async failed and
@@ -528,7 +601,12 @@ struct subprocess_info *call_usermodehelper_setup(char *path, char **argv,
 		goto out;
 
 	INIT_WORK(&sub_info->work, call_usermodehelper_exec_work);
+#ifdef CONFIG_GRKERNSEC
+	sub_info->origpath = path;
+	sub_info->path = kstrdup(path, gfp_mask);
+#else
 	sub_info->path = path;
+#endif
 	sub_info->argv = argv;
 	sub_info->envp = envp;
 
@@ -630,7 +708,7 @@ EXPORT_SYMBOL(call_usermodehelper);
 static int proc_cap_handler(struct ctl_table *table, int write,
 			 void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table t;
+	ctl_table_no_const t;
 	unsigned long cap_array[_KERNEL_CAPABILITY_U32S];
 	kernel_cap_t new_cap;
 	int err, i;
diff --git a/kernel/kprobes.c b/kernel/kprobes.c
index d10ab6b9b..1725fbd6b 100644
--- a/kernel/kprobes.c
+++ b/kernel/kprobes.c
@@ -31,6 +31,9 @@
  *		<jkenisto@us.ibm.com> and Prasanna S Panchamukhi
  *		<prasanna@in.ibm.com> added function-return probes.
  */
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+#define __INCLUDED_BY_HIDESYM 1
+#endif
 #include <linux/kprobes.h>
 #include <linux/hash.h>
 #include <linux/init.h>
@@ -122,12 +125,12 @@ enum kprobe_slot_state {
 
 static void *alloc_insn_page(void)
 {
-	return module_alloc(PAGE_SIZE);
+	return module_alloc_exec(PAGE_SIZE);
 }
 
 static void free_insn_page(void *page)
 {
-	module_memfree(page);
+	module_memfree_exec(page);
 }
 
 struct kprobe_insn_cache kprobe_insn_slots = {
@@ -2198,11 +2201,11 @@ static void report_probe(struct seq_file *pi, struct kprobe *p,
 		kprobe_type = "k";
 
 	if (sym)
-		seq_printf(pi, "%p  %s  %s+0x%x  %s ",
+		seq_printf(pi, "%pK  %s  %s+0x%x  %s ",
 			p->addr, kprobe_type, sym, offset,
 			(modname ? modname : " "));
 	else
-		seq_printf(pi, "%p  %s  %p ",
+		seq_printf(pi, "%pK  %s  %pK ",
 			p->addr, kprobe_type, p->addr);
 
 	if (!pp)
@@ -2291,7 +2294,7 @@ static int kprobe_blacklist_seq_show(struct seq_file *m, void *v)
 	struct kprobe_blacklist_entry *ent =
 		list_entry(v, struct kprobe_blacklist_entry, list);
 
-	seq_printf(m, "0x%p-0x%p\t%ps\n", (void *)ent->start_addr,
+	seq_printf(m, "0x%pK-0x%pK\t%ps\n", (void *)ent->start_addr,
 		   (void *)ent->end_addr, (void *)ent->start_addr);
 	return 0;
 }
diff --git a/kernel/ksysfs.c b/kernel/ksysfs.c
index ee1bc1bb8..a35180642 100644
--- a/kernel/ksysfs.c
+++ b/kernel/ksysfs.c
@@ -50,6 +50,8 @@ static ssize_t uevent_helper_store(struct kobject *kobj,
 {
 	if (count+1 > UEVENT_HELPER_PATH_LEN)
 		return -ENOENT;
+	if (!capable(CAP_SYS_ADMIN))
+		return -EPERM;
 	memcpy(uevent_helper, buf, count);
 	uevent_helper[count] = '\0';
 	if (count && uevent_helper[count-1] == '\n')
@@ -195,7 +197,7 @@ static ssize_t notes_read(struct file *filp, struct kobject *kobj,
 	return count;
 }
 
-static struct bin_attribute notes_attr = {
+static bin_attribute_no_const notes_attr __read_only = {
 	.attr = {
 		.name = "notes",
 		.mode = S_IRUGO,
diff --git a/kernel/locking/lockdep.c b/kernel/locking/lockdep.c
index 589d763a4..3962223a0 100644
--- a/kernel/locking/lockdep.c
+++ b/kernel/locking/lockdep.c
@@ -603,6 +603,10 @@ static int static_obj(void *obj)
 		      end   = (unsigned long) &_end,
 		      addr  = (unsigned long) obj;
 
+#ifdef CONFIG_PAX_KERNEXEC
+	start = ktla_ktva(start);
+#endif
+
 	/*
 	 * static variable?
 	 */
@@ -733,6 +737,7 @@ register_lock_class(struct lockdep_map *lock, unsigned int subclass, int force)
 	if (!static_obj(lock->key)) {
 		debug_locks_off();
 		printk("INFO: trying to register non-static key.\n");
+		printk("lock:%pS key:%pS.\n", lock, lock->key);
 		printk("the code is fine but needs lockdep annotation.\n");
 		printk("turning off the locking correctness validator.\n");
 		dump_stack();
@@ -3231,7 +3236,7 @@ static int __lock_acquire(struct lockdep_map *lock, unsigned int subclass,
 		if (!class)
 			return 0;
 	}
-	atomic_inc((atomic_t *)&class->ops);
+	atomic_long_inc_unchecked((atomic_long_unchecked_t *)&class->ops);
 	if (very_verbose(class)) {
 		printk("\nacquire class [%p] %s", class->key, class->name);
 		if (class->name_version > 1)
diff --git a/kernel/locking/lockdep_proc.c b/kernel/locking/lockdep_proc.c
index a0f61effa..b6aef3cb6 100644
--- a/kernel/locking/lockdep_proc.c
+++ b/kernel/locking/lockdep_proc.c
@@ -65,7 +65,7 @@ static int l_show(struct seq_file *m, void *v)
 		return 0;
 	}
 
-	seq_printf(m, "%p", class->key);
+	seq_printf(m, "%pK", class->key);
 #ifdef CONFIG_DEBUG_LOCKDEP
 	seq_printf(m, " OPS:%8ld", class->ops);
 #endif
@@ -83,7 +83,7 @@ static int l_show(struct seq_file *m, void *v)
 
 	list_for_each_entry(entry, &class->locks_after, entry) {
 		if (entry->distance == 1) {
-			seq_printf(m, " -> [%p] ", entry->class->key);
+			seq_printf(m, " -> [%pK] ", entry->class->key);
 			print_name(m, entry->class);
 			seq_puts(m, "\n");
 		}
@@ -154,7 +154,7 @@ static int lc_show(struct seq_file *m, void *v)
 		if (!class->key)
 			continue;
 
-		seq_printf(m, "[%p] ", class->key);
+		seq_printf(m, "[%pK] ", class->key);
 		print_name(m, class);
 		seq_puts(m, "\n");
 	}
@@ -510,7 +510,7 @@ static void seq_stats(struct seq_file *m, struct lock_stat_data *data)
 		if (!i)
 			seq_line(m, '-', 40-namelen, namelen);
 
-		snprintf(ip, sizeof(ip), "[<%p>]",
+		snprintf(ip, sizeof(ip), "[<%pK>]",
 				(void *)class->contention_point[i]);
 		seq_printf(m, "%40s %14lu %29s %pS\n",
 			   name, stats->contention_point[i],
@@ -525,7 +525,7 @@ static void seq_stats(struct seq_file *m, struct lock_stat_data *data)
 		if (!i)
 			seq_line(m, '-', 40-namelen, namelen);
 
-		snprintf(ip, sizeof(ip), "[<%p>]",
+		snprintf(ip, sizeof(ip), "[<%pK>]",
 				(void *)class->contending_point[i]);
 		seq_printf(m, "%40s %14lu %29s %pS\n",
 			   name, stats->contending_point[i],
diff --git a/kernel/module.c b/kernel/module.c
index 529efae9f..05499fa6e 100644
--- a/kernel/module.c
+++ b/kernel/module.c
@@ -61,6 +61,7 @@
 #include <linux/pfn.h>
 #include <linux/bsearch.h>
 #include <linux/dynamic_debug.h>
+#include <linux/grsecurity.h>
 #include <uapi/linux/module.h>
 #include "module-internal.h"
 
@@ -108,16 +109,32 @@ static LIST_HEAD(modules);
 
 static __always_inline unsigned long __mod_tree_val(struct latch_tree_node *n)
 {
-	struct module_layout *layout = container_of(n, struct module_layout, mtn.node);
+	struct mod_tree_node *mtn = container_of(n, struct mod_tree_node, node);
+	struct module *mod = mtn->mod;
 
-	return (unsigned long)layout->base;
+	if (unlikely(mtn == &mod->init_layout.mtn_rw))
+		return (unsigned long)mod->init_layout.base_rw;
+	if (unlikely(mtn == &mod->init_layout.mtn_rx))
+		return (unsigned long)mod->init_layout.base_rx;
+
+	if (unlikely(mtn == &mod->core_layout.mtn_rw))
+		return (unsigned long)mod->core_layout.base_rw;
+	return (unsigned long)mod->core_layout.base_rx;
 }
 
 static __always_inline unsigned long __mod_tree_size(struct latch_tree_node *n)
 {
-	struct module_layout *layout = container_of(n, struct module_layout, mtn.node);
+	struct mod_tree_node *mtn = container_of(n, struct mod_tree_node, node);
+	struct module *mod = mtn->mod;
+
+	if (unlikely(mtn == &mod->init_layout.mtn_rw))
+		return (unsigned long)mod->init_layout.size_rw;
+	if (unlikely(mtn == &mod->init_layout.mtn_rx))
+		return (unsigned long)mod->init_layout.size_rx;
 
-	return (unsigned long)layout->size;
+	if (unlikely(mtn == &mod->core_layout.mtn_rw))
+		return (unsigned long)mod->core_layout.size_rw;
+	return (unsigned long)mod->core_layout.size_rx;
 }
 
 static __always_inline bool
@@ -150,14 +167,19 @@ static const struct latch_tree_ops mod_tree_ops = {
 
 static struct mod_tree_root {
 	struct latch_tree_root root;
-	unsigned long addr_min;
-	unsigned long addr_max;
+	unsigned long addr_min_rw;
+	unsigned long addr_min_rx;
+	unsigned long addr_max_rw;
+	unsigned long addr_max_rx;
 } mod_tree __cacheline_aligned = {
-	.addr_min = -1UL,
+	.addr_min_rw = -1UL,
+	.addr_min_rx = -1UL,
 };
 
-#define module_addr_min mod_tree.addr_min
-#define module_addr_max mod_tree.addr_max
+#define module_addr_min_rw mod_tree.addr_min_rw
+#define module_addr_min_rx mod_tree.addr_min_rx
+#define module_addr_max_rw mod_tree.addr_max_rw
+#define module_addr_max_rx mod_tree.addr_max_rx
 
 static noinline void __mod_tree_insert(struct mod_tree_node *node)
 {
@@ -175,23 +197,31 @@ static void __mod_tree_remove(struct mod_tree_node *node)
  */
 static void mod_tree_insert(struct module *mod)
 {
-	mod->core_layout.mtn.mod = mod;
-	mod->init_layout.mtn.mod = mod;
+	mod->core_layout.mtn_rx.mod = mod;
+	mod->core_layout.mtn_rw.mod = mod;
+	mod->init_layout.mtn_rx.mod = mod;
+	mod->init_layout.mtn_rw.mod = mod;
 
-	__mod_tree_insert(&mod->core_layout.mtn);
-	if (mod->init_layout.size)
-		__mod_tree_insert(&mod->init_layout.mtn);
+	__mod_tree_insert(&mod->core_layout.mtn_rx);
+	__mod_tree_insert(&mod->core_layout.mtn_rw);
+	if (mod->init_layout.size_rx)
+		__mod_tree_insert(&mod->init_layout.mtn_rx);
+	if (mod->init_layout.size_rw)
+		__mod_tree_insert(&mod->init_layout.mtn_rw);
 }
 
 static void mod_tree_remove_init(struct module *mod)
 {
-	if (mod->init_layout.size)
-		__mod_tree_remove(&mod->init_layout.mtn);
+	if (mod->init_layout.size_rx)
+		__mod_tree_remove(&mod->init_layout.mtn_rx);
+	if (mod->init_layout.size_rw)
+		__mod_tree_remove(&mod->init_layout.mtn_rw);
 }
 
 static void mod_tree_remove(struct module *mod)
 {
-	__mod_tree_remove(&mod->core_layout.mtn);
+	__mod_tree_remove(&mod->core_layout.mtn_rx);
+	__mod_tree_remove(&mod->core_layout.mtn_rw);
 	mod_tree_remove_init(mod);
 }
 
@@ -208,7 +238,8 @@ static struct module *mod_find(unsigned long addr)
 
 #else /* MODULES_TREE_LOOKUP */
 
-static unsigned long module_addr_min = -1UL, module_addr_max = 0;
+static unsigned long module_addr_min_rw = -1UL, module_addr_max_rw = 0;
+static unsigned long module_addr_min_rx = -1UL, module_addr_max_rx = 0;
 
 static void mod_tree_insert(struct module *mod) { }
 static void mod_tree_remove_init(struct module *mod) { }
@@ -232,22 +263,36 @@ static struct module *mod_find(unsigned long addr)
  * Bounds of module text, for speeding up __module_address.
  * Protected by module_mutex.
  */
-static void __mod_update_bounds(void *base, unsigned int size)
+static void __mod_update_bounds_rx(void *base, unsigned int size)
+{
+	unsigned long min = (unsigned long)base;
+	unsigned long max = min + size;
+
+	if (min < module_addr_min_rx)
+		module_addr_min_rx = min;
+	if (max > module_addr_max_rx)
+		module_addr_max_rx = max;
+}
+
+static void __mod_update_bounds_rw(void *base, unsigned int size)
 {
 	unsigned long min = (unsigned long)base;
 	unsigned long max = min + size;
 
-	if (min < module_addr_min)
-		module_addr_min = min;
-	if (max > module_addr_max)
-		module_addr_max = max;
+	if (min < module_addr_min_rw)
+		module_addr_min_rw = min;
+	if (max > module_addr_max_rw)
+		module_addr_max_rw = max;
 }
 
 static void mod_update_bounds(struct module *mod)
 {
-	__mod_update_bounds(mod->core_layout.base, mod->core_layout.size);
-	if (mod->init_layout.size)
-		__mod_update_bounds(mod->init_layout.base, mod->init_layout.size);
+	__mod_update_bounds_rx(mod->core_layout.base_rx, mod->core_layout.size_rx);
+	__mod_update_bounds_rw(mod->core_layout.base_rw, mod->core_layout.size_rw);
+	if (mod->init_layout.size_rx)
+		__mod_update_bounds_rx(mod->init_layout.base_rx, mod->init_layout.size_rx);
+	if (mod->init_layout.size_rw)
+		__mod_update_bounds_rw(mod->init_layout.base_rw, mod->init_layout.size_rw);
 }
 
 #ifdef CONFIG_KGDB_KDB
@@ -276,7 +321,7 @@ module_param(sig_enforce, bool_enable_only, 0644);
 #endif /* !CONFIG_MODULE_SIG_FORCE */
 
 /* Block module loading/unloading? */
-int modules_disabled = 0;
+int modules_disabled __read_only = 0;
 core_param(nomodule, modules_disabled, bint, 0);
 
 /* Waiting for a module to finish initializing? */
@@ -454,7 +499,7 @@ bool each_symbol_section(bool (*fn)(const struct symsearch *arr,
 		return true;
 
 	list_for_each_entry_rcu(mod, &modules, list) {
-		struct symsearch arr[] = {
+		struct symsearch modarr[] = {
 			{ mod->syms, mod->syms + mod->num_syms, mod->crcs,
 			  NOT_GPL_ONLY, false },
 			{ mod->gpl_syms, mod->gpl_syms + mod->num_gpl_syms,
@@ -479,7 +524,7 @@ bool each_symbol_section(bool (*fn)(const struct symsearch *arr,
 		if (mod->state == MODULE_STATE_UNFORMED)
 			continue;
 
-		if (each_symbol_in_section(arr, ARRAY_SIZE(arr), mod, fn, data))
+		if (each_symbol_in_section(modarr, ARRAY_SIZE(modarr), mod, fn, data))
 			return true;
 	}
 	return false;
@@ -625,7 +670,7 @@ static int percpu_modalloc(struct module *mod, struct load_info *info)
 	if (!pcpusec->sh_size)
 		return 0;
 
-	if (align > PAGE_SIZE) {
+	if (align-1 >= PAGE_SIZE) {
 		pr_warn("%s: per-cpu alignment %li > %li\n",
 			mod->name, align, PAGE_SIZE);
 		align = PAGE_SIZE;
@@ -1198,7 +1243,7 @@ struct module_attribute module_uevent =
 static ssize_t show_coresize(struct module_attribute *mattr,
 			     struct module_kobject *mk, char *buffer)
 {
-	return sprintf(buffer, "%u\n", mk->mod->core_layout.size);
+	return sprintf(buffer, "%u\n", mk->mod->core_layout.size_rx + mk->mod->core_layout.size_rw);
 }
 
 static struct module_attribute modinfo_coresize =
@@ -1207,7 +1252,7 @@ static struct module_attribute modinfo_coresize =
 static ssize_t show_initsize(struct module_attribute *mattr,
 			     struct module_kobject *mk, char *buffer)
 {
-	return sprintf(buffer, "%u\n", mk->mod->init_layout.size);
+	return sprintf(buffer, "%u\n", mk->mod->init_layout.size_rx + mk->mod->init_layout.size_rw);
 }
 
 static struct module_attribute modinfo_initsize =
@@ -1299,12 +1344,29 @@ static int check_version(Elf_Shdr *sechdrs,
 		goto bad_version;
 	}
 
+#ifdef CONFIG_GRKERNSEC_RANDSTRUCT
+	/*
+	 * avoid potentially printing jibberish on attempted load
+	 * of a module randomized with a different seed
+	 */
+	pr_warn("no symbol version for %s\n", symname);
+#else
 	pr_warn("%s: no symbol version for %s\n", mod->name, symname);
+#endif
 	return 0;
 
 bad_version:
+#ifdef CONFIG_GRKERNSEC_RANDSTRUCT
+	/*
+	 * avoid potentially printing jibberish on attempted load
+	 * of a module randomized with a different seed
+	 */
+	pr_warn("attempted module disagrees about version of symbol %s\n",
+	       symname);
+#else
 	pr_warn("%s: disagrees about version of symbol %s\n",
 	       mod->name, symname);
+#endif
 	return 0;
 }
 
@@ -1432,7 +1494,7 @@ resolve_symbol_wait(struct module *mod,
  */
 #ifdef CONFIG_SYSFS
 
-#ifdef CONFIG_KALLSYMS
+#if defined(CONFIG_KALLSYMS) && !defined(CONFIG_GRKERNSEC_HIDESYM)
 static inline bool sect_empty(const Elf_Shdr *sect)
 {
 	return !(sect->sh_flags & SHF_ALLOC) || sect->sh_size == 0;
@@ -1570,7 +1632,7 @@ static void add_notes_attrs(struct module *mod, const struct load_info *info)
 {
 	unsigned int notes, loaded, i;
 	struct module_notes_attrs *notes_attrs;
-	struct bin_attribute *nattr;
+	bin_attribute_no_const *nattr;
 
 	/* failed to create section attributes, so can't create notes */
 	if (!mod->sect_attrs)
@@ -1682,7 +1744,7 @@ static void del_usage_links(struct module *mod)
 static int module_add_modinfo_attrs(struct module *mod)
 {
 	struct module_attribute *attr;
-	struct module_attribute *temp_attr;
+	module_attribute_no_const *temp_attr;
 	int error = 0;
 	int i;
 
@@ -1869,40 +1931,40 @@ static void mod_sysfs_teardown(struct module *mod)
 static void frob_text(const struct module_layout *layout,
 		      int (*set_memory)(unsigned long start, int num_pages))
 {
-	BUG_ON((unsigned long)layout->base & (PAGE_SIZE-1));
-	BUG_ON((unsigned long)layout->text_size & (PAGE_SIZE-1));
-	set_memory((unsigned long)layout->base,
-		   layout->text_size >> PAGE_SHIFT);
+	BUG_ON((unsigned long)layout->base_rx & (PAGE_SIZE-1));
+	BUG_ON((unsigned long)layout->size_rx & (PAGE_SIZE-1));
+	set_memory((unsigned long)layout->base_rx,
+		   layout->size_rx >> PAGE_SHIFT);
 }
 
 static void frob_rodata(const struct module_layout *layout,
 			int (*set_memory)(unsigned long start, int num_pages))
 {
-	BUG_ON((unsigned long)layout->base & (PAGE_SIZE-1));
-	BUG_ON((unsigned long)layout->text_size & (PAGE_SIZE-1));
-	BUG_ON((unsigned long)layout->ro_size & (PAGE_SIZE-1));
-	set_memory((unsigned long)layout->base + layout->text_size,
-		   (layout->ro_size - layout->text_size) >> PAGE_SHIFT);
+	BUG_ON((unsigned long)layout->base_rx & (PAGE_SIZE-1));
+	BUG_ON((unsigned long)layout->size_rx & (PAGE_SIZE-1));
+//	BUG_ON((unsigned long)layout->size_ro & (PAGE_SIZE-1));
+//	set_memory((unsigned long)layout->base_rx + layout->size_rx,
+//		   (layout->size_ro - layout->size_rx) >> PAGE_SHIFT);
 }
 
 static void frob_ro_after_init(const struct module_layout *layout,
 				int (*set_memory)(unsigned long start, int num_pages))
 {
-	BUG_ON((unsigned long)layout->base & (PAGE_SIZE-1));
+#if 0
+	BUG_ON((unsigned long)layout->base_rx & (PAGE_SIZE-1));
 	BUG_ON((unsigned long)layout->ro_size & (PAGE_SIZE-1));
 	BUG_ON((unsigned long)layout->ro_after_init_size & (PAGE_SIZE-1));
 	set_memory((unsigned long)layout->base + layout->ro_size,
 		   (layout->ro_after_init_size - layout->ro_size) >> PAGE_SHIFT);
+#endif
 }
 
 static void frob_writable_data(const struct module_layout *layout,
 			       int (*set_memory)(unsigned long start, int num_pages))
 {
-	BUG_ON((unsigned long)layout->base & (PAGE_SIZE-1));
-	BUG_ON((unsigned long)layout->ro_after_init_size & (PAGE_SIZE-1));
-	BUG_ON((unsigned long)layout->size & (PAGE_SIZE-1));
-	set_memory((unsigned long)layout->base + layout->ro_after_init_size,
-		   (layout->size - layout->ro_after_init_size) >> PAGE_SHIFT);
+	BUG_ON((unsigned long)layout->base_rw & (PAGE_SIZE-1));
+	BUG_ON((unsigned long)layout->size_rw & (PAGE_SIZE-1));
+	set_memory((unsigned long)layout->base_rw, layout->size_rw  >> PAGE_SHIFT);
 }
 
 /* livepatching wants to disable read-only so it can frob module. */
@@ -1987,7 +2049,15 @@ static void disable_ro_nx(const struct module_layout *layout)
 }
 
 #else
-static void disable_ro_nx(const struct module_layout *layout) { }
+static void disable_ro_nx(const struct module_layout *layout)
+{
+
+#ifdef CONFIG_PAX_KERNEXEC
+	set_memory_nx((unsigned long)layout->base_rx, PFN_UP(layout->size_rx));
+	set_memory_rw((unsigned long)layout->base_rx, PFN_UP(layout->size_rx));
+#endif
+
+}
 static void module_enable_nx(const struct module *mod) { }
 static void module_disable_nx(const struct module *mod) { }
 #endif
@@ -2124,16 +2194,19 @@ static void free_module(struct module *mod)
 	/* This may be empty, but that's OK */
 	disable_ro_nx(&mod->init_layout);
 	module_arch_freeing_init(mod);
-	module_memfree(mod->init_layout.base);
+	module_memfree(mod->init_layout.base_rw);
+	module_memfree_exec(mod->init_layout.base_rx);
 	kfree(mod->args);
 	percpu_modfree(mod);
 
 	/* Free lock-classes; relies on the preceding sync_rcu(). */
-	lockdep_free_key_range(mod->core_layout.base, mod->core_layout.size);
+	lockdep_free_key_range(mod->core_layout.base_rw, mod->core_layout.size_rw);
+	lockdep_free_key_range(mod->core_layout.base_rx, mod->core_layout.size_rx);
 
 	/* Finally, free the core (containing the module structure) */
 	disable_ro_nx(&mod->core_layout);
-	module_memfree(mod->core_layout.base);
+	module_memfree_exec(mod->core_layout.base_rx);
+	module_memfree(mod->core_layout.base_rw);
 
 #ifdef CONFIG_MPU
 	update_protections(current->mm);
@@ -2202,9 +2275,31 @@ static int simplify_symbols(struct module *mod, const struct load_info *info)
 	int ret = 0;
 	const struct kernel_symbol *ksym;
 
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+	int is_fs_load = 0;
+	int register_filesystem_found = 0;
+	char *p;
+
+	p = strstr(mod->args, "grsec_modharden_fs");
+	if (p) {
+		char *endptr = p + sizeof("grsec_modharden_fs") - 1;
+		/* copy \0 as well */
+		memmove(p, endptr, strlen(mod->args) - (unsigned int)(endptr - mod->args) + 1);
+		is_fs_load = 1;
+	}
+#endif
+
 	for (i = 1; i < symsec->sh_size / sizeof(Elf_Sym); i++) {
 		const char *name = info->strtab + sym[i].st_name;
 
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+		/* it's a real shame this will never get ripped and copied
+		   upstream! ;(
+		*/
+		if (is_fs_load && !strcmp(name, "register_filesystem"))
+			register_filesystem_found = 1;
+#endif
+
 		switch (sym[i].st_shndx) {
 		case SHN_COMMON:
 			/* Ignore common symbols */
@@ -2233,7 +2328,9 @@ static int simplify_symbols(struct module *mod, const struct load_info *info)
 			ksym = resolve_symbol_wait(mod, info, name);
 			/* Ok if resolved.  */
 			if (ksym && !IS_ERR(ksym)) {
+				pax_open_kernel();
 				sym[i].st_value = ksym->value;
+				pax_close_kernel();
 				break;
 			}
 
@@ -2252,11 +2349,20 @@ static int simplify_symbols(struct module *mod, const struct load_info *info)
 				secbase = (unsigned long)mod_percpu(mod);
 			else
 				secbase = info->sechdrs[sym[i].st_shndx].sh_addr;
+			pax_open_kernel();
 			sym[i].st_value += secbase;
+			pax_close_kernel();
 			break;
 		}
 	}
 
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+	if (is_fs_load && !register_filesystem_found) {
+		printk(KERN_ALERT "grsec: Denied attempt to load non-fs module %.64s through mount\n", mod->name);
+		ret = -EPERM;
+	}
+#endif
+
 	return ret;
 }
 
@@ -2345,26 +2451,12 @@ static void layout_sections(struct module *mod, struct load_info *info)
 			    || s->sh_entsize != ~0UL
 			    || strstarts(sname, ".init"))
 				continue;
-			s->sh_entsize = get_offset(mod, &mod->core_layout.size, s, i);
+			if ((s->sh_flags & SHF_WRITE) || !(s->sh_flags & SHF_ALLOC))
+				s->sh_entsize = get_offset(mod, &mod->core_layout.size_rw, s, i);
+			else
+				s->sh_entsize = get_offset(mod, &mod->core_layout.size_rx, s, i);
 			pr_debug("\t%s\n", sname);
 		}
-		switch (m) {
-		case 0: /* executable */
-			mod->core_layout.size = debug_align(mod->core_layout.size);
-			mod->core_layout.text_size = mod->core_layout.size;
-			break;
-		case 1: /* RO: text and ro-data */
-			mod->core_layout.size = debug_align(mod->core_layout.size);
-			mod->core_layout.ro_size = mod->core_layout.size;
-			break;
-		case 2: /* RO after init */
-			mod->core_layout.size = debug_align(mod->core_layout.size);
-			mod->core_layout.ro_after_init_size = mod->core_layout.size;
-			break;
-		case 4: /* whole core */
-			mod->core_layout.size = debug_align(mod->core_layout.size);
-			break;
-		}
 	}
 
 	pr_debug("Init section allocation order:\n");
@@ -2378,30 +2470,13 @@ static void layout_sections(struct module *mod, struct load_info *info)
 			    || s->sh_entsize != ~0UL
 			    || !strstarts(sname, ".init"))
 				continue;
-			s->sh_entsize = (get_offset(mod, &mod->init_layout.size, s, i)
-					 | INIT_OFFSET_MASK);
+			if ((s->sh_flags & SHF_WRITE) || !(s->sh_flags & SHF_ALLOC))
+				s->sh_entsize = get_offset(mod, &mod->init_layout.size_rw, s, i);
+			else
+				s->sh_entsize = get_offset(mod, &mod->init_layout.size_rx, s, i);
+			s->sh_entsize |= INIT_OFFSET_MASK;
 			pr_debug("\t%s\n", sname);
 		}
-		switch (m) {
-		case 0: /* executable */
-			mod->init_layout.size = debug_align(mod->init_layout.size);
-			mod->init_layout.text_size = mod->init_layout.size;
-			break;
-		case 1: /* RO: text and ro-data */
-			mod->init_layout.size = debug_align(mod->init_layout.size);
-			mod->init_layout.ro_size = mod->init_layout.size;
-			break;
-		case 2:
-			/*
-			 * RO after init doesn't apply to init_layout (only
-			 * core_layout), so it just takes the value of ro_size.
-			 */
-			mod->init_layout.ro_after_init_size = mod->init_layout.ro_size;
-			break;
-		case 4: /* whole init */
-			mod->init_layout.size = debug_align(mod->init_layout.size);
-			break;
-		}
 	}
 }
 
@@ -2579,7 +2654,7 @@ static void layout_symtab(struct module *mod, struct load_info *info)
 
 	/* Put symbol section at end of init part of module. */
 	symsect->sh_flags |= SHF_ALLOC;
-	symsect->sh_entsize = get_offset(mod, &mod->init_layout.size, symsect,
+	symsect->sh_entsize = get_offset(mod, &mod->init_layout.size_rx, symsect,
 					 info->index.sym) | INIT_OFFSET_MASK;
 	pr_debug("\t%s\n", info->secstrings + symsect->sh_name);
 
@@ -2597,23 +2672,23 @@ static void layout_symtab(struct module *mod, struct load_info *info)
 	}
 
 	/* Append room for core symbols at end of core part. */
-	info->symoffs = ALIGN(mod->core_layout.size, symsect->sh_addralign ?: 1);
-	info->stroffs = mod->core_layout.size = info->symoffs + ndst * sizeof(Elf_Sym);
-	mod->core_layout.size += strtab_size;
-	mod->core_layout.size = debug_align(mod->core_layout.size);
+	info->symoffs = ALIGN(mod->core_layout.size_rx, symsect->sh_addralign ?: 1);
+	info->stroffs = mod->core_layout.size_rx = info->symoffs + ndst * sizeof(Elf_Sym);
+	mod->core_layout.size_rx += strtab_size;
+	mod->core_layout.size_rx = debug_align(mod->core_layout.size_rx);
 
 	/* Put string table section at end of init part of module. */
 	strsect->sh_flags |= SHF_ALLOC;
-	strsect->sh_entsize = get_offset(mod, &mod->init_layout.size, strsect,
+	strsect->sh_entsize = get_offset(mod, &mod->init_layout.size_rx, strsect,
 					 info->index.str) | INIT_OFFSET_MASK;
 	pr_debug("\t%s\n", info->secstrings + strsect->sh_name);
 
 	/* We'll tack temporary mod_kallsyms on the end. */
-	mod->init_layout.size = ALIGN(mod->init_layout.size,
+	mod->init_layout.size_rx = ALIGN(mod->init_layout.size_rx,
 				      __alignof__(struct mod_kallsyms));
-	info->mod_kallsyms_init_off = mod->init_layout.size;
-	mod->init_layout.size += sizeof(struct mod_kallsyms);
-	mod->init_layout.size = debug_align(mod->init_layout.size);
+	info->mod_kallsyms_init_off = mod->init_layout.size_rx;
+	mod->init_layout.size_rx += sizeof(struct mod_kallsyms);
+	mod->init_layout.size_rx = debug_align(mod->init_layout.size_rx);
 }
 
 /*
@@ -2630,7 +2705,9 @@ static void add_kallsyms(struct module *mod, const struct load_info *info)
 	Elf_Shdr *symsec = &info->sechdrs[info->index.sym];
 
 	/* Set up to point into init section. */
-	mod->kallsyms = mod->init_layout.base + info->mod_kallsyms_init_off;
+	mod->kallsyms = mod->init_layout.base_rx + info->mod_kallsyms_init_off;
+
+	pax_open_kernel();
 
 	mod->kallsyms->symtab = (void *)symsec->sh_addr;
 	mod->kallsyms->num_symtab = symsec->sh_size / sizeof(Elf_Sym);
@@ -2643,8 +2720,8 @@ static void add_kallsyms(struct module *mod, const struct load_info *info)
 			= elf_type(&mod->kallsyms->symtab[i], info);
 
 	/* Now populate the cut down core kallsyms for after init. */
-	mod->core_kallsyms.symtab = dst = mod->core_layout.base + info->symoffs;
-	mod->core_kallsyms.strtab = s = mod->core_layout.base + info->stroffs;
+	mod->core_kallsyms.symtab = dst = mod->core_layout.base_rx + info->symoffs;
+	mod->core_kallsyms.strtab = s = mod->core_layout.base_rx + info->stroffs;
 	src = mod->kallsyms->symtab;
 	for (ndst = i = 0; i < mod->kallsyms->num_symtab; i++) {
 		if (i == 0 || is_livepatch_module(mod) ||
@@ -2657,6 +2734,8 @@ static void add_kallsyms(struct module *mod, const struct load_info *info)
 		}
 	}
 	mod->core_kallsyms.num_symtab = ndst;
+
+	pax_close_kernel();
 }
 #else
 static inline void layout_symtab(struct module *mod, struct load_info *info)
@@ -2924,7 +3003,15 @@ static struct module *setup_load_info(struct load_info *info, int flags)
 	mod = (void *)info->sechdrs[info->index.mod].sh_addr;
 
 	if (info->index.sym == 0) {
+#ifdef CONFIG_GRKERNSEC_RANDSTRUCT
+		/*
+		 * avoid potentially printing jibberish on attempted load
+		 * of a module randomized with a different seed
+		 */
+		pr_warn("module has no symbols (stripped?)\n");
+#else
 		pr_warn("%s: module has no symbols (stripped?)\n", mod->name);
+#endif
 		return ERR_PTR(-ENOEXEC);
 	}
 
@@ -2940,8 +3027,16 @@ static struct module *setup_load_info(struct load_info *info, int flags)
 static int check_modinfo(struct module *mod, struct load_info *info, int flags)
 {
 	const char *modmagic = get_modinfo(info, "vermagic");
+	const char *license = get_modinfo(info, "license");
 	int err;
 
+#if defined(CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR) || defined(CONFIG_PAX_RAP)
+	if (!license || !license_is_gpl_compatible(license)) {
+		pr_err("%s: module is not compatible with the KERNEXEC 'or' method and RAP\n", mod->name);
+		return -ENOEXEC;
+	}
+#endif
+
 	if (flags & MODULE_INIT_IGNORE_VERMAGIC)
 		modmagic = NULL;
 
@@ -2974,7 +3069,7 @@ static int check_modinfo(struct module *mod, struct load_info *info, int flags)
 		return err;
 
 	/* Set up license info based on the info section */
-	set_license(mod, get_modinfo(info, "license"));
+	set_license(mod, license);
 
 	return 0;
 }
@@ -3071,7 +3166,7 @@ static int move_module(struct module *mod, struct load_info *info)
 	void *ptr;
 
 	/* Do the allocs. */
-	ptr = module_alloc(mod->core_layout.size);
+	ptr = module_alloc(mod->core_layout.size_rw);
 	/*
 	 * The pointer to this block is stored in the module structure
 	 * which is inside the block. Just mark it as not being a
@@ -3081,11 +3176,11 @@ static int move_module(struct module *mod, struct load_info *info)
 	if (!ptr)
 		return -ENOMEM;
 
-	memset(ptr, 0, mod->core_layout.size);
-	mod->core_layout.base = ptr;
+	memset(ptr, 0, mod->core_layout.size_rw);
+	mod->core_layout.base_rw = ptr;
 
-	if (mod->init_layout.size) {
-		ptr = module_alloc(mod->init_layout.size);
+	if (mod->init_layout.size_rw) {
+		ptr = module_alloc(mod->init_layout.size_rw);
 		/*
 		 * The pointer to this block is stored in the module structure
 		 * which is inside the block. This block doesn't need to be
@@ -3094,13 +3189,45 @@ static int move_module(struct module *mod, struct load_info *info)
 		 */
 		kmemleak_ignore(ptr);
 		if (!ptr) {
-			module_memfree(mod->core_layout.base);
+			module_memfree(mod->core_layout.base_rw);
 			return -ENOMEM;
 		}
-		memset(ptr, 0, mod->init_layout.size);
-		mod->init_layout.base = ptr;
+		memset(ptr, 0, mod->init_layout.size_rw);
+		mod->init_layout.base_rw = ptr;
 	} else
-		mod->init_layout.base = NULL;
+		mod->init_layout.base_rw = NULL;
+
+	ptr = module_alloc_exec(mod->core_layout.size_rx);
+	kmemleak_not_leak(ptr);
+	if (!ptr) {
+		if (mod->init_layout.base_rw)
+			module_memfree(mod->init_layout.base_rw);
+		module_memfree(mod->core_layout.base_rw);
+		return -ENOMEM;
+	}
+
+	pax_open_kernel();
+	memset(ptr, 0, mod->core_layout.size_rx);
+	pax_close_kernel();
+	mod->core_layout.base_rx = ptr;
+
+	if (mod->init_layout.size_rx) {
+		ptr = module_alloc_exec(mod->init_layout.size_rx);
+		kmemleak_ignore(ptr);
+		if (!ptr) {
+			module_memfree(mod->core_layout.base_rx);
+			if (mod->init_layout.base_rw)
+				module_memfree(mod->init_layout.base_rw);
+			module_memfree(mod->core_layout.base_rw);
+			return -ENOMEM;
+		}
+
+		pax_open_kernel();
+		memset(ptr, 0, mod->init_layout.size_rx);
+		pax_close_kernel();
+		mod->init_layout.base_rx = ptr;
+	} else
+		mod->init_layout.base_rx = NULL;
 
 	/* Transfer each section which specifies SHF_ALLOC */
 	pr_debug("final section addresses:\n");
@@ -3111,16 +3238,45 @@ static int move_module(struct module *mod, struct load_info *info)
 		if (!(shdr->sh_flags & SHF_ALLOC))
 			continue;
 
-		if (shdr->sh_entsize & INIT_OFFSET_MASK)
-			dest = mod->init_layout.base
-				+ (shdr->sh_entsize & ~INIT_OFFSET_MASK);
-		else
-			dest = mod->core_layout.base + shdr->sh_entsize;
+		if (shdr->sh_entsize & INIT_OFFSET_MASK) {
+			if ((shdr->sh_flags & SHF_WRITE) || !(shdr->sh_flags & SHF_ALLOC))
+				dest = mod->init_layout.base_rw
+					+ (shdr->sh_entsize & ~INIT_OFFSET_MASK);
+			else
+				dest = mod->init_layout.base_rx
+					+ (shdr->sh_entsize & ~INIT_OFFSET_MASK);
+		} else {
+			if ((shdr->sh_flags & SHF_WRITE) || !(shdr->sh_flags & SHF_ALLOC))
+				dest = mod->core_layout.base_rw + shdr->sh_entsize;
+			else
+				dest = mod->core_layout.base_rx + shdr->sh_entsize;
+		}
+
+		if (shdr->sh_type != SHT_NOBITS) {
+
+#ifdef CONFIG_PAX_KERNEXEC
+#ifdef CONFIG_X86_64
+			if ((shdr->sh_flags & SHF_WRITE) && (shdr->sh_flags & SHF_EXECINSTR))
+				set_memory_x((unsigned long)dest, (shdr->sh_size + PAGE_SIZE) >> PAGE_SHIFT);
+#endif
+			if (!(shdr->sh_flags & SHF_WRITE) && (shdr->sh_flags & SHF_ALLOC)) {
+				pax_open_kernel();
+				memcpy(dest, (void *)shdr->sh_addr, shdr->sh_size);
+				pax_close_kernel();
+			} else
+#endif
 
-		if (shdr->sh_type != SHT_NOBITS)
 			memcpy(dest, (void *)shdr->sh_addr, shdr->sh_size);
+		}
 		/* Update sh_addr to point to copy in image. */
-		shdr->sh_addr = (unsigned long)dest;
+
+#ifdef CONFIG_PAX_KERNEXEC
+		if (shdr->sh_flags & SHF_EXECINSTR)
+			shdr->sh_addr = ktva_ktla((unsigned long)dest);
+		else
+#endif
+
+			shdr->sh_addr = (unsigned long)dest;
 		pr_debug("\t0x%lx %s\n",
 			 (long)shdr->sh_addr, info->secstrings + shdr->sh_name);
 	}
@@ -3182,12 +3338,12 @@ static void flush_module_icache(const struct module *mod)
 	 * Do it before processing of module parameters, so the module
 	 * can provide parameter accessor functions of its own.
 	 */
-	if (mod->init_layout.base)
-		flush_icache_range((unsigned long)mod->init_layout.base,
-				   (unsigned long)mod->init_layout.base
-				   + mod->init_layout.size);
-	flush_icache_range((unsigned long)mod->core_layout.base,
-			   (unsigned long)mod->core_layout.base + mod->core_layout.size);
+	if (mod->init_layout.base_rx)
+		flush_icache_range((unsigned long)mod->init_layout.base_rx,
+				   (unsigned long)mod->init_layout.base_rx
+				   + mod->init_layout.size_rx);
+	flush_icache_range((unsigned long)mod->core_layout.base_rx,
+			   (unsigned long)mod->core_layout.base_rx + mod->core_layout.size_rx);
 
 	set_fs(old_fs);
 }
@@ -3279,8 +3435,10 @@ static void module_deallocate(struct module *mod, struct load_info *info)
 {
 	percpu_modfree(mod);
 	module_arch_freeing_init(mod);
-	module_memfree(mod->init_layout.base);
-	module_memfree(mod->core_layout.base);
+	module_memfree_exec(mod->init_layout.base_rx);
+	module_memfree_exec(mod->core_layout.base_rx);
+	module_memfree(mod->init_layout.base_rw);
+	module_memfree(mod->core_layout.base_rw);
 }
 
 int __weak module_finalize(const Elf_Ehdr *hdr,
@@ -3293,7 +3451,9 @@ int __weak module_finalize(const Elf_Ehdr *hdr,
 static int post_relocation(struct module *mod, const struct load_info *info)
 {
 	/* Sort exception table now relocations are done. */
+	pax_open_kernel();
 	sort_extable(mod->extable, mod->extable + mod->num_exentries);
+	pax_close_kernel();
 
 	/* Copy relocated percpu area over. */
 	percpu_modcopy(mod, (void *)info->sechdrs[info->index.pcpu].sh_addr,
@@ -3341,13 +3501,15 @@ static void do_mod_ctors(struct module *mod)
 /* For freeing module_init on success, in case kallsyms traversing */
 struct mod_initfree {
 	struct rcu_head rcu;
-	void *module_init;
+	void *module_init_rw;
+	void *module_init_rx;
 };
 
 static void do_free_init(struct rcu_head *head)
 {
 	struct mod_initfree *m = container_of(head, struct mod_initfree, rcu);
-	module_memfree(m->module_init);
+	module_memfree(m->module_init_rw);
+	module_memfree_exec(m->module_init_rx);
 	kfree(m);
 }
 
@@ -3367,7 +3529,8 @@ static noinline int do_init_module(struct module *mod)
 		ret = -ENOMEM;
 		goto fail;
 	}
-	freeinit->module_init = mod->init_layout.base;
+	freeinit->module_init_rx = mod->init_layout.base_rx;
+	freeinit->module_init_rw = mod->init_layout.base_rw;
 
 	/*
 	 * We want to find out whether @mod uses async during init.  Clear
@@ -3427,11 +3590,10 @@ static noinline int do_init_module(struct module *mod)
 	mod_tree_remove_init(mod);
 	disable_ro_nx(&mod->init_layout);
 	module_arch_freeing_init(mod);
-	mod->init_layout.base = NULL;
-	mod->init_layout.size = 0;
-	mod->init_layout.ro_size = 0;
-	mod->init_layout.ro_after_init_size = 0;
-	mod->init_layout.text_size = 0;
+	mod->init_layout.base_rx = NULL;
+	mod->init_layout.base_rw = NULL;
+	mod->init_layout.size_rx = 0;
+	mod->init_layout.size_rw = 0;
 	/*
 	 * We want to free module_init, but be aware that kallsyms may be
 	 * walking this with preempt disabled.  In all the failure paths, we
@@ -3630,9 +3792,38 @@ static int load_module(struct load_info *info, const char __user *uargs,
 	if (err)
 		goto free_unload;
 
+	/* Now copy in args */
+	mod->args = strndup_user(uargs, ~0UL >> 1);
+	if (IS_ERR(mod->args)) {
+		err = PTR_ERR(mod->args);
+		goto free_unload;
+	}
+
 	/* Set up MODINFO_ATTR fields */
 	setup_modinfo(mod, info);
 
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+	{
+		char *p, *p2;
+
+		if (strstr(mod->args, "grsec_modharden_netdev")) {
+			printk(KERN_ALERT "grsec: denied auto-loading kernel module for a network device with CAP_SYS_MODULE (deprecated).  Use CAP_NET_ADMIN and alias netdev-%.64s instead.", mod->name);
+			err = -EPERM;
+			goto free_modinfo;
+		} else if ((p = strstr(mod->args, "grsec_modharden_normal"))) {
+			p += sizeof("grsec_modharden_normal") - 1;
+			p2 = strstr(p, "_");
+			if (p2) {
+				*p2 = '\0';
+				printk(KERN_ALERT "grsec: denied kernel module auto-load of %.64s by uid %.9s\n", mod->name, p);
+				*p2 = '_';
+			}
+			err = -EPERM;
+			goto free_modinfo;
+		}
+	}
+#endif
+
 	/* Fix up syms, so that st_value is a pointer to location. */
 	err = simplify_symbols(mod, info);
 	if (err < 0)
@@ -3648,13 +3839,6 @@ static int load_module(struct load_info *info, const char __user *uargs,
 
 	flush_module_icache(mod);
 
-	/* Now copy in args */
-	mod->args = strndup_user(uargs, ~0UL >> 1);
-	if (IS_ERR(mod->args)) {
-		err = PTR_ERR(mod->args);
-		goto free_arch_cleanup;
-	}
-
 	dynamic_debug_setup(info->debug, info->num_debug);
 
 	/* Ftrace init must be called in the MODULE_STATE_UNFORMED state */
@@ -3719,11 +3903,10 @@ static int load_module(struct load_info *info, const char __user *uargs,
  ddebug_cleanup:
 	dynamic_debug_remove(info->debug);
 	synchronize_sched();
-	kfree(mod->args);
- free_arch_cleanup:
 	module_arch_cleanup(mod);
  free_modinfo:
 	free_modinfo(mod);
+	kfree(mod->args);
  free_unload:
 	module_unload_free(mod);
  unlink_mod:
@@ -3743,7 +3926,8 @@ static int load_module(struct load_info *info, const char __user *uargs,
 	 */
 	ftrace_release_mod(mod);
 	/* Free lock-classes; relies on the preceding sync_rcu() */
-	lockdep_free_key_range(mod->core_layout.base, mod->core_layout.size);
+	lockdep_free_key_range(mod->core_layout.base_rw, mod->core_layout.size_rw);
+	lockdep_free_key_range(mod->core_layout.base_rx, mod->core_layout.size_rx);
 
 	module_deallocate(mod, info);
  free_copy:
@@ -3831,10 +4015,16 @@ static const char *get_ksymbol(struct module *mod,
 	struct mod_kallsyms *kallsyms = rcu_dereference_sched(mod->kallsyms);
 
 	/* At worse, next value is at end of module */
-	if (within_module_init(addr, mod))
-		nextval = (unsigned long)mod->init_layout.base+mod->init_layout.text_size;
+	if (within_module_rx(addr, &mod->init_layout))
+		nextval = (unsigned long)mod->init_layout.base_rx+mod->init_layout.size_rx;
+	else if (within_module_rw(addr, &mod->init_layout))
+		nextval = (unsigned long)mod->init_layout.base_rw+mod->init_layout.size_rw;
+	else if (within_module_rx(addr, &mod->core_layout))
+		nextval = (unsigned long)mod->core_layout.base_rx+mod->core_layout.size_rx;
+	else if (within_module_rw(addr, &mod->core_layout))
+		nextval = (unsigned long)mod->core_layout.base_rw+mod->core_layout.size_rw;
 	else
-		nextval = (unsigned long)mod->core_layout.base+mod->core_layout.text_size;
+		return NULL;
 
 	/* Scan for closest preceding symbol, and next symbol. (ELF
 	   starts real symbols at 1). */
@@ -4087,7 +4277,7 @@ static int m_show(struct seq_file *m, void *p)
 		return 0;
 
 	seq_printf(m, "%s %u",
-		   mod->name, mod->init_layout.size + mod->core_layout.size);
+		   mod->name, mod->init_layout.size_rx + mod->init_layout.size_rw + mod->core_layout.size_rx + mod->core_layout.size_rw);
 	print_unload_info(m, mod);
 
 	/* Informative for users. */
@@ -4096,7 +4286,7 @@ static int m_show(struct seq_file *m, void *p)
 		   mod->state == MODULE_STATE_COMING ? "Loading" :
 		   "Live");
 	/* Used by oprofile and other similar tools. */
-	seq_printf(m, " 0x%pK", mod->core_layout.base);
+	seq_printf(m, " 0x%pK 0x%pK", mod->core_layout.base_rx, mod->core_layout.base_rw);
 
 	/* Taints info */
 	if (mod->taints)
@@ -4132,7 +4322,17 @@ static const struct file_operations proc_modules_operations = {
 
 static int __init proc_modules_init(void)
 {
+#ifndef CONFIG_GRKERNSEC_HIDESYM
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	proc_create("modules", S_IRUSR, NULL, &proc_modules_operations);
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	proc_create("modules", S_IRUSR | S_IRGRP, NULL, &proc_modules_operations);
+#else
 	proc_create("modules", 0, NULL, &proc_modules_operations);
+#endif
+#else
+	proc_create("modules", S_IRUSR, NULL, &proc_modules_operations);
+#endif
 	return 0;
 }
 module_init(proc_modules_init);
@@ -4193,7 +4393,15 @@ struct module *__module_address(unsigned long addr)
 {
 	struct module *mod;
 
-	if (addr < module_addr_min || addr > module_addr_max)
+#ifdef CONFIG_X86_32
+	unsigned long vaddr = ktla_ktva(addr);
+
+	if (module_addr_min_rx <= vaddr && vaddr <= module_addr_max_rx)
+		addr = vaddr;
+#endif
+
+	if ((addr < module_addr_min_rx || addr > module_addr_max_rx) &&
+	    (addr < module_addr_min_rw || addr > module_addr_max_rw))
 		return NULL;
 
 	module_assert_mutex_or_preempt();
@@ -4236,11 +4444,21 @@ bool is_module_text_address(unsigned long addr)
  */
 struct module *__module_text_address(unsigned long addr)
 {
-	struct module *mod = __module_address(addr);
+	struct module *mod;
+
+#ifdef CONFIG_X86_32
+	addr = ktla_ktva(addr);
+#endif
+
+	if (addr < module_addr_min_rx || addr > module_addr_max_rx)
+		return NULL;
+
+	mod = __module_address(addr);
+
 	if (mod) {
 		/* Make sure it's within the text section. */
-		if (!within(addr, mod->init_layout.base, mod->init_layout.text_size)
-		    && !within(addr, mod->core_layout.base, mod->core_layout.text_size))
+		if (!within_module_rx(addr, &mod->init_layout)
+		    && !within_module_rx(addr, &mod->core_layout))
 			mod = NULL;
 	}
 	return mod;
@@ -4270,7 +4488,7 @@ void print_modules(void)
 #ifdef CONFIG_MODVERSIONS
 /* Generate the signature for all relevant module structures here.
  * If these change, we don't want to try to parse the module. */
-void module_layout(struct module *mod,
+__visible void module_layout(struct module *mod,
 		   struct modversion_info *ver,
 		   struct kernel_param *kp,
 		   struct kernel_symbol *ks,
diff --git a/kernel/notifier.c b/kernel/notifier.c
index fd2c9acbc..6263e05eb 100644
--- a/kernel/notifier.c
+++ b/kernel/notifier.c
@@ -5,6 +5,7 @@
 #include <linux/rcupdate.h>
 #include <linux/vmalloc.h>
 #include <linux/reboot.h>
+#include <linux/mm.h>
 
 /*
  *	Notifier list for kernel code which wants to be called
@@ -24,10 +25,12 @@ static int notifier_chain_register(struct notifier_block **nl,
 	while ((*nl) != NULL) {
 		if (n->priority > (*nl)->priority)
 			break;
-		nl = &((*nl)->next);
+		nl = (struct notifier_block **)&((*nl)->next);
 	}
-	n->next = *nl;
+	pax_open_kernel();
+	const_cast(n->next) = *nl;
 	rcu_assign_pointer(*nl, n);
+	pax_close_kernel();
 	return 0;
 }
 
@@ -39,10 +42,12 @@ static int notifier_chain_cond_register(struct notifier_block **nl,
 			return 0;
 		if (n->priority > (*nl)->priority)
 			break;
-		nl = &((*nl)->next);
+		nl = (struct notifier_block **)&((*nl)->next);
 	}
-	n->next = *nl;
+	pax_open_kernel();
+	const_cast(n->next) = *nl;
 	rcu_assign_pointer(*nl, n);
+	pax_close_kernel();
 	return 0;
 }
 
@@ -51,10 +56,12 @@ static int notifier_chain_unregister(struct notifier_block **nl,
 {
 	while ((*nl) != NULL) {
 		if ((*nl) == n) {
+			pax_open_kernel();
 			rcu_assign_pointer(*nl, n->next);
+			pax_close_kernel();
 			return 0;
 		}
-		nl = &((*nl)->next);
+		nl = (struct notifier_block **)&((*nl)->next);
 	}
 	return -ENOENT;
 }
diff --git a/kernel/padata.c b/kernel/padata.c
index 993278895..7052e2058 100644
--- a/kernel/padata.c
+++ b/kernel/padata.c
@@ -54,7 +54,7 @@ static int padata_cpu_hash(struct parallel_data *pd)
 	 * seq_nr mod. number of cpus in use.
 	 */
 
-	seq_nr = atomic_inc_return(&pd->seq_nr);
+	seq_nr = atomic_inc_return_unchecked(&pd->seq_nr);
 	cpu_index = seq_nr % cpumask_weight(pd->cpumask.pcpu);
 
 	return padata_index_to_cpu(pd, cpu_index);
@@ -428,7 +428,7 @@ static struct parallel_data *padata_alloc_pd(struct padata_instance *pinst,
 	padata_init_pqueues(pd);
 	padata_init_squeues(pd);
 	setup_timer(&pd->timer, padata_reorder_timer, (unsigned long)pd);
-	atomic_set(&pd->seq_nr, -1);
+	atomic_set_unchecked(&pd->seq_nr, -1);
 	atomic_set(&pd->reorder_objects, 0);
 	atomic_set(&pd->refcnt, 0);
 	pd->pinst = pinst;
diff --git a/kernel/panic.c b/kernel/panic.c
index ca8cea1ef..2de817135 100644
--- a/kernel/panic.c
+++ b/kernel/panic.c
@@ -56,7 +56,7 @@ EXPORT_SYMBOL(panic_blink);
 /*
  * Stop ourself in panic -- architecture code may override this
  */
-void __weak panic_smp_self_stop(void)
+void __weak __noreturn panic_smp_self_stop(void)
 {
 	while (1)
 		cpu_relax();
@@ -488,11 +488,11 @@ void __warn(const char *file, int line, void *caller, unsigned taint,
 	pr_warn("------------[ cut here ]------------\n");
 
 	if (file)
-		pr_warn("WARNING: CPU: %d PID: %d at %s:%d %pS\n",
+		pr_warn("WARNING: CPU: %d PID: %d at %s:%d %pA\n",
 			raw_smp_processor_id(), current->pid, file, line,
 			caller);
 	else
-		pr_warn("WARNING: CPU: %d PID: %d at %pS\n",
+		pr_warn("WARNING: CPU: %d PID: %d at %pA\n",
 			raw_smp_processor_id(), current->pid, caller);
 
 	if (args)
@@ -523,7 +523,7 @@ void __warn(const char *file, int line, void *caller, unsigned taint,
 }
 
 #ifdef WANT_WARN_ON_SLOWPATH
-void warn_slowpath_fmt(const char *file, int line, const char *fmt, ...)
+void warn_slowpath_fmt(const char *file, const int line, const char *fmt, ...)
 {
 	struct warn_args args;
 
@@ -535,7 +535,7 @@ void warn_slowpath_fmt(const char *file, int line, const char *fmt, ...)
 }
 EXPORT_SYMBOL(warn_slowpath_fmt);
 
-void warn_slowpath_fmt_taint(const char *file, int line,
+void warn_slowpath_fmt_taint(const char *file, const int line,
 			     unsigned taint, const char *fmt, ...)
 {
 	struct warn_args args;
@@ -547,7 +547,7 @@ void warn_slowpath_fmt_taint(const char *file, int line,
 }
 EXPORT_SYMBOL(warn_slowpath_fmt_taint);
 
-void warn_slowpath_null(const char *file, int line)
+void warn_slowpath_null(const char *file, const int line)
 {
 	__warn(file, line, __builtin_return_address(0), TAINT_WARN, NULL, NULL);
 }
@@ -562,7 +562,8 @@ EXPORT_SYMBOL(warn_slowpath_null);
  */
 __visible void __stack_chk_fail(void)
 {
-	panic("stack-protector: Kernel stack is corrupted in: %p\n",
+	dump_stack();
+	panic("stack-protector: Kernel stack is corrupted in: %pA\n",
 		__builtin_return_address(0));
 }
 EXPORT_SYMBOL(__stack_chk_fail);
diff --git a/kernel/pid.c b/kernel/pid.c
index f66162f23..e950a59b2 100644
--- a/kernel/pid.c
+++ b/kernel/pid.c
@@ -33,6 +33,7 @@
 #include <linux/rculist.h>
 #include <linux/bootmem.h>
 #include <linux/hash.h>
+#include <linux/security.h>
 #include <linux/pid_namespace.h>
 #include <linux/init_task.h>
 #include <linux/syscalls.h>
@@ -47,7 +48,7 @@ struct pid init_struct_pid = INIT_STRUCT_PID;
 
 int pid_max = PID_MAX_DEFAULT;
 
-#define RESERVED_PIDS		300
+#define RESERVED_PIDS		500
 
 int pid_max_min = RESERVED_PIDS + 1;
 int pid_max_max = PID_MAX_LIMIT;
@@ -451,9 +452,17 @@ EXPORT_SYMBOL(pid_task);
  */
 struct task_struct *find_task_by_pid_ns(pid_t nr, struct pid_namespace *ns)
 {
+	struct task_struct *task;
+
 	RCU_LOCKDEP_WARN(!rcu_read_lock_held(),
 			 "find_task_by_pid_ns() needs rcu_read_lock() protection");
-	return pid_task(find_pid_ns(nr, ns), PIDTYPE_PID);
+
+	task = pid_task(find_pid_ns(nr, ns), PIDTYPE_PID);
+
+	if (gr_pid_is_chrooted(task))
+		return NULL;
+
+	return task;
 }
 
 struct task_struct *find_task_by_vpid(pid_t vnr)
@@ -461,6 +470,13 @@ struct task_struct *find_task_by_vpid(pid_t vnr)
 	return find_task_by_pid_ns(vnr, task_active_pid_ns(current));
 }
 
+struct task_struct *find_task_by_vpid_unrestricted(pid_t vnr)
+{
+	RCU_LOCKDEP_WARN(!rcu_read_lock_held(),
+			 "find_task_by_pid_ns() needs rcu_read_lock() protection");
+	return pid_task(find_pid_ns(vnr, task_active_pid_ns(current)), PIDTYPE_PID);
+}
+
 struct pid *get_task_pid(struct task_struct *task, enum pid_type type)
 {
 	struct pid *pid;
@@ -497,9 +513,9 @@ struct pid *find_get_pid(pid_t nr)
 }
 EXPORT_SYMBOL_GPL(find_get_pid);
 
-pid_t pid_nr_ns(struct pid *pid, struct pid_namespace *ns)
+pid_t pid_nr_ns(const struct pid *pid, const struct pid_namespace *ns)
 {
-	struct upid *upid;
+	const struct upid *upid;
 	pid_t nr = 0;
 
 	if (pid && ns->level <= pid->level) {
@@ -511,7 +527,7 @@ pid_t pid_nr_ns(struct pid *pid, struct pid_namespace *ns)
 }
 EXPORT_SYMBOL_GPL(pid_nr_ns);
 
-pid_t pid_vnr(struct pid *pid)
+pid_t pid_vnr(const struct pid *pid)
 {
 	return pid_nr_ns(pid, task_active_pid_ns(current));
 }
diff --git a/kernel/pid_namespace.c b/kernel/pid_namespace.c
index a65ba137f..f600dbb39 100644
--- a/kernel/pid_namespace.c
+++ b/kernel/pid_namespace.c
@@ -274,7 +274,7 @@ static int pid_ns_ctl_handler(struct ctl_table *table, int write,
 		void __user *buffer, size_t *lenp, loff_t *ppos)
 {
 	struct pid_namespace *pid_ns = task_active_pid_ns(current);
-	struct ctl_table tmp = *table;
+	ctl_table_no_const tmp = *table;
 
 	if (write && !ns_capable(pid_ns->user_ns, CAP_SYS_ADMIN))
 		return -EPERM;
diff --git a/kernel/power/Kconfig b/kernel/power/Kconfig
index 68d3ebc12..554935da4 100644
--- a/kernel/power/Kconfig
+++ b/kernel/power/Kconfig
@@ -34,6 +34,7 @@ config HIBERNATE_CALLBACKS
 config HIBERNATION
 	bool "Hibernation (aka 'suspend to disk')"
 	depends on SWAP && ARCH_HIBERNATION_POSSIBLE
+	depends on !GRKERNSEC_KMEM
 	select HIBERNATE_CALLBACKS
 	select LZO_COMPRESS
 	select LZO_DECOMPRESS
diff --git a/kernel/power/hibernate.c b/kernel/power/hibernate.c
index 33c79b610..b26dbc48c 100644
--- a/kernel/power/hibernate.c
+++ b/kernel/power/hibernate.c
@@ -306,8 +306,10 @@ static int create_image(int platform_mode)
 	if (error)
 		printk(KERN_ERR "PM: Error %d creating hibernation image\n",
 			error);
-	if (!in_suspend)
+	if (!in_suspend) {
 		events_check_enabled = false;
+		clear_free_pages();
+	}
 
 	platform_leave(platform_mode);
 
@@ -1189,22 +1191,6 @@ static int __init nohibernate_setup(char *str)
 	return 1;
 }
 
-static int __init page_poison_nohibernate_setup(char *str)
-{
-#ifdef CONFIG_PAGE_POISONING_ZERO
-	/*
-	 * The zeroing option for page poison skips the checks on alloc.
-	 * since hibernation doesn't save free pages there's no way to
-	 * guarantee the pages will still be zeroed.
-	 */
-	if (!strcmp(str, "on")) {
-		pr_info("Disabling hibernation due to page poisoning\n");
-		return nohibernate_setup(str);
-	}
-#endif
-	return 1;
-}
-
 __setup("noresume", noresume_setup);
 __setup("resume_offset=", resume_offset_setup);
 __setup("resume=", resume_setup);
@@ -1212,4 +1198,3 @@ __setup("hibernate=", hibernate_setup);
 __setup("resumewait", resumewait_setup);
 __setup("resumedelay=", resumedelay_setup);
 __setup("nohibernate", nohibernate_setup);
-__setup("page_poison=", page_poison_nohibernate_setup);
diff --git a/kernel/power/power.h b/kernel/power/power.h
index 242d8b827..56d1d0ded 100644
--- a/kernel/power/power.h
+++ b/kernel/power/power.h
@@ -110,6 +110,8 @@ extern int create_basic_memory_bitmaps(void);
 extern void free_basic_memory_bitmaps(void);
 extern int hibernate_preallocate_memory(void);
 
+extern void clear_free_pages(void);
+
 /**
  *	Auxiliary structure used for reading the snapshot image data and
  *	metadata from and writing them to the list of page backup entries
diff --git a/kernel/power/process.c b/kernel/power/process.c
index 8f27d5a8a..e7389a050 100644
--- a/kernel/power/process.c
+++ b/kernel/power/process.c
@@ -34,6 +34,7 @@ static int try_to_freeze_tasks(bool user_only)
 	unsigned int elapsed_msecs;
 	bool wakeup = false;
 	int sleep_usecs = USEC_PER_MSEC;
+	bool timedout = false;
 
 	start = ktime_get_boottime();
 
@@ -44,13 +45,20 @@ static int try_to_freeze_tasks(bool user_only)
 
 	while (true) {
 		todo = 0;
+		if (time_after(jiffies, end_time))
+			timedout = true;
 		read_lock(&tasklist_lock);
 		for_each_process_thread(g, p) {
 			if (p == current || !freeze_task(p))
 				continue;
 
-			if (!freezer_should_skip(p))
+			if (!freezer_should_skip(p)) {
 				todo++;
+				if (timedout) {
+					printk(KERN_ERR "Task refusing to freeze:\n");
+					sched_show_task(p);
+				}
+			}
 		}
 		read_unlock(&tasklist_lock);
 
@@ -59,7 +67,7 @@ static int try_to_freeze_tasks(bool user_only)
 			todo += wq_busy;
 		}
 
-		if (!todo || time_after(jiffies, end_time))
+		if (!todo || timedout)
 			break;
 
 		if (pm_wakeup_pending()) {
diff --git a/kernel/power/snapshot.c b/kernel/power/snapshot.c
index b02228411..48d5ea680 100644
--- a/kernel/power/snapshot.c
+++ b/kernel/power/snapshot.c
@@ -1020,6 +1020,26 @@ static void swsusp_unset_page_forbidden(struct page *page)
 		memory_bm_clear_bit(forbidden_pages_map, page_to_pfn(page));
 }
 
+void clear_free_pages(void)
+{
+	struct memory_bitmap *bm = free_pages_map;
+	unsigned long pfn;
+
+	if (WARN_ON(!(free_pages_map)))
+		return;
+
+	memory_bm_position_reset(bm);
+	pfn = memory_bm_next_pfn(bm);
+	while (pfn != BM_END_OF_MAP) {
+		if (pfn_valid(pfn))
+			clear_highpage(pfn_to_page(pfn));
+
+		pfn = memory_bm_next_pfn(bm);
+	}
+	memory_bm_position_reset(bm);
+	pr_info("PM: free pages cleared after restore\n");
+}
+
 /**
  * mark_nosave_pages - Mark pages that should not be saved.
  * @bm: Memory bitmap.
diff --git a/kernel/printk/printk.c b/kernel/printk/printk.c
index eea6dbc2d..075ab5e9e 100644
--- a/kernel/printk/printk.c
+++ b/kernel/printk/printk.c
@@ -588,7 +588,7 @@ static int log_store(int facility, int level,
 	return msg->text_len;
 }
 
-int dmesg_restrict = IS_ENABLED(CONFIG_SECURITY_DMESG_RESTRICT);
+int dmesg_restrict __read_only = IS_ENABLED(CONFIG_SECURITY_DMESG_RESTRICT);
 
 static int syslog_action_restricted(int type)
 {
@@ -611,6 +611,11 @@ int check_syslog_permissions(int type, int source)
 	if (source == SYSLOG_FROM_PROC && type != SYSLOG_ACTION_OPEN)
 		goto ok;
 
+#ifdef CONFIG_GRKERNSEC_DMESG
+	if (grsec_enable_dmesg && !capable(CAP_SYSLOG) && !capable_nolog(CAP_SYS_ADMIN))
+		return -EPERM;
+#endif
+
 	if (syslog_action_restricted(type)) {
 		if (capable(CAP_SYSLOG))
 			goto ok;
diff --git a/kernel/profile.c b/kernel/profile.c
index 2dbccf2d8..f98676cd7 100644
--- a/kernel/profile.c
+++ b/kernel/profile.c
@@ -37,7 +37,7 @@ struct profile_hit {
 #define NR_PROFILE_HIT		(PAGE_SIZE/sizeof(struct profile_hit))
 #define NR_PROFILE_GRP		(NR_PROFILE_HIT/PROFILE_GRPSZ)
 
-static atomic_t *prof_buffer;
+static atomic_unchecked_t *prof_buffer;
 static unsigned long prof_len, prof_shift;
 
 int prof_on __read_mostly;
@@ -257,7 +257,7 @@ static void profile_flip_buffers(void)
 					hits[i].pc = 0;
 				continue;
 			}
-			atomic_add(hits[i].hits, &prof_buffer[hits[i].pc]);
+			atomic_add_unchecked(hits[i].hits, &prof_buffer[hits[i].pc]);
 			hits[i].hits = hits[i].pc = 0;
 		}
 	}
@@ -318,9 +318,9 @@ static void do_profile_hits(int type, void *__pc, unsigned int nr_hits)
 	 * Add the current hit(s) and flush the write-queue out
 	 * to the global buffer:
 	 */
-	atomic_add(nr_hits, &prof_buffer[pc]);
+	atomic_add_unchecked(nr_hits, &prof_buffer[pc]);
 	for (i = 0; i < NR_PROFILE_HIT; ++i) {
-		atomic_add(hits[i].hits, &prof_buffer[hits[i].pc]);
+		atomic_add_unchecked(hits[i].hits, &prof_buffer[hits[i].pc]);
 		hits[i].pc = hits[i].hits = 0;
 	}
 out:
@@ -384,7 +384,7 @@ static void do_profile_hits(int type, void *__pc, unsigned int nr_hits)
 {
 	unsigned long pc;
 	pc = ((unsigned long)__pc - (unsigned long)_stext) >> prof_shift;
-	atomic_add(nr_hits, &prof_buffer[min(pc, prof_len - 1)]);
+	atomic_add_unchecked(nr_hits, &prof_buffer[min(pc, prof_len - 1)]);
 }
 #endif /* !CONFIG_SMP */
 
@@ -479,7 +479,7 @@ read_profile(struct file *file, char __user *buf, size_t count, loff_t *ppos)
 			return -EFAULT;
 		buf++; p++; count--; read++;
 	}
-	pnt = (char *)prof_buffer + p - sizeof(atomic_t);
+	pnt = (char *)prof_buffer + p - sizeof(atomic_unchecked_t);
 	if (copy_to_user(buf, (void *)pnt, count))
 		return -EFAULT;
 	read += count;
@@ -510,7 +510,7 @@ static ssize_t write_profile(struct file *file, const char __user *buf,
 	}
 #endif
 	profile_discard_flip_buffers();
-	memset(prof_buffer, 0, prof_len * sizeof(atomic_t));
+	memset(prof_buffer, 0, prof_len * sizeof(atomic_unchecked_t));
 	return count;
 }
 
diff --git a/kernel/ptrace.c b/kernel/ptrace.c
index 7b20baea4..ed03ccbed 100644
--- a/kernel/ptrace.c
+++ b/kernel/ptrace.c
@@ -213,7 +213,35 @@ static int ptrace_check_attach(struct task_struct *child, bool ignore_state)
 	return ret;
 }
 
-static int ptrace_has_cap(struct user_namespace *ns, unsigned int mode)
+static bool ptrace_has_cap(const struct cred *tcred, unsigned int mode)
+{
+	struct user_namespace *tns = tcred->user_ns;
+	struct user_namespace *curns = current_cred()->user_ns;
+
+	/* When a root-owned process enters a user namespace created by a
+	 * malicious user, the user shouldn't be able to execute code under
+	 * uid 0 by attaching to the root-owned process via ptrace.
+	 * Therefore, similar to the capable_wrt_inode_uidgid() check,
+	 * verify that all the uids and gids of the target process are
+	 * mapped into the current namespace.
+	 * No fsuid/fsgid check because __ptrace_may_access doesn't do it
+	 * either.
+	 */
+	if (!kuid_has_mapping(curns, tcred->euid) ||
+			!kuid_has_mapping(curns, tcred->suid) ||
+			!kuid_has_mapping(curns, tcred->uid)  ||
+			!kgid_has_mapping(curns, tcred->egid) ||
+			!kgid_has_mapping(curns, tcred->sgid) ||
+			!kgid_has_mapping(curns, tcred->gid))
+		return false;
+
+	if (mode & PTRACE_MODE_NOAUDIT)
+		return has_ns_capability_noaudit(current, tns, CAP_SYS_PTRACE);
+	else
+		return has_ns_capability(current, tns, CAP_SYS_PTRACE);
+}
+
+static bool ptrace_userns_has_cap(struct user_namespace *ns, unsigned int mode)
 {
 	if (mode & PTRACE_MODE_NOAUDIT)
 		return has_ns_capability_noaudit(current, ns, CAP_SYS_PTRACE);
@@ -228,6 +256,7 @@ static int __ptrace_may_access(struct task_struct *task, unsigned int mode)
 	struct mm_struct *mm;
 	kuid_t caller_uid;
 	kgid_t caller_gid;
+	int dumpable = 0;
 
 	if (!(mode & PTRACE_MODE_FSCREDS) == !(mode & PTRACE_MODE_REALCREDS)) {
 		WARN(1, "denying ptrace access check without PTRACE_MODE_*CREDS\n");
@@ -270,16 +299,28 @@ static int __ptrace_may_access(struct task_struct *task, unsigned int mode)
 	    gid_eq(caller_gid, tcred->sgid) &&
 	    gid_eq(caller_gid, tcred->gid))
 		goto ok;
-	if (ptrace_has_cap(tcred->user_ns, mode))
+	if (ptrace_has_cap(tcred, mode))
 		goto ok;
 	rcu_read_unlock();
 	return -EPERM;
 ok:
 	rcu_read_unlock();
+	smp_rmb();
 	mm = task->mm;
+	if (mm)
+		dumpable = get_dumpable(mm);
+
+	rcu_read_lock();
+	if (dumpable != SUID_DUMP_USER &&
+	    !ptrace_has_cap(__task_cred(task), mode)) {
+		rcu_read_unlock();
+		return -EPERM;
+	}
+	rcu_read_unlock();
+
 	if (mm &&
-	    ((get_dumpable(mm) != SUID_DUMP_USER) &&
-	     !ptrace_has_cap(mm->user_ns, mode)))
+	    (dumpable != SUID_DUMP_USER) &&
+	     !ptrace_userns_has_cap(mm->user_ns, mode))
 	    return -EPERM;
 
 	return security_ptrace_access_check(task, mode);
@@ -540,7 +581,7 @@ int ptrace_readdata(struct task_struct *tsk, unsigned long src, char __user *dst
 				break;
 			return -EIO;
 		}
-		if (copy_to_user(dst, buf, retval))
+		if (retval > sizeof(buf) || copy_to_user(dst, buf, retval))
 			return -EFAULT;
 		copied += retval;
 		src += retval;
@@ -841,7 +882,7 @@ int ptrace_request(struct task_struct *child, long request,
 	bool seized = child->ptrace & PT_SEIZED;
 	int ret = -EIO;
 	siginfo_t siginfo, *si;
-	void __user *datavp = (void __user *) data;
+	void __user *datavp = (__force void __user *) data;
 	unsigned long __user *datalp = datavp;
 	unsigned long flags;
 
@@ -1092,14 +1133,21 @@ SYSCALL_DEFINE4(ptrace, long, request, long, pid, unsigned long, addr,
 		goto out;
 	}
 
+	if (gr_handle_ptrace(child, request)) {
+		ret = -EPERM;
+		goto out_put_task_struct;
+	}
+
 	if (request == PTRACE_ATTACH || request == PTRACE_SEIZE) {
 		ret = ptrace_attach(child, request, addr, data);
 		/*
 		 * Some architectures need to do book-keeping after
 		 * a ptrace attach.
 		 */
-		if (!ret)
+		if (!ret) {
 			arch_ptrace_attach(child);
+			gr_audit_ptrace(child);
+		}
 		goto out_put_task_struct;
 	}
 
@@ -1127,7 +1175,7 @@ int generic_ptrace_peekdata(struct task_struct *tsk, unsigned long addr,
 	copied = access_process_vm(tsk, addr, &tmp, sizeof(tmp), 0);
 	if (copied != sizeof(tmp))
 		return -EIO;
-	return put_user(tmp, (unsigned long __user *)data);
+	return put_user(tmp, (__force unsigned long __user *)data);
 }
 
 int generic_ptrace_pokedata(struct task_struct *tsk, unsigned long addr,
@@ -1220,7 +1268,7 @@ int compat_ptrace_request(struct task_struct *child, compat_long_t request,
 }
 
 COMPAT_SYSCALL_DEFINE4(ptrace, compat_long_t, request, compat_long_t, pid,
-		       compat_long_t, addr, compat_long_t, data)
+		       compat_ulong_t, addr, compat_ulong_t, data)
 {
 	struct task_struct *child;
 	long ret;
@@ -1236,14 +1284,21 @@ COMPAT_SYSCALL_DEFINE4(ptrace, compat_long_t, request, compat_long_t, pid,
 		goto out;
 	}
 
+	if (gr_handle_ptrace(child, request)) {
+		ret = -EPERM;
+		goto out_put_task_struct;
+	}
+
 	if (request == PTRACE_ATTACH || request == PTRACE_SEIZE) {
 		ret = ptrace_attach(child, request, addr, data);
 		/*
 		 * Some architectures need to do book-keeping after
 		 * a ptrace attach.
 		 */
-		if (!ret)
+		if (!ret) {
 			arch_ptrace_attach(child);
+			gr_audit_ptrace(child);
+		}
 		goto out_put_task_struct;
 	}
 
diff --git a/kernel/rcu/rcutorture.c b/kernel/rcu/rcutorture.c
index 971e2b138..dc5637d9d 100644
--- a/kernel/rcu/rcutorture.c
+++ b/kernel/rcu/rcutorture.c
@@ -132,12 +132,12 @@ static struct rcu_torture rcu_tortures[10 * RCU_TORTURE_PIPE_LEN];
 static DEFINE_SPINLOCK(rcu_torture_lock);
 static DEFINE_PER_CPU(long [RCU_TORTURE_PIPE_LEN + 1], rcu_torture_count);
 static DEFINE_PER_CPU(long [RCU_TORTURE_PIPE_LEN + 1], rcu_torture_batch);
-static atomic_t rcu_torture_wcount[RCU_TORTURE_PIPE_LEN + 1];
-static atomic_t n_rcu_torture_alloc;
-static atomic_t n_rcu_torture_alloc_fail;
-static atomic_t n_rcu_torture_free;
-static atomic_t n_rcu_torture_mberror;
-static atomic_t n_rcu_torture_error;
+static atomic_unchecked_t rcu_torture_wcount[RCU_TORTURE_PIPE_LEN + 1];
+static atomic_unchecked_t n_rcu_torture_alloc;
+static atomic_unchecked_t n_rcu_torture_alloc_fail;
+static atomic_unchecked_t n_rcu_torture_free;
+static atomic_unchecked_t n_rcu_torture_mberror;
+static atomic_unchecked_t n_rcu_torture_error;
 static long n_rcu_torture_barrier_error;
 static long n_rcu_torture_boost_ktrerror;
 static long n_rcu_torture_boost_rterror;
@@ -146,7 +146,7 @@ static long n_rcu_torture_boosts;
 static long n_rcu_torture_timers;
 static long n_barrier_attempts;
 static long n_barrier_successes;
-static atomic_long_t n_cbfloods;
+static atomic_long_unchecked_t n_cbfloods;
 static struct list_head rcu_torture_removed;
 
 static int rcu_torture_writer_state;
@@ -225,11 +225,11 @@ rcu_torture_alloc(void)
 
 	spin_lock_bh(&rcu_torture_lock);
 	if (list_empty(&rcu_torture_freelist)) {
-		atomic_inc(&n_rcu_torture_alloc_fail);
+		atomic_inc_unchecked(&n_rcu_torture_alloc_fail);
 		spin_unlock_bh(&rcu_torture_lock);
 		return NULL;
 	}
-	atomic_inc(&n_rcu_torture_alloc);
+	atomic_inc_unchecked(&n_rcu_torture_alloc);
 	p = rcu_torture_freelist.next;
 	list_del_init(p);
 	spin_unlock_bh(&rcu_torture_lock);
@@ -242,7 +242,7 @@ rcu_torture_alloc(void)
 static void
 rcu_torture_free(struct rcu_torture *p)
 {
-	atomic_inc(&n_rcu_torture_free);
+	atomic_inc_unchecked(&n_rcu_torture_free);
 	spin_lock_bh(&rcu_torture_lock);
 	list_add_tail(&p->rtort_free, &rcu_torture_freelist);
 	spin_unlock_bh(&rcu_torture_lock);
@@ -323,7 +323,7 @@ rcu_torture_pipe_update_one(struct rcu_torture *rp)
 	i = rp->rtort_pipe_count;
 	if (i > RCU_TORTURE_PIPE_LEN)
 		i = RCU_TORTURE_PIPE_LEN;
-	atomic_inc(&rcu_torture_wcount[i]);
+	atomic_inc_unchecked(&rcu_torture_wcount[i]);
 	if (++rp->rtort_pipe_count >= RCU_TORTURE_PIPE_LEN) {
 		rp->rtort_mbtest = 0;
 		return true;
@@ -853,7 +853,7 @@ rcu_torture_cbflood(void *arg)
 	VERBOSE_TOROUT_STRING("rcu_torture_cbflood task started");
 	do {
 		schedule_timeout_interruptible(cbflood_inter_holdoff);
-		atomic_long_inc(&n_cbfloods);
+		atomic_long_inc_unchecked(&n_cbfloods);
 		WARN_ON(signal_pending(current));
 		for (i = 0; i < cbflood_n_burst; i++) {
 			for (j = 0; j < cbflood_n_per_burst; j++) {
@@ -983,7 +983,7 @@ rcu_torture_writer(void *arg)
 			i = old_rp->rtort_pipe_count;
 			if (i > RCU_TORTURE_PIPE_LEN)
 				i = RCU_TORTURE_PIPE_LEN;
-			atomic_inc(&rcu_torture_wcount[i]);
+			atomic_inc_unchecked(&rcu_torture_wcount[i]);
 			old_rp->rtort_pipe_count++;
 			switch (synctype[torture_random(&rand) % nsynctypes]) {
 			case RTWS_DEF_FREE:
@@ -1111,7 +1111,7 @@ static void rcu_torture_timer(unsigned long unused)
 		return;
 	}
 	if (p->rtort_mbtest == 0)
-		atomic_inc(&n_rcu_torture_mberror);
+		atomic_inc_unchecked(&n_rcu_torture_mberror);
 	spin_lock(&rand_lock);
 	cur_ops->read_delay(&rand);
 	n_rcu_torture_timers++;
@@ -1187,7 +1187,7 @@ rcu_torture_reader(void *arg)
 			continue;
 		}
 		if (p->rtort_mbtest == 0)
-			atomic_inc(&n_rcu_torture_mberror);
+			atomic_inc_unchecked(&n_rcu_torture_mberror);
 		cur_ops->read_delay(&rand);
 		preempt_disable();
 		pipe_count = p->rtort_pipe_count;
@@ -1255,11 +1255,11 @@ rcu_torture_stats_print(void)
 		rcu_torture_current,
 		rcu_torture_current_version,
 		list_empty(&rcu_torture_freelist),
-		atomic_read(&n_rcu_torture_alloc),
-		atomic_read(&n_rcu_torture_alloc_fail),
-		atomic_read(&n_rcu_torture_free));
+		atomic_read_unchecked(&n_rcu_torture_alloc),
+		atomic_read_unchecked(&n_rcu_torture_alloc_fail),
+		atomic_read_unchecked(&n_rcu_torture_free));
 	pr_cont("rtmbe: %d rtbke: %ld rtbre: %ld ",
-		atomic_read(&n_rcu_torture_mberror),
+		atomic_read_unchecked(&n_rcu_torture_mberror),
 		n_rcu_torture_boost_ktrerror,
 		n_rcu_torture_boost_rterror);
 	pr_cont("rtbf: %ld rtb: %ld nt: %ld ",
@@ -1271,17 +1271,17 @@ rcu_torture_stats_print(void)
 		n_barrier_successes,
 		n_barrier_attempts,
 		n_rcu_torture_barrier_error);
-	pr_cont("cbflood: %ld\n", atomic_long_read(&n_cbfloods));
+	pr_cont("cbflood: %ld\n", atomic_long_read_unchecked(&n_cbfloods));
 
 	pr_alert("%s%s ", torture_type, TORTURE_FLAG);
-	if (atomic_read(&n_rcu_torture_mberror) != 0 ||
+	if (atomic_read_unchecked(&n_rcu_torture_mberror) != 0 ||
 	    n_rcu_torture_barrier_error != 0 ||
 	    n_rcu_torture_boost_ktrerror != 0 ||
 	    n_rcu_torture_boost_rterror != 0 ||
 	    n_rcu_torture_boost_failure != 0 ||
 	    i > 1) {
 		pr_cont("%s", "!!! ");
-		atomic_inc(&n_rcu_torture_error);
+		atomic_inc_unchecked(&n_rcu_torture_error);
 		WARN_ON_ONCE(1);
 	}
 	pr_cont("Reader Pipe: ");
@@ -1298,7 +1298,7 @@ rcu_torture_stats_print(void)
 	pr_alert("%s%s ", torture_type, TORTURE_FLAG);
 	pr_cont("Free-Block Circulation: ");
 	for (i = 0; i < RCU_TORTURE_PIPE_LEN + 1; i++) {
-		pr_cont(" %d", atomic_read(&rcu_torture_wcount[i]));
+		pr_cont(" %d", atomic_read_unchecked(&rcu_torture_wcount[i]));
 	}
 	pr_cont("\n");
 
@@ -1655,7 +1655,7 @@ rcu_torture_cleanup(void)
 
 	rcu_torture_stats_print();  /* -After- the stats thread is stopped! */
 
-	if (atomic_read(&n_rcu_torture_error) || n_rcu_torture_barrier_error)
+	if (atomic_read_unchecked(&n_rcu_torture_error) || n_rcu_torture_barrier_error)
 		rcu_torture_print_module_parms(cur_ops, "End of test: FAILURE");
 	else if (torture_onoff_failures())
 		rcu_torture_print_module_parms(cur_ops,
@@ -1780,18 +1780,18 @@ rcu_torture_init(void)
 
 	rcu_torture_current = NULL;
 	rcu_torture_current_version = 0;
-	atomic_set(&n_rcu_torture_alloc, 0);
-	atomic_set(&n_rcu_torture_alloc_fail, 0);
-	atomic_set(&n_rcu_torture_free, 0);
-	atomic_set(&n_rcu_torture_mberror, 0);
-	atomic_set(&n_rcu_torture_error, 0);
+	atomic_set_unchecked(&n_rcu_torture_alloc, 0);
+	atomic_set_unchecked(&n_rcu_torture_alloc_fail, 0);
+	atomic_set_unchecked(&n_rcu_torture_free, 0);
+	atomic_set_unchecked(&n_rcu_torture_mberror, 0);
+	atomic_set_unchecked(&n_rcu_torture_error, 0);
 	n_rcu_torture_barrier_error = 0;
 	n_rcu_torture_boost_ktrerror = 0;
 	n_rcu_torture_boost_rterror = 0;
 	n_rcu_torture_boost_failure = 0;
 	n_rcu_torture_boosts = 0;
 	for (i = 0; i < RCU_TORTURE_PIPE_LEN + 1; i++)
-		atomic_set(&rcu_torture_wcount[i], 0);
+		atomic_set_unchecked(&rcu_torture_wcount[i], 0);
 	for_each_possible_cpu(cpu) {
 		for (i = 0; i < RCU_TORTURE_PIPE_LEN + 1; i++) {
 			per_cpu(rcu_torture_count, cpu)[i] = 0;
diff --git a/kernel/rcu/tiny.c b/kernel/rcu/tiny.c
index 944b1b491..45d1d756c 100644
--- a/kernel/rcu/tiny.c
+++ b/kernel/rcu/tiny.c
@@ -42,7 +42,7 @@
 /* Forward declarations for tiny_plugin.h. */
 struct rcu_ctrlblk;
 static void __rcu_process_callbacks(struct rcu_ctrlblk *rcp);
-static void rcu_process_callbacks(struct softirq_action *unused);
+static void rcu_process_callbacks(void);
 static void __call_rcu(struct rcu_head *head,
 		       rcu_callback_t func,
 		       struct rcu_ctrlblk *rcp);
@@ -170,7 +170,7 @@ static void __rcu_process_callbacks(struct rcu_ctrlblk *rcp)
 				      false));
 }
 
-static void rcu_process_callbacks(struct softirq_action *unused)
+static __latent_entropy void rcu_process_callbacks(void)
 {
 	__rcu_process_callbacks(&rcu_sched_ctrlblk);
 	__rcu_process_callbacks(&rcu_bh_ctrlblk);
diff --git a/kernel/rcu/tree.c b/kernel/rcu/tree.c
index 5d80925e7..a71654ae4 100644
--- a/kernel/rcu/tree.c
+++ b/kernel/rcu/tree.c
@@ -328,7 +328,7 @@ static void rcu_momentary_dyntick_idle(void)
 		 */
 		rdtp = this_cpu_ptr(&rcu_dynticks);
 		smp_mb__before_atomic(); /* Earlier stuff before QS. */
-		atomic_add(2, &rdtp->dynticks);  /* QS. */
+		atomic_add_unchecked(2, &rdtp->dynticks);  /* QS. */
 		smp_mb__after_atomic(); /* Later stuff after QS. */
 		break;
 	}
@@ -693,10 +693,10 @@ static void rcu_eqs_enter_common(long long oldval, bool user)
 	rcu_prepare_for_idle();
 	/* CPUs seeing atomic_inc() must see prior RCU read-side crit sects */
 	smp_mb__before_atomic();  /* See above. */
-	atomic_inc(&rdtp->dynticks);
+	atomic_inc_unchecked(&rdtp->dynticks);
 	smp_mb__after_atomic();  /* Force ordering with next sojourn. */
 	WARN_ON_ONCE(IS_ENABLED(CONFIG_RCU_EQS_DEBUG) &&
-		     atomic_read(&rdtp->dynticks) & 0x1);
+		     atomic_read_unchecked(&rdtp->dynticks) & 0x1);
 	rcu_dynticks_task_enter();
 
 	/*
@@ -829,11 +829,11 @@ static void rcu_eqs_exit_common(long long oldval, int user)
 
 	rcu_dynticks_task_exit();
 	smp_mb__before_atomic();  /* Force ordering w/previous sojourn. */
-	atomic_inc(&rdtp->dynticks);
+	atomic_inc_unchecked(&rdtp->dynticks);
 	/* CPUs seeing atomic_inc() must see later RCU read-side crit sects */
 	smp_mb__after_atomic();  /* See above. */
 	WARN_ON_ONCE(IS_ENABLED(CONFIG_RCU_EQS_DEBUG) &&
-		     !(atomic_read(&rdtp->dynticks) & 0x1));
+		     !(atomic_read_unchecked(&rdtp->dynticks) & 0x1));
 	rcu_cleanup_after_idle();
 	trace_rcu_dyntick(TPS("End"), oldval, rdtp->dynticks_nesting);
 	if (IS_ENABLED(CONFIG_RCU_EQS_DEBUG) &&
@@ -979,12 +979,12 @@ void rcu_nmi_enter(void)
 	 * to be in the outermost NMI handler that interrupted an RCU-idle
 	 * period (observation due to Andy Lutomirski).
 	 */
-	if (!(atomic_read(&rdtp->dynticks) & 0x1)) {
+	if (!(atomic_read_unchecked(&rdtp->dynticks) & 0x1)) {
 		smp_mb__before_atomic();  /* Force delay from prior write. */
-		atomic_inc(&rdtp->dynticks);
+		atomic_inc_unchecked(&rdtp->dynticks);
 		/* atomic_inc() before later RCU read-side crit sects */
 		smp_mb__after_atomic();  /* See above. */
-		WARN_ON_ONCE(!(atomic_read(&rdtp->dynticks) & 0x1));
+		WARN_ON_ONCE(!(atomic_read_unchecked(&rdtp->dynticks) & 0x1));
 		incby = 1;
 	}
 	rdtp->dynticks_nmi_nesting += incby;
@@ -1009,7 +1009,7 @@ void rcu_nmi_exit(void)
 	 * to us!)
 	 */
 	WARN_ON_ONCE(rdtp->dynticks_nmi_nesting <= 0);
-	WARN_ON_ONCE(!(atomic_read(&rdtp->dynticks) & 0x1));
+	WARN_ON_ONCE(!(atomic_read_unchecked(&rdtp->dynticks) & 0x1));
 
 	/*
 	 * If the nesting level is not 1, the CPU wasn't RCU-idle, so
@@ -1024,9 +1024,9 @@ void rcu_nmi_exit(void)
 	rdtp->dynticks_nmi_nesting = 0;
 	/* CPUs seeing atomic_inc() must see prior RCU read-side crit sects */
 	smp_mb__before_atomic();  /* See above. */
-	atomic_inc(&rdtp->dynticks);
+	atomic_inc_unchecked(&rdtp->dynticks);
 	smp_mb__after_atomic();  /* Force delay to next write. */
-	WARN_ON_ONCE(atomic_read(&rdtp->dynticks) & 0x1);
+	WARN_ON_ONCE(atomic_read_unchecked(&rdtp->dynticks) & 0x1);
 }
 
 /**
@@ -1039,7 +1039,7 @@ void rcu_nmi_exit(void)
  */
 bool notrace __rcu_is_watching(void)
 {
-	return atomic_read(this_cpu_ptr(&rcu_dynticks.dynticks)) & 0x1;
+	return atomic_read_unchecked(this_cpu_ptr(&rcu_dynticks.dynticks)) & 0x1;
 }
 
 /**
@@ -1122,7 +1122,7 @@ static int rcu_is_cpu_rrupt_from_idle(void)
 static int dyntick_save_progress_counter(struct rcu_data *rdp,
 					 bool *isidle, unsigned long *maxj)
 {
-	rdp->dynticks_snap = atomic_add_return(0, &rdp->dynticks->dynticks);
+	rdp->dynticks_snap = atomic_add_return_unchecked(0, &rdp->dynticks->dynticks);
 	rcu_sysidle_check_cpu(rdp, isidle, maxj);
 	if ((rdp->dynticks_snap & 0x1) == 0) {
 		trace_rcu_fqs(rdp->rsp->name, rdp->gpnum, rdp->cpu, TPS("dti"));
@@ -1147,7 +1147,7 @@ static int rcu_implicit_dynticks_qs(struct rcu_data *rdp,
 	int *rcrmp;
 	unsigned int snap;
 
-	curr = (unsigned int)atomic_add_return(0, &rdp->dynticks->dynticks);
+	curr = (unsigned int)atomic_add_return_unchecked(0, &rdp->dynticks->dynticks);
 	snap = (unsigned int)rdp->dynticks_snap;
 
 	/*
@@ -3013,7 +3013,7 @@ __rcu_process_callbacks(struct rcu_state *rsp)
 /*
  * Do RCU core processing for the current CPU.
  */
-static void rcu_process_callbacks(struct softirq_action *unused)
+static __latent_entropy void rcu_process_callbacks(void)
 {
 	struct rcu_state *rsp;
 
@@ -3750,7 +3750,7 @@ rcu_boot_init_percpu_data(int cpu, struct rcu_state *rsp)
 	rdp->grpmask = leaf_node_cpu_bit(rdp->mynode, cpu);
 	rdp->dynticks = &per_cpu(rcu_dynticks, cpu);
 	WARN_ON_ONCE(rdp->dynticks->dynticks_nesting != DYNTICK_TASK_EXIT_IDLE);
-	WARN_ON_ONCE(atomic_read(&rdp->dynticks->dynticks) != 1);
+	WARN_ON_ONCE(atomic_read_unchecked(&rdp->dynticks->dynticks) != 1);
 	rdp->cpu = cpu;
 	rdp->rsp = rsp;
 	rcu_boot_init_nocb_percpu_data(rdp);
@@ -3780,8 +3780,8 @@ rcu_init_percpu_data(int cpu, struct rcu_state *rsp)
 		init_callback_list(rdp);  /* Re-enable callbacks on this CPU. */
 	rdp->dynticks->dynticks_nesting = DYNTICK_TASK_EXIT_IDLE;
 	rcu_sysidle_init_percpu_data(rdp->dynticks);
-	atomic_set(&rdp->dynticks->dynticks,
-		   (atomic_read(&rdp->dynticks->dynticks) & ~0x1) + 1);
+	atomic_set_unchecked(&rdp->dynticks->dynticks,
+		   (atomic_read_unchecked(&rdp->dynticks->dynticks) & ~0x1) + 1);
 	raw_spin_unlock_rcu_node(rnp);		/* irqs remain disabled. */
 
 	/*
diff --git a/kernel/rcu/tree.h b/kernel/rcu/tree.h
index f714f873b..f49d80b49 100644
--- a/kernel/rcu/tree.h
+++ b/kernel/rcu/tree.h
@@ -111,11 +111,11 @@ struct rcu_dynticks {
 	long long dynticks_nesting; /* Track irq/process nesting level. */
 				    /* Process level is worth LLONG_MAX/2. */
 	int dynticks_nmi_nesting;   /* Track NMI nesting level. */
-	atomic_t dynticks;	    /* Even value for idle, else odd. */
+	atomic_unchecked_t dynticks;/* Even value for idle, else odd. */
 #ifdef CONFIG_NO_HZ_FULL_SYSIDLE
 	long long dynticks_idle_nesting;
 				    /* irq/process nesting level from idle. */
-	atomic_t dynticks_idle;	    /* Even value for idle, else odd. */
+	atomic_unchecked_t dynticks_idle;/* Even value for idle, else odd. */
 				    /*  "Idle" excludes userspace execution. */
 	unsigned long dynticks_idle_jiffies;
 				    /* End of last non-NMI non-idle period. */
@@ -400,9 +400,9 @@ struct rcu_data {
 #ifdef CONFIG_RCU_FAST_NO_HZ
 	struct rcu_head oom_head;
 #endif /* #ifdef CONFIG_RCU_FAST_NO_HZ */
-	atomic_long_t exp_workdone1;	/* # done by others #1. */
-	atomic_long_t exp_workdone2;	/* # done by others #2. */
-	atomic_long_t exp_workdone3;	/* # done by others #3. */
+	atomic_long_unchecked_t exp_workdone1;	/* # done by others #1. */
+	atomic_long_unchecked_t exp_workdone2;	/* # done by others #2. */
+	atomic_long_unchecked_t exp_workdone3;	/* # done by others #3. */
 
 	/* 7) Callback offloading. */
 #ifdef CONFIG_RCU_NOCB_CPU
@@ -519,8 +519,8 @@ struct rcu_state {
 	struct mutex exp_mutex;			/* Serialize expedited GP. */
 	struct mutex exp_wake_mutex;		/* Serialize wakeup. */
 	unsigned long expedited_sequence;	/* Take a ticket. */
-	atomic_long_t expedited_normal;		/* # fallbacks to normal. */
-	atomic_t expedited_need_qs;		/* # CPUs left to check in. */
+	atomic_long_unchecked_t expedited_normal;/* # fallbacks to normal. */
+	atomic_unchecked_t expedited_need_qs;	/* # CPUs left to check in. */
 	struct swait_queue_head expedited_wq;	/* Wait for check-ins. */
 	int ncpus_snap;				/* # CPUs seen last time. */
 
diff --git a/kernel/rcu/tree_exp.h b/kernel/rcu/tree_exp.h
index 6d86ab6ec..7046dff5a 100644
--- a/kernel/rcu/tree_exp.h
+++ b/kernel/rcu/tree_exp.h
@@ -223,14 +223,14 @@ static void rcu_report_exp_rdp(struct rcu_state *rsp, struct rcu_data *rdp,
 }
 
 /* Common code for synchronize_{rcu,sched}_expedited() work-done checking. */
-static bool sync_exp_work_done(struct rcu_state *rsp, atomic_long_t *stat,
+static bool sync_exp_work_done(struct rcu_state *rsp, atomic_long_unchecked_t *stat,
 			       unsigned long s)
 {
 	if (rcu_exp_gp_seq_done(rsp, s)) {
 		trace_rcu_exp_grace_period(rsp->name, s, TPS("done"));
 		/* Ensure test happens before caller kfree(). */
 		smp_mb__before_atomic(); /* ^^^ */
-		atomic_long_inc(stat);
+		atomic_long_inc_unchecked(stat);
 		return true;
 	}
 	return false;
@@ -359,7 +359,7 @@ static void sync_rcu_exp_select_cpus(struct rcu_state *rsp,
 			struct rcu_dynticks *rdtp = &per_cpu(rcu_dynticks, cpu);
 
 			if (raw_smp_processor_id() == cpu ||
-			    !(atomic_add_return(0, &rdtp->dynticks) & 0x1))
+			    !(atomic_add_return_unchecked(0, &rdtp->dynticks) & 0x1))
 				mask_ofl_test |= rdp->grpmask;
 		}
 		mask_ofl_ipi = rnp->expmask & ~mask_ofl_test;
diff --git a/kernel/rcu/tree_plugin.h b/kernel/rcu/tree_plugin.h
index 85c5a883c..4479872e3 100644
--- a/kernel/rcu/tree_plugin.h
+++ b/kernel/rcu/tree_plugin.h
@@ -1174,7 +1174,7 @@ static void rcu_boost_kthread_setaffinity(struct rcu_node *rnp, int outgoingcpu)
 	free_cpumask_var(cm);
 }
 
-static struct smp_hotplug_thread rcu_cpu_thread_spec = {
+static struct smp_hotplug_thread rcu_cpu_thread_spec __read_only = {
 	.store			= &rcu_cpu_kthread_task,
 	.thread_should_run	= rcu_cpu_kthread_should_run,
 	.thread_fn		= rcu_cpu_kthread,
@@ -1643,7 +1643,7 @@ static void print_cpu_stall_info(struct rcu_state *rsp, int cpu)
 	       "o."[!!(rdp->grpmask & rdp->mynode->qsmaskinit)],
 	       "N."[!!(rdp->grpmask & rdp->mynode->qsmaskinitnext)],
 	       ticks_value, ticks_title,
-	       atomic_read(&rdtp->dynticks) & 0xfff,
+	       atomic_read_unchecked(&rdtp->dynticks) & 0xfff,
 	       rdtp->dynticks_nesting, rdtp->dynticks_nmi_nesting,
 	       rdp->softirq_snap, kstat_softirqs_cpu(RCU_SOFTIRQ, cpu),
 	       READ_ONCE(rsp->n_force_qs) - rsp->n_force_qs_gpstart,
@@ -2178,8 +2178,8 @@ static int rcu_nocb_kthread(void *arg)
 		}
 		trace_rcu_batch_end(rdp->rsp->name, c, !!list, 0, 0, 1);
 		smp_mb__before_atomic();  /* _add after CB invocation. */
-		atomic_long_add(-c, &rdp->nocb_q_count);
-		atomic_long_add(-cl, &rdp->nocb_q_count_lazy);
+		atomic_long_sub(c, &rdp->nocb_q_count);
+		atomic_long_sub(cl, &rdp->nocb_q_count_lazy);
 		rdp->n_nocbs_invoked += c;
 	}
 	return 0;
@@ -2534,9 +2534,9 @@ static void rcu_sysidle_enter(int irq)
 	j = jiffies;
 	WRITE_ONCE(rdtp->dynticks_idle_jiffies, j);
 	smp_mb__before_atomic();
-	atomic_inc(&rdtp->dynticks_idle);
+	atomic_inc_unchecked(&rdtp->dynticks_idle);
 	smp_mb__after_atomic();
-	WARN_ON_ONCE(atomic_read(&rdtp->dynticks_idle) & 0x1);
+	WARN_ON_ONCE(atomic_read_unchecked(&rdtp->dynticks_idle) & 0x1);
 }
 
 /*
@@ -2607,9 +2607,9 @@ static void rcu_sysidle_exit(int irq)
 
 	/* Record end of idle period. */
 	smp_mb__before_atomic();
-	atomic_inc(&rdtp->dynticks_idle);
+	atomic_inc_unchecked(&rdtp->dynticks_idle);
 	smp_mb__after_atomic();
-	WARN_ON_ONCE(!(atomic_read(&rdtp->dynticks_idle) & 0x1));
+	WARN_ON_ONCE(!(atomic_read_unchecked(&rdtp->dynticks_idle) & 0x1));
 
 	/*
 	 * If we are the timekeeping CPU, we are permitted to be non-idle
@@ -2655,7 +2655,7 @@ static void rcu_sysidle_check_cpu(struct rcu_data *rdp, bool *isidle,
 	WARN_ON_ONCE(smp_processor_id() != tick_do_timer_cpu);
 
 	/* Pick up current idle and NMI-nesting counter and check. */
-	cur = atomic_read(&rdtp->dynticks_idle);
+	cur = atomic_read_unchecked(&rdtp->dynticks_idle);
 	if (cur & 0x1) {
 		*isidle = false; /* We are not idle! */
 		return;
diff --git a/kernel/rcu/tree_trace.c b/kernel/rcu/tree_trace.c
index 86782f9a4..2e8c0a309 100644
--- a/kernel/rcu/tree_trace.c
+++ b/kernel/rcu/tree_trace.c
@@ -124,7 +124,7 @@ static void print_one_rcu_data(struct seq_file *m, struct rcu_data *rdp)
 		   rdp->rcu_qs_ctr_snap == per_cpu(rcu_qs_ctr, rdp->cpu),
 		   rdp->core_needs_qs);
 	seq_printf(m, " dt=%d/%llx/%d df=%lu",
-		   atomic_read(&rdp->dynticks->dynticks),
+		   atomic_read_unchecked(&rdp->dynticks->dynticks),
 		   rdp->dynticks->dynticks_nesting,
 		   rdp->dynticks->dynticks_nmi_nesting,
 		   rdp->dynticks_fqs);
@@ -189,14 +189,14 @@ static int show_rcuexp(struct seq_file *m, void *v)
 
 	for_each_possible_cpu(cpu) {
 		rdp = per_cpu_ptr(rsp->rda, cpu);
-		s1 += atomic_long_read(&rdp->exp_workdone1);
-		s2 += atomic_long_read(&rdp->exp_workdone2);
-		s3 += atomic_long_read(&rdp->exp_workdone3);
+		s1 += atomic_long_read_unchecked(&rdp->exp_workdone1);
+		s2 += atomic_long_read_unchecked(&rdp->exp_workdone2);
+		s3 += atomic_long_read_unchecked(&rdp->exp_workdone3);
 	}
 	seq_printf(m, "s=%lu wd1=%lu wd2=%lu wd3=%lu n=%lu enq=%d sc=%lu\n",
 		   rsp->expedited_sequence, s1, s2, s3,
-		   atomic_long_read(&rsp->expedited_normal),
-		   atomic_read(&rsp->expedited_need_qs),
+		   atomic_long_read_unchecked(&rsp->expedited_normal),
+		   atomic_read_unchecked(&rsp->expedited_need_qs),
 		   rsp->expedited_sequence / 2);
 	return 0;
 }
diff --git a/kernel/resource.c b/kernel/resource.c
index 9b5f04404..b8b0a3338 100644
--- a/kernel/resource.c
+++ b/kernel/resource.c
@@ -84,8 +84,8 @@ static void *r_next(struct seq_file *m, void *v, loff_t *pos)
 
 enum { MAX_IORES_LEVEL = 5 };
 
+static void *r_start(struct seq_file *m, loff_t *pos) __acquires(&resource_lock);
 static void *r_start(struct seq_file *m, loff_t *pos)
-	__acquires(resource_lock)
 {
 	struct resource *p = m->private;
 	loff_t l = 0;
@@ -95,8 +95,8 @@ static void *r_start(struct seq_file *m, loff_t *pos)
 	return p;
 }
 
+static void r_stop(struct seq_file *m, void *v) __releases(&resource_lock);
 static void r_stop(struct seq_file *m, void *v)
-	__releases(resource_lock)
 {
 	read_unlock(&resource_lock);
 }
@@ -171,8 +171,18 @@ static const struct file_operations proc_iomem_operations = {
 
 static int __init ioresources_init(void)
 {
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+#ifdef CONFIG_GRKERNSEC_PROC_USER
+	proc_create("ioports", S_IRUSR, NULL, &proc_ioports_operations);
+	proc_create("iomem", S_IRUSR, NULL, &proc_iomem_operations);
+#elif defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+	proc_create("ioports", S_IRUSR | S_IRGRP, NULL, &proc_ioports_operations);
+	proc_create("iomem", S_IRUSR | S_IRGRP, NULL, &proc_iomem_operations);
+#endif
+#else
 	proc_create("ioports", 0, NULL, &proc_ioports_operations);
 	proc_create("iomem", 0, NULL, &proc_iomem_operations);
+#endif
 	return 0;
 }
 __initcall(ioresources_init);
diff --git a/kernel/sched/auto_group.c b/kernel/sched/auto_group.c
index 418d9b627..45ff39b97 100644
--- a/kernel/sched/auto_group.c
+++ b/kernel/sched/auto_group.c
@@ -9,7 +9,7 @@
 
 unsigned int __read_mostly sysctl_sched_autogroup_enabled = 1;
 static struct autogroup autogroup_default;
-static atomic_t autogroup_seq_nr;
+static atomic_unchecked_t autogroup_seq_nr;
 
 void __init autogroup_init(struct task_struct *init_task)
 {
@@ -77,7 +77,7 @@ static inline struct autogroup *autogroup_create(void)
 
 	kref_init(&ag->kref);
 	init_rwsem(&ag->lock);
-	ag->id = atomic_inc_return(&autogroup_seq_nr);
+	ag->id = atomic_inc_return_unchecked(&autogroup_seq_nr);
 	ag->tg = tg;
 #ifdef CONFIG_RT_GROUP_SCHED
 	/*
diff --git a/kernel/sched/core.c b/kernel/sched/core.c
index 44817c640..caeebd2e8 100644
--- a/kernel/sched/core.c
+++ b/kernel/sched/core.c
@@ -2259,7 +2259,7 @@ void set_numabalancing_state(bool enabled)
 int sysctl_numa_balancing(struct ctl_table *table, int write,
 			 void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table t;
+	ctl_table_no_const t;
 	int err;
 	int state = static_branch_likely(&sched_numa_balancing);
 
@@ -2334,7 +2334,7 @@ static void __init init_schedstats(void)
 int sysctl_schedstats(struct ctl_table *table, int write,
 			 void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table t;
+	ctl_table_no_const t;
 	int err;
 	int state = static_branch_likely(&sched_schedstats);
 
@@ -2784,7 +2784,7 @@ static struct rq *finish_task_switch(struct task_struct *prev)
 /* rq->lock is NOT held, but preemption is disabled */
 static void __balance_callback(struct rq *rq)
 {
-	struct callback_head *head, *next;
+	struct balance_callback *head, *next;
 	void (*func)(struct rq *rq);
 	unsigned long flags;
 
@@ -2792,7 +2792,7 @@ static void __balance_callback(struct rq *rq)
 	head = rq->balance_callback;
 	rq->balance_callback = NULL;
 	while (head) {
-		func = (void (*)(struct rq *))head->func;
+		func = head->func;
 		next = head->next;
 		head->next = NULL;
 		head = next;
@@ -3759,6 +3759,8 @@ int can_nice(const struct task_struct *p, const int nice)
 	/* convert nice value [19,-20] to rlimit style value [1,40] */
 	int nice_rlim = nice_to_rlimit(nice);
 
+	gr_learn_resource(p, RLIMIT_NICE, nice_rlim, 1);
+
 	return (nice_rlim <= task_rlimit(p, RLIMIT_NICE) ||
 		capable(CAP_SYS_NICE));
 }
@@ -3785,7 +3787,8 @@ SYSCALL_DEFINE1(nice, int, increment)
 	nice = task_nice(current) + increment;
 
 	nice = clamp_val(nice, MIN_NICE, MAX_NICE);
-	if (increment < 0 && !can_nice(current, nice))
+	if (increment < 0 && (!can_nice(current, nice) ||
+			      gr_handle_chroot_nice()))
 		return -EPERM;
 
 	retval = security_task_setnice(current, nice);
@@ -4095,6 +4098,7 @@ recheck:
 			if (policy != p->policy && !rlim_rtprio)
 				return -EPERM;
 
+			gr_learn_resource(p, RLIMIT_RTPRIO, attr->sched_priority, 1);
 			/* can't increase priority */
 			if (attr->sched_priority > p->rt_priority &&
 			    attr->sched_priority > rlim_rtprio)
@@ -7450,6 +7454,14 @@ void __init sched_init(void)
 	for_each_possible_cpu(i) {
 		struct rq *rq;
 
+#if defined(CONFIG_GRKERNSEC_KSTACKOVERFLOW) && defined(CONFIG_X86_64)
+		void *newstack = vzalloc_irq_stack();
+		if (newstack == NULL)
+			panic("grsec: Unable to allocate irq stack");
+		populate_stack(newstack, IRQ_STACK_SIZE);
+		per_cpu(irq_stack_ptr, i) = newstack + IRQ_STACK_SIZE - 64;
+#endif
+
 		rq = cpu_rq(i);
 		raw_spin_lock_init(&rq->lock);
 		rq->nr_running = 0;
@@ -7580,7 +7592,7 @@ void __might_sleep(const char *file, int line, int preempt_offset)
 	 */
 	WARN_ONCE(current->state != TASK_RUNNING && current->task_state_change,
 			"do not call blocking ops when !TASK_RUNNING; "
-			"state=%lx set at [<%p>] %pS\n",
+			"state=%lx set at [<%p>] %pA\n",
 			current->state,
 			(void *)current->task_state_change,
 			(void *)current->task_state_change);
diff --git a/kernel/sched/deadline.c b/kernel/sched/deadline.c
index 1ce886728..0472a4934 100644
--- a/kernel/sched/deadline.c
+++ b/kernel/sched/deadline.c
@@ -219,8 +219,8 @@ static inline bool need_pull_dl_task(struct rq *rq, struct task_struct *prev)
 	return dl_task(prev);
 }
 
-static DEFINE_PER_CPU(struct callback_head, dl_push_head);
-static DEFINE_PER_CPU(struct callback_head, dl_pull_head);
+static DEFINE_PER_CPU(struct balance_callback, dl_push_head);
+static DEFINE_PER_CPU(struct balance_callback, dl_pull_head);
 
 static void push_dl_tasks(struct rq *);
 static void pull_dl_task(struct rq *);
diff --git a/kernel/sched/debug.c b/kernel/sched/debug.c
index 2a0a99952..dc593c867 100644
--- a/kernel/sched/debug.c
+++ b/kernel/sched/debug.c
@@ -193,7 +193,7 @@ late_initcall(sched_init_debug);
 
 #ifdef CONFIG_SYSCTL
 
-static struct ctl_table sd_ctl_dir[] = {
+static ctl_table_no_const sd_ctl_dir[] __read_only = {
 	{
 		.procname	= "sched_domain",
 		.mode		= 0555,
@@ -210,17 +210,17 @@ static struct ctl_table sd_ctl_root[] = {
 	{}
 };
 
-static struct ctl_table *sd_alloc_ctl_entry(int n)
+static ctl_table_no_const *sd_alloc_ctl_entry(int n)
 {
-	struct ctl_table *entry =
+	ctl_table_no_const *entry =
 		kcalloc(n, sizeof(struct ctl_table), GFP_KERNEL);
 
 	return entry;
 }
 
-static void sd_free_ctl_entry(struct ctl_table **tablep)
+static void sd_free_ctl_entry(ctl_table_no_const *tablep)
 {
-	struct ctl_table *entry;
+	ctl_table_no_const *entry;
 
 	/*
 	 * In the intermediate directories, both the child directory and
@@ -228,22 +228,25 @@ static void sd_free_ctl_entry(struct ctl_table **tablep)
 	 * will always be set. In the lowest directory the names are
 	 * static strings and all have proc handlers.
 	 */
-	for (entry = *tablep; entry->mode; entry++) {
-		if (entry->child)
-			sd_free_ctl_entry(&entry->child);
+	for (entry = tablep; entry->mode; entry++) {
+		if (entry->child) {
+			sd_free_ctl_entry(entry->child);
+			pax_open_kernel();
+			entry->child = NULL;
+			pax_close_kernel();
+		}
 		if (entry->proc_handler == NULL)
 			kfree(entry->procname);
 	}
 
-	kfree(*tablep);
-	*tablep = NULL;
+	kfree(tablep);
 }
 
 static int min_load_idx = 0;
 static int max_load_idx = CPU_LOAD_IDX_MAX-1;
 
 static void
-set_table_entry(struct ctl_table *entry,
+set_table_entry(ctl_table_no_const *entry,
 		const char *procname, void *data, int maxlen,
 		umode_t mode, proc_handler *proc_handler,
 		bool load_idx)
@@ -260,10 +263,10 @@ set_table_entry(struct ctl_table *entry,
 	}
 }
 
-static struct ctl_table *
+static ctl_table_no_const *
 sd_alloc_ctl_domain_table(struct sched_domain *sd)
 {
-	struct ctl_table *table = sd_alloc_ctl_entry(14);
+	ctl_table_no_const *table = sd_alloc_ctl_entry(14);
 
 	if (table == NULL)
 		return NULL;
@@ -301,9 +304,9 @@ sd_alloc_ctl_domain_table(struct sched_domain *sd)
 	return table;
 }
 
-static struct ctl_table *sd_alloc_ctl_cpu_table(int cpu)
+static ctl_table_no_const *sd_alloc_ctl_cpu_table(int cpu)
 {
-	struct ctl_table *entry, *table;
+	ctl_table_no_const *entry, *table;
 	struct sched_domain *sd;
 	int domain_num = 0, i;
 	char buf[32];
@@ -330,11 +333,13 @@ static struct ctl_table_header *sd_sysctl_header;
 void register_sched_domain_sysctl(void)
 {
 	int i, cpu_num = num_possible_cpus();
-	struct ctl_table *entry = sd_alloc_ctl_entry(cpu_num + 1);
+	ctl_table_no_const *entry = sd_alloc_ctl_entry(cpu_num + 1);
 	char buf[32];
 
 	WARN_ON(sd_ctl_dir[0].child);
+	pax_open_kernel();
 	sd_ctl_dir[0].child = entry;
+	pax_close_kernel();
 
 	if (entry == NULL)
 		return;
@@ -356,8 +361,12 @@ void unregister_sched_domain_sysctl(void)
 {
 	unregister_sysctl_table(sd_sysctl_header);
 	sd_sysctl_header = NULL;
-	if (sd_ctl_dir[0].child)
-		sd_free_ctl_entry(&sd_ctl_dir[0].child);
+	if (sd_ctl_dir[0].child) {
+		sd_free_ctl_entry(sd_ctl_dir[0].child);
+		pax_open_kernel();
+		sd_ctl_dir[0].child = NULL;
+		pax_close_kernel();
+	}
 }
 #endif /* CONFIG_SYSCTL */
 #endif /* CONFIG_SMP */
@@ -801,7 +810,11 @@ static int __init init_sched_debug_procfs(void)
 {
 	struct proc_dir_entry *pe;
 
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+	pe = proc_create("sched_debug", 0400, NULL, &sched_debug_fops);
+#else
 	pe = proc_create("sched_debug", 0444, NULL, &sched_debug_fops);
+#endif
 	if (!pe)
 		return -ENOMEM;
 	return 0;
diff --git a/kernel/sched/fair.c b/kernel/sched/fair.c
index 8b3610c87..94bbee30c 100644
--- a/kernel/sched/fair.c
+++ b/kernel/sched/fair.c
@@ -8305,7 +8305,7 @@ static void nohz_idle_balance(struct rq *this_rq, enum cpu_idle_type idle) { }
  * run_rebalance_domains is triggered when needed from the scheduler tick.
  * Also triggered for nohz idle balancing (with nohz_balancing_kick set).
  */
-static void run_rebalance_domains(struct softirq_action *h)
+static __latent_entropy void run_rebalance_domains(void)
 {
 	struct rq *this_rq = this_rq();
 	enum cpu_idle_type idle = this_rq->idle_balance ?
diff --git a/kernel/sched/rt.c b/kernel/sched/rt.c
index d5690b722..40d1c8571 100644
--- a/kernel/sched/rt.c
+++ b/kernel/sched/rt.c
@@ -362,8 +362,8 @@ static inline int has_pushable_tasks(struct rq *rq)
 	return !plist_head_empty(&rq->rt.pushable_tasks);
 }
 
-static DEFINE_PER_CPU(struct callback_head, rt_push_head);
-static DEFINE_PER_CPU(struct callback_head, rt_pull_head);
+static DEFINE_PER_CPU(struct balance_callback, rt_push_head);
+static DEFINE_PER_CPU(struct balance_callback, rt_pull_head);
 
 static void push_rt_tasks(struct rq *);
 static void pull_rt_task(struct rq *);
diff --git a/kernel/sched/sched.h b/kernel/sched/sched.h
index c64fc5114..d12559e02 100644
--- a/kernel/sched/sched.h
+++ b/kernel/sched/sched.h
@@ -642,7 +642,10 @@ struct rq {
 	unsigned long cpu_capacity;
 	unsigned long cpu_capacity_orig;
 
-	struct callback_head *balance_callback;
+	struct balance_callback {
+		struct balance_callback *next;
+		void (*func)(struct rq *rq);
+	} *balance_callback;
 
 	unsigned char idle_balance;
 	/* For active balancing */
@@ -788,7 +791,7 @@ extern int migrate_swap(struct task_struct *, struct task_struct *);
 
 static inline void
 queue_balance_callback(struct rq *rq,
-		       struct callback_head *head,
+		       struct balance_callback *head,
 		       void (*func)(struct rq *rq))
 {
 	lockdep_assert_held(&rq->lock);
@@ -796,7 +799,7 @@ queue_balance_callback(struct rq *rq,
 	if (unlikely(head->next))
 		return;
 
-	head->func = (void (*)(struct callback_head *))func;
+	head->func = func;
 	head->next = rq->balance_callback;
 	rq->balance_callback = head;
 }
@@ -1253,7 +1256,7 @@ struct sched_class {
 #ifdef CONFIG_FAIR_GROUP_SCHED
 	void (*task_change_group) (struct task_struct *p, int type);
 #endif
-};
+} __do_const;
 
 static inline void put_prev_task(struct rq *rq, struct task_struct *prev)
 {
@@ -1323,7 +1326,7 @@ extern struct dl_bandwidth def_dl_bandwidth;
 extern void init_dl_bandwidth(struct dl_bandwidth *dl_b, u64 period, u64 runtime);
 extern void init_dl_task_timer(struct sched_dl_entity *dl_se);
 
-unsigned long to_ratio(u64 period, u64 runtime);
+unsigned long __attribute_const__ to_ratio(u64 period, u64 runtime);
 
 extern void init_entity_runnable_average(struct sched_entity *se);
 extern void post_init_entity_util_avg(struct sched_entity *se);
diff --git a/kernel/signal.c b/kernel/signal.c
index af21afc00..bc14d326e 100644
--- a/kernel/signal.c
+++ b/kernel/signal.c
@@ -53,12 +53,12 @@ static struct kmem_cache *sigqueue_cachep;
 
 int print_fatal_signals __read_mostly;
 
-static void __user *sig_handler(struct task_struct *t, int sig)
+static __sighandler_t sig_handler(struct task_struct *t, int sig)
 {
 	return t->sighand->action[sig - 1].sa.sa_handler;
 }
 
-static int sig_handler_ignored(void __user *handler, int sig)
+static int sig_handler_ignored(__sighandler_t handler, int sig)
 {
 	/* Is it explicitly or implicitly ignored? */
 	return handler == SIG_IGN ||
@@ -67,7 +67,7 @@ static int sig_handler_ignored(void __user *handler, int sig)
 
 static int sig_task_ignored(struct task_struct *t, int sig, bool force)
 {
-	void __user *handler;
+	__sighandler_t handler;
 
 	handler = sig_handler(t, sig);
 
@@ -372,6 +372,9 @@ __sigqueue_alloc(int sig, struct task_struct *t, gfp_t flags, int override_rlimi
 	atomic_inc(&user->sigpending);
 	rcu_read_unlock();
 
+	if (!override_rlimit)
+		gr_learn_resource(t, RLIMIT_SIGPENDING, atomic_read(&user->sigpending), 1);
+
 	if (override_rlimit ||
 	    atomic_read(&user->sigpending) <=
 			task_rlimit(t, RLIMIT_SIGPENDING)) {
@@ -494,7 +497,7 @@ flush_signal_handlers(struct task_struct *t, int force_default)
 
 int unhandled_signal(struct task_struct *tsk, int sig)
 {
-	void __user *handler = tsk->sighand->action[sig-1].sa.sa_handler;
+	__sighandler_t handler = tsk->sighand->action[sig-1].sa.sa_handler;
 	if (is_global_init(tsk))
 		return 1;
 	if (handler != SIG_IGN && handler != SIG_DFL)
@@ -556,6 +559,7 @@ static int __dequeue_signal(struct sigpending *pending, sigset_t *mask,
  *
  * All callers have to hold the siglock.
  */
+int dequeue_signal(struct task_struct *tsk, sigset_t *mask, siginfo_t *info) __must_hold(&tsk->sighand->siglock);
 int dequeue_signal(struct task_struct *tsk, sigset_t *mask, siginfo_t *info)
 {
 	int signr;
@@ -742,6 +746,13 @@ static int check_kill_permission(int sig, struct siginfo *info,
 		}
 	}
 
+	/* allow glibc communication via tgkill to other threads in our
+	   thread group */
+	if ((info == SEND_SIG_NOINFO || info->si_code != SI_TKILL ||
+	     sig != (SIGRTMIN+1) || task_tgid_vnr(t) != info->si_pid)
+	    && gr_handle_signal(t, sig))
+		return -EPERM;
+
 	return security_task_kill(t, info, sig, 0);
 }
 
@@ -1125,7 +1136,7 @@ __group_send_sig_info(int sig, struct siginfo *info, struct task_struct *p)
 	return send_signal(sig, info, p, 1);
 }
 
-static int
+int
 specific_send_sig_info(int sig, struct siginfo *info, struct task_struct *t)
 {
 	return send_signal(sig, info, t, 0);
@@ -1162,6 +1173,7 @@ force_sig_info(int sig, struct siginfo *info, struct task_struct *t)
 	unsigned long int flags;
 	int ret, blocked, ignored;
 	struct k_sigaction *action;
+	int is_unhandled = 0;
 
 	spin_lock_irqsave(&t->sighand->siglock, flags);
 	action = &t->sighand->action[sig-1];
@@ -1176,9 +1188,18 @@ force_sig_info(int sig, struct siginfo *info, struct task_struct *t)
 	}
 	if (action->sa.sa_handler == SIG_DFL)
 		t->signal->flags &= ~SIGNAL_UNKILLABLE;
+	if (action->sa.sa_handler == SIG_IGN || action->sa.sa_handler == SIG_DFL)
+		is_unhandled = 1;
 	ret = specific_send_sig_info(sig, info, t);
 	spin_unlock_irqrestore(&t->sighand->siglock, flags);
 
+	/* only deal with unhandled signals, java etc trigger SIGSEGV during
+	   normal operation */
+	if (is_unhandled) {
+		gr_log_signal(sig, !is_si_special(info) ? info->si_addr : NULL, t);
+		gr_handle_crash(t, sig);
+	}
+
 	return ret;
 }
 
@@ -1259,8 +1280,11 @@ int group_send_sig_info(int sig, struct siginfo *info, struct task_struct *p)
 	ret = check_kill_permission(sig, info, p);
 	rcu_read_unlock();
 
-	if (!ret && sig)
+	if (!ret && sig) {
 		ret = do_send_sig_info(sig, info, p, true);
+		if (!ret)
+			gr_log_signal(sig, !is_si_special(info) ? info->si_addr : NULL, p);
+	}
 
 	return ret;
 }
@@ -1774,9 +1798,8 @@ static int sigkill_pending(struct task_struct *tsk)
  * If we actually decide not to stop at all because the tracer
  * is gone, we keep current->exit_code unless clear_code.
  */
+static void ptrace_stop(int exit_code, int why, int clear_code, siginfo_t *info) __must_hold(&current->sighand->siglock);
 static void ptrace_stop(int exit_code, int why, int clear_code, siginfo_t *info)
-	__releases(&current->sighand->siglock)
-	__acquires(&current->sighand->siglock)
 {
 	bool gstop_done = false;
 
@@ -1896,6 +1919,7 @@ static void ptrace_stop(int exit_code, int why, int clear_code, siginfo_t *info)
 	recalc_sigpending_tsk(current);
 }
 
+static void ptrace_do_notify(int signr, int exit_code, int why) __must_hold(&current->sighand->siglock);
 static void ptrace_do_notify(int signr, int exit_code, int why)
 {
 	siginfo_t info;
@@ -1943,8 +1967,8 @@ void ptrace_notify(int exit_code)
  * %false if group stop is already cancelled or ptrace trap is scheduled.
  * %true if participated in group stop.
  */
+static bool do_signal_stop(int signr) __releases(&current->sighand->siglock);
 static bool do_signal_stop(int signr)
-	__releases(&current->sighand->siglock)
 {
 	struct signal_struct *sig = current->signal;
 
@@ -1956,8 +1980,10 @@ static bool do_signal_stop(int signr)
 		WARN_ON_ONCE(signr & ~JOBCTL_STOP_SIGMASK);
 
 		if (!likely(current->jobctl & JOBCTL_STOP_DEQUEUED) ||
-		    unlikely(signal_group_exit(sig)))
+		    unlikely(signal_group_exit(sig))) {
+			__release(&current->sighand->siglock); // XXX sparse can't model conditional release
 			return false;
+		}
 		/*
 		 * There is no group stop already in progress.  We must
 		 * initiate one now.
@@ -2041,6 +2067,7 @@ static bool do_signal_stop(int signr)
 		 * Schedule it and let the caller deal with it.
 		 */
 		task_set_jobctl_pending(current, JOBCTL_TRAP_STOP);
+		__release(&current->sighand->siglock); // XXX sparse can't model conditional release
 		return false;
 	}
 }
@@ -2864,7 +2891,15 @@ do_send_specific(pid_t tgid, pid_t pid, int sig, struct siginfo *info)
 	int error = -ESRCH;
 
 	rcu_read_lock();
-	p = find_task_by_vpid(pid);
+#ifdef CONFIG_GRKERNSEC_CHROOT_FINDTASK
+	/* allow glibc communication via tgkill to other threads in our
+	   thread group */
+	if (grsec_enable_chroot_findtask && info->si_code == SI_TKILL &&
+	    sig == (SIGRTMIN+1) && tgid == info->si_pid)	    
+		p = find_task_by_vpid_unrestricted(pid);
+	else
+#endif
+		p = find_task_by_vpid(pid);
 	if (p && (tgid <= 0 || task_tgid_vnr(p) == tgid)) {
 		error = check_kill_permission(sig, info, p);
 		/*
@@ -3196,8 +3231,8 @@ COMPAT_SYSCALL_DEFINE2(sigaltstack,
 	}
 	seg = get_fs();
 	set_fs(KERNEL_DS);
-	ret = do_sigaltstack((stack_t __force __user *) (uss_ptr ? &uss : NULL),
-			     (stack_t __force __user *) &uoss,
+	ret = do_sigaltstack((stack_t __force_user *) (uss_ptr ? &uss : NULL),
+			     (stack_t __force_user *) &uoss,
 			     compat_user_stack_pointer());
 	set_fs(seg);
 	if (ret >= 0 && uoss_ptr)  {
@@ -3481,7 +3516,7 @@ SYSCALL_DEFINE1(ssetmask, int, newmask)
 SYSCALL_DEFINE2(signal, int, sig, __sighandler_t, handler)
 {
 	struct k_sigaction new_sa, old_sa;
-	int ret;
+	long ret;
 
 	new_sa.sa.sa_handler = handler;
 	new_sa.sa.sa_flags = SA_ONESHOT | SA_NOMASK;
@@ -3489,7 +3524,7 @@ SYSCALL_DEFINE2(signal, int, sig, __sighandler_t, handler)
 
 	ret = do_sigaction(sig, &new_sa, &old_sa);
 
-	return ret ? ret : (unsigned long)old_sa.sa.sa_handler;
+	return ret ? ret : (long)old_sa.sa.sa_handler;
 }
 #endif /* __ARCH_WANT_SYS_SIGNAL */
 
diff --git a/kernel/smp.c b/kernel/smp.c
index 3aa642d39..320001983 100644
--- a/kernel/smp.c
+++ b/kernel/smp.c
@@ -573,7 +573,7 @@ void __init smp_init(void)
  * early_boot_irqs_disabled is set.  Use local_irq_save/restore() instead
  * of local_irq_disable/enable().
  */
-int on_each_cpu(void (*func) (void *info), void *info, int wait)
+int on_each_cpu(smp_call_func_t func, void *info, int wait)
 {
 	unsigned long flags;
 	int ret = 0;
diff --git a/kernel/smpboot.c b/kernel/smpboot.c
index 13bc43d1f..e7068a251 100644
--- a/kernel/smpboot.c
+++ b/kernel/smpboot.c
@@ -13,6 +13,7 @@
 #include <linux/percpu.h>
 #include <linux/kthread.h>
 #include <linux/smpboot.h>
+#include <asm/pgtable.h>
 
 #include "smpboot.h"
 
@@ -303,7 +304,7 @@ int smpboot_register_percpu_thread_cpumask(struct smp_hotplug_thread *plug_threa
 		if (cpumask_test_cpu(cpu, cpumask))
 			smpboot_unpark_thread(plug_thread, cpu);
 	}
-	list_add(&plug_thread->list, &hotplug_threads);
+	pax_list_add(&plug_thread->list, &hotplug_threads);
 out:
 	mutex_unlock(&smpboot_threads_lock);
 	put_online_cpus();
@@ -321,7 +322,7 @@ void smpboot_unregister_percpu_thread(struct smp_hotplug_thread *plug_thread)
 {
 	get_online_cpus();
 	mutex_lock(&smpboot_threads_lock);
-	list_del(&plug_thread->list);
+	pax_list_del(&plug_thread->list);
 	smpboot_destroy_threads(plug_thread);
 	mutex_unlock(&smpboot_threads_lock);
 	put_online_cpus();
@@ -361,7 +362,9 @@ int smpboot_update_cpumask_percpu_thread(struct smp_hotplug_thread *plug_thread,
 	for_each_cpu_and(cpu, tmp, cpu_online_mask)
 		smpboot_unpark_thread(plug_thread, cpu);
 
+	pax_open_kernel();
 	cpumask_copy(old, new);
+	pax_close_kernel();
 
 	mutex_unlock(&smpboot_threads_lock);
 	put_online_cpus();
diff --git a/kernel/softirq.c b/kernel/softirq.c
index 17caf4b63..2e68ae7c7 100644
--- a/kernel/softirq.c
+++ b/kernel/softirq.c
@@ -53,7 +53,7 @@ irq_cpustat_t irq_stat[NR_CPUS] ____cacheline_aligned;
 EXPORT_SYMBOL(irq_stat);
 #endif
 
-static struct softirq_action softirq_vec[NR_SOFTIRQS] __cacheline_aligned_in_smp;
+static struct softirq_action softirq_vec[NR_SOFTIRQS] __read_only __aligned(PAGE_SIZE);
 
 DEFINE_PER_CPU(struct task_struct *, ksoftirqd);
 
@@ -270,7 +270,7 @@ restart:
 		kstat_incr_softirqs_this_cpu(vec_nr);
 
 		trace_softirq_entry(vec_nr);
-		h->action(h);
+		h->action();
 		trace_softirq_exit(vec_nr);
 		if (unlikely(prev_count != preempt_count())) {
 			pr_err("huh, entered softirq %u %s %p with preempt_count %08x, exited with %08x?\n",
@@ -430,7 +430,7 @@ void __raise_softirq_irqoff(unsigned int nr)
 	or_softirq_pending(1UL << nr);
 }
 
-void open_softirq(int nr, void (*action)(struct softirq_action *))
+void __init open_softirq(int nr, void (*action)(void))
 {
 	softirq_vec[nr].action = action;
 }
@@ -482,7 +482,7 @@ void __tasklet_hi_schedule_first(struct tasklet_struct *t)
 }
 EXPORT_SYMBOL(__tasklet_hi_schedule_first);
 
-static void tasklet_action(struct softirq_action *a)
+static __latent_entropy void tasklet_action(void)
 {
 	struct tasklet_struct *list;
 
@@ -518,7 +518,7 @@ static void tasklet_action(struct softirq_action *a)
 	}
 }
 
-static void tasklet_hi_action(struct softirq_action *a)
+static __latent_entropy void tasklet_hi_action(void)
 {
 	struct tasklet_struct *list;
 
@@ -744,7 +744,7 @@ static struct notifier_block cpu_nfb = {
 	.notifier_call = cpu_callback
 };
 
-static struct smp_hotplug_thread softirq_threads = {
+static struct smp_hotplug_thread softirq_threads __read_only = {
 	.store			= &ksoftirqd,
 	.thread_should_run	= ksoftirqd_should_run,
 	.thread_fn		= run_ksoftirqd,
diff --git a/kernel/stop_machine.c b/kernel/stop_machine.c
index 4a1ca5f6d..98ccb5641 100644
--- a/kernel/stop_machine.c
+++ b/kernel/stop_machine.c
@@ -509,7 +509,7 @@ void stop_machine_unpark(int cpu)
 	kthread_unpark(stopper->thread);
 }
 
-static struct smp_hotplug_thread cpu_stop_threads = {
+static struct smp_hotplug_thread cpu_stop_threads __read_only = {
 	.store			= &cpu_stopper.thread,
 	.thread_should_run	= cpu_stop_should_run,
 	.thread_fn		= cpu_stopper_thread,
diff --git a/kernel/sys.c b/kernel/sys.c
index 89d5be418..441bef36e 100644
--- a/kernel/sys.c
+++ b/kernel/sys.c
@@ -160,6 +160,12 @@ static int set_one_prio(struct task_struct *p, int niceval, int error)
 		error = -EACCES;
 		goto out;
 	}
+
+	if (gr_handle_chroot_setpriority(p, niceval)) {
+		error = -EACCES;
+		goto out;
+	}
+
 	no_nice = security_task_setnice(p, niceval);
 	if (no_nice) {
 		error = no_nice;
@@ -366,6 +372,20 @@ SYSCALL_DEFINE2(setregid, gid_t, rgid, gid_t, egid)
 			goto error;
 	}
 
+	if (gr_check_group_change(new->gid, new->egid, INVALID_GID))
+		goto error;
+
+	if (!gid_eq(new->gid, old->gid)) {
+		/* make sure we generate a learn log for what will
+		   end up being a role transition after a full-learning
+		   policy is generated
+		   CAP_SETGID is required to perform a transition
+		   we may not log a CAP_SETGID check above, e.g.
+		   in the case where new rgid = old egid
+		*/
+		gr_learn_cap(current, new, CAP_SETGID, true);
+	}
+
 	if (rgid != (gid_t) -1 ||
 	    (egid != (gid_t) -1 && !gid_eq(kegid, old->gid)))
 		new->sgid = new->egid;
@@ -401,6 +421,10 @@ SYSCALL_DEFINE1(setgid, gid_t, gid)
 	old = current_cred();
 
 	retval = -EPERM;
+
+	if (gr_check_group_change(kgid, kgid, kgid))
+		goto error;
+
 	if (ns_capable(old->user_ns, CAP_SETGID))
 		new->gid = new->egid = new->sgid = new->fsgid = kgid;
 	else if (gid_eq(kgid, old->gid) || gid_eq(kgid, old->sgid))
@@ -418,7 +442,7 @@ error:
 /*
  * change the user struct in a credentials set to match the new UID
  */
-static int set_user(struct cred *new)
+int set_user(struct cred *new)
 {
 	struct user_struct *new_user;
 
@@ -498,7 +522,18 @@ SYSCALL_DEFINE2(setreuid, uid_t, ruid, uid_t, euid)
 			goto error;
 	}
 
+	if (gr_check_user_change(new->uid, new->euid, INVALID_UID))
+		goto error;
+
 	if (!uid_eq(new->uid, old->uid)) {
+		/* make sure we generate a learn log for what will
+		   end up being a role transition after a full-learning
+		   policy is generated
+		   CAP_SETUID is required to perform a transition
+		   we may not log a CAP_SETUID check above, e.g.
+		   in the case where new ruid = old euid
+		*/
+		gr_learn_cap(current, new, CAP_SETUID, true);
 		retval = set_user(new);
 		if (retval < 0)
 			goto error;
@@ -548,6 +583,12 @@ SYSCALL_DEFINE1(setuid, uid_t, uid)
 	old = current_cred();
 
 	retval = -EPERM;
+
+	if (gr_check_crash_uid(kuid))
+		goto error;
+	if (gr_check_user_change(kuid, kuid, kuid))
+		goto error;
+
 	if (ns_capable(old->user_ns, CAP_SETUID)) {
 		new->suid = new->uid = kuid;
 		if (!uid_eq(kuid, old->uid)) {
@@ -617,6 +658,9 @@ SYSCALL_DEFINE3(setresuid, uid_t, ruid, uid_t, euid, uid_t, suid)
 			goto error;
 	}
 
+	if (gr_check_user_change(kruid, keuid, INVALID_UID))
+		goto error;
+
 	if (ruid != (uid_t) -1) {
 		new->uid = kruid;
 		if (!uid_eq(kruid, old->uid)) {
@@ -701,6 +745,9 @@ SYSCALL_DEFINE3(setresgid, gid_t, rgid, gid_t, egid, gid_t, sgid)
 			goto error;
 	}
 
+	if (gr_check_group_change(krgid, kegid, INVALID_GID))
+		goto error;
+
 	if (rgid != (gid_t) -1)
 		new->gid = krgid;
 	if (egid != (gid_t) -1)
@@ -765,12 +812,16 @@ SYSCALL_DEFINE1(setfsuid, uid_t, uid)
 	    uid_eq(kuid, old->suid) || uid_eq(kuid, old->fsuid) ||
 	    ns_capable(old->user_ns, CAP_SETUID)) {
 		if (!uid_eq(kuid, old->fsuid)) {
+			if (gr_check_user_change(INVALID_UID, INVALID_UID, kuid))
+				goto error;
+
 			new->fsuid = kuid;
 			if (security_task_fix_setuid(new, old, LSM_SETID_FS) == 0)
 				goto change_okay;
 		}
 	}
 
+error:
 	abort_creds(new);
 	return old_fsuid;
 
@@ -803,12 +854,16 @@ SYSCALL_DEFINE1(setfsgid, gid_t, gid)
 	if (gid_eq(kgid, old->gid)  || gid_eq(kgid, old->egid)  ||
 	    gid_eq(kgid, old->sgid) || gid_eq(kgid, old->fsgid) ||
 	    ns_capable(old->user_ns, CAP_SETGID)) {
+		if (gr_check_group_change(INVALID_GID, INVALID_GID, kgid))
+			goto error;
+
 		if (!gid_eq(kgid, old->fsgid)) {
 			new->fsgid = kgid;
 			goto change_okay;
 		}
 	}
 
+error:
 	abort_creds(new);
 	return old_fsgid;
 
@@ -1187,19 +1242,19 @@ SYSCALL_DEFINE1(olduname, struct oldold_utsname __user *, name)
 		return -EFAULT;
 
 	down_read(&uts_sem);
-	error = __copy_to_user(&name->sysname, &utsname()->sysname,
+	error = __copy_to_user(name->sysname, &utsname()->sysname,
 			       __OLD_UTS_LEN);
 	error |= __put_user(0, name->sysname + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->nodename, &utsname()->nodename,
+	error |= __copy_to_user(name->nodename, &utsname()->nodename,
 				__OLD_UTS_LEN);
 	error |= __put_user(0, name->nodename + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->release, &utsname()->release,
+	error |= __copy_to_user(name->release, &utsname()->release,
 				__OLD_UTS_LEN);
 	error |= __put_user(0, name->release + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->version, &utsname()->version,
+	error |= __copy_to_user(name->version, &utsname()->version,
 				__OLD_UTS_LEN);
 	error |= __put_user(0, name->version + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->machine, &utsname()->machine,
+	error |= __copy_to_user(name->machine, &utsname()->machine,
 				__OLD_UTS_LEN);
 	error |= __put_user(0, name->machine + __OLD_UTS_LEN);
 	up_read(&uts_sem);
@@ -1400,6 +1455,13 @@ int do_prlimit(struct task_struct *tsk, unsigned int resource,
 			 */
 			new_rlim->rlim_cur = 1;
 		}
+		/* Handle the case where a fork and setuid occur and then RLIMIT_NPROC
+		   is changed to a lower value.  Since tasks can be created by the same
+		   user in between this limit change and an execve by this task, force
+		   a recheck only for this task by setting PF_NPROC_EXCEEDED
+		*/
+		if (resource == RLIMIT_NPROC && tsk->real_cred->user != INIT_USER)
+			tsk->flags |= PF_NPROC_EXCEEDED;
 	}
 	if (!retval) {
 		if (old_rlim)
diff --git a/kernel/sys_ni.c b/kernel/sys_ni.c
index 2c5e3a8e0..301fb1ac7 100644
--- a/kernel/sys_ni.c
+++ b/kernel/sys_ni.c
@@ -6,12 +6,12 @@
 
 /*  we can't #include <linux/syscalls.h> here,
     but tell gcc to not warn with -Wmissing-prototypes  */
-asmlinkage long sys_ni_syscall(void);
+asmlinkage long sys_ni_syscall(unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long);
 
 /*
  * Non-implemented system calls get redirected here.
  */
-asmlinkage long sys_ni_syscall(void)
+asmlinkage long sys_ni_syscall(unsigned long a, unsigned long b, unsigned long c, unsigned long d, unsigned long e, unsigned long f)
 {
 	return -ENOSYS;
 }
diff --git a/kernel/sysctl.c b/kernel/sysctl.c
index a13bbdaab..745603f49 100644
--- a/kernel/sysctl.c
+++ b/kernel/sysctl.c
@@ -95,7 +95,6 @@
 #endif
 
 #if defined(CONFIG_SYSCTL)
-
 /* External variables not in a header file. */
 extern int suid_dumpable;
 #ifdef CONFIG_COREDUMP
@@ -112,23 +111,25 @@ extern int sysctl_nr_open_min, sysctl_nr_open_max;
 #ifndef CONFIG_MMU
 extern int sysctl_nr_trim_pages;
 #endif
+extern int sysctl_modify_ldt;
 
 /* Constants used for minimum and  maximum */
 #ifdef CONFIG_LOCKUP_DETECTOR
-static int sixty = 60;
+static int sixty __read_only = 60;
 #endif
 
-static int __maybe_unused neg_one = -1;
+static int __maybe_unused neg_one __read_only = -1;
 
-static int zero;
-static int __maybe_unused one = 1;
-static int __maybe_unused two = 2;
-static int __maybe_unused four = 4;
-static unsigned long one_ul = 1;
-static int one_hundred = 100;
-static int one_thousand = 1000;
+static int zero __read_only = 0;
+static int __maybe_unused one __read_only = 1;
+static int __maybe_unused two __read_only = 2;
+static int __maybe_unused three __read_only = 3;
+static int __maybe_unused four __read_only = 4;
+static unsigned long one_ul __read_only = 1;
+static int one_hundred __read_only = 100;
+static int one_thousand __read_only = 1000;
 #ifdef CONFIG_PRINTK
-static int ten_thousand = 10000;
+static int ten_thousand __read_only = 10000;
 #endif
 #ifdef CONFIG_PERF_EVENTS
 static int six_hundred_forty_kb = 640 * 1024;
@@ -185,10 +186,8 @@ static int proc_taint(struct ctl_table *table, int write,
 			       void __user *buffer, size_t *lenp, loff_t *ppos);
 #endif
 
-#ifdef CONFIG_PRINTK
-static int proc_dointvec_minmax_sysadmin(struct ctl_table *table, int write,
+static int proc_dointvec_minmax_secure_sysadmin(struct ctl_table *table, int write,
 				void __user *buffer, size_t *lenp, loff_t *ppos);
-#endif
 
 static int proc_dointvec_minmax_coredump(struct ctl_table *table, int write,
 		void __user *buffer, size_t *lenp, loff_t *ppos);
@@ -219,6 +218,8 @@ static int sysrq_sysctl_handler(struct ctl_table *table, int write,
 
 #endif
 
+extern struct ctl_table grsecurity_table[];
+
 static struct ctl_table kern_table[];
 static struct ctl_table vm_table[];
 static struct ctl_table fs_table[];
@@ -233,6 +234,20 @@ extern struct ctl_table epoll_table[];
 int sysctl_legacy_va_layout;
 #endif
 
+#ifdef CONFIG_PAX_SOFTMODE
+static struct ctl_table pax_table[] = {
+	{
+		.procname	= "softmode",
+		.data		= &pax_softmode,
+		.maxlen		= sizeof(unsigned int),
+		.mode		= 0600,
+		.proc_handler	= &proc_dointvec,
+	},
+
+	{ }
+};
+#endif
+
 /* The default sysctl tables: */
 
 static struct ctl_table sysctl_base_table[] = {
@@ -281,6 +296,22 @@ static int max_extfrag_threshold = 1000;
 #endif
 
 static struct ctl_table kern_table[] = {
+#if defined(CONFIG_GRKERNSEC_SYSCTL) || defined(CONFIG_GRKERNSEC_ROFS)
+	{
+		.procname	= "grsecurity",
+		.mode		= 0500,
+		.child		= grsecurity_table,
+	},
+#endif
+
+#ifdef CONFIG_PAX_SOFTMODE
+	{
+		.procname	= "pax",
+		.mode		= 0500,
+		.child		= pax_table,
+	},
+#endif
+
 	{
 		.procname	= "sched_child_runs_first",
 		.data		= &sysctl_sched_child_runs_first,
@@ -644,7 +675,7 @@ static struct ctl_table kern_table[] = {
 		.maxlen		= sizeof(int),
 		.mode		= 0644,
 		/* only handle a transition from default "0" to "1" */
-		.proc_handler	= proc_dointvec_minmax,
+		.proc_handler	= proc_dointvec_minmax_secure,
 		.extra1		= &one,
 		.extra2		= &one,
 	},
@@ -655,7 +686,7 @@ static struct ctl_table kern_table[] = {
 		.data		= &modprobe_path,
 		.maxlen		= KMOD_PATH_LEN,
 		.mode		= 0644,
-		.proc_handler	= proc_dostring,
+		.proc_handler	= proc_dostring_modpriv,
 	},
 	{
 		.procname	= "modules_disabled",
@@ -663,7 +694,7 @@ static struct ctl_table kern_table[] = {
 		.maxlen		= sizeof(int),
 		.mode		= 0644,
 		/* only handle a transition from default "0" to "1" */
-		.proc_handler	= proc_dointvec_minmax,
+		.proc_handler	= proc_dointvec_minmax_secure,
 		.extra1		= &one,
 		.extra2		= &one,
 	},
@@ -825,20 +856,24 @@ static struct ctl_table kern_table[] = {
 		.data		= &dmesg_restrict,
 		.maxlen		= sizeof(int),
 		.mode		= 0644,
-		.proc_handler	= proc_dointvec_minmax_sysadmin,
+		.proc_handler	= proc_dointvec_minmax_secure_sysadmin,
 		.extra1		= &zero,
 		.extra2		= &one,
 	},
+#endif
 	{
 		.procname	= "kptr_restrict",
 		.data		= &kptr_restrict,
 		.maxlen		= sizeof(int),
 		.mode		= 0644,
-		.proc_handler	= proc_dointvec_minmax_sysadmin,
+		.proc_handler	= proc_dointvec_minmax_secure_sysadmin,
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+		.extra1		= &one,
+#else
 		.extra1		= &zero,
+#endif
 		.extra2		= &two,
 	},
-#endif
 	{
 		.procname	= "ngroups_max",
 		.data		= &ngroups_max,
@@ -1003,6 +1038,17 @@ static struct ctl_table kern_table[] = {
 		.mode		= 0644,
 		.proc_handler	= proc_dointvec,
 	},
+#ifdef CONFIG_MODIFY_LDT_SYSCALL
+	{
+		.procname	= "modify_ldt",
+		.data		= &sysctl_modify_ldt,
+		.maxlen		= sizeof(int),
+		.mode		= 0644,
+		.proc_handler	= proc_dointvec_minmax_secure_sysadmin,
+		.extra1		= &zero,
+		.extra2		= &one,
+	},
+#endif
 #endif
 #if defined(CONFIG_MMU)
 	{
@@ -1125,10 +1171,17 @@ static struct ctl_table kern_table[] = {
 	 */
 	{
 		.procname	= "perf_event_paranoid",
-		.data		= &sysctl_perf_event_paranoid,
-		.maxlen		= sizeof(sysctl_perf_event_paranoid),
+		.data		= &sysctl_perf_event_legitimately_concerned,
+		.maxlen		= sizeof(sysctl_perf_event_legitimately_concerned),
 		.mode		= 0644,
-		.proc_handler	= proc_dointvec,
+		/* go ahead, be a hero */
+		.proc_handler	= proc_dointvec_minmax_secure_sysadmin,
+		.extra1		= &neg_one,
+#ifdef CONFIG_GRKERNSEC_PERF_HARDEN
+		.extra2		= &three,
+#else
+		.extra2		= &two,
+#endif
 	},
 	{
 		.procname	= "perf_event_mlock_kb",
@@ -1469,6 +1522,13 @@ static struct ctl_table vm_table[] = {
 		.proc_handler	= proc_dointvec_minmax,
 		.extra1		= &zero,
 	},
+	{
+		.procname	= "heap_stack_gap",
+		.data		= &sysctl_heap_stack_gap,
+		.maxlen		= sizeof(sysctl_heap_stack_gap),
+		.mode		= 0644,
+		.proc_handler	= proc_doulongvec_minmax,
+	},
 #else
 	{
 		.procname	= "nr_trim_pages",
@@ -1988,6 +2048,16 @@ int proc_dostring(struct ctl_table *table, int write,
 			       (char __user *)buffer, lenp, ppos);
 }
 
+int proc_dostring_modpriv(struct ctl_table *table, int write,
+		  void __user *buffer, size_t *lenp, loff_t *ppos)
+{
+	if (write && !capable(CAP_SYS_MODULE))
+		return -EPERM;
+
+	return _proc_do_string(table->data, table->maxlen, write,
+			       buffer, lenp, ppos);
+}
+
 static size_t proc_skip_spaces(char **buf)
 {
 	size_t ret;
@@ -2093,6 +2163,8 @@ static int proc_put_long(void __user **buf, size_t *size, unsigned long val,
 	len = strlen(tmp);
 	if (len > *size)
 		len = *size;
+	if (len > sizeof(tmp))
+		len = sizeof(tmp);
 	if (copy_to_user(*buf, tmp, len))
 		return -EFAULT;
 	*size -= len;
@@ -2297,6 +2369,44 @@ int proc_douintvec(struct ctl_table *table, int write,
 				do_proc_douintvec_conv, NULL);
 }
 
+static int do_proc_dointvec_conv_secure(bool *negp, unsigned long *lvalp,
+				 int *valp,
+				 int write, void *data)
+{
+	if (write) {
+		if (*negp) {
+			if (*lvalp > (unsigned long) INT_MAX + 1)
+				return -EINVAL;
+			pax_open_kernel();
+			*valp = -*lvalp;
+			pax_close_kernel();
+		} else {
+			if (*lvalp > (unsigned long) INT_MAX)
+				return -EINVAL;
+			pax_open_kernel();
+			*valp = *lvalp;
+			pax_close_kernel();
+		}
+	} else {
+		int val = *valp;
+		if (val < 0) {
+			*negp = true;
+			*lvalp = -(unsigned long)val;
+		} else {
+			*negp = false;
+			*lvalp = (unsigned long)val;
+		}
+	}
+	return 0;
+}
+
+int proc_dointvec_secure(struct ctl_table *table, int write,
+		     void __user *buffer, size_t *lenp, loff_t *ppos)
+{
+    return do_proc_dointvec(table,write,buffer,lenp,ppos,
+		    	    do_proc_dointvec_conv_secure,NULL);
+}
+
 /*
  * Taint values can only be increased
  * This means we can safely use a temporary.
@@ -2304,7 +2414,7 @@ int proc_douintvec(struct ctl_table *table, int write,
 static int proc_taint(struct ctl_table *table, int write,
 			       void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table t;
+	ctl_table_no_const t;
 	unsigned long tmptaint = get_taint();
 	int err;
 
@@ -2332,16 +2442,14 @@ static int proc_taint(struct ctl_table *table, int write,
 	return err;
 }
 
-#ifdef CONFIG_PRINTK
-static int proc_dointvec_minmax_sysadmin(struct ctl_table *table, int write,
+static int proc_dointvec_minmax_secure_sysadmin(struct ctl_table *table, int write,
 				void __user *buffer, size_t *lenp, loff_t *ppos)
 {
 	if (write && !capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
-	return proc_dointvec_minmax(table, write, buffer, lenp, ppos);
+	return proc_dointvec_minmax_secure(table, write, buffer, lenp, ppos);
 }
-#endif
 
 struct do_proc_dointvec_minmax_conv_param {
 	int *min;
@@ -2372,6 +2480,32 @@ static int do_proc_dointvec_minmax_conv(bool *negp, unsigned long *lvalp,
 	return 0;
 }
 
+static int do_proc_dointvec_minmax_conv_secure(bool *negp, unsigned long *lvalp,
+					int *valp,
+					int write, void *data)
+{
+	struct do_proc_dointvec_minmax_conv_param *param = data;
+	if (write) {
+		int val = *negp ? -*lvalp : *lvalp;
+		if ((param->min && *param->min > val) ||
+		    (param->max && *param->max < val))
+			return -EINVAL;
+		pax_open_kernel();
+		*valp = val;
+		pax_close_kernel();
+	} else {
+		int val = *valp;
+		if (val < 0) {
+			*negp = true;
+			*lvalp = -(unsigned long)val;
+		} else {
+			*negp = false;
+			*lvalp = (unsigned long)val;
+		}
+	}
+	return 0;
+}
+
 /**
  * proc_dointvec_minmax - read a vector of integers with min/max values
  * @table: the sysctl table
@@ -2399,6 +2533,17 @@ int proc_dointvec_minmax(struct ctl_table *table, int write,
 				do_proc_dointvec_minmax_conv, &param);
 }
 
+int proc_dointvec_minmax_secure(struct ctl_table *table, int write,
+		  void __user *buffer, size_t *lenp, loff_t *ppos)
+{
+	struct do_proc_dointvec_minmax_conv_param param = {
+		.min = (int *) table->extra1,
+		.max = (int *) table->extra2,
+	};
+	return do_proc_dointvec(table, write, buffer, lenp, ppos,
+				do_proc_dointvec_minmax_conv_secure, &param);
+}
+
 static void validate_coredump_safety(void)
 {
 #ifdef CONFIG_COREDUMP
@@ -2886,6 +3031,12 @@ int proc_dostring(struct ctl_table *table, int write,
 	return -ENOSYS;
 }
 
+int proc_dostring_modpriv(struct ctl_table *table, int write,
+		  void __user *buffer, size_t *lenp, loff_t *ppos)
+{
+	return -ENOSYS;
+}
+
 int proc_dointvec(struct ctl_table *table, int write,
 		  void __user *buffer, size_t *lenp, loff_t *ppos)
 {
@@ -2949,5 +3100,6 @@ EXPORT_SYMBOL(proc_dointvec_minmax);
 EXPORT_SYMBOL(proc_dointvec_userhz_jiffies);
 EXPORT_SYMBOL(proc_dointvec_ms_jiffies);
 EXPORT_SYMBOL(proc_dostring);
+EXPORT_SYMBOL(proc_dostring_modpriv);
 EXPORT_SYMBOL(proc_doulongvec_minmax);
 EXPORT_SYMBOL(proc_doulongvec_ms_jiffies_minmax);
diff --git a/kernel/taskstats.c b/kernel/taskstats.c
index b3f05ee20..b1b504491 100644
--- a/kernel/taskstats.c
+++ b/kernel/taskstats.c
@@ -28,9 +28,12 @@
 #include <linux/fs.h>
 #include <linux/file.h>
 #include <linux/pid_namespace.h>
+#include <linux/grsecurity.h>
 #include <net/genetlink.h>
 #include <linux/atomic.h>
 
+extern int gr_is_taskstats_denied(int pid);
+
 /*
  * Maximum length of a cpumask that can be specified in
  * the TASKSTATS_CMD_ATTR_REGISTER/DEREGISTER_CPUMASK attribute
@@ -540,6 +543,9 @@ err:
 
 static int taskstats_user_cmd(struct sk_buff *skb, struct genl_info *info)
 {
+	if (gr_is_taskstats_denied(current->pid))
+		return -EACCES;
+
 	if (info->attrs[TASKSTATS_CMD_ATTR_REGISTER_CPUMASK])
 		return cmd_attr_register_cpumask(info);
 	else if (info->attrs[TASKSTATS_CMD_ATTR_DEREGISTER_CPUMASK])
diff --git a/kernel/time/alarmtimer.c b/kernel/time/alarmtimer.c
index c3aad685b..c4b87f31f 100644
--- a/kernel/time/alarmtimer.c
+++ b/kernel/time/alarmtimer.c
@@ -522,7 +522,7 @@ static int alarm_clock_getres(const clockid_t which_clock, struct timespec *tp)
  *
  * Provides the underlying alarm base time.
  */
-static int alarm_clock_get(clockid_t which_clock, struct timespec *tp)
+static int alarm_clock_get(const clockid_t which_clock, struct timespec *tp)
 {
 	struct alarm_base *base = &alarm_bases[clock2alarm(which_clock)];
 
@@ -836,7 +836,7 @@ static int __init alarmtimer_init(void)
 	struct platform_device *pdev;
 	int error = 0;
 	int i;
-	struct k_clock alarm_clock = {
+	static struct k_clock alarm_clock = {
 		.clock_getres	= alarm_clock_getres,
 		.clock_get	= alarm_clock_get,
 		.timer_create	= alarm_timer_create,
diff --git a/kernel/time/posix-clock.c b/kernel/time/posix-clock.c
index 9cff0ab82..0e69c943c 100644
--- a/kernel/time/posix-clock.c
+++ b/kernel/time/posix-clock.c
@@ -273,7 +273,7 @@ static void put_clock_desc(struct posix_clock_desc *cd)
 	fput(cd->fp);
 }
 
-static int pc_clock_adjtime(clockid_t id, struct timex *tx)
+static int pc_clock_adjtime(const clockid_t id, struct timex *tx)
 {
 	struct posix_clock_desc cd;
 	int err;
@@ -297,7 +297,7 @@ out:
 	return err;
 }
 
-static int pc_clock_gettime(clockid_t id, struct timespec *ts)
+static int pc_clock_gettime(const clockid_t id, struct timespec *ts)
 {
 	struct posix_clock_desc cd;
 	int err;
@@ -316,7 +316,7 @@ static int pc_clock_gettime(clockid_t id, struct timespec *ts)
 	return err;
 }
 
-static int pc_clock_getres(clockid_t id, struct timespec *ts)
+static int pc_clock_getres(const clockid_t id, struct timespec *ts)
 {
 	struct posix_clock_desc cd;
 	int err;
@@ -335,7 +335,7 @@ static int pc_clock_getres(clockid_t id, struct timespec *ts)
 	return err;
 }
 
-static int pc_clock_settime(clockid_t id, const struct timespec *ts)
+static int pc_clock_settime(const clockid_t id, const struct timespec *ts)
 {
 	struct posix_clock_desc cd;
 	int err;
diff --git a/kernel/time/posix-cpu-timers.c b/kernel/time/posix-cpu-timers.c
index 39008d789..0a6046840 100644
--- a/kernel/time/posix-cpu-timers.c
+++ b/kernel/time/posix-cpu-timers.c
@@ -1468,14 +1468,14 @@ struct k_clock clock_posix_cpu = {
 
 static __init int init_posix_cpu_timers(void)
 {
-	struct k_clock process = {
+	static struct k_clock process = {
 		.clock_getres	= process_cpu_clock_getres,
 		.clock_get	= process_cpu_clock_get,
 		.timer_create	= process_cpu_timer_create,
 		.nsleep		= process_cpu_nsleep,
 		.nsleep_restart	= process_cpu_nsleep_restart,
 	};
-	struct k_clock thread = {
+	static struct k_clock thread = {
 		.clock_getres	= thread_cpu_clock_getres,
 		.clock_get	= thread_cpu_clock_get,
 		.timer_create	= thread_cpu_timer_create,
diff --git a/kernel/time/posix-timers.c b/kernel/time/posix-timers.c
index f2826c35e..7e6663aea 100644
--- a/kernel/time/posix-timers.c
+++ b/kernel/time/posix-timers.c
@@ -43,6 +43,7 @@
 #include <linux/hash.h>
 #include <linux/posix-clock.h>
 #include <linux/posix-timers.h>
+#include <linux/grsecurity.h>
 #include <linux/syscalls.h>
 #include <linux/wait.h>
 #include <linux/workqueue.h>
@@ -124,7 +125,7 @@ static DEFINE_SPINLOCK(hash_lock);
  *	    which we beg off on and pass to do_sys_settimeofday().
  */
 
-static struct k_clock posix_clocks[MAX_CLOCKS];
+static struct k_clock *posix_clocks[MAX_CLOCKS];
 
 /*
  * These ones are defined below.
@@ -203,7 +204,7 @@ static inline void unlock_timer(struct k_itimer *timr, unsigned long flags)
 }
 
 /* Get clock_realtime */
-static int posix_clock_realtime_get(clockid_t which_clock, struct timespec *tp)
+static int posix_clock_realtime_get(const clockid_t which_clock, struct timespec *tp)
 {
 	ktime_get_real_ts(tp);
 	return 0;
@@ -225,7 +226,7 @@ static int posix_clock_realtime_adj(const clockid_t which_clock,
 /*
  * Get monotonic time for posix timers
  */
-static int posix_ktime_get_ts(clockid_t which_clock, struct timespec *tp)
+static int posix_ktime_get_ts(const clockid_t which_clock, struct timespec *tp)
 {
 	ktime_get_ts(tp);
 	return 0;
@@ -234,20 +235,20 @@ static int posix_ktime_get_ts(clockid_t which_clock, struct timespec *tp)
 /*
  * Get monotonic-raw time for posix timers
  */
-static int posix_get_monotonic_raw(clockid_t which_clock, struct timespec *tp)
+static int posix_get_monotonic_raw(const clockid_t which_clock, struct timespec *tp)
 {
 	getrawmonotonic(tp);
 	return 0;
 }
 
 
-static int posix_get_realtime_coarse(clockid_t which_clock, struct timespec *tp)
+static int posix_get_realtime_coarse(const clockid_t which_clock, struct timespec *tp)
 {
 	*tp = current_kernel_time();
 	return 0;
 }
 
-static int posix_get_monotonic_coarse(clockid_t which_clock,
+static int posix_get_monotonic_coarse(const clockid_t which_clock,
 						struct timespec *tp)
 {
 	*tp = get_monotonic_coarse();
@@ -266,7 +267,7 @@ static int posix_get_boottime(const clockid_t which_clock, struct timespec *tp)
 	return 0;
 }
 
-static int posix_get_tai(clockid_t which_clock, struct timespec *tp)
+static int posix_get_tai(const clockid_t which_clock, struct timespec *tp)
 {
 	timekeeping_clocktai(tp);
 	return 0;
@@ -284,7 +285,7 @@ static int posix_get_hrtimer_res(clockid_t which_clock, struct timespec *tp)
  */
 static __init int init_posix_timers(void)
 {
-	struct k_clock clock_realtime = {
+	static struct k_clock clock_realtime = {
 		.clock_getres	= posix_get_hrtimer_res,
 		.clock_get	= posix_clock_realtime_get,
 		.clock_set	= posix_clock_realtime_set,
@@ -296,7 +297,7 @@ static __init int init_posix_timers(void)
 		.timer_get	= common_timer_get,
 		.timer_del	= common_timer_del,
 	};
-	struct k_clock clock_monotonic = {
+	static struct k_clock clock_monotonic = {
 		.clock_getres	= posix_get_hrtimer_res,
 		.clock_get	= posix_ktime_get_ts,
 		.nsleep		= common_nsleep,
@@ -306,19 +307,19 @@ static __init int init_posix_timers(void)
 		.timer_get	= common_timer_get,
 		.timer_del	= common_timer_del,
 	};
-	struct k_clock clock_monotonic_raw = {
+	static struct k_clock clock_monotonic_raw = {
 		.clock_getres	= posix_get_hrtimer_res,
 		.clock_get	= posix_get_monotonic_raw,
 	};
-	struct k_clock clock_realtime_coarse = {
+	static struct k_clock clock_realtime_coarse = {
 		.clock_getres	= posix_get_coarse_res,
 		.clock_get	= posix_get_realtime_coarse,
 	};
-	struct k_clock clock_monotonic_coarse = {
+	static struct k_clock clock_monotonic_coarse = {
 		.clock_getres	= posix_get_coarse_res,
 		.clock_get	= posix_get_monotonic_coarse,
 	};
-	struct k_clock clock_tai = {
+	static struct k_clock clock_tai = {
 		.clock_getres	= posix_get_hrtimer_res,
 		.clock_get	= posix_get_tai,
 		.nsleep		= common_nsleep,
@@ -328,7 +329,7 @@ static __init int init_posix_timers(void)
 		.timer_get	= common_timer_get,
 		.timer_del	= common_timer_del,
 	};
-	struct k_clock clock_boottime = {
+	static struct k_clock clock_boottime = {
 		.clock_getres	= posix_get_hrtimer_res,
 		.clock_get	= posix_get_boottime,
 		.nsleep		= common_nsleep,
@@ -540,7 +541,7 @@ void posix_timers_register_clock(const clockid_t clock_id,
 		return;
 	}
 
-	posix_clocks[clock_id] = *new_clock;
+	posix_clocks[clock_id] = new_clock;
 }
 EXPORT_SYMBOL_GPL(posix_timers_register_clock);
 
@@ -586,9 +587,9 @@ static struct k_clock *clockid_to_kclock(const clockid_t id)
 		return (id & CLOCKFD_MASK) == CLOCKFD ?
 			&clock_posix_dynamic : &clock_posix_cpu;
 
-	if (id >= MAX_CLOCKS || !posix_clocks[id].clock_getres)
+	if (id >= MAX_CLOCKS || !posix_clocks[id] || !posix_clocks[id]->clock_getres)
 		return NULL;
-	return &posix_clocks[id];
+	return posix_clocks[id];
 }
 
 static int common_timer_create(struct k_itimer *new_timer)
@@ -606,7 +607,7 @@ SYSCALL_DEFINE3(timer_create, const clockid_t, which_clock,
 	struct k_clock *kc = clockid_to_kclock(which_clock);
 	struct k_itimer *new_timer;
 	int error, new_timer_id;
-	sigevent_t event;
+	sigevent_t event = { };
 	int it_id_set = IT_ID_NOT_SET;
 
 	if (!kc)
@@ -1021,6 +1022,13 @@ SYSCALL_DEFINE2(clock_settime, const clockid_t, which_clock,
 	if (copy_from_user(&new_tp, tp, sizeof (*tp)))
 		return -EFAULT;
 
+	/* only the CLOCK_REALTIME clock can be set, all other clocks
+	   have their clock_set fptr set to a nosettime dummy function
+	   CLOCK_REALTIME has a NULL clock_set fptr which causes it to
+	   call common_clock_set, which calls do_sys_settimeofday, which
+	   we hook
+	*/
+
 	return kc->clock_set(which_clock, &new_tp);
 }
 
diff --git a/kernel/time/time.c b/kernel/time/time.c
index 667b9335f..166895217 100644
--- a/kernel/time/time.c
+++ b/kernel/time/time.c
@@ -177,6 +177,11 @@ int do_sys_settimeofday64(const struct timespec64 *tv, const struct timezone *tz
 		if (tz->tz_minuteswest > 15*60 || tz->tz_minuteswest < -15*60)
 			return -EINVAL;
 
+		/* we log in do_settimeofday called below, so don't log twice
+		*/
+		if (!tv)
+			gr_log_timechange();
+
 		sys_tz = *tz;
 		update_vsyscall_tz();
 		if (firsttime) {
diff --git a/kernel/time/timekeeping.c b/kernel/time/timekeeping.c
index 46e312e9b..c96310f40 100644
--- a/kernel/time/timekeeping.c
+++ b/kernel/time/timekeeping.c
@@ -15,6 +15,7 @@
 #include <linux/init.h>
 #include <linux/mm.h>
 #include <linux/sched.h>
+#include <linux/grsecurity.h>
 #include <linux/syscore_ops.h>
 #include <linux/clocksource.h>
 #include <linux/jiffies.h>
@@ -1172,6 +1173,8 @@ int do_settimeofday64(const struct timespec64 *ts)
 	if (!timespec64_valid_strict(ts))
 		return -EINVAL;
 
+	gr_log_timechange();
+
 	raw_spin_lock_irqsave(&timekeeper_lock, flags);
 	write_seqcount_begin(&tk_core.seq);
 
diff --git a/kernel/time/timer.c b/kernel/time/timer.c
index 96db64bde..9133bad40 100644
--- a/kernel/time/timer.c
+++ b/kernel/time/timer.c
@@ -1647,7 +1647,7 @@ static inline void __run_timers(struct timer_base *base)
 /*
  * This function runs timers and the timer-tq in bottom half context.
  */
-static void run_timer_softirq(struct softirq_action *h)
+static __latent_entropy void run_timer_softirq(void)
 {
 	struct timer_base *base = this_cpu_ptr(&timer_bases[BASE_STD]);
 
diff --git a/kernel/time/timer_list.c b/kernel/time/timer_list.c
index ba7d8b288..aa301b0ec 100644
--- a/kernel/time/timer_list.c
+++ b/kernel/time/timer_list.c
@@ -50,12 +50,16 @@ static void SEQ_printf(struct seq_file *m, const char *fmt, ...)
 
 static void print_name_offset(struct seq_file *m, void *sym)
 {
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	SEQ_printf(m, "<%p>", NULL);
+#else
 	char symname[KSYM_NAME_LEN];
 
 	if (lookup_symbol_name((unsigned long)sym, symname) < 0)
 		SEQ_printf(m, "<%pK>", sym);
 	else
 		SEQ_printf(m, "%s", symname);
+#endif
 }
 
 static void
@@ -124,11 +128,14 @@ next_one:
 static void
 print_base(struct seq_file *m, struct hrtimer_clock_base *base, u64 now)
 {
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	SEQ_printf(m, "  .base:       %p\n", NULL);
+#else
 	SEQ_printf(m, "  .base:       %pK\n", base);
+#endif
 	SEQ_printf(m, "  .index:      %d\n", base->index);
 
 	SEQ_printf(m, "  .resolution: %u nsecs\n", (unsigned) hrtimer_resolution);
-
 	SEQ_printf(m,   "  .get_time:   ");
 	print_name_offset(m, base->get_time);
 	SEQ_printf(m,   "\n");
@@ -393,7 +400,11 @@ static int __init init_timer_list_procfs(void)
 {
 	struct proc_dir_entry *pe;
 
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+	pe = proc_create("timer_list", 0400, NULL, &timer_list_fops);
+#else
 	pe = proc_create("timer_list", 0444, NULL, &timer_list_fops);
+#endif
 	if (!pe)
 		return -ENOMEM;
 	return 0;
diff --git a/kernel/time/timer_stats.c b/kernel/time/timer_stats.c
index 087204c73..671b58227 100644
--- a/kernel/time/timer_stats.c
+++ b/kernel/time/timer_stats.c
@@ -116,7 +116,7 @@ static ktime_t time_start, time_stop;
 static unsigned long nr_entries;
 static struct entry entries[MAX_ENTRIES];
 
-static atomic_t overflow_count;
+static atomic_unchecked_t overflow_count;
 
 /*
  * The entries are in a hash-table, for fast lookup:
@@ -140,7 +140,7 @@ static void reset_entries(void)
 	nr_entries = 0;
 	memset(entries, 0, sizeof(entries));
 	memset(tstat_hash_table, 0, sizeof(tstat_hash_table));
-	atomic_set(&overflow_count, 0);
+	atomic_set_unchecked(&overflow_count, 0);
 }
 
 static struct entry *alloc_entry(void)
@@ -261,7 +261,7 @@ void timer_stats_update_stats(void *timer, pid_t pid, void *startf,
 	if (likely(entry))
 		entry->count++;
 	else
-		atomic_inc(&overflow_count);
+		atomic_inc_unchecked(&overflow_count);
 
  out_unlock:
 	raw_spin_unlock_irqrestore(lock, flags);
@@ -269,12 +269,16 @@ void timer_stats_update_stats(void *timer, pid_t pid, void *startf,
 
 static void print_name_offset(struct seq_file *m, unsigned long addr)
 {
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	seq_printf(m, "<%p>", NULL);
+#else
 	char symname[KSYM_NAME_LEN];
 
 	if (lookup_symbol_name(addr, symname) < 0)
-		seq_printf(m, "<%p>", (void *)addr);
+		seq_printf(m, "<%pK>", (void *)addr);
 	else
 		seq_printf(m, "%s", symname);
+#endif
 }
 
 static int tstats_show(struct seq_file *m, void *v)
@@ -300,8 +304,8 @@ static int tstats_show(struct seq_file *m, void *v)
 
 	seq_puts(m, "Timer Stats Version: v0.3\n");
 	seq_printf(m, "Sample period: %ld.%03ld s\n", (long)period.tv_sec, ms);
-	if (atomic_read(&overflow_count))
-		seq_printf(m, "Overflow: %d entries\n", atomic_read(&overflow_count));
+	if (atomic_read_unchecked(&overflow_count))
+		seq_printf(m, "Overflow: %d entries\n", atomic_read_unchecked(&overflow_count));
 	seq_printf(m, "Collection: %s\n", timer_stats_active ? "active" : "inactive");
 
 	for (i = 0; i < nr_entries; i++) {
@@ -417,7 +421,11 @@ static int __init init_tstats_procfs(void)
 {
 	struct proc_dir_entry *pe;
 
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+	pe = proc_create("timer_stats", 0600, NULL, &tstats_fops);
+#else
 	pe = proc_create("timer_stats", 0644, NULL, &tstats_fops);
+#endif
 	if (!pe)
 		return -ENOMEM;
 	return 0;
diff --git a/kernel/trace/Kconfig b/kernel/trace/Kconfig
index f4b86e8ca..18903a2a3 100644
--- a/kernel/trace/Kconfig
+++ b/kernel/trace/Kconfig
@@ -107,6 +107,7 @@ config TRACING
 config GENERIC_TRACER
 	bool
 	select TRACING
+	depends on !GRKERNSEC_KMEM
 
 #
 # Minimum requirements an architecture has to meet for us to
@@ -120,6 +121,7 @@ config TRACING_SUPPORT
 	# irqflags tracing for your architecture.
 	depends on TRACE_IRQFLAGS_SUPPORT || PPC32
 	depends on STACKTRACE_SUPPORT
+	depends on !GRKERNSEC_KMEM
 	default y
 
 if TRACING_SUPPORT
@@ -225,6 +227,7 @@ config ENABLE_DEFAULT_TRACERS
 	bool "Trace process context switches and events"
 	depends on !GENERIC_TRACER
 	select TRACING
+	depends on !GRKERNSEC_KMEM
 	help
 	  This tracer hooks to various trace points in the kernel,
 	  allowing the user to pick and choose which trace point they
@@ -378,6 +381,7 @@ config BLK_DEV_IO_TRACE
 	depends on BLOCK
 	select RELAY
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	select TRACEPOINTS
 	select GENERIC_TRACER
 	select STACKTRACE
@@ -402,6 +406,7 @@ config KPROBE_EVENT
 	depends on HAVE_REGS_AND_STACK_ACCESS_API
 	bool "Enable kprobes-based dynamic events"
 	select TRACING
+	depends on !GRKERNSEC_KMEM
 	select PROBE_EVENTS
 	default y
 	help
@@ -423,6 +428,7 @@ config UPROBE_EVENT
 	select UPROBES
 	select PROBE_EVENTS
 	select TRACING
+	depends on !GRKERNSEC_KMEM
 	default n
 	help
 	  This allows the user to add tracing events on top of userspace
diff --git a/kernel/trace/blktrace.c b/kernel/trace/blktrace.c
index dbafc5df0..819bd5d72 100644
--- a/kernel/trace/blktrace.c
+++ b/kernel/trace/blktrace.c
@@ -334,7 +334,7 @@ static ssize_t blk_dropped_read(struct file *filp, char __user *buffer,
 	struct blk_trace *bt = filp->private_data;
 	char buf[16];
 
-	snprintf(buf, sizeof(buf), "%u\n", atomic_read(&bt->dropped));
+	snprintf(buf, sizeof(buf), "%u\n", atomic_read_unchecked(&bt->dropped));
 
 	return simple_read_from_buffer(buffer, count, ppos, buf, strlen(buf));
 }
@@ -386,7 +386,7 @@ static int blk_subbuf_start_callback(struct rchan_buf *buf, void *subbuf,
 		return 1;
 
 	bt = buf->chan->private_data;
-	atomic_inc(&bt->dropped);
+	atomic_inc_unchecked(&bt->dropped);
 	return 0;
 }
 
@@ -485,7 +485,7 @@ int do_blk_trace_setup(struct request_queue *q, char *name, dev_t dev,
 
 	bt->dir = dir;
 	bt->dev = dev;
-	atomic_set(&bt->dropped, 0);
+	atomic_set_unchecked(&bt->dropped, 0);
 	INIT_LIST_HEAD(&bt->running_list);
 
 	ret = -EIO;
diff --git a/kernel/trace/ftrace.c b/kernel/trace/ftrace.c
index b1d7f1b5e..22e2e5bb8 100644
--- a/kernel/trace/ftrace.c
+++ b/kernel/trace/ftrace.c
@@ -120,8 +120,9 @@ static void ftrace_ops_list_func(unsigned long ip, unsigned long parent_ip,
 				 struct ftrace_ops *op, struct pt_regs *regs);
 #else
 /* See comment below, where ftrace_ops_list_func is defined */
-static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip);
-#define ftrace_ops_list_func ((ftrace_func_t)ftrace_ops_no_ops)
+static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip,
+				 struct ftrace_ops *op, struct pt_regs *regs);
+#define ftrace_ops_list_func (ftrace_ops_no_ops)
 #endif
 
 /*
@@ -2492,13 +2493,18 @@ ftrace_code_disable(struct module *mod, struct dyn_ftrace *rec)
 	if (unlikely(ftrace_disabled))
 		return 0;
 
+	ret = ftrace_arch_code_modify_prepare();
+	FTRACE_WARN_ON(ret);
+	if (ret)
+		return 0;
+
 	ret = ftrace_make_nop(mod, rec, MCOUNT_ADDR);
+	FTRACE_WARN_ON(ftrace_arch_code_modify_post_process());
 	if (ret) {
 		ftrace_bug_type = FTRACE_BUG_INIT;
 		ftrace_bug(ret, rec);
-		return 0;
 	}
-	return 1;
+	return ret ? 0 : 1;
 }
 
 /*
@@ -4872,8 +4878,10 @@ static int ftrace_process_locs(struct module *mod,
 	if (!count)
 		return 0;
 
+	pax_open_kernel();
 	sort(start, count, sizeof(*start),
 	     ftrace_cmp_ips, NULL);
+	pax_close_kernel();
 
 	start_pg = ftrace_allocate_pages(count);
 	if (!start_pg)
@@ -5289,7 +5297,8 @@ static void ftrace_ops_list_func(unsigned long ip, unsigned long parent_ip,
 	__ftrace_ops_list_func(ip, parent_ip, NULL, regs);
 }
 #else
-static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip)
+static void ftrace_ops_no_ops(unsigned long ip, unsigned long parent_ip,
+				 struct ftrace_ops *op, struct pt_regs *regs)
 {
 	__ftrace_ops_list_func(ip, parent_ip, NULL, NULL);
 }
@@ -5712,8 +5721,12 @@ int ftrace_graph_entry_stub(struct ftrace_graph_ent *trace)
 }
 
 /* The callbacks that hook a function */
-trace_func_graph_ret_t ftrace_graph_return =
-			(trace_func_graph_ret_t)ftrace_stub;
+static void ftrace_graph_return_stub(struct ftrace_graph_ret *trace)
+{
+	ftrace_stub(0, 0, NULL, NULL);
+}
+
+trace_func_graph_ret_t ftrace_graph_return = ftrace_graph_return_stub;
 trace_func_graph_ent_t ftrace_graph_entry = ftrace_graph_entry_stub;
 static trace_func_graph_ent_t __ftrace_graph_entry = ftrace_graph_entry_stub;
 
@@ -5746,7 +5759,7 @@ static int alloc_retstack_tasklist(struct ftrace_ret_stack **ret_stack_list)
 
 		if (t->ret_stack == NULL) {
 			atomic_set(&t->tracing_graph_pause, 0);
-			atomic_set(&t->trace_overrun, 0);
+			atomic_set_unchecked(&t->trace_overrun, 0);
 			t->curr_ret_stack = -1;
 			/* Make sure the tasks see the -1 first: */
 			smp_wmb();
@@ -5941,7 +5954,7 @@ void unregister_ftrace_graph(void)
 		goto out;
 
 	ftrace_graph_active--;
-	ftrace_graph_return = (trace_func_graph_ret_t)ftrace_stub;
+	ftrace_graph_return = ftrace_graph_return_stub;
 	ftrace_graph_entry = ftrace_graph_entry_stub;
 	__ftrace_graph_entry = ftrace_graph_entry_stub;
 	ftrace_shutdown(&graph_ops, FTRACE_STOP_FUNC_RET);
@@ -5969,7 +5982,7 @@ static void
 graph_init_task(struct task_struct *t, struct ftrace_ret_stack *ret_stack)
 {
 	atomic_set(&t->tracing_graph_pause, 0);
-	atomic_set(&t->trace_overrun, 0);
+	atomic_set_unchecked(&t->trace_overrun, 0);
 	t->ftrace_timestamp = 0;
 	/* make curr_ret_stack visible before we add the ret_stack */
 	smp_wmb();
diff --git a/kernel/trace/ring_buffer.c b/kernel/trace/ring_buffer.c
index 9c143739b..5ddd76352 100644
--- a/kernel/trace/ring_buffer.c
+++ b/kernel/trace/ring_buffer.c
@@ -296,9 +296,9 @@ struct buffer_data_page {
  */
 struct buffer_page {
 	struct list_head list;		/* list of buffer pages */
-	local_t		 write;		/* index for next write */
+	local_unchecked_t	 write;		/* index for next write */
 	unsigned	 read;		/* index for next read */
-	local_t		 entries;	/* entries on this page */
+	local_unchecked_t	 entries;	/* entries on this page */
 	unsigned long	 real_end;	/* real end of data */
 	struct buffer_data_page *page;	/* Actual data page */
 };
@@ -448,11 +448,11 @@ struct ring_buffer_per_cpu {
 	unsigned long			last_overrun;
 	local_t				entries_bytes;
 	local_t				entries;
-	local_t				overrun;
-	local_t				commit_overrun;
-	local_t				dropped_events;
+	local_unchecked_t		overrun;
+	local_unchecked_t		commit_overrun;
+	local_unchecked_t		dropped_events;
 	local_t				committing;
-	local_t				commits;
+	local_unchecked_t		commits;
 	unsigned long			read;
 	unsigned long			read_bytes;
 	u64				write_stamp;
@@ -1018,8 +1018,8 @@ static void rb_tail_page_update(struct ring_buffer_per_cpu *cpu_buffer,
 	 *
 	 * We add a counter to the write field to denote this.
 	 */
-	old_write = local_add_return(RB_WRITE_INTCNT, &next_page->write);
-	old_entries = local_add_return(RB_WRITE_INTCNT, &next_page->entries);
+	old_write = local_add_return_unchecked(RB_WRITE_INTCNT, &next_page->write);
+	old_entries = local_add_return_unchecked(RB_WRITE_INTCNT, &next_page->entries);
 
 	/*
 	 * Just make sure we have seen our old_write and synchronize
@@ -1047,8 +1047,8 @@ static void rb_tail_page_update(struct ring_buffer_per_cpu *cpu_buffer,
 		 * cmpxchg to only update if an interrupt did not already
 		 * do it for us. If the cmpxchg fails, we don't care.
 		 */
-		(void)local_cmpxchg(&next_page->write, old_write, val);
-		(void)local_cmpxchg(&next_page->entries, old_entries, eval);
+		(void)local_cmpxchg_unchecked(&next_page->write, old_write, val);
+		(void)local_cmpxchg_unchecked(&next_page->entries, old_entries, eval);
 
 		/*
 		 * No need to worry about races with clearing out the commit.
@@ -1412,12 +1412,12 @@ static void rb_reset_cpu(struct ring_buffer_per_cpu *cpu_buffer);
 
 static inline unsigned long rb_page_entries(struct buffer_page *bpage)
 {
-	return local_read(&bpage->entries) & RB_WRITE_MASK;
+	return local_read_unchecked(&bpage->entries) & RB_WRITE_MASK;
 }
 
 static inline unsigned long rb_page_write(struct buffer_page *bpage)
 {
-	return local_read(&bpage->write) & RB_WRITE_MASK;
+	return local_read_unchecked(&bpage->write) & RB_WRITE_MASK;
 }
 
 static int
@@ -1512,7 +1512,7 @@ rb_remove_pages(struct ring_buffer_per_cpu *cpu_buffer, unsigned long nr_pages)
 			 * bytes consumed in ring buffer from here.
 			 * Increment overrun to account for the lost events.
 			 */
-			local_add(page_entries, &cpu_buffer->overrun);
+			local_add_unchecked(page_entries, &cpu_buffer->overrun);
 			local_sub(BUF_PAGE_SIZE, &cpu_buffer->entries_bytes);
 		}
 
@@ -1942,7 +1942,7 @@ rb_handle_head_page(struct ring_buffer_per_cpu *cpu_buffer,
 		 * it is our responsibility to update
 		 * the counters.
 		 */
-		local_add(entries, &cpu_buffer->overrun);
+		local_add_unchecked(entries, &cpu_buffer->overrun);
 		local_sub(BUF_PAGE_SIZE, &cpu_buffer->entries_bytes);
 
 		/*
@@ -2079,7 +2079,7 @@ rb_reset_tail(struct ring_buffer_per_cpu *cpu_buffer,
 		if (tail == BUF_PAGE_SIZE)
 			tail_page->real_end = 0;
 
-		local_sub(length, &tail_page->write);
+		local_sub_unchecked(length, &tail_page->write);
 		return;
 	}
 
@@ -2114,7 +2114,7 @@ rb_reset_tail(struct ring_buffer_per_cpu *cpu_buffer,
 		rb_event_set_padding(event);
 
 		/* Set the write back to the previous setting */
-		local_sub(length, &tail_page->write);
+		local_sub_unchecked(length, &tail_page->write);
 		return;
 	}
 
@@ -2126,7 +2126,7 @@ rb_reset_tail(struct ring_buffer_per_cpu *cpu_buffer,
 
 	/* Set write to end of buffer */
 	length = (tail + length) - BUF_PAGE_SIZE;
-	local_sub(length, &tail_page->write);
+	local_sub_unchecked(length, &tail_page->write);
 }
 
 static inline void rb_end_commit(struct ring_buffer_per_cpu *cpu_buffer);
@@ -2154,7 +2154,7 @@ rb_move_tail(struct ring_buffer_per_cpu *cpu_buffer,
 	 * about it.
 	 */
 	if (unlikely(next_page == commit_page)) {
-		local_inc(&cpu_buffer->commit_overrun);
+		local_inc_unchecked(&cpu_buffer->commit_overrun);
 		goto out_reset;
 	}
 
@@ -2184,7 +2184,7 @@ rb_move_tail(struct ring_buffer_per_cpu *cpu_buffer,
 			 * this is easy, just stop here.
 			 */
 			if (!(buffer->flags & RB_FL_OVERWRITE)) {
-				local_inc(&cpu_buffer->dropped_events);
+				local_inc_unchecked(&cpu_buffer->dropped_events);
 				goto out_reset;
 			}
 
@@ -2210,7 +2210,7 @@ rb_move_tail(struct ring_buffer_per_cpu *cpu_buffer,
 				      cpu_buffer->tail_page) &&
 				     (cpu_buffer->commit_page ==
 				      cpu_buffer->reader_page))) {
-				local_inc(&cpu_buffer->commit_overrun);
+				local_inc_unchecked(&cpu_buffer->commit_overrun);
 				goto out_reset;
 			}
 		}
@@ -2358,7 +2358,7 @@ rb_try_to_discard(struct ring_buffer_per_cpu *cpu_buffer,
 
 	if (bpage->page == (void *)addr && rb_page_write(bpage) == old_index) {
 		unsigned long write_mask =
-			local_read(&bpage->write) & ~RB_WRITE_MASK;
+			local_read_unchecked(&bpage->write) & ~RB_WRITE_MASK;
 		unsigned long event_length = rb_event_length(event);
 		/*
 		 * This is on the tail page. It is possible that
@@ -2368,7 +2368,7 @@ rb_try_to_discard(struct ring_buffer_per_cpu *cpu_buffer,
 		 */
 		old_index += write_mask;
 		new_index += write_mask;
-		index = local_cmpxchg(&bpage->write, old_index, new_index);
+		index = local_cmpxchg_unchecked(&bpage->write, old_index, new_index);
 		if (index == old_index) {
 			/* update counters */
 			local_sub(event_length, &cpu_buffer->entries_bytes);
@@ -2383,7 +2383,7 @@ rb_try_to_discard(struct ring_buffer_per_cpu *cpu_buffer,
 static void rb_start_commit(struct ring_buffer_per_cpu *cpu_buffer)
 {
 	local_inc(&cpu_buffer->committing);
-	local_inc(&cpu_buffer->commits);
+	local_inc_unchecked(&cpu_buffer->commits);
 }
 
 static void
@@ -2450,7 +2450,7 @@ static inline void rb_end_commit(struct ring_buffer_per_cpu *cpu_buffer)
 		return;
 
  again:
-	commits = local_read(&cpu_buffer->commits);
+	commits = local_read_unchecked(&cpu_buffer->commits);
 	/* synchronize with interrupts */
 	barrier();
 	if (local_read(&cpu_buffer->committing) == 1)
@@ -2466,7 +2466,7 @@ static inline void rb_end_commit(struct ring_buffer_per_cpu *cpu_buffer)
 	 * updating of the commit page and the clearing of the
 	 * committing counter.
 	 */
-	if (unlikely(local_read(&cpu_buffer->commits) != commits) &&
+	if (unlikely(local_read_unchecked(&cpu_buffer->commits) != commits) &&
 	    !local_read(&cpu_buffer->committing)) {
 		local_inc(&cpu_buffer->committing);
 		goto again;
@@ -2695,7 +2695,7 @@ __rb_reserve_next(struct ring_buffer_per_cpu *cpu_buffer,
 
 	/* Don't let the compiler play games with cpu_buffer->tail_page */
 	tail_page = info->tail_page = READ_ONCE(cpu_buffer->tail_page);
-	write = local_add_return(info->length, &tail_page->write);
+	write = local_add_return_unchecked(info->length, &tail_page->write);
 
 	/* set write to only the index of the write */
 	write &= RB_WRITE_MASK;
@@ -2718,7 +2718,7 @@ __rb_reserve_next(struct ring_buffer_per_cpu *cpu_buffer,
 	kmemcheck_annotate_bitfield(event, bitfield);
 	rb_update_event(cpu_buffer, event, info);
 
-	local_inc(&tail_page->entries);
+	local_inc_unchecked(&tail_page->entries);
 
 	/*
 	 * If this is the first commit on the page, then update
@@ -2755,7 +2755,7 @@ rb_reserve_next_event(struct ring_buffer *buffer,
 	barrier();
 	if (unlikely(ACCESS_ONCE(cpu_buffer->buffer) != buffer)) {
 		local_dec(&cpu_buffer->committing);
-		local_dec(&cpu_buffer->commits);
+		local_dec_unchecked(&cpu_buffer->commits);
 		return NULL;
 	}
 #endif
@@ -2884,7 +2884,7 @@ rb_decrement_entry(struct ring_buffer_per_cpu *cpu_buffer,
 
 	/* Do the likely case first */
 	if (likely(bpage->page == (void *)addr)) {
-		local_dec(&bpage->entries);
+		local_dec_unchecked(&bpage->entries);
 		return;
 	}
 
@@ -2896,7 +2896,7 @@ rb_decrement_entry(struct ring_buffer_per_cpu *cpu_buffer,
 	start = bpage;
 	do {
 		if (bpage->page == (void *)addr) {
-			local_dec(&bpage->entries);
+			local_dec_unchecked(&bpage->entries);
 			return;
 		}
 		rb_inc_page(cpu_buffer, &bpage);
@@ -3184,7 +3184,7 @@ static inline unsigned long
 rb_num_of_entries(struct ring_buffer_per_cpu *cpu_buffer)
 {
 	return local_read(&cpu_buffer->entries) -
-		(local_read(&cpu_buffer->overrun) + cpu_buffer->read);
+		(local_read_unchecked(&cpu_buffer->overrun) + cpu_buffer->read);
 }
 
 /**
@@ -3273,7 +3273,7 @@ unsigned long ring_buffer_overrun_cpu(struct ring_buffer *buffer, int cpu)
 		return 0;
 
 	cpu_buffer = buffer->buffers[cpu];
-	ret = local_read(&cpu_buffer->overrun);
+	ret = local_read_unchecked(&cpu_buffer->overrun);
 
 	return ret;
 }
@@ -3296,7 +3296,7 @@ ring_buffer_commit_overrun_cpu(struct ring_buffer *buffer, int cpu)
 		return 0;
 
 	cpu_buffer = buffer->buffers[cpu];
-	ret = local_read(&cpu_buffer->commit_overrun);
+	ret = local_read_unchecked(&cpu_buffer->commit_overrun);
 
 	return ret;
 }
@@ -3318,7 +3318,7 @@ ring_buffer_dropped_events_cpu(struct ring_buffer *buffer, int cpu)
 		return 0;
 
 	cpu_buffer = buffer->buffers[cpu];
-	ret = local_read(&cpu_buffer->dropped_events);
+	ret = local_read_unchecked(&cpu_buffer->dropped_events);
 
 	return ret;
 }
@@ -3381,7 +3381,7 @@ unsigned long ring_buffer_overruns(struct ring_buffer *buffer)
 	/* if you care about this being correct, lock the buffer */
 	for_each_buffer_cpu(buffer, cpu) {
 		cpu_buffer = buffer->buffers[cpu];
-		overruns += local_read(&cpu_buffer->overrun);
+		overruns += local_read_unchecked(&cpu_buffer->overrun);
 	}
 
 	return overruns;
@@ -3552,8 +3552,8 @@ rb_get_reader_page(struct ring_buffer_per_cpu *cpu_buffer)
 	/*
 	 * Reset the reader page to size zero.
 	 */
-	local_set(&cpu_buffer->reader_page->write, 0);
-	local_set(&cpu_buffer->reader_page->entries, 0);
+	local_set_unchecked(&cpu_buffer->reader_page->write, 0);
+	local_set_unchecked(&cpu_buffer->reader_page->entries, 0);
 	local_set(&cpu_buffer->reader_page->page->commit, 0);
 	cpu_buffer->reader_page->real_end = 0;
 
@@ -3587,7 +3587,7 @@ rb_get_reader_page(struct ring_buffer_per_cpu *cpu_buffer)
 	 * want to compare with the last_overrun.
 	 */
 	smp_mb();
-	overwrite = local_read(&(cpu_buffer->overrun));
+	overwrite = local_read_unchecked(&(cpu_buffer->overrun));
 
 	/*
 	 * Here's the tricky part.
@@ -4173,8 +4173,8 @@ rb_reset_cpu(struct ring_buffer_per_cpu *cpu_buffer)
 
 	cpu_buffer->head_page
 		= list_entry(cpu_buffer->pages, struct buffer_page, list);
-	local_set(&cpu_buffer->head_page->write, 0);
-	local_set(&cpu_buffer->head_page->entries, 0);
+	local_set_unchecked(&cpu_buffer->head_page->write, 0);
+	local_set_unchecked(&cpu_buffer->head_page->entries, 0);
 	local_set(&cpu_buffer->head_page->page->commit, 0);
 
 	cpu_buffer->head_page->read = 0;
@@ -4184,18 +4184,18 @@ rb_reset_cpu(struct ring_buffer_per_cpu *cpu_buffer)
 
 	INIT_LIST_HEAD(&cpu_buffer->reader_page->list);
 	INIT_LIST_HEAD(&cpu_buffer->new_pages);
-	local_set(&cpu_buffer->reader_page->write, 0);
-	local_set(&cpu_buffer->reader_page->entries, 0);
+	local_set_unchecked(&cpu_buffer->reader_page->write, 0);
+	local_set_unchecked(&cpu_buffer->reader_page->entries, 0);
 	local_set(&cpu_buffer->reader_page->page->commit, 0);
 	cpu_buffer->reader_page->read = 0;
 
 	local_set(&cpu_buffer->entries_bytes, 0);
-	local_set(&cpu_buffer->overrun, 0);
-	local_set(&cpu_buffer->commit_overrun, 0);
-	local_set(&cpu_buffer->dropped_events, 0);
+	local_set_unchecked(&cpu_buffer->overrun, 0);
+	local_set_unchecked(&cpu_buffer->commit_overrun, 0);
+	local_set_unchecked(&cpu_buffer->dropped_events, 0);
 	local_set(&cpu_buffer->entries, 0);
 	local_set(&cpu_buffer->committing, 0);
-	local_set(&cpu_buffer->commits, 0);
+	local_set_unchecked(&cpu_buffer->commits, 0);
 	cpu_buffer->read = 0;
 	cpu_buffer->read_bytes = 0;
 
@@ -4585,8 +4585,8 @@ int ring_buffer_read_page(struct ring_buffer *buffer,
 		rb_init_page(bpage);
 		bpage = reader->page;
 		reader->page = *data_page;
-		local_set(&reader->write, 0);
-		local_set(&reader->entries, 0);
+		local_set_unchecked(&reader->write, 0);
+		local_set_unchecked(&reader->entries, 0);
 		reader->read = 0;
 		*data_page = bpage;
 
diff --git a/kernel/trace/trace.c b/kernel/trace/trace.c
index 7bc56762c..90db3d8eb 100644
--- a/kernel/trace/trace.c
+++ b/kernel/trace/trace.c
@@ -3883,7 +3883,7 @@ int trace_keep_overwrite(struct tracer *tracer, u32 mask, int set)
 	return 0;
 }
 
-int set_tracer_flag(struct trace_array *tr, unsigned int mask, int enabled)
+int set_tracer_flag(struct trace_array *tr, unsigned long mask, int enabled)
 {
 	/* do nothing if flag is already set */
 	if (!!(tr->trace_flags & mask) == !!enabled)
diff --git a/kernel/trace/trace.h b/kernel/trace/trace.h
index f783df416..6d1062f7a 100644
--- a/kernel/trace/trace.h
+++ b/kernel/trace/trace.h
@@ -1610,7 +1610,7 @@ void trace_printk_control(bool enabled);
 void trace_printk_init_buffers(void);
 void trace_printk_start_comm(void);
 int trace_keep_overwrite(struct tracer *tracer, u32 mask, int set);
-int set_tracer_flag(struct trace_array *tr, unsigned int mask, int enabled);
+int set_tracer_flag(struct trace_array *tr, unsigned long mask, int enabled);
 
 /*
  * Normal trace_printk() and friends allocates special buffers
diff --git a/kernel/trace/trace_clock.c b/kernel/trace/trace_clock.c
index 0f06532a7..247c8e7ff 100644
--- a/kernel/trace/trace_clock.c
+++ b/kernel/trace/trace_clock.c
@@ -127,7 +127,7 @@ u64 notrace trace_clock_global(void)
 }
 EXPORT_SYMBOL_GPL(trace_clock_global);
 
-static atomic64_t trace_counter;
+static atomic64_unchecked_t trace_counter;
 
 /*
  * trace_clock_counter(): simply an atomic counter.
@@ -136,5 +136,5 @@ static atomic64_t trace_counter;
  */
 u64 notrace trace_clock_counter(void)
 {
-	return atomic64_add_return(1, &trace_counter);
+	return atomic64_inc_return_unchecked(&trace_counter);
 }
diff --git a/kernel/trace/trace_events.c b/kernel/trace/trace_events.c
index 03c0a48c3..154163e2d 100644
--- a/kernel/trace/trace_events.c
+++ b/kernel/trace/trace_events.c
@@ -2274,7 +2274,6 @@ __trace_early_add_new_event(struct trace_event_call *call,
 	return 0;
 }
 
-struct ftrace_module_file_ops;
 static void __add_event_to_tracers(struct trace_event_call *call);
 
 /* Add an additional event_call dynamically */
diff --git a/kernel/trace/trace_events_hist.c b/kernel/trace/trace_events_hist.c
index f3a960ed7..f4ce9f9ac 100644
--- a/kernel/trace/trace_events_hist.c
+++ b/kernel/trace/trace_events_hist.c
@@ -1078,8 +1078,8 @@ static void hist_trigger_show(struct seq_file *m,
 	}
 
 	seq_printf(m, "\nTotals:\n    Hits: %llu\n    Entries: %u\n    Dropped: %llu\n",
-		   (u64)atomic64_read(&hist_data->map->hits),
-		   n_entries, (u64)atomic64_read(&hist_data->map->drops));
+		   (u64)atomic64_read_unchecked(&hist_data->map->hits),
+		   n_entries, (u64)atomic64_read_unchecked(&hist_data->map->drops));
 }
 
 static int hist_show(struct seq_file *m, void *v)
diff --git a/kernel/trace/trace_functions_graph.c b/kernel/trace/trace_functions_graph.c
index 16047a818..6ca9aafb7 100644
--- a/kernel/trace/trace_functions_graph.c
+++ b/kernel/trace/trace_functions_graph.c
@@ -138,7 +138,7 @@ ftrace_push_return_trace(unsigned long ret, unsigned long func, int *depth,
 
 	/* The return trace stack is full */
 	if (current->curr_ret_stack == FTRACE_RETFUNC_DEPTH - 1) {
-		atomic_inc(&current->trace_overrun);
+		atomic_inc_unchecked(&current->trace_overrun);
 		return -EBUSY;
 	}
 
@@ -235,7 +235,7 @@ ftrace_pop_return_trace(struct ftrace_graph_ret *trace, unsigned long *ret,
 	*ret = current->ret_stack[index].ret;
 	trace->func = current->ret_stack[index].func;
 	trace->calltime = current->ret_stack[index].calltime;
-	trace->overrun = atomic_read(&current->trace_overrun);
+	trace->overrun = atomic_read_unchecked(&current->trace_overrun);
 	trace->depth = index;
 }
 
diff --git a/kernel/trace/trace_mmiotrace.c b/kernel/trace/trace_mmiotrace.c
index cd7480d0a..f97e6e4fe 100644
--- a/kernel/trace/trace_mmiotrace.c
+++ b/kernel/trace/trace_mmiotrace.c
@@ -24,7 +24,7 @@ struct header_iter {
 static struct trace_array *mmio_trace_array;
 static bool overrun_detected;
 static unsigned long prev_overruns;
-static atomic_t dropped_count;
+static atomic_unchecked_t dropped_count;
 
 static void mmio_reset_data(struct trace_array *tr)
 {
@@ -120,7 +120,7 @@ static void mmio_close(struct trace_iterator *iter)
 
 static unsigned long count_overruns(struct trace_iterator *iter)
 {
-	unsigned long cnt = atomic_xchg(&dropped_count, 0);
+	unsigned long cnt = atomic_xchg_unchecked(&dropped_count, 0);
 	unsigned long over = ring_buffer_overruns(iter->trace_buffer->buffer);
 
 	if (over > prev_overruns)
@@ -303,7 +303,7 @@ static void __trace_mmiotrace_rw(struct trace_array *tr,
 	event = trace_buffer_lock_reserve(buffer, TRACE_MMIO_RW,
 					  sizeof(*entry), 0, pc);
 	if (!event) {
-		atomic_inc(&dropped_count);
+		atomic_inc_unchecked(&dropped_count);
 		return;
 	}
 	entry	= ring_buffer_event_data(event);
@@ -333,7 +333,7 @@ static void __trace_mmiotrace_map(struct trace_array *tr,
 	event = trace_buffer_lock_reserve(buffer, TRACE_MMIO_MAP,
 					  sizeof(*entry), 0, pc);
 	if (!event) {
-		atomic_inc(&dropped_count);
+		atomic_inc_unchecked(&dropped_count);
 		return;
 	}
 	entry	= ring_buffer_event_data(event);
diff --git a/kernel/trace/trace_output.c b/kernel/trace/trace_output.c
index 0bb9cf2d5..f319026e8 100644
--- a/kernel/trace/trace_output.c
+++ b/kernel/trace/trace_output.c
@@ -717,14 +717,16 @@ int register_trace_event(struct trace_event *event)
 			goto out;
 	}
 
+	pax_open_kernel();
 	if (event->funcs->trace == NULL)
-		event->funcs->trace = trace_nop_print;
+		const_cast(event->funcs->trace) = trace_nop_print;
 	if (event->funcs->raw == NULL)
-		event->funcs->raw = trace_nop_print;
+		const_cast(event->funcs->raw) = trace_nop_print;
 	if (event->funcs->hex == NULL)
-		event->funcs->hex = trace_nop_print;
+		const_cast(event->funcs->hex) = trace_nop_print;
 	if (event->funcs->binary == NULL)
-		event->funcs->binary = trace_nop_print;
+		const_cast(event->funcs->binary) = trace_nop_print;
+	pax_close_kernel();
 
 	key = event->type & (EVENT_HASHSIZE - 1);
 
diff --git a/kernel/trace/trace_printk.c b/kernel/trace/trace_printk.c
index ad1d6164e..da547c1a1 100644
--- a/kernel/trace/trace_printk.c
+++ b/kernel/trace/trace_printk.c
@@ -167,13 +167,11 @@ static void format_mod_stop(void)
 	mutex_unlock(&btrace_mutex);
 }
 
+static struct notifier_block module_trace_bprintk_format_nb = {
+	.notifier_call = module_trace_bprintk_format_notify,
+};
+
 #else /* !CONFIG_MODULES */
-__init static int
-module_trace_bprintk_format_notify(struct notifier_block *self,
-		unsigned long val, void *data)
-{
-	return 0;
-}
 static inline const char **
 find_next_mod_format(int start_index, void *v, const char **fmt, loff_t *pos)
 {
@@ -190,11 +188,6 @@ void trace_printk_control(bool enabled)
 	trace_printk_enabled = enabled;
 }
 
-__initdata_or_module static
-struct notifier_block module_trace_bprintk_format_nb = {
-	.notifier_call = module_trace_bprintk_format_notify,
-};
-
 int __trace_bprintk(unsigned long ip, const char *fmt, ...)
  {
 	int ret;
@@ -373,9 +366,11 @@ static __init int init_trace_printk_function_export(void)
 
 fs_initcall(init_trace_printk_function_export);
 
+#ifdef CONFIG_MODULES
 static __init int init_trace_printk(void)
 {
 	return register_module_notifier(&module_trace_bprintk_format_nb);
 }
 
 early_initcall(init_trace_printk);
+#endif
diff --git a/kernel/trace/trace_seq.c b/kernel/trace/trace_seq.c
index e694c9f9e..6775a3891 100644
--- a/kernel/trace/trace_seq.c
+++ b/kernel/trace/trace_seq.c
@@ -337,7 +337,7 @@ int trace_seq_path(struct trace_seq *s, const struct path *path)
 		return 0;
 	}
 
-	seq_buf_path(&s->seq, path, "\n");
+	seq_buf_path(&s->seq, path, "\n\\");
 
 	if (unlikely(seq_buf_has_overflowed(&s->seq))) {
 		s->seq.len = save_len;
diff --git a/kernel/trace/trace_stack.c b/kernel/trace/trace_stack.c
index 2a1abbaca..2a81a7889 100644
--- a/kernel/trace/trace_stack.c
+++ b/kernel/trace/trace_stack.c
@@ -88,7 +88,7 @@ check_stack(unsigned long ip, unsigned long *stack)
 		return;
 
 	/* we do not handle interrupt stacks yet */
-	if (!object_is_on_stack(stack))
+	if (!object_starts_on_stack(stack))
 		return;
 
 	/* Can't do this from NMI context (can cause deadlocks) */
diff --git a/kernel/trace/trace_syscalls.c b/kernel/trace/trace_syscalls.c
index b2b6efc08..52e0a3d2a 100644
--- a/kernel/trace/trace_syscalls.c
+++ b/kernel/trace/trace_syscalls.c
@@ -605,6 +605,8 @@ static int perf_sysenter_enable(struct trace_event_call *call)
 	int num;
 
 	num = ((struct syscall_metadata *)call->data)->syscall_nr;
+	if (WARN_ON_ONCE(num < 0 || num >= NR_syscalls))
+		return -EINVAL;
 
 	mutex_lock(&syscall_trace_lock);
 	if (!sys_perf_refcount_enter)
@@ -625,6 +627,8 @@ static void perf_sysenter_disable(struct trace_event_call *call)
 	int num;
 
 	num = ((struct syscall_metadata *)call->data)->syscall_nr;
+	if (WARN_ON_ONCE(num < 0 || num >= NR_syscalls))
+		return;
 
 	mutex_lock(&syscall_trace_lock);
 	sys_perf_refcount_enter--;
@@ -677,6 +681,8 @@ static int perf_sysexit_enable(struct trace_event_call *call)
 	int num;
 
 	num = ((struct syscall_metadata *)call->data)->syscall_nr;
+	if (WARN_ON_ONCE(num < 0 || num >= NR_syscalls))
+		return -EINVAL;
 
 	mutex_lock(&syscall_trace_lock);
 	if (!sys_perf_refcount_exit)
@@ -697,6 +703,8 @@ static void perf_sysexit_disable(struct trace_event_call *call)
 	int num;
 
 	num = ((struct syscall_metadata *)call->data)->syscall_nr;
+	if (WARN_ON_ONCE(num < 0 || num >= NR_syscalls))
+		return;
 
 	mutex_lock(&syscall_trace_lock);
 	sys_perf_refcount_exit--;
diff --git a/kernel/trace/tracing_map.c b/kernel/trace/tracing_map.c
index 0a689bbb7..e96cd14e6 100644
--- a/kernel/trace/tracing_map.c
+++ b/kernel/trace/tracing_map.c
@@ -349,7 +349,7 @@ static struct tracing_map_elt *get_free_elt(struct tracing_map *map)
 	struct tracing_map_elt *elt = NULL;
 	int idx;
 
-	idx = atomic_inc_return(&map->next_elt);
+	idx = atomic_inc_return_unchecked(&map->next_elt);
 	if (idx < map->max_elts) {
 		elt = *(TRACING_MAP_ELT(map->elts, idx));
 		if (map->ops && map->ops->elt_init)
@@ -425,7 +425,7 @@ __tracing_map_insert(struct tracing_map *map, void *key, bool lookup_only)
 
 		if (test_key && test_key == key_hash && entry->val &&
 		    keys_match(key, entry->val->key, map->key_size)) {
-			atomic64_inc(&map->hits);
+			atomic64_inc_unchecked(&map->hits);
 			return entry->val;
 		}
 
@@ -438,14 +438,14 @@ __tracing_map_insert(struct tracing_map *map, void *key, bool lookup_only)
 
 				elt = get_free_elt(map);
 				if (!elt) {
-					atomic64_inc(&map->drops);
+					atomic64_inc_unchecked(&map->drops);
 					entry->key = 0;
 					break;
 				}
 
 				memcpy(elt->key, key, map->key_size);
 				entry->val = elt;
-				atomic64_inc(&map->hits);
+				atomic64_inc_unchecked(&map->hits);
 
 				return entry->val;
 			}
@@ -557,9 +557,9 @@ void tracing_map_clear(struct tracing_map *map)
 {
 	unsigned int i;
 
-	atomic_set(&map->next_elt, -1);
-	atomic64_set(&map->hits, 0);
-	atomic64_set(&map->drops, 0);
+	atomic_set_unchecked(&map->next_elt, -1);
+	atomic64_set_unchecked(&map->hits, 0);
+	atomic64_set_unchecked(&map->drops, 0);
 
 	tracing_map_array_clear(map->map);
 
@@ -641,7 +641,7 @@ struct tracing_map *tracing_map_create(unsigned int map_bits,
 
 	map->map_bits = map_bits;
 	map->max_elts = (1 << map_bits);
-	atomic_set(&map->next_elt, -1);
+	atomic_set_unchecked(&map->next_elt, -1);
 
 	map->map_size = (1 << (map_bits + 1));
 	map->ops = ops;
@@ -700,9 +700,10 @@ int tracing_map_init(struct tracing_map *map)
 	return err;
 }
 
-static int cmp_entries_dup(const struct tracing_map_sort_entry **a,
-			   const struct tracing_map_sort_entry **b)
+static int cmp_entries_dup(const void *_a, const void *_b)
 {
+	const struct tracing_map_sort_entry **a = (const struct tracing_map_sort_entry **)_a;
+	const struct tracing_map_sort_entry **b = (const struct tracing_map_sort_entry **)_b;
 	int ret = 0;
 
 	if (memcmp((*a)->key, (*b)->key, (*a)->elt->map->key_size))
@@ -711,9 +712,10 @@ static int cmp_entries_dup(const struct tracing_map_sort_entry **a,
 	return ret;
 }
 
-static int cmp_entries_sum(const struct tracing_map_sort_entry **a,
-			   const struct tracing_map_sort_entry **b)
+static int cmp_entries_sum(const void *_a, const void *_b)
 {
+	const struct tracing_map_sort_entry **a = (const struct tracing_map_sort_entry **)_a;
+	const struct tracing_map_sort_entry **b = (const struct tracing_map_sort_entry **)_b;
 	const struct tracing_map_elt *elt_a, *elt_b;
 	struct tracing_map_sort_key *sort_key;
 	struct tracing_map_field *field;
@@ -739,9 +741,10 @@ static int cmp_entries_sum(const struct tracing_map_sort_entry **a,
 	return ret;
 }
 
-static int cmp_entries_key(const struct tracing_map_sort_entry **a,
-			   const struct tracing_map_sort_entry **b)
+static int cmp_entries_key(const void *_a, const void *_b)
 {
+	const struct tracing_map_sort_entry **a = (const struct tracing_map_sort_entry **)_a;
+	const struct tracing_map_sort_entry **b = (const struct tracing_map_sort_entry **)_b;
 	const struct tracing_map_elt *elt_a, *elt_b;
 	struct tracing_map_sort_key *sort_key;
 	struct tracing_map_field *field;
@@ -874,8 +877,7 @@ static int merge_dups(struct tracing_map_sort_entry **sort_entries,
 	if (n_entries < 2)
 		return total_dups;
 
-	sort(sort_entries, n_entries, sizeof(struct tracing_map_sort_entry *),
-	     (int (*)(const void *, const void *))cmp_entries_dup, NULL);
+	sort(sort_entries, n_entries, sizeof(struct tracing_map_sort_entry *), cmp_entries_dup, NULL);
 
 	key = sort_entries[0]->key;
 	for (i = 1; i < n_entries; i++) {
@@ -923,10 +925,8 @@ static void sort_secondary(struct tracing_map *map,
 			   struct tracing_map_sort_key *primary_key,
 			   struct tracing_map_sort_key *secondary_key)
 {
-	int (*primary_fn)(const struct tracing_map_sort_entry **,
-			  const struct tracing_map_sort_entry **);
-	int (*secondary_fn)(const struct tracing_map_sort_entry **,
-			    const struct tracing_map_sort_entry **);
+	int (*primary_fn)(const void*, const void*);
+	int (*secondary_fn)(const void*, const void*);
 	unsigned i, start = 0, n_sub = 1;
 
 	if (is_key(map, primary_key->field_idx))
@@ -958,7 +958,7 @@ static void sort_secondary(struct tracing_map *map,
 		set_sort_key(map, secondary_key);
 		sort(&entries[start], n_sub,
 		     sizeof(struct tracing_map_sort_entry *),
-		     (int (*)(const void *, const void *))secondary_fn, NULL);
+		     secondary_fn, NULL);
 		set_sort_key(map, primary_key);
 
 		start = i + 1;
@@ -995,8 +995,7 @@ int tracing_map_sort_entries(struct tracing_map *map,
 			     unsigned int n_sort_keys,
 			     struct tracing_map_sort_entry ***sort_entries)
 {
-	int (*cmp_entries_fn)(const struct tracing_map_sort_entry **,
-			      const struct tracing_map_sort_entry **);
+	int (*cmp_entries_fn)(const void*, const void*);
 	struct tracing_map_sort_entry *sort_entry, **entries;
 	int i, n_entries, ret;
 
@@ -1042,8 +1041,7 @@ int tracing_map_sort_entries(struct tracing_map *map,
 
 	set_sort_key(map, &sort_keys[0]);
 
-	sort(entries, n_entries, sizeof(struct tracing_map_sort_entry *),
-	     (int (*)(const void *, const void *))cmp_entries_fn, NULL);
+	sort(entries, n_entries, sizeof(struct tracing_map_sort_entry *), cmp_entries_fn, NULL);
 
 	if (n_sort_keys > 1)
 		sort_secondary(map,
diff --git a/kernel/trace/tracing_map.h b/kernel/trace/tracing_map.h
index 618838f5f..3dc1b9b9e 100644
--- a/kernel/trace/tracing_map.h
+++ b/kernel/trace/tracing_map.h
@@ -181,7 +181,7 @@ struct tracing_map {
 	unsigned int			map_bits;
 	unsigned int			map_size;
 	unsigned int			max_elts;
-	atomic_t			next_elt;
+	atomic_unchecked_t		next_elt;
 	struct tracing_map_array	*elts;
 	struct tracing_map_array	*map;
 	const struct tracing_map_ops	*ops;
@@ -191,8 +191,8 @@ struct tracing_map {
 	int				key_idx[TRACING_MAP_KEYS_MAX];
 	unsigned int			n_keys;
 	struct tracing_map_sort_key	sort_key;
-	atomic64_t			hits;
-	atomic64_t			drops;
+	atomic64_unchecked_t		hits;
+	atomic64_unchecked_t		drops;
 };
 
 /**
diff --git a/kernel/user.c b/kernel/user.c
index b069ccbfb..c59fe26d2 100644
--- a/kernel/user.c
+++ b/kernel/user.c
@@ -127,8 +127,8 @@ static struct user_struct *uid_hash_find(kuid_t uid, struct hlist_head *hashent)
  * IRQ state (as stored in flags) is restored and uidhash_lock released
  * upon function exit.
  */
+static void free_user(struct user_struct *up, unsigned long flags) __releases(&uidhash_lock);
 static void free_user(struct user_struct *up, unsigned long flags)
-	__releases(&uidhash_lock)
 {
 	uid_hash_remove(up);
 	spin_unlock_irqrestore(&uidhash_lock, flags);
diff --git a/kernel/user_namespace.c b/kernel/user_namespace.c
index 68f594212..8576ce7cd 100644
--- a/kernel/user_namespace.c
+++ b/kernel/user_namespace.c
@@ -84,6 +84,21 @@ int create_user_ns(struct cred *new)
 	    !kgid_has_mapping(parent_ns, group))
 		return -EPERM;
 
+#ifdef CONFIG_GRKERNSEC
+	/*
+	 * This doesn't really inspire confidence:
+	 * http://marc.info/?l=linux-kernel&m=135543612731939&w=2
+	 * http://marc.info/?l=linux-kernel&m=135545831607095&w=2
+	 * Increases kernel attack surface in areas developers
+	 * previously cared little about ("low importance due
+	 * to requiring "root" capability")
+	 * To be removed when this code receives *proper* review
+	 */
+	if (!capable(CAP_SYS_ADMIN) || !capable(CAP_SETUID) ||
+			!capable(CAP_SETGID))
+		return -EPERM;
+#endif
+
 	ns = kmem_cache_zalloc(user_ns_cachep, GFP_KERNEL);
 	if (!ns)
 		return -ENOMEM;
@@ -988,7 +1003,7 @@ static int userns_install(struct nsproxy *nsproxy, struct ns_common *ns)
 	if (!thread_group_empty(current))
 		return -EINVAL;
 
-	if (current->fs->users != 1)
+	if (atomic_read(&current->fs->users) != 1)
 		return -EINVAL;
 
 	if (!ns_capable(user_ns, CAP_SYS_ADMIN))
diff --git a/kernel/utsname_sysctl.c b/kernel/utsname_sysctl.c
index c8eac4326..4b5f08f47 100644
--- a/kernel/utsname_sysctl.c
+++ b/kernel/utsname_sysctl.c
@@ -47,7 +47,7 @@ static void put_uts(struct ctl_table *table, int write, void *which)
 static int proc_do_uts_string(struct ctl_table *table, int write,
 		  void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table uts_table;
+	ctl_table_no_const uts_table;
 	int r;
 	memcpy(&uts_table, table, sizeof(uts_table));
 	uts_table.data = get_uts(table, write);
diff --git a/kernel/watchdog.c b/kernel/watchdog.c
index 6d1020c03..ae8f9902c 100644
--- a/kernel/watchdog.c
+++ b/kernel/watchdog.c
@@ -679,7 +679,7 @@ static int watchdog_nmi_enable(unsigned int cpu) { return 0; }
 static void watchdog_nmi_disable(unsigned int cpu) { return; }
 #endif /* CONFIG_HARDLOCKUP_DETECTOR */
 
-static struct smp_hotplug_thread watchdog_threads = {
+static struct smp_hotplug_thread watchdog_threads __read_only = {
 	.store			= &softlockup_watchdog,
 	.thread_should_run	= watchdog_should_run,
 	.thread_fn		= watchdog,
diff --git a/kernel/workqueue.c b/kernel/workqueue.c
index ef071ca73..621135cd8 100644
--- a/kernel/workqueue.c
+++ b/kernel/workqueue.c
@@ -1922,9 +1922,8 @@ static void pool_mayday_timeout(unsigned long __pool)
  * multiple times.  Does GFP_KERNEL allocations.  Called only from
  * manager.
  */
+static void maybe_create_worker(struct worker_pool *pool) __must_hold(&pool->lock);
 static void maybe_create_worker(struct worker_pool *pool)
-__releases(&pool->lock)
-__acquires(&pool->lock)
 {
 restart:
 	spin_unlock_irq(&pool->lock);
@@ -2014,9 +2013,8 @@ static bool manage_workers(struct worker *worker)
  * CONTEXT:
  * spin_lock_irq(pool->lock) which is released and regrabbed.
  */
+static void process_one_work(struct worker *worker, struct work_struct *work) __must_hold(&pool->lock);
 static void process_one_work(struct worker *worker, struct work_struct *work)
-__releases(&pool->lock)
-__acquires(&pool->lock)
 {
 	struct pool_workqueue *pwq = get_work_pwq(work);
 	struct worker_pool *pool = worker->pool;
@@ -4573,7 +4571,7 @@ static void rebind_workers(struct worker_pool *pool)
 		WARN_ON_ONCE(!(worker_flags & WORKER_UNBOUND));
 		worker_flags |= WORKER_REBOUND;
 		worker_flags &= ~WORKER_UNBOUND;
-		ACCESS_ONCE(worker->flags) = worker_flags;
+		ACCESS_ONCE_RW(worker->flags) = worker_flags;
 	}
 
 	spin_unlock_irq(&pool->lock);
diff --git a/lib/842/842_compress.c b/lib/842/842_compress.c
index 4051339bd..7144fad4a 100644
--- a/lib/842/842_compress.c
+++ b/lib/842/842_compress.c
@@ -306,7 +306,7 @@ static int add_template(struct sw842_param *p, u8 c)
 	}
 
 	if (sw842_template_counts)
-		atomic_inc(&template_count[t[4]]);
+		atomic_inc_unchecked(&template_count[t[4]]);
 
 	return 0;
 }
@@ -328,7 +328,7 @@ static int add_repeat_template(struct sw842_param *p, u8 r)
 		return ret;
 
 	if (sw842_template_counts)
-		atomic_inc(&template_repeat_count);
+		atomic_inc_unchecked(&template_repeat_count);
 
 	return 0;
 }
@@ -355,7 +355,7 @@ static int add_short_data_template(struct sw842_param *p, u8 b)
 	}
 
 	if (sw842_template_counts)
-		atomic_inc(&template_short_data_count);
+		atomic_inc_unchecked(&template_short_data_count);
 
 	return 0;
 }
@@ -368,7 +368,7 @@ static int add_zeros_template(struct sw842_param *p)
 		return ret;
 
 	if (sw842_template_counts)
-		atomic_inc(&template_zeros_count);
+		atomic_inc_unchecked(&template_zeros_count);
 
 	return 0;
 }
@@ -381,7 +381,7 @@ static int add_end_template(struct sw842_param *p)
 		return ret;
 
 	if (sw842_template_counts)
-		atomic_inc(&template_end_count);
+		atomic_inc_unchecked(&template_end_count);
 
 	return 0;
 }
diff --git a/lib/842/842_debugfs.h b/lib/842/842_debugfs.h
index e7f3bffaf..77d1d9215 100644
--- a/lib/842/842_debugfs.h
+++ b/lib/842/842_debugfs.h
@@ -7,7 +7,7 @@
 static bool sw842_template_counts;
 module_param_named(template_counts, sw842_template_counts, bool, 0444);
 
-static atomic_t template_count[OPS_MAX], template_repeat_count,
+static atomic_unchecked_t template_count[OPS_MAX], template_repeat_count,
 	template_zeros_count, template_short_data_count, template_end_count;
 
 static struct dentry *sw842_debugfs_root;
@@ -28,16 +28,16 @@ static int __init sw842_debugfs_create(void)
 		char name[32];
 
 		snprintf(name, 32, "template_%02x", i);
-		debugfs_create_atomic_t(name, m, sw842_debugfs_root,
+		debugfs_create_atomic_unchecked_t(name, m, sw842_debugfs_root,
 					&template_count[i]);
 	}
-	debugfs_create_atomic_t("template_repeat", m, sw842_debugfs_root,
+	debugfs_create_atomic_unchecked_t("template_repeat", m, sw842_debugfs_root,
 				&template_repeat_count);
-	debugfs_create_atomic_t("template_zeros", m, sw842_debugfs_root,
+	debugfs_create_atomic_unchecked_t("template_zeros", m, sw842_debugfs_root,
 				&template_zeros_count);
-	debugfs_create_atomic_t("template_short_data", m, sw842_debugfs_root,
+	debugfs_create_atomic_unchecked_t("template_short_data", m, sw842_debugfs_root,
 				&template_short_data_count);
-	debugfs_create_atomic_t("template_end", m, sw842_debugfs_root,
+	debugfs_create_atomic_unchecked_t("template_end", m, sw842_debugfs_root,
 				&template_end_count);
 
 	return 0;
diff --git a/lib/842/842_decompress.c b/lib/842/842_decompress.c
index 11fc39b40..e5cfa586a 100644
--- a/lib/842/842_decompress.c
+++ b/lib/842/842_decompress.c
@@ -263,7 +263,7 @@ static int do_op(struct sw842_param *p, u8 o)
 	}
 
 	if (sw842_template_counts)
-		atomic_inc(&template_count[o]);
+		atomic_inc_unchecked(&template_count[o]);
 
 	return 0;
 }
@@ -331,7 +331,7 @@ int sw842_decompress(const u8 *in, unsigned int ilen,
 			}
 
 			if (sw842_template_counts)
-				atomic_inc(&template_repeat_count);
+				atomic_inc_unchecked(&template_repeat_count);
 
 			break;
 		case OP_ZEROS:
@@ -343,7 +343,7 @@ int sw842_decompress(const u8 *in, unsigned int ilen,
 			p.olen -= 8;
 
 			if (sw842_template_counts)
-				atomic_inc(&template_zeros_count);
+				atomic_inc_unchecked(&template_zeros_count);
 
 			break;
 		case OP_SHORT_DATA:
@@ -364,12 +364,12 @@ int sw842_decompress(const u8 *in, unsigned int ilen,
 			}
 
 			if (sw842_template_counts)
-				atomic_inc(&template_short_data_count);
+				atomic_inc_unchecked(&template_short_data_count);
 
 			break;
 		case OP_END:
 			if (sw842_template_counts)
-				atomic_inc(&template_end_count);
+				atomic_inc_unchecked(&template_end_count);
 
 			break;
 		default: /* use template */
diff --git a/lib/Kconfig.debug b/lib/Kconfig.debug
index cab7405f4..c65d4730c 100644
--- a/lib/Kconfig.debug
+++ b/lib/Kconfig.debug
@@ -243,6 +243,7 @@ config PAGE_OWNER
 	bool "Track page owner"
 	depends on DEBUG_KERNEL && STACKTRACE_SUPPORT
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	select STACKTRACE
 	select STACKDEPOT
 	select PAGE_EXTENSION
@@ -259,6 +260,7 @@ config PAGE_OWNER
 config DEBUG_FS
 	bool "Debug Filesystem"
 	select SRCU
+	depends on !GRKERNSEC_KMEM
 	help
 	  debugfs is a virtual file system that kernel developers use to put
 	  debugging files into.  Enable this option to be able to read and
@@ -512,6 +514,7 @@ config DEBUG_KMEMLEAK
 	bool "Kernel memory leak detector"
 	depends on DEBUG_KERNEL && HAVE_DEBUG_KMEMLEAK
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	select STACKTRACE if STACKTRACE_SUPPORT
 	select KALLSYMS
 	select CRC32
@@ -711,6 +714,7 @@ config KCOV
 	select DEBUG_FS
 	select GCC_PLUGINS if !COMPILE_TEST
 	select GCC_PLUGIN_SANCOV if !COMPILE_TEST
+	depends on !GRKERNSEC_KMEM
 	help
 	  KCOV exposes kernel code coverage information in a form suitable
 	  for coverage-guided fuzzing (randomized testing).
@@ -1012,7 +1016,7 @@ config DEBUG_MUTEXES
 
 config DEBUG_WW_MUTEX_SLOWPATH
 	bool "Wait/wound mutex debugging: Slowpath testing"
-	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT
+	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT && !PAX_CONSTIFY_PLUGIN
 	select DEBUG_LOCK_ALLOC
 	select DEBUG_SPINLOCK
 	select DEBUG_MUTEXES
@@ -1029,7 +1033,7 @@ config DEBUG_WW_MUTEX_SLOWPATH
 
 config DEBUG_LOCK_ALLOC
 	bool "Lock debugging: detect incorrect freeing of live locks"
-	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT
+	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT && !PAX_CONSTIFY_PLUGIN
 	select DEBUG_SPINLOCK
 	select DEBUG_MUTEXES
 	select LOCKDEP
@@ -1043,7 +1047,7 @@ config DEBUG_LOCK_ALLOC
 
 config PROVE_LOCKING
 	bool "Lock debugging: prove locking correctness"
-	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT
+	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT && !PAX_CONSTIFY_PLUGIN
 	select LOCKDEP
 	select DEBUG_SPINLOCK
 	select DEBUG_MUTEXES
@@ -1094,7 +1098,7 @@ config LOCKDEP
 
 config LOCK_STAT
 	bool "Lock usage statistics"
-	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT
+	depends on DEBUG_KERNEL && TRACE_IRQFLAGS_SUPPORT && STACKTRACE_SUPPORT && LOCKDEP_SUPPORT && !PAX_CONSTIFY_PLUGIN
 	select LOCKDEP
 	select DEBUG_SPINLOCK
 	select DEBUG_MUTEXES
@@ -1507,6 +1511,7 @@ config NOTIFIER_ERROR_INJECTION
 	tristate "Notifier error injection"
 	depends on DEBUG_KERNEL
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	help
 	  This option provides the ability to inject artificial errors to
 	  specified notifier chain callbacks. It is useful to test the error
@@ -1652,6 +1657,7 @@ config FAIL_MMC_REQUEST
 config FAIL_FUTEX
 	bool "Fault-injection capability for futexes"
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	depends on FAULT_INJECTION && FUTEX
 	help
 	  Provide fault-injection capability for futexes.
@@ -1676,6 +1682,7 @@ config LATENCYTOP
 	depends on DEBUG_KERNEL
 	depends on STACKTRACE_SUPPORT
 	depends on PROC_FS
+	depends on !GRKERNSEC_HIDESYM
 	select FRAME_POINTER if !MIPS && !PPC && !S390 && !MICROBLAZE && !ARM_UNWIND && !ARC
 	select KALLSYMS
 	select KALLSYMS_ALL
@@ -1830,7 +1837,7 @@ endmenu # runtime tests
 
 config PROVIDE_OHCI1394_DMA_INIT
 	bool "Remote debugging over FireWire early on boot"
-	depends on PCI && X86
+	depends on PCI && X86 && !GRKERNSEC
 	help
 	  If you want to debug problems which hang or crash the kernel early
 	  on boot and the crashing machine has a FireWire port, you can use
diff --git a/lib/Kconfig.kmemcheck b/lib/Kconfig.kmemcheck
index 846e039a8..63ef28479 100644
--- a/lib/Kconfig.kmemcheck
+++ b/lib/Kconfig.kmemcheck
@@ -10,6 +10,7 @@ menuconfig KMEMCHECK
 	depends on SLUB || SLAB
 	depends on !CC_OPTIMIZE_FOR_SIZE
 	depends on !FUNCTION_TRACER
+	depends on !PAX_INITIFY
 	select FRAME_POINTER
 	select STACKTRACE
 	default n
diff --git a/lib/Makefile b/lib/Makefile
index 5dc77a8ec..8c1834509 100644
--- a/lib/Makefile
+++ b/lib/Makefile
@@ -76,7 +76,7 @@ obj-$(CONFIG_BTREE) += btree.o
 obj-$(CONFIG_INTERVAL_TREE) += interval_tree.o
 obj-$(CONFIG_ASSOCIATIVE_ARRAY) += assoc_array.o
 obj-$(CONFIG_DEBUG_PREEMPT) += smp_processor_id.o
-obj-$(CONFIG_DEBUG_LIST) += list_debug.o
+obj-y += list_debug.o
 obj-$(CONFIG_DEBUG_OBJECTS) += debugobjects.o
 
 ifneq ($(CONFIG_HAVE_DEC_LOCK),y)
diff --git a/lib/bitmap.c b/lib/bitmap.c
index eca88087f..23b3fd87f 100644
--- a/lib/bitmap.c
+++ b/lib/bitmap.c
@@ -363,7 +363,7 @@ int __bitmap_parse(const char *buf, unsigned int buflen,
 {
 	int c, old_c, totaldigits, ndigits, nchunks, nbits;
 	u32 chunk;
-	const char __user __force *ubuf = (const char __user __force *)buf;
+	const char __user *ubuf = (const char __force_user *)buf;
 
 	bitmap_zero(maskp, nmaskbits);
 
@@ -449,7 +449,7 @@ int bitmap_parse_user(const char __user *ubuf,
 {
 	if (!access_ok(VERIFY_READ, ubuf, ulen))
 		return -EFAULT;
-	return __bitmap_parse((const char __force *)ubuf,
+	return __bitmap_parse((const char __force_kernel *)ubuf,
 				ulen, 1, maskp, nmaskbits);
 
 }
@@ -509,7 +509,7 @@ static int __bitmap_parselist(const char *buf, unsigned int buflen,
 {
 	unsigned a, b;
 	int c, old_c, totaldigits, ndigits;
-	const char __user __force *ubuf = (const char __user __force *)buf;
+	const char __user *ubuf = (const char __force_user *)buf;
 	int at_start, in_range;
 
 	totaldigits = c = 0;
@@ -613,7 +613,7 @@ int bitmap_parselist_user(const char __user *ubuf,
 {
 	if (!access_ok(VERIFY_READ, ubuf, ulen))
 		return -EFAULT;
-	return __bitmap_parselist((const char __force *)ubuf,
+	return __bitmap_parselist((const char __force_kernel *)ubuf,
 					ulen, 1, maskp, nmaskbits);
 }
 EXPORT_SYMBOL(bitmap_parselist_user);
diff --git a/lib/bug.c b/lib/bug.c
index bc3656e94..470f3ab4c 100644
--- a/lib/bug.c
+++ b/lib/bug.c
@@ -148,6 +148,8 @@ enum bug_trap_type report_bug(unsigned long bugaddr, struct pt_regs *regs)
 		return BUG_TRAP_TYPE_NONE;
 
 	bug = find_bug(bugaddr);
+	if (!bug)
+		return BUG_TRAP_TYPE_NONE;
 
 	file = NULL;
 	line = 0;
diff --git a/lib/debugobjects.c b/lib/debugobjects.c
index a8e12601e..cf8f2bee5 100644
--- a/lib/debugobjects.c
+++ b/lib/debugobjects.c
@@ -288,7 +288,7 @@ static void debug_object_is_on_stack(void *addr, int onstack)
 	if (limit > 4)
 		return;
 
-	is_on_stack = object_is_on_stack(addr);
+	is_on_stack = object_starts_on_stack(addr);
 	if (is_on_stack == onstack)
 		return;
 
diff --git a/lib/decompress_bunzip2.c b/lib/decompress_bunzip2.c
index 0234361b2..41a411c99 100644
--- a/lib/decompress_bunzip2.c
+++ b/lib/decompress_bunzip2.c
@@ -665,7 +665,8 @@ static int INIT start_bunzip(struct bunzip_data **bdp, void *inbuf, long len,
 
 	/* Fourth byte (ascii '1'-'9'), indicates block size in units of 100k of
 	   uncompressed data.  Allocate intermediate buffer for block. */
-	bd->dbufSize = 100000*(i-BZh0);
+	i -= BZh0;
+	bd->dbufSize = 100000 * i;
 
 	bd->dbuf = large_malloc(bd->dbufSize * sizeof(int));
 	if (!bd->dbuf)
diff --git a/lib/decompress_unlzma.c b/lib/decompress_unlzma.c
index ed7a1fd81..44a1a62e4 100644
--- a/lib/decompress_unlzma.c
+++ b/lib/decompress_unlzma.c
@@ -39,10 +39,10 @@
 
 #define	MIN(a, b) (((a) < (b)) ? (a) : (b))
 
-static long long INIT read_int(unsigned char *ptr, int size)
+static unsigned long long INIT read_int(unsigned char *ptr, int size)
 {
 	int i;
-	long long ret = 0;
+	unsigned long long ret = 0;
 
 	for (i = 0; i < size; i++)
 		ret = (ret << 8) | ptr[size-i-1];
diff --git a/lib/div64.c b/lib/div64.c
index 7f345259c..c53be4b9d 100644
--- a/lib/div64.c
+++ b/lib/div64.c
@@ -61,7 +61,7 @@ EXPORT_SYMBOL(__div64_32);
 #endif
 
 #ifndef div_s64_rem
-s64 div_s64_rem(s64 dividend, s32 divisor, s32 *remainder)
+s64 __intentional_overflow(-1) div_s64_rem(s64 dividend, s32 divisor, s32 *remainder)
 {
 	u64 quotient;
 
@@ -132,7 +132,7 @@ EXPORT_SYMBOL(div64_u64_rem);
  * 'http://www.hackersdelight.org/hdcodetxt/divDouble.c.txt'
  */
 #ifndef div64_u64
-u64 div64_u64(u64 dividend, u64 divisor)
+u64 __intentional_overflow(-1) div64_u64(u64 dividend, u64 divisor)
 {
 	u32 high = divisor >> 32;
 	u64 quot;
diff --git a/lib/dma-debug.c b/lib/dma-debug.c
index fcfa1939a..b345d59d3 100644
--- a/lib/dma-debug.c
+++ b/lib/dma-debug.c
@@ -984,7 +984,7 @@ static int dma_debug_device_change(struct notifier_block *nb, unsigned long acti
 
 void dma_debug_add_bus(struct bus_type *bus)
 {
-	struct notifier_block *nb;
+	notifier_block_no_const *nb;
 
 	if (dma_debug_disabled())
 		return;
@@ -1166,7 +1166,7 @@ static void check_unmap(struct dma_debug_entry *ref)
 
 static void check_for_stack(struct device *dev, void *addr)
 {
-	if (object_is_on_stack(addr))
+	if (object_starts_on_stack(addr))
 		err_printk(dev, NULL, "DMA-API: device driver maps memory from "
 				"stack [addr=%p]\n", addr);
 }
diff --git a/lib/inflate.c b/lib/inflate.c
index 013a76193..c28f3fcda 100644
--- a/lib/inflate.c
+++ b/lib/inflate.c
@@ -269,7 +269,7 @@ static void free(void *where)
 		malloc_ptr = free_mem_ptr;
 }
 #else
-#define malloc(a) kmalloc(a, GFP_KERNEL)
+#define malloc(a) kmalloc((a), GFP_KERNEL)
 #define free(a) kfree(a)
 #endif
 
diff --git a/lib/ioremap.c b/lib/ioremap.c
index 86c8911b0..f5bfc34c5 100644
--- a/lib/ioremap.c
+++ b/lib/ioremap.c
@@ -75,7 +75,7 @@ static inline int ioremap_pmd_range(pud_t *pud, unsigned long addr,
 	unsigned long next;
 
 	phys_addr -= addr;
-	pmd = pmd_alloc(&init_mm, pud, addr);
+	pmd = pmd_alloc_kernel(&init_mm, pud, addr);
 	if (!pmd)
 		return -ENOMEM;
 	do {
@@ -101,7 +101,7 @@ static inline int ioremap_pud_range(pgd_t *pgd, unsigned long addr,
 	unsigned long next;
 
 	phys_addr -= addr;
-	pud = pud_alloc(&init_mm, pgd, addr);
+	pud = pud_alloc_kernel(&init_mm, pgd, addr);
 	if (!pud)
 		return -ENOMEM;
 	do {
diff --git a/lib/irq_poll.c b/lib/irq_poll.c
index 836f7db4e..44d984992 100644
--- a/lib/irq_poll.c
+++ b/lib/irq_poll.c
@@ -74,7 +74,7 @@ void irq_poll_complete(struct irq_poll *iop)
 }
 EXPORT_SYMBOL(irq_poll_complete);
 
-static void irq_poll_softirq(struct softirq_action *h)
+static __latent_entropy void irq_poll_softirq(void)
 {
 	struct list_head *list = this_cpu_ptr(&blk_cpu_iopoll);
 	int rearm = 0, budget = irq_poll_budget;
diff --git a/lib/is_single_threaded.c b/lib/is_single_threaded.c
index 391fd2397..96e17b6e0 100644
--- a/lib/is_single_threaded.c
+++ b/lib/is_single_threaded.c
@@ -22,6 +22,9 @@ bool current_is_single_threaded(void)
 	struct task_struct *p, *t;
 	bool ret;
 
+	if (!mm)
+		return true;
+
 	if (atomic_read(&task->signal->live) != 1)
 		return false;
 
diff --git a/lib/kobject.c b/lib/kobject.c
index 445dcaeb0..cbfd25de8 100644
--- a/lib/kobject.c
+++ b/lib/kobject.c
@@ -955,9 +955,9 @@ EXPORT_SYMBOL_GPL(kset_create_and_add);
 
 
 static DEFINE_SPINLOCK(kobj_ns_type_lock);
-static const struct kobj_ns_type_operations *kobj_ns_ops_tbl[KOBJ_NS_TYPES];
+static const struct kobj_ns_type_operations *kobj_ns_ops_tbl[KOBJ_NS_TYPES] __read_only;
 
-int kobj_ns_type_register(const struct kobj_ns_type_operations *ops)
+int __init kobj_ns_type_register(const struct kobj_ns_type_operations *ops)
 {
 	enum kobj_ns_type type = ops->type;
 	int error;
diff --git a/lib/list_debug.c b/lib/list_debug.c
index 3859bf635..818741d6c 100644
--- a/lib/list_debug.c
+++ b/lib/list_debug.c
@@ -11,7 +11,9 @@
 #include <linux/bug.h>
 #include <linux/kernel.h>
 #include <linux/rculist.h>
+#include <linux/mm.h>
 
+#ifdef CONFIG_DEBUG_LIST
 /*
  * Insert a new entry between two known consecutive entries.
  *
@@ -19,21 +21,40 @@
  * the prev/next entries already!
  */
 
+static bool __list_add_debug(struct list_head *new,
+			     struct list_head *prev,
+			     struct list_head *next)
+{
+	if (unlikely(next->prev != prev)) {
+		printk(KERN_ERR "list_add corruption. next->prev should be "
+			"prev (%p), but was %p. (next=%p).\n",
+			prev, next->prev, next);
+		BUG();
+		return false;
+	}
+	if (unlikely(prev->next != next)) {
+		printk(KERN_ERR "list_add corruption. prev->next should be "
+			"next (%p), but was %p. (prev=%p).\n",
+			next, prev->next, prev);
+		BUG();
+		return false;
+	}
+	if (unlikely(new == prev || new == next)) {
+		printk(KERN_ERR "list_add double add: new=%p, prev=%p, next=%p.\n",
+			new, prev, next);
+		BUG();
+		return false;
+	}
+	return true;
+}
+
 void __list_add(struct list_head *new,
-			      struct list_head *prev,
-			      struct list_head *next)
+		struct list_head *prev,
+		struct list_head *next)
 {
-	WARN(next->prev != prev,
-		"list_add corruption. next->prev should be "
-		"prev (%p), but was %p. (next=%p).\n",
-		prev, next->prev, next);
-	WARN(prev->next != next,
-		"list_add corruption. prev->next should be "
-		"next (%p), but was %p. (prev=%p).\n",
-		next, prev->next, prev);
-	WARN(new == prev || new == next,
-	     "list_add double add: new=%p, prev=%p, next=%p.\n",
-	     new, prev, next);
+	if (!__list_add_debug(new, prev, next))
+		return;
+
 	next->prev = new;
 	new->next = next;
 	new->prev = prev;
@@ -41,28 +62,46 @@ void __list_add(struct list_head *new,
 }
 EXPORT_SYMBOL(__list_add);
 
-void __list_del_entry(struct list_head *entry)
+static bool __list_del_entry_debug(struct list_head *entry)
 {
 	struct list_head *prev, *next;
 
 	prev = entry->prev;
 	next = entry->next;
 
-	if (WARN(next == LIST_POISON1,
-		"list_del corruption, %p->next is LIST_POISON1 (%p)\n",
-		entry, LIST_POISON1) ||
-	    WARN(prev == LIST_POISON2,
-		"list_del corruption, %p->prev is LIST_POISON2 (%p)\n",
-		entry, LIST_POISON2) ||
-	    WARN(prev->next != entry,
-		"list_del corruption. prev->next should be %p, "
-		"but was %p\n", entry, prev->next) ||
-	    WARN(next->prev != entry,
-		"list_del corruption. next->prev should be %p, "
-		"but was %p\n", entry, next->prev))
+	if (unlikely(next == LIST_POISON1)) {
+		printk(KERN_ERR "list_del corruption, %p->next is LIST_POISON1 (%p)\n",
+			entry, LIST_POISON1);
+		BUG();
+		return false;
+	}
+	if (unlikely(prev == LIST_POISON2)) {
+		printk(KERN_ERR "list_del corruption, %p->prev is LIST_POISON2 (%p)\n",
+			entry, LIST_POISON2);
+		BUG();
+		return false;
+	}
+	if (unlikely(entry->prev->next != entry)) {
+		printk(KERN_ERR "list_del corruption. prev->next should be %p, "
+			"but was %p\n", entry, prev->next);
+		BUG();
+		return false;
+	}
+	if (unlikely(entry->next->prev != entry)) {
+		printk(KERN_ERR "list_del corruption. next->prev should be %p, "
+			"but was %p\n", entry, next->prev);
+		BUG();
+		return false;
+	}
+	return true;
+}
+
+void __list_del_entry(struct list_head *entry)
+{
+	if (!__list_del_entry_debug(entry))
 		return;
 
-	__list_del(prev, next);
+	__list_del(entry->prev, entry->next);
 }
 EXPORT_SYMBOL(__list_del_entry);
 
@@ -86,15 +125,85 @@ EXPORT_SYMBOL(list_del);
 void __list_add_rcu(struct list_head *new,
 		    struct list_head *prev, struct list_head *next)
 {
-	WARN(next->prev != prev,
-		"list_add_rcu corruption. next->prev should be prev (%p), but was %p. (next=%p).\n",
-		prev, next->prev, next);
-	WARN(prev->next != next,
-		"list_add_rcu corruption. prev->next should be next (%p), but was %p. (prev=%p).\n",
-		next, prev->next, prev);
+	if (!__list_add_debug(new, prev, next))
+		return;
+
 	new->next = next;
 	new->prev = prev;
 	rcu_assign_pointer(list_next_rcu(prev), new);
 	next->prev = new;
 }
 EXPORT_SYMBOL(__list_add_rcu);
+#endif
+
+void __pax_list_add(struct list_head *new, struct list_head *prev, struct list_head *next)
+{
+#ifdef CONFIG_DEBUG_LIST
+	if (!__list_add_debug(new, prev, next))
+		return;
+#endif
+
+	pax_open_kernel();
+	next->prev = new;
+	new->next = next;
+	new->prev = prev;
+	prev->next = new;
+	pax_close_kernel();
+}
+EXPORT_SYMBOL(__pax_list_add);
+
+void pax_list_del(struct list_head *entry)
+{
+#ifdef CONFIG_DEBUG_LIST
+	if (!__list_del_entry_debug(entry))
+		return;
+#endif
+
+	pax_open_kernel();
+	__list_del(entry->prev, entry->next);
+	entry->next = LIST_POISON1;
+	entry->prev = LIST_POISON2;
+	pax_close_kernel();
+}
+EXPORT_SYMBOL(pax_list_del);
+
+void pax_list_del_init(struct list_head *entry)
+{
+	pax_open_kernel();
+	__list_del(entry->prev, entry->next);
+	INIT_LIST_HEAD(entry);
+	pax_close_kernel();
+}
+EXPORT_SYMBOL(pax_list_del_init);
+
+void __pax_list_add_rcu(struct list_head *new,
+			struct list_head *prev, struct list_head *next)
+{
+#ifdef CONFIG_DEBUG_LIST
+	if (!__list_add_debug(new, prev, next))
+		return;
+#endif
+
+	pax_open_kernel();
+	new->next = next;
+	new->prev = prev;
+	rcu_assign_pointer(list_next_rcu(prev), new);
+	next->prev = new;
+	pax_close_kernel();
+}
+EXPORT_SYMBOL(__pax_list_add_rcu);
+
+void pax_list_del_rcu(struct list_head *entry)
+{
+#ifdef CONFIG_DEBUG_LIST
+	if (!__list_del_entry_debug(entry))
+		return;
+#endif
+
+	pax_open_kernel();
+	__list_del(entry->prev, entry->next);
+	entry->next = LIST_POISON1;
+	entry->prev = LIST_POISON2;
+	pax_close_kernel();
+}
+EXPORT_SYMBOL(pax_list_del_rcu);
diff --git a/lib/llist.c b/lib/llist.c
index ae5872b1d..63a969863 100644
--- a/lib/llist.c
+++ b/lib/llist.c
@@ -25,6 +25,7 @@
 #include <linux/kernel.h>
 #include <linux/export.h>
 #include <linux/llist.h>
+#include <linux/mm.h>
 
 
 /**
@@ -48,6 +49,22 @@ bool llist_add_batch(struct llist_node *new_first, struct llist_node *new_last,
 }
 EXPORT_SYMBOL_GPL(llist_add_batch);
 
+bool pax_llist_add_batch(struct llist_node *new_first, struct llist_node *new_last,
+			 struct llist_head *head)
+{
+	struct llist_node *first;
+
+	do {
+		first = ACCESS_ONCE(head->first);
+		pax_open_kernel();
+		new_last->next = first;
+		pax_close_kernel();
+	} while (cmpxchg(&head->first, first, new_first) != first);
+
+	return !first;
+}
+EXPORT_SYMBOL_GPL(pax_llist_add_batch);
+
 /**
  * llist_del_first - delete the first entry of lock-less list
  * @head:	the head for your lock-less list
diff --git a/lib/lockref.c b/lib/lockref.c
index 5a92189ad..d77978d1c 100644
--- a/lib/lockref.c
+++ b/lib/lockref.c
@@ -40,13 +40,13 @@
 void lockref_get(struct lockref *lockref)
 {
 	CMPXCHG_LOOP(
-		new.count++;
+		__lockref_inc(&new);
 	,
 		return;
 	);
 
 	spin_lock(&lockref->lock);
-	lockref->count++;
+	__lockref_inc(lockref);
 	spin_unlock(&lockref->lock);
 }
 EXPORT_SYMBOL(lockref_get);
@@ -61,8 +61,8 @@ int lockref_get_not_zero(struct lockref *lockref)
 	int retval;
 
 	CMPXCHG_LOOP(
-		new.count++;
-		if (old.count <= 0)
+		__lockref_inc(&new);
+		if (__lockref_read(&old) <= 0)
 			return 0;
 	,
 		return 1;
@@ -70,8 +70,8 @@ int lockref_get_not_zero(struct lockref *lockref)
 
 	spin_lock(&lockref->lock);
 	retval = 0;
-	if (lockref->count > 0) {
-		lockref->count++;
+	if (__lockref_read(lockref) > 0) {
+		__lockref_inc(lockref);
 		retval = 1;
 	}
 	spin_unlock(&lockref->lock);
@@ -88,17 +88,17 @@ EXPORT_SYMBOL(lockref_get_not_zero);
 int lockref_get_or_lock(struct lockref *lockref)
 {
 	CMPXCHG_LOOP(
-		new.count++;
-		if (old.count <= 0)
+		__lockref_inc(&new);
+		if (__lockref_read(&old) <= 0)
 			break;
 	,
 		return 1;
 	);
 
 	spin_lock(&lockref->lock);
-	if (lockref->count <= 0)
+	if (__lockref_read(lockref) <= 0)
 		return 0;
-	lockref->count++;
+	__lockref_inc(lockref);
 	spin_unlock(&lockref->lock);
 	return 1;
 }
@@ -114,11 +114,11 @@ EXPORT_SYMBOL(lockref_get_or_lock);
 int lockref_put_return(struct lockref *lockref)
 {
 	CMPXCHG_LOOP(
-		new.count--;
-		if (old.count <= 0)
+		__lockref_dec(&new);
+		if (__lockref_read(&old) <= 0)
 			return -1;
 	,
-		return new.count;
+		return __lockref_read(&new);
 	);
 	return -1;
 }
@@ -132,17 +132,17 @@ EXPORT_SYMBOL(lockref_put_return);
 int lockref_put_or_lock(struct lockref *lockref)
 {
 	CMPXCHG_LOOP(
-		new.count--;
-		if (old.count <= 1)
+		__lockref_dec(&new);
+		if (__lockref_read(&old) <= 1)
 			break;
 	,
 		return 1;
 	);
 
 	spin_lock(&lockref->lock);
-	if (lockref->count <= 1)
+	if (__lockref_read(lockref) <= 1)
 		return 0;
-	lockref->count--;
+	__lockref_dec(lockref);
 	spin_unlock(&lockref->lock);
 	return 1;
 }
@@ -155,7 +155,7 @@ EXPORT_SYMBOL(lockref_put_or_lock);
 void lockref_mark_dead(struct lockref *lockref)
 {
 	assert_spin_locked(&lockref->lock);
-	lockref->count = -128;
+	__lockref_set(lockref, -128);
 }
 EXPORT_SYMBOL(lockref_mark_dead);
 
@@ -169,8 +169,8 @@ int lockref_get_not_dead(struct lockref *lockref)
 	int retval;
 
 	CMPXCHG_LOOP(
-		new.count++;
-		if (old.count < 0)
+		__lockref_inc(&new);
+		if (__lockref_read(&old) < 0)
 			return 0;
 	,
 		return 1;
@@ -178,8 +178,8 @@ int lockref_get_not_dead(struct lockref *lockref)
 
 	spin_lock(&lockref->lock);
 	retval = 0;
-	if (lockref->count >= 0) {
-		lockref->count++;
+	if (__lockref_read(lockref) >= 0) {
+		__lockref_inc(lockref);
 		retval = 1;
 	}
 	spin_unlock(&lockref->lock);
diff --git a/lib/nlattr.c b/lib/nlattr.c
index fce1e9afc..d44559b80 100644
--- a/lib/nlattr.c
+++ b/lib/nlattr.c
@@ -278,6 +278,8 @@ int nla_memcpy(void *dest, const struct nlattr *src, int count)
 {
 	int minlen = min_t(int, count, nla_len(src));
 
+	BUG_ON(minlen < 0);
+
 	memcpy(dest, nla_data(src), minlen);
 	if (count > minlen)
 		memset(dest + minlen, 0, count - minlen);
diff --git a/lib/percpu-refcount.c b/lib/percpu-refcount.c
index 27fe74948..2c0e8554b 100644
--- a/lib/percpu-refcount.c
+++ b/lib/percpu-refcount.c
@@ -31,7 +31,7 @@
  * atomic_long_t can't hit 0 before we've added up all the percpu refs.
  */
 
-#define PERCPU_COUNT_BIAS	(1LU << (BITS_PER_LONG - 1))
+#define PERCPU_COUNT_BIAS	(1LU << (BITS_PER_LONG - 2))
 
 static DECLARE_WAIT_QUEUE_HEAD(percpu_ref_switch_waitq);
 
diff --git a/lib/radix-tree.c b/lib/radix-tree.c
index 8e6d552c4..3b33b84e4 100644
--- a/lib/radix-tree.c
+++ b/lib/radix-tree.c
@@ -67,7 +67,7 @@ struct radix_tree_preload {
 	/* nodes->private_data points to next preallocated node */
 	struct radix_tree_node *nodes;
 };
-static DEFINE_PER_CPU(struct radix_tree_preload, radix_tree_preloads) = { 0, };
+static DEFINE_PER_CPU(struct radix_tree_preload, radix_tree_preloads);
 
 static inline void *node_to_entry(void *ptr)
 {
diff --git a/lib/random32.c b/lib/random32.c
index 69ed593aa..a30923573 100644
--- a/lib/random32.c
+++ b/lib/random32.c
@@ -47,7 +47,7 @@ static inline void prandom_state_selftest(void)
 }
 #endif
 
-static DEFINE_PER_CPU(struct rnd_state, net_rand_state);
+static DEFINE_PER_CPU(struct rnd_state, net_rand_state) __latent_entropy;
 
 /**
  *	prandom_u32_state - seeded pseudo-random number generator.
diff --git a/lib/rbtree.c b/lib/rbtree.c
index eb8a19fee..3cb9b612a 100644
--- a/lib/rbtree.c
+++ b/lib/rbtree.c
@@ -412,7 +412,9 @@ static inline void dummy_copy(struct rb_node *old, struct rb_node *new) {}
 static inline void dummy_rotate(struct rb_node *old, struct rb_node *new) {}
 
 static const struct rb_augment_callbacks dummy_callbacks = {
-	dummy_propagate, dummy_copy, dummy_rotate
+	.propagate = dummy_propagate,
+	.copy = dummy_copy,
+	.rotate = dummy_rotate
 };
 
 void rb_insert_color(struct rb_node *node, struct rb_root *root)
diff --git a/lib/rhashtable.c b/lib/rhashtable.c
index 56054e541..dd1cdc492 100644
--- a/lib/rhashtable.c
+++ b/lib/rhashtable.c
@@ -563,8 +563,8 @@ EXPORT_SYMBOL_GPL(rhashtable_walk_exit);
  * will rewind back to the beginning and you may use it immediately
  * by calling rhashtable_walk_next.
  */
+int rhashtable_walk_start(struct rhashtable_iter *iter) __acquires(RCU);
 int rhashtable_walk_start(struct rhashtable_iter *iter)
-	__acquires(RCU)
 {
 	struct rhashtable *ht = iter->ht;
 
@@ -648,8 +648,8 @@ EXPORT_SYMBOL_GPL(rhashtable_walk_next);
  *
  * Finish a hash table walk.
  */
+void rhashtable_walk_stop(struct rhashtable_iter *iter) __releases(RCU);
 void rhashtable_walk_stop(struct rhashtable_iter *iter)
-	__releases(RCU)
 {
 	struct rhashtable *ht;
 	struct bucket_table *tbl = iter->walker->tbl;
diff --git a/lib/seq_buf.c b/lib/seq_buf.c
index cb18469e1..20ac51125 100644
--- a/lib/seq_buf.c
+++ b/lib/seq_buf.c
@@ -259,7 +259,7 @@ int seq_buf_putmem_hex(struct seq_buf *s, const void *mem,
  */
 int seq_buf_path(struct seq_buf *s, const struct path *path, const char *esc)
 {
-	char *buf;
+	unsigned char *buf;
 	size_t size = seq_buf_get_buf(s, &buf);
 	int res = -1;
 
@@ -268,7 +268,7 @@ int seq_buf_path(struct seq_buf *s, const struct path *path, const char *esc)
 	if (size) {
 		char *p = d_path(path, buf, size);
 		if (!IS_ERR(p)) {
-			char *end = mangle_path(buf, p, esc);
+			unsigned char *end = mangle_path(buf, p, esc);
 			if (end)
 				res = end - buf;
 		}
diff --git a/lib/show_mem.c b/lib/show_mem.c
index 1feed6a2b..4ede1e979 100644
--- a/lib/show_mem.c
+++ b/lib/show_mem.c
@@ -47,6 +47,6 @@ void show_mem(unsigned int filter)
 		quicklist_total_size());
 #endif
 #ifdef CONFIG_MEMORY_FAILURE
-	printk("%lu pages hwpoisoned\n", atomic_long_read(&num_poisoned_pages));
+	printk("%lu pages hwpoisoned\n", atomic_long_read_unchecked(&num_poisoned_pages));
 #endif
 }
diff --git a/lib/strncpy_from_user.c b/lib/strncpy_from_user.c
index 9c5fe8110..00657ec78 100644
--- a/lib/strncpy_from_user.c
+++ b/lib/strncpy_from_user.c
@@ -23,7 +23,7 @@
  */
 static inline long do_strncpy_from_user(char *dst, const char __user *src, long count, unsigned long max)
 {
-	const struct word_at_a_time constants = WORD_AT_A_TIME_CONSTANTS;
+	static const struct word_at_a_time constants = WORD_AT_A_TIME_CONSTANTS;
 	long res = 0;
 
 	/*
diff --git a/lib/strnlen_user.c b/lib/strnlen_user.c
index 8e105ed4d..eefbbf996 100644
--- a/lib/strnlen_user.c
+++ b/lib/strnlen_user.c
@@ -26,7 +26,7 @@
  */
 static inline long do_strnlen_user(const char __user *src, unsigned long count, unsigned long max)
 {
-	const struct word_at_a_time constants = WORD_AT_A_TIME_CONSTANTS;
+	static const struct word_at_a_time constants = WORD_AT_A_TIME_CONSTANTS;
 	long align, res = 0;
 	unsigned long c;
 
diff --git a/lib/vsprintf.c b/lib/vsprintf.c
index 0967771d8..2871684ad 100644
--- a/lib/vsprintf.c
+++ b/lib/vsprintf.c
@@ -16,6 +16,9 @@
  * - scnprintf and vscnprintf
  */
 
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+#define __INCLUDED_BY_HIDESYM 1
+#endif
 #include <stdarg.h>
 #include <linux/clk.h>
 #include <linux/clk-provider.h>
@@ -118,7 +121,7 @@ long long simple_strtoll(const char *cp, char **endp, unsigned int base)
 }
 EXPORT_SYMBOL(simple_strtoll);
 
-static noinline_for_stack
+static noinline_for_stack __nocapture(1) __unverified_nocapture(1)
 int skip_atoi(const char **s)
 {
 	int i = 0;
@@ -680,7 +683,7 @@ char *symbol_string(char *buf, char *end, void *ptr,
 #ifdef CONFIG_KALLSYMS
 	if (*fmt == 'B')
 		sprint_backtrace(sym, value);
-	else if (*fmt != 'f' && *fmt != 's')
+	else if (*fmt != 'f' && *fmt != 's' && *fmt != 'X')
 		sprint_symbol(sym, value);
 	else
 		sprint_symbol_no_offset(sym, value);
@@ -1470,7 +1473,11 @@ char *flags_string(char *buf, char *end, void *flags_ptr, const char *fmt)
 	return format_flags(buf, end, flags, names);
 }
 
-int kptr_restrict __read_mostly;
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+int kptr_restrict __read_only = 1;
+#else
+int kptr_restrict __read_only;
+#endif
 
 /*
  * Show a '%p' thing.  A kernel extension is that the '%p' is followed
@@ -1481,8 +1488,10 @@ int kptr_restrict __read_mostly;
  *
  * - 'F' For symbolic function descriptor pointers with offset
  * - 'f' For simple symbolic function names without offset
+ * - 'X' For simple symbolic function names without offset approved for use with GRKERNSEC_HIDESYM
  * - 'S' For symbolic direct pointers with offset
  * - 's' For symbolic direct pointers without offset
+ * - 'A' For symbolic direct pointers with offset approved for use with GRKERNSEC_HIDESYM
  * - '[FfSs]R' as above with __builtin_extract_return_addr() translation
  * - 'B' For backtraced symbolic direct pointers with offset
  * - 'R' For decoded struct resource, e.g., [mem 0x0-0x1f 64bit pref]
@@ -1570,7 +1579,7 @@ int kptr_restrict __read_mostly;
  * function pointers are really function descriptors, which contain a
  * pointer to the real address.
  */
-static noinline_for_stack
+static noinline_for_stack __nocapture(1) __unverified_nocapture(1)
 char *pointer(const char *fmt, char *buf, char *end, void *ptr,
 	      struct printf_spec spec)
 {
@@ -1578,12 +1587,12 @@ char *pointer(const char *fmt, char *buf, char *end, void *ptr,
 
 	if (!ptr && *fmt != 'K') {
 		/*
-		 * Print (null) with the same width as a pointer so it makes
+		 * Print (nil) with the same width as a pointer so it makes
 		 * tabular output look nice.
 		 */
 		if (spec.field_width == -1)
 			spec.field_width = default_width;
-		return string(buf, end, "(null)", spec);
+		return string(buf, end, "(nil)", spec);
 	}
 
 	switch (*fmt) {
@@ -1593,6 +1602,14 @@ char *pointer(const char *fmt, char *buf, char *end, void *ptr,
 		/* Fallthrough */
 	case 'S':
 	case 's':
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+		break;
+#else
+		return symbol_string(buf, end, ptr, spec, fmt);
+#endif
+	case 'X':
+		ptr = dereference_function_descriptor(ptr);
+	case 'A':
 	case 'B':
 		return symbol_string(buf, end, ptr, spec, fmt);
 	case 'R':
@@ -1657,6 +1674,8 @@ char *pointer(const char *fmt, char *buf, char *end, void *ptr,
 			va_end(va);
 			return buf;
 		}
+	case 'P':
+		break;
 	case 'K':
 		switch (kptr_restrict) {
 		case 0:
@@ -1686,6 +1705,9 @@ char *pointer(const char *fmt, char *buf, char *end, void *ptr,
 			 */
 			cred = current_cred();
 			if (!has_capability_noaudit(current, CAP_SYSLOG) ||
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+			    !has_capability_noaudit(current, CAP_SYS_ADMIN) ||
+#endif
 			    !uid_eq(cred->euid, cred->uid) ||
 			    !gid_eq(cred->egid, cred->gid))
 				ptr = NULL;
@@ -1719,6 +1741,22 @@ char *pointer(const char *fmt, char *buf, char *end, void *ptr,
 	case 'G':
 		return flags_string(buf, end, ptr, fmt);
 	}
+
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	/* 'P' = approved pointers to copy to userland,
+	   as in the /proc/kallsyms case, as we make it display nothing
+	   for non-root users, and the real contents for root users
+	   'X' = approved simple symbols
+	   Also ignore 'K' pointers, since we force their NULLing for non-root users
+	   above
+	*/
+	if ((unsigned long)ptr > TASK_SIZE && *fmt != 'P' && *fmt != 'X' && *fmt != 'K' && is_usercopy_object(buf)) {
+		printk(KERN_ALERT "grsec: kernel infoleak detected!  Please report this log to spender@grsecurity.net.\n");
+		dump_stack();
+		ptr = NULL;
+	}
+#endif
+
 	spec.flags |= SMALL;
 	if (spec.field_width == -1) {
 		spec.field_width = default_width;
@@ -1749,7 +1787,7 @@ char *pointer(const char *fmt, char *buf, char *end, void *ptr,
  * @precision: precision of a number
  * @qualifier: qualifier of a number (long, size_t, ...)
  */
-static noinline_for_stack
+static noinline_for_stack __nocapture(1)
 int format_decode(const char *fmt, struct printf_spec *spec)
 {
 	const char *start = fmt;
@@ -2419,11 +2457,11 @@ int bstr_printf(char *buf, size_t size, const char *fmt, const u32 *bin_buf)
 	typeof(type) value;						\
 	if (sizeof(type) == 8) {					\
 		args = PTR_ALIGN(args, sizeof(u32));			\
-		*(u32 *)&value = *(u32 *)args;				\
-		*((u32 *)&value + 1) = *(u32 *)(args + 4);		\
+		*(u32 *)&value = *(const u32 *)args;			\
+		*((u32 *)&value + 1) = *(const u32 *)(args + 4);	\
 	} else {							\
 		args = PTR_ALIGN(args, sizeof(type));			\
-		value = *(typeof(type) *)args;				\
+		value = *(const typeof(type) *)args;			\
 	}								\
 	args += sizeof(type);						\
 	value;								\
@@ -2486,7 +2524,7 @@ int bstr_printf(char *buf, size_t size, const char *fmt, const u32 *bin_buf)
 		case FORMAT_TYPE_STR: {
 			const char *str_arg = args;
 			args += strlen(str_arg) + 1;
-			str = string(str, end, (char *)str_arg, spec);
+			str = string(str, end, str_arg, spec);
 			break;
 		}
 
diff --git b/localversion-grsec b/localversion-grsec
new file mode 100644
index 000000000..7cd6065be
--- /dev/null
+++ b/localversion-grsec
@@ -0,0 +1 @@
+-grsec
diff --git a/mm/Kconfig b/mm/Kconfig
index be0ee11fa..8e98a9577 100644
--- a/mm/Kconfig
+++ b/mm/Kconfig
@@ -342,10 +342,11 @@ config KSM
 	  root has set /sys/kernel/mm/ksm/run to 1 (if CONFIG_SYSFS is set).
 
 config DEFAULT_MMAP_MIN_ADDR
-        int "Low address space to protect from user allocation"
+	int "Low address space to protect from user allocation"
 	depends on MMU
-        default 4096
-        help
+	default 32768 if ALPHA || ARM || PARISC || SPARC32
+	default 65536
+	help
 	  This is the portion of low virtual memory which should be protected
 	  from userspace allocation.  Keeping a user from writing to low pages
 	  can help reduce the impact of kernel NULL pointer bugs.
@@ -377,8 +378,9 @@ config MEMORY_FAILURE
 
 config HWPOISON_INJECT
 	tristate "HWPoison pages injector"
-	depends on MEMORY_FAILURE && DEBUG_KERNEL && PROC_FS
+	depends on MEMORY_FAILURE && DEBUG_KERNEL && PROC_FS && !GRKERNSEC
 	select PROC_PAGE_MONITOR
+	depends on !GRKERNSEC
 
 config NOMMU_INITIAL_TRIM_EXCESS
 	int "Turn on mmap() excess space trimming before booting"
@@ -548,6 +550,7 @@ config MEM_SOFT_DIRTY
 	bool "Track memory changes"
 	depends on CHECKPOINT_RESTORE && HAVE_ARCH_SOFT_DIRTY && PROC_FS
 	select PROC_PAGE_MONITOR
+	depends on !GRKERNSEC
 	help
 	  This option enables memory changes tracking by introducing a
 	  soft-dirty bit on pte-s. This bit it set when someone writes
@@ -632,6 +635,7 @@ config ZSMALLOC_STAT
 	bool "Export zsmalloc statistics"
 	depends on ZSMALLOC
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	help
 	  This option enables code in the zsmalloc to collect various
 	  statistics about whats happening in zsmalloc and exports that
diff --git a/mm/Kconfig.debug b/mm/Kconfig.debug
index 22f4cd96a..ed3f09775 100644
--- a/mm/Kconfig.debug
+++ b/mm/Kconfig.debug
@@ -10,6 +10,7 @@ config PAGE_EXTENSION
 config DEBUG_PAGEALLOC
 	bool "Debug page memory allocations"
 	depends on DEBUG_KERNEL
+	depends on !PAX_MEMORY_SANITIZE
 	depends on !HIBERNATION || ARCH_SUPPORTS_DEBUG_PAGEALLOC && !PPC && !SPARC
 	depends on !KMEMCHECK
 	select PAGE_EXTENSION
@@ -76,8 +77,6 @@ config PAGE_POISONING_ZERO
 	   no longer necessary to write zeros when GFP_ZERO is used on
 	   allocation.
 
-	   Enabling page poisoning with this option will disable hibernation
-
 	   If unsure, say N
 	bool
 
diff --git a/mm/backing-dev.c b/mm/backing-dev.c
index 8fde443f3..a8cc38107 100644
--- a/mm/backing-dev.c
+++ b/mm/backing-dev.c
@@ -12,7 +12,7 @@
 #include <linux/device.h>
 #include <trace/events/writeback.h>
 
-static atomic_long_t bdi_seq = ATOMIC_LONG_INIT(0);
+static atomic_long_unchecked_t bdi_seq = ATOMIC_LONG_INIT(0);
 
 struct backing_dev_info noop_backing_dev_info = {
 	.name		= "noop",
@@ -898,7 +898,7 @@ int bdi_setup_and_register(struct backing_dev_info *bdi, char *name)
 		return err;
 
 	err = bdi_register(bdi, NULL, "%.28s-%ld", name,
-			   atomic_long_inc_return(&bdi_seq));
+			   atomic_long_inc_return_unchecked(&bdi_seq));
 	if (err) {
 		bdi_destroy(bdi);
 		return err;
diff --git a/mm/fadvise.c b/mm/fadvise.c
index 6c707bfe0..c8d0529b0 100644
--- a/mm/fadvise.c
+++ b/mm/fadvise.c
@@ -165,7 +165,7 @@ out:
 
 #ifdef __ARCH_WANT_SYS_FADVISE64
 
-SYSCALL_DEFINE4(fadvise64, int, fd, loff_t, offset, size_t, len, int, advice)
+SYSCALL_DEFINE4(fadvise64, int, fd, loff_t, offset, loff_t, len, int, advice)
 {
 	return sys_fadvise64_64(fd, offset, len, advice);
 }
diff --git a/mm/filemap.c b/mm/filemap.c
index f1da48d1f..b3151bf9a 100644
--- a/mm/filemap.c
+++ b/mm/filemap.c
@@ -2334,7 +2334,7 @@ int generic_file_mmap(struct file * file, struct vm_area_struct * vma)
 	struct address_space *mapping = file->f_mapping;
 
 	if (!mapping->a_ops->readpage)
-		return -ENOEXEC;
+		return -ENODEV;
 	file_accessed(file);
 	vma->vm_ops = &generic_file_vm_ops;
 	return 0;
@@ -2377,7 +2377,7 @@ static struct page *wait_on_page_read(struct page *page)
 
 static struct page *do_read_cache_page(struct address_space *mapping,
 				pgoff_t index,
-				int (*filler)(void *, struct page *),
+				filler_t *filler,
 				void *data,
 				gfp_t gfp)
 {
@@ -2484,7 +2484,7 @@ out:
  */
 struct page *read_cache_page(struct address_space *mapping,
 				pgoff_t index,
-				int (*filler)(void *, struct page *),
+				filler_t *filler,
 				void *data)
 {
 	return do_read_cache_page(mapping, index, filler, data, mapping_gfp_mask(mapping));
@@ -2506,7 +2506,7 @@ struct page *read_cache_page_gfp(struct address_space *mapping,
 				pgoff_t index,
 				gfp_t gfp)
 {
-	filler_t *filler = (filler_t *)mapping->a_ops->readpage;
+	filler_t *filler = mapping->a_ops->readpage;
 
 	return do_read_cache_page(mapping, index, filler, NULL, gfp);
 }
@@ -2536,6 +2536,7 @@ inline ssize_t generic_write_checks(struct kiocb *iocb, struct iov_iter *from)
 	pos = iocb->ki_pos;
 
 	if (limit != RLIM_INFINITY) {
+		gr_learn_resource(current, RLIMIT_FSIZE, iocb->ki_pos, 0);
 		if (iocb->ki_pos >= limit) {
 			send_sig(SIGXFSZ, current, 0);
 			return -EFBIG;
diff --git a/mm/gup.c b/mm/gup.c
index 22cc22e74..361d4568c 100644
--- a/mm/gup.c
+++ b/mm/gup.c
@@ -370,11 +370,6 @@ static int faultin_page(struct task_struct *tsk, struct vm_area_struct *vma,
 	/* mlock all present pages, but do not fault in new pages */
 	if ((*flags & (FOLL_POPULATE | FOLL_MLOCK)) == FOLL_MLOCK)
 		return -ENOENT;
-	/* For mm_populate(), just skip the stack guard page. */
-	if ((*flags & FOLL_POPULATE) &&
-			(stack_guard_page_start(vma, address) ||
-			 stack_guard_page_end(vma, address + PAGE_SIZE)))
-		return -ENOENT;
 	if (*flags & FOLL_WRITE)
 		fault_flags |= FAULT_FLAG_WRITE;
 	if (*flags & FOLL_REMOTE)
@@ -548,14 +543,14 @@ long __get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
 	if (!(gup_flags & FOLL_FORCE))
 		gup_flags |= FOLL_NUMA;
 
-	do {
+	while (nr_pages) {
 		struct page *page;
 		unsigned int foll_flags = gup_flags;
 		unsigned int page_increm;
 
 		/* first iteration or cross vma bound */
 		if (!vma || start >= vma->vm_end) {
-			vma = find_extend_vma(mm, start);
+			vma = find_vma(mm, start);
 			if (!vma && in_gate_area(mm, start)) {
 				int ret;
 				ret = get_gate_page(mm, start & PAGE_MASK,
@@ -567,7 +562,7 @@ long __get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
 				goto next_page;
 			}
 
-			if (!vma || check_vma_flags(vma, gup_flags))
+			if (!vma || start < vma->vm_start || check_vma_flags(vma, gup_flags))
 				return i ? : -EFAULT;
 			if (is_vm_hugetlb_page(vma)) {
 				i = follow_hugetlb_page(mm, vma, pages, vmas,
@@ -628,7 +623,7 @@ next_page:
 		i += page_increm;
 		start += page_increm * PAGE_SIZE;
 		nr_pages -= page_increm;
-	} while (nr_pages);
+	}
 	return i;
 }
 EXPORT_SYMBOL(__get_user_pages);
diff --git a/mm/highmem.c b/mm/highmem.c
index 50b4ca678..cf64608f2 100644
--- a/mm/highmem.c
+++ b/mm/highmem.c
@@ -191,8 +191,9 @@ static void flush_all_zero_pkmaps(void)
 		 * So no dangers, even with speculative execution.
 		 */
 		page = pte_page(pkmap_page_table[i]);
+		pax_open_kernel();
 		pte_clear(&init_mm, PKMAP_ADDR(i), &pkmap_page_table[i]);
-
+		pax_close_kernel();
 		set_page_address(page, NULL);
 		need_flush = 1;
 	}
@@ -255,8 +256,11 @@ start:
 		}
 	}
 	vaddr = PKMAP_ADDR(last_pkmap_nr);
+
+	pax_open_kernel();
 	set_pte_at(&init_mm, vaddr,
 		   &(pkmap_page_table[last_pkmap_nr]), mk_pte(page, kmap_prot));
+	pax_close_kernel();
 
 	pkmap_count[last_pkmap_nr] = 1;
 	set_page_address(page, (void *)vaddr);
diff --git a/mm/hugetlb.c b/mm/hugetlb.c
index 0ddce6a1c..3f23c4f80 100644
--- a/mm/hugetlb.c
+++ b/mm/hugetlb.c
@@ -38,7 +38,72 @@ int hugepages_treat_as_movable;
 
 int hugetlb_max_hstate __read_mostly;
 unsigned int default_hstate_idx;
-struct hstate hstates[HUGE_MAX_HSTATE];
+
+#ifdef CONFIG_CGROUP_HUGETLB
+static struct cftype hugetlb_files[HUGE_MAX_HSTATE][5] = {
+# define MEMFILE_PRIVATE(x, val)	(((x) << 16) | (val))
+# define CFTYPE_INIT(idx) \
+	{ /* Add the limit file */					\
+	  [0] = { .private = MEMFILE_PRIVATE(idx, RES_LIMIT),		\
+		  .read_u64 = hugetlb_cgroup_read_u64,			\
+		  .write = hugetlb_cgroup_write, },			\
+	  /* Add the usage file */					\
+	  [1] = { .private = MEMFILE_PRIVATE(idx, RES_USAGE),		\
+		  .read_u64 = hugetlb_cgroup_read_u64, },		\
+	  /* Add the MAX usage file */					\
+	  [2] = { .private = MEMFILE_PRIVATE(idx, RES_MAX_USAGE),	\
+		  .write = hugetlb_cgroup_reset,			\
+		  .read_u64 = hugetlb_cgroup_read_u64, },		\
+	  /* Add the failcntfile */					\
+	  [3] = { .private = MEMFILE_PRIVATE(idx, RES_FAILCNT),		\
+		  .write = hugetlb_cgroup_reset,			\
+		  .read_u64 = hugetlb_cgroup_read_u64, },		\
+	  [4] = { /* NULL terminator */ },				\
+	}
+
+# if HUGE_MAX_HSTATE > 0
+	[0] = CFTYPE_INIT(0),
+# endif
+# if HUGE_MAX_HSTATE > 1
+	[1] = CFTYPE_INIT(1),
+# endif
+# if HUGE_MAX_HSTATE > 2
+	[2] = CFTYPE_INIT(2),
+# endif
+# if HUGE_MAX_HSTATE > 3
+	[3] = CFTYPE_INIT(3),
+# endif
+# if HUGE_MAX_HSTATE > 4
+#  error PaX: add more initializers...
+# endif
+
+# undef CFTYPE_INIT
+};
+#endif
+
+struct hstate hstates[HUGE_MAX_HSTATE] = {
+#ifdef CONFIG_CGROUP_HUGETLB
+# define HSTATE_INIT(idx) [idx] = { .cgroup_files = &hugetlb_files[idx] }
+
+# if HUGE_MAX_HSTATE > 0
+	HSTATE_INIT(0),
+# endif
+# if HUGE_MAX_HSTATE > 1
+	HSTATE_INIT(1),
+# endif
+# if HUGE_MAX_HSTATE > 2
+	HSTATE_INIT(2),
+# endif
+# if HUGE_MAX_HSTATE > 3
+	HSTATE_INIT(3),
+# endif
+# if HUGE_MAX_HSTATE > 4
+#  error PaX: add more initializers...
+# endif
+
+# undef HSTATE_INIT
+#endif
+};
 /*
  * Minimum page order among possible hugepage sizes, set to a proper value
  * at boot time.
@@ -2894,6 +2959,7 @@ static int hugetlb_sysctl_handler_common(bool obey_mempolicy,
 			 struct ctl_table *table, int write,
 			 void __user *buffer, size_t *length, loff_t *ppos)
 {
+	ctl_table_no_const t;
 	struct hstate *h = &default_hstate;
 	unsigned long tmp = h->max_huge_pages;
 	int ret;
@@ -2901,9 +2967,10 @@ static int hugetlb_sysctl_handler_common(bool obey_mempolicy,
 	if (!hugepages_supported())
 		return -EOPNOTSUPP;
 
-	table->data = &tmp;
-	table->maxlen = sizeof(unsigned long);
-	ret = proc_doulongvec_minmax(table, write, buffer, length, ppos);
+	t = *table;
+	t.data = &tmp;
+	t.maxlen = sizeof(unsigned long);
+	ret = proc_doulongvec_minmax(&t, write, buffer, length, ppos);
 	if (ret)
 		goto out;
 
@@ -2938,6 +3005,7 @@ int hugetlb_overcommit_handler(struct ctl_table *table, int write,
 	struct hstate *h = &default_hstate;
 	unsigned long tmp;
 	int ret;
+	ctl_table_no_const hugetlb_table;
 
 	if (!hugepages_supported())
 		return -EOPNOTSUPP;
@@ -2947,9 +3015,10 @@ int hugetlb_overcommit_handler(struct ctl_table *table, int write,
 	if (write && hstate_is_gigantic(h))
 		return -EINVAL;
 
-	table->data = &tmp;
-	table->maxlen = sizeof(unsigned long);
-	ret = proc_doulongvec_minmax(table, write, buffer, length, ppos);
+	hugetlb_table = *table;
+	hugetlb_table.data = &tmp;
+	hugetlb_table.maxlen = sizeof(unsigned long);
+	ret = proc_doulongvec_minmax(&hugetlb_table, write, buffer, length, ppos);
 	if (ret)
 		goto out;
 
@@ -3443,6 +3512,27 @@ static void unmap_ref_private(struct mm_struct *mm, struct vm_area_struct *vma,
 	i_mmap_unlock_write(mapping);
 }
 
+#ifdef CONFIG_PAX_SEGMEXEC
+static void pax_mirror_huge_pte(struct vm_area_struct *vma, unsigned long address, struct page *page_m)
+{
+	struct mm_struct *mm = vma->vm_mm;
+	struct vm_area_struct *vma_m;
+	unsigned long address_m;
+	pte_t *ptep_m;
+
+	vma_m = pax_find_mirror_vma(vma);
+	if (!vma_m)
+		return;
+
+	BUG_ON(address >= SEGMEXEC_TASK_SIZE);
+	address_m = address + SEGMEXEC_TASK_SIZE;
+	ptep_m = huge_pte_offset(mm, address_m & HPAGE_MASK);
+	get_page(page_m);
+	hugepage_add_anon_rmap(page_m, vma_m, address_m);
+	set_huge_pte_at(mm, address_m, ptep_m, make_huge_pte(vma_m, page_m, 0));
+}
+#endif
+
 /*
  * Hugetlb_cow() should be called with page lock of the original hugepage held.
  * Called with hugetlb_instantiation_mutex held and pte_page locked so we
@@ -3556,6 +3646,11 @@ retry_avoidcopy:
 				make_huge_pte(vma, new_page, 1));
 		page_remove_rmap(old_page, true);
 		hugepage_add_new_anon_rmap(new_page, vma, address);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		pax_mirror_huge_pte(vma, address, new_page);
+#endif
+
 		/* Make the old page be freed below */
 		new_page = old_page;
 	}
@@ -3730,6 +3825,10 @@ retry:
 				&& (vma->vm_flags & VM_SHARED)));
 	set_huge_pte_at(mm, address, ptep, new_pte);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	pax_mirror_huge_pte(vma, address, page);
+#endif
+
 	hugetlb_count_add(pages_per_huge_page(h), mm);
 	if ((flags & FAULT_FLAG_WRITE) && !(vma->vm_flags & VM_SHARED)) {
 		/* Optimization, do the COW without a second fault */
@@ -3799,6 +3898,10 @@ int hugetlb_fault(struct mm_struct *mm, struct vm_area_struct *vma,
 	struct address_space *mapping;
 	int need_wait_lock = 0;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+#endif
+
 	address &= huge_page_mask(h);
 
 	ptep = huge_pte_offset(mm, address);
@@ -3816,6 +3919,26 @@ int hugetlb_fault(struct mm_struct *mm, struct vm_area_struct *vma,
 			return VM_FAULT_OOM;
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma_m = pax_find_mirror_vma(vma);
+	if (vma_m) {
+		unsigned long address_m;
+
+		if (vma->vm_start > vma_m->vm_start) {
+			address_m = address;
+			address -= SEGMEXEC_TASK_SIZE;
+			vma = vma_m;
+			h = hstate_vma(vma);
+		} else
+			address_m = address + SEGMEXEC_TASK_SIZE;
+
+		if (!huge_pte_alloc(mm, address_m, huge_page_size(h)))
+			return VM_FAULT_OOM;
+		address_m &= HPAGE_MASK;
+		unmap_hugepage_range(vma, address_m, address_m + HPAGE_SIZE, NULL);
+	}
+#endif
+
 	mapping = vma->vm_file->f_mapping;
 	idx = vma_hugecache_offset(h, vma, address);
 
diff --git a/mm/hugetlb_cgroup.c b/mm/hugetlb_cgroup.c
index eec115012..af03e3eee 100644
--- a/mm/hugetlb_cgroup.c
+++ b/mm/hugetlb_cgroup.c
@@ -27,7 +27,6 @@ struct hugetlb_cgroup {
 	struct page_counter hugepage[HUGE_MAX_HSTATE];
 };
 
-#define MEMFILE_PRIVATE(x, val)	(((x) << 16) | (val))
 #define MEMFILE_IDX(val)	(((val) >> 16) & 0xffff)
 #define MEMFILE_ATTR(val)	((val) & 0xffff)
 
@@ -254,14 +253,7 @@ void hugetlb_cgroup_uncharge_cgroup(int idx, unsigned long nr_pages,
 	return;
 }
 
-enum {
-	RES_USAGE,
-	RES_LIMIT,
-	RES_MAX_USAGE,
-	RES_FAILCNT,
-};
-
-static u64 hugetlb_cgroup_read_u64(struct cgroup_subsys_state *css,
+u64 hugetlb_cgroup_read_u64(struct cgroup_subsys_state *css,
 				   struct cftype *cft)
 {
 	struct page_counter *counter;
@@ -285,7 +277,7 @@ static u64 hugetlb_cgroup_read_u64(struct cgroup_subsys_state *css,
 
 static DEFINE_MUTEX(hugetlb_limit_mutex);
 
-static ssize_t hugetlb_cgroup_write(struct kernfs_open_file *of,
+ssize_t hugetlb_cgroup_write(struct kernfs_open_file *of,
 				    char *buf, size_t nbytes, loff_t off)
 {
 	int ret, idx;
@@ -316,7 +308,7 @@ static ssize_t hugetlb_cgroup_write(struct kernfs_open_file *of,
 	return ret ?: nbytes;
 }
 
-static ssize_t hugetlb_cgroup_reset(struct kernfs_open_file *of,
+ssize_t hugetlb_cgroup_reset(struct kernfs_open_file *of,
 				    char *buf, size_t nbytes, loff_t off)
 {
 	int ret = 0;
@@ -352,46 +344,26 @@ static char *mem_fmt(char *buf, int size, unsigned long hsize)
 
 static void __init __hugetlb_cgroup_file_init(int idx)
 {
+	char names[4][MAX_CFTYPE_NAME];
 	char buf[32];
-	struct cftype *cft;
 	struct hstate *h = &hstates[idx];
 
 	/* format the size */
 	mem_fmt(buf, 32, huge_page_size(h));
-
-	/* Add the limit file */
-	cft = &h->cgroup_files[0];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.limit_in_bytes", buf);
-	cft->private = MEMFILE_PRIVATE(idx, RES_LIMIT);
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-	cft->write = hugetlb_cgroup_write;
-
-	/* Add the usage file */
-	cft = &h->cgroup_files[1];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.usage_in_bytes", buf);
-	cft->private = MEMFILE_PRIVATE(idx, RES_USAGE);
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-
-	/* Add the MAX usage file */
-	cft = &h->cgroup_files[2];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.max_usage_in_bytes", buf);
-	cft->private = MEMFILE_PRIVATE(idx, RES_MAX_USAGE);
-	cft->write = hugetlb_cgroup_reset;
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-
-	/* Add the failcntfile */
-	cft = &h->cgroup_files[3];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.failcnt", buf);
-	cft->private  = MEMFILE_PRIVATE(idx, RES_FAILCNT);
-	cft->write = hugetlb_cgroup_reset;
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-
-	/* NULL terminate the last cft */
-	cft = &h->cgroup_files[4];
-	memset(cft, 0, sizeof(*cft));
+	snprintf(names[0], MAX_CFTYPE_NAME, "%s.limit_in_bytes", buf);
+	snprintf(names[1], MAX_CFTYPE_NAME, "%s.usage_in_bytes", buf);
+	snprintf(names[2], MAX_CFTYPE_NAME, "%s.max_usage_in_bytes", buf);
+	snprintf(names[3], MAX_CFTYPE_NAME, "%s.failcnt", buf);
+
+	pax_open_kernel();
+	strncpy((void *)(*h->cgroup_files)[0].name, names[0], MAX_CFTYPE_NAME);
+	strncpy((void *)(*h->cgroup_files)[1].name, names[1], MAX_CFTYPE_NAME);
+	strncpy((void *)(*h->cgroup_files)[2].name, names[2], MAX_CFTYPE_NAME);
+	strncpy((void *)(*h->cgroup_files)[3].name, names[3], MAX_CFTYPE_NAME);
+	pax_close_kernel();
 
 	WARN_ON(cgroup_add_legacy_cftypes(&hugetlb_cgrp_subsys,
-					  h->cgroup_files));
+					  *h->cgroup_files));
 }
 
 void __init hugetlb_cgroup_file_init(void)
diff --git a/mm/internal.h b/mm/internal.h
index 1501304f8..e026d6186 100644
--- a/mm/internal.h
+++ b/mm/internal.h
@@ -151,6 +151,7 @@ static inline struct page *pageblock_pfn_to_page(unsigned long start_pfn,
 extern int __isolate_free_page(struct page *page, unsigned int order);
 extern void __free_pages_bootmem(struct page *page, unsigned long pfn,
 					unsigned int order);
+extern void free_compound_page(struct page *page);
 extern void prep_compound_page(struct page *page, unsigned int order);
 extern void post_alloc_hook(struct page *page, unsigned int order,
 					gfp_t gfp_flags);
@@ -251,7 +252,7 @@ static inline bool is_exec_mapping(vm_flags_t flags)
  */
 static inline bool is_stack_mapping(vm_flags_t flags)
 {
-	return (flags & VM_STACK) == VM_STACK;
+	return flags & (VM_GROWSUP | VM_GROWSDOWN);
 }
 
 /*
diff --git a/mm/kmemleak.c b/mm/kmemleak.c
index 086292f7c..702caa3d6 100644
--- a/mm/kmemleak.c
+++ b/mm/kmemleak.c
@@ -367,7 +367,7 @@ static void print_unreferenced(struct seq_file *seq,
 
 	for (i = 0; i < object->trace_len; i++) {
 		void *ptr = (void *)object->trace[i];
-		seq_printf(seq, "    [<%p>] %pS\n", ptr, ptr);
+		seq_printf(seq, "    [<%pP>] %pA\n", ptr, ptr);
 	}
 }
 
@@ -1959,7 +1959,7 @@ static int __init kmemleak_late_init(void)
 		return -ENOMEM;
 	}
 
-	dentry = debugfs_create_file("kmemleak", S_IRUGO, NULL, NULL,
+	dentry = debugfs_create_file("kmemleak", S_IRUSR, NULL, NULL,
 				     &kmemleak_fops);
 	if (!dentry)
 		pr_warn("Failed to create the debugfs kmemleak file\n");
diff --git a/mm/maccess.c b/mm/maccess.c
index 78f9274dd..5d8c2e02e 100644
--- a/mm/maccess.c
+++ b/mm/maccess.c
@@ -28,12 +28,12 @@ long __probe_kernel_read(void *dst, const void *src, size_t size)
 	long ret;
 	mm_segment_t old_fs = get_fs();
 
-	set_fs(KERNEL_DS);
 	pagefault_disable();
+	set_fs(KERNEL_DS);
 	ret = __copy_from_user_inatomic(dst,
-			(__force const void __user *)src, size);
-	pagefault_enable();
+			(const void __force_user *)src, size);
 	set_fs(old_fs);
+	pagefault_enable();
 
 	return ret ? -EFAULT : 0;
 }
@@ -56,11 +56,11 @@ long __probe_kernel_write(void *dst, const void *src, size_t size)
 	long ret;
 	mm_segment_t old_fs = get_fs();
 
-	set_fs(KERNEL_DS);
 	pagefault_disable();
-	ret = __copy_to_user_inatomic((__force void __user *)dst, src, size);
-	pagefault_enable();
+	set_fs(KERNEL_DS);
+	ret = __copy_to_user_inatomic((void __force_user *)dst, src, size);
 	set_fs(old_fs);
+	pagefault_enable();
 
 	return ret ? -EFAULT : 0;
 }
diff --git a/mm/madvise.c b/mm/madvise.c
index 93fb63e88..0aa64482a 100644
--- a/mm/madvise.c
+++ b/mm/madvise.c
@@ -56,6 +56,10 @@ static long madvise_behavior(struct vm_area_struct *vma,
 	pgoff_t pgoff;
 	unsigned long new_flags = vma->vm_flags;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+#endif
+
 	switch (behavior) {
 	case MADV_NORMAL:
 		new_flags = new_flags & ~VM_RAND_READ & ~VM_SEQ_READ;
@@ -132,6 +136,13 @@ success:
 	/*
 	 * vm_flags is protected by the mmap_sem held in write mode.
 	 */
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma_m = pax_find_mirror_vma(vma);
+	if (vma_m)
+		vma_m->vm_flags = new_flags & ~(VM_WRITE | VM_MAYWRITE | VM_ACCOUNT);
+#endif
+
 	vma->vm_flags = new_flags;
 
 out:
@@ -471,11 +482,27 @@ static long madvise_dontneed(struct vm_area_struct *vma,
 			     struct vm_area_struct **prev,
 			     unsigned long start, unsigned long end)
 {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+#endif
+
 	*prev = vma;
 	if (vma->vm_flags & (VM_LOCKED|VM_HUGETLB|VM_PFNMAP))
 		return -EINVAL;
 
 	zap_page_range(vma, start, end - start, NULL);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma_m = pax_find_mirror_vma(vma);
+	if (vma_m) {
+		if (vma_m->vm_flags & (VM_LOCKED|VM_HUGETLB|VM_PFNMAP))
+			return -EINVAL;
+
+		zap_page_range(vma_m, start + SEGMEXEC_TASK_SIZE, end - start, NULL);
+	}
+#endif
+
 	return 0;
 }
 
@@ -702,6 +729,16 @@ SYSCALL_DEFINE3(madvise, unsigned long, start, size_t, len_in, int, behavior)
 	if (end < start)
 		return error;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (current->mm->pax_flags & MF_PAX_SEGMEXEC) {
+		if (end > SEGMEXEC_TASK_SIZE)
+			return error;
+	} else
+#endif
+
+	if (end > TASK_SIZE)
+		return error;
+
 	error = 0;
 	if (end == start)
 		return error;
diff --git a/mm/memcontrol.c b/mm/memcontrol.c
index dddead146..8832645e3 100644
--- a/mm/memcontrol.c
+++ b/mm/memcontrol.c
@@ -702,7 +702,7 @@ static void memcg_check_events(struct mem_cgroup *memcg, struct page *page)
 			mem_cgroup_update_tree(memcg, page);
 #if MAX_NUMNODES > 1
 		if (unlikely(do_numainfo))
-			atomic_inc(&memcg->numainfo_events);
+			atomic64_inc(&memcg->numainfo_events);
 #endif
 	}
 }
@@ -1318,7 +1318,7 @@ static void mem_cgroup_may_update_nodemask(struct mem_cgroup *memcg)
 	 * numainfo_events > 0 means there was at least NUMAINFO_EVENTS_TARGET
 	 * pagein/pageout changes since the last update.
 	 */
-	if (!atomic_read(&memcg->numainfo_events))
+	if (!atomic64_read(&memcg->numainfo_events))
 		return;
 	if (atomic_inc_return(&memcg->numainfo_updating) > 1)
 		return;
@@ -1332,7 +1332,7 @@ static void mem_cgroup_may_update_nodemask(struct mem_cgroup *memcg)
 			node_clear(nid, memcg->scan_nodes);
 	}
 
-	atomic_set(&memcg->numainfo_events, 0);
+	atomic64_set(&memcg->numainfo_events, 0);
 	atomic_set(&memcg->numainfo_updating, 0);
 }
 
diff --git a/mm/memory-failure.c b/mm/memory-failure.c
index 19e796d36..9c8fa80ba 100644
--- a/mm/memory-failure.c
+++ b/mm/memory-failure.c
@@ -64,7 +64,7 @@ int sysctl_memory_failure_early_kill __read_mostly = 0;
 
 int sysctl_memory_failure_recovery __read_mostly = 1;
 
-atomic_long_t num_poisoned_pages __read_mostly = ATOMIC_LONG_INIT(0);
+atomic_long_unchecked_t num_poisoned_pages __read_mostly = ATOMIC_LONG_INIT(0);
 
 #if defined(CONFIG_HWPOISON_INJECT) || defined(CONFIG_HWPOISON_INJECT_MODULE)
 
@@ -188,7 +188,7 @@ static int kill_proc(struct task_struct *t, unsigned long addr, int trapno,
 		pfn, t->comm, t->pid);
 	si.si_signo = SIGBUS;
 	si.si_errno = 0;
-	si.si_addr = (void *)addr;
+	si.si_addr = (void __user *)addr;
 #ifdef __ARCH_SI_TRAPNO
 	si.si_trapno = trapno;
 #endif
@@ -779,7 +779,7 @@ static struct page_state {
 	unsigned long res;
 	enum mf_action_page_type type;
 	int (*action)(struct page *p, unsigned long pfn);
-} error_states[] = {
+} __do_const error_states[] = {
 	{ reserved,	reserved,	MF_MSG_KERNEL,	me_kernel },
 	/*
 	 * free pages are specially detected outside this table:
diff --git a/mm/memory.c b/mm/memory.c
index 793fe0f98..9e24e9833 100644
--- a/mm/memory.c
+++ b/mm/memory.c
@@ -427,6 +427,7 @@ static inline void free_pmd_range(struct mmu_gather *tlb, pud_t *pud,
 		free_pte_range(tlb, pmd, addr);
 	} while (pmd++, addr = next, addr != end);
 
+#if !defined(CONFIG_X86_32) || !defined(CONFIG_PAX_PER_CPU_PGD)
 	start &= PUD_MASK;
 	if (start < floor)
 		return;
@@ -442,6 +443,7 @@ static inline void free_pmd_range(struct mmu_gather *tlb, pud_t *pud,
 	pud_clear(pud);
 	pmd_free_tlb(tlb, pmd, start);
 	mm_dec_nr_pmds(tlb->mm);
+#endif
 }
 
 static inline void free_pud_range(struct mmu_gather *tlb, pgd_t *pgd,
@@ -461,6 +463,7 @@ static inline void free_pud_range(struct mmu_gather *tlb, pgd_t *pgd,
 		free_pmd_range(tlb, pud, addr, next, floor, ceiling);
 	} while (pud++, addr = next, addr != end);
 
+#if !defined(CONFIG_X86_64) || !defined(CONFIG_PAX_PER_CPU_PGD)
 	start &= PGDIR_MASK;
 	if (start < floor)
 		return;
@@ -475,6 +478,8 @@ static inline void free_pud_range(struct mmu_gather *tlb, pgd_t *pgd,
 	pud = pud_offset(pgd, start);
 	pgd_clear(pgd);
 	pud_free_tlb(tlb, pud, start);
+#endif
+
 }
 
 /*
@@ -693,7 +698,7 @@ static void print_bad_pte(struct vm_area_struct *vma, unsigned long addr,
 	/*
 	 * Choose text because data symbols depend on CONFIG_KALLSYMS_ALL=y
 	 */
-	pr_alert("file:%pD fault:%pf mmap:%pf readpage:%pf\n",
+	pr_alert("file:%pD fault:%pX mmap:%pX readpage:%pX\n",
 		 vma->vm_file,
 		 vma->vm_ops ? vma->vm_ops->fault : NULL,
 		 vma->vm_file ? vma->vm_file->f_op->mmap : NULL,
@@ -1464,6 +1469,10 @@ pte_t *__get_locked_pte(struct mm_struct *mm, unsigned long addr,
 	return NULL;
 }
 
+#ifdef CONFIG_PAX_SEGMEXEC
+static void pax_mirror_file_pte(struct vm_area_struct *vma, unsigned long address, struct page *page_m, spinlock_t *ptl);
+#endif
+
 /*
  * This is the old fallback for page remapping.
  *
@@ -1497,6 +1506,10 @@ static int insert_page(struct vm_area_struct *vma, unsigned long addr,
 	page_add_file_rmap(page, false);
 	set_pte_at(mm, addr, pte, mk_pte(page, prot));
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	pax_mirror_file_pte(vma, addr, page, ptl);
+#endif
+
 	retval = 0;
 	pte_unmap_unlock(pte, ptl);
 	return retval;
@@ -1541,9 +1554,21 @@ int vm_insert_page(struct vm_area_struct *vma, unsigned long addr,
 	if (!page_count(page))
 		return -EINVAL;
 	if (!(vma->vm_flags & VM_MIXEDMAP)) {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		struct vm_area_struct *vma_m;
+#endif
+
 		BUG_ON(down_read_trylock(&vma->vm_mm->mmap_sem));
 		BUG_ON(vma->vm_flags & VM_PFNMAP);
 		vma->vm_flags |= VM_MIXEDMAP;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		vma_m = pax_find_mirror_vma(vma);
+		if (vma_m)
+			vma_m->vm_flags |= VM_MIXEDMAP;
+#endif
+
 	}
 	return insert_page(vma, addr, page, vma->vm_page_prot);
 }
@@ -1650,6 +1675,7 @@ int vm_insert_mixed(struct vm_area_struct *vma, unsigned long addr,
 			pfn_t pfn)
 {
 	BUG_ON(!(vma->vm_flags & VM_MIXEDMAP));
+	BUG_ON(vma->vm_mirror);
 
 	if (addr < vma->vm_start || addr >= vma->vm_end)
 		return -EFAULT;
@@ -1903,7 +1929,9 @@ static int apply_to_pmd_range(struct mm_struct *mm, pud_t *pud,
 
 	BUG_ON(pud_huge(*pud));
 
-	pmd = pmd_alloc(mm, pud, addr);
+	pmd = (mm == &init_mm) ?
+		pmd_alloc_kernel(mm, pud, addr) :
+		pmd_alloc(mm, pud, addr);
 	if (!pmd)
 		return -ENOMEM;
 	do {
@@ -1923,7 +1951,9 @@ static int apply_to_pud_range(struct mm_struct *mm, pgd_t *pgd,
 	unsigned long next;
 	int err;
 
-	pud = pud_alloc(mm, pgd, addr);
+	pud = (mm == &init_mm) ?
+		pud_alloc_kernel(mm, pgd, addr) :
+		pud_alloc(mm, pgd, addr);
 	if (!pud)
 		return -ENOMEM;
 	do {
@@ -2119,6 +2149,185 @@ static inline int wp_page_reuse(struct fault_env *fe, pte_t orig_pte,
 	return VM_FAULT_WRITE;
 }
 
+#ifdef CONFIG_PAX_SEGMEXEC
+static void pax_unmap_mirror_pte(struct vm_area_struct *vma, unsigned long address, pmd_t *pmd)
+{
+	struct mm_struct *mm = vma->vm_mm;
+	spinlock_t *ptl;
+	pte_t *pte, entry;
+
+	pte = pte_offset_map_lock(mm, pmd, address, &ptl);
+	entry = *pte;
+	if (pte_none(entry))
+		;
+	else if (!pte_present(entry)) {
+		swp_entry_t swapentry;
+
+		swapentry = pte_to_swp_entry(entry);
+		if (!non_swap_entry(swapentry))
+			dec_mm_counter_fast(mm, MM_SWAPENTS);
+		else if (is_migration_entry(swapentry))
+			dec_mm_counter_fast(mm, mm_counter(migration_entry_to_page(swapentry)));
+		free_swap_and_cache(swapentry);
+		pte_clear_not_present_full(mm, address, pte, 0);
+	} else {
+		struct page *page;
+
+		flush_cache_page(vma, address, pte_pfn(entry));
+		entry = ptep_clear_flush(vma, address, pte);
+		BUG_ON(pte_dirty(entry));
+		page = vm_normal_page(vma, address, entry);
+		if (page) {
+			update_hiwater_rss(mm);
+			dec_mm_counter_fast(mm, mm_counter(page));
+			page_remove_rmap(page, false);
+			put_page(page);
+		}
+	}
+	pte_unmap_unlock(pte, ptl);
+}
+
+/* PaX: if vma is mirrored, synchronize the mirror's PTE
+ *
+ * the ptl of the lower mapped page is held on entry and is not released on exit
+ * or inside to ensure atomic changes to the PTE states (swapout, mremap, munmap, etc)
+ */
+static bool pax_mirror_anon_pte(struct vm_area_struct *vma, unsigned long address, struct page *page_m, spinlock_t *ptl)
+{
+	struct mm_struct *mm = vma->vm_mm;
+	unsigned long address_m;
+	spinlock_t *ptl_m;
+	struct vm_area_struct *vma_m;
+	pmd_t *pmd_m;
+	pte_t *pte_m, entry_m;
+
+	BUG_ON(!page_m || !PageAnon(page_m));
+
+	vma_m = pax_find_mirror_vma(vma);
+	if (!vma_m)
+		return false;
+
+	BUG_ON(!PageLocked(page_m));
+	BUG_ON(address >= SEGMEXEC_TASK_SIZE);
+	address_m = address + SEGMEXEC_TASK_SIZE;
+	pmd_m = pmd_offset(pud_offset(pgd_offset(mm, address_m), address_m), address_m);
+	pte_m = pte_offset_map(pmd_m, address_m);
+	ptl_m = pte_lockptr(mm, pmd_m);
+	if (ptl != ptl_m) {
+		spin_lock_nested(ptl_m, SINGLE_DEPTH_NESTING);
+		if (!pte_none(*pte_m))
+			goto out;
+	}
+
+	entry_m = pfn_pte(page_to_pfn(page_m), vma_m->vm_page_prot);
+	get_page(page_m);
+	page_add_anon_rmap(page_m, vma_m, address_m, false);
+	inc_mm_counter_fast(mm, MM_ANONPAGES);
+	set_pte_at(mm, address_m, pte_m, entry_m);
+	update_mmu_cache(vma_m, address_m, pte_m);
+out:
+	if (ptl != ptl_m)
+		spin_unlock(ptl_m);
+	pte_unmap(pte_m);
+	return true;
+}
+
+static void pax_mirror_file_pte(struct vm_area_struct *vma, unsigned long address, struct page *page_m, spinlock_t *ptl)
+{
+	struct mm_struct *mm = vma->vm_mm;
+	unsigned long address_m;
+	spinlock_t *ptl_m;
+	struct vm_area_struct *vma_m;
+	pmd_t *pmd_m;
+	pte_t *pte_m, entry_m;
+
+	BUG_ON(!page_m || PageAnon(page_m));
+
+	vma_m = pax_find_mirror_vma(vma);
+	if (!vma_m)
+		return;
+
+	BUG_ON(address >= SEGMEXEC_TASK_SIZE);
+	address_m = address + SEGMEXEC_TASK_SIZE;
+	pmd_m = pmd_offset(pud_offset(pgd_offset(mm, address_m), address_m), address_m);
+	pte_m = pte_offset_map(pmd_m, address_m);
+	ptl_m = pte_lockptr(mm, pmd_m);
+	if (ptl != ptl_m) {
+		spin_lock_nested(ptl_m, SINGLE_DEPTH_NESTING);
+		if (!pte_none(*pte_m))
+			goto out;
+	}
+
+	entry_m = pfn_pte(page_to_pfn(page_m), vma_m->vm_page_prot);
+	get_page(page_m);
+	page_add_file_rmap(page_m, false);
+	inc_mm_counter_fast(mm, mm_counter_file(page_m));
+	set_pte_at(mm, address_m, pte_m, entry_m);
+	update_mmu_cache(vma_m, address_m, pte_m);
+out:
+	if (ptl != ptl_m)
+		spin_unlock(ptl_m);
+	pte_unmap(pte_m);
+}
+
+static void pax_mirror_pfn_pte(struct vm_area_struct *vma, unsigned long address, unsigned long pfn_m, spinlock_t *ptl)
+{
+	struct mm_struct *mm = vma->vm_mm;
+	unsigned long address_m;
+	spinlock_t *ptl_m;
+	struct vm_area_struct *vma_m;
+	pmd_t *pmd_m;
+	pte_t *pte_m, entry_m;
+
+	vma_m = pax_find_mirror_vma(vma);
+	if (!vma_m)
+		return;
+
+	BUG_ON(address >= SEGMEXEC_TASK_SIZE);
+	address_m = address + SEGMEXEC_TASK_SIZE;
+	pmd_m = pmd_offset(pud_offset(pgd_offset(mm, address_m), address_m), address_m);
+	pte_m = pte_offset_map(pmd_m, address_m);
+	ptl_m = pte_lockptr(mm, pmd_m);
+	if (ptl != ptl_m) {
+		spin_lock_nested(ptl_m, SINGLE_DEPTH_NESTING);
+		if (!pte_none(*pte_m))
+			goto out;
+	}
+
+	entry_m = pfn_pte(pfn_m, vma_m->vm_page_prot);
+	set_pte_at(mm, address_m, pte_m, entry_m);
+out:
+	if (ptl != ptl_m)
+		spin_unlock(ptl_m);
+	pte_unmap(pte_m);
+}
+
+static void pax_mirror_pte(struct vm_area_struct *vma, unsigned long address, pte_t *pte, pmd_t *pmd, spinlock_t *ptl)
+{
+	struct page *page_m;
+	pte_t entry;
+
+	if (!(vma->vm_mm->pax_flags & MF_PAX_SEGMEXEC))
+		return;
+
+	entry = *pte;
+	page_m  = vm_normal_page(vma, address, entry);
+	if (!page_m)
+		pax_mirror_pfn_pte(vma, address, pte_pfn(entry), ptl);
+	else if (PageAnon(page_m)) {
+		if (pax_find_mirror_vma(vma)) {
+			pte_unmap_unlock(pte, ptl);
+			lock_page(page_m);
+			pte = pte_offset_map_lock(vma->vm_mm, pmd, address, &ptl);
+			if (pte_same(entry, *pte))
+				pax_mirror_anon_pte(vma, address, page_m, ptl);
+			unlock_page(page_m);
+		}
+	} else
+		pax_mirror_file_pte(vma, address, page_m, ptl);
+}
+#endif
+
 /*
  * Handle the case of a page which we actually need to copy to a new page.
  *
@@ -2174,6 +2383,12 @@ static int wp_page_copy(struct fault_env *fe, pte_t orig_pte,
 	 */
 	fe->pte = pte_offset_map_lock(mm, fe->pmd, fe->address, &fe->ptl);
 	if (likely(pte_same(*fe->pte, orig_pte))) {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		if (pax_find_mirror_vma(vma))
+			BUG_ON(!trylock_page(new_page));
+#endif
+
 		if (old_page) {
 			if (!PageAnon(old_page)) {
 				dec_mm_counter_fast(mm,
@@ -2229,6 +2444,11 @@ static int wp_page_copy(struct fault_env *fe, pte_t orig_pte,
 			page_remove_rmap(old_page, false);
 		}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+		if (pax_mirror_anon_pte(vma, fe->address, new_page, fe->ptl))
+			unlock_page(new_page);
+#endif
+
 		/* Free the old page.. */
 		new_page = old_page;
 		page_copied = 1;
@@ -2653,6 +2873,11 @@ int do_swap_page(struct fault_env *fe, pte_t orig_pte)
 	if (mem_cgroup_swap_full(page) ||
 	    (vma->vm_flags & VM_LOCKED) || PageMlocked(page))
 		try_to_free_swap(page);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((fe->flags & FAULT_FLAG_WRITE) || !pax_find_mirror_vma(vma))
+#endif
+
 	unlock_page(page);
 	if (page != swapcache) {
 		/*
@@ -2676,6 +2901,12 @@ int do_swap_page(struct fault_env *fe, pte_t orig_pte)
 
 	/* No need to invalidate - it was non-present before */
 	update_mmu_cache(vma, fe->address, fe->pte);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (pax_mirror_anon_pte(vma, fe->address, page, fe->ptl))
+		unlock_page(page);
+#endif
+
 unlock:
 	pte_unmap_unlock(fe->pte, fe->ptl);
 out:
@@ -2695,40 +2926,6 @@ out_release:
 }
 
 /*
- * This is like a special single-page "expand_{down|up}wards()",
- * except we must first make sure that 'address{-|+}PAGE_SIZE'
- * doesn't hit another vma.
- */
-static inline int check_stack_guard_page(struct vm_area_struct *vma, unsigned long address)
-{
-	address &= PAGE_MASK;
-	if ((vma->vm_flags & VM_GROWSDOWN) && address == vma->vm_start) {
-		struct vm_area_struct *prev = vma->vm_prev;
-
-		/*
-		 * Is there a mapping abutting this one below?
-		 *
-		 * That's only ok if it's the same stack mapping
-		 * that has gotten split..
-		 */
-		if (prev && prev->vm_end == address)
-			return prev->vm_flags & VM_GROWSDOWN ? 0 : -ENOMEM;
-
-		return expand_downwards(vma, address - PAGE_SIZE);
-	}
-	if ((vma->vm_flags & VM_GROWSUP) && address + PAGE_SIZE == vma->vm_end) {
-		struct vm_area_struct *next = vma->vm_next;
-
-		/* As VM_GROWSDOWN but s/below/above/ */
-		if (next && next->vm_start == address + PAGE_SIZE)
-			return next->vm_flags & VM_GROWSUP ? 0 : -ENOMEM;
-
-		return expand_upwards(vma, address + PAGE_SIZE);
-	}
-	return 0;
-}
-
-/*
  * We enter with non-exclusive mmap_sem (to exclude vma changes,
  * but allow concurrent faults), and pte mapped but not yet locked.
  * We return with mmap_sem still held, but pte unmapped and unlocked.
@@ -2737,17 +2934,13 @@ static int do_anonymous_page(struct fault_env *fe)
 {
 	struct vm_area_struct *vma = fe->vma;
 	struct mem_cgroup *memcg;
-	struct page *page;
+	struct page *page = NULL;
 	pte_t entry;
 
 	/* File mapping without ->vm_ops ? */
 	if (vma->vm_flags & VM_SHARED)
 		return VM_FAULT_SIGBUS;
 
-	/* Check if we need to add a guard page to the stack */
-	if (check_stack_guard_page(vma, fe->address) < 0)
-		return VM_FAULT_SIGSEGV;
-
 	/*
 	 * Use pte_alloc() instead of pte_alloc_map().  We can't run
 	 * pte_offset_map() on pmds where a huge pmd might be created
@@ -2816,6 +3009,11 @@ static int do_anonymous_page(struct fault_env *fe)
 		return handle_userfault(fe, VM_UFFD_MISSING);
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (pax_find_mirror_vma(vma))
+		BUG_ON(!trylock_page(page));
+#endif
+
 	inc_mm_counter_fast(vma->vm_mm, MM_ANONPAGES);
 	page_add_new_anon_rmap(page, vma, fe->address, false);
 	mem_cgroup_commit_charge(page, memcg, false, false);
@@ -2825,6 +3023,12 @@ setpte:
 
 	/* No need to invalidate - it was non-present before */
 	update_mmu_cache(vma, fe->address, fe->pte);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (page && pax_mirror_anon_pte(vma, fe->address, page, fe->ptl))
+		unlock_page(page);
+#endif
+
 unlock:
 	pte_unmap_unlock(fe->pte, fe->ptl);
 	return 0;
@@ -3039,6 +3243,13 @@ int alloc_set_pte(struct fault_env *fe, struct mem_cgroup *memcg,
 	}
 	set_pte_at(vma->vm_mm, fe->address, fe->pte, entry);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (write && !(vma->vm_flags & VM_SHARED))
+		pax_mirror_anon_pte(vma, fe->address, page, fe->ptl);
+	else
+		pax_mirror_file_pte(vma, fe->address, page, fe->ptl);
+#endif
+
 	/* no need to invalidate: a not-present page won't be cached */
 	update_mmu_cache(vma, fe->address, fe->pte);
 
@@ -3226,6 +3437,11 @@ static int do_cow_fault(struct fault_env *fe, pgoff_t pgoff)
 		copy_user_highpage(new_page, fault_page, fe->address, vma);
 	__SetPageUptodate(new_page);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (pax_find_mirror_vma(vma))
+		BUG_ON(!trylock_page(new_page));
+#endif
+
 	ret |= alloc_set_pte(fe, memcg, new_page);
 	if (fe->pte)
 		pte_unmap_unlock(fe->pte, fe->ptl);
@@ -3235,6 +3451,12 @@ static int do_cow_fault(struct fault_env *fe, pgoff_t pgoff)
 	} else {
 		dax_unlock_mapping_entry(vma->vm_file->f_mapping, pgoff);
 	}
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (pax_find_mirror_vma(vma))
+		unlock_page(new_page);
+#endif
+
 	if (unlikely(ret & (VM_FAULT_ERROR | VM_FAULT_NOPAGE | VM_FAULT_RETRY)))
 		goto uncharge_out;
 	return ret;
@@ -3552,6 +3774,11 @@ static int handle_pte_fault(struct fault_env *fe)
 		if (fe->flags & FAULT_FLAG_WRITE)
 			flush_tlb_fix_spurious_fault(fe->vma, fe->address);
 	}
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	pax_mirror_pte(fe->vma, fe->address, fe->pte, fe->pmd, fe->ptl);
+#endif
+
 unlock:
 	pte_unmap_unlock(fe->pte, fe->ptl);
 	return 0;
@@ -3575,14 +3802,49 @@ static int __handle_mm_fault(struct vm_area_struct *vma, unsigned long address,
 	pgd_t *pgd;
 	pud_t *pud;
 
-	pgd = pgd_offset(mm, address);
-	pud = pud_alloc(mm, pgd, address);
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+
+	vma_m = pax_find_mirror_vma(vma);
+	if (vma_m) {
+		unsigned long address_m;
+		pgd_t *pgd_m;
+		pud_t *pud_m;
+		pmd_t *pmd_m;
+		pmd_t orig_pmd_m;
+
+		if (vma->vm_start > vma_m->vm_start) {
+			address_m = address;
+			fe.address -= SEGMEXEC_TASK_SIZE;
+			fe.vma = vma_m;
+		} else
+			address_m = address + SEGMEXEC_TASK_SIZE;
+
+		pgd_m = pgd_offset(mm, address_m);
+		pud_m = pud_alloc(mm, pgd_m, address_m);
+		if (!pud_m)
+			return VM_FAULT_OOM;
+		pmd_m = pmd_alloc(mm, pud_m, address_m);
+		if (!pmd_m)
+			return VM_FAULT_OOM;
+		BUG_ON(transparent_hugepage_enabled(vma_m));
+		orig_pmd_m = *pmd_m;
+		barrier();
+		BUG_ON(pmd_trans_huge(orig_pmd_m) || pmd_devmap(orig_pmd_m));
+		if (!pmd_present(*pmd_m) && __pte_alloc(mm, pmd_m, address_m))
+			return VM_FAULT_OOM;
+		pax_unmap_mirror_pte(vma_m, address_m, pmd_m);
+	}
+#endif
+
+	pgd = pgd_offset(mm, fe.address);
+	pud = pud_alloc(mm, pgd, fe.address);
 	if (!pud)
 		return VM_FAULT_OOM;
-	fe.pmd = pmd_alloc(mm, pud, address);
+	fe.pmd = pmd_alloc(mm, pud, fe.address);
 	if (!fe.pmd)
 		return VM_FAULT_OOM;
-	if (pmd_none(*fe.pmd) && transparent_hugepage_enabled(vma)) {
+	if (pmd_none(*fe.pmd) && transparent_hugepage_enabled(fe.vma)) {
 		int ret = create_huge_pmd(&fe);
 		if (!(ret & VM_FAULT_FALLBACK))
 			return ret;
@@ -3592,7 +3854,7 @@ static int __handle_mm_fault(struct vm_area_struct *vma, unsigned long address,
 
 		barrier();
 		if (pmd_trans_huge(orig_pmd) || pmd_devmap(orig_pmd)) {
-			if (pmd_protnone(orig_pmd) && vma_is_accessible(vma))
+			if (pmd_protnone(orig_pmd) && vma_is_accessible(fe.vma))
 				return do_huge_pmd_numa_page(&fe, orig_pmd);
 
 			if ((fe.flags & FAULT_FLAG_WRITE) &&
@@ -3667,7 +3929,7 @@ EXPORT_SYMBOL_GPL(handle_mm_fault);
  * Allocate page upper directory.
  * We've already handled the fast-path in-line.
  */
-int __pud_alloc(struct mm_struct *mm, pgd_t *pgd, unsigned long address)
+static int ____pud_alloc(struct mm_struct *mm, pgd_t *pgd, unsigned long address, bool kernel)
 {
 	pud_t *new = pud_alloc_one(mm, address);
 	if (!new)
@@ -3678,11 +3940,23 @@ int __pud_alloc(struct mm_struct *mm, pgd_t *pgd, unsigned long address)
 	spin_lock(&mm->page_table_lock);
 	if (pgd_present(*pgd))		/* Another has populated it */
 		pud_free(mm, new);
+	else if (kernel)
+		pgd_populate_kernel(mm, pgd, new);
 	else
 		pgd_populate(mm, pgd, new);
 	spin_unlock(&mm->page_table_lock);
 	return 0;
 }
+
+int __pud_alloc(struct mm_struct *mm, pgd_t *pgd, unsigned long address)
+{
+	return ____pud_alloc(mm, pgd, address, false);
+}
+
+int __pud_alloc_kernel(struct mm_struct *mm, pgd_t *pgd, unsigned long address)
+{
+	return ____pud_alloc(mm, pgd, address, true);
+}
 #endif /* __PAGETABLE_PUD_FOLDED */
 
 #ifndef __PAGETABLE_PMD_FOLDED
@@ -3690,7 +3964,7 @@ int __pud_alloc(struct mm_struct *mm, pgd_t *pgd, unsigned long address)
  * Allocate page middle directory.
  * We've already handled the fast-path in-line.
  */
-int __pmd_alloc(struct mm_struct *mm, pud_t *pud, unsigned long address)
+static int ____pmd_alloc(struct mm_struct *mm, pud_t *pud, unsigned long address, bool kernel)
 {
 	pmd_t *new = pmd_alloc_one(mm, address);
 	if (!new)
@@ -3702,19 +3976,35 @@ int __pmd_alloc(struct mm_struct *mm, pud_t *pud, unsigned long address)
 #ifndef __ARCH_HAS_4LEVEL_HACK
 	if (!pud_present(*pud)) {
 		mm_inc_nr_pmds(mm);
-		pud_populate(mm, pud, new);
+		if (kernel)
+			pud_populate_kernel(mm, pud, new);
+		else
+			pud_populate(mm, pud, new);
 	} else	/* Another has populated it */
 		pmd_free(mm, new);
 #else
 	if (!pgd_present(*pud)) {
 		mm_inc_nr_pmds(mm);
-		pgd_populate(mm, pud, new);
+		if (kernel)
+			pgd_populate_kernel(mm, pud, new);
+		else
+			pgd_populate(mm, pud, new);
 	} else /* Another has populated it */
 		pmd_free(mm, new);
 #endif /* __ARCH_HAS_4LEVEL_HACK */
 	spin_unlock(&mm->page_table_lock);
 	return 0;
 }
+
+int __pmd_alloc(struct mm_struct *mm, pud_t *pud, unsigned long address)
+{
+	return ____pmd_alloc(mm, pud, address, false);
+}
+
+int __pmd_alloc_kernel(struct mm_struct *mm, pud_t *pud, unsigned long address)
+{
+	return ____pmd_alloc(mm, pud, address, true);
+}
 #endif /* __PAGETABLE_PMD_FOLDED */
 
 static int __follow_pte(struct mm_struct *mm, unsigned long address,
@@ -3824,8 +4114,8 @@ out:
 	return ret;
 }
 
-int generic_access_phys(struct vm_area_struct *vma, unsigned long addr,
-			void *buf, int len, int write)
+ssize_t generic_access_phys(struct vm_area_struct *vma, unsigned long addr,
+			void *buf, size_t len, int write)
 {
 	resource_size_t phys_addr;
 	unsigned long prot = 0;
@@ -3851,8 +4141,8 @@ EXPORT_SYMBOL_GPL(generic_access_phys);
  * Access another process' address space as given in mm.  If non-NULL, use the
  * given task for page fault accounting.
  */
-static int __access_remote_vm(struct task_struct *tsk, struct mm_struct *mm,
-		unsigned long addr, void *buf, int len, int write)
+static ssize_t __access_remote_vm(struct task_struct *tsk, struct mm_struct *mm,
+		unsigned long addr, void *buf, size_t len, int write)
 {
 	struct vm_area_struct *vma;
 	void *old_buf = buf;
@@ -3860,7 +4150,7 @@ static int __access_remote_vm(struct task_struct *tsk, struct mm_struct *mm,
 	down_read(&mm->mmap_sem);
 	/* ignore errors, just check how much was successfully transferred */
 	while (len) {
-		int bytes, ret, offset;
+		ssize_t bytes, ret, offset;
 		void *maddr;
 		struct page *page = NULL;
 
@@ -3921,8 +4211,8 @@ static int __access_remote_vm(struct task_struct *tsk, struct mm_struct *mm,
  *
  * The caller must hold a reference on @mm.
  */
-int access_remote_vm(struct mm_struct *mm, unsigned long addr,
-		void *buf, int len, int write)
+ssize_t access_remote_vm(struct mm_struct *mm, unsigned long addr,
+		void *buf, size_t len, int write)
 {
 	return __access_remote_vm(NULL, mm, addr, buf, len, write);
 }
@@ -3932,11 +4222,11 @@ int access_remote_vm(struct mm_struct *mm, unsigned long addr,
  * Source/target buffer must be kernel space,
  * Do not walk the page table directly, use get_user_pages
  */
-int access_process_vm(struct task_struct *tsk, unsigned long addr,
-		void *buf, int len, int write)
+ssize_t access_process_vm(struct task_struct *tsk, unsigned long addr,
+		void *buf, size_t len, int write)
 {
 	struct mm_struct *mm;
-	int ret;
+	ssize_t ret;
 
 	mm = get_task_mm(tsk);
 	if (!mm)
diff --git a/mm/mempolicy.c b/mm/mempolicy.c
index 2da72a5b6..845e125e7 100644
--- a/mm/mempolicy.c
+++ b/mm/mempolicy.c
@@ -732,6 +732,10 @@ static int mbind_range(struct mm_struct *mm, unsigned long start,
 	unsigned long vmstart;
 	unsigned long vmend;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+#endif
+
 	vma = find_vma(mm, start);
 	if (!vma || vma->vm_start > start)
 		return -EFAULT;
@@ -775,6 +779,16 @@ static int mbind_range(struct mm_struct *mm, unsigned long start,
 		err = vma_replace_policy(vma, new_pol);
 		if (err)
 			goto out;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		vma_m = pax_find_mirror_vma(vma);
+		if (vma_m) {
+			err = vma_replace_policy(vma_m, new_pol);
+			if (err)
+				goto out;
+		}
+#endif
+
 	}
 
  out:
@@ -1190,6 +1204,17 @@ static long do_mbind(unsigned long start, unsigned long len,
 
 	if (end < start)
 		return -EINVAL;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC) {
+		if (end > SEGMEXEC_TASK_SIZE)
+			return -EINVAL;
+	} else
+#endif
+
+	if (end > TASK_SIZE)
+		return -EINVAL;
+
 	if (end == start)
 		return 0;
 
@@ -1415,8 +1440,7 @@ SYSCALL_DEFINE4(migrate_pages, pid_t, pid, unsigned long, maxnode,
 	 */
 	tcred = __task_cred(task);
 	if (!uid_eq(cred->euid, tcred->suid) && !uid_eq(cred->euid, tcred->uid) &&
-	    !uid_eq(cred->uid,  tcred->suid) && !uid_eq(cred->uid,  tcred->uid) &&
-	    !capable(CAP_SYS_NICE)) {
+	    !uid_eq(cred->uid,  tcred->suid) && !capable(CAP_SYS_NICE)) {
 		rcu_read_unlock();
 		err = -EPERM;
 		goto out_put;
@@ -1447,6 +1471,15 @@ SYSCALL_DEFINE4(migrate_pages, pid_t, pid, unsigned long, maxnode,
 		goto out;
 	}
 
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	if (mm != current->mm &&
+	    (mm->pax_flags & MF_PAX_RANDMMAP || mm->pax_flags & MF_PAX_SEGMEXEC)) {
+		mmput(mm);
+		err = -EPERM;
+		goto out;
+	}
+#endif
+
 	err = do_migrate_pages(mm, old, new,
 		capable(CAP_SYS_NICE) ? MPOL_MF_MOVE_ALL : MPOL_MF_MOVE);
 
diff --git a/mm/migrate.c b/mm/migrate.c
index f7ee04a5a..41da9dc3a 100644
--- a/mm/migrate.c
+++ b/mm/migrate.c
@@ -1686,8 +1686,7 @@ SYSCALL_DEFINE6(move_pages, pid_t, pid, unsigned long, nr_pages,
 	 */
 	tcred = __task_cred(task);
 	if (!uid_eq(cred->euid, tcred->suid) && !uid_eq(cred->euid, tcred->uid) &&
-	    !uid_eq(cred->uid,  tcred->suid) && !uid_eq(cred->uid,  tcred->uid) &&
-	    !capable(CAP_SYS_NICE)) {
+	    !uid_eq(cred->uid,  tcred->suid) && !capable(CAP_SYS_NICE)) {
 		rcu_read_unlock();
 		err = -EPERM;
 		goto out;
diff --git a/mm/mlock.c b/mm/mlock.c
index 9c91acc0e..d377a3b77 100644
--- a/mm/mlock.c
+++ b/mm/mlock.c
@@ -14,6 +14,7 @@
 #include <linux/pagevec.h>
 #include <linux/mempolicy.h>
 #include <linux/syscalls.h>
+#include <linux/security.h>
 #include <linux/sched.h>
 #include <linux/export.h>
 #include <linux/rmap.h>
@@ -576,7 +577,7 @@ static int apply_vma_lock_flags(unsigned long start, size_t len,
 {
 	unsigned long nstart, end, tmp;
 	struct vm_area_struct * vma, * prev;
-	int error;
+	int error = 0;
 
 	VM_BUG_ON(offset_in_page(start));
 	VM_BUG_ON(len != PAGE_ALIGN(len));
@@ -585,6 +586,9 @@ static int apply_vma_lock_flags(unsigned long start, size_t len,
 		return -EINVAL;
 	if (end == start)
 		return 0;
+	if (end > TASK_SIZE)
+		return -EINVAL;
+
 	vma = find_vma(current->mm, start);
 	if (!vma || vma->vm_start > start)
 		return -ENOMEM;
@@ -594,8 +598,14 @@ static int apply_vma_lock_flags(unsigned long start, size_t len,
 		prev = vma;
 
 	for (nstart = start ; ; ) {
-		vm_flags_t newflags = vma->vm_flags & VM_LOCKED_CLEAR_MASK;
+		vm_flags_t newflags;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		if ((current->mm->pax_flags & MF_PAX_SEGMEXEC) && (vma->vm_start >= SEGMEXEC_TASK_SIZE))
+			break;
+#endif
 
+		newflags = vma->vm_flags & VM_LOCKED_CLEAR_MASK;
 		newflags |= flags;
 
 		/* Here we know that  vma->vm_start <= nstart < vma->vm_end. */
@@ -644,6 +654,10 @@ static __must_check int do_mlock(unsigned long start, size_t len, vm_flags_t fla
 	locked += current->mm->locked_vm;
 
 	/* check against resource limits */
+	if (locked > (ULONG_MAX >> PAGE_SHIFT))
+		gr_learn_resource(current, RLIMIT_MEMLOCK, ULONG_MAX, 1);
+	else
+		gr_learn_resource(current, RLIMIT_MEMLOCK, locked << PAGE_SHIFT, 1);
 	if ((locked <= lock_limit) || capable(CAP_IPC_LOCK))
 		error = apply_vma_lock_flags(start, len, flags);
 
@@ -725,6 +739,11 @@ static int apply_mlockall_flags(int flags)
 	for (vma = current->mm->mmap; vma ; vma = prev->vm_next) {
 		vm_flags_t newflags;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+		if ((current->mm->pax_flags & MF_PAX_SEGMEXEC) && (vma->vm_start >= SEGMEXEC_TASK_SIZE))
+			break;
+#endif
+
 		newflags = vma->vm_flags & VM_LOCKED_CLEAR_MASK;
 		newflags |= to_add;
 
@@ -757,6 +776,10 @@ SYSCALL_DEFINE1(mlockall, int, flags)
 		return -EINTR;
 
 	ret = -ENOMEM;
+	if (current->mm->total_vm > (ULONG_MAX >> PAGE_SHIFT))
+		gr_learn_resource(current, RLIMIT_MEMLOCK, ULONG_MAX, 1);
+	else
+		gr_learn_resource(current, RLIMIT_MEMLOCK, current->mm->total_vm << PAGE_SHIFT, 1);
 	if (!(flags & MCL_CURRENT) || (current->mm->total_vm <= lock_limit) ||
 	    capable(CAP_IPC_LOCK))
 		ret = apply_mlockall_flags(flags);
diff --git a/mm/mm_init.c b/mm/mm_init.c
index 5b72266b4..dc04ce544 100644
--- a/mm/mm_init.c
+++ b/mm/mm_init.c
@@ -169,7 +169,7 @@ static int __meminit mm_compute_batch_notifier(struct notifier_block *self,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block compute_batch_nb __meminitdata = {
+static struct notifier_block compute_batch_nb = {
 	.notifier_call = mm_compute_batch_notifier,
 	.priority = IPC_CALLBACK_PRI, /* use lowest priority */
 };
diff --git a/mm/mmap.c b/mm/mmap.c
index ca9d91bca..b2438f13a 100644
--- a/mm/mmap.c
+++ b/mm/mmap.c
@@ -44,6 +44,7 @@
 #include <linux/userfaultfd_k.h>
 #include <linux/moduleparam.h>
 #include <linux/pkeys.h>
+#include <linux/random.h>
 
 #include <asm/uaccess.h>
 #include <asm/cacheflush.h>
@@ -70,6 +71,16 @@ int mmap_rnd_compat_bits __read_mostly = CONFIG_ARCH_MMAP_RND_COMPAT_BITS;
 static bool ignore_rlimit_data;
 core_param(ignore_rlimit_data, ignore_rlimit_data, bool, 0644);
 
+static inline void verify_mm_writelocked(struct mm_struct *mm)
+{
+#if defined(CONFIG_DEBUG_VM) || defined(CONFIG_PAX)
+	if (unlikely(down_read_trylock(&mm->mmap_sem))) {
+		up_read(&mm->mmap_sem);
+		BUG();
+	}
+#endif
+}
+
 static void unmap_region(struct mm_struct *mm,
 		struct vm_area_struct *vma, struct vm_area_struct *prev,
 		unsigned long start, unsigned long end);
@@ -89,16 +100,25 @@ static void unmap_region(struct mm_struct *mm,
  *		x: (no) no	x: (no) yes	x: (no) yes	x: (yes) yes
  *
  */
-pgprot_t protection_map[16] = {
+pgprot_t protection_map[16] __read_only = {
 	__P000, __P001, __P010, __P011, __P100, __P101, __P110, __P111,
 	__S000, __S001, __S010, __S011, __S100, __S101, __S110, __S111
 };
 
-pgprot_t vm_get_page_prot(unsigned long vm_flags)
+pgprot_t vm_get_page_prot(vm_flags_t vm_flags)
 {
-	return __pgprot(pgprot_val(protection_map[vm_flags &
+	pgprot_t prot = __pgprot(pgprot_val(protection_map[vm_flags &
 				(VM_READ|VM_WRITE|VM_EXEC|VM_SHARED)]) |
 			pgprot_val(arch_vm_get_page_prot(vm_flags)));
+
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_X86_32)
+	if (!(__supported_pte_mask & _PAGE_NX) &&
+	    (vm_flags & (VM_PAGEEXEC | VM_EXEC)) == VM_PAGEEXEC &&
+	    (vm_flags & (VM_READ | VM_WRITE)))
+		prot = __pgprot(pte_val(pte_exprotect(__pte(pgprot_val(prot)))));
+#endif
+
+	return prot;
 }
 EXPORT_SYMBOL(vm_get_page_prot);
 
@@ -160,6 +180,7 @@ static struct vm_area_struct *remove_vma(struct vm_area_struct *vma)
 	struct vm_area_struct *next = vma->vm_next;
 
 	might_sleep();
+	BUG_ON(vma->vm_mirror);
 	if (vma->vm_ops && vma->vm_ops->close)
 		vma->vm_ops->close(vma);
 	if (vma->vm_file)
@@ -173,6 +194,7 @@ static int do_brk(unsigned long addr, unsigned long len);
 
 SYSCALL_DEFINE1(brk, unsigned long, brk)
 {
+	unsigned long rlim;
 	unsigned long retval;
 	unsigned long newbrk, oldbrk;
 	struct mm_struct *mm = current->mm;
@@ -204,7 +226,13 @@ SYSCALL_DEFINE1(brk, unsigned long, brk)
 	 * segment grow beyond its set limit the in case where the limit is
 	 * not page aligned -Ram Gupta
 	 */
-	if (check_data_rlimit(rlimit(RLIMIT_DATA), brk, mm->start_brk,
+	rlim = rlimit(RLIMIT_DATA);
+#ifdef CONFIG_GRKERNSEC_PROC_MEMMAP
+	/* force a minimum 16MB brk heap on setuid/setgid binaries */
+	if (rlim < (4096 * PAGE_SIZE) && (get_dumpable(mm) != SUID_DUMP_USER) && gr_is_global_nonroot(current_uid()))
+		rlim = 4096 * PAGE_SIZE;
+#endif
+	if (check_data_rlimit(rlim, brk, mm->start_brk,
 			      mm->end_data, mm->start_data))
 		goto out;
 
@@ -879,6 +907,12 @@ can_vma_merge_before(struct vm_area_struct *vma, unsigned long vm_flags,
 		     pgoff_t vm_pgoff,
 		     struct vm_userfaultfd_ctx vm_userfaultfd_ctx)
 {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((vma->vm_mm->pax_flags & MF_PAX_SEGMEXEC) && vma->vm_start == SEGMEXEC_TASK_SIZE)
+		return 0;
+#endif
+
 	if (is_mergeable_vma(vma, file, vm_flags, vm_userfaultfd_ctx) &&
 	    is_mergeable_anon_vma(anon_vma, vma->anon_vma, vma)) {
 		if (vma->vm_pgoff == vm_pgoff)
@@ -900,6 +934,12 @@ can_vma_merge_after(struct vm_area_struct *vma, unsigned long vm_flags,
 		    pgoff_t vm_pgoff,
 		    struct vm_userfaultfd_ctx vm_userfaultfd_ctx)
 {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((vma->vm_mm->pax_flags & MF_PAX_SEGMEXEC) && vma->vm_end == SEGMEXEC_TASK_SIZE)
+		return 0;
+#endif
+
 	if (is_mergeable_vma(vma, file, vm_flags, vm_userfaultfd_ctx) &&
 	    is_mergeable_anon_vma(anon_vma, vma->anon_vma, vma)) {
 		pgoff_t vm_pglen;
@@ -950,6 +990,13 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 	struct vm_area_struct *area, *next;
 	int err;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	unsigned long addr_m = addr + SEGMEXEC_TASK_SIZE, end_m = end + SEGMEXEC_TASK_SIZE;
+	struct vm_area_struct *area_m = NULL, *next_m = NULL, *prev_m = NULL;
+
+	BUG_ON((mm->pax_flags & MF_PAX_SEGMEXEC) && SEGMEXEC_TASK_SIZE < end);
+#endif
+
 	/*
 	 * We later require that vma->vm_flags == vm_flags,
 	 * so this tests vma->vm_flags & VM_SPECIAL, too.
@@ -965,6 +1012,15 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 	if (next && next->vm_end == end)		/* cases 6, 7, 8 */
 		next = next->vm_next;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (prev)
+		prev_m = pax_find_mirror_vma(prev);
+	if (area)
+		area_m = pax_find_mirror_vma(area);
+	if (next)
+		next_m = pax_find_mirror_vma(next);
+#endif
+
 	/*
 	 * Can it merge with the predecessor?
 	 */
@@ -987,9 +1043,24 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 							/* cases 1, 6 */
 			err = vma_adjust(prev, prev->vm_start,
 				next->vm_end, prev->vm_pgoff, NULL);
-		} else					/* cases 2, 5, 7 */
+
+#ifdef CONFIG_PAX_SEGMEXEC
+			if (!err && prev_m)
+				err = vma_adjust(prev_m, prev_m->vm_start,
+					next_m->vm_end, prev_m->vm_pgoff, NULL);
+#endif
+
+		} else {				/* cases 2, 5, 7 */
 			err = vma_adjust(prev, prev->vm_start,
 				end, prev->vm_pgoff, NULL);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+			if (!err && prev_m)
+				err = vma_adjust(prev_m, prev_m->vm_start,
+						end_m, prev_m->vm_pgoff, NULL);
+#endif
+
+		}
 		if (err)
 			return NULL;
 		khugepaged_enter_vma_merge(prev, vm_flags);
@@ -1004,12 +1075,27 @@ struct vm_area_struct *vma_merge(struct mm_struct *mm,
 			can_vma_merge_before(next, vm_flags,
 					     anon_vma, file, pgoff+pglen,
 					     vm_userfaultfd_ctx)) {
-		if (prev && addr < prev->vm_end)	/* case 4 */
+		if (prev && addr < prev->vm_end) {	/* case 4 */
 			err = vma_adjust(prev, prev->vm_start,
 				addr, prev->vm_pgoff, NULL);
-		else					/* cases 3, 8 */
+
+#ifdef CONFIG_PAX_SEGMEXEC
+			if (!err && prev_m)
+				err = vma_adjust(prev_m, prev_m->vm_start,
+						addr_m, prev_m->vm_pgoff, NULL);
+#endif
+
+		} else {				/* cases 3, 8 */
 			err = vma_adjust(area, addr, next->vm_end,
 				next->vm_pgoff - pglen, NULL);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+			if (!err && area_m)
+				err = vma_adjust(area_m, addr_m, next_m->vm_end,
+						next_m->vm_pgoff - pglen, NULL);
+#endif
+
+		}
 		if (err)
 			return NULL;
 		khugepaged_enter_vma_merge(area, vm_flags);
@@ -1139,6 +1225,10 @@ static inline int mlock_future_check(struct mm_struct *mm,
 		locked += mm->locked_vm;
 		lock_limit = rlimit(RLIMIT_MEMLOCK);
 		lock_limit >>= PAGE_SHIFT;
+		if (locked > (ULONG_MAX >> PAGE_SHIFT))
+			gr_learn_resource(current, RLIMIT_MEMLOCK, ULONG_MAX, 1);
+		else
+			gr_learn_resource(current, RLIMIT_MEMLOCK, locked << PAGE_SHIFT, 1);
 		if (locked > lock_limit && !capable(CAP_IPC_LOCK))
 			return -EAGAIN;
 	}
@@ -1167,7 +1257,7 @@ unsigned long do_mmap(struct file *file, unsigned long addr,
 	 * (the exception is when the underlying filesystem is noexec
 	 *  mounted, in which case we dont add PROT_EXEC.)
 	 */
-	if ((prot & PROT_READ) && (current->personality & READ_IMPLIES_EXEC))
+	if ((prot & (PROT_READ | PROT_WRITE)) && (current->personality & READ_IMPLIES_EXEC))
 		if (!(file && path_noexec(&file->f_path)))
 			prot |= PROT_EXEC;
 
@@ -1190,7 +1280,7 @@ unsigned long do_mmap(struct file *file, unsigned long addr,
 	/* Obtain the address to map to. we verify (or select) it and ensure
 	 * that it represents a valid section of the address space.
 	 */
-	addr = get_unmapped_area(file, addr, len, pgoff, flags);
+	addr = get_unmapped_area(file, addr, len, pgoff, flags | ((prot & PROT_EXEC) ? MAP_EXECUTABLE : 0));
 	if (offset_in_page(addr))
 		return addr;
 
@@ -1207,6 +1297,43 @@ unsigned long do_mmap(struct file *file, unsigned long addr,
 	vm_flags |= calc_vm_prot_bits(prot, pkey) | calc_vm_flag_bits(flags) |
 			mm->def_flags | VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC;
 
+#ifdef CONFIG_PAX_MPROTECT
+	if (mm->pax_flags & MF_PAX_MPROTECT) {
+
+#ifdef CONFIG_GRKERNSEC_RWXMAP_LOG
+		if (file && !pgoff && (vm_flags & VM_EXEC) && mm->binfmt &&
+		    mm->binfmt->handle_mmap)
+			mm->binfmt->handle_mmap(file);
+#endif
+
+#ifndef CONFIG_PAX_MPROTECT_COMPAT
+		if ((vm_flags & (VM_WRITE | VM_EXEC)) == (VM_WRITE | VM_EXEC)) {
+			gr_log_rwxmmap(file);
+
+#ifdef CONFIG_PAX_EMUPLT
+			vm_flags &= ~VM_EXEC;
+#else
+			return -EPERM;
+#endif
+
+		}
+
+		if (!(vm_flags & VM_EXEC))
+			vm_flags &= ~VM_MAYEXEC;
+#else
+		if ((vm_flags & (VM_WRITE | VM_EXEC)) != VM_EXEC)
+			vm_flags &= ~(VM_EXEC | VM_MAYEXEC);
+#endif
+		else
+			vm_flags &= ~VM_MAYWRITE;
+	}
+#endif
+
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_X86_32)
+	if ((mm->pax_flags & MF_PAX_PAGEEXEC) && file)
+		vm_flags &= ~VM_PAGEEXEC;
+#endif
+
 	if (flags & MAP_LOCKED)
 		if (!can_do_mlock())
 			return -EPERM;
@@ -1294,6 +1421,9 @@ unsigned long do_mmap(struct file *file, unsigned long addr,
 			vm_flags |= VM_NORESERVE;
 	}
 
+	if (!gr_acl_handle_mmap(file, prot))
+		return -EACCES;
+	
 	addr = mmap_region(file, addr, len, vm_flags, pgoff);
 	if (!IS_ERR_VALUE(addr) &&
 	    ((vm_flags & VM_LOCKED) ||
@@ -1387,7 +1517,7 @@ int vma_wants_writenotify(struct vm_area_struct *vma)
 	const struct vm_operations_struct *vm_ops = vma->vm_ops;
 
 	/* If it was private or non-writable, the write bit is already clear */
-	if ((vm_flags & (VM_WRITE|VM_SHARED)) != ((VM_WRITE|VM_SHARED)))
+	if ((vm_flags & (VM_WRITE|VM_SHARED)) != (VM_WRITE|VM_SHARED))
 		return 0;
 
 	/* The backer wishes to know when pages are first written to? */
@@ -1438,7 +1568,22 @@ unsigned long mmap_region(struct file *file, unsigned long addr,
 	struct rb_node **rb_link, *rb_parent;
 	unsigned long charged = 0;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m = NULL;
+#endif
+
+	/*
+	 * mm->mmap_sem is required to protect against another thread
+	 * changing the mappings in case we sleep.
+	 */
+	verify_mm_writelocked(mm);
+
 	/* Check against address space limit. */
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP) || (vm_flags & (VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)))
+#endif
+
 	if (!may_expand_vm(mm, vm_flags, len >> PAGE_SHIFT)) {
 		unsigned long nr_pages;
 
@@ -1458,6 +1603,7 @@ unsigned long mmap_region(struct file *file, unsigned long addr,
 			      &rb_parent)) {
 		if (do_munmap(mm, addr, len))
 			return -ENOMEM;
+		BUG_ON(find_vma_links(mm, addr, addr + len, &prev, &rb_link, &rb_parent));
 	}
 
 	/*
@@ -1489,6 +1635,16 @@ unsigned long mmap_region(struct file *file, unsigned long addr,
 		goto unacct_error;
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((mm->pax_flags & MF_PAX_SEGMEXEC) && (vm_flags & VM_EXEC)) {
+		vma_m = kmem_cache_zalloc(vm_area_cachep, GFP_KERNEL);
+		if (!vma_m) {
+			error = -ENOMEM;
+			goto free_vma;
+		}
+	}
+#endif
+
 	vma->vm_mm = mm;
 	vma->vm_start = addr;
 	vma->vm_end = addr + len;
@@ -1519,6 +1675,13 @@ unsigned long mmap_region(struct file *file, unsigned long addr,
 		if (error)
 			goto unmap_and_free_vma;
 
+#if defined(CONFIG_PAX_PAGEEXEC) && defined(CONFIG_X86_32)
+		if ((mm->pax_flags & MF_PAX_PAGEEXEC) && !(vma->vm_flags & VM_SPECIAL)) {
+			vma->vm_flags |= VM_PAGEEXEC;
+			vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
+		}
+#endif
+
 		/* Can addr have changed??
 		 *
 		 * Answer: Yes, several device drivers can do it in their
@@ -1537,6 +1700,12 @@ unsigned long mmap_region(struct file *file, unsigned long addr,
 	}
 
 	vma_link(mm, vma, prev, rb_link, rb_parent);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (vma_m)
+		BUG_ON(pax_mirror_vma(vma_m, vma));
+#endif
+
 	/* Once vma denies write, undo our temporary denial count */
 	if (file) {
 		if (vm_flags & VM_SHARED)
@@ -1549,6 +1718,7 @@ out:
 	perf_event_mmap(vma);
 
 	vm_stat_account(mm, vm_flags, len >> PAGE_SHIFT);
+	track_exec_limit(mm, addr, addr + len, vm_flags);
 	if (vm_flags & VM_LOCKED) {
 		if (!((vm_flags & VM_SPECIAL) || is_vm_hugetlb_page(vma) ||
 					vma == get_gate_vma(current->mm)))
@@ -1586,6 +1756,12 @@ allow_write_and_free_vma:
 	if (vm_flags & VM_DENYWRITE)
 		allow_write_access(file);
 free_vma:
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (vma_m)
+		kmem_cache_free(vm_area_cachep, vma_m);
+#endif
+
 	kmem_cache_free(vm_area_cachep, vma);
 unacct_error:
 	if (charged)
@@ -1593,7 +1769,54 @@ unacct_error:
 	return error;
 }
 
-unsigned long unmapped_area(struct vm_unmapped_area_info *info)
+#ifdef CONFIG_GRKERNSEC_RAND_THREADSTACK
+unsigned long gr_rand_threadstack_offset(const struct mm_struct *mm, const struct file *filp, unsigned long flags)
+{
+	if ((mm->pax_flags & MF_PAX_RANDMMAP) && !filp && (flags & MAP_STACK))
+		return ((prandom_u32() & 0xFF) + 1) << PAGE_SHIFT;
+
+	return 0;
+}
+#endif
+
+bool check_heap_stack_gap(const struct vm_area_struct *vma, unsigned long addr, unsigned long len, unsigned long offset)
+{
+	if (!vma) {
+#ifdef CONFIG_STACK_GROWSUP
+		if (addr > sysctl_heap_stack_gap)
+			vma = find_vma(current->mm, addr - sysctl_heap_stack_gap);
+		else
+			vma = find_vma(current->mm, 0);
+		if (vma && (vma->vm_flags & VM_GROWSUP))
+			return false;
+#endif
+		return true;
+	}
+
+	if (addr + len > vma->vm_start)
+		return false;
+
+	if (vma->vm_flags & VM_GROWSDOWN)
+		return sysctl_heap_stack_gap <= vma->vm_start - addr - len;
+#ifdef CONFIG_STACK_GROWSUP
+	else if (vma->vm_prev && (vma->vm_prev->vm_flags & VM_GROWSUP))
+		return addr - vma->vm_prev->vm_end >= sysctl_heap_stack_gap;
+#endif
+	else if (offset)
+		return offset <= vma->vm_start - addr - len;
+
+	return true;
+}
+
+unsigned long skip_heap_stack_gap(const struct vm_area_struct *vma, unsigned long flag, unsigned long gap_start, unsigned long gap_end)
+{
+	if (!vma || !(vma->vm_flags & flag))
+		return 0;
+
+	return min(sysctl_heap_stack_gap, gap_end - gap_start);
+}
+
+unsigned long unmapped_area(const struct vm_unmapped_area_info *info)
 {
 	/*
 	 * We implement the search by looking for an rbtree node that
@@ -1646,6 +1869,15 @@ check_current:
 		/* Check if current node has a suitable gap */
 		if (gap_start > high_limit)
 			return -ENOMEM;
+
+		gap_start += skip_heap_stack_gap(vma->vm_prev, VM_GROWSUP, gap_start, gap_end);
+		gap_end -= skip_heap_stack_gap(vma, VM_GROWSDOWN, gap_start, gap_end);
+
+		if (gap_end - gap_start > info->threadstack_offset)
+			gap_start += info->threadstack_offset;
+		else
+			gap_start = gap_end;
+
 		if (gap_end >= low_limit && gap_end - gap_start >= length)
 			goto found;
 
@@ -1695,7 +1927,7 @@ found:
 	return gap_start;
 }
 
-unsigned long unmapped_area_topdown(struct vm_unmapped_area_info *info)
+unsigned long unmapped_area_topdown(const struct vm_unmapped_area_info *info)
 {
 	struct mm_struct *mm = current->mm;
 	struct vm_area_struct *vma;
@@ -1749,6 +1981,15 @@ check_current:
 		gap_end = vma->vm_start;
 		if (gap_end < low_limit)
 			return -ENOMEM;
+
+		gap_start += skip_heap_stack_gap(vma->vm_prev, VM_GROWSUP, gap_start, gap_end);
+		gap_end -= skip_heap_stack_gap(vma, VM_GROWSDOWN, gap_start, gap_end);
+
+		if (gap_end - gap_start > info->threadstack_offset)
+			gap_end -= info->threadstack_offset;
+		else
+			gap_end = gap_start;
+
 		if (gap_start <= high_limit && gap_end - gap_start >= length)
 			goto found;
 
@@ -1812,6 +2053,7 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	struct mm_struct *mm = current->mm;
 	struct vm_area_struct *vma;
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 
 	if (len > TASK_SIZE - mmap_min_addr)
 		return -ENOMEM;
@@ -1819,11 +2061,15 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	if (flags & MAP_FIXED)
 		return addr;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	if (addr) {
 		addr = PAGE_ALIGN(addr);
 		vma = find_vma(mm, addr);
 		if (TASK_SIZE - len >= addr && addr >= mmap_min_addr &&
-		    (!vma || addr + len <= vma->vm_start))
+		    check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -1832,6 +2078,7 @@ arch_get_unmapped_area(struct file *filp, unsigned long addr,
 	info.low_limit = mm->mmap_base;
 	info.high_limit = TASK_SIZE;
 	info.align_mask = 0;
+	info.threadstack_offset = offset;
 	return vm_unmapped_area(&info);
 }
 #endif
@@ -1850,6 +2097,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	struct mm_struct *mm = current->mm;
 	unsigned long addr = addr0;
 	struct vm_unmapped_area_info info;
+	unsigned long offset = gr_rand_threadstack_offset(mm, filp, flags);
 
 	/* requested length too big for entire address space */
 	if (len > TASK_SIZE - mmap_min_addr)
@@ -1858,12 +2106,16 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	if (flags & MAP_FIXED)
 		return addr;
 
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP))
+#endif
+
 	/* requesting a specific address */
 	if (addr) {
 		addr = PAGE_ALIGN(addr);
 		vma = find_vma(mm, addr);
 		if (TASK_SIZE - len >= addr && addr >= mmap_min_addr &&
-				(!vma || addr + len <= vma->vm_start))
+				check_heap_stack_gap(vma, addr, len, offset))
 			return addr;
 	}
 
@@ -1872,6 +2124,7 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 	info.low_limit = max(PAGE_SIZE, mmap_min_addr);
 	info.high_limit = mm->mmap_base;
 	info.align_mask = 0;
+	info.threadstack_offset = offset;
 	addr = vm_unmapped_area(&info);
 
 	/*
@@ -1884,6 +2137,12 @@ arch_get_unmapped_area_topdown(struct file *filp, const unsigned long addr0,
 		VM_BUG_ON(addr != -ENOMEM);
 		info.flags = 0;
 		info.low_limit = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+		if (mm->pax_flags & MF_PAX_RANDMMAP)
+			info.low_limit += mm->delta_mmap;
+#endif
+
 		info.high_limit = TASK_SIZE;
 		addr = vm_unmapped_area(&info);
 	}
@@ -1993,6 +2252,28 @@ find_vma_prev(struct mm_struct *mm, unsigned long addr,
 	return vma;
 }
 
+#ifdef CONFIG_PAX_SEGMEXEC
+struct vm_area_struct *pax_find_mirror_vma(struct vm_area_struct *vma)
+{
+	struct vm_area_struct *vma_m;
+
+	BUG_ON(!vma || vma->vm_start >= vma->vm_end);
+	if (!(vma->vm_mm->pax_flags & MF_PAX_SEGMEXEC) || !(vma->vm_flags & VM_EXEC)) {
+		BUG_ON(vma->vm_mirror);
+		return NULL;
+	}
+	BUG_ON(vma->vm_start < SEGMEXEC_TASK_SIZE && SEGMEXEC_TASK_SIZE < vma->vm_end);
+	vma_m = vma->vm_mirror;
+	BUG_ON(!vma_m || vma_m->vm_mirror != vma);
+	BUG_ON(vma->vm_file != vma_m->vm_file);
+	BUG_ON(vma->vm_end - vma->vm_start != vma_m->vm_end - vma_m->vm_start);
+	BUG_ON(vma->vm_pgoff != vma_m->vm_pgoff);
+	BUG_ON(vma->anon_vma != vma_m->anon_vma && vma->anon_vma->root != vma_m->anon_vma->root);
+	BUG_ON((vma->vm_flags ^ vma_m->vm_flags) & ~(VM_WRITE | VM_MAYWRITE | VM_ACCOUNT | VM_LOCKED));
+	return vma_m;
+}
+#endif
+
 /*
  * Verify that the stack growth is acceptable and
  * update accounting. This is shared with both the
@@ -2010,8 +2291,7 @@ static int acct_stack_growth(struct vm_area_struct *vma, unsigned long size, uns
 
 	/* Stack limit test */
 	actual_size = size;
-	if (size && (vma->vm_flags & (VM_GROWSUP | VM_GROWSDOWN)))
-		actual_size -= PAGE_SIZE;
+	gr_learn_resource(current, RLIMIT_STACK, actual_size, 1);
 	if (actual_size > READ_ONCE(rlim[RLIMIT_STACK].rlim_cur))
 		return -ENOMEM;
 
@@ -2022,6 +2302,10 @@ static int acct_stack_growth(struct vm_area_struct *vma, unsigned long size, uns
 		locked = mm->locked_vm + grow;
 		limit = READ_ONCE(rlim[RLIMIT_MEMLOCK].rlim_cur);
 		limit >>= PAGE_SHIFT;
+		if (locked > (ULONG_MAX >> PAGE_SHIFT))
+			gr_learn_resource(current, RLIMIT_MEMLOCK, ULONG_MAX, 1);
+		else
+			gr_learn_resource(current, RLIMIT_MEMLOCK, locked << PAGE_SHIFT, 1);
 		if (locked > limit && !capable(CAP_IPC_LOCK))
 			return -ENOMEM;
 	}
@@ -2047,17 +2331,21 @@ static int acct_stack_growth(struct vm_area_struct *vma, unsigned long size, uns
  * PA-RISC uses this for its stack; IA64 for its Register Backing Store.
  * vma is the last one with address > vma->vm_end.  Have to extend vma.
  */
+#ifndef CONFIG_IA64
+static
+#endif
 int expand_upwards(struct vm_area_struct *vma, unsigned long address)
 {
 	struct mm_struct *mm = vma->vm_mm;
 	int error = 0;
+	bool locknext;
 
 	if (!(vma->vm_flags & VM_GROWSUP))
 		return -EFAULT;
 
 	/* Guard against wrapping around to address 0. */
-	if (address < PAGE_ALIGN(address+4))
-		address = PAGE_ALIGN(address+4);
+	if (address < PAGE_ALIGN(address+1))
+		address = PAGE_ALIGN(address+1);
 	else
 		return -ENOMEM;
 
@@ -2065,15 +2353,24 @@ int expand_upwards(struct vm_area_struct *vma, unsigned long address)
 	if (unlikely(anon_vma_prepare(vma)))
 		return -ENOMEM;
 
+	locknext = vma->vm_next && (vma->vm_next->vm_flags & VM_GROWSDOWN);
+	if (locknext && anon_vma_prepare(vma->vm_next))
+		return -ENOMEM;
+
 	/*
 	 * vma->vm_start/vm_end cannot change under us because the caller
 	 * is required to hold the mmap_sem in read mode.  We need the
-	 * anon_vma lock to serialize against concurrent expand_stacks.
+	 * anon_vma locks to serialize against concurrent expand_stacks
+	 * and expand_upwards.
 	 */
 	anon_vma_lock_write(vma->anon_vma);
+	if (locknext)
+		anon_vma_lock_write(vma->vma_next->anon_vma);
 
 	/* Somebody else might have raced and expanded it already */
-	if (address > vma->vm_end) {
+	if (vma->vm_next && (vma->vm_next->vm_flags & (VM_READ | VM_WRITE | VM_EXEC)) && vma->vm_next->vm_start - address < sysctl_heap_stack_gap)
+		error = -ENOMEM;
+	else if (address > vma->vm_end && (!locknext || vma->vm_next->vm_start >= address)) {
 		unsigned long size, grow;
 
 		size = address - vma->vm_start;
@@ -2111,6 +2408,8 @@ int expand_upwards(struct vm_area_struct *vma, unsigned long address)
 			}
 		}
 	}
+	if (locknext)
+		anon_vma_unlock_write(vma->vm_next->anon_vma);
 	anon_vma_unlock_write(vma->anon_vma);
 	khugepaged_enter_vma_merge(vma, vma->vm_flags);
 	validate_mm(mm);
@@ -2126,6 +2425,8 @@ int expand_downwards(struct vm_area_struct *vma,
 {
 	struct mm_struct *mm = vma->vm_mm;
 	int error;
+	bool lockprev = false;
+	struct vm_area_struct *prev;
 
 	address &= PAGE_MASK;
 	error = security_mmap_addr(address);
@@ -2136,6 +2437,15 @@ int expand_downwards(struct vm_area_struct *vma,
 	if (unlikely(anon_vma_prepare(vma)))
 		return -ENOMEM;
 
+	prev = vma->vm_prev;
+#if defined(CONFIG_STACK_GROWSUP) || defined(CONFIG_IA64)
+	lockprev = prev && (prev->vm_flags & VM_GROWSUP);
+#endif
+	if (lockprev && anon_vma_prepare(prev))
+		return -ENOMEM;
+	if (lockprev)
+		anon_vma_lock_write(prev->anon_vma);
+
 	/*
 	 * vma->vm_start/vm_end cannot change under us because the caller
 	 * is required to hold the mmap_sem in read mode.  We need the
@@ -2144,9 +2454,17 @@ int expand_downwards(struct vm_area_struct *vma,
 	anon_vma_lock_write(vma->anon_vma);
 
 	/* Somebody else might have raced and expanded it already */
-	if (address < vma->vm_start) {
+	if (prev && (prev->vm_flags & (VM_READ | VM_WRITE | VM_EXEC)) && address - prev->vm_end < sysctl_heap_stack_gap)
+		error = -ENOMEM;
+	else if (address < vma->vm_start && (!lockprev || prev->vm_end <= address)) {
 		unsigned long size, grow;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+		struct vm_area_struct *vma_m;
+
+		vma_m = pax_find_mirror_vma(vma);
+#endif
+
 		size = vma->vm_end - address;
 		grow = (vma->vm_start - address) >> PAGE_SHIFT;
 
@@ -2174,13 +2492,27 @@ int expand_downwards(struct vm_area_struct *vma,
 				vma->vm_pgoff -= grow;
 				anon_vma_interval_tree_post_update_vma(vma);
 				vma_gap_update(vma);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+				if (vma_m) {
+					anon_vma_interval_tree_pre_update_vma(vma_m);
+					vma_m->vm_start -= grow << PAGE_SHIFT;
+					vma_m->vm_pgoff -= grow;
+					anon_vma_interval_tree_post_update_vma(vma_m);
+					vma_gap_update(vma_m);
+				}
+#endif
+
 				spin_unlock(&mm->page_table_lock);
 
+				track_exec_limit(vma->vm_mm, vma->vm_start, vma->vm_end, vma->vm_flags);
 				perf_event_mmap(vma);
 			}
 		}
 	}
 	anon_vma_unlock_write(vma->anon_vma);
+	if (lockprev)
+		anon_vma_unlock_write(prev->anon_vma);
 	khugepaged_enter_vma_merge(vma, vma->vm_flags);
 	validate_mm(mm);
 	return error;
@@ -2280,6 +2612,13 @@ static void remove_vma_list(struct mm_struct *mm, struct vm_area_struct *vma)
 	do {
 		long nrpages = vma_pages(vma);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+		if ((mm->pax_flags & MF_PAX_SEGMEXEC) && (vma->vm_start >= SEGMEXEC_TASK_SIZE)) {
+			vma = remove_vma(vma);
+			continue;
+		}
+#endif
+
 		if (vma->vm_flags & VM_ACCOUNT)
 			nr_accounted += nrpages;
 		vm_stat_account(mm, vma->vm_flags, -nrpages);
@@ -2324,6 +2663,16 @@ detach_vmas_to_be_unmapped(struct mm_struct *mm, struct vm_area_struct *vma,
 	insertion_point = (prev ? &prev->vm_next : &mm->mmap);
 	vma->vm_prev = NULL;
 	do {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		if (vma->vm_mirror) {
+			BUG_ON(!vma->vm_mirror->vm_mirror || vma->vm_mirror->vm_mirror != vma);
+			vma->vm_mirror->vm_mirror = NULL;
+			vma->vm_mirror->vm_flags &= ~VM_EXEC;
+			vma->vm_mirror = NULL;
+		}
+#endif
+
 		vma_rb_erase(vma, &mm->mm_rb);
 		mm->map_count--;
 		tail_vma = vma;
@@ -2351,14 +2700,33 @@ static int __split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
 	struct vm_area_struct *new;
 	int err;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m, *new_m = NULL;
+	unsigned long addr_m = addr + SEGMEXEC_TASK_SIZE;
+#endif
+
 	if (is_vm_hugetlb_page(vma) && (addr &
 					~(huge_page_mask(hstate_vma(vma)))))
 		return -EINVAL;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma_m = pax_find_mirror_vma(vma);
+#endif
+
 	new = kmem_cache_alloc(vm_area_cachep, GFP_KERNEL);
 	if (!new)
 		return -ENOMEM;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (vma_m) {
+		new_m = kmem_cache_alloc(vm_area_cachep, GFP_KERNEL);
+		if (!new_m) {
+			kmem_cache_free(vm_area_cachep, new);
+			return -ENOMEM;
+		}
+	}
+#endif
+
 	/* most fields are the same, copy all, and then fixup */
 	*new = *vma;
 
@@ -2371,6 +2739,22 @@ static int __split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
 		new->vm_pgoff += ((addr - vma->vm_start) >> PAGE_SHIFT);
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (vma_m) {
+		*new_m = *vma_m;
+		INIT_LIST_HEAD(&new_m->anon_vma_chain);
+		new_m->vm_mirror = new;
+		new->vm_mirror = new_m;
+
+		if (new_below)
+			new_m->vm_end = addr_m;
+		else {
+			new_m->vm_start = addr_m;
+			new_m->vm_pgoff += ((addr_m - vma_m->vm_start) >> PAGE_SHIFT);
+		}
+	}
+#endif
+
 	err = vma_dup_policy(vma, new);
 	if (err)
 		goto out_free_vma;
@@ -2391,6 +2775,38 @@ static int __split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
 	else
 		err = vma_adjust(vma, vma->vm_start, addr, vma->vm_pgoff, new);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (!err && vma_m) {
+		struct mempolicy *pol = vma_policy(new);
+
+		if (anon_vma_clone(new_m, vma_m))
+			goto out_free_mpol;
+
+		mpol_get(pol);
+		set_vma_policy(new_m, pol);
+
+		if (new_m->vm_file)
+			get_file(new_m->vm_file);
+
+		if (new_m->vm_ops && new_m->vm_ops->open)
+			new_m->vm_ops->open(new_m);
+
+		if (new_below)
+			err = vma_adjust(vma_m, addr_m, vma_m->vm_end, vma_m->vm_pgoff +
+				((addr_m - new_m->vm_start) >> PAGE_SHIFT), new_m);
+		else
+			err = vma_adjust(vma_m, vma_m->vm_start, addr_m, vma_m->vm_pgoff, new_m);
+
+		if (err) {
+			if (new_m->vm_ops && new_m->vm_ops->close)
+				new_m->vm_ops->close(new_m);
+			if (new_m->vm_file)
+				fput(new_m->vm_file);
+			mpol_put(pol);
+		}
+	}
+#endif
+
 	/* Success. */
 	if (!err)
 		return 0;
@@ -2400,10 +2816,18 @@ static int __split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
 		new->vm_ops->close(new);
 	if (new->vm_file)
 		fput(new->vm_file);
-	unlink_anon_vmas(new);
  out_free_mpol:
 	mpol_put(vma_policy(new));
  out_free_vma:
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (new_m) {
+		unlink_anon_vmas(new_m);
+		kmem_cache_free(vm_area_cachep, new_m);
+	}
+#endif
+
+	unlink_anon_vmas(new);
 	kmem_cache_free(vm_area_cachep, new);
 	return err;
 }
@@ -2415,6 +2839,15 @@ static int __split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
 int split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
 	      unsigned long addr, int new_below)
 {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC) {
+		BUG_ON(vma->vm_end > SEGMEXEC_TASK_SIZE);
+		if (mm->map_count >= sysctl_max_map_count-1)
+			return -ENOMEM;
+	} else
+#endif
+
 	if (mm->map_count >= sysctl_max_map_count)
 		return -ENOMEM;
 
@@ -2426,11 +2859,30 @@ int split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
  * work.  This now handles partial unmappings.
  * Jeremy Fitzhardinge <jeremy@goop.org>
  */
+#ifdef CONFIG_PAX_SEGMEXEC
+int do_munmap(struct mm_struct *mm, unsigned long start, size_t len)
+{
+	int ret = __do_munmap(mm, start, len);
+	if (ret || !(mm->pax_flags & MF_PAX_SEGMEXEC))
+		return ret;
+
+	return __do_munmap(mm, start + SEGMEXEC_TASK_SIZE, len);
+}
+
+int __do_munmap(struct mm_struct *mm, unsigned long start, size_t len)
+#else
 int do_munmap(struct mm_struct *mm, unsigned long start, size_t len)
+#endif
 {
 	unsigned long end;
 	struct vm_area_struct *vma, *prev, *last;
 
+	/*
+	 * mm->mmap_sem is required to protect against another thread
+	 * changing the mappings in case we sleep.
+	 */
+	verify_mm_writelocked(mm);
+
 	if ((offset_in_page(start)) || start > TASK_SIZE || len > TASK_SIZE-start)
 		return -EINVAL;
 
@@ -2508,6 +2960,8 @@ int do_munmap(struct mm_struct *mm, unsigned long start, size_t len)
 	/* Fix up all other VM information */
 	remove_vma_list(mm, vma);
 
+	track_exec_limit(mm, start, end, 0UL);
+
 	return 0;
 }
 
@@ -2516,6 +2970,12 @@ int vm_munmap(unsigned long start, size_t len)
 	int ret;
 	struct mm_struct *mm = current->mm;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((mm->pax_flags & MF_PAX_SEGMEXEC) &&
+	    (len > SEGMEXEC_TASK_SIZE || start > SEGMEXEC_TASK_SIZE-len))
+		return -EINVAL;
+#endif
+
 	if (down_write_killable(&mm->mmap_sem))
 		return -EINTR;
 
@@ -2572,6 +3032,11 @@ SYSCALL_DEFINE5(remap_file_pages, unsigned long, start, unsigned long, size,
 
 	vma = find_vma(mm, start);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (vma && (mm->pax_flags & MF_PAX_SEGMEXEC) && (vma->vm_flags & VM_MAYEXEC))
+		goto out;
+#endif
+
 	if (!vma || !(vma->vm_flags & VM_SHARED))
 		goto out;
 
@@ -2638,16 +3103,6 @@ out:
 	return ret;
 }
 
-static inline void verify_mm_writelocked(struct mm_struct *mm)
-{
-#ifdef CONFIG_DEBUG_VM
-	if (unlikely(down_read_trylock(&mm->mmap_sem))) {
-		WARN_ON(1);
-		up_read(&mm->mmap_sem);
-	}
-#endif
-}
-
 /*
  *  this is really a simplified "do_mmap".  it only handles
  *  anonymous maps.  eventually we may be able to do some
@@ -2661,6 +3116,7 @@ static int do_brk(unsigned long addr, unsigned long request)
 	struct rb_node **rb_link, *rb_parent;
 	pgoff_t pgoff = addr >> PAGE_SHIFT;
 	int error;
+	unsigned long charged;
 
 	len = PAGE_ALIGN(request);
 	if (len < request)
@@ -2670,10 +3126,24 @@ static int do_brk(unsigned long addr, unsigned long request)
 
 	flags = VM_DATA_DEFAULT_FLAGS | VM_ACCOUNT | mm->def_flags;
 
+#if defined(CONFIG_PAX_PAGEEXEC) || defined(CONFIG_PAX_SEGMEXEC)
+	if (mm->pax_flags & (MF_PAX_PAGEEXEC | MF_PAX_SEGMEXEC)) {
+		flags &= ~VM_EXEC;
+
+#ifdef CONFIG_PAX_MPROTECT
+		if (mm->pax_flags & MF_PAX_MPROTECT)
+			flags &= ~VM_MAYEXEC;
+#endif
+
+	}
+#endif
+
 	error = get_unmapped_area(NULL, addr, len, 0, MAP_FIXED);
 	if (offset_in_page(error))
 		return error;
 
+	charged = len >> PAGE_SHIFT;
+
 	error = mlock_future_check(mm, mm->def_flags, len);
 	if (error)
 		return error;
@@ -2691,16 +3161,17 @@ static int do_brk(unsigned long addr, unsigned long request)
 			      &rb_parent)) {
 		if (do_munmap(mm, addr, len))
 			return -ENOMEM;
+		BUG_ON(find_vma_links(mm, addr, addr + len, &prev, &rb_link, &rb_parent));
 	}
 
 	/* Check against address space limits *after* clearing old maps... */
-	if (!may_expand_vm(mm, flags, len >> PAGE_SHIFT))
+	if (!may_expand_vm(mm, flags, charged))
 		return -ENOMEM;
 
 	if (mm->map_count > sysctl_max_map_count)
 		return -ENOMEM;
 
-	if (security_vm_enough_memory_mm(mm, len >> PAGE_SHIFT))
+	if (security_vm_enough_memory_mm(mm, charged))
 		return -ENOMEM;
 
 	/* Can we just expand an old private anonymous mapping? */
@@ -2714,7 +3185,7 @@ static int do_brk(unsigned long addr, unsigned long request)
 	 */
 	vma = kmem_cache_zalloc(vm_area_cachep, GFP_KERNEL);
 	if (!vma) {
-		vm_unacct_memory(len >> PAGE_SHIFT);
+		vm_unacct_memory(charged);
 		return -ENOMEM;
 	}
 
@@ -2728,11 +3199,12 @@ static int do_brk(unsigned long addr, unsigned long request)
 	vma_link(mm, vma, prev, rb_link, rb_parent);
 out:
 	perf_event_mmap(vma);
-	mm->total_vm += len >> PAGE_SHIFT;
-	mm->data_vm += len >> PAGE_SHIFT;
+	mm->total_vm += charged;
+	mm->data_vm += charged;
 	if (flags & VM_LOCKED)
-		mm->locked_vm += (len >> PAGE_SHIFT);
+		mm->locked_vm += charged;
 	vma->vm_flags |= VM_SOFTDIRTY;
+	track_exec_limit(mm, addr, addr + len, flags);
 	return 0;
 }
 
@@ -2796,6 +3268,7 @@ void exit_mmap(struct mm_struct *mm)
 	while (vma) {
 		if (vma->vm_flags & VM_ACCOUNT)
 			nr_accounted += vma_pages(vma);
+		vma->vm_mirror = NULL;
 		vma = remove_vma(vma);
 	}
 	vm_unacct_memory(nr_accounted);
@@ -2810,6 +3283,10 @@ int insert_vm_struct(struct mm_struct *mm, struct vm_area_struct *vma)
 	struct vm_area_struct *prev;
 	struct rb_node **rb_link, *rb_parent;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m = NULL;
+#endif
+
 	if (find_vma_links(mm, vma->vm_start, vma->vm_end,
 			   &prev, &rb_link, &rb_parent))
 		return -ENOMEM;
@@ -2817,6 +3294,9 @@ int insert_vm_struct(struct mm_struct *mm, struct vm_area_struct *vma)
 	     security_vm_enough_memory_mm(mm, vma_pages(vma)))
 		return -ENOMEM;
 
+	if (security_mmap_addr(vma->vm_start))
+		return -EPERM;
+
 	/*
 	 * The vm_pgoff of a purely anonymous vma should be irrelevant
 	 * until its first write fault, when page's anon_vma and index
@@ -2834,7 +3314,21 @@ int insert_vm_struct(struct mm_struct *mm, struct vm_area_struct *vma)
 		vma->vm_pgoff = vma->vm_start >> PAGE_SHIFT;
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((mm->pax_flags & MF_PAX_SEGMEXEC) && (vma->vm_flags & VM_EXEC)) {
+		vma_m = kmem_cache_zalloc(vm_area_cachep, GFP_KERNEL);
+		if (!vma_m)
+			return -ENOMEM;
+	}
+#endif
+
 	vma_link(mm, vma, prev, rb_link, rb_parent);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (vma_m)
+		BUG_ON(pax_mirror_vma(vma_m, vma));
+#endif
+
 	return 0;
 }
 
@@ -2853,6 +3347,8 @@ struct vm_area_struct *copy_vma(struct vm_area_struct **vmap,
 	struct rb_node **rb_link, *rb_parent;
 	bool faulted_in_anon_vma = true;
 
+	BUG_ON(vma->vm_mirror);
+
 	/*
 	 * If anonymous vma has not yet been faulted, update new pgoff
 	 * to match new location, to increase its chance of merging.
@@ -2919,27 +3415,70 @@ out:
 	return NULL;
 }
 
+#ifdef CONFIG_PAX_SEGMEXEC
+long pax_mirror_vma(struct vm_area_struct *vma_m, struct vm_area_struct *vma)
+{
+	struct vm_area_struct *prev_m;
+	struct rb_node **rb_link_m, *rb_parent_m;
+	struct mempolicy *pol_m;
+
+	BUG_ON(!(vma->vm_mm->pax_flags & MF_PAX_SEGMEXEC) || !(vma->vm_flags & VM_EXEC));
+	BUG_ON(vma->vm_mirror || vma_m->vm_mirror);
+	BUG_ON(!mpol_equal(vma_policy(vma), vma_policy(vma_m)));
+	*vma_m = *vma;
+	INIT_LIST_HEAD(&vma_m->anon_vma_chain);
+	if (anon_vma_clone(vma_m, vma))
+		return -ENOMEM;
+	pol_m = vma_policy(vma_m);
+	mpol_get(pol_m);
+	set_vma_policy(vma_m, pol_m);
+	vma_m->vm_start += SEGMEXEC_TASK_SIZE;
+	vma_m->vm_end += SEGMEXEC_TASK_SIZE;
+	vma_m->vm_flags &= ~(VM_WRITE | VM_MAYWRITE | VM_ACCOUNT | VM_LOCKED);
+	vma_m->vm_page_prot = vm_get_page_prot(vma_m->vm_flags);
+	if (vma_m->vm_file)
+		get_file(vma_m->vm_file);
+	if (vma_m->vm_ops && vma_m->vm_ops->open)
+		vma_m->vm_ops->open(vma_m);
+	BUG_ON(find_vma_links(vma->vm_mm, vma_m->vm_start, vma_m->vm_end, &prev_m, &rb_link_m, &rb_parent_m));
+	vma_link(vma->vm_mm, vma_m, prev_m, rb_link_m, rb_parent_m);
+	vma_m->vm_mirror = vma;
+	vma->vm_mirror = vma_m;
+	return 0;
+}
+#endif
+
 /*
  * Return true if the calling process may expand its vm space by the passed
  * number of pages
  */
 bool may_expand_vm(struct mm_struct *mm, vm_flags_t flags, unsigned long npages)
 {
+	if ((mm->total_vm + npages) > (ULONG_MAX >> PAGE_SHIFT))
+		gr_learn_resource(current, RLIMIT_AS, ULONG_MAX, 1);
+	else
+		gr_learn_resource(current, RLIMIT_AS, (mm->total_vm + npages) << PAGE_SHIFT, 1);
+
 	if (mm->total_vm + npages > rlimit(RLIMIT_AS) >> PAGE_SHIFT)
 		return false;
 
-	if (is_data_mapping(flags) &&
-	    mm->data_vm + npages > rlimit(RLIMIT_DATA) >> PAGE_SHIFT) {
-		/* Workaround for Valgrind */
-		if (rlimit(RLIMIT_DATA) == 0 &&
-		    mm->data_vm + npages <= rlimit_max(RLIMIT_DATA) >> PAGE_SHIFT)
-			return true;
-		if (!ignore_rlimit_data) {
-			pr_warn_once("%s (%d): VmData %lu exceed data ulimit %lu. Update limits or use boot option ignore_rlimit_data.\n",
-				     current->comm, current->pid,
-				     (mm->data_vm + npages) << PAGE_SHIFT,
-				     rlimit(RLIMIT_DATA));
-			return false;
+	if (is_data_mapping(flags)) {
+		if ((mm->data_vm + npages) > (ULONG_MAX >> PAGE_SHIFT))
+			gr_learn_resource(current, RLIMIT_DATA, ULONG_MAX, 1);
+		else
+			gr_learn_resource(current, RLIMIT_DATA, (mm->data_vm + npages) << PAGE_SHIFT, 1);
+		if (mm->data_vm + npages > rlimit(RLIMIT_DATA) >> PAGE_SHIFT) {
+			/* Workaround for Valgrind */
+			if (rlimit(RLIMIT_DATA) == 0 &&
+			    mm->data_vm + npages <= rlimit_max(RLIMIT_DATA) >> PAGE_SHIFT)
+				return true;
+			if (!ignore_rlimit_data) {
+				pr_warn_once("%s (%d): VmData %lu exceed data ulimit %lu. Update limits or use boot option ignore_rlimit_data.\n",
+					     current->comm, current->pid,
+					     (mm->data_vm + npages) << PAGE_SHIFT,
+					     rlimit(RLIMIT_DATA));
+				return false;
+			}
 		}
 	}
 
@@ -2948,6 +3487,11 @@ bool may_expand_vm(struct mm_struct *mm, vm_flags_t flags, unsigned long npages)
 
 void vm_stat_account(struct mm_struct *mm, vm_flags_t flags, long npages)
 {
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (!(mm->pax_flags & MF_PAX_RANDMMAP) || (flags & (VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC)))
+#endif
+
 	mm->total_vm += npages;
 
 	if (is_exec_mapping(flags))
@@ -3042,6 +3586,22 @@ static struct vm_area_struct *__install_special_mapping(
 	vma->vm_start = addr;
 	vma->vm_end = addr + len;
 
+#ifdef CONFIG_PAX_MPROTECT
+	if (mm->pax_flags & MF_PAX_MPROTECT) {
+#ifndef CONFIG_PAX_MPROTECT_COMPAT
+		if ((vm_flags & (VM_WRITE | VM_EXEC)) == (VM_WRITE | VM_EXEC))
+			return ERR_PTR(-EPERM);
+		if (!(vm_flags & VM_EXEC))
+			vm_flags &= ~VM_MAYEXEC;
+#else
+		if ((vm_flags & (VM_WRITE | VM_EXEC)) != VM_EXEC)
+			vm_flags &= ~(VM_EXEC | VM_MAYEXEC);
+#endif
+		else
+			vm_flags &= ~VM_MAYWRITE;
+	}
+#endif
+
 	vma->vm_flags = vm_flags | mm->def_flags | VM_DONTEXPAND | VM_SOFTDIRTY;
 	vma->vm_page_prot = vm_get_page_prot(vma->vm_flags);
 
diff --git a/mm/mprotect.c b/mm/mprotect.c
index a4830f032..0675c132e 100644
--- a/mm/mprotect.c
+++ b/mm/mprotect.c
@@ -25,10 +25,18 @@
 #include <linux/perf_event.h>
 #include <linux/ksm.h>
 #include <linux/pkeys.h>
+#include <linux/sched/sysctl.h>
+
+#ifdef CONFIG_PAX_MPROTECT
+#include <linux/elf.h>
+#include <linux/binfmts.h>
+#endif
+
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
 #include <asm/cacheflush.h>
 #include <asm/tlbflush.h>
+#include <asm/mmu_context.h>
 
 #include "internal.h"
 
@@ -258,6 +266,48 @@ unsigned long change_protection(struct vm_area_struct *vma, unsigned long start,
 	return pages;
 }
 
+#ifdef CONFIG_ARCH_TRACK_EXEC_LIMIT
+/* called while holding the mmap semaphor for writing except stack expansion */
+void track_exec_limit(struct mm_struct *mm, unsigned long start, unsigned long end, unsigned long prot)
+{
+	unsigned long oldlimit, newlimit = 0UL;
+
+	if (!(mm->pax_flags & MF_PAX_PAGEEXEC) || (__supported_pte_mask & _PAGE_NX))
+		return;
+
+	spin_lock(&mm->page_table_lock);
+	oldlimit = mm->context.user_cs_limit;
+	if ((prot & VM_EXEC) && oldlimit < end)
+		/* USER_CS limit moved up */
+		newlimit = end;
+	else if (!(prot & VM_EXEC) && start < oldlimit && oldlimit <= end)
+		/* USER_CS limit moved down */
+		newlimit = start;
+
+	if (newlimit) {
+		mm->context.user_cs_limit = newlimit;
+
+#ifdef CONFIG_SMP
+		wmb();
+		cpumask_clear(&mm->context.cpu_user_cs_mask);
+		cpumask_set_cpu(smp_processor_id(), &mm->context.cpu_user_cs_mask);
+#endif
+
+		set_user_cs(mm->context.user_cs_base, mm->context.user_cs_limit, smp_processor_id());
+	}
+	spin_unlock(&mm->page_table_lock);
+	if (newlimit == end) {
+		struct vm_area_struct *vma = find_vma(mm, oldlimit);
+
+		for (; vma && vma->vm_start < end; vma = vma->vm_next)
+			if (is_vm_hugetlb_page(vma))
+				hugetlb_change_protection(vma, vma->vm_start, vma->vm_end, vma->vm_page_prot);
+			else
+				change_protection(vma, vma->vm_start, vma->vm_end, vma->vm_page_prot, vma_wants_writenotify(vma), 0);
+	}
+}
+#endif
+
 int
 mprotect_fixup(struct vm_area_struct *vma, struct vm_area_struct **pprev,
 	unsigned long start, unsigned long end, unsigned long newflags)
@@ -270,11 +320,29 @@ mprotect_fixup(struct vm_area_struct *vma, struct vm_area_struct **pprev,
 	int error;
 	int dirty_accountable = 0;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m = NULL;
+	unsigned long start_m, end_m;
+
+	start_m = start + SEGMEXEC_TASK_SIZE;
+	end_m = end + SEGMEXEC_TASK_SIZE;
+#endif
+
 	if (newflags == oldflags) {
 		*pprev = vma;
 		return 0;
 	}
 
+	if (newflags & (VM_READ | VM_WRITE | VM_EXEC)) {
+		struct vm_area_struct *prev = vma->vm_prev, *next = vma->vm_next;
+
+		if (next && (next->vm_flags & VM_GROWSDOWN) && sysctl_heap_stack_gap > next->vm_start - end)
+			return -ENOMEM;
+
+		if (prev && (prev->vm_flags & VM_GROWSUP) && sysctl_heap_stack_gap > start - prev->vm_end)
+			return -ENOMEM;
+	}
+
 	/*
 	 * If we make a private mapping writable we increase our commit;
 	 * but (without finer accounting) cannot reduce our commit if we
@@ -295,6 +363,42 @@ mprotect_fixup(struct vm_area_struct *vma, struct vm_area_struct **pprev,
 		}
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((mm->pax_flags & MF_PAX_SEGMEXEC) && ((oldflags ^ newflags) & VM_EXEC)) {
+		if (start != vma->vm_start) {
+			error = split_vma(mm, vma, start, 1);
+			if (error)
+				goto fail;
+			BUG_ON(!*pprev || (*pprev)->vm_next == vma);
+			*pprev = (*pprev)->vm_next;
+		}
+
+		if (end != vma->vm_end) {
+			error = split_vma(mm, vma, end, 0);
+			if (error)
+				goto fail;
+		}
+
+		if (pax_find_mirror_vma(vma)) {
+			error = __do_munmap(mm, start_m, end_m - start_m);
+			if (error)
+				goto fail;
+		} else {
+			vma_m = kmem_cache_zalloc(vm_area_cachep, GFP_KERNEL);
+			if (!vma_m) {
+				error = -ENOMEM;
+				goto fail;
+			}
+			vma->vm_flags = newflags;
+			error = pax_mirror_vma(vma_m, vma);
+			if (error) {
+				vma->vm_flags = oldflags;
+				goto fail;
+			}
+		}
+	}
+#endif
+
 	/*
 	 * First try to merge with previous and/or next vma.
 	 */
@@ -326,7 +430,19 @@ success:
 	 * vm_flags and vm_page_prot are protected by the mmap_sem
 	 * held in write mode.
 	 */
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if ((mm->pax_flags & MF_PAX_SEGMEXEC) && (newflags & VM_EXEC) && ((vma->vm_flags ^ newflags) & VM_READ))
+		pax_find_mirror_vma(vma)->vm_flags ^= VM_READ;
+#endif
+
 	vma->vm_flags = newflags;
+
+#ifdef CONFIG_PAX_MPROTECT
+	if (mm->binfmt && mm->binfmt->handle_mprotect)
+		mm->binfmt->handle_mprotect(vma, newflags);
+#endif
+
 	dirty_accountable = vma_wants_writenotify(vma);
 	vma_set_page_prot(vma);
 
@@ -360,7 +476,7 @@ SYSCALL_DEFINE3(mprotect, unsigned long, start, size_t, len,
 	int error = -EINVAL;
 	const int grows = prot & (PROT_GROWSDOWN|PROT_GROWSUP);
 	const bool rier = (current->personality & READ_IMPLIES_EXEC) &&
-				(prot & PROT_READ);
+				(prot & (PROT_READ | PROT_WRITE));
 
 	prot &= ~(PROT_GROWSDOWN|PROT_GROWSUP);
 	if (grows == (PROT_GROWSDOWN|PROT_GROWSUP)) /* can't be both */
@@ -374,6 +490,17 @@ SYSCALL_DEFINE3(mprotect, unsigned long, start, size_t, len,
 	end = start + len;
 	if (end <= start)
 		return -ENOMEM;
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (current->mm->pax_flags & MF_PAX_SEGMEXEC) {
+		if (end > SEGMEXEC_TASK_SIZE)
+			return -EINVAL;
+	} else
+#endif
+
+	if (end > TASK_SIZE)
+		return -EINVAL;
+
 	if (!arch_validate_prot(prot))
 		return -EINVAL;
 
@@ -407,6 +534,11 @@ SYSCALL_DEFINE3(mprotect, unsigned long, start, size_t, len,
 	if (start > vma->vm_start)
 		prev = vma;
 
+#ifdef CONFIG_PAX_MPROTECT
+	if (current->mm->binfmt && current->mm->binfmt->handle_mprotect)
+		current->mm->binfmt->handle_mprotect(vma, calc_vm_prot_bits(prot, 0));
+#endif
+
 	for (nstart = start ; ; ) {
 		unsigned long newflags;
 		int pkey = arch_override_mprotect_pkey(vma, prot, -1);
@@ -422,6 +554,14 @@ SYSCALL_DEFINE3(mprotect, unsigned long, start, size_t, len,
 
 		/* newflags >> 4 shift VM_MAY% in place of VM_% */
 		if ((newflags & ~(newflags >> 4)) & (VM_READ | VM_WRITE | VM_EXEC)) {
+			if (prot & (PROT_WRITE | PROT_EXEC))
+				gr_log_rwxmprotect(vma);
+
+			error = -EACCES;
+			goto out;
+		}
+
+		if (!gr_acl_handle_mprotect(vma->vm_file, prot)) {
 			error = -EACCES;
 			goto out;
 		}
@@ -436,6 +576,9 @@ SYSCALL_DEFINE3(mprotect, unsigned long, start, size_t, len,
 		error = mprotect_fixup(vma, &prev, nstart, tmp, newflags);
 		if (error)
 			goto out;
+
+		track_exec_limit(current->mm, nstart, tmp, newflags);
+
 		nstart = tmp;
 
 		if (nstart < prev->vm_end)
diff --git a/mm/mremap.c b/mm/mremap.c
index da22ad2a5..f98a3df5b 100644
--- a/mm/mremap.c
+++ b/mm/mremap.c
@@ -148,6 +148,12 @@ static void move_ptes(struct vm_area_struct *vma, pmd_t *old_pmd,
 			continue;
 		pte = ptep_get_and_clear(mm, old_addr, old_pte);
 		pte = move_pte(pte, new_vma->vm_page_prot, old_addr, new_addr);
+
+#ifdef CONFIG_ARCH_TRACK_EXEC_LIMIT
+		if (!(__supported_pte_mask & _PAGE_NX) && pte_present(pte) && (new_vma->vm_flags & (VM_PAGEEXEC | VM_EXEC)) == VM_PAGEEXEC)
+			pte = pte_exprotect(pte);
+#endif
+
 		pte = move_soft_dirty_pte(pte);
 		set_pte_at(mm, new_addr, new_pte, pte);
 	}
@@ -357,6 +363,11 @@ static struct vm_area_struct *vma_to_resize(unsigned long addr,
 	if (is_vm_hugetlb_page(vma))
 		return ERR_PTR(-EINVAL);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (pax_find_mirror_vma(vma))
+		return ERR_PTR(-EINVAL);
+#endif
+
 	/* We can't remap across vm area boundaries */
 	if (old_len > vma->vm_end - addr)
 		return ERR_PTR(-EFAULT);
@@ -404,11 +415,19 @@ static unsigned long mremap_to(unsigned long addr, unsigned long old_len,
 	unsigned long ret = -EINVAL;
 	unsigned long charged = 0;
 	unsigned long map_flags;
+	unsigned long pax_task_size = TASK_SIZE;
 
 	if (offset_in_page(new_addr))
 		goto out;
 
-	if (new_len > TASK_SIZE || new_addr > TASK_SIZE - new_len)
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
+
+	pax_task_size -= PAGE_SIZE;
+
+	if (new_len > TASK_SIZE || new_addr > pax_task_size - new_len)
 		goto out;
 
 	/* Ensure the old/new locations do not overlap */
@@ -481,6 +500,7 @@ SYSCALL_DEFINE5(mremap, unsigned long, addr, unsigned long, old_len,
 	unsigned long ret = -EINVAL;
 	unsigned long charged = 0;
 	bool locked = false;
+	unsigned long pax_task_size = TASK_SIZE;
 
 	if (flags & ~(MREMAP_FIXED | MREMAP_MAYMOVE))
 		return ret;
@@ -502,6 +522,17 @@ SYSCALL_DEFINE5(mremap, unsigned long, addr, unsigned long, old_len,
 	if (!new_len)
 		return ret;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (mm->pax_flags & MF_PAX_SEGMEXEC)
+		pax_task_size = SEGMEXEC_TASK_SIZE;
+#endif
+
+	pax_task_size -= PAGE_SIZE;
+
+	if (new_len > pax_task_size || addr > pax_task_size-new_len ||
+	    old_len > pax_task_size || addr > pax_task_size-old_len)
+		return ret;
+
 	if (down_write_killable(&current->mm->mmap_sem))
 		return -EINTR;
 
@@ -553,6 +584,7 @@ SYSCALL_DEFINE5(mremap, unsigned long, addr, unsigned long, old_len,
 				new_addr = addr;
 			}
 			ret = addr;
+			track_exec_limit(vma->vm_mm, vma->vm_start, addr + new_len, vma->vm_flags);
 			goto out;
 		}
 	}
@@ -576,7 +608,12 @@ SYSCALL_DEFINE5(mremap, unsigned long, addr, unsigned long, old_len,
 			goto out;
 		}
 
+		map_flags = vma->vm_flags;
 		ret = move_vma(vma, addr, old_len, new_len, new_addr, &locked);
+		if (!(ret & ~PAGE_MASK)) {
+			track_exec_limit(current->mm, addr, addr + old_len, 0UL);
+			track_exec_limit(current->mm, new_addr, new_addr + new_len, map_flags);
+		}
 	}
 out:
 	if (offset_in_page(ret)) {
diff --git a/mm/nommu.c b/mm/nommu.c
index 95daf81a4..559c30b43 100644
--- a/mm/nommu.c
+++ b/mm/nommu.c
@@ -48,7 +48,6 @@ unsigned long max_mapnr;
 EXPORT_SYMBOL(max_mapnr);
 unsigned long highest_memmap_pfn;
 int sysctl_nr_trim_pages = CONFIG_NOMMU_INITIAL_TRIM_EXCESS;
-int heap_stack_gap = 0;
 
 atomic_long_t mmap_pages_allocated;
 
@@ -836,15 +835,6 @@ struct vm_area_struct *find_vma(struct mm_struct *mm, unsigned long addr)
 EXPORT_SYMBOL(find_vma);
 
 /*
- * find a VMA
- * - we don't extend stack VMAs under NOMMU conditions
- */
-struct vm_area_struct *find_extend_vma(struct mm_struct *mm, unsigned long addr)
-{
-	return find_vma(mm, addr);
-}
-
-/*
  * expand a stack to a given address
  * - not supported under NOMMU conditions
  */
@@ -1509,6 +1499,7 @@ int split_vma(struct mm_struct *mm, struct vm_area_struct *vma,
 
 	/* most fields are the same, copy all, and then fixup */
 	*new = *vma;
+	INIT_LIST_HEAD(&new->anon_vma_chain);
 	*region = *vma->vm_region;
 	new->vm_region = region;
 
@@ -1816,8 +1807,8 @@ void filemap_map_pages(struct fault_env *fe,
 }
 EXPORT_SYMBOL(filemap_map_pages);
 
-static int __access_remote_vm(struct task_struct *tsk, struct mm_struct *mm,
-		unsigned long addr, void *buf, int len, int write)
+static ssize_t __access_remote_vm(struct task_struct *tsk, struct mm_struct *mm,
+		unsigned long addr, void *buf, size_t len, int write)
 {
 	struct vm_area_struct *vma;
 
@@ -1858,8 +1849,8 @@ static int __access_remote_vm(struct task_struct *tsk, struct mm_struct *mm,
  *
  * The caller must hold a reference on @mm.
  */
-int access_remote_vm(struct mm_struct *mm, unsigned long addr,
-		void *buf, int len, int write)
+ssize_t access_remote_vm(struct mm_struct *mm, unsigned long addr,
+		void *buf, size_t len, int write)
 {
 	return __access_remote_vm(NULL, mm, addr, buf, len, write);
 }
@@ -1868,7 +1859,7 @@ int access_remote_vm(struct mm_struct *mm, unsigned long addr,
  * Access another process' address space.
  * - source/target buffer must be kernel space
  */
-int access_process_vm(struct task_struct *tsk, unsigned long addr, void *buf, int len, int write)
+ssize_t access_process_vm(struct task_struct *tsk, unsigned long addr, void *buf, size_t len, int write)
 {
 	struct mm_struct *mm;
 
diff --git a/mm/page-writeback.c b/mm/page-writeback.c
index f4cd7d800..982c35dbc 100644
--- a/mm/page-writeback.c
+++ b/mm/page-writeback.c
@@ -902,7 +902,7 @@ static long long pos_ratio_polynom(unsigned long setpoint,
  *   card's wb_dirty may rush to many times higher than wb_setpoint.
  * - the wb dirty thresh drops quickly due to change of JBOD workload
  */
-static void wb_position_ratio(struct dirty_throttle_control *dtc)
+static void __intentional_overflow(-1) wb_position_ratio(struct dirty_throttle_control *dtc)
 {
 	struct bdi_writeback *wb = dtc->wb;
 	unsigned long write_bw = wb->avg_write_bandwidth;
diff --git a/mm/page_alloc.c b/mm/page_alloc.c
index 212a017a2..4c850fbf9 100644
--- a/mm/page_alloc.c
+++ b/mm/page_alloc.c
@@ -64,6 +64,7 @@
 #include <linux/page_owner.h>
 #include <linux/kthread.h>
 #include <linux/memcontrol.h>
+#include <linux/random.h>
 
 #include <asm/sections.h>
 #include <asm/tlbflush.h>
@@ -676,7 +677,7 @@ static inline void clear_page_guard(struct zone *zone, struct page *page,
 		__mod_zone_freepage_state(zone, (1 << order), migratetype);
 }
 #else
-struct page_ext_operations debug_guardpage_ops = { NULL, };
+struct page_ext_operations debug_guardpage_ops = { .need = NULL, .init = NULL };
 static inline void set_page_guard(struct zone *zone, struct page *page,
 				unsigned int order, int migratetype) {}
 static inline void clear_page_guard(struct zone *zone, struct page *page,
@@ -979,6 +980,10 @@ static __always_inline bool free_pages_prepare(struct page *page,
 {
 	int bad = 0;
 
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	unsigned long index = 1UL << order;
+#endif
+
 	VM_BUG_ON_PAGE(PageTail(page), page);
 
 	trace_mm_page_free(page, order);
@@ -1025,6 +1030,12 @@ static __always_inline bool free_pages_prepare(struct page *page,
 		debug_check_no_obj_freed(page_address(page),
 					   PAGE_SIZE << order);
 	}
+
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	for (; index; --index)
+		sanitize_highpage(page + index - 1);
+#endif
+
 	arch_free_page(page, order);
 	kernel_poison_pages(page, 1 << order, 0);
 	kernel_map_pages(page, 1 << order, 0);
@@ -1234,6 +1245,20 @@ static void __free_pages_ok(struct page *page, unsigned int order)
 	local_irq_restore(flags);
 }
 
+bool __meminitdata extra_latent_entropy;
+
+static int __init setup_pax_extra_latent_entropy(char *str)
+{
+	extra_latent_entropy = true;
+	return 0;
+}
+early_param("pax_extra_latent_entropy", setup_pax_extra_latent_entropy);
+
+#ifdef LATENT_ENTROPY_PLUGIN
+volatile unsigned long latent_entropy __latent_entropy;
+EXPORT_SYMBOL(latent_entropy);
+#endif
+
 static void __init __free_pages_boot_core(struct page *page, unsigned int order)
 {
 	unsigned int nr_pages = 1 << order;
@@ -1249,6 +1274,21 @@ static void __init __free_pages_boot_core(struct page *page, unsigned int order)
 	__ClearPageReserved(p);
 	set_page_count(p, 0);
 
+	if (extra_latent_entropy && !PageHighMem(page) && page_to_pfn(page) < 0x100000) {
+		unsigned long hash = 0;
+		size_t index, end = PAGE_SIZE * nr_pages / sizeof hash;
+		const unsigned long *data = lowmem_page_address(page);
+
+		for (index = 0; index < end; index++)
+			hash ^= hash + data[index];
+#ifdef LATENT_ENTROPY_PLUGIN
+		latent_entropy ^= hash;
+		add_device_randomness((const void *)&latent_entropy, sizeof(latent_entropy));
+#else
+		add_device_randomness((const void *)&hash, sizeof(hash));
+#endif
+	}
+
 	page_zone(page)->managed_pages += nr_pages;
 	set_page_refcounted(page);
 	__free_pages(page, order);
@@ -1305,7 +1345,6 @@ static inline bool __meminit meminit_pfn_in_nid(unsigned long pfn, int node,
 }
 #endif
 
-
 void __init __free_pages_bootmem(struct page *page, unsigned long pfn,
 							unsigned int order)
 {
@@ -1678,8 +1717,8 @@ static inline int check_new_page(struct page *page)
 
 static inline bool free_pages_prezeroed(bool poisoned)
 {
-	return IS_ENABLED(CONFIG_PAGE_POISONING_ZERO) &&
-		page_poisoning_enabled() && poisoned;
+	return IS_ENABLED(CONFIG_PAX_MEMORY_SANITIZE) ||
+		(IS_ENABLED(CONFIG_PAGE_POISONING_ZERO) && page_poisoning_enabled() && poisoned);
 }
 
 #ifdef CONFIG_DEBUG_VM
@@ -1735,11 +1774,13 @@ static void prep_new_page(struct page *page, unsigned int order, gfp_t gfp_flags
 	int i;
 	bool poisoned = true;
 
+#ifndef CONFIG_PAX_MEMORY_SANITIZE
 	for (i = 0; i < (1 << order); i++) {
 		struct page *p = page + i;
 		if (poisoned)
 			poisoned &= page_is_poisoned(p);
 	}
+#endif
 
 	post_alloc_hook(page, order, gfp_flags);
 
@@ -2286,8 +2327,9 @@ static void drain_pages(unsigned int cpu)
  * The CPU has to be pinned. When zone parameter is non-NULL, spill just
  * the single zone's pages.
  */
-void drain_local_pages(struct zone *zone)
+void drain_local_pages(void *_zone)
 {
+	struct zone *zone = _zone;
 	int cpu = smp_processor_id();
 
 	if (zone)
@@ -2347,8 +2389,7 @@ void drain_all_pages(struct zone *zone)
 		else
 			cpumask_clear_cpu(cpu, &cpus_with_pcps);
 	}
-	on_each_cpu_mask(&cpus_with_pcps, (smp_call_func_t) drain_local_pages,
-								zone, 1);
+	on_each_cpu_mask(&cpus_with_pcps, drain_local_pages, zone, 1);
 }
 
 #ifdef CONFIG_HIBERNATION
diff --git a/mm/percpu.c b/mm/percpu.c
index 9903830aa..51763250e 100644
--- a/mm/percpu.c
+++ b/mm/percpu.c
@@ -133,7 +133,7 @@ static unsigned int pcpu_low_unit_cpu __read_mostly;
 static unsigned int pcpu_high_unit_cpu __read_mostly;
 
 /* the address of the first chunk which starts with the kernel static area */
-void *pcpu_base_addr __read_mostly;
+void *pcpu_base_addr __read_only;
 EXPORT_SYMBOL_GPL(pcpu_base_addr);
 
 static const int *pcpu_unit_map __read_mostly;		/* cpu -> unit */
diff --git a/mm/process_vm_access.c b/mm/process_vm_access.c
index 07514d41e..99890909e 100644
--- a/mm/process_vm_access.c
+++ b/mm/process_vm_access.c
@@ -13,6 +13,7 @@
 #include <linux/uio.h>
 #include <linux/sched.h>
 #include <linux/highmem.h>
+#include <linux/security.h>
 #include <linux/ptrace.h>
 #include <linux/slab.h>
 #include <linux/syscalls.h>
@@ -159,19 +160,19 @@ static ssize_t process_vm_rw_core(pid_t pid, struct iov_iter *iter,
 	ssize_t iov_len;
 	size_t total_len = iov_iter_count(iter);
 
+	return -ENOSYS; // PaX: until properly audited
+
 	/*
 	 * Work out how many pages of struct pages we're going to need
 	 * when eventually calling get_user_pages
 	 */
 	for (i = 0; i < riovcnt; i++) {
 		iov_len = rvec[i].iov_len;
-		if (iov_len > 0) {
-			nr_pages_iov = ((unsigned long)rvec[i].iov_base
-					+ iov_len)
-				/ PAGE_SIZE - (unsigned long)rvec[i].iov_base
-				/ PAGE_SIZE + 1;
-			nr_pages = max(nr_pages, nr_pages_iov);
-		}
+		if (iov_len <= 0)
+			continue;
+		nr_pages_iov = ((unsigned long)rvec[i].iov_base + iov_len) / PAGE_SIZE -
+				(unsigned long)rvec[i].iov_base / PAGE_SIZE + 1;
+		nr_pages = max(nr_pages, nr_pages_iov);
 	}
 
 	if (nr_pages == 0)
@@ -199,6 +200,11 @@ static ssize_t process_vm_rw_core(pid_t pid, struct iov_iter *iter,
 		goto free_proc_pages;
 	}
 
+	if (gr_handle_ptrace(task, vm_write ? PTRACE_POKETEXT : PTRACE_ATTACH)) {
+		rc = -EPERM;
+		goto put_task_struct;
+	}
+
 	mm = mm_access(task, PTRACE_MODE_ATTACH_REALCREDS);
 	if (!mm || IS_ERR(mm)) {
 		rc = IS_ERR(mm) ? PTR_ERR(mm) : -ESRCH;
diff --git a/mm/readahead.c b/mm/readahead.c
index c8a955b12..fad212894 100644
--- a/mm/readahead.c
+++ b/mm/readahead.c
@@ -81,7 +81,7 @@ static void read_cache_pages_invalidate_pages(struct address_space *mapping,
  * Hides the details of the LRU cache etc from the filesystems.
  */
 int read_cache_pages(struct address_space *mapping, struct list_head *pages,
-			int (*filler)(void *, struct page *), void *data)
+			filler_t *filler, void *data)
 {
 	struct page *page;
 	int ret = 0;
diff --git a/mm/rmap.c b/mm/rmap.c
index 1ef36404e..88c345dbf 100644
--- a/mm/rmap.c
+++ b/mm/rmap.c
@@ -172,6 +172,10 @@ int anon_vma_prepare(struct vm_area_struct *vma)
 	struct anon_vma *anon_vma = vma->anon_vma;
 	struct anon_vma_chain *avc;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct anon_vma_chain *avc_m = NULL;
+#endif
+
 	might_sleep();
 	if (unlikely(!anon_vma)) {
 		struct mm_struct *mm = vma->vm_mm;
@@ -181,6 +185,12 @@ int anon_vma_prepare(struct vm_area_struct *vma)
 		if (!avc)
 			goto out_enomem;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+		avc_m = anon_vma_chain_alloc(GFP_KERNEL);
+		if (!avc_m)
+			goto out_enomem_free_avc;
+#endif
+
 		anon_vma = find_mergeable_anon_vma(vma);
 		allocated = NULL;
 		if (!anon_vma) {
@@ -194,6 +204,19 @@ int anon_vma_prepare(struct vm_area_struct *vma)
 		/* page_table_lock to protect against threads */
 		spin_lock(&mm->page_table_lock);
 		if (likely(!vma->anon_vma)) {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+			struct vm_area_struct *vma_m = pax_find_mirror_vma(vma);
+
+			if (vma_m) {
+				BUG_ON(vma_m->anon_vma);
+				vma_m->anon_vma = anon_vma;
+				anon_vma_chain_link(vma_m, avc_m, anon_vma);
+				anon_vma->degree++;
+				avc_m = NULL;
+			}
+#endif
+
 			vma->anon_vma = anon_vma;
 			anon_vma_chain_link(vma, avc, anon_vma);
 			/* vma reference or self-parent link for new root */
@@ -206,12 +229,24 @@ int anon_vma_prepare(struct vm_area_struct *vma)
 
 		if (unlikely(allocated))
 			put_anon_vma(allocated);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		if (unlikely(avc_m))
+			anon_vma_chain_free(avc_m);
+#endif
+
 		if (unlikely(avc))
 			anon_vma_chain_free(avc);
 	}
 	return 0;
 
  out_enomem_free_avc:
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (avc_m)
+		anon_vma_chain_free(avc_m);
+#endif
+
 	anon_vma_chain_free(avc);
  out_enomem:
 	return -ENOMEM;
@@ -255,7 +290,7 @@ static inline void unlock_anon_vma_root(struct anon_vma *root)
  * good chance of avoiding scanning the whole hierarchy when it searches where
  * page is mapped.
  */
-int anon_vma_clone(struct vm_area_struct *dst, struct vm_area_struct *src)
+int anon_vma_clone(struct vm_area_struct *dst, const struct vm_area_struct *src)
 {
 	struct anon_vma_chain *avc, *pavc;
 	struct anon_vma *root = NULL;
@@ -309,7 +344,7 @@ int anon_vma_clone(struct vm_area_struct *dst, struct vm_area_struct *src)
  * the corresponding VMA in the parent process is attached to.
  * Returns 0 on success, non-zero on failure.
  */
-int anon_vma_fork(struct vm_area_struct *vma, struct vm_area_struct *pvma)
+int anon_vma_fork(struct vm_area_struct *vma, const struct vm_area_struct *pvma)
 {
 	struct anon_vma_chain *avc;
 	struct anon_vma *anon_vma;
@@ -429,10 +464,10 @@ static void anon_vma_ctor(void *data)
 void __init anon_vma_init(void)
 {
 	anon_vma_cachep = kmem_cache_create("anon_vma", sizeof(struct anon_vma),
-			0, SLAB_DESTROY_BY_RCU|SLAB_PANIC|SLAB_ACCOUNT,
+			0, SLAB_DESTROY_BY_RCU|SLAB_PANIC|SLAB_ACCOUNT|SLAB_NO_SANITIZE,
 			anon_vma_ctor);
 	anon_vma_chain_cachep = KMEM_CACHE(anon_vma_chain,
-			SLAB_PANIC|SLAB_ACCOUNT);
+			SLAB_PANIC|SLAB_ACCOUNT|SLAB_NO_SANITIZE);
 }
 
 /*
diff --git a/mm/shmem.c b/mm/shmem.c
index 38aa5e0a9..9b3e13b18 100644
--- a/mm/shmem.c
+++ b/mm/shmem.c
@@ -34,7 +34,7 @@
 #include <linux/uio.h>
 #include <linux/khugepaged.h>
 
-static struct vfsmount *shm_mnt;
+struct vfsmount *shm_mnt;
 
 #ifdef CONFIG_SHMEM
 /*
@@ -83,7 +83,7 @@ static struct vfsmount *shm_mnt;
 #define BOGO_DIRENT_SIZE 20
 
 /* Symlink up to this size is kmalloc'ed instead of using a swappable page */
-#define SHORT_SYMLINK_LEN 128
+#define SHORT_SYMLINK_LEN 64
 
 /*
  * shmem_fallocate communicates with shmem_fault or shmem_writepage via
@@ -3257,6 +3257,24 @@ static int shmem_xattr_handler_set(const struct xattr_handler *handler,
 	return simple_xattr_set(&info->xattrs, name, value, size, flags);
 }
 
+#ifdef CONFIG_PAX_XATTR_PAX_FLAGS
+static int shmem_user_xattr_handler_set(const struct xattr_handler *handler,
+					struct dentry *dentry, struct inode *inode,
+					const char *name, const void *value,
+					size_t size, int flags)
+{
+	struct shmem_inode_info *info = SHMEM_I(inode);
+
+	if (strcmp(name, XATTR_NAME_PAX_FLAGS))
+		return -EOPNOTSUPP;
+	if (size > 8)
+		return -EINVAL;
+
+	name = xattr_full_name(handler, name);
+	return simple_xattr_set(&info->xattrs, name, value, size, flags);
+}
+#endif
+
 static const struct xattr_handler shmem_security_xattr_handler = {
 	.prefix = XATTR_SECURITY_PREFIX,
 	.get = shmem_xattr_handler_get,
@@ -3269,6 +3287,14 @@ static const struct xattr_handler shmem_trusted_xattr_handler = {
 	.set = shmem_xattr_handler_set,
 };
 
+#ifdef CONFIG_PAX_XATTR_PAX_FLAGS
+static const struct xattr_handler shmem_user_xattr_handler = {
+	.prefix = XATTR_USER_PREFIX,
+	.get = shmem_xattr_handler_get,
+	.set = shmem_user_xattr_handler_set,
+};
+#endif
+
 static const struct xattr_handler *shmem_xattr_handlers[] = {
 #ifdef CONFIG_TMPFS_POSIX_ACL
 	&posix_acl_access_xattr_handler,
@@ -3276,6 +3302,11 @@ static const struct xattr_handler *shmem_xattr_handlers[] = {
 #endif
 	&shmem_security_xattr_handler,
 	&shmem_trusted_xattr_handler,
+
+#ifdef CONFIG_PAX_XATTR_PAX_FLAGS
+	&shmem_user_xattr_handler,
+#endif
+
 	NULL
 };
 
@@ -3655,8 +3686,7 @@ int shmem_fill_super(struct super_block *sb, void *data, int silent)
 	int err = -ENOMEM;
 
 	/* Round up to L1_CACHE_BYTES to resist false sharing */
-	sbinfo = kzalloc(max((int)sizeof(struct shmem_sb_info),
-				L1_CACHE_BYTES), GFP_KERNEL);
+	sbinfo = kzalloc(max(sizeof(struct shmem_sb_info), L1_CACHE_BYTES), GFP_KERNEL);
 	if (!sbinfo)
 		return -ENOMEM;
 
diff --git a/mm/slab.c b/mm/slab.c
index 525a91198..b6279c01d 100644
--- a/mm/slab.c
+++ b/mm/slab.c
@@ -116,6 +116,7 @@
 #include	<linux/kmemcheck.h>
 #include	<linux/memory.h>
 #include	<linux/prefetch.h>
+#include	<linux/vmalloc.h>
 
 #include	<net/sock.h>
 
@@ -284,10 +285,12 @@ static void kmem_cache_node_init(struct kmem_cache_node *parent)
 		if ((x)->max_freeable < i)				\
 			(x)->max_freeable = i;				\
 	} while (0)
-#define STATS_INC_ALLOCHIT(x)	atomic_inc(&(x)->allochit)
-#define STATS_INC_ALLOCMISS(x)	atomic_inc(&(x)->allocmiss)
-#define STATS_INC_FREEHIT(x)	atomic_inc(&(x)->freehit)
-#define STATS_INC_FREEMISS(x)	atomic_inc(&(x)->freemiss)
+#define STATS_INC_ALLOCHIT(x)	atomic_inc_unchecked(&(x)->allochit)
+#define STATS_INC_ALLOCMISS(x)	atomic_inc_unchecked(&(x)->allocmiss)
+#define STATS_INC_FREEHIT(x)	atomic_inc_unchecked(&(x)->freehit)
+#define STATS_INC_FREEMISS(x)	atomic_inc_unchecked(&(x)->freemiss)
+#define STATS_INC_SANITIZED(x)	atomic_inc_unchecked(&(x)->sanitized)
+#define STATS_INC_NOT_SANITIZED(x) atomic_inc_unchecked(&(x)->not_sanitized)
 #else
 #define	STATS_INC_ACTIVE(x)	do { } while (0)
 #define	STATS_DEC_ACTIVE(x)	do { } while (0)
@@ -304,6 +307,8 @@ static void kmem_cache_node_init(struct kmem_cache_node *parent)
 #define STATS_INC_ALLOCMISS(x)	do { } while (0)
 #define STATS_INC_FREEHIT(x)	do { } while (0)
 #define STATS_INC_FREEMISS(x)	do { } while (0)
+#define STATS_INC_SANITIZED(x)	do { } while (0)
+#define STATS_INC_NOT_SANITIZED(x) do { } while (0)
 #endif
 
 #if DEBUG
@@ -410,7 +415,7 @@ static inline void *index_to_obj(struct kmem_cache *cache, struct page *page,
  *   reciprocal_divide(offset, cache->reciprocal_buffer_size)
  */
 static inline unsigned int obj_to_index(const struct kmem_cache *cache,
-					const struct page *page, void *obj)
+					const struct page *page, const void *obj)
 {
 	u32 offset = (obj - page->s_mem);
 	return reciprocal_divide(offset, cache->reciprocal_buffer_size);
@@ -1290,7 +1295,7 @@ void __init kmem_cache_init(void)
 	create_boot_cache(kmem_cache, "kmem_cache",
 		offsetof(struct kmem_cache, node) +
 				  nr_node_ids * sizeof(struct kmem_cache_node *),
-				  SLAB_HWCACHE_ALIGN);
+				  SLAB_HWCACHE_ALIGN, 0, 0);
 	list_add(&kmem_cache->list, &slab_caches);
 	slab_state = PARTIAL;
 
@@ -1298,8 +1303,8 @@ void __init kmem_cache_init(void)
 	 * Initialize the caches that provide memory for the  kmem_cache_node
 	 * structures first.  Without this, further allocations will bug.
 	 */
-	kmalloc_caches[INDEX_NODE] = create_kmalloc_cache("kmalloc-node",
-				kmalloc_size(INDEX_NODE), ARCH_KMALLOC_FLAGS);
+	kmalloc_caches[INDEX_NODE] = create_kmalloc_cache_usercopy("kmalloc-node",
+				kmalloc_size(INDEX_NODE), ARCH_KMALLOC_FLAGS, 0, kmalloc_size(INDEX_NODE));
 	slab_state = PARTIAL_NODE;
 	setup_kmalloc_cache_index_table();
 
@@ -1544,7 +1549,7 @@ static void store_stackinfo(struct kmem_cache *cachep, unsigned long *addr,
 
 		while (!kstack_end(sptr)) {
 			svalue = *sptr++;
-			if (kernel_text_address(svalue)) {
+			if (kernel_text_address(ktva_ktla(svalue))) {
 				*addr++ = svalue;
 				size -= sizeof(unsigned long);
 				if (size <= sizeof(unsigned long))
@@ -1931,7 +1936,7 @@ __kmem_cache_alias(const char *name, size_t size, size_t align,
 
 	cachep = find_mergeable(size, align, flags, name, ctor);
 	if (cachep) {
-		cachep->refcount++;
+		atomic_inc(&cachep->refcount);
 
 		/*
 		 * Adjust the object sizes so that we clear
@@ -2060,6 +2065,8 @@ __kmem_cache_create (struct kmem_cache *cachep, unsigned long flags)
 #endif
 #endif
 
+	flags = pax_sanitize_slab_flags(flags);
+
 	/*
 	 * Check that size is in terms of words.  This is needed to avoid
 	 * unaligned accesses for some archs when redzoning is used, and makes
@@ -2482,7 +2489,6 @@ union freelist_init_state {
 		unsigned int pos;
 		unsigned int *list;
 		unsigned int count;
-		unsigned int rand;
 	};
 	struct rnd_state rnd_state;
 };
@@ -2508,8 +2514,7 @@ static bool freelist_state_initialize(union freelist_init_state *state,
 	} else {
 		state->list = cachep->random_seq;
 		state->count = count;
-		state->pos = 0;
-		state->rand = rand;
+		state->pos = rand % count;
 		ret = true;
 	}
 	return ret;
@@ -2518,7 +2523,9 @@ static bool freelist_state_initialize(union freelist_init_state *state,
 /* Get the next entry on the list and randomize it using a random shift */
 static freelist_idx_t next_random_slot(union freelist_init_state *state)
 {
-	return (state->list[state->pos++] + state->rand) % state->count;
+	if (state->pos >= state->count)
+		state->pos = 0;
+	return state->list[state->pos++];
 }
 
 /* Swap two freelist entries */
@@ -3524,6 +3531,20 @@ void ___cache_free(struct kmem_cache *cachep, void *objp,
 	struct array_cache *ac = cpu_cache_get(cachep);
 
 	check_irq_off();
+
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	if (cachep->flags & (SLAB_POISON | SLAB_NO_SANITIZE))
+		STATS_INC_NOT_SANITIZED(cachep);
+	else {
+		memset(objp, PAX_MEMORY_SANITIZE_VALUE, cachep->object_size);
+
+		if (cachep->ctor)
+			cachep->ctor(objp);
+
+		STATS_INC_SANITIZED(cachep);
+	}
+#endif
+
 	kmemleak_free_recursive(objp, cachep->flags);
 	objp = cache_free_debugcheck(cachep, objp, caller);
 
@@ -3703,7 +3724,7 @@ __do_kmalloc_node(size_t size, gfp_t flags, int node, unsigned long caller)
 	return ret;
 }
 
-void *__kmalloc_node(size_t size, gfp_t flags, int node)
+void * __size_overflow(1) __kmalloc_node(size_t size, gfp_t flags, int node)
 {
 	return __do_kmalloc_node(size, flags, node, _RET_IP_);
 }
@@ -3723,7 +3744,7 @@ EXPORT_SYMBOL(__kmalloc_node_track_caller);
  * @flags: the type of memory to allocate (see kmalloc).
  * @caller: function caller for debug tracking of the caller
  */
-static __always_inline void *__do_kmalloc(size_t size, gfp_t flags,
+static __always_inline void * __size_overflow(1) __do_kmalloc(size_t size, gfp_t flags,
 					  unsigned long caller)
 {
 	struct kmem_cache *cachep;
@@ -3823,6 +3844,7 @@ void kfree(const void *objp)
 
 	if (unlikely(ZERO_OR_NULL_PTR(objp)))
 		return;
+	VM_BUG_ON(!virt_addr_valid(objp));
 	local_irq_save(flags);
 	kfree_debugcheck(objp);
 	c = virt_to_cache(objp);
@@ -4190,14 +4212,22 @@ void slabinfo_show_stats(struct seq_file *m, struct kmem_cache *cachep)
 	}
 	/* cpu stats */
 	{
-		unsigned long allochit = atomic_read(&cachep->allochit);
-		unsigned long allocmiss = atomic_read(&cachep->allocmiss);
-		unsigned long freehit = atomic_read(&cachep->freehit);
-		unsigned long freemiss = atomic_read(&cachep->freemiss);
+		unsigned long allochit = atomic_read_unchecked(&cachep->allochit);
+		unsigned long allocmiss = atomic_read_unchecked(&cachep->allocmiss);
+		unsigned long freehit = atomic_read_unchecked(&cachep->freehit);
+		unsigned long freemiss = atomic_read_unchecked(&cachep->freemiss);
 
 		seq_printf(m, " : cpustat %6lu %6lu %6lu %6lu",
 			   allochit, allocmiss, freehit, freemiss);
 	}
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	{
+		unsigned long sanitized = atomic_read_unchecked(&cachep->sanitized);
+		unsigned long not_sanitized = atomic_read_unchecked(&cachep->not_sanitized);
+
+		seq_printf(m, " : pax %6lu %6lu", sanitized, not_sanitized);
+	}
+#endif
 #endif
 }
 
@@ -4434,16 +4464,48 @@ static const struct file_operations proc_slabstats_operations = {
 static int __init slab_proc_init(void)
 {
 #ifdef CONFIG_DEBUG_SLAB_LEAK
-	proc_create("slab_allocators", 0, NULL, &proc_slabstats_operations);
+	proc_create("slab_allocators", S_IRUSR, NULL, &proc_slabstats_operations);
 #endif
 	return 0;
 }
 module_init(slab_proc_init);
 #endif
 
+bool is_usercopy_object(const void *ptr)
+{
+	struct page *page;
+
+	if (ZERO_OR_NULL_PTR(ptr))
+		return false;
+
+	if (!slab_is_available())
+		return false;
+
+	if (is_vmalloc_addr(ptr)
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	    && !object_starts_on_stack(ptr)
+#endif
+	) {
+		struct vm_struct *vm = find_vm_area(ptr);
+		if (vm && (vm->flags & VM_USERCOPY))
+			return true;
+		return false;
+	}
+
+	if (!virt_addr_valid(ptr))
+		return false;
+
+	page = virt_to_head_page(ptr);
+
+	if (!PageSlab(page))
+		return false;
+
+	return !!page->slab_cache->usersize;
+}
+
 #ifdef CONFIG_HARDENED_USERCOPY
 /*
- * Rejects objects that are incorrectly sized.
+ * Detect unwanted object access
  *
  * Returns NULL if check passes, otherwise const char * to name of cache
  * to indicate an error.
@@ -4457,17 +4519,23 @@ const char *__check_heap_object(const void *ptr, unsigned long n,
 
 	/* Find and validate object. */
 	cachep = page->slab_cache;
-	objnr = obj_to_index(cachep, page, (void *)ptr);
+
+	objnr = obj_to_index(cachep, page, ptr);
 	BUG_ON(objnr >= cachep->num);
 
 	/* Find offset within object. */
 	offset = ptr - index_to_obj(cachep, page, objnr) - obj_offset(cachep);
 
-	/* Allow address range falling entirely within object size. */
-	if (offset <= cachep->object_size && n <= cachep->object_size - offset)
-		return NULL;
+	if (offset < cachep->useroffset)
+		return cachep->name;
+
+	if (offset - cachep->useroffset >= cachep->usersize)
+		return cachep->name;
 
-	return cachep->name;
+	if (n > cachep->useroffset - offset + cachep->usersize)
+		return cachep->name;
+
+	return NULL;
 }
 #endif /* CONFIG_HARDENED_USERCOPY */
 
diff --git a/mm/slab.h b/mm/slab.h
index 9653f2e25..9b9e8cdde 100644
--- a/mm/slab.h
+++ b/mm/slab.h
@@ -21,8 +21,10 @@ struct kmem_cache {
 	unsigned int size;	/* The aligned/padded/added on size  */
 	unsigned int align;	/* Alignment as calculated */
 	unsigned long flags;	/* Active flags on the slab */
+	size_t useroffset;	/* USERCOPY region offset */
+	size_t usersize;	/* USERCOPY region size */
 	const char *name;	/* Slab name for sysfs */
-	int refcount;		/* Use counter */
+	atomic_t refcount;	/* Use counter */
 	void (*ctor)(void *);	/* Called on object slot creation */
 	struct list_head list;	/* List of all slab caches on the system */
 };
@@ -71,6 +73,35 @@ extern struct list_head slab_caches;
 /* The slab cache that manages slab cache information */
 extern struct kmem_cache *kmem_cache;
 
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+#ifdef CONFIG_X86_64
+#define PAX_MEMORY_SANITIZE_VALUE	'\xfe'
+#else
+#define PAX_MEMORY_SANITIZE_VALUE	'\xff'
+#endif
+enum pax_sanitize_mode {
+	PAX_SANITIZE_SLAB_OFF = 0,
+	PAX_SANITIZE_SLAB_FAST,
+	PAX_SANITIZE_SLAB_FULL,
+};
+
+extern enum pax_sanitize_mode pax_sanitize_slab;
+
+static inline unsigned long pax_sanitize_slab_flags(unsigned long flags)
+{
+	if (pax_sanitize_slab == PAX_SANITIZE_SLAB_OFF || (flags & SLAB_DESTROY_BY_RCU))
+		flags |= SLAB_NO_SANITIZE;
+	else if (pax_sanitize_slab == PAX_SANITIZE_SLAB_FULL)
+		flags &= ~SLAB_NO_SANITIZE;
+	return flags;
+}
+#else
+static inline unsigned long pax_sanitize_slab_flags(unsigned long flags)
+{
+	return flags;
+}
+#endif
+
 unsigned long calculate_alignment(unsigned long flags,
 		unsigned long align, unsigned long size);
 
@@ -89,8 +120,11 @@ extern int __kmem_cache_create(struct kmem_cache *, unsigned long flags);
 
 extern struct kmem_cache *create_kmalloc_cache(const char *name, size_t size,
 			unsigned long flags);
+extern struct kmem_cache *create_kmalloc_cache_usercopy(const char *name, size_t size,
+			unsigned long flags, size_t useroffset, size_t usersize);
 extern void create_boot_cache(struct kmem_cache *, const char *name,
-			size_t size, unsigned long flags);
+			size_t size, unsigned long flags,
+			size_t useroffset, size_t usersize);
 
 int slab_unmergeable(struct kmem_cache *s);
 struct kmem_cache *find_mergeable(size_t size, size_t align,
@@ -120,7 +154,7 @@ static inline unsigned long kmem_cache_flags(unsigned long object_size,
 
 /* Legal flag mask for kmem_cache_create(), for various configurations */
 #define SLAB_CORE_FLAGS (SLAB_HWCACHE_ALIGN | SLAB_CACHE_DMA | SLAB_PANIC | \
-			 SLAB_DESTROY_BY_RCU | SLAB_DEBUG_OBJECTS )
+			 SLAB_DESTROY_BY_RCU | SLAB_DEBUG_OBJECTS | SLAB_NO_SANITIZE)
 
 #if defined(CONFIG_DEBUG_SLAB)
 #define SLAB_DEBUG_FLAGS (SLAB_RED_ZONE | SLAB_POISON | SLAB_STORE_USER)
@@ -345,6 +379,9 @@ static inline struct kmem_cache *cache_from_obj(struct kmem_cache *s, void *x)
 		return s;
 
 	page = virt_to_head_page(x);
+
+	BUG_ON(!PageSlab(page));
+
 	cachep = page->slab_cache;
 	if (slab_equal_or_root(cachep, s))
 		return cachep;
diff --git a/mm/slab_common.c b/mm/slab_common.c
index 329b03843..52e9e91df 100644
--- a/mm/slab_common.c
+++ b/mm/slab_common.c
@@ -25,11 +25,35 @@
 
 #include "slab.h"
 
-enum slab_state slab_state;
+enum slab_state slab_state __read_only;
 LIST_HEAD(slab_caches);
 DEFINE_MUTEX(slab_mutex);
 struct kmem_cache *kmem_cache;
 
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+enum pax_sanitize_mode pax_sanitize_slab __read_only = PAX_SANITIZE_SLAB_FAST;
+static int __init pax_sanitize_slab_setup(char *str)
+{
+	if (!str)
+		return 0;
+
+	if (!strcmp(str, "0") || !strcmp(str, "off")) {
+		pr_info("PaX slab sanitization: %s\n", "disabled");
+		pax_sanitize_slab = PAX_SANITIZE_SLAB_OFF;
+	} else if (!strcmp(str, "1") || !strcmp(str, "fast")) {
+		pr_info("PaX slab sanitization: %s\n", "fast");
+		pax_sanitize_slab = PAX_SANITIZE_SLAB_FAST;
+	} else if (!strcmp(str, "full")) {
+		pr_info("PaX slab sanitization: %s\n", "full");
+		pax_sanitize_slab = PAX_SANITIZE_SLAB_FULL;
+	} else
+		pr_err("PaX slab sanitization: unsupported option '%s'\n", str);
+
+	return 0;
+}
+early_param("pax_sanitize_slab", pax_sanitize_slab_setup);
+#endif
+
 /*
  * Set of flags that will prevent slab merging
  */
@@ -44,7 +68,7 @@ struct kmem_cache *kmem_cache;
  * Merge control. If this is set then no merging of slab caches will occur.
  * (Could be removed. This was introduced to pacify the merge skeptics.)
  */
-static int slab_nomerge;
+static int slab_nomerge __read_only = 1;
 
 static int __init setup_slab_nomerge(char *str)
 {
@@ -244,7 +268,7 @@ int slab_unmergeable(struct kmem_cache *s)
 	/*
 	 * We may have set a slab to be unmergeable during bootstrap.
 	 */
-	if (s->refcount < 0)
+	if (atomic_read(&s->refcount) < 0)
 		return 1;
 
 	return 0;
@@ -323,12 +347,15 @@ unsigned long calculate_alignment(unsigned long flags,
 
 static struct kmem_cache *create_cache(const char *name,
 		size_t object_size, size_t size, size_t align,
-		unsigned long flags, void (*ctor)(void *),
+		unsigned long flags, size_t useroffset,
+		size_t usersize, void (*ctor)(void *),
 		struct mem_cgroup *memcg, struct kmem_cache *root_cache)
 {
 	struct kmem_cache *s;
 	int err;
 
+	BUG_ON(useroffset + usersize > object_size);
+
 	err = -ENOMEM;
 	s = kmem_cache_zalloc(kmem_cache, GFP_KERNEL);
 	if (!s)
@@ -339,6 +366,8 @@ static struct kmem_cache *create_cache(const char *name,
 	s->size = size;
 	s->align = align;
 	s->ctor = ctor;
+	s->useroffset = useroffset;
+	s->usersize = usersize;
 
 	err = init_memcg_params(s, memcg, root_cache);
 	if (err)
@@ -348,7 +377,7 @@ static struct kmem_cache *create_cache(const char *name,
 	if (err)
 		goto out_free_cache;
 
-	s->refcount = 1;
+	atomic_set(&s->refcount, 1);
 	list_add(&s->list, &slab_caches);
 out:
 	if (err)
@@ -362,11 +391,13 @@ out_free_cache:
 }
 
 /*
- * kmem_cache_create - Create a cache.
+ * __kmem_cache_create_usercopy - Create a cache.
  * @name: A string which is used in /proc/slabinfo to identify this cache.
  * @size: The size of objects to be created in this cache.
  * @align: The required alignment for the objects.
  * @flags: SLAB flags
+ * @useroffset: USERCOPY region offset
+ * @usersize: USERCOPY region size
  * @ctor: A constructor for the objects.
  *
  * Returns a ptr to the cache on success, NULL on failure.
@@ -385,9 +416,10 @@ out_free_cache:
  * cacheline.  This can be beneficial if you're counting cycles as closely
  * as davem.
  */
-struct kmem_cache *
-kmem_cache_create(const char *name, size_t size, size_t align,
-		  unsigned long flags, void (*ctor)(void *))
+static struct kmem_cache *
+__kmem_cache_create_usercopy(const char *name, size_t size, size_t align,
+		  unsigned long flags, size_t useroffset, size_t usersize,
+		  void (*ctor)(void *))
 {
 	struct kmem_cache *s = NULL;
 	const char *cache_name;
@@ -412,7 +444,10 @@ kmem_cache_create(const char *name, size_t size, size_t align,
 	 */
 	flags &= CACHE_CREATE_MASK;
 
-	s = __kmem_cache_alias(name, size, align, flags, ctor);
+	BUG_ON(!usersize && useroffset);
+	BUG_ON(size < usersize || size - usersize < useroffset);
+	if (!usersize)
+		s = __kmem_cache_alias(name, size, align, flags, ctor);
 	if (s)
 		goto out_unlock;
 
@@ -424,7 +459,7 @@ kmem_cache_create(const char *name, size_t size, size_t align,
 
 	s = create_cache(cache_name, size, size,
 			 calculate_alignment(flags, align, size),
-			 flags, ctor, NULL, NULL);
+			 flags, useroffset, usersize, ctor, NULL, NULL);
 	if (IS_ERR(s)) {
 		err = PTR_ERR(s);
 		kfree_const(cache_name);
@@ -450,8 +485,25 @@ out_unlock:
 	}
 	return s;
 }
+
+struct kmem_cache *
+kmem_cache_create(const char *name, size_t size, size_t align,
+		  unsigned long flags, void (*ctor)(void *))
+{
+	return __kmem_cache_create_usercopy(name, size, align, flags, 0,
+		(flags & SLAB_USERCOPY) ? size : 0, ctor);
+}
 EXPORT_SYMBOL(kmem_cache_create);
 
+struct kmem_cache *
+kmem_cache_create_usercopy(const char *name, size_t size, size_t align,
+		  unsigned long flags, size_t useroffset, size_t usersize,
+		  void (*ctor)(void *))
+{
+	return __kmem_cache_create_usercopy(name, size, align, flags, useroffset, usersize, ctor);
+}
+EXPORT_SYMBOL(kmem_cache_create_usercopy);
+
 static int shutdown_cache(struct kmem_cache *s,
 		struct list_head *release, bool *need_rcu_barrier)
 {
@@ -473,7 +525,7 @@ static void release_caches(struct list_head *release, bool need_rcu_barrier)
 		rcu_barrier();
 
 	list_for_each_entry_safe(s, s2, release, list) {
-#ifdef SLAB_SUPPORTS_SYSFS
+#if defined(SLAB_SUPPORTS_SYSFS) && !defined(CONFIG_GRKERNSEC_PROC_ADD)
 		sysfs_slab_remove(s);
 #else
 		slab_kmem_cache_release(s);
@@ -534,6 +586,7 @@ void memcg_create_kmem_cache(struct mem_cgroup *memcg,
 	s = create_cache(cache_name, root_cache->object_size,
 			 root_cache->size, root_cache->align,
 			 root_cache->flags & CACHE_CREATE_MASK,
+			 root_cache->useroffset, root_cache->usersize,
 			 root_cache->ctor, memcg, root_cache);
 	/*
 	 * If we could not create a memcg cache, do not complain, because
@@ -718,8 +771,7 @@ void kmem_cache_destroy(struct kmem_cache *s)
 	kasan_cache_destroy(s);
 	mutex_lock(&slab_mutex);
 
-	s->refcount--;
-	if (s->refcount)
+	if (!atomic_dec_and_test(&s->refcount))
 		goto out_unlock;
 
 	err = shutdown_memcg_caches(s, &release, &need_rcu_barrier);
@@ -770,13 +822,15 @@ bool slab_is_available(void)
 #ifndef CONFIG_SLOB
 /* Create a cache during boot when no slab services are available yet */
 void __init create_boot_cache(struct kmem_cache *s, const char *name, size_t size,
-		unsigned long flags)
+		unsigned long flags, size_t useroffset, size_t usersize)
 {
 	int err;
 
 	s->name = name;
 	s->size = s->object_size = size;
 	s->align = calculate_alignment(flags, ARCH_KMALLOC_MINALIGN, size);
+	s->useroffset = useroffset;
+	s->usersize = usersize;
 
 	slab_init_memcg_params(s);
 
@@ -786,23 +840,29 @@ void __init create_boot_cache(struct kmem_cache *s, const char *name, size_t siz
 		panic("Creation of kmalloc slab %s size=%zu failed. Reason %d\n",
 					name, size, err);
 
-	s->refcount = -1;	/* Exempt from merging for now */
+	atomic_set(&s->refcount, -1);	/* Exempt from merging for now */
 }
 
-struct kmem_cache *__init create_kmalloc_cache(const char *name, size_t size,
-				unsigned long flags)
+struct kmem_cache *__init create_kmalloc_cache_usercopy(const char *name, size_t size,
+				unsigned long flags, size_t useroffset, size_t usersize)
 {
 	struct kmem_cache *s = kmem_cache_zalloc(kmem_cache, GFP_NOWAIT);
 
 	if (!s)
 		panic("Out of memory when creating slab %s\n", name);
 
-	create_boot_cache(s, name, size, flags);
+	create_boot_cache(s, name, size, flags, useroffset, usersize);
 	list_add(&s->list, &slab_caches);
-	s->refcount = 1;
+	atomic_set(&s->refcount, 1);
 	return s;
 }
 
+struct kmem_cache *__init create_kmalloc_cache(const char *name, size_t size,
+				unsigned long flags)
+{
+	return create_kmalloc_cache_usercopy(name, size, flags, 0, 0);
+}
+
 struct kmem_cache *kmalloc_caches[KMALLOC_SHIFT_HIGH + 1];
 EXPORT_SYMBOL(kmalloc_caches);
 
@@ -811,6 +871,11 @@ struct kmem_cache *kmalloc_dma_caches[KMALLOC_SHIFT_HIGH + 1];
 EXPORT_SYMBOL(kmalloc_dma_caches);
 #endif
 
+#ifdef CONFIG_PAX_USERCOPY
+struct kmem_cache *kmalloc_usercopy_caches[KMALLOC_SHIFT_HIGH + 1];
+EXPORT_SYMBOL(kmalloc_usercopy_caches);
+#endif
+
 /*
  * Conversion table for small slabs sizes / 8 to the index in the
  * kmalloc array. This is necessary for slabs < 192 since we have non power
@@ -875,6 +940,13 @@ struct kmem_cache *kmalloc_slab(size_t size, gfp_t flags)
 		return kmalloc_dma_caches[index];
 
 #endif
+
+#ifdef CONFIG_PAX_USERCOPY
+	if (unlikely((flags & GFP_USERCOPY)))
+		return kmalloc_usercopy_caches[index];
+
+#endif
+
 	return kmalloc_caches[index];
 }
 
@@ -952,8 +1024,8 @@ void __init setup_kmalloc_cache_index_table(void)
 
 static void __init new_kmalloc_cache(int idx, unsigned long flags)
 {
-	kmalloc_caches[idx] = create_kmalloc_cache(kmalloc_info[idx].name,
-					kmalloc_info[idx].size, flags);
+	kmalloc_caches[idx] = create_kmalloc_cache_usercopy(kmalloc_info[idx].name,
+					kmalloc_info[idx].size, flags, 0, kmalloc_info[idx].size);
 }
 
 /*
@@ -998,6 +1070,23 @@ void __init create_kmalloc_caches(unsigned long flags)
 		}
 	}
 #endif
+
+#ifdef CONFIG_PAX_USERCOPY
+	for (i = 0; i <= KMALLOC_SHIFT_HIGH; i++) {
+		struct kmem_cache *s = kmalloc_caches[i];
+
+		if (s) {
+			int size = kmalloc_size(i);
+			char *n = kasprintf(GFP_NOWAIT,
+				 "usercopy-kmalloc-%d", size);
+
+			BUG_ON(!n);
+			kmalloc_usercopy_caches[i] = create_kmalloc_cache_usercopy(n,
+				size, flags, 0, size);
+		}
+	}
+#endif
+
 }
 #endif /* !CONFIG_SLOB */
 
@@ -1013,6 +1102,12 @@ void *kmalloc_order(size_t size, gfp_t flags, unsigned int order)
 
 	flags |= __GFP_COMP;
 	page = alloc_pages(flags, order);
+#ifdef CONFIG_SLOB
+	if (page) {
+		page->private = 1UL << order;
+		__SetPageSlab(page);
+	}
+#endif
 	ret = page ? page_address(page) : NULL;
 	kmemleak_alloc(ret, size, 1, flags);
 	kasan_kmalloc_large(ret, size, flags);
@@ -1102,6 +1197,9 @@ static void print_slabinfo_header(struct seq_file *m)
 #ifdef CONFIG_DEBUG_SLAB
 	seq_puts(m, " : globalstat <listallocs> <maxobjs> <grown> <reaped> <error> <maxfreeable> <nodeallocs> <remotefrees> <alienoverflow>");
 	seq_puts(m, " : cpustat <allochit> <allocmiss> <freehit> <freemiss>");
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	seq_puts(m, " : pax <sanitized> <not_sanitized>");
+#endif
 #endif
 	seq_putc(m, '\n');
 }
@@ -1231,7 +1329,7 @@ static int __init slab_proc_init(void)
 module_init(slab_proc_init);
 #endif /* CONFIG_SLABINFO */
 
-static __always_inline void *__do_krealloc(const void *p, size_t new_size,
+static __always_inline void * __size_overflow(2) __do_krealloc(const void *p, size_t new_size,
 					   gfp_t flags)
 {
 	void *ret;
diff --git a/mm/slob.c b/mm/slob.c
index 5ec158054..eea07f29e 100644
--- a/mm/slob.c
+++ b/mm/slob.c
@@ -67,6 +67,7 @@
 #include <linux/rcupdate.h>
 #include <linux/list.h>
 #include <linux/kmemleak.h>
+#include <linux/vmalloc.h>
 
 #include <trace/events/kmem.h>
 
@@ -157,7 +158,7 @@ static void set_slob(slob_t *s, slobidx_t size, slob_t *next)
 /*
  * Return the size of a slob block.
  */
-static slobidx_t slob_units(slob_t *s)
+static slobidx_t slob_units(const slob_t *s)
 {
 	if (s->units > 0)
 		return s->units;
@@ -167,7 +168,7 @@ static slobidx_t slob_units(slob_t *s)
 /*
  * Return the next free slob block pointer after this one.
  */
-static slob_t *slob_next(slob_t *s)
+static slob_t *slob_next(const slob_t *s)
 {
 	slob_t *base = (slob_t *)((unsigned long)s & PAGE_MASK);
 	slobidx_t next;
@@ -182,14 +183,14 @@ static slob_t *slob_next(slob_t *s)
 /*
  * Returns true if s is the last free block in its page.
  */
-static int slob_last(slob_t *s)
+static int slob_last(const slob_t *s)
 {
 	return !((unsigned long)slob_next(s) & ~PAGE_MASK);
 }
 
-static void *slob_new_pages(gfp_t gfp, int order, int node)
+static struct page *slob_new_pages(gfp_t gfp, unsigned int order, int node)
 {
-	void *page;
+	struct page *page;
 
 #ifdef CONFIG_NUMA
 	if (node != NUMA_NO_NODE)
@@ -201,14 +202,18 @@ static void *slob_new_pages(gfp_t gfp, int order, int node)
 	if (!page)
 		return NULL;
 
-	return page_address(page);
+	__SetPageSlab(page);
+	return page;
 }
 
-static void slob_free_pages(void *b, int order)
+static void slob_free_pages(struct page *sp, int order)
 {
 	if (current->reclaim_state)
 		current->reclaim_state->reclaimed_slab += 1 << order;
-	free_pages((unsigned long)b, order);
+	__ClearPageSlab(sp);
+	page_mapcount_reset(sp);
+	sp->private = 0;
+	__free_pages(sp, order);
 }
 
 /*
@@ -253,6 +258,7 @@ static void *slob_page_alloc(struct page *sp, size_t size, int align)
 			}
 
 			sp->units -= units;
+			BUG_ON(sp->units < 0);
 			if (!sp->units)
 				clear_slob_page_free(sp);
 			return cur;
@@ -313,15 +319,15 @@ static void *slob_alloc(size_t size, gfp_t gfp, int align, int node)
 
 	/* Not enough space: must allocate a new page */
 	if (!b) {
-		b = slob_new_pages(gfp & ~__GFP_ZERO, 0, node);
-		if (!b)
+		sp = slob_new_pages(gfp & ~__GFP_ZERO, 0, node);
+		if (!sp)
 			return NULL;
-		sp = virt_to_page(b);
-		__SetPageSlab(sp);
+		b = page_address(sp);
 
 		spin_lock_irqsave(&slob_lock, flags);
 		sp->units = SLOB_UNITS(PAGE_SIZE);
 		sp->freelist = b;
+		sp->private = 0;
 		INIT_LIST_HEAD(&sp->lru);
 		set_slob(b, SLOB_UNITS(PAGE_SIZE), b + SLOB_UNITS(PAGE_SIZE));
 		set_slob_page_free(sp, slob_list);
@@ -337,7 +343,7 @@ static void *slob_alloc(size_t size, gfp_t gfp, int align, int node)
 /*
  * slob_free: entry point into the slob allocator.
  */
-static void slob_free(void *block, int size)
+static void slob_free(struct kmem_cache *c, void *block, int size)
 {
 	struct page *sp;
 	slob_t *prev, *next, *b = (slob_t *)block;
@@ -349,7 +355,8 @@ static void slob_free(void *block, int size)
 		return;
 	BUG_ON(!size);
 
-	sp = virt_to_page(block);
+	sp = virt_to_head_page(block);
+	BUG_ON(virt_to_page(block) != sp);
 	units = SLOB_UNITS(size);
 
 	spin_lock_irqsave(&slob_lock, flags);
@@ -359,12 +366,15 @@ static void slob_free(void *block, int size)
 		if (slob_page_free(sp))
 			clear_slob_page_free(sp);
 		spin_unlock_irqrestore(&slob_lock, flags);
-		__ClearPageSlab(sp);
-		page_mapcount_reset(sp);
-		slob_free_pages(b, 0);
+		slob_free_pages(sp, 0);
 		return;
 	}
 
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	if (pax_sanitize_slab && !(c && (c->flags & SLAB_NO_SANITIZE)))
+		memset(block, PAX_MEMORY_SANITIZE_VALUE, size);
+#endif
+
 	if (!slob_page_free(sp)) {
 		/* This slob page is about to become partially free. Easy! */
 		sp->units = units;
@@ -424,11 +434,10 @@ out:
  */
 
 static __always_inline void *
-__do_kmalloc_node(size_t size, gfp_t gfp, int node, unsigned long caller)
+__do_kmalloc_node_align(size_t size, gfp_t gfp, int node, unsigned long caller, int align)
 {
-	unsigned int *m;
-	int align = max_t(size_t, ARCH_KMALLOC_MINALIGN, ARCH_SLAB_MINALIGN);
-	void *ret;
+	slob_t *m;
+	void *ret = NULL;
 
 	gfp &= gfp_allowed_mask;
 
@@ -442,27 +451,45 @@ __do_kmalloc_node(size_t size, gfp_t gfp, int node, unsigned long caller)
 
 		if (!m)
 			return NULL;
-		*m = size;
+		BUILD_BUG_ON(ARCH_KMALLOC_MINALIGN < 2 * SLOB_UNIT);
+		BUILD_BUG_ON(ARCH_SLAB_MINALIGN < 2 * SLOB_UNIT);
+		m[0].units = size;
+		m[1].units = align;
 		ret = (void *)m + align;
 
 		trace_kmalloc_node(caller, ret,
 				   size, size + align, gfp, node);
 	} else {
 		unsigned int order = get_order(size);
+		struct page *page;
 
 		if (likely(order))
 			gfp |= __GFP_COMP;
-		ret = slob_new_pages(gfp, order, node);
+		page = slob_new_pages(gfp, order, node);
+		if (page) {
+			ret = page_address(page);
+			page->private = size;
+		}
 
 		trace_kmalloc_node(caller, ret,
 				   size, PAGE_SIZE << order, gfp, node);
 	}
 
-	kmemleak_alloc(ret, size, 1, gfp);
 	return ret;
 }
 
-void *__kmalloc(size_t size, gfp_t gfp)
+static __always_inline void *
+__do_kmalloc_node(size_t size, gfp_t gfp, int node, unsigned long caller)
+{
+	int align = max(ARCH_KMALLOC_MINALIGN, ARCH_SLAB_MINALIGN);
+	void *ret = __do_kmalloc_node_align(size, gfp, node, caller, align);
+
+	if (!ZERO_OR_NULL_PTR(ret))
+		kmemleak_alloc(ret, size, 1, gfp);
+	return ret;
+}
+
+void * __size_overflow(1) __kmalloc(size_t size, gfp_t gfp)
 {
 	return __do_kmalloc_node(size, gfp, NUMA_NO_NODE, _RET_IP_);
 }
@@ -491,39 +518,140 @@ void kfree(const void *block)
 		return;
 	kmemleak_free(block);
 
-	sp = virt_to_page(block);
-	if (PageSlab(sp)) {
+	VM_BUG_ON(!virt_addr_valid(block));
+	sp = virt_to_head_page(block);
+	BUG_ON(virt_to_page(block) != sp);
+	VM_BUG_ON(!PageSlab(sp));
+	if (!sp->private) {
 		int align = max_t(size_t, ARCH_KMALLOC_MINALIGN, ARCH_SLAB_MINALIGN);
-		unsigned int *m = (unsigned int *)(block - align);
-		slob_free(m, *m + align);
-	} else
+		slob_t *m = (slob_t *)(block - align);
+
+		BUG_ON(sp->units < 0);
+		slob_free(NULL, m, m[0].units + align);
+	} else {
+		__ClearPageSlab(sp);
+		page_mapcount_reset(sp);
+		sp->private = 0;
 		__free_pages(sp, compound_order(sp));
+	}
 }
 EXPORT_SYMBOL(kfree);
 
+bool is_usercopy_object(const void *ptr)
+{
+	struct page *page;
+
+	if (ZERO_OR_NULL_PTR(ptr))
+		return false;
+
+	if (!slab_is_available())
+		return false;
+
+	if (is_vmalloc_addr(ptr)
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	    && !object_starts_on_stack(ptr)
+#endif
+	) {
+		struct vm_struct *vm = find_vm_area(ptr);
+		if (vm && (vm->flags & VM_USERCOPY))
+			return true;
+		return false;
+	}
+
+	if (!virt_addr_valid(ptr))
+		return false;
+
+	page = virt_to_head_page(ptr);
+	BUG_ON(virt_to_page(ptr) != page);
+
+	if (!PageSlab(page))
+		return false;
+
+	// PAX: TODO check SLAB_USERCOPY
+
+	return false;
+}
+
+#ifdef CONFIG_HARDENED_USERCOPY
+const char *__check_heap_object(const void *ptr, unsigned long n,
+				struct page *page)
+{
+	const slob_t *free;
+	const void *base;
+	unsigned long flags;
+
+	BUG_ON(virt_to_page(ptr) != page);
+
+	if (page->private) {
+		base = page_address(page);
+		if (base <= ptr && n <= page->private - (ptr - base))
+			return NULL;
+		return "<slob 1>";
+	}
+
+	/* some tricky double walking to find the chunk */
+	spin_lock_irqsave(&slob_lock, flags);
+	base = (const void *)((unsigned long)ptr & PAGE_MASK);
+	free = page->freelist;
+
+	while (!slob_last(free) && (const void *)free <= ptr) {
+		base = free + slob_units(free);
+		free = slob_next(free);
+	}
+
+	while (base < (const void *)free) {
+		slobidx_t m = ((slob_t *)base)[0].units, align = ((slob_t *)base)[1].units;
+		int size = SLOB_UNIT * SLOB_UNITS(m + align);
+		int offset;
+
+		if (ptr < base + align)
+			break;
+
+		offset = ptr - base - align;
+		if (offset >= m) {
+			base += size;
+			continue;
+		}
+
+		if (n > m - offset)
+			break;
+
+		spin_unlock_irqrestore(&slob_lock, flags);
+		return NULL;
+	}
+
+	spin_unlock_irqrestore(&slob_lock, flags);
+	return "<slob 2>";
+}
+#endif
+
 /* can't use ksize for kmem_cache_alloc memory, only kmalloc */
 size_t ksize(const void *block)
 {
 	struct page *sp;
 	int align;
-	unsigned int *m;
+	slob_t *m;
 
 	BUG_ON(!block);
 	if (unlikely(block == ZERO_SIZE_PTR))
 		return 0;
 
-	sp = virt_to_page(block);
-	if (unlikely(!PageSlab(sp)))
-		return PAGE_SIZE << compound_order(sp);
+	sp = virt_to_head_page(block);
+	BUG_ON(virt_to_page(block) != sp);
+	VM_BUG_ON(!PageSlab(sp));
+	if (sp->private)
+		return sp->private;
 
 	align = max_t(size_t, ARCH_KMALLOC_MINALIGN, ARCH_SLAB_MINALIGN);
-	m = (unsigned int *)(block - align);
-	return SLOB_UNITS(*m) * SLOB_UNIT;
+	m = (slob_t *)(block - align);
+	return SLOB_UNITS(m[0].units) * SLOB_UNIT;
 }
 EXPORT_SYMBOL(ksize);
 
 int __kmem_cache_create(struct kmem_cache *c, unsigned long flags)
 {
+	flags = pax_sanitize_slab_flags(flags);
+
 	if (flags & SLAB_DESTROY_BY_RCU) {
 		/* leave room for rcu footer at the end of object */
 		c->size += sizeof(struct slob_rcu);
@@ -534,23 +662,33 @@ int __kmem_cache_create(struct kmem_cache *c, unsigned long flags)
 
 static void *slob_alloc_node(struct kmem_cache *c, gfp_t flags, int node)
 {
-	void *b;
+	void *b = NULL;
 
 	flags &= gfp_allowed_mask;
 
 	lockdep_trace_alloc(flags);
 
+#ifdef CONFIG_PAX_USERCOPY
+	b = __do_kmalloc_node_align(c->size, flags, node, _RET_IP_, c->align);
+#else
 	if (c->size < PAGE_SIZE) {
 		b = slob_alloc(c->size, flags, c->align, node);
 		trace_kmem_cache_alloc_node(_RET_IP_, b, c->object_size,
 					    SLOB_UNITS(c->size) * SLOB_UNIT,
 					    flags, node);
 	} else {
-		b = slob_new_pages(flags, get_order(c->size), node);
+		struct page *sp;
+
+		sp = slob_new_pages(flags, get_order(c->size), node);
+		if (sp) {
+			b = page_address(sp);
+			sp->private = c->size;
+		}
 		trace_kmem_cache_alloc_node(_RET_IP_, b, c->object_size,
 					    PAGE_SIZE << get_order(c->size),
 					    flags, node);
 	}
+#endif
 
 	if (b && c->ctor)
 		c->ctor(b);
@@ -566,7 +704,7 @@ void *kmem_cache_alloc(struct kmem_cache *cachep, gfp_t flags)
 EXPORT_SYMBOL(kmem_cache_alloc);
 
 #ifdef CONFIG_NUMA
-void *__kmalloc_node(size_t size, gfp_t gfp, int node)
+void * __size_overflow(1) __kmalloc_node(size_t size, gfp_t gfp, int node)
 {
 	return __do_kmalloc_node(size, gfp, node, _RET_IP_);
 }
@@ -579,12 +717,17 @@ void *kmem_cache_alloc_node(struct kmem_cache *cachep, gfp_t gfp, int node)
 EXPORT_SYMBOL(kmem_cache_alloc_node);
 #endif
 
-static void __kmem_cache_free(void *b, int size)
+static void __kmem_cache_free(struct kmem_cache *c, void *b, int size)
 {
-	if (size < PAGE_SIZE)
-		slob_free(b, size);
+	struct page *sp;
+
+	BUG_ON(virt_to_page(b) != virt_to_head_page(b));
+	sp = virt_to_head_page(b);
+	BUG_ON(!PageSlab(sp));
+	if (!sp->private)
+		slob_free(c, b, size);
 	else
-		slob_free_pages(b, get_order(size));
+		slob_free_pages(sp, get_order(size));
 }
 
 static void kmem_rcu_free(struct rcu_head *head)
@@ -592,22 +735,36 @@ static void kmem_rcu_free(struct rcu_head *head)
 	struct slob_rcu *slob_rcu = (struct slob_rcu *)head;
 	void *b = (void *)slob_rcu - (slob_rcu->size - sizeof(struct slob_rcu));
 
-	__kmem_cache_free(b, slob_rcu->size);
+	__kmem_cache_free(NULL, b, slob_rcu->size);
 }
 
 void kmem_cache_free(struct kmem_cache *c, void *b)
 {
+	int size = c->size;
+
+#ifdef CONFIG_PAX_USERCOPY
+	if (size + c->align < PAGE_SIZE) {
+		size += c->align;
+		b -= c->align;
+	}
+#endif
+
 	kmemleak_free_recursive(b, c->flags);
 	if (unlikely(c->flags & SLAB_DESTROY_BY_RCU)) {
 		struct slob_rcu *slob_rcu;
-		slob_rcu = b + (c->size - sizeof(struct slob_rcu));
-		slob_rcu->size = c->size;
+		slob_rcu = b + (size - sizeof(struct slob_rcu));
+		slob_rcu->size = size;
 		call_rcu(&slob_rcu->head, kmem_rcu_free);
 	} else {
-		__kmem_cache_free(b, c->size);
+		__kmem_cache_free(c, b, size);
 	}
 
+#ifdef CONFIG_PAX_USERCOPY
+	trace_kfree(_RET_IP_, b);
+#else
 	trace_kmem_cache_free(_RET_IP_, b);
+#endif
+
 }
 EXPORT_SYMBOL(kmem_cache_free);
 
diff --git a/mm/slub.c b/mm/slub.c
index 9adae5846..5527bad2b 100644
--- a/mm/slub.c
+++ b/mm/slub.c
@@ -34,6 +34,7 @@
 #include <linux/stacktrace.h>
 #include <linux/prefetch.h>
 #include <linux/memcontrol.h>
+#include <linux/vmalloc.h>
 
 #include <trace/events/kmem.h>
 
@@ -214,7 +215,7 @@ struct track {
 
 enum track_item { TRACK_ALLOC, TRACK_FREE };
 
-#ifdef CONFIG_SYSFS
+#if defined(CONFIG_SYSFS) && !defined(CONFIG_GRKERNSEC_PROC_ADD)
 static int sysfs_slab_add(struct kmem_cache *);
 static int sysfs_slab_alias(struct kmem_cache *, const char *);
 static void memcg_propagate_slab_attrs(struct kmem_cache *s);
@@ -240,30 +241,40 @@ static inline void stat(const struct kmem_cache *s, enum stat_item si)
  * 			Core slab cache functions
  *******************************************************************/
 
+static const unsigned long global_rand __latent_entropy;
+
 static inline void *get_freepointer(struct kmem_cache *s, void *object)
 {
-	return *(void **)(object + s->offset);
+	unsigned long freepointer_addr = (unsigned long)object + s->offset;
+	return (void *)(*(unsigned long *)freepointer_addr ^ global_rand ^ freepointer_addr);
 }
 
 static void prefetch_freepointer(const struct kmem_cache *s, void *object)
 {
-	prefetch(object + s->offset);
+	unsigned long freepointer_addr = (unsigned long)object + s->offset;
+	if (object) {
+		void **freepointer_ptr = (void **)(*(unsigned long *)freepointer_addr ^ global_rand ^ freepointer_addr);
+		prefetch(freepointer_ptr);
+	}
 }
 
 static inline void *get_freepointer_safe(struct kmem_cache *s, void *object)
 {
+	unsigned long freepointer_addr;
 	void *p;
 
 	if (!debug_pagealloc_enabled())
 		return get_freepointer(s, object);
 
-	probe_kernel_read(&p, (void **)(object + s->offset), sizeof(p));
-	return p;
+	freepointer_addr = (unsigned long)object + s->offset;
+	probe_kernel_read(&p, (void **)freepointer_addr, sizeof(p));
+	return (void *)((unsigned long)p ^ global_rand ^ freepointer_addr);
 }
 
 static inline void set_freepointer(struct kmem_cache *s, void *object, void *fp)
 {
-	*(void **)(object + s->offset) = fp;
+	unsigned long freepointer_addr = (unsigned long)object + s->offset;
+	*(void **)freepointer_addr = (void *)((unsigned long)fp ^ global_rand ^ freepointer_addr);
 }
 
 /* Loop over all objects in a slab */
@@ -569,7 +580,7 @@ static void print_track(const char *s, struct track *t)
 	if (!t->addr)
 		return;
 
-	pr_err("INFO: %s in %pS age=%lu cpu=%u pid=%d\n",
+	pr_err("INFO: %s in %pA age=%lu cpu=%u pid=%d\n",
 	       s, (void *)t->addr, jiffies - t->when, t->cpu, t->pid);
 #ifdef CONFIG_STACKTRACE
 	{
@@ -2896,6 +2907,23 @@ static __always_inline void do_slab_free(struct kmem_cache *s,
 	void *tail_obj = tail ? : head;
 	struct kmem_cache_cpu *c;
 	unsigned long tid;
+
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	if (!(s->flags & SLAB_NO_SANITIZE)) {
+		int offset = s->offset ? 0 : sizeof(void *);
+		void *x = head;
+
+		while (1) {
+			memset(x + offset, PAX_MEMORY_SANITIZE_VALUE, s->object_size - offset);
+			if (s->ctor)
+				s->ctor(x);
+			if (x == tail_obj)
+				break;
+			x = get_freepointer(s, x);
+		}
+	}
+#endif
+
 redo:
 	/*
 	 * Determine the currently cpus per cpu slab.
@@ -3699,7 +3727,7 @@ static int __init setup_slub_min_objects(char *str)
 
 __setup("slub_min_objects=", setup_slub_min_objects);
 
-void *__kmalloc(size_t size, gfp_t flags)
+void * __size_overflow(1) __kmalloc(size_t size, gfp_t flags)
 {
 	struct kmem_cache *s;
 	void *ret;
@@ -3737,7 +3765,7 @@ static void *kmalloc_large_node(size_t size, gfp_t flags, int node)
 	return ptr;
 }
 
-void *__kmalloc_node(size_t size, gfp_t flags, int node)
+void * __size_overflow(1) __kmalloc_node(size_t size, gfp_t flags, int node)
 {
 	struct kmem_cache *s;
 	void *ret;
@@ -3768,9 +3796,41 @@ void *__kmalloc_node(size_t size, gfp_t flags, int node)
 EXPORT_SYMBOL(__kmalloc_node);
 #endif
 
+bool is_usercopy_object(const void *ptr)
+{
+	struct page *page;
+
+	if (ZERO_OR_NULL_PTR(ptr))
+		return false;
+
+	if (!slab_is_available())
+		return false;
+
+	if (is_vmalloc_addr(ptr)
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	    && !object_starts_on_stack(ptr)
+#endif
+	) {
+		struct vm_struct *vm = find_vm_area(ptr);
+		if (vm && (vm->flags & VM_USERCOPY))
+			return true;
+		return false;
+	}
+
+	if (!virt_addr_valid(ptr))
+		return false;
+
+	page = virt_to_head_page(ptr);
+
+	if (!PageSlab(page))
+		return false;
+
+	return !!page->slab_cache->usersize;
+}
+
 #ifdef CONFIG_HARDENED_USERCOPY
 /*
- * Rejects objects that are incorrectly sized.
+ * Detect unwanted object access
  *
  * Returns NULL if check passes, otherwise const char * to name of cache
  * to indicate an error.
@@ -3780,15 +3840,15 @@ const char *__check_heap_object(const void *ptr, unsigned long n,
 {
 	struct kmem_cache *s;
 	unsigned long offset;
-	size_t object_size;
 
 	/* Find object and usable object size. */
 	s = page->slab_cache;
-	object_size = slab_ksize(s);
 
+#ifdef CONFIG_BROKEN_SECURITY
 	/* Reject impossible pointers. */
 	if (ptr < page_address(page))
 		return s->name;
+#endif
 
 	/* Find offset within object. */
 	offset = (ptr - page_address(page)) % s->size;
@@ -3800,11 +3860,16 @@ const char *__check_heap_object(const void *ptr, unsigned long n,
 		offset -= s->red_left_pad;
 	}
 
-	/* Allow address range falling entirely within object size. */
-	if (offset <= object_size && n <= object_size - offset)
-		return NULL;
+	if (offset < s->useroffset)
+		return s->name;
+
+	if (offset - s->useroffset >= s->usersize)
+		return s->name;
 
-	return s->name;
+	if (n > s->useroffset - offset + s->usersize)
+		return s->name;
+
+	return NULL;
 }
 #endif /* CONFIG_HARDENED_USERCOPY */
 
@@ -3846,6 +3911,7 @@ void kfree(const void *x)
 	if (unlikely(ZERO_OR_NULL_PTR(x)))
 		return;
 
+	VM_BUG_ON(!virt_addr_valid(x));
 	page = virt_to_head_page(x);
 	if (unlikely(!PageSlab(page))) {
 		BUG_ON(!PageCompound(page));
@@ -4116,7 +4182,7 @@ void __init kmem_cache_init(void)
 	kmem_cache = &boot_kmem_cache;
 
 	create_boot_cache(kmem_cache_node, "kmem_cache_node",
-		sizeof(struct kmem_cache_node), SLAB_HWCACHE_ALIGN);
+		sizeof(struct kmem_cache_node), SLAB_HWCACHE_ALIGN, 0, 0);
 
 	register_hotmemory_notifier(&slab_memory_callback_nb);
 
@@ -4126,7 +4192,7 @@ void __init kmem_cache_init(void)
 	create_boot_cache(kmem_cache, "kmem_cache",
 			offsetof(struct kmem_cache, node) +
 				nr_node_ids * sizeof(struct kmem_cache_node *),
-		       SLAB_HWCACHE_ALIGN);
+		       SLAB_HWCACHE_ALIGN, 0, 0);
 
 	kmem_cache = bootstrap(&boot_kmem_cache);
 
@@ -4166,7 +4232,7 @@ __kmem_cache_alias(const char *name, size_t size, size_t align,
 
 	s = find_mergeable(size, align, flags, name, ctor);
 	if (s) {
-		s->refcount++;
+		atomic_inc(&s->refcount);
 
 		/*
 		 * Adjust the object sizes so that we clear
@@ -4182,7 +4248,7 @@ __kmem_cache_alias(const char *name, size_t size, size_t align,
 		}
 
 		if (sysfs_slab_alias(s, name)) {
-			s->refcount--;
+			atomic_dec(&s->refcount);
 			s = NULL;
 		}
 	}
@@ -4194,6 +4260,8 @@ int __kmem_cache_create(struct kmem_cache *s, unsigned long flags)
 {
 	int err;
 
+	flags = pax_sanitize_slab_flags(flags);
+
 	err = kmem_cache_open(s, flags);
 	if (err)
 		return err;
@@ -4299,7 +4367,7 @@ void *__kmalloc_node_track_caller(size_t size, gfp_t gfpflags,
 }
 #endif
 
-#ifdef CONFIG_SYSFS
+#if defined(CONFIG_SYSFS) && !defined(CONFIG_GRKERNSEC_PROC_ADD)
 static int count_inuse(struct page *page)
 {
 	return page->inuse;
@@ -4580,7 +4648,11 @@ static int list_locations(struct kmem_cache *s, char *buf,
 		len += sprintf(buf + len, "%7ld ", l->count);
 
 		if (l->addr)
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+			len += sprintf(buf + len, "%pS", NULL);
+#else
 			len += sprintf(buf + len, "%pS", (void *)l->addr);
+#endif
 		else
 			len += sprintf(buf + len, "<not-available>");
 
@@ -4678,12 +4750,12 @@ static void __init resiliency_test(void)
 	validate_slab_cache(kmalloc_caches[9]);
 }
 #else
-#ifdef CONFIG_SYSFS
+#if defined(CONFIG_SYSFS) && !defined(CONFIG_GRKERNSEC_PROC_ADD)
 static void resiliency_test(void) {};
 #endif
 #endif
 
-#ifdef CONFIG_SYSFS
+#if defined(CONFIG_SYSFS) && !defined(CONFIG_GRKERNSEC_PROC_ADD)
 enum slab_stat_type {
 	SL_ALL,			/* All slabs */
 	SL_PARTIAL,		/* Only partially allocated slabs */
@@ -4920,13 +4992,17 @@ static ssize_t ctor_show(struct kmem_cache *s, char *buf)
 {
 	if (!s->ctor)
 		return 0;
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+	return sprintf(buf, "%pS\n", NULL);
+#else
 	return sprintf(buf, "%pS\n", s->ctor);
+#endif
 }
 SLAB_ATTR_RO(ctor);
 
 static ssize_t aliases_show(struct kmem_cache *s, char *buf)
 {
-	return sprintf(buf, "%d\n", s->refcount < 0 ? 0 : s->refcount - 1);
+	return sprintf(buf, "%d\n", atomic_read(&s->refcount) < 0 ? 0 : atomic_read(&s->refcount) - 1);
 }
 SLAB_ATTR_RO(aliases);
 
@@ -5014,6 +5090,22 @@ static ssize_t cache_dma_show(struct kmem_cache *s, char *buf)
 SLAB_ATTR_RO(cache_dma);
 #endif
 
+#ifdef CONFIG_PAX_USERCOPY
+static ssize_t usercopy_show(struct kmem_cache *s, char *buf)
+{
+	return sprintf(buf, "%d\n", !!s->usersize);
+}
+SLAB_ATTR_RO(usercopy);
+#endif
+
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+static ssize_t sanitize_show(struct kmem_cache *s, char *buf)
+{
+	return sprintf(buf, "%d\n", !(s->flags & SLAB_NO_SANITIZE));
+}
+SLAB_ATTR_RO(sanitize);
+#endif
+
 static ssize_t destroy_by_rcu_show(struct kmem_cache *s, char *buf)
 {
 	return sprintf(buf, "%d\n", !!(s->flags & SLAB_DESTROY_BY_RCU));
@@ -5069,7 +5161,7 @@ static ssize_t trace_store(struct kmem_cache *s, const char *buf,
 	 * as well as cause other issues like converting a mergeable
 	 * cache into an umergeable one.
 	 */
-	if (s->refcount > 1)
+	if (atomic_read(&s->refcount) > 1)
 		return -EINVAL;
 
 	s->flags &= ~SLAB_TRACE;
@@ -5187,7 +5279,7 @@ static ssize_t failslab_show(struct kmem_cache *s, char *buf)
 static ssize_t failslab_store(struct kmem_cache *s, const char *buf,
 							size_t length)
 {
-	if (s->refcount > 1)
+	if (atomic_read(&s->refcount) > 1)
 		return -EINVAL;
 
 	s->flags &= ~SLAB_FAILSLAB;
@@ -5319,7 +5411,7 @@ STAT_ATTR(CPU_PARTIAL_NODE, cpu_partial_node);
 STAT_ATTR(CPU_PARTIAL_DRAIN, cpu_partial_drain);
 #endif
 
-static struct attribute *slab_attrs[] = {
+static struct attribute *slab_attrs[] __read_only = {
 	&slab_size_attr.attr,
 	&object_size_attr.attr,
 	&objs_per_slab_attr.attr,
@@ -5354,6 +5446,12 @@ static struct attribute *slab_attrs[] = {
 #ifdef CONFIG_ZONE_DMA
 	&cache_dma_attr.attr,
 #endif
+#ifdef CONFIG_PAX_USERCOPY
+	&usercopy_attr.attr,
+#endif
+#ifdef CONFIG_PAX_MEMORY_SANITIZE
+	&sanitize_attr.attr,
+#endif
 #ifdef CONFIG_NUMA
 	&remote_node_defrag_ratio_attr.attr,
 #endif
@@ -5597,6 +5695,7 @@ static char *create_unique_id(struct kmem_cache *s)
 	return name;
 }
 
+#if defined(CONFIG_SYSFS) && !defined(CONFIG_GRKERNSEC_PROC_ADD)
 static int sysfs_slab_add(struct kmem_cache *s)
 {
 	int err;
@@ -5668,6 +5767,7 @@ void sysfs_slab_remove(struct kmem_cache *s)
 	kobject_del(&s->kobj);
 	kobject_put(&s->kobj);
 }
+#endif
 
 /*
  * Need to buffer aliases during bootup until sysfs becomes
@@ -5681,6 +5781,7 @@ struct saved_alias {
 
 static struct saved_alias *alias_list;
 
+#if defined(CONFIG_SYSFS) && !defined(CONFIG_GRKERNSEC_PROC_ADD)
 static int sysfs_slab_alias(struct kmem_cache *s, const char *name)
 {
 	struct saved_alias *al;
@@ -5703,6 +5804,7 @@ static int sysfs_slab_alias(struct kmem_cache *s, const char *name)
 	alias_list = al;
 	return 0;
 }
+#endif
 
 static int __init slab_sysfs_init(void)
 {
diff --git a/mm/sparse-vmemmap.c b/mm/sparse-vmemmap.c
index 574c67b66..e890af88a 100644
--- a/mm/sparse-vmemmap.c
+++ b/mm/sparse-vmemmap.c
@@ -203,7 +203,7 @@ pud_t * __meminit vmemmap_pud_populate(pgd_t *pgd, unsigned long addr, int node)
 		void *p = vmemmap_alloc_block(PAGE_SIZE, node);
 		if (!p)
 			return NULL;
-		pud_populate(&init_mm, pud, p);
+		pud_populate_kernel(&init_mm, pud, p);
 	}
 	return pud;
 }
@@ -215,7 +215,7 @@ pgd_t * __meminit vmemmap_pgd_populate(unsigned long addr, int node)
 		void *p = vmemmap_alloc_block(PAGE_SIZE, node);
 		if (!p)
 			return NULL;
-		pgd_populate(&init_mm, pgd, p);
+		pgd_populate_kernel(&init_mm, pgd, p);
 	}
 	return pgd;
 }
diff --git a/mm/sparse.c b/mm/sparse.c
index 1e168bf27..2dc7328fe 100644
--- a/mm/sparse.c
+++ b/mm/sparse.c
@@ -749,7 +749,7 @@ static void clear_hwpoisoned_pages(struct page *memmap, int nr_pages)
 
 	for (i = 0; i < nr_pages; i++) {
 		if (PageHWPoison(&memmap[i])) {
-			atomic_long_sub(1, &num_poisoned_pages);
+			atomic_long_sub_unchecked(1, &num_poisoned_pages);
 			ClearPageHWPoison(&memmap[i]);
 		}
 	}
diff --git a/mm/swap.c b/mm/swap.c
index 75c63bb2a..a4dce2025 100644
--- a/mm/swap.c
+++ b/mm/swap.c
@@ -91,6 +91,13 @@ static void __put_compound_page(struct page *page)
 	if (!PageHuge(page))
 		__page_cache_release(page);
 	dtor = get_compound_page_dtor(page);
+	if (!PageHuge(page))
+		BUG_ON(dtor != free_compound_page
+#ifdef CONFIG_TRANSPARENT_HUGEPAGE
+			&& dtor != free_transhuge_page
+#endif
+		);
+
 	(*dtor)(page);
 }
 
diff --git a/mm/swapfile.c b/mm/swapfile.c
index bf262e494..c5bc3900d 100644
--- a/mm/swapfile.c
+++ b/mm/swapfile.c
@@ -90,7 +90,7 @@ static DEFINE_MUTEX(swapon_mutex);
 
 static DECLARE_WAIT_QUEUE_HEAD(proc_poll_wait);
 /* Activity counter to indicate that a swapon or swapoff has occurred */
-static atomic_t proc_poll_event = ATOMIC_INIT(0);
+static atomic_unchecked_t proc_poll_event = ATOMIC_INIT(0);
 
 static inline unsigned char swap_count(unsigned char ent)
 {
@@ -1979,7 +1979,7 @@ SYSCALL_DEFINE1(swapoff, const char __user *, specialfile)
 	spin_unlock(&swap_lock);
 
 	err = 0;
-	atomic_inc(&proc_poll_event);
+	atomic_inc_unchecked(&proc_poll_event);
 	wake_up_interruptible(&proc_poll_wait);
 
 out_dput:
@@ -1996,8 +1996,8 @@ static unsigned swaps_poll(struct file *file, poll_table *wait)
 
 	poll_wait(file, &proc_poll_wait, wait);
 
-	if (seq->poll_event != atomic_read(&proc_poll_event)) {
-		seq->poll_event = atomic_read(&proc_poll_event);
+	if (seq->poll_event != atomic_read_unchecked(&proc_poll_event)) {
+		seq->poll_event = atomic_read_unchecked(&proc_poll_event);
 		return POLLIN | POLLRDNORM | POLLERR | POLLPRI;
 	}
 
@@ -2095,7 +2095,7 @@ static int swaps_open(struct inode *inode, struct file *file)
 		return ret;
 
 	seq = file->private_data;
-	seq->poll_event = atomic_read(&proc_poll_event);
+	seq->poll_event = atomic_read_unchecked(&proc_poll_event);
 	return 0;
 }
 
@@ -2545,7 +2545,7 @@ SYSCALL_DEFINE2(swapon, const char __user *, specialfile, int, swap_flags)
 		(frontswap_map) ? "FS" : "");
 
 	mutex_unlock(&swapon_mutex);
-	atomic_inc(&proc_poll_event);
+	atomic_inc_unchecked(&proc_poll_event);
 	wake_up_interruptible(&proc_poll_wait);
 
 	if (S_ISREG(inode->i_mode))
diff --git a/mm/usercopy.c b/mm/usercopy.c
index 3c8da0af9..62823b9eb 100644
--- a/mm/usercopy.c
+++ b/mm/usercopy.c
@@ -16,15 +16,9 @@
 
 #include <linux/mm.h>
 #include <linux/slab.h>
+#include <linux/ratelimit.h>
 #include <asm/sections.h>
 
-enum {
-	BAD_STACK = -1,
-	NOT_STACK = 0,
-	GOOD_FRAME,
-	GOOD_STACK,
-};
-
 /*
  * Checks if a given pointer and length is contained by the current
  * stack frame (if possible).
@@ -35,11 +29,13 @@ enum {
  *	GOOD_STACK: fully on the stack (when can't do frame-checking)
  *	BAD_STACK: error condition (invalid stack position or bad stack frame)
  */
-static noinline int check_stack_object(const void *obj, unsigned long len)
+static noinline int check_stack_object(unsigned long obj, unsigned long len)
 {
-	const void * const stack = task_stack_page(current);
-	const void * const stackend = stack + THREAD_SIZE;
-	int ret;
+	unsigned long stack = (unsigned long)task_stack_page(current);
+	unsigned long stackend = (unsigned long)stack + THREAD_SIZE;
+
+	if (obj + len < obj)
+		return BAD_STACK;
 
 	/* Object is not on the stack at all. */
 	if (obj + len <= stack || stackend <= obj)
@@ -54,25 +50,29 @@ static noinline int check_stack_object(const void *obj, unsigned long len)
 		return BAD_STACK;
 
 	/* Check if object is safely within a valid frame. */
-	ret = arch_within_stack_frames(stack, stackend, obj, len);
-	if (ret)
-		return ret;
-
-	return GOOD_STACK;
+	return arch_within_stack_frames(stack, stackend, obj, len);
 }
 
-static void report_usercopy(const void *ptr, unsigned long len,
-			    bool to_user, const char *type)
+static DEFINE_RATELIMIT_STATE(usercopy_ratelimit, 15 * HZ, 3);
+
+static __noreturn void report_usercopy(const void *ptr, unsigned long len,
+				       bool to_user, const char *type)
 {
-	pr_emerg("kernel memory %s attempt detected %s %p (%s) (%lu bytes)\n",
-		to_user ? "exposure" : "overwrite",
-		to_user ? "from" : "to", ptr, type ? : "unknown", len);
+	if (__ratelimit(&usercopy_ratelimit)) {
+		pr_emerg("kernel memory %s attempt detected %s %p (%s) (%lu bytes)\n",
+			to_user ? "exposure" : "overwrite",
+			to_user ? "from" : "to", ptr, type ? : "unknown", len);
+		dump_stack();
+	}
+	do_group_exit(SIGKILL);
+#ifdef CONFIG_BROKEN_SECURITY
 	/*
 	 * For greater effect, it would be nice to do do_group_exit(),
 	 * but BUG() actually hooks all the lock-breaking and per-arch
 	 * Oops code, so that is used here instead.
 	 */
 	BUG();
+#endif
 }
 
 /* Returns true if any portion of [ptr,ptr+n) over laps with [low,high). */
@@ -93,8 +93,17 @@ static bool overlaps(const void *ptr, unsigned long n, unsigned long low,
 static inline const char *check_kernel_text_object(const void *ptr,
 						   unsigned long n)
 {
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	unsigned long textlow = ktla_ktva((unsigned long)_stext);
+#ifdef CONFIG_MODULES
+	unsigned long texthigh = (unsigned long)MODULES_EXEC_VADDR;
+#else
+	unsigned long texthigh = ktla_ktva((unsigned long)_etext);
+#endif
+#else
 	unsigned long textlow = (unsigned long)_stext;
 	unsigned long texthigh = (unsigned long)_etext;
+#endif
 	unsigned long textlow_linear, texthigh_linear;
 
 	if (overlaps(ptr, n, textlow, texthigh))
@@ -252,10 +261,15 @@ void __check_object_size(const void *ptr, unsigned long n, bool to_user)
 		goto report;
 
 	/* Check for bad stack object. */
-	switch (check_stack_object(ptr, n)) {
+	switch (check_stack_object((unsigned long)ptr, n)) {
 	case NOT_STACK:
 		/* Object is not touching the current process stack. */
-		break;
+		/* Check for object in kernel to avoid text exposure. */
+		err = check_kernel_text_object(ptr, n);
+		if (err)
+			break;
+		return;
+
 	case GOOD_FRAME:
 	case GOOD_STACK:
 		/*
@@ -264,16 +278,12 @@ void __check_object_size(const void *ptr, unsigned long n, bool to_user)
 		 * process stack (when frame checking not available).
 		 */
 		return;
-	default:
+
+	case BAD_STACK:
 		err = "<process stack>";
-		goto report;
+		break;
 	}
 
-	/* Check for object in kernel to avoid text exposure. */
-	err = check_kernel_text_object(ptr, n);
-	if (!err)
-		return;
-
 report:
 	report_usercopy(ptr, n, to_user, err);
 }
diff --git a/mm/util.c b/mm/util.c
index 662cddf91..ad8d778dd 100644
--- a/mm/util.c
+++ b/mm/util.c
@@ -239,6 +239,12 @@ int vma_is_stack_for_task(struct vm_area_struct *vma, struct task_struct *t)
 void arch_pick_mmap_layout(struct mm_struct *mm)
 {
 	mm->mmap_base = TASK_UNMAPPED_BASE;
+
+#ifdef CONFIG_PAX_RANDMMAP
+	if (mm->pax_flags & MF_PAX_RANDMMAP)
+		mm->mmap_base += mm->delta_mmap;
+#endif
+
 	mm->get_unmapped_area = arch_get_unmapped_area;
 }
 #endif
@@ -432,6 +438,7 @@ unsigned long sysctl_overcommit_kbytes __read_mostly;
 int sysctl_max_map_count __read_mostly = DEFAULT_MAX_MAP_COUNT;
 unsigned long sysctl_user_reserve_kbytes __read_mostly = 1UL << 17; /* 128MB */
 unsigned long sysctl_admin_reserve_kbytes __read_mostly = 1UL << 13; /* 8MB */
+unsigned long sysctl_heap_stack_gap __read_mostly = 64*1024;
 
 int overcommit_ratio_handler(struct ctl_table *table, int write,
 			     void __user *buffer, size_t *lenp,
@@ -611,6 +618,9 @@ int get_cmdline(struct task_struct *task, char *buffer, int buflen)
 	if (!mm->arg_end)
 		goto out_mm;	/* Shh! No looking before we're done */
 
+	if (gr_acl_handle_procpidmem(task))
+		goto out_mm;
+
 	down_read(&mm->mmap_sem);
 	arg_start = mm->arg_start;
 	arg_end = mm->arg_end;
diff --git a/mm/vmalloc.c b/mm/vmalloc.c
index 91f44e78c..8500d4064 100644
--- a/mm/vmalloc.c
+++ b/mm/vmalloc.c
@@ -43,20 +43,65 @@ struct vfree_deferred {
 	struct work_struct wq;
 };
 static DEFINE_PER_CPU(struct vfree_deferred, vfree_deferred);
+static DEFINE_PER_CPU(struct vfree_deferred, vunmap_deferred);
+
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+struct stack_deferred_llist {
+	struct llist_head list;
+	void *stack;
+	void *lowmem_stack;
+};
+
+struct stack_deferred {
+	struct stack_deferred_llist list;
+	struct work_struct wq;
+};
+
+static DEFINE_PER_CPU(struct stack_deferred, stack_deferred);
+#endif
 
 static void __vunmap(const void *, int);
 
-static void free_work(struct work_struct *w)
+static void vfree_work(struct work_struct *w)
+{
+	struct vfree_deferred *p = container_of(w, struct vfree_deferred, wq);
+	struct llist_node *llnode = llist_del_all(&p->list);
+	while (llnode) {
+		void *x = llnode;
+		llnode = llist_next(llnode);
+		__vunmap(x, 1);
+	}
+}
+
+static void vunmap_work(struct work_struct *w)
 {
 	struct vfree_deferred *p = container_of(w, struct vfree_deferred, wq);
 	struct llist_node *llnode = llist_del_all(&p->list);
 	while (llnode) {
-		void *p = llnode;
+		void *x = llnode;
 		llnode = llist_next(llnode);
-		__vunmap(p, 1);
+		__vunmap(x, 0);
 	}
 }
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+static void unmap_work(struct work_struct *w)
+{
+	struct stack_deferred *p = container_of(w, struct stack_deferred, wq);
+	struct llist_node *llnode = llist_del_all(&p->list.list);
+	while (llnode) {
+		struct stack_deferred_llist *x =
+			llist_entry((struct llist_head *)llnode,
+				     struct stack_deferred_llist, list);
+		void *stack = ACCESS_ONCE(x->stack);
+		void *lowmem_stack = ACCESS_ONCE(x->lowmem_stack);
+		llnode = llist_next(llnode);
+		__vunmap(stack, 0);
+		free_pages((unsigned long)lowmem_stack, THREAD_SIZE_ORDER);
+	}
+}
+#endif
+
 /*** Page table manipulation functions ***/
 
 static void vunmap_pte_range(pmd_t *pmd, unsigned long addr, unsigned long end)
@@ -64,10 +109,23 @@ static void vunmap_pte_range(pmd_t *pmd, unsigned long addr, unsigned long end)
 	pte_t *pte;
 
 	pte = pte_offset_kernel(pmd, addr);
+	pax_open_kernel();
 	do {
-		pte_t ptent = ptep_get_and_clear(&init_mm, addr, pte);
-		WARN_ON(!pte_none(ptent) && !pte_present(ptent));
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		if ((unsigned long)MODULES_EXEC_VADDR <= addr && addr < (unsigned long)MODULES_EXEC_END) {
+			BUG_ON(!pte_exec(*pte));
+			set_pte_at(&init_mm, addr, pte, pfn_pte(__pa(addr) >> PAGE_SHIFT, PAGE_KERNEL_EXEC));
+			continue;
+		}
+#endif
+
+		{
+			pte_t ptent = ptep_get_and_clear(&init_mm, addr, pte);
+			WARN_ON(!pte_none(ptent) && !pte_present(ptent));
+		}
 	} while (pte++, addr += PAGE_SIZE, addr != end);
+	pax_close_kernel();
 }
 
 static void vunmap_pmd_range(pud_t *pud, unsigned long addr, unsigned long end)
@@ -130,16 +188,29 @@ static int vmap_pte_range(pmd_t *pmd, unsigned long addr,
 	pte = pte_alloc_kernel(pmd, addr);
 	if (!pte)
 		return -ENOMEM;
+
+	pax_open_kernel();
 	do {
 		struct page *page = pages[*nr];
 
-		if (WARN_ON(!pte_none(*pte)))
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+		if (pgprot_val(prot) & _PAGE_NX)
+#endif
+
+		if (!pte_none(*pte)) {
+			pax_close_kernel();
+			WARN_ON(1);
 			return -EBUSY;
-		if (WARN_ON(!page))
+		}
+		if (!page) {
+			pax_close_kernel();
+			WARN_ON(1);
 			return -ENOMEM;
+		}
 		set_pte_at(&init_mm, addr, pte, mk_pte(page, prot));
 		(*nr)++;
 	} while (pte++, addr += PAGE_SIZE, addr != end);
+	pax_close_kernel();
 	return 0;
 }
 
@@ -149,7 +220,7 @@ static int vmap_pmd_range(pud_t *pud, unsigned long addr,
 	pmd_t *pmd;
 	unsigned long next;
 
-	pmd = pmd_alloc(&init_mm, pud, addr);
+	pmd = pmd_alloc_kernel(&init_mm, pud, addr);
 	if (!pmd)
 		return -ENOMEM;
 	do {
@@ -166,7 +237,7 @@ static int vmap_pud_range(pgd_t *pgd, unsigned long addr,
 	pud_t *pud;
 	unsigned long next;
 
-	pud = pud_alloc(&init_mm, pgd, addr);
+	pud = pud_alloc_kernel(&init_mm, pgd, addr);
 	if (!pud)
 		return -ENOMEM;
 	do {
@@ -226,6 +297,12 @@ int is_vmalloc_or_module_addr(const void *x)
 	if (addr >= MODULES_VADDR && addr < MODULES_END)
 		return 1;
 #endif
+
+#if defined(CONFIG_X86_32) && defined(CONFIG_PAX_KERNEXEC)
+	if (x >= (const void *)MODULES_EXEC_VADDR && x < (const void *)MODULES_EXEC_END)
+		return 1;
+#endif
+
 	return is_vmalloc_addr(x);
 }
 
@@ -246,8 +323,14 @@ struct page *vmalloc_to_page(const void *vmalloc_addr)
 
 	if (!pgd_none(*pgd)) {
 		pud_t *pud = pud_offset(pgd, addr);
+#ifdef CONFIG_X86
+		if (!pud_large(*pud))
+#endif
 		if (!pud_none(*pud)) {
 			pmd_t *pmd = pmd_offset(pud, addr);
+#ifdef CONFIG_X86
+			if (!pmd_large(*pmd))
+#endif
 			if (!pmd_none(*pmd)) {
 				pte_t *ptep, pte;
 
@@ -350,7 +433,7 @@ static BLOCKING_NOTIFIER_HEAD(vmap_notify_list);
  * Allocate a region of KVA of the specified size and alignment, within the
  * vstart and vend.
  */
-static struct vmap_area *alloc_vmap_area(unsigned long size,
+static struct vmap_area * __size_overflow(1) alloc_vmap_area(unsigned long size,
 				unsigned long align,
 				unsigned long vstart, unsigned long vend,
 				int node, gfp_t gfp_mask)
@@ -1228,13 +1311,27 @@ void __init vmalloc_init(void)
 	for_each_possible_cpu(i) {
 		struct vmap_block_queue *vbq;
 		struct vfree_deferred *p;
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+		struct stack_deferred *p2;
+#endif
 
 		vbq = &per_cpu(vmap_block_queue, i);
 		spin_lock_init(&vbq->lock);
 		INIT_LIST_HEAD(&vbq->free);
+
 		p = &per_cpu(vfree_deferred, i);
 		init_llist_head(&p->list);
-		INIT_WORK(&p->wq, free_work);
+		INIT_WORK(&p->wq, vfree_work);
+
+		p = &per_cpu(vunmap_deferred, i);
+		init_llist_head(&p->list);
+		INIT_WORK(&p->wq, vunmap_work);
+
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+		p2 = &per_cpu(stack_deferred, i);
+		init_llist_head(&p2->list.list);
+		INIT_WORK(&p2->wq, unmap_work);
+#endif
 	}
 
 	/* Import existing vmlist entries. */
@@ -1359,6 +1456,16 @@ static struct vm_struct *__get_vm_area_node(unsigned long size,
 	struct vm_struct *area;
 
 	BUG_ON(in_interrupt());
+
+#if defined(CONFIG_X86) && defined(CONFIG_PAX_KERNEXEC)
+	if (flags & VM_KERNEXEC) {
+		if (start != VMALLOC_START || end != VMALLOC_END)
+			return NULL;
+		start = (unsigned long)MODULES_EXEC_VADDR;
+		end = (unsigned long)MODULES_EXEC_END;
+	}
+#endif
+
 	if (flags & VM_IOREMAP)
 		align = 1ul << clamp_t(int, fls_long(size),
 				       PAGE_SHIFT, IOREMAP_MAX_ORDER);
@@ -1371,7 +1478,11 @@ static struct vm_struct *__get_vm_area_node(unsigned long size,
 	if (unlikely(!area))
 		return NULL;
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+	if (!(flags & VM_NO_GUARD) || (start >= VMALLOC_START && end <= VMALLOC_END))
+#else
 	if (!(flags & VM_NO_GUARD))
+#endif
 		size += PAGE_SIZE;
 
 	va = alloc_vmap_area(size, align, start, end, node, gfp_mask);
@@ -1553,13 +1664,36 @@ EXPORT_SYMBOL(vfree);
  */
 void vunmap(const void *addr)
 {
-	BUG_ON(in_interrupt());
-	might_sleep();
-	if (addr)
+	if (!addr)
+		return;
+	if (unlikely(in_interrupt())) {
+		struct vfree_deferred *p = this_cpu_ptr(&vunmap_deferred);
+		if (pax_llist_add((struct llist_node *)addr, &p->list))
+			schedule_work(&p->wq);
+	} else {
+		might_sleep();
 		__vunmap(addr, 0);
+	}
 }
 EXPORT_SYMBOL(vunmap);
 
+#ifdef CONFIG_GRKERNSEC_KSTACKOVERFLOW
+void unmap_process_stacks(struct task_struct *task)
+{
+	if (unlikely(in_interrupt())) {
+		struct stack_deferred *p = this_cpu_ptr(&stack_deferred);
+		struct stack_deferred_llist *list = task->stack;
+		list->stack = task->stack;
+		list->lowmem_stack = task->lowmem_stack;
+		if (llist_add((struct llist_node *)&list->list, &p->list.list))
+			schedule_work(&p->wq);
+	} else {
+		__vunmap(task->stack, 0);
+		free_pages((unsigned long)task->lowmem_stack, THREAD_SIZE_ORDER);
+	}
+}
+#endif
+
 /**
  *	vmap  -  map an array of pages into virtually contiguous space
  *	@pages:		array of page pointers
@@ -1581,6 +1715,11 @@ void *vmap(struct page **pages, unsigned int count,
 	if (count > totalram_pages)
 		return NULL;
 
+#if defined(CONFIG_X86) && defined(CONFIG_PAX_KERNEXEC)
+	if (!(pgprot_val(prot) & _PAGE_NX))
+		flags |= VM_KERNEXEC;
+#endif
+
 	size = (unsigned long)count << PAGE_SHIFT;
 	area = get_vm_area_caller(size, flags, __builtin_return_address(0));
 	if (!area)
@@ -1684,6 +1823,14 @@ void *__vmalloc_node_range(unsigned long size, unsigned long align,
 	if (!size || (size >> PAGE_SHIFT) > totalram_pages)
 		goto fail;
 
+#if defined(CONFIG_X86) && defined(CONFIG_PAX_KERNEXEC)
+	if (!(pgprot_val(prot) & _PAGE_NX)) {
+		vm_flags |= VM_KERNEXEC;
+		start = VMALLOC_START;
+		end = VMALLOC_END;
+	}
+#endif
+
 	area = __get_vm_area_node(size, align, VM_ALLOC | VM_UNINITIALIZED |
 				vm_flags, start, end, node, gfp_mask, caller);
 	if (!area)
@@ -1737,6 +1884,14 @@ static void *__vmalloc_node(unsigned long size, unsigned long align,
 				gfp_mask, prot, 0, node, caller);
 }
 
+void *vmalloc_usercopy(unsigned long size)
+{
+	return __vmalloc_node_range(size, 1, VMALLOC_START, VMALLOC_END,
+				    GFP_KERNEL | __GFP_HIGHMEM, PAGE_KERNEL,
+				    VM_USERCOPY, NUMA_NO_NODE,
+				    __builtin_return_address(0));
+}
+
 void *__vmalloc(unsigned long size, gfp_t gfp_mask, pgprot_t prot)
 {
 	return __vmalloc_node(size, 1, gfp_mask, prot, NUMA_NO_NODE,
@@ -1751,6 +1906,16 @@ static inline void *__vmalloc_node_flags(unsigned long size,
 					node, __builtin_return_address(0));
 }
 
+#if defined(CONFIG_GRKERNSEC_KSTACKOVERFLOW) && defined(CONFIG_X86_64)
+void *vzalloc_irq_stack(void)
+{
+	return __vmalloc_node(IRQ_STACK_SIZE, IRQ_STACK_SIZE,
+			      GFP_KERNEL | __GFP_NOTRACK | __GFP_ZERO,
+			      PAGE_KERNEL, NUMA_NO_NODE,
+			      __builtin_return_address(0));
+}
+#endif
+
 /**
  *	vmalloc  -  allocate virtually contiguous memory
  *	@size:		allocation size
@@ -1860,10 +2025,9 @@ EXPORT_SYMBOL(vzalloc_node);
  *	For tight control over page level allocator and protection flags
  *	use __vmalloc() instead.
  */
-
 void *vmalloc_exec(unsigned long size)
 {
-	return __vmalloc_node(size, 1, GFP_KERNEL | __GFP_HIGHMEM, PAGE_KERNEL_EXEC,
+	return __vmalloc_node(size, 1, GFP_KERNEL | __GFP_HIGHMEM | __GFP_ZERO, PAGE_KERNEL_EXEC,
 			      NUMA_NO_NODE, __builtin_return_address(0));
 }
 
@@ -2170,6 +2334,8 @@ int remap_vmalloc_range_partial(struct vm_area_struct *vma, unsigned long uaddr,
 {
 	struct vm_struct *area;
 
+	BUG_ON(vma->vm_mirror);
+
 	size = PAGE_ALIGN(size);
 
 	if (!PAGE_ALIGNED(uaddr) || !PAGE_ALIGNED(kaddr))
@@ -2539,7 +2705,7 @@ found:
 	/* insert all vm's */
 	for (area = 0; area < nr_vms; area++)
 		setup_vmalloc_vm(vms[area], vas[area], VM_ALLOC,
-				 pcpu_get_vm_areas);
+				 __builtin_return_address(0));
 
 	kfree(vas);
 	return vms;
@@ -2652,7 +2818,11 @@ static int s_show(struct seq_file *m, void *p)
 		v->addr, v->addr + v->size, v->size);
 
 	if (v->caller)
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+		seq_printf(m, " %pK", v->caller);
+#else
 		seq_printf(m, " %pS", v->caller);
+#endif
 
 	if (v->nr_pages)
 		seq_printf(m, " pages=%d", v->nr_pages);
diff --git a/mm/vmstat.c b/mm/vmstat.c
index 89cec42d1..673413a89 100644
--- a/mm/vmstat.c
+++ b/mm/vmstat.c
@@ -27,6 +27,7 @@
 #include <linux/mm_inline.h>
 #include <linux/page_ext.h>
 #include <linux/page_owner.h>
+#include <linux/grsecurity.h>
 
 #include "internal.h"
 
@@ -86,8 +87,8 @@ void vm_events_fold_cpu(int cpu)
  *
  * vm_stat contains the global counters
  */
-atomic_long_t vm_zone_stat[NR_VM_ZONE_STAT_ITEMS] __cacheline_aligned_in_smp;
-atomic_long_t vm_node_stat[NR_VM_NODE_STAT_ITEMS] __cacheline_aligned_in_smp;
+atomic_long_unchecked_t vm_zone_stat[NR_VM_ZONE_STAT_ITEMS] __cacheline_aligned_in_smp;
+atomic_long_unchecked_t vm_node_stat[NR_VM_NODE_STAT_ITEMS] __cacheline_aligned_in_smp;
 EXPORT_SYMBOL(vm_zone_stat);
 EXPORT_SYMBOL(vm_node_stat);
 
@@ -611,13 +612,13 @@ static int fold_diff(int *zone_diff, int *node_diff)
 
 	for (i = 0; i < NR_VM_ZONE_STAT_ITEMS; i++)
 		if (zone_diff[i]) {
-			atomic_long_add(zone_diff[i], &vm_zone_stat[i]);
+			atomic_long_add_unchecked(zone_diff[i], &vm_zone_stat[i]);
 			changes++;
 	}
 
 	for (i = 0; i < NR_VM_NODE_STAT_ITEMS; i++)
 		if (node_diff[i]) {
-			atomic_long_add(node_diff[i], &vm_node_stat[i]);
+			atomic_long_add_unchecked(node_diff[i], &vm_node_stat[i]);
 			changes++;
 	}
 	return changes;
@@ -657,7 +658,7 @@ static int refresh_cpu_vm_stats(bool do_pagesets)
 			v = this_cpu_xchg(p->vm_stat_diff[i], 0);
 			if (v) {
 
-				atomic_long_add(v, &zone->vm_stat[i]);
+				atomic_long_add_unchecked(v, &zone->vm_stat[i]);
 				global_zone_diff[i] += v;
 #ifdef CONFIG_NUMA
 				/* 3 seconds idle till flush */
@@ -706,7 +707,7 @@ static int refresh_cpu_vm_stats(bool do_pagesets)
 
 			v = this_cpu_xchg(p->vm_node_stat_diff[i], 0);
 			if (v) {
-				atomic_long_add(v, &pgdat->vm_stat[i]);
+				atomic_long_add_unchecked(v, &pgdat->vm_stat[i]);
 				global_node_diff[i] += v;
 			}
 		}
@@ -740,7 +741,7 @@ void cpu_vm_stats_fold(int cpu)
 
 				v = p->vm_stat_diff[i];
 				p->vm_stat_diff[i] = 0;
-				atomic_long_add(v, &zone->vm_stat[i]);
+				atomic_long_add_unchecked(v, &zone->vm_stat[i]);
 				global_zone_diff[i] += v;
 			}
 	}
@@ -756,7 +757,7 @@ void cpu_vm_stats_fold(int cpu)
 
 				v = p->vm_node_stat_diff[i];
 				p->vm_node_stat_diff[i] = 0;
-				atomic_long_add(v, &pgdat->vm_stat[i]);
+				atomic_long_add_unchecked(v, &pgdat->vm_stat[i]);
 				global_node_diff[i] += v;
 			}
 	}
@@ -776,8 +777,8 @@ void drain_zonestat(struct zone *zone, struct per_cpu_pageset *pset)
 		if (pset->vm_stat_diff[i]) {
 			int v = pset->vm_stat_diff[i];
 			pset->vm_stat_diff[i] = 0;
-			atomic_long_add(v, &zone->vm_stat[i]);
-			atomic_long_add(v, &vm_zone_stat[i]);
+			atomic_long_add_unchecked(v, &zone->vm_stat[i]);
+			atomic_long_add_unchecked(v, &vm_zone_stat[i]);
 		}
 }
 #endif
@@ -807,7 +808,7 @@ unsigned long sum_zone_node_page_state(int node,
 unsigned long node_page_state(struct pglist_data *pgdat,
 				enum node_stat_item item)
 {
-	long x = atomic_long_read(&pgdat->vm_stat[item]);
+	long x = atomic_long_read_unchecked(&pgdat->vm_stat[item]);
 #ifdef CONFIG_SMP
 	if (x < 0)
 		x = 0;
@@ -1556,10 +1557,22 @@ static void *vmstat_start(struct seq_file *m, loff_t *pos)
 	stat_items_size += sizeof(struct vm_event_state);
 #endif
 
-	v = kmalloc(stat_items_size, GFP_KERNEL);
+	v = kzalloc(stat_items_size, GFP_KERNEL);
 	m->private = v;
 	if (!v)
 		return ERR_PTR(-ENOMEM);
+
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+#if defined(CONFIG_GRKERNSEC_PROC_USER) || defined(CONFIG_GRKERNSEC_PROC_USERGROUP)
+        if (!uid_eq(current_uid(), GLOBAL_ROOT_UID)
+#ifdef CONFIG_GRKERNSEC_PROC_USERGROUP
+                && !in_group_p(grsec_proc_gid)
+#endif
+        )
+		return (unsigned long *)m->private + *pos;
+#endif
+#endif
+
 	for (i = 0; i < NR_VM_ZONE_STAT_ITEMS; i++)
 		v[i] = global_page_state(i);
 	v += NR_VM_ZONE_STAT_ITEMS;
@@ -1656,7 +1669,7 @@ int vmstat_refresh(struct ctl_table *table, int write,
 	if (err)
 		return err;
 	for (i = 0; i < NR_VM_ZONE_STAT_ITEMS; i++) {
-		val = atomic_long_read(&vm_zone_stat[i]);
+		val = atomic_long_read_unchecked(&vm_zone_stat[i]);
 		if (val < 0) {
 			switch (i) {
 			case NR_PAGES_SCANNED:
@@ -1856,10 +1869,16 @@ static int __init setup_vmstat(void)
 	cpu_notifier_register_done();
 #endif
 #ifdef CONFIG_PROC_FS
-	proc_create("buddyinfo", S_IRUGO, NULL, &fragmentation_file_operations);
-	proc_create("pagetypeinfo", S_IRUGO, NULL, &pagetypeinfo_file_ops);
-	proc_create("vmstat", S_IRUGO, NULL, &proc_vmstat_file_operations);
-	proc_create("zoneinfo", S_IRUGO, NULL, &proc_zoneinfo_file_operations);
+	{
+		mode_t gr_mode = S_IRUGO;
+#ifdef CONFIG_GRKERNSEC_PROC_ADD
+		gr_mode = S_IRUSR;
+#endif
+		proc_create("buddyinfo", gr_mode, NULL, &fragmentation_file_operations);
+		proc_create("pagetypeinfo", gr_mode, NULL, &pagetypeinfo_file_ops);
+		proc_create("vmstat", S_IRUGO, NULL, &proc_vmstat_file_operations);
+		proc_create("zoneinfo", gr_mode, NULL, &proc_zoneinfo_file_operations);
+	}
 #endif
 	return 0;
 }
diff --git a/net/8021q/vlan.c b/net/8021q/vlan.c
index f2531ad66..5792672b3 100644
--- a/net/8021q/vlan.c
+++ b/net/8021q/vlan.c
@@ -496,7 +496,7 @@ out:
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block vlan_notifier_block __read_mostly = {
+static struct notifier_block vlan_notifier_block = {
 	.notifier_call = vlan_device_event,
 };
 
@@ -571,8 +571,7 @@ static int vlan_ioctl_handler(struct net *net, void __user *arg)
 		err = -EPERM;
 		if (!ns_capable(net->user_ns, CAP_NET_ADMIN))
 			break;
-		if ((args.u.name_type >= 0) &&
-		    (args.u.name_type < VLAN_NAME_TYPE_HIGHEST)) {
+		if (args.u.name_type < VLAN_NAME_TYPE_HIGHEST) {
 			struct vlan_net *vn;
 
 			vn = net_generic(net, vlan_net_id);
diff --git a/net/8021q/vlan_netlink.c b/net/8021q/vlan_netlink.c
index 1270207f3..d165bb5c0 100644
--- a/net/8021q/vlan_netlink.c
+++ b/net/8021q/vlan_netlink.c
@@ -248,7 +248,7 @@ static struct net *vlan_get_link_net(const struct net_device *dev)
 	return dev_net(real_dev);
 }
 
-struct rtnl_link_ops vlan_link_ops __read_mostly = {
+struct rtnl_link_ops vlan_link_ops = {
 	.kind		= "vlan",
 	.maxtype	= IFLA_VLAN_MAX,
 	.policy		= vlan_policy,
diff --git a/net/9p/mod.c b/net/9p/mod.c
index 6ab36aea7..6f1841b7f 100644
--- a/net/9p/mod.c
+++ b/net/9p/mod.c
@@ -84,7 +84,7 @@ static LIST_HEAD(v9fs_trans_list);
 void v9fs_register_trans(struct p9_trans_module *m)
 {
 	spin_lock(&v9fs_trans_lock);
-	list_add_tail(&m->list, &v9fs_trans_list);
+	pax_list_add_tail((struct list_head *)&m->list, &v9fs_trans_list);
 	spin_unlock(&v9fs_trans_lock);
 }
 EXPORT_SYMBOL(v9fs_register_trans);
@@ -97,7 +97,7 @@ EXPORT_SYMBOL(v9fs_register_trans);
 void v9fs_unregister_trans(struct p9_trans_module *m)
 {
 	spin_lock(&v9fs_trans_lock);
-	list_del_init(&m->list);
+	pax_list_del_init((struct list_head *)&m->list);
 	spin_unlock(&v9fs_trans_lock);
 }
 EXPORT_SYMBOL(v9fs_unregister_trans);
diff --git a/net/9p/trans_fd.c b/net/9p/trans_fd.c
index 7bc2208b6..79c806869 100644
--- a/net/9p/trans_fd.c
+++ b/net/9p/trans_fd.c
@@ -432,7 +432,7 @@ static int p9_fd_write(struct p9_client *client, void *v, int len)
 	oldfs = get_fs();
 	set_fs(get_ds());
 	/* The cast to a user pointer is valid due to the set_fs() */
-	ret = vfs_write(ts->wr, (__force void __user *)v, len, &ts->wr->f_pos);
+	ret = vfs_write(ts->wr, (void __force_user *)v, len, &ts->wr->f_pos);
 	set_fs(oldfs);
 
 	if (ret <= 0 && ret != -ERESTARTSYS && ret != -EAGAIN)
diff --git a/net/appletalk/atalk_proc.c b/net/appletalk/atalk_proc.c
index af46bc49e..f9adfcdfd 100644
--- a/net/appletalk/atalk_proc.c
+++ b/net/appletalk/atalk_proc.c
@@ -256,7 +256,7 @@ int __init atalk_proc_init(void)
 	struct proc_dir_entry *p;
 	int rc = -ENOMEM;
 
-	atalk_proc_dir = proc_mkdir("atalk", init_net.proc_net);
+	atalk_proc_dir = proc_mkdir_restrict("atalk", init_net.proc_net);
 	if (!atalk_proc_dir)
 		goto out;
 
diff --git a/net/atm/atm_misc.c b/net/atm/atm_misc.c
index 876fbe83e..8bbea9f75 100644
--- a/net/atm/atm_misc.c
+++ b/net/atm/atm_misc.c
@@ -17,7 +17,7 @@ int atm_charge(struct atm_vcc *vcc, int truesize)
 	if (atomic_read(&sk_atm(vcc)->sk_rmem_alloc) <= sk_atm(vcc)->sk_rcvbuf)
 		return 1;
 	atm_return(vcc, truesize);
-	atomic_inc(&vcc->stats->rx_drop);
+	atomic_inc_unchecked(&vcc->stats->rx_drop);
 	return 0;
 }
 EXPORT_SYMBOL(atm_charge);
@@ -39,7 +39,7 @@ struct sk_buff *atm_alloc_charge(struct atm_vcc *vcc, int pdu_size,
 		}
 	}
 	atm_return(vcc, guess);
-	atomic_inc(&vcc->stats->rx_drop);
+	atomic_inc_unchecked(&vcc->stats->rx_drop);
 	return NULL;
 }
 EXPORT_SYMBOL(atm_alloc_charge);
@@ -86,7 +86,7 @@ EXPORT_SYMBOL(atm_pcr_goal);
 
 void sonet_copy_stats(struct k_sonet_stats *from, struct sonet_stats *to)
 {
-#define __HANDLE_ITEM(i) to->i = atomic_read(&from->i)
+#define __HANDLE_ITEM(i) to->i = atomic_read_unchecked(&from->i)
 	__SONET_ITEMS
 #undef __HANDLE_ITEM
 }
@@ -94,7 +94,7 @@ EXPORT_SYMBOL(sonet_copy_stats);
 
 void sonet_subtract_stats(struct k_sonet_stats *from, struct sonet_stats *to)
 {
-#define __HANDLE_ITEM(i) atomic_sub(to->i, &from->i)
+#define __HANDLE_ITEM(i) atomic_sub_unchecked(to->i,&from->i)
 	__SONET_ITEMS
 #undef __HANDLE_ITEM
 }
diff --git a/net/atm/lec.c b/net/atm/lec.c
index e574a7e9d..2f5a14d1b 100644
--- a/net/atm/lec.c
+++ b/net/atm/lec.c
@@ -111,9 +111,9 @@ static inline void lec_arp_put(struct lec_arp_table *entry)
 }
 
 static struct lane2_ops lane2_ops = {
-	lane2_resolve,		/* resolve,             spec 3.1.3 */
-	lane2_associate_req,	/* associate_req,       spec 3.1.4 */
-	NULL			/* associate indicator, spec 3.1.5 */
+	.resolve = lane2_resolve,
+	.associate_req = lane2_associate_req,
+	.associate_indicator = NULL
 };
 
 static unsigned char bus_mac[ETH_ALEN] = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
diff --git a/net/atm/lec.h b/net/atm/lec.h
index 4149db1b7..f2ab682cf 100644
--- a/net/atm/lec.h
+++ b/net/atm/lec.h
@@ -48,7 +48,7 @@ struct lane2_ops {
 			      const u8 *tlvs, u32 sizeoftlvs);
 	void (*associate_indicator) (struct net_device *dev, const u8 *mac_addr,
 				     const u8 *tlvs, u32 sizeoftlvs);
-};
+} __no_const;
 
 /*
  * ATM LAN Emulation supports both LLC & Dix Ethernet EtherType
diff --git a/net/atm/mpoa_caches.c b/net/atm/mpoa_caches.c
index 9e60e74c8..a89fdebef 100644
--- a/net/atm/mpoa_caches.c
+++ b/net/atm/mpoa_caches.c
@@ -535,33 +535,32 @@ static void eg_destroy_cache(struct mpoa_client *mpc)
 
 
 static const struct in_cache_ops ingress_ops = {
-	in_cache_add_entry,               /* add_entry       */
-	in_cache_get,                     /* get             */
-	in_cache_get_with_mask,           /* get_with_mask   */
-	in_cache_get_by_vcc,              /* get_by_vcc      */
-	in_cache_put,                     /* put             */
-	in_cache_remove_entry,            /* remove_entry    */
-	cache_hit,                        /* cache_hit       */
-	clear_count_and_expired,          /* clear_count     */
-	check_resolving_entries,          /* check_resolving */
-	refresh_entries,                  /* refresh         */
-	in_destroy_cache                  /* destroy_cache   */
+	.add_entry = in_cache_add_entry,
+	.get = in_cache_get,
+	.get_with_mask = in_cache_get_with_mask,
+	.get_by_vcc = in_cache_get_by_vcc,
+	.put = in_cache_put,
+	.remove_entry = in_cache_remove_entry,
+	.cache_hit = cache_hit,
+	.clear_count = clear_count_and_expired,
+	.check_resolving = check_resolving_entries,
+	.refresh = refresh_entries,
+	.destroy_cache = in_destroy_cache
 };
 
 static const struct eg_cache_ops egress_ops = {
-	eg_cache_add_entry,               /* add_entry        */
-	eg_cache_get_by_cache_id,         /* get_by_cache_id  */
-	eg_cache_get_by_tag,              /* get_by_tag       */
-	eg_cache_get_by_vcc,              /* get_by_vcc       */
-	eg_cache_get_by_src_ip,           /* get_by_src_ip    */
-	eg_cache_put,                     /* put              */
-	eg_cache_remove_entry,            /* remove_entry     */
-	update_eg_cache_entry,            /* update           */
-	clear_expired,                    /* clear_expired    */
-	eg_destroy_cache                  /* destroy_cache    */
+	.add_entry = eg_cache_add_entry,
+	.get_by_cache_id = eg_cache_get_by_cache_id,
+	.get_by_tag = eg_cache_get_by_tag,
+	.get_by_vcc = eg_cache_get_by_vcc,
+	.get_by_src_ip = eg_cache_get_by_src_ip,
+	.put = eg_cache_put,
+	.remove_entry = eg_cache_remove_entry,
+	.update = update_eg_cache_entry,
+	.clear_expired = clear_expired,
+	.destroy_cache = eg_destroy_cache
 };
 
-
 void atm_mpoa_init_cache(struct mpoa_client *mpc)
 {
 	mpc->in_ops = &ingress_ops;
diff --git a/net/atm/proc.c b/net/atm/proc.c
index bbb6461a4..cf040169e 100644
--- a/net/atm/proc.c
+++ b/net/atm/proc.c
@@ -45,9 +45,9 @@ static void add_stats(struct seq_file *seq, const char *aal,
   const struct k_atm_aal_stats *stats)
 {
 	seq_printf(seq, "%s ( %d %d %d %d %d )", aal,
-		   atomic_read(&stats->tx), atomic_read(&stats->tx_err),
-		   atomic_read(&stats->rx), atomic_read(&stats->rx_err),
-		   atomic_read(&stats->rx_drop));
+		   atomic_read_unchecked(&stats->tx),atomic_read_unchecked(&stats->tx_err),
+		   atomic_read_unchecked(&stats->rx),atomic_read_unchecked(&stats->rx_err),
+		   atomic_read_unchecked(&stats->rx_drop));
 }
 
 static void atm_dev_info(struct seq_file *seq, const struct atm_dev *dev)
diff --git a/net/atm/resources.c b/net/atm/resources.c
index 0447d5d0b..3cf472855 100644
--- a/net/atm/resources.c
+++ b/net/atm/resources.c
@@ -160,7 +160,7 @@ EXPORT_SYMBOL(atm_dev_deregister);
 static void copy_aal_stats(struct k_atm_aal_stats *from,
     struct atm_aal_stats *to)
 {
-#define __HANDLE_ITEM(i) to->i = atomic_read(&from->i)
+#define __HANDLE_ITEM(i) to->i = atomic_read_unchecked(&from->i)
 	__AAL_STAT_ITEMS
 #undef __HANDLE_ITEM
 }
@@ -168,7 +168,7 @@ static void copy_aal_stats(struct k_atm_aal_stats *from,
 static void subtract_aal_stats(struct k_atm_aal_stats *from,
     struct atm_aal_stats *to)
 {
-#define __HANDLE_ITEM(i) atomic_sub(to->i, &from->i)
+#define __HANDLE_ITEM(i) atomic_sub_unchecked(to->i, &from->i)
 	__AAL_STAT_ITEMS
 #undef __HANDLE_ITEM
 }
diff --git a/net/ax25/sysctl_net_ax25.c b/net/ax25/sysctl_net_ax25.c
index 919a5ce47..cc6b444b3 100644
--- a/net/ax25/sysctl_net_ax25.c
+++ b/net/ax25/sysctl_net_ax25.c
@@ -152,7 +152,7 @@ int ax25_register_dev_sysctl(ax25_dev *ax25_dev)
 {
 	char path[sizeof("net/ax25/") + IFNAMSIZ];
 	int k;
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(ax25_param_table, sizeof(ax25_param_table), GFP_KERNEL);
 	if (!table)
diff --git a/net/batman-adv/bat_iv_ogm.c b/net/batman-adv/bat_iv_ogm.c
index 19b0abd6c..9a487eeb0 100644
--- a/net/batman-adv/bat_iv_ogm.c
+++ b/net/batman-adv/bat_iv_ogm.c
@@ -361,7 +361,7 @@ static int batadv_iv_ogm_iface_enable(struct batadv_hard_iface *hard_iface)
 
 	/* randomize initial seqno to avoid collision */
 	get_random_bytes(&random_seqno, sizeof(random_seqno));
-	atomic_set(&hard_iface->bat_iv.ogm_seqno, random_seqno);
+	atomic_set_unchecked(&hard_iface->bat_iv.ogm_seqno, random_seqno);
 
 	hard_iface->bat_iv.ogm_buff_len = BATADV_OGM_HLEN;
 	ogm_buff = kmalloc(hard_iface->bat_iv.ogm_buff_len, GFP_ATOMIC);
@@ -973,9 +973,9 @@ static void batadv_iv_ogm_schedule(struct batadv_hard_iface *hard_iface)
 	batadv_ogm_packet->tvlv_len = htons(tvlv_len);
 
 	/* change sequence number to network order */
-	seqno = (u32)atomic_read(&hard_iface->bat_iv.ogm_seqno);
+	seqno = (u32)atomic_read_unchecked(&hard_iface->bat_iv.ogm_seqno);
 	batadv_ogm_packet->seqno = htonl(seqno);
-	atomic_inc(&hard_iface->bat_iv.ogm_seqno);
+	atomic_inc_unchecked(&hard_iface->bat_iv.ogm_seqno);
 
 	batadv_iv_ogm_slide_own_bcast_window(hard_iface);
 
@@ -1673,7 +1673,7 @@ static void batadv_iv_ogm_process(const struct sk_buff *skb, int ogm_offset,
 		return;
 
 	/* could be changed by schedule_own_packet() */
-	if_incoming_seqno = atomic_read(&if_incoming->bat_iv.ogm_seqno);
+	if_incoming_seqno = atomic_read_unchecked(&if_incoming->bat_iv.ogm_seqno);
 
 	if (ogm_packet->flags & BATADV_DIRECTLINK)
 		has_directlink_flag = true;
diff --git a/net/batman-adv/fragmentation.c b/net/batman-adv/fragmentation.c
index 0934730fb..a8189fc19 100644
--- a/net/batman-adv/fragmentation.c
+++ b/net/batman-adv/fragmentation.c
@@ -469,7 +469,7 @@ int batadv_frag_send_packet(struct sk_buff *skb,
 	frag_header.packet_type = BATADV_UNICAST_FRAG;
 	frag_header.version = BATADV_COMPAT_VERSION;
 	frag_header.ttl = BATADV_TTL;
-	frag_header.seqno = htons(atomic_inc_return(&bat_priv->frag_seqno));
+	frag_header.seqno = htons(atomic_inc_return_unchecked(&bat_priv->frag_seqno));
 	frag_header.reserved = 0;
 	frag_header.no = 0;
 	frag_header.total_size = htons(skb->len);
diff --git a/net/batman-adv/routing.c b/net/batman-adv/routing.c
index 3d199478c..5c6163861 100644
--- a/net/batman-adv/routing.c
+++ b/net/batman-adv/routing.c
@@ -758,7 +758,7 @@ batadv_reroute_unicast_packet(struct batadv_priv *bat_priv,
 		if (!primary_if)
 			goto out;
 		orig_addr = primary_if->net_dev->dev_addr;
-		orig_ttvn = (u8)atomic_read(&bat_priv->tt.vn);
+		orig_ttvn = (u8)atomic_read_unchecked(&bat_priv->tt.vn);
 	} else {
 		orig_node = batadv_transtable_search(bat_priv, NULL, dst_addr,
 						     vid);
@@ -834,7 +834,7 @@ static bool batadv_check_unicast_ttvn(struct batadv_priv *bat_priv,
 	 * value is used later to check if the node which sent (or re-routed
 	 * last time) the packet had an updated information or not
 	 */
-	curr_ttvn = (u8)atomic_read(&bat_priv->tt.vn);
+	curr_ttvn = (u8)atomic_read_unchecked(&bat_priv->tt.vn);
 	if (!batadv_is_my_mac(bat_priv, unicast_packet->dest)) {
 		orig_node = batadv_orig_hash_find(bat_priv,
 						  unicast_packet->dest);
diff --git a/net/batman-adv/soft-interface.c b/net/batman-adv/soft-interface.c
index 7527c0652..42024c600 100644
--- a/net/batman-adv/soft-interface.c
+++ b/net/batman-adv/soft-interface.c
@@ -180,7 +180,7 @@ static void batadv_interface_set_rx_mode(struct net_device *dev)
 {
 }
 
-static int batadv_interface_tx(struct sk_buff *skb,
+static netdev_tx_t batadv_interface_tx(struct sk_buff *skb,
 			       struct net_device *soft_iface)
 {
 	struct ethhdr *ethhdr;
@@ -332,7 +332,7 @@ send:
 				primary_if->net_dev->dev_addr);
 
 		/* set broadcast sequence number */
-		seqno = atomic_inc_return(&bat_priv->bcast_seqno);
+		seqno = atomic_inc_return_unchecked(&bat_priv->bcast_seqno);
 		bcast_packet->seqno = htonl(seqno);
 
 		batadv_add_bcast_packet_to_list(bat_priv, skb, brd_delay);
@@ -835,8 +835,8 @@ static int batadv_softif_init_late(struct net_device *dev)
 	atomic_set(&bat_priv->batman_queue_left, BATADV_BATMAN_QUEUE_LEN);
 
 	atomic_set(&bat_priv->mesh_state, BATADV_MESH_INACTIVE);
-	atomic_set(&bat_priv->bcast_seqno, 1);
-	atomic_set(&bat_priv->tt.vn, 0);
+	atomic_set_unchecked(&bat_priv->bcast_seqno, 1);
+	atomic_set_unchecked(&bat_priv->tt.vn, 0);
 	atomic_set(&bat_priv->tt.local_changes, 0);
 	atomic_set(&bat_priv->tt.ogm_append_cnt, 0);
 #ifdef CONFIG_BATMAN_ADV_BLA
@@ -851,7 +851,7 @@ static int batadv_softif_init_late(struct net_device *dev)
 
 	/* randomize initial seqno to avoid collision */
 	get_random_bytes(&random_seqno, sizeof(random_seqno));
-	atomic_set(&bat_priv->frag_seqno, random_seqno);
+	atomic_set_unchecked(&bat_priv->frag_seqno, random_seqno);
 
 	bat_priv->primary_if = NULL;
 	bat_priv->num_ifaces = 0;
@@ -1069,7 +1069,7 @@ bool batadv_softif_is_valid(const struct net_device *net_dev)
 	return false;
 }
 
-struct rtnl_link_ops batadv_link_ops __read_mostly = {
+struct rtnl_link_ops batadv_link_ops = {
 	.kind		= "batadv",
 	.priv_size	= sizeof(struct batadv_priv),
 	.setup		= batadv_softif_init_early,
diff --git a/net/batman-adv/sysfs.c b/net/batman-adv/sysfs.c
index fe9ca94dd..ae07bdc4b 100644
--- a/net/batman-adv/sysfs.c
+++ b/net/batman-adv/sysfs.c
@@ -146,7 +146,7 @@ struct batadv_attribute batadv_attr_##_name = {		\
 
 #define BATADV_ATTR_SIF_STORE_BOOL(_name, _post_func)			\
 ssize_t batadv_store_##_name(struct kobject *kobj,			\
-			     struct attribute *attr, char *buff,	\
+			     struct kobj_attribute *attr, char *buff,	\
 			     size_t count)				\
 {									\
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);	\
@@ -158,7 +158,7 @@ ssize_t batadv_store_##_name(struct kobject *kobj,			\
 
 #define BATADV_ATTR_SIF_SHOW_BOOL(_name)				\
 ssize_t batadv_show_##_name(struct kobject *kobj,			\
-			    struct attribute *attr, char *buff)		\
+			    struct kobj_attribute *attr, char *buff)	\
 {									\
 	struct batadv_priv *bat_priv = batadv_kobj_to_batpriv(kobj);	\
 									\
@@ -178,7 +178,7 @@ ssize_t batadv_show_##_name(struct kobject *kobj,			\
 
 #define BATADV_ATTR_SIF_STORE_UINT(_name, _var, _min, _max, _post_func)	\
 ssize_t batadv_store_##_name(struct kobject *kobj,			\
-			     struct attribute *attr, char *buff,	\
+			     struct kobj_attribute *attr, char *buff,	\
 			     size_t count)				\
 {									\
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);	\
@@ -191,7 +191,7 @@ ssize_t batadv_store_##_name(struct kobject *kobj,			\
 
 #define BATADV_ATTR_SIF_SHOW_UINT(_name, _var)				\
 ssize_t batadv_show_##_name(struct kobject *kobj,			\
-			    struct attribute *attr, char *buff)		\
+			    struct kobj_attribute *attr, char *buff)	\
 {									\
 	struct batadv_priv *bat_priv = batadv_kobj_to_batpriv(kobj);	\
 									\
@@ -209,7 +209,7 @@ ssize_t batadv_show_##_name(struct kobject *kobj,			\
 
 #define BATADV_ATTR_VLAN_STORE_BOOL(_name, _post_func)			\
 ssize_t batadv_store_vlan_##_name(struct kobject *kobj,			\
-				  struct attribute *attr, char *buff,	\
+				  struct kobj_attribute *attr, char *buff,\
 				  size_t count)				\
 {									\
 	struct batadv_priv *bat_priv = batadv_vlan_kobj_to_batpriv(kobj);\
@@ -225,7 +225,7 @@ ssize_t batadv_store_vlan_##_name(struct kobject *kobj,			\
 
 #define BATADV_ATTR_VLAN_SHOW_BOOL(_name)				\
 ssize_t batadv_show_vlan_##_name(struct kobject *kobj,			\
-				 struct attribute *attr, char *buff)	\
+				 struct kobj_attribute *attr, char *buff)\
 {									\
 	struct batadv_priv *bat_priv = batadv_vlan_kobj_to_batpriv(kobj);\
 	struct batadv_softif_vlan *vlan = batadv_kobj_to_vlan(bat_priv,	\
@@ -247,7 +247,7 @@ ssize_t batadv_show_vlan_##_name(struct kobject *kobj,			\
 
 #define BATADV_ATTR_HIF_STORE_UINT(_name, _var, _min, _max, _post_func)	\
 ssize_t batadv_store_##_name(struct kobject *kobj,			\
-			     struct attribute *attr, char *buff,	\
+			     struct kobj_attribute *attr, char *buff,	\
 			     size_t count)				\
 {									\
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);	\
@@ -268,7 +268,7 @@ ssize_t batadv_store_##_name(struct kobject *kobj,			\
 
 #define BATADV_ATTR_HIF_SHOW_UINT(_name, _var)				\
 ssize_t batadv_show_##_name(struct kobject *kobj,			\
-			    struct attribute *attr, char *buff)		\
+			    struct kobj_attribute *attr, char *buff)		\
 {									\
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);	\
 	struct batadv_hard_iface *hard_iface;				\
@@ -338,13 +338,13 @@ static int batadv_store_bool_attr(char *buff, size_t count,
 static inline ssize_t
 __batadv_store_bool_attr(char *buff, size_t count,
 			 void (*post_func)(struct net_device *),
-			 struct attribute *attr,
+			 struct kobj_attribute *attr,
 			 atomic_t *attr_store, struct net_device *net_dev)
 {
 	bool changed;
 	int ret;
 
-	ret = batadv_store_bool_attr(buff, count, net_dev, attr->name,
+	ret = batadv_store_bool_attr(buff, count, net_dev, attr->attr.name,
 				     attr_store, &changed);
 	if (post_func && changed)
 		post_func(net_dev);
@@ -393,13 +393,13 @@ static int batadv_store_uint_attr(const char *buff, size_t count,
 static ssize_t __batadv_store_uint_attr(const char *buff, size_t count,
 					int min, int max,
 					void (*post_func)(struct net_device *),
-					const struct attribute *attr,
+					const struct kobj_attribute *attr,
 					atomic_t *attr_store,
 					struct net_device *net_dev)
 {
 	int ret;
 
-	ret = batadv_store_uint_attr(buff, count, net_dev, attr->name, min, max,
+	ret = batadv_store_uint_attr(buff, count, net_dev, attr->attr.name, min, max,
 				     attr_store);
 	if (post_func && ret)
 		post_func(net_dev);
@@ -408,7 +408,7 @@ static ssize_t __batadv_store_uint_attr(const char *buff, size_t count,
 }
 
 static ssize_t batadv_show_bat_algo(struct kobject *kobj,
-				    struct attribute *attr, char *buff)
+				    struct kobj_attribute *attr, char *buff)
 {
 	struct batadv_priv *bat_priv = batadv_kobj_to_batpriv(kobj);
 
@@ -422,7 +422,7 @@ static void batadv_post_gw_reselect(struct net_device *net_dev)
 	batadv_gw_reselect(bat_priv);
 }
 
-static ssize_t batadv_show_gw_mode(struct kobject *kobj, struct attribute *attr,
+static ssize_t batadv_show_gw_mode(struct kobject *kobj, struct kobj_attribute *attr,
 				   char *buff)
 {
 	struct batadv_priv *bat_priv = batadv_kobj_to_batpriv(kobj);
@@ -447,7 +447,7 @@ static ssize_t batadv_show_gw_mode(struct kobject *kobj, struct attribute *attr,
 }
 
 static ssize_t batadv_store_gw_mode(struct kobject *kobj,
-				    struct attribute *attr, char *buff,
+				    struct kobj_attribute *attr, char *buff,
 				    size_t count)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
@@ -515,7 +515,7 @@ static ssize_t batadv_store_gw_mode(struct kobject *kobj,
 }
 
 static ssize_t batadv_show_gw_bwidth(struct kobject *kobj,
-				     struct attribute *attr, char *buff)
+				     struct kobj_attribute *attr, char *buff)
 {
 	struct batadv_priv *bat_priv = batadv_kobj_to_batpriv(kobj);
 	u32 down, up;
@@ -528,7 +528,7 @@ static ssize_t batadv_show_gw_bwidth(struct kobject *kobj,
 }
 
 static ssize_t batadv_store_gw_bwidth(struct kobject *kobj,
-				      struct attribute *attr, char *buff,
+				      struct kobj_attribute *attr, char *buff,
 				      size_t count)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
@@ -549,7 +549,7 @@ static ssize_t batadv_store_gw_bwidth(struct kobject *kobj,
  * error code in case of failure
  */
 static ssize_t batadv_show_isolation_mark(struct kobject *kobj,
-					  struct attribute *attr, char *buff)
+					  struct kobj_attribute *attr, char *buff)
 {
 	struct batadv_priv *bat_priv = batadv_kobj_to_batpriv(kobj);
 
@@ -568,7 +568,7 @@ static ssize_t batadv_show_isolation_mark(struct kobject *kobj,
  * Return: 'count' on success or a negative error code in case of failure
  */
 static ssize_t batadv_store_isolation_mark(struct kobject *kobj,
-					   struct attribute *attr, char *buff,
+					   struct kobj_attribute *attr, char *buff,
 					   size_t count)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
@@ -805,7 +805,7 @@ void batadv_sysfs_del_vlan(struct batadv_priv *bat_priv,
 }
 
 static ssize_t batadv_show_mesh_iface(struct kobject *kobj,
-				      struct attribute *attr, char *buff)
+				      struct kobj_attribute *attr, char *buff)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
 	struct batadv_hard_iface *hard_iface;
@@ -829,7 +829,7 @@ static ssize_t batadv_show_mesh_iface(struct kobject *kobj,
 }
 
 static ssize_t batadv_store_mesh_iface(struct kobject *kobj,
-				       struct attribute *attr, char *buff,
+				       struct kobj_attribute *attr, char *buff,
 				       size_t count)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
@@ -887,7 +887,7 @@ out:
 }
 
 static ssize_t batadv_show_iface_status(struct kobject *kobj,
-					struct attribute *attr, char *buff)
+					struct kobj_attribute *attr, char *buff)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
 	struct batadv_hard_iface *hard_iface;
@@ -934,7 +934,7 @@ static ssize_t batadv_show_iface_status(struct kobject *kobj,
  * Return: 'count' on success or a negative error code in case of failure
  */
 static ssize_t batadv_store_throughput_override(struct kobject *kobj,
-						struct attribute *attr,
+						struct kobj_attribute *attr,
 						char *buff, size_t count)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
@@ -972,7 +972,7 @@ out:
 }
 
 static ssize_t batadv_show_throughput_override(struct kobject *kobj,
-					       struct attribute *attr,
+					       struct kobj_attribute *attr,
 					       char *buff)
 {
 	struct net_device *net_dev = batadv_kobj_to_netdev(kobj);
diff --git a/net/batman-adv/sysfs.h b/net/batman-adv/sysfs.h
index c76021b4e..3aef37786 100644
--- a/net/batman-adv/sysfs.h
+++ b/net/batman-adv/sysfs.h
@@ -37,9 +37,9 @@ struct net_device;
 
 struct batadv_attribute {
 	struct attribute attr;
-	ssize_t (*show)(struct kobject *kobj, struct attribute *attr,
+	ssize_t (*show)(struct kobject *kobj, struct kobj_attribute *attr,
 			char *buf);
-	ssize_t (*store)(struct kobject *kobj, struct attribute *attr,
+	ssize_t (*store)(struct kobject *kobj, struct kobj_attribute *attr,
 			 char *buf, size_t count);
 };
 
diff --git a/net/batman-adv/translation-table.c b/net/batman-adv/translation-table.c
index 67f8fa9fc..4b611ebb1 100644
--- a/net/batman-adv/translation-table.c
+++ b/net/batman-adv/translation-table.c
@@ -664,7 +664,7 @@ bool batadv_tt_local_add(struct net_device *soft_iface, const u8 *addr,
 	batadv_dbg(BATADV_DBG_TT, bat_priv,
 		   "Creating new local tt entry: %pM (vid: %d, ttvn: %d)\n",
 		   addr, BATADV_PRINT_VID(vid),
-		   (u8)atomic_read(&bat_priv->tt.vn));
+		   (u8)atomic_read_unchecked(&bat_priv->tt.vn));
 
 	ether_addr_copy(tt_local->common.addr, addr);
 	/* The local entry has to be marked as NEW to avoid to send it in
@@ -894,7 +894,7 @@ batadv_tt_prepare_tvlv_local_data(struct batadv_priv *bat_priv,
 	}
 
 	(*tt_data)->flags = BATADV_NO_FLAGS;
-	(*tt_data)->ttvn = atomic_read(&bat_priv->tt.vn);
+	(*tt_data)->ttvn = atomic_read_unchecked(&bat_priv->tt.vn);
 	(*tt_data)->num_vlan = htons(num_vlan);
 
 	tt_vlan = (struct batadv_tvlv_tt_vlan_data *)(*tt_data + 1);
@@ -1011,7 +1011,7 @@ int batadv_tt_local_seq_print_text(struct seq_file *seq, void *offset)
 
 	seq_printf(seq,
 		   "Locally retrieved addresses (from %s) announced via TT (TTVN: %u):\n",
-		   net_dev->name, (u8)atomic_read(&bat_priv->tt.vn));
+		   net_dev->name, (u8)atomic_read_unchecked(&bat_priv->tt.vn));
 	seq_puts(seq,
 		 "       Client         VID Flags    Last seen (CRC       )\n");
 
@@ -2818,7 +2818,7 @@ static bool batadv_send_my_tt_response(struct batadv_priv *bat_priv,
 
 	spin_lock_bh(&bat_priv->tt.commit_lock);
 
-	my_ttvn = (u8)atomic_read(&bat_priv->tt.vn);
+	my_ttvn = (u8)atomic_read_unchecked(&bat_priv->tt.vn);
 	req_ttvn = tt_data->ttvn;
 
 	orig_node = batadv_orig_hash_find(bat_priv, req_src);
@@ -2857,7 +2857,7 @@ static bool batadv_send_my_tt_response(struct batadv_priv *bat_priv,
 		       bat_priv->tt.last_changeset_len);
 		spin_unlock_bh(&bat_priv->tt.last_changeset_lock);
 	} else {
-		req_ttvn = (u8)atomic_read(&bat_priv->tt.vn);
+		req_ttvn = (u8)atomic_read_unchecked(&bat_priv->tt.vn);
 
 		/* allocate the tvlv, put the tt_data and all the tt_vlan_data
 		 * in the initial part
@@ -3376,10 +3376,10 @@ static void batadv_tt_local_commit_changes_nolock(struct batadv_priv *bat_priv)
 	batadv_tt_local_update_crc(bat_priv);
 
 	/* Increment the TTVN only once per OGM interval */
-	atomic_inc(&bat_priv->tt.vn);
+	atomic_inc_unchecked(&bat_priv->tt.vn);
 	batadv_dbg(BATADV_DBG_TT, bat_priv,
 		   "Local changes committed, updating to ttvn %u\n",
-		   (u8)atomic_read(&bat_priv->tt.vn));
+		   (u8)atomic_read_unchecked(&bat_priv->tt.vn));
 
 	/* reset the sending counter */
 	atomic_set(&bat_priv->tt.ogm_append_cnt, BATADV_TT_OGM_APPEND_MAX);
diff --git a/net/batman-adv/types.h b/net/batman-adv/types.h
index a64522c3b..168782df4 100644
--- a/net/batman-adv/types.h
+++ b/net/batman-adv/types.h
@@ -84,7 +84,7 @@ enum batadv_dhcp_recipient {
 struct batadv_hard_iface_bat_iv {
 	unsigned char *ogm_buff;
 	int ogm_buff_len;
-	atomic_t ogm_seqno;
+	atomic_unchecked_t ogm_seqno;
 };
 
 /**
@@ -633,7 +633,7 @@ enum batadv_counters {
  * @work: work queue callback item for translation table purging
  */
 struct batadv_priv_tt {
-	atomic_t vn;
+	atomic_unchecked_t vn;
 	atomic_t ogm_append_cnt;
 	atomic_t local_changes;
 	struct list_head changes_list;
@@ -1042,7 +1042,7 @@ struct batadv_priv {
 	atomic_t bonding;
 	atomic_t fragmentation;
 	atomic_t packet_size_max;
-	atomic_t frag_seqno;
+	atomic_unchecked_t frag_seqno;
 #ifdef CONFIG_BATMAN_ADV_BLA
 	atomic_t bridge_loop_avoidance;
 #endif
@@ -1059,7 +1059,7 @@ struct batadv_priv {
 #endif
 	u32 isolation_mark;
 	u32 isolation_mark_mask;
-	atomic_t bcast_seqno;
+	atomic_unchecked_t bcast_seqno;
 	atomic_t bcast_queue_left;
 	atomic_t batman_queue_left;
 	char num_ifaces;
diff --git a/net/bluetooth/hci_sock.c b/net/bluetooth/hci_sock.c
index 96f04b7b9..753db63ef 100644
--- a/net/bluetooth/hci_sock.c
+++ b/net/bluetooth/hci_sock.c
@@ -1482,7 +1482,7 @@ static int hci_sock_setsockopt(struct socket *sock, int level, int optname,
 			uf.event_mask[1] = *((u32 *) f->event_mask + 1);
 		}
 
-		len = min_t(unsigned int, len, sizeof(uf));
+		len = min((size_t)len, sizeof(uf));
 		if (copy_from_user(&uf, optval, len)) {
 			err = -EFAULT;
 			break;
diff --git a/net/bluetooth/l2cap_core.c b/net/bluetooth/l2cap_core.c
index d4cad29b0..25c71a91c 100644
--- a/net/bluetooth/l2cap_core.c
+++ b/net/bluetooth/l2cap_core.c
@@ -3548,8 +3548,10 @@ static int l2cap_parse_conf_rsp(struct l2cap_chan *chan, void *rsp, int len,
 			break;
 
 		case L2CAP_CONF_RFC:
-			if (olen == sizeof(rfc))
-				memcpy(&rfc, (void *)val, olen);
+			if (olen != sizeof(rfc))
+				break;
+
+			memcpy(&rfc, (void *)val, olen);
 
 			if (test_bit(CONF_STATE2_DEVICE, &chan->conf_state) &&
 			    rfc.mode != chan->mode)
diff --git a/net/bluetooth/l2cap_sock.c b/net/bluetooth/l2cap_sock.c
index a8ba75273..de24ce02d 100644
--- a/net/bluetooth/l2cap_sock.c
+++ b/net/bluetooth/l2cap_sock.c
@@ -633,7 +633,8 @@ static int l2cap_sock_setsockopt_old(struct socket *sock, int optname,
 	struct sock *sk = sock->sk;
 	struct l2cap_chan *chan = l2cap_pi(sk)->chan;
 	struct l2cap_options opts;
-	int len, err = 0;
+	int err = 0;
+	size_t len = optlen;
 	u32 opt;
 
 	BT_DBG("sk %p", sk);
@@ -660,7 +661,7 @@ static int l2cap_sock_setsockopt_old(struct socket *sock, int optname,
 		opts.max_tx   = chan->max_tx;
 		opts.txwin_size = chan->tx_win;
 
-		len = min_t(unsigned int, sizeof(opts), optlen);
+		len = min(sizeof(opts), len);
 		if (copy_from_user((char *) &opts, optval, len)) {
 			err = -EFAULT;
 			break;
@@ -747,7 +748,8 @@ static int l2cap_sock_setsockopt(struct socket *sock, int level, int optname,
 	struct bt_security sec;
 	struct bt_power pwr;
 	struct l2cap_conn *conn;
-	int len, err = 0;
+	int err = 0;
+	size_t len = optlen;
 	u32 opt;
 
 	BT_DBG("sk %p", sk);
@@ -771,7 +773,7 @@ static int l2cap_sock_setsockopt(struct socket *sock, int level, int optname,
 
 		sec.level = BT_SECURITY_LOW;
 
-		len = min_t(unsigned int, sizeof(sec), optlen);
+		len = min(sizeof(sec), len);
 		if (copy_from_user((char *) &sec, optval, len)) {
 			err = -EFAULT;
 			break;
@@ -867,7 +869,7 @@ static int l2cap_sock_setsockopt(struct socket *sock, int level, int optname,
 
 		pwr.force_active = BT_POWER_FORCE_ACTIVE_ON;
 
-		len = min_t(unsigned int, sizeof(pwr), optlen);
+		len = min(sizeof(pwr), len);
 		if (copy_from_user((char *) &pwr, optval, len)) {
 			err = -EFAULT;
 			break;
diff --git a/net/bluetooth/rfcomm/sock.c b/net/bluetooth/rfcomm/sock.c
index 7511df723..a670df399 100644
--- a/net/bluetooth/rfcomm/sock.c
+++ b/net/bluetooth/rfcomm/sock.c
@@ -690,7 +690,7 @@ static int rfcomm_sock_setsockopt(struct socket *sock, int level, int optname, c
 	struct sock *sk = sock->sk;
 	struct bt_security sec;
 	int err = 0;
-	size_t len;
+	size_t len = optlen;
 	u32 opt;
 
 	BT_DBG("sk %p", sk);
@@ -712,7 +712,7 @@ static int rfcomm_sock_setsockopt(struct socket *sock, int level, int optname, c
 
 		sec.level = BT_SECURITY_LOW;
 
-		len = min_t(unsigned int, sizeof(sec), optlen);
+		len = min(sizeof(sec), len);
 		if (copy_from_user((char *) &sec, optval, len)) {
 			err = -EFAULT;
 			break;
diff --git a/net/bluetooth/rfcomm/tty.c b/net/bluetooth/rfcomm/tty.c
index 8e385a0ae..a5bdd8ef1 100644
--- a/net/bluetooth/rfcomm/tty.c
+++ b/net/bluetooth/rfcomm/tty.c
@@ -752,7 +752,7 @@ static int rfcomm_tty_open(struct tty_struct *tty, struct file *filp)
 	BT_DBG("tty %p id %d", tty, tty->index);
 
 	BT_DBG("dev %p dst %pMR channel %d opened %d", dev, &dev->dst,
-	       dev->channel, dev->port.count);
+	       dev->channel, atomic_read(&dev->port.count));
 
 	err = tty_port_open(&dev->port, tty, filp);
 	if (err)
@@ -775,7 +775,7 @@ static void rfcomm_tty_close(struct tty_struct *tty, struct file *filp)
 	struct rfcomm_dev *dev = (struct rfcomm_dev *) tty->driver_data;
 
 	BT_DBG("tty %p dev %p dlc %p opened %d", tty, dev, dev->dlc,
-						dev->port.count);
+						atomic_read(&dev->port.count));
 
 	tty_port_close(&dev->port, tty, filp);
 }
diff --git a/net/bridge/br_netfilter_hooks.c b/net/bridge/br_netfilter_hooks.c
index 77e7f69bf..6572d4373 100644
--- a/net/bridge/br_netfilter_hooks.c
+++ b/net/bridge/br_netfilter_hooks.c
@@ -982,13 +982,13 @@ static void __net_exit brnf_exit_net(struct net *net)
 	brnet->enabled = false;
 }
 
-static struct pernet_operations brnf_net_ops __read_mostly = {
+static struct pernet_operations brnf_net_ops = {
 	.exit = brnf_exit_net,
 	.id   = &brnf_net_id,
 	.size = sizeof(struct brnf_net),
 };
 
-static struct notifier_block brnf_notifier __read_mostly = {
+static struct notifier_block brnf_notifier = {
 	.notifier_call = brnf_device_event,
 };
 
diff --git a/net/bridge/br_netlink.c b/net/bridge/br_netlink.c
index f2a29e467..34963c3fe 100644
--- a/net/bridge/br_netlink.c
+++ b/net/bridge/br_netlink.c
@@ -1395,7 +1395,7 @@ static struct rtnl_af_ops br_af_ops __read_mostly = {
 	.get_link_af_size	= br_get_link_af_size_filtered,
 };
 
-struct rtnl_link_ops br_link_ops __read_mostly = {
+struct rtnl_link_ops br_link_ops = {
 	.kind			= "bridge",
 	.priv_size		= sizeof(struct net_bridge),
 	.setup			= br_dev_setup,
diff --git a/net/bridge/netfilter/ebtables.c b/net/bridge/netfilter/ebtables.c
index 0833c251a..c649cbf37 100644
--- a/net/bridge/netfilter/ebtables.c
+++ b/net/bridge/netfilter/ebtables.c
@@ -1547,7 +1547,7 @@ static int do_ebt_get_ctl(struct sock *sk, int cmd, void __user *user, int *len)
 			tmp.valid_hooks = t->table->valid_hooks;
 		}
 		mutex_unlock(&ebt_mutex);
-		if (copy_to_user(user, &tmp, *len) != 0) {
+		if (*len > sizeof(tmp) || copy_to_user(user, &tmp, *len) != 0) {
 			BUGPRINT("c2u Didn't work\n");
 			ret = -EFAULT;
 			break;
@@ -2351,7 +2351,7 @@ static int compat_do_ebt_get_ctl(struct sock *sk, int cmd,
 			goto out;
 		tmp.valid_hooks = t->valid_hooks;
 
-		if (copy_to_user(user, &tmp, *len) != 0) {
+		if (*len > sizeof(tmp) || copy_to_user(user, &tmp, *len) != 0) {
 			ret = -EFAULT;
 			break;
 		}
@@ -2362,7 +2362,7 @@ static int compat_do_ebt_get_ctl(struct sock *sk, int cmd,
 		tmp.entries_size = t->table->entries_size;
 		tmp.valid_hooks = t->table->valid_hooks;
 
-		if (copy_to_user(user, &tmp, *len) != 0) {
+		if (*len > sizeof(tmp) || copy_to_user(user, &tmp, *len) != 0) {
 			ret = -EFAULT;
 			break;
 		}
diff --git a/net/caif/cfctrl.c b/net/caif/cfctrl.c
index f5afda1ab..dcf770a63 100644
--- a/net/caif/cfctrl.c
+++ b/net/caif/cfctrl.c
@@ -10,6 +10,7 @@
 #include <linux/spinlock.h>
 #include <linux/slab.h>
 #include <linux/pkt_sched.h>
+#include <linux/sched.h>
 #include <net/caif/caif_layer.h>
 #include <net/caif/cfpkt.h>
 #include <net/caif/cfctrl.h>
@@ -43,8 +44,8 @@ struct cflayer *cfctrl_create(void)
 	memset(&dev_info, 0, sizeof(dev_info));
 	dev_info.id = 0xff;
 	cfsrvl_init(&this->serv, 0, &dev_info, false);
-	atomic_set(&this->req_seq_no, 1);
-	atomic_set(&this->rsp_seq_no, 1);
+	atomic_set_unchecked(&this->req_seq_no, 1);
+	atomic_set_unchecked(&this->rsp_seq_no, 1);
 	this->serv.layer.receive = cfctrl_recv;
 	sprintf(this->serv.layer.name, "ctrl");
 	this->serv.layer.ctrlcmd = cfctrl_ctrlcmd;
@@ -130,8 +131,8 @@ static void cfctrl_insert_req(struct cfctrl *ctrl,
 			      struct cfctrl_request_info *req)
 {
 	spin_lock_bh(&ctrl->info_list_lock);
-	atomic_inc(&ctrl->req_seq_no);
-	req->sequence_no = atomic_read(&ctrl->req_seq_no);
+	atomic_inc_unchecked(&ctrl->req_seq_no);
+	req->sequence_no = atomic_read_unchecked(&ctrl->req_seq_no);
 	list_add_tail(&req->list, &ctrl->list);
 	spin_unlock_bh(&ctrl->info_list_lock);
 }
@@ -149,7 +150,7 @@ static struct cfctrl_request_info *cfctrl_remove_req(struct cfctrl *ctrl,
 			if (p != first)
 				pr_warn("Requests are not received in order\n");
 
-			atomic_set(&ctrl->rsp_seq_no,
+			atomic_set_unchecked(&ctrl->rsp_seq_no,
 					 p->sequence_no);
 			list_del(&p->list);
 			goto out;
diff --git a/net/caif/chnl_net.c b/net/caif/chnl_net.c
index 3408ed51b..885aab5aa 100644
--- a/net/caif/chnl_net.c
+++ b/net/caif/chnl_net.c
@@ -213,7 +213,7 @@ static void chnl_flowctrl_cb(struct cflayer *layr, enum caif_ctrlcmd flow,
 	}
 }
 
-static int chnl_net_start_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t chnl_net_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct chnl_net *priv;
 	struct cfpkt *pkt = NULL;
@@ -514,7 +514,7 @@ static const struct nla_policy ipcaif_policy[IFLA_CAIF_MAX + 1] = {
 };
 
 
-static struct rtnl_link_ops ipcaif_link_ops __read_mostly = {
+static struct rtnl_link_ops ipcaif_link_ops = {
 	.kind		= "caif",
 	.priv_size	= sizeof(struct chnl_net),
 	.setup		= ipcaif_net_setup,
diff --git a/net/can/af_can.c b/net/can/af_can.c
index 1108079d9..1871d16ea 100644
--- a/net/can/af_can.c
+++ b/net/can/af_can.c
@@ -890,7 +890,7 @@ static const struct net_proto_family can_family_ops = {
 };
 
 /* notifier block for netdevice event */
-static struct notifier_block can_netdev_notifier __read_mostly = {
+static struct notifier_block can_netdev_notifier = {
 	.notifier_call = can_notifier,
 };
 
diff --git a/net/can/bcm.c b/net/can/bcm.c
index 436a7537e..4d61e73a4 100644
--- a/net/can/bcm.c
+++ b/net/can/bcm.c
@@ -1690,7 +1690,7 @@ static int __init bcm_module_init(void)
 	}
 
 	/* create /proc/net/can-bcm directory */
-	proc_dir = proc_mkdir("can-bcm", init_net.proc_net);
+	proc_dir = proc_mkdir_restrict("can-bcm", init_net.proc_net);
 	return 0;
 }
 
diff --git a/net/can/gw.c b/net/can/gw.c
index 455168718..4e82e9bfd 100644
--- a/net/can/gw.c
+++ b/net/can/gw.c
@@ -80,7 +80,6 @@ MODULE_PARM_DESC(max_hops,
 		 "default: " __stringify(CGW_DEFAULT_HOPS) ")");
 
 static HLIST_HEAD(cgw_list);
-static struct notifier_block notifier;
 
 static struct kmem_cache *cgw_cache __read_mostly;
 
@@ -992,6 +991,10 @@ static int cgw_remove_job(struct sk_buff *skb, struct nlmsghdr *nlh)
 	return err;
 }
 
+static struct notifier_block notifier = {
+	.notifier_call = cgw_notifier
+};
+
 static __init int cgw_module_init(void)
 {
 	/* sanitize given module parameter */
@@ -1007,7 +1010,6 @@ static __init int cgw_module_init(void)
 		return -ENOMEM;
 
 	/* set notifier */
-	notifier.notifier_call = cgw_notifier;
 	register_netdevice_notifier(&notifier);
 
 	if (__rtnl_register(PF_CAN, RTM_GETROUTE, NULL, cgw_dump_jobs, NULL)) {
diff --git a/net/can/proc.c b/net/can/proc.c
index 85ef7bb0f..84c0fec26 100644
--- a/net/can/proc.c
+++ b/net/can/proc.c
@@ -514,7 +514,7 @@ static void can_remove_proc_readentry(const char *name)
 void can_init_proc(void)
 {
 	/* create /proc/net/can directory */
-	can_dir = proc_mkdir("can", init_net.proc_net);
+	can_dir = proc_mkdir_restrict("can", init_net.proc_net);
 
 	if (!can_dir) {
 		pr_info("can: failed to create /proc/net/can.\n");
diff --git a/net/ceph/ceph_common.c b/net/ceph/ceph_common.c
index bddfcf6f0..36880cdd3 100644
--- a/net/ceph/ceph_common.c
+++ b/net/ceph/ceph_common.c
@@ -5,7 +5,7 @@
 #include <linux/fs.h>
 #include <linux/inet.h>
 #include <linux/in6.h>
-#include <linux/key.h>
+#include <linux/key-type.h>
 #include <keys/ceph-type.h>
 #include <linux/module.h>
 #include <linux/mount.h>
diff --git a/net/ceph/messenger.c b/net/ceph/messenger.c
index 2efb335de..e8a499d86 100644
--- a/net/ceph/messenger.c
+++ b/net/ceph/messenger.c
@@ -187,7 +187,7 @@ static void con_fault(struct ceph_connection *con);
 #define MAX_ADDR_STR_LEN	64	/* 54 is enough */
 
 static char addr_str[ADDR_STR_COUNT][MAX_ADDR_STR_LEN];
-static atomic_t addr_str_seq = ATOMIC_INIT(0);
+static atomic_unchecked_t addr_str_seq = ATOMIC_INIT(0);
 
 static struct page *zero_page;		/* used in certain error cases */
 
@@ -198,7 +198,7 @@ const char *ceph_pr_addr(const struct sockaddr_storage *ss)
 	struct sockaddr_in *in4 = (struct sockaddr_in *) ss;
 	struct sockaddr_in6 *in6 = (struct sockaddr_in6 *) ss;
 
-	i = atomic_inc_return(&addr_str_seq) & ADDR_STR_COUNT_MASK;
+	i = atomic_inc_return_unchecked(&addr_str_seq) & ADDR_STR_COUNT_MASK;
 	s = addr_str[i];
 
 	switch (ss->ss_family) {
diff --git a/net/compat.c b/net/compat.c
index 1cd2ec046..2650ce6f4 100644
--- a/net/compat.c
+++ b/net/compat.c
@@ -58,7 +58,7 @@ int get_compat_msghdr(struct msghdr *kmsg,
 
 	if (kmsg->msg_namelen > sizeof(struct sockaddr_storage))
 		kmsg->msg_namelen = sizeof(struct sockaddr_storage);
-	kmsg->msg_control = compat_ptr(tmp3);
+	kmsg->msg_control = (void __force_kernel *)compat_ptr(tmp3);
 
 	if (save_addr)
 		*save_addr = compat_ptr(uaddr);
@@ -98,20 +98,20 @@ int get_compat_msghdr(struct msghdr *kmsg,
 
 #define CMSG_COMPAT_FIRSTHDR(msg)			\
 	(((msg)->msg_controllen) >= sizeof(struct compat_cmsghdr) ?	\
-	 (struct compat_cmsghdr __user *)((msg)->msg_control) :		\
+	 (struct compat_cmsghdr __force_user *)((msg)->msg_control) :		\
 	 (struct compat_cmsghdr __user *)NULL)
 
 #define CMSG_COMPAT_OK(ucmlen, ucmsg, mhdr) \
 	((ucmlen) >= sizeof(struct compat_cmsghdr) && \
 	 (ucmlen) <= (unsigned long) \
 	 ((mhdr)->msg_controllen - \
-	  ((char *)(ucmsg) - (char *)(mhdr)->msg_control)))
+	  ((char __force_kernel *)(ucmsg) - (char *)(mhdr)->msg_control)))
 
 static inline struct compat_cmsghdr __user *cmsg_compat_nxthdr(struct msghdr *msg,
 		struct compat_cmsghdr __user *cmsg, int cmsg_len)
 {
 	char __user *ptr = (char __user *)cmsg + CMSG_COMPAT_ALIGN(cmsg_len);
-	if ((unsigned long)(ptr + 1 - (char __user *)msg->msg_control) >
+	if ((unsigned long)(ptr + 1 - (char __force_user *)msg->msg_control) >
 			msg->msg_controllen)
 		return NULL;
 	return (struct compat_cmsghdr __user *)ptr;
@@ -201,7 +201,7 @@ Efault:
 
 int put_cmsg_compat(struct msghdr *kmsg, int level, int type, int len, void *data)
 {
-	struct compat_cmsghdr __user *cm = (struct compat_cmsghdr __user *) kmsg->msg_control;
+	struct compat_cmsghdr __user *cm = (struct compat_cmsghdr __force_user *) kmsg->msg_control;
 	struct compat_cmsghdr cmhdr;
 	struct compat_timeval ctv;
 	struct compat_timespec cts[3];
@@ -257,7 +257,7 @@ int put_cmsg_compat(struct msghdr *kmsg, int level, int type, int len, void *dat
 
 void scm_detach_fds_compat(struct msghdr *kmsg, struct scm_cookie *scm)
 {
-	struct compat_cmsghdr __user *cm = (struct compat_cmsghdr __user *) kmsg->msg_control;
+	struct compat_cmsghdr __user *cm = (struct compat_cmsghdr __force_user *) kmsg->msg_control;
 	int fdmax = (kmsg->msg_controllen - sizeof(struct compat_cmsghdr)) / sizeof(int);
 	int fdnum = scm->fp->count;
 	struct file **fp = scm->fp->fp;
@@ -358,7 +358,7 @@ static int do_set_sock_timeout(struct socket *sock, int level,
 		return -EFAULT;
 	old_fs = get_fs();
 	set_fs(KERNEL_DS);
-	err = sock_setsockopt(sock, level, optname, (char *)&ktime, sizeof(ktime));
+	err = sock_setsockopt(sock, level, optname, (char __force_user *)&ktime, sizeof(ktime));
 	set_fs(old_fs);
 
 	return err;
@@ -420,7 +420,7 @@ static int do_get_sock_timeout(struct socket *sock, int level, int optname,
 	len = sizeof(ktime);
 	old_fs = get_fs();
 	set_fs(KERNEL_DS);
-	err = sock_getsockopt(sock, level, optname, (char *) &ktime, &len);
+	err = sock_getsockopt(sock, level, optname, (char __force_user *) &ktime, (int __force_user *)&len);
 	set_fs(old_fs);
 
 	if (!err) {
@@ -563,7 +563,7 @@ int compat_mc_setsockopt(struct sock *sock, int level, int optname,
 	case MCAST_JOIN_GROUP:
 	case MCAST_LEAVE_GROUP:
 	{
-		struct compat_group_req __user *gr32 = (void *)optval;
+		struct compat_group_req __user *gr32 = (void __user *)optval;
 		struct group_req __user *kgr =
 			compat_alloc_user_space(sizeof(struct group_req));
 		u32 interface;
@@ -584,7 +584,7 @@ int compat_mc_setsockopt(struct sock *sock, int level, int optname,
 	case MCAST_BLOCK_SOURCE:
 	case MCAST_UNBLOCK_SOURCE:
 	{
-		struct compat_group_source_req __user *gsr32 = (void *)optval;
+		struct compat_group_source_req __user *gsr32 = (void __user *)optval;
 		struct group_source_req __user *kgsr = compat_alloc_user_space(
 			sizeof(struct group_source_req));
 		u32 interface;
@@ -605,7 +605,7 @@ int compat_mc_setsockopt(struct sock *sock, int level, int optname,
 	}
 	case MCAST_MSFILTER:
 	{
-		struct compat_group_filter __user *gf32 = (void *)optval;
+		struct compat_group_filter __user *gf32 = (void __user *)optval;
 		struct group_filter __user *kgf;
 		u32 interface, fmode, numsrc;
 
@@ -643,7 +643,7 @@ int compat_mc_getsockopt(struct sock *sock, int level, int optname,
 	char __user *optval, int __user *optlen,
 	int (*getsockopt)(struct sock *, int, int, char __user *, int __user *))
 {
-	struct compat_group_filter __user *gf32 = (void *)optval;
+	struct compat_group_filter __user *gf32 = (void __user *)optval;
 	struct group_filter __user *kgf;
 	int __user	*koptlen;
 	u32 interface, fmode, numsrc;
@@ -787,7 +787,7 @@ COMPAT_SYSCALL_DEFINE2(socketcall, int, call, u32 __user *, args)
 
 	if (call < SYS_SOCKET || call > SYS_SENDMMSG)
 		return -EINVAL;
-	if (copy_from_user(a, args, nas[call]))
+	if (nas[call] > sizeof a || copy_from_user(a, args, nas[call]))
 		return -EFAULT;
 	a0 = a[0];
 	a1 = a[1];
diff --git a/net/core/datagram.c b/net/core/datagram.c
index b7de71f8d..808387db1 100644
--- a/net/core/datagram.c
+++ b/net/core/datagram.c
@@ -360,7 +360,7 @@ int skb_kill_datagram(struct sock *sk, struct sk_buff *skb, unsigned int flags)
 	}
 
 	kfree_skb(skb);
-	atomic_inc(&sk->sk_drops);
+	atomic_inc_unchecked(&sk->sk_drops);
 	sk_mem_reclaim_partial(sk);
 
 	return err;
diff --git a/net/core/dev.c b/net/core/dev.c
index 9ce9d7284..6221b9240 100644
--- a/net/core/dev.c
+++ b/net/core/dev.c
@@ -1768,7 +1768,7 @@ int __dev_forward_skb(struct net_device *dev, struct sk_buff *skb)
 {
 	if (skb_orphan_frags(skb, GFP_ATOMIC) ||
 	    unlikely(!is_skb_forwardable(dev, skb))) {
-		atomic_long_inc(&dev->rx_dropped);
+		atomic_long_inc_unchecked(&dev->rx_dropped);
 		kfree_skb(skb);
 		return NET_RX_DROP;
 	}
@@ -3005,7 +3005,7 @@ static struct sk_buff *validate_xmit_skb(struct sk_buff *skb, struct net_device
 out_kfree_skb:
 	kfree_skb(skb);
 out_null:
-	atomic_long_inc(&dev->tx_dropped);
+	atomic_long_inc_unchecked(&dev->tx_dropped);
 	return NULL;
 }
 
@@ -3426,7 +3426,7 @@ recursion_alert:
 	rc = -ENETDOWN;
 	rcu_read_unlock_bh();
 
-	atomic_long_inc(&dev->tx_dropped);
+	atomic_long_inc_unchecked(&dev->tx_dropped);
 	kfree_skb_list(skb);
 	return rc;
 out:
@@ -3779,7 +3779,7 @@ drop:
 
 	local_irq_restore(flags);
 
-	atomic_long_inc(&skb->dev->rx_dropped);
+	atomic_long_inc_unchecked(&skb->dev->rx_dropped);
 	kfree_skb(skb);
 	return NET_RX_DROP;
 }
@@ -3856,7 +3856,7 @@ int netif_rx_ni(struct sk_buff *skb)
 }
 EXPORT_SYMBOL(netif_rx_ni);
 
-static void net_tx_action(struct softirq_action *h)
+static __latent_entropy void net_tx_action(void)
 {
 	struct softnet_data *sd = this_cpu_ptr(&softnet_data);
 
@@ -4219,9 +4219,9 @@ ncls:
 	} else {
 drop:
 		if (!deliver_exact)
-			atomic_long_inc(&skb->dev->rx_dropped);
+			atomic_long_inc_unchecked(&skb->dev->rx_dropped);
 		else
-			atomic_long_inc(&skb->dev->rx_nohandler);
+			atomic_long_inc_unchecked(&skb->dev->rx_nohandler);
 		kfree_skb(skb);
 		/* Jamal, now you will not able to escape explaining
 		 * me how you were going to use this. :-)
@@ -5189,7 +5189,7 @@ out_unlock:
 	return work;
 }
 
-static void net_rx_action(struct softirq_action *h)
+static __latent_entropy void net_rx_action(void)
 {
 	struct softnet_data *sd = this_cpu_ptr(&softnet_data);
 	unsigned long time_limit = jiffies + 2;
@@ -7532,9 +7532,9 @@ struct rtnl_link_stats64 *dev_get_stats(struct net_device *dev,
 	} else {
 		netdev_stats_to_stats64(storage, &dev->stats);
 	}
-	storage->rx_dropped += atomic_long_read(&dev->rx_dropped);
-	storage->tx_dropped += atomic_long_read(&dev->tx_dropped);
-	storage->rx_nohandler += atomic_long_read(&dev->rx_nohandler);
+	storage->rx_dropped += atomic_long_read_unchecked(&dev->rx_dropped);
+	storage->tx_dropped += atomic_long_read_unchecked(&dev->tx_dropped);
+	storage->rx_nohandler += atomic_long_read_unchecked(&dev->rx_nohandler);
 	return storage;
 }
 EXPORT_SYMBOL(dev_get_stats);
@@ -8156,7 +8156,7 @@ static void __net_exit netdev_exit(struct net *net)
 	kfree(net->dev_index_head);
 }
 
-static struct pernet_operations __net_initdata netdev_net_ops = {
+static struct pernet_operations __net_initconst netdev_net_ops = {
 	.init = netdev_init,
 	.exit = netdev_exit,
 };
@@ -8256,7 +8256,7 @@ static void __net_exit default_device_exit_batch(struct list_head *net_list)
 	rtnl_unlock();
 }
 
-static struct pernet_operations __net_initdata default_device_ops = {
+static struct pernet_operations __net_initconst default_device_ops = {
 	.exit = default_device_exit,
 	.exit_batch = default_device_exit_batch,
 };
diff --git a/net/core/dev_ioctl.c b/net/core/dev_ioctl.c
index b94b1d293..da3ed7c4e 100644
--- a/net/core/dev_ioctl.c
+++ b/net/core/dev_ioctl.c
@@ -368,8 +368,13 @@ void dev_load(struct net *net, const char *name)
 	no_module = !dev;
 	if (no_module && capable(CAP_NET_ADMIN))
 		no_module = request_module("netdev-%s", name);
-	if (no_module && capable(CAP_SYS_MODULE))
+	if (no_module && capable(CAP_SYS_MODULE)) {
+#ifdef CONFIG_GRKERNSEC_MODHARDEN
+		___request_module(true, "grsec_modharden_netdev", "%s", name);
+#else
 		request_module("%s", name);
+#endif
+	}
 }
 EXPORT_SYMBOL(dev_load);
 
diff --git a/net/core/filter.c b/net/core/filter.c
index cb06aceb5..3cab3fca3 100644
--- a/net/core/filter.c
+++ b/net/core/filter.c
@@ -596,7 +596,11 @@ do_pass:
 
 		/* Unknown instruction. */
 		default:
-			goto err;
+			WARN(1, KERN_ALERT "Unknown sock filter code:%u jt:%u tf:%u k:%u\n",
+				       fp->code, fp->jt, fp->jf, fp->k);
+			kfree(addrs);
+			BUG();
+			return -EINVAL;
 		}
 
 		insn++;
@@ -640,7 +644,7 @@ static int check_load_and_stores(const struct sock_filter *filter, int flen)
 	u16 *masks, memvalid = 0; /* One bit per cell, 16 cells */
 	int pc, ret = 0;
 
-	BUILD_BUG_ON(BPF_MEMWORDS > 16);
+	BUILD_BUG_ON(BPF_MEMWORDS != 16);
 
 	masks = kmalloc_array(flen, sizeof(*masks), GFP_KERNEL);
 	if (!masks)
@@ -1086,7 +1090,7 @@ int bpf_prog_create(struct bpf_prog **pfp, struct sock_fprog_kern *fprog)
 	if (!fp)
 		return -ENOMEM;
 
-	memcpy(fp->insns, fprog->filter, fsize);
+	memcpy(fp->insns, (void __force_kernel *)fprog->filter, fsize);
 
 	fp->len = fprog->len;
 	/* Since unattached filters are not copied back to user
diff --git a/net/core/flow.c b/net/core/flow.c
index 18e8893d4..82936b220 100644
--- a/net/core/flow.c
+++ b/net/core/flow.c
@@ -65,7 +65,7 @@ static void flow_cache_new_hashrnd(unsigned long arg)
 static int flow_entry_valid(struct flow_cache_entry *fle,
 				struct netns_xfrm *xfrm)
 {
-	if (atomic_read(&xfrm->flow_cache_genid) != fle->genid)
+	if (atomic_read_unchecked(&xfrm->flow_cache_genid) != fle->genid)
 		return 0;
 	if (fle->object && !fle->object->ops->check(fle->object))
 		return 0;
@@ -251,7 +251,7 @@ flow_cache_lookup(struct net *net, const struct flowi *key, u16 family, u8 dir,
 			hlist_add_head(&fle->u.hlist, &fcp->hash_table[hash]);
 			fcp->hash_count++;
 		}
-	} else if (likely(fle->genid == atomic_read(&net->xfrm.flow_cache_genid))) {
+	} else if (likely(fle->genid == atomic_read_unchecked(&net->xfrm.flow_cache_genid))) {
 		flo = fle->object;
 		if (!flo)
 			goto ret_object;
@@ -272,7 +272,7 @@ nocache:
 	}
 	flo = resolver(net, key, family, dir, flo, ctx);
 	if (fle) {
-		fle->genid = atomic_read(&net->xfrm.flow_cache_genid);
+		fle->genid = atomic_read_unchecked(&net->xfrm.flow_cache_genid);
 		if (!IS_ERR(flo))
 			fle->object = flo;
 		else
diff --git a/net/core/neighbour.c b/net/core/neighbour.c
index cf26e04c4..e70ca13d2 100644
--- a/net/core/neighbour.c
+++ b/net/core/neighbour.c
@@ -860,7 +860,7 @@ static void neigh_probe(struct neighbour *neigh)
 		skb = skb_clone(skb, GFP_ATOMIC);
 	write_unlock(&neigh->lock);
 	neigh->ops->solicit(neigh, skb);
-	atomic_inc(&neigh->probes);
+	atomic_inc_unchecked(&neigh->probes);
 	kfree_skb(skb);
 }
 
@@ -916,7 +916,7 @@ static void neigh_timer_handler(unsigned long arg)
 			neigh_dbg(2, "neigh %p is probed\n", neigh);
 			neigh->nud_state = NUD_PROBE;
 			neigh->updated = jiffies;
-			atomic_set(&neigh->probes, 0);
+			atomic_set_unchecked(&neigh->probes, 0);
 			notify = 1;
 			next = now + NEIGH_VAR(neigh->parms, RETRANS_TIME);
 		}
@@ -926,7 +926,7 @@ static void neigh_timer_handler(unsigned long arg)
 	}
 
 	if ((neigh->nud_state & (NUD_INCOMPLETE | NUD_PROBE)) &&
-	    atomic_read(&neigh->probes) >= neigh_max_probes(neigh)) {
+	    atomic_read_unchecked(&neigh->probes) >= neigh_max_probes(neigh)) {
 		neigh->nud_state = NUD_FAILED;
 		notify = 1;
 		neigh_invalidate(neigh);
@@ -970,7 +970,7 @@ int __neigh_event_send(struct neighbour *neigh, struct sk_buff *skb)
 		    NEIGH_VAR(neigh->parms, APP_PROBES)) {
 			unsigned long next, now = jiffies;
 
-			atomic_set(&neigh->probes,
+			atomic_set_unchecked(&neigh->probes,
 				   NEIGH_VAR(neigh->parms, UCAST_PROBES));
 			neigh->nud_state     = NUD_INCOMPLETE;
 			neigh->updated = now;
@@ -1156,7 +1156,7 @@ int neigh_update(struct neighbour *neigh, const u8 *lladdr, u8 new,
 	if (new != old) {
 		neigh_del_timer(neigh);
 		if (new & NUD_PROBE)
-			atomic_set(&neigh->probes, 0);
+			atomic_set_unchecked(&neigh->probes, 0);
 		if (new & NUD_IN_TIMER)
 			neigh_add_timer(neigh, (jiffies +
 						((new & NUD_REACHABLE) ?
@@ -1244,7 +1244,7 @@ void __neigh_set_probe_once(struct neighbour *neigh)
 	if (!(neigh->nud_state & NUD_FAILED))
 		return;
 	neigh->nud_state = NUD_INCOMPLETE;
-	atomic_set(&neigh->probes, neigh_max_probes(neigh));
+	atomic_set_unchecked(&neigh->probes, neigh_max_probes(neigh));
 	neigh_add_timer(neigh,
 			jiffies + NEIGH_VAR(neigh->parms, RETRANS_TIME));
 }
@@ -2184,7 +2184,7 @@ static int neigh_fill_info(struct sk_buff *skb, struct neighbour *neigh,
 	ci.ndm_refcnt	 = atomic_read(&neigh->refcnt) - 1;
 	read_unlock_bh(&neigh->lock);
 
-	if (nla_put_u32(skb, NDA_PROBES, atomic_read(&neigh->probes)) ||
+	if (nla_put_u32(skb, NDA_PROBES, atomic_read_unchecked(&neigh->probes)) ||
 	    nla_put(skb, NDA_CACHEINFO, sizeof(ci), &ci))
 		goto nla_put_failure;
 
@@ -2872,7 +2872,7 @@ static int proc_unres_qlen(struct ctl_table *ctl, int write,
 			   void __user *buffer, size_t *lenp, loff_t *ppos)
 {
 	int size, ret;
-	struct ctl_table tmp = *ctl;
+	ctl_table_no_const tmp = *ctl;
 
 	tmp.extra1 = &zero;
 	tmp.extra2 = &unres_qlen_max;
@@ -2935,7 +2935,7 @@ static int neigh_proc_dointvec_zero_intmax(struct ctl_table *ctl, int write,
 					   void __user *buffer,
 					   size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table tmp = *ctl;
+	ctl_table_no_const tmp = *ctl;
 	int ret;
 
 	tmp.extra1 = &zero;
diff --git a/net/core/net-procfs.c b/net/core/net-procfs.c
index 14d09345f..f2a895f8a 100644
--- a/net/core/net-procfs.c
+++ b/net/core/net-procfs.c
@@ -79,7 +79,13 @@ static void dev_seq_printf_stats(struct seq_file *seq, struct net_device *dev)
 	struct rtnl_link_stats64 temp;
 	const struct rtnl_link_stats64 *stats = dev_get_stats(dev, &temp);
 
-	seq_printf(seq, "%6s: %7llu %7llu %4llu %4llu %4llu %5llu %10llu %9llu "
+	if (gr_proc_is_restricted())
+		seq_printf(seq, "%6s: %7llu %7llu %4llu %4llu %4llu %5llu %10llu %9llu "
+		   "%8llu %7llu %4llu %4llu %4llu %5llu %7llu %10llu\n",
+		   dev->name, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL,
+		   0ULL, 0ULL, 0ULL, 0ULL, 0ULL, 0ULL);
+	else
+		seq_printf(seq, "%6s: %7llu %7llu %4llu %4llu %4llu %5llu %10llu %9llu "
 		   "%8llu %7llu %4llu %4llu %4llu %5llu %7llu %10llu\n",
 		   dev->name, stats->rx_bytes, stats->rx_packets,
 		   stats->rx_errors,
@@ -167,7 +173,7 @@ static int softnet_seq_show(struct seq_file *seq, void *v)
 	return 0;
 }
 
-static const struct seq_operations dev_seq_ops = {
+const struct seq_operations dev_seq_ops = {
 	.start = dev_seq_start,
 	.next  = dev_seq_next,
 	.stop  = dev_seq_stop,
@@ -197,7 +203,7 @@ static const struct seq_operations softnet_seq_ops = {
 
 static int softnet_seq_open(struct inode *inode, struct file *file)
 {
-	return seq_open(file, &softnet_seq_ops);
+	return seq_open_restrict(file, &softnet_seq_ops);
 }
 
 static const struct file_operations softnet_seq_fops = {
@@ -284,8 +290,13 @@ static int ptype_seq_show(struct seq_file *seq, void *v)
 		else
 			seq_printf(seq, "%04x", ntohs(pt->type));
 
+#ifdef CONFIG_GRKERNSEC_HIDESYM
+		seq_printf(seq, " %-8s %pf\n",
+			   pt->dev ? pt->dev->name : "", NULL);
+#else
 		seq_printf(seq, " %-8s %pf\n",
 			   pt->dev ? pt->dev->name : "", pt->func);
+#endif
 	}
 
 	return 0;
@@ -348,7 +359,7 @@ static void __net_exit dev_proc_net_exit(struct net *net)
 	remove_proc_entry("dev", net->proc_net);
 }
 
-static struct pernet_operations __net_initdata dev_proc_ops = {
+static struct pernet_operations __net_initconst dev_proc_ops = {
 	.init = dev_proc_net_init,
 	.exit = dev_proc_net_exit,
 };
@@ -410,7 +421,7 @@ static void __net_exit dev_mc_net_exit(struct net *net)
 	remove_proc_entry("dev_mcast", net->proc_net);
 }
 
-static struct pernet_operations __net_initdata dev_mc_net_ops = {
+static struct pernet_operations __net_initconst dev_mc_net_ops = {
 	.init = dev_mc_net_init,
 	.exit = dev_mc_net_exit,
 };
diff --git a/net/core/net-sysfs.c b/net/core/net-sysfs.c
index 6e4f34721..8eff663b6 100644
--- a/net/core/net-sysfs.c
+++ b/net/core/net-sysfs.c
@@ -290,7 +290,7 @@ static ssize_t carrier_changes_show(struct device *dev,
 {
 	struct net_device *netdev = to_net_dev(dev);
 	return sprintf(buf, fmt_dec,
-		       atomic_read(&netdev->carrier_changes));
+		       atomic_read_unchecked(&netdev->carrier_changes));
 }
 static DEVICE_ATTR_RO(carrier_changes);
 
diff --git a/net/core/net_namespace.c b/net/core/net_namespace.c
index 2e9a1c281..95e9455a8 100644
--- a/net/core/net_namespace.c
+++ b/net/core/net_namespace.c
@@ -528,7 +528,7 @@ static __net_exit void net_ns_net_exit(struct net *net)
 	ns_free_inum(&net->ns);
 }
 
-static struct pernet_operations __net_initdata net_ns_ops = {
+static struct pernet_operations __net_initconst net_ns_ops = {
 	.init = net_ns_net_init,
 	.exit = net_ns_net_exit,
 };
@@ -777,7 +777,7 @@ static int __register_pernet_operations(struct list_head *list,
 	int error;
 	LIST_HEAD(net_exit_list);
 
-	list_add_tail(&ops->list, list);
+	pax_list_add_tail((struct list_head *)&ops->list, list);
 	if (ops->init || (ops->id && ops->size)) {
 		for_each_net(net) {
 			error = ops_init(ops, net);
@@ -790,7 +790,7 @@ static int __register_pernet_operations(struct list_head *list,
 
 out_undo:
 	/* If I have an error cleanup all namespaces I initialized */
-	list_del(&ops->list);
+	pax_list_del((struct list_head *)&ops->list);
 	ops_exit_list(ops, &net_exit_list);
 	ops_free_list(ops, &net_exit_list);
 	return error;
@@ -801,7 +801,7 @@ static void __unregister_pernet_operations(struct pernet_operations *ops)
 	struct net *net;
 	LIST_HEAD(net_exit_list);
 
-	list_del(&ops->list);
+	pax_list_del((struct list_head *)&ops->list);
 	for_each_net(net)
 		list_add_tail(&net->exit_list, &net_exit_list);
 	ops_exit_list(ops, &net_exit_list);
@@ -935,7 +935,7 @@ int register_pernet_device(struct pernet_operations *ops)
 	mutex_lock(&net_mutex);
 	error = register_pernet_operations(&pernet_list, ops);
 	if (!error && (first_device == &pernet_list))
-		first_device = &ops->list;
+		first_device = (struct list_head *)&ops->list;
 	mutex_unlock(&net_mutex);
 	return error;
 }
diff --git a/net/core/netpoll.c b/net/core/netpoll.c
index 53599bd0c..cbd0b29bf 100644
--- a/net/core/netpoll.c
+++ b/net/core/netpoll.c
@@ -382,7 +382,7 @@ void netpoll_send_udp(struct netpoll *np, const char *msg, int len)
 	struct udphdr *udph;
 	struct iphdr *iph;
 	struct ethhdr *eth;
-	static atomic_t ip_ident;
+	static atomic_unchecked_t ip_ident;
 	struct ipv6hdr *ip6h;
 
 	WARN_ON_ONCE(!irqs_disabled());
@@ -455,7 +455,7 @@ void netpoll_send_udp(struct netpoll *np, const char *msg, int len)
 		put_unaligned(0x45, (unsigned char *)iph);
 		iph->tos      = 0;
 		put_unaligned(htons(ip_len), &(iph->tot_len));
-		iph->id       = htons(atomic_inc_return(&ip_ident));
+		iph->id       = htons(atomic_inc_return_unchecked(&ip_ident));
 		iph->frag_off = 0;
 		iph->ttl      = 64;
 		iph->protocol = IPPROTO_UDP;
diff --git a/net/core/pktgen.c b/net/core/pktgen.c
index 306b8f0e0..021418787 100644
--- a/net/core/pktgen.c
+++ b/net/core/pktgen.c
@@ -3867,7 +3867,7 @@ static int __net_init pg_net_init(struct net *net)
 	pn->net = net;
 	INIT_LIST_HEAD(&pn->pktgen_threads);
 	pn->pktgen_exiting = false;
-	pn->proc_dir = proc_mkdir(PG_PROC_DIR, pn->net->proc_net);
+	pn->proc_dir = proc_mkdir_restrict(PG_PROC_DIR, pn->net->proc_net);
 	if (!pn->proc_dir) {
 		pr_warn("cannot create /proc/net/%s\n", PG_PROC_DIR);
 		return -ENODEV;
diff --git a/net/core/rtnetlink.c b/net/core/rtnetlink.c
index 08c3702f7..d50e67246 100644
--- a/net/core/rtnetlink.c
+++ b/net/core/rtnetlink.c
@@ -61,7 +61,7 @@ struct rtnl_link {
 	rtnl_doit_func		doit;
 	rtnl_dumpit_func	dumpit;
 	rtnl_calcit_func 	calcit;
-};
+} __no_const;
 
 static DEFINE_MUTEX(rtnl_mutex);
 
@@ -329,10 +329,13 @@ int __rtnl_link_register(struct rtnl_link_ops *ops)
 	 * to use the ops for creating device. So do not
 	 * fill up dellink as well. That disables rtnl_dellink.
 	 */
-	if (ops->setup && !ops->dellink)
-		ops->dellink = unregister_netdevice_queue;
+	if (ops->setup && !ops->dellink) {
+		pax_open_kernel();
+		const_cast(ops->dellink) = unregister_netdevice_queue;
+		pax_close_kernel();
+	}
 
-	list_add_tail(&ops->list, &link_ops);
+	pax_list_add_tail((struct list_head *)&ops->list, &link_ops);
 	return 0;
 }
 EXPORT_SYMBOL_GPL(__rtnl_link_register);
@@ -379,7 +382,7 @@ void __rtnl_link_unregister(struct rtnl_link_ops *ops)
 	for_each_net(net) {
 		__rtnl_kill_links(net, ops);
 	}
-	list_del(&ops->list);
+	pax_list_del((struct list_head *)&ops->list);
 }
 EXPORT_SYMBOL_GPL(__rtnl_link_unregister);
 
@@ -1296,7 +1299,7 @@ static int rtnl_fill_ifinfo(struct sk_buff *skb, struct net_device *dev,
 	    (dev->ifalias &&
 	     nla_put_string(skb, IFLA_IFALIAS, dev->ifalias)) ||
 	    nla_put_u32(skb, IFLA_CARRIER_CHANGES,
-			atomic_read(&dev->carrier_changes)) ||
+			atomic_read_unchecked(&dev->carrier_changes)) ||
 	    nla_put_u8(skb, IFLA_PROTO_DOWN, dev->proto_down))
 		goto nla_put_failure;
 
@@ -3832,7 +3835,7 @@ static int rtnetlink_rcv_msg(struct sk_buff *skb, struct nlmsghdr *nlh)
 		__rtnl_unlock();
 		rtnl = net->rtnl;
 		{
-			struct netlink_dump_control c = {
+			netlink_dump_control_no_const c = {
 				.dump		= dumpit,
 				.min_dump_alloc	= min_dump_alloc,
 			};
diff --git a/net/core/scm.c b/net/core/scm.c
index 2696aefdc..dbd580797 100644
--- a/net/core/scm.c
+++ b/net/core/scm.c
@@ -215,9 +215,9 @@ EXPORT_SYMBOL(__scm_send);
 int put_cmsg(struct msghdr * msg, int level, int type, int len, void *data)
 {
 	struct cmsghdr __user *cm
-		= (__force struct cmsghdr __user *)msg->msg_control;
+		= (struct cmsghdr __force_user *)msg->msg_control;
 	struct cmsghdr cmhdr;
-	int cmlen = CMSG_LEN(len);
+	size_t cmlen = CMSG_LEN(len);
 	int err;
 
 	if (MSG_CMSG_COMPAT & msg->msg_flags)
@@ -238,7 +238,7 @@ int put_cmsg(struct msghdr * msg, int level, int type, int len, void *data)
 	err = -EFAULT;
 	if (copy_to_user(cm, &cmhdr, sizeof cmhdr))
 		goto out;
-	if (copy_to_user(CMSG_DATA(cm), data, cmlen - sizeof(struct cmsghdr)))
+	if (copy_to_user((void __force_user *)CMSG_DATA((void __force_kernel *)cm), data, cmlen - sizeof(struct cmsghdr)))
 		goto out;
 	cmlen = CMSG_SPACE(len);
 	if (msg->msg_controllen < cmlen)
@@ -254,7 +254,7 @@ EXPORT_SYMBOL(put_cmsg);
 void scm_detach_fds(struct msghdr *msg, struct scm_cookie *scm)
 {
 	struct cmsghdr __user *cm
-		= (__force struct cmsghdr __user*)msg->msg_control;
+		= (struct cmsghdr __force_user *)msg->msg_control;
 
 	int fdmax = 0;
 	int fdnum = scm->fp->count;
@@ -274,7 +274,7 @@ void scm_detach_fds(struct msghdr *msg, struct scm_cookie *scm)
 	if (fdnum < fdmax)
 		fdmax = fdnum;
 
-	for (i=0, cmfptr=(__force int __user *)CMSG_DATA(cm); i<fdmax;
+	for (i=0, cmfptr=(int __force_user *)CMSG_DATA((void __force_kernel *)cm); i<fdmax;
 	     i++, cmfptr++)
 	{
 		struct socket *sock;
@@ -303,7 +303,7 @@ void scm_detach_fds(struct msghdr *msg, struct scm_cookie *scm)
 
 	if (i > 0)
 	{
-		int cmlen = CMSG_LEN(i*sizeof(int));
+		size_t cmlen = CMSG_LEN(i*sizeof(int));
 		err = put_user(SOL_SOCKET, &cm->cmsg_level);
 		if (!err)
 			err = put_user(SCM_RIGHTS, &cm->cmsg_type);
diff --git a/net/core/skbuff.c b/net/core/skbuff.c
index 3864b4b68..d2cbe8349 100644
--- a/net/core/skbuff.c
+++ b/net/core/skbuff.c
@@ -1047,7 +1047,8 @@ static void skb_headers_offset_update(struct sk_buff *skb, int off)
 	if (skb->ip_summed == CHECKSUM_PARTIAL)
 		skb->csum_start += off;
 	/* {transport,network,mac}_header and tail are relative to skb->head */
-	skb->transport_header += off;
+	if (skb_transport_header_was_set(skb))
+		skb->transport_header += off;
 	skb->network_header   += off;
 	if (skb_mac_header_was_set(skb))
 		skb->mac_header += off;
@@ -2174,7 +2175,7 @@ EXPORT_SYMBOL(__skb_checksum);
 __wsum skb_checksum(const struct sk_buff *skb, int offset,
 		    int len, __wsum csum)
 {
-	const struct skb_checksum_ops ops = {
+	static const struct skb_checksum_ops ops = {
 		.update  = csum_partial_ext,
 		.combine = csum_block_add_ext,
 	};
@@ -3432,12 +3433,14 @@ void __init skb_init(void)
 	skbuff_head_cache = kmem_cache_create("skbuff_head_cache",
 					      sizeof(struct sk_buff),
 					      0,
-					      SLAB_HWCACHE_ALIGN|SLAB_PANIC,
+					      SLAB_HWCACHE_ALIGN|SLAB_PANIC|
+					      SLAB_NO_SANITIZE,
 					      NULL);
 	skbuff_fclone_cache = kmem_cache_create("skbuff_fclone_cache",
 						sizeof(struct sk_buff_fclones),
 						0,
-						SLAB_HWCACHE_ALIGN|SLAB_PANIC,
+						SLAB_HWCACHE_ALIGN|SLAB_PANIC|
+						SLAB_NO_SANITIZE,
 						NULL);
 }
 
diff --git a/net/core/sock.c b/net/core/sock.c
index ba27920b6..3f998d0ed 100644
--- a/net/core/sock.c
+++ b/net/core/sock.c
@@ -411,13 +411,13 @@ int __sock_queue_rcv_skb(struct sock *sk, struct sk_buff *skb)
 	struct sk_buff_head *list = &sk->sk_receive_queue;
 
 	if (atomic_read(&sk->sk_rmem_alloc) >= sk->sk_rcvbuf) {
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		trace_sock_rcvqueue_full(sk, skb);
 		return -ENOMEM;
 	}
 
 	if (!sk_rmem_schedule(sk, skb, skb->truesize)) {
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		return -ENOBUFS;
 	}
 
@@ -463,7 +463,7 @@ int __sk_receive_skb(struct sock *sk, struct sk_buff *skb,
 	skb->dev = NULL;
 
 	if (sk_rcvqueues_full(sk, sk->sk_rcvbuf)) {
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		goto discard_and_relse;
 	}
 	if (nested)
@@ -481,7 +481,7 @@ int __sk_receive_skb(struct sock *sk, struct sk_buff *skb,
 		mutex_release(&sk->sk_lock.dep_map, 1, _RET_IP_);
 	} else if (sk_add_backlog(sk, skb, sk->sk_rcvbuf)) {
 		bh_unlock_sock(sk);
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		goto discard_and_relse;
 	}
 
@@ -890,29 +890,30 @@ set_rcvbuf:
 		}
 		break;
 
-	case SO_ATTACH_BPF:
+	case SO_ATTACH_REUSEPORT_CBPF:
 		ret = -EINVAL;
-		if (optlen == sizeof(u32)) {
-			u32 ufd;
+		if (optlen == sizeof(struct sock_fprog)) {
+			struct sock_fprog fprog;
 
 			ret = -EFAULT;
-			if (copy_from_user(&ufd, optval, sizeof(ufd)))
+			if (copy_from_user(&fprog, optval, sizeof(fprog)))
 				break;
 
-			ret = sk_attach_bpf(ufd, sk);
+			ret = sk_reuseport_attach_filter(&fprog, sk);
 		}
 		break;
 
-	case SO_ATTACH_REUSEPORT_CBPF:
+#ifndef GRKERNSEC_BPF_HARDEN
+	case SO_ATTACH_BPF:
 		ret = -EINVAL;
-		if (optlen == sizeof(struct sock_fprog)) {
-			struct sock_fprog fprog;
+		if (optlen == sizeof(u32)) {
+			u32 ufd;
 
 			ret = -EFAULT;
-			if (copy_from_user(&fprog, optval, sizeof(fprog)))
+			if (copy_from_user(&ufd, optval, sizeof(ufd)))
 				break;
 
-			ret = sk_reuseport_attach_filter(&fprog, sk);
+			ret = sk_attach_bpf(ufd, sk);
 		}
 		break;
 
@@ -929,6 +930,8 @@ set_rcvbuf:
 		}
 		break;
 
+#endif
+
 	case SO_DETACH_FILTER:
 		ret = sk_detach_filter(sk);
 		break;
@@ -1038,12 +1041,12 @@ int sock_getsockopt(struct socket *sock, int level, int optname,
 		struct timeval tm;
 	} v;
 
-	int lv = sizeof(int);
-	int len;
+	unsigned int lv = sizeof(int);
+	unsigned int len;
 
 	if (get_user(len, optlen))
 		return -EFAULT;
-	if (len < 0)
+	if (len > INT_MAX)
 		return -EINVAL;
 
 	memset(&v, 0, sizeof(v));
@@ -1181,11 +1184,11 @@ int sock_getsockopt(struct socket *sock, int level, int optname,
 
 	case SO_PEERNAME:
 	{
-		char address[128];
+		char address[_K_SS_MAXSIZE];
 
 		if (sock->ops->getname(sock, (struct sockaddr *)address, &lv, 2))
 			return -ENOTCONN;
-		if (lv < len)
+		if (lv < len || sizeof address < len)
 			return -EINVAL;
 		if (copy_to_user(optval, address, len))
 			return -EFAULT;
@@ -1273,7 +1276,7 @@ int sock_getsockopt(struct socket *sock, int level, int optname,
 
 	if (len > lv)
 		len = lv;
-	if (copy_to_user(optval, &v, len))
+	if (len > sizeof(v) || copy_to_user(optval, &v, len))
 		return -EFAULT;
 lenout:
 	if (put_user(len, optlen))
@@ -1537,7 +1540,7 @@ struct sock *sk_clone_lock(const struct sock *sk, const gfp_t priority)
 		newsk->sk_dst_cache	= NULL;
 		newsk->sk_wmem_queued	= 0;
 		newsk->sk_forward_alloc = 0;
-		atomic_set(&newsk->sk_drops, 0);
+		atomic_set_unchecked(&newsk->sk_drops, 0);
 		newsk->sk_send_head	= NULL;
 		newsk->sk_userlocks	= sk->sk_userlocks & ~SOCK_BINDPORT_LOCK;
 
@@ -1567,7 +1570,7 @@ struct sock *sk_clone_lock(const struct sock *sk, const gfp_t priority)
 		newsk->sk_err_soft = 0;
 		newsk->sk_priority = 0;
 		newsk->sk_incoming_cpu = raw_smp_processor_id();
-		atomic64_set(&newsk->sk_cookie, 0);
+		atomic64_set_unchecked(&newsk->sk_cookie, 0);
 
 		cgroup_sk_alloc(&newsk->sk_cgrp_data);
 
@@ -2499,7 +2502,7 @@ void sock_init_data(struct socket *sock, struct sock *sk)
 	 */
 	smp_wmb();
 	atomic_set(&sk->sk_refcnt, 1);
-	atomic_set(&sk->sk_drops, 0);
+	atomic_set_unchecked(&sk->sk_drops, 0);
 }
 EXPORT_SYMBOL(sock_init_data);
 
@@ -2623,6 +2626,7 @@ void sock_enable_timestamp(struct sock *sk, int flag)
 int sock_recv_errqueue(struct sock *sk, struct msghdr *msg, int len,
 		       int level, int type)
 {
+	struct sock_extended_err ee;
 	struct sock_exterr_skb *serr;
 	struct sk_buff *skb;
 	int copied, err;
@@ -2644,7 +2648,8 @@ int sock_recv_errqueue(struct sock *sk, struct msghdr *msg, int len,
 	sock_recv_timestamp(msg, sk, skb);
 
 	serr = SKB_EXT_ERR(skb);
-	put_cmsg(msg, level, type, sizeof(serr->ee), &serr->ee);
+	ee = serr->ee;
+	put_cmsg(msg, level, type, sizeof ee, &ee);
 
 	msg->msg_flags |= MSG_ERRQUEUE;
 	err = copied;
@@ -3096,7 +3101,7 @@ static __net_exit void proto_exit_net(struct net *net)
 }
 
 
-static __net_initdata struct pernet_operations proto_net_ops = {
+static __net_initconst struct pernet_operations proto_net_ops = {
 	.init = proto_init_net,
 	.exit = proto_exit_net,
 };
diff --git a/net/core/sock_diag.c b/net/core/sock_diag.c
index 6b10573cc..af9e62e45 100644
--- a/net/core/sock_diag.c
+++ b/net/core/sock_diag.c
@@ -14,7 +14,7 @@
 #include <linux/inet_diag.h>
 #include <linux/sock_diag.h>
 
-static const struct sock_diag_handler *sock_diag_handlers[AF_MAX];
+static const struct sock_diag_handler *sock_diag_handlers[AF_MAX] __read_only;
 static int (*inet_rcv_compat)(struct sk_buff *skb, struct nlmsghdr *nlh);
 static DEFINE_MUTEX(sock_diag_table_mutex);
 static struct workqueue_struct *broadcast_wq;
@@ -22,12 +22,12 @@ static struct workqueue_struct *broadcast_wq;
 static u64 sock_gen_cookie(struct sock *sk)
 {
 	while (1) {
-		u64 res = atomic64_read(&sk->sk_cookie);
+		u64 res = atomic64_read_unchecked(&sk->sk_cookie);
 
 		if (res)
 			return res;
-		res = atomic64_inc_return(&sock_net(sk)->cookie_gen);
-		atomic64_cmpxchg(&sk->sk_cookie, 0, res);
+		res = atomic64_inc_return_unchecked(&sock_net(sk)->cookie_gen);
+		atomic64_cmpxchg_unchecked(&sk->sk_cookie, 0, res);
 	}
 }
 
@@ -67,7 +67,7 @@ int sock_diag_put_meminfo(struct sock *sk, struct sk_buff *skb, int attrtype)
 	mem[SK_MEMINFO_WMEM_QUEUED] = sk->sk_wmem_queued;
 	mem[SK_MEMINFO_OPTMEM] = atomic_read(&sk->sk_omem_alloc);
 	mem[SK_MEMINFO_BACKLOG] = sk->sk_backlog.len;
-	mem[SK_MEMINFO_DROPS] = atomic_read(&sk->sk_drops);
+	mem[SK_MEMINFO_DROPS] = atomic_read_unchecked(&sk->sk_drops);
 
 	return nla_put(skb, attrtype, sizeof(mem), &mem);
 }
@@ -193,8 +193,11 @@ int sock_diag_register(const struct sock_diag_handler *hndl)
 	mutex_lock(&sock_diag_table_mutex);
 	if (sock_diag_handlers[hndl->family])
 		err = -EBUSY;
-	else
+	else {
+		pax_open_kernel();
 		sock_diag_handlers[hndl->family] = hndl;
+		pax_close_kernel();
+	}
 	mutex_unlock(&sock_diag_table_mutex);
 
 	return err;
@@ -210,7 +213,9 @@ void sock_diag_unregister(const struct sock_diag_handler *hnld)
 
 	mutex_lock(&sock_diag_table_mutex);
 	BUG_ON(sock_diag_handlers[family] != hnld);
+	pax_open_kernel();
 	sock_diag_handlers[family] = NULL;
+	pax_close_kernel();
 	mutex_unlock(&sock_diag_table_mutex);
 }
 EXPORT_SYMBOL_GPL(sock_diag_unregister);
diff --git a/net/core/sysctl_net_core.c b/net/core/sysctl_net_core.c
index 0df2aa652..7db59f71a 100644
--- a/net/core/sysctl_net_core.c
+++ b/net/core/sysctl_net_core.c
@@ -36,7 +36,7 @@ static int rps_sock_flow_sysctl(struct ctl_table *table, int write,
 {
 	unsigned int orig_size, size;
 	int ret, i;
-	struct ctl_table tmp = {
+	ctl_table_no_const tmp = {
 		.data = &size,
 		.maxlen = sizeof(size),
 		.mode = table->mode
@@ -204,7 +204,7 @@ static int set_default_qdisc(struct ctl_table *table, int write,
 			     void __user *buffer, size_t *lenp, loff_t *ppos)
 {
 	char id[IFNAMSIZ];
-	struct ctl_table tbl = {
+	ctl_table_no_const tbl = {
 		.data = id,
 		.maxlen = IFNAMSIZ,
 	};
@@ -222,7 +222,7 @@ static int set_default_qdisc(struct ctl_table *table, int write,
 static int proc_do_rss_key(struct ctl_table *table, int write,
 			   void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table fake_table;
+	ctl_table_no_const fake_table;
 	char buf[NETDEV_RSS_KEY_LEN * 3];
 
 	snprintf(buf, sizeof(buf), "%*phC", NETDEV_RSS_KEY_LEN, netdev_rss_key);
@@ -286,7 +286,7 @@ static struct ctl_table net_core_table[] = {
 		.mode		= 0444,
 		.proc_handler	= proc_do_rss_key,
 	},
-#ifdef CONFIG_BPF_JIT
+#if defined(CONFIG_BPF_JIT) && !defined(CONFIG_GRKERNSEC_BPF_HARDEN)
 	{
 		.procname	= "bpf_jit_enable",
 		.data		= &bpf_jit_enable,
@@ -428,13 +428,12 @@ static struct ctl_table netns_core_table[] = {
 
 static __net_init int sysctl_core_net_init(struct net *net)
 {
-	struct ctl_table *tbl;
+	ctl_table_no_const *tbl = NULL;
 
 	net->core.sysctl_somaxconn = SOMAXCONN;
 
-	tbl = netns_core_table;
 	if (!net_eq(net, &init_net)) {
-		tbl = kmemdup(tbl, sizeof(netns_core_table), GFP_KERNEL);
+		tbl = kmemdup(netns_core_table, sizeof(netns_core_table), GFP_KERNEL);
 		if (tbl == NULL)
 			goto err_dup;
 
@@ -444,17 +443,16 @@ static __net_init int sysctl_core_net_init(struct net *net)
 		if (net->user_ns != &init_user_ns) {
 			tbl[0].procname = NULL;
 		}
-	}
-
-	net->core.sysctl_hdr = register_net_sysctl(net, "net/core", tbl);
+		net->core.sysctl_hdr = register_net_sysctl(net, "net/core", tbl);
+	} else
+		net->core.sysctl_hdr = register_net_sysctl(net, "net/core", netns_core_table);
 	if (net->core.sysctl_hdr == NULL)
 		goto err_reg;
 
 	return 0;
 
 err_reg:
-	if (tbl != netns_core_table)
-		kfree(tbl);
+	kfree(tbl);
 err_dup:
 	return -ENOMEM;
 }
@@ -469,7 +467,7 @@ static __net_exit void sysctl_core_net_exit(struct net *net)
 	kfree(tbl);
 }
 
-static __net_initdata struct pernet_operations sysctl_core_ops = {
+static __net_initconst struct pernet_operations sysctl_core_ops = {
 	.init = sysctl_core_net_init,
 	.exit = sysctl_core_net_exit,
 };
diff --git a/net/decnet/af_decnet.c b/net/decnet/af_decnet.c
index 13d6b1a6e..eaa0ceeea 100644
--- a/net/decnet/af_decnet.c
+++ b/net/decnet/af_decnet.c
@@ -1524,7 +1524,12 @@ static int __dn_getsockopt(struct socket *sock, int level,int optname, char __us
 	struct linkinfo_dn link;
 	unsigned int r_len;
 	void *r_data = NULL;
-	unsigned int val;
+	struct optdata_dn opt;
+	struct accessdata_dn acc;
+	u8 mode;
+	int val;
+	unsigned long window;
+	unsigned char rem;
 
 	if(get_user(r_len , optlen))
 		return -EFAULT;
@@ -1533,25 +1538,29 @@ static int __dn_getsockopt(struct socket *sock, int level,int optname, char __us
 	case DSO_CONDATA:
 		if (r_len > sizeof(struct optdata_dn))
 			r_len = sizeof(struct optdata_dn);
-		r_data = &scp->conndata_in;
+		opt = scp->conndata_in;
+		r_data = &opt;
 		break;
 
 	case DSO_DISDATA:
 		if (r_len > sizeof(struct optdata_dn))
 			r_len = sizeof(struct optdata_dn);
-		r_data = &scp->discdata_in;
+		opt = scp->discdata_in;
+		r_data = &opt;
 		break;
 
 	case DSO_CONACCESS:
 		if (r_len > sizeof(struct accessdata_dn))
 			r_len = sizeof(struct accessdata_dn);
-		r_data = &scp->accessdata;
+		acc = scp->accessdata;
+		r_data = &acc;
 		break;
 
 	case DSO_ACCEPTMODE:
 		if (r_len > sizeof(unsigned char))
 			r_len = sizeof(unsigned char);
-		r_data = &scp->accept_mode;
+		mode = scp->accept_mode;
+		r_data = &mode;
 		break;
 
 	case DSO_LINKINFO:
@@ -1601,7 +1610,8 @@ static int __dn_getsockopt(struct socket *sock, int level,int optname, char __us
 	case DSO_MAXWINDOW:
 		if (r_len > sizeof(unsigned long))
 			r_len = sizeof(unsigned long);
-		r_data = &scp->max_window;
+		window = scp->max_window;
+		r_data = &window;
 		break;
 
 	case DSO_NODELAY:
@@ -1621,13 +1631,15 @@ static int __dn_getsockopt(struct socket *sock, int level,int optname, char __us
 	case DSO_SERVICES:
 		if (r_len > sizeof(unsigned char))
 			r_len = sizeof(unsigned char);
-		r_data = &scp->services_rem;
+		rem = scp->services_rem;
+		r_data = &rem;
 		break;
 
 	case DSO_INFO:
 		if (r_len > sizeof(unsigned char))
 			r_len = sizeof(unsigned char);
-		r_data = &scp->info_rem;
+		rem = scp->info_rem;
+		r_data = &rem;
 		break;
 	}
 
diff --git a/net/decnet/dn_dev.c b/net/decnet/dn_dev.c
index b2c26b081..41f803e35 100644
--- a/net/decnet/dn_dev.c
+++ b/net/decnet/dn_dev.c
@@ -201,7 +201,7 @@ static struct dn_dev_sysctl_table {
 		.extra1 = &min_t3,
 		.extra2 = &max_t3
 	},
-	{0}
+	{ }
 	},
 };
 
diff --git a/net/decnet/sysctl_net_decnet.c b/net/decnet/sysctl_net_decnet.c
index 5325b541c..a0d4d69ff 100644
--- a/net/decnet/sysctl_net_decnet.c
+++ b/net/decnet/sysctl_net_decnet.c
@@ -174,7 +174,7 @@ static int dn_node_address_handler(struct ctl_table *table, int write,
 
 	if (len > *lenp) len = *lenp;
 
-	if (copy_to_user(buffer, addr, len))
+	if (len > sizeof addr || copy_to_user(buffer, addr, len))
 		return -EFAULT;
 
 	*lenp = len;
@@ -237,7 +237,7 @@ static int dn_def_dev_handler(struct ctl_table *table, int write,
 
 	if (len > *lenp) len = *lenp;
 
-	if (copy_to_user(buffer, devname, len))
+	if (len > sizeof devname || copy_to_user(buffer, devname, len))
 		return -EFAULT;
 
 	*lenp = len;
diff --git a/net/dsa/dsa.c b/net/dsa/dsa.c
index 7e68bc6bc..09a607372 100644
--- a/net/dsa/dsa.c
+++ b/net/dsa/dsa.c
@@ -269,7 +269,7 @@ const struct dsa_device_ops *dsa_resolve_tag_protocol(int tag_protocol)
 int dsa_cpu_port_ethtool_setup(struct dsa_switch *ds)
 {
 	struct net_device *master;
-	struct ethtool_ops *cpu_ops;
+	ethtool_ops_no_const *cpu_ops;
 
 	master = ds->dst->master_netdev;
 	if (ds->master_netdev)
@@ -1045,7 +1045,7 @@ static struct packet_type dsa_pack_type __read_mostly = {
 	.func	= dsa_switch_rcv,
 };
 
-static struct notifier_block dsa_netdevice_nb __read_mostly = {
+static struct notifier_block dsa_netdevice_nb = {
 	.notifier_call	= dsa_slave_netdevice_event,
 };
 
diff --git a/net/dsa/dsa_priv.h b/net/dsa/dsa_priv.h
index 00077a9c9..c5130466a 100644
--- a/net/dsa/dsa_priv.h
+++ b/net/dsa/dsa_priv.h
@@ -60,7 +60,7 @@ void dsa_cpu_port_ethtool_restore(struct dsa_switch *ds);
 /* slave.c */
 extern const struct dsa_device_ops notag_netdev_ops;
 void dsa_slave_mii_bus_init(struct dsa_switch *ds);
-void dsa_cpu_port_ethtool_init(struct ethtool_ops *ops);
+void dsa_cpu_port_ethtool_init(ethtool_ops_no_const *ops);
 int dsa_slave_create(struct dsa_switch *ds, struct device *parent,
 		     int port, const char *name);
 void dsa_slave_destroy(struct net_device *slave_dev);
diff --git a/net/dsa/slave.c b/net/dsa/slave.c
index fc9196745..b11a8252c 100644
--- a/net/dsa/slave.c
+++ b/net/dsa/slave.c
@@ -906,7 +906,7 @@ static void dsa_slave_poll_controller(struct net_device *dev)
 }
 #endif
 
-void dsa_cpu_port_ethtool_init(struct ethtool_ops *ops)
+void dsa_cpu_port_ethtool_init(ethtool_ops_no_const *ops)
 {
 	ops->get_sset_count = dsa_cpu_port_get_sset_count;
 	ops->get_ethtool_stats = dsa_cpu_port_get_ethtool_stats;
diff --git a/net/hsr/hsr_device.c b/net/hsr/hsr_device.c
index 16737cd8d..812d5d5bf 100644
--- a/net/hsr/hsr_device.c
+++ b/net/hsr/hsr_device.c
@@ -233,7 +233,7 @@ static netdev_features_t hsr_fix_features(struct net_device *dev,
 }
 
 
-static int hsr_dev_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t hsr_dev_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct hsr_priv *hsr = netdev_priv(dev);
 	struct hsr_port *master;
diff --git a/net/hsr/hsr_netlink.c b/net/hsr/hsr_netlink.c
index d4d1617f4..06282b406 100644
--- a/net/hsr/hsr_netlink.c
+++ b/net/hsr/hsr_netlink.c
@@ -108,7 +108,7 @@ nla_put_failure:
 	return -EMSGSIZE;
 }
 
-static struct rtnl_link_ops hsr_link_ops __read_mostly = {
+static struct rtnl_link_ops hsr_link_ops = {
 	.kind		= "hsr",
 	.maxtype	= IFLA_HSR_MAX,
 	.policy		= hsr_policy,
diff --git a/net/ieee802154/6lowpan/core.c b/net/ieee802154/6lowpan/core.c
index d7efbf0da..2f69b06b1 100644
--- a/net/ieee802154/6lowpan/core.c
+++ b/net/ieee802154/6lowpan/core.c
@@ -182,7 +182,7 @@ static void lowpan_dellink(struct net_device *ldev, struct list_head *head)
 	dev_put(wdev);
 }
 
-static struct rtnl_link_ops lowpan_link_ops __read_mostly = {
+static struct rtnl_link_ops lowpan_link_ops = {
 	.kind		= "lowpan",
 	.priv_size	= LOWPAN_PRIV_SIZE(sizeof(struct lowpan_802154_dev)),
 	.setup		= lowpan_setup,
diff --git a/net/ieee802154/6lowpan/reassembly.c b/net/ieee802154/6lowpan/reassembly.c
index 30d875dff..760f4f1aa 100644
--- a/net/ieee802154/6lowpan/reassembly.c
+++ b/net/ieee802154/6lowpan/reassembly.c
@@ -492,14 +492,13 @@ static struct ctl_table lowpan_frags_ctl_table[] = {
 
 static int __net_init lowpan_frags_ns_sysctl_register(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 	struct ctl_table_header *hdr;
 	struct netns_ieee802154_lowpan *ieee802154_lowpan =
 		net_ieee802154_lowpan(net);
 
-	table = lowpan_frags_ns_ctl_table;
 	if (!net_eq(net, &init_net)) {
-		table = kmemdup(table, sizeof(lowpan_frags_ns_ctl_table),
+		table = kmemdup(lowpan_frags_ns_ctl_table, sizeof(lowpan_frags_ns_ctl_table),
 				GFP_KERNEL);
 		if (table == NULL)
 			goto err_alloc;
@@ -514,9 +513,9 @@ static int __net_init lowpan_frags_ns_sysctl_register(struct net *net)
 		/* Don't export sysctls to unprivileged users */
 		if (net->user_ns != &init_user_ns)
 			table[0].procname = NULL;
-	}
-
-	hdr = register_net_sysctl(net, "net/ieee802154/6lowpan", table);
+		hdr = register_net_sysctl(net, "net/ieee802154/6lowpan", table);
+	} else
+		hdr = register_net_sysctl(net, "net/ieee802154/6lowpan", lowpan_frags_ns_ctl_table);
 	if (hdr == NULL)
 		goto err_reg;
 
@@ -524,8 +523,7 @@ static int __net_init lowpan_frags_ns_sysctl_register(struct net *net)
 	return 0;
 
 err_reg:
-	if (!net_eq(net, &init_net))
-		kfree(table);
+	kfree(table);
 err_alloc:
 	return -ENOMEM;
 }
diff --git a/net/ieee802154/core.c b/net/ieee802154/core.c
index cb7176cd4..afd2c62c0 100644
--- a/net/ieee802154/core.c
+++ b/net/ieee802154/core.c
@@ -110,7 +110,7 @@ struct wpan_phy *wpan_phy_idx_to_wpan_phy(int wpan_phy_idx)
 struct wpan_phy *
 wpan_phy_new(const struct cfg802154_ops *ops, size_t priv_size)
 {
-	static atomic_t wpan_phy_counter = ATOMIC_INIT(0);
+	static atomic_unchecked_t wpan_phy_counter = ATOMIC_INIT(0);
 	struct cfg802154_registered_device *rdev;
 	size_t alloc_size;
 
@@ -121,11 +121,11 @@ wpan_phy_new(const struct cfg802154_ops *ops, size_t priv_size)
 
 	rdev->ops = ops;
 
-	rdev->wpan_phy_idx = atomic_inc_return(&wpan_phy_counter);
+	rdev->wpan_phy_idx = atomic_inc_return_unchecked(&wpan_phy_counter);
 
 	if (unlikely(rdev->wpan_phy_idx < 0)) {
 		/* ugh, wrapped! */
-		atomic_dec(&wpan_phy_counter);
+		atomic_dec_unchecked(&wpan_phy_counter);
 		kfree(rdev);
 		return NULL;
 	}
diff --git a/net/ipv4/af_inet.c b/net/ipv4/af_inet.c
index ed22af67c..0e88bcd25 100644
--- a/net/ipv4/af_inet.c
+++ b/net/ipv4/af_inet.c
@@ -1445,7 +1445,7 @@ int inet_recv_error(struct sock *sk, struct msghdr *msg, int len, int *addr_len)
 		return ip_recv_error(sk, msg, len, addr_len);
 #if IS_ENABLED(CONFIG_IPV6)
 	if (sk->sk_family == AF_INET6)
-		return pingv6_ops.ipv6_recv_error(sk, msg, len, addr_len);
+		return pingv6_ops->ipv6_recv_error(sk, msg, len, addr_len);
 #endif
 	return -EINVAL;
 }
@@ -1655,7 +1655,7 @@ static __net_exit void ipv4_mib_exit_net(struct net *net)
 	free_percpu(net->mib.tcp_statistics);
 }
 
-static __net_initdata struct pernet_operations ipv4_mib_ops = {
+static __net_initconst struct pernet_operations ipv4_mib_ops = {
 	.init = ipv4_mib_init_net,
 	.exit = ipv4_mib_exit_net,
 };
@@ -1696,7 +1696,7 @@ static __net_exit void inet_exit_net(struct net *net)
 {
 }
 
-static __net_initdata struct pernet_operations af_inet_ops = {
+static __net_initconst struct pernet_operations af_inet_ops = {
 	.init = inet_init_net,
 	.exit = inet_exit_net,
 };
diff --git a/net/ipv4/arp.c b/net/ipv4/arp.c
index 89a8cac47..7d3fdc588 100644
--- a/net/ipv4/arp.c
+++ b/net/ipv4/arp.c
@@ -332,7 +332,7 @@ static void arp_solicit(struct neighbour *neigh, struct sk_buff *skb)
 	u8 dst_ha[MAX_ADDR_LEN], *dst_hw = NULL;
 	struct net_device *dev = neigh->dev;
 	__be32 target = *(__be32 *)neigh->primary_key;
-	int probes = atomic_read(&neigh->probes);
+	int probes = atomic_read_unchecked(&neigh->probes);
 	struct in_device *in_dev;
 	struct dst_entry *dst = NULL;
 
diff --git a/net/ipv4/devinet.c b/net/ipv4/devinet.c
index 062a67ca9..cb05c9795 100644
--- a/net/ipv4/devinet.c
+++ b/net/ipv4/devinet.c
@@ -69,7 +69,8 @@
 
 static struct ipv4_devconf ipv4_devconf = {
 	.data = {
-		[IPV4_DEVCONF_ACCEPT_REDIRECTS - 1] = 1,
+		[IPV4_DEVCONF_ACCEPT_REDIRECTS - 1] = 0,
+		[IPV4_DEVCONF_RP_FILTER - 1] = 1,
 		[IPV4_DEVCONF_SEND_REDIRECTS - 1] = 1,
 		[IPV4_DEVCONF_SECURE_REDIRECTS - 1] = 1,
 		[IPV4_DEVCONF_SHARED_MEDIA - 1] = 1,
@@ -80,7 +81,8 @@ static struct ipv4_devconf ipv4_devconf = {
 
 static struct ipv4_devconf ipv4_devconf_dflt = {
 	.data = {
-		[IPV4_DEVCONF_ACCEPT_REDIRECTS - 1] = 1,
+		[IPV4_DEVCONF_ACCEPT_REDIRECTS - 1] = 0,
+		[IPV4_DEVCONF_RP_FILTER - 1] = 1,
 		[IPV4_DEVCONF_SEND_REDIRECTS - 1] = 1,
 		[IPV4_DEVCONF_SECURE_REDIRECTS - 1] = 1,
 		[IPV4_DEVCONF_SHARED_MEDIA - 1] = 1,
@@ -1605,7 +1607,7 @@ static int inet_dump_ifaddr(struct sk_buff *skb, struct netlink_callback *cb)
 		idx = 0;
 		head = &net->dev_index_head[h];
 		rcu_read_lock();
-		cb->seq = atomic_read(&net->ipv4.dev_addr_genid) ^
+		cb->seq = atomic_read_unchecked(&net->ipv4.dev_addr_genid) ^
 			  net->dev_base_seq;
 		hlist_for_each_entry_rcu(dev, head, index_hlist) {
 			if (idx < s_idx)
@@ -1939,7 +1941,7 @@ static int inet_netconf_dump_devconf(struct sk_buff *skb,
 		idx = 0;
 		head = &net->dev_index_head[h];
 		rcu_read_lock();
-		cb->seq = atomic_read(&net->ipv4.dev_addr_genid) ^
+		cb->seq = atomic_read_unchecked(&net->ipv4.dev_addr_genid) ^
 			  net->dev_base_seq;
 		hlist_for_each_entry_rcu(dev, head, index_hlist) {
 			if (idx < s_idx)
@@ -2180,7 +2182,7 @@ static int ipv4_doint_and_flush(struct ctl_table *ctl, int write,
 #define DEVINET_SYSCTL_FLUSHING_ENTRY(attr, name) \
 	DEVINET_SYSCTL_COMPLEX_ENTRY(attr, name, ipv4_doint_and_flush)
 
-static struct devinet_sysctl_table {
+static const struct devinet_sysctl_table {
 	struct ctl_table_header *sysctl_header;
 	struct ctl_table devinet_vars[__IPV4_DEVCONF_MAX];
 } devinet_sysctl = {
@@ -2320,7 +2322,7 @@ static __net_init int devinet_init_net(struct net *net)
 	int err;
 	struct ipv4_devconf *all, *dflt;
 #ifdef CONFIG_SYSCTL
-	struct ctl_table *tbl = ctl_forward_entry;
+	ctl_table_no_const *tbl = NULL;
 	struct ctl_table_header *forw_hdr;
 #endif
 
@@ -2338,7 +2340,7 @@ static __net_init int devinet_init_net(struct net *net)
 			goto err_alloc_dflt;
 
 #ifdef CONFIG_SYSCTL
-		tbl = kmemdup(tbl, sizeof(ctl_forward_entry), GFP_KERNEL);
+		tbl = kmemdup(ctl_forward_entry, sizeof(ctl_forward_entry), GFP_KERNEL);
 		if (!tbl)
 			goto err_alloc_ctl;
 
@@ -2359,7 +2361,10 @@ static __net_init int devinet_init_net(struct net *net)
 		goto err_reg_dflt;
 
 	err = -ENOMEM;
-	forw_hdr = register_net_sysctl(net, "net/ipv4", tbl);
+	if (!net_eq(net, &init_net))
+		forw_hdr = register_net_sysctl(net, "net/ipv4", tbl);
+	else
+		forw_hdr = register_net_sysctl(net, "net/ipv4", ctl_forward_entry);
 	if (!forw_hdr)
 		goto err_reg_ctl;
 	net->ipv4.forw_hdr = forw_hdr;
@@ -2375,8 +2380,7 @@ err_reg_ctl:
 err_reg_dflt:
 	__devinet_sysctl_unregister(all);
 err_reg_all:
-	if (tbl != ctl_forward_entry)
-		kfree(tbl);
+	kfree(tbl);
 err_alloc_ctl:
 #endif
 	if (dflt != &ipv4_devconf_dflt)
@@ -2403,7 +2407,7 @@ static __net_exit void devinet_exit_net(struct net *net)
 	kfree(net->ipv4.devconf_all);
 }
 
-static __net_initdata struct pernet_operations devinet_ops = {
+static __net_initconst struct pernet_operations devinet_ops = {
 	.init = devinet_init_net,
 	.exit = devinet_exit_net,
 };
diff --git a/net/ipv4/fib_frontend.c b/net/ipv4/fib_frontend.c
index 930130852..e164d8d48 100644
--- a/net/ipv4/fib_frontend.c
+++ b/net/ipv4/fib_frontend.c
@@ -1151,12 +1151,12 @@ static int fib_inetaddr_event(struct notifier_block *this, unsigned long event,
 #ifdef CONFIG_IP_ROUTE_MULTIPATH
 		fib_sync_up(dev, RTNH_F_DEAD);
 #endif
-		atomic_inc(&net->ipv4.dev_addr_genid);
+		atomic_inc_unchecked(&net->ipv4.dev_addr_genid);
 		rt_cache_flush(dev_net(dev));
 		break;
 	case NETDEV_DOWN:
 		fib_del_ifaddr(ifa, NULL);
-		atomic_inc(&net->ipv4.dev_addr_genid);
+		atomic_inc_unchecked(&net->ipv4.dev_addr_genid);
 		if (!ifa->ifa_dev->ifa_list) {
 			/* Last address was deleted from this interface.
 			 * Disable IP.
@@ -1196,7 +1196,7 @@ static int fib_netdev_event(struct notifier_block *this, unsigned long event, vo
 #ifdef CONFIG_IP_ROUTE_MULTIPATH
 		fib_sync_up(dev, RTNH_F_DEAD);
 #endif
-		atomic_inc(&net->ipv4.dev_addr_genid);
+		atomic_inc_unchecked(&net->ipv4.dev_addr_genid);
 		rt_cache_flush(net);
 		break;
 	case NETDEV_DOWN:
diff --git a/net/ipv4/fib_semantics.c b/net/ipv4/fib_semantics.c
index e9f56225e..975108bfe 100644
--- a/net/ipv4/fib_semantics.c
+++ b/net/ipv4/fib_semantics.c
@@ -916,7 +916,7 @@ __be32 fib_info_update_nh_saddr(struct net *net, struct fib_nh *nh)
 	nh->nh_saddr = inet_select_addr(nh->nh_dev,
 					nh->nh_gw,
 					nh->nh_parent->fib_scope);
-	nh->nh_saddr_genid = atomic_read(&net->ipv4.dev_addr_genid);
+	nh->nh_saddr_genid = atomic_read_unchecked(&net->ipv4.dev_addr_genid);
 
 	return nh->nh_saddr;
 }
diff --git a/net/ipv4/icmp.c b/net/ipv4/icmp.c
index 48734ee62..3308079e7 100644
--- a/net/ipv4/icmp.c
+++ b/net/ipv4/icmp.c
@@ -1228,7 +1228,7 @@ fail:
 	return err;
 }
 
-static struct pernet_operations __net_initdata icmp_sk_ops = {
+static struct pernet_operations __net_initconst icmp_sk_ops = {
        .init = icmp_sk_init,
        .exit = icmp_sk_exit,
 };
diff --git a/net/ipv4/inet_connection_sock.c b/net/ipv4/inet_connection_sock.c
index 61a9deec2..e3b4a9b20 100644
--- a/net/ipv4/inet_connection_sock.c
+++ b/net/ipv4/inet_connection_sock.c
@@ -666,8 +666,8 @@ struct sock *inet_csk_clone_lock(const struct sock *sk,
 		sock_reset_flag(newsk, SOCK_RCU_FREE);
 
 		newsk->sk_mark = inet_rsk(req)->ir_mark;
-		atomic64_set(&newsk->sk_cookie,
-			     atomic64_read(&inet_rsk(req)->ir_cookie));
+		atomic64_set_unchecked(&newsk->sk_cookie,
+			     atomic64_read_unchecked(&inet_rsk(req)->ir_cookie));
 
 		newicsk->icsk_retransmits = 0;
 		newicsk->icsk_backoff	  = 0;
diff --git a/net/ipv4/inet_diag.c b/net/ipv4/inet_diag.c
index 38c2c47fe..5d8ebc5cc 100644
--- a/net/ipv4/inet_diag.c
+++ b/net/ipv4/inet_diag.c
@@ -1029,7 +1029,7 @@ static int inet_diag_rcv_msg_compat(struct sk_buff *skb, struct nlmsghdr *nlh)
 				return -EINVAL;
 		}
 		{
-			struct netlink_dump_control c = {
+			static struct netlink_dump_control c = {
 				.dump = inet_diag_dump_compat,
 			};
 			return netlink_dump_start(net->diag_nlsk, skb, nlh, &c);
@@ -1060,7 +1060,7 @@ static int inet_diag_handler_cmd(struct sk_buff *skb, struct nlmsghdr *h)
 				return -EINVAL;
 		}
 		{
-			struct netlink_dump_control c = {
+			static struct netlink_dump_control c = {
 				.dump = inet_diag_dump,
 			};
 			return netlink_dump_start(net->diag_nlsk, skb, h, &c);
diff --git a/net/ipv4/inet_hashtables.c b/net/ipv4/inet_hashtables.c
index 77c20a489..76261b66c 100644
--- a/net/ipv4/inet_hashtables.c
+++ b/net/ipv4/inet_hashtables.c
@@ -19,6 +19,7 @@
 #include <linux/slab.h>
 #include <linux/wait.h>
 #include <linux/vmalloc.h>
+#include <linux/security.h>
 
 #include <net/addrconf.h>
 #include <net/inet_connection_sock.h>
@@ -56,6 +57,8 @@ u32 sk_ehashfn(const struct sock *sk)
 			    sk->sk_daddr, sk->sk_dport);
 }
 
+extern void gr_update_task_in_ip_table(const struct inet_sock *inet);
+
 /*
  * Allocate and initialize a new local port bind bucket.
  * The bindhash mutex for snum's hash chain must be held here.
@@ -642,6 +645,9 @@ ok:
 	spin_unlock(&head->lock);
 	if (tw)
 		inet_twsk_deschedule_put(tw);
+
+	gr_update_task_in_ip_table(inet_sk(sk));
+
 	local_bh_enable();
 	return 0;
 }
diff --git a/net/ipv4/inet_timewait_sock.c b/net/ipv4/inet_timewait_sock.c
index ddcd56c08..b2f4a52b1 100644
--- a/net/ipv4/inet_timewait_sock.c
+++ b/net/ipv4/inet_timewait_sock.c
@@ -186,7 +186,7 @@ struct inet_timewait_sock *inet_twsk_alloc(const struct sock *sk,
 		tw->tw_ipv6only	    = 0;
 		tw->tw_transparent  = inet->transparent;
 		tw->tw_prot	    = sk->sk_prot_creator;
-		atomic64_set(&tw->tw_cookie, atomic64_read(&sk->sk_cookie));
+		atomic64_set_unchecked(&tw->tw_cookie, atomic64_read_unchecked(&sk->sk_cookie));
 		twsk_net_set(tw, sock_net(sk));
 		setup_pinned_timer(&tw->tw_timer, tw_timer_handler,
 				   (unsigned long)tw);
diff --git a/net/ipv4/inetpeer.c b/net/ipv4/inetpeer.c
index 86fa45809..5f601b977 100644
--- a/net/ipv4/inetpeer.c
+++ b/net/ipv4/inetpeer.c
@@ -445,7 +445,7 @@ relookup:
 	if (p) {
 		p->daddr = *daddr;
 		atomic_set(&p->refcnt, 1);
-		atomic_set(&p->rid, 0);
+		atomic_set_unchecked(&p->rid, 0);
 		p->metrics[RTAX_LOCK-1] = INETPEER_METRICS_NEW;
 		p->rate_tokens = 0;
 		/* 60*HZ is arbitrary, but chosen enough high so that the first
diff --git a/net/ipv4/ip_fragment.c b/net/ipv4/ip_fragment.c
index bbe7f72db..7a5a57f2f 100644
--- a/net/ipv4/ip_fragment.c
+++ b/net/ipv4/ip_fragment.c
@@ -282,7 +282,7 @@ static int ip_frag_too_far(struct ipq *qp)
 		return 0;
 
 	start = qp->rid;
-	end = atomic_inc_return(&peer->rid);
+	end = atomic_inc_return_unchecked(&peer->rid);
 	qp->rid = end;
 
 	rc = qp->q.fragments && (end - start) > max;
@@ -773,12 +773,11 @@ static struct ctl_table ip4_frags_ctl_table[] = {
 
 static int __net_init ip4_frags_ns_ctl_register(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 	struct ctl_table_header *hdr;
 
-	table = ip4_frags_ns_ctl_table;
 	if (!net_eq(net, &init_net)) {
-		table = kmemdup(table, sizeof(ip4_frags_ns_ctl_table), GFP_KERNEL);
+		table = kmemdup(ip4_frags_ns_ctl_table, sizeof(ip4_frags_ns_ctl_table), GFP_KERNEL);
 		if (!table)
 			goto err_alloc;
 
@@ -789,9 +788,10 @@ static int __net_init ip4_frags_ns_ctl_register(struct net *net)
 		table[1].extra2 = &net->ipv4.frags.high_thresh;
 		table[2].data = &net->ipv4.frags.timeout;
 		table[3].data = &net->ipv4.frags.max_dist;
-	}
-
-	hdr = register_net_sysctl(net, "net/ipv4", table);
+		hdr = register_net_sysctl(net, "net/ipv4", table);
+	} else
+		hdr = register_net_sysctl(net, "net/ipv4", ip4_frags_ns_ctl_table);
+ 
 	if (!hdr)
 		goto err_reg;
 
@@ -799,8 +799,7 @@ static int __net_init ip4_frags_ns_ctl_register(struct net *net)
 	return 0;
 
 err_reg:
-	if (!net_eq(net, &init_net))
-		kfree(table);
+	kfree(table);
 err_alloc:
 	return -ENOMEM;
 }
diff --git a/net/ipv4/ip_gre.c b/net/ipv4/ip_gre.c
index 113cc43df..9f8987674 100644
--- a/net/ipv4/ip_gre.c
+++ b/net/ipv4/ip_gre.c
@@ -110,7 +110,7 @@ static bool log_ecn_error = true;
 module_param(log_ecn_error, bool, 0644);
 MODULE_PARM_DESC(log_ecn_error, "Log packets received with corrupted ECN");
 
-static struct rtnl_link_ops ipgre_link_ops __read_mostly;
+static struct rtnl_link_ops ipgre_link_ops;
 static int ipgre_tunnel_init(struct net_device *dev);
 
 static int ipgre_net_id __read_mostly;
@@ -1114,7 +1114,7 @@ static const struct nla_policy ipgre_policy[IFLA_GRE_MAX + 1] = {
 	[IFLA_GRE_IGNORE_DF]	= { .type = NLA_U8 },
 };
 
-static struct rtnl_link_ops ipgre_link_ops __read_mostly = {
+static struct rtnl_link_ops ipgre_link_ops = {
 	.kind		= "gre",
 	.maxtype	= IFLA_GRE_MAX,
 	.policy		= ipgre_policy,
@@ -1129,7 +1129,7 @@ static struct rtnl_link_ops ipgre_link_ops __read_mostly = {
 	.get_link_net	= ip_tunnel_get_link_net,
 };
 
-static struct rtnl_link_ops ipgre_tap_ops __read_mostly = {
+static struct rtnl_link_ops ipgre_tap_ops = {
 	.kind		= "gretap",
 	.maxtype	= IFLA_GRE_MAX,
 	.policy		= ipgre_policy,
diff --git a/net/ipv4/ip_input.c b/net/ipv4/ip_input.c
index d6feabb03..9cb3988a2 100644
--- a/net/ipv4/ip_input.c
+++ b/net/ipv4/ip_input.c
@@ -148,6 +148,10 @@
 #include <linux/netlink.h>
 #include <net/dst_metadata.h>
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 /*
  *	Process Router Attention IP option (RFC 2113)
  */
@@ -223,6 +227,9 @@ static int ip_local_deliver_finish(struct net *net, struct sock *sk, struct sk_b
 			if (!raw) {
 				if (xfrm4_policy_check(NULL, XFRM_POLICY_IN, skb)) {
 					__IP_INC_STATS(net, IPSTATS_MIB_INUNKNOWNPROTOS);
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+					if (!grsec_enable_blackhole || (skb->dev->flags & IFF_LOOPBACK))
+#endif
 					icmp_send(skb, ICMP_DEST_UNREACH,
 						  ICMP_PROT_UNREACH, 0);
 				}
diff --git a/net/ipv4/ip_sockglue.c b/net/ipv4/ip_sockglue.c
index 11ef96e21..69017062d 100644
--- a/net/ipv4/ip_sockglue.c
+++ b/net/ipv4/ip_sockglue.c
@@ -1326,7 +1326,8 @@ static int do_ip_getsockopt(struct sock *sk, int level, int optname,
 		len = min_t(unsigned int, len, opt->optlen);
 		if (put_user(len, optlen))
 			return -EFAULT;
-		if (copy_to_user(optval, opt->__data, len))
+		if ((len > (sizeof(optbuf) - sizeof(struct ip_options))) ||
+		    copy_to_user(optval, opt->__data, len))
 			return -EFAULT;
 		return 0;
 	}
@@ -1462,7 +1463,7 @@ static int do_ip_getsockopt(struct sock *sk, int level, int optname,
 		if (sk->sk_type != SOCK_STREAM)
 			return -ENOPROTOOPT;
 
-		msg.msg_control = (__force void *) optval;
+		msg.msg_control = (__force_kernel void *) optval;
 		msg.msg_controllen = len;
 		msg.msg_flags = flags;
 
diff --git a/net/ipv4/ip_vti.c b/net/ipv4/ip_vti.c
index 5d7944f39..f7953fe62 100644
--- a/net/ipv4/ip_vti.c
+++ b/net/ipv4/ip_vti.c
@@ -44,7 +44,7 @@
 #include <net/net_namespace.h>
 #include <net/netns/generic.h>
 
-static struct rtnl_link_ops vti_link_ops __read_mostly;
+static struct rtnl_link_ops vti_link_ops;
 
 static int vti_net_id __read_mostly;
 static int vti_tunnel_init(struct net_device *dev);
@@ -555,7 +555,7 @@ static const struct nla_policy vti_policy[IFLA_VTI_MAX + 1] = {
 	[IFLA_VTI_REMOTE]	= { .len = FIELD_SIZEOF(struct iphdr, daddr) },
 };
 
-static struct rtnl_link_ops vti_link_ops __read_mostly = {
+static struct rtnl_link_ops vti_link_ops = {
 	.kind		= "vti",
 	.maxtype	= IFLA_VTI_MAX,
 	.policy		= vti_policy,
@@ -593,7 +593,7 @@ static int vti_device_event(struct notifier_block *unused,
 	return NOTIFY_DONE;
 }
 
-static struct notifier_block vti_notifier_block __read_mostly = {
+static notifier_block_no_const vti_notifier_block __read_only = {
 	.notifier_call = vti_device_event,
 };
 
diff --git a/net/ipv4/ipconfig.c b/net/ipv4/ipconfig.c
index 1d71c40ea..3f8a6fad4 100644
--- a/net/ipv4/ipconfig.c
+++ b/net/ipv4/ipconfig.c
@@ -334,7 +334,7 @@ static int __init ic_devinet_ioctl(unsigned int cmd, struct ifreq *arg)
 
 	mm_segment_t oldfs = get_fs();
 	set_fs(get_ds());
-	res = devinet_ioctl(&init_net, cmd, (struct ifreq __user *) arg);
+	res = devinet_ioctl(&init_net, cmd, (struct ifreq __force_user *) arg);
 	set_fs(oldfs);
 	return res;
 }
@@ -345,7 +345,7 @@ static int __init ic_dev_ioctl(unsigned int cmd, struct ifreq *arg)
 
 	mm_segment_t oldfs = get_fs();
 	set_fs(get_ds());
-	res = dev_ioctl(&init_net, cmd, (struct ifreq __user *) arg);
+	res = dev_ioctl(&init_net, cmd, (struct ifreq __force_user *) arg);
 	set_fs(oldfs);
 	return res;
 }
@@ -356,7 +356,7 @@ static int __init ic_route_ioctl(unsigned int cmd, struct rtentry *arg)
 
 	mm_segment_t oldfs = get_fs();
 	set_fs(get_ds());
-	res = ip_rt_ioctl(&init_net, cmd, (void __user *) arg);
+	res = ip_rt_ioctl(&init_net, cmd, (void __force_user *) arg);
 	set_fs(oldfs);
 	return res;
 }
diff --git a/net/ipv4/ipip.c b/net/ipv4/ipip.c
index 4ae3f8e6c..bd0ea7289 100644
--- a/net/ipv4/ipip.c
+++ b/net/ipv4/ipip.c
@@ -123,7 +123,7 @@ MODULE_PARM_DESC(log_ecn_error, "Log packets received with corrupted ECN");
 static int ipip_net_id __read_mostly;
 
 static int ipip_tunnel_init(struct net_device *dev);
-static struct rtnl_link_ops ipip_link_ops __read_mostly;
+static struct rtnl_link_ops ipip_link_ops;
 
 static int ipip_err(struct sk_buff *skb, u32 info)
 {
@@ -564,7 +564,7 @@ static const struct nla_policy ipip_policy[IFLA_IPTUN_MAX + 1] = {
 	[IFLA_IPTUN_ENCAP_DPORT]	= { .type = NLA_U16 },
 };
 
-static struct rtnl_link_ops ipip_link_ops __read_mostly = {
+static struct rtnl_link_ops ipip_link_ops = {
 	.kind		= "ipip",
 	.maxtype	= IFLA_IPTUN_MAX,
 	.policy		= ipip_policy,
diff --git a/net/ipv4/netfilter/arp_tables.c b/net/ipv4/netfilter/arp_tables.c
index b31df597f..76740d38a 100644
--- a/net/ipv4/netfilter/arp_tables.c
+++ b/net/ipv4/netfilter/arp_tables.c
@@ -790,13 +790,13 @@ static int compat_table_info(const struct xt_table_info *info,
 #endif
 
 static int get_info(struct net *net, void __user *user,
-		    const int *len, int compat)
+		    int len, int compat)
 {
 	char name[XT_TABLE_MAXNAMELEN];
 	struct xt_table *t;
 	int ret;
 
-	if (*len != sizeof(struct arpt_getinfo))
+	if (len != sizeof(struct arpt_getinfo))
 		return -EINVAL;
 
 	if (copy_from_user(name, user, sizeof(name)) != 0)
@@ -831,7 +831,7 @@ static int get_info(struct net *net, void __user *user,
 		info.size = private->size;
 		strcpy(info.name, name);
 
-		if (copy_to_user(user, &info, *len) != 0)
+		if (copy_to_user(user, &info, len) != 0)
 			ret = -EFAULT;
 		else
 			ret = 0;
@@ -1441,7 +1441,7 @@ static int compat_do_arpt_get_ctl(struct sock *sk, int cmd, void __user *user,
 
 	switch (cmd) {
 	case ARPT_SO_GET_INFO:
-		ret = get_info(sock_net(sk), user, len, 1);
+		ret = get_info(sock_net(sk), user, *len, 1);
 		break;
 	case ARPT_SO_GET_ENTRIES:
 		ret = compat_get_entries(sock_net(sk), user, len);
@@ -1485,7 +1485,7 @@ static int do_arpt_get_ctl(struct sock *sk, int cmd, void __user *user, int *len
 
 	switch (cmd) {
 	case ARPT_SO_GET_INFO:
-		ret = get_info(sock_net(sk), user, len, 0);
+		ret = get_info(sock_net(sk), user, *len, 0);
 		break;
 
 	case ARPT_SO_GET_ENTRIES:
diff --git a/net/ipv4/netfilter/ip_tables.c b/net/ipv4/netfilter/ip_tables.c
index f993545a3..e98f20893 100644
--- a/net/ipv4/netfilter/ip_tables.c
+++ b/net/ipv4/netfilter/ip_tables.c
@@ -958,13 +958,13 @@ static int compat_table_info(const struct xt_table_info *info,
 #endif
 
 static int get_info(struct net *net, void __user *user,
-		    const int *len, int compat)
+		    int len, int compat)
 {
 	char name[XT_TABLE_MAXNAMELEN];
 	struct xt_table *t;
 	int ret;
 
-	if (*len != sizeof(struct ipt_getinfo))
+	if (len != sizeof(struct ipt_getinfo))
 		return -EINVAL;
 
 	if (copy_from_user(name, user, sizeof(name)) != 0)
@@ -999,7 +999,7 @@ static int get_info(struct net *net, void __user *user,
 		info.size = private->size;
 		strcpy(info.name, name);
 
-		if (copy_to_user(user, &info, *len) != 0)
+		if (copy_to_user(user, &info, len) != 0)
 			ret = -EFAULT;
 		else
 			ret = 0;
@@ -1662,7 +1662,7 @@ compat_do_ipt_get_ctl(struct sock *sk, int cmd, void __user *user, int *len)
 
 	switch (cmd) {
 	case IPT_SO_GET_INFO:
-		ret = get_info(sock_net(sk), user, len, 1);
+		ret = get_info(sock_net(sk), user, *len, 1);
 		break;
 	case IPT_SO_GET_ENTRIES:
 		ret = compat_get_entries(sock_net(sk), user, len);
@@ -1708,7 +1708,7 @@ do_ipt_get_ctl(struct sock *sk, int cmd, void __user *user, int *len)
 
 	switch (cmd) {
 	case IPT_SO_GET_INFO:
-		ret = get_info(sock_net(sk), user, len, 0);
+		ret = get_info(sock_net(sk), user, *len, 0);
 		break;
 
 	case IPT_SO_GET_ENTRIES:
diff --git a/net/ipv4/netfilter/ipt_CLUSTERIP.c b/net/ipv4/netfilter/ipt_CLUSTERIP.c
index 4a9e6db9d..06174e18b 100644
--- a/net/ipv4/netfilter/ipt_CLUSTERIP.c
+++ b/net/ipv4/netfilter/ipt_CLUSTERIP.c
@@ -730,7 +730,7 @@ static int clusterip_net_init(struct net *net)
 	spin_lock_init(&cn->lock);
 
 #ifdef CONFIG_PROC_FS
-	cn->procdir = proc_mkdir("ipt_CLUSTERIP", net->proc_net);
+	cn->procdir = proc_mkdir_restrict("ipt_CLUSTERIP", net->proc_net);
 	if (!cn->procdir) {
 		pr_err("Unable to proc dir entry\n");
 		return -ENOMEM;
diff --git a/net/ipv4/ping.c b/net/ipv4/ping.c
index dcdd5aed7..2b7b5a20d 100644
--- a/net/ipv4/ping.c
+++ b/net/ipv4/ping.c
@@ -59,7 +59,7 @@ struct ping_table {
 };
 
 static struct ping_table ping_table;
-struct pingv6_ops pingv6_ops;
+struct pingv6_ops *pingv6_ops;
 EXPORT_SYMBOL_GPL(pingv6_ops);
 
 static u16 ping_port_rover;
@@ -361,7 +361,7 @@ static int ping_check_bind_addr(struct sock *sk, struct inet_sock *isk,
 				return -ENODEV;
 			}
 		}
-		has_addr = pingv6_ops.ipv6_chk_addr(net, &addr->sin6_addr, dev,
+		has_addr = pingv6_ops->ipv6_chk_addr(net, &addr->sin6_addr, dev,
 						    scoped);
 		rcu_read_unlock();
 
@@ -570,7 +570,7 @@ void ping_err(struct sk_buff *skb, int offset, u32 info)
 		}
 #if IS_ENABLED(CONFIG_IPV6)
 	} else if (skb->protocol == htons(ETH_P_IPV6)) {
-		harderr = pingv6_ops.icmpv6_err_convert(type, code, &err);
+		harderr = pingv6_ops->icmpv6_err_convert(type, code, &err);
 #endif
 	}
 
@@ -588,7 +588,7 @@ void ping_err(struct sk_buff *skb, int offset, u32 info)
 				      info, (u8 *)icmph);
 #if IS_ENABLED(CONFIG_IPV6)
 		} else if (family == AF_INET6) {
-			pingv6_ops.ipv6_icmp_error(sk, skb, err, 0,
+			pingv6_ops->ipv6_icmp_error(sk, skb, err, 0,
 						   info, (u8 *)icmph);
 #endif
 		}
@@ -928,10 +928,10 @@ int ping_recvmsg(struct sock *sk, struct msghdr *msg, size_t len, int noblock,
 		}
 
 		if (inet6_sk(sk)->rxopt.all)
-			pingv6_ops.ip6_datagram_recv_common_ctl(sk, msg, skb);
+			pingv6_ops->ip6_datagram_recv_common_ctl(sk, msg, skb);
 		if (skb->protocol == htons(ETH_P_IPV6) &&
 		    inet6_sk(sk)->rxopt.all)
-			pingv6_ops.ip6_datagram_recv_specific_ctl(sk, msg, skb);
+			pingv6_ops->ip6_datagram_recv_specific_ctl(sk, msg, skb);
 		else if (skb->protocol == htons(ETH_P_IP) && isk->cmsg_flags)
 			ip_cmsg_recv(msg, skb);
 #endif
@@ -1128,7 +1128,7 @@ static void ping_v4_format_sock(struct sock *sp, struct seq_file *f,
 		from_kuid_munged(seq_user_ns(f), sock_i_uid(sp)),
 		0, sock_i_ino(sp),
 		atomic_read(&sp->sk_refcnt), sp,
-		atomic_read(&sp->sk_drops));
+		atomic_read_unchecked(&sp->sk_drops));
 }
 
 static int ping_v4_seq_show(struct seq_file *seq, void *v)
diff --git a/net/ipv4/proc.c b/net/ipv4/proc.c
index 9f665b63a..5900faece 100644
--- a/net/ipv4/proc.c
+++ b/net/ipv4/proc.c
@@ -333,7 +333,7 @@ static void icmpmsg_put(struct seq_file *seq)
 
 	count = 0;
 	for (i = 0; i < ICMPMSG_MIB_MAX; i++) {
-		val = atomic_long_read(&net->mib.icmpmsg_statistics->mibs[i]);
+		val = atomic_long_read_unchecked(&net->mib.icmpmsg_statistics->mibs[i]);
 		if (val) {
 			type[count] = i;
 			vals[count++] = val;
@@ -352,7 +352,7 @@ static void icmp_put(struct seq_file *seq)
 {
 	int i;
 	struct net *net = seq->private;
-	atomic_long_t *ptr = net->mib.icmpmsg_statistics->mibs;
+	atomic_long_unchecked_t *ptr = net->mib.icmpmsg_statistics->mibs;
 
 	seq_puts(seq, "\nIcmp: InMsgs InErrors InCsumErrors");
 	for (i = 0; icmpmibmap[i].name != NULL; i++)
@@ -366,13 +366,13 @@ static void icmp_put(struct seq_file *seq)
 		snmp_fold_field(net->mib.icmp_statistics, ICMP_MIB_CSUMERRORS));
 	for (i = 0; icmpmibmap[i].name != NULL; i++)
 		seq_printf(seq, " %lu",
-			   atomic_long_read(ptr + icmpmibmap[i].index));
+			   atomic_long_read_unchecked(ptr + icmpmibmap[i].index));
 	seq_printf(seq, " %lu %lu",
 		snmp_fold_field(net->mib.icmp_statistics, ICMP_MIB_OUTMSGS),
 		snmp_fold_field(net->mib.icmp_statistics, ICMP_MIB_OUTERRORS));
 	for (i = 0; icmpmibmap[i].name != NULL; i++)
 		seq_printf(seq, " %lu",
-			   atomic_long_read(ptr + (icmpmibmap[i].index | 0x100)));
+			   atomic_long_read_unchecked(ptr + (icmpmibmap[i].index | 0x100)));
 }
 
 /*
@@ -532,7 +532,7 @@ static __net_exit void ip_proc_exit_net(struct net *net)
 	remove_proc_entry("sockstat", net->proc_net);
 }
 
-static __net_initdata struct pernet_operations ip_proc_ops = {
+static __net_initconst struct pernet_operations ip_proc_ops = {
 	.init = ip_proc_init_net,
 	.exit = ip_proc_exit_net,
 };
diff --git a/net/ipv4/raw.c b/net/ipv4/raw.c
index 438f50c1a..96538dd15 100644
--- a/net/ipv4/raw.c
+++ b/net/ipv4/raw.c
@@ -325,7 +325,7 @@ static int raw_rcv_skb(struct sock *sk, struct sk_buff *skb)
 int raw_rcv(struct sock *sk, struct sk_buff *skb)
 {
 	if (!xfrm4_policy_check(sk, XFRM_POLICY_IN, skb)) {
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		kfree_skb(skb);
 		return NET_RX_DROP;
 	}
@@ -786,16 +786,20 @@ static int raw_init(struct sock *sk)
 
 static int raw_seticmpfilter(struct sock *sk, char __user *optval, int optlen)
 {
+	struct icmp_filter filter;
+
 	if (optlen > sizeof(struct icmp_filter))
 		optlen = sizeof(struct icmp_filter);
-	if (copy_from_user(&raw_sk(sk)->filter, optval, optlen))
+	if (copy_from_user(&filter, optval, optlen))
 		return -EFAULT;
+	raw_sk(sk)->filter = filter;
 	return 0;
 }
 
 static int raw_geticmpfilter(struct sock *sk, char __user *optval, int __user *optlen)
 {
 	int len, ret = -EFAULT;
+	struct icmp_filter filter;
 
 	if (get_user(len, optlen))
 		goto out;
@@ -805,8 +809,8 @@ static int raw_geticmpfilter(struct sock *sk, char __user *optval, int __user *o
 	if (len > sizeof(struct icmp_filter))
 		len = sizeof(struct icmp_filter);
 	ret = -EFAULT;
-	if (put_user(len, optlen) ||
-	    copy_to_user(optval, &raw_sk(sk)->filter, len))
+	filter = raw_sk(sk)->filter;
+	if (put_user(len, optlen) || len > sizeof filter || copy_to_user(optval, &filter, len))
 		goto out;
 	ret = 0;
 out:	return ret;
@@ -1035,7 +1039,7 @@ static void raw_sock_seq_show(struct seq_file *seq, struct sock *sp, int i)
 		0, 0L, 0,
 		from_kuid_munged(seq_user_ns(seq), sock_i_uid(sp)),
 		0, sock_i_ino(sp),
-		atomic_read(&sp->sk_refcnt), sp, atomic_read(&sp->sk_drops));
+		atomic_read(&sp->sk_refcnt), sp, atomic_read_unchecked(&sp->sk_drops));
 }
 
 static int raw_seq_show(struct seq_file *seq, void *v)
@@ -1098,7 +1102,7 @@ static __net_exit void raw_exit_net(struct net *net)
 	remove_proc_entry("raw", net->proc_net);
 }
 
-static __net_initdata struct pernet_operations raw_net_ops = {
+static __net_initconst struct pernet_operations raw_net_ops = {
 	.init = raw_init_net,
 	.exit = raw_exit_net,
 };
diff --git a/net/ipv4/route.c b/net/ipv4/route.c
index 2f23ef1a8..85c2f0dbb 100644
--- a/net/ipv4/route.c
+++ b/net/ipv4/route.c
@@ -232,7 +232,7 @@ static const struct seq_operations rt_cache_seq_ops = {
 
 static int rt_cache_seq_open(struct inode *inode, struct file *file)
 {
-	return seq_open(file, &rt_cache_seq_ops);
+	return seq_open_restrict(file, &rt_cache_seq_ops);
 }
 
 static const struct file_operations rt_cache_seq_fops = {
@@ -323,7 +323,7 @@ static const struct seq_operations rt_cpu_seq_ops = {
 
 static int rt_cpu_seq_open(struct inode *inode, struct file *file)
 {
-	return seq_open(file, &rt_cpu_seq_ops);
+	return seq_open_restrict(file, &rt_cpu_seq_ops);
 }
 
 static const struct file_operations rt_cpu_seq_fops = {
@@ -361,7 +361,7 @@ static int rt_acct_proc_show(struct seq_file *m, void *v)
 
 static int rt_acct_proc_open(struct inode *inode, struct file *file)
 {
-	return single_open(file, rt_acct_proc_show, NULL);
+	return single_open_restrict(file, rt_acct_proc_show, NULL);
 }
 
 static const struct file_operations rt_acct_proc_fops = {
@@ -413,7 +413,7 @@ static void __net_exit ip_rt_do_proc_exit(struct net *net)
 #endif
 }
 
-static struct pernet_operations ip_rt_proc_ops __net_initdata =  {
+static struct pernet_operations ip_rt_proc_ops __net_initconst =  {
 	.init = ip_rt_do_proc_init,
 	.exit = ip_rt_do_proc_exit,
 };
@@ -463,7 +463,7 @@ static struct neighbour *ipv4_neigh_lookup(const struct dst_entry *dst,
 
 #define IP_IDENTS_SZ 2048u
 
-static atomic_t *ip_idents __read_mostly;
+static atomic_t ip_idents[IP_IDENTS_SZ] __read_mostly;
 static u32 *ip_tstamps __read_mostly;
 
 /* In order to protect privacy, we add a perturbation to identifiers
@@ -2781,34 +2781,34 @@ static struct ctl_table ipv4_route_flush_table[] = {
 		.maxlen		= sizeof(int),
 		.mode		= 0200,
 		.proc_handler	= ipv4_sysctl_rtcache_flush,
+		.extra1		= &init_net,
 	},
 	{ },
 };
 
 static __net_init int sysctl_route_net_init(struct net *net)
 {
-	struct ctl_table *tbl;
+	ctl_table_no_const *tbl = NULL;
 
-	tbl = ipv4_route_flush_table;
 	if (!net_eq(net, &init_net)) {
-		tbl = kmemdup(tbl, sizeof(ipv4_route_flush_table), GFP_KERNEL);
+		tbl = kmemdup(ipv4_route_flush_table, sizeof(ipv4_route_flush_table), GFP_KERNEL);
 		if (!tbl)
 			goto err_dup;
 
 		/* Don't export sysctls to unprivileged users */
 		if (net->user_ns != &init_user_ns)
 			tbl[0].procname = NULL;
-	}
-	tbl[0].extra1 = net;
+		tbl[0].extra1 = net;
+		net->ipv4.route_hdr = register_net_sysctl(net, "net/ipv4/route", tbl);
+	} else
+		net->ipv4.route_hdr = register_net_sysctl(net, "net/ipv4/route", ipv4_route_flush_table);
 
-	net->ipv4.route_hdr = register_net_sysctl(net, "net/ipv4/route", tbl);
 	if (!net->ipv4.route_hdr)
 		goto err_reg;
 	return 0;
 
 err_reg:
-	if (tbl != ipv4_route_flush_table)
-		kfree(tbl);
+	kfree(tbl);
 err_dup:
 	return -ENOMEM;
 }
@@ -2823,7 +2823,7 @@ static __net_exit void sysctl_route_net_exit(struct net *net)
 	kfree(tbl);
 }
 
-static __net_initdata struct pernet_operations sysctl_route_ops = {
+static __net_initconst struct pernet_operations sysctl_route_ops = {
 	.init = sysctl_route_net_init,
 	.exit = sysctl_route_net_exit,
 };
@@ -2831,14 +2831,14 @@ static __net_initdata struct pernet_operations sysctl_route_ops = {
 
 static __net_init int rt_genid_init(struct net *net)
 {
-	atomic_set(&net->ipv4.rt_genid, 0);
-	atomic_set(&net->fnhe_genid, 0);
+	atomic_set_unchecked(&net->ipv4.rt_genid, 0);
+	atomic_set_unchecked(&net->fnhe_genid, 0);
 	get_random_bytes(&net->ipv4.dev_addr_genid,
 			 sizeof(net->ipv4.dev_addr_genid));
 	return 0;
 }
 
-static __net_initdata struct pernet_operations rt_genid_ops = {
+static __net_initconst struct pernet_operations rt_genid_ops = {
 	.init = rt_genid_init,
 };
 
@@ -2862,7 +2862,7 @@ static void __net_exit ipv4_inetpeer_exit(struct net *net)
 	kfree(bp);
 }
 
-static __net_initdata struct pernet_operations ipv4_inetpeer_ops = {
+static __net_initconst struct pernet_operations ipv4_inetpeer_ops = {
 	.init	=	ipv4_inetpeer_init,
 	.exit	=	ipv4_inetpeer_exit,
 };
@@ -2876,11 +2876,7 @@ int __init ip_rt_init(void)
 	int rc = 0;
 	int cpu;
 
-	ip_idents = kmalloc(IP_IDENTS_SZ * sizeof(*ip_idents), GFP_KERNEL);
-	if (!ip_idents)
-		panic("IP: failed to allocate ip_idents\n");
-
-	prandom_bytes(ip_idents, IP_IDENTS_SZ * sizeof(*ip_idents));
+	prandom_bytes(ip_idents, sizeof(ip_idents));
 
 	ip_tstamps = kcalloc(IP_IDENTS_SZ, sizeof(*ip_tstamps), GFP_KERNEL);
 	if (!ip_tstamps)
diff --git a/net/ipv4/sysctl_net_ipv4.c b/net/ipv4/sysctl_net_ipv4.c
index 80bc36b25..d70d6220b 100644
--- a/net/ipv4/sysctl_net_ipv4.c
+++ b/net/ipv4/sysctl_net_ipv4.c
@@ -66,7 +66,7 @@ static int ipv4_local_port_range(struct ctl_table *table, int write,
 		container_of(table->data, struct net, ipv4.ip_local_ports.range);
 	int ret;
 	int range[2];
-	struct ctl_table tmp = {
+	ctl_table_no_const tmp = {
 		.data = &range,
 		.maxlen = sizeof(range),
 		.mode = table->mode,
@@ -124,7 +124,7 @@ static int ipv4_ping_group_range(struct ctl_table *table, int write,
 	int ret;
 	gid_t urange[2];
 	kgid_t low, high;
-	struct ctl_table tmp = {
+	ctl_table_no_const tmp = {
 		.data = &urange,
 		.maxlen = sizeof(urange),
 		.mode = table->mode,
@@ -155,7 +155,7 @@ static int proc_tcp_congestion_control(struct ctl_table *ctl, int write,
 				       void __user *buffer, size_t *lenp, loff_t *ppos)
 {
 	char val[TCP_CA_NAME_MAX];
-	struct ctl_table tbl = {
+	ctl_table_no_const tbl = {
 		.data = val,
 		.maxlen = TCP_CA_NAME_MAX,
 	};
@@ -174,7 +174,7 @@ static int proc_tcp_available_congestion_control(struct ctl_table *ctl,
 						 void __user *buffer, size_t *lenp,
 						 loff_t *ppos)
 {
-	struct ctl_table tbl = { .maxlen = TCP_CA_BUF_MAX, };
+	ctl_table_no_const tbl = { .maxlen = TCP_CA_BUF_MAX, };
 	int ret;
 
 	tbl.data = kmalloc(tbl.maxlen, GFP_USER);
@@ -191,7 +191,7 @@ static int proc_allowed_congestion_control(struct ctl_table *ctl,
 					   void __user *buffer, size_t *lenp,
 					   loff_t *ppos)
 {
-	struct ctl_table tbl = { .maxlen = TCP_CA_BUF_MAX };
+	ctl_table_no_const tbl = { .maxlen = TCP_CA_BUF_MAX };
 	int ret;
 
 	tbl.data = kmalloc(tbl.maxlen, GFP_USER);
@@ -210,7 +210,7 @@ static int proc_tcp_fastopen_key(struct ctl_table *ctl, int write,
 				 void __user *buffer, size_t *lenp,
 				 loff_t *ppos)
 {
-	struct ctl_table tbl = { .maxlen = (TCP_FASTOPEN_KEY_LENGTH * 2 + 10) };
+	ctl_table_no_const tbl = { .maxlen = (TCP_FASTOPEN_KEY_LENGTH * 2 + 10) };
 	struct tcp_fastopen_context *ctxt;
 	int ret;
 	u32  user_key[4]; /* 16 bytes, matching TCP_FASTOPEN_KEY_LENGTH */
@@ -976,13 +976,12 @@ static struct ctl_table ipv4_net_table[] = {
 
 static __net_init int ipv4_sysctl_init_net(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 
-	table = ipv4_net_table;
 	if (!net_eq(net, &init_net)) {
 		int i;
 
-		table = kmemdup(table, sizeof(ipv4_net_table), GFP_KERNEL);
+		table = kmemdup(ipv4_net_table, sizeof(ipv4_net_table), GFP_KERNEL);
 		if (!table)
 			goto err_alloc;
 
@@ -991,7 +990,10 @@ static __net_init int ipv4_sysctl_init_net(struct net *net)
 			table[i].data += (void *)net - (void *)&init_net;
 	}
 
-	net->ipv4.ipv4_hdr = register_net_sysctl(net, "net/ipv4", table);
+	if (!net_eq(net, &init_net))
+		net->ipv4.ipv4_hdr = register_net_sysctl(net, "net/ipv4", table);
+	else
+		net->ipv4.ipv4_hdr = register_net_sysctl(net, "net/ipv4", ipv4_net_table);
 	if (!net->ipv4.ipv4_hdr)
 		goto err_reg;
 
@@ -1020,7 +1022,7 @@ static __net_exit void ipv4_sysctl_exit_net(struct net *net)
 	kfree(table);
 }
 
-static __net_initdata struct pernet_operations ipv4_sysctl_ops = {
+static __net_initconst struct pernet_operations ipv4_sysctl_ops = {
 	.init = ipv4_sysctl_init_net,
 	.exit = ipv4_sysctl_exit_net,
 };
diff --git a/net/ipv4/tcp_input.c b/net/ipv4/tcp_input.c
index a756b8749..7237f19c9 100644
--- a/net/ipv4/tcp_input.c
+++ b/net/ipv4/tcp_input.c
@@ -268,11 +268,13 @@ static void tcp_ecn_rcv_synack(struct tcp_sock *tp, const struct tcphdr *th)
 		tp->ecn_flags &= ~TCP_ECN_OK;
 }
 
+#ifndef CONFIG_GRKERNSEC_NO_SIMULT_CONNECT
 static void tcp_ecn_rcv_syn(struct tcp_sock *tp, const struct tcphdr *th)
 {
 	if ((tp->ecn_flags & TCP_ECN_OK) && (!th->ece || !th->cwr))
 		tp->ecn_flags &= ~TCP_ECN_OK;
 }
+#endif
 
 static bool tcp_ecn_rcv_ecn_echo(const struct tcp_sock *tp, const struct tcphdr *th)
 {
@@ -789,7 +791,7 @@ static void tcp_update_pacing_rate(struct sock *sk)
 	 * without any lock. We want to make sure compiler wont store
 	 * intermediate values in this location.
 	 */
-	ACCESS_ONCE(sk->sk_pacing_rate) = min_t(u64, rate,
+	ACCESS_ONCE_RW(sk->sk_pacing_rate) = min_t(u64, rate,
 						sk->sk_max_pacing_rate);
 }
 
@@ -4737,7 +4739,7 @@ static struct sk_buff *tcp_collapse_one(struct sock *sk, struct sk_buff *skb,
  * simplifies code)
  */
 static void
-tcp_collapse(struct sock *sk, struct sk_buff_head *list,
+__intentional_overflow(5,6) tcp_collapse(struct sock *sk, struct sk_buff_head *list,
 	     struct sk_buff *head, struct sk_buff *tail,
 	     u32 start, u32 end)
 {
@@ -5735,6 +5737,7 @@ discard:
 	    tcp_paws_reject(&tp->rx_opt, 0))
 		goto discard_and_undo;
 
+#ifndef CONFIG_GRKERNSEC_NO_SIMULT_CONNECT
 	if (th->syn) {
 		/* We see SYN without ACK. It is attempt of
 		 * simultaneous connect with crossed SYNs.
@@ -5786,6 +5789,7 @@ discard:
 		goto discard;
 #endif
 	}
+#endif
 	/* "fifth, if neither of the SYN or RST bits is set then
 	 * drop the segment and return."
 	 */
@@ -5829,7 +5833,7 @@ int tcp_rcv_state_process(struct sock *sk, struct sk_buff *skb)
 			goto discard;
 
 		if (th->syn) {
-			if (th->fin)
+			if (th->fin || th->urg || th->psh)
 				goto discard;
 			if (icsk->icsk_af_ops->conn_request(sk, skb) < 0)
 				return 1;
@@ -6149,7 +6153,7 @@ struct request_sock *inet_reqsk_alloc(const struct request_sock_ops *ops,
 #if IS_ENABLED(CONFIG_IPV6)
 		ireq->pktopts = NULL;
 #endif
-		atomic64_set(&ireq->ir_cookie, 0);
+		atomic64_set_unchecked(&ireq->ir_cookie, 0);
 		ireq->ireq_state = TCP_NEW_SYN_RECV;
 		write_pnet(&ireq->ireq_net, sock_net(sk_listener));
 		ireq->ireq_family = sk_listener->sk_family;
diff --git a/net/ipv4/tcp_ipv4.c b/net/ipv4/tcp_ipv4.c
index 7b235fa12..a8dbb72fa 100644
--- a/net/ipv4/tcp_ipv4.c
+++ b/net/ipv4/tcp_ipv4.c
@@ -88,6 +88,10 @@ int sysctl_tcp_tw_reuse __read_mostly;
 int sysctl_tcp_low_latency __read_mostly;
 EXPORT_SYMBOL(sysctl_tcp_low_latency);
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 #ifdef CONFIG_TCP_MD5SIG
 static int tcp_v4_md5_hash_hdr(char *md5_hash, const struct tcp_md5sig_key *key,
 			       __be32 daddr, __be32 saddr, const struct tcphdr *th);
@@ -1428,6 +1432,9 @@ int tcp_v4_do_rcv(struct sock *sk, struct sk_buff *skb)
 	return 0;
 
 reset:
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	if (!grsec_enable_blackhole)
+#endif
 	tcp_v4_send_reset(rsk, skb);
 discard:
 	kfree_skb(skb);
@@ -1610,12 +1617,19 @@ int tcp_v4_rcv(struct sk_buff *skb)
 lookup:
 	sk = __inet_lookup_skb(&tcp_hashinfo, skb, __tcp_hdrlen(th), th->source,
 			       th->dest, &refcounted);
-	if (!sk)
+	if (!sk) {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		ret = 1;
+#endif
 		goto no_tcp_socket;
-
+	}
 process:
-	if (sk->sk_state == TCP_TIME_WAIT)
+	if (sk->sk_state == TCP_TIME_WAIT) {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		ret = 2;
+#endif
 		goto do_time_wait;
+	}
 
 	if (sk->sk_state == TCP_NEW_SYN_RECV) {
 		struct request_sock *req = inet_reqsk(sk);
@@ -1707,6 +1721,10 @@ csum_error:
 bad_packet:
 		__TCP_INC_STATS(net, TCP_MIB_INERRS);
 	} else {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		if (!grsec_enable_blackhole || (ret == 1 &&
+		    (skb->dev->flags & IFF_LOOPBACK)))
+#endif
 		tcp_v4_send_reset(NULL, skb);
 	}
 
@@ -2445,7 +2463,7 @@ static void __net_exit tcp_sk_exit_batch(struct list_head *net_exit_list)
 	inet_twsk_purge(&tcp_hashinfo, &tcp_death_row, AF_INET);
 }
 
-static struct pernet_operations __net_initdata tcp_sk_ops = {
+static struct pernet_operations __net_initconst tcp_sk_ops = {
        .init	   = tcp_sk_init,
        .exit	   = tcp_sk_exit,
        .exit_batch = tcp_sk_exit_batch,
diff --git a/net/ipv4/tcp_metrics.c b/net/ipv4/tcp_metrics.c
index b617826e2..c544a9671 100644
--- a/net/ipv4/tcp_metrics.c
+++ b/net/ipv4/tcp_metrics.c
@@ -1166,7 +1166,7 @@ static void __net_exit tcp_net_metrics_exit(struct net *net)
 	tcp_metrics_flush_all(net);
 }
 
-static __net_initdata struct pernet_operations tcp_net_metrics_ops = {
+static __net_initconst struct pernet_operations tcp_net_metrics_ops = {
 	.init	=	tcp_net_metrics_init,
 	.exit	=	tcp_net_metrics_exit,
 };
diff --git a/net/ipv4/tcp_minisocks.c b/net/ipv4/tcp_minisocks.c
index 4b95ec4ed..4a83836b1 100644
--- a/net/ipv4/tcp_minisocks.c
+++ b/net/ipv4/tcp_minisocks.c
@@ -27,6 +27,10 @@
 #include <net/inet_common.h>
 #include <net/xfrm.h>
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 int sysctl_tcp_abort_on_overflow __read_mostly;
 
 struct inet_timewait_death_row tcp_death_row = {
@@ -784,7 +788,10 @@ embryonic_reset:
 		 * avoid becoming vulnerable to outside attack aiming at
 		 * resetting legit local connections.
 		 */
-		req->rsk_ops->send_reset(sk, skb);
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		if (!grsec_enable_blackhole)
+#endif
+			req->rsk_ops->send_reset(sk, skb);
 	} else if (fastopen) { /* received a valid RST pkt */
 		reqsk_fastopen_remove(sk, req, true);
 		tcp_reset(sk);
diff --git a/net/ipv4/tcp_probe.c b/net/ipv4/tcp_probe.c
index f6c50af24..1eb9aa505 100644
--- a/net/ipv4/tcp_probe.c
+++ b/net/ipv4/tcp_probe.c
@@ -236,7 +236,7 @@ static ssize_t tcpprobe_read(struct file *file, char __user *buf,
 		if (cnt + width >= len)
 			break;
 
-		if (copy_to_user(buf + cnt, tbuf, width))
+		if (width > sizeof tbuf || copy_to_user(buf + cnt, tbuf, width))
 			return -EFAULT;
 		cnt += width;
 	}
diff --git a/net/ipv4/tcp_timer.c b/net/ipv4/tcp_timer.c
index f712b411f..b6514037f 100644
--- a/net/ipv4/tcp_timer.c
+++ b/net/ipv4/tcp_timer.c
@@ -22,6 +22,10 @@
 #include <linux/gfp.h>
 #include <net/tcp.h>
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_lastack_retries;
+#endif
+
 int sysctl_tcp_thin_linear_timeouts __read_mostly;
 
 /**
@@ -228,6 +232,13 @@ static int tcp_write_timeout(struct sock *sk)
 		}
 	}
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	if ((sk->sk_state == TCP_LAST_ACK) &&
+	    (grsec_lastack_retries > 0) &&
+	    (grsec_lastack_retries < retry_until))
+		retry_until = grsec_lastack_retries;
+#endif
+
 	if (retransmits_timed_out(sk, retry_until,
 				  syn_set ? 0 : icsk->icsk_user_timeout, syn_set)) {
 		/* Has it gone just too far? */
diff --git a/net/ipv4/udp.c b/net/ipv4/udp.c
index a2d54f5b0..f94953aea 100644
--- a/net/ipv4/udp.c
+++ b/net/ipv4/udp.c
@@ -87,6 +87,7 @@
 #include <linux/types.h>
 #include <linux/fcntl.h>
 #include <linux/module.h>
+#include <linux/security.h>
 #include <linux/socket.h>
 #include <linux/sockios.h>
 #include <linux/igmp.h>
@@ -115,6 +116,10 @@
 #include "udp_impl.h"
 #include <net/sock_reuseport.h>
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 struct udp_table udp_table __read_mostly;
 EXPORT_SYMBOL(udp_table);
 
@@ -614,6 +619,9 @@ static inline bool __udp_is_mcast_sock(struct net *net, struct sock *sk,
 	return true;
 }
 
+extern int gr_search_udp_recvmsg(struct sock *sk, const struct sk_buff *skb);
+extern int gr_search_udp_sendmsg(struct sock *sk, struct sockaddr_in *addr);
+
 /*
  * This routine is called by the ICMP module when it gets some
  * sort of error condition.  If err < 0 then the socket should
@@ -940,9 +948,18 @@ int udp_sendmsg(struct sock *sk, struct msghdr *msg, size_t len)
 		dport = usin->sin_port;
 		if (dport == 0)
 			return -EINVAL;
+
+		err = gr_search_udp_sendmsg(sk, usin);
+		if (err)
+			return err;
 	} else {
 		if (sk->sk_state != TCP_ESTABLISHED)
 			return -EDESTADDRREQ;
+
+		err = gr_search_udp_sendmsg(sk, NULL);
+		if (err)
+			return err;
+
 		daddr = inet->inet_daddr;
 		dport = inet->inet_dport;
 		/* Open fast path for connected socket.
@@ -1199,7 +1216,7 @@ static int first_packet_length(struct sock *sk)
 				IS_UDPLITE(sk));
 		__UDP_INC_STATS(sock_net(sk), UDP_MIB_INERRORS,
 				IS_UDPLITE(sk));
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		__skb_unlink(skb, rcvq);
 		__skb_queue_tail(&list_kill, skb);
 	}
@@ -1301,10 +1318,13 @@ try_again:
 			goto csum_copy_err;
 	}
 
+	if (likely(!err))
+		err = gr_search_udp_recvmsg(sk, skb);
+
 	if (unlikely(err)) {
 		trace_kfree_skb(skb, udp_recvmsg);
 		if (!peeked) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			UDP_INC_STATS(sock_net(sk),
 				      UDP_MIB_INERRORS, is_udplite);
 		}
@@ -1609,7 +1629,7 @@ csum_error:
 	__UDP_INC_STATS(sock_net(sk), UDP_MIB_CSUMERRORS, is_udplite);
 drop:
 	__UDP_INC_STATS(sock_net(sk), UDP_MIB_INERRORS, is_udplite);
-	atomic_inc(&sk->sk_drops);
+	atomic_inc_unchecked(&sk->sk_drops);
 	kfree_skb(skb);
 	return -1;
 }
@@ -1667,7 +1687,7 @@ start_lookup:
 		nskb = skb_clone(skb, GFP_ATOMIC);
 
 		if (unlikely(!nskb)) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			__UDP_INC_STATS(net, UDP_MIB_RCVBUFERRORS,
 					IS_UDPLITE(sk));
 			__UDP_INC_STATS(net, UDP_MIB_INERRORS,
@@ -1808,6 +1828,9 @@ int __udp4_lib_rcv(struct sk_buff *skb, struct udp_table *udptable,
 		goto csum_error;
 
 	__UDP_INC_STATS(net, UDP_MIB_NOPORTS, proto == IPPROTO_UDPLITE);
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	if (!grsec_enable_blackhole || (skb->dev->flags & IFF_LOOPBACK))
+#endif
 	icmp_send(skb, ICMP_DEST_UNREACH, ICMP_PORT_UNREACH, 0);
 
 	/*
@@ -2372,7 +2395,7 @@ static void udp4_format_sock(struct sock *sp, struct seq_file *f,
 		from_kuid_munged(seq_user_ns(f), sock_i_uid(sp)),
 		0, sock_i_ino(sp),
 		atomic_read(&sp->sk_refcnt), sp,
-		atomic_read(&sp->sk_drops));
+		atomic_read_unchecked(&sp->sk_drops));
 }
 
 int udp4_seq_show(struct seq_file *seq, void *v)
diff --git a/net/ipv4/xfrm4_mode_beet.c b/net/ipv4/xfrm4_mode_beet.c
index 71acd0014..d2c74ee52 100644
--- a/net/ipv4/xfrm4_mode_beet.c
+++ b/net/ipv4/xfrm4_mode_beet.c
@@ -36,7 +36,7 @@ static void xfrm4_beet_make_header(struct sk_buff *skb)
  *
  * The top IP header will be constructed per draft-nikander-esp-beet-mode-06.txt.
  */
-static int xfrm4_beet_output(struct xfrm_state *x, struct sk_buff *skb)
+static int __intentional_overflow(0) xfrm4_beet_output(struct xfrm_state *x, struct sk_buff *skb)
 {
 	struct ip_beet_phdr *ph;
 	struct iphdr *top_iph;
diff --git a/net/ipv4/xfrm4_mode_transport.c b/net/ipv4/xfrm4_mode_transport.c
index fd840c7d7..b51762749 100644
--- a/net/ipv4/xfrm4_mode_transport.c
+++ b/net/ipv4/xfrm4_mode_transport.c
@@ -18,7 +18,7 @@
  * The IP header will be moved forward to make space for the encapsulation
  * header.
  */
-static int xfrm4_transport_output(struct xfrm_state *x, struct sk_buff *skb)
+static int __intentional_overflow(0) xfrm4_transport_output(struct xfrm_state *x, struct sk_buff *skb)
 {
 	struct iphdr *iph = ip_hdr(skb);
 	int ihl = iph->ihl * 4;
diff --git a/net/ipv4/xfrm4_policy.c b/net/ipv4/xfrm4_policy.c
index 41f5b504a..1b82e10c5 100644
--- a/net/ipv4/xfrm4_policy.c
+++ b/net/ipv4/xfrm4_policy.c
@@ -215,11 +215,11 @@ _decode_session4(struct sk_buff *skb, struct flowi *fl, int reverse)
 	fl4->flowi4_tos = iph->tos;
 }
 
-static inline int xfrm4_garbage_collect(struct dst_ops *ops)
+static int xfrm4_garbage_collect(struct dst_ops *ops)
 {
 	struct net *net = container_of(ops, struct net, xfrm.xfrm4_dst_ops);
 
-	xfrm4_policy_afinfo.garbage_collect(net);
+	xfrm_garbage_collect_deferred(net);
 	return (dst_entries_get_slow(ops) > ops->gc_thresh * 2);
 }
 
@@ -297,19 +297,19 @@ static struct ctl_table xfrm4_policy_table[] = {
 
 static __net_init int xfrm4_net_sysctl_init(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 	struct ctl_table_header *hdr;
 
-	table = xfrm4_policy_table;
 	if (!net_eq(net, &init_net)) {
-		table = kmemdup(table, sizeof(xfrm4_policy_table), GFP_KERNEL);
+		table = kmemdup(xfrm4_policy_table, sizeof(xfrm4_policy_table), GFP_KERNEL);
 		if (!table)
 			goto err_alloc;
 
 		table[0].data = &net->xfrm.xfrm4_dst_ops.gc_thresh;
-	}
 
-	hdr = register_net_sysctl(net, "net/ipv4", table);
+		hdr = register_net_sysctl(net, "net/ipv4", table);
+	} else
+		hdr = register_net_sysctl(net, "net/ipv4", xfrm4_policy_table);
 	if (!hdr)
 		goto err_reg;
 
@@ -317,8 +317,7 @@ static __net_init int xfrm4_net_sysctl_init(struct net *net)
 	return 0;
 
 err_reg:
-	if (!net_eq(net, &init_net))
-		kfree(table);
+	kfree(table);
 err_alloc:
 	return -ENOMEM;
 }
@@ -369,7 +368,7 @@ static void __net_exit xfrm4_net_exit(struct net *net)
 	dst_entries_destroy(&net->xfrm.xfrm4_dst_ops);
 }
 
-static struct pernet_operations __net_initdata xfrm4_net_ops = {
+static struct pernet_operations __net_initconst xfrm4_net_ops = {
 	.init	= xfrm4_net_init,
 	.exit	= xfrm4_net_exit,
 };
diff --git a/net/ipv4/xfrm4_state.c b/net/ipv4/xfrm4_state.c
index 542074c00..648df744a 100644
--- a/net/ipv4/xfrm4_state.c
+++ b/net/ipv4/xfrm4_state.c
@@ -56,6 +56,7 @@ xfrm4_init_temprop(struct xfrm_state *x, const struct xfrm_tmpl *tmpl,
 
 int xfrm4_extract_header(struct sk_buff *skb)
 {
+	unsigned char iph_tmp;
 	const struct iphdr *iph = ip_hdr(skb);
 
 	XFRM_MODE_SKB_CB(skb)->ihl = sizeof(*iph);
@@ -63,7 +64,8 @@ int xfrm4_extract_header(struct sk_buff *skb)
 	XFRM_MODE_SKB_CB(skb)->frag_off = iph->frag_off;
 	XFRM_MODE_SKB_CB(skb)->tos = iph->tos;
 	XFRM_MODE_SKB_CB(skb)->ttl = iph->ttl;
-	XFRM_MODE_SKB_CB(skb)->optlen = iph->ihl * 4 - sizeof(*iph);
+	iph_tmp = iph->ihl * 4;
+	XFRM_MODE_SKB_CB(skb)->optlen = iph_tmp - sizeof(*iph);
 	memset(XFRM_MODE_SKB_CB(skb)->flow_lbl, 0,
 	       sizeof(XFRM_MODE_SKB_CB(skb)->flow_lbl));
 
diff --git a/net/ipv6/addrconf.c b/net/ipv6/addrconf.c
index 8f2e36f8a..720a68f93 100644
--- a/net/ipv6/addrconf.c
+++ b/net/ipv6/addrconf.c
@@ -179,7 +179,7 @@ static struct ipv6_devconf ipv6_devconf __read_mostly = {
 	.hop_limit		= IPV6_DEFAULT_HOPLIMIT,
 	.mtu6			= IPV6_MIN_MTU,
 	.accept_ra		= 1,
-	.accept_redirects	= 1,
+	.accept_redirects	= 0,
 	.autoconf		= 1,
 	.force_mld_version	= 0,
 	.mldv1_unsolicited_report_interval = 10 * HZ,
@@ -224,7 +224,7 @@ static struct ipv6_devconf ipv6_devconf_dflt __read_mostly = {
 	.hop_limit		= IPV6_DEFAULT_HOPLIMIT,
 	.mtu6			= IPV6_MIN_MTU,
 	.accept_ra		= 1,
-	.accept_redirects	= 1,
+	.accept_redirects	= 0,
 	.autoconf		= 1,
 	.force_mld_version	= 0,
 	.mldv1_unsolicited_report_interval = 10 * HZ,
@@ -650,7 +650,7 @@ static int inet6_netconf_dump_devconf(struct sk_buff *skb,
 		idx = 0;
 		head = &net->dev_index_head[h];
 		rcu_read_lock();
-		cb->seq = atomic_read(&net->ipv6.dev_addr_genid) ^
+		cb->seq = atomic_read_unchecked(&net->ipv6.dev_addr_genid) ^
 			  net->dev_base_seq;
 		hlist_for_each_entry_rcu(dev, head, index_hlist) {
 			if (idx < s_idx)
@@ -2664,7 +2664,7 @@ int addrconf_set_dstaddr(struct net *net, void __user *arg)
 		p.iph.ihl = 5;
 		p.iph.protocol = IPPROTO_IPV6;
 		p.iph.ttl = 64;
-		ifr.ifr_ifru.ifru_data = (__force void __user *)&p;
+		ifr.ifr_ifru.ifru_data = (void __force_user *)&p;
 
 		if (ops->ndo_do_ioctl) {
 			mm_segment_t oldfs = get_fs();
@@ -4125,16 +4125,23 @@ static const struct file_operations if6_fops = {
 	.release	= seq_release_net,
 };
 
+extern void register_ipv6_seq_ops_addr(struct seq_operations *addr);
+extern void unregister_ipv6_seq_ops_addr(void);
+
 static int __net_init if6_proc_net_init(struct net *net)
 {
-	if (!proc_create("if_inet6", S_IRUGO, net->proc_net, &if6_fops))
+	register_ipv6_seq_ops_addr(&if6_seq_ops);
+	if (!proc_create("if_inet6", S_IRUGO, net->proc_net, &if6_fops)) {
+		unregister_ipv6_seq_ops_addr();
 		return -ENOMEM;
+	}
 	return 0;
 }
 
 static void __net_exit if6_proc_net_exit(struct net *net)
 {
 	remove_proc_entry("if_inet6", net->proc_net);
+	unregister_ipv6_seq_ops_addr();
 }
 
 static struct pernet_operations if6_proc_net_ops = {
@@ -4753,7 +4760,7 @@ static int inet6_dump_addr(struct sk_buff *skb, struct netlink_callback *cb,
 	s_ip_idx = ip_idx = cb->args[2];
 
 	rcu_read_lock();
-	cb->seq = atomic_read(&net->ipv6.dev_addr_genid) ^ net->dev_base_seq;
+	cb->seq = atomic_read_unchecked(&net->ipv6.dev_addr_genid) ^ net->dev_base_seq;
 	for (h = s_h; h < NETDEV_HASHENTRIES; h++, s_idx = 0) {
 		idx = 0;
 		head = &net->dev_index_head[h];
@@ -4966,7 +4973,7 @@ static inline size_t inet6_if_nlmsg_size(void)
 	       + nla_total_size(inet6_ifla6_size()); /* IFLA_PROTINFO */
 }
 
-static inline void __snmp6_fill_statsdev(u64 *stats, atomic_long_t *mib,
+static inline void __snmp6_fill_statsdev(u64 *stats, atomic_long_unchecked_t *mib,
 				      int items, int bytes)
 {
 	int i;
@@ -4976,7 +4983,7 @@ static inline void __snmp6_fill_statsdev(u64 *stats, atomic_long_t *mib,
 	/* Use put_unaligned() because stats may not be aligned for u64. */
 	put_unaligned(items, &stats[0]);
 	for (i = 1; i < items; i++)
-		put_unaligned(atomic_long_read(&mib[i]), &stats[i]);
+		put_unaligned(atomic_long_read_unchecked(&mib[i]), &stats[i]);
 
 	memset(&stats[items], 0, pad);
 }
@@ -5433,7 +5440,7 @@ static void __ipv6_ifa_notify(int event, struct inet6_ifaddr *ifp)
 		rt_genid_bump_ipv6(net);
 		break;
 	}
-	atomic_inc(&net->ipv6.dev_addr_genid);
+	atomic_inc_unchecked(&net->ipv6.dev_addr_genid);
 }
 
 static void ipv6_ifa_notify(int event, struct inet6_ifaddr *ifp)
@@ -5453,7 +5460,7 @@ int addrconf_sysctl_forward(struct ctl_table *ctl, int write,
 	int *valp = ctl->data;
 	int val = *valp;
 	loff_t pos = *ppos;
-	struct ctl_table lctl;
+	ctl_table_no_const lctl;
 	int ret;
 
 	/*
@@ -5476,7 +5483,7 @@ static
 int addrconf_sysctl_hop_limit(struct ctl_table *ctl, int write,
                               void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table lctl;
+	ctl_table_no_const lctl;
 	int min_hl = 1, max_hl = 255;
 
 	lctl = *ctl;
@@ -5492,7 +5499,7 @@ int addrconf_sysctl_mtu(struct ctl_table *ctl, int write,
 {
 	struct inet6_dev *idev = ctl->extra1;
 	int min_mtu = IPV6_MIN_MTU;
-	struct ctl_table lctl;
+	ctl_table_no_const lctl;
 
 	lctl = *ctl;
 	lctl.extra1 = &min_mtu;
@@ -5567,7 +5574,7 @@ int addrconf_sysctl_disable(struct ctl_table *ctl, int write,
 	int *valp = ctl->data;
 	int val = *valp;
 	loff_t pos = *ppos;
-	struct ctl_table lctl;
+	ctl_table_no_const lctl;
 	int ret;
 
 	/*
@@ -5632,7 +5639,7 @@ static int addrconf_sysctl_stable_secret(struct ctl_table *ctl, int write,
 	int err;
 	struct in6_addr addr;
 	char str[IPV6_MAX_STRLEN];
-	struct ctl_table lctl = *ctl;
+	ctl_table_no_const lctl = *ctl;
 	struct net *net = ctl->extra2;
 	struct ipv6_stable_secret *secret = ctl->data;
 
@@ -5701,7 +5708,7 @@ int addrconf_sysctl_ignore_routes_with_linkdown(struct ctl_table *ctl,
 	int *valp = ctl->data;
 	int val = *valp;
 	loff_t pos = *ppos;
-	struct ctl_table lctl;
+	ctl_table_no_const lctl;
 	int ret;
 
 	/* ctl->data points to idev->cnf.ignore_routes_when_linkdown
@@ -6041,7 +6048,7 @@ static int __addrconf_sysctl_register(struct net *net, char *dev_name,
 		struct inet6_dev *idev, struct ipv6_devconf *p)
 {
 	int i, ifindex;
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 	char path[sizeof("net/ipv6/conf/") + IFNAMSIZ];
 
 	table = kmemdup(addrconf_sysctl, sizeof(addrconf_sysctl), GFP_KERNEL);
diff --git a/net/ipv6/af_inet6.c b/net/ipv6/af_inet6.c
index b454055ba..0ac9a2d1c 100644
--- a/net/ipv6/af_inet6.c
+++ b/net/ipv6/af_inet6.c
@@ -794,7 +794,7 @@ static int __net_init inet6_net_init(struct net *net)
 	net->ipv6.sysctl.idgen_retries = 3;
 	net->ipv6.sysctl.idgen_delay = 1 * HZ;
 	net->ipv6.sysctl.flowlabel_state_ranges = 0;
-	atomic_set(&net->ipv6.fib6_sernum, 1);
+	atomic_set_unchecked(&net->ipv6.fib6_sernum, 1);
 
 	err = ipv6_init_mibs(net);
 	if (err)
diff --git a/net/ipv6/datagram.c b/net/ipv6/datagram.c
index 37874e2f3..d5cd49809 100644
--- a/net/ipv6/datagram.c
+++ b/net/ipv6/datagram.c
@@ -1032,5 +1032,5 @@ void ip6_dgram_sock_seq_show(struct seq_file *seq, struct sock *sp,
 		   0,
 		   sock_i_ino(sp),
 		   atomic_read(&sp->sk_refcnt), sp,
-		   atomic_read(&sp->sk_drops));
+		   atomic_read_unchecked(&sp->sk_drops));
 }
diff --git a/net/ipv6/icmp.c b/net/ipv6/icmp.c
index 7370ad2e6..7bbfa2308 100644
--- a/net/ipv6/icmp.c
+++ b/net/ipv6/icmp.c
@@ -447,8 +447,10 @@ static void icmp6_send(struct sk_buff *skb, u8 type, u8 code, __u32 info,
 
 	if (__ipv6_addr_needs_scope_id(addr_type))
 		iif = skb->dev->ifindex;
-	else
-		iif = l3mdev_master_ifindex(skb_dst(skb)->dev);
+	else {
+		dst = skb_dst(skb);
+		iif = l3mdev_master_ifindex(dst ? dst->dev : skb->dev);
+	}
 
 	/*
 	 *	Must not send error if the source does not uniquely
@@ -1073,7 +1075,7 @@ static struct ctl_table ipv6_icmp_table_template[] = {
 
 struct ctl_table * __net_init ipv6_icmp_sysctl_init(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(ipv6_icmp_table_template,
 			sizeof(ipv6_icmp_table_template),
diff --git a/net/ipv6/inet6_hashtables.c b/net/ipv6/inet6_hashtables.c
index 00cf28ad4..4699aa34b 100644
--- a/net/ipv6/inet6_hashtables.c
+++ b/net/ipv6/inet6_hashtables.c
@@ -178,7 +178,7 @@ struct sock *inet6_lookup(struct net *net, struct inet_hashinfo *hashinfo,
 EXPORT_SYMBOL_GPL(inet6_lookup);
 
 static int __inet6_check_established(struct inet_timewait_death_row *death_row,
-				     struct sock *sk, const __u16 lport,
+				     struct sock *sk, __u16 lport,
 				     struct inet_timewait_sock **twp)
 {
 	struct inet_hashinfo *hinfo = death_row->hashinfo;
diff --git a/net/ipv6/ip6_fib.c b/net/ipv6/ip6_fib.c
index 771be1fa4..e592cb867 100644
--- a/net/ipv6/ip6_fib.c
+++ b/net/ipv6/ip6_fib.c
@@ -98,9 +98,9 @@ static int fib6_new_sernum(struct net *net)
 	int new, old;
 
 	do {
-		old = atomic_read(&net->ipv6.fib6_sernum);
+		old = atomic_read_unchecked(&net->ipv6.fib6_sernum);
 		new = old < INT_MAX ? old + 1 : 1;
-	} while (atomic_cmpxchg(&net->ipv6.fib6_sernum,
+	} while (atomic_cmpxchg_unchecked(&net->ipv6.fib6_sernum,
 				old, new) != old);
 	return new;
 }
diff --git a/net/ipv6/ip6_gre.c b/net/ipv6/ip6_gre.c
index edc3daab3..c951634c5 100644
--- a/net/ipv6/ip6_gre.c
+++ b/net/ipv6/ip6_gre.c
@@ -71,8 +71,8 @@ struct ip6gre_net {
 	struct net_device *fb_tunnel_dev;
 };
 
-static struct rtnl_link_ops ip6gre_link_ops __read_mostly;
-static struct rtnl_link_ops ip6gre_tap_ops __read_mostly;
+static struct rtnl_link_ops ip6gre_link_ops;
+static struct rtnl_link_ops ip6gre_tap_ops;
 static int ip6gre_tunnel_init(struct net_device *dev);
 static void ip6gre_tunnel_setup(struct net_device *dev);
 static void ip6gre_tunnel_link(struct ip6gre_net *ign, struct ip6_tnl *t);
@@ -1067,7 +1067,7 @@ static void ip6gre_fb_tunnel_init(struct net_device *dev)
 }
 
 
-static struct inet6_protocol ip6gre_protocol __read_mostly = {
+static struct inet6_protocol ip6gre_protocol = {
 	.handler     = gre_rcv,
 	.err_handler = ip6gre_err,
 	.flags       = INET6_PROTO_NOPOLICY|INET6_PROTO_FINAL,
@@ -1520,7 +1520,7 @@ static const struct nla_policy ip6gre_policy[IFLA_GRE_MAX + 1] = {
 	[IFLA_GRE_ENCAP_DPORT]  = { .type = NLA_U16 },
 };
 
-static struct rtnl_link_ops ip6gre_link_ops __read_mostly = {
+static struct rtnl_link_ops ip6gre_link_ops = {
 	.kind		= "ip6gre",
 	.maxtype	= IFLA_GRE_MAX,
 	.policy		= ip6gre_policy,
@@ -1535,7 +1535,7 @@ static struct rtnl_link_ops ip6gre_link_ops __read_mostly = {
 	.get_link_net	= ip6_tnl_get_link_net,
 };
 
-static struct rtnl_link_ops ip6gre_tap_ops __read_mostly = {
+static struct rtnl_link_ops ip6gre_tap_ops = {
 	.kind		= "ip6gretap",
 	.maxtype	= IFLA_GRE_MAX,
 	.policy		= ip6gre_policy,
diff --git a/net/ipv6/ip6_tunnel.c b/net/ipv6/ip6_tunnel.c
index da4e7b377..fd21a2da3 100644
--- a/net/ipv6/ip6_tunnel.c
+++ b/net/ipv6/ip6_tunnel.c
@@ -80,7 +80,7 @@ static u32 HASH(const struct in6_addr *addr1, const struct in6_addr *addr2)
 
 static int ip6_tnl_dev_init(struct net_device *dev);
 static void ip6_tnl_dev_setup(struct net_device *dev);
-static struct rtnl_link_ops ip6_link_ops __read_mostly;
+static struct rtnl_link_ops ip6_link_ops;
 
 static int ip6_tnl_net_id __read_mostly;
 struct ip6_tnl_net {
@@ -2005,7 +2005,7 @@ static const struct nla_policy ip6_tnl_policy[IFLA_IPTUN_MAX + 1] = {
 	[IFLA_IPTUN_ENCAP_DPORT]	= { .type = NLA_U16 },
 };
 
-static struct rtnl_link_ops ip6_link_ops __read_mostly = {
+static struct rtnl_link_ops ip6_link_ops = {
 	.kind		= "ip6tnl",
 	.maxtype	= IFLA_IPTUN_MAX,
 	.policy		= ip6_tnl_policy,
diff --git a/net/ipv6/ip6_vti.c b/net/ipv6/ip6_vti.c
index 5bd3afdcc..207e6a14c 100644
--- a/net/ipv6/ip6_vti.c
+++ b/net/ipv6/ip6_vti.c
@@ -62,7 +62,7 @@ static u32 HASH(const struct in6_addr *addr1, const struct in6_addr *addr2)
 
 static int vti6_dev_init(struct net_device *dev);
 static void vti6_dev_setup(struct net_device *dev);
-static struct rtnl_link_ops vti6_link_ops __read_mostly;
+static struct rtnl_link_ops vti6_link_ops;
 
 static int vti6_net_id __read_mostly;
 struct vti6_net {
@@ -1030,7 +1030,7 @@ static const struct nla_policy vti6_policy[IFLA_VTI_MAX + 1] = {
 	[IFLA_VTI_OKEY]		= { .type = NLA_U32 },
 };
 
-static struct rtnl_link_ops vti6_link_ops __read_mostly = {
+static struct rtnl_link_ops vti6_link_ops = {
 	.kind		= "vti6",
 	.maxtype	= IFLA_VTI_MAX,
 	.policy		= vti6_policy,
diff --git a/net/ipv6/ipv6_sockglue.c b/net/ipv6/ipv6_sockglue.c
index 5330262ab..0335f4d6f 100644
--- a/net/ipv6/ipv6_sockglue.c
+++ b/net/ipv6/ipv6_sockglue.c
@@ -1026,7 +1026,7 @@ static int do_ipv6_getsockopt(struct sock *sk, int level, int optname,
 		if (sk->sk_type != SOCK_STREAM)
 			return -ENOPROTOOPT;
 
-		msg.msg_control = optval;
+		msg.msg_control = (void __force_kernel *)optval;
 		msg.msg_controllen = len;
 		msg.msg_flags = flags;
 
diff --git a/net/ipv6/ndisc.c b/net/ipv6/ndisc.c
index fe65cdc28..4e70b9907 100644
--- a/net/ipv6/ndisc.c
+++ b/net/ipv6/ndisc.c
@@ -683,7 +683,7 @@ static void ndisc_solicit(struct neighbour *neigh, struct sk_buff *skb)
 	struct in6_addr mcaddr;
 	struct net_device *dev = neigh->dev;
 	struct in6_addr *target = (struct in6_addr *)&neigh->primary_key;
-	int probes = atomic_read(&neigh->probes);
+	int probes = atomic_read_unchecked(&neigh->probes);
 
 	if (skb && ipv6_chk_addr_and_flags(dev_net(dev), &ipv6_hdr(skb)->saddr,
 					   dev, 1,
diff --git a/net/ipv6/netfilter/ip6_tables.c b/net/ipv6/netfilter/ip6_tables.c
index 552fac2f3..32c56ad74 100644
--- a/net/ipv6/netfilter/ip6_tables.c
+++ b/net/ipv6/netfilter/ip6_tables.c
@@ -988,13 +988,13 @@ static int compat_table_info(const struct xt_table_info *info,
 #endif
 
 static int get_info(struct net *net, void __user *user,
-		    const int *len, int compat)
+		    int len, int compat)
 {
 	char name[XT_TABLE_MAXNAMELEN];
 	struct xt_table *t;
 	int ret;
 
-	if (*len != sizeof(struct ip6t_getinfo))
+	if (len != sizeof(struct ip6t_getinfo))
 		return -EINVAL;
 
 	if (copy_from_user(name, user, sizeof(name)) != 0)
@@ -1029,7 +1029,7 @@ static int get_info(struct net *net, void __user *user,
 		info.size = private->size;
 		strcpy(info.name, name);
 
-		if (copy_to_user(user, &info, *len) != 0)
+		if (copy_to_user(user, &info, len) != 0)
 			ret = -EFAULT;
 		else
 			ret = 0;
@@ -1683,7 +1683,7 @@ compat_do_ip6t_get_ctl(struct sock *sk, int cmd, void __user *user, int *len)
 
 	switch (cmd) {
 	case IP6T_SO_GET_INFO:
-		ret = get_info(sock_net(sk), user, len, 1);
+		ret = get_info(sock_net(sk), user, *len, 1);
 		break;
 	case IP6T_SO_GET_ENTRIES:
 		ret = compat_get_entries(sock_net(sk), user, len);
@@ -1729,7 +1729,7 @@ do_ip6t_get_ctl(struct sock *sk, int cmd, void __user *user, int *len)
 
 	switch (cmd) {
 	case IP6T_SO_GET_INFO:
-		ret = get_info(sock_net(sk), user, len, 0);
+		ret = get_info(sock_net(sk), user, *len, 0);
 		break;
 
 	case IP6T_SO_GET_ENTRIES:
diff --git a/net/ipv6/netfilter/nf_conntrack_reasm.c b/net/ipv6/netfilter/nf_conntrack_reasm.c
index e4347aeb2..c7654e7e5 100644
--- a/net/ipv6/netfilter/nf_conntrack_reasm.c
+++ b/net/ipv6/netfilter/nf_conntrack_reasm.c
@@ -95,12 +95,11 @@ static struct ctl_table nf_ct_frag6_sysctl_table[] = {
 
 static int nf_ct_frag6_sysctl_register(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 	struct ctl_table_header *hdr;
 
-	table = nf_ct_frag6_sysctl_table;
 	if (!net_eq(net, &init_net)) {
-		table = kmemdup(table, sizeof(nf_ct_frag6_sysctl_table),
+		table = kmemdup(nf_ct_frag6_sysctl_table, sizeof(nf_ct_frag6_sysctl_table),
 				GFP_KERNEL);
 		if (table == NULL)
 			goto err_alloc;
@@ -111,9 +110,9 @@ static int nf_ct_frag6_sysctl_register(struct net *net)
 		table[2].data = &net->nf_frag.frags.high_thresh;
 		table[2].extra1 = &net->nf_frag.frags.low_thresh;
 		table[2].extra2 = &init_net.nf_frag.frags.high_thresh;
-	}
-
-	hdr = register_net_sysctl(net, "net/netfilter", table);
+		hdr = register_net_sysctl(net, "net/netfilter", table);
+	} else
+		hdr = register_net_sysctl(net, "net/netfilter", nf_ct_frag6_sysctl_table);
 	if (hdr == NULL)
 		goto err_reg;
 
@@ -121,8 +120,7 @@ static int nf_ct_frag6_sysctl_register(struct net *net)
 	return 0;
 
 err_reg:
-	if (!net_eq(net, &init_net))
-		kfree(table);
+	kfree(table);
 err_alloc:
 	return -ENOMEM;
 }
diff --git a/net/ipv6/ping.c b/net/ipv6/ping.c
index 0e983b694..655d90ba6 100644
--- a/net/ipv6/ping.c
+++ b/net/ipv6/ping.c
@@ -250,6 +250,24 @@ static struct pernet_operations ping_v6_net_ops = {
 };
 #endif
 
+static struct pingv6_ops real_pingv6_ops = {
+	.ipv6_recv_error		= ipv6_recv_error,
+	.ip6_datagram_recv_common_ctl	= ip6_datagram_recv_common_ctl,
+	.ip6_datagram_recv_specific_ctl	= ip6_datagram_recv_specific_ctl,
+	.icmpv6_err_convert		= icmpv6_err_convert,
+	.ipv6_icmp_error		= ipv6_icmp_error,
+	.ipv6_chk_addr			= ipv6_chk_addr,
+};
+
+static struct pingv6_ops dummy_pingv6_ops = {
+	.ipv6_recv_error		= dummy_ipv6_recv_error,
+	.ip6_datagram_recv_common_ctl	= dummy_ip6_datagram_recv_ctl,
+	.ip6_datagram_recv_specific_ctl	= dummy_ip6_datagram_recv_ctl,
+	.icmpv6_err_convert		= dummy_icmpv6_err_convert,
+	.ipv6_icmp_error		= dummy_ipv6_icmp_error,
+	.ipv6_chk_addr			= dummy_ipv6_chk_addr,
+};
+
 int __init pingv6_init(void)
 {
 #ifdef CONFIG_PROC_FS
@@ -257,13 +275,7 @@ int __init pingv6_init(void)
 	if (ret)
 		return ret;
 #endif
-	pingv6_ops.ipv6_recv_error = ipv6_recv_error;
-	pingv6_ops.ip6_datagram_recv_common_ctl = ip6_datagram_recv_common_ctl;
-	pingv6_ops.ip6_datagram_recv_specific_ctl =
-		ip6_datagram_recv_specific_ctl;
-	pingv6_ops.icmpv6_err_convert = icmpv6_err_convert;
-	pingv6_ops.ipv6_icmp_error = ipv6_icmp_error;
-	pingv6_ops.ipv6_chk_addr = ipv6_chk_addr;
+	pingv6_ops = &real_pingv6_ops;
 	return inet6_register_protosw(&pingv6_protosw);
 }
 
@@ -272,14 +284,9 @@ int __init pingv6_init(void)
  */
 void pingv6_exit(void)
 {
-	pingv6_ops.ipv6_recv_error = dummy_ipv6_recv_error;
-	pingv6_ops.ip6_datagram_recv_common_ctl = dummy_ip6_datagram_recv_ctl;
-	pingv6_ops.ip6_datagram_recv_specific_ctl = dummy_ip6_datagram_recv_ctl;
-	pingv6_ops.icmpv6_err_convert = dummy_icmpv6_err_convert;
-	pingv6_ops.ipv6_icmp_error = dummy_ipv6_icmp_error;
-	pingv6_ops.ipv6_chk_addr = dummy_ipv6_chk_addr;
 #ifdef CONFIG_PROC_FS
 	unregister_pernet_subsys(&ping_v6_net_ops);
 #endif
+	pingv6_ops = &dummy_pingv6_ops;
 	inet6_unregister_protosw(&pingv6_protosw);
 }
diff --git a/net/ipv6/proc.c b/net/ipv6/proc.c
index 679253d0a..d85dd9743 100644
--- a/net/ipv6/proc.c
+++ b/net/ipv6/proc.c
@@ -151,7 +151,7 @@ static const struct snmp_mib snmp6_udplite6_list[] = {
 	SNMP_MIB_SENTINEL
 };
 
-static void snmp6_seq_show_icmpv6msg(struct seq_file *seq, atomic_long_t *smib)
+static void snmp6_seq_show_icmpv6msg(struct seq_file *seq, atomic_long_unchecked_t *smib)
 {
 	char name[32];
 	int i;
@@ -168,14 +168,14 @@ static void snmp6_seq_show_icmpv6msg(struct seq_file *seq, atomic_long_t *smib)
 		snprintf(name, sizeof(name), "Icmp6%s%s",
 			i & 0x100 ? "Out" : "In", p);
 		seq_printf(seq, "%-32s\t%lu\n", name,
-			   atomic_long_read(smib + i));
+			   atomic_long_read_unchecked(smib + i));
 	}
 
 	/* print by number (nonzero only) - ICMPMsgStat format */
 	for (i = 0; i < ICMP6MSG_MIB_MAX; i++) {
 		unsigned long val;
 
-		val = atomic_long_read(smib + i);
+		val = atomic_long_read_unchecked(smib + i);
 		if (!val)
 			continue;
 		snprintf(name, sizeof(name), "Icmp6%sType%u",
@@ -188,7 +188,7 @@ static void snmp6_seq_show_icmpv6msg(struct seq_file *seq, atomic_long_t *smib)
  * or shared one (smib != NULL)
  */
 static void snmp6_seq_show_item(struct seq_file *seq, void __percpu *pcpumib,
-				atomic_long_t *smib,
+				atomic_long_unchecked_t *smib,
 				const struct snmp_mib *itemlist)
 {
 	int i;
@@ -197,7 +197,7 @@ static void snmp6_seq_show_item(struct seq_file *seq, void __percpu *pcpumib,
 	for (i = 0; itemlist[i].name; i++) {
 		val = pcpumib ?
 			snmp_fold_field(pcpumib, itemlist[i].entry) :
-			atomic_long_read(smib + itemlist[i].entry);
+			atomic_long_read_unchecked(smib + itemlist[i].entry);
 		seq_printf(seq, "%-32s\t%lu\n", itemlist[i].name, val);
 	}
 }
@@ -310,7 +310,7 @@ static int __net_init ipv6_proc_init_net(struct net *net)
 	if (!proc_create("snmp6", S_IRUGO, net->proc_net, &snmp6_seq_fops))
 		goto proc_snmp6_fail;
 
-	net->mib.proc_net_devsnmp6 = proc_mkdir("dev_snmp6", net->proc_net);
+	net->mib.proc_net_devsnmp6 = proc_mkdir_restrict("dev_snmp6", net->proc_net);
 	if (!net->mib.proc_net_devsnmp6)
 		goto proc_dev_snmp6_fail;
 	return 0;
diff --git a/net/ipv6/raw.c b/net/ipv6/raw.c
index 590dd1f77..97e5bd149 100644
--- a/net/ipv6/raw.c
+++ b/net/ipv6/raw.c
@@ -389,7 +389,7 @@ static inline int rawv6_rcv_skb(struct sock *sk, struct sk_buff *skb)
 {
 	if ((raw6_sk(sk)->checksum || rcu_access_pointer(sk->sk_filter)) &&
 	    skb_checksum_complete(skb)) {
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		kfree_skb(skb);
 		return NET_RX_DROP;
 	}
@@ -417,7 +417,7 @@ int rawv6_rcv(struct sock *sk, struct sk_buff *skb)
 	struct raw6_sock *rp = raw6_sk(sk);
 
 	if (!xfrm6_policy_check(sk, XFRM_POLICY_IN, skb)) {
-		atomic_inc(&sk->sk_drops);
+		atomic_inc_unchecked(&sk->sk_drops);
 		kfree_skb(skb);
 		return NET_RX_DROP;
 	}
@@ -441,7 +441,7 @@ int rawv6_rcv(struct sock *sk, struct sk_buff *skb)
 
 	if (inet->hdrincl) {
 		if (skb_checksum_complete(skb)) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			kfree_skb(skb);
 			return NET_RX_DROP;
 		}
@@ -609,7 +609,7 @@ out:
 	return err;
 }
 
-static int rawv6_send_hdrinc(struct sock *sk, struct msghdr *msg, int length,
+static int rawv6_send_hdrinc(struct sock *sk, struct msghdr *msg, unsigned int length,
 			struct flowi6 *fl6, struct dst_entry **dstp,
 			unsigned int flags)
 {
@@ -930,12 +930,15 @@ do_confirm:
 static int rawv6_seticmpfilter(struct sock *sk, int level, int optname,
 			       char __user *optval, int optlen)
 {
+	struct icmp6_filter filter;
+
 	switch (optname) {
 	case ICMPV6_FILTER:
 		if (optlen > sizeof(struct icmp6_filter))
 			optlen = sizeof(struct icmp6_filter);
-		if (copy_from_user(&raw6_sk(sk)->filter, optval, optlen))
+		if (copy_from_user(&filter, optval, optlen))
 			return -EFAULT;
+		raw6_sk(sk)->filter = filter;
 		return 0;
 	default:
 		return -ENOPROTOOPT;
@@ -948,6 +951,7 @@ static int rawv6_geticmpfilter(struct sock *sk, int level, int optname,
 			       char __user *optval, int __user *optlen)
 {
 	int len;
+	struct icmp6_filter filter;
 
 	switch (optname) {
 	case ICMPV6_FILTER:
@@ -959,7 +963,8 @@ static int rawv6_geticmpfilter(struct sock *sk, int level, int optname,
 			len = sizeof(struct icmp6_filter);
 		if (put_user(len, optlen))
 			return -EFAULT;
-		if (copy_to_user(optval, &raw6_sk(sk)->filter, len))
+		filter = raw6_sk(sk)->filter;
+		if (len > sizeof filter || copy_to_user(optval, &filter, len))
 			return -EFAULT;
 		return 0;
 	default:
diff --git a/net/ipv6/reassembly.c b/net/ipv6/reassembly.c
index 2160d5d00..6816c429e 100644
--- a/net/ipv6/reassembly.c
+++ b/net/ipv6/reassembly.c
@@ -628,12 +628,11 @@ static struct ctl_table ip6_frags_ctl_table[] = {
 
 static int __net_init ip6_frags_ns_sysctl_register(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 	struct ctl_table_header *hdr;
 
-	table = ip6_frags_ns_ctl_table;
 	if (!net_eq(net, &init_net)) {
-		table = kmemdup(table, sizeof(ip6_frags_ns_ctl_table), GFP_KERNEL);
+		table = kmemdup(ip6_frags_ns_ctl_table, sizeof(ip6_frags_ns_ctl_table), GFP_KERNEL);
 		if (!table)
 			goto err_alloc;
 
@@ -647,9 +646,10 @@ static int __net_init ip6_frags_ns_sysctl_register(struct net *net)
 		/* Don't export sysctls to unprivileged users */
 		if (net->user_ns != &init_user_ns)
 			table[0].procname = NULL;
-	}
+		hdr = register_net_sysctl(net, "net/ipv6", table);
+	} else
+		hdr = register_net_sysctl(net, "net/ipv6", ip6_frags_ns_ctl_table);
 
-	hdr = register_net_sysctl(net, "net/ipv6", table);
 	if (!hdr)
 		goto err_reg;
 
@@ -657,8 +657,7 @@ static int __net_init ip6_frags_ns_sysctl_register(struct net *net)
 	return 0;
 
 err_reg:
-	if (!net_eq(net, &init_net))
-		kfree(table);
+	kfree(table);
 err_alloc:
 	return -ENOMEM;
 }
diff --git a/net/ipv6/route.c b/net/ipv6/route.c
index 23153ac6c..08b47f94a 100644
--- a/net/ipv6/route.c
+++ b/net/ipv6/route.c
@@ -3573,7 +3573,7 @@ struct ctl_table ipv6_route_table_template[] = {
 
 struct ctl_table * __net_init ipv6_route_sysctl_init(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(ipv6_route_table_template,
 			sizeof(ipv6_route_table_template),
diff --git a/net/ipv6/sit.c b/net/ipv6/sit.c
index 182b6a9be..4d37cbac9 100644
--- a/net/ipv6/sit.c
+++ b/net/ipv6/sit.c
@@ -74,7 +74,7 @@ static void ipip6_tunnel_setup(struct net_device *dev);
 static void ipip6_dev_free(struct net_device *dev);
 static bool check_6rd(struct ip_tunnel *tunnel, const struct in6_addr *v6dst,
 		      __be32 *v4dst);
-static struct rtnl_link_ops sit_link_ops __read_mostly;
+static struct rtnl_link_ops sit_link_ops;
 
 static int sit_net_id __read_mostly;
 struct sit_net {
@@ -1735,7 +1735,7 @@ static void ipip6_dellink(struct net_device *dev, struct list_head *head)
 		unregister_netdevice_queue(dev, head);
 }
 
-static struct rtnl_link_ops sit_link_ops __read_mostly = {
+static struct rtnl_link_ops sit_link_ops = {
 	.kind		= "sit",
 	.maxtype	= IFLA_IPTUN_MAX,
 	.policy		= ipip6_policy,
diff --git a/net/ipv6/sysctl_net_ipv6.c b/net/ipv6/sysctl_net_ipv6.c
index 69c50e737..ec875facf 100644
--- a/net/ipv6/sysctl_net_ipv6.c
+++ b/net/ipv6/sysctl_net_ipv6.c
@@ -130,7 +130,7 @@ static struct ctl_table ipv6_rotable[] = {
 
 static int __net_init ipv6_sysctl_net_init(struct net *net)
 {
-	struct ctl_table *ipv6_table;
+	ctl_table_no_const *ipv6_table;
 	struct ctl_table *ipv6_route_table;
 	struct ctl_table *ipv6_icmp_table;
 	int err;
diff --git a/net/ipv6/tcp_ipv6.c b/net/ipv6/tcp_ipv6.c
index af6a09efa..3dafd52ae 100644
--- a/net/ipv6/tcp_ipv6.c
+++ b/net/ipv6/tcp_ipv6.c
@@ -101,6 +101,10 @@ static void inet6_sk_rx_dst_set(struct sock *sk, const struct sk_buff *skb)
 	}
 }
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 static __u32 tcp_v6_init_sequence(const struct sk_buff *skb)
 {
 	return secure_tcpv6_sequence_number(ipv6_hdr(skb)->daddr.s6_addr32,
@@ -1299,6 +1303,9 @@ static int tcp_v6_do_rcv(struct sock *sk, struct sk_buff *skb)
 	return 0;
 
 reset:
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	if (!grsec_enable_blackhole)
+#endif
 	tcp_v6_send_reset(sk, skb);
 discard:
 	if (opt_skb)
@@ -1403,12 +1410,20 @@ lookup:
 	sk = __inet6_lookup_skb(&tcp_hashinfo, skb, __tcp_hdrlen(th),
 				th->source, th->dest, inet6_iif(skb),
 				&refcounted);
-	if (!sk)
+	if (!sk) {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		ret = 1;
+#endif
 		goto no_tcp_socket;
+	}
 
 process:
-	if (sk->sk_state == TCP_TIME_WAIT)
+	if (sk->sk_state == TCP_TIME_WAIT) {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		ret = 2;
+#endif
 		goto do_time_wait;
+	}
 
 	if (sk->sk_state == TCP_NEW_SYN_RECV) {
 		struct request_sock *req = inet_reqsk(sk);
@@ -1500,6 +1515,10 @@ csum_error:
 bad_packet:
 		__TCP_INC_STATS(net, TCP_MIB_INERRS);
 	} else {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		if (!grsec_enable_blackhole || (ret == 1 &&
+		    (skb->dev->flags & IFF_LOOPBACK)))
+#endif
 		tcp_v6_send_reset(NULL, skb);
 	}
 
diff --git a/net/ipv6/udp.c b/net/ipv6/udp.c
index fa39ab8ec..580da9bc5 100644
--- a/net/ipv6/udp.c
+++ b/net/ipv6/udp.c
@@ -78,6 +78,10 @@ static u32 udp6_ehashfn(const struct net *net,
 			       udp_ipv6_hash_secret + net_hash_mix(net));
 }
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 static u32 udp6_portaddr_hash(const struct net *net,
 			      const struct in6_addr *addr6,
 			      unsigned int port)
@@ -380,7 +384,7 @@ try_again:
 	if (unlikely(err)) {
 		trace_kfree_skb(skb, udpv6_recvmsg);
 		if (!peeked) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			if (is_udp4)
 				UDP_INC_STATS(sock_net(sk), UDP_MIB_INERRORS,
 					      is_udplite);
@@ -647,7 +651,7 @@ csum_error:
 	__UDP6_INC_STATS(sock_net(sk), UDP_MIB_CSUMERRORS, is_udplite);
 drop:
 	__UDP6_INC_STATS(sock_net(sk), UDP_MIB_INERRORS, is_udplite);
-	atomic_inc(&sk->sk_drops);
+	atomic_inc_unchecked(&sk->sk_drops);
 	kfree_skb(skb);
 	return -1;
 }
@@ -728,7 +732,7 @@ start_lookup:
 		}
 		nskb = skb_clone(skb, GFP_ATOMIC);
 		if (unlikely(!nskb)) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			__UDP6_INC_STATS(net, UDP_MIB_RCVBUFERRORS,
 					 IS_UDPLITE(sk));
 			__UDP6_INC_STATS(net, UDP_MIB_INERRORS,
@@ -846,6 +850,9 @@ int __udp6_lib_rcv(struct sk_buff *skb, struct udp_table *udptable,
 		goto csum_error;
 
 	__UDP6_INC_STATS(net, UDP_MIB_NOPORTS, proto == IPPROTO_UDPLITE);
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	if (!grsec_enable_blackhole || (skb->dev->flags & IFF_LOOPBACK))
+#endif
 	icmpv6_send(skb, ICMPV6_DEST_UNREACH, ICMPV6_PORT_UNREACH, 0);
 
 	kfree_skb(skb);
diff --git a/net/ipv6/xfrm6_mode_beet.c b/net/ipv6/xfrm6_mode_beet.c
index 1e205c325..d71b84622 100644
--- a/net/ipv6/xfrm6_mode_beet.c
+++ b/net/ipv6/xfrm6_mode_beet.c
@@ -37,7 +37,7 @@ static void xfrm6_beet_make_header(struct sk_buff *skb)
  *
  * The top IP header will be constructed per draft-nikander-esp-beet-mode-06.txt.
  */
-static int xfrm6_beet_output(struct xfrm_state *x, struct sk_buff *skb)
+static int __intentional_overflow(0) xfrm6_beet_output(struct xfrm_state *x, struct sk_buff *skb)
 {
 	struct ipv6hdr *top_iph;
 	struct ip_beet_phdr *ph;
diff --git a/net/ipv6/xfrm6_mode_transport.c b/net/ipv6/xfrm6_mode_transport.c
index 4e344105b..232827a4e 100644
--- a/net/ipv6/xfrm6_mode_transport.c
+++ b/net/ipv6/xfrm6_mode_transport.c
@@ -19,7 +19,7 @@
  * The IP header and mutable extension headers will be moved forward to make
  * space for the encapsulation header.
  */
-static int xfrm6_transport_output(struct xfrm_state *x, struct sk_buff *skb)
+static int __intentional_overflow(0) xfrm6_transport_output(struct xfrm_state *x, struct sk_buff *skb)
 {
 	struct ipv6hdr *iph;
 	u8 *prevhdr;
diff --git a/net/ipv6/xfrm6_policy.c b/net/ipv6/xfrm6_policy.c
index 70a86adad..19ab7b0f0 100644
--- a/net/ipv6/xfrm6_policy.c
+++ b/net/ipv6/xfrm6_policy.c
@@ -216,11 +216,11 @@ _decode_session6(struct sk_buff *skb, struct flowi *fl, int reverse)
 	}
 }
 
-static inline int xfrm6_garbage_collect(struct dst_ops *ops)
+static int xfrm6_garbage_collect(struct dst_ops *ops)
 {
 	struct net *net = container_of(ops, struct net, xfrm.xfrm6_dst_ops);
 
-	xfrm6_policy_afinfo.garbage_collect(net);
+	xfrm_garbage_collect_deferred(net);
 	return dst_entries_get_fast(ops) > ops->gc_thresh * 2;
 }
 
@@ -327,19 +327,19 @@ static struct ctl_table xfrm6_policy_table[] = {
 
 static int __net_init xfrm6_net_sysctl_init(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 	struct ctl_table_header *hdr;
 
-	table = xfrm6_policy_table;
 	if (!net_eq(net, &init_net)) {
-		table = kmemdup(table, sizeof(xfrm6_policy_table), GFP_KERNEL);
+		table = kmemdup(xfrm6_policy_table, sizeof(xfrm6_policy_table), GFP_KERNEL);
 		if (!table)
 			goto err_alloc;
 
 		table[0].data = &net->xfrm.xfrm6_dst_ops.gc_thresh;
-	}
+		hdr = register_net_sysctl(net, "net/ipv6", table);
+	} else
+		hdr = register_net_sysctl(net, "net/ipv6", xfrm6_policy_table);
 
-	hdr = register_net_sysctl(net, "net/ipv6", table);
 	if (!hdr)
 		goto err_reg;
 
@@ -347,8 +347,7 @@ static int __net_init xfrm6_net_sysctl_init(struct net *net)
 	return 0;
 
 err_reg:
-	if (!net_eq(net, &init_net))
-		kfree(table);
+	kfree(table);
 err_alloc:
 	return -ENOMEM;
 }
diff --git a/net/ipx/ipx_proc.c b/net/ipx/ipx_proc.c
index c1d247ebe..9e5949d06 100644
--- a/net/ipx/ipx_proc.c
+++ b/net/ipx/ipx_proc.c
@@ -289,7 +289,7 @@ int __init ipx_proc_init(void)
 	struct proc_dir_entry *p;
 	int rc = -ENOMEM;
 
-	ipx_proc_dir = proc_mkdir("ipx", init_net.proc_net);
+	ipx_proc_dir = proc_mkdir_restrict("ipx", init_net.proc_net);
 
 	if (!ipx_proc_dir)
 		goto out;
diff --git a/net/irda/discovery.c b/net/irda/discovery.c
index 364d70aed..c503f3fe9 100644
--- a/net/irda/discovery.c
+++ b/net/irda/discovery.c
@@ -136,7 +136,7 @@ void irlmp_add_discovery_log(hashbin_t *cachelog, hashbin_t *log)
 	}
 
 	/* Delete the now empty log */
-	hashbin_delete(log, (FREE_FUNC) kfree);
+	hashbin_delete(log, irlmp_kfree);
 }
 
 /*
diff --git a/net/irda/ircomm/ircomm_core.c b/net/irda/ircomm/ircomm_core.c
index 3af219545..a38e80492 100644
--- a/net/irda/ircomm/ircomm_core.c
+++ b/net/irda/ircomm/ircomm_core.c
@@ -46,7 +46,7 @@
 #include <net/irda/ircomm_param.h>
 #include <net/irda/ircomm_core.h>
 
-static int __ircomm_close(struct ircomm_cb *self);
+static void __ircomm_close(void *_self);
 static void ircomm_control_indication(struct ircomm_cb *self,
 				      struct sk_buff *skb, int clen);
 
@@ -91,7 +91,7 @@ static int __init ircomm_init(void)
 
 static void __exit ircomm_cleanup(void)
 {
-	hashbin_delete(ircomm, (FREE_FUNC) __ircomm_close);
+	hashbin_delete(ircomm, __ircomm_close);
 
 #ifdef CONFIG_PROC_FS
 	remove_proc_entry("ircomm", proc_irda);
@@ -151,8 +151,10 @@ EXPORT_SYMBOL(ircomm_open);
  *    Remove IrCOMM instance
  *
  */
-static int __ircomm_close(struct ircomm_cb *self)
+static void __ircomm_close(void *_self)
 {
+	struct ircomm_cb *self = _self;
+
 	/* Disconnect link if any */
 	ircomm_do_event(self, IRCOMM_DISCONNECT_REQUEST, NULL, NULL);
 
@@ -170,8 +172,6 @@ static int __ircomm_close(struct ircomm_cb *self)
 	self->magic = 0;
 
 	kfree(self);
-
-	return 0;
 }
 
 /*
@@ -191,7 +191,8 @@ int ircomm_close(struct ircomm_cb *self)
 
 	IRDA_ASSERT(entry == self, return -1;);
 
-	return __ircomm_close(self);
+	__ircomm_close(self);
+	return 0;
 }
 
 EXPORT_SYMBOL(ircomm_close);
diff --git a/net/irda/ircomm/ircomm_tty.c b/net/irda/ircomm/ircomm_tty.c
index 873c4b707..6d3624f10 100644
--- a/net/irda/ircomm/ircomm_tty.c
+++ b/net/irda/ircomm/ircomm_tty.c
@@ -172,8 +172,10 @@ static int __init ircomm_tty_init(void)
 	return 0;
 }
 
-static void __exit __ircomm_tty_cleanup(struct ircomm_tty_cb *self)
+static void __exit __ircomm_tty_cleanup(void *_self)
 {
+	struct ircomm_tty_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == IRCOMM_TTY_MAGIC, return;);
 
@@ -201,7 +203,7 @@ static void __exit ircomm_tty_cleanup(void)
 		return;
 	}
 
-	hashbin_delete(ircomm_tty, (FREE_FUNC) __ircomm_tty_cleanup);
+	hashbin_delete(ircomm_tty, __ircomm_tty_cleanup);
 	put_tty_driver(driver);
 }
 
@@ -311,10 +313,10 @@ static int ircomm_tty_block_til_ready(struct ircomm_tty_cb *self,
 	add_wait_queue(&port->open_wait, &wait);
 
 	pr_debug("%s(%d):block_til_ready before block on %s open_count=%d\n",
-		 __FILE__, __LINE__, tty->driver->name, port->count);
+		 __FILE__, __LINE__, tty->driver->name, atomic_read(&port->count));
 
 	spin_lock_irqsave(&port->lock, flags);
-	port->count--;
+	atomic_dec(&port->count);
 	port->blocked_open++;
 	spin_unlock_irqrestore(&port->lock, flags);
 
@@ -347,7 +349,7 @@ static int ircomm_tty_block_til_ready(struct ircomm_tty_cb *self,
 		}
 
 		pr_debug("%s(%d):block_til_ready blocking on %s open_count=%d\n",
-			 __FILE__, __LINE__, tty->driver->name, port->count);
+			 __FILE__, __LINE__, tty->driver->name, atomic_read(&port->count));
 
 		schedule();
 	}
@@ -357,12 +359,12 @@ static int ircomm_tty_block_til_ready(struct ircomm_tty_cb *self,
 
 	spin_lock_irqsave(&port->lock, flags);
 	if (!tty_hung_up_p(filp))
-		port->count++;
+		atomic_inc(&port->count);
 	port->blocked_open--;
 	spin_unlock_irqrestore(&port->lock, flags);
 
 	pr_debug("%s(%d):block_til_ready after blocking on %s open_count=%d\n",
-		 __FILE__, __LINE__, tty->driver->name, port->count);
+		 __FILE__, __LINE__, tty->driver->name, atomic_read(&port->count));
 
 	if (!retval)
 		tty_port_set_active(port, 1);
@@ -432,12 +434,12 @@ static int ircomm_tty_open(struct tty_struct *tty, struct file *filp)
 
 	/* ++ is not atomic, so this should be protected - Jean II */
 	spin_lock_irqsave(&self->port.lock, flags);
-	self->port.count++;
+	atomic_inc(&self->port.count);
 	spin_unlock_irqrestore(&self->port.lock, flags);
 	tty_port_tty_set(&self->port, tty);
 
 	pr_debug("%s(), %s%d, count = %d\n", __func__ , tty->driver->name,
-		 self->line, self->port.count);
+		 self->line, atomic_read(&self->port.count));
 
 	/* Not really used by us, but lets do it anyway */
 	self->port.low_latency = (self->port.flags & ASYNC_LOW_LATENCY) ? 1 : 0;
@@ -931,7 +933,7 @@ static void ircomm_tty_hangup(struct tty_struct *tty)
 		tty_kref_put(port->tty);
 	}
 	port->tty = NULL;
-	port->count = 0;
+	atomic_set(&port->count, 0);
 	spin_unlock_irqrestore(&port->lock, flags);
 	tty_port_set_active(port, 0);
 
@@ -1275,7 +1277,7 @@ static void ircomm_tty_line_info(struct ircomm_tty_cb *self, struct seq_file *m)
 	seq_putc(m, '\n');
 
 	seq_printf(m, "Role: %s\n", self->client ? "client" : "server");
-	seq_printf(m, "Open count: %d\n", self->port.count);
+	seq_printf(m, "Open count: %d\n", atomic_read(&self->port.count));
 	seq_printf(m, "Max data size: %d\n", self->max_data_size);
 	seq_printf(m, "Max header size: %d\n", self->max_header_size);
 
diff --git a/net/irda/ircomm/ircomm_tty_attach.c b/net/irda/ircomm/ircomm_tty_attach.c
index 0a411019c..e811c2eff 100644
--- a/net/irda/ircomm/ircomm_tty_attach.c
+++ b/net/irda/ircomm/ircomm_tty_attach.c
@@ -52,7 +52,7 @@ static void ircomm_tty_getvalue_confirm(int result, __u16 obj_id,
 					struct ias_value *value, void *priv);
 static void ircomm_tty_start_watchdog_timer(struct ircomm_tty_cb *self,
 					    int timeout);
-static void ircomm_tty_watchdog_timer_expired(void *data);
+static void ircomm_tty_watchdog_timer_expired(unsigned long data);
 
 static int ircomm_tty_state_idle(struct ircomm_tty_cb *self,
 				 IRCOMM_TTY_EVENT event,
@@ -597,7 +597,7 @@ static void ircomm_tty_start_watchdog_timer(struct ircomm_tty_cb *self,
  *    Called when the connect procedure have taken to much time.
  *
  */
-static void ircomm_tty_watchdog_timer_expired(void *data)
+static void ircomm_tty_watchdog_timer_expired(unsigned long data)
 {
 	struct ircomm_tty_cb *self = (struct ircomm_tty_cb *) data;
 
diff --git a/net/irda/irda_device.c b/net/irda/irda_device.c
index 856736656..7c8aa5173 100644
--- a/net/irda/irda_device.c
+++ b/net/irda/irda_device.c
@@ -52,12 +52,12 @@
 #include <net/irda/timer.h>
 #include <net/irda/wrapper.h>
 
-static void __irda_task_delete(struct irda_task *task);
+static void __irda_task_delete(void *_task);
 
 static hashbin_t *dongles = NULL;
 static hashbin_t *tasks = NULL;
 
-static void irda_task_timer_expired(void *data);
+static void irda_task_timer_expired(unsigned long data);
 
 int __init irda_device_init( void)
 {
@@ -90,7 +90,7 @@ static void leftover_dongle(void *arg)
 
 void irda_device_cleanup(void)
 {
-	hashbin_delete(tasks, (FREE_FUNC) __irda_task_delete);
+	hashbin_delete(tasks, __irda_task_delete);
 
 	hashbin_delete(dongles, leftover_dongle);
 }
@@ -159,8 +159,10 @@ int irda_device_is_receiving(struct net_device *dev)
 	return req.ifr_receiving;
 }
 
-static void __irda_task_delete(struct irda_task *task)
+static void __irda_task_delete(void *_task)
 {
+	struct irda_task *task = _task;
+
 	del_timer(&task->timer);
 
 	kfree(task);
@@ -249,11 +251,11 @@ static int irda_task_kick(struct irda_task *task)
  *    Task time has expired. We now try to execute task (again), and restart
  *    the timer if the task has not finished yet
  */
-static void irda_task_timer_expired(void *data)
+static void irda_task_timer_expired(unsigned long data)
 {
 	struct irda_task *task;
 
-	task = data;
+	task = (struct irda_task *)data;
 
 	irda_task_kick(task);
 }
diff --git a/net/irda/iriap.c b/net/irda/iriap.c
index 1138eaf5c..cb1900c8a 100644
--- a/net/irda/iriap.c
+++ b/net/irda/iriap.c
@@ -61,7 +61,7 @@ static const char *const ias_charset_types[] __maybe_unused = {
 static hashbin_t *iriap = NULL;
 static void *service_handle;
 
-static void __iriap_close(struct iriap_cb *self);
+static void __iriap_close(void *_self);
 static int iriap_register_lsap(struct iriap_cb *self, __u8 slsap_sel, int mode);
 static void iriap_disconnect_indication(void *instance, void *sap,
 					LM_REASON reason, struct sk_buff *skb);
@@ -76,7 +76,7 @@ static void iriap_connect_confirm(void *instance, void *sap,
 static int iriap_data_indication(void *instance, void *sap,
 				 struct sk_buff *skb);
 
-static void iriap_watchdog_timer_expired(void *data);
+static void iriap_watchdog_timer_expired(unsigned long data);
 
 static inline void iriap_start_watchdog_timer(struct iriap_cb *self,
 					      int timeout)
@@ -161,8 +161,8 @@ void iriap_cleanup(void)
 {
 	irlmp_unregister_service(service_handle);
 
-	hashbin_delete(iriap, (FREE_FUNC) __iriap_close);
-	hashbin_delete(irias_objects, (FREE_FUNC) __irias_delete_object);
+	hashbin_delete(iriap, __iriap_close);
+	hashbin_delete(irias_objects, __irias_delete_object);
 }
 
 /*
@@ -219,8 +219,10 @@ EXPORT_SYMBOL(iriap_open);
  *    Removes (deallocates) the IrIAP instance
  *
  */
-static void __iriap_close(struct iriap_cb *self)
+static void __iriap_close(void *_self)
 {
+	struct iriap_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == IAS_MAGIC, return;);
 
@@ -946,7 +948,7 @@ void iriap_call_indication(struct iriap_cb *self, struct sk_buff *skb)
  *    Query has taken too long time, so abort
  *
  */
-static void iriap_watchdog_timer_expired(void *data)
+static void iriap_watchdog_timer_expired(unsigned long data)
 {
 	struct iriap_cb *self = (struct iriap_cb *) data;
 
diff --git a/net/irda/irias_object.c b/net/irda/irias_object.c
index 53b86d0e1..5b884f341 100644
--- a/net/irda/irias_object.c
+++ b/net/irda/irias_object.c
@@ -88,8 +88,10 @@ EXPORT_SYMBOL(irias_new_object);
  *    Delete given attribute and deallocate all its memory
  *
  */
-static void __irias_delete_attrib(struct ias_attrib *attrib)
+static void __irias_delete_attrib(void *_attrib)
 {
+	struct ias_attrib *attrib = _attrib;
+
 	IRDA_ASSERT(attrib != NULL, return;);
 	IRDA_ASSERT(attrib->magic == IAS_ATTRIB_MAGIC, return;);
 
@@ -101,14 +103,16 @@ static void __irias_delete_attrib(struct ias_attrib *attrib)
 	kfree(attrib);
 }
 
-void __irias_delete_object(struct ias_object *obj)
+void __irias_delete_object(void *_obj)
 {
+	struct ias_object *obj = _obj;
+
 	IRDA_ASSERT(obj != NULL, return;);
 	IRDA_ASSERT(obj->magic == IAS_OBJECT_MAGIC, return;);
 
 	kfree(obj->name);
 
-	hashbin_delete(obj->attribs, (FREE_FUNC) __irias_delete_attrib);
+	hashbin_delete(obj->attribs, __irias_delete_attrib);
 
 	obj->magic = ~IAS_OBJECT_MAGIC;
 
diff --git a/net/irda/irlan/irlan_client.c b/net/irda/irlan/irlan_client.c
index c5837a40c..518b358ec 100644
--- a/net/irda/irlan/irlan_client.c
+++ b/net/irda/irlan/irlan_client.c
@@ -68,7 +68,7 @@ static void irlan_check_response_param(struct irlan_cb *self, char *param,
 				       char *value, int val_len);
 static void irlan_client_open_ctrl_tsap(struct irlan_cb *self);
 
-static void irlan_client_kick_timer_expired(void *data)
+static void irlan_client_kick_timer_expired(unsigned long data)
 {
 	struct irlan_cb *self = (struct irlan_cb *) data;
 
diff --git a/net/irda/irlap.c b/net/irda/irlap.c
index 1cde711bc..d05a5fbe4 100644
--- a/net/irda/irlap.c
+++ b/net/irda/irlap.c
@@ -56,7 +56,7 @@ int sysctl_slot_timeout = SLOT_TIMEOUT * 1000 / HZ;
 int sysctl_warn_noreply_time = 3;
 
 extern void irlap_queue_xmit(struct irlap_cb *self, struct sk_buff *skb);
-static void __irlap_close(struct irlap_cb *self);
+static void __irlap_close(void *_self);
 static void irlap_init_qos_capabilities(struct irlap_cb *self,
 					struct qos_info *qos_user);
 
@@ -95,7 +95,7 @@ void irlap_cleanup(void)
 {
 	IRDA_ASSERT(irlap != NULL, return;);
 
-	hashbin_delete(irlap, (FREE_FUNC) __irlap_close);
+	hashbin_delete(irlap, __irlap_close);
 }
 
 /*
@@ -177,8 +177,10 @@ EXPORT_SYMBOL(irlap_open);
  *    Remove IrLAP and all allocated memory. Stop any pending timers.
  *
  */
-static void __irlap_close(struct irlap_cb *self)
+static void __irlap_close(void *_self)
 {
+	struct irlap_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == LAP_MAGIC, return;);
 
@@ -482,6 +484,11 @@ void irlap_disconnect_indication(struct irlap_cb *self, LAP_REASON reason)
  *    Start one single discovery operation.
  *
  */
+static void irlap_kfree(void *arg)
+{
+	kfree(arg);
+}
+
 void irlap_discovery_request(struct irlap_cb *self, discovery_t *discovery)
 {
 	struct irlap_info info;
@@ -513,7 +520,7 @@ void irlap_discovery_request(struct irlap_cb *self, discovery_t *discovery)
 	/* Check if last discovery request finished in time, or if
 	 * it was aborted due to the media busy flag. */
 	if (self->discovery_log != NULL) {
-		hashbin_delete(self->discovery_log, (FREE_FUNC) kfree);
+		hashbin_delete(self->discovery_log, irlap_kfree);
 		self->discovery_log = NULL;
 	}
 
diff --git a/net/irda/irlap_event.c b/net/irda/irlap_event.c
index 0e1b4d79f..7e39b1270 100644
--- a/net/irda/irlap_event.c
+++ b/net/irda/irlap_event.c
@@ -163,7 +163,7 @@ static int (*state[])(struct irlap_cb *self, IRLAP_EVENT event,
  *    Poll timer has expired. Normally we must now send a RR frame to the
  *    remote device
  */
-static void irlap_poll_timer_expired(void *data)
+static void irlap_poll_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
diff --git a/net/irda/irlmp.c b/net/irda/irlmp.c
index 43964594a..cbf44c25b 100644
--- a/net/irda/irlmp.c
+++ b/net/irda/irlmp.c
@@ -125,6 +125,11 @@ int __init irlmp_init(void)
  *    Remove IrLMP layer
  *
  */
+void irlmp_kfree(void *arg)
+{
+	kfree(arg);
+}
+
 void irlmp_cleanup(void)
 {
 	/* Check for main structure */
@@ -133,11 +138,11 @@ void irlmp_cleanup(void)
 
 	del_timer(&irlmp->discovery_timer);
 
-	hashbin_delete(irlmp->links, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->unconnected_lsaps, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->clients, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->services, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->cachelog, (FREE_FUNC) kfree);
+	hashbin_delete(irlmp->links, irlmp_kfree);
+	hashbin_delete(irlmp->unconnected_lsaps, irlmp_kfree);
+	hashbin_delete(irlmp->clients, irlmp_kfree);
+	hashbin_delete(irlmp->services, irlmp_kfree);
+	hashbin_delete(irlmp->cachelog, irlmp_kfree);
 
 	/* De-allocate main structure */
 	kfree(irlmp);
@@ -204,8 +209,10 @@ EXPORT_SYMBOL(irlmp_open_lsap);
  *
  *    Remove an instance of LSAP
  */
-static void __irlmp_close_lsap(struct lsap_cb *self)
+static void __irlmp_close_lsap(void *_self)
 {
+	struct lsap_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == LMP_LSAP_MAGIC, return;);
 
@@ -354,7 +361,7 @@ void irlmp_unregister_link(__u32 saddr)
 		/* Final cleanup */
 		del_timer(&link->idle_timer);
 		link->magic = 0;
-		hashbin_delete(link->lsaps, (FREE_FUNC) __irlmp_close_lsap);
+		hashbin_delete(link->lsaps, __irlmp_close_lsap);
 		kfree(link);
 	}
 }
diff --git a/net/irda/irlmp_event.c b/net/irda/irlmp_event.c
index e306cf2c1..e6e0e9042 100644
--- a/net/irda/irlmp_event.c
+++ b/net/irda/irlmp_event.c
@@ -165,7 +165,7 @@ void irlmp_do_lap_event(struct lap_cb *self, IRLMP_EVENT event,
 	(*lap_state[self->lap_state]) (self, event, skb);
 }
 
-void irlmp_discovery_timer_expired(void *data)
+void irlmp_discovery_timer_expired(unsigned long data)
 {
 	/* We always cleanup the log (active & passive discovery) */
 	irlmp_do_expiry();
@@ -176,7 +176,7 @@ void irlmp_discovery_timer_expired(void *data)
 	irlmp_start_discovery_timer(irlmp, sysctl_discovery_timeout * HZ);
 }
 
-void irlmp_watchdog_timer_expired(void *data)
+void irlmp_watchdog_timer_expired(unsigned long data)
 {
 	struct lsap_cb *self = (struct lsap_cb *) data;
 
@@ -186,7 +186,7 @@ void irlmp_watchdog_timer_expired(void *data)
 	irlmp_do_lsap_event(self, LM_WATCHDOG_TIMEOUT, NULL);
 }
 
-void irlmp_idle_timer_expired(void *data)
+void irlmp_idle_timer_expired(unsigned long data)
 {
 	struct lap_cb *self = (struct lap_cb *) data;
 
diff --git a/net/irda/irnet/irnet.h b/net/irda/irnet/irnet.h
index 8d65bb947..677364be9 100644
--- a/net/irda/irnet/irnet.h
+++ b/net/irda/irnet/irnet.h
@@ -511,7 +511,7 @@ typedef struct irnet_ctrl_channel
 /* -------------------------- IRDA PART -------------------------- */
 int irda_irnet_create(irnet_socket *);	/* Initialise an IrNET socket */
 int irda_irnet_connect(irnet_socket *);	/* Try to connect over IrDA */
-void irda_irnet_destroy(irnet_socket *);	/* Teardown an IrNET socket */
+void irda_irnet_destroy(void *);	/* Teardown an IrNET socket */
 int irda_irnet_init(void);		/* Initialise IrDA part of IrNET */
 void irda_irnet_cleanup(void);		/* Teardown IrDA part of IrNET */
 
diff --git a/net/irda/irnet/irnet_irda.c b/net/irda/irnet/irnet_irda.c
index 7f17a8020..98575e102 100644
--- a/net/irda/irnet/irnet_irda.c
+++ b/net/irda/irnet/irnet_irda.c
@@ -613,8 +613,10 @@ irda_irnet_connect(irnet_socket *	self)
  * Note : this need to be called from a process context.
  */
 void
-irda_irnet_destroy(irnet_socket *	self)
+irda_irnet_destroy(void *_self)
 {
+  irnet_socket *self = _self;
+
   DENTER(IRDA_SOCK_TRACE, "(self=0x%p)\n", self);
   if(self == NULL)
     return;
@@ -1879,7 +1881,7 @@ irda_irnet_cleanup(void)
   irnet_destroy_server();
 
   /* Remove all instances of IrNET socket still present */
-  hashbin_delete(irnet_server.list, (FREE_FUNC) irda_irnet_destroy);
+  hashbin_delete(irnet_server.list, irda_irnet_destroy);
 
   DEXIT(MODULE_TRACE, "\n");
 }
diff --git a/net/irda/irproc.c b/net/irda/irproc.c
index b9ac598e2..f88cc5627 100644
--- a/net/irda/irproc.c
+++ b/net/irda/irproc.c
@@ -66,7 +66,7 @@ void __init irda_proc_register(void)
 {
 	int i;
 
-	proc_irda = proc_mkdir("irda", init_net.proc_net);
+	proc_irda = proc_mkdir_restrict("irda", init_net.proc_net);
 	if (proc_irda == NULL)
 		return;
 
diff --git a/net/irda/irttp.c b/net/irda/irttp.c
index b6ab41d5b..e2263ce4b 100644
--- a/net/irda/irttp.c
+++ b/net/irda/irttp.c
@@ -42,7 +42,7 @@
 
 static struct irttp_cb *irttp;
 
-static void __irttp_close_tsap(struct tsap_cb *self);
+static void __irttp_close_tsap(void *_self);
 
 static int irttp_data_indication(void *instance, void *sap,
 				 struct sk_buff *skb);
@@ -121,7 +121,7 @@ void irttp_cleanup(void)
 	/*
 	 *  Delete hashbin and close all TSAP instances in it
 	 */
-	hashbin_delete(irttp->tsaps, (FREE_FUNC) __irttp_close_tsap);
+	hashbin_delete(irttp->tsaps, __irttp_close_tsap);
 
 	irttp->magic = 0;
 
@@ -469,8 +469,10 @@ EXPORT_SYMBOL(irttp_open_tsap);
  *    deallocation of the TSAP, and resetting of the TSAPs values;
  *
  */
-static void __irttp_close_tsap(struct tsap_cb *self)
+static void __irttp_close_tsap(void *_self)
 {
+	struct tsap_cb *self = _self;
+
 	/* First make sure we're connected. */
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == TTP_TSAP_MAGIC, return;);
diff --git a/net/irda/timer.c b/net/irda/timer.c
index f2280f73b..c0a006fa7 100644
--- a/net/irda/timer.c
+++ b/net/irda/timer.c
@@ -34,12 +34,12 @@
 
 extern int  sysctl_slot_timeout;
 
-static void irlap_slot_timer_expired(void* data);
-static void irlap_query_timer_expired(void* data);
-static void irlap_final_timer_expired(void* data);
-static void irlap_wd_timer_expired(void* data);
-static void irlap_backoff_timer_expired(void* data);
-static void irlap_media_busy_expired(void* data);
+static void irlap_slot_timer_expired(unsigned long data);
+static void irlap_query_timer_expired(unsigned long data);
+static void irlap_final_timer_expired(unsigned long data);
+static void irlap_wd_timer_expired(unsigned long data);
+static void irlap_backoff_timer_expired(unsigned long data);
+static void irlap_media_busy_expired(unsigned long data);
 
 void irlap_start_slot_timer(struct irlap_cb *self, int timeout)
 {
@@ -138,7 +138,7 @@ void irlmp_stop_idle_timer(struct lap_cb *self)
  *    IrLAP slot timer has expired
  *
  */
-static void irlap_slot_timer_expired(void *data)
+static void irlap_slot_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -154,7 +154,7 @@ static void irlap_slot_timer_expired(void *data)
  *    IrLAP query timer has expired
  *
  */
-static void irlap_query_timer_expired(void *data)
+static void irlap_query_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -170,7 +170,7 @@ static void irlap_query_timer_expired(void *data)
  *
  *
  */
-static void irlap_final_timer_expired(void *data)
+static void irlap_final_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -186,7 +186,7 @@ static void irlap_final_timer_expired(void *data)
  *
  *
  */
-static void irlap_wd_timer_expired(void *data)
+static void irlap_wd_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -202,7 +202,7 @@ static void irlap_wd_timer_expired(void *data)
  *
  *
  */
-static void irlap_backoff_timer_expired(void *data)
+static void irlap_backoff_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -218,7 +218,7 @@ static void irlap_backoff_timer_expired(void *data)
  *
  *
  */
-static void irlap_media_busy_expired(void *data)
+static void irlap_media_busy_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
diff --git a/net/iucv/af_iucv.c b/net/iucv/af_iucv.c
index 02b45a8e8..1c09f9245 100644
--- a/net/iucv/af_iucv.c
+++ b/net/iucv/af_iucv.c
@@ -688,10 +688,10 @@ static void __iucv_auto_name(struct iucv_sock *iucv)
 {
 	char name[12];
 
-	sprintf(name, "%08x", atomic_inc_return(&iucv_sk_list.autobind_name));
+	sprintf(name, "%08x", atomic_inc_return_unchecked(&iucv_sk_list.autobind_name));
 	while (__iucv_get_sock_by_name(name)) {
 		sprintf(name, "%08x",
-			atomic_inc_return(&iucv_sk_list.autobind_name));
+			atomic_inc_return_unchecked(&iucv_sk_list.autobind_name));
 	}
 	memcpy(iucv->src_name, name, 8);
 }
@@ -1350,7 +1350,7 @@ static int iucv_sock_recvmsg(struct socket *sock, struct msghdr *msg,
 	unsigned int copied, rlen;
 	struct sk_buff *skb, *rskb, *cskb;
 	int err = 0;
-	u32 offset;
+	u32 offset, class;
 
 	if ((sk->sk_state == IUCV_DISCONN) &&
 	    skb_queue_empty(&iucv->backlog_skb_q) &&
@@ -1394,9 +1394,8 @@ static int iucv_sock_recvmsg(struct socket *sock, struct msghdr *msg,
 	/* create control message to store iucv msg target class:
 	 * get the trgcls from the control buffer of the skb due to
 	 * fragmentation of original iucv message. */
-	err = put_cmsg(msg, SOL_IUCV, SCM_IUCV_TRGCLS,
-		       sizeof(IUCV_SKB_CB(skb)->class),
-		       (void *)&IUCV_SKB_CB(skb)->class);
+	class = IUCV_SKB_CB(skb)->class;
+	err = put_cmsg(msg, SOL_IUCV, SCM_IUCV_TRGCLS, sizeof(class), &class);
 	if (err) {
 		if (!(flags & MSG_PEEK))
 			skb_queue_head(&sk->sk_receive_queue, skb);
diff --git a/net/iucv/iucv.c b/net/iucv/iucv.c
index 88a2a3ba4..db2037a75 100644
--- a/net/iucv/iucv.c
+++ b/net/iucv/iucv.c
@@ -720,7 +720,7 @@ static int iucv_cpu_notify(struct notifier_block *self,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block __refdata iucv_cpu_notifier = {
+static struct notifier_block iucv_cpu_notifier = {
 	.notifier_call = iucv_cpu_notify,
 };
 
diff --git a/net/key/af_key.c b/net/key/af_key.c
index f9c9ecb0c..060751eef 100644
--- a/net/key/af_key.c
+++ b/net/key/af_key.c
@@ -3050,10 +3050,10 @@ static int pfkey_send_policy_notify(struct xfrm_policy *xp, int dir, const struc
 static u32 get_acqseq(void)
 {
 	u32 res;
-	static atomic_t acqseq;
+	static atomic_unchecked_t acqseq;
 
 	do {
-		res = atomic_inc_return(&acqseq);
+		res = atomic_inc_return_unchecked(&acqseq);
 	} while (!res);
 	return res;
 }
diff --git a/net/l2tp/l2tp_eth.c b/net/l2tp/l2tp_eth.c
index 57fc5a46c..310e75be6 100644
--- a/net/l2tp/l2tp_eth.c
+++ b/net/l2tp/l2tp_eth.c
@@ -42,12 +42,12 @@ struct l2tp_eth {
 	struct sock		*tunnel_sock;
 	struct l2tp_session	*session;
 	struct list_head	list;
-	atomic_long_t		tx_bytes;
-	atomic_long_t		tx_packets;
-	atomic_long_t		tx_dropped;
-	atomic_long_t		rx_bytes;
-	atomic_long_t		rx_packets;
-	atomic_long_t		rx_errors;
+	atomic_long_unchecked_t	tx_bytes;
+	atomic_long_unchecked_t	tx_packets;
+	atomic_long_unchecked_t	tx_dropped;
+	atomic_long_unchecked_t	rx_bytes;
+	atomic_long_unchecked_t	rx_packets;
+	atomic_long_unchecked_t	rx_errors;
 };
 
 /* via l2tp_session_priv() */
@@ -90,7 +90,7 @@ static void l2tp_eth_dev_uninit(struct net_device *dev)
 	dev_put(dev);
 }
 
-static int l2tp_eth_dev_xmit(struct sk_buff *skb, struct net_device *dev)
+static netdev_tx_t l2tp_eth_dev_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct l2tp_eth *priv = netdev_priv(dev);
 	struct l2tp_session *session = priv->session;
@@ -98,10 +98,10 @@ static int l2tp_eth_dev_xmit(struct sk_buff *skb, struct net_device *dev)
 	int ret = l2tp_xmit_skb(session, skb, session->hdr_len);
 
 	if (likely(ret == NET_XMIT_SUCCESS)) {
-		atomic_long_add(len, &priv->tx_bytes);
-		atomic_long_inc(&priv->tx_packets);
+		atomic_long_add_unchecked(len, &priv->tx_bytes);
+		atomic_long_inc_unchecked(&priv->tx_packets);
 	} else {
-		atomic_long_inc(&priv->tx_dropped);
+		atomic_long_inc_unchecked(&priv->tx_dropped);
 	}
 	return NETDEV_TX_OK;
 }
@@ -111,12 +111,12 @@ static struct rtnl_link_stats64 *l2tp_eth_get_stats64(struct net_device *dev,
 {
 	struct l2tp_eth *priv = netdev_priv(dev);
 
-	stats->tx_bytes   = atomic_long_read(&priv->tx_bytes);
-	stats->tx_packets = atomic_long_read(&priv->tx_packets);
-	stats->tx_dropped = atomic_long_read(&priv->tx_dropped);
-	stats->rx_bytes   = atomic_long_read(&priv->rx_bytes);
-	stats->rx_packets = atomic_long_read(&priv->rx_packets);
-	stats->rx_errors  = atomic_long_read(&priv->rx_errors);
+	stats->tx_bytes   = atomic_long_read_unchecked(&priv->tx_bytes);
+	stats->tx_packets = atomic_long_read_unchecked(&priv->tx_packets);
+	stats->tx_dropped = atomic_long_read_unchecked(&priv->tx_dropped);
+	stats->rx_bytes   = atomic_long_read_unchecked(&priv->rx_bytes);
+	stats->rx_packets = atomic_long_read_unchecked(&priv->rx_packets);
+	stats->rx_errors  = atomic_long_read_unchecked(&priv->rx_errors);
 	return stats;
 }
 
@@ -167,15 +167,15 @@ static void l2tp_eth_dev_recv(struct l2tp_session *session, struct sk_buff *skb,
 	nf_reset(skb);
 
 	if (dev_forward_skb(dev, skb) == NET_RX_SUCCESS) {
-		atomic_long_inc(&priv->rx_packets);
-		atomic_long_add(data_len, &priv->rx_bytes);
+		atomic_long_inc_unchecked(&priv->rx_packets);
+		atomic_long_add_unchecked(data_len, &priv->rx_bytes);
 	} else {
-		atomic_long_inc(&priv->rx_errors);
+		atomic_long_inc_unchecked(&priv->rx_errors);
 	}
 	return;
 
 error:
-	atomic_long_inc(&priv->rx_errors);
+	atomic_long_inc_unchecked(&priv->rx_errors);
 	kfree_skb(skb);
 }
 
diff --git a/net/l2tp/l2tp_ip.c b/net/l2tp/l2tp_ip.c
index d0e906d39..a6abcf4b9 100644
--- a/net/l2tp/l2tp_ip.c
+++ b/net/l2tp/l2tp_ip.c
@@ -611,7 +611,7 @@ static struct inet_protosw l2tp_ip_protosw = {
 	.ops		= &l2tp_ip_ops,
 };
 
-static struct net_protocol l2tp_ip_protocol __read_mostly = {
+static const struct net_protocol l2tp_ip_protocol = {
 	.handler	= l2tp_ip_recv,
 	.netns_ok	= 1,
 };
diff --git a/net/l2tp/l2tp_ip6.c b/net/l2tp/l2tp_ip6.c
index b9c6a412b..95592d6fe 100644
--- a/net/l2tp/l2tp_ip6.c
+++ b/net/l2tp/l2tp_ip6.c
@@ -772,7 +772,7 @@ static struct inet_protosw l2tp_ip6_protosw = {
 	.ops		= &l2tp_ip6_ops,
 };
 
-static struct inet6_protocol l2tp_ip6_protocol __read_mostly = {
+static const struct inet6_protocol l2tp_ip6_protocol = {
 	.handler	= l2tp_ip6_recv,
 };
 
diff --git a/net/llc/llc_proc.c b/net/llc/llc_proc.c
index 29c509c54..c19322a9c 100644
--- a/net/llc/llc_proc.c
+++ b/net/llc/llc_proc.c
@@ -247,7 +247,7 @@ int __init llc_proc_init(void)
 	int rc = -ENOMEM;
 	struct proc_dir_entry *p;
 
-	llc_proc_dir = proc_mkdir("llc", init_net.proc_net);
+	llc_proc_dir = proc_mkdir_restrict("llc", init_net.proc_net);
 	if (!llc_proc_dir)
 		goto out;
 
diff --git a/net/mac80211/aes_ccm.c b/net/mac80211/aes_ccm.c
index 7663c28ba..a4e0d59a4 100644
--- a/net/mac80211/aes_ccm.c
+++ b/net/mac80211/aes_ccm.c
@@ -18,21 +18,24 @@
 #include "key.h"
 #include "aes_ccm.h"
 
-void ieee80211_aes_ccm_encrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
-			       u8 *data, size_t data_len, u8 *mic,
-			       size_t mic_len)
+int ieee80211_aes_ccm_encrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
+			      u8 *data, size_t data_len, u8 *mic,
+			      size_t mic_len)
 {
 	struct scatterlist sg[3];
+	struct aead_request *aead_req;
+	int reqsize = sizeof(*aead_req) + crypto_aead_reqsize(tfm);
+	u8 *__aad;
 
-	char aead_req_data[sizeof(struct aead_request) +
-			   crypto_aead_reqsize(tfm)]
-		__aligned(__alignof__(struct aead_request));
-	struct aead_request *aead_req = (void *) aead_req_data;
+	aead_req = kzalloc(reqsize + CCM_AAD_LEN, GFP_ATOMIC);
+	if (!aead_req)
+		return -ENOMEM;
 
-	memset(aead_req, 0, sizeof(aead_req_data));
+	__aad = (u8 *)aead_req + reqsize;
+	memcpy(__aad, aad, CCM_AAD_LEN);
 
 	sg_init_table(sg, 3);
-	sg_set_buf(&sg[0], &aad[2], be16_to_cpup((__be16 *)aad));
+	sg_set_buf(&sg[0], &__aad[2], be16_to_cpup((__be16 *)__aad));
 	sg_set_buf(&sg[1], data, data_len);
 	sg_set_buf(&sg[2], mic, mic_len);
 
@@ -41,6 +44,9 @@ void ieee80211_aes_ccm_encrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
 	aead_request_set_ad(aead_req, sg[0].length);
 
 	crypto_aead_encrypt(aead_req);
+	kzfree(aead_req);
+
+	return 0;
 }
 
 int ieee80211_aes_ccm_decrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
@@ -48,18 +54,23 @@ int ieee80211_aes_ccm_decrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
 			      size_t mic_len)
 {
 	struct scatterlist sg[3];
-	char aead_req_data[sizeof(struct aead_request) +
-			   crypto_aead_reqsize(tfm)]
-		__aligned(__alignof__(struct aead_request));
-	struct aead_request *aead_req = (void *) aead_req_data;
+	struct aead_request *aead_req;
+	int reqsize = sizeof(*aead_req) + crypto_aead_reqsize(tfm);
+	u8 *__aad;
+	int err;
 
 	if (data_len == 0)
 		return -EINVAL;
 
-	memset(aead_req, 0, sizeof(aead_req_data));
+	aead_req = kzalloc(reqsize + CCM_AAD_LEN, GFP_ATOMIC);
+	if (!aead_req)
+		return -ENOMEM;
+
+	__aad = (u8 *)aead_req + reqsize;
+	memcpy(__aad, aad, CCM_AAD_LEN);
 
 	sg_init_table(sg, 3);
-	sg_set_buf(&sg[0], &aad[2], be16_to_cpup((__be16 *)aad));
+	sg_set_buf(&sg[0], &__aad[2], be16_to_cpup((__be16 *)__aad));
 	sg_set_buf(&sg[1], data, data_len);
 	sg_set_buf(&sg[2], mic, mic_len);
 
@@ -67,7 +78,10 @@ int ieee80211_aes_ccm_decrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
 	aead_request_set_crypt(aead_req, sg, sg, data_len + mic_len, b_0);
 	aead_request_set_ad(aead_req, sg[0].length);
 
-	return crypto_aead_decrypt(aead_req);
+	err = crypto_aead_decrypt(aead_req);
+	kzfree(aead_req);
+
+	return err;
 }
 
 struct crypto_aead *ieee80211_aes_key_setup_encrypt(const u8 key[],
diff --git a/net/mac80211/aes_ccm.h b/net/mac80211/aes_ccm.h
index 6a73d1e4d..fcd3254c5 100644
--- a/net/mac80211/aes_ccm.h
+++ b/net/mac80211/aes_ccm.h
@@ -12,12 +12,14 @@
 
 #include <linux/crypto.h>
 
+#define CCM_AAD_LEN	32
+
 struct crypto_aead *ieee80211_aes_key_setup_encrypt(const u8 key[],
 						    size_t key_len,
 						    size_t mic_len);
-void ieee80211_aes_ccm_encrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
-			       u8 *data, size_t data_len, u8 *mic,
-			       size_t mic_len);
+int ieee80211_aes_ccm_encrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
+			      u8 *data, size_t data_len, u8 *mic,
+			      size_t mic_len);
 int ieee80211_aes_ccm_decrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad,
 			      u8 *data, size_t data_len, u8 *mic,
 			      size_t mic_len);
diff --git a/net/mac80211/aes_gcm.c b/net/mac80211/aes_gcm.c
index 3afe361fd..8a4397cc1 100644
--- a/net/mac80211/aes_gcm.c
+++ b/net/mac80211/aes_gcm.c
@@ -15,20 +15,23 @@
 #include "key.h"
 #include "aes_gcm.h"
 
-void ieee80211_aes_gcm_encrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
-			       u8 *data, size_t data_len, u8 *mic)
+int ieee80211_aes_gcm_encrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
+			      u8 *data, size_t data_len, u8 *mic)
 {
 	struct scatterlist sg[3];
+	struct aead_request *aead_req;
+	int reqsize = sizeof(*aead_req) + crypto_aead_reqsize(tfm);
+	u8 *__aad;
 
-	char aead_req_data[sizeof(struct aead_request) +
-			   crypto_aead_reqsize(tfm)]
-		__aligned(__alignof__(struct aead_request));
-	struct aead_request *aead_req = (void *)aead_req_data;
+	aead_req = kzalloc(reqsize + GCM_AAD_LEN, GFP_ATOMIC);
+	if (!aead_req)
+		return -ENOMEM;
 
-	memset(aead_req, 0, sizeof(aead_req_data));
+	__aad = (u8 *)aead_req + reqsize;
+	memcpy(__aad, aad, GCM_AAD_LEN);
 
 	sg_init_table(sg, 3);
-	sg_set_buf(&sg[0], &aad[2], be16_to_cpup((__be16 *)aad));
+	sg_set_buf(&sg[0], &__aad[2], be16_to_cpup((__be16 *)__aad));
 	sg_set_buf(&sg[1], data, data_len);
 	sg_set_buf(&sg[2], mic, IEEE80211_GCMP_MIC_LEN);
 
@@ -37,24 +40,31 @@ void ieee80211_aes_gcm_encrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
 	aead_request_set_ad(aead_req, sg[0].length);
 
 	crypto_aead_encrypt(aead_req);
+	kzfree(aead_req);
+	return 0;
 }
 
 int ieee80211_aes_gcm_decrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
 			      u8 *data, size_t data_len, u8 *mic)
 {
 	struct scatterlist sg[3];
-	char aead_req_data[sizeof(struct aead_request) +
-			   crypto_aead_reqsize(tfm)]
-		__aligned(__alignof__(struct aead_request));
-	struct aead_request *aead_req = (void *)aead_req_data;
+	struct aead_request *aead_req;
+	int reqsize = sizeof(*aead_req) + crypto_aead_reqsize(tfm);
+	u8 *__aad;
+	int err;
 
 	if (data_len == 0)
 		return -EINVAL;
 
-	memset(aead_req, 0, sizeof(aead_req_data));
+	aead_req = kzalloc(reqsize + GCM_AAD_LEN, GFP_ATOMIC);
+	if (!aead_req)
+		return -ENOMEM;
+
+	__aad = (u8 *)aead_req + reqsize;
+	memcpy(__aad, aad, GCM_AAD_LEN);
 
 	sg_init_table(sg, 3);
-	sg_set_buf(&sg[0], &aad[2], be16_to_cpup((__be16 *)aad));
+	sg_set_buf(&sg[0], &__aad[2], be16_to_cpup((__be16 *)__aad));
 	sg_set_buf(&sg[1], data, data_len);
 	sg_set_buf(&sg[2], mic, IEEE80211_GCMP_MIC_LEN);
 
@@ -63,7 +73,10 @@ int ieee80211_aes_gcm_decrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
 			       data_len + IEEE80211_GCMP_MIC_LEN, j_0);
 	aead_request_set_ad(aead_req, sg[0].length);
 
-	return crypto_aead_decrypt(aead_req);
+	err = crypto_aead_decrypt(aead_req);
+	kzfree(aead_req);
+
+	return err;
 }
 
 struct crypto_aead *ieee80211_aes_gcm_key_setup_encrypt(const u8 key[],
diff --git a/net/mac80211/aes_gcm.h b/net/mac80211/aes_gcm.h
index 1347fda6b..55aed5352 100644
--- a/net/mac80211/aes_gcm.h
+++ b/net/mac80211/aes_gcm.h
@@ -11,8 +11,10 @@
 
 #include <linux/crypto.h>
 
-void ieee80211_aes_gcm_encrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
-			       u8 *data, size_t data_len, u8 *mic);
+#define GCM_AAD_LEN	32
+
+int ieee80211_aes_gcm_encrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
+			      u8 *data, size_t data_len, u8 *mic);
 int ieee80211_aes_gcm_decrypt(struct crypto_aead *tfm, u8 *j_0, u8 *aad,
 			      u8 *data, size_t data_len, u8 *mic);
 struct crypto_aead *ieee80211_aes_gcm_key_setup_encrypt(const u8 key[],
diff --git a/net/mac80211/aes_gmac.c b/net/mac80211/aes_gmac.c
index 3ddd927aa..bd72a862d 100644
--- a/net/mac80211/aes_gmac.c
+++ b/net/mac80211/aes_gmac.c
@@ -17,28 +17,27 @@
 #include "key.h"
 #include "aes_gmac.h"
 
-#define GMAC_MIC_LEN 16
-#define GMAC_NONCE_LEN 12
-#define AAD_LEN 20
-
 int ieee80211_aes_gmac(struct crypto_aead *tfm, const u8 *aad, u8 *nonce,
 		       const u8 *data, size_t data_len, u8 *mic)
 {
 	struct scatterlist sg[4];
-	char aead_req_data[sizeof(struct aead_request) +
-			   crypto_aead_reqsize(tfm)]
-		__aligned(__alignof__(struct aead_request));
-	struct aead_request *aead_req = (void *)aead_req_data;
-	u8 zero[GMAC_MIC_LEN], iv[AES_BLOCK_SIZE];
+	u8 *zero, *__aad, iv[AES_BLOCK_SIZE];
+	struct aead_request *aead_req;
+	int reqsize = sizeof(*aead_req) + crypto_aead_reqsize(tfm);
 
 	if (data_len < GMAC_MIC_LEN)
 		return -EINVAL;
 
-	memset(aead_req, 0, sizeof(aead_req_data));
+	aead_req = kzalloc(reqsize + GMAC_MIC_LEN + GMAC_AAD_LEN, GFP_ATOMIC);
+	if (!aead_req)
+		return -ENOMEM;
+
+	zero = (u8 *)aead_req + reqsize;
+	__aad = zero + GMAC_MIC_LEN;
+	memcpy(__aad, aad, GMAC_AAD_LEN);
 
-	memset(zero, 0, GMAC_MIC_LEN);
 	sg_init_table(sg, 4);
-	sg_set_buf(&sg[0], aad, AAD_LEN);
+	sg_set_buf(&sg[0], __aad, GMAC_AAD_LEN);
 	sg_set_buf(&sg[1], data, data_len - GMAC_MIC_LEN);
 	sg_set_buf(&sg[2], zero, GMAC_MIC_LEN);
 	sg_set_buf(&sg[3], mic, GMAC_MIC_LEN);
@@ -49,9 +48,10 @@ int ieee80211_aes_gmac(struct crypto_aead *tfm, const u8 *aad, u8 *nonce,
 
 	aead_request_set_tfm(aead_req, tfm);
 	aead_request_set_crypt(aead_req, sg, sg, 0, iv);
-	aead_request_set_ad(aead_req, AAD_LEN + data_len);
+	aead_request_set_ad(aead_req, GMAC_AAD_LEN + data_len);
 
 	crypto_aead_encrypt(aead_req);
+	kzfree(aead_req);
 
 	return 0;
 }
diff --git a/net/mac80211/aes_gmac.h b/net/mac80211/aes_gmac.h
index d328204d7..32e6442c9 100644
--- a/net/mac80211/aes_gmac.h
+++ b/net/mac80211/aes_gmac.h
@@ -11,6 +11,10 @@
 
 #include <linux/crypto.h>
 
+#define GMAC_AAD_LEN	20
+#define GMAC_MIC_LEN	16
+#define GMAC_NONCE_LEN	12
+
 struct crypto_aead *ieee80211_aes_gmac_key_setup(const u8 key[],
 						 size_t key_len);
 int ieee80211_aes_gmac(struct crypto_aead *tfm, const u8 *aad, u8 *nonce,
diff --git a/net/mac80211/cfg.c b/net/mac80211/cfg.c
index 543b1d4fc..bead45dbf 100644
--- a/net/mac80211/cfg.c
+++ b/net/mac80211/cfg.c
@@ -341,7 +341,7 @@ static int ieee80211_get_key(struct wiphy *wiphy, struct net_device *dev,
 
 	switch (key->conf.cipher) {
 	case WLAN_CIPHER_SUITE_TKIP:
-		pn64 = atomic64_read(&key->conf.tx_pn);
+		pn64 = atomic64_read_unchecked(&key->conf.tx_pn);
 		iv32 = TKIP_PN_TO_IV32(pn64);
 		iv16 = TKIP_PN_TO_IV16(pn64);
 
@@ -381,7 +381,7 @@ static int ieee80211_get_key(struct wiphy *wiphy, struct net_device *dev,
 			drv_get_key_seq(sdata->local, key, &kseq);
 			memcpy(seq, kseq.ccmp.pn, 6);
 		} else {
-			pn64 = atomic64_read(&key->conf.tx_pn);
+			pn64 = atomic64_read_unchecked(&key->conf.tx_pn);
 			seq[0] = pn64;
 			seq[1] = pn64 >> 8;
 			seq[2] = pn64 >> 16;
@@ -543,7 +543,7 @@ static int ieee80211_set_monitor_channel(struct wiphy *wiphy,
 			ret = ieee80211_vif_use_channel(sdata, chandef,
 					IEEE80211_CHANCTX_EXCLUSIVE);
 		}
-	} else if (local->open_count == local->monitors) {
+	} else if (local_read(&local->open_count) == local->monitors) {
 		local->_oper_chandef = *chandef;
 		ieee80211_hw_config(local, 0);
 	}
@@ -3074,7 +3074,7 @@ static void ieee80211_mgmt_frame_register(struct wiphy *wiphy,
 				sdata->vif.probe_req_reg--;
 		}
 
-		if (!local->open_count)
+		if (!local_read(&local->open_count))
 			break;
 
 		if (sdata->vif.probe_req_reg == 1)
@@ -3229,8 +3229,8 @@ static int ieee80211_cfg_get_channel(struct wiphy *wiphy,
 	if (chanctx_conf) {
 		*chandef = sdata->vif.bss_conf.chandef;
 		ret = 0;
-	} else if (local->open_count > 0 &&
-		   local->open_count == local->monitors &&
+	} else if (local_read(&local->open_count) > 0 &&
+		   local_read(&local->open_count) == local->monitors &&
 		   sdata->vif.type == NL80211_IFTYPE_MONITOR) {
 		if (local->use_chanctx)
 			*chandef = local->monitor_chandef;
diff --git a/net/mac80211/debugfs.c b/net/mac80211/debugfs.c
index 2906c1004..65d1f4476 100644
--- a/net/mac80211/debugfs.c
+++ b/net/mac80211/debugfs.c
@@ -263,7 +263,7 @@ static const struct file_operations reset_ops = {
 };
 #endif
 
-static const char *hw_flag_names[] = {
+static const char * const hw_flag_names[] = {
 #define FLAG(F)	[IEEE80211_HW_##F] = #F
 	FLAG(HAS_RATE_CONTROL),
 	FLAG(RX_INCLUDES_FCS),
diff --git a/net/mac80211/debugfs_key.c b/net/mac80211/debugfs_key.c
index a2ef95f16..5adf27db7 100644
--- a/net/mac80211/debugfs_key.c
+++ b/net/mac80211/debugfs_key.c
@@ -111,7 +111,7 @@ static ssize_t key_tx_spec_write(struct file *file, const char __user *userbuf,
 		/* PN is a 48-bit counter */
 		if (pn >= (1ULL << 48))
 			return -ERANGE;
-		atomic64_set(&key->conf.tx_pn, pn);
+		atomic64_set_unchecked(&key->conf.tx_pn, pn);
 		return count;
 	default:
 		return 0;
@@ -132,7 +132,7 @@ static ssize_t key_tx_spec_read(struct file *file, char __user *userbuf,
 		len = scnprintf(buf, sizeof(buf), "\n");
 		break;
 	case WLAN_CIPHER_SUITE_TKIP:
-		pn = atomic64_read(&key->conf.tx_pn);
+		pn = atomic64_read_unchecked(&key->conf.tx_pn);
 		len = scnprintf(buf, sizeof(buf), "%08x %04x\n",
 				TKIP_PN_TO_IV32(pn),
 				TKIP_PN_TO_IV16(pn));
@@ -145,7 +145,7 @@ static ssize_t key_tx_spec_read(struct file *file, char __user *userbuf,
 	case WLAN_CIPHER_SUITE_BIP_GMAC_256:
 	case WLAN_CIPHER_SUITE_GCMP:
 	case WLAN_CIPHER_SUITE_GCMP_256:
-		pn = atomic64_read(&key->conf.tx_pn);
+		pn = atomic64_read_unchecked(&key->conf.tx_pn);
 		len = scnprintf(buf, sizeof(buf), "%02x%02x%02x%02x%02x%02x\n",
 				(u8)(pn >> 40), (u8)(pn >> 32), (u8)(pn >> 24),
 				(u8)(pn >> 16), (u8)(pn >> 8), (u8)pn);
diff --git a/net/mac80211/ieee80211_i.h b/net/mac80211/ieee80211_i.h
index f56d342c3..6c01d5dd1 100644
--- a/net/mac80211/ieee80211_i.h
+++ b/net/mac80211/ieee80211_i.h
@@ -31,6 +31,7 @@
 #include <net/cfg80211.h>
 #include <net/mac80211.h>
 #include <net/fq.h>
+#include <asm/local.h>
 #include "key.h"
 #include "sta_info.h"
 #include "debug.h"
@@ -1127,7 +1128,7 @@ struct ieee80211_local {
 	/* also used to protect ampdu_ac_queue and amdpu_ac_stop_refcnt */
 	spinlock_t queue_stop_reason_lock;
 
-	int open_count;
+	local_t open_count;
 	int monitors, cooked_mntrs;
 	/* number of interfaces with corresponding FIF_ flags */
 	int fif_fcsfail, fif_plcpfail, fif_control, fif_other_bss, fif_pspoll,
diff --git a/net/mac80211/iface.c b/net/mac80211/iface.c
index b123a9e32..945cb8148 100644
--- a/net/mac80211/iface.c
+++ b/net/mac80211/iface.c
@@ -551,7 +551,7 @@ int ieee80211_do_open(struct wireless_dev *wdev, bool coming_up)
 		break;
 	}
 
-	if (local->open_count == 0) {
+	if (local_read(&local->open_count) == 0) {
 		res = drv_start(local);
 		if (res)
 			goto err_del_bss;
@@ -598,7 +598,7 @@ int ieee80211_do_open(struct wireless_dev *wdev, bool coming_up)
 			res = drv_add_interface(local, sdata);
 			if (res)
 				goto err_stop;
-		} else if (local->monitors == 0 && local->open_count == 0) {
+		} else if (local->monitors == 0 && local_read(&local->open_count) == 0) {
 			res = ieee80211_add_virtual_monitor(local);
 			if (res)
 				goto err_stop;
@@ -707,7 +707,7 @@ int ieee80211_do_open(struct wireless_dev *wdev, bool coming_up)
 		atomic_inc(&local->iff_allmultis);
 
 	if (coming_up)
-		local->open_count++;
+		local_inc(&local->open_count);
 
 	if (hw_reconf_flags)
 		ieee80211_hw_config(local, hw_reconf_flags);
@@ -745,7 +745,7 @@ int ieee80211_do_open(struct wireless_dev *wdev, bool coming_up)
  err_del_interface:
 	drv_remove_interface(local, sdata);
  err_stop:
-	if (!local->open_count)
+	if (!local_read(&local->open_count))
 		drv_stop(local);
  err_del_bss:
 	sdata->bss = NULL;
@@ -913,7 +913,7 @@ static void ieee80211_do_stop(struct ieee80211_sub_if_data *sdata,
 	}
 
 	if (going_down)
-		local->open_count--;
+		local_dec(&local->open_count);
 
 	switch (sdata->vif.type) {
 	case NL80211_IFTYPE_AP_VLAN:
@@ -983,7 +983,7 @@ static void ieee80211_do_stop(struct ieee80211_sub_if_data *sdata,
 		spin_unlock_bh(&fq->lock);
 	}
 
-	if (local->open_count == 0)
+	if (local_read(&local->open_count) == 0)
 		ieee80211_clear_tx_pending(local);
 
 	/*
@@ -1026,7 +1026,7 @@ static void ieee80211_do_stop(struct ieee80211_sub_if_data *sdata,
 	if (cancel_scan)
 		flush_delayed_work(&local->scan_work);
 
-	if (local->open_count == 0) {
+	if (local_read(&local->open_count) == 0) {
 		ieee80211_stop_device(local);
 
 		/* no reconfiguring after stop! */
@@ -1037,7 +1037,7 @@ static void ieee80211_do_stop(struct ieee80211_sub_if_data *sdata,
 	ieee80211_configure_filter(local);
 	ieee80211_hw_config(local, hw_reconf_flags);
 
-	if (local->monitors == local->open_count)
+	if (local->monitors == local_read(&local->open_count))
 		ieee80211_add_virtual_monitor(local);
 }
 
@@ -1919,8 +1919,8 @@ void ieee80211_remove_interfaces(struct ieee80211_local *local)
 	 */
 	cfg80211_shutdown_all_interfaces(local->hw.wiphy);
 
-	WARN(local->open_count, "%s: open count remains %d\n",
-	     wiphy_name(local->hw.wiphy), local->open_count);
+	WARN(local_read(&local->open_count), "%s: open count remains %ld\n",
+	     wiphy_name(local->hw.wiphy), local_read(&local->open_count));
 
 	mutex_lock(&local->iflist_mtx);
 	list_for_each_entry_safe(sdata, tmp, &local->interfaces, list) {
diff --git a/net/mac80211/main.c b/net/mac80211/main.c
index d00ea9b13..3f2e7f660 100644
--- a/net/mac80211/main.c
+++ b/net/mac80211/main.c
@@ -170,7 +170,7 @@ int ieee80211_hw_config(struct ieee80211_local *local, u32 changed)
 		changed &= ~(IEEE80211_CONF_CHANGE_CHANNEL |
 			     IEEE80211_CONF_CHANGE_POWER);
 
-	if (changed && local->open_count) {
+	if (changed && local_read(&local->open_count)) {
 		ret = drv_config(local, changed);
 		/*
 		 * Goal:
diff --git a/net/mac80211/pm.c b/net/mac80211/pm.c
index 00a43a70e..ab6deef01 100644
--- a/net/mac80211/pm.c
+++ b/net/mac80211/pm.c
@@ -19,7 +19,7 @@ int __ieee80211_suspend(struct ieee80211_hw *hw, struct cfg80211_wowlan *wowlan)
 	struct ieee80211_sub_if_data *sdata;
 	struct sta_info *sta;
 
-	if (!local->open_count)
+	if (!local_read(&local->open_count))
 		goto suspend;
 
 	ieee80211_scan_cancel(local);
@@ -178,7 +178,7 @@ int __ieee80211_suspend(struct ieee80211_hw *hw, struct cfg80211_wowlan *wowlan)
 	WARN_ON(!list_empty(&local->chanctx_list));
 
 	/* stop hardware - this must stop RX */
-	if (local->open_count)
+	if (local_read(&local->open_count))
 		ieee80211_stop_device(local);
 
  suspend:
diff --git a/net/mac80211/rate.c b/net/mac80211/rate.c
index 206698bc9..847e61021 100644
--- a/net/mac80211/rate.c
+++ b/net/mac80211/rate.c
@@ -901,7 +901,7 @@ int ieee80211_init_rate_ctrl_alg(struct ieee80211_local *local,
 
 	ASSERT_RTNL();
 
-	if (local->open_count)
+	if (local_read(&local->open_count))
 		return -EBUSY;
 
 	if (ieee80211_hw_check(&local->hw, HAS_RATE_CONTROL)) {
diff --git a/net/mac80211/sta_info.c b/net/mac80211/sta_info.c
index aa58df80e..4db13c9a7 100644
--- a/net/mac80211/sta_info.c
+++ b/net/mac80211/sta_info.c
@@ -361,7 +361,7 @@ struct sta_info *sta_info_alloc(struct ieee80211_sub_if_data *sdata,
 		int size = sizeof(struct txq_info) +
 			   ALIGN(hw->txq_data_size, sizeof(void *));
 
-		txq_data = kcalloc(ARRAY_SIZE(sta->sta.txq), size, gfp);
+		txq_data = kcalloc(size, ARRAY_SIZE(sta->sta.txq), gfp);
 		if (!txq_data)
 			goto free;
 
diff --git a/net/mac80211/tx.c b/net/mac80211/tx.c
index 18b285e06..20a4d5532 100644
--- a/net/mac80211/tx.c
+++ b/net/mac80211/tx.c
@@ -3324,7 +3324,7 @@ static bool ieee80211_xmit_fast(struct ieee80211_sub_if_data *sdata,
 		case WLAN_CIPHER_SUITE_CCMP_256:
 		case WLAN_CIPHER_SUITE_GCMP:
 		case WLAN_CIPHER_SUITE_GCMP_256:
-			pn = atomic64_inc_return(&fast_tx->key->conf.tx_pn);
+			pn = atomic64_inc_return_unchecked(&fast_tx->key->conf.tx_pn);
 			crypto_hdr[0] = pn;
 			crypto_hdr[1] = pn >> 8;
 			crypto_hdr[4] = pn >> 16;
diff --git a/net/mac80211/util.c b/net/mac80211/util.c
index 42bf0b668..8dcf0b25f 100644
--- a/net/mac80211/util.c
+++ b/net/mac80211/util.c
@@ -1762,7 +1762,7 @@ int ieee80211_reconfig(struct ieee80211_local *local)
 	bool suspended = local->suspended;
 
 	/* nothing to do if HW shouldn't run */
-	if (!local->open_count)
+	if (!local_read(&local->open_count))
 		goto wake_up;
 
 #ifdef CONFIG_PM
@@ -2068,7 +2068,7 @@ int ieee80211_reconfig(struct ieee80211_local *local)
 		mutex_unlock(&local->mtx);
 	}
 
-	if (local->monitors == local->open_count && local->monitors > 0)
+	if (local->monitors == local_read(&local->open_count) && local->monitors > 0)
 		ieee80211_add_virtual_monitor(local);
 
 	/*
@@ -2102,7 +2102,7 @@ int ieee80211_reconfig(struct ieee80211_local *local)
 	 * If this is for hw restart things are still running.
 	 * We may want to change that later, however.
 	 */
-	if (local->open_count && (!suspended || reconfig_due_to_wowlan))
+	if (local_read(&local->open_count) && (!suspended || reconfig_due_to_wowlan))
 		drv_reconfig_complete(local, IEEE80211_RECONFIG_TYPE_RESTART);
 
 	if (!suspended)
@@ -2116,7 +2116,7 @@ int ieee80211_reconfig(struct ieee80211_local *local)
 
 	ieee80211_flush_completed_scan(local, false);
 
-	if (local->open_count && !reconfig_due_to_wowlan)
+	if (local_read(&local->open_count) && !reconfig_due_to_wowlan)
 		drv_reconfig_complete(local, IEEE80211_RECONFIG_TYPE_SUSPEND);
 
 	list_for_each_entry(sdata, &local->interfaces, list) {
diff --git a/net/mac80211/wpa.c b/net/mac80211/wpa.c
index b48c1e13e..36ee4c265 100644
--- a/net/mac80211/wpa.c
+++ b/net/mac80211/wpa.c
@@ -223,7 +223,7 @@ static int tkip_encrypt_skb(struct ieee80211_tx_data *tx, struct sk_buff *skb)
 		return 0;
 
 	/* Increase IV for the frame */
-	pn = atomic64_inc_return(&key->conf.tx_pn);
+	pn = atomic64_inc_return_unchecked(&key->conf.tx_pn);
 	pos = ieee80211_tkip_add_iv(pos, &key->conf, pn);
 
 	/* hwaccel - with software IV */
@@ -405,7 +405,7 @@ static int ccmp_encrypt_skb(struct ieee80211_tx_data *tx, struct sk_buff *skb,
 	u8 *pos;
 	u8 pn[6];
 	u64 pn64;
-	u8 aad[2 * AES_BLOCK_SIZE];
+	u8 aad[CCM_AAD_LEN];
 	u8 b_0[AES_BLOCK_SIZE];
 
 	if (info->control.hw_key &&
@@ -444,7 +444,7 @@ static int ccmp_encrypt_skb(struct ieee80211_tx_data *tx, struct sk_buff *skb,
 	hdr = (struct ieee80211_hdr *) pos;
 	pos += hdrlen;
 
-	pn64 = atomic64_inc_return(&key->conf.tx_pn);
+	pn64 = atomic64_inc_return_unchecked(&key->conf.tx_pn);
 
 	pn[5] = pn64;
 	pn[4] = pn64 >> 8;
@@ -461,10 +461,8 @@ static int ccmp_encrypt_skb(struct ieee80211_tx_data *tx, struct sk_buff *skb,
 
 	pos += IEEE80211_CCMP_HDR_LEN;
 	ccmp_special_blocks(skb, pn, b_0, aad);
-	ieee80211_aes_ccm_encrypt(key->u.ccmp.tfm, b_0, aad, pos, len,
-				  skb_put(skb, mic_len), mic_len);
-
-	return 0;
+	return ieee80211_aes_ccm_encrypt(key->u.ccmp.tfm, b_0, aad, pos, len,
+					 skb_put(skb, mic_len), mic_len);
 }
 
 
@@ -639,7 +637,7 @@ static int gcmp_encrypt_skb(struct ieee80211_tx_data *tx, struct sk_buff *skb)
 	u8 *pos;
 	u8 pn[6];
 	u64 pn64;
-	u8 aad[2 * AES_BLOCK_SIZE];
+	u8 aad[GCM_AAD_LEN];
 	u8 j_0[AES_BLOCK_SIZE];
 
 	if (info->control.hw_key &&
@@ -679,7 +677,7 @@ static int gcmp_encrypt_skb(struct ieee80211_tx_data *tx, struct sk_buff *skb)
 	hdr = (struct ieee80211_hdr *)pos;
 	pos += hdrlen;
 
-	pn64 = atomic64_inc_return(&key->conf.tx_pn);
+	pn64 = atomic64_inc_return_unchecked(&key->conf.tx_pn);
 
 	pn[5] = pn64;
 	pn[4] = pn64 >> 8;
@@ -696,10 +694,8 @@ static int gcmp_encrypt_skb(struct ieee80211_tx_data *tx, struct sk_buff *skb)
 
 	pos += IEEE80211_GCMP_HDR_LEN;
 	gcmp_special_blocks(skb, pn, j_0, aad);
-	ieee80211_aes_gcm_encrypt(key->u.gcmp.tfm, j_0, aad, pos, len,
-				  skb_put(skb, IEEE80211_GCMP_MIC_LEN));
-
-	return 0;
+	return ieee80211_aes_gcm_encrypt(key->u.gcmp.tfm, j_0, aad, pos, len,
+					 skb_put(skb, IEEE80211_GCMP_MIC_LEN));
 }
 
 ieee80211_tx_result
@@ -957,7 +953,7 @@ ieee80211_crypto_aes_cmac_encrypt(struct ieee80211_tx_data *tx)
 	mmie->key_id = cpu_to_le16(key->conf.keyidx);
 
 	/* PN = PN + 1 */
-	pn64 = atomic64_inc_return(&key->conf.tx_pn);
+	pn64 = atomic64_inc_return_unchecked(&key->conf.tx_pn);
 
 	bip_ipn_set64(mmie->sequence_number, pn64);
 
@@ -1001,7 +997,7 @@ ieee80211_crypto_aes_cmac_256_encrypt(struct ieee80211_tx_data *tx)
 	mmie->key_id = cpu_to_le16(key->conf.keyidx);
 
 	/* PN = PN + 1 */
-	pn64 = atomic64_inc_return(&key->conf.tx_pn);
+	pn64 = atomic64_inc_return_unchecked(&key->conf.tx_pn);
 
 	bip_ipn_set64(mmie->sequence_number, pn64);
 
@@ -1123,9 +1119,9 @@ ieee80211_crypto_aes_gmac_encrypt(struct ieee80211_tx_data *tx)
 	struct ieee80211_key *key = tx->key;
 	struct ieee80211_mmie_16 *mmie;
 	struct ieee80211_hdr *hdr;
-	u8 aad[20];
+	u8 aad[GMAC_AAD_LEN];
 	u64 pn64;
-	u8 nonce[12];
+	u8 nonce[GMAC_NONCE_LEN];
 
 	if (WARN_ON(skb_queue_len(&tx->skbs) != 1))
 		return TX_DROP;
@@ -1146,7 +1142,7 @@ ieee80211_crypto_aes_gmac_encrypt(struct ieee80211_tx_data *tx)
 	mmie->key_id = cpu_to_le16(key->conf.keyidx);
 
 	/* PN = PN + 1 */
-	pn64 = atomic64_inc_return(&key->conf.tx_pn);
+	pn64 = atomic64_inc_return_unchecked(&key->conf.tx_pn);
 
 	bip_ipn_set64(mmie->sequence_number, pn64);
 
@@ -1171,7 +1167,7 @@ ieee80211_crypto_aes_gmac_decrypt(struct ieee80211_rx_data *rx)
 	struct ieee80211_rx_status *status = IEEE80211_SKB_RXCB(skb);
 	struct ieee80211_key *key = rx->key;
 	struct ieee80211_mmie_16 *mmie;
-	u8 aad[20], mic[16], ipn[6], nonce[12];
+	u8 aad[GMAC_AAD_LEN], mic[GMAC_MIC_LEN], ipn[6], nonce[GMAC_NONCE_LEN];
 	struct ieee80211_hdr *hdr = (struct ieee80211_hdr *)skb->data;
 
 	if (!ieee80211_is_mgmt(hdr->frame_control))
diff --git a/net/mac802154/iface.c b/net/mac802154/iface.c
index 7079cd32a..c299f0858 100644
--- a/net/mac802154/iface.c
+++ b/net/mac802154/iface.c
@@ -386,7 +386,7 @@ static int ieee802154_header_create(struct sk_buff *skb,
 	hdr.fc.type = cb->type;
 	hdr.fc.security_enabled = cb->secen;
 	hdr.fc.ack_request = cb->ackreq;
-	hdr.seq = atomic_inc_return(&dev->ieee802154_ptr->dsn) & 0xFF;
+	hdr.seq = atomic_inc_return_unchecked(&dev->ieee802154_ptr->dsn) & 0xFF;
 
 	if (mac802154_set_header_security(sdata, &hdr, cb) < 0)
 		return -EINVAL;
@@ -451,7 +451,7 @@ static int mac802154_header_create(struct sk_buff *skb,
 	memset(&hdr.fc, 0, sizeof(hdr.fc));
 	hdr.fc.type = IEEE802154_FC_TYPE_DATA;
 	hdr.fc.ack_request = wpan_dev->ackreq;
-	hdr.seq = atomic_inc_return(&dev->ieee802154_ptr->dsn) & 0xFF;
+	hdr.seq = atomic_inc_return_unchecked(&dev->ieee802154_ptr->dsn) & 0xFF;
 
 	/* TODO currently a workaround to give zero cb block to set
 	 * security parameters defaults according MIB.
@@ -576,7 +576,7 @@ ieee802154_setup_sdata(struct ieee802154_sub_if_data *sdata,
 	get_random_bytes(&tmp, sizeof(tmp));
 	atomic_set(&wpan_dev->bsn, tmp);
 	get_random_bytes(&tmp, sizeof(tmp));
-	atomic_set(&wpan_dev->dsn, tmp);
+	atomic_set_unchecked(&wpan_dev->dsn, tmp);
 
 	/* defaults per 802.15.4-2011 */
 	wpan_dev->min_be = 3;
diff --git a/net/mpls/af_mpls.c b/net/mpls/af_mpls.c
index 5c161e775..7bb4ebaa1 100644
--- a/net/mpls/af_mpls.c
+++ b/net/mpls/af_mpls.c
@@ -871,7 +871,7 @@ static int mpls_dev_sysctl_register(struct net_device *dev,
 				    struct mpls_dev *mdev)
 {
 	char path[sizeof("net/mpls/conf/") + IFNAMSIZ];
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 	int i;
 
 	table = kmemdup(&mpls_dev_table, sizeof(mpls_dev_table), GFP_KERNEL);
@@ -954,7 +954,7 @@ static void mpls_ifdown(struct net_device *dev, int event)
 				/* fall through */
 			case NETDEV_CHANGE:
 				nh->nh_flags |= RTNH_F_LINKDOWN;
-				ACCESS_ONCE(rt->rt_nhn_alive) = rt->rt_nhn_alive - 1;
+				ACCESS_ONCE_RW(rt->rt_nhn_alive) = rt->rt_nhn_alive - 1;
 				break;
 			}
 			if (event == NETDEV_UNREGISTER)
@@ -995,7 +995,7 @@ static void mpls_ifup(struct net_device *dev, unsigned int nh_flags)
 			nh->nh_flags &= ~nh_flags;
 		} endfor_nexthops(rt);
 
-		ACCESS_ONCE(rt->rt_nhn_alive) = alive;
+		ACCESS_ONCE_RW(rt->rt_nhn_alive) = alive;
 	}
 
 	return;
@@ -1624,7 +1624,7 @@ static int mpls_platform_labels(struct ctl_table *table, int write,
 	struct net *net = table->data;
 	int platform_labels = net->mpls.platform_labels;
 	int ret;
-	struct ctl_table tmp = {
+	ctl_table_no_const tmp = {
 		.procname	= table->procname,
 		.data		= &platform_labels,
 		.maxlen		= sizeof(int),
@@ -1654,7 +1654,7 @@ static const struct ctl_table mpls_table[] = {
 
 static int mpls_net_init(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	net->mpls.platform_labels = 0;
 	net->mpls.platform_label = NULL;
diff --git a/net/netfilter/Kconfig b/net/netfilter/Kconfig
index 9266ceebd..767338c4c 100644
--- a/net/netfilter/Kconfig
+++ b/net/netfilter/Kconfig
@@ -1148,6 +1148,16 @@ config NETFILTER_XT_MATCH_ESP
 
 	  To compile it as a module, choose M here.  If unsure, say N.
 
+config NETFILTER_XT_MATCH_GRADM
+	tristate '"gradm" match support'
+	depends on NETFILTER_XTABLES && NETFILTER_ADVANCED
+	depends on GRKERNSEC && !GRKERNSEC_NO_RBAC
+	---help---
+	  The gradm match allows to match on grsecurity RBAC being enabled.
+	  It is useful when iptables rules are applied early on bootup to
+	  prevent connections to the machine (except from a trusted host)
+	  while the RBAC system is disabled.
+
 config NETFILTER_XT_MATCH_HASHLIMIT
 	tristate '"hashlimit" match support'
 	depends on IP6_NF_IPTABLES || IP6_NF_IPTABLES=n
diff --git a/net/netfilter/Makefile b/net/netfilter/Makefile
index 69134541d..43686aa7c 100644
--- a/net/netfilter/Makefile
+++ b/net/netfilter/Makefile
@@ -145,6 +145,7 @@ obj-$(CONFIG_NETFILTER_XT_MATCH_DEVGROUP) += xt_devgroup.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_DSCP) += xt_dscp.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_ECN) += xt_ecn.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_ESP) += xt_esp.o
+obj-$(CONFIG_NETFILTER_XT_MATCH_GRADM) += xt_gradm.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_HASHLIMIT) += xt_hashlimit.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_HELPER) += xt_helper.o
 obj-$(CONFIG_NETFILTER_XT_MATCH_HL) += xt_hl.o
diff --git a/net/netfilter/ipset/ip_set_core.c b/net/netfilter/ipset/ip_set_core.c
index a748b0c2c..90c1df696 100644
--- a/net/netfilter/ipset/ip_set_core.c
+++ b/net/netfilter/ipset/ip_set_core.c
@@ -324,7 +324,6 @@ ip_set_get_ipaddr6(struct nlattr *nla, union nf_inet_addr *ipaddr)
 }
 EXPORT_SYMBOL_GPL(ip_set_get_ipaddr6);
 
-typedef void (*destroyer)(void *);
 /* ipset data extension types, in size order */
 
 const struct ip_set_ext_type ip_set_extensions[] = {
@@ -350,7 +349,7 @@ const struct ip_set_ext_type ip_set_extensions[] = {
 		.flag	 = IPSET_FLAG_WITH_COMMENT,
 		.len	 = sizeof(struct ip_set_comment),
 		.align	 = __alignof__(struct ip_set_comment),
-		.destroy = (destroyer) ip_set_comment_free,
+		.destroy = ip_set_comment_free,
 	},
 };
 EXPORT_SYMBOL_GPL(ip_set_extensions);
@@ -1440,7 +1439,7 @@ static int ip_set_dump(struct net *net, struct sock *ctnl, struct sk_buff *skb,
 		return -IPSET_ERR_PROTOCOL;
 
 	{
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = ip_set_dump_start,
 			.done = ip_set_dump_done,
 		};
@@ -2009,7 +2008,7 @@ done:
 	return ret;
 }
 
-static struct nf_sockopt_ops so_set __read_mostly = {
+static struct nf_sockopt_ops so_set = {
 	.pf		= PF_INET,
 	.get_optmin	= SO_IP_SET,
 	.get_optmax	= SO_IP_SET + 1,
diff --git a/net/netfilter/ipvs/ip_vs_conn.c b/net/netfilter/ipvs/ip_vs_conn.c
index 096a45103..c80bc59bb 100644
--- a/net/netfilter/ipvs/ip_vs_conn.c
+++ b/net/netfilter/ipvs/ip_vs_conn.c
@@ -591,7 +591,7 @@ ip_vs_bind_dest(struct ip_vs_conn *cp, struct ip_vs_dest *dest)
 	/* Increase the refcnt counter of the dest */
 	ip_vs_dest_hold(dest);
 
-	conn_flags = atomic_read(&dest->conn_flags);
+	conn_flags = atomic_read_unchecked(&dest->conn_flags);
 	if (cp->protocol != IPPROTO_UDP)
 		conn_flags &= ~IP_VS_CONN_F_ONE_PACKET;
 	flags = cp->flags;
@@ -945,7 +945,7 @@ ip_vs_conn_new(const struct ip_vs_conn_param *p, int dest_af,
 
 	cp->control = NULL;
 	atomic_set(&cp->n_control, 0);
-	atomic_set(&cp->in_pkts, 0);
+	atomic_set_unchecked(&cp->in_pkts, 0);
 
 	cp->packet_xmit = NULL;
 	cp->app = NULL;
@@ -1252,7 +1252,7 @@ static inline int todrop_entry(struct ip_vs_conn *cp)
 
 	/* Don't drop the entry if its number of incoming packets is not
 	   located in [0, 8] */
-	i = atomic_read(&cp->in_pkts);
+	i = atomic_read_unchecked(&cp->in_pkts);
 	if (i > 8 || i < 0) return 0;
 
 	if (!todrop_rate[i]) return 0;
diff --git a/net/netfilter/ipvs/ip_vs_core.c b/net/netfilter/ipvs/ip_vs_core.c
index 2c1b498a7..3bca85cd9 100644
--- a/net/netfilter/ipvs/ip_vs_core.c
+++ b/net/netfilter/ipvs/ip_vs_core.c
@@ -613,9 +613,9 @@ int ip_vs_leave(struct ip_vs_service *svc, struct sk_buff *skb,
 		/* do not touch skb anymore */
 
 		if ((cp->flags & IP_VS_CONN_F_ONE_PACKET) && cp->control)
-			atomic_inc(&cp->control->in_pkts);
+			atomic_inc_unchecked(&cp->control->in_pkts);
 		else
-			atomic_inc(&cp->in_pkts);
+			atomic_inc_unchecked(&cp->in_pkts);
 		ip_vs_conn_put(cp);
 		return ret;
 	}
@@ -1991,13 +1991,13 @@ ip_vs_in(struct netns_ipvs *ipvs, unsigned int hooknum, struct sk_buff *skb, int
 	if (cp->flags & IP_VS_CONN_F_ONE_PACKET)
 		pkts = sysctl_sync_threshold(ipvs);
 	else
-		pkts = atomic_add_return(1, &cp->in_pkts);
+		pkts = atomic_add_return_unchecked(1, &cp->in_pkts);
 
 	if (ipvs->sync_state & IP_VS_STATE_MASTER)
 		ip_vs_sync_conn(ipvs, cp, pkts);
 	else if ((cp->flags & IP_VS_CONN_F_ONE_PACKET) && cp->control)
 		/* increment is done inside ip_vs_sync_conn too */
-		atomic_inc(&cp->control->in_pkts);
+		atomic_inc_unchecked(&cp->control->in_pkts);
 
 	ip_vs_conn_put(cp);
 	return ret;
diff --git a/net/netfilter/ipvs/ip_vs_ctl.c b/net/netfilter/ipvs/ip_vs_ctl.c
index c3c809b2e..fb97ee5d7 100644
--- a/net/netfilter/ipvs/ip_vs_ctl.c
+++ b/net/netfilter/ipvs/ip_vs_ctl.c
@@ -841,7 +841,7 @@ __ip_vs_update_dest(struct ip_vs_service *svc, struct ip_vs_dest *dest,
 		 */
 		ip_vs_rs_hash(ipvs, dest);
 	}
-	atomic_set(&dest->conn_flags, conn_flags);
+	atomic_set_unchecked(&dest->conn_flags, conn_flags);
 
 	/* bind the service */
 	old_svc = rcu_dereference_protected(dest->svc, 1);
@@ -1728,7 +1728,7 @@ proc_do_sync_ports(struct ctl_table *table, int write,
  *	align with netns init in ip_vs_control_net_init()
  */
 
-static struct ctl_table vs_vars[] = {
+static ctl_table_no_const vs_vars[] __read_only = {
 	{
 		.procname	= "amemthresh",
 		.maxlen		= sizeof(int),
@@ -2083,7 +2083,7 @@ static int ip_vs_info_seq_show(struct seq_file *seq, void *v)
 					   "      %-7s %-6d %-10d %-10d\n",
 					   &dest->addr.in6,
 					   ntohs(dest->port),
-					   ip_vs_fwd_name(atomic_read(&dest->conn_flags)),
+					   ip_vs_fwd_name(atomic_read_unchecked(&dest->conn_flags)),
 					   atomic_read(&dest->weight),
 					   atomic_read(&dest->activeconns),
 					   atomic_read(&dest->inactconns));
@@ -2094,7 +2094,7 @@ static int ip_vs_info_seq_show(struct seq_file *seq, void *v)
 					   "%-7s %-6d %-10d %-10d\n",
 					   ntohl(dest->addr.ip),
 					   ntohs(dest->port),
-					   ip_vs_fwd_name(atomic_read(&dest->conn_flags)),
+					   ip_vs_fwd_name(atomic_read_unchecked(&dest->conn_flags)),
 					   atomic_read(&dest->weight),
 					   atomic_read(&dest->activeconns),
 					   atomic_read(&dest->inactconns));
@@ -2603,7 +2603,7 @@ __ip_vs_get_dest_entries(struct netns_ipvs *ipvs, const struct ip_vs_get_dests *
 
 			entry.addr = dest->addr.ip;
 			entry.port = dest->port;
-			entry.conn_flags = atomic_read(&dest->conn_flags);
+			entry.conn_flags = atomic_read_unchecked(&dest->conn_flags);
 			entry.weight = atomic_read(&dest->weight);
 			entry.u_threshold = dest->u_threshold;
 			entry.l_threshold = dest->l_threshold;
@@ -3196,7 +3196,7 @@ static int ip_vs_genl_fill_dest(struct sk_buff *skb, struct ip_vs_dest *dest)
 	if (nla_put(skb, IPVS_DEST_ATTR_ADDR, sizeof(dest->addr), &dest->addr) ||
 	    nla_put_be16(skb, IPVS_DEST_ATTR_PORT, dest->port) ||
 	    nla_put_u32(skb, IPVS_DEST_ATTR_FWD_METHOD,
-			(atomic_read(&dest->conn_flags) &
+			(atomic_read_unchecked(&dest->conn_flags) &
 			 IP_VS_CONN_F_FWD_MASK)) ||
 	    nla_put_u32(skb, IPVS_DEST_ATTR_WEIGHT,
 			atomic_read(&dest->weight)) ||
@@ -3893,7 +3893,7 @@ static int __net_init ip_vs_control_net_init_sysctl(struct netns_ipvs *ipvs)
 {
 	struct net *net = ipvs->net;
 	int idx;
-	struct ctl_table *tbl;
+	ctl_table_no_const *tbl;
 
 	atomic_set(&ipvs->dropentry, 0);
 	spin_lock_init(&ipvs->dropentry_lock);
diff --git a/net/netfilter/ipvs/ip_vs_lblc.c b/net/netfilter/ipvs/ip_vs_lblc.c
index cccf4d637..8d603995f 100644
--- a/net/netfilter/ipvs/ip_vs_lblc.c
+++ b/net/netfilter/ipvs/ip_vs_lblc.c
@@ -118,7 +118,7 @@ struct ip_vs_lblc_table {
  *      IPVS LBLC sysctl table
  */
 #ifdef CONFIG_SYSCTL
-static struct ctl_table vs_vars_table[] = {
+static ctl_table_no_const vs_vars_table[] __read_only = {
 	{
 		.procname	= "lblc_expiration",
 		.data		= NULL,
diff --git a/net/netfilter/ipvs/ip_vs_lblcr.c b/net/netfilter/ipvs/ip_vs_lblcr.c
index 796d70e47..8458955a4 100644
--- a/net/netfilter/ipvs/ip_vs_lblcr.c
+++ b/net/netfilter/ipvs/ip_vs_lblcr.c
@@ -289,7 +289,7 @@ struct ip_vs_lblcr_table {
  *      IPVS LBLCR sysctl table
  */
 
-static struct ctl_table vs_vars_table[] = {
+static ctl_table_no_const vs_vars_table[] __read_only = {
 	{
 		.procname	= "lblcr_expiration",
 		.data		= NULL,
diff --git a/net/netfilter/ipvs/ip_vs_sync.c b/net/netfilter/ipvs/ip_vs_sync.c
index 1b07578be..36b88cb6f 100644
--- a/net/netfilter/ipvs/ip_vs_sync.c
+++ b/net/netfilter/ipvs/ip_vs_sync.c
@@ -611,7 +611,7 @@ static void ip_vs_sync_conn_v0(struct netns_ipvs *ipvs, struct ip_vs_conn *cp,
 	cp = cp->control;
 	if (cp) {
 		if (cp->flags & IP_VS_CONN_F_TEMPLATE)
-			pkts = atomic_add_return(1, &cp->in_pkts);
+			pkts = atomic_add_return_unchecked(1, &cp->in_pkts);
 		else
 			pkts = sysctl_sync_threshold(ipvs);
 		ip_vs_sync_conn(ipvs, cp, pkts);
@@ -772,7 +772,7 @@ control:
 	if (!cp)
 		return;
 	if (cp->flags & IP_VS_CONN_F_TEMPLATE)
-		pkts = atomic_add_return(1, &cp->in_pkts);
+		pkts = atomic_add_return_unchecked(1, &cp->in_pkts);
 	else
 		pkts = sysctl_sync_threshold(ipvs);
 	goto sloop;
@@ -919,7 +919,7 @@ static void ip_vs_proc_conn(struct netns_ipvs *ipvs, struct ip_vs_conn_param *pa
 
 	if (opt)
 		memcpy(&cp->in_seq, opt, sizeof(*opt));
-	atomic_set(&cp->in_pkts, sysctl_sync_threshold(ipvs));
+	atomic_set_unchecked(&cp->in_pkts, sysctl_sync_threshold(ipvs));
 	cp->state = state;
 	cp->old_state = cp->state;
 	/*
diff --git a/net/netfilter/ipvs/ip_vs_xmit.c b/net/netfilter/ipvs/ip_vs_xmit.c
index 01d3d894d..fb0cd03c8 100644
--- a/net/netfilter/ipvs/ip_vs_xmit.c
+++ b/net/netfilter/ipvs/ip_vs_xmit.c
@@ -1255,7 +1255,7 @@ ip_vs_icmp_xmit(struct sk_buff *skb, struct ip_vs_conn *cp,
 		else
 			rc = NF_ACCEPT;
 		/* do not touch skb anymore */
-		atomic_inc(&cp->in_pkts);
+		atomic_inc_unchecked(&cp->in_pkts);
 		goto out;
 	}
 
@@ -1348,7 +1348,7 @@ ip_vs_icmp_xmit_v6(struct sk_buff *skb, struct ip_vs_conn *cp,
 		else
 			rc = NF_ACCEPT;
 		/* do not touch skb anymore */
-		atomic_inc(&cp->in_pkts);
+		atomic_inc_unchecked(&cp->in_pkts);
 		goto out;
 	}
 
diff --git a/net/netfilter/nf_conntrack_acct.c b/net/netfilter/nf_conntrack_acct.c
index 45da11afa..ef3e5dc36 100644
--- a/net/netfilter/nf_conntrack_acct.c
+++ b/net/netfilter/nf_conntrack_acct.c
@@ -64,7 +64,7 @@ static struct nf_ct_ext_type acct_extend __read_mostly = {
 #ifdef CONFIG_SYSCTL
 static int nf_conntrack_acct_init_sysctl(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(acct_sysctl_table, sizeof(acct_sysctl_table),
 			GFP_KERNEL);
diff --git a/net/netfilter/nf_conntrack_core.c b/net/netfilter/nf_conntrack_core.c
index 9934b0c93..08efb981c 100644
--- a/net/netfilter/nf_conntrack_core.c
+++ b/net/netfilter/nf_conntrack_core.c
@@ -1702,7 +1702,7 @@ int nf_conntrack_hash_resize(unsigned int hashsize)
 	return 0;
 }
 
-int nf_conntrack_set_hashsize(const char *val, struct kernel_param *kp)
+int nf_conntrack_set_hashsize(const char *val, const struct kernel_param *kp)
 {
 	unsigned int hashsize;
 	int rc;
diff --git a/net/netfilter/nf_conntrack_ecache.c b/net/netfilter/nf_conntrack_ecache.c
index d28011b42..04d5063b6 100644
--- a/net/netfilter/nf_conntrack_ecache.c
+++ b/net/netfilter/nf_conntrack_ecache.c
@@ -348,7 +348,7 @@ static struct nf_ct_ext_type event_extend __read_mostly = {
 #ifdef CONFIG_SYSCTL
 static int nf_conntrack_event_init_sysctl(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(event_sysctl_table, sizeof(event_sysctl_table),
 			GFP_KERNEL);
diff --git a/net/netfilter/nf_conntrack_helper.c b/net/netfilter/nf_conntrack_helper.c
index b989b81ac..2335d60c7 100644
--- a/net/netfilter/nf_conntrack_helper.c
+++ b/net/netfilter/nf_conntrack_helper.c
@@ -57,7 +57,7 @@ static struct ctl_table helper_sysctl_table[] = {
 
 static int nf_conntrack_helper_init_sysctl(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(helper_sysctl_table, sizeof(helper_sysctl_table),
 			GFP_KERNEL);
diff --git a/net/netfilter/nf_conntrack_netlink.c b/net/netfilter/nf_conntrack_netlink.c
index fdfc71f41..f47621ae3 100644
--- a/net/netfilter/nf_conntrack_netlink.c
+++ b/net/netfilter/nf_conntrack_netlink.c
@@ -1170,10 +1170,11 @@ static int ctnetlink_get_conntrack(struct net *net, struct sock *ctnl,
 	int err;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = ctnetlink_dump_table,
 			.done = ctnetlink_done,
 		};
+		void *data = NULL;
 
 		if (cda[CTA_MARK] && cda[CTA_MARK_MASK]) {
 			struct ctnetlink_filter *filter;
@@ -1182,9 +1183,9 @@ static int ctnetlink_get_conntrack(struct net *net, struct sock *ctnl,
 			if (IS_ERR(filter))
 				return PTR_ERR(filter);
 
-			c.data = filter;
+			data = filter;
 		}
-		return netlink_dump_start(ctnl, skb, nlh, &c);
+		return __netlink_dump_start(ctnl, skb, nlh, &c, data, THIS_MODULE);
 	}
 
 	err = ctnetlink_parse_zone(cda[CTA_ZONE], &zone);
@@ -1322,7 +1323,7 @@ static int ctnetlink_get_ct_dying(struct net *net, struct sock *ctnl,
 				  const struct nlattr * const cda[])
 {
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = ctnetlink_dump_dying,
 			.done = ctnetlink_done_list,
 		};
@@ -1344,7 +1345,7 @@ static int ctnetlink_get_ct_unconfirmed(struct net *net, struct sock *ctnl,
 					const struct nlattr * const cda[])
 {
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = ctnetlink_dump_unconfirmed,
 			.done = ctnetlink_done_list,
 		};
@@ -2027,7 +2028,7 @@ static int ctnetlink_stat_ct_cpu(struct net *net, struct sock *ctnl,
 				 const struct nlattr * const cda[])
 {
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = ctnetlink_ct_stat_cpu_dump,
 		};
 		return netlink_dump_start(ctnl, skb, nlh, &c);
@@ -2725,7 +2726,7 @@ static int ctnetlink_dump_exp_ct(struct net *net, struct sock *ctnl,
 	struct nf_conntrack_tuple_hash *h;
 	struct nf_conn *ct;
 	struct nf_conntrack_zone zone;
-	struct netlink_dump_control c = {
+	static struct netlink_dump_control c = {
 		.dump = ctnetlink_exp_ct_dump_table,
 		.done = ctnetlink_exp_done,
 	};
@@ -2744,9 +2745,8 @@ static int ctnetlink_dump_exp_ct(struct net *net, struct sock *ctnl,
 		return -ENOENT;
 
 	ct = nf_ct_tuplehash_to_ctrack(h);
-	c.data = ct;
 
-	err = netlink_dump_start(ctnl, skb, nlh, &c);
+	err = __netlink_dump_start(ctnl, skb, nlh, &c, ct, THIS_MODULE);
 	nf_ct_put(ct);
 
 	return err;
@@ -2768,7 +2768,7 @@ static int ctnetlink_get_expect(struct net *net, struct sock *ctnl,
 		if (cda[CTA_EXPECT_MASTER])
 			return ctnetlink_dump_exp_ct(net, ctnl, skb, nlh, cda);
 		else {
-			struct netlink_dump_control c = {
+			static struct netlink_dump_control c = {
 				.dump = ctnetlink_exp_dump_table,
 				.done = ctnetlink_exp_done,
 			};
@@ -3234,7 +3234,7 @@ static int ctnetlink_stat_exp_cpu(struct net *net, struct sock *ctnl,
 				  const struct nlattr * const cda[])
 {
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = ctnetlink_exp_stat_cpu_dump,
 		};
 		return netlink_dump_start(ctnl, skb, nlh, &c);
diff --git a/net/netfilter/nf_conntrack_proto.c b/net/netfilter/nf_conntrack_proto.c
index b65d5864b..beec9021d 100644
--- a/net/netfilter/nf_conntrack_proto.c
+++ b/net/netfilter/nf_conntrack_proto.c
@@ -52,7 +52,7 @@ nf_ct_register_sysctl(struct net *net,
 
 static void
 nf_ct_unregister_sysctl(struct ctl_table_header **header,
-			struct ctl_table **table,
+			ctl_table_no_const **table,
 			unsigned int users)
 {
 	if (users > 0)
diff --git a/net/netfilter/nf_conntrack_standalone.c b/net/netfilter/nf_conntrack_standalone.c
index 9f267c3ff..ca950e484 100644
--- a/net/netfilter/nf_conntrack_standalone.c
+++ b/net/netfilter/nf_conntrack_standalone.c
@@ -529,7 +529,7 @@ static struct ctl_table nf_ct_netfilter_table[] = {
 
 static int nf_conntrack_standalone_init_sysctl(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(nf_ct_sysctl_table, sizeof(nf_ct_sysctl_table),
 			GFP_KERNEL);
diff --git a/net/netfilter/nf_conntrack_timestamp.c b/net/netfilter/nf_conntrack_timestamp.c
index 7a394df0d..bd91a8aa4 100644
--- a/net/netfilter/nf_conntrack_timestamp.c
+++ b/net/netfilter/nf_conntrack_timestamp.c
@@ -42,7 +42,7 @@ static struct nf_ct_ext_type tstamp_extend __read_mostly = {
 #ifdef CONFIG_SYSCTL
 static int nf_conntrack_tstamp_init_sysctl(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(tstamp_sysctl_table, sizeof(tstamp_sysctl_table),
 			GFP_KERNEL);
diff --git a/net/netfilter/nf_log.c b/net/netfilter/nf_log.c
index 1df2c8dac..3e79332e6 100644
--- a/net/netfilter/nf_log.c
+++ b/net/netfilter/nf_log.c
@@ -411,7 +411,7 @@ static const struct file_operations nflog_file_ops = {
 
 #ifdef CONFIG_SYSCTL
 static char nf_log_sysctl_fnames[NFPROTO_NUMPROTO-NFPROTO_UNSPEC][3];
-static struct ctl_table nf_log_sysctl_table[NFPROTO_NUMPROTO+1];
+static ctl_table_no_const nf_log_sysctl_table[NFPROTO_NUMPROTO+1] __read_only;
 
 static int nf_log_proc_dostring(struct ctl_table *table, int write,
 			 void __user *buffer, size_t *lenp, loff_t *ppos)
@@ -423,7 +423,7 @@ static int nf_log_proc_dostring(struct ctl_table *table, int write,
 	struct net *net = table->extra2;
 
 	if (write) {
-		struct ctl_table tmp = *table;
+		ctl_table_no_const tmp = *table;
 
 		tmp.data = buf;
 		r = proc_dostring(&tmp, write, buffer, lenp, ppos);
@@ -443,13 +443,15 @@ static int nf_log_proc_dostring(struct ctl_table *table, int write,
 		rcu_assign_pointer(net->nf.nf_loggers[tindex], logger);
 		mutex_unlock(&nf_log_mutex);
 	} else {
+		ctl_table_no_const nf_log_table = *table;
+
 		mutex_lock(&nf_log_mutex);
 		logger = nft_log_dereference(net->nf.nf_loggers[tindex]);
 		if (!logger)
-			table->data = "NONE";
+			nf_log_table.data = "NONE";
 		else
-			table->data = logger->name;
-		r = proc_dostring(table, write, buffer, lenp, ppos);
+			nf_log_table.data = logger->name;
+		r = proc_dostring(&nf_log_table, write, buffer, lenp, ppos);
 		mutex_unlock(&nf_log_mutex);
 	}
 
@@ -459,7 +461,7 @@ static int nf_log_proc_dostring(struct ctl_table *table, int write,
 static int netfilter_log_sysctl_init(struct net *net)
 {
 	int i;
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = nf_log_sysctl_table;
 	if (!net_eq(net, &init_net)) {
diff --git a/net/netfilter/nf_nat_ftp.c b/net/netfilter/nf_nat_ftp.c
index e84a578db..d76afafdc 100644
--- a/net/netfilter/nf_nat_ftp.c
+++ b/net/netfilter/nf_nat_ftp.c
@@ -134,7 +134,7 @@ static int __init nf_nat_ftp_init(void)
 }
 
 /* Prior to 2.6.11, we had a ports param.  No longer, but don't break users. */
-static int warn_set(const char *val, struct kernel_param *kp)
+static int warn_set(const char *val, const struct kernel_param *kp)
 {
 	printk(KERN_INFO KBUILD_MODNAME
 	       ": kernel >= 2.6.10 only uses 'ports' for conntrack modules\n");
diff --git a/net/netfilter/nf_nat_irc.c b/net/netfilter/nf_nat_irc.c
index 1fb2258c3..8039bcd60 100644
--- a/net/netfilter/nf_nat_irc.c
+++ b/net/netfilter/nf_nat_irc.c
@@ -107,7 +107,7 @@ static int __init nf_nat_irc_init(void)
 }
 
 /* Prior to 2.6.11, we had a ports param.  No longer, but don't break users. */
-static int warn_set(const char *val, struct kernel_param *kp)
+static int warn_set(const char *val, const struct kernel_param *kp)
 {
 	printk(KERN_INFO KBUILD_MODNAME
 	       ": kernel >= 2.6.10 only uses 'ports' for conntrack modules\n");
diff --git a/net/netfilter/nf_sockopt.c b/net/netfilter/nf_sockopt.c
index c68c1e58b..8b5d6705c 100644
--- a/net/netfilter/nf_sockopt.c
+++ b/net/netfilter/nf_sockopt.c
@@ -43,7 +43,7 @@ int nf_register_sockopt(struct nf_sockopt_ops *reg)
 		}
 	}
 
-	list_add(&reg->list, &nf_sockopts);
+	pax_list_add((struct list_head *)&reg->list, &nf_sockopts);
 out:
 	mutex_unlock(&nf_sockopt_mutex);
 	return ret;
@@ -53,7 +53,7 @@ EXPORT_SYMBOL(nf_register_sockopt);
 void nf_unregister_sockopt(struct nf_sockopt_ops *reg)
 {
 	mutex_lock(&nf_sockopt_mutex);
-	list_del(&reg->list);
+	pax_list_del((struct list_head *)&reg->list);
 	mutex_unlock(&nf_sockopt_mutex);
 }
 EXPORT_SYMBOL(nf_unregister_sockopt);
diff --git a/net/netfilter/nf_tables_api.c b/net/netfilter/nf_tables_api.c
index 7e1c876c7..9b9f9b397 100644
--- a/net/netfilter/nf_tables_api.c
+++ b/net/netfilter/nf_tables_api.c
@@ -506,7 +506,7 @@ static int nf_tables_gettable(struct net *net, struct sock *nlsk,
 	int err;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = nf_tables_dump_tables,
 		};
 		return netlink_dump_start(nlsk, skb, nlh, &c);
@@ -1092,7 +1092,7 @@ static int nf_tables_getchain(struct net *net, struct sock *nlsk,
 	int err;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = nf_tables_dump_chains,
 		};
 		return netlink_dump_start(nlsk, skb, nlh, &c);
@@ -1944,7 +1944,7 @@ static int nf_tables_getrule(struct net *net, struct sock *nlsk,
 	int err;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		netlink_dump_control_no_const c = {
 			.dump = nf_tables_dump_rules,
 			.done = nf_tables_dump_rules_done,
 		};
@@ -2666,20 +2666,17 @@ static int nf_tables_getset(struct net *net, struct sock *nlsk,
 		return err;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = nf_tables_dump_sets,
 			.done = nf_tables_dump_sets_done,
 		};
 		struct nft_ctx *ctx_dump;
 
-		ctx_dump = kmalloc(sizeof(*ctx_dump), GFP_KERNEL);
+		ctx_dump = kmemdup(&ctx, sizeof(ctx), GFP_KERNEL);
 		if (ctx_dump == NULL)
 			return -ENOMEM;
 
-		*ctx_dump = ctx;
-		c.data = ctx_dump;
-
-		return netlink_dump_start(nlsk, skb, nlh, &c);
+		return __netlink_dump_start(nlsk, skb, nlh, &c, ctx_dump, THIS_MODULE);
 	}
 
 	/* Only accept unspec with dump */
@@ -3268,7 +3265,7 @@ static int nf_tables_getsetelem(struct net *net, struct sock *nlsk,
 		return PTR_ERR(set);
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = nf_tables_dump_set,
 		};
 		return netlink_dump_start(nlsk, skb, nlh, &c);
diff --git a/net/netfilter/nfnetlink_acct.c b/net/netfilter/nfnetlink_acct.c
index d44d89b56..c834ed3b2 100644
--- a/net/netfilter/nfnetlink_acct.c
+++ b/net/netfilter/nfnetlink_acct.c
@@ -28,8 +28,8 @@ MODULE_AUTHOR("Pablo Neira Ayuso <pablo@netfilter.org>");
 MODULE_DESCRIPTION("nfacct: Extended Netfilter accounting infrastructure");
 
 struct nf_acct {
-	atomic64_t		pkts;
-	atomic64_t		bytes;
+	atomic64_unchecked_t	pkts;
+	atomic64_unchecked_t	bytes;
 	unsigned long		flags;
 	struct list_head	head;
 	atomic_t		refcnt;
@@ -76,8 +76,8 @@ static int nfnl_acct_new(struct net *net, struct sock *nfnl,
 	if (matching) {
 		if (nlh->nlmsg_flags & NLM_F_REPLACE) {
 			/* reset counters if you request a replacement. */
-			atomic64_set(&matching->pkts, 0);
-			atomic64_set(&matching->bytes, 0);
+			atomic64_set_unchecked(&matching->pkts, 0);
+			atomic64_set_unchecked(&matching->bytes, 0);
 			smp_mb__before_atomic();
 			/* reset overquota flag if quota is enabled. */
 			if ((matching->flags & NFACCT_F_QUOTA))
@@ -116,11 +116,11 @@ static int nfnl_acct_new(struct net *net, struct sock *nfnl,
 	strncpy(nfacct->name, nla_data(tb[NFACCT_NAME]), NFACCT_NAME_MAX);
 
 	if (tb[NFACCT_BYTES]) {
-		atomic64_set(&nfacct->bytes,
+		atomic64_set_unchecked(&nfacct->bytes,
 			     be64_to_cpu(nla_get_be64(tb[NFACCT_BYTES])));
 	}
 	if (tb[NFACCT_PKTS]) {
-		atomic64_set(&nfacct->pkts,
+		atomic64_set_unchecked(&nfacct->pkts,
 			     be64_to_cpu(nla_get_be64(tb[NFACCT_PKTS])));
 	}
 	atomic_set(&nfacct->refcnt, 1);
@@ -153,14 +153,14 @@ nfnl_acct_fill_info(struct sk_buff *skb, u32 portid, u32 seq, u32 type,
 
 	old_flags = acct->flags;
 	if (type == NFNL_MSG_ACCT_GET_CTRZERO) {
-		pkts = atomic64_xchg(&acct->pkts, 0);
-		bytes = atomic64_xchg(&acct->bytes, 0);
+		pkts = atomic64_xchg_unchecked(&acct->pkts, 0);
+		bytes = atomic64_xchg_unchecked(&acct->bytes, 0);
 		smp_mb__before_atomic();
 		if (acct->flags & NFACCT_F_QUOTA)
 			clear_bit(NFACCT_OVERQUOTA_BIT, &acct->flags);
 	} else {
-		pkts = atomic64_read(&acct->pkts);
-		bytes = atomic64_read(&acct->bytes);
+		pkts = atomic64_read_unchecked(&acct->pkts);
+		bytes = atomic64_read_unchecked(&acct->bytes);
 	}
 	if (nla_put_be64(skb, NFACCT_PKTS, cpu_to_be64(pkts),
 			 NFACCT_PAD) ||
@@ -269,10 +269,11 @@ static int nfnl_acct_get(struct net *net, struct sock *nfnl,
 	char *acct_name;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = nfnl_acct_dump,
 			.done = nfnl_acct_done,
 		};
+		void *data = NULL;
 
 		if (tb[NFACCT_FILTER]) {
 			struct nfacct_filter *filter;
@@ -281,9 +282,9 @@ static int nfnl_acct_get(struct net *net, struct sock *nfnl,
 			if (IS_ERR(filter))
 				return PTR_ERR(filter);
 
-			c.data = filter;
+			data = filter;
 		}
-		return netlink_dump_start(nfnl, skb, nlh, &c);
+		return __netlink_dump_start(nfnl, skb, nlh, &c, data, THIS_MODULE);
 	}
 
 	if (!tb[NFACCT_NAME])
@@ -438,8 +439,8 @@ EXPORT_SYMBOL_GPL(nfnl_acct_put);
 
 void nfnl_acct_update(const struct sk_buff *skb, struct nf_acct *nfacct)
 {
-	atomic64_inc(&nfacct->pkts);
-	atomic64_add(skb->len, &nfacct->bytes);
+	atomic64_inc_unchecked(&nfacct->pkts);
+	atomic64_add_unchecked(skb->len, &nfacct->bytes);
 }
 EXPORT_SYMBOL_GPL(nfnl_acct_update);
 
@@ -475,7 +476,7 @@ int nfnl_acct_overquota(struct net *net, const struct sk_buff *skb,
 
 	quota = (u64 *)nfacct->data;
 	now = (nfacct->flags & NFACCT_F_QUOTA_PKTS) ?
-	       atomic64_read(&nfacct->pkts) : atomic64_read(&nfacct->bytes);
+	       atomic64_read_unchecked(&nfacct->pkts) : atomic64_read_unchecked(&nfacct->bytes);
 
 	ret = now > *quota;
 
diff --git a/net/netfilter/nfnetlink_cthelper.c b/net/netfilter/nfnetlink_cthelper.c
index e924e95fc..1e2e23316 100644
--- a/net/netfilter/nfnetlink_cthelper.c
+++ b/net/netfilter/nfnetlink_cthelper.c
@@ -510,7 +510,7 @@ static int nfnl_cthelper_get(struct net *net, struct sock *nfnl,
 	bool tuple_set = false;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = nfnl_cthelper_dump_table,
 		};
 		return netlink_dump_start(nfnl, skb, nlh, &c);
diff --git a/net/netfilter/nfnetlink_cttimeout.c b/net/netfilter/nfnetlink_cttimeout.c
index 139e0867e..73899bc57 100644
--- a/net/netfilter/nfnetlink_cttimeout.c
+++ b/net/netfilter/nfnetlink_cttimeout.c
@@ -245,7 +245,7 @@ static int cttimeout_get_timeout(struct net *net, struct sock *ctnl,
 	struct ctnl_timeout *cur;
 
 	if (nlh->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = ctnl_timeout_dump,
 		};
 		return netlink_dump_start(ctnl, skb, nlh, &c);
diff --git a/net/netfilter/nfnetlink_log.c b/net/netfilter/nfnetlink_log.c
index 6577db524..1a45ef7e5 100644
--- a/net/netfilter/nfnetlink_log.c
+++ b/net/netfilter/nfnetlink_log.c
@@ -85,7 +85,7 @@ static int nfnl_log_net_id __read_mostly;
 struct nfnl_log_net {
 	spinlock_t instances_lock;
 	struct hlist_head instance_table[INSTANCE_BUCKETS];
-	atomic_t global_seq;
+	atomic_unchecked_t global_seq;
 };
 
 static struct nfnl_log_net *nfnl_log_pernet(struct net *net)
@@ -570,7 +570,7 @@ __build_packet_message(struct nfnl_log_net *log,
 	/* global sequence number */
 	if ((inst->flags & NFULNL_CFG_F_SEQ_GLOBAL) &&
 	    nla_put_be32(inst->skb, NFULA_SEQ_GLOBAL,
-			 htonl(atomic_inc_return(&log->global_seq))))
+			 htonl(atomic_inc_return_unchecked(&log->global_seq))))
 		goto nla_put_failure;
 
 	if (ct && nfnl_ct->build(inst->skb, ct, ctinfo,
diff --git a/net/netfilter/nft_compat.c b/net/netfilter/nft_compat.c
index c21e7eb8d..79f631406 100644
--- a/net/netfilter/nft_compat.c
+++ b/net/netfilter/nft_compat.c
@@ -337,14 +337,7 @@ static void nft_match_eval(const struct nft_expr *expr,
 		return;
 	}
 
-	switch (ret ? 1 : 0) {
-	case 1:
-		regs->verdict.code = NFT_CONTINUE;
-		break;
-	case 0:
-		regs->verdict.code = NFT_BREAK;
-		break;
-	}
+	regs->verdict.code = ret ? NFT_CONTINUE : NFT_BREAK;
 }
 
 static const struct nla_policy nft_match_policy[NFTA_MATCH_MAX + 1] = {
diff --git a/net/netfilter/xt_IDLETIMER.c b/net/netfilter/xt_IDLETIMER.c
index daf45da44..615f97032 100644
--- a/net/netfilter/xt_IDLETIMER.c
+++ b/net/netfilter/xt_IDLETIMER.c
@@ -41,19 +41,13 @@
 #include <linux/workqueue.h>
 #include <linux/sysfs.h>
 
-struct idletimer_tg_attr {
-	struct attribute attr;
-	ssize_t	(*show)(struct kobject *kobj,
-			struct attribute *attr, char *buf);
-};
-
 struct idletimer_tg {
 	struct list_head entry;
 	struct timer_list timer;
 	struct work_struct work;
 
 	struct kobject *kobj;
-	struct idletimer_tg_attr attr;
+	struct device_attribute attr;
 
 	unsigned int refcnt;
 };
@@ -78,7 +72,7 @@ struct idletimer_tg *__idletimer_tg_find_by_label(const char *label)
 	return NULL;
 }
 
-static ssize_t idletimer_tg_show(struct kobject *kobj, struct attribute *attr,
+static ssize_t idletimer_tg_show(struct device *dev, struct device_attribute *attr,
 				 char *buf)
 {
 	struct idletimer_tg *timer;
@@ -86,7 +80,7 @@ static ssize_t idletimer_tg_show(struct kobject *kobj, struct attribute *attr,
 
 	mutex_lock(&list_mutex);
 
-	timer =	__idletimer_tg_find_by_label(attr->name);
+	timer =	__idletimer_tg_find_by_label(attr->attr.name);
 	if (timer)
 		expires = timer->timer.expires;
 
diff --git b/net/netfilter/xt_gradm.c b/net/netfilter/xt_gradm.c
new file mode 100644
index 000000000..a7cb915fe
--- /dev/null
+++ b/net/netfilter/xt_gradm.c
@@ -0,0 +1,51 @@
+/*
+ *	gradm match for netfilter
+ *	Copyright (c) Zbigniew Krzystolik, 2010
+ *
+ *	This program is free software; you can redistribute it and/or modify
+ *	it under the terms of the GNU General Public License; either version
+ *	2 or 3 as published by the Free Software Foundation.
+ */
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/skbuff.h>
+#include <linux/netfilter/x_tables.h>
+#include <linux/grsecurity.h>
+#include <linux/netfilter/xt_gradm.h>
+
+static bool
+gradm_mt(const struct sk_buff *skb, struct xt_action_param *par)
+{
+	const struct xt_gradm_mtinfo *info = par->matchinfo;
+	bool retval = false;
+	if (gr_acl_is_enabled())
+		retval = true;
+	return retval ^ info->invflags;
+}
+
+static struct xt_match gradm_mt_reg __read_mostly = {
+		.name       = "gradm",
+		.revision   = 0,
+		.family     = NFPROTO_UNSPEC,
+		.match      = gradm_mt,
+		.matchsize  = XT_ALIGN(sizeof(struct xt_gradm_mtinfo)),
+		.me         = THIS_MODULE,
+};
+
+static int __init gradm_mt_init(void)
+{
+	return xt_register_match(&gradm_mt_reg);
+}
+
+static void __exit gradm_mt_exit(void)
+{
+	xt_unregister_match(&gradm_mt_reg);
+}
+
+module_init(gradm_mt_init);
+module_exit(gradm_mt_exit);
+MODULE_AUTHOR("Zbigniew Krzystolik <zbyniu@destrukcja.pl>");
+MODULE_DESCRIPTION("Xtables: Grsecurity RBAC match");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("ipt_gradm");
+MODULE_ALIAS("ip6t_gradm");
diff --git a/net/netfilter/xt_hashlimit.c b/net/netfilter/xt_hashlimit.c
index 178696852..1ec6dac21 100644
--- a/net/netfilter/xt_hashlimit.c
+++ b/net/netfilter/xt_hashlimit.c
@@ -869,11 +869,11 @@ static int __net_init hashlimit_proc_net_init(struct net *net)
 {
 	struct hashlimit_net *hashlimit_net = hashlimit_pernet(net);
 
-	hashlimit_net->ipt_hashlimit = proc_mkdir("ipt_hashlimit", net->proc_net);
+	hashlimit_net->ipt_hashlimit = proc_mkdir_restrict("ipt_hashlimit", net->proc_net);
 	if (!hashlimit_net->ipt_hashlimit)
 		return -ENOMEM;
 #if IS_ENABLED(CONFIG_IP6_NF_IPTABLES)
-	hashlimit_net->ip6t_hashlimit = proc_mkdir("ip6t_hashlimit", net->proc_net);
+	hashlimit_net->ip6t_hashlimit = proc_mkdir_restrict("ip6t_hashlimit", net->proc_net);
 	if (!hashlimit_net->ip6t_hashlimit) {
 		remove_proc_entry("ipt_hashlimit", net->proc_net);
 		return -ENOMEM;
diff --git a/net/netfilter/xt_recent.c b/net/netfilter/xt_recent.c
index d725a2774..14b0c5164 100644
--- a/net/netfilter/xt_recent.c
+++ b/net/netfilter/xt_recent.c
@@ -642,7 +642,7 @@ static int __net_init recent_proc_net_init(struct net *net)
 {
 	struct recent_net *recent_net = recent_pernet(net);
 
-	recent_net->xt_recent = proc_mkdir("xt_recent", net->proc_net);
+	recent_net->xt_recent = proc_mkdir_restrict("xt_recent", net->proc_net);
 	if (!recent_net->xt_recent)
 		return -ENOMEM;
 	return 0;
diff --git a/net/netfilter/xt_statistic.c b/net/netfilter/xt_statistic.c
index 11de55e7a..f25e448af 100644
--- a/net/netfilter/xt_statistic.c
+++ b/net/netfilter/xt_statistic.c
@@ -19,7 +19,7 @@
 #include <linux/module.h>
 
 struct xt_statistic_priv {
-	atomic_t count;
+	atomic_unchecked_t count;
 } ____cacheline_aligned_in_smp;
 
 MODULE_LICENSE("GPL");
@@ -42,9 +42,9 @@ statistic_mt(const struct sk_buff *skb, struct xt_action_param *par)
 		break;
 	case XT_STATISTIC_MODE_NTH:
 		do {
-			oval = atomic_read(&info->master->count);
+			oval = atomic_read_unchecked(&info->master->count);
 			nval = (oval == info->u.nth.every) ? 0 : oval + 1;
-		} while (atomic_cmpxchg(&info->master->count, oval, nval) != oval);
+		} while (atomic_cmpxchg_unchecked(&info->master->count, oval, nval) != oval);
 		if (nval == 0)
 			ret = !ret;
 		break;
@@ -64,7 +64,7 @@ static int statistic_mt_check(const struct xt_mtchk_param *par)
 	info->master = kzalloc(sizeof(*info->master), GFP_KERNEL);
 	if (info->master == NULL)
 		return -ENOMEM;
-	atomic_set(&info->master->count, info->u.nth.count);
+	atomic_set_unchecked(&info->master->count, info->u.nth.count);
 
 	return 0;
 }
diff --git a/net/netlink/af_netlink.c b/net/netlink/af_netlink.c
index 246f29d36..1b680238f 100644
--- a/net/netlink/af_netlink.c
+++ b/net/netlink/af_netlink.c
@@ -287,7 +287,7 @@ static void netlink_overrun(struct sock *sk)
 			sk->sk_error_report(sk);
 		}
 	}
-	atomic_inc(&sk->sk_drops);
+	atomic_inc_unchecked(&sk->sk_drops);
 }
 
 static void netlink_rcv_wake(struct sock *sk)
@@ -1720,11 +1720,12 @@ static void netlink_cmsg_recv_pktinfo(struct msghdr *msg, struct sk_buff *skb)
 static void netlink_cmsg_listen_all_nsid(struct sock *sk, struct msghdr *msg,
 					 struct sk_buff *skb)
 {
+	int nsid = NETLINK_CB(skb).nsid;
+
 	if (!NETLINK_CB(skb).nsid_is_set)
 		return;
 
-	put_cmsg(msg, SOL_NETLINK, NETLINK_LISTEN_ALL_NSID, sizeof(int),
-		 &NETLINK_CB(skb).nsid);
+	put_cmsg(msg, SOL_NETLINK, NETLINK_LISTEN_ALL_NSID, sizeof(nsid), &nsid);
 }
 
 static int netlink_sendmsg(struct socket *sock, struct msghdr *msg, size_t len)
@@ -2168,7 +2169,9 @@ errout_skb:
 
 int __netlink_dump_start(struct sock *ssk, struct sk_buff *skb,
 			 const struct nlmsghdr *nlh,
-			 struct netlink_dump_control *control)
+			 struct netlink_dump_control *control,
+			 void *data,
+			 struct module *module)
 {
 	struct netlink_callback *cb;
 	struct sock *sk;
@@ -2191,7 +2194,7 @@ int __netlink_dump_start(struct sock *ssk, struct sk_buff *skb,
 		goto error_unlock;
 	}
 	/* add reference of module which cb->dump belongs to */
-	if (!try_module_get(control->module)) {
+	if (!try_module_get(module)) {
 		ret = -EPROTONOSUPPORT;
 		goto error_unlock;
 	}
@@ -2202,8 +2205,8 @@ int __netlink_dump_start(struct sock *ssk, struct sk_buff *skb,
 	cb->dump = control->dump;
 	cb->done = control->done;
 	cb->nlh = nlh;
-	cb->data = control->data;
-	cb->module = control->module;
+	cb->data = data;
+	cb->module = module;
 	cb->min_dump_alloc = control->min_dump_alloc;
 	cb->skb = skb;
 
@@ -2470,7 +2473,7 @@ static int netlink_seq_show(struct seq_file *seq, void *v)
 			   sk_wmem_alloc_get(s),
 			   nlk->cb_running,
 			   atomic_read(&s->sk_refcnt),
-			   atomic_read(&s->sk_drops),
+			   atomic_read_unchecked(&s->sk_drops),
 			   sock_i_ino(s)
 			);
 
@@ -2577,7 +2580,7 @@ static void __init netlink_add_usersock_entry(void)
 	netlink_table_ungrab();
 }
 
-static struct pernet_operations __net_initdata netlink_net_ops = {
+static struct pernet_operations __net_initconst netlink_net_ops = {
 	.init = netlink_net_init,
 	.exit = netlink_net_exit,
 };
diff --git a/net/netlink/diag.c b/net/netlink/diag.c
index 8dd836a8d..196d1cd33 100644
--- a/net/netlink/diag.c
+++ b/net/netlink/diag.c
@@ -170,7 +170,7 @@ static int netlink_diag_handler_dump(struct sk_buff *skb, struct nlmsghdr *h)
 		return -EINVAL;
 
 	if (h->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = netlink_diag_dump,
 		};
 		return netlink_dump_start(net->diag_nlsk, skb, h, &c);
diff --git a/net/netlink/genetlink.c b/net/netlink/genetlink.c
index a09132a69..75aa3876f 100644
--- a/net/netlink/genetlink.c
+++ b/net/netlink/genetlink.c
@@ -571,28 +571,26 @@ static int genl_family_rcv_msg(struct genl_family *family,
 			return -EOPNOTSUPP;
 
 		if (!family->parallel_ops) {
-			struct netlink_dump_control c = {
-				.module = family->module,
-				/* we have const, but the netlink API doesn't */
-				.data = (void *)ops,
+			static struct netlink_dump_control c = {
 				.start = genl_lock_start,
 				.dump = genl_lock_dumpit,
 				.done = genl_lock_done,
 			};
+			/* we have const, but the netlink API doesn't */
+			void *data = (void *)ops;
 
 			genl_unlock();
-			rc = __netlink_dump_start(net->genl_sock, skb, nlh, &c);
+			rc = __netlink_dump_start(net->genl_sock, skb, nlh, &c, data, family->module);
 			genl_lock();
 
 		} else {
-			struct netlink_dump_control c = {
-				.module = family->module,
+			netlink_dump_control_no_const c = {
 				.start = ops->start,
 				.dump = ops->dumpit,
 				.done = ops->done,
 			};
 
-			rc = __netlink_dump_start(net->genl_sock, skb, nlh, &c);
+			rc = __netlink_dump_start(net->genl_sock, skb, nlh, &c, NULL, family->module);
 		}
 
 		return rc;
diff --git a/net/openvswitch/vport-geneve.c b/net/openvswitch/vport-geneve.c
index 5aaf3babf..5080d01b4 100644
--- a/net/openvswitch/vport-geneve.c
+++ b/net/openvswitch/vport-geneve.c
@@ -118,12 +118,17 @@ static struct vport *geneve_create(const struct vport_parms *parms)
 	return ovs_netdev_link(vport, parms->name);
 }
 
+static netdev_tx_t geneve_send(struct sk_buff *skb)
+{
+	return dev_queue_xmit(skb);
+}
+
 static struct vport_ops ovs_geneve_vport_ops = {
 	.type		= OVS_VPORT_TYPE_GENEVE,
 	.create		= geneve_create,
 	.destroy	= ovs_netdev_tunnel_destroy,
 	.get_options	= geneve_get_options,
-	.send		= dev_queue_xmit,
+	.send		= geneve_send,
 };
 
 static int __init ovs_geneve_tnl_init(void)
diff --git a/net/openvswitch/vport-gre.c b/net/openvswitch/vport-gre.c
index 0e72d95b0..c082af54e 100644
--- a/net/openvswitch/vport-gre.c
+++ b/net/openvswitch/vport-gre.c
@@ -91,10 +91,15 @@ static struct vport *gre_create(const struct vport_parms *parms)
 	return ovs_netdev_link(vport, parms->name);
 }
 
+static netdev_tx_t gre_send(struct sk_buff *skb)
+{
+	return dev_queue_xmit(skb);
+}
+
 static struct vport_ops ovs_gre_vport_ops = {
 	.type		= OVS_VPORT_TYPE_GRE,
 	.create		= gre_create,
-	.send		= dev_queue_xmit,
+	.send		= gre_send,
 	.destroy	= ovs_netdev_tunnel_destroy,
 };
 
diff --git a/net/openvswitch/vport-internal_dev.c b/net/openvswitch/vport-internal_dev.c
index 95c36147a..bfd4a19f9 100644
--- a/net/openvswitch/vport-internal_dev.c
+++ b/net/openvswitch/vport-internal_dev.c
@@ -44,7 +44,7 @@ static struct internal_dev *internal_dev_priv(struct net_device *netdev)
 }
 
 /* Called with rcu_read_lock_bh. */
-static int internal_dev_xmit(struct sk_buff *skb, struct net_device *netdev)
+static netdev_tx_t internal_dev_xmit(struct sk_buff *skb, struct net_device *netdev)
 {
 	int len, err;
 
@@ -153,7 +153,7 @@ static const struct net_device_ops internal_dev_netdev_ops = {
 	.ndo_set_rx_headroom = internal_set_rx_headroom,
 };
 
-static struct rtnl_link_ops internal_dev_link_ops __read_mostly = {
+static struct rtnl_link_ops internal_dev_link_ops = {
 	.kind = "openvswitch",
 };
 
diff --git a/net/openvswitch/vport-netdev.c b/net/openvswitch/vport-netdev.c
index 4e3972344..50265d900 100644
--- a/net/openvswitch/vport-netdev.c
+++ b/net/openvswitch/vport-netdev.c
@@ -204,11 +204,16 @@ struct vport *ovs_netdev_get_vport(struct net_device *dev)
 		return NULL;
 }
 
+static netdev_tx_t netdev_send(struct sk_buff *skb)
+{
+	return dev_queue_xmit(skb);
+}
+
 static struct vport_ops ovs_netdev_vport_ops = {
 	.type		= OVS_VPORT_TYPE_NETDEV,
 	.create		= netdev_create,
 	.destroy	= netdev_destroy,
-	.send		= dev_queue_xmit,
+	.send		= netdev_send,
 };
 
 int __init ovs_netdev_init(void)
diff --git a/net/openvswitch/vport-vxlan.c b/net/openvswitch/vport-vxlan.c
index 7eb955e45..479c9a618 100644
--- a/net/openvswitch/vport-vxlan.c
+++ b/net/openvswitch/vport-vxlan.c
@@ -155,12 +155,17 @@ static struct vport *vxlan_create(const struct vport_parms *parms)
 	return ovs_netdev_link(vport, parms->name);
 }
 
+static netdev_tx_t vxlan_send(struct sk_buff *skb)
+{
+	return dev_queue_xmit(skb);
+}
+
 static struct vport_ops ovs_vxlan_netdev_vport_ops = {
 	.type			= OVS_VPORT_TYPE_VXLAN,
 	.create			= vxlan_create,
 	.destroy		= ovs_netdev_tunnel_destroy,
 	.get_options		= vxlan_get_options,
-	.send			= dev_queue_xmit,
+	.send			= vxlan_send,
 };
 
 static int __init ovs_vxlan_tnl_init(void)
diff --git a/net/packet/af_packet.c b/net/packet/af_packet.c
index dd2332390..746fec270 100644
--- a/net/packet/af_packet.c
+++ b/net/packet/af_packet.c
@@ -278,7 +278,7 @@ static int packet_direct_xmit(struct sk_buff *skb)
 
 	return ret;
 drop:
-	atomic_long_inc(&dev->tx_dropped);
+	atomic_long_inc_unchecked(&dev->tx_dropped);
 	kfree_skb_list(skb);
 	return NET_XMIT_DROP;
 }
@@ -1391,9 +1391,9 @@ static unsigned int fanout_demux_rollover(struct packet_fanout *f,
 		    packet_rcv_has_room(po_next, skb) == ROOM_NORMAL) {
 			if (i != j)
 				po->rollover->sock = i;
-			atomic_long_inc(&po->rollover->num);
+			atomic_long_inc_unchecked(&po->rollover->num);
 			if (room == ROOM_LOW)
-				atomic_long_inc(&po->rollover->num_huge);
+				atomic_long_inc_unchecked(&po->rollover->num_huge);
 			return i;
 		}
 
@@ -1401,7 +1401,7 @@ static unsigned int fanout_demux_rollover(struct packet_fanout *f,
 			i = 0;
 	} while (i != j);
 
-	atomic_long_inc(&po->rollover->num_failed);
+	atomic_long_inc_unchecked(&po->rollover->num_failed);
 	return idx;
 }
 
@@ -1652,9 +1652,9 @@ static int fanout_add(struct sock *sk, u16 id, u16 type_flags)
 		po->rollover = kzalloc(sizeof(*po->rollover), GFP_KERNEL);
 		if (!po->rollover)
 			return -ENOMEM;
-		atomic_long_set(&po->rollover->num, 0);
-		atomic_long_set(&po->rollover->num_huge, 0);
-		atomic_long_set(&po->rollover->num_failed, 0);
+		atomic_long_set_unchecked(&po->rollover->num, 0);
+		atomic_long_set_unchecked(&po->rollover->num_huge, 0);
+		atomic_long_set_unchecked(&po->rollover->num_failed, 0);
 	}
 
 	mutex_lock(&fanout_mutex);
@@ -2106,7 +2106,7 @@ drop_n_acct:
 	is_drop_n_account = true;
 	spin_lock(&sk->sk_receive_queue.lock);
 	po->stats.stats1.tp_drops++;
-	atomic_inc(&sk->sk_drops);
+	atomic_inc_unchecked(&sk->sk_drops);
 	spin_unlock(&sk->sk_receive_queue.lock);
 
 drop_n_restore:
@@ -3847,7 +3847,7 @@ static int packet_getsockopt(struct socket *sock, int level, int optname,
 	case PACKET_HDRLEN:
 		if (len > sizeof(int))
 			len = sizeof(int);
-		if (copy_from_user(&val, optval, len))
+		if (len > sizeof(val) || copy_from_user(&val, optval, len))
 			return -EFAULT;
 		switch (val) {
 		case TPACKET_V1:
@@ -3882,9 +3882,9 @@ static int packet_getsockopt(struct socket *sock, int level, int optname,
 	case PACKET_ROLLOVER_STATS:
 		if (!po->rollover)
 			return -EINVAL;
-		rstats.tp_all = atomic_long_read(&po->rollover->num);
-		rstats.tp_huge = atomic_long_read(&po->rollover->num_huge);
-		rstats.tp_failed = atomic_long_read(&po->rollover->num_failed);
+		rstats.tp_all = atomic_long_read_unchecked(&po->rollover->num);
+		rstats.tp_huge = atomic_long_read_unchecked(&po->rollover->num_huge);
+		rstats.tp_failed = atomic_long_read_unchecked(&po->rollover->num_failed);
 		data = &rstats;
 		lv = sizeof(rstats);
 		break;
@@ -3902,7 +3902,7 @@ static int packet_getsockopt(struct socket *sock, int level, int optname,
 		len = lv;
 	if (put_user(len, optlen))
 		return -EFAULT;
-	if (copy_to_user(optval, data, len))
+	if (len > sizeof(st) || copy_to_user(optval, data, len))
 		return -EFAULT;
 	return 0;
 }
diff --git a/net/packet/diag.c b/net/packet/diag.c
index 0ed68f023..54c1dbe46 100644
--- a/net/packet/diag.c
+++ b/net/packet/diag.c
@@ -236,7 +236,7 @@ static int packet_diag_handler_dump(struct sk_buff *skb, struct nlmsghdr *h)
 		return -EINVAL;
 
 	if (h->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = packet_diag_dump,
 		};
 		return netlink_dump_start(net->diag_nlsk, skb, h, &c);
diff --git a/net/packet/internal.h b/net/packet/internal.h
index 9ee46314b..6b79352cb 100644
--- a/net/packet/internal.h
+++ b/net/packet/internal.h
@@ -93,9 +93,9 @@ struct packet_fanout {
 struct packet_rollover {
 	int			sock;
 	struct rcu_head		rcu;
-	atomic_long_t		num;
-	atomic_long_t		num_huge;
-	atomic_long_t		num_failed;
+	atomic_long_unchecked_t	num;
+	atomic_long_unchecked_t	num_huge;
+	atomic_long_unchecked_t	num_failed;
 #define ROLLOVER_HLEN	(L1_CACHE_BYTES / sizeof(u32))
 	u32			history[ROLLOVER_HLEN] ____cacheline_aligned;
 } ____cacheline_aligned_in_smp;
diff --git a/net/phonet/pep.c b/net/phonet/pep.c
index 850a86cde..8884a37cd 100644
--- a/net/phonet/pep.c
+++ b/net/phonet/pep.c
@@ -388,7 +388,7 @@ static int pipe_do_rcv(struct sock *sk, struct sk_buff *skb)
 
 	case PNS_PEP_CTRL_REQ:
 		if (skb_queue_len(&pn->ctrlreq_queue) >= PNPIPE_CTRLREQ_MAX) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			break;
 		}
 		__skb_pull(skb, 4);
@@ -409,7 +409,7 @@ static int pipe_do_rcv(struct sock *sk, struct sk_buff *skb)
 		}
 
 		if (pn->rx_credits == 0) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			err = -ENOBUFS;
 			break;
 		}
@@ -579,7 +579,7 @@ static int pipe_handler_do_rcv(struct sock *sk, struct sk_buff *skb)
 		}
 
 		if (pn->rx_credits == 0) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			err = NET_RX_DROP;
 			break;
 		}
diff --git a/net/phonet/socket.c b/net/phonet/socket.c
index ffd5f2297..94a18ec4c 100644
--- a/net/phonet/socket.c
+++ b/net/phonet/socket.c
@@ -613,7 +613,7 @@ static int pn_sock_seq_show(struct seq_file *seq, void *v)
 			from_kuid_munged(seq_user_ns(seq), sock_i_uid(sk)),
 			sock_i_ino(sk),
 			atomic_read(&sk->sk_refcnt), sk,
-			atomic_read(&sk->sk_drops));
+			atomic_read_unchecked(&sk->sk_drops));
 	}
 	seq_pad(seq, '\n');
 	return 0;
diff --git a/net/phonet/sysctl.c b/net/phonet/sysctl.c
index c02a8c4bc..3c5b60020 100644
--- a/net/phonet/sysctl.c
+++ b/net/phonet/sysctl.c
@@ -67,7 +67,7 @@ static int proc_local_port_range(struct ctl_table *table, int write,
 {
 	int ret;
 	int range[2] = {local_port_range[0], local_port_range[1]};
-	struct ctl_table tmp = {
+	ctl_table_no_const tmp = {
 		.data = &range,
 		.maxlen = sizeof(range),
 		.mode = table->mode,
diff --git a/net/rds/cong.c b/net/rds/cong.c
index 8398fee7c..80a1acaea 100644
--- a/net/rds/cong.c
+++ b/net/rds/cong.c
@@ -78,7 +78,7 @@
  * finds that the saved generation number is smaller than the global generation
  * number, it wakes up the process.
  */
-static atomic_t		rds_cong_generation = ATOMIC_INIT(0);
+static atomic_unchecked_t		rds_cong_generation = ATOMIC_INIT(0);
 
 /*
  * Congestion monitoring
@@ -248,7 +248,7 @@ void rds_cong_map_updated(struct rds_cong_map *map, uint64_t portmask)
 	rdsdebug("waking map %p for %pI4\n",
 	  map, &map->m_addr);
 	rds_stats_inc(s_cong_update_received);
-	atomic_inc(&rds_cong_generation);
+	atomic_inc_unchecked(&rds_cong_generation);
 	if (waitqueue_active(&map->m_waitq))
 		wake_up(&map->m_waitq);
 	if (waitqueue_active(&rds_poll_waitq))
@@ -274,7 +274,7 @@ EXPORT_SYMBOL_GPL(rds_cong_map_updated);
 
 int rds_cong_updated_since(unsigned long *recent)
 {
-	unsigned long gen = atomic_read(&rds_cong_generation);
+	unsigned long gen = atomic_read_unchecked(&rds_cong_generation);
 
 	if (likely(*recent == gen))
 		return 0;
diff --git a/net/rds/ib.h b/net/rds/ib.h
index 046f7508c..33fe9427b 100644
--- a/net/rds/ib.h
+++ b/net/rds/ib.h
@@ -153,7 +153,7 @@ struct rds_ib_connection {
 	/* sending acks */
 	unsigned long		i_ack_flags;
 #ifdef KERNEL_HAS_ATOMIC64
-	atomic64_t		i_ack_next;	/* next ACK to send */
+	atomic64_unchecked_t	i_ack_next;	/* next ACK to send */
 #else
 	spinlock_t		i_ack_lock;	/* protect i_ack_next */
 	u64			i_ack_next;	/* next ACK to send */
diff --git a/net/rds/ib_cm.c b/net/rds/ib_cm.c
index 5b2ab95af..be81157ed 100644
--- a/net/rds/ib_cm.c
+++ b/net/rds/ib_cm.c
@@ -833,7 +833,7 @@ void rds_ib_conn_path_shutdown(struct rds_conn_path *cp)
 	/* Clear the ACK state */
 	clear_bit(IB_ACK_IN_FLIGHT, &ic->i_ack_flags);
 #ifdef KERNEL_HAS_ATOMIC64
-	atomic64_set(&ic->i_ack_next, 0);
+	atomic64_set_unchecked(&ic->i_ack_next, 0);
 #else
 	ic->i_ack_next = 0;
 #endif
diff --git a/net/rds/ib_recv.c b/net/rds/ib_recv.c
index 606a11f68..4c55743f7 100644
--- a/net/rds/ib_recv.c
+++ b/net/rds/ib_recv.c
@@ -624,7 +624,7 @@ static u64 rds_ib_get_ack(struct rds_ib_connection *ic)
 #else
 void rds_ib_set_ack(struct rds_ib_connection *ic, u64 seq, int ack_required)
 {
-	atomic64_set(&ic->i_ack_next, seq);
+	atomic64_set_unchecked(&ic->i_ack_next, seq);
 	if (ack_required) {
 		smp_mb__before_atomic();
 		set_bit(IB_ACK_REQUESTED, &ic->i_ack_flags);
@@ -636,7 +636,7 @@ static u64 rds_ib_get_ack(struct rds_ib_connection *ic)
 	clear_bit(IB_ACK_REQUESTED, &ic->i_ack_flags);
 	smp_mb__after_atomic();
 
-	return atomic64_read(&ic->i_ack_next);
+	return atomic64_read_unchecked(&ic->i_ack_next);
 }
 #endif
 
diff --git a/net/rds/rds.h b/net/rds/rds.h
index b2d17f0fa..42f94e259 100644
--- a/net/rds/rds.h
+++ b/net/rds/rds.h
@@ -500,7 +500,7 @@ struct rds_transport {
 	void (*sync_mr)(void *trans_private, int direction);
 	void (*free_mr)(void *trans_private, int invalidate);
 	void (*flush_mrs)(void);
-};
+} __do_const;
 
 struct rds_sock {
 	struct sock		rs_sk;
diff --git a/net/rds/tcp.c b/net/rds/tcp.c
index fcddacc92..c6d3c3532 100644
--- a/net/rds/tcp.c
+++ b/net/rds/tcp.c
@@ -59,7 +59,7 @@ static int rds_tcp_skbuf_handler(struct ctl_table *ctl, int write,
 static int rds_tcp_min_sndbuf = SOCK_MIN_SNDBUF;
 static int rds_tcp_min_rcvbuf = SOCK_MIN_RCVBUF;
 
-static struct ctl_table rds_tcp_sysctl_table[] = {
+static ctl_table_no_const rds_tcp_sysctl_table[] = {
 #define	RDS_TCP_SNDBUF	0
 	{
 		.procname       = "rds_tcp_sndbuf",
@@ -88,7 +88,7 @@ void rds_tcp_nonagle(struct socket *sock)
 	int val = 1;
 
 	set_fs(KERNEL_DS);
-	sock->ops->setsockopt(sock, SOL_TCP, TCP_NODELAY, (char __user *)&val,
+	sock->ops->setsockopt(sock, SOL_TCP, TCP_NODELAY, (char __force_user *)&val,
 			      sizeof(val));
 	set_fs(oldfs);
 }
@@ -415,7 +415,7 @@ void rds_tcp_accept_work(struct sock *sk)
 static __net_init int rds_tcp_init_net(struct net *net)
 {
 	struct rds_tcp_net *rtn = net_generic(net, rds_tcp_netid);
-	struct ctl_table *tbl;
+	ctl_table_no_const *tbl;
 	int err = 0;
 
 	memset(rtn, 0, sizeof(*rtn));
diff --git a/net/rds/tcp.h b/net/rds/tcp.h
index 9a1cc8906..d5eb68da7 100644
--- a/net/rds/tcp.h
+++ b/net/rds/tcp.h
@@ -17,9 +17,9 @@ struct rds_tcp_connection {
 	 */
 	struct mutex		t_conn_path_lock;
 	struct socket		*t_sock;
-	void			*t_orig_write_space;
-	void			*t_orig_data_ready;
-	void			*t_orig_state_change;
+	void			(*t_orig_write_space)(struct sock *sk);
+	void			(*t_orig_data_ready)(struct sock *sk);
+	void			(*t_orig_state_change)(struct sock *sk);
 
 	struct rds_tcp_incoming	*t_tinc;
 	size_t			t_tinc_hdr_rem;
diff --git a/net/rds/tcp_send.c b/net/rds/tcp_send.c
index 89d09b481..1bc552576 100644
--- a/net/rds/tcp_send.c
+++ b/net/rds/tcp_send.c
@@ -44,7 +44,7 @@ static void rds_tcp_cork(struct socket *sock, int val)
 
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
-	sock->ops->setsockopt(sock, SOL_TCP, TCP_CORK, (char __user *)&val,
+	sock->ops->setsockopt(sock, SOL_TCP, TCP_CORK, (char __force_user *)&val,
 			      sizeof(val));
 	set_fs(oldfs);
 }
diff --git a/net/rxrpc/af_rxrpc.c b/net/rxrpc/af_rxrpc.c
index 88effadd4..5de1d9ca7 100644
--- a/net/rxrpc/af_rxrpc.c
+++ b/net/rxrpc/af_rxrpc.c
@@ -40,7 +40,7 @@ static const struct proto_ops rxrpc_rpc_ops;
 u32 rxrpc_epoch;
 
 /* current debugging ID */
-atomic_t rxrpc_debug_id;
+atomic_unchecked_t rxrpc_debug_id;
 
 /* count of skbs currently in use */
 atomic_t rxrpc_n_skbs;
diff --git a/net/rxrpc/ar-internal.h b/net/rxrpc/ar-internal.h
index ff83fb1dd..1b148b036 100644
--- a/net/rxrpc/ar-internal.h
+++ b/net/rxrpc/ar-internal.h
@@ -85,7 +85,7 @@ struct rxrpc_host_header {
 	u32		epoch;		/* client boot timestamp */
 	u32		cid;		/* connection and channel ID */
 	u32		callNumber;	/* call ID (0 for connection-level packets) */
-	u32		seq;		/* sequence number of pkt in call stream */
+	u32		seq __intentional_overflow(-1);	/* sequence number of pkt in call stream */
 	u32		serial;		/* serial number of pkt sent to network */
 	u8		type;		/* packet type */
 	u8		flags;		/* packet flags */
@@ -321,8 +321,8 @@ struct rxrpc_connection {
 	u32			remote_abort;	/* remote abort code */
 	int			error;		/* local error incurred */
 	int			debug_id;	/* debug ID for printks */
-	atomic_t		serial;		/* packet serial number counter */
-	atomic_t		hi_serial;	/* highest serial number received */
+	atomic_unchecked_t	serial;		/* packet serial number counter */
+	atomic_unchecked_t	hi_serial;	/* highest serial number received */
 	atomic_t		avail_chans;	/* number of channels available */
 	u8			size_align;	/* data size alignment (for security) */
 	u8			header_size;	/* rxrpc + security header size */
@@ -426,7 +426,7 @@ struct rxrpc_call {
 	rwlock_t		state_lock;	/* lock for state transition */
 	atomic_t		usage;
 	atomic_t		skb_count;	/* Outstanding packets on this call */
-	atomic_t		sequence;	/* Tx data packet sequence counter */
+	atomic_unchecked_t	sequence;	/* Tx data packet sequence counter */
 	u32			local_abort;	/* local abort code */
 	u32			remote_abort;	/* remote abort code */
 	int			error_report;	/* Network error (ICMP/local transport) */
@@ -489,7 +489,7 @@ static inline void rxrpc_abort_call(struct rxrpc_call *call, u32 abort_code)
  */
 extern atomic_t rxrpc_n_skbs;
 extern u32 rxrpc_epoch;
-extern atomic_t rxrpc_debug_id;
+extern atomic_unchecked_t rxrpc_debug_id;
 extern struct workqueue_struct *rxrpc_workqueue;
 
 /*
diff --git a/net/rxrpc/call_event.c b/net/rxrpc/call_event.c
index e60cf65c2..e7fb167f8 100644
--- a/net/rxrpc/call_event.c
+++ b/net/rxrpc/call_event.c
@@ -157,7 +157,7 @@ static void rxrpc_resend(struct rxrpc_call *call)
 
 	_enter("{%d,%d,%d,%d},",
 	       call->acks_hard, call->acks_unacked,
-	       atomic_read(&call->sequence),
+	       atomic_read_unchecked(&call->sequence),
 	       CIRC_CNT(call->acks_head, call->acks_tail, call->acks_winsz));
 
 	stop = false;
@@ -180,7 +180,7 @@ static void rxrpc_resend(struct rxrpc_call *call)
 			sp->need_resend = false;
 
 			/* each Tx packet has a new serial number */
-			sp->hdr.serial = atomic_inc_return(&call->conn->serial);
+			sp->hdr.serial = atomic_inc_return_unchecked(&call->conn->serial);
 
 			whdr = (struct rxrpc_wire_header *)txb->head;
 			whdr->serial = htonl(sp->hdr.serial);
@@ -384,7 +384,7 @@ static void rxrpc_rotate_tx_window(struct rxrpc_call *call, u32 hard)
  */
 static void rxrpc_clear_tx_window(struct rxrpc_call *call)
 {
-	rxrpc_rotate_tx_window(call, atomic_read(&call->sequence));
+	rxrpc_rotate_tx_window(call, atomic_read_unchecked(&call->sequence));
 }
 
 /*
@@ -609,7 +609,7 @@ process_further:
 
 		latest = sp->hdr.serial;
 		hard = ntohl(ack.firstPacket);
-		tx = atomic_read(&call->sequence);
+		tx = atomic_read_unchecked(&call->sequence);
 
 		_proto("Rx ACK %%%u { m=%hu f=#%u p=#%u s=%%%u r=%s n=%u }",
 		       latest,
@@ -1155,7 +1155,7 @@ skip_msg_init:
 	goto maybe_reschedule;
 
 send_ACK_with_skew:
-	ack.maxSkew = htons(atomic_read(&call->conn->hi_serial) -
+	ack.maxSkew = htons(atomic_read_unchecked(&call->conn->hi_serial) -
 			    ntohl(ack.serial));
 send_ACK:
 	mtu = call->conn->params.peer->if_mtu;
@@ -1167,7 +1167,7 @@ send_ACK:
 	ackinfo.rxMTU	= htonl(rxrpc_rx_mtu);
 	ackinfo.jumbo_max = htonl(rxrpc_rx_jumbo_max);
 
-	serial = atomic_inc_return(&call->conn->serial);
+	serial = atomic_inc_return_unchecked(&call->conn->serial);
 	whdr.serial = htonl(serial);
 	_proto("Tx ACK %%%u { m=%hu f=#%u p=#%u s=%%%u r=%s n=%u }",
 	       serial,
@@ -1186,7 +1186,7 @@ send_ACK:
 send_message:
 	_debug("send message");
 
-	serial = atomic_inc_return(&call->conn->serial);
+	serial = atomic_inc_return_unchecked(&call->conn->serial);
 	whdr.serial = htonl(serial);
 	_proto("Tx %s %%%u", rxrpc_pkts[whdr.type], serial);
 send_message_2:
diff --git a/net/rxrpc/call_object.c b/net/rxrpc/call_object.c
index ae057e074..9cc546ddf 100644
--- a/net/rxrpc/call_object.c
+++ b/net/rxrpc/call_object.c
@@ -134,7 +134,7 @@ static struct rxrpc_call *rxrpc_alloc_call(gfp_t gfp)
 	spin_lock_init(&call->lock);
 	rwlock_init(&call->state_lock);
 	atomic_set(&call->usage, 1);
-	call->debug_id = atomic_inc_return(&rxrpc_debug_id);
+	call->debug_id = atomic_inc_return_unchecked(&rxrpc_debug_id);
 
 	memset(&call->sock_node, 0xed, sizeof(call->sock_node));
 
diff --git a/net/rxrpc/conn_event.c b/net/rxrpc/conn_event.c
index cee0f35bc..2b9be7faa 100644
--- a/net/rxrpc/conn_event.c
+++ b/net/rxrpc/conn_event.c
@@ -116,7 +116,7 @@ static int rxrpc_abort_connection(struct rxrpc_connection *conn,
 
 	len = iov[0].iov_len + iov[1].iov_len;
 
-	serial = atomic_inc_return(&conn->serial);
+	serial = atomic_inc_return_unchecked(&conn->serial);
 	whdr.serial = htonl(serial);
 	_proto("Tx CONN ABORT %%%u { %d }", serial, conn->local_abort);
 
diff --git a/net/rxrpc/conn_object.c b/net/rxrpc/conn_object.c
index 896d84493..ce1390a17 100644
--- a/net/rxrpc/conn_object.c
+++ b/net/rxrpc/conn_object.c
@@ -52,7 +52,7 @@ struct rxrpc_connection *rxrpc_alloc_connection(gfp_t gfp)
 		 * on the rxrpc_connections list.
 		 */
 		atomic_set(&conn->usage, 2);
-		conn->debug_id = atomic_inc_return(&rxrpc_debug_id);
+		conn->debug_id = atomic_inc_return_unchecked(&rxrpc_debug_id);
 		atomic_set(&conn->avail_chans, RXRPC_MAXCALLS);
 		conn->size_align = 4;
 		conn->header_size = sizeof(struct rxrpc_wire_header);
diff --git a/net/rxrpc/input.c b/net/rxrpc/input.c
index 70bb77818..8b3411c70 100644
--- a/net/rxrpc/input.c
+++ b/net/rxrpc/input.c
@@ -323,9 +323,9 @@ void rxrpc_fast_process_packet(struct rxrpc_call *call, struct sk_buff *skb)
 
 	/* track the latest serial number on this connection for ACK packet
 	 * information */
-	hi_serial = atomic_read(&call->conn->hi_serial);
+	hi_serial = atomic_read_unchecked(&call->conn->hi_serial);
 	while (sp->hdr.serial > hi_serial)
-		hi_serial = atomic_cmpxchg(&call->conn->hi_serial, hi_serial,
+		hi_serial = atomic_cmpxchg_unchecked(&call->conn->hi_serial, hi_serial,
 					   sp->hdr.serial);
 
 	/* request ACK generation for any ACK or DATA packet that requests
diff --git a/net/rxrpc/local_object.c b/net/rxrpc/local_object.c
index a753796fb..7151cb160 100644
--- a/net/rxrpc/local_object.c
+++ b/net/rxrpc/local_object.c
@@ -84,7 +84,7 @@ static struct rxrpc_local *rxrpc_alloc_local(const struct sockaddr_rxrpc *srx)
 		spin_lock_init(&local->client_conns_lock);
 		spin_lock_init(&local->lock);
 		rwlock_init(&local->services_lock);
-		local->debug_id = atomic_inc_return(&rxrpc_debug_id);
+		local->debug_id = atomic_inc_return_unchecked(&rxrpc_debug_id);
 		memcpy(&local->srx, srx, sizeof(*srx));
 	}
 
diff --git a/net/rxrpc/output.c b/net/rxrpc/output.c
index f4bda06b7..afdfbd2d5 100644
--- a/net/rxrpc/output.c
+++ b/net/rxrpc/output.c
@@ -657,13 +657,13 @@ static int rxrpc_send_data(struct rxrpc_sock *rx,
 					memset(skb_put(skb, pad), 0, pad);
 			}
 
-			seq = atomic_inc_return(&call->sequence);
+			seq = atomic_inc_return_unchecked(&call->sequence);
 
 			sp->hdr.epoch	= conn->proto.epoch;
 			sp->hdr.cid	= call->cid;
 			sp->hdr.callNumber = call->call_id;
 			sp->hdr.seq	= seq;
-			sp->hdr.serial	= atomic_inc_return(&conn->serial);
+			sp->hdr.serial	= atomic_inc_return_unchecked(&conn->serial);
 			sp->hdr.type	= RXRPC_PACKET_TYPE_DATA;
 			sp->hdr.userStatus = 0;
 			sp->hdr.securityIndex = conn->security_ix;
diff --git a/net/rxrpc/peer_object.c b/net/rxrpc/peer_object.c
index 538e9831c..854d3fb8b 100644
--- a/net/rxrpc/peer_object.c
+++ b/net/rxrpc/peer_object.c
@@ -191,7 +191,7 @@ struct rxrpc_peer *rxrpc_alloc_peer(struct rxrpc_local *local, gfp_t gfp)
 		peer->service_conns = RB_ROOT;
 		seqlock_init(&peer->service_conn_lock);
 		spin_lock_init(&peer->lock);
-		peer->debug_id = atomic_inc_return(&rxrpc_debug_id);
+		peer->debug_id = atomic_inc_return_unchecked(&rxrpc_debug_id);
 	}
 
 	_leave(" = %p", peer);
diff --git a/net/rxrpc/proc.c b/net/rxrpc/proc.c
index ced5f0744..26cd1152c 100644
--- a/net/rxrpc/proc.c
+++ b/net/rxrpc/proc.c
@@ -164,8 +164,8 @@ static int rxrpc_connection_seq_show(struct seq_file *seq, void *v)
 		   atomic_read(&conn->usage),
 		   rxrpc_conn_states[conn->state],
 		   key_serial(conn->params.key),
-		   atomic_read(&conn->serial),
-		   atomic_read(&conn->hi_serial));
+		   atomic_read_unchecked(&conn->serial),
+		   atomic_read_unchecked(&conn->hi_serial));
 
 	return 0;
 }
diff --git a/net/rxrpc/rxkad.c b/net/rxrpc/rxkad.c
index 63afa9e9c..5931eaec8 100644
--- a/net/rxrpc/rxkad.c
+++ b/net/rxrpc/rxkad.c
@@ -599,7 +599,7 @@ static int rxkad_issue_challenge(struct rxrpc_connection *conn)
 
 	len = iov[0].iov_len + iov[1].iov_len;
 
-	serial = atomic_inc_return(&conn->serial);
+	serial = atomic_inc_return_unchecked(&conn->serial);
 	whdr.serial = htonl(serial);
 	_proto("Tx CHALLENGE %%%u", serial);
 
@@ -653,7 +653,7 @@ static int rxkad_send_response(struct rxrpc_connection *conn,
 
 	len = iov[0].iov_len + iov[1].iov_len + iov[2].iov_len;
 
-	serial = atomic_inc_return(&conn->serial);
+	serial = atomic_inc_return_unchecked(&conn->serial);
 	whdr.serial = htonl(serial);
 	_proto("Tx RESPONSE %%%u", serial);
 
diff --git a/net/sched/sch_generic.c b/net/sched/sch_generic.c
index 657c13362..756ac5e58 100644
--- a/net/sched/sch_generic.c
+++ b/net/sched/sch_generic.c
@@ -362,7 +362,7 @@ void netif_carrier_on(struct net_device *dev)
 	if (test_and_clear_bit(__LINK_STATE_NOCARRIER, &dev->state)) {
 		if (dev->reg_state == NETREG_UNINITIALIZED)
 			return;
-		atomic_inc(&dev->carrier_changes);
+		atomic_inc_unchecked(&dev->carrier_changes);
 		linkwatch_fire_event(dev);
 		if (netif_running(dev))
 			__netdev_watchdog_up(dev);
@@ -381,7 +381,7 @@ void netif_carrier_off(struct net_device *dev)
 	if (!test_and_set_bit(__LINK_STATE_NOCARRIER, &dev->state)) {
 		if (dev->reg_state == NETREG_UNINITIALIZED)
 			return;
-		atomic_inc(&dev->carrier_changes);
+		atomic_inc_unchecked(&dev->carrier_changes);
 		linkwatch_fire_event(dev);
 	}
 }
diff --git a/net/sched/sch_tbf.c b/net/sched/sch_tbf.c
index 303355c44..d6ce615dc 100644
--- a/net/sched/sch_tbf.c
+++ b/net/sched/sch_tbf.c
@@ -162,7 +162,8 @@ static int tbf_segment(struct sk_buff *skb, struct Qdisc *sch,
 	struct sk_buff *segs, *nskb;
 	netdev_features_t features = netif_skb_features(skb);
 	unsigned int len = 0, prev_len = qdisc_pkt_len(skb);
-	int ret, nb;
+	int ret;
+	unsigned int nb;
 
 	segs = skb_gso_segment(skb, features & ~NETIF_F_GSO_MASK);
 
@@ -185,8 +186,10 @@ static int tbf_segment(struct sk_buff *skb, struct Qdisc *sch,
 		segs = nskb;
 	}
 	sch->q.qlen += nb;
-	if (nb > 1)
-		qdisc_tree_reduce_backlog(sch, 1 - nb, prev_len - len);
+	if (nb > 1) {
+		nb--;
+		qdisc_tree_reduce_backlog(sch, -nb, prev_len - len);
+	}
 	consume_skb(skb);
 	return nb > 0 ? NET_XMIT_SUCCESS : NET_XMIT_DROP;
 }
diff --git a/net/sctp/ipv6.c b/net/sctp/ipv6.c
index f473779e8..ec2667cd1 100644
--- a/net/sctp/ipv6.c
+++ b/net/sctp/ipv6.c
@@ -990,7 +990,7 @@ static const struct inet6_protocol sctpv6_protocol = {
 	.flags        = INET6_PROTO_NOPOLICY | INET6_PROTO_FINAL,
 };
 
-static struct sctp_af sctp_af_inet6 = {
+static struct sctp_af sctp_af_inet6 __read_only = {
 	.sa_family	   = AF_INET6,
 	.sctp_xmit	   = sctp_v6_xmit,
 	.setsockopt	   = ipv6_setsockopt,
@@ -1047,7 +1047,7 @@ void sctp_v6_pf_init(void)
 
 void sctp_v6_pf_exit(void)
 {
-	list_del(&sctp_af_inet6.list);
+	pax_list_del(&sctp_af_inet6.list);
 }
 
 /* Initialize IPv6 support and register with socket layer.  */
diff --git a/net/sctp/protocol.c b/net/sctp/protocol.c
index 7b523e3f5..0fe6a3882 100644
--- a/net/sctp/protocol.c
+++ b/net/sctp/protocol.c
@@ -860,8 +860,10 @@ int sctp_register_af(struct sctp_af *af)
 		return 0;
 	}
 
+	pax_open_kernel();
 	INIT_LIST_HEAD(&af->list);
-	list_add_tail(&af->list, &sctp_address_families);
+	pax_close_kernel();
+	pax_list_add_tail(&af->list, &sctp_address_families);
 	return 1;
 }
 
@@ -1063,7 +1065,7 @@ static const struct net_protocol sctp_protocol = {
 };
 
 /* IPv4 address related functions.  */
-static struct sctp_af sctp_af_inet = {
+static struct sctp_af sctp_af_inet __read_only = {
 	.sa_family	   = AF_INET,
 	.sctp_xmit	   = sctp_v4_xmit,
 	.setsockopt	   = ip_setsockopt,
@@ -1147,7 +1149,7 @@ static void sctp_v4_pf_init(void)
 
 static void sctp_v4_pf_exit(void)
 {
-	list_del(&sctp_af_inet.list);
+	pax_list_del(&sctp_af_inet.list);
 }
 
 static int sctp_v4_protosw_init(void)
diff --git a/net/sctp/sctp_diag.c b/net/sctp/sctp_diag.c
index cef0cee18..2058df766 100644
--- a/net/sctp/sctp_diag.c
+++ b/net/sctp/sctp_diag.c
@@ -156,7 +156,7 @@ static int inet_sctp_diag_fill(struct sock *sk, struct sctp_association *asoc,
 		mem[SK_MEMINFO_WMEM_QUEUED] = sk->sk_wmem_queued;
 		mem[SK_MEMINFO_OPTMEM] = atomic_read(&sk->sk_omem_alloc);
 		mem[SK_MEMINFO_BACKLOG] = sk->sk_backlog.len;
-		mem[SK_MEMINFO_DROPS] = atomic_read(&sk->sk_drops);
+		mem[SK_MEMINFO_DROPS] = atomic_read_unchecked(&sk->sk_drops);
 
 		if (nla_put(skb, INET_DIAG_SKMEMINFO, sizeof(mem), &mem) < 0)
 			goto errout;
diff --git a/net/sctp/sm_sideeffect.c b/net/sctp/sm_sideeffect.c
index 12d451933..367dae448 100644
--- a/net/sctp/sm_sideeffect.c
+++ b/net/sctp/sm_sideeffect.c
@@ -444,7 +444,7 @@ static void sctp_generate_sack_event(unsigned long data)
 	sctp_generate_timeout_event(asoc, SCTP_EVENT_TIMEOUT_SACK);
 }
 
-sctp_timer_event_t *sctp_timer_events[SCTP_NUM_TIMEOUT_TYPES] = {
+sctp_timer_event_t * const sctp_timer_events[SCTP_NUM_TIMEOUT_TYPES] = {
 	NULL,
 	sctp_generate_t1_cookie_event,
 	sctp_generate_t1_init_event,
@@ -1097,7 +1097,7 @@ int sctp_do_sm(struct net *net, sctp_event_t event_type, sctp_subtype_t subtype,
 	const sctp_sm_table_entry_t *state_fn;
 	sctp_disposition_t status;
 	int error = 0;
-	typedef const char *(printfn_t)(sctp_subtype_t);
+	typedef const char *(printfn_t)(const sctp_subtype_t);
 	static printfn_t *table[] = {
 		NULL, sctp_cname, sctp_tname, sctp_oname, sctp_pname,
 	};
diff --git a/net/sctp/socket.c b/net/sctp/socket.c
index 7b0e059bf..96ff61937 100644
--- a/net/sctp/socket.c
+++ b/net/sctp/socket.c
@@ -2202,11 +2202,13 @@ static int sctp_setsockopt_events(struct sock *sk, char __user *optval,
 {
 	struct sctp_association *asoc;
 	struct sctp_ulpevent *event;
+	struct sctp_event_subscribe subscribe;
 
 	if (optlen > sizeof(struct sctp_event_subscribe))
 		return -EINVAL;
-	if (copy_from_user(&sctp_sk(sk)->subscribe, optval, optlen))
+	if (copy_from_user(&subscribe, optval, optlen))
 		return -EFAULT;
+	sctp_sk(sk)->subscribe = subscribe;
 
 	/* At the time when a user app subscribes to SCTP_SENDER_DRY_EVENT,
 	 * if there is no data to be sent or retransmit, the stack will
@@ -4685,13 +4687,16 @@ static int sctp_getsockopt_disable_fragments(struct sock *sk, int len,
 static int sctp_getsockopt_events(struct sock *sk, int len, char __user *optval,
 				  int __user *optlen)
 {
+	struct sctp_event_subscribe subscribe;
+
 	if (len == 0)
 		return -EINVAL;
 	if (len > sizeof(struct sctp_event_subscribe))
 		len = sizeof(struct sctp_event_subscribe);
 	if (put_user(len, optlen))
 		return -EFAULT;
-	if (copy_to_user(optval, &sctp_sk(sk)->subscribe, len))
+	subscribe = sctp_sk(sk)->subscribe;
+	if (copy_to_user(optval, &subscribe, len))
 		return -EFAULT;
 	return 0;
 }
@@ -4709,6 +4714,8 @@ static int sctp_getsockopt_events(struct sock *sk, int len, char __user *optval,
  */
 static int sctp_getsockopt_autoclose(struct sock *sk, int len, char __user *optval, int __user *optlen)
 {
+	__u32 autoclose;
+
 	/* Applicable to UDP-style socket only */
 	if (sctp_style(sk, TCP))
 		return -EOPNOTSUPP;
@@ -4717,7 +4724,8 @@ static int sctp_getsockopt_autoclose(struct sock *sk, int len, char __user *optv
 	len = sizeof(int);
 	if (put_user(len, optlen))
 		return -EFAULT;
-	if (copy_to_user(optval, &sctp_sk(sk)->autoclose, sizeof(int)))
+	autoclose = sctp_sk(sk)->autoclose;
+	if (copy_to_user(optval, &autoclose, sizeof(int)))
 		return -EFAULT;
 	return 0;
 }
@@ -5091,12 +5099,15 @@ static int sctp_getsockopt_delayed_ack(struct sock *sk, int len,
  */
 static int sctp_getsockopt_initmsg(struct sock *sk, int len, char __user *optval, int __user *optlen)
 {
+	struct sctp_initmsg initmsg;
+
 	if (len < sizeof(struct sctp_initmsg))
 		return -EINVAL;
 	len = sizeof(struct sctp_initmsg);
 	if (put_user(len, optlen))
 		return -EFAULT;
-	if (copy_to_user(optval, &sctp_sk(sk)->initmsg, len))
+	initmsg = sctp_sk(sk)->initmsg;
+	if (copy_to_user(optval, &initmsg, len))
 		return -EFAULT;
 	return 0;
 }
@@ -5137,6 +5148,8 @@ static int sctp_getsockopt_peer_addrs(struct sock *sk, int len,
 			      ->addr_to_user(sp, &temp);
 		if (space_left < addrlen)
 			return -ENOMEM;
+		if (addrlen > sizeof(temp) || addrlen < 0)
+			return -EFAULT;
 		if (copy_to_user(to, &temp, addrlen))
 			return -EFAULT;
 		to += addrlen;
diff --git a/net/sctp/sysctl.c b/net/sctp/sysctl.c
index daf8554fd..4ab495b0f 100644
--- a/net/sctp/sysctl.c
+++ b/net/sctp/sysctl.c
@@ -324,7 +324,7 @@ static int proc_sctp_do_hmac_alg(struct ctl_table *ctl, int write,
 				loff_t *ppos)
 {
 	struct net *net = current->nsproxy->net_ns;
-	struct ctl_table tbl;
+	ctl_table_no_const tbl;
 	bool changed = false;
 	char *none = "none";
 	char tmp[8] = {0};
@@ -372,7 +372,7 @@ static int proc_sctp_do_rto_min(struct ctl_table *ctl, int write,
 	struct net *net = current->nsproxy->net_ns;
 	unsigned int min = *(unsigned int *) ctl->extra1;
 	unsigned int max = *(unsigned int *) ctl->extra2;
-	struct ctl_table tbl;
+	ctl_table_no_const tbl;
 	int ret, new_value;
 
 	memset(&tbl, 0, sizeof(struct ctl_table));
@@ -401,7 +401,7 @@ static int proc_sctp_do_rto_max(struct ctl_table *ctl, int write,
 	struct net *net = current->nsproxy->net_ns;
 	unsigned int min = *(unsigned int *) ctl->extra1;
 	unsigned int max = *(unsigned int *) ctl->extra2;
-	struct ctl_table tbl;
+	ctl_table_no_const tbl;
 	int ret, new_value;
 
 	memset(&tbl, 0, sizeof(struct ctl_table));
@@ -439,7 +439,7 @@ static int proc_sctp_do_auth(struct ctl_table *ctl, int write,
 			     loff_t *ppos)
 {
 	struct net *net = current->nsproxy->net_ns;
-	struct ctl_table tbl;
+	ctl_table_no_const tbl;
 	int new_value, ret;
 
 	memset(&tbl, 0, sizeof(struct ctl_table));
@@ -466,7 +466,7 @@ static int proc_sctp_do_auth(struct ctl_table *ctl, int write,
 
 int sctp_sysctl_net_register(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 	int i;
 
 	table = kmemdup(sctp_net_table, sizeof(sctp_net_table), GFP_KERNEL);
diff --git a/net/socket.c b/net/socket.c
index 03bc2c289..d3f469936 100644
--- a/net/socket.c
+++ b/net/socket.c
@@ -89,6 +89,7 @@
 #include <linux/magic.h>
 #include <linux/slab.h>
 #include <linux/xattr.h>
+#include <linux/in.h>
 
 #include <asm/uaccess.h>
 #include <asm/unistd.h>
@@ -107,6 +108,7 @@
 #include <linux/atalk.h>
 #include <net/busy_poll.h>
 #include <linux/errqueue.h>
+#include <linux/grsock.h>
 
 #ifdef CONFIG_NET_RX_BUSY_POLL
 unsigned int sysctl_net_busy_read __read_mostly;
@@ -160,7 +162,7 @@ static const struct file_operations socket_file_ops = {
  */
 
 static DEFINE_SPINLOCK(net_family_lock);
-static const struct net_proto_family __rcu *net_families[NPROTO] __read_mostly;
+const struct net_proto_family __rcu *net_families[NPROTO] __read_mostly;
 
 /*
  *	Statistics counters of the socket lists
@@ -327,7 +329,7 @@ static struct dentry *sockfs_mount(struct file_system_type *fs_type,
 		&sockfs_dentry_operations, SOCKFS_MAGIC);
 }
 
-static struct vfsmount *sock_mnt __read_mostly;
+struct vfsmount *sock_mnt __read_mostly;
 
 static struct file_system_type sock_fs_type = {
 	.name =		"sockfs",
@@ -1096,6 +1098,8 @@ int __sock_create(struct net *net, int family, int type, int protocol,
 		return -EAFNOSUPPORT;
 	if (type < 0 || type >= SOCK_MAX)
 		return -EINVAL;
+	if (protocol < 0)
+		return -EINVAL;
 
 	/* Compatibility.
 
@@ -1112,6 +1116,20 @@ int __sock_create(struct net *net, int family, int type, int protocol,
 	if (err)
 		return err;
 
+	if(!kern && !gr_search_socket(family, type, protocol)) {
+		if (rcu_access_pointer(net_families[family]) == NULL)
+			return -EAFNOSUPPORT;
+		else
+			return -EACCES;
+	}
+
+	if (!kern && gr_handle_sock_all(family, type, protocol)) {
+		if (rcu_access_pointer(net_families[family]) == NULL)
+			return -EAFNOSUPPORT;
+		else
+			return -EACCES;
+	}
+
 	/*
 	 *	Allocate the socket and allow the family to set things up. if
 	 *	the protocol is 0, the family is instructed to select an appropriate
@@ -1363,6 +1381,14 @@ SYSCALL_DEFINE3(bind, int, fd, struct sockaddr __user *, umyaddr, int, addrlen)
 	if (sock) {
 		err = move_addr_to_kernel(umyaddr, addrlen, &address);
 		if (err >= 0) {
+			if (gr_handle_sock_server((struct sockaddr *)&address)) {
+				err = -EACCES;
+				goto error;
+			}
+			err = gr_search_bind(sock, (struct sockaddr_in *)&address);
+			if (err)
+				goto error;
+
 			err = security_socket_bind(sock,
 						   (struct sockaddr *)&address,
 						   addrlen);
@@ -1371,6 +1397,7 @@ SYSCALL_DEFINE3(bind, int, fd, struct sockaddr __user *, umyaddr, int, addrlen)
 						      (struct sockaddr *)
 						      &address, addrlen);
 		}
+error:
 		fput_light(sock->file, fput_needed);
 	}
 	return err;
@@ -1394,10 +1421,20 @@ SYSCALL_DEFINE2(listen, int, fd, int, backlog)
 		if ((unsigned int)backlog > somaxconn)
 			backlog = somaxconn;
 
+		if (gr_handle_sock_server_other(sock->sk)) {
+			err = -EPERM;
+			goto error;
+		}
+
+		err = gr_search_listen(sock);
+		if (err)
+			goto error;
+
 		err = security_socket_listen(sock, backlog);
 		if (!err)
 			err = sock->ops->listen(sock, backlog);
 
+error:
 		fput_light(sock->file, fput_needed);
 	}
 	return err;
@@ -1441,6 +1478,18 @@ SYSCALL_DEFINE4(accept4, int, fd, struct sockaddr __user *, upeer_sockaddr,
 	newsock->type = sock->type;
 	newsock->ops = sock->ops;
 
+	if (gr_handle_sock_server_other(sock->sk)) {
+		err = -EPERM;
+		sock_release(newsock);
+		goto out_put;
+	}
+
+	err = gr_search_accept(sock);
+	if (err) {
+		sock_release(newsock);
+		goto out_put;
+	}
+
 	/*
 	 * We don't need try_module_get here, as the listening socket (sock)
 	 * has the protocol module (sock->ops->owner) held.
@@ -1486,6 +1535,8 @@ SYSCALL_DEFINE4(accept4, int, fd, struct sockaddr __user *, upeer_sockaddr,
 	fd_install(newfd, newfile);
 	err = newfd;
 
+	gr_attach_curr_ip(newsock->sk);
+
 out_put:
 	fput_light(sock->file, fput_needed);
 out:
@@ -1518,6 +1569,7 @@ SYSCALL_DEFINE3(connect, int, fd, struct sockaddr __user *, uservaddr,
 		int, addrlen)
 {
 	struct socket *sock;
+	struct sockaddr *sck;
 	struct sockaddr_storage address;
 	int err, fput_needed;
 
@@ -1528,6 +1580,17 @@ SYSCALL_DEFINE3(connect, int, fd, struct sockaddr __user *, uservaddr,
 	if (err < 0)
 		goto out_put;
 
+	sck = (struct sockaddr *)&address;
+
+	if (gr_handle_sock_client(sck)) {
+		err = -EACCES;
+		goto out_put;
+	}
+
+	err = gr_search_connect(sock, (struct sockaddr_in *)sck);
+	if (err)
+		goto out_put;
+
 	err =
 	    security_socket_connect(sock, (struct sockaddr *)&address, addrlen);
 	if (err)
@@ -1550,7 +1613,7 @@ SYSCALL_DEFINE3(getsockname, int, fd, struct sockaddr __user *, usockaddr,
 		int __user *, usockaddr_len)
 {
 	struct socket *sock;
-	struct sockaddr_storage address;
+	struct sockaddr_storage address = { };
 	int len, err, fput_needed;
 
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
@@ -1581,7 +1644,7 @@ SYSCALL_DEFINE3(getpeername, int, fd, struct sockaddr __user *, usockaddr,
 		int __user *, usockaddr_len)
 {
 	struct socket *sock;
-	struct sockaddr_storage address;
+	struct sockaddr_storage address = { };
 	int len, err, fput_needed;
 
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
@@ -1609,6 +1672,8 @@ SYSCALL_DEFINE3(getpeername, int, fd, struct sockaddr __user *, usockaddr,
  *	the protocol.
  */
 
+asmlinkage long sys_sendto(int, void __user *, size_t, unsigned, struct sockaddr __user *, int);
+
 SYSCALL_DEFINE6(sendto, int, fd, void __user *, buff, size_t, len,
 		unsigned int, flags, struct sockaddr __user *, addr,
 		int, addr_len)
@@ -1672,7 +1737,7 @@ SYSCALL_DEFINE6(recvfrom, int, fd, void __user *, ubuf, size_t, size,
 	struct socket *sock;
 	struct iovec iov;
 	struct msghdr msg;
-	struct sockaddr_storage address;
+	struct sockaddr_storage address = { };
 	int err, err2;
 	int fput_needed;
 
@@ -1917,7 +1982,7 @@ static int ___sys_sendmsg(struct socket *sock, struct user_msghdr __user *msg,
 		 * checking falls down on this.
 		 */
 		if (copy_from_user(ctl_buf,
-				   (void __user __force *)msg_sys->msg_control,
+				   (void __force_user *)msg_sys->msg_control,
 				   ctl_len))
 			goto out_freectl;
 		msg_sys->msg_control = ctl_buf;
@@ -2075,7 +2140,7 @@ static int ___sys_recvmsg(struct socket *sock, struct user_msghdr __user *msg,
 	ssize_t err;
 
 	/* kernel mode address */
-	struct sockaddr_storage addr;
+	struct sockaddr_storage addr = { };
 
 	/* user mode address pointers */
 	struct sockaddr __user *uaddr;
@@ -2721,7 +2786,7 @@ static int ethtool_ioctl(struct net *net, struct compat_ifreq __user *ifr32)
 	ifr = compat_alloc_user_space(buf_size);
 	rxnfc = (void __user *)ifr + ALIGN(sizeof(struct ifreq), 8);
 
-	if (copy_in_user(&ifr->ifr_name, &ifr32->ifr_name, IFNAMSIZ))
+	if (copy_in_user(ifr->ifr_name, ifr32->ifr_name, IFNAMSIZ))
 		return -EFAULT;
 
 	if (put_user(convert_in ? rxnfc : compat_ptr(data),
@@ -2832,7 +2897,7 @@ static int bond_ioctl(struct net *net, unsigned int cmd,
 		old_fs = get_fs();
 		set_fs(KERNEL_DS);
 		err = dev_ioctl(net, cmd,
-				(struct ifreq __user __force *) &kifr);
+				(struct ifreq __force_user *) &kifr);
 		set_fs(old_fs);
 
 		return err;
@@ -2925,7 +2990,7 @@ static int compat_sioc_ifmap(struct net *net, unsigned int cmd,
 
 	old_fs = get_fs();
 	set_fs(KERNEL_DS);
-	err = dev_ioctl(net, cmd, (void  __user __force *)&ifr);
+	err = dev_ioctl(net, cmd, (void  __force_user *)&ifr);
 	set_fs(old_fs);
 
 	if (cmd == SIOCGIFMAP && !err) {
@@ -3009,7 +3074,7 @@ static int routing_ioctl(struct net *net, struct socket *sock,
 		ret |= get_user(rtdev, &(ur4->rt_dev));
 		if (rtdev) {
 			ret |= copy_from_user(devname, compat_ptr(rtdev), 15);
-			r4.rt_dev = (char __user __force *)devname;
+			r4.rt_dev = (char __force_user *)devname;
 			devname[15] = 0;
 		} else
 			r4.rt_dev = NULL;
@@ -3236,8 +3301,8 @@ int kernel_getsockopt(struct socket *sock, int level, int optname,
 	int __user *uoptlen;
 	int err;
 
-	uoptval = (char __user __force *) optval;
-	uoptlen = (int __user __force *) optlen;
+	uoptval = (char __force_user *) optval;
+	uoptlen = (int __force_user *) optlen;
 
 	set_fs(KERNEL_DS);
 	if (level == SOL_SOCKET)
@@ -3257,7 +3322,7 @@ int kernel_setsockopt(struct socket *sock, int level, int optname,
 	char __user *uoptval;
 	int err;
 
-	uoptval = (char __user __force *) optval;
+	uoptval = (char __force_user *) optval;
 
 	set_fs(KERNEL_DS);
 	if (level == SOL_SOCKET)
diff --git a/net/sunrpc/Kconfig b/net/sunrpc/Kconfig
index 04ce2c0b6..b1dd1bdfa 100644
--- a/net/sunrpc/Kconfig
+++ b/net/sunrpc/Kconfig
@@ -38,6 +38,7 @@ config SUNRPC_DEBUG
 	bool "RPC: Enable dprintk debugging"
 	depends on SUNRPC && SYSCTL
 	select DEBUG_FS
+	depends on !GRKERNSEC_KMEM
 	help
 	  This option enables a sysctl-based debugging interface
 	  that is be used by the 'rpcdebug' utility to turn on or off
diff --git a/net/sunrpc/auth_gss/gss_rpc_upcall.c b/net/sunrpc/auth_gss/gss_rpc_upcall.c
index f0c6a8c78..3acb45935 100644
--- a/net/sunrpc/auth_gss/gss_rpc_upcall.c
+++ b/net/sunrpc/auth_gss/gss_rpc_upcall.c
@@ -55,8 +55,8 @@ enum {
 #define PROC(proc, name)				\
 [GSSX_##proc] = {					\
 	.p_proc   = GSSX_##proc,			\
-	.p_encode = (kxdreproc_t)gssx_enc_##name,	\
-	.p_decode = (kxdrdproc_t)gssx_dec_##name,	\
+	.p_encode = gssx_enc_##name,			\
+	.p_decode = gssx_dec_##name,			\
 	.p_arglen = GSSX_ARG_##name##_sz,		\
 	.p_replen = GSSX_RES_##name##_sz, 		\
 	.p_statidx = GSSX_##proc,			\
diff --git a/net/sunrpc/auth_gss/gss_rpc_xdr.c b/net/sunrpc/auth_gss/gss_rpc_xdr.c
index eeeba5ade..c0d96a1e1 100644
--- a/net/sunrpc/auth_gss/gss_rpc_xdr.c
+++ b/net/sunrpc/auth_gss/gss_rpc_xdr.c
@@ -731,10 +731,12 @@ static int gssx_enc_cb(struct xdr_stream *xdr, struct gssx_cb *cb)
 	return err;
 }
 
-void gssx_enc_accept_sec_context(struct rpc_rqst *req,
+void gssx_enc_accept_sec_context(void *_req,
 				 struct xdr_stream *xdr,
-				 struct gssx_arg_accept_sec_context *arg)
+				 void *_arg)
 {
+	struct rpc_rqst *req = _req;
+	struct gssx_arg_accept_sec_context *arg = _arg;
 	int err;
 
 	err = gssx_enc_call_ctx(xdr, &arg->call_ctx);
@@ -787,10 +789,11 @@ done:
 		dprintk("RPC:       gssx_enc_accept_sec_context: %d\n", err);
 }
 
-int gssx_dec_accept_sec_context(struct rpc_rqst *rqstp,
+int gssx_dec_accept_sec_context(void *rqstp,
 				struct xdr_stream *xdr,
-				struct gssx_res_accept_sec_context *res)
+				void *_res)
 {
+	struct gssx_res_accept_sec_context *res = _res;
 	u32 value_follows;
 	int err;
 	struct page *scratch;
diff --git a/net/sunrpc/auth_gss/gss_rpc_xdr.h b/net/sunrpc/auth_gss/gss_rpc_xdr.h
index 9d88c6239..53396b60f 100644
--- a/net/sunrpc/auth_gss/gss_rpc_xdr.h
+++ b/net/sunrpc/auth_gss/gss_rpc_xdr.h
@@ -177,12 +177,12 @@ struct gssx_res_accept_sec_context {
 #define gssx_dec_store_cred NULL
 #define gssx_enc_init_sec_context NULL
 #define gssx_dec_init_sec_context NULL
-void gssx_enc_accept_sec_context(struct rpc_rqst *req,
+void gssx_enc_accept_sec_context(void *req,
 				 struct xdr_stream *xdr,
-				 struct gssx_arg_accept_sec_context *args);
-int gssx_dec_accept_sec_context(struct rpc_rqst *rqstp,
+				 void *args);
+int gssx_dec_accept_sec_context(void *rqstp,
 				struct xdr_stream *xdr,
-				struct gssx_res_accept_sec_context *res);
+				void *res);
 #define gssx_enc_release_handle NULL
 #define gssx_dec_release_handle NULL
 #define gssx_enc_get_mic NULL
diff --git a/net/sunrpc/auth_gss/svcauth_gss.c b/net/sunrpc/auth_gss/svcauth_gss.c
index d8582028b..307157b57 100644
--- a/net/sunrpc/auth_gss/svcauth_gss.c
+++ b/net/sunrpc/auth_gss/svcauth_gss.c
@@ -1142,7 +1142,7 @@ static int gss_proxy_save_rsc(struct cache_detail *cd,
 				uint64_t *handle)
 {
 	struct rsc rsci, *rscp = NULL;
-	static atomic64_t ctxhctr;
+	static atomic64_unchecked_t ctxhctr = ATOMIC64_INIT(0);
 	long long ctxh;
 	struct gss_api_mech *gm = NULL;
 	time_t expiry;
@@ -1153,7 +1153,7 @@ static int gss_proxy_save_rsc(struct cache_detail *cd,
 	status = -ENOMEM;
 	/* the handle needs to be just a unique id,
 	 * use a static counter */
-	ctxh = atomic64_inc_return(&ctxhctr);
+	ctxh = atomic64_inc_return_unchecked(&ctxhctr);
 
 	/* make a copy for the caller */
 	*handle = ctxh;
diff --git a/net/sunrpc/cache.c b/net/sunrpc/cache.c
index 4d8e11f94..dcbf3500e 100644
--- a/net/sunrpc/cache.c
+++ b/net/sunrpc/cache.c
@@ -1623,7 +1623,7 @@ static int create_cache_proc_entries(struct cache_detail *cd, struct net *net)
 	struct sunrpc_net *sn;
 
 	sn = net_generic(net, sunrpc_net_id);
-	cd->u.procfs.proc_ent = proc_mkdir(cd->name, sn->proc_net_rpc);
+	cd->u.procfs.proc_ent = proc_mkdir_restrict(cd->name, sn->proc_net_rpc);
 	if (cd->u.procfs.proc_ent == NULL)
 		goto out_nomem;
 	cd->u.procfs.channel_ent = NULL;
diff --git a/net/sunrpc/clnt.c b/net/sunrpc/clnt.c
index 66f23b376..84d482125 100644
--- a/net/sunrpc/clnt.c
+++ b/net/sunrpc/clnt.c
@@ -1544,7 +1544,9 @@ call_start(struct rpc_task *task)
 			(RPC_IS_ASYNC(task) ? "async" : "sync"));
 
 	/* Increment call count */
-	task->tk_msg.rpc_proc->p_count++;
+	pax_open_kernel();
+	(*(unsigned int *)&task->tk_msg.rpc_proc->p_count)++;
+	pax_close_kernel();
 	clnt->cl_stats->rpccnt++;
 	task->tk_action = call_reserve;
 }
diff --git a/net/sunrpc/rpcb_clnt.c b/net/sunrpc/rpcb_clnt.c
index 5b3060359..d49e23a88 100644
--- a/net/sunrpc/rpcb_clnt.c
+++ b/net/sunrpc/rpcb_clnt.c
@@ -842,9 +842,11 @@ static void rpcb_getport_done(struct rpc_task *child, void *data)
  * XDR functions for rpcbind
  */
 
-static void rpcb_enc_mapping(struct rpc_rqst *req, struct xdr_stream *xdr,
-			     const struct rpcbind_args *rpcb)
+static void rpcb_enc_mapping(void *_req, struct xdr_stream *xdr,
+			     void *_rpcb)
 {
+	struct rpc_rqst *req = _req;
+	const struct rpcbind_args *rpcb = _rpcb;
 	__be32 *p;
 
 	dprintk("RPC: %5u encoding PMAP_%s call (%u, %u, %d, %u)\n",
@@ -859,9 +861,11 @@ static void rpcb_enc_mapping(struct rpc_rqst *req, struct xdr_stream *xdr,
 	*p   = cpu_to_be32(rpcb->r_port);
 }
 
-static int rpcb_dec_getport(struct rpc_rqst *req, struct xdr_stream *xdr,
-			    struct rpcbind_args *rpcb)
+static int rpcb_dec_getport(void *_req, struct xdr_stream *xdr,
+			    void *_rpcb)
 {
+	struct rpc_rqst *req = _req;
+	struct rpcbind_args *rpcb = _rpcb;
 	unsigned long port;
 	__be32 *p;
 
@@ -881,9 +885,11 @@ static int rpcb_dec_getport(struct rpc_rqst *req, struct xdr_stream *xdr,
 	return 0;
 }
 
-static int rpcb_dec_set(struct rpc_rqst *req, struct xdr_stream *xdr,
-			unsigned int *boolp)
+static int rpcb_dec_set(void *_req, struct xdr_stream *xdr,
+			void *_boolp)
 {
+	struct rpc_rqst *req = _req;
+	unsigned int *boolp = _boolp;
 	__be32 *p;
 
 	p = xdr_inline_decode(xdr, 4);
@@ -916,9 +922,11 @@ static void encode_rpcb_string(struct xdr_stream *xdr, const char *string,
 	xdr_encode_opaque(p, string, len);
 }
 
-static void rpcb_enc_getaddr(struct rpc_rqst *req, struct xdr_stream *xdr,
-			     const struct rpcbind_args *rpcb)
+static void rpcb_enc_getaddr(void *_req, struct xdr_stream *xdr,
+			     void *_rpcb)
 {
+	struct rpc_rqst *req = _req;
+	const struct rpcbind_args *rpcb = _rpcb;
 	__be32 *p;
 
 	dprintk("RPC: %5u encoding RPCB_%s call (%u, %u, '%s', '%s')\n",
@@ -936,9 +944,11 @@ static void rpcb_enc_getaddr(struct rpc_rqst *req, struct xdr_stream *xdr,
 	encode_rpcb_string(xdr, rpcb->r_owner, RPCB_MAXOWNERLEN);
 }
 
-static int rpcb_dec_getaddr(struct rpc_rqst *req, struct xdr_stream *xdr,
-			    struct rpcbind_args *rpcb)
+static int rpcb_dec_getaddr(void *_req, struct xdr_stream *xdr,
+			    void *_rpcb)
 {
+	struct rpc_rqst *req = _req;
+	struct rpcbind_args *rpcb = _rpcb;
 	struct sockaddr_storage address;
 	struct sockaddr *sap = (struct sockaddr *)&address;
 	__be32 *p;
@@ -992,8 +1002,8 @@ out_fail:
 static struct rpc_procinfo rpcb_procedures2[] = {
 	[RPCBPROC_SET] = {
 		.p_proc		= RPCBPROC_SET,
-		.p_encode	= (kxdreproc_t)rpcb_enc_mapping,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_set,
+		.p_encode	= rpcb_enc_mapping,
+		.p_decode	= rpcb_dec_set,
 		.p_arglen	= RPCB_mappingargs_sz,
 		.p_replen	= RPCB_setres_sz,
 		.p_statidx	= RPCBPROC_SET,
@@ -1002,8 +1012,8 @@ static struct rpc_procinfo rpcb_procedures2[] = {
 	},
 	[RPCBPROC_UNSET] = {
 		.p_proc		= RPCBPROC_UNSET,
-		.p_encode	= (kxdreproc_t)rpcb_enc_mapping,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_set,
+		.p_encode	= rpcb_enc_mapping,
+		.p_decode	= rpcb_dec_set,
 		.p_arglen	= RPCB_mappingargs_sz,
 		.p_replen	= RPCB_setres_sz,
 		.p_statidx	= RPCBPROC_UNSET,
@@ -1012,8 +1022,8 @@ static struct rpc_procinfo rpcb_procedures2[] = {
 	},
 	[RPCBPROC_GETPORT] = {
 		.p_proc		= RPCBPROC_GETPORT,
-		.p_encode	= (kxdreproc_t)rpcb_enc_mapping,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_getport,
+		.p_encode	= rpcb_enc_mapping,
+		.p_decode	= rpcb_dec_getport,
 		.p_arglen	= RPCB_mappingargs_sz,
 		.p_replen	= RPCB_getportres_sz,
 		.p_statidx	= RPCBPROC_GETPORT,
@@ -1025,8 +1035,8 @@ static struct rpc_procinfo rpcb_procedures2[] = {
 static struct rpc_procinfo rpcb_procedures3[] = {
 	[RPCBPROC_SET] = {
 		.p_proc		= RPCBPROC_SET,
-		.p_encode	= (kxdreproc_t)rpcb_enc_getaddr,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_set,
+		.p_encode	= rpcb_enc_getaddr,
+		.p_decode	= rpcb_dec_set,
 		.p_arglen	= RPCB_getaddrargs_sz,
 		.p_replen	= RPCB_setres_sz,
 		.p_statidx	= RPCBPROC_SET,
@@ -1035,8 +1045,8 @@ static struct rpc_procinfo rpcb_procedures3[] = {
 	},
 	[RPCBPROC_UNSET] = {
 		.p_proc		= RPCBPROC_UNSET,
-		.p_encode	= (kxdreproc_t)rpcb_enc_getaddr,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_set,
+		.p_encode	= rpcb_enc_getaddr,
+		.p_decode	= rpcb_dec_set,
 		.p_arglen	= RPCB_getaddrargs_sz,
 		.p_replen	= RPCB_setres_sz,
 		.p_statidx	= RPCBPROC_UNSET,
@@ -1045,8 +1055,8 @@ static struct rpc_procinfo rpcb_procedures3[] = {
 	},
 	[RPCBPROC_GETADDR] = {
 		.p_proc		= RPCBPROC_GETADDR,
-		.p_encode	= (kxdreproc_t)rpcb_enc_getaddr,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_getaddr,
+		.p_encode	= rpcb_enc_getaddr,
+		.p_decode	= rpcb_dec_getaddr,
 		.p_arglen	= RPCB_getaddrargs_sz,
 		.p_replen	= RPCB_getaddrres_sz,
 		.p_statidx	= RPCBPROC_GETADDR,
@@ -1058,8 +1068,8 @@ static struct rpc_procinfo rpcb_procedures3[] = {
 static struct rpc_procinfo rpcb_procedures4[] = {
 	[RPCBPROC_SET] = {
 		.p_proc		= RPCBPROC_SET,
-		.p_encode	= (kxdreproc_t)rpcb_enc_getaddr,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_set,
+		.p_encode	= rpcb_enc_getaddr,
+		.p_decode	= rpcb_dec_set,
 		.p_arglen	= RPCB_getaddrargs_sz,
 		.p_replen	= RPCB_setres_sz,
 		.p_statidx	= RPCBPROC_SET,
@@ -1068,8 +1078,8 @@ static struct rpc_procinfo rpcb_procedures4[] = {
 	},
 	[RPCBPROC_UNSET] = {
 		.p_proc		= RPCBPROC_UNSET,
-		.p_encode	= (kxdreproc_t)rpcb_enc_getaddr,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_set,
+		.p_encode	= rpcb_enc_getaddr,
+		.p_decode	= rpcb_dec_set,
 		.p_arglen	= RPCB_getaddrargs_sz,
 		.p_replen	= RPCB_setres_sz,
 		.p_statidx	= RPCBPROC_UNSET,
@@ -1078,8 +1088,8 @@ static struct rpc_procinfo rpcb_procedures4[] = {
 	},
 	[RPCBPROC_GETADDR] = {
 		.p_proc		= RPCBPROC_GETADDR,
-		.p_encode	= (kxdreproc_t)rpcb_enc_getaddr,
-		.p_decode	= (kxdrdproc_t)rpcb_dec_getaddr,
+		.p_encode	= rpcb_enc_getaddr,
+		.p_decode	= rpcb_dec_getaddr,
 		.p_arglen	= RPCB_getaddrargs_sz,
 		.p_replen	= RPCB_getaddrres_sz,
 		.p_statidx	= RPCBPROC_GETADDR,
diff --git a/net/sunrpc/sched.c b/net/sunrpc/sched.c
index 9ae588511..3aa6335a1 100644
--- a/net/sunrpc/sched.c
+++ b/net/sunrpc/sched.c
@@ -262,9 +262,9 @@ static int rpc_wait_bit_killable(struct wait_bit_key *key, int mode)
 #if IS_ENABLED(CONFIG_SUNRPC_DEBUG) || IS_ENABLED(CONFIG_TRACEPOINTS)
 static void rpc_task_set_debuginfo(struct rpc_task *task)
 {
-	static atomic_t rpc_pid;
+	static atomic_unchecked_t rpc_pid;
 
-	task->tk_pid = atomic_inc_return(&rpc_pid);
+	task->tk_pid = atomic_inc_return_unchecked(&rpc_pid);
 }
 #else
 static inline void rpc_task_set_debuginfo(struct rpc_task *task)
diff --git a/net/sunrpc/stats.c b/net/sunrpc/stats.c
index 2ecb99431..5afb49ff1 100644
--- a/net/sunrpc/stats.c
+++ b/net/sunrpc/stats.c
@@ -290,7 +290,7 @@ int rpc_proc_init(struct net *net)
 
 	dprintk("RPC:       registering /proc/net/rpc\n");
 	sn = net_generic(net, sunrpc_net_id);
-	sn->proc_net_rpc = proc_mkdir("rpc", net->proc_net);
+	sn->proc_net_rpc = proc_mkdir_restrict("rpc", net->proc_net);
 	if (sn->proc_net_rpc == NULL)
 		return -ENOMEM;
 
diff --git a/net/sunrpc/svc.c b/net/sunrpc/svc.c
index c5b0cb4f4..8ef3bff84 100644
--- a/net/sunrpc/svc.c
+++ b/net/sunrpc/svc.c
@@ -50,7 +50,7 @@ EXPORT_SYMBOL_GPL(svc_pool_map);
 static DEFINE_MUTEX(svc_pool_map_mutex);/* protects svc_pool_map.count only */
 
 static int
-param_set_pool_mode(const char *val, struct kernel_param *kp)
+param_set_pool_mode(const char *val, const struct kernel_param *kp)
 {
 	int *ip = (int *)kp->arg;
 	struct svc_pool_map *m = &svc_pool_map;
@@ -80,7 +80,7 @@ out:
 }
 
 static int
-param_get_pool_mode(char *buf, struct kernel_param *kp)
+param_get_pool_mode(char *buf, const struct kernel_param *kp)
 {
 	int *ip = (int *)kp->arg;
 
@@ -1166,7 +1166,9 @@ svc_process_common(struct svc_rqst *rqstp, struct kvec *argv, struct kvec *resv)
 	svc_putnl(resv, RPC_SUCCESS);
 
 	/* Bump per-procedure stats counter */
-	procp->pc_count++;
+	pax_open_kernel();
+	(*(unsigned int *)&procp->pc_count)++;
+	pax_close_kernel();
 
 	/* Initialize storage for argp and resp */
 	memset(rqstp->rq_argp, 0, procp->pc_argsize);
diff --git a/net/sunrpc/svcauth_unix.c b/net/sunrpc/svcauth_unix.c
index dfacdc95b..3cb08de74 100644
--- a/net/sunrpc/svcauth_unix.c
+++ b/net/sunrpc/svcauth_unix.c
@@ -470,7 +470,7 @@ static void unix_gid_request(struct cache_detail *cd,
 	(*bpp)[-1] = '\n';
 }
 
-static struct unix_gid *unix_gid_lookup(struct cache_detail *cd, kuid_t uid);
+static struct unix_gid * __intentional_overflow(-1) unix_gid_lookup(struct cache_detail *cd, kuid_t uid);
 
 static int unix_gid_parse(struct cache_detail *cd,
 			char *mesg, int mlen)
diff --git a/net/sunrpc/xprtrdma/svc_rdma.c b/net/sunrpc/xprtrdma/svc_rdma.c
index c846ca9f1..d5968b4e4 100644
--- a/net/sunrpc/xprtrdma/svc_rdma.c
+++ b/net/sunrpc/xprtrdma/svc_rdma.c
@@ -62,15 +62,15 @@ unsigned int svcrdma_max_req_size = RPCRDMA_MAX_REQ_SIZE;
 static unsigned int min_max_inline = 4096;
 static unsigned int max_max_inline = 65536;
 
-atomic_t rdma_stat_recv;
-atomic_t rdma_stat_read;
-atomic_t rdma_stat_write;
-atomic_t rdma_stat_sq_starve;
-atomic_t rdma_stat_rq_starve;
-atomic_t rdma_stat_rq_poll;
-atomic_t rdma_stat_rq_prod;
-atomic_t rdma_stat_sq_poll;
-atomic_t rdma_stat_sq_prod;
+atomic_unchecked_t rdma_stat_recv;
+atomic_unchecked_t rdma_stat_read;
+atomic_unchecked_t rdma_stat_write;
+atomic_unchecked_t rdma_stat_sq_starve;
+atomic_unchecked_t rdma_stat_rq_starve;
+atomic_unchecked_t rdma_stat_rq_poll;
+atomic_unchecked_t rdma_stat_rq_prod;
+atomic_unchecked_t rdma_stat_sq_poll;
+atomic_unchecked_t rdma_stat_sq_prod;
 
 struct workqueue_struct *svc_rdma_wq;
 
@@ -84,17 +84,17 @@ static int read_reset_stat(struct ctl_table *table, int write,
 			   void __user *buffer, size_t *lenp,
 			   loff_t *ppos)
 {
-	atomic_t *stat = (atomic_t *)table->data;
+	atomic_unchecked_t *stat = (atomic_unchecked_t *)table->data;
 
 	if (!stat)
 		return -EINVAL;
 
 	if (write)
-		atomic_set(stat, 0);
+		atomic_set_unchecked(stat, 0);
 	else {
 		char str_buf[32];
 		char *data;
-		int len = snprintf(str_buf, 32, "%d\n", atomic_read(stat));
+		int len = snprintf(str_buf, 32, "%d\n", atomic_read_unchecked(stat));
 		if (len >= 32)
 			return -EFAULT;
 		len = strlen(str_buf);
@@ -106,7 +106,7 @@ static int read_reset_stat(struct ctl_table *table, int write,
 		len -= *ppos;
 		if (len > *lenp)
 			len = *lenp;
-		if (len && copy_to_user(buffer, str_buf, len))
+		if (len > sizeof str_buf || (len && copy_to_user(buffer, str_buf, len)))
 			return -EFAULT;
 		*lenp = len;
 		*ppos += len;
@@ -147,63 +147,63 @@ static struct ctl_table svcrdma_parm_table[] = {
 	{
 		.procname	= "rdma_stat_read",
 		.data		= &rdma_stat_read,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_recv",
 		.data		= &rdma_stat_recv,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_write",
 		.data		= &rdma_stat_write,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_sq_starve",
 		.data		= &rdma_stat_sq_starve,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_rq_starve",
 		.data		= &rdma_stat_rq_starve,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_rq_poll",
 		.data		= &rdma_stat_rq_poll,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_rq_prod",
 		.data		= &rdma_stat_rq_prod,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_sq_poll",
 		.data		= &rdma_stat_sq_poll,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
 	{
 		.procname	= "rdma_stat_sq_prod",
 		.data		= &rdma_stat_sq_prod,
-		.maxlen		= sizeof(atomic_t),
+		.maxlen		= sizeof(atomic_unchecked_t),
 		.mode		= 0644,
 		.proc_handler	= read_reset_stat,
 	},
diff --git a/net/sunrpc/xprtrdma/svc_rdma_recvfrom.c b/net/sunrpc/xprtrdma/svc_rdma_recvfrom.c
index ad1df979b..83b90c755 100644
--- a/net/sunrpc/xprtrdma/svc_rdma_recvfrom.c
+++ b/net/sunrpc/xprtrdma/svc_rdma_recvfrom.c
@@ -200,7 +200,7 @@ int rdma_read_chunk_lcl(struct svcxprt_rdma *xprt,
 	*page_no = pg_no;
 	*page_offset = pg_off;
 	ret = read;
-	atomic_inc(&rdma_stat_read);
+	atomic_inc_unchecked(&rdma_stat_read);
 	return ret;
  err:
 	svc_rdma_unmap_dma(ctxt);
@@ -345,7 +345,7 @@ int rdma_read_chunk_frmr(struct svcxprt_rdma *xprt,
 	*page_no = pg_no;
 	*page_offset = pg_off;
 	ret = read;
-	atomic_inc(&rdma_stat_read);
+	atomic_inc_unchecked(&rdma_stat_read);
 	return ret;
  err:
 	ib_dma_unmap_sg(xprt->sc_cm_id->device,
@@ -612,7 +612,7 @@ int svc_rdma_recvfrom(struct svc_rqst *rqstp)
 				  dto_q);
 		list_del_init(&ctxt->dto_q);
 	} else {
-		atomic_inc(&rdma_stat_rq_starve);
+		atomic_inc_unchecked(&rdma_stat_rq_starve);
 		clear_bit(XPT_DATA, &xprt->xpt_flags);
 		ctxt = NULL;
 	}
@@ -629,7 +629,7 @@ int svc_rdma_recvfrom(struct svc_rqst *rqstp)
 	}
 	dprintk("svcrdma: processing ctxt=%p on xprt=%p, rqstp=%p, status=%d\n",
 		ctxt, rdma_xprt, rqstp, ctxt->wc_status);
-	atomic_inc(&rdma_stat_recv);
+	atomic_inc_unchecked(&rdma_stat_recv);
 
 	/* Build up the XDR from the receive buffers. */
 	rdma_build_arg_xdr(rqstp, ctxt, ctxt->byte_len);
diff --git a/net/sunrpc/xprtrdma/svc_rdma_sendto.c b/net/sunrpc/xprtrdma/svc_rdma_sendto.c
index 3b95b19fc..914e4827a 100644
--- a/net/sunrpc/xprtrdma/svc_rdma_sendto.c
+++ b/net/sunrpc/xprtrdma/svc_rdma_sendto.c
@@ -307,7 +307,7 @@ static int send_write(struct svcxprt_rdma *xprt, struct svc_rqst *rqstp,
 	write_wr.remote_addr = to;
 
 	/* Post It */
-	atomic_inc(&rdma_stat_write);
+	atomic_inc_unchecked(&rdma_stat_write);
 	if (svc_rdma_send(xprt, &write_wr.wr))
 		goto err;
 	return write_len - bc;
diff --git a/net/sunrpc/xprtrdma/svc_rdma_transport.c b/net/sunrpc/xprtrdma/svc_rdma_transport.c
index a55b8093a..c32fb3b8c 100644
--- a/net/sunrpc/xprtrdma/svc_rdma_transport.c
+++ b/net/sunrpc/xprtrdma/svc_rdma_transport.c
@@ -1310,7 +1310,7 @@ int svc_rdma_send(struct svcxprt_rdma *xprt, struct ib_send_wr *wr)
 		spin_lock_bh(&xprt->sc_lock);
 		if (xprt->sc_sq_depth < atomic_read(&xprt->sc_sq_count) + wr_count) {
 			spin_unlock_bh(&xprt->sc_lock);
-			atomic_inc(&rdma_stat_sq_starve);
+			atomic_inc_unchecked(&rdma_stat_sq_starve);
 
 			/* Wait until SQ WR available if SQ still full */
 			wait_event(xprt->sc_send_wait,
diff --git a/net/tipc/netlink_compat.c b/net/tipc/netlink_compat.c
index 1fd464764..ebf12ffc4 100644
--- a/net/tipc/netlink_compat.c
+++ b/net/tipc/netlink_compat.c
@@ -65,13 +65,13 @@ struct tipc_nl_compat_cmd_dump {
 	int (*header)(struct tipc_nl_compat_msg *);
 	int (*dumpit)(struct sk_buff *, struct netlink_callback *);
 	int (*format)(struct tipc_nl_compat_msg *msg, struct nlattr **attrs);
-};
+} __no_const;
 
 struct tipc_nl_compat_cmd_doit {
 	int (*doit)(struct sk_buff *skb, struct genl_info *info);
 	int (*transcode)(struct tipc_nl_compat_cmd_doit *cmd,
 			 struct sk_buff *skb, struct tipc_nl_compat_msg *msg);
-};
+} __no_const;
 
 static int tipc_skb_tailroom(struct sk_buff *skb)
 {
@@ -885,7 +885,10 @@ static int tipc_nl_compat_publ_dump(struct tipc_nl_compat_msg *msg, u32 sock)
 	void *hdr;
 	struct nlattr *nest;
 	struct sk_buff *args;
-	struct tipc_nl_compat_cmd_dump dump;
+	static struct tipc_nl_compat_cmd_dump dump = {
+		.dumpit = tipc_nl_publ_dump,
+		.format = __tipc_nl_compat_publ_dump,
+	};
 
 	args = nlmsg_new(NLMSG_GOODSIZE, GFP_KERNEL);
 	if (!args)
@@ -908,9 +911,6 @@ static int tipc_nl_compat_publ_dump(struct tipc_nl_compat_msg *msg, u32 sock)
 	nla_nest_end(args, nest);
 	genlmsg_end(args, hdr);
 
-	dump.dumpit = tipc_nl_publ_dump;
-	dump.format = __tipc_nl_compat_publ_dump;
-
 	err = __tipc_nl_compat_dumpit(&dump, msg, args);
 
 	kfree_skb(args);
diff --git a/net/tipc/subscr.c b/net/tipc/subscr.c
index 0dd02244e..36a22a061 100644
--- a/net/tipc/subscr.c
+++ b/net/tipc/subscr.c
@@ -75,7 +75,7 @@ static void tipc_subscrp_send_event(struct tipc_subscription *sub,
 	struct tipc_subscriber *subscriber = sub->subscriber;
 	struct kvec msg_sect;
 
-	msg_sect.iov_base = (void *)&sub->evt;
+	msg_sect.iov_base = &sub->evt;
 	msg_sect.iov_len = sizeof(struct tipc_event);
 	sub->evt.event = htohl(event, sub->swap);
 	sub->evt.found_lower = htohl(found_lower, sub->swap);
diff --git a/net/unix/af_unix.c b/net/unix/af_unix.c
index 568f307af..e5ca018de 100644
--- a/net/unix/af_unix.c
+++ b/net/unix/af_unix.c
@@ -921,6 +921,12 @@ static struct sock *unix_find_other(struct net *net,
 		err = -ECONNREFUSED;
 		if (!S_ISSOCK(inode->i_mode))
 			goto put_fail;
+
+		if (!gr_acl_handle_unix(path.dentry, path.mnt)) {
+			err = -EACCES;
+			goto put_fail;
+		}
+
 		u = unix_find_socket_byinode(inode);
 		if (!u)
 			goto put_fail;
@@ -941,6 +947,13 @@ static struct sock *unix_find_other(struct net *net,
 		if (u) {
 			struct dentry *dentry;
 			dentry = unix_sk(u)->path.dentry;
+
+			if (!gr_handle_chroot_unix(pid_vnr(u->sk_peer_pid))) {
+				err = -EPERM;
+				sock_put(u);
+				goto fail;
+			}
+
 			if (dentry)
 				touch_atime(&unix_sk(u)->path);
 		} else
@@ -974,12 +987,19 @@ static int unix_mknod(const char *sun_path, umode_t mode, struct path *res)
 	 */
 	err = security_path_mknod(&path, dentry, mode, 0);
 	if (!err) {
+		if (!gr_acl_handle_mknod(dentry, path.dentry, path.mnt, mode)) {
+			err = -EACCES;
+			goto out;
+		}
 		err = vfs_mknod(d_inode(path.dentry), dentry, mode, 0);
 		if (!err) {
 			res->mnt = mntget(path.mnt);
 			res->dentry = dget(dentry);
+			gr_handle_create(dentry, path.mnt);
 		}
 	}
+
+out:
 	done_path_create(&path, dentry);
 	return err;
 }
@@ -2804,9 +2824,13 @@ static int unix_seq_show(struct seq_file *seq, void *v)
 		seq_puts(seq, "Num       RefCount Protocol Flags    Type St "
 			 "Inode Path\n");
 	else {
-		struct sock *s = v;
+		struct sock *s = v, *peer;
 		struct unix_sock *u = unix_sk(s);
 		unix_state_lock(s);
+		peer = unix_peer(s);
+		unix_state_unlock(s);
+
+		unix_state_double_lock(s, peer);
 
 		seq_printf(seq, "%pK: %08X %08X %08X %04X %02X %5lu",
 			s,
@@ -2831,10 +2855,29 @@ static int unix_seq_show(struct seq_file *seq, void *v)
 				seq_putc(seq, '@');
 				i++;
 			}
-			for ( ; i < len; i++)
-				seq_putc(seq, u->addr->name->sun_path[i]);
-		}
-		unix_state_unlock(s);
+			for ( ; i < len; i++) {
+				char c = u->addr->name->sun_path[i];
+				switch (c) {
+				case '\n':
+					seq_putc(seq, '\\');
+					seq_putc(seq, 'n');
+					break;
+				case '\t':
+					seq_putc(seq, '\\');
+					seq_putc(seq, 't');
+					break;
+				case '\\':
+					seq_putc(seq, '\\');
+					seq_putc(seq, '\\');
+					break;
+				default:
+					seq_putc(seq, c);
+				}
+			}
+		} else if (peer)
+			seq_printf(seq, " P%lu", sock_i_ino(peer));
+
+		unix_state_double_unlock(s, peer);
 		seq_putc(seq, '\n');
 	}
 
diff --git a/net/unix/diag.c b/net/unix/diag.c
index 4d9679701..ab6a813a5 100644
--- a/net/unix/diag.c
+++ b/net/unix/diag.c
@@ -299,7 +299,7 @@ static int unix_diag_handler_dump(struct sk_buff *skb, struct nlmsghdr *h)
 		return -EINVAL;
 
 	if (h->nlmsg_flags & NLM_F_DUMP) {
-		struct netlink_dump_control c = {
+		static struct netlink_dump_control c = {
 			.dump = unix_diag_dump,
 		};
 		return netlink_dump_start(net->diag_nlsk, skb, h, &c);
diff --git a/net/unix/sysctl_net_unix.c b/net/unix/sysctl_net_unix.c
index b3d515021..ff3a8378b 100644
--- a/net/unix/sysctl_net_unix.c
+++ b/net/unix/sysctl_net_unix.c
@@ -28,7 +28,7 @@ static struct ctl_table unix_table[] = {
 
 int __net_init unix_sysctl_register(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	table = kmemdup(unix_table, sizeof(unix_table), GFP_KERNEL);
 	if (table == NULL)
diff --git a/net/vmw_vsock/vmci_transport_notify.c b/net/vmw_vsock/vmci_transport_notify.c
index fd8cf0214..1406db4d9 100644
--- a/net/vmw_vsock/vmci_transport_notify.c
+++ b/net/vmw_vsock/vmci_transport_notify.c
@@ -662,19 +662,19 @@ static void vmci_transport_notify_pkt_process_negotiate(struct sock *sk)
 
 /* Socket control packet based operations. */
 const struct vmci_transport_notify_ops vmci_transport_notify_pkt_ops = {
-	vmci_transport_notify_pkt_socket_init,
-	vmci_transport_notify_pkt_socket_destruct,
-	vmci_transport_notify_pkt_poll_in,
-	vmci_transport_notify_pkt_poll_out,
-	vmci_transport_notify_pkt_handle_pkt,
-	vmci_transport_notify_pkt_recv_init,
-	vmci_transport_notify_pkt_recv_pre_block,
-	vmci_transport_notify_pkt_recv_pre_dequeue,
-	vmci_transport_notify_pkt_recv_post_dequeue,
-	vmci_transport_notify_pkt_send_init,
-	vmci_transport_notify_pkt_send_pre_block,
-	vmci_transport_notify_pkt_send_pre_enqueue,
-	vmci_transport_notify_pkt_send_post_enqueue,
-	vmci_transport_notify_pkt_process_request,
-	vmci_transport_notify_pkt_process_negotiate,
+	.socket_init = vmci_transport_notify_pkt_socket_init,
+	.socket_destruct = vmci_transport_notify_pkt_socket_destruct,
+	.poll_in = vmci_transport_notify_pkt_poll_in,
+	.poll_out = vmci_transport_notify_pkt_poll_out,
+	.handle_notify_pkt = vmci_transport_notify_pkt_handle_pkt,
+	.recv_init = vmci_transport_notify_pkt_recv_init,
+	.recv_pre_block = vmci_transport_notify_pkt_recv_pre_block,
+	.recv_pre_dequeue = vmci_transport_notify_pkt_recv_pre_dequeue,
+	.recv_post_dequeue = vmci_transport_notify_pkt_recv_post_dequeue,
+	.send_init = vmci_transport_notify_pkt_send_init,
+	.send_pre_block = vmci_transport_notify_pkt_send_pre_block,
+	.send_pre_enqueue = vmci_transport_notify_pkt_send_pre_enqueue,
+	.send_post_enqueue = vmci_transport_notify_pkt_send_post_enqueue,
+	.process_request = vmci_transport_notify_pkt_process_request,
+	.process_negotiate = vmci_transport_notify_pkt_process_negotiate,
 };
diff --git a/net/vmw_vsock/vmci_transport_notify_qstate.c b/net/vmw_vsock/vmci_transport_notify_qstate.c
index 21e591daf..f3a0afc46 100644
--- a/net/vmw_vsock/vmci_transport_notify_qstate.c
+++ b/net/vmw_vsock/vmci_transport_notify_qstate.c
@@ -420,19 +420,19 @@ vmci_transport_notify_pkt_send_pre_enqueue(
 
 /* Socket always on control packet based operations. */
 const struct vmci_transport_notify_ops vmci_transport_notify_pkt_q_state_ops = {
-	vmci_transport_notify_pkt_socket_init,
-	vmci_transport_notify_pkt_socket_destruct,
-	vmci_transport_notify_pkt_poll_in,
-	vmci_transport_notify_pkt_poll_out,
-	vmci_transport_notify_pkt_handle_pkt,
-	vmci_transport_notify_pkt_recv_init,
-	vmci_transport_notify_pkt_recv_pre_block,
-	vmci_transport_notify_pkt_recv_pre_dequeue,
-	vmci_transport_notify_pkt_recv_post_dequeue,
-	vmci_transport_notify_pkt_send_init,
-	vmci_transport_notify_pkt_send_pre_block,
-	vmci_transport_notify_pkt_send_pre_enqueue,
-	vmci_transport_notify_pkt_send_post_enqueue,
-	vmci_transport_notify_pkt_process_request,
-	vmci_transport_notify_pkt_process_negotiate,
+	.socket_init = vmci_transport_notify_pkt_socket_init,
+	.socket_destruct = vmci_transport_notify_pkt_socket_destruct,
+	.poll_in = vmci_transport_notify_pkt_poll_in,
+	.poll_out = vmci_transport_notify_pkt_poll_out,
+	.handle_notify_pkt = vmci_transport_notify_pkt_handle_pkt,
+	.recv_init = vmci_transport_notify_pkt_recv_init,
+	.recv_pre_block = vmci_transport_notify_pkt_recv_pre_block,
+	.recv_pre_dequeue = vmci_transport_notify_pkt_recv_pre_dequeue,
+	.recv_post_dequeue = vmci_transport_notify_pkt_recv_post_dequeue,
+	.send_init = vmci_transport_notify_pkt_send_init,
+	.send_pre_block = vmci_transport_notify_pkt_send_pre_block,
+	.send_pre_enqueue = vmci_transport_notify_pkt_send_pre_enqueue,
+	.send_post_enqueue = vmci_transport_notify_pkt_send_post_enqueue,
+	.process_request = vmci_transport_notify_pkt_process_request,
+	.process_negotiate = vmci_transport_notify_pkt_process_negotiate,
 };
diff --git a/net/wireless/scan.c b/net/wireless/scan.c
index 438143a38..b88cdf67a 100644
--- a/net/wireless/scan.c
+++ b/net/wireless/scan.c
@@ -1732,8 +1732,9 @@ static int ieee80211_scan_results(struct cfg80211_registered_device *rdev,
 
 int cfg80211_wext_giwscan(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *data, char *extra)
+			  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct cfg80211_registered_device *rdev;
 	int res;
 
diff --git a/net/wireless/wext-compat.c b/net/wireless/wext-compat.c
index 9f27221c8..031b0c483 100644
--- a/net/wireless/wext-compat.c
+++ b/net/wireless/wext-compat.c
@@ -23,16 +23,19 @@
 
 int cfg80211_wext_giwname(struct net_device *dev,
 			  struct iw_request_info *info,
-			  char *name, char *extra)
+			  union iwreq_data *wrqu, char *extra)
 {
+	char *name = wrqu->name;
+
 	strcpy(name, "IEEE 802.11");
 	return 0;
 }
 EXPORT_WEXT_HANDLER(cfg80211_wext_giwname);
 
 int cfg80211_wext_siwmode(struct net_device *dev, struct iw_request_info *info,
-			  u32 *mode, char *extra)
+			  union iwreq_data *wrqu, char *extra)
 {
+	u32 *mode = &wrqu->mode;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev;
 	struct vif_params vifparams;
@@ -67,8 +70,9 @@ int cfg80211_wext_siwmode(struct net_device *dev, struct iw_request_info *info,
 EXPORT_WEXT_HANDLER(cfg80211_wext_siwmode);
 
 int cfg80211_wext_giwmode(struct net_device *dev, struct iw_request_info *info,
-			  u32 *mode, char *extra)
+			  union iwreq_data *wrqu, char *extra)
 {
+	u32 *mode = &wrqu->mode;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	if (!wdev)
@@ -104,8 +108,9 @@ EXPORT_WEXT_HANDLER(cfg80211_wext_giwmode);
 
 int cfg80211_wext_giwrange(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *data, char *extra)
+			   union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct iw_range *range = (struct iw_range *) extra;
 	enum nl80211_band band;
@@ -248,8 +253,9 @@ int cfg80211_wext_freq(struct iw_freq *freq)
 
 int cfg80211_wext_siwrts(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *rts, char *extra)
+			 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	u32 orts = wdev->wiphy->rts_threshold;
@@ -272,8 +278,9 @@ EXPORT_WEXT_HANDLER(cfg80211_wext_siwrts);
 
 int cfg80211_wext_giwrts(struct net_device *dev,
 			 struct iw_request_info *info,
-			 struct iw_param *rts, char *extra)
+			 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rts = &wrqu->rts;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	rts->value = wdev->wiphy->rts_threshold;
@@ -286,8 +293,9 @@ EXPORT_WEXT_HANDLER(cfg80211_wext_giwrts);
 
 int cfg80211_wext_siwfrag(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *frag, char *extra)
+			  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *frag = &wrqu->frag;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	u32 ofrag = wdev->wiphy->frag_threshold;
@@ -312,8 +320,9 @@ EXPORT_WEXT_HANDLER(cfg80211_wext_siwfrag);
 
 int cfg80211_wext_giwfrag(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_param *frag, char *extra)
+			  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *frag = &wrqu->frag;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	frag->value = wdev->wiphy->frag_threshold;
@@ -326,8 +335,9 @@ EXPORT_WEXT_HANDLER(cfg80211_wext_giwfrag);
 
 static int cfg80211_wext_siwretry(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_param *retry, char *extra)
+				  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *retry = &wrqu->retry;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	u32 changed = 0;
@@ -366,8 +376,9 @@ static int cfg80211_wext_siwretry(struct net_device *dev,
 
 int cfg80211_wext_giwretry(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_param *retry, char *extra)
+			   union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *retry = &wrqu->retry;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	retry->disabled = 0;
@@ -551,8 +562,9 @@ static int cfg80211_set_encryption(struct cfg80211_registered_device *rdev,
 
 static int cfg80211_wext_siwencode(struct net_device *dev,
 				   struct iw_request_info *info,
-				   struct iw_point *erq, char *keybuf)
+				   union iwreq_data *wrqu, char *keybuf)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	int idx, err;
@@ -611,8 +623,9 @@ static int cfg80211_wext_siwencode(struct net_device *dev,
 
 static int cfg80211_wext_siwencodeext(struct net_device *dev,
 				      struct iw_request_info *info,
-				      struct iw_point *erq, char *extra)
+				      union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	struct iw_encode_ext *ext = (struct iw_encode_ext *) extra;
@@ -702,8 +715,9 @@ static int cfg80211_wext_siwencodeext(struct net_device *dev,
 
 static int cfg80211_wext_giwencode(struct net_device *dev,
 				   struct iw_request_info *info,
-				   struct iw_point *erq, char *keybuf)
+				   union iwreq_data *wrqu, char *keybuf)
 {
+	struct iw_point *erq = &wrqu->encoding;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	int idx;
 
@@ -739,8 +753,9 @@ static int cfg80211_wext_giwencode(struct net_device *dev,
 
 static int cfg80211_wext_siwfreq(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_freq *wextfreq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *wextfreq = &wrqu->freq;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	struct cfg80211_chan_def chandef = {
@@ -782,8 +797,9 @@ static int cfg80211_wext_siwfreq(struct net_device *dev,
 
 static int cfg80211_wext_giwfreq(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_freq *freq, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_freq *freq = &wrqu->freq;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	struct cfg80211_chan_def chandef;
@@ -1041,8 +1057,9 @@ static int cfg80211_set_key_mgt(struct wireless_dev *wdev, u32 key_mgt)
 
 static int cfg80211_wext_siwauth(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *data, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *data = &wrqu->param;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	if (wdev->iftype != NL80211_IFTYPE_STATION)
@@ -1074,7 +1091,7 @@ static int cfg80211_wext_siwauth(struct net_device *dev,
 
 static int cfg80211_wext_giwauth(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *data, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
 	/* XXX: what do we need? */
 
@@ -1083,8 +1100,9 @@ static int cfg80211_wext_giwauth(struct net_device *dev,
 
 static int cfg80211_wext_siwpower(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_param *wrq, char *extra)
+				  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *wrq = &wrqu->power;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	bool ps = wdev->ps;
@@ -1130,8 +1148,9 @@ static int cfg80211_wext_siwpower(struct net_device *dev,
 
 static int cfg80211_wext_giwpower(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_param *wrq, char *extra)
+				  union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *wrq = &wrqu->power;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	wrq->disabled = !wdev->ps;
@@ -1185,8 +1204,9 @@ static int cfg80211_wds_wext_giwap(struct net_device *dev,
 
 static int cfg80211_wext_siwrate(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rate, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rate = &wrqu->bitrate;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	struct cfg80211_bitrate_mask mask;
@@ -1236,8 +1256,9 @@ static int cfg80211_wext_siwrate(struct net_device *dev,
 
 static int cfg80211_wext_giwrate(struct net_device *dev,
 				 struct iw_request_info *info,
-				 struct iw_param *rate, char *extra)
+				 union iwreq_data *wrqu, char *extra)
 {
+	struct iw_param *rate = &wrqu->bitrate;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	/* we are under RTNL - globally locked - so can use a static struct */
@@ -1344,8 +1365,9 @@ static struct iw_statistics *cfg80211_wireless_stats(struct net_device *dev)
 
 static int cfg80211_wext_siwap(struct net_device *dev,
 			       struct iw_request_info *info,
-			       struct sockaddr *ap_addr, char *extra)
+			       union iwreq_data *wrqu, char *extra)
 {
+	struct sockaddr *ap_addr = &wrqu->ap_addr;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	switch (wdev->iftype) {
@@ -1362,8 +1384,9 @@ static int cfg80211_wext_siwap(struct net_device *dev,
 
 static int cfg80211_wext_giwap(struct net_device *dev,
 			       struct iw_request_info *info,
-			       struct sockaddr *ap_addr, char *extra)
+			       union iwreq_data *wrqu, char *extra)
 {
+	struct sockaddr *ap_addr = &wrqu->ap_addr;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	switch (wdev->iftype) {
@@ -1380,8 +1403,9 @@ static int cfg80211_wext_giwap(struct net_device *dev,
 
 static int cfg80211_wext_siwessid(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *data, char *ssid)
+				  union iwreq_data *wrqu, char *ssid)
 {
+	struct iw_point *data = &wrqu->data;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	switch (wdev->iftype) {
@@ -1396,8 +1420,9 @@ static int cfg80211_wext_siwessid(struct net_device *dev,
 
 static int cfg80211_wext_giwessid(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *data, char *ssid)
+				  union iwreq_data *wrqu, char *ssid)
 {
+	struct iw_point *data = &wrqu->data;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 
 	data->flags = 0;
@@ -1415,7 +1440,7 @@ static int cfg80211_wext_giwessid(struct net_device *dev,
 
 static int cfg80211_wext_siwpmksa(struct net_device *dev,
 				  struct iw_request_info *info,
-				  struct iw_point *data, char *extra)
+				  union iwreq_data *wrqu, char *extra)
 {
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
@@ -1455,38 +1480,38 @@ static int cfg80211_wext_siwpmksa(struct net_device *dev,
 }
 
 static const iw_handler cfg80211_handlers[] = {
-	[IW_IOCTL_IDX(SIOCGIWNAME)]	= (iw_handler) cfg80211_wext_giwname,
-	[IW_IOCTL_IDX(SIOCSIWFREQ)]	= (iw_handler) cfg80211_wext_siwfreq,
-	[IW_IOCTL_IDX(SIOCGIWFREQ)]	= (iw_handler) cfg80211_wext_giwfreq,
-	[IW_IOCTL_IDX(SIOCSIWMODE)]	= (iw_handler) cfg80211_wext_siwmode,
-	[IW_IOCTL_IDX(SIOCGIWMODE)]	= (iw_handler) cfg80211_wext_giwmode,
-	[IW_IOCTL_IDX(SIOCGIWRANGE)]	= (iw_handler) cfg80211_wext_giwrange,
-	[IW_IOCTL_IDX(SIOCSIWAP)]	= (iw_handler) cfg80211_wext_siwap,
-	[IW_IOCTL_IDX(SIOCGIWAP)]	= (iw_handler) cfg80211_wext_giwap,
-	[IW_IOCTL_IDX(SIOCSIWMLME)]	= (iw_handler) cfg80211_wext_siwmlme,
-	[IW_IOCTL_IDX(SIOCSIWSCAN)]	= (iw_handler) cfg80211_wext_siwscan,
-	[IW_IOCTL_IDX(SIOCGIWSCAN)]	= (iw_handler) cfg80211_wext_giwscan,
-	[IW_IOCTL_IDX(SIOCSIWESSID)]	= (iw_handler) cfg80211_wext_siwessid,
-	[IW_IOCTL_IDX(SIOCGIWESSID)]	= (iw_handler) cfg80211_wext_giwessid,
-	[IW_IOCTL_IDX(SIOCSIWRATE)]	= (iw_handler) cfg80211_wext_siwrate,
-	[IW_IOCTL_IDX(SIOCGIWRATE)]	= (iw_handler) cfg80211_wext_giwrate,
-	[IW_IOCTL_IDX(SIOCSIWRTS)]	= (iw_handler) cfg80211_wext_siwrts,
-	[IW_IOCTL_IDX(SIOCGIWRTS)]	= (iw_handler) cfg80211_wext_giwrts,
-	[IW_IOCTL_IDX(SIOCSIWFRAG)]	= (iw_handler) cfg80211_wext_siwfrag,
-	[IW_IOCTL_IDX(SIOCGIWFRAG)]	= (iw_handler) cfg80211_wext_giwfrag,
-	[IW_IOCTL_IDX(SIOCSIWTXPOW)]	= (iw_handler) cfg80211_wext_siwtxpower,
-	[IW_IOCTL_IDX(SIOCGIWTXPOW)]	= (iw_handler) cfg80211_wext_giwtxpower,
-	[IW_IOCTL_IDX(SIOCSIWRETRY)]	= (iw_handler) cfg80211_wext_siwretry,
-	[IW_IOCTL_IDX(SIOCGIWRETRY)]	= (iw_handler) cfg80211_wext_giwretry,
-	[IW_IOCTL_IDX(SIOCSIWENCODE)]	= (iw_handler) cfg80211_wext_siwencode,
-	[IW_IOCTL_IDX(SIOCGIWENCODE)]	= (iw_handler) cfg80211_wext_giwencode,
-	[IW_IOCTL_IDX(SIOCSIWPOWER)]	= (iw_handler) cfg80211_wext_siwpower,
-	[IW_IOCTL_IDX(SIOCGIWPOWER)]	= (iw_handler) cfg80211_wext_giwpower,
-	[IW_IOCTL_IDX(SIOCSIWGENIE)]	= (iw_handler) cfg80211_wext_siwgenie,
-	[IW_IOCTL_IDX(SIOCSIWAUTH)]	= (iw_handler) cfg80211_wext_siwauth,
-	[IW_IOCTL_IDX(SIOCGIWAUTH)]	= (iw_handler) cfg80211_wext_giwauth,
-	[IW_IOCTL_IDX(SIOCSIWENCODEEXT)]= (iw_handler) cfg80211_wext_siwencodeext,
-	[IW_IOCTL_IDX(SIOCSIWPMKSA)]	= (iw_handler) cfg80211_wext_siwpmksa,
+	[IW_IOCTL_IDX(SIOCGIWNAME)]	= cfg80211_wext_giwname,
+	[IW_IOCTL_IDX(SIOCSIWFREQ)]	= cfg80211_wext_siwfreq,
+	[IW_IOCTL_IDX(SIOCGIWFREQ)]	= cfg80211_wext_giwfreq,
+	[IW_IOCTL_IDX(SIOCSIWMODE)]	= cfg80211_wext_siwmode,
+	[IW_IOCTL_IDX(SIOCGIWMODE)]	= cfg80211_wext_giwmode,
+	[IW_IOCTL_IDX(SIOCGIWRANGE)]	= cfg80211_wext_giwrange,
+	[IW_IOCTL_IDX(SIOCSIWAP)]	= cfg80211_wext_siwap,
+	[IW_IOCTL_IDX(SIOCGIWAP)]	= cfg80211_wext_giwap,
+	[IW_IOCTL_IDX(SIOCSIWMLME)]	= cfg80211_wext_siwmlme,
+	[IW_IOCTL_IDX(SIOCSIWSCAN)]	= cfg80211_wext_siwscan,
+	[IW_IOCTL_IDX(SIOCGIWSCAN)]	= cfg80211_wext_giwscan,
+	[IW_IOCTL_IDX(SIOCSIWESSID)]	= cfg80211_wext_siwessid,
+	[IW_IOCTL_IDX(SIOCGIWESSID)]	= cfg80211_wext_giwessid,
+	[IW_IOCTL_IDX(SIOCSIWRATE)]	= cfg80211_wext_siwrate,
+	[IW_IOCTL_IDX(SIOCGIWRATE)]	= cfg80211_wext_giwrate,
+	[IW_IOCTL_IDX(SIOCSIWRTS)]	= cfg80211_wext_siwrts,
+	[IW_IOCTL_IDX(SIOCGIWRTS)]	= cfg80211_wext_giwrts,
+	[IW_IOCTL_IDX(SIOCSIWFRAG)]	= cfg80211_wext_siwfrag,
+	[IW_IOCTL_IDX(SIOCGIWFRAG)]	= cfg80211_wext_giwfrag,
+	[IW_IOCTL_IDX(SIOCSIWTXPOW)]	= cfg80211_wext_siwtxpower,
+	[IW_IOCTL_IDX(SIOCGIWTXPOW)]	= cfg80211_wext_giwtxpower,
+	[IW_IOCTL_IDX(SIOCSIWRETRY)]	= cfg80211_wext_siwretry,
+	[IW_IOCTL_IDX(SIOCGIWRETRY)]	= cfg80211_wext_giwretry,
+	[IW_IOCTL_IDX(SIOCSIWENCODE)]	= cfg80211_wext_siwencode,
+	[IW_IOCTL_IDX(SIOCGIWENCODE)]	= cfg80211_wext_giwencode,
+	[IW_IOCTL_IDX(SIOCSIWPOWER)]	= cfg80211_wext_siwpower,
+	[IW_IOCTL_IDX(SIOCGIWPOWER)]	= cfg80211_wext_giwpower,
+	[IW_IOCTL_IDX(SIOCSIWGENIE)]	= cfg80211_wext_siwgenie,
+	[IW_IOCTL_IDX(SIOCSIWAUTH)]	= cfg80211_wext_siwauth,
+	[IW_IOCTL_IDX(SIOCGIWAUTH)]	= cfg80211_wext_giwauth,
+	[IW_IOCTL_IDX(SIOCSIWENCODEEXT)]= cfg80211_wext_siwencodeext,
+	[IW_IOCTL_IDX(SIOCSIWPMKSA)]	= cfg80211_wext_siwpmksa,
 };
 
 const struct iw_handler_def cfg80211_wext_handler = {
diff --git a/net/wireless/wext-compat.h b/net/wireless/wext-compat.h
index 94c7405a5..499cca48d 100644
--- a/net/wireless/wext-compat.h
+++ b/net/wireless/wext-compat.h
@@ -12,7 +12,7 @@
 
 int cfg80211_ibss_wext_siwfreq(struct net_device *dev,
 			       struct iw_request_info *info,
-			       struct iw_freq *freq, char *extra);
+			       struct iw_freq *wextfreq, char *extra);
 int cfg80211_ibss_wext_giwfreq(struct net_device *dev,
 			       struct iw_request_info *info,
 			       struct iw_freq *freq, char *extra);
@@ -31,7 +31,7 @@ int cfg80211_ibss_wext_giwessid(struct net_device *dev,
 
 int cfg80211_mgd_wext_siwfreq(struct net_device *dev,
 			      struct iw_request_info *info,
-			      struct iw_freq *freq, char *extra);
+			      struct iw_freq *wextfreq, char *extra);
 int cfg80211_mgd_wext_giwfreq(struct net_device *dev,
 			      struct iw_request_info *info,
 			      struct iw_freq *freq, char *extra);
@@ -50,10 +50,10 @@ int cfg80211_mgd_wext_giwessid(struct net_device *dev,
 
 int cfg80211_wext_siwmlme(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *data, char *extra);
+			  union iwreq_data *wrqu, char *extra);
 int cfg80211_wext_siwgenie(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *data, char *extra);
+			   union iwreq_data *wrqu, char *extra);
 
 
 int cfg80211_wext_freq(struct iw_freq *freq);
diff --git a/net/wireless/wext-core.c b/net/wireless/wext-core.c
index 6250b1cfc..91c4bc43a 100644
--- a/net/wireless/wext-core.c
+++ b/net/wireless/wext-core.c
@@ -781,8 +781,7 @@ static int ioctl_standard_iw_point(struct iw_point *iwp, unsigned int cmd,
 		 */
 
 		/* Support for very large requests */
-		if ((descr->flags & IW_DESCR_FLAG_NOMAX) &&
-		    (user_length > descr->max_tokens)) {
+		if (user_length > descr->max_tokens) {
 			/* Allow userspace to GET more than max so
 			 * we can support any size GET requests.
 			 * There is still a limit : -ENOMEM.
@@ -821,22 +820,6 @@ static int ioctl_standard_iw_point(struct iw_point *iwp, unsigned int cmd,
 		}
 	}
 
-	if (IW_IS_GET(cmd) && !(descr->flags & IW_DESCR_FLAG_NOMAX)) {
-		/*
-		 * If this is a GET, but not NOMAX, it means that the extra
-		 * data is not bounded by userspace, but by max_tokens. Thus
-		 * set the length to max_tokens. This matches the extra data
-		 * allocation.
-		 * The driver should fill it with the number of tokens it
-		 * provided, and it may check iwp->length rather than having
-		 * knowledge of max_tokens. If the driver doesn't change the
-		 * iwp->length, this ioctl just copies back max_token tokens
-		 * filled with zeroes. Hopefully the driver isn't claiming
-		 * them to be valid data.
-		 */
-		iwp->length = descr->max_tokens;
-	}
-
 	err = handler(dev, info, (union iwreq_data *) iwp, extra);
 
 	iwp->length += essid_compat;
diff --git a/net/wireless/wext-sme.c b/net/wireless/wext-sme.c
index a4e8af332..f8c0e7622 100644
--- a/net/wireless/wext-sme.c
+++ b/net/wireless/wext-sme.c
@@ -330,8 +330,9 @@ int cfg80211_mgd_wext_giwap(struct net_device *dev,
 
 int cfg80211_wext_siwgenie(struct net_device *dev,
 			   struct iw_request_info *info,
-			   struct iw_point *data, char *extra)
+			   union iwreq_data *wrqu, char *extra)
 {
+	struct iw_point *data = &wrqu->data;
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct cfg80211_registered_device *rdev = wiphy_to_rdev(wdev->wiphy);
 	u8 *ie = extra;
@@ -380,7 +381,7 @@ int cfg80211_wext_siwgenie(struct net_device *dev,
 
 int cfg80211_wext_siwmlme(struct net_device *dev,
 			  struct iw_request_info *info,
-			  struct iw_point *data, char *extra)
+			  union iwreq_data *wrqu, char *extra)
 {
 	struct wireless_dev *wdev = dev->ieee80211_ptr;
 	struct iw_mlme *mlme = (struct iw_mlme *)extra;
diff --git a/net/x25/sysctl_net_x25.c b/net/x25/sysctl_net_x25.c
index 43239527a..a06dfe143 100644
--- a/net/x25/sysctl_net_x25.c
+++ b/net/x25/sysctl_net_x25.c
@@ -70,7 +70,7 @@ static struct ctl_table x25_table[] = {
 		.mode = 	0644,
 		.proc_handler = proc_dointvec,
 	},
-	{ 0, },
+	{ },
 };
 
 void __init x25_register_sysctl(void)
diff --git a/net/x25/x25_proc.c b/net/x25/x25_proc.c
index 0917f047f..f4e3d8c79 100644
--- a/net/x25/x25_proc.c
+++ b/net/x25/x25_proc.c
@@ -209,7 +209,7 @@ static const struct file_operations x25_seq_forward_fops = {
 
 int __init x25_proc_init(void)
 {
-	if (!proc_mkdir("x25", init_net.proc_net))
+	if (!proc_mkdir_restrict("x25", init_net.proc_net))
 		return -ENOMEM;
 
 	if (!proc_create("x25/route", S_IRUGO, init_net.proc_net,
diff --git a/net/xfrm/xfrm_policy.c b/net/xfrm/xfrm_policy.c
index 45f9cf97e..73feea613 100644
--- a/net/xfrm/xfrm_policy.c
+++ b/net/xfrm/xfrm_policy.c
@@ -332,7 +332,7 @@ static void xfrm_policy_kill(struct xfrm_policy *policy)
 {
 	policy->walk.dead = 1;
 
-	atomic_inc(&policy->genid);
+	atomic_inc_unchecked(&policy->genid);
 
 	if (del_timer(&policy->polq.hold_timer))
 		xfrm_pol_put(policy);
@@ -786,7 +786,7 @@ int xfrm_policy_insert(int dir, struct xfrm_policy *policy, int excl)
 	else
 		hlist_add_head(&policy->bydst, chain);
 	__xfrm_policy_link(policy, dir);
-	atomic_inc(&net->xfrm.flow_cache_genid);
+	atomic_inc_unchecked(&net->xfrm.flow_cache_genid);
 
 	/* After previous checking, family can either be AF_INET or AF_INET6 */
 	if (policy->family == AF_INET)
@@ -1900,7 +1900,7 @@ xfrm_resolve_and_create_bundle(struct xfrm_policy **pols, int num_pols,
 
 	xdst->num_pols = num_pols;
 	memcpy(xdst->pols, pols, sizeof(struct xfrm_policy *) * num_pols);
-	xdst->policy_genid = atomic_read(&pols[0]->genid);
+	xdst->policy_genid = atomic_read_unchecked(&pols[0]->genid);
 
 	return xdst;
 }
@@ -2714,10 +2714,11 @@ void xfrm_garbage_collect(struct net *net)
 }
 EXPORT_SYMBOL(xfrm_garbage_collect);
 
-static void xfrm_garbage_collect_deferred(struct net *net)
+void xfrm_garbage_collect_deferred(struct net *net)
 {
 	flow_cache_flush_deferred(net);
 }
+EXPORT_SYMBOL(xfrm_garbage_collect_deferred);
 
 static void xfrm_init_pmtu(struct dst_entry *dst)
 {
@@ -2767,7 +2768,7 @@ static int xfrm_bundle_ok(struct xfrm_dst *first)
 		if (xdst->xfrm_genid != dst->xfrm->genid)
 			return 0;
 		if (xdst->num_pols > 0 &&
-		    xdst->policy_genid != atomic_read(&xdst->pols[0]->genid))
+		    xdst->policy_genid != atomic_read_unchecked(&xdst->pols[0]->genid))
 			return 0;
 
 		mtu = dst_mtu(dst->child);
@@ -2854,8 +2855,6 @@ int xfrm_policy_register_afinfo(struct xfrm_policy_afinfo *afinfo)
 			dst_ops->link_failure = xfrm_link_failure;
 		if (likely(dst_ops->neigh_lookup == NULL))
 			dst_ops->neigh_lookup = xfrm_neigh_lookup;
-		if (likely(afinfo->garbage_collect == NULL))
-			afinfo->garbage_collect = xfrm_garbage_collect_deferred;
 		rcu_assign_pointer(xfrm_policy_afinfo[afinfo->family], afinfo);
 	}
 	spin_unlock(&xfrm_policy_afinfo_lock);
@@ -2889,7 +2888,6 @@ int xfrm_policy_unregister_afinfo(struct xfrm_policy_afinfo *afinfo)
 		dst_ops->check = NULL;
 		dst_ops->negative_advice = NULL;
 		dst_ops->link_failure = NULL;
-		afinfo->garbage_collect = NULL;
 	}
 	return err;
 }
@@ -3078,7 +3076,7 @@ static void __net_exit xfrm_net_exit(struct net *net)
 	xfrm_statistics_fini(net);
 }
 
-static struct pernet_operations __net_initdata xfrm_net_ops = {
+static struct pernet_operations __net_initconst xfrm_net_ops = {
 	.init = xfrm_net_init,
 	.exit = xfrm_net_exit,
 };
@@ -3270,7 +3268,7 @@ static int xfrm_policy_migrate(struct xfrm_policy *pol,
 			       sizeof(pol->xfrm_vec[i].saddr));
 			pol->xfrm_vec[i].encap_family = mp->new_family;
 			/* flush bundles */
-			atomic_inc(&pol->genid);
+			atomic_inc_unchecked(&pol->genid);
 		}
 	}
 
diff --git a/net/xfrm/xfrm_state.c b/net/xfrm/xfrm_state.c
index a30f898dc..393092939 100644
--- a/net/xfrm/xfrm_state.c
+++ b/net/xfrm/xfrm_state.c
@@ -166,12 +166,14 @@ int xfrm_register_type(const struct xfrm_type *type, unsigned short family)
 
 	if (unlikely(afinfo == NULL))
 		return -EAFNOSUPPORT;
-	typemap = afinfo->type_map;
+	typemap = (const struct xfrm_type **)afinfo->type_map;
 	spin_lock_bh(&xfrm_type_lock);
 
-	if (likely(typemap[type->proto] == NULL))
+	if (likely(typemap[type->proto] == NULL)) {
+		pax_open_kernel();
 		typemap[type->proto] = type;
-	else
+		pax_close_kernel();
+	} else
 		err = -EEXIST;
 	spin_unlock_bh(&xfrm_type_lock);
 	xfrm_state_put_afinfo(afinfo);
@@ -187,13 +189,16 @@ int xfrm_unregister_type(const struct xfrm_type *type, unsigned short family)
 
 	if (unlikely(afinfo == NULL))
 		return -EAFNOSUPPORT;
-	typemap = afinfo->type_map;
+	typemap = (const struct xfrm_type **)afinfo->type_map;
 	spin_lock_bh(&xfrm_type_lock);
 
 	if (unlikely(typemap[type->proto] != type))
 		err = -ENOENT;
-	else
+	else {
+		pax_open_kernel();
 		typemap[type->proto] = NULL;
+		pax_close_kernel();
+	}
 	spin_unlock_bh(&xfrm_type_lock);
 	xfrm_state_put_afinfo(afinfo);
 	return err;
@@ -203,7 +208,6 @@ EXPORT_SYMBOL(xfrm_unregister_type);
 static const struct xfrm_type *xfrm_get_type(u8 proto, unsigned short family)
 {
 	struct xfrm_state_afinfo *afinfo;
-	const struct xfrm_type **typemap;
 	const struct xfrm_type *type;
 	int modload_attempted = 0;
 
@@ -211,9 +215,8 @@ retry:
 	afinfo = xfrm_state_get_afinfo(family);
 	if (unlikely(afinfo == NULL))
 		return NULL;
-	typemap = afinfo->type_map;
 
-	type = typemap[proto];
+	type = afinfo->type_map[proto];
 	if (unlikely(type && !try_module_get(type->owner)))
 		type = NULL;
 	if (!type && !modload_attempted) {
@@ -247,7 +250,7 @@ int xfrm_register_mode(struct xfrm_mode *mode, int family)
 		return -EAFNOSUPPORT;
 
 	err = -EEXIST;
-	modemap = afinfo->mode_map;
+	modemap = (struct xfrm_mode **)afinfo->mode_map;
 	spin_lock_bh(&xfrm_mode_lock);
 	if (modemap[mode->encap])
 		goto out;
@@ -256,8 +259,10 @@ int xfrm_register_mode(struct xfrm_mode *mode, int family)
 	if (!try_module_get(afinfo->owner))
 		goto out;
 
-	mode->afinfo = afinfo;
+	pax_open_kernel();
+	const_cast(mode->afinfo) = afinfo;
 	modemap[mode->encap] = mode;
+	pax_close_kernel();
 	err = 0;
 
 out:
@@ -281,10 +286,12 @@ int xfrm_unregister_mode(struct xfrm_mode *mode, int family)
 		return -EAFNOSUPPORT;
 
 	err = -ENOENT;
-	modemap = afinfo->mode_map;
+	modemap = (struct xfrm_mode **)afinfo->mode_map;
 	spin_lock_bh(&xfrm_mode_lock);
 	if (likely(modemap[mode->encap] == mode)) {
+		pax_open_kernel();
 		modemap[mode->encap] = NULL;
+		pax_close_kernel();
 		module_put(mode->afinfo->owner);
 		err = 0;
 	}
@@ -1506,10 +1513,10 @@ EXPORT_SYMBOL(xfrm_find_acq_byseq);
 u32 xfrm_get_acqseq(void)
 {
 	u32 res;
-	static atomic_t acqseq;
+	static atomic_unchecked_t acqseq;
 
 	do {
-		res = atomic_inc_return(&acqseq);
+		res = atomic_inc_return_unchecked(&acqseq);
 	} while (!res);
 
 	return res;
@@ -1884,7 +1891,7 @@ static DEFINE_SPINLOCK(xfrm_km_lock);
 int xfrm_register_km(struct xfrm_mgr *km)
 {
 	spin_lock_bh(&xfrm_km_lock);
-	list_add_tail_rcu(&km->list, &xfrm_km_list);
+	pax_list_add_tail_rcu((struct list_head *)&km->list, &xfrm_km_list);
 	spin_unlock_bh(&xfrm_km_lock);
 	return 0;
 }
@@ -1893,7 +1900,7 @@ EXPORT_SYMBOL(xfrm_register_km);
 int xfrm_unregister_km(struct xfrm_mgr *km)
 {
 	spin_lock_bh(&xfrm_km_lock);
-	list_del_rcu(&km->list);
+	pax_list_del_rcu((struct list_head *)&km->list);
 	spin_unlock_bh(&xfrm_km_lock);
 	synchronize_rcu();
 	return 0;
diff --git a/net/xfrm/xfrm_sysctl.c b/net/xfrm/xfrm_sysctl.c
index 05a6e3d9c..6716ec93c 100644
--- a/net/xfrm/xfrm_sysctl.c
+++ b/net/xfrm/xfrm_sysctl.c
@@ -42,7 +42,7 @@ static struct ctl_table xfrm_table[] = {
 
 int __net_init xfrm_sysctl_init(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table;
 
 	__xfrm_sysctl_init(net);
 
diff --git a/net/xfrm/xfrm_user.c b/net/xfrm/xfrm_user.c
index 08892091c..2645a4908 100644
--- a/net/xfrm/xfrm_user.c
+++ b/net/xfrm/xfrm_user.c
@@ -2471,7 +2471,7 @@ static int xfrm_user_rcv_msg(struct sk_buff *skb, struct nlmsghdr *nlh)
 			return -EINVAL;
 
 		{
-			struct netlink_dump_control c = {
+			netlink_dump_control_no_const c = {
 				.dump = link->dump,
 				.done = link->done,
 			};
diff --git a/scripts/Kbuild.include b/scripts/Kbuild.include
index 179219845..2620ac6e0 100644
--- a/scripts/Kbuild.include
+++ b/scripts/Kbuild.include
@@ -151,7 +151,7 @@ cc-ifversion = $(shell [ $(cc-version) $(1) $(2) ] && echo $(3) || echo $(4))
 # cc-ldoption
 # Usage: ldflags += $(call cc-ldoption, -Wl$(comma)--hash-style=both)
 cc-ldoption = $(call try-run,\
-	$(CC) $(1) -nostdlib -x c /dev/null -o "$$TMP",$(1),$(2))
+	$(CC) $(1) -Wl,-r -nostdlib -x c /dev/null -o "$$TMP",$(1),$(2))
 
 # ld-option
 # Usage: LDFLAGS += $(call ld-option, -X)
diff --git a/scripts/Makefile.extrawarn b/scripts/Makefile.extrawarn
index 53449a6ff..c1fd18049 100644
--- a/scripts/Makefile.extrawarn
+++ b/scripts/Makefile.extrawarn
@@ -28,6 +28,10 @@ warning-1 += $(call cc-option, -Wunused-const-variable)
 warning-1 += $(call cc-disable-warning, missing-field-initializers)
 warning-1 += $(call cc-disable-warning, sign-compare)
 
+#warning-1 += $(call cc-option, -Wnull-dereference)
+warning-1 += $(call cc-option, -Wduplicated-cond)
+warning-1 += $(call cc-option, -Wlogical-op)
+
 warning-2 := -Waggregate-return
 warning-2 += -Wcast-align
 warning-2 += -Wdisabled-optimization
diff --git a/scripts/Makefile.gcc-plugins b/scripts/Makefile.gcc-plugins
index 61f0e6db9..5486c77ff 100644
--- a/scripts/Makefile.gcc-plugins
+++ b/scripts/Makefile.gcc-plugins
@@ -19,16 +19,84 @@ ifdef CONFIG_GCC_PLUGINS
     endif
   endif
 
-  GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
+  gcc-plugin-$(CONFIG_PAX_CONSTIFY_PLUGIN)		+= constify_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_CONSTIFY_PLUGIN)	+= -DCONSTIFY_PLUGIN
+
+  gcc-plugin-$(CONFIG_PAX_MEMORY_STACKLEAK)		+= stackleak_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_MEMORY_STACKLEAK)	+= -DSTACKLEAK_PLUGIN -fplugin-arg-stackleak_plugin-track-lowest-sp=100
+
+  gcc-plugin-$(CONFIG_KALLOCSTAT_PLUGIN)		+= kallocstat_plugin.so
+
+  gcc-plugin-$(CONFIG_PAX_KERNEXEC_PLUGIN)		+= kernexec_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_KERNEXEC_PLUGIN)	+= -DKERNEXEC_PLUGIN
+  gcc-plugin-cflags-$(CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_BTS)	+= -fplugin-arg-kernexec_plugin-method=bts
+  gcc-plugin-cflags-$(CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_OR)	+= -fplugin-arg-kernexec_plugin-method=or
+  gcc-plugin-aflags-$(CONFIG_PAX_KERNEXEC_PLUGIN)	+= -DKERNEXEC_PLUGIN
+
+  ifdef CONFIG_CHECKER_PLUGIN
+    ifeq ($(call cc-ifversion, -ge, 0406, y), y)
+      gcc-plugin-$(CONFIG_CHECKER_PLUGIN)		+= checker_plugin.so
+      gcc-plugin-cflags-$(CONFIG_CHECKER_PLUGIN)	+= -DCHECKER_PLUGIN
+      gcc-plugin-cflags-$(CONFIG_CHECKER_PLUGIN_USER)	+= -DCHECKER_PLUGIN_USER -fplugin-arg-checker_plugin-user
+      gcc-plugin-cflags-$(CONFIG_CHECKER_PLUGIN_CONTEXT)+= -DCHECKER_PLUGIN_CONTEXT -fplugin-arg-checker_plugin-context
+    endif
+  endif
+
+  gcc-plugin-y						+= colorize_plugin.so
+
+  gcc-plugin-subdir-$(CONFIG_PAX_SIZE_OVERFLOW)		+= size_overflow_plugin
+  gcc-plugin-$(CONFIG_PAX_SIZE_OVERFLOW)		+= size_overflow_plugin/size_overflow_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_SIZE_OVERFLOW)		+= -DSIZE_OVERFLOW_PLUGIN
+  gcc-plugin-cflags-$(CONFIG_PAX_SIZE_OVERFLOW)		+= -fplugin-arg-size_overflow_plugin-check-fns
+  gcc-plugin-cflags-$(CONFIG_PAX_SIZE_OVERFLOW_EXTRA)	+= -fplugin-arg-size_overflow_plugin-check-fields
+  gcc-plugin-cflags-$(CONFIG_PAX_SIZE_OVERFLOW_EXTRA)	+= -fplugin-arg-size_overflow_plugin-check-fptrs
+  gcc-plugin-cflags-$(CONFIG_PAX_SIZE_OVERFLOW_EXTRA)	+= -fplugin-arg-size_overflow_plugin-check-vars
+
+  gcc-plugin-$(CONFIG_GRKERNSEC_RANDSTRUCT)		+= randomize_layout_plugin.so
+  gcc-plugin-cflags-$(CONFIG_GRKERNSEC_RANDSTRUCT)	+= -DRANDSTRUCT_PLUGIN
+  gcc-plugin-cflags-$(CONFIG_GRKERNSEC_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
 
-  export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR SANCOV_PLUGIN
+
+  gcc-plugin-$(CONFIG_PAX_LATENT_ENTROPY)		+= latent_entropy_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_LATENT_ENTROPY)	+= -DLATENT_ENTROPY_PLUGIN
+  ifdef CONFIG_PAX_LATENT_ENTROPY
+    DISABLE_LATENT_ENTROPY_PLUGIN			+= -fplugin-arg-latent_entropy_plugin-disable
+  endif
+
+  gcc-plugin-$(CONFIG_PAX_MEMORY_STRUCTLEAK)		+= structleak_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_MEMORY_STRUCTLEAK)	+= -DSTRUCTLEAK_PLUGIN
 
   ifneq ($(PLUGINCC),)
     # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
     GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
   endif
 
+  gcc-plugin-$(CONFIG_PAX_INITIFY)			+= initify_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_INITIFY)		+= -DINITIFY_PLUGIN -fplugin-arg-initify_plugin-search_init_exit_functions
+  gcc-plugin-cflags-$(CONFIG_PAX_INITIFY_VERBOSE)	+= -fplugin-arg-initify_plugin-verbose -fplugin-arg-initify_plugin-print_missing_attr
+  gcc-plugin-cflags-$(CONFIG_PAX_INITIFY_INIT_EXIT)	+= -fplugin-arg-initify_plugin-enable_init_to_exit_moves
+  ifdef CONFIG_PAX_INITIFY
+    INITIFY_DISABLE_VERIFY_NOCAPTURE_FUNCTIONS		+= -fplugin-arg-initify_plugin-disable_verify_nocapture_functions
+  endif
+
+  gcc-plugin-subdir-$(CONFIG_PAX_RAP)			+= rap_plugin
+  gcc-plugin-$(CONFIG_PAX_RAP)				+= rap_plugin/rap_plugin.so
+  gcc-plugin-cflags-$(CONFIG_PAX_RAP)			+= -DRAP_PLUGIN -fplugin-arg-rap_plugin-check=call
+#  gcc-plugin-cflags-$(CONFIG_PAX_RAP)			+= -fplugin-arg-rap_plugin-report=func,fptr,abs
+  gcc-plugin-aflags-$(CONFIG_PAX_RAP)			+= -DRAP_PLUGIN
+  ifdef CONFIG_PAX_RAP
+    RAP_PLUGIN_ABS_CFLAGS				:= -fplugin-arg-rap_plugin-hash=abs-finish
+  endif
+  gcc-plugin-cflags-$(CONFIG_PAX_RAP)			+= $(RAP_PLUGIN_ABS_CFLAGS)
+
+  GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
+  GCC_PLUGINS_AFLAGS := $(gcc-plugin-aflags-y)
+
+  export PLUGINCC GCC_PLUGIN GCC_PLUGIN_SUBDIR GCC_PLUGINS_CFLAGS GCC_PLUGINS_AFLAGS SANCOV_PLUGIN
+  export DISABLE_LATENT_ENTROPY_PLUGIN RAP_PLUGIN_ABS_CFLAGS INITIFY_DISABLE_VERIFY_NOCAPTURE_FUNCTIONS
+
   KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
+  KBUILD_AFLAGS += $(GCC_PLUGINS_AFLAGS)
   GCC_PLUGIN := $(gcc-plugin-y)
   GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
 endif
@@ -41,11 +109,12 @@ ifdef CONFIG_GCC_PLUGINS
   ifeq ($(PLUGINCC),)
     ifneq ($(GCC_PLUGINS_CFLAGS),)
       ifeq ($(call cc-ifversion, -ge, 0405, y), y)
-	$(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
-	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
+	$(Q)$(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true)
+	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2
       else
-	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
+	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2
       endif
+	@echo "PAX_MEMORY_STACKLEAK and other features will be less secure" >&2 && exit 1
     endif
   endif
 endif
diff --git a/scripts/basic/fixdep.c b/scripts/basic/fixdep.c
index 746ec1ece..994846b88 100644
--- a/scripts/basic/fixdep.c
+++ b/scripts/basic/fixdep.c
@@ -197,7 +197,7 @@ static unsigned int strhash(const char *str, unsigned int sz)
 /*
  * Lookup a value in the configuration string.
  */
-static int is_defined_config(const char *name, int len, unsigned int hash)
+static int is_defined_config(const char *name, unsigned int len, unsigned int hash)
 {
 	struct item *aux;
 
@@ -230,7 +230,7 @@ static void define_config(const char *name, int len, unsigned int hash)
 /*
  * Record the use of a CONFIG_* word.
  */
-static void use_config(const char *m, int slen)
+static void use_config(const char *m, unsigned int slen)
 {
 	unsigned int hash = strhash(m, slen);
 
@@ -243,9 +243,9 @@ static void use_config(const char *m, int slen)
 
 static void parse_config_file(const char *map, size_t len)
 {
-	const int *end = (const int *) (map + len);
+	const unsigned int *end = (const unsigned int *) (map + len);
 	/* start at +1, so that p can never be < map */
-	const int *m   = (const int *) map + 1;
+	const unsigned int *m   = (const unsigned int *) map + 1;
 	const char *p, *q;
 
 	for (; m < end; m++) {
@@ -449,7 +449,7 @@ static void print_deps(void)
 static void traps(void)
 {
 	static char test[] __attribute__((aligned(sizeof(int)))) = "CONF";
-	int *p = (int *)test;
+	unsigned int *p = (unsigned int *)test;
 
 	if (*p != INT_CONF) {
 		fprintf(stderr, "fixdep: sizeof(int) != 4 or wrong endianness? %#x\n",
diff --git a/scripts/dtc/checks.c b/scripts/dtc/checks.c
index 386f95633..a3b336563 100644
--- a/scripts/dtc/checks.c
+++ b/scripts/dtc/checks.c
@@ -277,7 +277,7 @@ NODE_ERROR(duplicate_property_names, NULL);
 static void check_node_name_chars(struct check *c, struct node *dt,
 				  struct node *node)
 {
-	int n = strspn(node->name, c->data);
+	size_t n = strspn(node->name, c->data);
 
 	if (n < strlen(node->name))
 		FAIL(c, "Bad character '%c' in node %s",
@@ -321,7 +321,7 @@ NODE_WARNING(unit_address_vs_reg, NULL);
 static void check_property_name_chars(struct check *c, struct node *dt,
 				      struct node *node, struct property *prop)
 {
-	int n = strspn(prop->name, c->data);
+	size_t n = strspn(prop->name, c->data);
 
 	if (n < strlen(prop->name))
 		FAIL(c, "Bad character '%c' in property name \"%s\", node %s",
@@ -423,7 +423,7 @@ static void check_explicit_phandles(struct check *c, struct node *root,
 
 	phandle = propval_cell(prop);
 
-	if ((phandle == 0) || (phandle == -1)) {
+	if ((phandle == 0) || (phandle == ~0U)) {
 		FAIL(c, "%s has bad value (0x%x) in %s property",
 		     node->fullpath, phandle, prop->name);
 		return;
@@ -486,7 +486,7 @@ static void fixup_phandle_references(struct check *c, struct node *dt,
 	cell_t phandle;
 
 	for_each_marker_of_type(m, REF_PHANDLE) {
-		assert(m->offset + sizeof(cell_t) <= prop->val.len);
+		assert(m->offset + (int)sizeof(cell_t) <= prop->val.len);
 
 		refnode = get_node_by_ref(dt, m->ref);
 		if (! refnode) {
@@ -714,7 +714,7 @@ static void enable_warning_error(struct check *c, bool warn, bool error)
 
 static void disable_warning_error(struct check *c, bool warn, bool error)
 {
-	int i;
+	size_t i;
 
 	/* Lowering level, also lower it for things this is the prereq
 	 * for */
@@ -735,7 +735,7 @@ static void disable_warning_error(struct check *c, bool warn, bool error)
 
 void parse_checks_option(bool warn, bool error, const char *arg)
 {
-	int i;
+	size_t i;
 	const char *name = arg;
 	bool enable = true;
 
@@ -763,7 +763,7 @@ void parse_checks_option(bool warn, bool error, const char *arg)
 void process_checks(bool force, struct boot_info *bi)
 {
 	struct node *dt = bi->dt;
-	int i;
+	size_t i;
 	int error = 0;
 
 	for (i = 0; i < ARRAY_SIZE(check_table); i++) {
diff --git a/scripts/dtc/data.c b/scripts/dtc/data.c
index 8cae23746..dcdab6630 100644
--- a/scripts/dtc/data.c
+++ b/scripts/dtc/data.c
@@ -94,10 +94,10 @@ struct data data_copy_file(FILE *f, size_t maxlen)
 {
 	struct data d = empty_data;
 
-	while (!feof(f) && (d.len < maxlen)) {
+	while (!feof(f) && ((size_t)d.len < maxlen)) {
 		size_t chunksize, ret;
 
-		if (maxlen == -1)
+		if (maxlen == ~0UL)
 			chunksize = 4096;
 		else
 			chunksize = maxlen - d.len;
@@ -108,7 +108,7 @@ struct data data_copy_file(FILE *f, size_t maxlen)
 		if (ferror(f))
 			die("Error reading file into data: %s", strerror(errno));
 
-		if (d.len + ret < d.len)
+		if (d.len + ret < (size_t)d.len)
 			die("Overflow reading file into data\n");
 
 		d.len += ret;
diff --git a/scripts/dtc/flattree.c b/scripts/dtc/flattree.c
index ec14954f5..dff184d1f 100644
--- a/scripts/dtc/flattree.c
+++ b/scripts/dtc/flattree.c
@@ -178,7 +178,7 @@ static void asm_emit_data(void *e, struct data d)
 	for_each_marker_of_type(m, LABEL)
 		emit_offset_label(f, m->ref, m->offset);
 
-	while ((d.len - off) >= sizeof(uint32_t)) {
+	while ((d.len - off) >= (int)sizeof(uint32_t)) {
 		asm_emit_cell(e, fdt32_to_cpu(*((uint32_t *)(d.val+off))));
 		off += sizeof(uint32_t);
 	}
@@ -369,7 +369,7 @@ static void make_fdt_header(struct fdt_header *fdt,
 void dt_to_blob(FILE *f, struct boot_info *bi, int version)
 {
 	struct version_info *vi = NULL;
-	int i;
+	size_t i;
 	struct data blob       = empty_data;
 	struct data reservebuf = empty_data;
 	struct data dtbuf      = empty_data;
@@ -463,7 +463,7 @@ static void dump_stringtable_asm(FILE *f, struct data strbuf)
 void dt_to_asm(FILE *f, struct boot_info *bi, int version)
 {
 	struct version_info *vi = NULL;
-	int i;
+	size_t i;
 	struct data strbuf = empty_data;
 	struct reserve_info *re;
 	const char *symprefix = "dt";
@@ -543,7 +543,7 @@ void dt_to_asm(FILE *f, struct boot_info *bi, int version)
 		ASM_EMIT_BELONG(f, "0x%08x", (unsigned int)(re->re.size >> 32));
 		ASM_EMIT_BELONG(f, "0x%08x", (unsigned int)(re->re.size & 0xffffffff));
 	}
-	for (i = 0; i < reservenum; i++) {
+	for (i = 0; i < (size_t)reservenum; i++) {
 		fprintf(f, "\t.long\t0, 0\n\t.long\t0, 0\n");
 	}
 
diff --git a/scripts/dtc/livetree.c b/scripts/dtc/livetree.c
index e229b8443..7141e8e21 100644
--- a/scripts/dtc/livetree.c
+++ b/scripts/dtc/livetree.c
@@ -492,7 +492,7 @@ struct node *get_node_by_phandle(struct node *tree, cell_t phandle)
 {
 	struct node *child, *node;
 
-	assert((phandle != 0) && (phandle != -1));
+	assert((phandle != 0) && (phandle != ~0U));
 
 	if (tree->phandle == phandle) {
 		if (tree->deleted)
@@ -523,7 +523,7 @@ cell_t get_node_phandle(struct node *root, struct node *node)
 {
 	static cell_t phandle = 1; /* FIXME: ick, static local */
 
-	if ((node->phandle != 0) && (node->phandle != -1))
+	if ((node->phandle != 0) && (node->phandle != ~0U))
 		return node->phandle;
 
 	while (get_node_by_phandle(root, phandle))
diff --git b/scripts/gcc-plugins/.gitignore b/scripts/gcc-plugins/.gitignore
new file mode 100644
index 000000000..de92ed9e3
--- /dev/null
+++ b/scripts/gcc-plugins/.gitignore
@@ -0,0 +1 @@
+randomize_layout_seed.h
diff --git a/scripts/gcc-plugins/Makefile b/scripts/gcc-plugins/Makefile
index 8b29dc17c..ec1516ef9 100644
--- a/scripts/gcc-plugins/Makefile
+++ b/scripts/gcc-plugins/Makefile
@@ -2,13 +2,17 @@ GCC_PLUGINS_DIR := $(shell $(CC) -print-file-name=plugin)
 
 ifeq ($(PLUGINCC),$(HOSTCC))
   HOSTLIBS := hostlibs
-  HOST_EXTRACFLAGS += -I$(GCC_PLUGINS_DIR)/include -I$(src) -std=gnu99 -ggdb
+  HOST_EXTRACFLAGS += -I$(GCC_PLUGINS_DIR)/include -I$(src)
+  HOST_EXTRACFLAGS += -std=gnu99 -ggdb -fvisibility=hidden
+  HOST_EXTRACFLAGS += -Wall -W
   export HOST_EXTRACFLAGS
 else
   HOSTLIBS := hostcxxlibs
-  HOST_EXTRACXXFLAGS += -I$(GCC_PLUGINS_DIR)/include -I$(src) -std=gnu++98 -fno-rtti
-  HOST_EXTRACXXFLAGS += -fno-exceptions -fasynchronous-unwind-tables -ggdb
-  HOST_EXTRACXXFLAGS += -Wno-narrowing -Wno-unused-variable
+  HOST_EXTRACXXFLAGS += -I$(GCC_PLUGINS_DIR)/include -I$(src)
+  HOST_EXTRACXXFLAGS += -std=gnu++98 -ggdb -fvisibility=hidden
+  HOST_EXTRACXXFLAGS += -fno-rtti -fno-exceptions -fasynchronous-unwind-tables
+  HOST_EXTRACXXFLAGS += -Wall -W
+  HOST_EXTRACXXFLAGS += -Wno-unused-parameter -Wno-narrowing -Wno-unused-variable
   export HOST_EXTRACXXFLAGS
 endif
 
@@ -20,9 +24,18 @@ export HOSTLIBS
 
 $(HOSTLIBS)-y := $(foreach p,$(GCC_PLUGIN),$(if $(findstring /,$(p)),,$(p)))
 always := $($(HOSTLIBS)-y)
-
 $(foreach p,$($(HOSTLIBS)-y:%.so=%),$(eval $(p)-objs := $(p).o))
 
+$(obj)/randomize_layout_plugin.o: $(objtree)/$(obj)/randomize_layout_seed.h
+
+quiet_cmd_create_randomize_layout_seed = GENSEED  $@
+	cmd_create_randomize_layout_seed = \
+	$(CONFIG_SHELL) $(srctree)/$(src)/gen-random-seed.sh $@ $(objtree)/include/generated/randomize_layout_hash.h
+$(objtree)/$(obj)/randomize_layout_seed.h: FORCE
+	$(call if_changed,create_randomize_layout_seed)
+ 
+targets += randomize_layout_seed.h randomize_layout_hash.h
+
 subdir-y := $(GCC_PLUGIN_SUBDIR)
 subdir-  += $(GCC_PLUGIN_SUBDIR)
 
diff --git b/scripts/gcc-plugins/checker_plugin.c b/scripts/gcc-plugins/checker_plugin.c
new file mode 100644
index 000000000..27fed8d35
--- /dev/null
+++ b/scripts/gcc-plugins/checker_plugin.c
@@ -0,0 +1,491 @@
+/*
+ * Copyright 2011-2017 by the PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * gcc plugin to implement various sparse (source code checker) features
+ *
+ * TODO:
+ * - define separate __iomem, __percpu and __rcu address spaces (lots of code to patch)
+ *
+ * BUGS:
+ * - none known
+ */
+
+#include "gcc-common.h"
+
+extern void c_register_addr_space (const char *str, addr_space_t as);
+extern enum machine_mode default_addr_space_pointer_mode (addr_space_t);
+extern enum machine_mode default_addr_space_address_mode (addr_space_t);
+extern bool default_addr_space_valid_pointer_mode(enum machine_mode mode, addr_space_t as);
+extern bool default_addr_space_legitimate_address_p(enum machine_mode mode, rtx mem, bool strict, addr_space_t as);
+extern rtx default_addr_space_legitimize_address(rtx x, rtx oldx, enum machine_mode mode, addr_space_t as);
+
+__visible int plugin_is_GPL_compatible;
+
+static struct plugin_info checker_plugin_info = {
+	.version	= "201602181345",
+	.help		= "user\tturn on user/kernel address space checking\n"
+			  "context\tturn on locking context checking\n"
+};
+
+#define ADDR_SPACE_KERNEL		0
+#define ADDR_SPACE_FORCE_KERNEL		1
+#define ADDR_SPACE_USER			2
+#define ADDR_SPACE_FORCE_USER		3
+#define ADDR_SPACE_IOMEM		0
+#define ADDR_SPACE_FORCE_IOMEM		0
+#define ADDR_SPACE_PERCPU		0
+#define ADDR_SPACE_FORCE_PERCPU		0
+#define ADDR_SPACE_RCU			0
+#define ADDR_SPACE_FORCE_RCU		0
+
+static enum machine_mode checker_addr_space_pointer_mode(addr_space_t addrspace)
+{
+	return default_addr_space_pointer_mode(ADDR_SPACE_GENERIC);
+}
+
+static enum machine_mode checker_addr_space_address_mode(addr_space_t addrspace)
+{
+	return default_addr_space_address_mode(ADDR_SPACE_GENERIC);
+}
+
+static bool checker_addr_space_valid_pointer_mode(enum machine_mode mode, addr_space_t as)
+{
+	return default_addr_space_valid_pointer_mode(mode, as);
+}
+
+static bool checker_addr_space_legitimate_address_p(enum machine_mode mode, rtx mem, bool strict, addr_space_t as)
+{
+	return default_addr_space_legitimate_address_p(mode, mem, strict, ADDR_SPACE_GENERIC);
+}
+
+static rtx checker_addr_space_legitimize_address(rtx x, rtx oldx, enum machine_mode mode, addr_space_t as)
+{
+	return default_addr_space_legitimize_address(x, oldx, mode, as);
+}
+
+static bool checker_addr_space_subset_p(addr_space_t subset, addr_space_t superset)
+{
+	if (subset == ADDR_SPACE_FORCE_KERNEL && superset == ADDR_SPACE_KERNEL)
+		return true;
+
+	if (subset == ADDR_SPACE_FORCE_USER && superset == ADDR_SPACE_USER)
+		return true;
+
+	if (subset == ADDR_SPACE_FORCE_IOMEM && superset == ADDR_SPACE_IOMEM)
+		return true;
+
+	if (subset == ADDR_SPACE_KERNEL && superset == ADDR_SPACE_FORCE_USER)
+		return true;
+
+	if (subset == ADDR_SPACE_KERNEL && superset == ADDR_SPACE_FORCE_IOMEM)
+		return true;
+
+	if (subset == ADDR_SPACE_USER && superset == ADDR_SPACE_FORCE_KERNEL)
+		return true;
+
+	if (subset == ADDR_SPACE_IOMEM && superset == ADDR_SPACE_FORCE_KERNEL)
+		return true;
+
+	return subset == superset;
+}
+
+static rtx checker_addr_space_convert(rtx op, tree from_type, tree to_type)
+{
+//	addr_space_t from_as = TYPE_ADDR_SPACE(TREE_TYPE(from_type));
+//	addr_space_t to_as = TYPE_ADDR_SPACE(TREE_TYPE(to_type));
+
+	return op;
+}
+
+static void register_checker_address_spaces(void *event_data, void *data)
+{
+	c_register_addr_space("__kernel", ADDR_SPACE_KERNEL);
+	c_register_addr_space("__force_kernel", ADDR_SPACE_FORCE_KERNEL);
+	c_register_addr_space("__user", ADDR_SPACE_USER);
+	c_register_addr_space("__force_user", ADDR_SPACE_FORCE_USER);
+//	c_register_addr_space("__iomem", ADDR_SPACE_IOMEM);
+//	c_register_addr_space("__force_iomem", ADDR_SPACE_FORCE_IOMEM);
+//	c_register_addr_space("__percpu", ADDR_SPACE_PERCPU);
+//	c_register_addr_space("__force_percpu", ADDR_SPACE_FORCE_PERCPU);
+//	c_register_addr_space("__rcu", ADDR_SPACE_RCU);
+//	c_register_addr_space("__force_rcu", ADDR_SPACE_FORCE_RCU);
+
+	targetm.addr_space.pointer_mode		= checker_addr_space_pointer_mode;
+	targetm.addr_space.address_mode		= checker_addr_space_address_mode;
+	targetm.addr_space.valid_pointer_mode	= checker_addr_space_valid_pointer_mode;
+	targetm.addr_space.legitimate_address_p	= checker_addr_space_legitimate_address_p;
+//	targetm.addr_space.legitimize_address	= checker_addr_space_legitimize_address;
+	targetm.addr_space.subset_p		= checker_addr_space_subset_p;
+	targetm.addr_space.convert		= checker_addr_space_convert;
+}
+
+static bool split_context_attribute(tree args, tree *lock, tree *in, tree *out)
+{
+	*in = TREE_VALUE(args);
+
+	if (TREE_CODE(*in) != INTEGER_CST) {
+		*lock = *in;
+		args = TREE_CHAIN(args);
+		*in = TREE_VALUE(args);
+	} else
+		*lock = NULL_TREE;
+
+	args = TREE_CHAIN(args);
+	if (*lock && !args)
+		return false;
+
+	*out = TREE_VALUE(args);
+	return true;
+}
+
+static tree handle_context_attribute(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
+{
+	*no_add_attrs = true;
+	tree lock, in, out;
+
+	if (TREE_CODE(*node) != FUNCTION_DECL) {
+		error("%qE attribute applies to functions only (%qD)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (!split_context_attribute(args, &lock, &in, &out)) {
+		error("%qE attribute needs two integers after the lock expression", name);
+		return NULL_TREE;
+	}
+
+	if (TREE_CODE(in) != INTEGER_CST) {
+		error("the 'in' argument of the %qE attribute must be an integer (%qE)", name, in);
+		return NULL_TREE;
+	}
+
+	if (TREE_CODE(out) != INTEGER_CST) {
+		error("the 'out' argument of the %qE attribute must be an integer (%qE)", name, out);
+		return NULL_TREE;
+	}
+
+	*no_add_attrs = false;
+	return NULL_TREE;
+}
+
+static struct attribute_spec context_attr = {
+	.name			= "context",
+	.min_length		= 2,
+	.max_length		= 3,
+	.decl_required		= true,
+	.type_required		= false,
+	.function_type_required	= false,
+	.handler		= handle_context_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity	= true
+#endif
+};
+
+static void register_attributes(void *event_data, void *data)
+{
+	register_attribute(&context_attr);
+}
+
+static const char context_function[] = "__context__";
+static GTY(()) tree context_function_decl;
+
+static const char context_error[] = "__context_error__";
+static GTY(()) tree context_error_decl;
+
+static void context_start_unit(void __unused *gcc_data, void __unused *user_data)
+{
+	tree fntype, attr;
+
+	// void __context__(void *, int);
+	fntype = build_function_type_list(void_type_node, ptr_type_node, integer_type_node, NULL_TREE);
+	context_function_decl = build_fn_decl(context_function, fntype);
+
+	TREE_PUBLIC(context_function_decl) = 1;
+	TREE_USED(context_function_decl) = 1;
+	DECL_EXTERNAL(context_function_decl) = 1;
+	DECL_ARTIFICIAL(context_function_decl) = 1;
+	DECL_PRESERVE_P(context_function_decl) = 1;
+//	TREE_NOTHROW(context_function_decl) = 1;
+//	DECL_UNINLINABLE(context_function_decl) = 1;
+	DECL_ASSEMBLER_NAME(context_function_decl); // for LTO
+	lang_hooks.decls.pushdecl(context_function_decl);
+
+	// void __context_error__(const void *, int) __attribute__((error("context error")));
+	fntype = build_function_type_list(void_type_node, const_ptr_type_node, integer_type_node, NULL_TREE);
+	context_error_decl = build_fn_decl(context_error, fntype);
+
+	TREE_PUBLIC(context_error_decl) = 1;
+	TREE_USED(context_error_decl) = 1;
+	DECL_EXTERNAL(context_error_decl) = 1;
+	DECL_ARTIFICIAL(context_error_decl) = 1;
+	DECL_PRESERVE_P(context_error_decl) = 1;
+//	TREE_NOTHROW(context_error_decl) = 1;
+//	DECL_UNINLINABLE(context_error_decl) = 1;
+	TREE_THIS_VOLATILE(context_error_decl) = 1;
+	DECL_ASSEMBLER_NAME(context_error_decl);
+
+	attr = tree_cons(NULL, build_const_char_string(14, "context error"), NULL);
+	attr = tree_cons(get_identifier("error"), attr, NULL);
+	decl_attributes(&context_error_decl, attr, 0);
+}
+
+static bool context_gate(void)
+{
+	tree context_attr;
+
+return true;
+
+	context_attr = lookup_attribute("context", DECL_ATTRIBUTES(current_function_decl));
+	return context_attr != NULL_TREE;
+}
+
+static basic_block verify_context_before(gimple_stmt_iterator *gsi, tree context, tree inout, tree error)
+{
+	gimple stmt;
+	basic_block cond_bb, join_bb, true_bb;
+	edge e;
+	location_t loc;
+	const char *file;
+	int line;
+	size_t len;
+	tree filename;
+
+	stmt = gsi_stmt(*gsi);
+	if (gimple_has_location(stmt)) {
+		loc = gimple_location(stmt);
+		file = gimple_filename(stmt);
+		line = gimple_lineno(stmt);
+	} else {
+		loc = DECL_SOURCE_LOCATION(current_function_decl);
+		file = DECL_SOURCE_FILE(current_function_decl);
+		line = DECL_SOURCE_LINE(current_function_decl);
+	}
+	gcc_assert(file);
+
+	// if (context != count) __context_error__(__FILE__, __LINE__);
+	stmt = gimple_build_cond(NE_EXPR, context, inout, NULL_TREE, NULL_TREE);
+	gimple_set_location(stmt, loc);
+	gsi_insert_before(gsi, stmt, GSI_NEW_STMT);
+
+	cond_bb = gsi_bb(*gsi);
+	gcc_assert(!gsi_end_p(*gsi));
+	gcc_assert(stmt == gsi_stmt(*gsi));
+
+	e = split_block(cond_bb, gsi_stmt(*gsi));
+	cond_bb = e->src;
+	join_bb = e->dest;
+	e->flags = EDGE_FALSE_VALUE;
+	e->probability = REG_BR_PROB_BASE;
+
+	true_bb = create_empty_bb(EXIT_BLOCK_PTR_FOR_FN(cfun)->prev_bb);
+	make_edge(cond_bb, true_bb, EDGE_TRUE_VALUE);
+	make_edge(true_bb, join_bb, EDGE_FALLTHRU);
+
+	set_immediate_dominator(CDI_DOMINATORS, true_bb, cond_bb);
+	set_immediate_dominator(CDI_DOMINATORS, join_bb, cond_bb);
+
+	gcc_assert(cond_bb->loop_father == join_bb->loop_father);
+	add_bb_to_loop(true_bb, cond_bb->loop_father);
+
+	// insert call to builtin_trap or __context_error__
+	*gsi = gsi_start_bb(true_bb);
+
+//	stmt = gimple_build_call(builtin_decl_implicit(BUILT_IN_TRAP), 0);
+	len = strlen(file) + 1;
+	filename = build_const_char_string(len, file);
+	filename = build1(ADDR_EXPR, const_ptr_type_node, filename);
+	stmt = gimple_build_call(error, 2, filename, build_int_cst(NULL_TREE, line));
+	gimple_set_location(stmt, loc);
+	gsi_insert_after(gsi, stmt, GSI_CONTINUE_LINKING);
+
+	*gsi = gsi_start_nondebug_bb(join_bb);
+	return join_bb;
+}
+
+static void update_context(gimple_stmt_iterator *gsi, tree context, int diff)
+{
+	gimple assign;
+	tree op;
+
+	op = fold_build2_loc(UNKNOWN_LOCATION, PLUS_EXPR, integer_type_node, context, build_int_cst(integer_type_node, diff));
+	assign = gimple_build_assign(context, op);
+	gsi_insert_after(gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+}
+
+static basic_block track_context(basic_block bb, tree context)
+{
+	gimple_stmt_iterator gsi;
+	gimple assign;
+
+	// adjust context according to the context information on any call stmt
+	for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+		gimple stmt = gsi_stmt(gsi);
+		tree fndecl, context_attr;
+		tree lock, in, out;
+		int incount, outcount;
+
+		if (!is_gimple_call(stmt))
+			continue;
+
+		fndecl = gimple_call_fndecl(stmt);
+		if (!fndecl)
+			continue;
+
+		if (fndecl == context_function_decl) {
+			unsigned int num_ops = gimple_num_ops(stmt);
+			int diff = tree_to_shwi(gimple_op(stmt, num_ops - 1));
+
+			gcc_assert(diff);
+			update_context(&gsi, context, diff);
+			continue;
+		}
+
+		context_attr = lookup_attribute("context", DECL_ATTRIBUTES(fndecl));
+		if (!context_attr)
+			continue;
+
+		gcc_assert(split_context_attribute(TREE_VALUE(context_attr), &lock, &in, &out));
+		incount = tree_to_shwi(in);
+		outcount = tree_to_shwi(out);
+		bb = verify_context_before(&gsi, context, in, context_error_decl);
+		update_context(&gsi, context, outcount - incount);
+	}
+
+	return bb;
+}
+
+static bool bb_any_loop(basic_block bb)
+{
+	return bb_loop_depth(bb) || (bb->flags & BB_IRREDUCIBLE_LOOP);
+}
+
+static unsigned int context_execute(void)
+{
+	basic_block bb;
+	gimple assign;
+	gimple_stmt_iterator gsi;
+	tree context_attr, context;
+	tree lock, in, out;
+
+	loop_optimizer_init(LOOPS_NORMAL | LOOPS_HAVE_RECORDED_EXITS);
+	gcc_assert(current_loops);
+
+	calculate_dominance_info(CDI_DOMINATORS);
+	calculate_dominance_info(CDI_POST_DOMINATORS);
+
+	context_attr = lookup_attribute("context", DECL_ATTRIBUTES(current_function_decl));
+	if (context_attr) {
+		gcc_assert(split_context_attribute(TREE_VALUE(context_attr), &lock, &in, &out));
+	} else {
+		in = out = integer_zero_node;
+	}
+
+	// 1. create local context variable
+	context = create_tmp_var(integer_type_node, "context");
+	add_referenced_var(context);
+	mark_sym_for_renaming(context);
+
+	// 2. initialize local context variable
+	gcc_assert(single_succ_p(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+	bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+	if (!single_pred_p(bb)) {
+		gcc_assert(bb_any_loop(bb));
+		split_edge(single_succ_edge(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+		bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+	}
+	gsi = gsi_start_bb(bb);
+	assign = gimple_build_assign(context, in);
+	gsi_insert_before(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+
+	// 3. instrument each BB to track the local context variable
+	FOR_EACH_BB_FN(bb, cfun) {
+		bb = track_context(bb, context);
+	}
+
+	// 4. verify the local context variable against the expected state
+	if (EDGE_COUNT(EXIT_BLOCK_PTR_FOR_FN(cfun)->preds)) {
+		gcc_assert(single_pred_p(EXIT_BLOCK_PTR_FOR_FN(cfun)));
+		gsi = gsi_last_nondebug_bb(single_pred(EXIT_BLOCK_PTR_FOR_FN(cfun)));
+		verify_context_before(&gsi, context, out, context_error_decl);
+	}
+
+	free_dominance_info(CDI_DOMINATORS);
+	free_dominance_info(CDI_POST_DOMINATORS);
+	loop_optimizer_finalize();
+	return 0;
+}
+
+#define PASS_NAME context
+#define PROPERTIES_REQUIRED PROP_gimple_leh | PROP_cfg
+//#define TODO_FLAGS_START TODO_verify_ssa | TODO_verify_flow | TODO_verify_stmts
+#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_verify_flow | TODO_update_ssa
+#include "gcc-generate-gimple-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	int i;
+	bool enable_user, enable_context;
+
+	static const struct ggc_root_tab gt_ggc_r_gt_checker[] = {
+		{
+			.base = &context_function_decl,
+			.nelt = 1,
+			.stride = sizeof(context_function_decl),
+			.cb = &gt_ggc_mx_tree_node,
+			.pchw = &gt_pch_nx_tree_node
+		},
+		{
+			.base = &context_error_decl,
+			.nelt = 1,
+			.stride = sizeof(context_error_decl),
+			.cb = &gt_ggc_mx_tree_node,
+			.pchw = &gt_pch_nx_tree_node
+		},
+		LAST_GGC_ROOT_TAB
+	};
+
+//	PASS_INFO(context, "ssa", 1, PASS_POS_INSERT_AFTER);
+	PASS_INFO(context, "phiprop", 1, PASS_POS_INSERT_AFTER);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &checker_plugin_info);
+
+	enable_user = false;
+	enable_context = false;
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "user")) {
+			enable_user = true;
+			continue;
+		}
+		if (!strcmp(argv[i].key, "context")) {
+			enable_context = true;
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	if (enable_user)
+		register_callback(plugin_name, PLUGIN_PRAGMAS, register_checker_address_spaces, NULL);
+	if (enable_context) {
+		register_callback(plugin_name, PLUGIN_ATTRIBUTES, register_attributes, NULL);
+		register_callback(plugin_name, PLUGIN_START_UNIT, context_start_unit, NULL);
+		register_callback(plugin_name, PLUGIN_REGISTER_GGC_ROOTS, NULL, (void *)&gt_ggc_r_gt_checker);
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &context_pass_info);
+	}
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/colorize_plugin.c b/scripts/gcc-plugins/colorize_plugin.c
new file mode 100644
index 000000000..a229d002e
--- /dev/null
+++ b/scripts/gcc-plugins/colorize_plugin.c
@@ -0,0 +1,158 @@
+/*
+ * Copyright 2012-2017 by PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * gcc plugin to colorize diagnostic output
+ *
+ */
+
+#include "gcc-common.h"
+
+__visible int plugin_is_GPL_compatible;
+
+static struct plugin_info colorize_plugin_info = {
+	.version	= "201602181345",
+	.help		= "color=[never|always|auto]\tdetermine when to colorize\n",
+};
+
+#define GREEN		"\033[32m\033[K"
+#define LIGHTGREEN	"\033[1;32m\033[K"
+#define YELLOW		"\033[33m\033[K"
+#define LIGHTYELLOW	"\033[1;33m\033[K"
+#define RED		"\033[31m\033[K"
+#define LIGHTRED	"\033[1;31m\033[K"
+#define BLUE		"\033[34m\033[K"
+#define LIGHTBLUE	"\033[1;34m\033[K"
+#define BRIGHT		"\033[1;m\033[K"
+#define NORMAL		"\033[m\033[K"
+
+static diagnostic_starter_fn old_starter;
+static diagnostic_finalizer_fn old_finalizer;
+
+static void start_colorize(diagnostic_context *context, diagnostic_info *diagnostic)
+{
+	const char *color;
+	char *newprefix;
+
+	switch (diagnostic->kind) {
+	case DK_NOTE:
+		color = LIGHTBLUE;
+		break;
+
+	case DK_PEDWARN:
+	case DK_WARNING:
+		color = LIGHTYELLOW;
+		break;
+
+	case DK_ERROR:
+	case DK_FATAL:
+	case DK_ICE:
+	case DK_PERMERROR:
+	case DK_SORRY:
+		color = LIGHTRED;
+		break;
+
+	default:
+		color = NORMAL;
+	}
+
+	old_starter(context, diagnostic);
+	if (-1 == asprintf(&newprefix, "%s%s" NORMAL, color, context->printer->prefix))
+		return;
+	pp_destroy_prefix(context->printer);
+	pp_set_prefix(context->printer, newprefix);
+}
+
+static void finalize_colorize(diagnostic_context *context, diagnostic_info *diagnostic)
+{
+	old_finalizer(context, diagnostic);
+}
+
+static void colorize_arm(void)
+{
+	old_starter = diagnostic_starter(global_dc);
+	old_finalizer = diagnostic_finalizer(global_dc);
+
+	diagnostic_starter(global_dc) = start_colorize;
+	diagnostic_finalizer(global_dc) = finalize_colorize;
+}
+
+static unsigned int colorize_rearm_execute(void)
+{
+	if (diagnostic_starter(global_dc) == start_colorize)
+		return 0;
+
+	colorize_arm();
+	return 0;
+}
+
+#define PASS_NAME colorize_rearm
+#define NO_GATE
+#include "gcc-generate-simple_ipa-pass.h"
+
+static void colorize_start_unit(void *gcc_data, void *user_data)
+{
+	colorize_arm();
+}
+
+static bool should_colorize(void)
+{
+#if BUILDING_GCC_VERSION >= 4009
+	return false;
+#else
+	char const *t = getenv("TERM");
+
+	return t && strcmp(t, "dumb") && isatty(STDERR_FILENO);
+#endif
+}
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	int i;
+	bool colorize;
+
+	PASS_INFO(colorize_rearm, "*free_lang_data", 1, PASS_POS_INSERT_AFTER);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &colorize_plugin_info);
+
+	colorize = getenv("GCC_COLORS") ? should_colorize() : false;
+
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "color")) {
+			if (!argv[i].value) {
+				error(G_("no value supplied for option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+				continue;
+			}
+			if (!strcmp(argv[i].value, "always"))
+				colorize = true;
+			else if (!strcmp(argv[i].value, "never"))
+				colorize = false;
+			else if (!strcmp(argv[i].value, "auto"))
+				colorize = should_colorize();
+			else
+				error(G_("invalid option argument '-fplugin-arg-%s-%s=%s'"), plugin_name, argv[i].key, argv[i].value);
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	if (colorize) {
+		// TODO: parse GCC_COLORS as used by gcc 4.9+
+		register_callback(plugin_name, PLUGIN_START_UNIT, &colorize_start_unit, NULL);
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &colorize_rearm_pass_info);
+	}
+	return 0;
+}
diff --git b/scripts/gcc-plugins/constify_plugin.c b/scripts/gcc-plugins/constify_plugin.c
new file mode 100644
index 000000000..3cd0652b4
--- /dev/null
+++ b/scripts/gcc-plugins/constify_plugin.c
@@ -0,0 +1,577 @@
+/*
+ * Copyright 2011 by Emese Revfy <re.emese@gmail.com>
+ * Copyright 2011-2017 by PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2, or (at your option) v3
+ *
+ * This gcc plugin constifies all structures which contain only function pointers or are explicitly marked for constification.
+ *
+ * Homepage:
+ * http://www.grsecurity.net/~ephox/const_plugin/
+ *
+ * Usage:
+ * $ gcc -I`gcc -print-file-name=plugin`/include -fPIC -shared -O2 -o constify_plugin.so constify_plugin.c
+ * $ gcc -fplugin=constify_plugin.so test.c -O2
+ */
+
+#include "gcc-common.h"
+
+// unused C type flag in all versions 4.5-6
+#define TYPE_CONSTIFY_VISITED(TYPE) TYPE_LANG_FLAG_4(TYPE)
+
+__visible int plugin_is_GPL_compatible;
+
+static bool enabled = true;
+
+static struct plugin_info const_plugin_info = {
+	.version	= "201607241840",
+	.help		= "disable\tturn off constification\n",
+};
+
+static struct {
+	const char *name;
+	const char *asm_op;
+} const_sections[] = {
+	{".init.rodata",     "\t.section\t.init.rodata,\"a\""},
+	{".ref.rodata",      "\t.section\t.ref.rodata,\"a\""},
+	{".devinit.rodata",  "\t.section\t.devinit.rodata,\"a\""},
+	{".devexit.rodata",  "\t.section\t.devexit.rodata,\"a\""},
+	{".cpuinit.rodata",  "\t.section\t.cpuinit.rodata,\"a\""},
+	{".cpuexit.rodata",  "\t.section\t.cpuexit.rodata,\"a\""},
+	{".meminit.rodata",  "\t.section\t.meminit.rodata,\"a\""},
+	{".memexit.rodata",  "\t.section\t.memexit.rodata,\"a\""},
+	{".data..read_only", "\t.section\t.data..read_only,\"a\""},
+};
+
+typedef struct {
+	bool has_fptr_field;
+	bool has_writable_field;
+	bool has_do_const_field;
+	bool has_no_const_field;
+} constify_info;
+
+static const_tree get_field_type(const_tree field)
+{
+	return strip_array_types(TREE_TYPE(field));
+}
+
+static bool is_fptr(const_tree field)
+{
+	const_tree ptr = get_field_type(field);
+
+	if (TREE_CODE(ptr) != POINTER_TYPE)
+		return false;
+
+	return TREE_CODE(TREE_TYPE(ptr)) == FUNCTION_TYPE;
+}
+
+/*
+ * determine whether the given structure type meets the requirements for automatic constification,
+ * including the constification attributes on nested structure types
+ */
+static void constifiable(const_tree node, constify_info *cinfo)
+{
+	const_tree field;
+
+	gcc_assert(TREE_CODE(node) == RECORD_TYPE || TREE_CODE(node) == UNION_TYPE);
+
+	// e.g., pointer to structure fields while still constructing the structure type
+	if (TYPE_FIELDS(node) == NULL_TREE)
+		return;
+
+	for (field = TYPE_FIELDS(node); field; field = TREE_CHAIN(field)) {
+		const_tree type = get_field_type(field);
+		enum tree_code code = TREE_CODE(type);
+
+		if (node == type)
+			continue;
+
+		if (is_fptr(field))
+			cinfo->has_fptr_field = true;
+		else if (code == RECORD_TYPE || code == UNION_TYPE) {
+			if (lookup_attribute("do_const", TYPE_ATTRIBUTES(type)))
+				cinfo->has_do_const_field = true;
+			else if (lookup_attribute("no_const", TYPE_ATTRIBUTES(type)))
+				cinfo->has_no_const_field = true;
+			else
+				constifiable(type, cinfo);
+		} else if (!TREE_READONLY(field))
+			cinfo->has_writable_field = true;
+	}
+}
+
+static bool constified(const_tree node)
+{
+	constify_info cinfo = {
+		.has_fptr_field = false,
+		.has_writable_field = false,
+		.has_do_const_field = false,
+		.has_no_const_field = false
+	};
+
+	gcc_assert(TREE_CODE(node) == RECORD_TYPE || TREE_CODE(node) == UNION_TYPE);
+
+	if (lookup_attribute("no_const", TYPE_ATTRIBUTES(node))) {
+//		gcc_assert(!TYPE_READONLY(node));
+		return false;
+	}
+
+	if (lookup_attribute("do_const", TYPE_ATTRIBUTES(node))) {
+		gcc_assert(TYPE_READONLY(node));
+		return true;
+	}
+
+	constifiable(node, &cinfo);
+	if ((!cinfo.has_fptr_field || cinfo.has_writable_field || cinfo.has_no_const_field) && !cinfo.has_do_const_field)
+		return false;
+
+	return TYPE_READONLY(node);
+}
+
+static void deconstify_tree(tree node);
+
+static void deconstify_type(tree type)
+{
+	tree field;
+
+	gcc_assert(TREE_CODE(type) == RECORD_TYPE || TREE_CODE(type) == UNION_TYPE);
+
+	for (field = TYPE_FIELDS(type); field; field = TREE_CHAIN(field)) {
+		const_tree fieldtype = get_field_type(field);
+
+		// special case handling of simple ptr-to-same-array-type members
+		if (TREE_CODE(TREE_TYPE(field)) == POINTER_TYPE) {
+			tree ptrtype = TREE_TYPE(TREE_TYPE(field));
+
+			if (TREE_TYPE(TREE_TYPE(field)) == type)
+				continue;
+			if (TREE_CODE(ptrtype) != RECORD_TYPE && TREE_CODE(ptrtype) != UNION_TYPE)
+				continue;
+			if (!constified(ptrtype))
+				continue;
+			if (TYPE_MAIN_VARIANT(ptrtype) == TYPE_MAIN_VARIANT(type))
+				TREE_TYPE(field) = build_pointer_type(build_qualified_type(type, TYPE_QUALS(ptrtype) & ~TYPE_QUAL_CONST));
+			continue;
+		}
+		if (TREE_CODE(fieldtype) != RECORD_TYPE && TREE_CODE(fieldtype) != UNION_TYPE)
+			continue;
+		if (!constified(fieldtype))
+			continue;
+
+		deconstify_tree(field);
+		TREE_READONLY(field) = 0;
+	}
+	TYPE_READONLY(type) = 0;
+	C_TYPE_FIELDS_READONLY(type) = 0;
+	if (lookup_attribute("do_const", TYPE_ATTRIBUTES(type))) {
+		TYPE_ATTRIBUTES(type) = copy_list(TYPE_ATTRIBUTES(type));
+		TYPE_ATTRIBUTES(type) = remove_attribute("do_const", TYPE_ATTRIBUTES(type));
+	}
+}
+
+static void deconstify_tree(tree node)
+{
+	tree old_type, new_type, field;
+
+	old_type = TREE_TYPE(node);
+	while (TREE_CODE(old_type) == ARRAY_TYPE && TREE_CODE(TREE_TYPE(old_type)) != ARRAY_TYPE) {
+		node = TREE_TYPE(node) = copy_node(old_type);
+		old_type = TREE_TYPE(old_type);
+	}
+
+	gcc_assert(TREE_CODE(old_type) == RECORD_TYPE || TREE_CODE(old_type) == UNION_TYPE);
+	gcc_assert(TYPE_READONLY(old_type) && (TYPE_QUALS(old_type) & TYPE_QUAL_CONST));
+
+	new_type = build_qualified_type(old_type, TYPE_QUALS(old_type) & ~TYPE_QUAL_CONST);
+	TYPE_FIELDS(new_type) = copy_list(TYPE_FIELDS(new_type));
+	for (field = TYPE_FIELDS(new_type); field; field = TREE_CHAIN(field))
+		DECL_FIELD_CONTEXT(field) = new_type;
+
+	deconstify_type(new_type);
+
+	TREE_TYPE(node) = new_type;
+}
+
+static tree handle_no_const_attribute(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
+{
+	tree type;
+	constify_info cinfo = {
+		.has_fptr_field = false,
+		.has_writable_field = false,
+		.has_do_const_field = false,
+		.has_no_const_field = false
+	};
+
+	*no_add_attrs = true;
+	if (TREE_CODE(*node) == FUNCTION_DECL) {
+		error("%qE attribute does not apply to functions (%qF)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (TREE_CODE(*node) == PARM_DECL) {
+		error("%qE attribute does not apply to function parameters (%qD)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (TREE_CODE(*node) == VAR_DECL) {
+		error("%qE attribute does not apply to variables (%qD)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (TYPE_P(*node)) {
+		type = *node;
+	} else {
+		if (TREE_CODE(*node) != TYPE_DECL) {
+			error("%qE attribute does not apply to %qD (%qT)", name, *node, TREE_TYPE(*node));
+			return NULL_TREE;
+		}
+		type = TREE_TYPE(*node);
+	}
+
+	if (TREE_CODE(type) != RECORD_TYPE && TREE_CODE(type) != UNION_TYPE) {
+		error("%qE attribute used on %qT applies to struct and union types only", name, type);
+		return NULL_TREE;
+	}
+
+	if (lookup_attribute(IDENTIFIER_POINTER(name), TYPE_ATTRIBUTES(type))) {
+		error("%qE attribute is already applied to the type %qT", name, type);
+		return NULL_TREE;
+	}
+
+	if (TYPE_P(*node)) {
+		if (lookup_attribute("do_const", TYPE_ATTRIBUTES(type)))
+			error("%qE attribute used on type %qT is incompatible with 'do_const'", name, type);
+		else
+			*no_add_attrs = false;
+		return NULL_TREE;
+	}
+
+	constifiable(type, &cinfo);
+	if ((cinfo.has_fptr_field && !cinfo.has_writable_field && !cinfo.has_no_const_field) || lookup_attribute("do_const", TYPE_ATTRIBUTES(type))) {
+		if (enabled) {
+			if TYPE_P(*node)
+				deconstify_type(*node);
+			else
+				deconstify_tree(*node);
+		}
+		if (TYPE_P(*node))
+			TYPE_CONSTIFY_VISITED(*node) = 1;
+		else
+			TYPE_CONSTIFY_VISITED(TREE_TYPE(*node)) = 1;
+		return NULL_TREE;
+	}
+
+	if (enabled && TYPE_FIELDS(type))
+		error("%qE attribute used on type %qT that is not constified", name, type);
+	return NULL_TREE;
+}
+
+static void constify_type(tree type)
+{
+	gcc_assert(type == TYPE_MAIN_VARIANT(type));
+	TYPE_READONLY(type) = 1;
+	C_TYPE_FIELDS_READONLY(type) = 1;
+	TYPE_CONSTIFY_VISITED(type) = 1;
+//	TYPE_ATTRIBUTES(type) = copy_list(TYPE_ATTRIBUTES(type));
+//	TYPE_ATTRIBUTES(type) = tree_cons(get_identifier("do_const"), NULL_TREE, TYPE_ATTRIBUTES(type));
+}
+
+static tree handle_do_const_attribute(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
+{
+	*no_add_attrs = true;
+	if (!TYPE_P(*node)) {
+		error("%qE attribute applies to types only (%qD)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (TREE_CODE(*node) != RECORD_TYPE && TREE_CODE(*node) != UNION_TYPE) {
+		error("%qE attribute used on %qT applies to struct and union types only", name, *node);
+		return NULL_TREE;
+	}
+
+	if (lookup_attribute(IDENTIFIER_POINTER(name), TYPE_ATTRIBUTES(*node))) {
+		error("%qE attribute used on %qT is already applied to the type", name, *node);
+		return NULL_TREE;
+	}
+
+	if (lookup_attribute("no_const", TYPE_ATTRIBUTES(*node))) {
+		error("%qE attribute used on %qT is incompatible with 'no_const'", name, *node);
+		return NULL_TREE;
+	}
+
+	*no_add_attrs = false;
+	return NULL_TREE;
+}
+
+static struct attribute_spec no_const_attr = {
+	.name			= "no_const",
+	.min_length		= 0,
+	.max_length		= 0,
+	.decl_required		= false,
+	.type_required		= false,
+	.function_type_required	= false,
+	.handler		= handle_no_const_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity	= true
+#endif
+};
+
+static struct attribute_spec do_const_attr = {
+	.name			= "do_const",
+	.min_length		= 0,
+	.max_length		= 0,
+	.decl_required		= false,
+	.type_required		= false,
+	.function_type_required	= false,
+	.handler		= handle_do_const_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity	= true
+#endif
+};
+
+static void register_attributes(void *event_data, void *data)
+{
+	register_attribute(&no_const_attr);
+	register_attribute(&do_const_attr);
+}
+
+static void finish_type(void *event_data, void *data)
+{
+	tree type = (tree)event_data;
+	constify_info cinfo = {
+		.has_fptr_field = false,
+		.has_writable_field = false,
+		.has_do_const_field = false,
+		.has_no_const_field = false
+	};
+
+	if (type == NULL_TREE || type == error_mark_node)
+		return;
+
+#if BUILDING_GCC_VERSION >= 5000
+	if (TREE_CODE(type) == ENUMERAL_TYPE)
+		return;
+#endif
+
+	if (TYPE_FIELDS(type) == NULL_TREE || TYPE_CONSTIFY_VISITED(type))
+		return;
+
+	constifiable(type, &cinfo);
+
+	if (lookup_attribute("no_const", TYPE_ATTRIBUTES(type))) {
+		if ((cinfo.has_fptr_field && !cinfo.has_writable_field && !cinfo.has_no_const_field) || cinfo.has_do_const_field) {
+			deconstify_type(type);
+			TYPE_CONSTIFY_VISITED(type) = 1;
+		} else
+			error("'no_const' attribute used on type %qT that is not constified", type);
+		return;
+	}
+
+	if (lookup_attribute("do_const", TYPE_ATTRIBUTES(type))) {
+		if (!cinfo.has_writable_field && !cinfo.has_no_const_field) {
+			error("'do_const' attribute used on type %qT that is%sconstified", type, cinfo.has_fptr_field ? " " : " not ");
+			return;
+		}
+		constify_type(type);
+		return;
+	}
+
+	if (cinfo.has_fptr_field && !cinfo.has_writable_field && !cinfo.has_no_const_field) {
+		if (lookup_attribute("do_const", TYPE_ATTRIBUTES(type))) {
+			error("'do_const' attribute used on type %qT that is constified", type);
+			return;
+		}
+		constify_type(type);
+		return;
+	}
+
+	deconstify_type(type);
+	TYPE_CONSTIFY_VISITED(type) = 1;
+}
+
+static bool is_constified_var(varpool_node_ptr node)
+{
+	tree var = NODE_DECL(node);
+	tree type = TREE_TYPE(var);
+
+	if (node->alias)
+		return false;
+
+	if (DECL_EXTERNAL(var))
+		return false;
+
+	// XXX handle more complex nesting of arrays/structs
+	if (TREE_CODE(type) == ARRAY_TYPE)
+		type = TREE_TYPE(type);
+
+	if (TREE_CODE(type) != RECORD_TYPE && TREE_CODE(type) != UNION_TYPE)
+		return false;
+
+	if (!TYPE_READONLY(type) || !C_TYPE_FIELDS_READONLY(type))
+		return false;
+
+	if (!TYPE_CONSTIFY_VISITED(type))
+		return false;
+
+	return true;
+}
+
+static void check_section_mismatch(varpool_node_ptr node)
+{
+	tree var, section;
+	size_t i;
+	const char *name;
+
+	var = NODE_DECL(node);
+	name = get_decl_section_name(var);
+	section = lookup_attribute("section", DECL_ATTRIBUTES(var));
+	if (!section) {
+		if (name) {
+			fprintf(stderr, "DECL_SECTION [%s] ", name);
+			dump_varpool_node(stderr, node);
+			gcc_unreachable();
+		}
+		return;
+	} else
+		gcc_assert(name);
+
+//fprintf(stderr, "SECTIONAME: [%s] ", get_decl_section_name(var));
+//debug_tree(var);
+
+	gcc_assert(!TREE_CHAIN(section));
+	gcc_assert(TREE_VALUE(section));
+
+	section = TREE_VALUE(TREE_VALUE(section));
+	gcc_assert(!strcmp(TREE_STRING_POINTER(section), name));
+//debug_tree(section);
+
+	for (i = 0; i < ARRAY_SIZE(const_sections); i++)
+		if (!strcmp(const_sections[i].name, name))
+			return;
+
+	error_at(DECL_SOURCE_LOCATION(var), "constified variable %qD placed into writable section %E", var, section);
+}
+
+// this works around a gcc bug/feature where uninitialized globals
+// are moved into the .bss section regardless of any constification
+// see gcc/varasm.c:bss_initializer_p()
+static void fix_initializer(varpool_node_ptr node)
+{
+	tree var = NODE_DECL(node);
+	tree type = TREE_TYPE(var);
+
+	if (DECL_INITIAL(var))
+		return;
+
+	DECL_INITIAL(var) = build_constructor(type, NULL);
+//	inform(DECL_SOURCE_LOCATION(var), "constified variable %qE moved into .rodata", var);
+}
+
+static void check_global_variables(void *event_data, void *data)
+{
+	varpool_node_ptr node;
+
+	FOR_EACH_VARIABLE(node) {
+		if (!is_constified_var(node))
+			continue;
+
+		check_section_mismatch(node);
+		fix_initializer(node);
+	}
+}
+
+static unsigned int check_local_variables_execute(void)
+{
+	unsigned int ret = 0;
+	tree var;
+
+	unsigned int i;
+
+	FOR_EACH_LOCAL_DECL(cfun, i, var) {
+		tree type = TREE_TYPE(var);
+
+		gcc_assert(DECL_P(var));
+		if (is_global_var(var))
+			continue;
+
+		if (TREE_CODE(type) != RECORD_TYPE && TREE_CODE(type) != UNION_TYPE)
+			continue;
+
+		if (!TYPE_READONLY(type) || !C_TYPE_FIELDS_READONLY(type))
+			continue;
+
+		if (!TYPE_CONSTIFY_VISITED(type))
+			continue;
+
+		error_at(DECL_SOURCE_LOCATION(var), "constified variable %qE cannot be local", var);
+		ret = 1;
+	}
+	return ret;
+}
+
+#define PASS_NAME check_local_variables
+#define NO_GATE
+#include "gcc-generate-gimple-pass.h"
+
+static unsigned int (*old_section_type_flags)(tree decl, const char *name, int reloc);
+
+static unsigned int constify_section_type_flags(tree decl, const char *name, int reloc)
+{
+	size_t i;
+
+	for (i = 0; i < ARRAY_SIZE(const_sections); i++)
+		if (!strcmp(const_sections[i].name, name))
+			return 0;
+
+	return old_section_type_flags(decl, name, reloc);
+}
+
+static void constify_start_unit(void *gcc_data, void *user_data)
+{
+//	size_t i;
+
+//	for (i = 0; i < ARRAY_SIZE(const_sections); i++)
+//		const_sections[i].section = get_unnamed_section(0, output_section_asm_op, const_sections[i].asm_op);
+//		const_sections[i].section = get_section(const_sections[i].name, 0, NULL);
+
+	old_section_type_flags = targetm.section_type_flags;
+	targetm.section_type_flags = constify_section_type_flags;
+}
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	int i;
+
+	PASS_INFO(check_local_variables, "ssa", 1, PASS_POS_INSERT_BEFORE);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	for (i = 0; i < argc; ++i) {
+		if (!(strcmp(argv[i].key, "disable"))) {
+			enabled = false;
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	if (strncmp(lang_hooks.name, "GNU C", 5) && !strncmp(lang_hooks.name, "GNU C+", 6)) {
+		inform(UNKNOWN_LOCATION, G_("%s supports C only, not %s"), plugin_name, lang_hooks.name);
+		enabled = false;
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &const_plugin_info);
+	if (enabled) {
+		register_callback(plugin_name, PLUGIN_ALL_IPA_PASSES_START, check_global_variables, NULL);
+		register_callback(plugin_name, PLUGIN_FINISH_TYPE, finish_type, NULL);
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &check_local_variables_pass_info);
+		register_callback(plugin_name, PLUGIN_START_UNIT, constify_start_unit, NULL);
+	}
+	register_callback(plugin_name, PLUGIN_ATTRIBUTES, register_attributes, NULL);
+
+	return 0;
+}
diff --git a/scripts/gcc-plugins/cyc_complexity_plugin.c b/scripts/gcc-plugins/cyc_complexity_plugin.c
index 34df974c6..2b01d4d85 100644
--- a/scripts/gcc-plugins/cyc_complexity_plugin.c
+++ b/scripts/gcc-plugins/cyc_complexity_plugin.c
@@ -1,5 +1,5 @@
 /*
- * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
  * Licensed under the GPL v2, or (at your option) v3
  *
  * Homepage:
@@ -20,7 +20,7 @@
 
 #include "gcc-common.h"
 
-int plugin_is_GPL_compatible;
+__visible int plugin_is_GPL_compatible;
 
 static struct plugin_info cyc_complexity_plugin_info = {
 	.version	= "20160225",
@@ -49,15 +49,11 @@ static unsigned int cyc_complexity_execute(void)
 
 #include "gcc-generate-gimple-pass.h"
 
-int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
 {
 	const char * const plugin_name = plugin_info->base_name;
-	struct register_pass_info cyc_complexity_pass_info;
 
-	cyc_complexity_pass_info.pass				= make_cyc_complexity_pass();
-	cyc_complexity_pass_info.reference_pass_name		= "ssa";
-	cyc_complexity_pass_info.ref_pass_instance_number	= 1;
-	cyc_complexity_pass_info.pos_op				= PASS_POS_INSERT_AFTER;
+	PASS_INFO(cyc_complexity, "ssa", 1, PASS_POS_INSERT_AFTER);
 
 	if (!plugin_default_version_check(version, &gcc_version)) {
 		error(G_("incompatible gcc/plugin versions"));
diff --git a/scripts/gcc-plugins/gcc-common.h b/scripts/gcc-plugins/gcc-common.h
index 172850bcd..879f0d55f 100644
--- a/scripts/gcc-plugins/gcc-common.h
+++ b/scripts/gcc-plugins/gcc-common.h
@@ -21,14 +21,22 @@
 #include "rtl.h"
 #include "tm_p.h"
 #include "flags.h"
+//#include "insn-attr.h"
+//#include "insn-config.h"
+//#include "insn-flags.h"
 #include "hard-reg-set.h"
+//#include "recog.h"
 #include "output.h"
 #include "except.h"
 #include "function.h"
 #include "toplev.h"
+#if BUILDING_GCC_VERSION >= 5000
+#include "expr.h"
+#endif
 #include "basic-block.h"
 #include "intl.h"
 #include "ggc.h"
+//#include "regs.h"
 #include "timevar.h"
 
 #include "params.h"
@@ -39,13 +47,22 @@
 #include "hash-map.h"
 #endif
 
+#if BUILDING_GCC_VERSION >= 7000
+#include "memmodel.h"
+#endif
 #include "emit-rtl.h"
+//#include "reload.h"
+//#include "ira.h"
+//#include "dwarf2asm.h"
 #include "debug.h"
 #include "target.h"
 #include "langhooks.h"
 #include "cfgloop.h"
+//#include "hosthooks.h"
 #include "cgraph.h"
 #include "opts.h"
+//#include "coverage.h"
+//#include "value-prof.h"
 
 #if BUILDING_GCC_VERSION == 4005
 #include <sys/mman.h>
@@ -57,6 +74,8 @@
 #endif
 
 #if BUILDING_GCC_VERSION >= 4006
+//#include "c-tree.h"
+//#include "cp/cp-tree.h"
 #include "c-family/c-common.h"
 #else
 #include "c-common.h"
@@ -75,8 +94,13 @@
 #endif
 
 #include "diagnostic.h"
+//#include "tree-diagnostic.h"
 #include "tree-dump.h"
 #include "tree-pass.h"
+#if BUILDING_GCC_VERSION >= 4009
+#include "pass_manager.h"
+#endif
+//#include "df.h"
 #include "predict.h"
 #include "ipa-utils.h"
 
@@ -87,10 +111,14 @@
 #include "internal-fn.h"
 #include "gimple-expr.h"
 #include "gimple-fold.h"
+//#include "diagnostic-color.h"
 #include "context.h"
 #include "tree-ssa-alias.h"
 #include "tree-ssa.h"
 #include "stringpool.h"
+#if BUILDING_GCC_VERSION >= 7000
+#include "tree-vrp.h"
+#endif
 #include "tree-ssanames.h"
 #include "print-tree.h"
 #include "tree-eh.h"
@@ -109,27 +137,33 @@
 #include "ssa-iterators.h"
 #endif
 
+//#include "lto/lto.h"
+#if BUILDING_GCC_VERSION >= 4007
+//#include "data-streamer.h"
+#else
+//#include "lto-streamer.h"
+#endif
+//#include "lto-compress.h"
 #if BUILDING_GCC_VERSION >= 5000
+//#include "lto-section-names.h"
 #include "builtins.h"
 #endif
 
-/* #include "expr.h" where are you... */
-extern rtx emit_move_insn(rtx x, rtx y);
-
 /* missing from basic_block.h... */
-extern void debug_dominance_info(enum cdi_direction dir);
-extern void debug_dominance_tree(enum cdi_direction dir, basic_block root);
+void debug_dominance_info(enum cdi_direction dir);
+void debug_dominance_tree(enum cdi_direction dir, basic_block root);
 
 #if BUILDING_GCC_VERSION == 4006
-extern void debug_gimple_stmt(gimple);
-extern void debug_gimple_seq(gimple_seq);
-extern void print_gimple_seq(FILE *, gimple_seq, int, int);
-extern void print_gimple_stmt(FILE *, gimple, int, int);
-extern void print_gimple_expr(FILE *, gimple, int, int);
-extern void dump_gimple_stmt(pretty_printer *, gimple, int, int);
+void debug_gimple_stmt(gimple);
+void debug_gimple_seq(gimple_seq);
+void print_gimple_seq(FILE *, gimple_seq, int, int);
+void print_gimple_stmt(FILE *, gimple, int, int);
+void print_gimple_expr(FILE *, gimple, int, int);
+void dump_gimple_stmt(pretty_printer *, gimple, int, int);
 #endif
 
 #define __unused __attribute__((__unused__))
+#define __visible __attribute__((visibility("default")))
 
 #define DECL_NAME_POINTER(node) IDENTIFIER_POINTER(DECL_NAME(node))
 #define DECL_NAME_LENGTH(node) IDENTIFIER_LENGTH(DECL_NAME(node))
@@ -139,6 +173,29 @@ extern void dump_gimple_stmt(pretty_printer *, gimple, int, int);
 /* should come from c-tree.h if only it were installed for gcc 4.5... */
 #define C_TYPE_FIELDS_READONLY(TYPE) TREE_LANG_FLAG_1(TYPE)
 
+static inline tree build_const_char_string(int len, const char *str)
+{
+	tree cstr, elem, index, type;
+
+	cstr = build_string(len, str);
+	elem = build_type_variant(char_type_node, 1, 0);
+	index = build_index_type(size_int(len - 1));
+	type = build_array_type(elem, index);
+	TREE_TYPE(cstr) = type;
+	TREE_CONSTANT(cstr) = 1;
+	TREE_READONLY(cstr) = 1;
+	TREE_STATIC(cstr) = 1;
+	return cstr;
+}
+
+#define PASS_INFO(NAME, REF, ID, POS)		\
+struct register_pass_info NAME##_pass_info = {	\
+	.pass = make_##NAME##_pass(),		\
+	.reference_pass_name = REF,		\
+	.ref_pass_instance_number = ID,		\
+	.pos_op = POS,				\
+}
+
 #if BUILDING_GCC_VERSION == 4005
 #define FOR_EACH_LOCAL_DECL(FUN, I, D)			\
 	for (tree vars = (FUN)->local_decls, (I) = 0;	\
@@ -165,6 +222,7 @@ static inline bool gimple_call_builtin_p(gimple stmt, enum built_in_function cod
 	fndecl = gimple_call_fndecl(stmt);
 	if (!fndecl || DECL_BUILT_IN_CLASS(fndecl) != BUILT_IN_NORMAL)
 		return false;
+//	print_node(stderr, "pax", fndecl, 4);
 	return DECL_FUNCTION_CODE(fndecl) == code;
 }
 
@@ -286,6 +344,22 @@ static inline struct cgraph_node *cgraph_next_function_with_gimple_body(struct c
 	return NULL;
 }
 
+static inline bool cgraph_for_node_and_aliases(cgraph_node_ptr node, bool (*callback)(cgraph_node_ptr, void *), void *data, bool include_overwritable)
+{
+	cgraph_node_ptr alias;
+
+	if (callback(node, data))
+		return true;
+
+	for (alias = node->same_body; alias; alias = alias->next) {
+		if (include_overwritable || cgraph_function_body_availability(alias) > AVAIL_OVERWRITABLE)
+			if (cgraph_for_node_and_aliases(alias, callback, data, include_overwritable))
+				return true;
+	}
+
+	return false;
+}
+
 #define FOR_EACH_FUNCTION_WITH_GIMPLE_BODY(node) \
 	for ((node) = cgraph_first_function_with_gimple_body(); (node); \
 		(node) = cgraph_next_function_with_gimple_body(node))
@@ -398,6 +472,7 @@ typedef union gimple_statement_d gassign;
 typedef union gimple_statement_d gcall;
 typedef union gimple_statement_d gcond;
 typedef union gimple_statement_d gdebug;
+typedef union gimple_statement_d ggoto;
 typedef union gimple_statement_d gphi;
 typedef union gimple_statement_d greturn;
 
@@ -451,6 +526,16 @@ static inline const gdebug *as_a_const_gdebug(const_gimple stmt)
 	return stmt;
 }
 
+static inline ggoto *as_a_ggoto(gimple stmt)
+{
+	return stmt;
+}
+
+static inline const ggoto *as_a_const_ggoto(const_gimple stmt)
+{
+	return stmt;
+}
+
 static inline gphi *as_a_gphi(gimple stmt)
 {
 	return stmt;
@@ -493,8 +578,18 @@ static inline const greturn *as_a_const_greturn(const_gimple stmt)
 #define section_name_prefix LTO_SECTION_NAME_PREFIX
 #define fatal_error(loc, gmsgid, ...) fatal_error((gmsgid), __VA_ARGS__)
 
+rtx emit_move_insn(rtx x, rtx y);
+
 typedef struct rtx_def rtx_insn;
 
+static inline const char *get_decl_section_name(const_tree decl)
+{
+	if (DECL_SECTION_NAME(decl) == NULL_TREE)
+		return NULL;
+
+	return TREE_STRING_POINTER(DECL_SECTION_NAME(decl));
+}
+
 static inline void set_decl_section_name(tree node, const char *value)
 {
 	if (value)
@@ -510,6 +605,7 @@ typedef struct gimple_statement_base gassign;
 typedef struct gimple_statement_call gcall;
 typedef struct gimple_statement_base gcond;
 typedef struct gimple_statement_base gdebug;
+typedef struct gimple_statement_base ggoto;
 typedef struct gimple_statement_phi gphi;
 typedef struct gimple_statement_base greturn;
 
@@ -563,6 +659,16 @@ static inline const gdebug *as_a_const_gdebug(const_gimple stmt)
 	return stmt;
 }
 
+static inline ggoto *as_a_ggoto(gimple stmt)
+{
+	return stmt;
+}
+
+static inline const ggoto *as_a_const_ggoto(const_gimple stmt)
+{
+	return stmt;
+}
+
 static inline gphi *as_a_gphi(gimple stmt)
 {
 	return as_a<gphi>(stmt);
@@ -590,6 +696,11 @@ static inline const greturn *as_a_const_greturn(const_gimple stmt)
 #define NODE_DECL(node) (node)->decl
 #define cgraph_node_name(node) (node)->name()
 #define NODE_IMPLICIT_ALIAS(node) (node)->cpp_implicit_alias
+
+static inline opt_pass *get_pass_for_id(int id)
+{
+	return g->get_passes()->get_pass_for_id(id);
+}
 #endif
 
 #if BUILDING_GCC_VERSION >= 5000 && BUILDING_GCC_VERSION < 6000
@@ -608,8 +719,15 @@ inline bool is_a_helper<const gassign *>::test(const_gimple gs)
 #define TODO_verify_stmts TODO_verify_il
 #define TODO_verify_rtl_sharing TODO_verify_il
 
+//#define TREE_INT_CST_HIGH(NODE) ({ TREE_INT_CST_EXT_NUNITS(NODE) > 1 ? (unsigned HOST_WIDE_INT)TREE_INT_CST_ELT(NODE, 1) : 0; })
+
 #define INSN_DELETED_P(insn) (insn)->deleted()
 
+static inline const char *get_decl_section_name(const_tree decl)
+{
+	return DECL_SECTION_NAME(decl);
+}
+
 /* symtab/cgraph related */
 #define debug_cgraph_node(node) (node)->debug()
 #define cgraph_get_node(decl) cgraph_node::get(decl)
@@ -618,6 +736,7 @@ inline bool is_a_helper<const gassign *>::test(const_gimple gs)
 #define cgraph_n_nodes symtab->cgraph_count
 #define cgraph_max_uid symtab->cgraph_max_uid
 #define varpool_get_node(decl) varpool_node::get(decl)
+#define dump_varpool_node(file, node) (node)->dump(file)
 
 #define cgraph_create_edge(caller, callee, call_stmt, count, freq, nest) \
 	(caller)->create_edge((callee), (call_stmt), (count), (freq))
@@ -673,6 +792,11 @@ static inline cgraph_node_ptr cgraph_alias_target(cgraph_node_ptr node)
 	return node->get_alias_target();
 }
 
+static inline bool cgraph_for_node_and_aliases(cgraph_node_ptr node, bool (*callback)(cgraph_node_ptr, void *), void *data, bool include_overwritable)
+{
+	return node->call_for_symbol_thunks_and_aliases(callback, data, include_overwritable);
+}
+
 static inline struct cgraph_node_hook_list *cgraph_add_function_insertion_hook(cgraph_node_hook hook, void *data)
 {
 	return symtab->add_cgraph_insertion_hook(hook, data);
@@ -730,6 +854,13 @@ static inline gimple gimple_build_assign_with_ops(enum tree_code subcode, tree l
 
 template <>
 template <>
+inline bool is_a_helper<const ggoto *>::test(const_gimple gs)
+{
+	return gs->code == GIMPLE_GOTO;
+}
+
+template <>
+template <>
 inline bool is_a_helper<const greturn *>::test(const_gimple gs)
 {
 	return gs->code == GIMPLE_RETURN;
@@ -765,6 +896,16 @@ static inline const gcall *as_a_const_gcall(const_gimple stmt)
 	return as_a<const gcall *>(stmt);
 }
 
+static inline ggoto *as_a_ggoto(gimple stmt)
+{
+	return as_a<ggoto *>(stmt);
+}
+
+static inline const ggoto *as_a_const_ggoto(const_gimple stmt)
+{
+	return as_a<const ggoto *>(stmt);
+}
+
 static inline gphi *as_a_gphi(gimple stmt)
 {
 	return as_a<gphi *>(stmt);
@@ -827,4 +968,9 @@ static inline void debug_gimple_stmt(const_gimple s)
 #define debug_gimple_stmt(s) debug_gimple_stmt(CONST_CAST_GIMPLE(s))
 #endif
 
+#if BUILDING_GCC_VERSION >= 7000
+#define get_inner_reference(exp, pbitsize, pbitpos, poffset, pmode, punsignedp, preversep, pvolatilep, keep_aligning)	\
+	get_inner_reference(exp, pbitsize, pbitpos, poffset, pmode, punsignedp, preversep, pvolatilep)
+#endif
+
 #endif
diff --git a/scripts/gcc-plugins/gcc-generate-gimple-pass.h b/scripts/gcc-plugins/gcc-generate-gimple-pass.h
index 526c3c79b..831300b05 100644
--- a/scripts/gcc-plugins/gcc-generate-gimple-pass.h
+++ b/scripts/gcc-plugins/gcc-generate-gimple-pass.h
@@ -119,7 +119,7 @@ public:
 #endif
 #endif
 
-	virtual opt_pass * clone () { return new _PASS_NAME_PASS(); }
+	virtual opt_pass *clone() { return new _PASS_NAME_PASS(); }
 
 #ifndef NO_EXECUTE
 #if BUILDING_GCC_VERSION >= 5000
@@ -136,6 +136,7 @@ opt_pass *_MAKE_PASS_NAME_PASS(void)
 	return new _PASS_NAME_PASS();
 }
 #else
+struct opt_pass *_MAKE_PASS_NAME_PASS(void);
 struct opt_pass *_MAKE_PASS_NAME_PASS(void)
 {
 	return &_PASS_NAME_PASS.pass;
diff --git a/scripts/gcc-plugins/gcc-generate-ipa-pass.h b/scripts/gcc-plugins/gcc-generate-ipa-pass.h
index 9bd926e07..93d8743d2 100644
--- a/scripts/gcc-plugins/gcc-generate-ipa-pass.h
+++ b/scripts/gcc-plugins/gcc-generate-ipa-pass.h
@@ -225,6 +225,7 @@ opt_pass *_MAKE_PASS_NAME_PASS(void)
 	return new _PASS_NAME_PASS();
 }
 #else
+struct opt_pass *_MAKE_PASS_NAME_PASS(void);
 struct opt_pass *_MAKE_PASS_NAME_PASS(void)
 {
 	return &_PASS_NAME_PASS.pass;
diff --git a/scripts/gcc-plugins/gcc-generate-rtl-pass.h b/scripts/gcc-plugins/gcc-generate-rtl-pass.h
index 1dc67a5ae..e858d6776 100644
--- a/scripts/gcc-plugins/gcc-generate-rtl-pass.h
+++ b/scripts/gcc-plugins/gcc-generate-rtl-pass.h
@@ -136,6 +136,7 @@ opt_pass *_MAKE_PASS_NAME_PASS(void)
 	return new _PASS_NAME_PASS();
 }
 #else
+struct opt_pass *_MAKE_PASS_NAME_PASS(void);
 struct opt_pass *_MAKE_PASS_NAME_PASS(void)
 {
 	return &_PASS_NAME_PASS.pass;
diff --git a/scripts/gcc-plugins/gcc-generate-simple_ipa-pass.h b/scripts/gcc-plugins/gcc-generate-simple_ipa-pass.h
index a27e2b36a..d5ed4e2ff 100644
--- a/scripts/gcc-plugins/gcc-generate-simple_ipa-pass.h
+++ b/scripts/gcc-plugins/gcc-generate-simple_ipa-pass.h
@@ -136,6 +136,7 @@ opt_pass *_MAKE_PASS_NAME_PASS(void)
 	return new _PASS_NAME_PASS();
 }
 #else
+struct opt_pass *_MAKE_PASS_NAME_PASS(void);
 struct opt_pass *_MAKE_PASS_NAME_PASS(void)
 {
 	return &_PASS_NAME_PASS.pass;
diff --git b/scripts/gcc-plugins/gen-random-seed.sh b/scripts/gcc-plugins/gen-random-seed.sh
new file mode 100644
index 000000000..7514850f4
--- /dev/null
+++ b/scripts/gcc-plugins/gen-random-seed.sh
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+if [ ! -f "$1" ]; then
+	SEED=`od -A n -t x8 -N 32 /dev/urandom | tr -d ' \n'`
+	echo "const char *randstruct_seed = \"$SEED\";" > "$1"
+	HASH=`echo -n "$SEED" | sha256sum | cut -d" " -f1 | tr -d ' \n'`
+	echo "#define RANDSTRUCT_HASHED_SEED \"$HASH\"" > "$2"
+fi
diff --git b/scripts/gcc-plugins/initify_plugin.c b/scripts/gcc-plugins/initify_plugin.c
new file mode 100644
index 000000000..0fa1d7fb5
--- /dev/null
+++ b/scripts/gcc-plugins/initify_plugin.c
@@ -0,0 +1,1831 @@
+/*
+ * Copyright 2015-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/initify
+ *
+ * This plugin has two passes. The first one tries to find all functions that
+ * can be become __init/__exit. The second one moves string constants
+ * (local variables and function string arguments marked by
+ * the nocapture attribute) only referenced in __init/__exit functions
+ * to __initconst/__exitconst sections.
+ * Based on an idea from Mathias Krause <minipli@ld-linux.so>.
+ *
+ * The instrumentation pass of the latent_entropy plugin must run after
+ * the initify plugin to increase coverage.
+ *
+ * Options:
+ * -fplugin-arg-initify_plugin-disable
+ * -fplugin-arg-initify_plugin-verbose
+ * -fplugin-arg-initify_plugin-print_missing_attr
+ * -fplugin-arg-initify_plugin-search_init_exit_functions
+ * -fplugin-arg-initify_plugin-enable_init_to_exit_moves
+ * -fplugin-arg-initify_plugin-disable_verify_nocapture_functions
+ *
+ * Attribute: __attribute__((nocapture(x, y ...)))
+ *  The nocapture gcc attribute can be on functions only.
+ *  The attribute takes one or more unsigned integer constants as parameters
+ *  that specify the function argument(s) of const char* type to initify.
+ *  If the marked argument is a vararg then the plugin initifies
+ *  all vararg arguments.
+ *  There can be one negative value which means that the return of the function
+ *  will be followed to find it is a nocapture attribute or not.
+ *
+ * Attribute: __attribute__((unverified_nocapture(x, y ...)))
+ *  This attribute disables the compile data flow verification of the designated
+ *  nocapture parameters of the function. Use it only on function parameters
+ *  that are difficult for the plugin to analyze.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "gcc-common.h"
+
+__visible int plugin_is_GPL_compatible;
+
+static struct plugin_info initify_plugin_info = {
+	.version	=	"20170112",
+	.help		=	"disable\tturn off the initify plugin\n"
+				"verbose\tprint all initified strings and all"
+				" functions which should be __init/__exit\n"
+				"print_missing_attr\tprint functions which"
+				" can be marked by nocapture attribute\n"
+				"search_init_exit_functions\tfind functions"
+				" which should be marked by __init or __exit"
+				" attribute\n"
+				"enable_init_to_exit_moves\tmove a function"
+				" to the exit section if it is called by __init"
+				" and __exit functions too\n"
+				"disable_verify_nocapture_functions\tdisable"
+				" the search of capture uses in nocapture"
+				" functions\n"
+};
+
+#define ARGNUM_NONE 0
+static bool verbose, print_missing_attr, search_init_exit_functions;
+static bool enable_init_to_exit_moves, disable_verify_nocapture_functions;
+
+enum section_type {
+	INIT, EXIT, BOTH, NONE
+};
+
+enum attribute_type {
+	UNVERIFIED, NOCAPTURE, PRINTF, BUILTINS, SYSCALL, NONE_ATTRIBUTE
+};
+
+
+#if BUILDING_GCC_VERSION >= 5000
+typedef struct hash_set<const_gimple> gimple_set;
+
+static inline bool pointer_set_insert(gimple_set *visited, const_gimple stmt)
+{
+	return visited->add(stmt);
+}
+
+static inline bool pointer_set_contains(gimple_set *visited, const_gimple stmt)
+{
+	return visited->contains(stmt);
+}
+
+static inline gimple_set* pointer_set_create(void)
+{
+	return new hash_set<const_gimple>;
+}
+
+static inline void pointer_set_destroy(gimple_set *visited)
+{
+	delete visited;
+}
+
+typedef struct hash_set<const_tree> tree_set;
+
+static inline bool pointer_set_insert(tree_set *visited, const_tree node)
+{
+	return visited->add(node);
+}
+
+static inline tree_set* tree_pointer_set_create(void)
+{
+	return new hash_set<const_tree>;
+}
+
+static inline void pointer_set_destroy(tree_set *visited)
+{
+	delete visited;
+}
+#else
+typedef struct pointer_set_t gimple_set;
+typedef struct pointer_set_t tree_set;
+
+static inline tree_set *tree_pointer_set_create(void)
+{
+	return pointer_set_create();
+}
+#endif
+
+static gimple initify_get_def_stmt(const_tree node)
+{
+	gcc_assert(node != NULL_TREE);
+
+	if (TREE_CODE(node) != SSA_NAME)
+		return NULL;
+	return SSA_NAME_DEF_STMT(node);
+}
+
+static void search_constant_strings(bool *has_str_cst, gimple_set *visited, tree node);
+static bool has_capture_use_local_var(const_tree vardecl);
+static bool search_capture_ssa_use(gimple_set *visited_defs, tree node);
+
+#define FUNCTION_PTR_P(node) \
+	(TREE_CODE(TREE_TYPE(node)) == POINTER_TYPE && \
+	(TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == FUNCTION_TYPE || \
+	TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == METHOD_TYPE))
+
+static bool is_vararg_arg(tree arg_list, unsigned int num)
+{
+	if (tree_last(arg_list) == void_list_node)
+		return false;
+
+	return num >= (unsigned int)list_length(arg_list);
+}
+
+static const_tree get_ptr_type(const_tree type)
+{
+	gcc_assert(type != NULL_TREE);
+
+	if (TREE_CODE(type) != POINTER_TYPE)
+		return type;
+	return get_ptr_type(TREE_TYPE(type));
+}
+
+static bool check_parameter(tree *node, tree type_args, int idx)
+{
+	const_tree type_arg, type, type_type, type_name, ptr_type;
+
+	if (is_vararg_arg(type_args, idx))
+		return true;
+
+	type_arg = chain_index(idx - 1, type_args);
+	type = TREE_VALUE(type_arg);
+	gcc_assert(type != NULL_TREE);
+	type_type = TREE_TYPE(type);
+	gcc_assert(type_type != NULL_TREE);
+
+	type_name = TYPE_NAME(type_type);
+	if (type_name != NULL_TREE && TREE_CODE(type_name) == IDENTIFIER_NODE && !strcmp(TYPE_NAME_POINTER(type_type), "va_format"))
+		return true;
+
+	if (TREE_CODE(type) != POINTER_TYPE) {
+		error("%u. parameter of the %qE function must be a pointer", idx, *node);
+		return false;
+	}
+
+	ptr_type = get_ptr_type(type_type);
+	if (!TYPE_READONLY(ptr_type)) {
+		error("%u. parameter of the %qE function must be readonly", idx, *node);
+		return false;
+	}
+
+	if (TREE_THIS_VOLATILE(ptr_type)) {
+		error("%u. parameter of the %qE function can't be volatile", idx, *node);
+		return false;
+	}
+
+	return true;
+}
+
+static bool check_marked_parameters(tree *node, tree type_args, const_tree args, const_tree name)
+{
+	const_tree arg;
+	bool negative_val;
+
+	negative_val = false;
+	for (arg = args; arg; arg = TREE_CHAIN(arg)) {
+		int idx;
+		unsigned int abs_idx;
+		tree position = TREE_VALUE(arg);
+
+		if (TREE_CODE(position) != INTEGER_CST) {
+			error("%qE parameter of the %qE attribute isn't an integer (fn: %qE)", position, name, *node);
+			return false;
+		}
+
+		idx = (int)tree_to_shwi(position);
+		if (negative_val && idx < 0) {
+			error("Only one negative attribute value is supported (attribute: %qE fn: %qE)", name, *node);
+			return false;
+		}
+
+		if (idx < 0)
+			negative_val = true;
+
+		abs_idx = abs(idx);
+		if (abs_idx == 0)
+			continue;
+
+		if (!check_parameter(node, type_args, abs_idx))
+			return false;
+	}
+	return true;
+}
+
+static bool check_all_parameters(tree *node, tree type_args)
+{
+	int arg, len = list_length(type_args);
+
+	if (tree_last(type_args) == void_list_node)
+		len -= 1;
+
+	for (arg = 1; arg <= len; arg++) {
+		if (!check_parameter(node, type_args, arg))
+			return false;
+	}
+	return true;
+}
+
+/* nocapture attribute:
+ *  * to mark nocapture function arguments. If used on a vararg argument
+ *    it applies to all of them that have no other uses.
+ *  * attribute value 0 is ignored to allow reusing print attribute arguments
+ */
+static bool handle_initify_attributes(tree *node, tree name, tree args)
+{
+	tree type_args = NULL_TREE;
+
+	switch (TREE_CODE(*node)) {
+	case FUNCTION_DECL:
+		type_args = TYPE_ARG_TYPES(TREE_TYPE(*node));
+		break;
+
+	case FUNCTION_TYPE:
+	case METHOD_TYPE:
+		type_args = TYPE_ARG_TYPES(*node);
+		break;
+
+	case TYPE_DECL: {
+		enum tree_code fn_code;
+		const_tree fntype = TREE_TYPE(*node);
+
+		fn_code = TREE_CODE(fntype);
+		if (fn_code == POINTER_TYPE)
+			fntype = TREE_TYPE(fntype);
+		fn_code = TREE_CODE(fntype);
+		if (fn_code == FUNCTION_TYPE || fn_code == METHOD_TYPE) {
+			type_args = TYPE_ARG_TYPES(fntype);
+			break;
+		}
+		/* FALLTHROUGH */
+	}
+
+	default:
+		debug_tree(*node);
+		error("%s: %qE attribute only applies to functions", __func__, name);
+		return false;
+	}
+
+	gcc_assert(type_args != NULL_TREE);
+
+	if (!check_marked_parameters(node, type_args, args, name))
+		return false;
+	return args != NULL_TREE || check_all_parameters(node, type_args);
+}
+
+static tree handle_nocapture_attribute(tree *node, tree name, tree args, int __unused flags, bool *no_add_attrs)
+{
+	tree nocapture_attr;
+
+	*no_add_attrs = true;
+
+	if (!handle_initify_attributes(node, name, args))
+		return NULL_TREE;
+
+	nocapture_attr = lookup_attribute("nocapture", DECL_ATTRIBUTES(*node));
+	if (nocapture_attr)
+		chainon(TREE_VALUE(nocapture_attr), args);
+	else
+		*no_add_attrs = false;
+
+	return NULL_TREE;
+}
+
+static tree handle_unverified_nocapture_attribute(tree *node, tree name, tree args, int __unused flags, bool *no_add_attrs)
+{
+	tree unverified_attr;
+
+	*no_add_attrs = true;
+
+	if (!handle_initify_attributes(node, name, args))
+		return NULL_TREE;
+
+	unverified_attr = lookup_attribute("unverified_nocapture", DECL_ATTRIBUTES(*node));
+	if (unverified_attr)
+		chainon(TREE_VALUE(unverified_attr), args);
+	else
+		*no_add_attrs = false;
+
+	return NULL_TREE;
+}
+
+static struct attribute_spec nocapture_attr = {
+	.name				= "nocapture",
+	.min_length			= 0,
+	.max_length			= -1,
+	.decl_required			= true,
+	.type_required			= false,
+	.function_type_required		= false,
+	.handler			= handle_nocapture_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity		= false
+#endif
+};
+
+static struct attribute_spec unverified_nocapture_attr = {
+	.name				= "unverified_nocapture",
+	.min_length			= 0,
+	.max_length			= -1,
+	.decl_required			= true,
+	.type_required			= false,
+	.function_type_required		= false,
+	.handler			= handle_unverified_nocapture_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity		= false
+#endif
+};
+
+static void register_attributes(void __unused *event_data, void __unused *data)
+{
+	register_attribute(&nocapture_attr);
+	register_attribute(&unverified_nocapture_attr);
+}
+
+/* Determine whether the function is in the init or exit sections. */
+static enum section_type get_init_exit_section(const_tree decl)
+{
+	const char *str;
+	const_tree section, attr_value;
+
+	section = lookup_attribute("section", DECL_ATTRIBUTES(decl));
+	if (!section)
+		return NONE;
+
+	attr_value = TREE_VALUE(section);
+	gcc_assert(attr_value != NULL_TREE);
+	gcc_assert(list_length(attr_value) == 1);
+
+	str = TREE_STRING_POINTER(TREE_VALUE(attr_value));
+
+	if (!strncmp(str, ".init.", 6))
+		return INIT;
+	if (!strncmp(str, ".exit.", 6))
+		return EXIT;
+	return NONE;
+}
+
+static tree get_string_cst(tree var)
+{
+	if (var == NULL_TREE)
+		return NULL_TREE;
+
+	if (TREE_CODE(var) == STRING_CST)
+		return var;
+
+	switch (TREE_CODE_CLASS(TREE_CODE(var))) {
+	case tcc_expression:
+	case tcc_reference: {
+		int i;
+
+		for (i = 0; i < TREE_OPERAND_LENGTH(var); i++) {
+			tree ret = get_string_cst(TREE_OPERAND(var, i));
+			if (ret != NULL_TREE)
+				return ret;
+		}
+		break;
+	}
+
+	default:
+		break;
+	}
+
+	return NULL_TREE;
+}
+
+static bool set_init_exit_section(tree decl)
+{
+	gcc_assert(DECL_P(decl));
+
+	if (get_init_exit_section(decl) != NONE)
+		return false;
+
+	if (get_init_exit_section(current_function_decl) == INIT)
+		set_decl_section_name(decl, ".init.rodata.str");
+	else
+		set_decl_section_name(decl, ".exit.rodata.str");
+	return true;
+}
+
+/* Syscalls are always nocapture functions. */
+static bool is_syscall(const_tree fn)
+{
+	const char *name = DECL_NAME_POINTER(fn);
+
+	if (!strncmp(name, "sys_", 4))
+		return true;
+
+	if (!strncmp(name, "sys32_", 6))
+		return true;
+
+	if (!strncmp(name, "compat_sys_", 11))
+		return true;
+
+	return false;
+}
+
+/* These builtins are nocapture functions. */
+static bool allowed_builtins(const_tree fn)
+{
+	const char *name = DECL_NAME_POINTER(fn);
+
+	if (!strcmp(name, "__builtin_va_start"))
+		return true;
+	if (!strcmp(name, "__builtin_expect"))
+		return true;
+	if (!strcmp(name, "__builtin_memcpy"))
+		return true;
+	return false;
+}
+
+static enum attribute_type search_argnum_in_attribute_params(const_tree attr, int fn_arg_num, int fntype_arg_len)
+{
+	const_tree attr_val;
+
+	for (attr_val = TREE_VALUE(attr); attr_val; attr_val = TREE_CHAIN(attr_val)) {
+		int attr_arg_val;
+
+		if (TREE_CODE(TREE_VALUE(attr_val)) == IDENTIFIER_NODE)
+			continue;
+
+		attr_arg_val = (int)abs(tree_to_shwi(TREE_VALUE(attr_val)));
+		if (attr_arg_val == fn_arg_num)
+			return NOCAPTURE;
+		if (attr_arg_val > fntype_arg_len && fn_arg_num >= attr_arg_val)
+			return NOCAPTURE;
+	}
+	return NONE_ATTRIBUTE;
+}
+
+/* Check that fn_arg_num is a nocapture argument, handle cloned functions too. */
+static enum attribute_type lookup_nocapture_argument(const_tree fndecl, const_tree attr, int fn_arg_num, int fntype_arg_len)
+{
+	const_tree orig_decl, clone_arg, orig_arg;
+	tree decl_list, orig_decl_list;
+	enum attribute_type orig_attribute;
+	struct cgraph_node *node = cgraph_get_node(fndecl);
+
+	orig_attribute = search_argnum_in_attribute_params(attr, fn_arg_num, fntype_arg_len);
+	if (orig_attribute == NONE_ATTRIBUTE)
+		return orig_attribute;
+
+	gcc_assert(node);
+	if (node->clone_of && node->clone.tree_map)
+		gcc_assert(!node->clone.args_to_skip);
+
+	if (!DECL_ARTIFICIAL(fndecl) && DECL_ABSTRACT_ORIGIN(fndecl) == NULL_TREE)
+		return orig_attribute;
+
+	orig_decl = DECL_ABSTRACT_ORIGIN(fndecl);
+	gcc_assert(orig_decl != NULL_TREE);
+
+	decl_list = DECL_ARGUMENTS(fndecl);
+	orig_decl_list = DECL_ARGUMENTS(orig_decl);
+
+	if (decl_list == NULL_TREE || orig_decl_list == NULL_TREE)
+		return NONE_ATTRIBUTE;
+
+	if (list_length(decl_list) == list_length(orig_decl_list))
+		return orig_attribute;
+
+	clone_arg = chain_index(fn_arg_num - 1, decl_list);
+	gcc_assert(clone_arg != NULL_TREE);
+
+	orig_arg = chain_index(fn_arg_num - 1, orig_decl_list);
+	gcc_assert(orig_arg != NULL_TREE);
+
+	if (!strcmp(DECL_NAME_POINTER(clone_arg), DECL_NAME_POINTER(orig_arg)))
+		return orig_attribute;
+	return NONE_ATTRIBUTE;
+}
+
+/* Check whether the function argument is nocapture. */
+static enum attribute_type is_fndecl_nocapture_arg(const_tree fndecl, int fn_arg_num)
+{
+	int fntype_arg_len;
+	const_tree type, attr = NULL_TREE;
+	bool fnptr = FUNCTION_PTR_P(fndecl);
+
+	if (!fnptr && is_syscall(fndecl))
+		return SYSCALL;
+
+	if (!fnptr && DECL_BUILT_IN(fndecl) && allowed_builtins(fndecl))
+		return BUILTINS;
+
+	if (fnptr)
+		type = TREE_TYPE(TREE_TYPE(fndecl));
+	else
+		type = TREE_TYPE(fndecl);
+
+	fntype_arg_len = type_num_arguments(type);
+
+	if (!fnptr)
+		attr = lookup_attribute("unverified_nocapture", DECL_ATTRIBUTES(fndecl));
+	if (attr != NULL_TREE && lookup_nocapture_argument(fndecl, attr, fn_arg_num, fntype_arg_len) != NONE_ATTRIBUTE)
+		return UNVERIFIED;
+
+	attr = lookup_attribute("format", TYPE_ATTRIBUTES(type));
+	if (attr != NULL_TREE && lookup_nocapture_argument(fndecl, attr, fn_arg_num, fntype_arg_len) != NONE_ATTRIBUTE)
+		return PRINTF;
+
+	if (fnptr)
+		return NONE_ATTRIBUTE;
+
+	attr = lookup_attribute("nocapture", DECL_ATTRIBUTES(fndecl));
+	if (attr == NULL_TREE)
+		return NONE_ATTRIBUTE;
+
+	if (TREE_VALUE(attr) == NULL_TREE)
+		return NOCAPTURE;
+
+	return lookup_nocapture_argument(fndecl, attr, fn_arg_num, fntype_arg_len);
+}
+
+/* Check whether arg_num is a nocapture argument that can be returned. */
+static bool is_negative_nocapture_arg(const_tree fndecl, int arg_num)
+{
+	const_tree attr, attr_val;
+
+	gcc_assert(arg_num <= 0);
+
+	if (FUNCTION_PTR_P(fndecl))
+		return false;
+
+	attr = lookup_attribute("nocapture", DECL_ATTRIBUTES(fndecl));
+	if (attr == NULL_TREE)
+		return false;
+
+	for (attr_val = TREE_VALUE(attr); attr_val; attr_val = TREE_CHAIN(attr_val)) {
+		int attr_arg_val;
+
+		if (arg_num == 0 && tree_int_cst_lt(TREE_VALUE(attr_val), integer_zero_node))
+			return true;
+
+		attr_arg_val = (int)tree_to_shwi(TREE_VALUE(attr_val));
+		if (attr_arg_val == arg_num)
+			return true;
+	}
+
+	return false;
+}
+
+static bool is_same_vardecl(const_tree op, const_tree vardecl)
+{
+	const_tree decl;
+
+	if (op == vardecl)
+		return true;
+	if (TREE_CODE(op) == SSA_NAME)
+		decl = SSA_NAME_VAR(op);
+	else
+		decl = op;
+
+	if (decl == NULL_TREE || !DECL_P(decl))
+		return false;
+
+	if (TREE_CODE(decl) != TREE_CODE(vardecl))
+		return false;
+
+	return DECL_NAME(decl) && !strcmp(DECL_NAME_POINTER(decl), DECL_NAME_POINTER(vardecl));
+}
+
+static bool search_same_vardecl(const_tree value, const_tree vardecl)
+{
+	int i;
+
+	for (i = 0; i < TREE_OPERAND_LENGTH(value); i++) {
+		const_tree op = TREE_OPERAND(value, i);
+
+		if (op == NULL_TREE)
+			continue;
+		if (is_same_vardecl(op, vardecl))
+			return true;
+		if (search_same_vardecl(op, vardecl))
+			return true;
+	}
+	return false;
+}
+
+static bool check_constructor(const_tree constructor, const_tree vardecl)
+{
+	unsigned HOST_WIDE_INT cnt __unused;
+	tree value;
+
+	FOR_EACH_CONSTRUCTOR_VALUE(CONSTRUCTOR_ELTS(constructor), cnt, value) {
+		if (TREE_CODE(value) == CONSTRUCTOR)
+			return check_constructor(value, vardecl);
+		if (is_gimple_constant(value))
+			continue;
+
+		gcc_assert(TREE_OPERAND_LENGTH(value) > 0);
+		if (search_same_vardecl(value, vardecl))
+			return true;
+	}
+	return false;
+}
+
+static bool compare_ops(const_tree vardecl, tree op)
+{
+	if (TREE_CODE(op) == TREE_LIST)
+		op = TREE_VALUE(op);
+	if (TREE_CODE(op) == SSA_NAME)
+		op = SSA_NAME_VAR(op);
+	if (op == NULL_TREE)
+		return false;
+
+	switch (TREE_CODE_CLASS(TREE_CODE(op))) {
+	case tcc_declaration:
+		return is_same_vardecl(op, vardecl);
+
+	case tcc_exceptional:
+		return check_constructor(op, vardecl);
+
+	case tcc_constant:
+	case tcc_statement:
+	case tcc_comparison:
+		return false;
+
+	default:
+		break;
+	}
+
+	gcc_assert(TREE_OPERAND_LENGTH(op) > 0);
+	return search_same_vardecl(op, vardecl);
+}
+
+static bool is_stmt_nocapture_arg(const gcall *stmt, int arg_num)
+{
+	tree fndecl;
+
+	fndecl = gimple_call_fndecl(stmt);
+	if (fndecl == NULL_TREE)
+		fndecl = gimple_call_fn(stmt);
+
+	gcc_assert(fndecl != NULL_TREE);
+	if (is_fndecl_nocapture_arg(fndecl, arg_num) != NONE_ATTRIBUTE)
+		return true;
+
+	/*
+	 * These are potentially nocapture functions that must be checked
+	 *  manually.
+	 */
+	if (print_missing_attr)
+		inform(gimple_location(stmt), "nocapture attribute is missing (fn: %E, arg: %u)\n", fndecl, arg_num);
+	return false;
+}
+
+/* Find the argument position of arg. */
+static int get_arg_num(const gcall *call, const_tree arg)
+{
+	int idx;
+
+	for (idx = 0; idx < (int)gimple_call_num_args(call); idx++) {
+		const_tree cur_arg = gimple_call_arg(call, idx);
+
+		if (cur_arg == arg)
+			return idx + 1;
+	}
+
+	debug_tree(arg);
+	debug_gimple_stmt(call);
+	gcc_unreachable();
+}
+
+/* Determine if the variable uses are only in nocapture functions. */
+static bool only_nocapture_call(const_tree decl)
+{
+	struct cgraph_edge *e;
+	struct cgraph_node *caller;
+	bool has_call = false;
+
+	gcc_assert(TREE_CODE(decl) == VAR_DECL);
+
+	caller = cgraph_get_node(current_function_decl);
+	for (e = caller->callees; e; e = e->next_callee) {
+		int idx;
+		const gcall *call = as_a_const_gcall(e->call_stmt);
+
+		for (idx = 0; idx < (int)gimple_call_num_args(call); idx++) {
+			const_tree arg = gimple_call_arg(call, idx);
+
+			if (TREE_CODE(arg) != ADDR_EXPR)
+				continue;
+			if (TREE_OPERAND(arg, 0) != decl)
+				continue;
+
+			has_call = true;
+			if (!is_stmt_nocapture_arg(call, idx + 1))
+				return false;
+		}
+	}
+
+	gcc_assert(has_call);
+	return has_call;
+}
+
+/* Determine if all uses of a va_format typed variable are nocapture. */
+static bool is_va_format_use_nocapture(const_tree node)
+{
+	const_tree decl, type;
+
+	if (TREE_CODE(node) != COMPONENT_REF)
+		return false;
+
+	decl = TREE_OPERAND(node, 0);
+	type = TREE_TYPE(decl);
+	gcc_assert(TREE_CODE(type) == RECORD_TYPE);
+
+	if (!TYPE_NAME(type) || strcmp(TYPE_NAME_POINTER(type), "va_format"))
+		return false;
+
+	return only_nocapture_call(decl);
+}
+
+/* If there is a cast to integer (from const char) then it is a nocapture data flow */
+static bool is_cast_to_integer_type(gassign *assign)
+{
+	const_tree lhs_type, lhs;
+
+	if (!gimple_assign_cast_p(assign))
+		return false;
+
+	lhs = gimple_assign_rhs1(assign);
+	lhs_type = TREE_TYPE(lhs);
+	return TYPE_MODE(lhs_type) != QImode;
+}
+
+/* Search the uses of a return value. */
+static bool is_return_value_captured(gimple_set *visited_defs, const gcall *call)
+{
+	tree ret = gimple_call_lhs(call);
+
+	gcc_assert(ret != NULL_TREE);
+	return search_capture_ssa_use(visited_defs, ret);
+}
+
+/* Check if arg_num is a nocapture argument. */
+static bool is_call_arg_nocapture(gimple_set *visited_defs, const gcall *call, int arg_num)
+{
+	tree fndecl = gimple_call_fndecl(call);
+
+	if (fndecl == NULL_TREE)
+		fndecl = gimple_call_fn(call);
+	gcc_assert(fndecl != NULL_TREE);
+
+	if (is_negative_nocapture_arg(fndecl, -arg_num) && is_return_value_captured(visited_defs, call))
+		return false;
+
+	return is_stmt_nocapture_arg(call, arg_num);
+}
+
+/* Determine whether the function has at least one nocapture argument. */
+static bool has_nocapture_param(const_tree fndecl)
+{
+	const_tree attr;
+
+	if (fndecl == NULL_TREE)
+		return false;
+
+	if (is_syscall(fndecl))
+		return true;
+
+	attr = lookup_attribute("nocapture", DECL_ATTRIBUTES(fndecl));
+	if (attr == NULL_TREE)
+		attr = lookup_attribute("format", TYPE_ATTRIBUTES(TREE_TYPE(fndecl)));
+	return attr != NULL_TREE;
+}
+
+static void walk_def_stmt(bool *has_capture_use, gimple_set *visited, tree node)
+{
+	gimple def_stmt;
+	const_tree parm_decl;
+
+	if (*has_capture_use)
+		return;
+
+	if (TREE_CODE(node) != SSA_NAME)
+		goto true_out;
+
+	parm_decl = SSA_NAME_VAR(node);
+	if (parm_decl != NULL_TREE && TREE_CODE(parm_decl) == PARM_DECL)
+		return;
+
+	def_stmt = initify_get_def_stmt(node);
+	if (pointer_set_insert(visited, def_stmt))
+		return;
+
+	switch (gimple_code(def_stmt)) {
+	case GIMPLE_CALL: {
+		tree fndecl = gimple_call_fndecl(def_stmt);
+
+		if (fndecl == NULL_TREE)
+			fndecl = gimple_call_fn(def_stmt);
+
+		gcc_assert(fndecl != NULL_TREE);
+		if (has_nocapture_param(fndecl))
+			goto true_out;
+		return;
+	}
+
+	case GIMPLE_ASM:
+	case GIMPLE_ASSIGN:
+		goto true_out;
+
+	case GIMPLE_NOP:
+		return;
+
+	case GIMPLE_PHI: {
+		unsigned int i;
+
+		for (i = 0; i < gimple_phi_num_args(def_stmt); i++) {
+			tree arg = gimple_phi_arg_def(def_stmt, i);
+
+			walk_def_stmt(has_capture_use, visited, arg);
+		}
+		return;
+	}
+
+	default:
+		debug_gimple_stmt(def_stmt);
+		error("%s: unknown gimple code", __func__);
+		gcc_unreachable();
+	}
+	gcc_unreachable();
+
+true_out:
+	*has_capture_use = true;
+}
+
+static bool search_return_capture_use(const greturn *ret_stmt)
+{
+	gimple_set *def_visited;
+	tree ret;
+	bool has_capture_use;
+
+	if (is_negative_nocapture_arg(current_function_decl, 0))
+		return false;
+
+	def_visited = pointer_set_create();
+	ret = gimple_return_retval(ret_stmt);
+	has_capture_use = false;
+	walk_def_stmt(&has_capture_use, def_visited, ret);
+	pointer_set_destroy(def_visited);
+
+	return has_capture_use;
+}
+
+static bool lhs_is_a_nocapture_parm_decl(const_tree lhs)
+{
+	int arg_idx, len;
+	tree arg_list;
+
+	if (TREE_CODE(lhs) != PARM_DECL)
+		return false;
+
+	arg_list = DECL_ARGUMENTS(current_function_decl);
+	len = list_length(arg_list);
+
+	for (arg_idx = 0; arg_idx < len; arg_idx++) {
+		const_tree arg = chain_index(arg_idx, arg_list);
+
+		if (arg == lhs)
+			return is_fndecl_nocapture_arg(current_function_decl, arg_idx + 1) != NONE_ATTRIBUTE;
+	}
+
+	debug_tree(current_function_decl);
+	debug_tree(lhs);
+	gcc_unreachable();
+}
+
+static void has_capture_use_ssa_var(bool *has_capture_use, gimple_set *visited_defs, tree_set *use_visited, tree node)
+{
+	imm_use_iterator imm_iter;
+	use_operand_p use_p;
+
+	if (pointer_set_insert(use_visited, node))
+		return;
+
+	if (*has_capture_use)
+		return;
+
+	if (is_va_format_use_nocapture(node))
+		return;
+
+	if (lhs_is_a_nocapture_parm_decl(node))
+		return;
+
+	if (TREE_CODE(node) != SSA_NAME)
+		goto true_out;
+
+	FOR_EACH_IMM_USE_FAST(use_p, imm_iter, node) {
+		gimple use_stmt = USE_STMT(use_p);
+
+		if (use_stmt == NULL)
+			return;
+		if (is_gimple_debug(use_stmt))
+			continue;
+
+		if (pointer_set_insert(visited_defs, use_stmt))
+			continue;
+
+		switch (gimple_code(use_stmt)) {
+		case GIMPLE_COND:
+		case GIMPLE_SWITCH:
+			return;
+
+		case GIMPLE_ASM:
+			goto true_out;
+
+		case GIMPLE_CALL: {
+			const gcall *call = as_a_const_gcall(use_stmt);
+			int arg_num = get_arg_num(call, node);
+
+			if (is_call_arg_nocapture(visited_defs, call, arg_num))
+				return;
+			goto true_out;
+		}
+
+		case GIMPLE_ASSIGN: {
+			tree lhs;
+			gassign *assign = as_a_gassign(use_stmt);
+			const_tree rhs = gimple_assign_rhs1(assign);
+
+			if (TREE_CODE(rhs) == INDIRECT_REF)
+				return;
+#if BUILDING_GCC_VERSION >= 4006
+			if (TREE_CODE(rhs) == MEM_REF)
+				return;
+#endif
+			if (is_cast_to_integer_type(assign))
+				return;
+
+			lhs = gimple_assign_lhs(assign);
+			has_capture_use_ssa_var(has_capture_use, visited_defs, use_visited, lhs);
+			return;
+		}
+
+		case GIMPLE_PHI: {
+			tree result = gimple_phi_result(use_stmt);
+
+			has_capture_use_ssa_var(has_capture_use, visited_defs, use_visited, result);
+			return;
+		}
+
+		case GIMPLE_RETURN:
+			if (search_return_capture_use(as_a_const_greturn(use_stmt)))
+				goto true_out;
+			return;
+
+		default:
+			debug_tree(node);
+			debug_gimple_stmt(use_stmt);
+			gcc_unreachable();
+		}
+	}
+	return;
+
+true_out:
+	*has_capture_use = true;
+}
+
+static bool search_capture_ssa_use(gimple_set *visited_defs, tree node)
+{
+	tree_set *use_visited;
+	bool has_capture_use = false;
+
+	use_visited = tree_pointer_set_create();
+	has_capture_use_ssa_var(&has_capture_use, visited_defs, use_visited, node);
+	pointer_set_destroy(use_visited);
+
+	return has_capture_use;
+}
+
+static bool search_capture_use(const_tree vardecl, gimple stmt)
+{
+	unsigned int i;
+	gimple_set *visited_defs = pointer_set_create();
+
+	for (i = 0; i < gimple_num_ops(stmt); i++) {
+		int arg_num;
+		tree op = *(gimple_op_ptr(stmt, i));
+
+		if (op == NULL_TREE)
+			continue;
+		if (is_gimple_constant(op))
+			continue;
+
+		if (!compare_ops(vardecl, op))
+			continue;
+
+		switch (gimple_code(stmt)) {
+		case GIMPLE_COND:
+			break;
+
+		case GIMPLE_ASM:
+			gcc_assert(get_init_exit_section(vardecl) == NONE);
+			goto true_out;
+
+		case GIMPLE_CALL:
+			if (i == 0)
+				break;
+			/* return, fndecl */
+			gcc_assert(i >= 3);
+			arg_num = i - 2;
+
+			if (is_call_arg_nocapture(visited_defs, as_a_const_gcall(stmt), arg_num))
+				break;
+			goto true_out;
+
+		case GIMPLE_ASSIGN: {
+			tree lhs;
+			const_tree rhs = gimple_assign_rhs1(stmt);
+
+			if (TREE_CODE(rhs) == INDIRECT_REF)
+				break;
+#if BUILDING_GCC_VERSION >= 4006
+			if (TREE_CODE(rhs) == MEM_REF)
+				break;
+#endif
+
+			lhs = gimple_assign_lhs(stmt);
+			if (lhs_is_a_nocapture_parm_decl(lhs))
+				break;
+
+			if (!search_capture_ssa_use(visited_defs, lhs))
+				break;
+			gcc_assert(get_init_exit_section(vardecl) == NONE);
+			goto true_out;
+		}
+
+		case GIMPLE_RETURN:
+			if (search_return_capture_use(as_a_const_greturn(stmt)))
+				goto true_out;
+			break;
+		default:
+			debug_tree(vardecl);
+			debug_gimple_stmt(stmt);
+			gcc_unreachable();
+		}
+	}
+
+	pointer_set_destroy(visited_defs);
+	return false;
+
+true_out:
+	pointer_set_destroy(visited_defs);
+	return true;
+
+}
+
+/* Check all initialized local variables for nocapture uses. */
+static bool is_in_capture_init(const_tree vardecl)
+{
+	unsigned int i __unused;
+	tree var;
+
+	if (TREE_CODE(vardecl) == PARM_DECL)
+		return false;
+
+	FOR_EACH_LOCAL_DECL(cfun, i, var) {
+		const_tree type, initial = DECL_INITIAL(var);
+
+		if (DECL_EXTERNAL(var))
+			continue;
+		if (initial == NULL_TREE)
+			continue;
+		if (TREE_CODE(initial) != CONSTRUCTOR)
+			continue;
+
+		type = TREE_TYPE(var);
+		gcc_assert(TREE_CODE(type) == RECORD_TYPE || DECL_P(var));
+		if (check_constructor(initial, vardecl))
+			return true;
+	}
+	return false;
+}
+
+static bool has_capture_use_local_var(const_tree vardecl)
+{
+	basic_block bb;
+	enum tree_code code = TREE_CODE(vardecl);
+
+	gcc_assert(code == VAR_DECL || code == PARM_DECL);
+
+	if (is_in_capture_init(vardecl))
+		return true;
+
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			if (search_capture_use(vardecl, gsi_stmt(gsi)))
+				return true;
+		}
+	}
+
+	return false;
+}
+
+/* Search local variables that have only nocapture uses. */
+static void find_local_str(void)
+{
+	unsigned int i __unused;
+	tree var;
+
+	FOR_EACH_LOCAL_DECL(cfun, i, var) {
+		tree str, init_val;
+
+		if (TREE_CODE(TREE_TYPE(var)) != ARRAY_TYPE)
+			continue;
+
+		init_val = DECL_INITIAL(var);
+		if (init_val == NULL_TREE || init_val == error_mark_node)
+			continue;
+		if (TREE_CODE(init_val) != STRING_CST)
+			continue;
+
+		if (has_capture_use_local_var(var))
+			continue;
+
+		str = get_string_cst(init_val);
+		gcc_assert(str);
+
+		if (set_init_exit_section(var) && verbose)
+			inform(DECL_SOURCE_LOCATION(var), "initified local var: %s: %s", DECL_NAME_POINTER(current_function_decl), TREE_STRING_POINTER(str));
+	}
+}
+
+static tree create_decl(tree node)
+{
+	tree str, decl, type, name, type_type;
+	location_t loc;
+
+	str = get_string_cst(node);
+	type = TREE_TYPE(str);
+	gcc_assert(TREE_CODE(type) == ARRAY_TYPE);
+
+	type_type = TREE_TYPE(type);
+	gcc_assert(type_type != NULL_TREE && TREE_CODE(type_type) == INTEGER_TYPE);
+
+	name = create_tmp_var_name("initify");
+	loc = DECL_SOURCE_LOCATION(current_function_decl);
+	decl = build_decl(loc, VAR_DECL, name, type);
+
+	DECL_INITIAL(decl) = str;
+	DECL_CONTEXT(decl) = current_function_decl;
+	DECL_ARTIFICIAL(decl) = 1;
+
+	TREE_STATIC(decl) = 1;
+	TREE_READONLY(decl) = 1;
+	TREE_ADDRESSABLE(decl) = 1;
+	TREE_USED(decl) = 1;
+
+	add_referenced_var(decl);
+	add_local_decl(cfun, decl);
+
+	varpool_add_new_variable(decl);
+	varpool_mark_needed_node(varpool_node(decl));
+
+	DECL_CHAIN(decl) = BLOCK_VARS(DECL_INITIAL(current_function_decl));
+	BLOCK_VARS(DECL_INITIAL(current_function_decl)) = decl;
+
+	return build_fold_addr_expr_loc(loc, decl);
+}
+
+static void set_section_call_assign(gimple stmt, tree node, unsigned int num)
+{
+	tree decl;
+
+	decl = create_decl(node);
+
+	switch (gimple_code(stmt)) {
+	case GIMPLE_ASSIGN:
+		gcc_assert(gimple_num_ops(stmt) == 2);
+		gimple_assign_set_rhs1(stmt, decl);
+		break;
+
+	case GIMPLE_CALL:
+		gimple_call_set_arg(stmt, num, decl);
+		break;
+
+	default:
+		debug_gimple_stmt(stmt);
+		error("%s: unknown gimple code", __func__);
+		gcc_unreachable();
+	}
+
+	update_stmt(stmt);
+
+	if (set_init_exit_section(TREE_OPERAND(decl, 0)) && verbose)
+		inform(gimple_location(stmt), "initified function arg: %E: [%E]", current_function_decl, get_string_cst(node));
+}
+
+static tree initify_create_new_var(tree type)
+{
+	tree new_var = create_tmp_var(type, "initify");
+
+	add_referenced_var(new_var);
+	mark_sym_for_renaming(new_var);
+	return new_var;
+}
+
+static void initify_create_new_phi_arg(gimple_set *visited_defs, tree ssa_var, gphi *stmt, unsigned int i)
+{
+	gassign *assign;
+	gimple_stmt_iterator gsi;
+	basic_block arg_bb;
+	tree decl, arg;
+	const_tree str;
+	location_t loc;
+
+	arg = gimple_phi_arg_def(stmt, i);
+
+	if (search_capture_ssa_use(visited_defs, arg))
+		return;
+
+	decl = create_decl(arg);
+
+	assign = gimple_build_assign(ssa_var, decl);
+
+	arg_bb = gimple_phi_arg_edge(stmt, i)->src;
+	gcc_assert(arg_bb->index != 0);
+
+	gsi = gsi_after_labels(arg_bb);
+	gsi_insert_before(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+
+	if (!set_init_exit_section(TREE_OPERAND(decl, 0)) || !verbose)
+		return;
+
+	loc = gimple_location(stmt);
+	str = get_string_cst(arg);
+	inform(loc, "initified local var, phi arg: %E: [%E]", current_function_decl, str);
+}
+
+static void set_section_phi(bool *has_str_cst, gimple_set *visited, gphi *stmt)
+{
+	tree result, ssa_var;
+	unsigned int i;
+
+	result = gimple_phi_result(stmt);
+	ssa_var = initify_create_new_var(TREE_TYPE(result));
+
+	for (i = 0; i < gimple_phi_num_args(stmt); i++) {
+		tree arg = gimple_phi_arg_def(stmt, i);
+
+		if (get_string_cst(arg) == NULL_TREE)
+			search_constant_strings(has_str_cst, visited, arg);
+		else
+			initify_create_new_phi_arg(visited, ssa_var, stmt, i);
+	}
+}
+
+static void search_constant_strings(bool *has_str_cst, gimple_set *visited, tree node)
+{
+	gimple def_stmt;
+	const_tree parm_decl;
+
+	if (!*has_str_cst)
+		return;
+
+	if (TREE_CODE(node) != SSA_NAME)
+		goto false_out;
+
+	parm_decl = SSA_NAME_VAR(node);
+	if (parm_decl != NULL_TREE && TREE_CODE(parm_decl) == PARM_DECL)
+		goto false_out;
+
+	def_stmt = initify_get_def_stmt(node);
+	if (pointer_set_insert(visited, def_stmt))
+		return;
+
+	switch (gimple_code(def_stmt)) {
+	case GIMPLE_NOP:
+	case GIMPLE_CALL:
+	case GIMPLE_ASM:
+	case GIMPLE_RETURN:
+		goto false_out;
+
+	case GIMPLE_PHI:
+		set_section_phi(has_str_cst, visited, as_a_gphi(def_stmt));
+		return;
+
+	case GIMPLE_ASSIGN: {
+		tree rhs1, str;
+
+		if (gimple_num_ops(def_stmt) != 2)
+			goto false_out;
+
+		rhs1 = gimple_assign_rhs1(def_stmt);
+		search_constant_strings(has_str_cst, visited, rhs1);
+		if (!*has_str_cst)
+			return;
+
+		if (search_capture_ssa_use(visited, node))
+			goto false_out;
+
+		str = get_string_cst(rhs1);
+		gcc_assert(str != NULL_TREE);
+		set_section_call_assign(def_stmt, rhs1, 0);
+		return;
+	}
+
+	default:
+		debug_gimple_stmt(def_stmt);
+		error("%s: unknown gimple code", __func__);
+		gcc_unreachable();
+	}
+	gcc_unreachable();
+
+false_out:
+	*has_str_cst = false;
+}
+
+/* Search constant strings assigned to variables. */
+static void search_var_param(gcall *stmt)
+{
+	int num;
+	gimple_set *visited = pointer_set_create();
+
+	pointer_set_insert(visited, stmt);
+
+	for (num = 0; num < (int)gimple_call_num_args(stmt); num++) {
+		const_tree type, fndecl;
+		bool has_str_cst = true;
+		tree str, arg = gimple_call_arg(stmt, num);
+
+		str = get_string_cst(arg);
+		if (str != NULL_TREE)
+			continue;
+
+		if (TREE_CODE(TREE_TYPE(arg)) != POINTER_TYPE)
+			continue;
+		type = TREE_TYPE(TREE_TYPE(arg));
+		if (!TYPE_STRING_FLAG(type))
+			continue;
+
+		fndecl = gimple_call_fndecl(stmt);
+		if (is_negative_nocapture_arg(fndecl, -(num + 1)) && is_return_value_captured(visited, stmt))
+			continue;
+
+		if (is_fndecl_nocapture_arg(fndecl, num + 1) != NONE_ATTRIBUTE)
+			search_constant_strings(&has_str_cst, visited, arg);
+	}
+
+	pointer_set_destroy(visited);
+}
+
+/* Search constant strings passed as arguments. */
+static void search_str_param(gcall *stmt)
+{
+	int num;
+	gimple_set *visited = pointer_set_create();
+
+	pointer_set_insert(visited, stmt);
+
+	for (num = 0; num < (int)gimple_call_num_args(stmt); num++) {
+		const_tree fndecl;
+		tree str, arg = gimple_call_arg(stmt, num);
+
+		str = get_string_cst(arg);
+		if (str == NULL_TREE)
+			continue;
+
+		fndecl = gimple_call_fndecl(stmt);
+		if (is_negative_nocapture_arg(fndecl, -(num + 1)) && is_return_value_captured(visited, stmt))
+			continue;
+
+		if (is_fndecl_nocapture_arg(fndecl, num + 1) != NONE_ATTRIBUTE)
+			set_section_call_assign(stmt, arg, num);
+	}
+
+	pointer_set_destroy(visited);
+}
+
+/* Search constant strings in arguments of nocapture functions. */
+static void search_const_strs(void)
+{
+	basic_block bb;
+
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			gcall *call_stmt;
+			gimple stmt = gsi_stmt(gsi);
+
+			if (!is_gimple_call(stmt))
+				continue;
+
+			call_stmt = as_a_gcall(stmt);
+			if (!has_nocapture_param(gimple_call_fndecl(call_stmt)))
+				continue;
+			search_str_param(call_stmt);
+			search_var_param(call_stmt);
+		}
+	}
+}
+
+/*
+ * Verify the data flows of the uses of function arguments marked by the nocapture attribute.
+ * The printf attribute is ignored temporarily.
+ */
+static void verify_nocapture_functions(void)
+{
+	int i, len;
+	tree arg_list;
+
+	if (disable_verify_nocapture_functions)
+		return;
+
+	if (is_syscall(current_function_decl))
+		return;
+
+	if (!has_nocapture_param(current_function_decl))
+		return;
+
+	arg_list = DECL_ARGUMENTS(current_function_decl);
+	len = list_length(arg_list);
+	for (i = 0; i < len; i++) {
+		const_tree arg;
+
+		if (is_fndecl_nocapture_arg(current_function_decl, i + 1) != NOCAPTURE)
+			continue;
+
+		arg = chain_index(i, arg_list);
+		gcc_assert(arg != NULL_TREE);
+
+		if (has_capture_use_local_var(arg))
+			warning(0, "%qE captures its %u (%qD) parameter, please remove it from the nocapture attribute.", current_function_decl, i + 1, arg);
+	}
+}
+
+/* Find and move constant strings to the proper init or exit read-only data section. */
+static unsigned int initify_function_transform(struct cgraph_node *node __unused)
+{
+	verify_nocapture_functions();
+
+	if (get_init_exit_section(current_function_decl) == NONE)
+		return 0;
+
+	find_local_str();
+	search_const_strs();
+
+	return TODO_dump_func | TODO_verify_ssa | TODO_verify_stmts
+		| TODO_remove_unused_locals | TODO_cleanup_cfg
+		| TODO_ggc_collect | TODO_verify_flow | TODO_update_ssa;
+}
+
+static void __unused debug_print_section_type(struct cgraph_node *node)
+{
+	enum section_type section;
+
+	section = (enum section_type)(unsigned long)NODE_SYMBOL(node)->aux;
+	switch (section) {
+	case INIT:
+		fprintf(stderr, "init\n");
+		break;
+
+	case EXIT:
+		fprintf(stderr, "exit\n");
+		break;
+
+	case BOTH:
+		fprintf(stderr, "init and exit\n");
+		break;
+
+	case NONE:
+		fprintf(stderr, "none\n");
+		break;
+	}
+}
+
+static bool has_non_init_caller(struct cgraph_node *callee)
+{
+	struct cgraph_edge *e = callee->callers;
+
+	if (!e)
+		return true;
+
+	for (; e; e = e->next_caller) {
+		enum section_type caller_section;
+		struct cgraph_node *caller = e->caller;
+
+		caller_section = get_init_exit_section(NODE_DECL(caller));
+		if (caller_section == NONE && NODE_SYMBOL(caller)->aux == (void *)NONE)
+			return true;
+	}
+
+	return false;
+}
+
+static void has_non_init_clone(struct cgraph_node *node, bool *has_non_init)
+{
+	if (*has_non_init)
+		return;
+
+	if (has_non_init_caller(node))
+		*has_non_init = true;
+
+	if (node->clones)
+		has_non_init_clone(node->clones, has_non_init);
+	if (node->clone_of)
+		has_non_init_clone(node->clone_of, has_non_init);
+}
+
+/*
+ * If the function is called by only __init/__exit functions then it can become
+ * an __init/__exit function as well.
+ */
+static bool should_init_exit(struct cgraph_node *callee)
+{
+	bool has_non_init;
+	const_tree callee_decl = NODE_DECL(callee);
+
+	if (NODE_SYMBOL(callee)->aux != (void *)NONE)
+		return false;
+	if (get_init_exit_section(callee_decl) != NONE)
+		return false;
+
+	/* If gcc isn't in LTO mode then we can handle only static functions. */
+	if (!in_lto_p && TREE_PUBLIC(callee_decl))
+		return false;
+
+	if (NODE_SYMBOL(callee)->address_taken)
+		return false;
+
+	has_non_init = false;
+	has_non_init_clone(callee, &has_non_init);
+	return !has_non_init;
+}
+
+static bool inherit_section(struct cgraph_node *callee, struct cgraph_node *caller, enum section_type caller_section)
+{
+	enum section_type callee_section;
+
+	if (caller_section == NONE)
+		caller_section = (enum section_type)(unsigned long)NODE_SYMBOL(caller)->aux;
+
+	callee_section = (enum section_type)(unsigned long)NODE_SYMBOL(callee)->aux;
+	if (caller_section == INIT && callee_section == EXIT)
+		goto both_section;
+
+	if (caller_section == EXIT && callee_section == INIT)
+		goto both_section;
+
+	if (caller_section == BOTH && (callee_section == INIT || callee_section == EXIT))
+		goto both_section;
+
+	if (!should_init_exit(callee))
+		return false;
+
+	gcc_assert(callee_section == NONE);
+	NODE_SYMBOL(callee)->aux = (void *)caller_section;
+	return true;
+
+both_section:
+	NODE_SYMBOL(callee)->aux = (void *)BOTH;
+	return true;
+}
+
+/*
+ * Try to propagate __init/__exit to callees in __init/__exit functions.
+ * If a function is called by __init and __exit functions as well then it can be
+ * an __exit function at most.
+ */
+static bool search_init_exit_callers(void)
+{
+	struct cgraph_node *node;
+	bool change = false;
+
+	FOR_EACH_FUNCTION(node) {
+		struct cgraph_edge *e;
+		enum section_type section;
+		const_tree cur_fndecl = NODE_DECL(node);
+
+		if (DECL_BUILT_IN(cur_fndecl))
+			continue;
+
+		section = get_init_exit_section(cur_fndecl);
+		if (section == NONE && NODE_SYMBOL(node)->aux == (void *)NONE)
+			continue;
+
+		for (e = node->callees; e; e = e->next_callee) {
+			if (e->callee->global.inlined_to)
+				continue;
+
+			if (inherit_section(e->callee, node, section))
+				change = true;
+		}
+	}
+
+	return change;
+}
+
+/* We can't move functions to the init/exit sections from certain sections. */
+static bool can_move_to_init_exit(const_tree fndecl)
+{
+	const char *section_name = get_decl_section_name(fndecl);
+
+	if (!section_name)
+		return true;
+
+	if (!strcmp(section_name, ".ref.text"))
+		return false;
+
+	if (!strcmp(section_name, ".meminit.text"))
+		return false;
+
+	inform(DECL_SOURCE_LOCATION(fndecl), "Section of %qE: %s\n", fndecl, section_name);
+	gcc_unreachable();
+}
+
+static void move_function_to_init_exit_text(struct cgraph_node *node)
+{
+	const char *section_name;
+	tree id, attr;
+	tree section_str, attr_args, fndecl = NODE_DECL(node);
+
+	/*
+	 * If the function is a candidate for both __init and __exit and enable_init_to_exit_moves is false
+	 * then these functions arent't moved to the exit section.
+	 */
+	if (NODE_SYMBOL(node)->aux == (void *)BOTH) {
+		if (enable_init_to_exit_moves)
+			NODE_SYMBOL(node)->aux = (void *)EXIT;
+		else
+			return;
+	}
+
+	if (NODE_SYMBOL(node)->aux == (void *)NONE)
+		return;
+
+	if (!can_move_to_init_exit(fndecl))
+		return;
+
+	if (verbose) {
+		const char *attr_name;
+		location_t loc = DECL_SOURCE_LOCATION(fndecl);
+
+		attr_name = NODE_SYMBOL(node)->aux == (void *)INIT ? "__init" : "__exit";
+
+		if (in_lto_p && TREE_PUBLIC(fndecl))
+			inform(loc, "%s attribute is missing from the %qE function (public)", attr_name, fndecl);
+
+		if (!in_lto_p && !TREE_PUBLIC(fndecl))
+			inform(loc, "%s attribute is missing from the %qE function (static)", attr_name, fndecl);
+	}
+
+	if (in_lto_p)
+		return;
+
+	/* Add the init/exit section attribute to the function declaration. */
+	DECL_ATTRIBUTES(fndecl) = copy_list(DECL_ATTRIBUTES(fndecl));
+
+	section_name = NODE_SYMBOL(node)->aux == (void *)INIT ? ".init.text" : ".exit.text";
+	section_str = build_const_char_string(strlen(section_name) + 1, section_name);
+	TREE_READONLY(section_str) = 1;
+	TREE_STATIC(section_str) = 1;
+	attr_args = build_tree_list(NULL_TREE, section_str);
+
+	id = get_identifier("__section__");
+	attr = DECL_ATTRIBUTES(fndecl);
+	DECL_ATTRIBUTES(fndecl) = tree_cons(id, attr_args, attr);
+
+#if BUILDING_GCC_VERSION < 5000
+	DECL_SECTION_NAME(fndecl) = section_str;
+#endif
+	set_decl_section_name(fndecl, section_name);
+}
+
+/* Find all functions that can become __init/__exit functions */
+static unsigned int initify_execute(void)
+{
+	struct cgraph_node *node;
+
+	if (!search_init_exit_functions)
+		return 0;
+
+	if (flag_lto && !in_lto_p)
+		return 0;
+
+	FOR_EACH_FUNCTION(node)
+		NODE_SYMBOL(node)->aux = (void *)NONE;
+
+	while (search_init_exit_callers()) {};
+
+	FOR_EACH_FUNCTION(node) {
+		move_function_to_init_exit_text(node);
+
+		NODE_SYMBOL(node)->aux = NULL;
+	}
+
+	return 0;
+}
+
+#define PASS_NAME initify
+#define NO_WRITE_SUMMARY
+#define NO_GENERATE_SUMMARY
+#define NO_READ_SUMMARY
+#define NO_READ_OPTIMIZATION_SUMMARY
+#define NO_WRITE_OPTIMIZATION_SUMMARY
+#define NO_STMT_FIXUP
+#define NO_VARIABLE_TRANSFORM
+#define NO_GATE
+
+#include "gcc-generate-ipa-pass.h"
+
+static unsigned int (*old_section_type_flags)(tree decl, const char *name, int reloc);
+
+static unsigned int initify_section_type_flags(tree decl, const char *name, int reloc)
+{
+	if (!strcmp(name, ".init.rodata.str") || !strcmp(name, ".exit.rodata.str")) {
+		gcc_assert(TREE_CODE(decl) == VAR_DECL);
+		gcc_assert(DECL_INITIAL(decl));
+		gcc_assert(TREE_CODE(DECL_INITIAL(decl)) == STRING_CST);
+
+		return 1 | SECTION_MERGE | SECTION_STRINGS;
+	}
+
+	return old_section_type_flags(decl, name, reloc);
+}
+
+static void initify_start_unit(void __unused *gcc_data, void __unused *user_data)
+{
+	old_section_type_flags = targetm.section_type_flags;
+	targetm.section_type_flags = initify_section_type_flags;
+}
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	int i;
+	const int argc = plugin_info->argc;
+	bool enabled = true;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	const char * const plugin_name = plugin_info->base_name;
+
+	PASS_INFO(initify, "inline", 1, PASS_POS_INSERT_AFTER);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	for (i = 0; i < argc; ++i) {
+		if (!(strcmp(argv[i].key, "disable"))) {
+			enabled = false;
+			continue;
+		}
+		if (!strcmp(argv[i].key, "verbose")) {
+			verbose = true;
+			continue;
+		}
+		if (!strcmp(argv[i].key, "print_missing_attr")) {
+			print_missing_attr = true;
+			continue;
+		}
+		if (!strcmp(argv[i].key, "search_init_exit_functions")) {
+			search_init_exit_functions = true;
+			continue;
+		}
+		if (!strcmp(argv[i].key, "enable_init_to_exit_moves")) {
+			enable_init_to_exit_moves = true;
+			continue;
+		}
+
+		if (!strcmp(argv[i].key, "disable_verify_nocapture_functions")) {
+			disable_verify_nocapture_functions = true;
+			continue;
+		}
+
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &initify_plugin_info);
+	if (enabled) {
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &initify_pass_info);
+		register_callback(plugin_name, PLUGIN_START_UNIT, initify_start_unit, NULL);
+	}
+	register_callback(plugin_name, PLUGIN_ATTRIBUTES, register_attributes, NULL);
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/kallocstat_plugin.c b/scripts/gcc-plugins/kallocstat_plugin.c
new file mode 100644
index 000000000..0a9214dd9
--- /dev/null
+++ b/scripts/gcc-plugins/kallocstat_plugin.c
@@ -0,0 +1,131 @@
+/*
+ * Copyright 2011-2017 by the PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * gcc plugin to find the distribution of k*alloc sizes
+ *
+ * TODO:
+ *
+ * BUGS:
+ * - none known
+ */
+
+#include "gcc-common.h"
+
+__visible int plugin_is_GPL_compatible;
+
+static struct plugin_info kallocstat_plugin_info = {
+	.version	= "201602181345",
+	.help		= NULL
+};
+
+static const char * const kalloc_functions[] = {
+	"__kmalloc",
+	"kmalloc",
+	"kmalloc_large",
+	"kmalloc_node",
+	"kmalloc_order",
+	"kmalloc_order_trace",
+	"kmalloc_slab",
+	"kzalloc",
+	"kzalloc_node",
+};
+
+static bool is_kalloc(const char *fnname)
+{
+	size_t i;
+
+	for (i = 0; i < ARRAY_SIZE(kalloc_functions); i++)
+		if (!strcmp(fnname, kalloc_functions[i]))
+			return true;
+	return false;
+}
+
+static unsigned int kallocstat_execute(void)
+{
+	basic_block bb;
+
+	// 1. loop through BBs and GIMPLE statements
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			// gimple match: 
+			tree fndecl, size;
+			gimple stmt;
+			const char *fnname;
+
+			// is it a call
+			stmt = gsi_stmt(gsi);
+			if (!is_gimple_call(stmt))
+				continue;
+			fndecl = gimple_call_fndecl(stmt);
+			if (fndecl == NULL_TREE)
+				continue;
+			if (TREE_CODE(fndecl) != FUNCTION_DECL)
+				continue;
+
+			// is it a call to k*alloc
+			fnname = DECL_NAME_POINTER(fndecl);
+			if (!is_kalloc(fnname))
+				continue;
+
+			// is the size arg const or the result of a simple const assignment
+			size = gimple_call_arg(stmt, 0);
+			while (true) {
+				expanded_location xloc;
+				size_t size_val;
+
+				if (TREE_CONSTANT(size)) {
+					xloc = expand_location(gimple_location(stmt));
+					if (!xloc.file)
+						xloc = expand_location(DECL_SOURCE_LOCATION(current_function_decl));
+					size_val = TREE_INT_CST_LOW(size);
+					fprintf(stderr, "kallocsize: %8zu %8zx %s %s:%u\n", size_val, size_val, fnname, xloc.file, xloc.line);
+					break;
+				}
+
+				if (TREE_CODE(size) != SSA_NAME)
+					break;
+				stmt = SSA_NAME_DEF_STMT(size);
+//debug_gimple_stmt(stmt);
+//debug_tree(size);
+				if (!stmt || !is_gimple_assign(stmt))
+					break;
+				if (gimple_num_ops(stmt) != 2)
+					break;
+				size = gimple_assign_rhs1(stmt);
+			}
+//print_gimple_stmt(stderr, call_stmt, 0, TDF_LINENO);
+//debug_tree(gimple_call_fn(call_stmt));
+//print_node(stderr, "pax", fndecl, 4);
+		}
+	}
+
+	return 0;
+}
+
+#define PASS_NAME kallocstat
+#define NO_GATE
+#include "gcc-generate-gimple-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	const char * const plugin_name = plugin_info->base_name;
+
+	PASS_INFO(kallocstat, "ssa", 1, PASS_POS_INSERT_AFTER);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &kallocstat_plugin_info);
+	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &kallocstat_pass_info);
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/kernexec_plugin.c b/scripts/gcc-plugins/kernexec_plugin.c
new file mode 100644
index 000000000..1a35a0caa
--- /dev/null
+++ b/scripts/gcc-plugins/kernexec_plugin.c
@@ -0,0 +1,393 @@
+/*
+ * Copyright 2011-2017 by the PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * gcc plugin to make KERNEXEC/amd64 almost as good as it is on i386
+ *
+ * TODO:
+ *
+ * BUGS:
+ * - none known
+ */
+
+#include "gcc-common.h"
+
+__visible int plugin_is_GPL_compatible;
+
+static struct plugin_info kernexec_plugin_info = {
+	.version	= "201607271510",
+	.help		= "method=[bts|or]\tinstrumentation method\n"
+};
+
+static void (*kernexec_instrument_fptr)(gimple_stmt_iterator *);
+static void (*kernexec_instrument_retaddr)(rtx);
+
+/*
+ * add special KERNEXEC instrumentation: reload %r12 after it has been clobbered
+ */
+static void kernexec_reload_fptr_mask(gimple_stmt_iterator *gsi)
+{
+	gimple stmt;
+	gasm *asm_movabs_stmt;
+
+	// build asm volatile("movabs $0x8000000000000000, %%r12\n\t" : : : );
+	stmt = gimple_build_asm_vec("movabs $0x8000000000000000, %%r12\n\t", NULL, NULL, NULL, NULL);
+	asm_movabs_stmt = as_a_gasm(stmt);
+	gimple_asm_set_volatile(asm_movabs_stmt, true);
+	gsi_insert_after(gsi, asm_movabs_stmt, GSI_CONTINUE_LINKING);
+	update_stmt(asm_movabs_stmt);
+}
+
+/*
+ * find all asm() stmts that clobber r12 and add a reload of r12
+ */
+static unsigned int kernexec_reload_execute(void)
+{
+	basic_block bb;
+
+	// 1. loop through BBs and GIMPLE statements
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			// gimple match: __asm__ ("" :  :  : "r12");
+			gimple stmt;
+			gasm *asm_stmt;
+			size_t nclobbers;
+
+			// is it an asm ...
+			stmt = gsi_stmt(gsi);
+			if (gimple_code(stmt) != GIMPLE_ASM)
+				continue;
+
+			asm_stmt = as_a_gasm(stmt);
+
+			// ... clobbering r12
+			nclobbers = gimple_asm_nclobbers(asm_stmt);
+			while (nclobbers--) {
+				tree op = gimple_asm_clobber_op(asm_stmt, nclobbers);
+				if (strcmp(TREE_STRING_POINTER(TREE_VALUE(op)), "r12"))
+					continue;
+				kernexec_reload_fptr_mask(&gsi);
+//print_gimple_stmt(stderr, asm_stmt, 0, TDF_LINENO);
+				break;
+			}
+		}
+	}
+
+	return 0;
+}
+
+/*
+ * add special KERNEXEC instrumentation: force MSB of fptr to 1, which will produce
+ * a non-canonical address from a userland ptr and will just trigger a GPF on dereference
+ */
+static void kernexec_instrument_fptr_bts(gimple_stmt_iterator *gsi)
+{
+	gimple assign_intptr, assign_new_fptr;
+	gcall *call_stmt;
+	tree intptr, orptr, old_fptr, new_fptr, kernexec_mask;
+
+	call_stmt = as_a_gcall(gsi_stmt(*gsi));
+	old_fptr = gimple_call_fn(call_stmt);
+
+	// create temporary unsigned long variable used for bitops and cast fptr to it
+	intptr = create_tmp_var(long_unsigned_type_node, "kernexec_bts");
+	add_referenced_var(intptr);
+	intptr = make_ssa_name(intptr, NULL);
+	assign_intptr = gimple_build_assign(intptr, fold_convert(long_unsigned_type_node, old_fptr));
+	SSA_NAME_DEF_STMT(intptr) = assign_intptr;
+	gsi_insert_before(gsi, assign_intptr, GSI_SAME_STMT);
+	update_stmt(assign_intptr);
+
+	// apply logical or to temporary unsigned long and bitmask
+	kernexec_mask = build_int_cstu(long_long_unsigned_type_node, 0x8000000000000000LL);
+//	kernexec_mask = build_int_cstu(long_long_unsigned_type_node, 0xffffffff80000000LL);
+	orptr = fold_build2(BIT_IOR_EXPR, long_long_unsigned_type_node, intptr, kernexec_mask);
+	intptr = make_ssa_name(SSA_NAME_VAR(intptr), NULL);
+	assign_intptr = gimple_build_assign(intptr, orptr);
+	SSA_NAME_DEF_STMT(intptr) = assign_intptr;
+	gsi_insert_before(gsi, assign_intptr, GSI_SAME_STMT);
+	update_stmt(assign_intptr);
+
+	// cast temporary unsigned long back to a temporary fptr variable
+	new_fptr = create_tmp_var(TREE_TYPE(old_fptr), "kernexec_fptr");
+	add_referenced_var(new_fptr);
+	new_fptr = make_ssa_name(new_fptr, NULL);
+	assign_new_fptr = gimple_build_assign(new_fptr, fold_convert(TREE_TYPE(old_fptr), intptr));
+	SSA_NAME_DEF_STMT(new_fptr) = assign_new_fptr;
+	gsi_insert_before(gsi, assign_new_fptr, GSI_SAME_STMT);
+	update_stmt(assign_new_fptr);
+
+	// replace call stmt fn with the new fptr
+	gimple_call_set_fn(call_stmt, new_fptr);
+	update_stmt(call_stmt);
+}
+
+static void kernexec_instrument_fptr_or(gimple_stmt_iterator *gsi)
+{
+	gimple stmt;
+	gasm *asm_or_stmt;
+	gcall *call_stmt;
+	tree old_fptr, new_fptr, input, output;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(tree, gc) *inputs = NULL;
+	VEC(tree, gc) *outputs = NULL;
+#else
+	vec<tree, va_gc> *inputs = NULL;
+	vec<tree, va_gc> *outputs = NULL;
+#endif
+
+	call_stmt = as_a_gcall(gsi_stmt(*gsi));
+	old_fptr = gimple_call_fn(call_stmt);
+
+	// create temporary fptr variable
+	new_fptr = create_tmp_var(TREE_TYPE(old_fptr), "kernexec_or");
+	add_referenced_var(new_fptr);
+	new_fptr = make_ssa_name(new_fptr, NULL);
+
+	// build asm volatile("orq %%r12, %0\n\t" : "=r"(new_fptr) : "0"(old_fptr));
+	input = build_tree_list(NULL_TREE, build_const_char_string(2, "0"));
+	input = chainon(NULL_TREE, build_tree_list(input, old_fptr));
+	output = build_tree_list(NULL_TREE, build_const_char_string(3, "=r"));
+	output = chainon(NULL_TREE, build_tree_list(output, new_fptr));
+#if BUILDING_GCC_VERSION <= 4007
+	VEC_safe_push(tree, gc, inputs, input);
+	VEC_safe_push(tree, gc, outputs, output);
+#else
+	vec_safe_push(inputs, input);
+	vec_safe_push(outputs, output);
+#endif
+	stmt = gimple_build_asm_vec("orq %%r12, %0\n\t", inputs, outputs, NULL, NULL);
+	asm_or_stmt = as_a_gasm(stmt);
+	SSA_NAME_DEF_STMT(new_fptr) = asm_or_stmt;
+	gimple_asm_set_volatile(asm_or_stmt, true);
+	gsi_insert_before(gsi, asm_or_stmt, GSI_SAME_STMT);
+	update_stmt(asm_or_stmt);
+
+	// replace call stmt fn with the new fptr
+	gimple_call_set_fn(call_stmt, new_fptr);
+	update_stmt(call_stmt);
+}
+
+/*
+ * find all C level function pointer dereferences and forcibly set the highest bit of the pointer
+ */
+static unsigned int kernexec_fptr_execute(void)
+{
+	basic_block bb;
+
+	// 1. loop through BBs and GIMPLE statements
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			// gimple match: h_1 = get_fptr (); D.2709_3 = h_1 (x_2(D));
+			tree fn;
+			gimple stmt;
+			gcall *call_stmt;
+
+			// is it a call ...
+			stmt = gsi_stmt(gsi);
+			if (!is_gimple_call(stmt))
+				continue;
+			call_stmt = as_a_gcall(stmt);
+			fn = gimple_call_fn(call_stmt);
+			if (!fn)
+				continue;
+			if (TREE_CODE(fn) == ADDR_EXPR)
+				continue;
+			if (TREE_CODE(fn) != SSA_NAME)
+				gcc_unreachable();
+
+			// ... through a function pointer
+			if (SSA_NAME_VAR(fn) != NULL_TREE) {
+				fn = SSA_NAME_VAR(fn);
+				if (TREE_CODE(fn) != VAR_DECL && TREE_CODE(fn) != PARM_DECL) {
+					debug_tree(fn);
+					gcc_unreachable();
+				}
+			}
+			fn = TREE_TYPE(fn);
+			if (TREE_CODE(fn) != POINTER_TYPE)
+				continue;
+			fn = TREE_TYPE(fn);
+			if (TREE_CODE(fn) != FUNCTION_TYPE)
+				continue;
+
+			kernexec_instrument_fptr(&gsi);
+
+//debug_tree(gimple_call_fn(call_stmt));
+//print_gimple_stmt(stderr, call_stmt, 0, TDF_LINENO);
+		}
+	}
+
+	return 0;
+}
+
+// add special KERNEXEC instrumentation: btsq $63,(%rsp) just before retn
+static void kernexec_instrument_retaddr_bts(rtx insn)
+{
+	rtx btsq;
+	rtvec argvec, constraintvec, labelvec;
+
+	// create asm volatile("btsq $63,(%%rsp)":::)
+	argvec = rtvec_alloc(0);
+	constraintvec = rtvec_alloc(0);
+	labelvec = rtvec_alloc(0);
+	btsq = gen_rtx_ASM_OPERANDS(VOIDmode, "btsq $63,(%%rsp)", empty_string, 0, argvec, constraintvec, labelvec, RTL_LOCATION(insn));
+	MEM_VOLATILE_P(btsq) = 1;
+//	RTX_FRAME_RELATED_P(btsq) = 1; // not for ASM_OPERANDS
+	emit_insn_before(btsq, insn);
+}
+
+// add special KERNEXEC instrumentation: orq %r12,(%rsp) just before retn
+static void kernexec_instrument_retaddr_or(rtx insn)
+{
+	rtx orq;
+	rtvec argvec, constraintvec, labelvec;
+
+	// create asm volatile("orq %%r12,(%%rsp)":::)
+	argvec = rtvec_alloc(0);
+	constraintvec = rtvec_alloc(0);
+	labelvec = rtvec_alloc(0);
+	orq = gen_rtx_ASM_OPERANDS(VOIDmode, "orq %%r12,(%%rsp)", empty_string, 0, argvec, constraintvec, labelvec, RTL_LOCATION(insn));
+	MEM_VOLATILE_P(orq) = 1;
+//	RTX_FRAME_RELATED_P(orq) = 1; // not for ASM_OPERANDS
+	emit_insn_before(orq, insn);
+}
+
+/*
+ * find all asm level function returns and forcibly set the highest bit of the return address
+ */
+static unsigned int kernexec_retaddr_execute(void)
+{
+	rtx_insn *insn;
+
+//	if (stack_realign_drap)
+//		inform(DECL_SOURCE_LOCATION(current_function_decl), "drap detected in %s\n", IDENTIFIER_POINTER(DECL_NAME(current_function_decl)));
+
+	// 1. find function returns
+	for (insn = get_insns(); insn; insn = NEXT_INSN(insn)) {
+		// rtl match: (jump_insn 41 40 42 2 (return) fptr.c:42 634 {return_internal} (nil))
+		//            (jump_insn 12 9 11 2 (parallel [ (return) (unspec [ (0) ] UNSPEC_REP) ]) fptr.c:46 635 {return_internal_long} (nil))
+		//            (jump_insn 97 96 98 6 (simple_return) fptr.c:50 -1 (nil) -> simple_return)
+		rtx body;
+
+		// is it a retn
+		if (!JUMP_P(insn))
+			continue;
+		body = PATTERN(insn);
+		if (GET_CODE(body) == PARALLEL)
+			body = XVECEXP(body, 0, 0);
+		if (!ANY_RETURN_P(body))
+			continue;
+		kernexec_instrument_retaddr(insn);
+	}
+
+//	print_simple_rtl(stderr, get_insns());
+//	print_rtl(stderr, get_insns());
+
+	return 0;
+}
+
+static bool kernexec_cmodel_check(void)
+{
+	tree section;
+
+	if (ix86_cmodel != CM_KERNEL)
+		return false;
+
+	section = lookup_attribute("section", DECL_ATTRIBUTES(current_function_decl));
+	if (!section || !TREE_VALUE(section))
+		return true;
+
+	section = TREE_VALUE(TREE_VALUE(section));
+	if (strncmp(TREE_STRING_POINTER(section), ".vsyscall_", 10))
+		return true;
+
+	return false;
+}
+
+static bool kernexec_reload_gate(void)
+{
+	return kernexec_cmodel_check();
+}
+
+#define PASS_NAME kernexec_reload
+#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_remove_unused_locals | TODO_update_ssa_no_phi
+#include "gcc-generate-gimple-pass.h"
+
+static bool kernexec_fptr_gate(void)
+{
+	return kernexec_cmodel_check();
+}
+
+#define PASS_NAME kernexec_fptr
+#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_remove_unused_locals | TODO_update_ssa_no_phi
+#include "gcc-generate-gimple-pass.h"
+
+static bool kernexec_retaddr_gate(void)
+{
+	return kernexec_cmodel_check();
+}
+
+#define PASS_NAME kernexec_retaddr
+#define TODO_FLAGS_FINISH TODO_dump_func | TODO_ggc_collect
+#include "gcc-generate-rtl-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	int i;
+
+	PASS_INFO(kernexec_reload, "early_optimizations", 1, PASS_POS_INSERT_BEFORE);
+	PASS_INFO(kernexec_fptr, "early_optimizations", 1, PASS_POS_INSERT_BEFORE);
+	PASS_INFO(kernexec_retaddr, "pro_and_epilogue", 1, PASS_POS_INSERT_AFTER);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &kernexec_plugin_info);
+
+	if (TARGET_64BIT == 0)
+		return 0;
+
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "method")) {
+			if (!argv[i].value) {
+				error(G_("no value supplied for option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+				continue;
+			}
+			if (!strcmp(argv[i].value, "bts") || !strcmp(argv[i].value, "\"bts\"")) {
+				kernexec_instrument_fptr = kernexec_instrument_fptr_bts;
+				kernexec_instrument_retaddr = kernexec_instrument_retaddr_bts;
+			} else if (!strcmp(argv[i].value, "or") || !strcmp(argv[i].value, "\"or\"")) {
+				kernexec_instrument_fptr = kernexec_instrument_fptr_or;
+				kernexec_instrument_retaddr = kernexec_instrument_retaddr_or;
+				fix_register("r12", 1, 1);
+			} else
+				error(G_("invalid option argument '-fplugin-arg-%s-%s=%s'"), plugin_name, argv[i].key, argv[i].value);
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+	if (!kernexec_instrument_fptr || !kernexec_instrument_retaddr)
+		error(G_("no instrumentation method was selected via '-fplugin-arg-%s-method'"), plugin_name);
+
+	if (kernexec_instrument_fptr == kernexec_instrument_fptr_or)
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &kernexec_reload_pass_info);
+	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &kernexec_fptr_pass_info);
+	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &kernexec_retaddr_pass_info);
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/latent_entropy_plugin.c b/scripts/gcc-plugins/latent_entropy_plugin.c
new file mode 100644
index 000000000..d5a37cb96
--- /dev/null
+++ b/scripts/gcc-plugins/latent_entropy_plugin.c
@@ -0,0 +1,609 @@
+/*
+ * Copyright 2012-2017 by the PaX Team <pageexec@freemail.hu>
+ * Copyright 2016 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * This gcc plugin helps generate a little bit of entropy from program state,
+ * used throughout the uptime of the kernel. Here is an instrumentation example:
+ *
+ * before:
+ * void __latent_entropy test(int argc, char *argv[])
+ * {
+ *	printf("%u %s\n", argc, *argv);
+ * }
+ *
+ * after:
+ * void __latent_entropy test(int argc, char *argv[])
+ * {
+ *	// latent_entropy_execute() 1.
+ *	unsigned long local_entropy;
+ *	// init_local_entropy() 1.
+ *	void *local_entropy_frame_addr;
+ *	// init_local_entropy() 3.
+ *	unsigned long temp_latent_entropy;
+ *
+ *	// init_local_entropy() 2.
+ *	local_entropy_frame_addr = __builtin_frame_address(0);
+ *	local_entropy = (unsigned long) local_entropy_frame_addr;
+ *
+ *	// init_local_entropy() 4.
+ *	temp_latent_entropy = latent_entropy;
+ *	// init_local_entropy() 5.
+ *	local_entropy ^= temp_latent_entropy;
+ *
+ *	// latent_entropy_execute() 3.
+ *	local_entropy += 4623067384293424948;
+ *
+ *	printf("%u %s\n", argc, *argv);
+ *
+ *	// latent_entropy_execute() 4.
+ *	temp_latent_entropy = rol(temp_latent_entropy, local_entropy);
+ *	latent_entropy = temp_latent_entropy;
+ * }
+ *
+ * It would look like this in C:
+ *
+ * unsigned long local_entropy = latent_entropy;
+ * local_entropy ^= 1234567890;
+ * local_entropy ^= (unsigned long)__builtin_frame_address(0);
+ * local_entropy += 9876543210;
+ * latent_entropy = rol(local_entropy, 1234509876);
+ *
+ * TODO:
+ * - add ipa pass to identify not explicitly marked candidate functions
+ * - mix in more program state (function arguments/return values,
+ *   loop variables, etc)
+ * - more instrumentation control via attribute parameters
+ *
+ * BUGS:
+ * - none known
+ *
+ * Options:
+ * -fplugin-arg-latent_entropy_plugin-disable
+ *
+ * Attribute: __attribute__((latent_entropy))
+ *  The latent_entropy gcc attribute can be only on functions and variables.
+ *  If it is on a function then the plugin will instrument it. If the attribute
+ *  is on a variable then the plugin will initialize it with a random value.
+ *  The variable must be an integer, an integer array type or a structure
+ *  with integer fields.
+ */
+
+#include "gcc-common.h"
+
+__visible int plugin_is_GPL_compatible;
+
+static GTY(()) tree latent_entropy_decl;
+
+static struct plugin_info latent_entropy_plugin_info = {
+	.version	= "20161210",
+	.help		= "disable\tturn off latent entropy instrumentation\n",
+};
+
+static unsigned HOST_WIDE_INT seed;
+
+/*
+ * get_random_seed() (this is a GCC function) generates the seed.
+ * This is a simple random generator without any cryptographic security because
+ * the entropy doesn't come from here.
+ */
+static unsigned HOST_WIDE_INT get_random_const(void)
+{
+	unsigned int i;
+	unsigned HOST_WIDE_INT ret = 0;
+
+	for (i = 0; i < 8 * sizeof ret; i++) {
+		ret = (ret << 1) | (seed & 1);
+		seed >>= 1;
+		if (ret & 1)
+			seed ^= 0xD800000000000000ULL;
+	}
+
+	return ret;
+}
+
+static tree tree_get_random_const(tree type)
+{
+	unsigned long long mask;
+
+	mask = 1ULL << (TREE_INT_CST_LOW(TYPE_SIZE(type)) - 1);
+	mask = 2 * (mask - 1) + 1;
+
+	if (TYPE_UNSIGNED(type))
+		return build_int_cstu(type, mask & get_random_const());
+	return build_int_cst(type, mask & get_random_const());
+}
+
+static tree handle_latent_entropy_attribute(tree *node, tree name, tree args __unused, int flags __unused, bool *no_add_attrs)
+{
+	tree type;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(constructor_elt, gc) *vals;
+#else
+	vec<constructor_elt, va_gc> *vals;
+#endif
+
+	switch (TREE_CODE(*node)) {
+	default:
+		*no_add_attrs = true;
+		error("%qE attribute only applies to functions and variables", name);
+		break;
+
+	case VAR_DECL:
+		if (DECL_INITIAL(*node)) {
+			*no_add_attrs = true;
+			error("variable %qD with %qE attribute must not be initialized", *node, name);
+			break;
+		}
+
+		if (!TREE_STATIC(*node)) {
+			*no_add_attrs = true;
+			error("variable %qD with %qE attribute must not be local", *node, name);
+			break;
+		}
+
+		type = TREE_TYPE(*node);
+		switch (TREE_CODE(type)) {
+		default:
+			*no_add_attrs = true;
+			error("variable %qD with %qE attribute must be an integer"
+				" or a fixed length integer array type"
+				" or a fixed sized structure with integer fields", *node, name);
+			break;
+
+		case RECORD_TYPE: {
+			tree field;
+			unsigned int nelt = 0;
+
+			for (field = TYPE_FIELDS(type); field; nelt++, field = TREE_CHAIN(field)) {
+				tree fieldtype;
+
+				fieldtype = TREE_TYPE(field);
+				if (TREE_CODE(fieldtype) == INTEGER_TYPE)
+					continue;
+
+				*no_add_attrs = true;
+				error("structure variable %qD with %qE attribute has"
+					" a non-integer field %qE", *node, name, field);
+				break;
+			}
+
+			if (field)
+				break;
+
+#if BUILDING_GCC_VERSION <= 4007
+			vals = VEC_alloc(constructor_elt, gc, nelt);
+#else
+			vec_alloc(vals, nelt);
+#endif
+
+			for (field = TYPE_FIELDS(type); field; field = TREE_CHAIN(field)) {
+				tree random_const;
+
+				random_const = tree_get_random_const(TREE_TYPE(field));
+				CONSTRUCTOR_APPEND_ELT(vals, field, random_const);
+			}
+
+			/* Initialize the fields with random constants */
+			DECL_INITIAL(*node) = build_constructor(type, vals);
+//debug_tree(DECL_INITIAL(*node));
+			break;
+		}
+
+		/* Initialize the variable with a random constant */
+		case INTEGER_TYPE:
+			DECL_INITIAL(*node) = tree_get_random_const(type);
+			break;
+
+		case ARRAY_TYPE: {
+			tree elt_type, array_size, elt_size;
+			unsigned int i, nelt;
+
+			elt_type = TREE_TYPE(type);
+			elt_size = TYPE_SIZE_UNIT(TREE_TYPE(type));
+			array_size = TYPE_SIZE_UNIT(type);
+
+			if (TREE_CODE(elt_type) != INTEGER_TYPE || !array_size || TREE_CODE(array_size) != INTEGER_CST) {
+				*no_add_attrs = true;
+				error("array variable %qD with %qE attribute must be"
+					" a fixed length integer array type", *node, name);
+				break;
+			}
+
+			nelt = TREE_INT_CST_LOW(array_size) / TREE_INT_CST_LOW(elt_size);
+#if BUILDING_GCC_VERSION <= 4007
+			vals = VEC_alloc(constructor_elt, gc, nelt);
+#else
+			vec_alloc(vals, nelt);
+#endif
+
+			for (i = 0; i < nelt; i++) {
+				tree random_const = tree_get_random_const(elt_type);
+
+				CONSTRUCTOR_APPEND_ELT(vals, size_int(i), random_const);
+			}
+
+			/* Initialize the elements of the array with random constants */
+			DECL_INITIAL(*node) = build_constructor(type, vals);
+//debug_tree(DECL_INITIAL(*node));
+			break;
+		}
+		}
+		break;
+
+	case FUNCTION_DECL:
+		break;
+	}
+
+	return NULL_TREE;
+}
+
+static struct attribute_spec latent_entropy_attr = {
+	.name				= "latent_entropy",
+	.min_length			= 0,
+	.max_length			= 0,
+	.decl_required			= true,
+	.type_required			= false,
+	.function_type_required		= false,
+	.handler			= handle_latent_entropy_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity		= false
+#endif
+};
+
+static void register_attributes(void *event_data __unused, void *data __unused)
+{
+	register_attribute(&latent_entropy_attr);
+}
+
+static bool latent_entropy_gate(void)
+{
+	/* don't bother with noreturn functions for now */
+	if (TREE_THIS_VOLATILE(current_function_decl))
+		return false;
+
+	/* gcc-4.5 doesn't discover some trivial noreturn functions */
+	if (EDGE_COUNT(EXIT_BLOCK_PTR_FOR_FN(cfun)->preds) == 0)
+		return false;
+
+	return lookup_attribute("latent_entropy", DECL_ATTRIBUTES(current_function_decl)) != NULL_TREE;
+}
+
+static tree create_a_tmp_var(tree type, const char *name)
+{
+	tree var;
+
+	var = create_tmp_var(type, name);
+	add_referenced_var(var);
+	mark_sym_for_renaming(var);
+	return var;
+}
+
+/*
+ * Set up the next operation and its constant operand to use in the latent
+ * entropy PRNG. When RHS is specified, the request is for perturbing the
+ * local latent entropy variable, otherwise it is for perturbing the global
+ * latent entropy variable where the two operands are already given by the
+ * local and global latent entropy variables themselves.
+ *
+ * The operation is one of add/xor/rol when instrumenting the local entropy
+ * variable and one of add/xor when perturbing the global entropy variable.
+ * Rotation is not used for the latter case because it would transmit less
+ * entropy to the global variable than the other two operations.
+ */
+static enum tree_code get_op(tree *rhs)
+{
+	static enum tree_code op;
+	unsigned HOST_WIDE_INT random_const;
+
+	random_const = get_random_const();
+
+	switch (op) {
+	case BIT_XOR_EXPR:
+		op = PLUS_EXPR;
+		break;
+
+	case PLUS_EXPR:
+		if (rhs) {
+			op = LROTATE_EXPR;
+			/*
+			 * This code limits the value of random_const to
+			 * the size of a long for the rotation
+			 */
+			random_const %= TYPE_PRECISION(long_unsigned_type_node);
+			break;
+		}
+
+	case LROTATE_EXPR:
+	default:
+		op = BIT_XOR_EXPR;
+		break;
+	}
+	if (rhs)
+		*rhs = build_int_cstu(long_unsigned_type_node, random_const);
+	return op;
+}
+
+static void perturb_local_entropy(basic_block bb, tree local_entropy)
+{
+	gimple_stmt_iterator gsi;
+	gimple assign;
+	tree rhs;
+	enum tree_code op;
+
+	op = get_op(&rhs);
+	assign = gimple_build_assign_with_ops(op, local_entropy, local_entropy, rhs);
+	gsi = gsi_after_labels(bb);
+	gsi_insert_before(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+//debug_bb(bb);
+}
+
+static void __perturb_latent_entropy(gimple_stmt_iterator *gsi, tree local_entropy)
+{
+	gimple assign;
+	tree temp;
+	enum tree_code op;
+
+	/* 1. create temporary copy of latent_entropy */
+	temp = create_a_tmp_var(long_unsigned_type_node, "temp_latent_entropy");
+
+	/* 2. read... */
+	add_referenced_var(latent_entropy_decl);
+	mark_sym_for_renaming(latent_entropy_decl);
+	assign = gimple_build_assign(temp, latent_entropy_decl);
+	gsi_insert_before(gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+
+	/* 3. ...modify... */
+	op = get_op(NULL);
+	assign = gimple_build_assign_with_ops(op, temp, temp, local_entropy);
+	gsi_insert_after(gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+
+	/* 4. ...write latent_entropy */
+	assign = gimple_build_assign(latent_entropy_decl, temp);
+	gsi_insert_after(gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+}
+
+static bool handle_tail_calls(basic_block bb, tree local_entropy)
+{
+	gimple_stmt_iterator gsi;
+
+	for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+		gcall *call;
+		gimple stmt = gsi_stmt(gsi);
+
+		if (!is_gimple_call(stmt))
+			continue;
+
+		call = as_a_gcall(stmt);
+		if (!gimple_call_tail_p(call))
+			continue;
+
+		__perturb_latent_entropy(&gsi, local_entropy);
+		return true;
+	}
+
+	return false;
+}
+
+static void perturb_latent_entropy(tree local_entropy)
+{
+	edge_iterator ei;
+	edge e, last_bb_e;
+	basic_block last_bb;
+
+	gcc_assert(single_pred_p(EXIT_BLOCK_PTR_FOR_FN(cfun)));
+	last_bb_e = single_pred_edge(EXIT_BLOCK_PTR_FOR_FN(cfun));
+
+	FOR_EACH_EDGE(e, ei, last_bb_e->src->preds) {
+		if (ENTRY_BLOCK_PTR_FOR_FN(cfun) == e->src)
+			continue;
+		if (EXIT_BLOCK_PTR_FOR_FN(cfun) == e->src)
+			continue;
+
+		handle_tail_calls(e->src, local_entropy);
+	}
+
+	last_bb = single_pred(EXIT_BLOCK_PTR_FOR_FN(cfun));
+	if (!handle_tail_calls(last_bb, local_entropy)) {
+		gimple_stmt_iterator gsi = gsi_last_bb(last_bb);
+
+		__perturb_latent_entropy(&gsi, local_entropy);
+	}
+//debug_bb(single_pred(EXIT_BLOCK_PTR_FOR_FN(cfun)));
+}
+
+static void init_local_entropy(basic_block bb, tree local_entropy)
+{
+	gimple assign, call;
+	tree frame_addr, rand_const, temp, fndecl, udi_frame_addr;
+	enum tree_code op;
+	gimple_stmt_iterator gsi = gsi_after_labels(bb);
+
+	/* 1. create local_entropy_frame_addr */
+	frame_addr = create_a_tmp_var(ptr_type_node, "local_entropy_frame_addr");
+
+	/* 2. local_entropy_frame_addr = __builtin_frame_address() */
+	fndecl = builtin_decl_implicit(BUILT_IN_FRAME_ADDRESS);
+	call = gimple_build_call(fndecl, 1, integer_zero_node);
+	gimple_call_set_lhs(call, frame_addr);
+	gsi_insert_before(&gsi, call, GSI_NEW_STMT);
+	update_stmt(call);
+
+	udi_frame_addr = fold_convert(long_unsigned_type_node, frame_addr);
+	assign = gimple_build_assign(local_entropy, udi_frame_addr);
+	gsi_insert_after(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+
+	/* 3. create temporary copy of latent_entropy */
+	temp = create_a_tmp_var(long_unsigned_type_node, "temp_latent_entropy");
+
+	/* 4. read the global entropy variable into local entropy */
+	add_referenced_var(latent_entropy_decl);
+	mark_sym_for_renaming(latent_entropy_decl);
+	assign = gimple_build_assign(temp, latent_entropy_decl);
+	gsi_insert_after(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+
+	/* 5. mix local_entropy_frame_addr into local entropy */
+	assign = gimple_build_assign_with_ops(BIT_XOR_EXPR, local_entropy, local_entropy, temp);
+	gsi_insert_after(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+
+	rand_const = build_int_cstu(long_unsigned_type_node, get_random_const());
+	op = get_op(NULL);
+	assign = gimple_build_assign_with_ops(op, local_entropy, local_entropy, rand_const);
+	gsi_insert_after(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+//debug_bb(bb);
+}
+
+static bool create_latent_entropy_decl(void)
+{
+	varpool_node_ptr node;
+
+	if (latent_entropy_decl != NULL_TREE)
+		return true;
+
+	FOR_EACH_VARIABLE(node) {
+		tree var = NODE_DECL(node);
+
+		if (DECL_NAME_LENGTH(var) < sizeof("latent_entropy") - 1)
+			continue;
+		if (strcmp(IDENTIFIER_POINTER(DECL_NAME(var)), "latent_entropy"))
+			continue;
+
+		latent_entropy_decl = var;
+//		debug_tree(var);
+		break;
+	}
+
+	return latent_entropy_decl != NULL_TREE;
+}
+
+static unsigned int latent_entropy_execute(void)
+{
+	basic_block bb;
+	tree local_entropy;
+
+	if (!create_latent_entropy_decl()) {
+//		debug_tree(current_function_decl);
+		return 0;
+	}
+
+//fprintf(stderr, "latent_entropy: %s\n", IDENTIFIER_POINTER(DECL_NAME(current_function_decl)));
+
+	/* 2. initialize local entropy variable */
+	gcc_assert(single_succ_p(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+	bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+	if (!single_pred_p(bb)) {
+//		gcc_assert(bb_loop_depth(bb) || (bb->flags & BB_IRREDUCIBLE_LOOP));
+		split_edge(single_succ_edge(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+		gcc_assert(single_succ_p(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+		bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+	}
+
+	/* 1. create the local entropy variable */
+	local_entropy = create_a_tmp_var(long_unsigned_type_node, "local_entropy");
+
+	/* 2. initialize the local entropy variable */
+	init_local_entropy(bb, local_entropy);
+
+	bb = bb->next_bb;
+
+	/* 3. instrument each BB with an operation on the local entropy variable */
+	while (bb != EXIT_BLOCK_PTR_FOR_FN(cfun)) {
+		perturb_local_entropy(bb, local_entropy);
+//debug_bb(bb);
+		bb = bb->next_bb;
+	};
+
+	/* 4. mix local entropy into the global entropy variable */
+	perturb_latent_entropy(local_entropy);
+	return 0;
+}
+
+static void latent_entropy_start_unit(void *gcc_data __unused, void *user_data __unused)
+{
+	tree latent_entropy_type;
+
+	seed = get_random_seed(false);
+
+	if (in_lto_p)
+		return;
+
+	/* extern volatile unsigned long latent_entropy */
+	latent_entropy_type = build_qualified_type(long_unsigned_type_node, TYPE_QUALS(long_unsigned_type_node) | TYPE_QUAL_VOLATILE);
+	latent_entropy_decl = build_decl(UNKNOWN_LOCATION, VAR_DECL, get_identifier("latent_entropy"), latent_entropy_type);
+
+	TREE_STATIC(latent_entropy_decl) = 1;
+	TREE_PUBLIC(latent_entropy_decl) = 1;
+	TREE_USED(latent_entropy_decl) = 1;
+	DECL_PRESERVE_P(latent_entropy_decl) = 1;
+	TREE_THIS_VOLATILE(latent_entropy_decl) = 1;
+	DECL_EXTERNAL(latent_entropy_decl) = 1;
+	DECL_ARTIFICIAL(latent_entropy_decl) = 1;
+	lang_hooks.decls.pushdecl(latent_entropy_decl);
+//	DECL_ASSEMBLER_NAME(latent_entropy_decl);
+//	varpool_finalize_decl(latent_entropy_decl);
+//	varpool_mark_needed_node(latent_entropy_decl);
+}
+
+#define PASS_NAME latent_entropy
+#define PROPERTIES_REQUIRED PROP_gimple_leh | PROP_cfg
+//#define TODO_FLAGS_START TODO_verify_ssa | TODO_verify_flow | TODO_verify_stmts
+#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_update_ssa
+#include "gcc-generate-gimple-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	bool enabled = true;
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	int i;
+
+	static const struct ggc_root_tab gt_ggc_r_gt_latent_entropy[] = {
+		{
+			.base = &latent_entropy_decl,
+			.nelt = 1,
+			.stride = sizeof(latent_entropy_decl),
+			.cb = &gt_ggc_mx_tree_node,
+			.pchw = &gt_pch_nx_tree_node
+		},
+		LAST_GGC_ROOT_TAB
+	};
+
+	PASS_INFO(latent_entropy, "optimized", 1, PASS_POS_INSERT_BEFORE);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	for (i = 0; i < argc; ++i) {
+		if (!(strcmp(argv[i].key, "disable"))) {
+			enabled = false;
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &latent_entropy_plugin_info);
+	if (enabled) {
+		register_callback(plugin_name, PLUGIN_START_UNIT, &latent_entropy_start_unit, NULL);
+		register_callback(plugin_name, PLUGIN_REGISTER_GGC_ROOTS, NULL, (void *)&gt_ggc_r_gt_latent_entropy);
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &latent_entropy_pass_info);
+	}
+	register_callback(plugin_name, PLUGIN_ATTRIBUTES, register_attributes, NULL);
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/randomize_layout_plugin.c b/scripts/gcc-plugins/randomize_layout_plugin.c
new file mode 100644
index 000000000..71911c828
--- /dev/null
+++ b/scripts/gcc-plugins/randomize_layout_plugin.c
@@ -0,0 +1,940 @@
+/*
+ * Copyright 2014-2016 by Open Source Security, Inc., Brad Spengler <spender@grsecurity.net>
+ *                   and PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * Usage:
+ * $ # for 4.5/4.6/C based 4.7
+ * $ gcc -I`gcc -print-file-name=plugin`/include -I`gcc -print-file-name=plugin`/include/c-family -fPIC -shared -O2 -o randomize_layout_plugin.so randomize_layout_plugin.c
+ * $ # for C++ based 4.7/4.8+
+ * $ g++ -I`g++ -print-file-name=plugin`/include -I`g++ -print-file-name=plugin`/include/c-family -fPIC -shared -O2 -o randomize_layout_plugin.so randomize_layout_plugin.c
+ * $ gcc -fplugin=./randomize_layout_plugin.so test.c -O2
+ */
+
+#include "gcc-common.h"
+#include "randomize_layout_seed.h"
+
+#if BUILDING_GCC_MAJOR < 4 || (BUILDING_GCC_MAJOR == 4 && BUILDING_GCC_MINOR < 6) || \
+   (BUILDING_GCC_MAJOR == 4 && BUILDING_GCC_MINOR == 6 && BUILDING_GCC_PATCHLEVEL < 4)
+#error "The RANDSTRUCT plugin requires GCC 4.6.4 or newer."
+#endif
+
+#define ORIG_TYPE_NAME(node) \
+	(TYPE_NAME(TYPE_MAIN_VARIANT(node)) != NULL_TREE ? ((const unsigned char *)IDENTIFIER_POINTER(TYPE_NAME(TYPE_MAIN_VARIANT(node)))) : (const unsigned char *)"anonymous")
+
+__visible int plugin_is_GPL_compatible;
+
+static int performance_mode;
+
+static struct plugin_info randomize_layout_plugin_info = {
+	.version	= "201402201816",
+	.help		= "disable\t\t\tdo not activate plugin\n"
+			  "performance-mode\tenable cacheline-aware layout randomization\n"
+};
+
+/* from old Linux dcache.h */
+static inline unsigned long
+partial_name_hash(unsigned long c, unsigned long prevhash)
+{
+	return (prevhash + (c << 4) + (c >> 4)) * 11;
+}
+static inline unsigned int
+name_hash(const unsigned char *name)
+{
+	unsigned long hash = 0;
+	unsigned int len = strlen((const char *)name);
+	while (len--)
+		hash = partial_name_hash(*name++, hash);
+	return (unsigned int)hash;
+}
+
+static tree handle_randomize_layout_attr(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
+{
+	tree type;
+
+	*no_add_attrs = true;
+	if (TREE_CODE(*node) == FUNCTION_DECL) {
+		error("%qE attribute does not apply to functions (%qF)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (TREE_CODE(*node) == PARM_DECL) {
+		error("%qE attribute does not apply to function parameters (%qD)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (TREE_CODE(*node) == VAR_DECL) {
+		error("%qE attribute does not apply to variables (%qD)", name, *node);
+		return NULL_TREE;
+	}
+
+	if (TYPE_P(*node)) {
+		type = *node;
+	} else {
+		gcc_assert(TREE_CODE(*node) == TYPE_DECL);
+		type = TREE_TYPE(*node);
+	}
+
+	if (TREE_CODE(type) != RECORD_TYPE) {
+		error("%qE attribute used on %qT applies to struct types only", name, type);
+		return NULL_TREE;
+	}
+
+	if (lookup_attribute(IDENTIFIER_POINTER(name), TYPE_ATTRIBUTES(type))) {
+		error("%qE attribute is already applied to the type %qT", name, type);
+		return NULL_TREE;
+	}
+
+	*no_add_attrs = false;
+
+	return NULL_TREE;
+}
+
+/* set on complete types that we don't need to inspect further at all */
+static tree handle_randomize_considered_attr(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
+{
+	*no_add_attrs = false;
+	return NULL_TREE;
+}
+
+/*
+ * set on types that we've performed a shuffle on, to prevent re-shuffling
+ * this does not preclude us from inspecting its fields for potential shuffles
+ */
+static tree handle_randomize_performed_attr(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
+{
+	*no_add_attrs = false;
+	return NULL_TREE;
+}
+
+/*
+ * 64bit variant of Bob Jenkins' public domain PRNG
+ * 256 bits of internal state
+ */
+
+typedef unsigned long long u64;
+
+typedef struct ranctx { u64 a; u64 b; u64 c; u64 d; } ranctx;
+
+#define rot(x,k) (((x)<<(k))|((x)>>(64-(k))))
+static u64 ranval(ranctx *x) {
+	u64 e = x->a - rot(x->b, 7);
+	x->a = x->b ^ rot(x->c, 13);
+	x->b = x->c + rot(x->d, 37);
+	x->c = x->d + e;
+	x->d = e + x->a;
+	return x->d;
+}
+
+static void raninit(ranctx *x, u64 *seed) {
+	int i;
+
+	x->a = seed[0];
+	x->b = seed[1];
+	x->c = seed[2];
+	x->d = seed[3];
+
+	for (i=0; i < 30; ++i)
+		(void)ranval(x);
+}
+
+static u64 shuffle_seed[4];
+
+struct partition_group {
+	tree tree_start;
+	unsigned long start;
+	unsigned long length;
+};
+
+static void partition_struct(tree *fields, unsigned long length, struct partition_group *size_groups, unsigned long *num_groups)
+{
+	unsigned long i;
+	unsigned long accum_size = 0;
+	unsigned long accum_length = 0;
+	unsigned long group_idx = 0;
+
+	gcc_assert(length < INT_MAX);
+
+	memset(size_groups, 0, sizeof(struct partition_group) * length);
+
+	for (i = 0; i < length; i++) {
+		if (size_groups[group_idx].tree_start == NULL_TREE) {
+			size_groups[group_idx].tree_start = fields[i];
+			size_groups[group_idx].start = i;
+			accum_length = 0;
+			accum_size = 0;
+		}
+		accum_size += (unsigned long)int_size_in_bytes(TREE_TYPE(fields[i]));
+		accum_length++;
+		if (accum_size >= 64) {
+			size_groups[group_idx].length = accum_length;
+			accum_length = 0;
+			group_idx++;
+		}
+	}
+
+	if (size_groups[group_idx].tree_start != NULL_TREE &&
+	    !size_groups[group_idx].length) {
+		size_groups[group_idx].length = accum_length;
+		group_idx++;
+	}
+
+	*num_groups = group_idx;
+}
+
+static void performance_shuffle(tree *newtree, unsigned long length, ranctx *prng_state)
+{
+	unsigned long i, x;
+	struct partition_group size_group[length];
+	unsigned long num_groups = 0;
+	unsigned long randnum;
+
+	partition_struct(newtree, length, (struct partition_group *)&size_group, &num_groups);
+	for (i = num_groups - 1; i > 0; i--) {
+		struct partition_group tmp;
+		randnum = ranval(prng_state) % (i + 1);
+		tmp = size_group[i];
+		size_group[i] = size_group[randnum];
+		size_group[randnum] = tmp;
+	}
+
+	for (x = 0; x < num_groups; x++) {
+		for (i = size_group[x].start + size_group[x].length - 1; i > size_group[x].start; i--) {
+			tree tmp;
+			if (DECL_BIT_FIELD_TYPE(newtree[i]))
+				continue;
+			randnum = ranval(prng_state) % (i + 1);
+			// we could handle this case differently if desired
+			if (DECL_BIT_FIELD_TYPE(newtree[randnum]))
+				continue;
+			tmp = newtree[i];
+			newtree[i] = newtree[randnum];
+			newtree[randnum] = tmp;
+		}
+	}
+}
+
+static void full_shuffle(tree *newtree, unsigned long length, ranctx *prng_state)
+{
+	unsigned long i, randnum;
+
+	for (i = length - 1; i > 0; i--) {
+		tree tmp;
+		randnum = ranval(prng_state) % (i + 1);
+		tmp = newtree[i];
+		newtree[i] = newtree[randnum];
+		newtree[randnum] = tmp;
+	}
+}
+
+/* modern in-place Fisher-Yates shuffle */
+static void shuffle(const_tree type, tree *newtree, unsigned long length)
+{
+	unsigned long i;
+	u64 seed[4];
+	ranctx prng_state;
+	const unsigned char *structname;
+
+	if (length == 0)
+		return;
+
+	gcc_assert(TREE_CODE(type) == RECORD_TYPE);
+
+	structname = ORIG_TYPE_NAME(type);
+
+#ifdef __DEBUG_PLUGIN
+	fprintf(stderr, "Shuffling struct %s %p\n", (const char *)structname, type);
+#ifdef __DEBUG_VERBOSE
+	debug_tree((tree)type);
+#endif
+#endif
+
+	for (i = 0; i < 4; i++) {
+		seed[i] = shuffle_seed[i];
+		seed[i] ^= name_hash(structname);
+	}
+
+	raninit(&prng_state, (u64 *)&seed);
+
+	if (performance_mode)
+		performance_shuffle(newtree, length, &prng_state);
+	else
+		full_shuffle(newtree, length, &prng_state);
+}
+
+static bool is_flexible_array(const_tree field)
+{
+	const_tree fieldtype;
+	const_tree typesize;
+	const_tree elemtype;
+	const_tree elemsize;
+
+	fieldtype = TREE_TYPE(field);
+	typesize = TYPE_SIZE(fieldtype);
+
+	if (TREE_CODE(fieldtype) != ARRAY_TYPE)
+		return false;
+
+	elemtype = TREE_TYPE(fieldtype);
+	elemsize = TYPE_SIZE(elemtype);
+
+	/* size of type is represented in bits */
+
+	if (typesize == NULL_TREE && TYPE_DOMAIN(fieldtype) != NULL_TREE &&
+	    TYPE_MAX_VALUE(TYPE_DOMAIN(fieldtype)) == NULL_TREE)
+		return true;
+
+	if (typesize != NULL_TREE && 
+	    (TREE_CONSTANT(typesize) && (!tree_to_uhwi(typesize) ||
+	     tree_to_uhwi(typesize) == tree_to_uhwi(elemsize))))
+		return true;
+
+	return false;
+}
+
+static int relayout_struct(tree type)
+{
+	unsigned long num_fields = (unsigned long)list_length(TYPE_FIELDS(type));
+	unsigned long shuffle_length = num_fields;
+	tree field;
+	tree newtree[num_fields];
+	unsigned long i;
+	tree list;
+	tree variant;
+	tree main_variant;
+	expanded_location xloc;
+	bool has_flexarray = false;
+
+	if (TYPE_FIELDS(type) == NULL_TREE)
+		return 0;
+
+	if (num_fields < 2)
+		return 0;
+
+	gcc_assert(TREE_CODE(type) == RECORD_TYPE);
+
+	gcc_assert(num_fields < INT_MAX);
+
+	if (lookup_attribute("randomize_performed", TYPE_ATTRIBUTES(type)) ||
+	    lookup_attribute("no_randomize_layout", TYPE_ATTRIBUTES(TYPE_MAIN_VARIANT(type))))
+		return 0;
+
+	/* Workaround for 3rd-party VirtualBox source that we can't modify ourselves */
+	if (!strcmp((const char *)ORIG_TYPE_NAME(type), "INTNETTRUNKFACTORY") ||
+	    !strcmp((const char *)ORIG_TYPE_NAME(type), "RAWPCIFACTORY"))
+		return 0;
+
+	/* throw out any structs in uapi */
+	xloc = expand_location(DECL_SOURCE_LOCATION(TYPE_FIELDS(type)));
+
+	if (strstr(xloc.file, "/uapi/"))
+		error(G_("attempted to randomize userland API struct %s"), ORIG_TYPE_NAME(type));
+
+	for (field = TYPE_FIELDS(type), i = 0; field; field = TREE_CHAIN(field), i++) {
+		gcc_assert(TREE_CODE(field) == FIELD_DECL);
+		newtree[i] = field;
+	}
+
+	/*
+	 * enforce that we don't randomize the layout of the last
+	 * element of a struct if it's a 0 or 1-length array
+	 * or a proper flexible array
+	 */
+	if (is_flexible_array(newtree[num_fields - 1])) {
+		has_flexarray = true;
+		shuffle_length--;
+	}
+
+	shuffle(type, (tree *)newtree, shuffle_length);
+
+	/*
+	 * set up a bogus anonymous struct field designed to error out on unnamed struct initializers
+	 * as gcc provides no other way to detect such code
+	 */
+	list = make_node(FIELD_DECL);
+	TREE_CHAIN(list) = newtree[0];
+	TREE_TYPE(list) = void_type_node;
+	DECL_SIZE(list) = bitsize_zero_node;
+	DECL_NONADDRESSABLE_P(list) = 1;
+	DECL_FIELD_BIT_OFFSET(list) = bitsize_zero_node;
+	DECL_SIZE_UNIT(list) = size_zero_node;
+	DECL_FIELD_OFFSET(list) = size_zero_node;
+	DECL_CONTEXT(list) = type;
+	// to satisfy the constify plugin
+	TREE_READONLY(list) = 1;
+
+	for (i = 0; i < num_fields - 1; i++)
+		TREE_CHAIN(newtree[i]) = newtree[i+1];
+	TREE_CHAIN(newtree[num_fields - 1]) = NULL_TREE;
+
+	main_variant = TYPE_MAIN_VARIANT(type);
+	for (variant = main_variant; variant; variant = TYPE_NEXT_VARIANT(variant)) {
+		TYPE_FIELDS(variant) = list;
+		TYPE_ATTRIBUTES(variant) = copy_list(TYPE_ATTRIBUTES(variant));
+		TYPE_ATTRIBUTES(variant) = tree_cons(get_identifier("randomize_performed"), NULL_TREE, TYPE_ATTRIBUTES(variant));
+		if (has_flexarray)
+			TYPE_ATTRIBUTES(type) = tree_cons(get_identifier("has_flexarray"), NULL_TREE, TYPE_ATTRIBUTES(type));
+	}
+
+	/*
+	 * force a re-layout of the main variant
+	 * the TYPE_SIZE for all variants will be recomputed
+	 * by finalize_type_size()
+	 */
+	TYPE_SIZE(main_variant) = NULL_TREE;
+	layout_type(main_variant);
+	gcc_assert(TYPE_SIZE(main_variant) != NULL_TREE);
+
+	return 1;
+}
+
+/* from constify plugin */
+static const_tree get_field_type(const_tree field)
+{
+	return strip_array_types(TREE_TYPE(field));
+}
+
+/* from constify plugin */
+static bool is_fptr(const_tree fieldtype)
+{
+	if (TREE_CODE(fieldtype) != POINTER_TYPE)
+		return false;
+
+	return TREE_CODE(TREE_TYPE(fieldtype)) == FUNCTION_TYPE;
+}
+
+/* derived from constify plugin */
+static int is_pure_ops_struct(const_tree node)
+{
+	const_tree field;
+
+	gcc_assert(TREE_CODE(node) == RECORD_TYPE || TREE_CODE(node) == UNION_TYPE);
+
+	for (field = TYPE_FIELDS(node); field; field = TREE_CHAIN(field)) {
+		const_tree fieldtype = get_field_type(field);
+		enum tree_code code = TREE_CODE(fieldtype);
+
+		if (node == fieldtype)
+			continue;
+
+		if (!is_fptr(fieldtype))
+			return 0;
+
+		if (code != RECORD_TYPE && code != UNION_TYPE)
+			continue;
+
+		if (!is_pure_ops_struct(fieldtype))
+			return 0;
+	}
+
+	return 1;
+}
+
+static void randomize_type(tree type)
+{
+	tree variant;
+
+	gcc_assert(TREE_CODE(type) == RECORD_TYPE);
+
+	if (lookup_attribute("randomize_considered", TYPE_ATTRIBUTES(type)))
+		return;
+
+	if (lookup_attribute("randomize_layout", TYPE_ATTRIBUTES(TYPE_MAIN_VARIANT(type))) || is_pure_ops_struct(type))
+		relayout_struct(type);
+
+	for (variant = TYPE_MAIN_VARIANT(type); variant; variant = TYPE_NEXT_VARIANT(variant)) {
+		TYPE_ATTRIBUTES(type) = copy_list(TYPE_ATTRIBUTES(type));
+		TYPE_ATTRIBUTES(type) = tree_cons(get_identifier("randomize_considered"), NULL_TREE, TYPE_ATTRIBUTES(type));
+	}
+#ifdef __DEBUG_PLUGIN
+	fprintf(stderr, "Marking randomize_considered on struct %s\n", ORIG_TYPE_NAME(type));
+#ifdef __DEBUG_VERBOSE
+	debug_tree(type);
+#endif
+#endif
+}
+
+static void update_decl_size(tree decl)
+{
+	tree lastval, lastidx, field, init, type, flexsize;
+	unsigned HOST_WIDE_INT len;
+
+	type = TREE_TYPE(decl);
+
+	if (!lookup_attribute("has_flexarray", TYPE_ATTRIBUTES(type)))
+		return;
+
+	init = DECL_INITIAL(decl);
+	if (init == NULL_TREE || init == error_mark_node)
+		return;
+
+	if (TREE_CODE(init) != CONSTRUCTOR)
+		return;
+
+	len = CONSTRUCTOR_NELTS(init);
+        if (!len)
+		return;
+
+	lastval = CONSTRUCTOR_ELT(init, CONSTRUCTOR_NELTS(init) - 1)->value;
+	lastidx = CONSTRUCTOR_ELT(init, CONSTRUCTOR_NELTS(init) - 1)->index;
+
+	for (field = TYPE_FIELDS(TREE_TYPE(decl)); TREE_CHAIN(field); field = TREE_CHAIN(field))
+		;
+
+	if (lastidx != field)
+		return;
+
+	if (TREE_CODE(lastval) != STRING_CST) {
+		error("Only string constants are supported as initializers "
+		      "for randomized structures with flexible arrays");
+		return;
+	}
+
+	flexsize = bitsize_int(TREE_STRING_LENGTH(lastval) *
+		tree_to_uhwi(TYPE_SIZE(TREE_TYPE(TREE_TYPE(lastval)))));
+
+	DECL_SIZE(decl) = size_binop(PLUS_EXPR, TYPE_SIZE(type), flexsize);
+
+	return;
+}
+
+
+static void randomize_layout_finish_decl(void *event_data, void *data)
+{
+	tree decl = (tree)event_data;
+	tree type;
+
+	if (decl == NULL_TREE || decl == error_mark_node)
+		return;
+
+	type = TREE_TYPE(decl);
+
+	if (TREE_CODE(decl) != VAR_DECL)
+		return;
+
+	if (TREE_CODE(type) != RECORD_TYPE && TREE_CODE(type) != UNION_TYPE)
+		return;
+
+	if (!lookup_attribute("randomize_performed", TYPE_ATTRIBUTES(type)))
+		return;
+
+	DECL_SIZE(decl) = 0;
+	DECL_SIZE_UNIT(decl) = 0;
+	DECL_ALIGN(decl) = 0;
+	DECL_MODE (decl) = VOIDmode;
+	SET_DECL_RTL(decl, 0);
+	update_decl_size(decl);
+	layout_decl(decl, 0);
+}
+
+static void finish_type(void *event_data, void *data)
+{
+	tree type = (tree)event_data;
+
+	if (type == NULL_TREE || type == error_mark_node)
+		return;
+
+	if (TREE_CODE(type) != RECORD_TYPE)
+		return;
+
+	if (TYPE_FIELDS(type) == NULL_TREE)
+		return;
+
+	if (lookup_attribute("randomize_considered", TYPE_ATTRIBUTES(type)))
+		return;
+
+#ifdef __DEBUG_PLUGIN
+	fprintf(stderr, "Calling randomize_type on %s\n", ORIG_TYPE_NAME(type));
+#endif
+#ifdef __DEBUG_VERBOSE
+	debug_tree(type);
+#endif
+	randomize_type(type);
+
+	return;
+}
+
+static struct attribute_spec randomize_layout_attr = {
+	.name		= "randomize_layout",
+	// related to args
+	.min_length	= 0,
+	.max_length	= 0,
+	.decl_required	= false,
+	// need type declaration
+	.type_required	= true,
+	.function_type_required = false,
+	.handler		= handle_randomize_layout_attr,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity  = true
+#endif
+};
+
+static struct attribute_spec no_randomize_layout_attr = {
+	.name		= "no_randomize_layout",
+	// related to args
+	.min_length	= 0,
+	.max_length	= 0,
+	.decl_required	= false,
+	// need type declaration
+	.type_required	= true,
+	.function_type_required = false,
+	.handler		= handle_randomize_layout_attr,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity  = true
+#endif
+};
+
+static struct attribute_spec randomize_considered_attr = {
+	.name		= "randomize_considered",
+	// related to args
+	.min_length	= 0,
+	.max_length	= 0,
+	.decl_required	= false,
+	// need type declaration
+	.type_required	= true,
+	.function_type_required = false,
+	.handler		= handle_randomize_considered_attr,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity  = false
+#endif
+};
+
+static struct attribute_spec randomize_performed_attr = {
+	.name		= "randomize_performed",
+	// related to args
+	.min_length	= 0,
+	.max_length	= 0,
+	.decl_required	= false,
+	// need type declaration
+	.type_required	= true,
+	.function_type_required = false,
+	.handler		= handle_randomize_performed_attr,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity  = false
+#endif
+};
+
+static void register_attributes(void *event_data, void *data)
+{
+	register_attribute(&randomize_layout_attr);
+	register_attribute(&no_randomize_layout_attr);
+	register_attribute(&randomize_considered_attr);
+	register_attribute(&randomize_performed_attr);
+}
+
+static void check_bad_casts_in_constructor(tree var, tree init)
+{
+	unsigned HOST_WIDE_INT idx;
+	tree field, val;
+	tree field_type, val_type;
+
+	FOR_EACH_CONSTRUCTOR_ELT(CONSTRUCTOR_ELTS(init), idx, field, val) {
+		if (TREE_CODE(val) == CONSTRUCTOR) {
+			check_bad_casts_in_constructor(var, val);
+			continue;
+		}
+
+		/* pipacs' plugin creates franken-arrays that differ from those produced by
+		   normal code which all have valid 'field' trees. work around this */
+		if (field == NULL_TREE)
+			continue;
+		field_type = TREE_TYPE(field);
+		val_type = TREE_TYPE(val);
+
+		if (TREE_CODE(field_type) != POINTER_TYPE || TREE_CODE(val_type) != POINTER_TYPE)
+			continue;
+
+		if (field_type == val_type)
+			continue;
+
+		field_type = TYPE_MAIN_VARIANT(strip_array_types(TYPE_MAIN_VARIANT(TREE_TYPE(field_type))));
+		val_type = TYPE_MAIN_VARIANT(strip_array_types(TYPE_MAIN_VARIANT(TREE_TYPE(val_type))));
+
+		if (field_type == void_type_node)
+			continue;
+		if (field_type == val_type)
+			continue;
+		if (TREE_CODE(val_type) != RECORD_TYPE)
+			continue;
+
+		if (!lookup_attribute("randomize_performed", TYPE_ATTRIBUTES(val_type)))
+			continue;
+		inform(DECL_SOURCE_LOCATION(var), "found mismatched struct pointer types: %qT and %qT\n", TYPE_MAIN_VARIANT(field_type), TYPE_MAIN_VARIANT(val_type));
+	}
+}
+
+/* derived from the constify plugin */
+static void check_global_variables(void *event_data, void *data)
+{
+	struct varpool_node *node;
+	tree init;
+
+	FOR_EACH_VARIABLE(node) {
+		tree var = NODE_DECL(node);
+		init = DECL_INITIAL(var);
+		if (init == NULL_TREE)
+			continue;
+
+		if (TREE_CODE(init) != CONSTRUCTOR)
+			continue;
+
+		check_bad_casts_in_constructor(var, init);
+	}
+}
+
+static bool dominated_by_is_err(const_tree rhs, basic_block bb)
+{
+	basic_block dom;
+	gimple dom_stmt;
+	gimple call_stmt;
+	const_tree dom_lhs;
+	const_tree poss_is_err_cond;
+	const_tree poss_is_err_func;
+	const_tree is_err_arg;
+
+	dom = get_immediate_dominator(CDI_DOMINATORS, bb);
+	if (!dom)
+		return false;
+
+	dom_stmt = last_stmt(dom);
+	if (!dom_stmt)
+		return false;
+
+	if (gimple_code(dom_stmt) != GIMPLE_COND)
+		return false;
+
+	if (gimple_cond_code(dom_stmt) != NE_EXPR)
+		return false;
+
+	if (!integer_zerop(gimple_cond_rhs(dom_stmt)))
+		return false;
+
+	poss_is_err_cond = gimple_cond_lhs(dom_stmt);
+
+	if (TREE_CODE(poss_is_err_cond) != SSA_NAME)
+		return false;
+
+	call_stmt = SSA_NAME_DEF_STMT(poss_is_err_cond);
+
+	if (gimple_code(call_stmt) != GIMPLE_CALL)
+		return false;
+
+	dom_lhs = gimple_get_lhs(call_stmt);
+	poss_is_err_func = gimple_call_fndecl(call_stmt);
+	if (!poss_is_err_func)
+		return false;
+	if (dom_lhs != poss_is_err_cond)
+		return false;
+	if (strcmp(DECL_NAME_POINTER(poss_is_err_func), "IS_ERR"))
+		return false;
+
+	is_err_arg = gimple_call_arg(call_stmt, 0);
+	if (!is_err_arg)
+		return false;
+
+	if (is_err_arg != rhs)
+		return false;
+
+	return true;
+}
+
+static void handle_local_var_initializers(void)
+{
+	tree var;
+	unsigned int i;
+
+	FOR_EACH_LOCAL_DECL(cfun, i, var) {
+		tree init = DECL_INITIAL(var);
+		if (!init)
+			continue;
+		if (TREE_CODE(init) != CONSTRUCTOR)
+			continue;
+		check_bad_casts_in_constructor(var, init);
+	}
+}
+
+/*
+ * iterate over all statements to find "bad" casts:
+ * those where the address of the start of a structure is cast
+ * to a pointer of a structure of a different type, or a
+ * structure pointer type is cast to a different structure pointer type
+ */
+static unsigned int find_bad_casts_execute(void)
+{
+	basic_block bb;
+
+	handle_local_var_initializers();
+
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			gimple stmt;
+			const_tree lhs;
+			const_tree lhs_type;
+			const_tree rhs1;
+			const_tree rhs_type;
+			const_tree ptr_lhs_type;
+			const_tree ptr_rhs_type;
+			const_tree op0;
+			const_tree op0_type;
+			enum tree_code rhs_code;
+
+			stmt = gsi_stmt(gsi);
+
+#ifdef __DEBUG_PLUGIN
+#ifdef __DEBUG_VERBOSE
+			debug_gimple_stmt(stmt);
+			debug_tree(gimple_get_lhs(stmt));
+#endif
+#endif
+
+			if (gimple_code(stmt) != GIMPLE_ASSIGN)
+				continue;
+
+#ifdef __DEBUG_PLUGIN
+#ifdef __DEBUG_VERBOSE
+			debug_tree(gimple_assign_rhs1(stmt));
+#endif
+#endif
+
+			rhs_code = gimple_assign_rhs_code(stmt);
+
+			if (rhs_code != ADDR_EXPR && rhs_code != SSA_NAME)
+				continue;
+
+			lhs = gimple_get_lhs(stmt);
+			lhs_type = TREE_TYPE(lhs);
+			rhs1 = gimple_assign_rhs1(stmt);
+			rhs_type = TREE_TYPE(rhs1);
+
+			if (TREE_CODE(rhs_type) != POINTER_TYPE ||
+			    TREE_CODE(lhs_type) != POINTER_TYPE)
+				continue;
+
+			ptr_lhs_type = TYPE_MAIN_VARIANT(strip_array_types(TYPE_MAIN_VARIANT(TREE_TYPE(lhs_type))));
+			ptr_rhs_type = TYPE_MAIN_VARIANT(strip_array_types(TYPE_MAIN_VARIANT(TREE_TYPE(rhs_type))));
+
+			if (ptr_rhs_type == void_type_node)
+				continue;
+
+			if (ptr_lhs_type == void_type_node)
+				continue;
+
+			if (dominated_by_is_err(rhs1, bb))
+				continue;
+
+			if (TREE_CODE(ptr_rhs_type) != RECORD_TYPE) {
+#ifndef __DEBUG_PLUGIN
+				if (lookup_attribute("randomize_performed", TYPE_ATTRIBUTES(ptr_lhs_type)))
+#endif
+				inform(gimple_location(stmt), "found mismatched struct pointer types: %qT and %qT\n", ptr_lhs_type, ptr_rhs_type);
+				continue;
+			}
+
+			if (rhs_code == SSA_NAME && ptr_lhs_type == ptr_rhs_type)
+				continue;
+
+			if (rhs_code == ADDR_EXPR) {
+				op0 = TREE_OPERAND(rhs1, 0);
+
+				if (op0 == NULL_TREE)
+					continue;
+
+				if (TREE_CODE(op0) != VAR_DECL)
+					continue;
+
+				op0_type = TYPE_MAIN_VARIANT(strip_array_types(TYPE_MAIN_VARIANT(TREE_TYPE(op0))));
+				if (op0_type == ptr_lhs_type)
+					continue;
+
+#ifndef __DEBUG_PLUGIN
+				if (lookup_attribute("randomize_performed", TYPE_ATTRIBUTES(op0_type)))
+#endif
+				inform(gimple_location(stmt), "found mismatched struct pointer types: %qT and %qT\n", ptr_lhs_type, op0_type);
+			} else {
+				const_tree ssa_name_var = SSA_NAME_VAR(rhs1);
+				/* skip bogus type casts introduced by container_of */
+				if (ssa_name_var != NULL_TREE && DECL_NAME(ssa_name_var) && 
+				    !strcmp((const char *)DECL_NAME_POINTER(ssa_name_var), "__mptr"))
+					continue;
+#ifndef __DEBUG_PLUGIN
+				if (lookup_attribute("randomize_performed", TYPE_ATTRIBUTES(ptr_rhs_type)))
+#endif
+				inform(gimple_location(stmt), "found mismatched struct pointer types: %qT and %qT\n", ptr_lhs_type, ptr_rhs_type);
+			}
+
+		}
+	}
+	return 0;
+}
+
+#define PASS_NAME find_bad_casts
+#define NO_GATE
+#define TODO_FLAGS_FINISH TODO_dump_func
+#include "gcc-generate-gimple-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	int i;
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	bool enable = true;
+	int obtained_seed = 0;
+	struct register_pass_info find_bad_casts_pass_info;
+
+	find_bad_casts_pass_info.pass			= make_find_bad_casts_pass();
+	find_bad_casts_pass_info.reference_pass_name	= "ssa";
+	find_bad_casts_pass_info.ref_pass_instance_number	= 1;
+	find_bad_casts_pass_info.pos_op			= PASS_POS_INSERT_AFTER;
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	if (strncmp(lang_hooks.name, "GNU C", 5) && !strncmp(lang_hooks.name, "GNU C+", 6)) {
+		inform(UNKNOWN_LOCATION, G_("%s supports C only, not %s"), plugin_name, lang_hooks.name);
+		enable = false;
+	}
+
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "disable")) {
+			enable = false;
+			continue;
+		}
+		if (!strcmp(argv[i].key, "performance-mode")) {
+			performance_mode = 1;
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	if (strlen(randstruct_seed) != 64) {
+		error(G_("invalid seed value supplied for %s plugin"), plugin_name);
+		return 1;
+	}
+	obtained_seed = sscanf(randstruct_seed, "%016llx%016llx%016llx%016llx",
+		&shuffle_seed[0], &shuffle_seed[1], &shuffle_seed[2], &shuffle_seed[3]);
+	if (obtained_seed != 4) {
+		error(G_("Invalid seed supplied for %s plugin"), plugin_name);
+		return 1;
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &randomize_layout_plugin_info);
+	if (enable) {
+		register_callback(plugin_name, PLUGIN_ALL_IPA_PASSES_START, check_global_variables, NULL);
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &find_bad_casts_pass_info);
+		register_callback(plugin_name, PLUGIN_FINISH_TYPE, finish_type, NULL);
+		register_callback(plugin_name, PLUGIN_FINISH_DECL, randomize_layout_finish_decl, NULL);
+	}
+	register_callback(plugin_name, PLUGIN_ATTRIBUTES, register_attributes, NULL);
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/rap_plugin/Makefile b/scripts/gcc-plugins/rap_plugin/Makefile
new file mode 100644
index 000000000..f2a0a035c
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/Makefile
@@ -0,0 +1,6 @@
+$(HOSTLIBS)-$(CONFIG_PAX_RAP) += rap_plugin.so
+always := $($(HOSTLIBS)-y)
+
+rap_plugin-objs := $(patsubst $(srctree)/$(src)/%.c,%.o,$(wildcard $(srctree)/$(src)/*.c))
+
+clean-files += *.so
diff --git b/scripts/gcc-plugins/rap_plugin/rap.h b/scripts/gcc-plugins/rap_plugin/rap.h
new file mode 100644
index 000000000..f6a284da4
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/rap.h
@@ -0,0 +1,36 @@
+#ifndef RAP_H_INCLUDED
+#define RAP_H_INCLUDED
+
+#include "gcc-common.h"
+
+typedef struct {
+	int hash; // will be sign extended to long in reality
+} rap_hash_t;
+
+typedef struct {
+	unsigned int qual_const:1;
+	unsigned int qual_volatile:1;
+} rap_hash_flags_t;
+extern rap_hash_flags_t imprecise_rap_hash_flags;
+
+extern bool report_fptr_hash;
+
+extern GTY(()) tree rap_hash_type_node;
+
+void siphash24fold(unsigned char *out, const unsigned char *in, unsigned long long inlen, const unsigned char *k);
+void rap_calculate_func_hashes(void *event_data, void *data);
+rap_hash_t rap_hash_function_type(const_tree fntype, rap_hash_flags_t flags);
+rap_hash_t rap_hash_function_decl(const_tree fndecl, rap_hash_flags_t flags);
+rap_hash_t rap_hash_function_node_imprecise(cgraph_node_ptr node);
+const_tree type_name(const_tree type);
+tree create_new_var(tree type, const char *name);
+
+gimple barrier(tree var, bool full);
+
+#if BUILDING_GCC_VERSION >= 4009
+opt_pass *make_rap_fptr_pass(void);
+#else
+struct opt_pass *make_rap_fptr_pass(void);
+#endif
+
+#endif
diff --git b/scripts/gcc-plugins/rap_plugin/rap_fptr_pass.c b/scripts/gcc-plugins/rap_plugin/rap_fptr_pass.c
new file mode 100644
index 000000000..2f53f142a
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/rap_fptr_pass.c
@@ -0,0 +1,220 @@
+/*
+ * Copyright 2012-2016 by PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Homepage: http://pax.grsecurity.net/
+ */
+
+#include "rap.h"
+
+bool report_fptr_hash;
+
+static bool rap_fptr_gate(void)
+{
+#ifdef TARGET_386
+	tree section;
+
+	if (!TARGET_64BIT || ix86_cmodel != CM_KERNEL)
+		return true;
+
+	section = lookup_attribute("section", DECL_ATTRIBUTES(current_function_decl));
+	if (!section || !TREE_VALUE(section))
+		return true;
+
+	section = TREE_VALUE(TREE_VALUE(section));
+	return strncmp(TREE_STRING_POINTER(section), ".vsyscall_", 10);
+#else
+#error unsupported target
+#endif
+}
+
+static tree build_rap_hash(gimple call_stmt, tree fntype)
+{
+	rap_hash_t hash;
+
+	hash = rap_hash_function_type(fntype, imprecise_rap_hash_flags);
+	if (report_fptr_hash)
+		inform(gimple_location(call_stmt), "fptr rap_hash: %x", hash.hash);
+	return build_int_cst_type(rap_hash_type_node, hash.hash);
+}
+
+// check the function hash of the target of the fptr
+static basic_block rap_instrument_fptr(gimple_stmt_iterator *gsi)
+{
+	gimple assign_hash, check_hash, call_stmt, stmt;
+	location_t loc;
+	tree computed_hash, target_hash, fptr, fntype;
+#if BUILDING_GCC_VERSION == 4005
+	tree fptr2;
+#endif
+	basic_block cond_bb, join_bb, true_bb;
+	edge e;
+	const HOST_WIDE_INT rap_hash_offset = TARGET_64BIT ? 2 * sizeof(rap_hash_t) : sizeof(rap_hash_t);
+
+	call_stmt = gsi_stmt(*gsi);
+	loc = gimple_location(call_stmt);
+	fptr = gimple_call_fn(call_stmt);
+	fntype = TREE_TYPE(TREE_TYPE(fptr));
+
+	if (TREE_CODE(fntype) == FUNCTION_TYPE) {
+		computed_hash = build_rap_hash(call_stmt, fntype);
+	} else {
+		debug_tree(fntype);
+		gcc_unreachable();
+	}
+
+	// target_hash = ((s64*)fptr)[-rap_hash_offset]
+	target_hash = create_tmp_var(rap_hash_type_node, "rap_hash");
+	add_referenced_var(target_hash);
+	target_hash = make_ssa_name(target_hash, NULL);
+#if BUILDING_GCC_VERSION == 4005
+	fptr2 = create_tmp_var(ptr_type_node, "rap_fptr2");
+	fptr2 = make_ssa_name(fptr2, NULL);
+	assign_hash = gimple_build_assign(fptr2, build2(POINTER_PLUS_EXPR, ptr_type_node, fptr, build_int_cst_type(sizetype, -rap_hash_offset)));
+	gimple_set_location(assign_hash, loc);
+	SSA_NAME_DEF_STMT(fptr2) = assign_hash;
+	gsi_insert_before(gsi, assign_hash, GSI_SAME_STMT);
+	update_stmt(assign_hash);
+	fptr = gimple_get_lhs(assign_hash);
+
+	fptr2 = create_tmp_var(build_pointer_type(rap_hash_type_node), "rap_fptr2");
+	fptr2 = make_ssa_name(fptr2, NULL);
+	assign_hash = gimple_build_assign(fptr2, fold_convert(build_pointer_type(TREE_TYPE(target_hash)), fptr));
+	gimple_set_location(assign_hash, loc);
+	SSA_NAME_DEF_STMT(fptr2) = assign_hash;
+	gsi_insert_before(gsi, assign_hash, GSI_SAME_STMT);
+	update_stmt(assign_hash);
+	fptr = gimple_get_lhs(assign_hash);
+
+	assign_hash = gimple_build_assign(target_hash, build1(INDIRECT_REF, rap_hash_type_node, fptr));
+#else
+	assign_hash = gimple_build_assign(target_hash, build2(MEM_REF, rap_hash_type_node, fptr, build_int_cst_type(build_pointer_type(rap_hash_type_node), -rap_hash_offset)));
+#endif
+	gimple_set_location(assign_hash, loc);
+	SSA_NAME_DEF_STMT(target_hash) = assign_hash;
+	gsi_insert_before(gsi, assign_hash, GSI_NEW_STMT);
+	update_stmt(assign_hash);
+
+	// compare target_hash against computed function hash
+	// bail out on mismatch
+	check_hash = gimple_build_cond(NE_EXPR, target_hash, computed_hash, NULL_TREE, NULL_TREE);
+	gimple_set_location(check_hash, loc);
+	gsi_insert_after(gsi, check_hash, GSI_NEW_STMT);
+
+	cond_bb = gimple_bb(gsi_stmt(*gsi));
+	gcc_assert(!gsi_end_p(*gsi));
+	gcc_assert(check_hash == gsi_stmt(*gsi));
+
+	e = split_block(cond_bb, gsi_stmt(*gsi));
+	cond_bb = e->src;
+	join_bb = e->dest;
+	e->flags = EDGE_FALSE_VALUE;
+	e->probability = REG_BR_PROB_BASE;
+
+	true_bb = create_empty_bb(EXIT_BLOCK_PTR_FOR_FN(cfun)->prev_bb);
+	make_edge(cond_bb, true_bb, EDGE_TRUE_VALUE | EDGE_PRESERVE);
+
+	gcc_assert(dom_info_available_p(CDI_DOMINATORS));
+	set_immediate_dominator(CDI_DOMINATORS, true_bb, cond_bb);
+	set_immediate_dominator(CDI_DOMINATORS, join_bb, cond_bb);
+
+	gcc_assert(cond_bb->loop_father == join_bb->loop_father);
+	add_bb_to_loop(true_bb, cond_bb->loop_father);
+
+	*gsi = gsi_start_bb(true_bb);
+
+	// this fake dependency is to prevent PRE from merging this BB with others of the same kind
+	stmt = barrier(fptr, false);
+	gimple_set_location(stmt, loc);
+	gsi_insert_after(gsi, stmt, GSI_CONTINUE_LINKING);
+
+	stmt = gimple_build_call(builtin_decl_implicit(BUILT_IN_TRAP), 0);
+	gimple_set_location(stmt, loc);
+	gsi_insert_after(gsi, stmt, GSI_CONTINUE_LINKING);
+
+	return join_bb;
+}
+
+// find all language level function pointer dereferences and verify the target function
+static unsigned int rap_fptr_execute(void)
+{
+	basic_block bb;
+
+	loop_optimizer_init(LOOPS_NORMAL | LOOPS_HAVE_RECORDED_EXITS);
+	gcc_assert(current_loops);
+
+	calculate_dominance_info(CDI_DOMINATORS);
+	calculate_dominance_info(CDI_POST_DOMINATORS);
+
+	// 1. loop through BBs and GIMPLE statements
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			// gimple match: h_1 = get_fptr (); D.2709_3 = h_1 (x_2(D));
+			tree fptr, fntype;
+			gimple call_stmt;
+
+			// is it a call ...
+			call_stmt = gsi_stmt(gsi);
+			if (!is_gimple_call(call_stmt))
+				continue;
+
+			fptr = gimple_call_fn(call_stmt);
+			if (!fptr)
+				continue;
+
+			switch (TREE_CODE(fptr)) {
+			default:
+				debug_gimple_stmt(call_stmt);
+				debug_tree(fptr);
+				debug_tree(TREE_TYPE(fptr));
+				gcc_unreachable();
+
+			case ADDR_EXPR:
+				continue;
+
+			case SSA_NAME:
+				if (SSA_NAME_VAR(fptr) == NULL_TREE)
+					break;
+
+				switch (TREE_CODE(SSA_NAME_VAR(fptr))) {
+				default:
+					debug_gimple_stmt(call_stmt);
+					debug_tree(fptr);
+					gcc_unreachable();
+
+				case VAR_DECL:
+				case PARM_DECL:
+					break;
+				}
+				break;
+
+			case INTEGER_CST:
+			case OBJ_TYPE_REF:
+				break;
+			}
+
+			// ... through a function pointer
+			fntype = TREE_TYPE(fptr);
+			if (TREE_CODE(fntype) != POINTER_TYPE)
+				continue;
+
+			fntype = TREE_TYPE(fntype);
+			gcc_assert(TREE_CODE(fntype) == FUNCTION_TYPE || TREE_CODE(fntype) == METHOD_TYPE);
+
+			bb = rap_instrument_fptr(&gsi);
+			gsi = gsi_start_bb(bb);
+		}
+	}
+
+	free_dominance_info(CDI_DOMINATORS);
+	free_dominance_info(CDI_POST_DOMINATORS);
+	loop_optimizer_finalize();
+
+	return 0;
+}
+
+#define PASS_NAME rap_fptr
+#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_remove_unused_locals | TODO_update_ssa | TODO_cleanup_cfg | TODO_rebuild_cgraph_edges | TODO_verify_flow
+#include "gcc-generate-gimple-pass.h"
diff --git b/scripts/gcc-plugins/rap_plugin/rap_hash.c b/scripts/gcc-plugins/rap_plugin/rap_hash.c
new file mode 100644
index 000000000..161102f5c
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/rap_hash.c
@@ -0,0 +1,380 @@
+/*
+ * Copyright 2012-2016 by PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Homepage: http://pax.grsecurity.net/
+ */
+
+#include "rap.h"
+
+static rap_hash_t *rap_imprecise_hashes;
+static int rap_cgraph_max_uid;
+
+static void rap_hash_function(const_tree fntype, rap_hash_flags_t flags, unsigned char sip_hash[8]);
+
+static const unsigned char rap_hash_tree_code[MAX_TREE_CODES] = {
+	[0] = 0,
+	[1] = 0,
+	[2] = 0,
+	[3] = 0,
+	[4] = 0,
+	[OFFSET_TYPE] = 10,
+	[ENUMERAL_TYPE] = 20,
+	[BOOLEAN_TYPE] = 30,
+	[INTEGER_TYPE] = 40,
+	[REAL_TYPE] = 50,
+	[POINTER_TYPE] = 60,
+	[REFERENCE_TYPE] = 70,
+#if BUILDING_GCC_VERSION >= 4006
+	[NULLPTR_TYPE] = 80,
+#endif
+	[FIXED_POINT_TYPE] = 0,
+	[COMPLEX_TYPE] = 100,
+	[VECTOR_TYPE] = 110,
+	[ARRAY_TYPE] = 120,
+	[RECORD_TYPE] = 130,
+	[UNION_TYPE] = 140,
+	[QUAL_UNION_TYPE] = 0,
+	[VOID_TYPE] = 160,
+#if BUILDING_GCC_VERSION >= 5000
+	[POINTER_BOUNDS_TYPE] = 170,
+#endif
+	[FUNCTION_TYPE] = 180,
+	[METHOD_TYPE] = 0,
+	[LANG_TYPE] = 0,
+};
+
+static void rap_fold_hash(unsigned char *out, const unsigned char *in, unsigned long long inlen)
+{
+	static const unsigned char rap_sip_key[16] = {
+		'P', 'a', 'X', ' ', 'T', 'e', 'a', 'm',
+		'R', 'A', 'P', ' ', 'H', 'A', 'S', 'H',
+	};
+
+	siphash24fold(out, in, inlen, rap_sip_key);
+}
+
+// compute the final hash value in the range [1,INT_MAX]
+// the % and +1 trick leaves the value 0 available for marking non-indirectly callable functions
+// and INT_MIN (0x80000000) for longjmp targets (sign extended)
+// return places will use the (sign extended) range [INT_MIN+1,-1] ([0x8000001,0xffffffff])
+static rap_hash_t rap_extract_hash(const unsigned char sip_hash[8])
+{
+	rap_hash_t hash;
+	unsigned long long dividend, divisor;
+
+	memcpy(&dividend, sip_hash, sizeof dividend);
+//	divisor = 1ULL << (sizeof hash * 8 - 1);
+//	divisor |= divisor - 1;
+	divisor = 0x7fffffffUL;
+	hash.hash = dividend % divisor + 1;
+	return hash;
+}
+
+static void rap_hash_type_name(const_tree type, unsigned char sip_hash[8])
+{
+	const_tree name = type_name(TYPE_MAIN_VARIANT(type));
+
+	// handle typedefs of anonymous structs/unions
+	if (name == NULL_TREE)
+		name = type_name(type);
+
+	if (name == NULL_TREE)
+		return;
+
+	gcc_assert(TREE_CODE(name) == IDENTIFIER_NODE);
+	rap_fold_hash(sip_hash, (const unsigned char *)IDENTIFIER_POINTER(name), IDENTIFIER_LENGTH(name));
+}
+
+static void rap_hash_type_precision(const_tree type, unsigned char sip_hash[8])
+{
+	unsigned HOST_WIDE_INT size;
+
+	gcc_assert(TYPE_PRECISION(type));
+
+	size = TYPE_PRECISION(type);
+	rap_fold_hash(sip_hash, (const unsigned char *)&size, sizeof size);
+}
+
+const_tree type_name(const_tree type)
+{
+	const_tree name;
+
+	name = TYPE_NAME(type);
+	if (!name)
+		return NULL_TREE;
+
+	switch (TREE_CODE(name)) {
+	case IDENTIFIER_NODE:
+		return name;
+
+	case TYPE_DECL:
+		gcc_assert(DECL_NAME(name));
+		return DECL_NAME(name);
+
+	default:
+		gcc_unreachable();
+	}
+}
+
+// the core computation of the rap hash
+// the first piece is a (hopefully) compiler independent encondig of the type, derived from the gcc tree code
+// the second piece is type specific information, such as the size, qualifiers, (recursively) referenced types, etc
+static void rap_hash_tree(const_tree type, rap_hash_flags_t flags, unsigned char sip_hash[8])
+{
+	enum tree_code code;
+	unsigned int attrs;
+
+	code = TREE_CODE(type);
+	attrs = rap_hash_tree_code[code];
+	if (!attrs) {
+		fprintf(stderr, "unhandled tree_code %s %d\n", get_tree_code_name(code), code);
+		debug_tree(type);
+		gcc_unreachable();
+	}
+	rap_fold_hash(sip_hash, (const unsigned char *)&attrs, sizeof attrs);
+
+	enum {
+	// attrs layout for
+		// - all types:
+		RAP_HASH_VOLATILE		= 1U << 31,
+		RAP_HASH_NOT_VOLATILE		= 1U << 30,
+		RAP_HASH_CONST			= 1U << 29,
+		RAP_HASH_NOT_CONST		= 1U << 28,
+
+		// - pointer types:
+		RAP_HASH_RESTRICT		= 1U << 27,
+		RAP_HASH_NOT_RESTRICT		= 1U << 26,
+
+		// - C integer types:
+		RAP_HASH_UNSIGNED		= 1U << 25,
+		RAP_HASH_SIGNED			= 1U << 24,
+
+		RAP_HASH_UNQUALIFIED_CHAR	= 1U << 23,
+		RAP_HASH_CHAR			= 1U << 22,
+		RAP_HASH_SHORT			= 1U << 21,
+		RAP_HASH_INT			= 1U << 20,
+		RAP_HASH_LONG			= 1U << 19,
+		RAP_HASH_LONG_LONG		= 1U << 18,
+		RAP_HASH_WCHAR			= 1U << 17,
+		RAP_HASH_CHAR16			= 1U << 16,
+		RAP_HASH_CHAR32			= 1U << 15,
+
+		// - C float types
+		RAP_HASH_FLOAT			= 1U << 14,
+		RAP_HASH_DOUBLE			= 1U << 13,
+		RAP_HASH_LONG_DOUBLE		= 1U << 12,
+		RAP_HASH_DFLOAT32		= 1U << 11,
+		RAP_HASH_DFLOAT64		= 1U << 10,
+		RAP_HASH_DFLOAT128		= 1U << 9,
+	};
+
+	attrs = 0;
+	if (flags.qual_volatile)
+		attrs |= TYPE_VOLATILE(type) ? RAP_HASH_VOLATILE : RAP_HASH_NOT_VOLATILE;
+	if (flags.qual_const)
+		attrs |= TYPE_READONLY(type) ? RAP_HASH_CONST : RAP_HASH_NOT_CONST;
+
+	switch (code) {
+	default:
+		debug_tree(type);
+		gcc_unreachable();
+		break;
+
+	case VOID_TYPE:
+		break;
+
+	case OFFSET_TYPE:
+		rap_hash_tree(TREE_TYPE(type), flags, sip_hash);
+		rap_hash_tree(TYPE_OFFSET_BASETYPE(type), flags, sip_hash);
+		break;
+
+	case FUNCTION_TYPE:
+		rap_hash_function(type, flags, sip_hash);
+		break;
+
+	case RECORD_TYPE:
+		rap_hash_type_name(type, sip_hash);
+		break;
+
+	case UNION_TYPE:
+		rap_hash_type_name(type, sip_hash);
+		break;
+
+	case POINTER_TYPE:
+	case REFERENCE_TYPE:
+		rap_hash_tree(TREE_TYPE(type), flags, sip_hash);
+		break;
+
+	case VECTOR_TYPE:
+		rap_hash_tree(TREE_TYPE(type), flags, sip_hash);
+		rap_hash_type_precision(TREE_TYPE(type), sip_hash);
+		break;
+
+	case ARRAY_TYPE:
+		rap_hash_tree(TREE_TYPE(type), flags, sip_hash);
+		break;
+
+	case REAL_TYPE: {
+		const_tree main_variant = TYPE_MAIN_VARIANT(type);
+
+		switch (TYPE_PRECISION(main_variant)) {
+		default:
+			debug_tree(type);
+			debug_tree(TYPE_MAIN_VARIANT(type));
+			gcc_unreachable();
+
+		case 32:
+//			attrs |= RAP_HASH_FLOAT;
+			break;
+
+		case 64:
+//			attrs |= RAP_HASH_DOUBLE;
+			break;
+
+		case 80:
+		case 128:
+			attrs |= RAP_HASH_LONG_DOUBLE;
+			break;
+		}
+		rap_hash_type_precision(main_variant, sip_hash);
+		break;
+	}
+
+	case ENUMERAL_TYPE:
+		rap_hash_type_name(type, sip_hash);
+	case BOOLEAN_TYPE:
+		rap_hash_type_precision(type, sip_hash);
+		break;
+
+	case INTEGER_TYPE: {
+		attrs |= TYPE_UNSIGNED(type) ? RAP_HASH_UNSIGNED : RAP_HASH_SIGNED;
+		rap_hash_type_precision(type, sip_hash);
+		break;
+	}
+	}
+
+	rap_fold_hash(sip_hash, (const unsigned char *)&attrs, sizeof attrs);
+}
+
+static const_tree rap_dequal_argtype(const_tree argtype)
+{
+	// since gcc/tree.c:free_lang_data_in_type removes const/volatile from the top level param decl
+	// we have to simulate it here as this can be called earlier from the frontend as well
+	if (TYPE_READONLY(argtype) || TYPE_VOLATILE(argtype)) {
+		int quals;
+
+		quals = TYPE_QUALS(argtype) & ~TYPE_QUAL_CONST & ~TYPE_QUAL_VOLATILE;
+		argtype = build_qualified_type(CONST_CAST_TREE(argtype), quals);
+	}
+
+	return argtype;
+}
+
+// main function to compute the rap hash for function types
+// while virtual class methods are always replaced with their ancestor,
+// callers can decide whether to fully utilize that information via flags.method_ancestor
+static void rap_hash_function(const_tree fntype, rap_hash_flags_t flags, unsigned char sip_hash[8])
+{
+	function_args_iterator args_iter;
+	const_tree arg;
+
+	switch (TREE_CODE(fntype)) {
+	default:
+		debug_tree(fntype);
+		gcc_unreachable();
+
+	case FUNCTION_TYPE:
+		// 1. hash the result
+		rap_hash_tree(TREE_TYPE(fntype), flags, sip_hash);
+
+		// 2. hash the function parameters
+		FOREACH_FUNCTION_ARGS(fntype, arg, args_iter) {
+			const_tree argtype = arg;
+
+			argtype = rap_dequal_argtype(argtype);
+			rap_hash_tree(argtype, flags, sip_hash);
+		}
+		break;
+	}
+}
+
+rap_hash_t rap_hash_function_type(const_tree fntype, rap_hash_flags_t flags)
+{
+	unsigned char sip_hash[8] = { };
+	rap_hash_t hash;
+
+	rap_hash_function(fntype, flags, sip_hash);
+	hash = rap_extract_hash(sip_hash);
+
+	gcc_assert(hash.hash);
+	return hash;
+}
+
+rap_hash_t rap_hash_function_decl(const_tree fndecl, rap_hash_flags_t flags)
+{
+	tree fntype;
+
+	gcc_assert(TREE_CODE(fndecl) == FUNCTION_DECL);
+	fntype = TREE_TYPE(fndecl);
+
+	switch (TREE_CODE(fntype)) {
+	default:
+		debug_tree(fndecl);
+		gcc_unreachable();
+
+	case FUNCTION_TYPE:
+		return rap_hash_function_type(fntype, flags);
+	}
+}
+
+rap_hash_t rap_hash_function_node_imprecise(cgraph_node_ptr node)
+{
+	rap_hash_t hash;
+	tree fndecl;
+
+	gcc_assert(rap_imprecise_hashes);
+
+	hash.hash = 0;
+	if (node->uid < rap_cgraph_max_uid)
+		hash = rap_imprecise_hashes[node->uid];
+
+	if (hash.hash)
+		return hash;
+
+	fndecl = NODE_DECL(node);
+	if (TREE_CODE(TREE_TYPE(fndecl)) == FUNCTION_TYPE)
+		return rap_hash_function_decl(fndecl, imprecise_rap_hash_flags);
+
+	debug_cgraph_node(node);
+	debug_tree(fndecl);
+	error("indirect call to function %qD with a reserved hash value", fndecl);
+	return hash;
+}
+
+void rap_calculate_func_hashes(void *event_data __unused, void *data __unused)
+{
+	cgraph_node_ptr node;
+	int uid;
+
+	gcc_assert(!rap_imprecise_hashes);
+
+	rap_imprecise_hashes = (rap_hash_t *)xcalloc(cgraph_max_uid, sizeof(*rap_imprecise_hashes));
+	rap_cgraph_max_uid = cgraph_max_uid;
+
+	FOR_EACH_FUNCTION(node) {
+		const_tree fndecl;
+
+		uid = node->uid;
+		gcc_assert(uid < rap_cgraph_max_uid);
+
+		if (node->global.inlined_to)
+			continue;
+
+		fndecl = NODE_DECL(node);
+		gcc_assert(fndecl);
+
+		rap_imprecise_hashes[uid] = rap_hash_function_decl(fndecl, imprecise_rap_hash_flags);
+		gcc_assert(rap_imprecise_hashes[uid].hash);
+	}
+}
diff --git b/scripts/gcc-plugins/rap_plugin/rap_plugin.c b/scripts/gcc-plugins/rap_plugin/rap_plugin.c
new file mode 100644
index 000000000..998fc0f32
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/rap_plugin.c
@@ -0,0 +1,505 @@
+/*
+ * Copyright 2012-2017 by PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Homepage: http://pax.grsecurity.net/
+ *
+ * Usage:
+ * $ # for 4.5/4.6/C based 4.7
+ * $ gcc -I`gcc -print-file-name=plugin`/include -I`gcc -print-file-name=plugin`/include/c-family -fPIC -shared -O2 -o rap_plugin.so rap_plugin.c
+ * $ # for C++ based 4.7/4.8+
+ * $ g++ -I`g++ -print-file-name=plugin`/include -I`g++ -print-file-name=plugin`/include/c-family -fPIC -shared -O2 -o rap_plugin.so rap_plugin.c
+ * $ gcc -fplugin=./rap_plugin.so -fplugin-arg-rap_plugin-check=call test.c -O2
+ */
+
+#include "rap.h"
+
+__visible int plugin_is_GPL_compatible;
+
+static struct plugin_info rap_plugin_info = {
+	.version	= "201604272100",
+	.help		= "check=call\tenable the corresponding features\n"
+			  "hash=abs,abs-finish,const,volatile\n"
+			  "report=func,fptr,abs\n"
+};
+
+rap_hash_flags_t imprecise_rap_hash_flags = {
+	.qual_const	= 1,
+	.qual_volatile	= 1,
+};
+
+tree rap_hash_type_node;
+
+static bool report_func_hash, report_abs_hash;
+
+// create the equivalent of
+// asm volatile("" : : : "memory");
+// or
+// asm("" : "+rm"(var));
+// or
+// asm("" : : "rm"(var));
+gimple barrier(tree var, bool full)
+{
+	gimple stmt;
+	gasm *asm_stmt;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(tree, gc) *inputs = NULL;
+	VEC(tree, gc) *outputs = NULL;
+	VEC(tree, gc) *clobbers = NULL;
+#else
+	vec<tree, va_gc> *inputs = NULL;
+	vec<tree, va_gc> *outputs = NULL;
+	vec<tree, va_gc> *clobbers = NULL;
+#endif
+
+	if (!var && full) {
+		tree clobber;
+
+		clobber = build_tree_list(NULL_TREE, build_const_char_string(7, "memory"));
+#if BUILDING_GCC_VERSION <= 4007
+		VEC_safe_push(tree, gc, clobbers, clobber);
+#else
+		vec_safe_push(clobbers, clobber);
+#endif
+	} else if (full) {
+		tree input, output;
+
+		input = build_tree_list(NULL_TREE, build_const_char_string(2, "0"));
+		input = chainon(NULL_TREE, build_tree_list(input, var));
+#if BUILDING_GCC_VERSION <= 4007
+		VEC_safe_push(tree, gc, inputs, input);
+#else
+		vec_safe_push(inputs, input);
+#endif
+
+		output = build_tree_list(NULL_TREE, build_const_char_string(4, "=rm"));
+		gcc_assert(SSA_NAME_VAR(var));
+		var = make_ssa_name(SSA_NAME_VAR(var), NULL);
+		output = chainon(NULL_TREE, build_tree_list(output, var));
+#if BUILDING_GCC_VERSION <= 4007
+		VEC_safe_push(tree, gc, outputs, output);
+#else
+		vec_safe_push(outputs, output);
+#endif
+	} else {
+		tree input;
+
+		input = build_tree_list(NULL_TREE, build_const_char_string(3, "rm"));
+		input = chainon(NULL_TREE, build_tree_list(input, var));
+#if BUILDING_GCC_VERSION <= 4007
+		VEC_safe_push(tree, gc, inputs, input);
+#else
+		vec_safe_push(inputs, input);
+#endif
+	}
+
+	stmt = gimple_build_asm_vec("", inputs, outputs, clobbers, NULL);
+	asm_stmt = as_a_gasm(stmt);
+	if (!var && full)
+		gimple_asm_set_volatile(asm_stmt, true);
+	else if (full)
+		SSA_NAME_DEF_STMT(var) = stmt;
+	return stmt;
+}
+
+static const struct gcc_debug_hooks *old_debug_hooks;
+static struct gcc_debug_hooks rap_debug_hooks;
+
+static bool __rap_cgraph_indirectly_callable(cgraph_node_ptr node, void *data)
+{
+#if BUILDING_GCC_VERSION >= 4008
+	if (NODE_SYMBOL(node)->externally_visible)
+#else
+	if (node->local.externally_visible)
+#endif
+		return true;
+
+	if (NODE_SYMBOL(node)->address_taken)
+		return true;
+
+	return false;
+}
+
+static bool rap_cgraph_indirectly_callable(cgraph_node_ptr node)
+{
+	return cgraph_for_node_and_aliases(node, __rap_cgraph_indirectly_callable, NULL, true);
+}
+
+static void rap_hash_align(tree decl)
+{
+	const unsigned HOST_WIDE_INT rap_hash_offset = TARGET_64BIT ? 2 * sizeof(rap_hash_t) : sizeof(rap_hash_t);
+	unsigned HOST_WIDE_INT skip;
+
+	skip = 1ULL << align_functions_log;
+	if (DECL_USER_ALIGN(decl))
+		return;
+
+	if (!optimize_function_for_speed_p(cfun))
+		return;
+
+	if (skip <= rap_hash_offset)
+		return;
+
+#ifdef TARGET_386
+	{
+		char padding[skip - rap_hash_offset];
+
+		// this byte sequence helps disassemblers not trip up on the following rap hash
+		memset(padding, 0xcc, sizeof padding - 1);
+		padding[sizeof padding - 1] = 0xb8;
+		if (TARGET_64BIT && sizeof padding > 1)
+			padding[sizeof padding - 2] = 0x48;
+		ASM_OUTPUT_ASCII(asm_out_file, padding, sizeof padding);
+	}
+#else
+	ASM_OUTPUT_SKIP(asm_out_file, skip - rap_hash_offset);
+#endif
+}
+
+static void rap_begin_function(tree decl)
+{
+	cgraph_node_ptr node;
+	rap_hash_t imprecise_rap_hash;
+
+	gcc_assert(debug_hooks == &rap_debug_hooks);
+
+	// chain to previous callback
+	if (old_debug_hooks && old_debug_hooks->begin_function)
+		old_debug_hooks->begin_function(decl);
+
+	// align the rap hash if necessary
+	rap_hash_align(decl);
+
+	// don't compute hash for functions called only directly
+	node = cgraph_get_node(decl);
+	gcc_assert(node);
+	if (!rap_cgraph_indirectly_callable(node)) {
+		imprecise_rap_hash.hash = 0;
+	} else {
+		imprecise_rap_hash = rap_hash_function_node_imprecise(node);
+	}
+
+	if (report_func_hash)
+		inform(DECL_SOURCE_LOCATION(decl), "func rap_hash: %x %s", imprecise_rap_hash.hash, IDENTIFIER_POINTER(DECL_ASSEMBLER_NAME(decl)));
+
+	if (TARGET_64BIT)
+		fprintf(asm_out_file, "\t.quad %#lx\t%s __rap_hash_%s\n", (long)imprecise_rap_hash.hash, ASM_COMMENT_START, IDENTIFIER_POINTER(DECL_ASSEMBLER_NAME(decl)));
+	else
+		fprintf(asm_out_file, "\t.long %#x\t%s __rap_hash_%s\n", imprecise_rap_hash.hash, ASM_COMMENT_START, IDENTIFIER_POINTER(DECL_ASSEMBLER_NAME(decl)));
+}
+
+static void rap_start_unit_common(void *gcc_data __unused, void *user_data __unused)
+{
+	rap_hash_type_node = long_integer_type_node;
+
+	if (debug_hooks)
+		rap_debug_hooks = *debug_hooks;
+	rap_debug_hooks.begin_function = rap_begin_function;
+	old_debug_hooks = debug_hooks;
+	debug_hooks = &rap_debug_hooks;
+}
+
+/*
+   emit an absolute symbol for each function that may be referenced through the plt
+     - all externs
+     - non-static functions
+       - use visibility instead?
+
+   .globl __rap_hash_func
+   .offset 0xhash_for_func
+   .type __rap_hash_func, @object
+   __rap_hash_func:
+   .previous
+*/
+static void rap_finish_unit(void *gcc_data __unused, void *user_data __unused)
+{
+	cgraph_node_ptr node;
+	rap_hash_t hash;
+
+	gcc_assert(debug_hooks == &rap_debug_hooks);
+
+	hash.hash = 0;
+	FOR_EACH_FUNCTION(node) {
+		tree fndecl;
+		const char *asmname;
+		char *name = NULL;
+
+		if (cgraph_function_body_availability(node) >= AVAIL_INTERPOSABLE) {
+			if (node->thunk.thunk_p || node->alias)
+				continue;
+			if (!rap_cgraph_indirectly_callable(node))
+				continue;
+		}
+
+#if BUILDING_GCC_VERSION >= 4007
+		gcc_assert(cgraph_function_or_thunk_node(node, NULL) == node);
+#endif
+
+		fndecl = NODE_DECL(node);
+		gcc_assert(fndecl);
+		if (DECL_IS_BUILTIN(fndecl) && DECL_BUILT_IN_CLASS(fndecl) == BUILT_IN_NORMAL)
+			continue;
+
+		if (!TREE_PUBLIC(fndecl))
+			continue;
+
+		if (DECL_ARTIFICIAL(fndecl))
+			continue;
+
+		if (DECL_ABSTRACT_ORIGIN(fndecl) && DECL_ABSTRACT_ORIGIN(fndecl) != fndecl)
+			continue;
+
+		gcc_assert(DECL_ASSEMBLER_NAME(fndecl));
+		asmname = IDENTIFIER_POINTER(DECL_ASSEMBLER_NAME(fndecl));
+		if (strchr(asmname, '.'))
+			continue;
+
+		if (asmname[0] == '*')
+			asmname++;
+
+		gcc_assert(asmname[0]);
+		gcc_assert(asprintf(&name, "__rap_hash_%s", asmname) != -1);
+
+		hash = rap_hash_function_node_imprecise(node);
+		if (report_abs_hash)
+			inform(DECL_SOURCE_LOCATION(fndecl), "abs rap_hash: %x %s", hash.hash, IDENTIFIER_POINTER(DECL_ASSEMBLER_NAME(fndecl)));
+
+		fprintf(asm_out_file, GLOBAL_ASM_OP " %s\n", name);
+		if (TARGET_64BIT)
+			fprintf(asm_out_file, "\t.offset %#lx\n", (long)hash.hash);
+		else
+			fprintf(asm_out_file, "\t.offset %#x\n", hash.hash);
+		ASM_OUTPUT_TYPE_DIRECTIVE(asm_out_file, name, "object");
+		ASM_OUTPUT_LABEL(asm_out_file, name);
+		free(name);
+	}
+
+	if (hash.hash)
+		fprintf(asm_out_file, "\t.previous\n");
+}
+
+#if BUILDING_GCC_VERSION >= 4007
+// emit the rap hash as an absolute symbol for all functions seen in the frontend
+// this is necessary as later unreferenced nodes will be removed yet we'd like to emit as many hashes as possible
+static void rap_finish_decl(void *event_data, void *data __unused)
+{
+	tree fndecl = (tree)event_data;
+	rap_hash_t hash;
+	const char *asmname;
+	char *name = NULL;
+
+	if (fndecl == error_mark_node)
+		return;
+
+	if (TREE_CODE(fndecl) != FUNCTION_DECL)
+		return;
+
+	if (!TREE_PUBLIC(fndecl))
+		return;
+
+	if (DECL_ARTIFICIAL(fndecl))
+		return;
+
+	if (DECL_ABSTRACT_ORIGIN(fndecl) && DECL_ABSTRACT_ORIGIN(fndecl) != fndecl)
+		return;
+
+	asmname = DECL_NAME_POINTER(fndecl);
+	gcc_assert(asmname[0]);
+
+	if (strchr(asmname, '.'))
+		return;
+
+	gcc_assert(asprintf(&name, "__rap_hash_%s", asmname) != -1);
+
+	hash = rap_hash_function_decl(fndecl, imprecise_rap_hash_flags);
+
+	if (report_abs_hash)
+		inform(DECL_SOURCE_LOCATION(fndecl), "abs rap_hash: %x %s", hash.hash, asmname);
+
+	fprintf(asm_out_file, GLOBAL_ASM_OP " %s\n", name);
+	if (TARGET_64BIT)
+		fprintf(asm_out_file, "\t.offset %#lx\n", (long)hash.hash);
+	else
+		fprintf(asm_out_file, "\t.offset %#x\n", hash.hash);
+	ASM_OUTPUT_TYPE_DIRECTIVE(asm_out_file, name, "object");
+	ASM_OUTPUT_LABEL(asm_out_file, name);
+	free(name);
+
+	fprintf(asm_out_file, "\t.previous\n");
+}
+#endif
+
+static bool rap_unignore_gate(void)
+{
+	if (!DECL_IGNORED_P(current_function_decl))
+		return false;
+
+	inform(DECL_SOURCE_LOCATION(current_function_decl), "DECL_IGNORED fixed");
+
+	DECL_IGNORED_P(current_function_decl) = 0;
+	return false;
+}
+
+#define PASS_NAME rap_unignore
+#define NO_EXECUTE
+#define TODO_FLAGS_FINISH TODO_dump_func
+#include "gcc-generate-rtl-pass.h"
+
+static bool rap_version_check(struct plugin_gcc_version *gcc_version, struct plugin_gcc_version *plugin_version)
+{
+	if (!gcc_version || !plugin_version)
+		return false;
+
+#if BUILDING_GCC_VERSION >= 5000
+	if (strncmp(gcc_version->basever, plugin_version->basever, 4))
+#else
+	if (strcmp(gcc_version->basever, plugin_version->basever))
+#endif
+		return false;
+	if (strcmp(gcc_version->datestamp, plugin_version->datestamp))
+		return false;
+	if (strcmp(gcc_version->devphase, plugin_version->devphase))
+		return false;
+	if (strcmp(gcc_version->revision, plugin_version->revision))
+		return false;
+//	if (strcmp(gcc_version->configuration_arguments, plugin_version->configuration_arguments))
+//		return false;
+	return true;
+}
+
+EXPORTED_CONST struct ggc_root_tab gt_ggc_r_gt_rap[] = {
+	{
+		.base = &rap_hash_type_node,
+		.nelt = 1,
+		.stride = sizeof(rap_hash_type_node),
+		.cb = &gt_ggc_mx_tree_node,
+		.pchw = &gt_pch_nx_tree_node
+	},
+	LAST_GGC_ROOT_TAB
+};
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	int i;
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	bool enable_call = false;
+	bool enable_abs = false, enable_abs_finish = false;
+
+	PASS_INFO(rap_fptr, "nrv", 1, PASS_POS_INSERT_AFTER);
+	PASS_INFO(rap_unignore, "final", 1, PASS_POS_INSERT_BEFORE);
+
+	if (!rap_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+#if BUILDING_GCC_VERSION >= 5000
+	if (flag_ipa_icf_functions) {
+//		warning_at(UNKNOWN_LOCATION, 0, G_("-fipa-icf is incompatible with %s, disabling..."), plugin_name);
+//		inform(UNKNOWN_LOCATION, G_("-fipa-icf is incompatible with %s, disabling..."), plugin_name);
+		flag_ipa_icf_functions = 0;
+	}
+#endif
+
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "disable"))
+			continue;
+
+		if (!strcmp(argv[i].key, "check")) {
+			char *values, *value, *saveptr;
+
+			if (!argv[i].value) {
+				error(G_("no value supplied for option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+				continue;
+			}
+
+			values = xstrdup(argv[i].value);
+			value = strtok_r(values, ",", &saveptr);
+			while (value) {
+				if (!strcmp(value, "call"))
+					enable_call = true;
+				else
+					error(G_("unknown value supplied for option '-fplugin-arg-%s-%s=%s'"), plugin_name, argv[i].key, value);
+				value = strtok_r(NULL, ",", &saveptr);
+			}
+			free(values);
+			continue;
+		}
+
+		if (!strcmp(argv[i].key, "hash")) {
+			char *values, *value, *saveptr;
+
+			if (!argv[i].value) {
+				error(G_("no value supplied for option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+				continue;
+			}
+
+			values = xstrdup(argv[i].value);
+			value = strtok_r(values, ",", &saveptr);
+			while (value) {
+				if (!strcmp(value, "abs"))
+					enable_abs = enable_abs_finish = true;
+				else if (!strcmp(value, "abs-finish"))
+					enable_abs_finish = true;
+//				else if (!strcmp(value, "const"))
+//					imprecise_rap_hash_flags.qual_const = 1;
+//				else if (!strcmp(value, "volatile"))
+//					imprecise_rap_hash_flags.qual_volatile = 1;
+				else
+					error(G_("unknown value supplied for option '-fplugin-arg-%s-%s=%s'"), plugin_name, argv[i].key, value);
+				value = strtok_r(NULL, ",", &saveptr);
+			}
+			free(values);
+			continue;
+		}
+
+		if (!strcmp(argv[i].key, "report")) {
+			char *values, *value, *saveptr;
+
+			if (!argv[i].value) {
+				error(G_("no value supplied for option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+				continue;
+			}
+
+			values = xstrdup(argv[i].value);
+			value = strtok_r(values, ",", &saveptr);
+			while (value) {
+				if (!strcmp(value, "func"))
+					report_func_hash = true;
+				else if (!strcmp(value, "fptr"))
+					report_fptr_hash = true;
+				else if (!strcmp(value, "abs"))
+					report_abs_hash = true;
+				else
+					error(G_("unknown value supplied for option '-fplugin-arg-%s-%s=%s'"), plugin_name, argv[i].key, value);
+				value = strtok_r(NULL, ",", &saveptr);
+			}
+			free(values);
+			continue;
+		}
+
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &rap_plugin_info);
+
+	if (enable_call) {
+#if BUILDING_GCC_VERSION >= 4007
+		if (enable_abs)
+			register_callback(plugin_name, PLUGIN_FINISH_DECL, rap_finish_decl, NULL);
+#else
+#warning TODO
+#endif
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &rap_unignore_pass_info);
+		register_callback(plugin_name, PLUGIN_START_UNIT, rap_start_unit_common, NULL);
+		register_callback(plugin_name, PLUGIN_REGISTER_GGC_ROOTS, NULL, (void *)&gt_ggc_r_gt_rap);
+		if (enable_abs_finish)
+			register_callback(plugin_name, PLUGIN_FINISH_UNIT, rap_finish_unit, NULL);
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &rap_fptr_pass_info);
+		register_callback(plugin_name, PLUGIN_ALL_IPA_PASSES_START, rap_calculate_func_hashes, NULL);
+	}
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/rap_plugin/sip.c b/scripts/gcc-plugins/rap_plugin/sip.c
new file mode 100644
index 000000000..65bc1cdea
--- /dev/null
+++ b/scripts/gcc-plugins/rap_plugin/sip.c
@@ -0,0 +1,96 @@
+// SipHash-2-4 adapted by the PaX Team from the public domain version written by
+//   Jean-Philippe Aumasson <jeanphilippe.aumasson@gmail.com>
+//   Daniel J. Bernstein <djb@cr.yp.to>
+
+#include <stdint.h>
+
+#define ROTL(x, b) (u64)(((x) << (b)) | ((x) >> (64 - (b))))
+
+#define U32TO8_LE(p, v)						\
+	(p)[0] = (u8)((v)      ); (p)[1] = (u8)((v) >>  8);	\
+	(p)[2] = (u8)((v) >> 16); (p)[3] = (u8)((v) >> 24);
+
+#define U64TO8_LE(p, v)				\
+	U32TO8_LE((p),     (u32)((v)      ));	\
+	U32TO8_LE((p) + 4, (u32)((v) >> 32));
+
+#define U8TO64_LE(p)	(	\
+	((u64)((p)[0])      ) |	\
+	((u64)((p)[1]) <<  8) |	\
+	((u64)((p)[2]) << 16) |	\
+	((u64)((p)[3]) << 24) |	\
+	((u64)((p)[4]) << 32) |	\
+	((u64)((p)[5]) << 40) |	\
+	((u64)((p)[6]) << 48) |	\
+	((u64)((p)[7]) << 56))
+
+#define SIPROUND							\
+do {									\
+	v0 += v1; v1 = ROTL(v1, 13); v1 ^= v0; v0 = ROTL(v0, 32);	\
+	v2 += v3; v3 = ROTL(v3, 16); v3 ^= v2;				\
+	v0 += v3; v3 = ROTL(v3, 21); v3 ^= v0;				\
+	v2 += v1; v1 = ROTL(v1, 17); v1 ^= v2; v2 = ROTL(v2, 32);	\
+} while(0)
+
+typedef uint64_t u64;
+typedef uint32_t u32;
+typedef uint8_t u8;
+
+/* SipHash-2-4 with previous output folding, a poor man's streaming interface */
+void siphash24fold(unsigned char *out, const unsigned char *in, unsigned long long inlen, const unsigned char *k);
+
+void siphash24fold(unsigned char *out, const unsigned char *in, unsigned long long inlen, const unsigned char *k)
+{
+	u64 k0 = U8TO64_LE(k);
+	u64 k1 = U8TO64_LE(k + 8);
+	/* "somepseudorandomlygeneratedbytes" */
+	u64 v0 = 0x736f6d6570736575ULL ^ k0;
+	u64 v1 = 0x646f72616e646f6dULL ^ k1;
+	u64 v2 = 0x6c7967656e657261ULL ^ k0;
+	u64 v3 = 0x7465646279746573ULL ^ k1;
+	u64 b, m;
+	const u8 * const end = in + inlen - (inlen % sizeof(u64));
+	const int left = inlen & 7;
+	b = ((u64)inlen) << 56;
+
+	// fold in the previous output
+	m = U8TO64_LE(out);
+	v3 ^= m;
+	SIPROUND;
+	SIPROUND;
+	v0 ^= m;
+
+	// consume full input blocks
+	for (; in != end; in += 8) {
+		m = U8TO64_LE(in);
+		v3 ^= m;
+		SIPROUND;
+		SIPROUND;
+		v0 ^= m;
+	}
+
+	// consume the last potentially partial block
+	switch (left) {
+	case 7: b |= ((u64)in[6]) << 48;
+	case 6: b |= ((u64)in[5]) << 40;
+	case 5: b |= ((u64)in[4]) << 32;
+	case 4: b |= ((u64)in[3]) << 24;
+	case 3: b |= ((u64)in[2]) << 16;
+	case 2: b |= ((u64)in[1]) <<  8;
+	case 1: b |= ((u64)in[0]); break;
+	case 0: break;
+	}
+
+	// finalize
+	v3 ^= b;
+	SIPROUND;
+	SIPROUND;
+	v0 ^= b;
+	v2 ^= 0xff;
+	SIPROUND;
+	SIPROUND;
+	SIPROUND;
+	SIPROUND;
+	b = v0 ^ v1 ^ v2 ^ v3;
+	U64TO8_LE(out, b);
+}
diff --git a/scripts/gcc-plugins/sancov_plugin.c b/scripts/gcc-plugins/sancov_plugin.c
index aedd6113c..f39cee30d 100644
--- a/scripts/gcc-plugins/sancov_plugin.c
+++ b/scripts/gcc-plugins/sancov_plugin.c
@@ -1,5 +1,5 @@
 /*
- * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
  * Licensed under the GPL v2, or (at your option) v3
  *
  * Homepage:
@@ -21,7 +21,7 @@
 
 #include "gcc-common.h"
 
-int plugin_is_GPL_compatible;
+__visible int plugin_is_GPL_compatible;
 
 tree sancov_fndecl;
 
@@ -62,6 +62,7 @@ static unsigned int sancov_execute(void)
 
 #include "gcc-generate-gimple-pass.h"
 
+#if BUILDING_GCC_VERSION < 6000
 static void sancov_start_unit(void __unused *gcc_data, void __unused *user_data)
 {
 	tree leaf_attr, nothrow_attr;
@@ -85,11 +86,11 @@ static void sancov_start_unit(void __unused *gcc_data, void __unused *user_data)
 	decl_attributes(&sancov_fndecl, leaf_attr, 0);
 #endif
 }
+#endif
 
-int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
 {
 	int i;
-	struct register_pass_info sancov_plugin_pass_info;
 	const char * const plugin_name = plugin_info->base_name;
 	const int argc = plugin_info->argc;
 	const struct plugin_argument * const argv = plugin_info->argv;
@@ -107,14 +108,11 @@ int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version
 	};
 
 	/* BBs can be split afterwards?? */
-	sancov_plugin_pass_info.pass				= make_sancov_pass();
 #if BUILDING_GCC_VERSION >= 4009
-	sancov_plugin_pass_info.reference_pass_name		= "asan";
+	PASS_INFO(sancov, "asan", 0, PASS_POS_INSERT_BEFORE);
 #else
-	sancov_plugin_pass_info.reference_pass_name		= "nrv";
+	PASS_INFO(sancov, "nrv", 1, PASS_POS_INSERT_BEFORE);
 #endif
-	sancov_plugin_pass_info.ref_pass_instance_number	= 0;
-	sancov_plugin_pass_info.pos_op				= PASS_POS_INSERT_BEFORE;
 
 	if (!plugin_default_version_check(version, &gcc_version)) {
 		error(G_("incompatible gcc/plugin versions"));
@@ -126,7 +124,7 @@ int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version
 			enable = false;
 			continue;
 		}
-		error(G_("unkown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
 	}
 
 	register_callback(plugin_name, PLUGIN_INFO, NULL, &sancov_plugin_info);
@@ -137,7 +135,7 @@ int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version
 #if BUILDING_GCC_VERSION < 6000
 	register_callback(plugin_name, PLUGIN_START_UNIT, &sancov_start_unit, NULL);
 	register_callback(plugin_name, PLUGIN_REGISTER_GGC_ROOTS, NULL, (void *)&gt_ggc_r_gt_sancov);
-	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &sancov_plugin_pass_info);
+	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &sancov_pass_info);
 #endif
 
 	return 0;
diff --git b/scripts/gcc-plugins/size_overflow_plugin/.gitignore b/scripts/gcc-plugins/size_overflow_plugin/.gitignore
new file mode 100644
index 000000000..36211fb36
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/.gitignore
@@ -0,0 +1,2 @@
+disable.h
+e_*.h
diff --git b/scripts/gcc-plugins/size_overflow_plugin/Makefile b/scripts/gcc-plugins/size_overflow_plugin/Makefile
new file mode 100644
index 000000000..a8039b2ba
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/Makefile
@@ -0,0 +1,22 @@
+HOST_EXTRACXXFLAGS += $(call hostcc-option, -fno-ipa-icf)
+
+$(HOSTLIBS)-$(CONFIG_PAX_SIZE_OVERFLOW) += size_overflow_plugin.so
+always := $($(HOSTLIBS)-y)
+
+size_overflow_plugin-objs := $(patsubst $(srctree)/$(src)/%.c,%.o,$(wildcard $(srctree)/$(src)/*.c))
+
+quiet_cmd_build_size_overflow_hash = GENHASH  $@
+      cmd_build_size_overflow_hash = \
+	$(CONFIG_SHELL) $(srctree)/$(src)/generate_size_overflow_hash.sh -s $(patsubst e_%,%,$(patsubst $(obj)/%.h,%,$@))_hash -d $< -o $@
+
+define build_size_overflow_hash
+targets += $(addsuffix .h,$(1))
+$(srctree)/$(src)/size_overflow_plugin_hash.c: $(addprefix $(obj)/,$(addsuffix .h,$(1)))
+$(addprefix $(obj)/,$(addsuffix .h,$(1))): $(addprefix $(src)/,$(addsuffix .data,$(1)))
+	$$(call if_changed,build_size_overflow_hash)
+endef
+
+size_overflow_hash_tables := e_fns e_fields e_fptrs e_vars e_aux disable
+$(foreach h,$(size_overflow_hash_tables),$(eval $(call build_size_overflow_hash,$(h))))
+
+clean-files += *.so
diff --git b/scripts/gcc-plugins/size_overflow_plugin/disable.data b/scripts/gcc-plugins/size_overflow_plugin/disable.data
new file mode 100644
index 000000000..83975f258
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/disable.data
@@ -0,0 +1,12472 @@
+disable_so_interrupt_pnode_gru_message_queue_desc_4 interrupt_pnode gru_message_queue_desc 0 4 NULL
+disable_so_bch_btree_insert_fndecl_12 bch_btree_insert fndecl 0 12 NULL
+disable_so_macvlan_sync_address_fndecl_22 macvlan_sync_address fndecl 0 22 NULL nohasharray
+disable_so_sil_iowrite8_fndecl_22 sil_iowrite8 fndecl 3-2 22 &disable_so_macvlan_sync_address_fndecl_22
+disable_so_addr_to_user_sctp_pf_23 addr_to_user sctp_pf 0 23 NULL nohasharray
+disable_so_signalquality_rtl_stats_23 signalquality rtl_stats 0 23 &disable_so_addr_to_user_sctp_pf_23
+disable_so_sem_otime_semid64_ds_29 sem_otime semid64_ds 0 29 NULL
+disable_so_rec8b_ide_timing_33 rec8b ide_timing 0 33 NULL
+disable_so_stime_task_struct_41 stime task_struct 0 41 NULL nohasharray
+disable_so_ulist_rbtree_search_fndecl_41 ulist_rbtree_search fndecl 2 41 &disable_so_stime_task_struct_41
+disable_so_pfuze100_set_ramp_delay_fndecl_52 pfuze100_set_ramp_delay fndecl 0-2 52 NULL
+disable_so_make_sockaddr_fndecl_54 make_sockaddr fndecl 2 54 NULL
+disable_so_mmap_min_addr_vardecl_56 mmap_min_addr vardecl 0 56 NULL nohasharray
+disable_so_mwl8k_cmd_get_watchdog_bitmap_fndecl_56 mwl8k_cmd_get_watchdog_bitmap fndecl 0 56 &disable_so_mmap_min_addr_vardecl_56
+disable_so_panel_power_down_delay_cdv_intel_dp_59 panel_power_down_delay cdv_intel_dp 0 59 NULL
+disable_so_max_ref_div_radeon_pll_60 max_ref_div radeon_pll 0 60 NULL
+disable_so_penirq_recheck_delay_usecs_ads7846_81 penirq_recheck_delay_usecs ads7846 0 81 NULL
+disable_so_cobalt_query_dv_timings_fndecl_82 cobalt_query_dv_timings fndecl 0 82 NULL
+disable_so_timeout_slgt_info_83 timeout slgt_info 0 83 NULL
+disable_so_radio_syn_reserved_addr28_b43_nphy_channeltab_entry_rev3_92 radio_syn_reserved_addr28 b43_nphy_channeltab_entry_rev3 0 92 NULL
+disable_so_vsc824x_ack_interrupt_fndecl_109 vsc824x_ack_interrupt fndecl 0 109 NULL
+disable_so_scan_timing_sh_keysc_info_117 scan_timing sh_keysc_info 0 117 NULL
+disable_so_cp_table_gpu_addr_radeon_rlc_124 cp_table_gpu_addr radeon_rlc 0 124 NULL
+disable_so_mpihelp_mul_karatsuba_case_fndecl_125 mpihelp_mul_karatsuba_case fndecl 3-5 125 NULL nohasharray
+disable_so_g84_cipher_object_ctor_fndecl_125 g84_cipher_object_ctor fndecl 0 125 &disable_so_mpihelp_mul_karatsuba_case_fndecl_125
+disable_so_current_nat_addr_fndecl_130 current_nat_addr fndecl 0-2 130 NULL
+disable_so_qla2x00_gid_pt_rsp_size_fndecl_134 qla2x00_gid_pt_rsp_size fndecl 0 134 NULL
+disable_so_zd_check_signal_fndecl_139 zd_check_signal fndecl 0-2 139 NULL
+disable_so_qlcnic_83xx_interrupt_test_fndecl_160 qlcnic_83xx_interrupt_test fndecl 0 160 NULL
+disable_so_show_cpu_clock_sel_fndecl_161 show_cpu_clock_sel fndecl 0 161 NULL
+disable_so_zd_usb_iowrite16v_async_fndecl_163 zd_usb_iowrite16v_async fndecl 3 163 NULL
+disable_so_si_get_mclk_frequency_ratio_fndecl_169 si_get_mclk_frequency_ratio fndecl 0-1 169 NULL
+disable_so_vactive_vblank_hi_detailed_pixel_timing_173 vactive_vblank_hi detailed_pixel_timing 0 173 NULL
+disable_so_ecryptfs_hash_bits_vardecl_messaging_c_174 ecryptfs_hash_bits vardecl_messaging.c 0 174 NULL
+disable_so_addr_efx_endpoint_page_189 addr efx_endpoint_page 0 189 NULL
+disable_so_uptime_proc_open_fndecl_190 uptime_proc_open fndecl 0 190 NULL
+disable_so_mtrr_tom2_vardecl_198 mtrr_tom2 vardecl 0 198 NULL
+disable_so_addr_sh_eth_txdesc_201 addr sh_eth_txdesc 0 201 NULL
+disable_so_ocfs2_info_handle_uuid_fndecl_202 ocfs2_info_handle_uuid fndecl 0 202 NULL
+disable_so_nf_oaktrail_hdmi_clock_216 nf oaktrail_hdmi_clock 0 216 NULL
+disable_so_cpufreq_p4_setdc_fndecl_226 cpufreq_p4_setdc fndecl 1-2 226 NULL
+disable_so_ieee80211_aes_ccm_decrypt_fndecl_227 ieee80211_aes_ccm_decrypt fndecl 0-5-7 227 NULL
+disable_so_l1oip_4bit_to_law_fndecl_247 l1oip_4bit_to_law fndecl 0-2 247 NULL
+disable_so_tune_timeout_vardecl_radio_si470x_common_c_250 tune_timeout vardecl_radio-si470x-common.c 0 250 NULL
+disable_so_ieee80211_aes_cmac_key_setup_fndecl_254 ieee80211_aes_cmac_key_setup fndecl 2 254 NULL
+disable_so_padlock_sha1_finup_fndecl_258 padlock_sha1_finup fndecl 0 258 NULL
+disable_so_iwl_dbgfs_interrupt_read_fndecl_261 iwl_dbgfs_interrupt_read fndecl 3-0 261 NULL
+disable_so_c2_del_addr_fndecl_280 c2_del_addr fndecl 2-3 280 NULL
+disable_so_get_systime_stmmac_hwtimestamp_281 get_systime stmmac_hwtimestamp 0 281 NULL
+disable_so_xfrm_flowi_saddr_fndecl_287 xfrm_flowi_saddr fndecl 2 287 NULL
+disable_so_lifetime_route_info_291 lifetime route_info 0 291 NULL
+disable_so_mtime_cifs_unix_set_info_args_293 mtime cifs_unix_set_info_args 0 293 NULL
+disable_so_sense_addr_mscp_296 sense_addr mscp 0 296 NULL
+disable_so_module_addr_max_rx_vardecl_module_c_304 module_addr_max_rx vardecl_module.c 0 304 NULL
+disable_so_cy8ctmg110_set_sleepmode_fndecl_309 cy8ctmg110_set_sleepmode fndecl 0 309 NULL
+disable_so_signal_cck_phy_hdr_312 signal cck_phy_hdr 0 312 NULL
+disable_so_i915_ring_freq_table_fndecl_313 i915_ring_freq_table fndecl 0 313 NULL
+disable_so_vga16fb_clock_chip_fndecl_316 vga16fb_clock_chip fndecl 2 316 NULL
+disable_so_abituguru_send_address_fndecl_319 abituguru_send_address fndecl 3 319 NULL
+disable_so_err_hci_request_321 err hci_request 0 321 NULL
+disable_so_timeout_sg_io_hdr_322 timeout sg_io_hdr 0 322 NULL
+disable_so_crypto_aead_maxauthsize_fndecl_331 crypto_aead_maxauthsize fndecl 0 331 NULL
+disable_so_gru_first_node_paddr_vardecl_x2apic_uv_x_c_335 gru_first_node_paddr vardecl_x2apic_uv_x.c 0 335 NULL
+disable_so_bitmap_subset_fndecl_340 bitmap_subset fndecl 3 340 NULL
+disable_so_intr_timer_vnic_fc_config_342 intr_timer vnic_fc_config 0 342 NULL
+disable_so_abort_timeout_iscsi_session_343 abort_timeout iscsi_session 0 343 NULL
+disable_so_crypto_authenc_esn_verify_fndecl_345 crypto_authenc_esn_verify fndecl 0 345 NULL
+disable_so_dn_hash_dump_zone_fndecl_347 dn_hash_dump_zone fndecl 0 347 NULL
+disable_so_new_center_freq_seg0_ieee80211_wide_bw_chansw_ie_350 new_center_freq_seg0 ieee80211_wide_bw_chansw_ie 0 350 NULL
+disable_so_ata_probe_timeout_vardecl_libata_core_c_353 ata_probe_timeout vardecl_libata-core.c 0 353 NULL
+disable_so_posix_cpu_clock_get_fndecl_354 posix_cpu_clock_get fndecl 1 354 NULL
+disable_so_ivtv_msleep_timeout_fndecl_356 ivtv_msleep_timeout fndecl 1 356 NULL nohasharray
+disable_so_wrmsrl_amd_safe_fndecl_356 wrmsrl_amd_safe fndecl 0 356 &disable_so_ivtv_msleep_timeout_fndecl_356
+disable_so_bp_tss_segment_16_362 bp tss_segment_16 0 362 NULL
+disable_so_btree_level_jset_372 btree_level jset 0 372 NULL
+disable_so_addr_mlx5_wqe_data_seg_376 addr mlx5_wqe_data_seg 0 376 NULL
+disable_so_pos_encryptor_desc_380 pos encryptor_desc 0 380 NULL
+disable_so_des4_idmac_desc_64addr_382 des4 idmac_desc_64addr 0 382 NULL
+disable_so_huptimer_isdn_net_local_s_386 huptimer isdn_net_local_s 0 386 NULL
+disable_so_ali_settimer_fndecl_390 ali_settimer fndecl 1 390 NULL
+disable_so_show_constraint_time_window_us_fndecl_393 show_constraint_time_window_us fndecl 0 393 NULL nohasharray
+disable_so_queue_con_delay_fndecl_393 queue_con_delay fndecl 2 393 &disable_so_show_constraint_time_window_us_fndecl_393
+disable_so_btrfs_insert_delayed_item_fndecl_394 btrfs_insert_delayed_item fndecl 0 394 NULL nohasharray
+disable_so_reg_w_fndecl_394 reg_w fndecl 3 394 &disable_so_btrfs_insert_delayed_item_fndecl_394
+disable_so_liquidio_ptp_adjfreq_fndecl_396 liquidio_ptp_adjfreq fndecl 2 396 NULL
+disable_so_freq_dvbt_set_parameters_msg_404 freq dvbt_set_parameters_msg 0 404 NULL
+disable_so_uid_btrfs_inode_item_419 uid btrfs_inode_item 0 419 NULL
+disable_so_cuid_ipc64_perm_421 cuid ipc64_perm 0 421 NULL
+disable_so_addr_nvkm_fb_tile_430 addr nvkm_fb_tile 0 430 NULL
+disable_so_st_ctime_nsec_stat_435 st_ctime_nsec stat 0 435 NULL nohasharray
+disable_so_end_seq_tcp_skb_cb_435 end_seq tcp_skb_cb 0 435 &disable_so_st_ctime_nsec_stat_435
+disable_so_ttime_samples_cfq_ttime_442 ttime_samples cfq_ttime 0 442 NULL
+disable_so_snd_timer_interrupt_fndecl_465 snd_timer_interrupt fndecl 2 465 NULL
+disable_so_min_img_ir_timing_range_466 min img_ir_timing_range 0 466 NULL
+disable_so_freq_wmi_cancel_remain_on_chnl_event_472 freq wmi_cancel_remain_on_chnl_event 0 472 NULL
+disable_so_prism54_set_mac_address_fndecl_477 prism54_set_mac_address fndecl 0 477 NULL
+disable_so_ccp_run_xts_aes_cmd_fndecl_481 ccp_run_xts_aes_cmd fndecl 0 481 NULL
+disable_so_queue_time_cqm_rmid_entry_485 queue_time cqm_rmid_entry 0 485 NULL
+disable_so_hpi_sample_clock_query_local_rate_fndecl_487 hpi_sample_clock_query_local_rate fndecl 1-0 487 NULL
+disable_so_bcma_chipco_get_alp_clock_fndecl_488 bcma_chipco_get_alp_clock fndecl 0 488 NULL
+disable_so_musb_read_txhubaddr_fndecl_495 musb_read_txhubaddr fndecl 2-0 495 NULL
+disable_so_timestamp_discovery_state_508 timestamp discovery_state 0 508 NULL
+disable_so_autosleep_show_fndecl_509 autosleep_show fndecl 0 509 NULL
+disable_so_dx_major_hash_ocfs2_dx_entry_517 dx_major_hash ocfs2_dx_entry 0 517 NULL
+disable_so_rhashtable_insert_slow_fndecl_525 rhashtable_insert_slow fndecl 0 525 NULL
+disable_so_vaddr_page_fndecl_526 vaddr_page fndecl 0 526 NULL
+disable_so_apei_check_mce_fndecl_561 apei_check_mce fndecl 0 561 NULL
+disable_so_cifs_convert_address_fndecl_567 cifs_convert_address fndecl 3 567 NULL
+disable_so_nla_put_be32_fndecl_572 nla_put_be32 fndecl 0-3 572 NULL
+disable_so_dn_username2sockaddr_fndecl_573 dn_username2sockaddr fndecl 0-2 573 NULL
+disable_so_compat_sys_timer_settime_fndecl_577 compat_sys_timer_settime fndecl 1 577 NULL
+disable_so_hash_extent_data_ref_fndecl_581 hash_extent_data_ref fndecl 0-1-2-3 581 NULL
+disable_so_addr_buffer1_cmd_desc_type0_591 addr_buffer1 cmd_desc_type0 0 591 NULL
+disable_so_acpi_os_prepare_extended_sleep_fndecl_597 acpi_os_prepare_extended_sleep fndecl 0-2 597 NULL
+disable_so_mdio_addr_port_info_608 mdio_addr port_info 0 608 NULL
+disable_so_dl_runtime_dl_bandwidth_609 dl_runtime dl_bandwidth 0 609 NULL
+disable_so_sense_addr_asc_scsiq_1_628 sense_addr asc_scsiq_1 0 628 NULL
+disable_so_x86_cache_max_rmid_cpuinfo_x86_631 x86_cache_max_rmid cpuinfo_x86 0 631 NULL
+disable_so_wm8978_set_dai_clkdiv_fndecl_638 wm8978_set_dai_clkdiv fndecl 3-0 638 NULL
+disable_so_new_cpufreq_freqs_646 new cpufreq_freqs 0 646 NULL
+disable_so_max_offchan_duration_iwl_tdls_channel_switch_timing_649 max_offchan_duration iwl_tdls_channel_switch_timing 0 649 NULL
+disable_so_i_ctime_nsec_ocfs2_dinode_657 i_ctime_nsec ocfs2_dinode 0 657 NULL
+disable_so_req_dma_addr_generic_pdu_resc_661 req_dma_addr generic_pdu_resc 0 661 NULL
+disable_so_minor_hash_fname_673 minor_hash fname 0 673 NULL
+disable_so_sprintf_temp_from_reg_fndecl_675 sprintf_temp_from_reg fndecl 0-3 675 NULL
+disable_so_cpu_freq_to_power_fndecl_677 cpu_freq_to_power fndecl 0-2 677 NULL
+disable_so_timbradio_vidioc_s_frequency_fndecl_688 timbradio_vidioc_s_frequency fndecl 0 688 NULL
+disable_so_target_bfa_bsg_rport_scsi_addr_s_690 target bfa_bsg_rport_scsi_addr_s 0 690 NULL
+disable_so_cs_addr_snd_ak4xxx_private_693 cs_addr snd_ak4xxx_private 0 693 NULL
+disable_so_s3_set_pixclock_fndecl_694 s3_set_pixclock fndecl 2 694 NULL
+disable_so_write_gracetime_fndecl_705 write_gracetime fndecl 0 705 NULL
+disable_so_smack_task_getpgid_fndecl_708 smack_task_getpgid fndecl 0 708 NULL
+disable_so_wl1251_acx_service_period_timeout_fndecl_709 wl1251_acx_service_period_timeout fndecl 0 709 NULL
+disable_so_gid_ubifs_ino_node_712 gid ubifs_ino_node 0 712 NULL
+disable_so___sony_nc_kbd_backlight_timeout_set_fndecl_713 __sony_nc_kbd_backlight_timeout_set fndecl 1 713 NULL
+disable_so_watchdog_init_timeout_fndecl_721 watchdog_init_timeout fndecl 2 721 NULL
+disable_so_led_on_time_adp8870_backlight_platform_data_723 led_on_time adp8870_backlight_platform_data 0 723 NULL
+disable_so_txhubaddr_musb_csr_regs_727 txhubaddr musb_csr_regs 0 727 NULL
+disable_so_flexonenand_addr_fndecl_731 flexonenand_addr fndecl 0-2 731 NULL
+disable_so_scan_timestamp_local_info_733 scan_timestamp local_info 0 733 NULL
+disable_so_brcmf_dongle_scantime_fndecl_735 brcmf_dongle_scantime fndecl 2-3-4-0 735 NULL
+disable_so_pg_delay_d_vardecl_pktgen_c_748 pg_delay_d vardecl_pktgen.c 0 748 NULL
+disable_so_current_sit_addr_fndecl_752 current_sit_addr fndecl 0-2 752 NULL
+disable_so_mix_msr_src_node_conf_t_769 mix_msr src_node_conf_t 0 769 NULL
+disable_so_sha1_mb_async_final_fndecl_780 sha1_mb_async_final fndecl 0 780 NULL
+disable_so_dma_addr_ipw2100_rx_packet_785 dma_addr ipw2100_rx_packet 0 785 NULL
+disable_so_addrHigh_lpfc_pde7_802 addrHigh lpfc_pde7 0 802 NULL
+disable_so_frequency_cpufreq_frequency_table_805 frequency cpufreq_frequency_table 0 805 NULL
+disable_so_timer_int_req_nes_device_806 timer_int_req nes_device 0 806 NULL
+disable_so_if_freq_mxl5005s_config_819 if_freq mxl5005s_config 0 819 NULL
+disable_so_radix_tree_lookup_fndecl_821 radix_tree_lookup fndecl 2 821 NULL
+disable_so_subdivision_dma_buffparms_826 subdivision dma_buffparms 0 826 NULL
+disable_so_HYPERVISOR_event_channel_op_fndecl_838 HYPERVISOR_event_channel_op fndecl 0 838 NULL
+disable_so_dm_jiffies_to_msec64_fndecl_843 dm_jiffies_to_msec64 fndecl 1-0 843 NULL
+disable_so_trim_bitmaps_fndecl_845 trim_bitmaps fndecl 0-3-4-5 845 NULL
+disable_so_cg_spll_spread_spectrum_2_ni_clock_registers_846 cg_spll_spread_spectrum_2 ni_clock_registers 0 846 NULL
+disable_so_xfs_btree_increment_fndecl_856 xfs_btree_increment fndecl 0 856 NULL nohasharray
+disable_so_xfs_btree_ptr_offset_fndecl_856 xfs_btree_ptr_offset fndecl 0-2 856 &disable_so_xfs_btree_increment_fndecl_856
+disable_so_put_unaligned_be32_fndecl_861 put_unaligned_be32 fndecl 1 861 NULL
+disable_so_acpi_os_map_generic_address_fndecl_862 acpi_os_map_generic_address fndecl 0 862 NULL
+disable_so_mpll_func_cntl_1_ci_clock_registers_864 mpll_func_cntl_1 ci_clock_registers 0 864 NULL
+disable_so_buffer_warning_time_budget_870 buffer_warning_time budget 0 870 NULL
+disable_so_imr_sourceaddr_ip_mreq_source_875 imr_sourceaddr ip_mreq_source 0 875 NULL
+disable_so_msi2500_s_frequency_fndecl_879 msi2500_s_frequency fndecl 0 879 NULL
+disable_so_tx_bd_haddr_hi_bnx2_tx_bd_881 tx_bd_haddr_hi bnx2_tx_bd 0 881 NULL
+disable_so_wmi_addr_fndecl_882 wmi_addr fndecl 2 882 NULL
+disable_so_rt6_info_hash_nhsfn_fndecl_886 rt6_info_hash_nhsfn fndecl 0-1 886 NULL
+disable_so_snd_seq_oss_timer_stop_fndecl_904 snd_seq_oss_timer_stop fndecl 0 904 NULL
+disable_so_addr_lo_rx_desc_909 addr_lo rx_desc 0 909 NULL
+disable_so_bx_tss_segment_16_926 bx tss_segment_16 0 926 NULL
+disable_so_inactive_time_station_info_927 inactive_time station_info 0 927 NULL
+disable_so_last_reset_jiffies_iwl_rf_reset_931 last_reset_jiffies iwl_rf_reset 0 931 NULL
+disable_so_shm_dtime_shmid64_ds_943 shm_dtime shmid64_ds 0 943 NULL
+disable_so_autosleep_store_fndecl_949 autosleep_store fndecl 0-4 949 NULL nohasharray
+disable_so_sit_base_addr_sit_info_949 sit_base_addr sit_info 0 949 &disable_so_autosleep_store_fndecl_949
+disable_so_ageing_time_net_bridge_957 ageing_time net_bridge 0 957 NULL
+disable_so_set_frequency_shifter_fndecl_959 set_frequency_shifter fndecl 0-2-3 959 NULL
+disable_so_pci_bus_vardecl_bkm_a8_c_960 pci_bus vardecl_bkm_a8.c 0 960 NULL
+disable_so_i_uid_ext2_inode_963 i_uid ext2_inode 0 963 NULL
+disable_so_cpufreq_cpu_get_fndecl_965 cpufreq_cpu_get fndecl 1 965 NULL
+disable_so_tsc_offset_vmcb_control_area_968 tsc_offset vmcb_control_area 0 968 NULL
+disable_so_read_addr_qla8044_minidump_entry_rdmem_977 read_addr qla8044_minidump_entry_rdmem 0 977 NULL
+disable_so_addr1_nphy_rf_control_override_rev2_978 addr1 nphy_rf_control_override_rev2 0 978 NULL
+disable_so_qdisc_class_hash_fndecl_982 qdisc_class_hash fndecl 0-1-2 982 NULL
+disable_so_crypto_register_ahash_fndecl_984 crypto_register_ahash fndecl 0 984 NULL
+disable_so_addr_unlock2_cfi_private_989 addr_unlock2 cfi_private 0 989 NULL
+disable_so_calc_baud_rate_divisor_fndecl_995 calc_baud_rate_divisor fndecl 2 995 NULL
+disable_so_scsi_runtime_suspend_fndecl_1008 scsi_runtime_suspend fndecl 0 1008 NULL
+disable_so_gran_sizek_var_mtrr_state_1012 gran_sizek var_mtrr_state 0 1012 NULL
+disable_so_ax25_uid_info_open_fndecl_1028 ax25_uid_info_open fndecl 0 1028 NULL
+disable_so_sh_mmcif_clock_control_fndecl_1029 sh_mmcif_clock_control fndecl 2 1029 NULL
+disable_so_SYSC_setresgid_fndecl_1032 SYSC_setresgid fndecl 0 1032 NULL
+disable_so_f1x_lookup_addr_in_dct_fndecl_1033 f1x_lookup_addr_in_dct fndecl 0-1-2-3 1033 NULL
+disable_so_ufshcd_pci_runtime_suspend_fndecl_1044 ufshcd_pci_runtime_suspend fndecl 0 1044 NULL
+disable_so_rme9652_set_interrupt_interval_fndecl_1049 rme9652_set_interrupt_interval fndecl 2 1049 NULL
+disable_so_kgdb_validate_break_address_fndecl_1055 kgdb_validate_break_address fndecl 0 1055 NULL
+disable_so_cp_mqd_base_addr_hi_hqd_registers_1058 cp_mqd_base_addr_hi hqd_registers 0 1058 NULL
+disable_so_serial8250_get_divisor_fndecl_1063 serial8250_get_divisor fndecl 2-0 1063 NULL
+disable_so_mpll_func_cntl_ci_clock_registers_1072 mpll_func_cntl ci_clock_registers 0 1072 NULL
+disable_so_dma_addr_iser_tx_desc_1074 dma_addr iser_tx_desc 0 1074 NULL nohasharray
+disable_so_fail_addr_erase_info_1074 fail_addr erase_info 0 1074 &disable_so_dma_addr_iser_tx_desc_1074
+disable_so_timeout_static_key_deferred_1078 timeout static_key_deferred 0 1078 NULL
+disable_so_uid_vardecl_initramfs_c_1083 uid vardecl_initramfs.c 0 1083 NULL
+disable_so_amdgpu_mm_rreg_fndecl_1084 amdgpu_mm_rreg fndecl 0-2 1084 NULL
+disable_so_hash_ip6_expire_fndecl_1088 hash_ip6_expire fndecl 4 1088 NULL
+disable_so_addr_buffer4_cmd_desc_type0_1089 addr_buffer4 cmd_desc_type0 0 1089 NULL
+disable_so__snd_hdac_read_parm_fndecl_1100 _snd_hdac_read_parm fndecl 3-2-0 1100 NULL
+disable_so_mlx5_query_mad_ifc_gids_fndecl_1101 mlx5_query_mad_ifc_gids fndecl 0 1101 NULL
+disable_so_dbgfs_prph_reg_addr_iwl_mvm_1102 dbgfs_prph_reg_addr iwl_mvm 0 1102 NULL
+disable_so_cttimeout_default_fill_info_fndecl_1107 cttimeout_default_fill_info fndecl 4-3-6-0 1107 NULL
+disable_so_expiry_time_cache_head_1108 expiry_time cache_head 0 1108 NULL
+disable_so_dma_desc_set_addr_fndecl_1139 dma_desc_set_addr fndecl 3 1139 NULL
+disable_so_addr_crb_addr_pair_1140 addr crb_addr_pair 0 1140 NULL
+disable_so_sleep_dvb_tuner_ops_1155 sleep dvb_tuner_ops 0 1155 NULL
+disable_so_info_for_irq_fndecl_1159 info_for_irq fndecl 1 1159 NULL
+disable_so_mlx4_ib_find_real_gid_fndecl_1163 mlx4_ib_find_real_gid fndecl 2 1163 NULL
+disable_so_timestamp_perf_cgroup_info_1168 timestamp perf_cgroup_info 0 1168 NULL
+disable_so_mthca_QUERY_FW_fndecl_1176 mthca_QUERY_FW fndecl 0 1176 NULL
+disable_so_fc_exch_set_addr_fndecl_1180 fc_exch_set_addr fndecl 2-3 1180 NULL
+disable_so_rhashtable_rehash_chain_fndecl_1192 rhashtable_rehash_chain fndecl 2 1192 NULL
+disable_so_own_addr_tipc_net_1206 own_addr tipc_net 0 1206 NULL
+disable_so_ip6addrlbl_alloc_fndecl_1212 ip6addrlbl_alloc fndecl 4 1212 NULL
+disable_so_nft_hash_init_fndecl_1216 nft_hash_init fndecl 0 1216 NULL
+disable_so_max_freq_cpufreq_cpuinfo_1219 max_freq cpufreq_cpuinfo 0 1219 NULL
+disable_so_spi_port_rcvhdr_tailaddr_ipath_base_info_1223 spi_port_rcvhdr_tailaddr ipath_base_info 0 1223 NULL
+disable_so_ceph_vxattrcb_dir_rctime_fndecl_1240 ceph_vxattrcb_dir_rctime fndecl 3-0 1240 NULL
+disable_so_cas_interrupt_fndecl_1242 cas_interrupt fndecl 1 1242 NULL nohasharray
+disable_so_set_msr_hyperv_fndecl_1242 set_msr_hyperv fndecl 3 1242 &disable_so_cas_interrupt_fndecl_1242
+disable_so_mmc_rescan_try_freq_fndecl_1249 mmc_rescan_try_freq fndecl 2 1249 NULL
+disable_so_rtsx_pci_write_be32_fndecl_1251 rtsx_pci_write_be32 fndecl 2-3 1251 NULL
+disable_so_sum_sleep_runtime_sched_statistics_1253 sum_sleep_runtime sched_statistics 0 1253 NULL
+disable_so_flags_pt_regs_1254 flags pt_regs 0 1254 NULL
+disable_so_bug10934_timer_txc43128_data_1290 bug10934_timer txc43128_data 0 1290 NULL nohasharray
+disable_so_rq_size_log2_t3_wq_1290 rq_size_log2 t3_wq 0 1290 &disable_so_bug10934_timer_txc43128_data_1290
+disable_so_do_sched_rt_period_timer_fndecl_1292 do_sched_rt_period_timer fndecl 2 1292 NULL
+disable_so_db_dma_address_skd_special_context_1295 db_dma_address skd_special_context 0 1295 NULL
+disable_so_time_stamp_hbq_dmabuf_1300 time_stamp hbq_dmabuf 0 1300 NULL
+disable_so_print_vma_addr_fndecl_1312 print_vma_addr fndecl 2 1312 NULL
+disable_so_max_acl_mac_addrs_wiphy_1316 max_acl_mac_addrs wiphy 0 1316 NULL
+disable_so_shash_async_update_fndecl_1319 shash_async_update fndecl 0 1319 NULL
+disable_so_programm_delay_vardecl_nandsim_c_1320 programm_delay vardecl_nandsim.c 0 1320 NULL
+disable_so_stimescaled_task_struct_1330 stimescaled task_struct 0 1330 NULL nohasharray
+disable_so_p_gma_clock_t_1330 p gma_clock_t 0 1330 &disable_so_stimescaled_task_struct_1330
+disable_so_bitmap_bytes_fndecl_1338 bitmap_bytes fndecl 0-1-2 1338 NULL
+disable_so_max8649_enable_time_fndecl_1340 max8649_enable_time fndecl 0 1340 NULL
+disable_so_sg_set_timeout_fndecl_1360 sg_set_timeout fndecl 0 1360 NULL
+disable_so_mrp_join_time_vardecl_mrp_c_1361 mrp_join_time vardecl_mrp.c 0 1361 NULL
+disable_so_queue_address_queue_properties_1364 queue_address queue_properties 0 1364 NULL
+disable_so_adfs_unix2adfs_time_fndecl_1365 adfs_unix2adfs_time fndecl 2 1365 NULL nohasharray
+disable_so_start_rmt_timer2_fndecl_1365 start_rmt_timer2 fndecl 2 1365 &disable_so_adfs_unix2adfs_time_fndecl_1365
+disable_so_qla2x00_gid_list_size_fndecl_1367 qla2x00_gid_list_size fndecl 0 1367 NULL nohasharray
+disable_so_sr_get_phy_addr_fndecl_1367 sr_get_phy_addr fndecl 0 1367 &disable_so_qla2x00_gid_list_size_fndecl_1367
+disable_so_rb_subtree_last_anon_vma_chain_1370 rb_subtree_last anon_vma_chain 0 1370 NULL
+disable_so_snd_soc_runtime_activate_fndecl_1372 snd_soc_runtime_activate fndecl 2 1372 NULL nohasharray
+disable_so_gateway_ctrl_address_wil_fw_record_gateway_data4_1372 gateway_ctrl_address wil_fw_record_gateway_data4 0 1372 &disable_so_snd_soc_runtime_activate_fndecl_1372
+disable_so_timer_elsa_hw_1375 timer elsa_hw 0 1375 NULL nohasharray
+disable_so_sched_setscheduler_fndecl_1375 sched_setscheduler fndecl 2-0 1375 &disable_so_timer_elsa_hw_1375 nohasharray
+disable_so_bitmap_check_fndecl_1375 bitmap_check fndecl 3 1375 &disable_so_sched_setscheduler_fndecl_1375
+disable_so_pwr_wake_on_timer_exp_read_fndecl_1379 pwr_wake_on_timer_exp_read fndecl 3-0 1379 NULL
+disable_so_prev_input_time_vardecl_sequencer_c_1380 prev_input_time vardecl_sequencer.c 0 1380 NULL
+disable_so_mii_phy_addr_gem_1381 mii_phy_addr gem 0 1381 NULL
+disable_so_snd_seq_queue_timer_set_tempo_fndecl_1388 snd_seq_queue_timer_set_tempo fndecl 1-2 1388 NULL
+disable_so_efx_ef10_rx_enable_timestamping_fndecl_1394 efx_ef10_rx_enable_timestamping fndecl 0 1394 NULL
+disable_so_xfrm_src_hash_fndecl_1398 xfrm_src_hash fndecl 0-4 1398 NULL
+disable_so_set_pixclock_fndecl_1401 set_pixclock fndecl 2 1401 NULL
+disable_so_start_dma_addr_vardecl_swiotlb_xen_c_1402 start_dma_addr vardecl_swiotlb-xen.c 0 1402 NULL
+disable_so_pcm512x_set_dividers_fndecl_1412 pcm512x_set_dividers fndecl 0 1412 NULL
+disable_so_frequency_tea5761_priv_1416 frequency tea5761_priv 0 1416 NULL
+disable_so_ifa_flags_ifaddrmsg_1431 ifa_flags ifaddrmsg 0 1431 NULL
+disable_so_last_queue_full_time_scsi_device_1432 last_queue_full_time scsi_device 0 1432 NULL
+disable_so_dma_ops_reserve_addresses_fndecl_1438 dma_ops_reserve_addresses fndecl 2-3 1438 NULL
+disable_so_reg_w_fndecl_1440 reg_w fndecl 4-0 1440 NULL
+disable_so_tomoyo_check_inet_address_fndecl_1442 tomoyo_check_inet_address fndecl 0-2-3 1442 NULL
+disable_so_is_oldclock_fndecl_1444 is_oldclock fndecl 1 1444 NULL
+disable_so_width_latch_addr_flash_data_1448 width latch_addr_flash_data 0 1448 NULL
+disable_so_tuner_address_ix2505v_config_1466 tuner_address ix2505v_config 0 1466 NULL
+disable_so_alarm_setitimer_fndecl_1477 alarm_setitimer fndecl 1-0 1477 NULL
+disable_so_enc28j60_rx_interrupt_fndecl_1478 enc28j60_rx_interrupt fndecl 0 1478 NULL
+disable_so_i2c_address_xc4000_config_1488 i2c_address xc4000_config 0 1488 NULL
+disable_so_dx_runtime_sc_1503 dx runtime_sc 0 1503 NULL
+disable_so_tda827x_addr_tda8290_priv_1514 tda827x_addr tda8290_priv 0 1514 NULL
+disable_so_addr_sym_tblmove_1540 addr sym_tblmove 0 1540 NULL
+disable_so_cs_tss_segment_16_1560 cs tss_segment_16 0 1560 NULL
+disable_so_demod_address_drxk_state_1562 demod_address drxk_state 0 1562 NULL
+disable_so_enable_time_regulation_constraints_1573 enable_time regulation_constraints 0 1573 NULL nohasharray
+disable_so_dma_addr_flexcop_usb_1573 dma_addr flexcop_usb 0 1573 &disable_so_enable_time_regulation_constraints_1573
+disable_so_dma_addr_cas_page_1575 dma_addr cas_page 0 1575 NULL
+disable_so_start_read_delay_c_1578 start_read delay_c 0 1578 NULL
+disable_so_complete_crypto_async_request_1579 complete crypto_async_request 2 1579 NULL
+disable_so_cycles_2_us_fndecl_1583 cycles_2_us fndecl 0-1 1583 NULL
+disable_so_pd_timeout_vardecl_pd_c_1584 pd_timeout vardecl_pd.c 0 1584 NULL
+disable_so_last_end_request_cfq_ttime_1591 last_end_request cfq_ttime 0 1591 NULL
+disable_so_addr_sky2_rx_le_1593 addr sky2_rx_le 0 1593 NULL
+disable_so_tick_raw_sched_clock_data_1597 tick_raw sched_clock_data 0 1597 NULL
+disable_so_if_freq_khz_pll_tab_1599 if_freq_khz pll_tab 0 1599 NULL
+disable_so_set_clock_info_fndecl_1600 set_clock_info fndecl 0 1600 NULL
+disable_so_bs_delay_cx24113_state_1602 bs_delay cx24113_state 0 1602 NULL
+disable_so_address_atto_physical_region_description_1608 address atto_physical_region_description 0 1608 NULL
+disable_so_jiffies_force_qs_rcu_state_1611 jiffies_force_qs rcu_state 0 1611 NULL
+disable_so_mpll_ad_func_cntl_si_clock_registers_1615 mpll_ad_func_cntl si_clock_registers 0 1615 NULL
+disable_so___new_c_uuid_parms_from_attrs_fndecl_1628 __new_c_uuid_parms_from_attrs fndecl 0 1628 NULL
+disable_so___btree_sort_fndecl_1629 __btree_sort fndecl 4 1629 NULL
+disable_so_crypto_authenc_encrypt_done_fndecl_1634 crypto_authenc_encrypt_done fndecl 2 1634 NULL
+disable_so_uhci_submit_interrupt_fndecl_1635 uhci_submit_interrupt fndecl 0 1635 NULL
+disable_so_es_tss_segment_16_1639 es tss_segment_16 0 1639 NULL
+disable_so_addrHigh_sge_ieee1212_1649 addrHigh sge_ieee1212 0 1649 NULL
+disable_so_btree_insert_level_fndecl_1651 btree_insert_level fndecl 6 1651 NULL
+disable_so_calc_gus_envelope_time_fndecl_1653 calc_gus_envelope_time fndecl 1-2-3-0 1653 NULL
+disable_so_rhashtable_shrink_fndecl_1657 rhashtable_shrink fndecl 0 1657 NULL
+disable_so_jiffies_next_msi2500_state_1659 jiffies_next msi2500_state 0 1659 NULL
+disable_so_di_gid_dinode_1663 di_gid dinode 0 1663 NULL
+disable_so_address_drm_radeon_surface_alloc_1665 address drm_radeon_surface_alloc 0 1665 NULL
+disable_so_nsec_btrfs_ioctl_timespec_1668 nsec btrfs_ioctl_timespec 0 1668 NULL
+disable_so_uptime_sysinfo_1669 uptime sysinfo 0 1669 NULL
+disable_so_timeout_mgmt_cp_add_advertising_1685 timeout mgmt_cp_add_advertising 0 1685 NULL nohasharray
+disable_so_systime_fndecl_1685 systime fndecl 0 1685 &disable_so_timeout_mgmt_cp_add_advertising_1685 nohasharray
+disable_so_addr0_ulptx_sgl_1685 addr0 ulptx_sgl 0 1685 &disable_so_systime_fndecl_1685
+disable_so_poll_timeout_irlap_cb_1688 poll_timeout irlap_cb 0 1688 NULL nohasharray
+disable_so_tsc_irq_max8925_chip_1688 tsc_irq max8925_chip 0 1688 &disable_so_poll_timeout_irlap_cb_1688
+disable_so_pbl_addr_t3_swrq_1691 pbl_addr t3_swrq 0 1691 NULL
+disable_so_ar_addr_qlc_83xx_quad_entry_1699 ar_addr qlc_83xx_quad_entry 0 1699 NULL
+disable_so_min_freq_softlimit_intel_gen6_power_mgmt_1704 min_freq_softlimit intel_gen6_power_mgmt 0 1704 NULL
+disable_so_spkt_family_sockaddr_pkt_1712 spkt_family sockaddr_pkt 0 1712 NULL
+disable_so_timeout_vardecl_w83877f_wdt_c_1721 timeout vardecl_w83877f_wdt.c 0 1721 NULL
+disable_so_nfs_map_gid_to_group_fndecl_1724 nfs_map_gid_to_group fndecl 4-0 1724 NULL
+disable_so_iram_offset_sst_addr_1727 iram_offset sst_addr 0 1727 NULL
+disable_so_mp_lapic_addr_vardecl_1729 mp_lapic_addr vardecl 0 1729 NULL
+disable_so_apei_write_mce_fndecl_1731 apei_write_mce fndecl 0 1731 NULL
+disable_so_spectrum_stv0900_signal_info_1736 spectrum stv0900_signal_info 0 1736 NULL
+disable_so_hash_ipmark6_expire_fndecl_1741 hash_ipmark6_expire fndecl 4 1741 NULL
+disable_so_r100_mm_rreg_slow_fndecl_1751 r100_mm_rreg_slow fndecl 2-0 1751 NULL
+disable_so_gntdev_ioctl_get_offset_for_vaddr_fndecl_1754 gntdev_ioctl_get_offset_for_vaddr fndecl 0 1754 NULL
+disable_so_cm36651_write_int_time_fndecl_1774 cm36651_write_int_time fndecl 0 1774 NULL
+disable_so_dp_clock_radeon_connector_atom_dig_1775 dp_clock radeon_connector_atom_dig 0 1775 NULL nohasharray
+disable_so_am79c_ack_interrupt_fndecl_1775 am79c_ack_interrupt fndecl 0 1775 &disable_so_dp_clock_radeon_connector_atom_dig_1775
+disable_so_phys_addr_qlcnic_host_tx_ring_1780 phys_addr qlcnic_host_tx_ring 0 1780 NULL nohasharray
+disable_so_read_addr_qla83xx_minidump_entry_rdmux2_1780 read_addr qla83xx_minidump_entry_rdmux2 0 1780 &disable_so_phys_addr_qlcnic_host_tx_ring_1780
+disable_so_select_addr_1_qla83xx_minidump_entry_rdmux2_1790 select_addr_1 qla83xx_minidump_entry_rdmux2 0 1790 NULL
+disable_so___padata_set_cpumasks_fndecl_1793 __padata_set_cpumasks fndecl 0 1793 NULL
+disable_so_padlock_sha_init_fndecl_1815 padlock_sha_init fndecl 0 1815 NULL
+disable_so_acpi_cpufreq_early_init_fndecl_1824 acpi_cpufreq_early_init fndecl 0 1824 NULL
+disable_so_dst_addr_ioat_xor_descriptor_1835 dst_addr ioat_xor_descriptor 0 1835 NULL
+disable_so_sadb_lifetime_bytes_sadb_lifetime_1836 sadb_lifetime_bytes sadb_lifetime 0 1836 NULL
+disable_so_event_box_addr_wl1251_1839 event_box_addr wl1251 0 1839 NULL
+disable_so_addr_ahci_sg_1848 addr ahci_sg 0 1848 NULL
+disable_so_acct_timexpd_task_struct_1854 acct_timexpd task_struct 0 1854 NULL
+disable_so_mkey_lease_timeout_ipath_ibdev_1856 mkey_lease_timeout ipath_ibdev 0 1856 NULL nohasharray
+disable_so_paddr_idt77252_skb_prv_1856 paddr idt77252_skb_prv 0 1856 &disable_so_mkey_lease_timeout_ipath_ibdev_1856
+disable_so_timeout_dmatest_params_1857 timeout dmatest_params 0 1857 NULL
+disable_so_cipso_v4_bitmap_setbit_fndecl_1861 cipso_v4_bitmap_setbit fndecl 2 1861 NULL
+disable_so_sun6i_spi_runtime_resume_fndecl_1869 sun6i_spi_runtime_resume fndecl 0 1869 NULL
+disable_so_shash_ahash_update_fndecl_1877 shash_ahash_update fndecl 0 1877 NULL
+disable_so_ss_family___kernel_sockaddr_storage_1886 ss_family __kernel_sockaddr_storage 0 1886 NULL
+disable_so_swap_time_bloom_pair_1898 swap_time bloom_pair 0 1898 NULL nohasharray
+disable_so_blank_time_dce6_wm_params_1898 blank_time dce6_wm_params 0 1898 &disable_so_swap_time_bloom_pair_1898
+disable_so_btree_order_fndecl_1901 btree_order fndecl 0 1901 NULL
+disable_so_sil_iowrite16_fndecl_1906 sil_iowrite16 fndecl 3-2 1906 NULL
+disable_so_service_timer_period_i40e_pf_1923 service_timer_period i40e_pf 0 1923 NULL nohasharray
+disable_so_address_acpi_resource_fixed_memory32_1923 address acpi_resource_fixed_memory32 0 1923 &disable_so_service_timer_period_i40e_pf_1923
+disable_so_paddr_dw_spi_1926 paddr dw_spi 0 1926 NULL
+disable_so___audit_sockaddr_fndecl_1929 __audit_sockaddr fndecl 1 1929 NULL
+disable_so_ieee80211_aes_gcm_key_setup_encrypt_fndecl_1936 ieee80211_aes_gcm_key_setup_encrypt fndecl 2 1936 NULL
+disable_so_mce_chrdev_open_fndecl_1937 mce_chrdev_open fndecl 0 1937 NULL
+disable_so_shadow_reg_phy_addr_ql3_adapter_1940 shadow_reg_phy_addr ql3_adapter 0 1940 NULL
+disable_so_dma_addr_t3_cq_1953 dma_addr t3_cq 0 1953 NULL
+disable_so_crypto_pcbc_decrypt_inplace_fndecl_1957 crypto_pcbc_decrypt_inplace fndecl 0 1957 NULL
+disable_so_sw_reset_and_clock_fndecl_1963 sw_reset_and_clock fndecl 0 1963 NULL
+disable_so_wp_next_time_fndecl_1967 wp_next_time fndecl 0-1 1967 NULL
+disable_so_timer_expires_dev_pm_info_1979 timer_expires dev_pm_info 0 1979 NULL
+disable_so_dll_cntl_si_clock_registers_1988 dll_cntl si_clock_registers 0 1988 NULL
+disable_so_sysctl_x25_clear_request_timeout_vardecl_2007 sysctl_x25_clear_request_timeout vardecl 0 2007 NULL
+disable_so___skb_complete_tx_timestamp_fndecl_2011 __skb_complete_tx_timestamp fndecl 3 2011 NULL
+disable_so_st_ctime_compat_stat_2020 st_ctime compat_stat 0 2020 NULL
+disable_so_ns_nongc_ctime_the_nilfs_2021 ns_nongc_ctime the_nilfs 0 2021 NULL
+disable_so_slave_address_cp2112_write_read_req_report_2022 slave_address cp2112_write_read_req_report 0 2022 NULL
+disable_so_beacon_timeout_ms_show_fndecl_2029 beacon_timeout_ms_show fndecl 0 2029 NULL
+disable_so_daddr_lap_cb_2033 daddr lap_cb 0 2033 NULL
+disable_so_next_txd_phys_addr_mwl8k_tx_desc_2040 next_txd_phys_addr mwl8k_tx_desc 0 2040 NULL
+disable_so_tps65910_rtc_set_time_fndecl_2042 tps65910_rtc_set_time fndecl 0 2042 NULL
+disable_so_address_sg_list_2047 address sg_list 0 2047 NULL
+disable_so_r62_val_fc2580_freq_regs_2052 r62_val fc2580_freq_regs 0 2052 NULL
+disable_so_atomic64_cmpxchg_fndecl_2053 atomic64_cmpxchg fndecl 0-2-3 2053 NULL
+disable_so_delay_cfg80211_coalesce_rules_2055 delay cfg80211_coalesce_rules 0 2055 NULL
+disable_so_addrconf_sysctl_register_fndecl_2065 addrconf_sysctl_register fndecl 0 2065 NULL nohasharray
+disable_so_max_timeout_watchdog_device_2065 max_timeout watchdog_device 0 2065 &disable_so_addrconf_sysctl_register_fndecl_2065
+disable_so_gid_autofs_v5_packet_2071 gid autofs_v5_packet 0 2071 NULL
+disable_so_ratio_t_rj54n1_clock_div_2081 ratio_t rj54n1_clock_div 0 2081 NULL
+disable_so_compat_sys_signalfd4_fndecl_2082 compat_sys_signalfd4 fndecl 0-4 2082 NULL
+disable_so_demod_address_ds3000_config_2084 demod_address ds3000_config 0 2084 NULL
+disable_so_xfrm_flowi_addr_get_fndecl_2087 xfrm_flowi_addr_get fndecl 4 2087 NULL
+disable_so_ts_delay_vardecl_ucb1400_ts_c_2088 ts_delay vardecl_ucb1400_ts.c 0 2088 NULL
+disable_so_get_cpu_iowait_time_us_fndecl_2097 get_cpu_iowait_time_us fndecl 0-1 2097 NULL
+disable_so_crypto_sha1_finup_fndecl_2101 crypto_sha1_finup fndecl 3 2101 NULL
+disable_so_wlc_phy_chan2freq_nphy_fndecl_2103 wlc_phy_chan2freq_nphy fndecl 2 2103 NULL
+disable_so_palmas_smps_set_ramp_delay_fndecl_2110 palmas_smps_set_ramp_delay fndecl 0 2110 NULL
+disable_so_ncp_add_be32_fndecl_2114 ncp_add_be32 fndecl 2 2114 NULL
+disable_so_fast_div_bias_ath_hw_antcomb_conf_2119 fast_div_bias ath_hw_antcomb_conf 0 2119 NULL
+disable_so_memconsole_baseaddr_vardecl_memconsole_c_2130 memconsole_baseaddr vardecl_memconsole.c 0 2130 NULL
+disable_so_max8907_rtc_read_time_fndecl_2134 max8907_rtc_read_time fndecl 0 2134 NULL
+disable_so_cur_daddr_pktgen_dev_2141 cur_daddr pktgen_dev 0 2141 NULL
+disable_so_mapped_loc_addr_nes_cm_listener_2153 mapped_loc_addr nes_cm_listener 0 2153 NULL
+disable_so_index_ath_gen_timer_2154 index ath_gen_timer 0 2154 NULL
+disable_so_brcms_c_duty_cycle_set_fndecl_2162 brcms_c_duty_cycle_set fndecl 2 2162 NULL
+disable_so_rx_addr_happy_meal_rxd_2164 rx_addr happy_meal_rxd 0 2164 NULL
+disable_so_cp_dma_addr_mscp_2187 cp_dma_addr mscp 0 2187 NULL
+disable_so_address_hi_be_bus_address32_2192 address_hi be_bus_address32 0 2192 NULL nohasharray
+disable_so_parse_sockaddr_pair_fndecl_2192 parse_sockaddr_pair fndecl 0-2 2192 &disable_so_address_hi_be_bus_address32_2192
+disable_so_channel_sockaddr_mISDN_2193 channel sockaddr_mISDN 0 2193 NULL
+disable_so_channel_time_mwl8k_priv_2196 channel_time mwl8k_priv 0 2196 NULL
+disable_so_saddr_min_pktgen_dev_2198 saddr_min pktgen_dev 0 2198 NULL
+disable_so_cirrus_set_start_address_fndecl_2201 cirrus_set_start_address fndecl 2 2201 NULL
+disable_so_exp_time_rmc_entry_2203 exp_time rmc_entry 0 2203 NULL
+disable_so_acpi_os_get_timer_fndecl_2213 acpi_os_get_timer fndecl 0 2213 NULL nohasharray
+disable_so_to_addr_efx_memcpy_req_2213 to_addr efx_memcpy_req 0 2213 &disable_so_acpi_os_get_timer_fndecl_2213
+disable_so_gather_bitmaps_fndecl_2219 gather_bitmaps fndecl 0 2219 NULL
+disable_so_timeout_ms_rdma_ucm_resolve_ip_2231 timeout_ms rdma_ucm_resolve_ip 0 2231 NULL
+disable_so_ui_birthtime_ufs2_inode_2238 ui_birthtime ufs2_inode 0 2238 NULL
+disable_so_security_mmap_addr_fndecl_2241 security_mmap_addr fndecl 0-1 2241 NULL
+disable_so_atl1c_hash_mc_addr_fndecl_2245 atl1c_hash_mc_addr fndecl 0 2245 NULL
+disable_so_isl1208_i2c_read_time_fndecl_2247 isl1208_i2c_read_time fndecl 0 2247 NULL
+disable_so_stats_reset_time_bfa_fcport_s_2251 stats_reset_time bfa_fcport_s 0 2251 NULL
+disable_so_uid_mcontroller_2253 uid mcontroller 0 2253 NULL
+disable_so_daddr_iriap_cb_2262 daddr iriap_cb 0 2262 NULL
+disable_so_rtl2832_sdr_set_tuner_freq_fndecl_2267 rtl2832_sdr_set_tuner_freq fndecl 0 2267 NULL
+disable_so_chipio_write_address_fndecl_2270 chipio_write_address fndecl 0-2 2270 NULL
+disable_so_small_buf_q_phy_addr_ql3_adapter_2279 small_buf_q_phy_addr ql3_adapter 0 2279 NULL
+disable_so_sys_utime_fndecl_2283 sys_utime fndecl 0 2283 NULL nohasharray
+disable_so_muldiv32_fndecl_2283 muldiv32 fndecl 0-1-2-3 2283 &disable_so_sys_utime_fndecl_2283
+disable_so_bd_list_addr_hi_bnx2i_nop_out_request_2284 bd_list_addr_hi bnx2i_nop_out_request 0 2284 NULL
+disable_so_show_trans_timeout_fndecl_2286 show_trans_timeout fndecl 0 2286 NULL
+disable_so_il4965_tx_queue_stop_scheduler_fndecl_2292 il4965_tx_queue_stop_scheduler fndecl 2 2292 NULL
+disable_so_demod_address_ves1820_config_2298 demod_address ves1820_config 0 2298 NULL
+disable_so_backlight_on_delay_cdv_intel_dp_2301 backlight_on_delay cdv_intel_dp 0 2301 NULL
+disable_so_ip_vs_lblcr_hashkey_fndecl_2305 ip_vs_lblcr_hashkey fndecl 1 2305 NULL
+disable_so_tulip_interrupt_fndecl_2323 tulip_interrupt fndecl 1 2323 NULL
+disable_so_m_ts_clockk_strength_drxk_state_2324 m_ts_clockk_strength drxk_state 0 2324 NULL
+disable_so_carl9170_debugfs_hw_iowrite32_write_fndecl_2330 carl9170_debugfs_hw_iowrite32_write fndecl 0-3 2330 NULL
+disable_so_iclock_count_vardecl_clock_c_2334 iclock_count vardecl_clock.c 0 2334 NULL
+disable_so_eop_gpu_addr_kernel_queue_2339 eop_gpu_addr kernel_queue 0 2339 NULL
+disable_so___insert_inode_hash_fndecl_2341 __insert_inode_hash fndecl 2 2341 NULL
+disable_so_lasttime_vardecl_serial_u16550_c_2348 lasttime vardecl_serial-u16550.c 0 2348 NULL
+disable_so_custom_divisor_ftdi_private_2356 custom_divisor ftdi_private 0 2356 NULL nohasharray
+disable_so_bma150_set_any_motion_interrupt_fndecl_2356 bma150_set_any_motion_interrupt fndecl 3-4-0 2356 &disable_so_custom_divisor_ftdi_private_2356
+disable_so_cdrom_get_random_writable_fndecl_2357 cdrom_get_random_writable fndecl 0 2357 NULL
+disable_so_delay_vardecl_wm9713_c_2358 delay vardecl_wm9713.c 0 2358 NULL
+disable_so_usc_enable_async_clock_fndecl_2361 usc_enable_async_clock fndecl 2 2361 NULL
+disable_so___cpu_to_virtio64_fndecl_2365 __cpu_to_virtio64 fndecl 0-2 2365 NULL
+disable_so_freq_offset_xc5000_priv_2385 freq_offset xc5000_priv 0 2385 NULL
+disable_so_decompressed_size_regcache_lzo_ctx_2401 decompressed_size regcache_lzo_ctx 0 2401 NULL
+disable_so_tps65910_sleepinit_fndecl_2406 tps65910_sleepinit fndecl 0 2406 NULL
+disable_so_i2c_address_dib0090_config_2410 i2c_address dib0090_config 0 2410 NULL
+disable_so_paddr_nes_fast_mr_wqe_pbl_2411 paddr nes_fast_mr_wqe_pbl 0 2411 NULL
+disable_so_time_fcoe_fcf_2412 time fcoe_fcf 0 2412 NULL
+disable_so_ndisc_addr_option_pad_fndecl_2413 ndisc_addr_option_pad fndecl 0 2413 NULL
+disable_so_next_cpu_uv_rtc_timer_head_2424 next_cpu uv_rtc_timer_head 0 2424 NULL
+disable_so_buffer_addr_fm10k_tx_desc_2425 buffer_addr fm10k_tx_desc 0 2425 NULL
+disable_so_ahci_init_interrupts_fndecl_2426 ahci_init_interrupts fndecl 2-0 2426 NULL
+disable_so_cp_interrupt_fndecl_2429 cp_interrupt fndecl 1 2429 NULL
+disable_so_sha1_mb_update_fndecl_2431 sha1_mb_update fndecl 0 2431 NULL
+disable_so_mii_bmsr1_bnx2_2432 mii_bmsr1 bnx2 0 2432 NULL
+disable_so_i2c_addr_lnbp21_2433 i2c_addr lnbp21 0 2433 NULL
+disable_so_dmadesc_set_addr_fndecl_2434 dmadesc_set_addr fndecl 3 2434 NULL
+disable_so___irq_alloc_descs_fndecl_2452 __irq_alloc_descs fndecl 0-3-2-1-4 2452 NULL
+disable_so_efx_ptp_process_times_fndecl_2453 efx_ptp_process_times fndecl 0 2453 NULL
+disable_so_SiS_SetReg_fndecl_2455 SiS_SetReg fndecl 2-3-4 2455 NULL
+disable_so_hashlimit_byte_cost_fndecl_2456 hashlimit_byte_cost fndecl 0-1 2456 NULL
+disable_so_sd_mtime_stat_data_v1_2460 sd_mtime stat_data_v1 0 2460 NULL
+disable_so_string_addr_inc_fndecl_2472 string_addr_inc fndecl 2 2472 NULL
+disable_so_set_mc_hash_fndecl_2473 set_mc_hash fndecl 0 2473 NULL
+disable_so_height_psb_intel_sdvo_preferred_input_timing_args_2479 height psb_intel_sdvo_preferred_input_timing_args 0 2479 NULL
+disable_so_seq_netlbl_unlhsh_walk_arg_2483 seq netlbl_unlhsh_walk_arg 0 2483 NULL
+disable_so_set_cpu_itimer_fndecl_2486 set_cpu_itimer fndecl 2 2486 NULL
+disable_so_reqoff_crypto_authenc_ctx_2490 reqoff crypto_authenc_ctx 0 2490 NULL
+disable_so_i_gid_ocfs2_dinode_2496 i_gid ocfs2_dinode 0 2496 NULL
+disable_so_bind_mcastif_addr_fndecl_2497 bind_mcastif_addr fndecl 0 2497 NULL
+disable_so_pm_runtime_put_autosuspend_fndecl_2498 pm_runtime_put_autosuspend fndecl 0 2498 NULL
+disable_so_xfs_btree_insert_fndecl_2499 xfs_btree_insert fndecl 0 2499 NULL
+disable_so_update_time_fndecl_2500 update_time fndecl 0 2500 NULL
+disable_so_fill_mtrr_var_range_fndecl_2523 fill_mtrr_var_range fndecl 2-3-4-5 2523 NULL
+disable_so_of_cpufreq_power_cooling_register_fndecl_2525 of_cpufreq_power_cooling_register fndecl 3 2525 NULL
+disable_so_addr_genwqe_mem_2530 addr genwqe_mem 0 2530 NULL
+disable_so_rtr_solicit_delay_ipv6_devconf_2532 rtr_solicit_delay ipv6_devconf 0 2532 NULL nohasharray
+disable_so_num_of_cycles_in_period_igp_power_info_2532 num_of_cycles_in_period igp_power_info 0 2532 &disable_so_rtr_solicit_delay_ipv6_devconf_2532
+disable_so_vhost16_to_cpu_fndecl_2533 vhost16_to_cpu fndecl 0 2533 NULL
+disable_so_clock_adj_k_clock_2534 clock_adj k_clock 1 2534 NULL
+disable_so_global_default_fn_cipher_key_bytes_ecryptfs_mount_crypt_stat_2536 global_default_fn_cipher_key_bytes ecryptfs_mount_crypt_stat 0 2536 NULL
+disable_so_clock_fc2580_config_2541 clock fc2580_config 0 2541 NULL
+disable_so_sb_bitmaps_hpfs_sb_info_2542 sb_bitmaps hpfs_sb_info 0 2542 NULL
+disable_so_devfreq_event_get_edev_by_phandle_fndecl_2550 devfreq_event_get_edev_by_phandle fndecl 2 2550 NULL
+disable_so_reiserfs_allocate_list_bitmaps_fndecl_2551 reiserfs_allocate_list_bitmaps fndecl 3 2551 NULL
+disable_so_nr_set_mac_address_fndecl_2555 nr_set_mac_address fndecl 0 2555 NULL
+disable_so_SYSC_setuid_fndecl_2561 SYSC_setuid fndecl 0 2561 NULL
+disable_so_shadow_ctx_time_perf_event_2574 shadow_ctx_time perf_event 0 2574 NULL nohasharray
+disable_so_kernel_text_address_fndecl_2574 kernel_text_address fndecl 1 2574 &disable_so_shadow_ctx_time_perf_event_2574
+disable_so_msb_bna_dma_addr_2580 msb bna_dma_addr 0 2580 NULL
+disable_so_ipmi_get_my_address_fndecl_2581 ipmi_get_my_address fndecl 0 2581 NULL
+disable_so_scan_sleep_millisecs_show_fndecl_2585 scan_sleep_millisecs_show fndecl 0 2585 NULL
+disable_so_l2tp_scope_id_sockaddr_l2tpip6_2587 l2tp_scope_id sockaddr_l2tpip6 0 2587 NULL
+disable_so_freq_to_idx_fndecl_2591 freq_to_idx fndecl 2 2591 NULL
+disable_so_tps65910_set_ext_sleep_config_fndecl_2597 tps65910_set_ext_sleep_config fndecl 0-2 2597 NULL
+disable_so_try_write_address_fndecl_2599 try_write_address fndecl 0 2599 NULL
+disable_so_ifa_mask_in_ifaddr_2609 ifa_mask in_ifaddr 0 2609 NULL
+disable_so_phys_addr_nx_host_tx_ring_2615 phys_addr nx_host_tx_ring 0 2615 NULL
+disable_so_usb_wait_anchor_empty_timeout_fndecl_2618 usb_wait_anchor_empty_timeout fndecl 2-0 2618 NULL nohasharray
+disable_so_p2_gma_clock_t_2618 p2 gma_clock_t 0 2618 &disable_so_usb_wait_anchor_empty_timeout_fndecl_2618 nohasharray
+disable_so_cra_blocksize_crypto_alg_2618 cra_blocksize crypto_alg 0 2618 &disable_so_p2_gma_clock_t_2618
+disable_so_b1_setinterrupt_fndecl_2626 b1_setinterrupt fndecl 1-2 2626 NULL
+disable_so_flsh_addr_esas2r_flash_context_2628 flsh_addr esas2r_flash_context 0 2628 NULL
+disable_so_bClockID_uac_clock_source_descriptor_2629 bClockID uac_clock_source_descriptor 0 2629 NULL
+disable_so_free_dma_map_ops_2636 free dma_map_ops 4 2636 NULL
+disable_so_apds990x_set_atime_fndecl_2647 apds990x_set_atime fndecl 2 2647 NULL
+disable_so_jiffies_sdr_cap_vivid_dev_2650 jiffies_sdr_cap vivid_dev 0 2650 NULL
+disable_so_rf_mux_ploy_r820t_freq_range_2652 rf_mux_ploy r820t_freq_range 0 2652 NULL nohasharray
+disable_so_policy_hash_direct_fndecl_2652 policy_hash_direct fndecl 4 2652 &disable_so_rf_mux_ploy_r820t_freq_range_2652
+disable_so_base_addr_sudmac_regs_2655 base_addr sudmac_regs 0 2655 NULL
+disable_so_id_rdma_ucm_resolve_addr_2656 id rdma_ucm_resolve_addr 0 2656 NULL
+disable_so_demod_address_stv0367_config_2659 demod_address stv0367_config 0 2659 NULL
+disable_so_get_if_frequency_dvb_tuner_ops_2660 get_if_frequency dvb_tuner_ops 0 2660 NULL
+disable_so_r_idx_addr_brcmf_pcie_ringbuf_2666 r_idx_addr brcmf_pcie_ringbuf 0 2666 NULL
+disable_so_address_sisusb_packet_2668 address sisusb_packet 0 2668 NULL
+disable_so_cia_min_keysize_cipher_alg_2682 cia_min_keysize cipher_alg 0 2682 NULL
+disable_so_snd_timer_start_fndecl_2702 snd_timer_start fndecl 2-0 2702 NULL
+disable_so_erst_exec_set_src_address_base_fndecl_2703 erst_exec_set_src_address_base fndecl 0 2703 NULL
+disable_so_end_seq_tcp_sack_block_wire_2708 end_seq tcp_sack_block_wire 0 2708 NULL nohasharray
+disable_so__abb5zes3_rtc_read_timer_fndecl_2708 _abb5zes3_rtc_read_timer fndecl 0 2708 &disable_so_end_seq_tcp_sack_block_wire_2708
+disable_so_rn5t618_wdt_set_timeout_fndecl_2711 rn5t618_wdt_set_timeout fndecl 2-0 2711 NULL nohasharray
+disable_so_hsync_off_hi_lvds_dvo_timing_2711 hsync_off_hi lvds_dvo_timing 0 2711 &disable_so_rn5t618_wdt_set_timeout_fndecl_2711
+disable_so_hdelayx1_bttv_tvnorm_2714 hdelayx1 bttv_tvnorm 0 2714 NULL
+disable_so_raw_interval_timekeeper_2728 raw_interval timekeeper 0 2728 NULL
+disable_so___vxge_hw_ring_item_dma_addr_fndecl_2731 __vxge_hw_ring_item_dma_addr fndecl 0 2731 NULL
+disable_so_mlx5_query_hca_vport_gid_fndecl_2744 mlx5_query_hca_vport_gid fndecl 0 2744 NULL
+disable_so_period_ptr_atmel_runtime_data_2748 period_ptr atmel_runtime_data 0 2748 NULL
+disable_so_buf_addr_lo_fcoe_bd_ctx_2755 buf_addr_lo fcoe_bd_ctx 0 2755 NULL nohasharray
+disable_so_cycles_2_ns_fndecl_2755 cycles_2_ns fndecl 0-1 2755 &disable_so_buf_addr_lo_fcoe_bd_ctx_2755
+disable_so_md5_parse_tcp_sock_af_ops_2765 md5_parse tcp_sock_af_ops 3-0 2765 NULL
+disable_so_nbytes_ablkcipher_walk_2767 nbytes ablkcipher_walk 0 2767 NULL
+disable_so_crypto_hash_setkey_fndecl_2770 crypto_hash_setkey fndecl 0-3 2770 NULL
+disable_so_addr_gf100_gr_init_2776 addr gf100_gr_init 0 2776 NULL
+disable_so_auth_hashbits_vardecl_auth_c_2783 auth_hashbits vardecl_auth.c 0 2783 NULL
+disable_so_ipr_reset_start_timer_fndecl_2784 ipr_reset_start_timer fndecl 2 2784 NULL nohasharray
+disable_so_tv_sec_compat_timeval_2784 tv_sec compat_timeval 0 2784 &disable_so_ipr_reset_start_timer_fndecl_2784 nohasharray
+disable_so_addr_vring_desc_2784 addr vring_desc 0 2784 &disable_so_tv_sec_compat_timeval_2784
+disable_so_addr_initio_host_2790 addr initio_host 0 2790 NULL
+disable_so_i2c_addr_dib7000p_state_2791 i2c_addr dib7000p_state 0 2791 NULL
+disable_so_trim_no_bitmap_fndecl_2799 trim_no_bitmap fndecl 0-3-4-5 2799 NULL nohasharray
+disable_so_imp_msr_src_node_conf_t_2799 imp_msr src_node_conf_t 0 2799 &disable_so_trim_no_bitmap_fndecl_2799
+disable_so_phys_addr_pch_udc_dev_2801 phys_addr pch_udc_dev 0 2801 NULL
+disable_so_mpll_ss2_ci_clock_registers_2804 mpll_ss2 ci_clock_registers 0 2804 NULL
+disable_so_mutex_lock_interruptible_fndecl_2810 mutex_lock_interruptible fndecl 0 2810 NULL
+disable_so___btrfs_add_delayed_item_fndecl_2812 __btrfs_add_delayed_item fndecl 0 2812 NULL
+disable_so_physaddr_map_node_2828 physaddr map_node 0 2828 NULL
+disable_so_fault_mutex_hash_fndecl_2829 fault_mutex_hash fndecl 0-5-6 2829 NULL
+disable_so_tsi721_imsg_interrupt_enable_fndecl_2832 tsi721_imsg_interrupt_enable fndecl 2-3 2832 NULL
+disable_so_ocfs2_reserve_cluster_bitmap_bits_fndecl_2835 ocfs2_reserve_cluster_bitmap_bits fndecl 0 2835 NULL
+disable_so_address_lcnphy_radio_regs_2840 address lcnphy_radio_regs 0 2840 NULL
+disable_so_write_timeout_vardecl_at24_c_2843 write_timeout vardecl_at24.c 0 2843 NULL nohasharray
+disable_so_rdma_bind_addr_fndecl_2843 rdma_bind_addr fndecl 0 2843 &disable_so_write_timeout_vardecl_at24_c_2843
+disable_so_x86_schedule_events_fndecl_2848 x86_schedule_events fndecl 2 2848 NULL
+disable_so_acpi_ut_status_exit_fndecl_2850 acpi_ut_status_exit fndecl 5 2850 NULL
+disable_so_wlcore_read_hwaddr_fndecl_2853 wlcore_read_hwaddr fndecl 0-4 2853 NULL
+disable_so_apicaddr_mpc_ioapic_2859 apicaddr mpc_ioapic 0 2859 NULL
+disable_so_msec_dwell_time_host_cmd_ds_chan_rpt_req_2868 msec_dwell_time host_cmd_ds_chan_rpt_req 0 2868 NULL
+disable_so_hpsa_find_cfg_addrs_fndecl_2876 hpsa_find_cfg_addrs fndecl 0 2876 NULL
+disable_so_sched_clock_cpu_fndecl_2881 sched_clock_cpu fndecl 0-1 2881 NULL
+disable_so_qs_itimelimit_fs_quota_stat_2888 qs_itimelimit fs_quota_stat 0 2888 NULL
+disable_so_bitmap_set_pending_fndecl_2892 bitmap_set_pending fndecl 2 2892 NULL
+disable_so_rt2x00debug_read_crypto_stats_fndecl_2894 rt2x00debug_read_crypto_stats fndecl 0-3 2894 NULL
+disable_so_calibrate_tsc_x86_platform_ops_2895 calibrate_tsc x86_platform_ops 0 2895 NULL
+disable_so_timeout_show_fndecl_2898 timeout_show fndecl 0 2898 NULL
+disable_so_snd_hda_codec_read_fndecl_2913 snd_hda_codec_read fndecl 0-2-4-5 2913 NULL
+disable_so___bitmap_size_fndecl_2921 __bitmap_size fndecl 0 2921 NULL
+disable_so_snd_pcm_ioctl_delay_compat_fndecl_2923 snd_pcm_ioctl_delay_compat fndecl 0 2923 NULL nohasharray
+disable_so_addr_abituguru_data_2923 addr abituguru_data 0 2923 &disable_so_snd_pcm_ioctl_delay_compat_fndecl_2923
+disable_so_amdgpu_atombios_set_engine_dram_timings_fndecl_2927 amdgpu_atombios_set_engine_dram_timings fndecl 2-3 2927 NULL
+disable_so_i2c_address_mt2060_config_2931 i2c_address mt2060_config 0 2931 NULL
+disable_so_time_msdos_dir_entry_2939 time msdos_dir_entry 0 2939 NULL
+disable_so_acpi_install_address_space_handler_fndecl_2940 acpi_install_address_space_handler fndecl 0-2 2940 NULL nohasharray
+disable_so_addr_genwqe_reg_2940 addr genwqe_reg 0 2940 &disable_so_acpi_install_address_space_handler_fndecl_2940
+disable_so_addr_max77693_reg_data_2945 addr max77693_reg_data 0 2945 NULL nohasharray
+disable_so_addrconf_set_dstaddr_fndecl_2945 addrconf_set_dstaddr fndecl 0 2945 &disable_so_addr_max77693_reg_data_2945
+disable_so_gcm_hash_init_done_fndecl_2957 gcm_hash_init_done fndecl 2 2957 NULL
+disable_so_mwifiex_pcie_alloc_sleep_cookie_buf_fndecl_2961 mwifiex_pcie_alloc_sleep_cookie_buf fndecl 0 2961 NULL
+disable_so_ip_list_gid_vardecl_xt_recent_c_2969 ip_list_gid vardecl_xt_recent.c 0 2969 NULL
+disable_so_ieee80211_calculate_rx_timestamp_fndecl_2979 ieee80211_calculate_rx_timestamp fndecl 3-4-0 2979 NULL
+disable_so_jiffies_at_last_reset_qla_statistics_2982 jiffies_at_last_reset qla_statistics 0 2982 NULL
+disable_so_read_magic_time_fndecl_3002 read_magic_time fndecl 0 3002 NULL
+disable_so_node_addr_mdc_hw_list_desc_3006 node_addr mdc_hw_list_desc 0 3006 NULL
+disable_so_bitmap_clear_bits_fndecl_3008 bitmap_clear_bits fndecl 3-4 3008 NULL
+disable_so_cipher_offset_icp_qat_fw_la_cipher_req_params_3009 cipher_offset icp_qat_fw_la_cipher_req_params 0 3009 NULL
+disable_so_local_addr_c2wr_ep_listen_create_req_3021 local_addr c2wr_ep_listen_create_req 0 3021 NULL nohasharray
+disable_so_bitmap_end_sync_fndecl_3021 bitmap_end_sync fndecl 2 3021 &disable_so_local_addr_c2wr_ep_listen_create_req_3021
+disable_so___xfrm6_daddr_saddr_hash_fndecl_3024 __xfrm6_daddr_saddr_hash fndecl 0 3024 NULL
+disable_so_port_name_fcgs_gidpn_req_s_3037 port_name fcgs_gidpn_req_s 0 3037 NULL
+disable_so___pm_runtime_set_status_fndecl_3040 __pm_runtime_set_status fndecl 0 3040 NULL nohasharray
+disable_so_inactivity_time_adxl34x_platform_data_3040 inactivity_time adxl34x_platform_data 0 3040 &disable_so___pm_runtime_set_status_fndecl_3040
+disable_so_bm_dev_capacity_drbd_bitmap_3043 bm_dev_capacity drbd_bitmap 0 3043 NULL
+disable_so_arp_hash_fndecl_3046 arp_hash fndecl 2 3046 NULL
+disable_so_setkey_ablkcipher_alg_3056 setkey ablkcipher_alg 3 3056 NULL
+disable_so_display_delay_s5p_mfc_ctx_3062 display_delay s5p_mfc_ctx 0 3062 NULL
+disable_so_power_jiffies_hda_codec_3064 power_jiffies hda_codec 0 3064 NULL
+disable_so_dw_mci_exynos_adjust_clock_fndecl_3069 dw_mci_exynos_adjust_clock fndecl 2 3069 NULL
+disable_so_set_var_mtrr_msr_fndecl_3073 set_var_mtrr_msr fndecl 3 3073 NULL
+disable_so_pm860x_rtc_read_time_fndecl_3079 pm860x_rtc_read_time fndecl 0 3079 NULL nohasharray
+disable_so_buffer_haddr_rbd_3079 buffer_haddr rbd 0 3079 &disable_so_pm860x_rtc_read_time_fndecl_3079
+disable_so_snd_usb_find_clock_source_fndecl_3080 snd_usb_find_clock_source fndecl 2 3080 NULL
+disable_so_response_buffer_address_on_dsp_hpi_hw_obj_3083 response_buffer_address_on_dsp hpi_hw_obj 0 3083 NULL
+disable_so_valid_mmap_phys_addr_range_fndecl_3090 valid_mmap_phys_addr_range fndecl 1-2 3090 NULL
+disable_so_mc_addr_count_s2io_nic_3095 mc_addr_count s2io_nic 0 3095 NULL
+disable_so_si4713_g_frequency_fndecl_3096 si4713_g_frequency fndecl 0 3096 NULL
+disable_so_rtl_bb_delay_fndecl_3097 rtl_bb_delay fndecl 2-3 3097 NULL
+disable_so_nla_put_u16_fndecl_3101 nla_put_u16 fndecl 3-0 3101 NULL
+disable_so_enet_addr_rst_fndecl_3111 enet_addr_rst fndecl 1 3111 NULL
+disable_so_xtime_interval_timekeeper_3116 xtime_interval timekeeper 0 3116 NULL
+disable_so_atomic_set_prop_fndecl_3117 atomic_set_prop fndecl 4-0 3117 NULL
+disable_so_read_timeout_vardecl_legousbtower_c_3118 read_timeout vardecl_legousbtower.c 0 3118 NULL nohasharray
+disable_so_netmask_c2_netaddr_3118 netmask c2_netaddr 0 3118 &disable_so_read_timeout_vardecl_legousbtower_c_3118 nohasharray
+disable_so_hashlo_smsc911x_data_3118 hashlo smsc911x_data 0 3118 &disable_so_netmask_c2_netaddr_3118 nohasharray
+disable_so_q_hash_irda_queue_3118 q_hash irda_queue 0 3118 &disable_so_hashlo_smsc911x_data_3118
+disable_so_rpc_get_timeout_fndecl_3124 rpc_get_timeout fndecl 0 3124 NULL
+disable_so_ctime_fuse_attr_3128 ctime fuse_attr 0 3128 NULL
+disable_so_dl_time_nfs4_delegation_3130 dl_time nfs4_delegation 0 3130 NULL
+disable_so_tx_packet_ring_addr_acx_data_path_params_resp_3132 tx_packet_ring_addr acx_data_path_params_resp 0 3132 NULL
+disable_so__div_round_fndecl_3134 _div_round fndecl 2-3-0 3134 NULL
+disable_so_power_up_frequency_adf4350_platform_data_3140 power_up_frequency adf4350_platform_data 0 3140 NULL
+disable_so_bytes_xfrm_lifetime_cur_3145 bytes xfrm_lifetime_cur 0 3145 NULL
+disable_so_show_nguid_fndecl_3155 show_nguid fndecl 0 3155 NULL nohasharray
+disable_so_svm_read_tsc_offset_fndecl_3155 svm_read_tsc_offset fndecl 0 3155 &disable_so_show_nguid_fndecl_3155
+disable_so_shash_ahash_finup_fndecl_3156 shash_ahash_finup fndecl 0 3156 NULL
+disable_so_adjtime_ptp_clock_info_3161 adjtime ptp_clock_info 2 3161 NULL
+disable_so_read_addr___mux2_3162 read_addr __mux2 0 3162 NULL
+disable_so_mem_type_mtrr_iter_3164 mem_type mtrr_iter 0 3164 NULL
+disable_so_cg_spll_func_cntl_ni_clock_registers_3176 cg_spll_func_cntl ni_clock_registers 0 3176 NULL
+disable_so_schedule_hrtimeout_range_clock_fndecl_3178 schedule_hrtimeout_range_clock fndecl 4-2 3178 NULL nohasharray
+disable_so_bitmap_copy_fndecl_3178 bitmap_copy fndecl 3 3178 &disable_so_schedule_hrtimeout_range_clock_fndecl_3178
+disable_so__is_valid_table_div_fndecl_3179 _is_valid_table_div fndecl 2 3179 NULL
+disable_so_addr_2_qla83xx_minidump_entry_pollrdmwr_3183 addr_2 qla83xx_minidump_entry_pollrdmwr 0 3183 NULL
+disable_so_via_clock_vardecl_via82cxxx_c_3195 via_clock vardecl_via82cxxx.c 0 3195 NULL
+disable_so_timeout_reader_dev_3196 timeout reader_dev 0 3196 NULL
+disable_so_delay_palmas_clk32k_desc_3198 delay palmas_clk32k_desc 0 3198 NULL nohasharray
+disable_so_freq_if_hz_tda10048_state_3198 freq_if_hz tda10048_state 0 3198 &disable_so_delay_palmas_clk32k_desc_3198
+disable_so_i2c_address_tda18218_config_3199 i2c_address tda18218_config 0 3199 NULL nohasharray
+disable_so_bot_freq_region_info_3199 bot_freq region_info 0 3199 &disable_so_i2c_address_tda18218_config_3199
+disable_so_sdr_adc_freq_vivid_dev_3202 sdr_adc_freq vivid_dev 0 3202 NULL
+disable_so_wlc_phy_cal_perical_mphase_schedule_fndecl_3220 wlc_phy_cal_perical_mphase_schedule fndecl 2 3220 NULL
+disable_so_uid_ceph_mds_reply_inode_3222 uid ceph_mds_reply_inode 0 3222 NULL nohasharray
+disable_so_mapped_rem_addr_nes_cm_node_3222 mapped_rem_addr nes_cm_node 0 3222 &disable_so_uid_ceph_mds_reply_inode_3222
+disable_so_txq_addr_vf_pf_txq_params_3223 txq_addr vf_pf_txq_params 0 3223 NULL
+disable_so_dma_addr_ksz_shared_mem_3226 dma_addr ksz_shared_mem 0 3226 NULL
+disable_so_smb_timer_atl1_hw_3230 smb_timer atl1_hw 0 3230 NULL
+disable_so_nilfs_btree_node_set_key_fndecl_3231 nilfs_btree_node_set_key fndecl 2-3 3231 NULL
+disable_so_finish_output_interrupt_fndecl_3255 finish_output_interrupt fndecl 1 3255 NULL
+disable_so_command_block_agent_address_sbp2_logical_unit_3261 command_block_agent_address sbp2_logical_unit 0 3261 NULL
+disable_so_st21nfca_get_iso14443_3_uid_fndecl_3264 st21nfca_get_iso14443_3_uid fndecl 0 3264 NULL
+disable_so_db_rec_addr_mlx5_qp_context_3265 db_rec_addr mlx5_qp_context 0 3265 NULL
+disable_so_rssi_jiffies_mwifiex_auto_tdls_peer_3275 rssi_jiffies mwifiex_auto_tdls_peer 0 3275 NULL
+disable_so_random_read_wakeup_bits_vardecl_random_c_3284 random_read_wakeup_bits vardecl_random.c 0 3284 NULL
+disable_so_time_busy_survey_info_3291 time_busy survey_info 0 3291 NULL
+disable_so_platform_pci_sleep_wake_fndecl_3293 platform_pci_sleep_wake fndecl 0 3293 NULL nohasharray
+disable_so_walk_blocksize_blkcipher_walk_3293 walk_blocksize blkcipher_walk 0 3293 &disable_so_platform_pci_sleep_wake_fndecl_3293
+disable_so_addr_kvm_shadow_walk_iterator_3297 addr kvm_shadow_walk_iterator 0 3297 NULL
+disable_so_r6e_val_fc2580_freq_regs_3300 r6e_val fc2580_freq_regs 0 3300 NULL
+disable_so_clock_speed_ov7670_info_3304 clock_speed ov7670_info 0 3304 NULL
+disable_so_bank_base_effect_addr_snd_ymfpci_3311 bank_base_effect_addr snd_ymfpci 0 3311 NULL
+disable_so_nfs_map_name_to_uid_fndecl_3313 nfs_map_name_to_uid fndecl 0-3 3313 NULL
+disable_so_read_block_bitmap_fndecl_3319 read_block_bitmap fndecl 0-3-4 3319 NULL
+disable_so_sis190_get_mac_addr_from_apc_fndecl_3325 sis190_get_mac_addr_from_apc fndecl 0 3325 NULL
+disable_so_head_uvc_clock_3340 head uvc_clock 0 3340 NULL
+disable_so_amd_clock_vardecl_amd74xx_c_3344 amd_clock vardecl_amd74xx.c 0 3344 NULL nohasharray
+disable_so_host_cmds_addr_rtsx_pcr_3344 host_cmds_addr rtsx_pcr 0 3344 &disable_so_amd_clock_vardecl_amd74xx_c_3344
+disable_so_xp_cpu_to_nasid_uv_fndecl_3353 xp_cpu_to_nasid_uv fndecl 0 3353 NULL
+disable_so_last_join_time_local_info_3359 last_join_time local_info 0 3359 NULL
+disable_so_tcf_hash_release_fndecl_3369 tcf_hash_release fndecl 0 3369 NULL
+disable_so_carl9170_set_slot_time_fndecl_3372 carl9170_set_slot_time fndecl 0 3372 NULL
+disable_so_mmc_schedule_delayed_work_fndecl_3376 mmc_schedule_delayed_work fndecl 2 3376 NULL
+disable_so_m_mt9t112_pll_divider_3397 m mt9t112_pll_divider 0 3397 NULL nohasharray
+disable_so__rtl92c_phy_calculate_bit_shift_fndecl_3397 _rtl92c_phy_calculate_bit_shift fndecl 0-1 3397 &disable_so_m_mt9t112_pll_divider_3397
+disable_so_irlap_generate_rand_time_slot_fndecl_3415 irlap_generate_rand_time_slot fndecl 0-1-2 3415 NULL
+disable_so_via_set_secondary_address_fndecl_3417 via_set_secondary_address fndecl 1 3417 NULL
+disable_so___timekeeping_set_tai_offset_fndecl_3425 __timekeeping_set_tai_offset fndecl 2 3425 NULL
+disable_so_apic_access_addr_vmcs12_3427 apic_access_addr vmcs12 0 3427 NULL
+disable_so_prod_idx_addr_cqicb_3435 prod_idx_addr cqicb 0 3435 NULL
+disable_so_uwb_rc_dev_addr_mgmt_fndecl_3445 uwb_rc_dev_addr_mgmt fndecl 0 3445 NULL
+disable_so_sg_bus_addr_ScsiReqBlk_3447 sg_bus_addr ScsiReqBlk 0 3447 NULL
+disable_so_i2c_addr_lgdt3306a_config_3452 i2c_addr lgdt3306a_config 0 3452 NULL
+disable_so_sym_selectclock_fndecl_3453 sym_selectclock fndecl 2 3453 NULL
+disable_so_timestamp_wl1251_rx_descriptor_3475 timestamp wl1251_rx_descriptor 0 3475 NULL
+disable_so_hw_cons_phys_addr_qlcnic_host_tx_ring_3481 hw_cons_phys_addr qlcnic_host_tx_ring 0 3481 NULL
+disable_so_last_jiffies_snd_timer_system_private_3482 last_jiffies snd_timer_system_private 0 3482 NULL
+disable_so_r_min_rnr_timer_qib_qp_3487 r_min_rnr_timer qib_qp 0 3487 NULL
+disable_so_ata_wait_register_fndecl_3494 ata_wait_register fndecl 0 3494 NULL
+disable_so_time_adjust_vardecl_ntp_c_3504 time_adjust vardecl_ntp.c 0 3504 NULL
+disable_so_cursor_addr_intel_crtc_3508 cursor_addr intel_crtc 0 3508 NULL
+disable_so_trf7970a_pm_runtime_suspend_fndecl_3511 trf7970a_pm_runtime_suspend fndecl 0 3511 NULL
+disable_so_oops_timestamp_vardecl_printk_c_3515 oops_timestamp vardecl_printk.c 0 3515 NULL
+disable_so_data_blkaddr_dnode_of_data_3521 data_blkaddr dnode_of_data 0 3521 NULL
+disable_so_SYSC_set_tid_address_fndecl_3523 SYSC_set_tid_address fndecl 0 3523 NULL
+disable_so_ftdi_232am_baud_base_to_divisor_fndecl_3525 ftdi_232am_baud_base_to_divisor fndecl 0-1-2 3525 NULL nohasharray
+disable_so_fll_ratio__fll_div_3525 fll_ratio _fll_div 0 3525 &disable_so_ftdi_232am_baud_base_to_divisor_fndecl_3525 nohasharray
+disable_so_xpcs_reg_addr_write_fndecl_3525 xpcs_reg_addr_write fndecl 3-0 3525 &disable_so_fll_ratio__fll_div_3525
+disable_so_init_crypto_ahash_3526 init crypto_ahash 0 3526 NULL
+disable_so_sit_blkaddr_f2fs_super_block_3531 sit_blkaddr f2fs_super_block 0 3531 NULL
+disable_so_uuid_io_fndecl_3533 uuid_io fndecl 2 3533 NULL
+disable_so_bufs_dma_addr_slgt_info_3534 bufs_dma_addr slgt_info 0 3534 NULL
+disable_so_cpumask_size_fndecl_3544 cpumask_size fndecl 0 3544 NULL
+disable_so_ocfs2_load_local_quota_bitmaps_fndecl_3551 ocfs2_load_local_quota_bitmaps fndecl 0 3551 NULL
+disable_so_ghash_mod_init_fndecl_3557 ghash_mod_init fndecl 0 3557 NULL
+disable_so_ath5k_hw_init_beacon_timers_fndecl_3558 ath5k_hw_init_beacon_timers fndecl 2-3 3558 NULL
+disable_so_addr_h_qla2xxx_fce_chain_3560 addr_h qla2xxx_fce_chain 0 3560 NULL
+disable_so_acpi_pci_sleep_wake_fndecl_3562 acpi_pci_sleep_wake fndecl 0 3562 NULL
+disable_so_sd_set_timing_fndecl_3566 sd_set_timing fndecl 0 3566 NULL
+disable_so_hpt3x2n_pci_clock_fndecl_3568 hpt3x2n_pci_clock fndecl 0 3568 NULL
+disable_so_ata_sff_busy_sleep_fndecl_3571 ata_sff_busy_sleep fndecl 2-3 3571 NULL
+disable_so_min_freq_cpufreq_cpuinfo_3592 min_freq cpufreq_cpuinfo 0 3592 NULL
+disable_so_ver_blank_start_via_display_timing_3593 ver_blank_start via_display_timing 0 3593 NULL
+disable_so_last_tsc_khz_kvm_arch_3596 last_tsc_khz kvm_arch 0 3596 NULL
+disable_so_addrconf_sysctl_stable_secret_fndecl_3602 addrconf_sysctl_stable_secret fndecl 0 3602 NULL
+disable_so_rxq_addr_vf_pf_rxq_params_3624 rxq_addr vf_pf_rxq_params 0 3624 NULL
+disable_so_go7007_usb_ezusb_write_interrupt_fndecl_3625 go7007_usb_ezusb_write_interrupt fndecl 3-2 3625 NULL
+disable_so_zd_write_mac_addr_fndecl_3635 zd_write_mac_addr fndecl 0 3635 NULL
+disable_so_rt2x00crypto_tx_insert_iv_fndecl_3640 rt2x00crypto_tx_insert_iv fndecl 2 3640 NULL
+disable_so_lvb_imtime_packed_ocfs2_meta_lvb_3641 lvb_imtime_packed ocfs2_meta_lvb 0 3641 NULL
+disable_so_base_address_acpi_srat_mem_affinity_3662 base_address acpi_srat_mem_affinity 0 3662 NULL
+disable_so_time_ksz_counter_info_3667 time ksz_counter_info 0 3667 NULL
+disable_so_phys_addr_qlcnic_host_sds_ring_3676 phys_addr qlcnic_host_sds_ring 0 3676 NULL
+disable_so_addr_ipcm_cookie_3680 addr ipcm_cookie 0 3680 NULL
+disable_so_timestamp_nfs4_renewdata_3698 timestamp nfs4_renewdata 0 3698 NULL
+disable_so_ocfs2_find_subtree_root_fndecl_3700 ocfs2_find_subtree_root fndecl 0 3700 NULL
+disable_so_azx_get_delay_from_lpib_fndecl_3703 azx_get_delay_from_lpib fndecl 0-3 3703 NULL
+disable_so_ieee80211_frequency_to_channel_fndecl_3709 ieee80211_frequency_to_channel fndecl 0-1 3709 NULL
+disable_so_rx8025_sysfs_show_clock_adjust_fndecl_3720 rx8025_sysfs_show_clock_adjust fndecl 0 3720 NULL nohasharray
+disable_so_vtotal___fb_timings_3720 vtotal __fb_timings 0 3720 &disable_so_rx8025_sysfs_show_clock_adjust_fndecl_3720
+disable_so_autofs4_compat_get_set_timeout_fndecl_3726 autofs4_compat_get_set_timeout fndecl 0 3726 NULL
+disable_so_paddr_ath10k_mem_chunk_3729 paddr ath10k_mem_chunk 0 3729 NULL
+disable_so_interrupt_serio_driver_3738 interrupt serio_driver 2 3738 NULL
+disable_so_m2_gma_clock_t_3742 m2 gma_clock_t 0 3742 NULL
+disable_so_n_mt9t112_pll_divider_3743 n mt9t112_pll_divider 0 3743 NULL
+disable_so_gcm_hash_crypt_done_fndecl_3746 gcm_hash_crypt_done fndecl 2 3746 NULL
+disable_so_addr_i915_wa_reg_3751 addr i915_wa_reg 0 3751 NULL
+disable_so_r12_kvm_regs_3771 r12 kvm_regs 0 3771 NULL
+disable_so_sw_addr_dsa_chip_data_3785 sw_addr dsa_chip_data 0 3785 NULL
+disable_so_t_sec_xfs_ictimestamp_3790 t_sec xfs_ictimestamp 0 3790 NULL
+disable_so_ext4_block_bitmap_csum_set_fndecl_3795 ext4_block_bitmap_csum_set fndecl 2 3795 NULL
+disable_so_pud_page_vaddr_fndecl_3809 pud_page_vaddr fndecl 0 3809 NULL
+disable_so_coalescing_timeout_bfi_enet_ib_cfg_3813 coalescing_timeout bfi_enet_ib_cfg 0 3813 NULL
+disable_so_sg_list_dma_address_skd_command_header_3825 sg_list_dma_address skd_command_header 0 3825 NULL
+disable_so_ax25_display_timer_fndecl_3831 ax25_display_timer fndecl 0 3831 NULL
+disable_so_tsi721_imsg_interrupt_disable_fndecl_3835 tsi721_imsg_interrupt_disable fndecl 2-3 3835 NULL
+disable_so_irlap_start_mbusy_timer_fndecl_3852 irlap_start_mbusy_timer fndecl 2 3852 NULL
+disable_so_size_log2_iwch_create_cq_resp_3861 size_log2 iwch_create_cq_resp 0 3861 NULL
+disable_so_cttimeout_get_timeout_fndecl_3867 cttimeout_get_timeout fndecl 0 3867 NULL
+disable_so_ioadl_bus_addr_pmcraid_ioarcb_3871 ioadl_bus_addr pmcraid_ioarcb 0 3871 NULL
+disable_so___clocksource_register_scale_fndecl_3879 __clocksource_register_scale fndecl 2-3-0 3879 NULL
+disable_so_tx_lsndtime_ccid2_hc_tx_sock_3890 tx_lsndtime ccid2_hc_tx_sock 0 3890 NULL
+disable_so_xfs_btree_new_root_fndecl_3895 xfs_btree_new_root fndecl 0 3895 NULL
+disable_so_freq_p54_channel_entry_3897 freq p54_channel_entry 0 3897 NULL
+disable_so_xen_poll_irq_timeout_fndecl_3900 xen_poll_irq_timeout fndecl 1-2 3900 NULL
+disable_so_nilfs_btree_propagate_v_fndecl_3902 nilfs_btree_propagate_v fndecl 0 3902 NULL
+disable_so_max8907_rtc_set_time_fndecl_3905 max8907_rtc_set_time fndecl 0 3905 NULL
+disable_so_alps_command_mode_set_addr_fndecl_3910 alps_command_mode_set_addr fndecl 2 3910 NULL
+disable_so_ltimer_val_vxge_hw_tim_intr_config_3911 ltimer_val vxge_hw_tim_intr_config 0 3911 NULL
+disable_so_dqb_btime_v1_disk_dqblk_3914 dqb_btime v1_disk_dqblk 0 3914 NULL nohasharray
+disable_so_rsp_dmaaddr_fw_scsi_read_wr_3914 rsp_dmaaddr fw_scsi_read_wr 0 3914 &disable_so_dqb_btime_v1_disk_dqblk_3914
+disable_so_ieee802154_hdr_push_addr_fndecl_3915 ieee802154_hdr_push_addr fndecl 0 3915 NULL
+disable_so_blk_mq_init_bitmap_tags_fndecl_3929 blk_mq_init_bitmap_tags fndecl 2 3929 NULL
+disable_so_mtimensec_fuse_attr_3937 mtimensec fuse_attr 0 3937 NULL
+disable_so_cpu_clock_sample_group_fndecl_3939 cpu_clock_sample_group fndecl 1 3939 NULL
+disable_so_min_bit_val_anatop_regulator_3947 min_bit_val anatop_regulator 0 3947 NULL
+disable_so_warmup_time_sfb_sched_data_3959 warmup_time sfb_sched_data 0 3959 NULL
+disable_so_zd_write_mac_addr_common_fndecl_3965 zd_write_mac_addr_common fndecl 0 3965 NULL
+disable_so_ext2_valid_block_bitmap_fndecl_3966 ext2_valid_block_bitmap fndecl 3 3966 NULL
+disable_so_ctnetlink_change_timeout_fndecl_3973 ctnetlink_change_timeout fndecl 0 3973 NULL
+disable_so_root_nfs_parse_addr_fndecl_3974 root_nfs_parse_addr fndecl 0 3974 NULL
+disable_so_zalloc_cpumask_var_fndecl_3979 zalloc_cpumask_var fndecl 2 3979 NULL
+disable_so_sta_addr_hash_fndecl_3982 sta_addr_hash fndecl 0-3 3982 NULL
+disable_so_address_ins_format3_3983 address ins_format3 0 3983 NULL
+disable_so___nfsd4_write_time_fndecl_3999 __nfsd4_write_time fndecl 0 3999 NULL
+disable_so_disc_start_time_esas2r_adapter_4010 disc_start_time esas2r_adapter 0 4010 NULL
+disable_so_scroll_jiffies_magicmouse_sc_4034 scroll_jiffies magicmouse_sc 0 4034 NULL
+disable_so_add_input_randomness_fndecl_4036 add_input_randomness fndecl 3-1-2 4036 NULL
+disable_so_rc5t583_regulator_enable_time_fndecl_4047 rc5t583_regulator_enable_time fndecl 0 4047 NULL
+disable_so_s_log2sharesize_adfs_sb_info_4052 s_log2sharesize adfs_sb_info 0 4052 NULL
+disable_so___bitmap_or_fndecl_4055 __bitmap_or fndecl 4 4055 NULL
+disable_so_clockevents_config_and_register_fndecl_4078 clockevents_config_and_register fndecl 2-3-4 4078 NULL
+disable_so_db_addr_mlx5_ib_create_qp_4086 db_addr mlx5_ib_create_qp 0 4086 NULL
+disable_so_t4_wr_mbox_meat_fndecl_4090 t4_wr_mbox_meat fndecl 0-2 4090 NULL
+disable_so_debounce_time_lm8333_platform_data_4097 debounce_time lm8333_platform_data 0 4097 NULL
+disable_so_di_atime_logfs_disk_inode_4115 di_atime logfs_disk_inode 0 4115 NULL
+disable_so_slave_address_cp2112_read_req_report_4116 slave_address cp2112_read_req_report 0 4116 NULL
+disable_so_sleep_functions_on_battery_store_fndecl_4126 sleep_functions_on_battery_store fndecl 0-4 4126 NULL
+disable_so_neigh_rand_reach_time_fndecl_4142 neigh_rand_reach_time fndecl 0-1 4142 NULL
+disable_so_fib_devindex_hashfn_fndecl_4150 fib_devindex_hashfn fndecl 0-1 4150 NULL
+disable_so_compat_sys_clock_adjtime_fndecl_4152 compat_sys_clock_adjtime fndecl 1 4152 NULL nohasharray
+disable_so_addr_sh_eth_rxdesc_4152 addr sh_eth_rxdesc 0 4152 &disable_so_compat_sys_clock_adjtime_fndecl_4152
+disable_so_throttled_clock_task_time_cfs_rq_4161 throttled_clock_task_time cfs_rq 0 4161 NULL
+disable_so_usb_set_lpm_timeout_fndecl_4163 usb_set_lpm_timeout fndecl 3 4163 NULL
+disable_so_delay_multi_eq_delay_info_4167 delay_multi eq_delay_info 0 4167 NULL nohasharray
+disable_so_reg_w_fndecl_4167 reg_w fndecl 2 4167 &disable_so_delay_multi_eq_delay_info_4167
+disable_so_btree_migratepage_fndecl_4171 btree_migratepage fndecl 0 4171 NULL
+disable_so_vpfe_set_sdr_addr_fndecl_4178 vpfe_set_sdr_addr fndecl 2 4178 NULL
+disable_so_rx_beacon_signal_avg_station_info_4180 rx_beacon_signal_avg station_info 0 4180 NULL
+disable_so_put_time_rxrpc_connection_4183 put_time rxrpc_connection 0 4183 NULL
+disable_so_demod_address_nxt200x_config_4185 demod_address nxt200x_config 0 4185 NULL
+disable_so_addr_lo_cmdQ_e_4186 addr_lo cmdQ_e 0 4186 NULL
+disable_so_addr_lo_eth_tx_next_bd_4188 addr_lo eth_tx_next_bd 0 4188 NULL
+disable_so_timeout_kbd_backlight_4193 timeout kbd_backlight 0 4193 NULL
+disable_so_hw_ptr_buffer_jiffies_snd_pcm_runtime_4199 hw_ptr_buffer_jiffies snd_pcm_runtime 0 4199 NULL
+disable_so_hash_walk_new_entry_fndecl_4203 hash_walk_new_entry fndecl 0 4203 NULL
+disable_so_time_of_death_afs_server_4206 time_of_death afs_server 0 4206 NULL
+disable_so_rtl2832_sdr_s_frequency_fndecl_4208 rtl2832_sdr_s_frequency fndecl 0 4208 NULL
+disable_so_si476x_radio_g_frequency_fndecl_4218 si476x_radio_g_frequency fndecl 0 4218 NULL
+disable_so_ahc_delay_fndecl_4220 ahc_delay fndecl 1 4220 NULL
+disable_so_mounted_time_sit_info_4228 mounted_time sit_info 0 4228 NULL
+disable_so_ahash_register_instance_fndecl_4229 ahash_register_instance fndecl 0 4229 NULL
+disable_so_f_frequency_e4000_dev_4236 f_frequency e4000_dev 0 4236 NULL
+disable_so_timekeeping_adjust_fndecl_4243 timekeeping_adjust fndecl 2 4243 NULL
+disable_so_sis190_mac_addr_fndecl_4248 sis190_mac_addr fndecl 0 4248 NULL nohasharray
+disable_so_vma_interval_tree_subtree_search_fndecl_4248 vma_interval_tree_subtree_search fndecl 2-3 4248 &disable_so_sis190_mac_addr_fndecl_4248
+disable_so_xhci_enable_usb3_lpm_timeout_fndecl_4278 xhci_enable_usb3_lpm_timeout fndecl 0 4278 NULL
+disable_so_address_be_bus_address64_4299 address be_bus_address64 0 4299 NULL
+disable_so_freq_tef6862_state_4304 freq tef6862_state 0 4304 NULL
+disable_so_aes_decrypt_interrupt_read_fndecl_4309 aes_decrypt_interrupt_read fndecl 3-0 4309 NULL
+disable_so_lm3533_set_boost_freq_fndecl_4311 lm3533_set_boost_freq fndecl 0-2 4311 NULL
+disable_so_adis16400_set_freq_fndecl_4314 adis16400_set_freq fndecl 0 4314 NULL
+disable_so_vsync_offset_pulse_width_lo_detailed_pixel_timing_4318 vsync_offset_pulse_width_lo detailed_pixel_timing 0 4318 NULL
+disable_so_time_atkbd_4320 time atkbd 0 4320 NULL nohasharray
+disable_so_make_kuid_fndecl_4320 make_kuid fndecl 2 4320 &disable_so_time_atkbd_4320
+disable_so_lookup_scsi3addr_fndecl_4332 lookup_scsi3addr fndecl 2-3-4 4332 NULL
+disable_so_bf_buf_addr_ath_rxbuf_4337 bf_buf_addr ath_rxbuf 0 4337 NULL
+disable_so_kbd_backlight_timeout_vardecl_sony_laptop_c_4340 kbd_backlight_timeout vardecl_sony-laptop.c 0 4340 NULL
+disable_so_tomoyo_addprintf_fndecl_4352 tomoyo_addprintf fndecl 2 4352 NULL
+disable_so_ab3100_get_register_interruptible_fndecl_4353 ab3100_get_register_interruptible fndecl 0 4353 NULL
+disable_so_cpufreq_add_dev_interface_fndecl_4356 cpufreq_add_dev_interface fndecl 0 4356 NULL
+disable_so_upper_addr_ufshcd_sg_entry_4364 upper_addr ufshcd_sg_entry 0 4364 NULL
+disable_so_linear_address_kvm_translation_4366 linear_address kvm_translation 0 4366 NULL
+disable_so_n_tty_receive_signal_char_fndecl_4373 n_tty_receive_signal_char fndecl 2 4373 NULL
+disable_so_proc_uid_vardecl_airo_c_4387 proc_uid vardecl_airo.c 0 4387 NULL nohasharray
+disable_so_dequeue_signal_fndecl_4387 dequeue_signal fndecl 0 4387 &disable_so_proc_uid_vardecl_airo_c_4387
+disable_so_nilfs_btree_root_broken_fndecl_4403 nilfs_btree_root_broken fndecl 2 4403 NULL
+disable_so_kstrtoll_from_user_fndecl_4415 kstrtoll_from_user fndecl 2 4415 NULL
+disable_so_timestamp_fw_packet_4416 timestamp fw_packet 0 4416 NULL
+disable_so_hhf_reset_timeout_hhf_sched_data_4417 hhf_reset_timeout hhf_sched_data 0 4417 NULL
+disable_so_timeout_mpt3_ioctl_command_4422 timeout mpt3_ioctl_command 0 4422 NULL
+disable_so_reg_write_fndecl_4433 reg_write fndecl 0-2-3 4433 NULL
+disable_so_et0phyaddr_ssb_sprom_4448 et0phyaddr ssb_sprom 0 4448 NULL
+disable_so_prev_steal_time_rq_4451 prev_steal_time rq 0 4451 NULL
+disable_so_master_init_timer_mipi_config_4453 master_init_timer mipi_config 0 4453 NULL
+disable_so_find_eth_addr_in_vpd_fndecl_4457 find_eth_addr_in_vpd fndecl 3 4457 NULL
+disable_so_ccca_start_addr_snd_emu10k1_pcm_4459 ccca_start_addr snd_emu10k1_pcm 0 4459 NULL
+disable_so_freq_offset_khz_vhf_dib0090_config_4461 freq_offset_khz_vhf dib0090_config 0 4461 NULL
+disable_so_rxqueue_timer_velocity_opt_4470 rxqueue_timer velocity_opt 0 4470 NULL
+disable_so_sysctl_rose_link_fail_timeout_vardecl_4477 sysctl_rose_link_fail_timeout vardecl 0 4477 NULL
+disable_so_ablkcipher_walk_first_fndecl_4483 ablkcipher_walk_first fndecl 0 4483 NULL
+disable_so_get_cached_alias_guid_fndecl_4490 get_cached_alias_guid fndecl 2-3 4490 NULL
+disable_so_cfg80211_chandef_dfs_cac_time_fndecl_4493 cfg80211_chandef_dfs_cac_time fndecl 0 4493 NULL
+disable_so_mclk_div2_cs42l56_private_4499 mclk_div2 cs42l56_private 0 4499 NULL
+disable_so_snd_timer_user_ioctl_fndecl_4500 snd_timer_user_ioctl fndecl 0 4500 NULL nohasharray
+disable_so_s5p_mfc_clock_on_fndecl_4500 s5p_mfc_clock_on fndecl 0 4500 &disable_so_snd_timer_user_ioctl_fndecl_4500
+disable_so_boundary_snd_pcm_runtime_4504 boundary snd_pcm_runtime 0 4504 NULL nohasharray
+disable_so_show_message_age_timer_fndecl_4504 show_message_age_timer fndecl 0 4504 &disable_so_boundary_snd_pcm_runtime_4504
+disable_so_tn_smc_wreg_fndecl_4512 tn_smc_wreg fndecl 2-3 4512 NULL
+disable_so_ip_perf_sample_data_4515 ip perf_sample_data 0 4515 NULL nohasharray
+disable_so_intel_gpu_freq_fndecl_4515 intel_gpu_freq fndecl 0-2 4515 &disable_so_ip_perf_sample_data_4515
+disable_so_clk_delay_mmc_host_4517 clk_delay mmc_host 0 4517 NULL
+disable_so_addr_atiixp_modem_4521 addr atiixp_modem 0 4521 NULL
+disable_so_rsp_dmaaddr_fw_scsi_write_wr_4522 rsp_dmaaddr fw_scsi_write_wr 0 4522 NULL
+disable_so_last_sum_exec_runtime_task_struct_4531 last_sum_exec_runtime task_struct 0 4531 NULL
+disable_so_buf_addr_mlx5_ib_create_qp_4533 buf_addr mlx5_ib_create_qp 0 4533 NULL
+disable_so_set_h245_addr_fndecl_4538 set_h245_addr fndecl 2-4 4538 NULL
+disable_so_sleep_reg_fan53555_device_info_4552 sleep_reg fan53555_device_info 0 4552 NULL
+disable_so_freqmode__pll_div_4562 freqmode _pll_div 0 4562 NULL
+disable_so_buffer_addr_i40e_tx_desc_4570 buffer_addr i40e_tx_desc 0 4570 NULL
+disable_so_ctime_cifs_unix_set_info_args_4572 ctime cifs_unix_set_info_args 0 4572 NULL
+disable_so_pci_bus_saa7164_dev_4576 pci_bus saa7164_dev 0 4576 NULL
+disable_so_addr_vhost_log_4579 addr vhost_log 0 4579 NULL
+disable_so_store_fan_div_fndecl_4585 store_fan_div fndecl 0-4 4585 NULL
+disable_so_timeout__mgslpc_info_4586 timeout _mgslpc_info 0 4586 NULL
+disable_so_posix_timer_add_fndecl_4591 posix_timer_add fndecl 0 4591 NULL
+disable_so_system_timestamp_iwl_rx_phy_info_4592 system_timestamp iwl_rx_phy_info 0 4592 NULL
+disable_so_guid_ib_dm_ioc_profile_4593 guid ib_dm_ioc_profile 0 4593 NULL
+disable_so_qat_alg_ablkcipher_init_com_fndecl_4596 qat_alg_ablkcipher_init_com fndecl 5 4596 NULL
+disable_so_irlan_client_start_kick_timer_fndecl_4618 irlan_client_start_kick_timer fndecl 2 4618 NULL
+disable_so_kvm_apic_match_physical_addr_fndecl_4632 kvm_apic_match_physical_addr fndecl 2 4632 NULL
+disable_so_task_fix_setuid_security_operations_4637 task_fix_setuid security_operations 0 4637 NULL
+disable_so_nla_put_labels_fndecl_4639 nla_put_labels fndecl 3 4639 NULL
+disable_so_xen_pcibk_guest_interrupt_fndecl_4644 xen_pcibk_guest_interrupt fndecl 1 4644 NULL
+disable_so_phys_addr_qlcnic_fw_dump_4650 phys_addr qlcnic_fw_dump 0 4650 NULL
+disable_so_daddr_ath5k_buf_4651 daddr ath5k_buf 0 4651 NULL
+disable_so_phase_delay_atom_voltage_table_4655 phase_delay atom_voltage_table 0 4655 NULL
+disable_so_nl80211_send_auth_timeout_fndecl_4657 nl80211_send_auth_timeout fndecl 4 4657 NULL
+disable_so_af9013_statistics_signal_strength_fndecl_4658 af9013_statistics_signal_strength fndecl 0 4658 NULL
+disable_so_kbd_led_timeout_store_fndecl_4659 kbd_led_timeout_store fndecl 0-4 4659 NULL
+disable_so_byte_align_snd_pcm_runtime_4661 byte_align snd_pcm_runtime 0 4661 NULL
+disable_so_stv0900_get_timing_offst_fndecl_4670 stv0900_get_timing_offst fndecl 0-2 4670 NULL
+disable_so_clk_frequency_imx_sgtl5000_data_4671 clk_frequency imx_sgtl5000_data 0 4671 NULL
+disable_so_sys_image_guid_ib_device_attr_4674 sys_image_guid ib_device_attr 0 4674 NULL
+disable_so_timestamp_usec_rt2x00dump_hdr_4680 timestamp_usec rt2x00dump_hdr 0 4680 NULL
+disable_so_ieee80211_aes_cmac_fndecl_4693 ieee80211_aes_cmac fndecl 4 4693 NULL
+disable_so_hpi_handle_indexes_fndecl_4704 hpi_handle_indexes fndecl 1 4704 NULL
+disable_so_runtime_suspend_mmc_bus_ops_4709 runtime_suspend mmc_bus_ops 0 4709 NULL
+disable_so_i_atime_bfs_inode_4710 i_atime bfs_inode 0 4710 NULL
+disable_so_tsf_timestamp_rx_ppdu_end_common_4717 tsf_timestamp rx_ppdu_end_common 0 4717 NULL
+disable_so_register_blkdev_fndecl_4723 register_blkdev fndecl 0-1 4723 NULL
+disable_so_clockevents_unbind_fndecl_4727 clockevents_unbind fndecl 2 4727 NULL
+disable_so_dma_addr_vmxnet3_rx_buf_info_4730 dma_addr vmxnet3_rx_buf_info 0 4730 NULL
+disable_so_ip_idents_reserve_fndecl_4731 ip_idents_reserve fndecl 0-1-2 4731 NULL
+disable_so_atomic64_sub_and_test_fndecl_4733 atomic64_sub_and_test fndecl 1 4733 NULL nohasharray
+disable_so_hsync_offset_lo_detailed_pixel_timing_4733 hsync_offset_lo detailed_pixel_timing 0 4733 &disable_so_atomic64_sub_and_test_fndecl_4733
+disable_so_wakeup_total_time_show_fndecl_4745 wakeup_total_time_show fndecl 0 4745 NULL
+disable_so_kv_get_sleep_divider_id_from_clock_fndecl_4756 kv_get_sleep_divider_id_from_clock fndecl 2 4756 NULL
+disable_so_delay_fn_vardecl_delay_c_4772 delay_fn vardecl_delay.c 1 4772 NULL
+disable_so_do_sched_cfs_period_timer_fndecl_4778 do_sched_cfs_period_timer fndecl 2 4778 NULL
+disable_so_gid_index_mlx4_av_4786 gid_index mlx4_av 0 4786 NULL
+disable_so_rq_addr_high_nes_qp_context_4796 rq_addr_high nes_qp_context 0 4796 NULL
+disable_so_last_commit_jiffies_cache_4801 last_commit_jiffies cache 0 4801 NULL
+disable_so_frequency_sst_hsw_audio_data_format_ipc_4811 frequency sst_hsw_audio_data_format_ipc 0 4811 NULL
+disable_so_dev_sleep_time_cyapa_4825 dev_sleep_time cyapa 0 4825 NULL nohasharray
+disable_so_si570_update_rfreq_fndecl_4825 si570_update_rfreq fndecl 0 4825 &disable_so_dev_sleep_time_cyapa_4825
+disable_so_reply_dma_max_address_MPT2SAS_ADAPTER_4826 reply_dma_max_address MPT2SAS_ADAPTER 0 4826 NULL
+disable_so_freq_nvkm_ram_data_4838 freq nvkm_ram_data 0 4838 NULL
+disable_so_ata_timing_find_mode_fndecl_4841 ata_timing_find_mode fndecl 1 4841 NULL
+disable_so_hci_bdaddr_list_del_fndecl_4856 hci_bdaddr_list_del fndecl 0 4856 NULL
+disable_so_challenge_timestamp_vardecl_tcp_input_c_4859 challenge_timestamp vardecl_tcp_input.c 0 4859 NULL
+disable_so_bar2_address_fndecl_4862 bar2_address fndecl 2 4862 NULL
+disable_so_time_pardevice_4872 time pardevice 0 4872 NULL
+disable_so_open_posix_clock_operations_4876 open posix_clock_operations 2 4876 NULL
+disable_so_buf2_addr_xgmac_dma_desc_4877 buf2_addr xgmac_dma_desc 0 4877 NULL
+disable_so_mixart_set_clock_fndecl_4878 mixart_set_clock fndecl 3 4878 NULL nohasharray
+disable_so_adis16480_get_filter_freq_fndecl_4878 adis16480_get_filter_freq fndecl 0 4878 &disable_so_mixart_set_clock_fndecl_4878
+disable_so_ssb_chipco_watchdog_get_max_timer_fndecl_4885 ssb_chipco_watchdog_get_max_timer fndecl 0 4885 NULL
+disable_so_sys_timerfd_gettime_fndecl_4888 sys_timerfd_gettime fndecl 1 4888 NULL nohasharray
+disable_so_regcache_rbtree_read_fndecl_4888 regcache_rbtree_read fndecl 2 4888 &disable_so_sys_timerfd_gettime_fndecl_4888
+disable_so_reiserfs_read_bitmap_block_fndecl_4892 reiserfs_read_bitmap_block fndecl 2 4892 NULL
+disable_so_mapaddr_bq_desc_4896 mapaddr bq_desc 0 4896 NULL
+disable_so_sec_tomoyo_time_4898 sec tomoyo_time 0 4898 NULL
+disable_so_nvkm_timer_wait_ne_fndecl_4904 nvkm_timer_wait_ne fndecl 3-5 4904 NULL
+disable_so_ehash_locks_mask_inet_hashinfo_4906 ehash_locks_mask inet_hashinfo 0 4906 NULL
+disable_so_split_scan_timeout_read_fndecl_4910 split_scan_timeout_read fndecl 3-0 4910 NULL
+disable_so_rdmsr_safe_regs_on_cpu_fndecl_4918 rdmsr_safe_regs_on_cpu fndecl 0-1 4918 NULL
+disable_so_data_addr_pmu_nvbios_pmuR_4930 data_addr_pmu nvbios_pmuR 0 4930 NULL
+disable_so_fs_overflowgid_vardecl_4952 fs_overflowgid vardecl 0 4952 NULL
+disable_so_crypto_authenc_esn_encrypt_done_fndecl_4953 crypto_authenc_esn_encrypt_done fndecl 2 4953 NULL
+disable_so_addr_lo_sdhci_adma2_64_desc_4956 addr_lo sdhci_adma2_64_desc 0 4956 NULL
+disable_so_hc_erase_timeout_mmc_ext_csd_4958 hc_erase_timeout mmc_ext_csd 0 4958 NULL nohasharray
+disable_so_translation_offset_acpi_address64_attribute_4958 translation_offset acpi_address64_attribute 0 4958 &disable_so_hc_erase_timeout_mmc_ext_csd_4958
+disable_so_address_acpi_object_region_4962 address acpi_object_region 0 4962 NULL
+disable_so_nlmsvc_timeout_vardecl_4968 nlmsvc_timeout vardecl 0 4968 NULL
+disable_so_icmpv6_time_netns_sysctl_ipv6_4971 icmpv6_time netns_sysctl_ipv6 0 4971 NULL
+disable_so_rhashtable_walk_init_fndecl_4975 rhashtable_walk_init fndecl 0 4975 NULL
+disable_so_tm_wday_rtc_time_4991 tm_wday rtc_time 0 4991 NULL
+disable_so_pre_event_timeout_seq_oss_readq_4996 pre_event_timeout seq_oss_readq 0 4996 NULL
+disable_so_m_sys_clock_freq_drxk_state_5005 m_sys_clock_freq drxk_state 0 5005 NULL
+disable_so_btree_merge_fndecl_5007 btree_merge fndecl 4 5007 NULL
+disable_so_addr_snd_dma_buffer_5022 addr snd_dma_buffer 0 5022 NULL
+disable_so_mlx4_get_slave_num_gids_fndecl_5024 mlx4_get_slave_num_gids fndecl 0-2-3 5024 NULL
+disable_so_time_nfc_llcp_sdp_tlv_5037 time nfc_llcp_sdp_tlv 0 5037 NULL
+disable_so_hangcheck_tsc_margin_vardecl_hangcheck_timer_c_5043 hangcheck_tsc_margin vardecl_hangcheck-timer.c 0 5043 NULL
+disable_so_fill_node_footer_blkaddr_fndecl_5053 fill_node_footer_blkaddr fndecl 2 5053 NULL
+disable_so_sc_lseg_stime_nilfs_sc_info_5054 sc_lseg_stime nilfs_sc_info 0 5054 NULL
+disable_so_kstrtou8_fndecl_5058 kstrtou8 fndecl 0 5058 NULL
+disable_so_RF_SYN_pll_refdiv_chan_info_nphy_radio205x_5063 RF_SYN_pll_refdiv chan_info_nphy_radio205x 0 5063 NULL
+disable_so_addr_lo_tx_desc_5065 addr_lo tx_desc 0 5065 NULL
+disable_so_mos7840_calc_baud_rate_divisor_fndecl_5067 mos7840_calc_baud_rate_divisor fndecl 2 5067 NULL nohasharray
+disable_so_addr_iwch_mm_entry_5067 addr iwch_mm_entry 0 5067 &disable_so_mos7840_calc_baud_rate_divisor_fndecl_5067
+disable_so_freq_wmi_send_mgmt_cmd_5080 freq wmi_send_mgmt_cmd 0 5080 NULL
+disable_so_wep_addr_key_count_read_fndecl_5085 wep_addr_key_count_read fndecl 3-0 5085 NULL
+disable_so_bitmap_find_next_zero_area_off_fndecl_5088 bitmap_find_next_zero_area_off fndecl 0-2-3-4-5-6 5088 NULL
+disable_so_udf_bitmap_new_block_fndecl_5093 udf_bitmap_new_block fndecl 0-4 5093 NULL
+disable_so_ds1343_read_time_fndecl_5094 ds1343_read_time fndecl 0 5094 NULL nohasharray
+disable_so_panel_blon_delay_radeon_encoder_lvds_5094 panel_blon_delay radeon_encoder_lvds 0 5094 &disable_so_ds1343_read_time_fndecl_5094
+disable_so_hpi_cobranet_set_ip_address_fndecl_5106 hpi_cobranet_set_ip_address fndecl 1 5106 NULL
+disable_so_rx_bidx_addr_bnx2_rx_ring_info_5107 rx_bidx_addr bnx2_rx_ring_info 0 5107 NULL nohasharray
+disable_so_bitmap_andnot_fndecl_5107 bitmap_andnot fndecl 4 5107 &disable_so_rx_bidx_addr_bnx2_rx_ring_info_5107
+disable_so_end_seq_illinois_5111 end_seq illinois 0 5111 NULL
+disable_so_in_progress_block_addr_flchip_5114 in_progress_block_addr flchip 0 5114 NULL
+disable_so_xmit_timestamp_cw1200_queue_item_5121 xmit_timestamp cw1200_queue_item 0 5121 NULL
+disable_so_snd_ymfpci_timer_fndecl_5137 snd_ymfpci_timer fndecl 2-0 5137 NULL
+disable_so_sysctl_rose_no_activity_timeout_vardecl_5143 sysctl_rose_no_activity_timeout vardecl 0 5143 NULL
+disable_so_mtime_p9_wstat_5152 mtime p9_wstat 0 5152 NULL nohasharray
+disable_so_addr_mvs_prd_5152 addr mvs_prd 0 5152 &disable_so_mtime_p9_wstat_5152
+disable_so_pcan_usb_pro_set_bittiming_fndecl_5169 pcan_usb_pro_set_bittiming fndecl 0 5169 NULL
+disable_so_phy_addr_e1000_hw_5196 phy_addr e1000_hw 0 5196 NULL
+disable_so_cpufreq_p4_init_fndecl_5201 cpufreq_p4_init fndecl 0 5201 NULL
+disable_so_iscsit_na_dataout_timeout_retries_fndecl_5205 iscsit_na_dataout_timeout_retries fndecl 0 5205 NULL
+disable_so_ata_sff_queue_delayed_work_fndecl_5217 ata_sff_queue_delayed_work fndecl 2 5217 NULL
+disable_so_post_div_atom_mpll_param_5225 post_div atom_mpll_param 0 5225 NULL
+disable_so_cfg80211_wext_freq_fndecl_5229 cfg80211_wext_freq fndecl 0 5229 NULL
+disable_so_poll_timer_vardecl_hfcmulti_c_5232 poll_timer vardecl_hfcmulti.c 0 5232 NULL
+disable_so_antdiv_ctl1_modal_eep_4k_header_5248 antdiv_ctl1 modal_eep_4k_header 0 5248 NULL
+disable_so_snd_efw_command_get_clock_source_fndecl_5253 snd_efw_command_get_clock_source fndecl 0 5253 NULL
+disable_so_img_ir_free_timing_dynamic_fndecl_5255 img_ir_free_timing_dynamic fndecl 0-1 5255 NULL
+disable_so_iscsi_nacl_attrib_store_dataout_timeout_retries_fndecl_5267 iscsi_nacl_attrib_store_dataout_timeout_retries fndecl 0-3 5267 NULL
+disable_so_st_mtime_nsec_compat_stat_5268 st_mtime_nsec compat_stat 0 5268 NULL nohasharray
+disable_so_mpll_dq_func_cntl_2_rv770_clock_registers_5268 mpll_dq_func_cntl_2 rv770_clock_registers 0 5268 &disable_so_st_mtime_nsec_compat_stat_5268
+disable_so_selinux_task_setpgid_fndecl_5275 selinux_task_setpgid fndecl 0 5275 NULL
+disable_so_target_addr_sg_entry_5281 target_addr sg_entry 0 5281 NULL nohasharray
+disable_so_range_start_fixed_mtrr_segment_5281 range_start fixed_mtrr_segment 0 5281 &disable_so_target_addr_sg_entry_5281
+disable_so_interrupt_offset_vnic_cq_5300 interrupt_offset vnic_cq 0 5300 NULL
+disable_so_usb_calc_bus_time_fndecl_5306 usb_calc_bus_time fndecl 0-4-2 5306 NULL
+disable_so_cypress_calculate_burst_time_fndecl_5314 cypress_calculate_burst_time fndecl 2-3-0 5314 NULL nohasharray
+disable_so_ds_num_nfs4_file_layout_dsaddr_5314 ds_num nfs4_file_layout_dsaddr 0 5314 &disable_so_cypress_calculate_burst_time_fndecl_5314
+disable_so_nilfs_btree_assign_v_fndecl_5317 nilfs_btree_assign_v fndecl 0-5 5317 NULL
+disable_so_seq_tipc_nl_msg_5321 seq tipc_nl_msg 0 5321 NULL
+disable_so_dr_addr_qlc_83xx_quad_entry_5328 dr_addr qlc_83xx_quad_entry 0 5328 NULL
+disable_so_lzo_decompress_fndecl_5329 lzo_decompress fndecl 3 5329 NULL
+disable_so_get_phys_addr_esas2r_sg_context_5331 get_phys_addr esas2r_sg_context 0 5331 NULL
+disable_so_i2c_udelay_vardecl_bttv_i2c_c_5339 i2c_udelay vardecl_bttv-i2c.c 0 5339 NULL
+disable_so_msr_src_desc_5345 msr src_desc 0 5345 NULL
+disable_so_put_time_rxrpc_transport_5355 put_time rxrpc_transport 0 5355 NULL
+disable_so_mtrr_del_fndecl_5356 mtrr_del fndecl 2-3 5356 NULL
+disable_so_d_itimer_fs_disk_quota_5358 d_itimer fs_disk_quota 0 5358 NULL
+disable_so_buf_phy_addr_high_ql_rcv_buf_cb_5366 buf_phy_addr_high ql_rcv_buf_cb 0 5366 NULL
+disable_so_cpufreq_get_cur_state_fndecl_5369 cpufreq_get_cur_state fndecl 1 5369 NULL
+disable_so_hi_cfg_bridge_delay_drxj_data_5374 hi_cfg_bridge_delay drxj_data 0 5374 NULL
+disable_so_btrfs_uuid_tree_lookup_fndecl_5376 btrfs_uuid_tree_lookup fndecl 0-3-4 5376 NULL
+disable_so_ds1347_read_time_fndecl_5383 ds1347_read_time fndecl 0 5383 NULL nohasharray
+disable_so_uv_nmi_slave_delay_vardecl_uv_nmi_c_5383 uv_nmi_slave_delay vardecl_uv_nmi.c 0 5383 &disable_so_ds1347_read_time_fndecl_5383
+disable_so_nvm_start_addr_code_entry_5390 nvm_start_addr code_entry 0 5390 NULL
+disable_so_bna_tx_coalescing_timeo_set_fndecl_5397 bna_tx_coalescing_timeo_set fndecl 2 5397 NULL
+disable_so_ptp_pch_adjtime_fndecl_5406 ptp_pch_adjtime fndecl 2 5406 NULL nohasharray
+disable_so_setkey_blkcipher_tfm_5406 setkey blkcipher_tfm 0-3 5406 &disable_so_ptp_pch_adjtime_fndecl_5406
+disable_so_poll_time_plat_max3100_5416 poll_time plat_max3100 0 5416 NULL
+disable_so_xfrm_hash_free_fndecl_5437 xfrm_hash_free fndecl 2 5437 NULL
+disable_so_sh_cmt_register_clockevent_fndecl_5438 sh_cmt_register_clockevent fndecl 0 5438 NULL
+disable_so_wake_cnt_blk_mq_bitmap_tags_5442 wake_cnt blk_mq_bitmap_tags 0 5442 NULL
+disable_so_ping_clear_saddr_fndecl_5445 ping_clear_saddr fndecl 2 5445 NULL
+disable_so_address_dummy_5460 address dummy 0 5460 NULL
+disable_so_rtl_signal_scale_mapping_fndecl_5462 rtl_signal_scale_mapping fndecl 0-2 5462 NULL
+disable_so_nfs_cache_getent_timeout_vardecl_cache_lib_c_5468 nfs_cache_getent_timeout vardecl_cache_lib.c 0 5468 NULL
+disable_so_wmi_addr_remap_fndecl_5469 wmi_addr_remap fndecl 0-1 5469 NULL
+disable_so_hash_mem_fndecl_5475 hash_mem fndecl 2 5475 NULL
+disable_so_mpll_ss1_ni_clock_registers_5476 mpll_ss1 ni_clock_registers 0 5476 NULL
+disable_so_cg_spll_spread_spectrum_rv730_clock_registers_5480 cg_spll_spread_spectrum rv730_clock_registers 0 5480 NULL
+disable_so_data_shared_msr_entry_5484 data shared_msr_entry 0 5484 NULL
+disable_so_bitmap_count_page_fndecl_5494 bitmap_count_page fndecl 2 5494 NULL
+disable_so_write_radio_reg_fndecl_5497 write_radio_reg fndecl 2-3 5497 NULL nohasharray
+disable_so_skcipher_recvmsg_async_fndecl_5497 skcipher_recvmsg_async fndecl 0 5497 &disable_so_write_radio_reg_fndecl_5497
+disable_so_i2c_address_stv6110_priv_5499 i2c_address stv6110_priv 0 5499 NULL
+disable_so_sh_cmt_clocksource_enable_fndecl_5501 sh_cmt_clocksource_enable fndecl 0 5501 NULL
+disable_so_effhash_fndecl_5510 effhash fndecl 0-1 5510 NULL
+disable_so_kswapd_try_to_sleep_fndecl_5521 kswapd_try_to_sleep fndecl 2 5521 NULL
+disable_so_oublock_signal_struct_5525 oublock signal_struct 0 5525 NULL
+disable_so_intel_bios_ssc_frequency_fndecl_5528 intel_bios_ssc_frequency fndecl 0 5528 NULL
+disable_so_ioasa_bus_addr_pmcraid_ioarcb_5540 ioasa_bus_addr pmcraid_ioarcb 0 5540 NULL
+disable_so_addr_req_t_5548 addr req_t 0 5548 NULL
+disable_so_xfs_btree_read_bufl_fndecl_5558 xfs_btree_read_bufl fndecl 0-3 5558 NULL
+disable_so_csa_expire_time_mwifiex_private_5561 csa_expire_time mwifiex_private 0 5561 NULL
+disable_so_hpi_cobranet_set_static_ip_address_fndecl_5564 hpi_cobranet_set_static_ip_address fndecl 1 5564 NULL
+disable_so_crypto_sha256_update_fndecl_5571 crypto_sha256_update fndecl 3 5571 NULL
+disable_so_pixclock_vardecl_matroxfb_base_c_5573 pixclock vardecl_matroxfb_base.c 0 5573 NULL
+disable_so_crypto_inc_byte_fndecl_5578 crypto_inc_byte fndecl 2 5578 NULL
+disable_so_duration_iwl_time_event_cmd_5595 duration iwl_time_event_cmd 0 5595 NULL
+disable_so_ddcb_daddr_ddcb_queue_5599 ddcb_daddr ddcb_queue 0 5599 NULL
+disable_so_sst_handle_vb_timer_fndecl_5602 sst_handle_vb_timer fndecl 0 5602 NULL
+disable_so_comp_resp_timeout_reg_pch_phub_reg_5604 comp_resp_timeout_reg pch_phub_reg 0 5604 NULL
+disable_so_sys_getegid_fndecl_5608 sys_getegid fndecl 0 5608 NULL
+disable_so_st_gid___old_kernel_stat_5613 st_gid __old_kernel_stat 0 5613 NULL
+disable_so_daddr_iphdr_5614 daddr iphdr 0 5614 NULL
+disable_so_desc_set_buf_addr_and_size_fndecl_5618 desc_set_buf_addr_and_size fndecl 2-3 5618 NULL
+disable_so_pch_udc_enable_ep_interrupts_fndecl_5624 pch_udc_enable_ep_interrupts fndecl 2 5624 NULL
+disable_so_physaddr_brcmf_msgbuf_pktid_5642 physaddr brcmf_msgbuf_pktid 0 5642 NULL
+disable_so_usb_timeout_vardecl_radio_si470x_usb_c_5648 usb_timeout vardecl_radio-si470x-usb.c 0 5648 NULL
+disable_so_show_sys_image_guid_fndecl_5652 show_sys_image_guid fndecl 0 5652 NULL
+disable_so_mtask_addr_beiscsi_io_task_5654 mtask_addr beiscsi_io_task 0 5654 NULL
+disable_so_no_addr_gfs2_inum_host_5660 no_addr gfs2_inum_host 0 5660 NULL
+disable_so___sw_hweight64_fndecl_5663 __sw_hweight64 fndecl 1-0 5663 NULL
+disable_so_aca_tstamp_ifacaddr6_5678 aca_tstamp ifacaddr6 0 5678 NULL
+disable_so_fill_in_addresses_op_x86_model_spec_5684 fill_in_addresses op_x86_model_spec 0 5684 NULL
+disable_so_root_hfs_btree_5692 root hfs_btree 0 5692 NULL
+disable_so_update_time_saa7164_histogram_bucket_5697 update_time saa7164_histogram_bucket 0 5697 NULL
+disable_so_hw_ptr_base_snd_pcm_runtime_5698 hw_ptr_base snd_pcm_runtime 0 5698 NULL
+disable_so_snd_emu10k1_timer_fndecl_5702 snd_emu10k1_timer fndecl 2-0 5702 NULL
+disable_so_bmap_hash_id_fndecl_5706 bmap_hash_id fndecl 0-2 5706 NULL
+disable_so_timeout_abs_ns_vcpu_set_singleshot_timer_5711 timeout_abs_ns vcpu_set_singleshot_timer 0 5711 NULL
+disable_so_timestamp_discovery_t_5725 timestamp discovery_t 0 5725 NULL nohasharray
+disable_so_uid_fuse_setattr_in_5725 uid fuse_setattr_in 0 5725 &disable_so_timestamp_discovery_t_5725 nohasharray
+disable_so_SYSC_setreuid_fndecl_5725 SYSC_setreuid fndecl 0 5725 &disable_so_uid_fuse_setattr_in_5725
+disable_so_r10_kvm_regs_5730 r10 kvm_regs 0 5730 NULL
+disable_so_bulk_in_epaddr_sur40_state_5741 bulk_in_epaddr sur40_state 0 5741 NULL
+disable_so_rt2x00lib_rxdone_read_signal_fndecl_5747 rt2x00lib_rxdone_read_signal fndecl 0 5747 NULL
+disable_so_ti_tscadc_driver_init_fndecl_5771 ti_tscadc_driver_init fndecl 0 5771 NULL
+disable_so_iowrite8_fndecl_5781 iowrite8 fndecl 1 5781 NULL
+disable_so_mthca_resize_cq_fndecl_5782 mthca_resize_cq fndecl 0 5782 NULL
+disable_so_lbs_host_sleep_write_fndecl_5783 lbs_host_sleep_write fndecl 0-3 5783 NULL
+disable_so_addr_tx_buf_desc_5787 addr tx_buf_desc 0 5787 NULL
+disable_so_tcn_timer_value___bridge_info_5789 tcn_timer_value __bridge_info 0 5789 NULL
+disable_so_old_jiffies_ati_remote_5798 old_jiffies ati_remote 0 5798 NULL
+disable_so_timeout_sched_poll_5810 timeout sched_poll 0 5810 NULL
+disable_so_addr_doit_fndecl_5813 addr_doit fndecl 0 5813 NULL
+disable_so_enic_dev_del_addr_fndecl_5814 enic_dev_del_addr fndecl 0 5814 NULL
+disable_so_start_addr_gen_pool_chunk_5822 start_addr gen_pool_chunk 0 5822 NULL
+disable_so_smsc75xx_enable_phy_wakeup_interrupts_fndecl_5824 smsc75xx_enable_phy_wakeup_interrupts fndecl 2-0 5824 NULL
+disable_so_ieee802154_hdr_peek_addrs_fndecl_5825 ieee802154_hdr_peek_addrs fndecl 0 5825 NULL
+disable_so_dsp_dram_offset_sst_addr_5830 dsp_dram_offset sst_addr 0 5830 NULL
+disable_so_mwifiex_read_reg_fndecl_5832 mwifiex_read_reg fndecl 2 5832 NULL
+disable_so_process_tgid_comm_proc_event_5834 process_tgid comm_proc_event 0 5834 NULL
+disable_so_idedisk_read_native_max_address_fndecl_5836 idedisk_read_native_max_address fndecl 0 5836 NULL
+disable_so_bus_time_fw_ohci_5838 bus_time fw_ohci 0 5838 NULL
+disable_so_demod_address_nxt6000_config_5841 demod_address nxt6000_config 0 5841 NULL
+disable_so_recover_timer_write_fndecl_5848 recover_timer_write fndecl 3-0 5848 NULL
+disable_so_next_jiffies_tick_sched_5856 next_jiffies tick_sched 0 5856 NULL
+disable_so_addr_asc_sg_list_5863 addr asc_sg_list 0 5863 NULL
+disable_so_schedule_delayed_work_fndecl_5873 schedule_delayed_work fndecl 2 5873 NULL
+disable_so_allow_utime_fat_mount_options_5877 allow_utime fat_mount_options 0 5877 NULL
+disable_so_irlap_start_query_timer_fndecl_5881 irlap_start_query_timer fndecl 3-2 5881 NULL
+disable_so_nent_kvm_cpuid2_5883 nent kvm_cpuid2 0 5883 NULL
+disable_so_delay_pcm_irq_snd_emu10k1_5885 delay_pcm_irq snd_emu10k1 0 5885 NULL
+disable_so_DAC1064_calcclock_fndecl_5888 DAC1064_calcclock fndecl 2-3 5888 NULL
+disable_so_ep_address_ath6kl_usb_pipe_5905 ep_address ath6kl_usb_pipe 0 5905 NULL nohasharray
+disable_so_set_bit_le_fndecl_5905 set_bit_le fndecl 1 5905 &disable_so_ep_address_ath6kl_usb_pipe_5905
+disable_so_last_force_reset_jiffies_il_force_reset_5911 last_force_reset_jiffies il_force_reset 0 5911 NULL
+disable_so_evclk_radeon_vce_clock_voltage_dependency_entry_5913 evclk radeon_vce_clock_voltage_dependency_entry 0 5913 NULL
+disable_so_status_address_card_5915 status_address card 0 5915 NULL
+disable_so_ifal_index_ifaddrlblmsg_5916 ifal_index ifaddrlblmsg 0 5916 NULL
+disable_so_validate_add_page_mtrr_ops_5922 validate_add_page mtrr_ops 1-2 5922 NULL
+disable_so_fm10k_ptp_adjtime_fndecl_5923 fm10k_ptp_adjtime fndecl 2 5923 NULL
+disable_so_addrtype_ip6addrlbl_entry_5927 addrtype ip6addrlbl_entry 0 5927 NULL
+disable_so_packet_life_time_ib_sa_path_rec_5929 packet_life_time ib_sa_path_rec 0 5929 NULL
+disable_so_open_time_local_info_5930 open_time local_info 0 5930 NULL
+disable_so_apply_time_iwl_time_event_cmd_5933 apply_time iwl_time_event_cmd 0 5933 NULL
+disable_so_default_address_sc520_par_table_5941 default_address sc520_par_table 0 5941 NULL
+disable_so_btrfs_hash_init_fndecl_5945 btrfs_hash_init fndecl 0 5945 NULL
+disable_so_tsc_khz_ref_vardecl_tsc_c_5951 tsc_khz_ref vardecl_tsc.c 0 5951 NULL
+disable_so_init_hrtimers_cpu_fndecl_5954 init_hrtimers_cpu fndecl 1 5954 NULL
+disable_so_dma_address_scatterlist_5955 dma_address scatterlist 0 5955 NULL
+disable_so_vsi_id_i40e_virtchnl_ether_addr_list_5963 vsi_id i40e_virtchnl_ether_addr_list 0 5963 NULL
+disable_so_i_mtime_sysv_inode_5967 i_mtime sysv_inode 0 5967 NULL
+disable_so_mult_clock_event_device_5973 mult clock_event_device 0 5973 NULL nohasharray
+disable_so_schedule_internal_copy_fndecl_5973 schedule_internal_copy fndecl 2-3-4 5973 &disable_so_mult_clock_event_device_5973
+disable_so_hash_netport6_expire_fndecl_5974 hash_netport6_expire fndecl 4 5974 NULL
+disable_so_tap_time_vardecl_mousedev_c_5990 tap_time vardecl_mousedev.c 0 5990 NULL
+disable_so_write_reg_fndecl_5992 write_reg fndecl 3 5992 NULL
+disable_so_clk_divider_round_rate_fndecl_6000 clk_divider_round_rate fndecl 2-0 6000 NULL
+disable_so_hor_sync_end_via_display_timing_6001 hor_sync_end via_display_timing 0 6001 NULL
+disable_so_xe_name_hash_ocfs2_xattr_entry_6006 xe_name_hash ocfs2_xattr_entry 0 6006 NULL
+disable_so_blkcipher_next_fast_fndecl_6013 blkcipher_next_fast fndecl 0 6013 NULL
+disable_so_gcm_dec_hash_continue_fndecl_6014 gcm_dec_hash_continue fndecl 0 6014 NULL
+disable_so_x_qxl_bitmap_6015 x qxl_bitmap 0 6015 NULL
+disable_so__rtl92s_phy_calculate_bit_shift_fndecl_6019 _rtl92s_phy_calculate_bit_shift fndecl 0-1 6019 NULL
+disable_so_snd_pcm_oss_get_odelay_fndecl_6033 snd_pcm_oss_get_odelay fndecl 0 6033 NULL
+disable_so_remote_addr_c2wr_qp_connect_req_6036 remote_addr c2wr_qp_connect_req 0 6036 NULL
+disable_so_set_time_rtc_class_ops_6037 set_time rtc_class_ops 0 6037 NULL
+disable_so_kvm_lapic_set_vapic_addr_fndecl_6040 kvm_lapic_set_vapic_addr fndecl 2 6040 NULL
+disable_so_netlink_hash_fndecl_6041 netlink_hash fndecl 0 6041 NULL
+disable_so_delay_edac_device_ctl_info_6043 delay edac_device_ctl_info 0 6043 NULL
+disable_so_hash_src_fndecl_6045 hash_src fndecl 0 6045 NULL
+disable_so_addrconf_add_ifaddr_fndecl_6046 addrconf_add_ifaddr fndecl 0 6046 NULL
+disable_so_abx500_get_register_interruptible_fndecl_6047 abx500_get_register_interruptible fndecl 0 6047 NULL
+disable_so_uac_clock_source_is_valid_fndecl_6049 uac_clock_source_is_valid fndecl 2 6049 NULL
+disable_so_max_keysize_crypto_report_cipher_6050 max_keysize crypto_report_cipher 0 6050 NULL
+disable_so_hit_timestamp_hh_flow_state_6053 hit_timestamp hh_flow_state 0 6053 NULL
+disable_so_crypto_fpu_setkey_fndecl_6067 crypto_fpu_setkey fndecl 0-3 6067 NULL
+disable_so_ticks_snd_timer_instance_6068 ticks snd_timer_instance 0 6068 NULL nohasharray
+disable_so_dev_mem_address_mlx4_cable_info_6068 dev_mem_address mlx4_cable_info 0 6068 &disable_so_ticks_snd_timer_instance_6068
+disable_so_start_time_ieee80211_measurement_params_6073 start_time ieee80211_measurement_params 0 6073 NULL
+disable_so_i_ino_timelimit_qc_info_6082 i_ino_timelimit qc_info 0 6082 NULL
+disable_so_sll_ifindex_sockaddr_ll_6083 sll_ifindex sockaddr_ll 0 6083 NULL
+disable_so_sleep_auth_read_fndecl_6084 sleep_auth_read fndecl 3-0 6084 NULL
+disable_so_btrfs_run_delayed_refs_fndecl_6098 btrfs_run_delayed_refs fndecl 0 6098 NULL
+disable_so_blocksize_crypto_report_aead_6103 blocksize crypto_report_aead 0 6103 NULL
+disable_so_periods_snd_pcm_runtime_6104 periods snd_pcm_runtime 0 6104 NULL
+disable_so_wait_for_completion_io_timeout_fndecl_6120 wait_for_completion_io_timeout fndecl 2-0 6120 NULL
+disable_so_rsi_cmd52readbyte_fndecl_6123 rsi_cmd52readbyte fndecl 0-2 6123 NULL
+disable_so_jiffies_io_6127 jiffies io 0 6127 NULL
+disable_so_ac97_clock_vardecl_atiixp_c_6132 ac97_clock vardecl_atiixp.c 0 6132 NULL
+disable_so_vmap_block_vaddr_fndecl_6152 vmap_block_vaddr fndecl 1-2 6152 NULL
+disable_so_depth_blk_mq_bitmap_tags_6153 depth blk_mq_bitmap_tags 0 6153 NULL
+disable_so_mul_vnic_intr_coal_timer_info_6154 mul vnic_intr_coal_timer_info 0 6154 NULL
+disable_so_ctrl_freq_au0828_dev_6155 ctrl_freq au0828_dev 0 6155 NULL
+disable_so_hrtimer_get_res_fndecl_6170 hrtimer_get_res fndecl 1 6170 NULL
+disable_so_nlm_hash_address_fndecl_6174 nlm_hash_address fndecl 0 6174 NULL
+disable_so_vaddr_vfio_iommu_type1_dma_map_6175 vaddr vfio_iommu_type1_dma_map 0 6175 NULL
+disable_so_cpuidle_register_device_fndecl_6179 cpuidle_register_device fndecl 0 6179 NULL
+disable_so_wl18xx_set_host_cfg_bitmap_fndecl_6180 wl18xx_set_host_cfg_bitmap fndecl 0 6180 NULL
+disable_so_daddr_ircomm_tty_cb_6187 daddr ircomm_tty_cb 0 6187 NULL
+disable_so_address_iio_chan_spec_6188 address iio_chan_spec 0 6188 NULL
+disable_so_gem_interrupt_fndecl_6193 gem_interrupt fndecl 1 6193 NULL
+disable_so_test_steal_space_from_bitmap_to_extent_fndecl_6197 test_steal_space_from_bitmap_to_extent fndecl 0 6197 NULL
+disable_so_write8_async_rtl_io_6212 write8_async rtl_io 2-3 6212 NULL
+disable_so_gpio_request_fndecl_6213 gpio_request fndecl 0-1 6213 NULL
+disable_so_max_cmds_mthca_cmd_6222 max_cmds mthca_cmd 0 6222 NULL
+disable_so_rhashtable_rehash_one_fndecl_6224 rhashtable_rehash_one fndecl 2 6224 NULL
+disable_so_addr_hi_sli4_sge_6229 addr_hi sli4_sge 0 6229 NULL
+disable_so_bnx2x_set_iscsi_eth_mac_addr_fndecl_6234 bnx2x_set_iscsi_eth_mac_addr fndecl 0 6234 NULL
+disable_so___ipv6_addr_label_fndecl_6235 __ipv6_addr_label fndecl 3-4 6235 NULL
+disable_so_chnl_freq_wil6210_rtap_6236 chnl_freq wil6210_rtap 0 6236 NULL
+disable_so_mv88e6xxx_port_to_phy_addr_fndecl_6239 mv88e6xxx_port_to_phy_addr fndecl 0-2 6239 NULL
+disable_so_phy_pm_runtime_get_sync_fndecl_6245 phy_pm_runtime_get_sync fndecl 0 6245 NULL
+disable_so_kempld_wdt_set_pretimeout_fndecl_6258 kempld_wdt_set_pretimeout fndecl 2 6258 NULL
+disable_so_sq_page_table_addr_lo_iscsi_kwqe_conn_offload1_6259 sq_page_table_addr_lo iscsi_kwqe_conn_offload1 0 6259 NULL
+disable_so_async_chainiv_schedule_work_fndecl_6271 async_chainiv_schedule_work fndecl 0 6271 NULL
+disable_so_bus_clock_khz_ocores_i2c_6290 bus_clock_khz ocores_i2c 0 6290 NULL
+disable_so_cttimeout_default_get_fndecl_6297 cttimeout_default_get fndecl 0 6297 NULL
+disable_so_show_pci_clock_sel_fndecl_6300 show_pci_clock_sel fndecl 0 6300 NULL nohasharray
+disable_so_addr_w83627ehf_data_6300 addr w83627ehf_data 0 6300 &disable_so_show_pci_clock_sel_fndecl_6300
+disable_so_base_addr_pmc_dev_6305 base_addr pmc_dev 0 6305 NULL
+disable_so_max_post_div_radeon_pll_6315 max_post_div radeon_pll 0 6315 NULL
+disable_so_mmc_sd_erase_timeout_fndecl_6317 mmc_sd_erase_timeout fndecl 0-3 6317 NULL
+disable_so_get_time_sound_timer_operations_6318 get_time sound_timer_operations 0 6318 NULL
+disable_so_runtime_reg_sch311x_pdev_data_6324 runtime_reg sch311x_pdev_data 0 6324 NULL
+disable_so_hscx_interrupt_fndecl_6328 hscx_interrupt fndecl 2 6328 NULL
+disable_so_hangcheck_margin_vardecl_hangcheck_timer_c_6346 hangcheck_margin vardecl_hangcheck-timer.c 0 6346 NULL nohasharray
+disable_so___hrtimer_start_range_ns_fndecl_6346 __hrtimer_start_range_ns fndecl 3 6346 &disable_so_hangcheck_margin_vardecl_hangcheck_timer_c_6346
+disable_so_force_addr_vardecl_i2c_ali15x3_c_6378 force_addr vardecl_i2c-ali15x3.c 0 6378 NULL
+disable_so_usb_interrupt_msg_fndecl_6387 usb_interrupt_msg fndecl 4-2-6-0 6387 NULL
+disable_so_bitmap_file_test_bit_fndecl_6390 bitmap_file_test_bit fndecl 2 6390 NULL
+disable_so_access_delay_vardecl_nandsim_c_6394 access_delay vardecl_nandsim.c 0 6394 NULL
+disable_so_snd_ice1712_interrupt_fndecl_6396 snd_ice1712_interrupt fndecl 1 6396 NULL
+disable_so_i2c_addr_isl6421_6399 i2c_addr isl6421 0 6399 NULL
+disable_so_sta_connected_time_read_fndecl_6408 sta_connected_time_read fndecl 3 6408 NULL
+disable_so_dbg_uidn_show_fndecl_6415 dbg_uidn_show fndecl 3 6415 NULL
+disable_so_timeout_fib6_gc_args_6417 timeout fib6_gc_args 0 6417 NULL
+disable_so_max_pixelclock_v4l2_bt_timings_cap_6421 max_pixelclock v4l2_bt_timings_cap 0 6421 NULL nohasharray
+disable_so_vlv_clock_fndecl_6421 vlv_clock fndecl 1 6421 &disable_so_max_pixelclock_v4l2_bt_timings_cap_6421
+disable_so_hold_timer_value___port_info_6426 hold_timer_value __port_info 0 6426 NULL
+disable_so_plllocktime_psb_s_6428 plllocktime psb_s 0 6428 NULL nohasharray
+disable_so_channel2freq_lp_fndecl_6428 channel2freq_lp fndecl 0-1 6428 &disable_so_plllocktime_psb_s_6428
+disable_so_base_addr_fpoint_info_6432 base_addr fpoint_info 0 6432 NULL
+disable_so_paravirt_write_msr_fndecl_6445 paravirt_write_msr fndecl 0-1-2-3 6445 NULL
+disable_so_bnx2x_eee_nvram_to_time_fndecl_6450 bnx2x_eee_nvram_to_time fndecl 1 6450 NULL
+disable_so_dn_nl_deladdr_fndecl_6451 dn_nl_deladdr fndecl 0 6451 NULL
+disable_so_mpll_ss_rv730_clock_registers_6456 mpll_ss rv730_clock_registers 0 6456 NULL nohasharray
+disable_so_buffer_addr_atl1e_tpd_desc_6456 buffer_addr atl1e_tpd_desc 0 6456 &disable_so_mpll_ss_rv730_clock_registers_6456
+disable_so_xfs_btree_lshift_fndecl_6459 xfs_btree_lshift fndecl 0 6459 NULL
+disable_so_tomoyo_check_unix_address_fndecl_6464 tomoyo_check_unix_address fndecl 0-2 6464 NULL
+disable_so_bitmap_pos_to_ord_fndecl_6476 bitmap_pos_to_ord fndecl 3-2 6476 NULL
+disable_so_bql_set_hold_time_fndecl_6478 bql_set_hold_time fndecl 0-4 6478 NULL
+disable_so_range_shift_fixed_mtrr_segment_6484 range_shift fixed_mtrr_segment 0 6484 NULL
+disable_so___clocksource_update_freq_scale_fndecl_6485 __clocksource_update_freq_scale fndecl 2-3 6485 NULL
+disable_so_freq_pmu1_plltab_entry_6497 freq pmu1_plltab_entry 0 6497 NULL
+disable_so___btrfs_abort_transaction_fndecl_6516 __btrfs_abort_transaction fndecl 5 6516 NULL
+disable_so_timeout_clks_mmc_data_6527 timeout_clks mmc_data 0 6527 NULL
+disable_so_set_tss_addr_kvm_x86_ops_6529 set_tss_addr kvm_x86_ops 2 6529 NULL
+disable_so_acpi_device_sleep_wake_fndecl_6537 acpi_device_sleep_wake fndecl 0-2-3 6537 NULL nohasharray
+disable_so_rtsc_x2y_fndecl_6537 rtsc_x2y fndecl 0-2 6537 &disable_so_acpi_device_sleep_wake_fndecl_6537
+disable_so_msr_saved_flags_uart_8250_port_6538 msr_saved_flags uart_8250_port 0 6538 NULL
+disable_so_next_blk_mq_timeout_data_6556 next blk_mq_timeout_data 0 6556 NULL nohasharray
+disable_so_sumo_set_uvd_clocks_fndecl_6556 sumo_set_uvd_clocks fndecl 2-3-0 6556 &disable_so_next_blk_mq_timeout_data_6556
+disable_so_ovs_flow_used_time_fndecl_6571 ovs_flow_used_time fndecl 1-0 6571 NULL
+disable_so_orinoco_ioctl_setfreq_fndecl_6577 orinoco_ioctl_setfreq fndecl 0 6577 NULL
+disable_so_hash_netport4_expire_fndecl_6582 hash_netport4_expire fndecl 4 6582 NULL
+disable_so_rpwwn_bfa_bsg_rport_scsi_addr_s_6584 rpwwn bfa_bsg_rport_scsi_addr_s 0 6584 NULL
+disable_so_gid_ncp_mount_data_v4_6586 gid ncp_mount_data_v4 0 6586 NULL
+disable_so_set_input_clock_fndecl_6599 set_input_clock fndecl 0 6599 NULL
+disable_so_mmap_bytes_snd_pcm_oss_runtime_6600 mmap_bytes snd_pcm_oss_runtime 0 6600 NULL
+disable_so_do_sys_settimeofday_fndecl_6601 do_sys_settimeofday fndecl 0 6601 NULL
+disable_so_tv_sec_ufs_timeval_6608 tv_sec ufs_timeval 0 6608 NULL
+disable_so_tk_debug_sleep_time_open_fndecl_6625 tk_debug_sleep_time_open fndecl 0 6625 NULL
+disable_so_bmg160_convert_freq_to_bit_fndecl_6628 bmg160_convert_freq_to_bit fndecl 0 6628 NULL
+disable_so_sis_ata133_program_timings_fndecl_6633 sis_ata133_program_timings fndecl 2 6633 NULL
+disable_so_timestamp_nvkm_alarm_6635 timestamp nvkm_alarm 0 6635 NULL nohasharray
+disable_so_offset_crypto_hash_walk_6635 offset crypto_hash_walk 0 6635 &disable_so_timestamp_nvkm_alarm_6635
+disable_so_ocfs2_rotate_subtree_left_fndecl_6641 ocfs2_rotate_subtree_left fndecl 0-5 6641 NULL
+disable_so_vactive_lo_detailed_pixel_timing_6644 vactive_lo detailed_pixel_timing 0 6644 NULL
+disable_so_givencrypt_ablkcipher_tfm_6647 givencrypt ablkcipher_tfm 0 6647 NULL
+disable_so_fill_in_real_sgid_index_fndecl_6648 fill_in_real_sgid_index fndecl 2-3 6648 NULL
+disable_so_i_gid_read_fndecl_6650 i_gid_read fndecl 0 6650 NULL
+disable_so_uniq_time_smt_values_6653 uniq_time smt_values 0 6653 NULL nohasharray
+disable_so_missvaddr_gru_tlb_fault_handle_6653 missvaddr gru_tlb_fault_handle 0 6653 &disable_so_uniq_time_smt_values_6653
+disable_so_rq_timeout_request_queue_6657 rq_timeout request_queue 0 6657 NULL
+disable_so_resp_bd_list_addr_hi_bnx2i_login_request_6658 resp_bd_list_addr_hi bnx2i_login_request 0 6658 NULL
+disable_so_ebp_tss_segment_32_6659 ebp tss_segment_32 0 6659 NULL
+disable_so_sha_complete_job_fndecl_6679 sha_complete_job fndecl 3 6679 NULL
+disable_so_cursor_vram_addr_viafb_shared_6684 cursor_vram_addr viafb_shared 0 6684 NULL
+disable_so_si_set_smc_sram_address_fndecl_6696 si_set_smc_sram_address fndecl 0-2 6696 NULL
+disable_so_ocfs2_divide_leaf_refcount_block_fndecl_6709 ocfs2_divide_leaf_refcount_block fndecl 0 6709 NULL
+disable_so_smp_base_set_mtrr_data_6722 smp_base set_mtrr_data 0 6722 NULL
+disable_so_titsc_parse_dt_fndecl_6744 titsc_parse_dt fndecl 0 6744 NULL
+disable_so_driver_timestamp_netxen_minidump_template_hdr_6745 driver_timestamp netxen_minidump_template_hdr 0 6745 NULL
+disable_so_end_address_dmar_rmrr_unit_6748 end_address dmar_rmrr_unit 0 6748 NULL
+disable_so_std_signal_mode_vivid_dev_6752 std_signal_mode vivid_dev 0 6752 NULL
+disable_so_part_timeout_show_fndecl_6761 part_timeout_show fndecl 0 6761 NULL
+disable_so_tx_coal_timer_stmmac_priv_6772 tx_coal_timer stmmac_priv 0 6772 NULL
+disable_so_kvm_clock_read_fndecl_6779 kvm_clock_read fndecl 0 6779 NULL
+disable_so_alarm_clock_get_fndecl_6780 alarm_clock_get fndecl 1 6780 NULL
+disable_so_rcar_i2c_clock_calculate_fndecl_6789 rcar_i2c_clock_calculate fndecl 0 6789 NULL
+disable_so_timeout_vardecl_sbc60xxwdt_c_6807 timeout vardecl_sbc60xxwdt.c 0 6807 NULL
+disable_so_rp_uid_ubifs_sb_node_6810 rp_uid ubifs_sb_node 0 6810 NULL
+disable_so_wm8940_set_dai_clkdiv_fndecl_6811 wm8940_set_dai_clkdiv fndecl 3-0 6811 NULL
+disable_so_shift_clk_divider_6812 shift clk_divider 0 6812 NULL nohasharray
+disable_so_gateway_addr_addr_wil_fw_record_gateway_data_6812 gateway_addr_addr wil_fw_record_gateway_data 0 6812 &disable_so_shift_clk_divider_6812 nohasharray
+disable_so_snd_bebob_stream_get_clock_src_fndecl_6812 snd_bebob_stream_get_clock_src fndecl 0 6812 &disable_so_gateway_addr_addr_wil_fw_record_gateway_data_6812
+disable_so_io_profile_start_time_bfa_fcpim_s_6814 io_profile_start_time bfa_fcpim_s 0 6814 NULL
+disable_so_tsc_timestamp_pvclock_vcpu_time_info_6819 tsc_timestamp pvclock_vcpu_time_info 0 6819 NULL
+disable_so_paddr_ath10k_skb_rxcb_6820 paddr ath10k_skb_rxcb 0 6820 NULL
+disable_so_src_addr_ioat_dma_descriptor_6823 src_addr ioat_dma_descriptor 0 6823 NULL
+disable_so_ivsize_ablkcipher_tfm_6824 ivsize ablkcipher_tfm 0 6824 NULL
+disable_so_p_val_aic32x4_rate_divs_6838 p_val aic32x4_rate_divs 0 6838 NULL nohasharray
+disable_so_bit_putcs_unaligned_fndecl_6838 bit_putcs_unaligned fndecl 5-6-7-8 6838 &disable_so_p_val_aic32x4_rate_divs_6838
+disable_so_iaddr2blockno_fndecl_6842 iaddr2blockno fndecl 0 6842 NULL nohasharray
+disable_so_reserved_top_mlx4_bitmap_6842 reserved_top mlx4_bitmap 0 6842 &disable_so_iaddr2blockno_fndecl_6842
+disable_so_address_acpi_object_processor_6844 address acpi_object_processor 0 6844 NULL nohasharray
+disable_so_top_freq_region_info_6844 top_freq region_info 0 6844 &disable_so_address_acpi_object_processor_6844
+disable_so_phys_addr_sge_txq_6851 phys_addr sge_txq 0 6851 NULL
+disable_so_irq_find_mapping_fndecl_6855 irq_find_mapping fndecl 0-2 6855 NULL
+disable_so_ipaddr_rds_ib_ipaddr_6865 ipaddr rds_ib_ipaddr 0 6865 NULL
+disable_so_cdv_intel_clock_recovery_ok_fndecl_6866 cdv_intel_clock_recovery_ok fndecl 2 6866 NULL
+disable_so_rmw_ath_ops_6869 rmw ath_ops 2-3-4 6869 NULL
+disable_so_last_jiffies_ivtv_api_cache_6880 last_jiffies ivtv_api_cache 0 6880 NULL
+disable_so_ui_atimensec_ufs2_inode_6881 ui_atimensec ufs2_inode 0 6881 NULL
+disable_so_gether_get_host_addr_cdc_fndecl_6888 gether_get_host_addr_cdc fndecl 0 6888 NULL
+disable_so_wmi_add_cipher_key_fndecl_6891 wmi_add_cipher_key fndecl 0-2-4 6891 NULL
+disable_so_ppp_gidle_fndecl_6898 ppp_gidle fndecl 0-1 6898 NULL
+disable_so_dialtimeout_isdn_net_local_s_6908 dialtimeout isdn_net_local_s 0 6908 NULL
+disable_so_conf_printf2_fndecl_6910 conf_printf2 fndecl 2-4-5 6910 NULL
+disable_so_pilot_stv0900_signal_info_6915 pilot stv0900_signal_info 0 6915 NULL
+disable_so_size_log2_t3_wq_6928 size_log2 t3_wq 0 6928 NULL
+disable_so_s35390a_set_datetime_fndecl_6935 s35390a_set_datetime fndecl 0 6935 NULL
+disable_so_sys_setfsgid_fndecl_6945 sys_setfsgid fndecl 0-1 6945 NULL
+disable_so_triflex_load_timing_fndecl_6946 triflex_load_timing fndecl 3 6946 NULL
+disable_so_ps2mult_interrupt_fndecl_6951 ps2mult_interrupt fndecl 2 6951 NULL
+disable_so_hpi_sample_clock_query_source_fndecl_6959 hpi_sample_clock_query_source fndecl 1-0 6959 NULL
+disable_so_tseg2_max_can_bittiming_const_6963 tseg2_max can_bittiming_const 0 6963 NULL
+disable_so_rec8b_ata_timing_6977 rec8b ata_timing 0 6977 NULL
+disable_so_vactive___fb_timings_6978 vactive __fb_timings 0 6978 NULL
+disable_so_mgid_index_mlx4_qp_path_6990 mgid_index mlx4_qp_path 0 6990 NULL
+disable_so_log_start_addr_server_hdr_7000 log_start_addr server_hdr 0 7000 NULL
+disable_so_t2timer_ax25_info_struct_7019 t2timer ax25_info_struct 0 7019 NULL
+disable_so_start_address_mxt_object_7033 start_address mxt_object 0 7033 NULL
+disable_so_cpufreq_add_dev_symlink_fndecl_7039 cpufreq_add_dev_symlink fndecl 0 7039 NULL
+disable_so_fm10k_systime_read_fndecl_7040 fm10k_systime_read fndecl 0 7040 NULL
+disable_so_dv_timings_signal_mode_vivid_dev_7046 dv_timings_signal_mode vivid_dev 0 7046 NULL
+disable_so_set_expect_timeout_fndecl_7051 set_expect_timeout fndecl 2 7051 NULL
+disable_so_ts_dev_2_peak_time_ref_7055 ts_dev_2 peak_time_ref 0 7055 NULL
+disable_so_pci_lat_timer_tg3_7056 pci_lat_timer tg3 0 7056 NULL
+disable_so_ioarcb_bus_addr_pmcraid_ioarcb_7057 ioarcb_bus_addr pmcraid_ioarcb 0 7057 NULL
+disable_so_tbl_addr_ahci_cmd_hdr_7060 tbl_addr ahci_cmd_hdr 0 7060 NULL
+disable_so_total_i915_address_space_7088 total i915_address_space 0 7088 NULL
+disable_so_nfs_mountpoint_expiry_timeout_vardecl_7089 nfs_mountpoint_expiry_timeout vardecl 0 7089 NULL
+disable_so_rx_control_addr_acx_data_path_params_resp_7090 rx_control_addr acx_data_path_params_resp 0 7090 NULL
+disable_so_qs_btimelimit_fs_quota_stat_7091 qs_btimelimit fs_quota_stat 0 7091 NULL
+disable_so_SYSC_semtimedop_fndecl_7096 SYSC_semtimedop fndecl 1-3 7096 NULL
+disable_so_lm8323_pwm_show_time_fndecl_7100 lm8323_pwm_show_time fndecl 0 7100 NULL
+disable_so_start_time_btrfs_transaction_7107 start_time btrfs_transaction 0 7107 NULL
+disable_so_dma_bytes_snd_pcm_runtime_7108 dma_bytes snd_pcm_runtime 0 7108 NULL
+disable_so_sr__coeff_div_7109 sr _coeff_div 0 7109 NULL
+disable_so_assert_pio_clocks_7119 assert pio_clocks 0 7119 NULL
+disable_so_sctp_bind_addr_copy_fndecl_7122 sctp_bind_addr_copy fndecl 0-5 7122 NULL
+disable_so_irq_domain_get_irq_data_fndecl_7132 irq_domain_get_irq_data fndecl 2 7132 NULL
+disable_so_cur_freq_intel_gen6_power_mgmt_7134 cur_freq intel_gen6_power_mgmt 0 7134 NULL nohasharray
+disable_so_address_mask_fndecl_7134 address_mask fndecl 0-2 7134 &disable_so_cur_freq_intel_gen6_power_mgmt_7134
+disable_so_timeout_md_thread_7138 timeout md_thread 0 7138 NULL
+disable_so_nicvf_register_interrupts_fndecl_7143 nicvf_register_interrupts fndecl 0 7143 NULL
+disable_so_logical_drive_info_dma_addr_ips_ha_7146 logical_drive_info_dma_addr ips_ha 0 7146 NULL
+disable_so_ai_slowclk_freq_fndecl_7147 ai_slowclk_freq fndecl 0 7147 NULL
+disable_so_addr_play_vals_7151 addr play_vals 0 7151 NULL
+disable_so_enc_addr_low_ssp_ini_io_start_req_7153 enc_addr_low ssp_ini_io_start_req 0 7153 NULL
+disable_so_dev_sockaddr_mISDN_7154 dev sockaddr_mISDN 0 7154 NULL
+disable_so_scan_start_time_ath_ant_comb_7155 scan_start_time ath_ant_comb 0 7155 NULL nohasharray
+disable_so_mcryptd_hash_final_fndecl_7155 mcryptd_hash_final fndecl 2 7155 &disable_so_scan_start_time_ath_ant_comb_7155
+disable_so_ack_time_minstrel_rate_7156 ack_time minstrel_rate 0 7156 NULL
+disable_so_start_time_fscache_retrieval_7166 start_time fscache_retrieval 0 7166 NULL
+disable_so_timetosend_nes_timer_entry_7169 timetosend nes_timer_entry 0 7169 NULL
+disable_so_autofs4_get_set_timeout_fndecl_7185 autofs4_get_set_timeout fndecl 0 7185 NULL
+disable_so_list_voltage_regulator_ops_7194 list_voltage regulator_ops 0-2 7194 NULL
+disable_so_round_jiffies_fndecl_7204 round_jiffies fndecl 0-1 7204 NULL nohasharray
+disable_so_address_lo_be_bus_address32_7204 address_lo be_bus_address32 0 7204 &disable_so_round_jiffies_fndecl_7204
+disable_so_efx_recycle_rx_pages_fndecl_7206 efx_recycle_rx_pages fndecl 3 7206 NULL
+disable_so_ssb_chipco_watchdog_timer_set_fndecl_7210 ssb_chipco_watchdog_timer_set fndecl 2-0 7210 NULL
+disable_so_ebitmap_netlbl_export_fndecl_7212 ebitmap_netlbl_export fndecl 0 7212 NULL
+disable_so_charge_timeout_wm8350_charger_policy_7222 charge_timeout wm8350_charger_policy 0 7222 NULL
+disable_so_tf_c_r820t_freq_range_7225 tf_c r820t_freq_range 0 7225 NULL
+disable_so_hpi_read_words_le16_fndecl_7226 hpi_read_words_le16 fndecl 2-4 7226 NULL
+disable_so_ip6addrlbl_newdel_fndecl_7230 ip6addrlbl_newdel fndecl 0 7230 NULL
+disable_so_seq_default_timer_card_vardecl_7233 seq_default_timer_card vardecl 0 7233 NULL
+disable_so_ip6_route_get_saddr_fndecl_7240 ip6_route_get_saddr fndecl 0 7240 NULL
+disable_so_packet_timeout_vardecl_legousbtower_c_7247 packet_timeout vardecl_legousbtower.c 0 7247 NULL
+disable_so_base_clockid_alarm_base_7253 base_clockid alarm_base 0 7253 NULL
+disable_so_pll_time_modem_state_ser12_7269 pll_time modem_state_ser12 0 7269 NULL
+disable_so_phyaddr_fe_priv_7272 phyaddr fe_priv 0 7272 NULL
+disable_so_xfs_btree_copy_keys_fndecl_7274 xfs_btree_copy_keys fndecl 4 7274 NULL
+disable_so_lzo_uncompress_fndecl_7276 lzo_uncompress fndecl 6 7276 NULL
+disable_so_spc_assoc_id_sctp_paddr_change_7283 spc_assoc_id sctp_paddr_change 0 7283 NULL
+disable_so_min_interrupt_out_interval_vardecl_ldusb_c_7293 min_interrupt_out_interval vardecl_ldusb.c 0 7293 NULL
+disable_so_phys_addr_qlcnic_host_rds_ring_7298 phys_addr qlcnic_host_rds_ring 0 7298 NULL
+disable_so_ethoc_interrupt_fndecl_7299 ethoc_interrupt fndecl 1 7299 NULL
+disable_so_wintime_si_dyn_powertune_data_7305 wintime si_dyn_powertune_data 0 7305 NULL
+disable_so_timestamp_cnic_context_7309 timestamp cnic_context 0 7309 NULL nohasharray
+disable_so_rx8025_set_clock_adjust_fndecl_7309 rx8025_set_clock_adjust fndecl 2-0 7309 &disable_so_timestamp_cnic_context_7309
+disable_so_read_mac_address_dvb_usb_device_properties_7321 read_mac_address dvb_usb_device_properties 0 7321 NULL
+disable_so_pm_runtime_set_active_fndecl_7330 pm_runtime_set_active fndecl 0 7330 NULL
+disable_so_snd_seq_oss_synth_addr_fndecl_7331 snd_seq_oss_synth_addr fndecl 0 7331 NULL
+disable_so_netlbl_unlabel_addrinfo_get_fndecl_7332 netlbl_unlabel_addrinfo_get fndecl 0 7332 NULL nohasharray
+disable_so_transport_type_sockaddr_rxrpc_7332 transport_type sockaddr_rxrpc 0 7332 &disable_so_netlbl_unlabel_addrinfo_get_fndecl_7332
+disable_so_tx_control_addr_acx_data_path_params_resp_7345 tx_control_addr acx_data_path_params_resp 0 7345 NULL
+disable_so_intel_runtime_suspend_fndecl_7354 intel_runtime_suspend fndecl 0 7354 NULL nohasharray
+disable_so_arb_timeout_pca9541_7354 arb_timeout pca9541 0 7354 &disable_so_intel_runtime_suspend_fndecl_7354
+disable_so_authenc_esn_geniv_ahash_done_fndecl_7357 authenc_esn_geniv_ahash_done fndecl 2 7357 NULL
+disable_so_total_blkcipher_walk_7358 total blkcipher_walk 0 7358 NULL
+disable_so_mtime_fuse_attr_7361 mtime fuse_attr 0 7361 NULL
+disable_so_gtt_phys_addr__intel_private_7365 gtt_phys_addr _intel_private 0 7365 NULL
+disable_so_btree_lookup_raw_fndecl_7367 btree_lookup_raw fndecl 0-2-7 7367 NULL
+disable_so_show_imon_clock_fndecl_7376 show_imon_clock fndecl 0 7376 NULL
+disable_so_acpi_cpufreq_guess_freq_fndecl_7383 acpi_cpufreq_guess_freq fndecl 0 7383 NULL
+disable_so_pch_udc_ep_bit_set_fndecl_7386 pch_udc_ep_bit_set fndecl 3 7386 NULL
+disable_so_tv_nsec_compat_timespec_7389 tv_nsec compat_timespec 0 7389 NULL
+disable_so_try_msr_calibrate_tsc_fndecl_7392 try_msr_calibrate_tsc fndecl 0 7392 NULL
+disable_so_msi001_s_frequency_fndecl_7396 msi001_s_frequency fndecl 0 7396 NULL
+disable_so_lxt971_ack_interrupt_fndecl_7397 lxt971_ack_interrupt fndecl 0 7397 NULL nohasharray
+disable_so_i40e_get_mac_addr_fndecl_7397 i40e_get_mac_addr fndecl 0 7397 &disable_so_lxt971_ack_interrupt_fndecl_7397
+disable_so_conn_db_addr_lo_fcoe_kwqe_conn_offload2_7408 conn_db_addr_lo fcoe_kwqe_conn_offload2 0 7408 NULL
+disable_so_spcp8x5_get_msr_fndecl_7409 spcp8x5_get_msr fndecl 0 7409 NULL
+disable_so_signal_det_fndecl_7411 signal_det fndecl 2 7411 NULL
+disable_so_vclk_fb_div_pll_ct_7423 vclk_fb_div pll_ct 0 7423 NULL
+disable_so_crypto_ahash_final_fndecl_7433 crypto_ahash_final fndecl 0 7433 NULL
+disable_so_vidioc_s_hw_freq_seek_fndecl_7439 vidioc_s_hw_freq_seek fndecl 0 7439 NULL
+disable_so_aa_calc_profile_hash_fndecl_7443 aa_calc_profile_hash fndecl 0-4 7443 NULL
+disable_so_count_sha1_state_7456 count sha1_state 0 7456 NULL
+disable_so_full_name_hash_fndecl_7466 full_name_hash fndecl 0-2 7466 NULL
+disable_so_serial8250_set_divisor_fndecl_7469 serial8250_set_divisor fndecl 4-3 7469 NULL
+disable_so_add_hwgenerator_randomness_fndecl_7471 add_hwgenerator_randomness fndecl 2-3 7471 NULL
+disable_so_xfs_btree_check_block_fndecl_7472 xfs_btree_check_block fndecl 0 7472 NULL
+disable_so_f1x_get_norm_dct_addr_fndecl_7473 f1x_get_norm_dct_addr fndecl 0-3-5 7473 NULL
+disable_so_timeout_tid_ampdu_rx_7484 timeout tid_ampdu_rx 0 7484 NULL
+disable_so_uv_rtc_find_next_timer_fndecl_7494 uv_rtc_find_next_timer fndecl 2 7494 NULL
+disable_so_mmc_erase_timeout_fndecl_7496 mmc_erase_timeout fndecl 0-3-2 7496 NULL
+disable_so_interrupt_in_endpoint_edgeport_serial_7513 interrupt_in_endpoint edgeport_serial 0 7513 NULL
+disable_so_start_asd_ha_addrspace_7515 start asd_ha_addrspace 0 7515 NULL
+disable_so_ccp_register_aes_alg_fndecl_7517 ccp_register_aes_alg fndecl 0 7517 NULL
+disable_so_addr_ptr_drm_i915_gem_mmap_7520 addr_ptr drm_i915_gem_mmap 0 7520 NULL
+disable_so_ecryptfs_get_tfm_and_mutex_for_cipher_name_fndecl_7524 ecryptfs_get_tfm_and_mutex_for_cipher_name fndecl 0 7524 NULL
+disable_so_async_schedule_fndecl_7528 async_schedule fndecl 0 7528 NULL nohasharray
+disable_so_crypto_ctr_crypt_inplace_fndecl_7528 crypto_ctr_crypt_inplace fndecl 0 7528 &disable_so_async_schedule_fndecl_7528
+disable_so_snd_mpu401_uart_interrupt_fndecl_7536 snd_mpu401_uart_interrupt fndecl 1 7536 NULL
+disable_so_cfg_max_scsicmpl_time_lpfc_vport_7541 cfg_max_scsicmpl_time lpfc_vport 0 7541 NULL
+disable_so_blkcipher_done_slow_fndecl_7555 blkcipher_done_slow fndecl 0-2 7555 NULL
+disable_so_cg_spll_spread_spectrum_si_clock_registers_7557 cg_spll_spread_spectrum si_clock_registers 0 7557 NULL
+disable_so_dev_addr_mv_udc_7559 dev_addr mv_udc 0 7559 NULL
+disable_so___restart_timer_fndecl_7572 __restart_timer fndecl 2 7572 NULL
+disable_so_phy_interrupt_fndecl_7576 phy_interrupt fndecl 1 7576 NULL
+disable_so_pending_auth_reply_time_wl12xx_vif_7583 pending_auth_reply_time wl12xx_vif 0 7583 NULL
+disable_so_kempld_wdt_set_stage_timeout_fndecl_7592 kempld_wdt_set_stage_timeout fndecl 3 7592 NULL
+disable_so_mwifiex_ret_802_11_mac_address_fndecl_7598 mwifiex_ret_802_11_mac_address fndecl 0 7598 NULL
+disable_so_ad799x_write_frequency_fndecl_7606 ad799x_write_frequency fndecl 0-4 7606 NULL
+disable_so_htab_map_hash_fndecl_7622 htab_map_hash fndecl 0-2 7622 NULL
+disable_so_smack_task_getscheduler_fndecl_7629 smack_task_getscheduler fndecl 0 7629 NULL
+disable_so_atomic64_sub_fndecl_7638 atomic64_sub fndecl 1 7638 NULL
+disable_so___mcheck_cpu_cap_init_fndecl_7640 __mcheck_cpu_cap_init fndecl 0 7640 NULL
+disable_so_sq_dma_addr_nvme_queue_7641 sq_dma_addr nvme_queue 0 7641 NULL
+disable_so_data_address_mscp_7645 data_address mscp 0 7645 NULL
+disable_so_block_address_ms_param_register_7651 block_address ms_param_register 0 7651 NULL
+disable_so___wait_on_bit_lock_fndecl_7653 __wait_on_bit_lock fndecl 0 7653 NULL
+disable_so_dma_addr_qla2_sgx_7667 dma_addr qla2_sgx 0 7667 NULL
+disable_so_ba1_addr_cs4281_7670 ba1_addr cs4281 0 7670 NULL
+disable_so_addr_nv50_disp_mthd_list_7671 addr nv50_disp_mthd_list 0 7671 NULL
+disable_so_address_stv090x_config_7672 address stv090x_config 0 7672 NULL
+disable_so_addr_oxygen_7675 addr oxygen 0 7675 NULL
+disable_so_mei_wd_ops_set_timeout_fndecl_7696 mei_wd_ops_set_timeout fndecl 2 7696 NULL
+disable_so_clock_getres_k_clock_7708 clock_getres k_clock 1 7708 NULL
+disable_so_hash_shift_neigh_hash_table_7714 hash_shift neigh_hash_table 0 7714 NULL
+disable_so_pmu_fast_powerup_delay_fndecl_7721 pmu_fast_powerup_delay fndecl 0 7721 NULL
+disable_so_dst_addr_rds_info_rdma_connection_7722 dst_addr rds_info_rdma_connection 0 7722 NULL
+disable_so_period_timeriomem_rng_private_data_7730 period timeriomem_rng_private_data 0 7730 NULL
+disable_so_ocfs2_flock_handle_signal_fndecl_7734 ocfs2_flock_handle_signal fndecl 0 7734 NULL
+disable_so_seq_rds_info_message_7735 seq rds_info_message 0 7735 NULL
+disable_so_base_addr_net_device_7745 base_addr net_device 0 7745 NULL
+disable_so_sense_addr_fcpio_icmnd_16_7746 sense_addr fcpio_icmnd_16 0 7746 NULL
+disable_so_clocks_calc_mult_shift_fndecl_7747 clocks_calc_mult_shift fndecl 3-4-5 7747 NULL
+disable_so_monotonic_time_coarse_sec_vsyscall_gtod_data_7749 monotonic_time_coarse_sec vsyscall_gtod_data 0 7749 NULL
+disable_so_remote_ca_guid_cm_timewait_info_7768 remote_ca_guid cm_timewait_info 0 7768 NULL
+disable_so_tsf_timestamp_wmi_phyerr_7783 tsf_timestamp wmi_phyerr 0 7783 NULL
+disable_so_fullbatt_vchk_jiffies_at_charger_manager_7786 fullbatt_vchk_jiffies_at charger_manager 0 7786 NULL
+disable_so_st_mtime_nsec_p9_stat_dotl_7787 st_mtime_nsec p9_stat_dotl 0 7787 NULL
+disable_so_hmac_sha256_fndecl_7789 hmac_sha256 fndecl 0-2-4 7789 NULL
+disable_so_writeback_delay_fndecl_7808 writeback_delay fndecl 0-2 7808 NULL
+disable_so_offset_ioctl_gntdev_get_offset_for_vaddr_7812 offset ioctl_gntdev_get_offset_for_vaddr 0 7812 NULL
+disable_so_tuner_frequency_stv0288_state_7823 tuner_frequency stv0288_state 0 7823 NULL
+disable_so_neigh_hash_grow_fndecl_7824 neigh_hash_grow fndecl 2 7824 NULL
+disable_so_timeout_sh_mmcif_host_7836 timeout sh_mmcif_host 0 7836 NULL
+disable_so_cpuid_eax_fndecl_7845 cpuid_eax fndecl 0 7845 NULL
+disable_so_mclk_pwrmgt_cntl_si_clock_registers_7850 mclk_pwrmgt_cntl si_clock_registers 0 7850 NULL
+disable_so_mgt_update_addr_fndecl_7857 mgt_update_addr fndecl 0 7857 NULL nohasharray
+disable_so_regmap_bulk_read_fndecl_7857 regmap_bulk_read fndecl 4-0-2 7857 &disable_so_mgt_update_addr_fndecl_7857
+disable_so_cpufreq_governor_init_fndecl_7864 cpufreq_governor_init fndecl 0 7864 NULL
+disable_so_sync_freq_arizona_fll_7868 sync_freq arizona_fll 0 7868 NULL
+disable_so_channel_switch_time_ath_chanctx_sched_7869 channel_switch_time ath_chanctx_sched 0 7869 NULL nohasharray
+disable_so_isp1760_udc_set_address_fndecl_7869 isp1760_udc_set_address fndecl 2 7869 &disable_so_channel_switch_time_ath_chanctx_sched_7869
+disable_so_n_hw_addrs_iwl_nvm_data_7872 n_hw_addrs iwl_nvm_data 0 7872 NULL
+disable_so_rcu_jiffies_till_stall_check_fndecl_7874 rcu_jiffies_till_stall_check fndecl 0 7874 NULL
+disable_so_seq_b43legacy_txstatus_7880 seq b43legacy_txstatus 0 7880 NULL
+disable_so_hpi_tuner_query_frequency_fndecl_7881 hpi_tuner_query_frequency fndecl 0-1 7881 NULL
+disable_so_data_address_descriptor_7886 data_address descriptor 0 7886 NULL
+disable_so_mpll_dq_func_cntl_ci_clock_registers_7890 mpll_dq_func_cntl ci_clock_registers 0 7890 NULL
+disable_so_hpfs_load_bitmap_directory_fndecl_7892 hpfs_load_bitmap_directory fndecl 2 7892 NULL
+disable_so_hour_tomoyo_time_7893 hour tomoyo_time 0 7893 NULL
+disable_so_dx_pt_regs_7894 dx pt_regs 0 7894 NULL
+disable_so_mthca_SW2HW_EQ_fndecl_7906 mthca_SW2HW_EQ fndecl 3-0 7906 NULL
+disable_so_megasas_start_timer_fndecl_7920 megasas_start_timer fndecl 4 7920 NULL
+disable_so_Memhscx_interrupt_fndecl_7925 Memhscx_interrupt fndecl 2 7925 NULL
+disable_so_ena_gpio_regulator_config_7927 ena_gpio regulator_config 0 7927 NULL
+disable_so_tda827x_initial_sleep_fndecl_7929 tda827x_initial_sleep fndecl 0 7929 NULL
+disable_so_hfrontporch_v4l2_bt_timings_7935 hfrontporch v4l2_bt_timings 0 7935 NULL
+disable_so_xfrm_flowi_daddr_fndecl_7937 xfrm_flowi_daddr fndecl 2 7937 NULL
+disable_so_fw_schedule_device_work_fndecl_7962 fw_schedule_device_work fndecl 2 7962 NULL
+disable_so_xfs_btree_get_bufl_fndecl_7965 xfs_btree_get_bufl fndecl 3 7965 NULL
+disable_so_cpu_to_macvtap16_fndecl_7976 cpu_to_macvtap16 fndecl 0-2 7976 NULL nohasharray
+disable_so_evm_calc_hmac_or_hash_fndecl_7976 evm_calc_hmac_or_hash fndecl 0-4 7976 &disable_so_cpu_to_macvtap16_fndecl_7976
+disable_so_first_port_bitmap_port_7981 first_port bitmap_port 0 7981 NULL
+disable_so_compat_get_bitmap_fndecl_7984 compat_get_bitmap fndecl 0-3 7984 NULL
+disable_so_dma_addr_iser_rx_desc_7996 dma_addr iser_rx_desc 0 7996 NULL
+disable_so_channel2freq_a_fndecl_7997 channel2freq_a fndecl 0-1 7997 NULL
+disable_so_card_snd_timer_info_8007 card snd_timer_info 0 8007 NULL nohasharray
+disable_so_svga_set_timings_fndecl_8007 svga_set_timings fndecl 4-5-6-7-8-9 8007 &disable_so_card_snd_timer_info_8007
+disable_so_apanel_addr_vardecl_i2c_i801_c_8018 apanel_addr vardecl_i2c-i801.c 0 8018 NULL
+disable_so_bcma_pmu_pll_clock_fndecl_8024 bcma_pmu_pll_clock fndecl 2-3-0 8024 NULL
+disable_so_sha1_transform_asm_vardecl_sha1_ssse3_glue_c_8028 sha1_transform_asm vardecl_sha1_ssse3_glue.c 3 8028 NULL
+disable_so_add_timer_randomness_fndecl_8030 add_timer_randomness fndecl 2 8030 NULL
+disable_so_hash_mask_mesh_table_8031 hash_mask mesh_table 0 8031 NULL
+disable_so_show_dgid_fndecl_8032 show_dgid fndecl 0 8032 NULL
+disable_so_div_cfg_dib8000_config_8034 div_cfg dib8000_config 0 8034 NULL
+disable_so_demod_address_l64781_config_8035 demod_address l64781_config 0 8035 NULL
+disable_so_uid_cramfs_inode_8037 uid cramfs_inode 0 8037 NULL
+disable_so_recover_timer_read_fndecl_8053 recover_timer_read fndecl 0 8053 NULL
+disable_so_usb_sleep_music_show_fndecl_8055 usb_sleep_music_show fndecl 0 8055 NULL
+disable_so_hw_ptr_interrupt_snd_pcm_runtime_8061 hw_ptr_interrupt snd_pcm_runtime 0 8061 NULL
+disable_so_reset_delay_us_e1000_phy_info_8066 reset_delay_us e1000_phy_info 0 8066 NULL
+disable_so_timeout_packet_command_8072 timeout packet_command 0 8072 NULL
+disable_so_jiffies_a_sl811_8074 jiffies_a sl811 0 8074 NULL nohasharray
+disable_so_idedisk_set_max_address_fndecl_8074 idedisk_set_max_address fndecl 0-2 8074 &disable_so_jiffies_a_sl811_8074
+disable_so_base_addr_TAG_TW_Device_Extension_8076 base_addr TAG_TW_Device_Extension 0 8076 NULL
+disable_so_gateway_cmd_addr_wil_fw_record_gateway_data4_8080 gateway_cmd_addr wil_fw_record_gateway_data4 0 8080 NULL
+disable_so_snd_cmipci_interrupt_fndecl_8083 snd_cmipci_interrupt fndecl 1 8083 NULL
+disable_so_ivsize_blkcipher_alg_8085 ivsize blkcipher_alg 0 8085 NULL
+disable_so_mlx5e_add_eth_addr_rule_fndecl_8090 mlx5e_add_eth_addr_rule fndecl 0 8090 NULL
+disable_so_sysctl_rose_call_request_timeout_vardecl_8095 sysctl_rose_call_request_timeout vardecl 0 8095 NULL nohasharray
+disable_so_b43_phy_maskset_fndecl_8095 b43_phy_maskset fndecl 2-3-4 8095 &disable_so_sysctl_rose_call_request_timeout_vardecl_8095
+disable_so_dma_addr_mraid_pci_blk_8116 dma_addr mraid_pci_blk 0 8116 NULL
+disable_so___arch_hweight32_fndecl_8119 __arch_hweight32 fndecl 0-1 8119 NULL
+disable_so_lvds_downclock_drm_i915_private_8128 lvds_downclock drm_i915_private 0 8128 NULL
+disable_so_calgary_set_split_completion_timeout_fndecl_8129 calgary_set_split_completion_timeout fndecl 2 8129 NULL
+disable_so_i_atime_minix2_inode_8131 i_atime minix2_inode 0 8131 NULL
+disable_so_xclk_post_div_pll_ct_8137 xclk_post_div pll_ct 0 8137 NULL
+disable_so_legacy_display_base_addr_radeon_crtc_8144 legacy_display_base_addr radeon_crtc 0 8144 NULL
+disable_so_rv6xx_memory_clock_entry_set_reference_divider_fndecl_8149 rv6xx_memory_clock_entry_set_reference_divider fndecl 3 8149 NULL
+disable_so_x86_phys_bits_cpuinfo_x86_8154 x86_phys_bits cpuinfo_x86 0 8154 NULL
+disable_so_vmx_get_preemption_timer_value_fndecl_8155 vmx_get_preemption_timer_value fndecl 0 8155 NULL
+disable_so_delayed_set_value_led_classdev_8162 delayed_set_value led_classdev 0 8162 NULL
+disable_so_link_timeout_fe_priv_8170 link_timeout fe_priv 0 8170 NULL nohasharray
+disable_so_snd_ice1712_pro_internal_clock_info_fndecl_8170 snd_ice1712_pro_internal_clock_info fndecl 0 8170 &disable_so_link_timeout_fe_priv_8170
+disable_so___jhash_nwords_fndecl_8180 __jhash_nwords fndecl 0-1-2-3 8180 NULL
+disable_so_buffer_addr_e1000_rx_desc_8186 buffer_addr e1000_rx_desc 0 8186 NULL
+disable_so_s_wtime_ext2_super_block_8189 s_wtime ext2_super_block 0 8189 NULL nohasharray
+disable_so_sel_addr1___mux2_8189 sel_addr1 __mux2 0 8189 &disable_so_s_wtime_ext2_super_block_8189
+disable_so_elan_smbus_sleep_control_fndecl_8190 elan_smbus_sleep_control fndecl 0 8190 NULL
+disable_so_hscale_timing_8195 hscale timing 0 8195 NULL
+disable_so_mem_addr_sms_data_download_8196 mem_addr sms_data_download 0 8196 NULL
+disable_so_last_time2_intel_ilk_power_mgmt_8197 last_time2 intel_ilk_power_mgmt 0 8197 NULL
+disable_so_end_point_addr_cx231xx_video_mode_8198 end_point_addr cx231xx_video_mode 0 8198 NULL
+disable_so_cmx_delay_dsp_8202 cmx_delay dsp 0 8202 NULL
+disable_so_inet6_rtm_deladdr_fndecl_8203 inet6_rtm_deladdr fndecl 0 8203 NULL
+disable_so_local_ca_guid_cm_rep_msg_8210 local_ca_guid cm_rep_msg 0 8210 NULL
+disable_so_address_r8a66597_device_8227 address r8a66597_device 0 8227 NULL
+disable_so_idle_jiffies_tick_sched_8241 idle_jiffies tick_sched 0 8241 NULL nohasharray
+disable_so_ver_addr_via_display_timing_8241 ver_addr via_display_timing 0 8241 &disable_so_idle_jiffies_tick_sched_8241
+disable_so_addr_hamachi_desc_8244 addr hamachi_desc 0 8244 NULL nohasharray
+disable_so_addr_snd_dmaengine_dai_dma_data_8244 addr snd_dmaengine_dai_dma_data 0 8244 &disable_so_addr_hamachi_desc_8244
+disable_so_ip6addrlbl_add_fndecl_8251 ip6addrlbl_add fndecl 0-4 8251 NULL
+disable_so_transtime_vim2m_ctx_8252 transtime vim2m_ctx 0 8252 NULL
+disable_so_seq_prism2_frag_entry_8262 seq prism2_frag_entry 0 8262 NULL
+disable_so_uid_args_requester_8263 uid args_requester 0 8263 NULL
+disable_so_bfa_fcs_lport_ns_sm_gid_ft_retry_fndecl_8264 bfa_fcs_lport_ns_sm_gid_ft_retry fndecl 2 8264 NULL
+disable_so_jffs2_lzo_decompress_fndecl_8274 jffs2_lzo_decompress fndecl 3 8274 NULL
+disable_so_fb_start_aligned_physaddr_osd_info_8300 fb_start_aligned_physaddr osd_info 0 8300 NULL
+disable_so_latch_addr_flash_driver_init_fndecl_8304 latch_addr_flash_driver_init fndecl 0 8304 NULL
+disable_so_ab3100_rtc_read_time_fndecl_8312 ab3100_rtc_read_time fndecl 0 8312 NULL
+disable_so_set_addr_fndecl_8318 set_addr fndecl 2-4-5 8318 NULL
+disable_so_bit_width_acpi_pct_register_8319 bit_width acpi_pct_register 0 8319 NULL
+disable_so_cpu_core_id_cpuinfo_x86_8323 cpu_core_id cpuinfo_x86 0 8323 NULL
+disable_so_hash_rem_ccp_aes_cmac_req_ctx_8330 hash_rem ccp_aes_cmac_req_ctx 0 8330 NULL
+disable_so_ps_timeout_wireless_dev_8334 ps_timeout wireless_dev 0 8334 NULL
+disable_so_next_address_dma_ops_domain_8335 next_address dma_ops_domain 0 8335 NULL
+disable_so_skcipher_pull_sgl_fndecl_8337 skcipher_pull_sgl fndecl 2 8337 NULL
+disable_so_create_impulse_test_signal_fndecl_8361 create_impulse_test_signal fndecl 3 8361 NULL
+disable_so_mod_timer_pending_fndecl_8362 mod_timer_pending fndecl 2-0 8362 NULL nohasharray
+disable_so_ep0_trb_addr_dwc3_8362 ep0_trb_addr dwc3 0 8362 &disable_so_mod_timer_pending_fndecl_8362
+disable_so_mtt_base_addr_h_mlx4_cq_context_8364 mtt_base_addr_h mlx4_cq_context 0 8364 NULL
+disable_so_i2c_smbus_write_byte_data_fndecl_8369 i2c_smbus_write_byte_data fndecl 0-2-3 8369 NULL
+disable_so_tpg_hscale_div_fndecl_8382 tpg_hscale_div fndecl 0-3 8382 NULL
+disable_so_timestamp_bnx2i_endpoint_8390 timestamp bnx2i_endpoint 0 8390 NULL
+disable_so_audit_backlog_wait_time_vardecl_audit_c_8393 audit_backlog_wait_time vardecl_audit.c 0 8393 NULL
+disable_so_compat_put_timeval_fndecl_8394 compat_put_timeval fndecl 0 8394 NULL
+disable_so_btree_remove128_fndecl_8408 btree_remove128 fndecl 2 8408 NULL
+disable_so_pcxhr_hardware_timer_fndecl_8413 pcxhr_hardware_timer fndecl 0 8413 NULL
+disable_so_ixgbe_atr_compute_sig_hash_82599_fndecl_8416 ixgbe_atr_compute_sig_hash_82599 fndecl 0 8416 NULL
+disable_so_space_id_acpi_generic_address_8425 space_id acpi_generic_address 0 8425 NULL
+disable_so_befs_btree_read_fndecl_8444 befs_btree_read fndecl 3 8444 NULL
+disable_so_cttimeout_default_set_fndecl_8445 cttimeout_default_set fndecl 0 8445 NULL
+disable_so_set_bdaddr_hci_dev_8450 set_bdaddr hci_dev 0 8450 NULL
+disable_so_select_addr_qla82xx_md_entry_queue_8457 select_addr qla82xx_md_entry_queue 0 8457 NULL
+disable_so_crypto_register_alg_fndecl_8460 crypto_register_alg fndecl 0 8460 NULL
+disable_so_inet6_fill_ifmcaddr_fndecl_8465 inet6_fill_ifmcaddr fndecl 0-3-5 8465 NULL
+disable_so_image_address_acpi_table_bgrt_8468 image_address acpi_table_bgrt 0 8468 NULL
+disable_so_cmd_lock_addr_ulp_mem_io_8484 cmd_lock_addr ulp_mem_io 0 8484 NULL
+disable_so_r600_engine_clock_entry_set_step_time_fndecl_8486 r600_engine_clock_entry_set_step_time fndecl 3 8486 NULL
+disable_so_cxd2820r_sleep_t2_fndecl_8488 cxd2820r_sleep_t2 fndecl 0 8488 NULL
+disable_so_si_get_cu_active_bitmap_fndecl_8498 si_get_cu_active_bitmap fndecl 0-2-3 8498 NULL
+disable_so_clock_drxd_config_8500 clock drxd_config 0 8500 NULL nohasharray
+disable_so_i2c_addr_zl10039_state_8500 i2c_addr zl10039_state 0 8500 &disable_so_clock_drxd_config_8500 nohasharray
+disable_so_map_sg_dma_map_ops_8500 map_sg dma_map_ops 0-3 8500 &disable_so_i2c_addr_zl10039_state_8500
+disable_so_addr_vt1211_data_8504 addr vt1211_data 0 8504 NULL
+disable_so_vsync_pulse_width_lvds_dvo_timing_8520 vsync_pulse_width lvds_dvo_timing 0 8520 NULL
+disable_so_set_frequency_fndecl_8523 set_frequency fndecl 0-3 8523 NULL
+disable_so_lola_enable_clock_events_fndecl_8528 lola_enable_clock_events fndecl 0 8528 NULL
+disable_so_pci_prepare_to_sleep_fndecl_8531 pci_prepare_to_sleep fndecl 0 8531 NULL
+disable_so_valleyview_rps_max_freq_fndecl_8541 valleyview_rps_max_freq fndecl 0 8541 NULL
+disable_so_wm8350_set_clkdiv_fndecl_8547 wm8350_set_clkdiv fndecl 3 8547 NULL
+disable_so_scope_inet6_ifaddr_8569 scope inet6_ifaddr 0 8569 NULL
+disable_so_hci_update_random_address_fndecl_8570 hci_update_random_address fndecl 0 8570 NULL nohasharray
+disable_so_level_btrfs_delayed_extent_op_8570 level btrfs_delayed_extent_op 0 8570 &disable_so_hci_update_random_address_fndecl_8570
+disable_so_p5_mt9t112_pll_divider_8582 p5 mt9t112_pll_divider 0 8582 NULL
+disable_so_period_frames_snd_pcm_oss_runtime_8583 period_frames snd_pcm_oss_runtime 0 8583 NULL nohasharray
+disable_so_sgtl5000_set_clock_fndecl_8583 sgtl5000_set_clock fndecl 2 8583 &disable_so_period_frames_snd_pcm_oss_runtime_8583
+disable_so_ns_to_timespec_fndecl_8584 ns_to_timespec fndecl 1 8584 NULL
+disable_so_mmc_test_random_perf_fndecl_8591 mmc_test_random_perf fndecl 0 8591 NULL
+disable_so_ac_sleep_before_get_state_ms_vardecl_ac_c_8592 ac_sleep_before_get_state_ms vardecl_ac.c 0 8592 NULL
+disable_so_s5h1420_getfreqoffset_fndecl_8597 s5h1420_getfreqoffset fndecl 0 8597 NULL
+disable_so_pll_j_aic32x4_rate_divs_8598 pll_j aic32x4_rate_divs 0 8598 NULL
+disable_so_freq_stb0899_params_8606 freq stb0899_params 0 8606 NULL
+disable_so_vblank_hi_oaktrail_timing_info_8607 vblank_hi oaktrail_timing_info 0 8607 NULL
+disable_so_subnet_timeout_ipath_ibdev_8613 subnet_timeout ipath_ibdev 0 8613 NULL nohasharray
+disable_so_demod_address_or51211_config_8613 demod_address or51211_config 0 8613 &disable_so_subnet_timeout_ipath_ibdev_8613
+disable_so___compat_put_timespec_fndecl_8625 __compat_put_timespec fndecl 0 8625 NULL
+disable_so_sq_addr_hi_fcoe_kwqe_conn_offload1_8631 sq_addr_hi fcoe_kwqe_conn_offload1 0 8631 NULL
+disable_so_compat_sock_get_timestamp_fndecl_8635 compat_sock_get_timestamp fndecl 0 8635 NULL
+disable_so_next_sit_addr_fndecl_8639 next_sit_addr fndecl 0-2 8639 NULL
+disable_so_update_mc_addr_fm10k_mac_ops_8643 update_mc_addr fm10k_mac_ops 4 8643 NULL
+disable_so_img_ir_timing_range_convert_fndecl_8648 img_ir_timing_range_convert fndecl 3-4-5 8648 NULL
+disable_so_adc_clock_ratio_dib0090_io_config_8649 adc_clock_ratio dib0090_io_config 0 8649 NULL
+disable_so_regcache_rbtree_sync_fndecl_8655 regcache_rbtree_sync fndecl 0-2-3 8655 NULL
+disable_so_nilfs_btree_gather_data_fndecl_8666 nilfs_btree_gather_data fndecl 0-4 8666 NULL
+disable_so__scsih_get_sas_address_fndecl_8674 _scsih_get_sas_address fndecl 2 8674 NULL
+disable_so_mul_u64_u32_shr_fndecl_8675 mul_u64_u32_shr fndecl 0-1-2-3 8675 NULL
+disable_so_find_next_zero_bit_fndecl_8677 find_next_zero_bit fndecl 0-2-3 8677 NULL
+disable_so_generic_set_freq_fndecl_8678 generic_set_freq fndecl 0-2 8678 NULL
+disable_so_time_in_irq_usb_usbvision_8687 time_in_irq usb_usbvision 0 8687 NULL
+disable_so_data_addr_asc_scsiq_1_8688 data_addr asc_scsiq_1 0 8688 NULL
+disable_so_nl80211_parse_random_mac_fndecl_8702 nl80211_parse_random_mac fndecl 0 8702 NULL
+disable_so_hpi_compander_set_attack_time_constant_fndecl_8705 hpi_compander_set_attack_time_constant fndecl 1-0 8705 NULL
+disable_so_qla2x00_sns_gid_pt_fndecl_8706 qla2x00_sns_gid_pt fndecl 0 8706 NULL
+disable_so_tipc_own_addr_fndecl_8707 tipc_own_addr fndecl 0 8707 NULL
+disable_so_da9055_rtc_read_time_fndecl_8709 da9055_rtc_read_time fndecl 0 8709 NULL
+disable_so_theta__fll_div_8710 theta _fll_div 0 8710 NULL nohasharray
+disable_so_size_genwqe_bitstream_8710 size genwqe_bitstream 0 8710 &disable_so_theta__fll_div_8710
+disable_so_cpu_to_virtio64_fndecl_8714 cpu_to_virtio64 fndecl 0-2 8714 NULL
+disable_so_sleep_reg_bma180_part_info_8720 sleep_reg bma180_part_info 0 8720 NULL
+disable_so_via_clock_init_fndecl_8721 via_clock_init fndecl 2 8721 NULL
+disable_so_time_reftime_vardecl_ntp_c_8722 time_reftime vardecl_ntp.c 0 8722 NULL
+disable_so_sysfs_set_reg_fndecl_8723 sysfs_set_reg fndecl 5 8723 NULL
+disable_so_rport_del_timeout_vardecl_8725 rport_del_timeout vardecl 0 8725 NULL
+disable_so_rb_subtree_gap_vm_area_struct_8729 rb_subtree_gap vm_area_struct 0 8729 NULL
+disable_so_mipi_dsi_dcs_set_column_address_fndecl_8732 mipi_dsi_dcs_set_column_address fndecl 0 8732 NULL
+disable_so_aes_encrypt_fail_read_fndecl_8737 aes_encrypt_fail_read fndecl 0-3 8737 NULL
+disable_so_sumo_set_uvd_clock_fndecl_8742 sumo_set_uvd_clock fndecl 0-2-3-4 8742 NULL
+disable_so_daddr_irlap_cb_8752 daddr irlap_cb 0 8752 NULL
+disable_so_skcipher_sendpage_fndecl_8759 skcipher_sendpage fndecl 0-3-4-5 8759 NULL
+disable_so_bitmap_store_fndecl_8764 bitmap_store fndecl 0-3 8764 NULL
+disable_so_outdiv_arizona_fll_cfg_8765 outdiv arizona_fll_cfg 0 8765 NULL
+disable_so_mce_start_timer_fndecl_8772 mce_start_timer fndecl 1 8772 NULL nohasharray
+disable_so_kxcjk1013_runtime_resume_fndecl_8772 kxcjk1013_runtime_resume fndecl 0 8772 &disable_so_mce_start_timer_fndecl_8772
+disable_so_p_addr_fw_desc_8777 p_addr fw_desc 0 8777 NULL
+disable_so_count_uid_gid_extent_8799 count uid_gid_extent 0 8799 NULL
+disable_so_ring_base_address_kfd_ioctl_create_queue_args_8811 ring_base_address kfd_ioctl_create_queue_args 0 8811 NULL
+disable_so_start_addr_mlx5_mkey_seg_8817 start_addr mlx5_mkey_seg 0 8817 NULL
+disable_so_ui_gid_ufs2_inode_8825 ui_gid ufs2_inode 0 8825 NULL
+disable_so_addr_idx_tx_sw_desc_8827 addr_idx tx_sw_desc 0 8827 NULL
+disable_so_cookie_init_timestamp_fndecl_8835 cookie_init_timestamp fndecl 0 8835 NULL
+disable_so_f2fs_crypto_initialize_fndecl_8839 f2fs_crypto_initialize fndecl 0 8839 NULL
+disable_so_timeout_ib_mad_send_wr_private_8841 timeout ib_mad_send_wr_private 0 8841 NULL nohasharray
+disable_so_ddiv_gf100_clk_info_8841 ddiv gf100_clk_info 0 8841 &disable_so_timeout_ib_mad_send_wr_private_8841
+disable_so_start_time_ieee80211_p2p_noa_desc_8844 start_time ieee80211_p2p_noa_desc 0 8844 NULL
+disable_so__isl12057_rtc_read_time_fndecl_8850 _isl12057_rtc_read_time fndecl 0 8850 NULL
+disable_so_read_addr_qla8xxx_minidump_entry_cache_8859 read_addr qla8xxx_minidump_entry_cache 0 8859 NULL
+disable_so_b43legacy_get_txgain_freq_power_amp_fndecl_8866 b43legacy_get_txgain_freq_power_amp fndecl 0-1 8866 NULL
+disable_so_ldelay_codel_vars_8872 ldelay codel_vars 0 8872 NULL
+disable_so_mode_addr_ath_gen_timer_configuration_8875 mode_addr ath_gen_timer_configuration 0 8875 NULL
+disable_so_move_addr_to_kernel_fndecl_8882 move_addr_to_kernel fndecl 0-2 8882 NULL
+disable_so_last_time_cpufreq_stats_8891 last_time cpufreq_stats 0 8891 NULL
+disable_so_di_uid_xfs_icdinode_8897 di_uid xfs_icdinode 0 8897 NULL
+disable_so_g84_cipher_init_fndecl_8909 g84_cipher_init fndecl 0 8909 NULL
+disable_so_slave_addr_intel_dvo_device_8910 slave_addr intel_dvo_device 0 8910 NULL
+disable_so_avg_time_ide_tape_obj_8917 avg_time ide_tape_obj 0 8917 NULL
+disable_so_ticks_timerfd_ctx_8928 ticks timerfd_ctx 0 8928 NULL
+disable_so_st_atime_compat_stat_8936 st_atime compat_stat 0 8936 NULL
+disable_so_addrconf_init_net_fndecl_8938 addrconf_init_net fndecl 0 8938 NULL
+disable_so_qla4xxx_start_timer_fndecl_8945 qla4xxx_start_timer fndecl 3 8945 NULL
+disable_so_crypto_blkcipher_decrypt_fndecl_8955 crypto_blkcipher_decrypt fndecl 0-4 8955 NULL
+disable_so_guest_physical_address_vmcs12_8957 guest_physical_address vmcs12 0 8957 NULL
+disable_so_acpi_lpss_runtime_resume_fndecl_8958 acpi_lpss_runtime_resume fndecl 0 8958 NULL nohasharray
+disable_so_tegra_spi_runtime_resume_fndecl_8958 tegra_spi_runtime_resume fndecl 0 8958 &disable_so_acpi_lpss_runtime_resume_fndecl_8958
+disable_so_runtime_resume_fndecl_8969 runtime_resume fndecl 0 8969 NULL
+disable_so_hpi_tuner_set_hd_radio_signal_blend_fndecl_8970 hpi_tuner_set_hd_radio_signal_blend fndecl 0-1 8970 NULL
+disable_so_wait_isoch_resource_delay_after_bus_reset_fndecl_8971 wait_isoch_resource_delay_after_bus_reset fndecl 0 8971 NULL
+disable_so_end_fw_address_region_8972 end fw_address_region 0 8972 NULL
+disable_so_sel_time_fcoe_ctlr_8977 sel_time fcoe_ctlr 0 8977 NULL
+disable_so_unmap_addr_tso_state_8980 unmap_addr tso_state 0 8980 NULL
+disable_so_v_freq_adv76xx_video_standards_8995 v_freq adv76xx_video_standards 0 8995 NULL
+disable_so_p3_mt9t112_pll_divider_8996 p3 mt9t112_pll_divider 0 8996 NULL
+disable_so_si476x_cmd_tune_seek_freq_fndecl_8997 si476x_cmd_tune_seek_freq fndecl 0-4-6 8997 NULL
+disable_so_lzo1x_1_do_compress_fndecl_9000 lzo1x_1_do_compress fndecl 2 9000 NULL
+disable_so_data_ramfuc_reg_9003 data ramfuc_reg 0 9003 NULL
+disable_so_uid_drm_client_9005 uid drm_client 0 9005 NULL nohasharray
+disable_so_size_pfn_var_mtrr_range_state_9005 size_pfn var_mtrr_range_state 0 9005 &disable_so_uid_drm_client_9005
+disable_so_decode_attr_time_modify_fndecl_9006 decode_attr_time_modify fndecl 0 9006 NULL nohasharray
+disable_so_last_jiffies_debug_vals_9006 last_jiffies debug_vals 0 9006 &disable_so_decode_attr_time_modify_fndecl_9006
+disable_so_i2c_address_tua6100_priv_9007 i2c_address tua6100_priv 0 9007 NULL nohasharray
+disable_so_end_mtrr_iter_9007 end mtrr_iter 0 9007 &disable_so_i2c_address_tua6100_priv_9007
+disable_so_sin6_flowinfo_sockaddr_in6_9019 sin6_flowinfo sockaddr_in6 0 9019 NULL nohasharray
+disable_so_device_destroy_fndecl_9019 device_destroy fndecl 2 9019 &disable_so_sin6_flowinfo_sockaddr_in6_9019
+disable_so_si_tss_segment_16_9021 si tss_segment_16 0 9021 NULL
+disable_so_parport_ieee1284_epp_write_addr_fndecl_9024 parport_ieee1284_epp_write_addr fndecl 0 9024 NULL
+disable_so_esi_user_regs_struct32_9028 esi user_regs_struct32 0 9028 NULL
+disable_so_clockevents_unbind_device_fndecl_9035 clockevents_unbind_device fndecl 2 9035 NULL nohasharray
+disable_so_t1_interrupt_fndecl_9035 t1_interrupt fndecl 1 9035 &disable_so_clockevents_unbind_device_fndecl_9035 nohasharray
+disable_so_randomize_stack_top_fndecl_9035 randomize_stack_top fndecl 0-1 9035 &disable_so_t1_interrupt_fndecl_9035
+disable_so_mv88e6xxx_set_addr_direct_fndecl_9045 mv88e6xxx_set_addr_direct fndecl 0 9045 NULL
+disable_so_phy_addr_cas_9051 phy_addr cas 0 9051 NULL
+disable_so_usnic_transport_sock_get_addr_fndecl_9083 usnic_transport_sock_get_addr fndecl 0 9083 NULL
+disable_so_debug_dma_free_coherent_fndecl_9087 debug_dma_free_coherent fndecl 4 9087 NULL nohasharray
+disable_so_hashtab_insert_fndecl_9087 hashtab_insert fndecl 0 9087 &disable_so_debug_dma_free_coherent_fndecl_9087
+disable_so_kblockd_schedule_delayed_work_on_fndecl_9095 kblockd_schedule_delayed_work_on fndecl 3-1 9095 NULL nohasharray
+disable_so_lbs_host_sleep_cfg_fndecl_9095 lbs_host_sleep_cfg fndecl 0 9095 &disable_so_kblockd_schedule_delayed_work_on_fndecl_9095
+disable_so_q_ctime_msg_queue_9100 q_ctime msg_queue 0 9100 NULL
+disable_so_start_time_il_spectrum_cmd_9104 start_time il_spectrum_cmd 0 9104 NULL
+disable_so_local_clock_fndecl_9106 local_clock fndecl 0 9106 NULL
+disable_so_addr_xtsplit_9109 addr xtsplit 0 9109 NULL
+disable_so_runtime_suspend_fndecl_9118 runtime_suspend fndecl 0 9118 NULL
+disable_so_pch_src_uuid_lo_read_fndecl_9120 pch_src_uuid_lo_read fndecl 0 9120 NULL nohasharray
+disable_so_freq_is_chan_12_13_14_fndecl_9120 freq_is_chan_12_13_14 fndecl 1 9120 &disable_so_pch_src_uuid_lo_read_fndecl_9120
+disable_so_addr1___pollrdmwr_9145 addr1 __pollrdmwr 0 9145 NULL
+disable_so_iowrite16_rep_fndecl_9149 iowrite16_rep fndecl 3 9149 NULL
+disable_so_rss_hash_result_eth_fast_path_rx_cqe_9151 rss_hash_result eth_fast_path_rx_cqe 0 9151 NULL
+disable_so_ieee80211_fill_mesh_addresses_fndecl_9154 ieee80211_fill_mesh_addresses fndecl 0 9154 NULL
+disable_so_dequeue_signal_lock_fndecl_9161 dequeue_signal_lock fndecl 0 9161 NULL
+disable_so_min_tomoyo_time_9165 min tomoyo_time 0 9165 NULL
+disable_so_hash_kernfs_node_9177 hash kernfs_node 0 9177 NULL
+disable_so_get_subaddr_fndecl_9183 get_subaddr fndecl 0-3 9183 NULL
+disable_so_tms_stime_tms_9187 tms_stime tms 0 9187 NULL
+disable_so_shash_async_final_fndecl_9193 shash_async_final fndecl 0 9193 NULL
+disable_so_sksg_dma_address_skd_request_context_9194 sksg_dma_address skd_request_context 0 9194 NULL
+disable_so_rss_hash_val_rss_header_9205 rss_hash_val rss_header 0 9205 NULL
+disable_so_actual_clock_mmc_host_9217 actual_clock mmc_host 0 9217 NULL
+disable_so_xt_cluster_is_multicast_addr_fndecl_9218 xt_cluster_is_multicast_addr fndecl 2 9218 NULL
+disable_so_ww_mutex_lock_interruptible_fndecl_9222 ww_mutex_lock_interruptible fndecl 0 9222 NULL
+disable_so_twake_snd_pcm_runtime_9229 twake snd_pcm_runtime 0 9229 NULL
+disable_so_read_file_bt_ant_diversity_fndecl_9236 read_file_bt_ant_diversity fndecl 0 9236 NULL
+disable_so_tx_complete_addr_acx_data_path_params_resp_9246 tx_complete_addr acx_data_path_params_resp 0 9246 NULL
+disable_so_pbn_div_drm_dp_mst_topology_mgr_9251 pbn_div drm_dp_mst_topology_mgr 0 9251 NULL
+disable_so_num_address_p54_group_address_table_9258 num_address p54_group_address_table 0 9258 NULL
+disable_so_ks108_set_xaddr_fndecl_9262 ks108_set_xaddr fndecl 2-3 9262 NULL
+disable_so_xtal_freq_qm1d1c0042_config_9263 xtal_freq qm1d1c0042_config 0 9263 NULL
+disable_so_lbs_host_sleep_read_fndecl_9270 lbs_host_sleep_read fndecl 3-0 9270 NULL
+disable_so_fdiv_it913x_dev_9273 fdiv it913x_dev 0 9273 NULL nohasharray
+disable_so_oom_score_adj_signal_struct_9273 oom_score_adj signal_struct 0 9273 &disable_so_fdiv_it913x_dev_9273
+disable_so_compat_sys_mq_timedsend_fndecl_9287 compat_sys_mq_timedsend fndecl 3-1 9287 NULL
+disable_so_snd_tea575x_val_to_freq_fndecl_9302 snd_tea575x_val_to_freq fndecl 0-2 9302 NULL
+disable_so_addr_resolve_fndecl_9304 addr_resolve fndecl 0 9304 NULL
+disable_so_address_mic_vqconfig_9306 address mic_vqconfig 0 9306 NULL nohasharray
+disable_so_stat_params_addr_lo_fcoe_kwqe_stat_9306 stat_params_addr_lo fcoe_kwqe_stat 0 9306 &disable_so_address_mic_vqconfig_9306
+disable_so_trace_clock_local_fndecl_9318 trace_clock_local fndecl 0 9318 NULL nohasharray
+disable_so_proc_gid_map_write_fndecl_9318 proc_gid_map_write fndecl 0-3 9318 &disable_so_trace_clock_local_fndecl_9318
+disable_so_discovery_timeout_mpath_info_9320 discovery_timeout mpath_info 0 9320 NULL
+disable_so_xmit_timeout_nbd_device_9323 xmit_timeout nbd_device 0 9323 NULL
+disable_so_timer_irq_vardecl_cs5535_clockevt_c_9326 timer_irq vardecl_cs5535-clockevt.c 0 9326 NULL
+disable_so_kblockd_schedule_delayed_work_fndecl_9328 kblockd_schedule_delayed_work fndecl 2 9328 NULL
+disable_so_utimes_common_fndecl_9330 utimes_common fndecl 0 9330 NULL
+disable_so_di_gid_qnx4_inode_entry_9346 di_gid qnx4_inode_entry 0 9346 NULL nohasharray
+disable_so_rpc_localaddr_fndecl_9346 rpc_localaddr fndecl 0 9346 &disable_so_di_gid_qnx4_inode_entry_9346
+disable_so_ibits_pll_freq_tbl_9354 ibits pll_freq_tbl 0 9354 NULL
+disable_so_addr_nct6683_data_9356 addr nct6683_data 0 9356 NULL
+disable_so_l2_fhdr_hash_l2_fhdr_9360 l2_fhdr_hash l2_fhdr 0 9360 NULL
+disable_so_hpfs_count_one_bitmap_fndecl_9362 hpfs_count_one_bitmap fndecl 0-2 9362 NULL
+disable_so_ax25_uid_ioctl_fndecl_9367 ax25_uid_ioctl fndecl 0 9367 NULL
+disable_so_last_rebuild_jiffies_inet_frags_9369 last_rebuild_jiffies inet_frags 0 9369 NULL
+disable_so_hash_ipportnet6_expire_fndecl_9373 hash_ipportnet6_expire fndecl 4 9373 NULL
+disable_so_uuid_count_mgmt_cp_start_service_discovery_9374 uuid_count mgmt_cp_start_service_discovery 0 9374 NULL
+disable_so_ixgbe_set_vf_mac_addr_fndecl_9376 ixgbe_set_vf_mac_addr fndecl 3 9376 NULL
+disable_so_addr_dma_desc_9383 addr dma_desc 0 9383 NULL
+disable_so_ilk_get_aux_clock_divider_fndecl_9386 ilk_get_aux_clock_divider fndecl 0 9386 NULL
+disable_so_host_bfa_bsg_rport_scsi_addr_s_9387 host bfa_bsg_rport_scsi_addr_s 0 9387 NULL
+disable_so_xfs_btree_init_block_int_fndecl_9393 xfs_btree_init_block_int fndecl 3-7 9393 NULL
+disable_so_dutycycle_pwm_voltages_9394 dutycycle pwm_voltages 0 9394 NULL
+disable_so_max_timer_ms_ssb_chipcommon_9403 max_timer_ms ssb_chipcommon 0 9403 NULL
+disable_so_demod_address_jdvbt90502_config_9412 demod_address jdvbt90502_config 0 9412 NULL nohasharray
+disable_so_inet_dev_addr_type_fndecl_9412 inet_dev_addr_type fndecl 3 9412 &disable_so_demod_address_jdvbt90502_config_9412
+disable_so_bit_offset_acpi_generic_address_9413 bit_offset acpi_generic_address 0 9413 NULL
+disable_so_crypto_hash_update_fndecl_9415 crypto_hash_update fndecl 0-3 9415 NULL
+disable_so_ftdi_2232h_baud_to_divisor_fndecl_9425 ftdi_2232h_baud_to_divisor fndecl 0-1 9425 NULL
+disable_so_blk_post_runtime_resume_fndecl_9432 blk_post_runtime_resume fndecl 2 9432 NULL
+disable_so_parent_btrfs_delayed_data_ref_9437 parent btrfs_delayed_data_ref 0 9437 NULL nohasharray
+disable_so_netxen_get_interrupt_mode_fndecl_9437 netxen_get_interrupt_mode fndecl 0 9437 &disable_so_parent_btrfs_delayed_data_ref_9437
+disable_so_entry_attr_timeout_fndecl_9441 entry_attr_timeout fndecl 0 9441 NULL
+disable_so_wall_time_snsec_vsyscall_gtod_data_9445 wall_time_snsec vsyscall_gtod_data 0 9445 NULL
+disable_so_atm_get_addr_fndecl_9446 atm_get_addr fndecl 3 9446 NULL
+disable_so_address_efx_farch_register_test_9448 address efx_farch_register_test 0 9448 NULL
+disable_so_rx_errors_net_device_stats_9453 rx_errors net_device_stats 0 9453 NULL
+disable_so_crypto_sha1_update_fndecl_9455 crypto_sha1_update fndecl 3 9455 NULL
+disable_so_bm_set_drbd_bitmap_9457 bm_set drbd_bitmap 0 9457 NULL
+disable_so_mb86a16_write_fndecl_9462 mb86a16_write fndecl 3 9462 NULL
+disable_so_cycle_delay_radeon_dpm_fan_9463 cycle_delay radeon_dpm_fan 0 9463 NULL
+disable_so_value_vmx_msr_entry_9464 value vmx_msr_entry 0 9464 NULL
+disable_so_io_bitmap_b_vmcs12_9472 io_bitmap_b vmcs12 0 9472 NULL
+disable_so_brtime_id_seeprom_config_9474 brtime_id seeprom_config 0 9474 NULL
+disable_so_frequency_stv0367ter_state_9481 frequency stv0367ter_state 0 9481 NULL
+disable_so_ccp_aes_cmac_setkey_fndecl_9503 ccp_aes_cmac_setkey fndecl 0-3 9503 NULL
+disable_so_tsc_ratio_vcpu_svm_9506 tsc_ratio vcpu_svm 0 9506 NULL
+disable_so_crypto_cts_setkey_fndecl_9507 crypto_cts_setkey fndecl 0-3 9507 NULL
+disable_so_clock_t_to_compat_clock_t_fndecl_9510 clock_t_to_compat_clock_t fndecl 1-0 9510 NULL
+disable_so_xcan_err_interrupt_fndecl_9511 xcan_err_interrupt fndecl 2 9511 NULL nohasharray
+disable_so_gru_start_paddr_vardecl_x2apic_uv_x_c_9511 gru_start_paddr vardecl_x2apic_uv_x.c 0 9511 &disable_so_xcan_err_interrupt_fndecl_9511
+disable_so_nilfs_btree_check_delete_fndecl_9514 nilfs_btree_check_delete fndecl 0 9514 NULL
+disable_so_debug_dma_sync_single_for_device_fndecl_9517 debug_dma_sync_single_for_device fndecl 3-2 9517 NULL
+disable_so_single_bit_error_correct_fndecl_9520 single_bit_error_correct fndecl 4 9520 NULL
+disable_so_data_busaddr_ips_scb_9530 data_busaddr ips_scb 0 9530 NULL
+disable_so_diversity_delay_dib8000_config_9533 diversity_delay dib8000_config 0 9533 NULL
+disable_so_ems_usb_set_bittiming_fndecl_9537 ems_usb_set_bittiming fndecl 0 9537 NULL
+disable_so_port_update_gid_work_9549 port update_gid_work 0 9549 NULL
+disable_so_cryptomgr_schedule_test_fndecl_9550 cryptomgr_schedule_test fndecl 0 9550 NULL
+disable_so_hpd_eop_gpu_addr_radeon_mec_9554 hpd_eop_gpu_addr radeon_mec 0 9554 NULL
+disable_so_cluster_slot_bitmap_9571 cluster_slot bitmap 0 9571 NULL
+disable_so_address_space_cmos_rtc_board_info_9586 address_space cmos_rtc_board_info 0 9586 NULL
+disable_so_regcache_rbtree_set_register_fndecl_9588 regcache_rbtree_set_register fndecl 3-4 9588 NULL
+disable_so_gen8_xcs_signal_fndecl_9591 gen8_xcs_signal fndecl 0-2 9591 NULL
+disable_so_time_stamp_il_tx_queue_9592 time_stamp il_tx_queue 0 9592 NULL
+disable_so_first_dev_address_fndecl_9599 first_dev_address fndecl 0-1 9599 NULL
+disable_so_lpfc_max_scsicmpl_time_show_fndecl_9604 lpfc_max_scsicmpl_time_show fndecl 0 9604 NULL
+disable_so_efx_ef10_get_sysclk_freq_fndecl_9605 efx_ef10_get_sysclk_freq fndecl 0 9605 NULL
+disable_so_utime_signal_struct_9619 utime signal_struct 0 9619 NULL nohasharray
+disable_so_connected_time_station_info_9619 connected_time station_info 0 9619 &disable_so_utime_signal_struct_9619
+disable_so_elapsed_time_f2fs_checkpoint_9631 elapsed_time f2fs_checkpoint 0 9631 NULL
+disable_so_read_addr_qla8044_minidump_entry_pollrd_9634 read_addr qla8044_minidump_entry_pollrd 0 9634 NULL
+disable_so_time_stamp_sec_TAG_TW_Event_9639 time_stamp_sec TAG_TW_Event 0 9639 NULL
+disable_so_blk_pre_runtime_suspend_fndecl_9640 blk_pre_runtime_suspend fndecl 0 9640 NULL
+disable_so_ds_divider_index_sumo_pl_9644 ds_divider_index sumo_pl 0 9644 NULL
+disable_so_out_of_line_wait_on_bit_timeout_fndecl_9648 out_of_line_wait_on_bit_timeout fndecl 5-0 9648 NULL
+disable_so_sys_getuid16_fndecl_9653 sys_getuid16 fndecl 0 9653 NULL
+disable_so_smc_interrupt_fndecl_9659 smc_interrupt fndecl 1 9659 NULL
+disable_so_pld_clock_kempld_device_data_9670 pld_clock kempld_device_data 0 9670 NULL
+disable_so_hello_time_show_fndecl_9675 hello_time_show fndecl 0 9675 NULL
+disable_so_paddr_tsq_info_9680 paddr tsq_info 0 9680 NULL
+disable_so_fifo_addr_fwnet_packet_task_9682 fifo_addr fwnet_packet_task 0 9682 NULL
+disable_so_uaddr_ivtv_dma_page_info_9683 uaddr ivtv_dma_page_info 0 9683 NULL
+disable_so_lp872x_regulator_enable_time_fndecl_9684 lp872x_regulator_enable_time fndecl 0 9684 NULL
+disable_so_r67_val_fc2580_freq_regs_9685 r67_val fc2580_freq_regs 0 9685 NULL
+disable_so_mclk_freq_rj54n1_pdata_9727 mclk_freq rj54n1_pdata 0 9727 NULL
+disable_so_qdelay_pie_vars_9735 qdelay pie_vars 0 9735 NULL
+disable_so_uncore_msr_fixed_ctl_fndecl_9740 uncore_msr_fixed_ctl fndecl 0 9740 NULL
+disable_so_ifa_preferred_lft_in_ifaddr_9744 ifa_preferred_lft in_ifaddr 0 9744 NULL
+disable_so_cpuid_device_create_fndecl_9746 cpuid_device_create fndecl 1 9746 NULL
+disable_so_musb_write_rxhubaddr_fndecl_9750 musb_write_rxhubaddr fndecl 2-3 9750 NULL
+disable_so_moddelay_soundfont_voice_parm_9752 moddelay soundfont_voice_parm 0 9752 NULL
+disable_so_uwb_rc_mac_addr_setup_fndecl_9754 uwb_rc_mac_addr_setup fndecl 0 9754 NULL
+disable_so_kv_convert_2bit_index_to_voltage_fndecl_9759 kv_convert_2bit_index_to_voltage fndecl 0-2 9759 NULL
+disable_so_timeout_interval_bau_control_9762 timeout_interval bau_control 0 9762 NULL
+disable_so_acpi_ut_check_address_range_fndecl_9782 acpi_ut_check_address_range fndecl 1-2-3 9782 NULL
+disable_so_signal_rtl8187_priv_9785 signal rtl8187_priv 0 9785 NULL
+disable_so_usb__coeff_div_9793 usb _coeff_div 0 9793 NULL
+disable_so_dspaddr_offset_intel_crtc_9795 dspaddr_offset intel_crtc 0 9795 NULL
+disable_so_demod_address_mt352_config_9806 demod_address mt352_config 0 9806 NULL
+disable_so_ntfs_bitmap_set_bits_in_run_fndecl_9807 ntfs_bitmap_set_bits_in_run fndecl 2-3 9807 NULL
+disable_so_vaddr_ioctl_gntdev_get_offset_for_vaddr_9810 vaddr ioctl_gntdev_get_offset_for_vaddr 0 9810 NULL
+disable_so_mtime_fuse_setattr_in_9811 mtime fuse_setattr_in 0 9811 NULL nohasharray
+disable_so_r10_pt_regs_9811 r10 pt_regs 0 9811 &disable_so_mtime_fuse_setattr_in_9811
+disable_so_ath6kl_wmi_bmisstime_cmd_fndecl_9818 ath6kl_wmi_bmisstime_cmd fndecl 2-0 9818 NULL
+disable_so_addr_lp55xx_reg_9819 addr lp55xx_reg 0 9819 NULL
+disable_so_rq_pbl_addr_hi_fcoe_kwqe_conn_offload1_9838 rq_pbl_addr_hi fcoe_kwqe_conn_offload1 0 9838 NULL
+disable_so___bitmap_shift_right_fndecl_9852 __bitmap_shift_right fndecl 3-4 9852 NULL
+disable_so_set_ramp_delay_regulator_ops_9853 set_ramp_delay regulator_ops 0 9853 NULL
+disable_so_delay_qla8044_reset_entry_hdr_9861 delay qla8044_reset_entry_hdr 0 9861 NULL
+disable_so_dn_nl_dump_ifaddr_fndecl_9864 dn_nl_dump_ifaddr fndecl 0 9864 NULL
+disable_so_cryptd_blkcipher_decrypt_enqueue_fndecl_9865 cryptd_blkcipher_decrypt_enqueue fndecl 0 9865 NULL
+disable_so_dma_addr_vnic_rq_buf_9867 dma_addr vnic_rq_buf 0 9867 NULL
+disable_so_atomic_pte_lookup_fndecl_9877 atomic_pte_lookup fndecl 2 9877 NULL
+disable_so_init_freq_pt3_adap_config_9886 init_freq pt3_adap_config 0 9886 NULL nohasharray
+disable_so_tq_can_bittiming_9886 tq can_bittiming 0 9886 &disable_so_init_freq_pt3_adap_config_9886
+disable_so_base_addr_tg3_firmware_hdr_9887 base_addr tg3_firmware_hdr 0 9887 NULL
+disable_so_execaddr_object_info_9888 execaddr object_info 0 9888 NULL
+disable_so_freq_r3A_value_fndecl_9891 freq_r3A_value fndecl 0-1 9891 NULL
+disable_so_xfs_btree_shift_ptrs_fndecl_9894 xfs_btree_shift_ptrs fndecl 4 9894 NULL
+disable_so_rsp_producer_index_phy_addr_low_ql3_adapter_9895 rsp_producer_index_phy_addr_low ql3_adapter 0 9895 NULL
+disable_so_n_voltages_regulator_desc_9911 n_voltages regulator_desc 0 9911 NULL
+disable_so_reset_gid_table_fndecl_9912 reset_gid_table fndecl 2 9912 NULL
+disable_so_dentist_vco_freq_trinity_sys_info_9922 dentist_vco_freq trinity_sys_info 0 9922 NULL
+disable_so_mactime_linux_wlan_ng_cap_hdr_9926 mactime linux_wlan_ng_cap_hdr 0 9926 NULL nohasharray
+disable_so_address_hi_ht_irq_msg_9926 address_hi ht_irq_msg 0 9926 &disable_so_mactime_linux_wlan_ng_cap_hdr_9926
+disable_so_mdac_aic31xx_rate_divs_9931 mdac aic31xx_rate_divs 0 9931 NULL
+disable_so_si2168_sleep_fndecl_9938 si2168_sleep fndecl 0 9938 NULL
+disable_so_spp_assoc_id_sctp_paddrparams_9958 spp_assoc_id sctp_paddrparams 0 9958 NULL
+disable_so_skcipher_wait_for_data_fndecl_9959 skcipher_wait_for_data fndecl 0 9959 NULL
+disable_so_c_delay_target_disk_conf_9960 c_delay_target disk_conf 0 9960 NULL
+disable_so_p1div_pmu1_plltab_entry_9962 p1div pmu1_plltab_entry 0 9962 NULL
+disable_so_extract_clock_fndecl_9973 extract_clock fndecl 1-2-0 9973 NULL
+disable_so_addr_hi_rx_desc_9978 addr_hi rx_desc 0 9978 NULL
+disable_so_sin_family_sockaddr_in_9981 sin_family sockaddr_in 0 9981 NULL
+disable_so_ticks_snd_timer_user_9987 ticks snd_timer_user 0 9987 NULL
+disable_so_address_musb_9992 address musb 0 9992 NULL
+disable_so_invalidate_guid_record_fndecl_9996 invalidate_guid_record fndecl 2 9996 NULL
+disable_so_request_daddr_isci_request_10008 request_daddr isci_request 0 10008 NULL
+disable_so_addr_sec_info_di_buf_entry_10016 addr_sec_info di_buf_entry 0 10016 NULL
+disable_so_hash_netportnet4_expire_fndecl_10025 hash_netportnet4_expire fndecl 4 10025 NULL
+disable_so_hid_time_value_fndecl_10028 hid_time_value fndecl 0 10028 NULL
+disable_so_ts_jiffies_uwb_beca_e_10039 ts_jiffies uwb_beca_e 0 10039 NULL
+disable_so_hpi_sample_clock_get_source_fndecl_10048 hpi_sample_clock_get_source fndecl 1-0 10048 NULL
+disable_so_hfsplus_btree_open_fndecl_10055 hfsplus_btree_open fndecl 2 10055 NULL
+disable_so_rx_drain_timeout_msecs_vardecl_10061 rx_drain_timeout_msecs vardecl 0 10061 NULL
+disable_so_start_seq_tcp_sack_block_wire_10072 start_seq tcp_sack_block_wire 0 10072 NULL
+disable_so_sha1_mb_finup_fndecl_10074 sha1_mb_finup fndecl 0 10074 NULL
+disable_so_flow_get_skuid_fndecl_10095 flow_get_skuid fndecl 0 10095 NULL
+disable_so_i_atime_ext4_inode_10096 i_atime ext4_inode 0 10096 NULL
+disable_so_wd_timeout_iwl_txq_10106 wd_timeout iwl_txq 0 10106 NULL
+disable_so_tx_lpi_timer_ethtool_eee_10108 tx_lpi_timer ethtool_eee 0 10108 NULL
+disable_so_cpumask_clear_cpu_fndecl_10109 cpumask_clear_cpu fndecl 1 10109 NULL
+disable_so_apply_time_iwl_hs20_roc_req_10117 apply_time iwl_hs20_roc_req 0 10117 NULL
+disable_so_pos2min_hash_fndecl_10123 pos2min_hash fndecl 0-2 10123 NULL
+disable_so_mode_mask_ath_gen_timer_configuration_10124 mode_mask ath_gen_timer_configuration 0 10124 NULL
+disable_so_del_timer_sync_fndecl_10133 del_timer_sync fndecl 0 10133 NULL
+disable_so_res_toss_time_dlm_rsb_10135 res_toss_time dlm_rsb 0 10135 NULL nohasharray
+disable_so_vblank___fb_timings_10135 vblank __fb_timings 0 10135 &disable_so_res_toss_time_dlm_rsb_10135
+disable_so_phase_seg1_can_bittiming_10141 phase_seg1 can_bittiming 0 10141 NULL
+disable_so_fixed_mtrr_seg_end_range_index_fndecl_10143 fixed_mtrr_seg_end_range_index fndecl 0 10143 NULL
+disable_so_xgene_enet_set_mac_address_fndecl_10148 xgene_enet_set_mac_address fndecl 0 10148 NULL
+disable_so_rtl_rfreg_delay_fndecl_10149 rtl_rfreg_delay fndecl 3-5 10149 NULL
+disable_so_channel_of_freq_fndecl_10152 channel_of_freq fndecl 0-1 10152 NULL nohasharray
+disable_so_gpio_set_value_cansleep_fndecl_10152 gpio_set_value_cansleep fndecl 1-2 10152 &disable_so_channel_of_freq_fndecl_10152
+disable_so_em_sti_clocksource_read_fndecl_10153 em_sti_clocksource_read fndecl 0 10153 NULL
+disable_so_tc90522_sleep_fndecl_10162 tc90522_sleep fndecl 0 10162 NULL
+disable_so_discovery_timeout_mesh_path_10170 discovery_timeout mesh_path 0 10170 NULL
+disable_so_pcf8563_rtc_read_time_fndecl_10175 pcf8563_rtc_read_time fndecl 0 10175 NULL
+disable_so_ixgb_mc_addr_list_update_fndecl_10187 ixgb_mc_addr_list_update fndecl 3 10187 NULL
+disable_so_rng_gen_random_rng_tfm_10199 rng_gen_random rng_tfm 3-0 10199 NULL
+disable_so_db_rec_addr_mlx4_qp_context_10204 db_rec_addr mlx4_qp_context 0 10204 NULL nohasharray
+disable_so_sgl_pg0_addr_lo_sgl_page_pairs_10204 sgl_pg0_addr_lo sgl_page_pairs 0 10204 &disable_so_db_rec_addr_mlx4_qp_context_10204
+disable_so_pgid_coda_in_hdr_10212 pgid coda_in_hdr 0 10212 NULL
+disable_so_xfs_btree_get_numrecs_fndecl_10214 xfs_btree_get_numrecs fndecl 0 10214 NULL
+disable_so_txLifetime_ConfigRid_10224 txLifetime ConfigRid 0 10224 NULL
+disable_so_active_time_dce8_wm_params_10231 active_time dce8_wm_params 0 10231 NULL
+disable_so_spi_imx_clkdiv_1_fndecl_10237 spi_imx_clkdiv_1 fndecl 1-2 10237 NULL
+disable_so_vlv_force_gfx_clock_fndecl_10238 vlv_force_gfx_clock fndecl 0 10238 NULL
+disable_so_prism54_get_freq_fndecl_10256 prism54_get_freq fndecl 0 10256 NULL
+disable_so_ath6kl_wmi_disctimeout_cmd_fndecl_10259 ath6kl_wmi_disctimeout_cmd fndecl 2-0 10259 NULL
+disable_so_dma_addr_snd_pcm_runtime_10260 dma_addr snd_pcm_runtime 0 10260 NULL
+disable_so_p7_mt9t112_pll_divider_10261 p7 mt9t112_pll_divider 0 10261 NULL
+disable_so_start_pid_timer_list_10264 start_pid timer_list 0 10264 NULL
+disable_so_gateway_ctrl_address_wil_fw_record_gateway_data_10268 gateway_ctrl_address wil_fw_record_gateway_data 0 10268 NULL
+disable_so_btree_insert128_fndecl_10277 btree_insert128 fndecl 2-3-5 10277 NULL
+disable_so_i_dtime_ext2_inode_info_10287 i_dtime ext2_inode_info 0 10287 NULL
+disable_so_mcryptd_hash_init_fndecl_10290 mcryptd_hash_init fndecl 2 10290 NULL
+disable_so_freq_bfa_diag_ledtest_s_10293 freq bfa_diag_ledtest_s 0 10293 NULL
+disable_so_TSS_sha1_fndecl_10297 TSS_sha1 fndecl 2 10297 NULL
+disable_so_ccp_aes_cmac_init_fndecl_10298 ccp_aes_cmac_init fndecl 0 10298 NULL
+disable_so_fc_fcp_timer_set_fndecl_10312 fc_fcp_timer_set fndecl 2 10312 NULL
+disable_so_blkcipher_walk_next_fndecl_10321 blkcipher_walk_next fndecl 0 10321 NULL
+disable_so_pwm_clock_nvkm_therm_10336 pwm_clock nvkm_therm 2-0 10336 NULL nohasharray
+disable_so_ecryptfs_code_for_cipher_string_fndecl_10336 ecryptfs_code_for_cipher_string fndecl 2 10336 &disable_so_pwm_clock_nvkm_therm_10336
+disable_so_smc_wreg_amdgpu_device_10339 smc_wreg amdgpu_device 2-3 10339 NULL
+disable_so_symlink_hash_fndecl_10341 symlink_hash fndecl 1 10341 NULL
+disable_so_eax_smm_regs_10346 eax smm_regs 0 10346 NULL
+disable_so_sctp_setsockopt_nodelay_fndecl_10349 sctp_setsockopt_nodelay fndecl 0-3 10349 NULL
+disable_so_min_vdisktime_cfq_rb_root_10355 min_vdisktime cfq_rb_root 0 10355 NULL
+disable_so_address_lo_msi_msg_10356 address_lo msi_msg 0 10356 NULL
+disable_so_unmapped_addr_srp_map_state_10359 unmapped_addr srp_map_state 0 10359 NULL
+disable_so_buff_addr_ixgb_tx_desc_10366 buff_addr ixgb_tx_desc 0 10366 NULL
+disable_so_i_ctime_sysv_inode_10368 i_ctime sysv_inode 0 10368 NULL
+disable_so_avg_signal_local_info_10389 avg_signal local_info 0 10389 NULL
+disable_so_sctp_bind_addrs_to_raw_fndecl_10390 sctp_bind_addrs_to_raw fndecl 3 10390 NULL
+disable_so_xfs_btree_reada_bufs_fndecl_10403 xfs_btree_reada_bufs fndecl 2-3-4 10403 NULL
+disable_so_cx_tss_segment_16_10404 cx tss_segment_16 0 10404 NULL
+disable_so_cryptd_hash_update_enqueue_fndecl_10406 cryptd_hash_update_enqueue fndecl 0 10406 NULL
+disable_so_log2sharesize_adfs_discrecord_10408 log2sharesize adfs_discrecord 0 10408 NULL
+disable_so_eqaddr_csio_eq_params_10412 eqaddr csio_eq_params 0 10412 NULL
+disable_so_dad_probes_inet6_ifaddr_10417 dad_probes inet6_ifaddr 0 10417 NULL
+disable_so_ath5k_iowrite32_fndecl_10429 ath5k_iowrite32 fndecl 2 10429 NULL
+disable_so_timeout_proto_10448 timeout proto 0 10448 NULL
+disable_so_recycle_rx_buf_fndecl_10456 recycle_rx_buf fndecl 3 10456 NULL
+disable_so_zero_scatter_daddr_isci_request_10458 zero_scatter_daddr isci_request 0 10458 NULL nohasharray
+disable_so_cryptd_hash_digest_enqueue_fndecl_10458 cryptd_hash_digest_enqueue fndecl 0 10458 &disable_so_zero_scatter_daddr_isci_request_10458
+disable_so_snd_pcm_hw_rule_muldivk_fndecl_10469 snd_pcm_hw_rule_muldivk fndecl 0 10469 NULL
+disable_so_nilfs_btree_assign_fndecl_10473 nilfs_btree_assign fndecl 0-3 10473 NULL
+disable_so_base_addr_ce_space_unaligned_ath10k_ce_ring_10487 base_addr_ce_space_unaligned ath10k_ce_ring 0 10487 NULL
+disable_so_bch_btree_map_leaf_nodes_fndecl_10499 bch_btree_map_leaf_nodes fndecl 0 10499 NULL
+disable_so_periods_snd_pcm_oss_runtime_10500 periods snd_pcm_oss_runtime 0 10500 NULL
+disable_so_uvc_video_clock_decode_fndecl_10502 uvc_video_clock_decode fndecl 4 10502 NULL
+disable_so_t3timer_ax25_info_struct_10512 t3timer ax25_info_struct 0 10512 NULL
+disable_so_sq_page_table_addr_hi_iscsi_kwqe_conn_offload1_10520 sq_page_table_addr_hi iscsi_kwqe_conn_offload1 0 10520 NULL
+disable_so_phys_addr_nx_host_sds_ring_10525 phys_addr nx_host_sds_ring 0 10525 NULL nohasharray
+disable_so_current_pixclock_sis_video_info_10525 current_pixclock sis_video_info 0 10525 &disable_so_phys_addr_nx_host_sds_ring_10525
+disable_so_ccp_aes_crypt_fndecl_10531 ccp_aes_crypt fndecl 0 10531 NULL
+disable_so_clock_speed_MGSL_PARAMS32_10537 clock_speed MGSL_PARAMS32 0 10537 NULL
+disable_so_sense_paddr_gdth_cmndinfo_10539 sense_paddr gdth_cmndinfo 0 10539 NULL
+disable_so_lasttime_batadv_bla_claim_10544 lasttime batadv_bla_claim 0 10544 NULL
+disable_so_tv_sec_timespec_10551 tv_sec timespec 0 10551 NULL
+disable_so_cmb_tx_timer_atl1_hw_10553 cmb_tx_timer atl1_hw 0 10553 NULL nohasharray
+disable_so_bm_bit_to_page_idx_fndecl_10553 bm_bit_to_page_idx fndecl 0-2 10553 &disable_so_cmb_tx_timer_atl1_hw_10553
+disable_so_xfs_btree_read_buf_block_fndecl_10555 xfs_btree_read_buf_block fndecl 0 10555 NULL
+disable_so_hash_dx_hash_info_10563 hash dx_hash_info 0 10563 NULL
+disable_so_be16_to_cpu_n_fndecl_10566 be16_to_cpu_n fndecl 3 10566 NULL nohasharray
+disable_so_ip_vs_bind_scheduler_fndecl_10566 ip_vs_bind_scheduler fndecl 0 10566 &disable_so_be16_to_cpu_n_fndecl_10566
+disable_so_di_ctime_gfs2_dinode_10570 di_ctime gfs2_dinode 0 10570 NULL
+disable_so_adjust_tsc_offset_kvm_x86_ops_10575 adjust_tsc_offset kvm_x86_ops 2 10575 NULL
+disable_so_num_timeout_request_sock_10577 num_timeout request_sock 0 10577 NULL
+disable_so___const_udelay_fndecl_10578 __const_udelay fndecl 1 10578 NULL
+disable_so_wsm_ba_timeout_indication_fndecl_10580 wsm_ba_timeout_indication fndecl 0 10580 NULL
+disable_so_tsc_connect_fndecl_10581 tsc_connect fndecl 0 10581 NULL
+disable_so_recover_ata_timing_10582 recover ata_timing 0 10582 NULL
+disable_so_addr_sch56xx_watchdog_data_10589 addr sch56xx_watchdog_data 0 10589 NULL
+disable_so_phys_proc_id_cpuinfo_x86_10590 phys_proc_id cpuinfo_x86 0 10590 NULL
+disable_so_gtime_signal_struct_10597 gtime signal_struct 0 10597 NULL
+disable_so_clk_radeon_clock_voltage_dependency_entry_10605 clk radeon_clock_voltage_dependency_entry 0 10605 NULL
+disable_so___oprofile_hrtimer_stop_fndecl_10609 __oprofile_hrtimer_stop fndecl 1 10609 NULL
+disable_so_psched_get_time_fndecl_10619 psched_get_time fndecl 0 10619 NULL
+disable_so_min_sleep_time_f2fs_gc_kthread_10623 min_sleep_time f2fs_gc_kthread 0 10623 NULL
+disable_so_runtime_cfs_bandwidth_10624 runtime cfs_bandwidth 0 10624 NULL
+disable_so_parse_timing_property_fndecl_10626 parse_timing_property fndecl 0 10626 NULL
+disable_so_scan_bitmap_block_fndecl_10627 scan_bitmap_block fndecl 0-2-4-6 10627 NULL
+disable_so_e1000e_pm_runtime_resume_fndecl_10638 e1000e_pm_runtime_resume fndecl 0 10638 NULL
+disable_so_spi_nor_read_dummy_cycles_fndecl_10639 spi_nor_read_dummy_cycles fndecl 0 10639 NULL nohasharray
+disable_so_sha_finish_walk_fndecl_10639 sha_finish_walk fndecl 0 10639 &disable_so_spi_nor_read_dummy_cycles_fndecl_10639
+disable_so_address_gsm_mux_10640 address gsm_mux 0 10640 NULL
+disable_so__rtl92ee_phy_calculate_bit_shift_fndecl_10643 _rtl92ee_phy_calculate_bit_shift fndecl 0-1 10643 NULL
+disable_so_lasttime_batadv_bla_backbone_gw_10651 lasttime batadv_bla_backbone_gw 0 10651 NULL
+disable_so_addr___crb_10654 addr __crb 0 10654 NULL
+disable_so_stv0297_set_tv_freq_fndecl_10665 stv0297_set_tv_freq fndecl 2 10665 NULL
+disable_so_txlo_dma_addr_typhoon_10667 txlo_dma_addr typhoon 0 10667 NULL
+disable_so_ip_vs_dh_hashkey_fndecl_10670 ip_vs_dh_hashkey fndecl 1 10670 NULL
+disable_so_setup_clocks_ufs_hba_variant_ops_10681 setup_clocks ufs_hba_variant_ops 0 10681 NULL
+disable_so_decode_attr_time_access_fndecl_10682 decode_attr_time_access fndecl 0 10682 NULL
+disable_so_pci_back_from_sleep_fndecl_10685 pci_back_from_sleep fndecl 0 10685 NULL
+disable_so_ath9k_hw_init_macaddr_fndecl_10686 ath9k_hw_init_macaddr fndecl 0 10686 NULL nohasharray
+disable_so_dma_buffer_atmel_runtime_data_10686 dma_buffer atmel_runtime_data 0 10686 &disable_so_ath9k_hw_init_macaddr_fndecl_10686
+disable_so_timer_resolution_snd_pcm_runtime_10688 timer_resolution snd_pcm_runtime 0 10688 NULL
+disable_so_snd_pcm_hw_rule_mul_fndecl_10689 snd_pcm_hw_rule_mul fndecl 0 10689 NULL
+disable_so_subdivision_snd_pcm_oss_runtime_10697 subdivision snd_pcm_oss_runtime 0 10697 NULL
+disable_so_split_huge_page_address_fndecl_10699 split_huge_page_address fndecl 2 10699 NULL
+disable_so_bound_dev_if_rdma_dev_addr_10707 bound_dev_if rdma_dev_addr 0 10707 NULL
+disable_so_gyro_3d_adjust_channel_bit_mask_fndecl_10717 gyro_3d_adjust_channel_bit_mask fndecl 3 10717 NULL
+disable_so_ahash_prepare_alg_fndecl_10721 ahash_prepare_alg fndecl 0 10721 NULL
+disable_so_st_mtime_sec_p9_stat_dotl_10725 st_mtime_sec p9_stat_dotl 0 10725 NULL
+disable_so_num_timings_display_timings_10728 num_timings display_timings 0 10728 NULL
+disable_so_clock_rq_10733 clock rq 0 10733 NULL
+disable_so_sys_signalfd_fndecl_10740 sys_signalfd fndecl 0 10740 NULL
+disable_so_last_tick_time_esas2r_adapter_10742 last_tick_time esas2r_adapter 0 10742 NULL
+disable_so_low_addr_msgbuf_buf_addr_10746 low_addr msgbuf_buf_addr 0 10746 NULL
+disable_so_mlx4_ib_invalidate_all_guid_record_fndecl_10755 mlx4_ib_invalidate_all_guid_record fndecl 2 10755 NULL
+disable_so_crypto_gcm_verify_fndecl_10762 crypto_gcm_verify fndecl 0 10762 NULL
+disable_so_devt_from_partuuid_fndecl_10763 devt_from_partuuid fndecl 0 10763 NULL nohasharray
+disable_so_demod_address_or51132_config_10763 demod_address or51132_config 0 10763 &disable_so_devt_from_partuuid_fndecl_10763
+disable_so_rv770_program_interrupt_vectors_fndecl_10768 rv770_program_interrupt_vectors fndecl 0 10768 NULL
+disable_so_i915_mutex_lock_interruptible_fndecl_10777 i915_mutex_lock_interruptible fndecl 0 10777 NULL
+disable_so_addr_il3945_tfd_tb_10790 addr il3945_tfd_tb 0 10790 NULL
+disable_so_pr_gid_elf_prpsinfo_10803 pr_gid elf_prpsinfo 0 10803 NULL
+disable_so_ism2_runtime_sc_10805 ism2 runtime_sc 0 10805 NULL
+disable_so_sumo_get_sleep_divider_id_from_clock_fndecl_10823 sumo_get_sleep_divider_id_from_clock fndecl 2-0 10823 NULL nohasharray
+disable_so_consumer_index_phys_addr_lo_megasas_init_queue_info_10823 consumer_index_phys_addr_lo megasas_init_queue_info 0 10823 &disable_so_sumo_get_sleep_divider_id_from_clock_fndecl_10823
+disable_so__mv88e6xxx_reg_write_fndecl_10825 _mv88e6xxx_reg_write fndecl 0-2-3-4 10825 NULL
+disable_so_flush_timeout_ath_chanctx_10828 flush_timeout ath_chanctx 0 10828 NULL nohasharray
+disable_so_rxaddr_starfire_rx_desc_10828 rxaddr starfire_rx_desc 0 10828 &disable_so_flush_timeout_ath_chanctx_10828 nohasharray
+disable_so_nla_get_u64_fndecl_10828 nla_get_u64 fndecl 0 10828 &disable_so_rxaddr_starfire_rx_desc_10828
+disable_so_r600_get_gpu_clock_counter_fndecl_10836 r600_get_gpu_clock_counter fndecl 0 10836 NULL
+disable_so_sys_timer_settime_fndecl_10837 sys_timer_settime fndecl 1 10837 NULL
+disable_so_cmp_next_hrtimer_event_fndecl_10846 cmp_next_hrtimer_event fndecl 0-1-2 10846 NULL
+disable_so_ac97_clock_via82xx_10850 ac97_clock via82xx 0 10850 NULL
+disable_so_ageing_timer_value___fdb_entry_10853 ageing_timer_value __fdb_entry 0 10853 NULL
+disable_so_dv_timings_cap_v4l2_subdev_pad_ops_10860 dv_timings_cap v4l2_subdev_pad_ops 0 10860 NULL
+disable_so_cpufreq_get_global_kobject_fndecl_10881 cpufreq_get_global_kobject fndecl 0 10881 NULL
+disable_so_freq_ath5k_rate_pcal_info_10883 freq ath5k_rate_pcal_info 0 10883 NULL
+disable_so_shm_ctime_shmid64_ds_10884 shm_ctime shmid64_ds 0 10884 NULL nohasharray
+disable_so_mt2050_set_if_freq_fndecl_10884 mt2050_set_if_freq fndecl 2 10884 &disable_so_shm_ctime_shmid64_ds_10884
+disable_so_d_itimer_xfs_disk_dquot_10893 d_itimer xfs_disk_dquot 0 10893 NULL nohasharray
+disable_so_saddr_irda_sock_10893 saddr irda_sock 0 10893 &disable_so_d_itimer_xfs_disk_dquot_10893
+disable_so_doorbell_preserve_vardecl_pcc_cpufreq_c_10898 doorbell_preserve vardecl_pcc-cpufreq.c 0 10898 NULL
+disable_so_signal_nr_nvkm_perfdom_10899 signal_nr nvkm_perfdom 0 10899 NULL
+disable_so_cg_spll_func_cntl_2_ni_clock_registers_10900 cg_spll_func_cntl_2 ni_clock_registers 0 10900 NULL
+disable_so_ac_utime_acct_v3_10901 ac_utime acct_v3 0 10901 NULL
+disable_so_mclk_prediv_cs42l56_private_10907 mclk_prediv cs42l56_private 0 10907 NULL
+disable_so_SYSC_mq_timedreceive_fndecl_10921 SYSC_mq_timedreceive fndecl 1-3 10921 NULL
+disable_so_vpm_write_address_fndecl_10930 vpm_write_address fndecl 2 10930 NULL
+disable_so_i_iw_freq_10939 i iw_freq 0 10939 NULL nohasharray
+disable_so_ia32_tsc_adjust_msr_kvm_vcpu_arch_10939 ia32_tsc_adjust_msr kvm_vcpu_arch 0 10939 &disable_so_i_iw_freq_10939
+disable_so_rv3029c2_i2c_read_time_fndecl_10942 rv3029c2_i2c_read_time fndecl 0 10942 NULL nohasharray
+disable_so_txok_interrupt_mask_ath_hw_10942 txok_interrupt_mask ath_hw 0 10942 &disable_so_rv3029c2_i2c_read_time_fndecl_10942
+disable_so_err_time_ip6_tnl_10945 err_time ip6_tnl 0 10945 NULL
+disable_so_free_nodes_hfs_btree_10954 free_nodes hfs_btree 0 10954 NULL
+disable_so_dwell_time_delta_per_probe_conf_sched_scan_settings_10955 dwell_time_delta_per_probe conf_sched_scan_settings 0 10955 NULL
+disable_so_blkcipher_walk_virt_block_fndecl_10958 blkcipher_walk_virt_block fndecl 0-3 10958 NULL
+disable_so_bnx2x_change_mac_addr_fndecl_10964 bnx2x_change_mac_addr fndecl 0 10964 NULL
+disable_so_sh_tmu_clocksource_enable_fndecl_10968 sh_tmu_clocksource_enable fndecl 0 10968 NULL
+disable_so_pdiv_b43_phy_lp_10974 pdiv b43_phy_lp 0 10974 NULL
+disable_so_br2684_mac_addr_fndecl_10977 br2684_mac_addr fndecl 0 10977 NULL
+disable_so___hrtimer_init_fndecl_10979 __hrtimer_init fndecl 2 10979 NULL
+disable_so_cisco_timer_fndecl_10984 cisco_timer fndecl 1 10984 NULL
+disable_so_desc_address_fndecl_10998 desc_address fndecl 2-3 10998 NULL
+disable_so_padlock_sha256_update_nano_fndecl_11008 padlock_sha256_update_nano fndecl 3 11008 NULL
+disable_so_end_addr_gen_pool_chunk_11013 end_addr gen_pool_chunk 0 11013 NULL
+disable_so_bitmap_file_set_bit_fndecl_11015 bitmap_file_set_bit fndecl 2 11015 NULL
+disable_so_em28xx_write_reg_fndecl_11020 em28xx_write_reg fndecl 2-0-3 11020 NULL
+disable_so_ocfs2_info_freefrag_scan_bitmap_fndecl_11032 ocfs2_info_freefrag_scan_bitmap fndecl 0-3 11032 NULL
+disable_so_xen_teardown_timer_fndecl_11036 xen_teardown_timer fndecl 1 11036 NULL
+disable_so_get_physaddr_fm_api_fndecl_11037 get_physaddr_fm_api fndecl 0 11037 NULL
+disable_so_nfs_direct_read_schedule_iovec_fndecl_11039 nfs_direct_read_schedule_iovec fndecl 0-3 11039 NULL
+disable_so_ocfs2_group_bitmap_size_fndecl_11043 ocfs2_group_bitmap_size fndecl 0 11043 NULL
+disable_so_hsw_pcm_runtime_suspend_fndecl_11046 hsw_pcm_runtime_suspend fndecl 0 11046 NULL
+disable_so_bi_start_gfs2_bitmap_11049 bi_start gfs2_bitmap 0 11049 NULL
+disable_so_src_addr_hi_dmae_command_11052 src_addr_hi dmae_command 0 11052 NULL
+disable_so_lsb_bna_dma_addr_11059 lsb bna_dma_addr 0 11059 NULL
+disable_so_cb_s5p_jpeg_addr_11062 cb s5p_jpeg_addr 0 11062 NULL
+disable_so_plink_timeout_sta_info_11094 plink_timeout sta_info 0 11094 NULL
+disable_so_crypto_blkcipher_set_iv_fndecl_11098 crypto_blkcipher_set_iv fndecl 3 11098 NULL
+disable_so_custom_divisor_mxser_port_11109 custom_divisor mxser_port 0 11109 NULL
+disable_so_raw_cell_paddr_idt77252_dev_11112 raw_cell_paddr idt77252_dev 0 11112 NULL
+disable_so_acpi_lpss_runtime_suspend_fndecl_11116 acpi_lpss_runtime_suspend fndecl 0 11116 NULL nohasharray
+disable_so_addr_creg_cmd_11116 addr creg_cmd 0 11116 &disable_so_acpi_lpss_runtime_suspend_fndecl_11116
+disable_so_dev_type_rdma_dev_addr_11123 dev_type rdma_dev_addr 0 11123 NULL
+disable_so_signal_hermes_rx_descriptor_11147 signal hermes_rx_descriptor 0 11147 NULL
+disable_so_phys_addr_nx_host_rds_ring_11168 phys_addr nx_host_rds_ring 0 11168 NULL
+disable_so_addr1_de_desc_11170 addr1 de_desc 0 11170 NULL nohasharray
+disable_so_ci_populate_mc_reg_addresses_fndecl_11170 ci_populate_mc_reg_addresses fndecl 0 11170 &disable_so_addr1_de_desc_11170
+disable_so_addr__ioeventfd_11180 addr _ioeventfd 0 11180 NULL
+disable_so_vx_change_frequency_fndecl_11184 vx_change_frequency fndecl 0 11184 NULL
+disable_so_unbind_from_irq_fndecl_11196 unbind_from_irq fndecl 1 11196 NULL
+disable_so_wext_cipher2level_fndecl_11197 wext_cipher2level fndecl 1 11197 NULL
+disable_so_demod_address_cx24117_priv_11199 demod_address cx24117_priv 0 11199 NULL
+disable_so_local_pkt_addr_dle_11206 local_pkt_addr dle 0 11206 NULL
+disable_so_timewarn_cs_write_fndecl_11208 timewarn_cs_write fndecl 3-0 11208 NULL nohasharray
+disable_so_prescale__pll_div_11208 prescale _pll_div 0 11208 &disable_so_timewarn_cs_write_fndecl_11208
+disable_so_i2400m_read_mac_addr_fndecl_11209 i2400m_read_mac_addr fndecl 0 11209 NULL
+disable_so__drbd_bm_find_next_zero_fndecl_11228 _drbd_bm_find_next_zero fndecl 0-2 11228 NULL
+disable_so_printfbuf_aac_init_11236 printfbuf aac_init 0 11236 NULL nohasharray
+disable_so_crypto_ablkcipher_ctxsize_fndecl_11236 crypto_ablkcipher_ctxsize fndecl 0 11236 &disable_so_printfbuf_aac_init_11236
+disable_so_k__pll_div_11239 k _pll_div 0 11239 NULL
+disable_so_qdiv_ratio_skl_wrpll_params_11242 qdiv_ratio skl_wrpll_params 0 11242 NULL
+disable_so_dma_addr___vxge_hw_fifo_txdl_priv_11244 dma_addr __vxge_hw_fifo_txdl_priv 0 11244 NULL
+disable_so_urandom_read_fndecl_11245 urandom_read fndecl 0-3 11245 NULL
+disable_so_crypto_notify_fndecl_11249 crypto_notify fndecl 1 11249 NULL
+disable_so_sd_gid_stat_data_v1_11250 sd_gid stat_data_v1 0 11250 NULL
+disable_so_xlog_find_cycle_start_fndecl_11263 xlog_find_cycle_start fndecl 0-3 11263 NULL
+disable_so_unbind_from_irqhandler_fndecl_11274 unbind_from_irqhandler fndecl 1 11274 NULL
+disable_so_ref_divider_panel_info_11279 ref_divider panel_info 0 11279 NULL nohasharray
+disable_so_nfs_wait_bit_killable_fndecl_11279 nfs_wait_bit_killable fndecl 0 11279 &disable_so_ref_divider_panel_info_11279
+disable_so_freq_p54_scan_head_11280 freq p54_scan_head 0 11280 NULL
+disable_so_it_overrun_k_itimer_11284 it_overrun k_itimer 0 11284 NULL
+disable_so_txbd_addr_lo_host_cmd_ds_pcie_details_11288 txbd_addr_lo host_cmd_ds_pcie_details 0 11288 NULL
+disable_so_calc_baud_divisor_fndecl_11290 calc_baud_divisor fndecl 0-1 11290 NULL
+disable_so_hash_net6_expire_fndecl_11296 hash_net6_expire fndecl 4 11296 NULL
+disable_so_ax25_addr_build_fndecl_11299 ax25_addr_build fndecl 0 11299 NULL
+disable_so_vnic_dev_del_addr_fndecl_11303 vnic_dev_del_addr fndecl 0 11303 NULL
+disable_so_wrmsrl_safe_fndecl_11305 wrmsrl_safe fndecl 0-2 11305 NULL
+disable_so_jiffies_last_vardecl_intel_powerclamp_c_11307 jiffies_last vardecl_intel_powerclamp.c 0 11307 NULL
+disable_so_mmc_select_timing_fndecl_11311 mmc_select_timing fndecl 0 11311 NULL
+disable_so_crypto_cbc_encrypt_inplace_fndecl_11315 crypto_cbc_encrypt_inplace fndecl 0 11315 NULL
+disable_so_cma_translate_addr_fndecl_11326 cma_translate_addr fndecl 0 11326 NULL
+disable_so_period_bytes_snd_pcm_oss_runtime_11332 period_bytes snd_pcm_oss_runtime 0 11332 NULL
+disable_so_board_addr_ath6kl_hw_11334 board_addr ath6kl_hw 0 11334 NULL
+disable_so_shash_ahash_mcryptd_digest_fndecl_11335 shash_ahash_mcryptd_digest fndecl 0 11335 NULL
+disable_so_crypto_gcm_encrypt_fndecl_11338 crypto_gcm_encrypt fndecl 0 11338 NULL
+disable_so_btrfs_wq_run_delayed_node_fndecl_11342 btrfs_wq_run_delayed_node fndecl 0 11342 NULL
+disable_so_pch_udc_ep_bit_clr_fndecl_11345 pch_udc_ep_bit_clr fndecl 3 11345 NULL nohasharray
+enable_so_rcv_tsecr_tcp_options_received_11345 rcv_tsecr tcp_options_received 0 11345 &disable_so_pch_udc_ep_bit_clr_fndecl_11345
+disable_so_bin_uuid_fndecl_11348 bin_uuid fndecl 3-0 11348 NULL
+disable_so_offset_to_bitmap_fndecl_11359 offset_to_bitmap fndecl 0-2 11359 NULL
+disable_so_default_tv_freq_vardecl_pvrusb2_hdw_c_11362 default_tv_freq vardecl_pvrusb2-hdw.c 0 11362 NULL
+disable_so_SiS_SetReg_fndecl_11366 SiS_SetReg fndecl 1-3 11366 NULL
+disable_so_sec_btrfs_ioctl_timespec_11375 sec btrfs_ioctl_timespec 0 11375 NULL
+disable_so_dn_nl_newaddr_fndecl_11380 dn_nl_newaddr fndecl 0 11380 NULL
+disable_so_DAC1064_calcclock_fndecl_11385 DAC1064_calcclock fndecl 1-2 11385 NULL
+disable_so_trinity_set_divider_value_fndecl_11387 trinity_set_divider_value fndecl 3 11387 NULL
+disable_so_ac_utime_taskstats_11391 ac_utime taskstats 0 11391 NULL nohasharray
+disable_so_zd_iowrite32_locked_fndecl_11391 zd_iowrite32_locked fndecl 0-2 11391 &disable_so_ac_utime_taskstats_11391
+disable_so_crypto_rfc4309_setkey_fndecl_11398 crypto_rfc4309_setkey fndecl 0-3 11398 NULL
+disable_so_lvb_igid_ocfs2_meta_lvb_11400 lvb_igid ocfs2_meta_lvb 0 11400 NULL nohasharray
+disable_so_buffer_list_dma_addr_mgsl_struct_11400 buffer_list_dma_addr mgsl_struct 0 11400 &disable_so_lvb_igid_ocfs2_meta_lvb_11400
+disable_so_si_pmu_fast_pwrup_delay_fndecl_11409 si_pmu_fast_pwrup_delay fndecl 0 11409 NULL
+disable_so_tps6586x_rtc_read_time_fndecl_11415 tps6586x_rtc_read_time fndecl 0 11415 NULL
+disable_so_hash_rem_ccp_sha_req_ctx_11427 hash_rem ccp_sha_req_ctx 0 11427 NULL
+disable_so_phys_addr_udc_11429 phys_addr udc 0 11429 NULL
+disable_so_center_freq2_cfg80211_chan_def_11433 center_freq2 cfg80211_chan_def 0 11433 NULL
+disable_so_lock_btree_op_11443 lock btree_op 0 11443 NULL
+disable_so_freq_mt7601u_freq_cal_11461 freq mt7601u_freq_cal 0 11461 NULL
+disable_so_pm860x_reg_write_fndecl_11462 pm860x_reg_write fndecl 0-2-3 11462 NULL
+disable_so_crypto_hash_walk_first_fndecl_11464 crypto_hash_walk_first fndecl 0 11464 NULL
+disable_so_mlx4_ib_init_alias_guid_work_fndecl_11465 mlx4_ib_init_alias_guid_work fndecl 2 11465 NULL
+disable_so_uid_fuse_attr_11471 uid fuse_attr 0 11471 NULL nohasharray
+disable_so_l2addrsize_fndecl_11471 l2addrsize fndecl 0 11471 &disable_so_uid_fuse_attr_11471
+disable_so_snprintf_fndecl_11478 snprintf fndecl 0-2 11478 NULL
+disable_so_ath9k_hw_set_ack_timeout_fndecl_11491 ath9k_hw_set_ack_timeout fndecl 2 11491 NULL
+disable_so_eq_delay_to_mult_fndecl_11493 eq_delay_to_mult fndecl 0-1 11493 NULL
+disable_so_bit_length_acpi_object_field_common_11503 bit_length acpi_object_field_common 0 11503 NULL
+disable_so_di_mtime_qnx6_inode_entry_11506 di_mtime qnx6_inode_entry 0 11506 NULL
+disable_so_prism54_set_freq_fndecl_11509 prism54_set_freq fndecl 0 11509 NULL
+disable_so_resp_bd_list_addr_lo_bnx2i_text_request_11511 resp_bd_list_addr_lo bnx2i_text_request 0 11511 NULL
+disable_so_gid_ipc64_perm_11519 gid ipc64_perm 0 11519 NULL
+disable_so_offset_delta_bnx2x_func_set_timesync_params_11542 offset_delta bnx2x_func_set_timesync_params 0 11542 NULL
+disable_so_local_clock_us_fndecl_11549 local_clock_us fndecl 0 11549 NULL
+disable_so_seq_tnl_ptk_info_11554 seq tnl_ptk_info 0 11554 NULL
+disable_so_carl9170_set_freq_cal_data_fndecl_11578 carl9170_set_freq_cal_data fndecl 0 11578 NULL
+disable_so_pmcraid_enable_interrupts_fndecl_11580 pmcraid_enable_interrupts fndecl 2 11580 NULL nohasharray
+disable_so_get_free_region_mtrr_ops_11580 get_free_region mtrr_ops 1-2 11580 &disable_so_pmcraid_enable_interrupts_fndecl_11580
+disable_so_mclkdiv2_cs42l52_clk_para_11588 mclkdiv2 cs42l52_clk_para 0 11588 NULL
+disable_so_secid_netlbl_unlhsh_addr6_11595 secid netlbl_unlhsh_addr6 0 11595 NULL
+disable_so_opaque_hashval_fndecl_11605 opaque_hashval fndecl 2 11605 NULL
+disable_so_bcma_chipco_watchdog_get_max_timer_fndecl_11606 bcma_chipco_watchdog_get_max_timer fndecl 0 11606 NULL
+disable_so_security_settime_fndecl_11608 security_settime fndecl 0 11608 NULL
+disable_so_hash_tomoyo_path_info_11611 hash tomoyo_path_info 0 11611 NULL
+disable_so_sllc_family_sockaddr_llc_11612 sllc_family sockaddr_llc 0 11612 NULL
+disable_so_get_physaddr_from_sgc_fndecl_11613 get_physaddr_from_sgc fndecl 0 11613 NULL
+disable_so_compat_sock_get_timestampns_fndecl_11614 compat_sock_get_timestampns fndecl 0 11614 NULL
+disable_so_div2_pll_div_11630 div2 pll_div 0 11630 NULL
+disable_so_dot_gma_clock_t_11632 dot gma_clock_t 0 11632 NULL
+disable_so_addr_smsc47b397_data_11633 addr smsc47b397_data 0 11633 NULL nohasharray
+disable_so_cpufreq_power2state_fndecl_11633 cpufreq_power2state fndecl 3 11633 &disable_so_addr_smsc47b397_data_11633 nohasharray
+disable_so_cia_setkey_cipher_alg_11633 cia_setkey cipher_alg 0-3 11633 &disable_so_cpufreq_power2state_fndecl_11633
+disable_so_log2P_nvkm_pll_vals_11639 log2P nvkm_pll_vals 0 11639 NULL
+disable_so_timeout_tipc_subscription_11656 timeout tipc_subscription 0 11656 NULL
+disable_so_sem_addr_mm_dma_desc_11658 sem_addr mm_dma_desc 0 11658 NULL
+disable_so_adis16334_get_freq_fndecl_11667 adis16334_get_freq fndecl 0 11667 NULL
+disable_so_register_address_dif_settings_11668 register_address dif_settings 0 11668 NULL
+disable_so_cpufreq_p4_get_frequency_fndecl_11672 cpufreq_p4_get_frequency fndecl 0 11672 NULL
+disable_so_sysctl_tcp_keepalive_time_vardecl_11678 sysctl_tcp_keepalive_time vardecl 0 11678 NULL nohasharray
+disable_so_paddr_rsq_info_11678 paddr rsq_info 0 11678 &disable_so_sysctl_tcp_keepalive_time_vardecl_11678
+disable_so_gc_timer_show_fndecl_11691 gc_timer_show fndecl 0 11691 NULL
+disable_so_udp6_portaddr_hash_fndecl_11698 udp6_portaddr_hash fndecl 0-3 11698 NULL
+disable_so_ablkcipher_walk_done_fndecl_11708 ablkcipher_walk_done fndecl 0-3 11708 NULL
+disable_so_ahci_exec_polled_cmd_fndecl_11713 ahci_exec_polled_cmd fndecl 6-2-5 11713 NULL
+disable_so_fb_addr_drm_via_dmablit_11717 fb_addr drm_via_dmablit 0 11717 NULL
+disable_so_pci_bus_cx23885_dev_11720 pci_bus cx23885_dev 0 11720 NULL
+disable_so_spacing_v4l2_hw_freq_seek_11726 spacing v4l2_hw_freq_seek 0 11726 NULL
+disable_so_ncp_obtain_mtime_fndecl_11732 ncp_obtain_mtime fndecl 0 11732 NULL
+disable_so_timer_index_at_state_t_11751 timer_index at_state_t 0 11751 NULL nohasharray
+disable_so_sctp_copy_laddrs_fndecl_11751 sctp_copy_laddrs fndecl 2-4 11751 &disable_so_timer_index_at_state_t_11751
+disable_so_max_freq_omap_hsmmc_platform_data_11755 max_freq omap_hsmmc_platform_data 0 11755 NULL nohasharray
+disable_so_tcp_md5_do_add_fndecl_11755 tcp_md5_do_add fndecl 5-6 11755 &disable_so_max_freq_omap_hsmmc_platform_data_11755
+disable_so_iio_interrupt_trigger_driver_init_fndecl_11758 iio_interrupt_trigger_driver_init fndecl 0 11758 NULL nohasharray
+disable_so_iwl_dbgfs_sleep_level_override_write_fndecl_11758 iwl_dbgfs_sleep_level_override_write fndecl 0-3 11758 &disable_so_iio_interrupt_trigger_driver_init_fndecl_11758
+disable_so_ps_upsd_timeouts_read_fndecl_11759 ps_upsd_timeouts_read fndecl 3-0 11759 NULL nohasharray
+disable_so_bus_frequency_vardecl_i2c_kempld_c_11759 bus_frequency vardecl_i2c-kempld.c 0 11759 &disable_so_ps_upsd_timeouts_read_fndecl_11759
+disable_so_nm_uid_nl_mmap_hdr_11761 nm_uid nl_mmap_hdr 0 11761 NULL
+disable_so_s_wtime_ext3_super_block_11765 s_wtime ext3_super_block 0 11765 NULL
+disable_so_gr_fhash_fndecl_11768 gr_fhash fndecl 1-2 11768 NULL
+disable_so_orig_ax_pt_regs_11775 orig_ax pt_regs 0 11775 NULL
+disable_so_validate_scan_freqs_fndecl_11781 validate_scan_freqs fndecl 0 11781 NULL
+disable_so_sbq_addr_cqicb_11782 sbq_addr cqicb 0 11782 NULL nohasharray
+disable_so_irq_i2c_client_11782 irq i2c_client 0 11782 &disable_so_sbq_addr_cqicb_11782
+disable_so_ip_addr_rocker_neigh_tbl_entry_11785 ip_addr rocker_neigh_tbl_entry 0 11785 NULL
+disable_so_timestamp_mwifiex_bssdescriptor_11788 timestamp mwifiex_bssdescriptor 0 11788 NULL
+disable_so_bg_block_bitmap_ext3_group_desc_11791 bg_block_bitmap ext3_group_desc 0 11791 NULL
+disable_so_crystal_freq_saa711x_state_11797 crystal_freq saa711x_state 0 11797 NULL
+disable_so_dqb_itime_mem_dqblk_11799 dqb_itime mem_dqblk 0 11799 NULL nohasharray
+disable_so_get_journal_hash_dev_fndecl_11799 get_journal_hash_dev fndecl 3 11799 &disable_so_dqb_itime_mem_dqblk_11799
+disable_so_addr_domain_fndecl_11807 addr_domain fndecl 2 11807 NULL
+disable_so_get_time_window_fndecl_11808 get_time_window fndecl 0 11808 NULL
+disable_so_chargetime_isdn_net_local_s_11812 chargetime isdn_net_local_s 0 11812 NULL
+disable_so_sched_clock_local_fndecl_11817 sched_clock_local fndecl 0 11817 NULL
+disable_so_address_ehci_iso_stream_11822 address ehci_iso_stream 0 11822 NULL
+disable_so_simple_strtoul_fndecl_11835 simple_strtoul fndecl 0 11835 NULL
+disable_so_i9xx_get_aux_clock_divider_fndecl_11841 i9xx_get_aux_clock_divider fndecl 0 11841 NULL
+disable_so_emulator_set_msr_fndecl_11853 emulator_set_msr fndecl 3 11853 NULL
+disable_so_sst_module_runtime_alloc_blocks_fndecl_11854 sst_module_runtime_alloc_blocks fndecl 2-0 11854 NULL
+disable_so_msr_sum_desc_11862 msr sum_desc 0 11862 NULL
+disable_so_rs780_set_engine_clock_scaling_fndecl_11864 rs780_set_engine_clock_scaling fndecl 0 11864 NULL
+disable_so_write_file_regidx_fndecl_11870 write_file_regidx fndecl 3 11870 NULL
+disable_so_task_sched_runtime_fndecl_11884 task_sched_runtime fndecl 0 11884 NULL
+disable_so_hash_dst_fndecl_11898 hash_dst fndecl 0 11898 NULL
+disable_so_xtal_cap10p_r820t_freq_range_11904 xtal_cap10p r820t_freq_range 0 11904 NULL
+disable_so_ath6kl_cfg80211_deepsleep_resume_fndecl_11915 ath6kl_cfg80211_deepsleep_resume fndecl 0 11915 NULL
+disable_so_count_qce_sha_reqctx_11921 count qce_sha_reqctx 0 11921 NULL
+disable_so_hashlimit_mt_init_fndecl_11925 hashlimit_mt_init fndecl 0 11925 NULL
+disable_so_time_remaining_msec_TAG_TW_Lock_11931 time_remaining_msec TAG_TW_Lock 0 11931 NULL
+disable_so_extcpu_mce_11945 extcpu mce 0 11945 NULL
+disable_so_hci_bdaddr_list_add_fndecl_11954 hci_bdaddr_list_add fndecl 0 11954 NULL
+disable_so_task_list_pbl_addr_hi_fcoe_kwqe_init1_11965 task_list_pbl_addr_hi fcoe_kwqe_init1 0 11965 NULL
+disable_so_time_blocked_kvm_spinlock_stats_11970 time_blocked kvm_spinlock_stats 0 11970 NULL
+disable_so_mapaddr_c2_element_11974 mapaddr c2_element 0 11974 NULL
+disable_so_uwb_rc_mac_addr_show_fndecl_11979 uwb_rc_mac_addr_show fndecl 0 11979 NULL
+disable_so_ccp_run_rsa_cmd_fndecl_11983 ccp_run_rsa_cmd fndecl 0 11983 NULL
+disable_so_cc770_rtr_interrupt_fndecl_11989 cc770_rtr_interrupt fndecl 2 11989 NULL
+disable_so_bitmap_create_fndecl_12000 bitmap_create fndecl 2 12000 NULL
+disable_so_maximum_acpi_address64_attribute_12007 maximum acpi_address64_attribute 0 12007 NULL
+disable_so_i2c_addr_stv090x_internal_12008 i2c_addr stv090x_internal 0 12008 NULL
+disable_so_s_time_ptc_stats_12018 s_time ptc_stats 0 12018 NULL
+disable_so_disc_timeout_hci_conn_12021 disc_timeout hci_conn 0 12021 NULL
+disable_so_proc_dointvec_jiffies_fndecl_12024 proc_dointvec_jiffies fndecl 0 12024 NULL
+disable_so_wm8350_wdt_set_timeout_fndecl_12039 wm8350_wdt_set_timeout fndecl 2-0 12039 NULL
+disable_so_sys_geteuid16_fndecl_12045 sys_geteuid16 fndecl 0 12045 NULL
+disable_so_parse_strtoull_fndecl_12065 parse_strtoull fndecl 0 12065 NULL
+disable_so_bp_index_nilfs_btree_path_12067 bp_index nilfs_btree_path 0 12067 NULL
+disable_so_max_signal_ieee80211_hw_12078 max_signal ieee80211_hw 0 12078 NULL
+disable_so_rx_timeout_vardecl_men_z135_uart_c_12080 rx_timeout vardecl_men_z135_uart.c 0 12080 NULL
+disable_so_sws_timer_config_nes_adapter_12081 sws_timer_config nes_adapter 0 12081 NULL
+disable_so_ic_myaddr_vardecl_12088 ic_myaddr vardecl 0 12088 NULL
+disable_so_bitmap_ord_to_pos_fndecl_12108 bitmap_ord_to_pos fndecl 3-0 12108 NULL
+disable_so_debounce_jiffies_lp8727_chg_12115 debounce_jiffies lp8727_chg 0 12115 NULL
+disable_so_hashval1_2_rx_pkt_hdr1_12125 hashval1_2 rx_pkt_hdr1 0 12125 NULL
+disable_so_acpi_ut_divide_fndecl_12126 acpi_ut_divide fndecl 0-1-2 12126 NULL
+disable_so_irst_store_wakeup_time_fndecl_12127 irst_store_wakeup_time fndecl 0-4 12127 NULL
+disable_so_xfs_bmap_btree_to_extents_fndecl_12130 xfs_bmap_btree_to_extents fndecl 0 12130 NULL
+disable_so_addrconf_notify_fndecl_12132 addrconf_notify fndecl 0 12132 NULL
+disable_so_ath5k_beacon_update_timers_fndecl_12135 ath5k_beacon_update_timers fndecl 2 12135 NULL
+disable_so_pid_pppol2tpv3in6_addr_12136 pid pppol2tpv3in6_addr 0 12136 NULL
+disable_so__abb5zes3_rtc_set_timer_fndecl_12149 _abb5zes3_rtc_set_timer fndecl 0 12149 NULL
+disable_so_remote_ca_guid_ib_cm_req_event_param_12150 remote_ca_guid ib_cm_req_event_param 0 12150 NULL
+disable_so_grcan_reset_timer_fndecl_12158 grcan_reset_timer fndecl 2 12158 NULL
+disable_so_sctp_sockaddr_af_fndecl_12166 sctp_sockaddr_af fndecl 3 12166 NULL
+disable_so_di_ctime_efs_dinode_12170 di_ctime efs_dinode 0 12170 NULL
+disable_so_bitmap_fill_fndecl_12173 bitmap_fill fndecl 2 12173 NULL
+disable_so_clock_mga_i2c_chan_12185 clock mga_i2c_chan 0 12185 NULL
+disable_so_physaddr_pau_fpdu_frag_12193 physaddr pau_fpdu_frag 0 12193 NULL
+disable_so_adm9240_write_fan_div_fndecl_12196 adm9240_write_fan_div fndecl 3-2 12196 NULL
+disable_so_addr_privcmd_mmapbatch_v2_12199 addr privcmd_mmapbatch_v2 0 12199 NULL
+disable_so_start_freq_khz_ieee80211_freq_range_12202 start_freq_khz ieee80211_freq_range 0 12202 NULL nohasharray
+disable_so_total_ablkcipher_walk_12202 total ablkcipher_walk 0 12202 &disable_so_start_freq_khz_ieee80211_freq_range_12202
+disable_so_ktime_us_delta_fndecl_12204 ktime_us_delta fndecl 0 12204 NULL
+disable_so_hmark_addr_mask_fndecl_12206 hmark_addr_mask fndecl 1 12206 NULL
+disable_so_force_addr_vardecl_i2c_viapro_c_12216 force_addr vardecl_i2c-viapro.c 0 12216 NULL nohasharray
+disable_so_next_hash_dir_private_info_12216 next_hash dir_private_info 0 12216 &disable_so_force_addr_vardecl_i2c_viapro_c_12216
+disable_so_i40e_aq_mac_address_write_fndecl_12217 i40e_aq_mac_address_write fndecl 0 12217 NULL
+disable_so_sys_set_tid_address_fndecl_12219 sys_set_tid_address fndecl 0 12219 NULL
+disable_so_ebitmap_contains_fndecl_12231 ebitmap_contains fndecl 3 12231 NULL
+disable_so_bfa_timer_begin_fndecl_12232 bfa_timer_begin fndecl 5 12232 NULL
+disable_so_sst_hsw_dsp_runtime_resume_fndecl_12234 sst_hsw_dsp_runtime_resume fndecl 0 12234 NULL
+disable_so_crypto_rfc4543_encrypt_fndecl_12243 crypto_rfc4543_encrypt fndecl 0 12243 NULL
+disable_so_addr_ib_phys_buf_12245 addr ib_phys_buf 0 12245 NULL
+disable_so_rhashtable_jhash2_fndecl_12249 rhashtable_jhash2 fndecl 0 12249 NULL
+disable_so_highbit_ebitmap_12260 highbit ebitmap 0 12260 NULL
+disable_so_btrfs_run_delayed_items_fndecl_12263 btrfs_run_delayed_items fndecl 0 12263 NULL
+disable_so_security_task_setscheduler_fndecl_12267 security_task_setscheduler fndecl 0 12267 NULL
+disable_so_sense_phys_addr_megasas_cmd_fusion_12272 sense_phys_addr megasas_cmd_fusion 0 12272 NULL
+disable_so_devid_ptp_clock_12277 devid ptp_clock 0 12277 NULL
+disable_so_pwwn_bfa_bsg_rport_scsi_addr_s_12278 pwwn bfa_bsg_rport_scsi_addr_s 0 12278 NULL nohasharray
+disable_so_ihash_entries_vardecl_inode_c_12278 ihash_entries vardecl_inode.c 0 12278 &disable_so_pwwn_bfa_bsg_rport_scsi_addr_s_12278
+disable_so_gid_ncp_mount_data_12282 gid ncp_mount_data 0 12282 NULL
+disable_so_qla2x00_zio_timer_show_fndecl_12290 qla2x00_zio_timer_show fndecl 0 12290 NULL
+disable_so_mlx4_hca_core_clock_update_fndecl_12300 mlx4_hca_core_clock_update fndecl 0 12300 NULL
+disable_so_accel_3d_adjust_channel_bit_mask_fndecl_12308 accel_3d_adjust_channel_bit_mask fndecl 3 12308 NULL
+disable_so_dtt200u_fe_sleep_fndecl_12311 dtt200u_fe_sleep fndecl 0 12311 NULL
+disable_so_asix_read_phy_addr_fndecl_12320 asix_read_phy_addr fndecl 0 12320 NULL
+disable_so_viafb_load_reg_fndecl_12323 viafb_load_reg fndecl 1 12323 NULL nohasharray
+disable_so_bm_bits_drbd_bitmap_12323 bm_bits drbd_bitmap 0 12323 &disable_so_viafb_load_reg_fndecl_12323
+disable_so_ixgbe_write_mc_addr_list_fndecl_12325 ixgbe_write_mc_addr_list fndecl 0 12325 NULL
+disable_so_gid_max_xt_owner_match_info_12332 gid_max xt_owner_match_info 0 12332 NULL
+disable_so_duty_cycle_pwm_device_12334 duty_cycle pwm_device 0 12334 NULL
+disable_so_get_nohz_timer_target_fndecl_12336 get_nohz_timer_target fndecl 0 12336 NULL
+disable_so_pte_encode_i915_address_space_12340 pte_encode i915_address_space 0-1 12340 NULL
+disable_so_mdac_aic32x4_rate_divs_12367 mdac aic32x4_rate_divs 0 12367 NULL
+disable_so_tipc_media_addr_printf_fndecl_12368 tipc_media_addr_printf fndecl 2 12368 NULL
+disable_so_i_atime_ext3_inode_12370 i_atime ext3_inode 0 12370 NULL
+disable_so_bitmap_ip_gc_test_fndecl_12372 bitmap_ip_gc_test fndecl 3 12372 NULL
+disable_so_vlv_gpu_freq_div_fndecl_12377 vlv_gpu_freq_div fndecl 0 12377 NULL nohasharray
+disable_so_nilfs_btree_get_new_block_fndecl_12377 nilfs_btree_get_new_block fndecl 0-2 12377 &disable_so_vlv_gpu_freq_div_fndecl_12377
+disable_so_schedule_hrtimeout_range_fndecl_12390 schedule_hrtimeout_range fndecl 2 12390 NULL
+disable_so_btrfs_init_delayed_node_fndecl_12401 btrfs_init_delayed_node fndecl 3 12401 NULL
+disable_so_connect_time_stamp_skd_device_12406 connect_time_stamp skd_device 0 12406 NULL
+disable_so_gcm_hash_remain_fndecl_12408 gcm_hash_remain fndecl 0-2 12408 NULL
+disable_so_kasprintf_fndecl_12414 kasprintf fndecl 1 12414 NULL
+disable_so_iTCO_wdt_set_timeout_fndecl_12423 iTCO_wdt_set_timeout fndecl 2 12423 NULL
+disable_so_queue_ixgbe_mac_addr_12436 queue ixgbe_mac_addr 0 12436 NULL
+disable_so_i_atime_extra_ext4_inode_12438 i_atime_extra ext4_inode 0 12438 NULL
+disable_so_bts_interrupt_threshold_debug_store_12439 bts_interrupt_threshold debug_store 0 12439 NULL
+disable_so_erase_delay_vardecl_nandsim_c_12453 erase_delay vardecl_nandsim.c 0 12453 NULL
+disable_so__rx_page_addr_iwl_host_cmd_12457 _rx_page_addr iwl_host_cmd 0 12457 NULL
+disable_so_fandiv1_w83627ehf_data_12459 fandiv1 w83627ehf_data 0 12459 NULL
+disable_so_affs_hash_name_fndecl_12465 affs_hash_name fndecl 0-3 12465 NULL
+disable_so_timeout_tipc_subscr_12467 timeout tipc_subscr 0 12467 NULL
+disable_so_decrypt_msdu_lib80211_crypto_ops_12475 decrypt_msdu lib80211_crypto_ops 3 12475 NULL
+disable_so_ext4_read_block_bitmap_nowait_fndecl_12477 ext4_read_block_bitmap_nowait fndecl 2 12477 NULL
+disable_so_i40e_rx_hash_fndecl_12482 i40e_rx_hash fndecl 0 12482 NULL
+disable_so_padata_set_cpumasks_fndecl_12492 padata_set_cpumasks fndecl 0 12492 NULL
+disable_so_dm_btree_empty_fndecl_12493 dm_btree_empty fndecl 0 12493 NULL
+disable_so_nv_do_interrupt_fndecl_12501 nv_do_interrupt fndecl 2 12501 NULL
+disable_so_max8997_set_voltage_buck_time_sel_fndecl_12503 max8997_set_voltage_buck_time_sel fndecl 0-2-3 12503 NULL
+disable_so_div_factor_fine_fndecl_12505 div_factor_fine fndecl 0-1 12505 NULL
+disable_so_r820t_sysfreq_sel_fndecl_12506 r820t_sysfreq_sel fndecl 0-2 12506 NULL
+disable_so_msleep_xc2028_ctrl_12512 msleep xc2028_ctrl 0 12512 NULL nohasharray
+disable_so_get_maxrecs_xfs_btree_ops_12512 get_maxrecs xfs_btree_ops 0 12512 &disable_so_msleep_xc2028_ctrl_12512
+disable_so_test_rhashtable_fndecl_12513 test_rhashtable fndecl 0 12513 NULL
+disable_so_i2c_address_mt2131_config_12514 i2c_address mt2131_config 0 12514 NULL
+disable_so_rapl_compute_time_window_core_fndecl_12519 rapl_compute_time_window_core fndecl 0-2 12519 NULL
+disable_so_mi1_wr_addr_fndecl_12527 mi1_wr_addr fndecl 0 12527 NULL nohasharray
+disable_so_write_reg_fndecl_12527 write_reg fndecl 1 12527 &disable_so_mi1_wr_addr_fndecl_12527
+disable_so_mce_adjust_timer_default_fndecl_12530 mce_adjust_timer_default fndecl 0-1 12530 NULL
+disable_so_low_bkey_12536 low bkey 0 12536 NULL
+disable_so_arcmsr_alloc_sysfs_attr_fndecl_12547 arcmsr_alloc_sysfs_attr fndecl 0 12547 NULL
+disable_so_data_qxl_bitmap_12551 data qxl_bitmap 0 12551 NULL
+disable_so_imsf_multiaddr_ip_msfilter_12556 imsf_multiaddr ip_msfilter 0 12556 NULL
+disable_so_qa_indx_sdebug_hrtimer_12577 qa_indx sdebug_hrtimer 0 12577 NULL
+disable_so_shash_compat_digest_fndecl_12579 shash_compat_digest fndecl 0-3 12579 NULL
+disable_so_max8998_rtc_set_time_fndecl_12607 max8998_rtc_set_time fndecl 0 12607 NULL
+disable_so_dib7000m_write_word_fndecl_12610 dib7000m_write_word fndecl 3 12610 NULL
+disable_so_real_start_time_task_struct_12612 real_start_time task_struct 0 12612 NULL
+disable_so_rhashtable_expand_fndecl_12634 rhashtable_expand fndecl 0 12634 NULL
+disable_so_seq_cxgbi_skb_cb_12636 seq cxgbi_skb_cb 0 12636 NULL
+disable_so_daddr_irnet_log_12640 daddr irnet_log 0 12640 NULL
+disable_so_r8a66597_clock_enable_fndecl_12645 r8a66597_clock_enable fndecl 0 12645 NULL
+disable_so_rsa_get_d_fndecl_12646 rsa_get_d fndecl 5 12646 NULL
+disable_so_compat_sys_timer_gettime_fndecl_12649 compat_sys_timer_gettime fndecl 1 12649 NULL
+disable_so_daddr_tcp4_pseudohdr_12650 daddr tcp4_pseudohdr 0 12650 NULL
+disable_so_ccp_crypto_enqueue_cmd_fndecl_12657 ccp_crypto_enqueue_cmd fndecl 0 12657 NULL
+disable_so_gm107_fan_pwm_clock_fndecl_12663 gm107_fan_pwm_clock fndecl 0 12663 NULL
+disable_so_em_sti_clock_event_next_fndecl_12667 em_sti_clock_event_next fndecl 1 12667 NULL
+disable_so___hash_conntrack_fndecl_12675 __hash_conntrack fndecl 0-3 12675 NULL
+disable_so_nr_of_adrs_cmd_ds_mac_multicast_addr_12679 nr_of_adrs cmd_ds_mac_multicast_addr 0 12679 NULL
+disable_so_mpihelp_mul_fndecl_12686 mpihelp_mul fndecl 3-5 12686 NULL
+disable_so_retry_delay_timer_fcoe_fcp_rsp_payload_12692 retry_delay_timer fcoe_fcp_rsp_payload 0 12692 NULL
+disable_so_b43_phy_write_fndecl_12694 b43_phy_write fndecl 2-3 12694 NULL
+disable_so_ageing_time_tun_struct_12716 ageing_time tun_struct 0 12716 NULL nohasharray
+disable_so_rx_delay_rk_priv_data_12716 rx_delay rk_priv_data 0 12716 &disable_so_ageing_time_tun_struct_12716
+disable_so_dma_addr_rxbuff_ent_12717 dma_addr rxbuff_ent 0 12717 NULL
+disable_so_swb_base_asd_ha_addrspace_12726 swb_base asd_ha_addrspace 0 12726 NULL
+disable_so_set_voltage_time_sel_regulator_ops_12737 set_voltage_time_sel regulator_ops 0-2 12737 NULL nohasharray
+disable_so_crypto_ecb_setkey_fndecl_12737 crypto_ecb_setkey fndecl 0-3 12737 &disable_so_set_voltage_time_sel_regulator_ops_12737
+disable_so_width_clk_divider_12738 width clk_divider 0 12738 NULL
+disable_so_mga_set_start_address_fndecl_12745 mga_set_start_address fndecl 2 12745 NULL
+disable_so_last_timer_vardecl_tusb6010_c_12750 last_timer vardecl_tusb6010.c 0 12750 NULL
+disable_so_jiffies_at_free_qla_tgt_cmd_12753 jiffies_at_free qla_tgt_cmd 0 12753 NULL nohasharray
+disable_so_ufs_set_inode_uid_fndecl_12753 ufs_set_inode_uid fndecl 3 12753 &disable_so_jiffies_at_free_qla_tgt_cmd_12753
+disable_so_ipv6_get_saddr_eval_fndecl_12754 ipv6_get_saddr_eval fndecl 0 12754 NULL
+disable_so_bond_xmit_hash_fndecl_12757 bond_xmit_hash fndecl 0 12757 NULL
+disable_so_freqm_snd_usb_endpoint_12761 freqm snd_usb_endpoint 0 12761 NULL
+disable_so_mclkdiv_cs42l73_mclkx_div_12771 mclkdiv cs42l73_mclkx_div 0 12771 NULL
+disable_so_slot_time_rtl8187_priv_12775 slot_time rtl8187_priv 0 12775 NULL
+disable_so_mwifiex_auto_tdls_update_peer_signal_fndecl_12781 mwifiex_auto_tdls_update_peer_signal fndecl 3-4 12781 NULL
+disable_so_channel_mwifiex_chan_freq_power_12794 channel mwifiex_chan_freq_power 0 12794 NULL
+disable_so_pll_loopdiv_dib0090_io_config_12799 pll_loopdiv dib0090_io_config 0 12799 NULL nohasharray
+disable_so_branch_addr_yellowfin_desc_12799 branch_addr yellowfin_desc 0 12799 &disable_so_pll_loopdiv_dib0090_io_config_12799
+disable_so__kstrtoul_fndecl_12800 _kstrtoul fndecl 0 12800 NULL
+disable_so_ns_to_timeval_fndecl_12804 ns_to_timeval fndecl 1 12804 NULL nohasharray
+disable_so_enc_addr_high_sata_start_req_12804 enc_addr_high sata_start_req 0 12804 &disable_so_ns_to_timeval_fndecl_12804
+disable_so_ftdi_232bm_baud_to_divisor_fndecl_12815 ftdi_232bm_baud_to_divisor fndecl 0-1 12815 NULL
+disable_so_crypto_aead_setkey_fndecl_12818 crypto_aead_setkey fndecl 0-3 12818 NULL
+disable_so_ufs_cpu_to_data_ptr_fndecl_12819 ufs_cpu_to_data_ptr fndecl 3 12819 NULL
+disable_so_s35390a_rtc_read_time_fndecl_12823 s35390a_rtc_read_time fndecl 0 12823 NULL
+disable_so_orinoco_ioctl_getfreq_fndecl_12824 orinoco_ioctl_getfreq fndecl 0 12824 NULL
+disable_so_be_get_temp_freq_be_adapter_12832 be_get_temp_freq be_adapter 0 12832 NULL
+disable_so_sha256_transform_asm_vardecl_sha256_ssse3_glue_c_12837 sha256_transform_asm vardecl_sha256_ssse3_glue.c 3 12837 NULL
+disable_so_ubifs_leb_unmap_fndecl_12841 ubifs_leb_unmap fndecl 0-2 12841 NULL
+disable_so_telclk_interrupt_vardecl_tlclk_c_12842 telclk_interrupt vardecl_tlclk.c 0 12842 NULL
+disable_so_eax_tss_segment_32_12853 eax tss_segment_32 0 12853 NULL
+disable_so_recover_ide_timing_12854 recover ide_timing 0 12854 NULL
+disable_so_ima_calc_file_hash_fndecl_12858 ima_calc_file_hash fndecl 0 12858 NULL
+disable_so_timestamp_inquiry_entry_12867 timestamp inquiry_entry 0 12867 NULL
+disable_so_blk_post_runtime_suspend_fndecl_12869 blk_post_runtime_suspend fndecl 2 12869 NULL
+disable_so_clocksource_register_khz_fndecl_12871 clocksource_register_khz fndecl 2 12871 NULL
+disable_so___xfrm4_daddr_saddr_hash_fndecl_12875 __xfrm4_daddr_saddr_hash fndecl 0 12875 NULL
+disable_so_calibrate_delay_converge_fndecl_12881 calibrate_delay_converge fndecl 0 12881 NULL
+disable_so_cgroup_kn_set_ugid_fndecl_12885 cgroup_kn_set_ugid fndecl 0 12885 NULL
+disable_so_bm_number_of_pages_drbd_bitmap_12889 bm_number_of_pages drbd_bitmap 0 12889 NULL
+disable_so_blck_N_aic32x4_rate_divs_12896 blck_N aic32x4_rate_divs 0 12896 NULL
+disable_so_delayacct_blkio_ticks_fndecl_12901 delayacct_blkio_ticks fndecl 0 12901 NULL
+disable_so_sh_irda_set_timeout_fndecl_12902 sh_irda_set_timeout fndecl 2 12902 NULL
+disable_so_bch_next_delay_fndecl_12906 bch_next_delay fndecl 0-2 12906 NULL
+disable_so_address_lo_ht_irq_msg_12914 address_lo ht_irq_msg 0 12914 NULL
+disable_so_cr_gsc_addr_12917 cr gsc_addr 0 12917 NULL nohasharray
+disable_so_fmc_set_freq_fndecl_12917 fmc_set_freq fndecl 0-2 12917 &disable_so_cr_gsc_addr_12917
+disable_so_s_wtime_nilfs_super_block_12947 s_wtime nilfs_super_block 0 12947 NULL
+disable_so___pm_runtime_idle_fndecl_12950 __pm_runtime_idle fndecl 0 12950 NULL
+disable_so_timeout_dvb_ca_slot_12955 timeout dvb_ca_slot 0 12955 NULL
+disable_so_ktime_get_real_ns_fndecl_12957 ktime_get_real_ns fndecl 0 12957 NULL nohasharray
+disable_so_read_temp_msr_fndecl_12957 read_temp_msr fndecl 0 12957 &disable_so_ktime_get_real_ns_fndecl_12957
+disable_so_clock_get_k_clock_12965 clock_get k_clock 1 12965 NULL
+disable_so_addr___cache_12967 addr __cache 0 12967 NULL
+disable_so_dev_addr_mv_u3d_12969 dev_addr mv_u3d 0 12969 NULL
+disable_so_xfrm6_input_addr_fndecl_12971 xfrm6_input_addr fndecl 4 12971 NULL
+disable_so_rfcomm_dlc_set_timer_fndecl_12983 rfcomm_dlc_set_timer fndecl 2 12983 NULL
+disable_so_short_addr_ieee802154_hw_addr_filt_12985 short_addr ieee802154_hw_addr_filt 0 12985 NULL
+disable_so_base_addr_rdma_cq_setup_12989 base_addr rdma_cq_setup 0 12989 NULL
+disable_so_rsp_q_phy_addr_ql3_adapter_12990 rsp_q_phy_addr ql3_adapter 0 12990 NULL
+disable_so_cc770_status_interrupt_fndecl_12992 cc770_status_interrupt fndecl 0 12992 NULL
+disable_so_tx_addr_uart_8250_dma_12997 tx_addr uart_8250_dma 0 12997 NULL
+disable_so_cur_delay_intel_ilk_power_mgmt_13003 cur_delay intel_ilk_power_mgmt 0 13003 NULL
+disable_so_gateway_cmd_addr_wil_fw_record_gateway_data_13008 gateway_cmd_addr wil_fw_record_gateway_data 0 13008 NULL
+disable_so_wq_cpumask_show_fndecl_13018 wq_cpumask_show fndecl 0 13018 NULL
+disable_so_hash_index_fndecl_13050 hash_index fndecl 0-1-2 13050 NULL
+disable_so_qs6612_ack_interrupt_fndecl_13054 qs6612_ack_interrupt fndecl 0 13054 NULL
+disable_so_dst_addr_ioat_dma_descriptor_13055 dst_addr ioat_dma_descriptor 0 13055 NULL
+disable_so_qce_ablkcipher_encrypt_fndecl_13064 qce_ablkcipher_encrypt fndecl 0 13064 NULL
+disable_so_cra_alignmask_crypto_alg_13076 cra_alignmask crypto_alg 0 13076 NULL
+disable_so_rx_busy_ath_cycle_counters_13078 rx_busy ath_cycle_counters 0 13078 NULL
+disable_so_dummy_hrtimer_pointer_fndecl_13080 dummy_hrtimer_pointer fndecl 0 13080 NULL nohasharray
+disable_so_freq_carl9170_rf_init_13080 freq carl9170_rf_init 0 13080 &disable_so_dummy_hrtimer_pointer_fndecl_13080
+disable_so_host_addr_mei_hbm_cl_cmd_13107 host_addr mei_hbm_cl_cmd 0 13107 NULL nohasharray
+disable_so_set_bbreg_rtl_hal_ops_13107 set_bbreg rtl_hal_ops 2-4 13107 &disable_so_host_addr_mei_hbm_cl_cmd_13107
+disable_so_da9063_rtc_read_time_fndecl_13117 da9063_rtc_read_time fndecl 0 13117 NULL
+disable_so_ext4_validate_block_bitmap_fndecl_13120 ext4_validate_block_bitmap fndecl 3 13120 NULL
+disable_so_adp8870_write_fndecl_13121 adp8870_write fndecl 0-2-3 13121 NULL
+disable_so_clock_set_k_clock_13122 clock_set k_clock 1 13122 NULL nohasharray
+disable_so_check_clock_fndecl_13122 check_clock fndecl 1 13122 &disable_so_clock_set_k_clock_13122
+disable_so_addr_wil6210_mbox_ring_desc_13127 addr wil6210_mbox_ring_desc 0 13127 NULL
+disable_so_stats_time_fnic_13131 stats_time fnic 0 13131 NULL
+disable_so_brcms_add_timer_fndecl_13133 brcms_add_timer fndecl 2 13133 NULL
+disable_so_r6a_val_fc2580_freq_regs_13136 r6a_val fc2580_freq_regs 0 13136 NULL
+disable_so_enabled_otg_timer_bits_ci_hdrc_13140 enabled_otg_timer_bits ci_hdrc 0 13140 NULL
+disable_so_atp867x_get_recover_clocks_shifted_fndecl_13150 atp867x_get_recover_clocks_shifted fndecl 0-1 13150 NULL
+disable_so_timeout_nf_ct_gre_13156 timeout nf_ct_gre 0 13156 NULL
+disable_so_snd_fm801_interrupt_fndecl_13162 snd_fm801_interrupt fndecl 1 13162 NULL
+disable_so_afs_server_timeout_vardecl_server_c_13168 afs_server_timeout vardecl_server.c 0 13168 NULL
+disable_so_wm8974_set_dai_clkdiv_fndecl_13171 wm8974_set_dai_clkdiv fndecl 3 13171 NULL
+disable_so_ipw_send_adapter_address_fndecl_13183 ipw_send_adapter_address fndecl 0 13183 NULL
+disable_so_crypto_fpu_encrypt_fndecl_13188 crypto_fpu_encrypt fndecl 0-4 13188 NULL
+disable_so_blockno2iaddr_fndecl_13194 blockno2iaddr fndecl 2 13194 NULL
+disable_so_s_addr_per_block_bits_ext2_sb_info_13196 s_addr_per_block_bits ext2_sb_info 0 13196 NULL
+disable_so_mac_time_rtl8187_rx_hdr_13204 mac_time rtl8187_rx_hdr 0 13204 NULL
+disable_so_efx_phc_gettime_fndecl_13210 efx_phc_gettime fndecl 0 13210 NULL nohasharray
+disable_so_freq_fm_rx_13210 freq fm_rx 0 13210 &disable_so_efx_phc_gettime_fndecl_13210
+disable_so_set_fan1_div_fndecl_13214 set_fan1_div fndecl 0-4 13214 NULL
+disable_so_kstrtos16_from_user_fndecl_13215 kstrtos16_from_user fndecl 2 13215 NULL
+disable_so_timer_int_req_nes_adapter_13220 timer_int_req nes_adapter 0 13220 NULL nohasharray
+disable_so_raddr_rdma_iu_13220 raddr rdma_iu 0 13220 &disable_so_timer_int_req_nes_adapter_13220
+disable_so_calibrate_delay_direct_fndecl_13221 calibrate_delay_direct fndecl 0 13221 NULL
+disable_so_il_scan_cancel_timeout_fndecl_13227 il_scan_cancel_timeout fndecl 2 13227 NULL
+disable_so_di_uid_gfs2_dinode_13234 di_uid gfs2_dinode 0 13234 NULL
+disable_so_globaltxtimeout_ath_hw_13238 globaltxtimeout ath_hw 0 13238 NULL
+disable_so_handle_new_msr_fndecl_13247 handle_new_msr fndecl 2 13247 NULL
+disable_so_efx_ef10_get_mac_address_fndecl_13249 efx_ef10_get_mac_address fndecl 0 13249 NULL
+disable_so_i_atime_exofs_fcb_13250 i_atime exofs_fcb 0 13250 NULL
+disable_so_dwell_time_active_wmi_start_scan_arg_13251 dwell_time_active wmi_start_scan_arg 0 13251 NULL
+disable_so_SYSC_signalfd_fndecl_13255 SYSC_signalfd fndecl 0 13255 NULL
+disable_so_ipv4addr_iscsi_ipv4addr_13263 ipv4addr iscsi_ipv4addr 0 13263 NULL
+disable_so_nilfs_btree_prepare_update_v_fndecl_13265 nilfs_btree_prepare_update_v fndecl 0 13265 NULL
+disable_so_timer_in_use_max_nes_hw_tune_timer_13266 timer_in_use_max nes_hw_tune_timer 0 13266 NULL nohasharray
+disable_so_qlcnic_83xx_sre_macaddr_change_fndecl_13266 qlcnic_83xx_sre_macaddr_change fndecl 0 13266 &disable_so_timer_in_use_max_nes_hw_tune_timer_13266
+disable_so_xgmac_interrupt_fndecl_13268 xgmac_interrupt fndecl 1 13268 NULL
+disable_so_radio_s_hw_freq_seek_fndecl_13308 radio_s_hw_freq_seek fndecl 0 13308 NULL nohasharray
+disable_so_apei_read_mce_fndecl_13308 apei_read_mce fndecl 0 13308 &disable_so_radio_s_hw_freq_seek_fndecl_13308
+disable_so_clear_tasks_mm_cpumask_fndecl_13309 clear_tasks_mm_cpumask fndecl 1 13309 NULL
+disable_so_bmsr_e1000_phy_regs_13313 bmsr e1000_phy_regs 0 13313 NULL
+disable_so_mcryptd_hash_digest_fndecl_13325 mcryptd_hash_digest fndecl 2 13325 NULL
+disable_so_cpumask_set_cpu_fndecl_13326 cpumask_set_cpu fndecl 1 13326 NULL
+disable_so_ipath_unmasktime_ipath_devdata_13342 ipath_unmasktime ipath_devdata 0 13342 NULL
+disable_so_interruptjiffies_vardecl_floppy_c_13345 interruptjiffies vardecl_floppy.c 0 13345 NULL
+disable_so_remove_from_bitmap_fndecl_13352 remove_from_bitmap fndecl 0 13352 NULL
+disable_so_sst_wait_timeout_fndecl_13353 sst_wait_timeout fndecl 0 13353 NULL nohasharray
+disable_so_last_timeout_arcnet_local_13353 last_timeout arcnet_local 0 13353 &disable_so_sst_wait_timeout_fndecl_13353 nohasharray
+disable_so_cfg_table_bus_addr_pmcraid_instance_13353 cfg_table_bus_addr pmcraid_instance 0 13353 &disable_so_last_timeout_arcnet_local_13353
+disable_so_mtime_vardecl_initramfs_c_13365 mtime vardecl_initramfs.c 0 13365 NULL
+disable_so_ds3232_read_time_fndecl_13366 ds3232_read_time fndecl 0 13366 NULL nohasharray
+disable_so_addr_bcma_device_13366 addr bcma_device 0 13366 &disable_so_ds3232_read_time_fndecl_13366
+disable_so_dma_addr_drv_ctl_io_13371 dma_addr drv_ctl_io 0 13371 NULL
+disable_so_crypto_check_alg_fndecl_13376 crypto_check_alg fndecl 0 13376 NULL
+disable_so_drbd_adm_get_timeout_type_fndecl_13391 drbd_adm_get_timeout_type fndecl 0 13391 NULL
+disable_so_hpi_silence_detector_set_delay_fndecl_13393 hpi_silence_detector_set_delay fndecl 0-1 13393 NULL
+disable_so__get_table_div_fndecl_13398 _get_table_div fndecl 0-2 13398 NULL
+disable_so_backtrace_address_fndecl_13401 backtrace_address fndecl 2 13401 NULL
+disable_so_ax25_addr_parse_fndecl_13402 ax25_addr_parse fndecl 2 13402 NULL
+disable_so_ath5k_hw_ani_get_listen_time_fndecl_13417 ath5k_hw_ani_get_listen_time fndecl 0 13417 NULL nohasharray
+disable_so_map_page_dma_map_ops_13417 map_page dma_map_ops 0-3-4 13417 &disable_so_ath5k_hw_ani_get_listen_time_fndecl_13417
+disable_so_cpufreq_stats_free_table_fndecl_13437 cpufreq_stats_free_table fndecl 1 13437 NULL
+disable_so_eft_addr_l_qla2xxx_fw_dump_13450 eft_addr_l qla2xxx_fw_dump 0 13450 NULL
+disable_so_cit_write_reg_fndecl_13451 cit_write_reg fndecl 2 13451 NULL
+disable_so_chash_f2fs_inode_info_13456 chash f2fs_inode_info 0 13456 NULL
+disable_so_vblank_lo_oaktrail_timing_info_13463 vblank_lo oaktrail_timing_info 0 13463 NULL
+disable_so_rtl8139_interrupt_fndecl_13468 rtl8139_interrupt fndecl 1 13468 NULL
+disable_so_start_time_dm_io_13470 start_time dm_io 0 13470 NULL
+disable_so_mt2032_set_if_freq_fndecl_13473 mt2032_set_if_freq fndecl 2-3-4 13473 NULL
+disable_so_demod_address_cx24110_config_13476 demod_address cx24110_config 0 13476 NULL
+disable_so_atime_tcs3472_data_13482 atime tcs3472_data 0 13482 NULL
+disable_so_div_ratio_fndecl_13491 div_ratio fndecl 0-2-1 13491 NULL
+disable_so_seq_xfrm_state_walk_13498 seq xfrm_state_walk 0 13498 NULL
+disable_so_qdisc_class_hash_init_fndecl_13502 qdisc_class_hash_init fndecl 0 13502 NULL
+disable_so_sha256_generic_block_fn_fndecl_13506 sha256_generic_block_fn fndecl 3 13506 NULL
+disable_so_find_first_bit_fndecl_13507 find_first_bit fndecl 0-2 13507 NULL
+disable_so_idle_timeout_clip_vcc_13512 idle_timeout clip_vcc 0 13512 NULL nohasharray
+disable_so_input_set_abs_params_fndecl_13512 input_set_abs_params fndecl 3-4-5-6-2 13512 &disable_so_idle_timeout_clip_vcc_13512
+disable_so_bond_time_in_interval_fndecl_13516 bond_time_in_interval fndecl 2 13516 NULL nohasharray
+disable_so_nv04_timer_init_fndecl_13516 nv04_timer_init fndecl 0 13516 &disable_so_bond_time_in_interval_fndecl_13516
+disable_so_paravirt_read_msr_fndecl_13526 paravirt_read_msr fndecl 0-1 13526 NULL
+disable_so_dram_offset_sst_addr_13528 dram_offset sst_addr 0 13528 NULL
+disable_so_em_sti_clocksource_enable_fndecl_13530 em_sti_clocksource_enable fndecl 0 13530 NULL
+disable_so_timestamp_ieee80211_tdls_ch_sw_params_13545 timestamp ieee80211_tdls_ch_sw_params 0 13545 NULL
+disable_so_post_divider_rv6xx_sclk_stepping_13551 post_divider rv6xx_sclk_stepping 0 13551 NULL nohasharray
+disable_so_center_freq_ieee80211_channel_13551 center_freq ieee80211_channel 0 13551 &disable_so_post_divider_rv6xx_sclk_stepping_13551
+disable_so_port_rcvhdrqtailaddr_phys_ipath_portdata_13553 port_rcvhdrqtailaddr_phys ipath_portdata 0 13553 NULL
+disable_so_acpi_check_address_range_fndecl_13569 acpi_check_address_range fndecl 1-2-3 13569 NULL
+disable_so_time_mt_init_fndecl_13576 time_mt_init fndecl 0 13576 NULL
+disable_so_blkcipher_done_fast_fndecl_13584 blkcipher_done_fast fndecl 0-2 13584 NULL
+disable_so_phys_addr_mpi_mem_13591 phys_addr mpi_mem 0 13591 NULL nohasharray
+disable_so_timeout_p9_trans_rdma_13591 timeout p9_trans_rdma 0 13591 &disable_so_phys_addr_mpi_mem_13591 nohasharray
+disable_so_ssb_chipco_watchdog_timer_set_ms_fndecl_13591 ssb_chipco_watchdog_timer_set_ms fndecl 2-0 13591 &disable_so_timeout_p9_trans_rdma_13591
+disable_so_c_can_set_bittiming_fndecl_13601 c_can_set_bittiming fndecl 0 13601 NULL
+disable_so_crypto_ccm_module_init_fndecl_13609 crypto_ccm_module_init fndecl 0 13609 NULL
+disable_so_addr_hi_eth_tx_next_bd_13611 addr_hi eth_tx_next_bd 0 13611 NULL
+disable_so_addr_hi_cmdQ_e_13613 addr_hi cmdQ_e 0 13613 NULL
+disable_so_min_keysize_crypto_report_cipher_13617 min_keysize crypto_report_cipher 0 13617 NULL
+disable_so_seq_printf_with_thousands_grouping_fndecl_13628 seq_printf_with_thousands_grouping fndecl 2 13628 NULL
+disable_so_cpuidle_init_fndecl_13639 cpuidle_init fndecl 0 13639 NULL
+disable_so_period_ksz_timer_info_13641 period ksz_timer_info 0 13641 NULL
+disable_so_vx_modify_board_clock_fndecl_13669 vx_modify_board_clock fndecl 0 13669 NULL
+disable_so_cmd_box_addr_wl1251_13673 cmd_box_addr wl1251 0 13673 NULL
+disable_so_demod_address_va1j5jf8007s_config_13675 demod_address va1j5jf8007s_config 0 13675 NULL
+disable_so_timestamp_unavailable_nfs4_deviceid_node_13676 timestamp_unavailable nfs4_deviceid_node 0 13676 NULL nohasharray
+disable_so_len_in_mceusb_dev_13676 len_in mceusb_dev 0 13676 &disable_so_timestamp_unavailable_nfs4_deviceid_node_13676
+disable_so_di_uid_efs_dinode_13682 di_uid efs_dinode 0 13682 NULL
+disable_so_aty_ld_le32_fndecl_13683 aty_ld_le32 fndecl 0 13683 NULL
+disable_so_freqValRadio_pvr2_hdw_13684 freqValRadio pvr2_hdw 0 13684 NULL
+disable_so_fd_pppol2tp_addr_13691 fd pppol2tp_addr 0 13691 NULL
+disable_so_ver_total_via_display_timing_13695 ver_total via_display_timing 0 13695 NULL
+disable_so_wait_on_bit_action_fndecl_13700 wait_on_bit_action fndecl 0 13700 NULL
+disable_so_prandom_seed_state_fndecl_13705 prandom_seed_state fndecl 2 13705 NULL
+disable_so_br_set_hello_time_fndecl_13706 br_set_hello_time fndecl 2-0 13706 NULL
+disable_so_servaddr_vardecl_nfsroot_c_13709 servaddr vardecl_nfsroot.c 0 13709 NULL
+disable_so_pci_bus_read_config_byte_fndecl_13716 pci_bus_read_config_byte fndecl 0-2-3 13716 NULL
+disable_so_cipher_blocksize_blkcipher_walk_13719 cipher_blocksize blkcipher_walk 0 13719 NULL
+disable_so_isdn_divert_read_fndecl_13720 isdn_divert_read fndecl 0 13720 NULL
+disable_so_sys_getegid16_fndecl_13732 sys_getegid16 fndecl 0 13732 NULL
+disable_so_turnaround_delay_fndecl_13736 turnaround_delay fndecl 2 13736 NULL nohasharray
+disable_so_ft_min_img_ir_free_timing_13736 ft_min img_ir_free_timing 0 13736 &disable_so_turnaround_delay_fndecl_13736
+disable_so_addr_1_qla8044_minidump_entry_rdmdio_13738 addr_1 qla8044_minidump_entry_rdmdio 0 13738 NULL nohasharray
+disable_so_write_begin_address_space_operations_13738 write_begin address_space_operations 0-3-4 13738 &disable_so_addr_1_qla8044_minidump_entry_rdmdio_13738
+disable_so_ext4fs_dirhash_fndecl_13754 ext4fs_dirhash fndecl 2 13754 NULL
+disable_so_mpll_func_cntl_2_ci_clock_registers_13768 mpll_func_cntl_2 ci_clock_registers 0 13768 NULL
+disable_so_update_ts_time_stats_fndecl_13777 update_ts_time_stats fndecl 1 13777 NULL
+disable_so_adv_smbus_write_byte_data_fndecl_13784 adv_smbus_write_byte_data fndecl 0-3-2-4 13784 NULL
+disable_so_tg3_nvram_read_be32_fndecl_13791 tg3_nvram_read_be32 fndecl 0-2 13791 NULL
+disable_so_ftdi_232bm_baud_base_to_divisor_fndecl_13805 ftdi_232bm_baud_base_to_divisor fndecl 0-1-2 13805 NULL nohasharray
+disable_so_compat_sys_clock_getres_fndecl_13805 compat_sys_clock_getres fndecl 1 13805 &disable_so_ftdi_232bm_baud_base_to_divisor_fndecl_13805
+disable_so_mtimensec_fuse_setattr_in_13811 mtimensec fuse_setattr_in 0 13811 NULL
+disable_so_stime_task_cputime_13814 stime task_cputime 0 13814 NULL
+disable_so_update_rq_clock_task_fndecl_13818 update_rq_clock_task fndecl 2 13818 NULL
+disable_so_first_pending_disptime_throtl_service_queue_13825 first_pending_disptime throtl_service_queue 0 13825 NULL
+disable_so_zalloc_cpumask_var_node_fndecl_13830 zalloc_cpumask_var_node fndecl 2-3 13830 NULL
+disable_so_s_last_error_time_ext4_super_block_13833 s_last_error_time ext4_super_block 0 13833 NULL
+disable_so_ksz_start_timer_fndecl_13834 ksz_start_timer fndecl 2 13834 NULL nohasharray
+disable_so_uwb_rc_mac_addr_get_fndecl_13834 uwb_rc_mac_addr_get fndecl 0 13834 &disable_so_ksz_start_timer_fndecl_13834
+disable_so_last_jiffies_loopback_pcm_13838 last_jiffies loopback_pcm 0 13838 NULL
+disable_so_devm_free_irq_fndecl_13839 devm_free_irq fndecl 2 13839 NULL
+disable_so_wlcore_irq_locked_fndecl_13846 wlcore_irq_locked fndecl 0 13846 NULL
+disable_so_hpet_reserve_platform_timers_fndecl_13848 hpet_reserve_platform_timers fndecl 1 13848 NULL
+disable_so_drm_legacy_ctxbitmap_next_fndecl_13853 drm_legacy_ctxbitmap_next fndecl 0 13853 NULL
+disable_so_addr_hi_sdhci_adma2_64_desc_13867 addr_hi sdhci_adma2_64_desc 0 13867 NULL nohasharray
+disable_so_xfs_btree_lookup_get_block_fndecl_13867 xfs_btree_lookup_get_block fndecl 0 13867 &disable_so_addr_hi_sdhci_adma2_64_desc_13867
+disable_so_ktime_to_us_fndecl_13868 ktime_to_us fndecl 0 13868 NULL nohasharray
+disable_so_mlx5_query_mad_ifc_system_image_guid_fndecl_13868 mlx5_query_mad_ifc_system_image_guid fndecl 0 13868 &disable_so_ktime_to_us_fndecl_13868
+disable_so_smack_task_setpgid_fndecl_13869 smack_task_setpgid fndecl 0 13869 NULL
+disable_so_payload_addr_vpdma_cfd_13876 payload_addr vpdma_cfd 0 13876 NULL
+disable_so_chgfreq_cs42l73_platform_data_13884 chgfreq cs42l73_platform_data 0 13884 NULL
+disable_so_interrupt_page_vmbus_channel_initiate_contact_13895 interrupt_page vmbus_channel_initiate_contact 0 13895 NULL
+disable_so_ptrace_set_breakpoint_addr_fndecl_13901 ptrace_set_breakpoint_addr fndecl 0-2-3 13901 NULL nohasharray
+disable_so_vsync_pulse_width_lo_oaktrail_timing_info_13901 vsync_pulse_width_lo oaktrail_timing_info 0 13901 &disable_so_ptrace_set_breakpoint_addr_fndecl_13901
+disable_so_mcryptd_hash_setkey_fndecl_13926 mcryptd_hash_setkey fndecl 0-3 13926 NULL
+disable_so_put_unaligned_be64_fndecl_13929 put_unaligned_be64 fndecl 1 13929 NULL
+disable_so_voldelay_soundfont_voice_parm_13931 voldelay soundfont_voice_parm 0 13931 NULL
+disable_so_addr_high_lancer_cmd_req_read_object_13932 addr_high lancer_cmd_req_read_object 0 13932 NULL
+disable_so_src_addr_rds_info_rdma_connection_13938 src_addr rds_info_rdma_connection 0 13938 NULL
+disable_so_rs780_force_fbdiv_fndecl_13945 rs780_force_fbdiv fndecl 2 13945 NULL
+disable_so_xfs_btree_key_offset_fndecl_13946 xfs_btree_key_offset fndecl 0-2 13946 NULL nohasharray
+disable_so_cryptd_hash_init_enqueue_fndecl_13946 cryptd_hash_init_enqueue fndecl 0 13946 &disable_so_xfs_btree_key_offset_fndecl_13946
+disable_so_from_addr_param_sctp_af_13948 from_addr_param sctp_af 3 13948 NULL
+disable_so_ept_walk_addr_generic_fndecl_13950 ept_walk_addr_generic fndecl 4-5 13950 NULL
+disable_so_cpu_timer_list_iter_13954 cpu timer_list_iter 0 13954 NULL nohasharray
+disable_so_iowrite16_fndecl_13954 iowrite16 fndecl 1 13954 &disable_so_cpu_timer_list_iter_13954
+disable_so_do_utime_fndecl_13972 do_utime fndecl 2-0 13972 NULL
+disable_so_base_addr_cx18_13974 base_addr cx18 0 13974 NULL
+disable_so_rtpm_suspended_time_show_fndecl_13986 rtpm_suspended_time_show fndecl 0 13986 NULL
+disable_so_ctime_fuse_setattr_in_13994 ctime fuse_setattr_in 0 13994 NULL
+disable_so__rtl92ce_signal_scale_mapping_fndecl_14005 _rtl92ce_signal_scale_mapping fndecl 0-2 14005 NULL
+disable_so_base_address_kvm_ioapic_14007 base_address kvm_ioapic 0 14007 NULL
+disable_so_addr_hi_tx_desc_14014 addr_hi tx_desc 0 14014 NULL
+disable_so_db_page_addr_ocrdma_create_cq_uresp_14016 db_page_addr ocrdma_create_cq_uresp 0 14016 NULL
+disable_so_cur_cpufreq_policy_14023 cur cpufreq_policy 0 14023 NULL
+disable_so_iommu_context_addr_fndecl_14032 iommu_context_addr fndecl 2-3 14032 NULL
+disable_so_pll_i2c_address_dvb_pll_priv_14036 pll_i2c_address dvb_pll_priv 0 14036 NULL
+disable_so_eth_mac_addr_fndecl_14045 eth_mac_addr fndecl 0 14045 NULL
+disable_so_dce_v8_0_crtc_set_base_atomic_fndecl_14048 dce_v8_0_crtc_set_base_atomic fndecl 0 14048 NULL
+disable_so_irq_to_desc_fndecl_14051 irq_to_desc fndecl 1 14051 NULL
+disable_so_ept_identity_map_addr_kvm_arch_14060 ept_identity_map_addr kvm_arch 0 14060 NULL
+disable_so_t1timer_ax25_info_struct_14071 t1timer ax25_info_struct 0 14071 NULL
+disable_so_rxbd_addr_hi_host_cmd_ds_pcie_details_14073 rxbd_addr_hi host_cmd_ds_pcie_details 0 14073 NULL nohasharray
+disable_so_nfsd4_decode_bitmap_fndecl_14073 nfsd4_decode_bitmap fndecl 0 14073 &disable_so_rxbd_addr_hi_host_cmd_ds_pcie_details_14073
+disable_so_xfs_vn_update_time_fndecl_14075 xfs_vn_update_time fndecl 0 14075 NULL
+disable_so_cpufreq_frequency_table_target_fndecl_14082 cpufreq_frequency_table_target fndecl 3 14082 NULL
+disable_so_pll_j_aic31xx_rate_divs_14098 pll_j aic31xx_rate_divs 0 14098 NULL
+disable_so_pirq_from_irq_fndecl_14110 pirq_from_irq fndecl 1 14110 NULL
+disable_so_zforce_scan_frequency_fndecl_14111 zforce_scan_frequency fndecl 0 14111 NULL
+disable_so_uv_bios_freq_base_fndecl_14114 uv_bios_freq_base fndecl 1 14114 NULL
+disable_so_si2165_set_if_freq_shift_fndecl_14123 si2165_set_if_freq_shift fndecl 0-2 14123 NULL
+disable_so___hw_addr_sync_fndecl_14136 __hw_addr_sync fndecl 0-3 14136 NULL
+disable_so_y_qxl_bitmap_14153 y qxl_bitmap 0 14153 NULL
+disable_so_crypto_aead_setauthsize_fndecl_14158 crypto_aead_setauthsize fndecl 2 14158 NULL
+disable_so_r600_engine_clock_entry_set_post_divider_fndecl_14159 r600_engine_clock_entry_set_post_divider fndecl 3 14159 NULL
+disable_so_onenand_buffer_address_fndecl_14162 onenand_buffer_address fndecl 0-2-3 14162 NULL
+disable_so___xfrm_state_lookup_byaddr_fndecl_14170 __xfrm_state_lookup_byaddr fndecl 2-5-6 14170 NULL
+disable_so_uwbd_evt_handle_rc_dev_addr_conflict_fndecl_14177 uwbd_evt_handle_rc_dev_addr_conflict fndecl 0 14177 NULL
+disable_so_mpt_add_sge_64bit_1078_fndecl_14179 mpt_add_sge_64bit_1078 fndecl 2-3 14179 NULL
+disable_so_exynos4_jpeg_set_dec_bitstream_size_fndecl_14180 exynos4_jpeg_set_dec_bitstream_size fndecl 2 14180 NULL
+disable_so_bg_block_bitmap_hi_ext4_group_desc_14201 bg_block_bitmap_hi ext4_group_desc 0 14201 NULL
+disable_so_msecs_to_jiffies_fndecl_14205 msecs_to_jiffies fndecl 0-1 14205 NULL
+disable_so_wait_on_page_bit_killable_timeout_fndecl_14212 wait_on_page_bit_killable_timeout fndecl 3-0 14212 NULL
+disable_so_xfrm_state_addr_check_fndecl_14213 xfrm_state_addr_check fndecl 4 14213 NULL
+disable_so_addr_sil24_sge_14214 addr sil24_sge 0 14214 NULL
+disable_so_t2_hash_tbl_addr_lo_fcoe_kwqe_init2_14217 t2_hash_tbl_addr_lo fcoe_kwqe_init2 0 14217 NULL
+disable_so_custom_divisor_uart_port_14227 custom_divisor uart_port 0 14227 NULL
+disable_so_mclk_freq_s3fb_info_14228 mclk_freq s3fb_info 0 14228 NULL
+disable_so_crypto_rfc4106_decrypt_fndecl_14233 crypto_rfc4106_decrypt fndecl 0 14233 NULL
+disable_so_phy_addr_b44_14235 phy_addr b44 0 14235 NULL
+disable_so_gpiochip_set_chained_irqchip_fndecl_14248 gpiochip_set_chained_irqchip fndecl 3 14248 NULL
+disable_so_pci_bus_address_fndecl_14252 pci_bus_address fndecl 0 14252 NULL
+disable_so_sleep_functions_on_battery_show_fndecl_14253 sleep_functions_on_battery_show fndecl 0 14253 NULL nohasharray
+disable_so_to_hash_fndecl_14253 to_hash fndecl 0-1 14253 &disable_so_sleep_functions_on_battery_show_fndecl_14253
+disable_so_ghash_async_init_fndecl_14257 ghash_async_init fndecl 0 14257 NULL
+disable_so_port_down_timeout_vnic_fc_config_14262 port_down_timeout vnic_fc_config 0 14262 NULL
+disable_so_master_timeout_vardecl_nf_conntrack_amanda_c_14266 master_timeout vardecl_nf_conntrack_amanda.c 0 14266 NULL
+disable_so_register_address_increment_fndecl_14270 register_address_increment fndecl 2-3 14270 NULL
+disable_so_ultra_settings_chipset_bus_clock_list_entry_14273 ultra_settings chipset_bus_clock_list_entry 0 14273 NULL
+disable_so_do_timer_fndecl_14291 do_timer fndecl 1 14291 NULL nohasharray
+disable_so_hpi_sample_clock_set_source_index_fndecl_14291 hpi_sample_clock_set_source_index fndecl 1-0 14291 &disable_so_do_timer_fndecl_14291
+disable_so_ndi_latency_timer_vardecl_ftdi_sio_c_14293 ndi_latency_timer vardecl_ftdi_sio.c 0 14293 NULL
+disable_so_gateway_addr_addr_wil_fw_record_gateway_data4_14300 gateway_addr_addr wil_fw_record_gateway_data4 0 14300 NULL
+disable_so_rxrpc_validate_address_fndecl_14303 rxrpc_validate_address fndecl 0-3 14303 NULL
+disable_so_function_num_atto_csmi_get_pci_bus_addr_14307 function_num atto_csmi_get_pci_bus_addr 0 14307 NULL
+disable_so_packet_timeout_jiffies_lego_usb_tower_14311 packet_timeout_jiffies lego_usb_tower 0 14311 NULL
+disable_so_caller_uid_ceph_mds_request_head_14323 caller_uid ceph_mds_request_head 0 14323 NULL
+disable_so_e1000_get_phy_addr_for_bm_page_fndecl_14324 e1000_get_phy_addr_for_bm_page fndecl 0-1-2 14324 NULL
+disable_so_buf_base_addr_c67x00_hcd_14328 buf_base_addr c67x00_hcd 0 14328 NULL nohasharray
+disable_so_hactive_hi_lvds_dvo_timing_14328 hactive_hi lvds_dvo_timing 0 14328 &disable_so_buf_base_addr_c67x00_hcd_14328
+disable_so_addr_nv4e_i2c_port_14334 addr nv4e_i2c_port 0 14334 NULL
+disable_so_ncp_add_be16_fndecl_14337 ncp_add_be16 fndecl 2 14337 NULL
+disable_so_paddr_mm_dmapool_14345 paddr mm_dmapool 0 14345 NULL
+disable_so_disc_wait_time_esas2r_adapter_14347 disc_wait_time esas2r_adapter 0 14347 NULL
+disable_so_sgidx_scsi_ctrl_blk_14351 sgidx scsi_ctrl_blk 0 14351 NULL
+disable_so_compute_split_timeout_timestamp_fndecl_14357 compute_split_timeout_timestamp fndecl 0-2 14357 NULL
+disable_so_sin_port_sockaddr_in_14374 sin_port sockaddr_in 0 14374 NULL
+disable_so_ci_get_mclk_frequency_ratio_fndecl_14375 ci_get_mclk_frequency_ratio fndecl 0-1 14375 NULL nohasharray
+disable_so_nilfs_btree_node_move_left_fndecl_14375 nilfs_btree_node_move_left fndecl 3 14375 &disable_so_ci_get_mclk_frequency_ratio_fndecl_14375
+disable_so_stv0367cab_get_derot_freq_fndecl_14379 stv0367cab_get_derot_freq fndecl 0-2 14379 NULL
+disable_so_line_time_radeon_crtc_14380 line_time radeon_crtc 0 14380 NULL
+disable_so_src_data_addr_icp_qat_fw_comn_req_mid_14391 src_data_addr icp_qat_fw_comn_req_mid 0 14391 NULL
+disable_so_dev_addr_cx231xx_i2c_xfer_data_14403 dev_addr cx231xx_i2c_xfer_data 0 14403 NULL
+disable_so_card_snd_timer_info32_14407 card snd_timer_info32 0 14407 NULL nohasharray
+disable_so_authenc_esn_verify_ahash_done_fndecl_14407 authenc_esn_verify_ahash_done fndecl 2 14407 &disable_so_card_snd_timer_info32_14407
+disable_so_compat_put_timespec_fndecl_14416 compat_put_timespec fndecl 0 14416 NULL
+disable_so_nct6775_write_fan_div_fndecl_14421 nct6775_write_fan_div fndecl 2 14421 NULL
+disable_so_compat_sys_settimeofday_fndecl_14431 compat_sys_settimeofday fndecl 0 14431 NULL
+disable_so_irlmp_start_idle_timer_fndecl_14433 irlmp_start_idle_timer fndecl 2 14433 NULL
+disable_so_min_flt_signal_struct_14436 min_flt signal_struct 0 14436 NULL
+disable_so___release_region_fndecl_14448 __release_region fndecl 2-3 14448 NULL
+disable_so_dccp_time_wait_fndecl_14450 dccp_time_wait fndecl 3-2 14450 NULL nohasharray
+disable_so_rt_mutex_timed_futex_lock_fndecl_14450 rt_mutex_timed_futex_lock fndecl 0 14450 &disable_so_dccp_time_wait_fndecl_14450
+disable_so_div1_pll_div_14458 div1 pll_div 0 14458 NULL
+disable_so_timestamp_ata_ering_entry_14485 timestamp ata_ering_entry 0 14485 NULL
+disable_so_mod_delayed_work_on_fndecl_14497 mod_delayed_work_on fndecl 1-4 14497 NULL
+disable_so_dma_addr_rx_14500 dma_addr rx 0 14500 NULL nohasharray
+disable_so__rtl92de_signal_scale_mapping_fndecl_14500 _rtl92de_signal_scale_mapping fndecl 0-2 14500 &disable_so_dma_addr_rx_14500
+disable_so_cp_hqd_pq_rptr_report_addr_hi_hqd_registers_14512 cp_hqd_pq_rptr_report_addr_hi hqd_registers 0 14512 NULL
+disable_so_snd_emu1010_internal_clock_info_fndecl_14514 snd_emu1010_internal_clock_info fndecl 0 14514 NULL
+disable_so_nicvf_queue_reg_write_fndecl_14519 nicvf_queue_reg_write fndecl 3-4 14519 NULL
+disable_so_icsk_user_timeout_inet_connection_sock_14528 icsk_user_timeout inet_connection_sock 0 14528 NULL
+disable_so_gcm_hash_assoc_remain_continue_fndecl_14530 gcm_hash_assoc_remain_continue fndecl 0 14530 NULL
+disable_so_get_max_engine_clock_in_mhz_fndecl_14540 get_max_engine_clock_in_mhz fndecl 0 14540 NULL
+disable_so_port_snd_seq_addr_14543 port snd_seq_addr 0 14543 NULL
+disable_so_nouveau_pmops_runtime_resume_fndecl_14545 nouveau_pmops_runtime_resume fndecl 0 14545 NULL
+disable_so_timeout_vardecl_nf_conntrack_netbios_ns_c_14547 timeout vardecl_nf_conntrack_netbios_ns.c 0 14547 NULL
+disable_so_cik_get_gpu_clock_counter_fndecl_14557 cik_get_gpu_clock_counter fndecl 0 14557 NULL
+disable_so_addrconf_fixup_forwarding_fndecl_14567 addrconf_fixup_forwarding fndecl 0-3 14567 NULL
+disable_so_batadv_nc_hash_choose_fndecl_14575 batadv_nc_hash_choose fndecl 0-2 14575 NULL
+disable_so_pbl_addr_iwch_reg_user_mr_resp_14576 pbl_addr iwch_reg_user_mr_resp 0 14576 NULL
+disable_so_m48t59_rtc_read_time_fndecl_14585 m48t59_rtc_read_time fndecl 0 14585 NULL
+disable_so_read_tsc_fndecl_14589 read_tsc fndecl 0 14589 NULL
+disable_so_rtsc_min_fndecl_14591 rtsc_min fndecl 3-4 14591 NULL
+disable_so_bank_addr_snd_ymfpci_voice_14595 bank_addr snd_ymfpci_voice 0 14595 NULL
+disable_so_hpi_bitstream_get_activity_fndecl_14606 hpi_bitstream_get_activity fndecl 0 14606 NULL
+disable_so_prandom_seed_early_fndecl_14613 prandom_seed_early fndecl 2 14613 NULL
+disable_so_cmd_cons_dma_addr_qlcnic_hostrq_tx_ctx_14615 cmd_cons_dma_addr qlcnic_hostrq_tx_ctx 0 14615 NULL
+disable_so_shash_async_import_fndecl_14618 shash_async_import fndecl 0 14618 NULL
+disable_so_osc_clock_freq_drx_common_attr_14640 osc_clock_freq drx_common_attr 0 14640 NULL
+disable_so_freq_ath5k_edge_power_14657 freq ath5k_edge_power 0 14657 NULL
+disable_so_td_addr_c67x00_td_14658 td_addr c67x00_td 0 14658 NULL
+disable_so_dma_addr_whc_std_14663 dma_addr whc_std 0 14663 NULL nohasharray
+disable_so_elfcorehdr_addr_vardecl_14663 elfcorehdr_addr vardecl 0 14663 &disable_so_dma_addr_whc_std_14663
+disable_so_ene_set_reg_addr_fndecl_14666 ene_set_reg_addr fndecl 2 14666 NULL
+disable_so_fbk_divider_panel_info_14668 fbk_divider panel_info 0 14668 NULL
+disable_so_bytes_snd_pcm_oss_runtime_14669 bytes snd_pcm_oss_runtime 0 14669 NULL
+disable_so_vadc_hw_settle_time_from_dt_fndecl_14670 vadc_hw_settle_time_from_dt fndecl 0-1 14670 NULL
+disable_so_crypto842_mod_init_fndecl_14677 crypto842_mod_init fndecl 0 14677 NULL
+disable_so_max77693_set_timeout_fndecl_14678 max77693_set_timeout fndecl 2 14678 NULL
+disable_so_mtt_base_addr_h_mlx4_qp_context_14690 mtt_base_addr_h mlx4_qp_context 0 14690 NULL
+disable_so_mtt_base_addr_l_mlx4_srq_context_14691 mtt_base_addr_l mlx4_srq_context 0 14691 NULL
+disable_so_fib_info_hash_size_vardecl_fib_semantics_c_14699 fib_info_hash_size vardecl_fib_semantics.c 0 14699 NULL
+disable_so___addr_hash_fndecl_14702 __addr_hash fndecl 0-3-4 14702 NULL
+disable_so_rise_time_lp8788_bl_config_14703 rise_time lp8788_bl_config 0 14703 NULL
+disable_so_ebitmap_start_positive_fndecl_14708 ebitmap_start_positive fndecl 0 14708 NULL
+disable_so_ssb_chipco_watchdog_timer_set_wdt_fndecl_14712 ssb_chipco_watchdog_timer_set_wdt fndecl 2-0 14712 NULL
+disable_so_saddr_ipq_14715 saddr ipq 0 14715 NULL
+disable_so_il4965_math_div_round_fndecl_14717 il4965_math_div_round fndecl 1-2 14717 NULL
+disable_so_dac_mmap_min_addr_vardecl_14725 dac_mmap_min_addr vardecl 0 14725 NULL
+disable_so_show_sas_end_dev_initiator_response_timeout_fndecl_14730 show_sas_end_dev_initiator_response_timeout fndecl 0 14730 NULL
+disable_so_md5_mod_init_fndecl_14761 md5_mod_init fndecl 0 14761 NULL
+disable_so_lasttime_htcp_14766 lasttime htcp 0 14766 NULL
+disable_so_cac_time_ms_mwifiex_radar_params_14775 cac_time_ms mwifiex_radar_params 0 14775 NULL
+disable_so_rs5c348_rtc_set_time_fndecl_14776 rs5c348_rtc_set_time fndecl 0 14776 NULL
+disable_so_o2net_sc_queue_delayed_work_fndecl_14778 o2net_sc_queue_delayed_work fndecl 3 14778 NULL
+disable_so_phonet_address_del_fndecl_14787 phonet_address_del fndecl 0 14787 NULL
+disable_so_efx_phc_adjtime_fndecl_14790 efx_phc_adjtime fndecl 0 14790 NULL
+disable_so_lzo_compress_pages_fndecl_14806 lzo_compress_pages fndecl 3-4 14806 NULL
+disable_so_chv_gpu_freq_fndecl_14811 chv_gpu_freq fndecl 0-2 14811 NULL nohasharray
+disable_so_nbytes_blkcipher_walk_14811 nbytes blkcipher_walk 0 14811 &disable_so_chv_gpu_freq_fndecl_14811
+disable_so_addr___mem_14815 addr __mem 0 14815 NULL
+disable_so___cpufreq_governor_fndecl_14821 __cpufreq_governor fndecl 0 14821 NULL nohasharray
+disable_so_hash_lo_smsc95xx_priv_14821 hash_lo smsc95xx_priv 0 14821 &disable_so___cpufreq_governor_fndecl_14821
+disable_so_naddr_ipath_user_sdma_pkt_14830 naddr ipath_user_sdma_pkt 0 14830 NULL
+disable_so_address_pci_mmcfg_region_14831 address pci_mmcfg_region 0 14831 NULL
+disable_so_crypto_ecb_module_init_fndecl_14834 crypto_ecb_module_init fndecl 0 14834 NULL
+disable_so_last_host_tsc_kvm_vcpu_arch_14836 last_host_tsc kvm_vcpu_arch 0 14836 NULL
+disable_so_eir_has_uuids_fndecl_14845 eir_has_uuids fndecl 2 14845 NULL
+disable_so_b_addr_xfer_desc_buffer_14849 b_addr xfer_desc_buffer 0 14849 NULL
+disable_so_xtal_freq_mxl5005s_config_14852 xtal_freq mxl5005s_config 0 14852 NULL
+disable_so_pvclock_tsc_khz_fndecl_14859 pvclock_tsc_khz fndecl 0 14859 NULL
+disable_so_isl1208_rtc_interrupt_fndecl_14861 isl1208_rtc_interrupt fndecl 0 14861 NULL
+disable_so_dwell_time_passive_wmi_start_scan_arg_14866 dwell_time_passive wmi_start_scan_arg 0 14866 NULL
+disable_so_writeout_period_time_vardecl_page_writeback_c_14870 writeout_period_time vardecl_page-writeback.c 0 14870 NULL
+disable_so_valid_mtrr_type_fndecl_14883 valid_mtrr_type fndecl 1 14883 NULL
+disable_so_dev_idx_sockaddr_nfc_llcp_14893 dev_idx sockaddr_nfc_llcp 0 14893 NULL
+disable_so_addr_nv50_disp_mthd_chan_14896 addr nv50_disp_mthd_chan 0 14896 NULL
+disable_so_ts_paddr_end_ath_hw_14898 ts_paddr_end ath_hw 0 14898 NULL
+disable_so_get_urb_to_r8a66597_addr_fndecl_14901 get_urb_to_r8a66597_addr fndecl 0 14901 NULL
+disable_so_remote_ref_time_lp_14915 remote_ref_time lp 0 14915 NULL
+disable_so_bitmap_id_iscsi_conn_14920 bitmap_id iscsi_conn 0 14920 NULL
+disable_so_root_btrfs_delayed_data_ref_14922 root btrfs_delayed_data_ref 0 14922 NULL
+disable_so_c67x00_ll_read_mem_le16_fndecl_14937 c67x00_ll_read_mem_le16 fndecl 2-4 14937 NULL
+disable_so_addr_sz_picolcd_data_14956 addr_sz picolcd_data 0 14956 NULL
+disable_so_xhci_calculate_intel_u1_timeout_fndecl_14959 xhci_calculate_intel_u1_timeout fndecl 0 14959 NULL
+disable_so_crypto_init_shash_ops_fndecl_14968 crypto_init_shash_ops fndecl 0 14968 NULL
+disable_so_cputime_to_compat_timeval_fndecl_14969 cputime_to_compat_timeval fndecl 1 14969 NULL nohasharray
+disable_so_cpufreq_set_cur_state_fndecl_14969 cpufreq_set_cur_state fndecl 1 14969 &disable_so_cputime_to_compat_timeval_fndecl_14969
+disable_so_start_time_flakey_c_14970 start_time flakey_c 0 14970 NULL
+disable_so_snd_asihpi_sampleclock_add_fndecl_14973 snd_asihpi_sampleclock_add fndecl 0 14973 NULL
+disable_so_addr_sky2_tx_le_14974 addr sky2_tx_le 0 14974 NULL
+disable_so_mcfg_addr_acpi_pci_root_14978 mcfg_addr acpi_pci_root 0 14978 NULL
+disable_so_cryptd_hash_import_fndecl_14985 cryptd_hash_import fndecl 0 14985 NULL
+disable_so_cac_start_time_wireless_dev_14998 cac_start_time wireless_dev 0 14998 NULL
+disable_so_inaddr_any_override_acl_subject_label_15014 inaddr_any_override acl_subject_label 0 15014 NULL
+disable_so_dma_addr_cmdQ_ce_15023 dma_addr cmdQ_ce 0 15023 NULL nohasharray
+disable_so_affs_init_bitmap_fndecl_15023 affs_init_bitmap fndecl 0 15023 &disable_so_dma_addr_cmdQ_ce_15023
+disable_so_select_addr_qla8xxx_minidump_entry_mux_15025 select_addr qla8xxx_minidump_entry_mux 0 15025 NULL
+disable_so_frequency_cx24113_state_15031 frequency cx24113_state 0 15031 NULL
+disable_so_port0_phy_addr_falcon_nvconfig_board_v2_15034 port0_phy_addr falcon_nvconfig_board_v2 0 15034 NULL
+disable_so_snd_dice_transaction_get_clock_source_fndecl_15041 snd_dice_transaction_get_clock_source fndecl 0 15041 NULL
+disable_so_valid_time_prefix_cacheinfo_15043 valid_time prefix_cacheinfo 0 15043 NULL
+disable_so_acpi_get_cpuid_fndecl_15055 acpi_get_cpuid fndecl 0-3 15055 NULL
+disable_so_faddr_rds_info_message_15057 faddr rds_info_message 0 15057 NULL
+disable_so_hsync_pulse_width_lo_oaktrail_timing_info_15059 hsync_pulse_width_lo oaktrail_timing_info 0 15059 NULL
+disable_so_mthca_WRITE_MTT_fndecl_15060 mthca_WRITE_MTT fndecl 0-3 15060 NULL
+disable_so_ath9k_iowrite32_fndecl_15073 ath9k_iowrite32 fndecl 2 15073 NULL
+disable_so_uid_max_xt_owner_match_info_15077 uid_max xt_owner_match_info 0 15077 NULL
+disable_so_addr_low_mcp_kreq_ether_recv_15081 addr_low mcp_kreq_ether_recv 0 15081 NULL
+disable_so_gem_get_device_address_fndecl_15093 gem_get_device_address fndecl 0 15093 NULL
+disable_so_s5m8767_rtc_set_time_reg_fndecl_15094 s5m8767_rtc_set_time_reg fndecl 0 15094 NULL
+disable_so_host_side_addr_fit_sg_descriptor_15098 host_side_addr fit_sg_descriptor 0 15098 NULL
+disable_so_gtt_start_gpu_addr_kfd_dev_15100 gtt_start_gpu_addr kfd_dev 0 15100 NULL
+disable_so_device_timestamp_ieee80211_rx_status_15103 device_timestamp ieee80211_rx_status 0 15103 NULL
+disable_so_tcp_fastopen_reset_cipher_fndecl_15116 tcp_fastopen_reset_cipher fndecl 2 15116 NULL
+disable_so_acpi_leave_sleep_state_prep_fndecl_15121 acpi_leave_sleep_state_prep fndecl 0-1 15121 NULL
+disable_so_suspend_freq_cpufreq_policy_15133 suspend_freq cpufreq_policy 0 15133 NULL
+disable_so___usb_control_msg_fndecl_15142 __usb_control_msg fndecl 8-2-9-5-0-4-6-3 15142 NULL
+disable_so_sin6_scope_id_sockaddr_in6_15151 sin6_scope_id sockaddr_in6 0 15151 NULL
+disable_so_ufshcd_devfreq_target_fndecl_15152 ufshcd_devfreq_target fndecl 0 15152 NULL
+disable_so_dma_addr_wbsd_host_15158 dma_addr wbsd_host 0 15158 NULL
+disable_so_timer_in_use_old_nes_hw_tune_timer_15174 timer_in_use_old nes_hw_tune_timer 0 15174 NULL
+disable_so_mce_log_therm_throt_event_fndecl_15178 mce_log_therm_throt_event fndecl 1 15178 NULL nohasharray
+disable_so_mce_write_fndecl_15178 mce_write fndecl 3-0 15178 &disable_so_mce_log_therm_throt_event_fndecl_15178
+disable_so_expires_cpu_timer_list_15182 expires cpu_timer_list 0 15182 NULL
+disable_so_address_drm_dp_aux_msg_15184 address drm_dp_aux_msg 0 15184 NULL
+disable_so_eip_tss_segment_32_15186 eip tss_segment_32 0 15186 NULL
+disable_so_snd_als4000_interrupt_fndecl_15191 snd_als4000_interrupt fndecl 1 15191 NULL nohasharray
+disable_so_pcf2123_rtc_read_time_fndecl_15191 pcf2123_rtc_read_time fndecl 0 15191 &disable_so_snd_als4000_interrupt_fndecl_15191
+disable_so_rcx_kvm_regs_15192 rcx kvm_regs 0 15192 NULL
+disable_so_dma_addr_s_rxd_os_15193 dma_addr s_rxd_os 0 15193 NULL
+disable_so_retrans_time_ifla_cacheinfo_15201 retrans_time ifla_cacheinfo 0 15201 NULL
+disable_so_cxd2820r_sleep_t_fndecl_15204 cxd2820r_sleep_t fndecl 0 15204 NULL
+disable_so_bcma_core_pcie2_war_delay_perst_enab_fndecl_15208 bcma_core_pcie2_war_delay_perst_enab fndecl 0 15208 NULL
+disable_so_btrfs_delayed_inode_reserve_metadata_fndecl_15215 btrfs_delayed_inode_reserve_metadata fndecl 0 15215 NULL
+disable_so___iowrite64_copy_fndecl_15216 __iowrite64_copy fndecl 3 15216 NULL nohasharray
+disable_so_ext3fs_dirhash_fndecl_15216 ext3fs_dirhash fndecl 2 15216 &disable_so___iowrite64_copy_fndecl_15216
+disable_so_nilfs_btree_propagate_fndecl_15225 nilfs_btree_propagate fndecl 0 15225 NULL
+disable_so_sha256_ssse3_update_fndecl_15226 sha256_ssse3_update fndecl 3 15226 NULL
+disable_so_target_addr_i2400m_bootrom_header_15227 target_addr i2400m_bootrom_header 0 15227 NULL
+disable_so_ip_vs_addr_equal_fndecl_15229 ip_vs_addr_equal fndecl 1 15229 NULL
+disable_so_matroxfb_PLL_calcclock_fndecl_15230 matroxfb_PLL_calcclock fndecl 2-3-0 15230 NULL
+disable_so_int_timeout_msb_data_15245 int_timeout msb_data 0 15245 NULL nohasharray
+disable_so_check_quotactl_permission_fndecl_15245 check_quotactl_permission fndecl 4-0-3-2 15245 &disable_so_int_timeout_msb_data_15245
+disable_so_expires_crash_uid_15248 expires crash_uid 0 15248 NULL
+disable_so_mul_n_basecase_fndecl_15258 mul_n_basecase fndecl 4 15258 NULL
+disable_so_crypto_xcbc_digest_update_fndecl_15259 crypto_xcbc_digest_update fndecl 3 15259 NULL
+disable_so_first_jiffies_ati_remote_15260 first_jiffies ati_remote 0 15260 NULL
+disable_so___get_hash_thresh_fndecl_15268 __get_hash_thresh fndecl 2 15268 NULL
+disable_so_isoc_in_endpointaddr_au0828_dev_15269 isoc_in_endpointaddr au0828_dev 0 15269 NULL
+disable_so_crypto_ctxsize_fndecl_15285 crypto_ctxsize fndecl 0 15285 NULL
+disable_so_max_rx_ip_addr_qlcnic_info_15295 max_rx_ip_addr qlcnic_info 0 15295 NULL nohasharray
+disable_so_mtrr_add_fndecl_15295 mtrr_add fndecl 1-2 15295 &disable_so_max_rx_ip_addr_qlcnic_info_15295
+disable_so_plugged_delay_bau_control_15298 plugged_delay bau_control 0 15298 NULL
+disable_so_skcipher_async_cb_fndecl_15303 skcipher_async_cb fndecl 2 15303 NULL
+disable_so_bytes_bitmap_storage_15310 bytes bitmap_storage 0 15310 NULL
+disable_so_xhci_calculate_u1_timeout_fndecl_15314 xhci_calculate_u1_timeout fndecl 0 15314 NULL nohasharray
+disable_so_sym_getpciclock_fndecl_15314 sym_getpciclock fndecl 0 15314 &disable_so_xhci_calculate_u1_timeout_fndecl_15314 nohasharray
+disable_so_major_hash_ocfs2_dx_hinfo_15314 major_hash ocfs2_dx_hinfo 0 15314 &disable_so_sym_getpciclock_fndecl_15314
+disable_so_ns_delay_scale_fndecl_15317 ns_delay_scale fndecl 4 15317 NULL
+disable_so_addr_atiixp_dma_desc_15333 addr atiixp_dma_desc 0 15333 NULL
+disable_so_logicalBlockNum_kernel_lb_addr_15336 logicalBlockNum kernel_lb_addr 0 15336 NULL
+disable_so_last_rx_timestamp_i40e_ring_15342 last_rx_timestamp i40e_ring 0 15342 NULL
+disable_so_ifa_index_ifaddrmsg_15348 ifa_index ifaddrmsg 0 15348 NULL
+disable_so_timing_reg_mtk_i2c_15349 timing_reg mtk_i2c 0 15349 NULL
+disable_so_msr_srcimp_desc_15353 msr srcimp_desc 0 15353 NULL
+disable_so_r2c_val_fc2580_freq_regs_15359 r2c_val fc2580_freq_regs 0 15359 NULL
+disable_so_xfer_udelay_nci_spi_15364 xfer_udelay nci_spi 0 15364 NULL
+disable_so_hash_key_type_and_desc_fndecl_15370 hash_key_type_and_desc fndecl 0 15370 NULL
+disable_so_set_window_latch_addr_flash_info_15372 set_window latch_addr_flash_info 1 15372 NULL
+disable_so_host_addr_ipw2100_bd_15376 host_addr ipw2100_bd 0 15376 NULL
+disable_so_eeprom_addr_state_15380 eeprom_addr state 0 15380 NULL
+disable_so_sys_mq_timedreceive_fndecl_15392 sys_mq_timedreceive fndecl 1-3 15392 NULL
+disable_so_ghash_async_update_fndecl_15422 ghash_async_update fndecl 0 15422 NULL
+disable_so___send_signal_fndecl_15424 __send_signal fndecl 0-1 15424 NULL
+disable_so_edi_user_regs_struct32_15430 edi user_regs_struct32 0 15430 NULL
+disable_so_perf_cpu_time_max_percent_handler_fndecl_15448 perf_cpu_time_max_percent_handler fndecl 0 15448 NULL
+disable_so_phy_register_fixup_for_uid_fndecl_15449 phy_register_fixup_for_uid fndecl 0 15449 NULL
+disable_so_vpd_address_write_fndecl_15453 vpd_address_write fndecl 0-2-3 15453 NULL
+disable_so_schedule_timeout_killable_fndecl_15458 schedule_timeout_killable fndecl 1-0 15458 NULL
+disable_so_a21_wdt_set_timeout_fndecl_15463 a21_wdt_set_timeout fndecl 2 15463 NULL
+disable_so_reg_val_pll_div_15464 reg_val pll_div 0 15464 NULL
+disable_so_adjfreq_ptp_clock_info_15468 adjfreq ptp_clock_info 2 15468 NULL
+disable_so___nlm_hash_addr6_fndecl_15486 __nlm_hash_addr6 fndecl 0 15486 NULL
+disable_so_addr_sgentry_15489 addr sgentry 0 15489 NULL
+disable_so_psb_sgx_interrupt_fndecl_15502 psb_sgx_interrupt fndecl 2-3 15502 NULL
+disable_so_clk_divider_recalc_rate_fndecl_15503 clk_divider_recalc_rate fndecl 2-0 15503 NULL
+disable_so_xferq_addr_hi_fcoe_kwqe_conn_offload2_15506 xferq_addr_hi fcoe_kwqe_conn_offload2 0 15506 NULL
+disable_so_enable_usb3_lpm_timeout_hc_driver_15513 enable_usb3_lpm_timeout hc_driver 0 15513 NULL
+disable_so_i2c_addr_lg2160_config_15521 i2c_addr lg2160_config 0 15521 NULL
+disable_so_timeout_ms_nvme_passthru_cmd_15526 timeout_ms nvme_passthru_cmd 0 15526 NULL
+disable_so_vm_cr_msr_nested_state_15529 vm_cr_msr nested_state 0 15529 NULL
+disable_so_ocfs2_xattr_find_divide_pos_fndecl_15532 ocfs2_xattr_find_divide_pos fndecl 0 15532 NULL
+disable_so_async_schedule_domain_fndecl_15534 async_schedule_domain fndecl 0 15534 NULL
+disable_so_last_cqm_event_signal_ieee80211_if_managed_15539 last_cqm_event_signal ieee80211_if_managed 0 15539 NULL
+disable_so_aic79xx_seltime_vardecl_aic79xx_osm_c_15542 aic79xx_seltime vardecl_aic79xx_osm.c 0 15542 NULL
+disable_so_hrtimer_interval_ms_pmu_15546 hrtimer_interval_ms pmu 0 15546 NULL
+disable_so_address_hi_msi_msg_15552 address_hi msi_msg 0 15552 NULL
+disable_so_test_and_clear_bit_le_fndecl_15554 test_and_clear_bit_le fndecl 1 15554 NULL
+disable_so_snd_echo_clock_source_put_fndecl_15557 snd_echo_clock_source_put fndecl 0 15557 NULL
+disable_so_wait_for_completion_interruptible_timeout_fndecl_15561 wait_for_completion_interruptible_timeout fndecl 0-2 15561 NULL
+disable_so_recover_width_atiixp_ide_timing_15562 recover_width atiixp_ide_timing 0 15562 NULL
+disable_so_start_int_poll_timer_fndecl_15566 start_int_poll_timer fndecl 2 15566 NULL
+disable_so_runtime_error_dev_pm_info_15567 runtime_error dev_pm_info 0 15567 NULL
+disable_so_rdmsrl_on_cpu_fndecl_15568 rdmsrl_on_cpu fndecl 0-1 15568 NULL
+disable_so_test_ahash_cycles_fndecl_15585 test_ahash_cycles fndecl 0-3 15585 NULL
+disable_so_freq_hz_xc5000_priv_15586 freq_hz xc5000_priv 0 15586 NULL
+disable_so_timeout_d_tpm_vendor_specific_15591 timeout_d tpm_vendor_specific 0 15591 NULL nohasharray
+disable_so_laddr_rds_info_connection_15591 laddr rds_info_connection 0 15591 &disable_so_timeout_d_tpm_vendor_specific_15591
+disable_so_be_get_rss_hash_opts_fndecl_15601 be_get_rss_hash_opts fndecl 0 15601 NULL
+disable_so_shadow_addr_kvm_shadow_walk_iterator_15604 shadow_addr kvm_shadow_walk_iterator 0 15604 NULL
+disable_so_hactive_lo_detailed_pixel_timing_15606 hactive_lo detailed_pixel_timing 0 15606 NULL
+disable_so_SYSC_getpgid_fndecl_15618 SYSC_getpgid fndecl 0-1 15618 NULL
+disable_so_inet_dump_ifaddr_fndecl_15621 inet_dump_ifaddr fndecl 0 15621 NULL
+disable_so_sjw_t_pucan_timing_slow_15625 sjw_t pucan_timing_slow 0 15625 NULL
+disable_so_slave_id_snd_timer_instance_15628 slave_id snd_timer_instance 0 15628 NULL nohasharray
+disable_so__ubh_find_last_zero_bit__fndecl_15628 _ubh_find_last_zero_bit_ fndecl 0-3-4-5 15628 &disable_so_slave_id_snd_timer_instance_15628
+disable_so_cmin_flt_signal_struct_15630 cmin_flt signal_struct 0 15630 NULL
+disable_so_sg_busaddr_ips_scb_15639 sg_busaddr ips_scb 0 15639 NULL
+disable_so_rq_timeout_rpc_rqst_15640 rq_timeout rpc_rqst 0 15640 NULL
+disable_so_hpi_bitstream_set_data_polarity_fndecl_15646 hpi_bitstream_set_data_polarity fndecl 0-1 15646 NULL
+disable_so_bs_rdiv_cx24113_state_15647 bs_rdiv cx24113_state 0 15647 NULL
+disable_so_addr_lo_sli4_sge_15650 addr_lo sli4_sge 0 15650 NULL
+disable_so_sctp_getsockopt_primary_addr_fndecl_15660 sctp_getsockopt_primary_addr fndecl 0 15660 NULL
+disable_so_chip_uptime_esas2r_adapter_15661 chip_uptime esas2r_adapter 0 15661 NULL
+disable_so_rx_statistics_jiffies_iwl_priv_15670 rx_statistics_jiffies iwl_priv 0 15670 NULL
+disable_so_ablkcipher_walk_phys_fndecl_15671 ablkcipher_walk_phys fndecl 0 15671 NULL
+disable_so_test_bitmaps_and_extents_fndecl_15676 test_bitmaps_and_extents fndecl 0 15676 NULL
+disable_so_cur_rx_coal_timeval_vnic_cq_15695 cur_rx_coal_timeval vnic_cq 0 15695 NULL
+disable_so_ds_addr_bus_dma_segment_15697 ds_addr bus_dma_segment 0 15697 NULL
+disable_so_hrtimer_forward_fndecl_15719 hrtimer_forward fndecl 0 15719 NULL
+disable_so_pmc_sleep_tmr_open_fndecl_15722 pmc_sleep_tmr_open fndecl 0 15722 NULL
+disable_so_ovol_updated_control_runtime_15730 ovol_updated control_runtime 0 15730 NULL
+disable_so___btrfs_run_delayed_refs_fndecl_15751 __btrfs_run_delayed_refs fndecl 0 15751 NULL
+disable_so_at803x_ack_interrupt_fndecl_15758 at803x_ack_interrupt fndecl 0 15758 NULL
+disable_so_phy_addr_bnx2_15762 phy_addr bnx2 0 15762 NULL
+disable_so_acpi_os_sleep_fndecl_15766 acpi_os_sleep fndecl 1 15766 NULL
+disable_so_mceusb_dev_driver_init_fndecl_15775 mceusb_dev_driver_init fndecl 0 15775 NULL
+disable_so_iowrite32be_fndecl_15786 iowrite32be fndecl 1 15786 NULL
+disable_so_rp1_freq_intel_gen6_power_mgmt_15787 rp1_freq intel_gen6_power_mgmt 0 15787 NULL
+disable_so_mapped_rem_addr_nes_cm_info_15788 mapped_rem_addr nes_cm_info 0 15788 NULL
+disable_so_bulkin_endpoint_addr_rsi_91x_usbdev_15790 bulkin_endpoint_addr rsi_91x_usbdev 0 15790 NULL
+disable_so_connected_addr_rds_info_socket_15792 connected_addr rds_info_socket 0 15792 NULL
+disable_so_usc_enable_aux_clock_fndecl_15795 usc_enable_aux_clock fndecl 2 15795 NULL
+disable_so_add_delayed_tree_ref_fndecl_15797 add_delayed_tree_ref fndecl 11-5-6-7-8-9 15797 NULL
+disable_so_wow_intr_before_sleep_ath_softc_15802 wow_intr_before_sleep ath_softc 0 15802 NULL
+disable_so_rgb_time_bd2802_led_platform_data_15808 rgb_time bd2802_led_platform_data 0 15808 NULL
+disable_so_intel_sdvo_get_slave_addr_fndecl_15818 intel_sdvo_get_slave_addr fndecl 0 15818 NULL
+disable_so_tsc_start_vardecl_tsc_c_15853 tsc_start vardecl_tsc.c 0 15853 NULL
+disable_so_get_cycle_time_fndecl_15861 get_cycle_time fndecl 0 15861 NULL
+disable_so_cookie_dmaengine_pcm_runtime_data_15862 cookie dmaengine_pcm_runtime_data 0 15862 NULL nohasharray
+disable_so___bfa_dma_be_addr_set_fndecl_15862 __bfa_dma_be_addr_set fndecl 2 15862 &disable_so_cookie_dmaengine_pcm_runtime_data_15862
+disable_so_vactive_timing_15863 vactive timing 0 15863 NULL
+disable_so_management_agent_address_sbp2_target_15871 management_agent_address sbp2_target 0 15871 NULL
+disable_so_i2c_check_addr_busy_fndecl_15889 i2c_check_addr_busy fndecl 2 15889 NULL
+disable_so_db_rec_addr_mlx4_cq_context_15890 db_rec_addr mlx4_cq_context 0 15890 NULL
+disable_so_addr_wil_memio_block_15893 addr wil_memio_block 0 15893 NULL
+disable_so_interrupt_out_size_usb_serial_port_15896 interrupt_out_size usb_serial_port 0 15896 NULL
+disable_so_wait_for_completion_killable_fndecl_15899 wait_for_completion_killable fndecl 0 15899 NULL
+disable_so_m48t35_read_time_fndecl_15900 m48t35_read_time fndecl 0 15900 NULL
+disable_so_ath9k_btcoex_handle_interrupt_fndecl_15912 ath9k_btcoex_handle_interrupt fndecl 2 15912 NULL
+disable_so_get_key_lib80211_crypto_ops_15916 get_key lib80211_crypto_ops 0-2 15916 NULL
+disable_so_tw_sport_inet_timewait_sock_15928 tw_sport inet_timewait_sock 0 15928 NULL
+disable_so_crypto_xor_byte_fndecl_15934 crypto_xor_byte fndecl 3 15934 NULL
+disable_so_nilfs_btree_promote_key_fndecl_15935 nilfs_btree_promote_key fndecl 4 15935 NULL
+disable_so_irq_set_chip_data_fndecl_15945 irq_set_chip_data fndecl 1 15945 NULL
+disable_so_retransmits_timed_out_fndecl_15952 retransmits_timed_out fndecl 3 15952 NULL
+disable_so_titsc_config_wires_fndecl_15953 titsc_config_wires fndecl 0 15953 NULL
+disable_so_cpufreq_quick_get_max_fndecl_15956 cpufreq_quick_get_max fndecl 0-1 15956 NULL
+disable_so_verify_ptp_clock_info_15963 verify ptp_clock_info 4 15963 NULL
+disable_so_gid_ceph_mds_caps_15966 gid ceph_mds_caps 0 15966 NULL
+disable_so_mlx4_ib_update_cache_on_guid_change_fndecl_15969 mlx4_ib_update_cache_on_guid_change fndecl 2-3 15969 NULL
+disable_so_musb_write_txfunaddr_fndecl_15974 musb_write_txfunaddr fndecl 2-3 15974 NULL
+disable_so_acpi_ut_add_address_range_fndecl_16007 acpi_ut_add_address_range fndecl 1-2-3-0 16007 NULL
+disable_so_dma_addr_rsxx_dma_16020 dma_addr rsxx_dma 0 16020 NULL
+disable_so_setup_acpi_object_addr_handler_16031 setup acpi_object_addr_handler 0 16031 NULL
+disable_so_idletimer_tg_init_fndecl_16041 idletimer_tg_init fndecl 0 16041 NULL
+disable_so_msdu_paddr_htt_mgmt_tx_desc_16042 msdu_paddr htt_mgmt_tx_desc 0 16042 NULL
+disable_so_radeon_atombios_parse_pplib_non_clock_info_fndecl_16044 radeon_atombios_parse_pplib_non_clock_info fndecl 2 16044 NULL
+disable_so_scale_stime_fndecl_16047 scale_stime fndecl 1-2-3-0 16047 NULL
+disable_so_wl12xx_enable_interrupts_fndecl_16057 wl12xx_enable_interrupts fndecl 0 16057 NULL
+disable_so_paddr_persistent_ram_zone_16058 paddr persistent_ram_zone 0 16058 NULL
+disable_so_get_dst_timing_fndecl_16070 get_dst_timing fndecl 0 16070 NULL
+disable_so_max_init_timeo_sctp_association_16072 max_init_timeo sctp_association 0 16072 NULL
+disable_so_update_gid_table_fndecl_16082 update_gid_table fndecl 2 16082 NULL
+disable_so_dma_addr_xilly_mapping_16083 dma_addr xilly_mapping 0 16083 NULL
+disable_so_bt_wait_time_ath_btcoex_16086 bt_wait_time ath_btcoex 0 16086 NULL
+disable_so_cfg80211_rx_unexpected_4addr_frame_fndecl_16088 cfg80211_rx_unexpected_4addr_frame fndecl 3 16088 NULL
+disable_so_ip6_rt_gc_timeout_netns_sysctl_ipv6_16090 ip6_rt_gc_timeout netns_sysctl_ipv6 0 16090 NULL nohasharray
+disable_so_ieee80211_if_read_path_refresh_time_fndecl_16090 ieee80211_if_read_path_refresh_time fndecl 3-0 16090 &disable_so_ip6_rt_gc_timeout_netns_sysctl_ipv6_16090
+disable_so_wimax_addr_scnprint_fndecl_16095 wimax_addr_scnprint fndecl 4 16095 NULL
+disable_so_airspy_s_frequency_fndecl_16098 airspy_s_frequency fndecl 0 16098 NULL
+disable_so_crypto_blkcipher_ctxsize_fndecl_16105 crypto_blkcipher_ctxsize fndecl 0 16105 NULL
+disable_so_blk_addr_f2fs_io_info_16107 blk_addr f2fs_io_info 0 16107 NULL
+disable_so_div_r0_pll_values_16109 div_r0 pll_values 0 16109 NULL
+disable_so_slack_hold_time_dql_16111 slack_hold_time dql 0 16111 NULL
+disable_so_iscsi_tpg_attrib_show_netif_timeout_fndecl_16119 iscsi_tpg_attrib_show_netif_timeout fndecl 0 16119 NULL
+disable_so_crypto_inc_fndecl_16125 crypto_inc fndecl 2 16125 NULL
+disable_so_dualwatch_jiffies_ivtv_16137 dualwatch_jiffies ivtv 0 16137 NULL nohasharray
+disable_so_enable_irq_fndecl_16137 enable_irq fndecl 1 16137 &disable_so_dualwatch_jiffies_ivtv_16137
+disable_so_alb_set_mac_address_fndecl_16150 alb_set_mac_address fndecl 0 16150 NULL
+disable_so_do_sigtimedwait_fndecl_16152 do_sigtimedwait fndecl 0 16152 NULL
+disable_so_sys_timerfd_create_fndecl_16155 sys_timerfd_create fndecl 2-1 16155 NULL
+disable_so_xen_smp_send_reschedule_fndecl_16161 xen_smp_send_reschedule fndecl 1 16161 NULL nohasharray
+disable_so_addrHigh_ulp_bde64_16161 addrHigh ulp_bde64 0 16161 &disable_so_xen_smp_send_reschedule_fndecl_16161
+disable_so_storm_memset_spq_addr_fndecl_16172 storm_memset_spq_addr fndecl 2-3 16172 NULL
+disable_so_inactivity_timeout_cfhsi_config_16173 inactivity_timeout cfhsi_config 0 16173 NULL nohasharray
+disable_so_iwl_eeprom_query_addr_fndecl_16173 iwl_eeprom_query_addr fndecl 2-3 16173 &disable_so_inactivity_timeout_cfhsi_config_16173
+disable_so_nmsrs_kvm_msr_list_16175 nmsrs kvm_msr_list 0 16175 NULL
+disable_so_count_radeon_vce_clock_voltage_dependency_table_16180 count radeon_vce_clock_voltage_dependency_table 0 16180 NULL
+disable_so_qla4_83xx_wr_reg_indirect_fndecl_16184 qla4_83xx_wr_reg_indirect fndecl 2-3 16184 NULL
+disable_so_show_src_clock_fndecl_16195 show_src_clock fndecl 0 16195 NULL
+disable_so_timeout_ncp_lock_ioctl_16196 timeout ncp_lock_ioctl 0 16196 NULL
+disable_so_sctp_getsockopt_local_addrs_fndecl_16201 sctp_getsockopt_local_addrs fndecl 2 16201 NULL nohasharray
+disable_so_wusb_set_dev_addr_fndecl_16201 wusb_set_dev_addr fndecl 3 16201 &disable_so_sctp_getsockopt_local_addrs_fndecl_16201
+disable_so_ageing_time___bridge_info_16213 ageing_time __bridge_info 0 16213 NULL
+disable_so_bd_list_addr_hi_bnx2i_login_request_16219 bd_list_addr_hi bnx2i_login_request 0 16219 NULL
+disable_so_btrfs_delete_delayed_items_fndecl_16220 btrfs_delete_delayed_items fndecl 0 16220 NULL nohasharray
+disable_so_sethdraddr_fndecl_16220 sethdraddr fndecl 0 16220 &disable_so_btrfs_delete_delayed_items_fndecl_16220
+disable_so_ci_i2c_addr_netup_ci_state_16240 ci_i2c_addr netup_ci_state 0 16240 NULL
+disable_so_hi_phys_addr_16280 hi phys_addr 0 16280 NULL
+disable_so___chk_range_not_ok_fndecl_16282 __chk_range_not_ok fndecl 1-2 16282 NULL
+disable_so_ocfs2_add_clusters_in_btree_fndecl_16283 ocfs2_add_clusters_in_btree fndecl 0-4 16283 NULL
+disable_so_prev_task_link_tss_segment_32_16296 prev_task_link tss_segment_32 0 16296 NULL
+disable_so_ad1889_load_adc_interrupt_count_fndecl_16303 ad1889_load_adc_interrupt_count fndecl 2 16303 NULL
+disable_so_cp_mqd_base_addr_lo_cik_mqd_16307 cp_mqd_base_addr_lo cik_mqd 0 16307 NULL
+disable_so_led_on_time_adp5520_leds_platform_data_16308 led_on_time adp5520_leds_platform_data 0 16308 NULL
+disable_so_dma_addr_adf_etr_ring_data_16309 dma_addr adf_etr_ring_data 0 16309 NULL
+disable_so_demod_address_s921_config_16312 demod_address s921_config 0 16312 NULL
+disable_so_valid_lft_inet6_ifaddr_16318 valid_lft inet6_ifaddr 0 16318 NULL
+disable_so_addr_boom_rx_desc_16324 addr boom_rx_desc 0 16324 NULL
+disable_so_ghash_async_digest_fndecl_16326 ghash_async_digest fndecl 0 16326 NULL
+disable_so_i_atime_f2fs_inode_16339 i_atime f2fs_inode 0 16339 NULL
+disable_so_update_bus_time_fndecl_16343 update_bus_time fndecl 0 16343 NULL
+disable_so_addr_st_register_16344 addr st_register 0 16344 NULL nohasharray
+disable_so_team_port_set_team_dev_addr_fndecl_16344 team_port_set_team_dev_addr fndecl 0 16344 &disable_so_addr_st_register_16344
+disable_so_pll_prediv_dibx000_bandwidth_config_16345 pll_prediv dibx000_bandwidth_config 0 16345 NULL
+disable_so_delay_kbd_repeat_16363 delay kbd_repeat 0 16363 NULL
+disable_so_rproc_elf_get_boot_addr_fndecl_16372 rproc_elf_get_boot_addr fndecl 0 16372 NULL
+disable_so_f2fs_dentry_hash_fndecl_16378 f2fs_dentry_hash fndecl 0 16378 NULL
+disable_so_alarm_nvkm_timer_16388 alarm nvkm_timer 2 16388 NULL
+disable_so_snd_seq_oss_timer_continue_fndecl_16406 snd_seq_oss_timer_continue fndecl 0 16406 NULL
+disable_so_p1_mt9t112_pll_divider_16434 p1 mt9t112_pll_divider 0 16434 NULL
+disable_so_unmap_sg_dma_map_ops_16437 unmap_sg dma_map_ops 3 16437 NULL
+disable_so_ccp_aes_rfc3686_encrypt_fndecl_16455 ccp_aes_rfc3686_encrypt fndecl 0 16455 NULL
+disable_so_bad_dma_addr_vardecl_amd_gart_64_c_16460 bad_dma_addr vardecl_amd_gart_64.c 0 16460 NULL
+disable_so_ath6kl_sdio_set_cmd53_arg_fndecl_16468 ath6kl_sdio_set_cmd53_arg fndecl 3-7 16468 NULL
+disable_so_list_phy_addr_list_info_hold_16469 list_phy_addr list_info_hold 0 16469 NULL
+disable_so_jack_detect_delay_max98095_pdata_16483 jack_detect_delay max98095_pdata 0 16483 NULL
+disable_so_bcma_erom_get_addr_desc_fndecl_16484 bcma_erom_get_addr_desc fndecl 0 16484 NULL nohasharray
+disable_so_fib_info_hash_free_fndecl_16484 fib_info_hash_free fndecl 2 16484 &disable_so_bcma_erom_get_addr_desc_fndecl_16484
+disable_so_frequency_xc2028_data_16487 frequency xc2028_data 0 16487 NULL
+disable_so_acpi_hw_extended_sleep_fndecl_16503 acpi_hw_extended_sleep fndecl 0 16503 NULL
+disable_so_lxt970_ack_interrupt_fndecl_16507 lxt970_ack_interrupt fndecl 0 16507 NULL nohasharray
+disable_so_debug_dma_map_page_fndecl_16507 debug_dma_map_page fndecl 3-6-4 16507 &disable_so_lxt970_ack_interrupt_fndecl_16507
+disable_so_freq_hi_jiffies_od_cpu_dbs_info_s_16514 freq_hi_jiffies od_cpu_dbs_info_s 0 16514 NULL
+disable_so_address_u132_respond_16518 address u132_respond 0 16518 NULL
+disable_so_tegra_spi_transfer_delay_fndecl_16528 tegra_spi_transfer_delay fndecl 1 16528 NULL
+disable_so_cdb_phyaddr_hi32_AdapterControlBlock_16537 cdb_phyaddr_hi32 AdapterControlBlock 0 16537 NULL
+disable_so_copied_seq_cxgbi_sock_16540 copied_seq cxgbi_sock 0 16540 NULL
+disable_so_src_addr_lo_dmae_command_16542 src_addr_lo dmae_command 0 16542 NULL
+disable_so_addr_lo_eth_tx_bd_16543 addr_lo eth_tx_bd 0 16543 NULL
+disable_so_ccp_aes_cmac_digest_fndecl_16547 ccp_aes_cmac_digest fndecl 0 16547 NULL
+disable_so_ip_pt_regs_16548 ip pt_regs 0 16548 NULL
+disable_so_sleep_vol_cache_fan53555_device_info_16553 sleep_vol_cache fan53555_device_info 0 16553 NULL
+disable_so_hblank_hi_oaktrail_timing_info_16559 hblank_hi oaktrail_timing_info 0 16559 NULL
+disable_so_qla2x00_get_async_timeout_fndecl_16577 qla2x00_get_async_timeout fndecl 0 16577 NULL
+disable_so___bitmap_andnot_fndecl_16578 __bitmap_andnot fndecl 4 16578 NULL
+disable_so_hfreq_fb_cvt_data_16579 hfreq fb_cvt_data 0 16579 NULL
+disable_so_tseg1_pucan_timing_slow_16580 tseg1 pucan_timing_slow 0 16580 NULL
+disable_so_freq_rfmon_header_16593 freq rfmon_header 0 16593 NULL
+disable_so_load_block_bitmap_fndecl_16597 load_block_bitmap fndecl 0-3 16597 NULL
+disable_so_flush_timer_il_lq_sta_16606 flush_timer il_lq_sta 0 16606 NULL
+disable_so_ieee80211_channel_to_frequency_fndecl_16619 ieee80211_channel_to_frequency fndecl 0-1 16619 NULL
+disable_so_log_guest_addr_vhost_vring_addr_16627 log_guest_addr vhost_vring_addr 0 16627 NULL nohasharray
+disable_so_cpumask_first_fndecl_16627 cpumask_first fndecl 0 16627 &disable_so_log_guest_addr_vhost_vring_addr_16627
+disable_so_sctp_addr_id2transport_fndecl_16639 sctp_addr_id2transport fndecl 3 16639 NULL
+disable_so_dx_context_paddr_sst_hsw_16656 dx_context_paddr sst_hsw 0 16656 NULL
+disable_so_demod_address_au8522_config_16665 demod_address au8522_config 0 16665 NULL
+disable_so_acpi_device_uid_show_fndecl_16681 acpi_device_uid_show fndecl 0 16681 NULL nohasharray
+disable_so_sys_setresuid16_fndecl_16681 sys_setresuid16 fndecl 0-1-2-3 16681 &disable_so_acpi_device_uid_show_fndecl_16681
+disable_so_crypto_rfc4106_encrypt_fndecl_16683 crypto_rfc4106_encrypt fndecl 0 16683 NULL
+disable_so_field_bit_length_acpi_create_field_info_16693 field_bit_length acpi_create_field_info 0 16693 NULL nohasharray
+disable_so_insert_revoke_hash_fndecl_16693 insert_revoke_hash fndecl 0-2 16693 &disable_so_field_bit_length_acpi_create_field_info_16693
+disable_so_target_cpufreq_driver_16704 target cpufreq_driver 2 16704 NULL
+disable_so_vm_mmap_pgoff_fndecl_16712 vm_mmap_pgoff fndecl 0-2-4-5-6 16712 NULL
+disable_so_time_kvm_vcpu_arch_16718 time kvm_vcpu_arch 0 16718 NULL
+disable_so_mark_bitmap_end_fndecl_16723 mark_bitmap_end fndecl 1-2 16723 NULL
+disable_so_edi_tss_segment_32_16727 edi tss_segment_32 0 16727 NULL
+disable_so_native_calibrate_tsc_fndecl_16735 native_calibrate_tsc fndecl 0 16735 NULL
+disable_so_buf_phy_addr_low_ql_rcv_buf_cb_16742 buf_phy_addr_low ql_rcv_buf_cb 0 16742 NULL
+disable_so_mv88e6131_port_to_phy_addr_fndecl_16751 mv88e6131_port_to_phy_addr fndecl 0-2 16751 NULL
+disable_so_vpd_cap_addr_pci_params_16752 vpd_cap_addr pci_params 0 16752 NULL nohasharray
+disable_so_qce_ablkcipher_decrypt_fndecl_16752 qce_ablkcipher_decrypt fndecl 0 16752 &disable_so_vpd_cap_addr_pci_params_16752
+disable_so_guest_interruptibility_info_vmcs12_16754 guest_interruptibility_info vmcs12 0 16754 NULL
+disable_so_dma_ops_alloc_addresses_fndecl_16763 dma_ops_alloc_addresses fndecl 0-3-4-5 16763 NULL
+disable_so_base_io_addr_cx25821_dev_16770 base_io_addr cx25821_dev 0 16770 NULL
+disable_so_w1_delay_parm_vardecl_w1_io_c_16771 w1_delay_parm vardecl_w1_io.c 0 16771 NULL
+disable_so_devm_kasprintf_fndecl_16792 devm_kasprintf fndecl 2 16792 NULL nohasharray
+disable_so_crypto_rfc4309_setauthsize_fndecl_16792 crypto_rfc4309_setauthsize fndecl 2 16792 &disable_so_devm_kasprintf_fndecl_16792
+disable_so_blp_qat_crypto_request_buffs_16801 blp qat_crypto_request_buffs 0 16801 NULL
+disable_so_crypto_enqueue_request_fndecl_16802 crypto_enqueue_request fndecl 0 16802 NULL
+disable_so_si2165_sleep_fndecl_16803 si2165_sleep fndecl 0 16803 NULL
+disable_so_count_radeon_uvd_clock_voltage_dependency_table_16804 count radeon_uvd_clock_voltage_dependency_table 0 16804 NULL
+disable_so_addr_low_viafb_vx855_dma_descr_16813 addr_low viafb_vx855_dma_descr 0 16813 NULL
+disable_so_shash_async_digest_fndecl_16817 shash_async_digest fndecl 0 16817 NULL
+disable_so_ip_apei_exec_context_16824 ip apei_exec_context 0 16824 NULL nohasharray
+disable_so_si_program_ulv_memory_timing_parameters_fndecl_16824 si_program_ulv_memory_timing_parameters fndecl 0 16824 &disable_so_ip_apei_exec_context_16824
+disable_so_xfs_btree_delete_fndecl_16843 xfs_btree_delete fndecl 0 16843 NULL
+disable_so_round_jiffies_up_fndecl_16844 round_jiffies_up fndecl 1-0 16844 NULL
+disable_so___add_delayed_refs_fndecl_16846 __add_delayed_refs fndecl 0-5 16846 NULL
+disable_so_tv_sec_xfs_bstime_16848 tv_sec xfs_bstime 0 16848 NULL
+disable_so_lsize_mtrr_value_16850 lsize mtrr_value 0 16850 NULL
+disable_so_demod_address_stv0288_config_16852 demod_address stv0288_config 0 16852 NULL
+disable_so_efi_lookup_mapped_addr_fndecl_16854 efi_lookup_mapped_addr fndecl 1 16854 NULL
+disable_so_schedule_timeout_fndecl_16856 schedule_timeout fndecl 0-1 16856 NULL
+disable_so_ceph_aes_decrypt2_fndecl_16857 ceph_aes_decrypt2 fndecl 2-8 16857 NULL
+disable_so_da9055_wdt_set_timeout_fndecl_16860 da9055_wdt_set_timeout fndecl 2-0 16860 NULL
+disable_so_erst_dma_addr_xhci_erst_16864 erst_dma_addr xhci_erst 0 16864 NULL
+disable_so_prefered_lft_inet6_ifaddr_16873 prefered_lft inet6_ifaddr 0 16873 NULL
+disable_so_ti_tsc_driver_init_fndecl_16883 ti_tsc_driver_init fndecl 0 16883 NULL
+disable_so_dataout_timeout_iscsi_node_attrib_16884 dataout_timeout iscsi_node_attrib 0 16884 NULL
+disable_so___rtc_read_time_fndecl_16890 __rtc_read_time fndecl 0 16890 NULL nohasharray
+disable_so_tn_smc_rreg_fndecl_16890 tn_smc_rreg fndecl 0-2 16890 &disable_so___rtc_read_time_fndecl_16890
+disable_so_lpage_dma_addr_genwqe_sgl_16893 lpage_dma_addr genwqe_sgl 0 16893 NULL
+disable_so_schedule_on_each_cpu_fndecl_16903 schedule_on_each_cpu fndecl 0 16903 NULL nohasharray
+disable_so_print_dropped_signal_fndecl_16903 print_dropped_signal fndecl 1 16903 &disable_so_schedule_on_each_cpu_fndecl_16903
+disable_so_pctv452e_read_mac_address_fndecl_16904 pctv452e_read_mac_address fndecl 0 16904 NULL
+disable_so_regcache_lzo_get_blkindex_fndecl_16910 regcache_lzo_get_blkindex fndecl 0-2 16910 NULL
+disable_so_login_timeout_qla_hw_data_16911 login_timeout qla_hw_data 0 16911 NULL
+disable_so_bitmap_find_free_region_fndecl_16912 bitmap_find_free_region fndecl 0-2-3 16912 NULL
+disable_so_bit_reverse_mpeg_output_fndecl_16915 bit_reverse_mpeg_output fndecl 0 16915 NULL
+disable_so_da9063_wdt_set_timeout_fndecl_16916 da9063_wdt_set_timeout fndecl 2-0 16916 NULL
+disable_so_pci_bus_insert_busn_res_fndecl_16923 pci_bus_insert_busn_res fndecl 3-2 16923 NULL
+disable_so_port_mlx4_next_alias_guid_work_16924 port mlx4_next_alias_guid_work 0 16924 NULL
+disable_so_port_guid_nodeinfo_16928 port_guid nodeinfo 0 16928 NULL
+disable_so_transition_latency_cpufreq_cpuinfo_16939 transition_latency cpufreq_cpuinfo 0 16939 NULL
+disable_so_si476x_core_cmd_fm_phase_div_status_fndecl_16940 si476x_core_cmd_fm_phase_div_status fndecl 0 16940 NULL nohasharray
+disable_so_convert_hwaddr_wlcore_ops_16940 convert_hwaddr wlcore_ops 0 16940 &disable_so_si476x_core_cmd_fm_phase_div_status_fndecl_16940
+disable_so_tps80031_rtc_set_time_fndecl_16950 tps80031_rtc_set_time fndecl 0 16950 NULL
+disable_so_select_addr_qla8044_minidump_entry_mux_16956 select_addr qla8044_minidump_entry_mux 0 16956 NULL
+disable_so_hr222_get_external_clock_fndecl_16966 hr222_get_external_clock fndecl 0 16966 NULL
+disable_so_evm_calc_hash_fndecl_16971 evm_calc_hash fndecl 0-4 16971 NULL
+disable_so_ima_maxorder_vardecl_ima_crypto_c_16973 ima_maxorder vardecl_ima_crypto.c 0 16973 NULL
+disable_so_delay_sh_keysc_info_16974 delay sh_keysc_info 0 16974 NULL
+disable_so_sample_point_can_bittiming_16980 sample_point can_bittiming 0 16980 NULL
+disable_so_ipmi_set_timeout_fndecl_16982 ipmi_set_timeout fndecl 0 16982 NULL
+disable_so_address_SG32ENTRY_16984 address SG32ENTRY 0 16984 NULL
+disable_so_mlx4_ib_guid_port_init_fndecl_16985 mlx4_ib_guid_port_init fndecl 2 16985 NULL
+disable_so_ma901radio_set_freq_fndecl_16989 ma901radio_set_freq fndecl 0-2 16989 NULL
+disable_so_i_ctime_f2fs_inode_17005 i_ctime f2fs_inode 0 17005 NULL
+disable_so_pa_rxrf_lna2_freq_tune_chan_info_2064_lcnphy_17009 pa_rxrf_lna2_freq_tune chan_info_2064_lcnphy 0 17009 NULL
+disable_so_vhost_add_used_and_signal_n_fndecl_17013 vhost_add_used_and_signal_n fndecl 4 17013 NULL
+disable_so_fragshift_snd_pcm_oss_runtime_17015 fragshift snd_pcm_oss_runtime 0 17015 NULL
+disable_so_sci_rx_interrupt_fndecl_17016 sci_rx_interrupt fndecl 1 17016 NULL
+disable_so_wakeup_last_time_show_fndecl_17020 wakeup_last_time_show fndecl 0 17020 NULL
+disable_so_from_addr_efx_memcpy_req_17021 from_addr efx_memcpy_req 0 17021 NULL
+disable_so_tcp_timer_core_clk_divisor_nes_adapter_17033 tcp_timer_core_clk_divisor nes_adapter 0 17033 NULL
+disable_so_reconnect_delay_srp_rport_17034 reconnect_delay srp_rport 0 17034 NULL
+disable_so_clock_frequency_s3c_camif_sensor_info_17035 clock_frequency s3c_camif_sensor_info 0 17035 NULL
+disable_so_copy_to_user_kmaddress_fndecl_17049 copy_to_user_kmaddress fndecl 0 17049 NULL
+disable_so_il_send_rxon_timing_fndecl_17051 il_send_rxon_timing fndecl 0 17051 NULL
+disable_so_system_time_pvclock_vcpu_time_info_17061 system_time pvclock_vcpu_time_info 0 17061 NULL
+disable_so_ds3234_read_time_fndecl_17062 ds3234_read_time fndecl 0 17062 NULL
+disable_so_dat_addr_batadv_orig_node_17063 dat_addr batadv_orig_node 0 17063 NULL
+disable_so_master_cycle_now_kvm_arch_17072 master_cycle_now kvm_arch 0 17072 NULL
+disable_so_netxen_decode_crb_addr_fndecl_17076 netxen_decode_crb_addr fndecl 0-1 17076 NULL
+disable_so_pwm1_freq_lm63_data_17083 pwm1_freq lm63_data 0 17083 NULL
+disable_so_leddc_on_time_ssb_sprom_17089 leddc_on_time ssb_sprom 0 17089 NULL
+disable_so_timer_offset_tg3_17106 timer_offset tg3 0 17106 NULL
+disable_so_rcvhdrqtailaddr_phys_qib_ctxtdata_17108 rcvhdrqtailaddr_phys qib_ctxtdata 0 17108 NULL nohasharray
+disable_so_next_signal_fndecl_17108 next_signal fndecl 0 17108 &disable_so_rcvhdrqtailaddr_phys_qib_ctxtdata_17108
+disable_so_ptp_write_host_time_efx_nic_type_17118 ptp_write_host_time efx_nic_type 2 17118 NULL
+disable_so_isl12057_rtc_set_time_fndecl_17119 isl12057_rtc_set_time fndecl 0 17119 NULL
+disable_so_p4_mt9t112_pll_divider_17123 p4 mt9t112_pll_divider 0 17123 NULL
+disable_so___sk_mem_schedule_fndecl_17130 __sk_mem_schedule fndecl 2 17130 NULL
+disable_so_do_sched_setscheduler_fndecl_17133 do_sched_setscheduler fndecl 2-1-0 17133 NULL
+disable_so_demod_address_s5h1420_config_17152 demod_address s5h1420_config 0 17152 NULL
+disable_so_stats_reset_time_fnic_17155 stats_reset_time fnic 0 17155 NULL nohasharray
+disable_so_buffer_addr_hi_iscsi_bd_17155 buffer_addr_hi iscsi_bd 0 17155 &disable_so_stats_reset_time_fnic_17155 nohasharray
+disable_so_ver_sync_end_via_display_timing_17155 ver_sync_end via_display_timing 0 17155 &disable_so_buffer_addr_hi_iscsi_bd_17155
+disable_so_bit_cursor_fndecl_17158 bit_cursor fndecl 4-5-6 17158 NULL
+disable_so_nv50_fan_pwm_clock_fndecl_17168 nv50_fan_pwm_clock fndecl 0 17168 NULL
+disable_so_s_def_resuid_ext2_super_block_17174 s_def_resuid ext2_super_block 0 17174 NULL
+disable_so_delay_until_ipoib_mcast_17176 delay_until ipoib_mcast 0 17176 NULL
+disable_so_command_addr_acpi_ec_17177 command_addr acpi_ec 0 17177 NULL
+disable_so_set_freq_adis16400_chip_info_17183 set_freq adis16400_chip_info 0 17183 NULL
+disable_so_fd_pppol2tpin6_addr_17186 fd pppol2tpin6_addr 0 17186 NULL
+disable_so_genwqe_set_interrupt_capability_fndecl_17191 genwqe_set_interrupt_capability fndecl 2-0 17191 NULL
+disable_so_random_frame_ehci_hcd_17194 random_frame ehci_hcd 0 17194 NULL nohasharray
+disable_so_ctrl_req_addr_dwc3_17194 ctrl_req_addr dwc3 0 17194 &disable_so_random_frame_ehci_hcd_17194
+disable_so_xhci_disable_usb3_lpm_timeout_fndecl_17199 xhci_disable_usb3_lpm_timeout fndecl 0 17199 NULL
+disable_so_sp_dma_addr_hostdata_17202 sp_dma_addr hostdata 0 17202 NULL nohasharray
+disable_so_drbg_hash_hashgen_fndecl_17202 drbg_hash_hashgen fndecl 0-3 17202 &disable_so_sp_dma_addr_hostdata_17202
+disable_so_demod_address_mt312_config_17203 demod_address mt312_config 0 17203 NULL
+disable_so_buf_count_ccp_sha_req_ctx_17205 buf_count ccp_sha_req_ctx 0 17205 NULL
+disable_so_atiixp_set_pio_timing_fndecl_17209 atiixp_set_pio_timing fndecl 3 17209 NULL
+disable_so_tpm2_get_random_fndecl_17212 tpm2_get_random fndecl 0-3 17212 NULL
+disable_so_offset_btrfs_key_17213 offset btrfs_key 0 17213 NULL
+disable_so_dccps_timestamp_time_dccp_sock_17214 dccps_timestamp_time dccp_sock 0 17214 NULL
+disable_so_this_tsc_write_kvm_vcpu_arch_17221 this_tsc_write kvm_vcpu_arch 0 17221 NULL
+disable_so_cpufreq_driver_target_fndecl_17222 cpufreq_driver_target fndecl 2 17222 NULL
+disable_so_prev_task_link_tss_segment_16_17224 prev_task_link tss_segment_16 0 17224 NULL
+disable_so_sc92031_interrupt_fndecl_17226 sc92031_interrupt fndecl 1 17226 NULL nohasharray
+disable_so_daddr_irnet_socket_17226 daddr irnet_socket 0 17226 &disable_so_sc92031_interrupt_fndecl_17226 nohasharray
+disable_so_new_center_freq_seg1_ieee80211_wide_bw_chansw_ie_17226 new_center_freq_seg1 ieee80211_wide_bw_chansw_ie 0 17226 &disable_so_daddr_irnet_socket_17226
+disable_so_iffreq_tuner_params_17241 iffreq tuner_params 0 17241 NULL
+disable_so_erase_time_flchip_17257 erase_time flchip 0 17257 NULL
+disable_so_lp8788_is_valid_buck_addr_fndecl_17271 lp8788_is_valid_buck_addr fndecl 1 17271 NULL nohasharray
+disable_so_ntfs_mft_bitmap_find_and_alloc_free_rec_nolock_fndecl_17271 ntfs_mft_bitmap_find_and_alloc_free_rec_nolock fndecl 0 17271 &disable_so_lp8788_is_valid_buck_addr_fndecl_17271
+disable_so_pci_timedia_setup_fndecl_17276 pci_timedia_setup fndecl 4 17276 NULL
+disable_so_security_task_setpgid_fndecl_17277 security_task_setpgid fndecl 2 17277 NULL
+disable_so_ref_div_pll_info_17279 ref_div pll_info 0 17279 NULL nohasharray
+disable_so_ifr6_ifindex_in6_ifreq_17279 ifr6_ifindex in6_ifreq 0 17279 &disable_so_ref_div_pll_info_17279
+disable_so_nm_gid_nl_mmap_hdr_17280 nm_gid nl_mmap_hdr 0 17280 NULL
+disable_so_account_system_time_fndecl_17285 account_system_time fndecl 3-4 17285 NULL nohasharray
+disable_so_ptrace_signal_fndecl_17285 ptrace_signal fndecl 0-1 17285 &disable_so_account_system_time_fndecl_17285
+disable_so_cm36651_read_int_time_fndecl_17287 cm36651_read_int_time fndecl 0 17287 NULL
+disable_so_calculate_destination_timeout_fndecl_17288 calculate_destination_timeout fndecl 0 17288 NULL
+disable_so_hsync_pulse_width_lo_detailed_pixel_timing_17297 hsync_pulse_width_lo detailed_pixel_timing 0 17297 NULL
+disable_so_pci_pm_runtime_suspend_fndecl_17299 pci_pm_runtime_suspend fndecl 0 17299 NULL
+disable_so_ifindex_ip6addrlbl_entry_17305 ifindex ip6addrlbl_entry 0 17305 NULL
+disable_so_lookup_enclosing_address_handler_fndecl_17312 lookup_enclosing_address_handler fndecl 3 17312 NULL
+disable_so_addrconf_mod_rs_timer_fndecl_17333 addrconf_mod_rs_timer fndecl 2 17333 NULL nohasharray
+disable_so_dma_addr_tse_buffer_17333 dma_addr tse_buffer 0 17333 &disable_so_addrconf_mod_rs_timer_fndecl_17333
+disable_so_mod_timer_pinned_fndecl_17334 mod_timer_pinned fndecl 2-0 17334 NULL
+disable_so_cpufreq_power_cooling_register_fndecl_17338 cpufreq_power_cooling_register fndecl 2 17338 NULL
+disable_so_bytenr_btrfs_delayed_ref_node_17344 bytenr btrfs_delayed_ref_node 0 17344 NULL
+disable_so_genwqe_debugfs_queue_working_time_open_fndecl_17354 genwqe_debugfs_queue_working_time_open fndecl 0 17354 NULL
+disable_so_poll_select_set_timeout_fndecl_17361 poll_select_set_timeout fndecl 2-3 17361 NULL nohasharray
+disable_so_dma_addr_efx_buffer_17361 dma_addr efx_buffer 0 17361 &disable_so_poll_select_set_timeout_fndecl_17361
+disable_so_loc_addr_nes_cm_node_17375 loc_addr nes_cm_node 0 17375 NULL
+disable_so_sdev_show_eh_timeout_fndecl_17386 sdev_show_eh_timeout fndecl 0 17386 NULL
+disable_so_isl1208_i2c_set_time_fndecl_17398 isl1208_i2c_set_time fndecl 0 17398 NULL
+disable_so_lx_interrupt_handle_async_events_fndecl_17400 lx_interrupt_handle_async_events fndecl 0 17400 NULL
+disable_so_phys_addr_pmem_device_17405 phys_addr pmem_device 0 17405 NULL
+disable_so___cpufreq_remove_dev_prepare_fndecl_17414 __cpufreq_remove_dev_prepare fndecl 0 17414 NULL
+disable_so_readpage_address_space_operations_17426 readpage address_space_operations 0 17426 NULL
+disable_so_last_tdls_pkt_time_sta_info_17439 last_tdls_pkt_time sta_info 0 17439 NULL
+disable_so_bfa_fcs_rport_set_del_timeout_fndecl_17442 bfa_fcs_rport_set_del_timeout fndecl 1 17442 NULL nohasharray
+disable_so_last_div_tuner_simple_priv_17442 last_div tuner_simple_priv 0 17442 &disable_so_bfa_fcs_rport_set_del_timeout_fndecl_17442
+disable_so_clockevents_update_freq_fndecl_17446 clockevents_update_freq fndecl 2 17446 NULL
+disable_so_dev_addr_init_fndecl_17450 dev_addr_init fndecl 0 17450 NULL
+disable_so_div_clk_fixed_factor_17451 div clk_fixed_factor 0 17451 NULL
+disable_so_t2_ptr_hash_tbl_addr_hi_fcoe_kwqe_init2_17457 t2_ptr_hash_tbl_addr_hi fcoe_kwqe_init2 0 17457 NULL
+disable_so_i_unsignaled_bytes_rds_iw_connection_17462 i_unsignaled_bytes rds_iw_connection 0 17462 NULL
+disable_so_calc_pmtimer_ref_fndecl_17467 calc_pmtimer_ref fndecl 0-2-3-1 17467 NULL
+disable_so_mb_dma_address_skd_fitmsg_context_17468 mb_dma_address skd_fitmsg_context 0 17468 NULL
+disable_so_bd_list_addr_hi_bnx2i_cmd_request_17469 bd_list_addr_hi bnx2i_cmd_request 0 17469 NULL
+disable_so_schedule_iso_resource_fndecl_17474 schedule_iso_resource fndecl 2 17474 NULL
+disable_so_select_addr_qla83xx_minidump_entry_pollrd_17476 select_addr qla83xx_minidump_entry_pollrd 0 17476 NULL
+disable_so_ipv4_daddr_nf_bridge_info_17490 ipv4_daddr nf_bridge_info 0 17490 NULL
+disable_so_fifo_delay_map_brcmf_fws_info_17499 fifo_delay_map brcmf_fws_info 0 17499 NULL
+disable_so_cpumask_next_and_fndecl_17511 cpumask_next_and fndecl 1-0 17511 NULL
+disable_so_crypto_ctr_crypt_fndecl_17512 crypto_ctr_crypt fndecl 0-4 17512 NULL
+disable_so_current_frequency_or51132_state_17519 current_frequency or51132_state 0 17519 NULL
+disable_so_clocks_calc_max_nsecs_fndecl_17521 clocks_calc_max_nsecs fndecl 1-2-3-4-0 17521 NULL
+disable_so_brcmf_get_next_free_bsscfgidx_fndecl_17528 brcmf_get_next_free_bsscfgidx fndecl 0 17528 NULL
+disable_so_ide_dma_timeout_retry_fndecl_17531 ide_dma_timeout_retry fndecl 2 17531 NULL
+disable_so_radeon_legacy_get_engine_clock_fndecl_17536 radeon_legacy_get_engine_clock fndecl 0 17536 NULL
+disable_so_longcal_timer_ath_ani_17540 longcal_timer ath_ani 0 17540 NULL
+disable_so_beacon_init_val_il_rxon_time_cmd_17543 beacon_init_val il_rxon_time_cmd 0 17543 NULL
+disable_so_bcma_pmu_xtalfreq_fndecl_17556 bcma_pmu_xtalfreq fndecl 0 17556 NULL
+disable_so_hdelay_timing_17557 hdelay timing 0 17557 NULL
+disable_so_ticks_snd_seq_timer_17559 ticks snd_seq_timer 0 17559 NULL nohasharray
+disable_so_coublock_signal_struct_17559 coublock signal_struct 0 17559 &disable_so_ticks_snd_seq_timer_17559
+disable_so_snd_timer_dev_register_fndecl_17565 snd_timer_dev_register fndecl 0 17565 NULL
+disable_so_wait_on_bit_lock_action_fndecl_17576 wait_on_bit_lock_action fndecl 0 17576 NULL
+disable_so_node_guid_nodeinfo_17589 node_guid nodeinfo 0 17589 NULL
+disable_so_packet_filter_bitmap_kaweth_device_17590 packet_filter_bitmap kaweth_device 0 17590 NULL
+disable_so_erase_timeout_sd_ssr_17594 erase_timeout sd_ssr 0 17594 NULL
+disable_so_ratio_r_rj54n1_clock_div_17609 ratio_r rj54n1_clock_div 0 17609 NULL
+disable_so_clock_info_cmd_complete_fndecl_17616 clock_info_cmd_complete fndecl 0 17616 NULL
+disable_so_cir_addr_nvt_dev_17619 cir_addr nvt_dev 0 17619 NULL
+disable_so_plink_timeout_mesh_config_17621 plink_timeout mesh_config 0 17621 NULL
+disable_so_numaddr_mwl8k_cmd_mac_multicast_adr_17633 numaddr mwl8k_cmd_mac_multicast_adr 0 17633 NULL
+enable_so_last_used_idx_vringh_17635 last_used_idx vringh 0 17635 NULL nohasharray
+disable_so_addr_nvbios_extdev_func_17635 addr nvbios_extdev_func 0 17635 &enable_so_last_used_idx_vringh_17635 nohasharray
+disable_so_xfs_btree_set_numrecs_fndecl_17635 xfs_btree_set_numrecs fndecl 2 17635 &disable_so_addr_nvbios_extdev_func_17635
+disable_so_pll_clkdiv_adau1701_17652 pll_clkdiv adau1701 0 17652 NULL
+disable_so_btree_insert_raw_fndecl_17655 btree_insert_raw fndecl 0-2 17655 NULL
+disable_so_svm_adjust_tsc_offset_fndecl_17663 svm_adjust_tsc_offset fndecl 2 17663 NULL
+disable_so_mpll_ss2_ni_clock_registers_17677 mpll_ss2 ni_clock_registers 0 17677 NULL
+disable_so_seq_zoran_sync_17679 seq zoran_sync 0 17679 NULL
+disable_so_frequency_drv2667_data_17686 frequency drv2667_data 0 17686 NULL
+disable_so_ieee80211_if_fmt_beacon_timeout_fndecl_17690 ieee80211_if_fmt_beacon_timeout fndecl 0-3 17690 NULL
+disable_so_switch_time_iwl5000_channel_switch_cmd_17709 switch_time iwl5000_channel_switch_cmd 0 17709 NULL
+disable_so_paging64_walk_addr_generic_fndecl_17719 paging64_walk_addr_generic fndecl 4-5 17719 NULL
+disable_so_hw_usb_set_address_fndecl_17723 hw_usb_set_address fndecl 2 17723 NULL
+disable_so_sysrq_reset_downtime_ms_vardecl_sysrq_c_17734 sysrq_reset_downtime_ms vardecl_sysrq.c 0 17734 NULL
+disable_so_ttime_mean_cfq_ttime_17742 ttime_mean cfq_ttime 0 17742 NULL nohasharray
+disable_so_cpufreq_add_dev_fndecl_17742 cpufreq_add_dev fndecl 0 17742 &disable_so_ttime_mean_cfq_ttime_17742
+disable_so_int_poll_timeout_fndecl_17745 int_poll_timeout fndecl 1 17745 NULL
+disable_so_pmdown_time_snd_soc_pcm_runtime_17753 pmdown_time snd_soc_pcm_runtime 0 17753 NULL
+disable_so_i_dtime_ocfs2_dinode_17762 i_dtime ocfs2_dinode 0 17762 NULL
+disable_so_stk1160_write_reg_fndecl_17777 stk1160_write_reg fndecl 0-2-3 17777 NULL
+disable_so_wlcore_save_freed_pkts_addr_fndecl_17778 wlcore_save_freed_pkts_addr fndecl 3 17778 NULL
+disable_so_sys_getuid_fndecl_17783 sys_getuid fndecl 0 17783 NULL
+disable_so_ath5k_hw_set_ack_timeout_fndecl_17785 ath5k_hw_set_ack_timeout fndecl 2 17785 NULL
+disable_so_vfio_intx_set_signal_fndecl_17806 vfio_intx_set_signal fndecl 0 17806 NULL
+disable_so_hash_dst_fndecl_17815 hash_dst fndecl 0-2-3 17815 NULL
+disable_so_ci_set_smc_sram_address_fndecl_17817 ci_set_smc_sram_address fndecl 0-2 17817 NULL
+disable_so_ax_pt_regs_17818 ax pt_regs 0 17818 NULL
+disable_so_gf110_fan_pwm_clock_fndecl_17824 gf110_fan_pwm_clock fndecl 0 17824 NULL nohasharray
+disable_so_txdescmem_busaddr_altera_tse_private_17824 txdescmem_busaddr altera_tse_private 0 17824 &disable_so_gf110_fan_pwm_clock_fndecl_17824
+disable_so_shash_digest_unaligned_fndecl_17828 shash_digest_unaligned fndecl 0-3 17828 NULL
+disable_so_crypto_user_rcv_msg_fndecl_17830 crypto_user_rcv_msg fndecl 0 17830 NULL
+disable_so_hfsplus_bnode_findhash_fndecl_17834 hfsplus_bnode_findhash fndecl 2 17834 NULL
+disable_so_hactive_lo_oaktrail_timing_info_17844 hactive_lo oaktrail_timing_info 0 17844 NULL
+disable_so_paddr_eni_skb_prv_17847 paddr eni_skb_prv 0 17847 NULL nohasharray
+disable_so_proc_disconnectsignal_fndecl_17847 proc_disconnectsignal fndecl 0 17847 &disable_so_paddr_eni_skb_prv_17847
+disable_so_msec_bts_action_delay_17848 msec bts_action_delay 0 17848 NULL
+disable_so_start_fixed_mtrr_segment_17854 start fixed_mtrr_segment 0 17854 NULL
+disable_so_addr_mlx4_wqe_data_seg_17863 addr mlx4_wqe_data_seg 0 17863 NULL
+disable_so_vhost32_to_cpu_fndecl_17870 vhost32_to_cpu fndecl 0-2 17870 NULL
+disable_so_wl1273_fm_get_freq_fndecl_17876 wl1273_fm_get_freq fndecl 0 17876 NULL
+disable_so_sumo_set_divider_value_fndecl_17879 sumo_set_divider_value fndecl 3-2 17879 NULL
+disable_so_dev_stc_uvc_clock_sample_17886 dev_stc uvc_clock_sample 0 17886 NULL
+disable_so_xfs_bmap_extents_to_btree_fndecl_17888 xfs_bmap_extents_to_btree fndecl 0 17888 NULL nohasharray
+disable_so_sha1_ssse3_finup_fndecl_17888 sha1_ssse3_finup fndecl 3 17888 &disable_so_xfs_bmap_extents_to_btree_fndecl_17888
+disable_so_address_threshold_block_17898 address threshold_block 0 17898 NULL
+disable_so_timeout_vardecl_w83793_c_17902 timeout vardecl_w83793.c 0 17902 NULL
+disable_so_bitmap_port_gc_test_fndecl_17905 bitmap_port_gc_test fndecl 3 17905 NULL
+disable_so_efx_ef10_filter_hash_fndecl_17915 efx_ef10_filter_hash fndecl 0 17915 NULL
+disable_so_i40evf_init_interrupt_scheme_fndecl_17922 i40evf_init_interrupt_scheme fndecl 0 17922 NULL
+disable_so_get_descriptor_addr_fndecl_17925 get_descriptor_addr fndecl 0 17925 NULL
+disable_so_fll_loop_gain__fll_div_17926 fll_loop_gain _fll_div 0 17926 NULL
+disable_so_timestamp_nfs_pgio_header_17936 timestamp nfs_pgio_header 0 17936 NULL
+disable_so_axp20x_set_dcdc_freq_fndecl_17938 axp20x_set_dcdc_freq fndecl 0-2 17938 NULL
+disable_so_fc2580_s_frequency_fndecl_17946 fc2580_s_frequency fndecl 0 17946 NULL
+disable_so_cxd2820r_sleep_fndecl_17948 cxd2820r_sleep fndecl 0 17948 NULL
+disable_so_shash_update_unaligned_fndecl_17955 shash_update_unaligned fndecl 0-3 17955 NULL
+disable_so_queue_snd_seq_queue_timer_17961 queue snd_seq_queue_timer 0 17961 NULL nohasharray
+disable_so_toshiba_sleep_functions_status_get_fndecl_17961 toshiba_sleep_functions_status_get fndecl 0 17961 &disable_so_queue_snd_seq_queue_timer_17961
+disable_so_pcc_cpufreq_probe_fndecl_17966 pcc_cpufreq_probe fndecl 0 17966 NULL nohasharray
+disable_so_rsa_extract_mpi_fndecl_17966 rsa_extract_mpi fndecl 5 17966 &disable_so_pcc_cpufreq_probe_fndecl_17966
+disable_so_rxrpc_resend_timeout_vardecl_17967 rxrpc_resend_timeout vardecl 0 17967 NULL nohasharray
+disable_so_cxd2820r_sleep_c_fndecl_17967 cxd2820r_sleep_c fndecl 0 17967 &disable_so_rxrpc_resend_timeout_vardecl_17967
+disable_so_ab3100_get_register_page_interruptible_fndecl_17972 ab3100_get_register_page_interruptible fndecl 0 17972 NULL
+disable_so_perf_event_time_fndecl_17980 perf_event_time fndecl 0 17980 NULL nohasharray
+disable_so_crypto_ahash_update_fndecl_17980 crypto_ahash_update fndecl 0 17980 &disable_so_perf_event_time_fndecl_17980
+disable_so_palmas_clear_interrupts_fndecl_17987 palmas_clear_interrupts fndecl 0 17987 NULL
+disable_so_timeout_vardecl_nf_conntrack_snmp_c_17991 timeout vardecl_nf_conntrack_snmp.c 0 17991 NULL
+disable_so_addr_lo_eth_rx_sge_17992 addr_lo eth_rx_sge 0 17992 NULL
+disable_so_cryptd_hash_update_fndecl_17997 cryptd_hash_update fndecl 2 17997 NULL
+disable_so_crypto_authenc_esn_setkey_fndecl_18010 crypto_authenc_esn_setkey fndecl 0 18010 NULL
+disable_so_uwb_rc_mac_addr_store_fndecl_18016 uwb_rc_mac_addr_store fndecl 0-4 18016 NULL
+disable_so_netlbl_unlhsh_hash_fndecl_18024 netlbl_unlhsh_hash fndecl 0-1 18024 NULL
+disable_so_min_delta_ns_clock_event_device_18031 min_delta_ns clock_event_device 0 18031 NULL
+disable_so_ali_timeout_bits_vardecl_alim1535_wdt_c_18033 ali_timeout_bits vardecl_alim1535_wdt.c 0 18033 NULL
+disable_so_sci_mpxed_interrupt_fndecl_18035 sci_mpxed_interrupt fndecl 1 18035 NULL
+disable_so_time_freq_vardecl_ntp_c_18036 time_freq vardecl_ntp.c 0 18036 NULL
+disable_so_be_cmd_page_addrs_prepare_fndecl_18059 be_cmd_page_addrs_prepare fndecl 2 18059 NULL
+disable_so_base_addr_brcmf_pcie_console_18075 base_addr brcmf_pcie_console 0 18075 NULL
+disable_so_seq_cn_msg_18076 seq cn_msg 0 18076 NULL
+disable_so_packet_time_ipw_ibss_seq_18079 packet_time ipw_ibss_seq 0 18079 NULL
+disable_so_atomic_set_property_drm_connector_funcs_18088 atomic_set_property drm_connector_funcs 0-4 18088 NULL
+disable_so_ts_jiffies_uwb_event_18092 ts_jiffies uwb_event 0 18092 NULL nohasharray
+disable_so_xc_set_rf_frequency_fndecl_18092 xc_set_rf_frequency fndecl 0-2 18092 &disable_so_ts_jiffies_uwb_event_18092
+disable_so_beacon_time_tsf_bits_il_hw_params_18095 beacon_time_tsf_bits il_hw_params 0 18095 NULL
+disable_so_restore_freq_cpufreq_policy_18098 restore_freq cpufreq_policy 0 18098 NULL
+disable_so_link_check_timeout_ixgbe_adapter_18101 link_check_timeout ixgbe_adapter 0 18101 NULL
+disable_so_zd_iowrite32_fndecl_18117 zd_iowrite32 fndecl 0-3 18117 NULL nohasharray
+disable_so_block_bitmap_ext3_new_group_data_18117 block_bitmap ext3_new_group_data 0 18117 &disable_so_zd_iowrite32_fndecl_18117
+disable_so_radeon_fence_schedule_check_fndecl_18136 radeon_fence_schedule_check fndecl 2 18136 NULL
+disable_so_ed_schedule_fndecl_18142 ed_schedule fndecl 0 18142 NULL
+disable_so_pci_clock_ctrl_tg3_18144 pci_clock_ctrl tg3 0 18144 NULL
+disable_so_start_i915_address_space_18152 start i915_address_space 0 18152 NULL
+disable_so_reg_w_fndecl_18159 reg_w fndecl 2 18159 NULL
+disable_so_xfrm_get_saddr_fndecl_18161 xfrm_get_saddr fndecl 4 18161 NULL
+disable_so_src_addr_rcar_dmac_xfer_chunk_18165 src_addr rcar_dmac_xfer_chunk 0 18165 NULL
+disable_so_chip_init_time_esas2r_adapter_18169 chip_init_time esas2r_adapter 0 18169 NULL
+disable_so___btree_submit_bio_done_fndecl_18170 __btree_submit_bio_done fndecl 0-2 18170 NULL
+disable_so_pick_local_ipaddrs_fndecl_18171 pick_local_ipaddrs fndecl 0 18171 NULL
+disable_so_host_sof_uvc_clock_sample_18177 host_sof uvc_clock_sample 0 18177 NULL
+disable_so_ratio_op_rj54n1_clock_div_18180 ratio_op rj54n1_clock_div 0 18180 NULL
+disable_so_dm_btree_remove_leaves_fndecl_18182 dm_btree_remove_leaves fndecl 0-2-4 18182 NULL
+disable_so_rfcomm_session_set_timer_fndecl_18183 rfcomm_session_set_timer fndecl 2 18183 NULL
+disable_so_i_gid_ext2_inode_18187 i_gid ext2_inode 0 18187 NULL
+disable_so_tipc_tlv_sprintf_fndecl_18203 tipc_tlv_sprintf fndecl 0 18203 NULL
+disable_so_usbnet_get_ethernet_addr_fndecl_18204 usbnet_get_ethernet_addr fndecl 0 18204 NULL
+disable_so_faddr_drm_i915_error_ring_18209 faddr drm_i915_error_ring 0 18209 NULL
+disable_so_nla_put_ipaddr4_fndecl_18214 nla_put_ipaddr4 fndecl 0 18214 NULL
+disable_so_ring_dma_addr_netdev_private_18216 ring_dma_addr netdev_private 0 18216 NULL
+disable_so_fc_gid_ft_build_fndecl_18221 fc_gid_ft_build fndecl 0-3 18221 NULL
+disable_so_base_hi_mtrr_var_range_18224 base_hi mtrr_var_range 0 18224 NULL nohasharray
+disable_so_mISDNisac_irq_fndecl_18224 mISDNisac_irq fndecl 2 18224 &disable_so_base_hi_mtrr_var_range_18224
+disable_so_no_bit_error_verify_fndecl_18225 no_bit_error_verify fndecl 4 18225 NULL
+disable_so_account_guest_time_fndecl_18233 account_guest_time fndecl 2-3 18233 NULL
+disable_so_show_port_gid_idx_fndecl_18237 show_port_gid_idx fndecl 0 18237 NULL
+disable_so_ath9k_hw_set_cts_timeout_fndecl_18239 ath9k_hw_set_cts_timeout fndecl 2 18239 NULL
+disable_so_sctp_raw_to_bind_addrs_fndecl_18240 sctp_raw_to_bind_addrs fndecl 0-3-4-5 18240 NULL
+disable_so_format_snd_pcm_oss_runtime_18246 format snd_pcm_oss_runtime 0 18246 NULL
+disable_so_ring_base_address_kfd_ioctl_update_queue_args_18252 ring_base_address kfd_ioctl_update_queue_args 0 18252 NULL
+disable_so_best_dsc_rw_freq_ide_tape_obj_18253 best_dsc_rw_freq ide_tape_obj 0 18253 NULL
+disable_so_mlx4_ib_set_default_gid_fndecl_18263 mlx4_ib_set_default_gid fndecl 3 18263 NULL
+disable_so_msrpm_base_pa_vmcb_control_area_18266 msrpm_base_pa vmcb_control_area 0 18266 NULL
+disable_so_macb_reg_writel_macb_18287 macb_reg_writel macb 3 18287 NULL
+disable_so_btrfs_inode_delayed_dir_index_count_fndecl_18292 btrfs_inode_delayed_dir_index_count fndecl 0 18292 NULL
+disable_so_rounded_hashtable_size_fndecl_18305 rounded_hashtable_size fndecl 0 18305 NULL
+disable_so_kv_calculate_ds_divider_fndecl_18314 kv_calculate_ds_divider fndecl 0 18314 NULL
+disable_so_srom_address_fndecl_18316 srom_address fndecl 2 18316 NULL
+disable_so_min_keysize_blkcipher_alg_18320 min_keysize blkcipher_alg 0 18320 NULL
+disable_so_sd_atime_stat_data_v1_18328 sd_atime stat_data_v1 0 18328 NULL nohasharray
+disable_so_last_valid_interrupt_tsc2005_18328 last_valid_interrupt tsc2005 0 18328 &disable_so_sd_atime_stat_data_v1_18328
+disable_so_divider_sm501_clock_18331 divider sm501_clock 0 18331 NULL
+disable_so_dwell_time_dfs_conf_sched_scan_settings_18333 dwell_time_dfs conf_sched_scan_settings 0 18333 NULL
+disable_so_synaptics_i2c_reschedule_work_fndecl_18336 synaptics_i2c_reschedule_work fndecl 2 18336 NULL
+disable_so_active_time_dce6_wm_params_18344 active_time dce6_wm_params 0 18344 NULL
+disable_so_shpchp_poll_time_vardecl_18356 shpchp_poll_time vardecl 0 18356 NULL
+disable_so_qat_alg_ablkcipher_init_sessions_fndecl_18359 qat_alg_ablkcipher_init_sessions fndecl 3 18359 NULL
+disable_so_next_blkaddr_node_footer_18360 next_blkaddr node_footer 0 18360 NULL
+disable_so_r9701_set_datetime_fndecl_18365 r9701_set_datetime fndecl 0 18365 NULL
+disable_so_global_default_cipher_key_size_ecryptfs_mount_crypt_stat_18369 global_default_cipher_key_size ecryptfs_mount_crypt_stat 0 18369 NULL
+disable_so_read_tsc_offset_kvm_x86_ops_18374 read_tsc_offset kvm_x86_ops 0 18374 NULL
+disable_so_chunkshift_bitmap_counts_18388 chunkshift bitmap_counts 0 18388 NULL
+disable_so_daddr_i915_page_table_entry_18391 daddr i915_page_table_entry 0 18391 NULL
+disable_so_set_addr_filters_fndecl_18395 set_addr_filters fndecl 0 18395 NULL nohasharray
+disable_so_writepages_address_space_operations_18395 writepages address_space_operations 0 18395 &disable_so_set_addr_filters_fndecl_18395
+disable_so_ablkcipher_next_fast_fndecl_18397 ablkcipher_next_fast fndecl 0 18397 NULL
+disable_so_local_ref_time_lp_18398 local_ref_time lp 0 18398 NULL
+disable_so_size__cpuid4_info_regs_18403 size _cpuid4_info_regs 0 18403 NULL
+disable_so_st_atime_sec_p9_stat_dotl_18404 st_atime_sec p9_stat_dotl 0 18404 NULL nohasharray
+disable_so_hackrf_s_frequency_fndecl_18404 hackrf_s_frequency fndecl 0 18404 &disable_so_st_atime_sec_p9_stat_dotl_18404
+disable_so_ext4_inode_bitmap_fndecl_18405 ext4_inode_bitmap fndecl 0 18405 NULL
+disable_so_crypto_sha256_finup_fndecl_18406 crypto_sha256_finup fndecl 3 18406 NULL
+disable_so_timeout_ip_vs_sync_v4_18416 timeout ip_vs_sync_v4 0 18416 NULL nohasharray
+disable_so_nla_put_hwaddr_fndecl_18416 nla_put_hwaddr fndecl 0 18416 &disable_so_timeout_ip_vs_sync_v4_18416
+disable_so_tasklet_hrtimer_init_fndecl_18423 tasklet_hrtimer_init fndecl 3 18423 NULL
+disable_so_ieee80211_if_fmt_path_refresh_time_fndecl_18427 ieee80211_if_fmt_path_refresh_time fndecl 0-3 18427 NULL
+disable_so_address_high_b43_dmadesc64_18431 address_high b43_dmadesc64 0 18431 NULL
+disable_so_wd_timeout_mei_device_18432 wd_timeout mei_device 0 18432 NULL
+disable_so_bitmap_fold_fndecl_18439 bitmap_fold fndecl 4 18439 NULL
+disable_so_dma_addr_freelQ_ce_18441 dma_addr freelQ_ce 0 18441 NULL
+disable_so_demod_address_cx24117_config_18444 demod_address cx24117_config 0 18444 NULL
+disable_so_rs5c372_get_datetime_fndecl_18451 rs5c372_get_datetime fndecl 0 18451 NULL
+disable_so_diolan_set_clock_synch_fndecl_18461 diolan_set_clock_synch fndecl 0 18461 NULL nohasharray
+disable_so_tcp_timeout_ip_vs_timeout_user_18461 tcp_timeout ip_vs_timeout_user 0 18461 &disable_so_diolan_set_clock_synch_fndecl_18461
+disable_so_mac_addr_low_nes_adapter_18465 mac_addr_low nes_adapter 0 18465 NULL nohasharray
+enable_so_get_next_ino_fndecl_18465 get_next_ino fndecl 0 18465 &disable_so_mac_addr_low_nes_adapter_18465
+disable_so_sci_interrupt_acpi_table_fadt_18467 sci_interrupt acpi_table_fadt 0 18467 NULL
+disable_so_mii_bmsr_bnx2_18468 mii_bmsr bnx2 0 18468 NULL
+disable_so_qla4xxx_fw_timestamp_show_fndecl_18474 qla4xxx_fw_timestamp_show fndecl 0 18474 NULL
+disable_so_viafb_fill_crtc_timing_fndecl_18476 viafb_fill_crtc_timing fndecl 2-3 18476 NULL
+disable_so_sysctl_max_tw_buckets_inet_timewait_death_row_18487 sysctl_max_tw_buckets inet_timewait_death_row 0 18487 NULL
+disable_so_hfdiv_dib0090_pll_18489 hfdiv dib0090_pll 0 18489 NULL
+disable_so_demod_address_si21xx_config_18490 demod_address si21xx_config 0 18490 NULL
+disable_so_sbp_tpg_attrib_show_max_reconnect_timeout_fndecl_18494 sbp_tpg_attrib_show_max_reconnect_timeout fndecl 0 18494 NULL
+disable_so_cciss_find_cfg_addrs_fndecl_18500 cciss_find_cfg_addrs fndecl 0 18500 NULL
+disable_so_sdo_runtime_resume_fndecl_18516 sdo_runtime_resume fndecl 0 18516 NULL
+disable_so_available_uuids_show_fndecl_18518 available_uuids_show fndecl 0 18518 NULL
+disable_so_mtrr_open_fndecl_18521 mtrr_open fndecl 0 18521 NULL
+disable_so_r_min_rnr_timer_ipath_qp_18527 r_min_rnr_timer ipath_qp 0 18527 NULL
+disable_so_fixed_mtrr_addr_seg_to_range_index_fndecl_18537 fixed_mtrr_addr_seg_to_range_index fndecl 1-0 18537 NULL
+disable_so_timeout_floppy_drive_params_18540 timeout floppy_drive_params 0 18540 NULL
+disable_so_show_cpu_clock_fndecl_18546 show_cpu_clock fndecl 0 18546 NULL
+disable_so_inet6_fill_ifacaddr_fndecl_18549 inet6_fill_ifacaddr fndecl 0-3-5 18549 NULL
+disable_so_physical_address_kvm_translation_18550 physical_address kvm_translation 0 18550 NULL
+disable_so_kvm_mtrr_set_msr_fndecl_18553 kvm_mtrr_set_msr fndecl 3 18553 NULL
+disable_so_dccp_timestamp_fndecl_18560 dccp_timestamp fndecl 0 18560 NULL
+disable_so_frequency_analog_parameters_18561 frequency analog_parameters 0 18561 NULL
+disable_so_resp_bd_list_addr_lo_bnx2i_login_request_18562 resp_bd_list_addr_lo bnx2i_login_request 0 18562 NULL
+disable_so_pixels_1_gpu_addr_mga_cursor_18572 pixels_1_gpu_addr mga_cursor 0 18572 NULL
+disable_so_compat_sys_stime_fndecl_18574 compat_sys_stime fndecl 0 18574 NULL
+disable_so_timestamp_fwd_flush_batadv_priv_nc_18585 timestamp_fwd_flush batadv_priv_nc 0 18585 NULL nohasharray
+disable_so_nilfs_btree_get_block_fndecl_18585 nilfs_btree_get_block fndecl 0-2 18585 &disable_so_timestamp_fwd_flush_batadv_priv_nc_18585
+disable_so_sleep_cookie_pbase_pcie_service_card_18597 sleep_cookie_pbase pcie_service_card 0 18597 NULL
+disable_so_sm_set_bitmap_fndecl_18598 sm_set_bitmap fndecl 2 18598 NULL
+disable_so_lr_timeout_ext4_li_request_18599 lr_timeout ext4_li_request 0 18599 NULL
+disable_so_start_time_bfa_diag_dport_subtest_result_s_18621 start_time bfa_diag_dport_subtest_result_s 0 18621 NULL
+disable_so_ieee80211_aes_gmac_key_setup_fndecl_18626 ieee80211_aes_gmac_key_setup fndecl 2 18626 NULL
+disable_so_code_addr_pmu_nvbios_pmuR_18630 code_addr_pmu nvbios_pmuR 0 18630 NULL
+disable_so_btree_write_alias_fndecl_18631 btree_write_alias fndecl 0 18631 NULL
+disable_so_level_btrfs_delayed_tree_ref_18632 level btrfs_delayed_tree_ref 0 18632 NULL
+disable_so_bch_strtoull_h_fndecl_18633 bch_strtoull_h fndecl 0 18633 NULL
+disable_so_resolution_snd_timer_status_18636 resolution snd_timer_status 0 18636 NULL
+disable_so_crypto_module_init_fndecl_18640 crypto_module_init fndecl 0 18640 NULL
+disable_so_mic_to_dma_addr_fndecl_18642 mic_to_dma_addr fndecl 0-2 18642 NULL
+disable_so_nonblocking_wait_time_shtc1_data_18656 nonblocking_wait_time shtc1_data 0 18656 NULL
+disable_so___remove_suid_fndecl_18657 __remove_suid fndecl 0 18657 NULL
+disable_so_bootime_st_sensor_settings_18658 bootime st_sensor_settings 0 18658 NULL
+disable_so_total_ref_mod_btrfs_delayed_ref_head_18666 total_ref_mod btrfs_delayed_ref_head 0 18666 NULL
+disable_so_is_noncanonical_address_fndecl_18677 is_noncanonical_address fndecl 1 18677 NULL
+disable_so_xcan_set_bittiming_fndecl_18678 xcan_set_bittiming fndecl 0 18678 NULL
+disable_so_ipmi_set_my_address_fndecl_18680 ipmi_set_my_address fndecl 0 18680 NULL
+disable_so_pixels_2_gpu_addr_mga_cursor_18686 pixels_2_gpu_addr mga_cursor 0 18686 NULL
+disable_so_adjust_tsc_offset_guest_fndecl_18708 adjust_tsc_offset_guest fndecl 2 18708 NULL
+disable_so_meson_spifc_runtime_resume_fndecl_18709 meson_spifc_runtime_resume fndecl 0 18709 NULL
+disable_so_mclk_pwrmgt_cntl_rv770_clock_registers_18711 mclk_pwrmgt_cntl rv770_clock_registers 0 18711 NULL
+disable_so_avgidle_cbq_class_18722 avgidle cbq_class 0 18722 NULL
+disable_so_nla_nest_end_fndecl_18729 nla_nest_end fndecl 0 18729 NULL
+disable_so_suspend_time_il_scan_cmd_18736 suspend_time il_scan_cmd 0 18736 NULL
+disable_so_jiffies_to_timespec_fndecl_18737 jiffies_to_timespec fndecl 1 18737 NULL
+disable_so___uwb_addr_print_fndecl_18746 __uwb_addr_print fndecl 0 18746 NULL
+disable_so_apicid_set_error_type_with_address_18747 apicid set_error_type_with_address 0 18747 NULL
+disable_so_reachable_time_ifla_cacheinfo_18748 reachable_time ifla_cacheinfo 0 18748 NULL
+disable_so_mxl111sf_write_reg_fndecl_18752 mxl111sf_write_reg fndecl 0 18752 NULL
+disable_so_img_ir_timing_preprocess_fndecl_18766 img_ir_timing_preprocess fndecl 2 18766 NULL
+disable_so_aosr_aic31xx_rate_divs_18787 aosr aic31xx_rate_divs 0 18787 NULL
+disable_so_led_set_flash_timeout_fndecl_18793 led_set_flash_timeout fndecl 2 18793 NULL
+disable_so_proc_dointvec_userhz_jiffies_fndecl_18794 proc_dointvec_userhz_jiffies fndecl 0 18794 NULL
+disable_so_return_address_stack_frame_18797 return_address stack_frame 0 18797 NULL
+disable_so_perf_set_shadow_time_fndecl_18814 perf_set_shadow_time fndecl 3 18814 NULL nohasharray
+disable_so_start_time_mem_ctl_info_18814 start_time mem_ctl_info 0 18814 &disable_so_perf_set_shadow_time_fndecl_18814
+disable_so_out_of_int_time_mmc_ext_csd_18824 out_of_int_time mmc_ext_csd 0 18824 NULL
+disable_so_tmr_subdevice_snd_timer_18828 tmr_subdevice snd_timer 0 18828 NULL
+disable_so_xgmac_reg_addr_read_fndecl_18829 xgmac_reg_addr_read fndecl 3-0 18829 NULL
+disable_so_iscsi_nacl_attrib_show_dataout_timeout_retries_fndecl_18834 iscsi_nacl_attrib_show_dataout_timeout_retries fndecl 0 18834 NULL
+disable_so_ip_hash_net4_elem_18835 ip hash_net4_elem 0 18835 NULL
+disable_so_gid_ucred_18846 gid ucred 0 18846 NULL
+disable_so_r44_val_fc2580_freq_regs_18847 r44_val fc2580_freq_regs 0 18847 NULL
+disable_so_fotg210_set_dev_addr_fndecl_18854 fotg210_set_dev_addr fndecl 2 18854 NULL
+disable_so_mac_time_hostap_80211_rx_status_18865 mac_time hostap_80211_rx_status 0 18865 NULL
+disable_so___smsc95xx_write_reg_fndecl_18876 __smsc95xx_write_reg fndecl 0-2-3 18876 NULL
+disable_so_svm_write_tsc_offset_fndecl_18879 svm_write_tsc_offset fndecl 2 18879 NULL
+disable_so_max8997_rtc_read_time_fndecl_18881 max8997_rtc_read_time fndecl 0 18881 NULL nohasharray
+disable_so_prev_tsc_cpudata_18881 prev_tsc cpudata 0 18881 &disable_so_max8997_rtc_read_time_fndecl_18881
+disable_so_padlock_sha1_update_nano_fndecl_18884 padlock_sha1_update_nano fndecl 3 18884 NULL
+disable_so_sysctl_rose_restart_request_timeout_vardecl_18885 sysctl_rose_restart_request_timeout vardecl 0 18885 NULL
+disable_so_sysctl_aarp_expiry_time_vardecl_18891 sysctl_aarp_expiry_time vardecl 0 18891 NULL
+disable_so_crypto_register_pcomp_fndecl_18915 crypto_register_pcomp fndecl 0 18915 NULL
+disable_so_ata_timing_cycle2mode_fndecl_18918 ata_timing_cycle2mode fndecl 0 18918 NULL
+disable_so_proc_dointvec_ms_jiffies_fndecl_18925 proc_dointvec_ms_jiffies fndecl 0 18925 NULL
+disable_so_busaddr_vlsi_irda_dev_18931 busaddr vlsi_irda_dev 0 18931 NULL
+disable_so_rx_coalescing_timeo_bna_ccb_18934 rx_coalescing_timeo bna_ccb 0 18934 NULL
+disable_so_tx_ring_dma_addr_pcnet32_private_18936 tx_ring_dma_addr pcnet32_private 0 18936 NULL
+disable_so_netlbl_unlhsh_add_addr6_fndecl_18945 netlbl_unlhsh_add_addr6 fndecl 4-0 18945 NULL nohasharray
+disable_so_libipw_channel_to_freq_fndecl_18945 libipw_channel_to_freq fndecl 0-2 18945 &disable_so_netlbl_unlhsh_add_addr6_fndecl_18945
+disable_so_oo_time_nfs4_openowner_18954 oo_time nfs4_openowner 0 18954 NULL
+disable_so_rht_key_hashfn_fndecl_18957 rht_key_hashfn fndecl 0 18957 NULL
+disable_so_query_id_mlx4_alias_guid_work_context_18958 query_id mlx4_alias_guid_work_context 0 18958 NULL nohasharray
+disable_so_address_rq_enet_desc_18958 address rq_enet_desc 0 18958 &disable_so_query_id_mlx4_alias_guid_work_context_18958
+disable_so_scan_bitmap_fndecl_18963 scan_bitmap fndecl 0-3-5-7 18963 NULL
+disable_so_btrfs_item_key_to_cpu_fndecl_18966 btrfs_item_key_to_cpu fndecl 3 18966 NULL
+disable_so_store_fan_time_fndecl_18972 store_fan_time fndecl 0-4 18972 NULL
+disable_so_hash_conntrack_fndecl_18974 hash_conntrack fndecl 0 18974 NULL
+disable_so_lsndtime_tcp_sock_18975 lsndtime tcp_sock 0 18975 NULL
+disable_so_ratio_tg_rj54n1_clock_div_18979 ratio_tg rj54n1_clock_div 0 18979 NULL
+disable_so_freq_lo_od_cpu_dbs_info_s_18987 freq_lo od_cpu_dbs_info_s 0 18987 NULL
+disable_so_usnic_uiom_interval_tree_compute_subtree_last_fndecl_18989 usnic_uiom_interval_tree_compute_subtree_last fndecl 0 18989 NULL
+disable_so_cg_spll_spread_spectrum_rv770_clock_registers_19000 cg_spll_spread_spectrum rv770_clock_registers 0 19000 NULL
+disable_so_ps_poll_ps_poll_timeouts_read_fndecl_19005 ps_poll_ps_poll_timeouts_read fndecl 3 19005 NULL
+disable_so_addr_low_sata_start_req_19006 addr_low sata_start_req 0 19006 NULL
+disable_so_seq_rxrpc_header_19018 seq rxrpc_header 0 19018 NULL
+disable_so_bs_uid_xfs_bstat_19023 bs_uid xfs_bstat 0 19023 NULL
+disable_so_cmb_rx_timer_atl1_hw_19025 cmb_rx_timer atl1_hw 0 19025 NULL
+disable_so_timestamp_batadv_nc_packet_19027 timestamp batadv_nc_packet 0 19027 NULL
+disable_so_addr_high_ssp_ini_io_start_req_19029 addr_high ssp_ini_io_start_req 0 19029 NULL
+disable_so_n_addresses_rxk5_key_19030 n_addresses rxk5_key 0 19030 NULL
+e_old_decode_dev_fndecl_19035 old_decode_dev fndecl 0-1 19035 NULL nohasharray
+disable_so_ccp_crypto_enqueue_request_fndecl_19035 ccp_crypto_enqueue_request fndecl 0 19035 &e_old_decode_dev_fndecl_19035
+disable_so_timeout_mxser_port_19037 timeout mxser_port 0 19037 NULL
+disable_so_xfs_btree_rec_addr_fndecl_19048 xfs_btree_rec_addr fndecl 2 19048 NULL
+disable_so_sz_qat_crypto_request_buffs_19050 sz qat_crypto_request_buffs 0 19050 NULL
+disable_so_start_field_bit_offset_acpi_object_field_common_19052 start_field_bit_offset acpi_object_field_common 0 19052 NULL
+disable_so_compat_sys_timer_create_fndecl_19053 compat_sys_timer_create fndecl 1 19053 NULL
+disable_so_ioctl_busaddr_ips_ha_19067 ioctl_busaddr ips_ha 0 19067 NULL
+disable_so_crypto_rng_reset_fndecl_19075 crypto_rng_reset fndecl 3 19075 NULL
+disable_so_alignmask_crypto_hash_walk_19078 alignmask crypto_hash_walk 0 19078 NULL
+disable_so_dst_addr_hi_dmae_command_19086 dst_addr_hi dmae_command 0 19086 NULL
+disable_so_tx_time_us_qlcnic_nic_intr_coalesce_19089 tx_time_us qlcnic_nic_intr_coalesce 0 19089 NULL
+disable_so_sctp_getsockopt_peer_addr_info_fndecl_19099 sctp_getsockopt_peer_addr_info fndecl 0 19099 NULL
+disable_so_ack_interrupt_mbus_hw_ops_19100 ack_interrupt mbus_hw_ops 2 19100 NULL
+disable_so_fm_tx_set_freq_fndecl_19116 fm_tx_set_freq fndecl 0-2 19116 NULL
+disable_so_time_stabiliz_dibx000_agc_config_19117 time_stabiliz dibx000_agc_config 0 19117 NULL
+disable_so_m_session_timeout_ceph_mdsmap_19122 m_session_timeout ceph_mdsmap 0 19122 NULL nohasharray
+disable_so_rq_first_pbe_addr_hi_fcoe_kwqe_conn_offload1_19122 rq_first_pbe_addr_hi fcoe_kwqe_conn_offload1 0 19122 &disable_so_m_session_timeout_ceph_mdsmap_19122
+disable_so_cfg80211_set_cipher_pairwise_fndecl_19124 cfg80211_set_cipher_pairwise fndecl 2 19124 NULL
+disable_so_addr_low_bufq_addr_element_19128 addr_low bufq_addr_element 0 19128 NULL
+disable_so__random_read_fndecl_19137 _random_read fndecl 0-1-3 19137 NULL
+disable_so_data_timeout_ns_mmc_ioc_cmd_19142 data_timeout_ns mmc_ioc_cmd 0 19142 NULL
+disable_so_sys_timer_getoverrun_fndecl_19145 sys_timer_getoverrun fndecl 1-0 19145 NULL
+disable_so_force_static_address_read_fndecl_19149 force_static_address_read fndecl 3-0 19149 NULL
+disable_so_timeout_vardecl_alim7101_wdt_c_19153 timeout vardecl_alim7101_wdt.c 0 19153 NULL
+disable_so_get_msr_x86_emulate_ops_19170 get_msr x86_emulate_ops 2 19170 NULL
+disable_so_freeze_timeout_msecs_vardecl_19173 freeze_timeout_msecs vardecl 0 19173 NULL
+disable_so_time_mid_afs_uuid_19174 time_mid afs_uuid 0 19174 NULL
+disable_so_do_signal_stop_fndecl_19193 do_signal_stop fndecl 1 19193 NULL
+disable_so_xtime_update_fndecl_19206 xtime_update fndecl 1 19206 NULL
+disable_so_sd_uid_stat_data_19209 sd_uid stat_data 0 19209 NULL
+disable_so_conn_schedule_ip_vs_protocol_19210 conn_schedule ip_vs_protocol 1 19210 NULL
+disable_so_ocfs2_dx_dir_name_hash_fndecl_19211 ocfs2_dx_dir_name_hash fndecl 3 19211 NULL
+disable_so_posix_clock_register_fndecl_19213 posix_clock_register fndecl 2-0 19213 NULL
+disable_so_ctnl_timeout_parse_policy_fndecl_19218 ctnl_timeout_parse_policy fndecl 0 19218 NULL
+disable_so_get_parent_r8a66597_address_fndecl_19219 get_parent_r8a66597_address fndecl 0 19219 NULL
+disable_so_ath5k_hw_htoclock_fndecl_19227 ath5k_hw_htoclock fndecl 2-0 19227 NULL
+disable_so_cport_addr_nm256_19228 cport_addr nm256 0 19228 NULL
+disable_so_mt2032_compute_freq_fndecl_19230 mt2032_compute_freq fndecl 2-3-4 19230 NULL
+disable_so_prox_adjust_channel_bit_mask_fndecl_19253 prox_adjust_channel_bit_mask fndecl 3 19253 NULL
+disable_so_base_addr_vnic_dev_ring_19264 base_addr vnic_dev_ring 0 19264 NULL
+disable_so_authenc_geniv_ahash_update_done_fndecl_19273 authenc_geniv_ahash_update_done fndecl 2 19273 NULL
+disable_so_ath6kl_cfg80211_host_sleep_fndecl_19284 ath6kl_cfg80211_host_sleep fndecl 0 19284 NULL
+disable_so_keyring_detect_cycle_fndecl_19294 keyring_detect_cycle fndecl 0 19294 NULL
+disable_so_bus_addr_img_hash_dev_19301 bus_addr img_hash_dev 0 19301 NULL
+disable_so_nv04_timer_fini_fndecl_19314 nv04_timer_fini fndecl 0 19314 NULL
+disable_so_sysctl_x25_restart_request_timeout_vardecl_19317 sysctl_x25_restart_request_timeout vardecl 0 19317 NULL
+disable_so_timer_in_use_nes_hw_tune_timer_19327 timer_in_use nes_hw_tune_timer 0 19327 NULL
+disable_so_misdn_add_timer_fndecl_19332 misdn_add_timer fndecl 2-0 19332 NULL
+disable_so_timeout_vardecl_rn5t618_wdt_c_19337 timeout vardecl_rn5t618_wdt.c 0 19337 NULL
+disable_so_err_addr_bfa_diag_memtest_result_19350 err_addr bfa_diag_memtest_result 0 19350 NULL
+disable_so_jfs_strtoUCS_fndecl_19357 jfs_strtoUCS fndecl 3-0 19357 NULL
+disable_so_addr_to_vsyscall_nr_fndecl_19368 addr_to_vsyscall_nr fndecl 0-1 19368 NULL
+disable_so_small_buf_phy_addr_high_ql3_adapter_19371 small_buf_phy_addr_high ql3_adapter 0 19371 NULL
+disable_so_micd_bias_start_time_arizona_pdata_19379 micd_bias_start_time arizona_pdata 0 19379 NULL
+disable_so_current_frequency_s5h1411_state_19382 current_frequency s5h1411_state 0 19382 NULL
+disable_so_silence_threshold_snd_pcm_runtime_19384 silence_threshold snd_pcm_runtime 0 19384 NULL
+disable_so_pid_pppol2tpv3_addr_19385 pid pppol2tpv3_addr 0 19385 NULL
+disable_so_wm8960_set_dai_clkdiv_fndecl_19392 wm8960_set_dai_clkdiv fndecl 3 19392 NULL
+disable_so_drm_modeset_lock_interruptible_fndecl_19397 drm_modeset_lock_interruptible fndecl 0 19397 NULL
+disable_so_isdn_divert_open_fndecl_19417 isdn_divert_open fndecl 0 19417 NULL
+disable_so_uwb_rc_dev_addr_set_fndecl_19418 uwb_rc_dev_addr_set fndecl 0 19418 NULL
+disable_so_frames_v4l2_timecode_19427 frames v4l2_timecode 0 19427 NULL
+disable_so_bw_time_stamp_backing_dev_info_19428 bw_time_stamp backing_dev_info 0 19428 NULL
+disable_so_nes_create_sockaddr_fndecl_19431 nes_create_sockaddr fndecl 1-2 19431 NULL
+disable_so_s_uuid_hash_ocfs2_super_block_19432 s_uuid_hash ocfs2_super_block 0 19432 NULL
+disable_so_paging64_walk_addr_fndecl_19436 paging64_walk_addr fndecl 3-4 19436 NULL
+disable_so_snd_sonicvibes_interrupt_fndecl_19437 snd_sonicvibes_interrupt fndecl 1 19437 NULL
+disable_so_width_psb_intel_sdvo_preferred_input_timing_args_19438 width psb_intel_sdvo_preferred_input_timing_args 0 19438 NULL
+disable_so_padlock_sha256_final_fndecl_19450 padlock_sha256_final fndecl 0 19450 NULL
+disable_so_period_time_bau_control_19451 period_time bau_control 0 19451 NULL
+disable_so_timestamp_nfs4_closedata_19455 timestamp nfs4_closedata 0 19455 NULL
+disable_so_crypto_fpu_init_fndecl_19461 crypto_fpu_init fndecl 0 19461 NULL
+disable_so_sysctl_x25_reset_request_timeout_vardecl_19463 sysctl_x25_reset_request_timeout vardecl 0 19463 NULL nohasharray
+disable_so_start_write_delay_c_19463 start_write delay_c 0 19463 &disable_so_sysctl_x25_reset_request_timeout_vardecl_19463
+disable_so_calc_div_fndecl_19469 calc_div fndecl 0-4-3 19469 NULL
+disable_so_log2bpmb_adfs_discrecord_19475 log2bpmb adfs_discrecord 0 19475 NULL
+disable_so_sys_pkt_addr_dle_19487 sys_pkt_addr dle 0 19487 NULL
+disable_so_igb_set_vf_mac_addr_fndecl_19490 igb_set_vf_mac_addr fndecl 3 19490 NULL
+disable_so_ipaddr_atm_mpoa_qos_19492 ipaddr atm_mpoa_qos 0 19492 NULL
+disable_so_start_addr_ms_system_item_19495 start_addr ms_system_item 0 19495 NULL
+disable_so_nmi_timer_start_cpu_fndecl_19509 nmi_timer_start_cpu fndecl 1-0 19509 NULL
+disable_so_rv3029c2_i2c_set_time_fndecl_19511 rv3029c2_i2c_set_time fndecl 0 19511 NULL
+disable_so_trinity_get_valid_engine_clock_fndecl_19516 trinity_get_valid_engine_clock fndecl 0 19516 NULL
+disable_so_add_addr_fndecl_19518 add_addr fndecl 3-4 19518 NULL nohasharray
+disable_so_hash_extent_data_ref_item_fndecl_19518 hash_extent_data_ref_item fndecl 0 19518 &disable_so_add_addr_fndecl_19518
+disable_so_prev_hw_ptr_period_snd_pcm_oss_runtime_19519 prev_hw_ptr_period snd_pcm_oss_runtime 0 19519 NULL
+disable_so_eqaddr_fw_ri_res_sqrq_19526 eqaddr fw_ri_res_sqrq 0 19526 NULL
+disable_so_tms_stime_compat_tms_19527 tms_stime compat_tms 0 19527 NULL
+disable_so_period_addr_ath_gen_timer_configuration_19529 period_addr ath_gen_timer_configuration 0 19529 NULL
+disable_so_sp_tss_segment_16_19536 sp tss_segment_16 0 19536 NULL nohasharray
+disable_so_nrpages_address_space_19536 nrpages address_space 0 19536 &disable_so_sp_tss_segment_16_19536
+disable_so_fb_cvt_pixclock_fndecl_19545 fb_cvt_pixclock fndecl 0 19545 NULL
+disable_so_ipv6_addr_hash_fndecl_19554 ipv6_addr_hash fndecl 0 19554 NULL
+disable_so_fnhe_daddr_fib_nh_exception_19556 fnhe_daddr fib_nh_exception 0 19556 NULL
+disable_so_cir_addr_fintek_dev_19561 cir_addr fintek_dev 0 19561 NULL
+disable_so_saddr_max_pktgen_dev_19567 saddr_max pktgen_dev 0 19567 NULL
+disable_so_check_nnp_nosuid_fndecl_19568 check_nnp_nosuid fndecl 0 19568 NULL
+disable_so_write_phy_reg_fndecl_19585 write_phy_reg fndecl 0-2-3 19585 NULL
+disable_so_garp_join_time_vardecl_garp_c_19597 garp_join_time vardecl_garp.c 0 19597 NULL
+disable_so_signalfd_dequeue_fndecl_19602 signalfd_dequeue fndecl 0-3 19602 NULL
+disable_so_write8_comm_runtime_19603 write8 comm_runtime 4 19603 NULL
+disable_so_sys_semtimedop_fndecl_19605 sys_semtimedop fndecl 1-3-0 19605 NULL
+disable_so_xenvif_rx_queue_timeout_fndecl_19613 xenvif_rx_queue_timeout fndecl 0 19613 NULL
+disable_so_local_cm_response_timeout_ib_cm_req_param_19614 local_cm_response_timeout ib_cm_req_param 0 19614 NULL nohasharray
+disable_so_ath9k_hw_gen_timer_start_fndecl_19614 ath9k_hw_gen_timer_start fndecl 3-4 19614 &disable_so_local_cm_response_timeout_ib_cm_req_param_19614 nohasharray
+disable_so_xtal_cap0p_r820t_freq_range_19614 xtal_cap0p r820t_freq_range 0 19614 &disable_so_ath9k_hw_gen_timer_start_fndecl_19614
+disable_so_time_fmeter_19622 time fmeter 0 19622 NULL
+disable_so_mce_timer_kick_fndecl_19627 mce_timer_kick fndecl 1 19627 NULL
+disable_so_freqn_usb_stream_kernel_19628 freqn usb_stream_kernel 0 19628 NULL
+disable_so_cg_spll_spread_spectrum_2_ci_clock_registers_19639 cg_spll_spread_spectrum_2 ci_clock_registers 0 19639 NULL
+disable_so_ltr501_als_read_samp_freq_fndecl_19642 ltr501_als_read_samp_freq fndecl 0 19642 NULL
+disable_so_addr_snd_sg_page_19645 addr snd_sg_page 0 19645 NULL nohasharray
+disable_so_xfs_btree_kill_root_fndecl_19645 xfs_btree_kill_root fndecl 0 19645 &disable_so_addr_snd_sg_page_19645
+disable_so_xc_get_signal_level_fndecl_19649 xc_get_signal_level fndecl 0 19649 NULL
+disable_so_rx8581_get_datetime_fndecl_19650 rx8581_get_datetime fndecl 0 19650 NULL
+disable_so_mdiv_gk104_clk_info_19653 mdiv gk104_clk_info 0 19653 NULL
+disable_so_c_faddr_rds_connection_19664 c_faddr rds_connection 0 19664 NULL
+disable_so_afs_mntpt_expiry_timeout_vardecl_mntpt_c_19666 afs_mntpt_expiry_timeout vardecl_mntpt.c 0 19666 NULL nohasharray
+disable_so___queue_delayed_work_fndecl_19666 __queue_delayed_work fndecl 1-4 19666 &disable_so_afs_mntpt_expiry_timeout_vardecl_mntpt_c_19666
+disable_so_store_risetime_fndecl_19668 store_risetime fndecl 4-0 19668 NULL
+disable_so_div_r1_pll_values_19670 div_r1 pll_values 0 19670 NULL
+disable_so_tstamp_inet6_ifaddr_19680 tstamp inet6_ifaddr 0 19680 NULL
+disable_so_get_bt_addr_fndecl_19687 get_bt_addr fndecl 0 19687 NULL
+disable_so_clocksource_register_hz_fndecl_19688 clocksource_register_hz fndecl 2 19688 NULL
+disable_so_ceph_mdsmap_get_random_mds_fndecl_19695 ceph_mdsmap_get_random_mds fndecl 0 19695 NULL
+disable_so_addr_qla82xx_md_entry_crb_19696 addr qla82xx_md_entry_crb 0 19696 NULL
+disable_so_frequency_itd1000_state_19704 frequency itd1000_state 0 19704 NULL
+disable_so_parent_tgid_fork_proc_event_19713 parent_tgid fork_proc_event 0 19713 NULL
+disable_so_i_uid_ocfs2_dinode_19720 i_uid ocfs2_dinode 0 19720 NULL
+disable_so_mx2_camera_clock_start_fndecl_19722 mx2_camera_clock_start fndecl 0 19722 NULL
+disable_so_crypto_ccm_decrypt_fndecl_19728 crypto_ccm_decrypt fndecl 0 19728 NULL
+disable_so_seq_put_decimal_ull_fndecl_19739 seq_put_decimal_ull fndecl 3 19739 NULL
+disable_so_capture_source_addr_snd_card_saa7134_19740 capture_source_addr snd_card_saa7134 0 19740 NULL
+disable_so_write_reg_fndecl_19743 write_reg fndecl 0-3 19743 NULL
+disable_so_ndac_aic32x4_rate_divs_19748 ndac aic32x4_rate_divs 0 19748 NULL
+disable_so_hpi_sample_clock_set_source_fndecl_19753 hpi_sample_clock_set_source fndecl 1-0 19753 NULL
+disable_so_address_ipr_ioadl_desc_19756 address ipr_ioadl_desc 0 19756 NULL
+disable_so_curr_hash_dir_private_info_19760 curr_hash dir_private_info 0 19760 NULL
+disable_so_ccp_register_sha_alg_fndecl_19771 ccp_register_sha_alg fndecl 0 19771 NULL
+disable_so_addr_set_port_fndecl_19776 addr_set_port fndecl 2 19776 NULL
+disable_so_gpu_id_kfd_ioctl_get_clock_counters_args_19784 gpu_id kfd_ioctl_get_clock_counters_args 0 19784 NULL
+disable_so_seq_cpl_rx_data_ddp_norss_19788 seq cpl_rx_data_ddp_norss 0 19788 NULL nohasharray
+disable_so_cherryview_rps_max_freq_fndecl_19788 cherryview_rps_max_freq fndecl 0 19788 &disable_so_seq_cpl_rx_data_ddp_norss_19788
+disable_so_inet6_dump_addr_fndecl_19792 inet6_dump_addr fndecl 0 19792 NULL
+disable_so_pixelclock_videomode_19794 pixelclock videomode 0 19794 NULL
+disable_so_hbackporch_v4l2_bt_timings_19806 hbackporch v4l2_bt_timings 0 19806 NULL
+disable_so_dy_runtime_sc_19824 dy runtime_sc 0 19824 NULL nohasharray
+disable_so_dm_btree_insert_fndecl_19824 dm_btree_insert fndecl 0-2 19824 &disable_so_dy_runtime_sc_19824
+disable_so_cpufreq_generic_get_fndecl_19829 cpufreq_generic_get fndecl 0-1 19829 NULL
+disable_so_outdiv_fll_factors_19836 outdiv fll_factors 0 19836 NULL
+disable_so_scd_base_addr_il_priv_19840 scd_base_addr il_priv 0 19840 NULL
+disable_so_acpi_ut_short_divide_fndecl_19845 acpi_ut_short_divide fndecl 1 19845 NULL
+disable_so_timewarn_cs_read_fndecl_19849 timewarn_cs_read fndecl 0 19849 NULL
+disable_so_freq_wmi_rx_action_event_19864 freq wmi_rx_action_event 0 19864 NULL
+disable_so_eeprom_indirect_address_fndecl_19868 eeprom_indirect_address fndecl 0-2-3 19868 NULL
+disable_so_core_clock_nes_adapter_19875 core_clock nes_adapter 0 19875 NULL
+disable_so_ecx_v86_regs_19877 ecx v86_regs 0 19877 NULL
+disable_so_base_clock_show_fndecl_19894 base_clock_show fndecl 0 19894 NULL
+disable_so_jiffies_next_rtl2832_sdr_dev_19897 jiffies_next rtl2832_sdr_dev 0 19897 NULL
+disable_so_process_tgid_exit_proc_event_19898 process_tgid exit_proc_event 0 19898 NULL
+disable_so_n_cipher_suites_wiphy_19902 n_cipher_suites wiphy 0 19902 NULL
+disable_so_fsl_asrc_cal_asrck_divisor_fndecl_19905 fsl_asrc_cal_asrck_divisor fndecl 0-2 19905 NULL
+disable_so_ntimer_qs_tp_params_19910 ntimer_qs tp_params 0 19910 NULL
+disable_so_rf_freq_off_mt7601u_eeprom_params_19920 rf_freq_off mt7601u_eeprom_params 0 19920 NULL
+disable_so_ip_hash_netport4_elem_19921 ip hash_netport4_elem 0 19921 NULL
+disable_so_cnid_hfs_btree_19924 cnid hfs_btree 0 19924 NULL
+disable_so_vblank_lo_detailed_pixel_timing_19925 vblank_lo detailed_pixel_timing 0 19925 NULL
+disable_so_addr_i2c_client_19929 addr i2c_client 0 19929 NULL
+disable_so_addr_nv50_i2c_port_19931 addr nv50_i2c_port 0 19931 NULL
+disable_so_epp_write_addr_parport_operations_19935 epp_write_addr parport_operations 0-3 19935 NULL
+disable_so_ds_last_time_o2hb_disk_slot_19938 ds_last_time o2hb_disk_slot 0 19938 NULL
+disable_so_local_addr_rds_info_tcp_socket_19943 local_addr rds_info_tcp_socket 0 19943 NULL
+disable_so_i_ctime_ext3_inode_19948 i_ctime ext3_inode 0 19948 NULL
+disable_so_maven_set_reg_fndecl_19961 maven_set_reg fndecl 3 19961 NULL
+disable_so_maven_find_exact_clocks_fndecl_19977 maven_find_exact_clocks fndecl 1-2 19977 NULL
+disable_so_tda826x_sleep_fndecl_19981 tda826x_sleep fndecl 0 19981 NULL
+disable_so_rate_snd_pcm_runtime_19986 rate snd_pcm_runtime 0 19986 NULL
+disable_so___pm_runtime_suspend_fndecl_19989 __pm_runtime_suspend fndecl 0 19989 NULL
+disable_so_time_tx_survey_info_19997 time_tx survey_info 0 19997 NULL
+disable_so_rt_time_rt_rq_20001 rt_time rt_rq 0 20001 NULL
+disable_so_message_buffer_address_on_dsp_hpi_hw_obj_20007 message_buffer_address_on_dsp hpi_hw_obj 0 20007 NULL nohasharray
+disable_so_log2_element_size_xilly_channel_20007 log2_element_size xilly_channel 0 20007 &disable_so_message_buffer_address_on_dsp_hpi_hw_obj_20007
+disable_so_xfs_btree_init_block_fndecl_20025 xfs_btree_init_block fndecl 6 20025 NULL
+disable_so_ds1347_set_time_fndecl_20026 ds1347_set_time fndecl 0 20026 NULL
+disable_so_cyapa_start_runtime_fndecl_20033 cyapa_start_runtime fndecl 0 20033 NULL
+disable_so_mvumi_map_pci_addr_fndecl_20039 mvumi_map_pci_addr fndecl 0 20039 NULL
+disable_so_vpd_paddr_low_lpfc_mbx_read_rev_20047 vpd_paddr_low lpfc_mbx_read_rev 0 20047 NULL
+disable_so_di_atime_qnx4_inode_entry_20056 di_atime qnx4_inode_entry 0 20056 NULL nohasharray
+disable_so_cgid_ipc64_perm_20056 cgid ipc64_perm 0 20056 &disable_so_di_atime_qnx4_inode_entry_20056
+disable_so_bb_watchdog_timeout_ms_ath_hw_20060 bb_watchdog_timeout_ms ath_hw 0 20060 NULL
+disable_so_des5_idmac_desc_64addr_20062 des5 idmac_desc_64addr 0 20062 NULL
+disable_so_buf_addr_mlx5_ib_resize_cq_20068 buf_addr mlx5_ib_resize_cq 0 20068 NULL
+disable_so_is_partially_uptodate_address_space_operations_20075 is_partially_uptodate address_space_operations 2-3 20075 NULL
+disable_so_mask_kvm_mtrr_range_20079 mask kvm_mtrr_range 0 20079 NULL
+disable_so_st_ctime___old_kernel_stat_20080 st_ctime __old_kernel_stat 0 20080 NULL
+disable_so_i_ctime_exofs_fcb_20092 i_ctime exofs_fcb 0 20092 NULL
+disable_so_drbg_kcapi_random_fndecl_20112 drbg_kcapi_random fndecl 3-0 20112 NULL
+disable_so_gid_fuse_in_header_20113 gid fuse_in_header 0 20113 NULL
+disable_so_proto_xfrm_usersa_id_20137 proto xfrm_usersa_id 0 20137 NULL
+disable_so_nsec_timecounter_20144 nsec timecounter 0 20144 NULL nohasharray
+disable_so_kvm_set_shared_msr_fndecl_20144 kvm_set_shared_msr fndecl 2 20144 &disable_so_nsec_timecounter_20144
+disable_so___xfrm4_addr_hash_fndecl_20148 __xfrm4_addr_hash fndecl 0 20148 NULL
+disable_so_hpet_address_vardecl_20150 hpet_address vardecl 0 20150 NULL
+disable_so_next_buf_addr_c67x00_hcd_20169 next_buf_addr c67x00_hcd 0 20169 NULL
+disable_so_urg_seq_tcp_sock_20171 urg_seq tcp_sock 0 20171 NULL
+disable_so_uid_crash_uid_20189 uid crash_uid 0 20189 NULL
+disable_so_force_addr_vardecl_i2c_sis5595_c_20194 force_addr vardecl_i2c-sis5595.c 0 20194 NULL
+disable_so_get_random_bytes_fndecl_20208 get_random_bytes fndecl 2 20208 NULL
+e_epoch_start_bictcp_20220 epoch_start bictcp 0 20220 NULL nohasharray
+disable_so_end_pci_bus_region_20220 end pci_bus_region 0 20220 &e_epoch_start_bictcp_20220
+disable_so_ptp_devt_vardecl_ptp_clock_c_20222 ptp_devt vardecl_ptp_clock.c 0 20222 NULL
+disable_so_rp5c01_read_time_fndecl_20225 rp5c01_read_time fndecl 0 20225 NULL
+disable_so_scsi_inq_timeout_vardecl_scsi_scan_c_20228 scsi_inq_timeout vardecl_scsi_scan.c 0 20228 NULL
+disable_so_crypto_report_alg_fndecl_20233 crypto_report_alg fndecl 0 20233 NULL
+disable_so_cache_flush_timeout_vardecl_ms_block_c_20240 cache_flush_timeout vardecl_ms_block.c 0 20240 NULL nohasharray
+disable_so_freq_to_note_fndecl_20240 freq_to_note fndecl 0-1 20240 &disable_so_cache_flush_timeout_vardecl_ms_block_c_20240
+disable_so_sdhci_runtime_pm_put_fndecl_20243 sdhci_runtime_pm_put fndecl 0 20243 NULL nohasharray
+disable_so_lookup_signal_page_by_index_fndecl_20243 lookup_signal_page_by_index fndecl 2 20243 &disable_so_sdhci_runtime_pm_put_fndecl_20243
+disable_so_blkaddr_fsync_inode_entry_20244 blkaddr fsync_inode_entry 0 20244 NULL
+disable_so_refb_r_div_ad9523_platform_data_20245 refb_r_div ad9523_platform_data 0 20245 NULL nohasharray
+disable_so_i40e_aq_mac_address_read_fndecl_20245 i40e_aq_mac_address_read fndecl 0 20245 &disable_so_refb_r_div_ad9523_platform_data_20245
+disable_so_buf_count_ccp_aes_cmac_req_ctx_20252 buf_count ccp_aes_cmac_req_ctx 0 20252 NULL
+disable_so_nfs4_proc_get_lease_time_fndecl_20254 nfs4_proc_get_lease_time fndecl 0 20254 NULL nohasharray
+disable_so_dma_addr_enet_cb_20254 dma_addr enet_cb 0 20254 &disable_so_nfs4_proc_get_lease_time_fndecl_20254
+disable_so_eax_user_regs_struct32_20260 eax user_regs_struct32 0 20260 NULL
+disable_so_freq_wmi_remain_on_chnl_cmd_20271 freq wmi_remain_on_chnl_cmd 0 20271 NULL
+disable_so_esp_tss_segment_32_20300 esp tss_segment_32 0 20300 NULL
+disable_so_hash_netportnet6_expire_fndecl_20301 hash_netportnet6_expire fndecl 4 20301 NULL
+disable_so_dma_buffer_sst_module_runtime_context_20307 dma_buffer sst_module_runtime_context 0 20307 NULL nohasharray
+disable_so_dest_data_addr_icp_qat_fw_comn_req_mid_20307 dest_data_addr icp_qat_fw_comn_req_mid 0 20307 &disable_so_dma_buffer_sst_module_runtime_context_20307
+disable_so_nosnoop_pbladdr_fw_ri_tpte_20317 nosnoop_pbladdr fw_ri_tpte 0 20317 NULL
+disable_so_sir_addr_sockaddr_irda_20319 sir_addr sockaddr_irda 0 20319 NULL
+disable_so_iter_div_u64_rem_fndecl_20326 iter_div_u64_rem fndecl 0 20326 NULL
+disable_so_ps2_adjust_timeout_fndecl_20329 ps2_adjust_timeout fndecl 0-3-2 20329 NULL nohasharray
+disable_so_ztime_trackpoint_data_20329 ztime trackpoint_data 0 20329 &disable_so_ps2_adjust_timeout_fndecl_20329
+disable_so_ui_uid_ufs2_inode_20330 ui_uid ufs2_inode 0 20330 NULL nohasharray
+disable_so_stb6000_sleep_fndecl_20330 stb6000_sleep fndecl 0 20330 &disable_so_ui_uid_ufs2_inode_20330
+disable_so_gfs2_bit_search_fndecl_20331 gfs2_bit_search fndecl 0-2 20331 NULL
+disable_so_ccp_run_aes_cmac_cmd_fndecl_20335 ccp_run_aes_cmac_cmd fndecl 0 20335 NULL
+disable_so_compat_sys_clock_gettime_fndecl_20336 compat_sys_clock_gettime fndecl 1 20336 NULL
+disable_so_div_fc2580_pll_20347 div fc2580_pll 0 20347 NULL
+disable_so_xfrm_spi_hash_fndecl_20353 xfrm_spi_hash fndecl 0-3-4-5 20353 NULL
+disable_so_compute_duty_cycle_fndecl_20356 compute_duty_cycle fndecl 0-2 20356 NULL
+disable_so_pmcraid_read_interrupts_fndecl_20362 pmcraid_read_interrupts fndecl 0 20362 NULL
+disable_so_receive_bitmap_fndecl_20365 receive_bitmap fndecl 0 20365 NULL
+disable_so_ccycle_esp_20366 ccycle esp 0 20366 NULL
+disable_so_rspi_wait_for_interrupt_fndecl_20368 rspi_wait_for_interrupt fndecl 3-0 20368 NULL
+disable_so_bitmap_startwrite_fndecl_20371 bitmap_startwrite fndecl 2-3 20371 NULL
+disable_so_crypto_rfc4543_decrypt_fndecl_20376 crypto_rfc4543_decrypt fndecl 0 20376 NULL
+disable_so_acpi_os_signal_fndecl_20378 acpi_os_signal fndecl 0 20378 NULL
+disable_so_interrupt_type___vxge_hw_fifo_20379 interrupt_type __vxge_hw_fifo 0 20379 NULL
+disable_so_address_lo_lpfc_rqe_20386 address_lo lpfc_rqe 0 20386 NULL
+disable_so_addr_rsxx_reg_access_20389 addr rsxx_reg_access 0 20389 NULL
+disable_so_vpm_read_address_fndecl_20399 vpm_read_address fndecl 0 20399 NULL
+disable_so_block_addr_f2fs_nat_entry_20409 block_addr f2fs_nat_entry 0 20409 NULL
+disable_so_backlight_duty_cycle_psb_intel_mode_device_20421 backlight_duty_cycle psb_intel_mode_device 0 20421 NULL
+disable_so_skd_start_timer_fndecl_20432 skd_start_timer fndecl 0 20432 NULL
+disable_so_cmd64x_program_timings_fndecl_20435 cmd64x_program_timings fndecl 2 20435 NULL
+disable_so_chgfreq_cs42l52_platform_data_20448 chgfreq cs42l52_platform_data 0 20448 NULL
+disable_so_tvaudio_sleep_fndecl_20455 tvaudio_sleep fndecl 2 20455 NULL
+disable_so_simplefb_clocks_init_fndecl_20466 simplefb_clocks_init fndecl 0 20466 NULL
+disable_so_last_time_stats_20477 last time_stats 0 20477 NULL
+disable_so_min_freq_intel_gen6_power_mgmt_20480 min_freq intel_gen6_power_mgmt 0 20480 NULL
+disable_so_il_dbgfs_interrupt_read_fndecl_20484 il_dbgfs_interrupt_read fndecl 3-0 20484 NULL
+disable_so_final_timeout_irlap_cb_20486 final_timeout irlap_cb 0 20486 NULL
+disable_so_sec_btrfs_timespec_20492 sec btrfs_timespec 0 20492 NULL
+disable_so_bitmap_prepare_for_write_fndecl_20495 bitmap_prepare_for_write fndecl 3 20495 NULL
+disable_so_cg_spll_func_cntl_3_ni_clock_registers_20497 cg_spll_func_cntl_3 ni_clock_registers 0 20497 NULL
+disable_so_pch_udc_disable_interrupts_fndecl_20502 pch_udc_disable_interrupts fndecl 2 20502 NULL
+disable_so_i_mtime_bfs_inode_20503 i_mtime bfs_inode 0 20503 NULL
+disable_so_timeout_nft_dynset_20509 timeout nft_dynset 0 20509 NULL
+disable_so_ni_populate_memory_timing_parameters_fndecl_20513 ni_populate_memory_timing_parameters fndecl 0 20513 NULL
+disable_so_scnprintf_fndecl_20531 scnprintf fndecl 0-2 20531 NULL nohasharray
+disable_so_select_addr_qla8xxx_minidump_entry_queue_20531 select_addr qla8xxx_minidump_entry_queue 0 20531 &disable_so_scnprintf_fndecl_20531
+disable_so___ww_mutex_lock_interruptible_slowpath_fndecl_20533 __ww_mutex_lock_interruptible_slowpath fndecl 0 20533 NULL
+disable_so_compute_subtree_max_end_fndecl_20536 compute_subtree_max_end fndecl 0 20536 NULL
+disable_so_wlc_lcnphy_qdiv_roundup_fndecl_20539 wlc_lcnphy_qdiv_roundup fndecl 0-2-1 20539 NULL
+disable_so_value_ieee80211_timeout_interval_ie_20540 value ieee80211_timeout_interval_ie 0 20540 NULL
+disable_so_skb_put_le32_fndecl_20551 skb_put_le32 fndecl 2 20551 NULL
+disable_so_get_setup_data_paddr_fndecl_20558 get_setup_data_paddr fndecl 0 20558 NULL
+disable_so_i_mtime_nilfs_inode_20563 i_mtime nilfs_inode 0 20563 NULL
+disable_so_cipher_key_params_20564 cipher key_params 0 20564 NULL
+disable_so_iscsit_na_random_datain_pdu_offsets_fndecl_20565 iscsit_na_random_datain_pdu_offsets fndecl 0 20565 NULL
+disable_so_delay_mult_qib_pportdata_20567 delay_mult qib_pportdata 0 20567 NULL
+disable_so_pm_timer_block_acpi_table_fadt_20569 pm_timer_block acpi_table_fadt 0 20569 NULL
+disable_so_addr_data_si_sm_io_20586 addr_data si_sm_io 0 20586 NULL nohasharray
+disable_so_sib_flowinfo_sockaddr_ib_20586 sib_flowinfo sockaddr_ib 0 20586 &disable_so_addr_data_si_sm_io_20586
+disable_so_dll_cntl_rv770_clock_registers_20601 dll_cntl rv770_clock_registers 0 20601 NULL nohasharray
+disable_so_field_bit_position_acpi_create_field_info_20601 field_bit_position acpi_create_field_info 0 20601 &disable_so_dll_cntl_rv770_clock_registers_20601
+disable_so_ndtc_hash_mask_ndt_config_20603 ndtc_hash_mask ndt_config 0 20603 NULL
+disable_so_borrow_defer_timestamp_brcmf_fws_info_20615 borrow_defer_timestamp brcmf_fws_info 0 20615 NULL
+disable_so_wakeup_max_time_show_fndecl_20622 wakeup_max_time_show fndecl 0 20622 NULL
+disable_so_tw_flowlabel_inet_timewait_sock_20634 tw_flowlabel inet_timewait_sock 0 20634 NULL
+disable_so_ib_baseaddr_l_mvumi_hs_page4_20645 ib_baseaddr_l mvumi_hs_page4 0 20645 NULL
+disable_so_shash_register_instance_fndecl_20652 shash_register_instance fndecl 0 20652 NULL
+disable_so_snd_usb_clock_find_source_fndecl_20655 snd_usb_clock_find_source fndecl 0-2 20655 NULL
+disable_so_g_dv_timings_v4l2_subdev_video_ops_20656 g_dv_timings v4l2_subdev_video_ops 0 20656 NULL
+disable_so_radio_addr_em28xx_board_20659 radio_addr em28xx_board 0 20659 NULL
+disable_so_cx24117_sleep_fndecl_20661 cx24117_sleep fndecl 0 20661 NULL
+disable_so_run_one_delayed_ref_fndecl_20668 run_one_delayed_ref fndecl 0 20668 NULL nohasharray
+disable_so_saddr_ircomm_info_20668 saddr ircomm_info 0 20668 &disable_so_run_one_delayed_ref_fndecl_20668
+disable_so_i2c_addr_req_t_20671 i2c_addr req_t 0 20671 NULL
+disable_so_mcryptd_hash_import_fndecl_20673 mcryptd_hash_import fndecl 0 20673 NULL
+disable_so_ath10k_reg_addr_read_fndecl_20675 ath10k_reg_addr_read fndecl 3-0 20675 NULL nohasharray
+disable_so_frequency_stepsize_dvb_frontend_info_20675 frequency_stepsize dvb_frontend_info 0 20675 &disable_so_ath10k_reg_addr_read_fndecl_20675
+disable_so_latency_timer_show_fndecl_20676 latency_timer_show fndecl 0 20676 NULL nohasharray
+disable_so_total_bytes_transferred_snd_compr_runtime_20676 total_bytes_transferred snd_compr_runtime 0 20676 &disable_so_latency_timer_show_fndecl_20676
+disable_so_control_addr_qla8xxx_minidump_entry_cache_20678 control_addr qla8xxx_minidump_entry_cache 0 20678 NULL
+disable_so_timeout_i2c_algo_bit_data_20687 timeout i2c_algo_bit_data 0 20687 NULL
+disable_so_lookup_address_fndecl_20689 lookup_address fndecl 1 20689 NULL
+disable_so_pcf8523_rtc_read_time_fndecl_20690 pcf8523_rtc_read_time fndecl 0 20690 NULL
+disable_so_freq_nvbios_cstepX_20695 freq nvbios_cstepX 0 20695 NULL
+disable_so_seq_virtio_gpu_fence_20701 seq virtio_gpu_fence 0 20701 NULL
+disable_so_ftime_qlcnic_filter_20707 ftime qlcnic_filter 0 20707 NULL nohasharray
+disable_so_myri10ge_rss_hash_vardecl_myri10ge_c_20707 myri10ge_rss_hash vardecl_myri10ge.c 0 20707 &disable_so_ftime_qlcnic_filter_20707
+disable_so_mwifiex_cmd_802_11_mac_address_fndecl_20714 mwifiex_cmd_802_11_mac_address fndecl 0 20714 NULL
+disable_so_typeAndTimezone_timestamp_20722 typeAndTimezone timestamp 0 20722 NULL
+disable_so_btrfs_delayed_update_inode_fndecl_20726 btrfs_delayed_update_inode fndecl 0 20726 NULL
+disable_so_dsc_timeout_ide_tape_obj_20727 dsc_timeout ide_tape_obj 0 20727 NULL
+disable_so_stb0899_dvbs2_set_carr_freq_fndecl_20730 stb0899_dvbs2_set_carr_freq fndecl 2-3 20730 NULL
+disable_so_wl1271_acx_service_period_timeout_fndecl_20736 wl1271_acx_service_period_timeout fndecl 0 20736 NULL
+disable_so_am335x_tsc_se_clr_fndecl_20745 am335x_tsc_se_clr fndecl 2 20745 NULL
+disable_so_node_guid_ib_node_info_20750 node_guid ib_node_info 0 20750 NULL nohasharray
+disable_so_rsxx_addr8_to_laddr_fndecl_20750 rsxx_addr8_to_laddr fndecl 0-1 20750 &disable_so_node_guid_ib_node_info_20750
+disable_so_nilfs_btree_propagate_p_fndecl_20757 nilfs_btree_propagate_p fndecl 0 20757 NULL
+disable_so_read_file_antenna_diversity_fndecl_20758 read_file_antenna_diversity fndecl 0 20758 NULL
+disable_so_dev_pm_opp_find_freq_exact_fndecl_20768 dev_pm_opp_find_freq_exact fndecl 2 20768 NULL
+disable_so_mpll_dq_func_cntl_ni_clock_registers_20779 mpll_dq_func_cntl ni_clock_registers 0 20779 NULL
+disable_so_print_time_fndecl_20783 print_time fndecl 1-0 20783 NULL
+disable_so_store_fan_stop_time_fndecl_20785 store_fan_stop_time fndecl 0-4 20785 NULL nohasharray
+disable_so_gpu_addr_r600_vram_scratch_20785 gpu_addr r600_vram_scratch 0 20785 &disable_so_store_fan_stop_time_fndecl_20785
+disable_so_s5m8767_set_voltage_time_sel_fndecl_20788 s5m8767_set_voltage_time_sel fndecl 0-2-3 20788 NULL nohasharray
+disable_so_addr_kvm_async_pf_20788 addr kvm_async_pf 0 20788 &disable_so_s5m8767_set_voltage_time_sel_fndecl_20788
+disable_so_rxLifetime_ConfigRid_20793 rxLifetime ConfigRid 0 20793 NULL
+disable_so_downdelay_bond_params_20794 downdelay bond_params 0 20794 NULL
+disable_so_dma_address_info_20796 dma address_info 0 20796 NULL
+disable_so_write16_async_rtl_io_20799 write16_async rtl_io 2-3 20799 NULL
+disable_so_sec_2_cycles_fndecl_20803 sec_2_cycles fndecl 0-1 20803 NULL
+disable_so_nsec_base_pvclock_gtod_data_20804 nsec_base pvclock_gtod_data 0 20804 NULL
+disable_so_ndo_set_mac_address_net_device_ops_20806 ndo_set_mac_address net_device_ops 0 20806 NULL
+disable_so_crypto_dump_report_fndecl_20811 crypto_dump_report fndecl 0 20811 NULL
+disable_so_ttime_total_cfq_ttime_20813 ttime_total cfq_ttime 0 20813 NULL
+disable_so_freq_chan_info_2064_lcnphy_20814 freq chan_info_2064_lcnphy 0 20814 NULL
+disable_so_msleep_fndecl_20815 msleep fndecl 1 20815 NULL nohasharray
+disable_so_freq_hz_xc4000_priv_20815 freq_hz xc4000_priv 0 20815 &disable_so_msleep_fndecl_20815
+disable_so_t4_set_params_nosleep_fndecl_20819 t4_set_params_nosleep fndecl 0-2-3-4 20819 NULL
+disable_so_get_next_timer_interrupt_fndecl_20832 get_next_timer_interrupt fndecl 0-1 20832 NULL
+disable_so_vol_bit_width_anatop_regulator_20852 vol_bit_width anatop_regulator 0 20852 NULL
+disable_so_VSyncStart_xtimings_20858 VSyncStart xtimings 0 20858 NULL
+disable_so_calibrate_delay_is_known_fndecl_20859 calibrate_delay_is_known fndecl 0 20859 NULL
+disable_so_handling_delay_adc_jack_data_20874 handling_delay adc_jack_data 0 20874 NULL
+disable_so_fm3130_get_time_fndecl_20875 fm3130_get_time fndecl 0 20875 NULL
+disable_so_addr_hi_mv_sg_20880 addr_hi mv_sg 0 20880 NULL
+disable_so_print_time_fndecl_20896 print_time fndecl 1 20896 NULL nohasharray
+disable_so_ini_jiffies_tm6000_dmaqueue_20896 ini_jiffies tm6000_dmaqueue 0 20896 &disable_so_print_time_fndecl_20896
+disable_so_timeout_carl9170_tx_info_20900 timeout carl9170_tx_info 0 20900 NULL
+disable_so_phys_addr_t4_sq_20908 phys_addr t4_sq 0 20908 NULL
+disable_so_ns_2_cycles_fndecl_20913 ns_2_cycles fndecl 0-1 20913 NULL
+disable_so_number_fndecl_20920 number fndecl 3 20920 NULL
+disable_so_n_wm8978_pll_div_20930 n wm8978_pll_div 0 20930 NULL
+disable_so_snd_es1938_interrupt_fndecl_20934 snd_es1938_interrupt fndecl 1 20934 NULL
+disable_so___ilog2_u64_fndecl_20935 __ilog2_u64 fndecl 0-1 20935 NULL
+disable_so_acpi_target_sleep_state_vardecl_sleep_c_20940 acpi_target_sleep_state vardecl_sleep.c 0 20940 NULL
+disable_so_wq_cpumask_store_fndecl_20950 wq_cpumask_store fndecl 0-4 20950 NULL
+disable_so_bmc150_accel_get_startup_times_fndecl_20957 bmc150_accel_get_startup_times fndecl 0 20957 NULL
+disable_so_antdiv_ctl2_modal_eep_4k_header_20958 antdiv_ctl2 modal_eep_4k_header 0 20958 NULL
+disable_so_rc_keydown_notimeout_fndecl_20964 rc_keydown_notimeout fndecl 4-3 20964 NULL
+disable_so_inet6_fill_ifaddr_fndecl_20965 inet6_fill_ifaddr fndecl 0-3-5 20965 NULL
+disable_so_hca_core_clock_mlx4_caps_20972 hca_core_clock mlx4_caps 0 20972 NULL
+disable_so_netxen_set_interrupt_mode_fndecl_20973 netxen_set_interrupt_mode fndecl 2 20973 NULL
+disable_so_slottime_sixpack_20976 slottime sixpack 0 20976 NULL
+disable_so_mpll_ad_func_cntl_rv770_clock_registers_20978 mpll_ad_func_cntl rv770_clock_registers 0 20978 NULL
+disable_so_uhash_entries_vardecl_udp_c_20980 uhash_entries vardecl_udp.c 0 20980 NULL
+disable_so_s2mps11_regulator_set_voltage_time_sel_fndecl_20983 s2mps11_regulator_set_voltage_time_sel fndecl 0-2-3 20983 NULL
+disable_so_mlx4_ib_query_gid_fndecl_20997 mlx4_ib_query_gid fndecl 0-2-3 20997 NULL
+disable_so_ep_timeout_secs_vardecl_iwch_cm_c_20999 ep_timeout_secs vardecl_iwch_cm.c 0 20999 NULL nohasharray
+disable_so_w83627ehf_write_fan_div_fndecl_20999 w83627ehf_write_fan_div fndecl 2 20999 &disable_so_ep_timeout_secs_vardecl_iwch_cm_c_20999
+disable_so_vddc_radeon_clock_and_voltage_limits_21012 vddc radeon_clock_and_voltage_limits 0 21012 NULL
+disable_so_spu_sleep_ds_device_21015 spu_sleep ds_device 0 21015 NULL
+disable_so_dqb_btime_if_dqblk_21019 dqb_btime if_dqblk 0 21019 NULL
+disable_so_sg_frame_phys_addr_megasas_cmd_fusion_21025 sg_frame_phys_addr megasas_cmd_fusion 0 21025 NULL
+disable_so_radeon_crtc_set_base_atomic_fndecl_21027 radeon_crtc_set_base_atomic fndecl 0-3-4 21027 NULL
+disable_so_i40e_get_san_mac_addr_fndecl_21029 i40e_get_san_mac_addr fndecl 0 21029 NULL
+disable_so_regmap_del_irq_chip_fndecl_21031 regmap_del_irq_chip fndecl 1 21031 NULL
+disable_so_res_hash_dlm_rsb_21034 res_hash dlm_rsb 0 21034 NULL
+disable_so_early_acpi_parse_madt_lapic_addr_ovr_fndecl_21041 early_acpi_parse_madt_lapic_addr_ovr fndecl 0 21041 NULL
+disable_so_tw_tos_inet_timewait_sock_21047 tw_tos inet_timewait_sock 0 21047 NULL
+disable_so_cfg80211_get_chans_dfs_cac_time_fndecl_21052 cfg80211_get_chans_dfs_cac_time fndecl 0-2-3 21052 NULL
+disable_so_random_tipc_net_21055 random tipc_net 0 21055 NULL
+disable_so_tag_reg_addr_qla8xxx_minidump_entry_cache_21058 tag_reg_addr qla8xxx_minidump_entry_cache 0 21058 NULL
+disable_so_m1_gma_clock_t_21062 m1 gma_clock_t 0 21062 NULL
+disable_so_cutime_signal_struct_21069 cutime signal_struct 0 21069 NULL
+disable_so_frac_pos_dummy_systimer_pcm_21070 frac_pos dummy_systimer_pcm 0 21070 NULL
+disable_so_mmc_sdio_runtime_resume_fndecl_21078 mmc_sdio_runtime_resume fndecl 0 21078 NULL
+disable_so_last_write_time_smb_com_query_information_rsp_21093 last_write_time smb_com_query_information_rsp 0 21093 NULL
+disable_so_ssb_sdio_set_sbaddr_window_fndecl_21116 ssb_sdio_set_sbaddr_window fndecl 0-2 21116 NULL
+disable_so_apei_clear_mce_fndecl_21119 apei_clear_mce fndecl 0 21119 NULL
+disable_so_pnfs_layoutget_retry_bit_wait_fndecl_21127 pnfs_layoutget_retry_bit_wait fndecl 0 21127 NULL
+disable_so_rq_page_table_addr_lo_iscsi_kwqe_conn_offload2_21144 rq_page_table_addr_lo iscsi_kwqe_conn_offload2 0 21144 NULL
+disable_so_addrconf_sysctl_forward_fndecl_21146 addrconf_sysctl_forward fndecl 0 21146 NULL
+disable_so_bcma_pmu_get_bus_clock_fndecl_21147 bcma_pmu_get_bus_clock fndecl 0 21147 NULL nohasharray
+disable_so_address_acpi_generic_address_21147 address acpi_generic_address 0 21147 &disable_so_bcma_pmu_get_bus_clock_fndecl_21147
+disable_so_phys_addr__DMABUFFERENTRY_21149 phys_addr _DMABUFFERENTRY 0 21149 NULL
+disable_so_phy_addr_bnx2x_port_21152 phy_addr bnx2x_port 0 21152 NULL
+disable_so_demod_address_va1j5jf8007t_config_21154 demod_address va1j5jf8007t_config 0 21154 NULL
+disable_so_mgt_orb_timeout_sbp2_target_21164 mgt_orb_timeout sbp2_target 0 21164 NULL
+disable_so_io_addr_blogic_probeinfo_21171 io_addr blogic_probeinfo 0 21171 NULL
+disable_so_stag_c2_data_addr_21185 stag c2_data_addr 0 21185 NULL
+disable_so_idle_timeout_set_fndecl_21189 idle_timeout_set fndecl 2 21189 NULL nohasharray
+disable_so_rx_dma_addr_sh_msiof_spi_priv_21189 rx_dma_addr sh_msiof_spi_priv 0 21189 &disable_so_idle_timeout_set_fndecl_21189
+disable_so_poll_schedule_timeout_fndecl_21195 poll_schedule_timeout fndecl 4 21195 NULL
+disable_so_fb_cvt_ideal_duty_cycle_fndecl_21197 fb_cvt_ideal_duty_cycle fndecl 0 21197 NULL
+disable_so_dwell_time_brcmf_fil_af_params_le_21198 dwell_time brcmf_fil_af_params_le 0 21198 NULL
+disable_so_pciehp_poll_time_vardecl_21204 pciehp_poll_time vardecl 0 21204 NULL
+disable_so_sha1_base_do_update_fndecl_21207 sha1_base_do_update fndecl 3 21207 NULL
+disable_so_arizona_runtime_suspend_fndecl_21209 arizona_runtime_suspend fndecl 0 21209 NULL nohasharray
+disable_so_pdev_bus_addr_vardecl_pdev_bus_c_21209 pdev_bus_addr vardecl_pdev_bus.c 0 21209 &disable_so_arizona_runtime_suspend_fndecl_21209
+disable_so_xc_get_frequency_error_fndecl_21217 xc_get_frequency_error fndecl 0 21217 NULL
+disable_so_phys_addr_megasas_sge_skinny_21220 phys_addr megasas_sge_skinny 0 21220 NULL
+disable_so_i2c_addr_radeon_router_21224 i2c_addr radeon_router 0 21224 NULL
+disable_so_invalidatepage_address_space_operations_21227 invalidatepage address_space_operations 2-3 21227 NULL
+disable_so_usb_free_coherent_fndecl_21239 usb_free_coherent fndecl 2-4 21239 NULL
+disable_so_ci_populate_memory_timing_parameters_fndecl_21251 ci_populate_memory_timing_parameters fndecl 0-2-3 21251 NULL
+disable_so_compat_sys_semtimedop_fndecl_21253 compat_sys_semtimedop fndecl 3-1-0 21253 NULL
+disable_so_blkcipher_walk_done_fndecl_21256 blkcipher_walk_done fndecl 0-3 21256 NULL
+disable_so_iscsi_tpg_attrib_store_login_timeout_fndecl_21278 iscsi_tpg_attrib_store_login_timeout fndecl 0-3 21278 NULL
+disable_so_tuner_address_mt2063_config_21279 tuner_address mt2063_config 0 21279 NULL
+disable_so_register_refined_jiffies_fndecl_21283 register_refined_jiffies fndecl 1 21283 NULL
+disable_so_debug_dma_unmap_sg_fndecl_21286 debug_dma_unmap_sg fndecl 3 21286 NULL
+disable_so_of_do_get_timings_fndecl_21294 of_do_get_timings fndecl 0 21294 NULL
+disable_so_mtrr_file_del_fndecl_21306 mtrr_file_del fndecl 1-2 21306 NULL
+disable_so_set_timeout_watchdog_ops_21311 set_timeout watchdog_ops 2-0 21311 NULL
+disable_so_ipv6_addr_prefix_fndecl_21318 ipv6_addr_prefix fndecl 3 21318 NULL
+disable_so_ath6kl_disconnect_timeout_read_fndecl_21329 ath6kl_disconnect_timeout_read fndecl 3-0 21329 NULL
+disable_so_tx_duty_cycle_cck_brcms_c_info_21336 tx_duty_cycle_cck brcms_c_info 0 21336 NULL
+disable_so_pentium3_get_frequency_fndecl_21339 pentium3_get_frequency fndecl 0 21339 NULL
+disable_so_ldr_img_ir_timing_regvals_21340 ldr img_ir_timing_regvals 0 21340 NULL
+disable_so_extended_cpuid_level_cpuinfo_x86_21354 extended_cpuid_level cpuinfo_x86 0 21354 NULL
+disable_so_btrfs_dev_replace_time_started_fndecl_21355 btrfs_dev_replace_time_started fndecl 0 21355 NULL
+disable_so_sys_getrandom_fndecl_21357 sys_getrandom fndecl 3-0-2 21357 NULL
+disable_so_bit_offset_bm_xfer_ctx_21370 bit_offset bm_xfer_ctx 0 21370 NULL
+disable_so_dtime_inet_peer_21374 dtime inet_peer 0 21374 NULL
+disable_so_ac_btime_acct_v3_21378 ac_btime acct_v3 0 21378 NULL nohasharray
+disable_so_ccp_aes_cmac_final_fndecl_21378 ccp_aes_cmac_final fndecl 0 21378 &disable_so_ac_btime_acct_v3_21378
+disable_so_clock_sdhci_host_21381 clock sdhci_host 0 21381 NULL
+disable_so_check_delayed_ref_fndecl_21388 check_delayed_ref fndecl 0-4-5-6 21388 NULL
+disable_so_ath_gen_timer_alloc_fndecl_21393 ath_gen_timer_alloc fndecl 5 21393 NULL
+disable_so_irq_address_info_21405 irq address_info 0 21405 NULL
+disable_so_mpll_ad_func_cntl_2_rv770_clock_registers_21412 mpll_ad_func_cntl_2 rv770_clock_registers 0 21412 NULL
+disable_so_sctp_copy_one_addr_fndecl_21416 sctp_copy_one_addr fndecl 0-5 21416 NULL
+disable_so_high_mcp_dma_addr_21433 high mcp_dma_addr 0 21433 NULL
+disable_so_volt_change_delay_si_ulv_param_21442 volt_change_delay si_ulv_param 0 21442 NULL
+disable_so_msr_bitmap_vmcs12_21445 msr_bitmap vmcs12 0 21445 NULL
+disable_so_setauthsize_crypto_aead_21450 setauthsize crypto_aead 2 21450 NULL
+disable_so_next_txpwr_check_time_b43_phy_21453 next_txpwr_check_time b43_phy 0 21453 NULL
+disable_so_nl80211_send_assoc_timeout_fndecl_21464 nl80211_send_assoc_timeout fndecl 4 21464 NULL nohasharray
+disable_so_i_no_addr_gfs2_inode_21464 i_no_addr gfs2_inode 0 21464 &disable_so_nl80211_send_assoc_timeout_fndecl_21464
+disable_so_indirect_dma_addr_srp_request_21474 indirect_dma_addr srp_request 0 21474 NULL
+disable_so_btrfs_uuid_iter_rem_fndecl_21476 btrfs_uuid_iter_rem fndecl 0-3-4 21476 NULL
+disable_so_addr_op_msr_21481 addr op_msr 0 21481 NULL
+disable_so_sysctl_x25_call_request_timeout_vardecl_21486 sysctl_x25_call_request_timeout vardecl 0 21486 NULL
+disable_so_guard_time_trf7970a_21487 guard_time trf7970a 0 21487 NULL
+disable_so_mclk_div_mcam_camera_21501 mclk_div mcam_camera 0 21501 NULL
+disable_so_cpu_to_fs16_fndecl_21502 cpu_to_fs16 fndecl 0-2 21502 NULL
+disable_so_dma_addr_dma_mapping_21503 dma_addr dma_mapping 0 21503 NULL
+disable_so_extra_buf1_address_ene_device_21504 extra_buf1_address ene_device 0 21504 NULL
+disable_so_last_completion_time_lpfc_hba_21515 last_completion_time lpfc_hba 0 21515 NULL
+disable_so_il_add_beacon_time_fndecl_21519 il_add_beacon_time fndecl 0-4-3-2 21519 NULL
+disable_so_stats_reset_time_bfa_port_s_21525 stats_reset_time bfa_port_s 0 21525 NULL
+disable_so_rptr_gpu_addr_kernel_queue_21535 rptr_gpu_addr kernel_queue 0 21535 NULL nohasharray
+disable_so_ceph_crypto_init_fndecl_21535 ceph_crypto_init fndecl 0 21535 &disable_so_rptr_gpu_addr_kernel_queue_21535
+disable_so_out_of_line_wait_on_bit_lock_fndecl_21538 out_of_line_wait_on_bit_lock fndecl 0 21538 NULL
+disable_so_demod_address_s5h1409_config_21550 demod_address s5h1409_config 0 21550 NULL
+disable_so_bmsr_cphy_21556 bmsr cphy 0 21556 NULL
+disable_so_small_buf_phy_addr_low_ql3_adapter_21561 small_buf_phy_addr_low ql3_adapter 0 21561 NULL
+disable_so_bitmap_start_sync_fndecl_21564 bitmap_start_sync fndecl 2-4 21564 NULL
+disable_so_last_frequency_mb86a20s_state_21569 last_frequency mb86a20s_state 0 21569 NULL
+disable_so_addr_hi_st_ss_sgitem_21571 addr_hi st_ss_sgitem 0 21571 NULL
+disable_so_last_dev_address_fndecl_21603 last_dev_address fndecl 0-1 21603 NULL
+disable_so_account_user_time_fndecl_21611 account_user_time fndecl 2-3 21611 NULL
+disable_so_mdiv_nvkm_domain_21612 mdiv nvkm_domain 0 21612 NULL
+disable_so_mclk_div_wm8804_priv_21616 mclk_div wm8804_priv 0 21616 NULL
+disable_so_dclk___fb_timings_21625 dclk __fb_timings 0 21625 NULL
+disable_so_ts_jiffies_xpc_rsvd_page_21630 ts_jiffies xpc_rsvd_page 0 21630 NULL
+disable_so_wlcore_translate_addr_fndecl_21631 wlcore_translate_addr fndecl 0-2 21631 NULL
+disable_so_clock_mult_par_info_21633 clock_mult par_info 0 21633 NULL
+disable_so_timeout_mgmt_cp_set_discoverable_21656 timeout mgmt_cp_set_discoverable 0 21656 NULL
+disable_so_timeout_jiffies_jmb38x_ms_host_21666 timeout_jiffies jmb38x_ms_host 0 21666 NULL
+disable_so_ax88179_set_mac_addr_fndecl_21668 ax88179_set_mac_addr fndecl 0 21668 NULL
+disable_so_signalfd_copyinfo_fndecl_21691 signalfd_copyinfo fndecl 0 21691 NULL
+disable_so_crypto_cbc_setkey_fndecl_21695 crypto_cbc_setkey fndecl 0-3 21695 NULL
+disable_so_pm_freeze_timeout_show_fndecl_21696 pm_freeze_timeout_show fndecl 0 21696 NULL
+disable_so_ip_clock_khz_ocores_i2c_21700 ip_clock_khz ocores_i2c 0 21700 NULL
+disable_so_HDSPM_bit2freq_fndecl_21701 HDSPM_bit2freq fndecl 0 21701 NULL
+disable_so_qdelay_old_pie_vars_21717 qdelay_old pie_vars 0 21717 NULL
+disable_so_pixel_clock_max_soc_camera_sense_21728 pixel_clock_max soc_camera_sense 0 21728 NULL
+disable_so_hash_max_net_bridge_21732 hash_max net_bridge 0 21732 NULL
+disable_so_hashfn_fndecl_21739 hashfn fndecl 0 21739 NULL
+disable_so_default_gfx_clock_sst_spec_21741 default_gfx_clock sst_spec 0 21741 NULL
+disable_so_snd_seq_oss_timer_ioctl_fndecl_21751 snd_seq_oss_timer_ioctl fndecl 0 21751 NULL
+disable_so_addr1_dir_table_slot_21753 addr1 dir_table_slot 0 21753 NULL
+disable_so_ieee80211_extend_absent_time_fndecl_21756 ieee80211_extend_absent_time fndecl 2 21756 NULL
+disable_so_sumo_set_ds_dividers_fndecl_21757 sumo_set_ds_dividers fndecl 2-3 21757 NULL
+disable_so_fm_rx_set_freq_fndecl_21763 fm_rx_set_freq fndecl 0-2 21763 NULL
+disable_so_end_phys_addr_qxl_memslot_21767 end_phys_addr qxl_memslot 0 21767 NULL
+disable_so_phys_addr_megasas_sge64_21771 phys_addr megasas_sge64 0 21771 NULL
+disable_so_evtchn_from_irq_fndecl_21772 evtchn_from_irq fndecl 1-0 21772 NULL
+disable_so_addr_pch_gbe_phy_info_21776 addr pch_gbe_phy_info 0 21776 NULL
+disable_so_jiffies_vid_out_vivid_dev_21777 jiffies_vid_out vivid_dev 0 21777 NULL
+disable_so_slottime_ath_hw_21784 slottime ath_hw 0 21784 NULL
+disable_so_ath6kl_wmi_set_host_sleep_mode_cmd_fndecl_21804 ath6kl_wmi_set_host_sleep_mode_cmd fndecl 0-2 21804 NULL
+disable_so_iwl_dbgfs_current_sleep_command_read_fndecl_21810 iwl_dbgfs_current_sleep_command_read fndecl 3-0 21810 NULL
+disable_so_ioctl_sound_timer_operations_21820 ioctl sound_timer_operations 0 21820 NULL
+disable_so_i_atime_sysv_inode_21822 i_atime sysv_inode 0 21822 NULL
+disable_so_rx_ring_dma_addr_amd8111e_priv_21826 rx_ring_dma_addr amd8111e_priv 0 21826 NULL
+disable_so_hundredsOfMicroseconds_timestamp_21834 hundredsOfMicroseconds timestamp 0 21834 NULL
+disable_so_ei_interrupt_fndecl_21846 ei_interrupt fndecl 1 21846 NULL
+disable_so_address_wq_enet_desc_21854 address wq_enet_desc 0 21854 NULL
+disable_so_avivo_get_fb_ref_div_fndecl_21857 avivo_get_fb_ref_div fndecl 3-5 21857 NULL
+disable_so_ac_btime_taskstats_21864 ac_btime taskstats 0 21864 NULL
+disable_so_reg_base_addr_dmar_drhd_unit_21865 reg_base_addr dmar_drhd_unit 0 21865 NULL
+disable_so_svm_scale_tsc_fndecl_21868 svm_scale_tsc fndecl 0-2 21868 NULL
+disable_so_m88rs6000t_sleep_fndecl_21874 m88rs6000t_sleep fndecl 0 21874 NULL
+disable_so_bt_priority_time_ath_btcoex_21878 bt_priority_time ath_btcoex 0 21878 NULL
+disable_so_radeon_legacy_get_memory_clock_fndecl_21881 radeon_legacy_get_memory_clock fndecl 0 21881 NULL
+disable_so_drbg_cpu_to_be32_fndecl_21882 drbg_cpu_to_be32 fndecl 1 21882 NULL
+disable_so_hpi_sample_clock_get_sample_rate_fndecl_21888 hpi_sample_clock_get_sample_rate fndecl 1-0 21888 NULL
+disable_so_refdiv_radeon_atom_ss_21889 refdiv radeon_atom_ss 0 21889 NULL
+disable_so_e_d_tov_timer_val_fcoe_kwqe_conn_offload4_21894 e_d_tov_timer_val fcoe_kwqe_conn_offload4 0 21894 NULL
+disable_so_efx_ef10_rx_disable_timestamping_fndecl_21895 efx_ef10_rx_disable_timestamping fndecl 0 21895 NULL
+disable_so_microseconds_timestamp_21897 microseconds timestamp 0 21897 NULL nohasharray
+disable_so_hashbin_find_fndecl_21897 hashbin_find fndecl 2 21897 &disable_so_microseconds_timestamp_21897
+disable_so_uid_audit_sig_info_21901 uid audit_sig_info 0 21901 NULL
+disable_so_scb_busaddr_ips_scb_21906 scb_busaddr ips_scb 0 21906 NULL
+disable_so_uvc_clock_param_get_fndecl_21908 uvc_clock_param_get fndecl 0 21908 NULL
+disable_so_ali_program_timings_fndecl_21912 ali_program_timings fndecl 4 21912 NULL
+disable_so_rx8025_get_time_fndecl_21924 rx8025_get_time fndecl 0 21924 NULL
+disable_so_rx_addr_uart_8250_dma_21929 rx_addr uart_8250_dma 0 21929 NULL
+disable_so_i2c_addr_sensor_s_21935 i2c_addr sensor_s 0 21935 NULL
+disable_so_interrupt_m66592_21937 interrupt m66592 0 21937 NULL
+disable_so_btintel_check_bdaddr_fndecl_21945 btintel_check_bdaddr fndecl 0 21945 NULL
+disable_so_re_timeout_dummy_hcd_21947 re_timeout dummy_hcd 0 21947 NULL nohasharray
+disable_so_mmc_runtime_suspend_fndecl_21947 mmc_runtime_suspend fndecl 0 21947 &disable_so_re_timeout_dummy_hcd_21947
+disable_so_prb_resp_timeout_brcms_c_info_21953 prb_resp_timeout brcms_c_info 0 21953 NULL
+disable_so_pcf8563_set_datetime_fndecl_21960 pcf8563_set_datetime fndecl 0 21960 NULL nohasharray
+disable_so_addr_low_vring_dma_addr_21960 addr_low vring_dma_addr 0 21960 &disable_so_pcf8563_set_datetime_fndecl_21960
+disable_so_key_schedule_gc_fndecl_21977 key_schedule_gc fndecl 1 21977 NULL
+disable_so_max_freq_softlimit_intel_gen6_power_mgmt_21980 max_freq_softlimit intel_gen6_power_mgmt 0 21980 NULL
+disable_so_sctp_v6_inaddr_any_fndecl_21991 sctp_v6_inaddr_any fndecl 2 21991 NULL
+disable_so_bitmap_get_counter_fndecl_22004 bitmap_get_counter fndecl 2 22004 NULL
+disable_so_id_cpufreq_cooling_device_22010 id cpufreq_cooling_device 0 22010 NULL
+disable_so_efx_phc_adjfreq_fndecl_22013 efx_phc_adjfreq fndecl 0 22013 NULL
+disable_so_i9xx_clock_fndecl_22015 i9xx_clock fndecl 1 22015 NULL
+disable_so_backlight_off_delay_intel_dp_22022 backlight_off_delay intel_dp 0 22022 NULL
+disable_so_adjust_tsc_offset_host_fndecl_22031 adjust_tsc_offset_host fndecl 2 22031 NULL
+disable_so_ocfs2_inode_lock_atime_fndecl_22032 ocfs2_inode_lock_atime fndecl 0 22032 NULL
+disable_so_last_timeout_jiffies_smi_info_22035 last_timeout_jiffies smi_info 0 22035 NULL
+disable_so_dnet_addr_type_fndecl_22038 dnet_addr_type fndecl 1 22038 NULL
+disable_so_qce_ablkcipher_crypt_fndecl_22054 qce_ablkcipher_crypt fndecl 0 22054 NULL
+disable_so_move_addr_to_user_fndecl_22055 move_addr_to_user fndecl 2-0 22055 NULL
+disable_so_qce_cpu_to_be32p_array_fndecl_22057 qce_cpu_to_be32p_array fndecl 3 22057 NULL
+disable_so_rsp_kvm_regs_22061 rsp kvm_regs 0 22061 NULL
+disable_so_sst_hsw_runtime_module_create_fndecl_22070 sst_hsw_runtime_module_create fndecl 3-2 22070 NULL
+disable_so_paddr_ctlr_info_22072 paddr ctlr_info 0 22072 NULL
+disable_so_net2272_get_ep_by_addr_fndecl_22073 net2272_get_ep_by_addr fndecl 2 22073 NULL
+disable_so_nilfs_btree_node_get_ptr_fndecl_22076 nilfs_btree_node_get_ptr fndecl 0-2 22076 NULL
+disable_so_signal_avg_station_info_22078 signal_avg station_info 0 22078 NULL
+disable_so_hdmi_runtime_resume_fndecl_22080 hdmi_runtime_resume fndecl 0 22080 NULL
+disable_so_nla_padlen_fndecl_22096 nla_padlen fndecl 1-0 22096 NULL
+disable_so_sof_offset_uvc_clock_22104 sof_offset uvc_clock 0 22104 NULL
+disable_so_current_frequency_au8522_state_22105 current_frequency au8522_state 0 22105 NULL
+disable_so_vdelay_timing_22106 vdelay timing 0 22106 NULL
+disable_so_abx500_get_register_page_interruptible_fndecl_22107 abx500_get_register_page_interruptible fndecl 0 22107 NULL
+disable_so_xc_set_IF_frequency_fndecl_22111 xc_set_IF_frequency fndecl 0-2 22111 NULL
+disable_so_curr_minor_hash_dir_private_info_22113 curr_minor_hash dir_private_info 0 22113 NULL
+disable_so_ipg_find_phyaddr_fndecl_22117 ipg_find_phyaddr fndecl 0 22117 NULL
+disable_so_dwell_time_passive_conf_sched_scan_settings_22127 dwell_time_passive conf_sched_scan_settings 0 22127 NULL
+disable_so_ontime_snd_emux_voice_22136 ontime snd_emux_voice 0 22136 NULL
+disable_so_queue_info_new_phys_addr_hi_megasas_init_frame_22147 queue_info_new_phys_addr_hi megasas_init_frame 0 22147 NULL
+disable_so_demod_address_tda10048_config_22153 demod_address tda10048_config 0 22153 NULL
+disable_so_timestamp_data_baddr_pmcraid_instance_22154 timestamp_data_baddr pmcraid_instance 0 22154 NULL
+disable_so_qce_setup_regs_ablkcipher_fndecl_22163 qce_setup_regs_ablkcipher fndecl 0-2 22163 NULL
+disable_so_cpu_index_cpuinfo_x86_22166 cpu_index cpuinfo_x86 0 22166 NULL nohasharray
+disable_so_cache_timeout_vardecl_sm_ftl_c_22166 cache_timeout vardecl_sm_ftl.c 0 22166 &disable_so_cpu_index_cpuinfo_x86_22166
+disable_so_ls_scan_time_dlm_ls_22170 ls_scan_time dlm_ls 0 22170 NULL
+disable_so_overflowgid_vardecl_22177 overflowgid vardecl 0 22177 NULL
+disable_so_timeout_uart_port_22187 timeout uart_port 0 22187 NULL
+disable_so_ctime_nilfs_segsum_info_22193 ctime nilfs_segsum_info 0 22193 NULL
+disable_so___cpu_to_virtio32_fndecl_22198 __cpu_to_virtio32 fndecl 0-2 22198 NULL
+disable_so___page_check_address_fndecl_22199 __page_check_address fndecl 3 22199 NULL
+disable_so_frequency_khz_m88rs6000t_dev_22206 frequency_khz m88rs6000t_dev 0 22206 NULL
+disable_so_fm10k_update_mc_addr_vf_fndecl_22212 fm10k_update_mc_addr_vf fndecl 4 22212 NULL
+disable_so_xfs_daddr_to_agno_fndecl_22214 xfs_daddr_to_agno fndecl 0-2 22214 NULL
+disable_so_addr_radeon_bo_va_22216 addr radeon_bo_va 0 22216 NULL
+disable_so_iwl_dbgfs_sleep_level_override_read_fndecl_22221 iwl_dbgfs_sleep_level_override_read fndecl 3-0 22221 NULL
+disable_so_write_seq_cxgbi_sock_22223 write_seq cxgbi_sock 0 22223 NULL
+disable_so_jiffies_init_s_stats_22227 jiffies_init s_stats 0 22227 NULL
+disable_so_addr_1_qla83xx_minidump_entry_pollrdmwr_22235 addr_1 qla83xx_minidump_entry_pollrdmwr 0 22235 NULL
+disable_so_boomerang_interrupt_fndecl_22238 boomerang_interrupt fndecl 1 22238 NULL
+disable_so_start_addr_prism2_download_data_22240 start_addr prism2_download_data 0 22240 NULL
+disable_so_addr_fixed_phy_22243 addr fixed_phy 0 22243 NULL
+disable_so_parenttime_ictimesync_data_22250 parenttime ictimesync_data 0 22250 NULL
+disable_so_tidvaddr_ipath_tid_info_22251 tidvaddr ipath_tid_info 0 22251 NULL
+disable_so_ip_vs_sh_hashkey_fndecl_22252 ip_vs_sh_hashkey fndecl 1 22252 NULL
+disable_so_m41t94_set_time_fndecl_22256 m41t94_set_time fndecl 0 22256 NULL
+disable_so___bitmap_and_fndecl_22259 __bitmap_and fndecl 4 22259 NULL
+disable_so_read_addr_qla82xx_md_entry_rdrom_22262 read_addr qla82xx_md_entry_rdrom 0 22262 NULL
+disable_so_crypto_authenc_esn_iverify_fndecl_22263 crypto_authenc_esn_iverify fndecl 0-3 22263 NULL
+disable_so_udelay_ixgbe_mbx_info_22275 udelay ixgbe_mbx_info 0 22275 NULL
+disable_so_addr_init_tab_22277 addr init_tab 0 22277 NULL nohasharray
+disable_so_cpufreq_cpu_get_raw_fndecl_22277 cpufreq_cpu_get_raw fndecl 1 22277 &disable_so_addr_init_tab_22277
+disable_so_show_orig_dgid_fndecl_22281 show_orig_dgid fndecl 0 22281 NULL
+disable_so_tua6100_sleep_fndecl_22289 tua6100_sleep fndecl 0 22289 NULL
+disable_so_crypto_memneq_fndecl_22293 crypto_memneq fndecl 3 22293 NULL
+disable_so_next_gid_index_mthca_mgm_22295 next_gid_index mthca_mgm 0 22295 NULL
+disable_so__abb5zes3_rtc_read_time_fndecl_22302 _abb5zes3_rtc_read_time fndecl 0 22302 NULL nohasharray
+disable_so_free_block_xfs_btree_ops_22302 free_block xfs_btree_ops 0 22302 &disable_so__abb5zes3_rtc_read_time_fndecl_22302
+disable_so_cn_vprintf_fndecl_22303 cn_vprintf fndecl 0 22303 NULL nohasharray
+disable_so_ixgbe_read_reg_fndecl_22303 ixgbe_read_reg fndecl 0-2 22303 &disable_so_cn_vprintf_fndecl_22303
+disable_so_utime_mddev_22314 utime mddev 0 22314 NULL
+disable_so_set_node_addr_fndecl_22329 set_node_addr fndecl 3 22329 NULL
+disable_so_start_group_wait_time_cfqg_stats_22330 start_group_wait_time cfqg_stats 0 22330 NULL
+disable_so_addrLow_ulp_bde64_22341 addrLow ulp_bde64 0 22341 NULL
+disable_so_mr_get_mtt_addr_fndecl_22342 mr_get_mtt_addr fndecl 0 22342 NULL
+disable_so_auto_deep_sleep_timeout_lbs_private_22358 auto_deep_sleep_timeout lbs_private 0 22358 NULL
+disable_so_daddr_min_pktgen_dev_22362 daddr_min pktgen_dev 0 22362 NULL
+disable_so_tusb_set_clock_source_fndecl_22365 tusb_set_clock_source fndecl 2 22365 NULL
+disable_so_ocfs2_rotate_subtree_right_fndecl_22369 ocfs2_rotate_subtree_right fndecl 0-5 22369 NULL
+disable_so_timestamp_nfs4_unlockdata_22375 timestamp nfs4_unlockdata 0 22375 NULL
+disable_so_time_perf_event_context_22379 time perf_event_context 0 22379 NULL
+disable_so_max8998_set_voltage_buck_time_sel_fndecl_22384 max8998_set_voltage_buck_time_sel fndecl 0-2-3 22384 NULL
+disable_so_to_increment_rpc_timeout_22408 to_increment rpc_timeout 0 22408 NULL
+disable_so_pci_addr_islpci_membuf_22412 pci_addr islpci_membuf 0 22412 NULL
+disable_so_gf_div_fndecl_22416 gf_div fndecl 0-2-3 22416 NULL
+disable_so_timeout_us_drm_vmw_fence_wait_arg_22421 timeout_us drm_vmw_fence_wait_arg 0 22421 NULL
+disable_so_sd_ctime_stat_data_22425 sd_ctime stat_data 0 22425 NULL nohasharray
+disable_so_runtime_reg_sch311x_gpio_block_22425 runtime_reg sch311x_gpio_block 0 22425 &disable_so_sd_ctime_stat_data_22425 nohasharray
+disable_so_crypto_authenc_iverify_fndecl_22425 crypto_authenc_iverify fndecl 0-3 22425 &disable_so_runtime_reg_sch311x_gpio_block_22425
+disable_so_port_guid_ib_node_info_22427 port_guid ib_node_info 0 22427 NULL
+disable_so_ring_iowrite32options_fndecl_22428 ring_iowrite32options fndecl 2 22428 NULL
+disable_so_period_ptr_snd_pcm_oss_runtime_22430 period_ptr snd_pcm_oss_runtime 0 22430 NULL
+disable_so_ac_stimescaled_taskstats_22436 ac_stimescaled taskstats 0 22436 NULL
+disable_so_slave_address_acpi_resource_i2c_serialbus_22453 slave_address acpi_resource_i2c_serialbus 0 22453 NULL
+disable_so_dma_addr1_flexcop_dma_22481 dma_addr1 flexcop_dma 0 22481 NULL
+disable_so_r11_kvm_regs_22488 r11 kvm_regs 0 22488 NULL
+disable_so_lookup_overlapping_address_handler_fndecl_22494 lookup_overlapping_address_handler fndecl 2-3 22494 NULL
+disable_so_throttled_clock_task_cfs_rq_22505 throttled_clock_task cfs_rq 0 22505 NULL
+disable_so_bulletin_addr_vfpf_acquire_tlv_22506 bulletin_addr vfpf_acquire_tlv 0 22506 NULL
+disable_so_buffer_bytes_snd_pcm_oss_runtime_22509 buffer_bytes snd_pcm_oss_runtime 0 22509 NULL
+disable_so_cryptd_hash_enqueue_fndecl_22511 cryptd_hash_enqueue fndecl 0 22511 NULL
+disable_so_set_msr_hyperv_pw_fndecl_22514 set_msr_hyperv_pw fndecl 3 22514 NULL
+disable_so_am335x_tsc_se_set_cache_fndecl_22522 am335x_tsc_se_set_cache fndecl 2 22522 NULL
+disable_so_dwell_time_delta_per_probe_5_conf_sched_scan_settings_22525 dwell_time_delta_per_probe_5 conf_sched_scan_settings 0 22525 NULL
+disable_so_stride_qxl_bitmap_22527 stride qxl_bitmap 0 22527 NULL
+disable_so_enable_time_regulator_ops_22541 enable_time regulator_ops 0 22541 NULL
+disable_so_usb_port_runtime_resume_fndecl_22542 usb_port_runtime_resume fndecl 0 22542 NULL
+disable_so_i_time_minix_inode_22559 i_time minix_inode 0 22559 NULL
+disable_so_rpc_uaddr2sockaddr_fndecl_22573 rpc_uaddr2sockaddr fndecl 0-3 22573 NULL
+disable_so_runtime_show_fndecl_22581 runtime_show fndecl 0 22581 NULL
+disable_so__sched_setscheduler_fndecl_22589 _sched_setscheduler fndecl 0-2 22589 NULL
+disable_so_ahc_outb_fndecl_22592 ahc_outb fndecl 2-3 22592 NULL
+disable_so_tcp_fin_timeout_ip_vs_timeout_user_22596 tcp_fin_timeout ip_vs_timeout_user 0 22596 NULL
+disable_so_channels_snd_pcm_oss_runtime_22629 channels snd_pcm_oss_runtime 0 22629 NULL
+disable_so_ivsize_blkcipher_walk_22638 ivsize blkcipher_walk 0 22638 NULL
+disable_so_xpcs_reg_addr_read_fndecl_22646 xpcs_reg_addr_read fndecl 3-0 22646 NULL
+disable_so_ea_segmented_address_22657 ea segmented_address 0 22657 NULL
+disable_so_rxhash_bnx2x_agg_info_22658 rxhash bnx2x_agg_info 0 22658 NULL
+disable_so_get_timer_interval_fndecl_22661 get_timer_interval fndecl 0-2 22661 NULL
+disable_so_clock_psb_intel_sdvo_preferred_input_timing_args_22671 clock psb_intel_sdvo_preferred_input_timing_args 0 22671 NULL
+disable_so_nft_hash_obj_fndecl_22673 nft_hash_obj fndecl 0-2 22673 NULL
+disable_so_ber_jiffies_stats_dib8000_state_22674 ber_jiffies_stats dib8000_state 0 22674 NULL
+disable_so_sleep_ms_rtl_ps_ctl_22681 sleep_ms rtl_ps_ctl 0 22681 NULL
+disable_so_addr_hi_eth_tx_start_bd_22685 addr_hi eth_tx_start_bd 0 22685 NULL
+disable_so_lasttime_sym_shcb_22688 lasttime sym_shcb 0 22688 NULL
+disable_so_cttimeout_init_fndecl_22691 cttimeout_init fndecl 0 22691 NULL
+disable_so_crypto_authenc_encrypt_fndecl_22693 crypto_authenc_encrypt fndecl 0 22693 NULL
+disable_so_kernfs_name_hash_fndecl_22704 kernfs_name_hash fndecl 0 22704 NULL
+disable_so_msleep_interruptible_fndecl_22713 msleep_interruptible fndecl 1-0 22713 NULL
+disable_so_compq_addr_lo_addr_ctrl_blk_22728 compq_addr_lo addr_ctrl_blk 0 22728 NULL
+disable_so_dib7000p_get_time_us_fndecl_22737 dib7000p_get_time_us fndecl 0 22737 NULL
+disable_so_src_addr_dma_slave_config_22748 src_addr dma_slave_config 0 22748 NULL
+disable_so_userspace_addr_kvm_memory_slot_22749 userspace_addr kvm_memory_slot 0 22749 NULL
+disable_so_addr6_resolve_fndecl_22753 addr6_resolve fndecl 0 22753 NULL
+disable_so_sst_pm_runtime_put_fndecl_22759 sst_pm_runtime_put fndecl 0 22759 NULL
+disable_so_mlx4_ib_get_aguid_comp_mask_from_ix_fndecl_22761 mlx4_ib_get_aguid_comp_mask_from_ix fndecl 0-1 22761 NULL
+disable_so_d_time_dentry_22767 d_time dentry 0 22767 NULL
+disable_so_mtd_to_docg4_address_fndecl_22769 mtd_to_docg4_address fndecl 0-1-2 22769 NULL
+disable_so_cycle_counter_tag_capidtmf_recv_state_22771 cycle_counter tag_capidtmf_recv_state 0 22771 NULL
+disable_so_lp872x_select_buck_vout_addr_fndecl_22790 lp872x_select_buck_vout_addr fndecl 0-2 22790 NULL
+disable_so_base_mbox_addr_blogic_extmbox_req_22802 base_mbox_addr blogic_extmbox_req 0 22802 NULL nohasharray
+disable_so_no_addr_gfs2_inum_22802 no_addr gfs2_inum 0 22802 &disable_so_base_mbox_addr_blogic_extmbox_req_22802
+disable_so_debug_dma_map_sg_fndecl_22804 debug_dma_map_sg fndecl 3-4 22804 NULL
+disable_so___cpuidle_register_driver_fndecl_22806 __cpuidle_register_driver fndecl 0 22806 NULL
+disable_so_vhost64_to_cpu_fndecl_22807 vhost64_to_cpu fndecl 0 22807 NULL
+disable_so_start_address_acpi_address_range_22816 start_address acpi_address_range 0 22816 NULL
+disable_so_mce_request_packet_fndecl_22818 mce_request_packet fndecl 3 22818 NULL
+disable_so_bad_std_timing_fndecl_22827 bad_std_timing fndecl 1 22827 NULL
+disable_so_swap_cluster_schedule_discard_fndecl_22833 swap_cluster_schedule_discard fndecl 2 22833 NULL
+disable_so_palmas_rtc_set_time_fndecl_22849 palmas_rtc_set_time fndecl 0 22849 NULL
+disable_so___arch_hweight8_fndecl_22850 __arch_hweight8 fndecl 0-1 22850 NULL
+disable_so_store_risefalltime_fndecl_22854 store_risefalltime fndecl 5-0-4 22854 NULL
+disable_so_qlcnic_83xx_get_mac_address_fndecl_22858 qlcnic_83xx_get_mac_address fndecl 0 22858 NULL
+disable_so_vnic_dev_get_mac_addr_fndecl_22860 vnic_dev_get_mac_addr fndecl 0 22860 NULL
+disable_so_hash_id_hh_flow_state_22864 hash_id hh_flow_state 0 22864 NULL
+disable_so_runtime_suspend_dev_pm_ops_22871 runtime_suspend dev_pm_ops 0 22871 NULL nohasharray
+disable_so_objectid_btrfs_key_22871 objectid btrfs_key 0 22871 &disable_so_runtime_suspend_dev_pm_ops_22871
+disable_so_bitmap_parse_fndecl_22876 bitmap_parse fndecl 0-2-4 22876 NULL
+disable_so_avg_delay_fndecl_22883 avg_delay fndecl 0 22883 NULL nohasharray
+disable_so_mce_threshold_block_init_fndecl_22883 mce_threshold_block_init fndecl 2 22883 &disable_so_avg_delay_fndecl_22883
+disable_so_pdeath_signal_task_struct_22884 pdeath_signal task_struct 0 22884 NULL
+disable_so_bits_per_word_blk_mq_bitmap_tags_22896 bits_per_word blk_mq_bitmap_tags 0 22896 NULL
+disable_so_saddr_irda_device_info_22915 saddr irda_device_info 0 22915 NULL
+disable_so_frm_extra_delay_vardecl_isar_c_22927 frm_extra_delay vardecl_isar.c 0 22927 NULL
+disable_so_lbs_set_host_sleep_fndecl_22932 lbs_set_host_sleep fndecl 0 22932 NULL
+disable_so_orinoco_ioctl_setfreq_fndecl_22934 orinoco_ioctl_setfreq fndecl 0 22934 NULL
+disable_so_bit_bitstream_cursor_22959 bit bitstream_cursor 0 22959 NULL
+disable_so_cifs_strtoUTF16_fndecl_22967 cifs_strtoUTF16 fndecl 0-3 22967 NULL
+disable_so_rbx_kvm_regs_22975 rbx kvm_regs 0 22975 NULL
+disable_so_runtime_resume_dev_pm_ops_22976 runtime_resume dev_pm_ops 0 22976 NULL
+disable_so_address_ioaccel2_sg_element_22986 address ioaccel2_sg_element 0 22986 NULL
+disable_so_frags_paddr_htt_data_tx_desc_22993 frags_paddr htt_data_tx_desc 0 22993 NULL
+disable_so_ss_ctime_nilfs_sustat_23015 ss_ctime nilfs_sustat 0 23015 NULL
+disable_so_radeon_atom_set_ac_timing_fndecl_23020 radeon_atom_set_ac_timing fndecl 2 23020 NULL
+disable_so_b43legacy_interrupt_ack_fndecl_23025 b43legacy_interrupt_ack fndecl 2 23025 NULL
+disable_so_i_atime_nsec_f2fs_inode_23028 i_atime_nsec f2fs_inode 0 23028 NULL
+disable_so_addr_wil_fw_record_fill_23039 addr wil_fw_record_fill 0 23039 NULL
+disable_so_cyc2ns_offset_cyc2ns_data_23042 cyc2ns_offset cyc2ns_data 0 23042 NULL
+disable_so_panel_power_cycle_delay_cdv_intel_dp_23045 panel_power_cycle_delay cdv_intel_dp 0 23045 NULL
+disable_so_crypto_rfc4543_copy_src_to_dst_fndecl_23047 crypto_rfc4543_copy_src_to_dst fndecl 0 23047 NULL
+disable_so_pte_pfn_to_mfn_fndecl_23066 pte_pfn_to_mfn fndecl 1-0 23066 NULL
+disable_so_hpll_freq_drm_i915_private_23074 hpll_freq drm_i915_private 0 23074 NULL
+disable_so_ly_base_addr_c67x00_td_23082 ly_base_addr c67x00_td 0 23082 NULL
+disable_so_num_bits_alps_bitmap_point_23084 num_bits alps_bitmap_point 0 23084 NULL
+disable_so_ip6addrlbl_dump_fndecl_23085 ip6addrlbl_dump fndecl 0 23085 NULL
+disable_so_sc_seg_ctime_nilfs_sc_info_23088 sc_seg_ctime nilfs_sc_info 0 23088 NULL
+disable_so_rxbd_addr_lo_host_cmd_ds_pcie_details_23092 rxbd_addr_lo host_cmd_ds_pcie_details 0 23092 NULL
+disable_so_addrconf_init_fndecl_23107 addrconf_init fndecl 0 23107 NULL
+disable_so_regcache_lzo_read_fndecl_23109 regcache_lzo_read fndecl 0-2 23109 NULL
+disable_so_mac_addr_high_nes_adapter_23110 mac_addr_high nes_adapter 0 23110 NULL nohasharray
+disable_so_gf100_fifo_engidx_fndecl_23110 gf100_fifo_engidx fndecl 0 23110 &disable_so_mac_addr_high_nes_adapter_23110
+disable_so_busy_timeout_mmc_command_23112 busy_timeout mmc_command 0 23112 NULL
+disable_so_expired_tscdeadline_kvm_timer_23113 expired_tscdeadline kvm_timer 0 23113 NULL nohasharray
+disable_so_dtoh_mb_data_addr_brcmf_pcie_shared_info_23113 dtoh_mb_data_addr brcmf_pcie_shared_info 0 23113 &disable_so_expired_tscdeadline_kvm_timer_23113
+disable_so_mmc_mmc_erase_timeout_fndecl_23122 mmc_mmc_erase_timeout fndecl 0-3-2 23122 NULL
+disable_so_bq32k_rtc_read_time_fndecl_23124 bq32k_rtc_read_time fndecl 0 23124 NULL
+disable_so_mtt_base_addr_h_mlx4_eq_context_23127 mtt_base_addr_h mlx4_eq_context 0 23127 NULL
+disable_so_sack_timeout_netns_sctp_23134 sack_timeout netns_sctp 0 23134 NULL
+disable_so_addr_hw_breakpoint_23137 addr hw_breakpoint 0 23137 NULL
+disable_so_port_sctp_bind_addr_23142 port sctp_bind_addr 0 23142 NULL
+disable_so_rpa_timeout_set_fndecl_23145 rpa_timeout_set fndecl 2 23145 NULL nohasharray
+disable_so_mthca_SW2HW_MPT_fndecl_23145 mthca_SW2HW_MPT fndecl 0-3 23145 &disable_so_rpa_timeout_set_fndecl_23145 nohasharray
+disable_so_mlx5_query_mad_ifc_node_guid_fndecl_23145 mlx5_query_mad_ifc_node_guid fndecl 0 23145 &disable_so_mthca_SW2HW_MPT_fndecl_23145
+disable_so_eof_gid_xfs_fs_eofblocks_23146 eof_gid xfs_fs_eofblocks 0 23146 NULL
+disable_so_ccp_aes_decrypt_fndecl_23149 ccp_aes_decrypt fndecl 0 23149 NULL
+disable_so_idle_timeout_hci_dev_23160 idle_timeout hci_dev 0 23160 NULL
+disable_so_radeon_atom_set_memory_clock_fndecl_23164 radeon_atom_set_memory_clock fndecl 2 23164 NULL
+disable_so_k_pll_div_23168 k pll_div 0 23168 NULL
+disable_so_ebitmap_node_clr_bit_fndecl_23171 ebitmap_node_clr_bit fndecl 2 23171 NULL
+disable_so_rt_runtime_rt_schedulable_data_23172 rt_runtime rt_schedulable_data 0 23172 NULL
+disable_so_reply_dma_min_address_MPT2SAS_ADAPTER_23181 reply_dma_min_address MPT2SAS_ADAPTER 0 23181 NULL
+disable_so_tsc_shift_pvclock_vcpu_time_info_23184 tsc_shift pvclock_vcpu_time_info 0 23184 NULL
+disable_so_vlan_dev_set_mac_address_fndecl_23188 vlan_dev_set_mac_address fndecl 0 23188 NULL
+disable_so_mpll_ss1_ci_clock_registers_23197 mpll_ss1 ci_clock_registers 0 23197 NULL
+disable_so_addr_cmd_complete_fndecl_23200 addr_cmd_complete fndecl 0 23200 NULL
+disable_so_cpu_clock_fndecl_23205 cpu_clock fndecl 1-0 23205 NULL
+disable_so_prescale_pll_div_23215 prescale pll_div 0 23215 NULL
+disable_so_sel_addr2___mux2_23216 sel_addr2 __mux2 0 23216 NULL
+disable_so_usb_sleep_charge_store_fndecl_23232 usb_sleep_charge_store fndecl 0-4 23232 NULL
+disable_so_bmc150_accel_set_interrupt_fndecl_23235 bmc150_accel_set_interrupt fndecl 0 23235 NULL
+disable_so_netlbl_af4list_audit_addr_fndecl_23240 netlbl_af4list_audit_addr fndecl 4-5 23240 NULL
+disable_so_max_freq_intel_gen6_power_mgmt_23243 max_freq intel_gen6_power_mgmt 0 23243 NULL
+disable_so_i_ctime_ext4_inode_23246 i_ctime ext4_inode 0 23246 NULL
+disable_so_sel_read_avc_hash_stats_fndecl_23251 sel_read_avc_hash_stats fndecl 0-3 23251 NULL
+disable_so_wlc_phy_get_chan_freq_range_nphy_fndecl_23253 wlc_phy_get_chan_freq_range_nphy fndecl 2 23253 NULL
+disable_so_trinity_convert_did_to_freq_fndecl_23254 trinity_convert_did_to_freq fndecl 0-2 23254 NULL
+disable_so_nopin_timeout_iscsi_node_attrib_23262 nopin_timeout iscsi_node_attrib 0 23262 NULL
+disable_so_blk_rq_timeout_fndecl_23263 blk_rq_timeout fndecl 0-1 23263 NULL
+disable_so_dmfe_interrupt_fndecl_23265 dmfe_interrupt fndecl 1 23265 NULL
+disable_so_crypto_rng_generate_fndecl_23266 crypto_rng_generate fndecl 0-5 23266 NULL
+disable_so_ebitmap_read_fndecl_23268 ebitmap_read fndecl 0 23268 NULL
+disable_so_loops_per_jiffy_cpuinfo_x86_23277 loops_per_jiffy cpuinfo_x86 0 23277 NULL
+disable_so_T7_address_mxt_data_23282 T7_address mxt_data 0 23282 NULL
+disable_so_turn_around_timeout_mipi_config_23283 turn_around_timeout mipi_config 0 23283 NULL
+disable_so_crypto_report_one_fndecl_23300 crypto_report_one fndecl 0 23300 NULL
+disable_so_io_base_addr_pch_spi_data_23302 io_base_addr pch_spi_data 0 23302 NULL
+disable_so___ww_mutex_lock_interruptible_fndecl_23308 __ww_mutex_lock_interruptible fndecl 0 23308 NULL
+disable_so_get_bitmap_file_fndecl_23317 get_bitmap_file fndecl 0 23317 NULL
+disable_so_address_hi_lpfc_rqe_23318 address_hi lpfc_rqe 0 23318 NULL
+disable_so_iscsit_na_nopin_response_timeout_fndecl_23323 iscsit_na_nopin_response_timeout fndecl 2-0 23323 NULL
+disable_so_omap1_spi100k_runtime_resume_fndecl_23325 omap1_spi100k_runtime_resume fndecl 0 23325 NULL
+disable_so_snd_timer_global_register_fndecl_23326 snd_timer_global_register fndecl 0 23326 NULL
+disable_so_to_initval_rpc_timeout_23329 to_initval rpc_timeout 0 23329 NULL
+disable_so_bd_list_addr_hi_bnx2i_text_request_23342 bd_list_addr_hi bnx2i_text_request 0 23342 NULL
+disable_so_i2c_addr_a8293_config_23348 i2c_addr a8293_config 0 23348 NULL
+disable_so_range_sizek_var_mtrr_state_23353 range_sizek var_mtrr_state 0 23353 NULL
+disable_so_total_time_running_perf_event_23362 total_time_running perf_event 0 23362 NULL
+disable_so_vdi_gid_vxfs_inode_info_23369 vdi_gid vxfs_inode_info 0 23369 NULL
+disable_so_attrtimeo_timestamp_nfs_inode_23391 attrtimeo_timestamp nfs_inode 0 23391 NULL
+disable_so_si476x_core_cmd_fm_tune_freq_a10_fndecl_23406 si476x_core_cmd_fm_tune_freq_a10 fndecl 0 23406 NULL
+disable_so_sensor_addr_sd_23409 sensor_addr sd 0 23409 NULL
+disable_so_run_delayed_extent_op_fndecl_23414 run_delayed_extent_op fndecl 0 23414 NULL
+disable_so_PXDaddress_fndecl_23420 PXDaddress fndecl 2 23420 NULL
+disable_so_timeout_addr_req_23421 timeout addr_req 0 23421 NULL
+disable_so_tx_pwr_last_recalc_freq_b43_phy_n_23433 tx_pwr_last_recalc_freq b43_phy_n 0 23433 NULL
+disable_so_iscsit_na_nopin_timeout_fndecl_23436 iscsit_na_nopin_timeout fndecl 2-0 23436 NULL
+disable_so_set_tsc_khz_kvm_x86_ops_23439 set_tsc_khz kvm_x86_ops 2 23439 NULL
+disable_so_eee_timer_vardecl_stmmac_main_c_23447 eee_timer vardecl_stmmac_main.c 0 23447 NULL
+disable_so_ndac_aic31xx_rate_divs_23456 ndac aic31xx_rate_divs 0 23456 NULL nohasharray
+disable_so_r27_val_fc2580_freq_regs_23456 r27_val fc2580_freq_regs 0 23456 &disable_so_ndac_aic31xx_rate_divs_23456
+disable_so_ports_timeout_uhci_hcd_23457 ports_timeout uhci_hcd 0 23457 NULL
+disable_so_fw_load_addr_cas_23459 fw_load_addr cas 0 23459 NULL
+disable_so_enic_dev_add_addr_fndecl_23465 enic_dev_add_addr fndecl 0 23465 NULL
+disable_so_hpet_num_timers_vardecl_hpet_c_23468 hpet_num_timers vardecl_hpet.c 0 23468 NULL
+disable_so_protocol_tomoyo_addr_info_23473 protocol tomoyo_addr_info 0 23473 NULL
+disable_so_sys_clock_settime_fndecl_23475 sys_clock_settime fndecl 1 23475 NULL
+disable_so_pch_uart_hal_enable_interrupt_fndecl_23482 pch_uart_hal_enable_interrupt fndecl 2 23482 NULL
+disable_so_start_addr_snd_emu10k1_pcm_23487 start_addr snd_emu10k1_pcm 0 23487 NULL
+disable_so___bitmap_xor_fndecl_23490 __bitmap_xor fndecl 4 23490 NULL
+disable_so_dst_addr_beiscsi_endpoint_23495 dst_addr beiscsi_endpoint 0 23495 NULL
+disable_so_mask_hi_mtrr_var_range_23508 mask_hi mtrr_var_range 0 23508 NULL
+disable_so_max_mlx4_bitmap_23521 max mlx4_bitmap 0 23521 NULL
+disable_so_bitmap_ip_do_list_fndecl_23527 bitmap_ip_do_list fndecl 0 23527 NULL
+disable_so_radio_freq_tuner_23529 radio_freq tuner 0 23529 NULL
+disable_so_timeout_idletimer_tg_info_23534 timeout idletimer_tg_info 0 23534 NULL
+disable_so_end_jiffies_iwl_mvm_time_event_data_23536 end_jiffies iwl_mvm_time_event_data 0 23536 NULL
+disable_so_try_read_address_fndecl_23550 try_read_address fndecl 0-2 23550 NULL
+disable_so_cpufreq_stats_create_table_fndecl_23554 cpufreq_stats_create_table fndecl 1 23554 NULL
+disable_so_div2__pll_div_23561 div2 _pll_div 0 23561 NULL
+disable_so_hpi_sample_clock_set_local_rate_fndecl_23570 hpi_sample_clock_set_local_rate fndecl 1-0 23570 NULL
+disable_so_sctp_assoc_set_bind_addr_from_ep_fndecl_23572 sctp_assoc_set_bind_addr_from_ep fndecl 0-3 23572 NULL
+disable_so_hscb_busaddr_scb_data_23574 hscb_busaddr scb_data 0 23574 NULL
+disable_so_shadow_msr_edgeport_port_23577 shadow_msr edgeport_port 0 23577 NULL
+disable_so_gcm_hash_fndecl_23580 gcm_hash fndecl 0 23580 NULL
+disable_so_kvm_send_hwpoison_signal_fndecl_23581 kvm_send_hwpoison_signal fndecl 1 23581 NULL
+disable_so_spu_reg_delay_if_spi_card_23584 spu_reg_delay if_spi_card 0 23584 NULL
+disable_so_inet_rtm_deladdr_fndecl_23589 inet_rtm_deladdr fndecl 0 23589 NULL
+disable_so_sm2_runtime_sc_23590 sm2 runtime_sc 0 23590 NULL
+disable_so_cpumask_parselist_user_fndecl_23592 cpumask_parselist_user fndecl 0-2 23592 NULL
+disable_so_clock_cooling_get_frequency_fndecl_23598 clock_cooling_get_frequency fndecl 0 23598 NULL
+disable_so_nilfs_btree_last_key_fndecl_23599 nilfs_btree_last_key fndecl 0 23599 NULL
+disable_so_address_map_r8a66597_23613 address_map r8a66597 0 23613 NULL
+disable_so_closest_timer_fndecl_23617 closest_timer fndecl 2 23617 NULL
+disable_so_delay_radeon_atom_ss_23618 delay radeon_atom_ss 0 23618 NULL
+disable_so_no_addr_gfs2_skip_data_23619 no_addr gfs2_skip_data 0 23619 NULL nohasharray
+disable_so_bloutp_qat_crypto_request_buffs_23619 bloutp qat_crypto_request_buffs 0 23619 &disable_so_no_addr_gfs2_skip_data_23619
+disable_so_i2s_runtime_resume_fndecl_23625 i2s_runtime_resume fndecl 0 23625 NULL nohasharray
+disable_so_mtime_seg_entry_23625 mtime seg_entry 0 23625 &disable_so_i2s_runtime_resume_fndecl_23625
+disable_so_atime_apds990x_chip_23626 atime apds990x_chip 0 23626 NULL
+disable_so_irq_domain_free_irqs_fndecl_23634 irq_domain_free_irqs fndecl 1-2 23634 NULL
+disable_so_gru_last_node_paddr_vardecl_x2apic_uv_x_c_23641 gru_last_node_paddr vardecl_x2apic_uv_x.c 0 23641 NULL
+disable_so_tss_addr_kvm_arch_23642 tss_addr kvm_arch 0 23642 NULL
+disable_so_rv3029c2_rtc_read_time_fndecl_23644 rv3029c2_rtc_read_time fndecl 0 23644 NULL
+disable_so___round_jiffies_fndecl_23650 __round_jiffies fndecl 2-1-0 23650 NULL
+disable_so_fixed_mtrr_seg_unit_range_index_fndecl_23657 fixed_mtrr_seg_unit_range_index fndecl 2-0 23657 NULL
+disable_so_timeriomem_rng_driver_init_fndecl_23666 timeriomem_rng_driver_init fndecl 0 23666 NULL
+disable_so_read_status_jiffies_af9013_state_23669 read_status_jiffies af9013_state 0 23669 NULL
+disable_so_st_gid_compat_stat_23673 st_gid compat_stat 0 23673 NULL nohasharray
+disable_so_addr_snic_sg_desc_23673 addr snic_sg_desc 0 23673 &disable_so_st_gid_compat_stat_23673
+disable_so_boottime_get_fndecl_23679 boottime_get fndecl 0 23679 NULL
+disable_so_sctp_v4_inaddr_any_fndecl_23681 sctp_v4_inaddr_any fndecl 2 23681 NULL
+disable_so_posix_cpu_clock_get_task_fndecl_23683 posix_cpu_clock_get_task fndecl 2 23683 NULL nohasharray
+disable_so_gpio_free_fndecl_23683 gpio_free fndecl 1 23683 &disable_so_posix_cpu_clock_get_task_fndecl_23683
+disable_so_ebitmap_cpy_fndecl_23688 ebitmap_cpy fndecl 0 23688 NULL
+disable_so___bitmap_parselist_fndecl_23689 __bitmap_parselist fndecl 0-2-5 23689 NULL
+disable_so_wlcore_hw_interrupt_notify_fndecl_23695 wlcore_hw_interrupt_notify fndecl 0 23695 NULL
+disable_so_schedule_zero_fndecl_23702 schedule_zero fndecl 2-3 23702 NULL nohasharray
+disable_so_mtt_addr_mlx4_mpt_entry_23702 mtt_addr mlx4_mpt_entry 0 23702 &disable_so_schedule_zero_fndecl_23702
+disable_so_adis16400_get_freq_fndecl_23703 adis16400_get_freq fndecl 0 23703 NULL
+disable_so_interrupt_out_endpoint_size_ld_usb_23705 interrupt_out_endpoint_size ld_usb 0 23705 NULL
+disable_so_mac_time_libipw_rx_stats_23706 mac_time libipw_rx_stats 0 23706 NULL nohasharray
+disable_so___ipv6_addr_diff_fndecl_23706 __ipv6_addr_diff fndecl 0 23706 &disable_so_mac_time_libipw_rx_stats_23706
+disable_so_delay_snd_pcm_status_23708 delay snd_pcm_status 0 23708 NULL
+disable_so_oprofile_set_timeout_fndecl_23715 oprofile_set_timeout fndecl 1-0 23715 NULL
+disable_so_fll_fratio__fll_div_23723 fll_fratio _fll_div 0 23723 NULL
+disable_so___uac_clock_find_source_fndecl_23728 __uac_clock_find_source fndecl 0-2 23728 NULL
+disable_so_acpi_pci_root_get_mcfg_addr_fndecl_23731 acpi_pci_root_get_mcfg_addr fndecl 0 23731 NULL
+disable_so_snd_hda_codec_write_fndecl_23746 snd_hda_codec_write fndecl 0-5-4-2 23746 NULL
+disable_so_local_ipaddr_nes_vnic_23747 local_ipaddr nes_vnic 0 23747 NULL
+disable_so_frequency_stv0900_signal_info_23753 frequency stv0900_signal_info 0 23753 NULL
+disable_so_ic_addrservaddr_vardecl_23754 ic_addrservaddr vardecl 0 23754 NULL
+disable_so_next_hrtimer_event_fusbh200_hcd_23756 next_hrtimer_event fusbh200_hcd 0 23756 NULL
+disable_so_speedstep_get_frequency_fndecl_23758 speedstep_get_frequency fndecl 0 23758 NULL
+disable_so_lpe_base_sst_addr_23776 lpe_base sst_addr 0 23776 NULL
+disable_so_saddr_flowidn_23780 saddr flowidn 0 23780 NULL
+disable_so_uwb_rc_dev_addr_get_fndecl_23783 uwb_rc_dev_addr_get fndecl 0 23783 NULL
+disable_so_qla2x00_start_timer_fndecl_23784 qla2x00_start_timer fndecl 3 23784 NULL
+disable_so_pcan_usb_fd_set_bittiming_slow_fndecl_23790 pcan_usb_fd_set_bittiming_slow fndecl 0 23790 NULL
+disable_so_crypto_rfc4543_setauthsize_fndecl_23801 crypto_rfc4543_setauthsize fndecl 2 23801 NULL
+disable_so_drbd_send_uuids_skip_initial_sync_fndecl_23802 drbd_send_uuids_skip_initial_sync fndecl 0 23802 NULL
+disable_so_si476x_phase_diversity_mode_to_idx_fndecl_23804 si476x_phase_diversity_mode_to_idx fndecl 0 23804 NULL
+disable_so_ci_program_memory_timing_parameters_fndecl_23805 ci_program_memory_timing_parameters fndecl 0 23805 NULL
+disable_so_show_ioc_guid_fndecl_23810 show_ioc_guid fndecl 0 23810 NULL
+disable_so_gpiod_get_raw_value_cansleep_fndecl_23812 gpiod_get_raw_value_cansleep fndecl 0 23812 NULL
+disable_so_cpu_to_fs64_fndecl_23816 cpu_to_fs64 fndecl 0-2 23816 NULL
+disable_so_tomoyo_convert_time_fndecl_23823 tomoyo_convert_time fndecl 1 23823 NULL
+disable_so_ufshcd_runtime_resume_fndecl_23824 ufshcd_runtime_resume fndecl 0 23824 NULL
+disable_so_ext4_block_bitmap_csum_verify_fndecl_23826 ext4_block_bitmap_csum_verify fndecl 2 23826 NULL
+disable_so_hash_hi_smsc95xx_priv_23835 hash_hi smsc95xx_priv 0 23835 NULL
+disable_so_pm_autosleep_init_fndecl_23847 pm_autosleep_init fndecl 0 23847 NULL
+disable_so_mpu_timer_init_fndecl_23854 mpu_timer_init fndecl 1 23854 NULL
+disable_so_bg_block_bitmap_ext2_group_desc_23861 bg_block_bitmap ext2_group_desc 0 23861 NULL
+disable_so_mlx4_en_config_port_scheduler_fndecl_23868 mlx4_en_config_port_scheduler fndecl 0 23868 NULL
+disable_so_pixelclock_for_modeset_radeon_connector_23870 pixelclock_for_modeset radeon_connector 0 23870 NULL
+disable_so_ocfs2_remove_btree_range_fndecl_23874 ocfs2_remove_btree_range fndecl 0-3-4-5-8 23874 NULL
+disable_so_crypto_authenc_setkey_fndecl_23875 crypto_authenc_setkey fndecl 0 23875 NULL
+disable_so_vdiv_mcp77_clk_priv_23881 vdiv mcp77_clk_priv 0 23881 NULL
+disable_so_xfs_da_hashname_fndecl_23895 xfs_da_hashname fndecl 2 23895 NULL
+disable_so_sky2_rx_hash_fndecl_23905 sky2_rx_hash fndecl 2 23905 NULL
+disable_so_pci_revert_fw_address_fndecl_23911 pci_revert_fw_address fndecl 3-4 23911 NULL
+disable_so_gru_chiplet_cpu_to_mmr_fndecl_23914 gru_chiplet_cpu_to_mmr fndecl 2 23914 NULL nohasharray
+disable_so_htotal___fb_timings_23914 htotal __fb_timings 0 23914 &disable_so_gru_chiplet_cpu_to_mmr_fndecl_23914
+disable_so_coalescing_timeo_bna_tx_config_23917 coalescing_timeo bna_tx_config 0 23917 NULL
+disable_so_block_size_ccp_sha_def_23920 block_size ccp_sha_def 0 23920 NULL
+disable_so_chunk_sizek_mtrr_cleanup_result_23928 chunk_sizek mtrr_cleanup_result 0 23928 NULL
+disable_so_cpufreq_register_driver_fndecl_23933 cpufreq_register_driver fndecl 0 23933 NULL
+disable_so_requested_freq_cs_cpu_dbs_info_s_23941 requested_freq cs_cpu_dbs_info_s 0 23941 NULL
+disable_so_ath9k_hw_setslottime_fndecl_23946 ath9k_hw_setslottime fndecl 2 23946 NULL
+disable_so_clock_man_fndecl_23950 clock_man fndecl 2 23950 NULL
+disable_so_dma2_address_info_23953 dma2 address_info 0 23953 NULL
+disable_so_crypto_ctr_crypt_segment_fndecl_23955 crypto_ctr_crypt_segment fndecl 0 23955 NULL
+disable_so_be_set_rss_hash_opts_fndecl_23960 be_set_rss_hash_opts fndecl 0 23960 NULL
+disable_so_src_low_addr_mvumi_dyn_list_entry_23961 src_low_addr mvumi_dyn_list_entry 0 23961 NULL
+disable_so_fm_v4l2_vidioc_s_hw_freq_seek_fndecl_23963 fm_v4l2_vidioc_s_hw_freq_seek fndecl 0 23963 NULL
+disable_so_tmr_start_sound_lowlev_timer_23966 tmr_start sound_lowlev_timer 1 23966 NULL
+disable_so_task_clock_event_update_fndecl_23968 task_clock_event_update fndecl 2 23968 NULL
+disable_so_i_mtime_minix2_inode_23986 i_mtime minix2_inode 0 23986 NULL
+disable_so_time_offset_wl1271_23987 time_offset wl1271 0 23987 NULL
+disable_so_src_nents_qce_sha_reqctx_24004 src_nents qce_sha_reqctx 0 24004 NULL
+disable_so_elements_bitmap_ipmac_24013 elements bitmap_ipmac 0 24013 NULL
+disable_so_aggregation_timeout_cfhsi_config_24023 aggregation_timeout cfhsi_config 0 24023 NULL
+disable_so_write_interrupt_go7007_hpi_ops_24025 write_interrupt go7007_hpi_ops 3 24025 NULL
+disable_so_data_timer_list_24031 data timer_list 0 24031 NULL
+disable_so_reference_freq_radeon_pll_24034 reference_freq radeon_pll 0 24034 NULL
+disable_so_smi_mod_timer_fndecl_24037 smi_mod_timer fndecl 2 24037 NULL
+disable_so_sha1_mb_async_digest_fndecl_24067 sha1_mb_async_digest fndecl 0 24067 NULL
+disable_so_drv2667_set_waveform_freq_fndecl_24071 drv2667_set_waveform_freq fndecl 0 24071 NULL
+disable_so_ath6kl_disconnect_timeout_write_fndecl_24073 ath6kl_disconnect_timeout_write fndecl 3-0 24073 NULL nohasharray
+disable_so_band_center_freq1_wmi_channel_arg_24073 band_center_freq1 wmi_channel_arg 0 24073 &disable_so_ath6kl_disconnect_timeout_write_fndecl_24073
+disable_so_hi_cfg_timing_div_drxd_state_24076 hi_cfg_timing_div drxd_state 0 24076 NULL nohasharray
+disable_so_addr_gf100_grctx_24076 addr gf100_grctx 0 24076 &disable_so_hi_cfg_timing_div_drxd_state_24076
+disable_so_expected_sys_clock_freq_drxd_state_24078 expected_sys_clock_freq drxd_state 0 24078 NULL
+disable_so_img_ir_symbol_timing_fndecl_24080 img_ir_symbol_timing fndecl 0-2-3-4-5 24080 NULL
+disable_so_nr_uuids_cache_set_24084 nr_uuids cache_set 0 24084 NULL nohasharray
+disable_so_hash_tbl_pbl_addr_lo_fcoe_kwqe_init2_24084 hash_tbl_pbl_addr_lo fcoe_kwqe_init2 0 24084 &disable_so_nr_uuids_cache_set_24084
+disable_so_radeon_atom_get_clock_dividers_fndecl_24091 radeon_atom_get_clock_dividers fndecl 2-0-3 24091 NULL
+disable_so_rx_pg_bidx_addr_bnx2_rx_ring_info_24100 rx_pg_bidx_addr bnx2_rx_ring_info 0 24100 NULL
+disable_so_pty_signal_fndecl_24107 pty_signal fndecl 2 24107 NULL
+disable_so_laddr_rsxx_dma_24112 laddr rsxx_dma 0 24112 NULL
+disable_so_position_ct_timer_instance_24114 position ct_timer_instance 0 24114 NULL
+disable_so_btrfs_create_uuid_tree_fndecl_24124 btrfs_create_uuid_tree fndecl 0 24124 NULL
+disable_so_version_ethtool_regs_24128 version ethtool_regs 0 24128 NULL
+disable_so_usleep_range_fndecl_24129 usleep_range fndecl 1-2 24129 NULL
+disable_so_pdc_detect_pll_input_clock_fndecl_24132 pdc_detect_pll_input_clock fndecl 0 24132 NULL
+disable_so_dn_ifaddr_notify_fndecl_24133 dn_ifaddr_notify fndecl 1 24133 NULL
+disable_so_sis_ata133_program_udma_timings_fndecl_24137 sis_ata133_program_udma_timings fndecl 2 24137 NULL
+disable_so_fll_fratio_fll_div_24138 fll_fratio fll_div 0 24138 NULL
+disable_so_switch_addr_tda827x_config_24144 switch_addr tda827x_config 0 24144 NULL
+disable_so_scan_timeout_airo_info_24146 scan_timeout airo_info 0 24146 NULL nohasharray
+disable_so_tps6586x_rtc_set_time_fndecl_24146 tps6586x_rtc_set_time fndecl 0 24146 &disable_so_scan_timeout_airo_info_24146
+disable_so_ip101a_g_ack_interrupt_fndecl_24147 ip101a_g_ack_interrupt fndecl 0 24147 NULL
+disable_so_clock_speed__MGSL_PARAMS_24149 clock_speed _MGSL_PARAMS 0 24149 NULL nohasharray
+disable_so_esi_tss_segment_32_24149 esi tss_segment_32 0 24149 &disable_so_clock_speed__MGSL_PARAMS_24149
+disable_so_sync_size_bitmap_super_s_24170 sync_size bitmap_super_s 0 24170 NULL
+disable_so_hwirq_irq_data_24172 hwirq irq_data 0 24172 NULL
+disable_so_brcm_fet_ack_interrupt_fndecl_24181 brcm_fet_ack_interrupt fndecl 0 24181 NULL
+disable_so_min_delta_ticks_clock_event_device_24191 min_delta_ticks clock_event_device 0 24191 NULL
+disable_so_device_snd_timer_id_24197 device snd_timer_id 0 24197 NULL
+disable_so_xcan_tx_interrupt_fndecl_24200 xcan_tx_interrupt fndecl 2 24200 NULL
+disable_so_dmabuf_timeout_fndecl_24205 dmabuf_timeout fndecl 0 24205 NULL
+disable_so_pm_runtime_get_sync_fndecl_24206 pm_runtime_get_sync fndecl 0 24206 NULL
+disable_so_vdso_addr_fndecl_24212 vdso_addr fndecl 1-2 24212 NULL
+disable_so___subtree_last_usnic_uiom_interval_node_24213 __subtree_last usnic_uiom_interval_node 0 24213 NULL
+disable_so_read_mac_addr_pch_gbe_functions_24216 read_mac_addr pch_gbe_functions 0 24216 NULL
+disable_so_get_option_gid_fndecl_24218 get_option_gid fndecl 0 24218 NULL
+disable_so_decode_freq_dst_state_24221 decode_freq dst_state 0 24221 NULL
+disable_so_nilfs_btree_prepare_delete_fndecl_24237 nilfs_btree_prepare_delete fndecl 0 24237 NULL
+disable_so_start_time_s2io_nic_24242 start_time s2io_nic 0 24242 NULL
+disable_so_tv_vsync_delay_nv04_crtc_reg_24261 tv_vsync_delay nv04_crtc_reg 0 24261 NULL
+disable_so_sq_addr_low_nes_qp_context_24263 sq_addr_low nes_qp_context 0 24263 NULL
+disable_so_jiffies_next_airspy_24265 jiffies_next airspy 0 24265 NULL
+disable_so_show_node_guid_fndecl_24266 show_node_guid fndecl 0 24266 NULL
+disable_so_new_addr_tcf_nat_24272 new_addr tcf_nat 0 24272 NULL nohasharray
+disable_so_dt_cpufreq_probe_fndecl_24272 dt_cpufreq_probe fndecl 0 24272 &disable_so_new_addr_tcf_nat_24272
+disable_so_src_freq_tbl_24280 src freq_tbl 0 24280 NULL
+disable_so_tps51632_dcdc_set_ramp_delay_fndecl_24291 tps51632_dcdc_set_ramp_delay fndecl 0-2 24291 NULL
+disable_so_resolution_num_snd_timer_gstatus_24293 resolution_num snd_timer_gstatus 0 24293 NULL
+disable_so_delay_usecs_spi_transfer_24301 delay_usecs spi_transfer 0 24301 NULL
+disable_so_curfreq_dsbr100_device_24314 curfreq dsbr100_device 0 24314 NULL
+disable_so_mlx4_set_admin_guid_fndecl_24342 mlx4_set_admin_guid fndecl 3-4 24342 NULL
+disable_so__get_table_maxdiv_fndecl_24353 _get_table_maxdiv fndecl 0 24353 NULL
+disable_so_fb_div_scale_rv6xx_power_info_24360 fb_div_scale rv6xx_power_info 0 24360 NULL
+disable_so_fb_get_hfreq_fndecl_24369 fb_get_hfreq fndecl 0-1-2 24369 NULL
+disable_so_mmp_time_mmp_struct_24373 mmp_time mmp_struct 0 24373 NULL
+disable_so_timestamp_mwifiex_fixed_bcn_param_24375 timestamp mwifiex_fixed_bcn_param 0 24375 NULL
+disable_so_s2mpu02_set_ramp_delay_fndecl_24379 s2mpu02_set_ramp_delay fndecl 0 24379 NULL
+disable_so_last_fail_time_iscsi_login_stats_24381 last_fail_time iscsi_login_stats 0 24381 NULL
+disable_so_bus_addr_vnic_res_24386 bus_addr vnic_res 0 24386 NULL
+disable_so_i40e_ptp_adjtime_fndecl_24400 i40e_ptp_adjtime fndecl 2 24400 NULL
+disable_so_msr_ct_atc_24401 msr ct_atc 0 24401 NULL
+disable_so_pvr2_hdw_get_cur_freq_fndecl_24402 pvr2_hdw_get_cur_freq fndecl 0 24402 NULL
+disable_so_time_ubifs_znode_24419 time ubifs_znode 0 24419 NULL
+disable_so_ssp_get_clk_div_fndecl_24428 ssp_get_clk_div fndecl 0-2 24428 NULL
+disable_so_sem_otime_sem_24429 sem_otime sem 0 24429 NULL
+disable_so_mrst_lvds_clock_fndecl_24433 mrst_lvds_clock fndecl 1 24433 NULL
+disable_so_ccp_aes_setkey_fndecl_24438 ccp_aes_setkey fndecl 3 24438 NULL
+disable_so_log2_page_size_mlx5_mkey_seg_24441 log2_page_size mlx5_mkey_seg 0 24441 NULL
+disable_so_qtimer_val_fndecl_24449 qtimer_val fndecl 0 24449 NULL
+disable_so_sum_exec_runtime_sched_entity_24453 sum_exec_runtime sched_entity 0 24453 NULL
+disable_so_ehash_mask_inet_hashinfo_24457 ehash_mask inet_hashinfo 0 24457 NULL
+disable_so_bd_list_addr_hi_bnx2i_tmf_request_24461 bd_list_addr_hi bnx2i_tmf_request 0 24461 NULL
+disable_so_qce_ahash_register_fndecl_24475 qce_ahash_register fndecl 0 24475 NULL
+disable_so_acpi_leave_sleep_state_fndecl_24476 acpi_leave_sleep_state fndecl 0-1 24476 NULL
+disable_so_last_can_queue_ramp_up_time_fc_fcp_internal_24477 last_can_queue_ramp_up_time fc_fcp_internal 0 24477 NULL
+disable_so_mtrr_gran_size_vardecl_cleanup_c_24487 mtrr_gran_size vardecl_cleanup.c 0 24487 NULL
+disable_so_tef6862_s_frequency_fndecl_24490 tef6862_s_frequency fndecl 0 24490 NULL
+disable_so_update_uc_addr_fm10k_mac_ops_24492 update_uc_addr fm10k_mac_ops 4 24492 NULL
+disable_so_cipher_key_sz_icp_qat_fw_cipher_cd_ctrl_hdr_24515 cipher_key_sz icp_qat_fw_cipher_cd_ctrl_hdr 0 24515 NULL
+disable_so_read_div_fndecl_24524 read_div fndecl 0-2-3-4 24524 NULL
+disable_so_sctp_setsockopt_peer_addr_params_fndecl_24525 sctp_setsockopt_peer_addr_params fndecl 3-0 24525 NULL
+disable_so_dev_addr_dma_debug_entry_24528 dev_addr dma_debug_entry 0 24528 NULL
+disable_so_txurn_interrupt_mask_ath_hw_24529 txurn_interrupt_mask ath_hw 0 24529 NULL
+disable_so_reg_w_fndecl_24535 reg_w fndecl 2-3 24535 NULL
+disable_so_fs_csaddr_ufs_super_block_first_24537 fs_csaddr ufs_super_block_first 0 24537 NULL nohasharray
+disable_so_dv_timings_aspect_ratio_vivid_dev_24537 dv_timings_aspect_ratio vivid_dev 0 24537 &disable_so_fs_csaddr_ufs_super_block_first_24537
+disable_so_af_tx_sent_jiffies_brcmf_p2p_info_24540 af_tx_sent_jiffies brcmf_p2p_info 0 24540 NULL
+disable_so_timekeeping_max_deferment_fndecl_24546 timekeeping_max_deferment fndecl 0 24546 NULL
+disable_so_poly_cipherpad_fndecl_24550 poly_cipherpad fndecl 0 24550 NULL
+disable_so_aosr_aic32x4_rate_divs_24551 aosr aic32x4_rate_divs 0 24551 NULL
+disable_so_dir_band_bitmap_hpfs_super_block_24552 dir_band_bitmap hpfs_super_block 0 24552 NULL
+disable_so_confq_first_pbe_addr_hi_fcoe_kwqe_conn_offload3_24566 confq_first_pbe_addr_hi fcoe_kwqe_conn_offload3 0 24566 NULL
+disable_so_console_addr_brcmf_sdio_24567 console_addr brcmf_sdio 0 24567 NULL
+disable_so_cis820x_ack_interrupt_fndecl_24585 cis820x_ack_interrupt fndecl 0 24585 NULL
+disable_so_proc_loginuid_read_fndecl_24604 proc_loginuid_read fndecl 3-0 24604 NULL
+disable_so_schedule_nes_timer_fndecl_24613 schedule_nes_timer fndecl 0 24613 NULL
+disable_so_base_freq_patch_info_24622 base_freq patch_info 0 24622 NULL
+disable_so_acpi_hw_sleep_dispatch_fndecl_24627 acpi_hw_sleep_dispatch fndecl 0-1 24627 NULL
+disable_so_busaddr_cciss_scsi_cmd_stack_elem_t_24629 busaddr cciss_scsi_cmd_stack_elem_t 0 24629 NULL
+disable_so_hscb_busaddr_hardware_scb_24633 hscb_busaddr hardware_scb 0 24633 NULL
+disable_so_scsi_reset_delay_adveep_38C0800_config_24634 scsi_reset_delay adveep_38C0800_config 0 24634 NULL
+disable_so_mclk_fb_div_pll_ct_24641 mclk_fb_div pll_ct 0 24641 NULL
+disable_so_writeback_index_address_space_24643 writeback_index address_space 0 24643 NULL
+disable_so_ieee80211_aes_cmac_256_fndecl_24647 ieee80211_aes_cmac_256 fndecl 4 24647 NULL
+disable_so_i915_gem_object_set_to_cpu_domain_fndecl_24650 i915_gem_object_set_to_cpu_domain fndecl 0 24650 NULL
+disable_so_i2c_addr_sd_24651 i2c_addr sd 0 24651 NULL
+disable_so_next_jiffies_vardecl_ksz884x_c_24672 next_jiffies vardecl_ksz884x.c 0 24672 NULL
+disable_so_sclk_frequency_sumo_sclk_voltage_mapping_entry_24676 sclk_frequency sumo_sclk_voltage_mapping_entry 0 24676 NULL
+disable_so_eop_buffer_address_kfd_ioctl_create_queue_args_24677 eop_buffer_address kfd_ioctl_create_queue_args 0 24677 NULL
+disable_so_cyc2ns_mul_cyc2ns_data_24698 cyc2ns_mul cyc2ns_data 0 24698 NULL
+disable_so_task_getscheduler_security_operations_24701 task_getscheduler security_operations 0 24701 NULL
+disable_so_bitmap_search_next_usable_block_fndecl_24705 bitmap_search_next_usable_block fndecl 0-1-3 24705 NULL
+disable_so_gfn_to_memslot_dirty_bitmap_fndecl_24710 gfn_to_memslot_dirty_bitmap fndecl 2 24710 NULL
+disable_so_type_acpi_signal_fatal_info_24717 type acpi_signal_fatal_info 0 24717 NULL
+disable_so_interrupt_mod_interval_vardecl_24721 interrupt_mod_interval vardecl 0 24721 NULL
+disable_so_crypto_authenc_esn_givencrypt_fndecl_24722 crypto_authenc_esn_givencrypt fndecl 0 24722 NULL
+disable_so_atl1e_hash_mc_addr_fndecl_24728 atl1e_hash_mc_addr fndecl 0 24728 NULL
+disable_so_digest_size_ccp_sha_def_24730 digest_size ccp_sha_def 0 24730 NULL
+disable_so_sysfs_show_current_clocksources_fndecl_24748 sysfs_show_current_clocksources fndecl 0 24748 NULL
+disable_so_timeout_ip_set_ext_24754 timeout ip_set_ext 0 24754 NULL
+disable_so_freqmode_pll_div_24757 freqmode pll_div 0 24757 NULL
+disable_so_mvs_write_port_cfg_addr_fndecl_24758 mvs_write_port_cfg_addr fndecl 3 24758 NULL nohasharray
+disable_so_vactive_lo_oaktrail_timing_info_24758 vactive_lo oaktrail_timing_info 0 24758 &disable_so_mvs_write_port_cfg_addr_fndecl_24758
+disable_so_cs42xx8_runtime_resume_fndecl_24764 cs42xx8_runtime_resume fndecl 0 24764 NULL
+disable_so_snd_pcm_hw_rule_div_fndecl_24768 snd_pcm_hw_rule_div fndecl 0 24768 NULL
+disable_so_drbg_hash_process_addtl_fndecl_24773 drbg_hash_process_addtl fndecl 0 24773 NULL
+disable_so__lookup_address_cpa_fndecl_24780 _lookup_address_cpa fndecl 2 24780 NULL
+disable_so_time_stamp_iwl_traffic_load_24795 time_stamp iwl_traffic_load 0 24795 NULL
+disable_so_remote_cm_response_timeout_ib_cm_req_event_param_24800 remote_cm_response_timeout ib_cm_req_event_param 0 24800 NULL
+disable_so_busaddr_nes_rskb_cb_24803 busaddr nes_rskb_cb 0 24803 NULL nohasharray
+disable_so_setkey_ablkcipher_tfm_24803 setkey ablkcipher_tfm 0-3 24803 &disable_so_busaddr_nes_rskb_cb_24803
+disable_so_acpi_sleep_prepare_fndecl_24809 acpi_sleep_prepare fndecl 1 24809 NULL
+disable_so_max98090_find_divisor_fndecl_24832 max98090_find_divisor fndecl 0-2 24832 NULL
+disable_so_panel_digon_delay_radeon_encoder_lvds_24833 panel_digon_delay radeon_encoder_lvds 0 24833 NULL
+disable_so_qp_dma_addr_t3_rdma_init_attr_24843 qp_dma_addr t3_rdma_init_attr 0 24843 NULL
+disable_so_interval_tree_compute_subtree_last_fndecl_24849 interval_tree_compute_subtree_last fndecl 0 24849 NULL
+disable_so_queue_info_new_phys_addr_lo_megasas_init_frame_24856 queue_info_new_phys_addr_lo megasas_init_frame 0 24856 NULL
+disable_so_mipi_dsi_dcs_enter_sleep_mode_fndecl_24857 mipi_dsi_dcs_enter_sleep_mode fndecl 0 24857 NULL
+disable_so_ring_iowrite64desc_fndecl_24858 ring_iowrite64desc fndecl 2 24858 NULL nohasharray
+disable_so_regcache_rbtree_lookup_fndecl_24858 regcache_rbtree_lookup fndecl 2 24858 &disable_so_ring_iowrite64desc_fndecl_24858
+disable_so_rx_timeout_sci_port_24883 rx_timeout sci_port 0 24883 NULL nohasharray
+disable_so_add_atomic_switch_msr_fndecl_24883 add_atomic_switch_msr fndecl 3-4 24883 &disable_so_rx_timeout_sci_port_24883
+disable_so_xfs_btree_del_cursor_fndecl_24886 xfs_btree_del_cursor fndecl 2 24886 NULL
+disable_so_dsp_time_last_pcxhr_mgr_24894 dsp_time_last pcxhr_mgr 0 24894 NULL
+disable_so_addr_carm_msg_allocbuf_24908 addr carm_msg_allocbuf 0 24908 NULL
+disable_so_max_gids_mthca_dev_lim_24911 max_gids mthca_dev_lim 0 24911 NULL nohasharray
+disable_so_af9005_get_pre_vit_err_bit_count_fndecl_24911 af9005_get_pre_vit_err_bit_count fndecl 0 24911 &disable_so_max_gids_mthca_dev_lim_24911
+disable_so_last_jiffies_vardecl_isdn_net_c_24918 last_jiffies vardecl_isdn_net.c 0 24918 NULL
+disable_so_pci_bus_cx88_core_24932 pci_bus cx88_core 0 24932 NULL
+disable_so_devm_gpio_request_one_fndecl_24938 devm_gpio_request_one fndecl 0-2 24938 NULL
+disable_so_launder_page_address_space_operations_24942 launder_page address_space_operations 0 24942 NULL
+disable_so_enh_desc_get_timestamp_fndecl_24946 enh_desc_get_timestamp fndecl 0 24946 NULL
+disable_so___pci_bus_find_cap_start_fndecl_24949 __pci_bus_find_cap_start fndecl 0-2 24949 NULL
+disable_so_prepare_signal_fndecl_24954 prepare_signal fndecl 1 24954 NULL
+disable_so_il_vfrontporch_v4l2_bt_timings_24960 il_vfrontporch v4l2_bt_timings 0 24960 NULL
+disable_so_ide_pio_cycle_time_fndecl_24963 ide_pio_cycle_time fndecl 2-0 24963 NULL
+disable_so_demod_address_tda10086_config_24966 demod_address tda10086_config 0 24966 NULL nohasharray
+disable_so_ath5k_check_timer_win_fndecl_24966 ath5k_check_timer_win fndecl 1-2 24966 &disable_so_demod_address_tda10086_config_24966
+disable_so_pentium_core_get_frequency_fndecl_24968 pentium_core_get_frequency fndecl 0 24968 NULL
+disable_so_freqerr_chk_fndecl_24974 freqerr_chk fndecl 0-2-3 24974 NULL
+disable_so_tgt_reset_timeout_iscsi_session_24977 tgt_reset_timeout iscsi_session 0 24977 NULL
+disable_so_gpiod_set_raw_value_cansleep_fndecl_24979 gpiod_set_raw_value_cansleep fndecl 2 24979 NULL
+disable_so_write_addr_fndecl_24985 write_addr fndecl 2 24985 NULL
+disable_so_mcs7830_set_mac_address_fndecl_24986 mcs7830_set_mac_address fndecl 0 24986 NULL
+disable_so_multiaddr_ip_mc_list_24989 multiaddr ip_mc_list 0 24989 NULL
+disable_so_shash_ahash_digest_fndecl_24990 shash_ahash_digest fndecl 0 24990 NULL
+disable_so_unlock_timer_adp5589_kpad_platform_data_24993 unlock_timer adp5589_kpad_platform_data 0 24993 NULL
+disable_so_connect_timeout_vsock_sock_25001 connect_timeout vsock_sock 0 25001 NULL
+disable_so_m_addr_rds_cong_map_25013 m_addr rds_cong_map 0 25013 NULL
+disable_so_flash_addr_esas2r_ioctlfs_command_25014 flash_addr esas2r_ioctlfs_command 0 25014 NULL
+disable_so_da9052_rtc_read_time_fndecl_25015 da9052_rtc_read_time fndecl 0 25015 NULL
+disable_so_cpu_to_vhost32_fndecl_25031 cpu_to_vhost32 fndecl 0-2 25031 NULL
+disable_so_vxlan_nla_put_addr_fndecl_25037 vxlan_nla_put_addr fndecl 0 25037 NULL
+disable_so_hello_timer_value___bridge_info_25048 hello_timer_value __bridge_info 0 25048 NULL
+disable_so_steer_res_gid_25050 steer res_gid 0 25050 NULL
+disable_so_average_frequency_time_stats_25055 average_frequency time_stats 0 25055 NULL
+disable_so_sense_busaddr_scb_data_25056 sense_busaddr scb_data 0 25056 NULL
+disable_so_rx_stall_timeout_msecs_vardecl_25059 rx_stall_timeout_msecs vardecl 0 25059 NULL
+disable_so_bypclk_div_dibx000_bandwidth_config_25065 bypclk_div dibx000_bandwidth_config 0 25065 NULL
+disable_so_drm_dp_clock_recovery_ok_fndecl_25083 drm_dp_clock_recovery_ok fndecl 2 25083 NULL
+disable_so_get_min_clock_sdhci_ops_25084 get_min_clock sdhci_ops 0 25084 NULL
+disable_so_port_ka_time_fcoe_ctlr_25085 port_ka_time fcoe_ctlr 0 25085 NULL
+disable_so_btrfs_set_token_timespec_nsec_fndecl_25090 btrfs_set_token_timespec_nsec fndecl 3 25090 NULL
+disable_so_tx_bd_haddr_lo_bnx2_tx_bd_25100 tx_bd_haddr_lo bnx2_tx_bd 0 25100 NULL
+disable_so_pwm_freq_div_dib7000p_config_25102 pwm_freq_div dib7000p_config 0 25102 NULL
+disable_so_x86_pmu_config_addr_fndecl_25103 x86_pmu_config_addr fndecl 0-1 25103 NULL
+disable_so_address_TAG_TW_SG_Entry_25109 address TAG_TW_SG_Entry 0 25109 NULL
+disable_so_cfg_base_smsc_chip_address_25125 cfg_base smsc_chip_address 0 25125 NULL
+disable_so_snd_iprintf_fndecl_25126 snd_iprintf fndecl 0 25126 NULL
+disable_so_sony_nc_kbd_backlight_timeout_show_fndecl_25134 sony_nc_kbd_backlight_timeout_show fndecl 0 25134 NULL
+disable_so___hw_addr_create_ex_fndecl_25138 __hw_addr_create_ex fndecl 3 25138 NULL
+disable_so_sdev_show_timeout_fndecl_25140 sdev_show_timeout fndecl 0 25140 NULL
+disable_so_valleyview_rps_guar_freq_fndecl_25141 valleyview_rps_guar_freq fndecl 0 25141 NULL
+disable_so_msg_addr_lo_vf_pf_event_data_25142 msg_addr_lo vf_pf_event_data 0 25142 NULL nohasharray
+disable_so_hfreq___fb_timings_25142 hfreq __fb_timings 0 25142 &disable_so_msg_addr_lo_vf_pf_event_data_25142
+disable_so_select_addr_2_qla83xx_minidump_entry_rdmux2_25145 select_addr_2 qla83xx_minidump_entry_rdmux2 0 25145 NULL
+disable_so_ctrl_addr_palmas_regs_info_25149 ctrl_addr palmas_regs_info 0 25149 NULL
+disable_so_gid_affs_tail_25153 gid affs_tail 0 25153 NULL
+disable_so_recv_timeout_iscsi_conn_25159 recv_timeout iscsi_conn 0 25159 NULL
+disable_so_decode_attr_lease_time_fndecl_25160 decode_attr_lease_time fndecl 0 25160 NULL
+disable_so_log10times100_fndecl_25175 log10times100 fndecl 0-1 25175 NULL
+disable_so_crypto_register_shashes_fndecl_25178 crypto_register_shashes fndecl 0 25178 NULL
+disable_so_sh_cmt_clock_event_next_fndecl_25183 sh_cmt_clock_event_next fndecl 1 25183 NULL
+disable_so_update_mctime_fndecl_25185 update_mctime fndecl 0 25185 NULL
+disable_so_snd_hdspm_info_clock_source_fndecl_25189 snd_hdspm_info_clock_source fndecl 0 25189 NULL
+disable_so_ds1390_read_time_fndecl_25191 ds1390_read_time fndecl 0 25191 NULL
+disable_so_crypto_gcm_setkey_fndecl_25197 crypto_gcm_setkey fndecl 0-3 25197 NULL
+disable_so_atomic_read_file_fndecl_25200 atomic_read_file fndecl 3-0 25200 NULL
+disable_so_i_ctime_minix2_inode_25213 i_ctime minix2_inode 0 25213 NULL
+disable_so_account_fndecl_25224 account fndecl 0-4-2 25224 NULL
+disable_so_bestclock_fndecl_25226 bestclock fndecl 1 25226 NULL
+disable_so_regcache_rbtree_insert_to_block_fndecl_25230 regcache_rbtree_insert_to_block fndecl 3-4-5-6 25230 NULL
+disable_so_pentiumM_get_frequency_fndecl_25231 pentiumM_get_frequency fndecl 0 25231 NULL
+disable_so_model_mceusb_dev_25234 model mceusb_dev 0 25234 NULL
+disable_so_sk_rcvtimeo_sock_25235 sk_rcvtimeo sock 0 25235 NULL
+disable_so_atomic_long_add_fndecl_25245 atomic_long_add fndecl 1 25245 NULL
+disable_so_tw_rcv_wnd_tcp_timewait_sock_25247 tw_rcv_wnd tcp_timewait_sock 0 25247 NULL
+disable_so_vga_switcheroo_runtime_resume_fndecl_25258 vga_switcheroo_runtime_resume fndecl 0 25258 NULL nohasharray
+disable_so_swp_freq_calcuation_fndecl_25258 swp_freq_calcuation fndecl 0-10-8-9 25258 &disable_so_vga_switcheroo_runtime_resume_fndecl_25258
+disable_so_sys_setresuid_fndecl_25263 sys_setresuid fndecl 0-1-2-3 25263 NULL
+disable_so_va_gid_coda_vattr_25267 va_gid coda_vattr 0 25267 NULL
+disable_so_adis16136_set_freq_fndecl_25268 adis16136_set_freq fndecl 0 25268 NULL
+disable_so_sha1_ssse3_update_fndecl_25270 sha1_ssse3_update fndecl 3 25270 NULL
+disable_so_data_addr_rx_ring_info_25277 data_addr rx_ring_info 0 25277 NULL
+disable_so_in_n_analog_pcm_runtime_25285 in_n_analog pcm_runtime 0 25285 NULL
+disable_so_active_ide_timing_25290 active ide_timing 0 25290 NULL
+disable_so_max_img_ir_timing_range_25312 max img_ir_timing_range 0 25312 NULL
+disable_so_sisusb_setidxreg_fndecl_25313 sisusb_setidxreg fndecl 0-2-3-4 25313 NULL
+disable_so_rss_hash_cq_enet_rq_desc_25315 rss_hash cq_enet_rq_desc 0 25315 NULL
+disable_so_sdhci_pltfm_clk_get_max_clock_fndecl_25319 sdhci_pltfm_clk_get_max_clock fndecl 0 25319 NULL
+disable_so_be_cmd_mac_addr_query_fndecl_25342 be_cmd_mac_addr_query fndecl 0 25342 NULL
+disable_so_st_atime_nsec_compat_stat_25348 st_atime_nsec compat_stat 0 25348 NULL
+disable_so_blkcipher_walk_virt_fndecl_25350 blkcipher_walk_virt fndecl 0 25350 NULL
+disable_so_ata_sff_interrupt_fndecl_25352 ata_sff_interrupt fndecl 1 25352 NULL
+disable_so_vdisktime_cfq_group_25353 vdisktime cfq_group 0 25353 NULL
+disable_so_sctp_apply_peer_addr_params_fndecl_25357 sctp_apply_peer_addr_params fndecl 0 25357 NULL
+disable_so_hpi_sample_clock_get_local_rate_lock_fndecl_25364 hpi_sample_clock_get_local_rate_lock fndecl 1-0 25364 NULL
+disable_so_sticks_snd_timer_25366 sticks snd_timer 0 25366 NULL
+disable_so_segv_uid_gr_arg_25373 segv_uid gr_arg 0 25373 NULL
+disable_so_signal_rate_plcp_signal_rate_lookup_25377 signal_rate plcp_signal_rate_lookup 0 25377 NULL
+disable_so_timeout_jiffies_tifm_sd_25387 timeout_jiffies tifm_sd 0 25387 NULL
+disable_so_fence_gpu_addr_kernel_queue_25394 fence_gpu_addr kernel_queue 0 25394 NULL
+disable_so_pch_udc_enable_interrupts_fndecl_25405 pch_udc_enable_interrupts fndecl 2 25405 NULL
+disable_so_addr_hi_eth_rx_sge_25407 addr_hi eth_rx_sge 0 25407 NULL
+disable_so_flushtimeout_nfulnl_instance_25409 flushtimeout nfulnl_instance 0 25409 NULL
+disable_so_ti12xx_untie_interrupts_fndecl_25411 ti12xx_untie_interrupts fndecl 2 25411 NULL
+disable_so_dma_addr_t4_cq_25412 dma_addr t4_cq 0 25412 NULL
+disable_so_task_list_pbl_addr_lo_fcoe_kwqe_init1_25414 task_list_pbl_addr_lo fcoe_kwqe_init1 0 25414 NULL
+disable_so_conntrack_addrcmp_fndecl_25418 conntrack_addrcmp fndecl 4 25418 NULL
+disable_so_datablock_addr_fndecl_25424 datablock_addr fndecl 0-2 25424 NULL
+disable_so_intel_sdvo_create_preferred_input_timing_fndecl_25428 intel_sdvo_create_preferred_input_timing fndecl 3-4 25428 NULL
+disable_so_return_address_stack_frame_ia32_25439 return_address stack_frame_ia32 0 25439 NULL
+disable_so_tmds_chip_slave_addr_tmds_chip_information_25446 tmds_chip_slave_addr tmds_chip_information 0 25446 NULL
+disable_so_releasepage_address_space_operations_25450 releasepage address_space_operations 2 25450 NULL
+disable_so_sys_setgid_fndecl_25470 sys_setgid fndecl 0-1 25470 NULL nohasharray
+disable_so_random_address_open_fndecl_25470 random_address_open fndecl 0 25470 &disable_so_sys_setgid_fndecl_25470
+disable_so_creation_time_se_device_25474 creation_time se_device 0 25474 NULL
+disable_so_addr_qla8xxx_minidump_entry_crb_25475 addr qla8xxx_minidump_entry_crb 0 25475 NULL
+disable_so_wrmsr_safe_on_cpu_fndecl_25481 wrmsr_safe_on_cpu fndecl 0-1 25481 NULL
+disable_so_htc_addr_ath6kl_mbox_info_25495 htc_addr ath6kl_mbox_info 0 25495 NULL
+disable_so_crypto_shash_export_fndecl_25501 crypto_shash_export fndecl 0 25501 NULL
+disable_so_pm_runtime_autosuspend_expiration_fndecl_25503 pm_runtime_autosuspend_expiration fndecl 0 25503 NULL
+disable_so_fib_info_update_nh_saddr_fndecl_25504 fib_info_update_nh_saddr fndecl 0 25504 NULL
+disable_so_ac_uid_taskstats_25506 ac_uid taskstats 0 25506 NULL
+disable_so_bufaddr_epic_rx_desc_25507 bufaddr epic_rx_desc 0 25507 NULL
+disable_so_process_tgid_id_proc_event_25512 process_tgid id_proc_event 0 25512 NULL
+disable_so_si5351_msynth_params_address_fndecl_25517 si5351_msynth_params_address fndecl 0-1 25517 NULL
+disable_so_btrfs_dev_replace_time_stopped_fndecl_25538 btrfs_dev_replace_time_stopped fndecl 0 25538 NULL
+disable_so___irq_set_handler_fndecl_25547 __irq_set_handler fndecl 1 25547 NULL
+disable_so_next_addr_ath_gen_timer_configuration_25559 next_addr ath_gen_timer_configuration 0 25559 NULL
+disable_so_timeout_request_25561 timeout request 0 25561 NULL
+disable_so_rx_bd_haddr_hi_bnx2_rx_bd_25562 rx_bd_haddr_hi bnx2_rx_bd 0 25562 NULL nohasharray
+disable_so_jhash_1word_fndecl_25562 jhash_1word fndecl 0-1 25562 &disable_so_rx_bd_haddr_hi_bnx2_rx_bd_25562
+disable_so_freq_ref_fll_factors_25565 freq_ref fll_factors 0 25565 NULL
+disable_so_compat_sys_mq_timedreceive_fndecl_25566 compat_sys_mq_timedreceive fndecl 1-3 25566 NULL
+disable_so_scl_falling_time_dw_i2c_dev_25576 scl_falling_time dw_i2c_dev 0 25576 NULL
+disable_so_maj_flt_signal_struct_25583 maj_flt signal_struct 0 25583 NULL
+disable_so_irq_set_chip_and_handler_name_fndecl_25596 irq_set_chip_and_handler_name fndecl 1 25596 NULL
+disable_so_timeout_ms_ib_mad_send_buf_25607 timeout_ms ib_mad_send_buf 0 25607 NULL
+disable_so_qs_itimelimit_fs_quota_statv_25612 qs_itimelimit fs_quota_statv 0 25612 NULL nohasharray
+disable_so_blkcipher_aead_walk_virt_block_fndecl_25612 blkcipher_aead_walk_virt_block fndecl 0-4 25612 &disable_so_qs_itimelimit_fs_quota_statv_25612
+disable_so_o2hb_heartbeat_timeout_ms_o2net_handshake_25614 o2hb_heartbeat_timeout_ms o2net_handshake 0 25614 NULL
+disable_so_sampling_time_acpi_power_meter_capabilities_25620 sampling_time acpi_power_meter_capabilities 0 25620 NULL
+disable_so_C_SYSC_signalfd_fndecl_25641 C_SYSC_signalfd fndecl 0 25641 NULL
+disable_so_dpp_page_addr_lo_ocrdma_alloc_pd_uresp_25645 dpp_page_addr_lo ocrdma_alloc_pd_uresp 0 25645 NULL
+disable_so_memclock_pm2fb_par_25648 memclock pm2fb_par 0 25648 NULL
+disable_so_hca_core_clock_mlx4_init_hca_param_25649 hca_core_clock mlx4_init_hca_param 0 25649 NULL
+disable_so_hash_fndecl_25655 hash fndecl 0-2 25655 NULL
+disable_so_get_scr_cfg_addr_fndecl_25659 get_scr_cfg_addr fndecl 0-2 25659 NULL
+disable_so_brp_can_bittiming_25672 brp can_bittiming 0 25672 NULL
+disable_so_hash_tcindex_data_25674 hash tcindex_data 0 25674 NULL
+disable_so_store_pwm_auto_spinup_time_fndecl_25686 store_pwm_auto_spinup_time fndecl 0-4 25686 NULL nohasharray
+disable_so_wm5100_runtime_resume_fndecl_25686 wm5100_runtime_resume fndecl 0 25686 &disable_so_store_pwm_auto_spinup_time_fndecl_25686
+disable_so_cbc_aes_decrypt_fndecl_25690 cbc_aes_decrypt fndecl 0-4 25690 NULL
+disable_so_find_vma_fndecl_25710 find_vma fndecl 2 25710 NULL
+disable_so_set_register_interruptible_fndecl_25711 set_register_interruptible fndecl 0 25711 NULL
+disable_so_last_beacon_timestamp_atmel_private_25714 last_beacon_timestamp atmel_private 0 25714 NULL
+disable_so_print_uuid_item_fndecl_25720 print_uuid_item fndecl 2-3 25720 NULL nohasharray
+disable_so_intel_pxfreq_fndecl_25720 intel_pxfreq fndecl 0-1 25720 &disable_so_print_uuid_item_fndecl_25720
+disable_so___mlx4_ib_query_gid_fndecl_25733 __mlx4_ib_query_gid fndecl 0-2-3 25733 NULL
+disable_so_crypto_pcbc_setkey_fndecl_25734 crypto_pcbc_setkey fndecl 0-3 25734 NULL
+disable_so_iClockSource_uac_clock_source_descriptor_25741 iClockSource uac_clock_source_descriptor 0 25741 NULL
+disable_so_madc_aic32x4_rate_divs_25746 madc aic32x4_rate_divs 0 25746 NULL nohasharray
+disable_so_test_and_set_bit_le_fndecl_25746 test_and_set_bit_le fndecl 1 25746 &disable_so_madc_aic32x4_rate_divs_25746
+disable_so_init_acpi_pm_clocksource_fndecl_25751 init_acpi_pm_clocksource fndecl 0 25751 NULL
+disable_so_bit_width_io_addr_25761 bit_width io_addr 0 25761 NULL nohasharray
+disable_so_shash_async_finup_fndecl_25761 shash_async_finup fndecl 0 25761 &disable_so_bit_width_io_addr_25761
+disable_so_i_mtime_extra_ext4_inode_25766 i_mtime_extra ext4_inode 0 25766 NULL
+disable_so_suid_ban_expires_user_struct_25778 suid_ban_expires user_struct 0 25778 NULL
+disable_so_sys_timer_delete_fndecl_25781 sys_timer_delete fndecl 1 25781 NULL
+disable_so_write16_b43_bus_dev_25800 write16 b43_bus_dev 3 25800 NULL
+disable_so_pci_bus_clock_list_fndecl_25811 pci_bus_clock_list fndecl 0-1 25811 NULL
+disable_so_pll_freq_adau_25818 pll_freq adau 0 25818 NULL
+disable_so_kvm_get_lapic_tscdeadline_msr_fndecl_25821 kvm_get_lapic_tscdeadline_msr fndecl 0 25821 NULL
+disable_so_power_off_longtime_mmc_ext_csd_25827 power_off_longtime mmc_ext_csd 0 25827 NULL
+disable_so_mcryptd_hash_digest_enqueue_fndecl_25830 mcryptd_hash_digest_enqueue fndecl 0 25830 NULL
+disable_so_bch_btree_node_get_fndecl_25837 bch_btree_node_get fndecl 4 25837 NULL
+disable_so_sa_timeout_mmc_ext_csd_25842 sa_timeout mmc_ext_csd 0 25842 NULL
+disable_so_rc5t583_rtc_set_time_fndecl_25844 rc5t583_rtc_set_time fndecl 0 25844 NULL
+disable_so_pll2_ndiv_b_cnt_ad9523_platform_data_25849 pll2_ndiv_b_cnt ad9523_platform_data 0 25849 NULL
+disable_so_xfs_btree_kill_iroot_fndecl_25851 xfs_btree_kill_iroot fndecl 0 25851 NULL
+disable_so_freq_offset_xc4000_priv_25852 freq_offset xc4000_priv 0 25852 NULL
+disable_so_orig_eax_user_regs_struct32_25853 orig_eax user_regs_struct32 0 25853 NULL
+disable_so_i_mtime_ext4_inode_25857 i_mtime ext4_inode 0 25857 NULL nohasharray
+disable_so_hash_ipportnet4_expire_fndecl_25857 hash_ipportnet4_expire fndecl 4 25857 &disable_so_i_mtime_ext4_inode_25857
+disable_so_max_keysize_blkcipher_alg_25859 max_keysize blkcipher_alg 0 25859 NULL
+disable_so__kstrtol_fndecl_25860 _kstrtol fndecl 0 25860 NULL nohasharray
+disable_so_reqsize_crypto_aead_25860 reqsize crypto_aead 0 25860 &disable_so__kstrtol_fndecl_25860
+disable_so_group_exit_code_signal_struct_25863 group_exit_code signal_struct 0 25863 NULL
+disable_so_i2c_address_qt1010_config_25866 i2c_address qt1010_config 0 25866 NULL
+disable_so_musb_bulk_nak_timeout_fndecl_25876 musb_bulk_nak_timeout fndecl 3 25876 NULL
+disable_so_rangehigh_v4l2_hw_freq_seek_25892 rangehigh v4l2_hw_freq_seek 0 25892 NULL
+disable_so_xferaddr_mbox_out_25904 xferaddr mbox_out 0 25904 NULL
+disable_so_address_mode_snd_emu10k1_25917 address_mode snd_emu10k1 0 25917 NULL
+disable_so_ac_uid_acct_v3_25928 ac_uid acct_v3 0 25928 NULL
+disable_so_show_cpumask_fndecl_25949 show_cpumask fndecl 0 25949 NULL
+disable_so_x86_max_cores_cpuinfo_x86_25950 x86_max_cores cpuinfo_x86 0 25950 NULL
+disable_so_nr_mtrr_spare_reg_vardecl_cleanup_c_25954 nr_mtrr_spare_reg vardecl_cleanup.c 0 25954 NULL
+disable_so_fib_info_hash_move_fndecl_25959 fib_info_hash_move fndecl 3 25959 NULL
+disable_so_rst_timer_val_intel_dsi_25967 rst_timer_val intel_dsi 0 25967 NULL
+disable_so_backlog_wait_time_audit_status_25971 backlog_wait_time audit_status 0 25971 NULL
+disable_so_gid_h_misc_25975 gid h_misc 0 25975 NULL
+disable_so_wm8962_runtime_resume_fndecl_25981 wm8962_runtime_resume fndecl 0 25981 NULL
+disable_so_ip_vs_rs_hashkey_fndecl_25992 ip_vs_rs_hashkey fndecl 1 25992 NULL
+disable_so_sbp_tpg_attrib_store_max_reconnect_timeout_fndecl_25997 sbp_tpg_attrib_store_max_reconnect_timeout fndecl 0-3 25997 NULL
+disable_so_hpwdt_time_left_fndecl_25998 hpwdt_time_left fndecl 0 25998 NULL
+disable_so_mtrr_calc_range_state_fndecl_26002 mtrr_calc_range_state fndecl 3-4-2-1 26002 NULL
+disable_so_tipc_addr_scope_fndecl_26006 tipc_addr_scope fndecl 0 26006 NULL
+disable_so_rdmsr_safe_regs_fndecl_26012 rdmsr_safe_regs fndecl 0 26012 NULL
+disable_so_kvm_inject_realmode_interrupt_fndecl_26018 kvm_inject_realmode_interrupt fndecl 2 26018 NULL
+disable_so_addr_ethoc_bd_26021 addr ethoc_bd 0 26021 NULL
+disable_so_marvell_ack_interrupt_fndecl_26036 marvell_ack_interrupt fndecl 0 26036 NULL
+disable_so_link_check_timeout_igb_adapter_26037 link_check_timeout igb_adapter 0 26037 NULL nohasharray
+disable_so_psb_intel_crtc_clock_get_fndecl_26037 psb_intel_crtc_clock_get fndecl 0 26037 &disable_so_link_check_timeout_igb_adapter_26037
+disable_so_t2_ptr_hash_tbl_addr_lo_fcoe_kwqe_init2_26039 t2_ptr_hash_tbl_addr_lo fcoe_kwqe_init2 0 26039 NULL
+disable_so_interrupt_out_interval_ld_usb_26046 interrupt_out_interval ld_usb 0 26046 NULL
+disable_so_bs_gid_xfs_bstat_26053 bs_gid xfs_bstat 0 26053 NULL
+disable_so_wm8900_set_dai_clkdiv_fndecl_26074 wm8900_set_dai_clkdiv fndecl 3 26074 NULL
+disable_so_setkey_blkcipher_alg_26078 setkey blkcipher_alg 3 26078 NULL
+disable_so_ixgbevf_init_interrupt_scheme_fndecl_26085 ixgbevf_init_interrupt_scheme fndecl 0 26085 NULL
+disable_so___sw_hweight32_fndecl_26088 __sw_hweight32 fndecl 1-0 26088 NULL nohasharray
+disable_so_addr_hi_eth_tx_bd_26088 addr_hi eth_tx_bd 0 26088 &disable_so___sw_hweight32_fndecl_26088 nohasharray
+disable_so_hashval2_1_rx_pkt_hdr1_26088 hashval2_1 rx_pkt_hdr1 0 26088 &disable_so_addr_hi_eth_tx_bd_26088
+disable_so_debounce_time_snd_soc_jack_gpio_26097 debounce_time snd_soc_jack_gpio 0 26097 NULL
+disable_so_ath6kl_wmi_pstream_timeout_event_rx_fndecl_26100 ath6kl_wmi_pstream_timeout_event_rx fndecl 3 26100 NULL
+disable_so_fl0addr_fw_iq_cmd_26103 fl0addr fw_iq_cmd 0 26103 NULL
+disable_so___acpi_os_prepare_extended_sleep_vardecl_osl_c_26106 __acpi_os_prepare_extended_sleep vardecl_osl.c 2 26106 NULL
+disable_so_atomic_check_drm_mode_config_funcs_26109 atomic_check drm_mode_config_funcs 0 26109 NULL
+disable_so_st_mtime_stat_26114 st_mtime stat 0 26114 NULL
+disable_so_cx23885_set_freq_fndecl_26129 cx23885_set_freq fndecl 0 26129 NULL
+disable_so_img_ir_timings_convert_fndecl_26132 img_ir_timings_convert fndecl 3-4 26132 NULL
+disable_so_generic_update_time_fndecl_26133 generic_update_time fndecl 0 26133 NULL
+disable_so_cpu_to_virtio32_fndecl_26151 cpu_to_virtio32 fndecl 0-2 26151 NULL
+disable_so_dp_dma_addr_mic_device_26153 dp_dma_addr mic_device 0 26153 NULL
+disable_so_mask_clocksource_26154 mask clocksource 0 26154 NULL
+disable_so_bit_rate_hpi_msg_format_26167 bit_rate hpi_msg_format 0 26167 NULL
+disable_so_set_bitmap_file_fndecl_26171 set_bitmap_file fndecl 0-2 26171 NULL
+disable_so_show_fast_charge_timer_fndecl_26172 show_fast_charge_timer fndecl 0 26172 NULL
+disable_so_rt_spc_timelimit_qc_type_state_26186 rt_spc_timelimit qc_type_state 0 26186 NULL
+disable_so_HYPERVISOR_physdev_op_fndecl_26192 HYPERVISOR_physdev_op fndecl 0 26192 NULL
+disable_so_sci_br_interrupt_fndecl_26202 sci_br_interrupt fndecl 1 26202 NULL
+disable_so_bitmap_ipmac_do_list_fndecl_26203 bitmap_ipmac_do_list fndecl 4 26203 NULL
+disable_so_kxcjk1013_setup_any_motion_interrupt_fndecl_26214 kxcjk1013_setup_any_motion_interrupt fndecl 0 26214 NULL
+disable_so_io_request_phys_addr_megasas_cmd_fusion_26240 io_request_phys_addr megasas_cmd_fusion 0 26240 NULL
+disable_so_compute_unit_id_cpuinfo_x86_26241 compute_unit_id cpuinfo_x86 0 26241 NULL
+disable_so_dynpm_action_timeout_radeon_pm_26257 dynpm_action_timeout radeon_pm 0 26257 NULL
+disable_so_lookup_address_in_pgd_fndecl_26268 lookup_address_in_pgd fndecl 2 26268 NULL
+disable_so_addr_prism2_download_data_area_26275 addr prism2_download_data_area 0 26275 NULL
+disable_so_channels_snd_pcm_runtime_26297 channels snd_pcm_runtime 0 26297 NULL
+disable_so_iamthif_timer_mei_device_26298 iamthif_timer mei_device 0 26298 NULL nohasharray
+disable_so_simple_strtol_fndecl_26298 simple_strtol fndecl 0 26298 &disable_so_iamthif_timer_mei_device_26298
+disable_so_rose_set_mac_address_fndecl_26302 rose_set_mac_address fndecl 0 26302 NULL
+disable_so_sq_addr_lo_fcoe_kwqe_conn_offload1_26303 sq_addr_lo fcoe_kwqe_conn_offload1 0 26303 NULL
+disable_so_m88ds3103_sleep_fndecl_26315 m88ds3103_sleep fndecl 0 26315 NULL
+disable_so_ping_timeo_net_conf_26316 ping_timeo net_conf 0 26316 NULL nohasharray
+disable_so_parent_btrfs_delayed_tree_ref_26316 parent btrfs_delayed_tree_ref 0 26316 &disable_so_ping_timeo_net_conf_26316
+disable_so_esd_timeout_ms_tsc2005_platform_data_26333 esd_timeout_ms tsc2005_platform_data 0 26333 NULL
+disable_so_addr_change_member_26339 addr change_member 0 26339 NULL
+disable_so_mvs_show_interrupt_coalescing_fndecl_26346 mvs_show_interrupt_coalescing fndecl 0 26346 NULL
+disable_so_hashkey_raw_ip_vs_pe_26355 hashkey_raw ip_vs_pe 0 26355 NULL
+disable_so_skl_compute_linetime_wm_fndecl_26358 skl_compute_linetime_wm fndecl 0 26358 NULL
+disable_so_radeon_pmops_runtime_resume_fndecl_26363 radeon_pmops_runtime_resume fndecl 0 26363 NULL
+disable_so_op_remote_addr_rm_rdma_op_26364 op_remote_addr rm_rdma_op 0 26364 NULL
+disable_so_yura_hash_fndecl_26368 yura_hash fndecl 2 26368 NULL
+disable_so_blocksize_qce_ablkcipher_def_26370 blocksize qce_ablkcipher_def 0 26370 NULL
+disable_so_phys_efi_set_virtual_address_map_fndecl_26380 phys_efi_set_virtual_address_map fndecl 1-2 26380 NULL
+disable_so_sfi_lapic_addr_vardecl_sfi_c_26384 sfi_lapic_addr vardecl_sfi.c 0 26384 NULL
+disable_so_ebp_user_regs_struct32_26386 ebp user_regs_struct32 0 26386 NULL
+disable_so_total_time_enabled_perf_event_26387 total_time_enabled perf_event 0 26387 NULL nohasharray
+disable_so_ext4_inode_bitmap_csum_set_fndecl_26387 ext4_inode_bitmap_csum_set fndecl 2-5 26387 &disable_so_total_time_enabled_perf_event_26387
+disable_so_write32_b43_bus_dev_26402 write32 b43_bus_dev 3 26402 NULL
+disable_so_seq_default_timer_device_vardecl_26404 seq_default_timer_device vardecl 0 26404 NULL
+disable_so_address_xfs_dir2_leaf_entry_26411 address xfs_dir2_leaf_entry 0 26411 NULL
+disable_so_regmap_irq_get_virq_fndecl_26413 regmap_irq_get_virq fndecl 2-0 26413 NULL
+disable_so_msr_ia32_feature_control_nested_vmx_26415 msr_ia32_feature_control nested_vmx 0 26415 NULL
+disable_so_last_load_cpufreq_cooling_device_26418 last_load cpufreq_cooling_device 0 26418 NULL
+disable_so_blank_time_dce8_wm_params_26421 blank_time dce8_wm_params 0 26421 NULL
+disable_so_start_time_rsxx_bio_meta_26424 start_time rsxx_bio_meta 0 26424 NULL
+disable_so_ima_calc_file_hash_atfm_fndecl_26437 ima_calc_file_hash_atfm fndecl 0 26437 NULL
+disable_so_range_to_mtrr_fndecl_26447 range_to_mtrr fndecl 2-3 26447 NULL
+disable_so_sm_addr_ns_dev_26449 sm_addr ns_dev 0 26449 NULL
+disable_so_uartlite_outle32_fndecl_26455 uartlite_outle32 fndecl 1 26455 NULL
+disable_so___arch_hweight64_fndecl_26456 __arch_hweight64 fndecl 0-1 26456 NULL nohasharray
+disable_so_rsa_parse_key_fndecl_26456 rsa_parse_key fndecl 3 26456 &disable_so___arch_hweight64_fndecl_26456
+disable_so_data_addr_ide_io_ports_26461 data_addr ide_io_ports 0 26461 NULL
+disable_so_mce_adjust_timer_vardecl_mce_c_26462 mce_adjust_timer vardecl_mce.c 0-1 26462 NULL
+disable_so_tv_sec_ceph_timespec_26463 tv_sec ceph_timespec 0 26463 NULL
+disable_so_val_v4l2_dbg_register_26470 val v4l2_dbg_register 0 26470 NULL
+disable_so_jiffies_read_fndecl_26480 jiffies_read fndecl 0 26480 NULL
+disable_so_compat_sys_clock_settime_fndecl_26491 compat_sys_clock_settime fndecl 1 26491 NULL
+disable_so_i2c_addr_tda827x_priv_26495 i2c_addr tda827x_priv 0 26495 NULL
+disable_so_snd_trident_interrupt_fndecl_26498 snd_trident_interrupt fndecl 1 26498 NULL
+disable_so_mce_flush_rx_buffer_fndecl_26515 mce_flush_rx_buffer fndecl 2 26515 NULL
+disable_so_ufshcd_runtime_suspend_fndecl_26519 ufshcd_runtime_suspend fndecl 0 26519 NULL
+disable_so___down_timeout_fndecl_26530 __down_timeout fndecl 2-0 26530 NULL nohasharray
+disable_so_rdma_addr_find_dmac_by_grh_fndecl_26530 rdma_addr_find_dmac_by_grh fndecl 0 26530 &disable_so___down_timeout_fndecl_26530
+disable_so_ppll_ref_div_radeon_regs_26531 ppll_ref_div radeon_regs 0 26531 NULL
+disable_so_fs_overflowuid_vardecl_26541 fs_overflowuid vardecl 0 26541 NULL
+disable_so_ceph_str_hash_rjenkins_fndecl_26542 ceph_str_hash_rjenkins fndecl 0-2 26542 NULL
+disable_so_threshold_low_nes_hw_tune_timer_26544 threshold_low nes_hw_tune_timer 0 26544 NULL
+disable_so_addressPXD_fndecl_26546 addressPXD fndecl 0 26546 NULL
+disable_so_get_cpu_idle_time_us_fndecl_26547 get_cpu_idle_time_us fndecl 0-1 26547 NULL
+disable_so_x86_pmu_event_addr_fndecl_26551 x86_pmu_event_addr fndecl 0-1 26551 NULL
+disable_so_da9055_rtc_set_time_fndecl_26553 da9055_rtc_set_time fndecl 0 26553 NULL nohasharray
+disable_so_address_hi_ips_enh_sglist_26553 address_hi ips_enh_sglist 0 26553 &disable_so_da9055_rtc_set_time_fndecl_26553
+disable_so_cpufreq_quick_get_fndecl_26559 cpufreq_quick_get fndecl 0-1 26559 NULL nohasharray
+disable_so_ieee80211_aes_gcm_encrypt_fndecl_26559 ieee80211_aes_gcm_encrypt fndecl 5 26559 &disable_so_cpufreq_quick_get_fndecl_26559
+disable_so_bug17190_timer_qt202x_phy_data_26561 bug17190_timer qt202x_phy_data 0 26561 NULL nohasharray
+disable_so_efx_farch_filter_hash_fndecl_26561 efx_farch_filter_hash fndecl 0-1 26561 &disable_so_bug17190_timer_qt202x_phy_data_26561
+disable_so_timestamp_beacon_format_26566 timestamp beacon_format 0 26566 NULL
+disable_so_postscale__pll_div_26568 postscale _pll_div 0 26568 NULL
+disable_so_next_nat_addr_fndecl_26576 next_nat_addr fndecl 0-2 26576 NULL
+disable_so_shdwreg_addr_hi_addr_ctrl_blk_26592 shdwreg_addr_hi addr_ctrl_blk 0 26592 NULL
+disable_so_xfs_btree_insrec_fndecl_26593 xfs_btree_insrec fndecl 0 26593 NULL
+disable_so_sci_tx_interrupt_fndecl_26595 sci_tx_interrupt fndecl 1 26595 NULL nohasharray
+disable_so_add_delayed_ref_head_fndecl_26595 add_delayed_ref_head fndecl 4-5 26595 &disable_so_sci_tx_interrupt_fndecl_26595
+disable_so_tegra_wdt_set_timeout_fndecl_26597 tegra_wdt_set_timeout fndecl 2 26597 NULL
+disable_so_base_addr_dmi_ipmi_data_26600 base_addr dmi_ipmi_data 0 26600 NULL nohasharray
+disable_so_s_audio_sampling_freq_cx2341x_handler_ops_26600 s_audio_sampling_freq cx2341x_handler_ops 0-2 26600 &disable_so_base_addr_dmi_ipmi_data_26600
+disable_so_pll_post_div_radeon_crtc_26608 pll_post_div radeon_crtc 0 26608 NULL
+disable_so_sdio_enable_4bit_bus_fndecl_26617 sdio_enable_4bit_bus fndecl 0 26617 NULL
+disable_so_jiffies_to_usecs_fndecl_26625 jiffies_to_usecs fndecl 0-1 26625 NULL
+disable_so_i_mtime_nsec_ocfs2_dinode_26627 i_mtime_nsec ocfs2_dinode 0 26627 NULL
+disable_so_set_var_mtrr_fndecl_26628 set_var_mtrr fndecl 2-3 26628 NULL
+disable_so_usec_2_cycles_fndecl_26641 usec_2_cycles fndecl 0-1 26641 NULL
+disable_so_inq_data_baddr_pmcraid_instance_26646 inq_data_baddr pmcraid_instance 0 26646 NULL
+disable_so_re_timeout_vhci_hcd_26649 re_timeout vhci_hcd 0 26649 NULL
+disable_so_timer_buf_periods_pcxhr_stream_26650 timer_buf_periods pcxhr_stream 0 26650 NULL
+disable_so_lease_break_time_vardecl_26659 lease_break_time vardecl 0 26659 NULL
+disable_so_first_frag_time_libipw_frag_entry_26673 first_frag_time libipw_frag_entry 0 26673 NULL
+disable_so_send_timer_event_fndecl_26675 send_timer_event fndecl 0 26675 NULL
+disable_so_timestamp_lo_mlx4_ts_cqe_26678 timestamp_lo mlx4_ts_cqe 0 26678 NULL nohasharray
+disable_so_twl_rtc_read_time_fndecl_26678 twl_rtc_read_time fndecl 0 26678 &disable_so_timestamp_lo_mlx4_ts_cqe_26678
+disable_so_prism54_get_freq_fndecl_26679 prism54_get_freq fndecl 0 26679 NULL
+disable_so_signal_quality_wireless_stats_26683 signal_quality wireless_stats 0 26683 NULL
+disable_so_serial8250_request_rsa_resource_fndecl_26695 serial8250_request_rsa_resource fndecl 0 26695 NULL
+disable_so_crypto_ahash_init_fndecl_26697 crypto_ahash_init fndecl 0 26697 NULL
+disable_so_i8xx_clock_fndecl_26699 i8xx_clock fndecl 1 26699 NULL
+disable_so_crypto_alg_extsize_fndecl_26720 crypto_alg_extsize fndecl 0 26720 NULL
+disable_so_get_iowait_time_fndecl_26723 get_iowait_time fndecl 1-0 26723 NULL
+disable_so_wl1271_acx_init_rx_interrupt_fndecl_26727 wl1271_acx_init_rx_interrupt fndecl 0 26727 NULL
+disable_so_check_intr_schedule_fndecl_26728 check_intr_schedule fndecl 2-3 26728 NULL
+disable_so_cobalt_s_dv_timings_fndecl_26730 cobalt_s_dv_timings fndecl 0 26730 NULL
+disable_so_resolution_snd_timer_instance_26747 resolution snd_timer_instance 0 26747 NULL
+disable_so_gf100_vm_addr_fndecl_26753 gf100_vm_addr fndecl 0-2-3-4 26753 NULL
+disable_so_nilfs_btree_convert_and_insert_fndecl_26755 nilfs_btree_convert_and_insert fndecl 0-2-6 26755 NULL
+disable_so_xlog_find_verify_cycle_fndecl_26760 xlog_find_verify_cycle fndecl 0-2-3 26760 NULL
+disable_so_base_address_kvm_lapic_26767 base_address kvm_lapic 0 26767 NULL
+disable_so_unmap_page_dma_map_ops_26774 unmap_page dma_map_ops 2-3 26774 NULL nohasharray
+disable_so_modcode_stv0900_signal_info_26774 modcode stv0900_signal_info 0 26774 &disable_so_unmap_page_dma_map_ops_26774
+disable_so_mthca_cmd_wait_fndecl_26776 mthca_cmd_wait fndecl 0-2 26776 NULL nohasharray
+disable_so_tun2_maddress_stv0900_init_params_26776 tun2_maddress stv0900_init_params 0 26776 &disable_so_mthca_cmd_wait_fndecl_26776
+disable_so_simple_sleep_fndecl_26802 simple_sleep fndecl 0 26802 NULL
+disable_so_tv_sec_timestruc_t_26805 tv_sec timestruc_t 0 26805 NULL
+disable_so_get_vblank_timestamp_drm_driver_26807 get_vblank_timestamp drm_driver 2 26807 NULL
+disable_so_dsbr100_setfreq_fndecl_26808 dsbr100_setfreq fndecl 0-2 26808 NULL
+disable_so_base_addr_unaligned_vnic_dev_ring_26813 base_addr_unaligned vnic_dev_ring 0 26813 NULL
+disable_so_addr_ib_mw_bind_info_26826 addr ib_mw_bind_info 0 26826 NULL
+disable_so_cpuidle_add_interface_fndecl_26838 cpuidle_add_interface fndecl 0 26838 NULL nohasharray
+disable_so_addr4_resolve_fndecl_26838 addr4_resolve fndecl 0 26838 &disable_so_cpuidle_add_interface_fndecl_26838
+disable_so_rdmsrl_safe_on_cpu_fndecl_26843 rdmsrl_safe_on_cpu fndecl 0-1 26843 NULL
+disable_so_random_read_fndecl_26852 random_read fndecl 0-3 26852 NULL
+disable_so_reachable_time_ra_msg_26853 reachable_time ra_msg 0 26853 NULL
+disable_so_mutex_lock_interruptible_nested_fndecl_26858 mutex_lock_interruptible_nested fndecl 0 26858 NULL
+disable_so_erase_time_max_flchip_26863 erase_time_max flchip 0 26863 NULL
+disable_so_cpufreq_frequency_table_get_index_fndecl_26865 cpufreq_frequency_table_get_index fndecl 2 26865 NULL
+disable_so_efficient_freq_intel_gen6_power_mgmt_26867 efficient_freq intel_gen6_power_mgmt 0 26867 NULL
+disable_so_sysctl_sched_rt_runtime_vardecl_26872 sysctl_sched_rt_runtime vardecl 0 26872 NULL
+disable_so_time_ncp_cache_head_26879 time ncp_cache_head 0 26879 NULL
+disable_so_qdisc_class_hash_free_fndecl_26882 qdisc_class_hash_free fndecl 2 26882 NULL
+disable_so_cpu_cpuidle_device_26895 cpu cpuidle_device 0 26895 NULL
+disable_so_mod_phy_reg_fndecl_26899 mod_phy_reg fndecl 2-3-4 26899 NULL
+disable_so_vb2_dma_contig_plane_dma_addr_fndecl_26900 vb2_dma_contig_plane_dma_addr fndecl 0 26900 NULL
+disable_so_btree_split_beneath_fndecl_26901 btree_split_beneath fndecl 0 26901 NULL
+disable_so_timestamp_desc_tbl_t_26905 timestamp desc_tbl_t 0 26905 NULL
+disable_so_addr_bit_set_fndecl_26910 addr_bit_set fndecl 0-2 26910 NULL nohasharray
+disable_so_snd_soc_write_fndecl_26910 snd_soc_write fndecl 0-2-3 26910 &disable_so_addr_bit_set_fndecl_26910 nohasharray
+disable_so_timing_legacy_data_26910 timing legacy_data 0 26910 &disable_so_snd_soc_write_fndecl_26910
+disable_so_nsleep_k_clock_26913 nsleep k_clock 1 26913 NULL
+disable_so_sys_stime_fndecl_26915 sys_stime fndecl 0 26915 NULL
+disable_so_sjw_max_can_bittiming_const_26917 sjw_max can_bittiming_const 0 26917 NULL nohasharray
+disable_so_cbc_aes_encrypt_fndecl_26917 cbc_aes_encrypt fndecl 0-4 26917 &disable_so_sjw_max_can_bittiming_const_26917
+disable_so_get_debugctlmsr_fndecl_26918 get_debugctlmsr fndecl 0 26918 NULL
+disable_so_xfs_btree_delrec_fndecl_26919 xfs_btree_delrec fndecl 0 26919 NULL
+disable_so_hr222_sub_set_clock_fndecl_26925 hr222_sub_set_clock fndecl 2-0 26925 NULL
+disable_so_dd_desc_paddr_ath_descdma_26927 dd_desc_paddr ath_descdma 0 26927 NULL
+disable_so_shift_clock_event_device_26934 shift clock_event_device 0 26934 NULL
+disable_so_rx_bseq_addr_bnx2_rx_ring_info_26936 rx_bseq_addr bnx2_rx_ring_info 0 26936 NULL
+disable_so_brcms_c_calc_ba_time_fndecl_26948 brcms_c_calc_ba_time fndecl 0-2 26948 NULL
+disable_so_rcv_buffer_time_stamp_lpfc_vport_26952 rcv_buffer_time_stamp lpfc_vport 0 26952 NULL
+disable_so_min_post_div_radeon_pll_26958 min_post_div radeon_pll 0 26958 NULL
+disable_so_mcryptd_hash_finup_enqueue_fndecl_26959 mcryptd_hash_finup_enqueue fndecl 0 26959 NULL
+disable_so_ip_TransportAddress_ipAddress_26969 ip TransportAddress_ipAddress 0 26969 NULL
+disable_so_addr_fritzcard_26973 addr fritzcard 0 26973 NULL nohasharray
+disable_so_ata_read_native_max_address_fndecl_26973 ata_read_native_max_address fndecl 0 26973 &disable_so_addr_fritzcard_26973
+disable_so_ktime_get_real_seconds_fndecl_26974 ktime_get_real_seconds fndecl 0 26974 NULL nohasharray
+disable_so_i_crtime_extra_ext4_inode_26974 i_crtime_extra ext4_inode 0 26974 &disable_so_ktime_get_real_seconds_fndecl_26974
+disable_so_kern_addr_valid_fndecl_26978 kern_addr_valid fndecl 1 26978 NULL
+disable_so_rtimer_val_vxge_hw_tim_intr_config_26991 rtimer_val vxge_hw_tim_intr_config 0 26991 NULL
+disable_so_timestamp_agere_ext_scan_info_26993 timestamp agere_ext_scan_info 0 26993 NULL
+disable_so_ps_ring_physaddr_rx_ring_26997 ps_ring_physaddr rx_ring 0 26997 NULL
+disable_so_set_bit_in_list_bitmap_fndecl_26998 set_bit_in_list_bitmap fndecl 2 26998 NULL
+disable_so_gid_index_mlx4_eth_av_27005 gid_index mlx4_eth_av 0 27005 NULL
+disable_so_sender_euid_binder_transaction_data_27019 sender_euid binder_transaction_data 0 27019 NULL
+disable_so_sctp_setsockopt_peer_primary_addr_fndecl_27027 sctp_setsockopt_peer_primary_addr fndecl 3-0 27027 NULL
+disable_so_sysctl_x25_ack_holdback_timeout_vardecl_27031 sysctl_x25_ack_holdback_timeout vardecl 0 27031 NULL
+disable_so_blkcipher_next_copy_fndecl_27033 blkcipher_next_copy fndecl 0 27033 NULL
+disable_so_cg_spll_func_cntl_4_si_clock_registers_27036 cg_spll_func_cntl_4 si_clock_registers 0 27036 NULL
+disable_so_mthca_buddy_alloc_fndecl_27037 mthca_buddy_alloc fndecl 2-0 27037 NULL
+disable_so_seq_tcp_skb_cb_27054 seq tcp_skb_cb 0 27054 NULL
+disable_so_s_bitmap_maxbytes_ext4_sb_info_27055 s_bitmap_maxbytes ext4_sb_info 0 27055 NULL
+disable_so_addr_off_bfa_fru_s_27061 addr_off bfa_fru_s 0 27061 NULL
+disable_so_dataserver_timeo_vardecl_filelayoutdev_c_27062 dataserver_timeo vardecl_filelayoutdev.c 0 27062 NULL
+disable_so_demod_address_stv0900_config_27065 demod_address stv0900_config 0 27065 NULL
+disable_so_kvm_apic_match_logical_addr_fndecl_27077 kvm_apic_match_logical_addr fndecl 2 27077 NULL
+disable_so_expires_cpu_itimer_27081 expires cpu_itimer 0 27081 NULL nohasharray
+disable_so_request_any_context_irq_fndecl_27081 request_any_context_irq fndecl 0-1 27081 &disable_so_expires_cpu_itimer_27081
+disable_so_timeout_vardecl_kempld_wdt_c_27085 timeout vardecl_kempld_wdt.c 0 27085 NULL
+disable_so_buffer_addr_rx_free_desc_27090 buffer_addr rx_free_desc 0 27090 NULL
+disable_so_vx_set_clock_fndecl_27093 vx_set_clock fndecl 2 27093 NULL
+disable_so_br_set_forward_delay_fndecl_27097 br_set_forward_delay fndecl 0 27097 NULL
+disable_so_hash_net4_expire_fndecl_27108 hash_net4_expire fndecl 4 27108 NULL
+disable_so_stv0900_get_freq_auto_fndecl_27111 stv0900_get_freq_auto fndecl 0 27111 NULL
+disable_so_wait_for_common_fndecl_27112 wait_for_common fndecl 3 27112 NULL
+disable_so_nfs4_schedule_migration_recovery_fndecl_27114 nfs4_schedule_migration_recovery fndecl 0 27114 NULL
+disable_so_d_rt_spc_timer_qc_dqblk_27117 d_rt_spc_timer qc_dqblk 0 27117 NULL
+disable_so_btree_insert64_fndecl_27118 btree_insert64 fndecl 2-4 27118 NULL
+disable_so_addrconf_mod_dad_work_fndecl_27128 addrconf_mod_dad_work fndecl 2 27128 NULL
+disable_so_coalescing_timeo_bna_rx_config_27130 coalescing_timeo bna_rx_config 0 27130 NULL nohasharray
+disable_so_addr_page_to_node_27130 addr page_to_node 0 27130 &disable_so_coalescing_timeo_bna_rx_config_27130
+disable_so_st_atime_nsec_p9_stat_dotl_27131 st_atime_nsec p9_stat_dotl 0 27131 NULL
+disable_so_myri10ge_intr_coal_delay_vardecl_myri10ge_c_27141 myri10ge_intr_coal_delay vardecl_myri10ge.c 0 27141 NULL
+disable_so_hash_shift_deflate_state_27146 hash_shift deflate_state 0 27146 NULL
+disable_so_palmas_rtc_read_time_fndecl_27149 palmas_rtc_read_time fndecl 0 27149 NULL
+disable_so___atomic_add_ifless_fndecl_27155 __atomic_add_ifless fndecl 3 27155 NULL
+disable_so_iscsi_conn_get_addr_param_fndecl_27170 iscsi_conn_get_addr_param fndecl 0 27170 NULL
+disable_so___clocksource_update_freq_hz_fndecl_27171 __clocksource_update_freq_hz fndecl 2 27171 NULL
+disable_so_id_sst_module_runtime_27177 id sst_module_runtime 0 27177 NULL
+disable_so_crypto_xcbc_digest_setkey_fndecl_27185 crypto_xcbc_digest_setkey fndecl 0-3 27185 NULL
+disable_so_enic_set_mac_addr_fndecl_27188 enic_set_mac_addr fndecl 0 27188 NULL
+disable_so_expires_timer_list_27202 expires timer_list 0 27202 NULL
+disable_so_compute_subtree_last_fndecl_27204 compute_subtree_last fndecl 0 27204 NULL
+disable_so_qla4_82xx_decode_crb_addr_fndecl_27209 qla4_82xx_decode_crb_addr fndecl 0-1 27209 NULL
+disable_so_debugtimer_vardecl_floppy_c_27217 debugtimer vardecl_floppy.c 0 27217 NULL
+disable_so_time_offset_perf_event_mmap_page_27223 time_offset perf_event_mmap_page 0 27223 NULL
+disable_so___ufshcd_setup_clocks_fndecl_27227 __ufshcd_setup_clocks fndecl 0 27227 NULL
+disable_so_ccallback_snd_timer_instance_27233 ccallback snd_timer_instance 4 27233 NULL
+disable_so_cpufreq_p4_get_fndecl_27237 cpufreq_p4_get fndecl 1 27237 NULL
+disable_so_bd_phy_addr_wcn36xx_dxe_ctl_27253 bd_phy_addr wcn36xx_dxe_ctl 0 27253 NULL
+disable_so___xfrm_dst_hash_fndecl_27263 __xfrm_dst_hash fndecl 0-3-4-5 27263 NULL
+disable_so_mcp795_read_time_fndecl_27267 mcp795_read_time fndecl 0 27267 NULL
+disable_so_base_mtrr_sentry_27271 base mtrr_sentry 0 27271 NULL
+disable_so_proc_do_large_bitmap_fndecl_27272 proc_do_large_bitmap fndecl 0 27272 NULL
+disable_so_stv0367cab_get_adc_freq_fndecl_27274 stv0367cab_get_adc_freq fndecl 0-2 27274 NULL
+disable_so_gpadc_page_addr_pm80x_subchip_27284 gpadc_page_addr pm80x_subchip 0 27284 NULL
+disable_so_udf_count_free_bitmap_fndecl_27294 udf_count_free_bitmap fndecl 0 27294 NULL
+disable_so_timestamp_ieee80211_channel_switch_27297 timestamp ieee80211_channel_switch 0 27297 NULL
+disable_so_fd_flush_timestamp_i40e_pf_27298 fd_flush_timestamp i40e_pf 0 27298 NULL nohasharray
+disable_so_snd_rme96_info_clockmode_control_fndecl_27298 snd_rme96_info_clockmode_control fndecl 0 27298 &disable_so_fd_flush_timestamp_i40e_pf_27298
+disable_so_past_time_fndecl_27299 past_time fndecl 1 27299 NULL
+disable_so_status_hci_rp_read_bd_addr_27307 status hci_rp_read_bd_addr 0 27307 NULL
+disable_so_demod_address_lgs8gxx_config_27311 demod_address lgs8gxx_config 0 27311 NULL
+disable_so_clock_offset_mlx4_fw_27318 clock_offset mlx4_fw 0 27318 NULL
+disable_so_native_sched_clock_fndecl_27322 native_sched_clock fndecl 0 27322 NULL
+disable_so_preferred_time_prefix_cacheinfo_27329 preferred_time prefix_cacheinfo 0 27329 NULL nohasharray
+disable_so_srq_get_mtt_addr_fndecl_27329 srq_get_mtt_addr fndecl 0 27329 &disable_so_preferred_time_prefix_cacheinfo_27329
+disable_so_di_pt_regs_27336 di pt_regs 0 27336 NULL
+disable_so_buf1_addr_xgmac_dma_desc_27344 buf1_addr xgmac_dma_desc 0 27344 NULL
+disable_so_timer_mask_ath_gen_timer_table_27351 timer_mask ath_gen_timer_table 0 27351 NULL
+disable_so_max_frags_iwl_time_event_cmd_27357 max_frags iwl_time_event_cmd 0 27357 NULL nohasharray
+disable_so_wd_last_clocksource_27357 wd_last clocksource 0 27357 &disable_so_max_frags_iwl_time_event_cmd_27357
+disable_so_sermouse_interrupt_fndecl_27361 sermouse_interrupt fndecl 2 27361 NULL
+disable_so_tm_mday_rtc_time_27369 tm_mday rtc_time 0 27369 NULL
+disable_so_opad_count_ccp_sha_ctx_27374 opad_count ccp_sha_ctx 0 27374 NULL
+disable_so_keyed_hash_fndecl_27379 keyed_hash fndecl 0-2 27379 NULL
+disable_so_addr_d11init_27383 addr d11init 0 27383 NULL
+disable_so_test_bit_le_fndecl_27392 test_bit_le fndecl 1 27392 NULL
+disable_so_i2c_bit_add_bus_fndecl_27395 i2c_bit_add_bus fndecl 0 27395 NULL
+disable_so_xhci_calculate_u2_timeout_fndecl_27406 xhci_calculate_u2_timeout fndecl 0 27406 NULL
+disable_so_sym_getclock_fndecl_27414 sym_getclock fndecl 2 27414 NULL
+disable_so_pat_x_mtrr_type_fndecl_27415 pat_x_mtrr_type fndecl 1-2 27415 NULL
+disable_so_val_addr_core1_nphy_rf_control_override_rev7_27422 val_addr_core1 nphy_rf_control_override_rev7 0 27422 NULL nohasharray
+disable_so_qce_ahash_hmac_setkey_fndecl_27422 qce_ahash_hmac_setkey fndecl 3 27422 &disable_so_val_addr_core1_nphy_rf_control_override_rev7_27422
+disable_so_ratio_o_rj54n1_clock_div_27431 ratio_o rj54n1_clock_div 0 27431 NULL nohasharray
+disable_so_pr_uid_elf_prpsinfo_27431 pr_uid elf_prpsinfo 0 27431 &disable_so_ratio_o_rj54n1_clock_div_27431
+disable_so_nla_get_be64_fndecl_27433 nla_get_be64 fndecl 0 27433 NULL
+disable_so_encryptor_fndecl_27450 encryptor fndecl 0 27450 NULL
+disable_so_hsync_offset_lo_oaktrail_timing_info_27455 hsync_offset_lo oaktrail_timing_info 0 27455 NULL
+disable_so_store_scaling_max_freq_fndecl_27459 store_scaling_max_freq fndecl 0-3 27459 NULL
+disable_so_addrLow_lpfc_pde7_27462 addrLow lpfc_pde7 0 27462 NULL
+disable_so_ql_get_mac_addr_reg_fndecl_27466 ql_get_mac_addr_reg fndecl 0 27466 NULL
+disable_so_r600_engine_clock_entry_set_feedback_divider_fndecl_27467 r600_engine_clock_entry_set_feedback_divider fndecl 3 27467 NULL
+disable_so_queue_timestamp_cw1200_queue_item_27470 queue_timestamp cw1200_queue_item 0 27470 NULL nohasharray
+disable_so_timing_event_fndecl_27470 timing_event fndecl 0 27470 &disable_so_queue_timestamp_cw1200_queue_item_27470
+disable_so_seg0_blkaddr_f2fs_sm_info_27483 seg0_blkaddr f2fs_sm_info 0 27483 NULL nohasharray
+disable_so_shash_async_init_fndecl_27483 shash_async_init fndecl 0 27483 &disable_so_seg0_blkaddr_f2fs_sm_info_27483
+disable_so_esas2r_buffered_ioctl_addr_vardecl_27487 esas2r_buffered_ioctl_addr vardecl 0 27487 NULL
+disable_so_buffer_write_time_max_flchip_27491 buffer_write_time_max flchip 0 27491 NULL
+disable_so_reg_data_clock_eeprom_93cx6_27496 reg_data_clock eeprom_93cx6 0 27496 NULL
+disable_so_ieee80211_if_read_min_discovery_timeout_fndecl_27497 ieee80211_if_read_min_discovery_timeout fndecl 3-0 27497 NULL nohasharray
+disable_so_address_pmcraid_ioadl_desc_27497 address pmcraid_ioadl_desc 0 27497 &disable_so_ieee80211_if_read_min_discovery_timeout_fndecl_27497
+disable_so_host_perf_guest_switch_msr_27498 host perf_guest_switch_msr 0 27498 NULL
+disable_so_dummy_buffer_addr_hi_iscsi_kwqe_init1_27499 dummy_buffer_addr_hi iscsi_kwqe_init1 0 27499 NULL
+disable_so__rtl88e_phy_calculate_bit_shift_fndecl_27500 _rtl88e_phy_calculate_bit_shift fndecl 0-1 27500 NULL
+disable_so_mceusb_dev_printdata_fndecl_27502 mceusb_dev_printdata fndecl 4 27502 NULL
+disable_so_sk_sndtimeo_sock_27506 sk_sndtimeo sock 0 27506 NULL
+disable_so_oprofile_timer_init_fndecl_27514 oprofile_timer_init fndecl 0 27514 NULL
+disable_so_st_atime___old_kernel_stat_27516 st_atime __old_kernel_stat 0 27516 NULL
+disable_so_hpi_sample_clock_set_local_rate_lock_fndecl_27517 hpi_sample_clock_set_local_rate_lock fndecl 1-0 27517 NULL
+disable_so_addr_perf_sample_data_27520 addr perf_sample_data 0 27520 NULL
+disable_so_curr_dbg_uidn_show_fndecl_27524 curr_dbg_uidn_show fndecl 3 27524 NULL
+disable_so_crypto_register_template_fndecl_27525 crypto_register_template fndecl 0 27525 NULL
+disable_so_process_tgid_sid_proc_event_27544 process_tgid sid_proc_event 0 27544 NULL
+disable_so_fandiv2_nct6775_data_27558 fandiv2 nct6775_data 0 27558 NULL
+disable_so_delay_time_bridge_mcast_other_query_27560 delay_time bridge_mcast_other_query 0 27560 NULL
+disable_so_addr_hi_acard_sg_27563 addr_hi acard_sg 0 27563 NULL
+disable_so_address_tlan_buffer_27580 address tlan_buffer 0 27580 NULL
+disable_so_rdma_addr_find_smac_by_sgid_fndecl_27591 rdma_addr_find_smac_by_sgid fndecl 0 27591 NULL
+disable_so_addrconf_add_linklocal_fndecl_27592 addrconf_add_linklocal fndecl 3 27592 NULL
+disable_so_fb_delay_gt215_clk_info_27603 fb_delay gt215_clk_info 0 27603 NULL
+disable_so_ss_nongc_ctime_nilfs_sustat_27619 ss_nongc_ctime nilfs_sustat 0 27619 NULL
+disable_so_shash_ahash_mcryptd_final_fndecl_27624 shash_ahash_mcryptd_final fndecl 0 27624 NULL
+disable_so_iwl_set_hw_address_family_8000_fndecl_27628 iwl_set_hw_address_family_8000 fndecl 6-7 27628 NULL
+disable_so_dm_delay_init_fndecl_27635 dm_delay_init fndecl 0 27635 NULL
+disable_so_seq_tcphdr_27638 seq tcphdr 0 27638 NULL
+disable_so_cbq_undelay_prio_fndecl_27641 cbq_undelay_prio fndecl 0-3 27641 NULL
+disable_so_sst_module_runtime_save_fndecl_27642 sst_module_runtime_save fndecl 0 27642 NULL
+disable_so_crypto_pcbc_module_init_fndecl_27648 crypto_pcbc_module_init fndecl 0 27648 NULL
+disable_so_freq_prev_cpu_data_t_27649 freq_prev cpu_data_t 0 27649 NULL
+disable_so_status_mce_27652 status mce 0 27652 NULL
+disable_so_buff_addr_ixgb_rx_desc_27660 buff_addr ixgb_rx_desc 0 27660 NULL
+disable_so_phy_addr_mii_phy_27664 phy_addr mii_phy 0 27664 NULL
+disable_so_demod_address_lgdt330x_config_27668 demod_address lgdt330x_config 0 27668 NULL
+disable_so__next_div_fndecl_27679 _next_div fndecl 0-2 27679 NULL
+disable_so_rtc_timer_enqueue_fndecl_27693 rtc_timer_enqueue fndecl 0 27693 NULL nohasharray
+disable_so_addr_phy_device_27693 addr phy_device 0 27693 &disable_so_rtc_timer_enqueue_fndecl_27693
+disable_so_timer_multiplier_tg3_27703 timer_multiplier tg3 0 27703 NULL
+disable_so_address_acpi_table_madt_27705 address acpi_table_madt 0 27705 NULL
+disable_so_saddr_flowi4_27709 saddr flowi4 0 27709 NULL
+disable_so_acpi_tb_select_address_fndecl_27710 acpi_tb_select_address fndecl 0-2-3 27710 NULL
+disable_so_wl18xx_acx_ap_sleep_fndecl_27719 wl18xx_acx_ap_sleep fndecl 0 27719 NULL
+disable_so_sleep_start_sched_statistics_27721 sleep_start sched_statistics 0 27721 NULL nohasharray
+disable_so_inj_addr_set_fndecl_27721 inj_addr_set fndecl 2 27721 &disable_so_sleep_start_sched_statistics_27721
+disable_so_addr_fw_page_27728 addr fw_page 0 27728 NULL
+disable_so_time_stamp_e1000_tx_buffer_27729 time_stamp e1000_tx_buffer 0 27729 NULL
+disable_so_ata_internal_cmd_timed_out_fndecl_27734 ata_internal_cmd_timed_out fndecl 2 27734 NULL
+disable_so_sleep_ide_drive_s_27745 sleep ide_drive_s 0 27745 NULL
+disable_so_platform_clock_control_fndecl_27752 platform_clock_control fndecl 0 27752 NULL
+disable_so_tick_timex_27769 tick timex 0 27769 NULL
+disable_so__is_best_div_fndecl_27772 _is_best_div fndecl 1-2-3 27772 NULL
+disable_so_update_cpumask_fndecl_27776 update_cpumask fndecl 0 27776 NULL
+disable_so_mxser_get_msr_fndecl_27778 mxser_get_msr fndecl 3 27778 NULL
+disable_so_btree_insert32_fndecl_27786 btree_insert32 fndecl 2-4 27786 NULL
+disable_so_ccp_do_sha_update_fndecl_27787 ccp_do_sha_update fndecl 0-2 27787 NULL
+disable_so_complete_crypto_gcm_ghash_ctx_27789 complete crypto_gcm_ghash_ctx 0 27789 NULL
+disable_so_cryptoloop_transfer_fndecl_27794 cryptoloop_transfer fndecl 0-4-6-7 27794 NULL
+disable_so_max_reconnect_timeout_sbp_tport_27795 max_reconnect_timeout sbp_tport 0 27795 NULL
+disable_so_drxj_dap_write_reg16_fndecl_27796 drxj_dap_write_reg16 fndecl 0-3 27796 NULL
+disable_so_i_crtime_ext4_inode_27803 i_crtime ext4_inode 0 27803 NULL
+disable_so_bridge_ctl_pci_bus_27806 bridge_ctl pci_bus 0 27806 NULL
+disable_so_sas_unregister_devs_sas_addr_fndecl_27808 sas_unregister_devs_sas_addr fndecl 2 27808 NULL
+disable_so_move_to_next_stateful_cpuid_entry_fndecl_27817 move_to_next_stateful_cpuid_entry fndecl 0-2 27817 NULL
+disable_so_delay_pktgen_dev_27827 delay pktgen_dev 0 27827 NULL
+disable_so_ipath_physaddr_ipath_devdata_27830 ipath_physaddr ipath_devdata 0 27830 NULL
+disable_so_rh_timer_musb_27835 rh_timer musb 0 27835 NULL
+disable_so_spinfo_cwnd_sctp_paddrinfo_27841 spinfo_cwnd sctp_paddrinfo 0 27841 NULL
+disable_so_prism54_set_freq_fndecl_27858 prism54_set_freq fndecl 0 27858 NULL
+disable_so_host_addr_mei_msg_hdr_27859 host_addr mei_msg_hdr 0 27859 NULL
+disable_so_xr17v35x_get_divisor_fndecl_27860 xr17v35x_get_divisor fndecl 0-2 27860 NULL
+disable_so_run_delayed_data_ref_fndecl_27870 run_delayed_data_ref fndecl 0 27870 NULL
+disable_so_args_addr_pmu_nvbios_pmuR_27871 args_addr_pmu nvbios_pmuR 0 27871 NULL
+disable_so_nr_of_multicastmacaddr_lbtf_private_27872 nr_of_multicastmacaddr lbtf_private 0 27872 NULL
+disable_so_cfg80211_mgd_wext_siwfreq_fndecl_27873 cfg80211_mgd_wext_siwfreq fndecl 0 27873 NULL
+disable_so_get_ftdi_divisor_fndecl_27883 get_ftdi_divisor fndecl 0 27883 NULL nohasharray
+disable_so_sense_buf_phys_addr_lo_megasas_pthru_frame_27883 sense_buf_phys_addr_lo megasas_pthru_frame 0 27883 &disable_so_get_ftdi_divisor_fndecl_27883
+disable_so_acpi_gbl_sleep_type_a_vardecl_27893 acpi_gbl_sleep_type_a vardecl 0 27893 NULL
+disable_so_addr_ahc_dma_seg_27896 addr ahc_dma_seg 0 27896 NULL
+disable_so_est_timer_fndecl_27898 est_timer fndecl 1 27898 NULL
+disable_so_phonet_address_add_fndecl_27900 phonet_address_add fndecl 0-2 27900 NULL
+disable_so_uhci_sprint_schedule_fndecl_27905 uhci_sprint_schedule fndecl 0 27905 NULL
+disable_so_cpufreq_generic_init_fndecl_27911 cpufreq_generic_init fndecl 3 27911 NULL
+disable_so_brcms_c_calc_frame_time_fndecl_27915 brcms_c_calc_frame_time fndecl 0-4-2 27915 NULL
+disable_so_max_pixel_clock_matrox_fb_info_27917 max_pixel_clock matrox_fb_info 0 27917 NULL
+disable_so_cfg80211_get_end_freq_fndecl_27923 cfg80211_get_end_freq fndecl 0-1-2 27923 NULL
+disable_so_tv_usec_timeval_27924 tv_usec timeval 0 27924 NULL nohasharray
+disable_so_bootloader_addr_mxt_data_27924 bootloader_addr mxt_data 0 27924 &disable_so_tv_usec_timeval_27924
+disable_so_scope_ipv6_saddr_dst_27930 scope ipv6_saddr_dst 0 27930 NULL
+disable_so_skcipher_recvmsg_sync_fndecl_27933 skcipher_recvmsg_sync fndecl 0 27933 NULL
+disable_so_nf_ct_free_hashtable_fndecl_27936 nf_ct_free_hashtable fndecl 2 27936 NULL
+disable_so_addr_netlbl_af4list_27939 addr netlbl_af4list 0 27939 NULL
+disable_so_idgen_delay_netns_sysctl_ipv6_27941 idgen_delay netns_sysctl_ipv6 0 27941 NULL
+disable_so_time_low_afs_uuid_27956 time_low afs_uuid 0 27956 NULL
+disable_so_set_tv_freq_fndecl_27970 set_tv_freq fndecl 2 27970 NULL
+disable_so_average_duration_time_stats_27971 average_duration time_stats 0 27971 NULL
+disable_so_multicast_num_addrs__mace_private_27974 multicast_num_addrs _mace_private 0 27974 NULL
+disable_so_ghash_pclmulqdqni_mod_init_fndecl_27975 ghash_pclmulqdqni_mod_init fndecl 0 27975 NULL
+disable_so_gs_gru_base_paddr_gru_state_27988 gs_gru_base_paddr gru_state 0 27988 NULL nohasharray
+disable_so_paging32_walk_addr_fndecl_27988 paging32_walk_addr fndecl 3-4 27988 &disable_so_gs_gru_base_paddr_gru_state_27988
+disable_so_musb_read_rxfunaddr_fndecl_27990 musb_read_rxfunaddr fndecl 2-0 27990 NULL
+disable_so_kstrtoint_fndecl_27993 kstrtoint fndecl 0 27993 NULL
+disable_so_rv770_encode_yclk_post_div_fndecl_27996 rv770_encode_yclk_post_div fndecl 0-1 27996 NULL
+disable_so_di_uid_qnx6_inode_entry_28014 di_uid qnx6_inode_entry 0 28014 NULL
+disable_so_sctp_verify_addr_fndecl_28018 sctp_verify_addr fndecl 0-3 28018 NULL
+disable_so_timeout_ieee80211_mgd_assoc_data_28022 timeout ieee80211_mgd_assoc_data 0 28022 NULL
+disable_so_nadc_aic31xx_rate_divs_28025 nadc aic31xx_rate_divs 0 28025 NULL
+disable_so_address_end_unity_map_entry_28028 address_end unity_map_entry 0 28028 NULL
+disable_so_ring_pt_address_sst_hsw_ipc_stream_ring_28034 ring_pt_address sst_hsw_ipc_stream_ring 0 28034 NULL
+disable_so_rx_hashtbl_used_head_alb_bond_info_28035 rx_hashtbl_used_head alb_bond_info 0 28035 NULL
+disable_so_reset_time_vardecl_cs_c_28036 reset_time vardecl_cs.c 0 28036 NULL
+disable_so_slicer_line_delay_cx18_av_state_28042 slicer_line_delay cx18_av_state 0 28042 NULL
+disable_so_addr1_unlock_addr_28045 addr1 unlock_addr 0 28045 NULL
+disable_so_timestamp_ath6kl_fwlog_slot_28050 timestamp ath6kl_fwlog_slot 0 28050 NULL
+disable_so_max8925_rtc_set_time_fndecl_28052 max8925_rtc_set_time fndecl 0 28052 NULL
+disable_so_hblank_lo_lvds_dvo_timing_28054 hblank_lo lvds_dvo_timing 0 28054 NULL
+disable_so_total_bytes_available_snd_compr_runtime_28061 total_bytes_available snd_compr_runtime 0 28061 NULL
+disable_so_start_jiffies_dm_cache_migration_28062 start_jiffies dm_cache_migration 0 28062 NULL
+disable_so_fm10k_read_systime_pf_fndecl_28063 fm10k_read_systime_pf fndecl 0 28063 NULL
+disable_so_time_stopped_btrfs_dev_replace_28065 time_stopped btrfs_dev_replace 0 28065 NULL
+disable_so_total_time_devfreq_dev_status_28070 total_time devfreq_dev_status 0 28070 NULL
+disable_so_congested_cycles_vardecl_tlb_uv_c_28074 congested_cycles vardecl_tlb_uv.c 0 28074 NULL
+disable_so_db_addr_mlx4_ib_create_cq_28077 db_addr mlx4_ib_create_cq 0 28077 NULL
+disable_so_ipaddr_atmmpc_ioc_28080 ipaddr atmmpc_ioc 0 28080 NULL
+disable_so_drm_modeset_backoff_interruptible_fndecl_28087 drm_modeset_backoff_interruptible fndecl 0 28087 NULL
+disable_so_pcr_address_fndecl_28088 pcr_address fndecl 0 28088 NULL
+disable_so_fill_stats_for_tgid_fndecl_28092 fill_stats_for_tgid fndecl 0-1 28092 NULL
+disable_so_ep0_set_address_fndecl_28094 ep0_set_address fndecl 0 28094 NULL
+disable_so_vdi_uid_vxfs_inode_info_28097 vdi_uid vxfs_inode_info 0 28097 NULL
+disable_so_cryptd_hash_final_fndecl_28098 cryptd_hash_final fndecl 2 28098 NULL
+disable_so_sysctl_aevent_etime_netns_xfrm_28099 sysctl_aevent_etime netns_xfrm 0 28099 NULL
+disable_so_nilfs_segctor_last_seg_write_time_secs_show_fndecl_28103 nilfs_segctor_last_seg_write_time_secs_show fndecl 0 28103 NULL
+disable_so_toshiba_usb_sleep_charge_set_fndecl_28108 toshiba_usb_sleep_charge_set fndecl 0 28108 NULL
+disable_so_r63_val_fc2580_freq_regs_28120 r63_val fc2580_freq_regs 0 28120 NULL
+disable_so_myri10ge_read_mac_addr_fndecl_28129 myri10ge_read_mac_addr fndecl 0 28129 NULL
+disable_so_stv090x_get_feclock_fndecl_28130 stv090x_get_feclock fndecl 0 28130 NULL
+disable_so_m_blkbit_log_xfs_mount_28131 m_blkbit_log xfs_mount 0 28131 NULL
+disable_so_duration_iwl_mvm_time_event_data_28140 duration iwl_mvm_time_event_data 0 28140 NULL
+disable_so_compute_tsc_offset_kvm_x86_ops_28149 compute_tsc_offset kvm_x86_ops 0-2 28149 NULL
+disable_so_sys_clock_freq_drxd_state_28176 sys_clock_freq drxd_state 0 28176 NULL
+disable_so_addrLow_sge_ieee1212_28181 addrLow sge_ieee1212 0 28181 NULL
+disable_so_ctnetlink_timestamp_size_fndecl_28183 ctnetlink_timestamp_size fndecl 0 28183 NULL
+disable_so_ahash_def_finup_fndecl_28189 ahash_def_finup fndecl 0 28189 NULL
+disable_so_hw_ptr_jiffies_snd_pcm_runtime_28200 hw_ptr_jiffies snd_pcm_runtime 0 28200 NULL
+disable_so_tmr_device_snd_timer_28205 tmr_device snd_timer 0 28205 NULL
+disable_so_kycr2_delay_sh_keysc_info_28217 kycr2_delay sh_keysc_info 0 28217 NULL
+disable_so_timestamp_nfs4_opendata_28221 timestamp nfs4_opendata 0 28221 NULL
+disable_so_mb_find_next_zero_bit_fndecl_28223 mb_find_next_zero_bit fndecl 0-2-3 28223 NULL
+disable_so_nbytes_orig_qce_sha_reqctx_28228 nbytes_orig qce_sha_reqctx 0 28228 NULL
+disable_so_code_addr_nvbios_pmuR_28229 code_addr nvbios_pmuR 0 28229 NULL
+disable_so_clock_pad_drive_dib0070_config_28232 clock_pad_drive dib0070_config 0 28232 NULL nohasharray
+disable_so_ringid_wmi_bcast_vring_cfg_28232 ringid wmi_bcast_vring_cfg 0 28232 &disable_so_clock_pad_drive_dib0070_config_28232
+disable_so_centiseconds_timestamp_28239 centiseconds timestamp 0 28239 NULL nohasharray
+disable_so_psb_vdc_interrupt_fndecl_28239 psb_vdc_interrupt fndecl 2 28239 &disable_so_centiseconds_timestamp_28239
+disable_so_freqshift_snd_usb_endpoint_28255 freqshift snd_usb_endpoint 0 28255 NULL
+disable_so_drm_vblank_count_and_time_fndecl_28263 drm_vblank_count_and_time fndecl 2 28263 NULL
+disable_so_cr_s5p_jpeg_addr_28264 cr s5p_jpeg_addr 0 28264 NULL
+disable_so_adis16136_get_freq_fndecl_28268 adis16136_get_freq fndecl 0 28268 NULL nohasharray
+disable_so_cpu_to_tun16_fndecl_28268 cpu_to_tun16 fndecl 0-2 28268 &disable_so_adis16136_get_freq_fndecl_28268
+disable_so_index_msr_data_28269 index msr_data 0 28269 NULL
+disable_so_clock_realtek_pci_sdmmc_28276 clock realtek_pci_sdmmc 0 28276 NULL
+disable_so_div_q0_pll_values_28280 div_q0 pll_values 0 28280 NULL
+disable_so_fall_time_lp8788_bl_config_28282 fall_time lp8788_bl_config 0 28282 NULL
+disable_so_producer_index_phys_addr_lo_megasas_init_queue_info_28289 producer_index_phys_addr_lo megasas_init_queue_info 0 28289 NULL
+disable_so_hash_ipport4_expire_fndecl_28290 hash_ipport4_expire fndecl 4 28290 NULL
+disable_so_ifa_valid_lft_in_ifaddr_28292 ifa_valid_lft in_ifaddr 0 28292 NULL nohasharray
+disable_so_test_ahash_jiffies_digest_fndecl_28292 test_ahash_jiffies_digest fndecl 0 28292 &disable_so_ifa_valid_lft_in_ifaddr_28292
+disable_so_bitmap_parselist_fndecl_28296 bitmap_parselist fndecl 0-3 28296 NULL
+disable_so_st_uid_stat_28301 st_uid stat 0 28301 NULL
+disable_so_default_powersave_bias_vardecl_cpufreq_ondemand_c_28302 default_powersave_bias vardecl_cpufreq_ondemand.c 0 28302 NULL
+disable_so__simple_hash_fndecl_28307 _simple_hash fndecl 0 28307 NULL
+disable_so_sys_setfsuid_fndecl_28311 sys_setfsuid fndecl 0-1 28311 NULL
+disable_so_buf_addr_mlx4_ib_resize_cq_28313 buf_addr mlx4_ib_resize_cq 0 28313 NULL nohasharray
+disable_so_netxen_config_ipaddr_fndecl_28313 netxen_config_ipaddr fndecl 2 28313 &disable_so_buf_addr_mlx4_ib_resize_cq_28313 nohasharray
+disable_so_set_32bit_tls_fndecl_28313 set_32bit_tls fndecl 3 28313 &disable_so_netxen_config_ipaddr_fndecl_28313
+disable_so_init_systime_stmmac_hwtimestamp_28315 init_systime stmmac_hwtimestamp 2-3 28315 NULL
+disable_so_bf_daddr_ath_buf_28317 bf_daddr ath_buf 0 28317 NULL nohasharray
+disable_so_xfs_btree_readahead_ptr_fndecl_28317 xfs_btree_readahead_ptr fndecl 3 28317 &disable_so_bf_daddr_ath_buf_28317
+disable_so__is_valid_div_fndecl_28320 _is_valid_div fndecl 2 28320 NULL
+disable_so_loop_id_2100_gid_list_info_28327 loop_id_2100 gid_list_info 0 28327 NULL nohasharray
+disable_so_hi_regpair_28327 hi regpair 0 28327 &disable_so_loop_id_2100_gid_list_info_28327
+disable_so_dst_addr_rcar_dmac_xfer_chunk_28333 dst_addr rcar_dmac_xfer_chunk 0 28333 NULL
+disable_so_svm_msrpm_offset_fndecl_28343 svm_msrpm_offset fndecl 0-1 28343 NULL
+disable_so_dma_free_attrs_fndecl_28349 dma_free_attrs fndecl 2-4 28349 NULL
+disable_so_gc_psx_delay_vardecl_gamecon_c_28354 gc_psx_delay vardecl_gamecon.c 0 28354 NULL
+disable_so_di_mtime_nsec_gfs2_dinode_28356 di_mtime_nsec gfs2_dinode 0 28356 NULL
+disable_so_panel_post_divider_radeon_encoder_lvds_28360 panel_post_divider radeon_encoder_lvds 0 28360 NULL
+disable_so_cpu_rt_runtime_write_fndecl_28375 cpu_rt_runtime_write fndecl 3-0 28375 NULL nohasharray
+disable_so_hrtimer_nanosleep_fndecl_28375 hrtimer_nanosleep fndecl 4 28375 &disable_so_cpu_rt_runtime_write_fndecl_28375
+disable_so_addr_yellowfin_desc_28380 addr yellowfin_desc 0 28380 NULL
+disable_so_time_count_mptsas_target_reset_event_28383 time_count mptsas_target_reset_event 0 28383 NULL nohasharray
+disable_so_pos2maj_hash_fndecl_28383 pos2maj_hash fndecl 0-2 28383 &disable_so_time_count_mptsas_target_reset_event_28383
+disable_so_chv_freq_opcode_fndecl_28386 chv_freq_opcode fndecl 0-2 28386 NULL
+disable_so_nsecs_to_jiffies_fndecl_28394 nsecs_to_jiffies fndecl 0-1 28394 NULL
+disable_so_qpn_hash_fndecl_28400 qpn_hash fndecl 0-2 28400 NULL
+disable_so_seltime_b_ahc_softc_28409 seltime_b ahc_softc 0 28409 NULL
+disable_so_ast_set_start_address_crt1_fndecl_28414 ast_set_start_address_crt1 fndecl 2 28414 NULL
+disable_so_tseg2_pucan_timing_fast_28420 tseg2 pucan_timing_fast 0 28420 NULL
+disable_so_tlv_put_uuid_fndecl_28427 tlv_put_uuid fndecl 0 28427 NULL
+disable_so_cur_tsc_write_kvm_arch_28444 cur_tsc_write kvm_arch 0 28444 NULL
+disable_so_addr_2_qla8044_minidump_entry_rdmdio_28446 addr_2 qla8044_minidump_entry_rdmdio 0 28446 NULL
+disable_so_ft_img_ir_timing_regvals_28448 ft img_ir_timing_regvals 0 28448 NULL
+disable_so_blk_queue_rq_timeout_fndecl_28452 blk_queue_rq_timeout fndecl 2 28452 NULL
+disable_so_pch_udc_read_device_interrupts_fndecl_28463 pch_udc_read_device_interrupts fndecl 0 28463 NULL
+disable_so_spidev_sync_fndecl_28473 spidev_sync fndecl 0 28473 NULL
+disable_so_mvs_store_interrupt_coalescing_fndecl_28474 mvs_store_interrupt_coalescing fndecl 0-4 28474 NULL
+disable_so_div_up_fndecl_28477 div_up fndecl 0-1-2 28477 NULL
+disable_so_iwlagn_hw_valid_rtc_data_addr_fndecl_28480 iwlagn_hw_valid_rtc_data_addr fndecl 1 28480 NULL
+disable_so_ixgbe_init_interrupt_scheme_fndecl_28488 ixgbe_init_interrupt_scheme fndecl 0 28488 NULL
+disable_so_next_hrtimer_event_ehci_hcd_28494 next_hrtimer_event ehci_hcd 0 28494 NULL
+disable_so_show_hold_timer_fndecl_28495 show_hold_timer fndecl 0 28495 NULL
+disable_so_linetime_intel_pipe_wm_28496 linetime intel_pipe_wm 0 28496 NULL
+disable_so_rcq_addr_vf_pf_rxq_params_28504 rcq_addr vf_pf_rxq_params 0 28504 NULL
+disable_so_paddr_ath10k_hif_sg_item_28509 paddr ath10k_hif_sg_item 0 28509 NULL
+disable_so_ocfs2_clear_bit_unaligned_fndecl_28520 ocfs2_clear_bit_unaligned fndecl 1 28520 NULL
+disable_so_interrupt_notify_wlcore_ops_28523 interrupt_notify wlcore_ops 0 28523 NULL
+disable_so_r_direct_hash_ceph_mds_request_28525 r_direct_hash ceph_mds_request 0 28525 NULL
+disable_so_i_ctime_omfs_inode_28528 i_ctime omfs_inode 0 28528 NULL
+disable_so_sas_request_addr_fndecl_28536 sas_request_addr fndecl 0 28536 NULL
+disable_so_bnx2x_send_reset_timesync_ramrod_fndecl_28537 bnx2x_send_reset_timesync_ramrod fndecl 0 28537 NULL
+disable_so_prev_sum_exec_runtime_sched_entity_28542 prev_sum_exec_runtime sched_entity 0 28542 NULL nohasharray
+disable_so_reg_w1_fndecl_28542 reg_w1 fndecl 2-3 28542 &disable_so_prev_sum_exec_runtime_sched_entity_28542
+disable_so_addr_wil_memio_28545 addr wil_memio 0 28545 NULL
+disable_so_drm_get_last_vbltimestamp_fndecl_28555 drm_get_last_vbltimestamp fndecl 2 28555 NULL nohasharray
+disable_so_decryptor_fndecl_28555 decryptor fndecl 0 28555 &disable_so_drm_get_last_vbltimestamp_fndecl_28555
+disable_so_mcryptd_hash_enqueue_fndecl_28559 mcryptd_hash_enqueue fndecl 0 28559 NULL
+disable_so_i_ctime_nilfs_inode_28572 i_ctime nilfs_inode 0 28572 NULL
+disable_so_ablkcipher_request_complete_fndecl_28578 ablkcipher_request_complete fndecl 2 28578 NULL
+disable_so_quark_x1000_get_clk_div_fndecl_28592 quark_x1000_get_clk_div fndecl 0-1 28592 NULL
+disable_so_myri10ge_update_mac_address_fndecl_28593 myri10ge_update_mac_address fndecl 0 28593 NULL
+disable_so_crypto_authenc_decrypt_fndecl_28596 crypto_authenc_decrypt fndecl 0 28596 NULL
+disable_so_addr_starfire_tx_desc_2_28603 addr starfire_tx_desc_2 0 28603 NULL
+disable_so___rhashtable_insert_fast_fndecl_28605 __rhashtable_insert_fast fndecl 0 28605 NULL
+disable_so_addr_cp_desc_28611 addr cp_desc 0 28611 NULL
+disable_so_ic_pause_timer_mtip_port_28612 ic_pause_timer mtip_port 0 28612 NULL nohasharray
+disable_so_bitmap_checkfree_fndecl_28612 bitmap_checkfree fndecl 2 28612 &disable_so_ic_pause_timer_mtip_port_28612
+disable_so_ac_utimescaled_taskstats_28613 ac_utimescaled taskstats 0 28613 NULL
+disable_so___subtree_last_umem_odp_node_28630 __subtree_last umem_odp_node 0 28630 NULL
+disable_so_i_ctime_bfs_inode_28632 i_ctime bfs_inode 0 28632 NULL
+disable_so_s_def_resgid_ext4_super_block_28638 s_def_resgid ext4_super_block 0 28638 NULL
+disable_so_addr_alert_data_28639 addr alert_data 0 28639 NULL
+disable_so_p_vaddr_elf32_phdr_28641 p_vaddr elf32_phdr 0 28641 NULL
+disable_so_kv_set_divider_value_fndecl_28644 kv_set_divider_value fndecl 3-0 28644 NULL
+disable_so_bitmap_clear_fndecl_28646 bitmap_clear fndecl 2-3 28646 NULL
+disable_so_uartlite_inle32_fndecl_28652 uartlite_inle32 fndecl 0 28652 NULL
+disable_so_kvm_hv_vapic_msr_write_fndecl_28670 kvm_hv_vapic_msr_write fndecl 3 28670 NULL
+disable_so_sgl_addr_fcpio_icmnd_16_28672 sgl_addr fcpio_icmnd_16 0 28672 NULL
+disable_so_timestamp_bfa_trc_s_28675 timestamp bfa_trc_s 0 28675 NULL
+disable_so_xbofs_delay_irda_skb_cb_28676 xbofs_delay irda_skb_cb 0 28676 NULL
+disable_so_hpfs_map_bitmap_fndecl_28681 hpfs_map_bitmap fndecl 2 28681 NULL
+disable_so_tz_minuteswest_timezone_28688 tz_minuteswest timezone 0 28688 NULL
+disable_so_pc_clock_settime_fndecl_28698 pc_clock_settime fndecl 1 28698 NULL
+disable_so_orinoco_hw_get_freq_fndecl_28700 orinoco_hw_get_freq fndecl 0 28700 NULL
+disable_so_phys_addr_megasas_sge32_28701 phys_addr megasas_sge32 0 28701 NULL
+disable_so_tusb_otg_ints_fndecl_28728 tusb_otg_ints fndecl 2 28728 NULL
+disable_so_dynamic_ps_forced_timeout_ieee80211_local_28729 dynamic_ps_forced_timeout ieee80211_local 0 28729 NULL
+disable_so_atomic_notifier_call_chain_fndecl_28732 atomic_notifier_call_chain fndecl 0-2 28732 NULL
+disable_so_time_ext_busy_survey_info_28734 time_ext_busy survey_info 0 28734 NULL
+disable_so___audit_signal_info_fndecl_28736 __audit_signal_info fndecl 0-1 28736 NULL
+disable_so_SYSC_mq_timedsend_fndecl_28740 SYSC_mq_timedsend fndecl 1-3 28740 NULL
+disable_so_gss_krb5_aes_decrypt_fndecl_28742 gss_krb5_aes_decrypt fndecl 0-2 28742 NULL
+disable_so_sys_clock_getres_fndecl_28754 sys_clock_getres fndecl 1 28754 NULL
+disable_so_addr_max8997_muic_reg_data_28757 addr max8997_muic_reg_data 0 28757 NULL
+disable_so_address_floppy_fdc_state_28762 address floppy_fdc_state 0 28762 NULL
+disable_so_btrfs_uuid_tree_add_fndecl_28765 btrfs_uuid_tree_add fndecl 0-4-5 28765 NULL
+disable_so_default_radio_freq_vardecl_pvrusb2_hdw_c_28767 default_radio_freq vardecl_pvrusb2-hdw.c 0 28767 NULL
+disable_so_ac_stime_pacct_struct_28773 ac_stime pacct_struct 0 28773 NULL
+disable_so___btree_submit_bio_start_fndecl_28775 __btree_submit_bio_start fndecl 0 28775 NULL
+disable_so_add_new_bitmap_fndecl_28783 add_new_bitmap fndecl 3 28783 NULL
+disable_so_cinblock_signal_struct_28789 cinblock signal_struct 0 28789 NULL
+disable_so_bd_list_addr_hi_bnx2i_logout_request_28791 bd_list_addr_hi bnx2i_logout_request 0 28791 NULL
+disable_so_tv_freq_bttv_28796 tv_freq bttv 0 28796 NULL
+disable_so___btrfs_run_delayed_items_fndecl_28804 __btrfs_run_delayed_items fndecl 0-3 28804 NULL nohasharray
+disable_so_dst_addr_dma_slave_config_28804 dst_addr dma_slave_config 0 28804 &disable_so___btrfs_run_delayed_items_fndecl_28804
+disable_so_xfs_bitmap_empty_fndecl_28805 xfs_bitmap_empty fndecl 2 28805 NULL
+disable_so_btrfs_alloc_delayed_item_fndecl_28813 btrfs_alloc_delayed_item fndecl 1 28813 NULL
+disable_so_virtio32_to_cpu_fndecl_28839 virtio32_to_cpu fndecl 0-2 28839 NULL
+disable_so_random_frame_fusbh200_hcd_28840 random_frame fusbh200_hcd 0 28840 NULL
+disable_so_wl1273_fm_set_tx_freq_fndecl_28841 wl1273_fm_set_tx_freq fndecl 2 28841 NULL nohasharray
+disable_so_rip_kvm_regs_28841 rip kvm_regs 0 28841 &disable_so_wl1273_fm_set_tx_freq_fndecl_28841
+disable_so_last_capture_dmaaddr_es1938_28843 last_capture_dmaaddr es1938 0 28843 NULL
+disable_so_mic_is_system_addr_fndecl_28851 mic_is_system_addr fndecl 2 28851 NULL
+disable_so_sst_module_runtime_new_fndecl_28861 sst_module_runtime_new fndecl 2 28861 NULL
+disable_so_nat_blkaddr_f2fs_nm_info_28862 nat_blkaddr f2fs_nm_info 0 28862 NULL
+disable_so_ustrtoul_fndecl_28866 ustrtoul fndecl 0 28866 NULL
+disable_so_tomoyo_write_log2_fndecl_28871 tomoyo_write_log2 fndecl 2 28871 NULL
+disable_so_rate_snd_pcm_oss_runtime_28878 rate snd_pcm_oss_runtime 0 28878 NULL
+disable_so_cl_idle_timeout_ms_o2nm_cluster_28885 cl_idle_timeout_ms o2nm_cluster 0 28885 NULL
+disable_so_pc_clock_adjtime_fndecl_28892 pc_clock_adjtime fndecl 1 28892 NULL
+disable_so_mmc_power_cycle_fndecl_28894 mmc_power_cycle fndecl 2 28894 NULL
+disable_so_cpufreq_get_fndecl_28896 cpufreq_get fndecl 0-1 28896 NULL
+disable_so_ci_get_sleep_divider_id_from_clock_fndecl_28898 ci_get_sleep_divider_id_from_clock fndecl 2 28898 NULL
+disable_so_mmio_writel_intel_uncore_funcs_28903 mmio_writel intel_uncore_funcs 2-3 28903 NULL
+disable_so_cpufreq_stats_init_fndecl_28912 cpufreq_stats_init fndecl 0 28912 NULL
+disable_so_sbp_tpg_attrib_store_mgt_orb_timeout_fndecl_28914 sbp_tpg_attrib_store_mgt_orb_timeout fndecl 0-3 28914 NULL
+disable_so___virtio16_to_cpu_fndecl_28917 __virtio16_to_cpu fndecl 0-2 28917 NULL
+disable_so___pm_runtime_resume_fndecl_28918 __pm_runtime_resume fndecl 0 28918 NULL
+disable_so_task_setpgid_security_operations_28939 task_setpgid security_operations 2 28939 NULL
+disable_so_perf_event_set_clock_fndecl_28941 perf_event_set_clock fndecl 0 28941 NULL
+disable_so_sci_er_interrupt_fndecl_28944 sci_er_interrupt fndecl 1 28944 NULL
+disable_so_mmc_sdio_get_max_clock_fndecl_28945 mmc_sdio_get_max_clock fndecl 0 28945 NULL
+disable_so_dma_addr_cmdQ_28949 dma_addr cmdQ 0 28949 NULL
+disable_so_s_def_resuid_ext3_super_block_28958 s_def_resuid ext3_super_block 0 28958 NULL
+disable_so_init_timer_cpu_fndecl_28961 init_timer_cpu fndecl 2 28961 NULL
+disable_so_sst_hsw_dsp_runtime_suspend_fndecl_28962 sst_hsw_dsp_runtime_suspend fndecl 0 28962 NULL nohasharray
+disable_so_mem_busaddr_ahd_platform_data_28962 mem_busaddr ahd_platform_data 0 28962 &disable_so_sst_hsw_dsp_runtime_suspend_fndecl_28962
+disable_so_xen_setup_timer_fndecl_28968 xen_setup_timer fndecl 1 28968 NULL
+disable_so_vx_clock_mode_info_fndecl_28969 vx_clock_mode_info fndecl 0 28969 NULL
+disable_so_clk_frequency_csis_state_28987 clk_frequency csis_state 0 28987 NULL
+disable_so_cma_clear_bitmap_fndecl_28991 cma_clear_bitmap fndecl 2-3 28991 NULL
+disable_so_tg3_nvram_phys_addr_fndecl_28993 tg3_nvram_phys_addr fndecl 0-2 28993 NULL
+disable_so_ufshcd_init_clocks_fndecl_28995 ufshcd_init_clocks fndecl 0 28995 NULL nohasharray
+disable_so_ima_init_crypto_fndecl_28995 ima_init_crypto fndecl 0 28995 &disable_so_ufshcd_init_clocks_fndecl_28995
+disable_so_i2c_address_ts2020_priv_29002 i2c_address ts2020_priv 0 29002 NULL
+disable_so_gf_mul_fndecl_29007 gf_mul fndecl 0-3 29007 NULL
+disable_so_sys_geteuid_fndecl_29013 sys_geteuid fndecl 0 29013 NULL
+disable_so_do_one_acipher_op_fndecl_29014 do_one_acipher_op fndecl 0-2 29014 NULL
+disable_so_ssb_pmu_get_alp_clock_clk0_fndecl_29019 ssb_pmu_get_alp_clock_clk0 fndecl 0 29019 NULL
+disable_so_addr_ib_sge_29021 addr ib_sge 0 29021 NULL
+disable_so_rdi_kvm_regs_29022 rdi kvm_regs 0 29022 NULL
+disable_so_dma_subdivide_fndecl_29027 dma_subdivide fndecl 3-0 29027 NULL
+disable_so_nilfs_superblock_sb_write_time_secs_show_fndecl_29044 nilfs_superblock_sb_write_time_secs_show fndecl 0 29044 NULL
+disable_so_mlx4_ib_init_gid_table_fndecl_29049 mlx4_ib_init_gid_table fndecl 0 29049 NULL
+disable_so_xfs_bmap_add_attrfork_btree_fndecl_29052 xfs_bmap_add_attrfork_btree fndecl 0 29052 NULL
+disable_so_pcf2123_rtc_set_time_fndecl_29057 pcf2123_rtc_set_time fndecl 0 29057 NULL
+disable_so_vactive_hi_oaktrail_timing_info_29063 vactive_hi oaktrail_timing_info 0 29063 NULL
+disable_so_xfs_btree_lookup_fndecl_29066 xfs_btree_lookup fndecl 0 29066 NULL
+disable_so_si476x_core_cmd_fm_tune_freq_a20_fndecl_29072 si476x_core_cmd_fm_tune_freq_a20 fndecl 0 29072 NULL
+disable_so_hcd_pci_runtime_resume_fndecl_29073 hcd_pci_runtime_resume fndecl 0 29073 NULL
+disable_so_switch_time_wl12xx_cmd_channel_switch_29074 switch_time wl12xx_cmd_channel_switch 0 29074 NULL
+disable_so_ata_internal_cmd_timeout_fndecl_29075 ata_internal_cmd_timeout fndecl 0-2 29075 NULL nohasharray
+disable_so_hash_shift_flow_cache_29075 hash_shift flow_cache 0 29075 &disable_so_ata_internal_cmd_timeout_fndecl_29075
+disable_so_timeout_sg_io_v4_29079 timeout sg_io_v4 0 29079 NULL
+disable_so___btrfs_add_delayed_insertion_item_fndecl_29083 __btrfs_add_delayed_insertion_item fndecl 0 29083 NULL
+disable_so_bn_nchildren_nilfs_btree_node_29084 bn_nchildren nilfs_btree_node 0 29084 NULL
+disable_so_jiffies_vardecl_29085 jiffies vardecl 0 29085 NULL
+disable_so_frag_count_ct_timer_instance_29091 frag_count ct_timer_instance 0 29091 NULL
+disable_so_ref_start_vardecl_tsc_c_29097 ref_start vardecl_tsc.c 0 29097 NULL
+disable_so_timeout_ms_cm_id_private_29104 timeout_ms cm_id_private 0 29104 NULL
+disable_so_nfulnl_set_timeout_fndecl_29106 nfulnl_set_timeout fndecl 2 29106 NULL nohasharray
+disable_so_addr_high_lancer_cmd_req_write_object_29106 addr_high lancer_cmd_req_write_object 0 29106 &disable_so_nfulnl_set_timeout_fndecl_29106
+disable_so_i_mtime_exofs_fcb_29107 i_mtime exofs_fcb 0 29107 NULL
+disable_so_ss_pt_regs_29109 ss pt_regs 0 29109 NULL
+disable_so_ivsize_ablkcipher_alg_29115 ivsize ablkcipher_alg 0 29115 NULL
+disable_so_signal_strength_rx_status_29125 signal_strength rx_status 0 29125 NULL
+disable_so_radio_rx_freq_vivid_dev_29126 radio_rx_freq vivid_dev 0 29126 NULL
+disable_so_io_virtual_address_ib_pool_fmr_29135 io_virtual_address ib_pool_fmr 0 29135 NULL
+disable_so_addr_low_mcp_kreq_ether_send_29138 addr_low mcp_kreq_ether_send 0 29138 NULL
+disable_so_pad_bits_bitstream_29149 pad_bits bitstream 0 29149 NULL
+disable_so_clockdiv_sd_29154 clockdiv sd 0 29154 NULL
+disable_so_retu_wdt_set_timeout_fndecl_29155 retu_wdt_set_timeout fndecl 2-0 29155 NULL nohasharray
+disable_so_hw_roc_start_time_ieee80211_local_29155 hw_roc_start_time ieee80211_local 0 29155 &disable_so_retu_wdt_set_timeout_fndecl_29155
+disable_so_set_ip_addr_fndecl_29159 set_ip_addr fndecl 4 29159 NULL nohasharray
+disable_so_hsync_offset_hi_oaktrail_timing_info_29159 hsync_offset_hi oaktrail_timing_info 0 29159 &disable_so_set_ip_addr_fndecl_29159
+disable_so_valid_phys_addr_range_fndecl_29163 valid_phys_addr_range fndecl 2 29163 NULL
+disable_so_hsw_compute_linetime_wm_fndecl_29166 hsw_compute_linetime_wm fndecl 0 29166 NULL
+disable_so_set_frontend_jiffies_af9013_state_29174 set_frontend_jiffies af9013_state 0 29174 NULL
+disable_so_max_schedule_delay_balloon_stats_29176 max_schedule_delay balloon_stats 0 29176 NULL
+disable_so_matroxfb_mavenclock_fndecl_29182 matroxfb_mavenclock fndecl 2-3 29182 NULL
+disable_so_rrq_stop_time_lpfc_node_rrq_29187 rrq_stop_time lpfc_node_rrq 0 29187 NULL
+disable_so_can_ifindex_sockaddr_can_29188 can_ifindex sockaddr_can 0 29188 NULL
+disable_so_time_hi_and_version_afs_uuid_29192 time_hi_and_version afs_uuid 0 29192 NULL
+disable_so_inode_bitmap_ext4_new_group_data_29195 inode_bitmap ext4_new_group_data 0 29195 NULL
+disable_so_madc_aic31xx_rate_divs_29206 madc aic31xx_rate_divs 0 29206 NULL
+disable_so_i_mtime_ext3_inode_29219 i_mtime ext3_inode 0 29219 NULL
+disable_so_ccp_aes_cmac_finup_fndecl_29220 ccp_aes_cmac_finup fndecl 0 29220 NULL
+disable_so_listen_time_ath5k_ani_state_29228 listen_time ath5k_ani_state 0 29228 NULL
+disable_so_di_mtime_gfs2_dinode_29230 di_mtime gfs2_dinode 0 29230 NULL nohasharray
+disable_so_snd_pcm_hw_rule_mulkdiv_fndecl_29230 snd_pcm_hw_rule_mulkdiv fndecl 0 29230 &disable_so_di_mtime_gfs2_dinode_29230
+disable_so_qlcnic_get_ioaddr_fndecl_29235 qlcnic_get_ioaddr fndecl 2 29235 NULL
+disable_so_si476x_radio_s_hw_freq_seek_fndecl_29237 si476x_radio_s_hw_freq_seek fndecl 0 29237 NULL
+disable_so_SiS_SetRegANDOR_fndecl_29240 SiS_SetRegANDOR fndecl 2-3-5-4 29240 NULL
+disable_so_dev_wait_time_esas2r_sas_nvram_29244 dev_wait_time esas2r_sas_nvram 0 29244 NULL
+disable_so_b44_recycle_rx_fndecl_29255 b44_recycle_rx fndecl 2-3 29255 NULL
+disable_so_max_state_devfreq_dev_profile_29257 max_state devfreq_dev_profile 0 29257 NULL
+disable_so_freq_std_sccnxp_chip_29265 freq_std sccnxp_chip 0 29265 NULL nohasharray
+disable_so___ipv6_addr_diff32_fndecl_29265 __ipv6_addr_diff32 fndecl 0 29265 &disable_so_freq_std_sccnxp_chip_29265
+disable_so_kvm_max_guest_tsc_khz_vardecl_29276 kvm_max_guest_tsc_khz vardecl 0 29276 NULL
+disable_so_ioaddr_velocity_info_29278 ioaddr velocity_info 0 29278 NULL
+disable_so_last_rx_time_xenvif_queue_29307 last_rx_time xenvif_queue 0 29307 NULL
+disable_so_expires_timeriomem_rng_private_data_29310 expires timeriomem_rng_private_data 0 29310 NULL nohasharray
+disable_so_dev_sound_lowlev_timer_29310 dev sound_lowlev_timer 0 29310 &disable_so_expires_timeriomem_rng_private_data_29310
+disable_so_btrfs_set_inode_gid_fndecl_29338 btrfs_set_inode_gid fndecl 3 29338 NULL
+disable_so_i2c_clock_speed_i2c_pca9564_pf_platform_data_29345 i2c_clock_speed i2c_pca9564_pf_platform_data 0 29345 NULL nohasharray
+disable_so_pci_bus_read_config_dword_fndecl_29345 pci_bus_read_config_dword fndecl 0-2-3 29345 &disable_so_i2c_clock_speed_i2c_pca9564_pf_platform_data_29345
+disable_so_adav80x_set_adc_clock_fndecl_29348 adav80x_set_adc_clock fndecl 2 29348 NULL
+disable_so_mod_size_ccp_rsa_op_29350 mod_size ccp_rsa_op 0 29350 NULL
+disable_so_iscsit_na_random_r2t_offsets_fndecl_29363 iscsit_na_random_r2t_offsets fndecl 0 29363 NULL nohasharray
+disable_so_buf_addr_lo_mv_u3d_trb_hw_29363 buf_addr_lo mv_u3d_trb_hw 0 29363 &disable_so_iscsit_na_random_r2t_offsets_fndecl_29363
+disable_so_smsc75xx_set_mac_address_fndecl_29364 smsc75xx_set_mac_address fndecl 0 29364 NULL
+disable_so_m88rs6000t_set_pll_freq_fndecl_29365 m88rs6000t_set_pll_freq fndecl 0-2 29365 NULL
+disable_so_scaled_div_fndecl_29370 scaled_div fndecl 0-1-2 29370 NULL
+disable_so_rtsc_y2x_fndecl_29372 rtsc_y2x fndecl 0-2 29372 NULL
+disable_so_uart_update_timeout_fndecl_29380 uart_update_timeout fndecl 3-2 29380 NULL
+disable_so_dbuf_addr_ath6kl_dbglog_hdr_29381 dbuf_addr ath6kl_dbglog_hdr 0 29381 NULL
+disable_so_sample_rate_div_inv_mpu6050_reg_map_29386 sample_rate_div inv_mpu6050_reg_map 0 29386 NULL nohasharray
+disable_so_ath10k_ce_dest_ring_base_addr_set_fndecl_29386 ath10k_ce_dest_ring_base_addr_set fndecl 3 29386 &disable_so_sample_rate_div_inv_mpu6050_reg_map_29386
+disable_so_nla_parse_nested_fndecl_29395 nla_parse_nested fndecl 2-0 29395 NULL
+disable_so___sched_setscheduler_fndecl_29397 __sched_setscheduler fndecl 0 29397 NULL
+disable_so_add_atomic_switch_msr_special_fndecl_29400 add_atomic_switch_msr_special fndecl 6-7 29400 NULL
+disable_so___xfrm_spi_hash_fndecl_29403 __xfrm_spi_hash fndecl 0-2-3-4-5 29403 NULL
+disable_so_ceph_decode_pgid_fndecl_29407 ceph_decode_pgid fndecl 0 29407 NULL
+disable_so_loc_addr_nes_cm_info_29413 loc_addr nes_cm_info 0 29413 NULL
+disable_so_kxcjk1013_convert_freq_to_bit_fndecl_29417 kxcjk1013_convert_freq_to_bit fndecl 0 29417 NULL
+disable_so_exec_clock_cfs_rq_29423 exec_clock cfs_rq 0 29423 NULL
+disable_so_irst_show_wakeup_time_fndecl_29431 irst_show_wakeup_time fndecl 0 29431 NULL nohasharray
+disable_so_macb_interrupt_fndecl_29431 macb_interrupt fndecl 1 29431 &disable_so_irst_show_wakeup_time_fndecl_29431
+disable_so_crypto_register_notifier_fndecl_29432 crypto_register_notifier fndecl 0 29432 NULL nohasharray
+disable_so_shash_compat_setkey_fndecl_29432 shash_compat_setkey fndecl 0-3 29432 &disable_so_crypto_register_notifier_fndecl_29432
+disable_so_pwm_freq_div_dib8000_config_29434 pwm_freq_div dib8000_config 0 29434 NULL
+disable_so_ds1305_set_time_fndecl_29436 ds1305_set_time fndecl 0 29436 NULL
+disable_so_add_sctp_bind_addr_fndecl_29438 add_sctp_bind_addr fndecl 0-3 29438 NULL
+disable_so___virtio32_to_cpu_fndecl_29440 __virtio32_to_cpu fndecl 0-2 29440 NULL
+disable_so_phonet_address_lookup_fndecl_29442 phonet_address_lookup fndecl 2 29442 NULL
+disable_so_max_timeout_rc_dev_29444 max_timeout rc_dev 0 29444 NULL
+disable_so_address_lo_ips_enh_sglist_29453 address_lo ips_enh_sglist 0 29453 NULL
+disable_so_cdrom_is_random_writable_fndecl_29454 cdrom_is_random_writable fndecl 0 29454 NULL
+disable_so_devblksize_log2_squashfs_sb_info_29455 devblksize_log2 squashfs_sb_info 0 29455 NULL
+disable_so_ps_pspoll_timeouts_read_fndecl_29459 ps_pspoll_timeouts_read fndecl 3-0 29459 NULL
+disable_so_kvm_apic_has_interrupt_fndecl_29462 kvm_apic_has_interrupt fndecl 0 29462 NULL
+disable_so_max6902_read_time_fndecl_29464 max6902_read_time fndecl 0 29464 NULL
+disable_so_get_bit_address_fndecl_29473 get_bit_address fndecl 2 29473 NULL
+disable_so_last_sample_time_vardecl_smscoreapi_c_29477 last_sample_time vardecl_smscoreapi.c 0 29477 NULL nohasharray
+disable_so_btree_readahead_hook_fndecl_29477 btree_readahead_hook fndecl 3-4 29477 &disable_so_last_sample_time_vardecl_smscoreapi_c_29477
+disable_so_final_crypto_ahash_29478 final crypto_ahash 0 29478 NULL
+disable_so_sum_sched_runtime_signal_struct_29480 sum_sched_runtime signal_struct 0 29480 NULL
+disable_so_status_addr_req_29482 status addr_req 0 29482 NULL
+disable_so_micd_dbtime_arizona_pdata_29495 micd_dbtime arizona_pdata 0 29495 NULL
+disable_so_tqi_burst_time_ath5k_txq_info_29499 tqi_burst_time ath5k_txq_info 0 29499 NULL
+disable_so_rs5c372_rtc_read_time_fndecl_29505 rs5c372_rtc_read_time fndecl 0 29505 NULL
+disable_so_pi_write_regr_fndecl_29517 pi_write_regr fndecl 4 29517 NULL
+disable_so_used_cells_ti_tscadc_dev_29522 used_cells ti_tscadc_dev 0 29522 NULL
+disable_so_delay_to_eeprom_index_fndecl_29523 delay_to_eeprom_index fndecl 1 29523 NULL
+disable_so_devfreq_event_get_edev_count_fndecl_29524 devfreq_event_get_edev_count fndecl 0 29524 NULL
+disable_so_pci_enable_msix_range_fndecl_29535 pci_enable_msix_range fndecl 0-4-3 29535 NULL
+disable_so_last_stats_time_ocrdma_dev_29544 last_stats_time ocrdma_dev 0 29544 NULL
+disable_so_sb_c_bitmap_hpfs_sb_info_29558 sb_c_bitmap hpfs_sb_info 0 29558 NULL
+disable_so_submit_time_us_bbio_29575 submit_time_us bbio 0 29575 NULL
+disable_so_bitmap_remap_fndecl_29578 bitmap_remap fndecl 5 29578 NULL
+disable_so_ath_force_no_ir_freq_fndecl_29580 ath_force_no_ir_freq fndecl 2 29580 NULL
+disable_so_time_slice_start_ieee80211_sta_tx_tspec_29586 time_slice_start ieee80211_sta_tx_tspec 0 29586 NULL
+disable_so_mlx4_get_roce_gid_from_slave_fndecl_29587 mlx4_get_roce_gid_from_slave fndecl 2-3 29587 NULL
+disable_so_signalfd_read_fndecl_29589 signalfd_read fndecl 0 29589 NULL
+disable_so_iscsi_nacl_attrib_show_random_datain_seq_offsets_fndecl_29602 iscsi_nacl_attrib_show_random_datain_seq_offsets fndecl 0 29602 NULL
+disable_so_it913x_sleep_fndecl_29615 it913x_sleep fndecl 0 29615 NULL
+disable_so_phy_addr_external_netdev_private_29618 phy_addr_external netdev_private 0 29618 NULL
+disable_so_ssb_clockspeed_fndecl_29627 ssb_clockspeed fndecl 0 29627 NULL
+disable_so_tx_int_delay_e1000_adapter_29628 tx_int_delay e1000_adapter 0 29628 NULL
+disable_so_qlcnic_83xx_idc_check_timeout_fndecl_29633 qlcnic_83xx_idc_check_timeout fndecl 0 29633 NULL
+disable_so_tegra_wdt_get_timeleft_fndecl_29649 tegra_wdt_get_timeleft fndecl 0 29649 NULL
+disable_so_get_intermediate_cpufreq_driver_29653 get_intermediate cpufreq_driver 0 29653 NULL
+disable_so_lpfc_debugfs_start_time_vardecl_lpfc_debugfs_c_29655 lpfc_debugfs_start_time vardecl_lpfc_debugfs.c 0 29655 NULL
+disable_so_check_addr_fndecl_29658 check_addr fndecl 3-4 29658 NULL
+disable_so_irlap_start_poll_timer_fndecl_29663 irlap_start_poll_timer fndecl 2 29663 NULL nohasharray
+disable_so_mlx5_query_node_guid_fndecl_29663 mlx5_query_node_guid fndecl 0 29663 &disable_so_irlap_start_poll_timer_fndecl_29663
+disable_so_read_addr_qla8044_minidump_entry_rdrom_29676 read_addr qla8044_minidump_entry_rdrom 0 29676 NULL nohasharray
+disable_so_to_addr_param_sctp_af_29676 to_addr_param sctp_af 0 29676 &disable_so_read_addr_qla8044_minidump_entry_rdrom_29676
+disable_so_buf_addr_mlx4_ib_create_cq_29678 buf_addr mlx4_ib_create_cq 0 29678 NULL
+disable_so_forward_delay_timer_value___port_info_29680 forward_delay_timer_value __port_info 0 29680 NULL
+disable_so_packet_life_time_ib_sa_mcmember_rec_29682 packet_life_time ib_sa_mcmember_rec 0 29682 NULL
+disable_so_batadv_hash_dat_fndecl_29684 batadv_hash_dat fndecl 0-2 29684 NULL
+disable_so_qxl_bo_physical_address_fndecl_29696 qxl_bo_physical_address fndecl 0-3 29696 NULL
+disable_so_hspi_status_check_timeout_fndecl_29712 hspi_status_check_timeout fndecl 0 29712 NULL
+disable_so_nes_addr_resolve_neigh_fndecl_29717 nes_addr_resolve_neigh fndecl 0-2-3 29717 NULL
+disable_so_hash2pos_fndecl_29725 hash2pos fndecl 0-2-3 29725 NULL
+disable_so_bcma_chipco_watchdog_timer_set_fndecl_29730 bcma_chipco_watchdog_timer_set fndecl 2-0 29730 NULL
+disable_so_hor_addr_via_display_timing_29736 hor_addr via_display_timing 0 29736 NULL
+disable_so_ceph_str_hash_fndecl_29742 ceph_str_hash fndecl 0-3 29742 NULL
+disable_so_qla2x00_gid_pt_fndecl_29752 qla2x00_gid_pt fndecl 0 29752 NULL nohasharray
+disable_so_ocfs2_xattr_name_hash_fndecl_29752 ocfs2_xattr_name_hash fndecl 0-3 29752 &disable_so_qla2x00_gid_pt_fndecl_29752
+disable_so_kstrtouint_from_user_fndecl_29755 kstrtouint_from_user fndecl 0-2 29755 NULL
+disable_so_get_timeout_clock_sdhci_ops_29760 get_timeout_clock sdhci_ops 0 29760 NULL nohasharray
+disable_so_curfreq_raremono_device_29760 curfreq raremono_device 0 29760 &disable_so_get_timeout_clock_sdhci_ops_29760
+disable_so_send_time_batadv_forw_packet_29762 send_time batadv_forw_packet 0 29762 NULL
+disable_so_ms_brcms_timer_29763 ms brcms_timer 0 29763 NULL nohasharray
+disable_so_lp872x_get_timestep_usec_fndecl_29763 lp872x_get_timestep_usec fndecl 0 29763 &disable_so_ms_brcms_timer_29763
+disable_so_bmap_address_space_operations_29766 bmap address_space_operations 2 29766 NULL
+disable_so_ds1390_set_time_fndecl_29768 ds1390_set_time fndecl 0 29768 NULL
+disable_so_release_jiffies_dvb_frontend_private_29775 release_jiffies dvb_frontend_private 0 29775 NULL
+disable_so_hsw_pcm_runtime_resume_fndecl_29777 hsw_pcm_runtime_resume fndecl 0 29777 NULL
+disable_so_pcan_usb_set_bittiming_fndecl_29781 pcan_usb_set_bittiming fndecl 0 29781 NULL
+disable_so_pmcraid_disable_interrupts_fndecl_29788 pmcraid_disable_interrupts fndecl 2 29788 NULL
+disable_so_bit_line_usb_fifo_29792 bit_line usb_fifo 0 29792 NULL
+disable_so_hash_name_fndecl_29814 hash_name fndecl 0 29814 NULL
+disable_so_t4vf_set_addr_hash_fndecl_29821 t4vf_set_addr_hash fndecl 0-2 29821 NULL
+disable_so_bit_length_acpi_object_region_field_29824 bit_length acpi_object_region_field 0 29824 NULL
+disable_so_native_read_tsc_fndecl_29825 native_read_tsc fndecl 0 29825 NULL
+disable_so_sha256_base_do_update_fndecl_29849 sha256_base_do_update fndecl 3 29849 NULL
+disable_so_timeout_ip_vs_conn_29852 timeout ip_vs_conn 0 29852 NULL
+disable_so_conn_db_addr_hi_fcoe_kwqe_conn_offload2_29864 conn_db_addr_hi fcoe_kwqe_conn_offload2 0 29864 NULL
+disable_so_timeout_type_timeout_parms_29877 timeout_type timeout_parms 0 29877 NULL
+disable_so_arch_apei_filter_addr_vardecl_29884 arch_apei_filter_addr vardecl 0 29884 NULL
+disable_so_crypto_shash_import_fndecl_29885 crypto_shash_import fndecl 0 29885 NULL
+disable_so_ktime_get_ns_fndecl_29890 ktime_get_ns fndecl 0 29890 NULL
+disable_so_store_scaling_min_freq_fndecl_29892 store_scaling_min_freq fndecl 0-3 29892 NULL
+disable_so_nfsd_map_name_to_uid_fndecl_29920 nfsd_map_name_to_uid fndecl 0 29920 NULL
+disable_so_min_interrupt_in_interval_vardecl_ldusb_c_29924 min_interrupt_in_interval vardecl_ldusb.c 0 29924 NULL
+disable_so_cdv_intel_clock_fndecl_29931 cdv_intel_clock fndecl 1 29931 NULL
+disable_so_di_mtime_efs_dinode_29934 di_mtime efs_dinode 0 29934 NULL nohasharray
+disable_so_hpet_freq_vardecl_hpet_c_29934 hpet_freq vardecl_hpet.c 0 29934 &disable_so_di_mtime_efs_dinode_29934
+disable_so_shash_async_setkey_fndecl_29939 shash_async_setkey fndecl 0-3 29939 NULL
+disable_so_qs_btimelimit_fs_quota_statv_29943 qs_btimelimit fs_quota_statv 0 29943 NULL
+disable_so_addr_mpr121_init_register_29945 addr mpr121_init_register 0 29945 NULL
+disable_so_pixelclock_v4l2_bt_timings_29967 pixelclock v4l2_bt_timings 0 29967 NULL
+disable_so_spi_imx_clkdiv_2_fndecl_29968 spi_imx_clkdiv_2 fndecl 1-2 29968 NULL
+disable_so_ed_uuid_drbd_device_29970 ed_uuid drbd_device 0 29970 NULL
+disable_so_timestamp_nfs_release_lockowner_data_29972 timestamp nfs_release_lockowner_data 0 29972 NULL
+disable_so_smp_send_reschedule_smp_ops_29981 smp_send_reschedule smp_ops 1 29981 NULL
+disable_so_lm3533_led_delay_set_fndecl_29984 lm3533_led_delay_set fndecl 0-2 29984 NULL
+disable_so_rx_errors_rtnl_link_stats64_29988 rx_errors rtnl_link_stats64 0 29988 NULL
+disable_so_fm10k_read_reg_fndecl_29989 fm10k_read_reg fndecl 0-2 29989 NULL
+disable_so_timeout_jiffies_tifm_ms_29995 timeout_jiffies tifm_ms 0 29995 NULL nohasharray
+disable_so_confq_pbl_base_addr_hi_fcoe_kwqe_conn_offload4_29995 confq_pbl_base_addr_hi fcoe_kwqe_conn_offload4 0 29995 &disable_so_timeout_jiffies_tifm_ms_29995
+disable_so_wait_on_bit_lock_fndecl_30009 wait_on_bit_lock fndecl 0 30009 NULL
+disable_so_rx8025_get_clock_adjust_fndecl_30011 rx8025_get_clock_adjust fndecl 0 30011 NULL
+disable_so_sem_ctime_sem_array_30014 sem_ctime sem_array 0 30014 NULL
+disable_so_sleep_mask_bma180_part_info_30016 sleep_mask bma180_part_info 0 30016 NULL
+disable_so_demod_address_zl10353_config_30017 demod_address zl10353_config 0 30017 NULL
+disable_so_msr_amixer_desc_30027 msr amixer_desc 0 30027 NULL
+disable_so_diolan_usb_transfer_fndecl_30033 diolan_usb_transfer fndecl 0 30033 NULL
+disable_so_mlx4_get_slave_from_roce_gid_fndecl_30035 mlx4_get_slave_from_roce_gid fndecl 2 30035 NULL
+disable_so_or51211_read_signal_strength_fndecl_30044 or51211_read_signal_strength fndecl 0 30044 NULL
+disable_so_panel_power_up_delay_intel_dp_30048 panel_power_up_delay intel_dp 0 30048 NULL
+disable_so_bit_bmove_fndecl_30057 bit_bmove fndecl 3-4-5-6-7-8 30057 NULL
+disable_so_posix_cpu_clock_getres_fndecl_30065 posix_cpu_clock_getres fndecl 1 30065 NULL
+disable_so_ktime_divns_fndecl_30067 ktime_divns fndecl 0-2 30067 NULL
+disable_so_vsync_offset_hi_oaktrail_timing_info_30079 vsync_offset_hi oaktrail_timing_info 0 30079 NULL
+disable_so_msr_host_kernel_gs_base_vcpu_vmx_30082 msr_host_kernel_gs_base vcpu_vmx 0 30082 NULL
+disable_so_r6d_val_fc2580_freq_regs_30084 r6d_val fc2580_freq_regs 0 30084 NULL
+disable_so_qlcnic_pci_get_crb_addr_2M_fndecl_30093 qlcnic_pci_get_crb_addr_2M fndecl 2 30093 NULL
+disable_so_btrfs_commit_inode_delayed_items_fndecl_30109 btrfs_commit_inode_delayed_items fndecl 0 30109 NULL
+disable_so_usec_delay_e1000_mbx_info_30132 usec_delay e1000_mbx_info 0 30132 NULL
+disable_so_inet6_rtm_getaddr_fndecl_30136 inet6_rtm_getaddr fndecl 0 30136 NULL
+disable_so_busaddr_reply_queue_buffer_30140 busaddr reply_queue_buffer 0 30140 NULL
+disable_so_show_pwm_auto_spinup_time_fndecl_30149 show_pwm_auto_spinup_time fndecl 0 30149 NULL
+disable_so_addr_rds_iovec_30161 addr rds_iovec 0 30161 NULL
+disable_so___nlm_hash_addr4_fndecl_30164 __nlm_hash_addr4 fndecl 0 30164 NULL
+disable_so_ctime_cs_msdos_dir_entry_30167 ctime_cs msdos_dir_entry 0 30167 NULL
+disable_so_next_otg_timer_ci_hdrc_30174 next_otg_timer ci_hdrc 0 30174 NULL
+disable_so_select_addr_qla82xx_md_entry_mux_30183 select_addr qla82xx_md_entry_mux 0 30183 NULL
+disable_so_qi_itimelimit_xfs_quotainfo_30196 qi_itimelimit xfs_quotainfo 0 30196 NULL
+disable_so_iowrite32_fndecl_30197 iowrite32 fndecl 1 30197 NULL
+disable_so_hash_ipportip6_expire_fndecl_30205 hash_ipportip6_expire fndecl 4 30205 NULL
+disable_so_argument_acpi_signal_fatal_info_30208 argument acpi_signal_fatal_info 0 30208 NULL
+disable_so_btree_write_cache_pages_fndecl_30231 btree_write_cache_pages fndecl 0 30231 NULL
+disable_so_clock_audioformat_30236 clock audioformat 0 30236 NULL
+disable_so_to_retries_rpc_timeout_30265 to_retries rpc_timeout 0 30265 NULL
+disable_so_last_moder_jiffies_mlx4_en_priv_30269 last_moder_jiffies mlx4_en_priv 0 30269 NULL nohasharray
+disable_so_vivid_radio_rx_s_hw_freq_seek_fndecl_30269 vivid_radio_rx_s_hw_freq_seek fndecl 0 30269 &disable_so_last_moder_jiffies_mlx4_en_priv_30269
+disable_so_start_empty_time_cfqg_stats_30276 start_empty_time cfqg_stats 0 30276 NULL nohasharray
+disable_so_i2c_addr_dib7000m_state_30276 i2c_addr dib7000m_state 0 30276 &disable_so_start_empty_time_cfqg_stats_30276
+disable_so_ext_phy_addr_amd8111e_priv_30286 ext_phy_addr amd8111e_priv 0 30286 NULL
+disable_so___account_cfs_rq_runtime_fndecl_30291 __account_cfs_rq_runtime fndecl 2 30291 NULL
+disable_so_snd_pcm_delay_fndecl_30298 snd_pcm_delay fndecl 0 30298 NULL
+disable_so_lpfc_cr_delay_store_fndecl_30310 lpfc_cr_delay_store fndecl 0 30310 NULL
+disable_so_uartlite_outbe32_fndecl_30324 uartlite_outbe32 fndecl 1 30324 NULL
+disable_so_intel_runtime_resume_fndecl_30334 intel_runtime_resume fndecl 0 30334 NULL
+disable_so_hv_tsc_page_kvm_arch_30336 hv_tsc_page kvm_arch 0 30336 NULL
+disable_so_snprintf_int_array_fndecl_30344 snprintf_int_array fndecl 2 30344 NULL
+disable_so___hw_addr_sync_one_fndecl_30350 __hw_addr_sync_one fndecl 0-3 30350 NULL
+disable_so_tuner_addr_em28xx_board_30367 tuner_addr em28xx_board 0 30367 NULL
+disable_so_stat_params_addr_hi_fcoe_kwqe_stat_30370 stat_params_addr_hi fcoe_kwqe_stat 0 30370 NULL
+disable_so_tv_hsync_delay2_nv04_crtc_reg_30375 tv_hsync_delay2 nv04_crtc_reg 0 30375 NULL
+disable_so_wlc_phy_table_addr_fndecl_30378 wlc_phy_table_addr fndecl 2-3-4-5-6 30378 NULL
+disable_so_rsa_setkey_fndecl_30386 rsa_setkey fndecl 3 30386 NULL
+disable_so_bcma_pmu_get_alp_clock_fndecl_30397 bcma_pmu_get_alp_clock fndecl 0 30397 NULL
+disable_so_timeout_nft_set_30398 timeout nft_set 0 30398 NULL
+disable_so_cm_create_timewait_info_fndecl_30403 cm_create_timewait_info fndecl 1 30403 NULL
+disable_so_start_time_bfa_diag_dport_result_s_30404 start_time bfa_diag_dport_result_s 0 30404 NULL
+disable_so_fw_schedule_bm_work_fndecl_30422 fw_schedule_bm_work fndecl 2 30422 NULL
+disable_so_xs_get_random_port_fndecl_30424 xs_get_random_port fndecl 0 30424 NULL
+disable_so_ba0_addr_snd_cs46xx_30426 ba0_addr snd_cs46xx 0 30426 NULL
+disable_so_rx_interframe_timeout_wil6210_priv_30430 rx_interframe_timeout wil6210_priv 0 30430 NULL
+disable_so_xfs_uuid_mount_fndecl_30439 xfs_uuid_mount fndecl 0 30439 NULL nohasharray
+disable_so_avtab_hash_fndecl_30439 avtab_hash fndecl 0-2 30439 &disable_so_xfs_uuid_mount_fndecl_30439
+disable_so_snd_seq_queue_timer_close_fndecl_30450 snd_seq_queue_timer_close fndecl 1 30450 NULL nohasharray
+disable_so_gid_cap_mthca_init_ib_param_30450 gid_cap mthca_init_ib_param 0 30450 &disable_so_snd_seq_queue_timer_close_fndecl_30450
+disable_so_powerdown_delay_divider_sta350_platform_data_30459 powerdown_delay_divider sta350_platform_data 0 30459 NULL nohasharray
+disable_so_acpi_pm_device_sleep_state_fndecl_30459 acpi_pm_device_sleep_state fndecl 0 30459 &disable_so_powerdown_delay_divider_sta350_platform_data_30459
+disable_so__regulator_get_enable_time_fndecl_30467 _regulator_get_enable_time fndecl 0 30467 NULL
+disable_so_hpet_set_alarm_time_fndecl_30469 hpet_set_alarm_time fndecl 3-2-1 30469 NULL
+disable_so_ctime_nsec_ubifs_ino_node_30480 ctime_nsec ubifs_ino_node 0 30480 NULL
+disable_so_ocfb_writereg_fndecl_30484 ocfb_writereg fndecl 3 30484 NULL
+disable_so_i2c_smbus_read_word_data_fndecl_30505 i2c_smbus_read_word_data fndecl 0-2 30505 NULL nohasharray
+disable_so_r13_kvm_regs_30505 r13 kvm_regs 0 30505 &disable_so_i2c_smbus_read_word_data_fndecl_30505
+disable_so_cb_gsc_addr_30507 cb gsc_addr 0 30507 NULL
+disable_so_freq_mwifiex_chan_freq_power_30518 freq mwifiex_chan_freq_power 0 30518 NULL
+disable_so_fflp_hash_clear_fndecl_30528 fflp_hash_clear fndecl 0 30528 NULL
+disable_so_time_stamp_ixgb_buffer_30530 time_stamp ixgb_buffer 0 30530 NULL
+disable_so_lbs_sleepparams_read_fndecl_30539 lbs_sleepparams_read fndecl 3-0 30539 NULL
+disable_so_extract_freq_fndecl_30555 extract_freq fndecl 0-1 30555 NULL
+disable_so_ndiv_int_pmu1_plltab_entry_30559 ndiv_int pmu1_plltab_entry 0 30559 NULL
+disable_so_u1_timeout_store_fndecl_30569 u1_timeout_store fndecl 0-4 30569 NULL
+disable_so_queue_working_time_show_fndecl_30574 queue_working_time_show fndecl 0 30574 NULL
+disable_so_addr_atiixp_30579 addr atiixp 0 30579 NULL
+disable_so_c67x00_ll_write_mem_le16_fndecl_30584 c67x00_ll_write_mem_le16 fndecl 2-4 30584 NULL
+disable_so_demod_address_atbm8830_config_30586 demod_address atbm8830_config 0 30586 NULL
+disable_so_crypto_hash_digest_fndecl_30590 crypto_hash_digest fndecl 0-3 30590 NULL
+disable_so_addr_filter__MGSL_PARAMS_30592 addr_filter _MGSL_PARAMS 0 30592 NULL
+disable_so_clock_khz_dib0070_config_30609 clock_khz dib0070_config 0 30609 NULL
+disable_so_sha1_mb_final_fndecl_30610 sha1_mb_final fndecl 0 30610 NULL
+disable_so_tw_rcv_nxt_tcp_timewait_sock_30612 tw_rcv_nxt tcp_timewait_sock 0 30612 NULL
+disable_so_xtal_freq_stb0899_config_30613 xtal_freq stb0899_config 0 30613 NULL
+disable_so_di_ctime_qnx6_inode_entry_30614 di_ctime qnx6_inode_entry 0 30614 NULL
+disable_so_start_time_lpfc_scsi_buf_30621 start_time lpfc_scsi_buf 0 30621 NULL
+disable_so_xfs_btree_log_keys_fndecl_30625 xfs_btree_log_keys fndecl 3-4 30625 NULL
+disable_so_pcpu_chunk_addr_fndecl_30628 pcpu_chunk_addr fndecl 0-2-3 30628 NULL
+disable_so_day_timestamp_30633 day timestamp 0 30633 NULL
+disable_so_rds_cong_from_addr_fndecl_30634 rds_cong_from_addr fndecl 1 30634 NULL
+disable_so_tx_dma_addr_smsc9420_pdata_30649 tx_dma_addr smsc9420_pdata 0 30649 NULL
+disable_so_xact_addr_filt_port_info_30664 xact_addr_filt port_info 0 30664 NULL
+disable_so_slot_time_rtl8180_priv_30669 slot_time rtl8180_priv 0 30669 NULL
+disable_so_store_guid_fndecl_30675 store_guid fndecl 0 30675 NULL
+disable_so_input_addr_to_csrow_fndecl_30677 input_addr_to_csrow fndecl 0-2 30677 NULL
+disable_so_sq_read_base_addr_a1_btmrvl_sdio_card_reg_30692 sq_read_base_addr_a1 btmrvl_sdio_card_reg 0 30692 NULL
+disable_so_fq_codel_hash_fndecl_30698 fq_codel_hash fndecl 0 30698 NULL
+disable_so_btrfs_add_delayed_extent_op_fndecl_30699 btrfs_add_delayed_extent_op fndecl 0-3-4 30699 NULL
+disable_so_enabled_hrtimer_events_fotg210_hcd_30705 enabled_hrtimer_events fotg210_hcd 0 30705 NULL
+disable_so_shift_sm501_clock_30710 shift sm501_clock 0 30710 NULL
+disable_so_tov_in_jiffies_tpacket_kbdq_core_30716 tov_in_jiffies tpacket_kbdq_core 0 30716 NULL nohasharray
+disable_so_rqq_addr_lo_addr_ctrl_blk_30716 rqq_addr_lo addr_ctrl_blk 0 30716 &disable_so_tov_in_jiffies_tpacket_kbdq_core_30716
+disable_so_fill_addr_fndecl_30730 fill_addr fndecl 0-3-4-6 30730 NULL
+disable_so_policy_hash_bysel_fndecl_30767 policy_hash_bysel fndecl 3 30767 NULL
+disable_so_flags_to_set_btrfs_delayed_extent_op_30771 flags_to_set btrfs_delayed_extent_op 0 30771 NULL
+disable_so_blk_mq_alloc_bitmap_fndecl_30774 blk_mq_alloc_bitmap fndecl 2 30774 NULL
+disable_so_btrfs_add_delayed_data_ref_fndecl_30775 btrfs_add_delayed_data_ref fndecl 0-11-3-4-5-6-7-8 30775 NULL
+disable_so_pm_runtime_get_fndecl_30787 pm_runtime_get fndecl 0 30787 NULL
+disable_so_dln2_spi_runtime_suspend_fndecl_30789 dln2_spi_runtime_suspend fndecl 0 30789 NULL
+disable_so_rq_page_table_addr_hi_iscsi_kwqe_conn_offload2_30790 rq_page_table_addr_hi iscsi_kwqe_conn_offload2 0 30790 NULL
+disable_so_crypto_authenc_esn_decrypt_fndecl_30793 crypto_authenc_esn_decrypt fndecl 0 30793 NULL
+disable_so_brcmf_cfg80211_wait_vif_event_timeout_fndecl_30794 brcmf_cfg80211_wait_vif_event_timeout fndecl 3-0 30794 NULL
+disable_so_sctp_getsockopt_nodelay_fndecl_30795 sctp_getsockopt_nodelay fndecl 0 30795 NULL nohasharray
+disable_so_sll_pkttype_sockaddr_ll_30795 sll_pkttype sockaddr_ll 0 30795 &disable_so_sctp_getsockopt_nodelay_fndecl_30795
+disable_so_txfunaddr_musb_csr_regs_30797 txfunaddr musb_csr_regs 0 30797 NULL
+disable_so_hash_phys_wd719x_30798 hash_phys wd719x 0 30798 NULL
+disable_so_io_base_address_info_30800 io_base address_info 0 30800 NULL
+disable_so_dummy_buffer_addr_lo_iscsi_kwqe_init1_30804 dummy_buffer_addr_lo iscsi_kwqe_init1 0 30804 NULL
+disable_so_root_btrfs_delayed_tree_ref_30811 root btrfs_delayed_tree_ref 0 30811 NULL nohasharray
+disable_so_sr_bit_offset_ocfs2_suballoc_result_30811 sr_bit_offset ocfs2_suballoc_result 0 30811 &disable_so_root_btrfs_delayed_tree_ref_30811
+disable_so_mmc_test_random_write_perf_fndecl_30814 mmc_test_random_write_perf fndecl 0 30814 NULL
+disable_so_block_num_ib_sa_guidinfo_rec_30816 block_num ib_sa_guidinfo_rec 0 30816 NULL
+disable_so_decode_attr_time_metadata_fndecl_30823 decode_attr_time_metadata fndecl 0 30823 NULL nohasharray
+disable_so_i40e_get_port_mac_addr_fndecl_30823 i40e_get_port_mac_addr fndecl 0 30823 &disable_so_decode_attr_time_metadata_fndecl_30823
+disable_so_first_frag_time_ieee80211_fragment_entry_30835 first_frag_time ieee80211_fragment_entry 0 30835 NULL nohasharray
+disable_so_ccp_crypto_success_fndecl_30835 ccp_crypto_success fndecl 1 30835 &disable_so_first_frag_time_ieee80211_fragment_entry_30835 nohasharray
+disable_so_recent_entry_hash4_fndecl_30835 recent_entry_hash4 fndecl 0 30835 &disable_so_ccp_crypto_success_fndecl_30835
+disable_so_rp0_freq_intel_gen6_power_mgmt_30837 rp0_freq intel_gen6_power_mgmt 0 30837 NULL
+disable_so_dm_btree_walk_fndecl_30840 dm_btree_walk fndecl 0-2 30840 NULL
+disable_so_hid_descriptor_address_i2c_hid_platform_data_30846 hid_descriptor_address i2c_hid_platform_data 0 30846 NULL
+disable_so_address_acpi_mcfg_allocation_30855 address acpi_mcfg_allocation 0 30855 NULL
+disable_so_hpfs_truncate_btree_fndecl_30857 hpfs_truncate_btree fndecl 2-4 30857 NULL
+disable_so_timestamp_transaction_30860 timestamp transaction 0 30860 NULL
+disable_so_crypto_pcbc_encrypt_inplace_fndecl_30862 crypto_pcbc_encrypt_inplace fndecl 0 30862 NULL
+disable_so_part_time_mmc_ext_csd_30871 part_time mmc_ext_csd 0 30871 NULL
+disable_so_vpd_paddr_high_lpfc_mbx_read_rev_30896 vpd_paddr_high lpfc_mbx_read_rev 0 30896 NULL
+disable_so_addr_nvkm_fifo_chan_30902 addr nvkm_fifo_chan 0 30902 NULL
+disable_so_crypto_register_algs_fndecl_30905 crypto_register_algs fndecl 0 30905 NULL nohasharray
+disable_so_dhash_entries_vardecl_dcache_c_30905 dhash_entries vardecl_dcache.c 0 30905 &disable_so_crypto_register_algs_fndecl_30905
+disable_so_bank_base_capture_addr_snd_ymfpci_30915 bank_base_capture_addr snd_ymfpci 0 30915 NULL
+disable_so_t2_hash_tbl_addr_hi_fcoe_kwqe_init2_30918 t2_hash_tbl_addr_hi fcoe_kwqe_init2 0 30918 NULL nohasharray
+disable_so_nilfs_btree_lookup_fndecl_30918 nilfs_btree_lookup fndecl 0-2 30918 &disable_so_t2_hash_tbl_addr_hi_fcoe_kwqe_init2_30918
+disable_so_cpufreq_set_fndecl_30921 cpufreq_set fndecl 2 30921 NULL
+disable_so_phys_addr_sge_fl_30927 phys_addr sge_fl 0 30927 NULL
+disable_so_brcms_c_calc_ack_time_fndecl_30936 brcms_c_calc_ack_time fndecl 0-2 30936 NULL
+disable_so_limit_gma_clock_funcs_30938 limit gma_clock_funcs 2 30938 NULL nohasharray
+disable_so_xenbus_printf_fndecl_30938 xenbus_printf fndecl 0 30938 &disable_so_limit_gma_clock_funcs_30938
+disable_so_qlcnic_decode_crb_addr_fndecl_30939 qlcnic_decode_crb_addr fndecl 0-1 30939 NULL
+disable_so_last_sleep_jiffies_rtl_ps_ctl_30947 last_sleep_jiffies rtl_ps_ctl 0 30947 NULL nohasharray
+disable_so___virtio64_to_cpu_fndecl_30947 __virtio64_to_cpu fndecl 0 30947 &disable_so_last_sleep_jiffies_rtl_ps_ctl_30947
+disable_so_do_one_ahash_op_fndecl_30974 do_one_ahash_op fndecl 0-2 30974 NULL
+disable_so_dev_bus_addr_gnttab_map_grant_ref_30975 dev_bus_addr gnttab_map_grant_ref 0 30975 NULL
+disable_so_sctp_getsockopt_delayed_ack_fndecl_30979 sctp_getsockopt_delayed_ack fndecl 2-0 30979 NULL
+disable_so_mclk_div_cfb_info_30983 mclk_div cfb_info 0 30983 NULL
+disable_so_HYPERVISOR_update_va_mapping_fndecl_30985 HYPERVISOR_update_va_mapping fndecl 1 30985 NULL
+disable_so_xfrm_addr_any_fndecl_30992 xfrm_addr_any fndecl 2 30992 NULL
+disable_so_cyapa_gen5_deep_sleep_fndecl_30993 cyapa_gen5_deep_sleep fndecl 0 30993 NULL
+disable_so_addr_unlock1_cfi_private_30996 addr_unlock1 cfi_private 0 30996 NULL
+disable_so_adc_cell_ti_tscadc_dev_31010 adc_cell ti_tscadc_dev 0 31010 NULL
+disable_so_vpe_runtime_get_fndecl_31015 vpe_runtime_get fndecl 0 31015 NULL
+disable_so_crypto_cts_module_init_fndecl_31019 crypto_cts_module_init fndecl 0 31019 NULL
+disable_so_show_fan_stop_time_fndecl_31023 show_fan_stop_time fndecl 0 31023 NULL
+disable_so_addr_bnx2_fw_file_section_31025 addr bnx2_fw_file_section 0 31025 NULL
+disable_so_seg_addr_xhci_erst_entry_31037 seg_addr xhci_erst_entry 0 31037 NULL
+disable_so_fb_get_hblank_by_hfreq_fndecl_31039 fb_get_hblank_by_hfreq fndecl 0-1-2 31039 NULL
+disable_so_addr_hif_scatter_req_31042 addr hif_scatter_req 0 31042 NULL
+disable_so_sg_page_iter_dma_address_fndecl_31047 sg_page_iter_dma_address fndecl 0 31047 NULL
+disable_so_btrfsic_block_hashtable_lookup_fndecl_31074 btrfsic_block_hashtable_lookup fndecl 2 31074 NULL
+disable_so_tm6000_set_reg_fndecl_31090 tm6000_set_reg fndecl 0-3-4 31090 NULL
+disable_so_sense_buf_phys_addr_lo_megasas_io_frame_31098 sense_buf_phys_addr_lo megasas_io_frame 0 31098 NULL
+disable_so_batadv_iv_ogm_emit_send_time_fndecl_31100 batadv_iv_ogm_emit_send_time fndecl 0 31100 NULL
+disable_so_pcf8563_rtc_set_time_fndecl_31101 pcf8563_rtc_set_time fndecl 0 31101 NULL
+disable_so_s_extPosition_udf_bitmap_31104 s_extPosition udf_bitmap 0 31104 NULL
+disable_so_base_io_addr__hp_host_info_31105 base_io_addr _hp_host_info 0 31105 NULL
+disable_so_tsi721_omsg_interrupt_disable_fndecl_31108 tsi721_omsg_interrupt_disable fndecl 3-2 31108 NULL
+disable_so_ac_etime_acct_v3_31115 ac_etime acct_v3 0 31115 NULL
+disable_so_io_bitmap_a_vmcs12_31120 io_bitmap_a vmcs12 0 31120 NULL
+disable_so_vddci_radeon_clock_and_voltage_limits_31124 vddci radeon_clock_and_voltage_limits 0 31124 NULL
+disable_so_format_snd_pcm_runtime_31130 format snd_pcm_runtime 0 31130 NULL
+disable_so_ds3232_set_time_fndecl_31132 ds3232_set_time fndecl 0 31132 NULL
+disable_so_mlx4_bitmap_init_fndecl_31138 mlx4_bitmap_init fndecl 0-2-3-4-5 31138 NULL
+disable_so_nfs4_xdr_dec_get_lease_time_fndecl_31141 nfs4_xdr_dec_get_lease_time fndecl 0 31141 NULL
+disable_so_active_ata_timing_31146 active ata_timing 0 31146 NULL
+disable_so_cpuidle_register_driver_fndecl_31155 cpuidle_register_driver fndecl 0 31155 NULL
+disable_so_sha1_ssse3_mod_init_fndecl_31158 sha1_ssse3_mod_init fndecl 0 31158 NULL
+disable_so_trust_timeout_wusbhc_31165 trust_timeout wusbhc 0 31165 NULL
+disable_so___crypto_memneq_generic_fndecl_31174 __crypto_memneq_generic fndecl 3 31174 NULL
+disable_so_hash_ipportip4_expire_fndecl_31188 hash_ipportip4_expire fndecl 4 31188 NULL
+disable_so_timestamp_sniffed_purge_batadv_priv_nc_31190 timestamp_sniffed_purge batadv_priv_nc 0 31190 NULL
+disable_so_i915_min_freq_get_fndecl_31193 i915_min_freq_get fndecl 0 31193 NULL
+disable_so_max_scan_time_wmi_start_scan_arg_31206 max_scan_time wmi_start_scan_arg 0 31206 NULL nohasharray
+disable_so_n_pins_ptp_clock_info_31206 n_pins ptp_clock_info 0 31206 &disable_so_max_scan_time_wmi_start_scan_arg_31206
+disable_so_adis16136_read_frequency_fndecl_31213 adis16136_read_frequency fndecl 0 31213 NULL
+disable_so_dce_v11_0_crtc_set_base_atomic_fndecl_31215 dce_v11_0_crtc_set_base_atomic fndecl 0 31215 NULL
+disable_so_clock2alarm_fndecl_31223 clock2alarm fndecl 1 31223 NULL
+disable_so_timeout_wait_bit_key_31247 timeout wait_bit_key 0 31247 NULL
+disable_so_time_offset_fat_mount_options_31254 time_offset fat_mount_options 0 31254 NULL
+disable_so_max3421_set_address_fndecl_31258 max3421_set_address fndecl 3 31258 NULL
+disable_so_tick_gtod_sched_clock_data_31262 tick_gtod sched_clock_data 0 31262 NULL
+disable_so_freq_usb_usbvision_31263 freq usb_usbvision 0 31263 NULL
+disable_so_address_high_sbp2_target_31266 address_high sbp2_target 0 31266 NULL nohasharray
+disable_so_batadv_orig_hash_add_if_fndecl_31266 batadv_orig_hash_add_if fndecl 0-2 31266 &disable_so_address_high_sbp2_target_31266
+disable_so_rx8581_rtc_read_time_fndecl_31271 rx8581_rtc_read_time fndecl 0 31271 NULL
+disable_so_address_acpi_madt_io_apic_31284 address acpi_madt_io_apic 0 31284 NULL
+disable_so_qce_setup_regs_ahash_fndecl_31290 qce_setup_regs_ahash fndecl 0 31290 NULL
+disable_so_freq_offset_khz_uhf_dib0070_config_31304 freq_offset_khz_uhf dib0070_config 0 31304 NULL
+disable_so_dmaaddr_lanai_buffer_31308 dmaaddr lanai_buffer 0 31308 NULL
+disable_so_selinux_mmap_addr_fndecl_31313 selinux_mmap_addr fndecl 0 31313 NULL
+disable_so_wt_timeout_st21nfcb_se_info_31334 wt_timeout st21nfcb_se_info 0 31334 NULL
+disable_so_baseaddr_h_mvumi_sgl_31335 baseaddr_h mvumi_sgl 0 31335 NULL
+disable_so_mmc_send_relative_addr_fndecl_31338 mmc_send_relative_addr fndecl 0 31338 NULL nohasharray
+disable_so_ufs_bitmap_search_fndecl_31338 ufs_bitmap_search fndecl 0-3-4 31338 &disable_so_mmc_send_relative_addr_fndecl_31338 nohasharray
+disable_so_cur_tsc_offset_kvm_arch_31338 cur_tsc_offset kvm_arch 0 31338 &disable_so_ufs_bitmap_search_fndecl_31338
+disable_so_xfs_btree_check_lptr_fndecl_31339 xfs_btree_check_lptr fndecl 0 31339 NULL
+disable_so_dynamic_ps_timeout_read_fndecl_31341 dynamic_ps_timeout_read fndecl 3-0 31341 NULL
+disable_so_ret_ccp_crypto_cmd_31344 ret ccp_crypto_cmd 0 31344 NULL
+disable_so_physical_mem_addr_wl1251_31345 physical_mem_addr wl1251 0 31345 NULL
+disable_so_schedule_work_on_fndecl_31361 schedule_work_on fndecl 1 31361 NULL
+disable_so_es_tss_segment_32_31367 es tss_segment_32 0 31367 NULL
+disable_so_link_schedule_user_fndecl_31379 link_schedule_user fndecl 0 31379 NULL
+disable_so_vsock_addr_cast_fndecl_31386 vsock_addr_cast fndecl 2 31386 NULL
+disable_so_debug_dma_sync_single_for_cpu_fndecl_31387 debug_dma_sync_single_for_cpu fndecl 3-2 31387 NULL
+disable_so_num_bytes_btrfs_delayed_ref_node_31390 num_bytes btrfs_delayed_ref_node 0 31390 NULL
+disable_so_clockevents_config_fndecl_31391 clockevents_config fndecl 2 31391 NULL nohasharray
+disable_so_wl1271_acx_host_if_cfg_bitmap_fndecl_31391 wl1271_acx_host_if_cfg_bitmap fndecl 0 31391 &disable_so_clockevents_config_fndecl_31391
+disable_so_kstrtol_from_user_fndecl_31403 kstrtol_from_user fndecl 0-2 31403 NULL
+disable_so_req_timeout_ppp_31406 req_timeout ppp 0 31406 NULL
+disable_so_recvsignalpower_rtl_stats_31407 recvsignalpower rtl_stats 0 31407 NULL
+disable_so_gr_log_signal_fndecl_31408 gr_log_signal fndecl 1 31408 NULL
+disable_so_round_jiffies_up_relative_fndecl_31409 round_jiffies_up_relative fndecl 1-0 31409 NULL
+disable_so_nr_cs5535_mfgpt_timer_31410 nr cs5535_mfgpt_timer 0 31410 NULL
+disable_so_af9005_fe_read_signal_strength_fndecl_31416 af9005_fe_read_signal_strength fndecl 0 31416 NULL nohasharray
+disable_so_aes_decrypt_packets_read_fndecl_31416 aes_decrypt_packets_read fndecl 0-3 31416 &disable_so_af9005_fe_read_signal_strength_fndecl_31416
+disable_so_usnic_uiom_interval_tree_subtree_search_fndecl_31422 usnic_uiom_interval_tree_subtree_search fndecl 2-3 31422 NULL nohasharray
+disable_so_ima_calc_file_hash_tfm_fndecl_31422 ima_calc_file_hash_tfm fndecl 0 31422 &disable_so_usnic_uiom_interval_tree_subtree_search_fndecl_31422
+disable_so_rxrpc_max_call_lifetime_vardecl_31433 rxrpc_max_call_lifetime vardecl 0 31433 NULL nohasharray
+disable_so_di_gid_logfs_disk_inode_31433 di_gid logfs_disk_inode 0 31433 &disable_so_rxrpc_max_call_lifetime_vardecl_31433
+disable_so_ds1374_wdt_settimeout_fndecl_31434 ds1374_wdt_settimeout fndecl 1-0 31434 NULL
+disable_so_tei_sockaddr_mISDN_31438 tei sockaddr_mISDN 0 31438 NULL
+disable_so_bs_sleepduration_ath9k_beacon_state_31443 bs_sleepduration ath9k_beacon_state 0 31443 NULL
+disable_so_pci_bus_write_config_word_fndecl_31447 pci_bus_write_config_word fndecl 0-2-3-4 31447 NULL
+disable_so_cra_ctxsize_crypto_alg_31451 cra_ctxsize crypto_alg 0 31451 NULL
+disable_so_dmable_fw_paddr_sst_fw_31454 dmable_fw_paddr sst_fw 0 31454 NULL
+disable_so_nsec_btrfs_timespec_31463 nsec btrfs_timespec 0 31463 NULL nohasharray
+disable_so_set_timeout_fndecl_31463 set_timeout fndecl 2-0 31463 &disable_so_nsec_btrfs_timespec_31463
+disable_so_ima_calc_field_array_hash_tfm_fndecl_31467 ima_calc_field_array_hash_tfm fndecl 0-3 31467 NULL
+disable_so_bond_eth_hash_fndecl_31472 bond_eth_hash fndecl 0 31472 NULL
+disable_so_task_setscheduler_security_operations_31479 task_setscheduler security_operations 0 31479 NULL
+disable_so_cs_tss_segment_32_31480 cs tss_segment_32 0 31480 NULL
+disable_so_intr_gen_timer_thresh_ath_hw_31491 intr_gen_timer_thresh ath_hw 0 31491 NULL nohasharray
+disable_so_nilfs_btree_find_near_fndecl_31491 nilfs_btree_find_near fndecl 0 31491 &disable_so_intr_gen_timer_thresh_ath_hw_31491
+disable_so_sta_last_ack_signal_read_fndecl_31492 sta_last_ack_signal_read fndecl 3 31492 NULL
+disable_so___uwb_dev_addr_assigned_fndecl_31493 __uwb_dev_addr_assigned fndecl 0 31493 NULL
+disable_so_uuid_show_fndecl_31494 uuid_show fndecl 0 31494 NULL
+disable_so_elan_sleep_fndecl_31502 elan_sleep fndecl 0 31502 NULL
+disable_so_setkey_crypto_aead_31507 setkey crypto_aead 0-3 31507 NULL
+disable_so_ebitmap_netlbl_import_fndecl_31508 ebitmap_netlbl_import fndecl 0 31508 NULL
+disable_so_ccp_aes_rfc3686_decrypt_fndecl_31513 ccp_aes_rfc3686_decrypt fndecl 0 31513 NULL
+disable_so_timeout_map_r8a66597_31517 timeout_map r8a66597 0 31517 NULL
+disable_so_vga_switcheroo_runtime_resume_hdmi_audio_fndecl_31521 vga_switcheroo_runtime_resume_hdmi_audio fndecl 0 31521 NULL nohasharray
+disable_so_in_div_min_matrox_pll_features_31521 in_div_min matrox_pll_features 0 31521 &disable_so_vga_switcheroo_runtime_resume_hdmi_audio_fndecl_31521
+disable_so_hashbin_insert_fndecl_31527 hashbin_insert fndecl 3 31527 NULL
+disable_so_reset_jiffies_fw_card_31535 reset_jiffies fw_card 0 31535 NULL
+disable_so_addr_gk20a_instmem_priv_31544 addr gk20a_instmem_priv 0 31544 NULL
+disable_so_vringh32_to_cpu_fndecl_31546 vringh32_to_cpu fndecl 0-2 31546 NULL
+disable_so_qat_hash_alg_qat_alg_aead_ctx_31550 qat_hash_alg qat_alg_aead_ctx 0 31550 NULL
+disable_so_timeout_move_vardecl_ch_c_31551 timeout_move vardecl_ch.c 0 31551 NULL
+disable_so_iowrite8_rep_fndecl_31565 iowrite8_rep fndecl 3 31565 NULL
+disable_so_omfs_hash_fndecl_31572 omfs_hash fndecl 0-3 31572 NULL
+disable_so_ltc3589_set_ramp_delay_fndecl_31580 ltc3589_set_ramp_delay fndecl 0 31580 NULL
+disable_so_wants_signal_fndecl_31583 wants_signal fndecl 1 31583 NULL
+disable_so_set_sig_addr_fndecl_31588 set_sig_addr fndecl 4 31588 NULL
+disable_so_udelay_i2c_algo_bit_data_31597 udelay i2c_algo_bit_data 0 31597 NULL
+disable_so_wlapi_add_timer_fndecl_31598 wlapi_add_timer fndecl 2 31598 NULL
+disable_so_gid_min_xt_owner_match_info_31604 gid_min xt_owner_match_info 0 31604 NULL
+disable_so_mmap_addr_security_operations_31609 mmap_addr security_operations 0-1 31609 NULL
+disable_so_cache_time_vardecl_battery_c_31620 cache_time vardecl_battery.c 0 31620 NULL
+disable_so_idletimer_tg_checkentry_fndecl_31633 idletimer_tg_checkentry fndecl 0 31633 NULL
+disable_so_sha256_ssse3_finup_fndecl_31637 sha256_ssse3_finup fndecl 3 31637 NULL
+disable_so_f1x_translate_sysaddr_to_cs_fndecl_31647 f1x_translate_sysaddr_to_cs fndecl 0-2 31647 NULL
+disable_so_partial_name_hash_fndecl_31651 partial_name_hash fndecl 0-1-2 31651 NULL
+disable_so_edx_v86_regs_31655 edx v86_regs 0 31655 NULL
+disable_so_kdb_printf_fndecl_31658 kdb_printf fndecl 0 31658 NULL
+disable_so_voltage_response_time_radeon_dpm_31671 voltage_response_time radeon_dpm 0 31671 NULL
+disable_so_ufshcd_pci_runtime_resume_fndecl_31682 ufshcd_pci_runtime_resume fndecl 0 31682 NULL
+disable_so_trace_clock_jiffies_fndecl_31684 trace_clock_jiffies fndecl 0 31684 NULL
+disable_so_crypto_rfc4543_crypt_fndecl_31691 crypto_rfc4543_crypt fndecl 0 31691 NULL
+disable_so_qp_bitmap_ntb_transport_ctx_31692 qp_bitmap ntb_transport_ctx 0 31692 NULL
+disable_so_mclk_radeon_clock_and_voltage_limits_31701 mclk radeon_clock_and_voltage_limits 0 31701 NULL
+disable_so_hash_dev_block_bits_dm_verity_31709 hash_dev_block_bits dm_verity 0 31709 NULL
+disable_so_crypto_gcm_init_crypt_fndecl_31718 crypto_gcm_init_crypt fndecl 2 31718 NULL
+disable_so_addr_ahd_dma_seg_31719 addr ahd_dma_seg 0 31719 NULL
+disable_so_rx_frame_ath_cycle_counters_31739 rx_frame ath_cycle_counters 0 31739 NULL
+disable_so_nadc_aic32x4_rate_divs_31741 nadc aic32x4_rate_divs 0 31741 NULL
+disable_so_gpu_addr_r600_ih_31749 gpu_addr r600_ih 0 31749 NULL
+disable_so_acpi_ex_system_do_sleep_fndecl_31750 acpi_ex_system_do_sleep fndecl 0-1 31750 NULL
+disable_so_bigdirindaddr_adfs_bigdirentry_31757 bigdirindaddr adfs_bigdirentry 0 31757 NULL
+disable_so_vm_entry_msr_load_addr_vmcs12_31781 vm_entry_msr_load_addr vmcs12 0 31781 NULL
+disable_so_qce_ahash_async_req_handle_fndecl_31785 qce_ahash_async_req_handle fndecl 0 31785 NULL
+disable_so_ecryptfs_calculate_md5_fndecl_31787 ecryptfs_calculate_md5 fndecl 0-4 31787 NULL
+disable_so_pixclock_fb_var_screeninfo_31790 pixclock fb_var_screeninfo 0 31790 NULL
+disable_so_from_kgid_munged_fndecl_31791 from_kgid_munged fndecl 0 31791 NULL
+disable_so_memsize_bitmap_ipmac_31792 memsize bitmap_ipmac 0 31792 NULL
+disable_so_ctxsize_crypto_type_31795 ctxsize crypto_type 0 31795 NULL
+disable_so_fpage_dma_addr_genwqe_sgl_31796 fpage_dma_addr genwqe_sgl 0 31796 NULL
+disable_so_qib_hol_timeout_ms_vardecl_qib_tx_c_31801 qib_hol_timeout_ms vardecl_qib_tx.c 0 31801 NULL
+disable_so_ping_timeout_iscsi_conn_31802 ping_timeout iscsi_conn 0 31802 NULL
+disable_so_rpcauth_key_timeout_notify_fndecl_31805 rpcauth_key_timeout_notify fndecl 0 31805 NULL
+disable_so_snd_timer_open_fndecl_31807 snd_timer_open fndecl 4 31807 NULL
+disable_so_it_overrun_last_k_itimer_31814 it_overrun_last k_itimer 0 31814 NULL
+disable_so_mapaddr_rocker_dma_ring_info_31819 mapaddr rocker_dma_ring_info 0 31819 NULL
+disable_so_disarm_req_delay_fndecl_31821 disarm_req_delay fndecl 0 31821 NULL
+disable_so_bus_addr_mvumi_res_31827 bus_addr mvumi_res 0 31827 NULL nohasharray
+disable_so_dev_sas_addr_mvs_phy_31827 dev_sas_addr mvs_phy 0 31827 &disable_so_bus_addr_mvumi_res_31827 nohasharray
+disable_so_select_addr_qla8044_minidump_entry_queue_31827 select_addr qla8044_minidump_entry_queue 0 31827 &disable_so_dev_sas_addr_mvs_phy_31827
+disable_so_lzo1x_decompress_safe_fndecl_31834 lzo1x_decompress_safe fndecl 2 31834 NULL
+disable_so_spte_is_bit_cleared_fndecl_31843 spte_is_bit_cleared fndecl 2-3 31843 NULL
+disable_so_mclk_radeon_pm_clock_info_31848 mclk radeon_pm_clock_info 0 31848 NULL
+disable_so_timer_expires_wakeup_source_31849 timer_expires wakeup_source 0 31849 NULL
+disable_so_si_populate_memory_timing_parameters_fndecl_31852 si_populate_memory_timing_parameters fndecl 0 31852 NULL
+disable_so_offset_timex_31854 offset timex 0 31854 NULL
+disable_so_tuner_addr_tvcard_31862 tuner_addr tvcard 0 31862 NULL
+disable_so_mask_and_set_register_interruptible_fndecl_31871 mask_and_set_register_interruptible fndecl 0 31871 NULL
+disable_so_generic_set_freq_fndecl_31881 generic_set_freq fndecl 0-2-3 31881 NULL
+disable_so_quota_iwl_time_quota_data_31890 quota iwl_time_quota_data 0 31890 NULL
+disable_so_timer_set_at_tlan_priv_31902 timer_set_at tlan_priv 0 31902 NULL
+disable_so_update_time_ds2760_device_info_31906 update_time ds2760_device_info 0 31906 NULL
+disable_so_qlcnic_83xx_wrt_reg_indirect_fndecl_31907 qlcnic_83xx_wrt_reg_indirect fndecl 2-3 31907 NULL
+disable_so_nmi_timer_setup_fndecl_31908 nmi_timer_setup fndecl 0 31908 NULL
+disable_so_period_size_atmel_runtime_data_31909 period_size atmel_runtime_data 0 31909 NULL
+disable_so_spi_pioavailaddr_qib_base_info_31911 spi_pioavailaddr qib_base_info 0 31911 NULL
+disable_so_err_msr_info_31913 err msr_info 0 31913 NULL
+disable_so_pcan_usb_fd_set_clock_domain_fndecl_31920 pcan_usb_fd_set_clock_domain fndecl 0 31920 NULL
+disable_so_i_ipmi_set_timeout_fndecl_31922 i_ipmi_set_timeout fndecl 0 31922 NULL
+disable_so_tw_ts_offset_tcp_timewait_sock_31933 tw_ts_offset tcp_timewait_sock 0 31933 NULL
+disable_so_shash_setkey_unaligned_fndecl_31935 shash_setkey_unaligned fndecl 3 31935 NULL
+disable_so_kempld_wdt_get_timeout_fndecl_31937 kempld_wdt_get_timeout fndecl 0 31937 NULL
+disable_so_addr___mux_31940 addr __mux 0 31940 NULL
+disable_so_clk_divider_bestdiv_fndecl_31941 clk_divider_bestdiv fndecl 2-0-5 31941 NULL
+disable_so_bm_words_drbd_bitmap_31943 bm_words drbd_bitmap 0 31943 NULL
+disable_so_timeout_show_fndecl_31957 timeout_show fndecl 0 31957 NULL
+disable_so_snd_hdsp_info_system_clock_mode_fndecl_31974 snd_hdsp_info_system_clock_mode fndecl 0 31974 NULL
+disable_so_time_wrap_offset_vivid_dev_31985 time_wrap_offset vivid_dev 0 31985 NULL
+disable_so_addr_iwl_fw_dbg_reg_op_31986 addr iwl_fw_dbg_reg_op 0 31986 NULL
+disable_so_xclk_ref_div_pll_ct_31987 xclk_ref_div pll_ct 0 31987 NULL
+disable_so_rd32_nvkm_ofuncs_31990 rd32 nvkm_ofuncs 0-2 31990 NULL
+disable_so_addr_sis5595_data_32006 addr sis5595_data 0 32006 NULL
+disable_so_demod_address_cx22702_config_32010 demod_address cx22702_config 0 32010 NULL
+disable_so_hashlimit_init_dst_fndecl_32011 hashlimit_init_dst fndecl 4 32011 NULL
+disable_so_cx24113_set_frequency_fndecl_32013 cx24113_set_frequency fndecl 2 32013 NULL
+disable_so_bq2415x_sysfs_set_timer_fndecl_32020 bq2415x_sysfs_set_timer fndecl 0-4 32020 NULL
+disable_so___find_rev_next_zero_bit_fndecl_32028 __find_rev_next_zero_bit fndecl 0-2-3 32028 NULL
+disable_so_ahd_outb_fndecl_32029 ahd_outb fndecl 2-3 32029 NULL
+disable_so_pfn_to_mfn_frame_list_list_arch_shared_info_32030 pfn_to_mfn_frame_list_list arch_shared_info 0 32030 NULL
+disable_so_viafb_set_vclock_fndecl_32033 viafb_set_vclock fndecl 1 32033 NULL
+disable_so_paddr_csio_dma_buf_32035 paddr csio_dma_buf 0 32035 NULL
+disable_so_tw_ts_recent_stamp_tcp_timewait_sock_32042 tw_ts_recent_stamp tcp_timewait_sock 0 32042 NULL
+disable_so_rangetr_hash_fndecl_32045 rangetr_hash fndecl 0 32045 NULL
+disable_so_vsyn_off_hdmi_timings_32055 vsyn_off hdmi_timings 0 32055 NULL
+disable_so_fnic_dev_mac_addr_fndecl_32057 fnic_dev_mac_addr fndecl 0 32057 NULL nohasharray
+disable_so_s921_read_signal_strength_fndecl_32057 s921_read_signal_strength fndecl 0 32057 &disable_so_fnic_dev_mac_addr_fndecl_32057
+disable_so_iscsit_ta_login_timeout_fndecl_32061 iscsit_ta_login_timeout fndecl 0 32061 NULL
+disable_so_btrfs_delayed_ref_init_fndecl_32064 btrfs_delayed_ref_init fndecl 0 32064 NULL
+disable_so_clk_register_divider_fndecl_32066 clk_register_divider fndecl 7-6 32066 NULL
+disable_so_compat_sys_timerfd_settime_fndecl_32068 compat_sys_timerfd_settime fndecl 1 32068 NULL
+disable_so_last_tsc_write_kvm_arch_32069 last_tsc_write kvm_arch 0 32069 NULL
+disable_so_timeout_mraid_mmadp_32081 timeout mraid_mmadp 0 32081 NULL
+disable_so_selinux_task_getscheduler_fndecl_32087 selinux_task_getscheduler fndecl 0 32087 NULL
+disable_so_handle_slaves_guid_change_fndecl_32090 handle_slaves_guid_change fndecl 2-3 32090 NULL
+disable_so_r68_val_fc2580_freq_regs_32091 r68_val fc2580_freq_regs 0 32091 NULL
+disable_so_cx23885_set_frequency_fndecl_32119 cx23885_set_frequency fndecl 0 32119 NULL
+disable_so_freqn_snd_usb_endpoint_32123 freqn snd_usb_endpoint 0 32123 NULL
+disable_so_prandom_bytes_fndecl_32129 prandom_bytes fndecl 2 32129 NULL nohasharray
+disable_so_tfmsize_crypto_type_32129 tfmsize crypto_type 0 32129 &disable_so_prandom_bytes_fndecl_32129
+disable_so_freq_ar9170_calibration_target_power_legacy_32133 freq ar9170_calibration_target_power_legacy 0 32133 NULL nohasharray
+disable_so_addr_buffer_state_32133 addr buffer_state 0 32133 &disable_so_freq_ar9170_calibration_target_power_legacy_32133
+enable_so_max_rate_idx_ieee80211_tx_rate_control_32134 max_rate_idx ieee80211_tx_rate_control 0 32134 NULL nohasharray
+disable_so_btree_invalidatepage_fndecl_32134 btree_invalidatepage fndecl 2 32134 &enable_so_max_rate_idx_ieee80211_tx_rate_control_32134
+disable_so_hfs_bnode_findhash_fndecl_32138 hfs_bnode_findhash fndecl 2 32138 NULL
+disable_so_symhash_fndecl_32144 symhash fndecl 0 32144 NULL
+disable_so_ahc_print_register_fndecl_32148 ahc_print_register fndecl 5 32148 NULL
+disable_so_rq_majortimeo_rpc_rqst_32158 rq_majortimeo rpc_rqst 0 32158 NULL
+disable_so_ber_jiffies_stats_dib7000p_state_32159 ber_jiffies_stats dib7000p_state 0 32159 NULL
+disable_so_i_mtime_f2fs_inode_32162 i_mtime f2fs_inode 0 32162 NULL
+disable_so_addr_cistpl_checksum_t_32163 addr cistpl_checksum_t 0 32163 NULL
+disable_so_n_fll_div_32168 n fll_div 0 32168 NULL
+disable_so_advance_jiffies_uhci_qh_32179 advance_jiffies uhci_qh 0 32179 NULL
+disable_so_query_dv_timings_last_vivid_dev_32182 query_dv_timings_last vivid_dev 0 32182 NULL
+disable_so_mlx4_reset_roce_gids_fndecl_32207 mlx4_reset_roce_gids fndecl 2 32207 NULL
+disable_so_addr_rec_vals_32208 addr rec_vals 0 32208 NULL
+disable_so_chunks_bitmap_counts_32213 chunks bitmap_counts 0 32213 NULL
+disable_so_irq_create_mapping_fndecl_32230 irq_create_mapping fndecl 0-2 32230 NULL
+disable_so_addr_lo_eth_tx_start_bd_32234 addr_lo eth_tx_start_bd 0 32234 NULL
+disable_so_radeon_irq_kms_sw_irq_get_delayed_fndecl_32235 radeon_irq_kms_sw_irq_get_delayed fndecl 2 32235 NULL
+disable_so_irlap_start_slot_timer_fndecl_32236 irlap_start_slot_timer fndecl 2 32236 NULL
+disable_so_get_timeout_fndecl_32254 get_timeout fndecl 0 32254 NULL
+disable_so_smk_open_netlbladdr_fndecl_32279 smk_open_netlbladdr fndecl 0 32279 NULL
+disable_so_cifs_dfs_mountpoint_expiry_timeout_vardecl_cifs_dfs_ref_c_32281 cifs_dfs_mountpoint_expiry_timeout vardecl_cifs_dfs_ref.c 0 32281 NULL
+disable_so_freq_stb0899_internal_32287 freq stb0899_internal 0 32287 NULL
+disable_so_crypto_cmac_digest_update_fndecl_32293 crypto_cmac_digest_update fndecl 3 32293 NULL
+disable_so_sirf_usp_pcm_runtime_resume_fndecl_32303 sirf_usp_pcm_runtime_resume fndecl 0 32303 NULL
+disable_so_show_state_time_fndecl_32307 show_state_time fndecl 0 32307 NULL
+disable_so_max_freq_dw_spi_32310 max_freq dw_spi 0 32310 NULL
+disable_so_msg_stime_msqid64_ds_32312 msg_stime msqid64_ds 0 32312 NULL
+disable_so_xtalfreq_brcms_phy_32317 xtalfreq brcms_phy 0 32317 NULL
+disable_so_cpu_to_be32_array_fndecl_32318 cpu_to_be32_array fndecl 3 32318 NULL
+disable_so_addr_tuner_setup_32321 addr tuner_setup 0 32321 NULL
+disable_so_schedule_timeout_interruptible_fndecl_32331 schedule_timeout_interruptible fndecl 0-1 32331 NULL
+disable_so_shm16read_addr_next_b43_dfsentry_32334 shm16read_addr_next b43_dfsentry 0 32334 NULL
+disable_so_ver_sync_start_via_display_timing_32337 ver_sync_start via_display_timing 0 32337 NULL
+disable_so_ath9k_hw_synth_delay_fndecl_32339 ath9k_hw_synth_delay fndecl 3 32339 NULL
+disable_so_sys_setpgid_fndecl_32340 sys_setpgid fndecl 1-2 32340 NULL
+disable_so_mmc_test_random_read_perf_fndecl_32342 mmc_test_random_read_perf fndecl 0 32342 NULL nohasharray
+disable_so_addrmax_vxlan_dev_32342 addrmax vxlan_dev 0 32342 &disable_so_mmc_test_random_read_perf_fndecl_32342
+disable_so_interrupt_in_interval_ld_usb_32353 interrupt_in_interval ld_usb 0 32353 NULL
+disable_so_mlx4_ib_slave_alias_guid_event_fndecl_32363 mlx4_ib_slave_alias_guid_event fndecl 2-3 32363 NULL
+disable_so_usb_addr_u132_udev_32366 usb_addr u132_udev 0 32366 NULL
+disable_so_account_shared_subtree_fndecl_32369 account_shared_subtree fndecl 4-5 32369 NULL
+disable_so_process_tgid_exec_proc_event_32371 process_tgid exec_proc_event 0 32371 NULL
+disable_so_resp_bd_list_addr_hi_bnx2i_text_request_32375 resp_bd_list_addr_hi bnx2i_text_request 0 32375 NULL nohasharray
+disable_so_rhashtable_lookup_insert_key_fndecl_32375 rhashtable_lookup_insert_key fndecl 0 32375 &disable_so_resp_bd_list_addr_hi_bnx2i_text_request_32375
+disable_so_last_ave_beacon_signal_ieee80211_if_managed_32405 last_ave_beacon_signal ieee80211_if_managed 0 32405 NULL
+disable_so_vml_nearest_clock_fndecl_32407 vml_nearest_clock fndecl 1-0 32407 NULL
+disable_so_silence_start_snd_pcm_runtime_32410 silence_start snd_pcm_runtime 0 32410 NULL
+disable_so_setfreq_fndecl_32411 setfreq fndecl 2 32411 NULL
+disable_so_nent_kvm_cpuid_32413 nent kvm_cpuid 0 32413 NULL
+disable_so_try_to_del_timer_sync_fndecl_32416 try_to_del_timer_sync fndecl 0 32416 NULL
+disable_so_rtc_timer_start_fndecl_32417 rtc_timer_start fndecl 0 32417 NULL nohasharray
+disable_so_get_cur_freq_fndecl_32417 get_cur_freq fndecl 1 32417 &disable_so_rtc_timer_start_fndecl_32417
+disable_so_rf_set_freq_ath_hw_private_ops_32419 rf_set_freq ath_hw_private_ops 0 32419 NULL
+disable_so_buffer_addr_pch_gbe_rx_desc_32427 buffer_addr pch_gbe_rx_desc 0 32427 NULL
+disable_so_ath_chanctx_setup_timer_fndecl_32434 ath_chanctx_setup_timer fndecl 2 32434 NULL nohasharray
+disable_so_top_mlx4_bitmap_32434 top mlx4_bitmap 0 32434 &disable_so_ath_chanctx_setup_timer_fndecl_32434
+disable_so_addr_acl_ip_label_32438 addr acl_ip_label 0 32438 NULL nohasharray
+disable_so_center_freq_seg2_idx_ieee80211_vht_operation_32438 center_freq_seg2_idx ieee80211_vht_operation 0 32438 &disable_so_addr_acl_ip_label_32438
+disable_so_dn_sockaddr2username_fndecl_32446 dn_sockaddr2username fndecl 0 32446 NULL
+disable_so_lasttime_vardecl_xfs_buf_item_c_32457 lasttime vardecl_xfs_buf_item.c 0 32457 NULL
+disable_so___btrfs_add_delayed_deletion_item_fndecl_32458 __btrfs_add_delayed_deletion_item fndecl 0 32458 NULL
+disable_so_pm_autosleep_lock_fndecl_32459 pm_autosleep_lock fndecl 0 32459 NULL
+disable_so_bitmap_storage_alloc_fndecl_32460 bitmap_storage_alloc fndecl 2-4 32460 NULL nohasharray
+disable_so_num_emulated_msrs_vardecl_x86_c_32460 num_emulated_msrs vardecl_x86.c 0 32460 &disable_so_bitmap_storage_alloc_fndecl_32460
+disable_so_C_SYSC_signalfd4_fndecl_32461 C_SYSC_signalfd4 fndecl 0-4 32461 NULL nohasharray
+disable_so_io_ctl_read_bitmap_fndecl_32461 io_ctl_read_bitmap fndecl 0 32461 &disable_so_C_SYSC_signalfd4_fndecl_32461
+disable_so_address_u132_addr_32463 address u132_addr 0 32463 NULL
+disable_so_att_dev_sas_addr_mvs_phy_32465 att_dev_sas_addr mvs_phy 0 32465 NULL
+disable_so_next_status_checked_time_sp2_32472 next_status_checked_time sp2 0 32472 NULL
+disable_so_address_i2400m_poke_table_32473 address i2400m_poke_table 0 32473 NULL
+disable_so_time_slice_sched_rt_entity_32475 time_slice sched_rt_entity 0 32475 NULL nohasharray
+disable_so_xfs_btree_ptr_to_daddr_fndecl_32475 xfs_btree_ptr_to_daddr fndecl 0 32475 &disable_so_time_slice_sched_rt_entity_32475
+disable_so_br_multicast_update_query_timer_fndecl_32479 br_multicast_update_query_timer fndecl 3 32479 NULL
+disable_so_rpa_timeout_hci_dev_32482 rpa_timeout hci_dev 0 32482 NULL
+disable_so_retry_delay_timestamp_bnx2fc_rport_32484 retry_delay_timestamp bnx2fc_rport 0 32484 NULL
+disable_so_ext4_mark_bitmap_end_fndecl_32489 ext4_mark_bitmap_end fndecl 1-2 32489 NULL
+disable_so_hw_start_time_ieee80211_roc_work_32492 hw_start_time ieee80211_roc_work 0 32492 NULL
+disable_so_enq_busaddr_ips_ha_32493 enq_busaddr ips_ha 0 32493 NULL
+disable_so_xfs_btree_rshift_fndecl_32496 xfs_btree_rshift fndecl 0 32496 NULL
+disable_so_reqsize_ablkcipher_tfm_32500 reqsize ablkcipher_tfm 0 32500 NULL
+disable_so_checkani_timer_ath_ani_32510 checkani_timer ath_ani 0 32510 NULL
+disable_so_refdiv_cx24113_state_32517 refdiv cx24113_state 0 32517 NULL
+disable_so_clock_divn_sym_hcb_32524 clock_divn sym_hcb 0 32524 NULL nohasharray
+disable_so_delay_qla4_83xx_reset_entry_hdr_32524 delay qla4_83xx_reset_entry_hdr 0 32524 &disable_so_clock_divn_sym_hcb_32524
+disable_so_write_bitmap_entries_fndecl_32527 write_bitmap_entries fndecl 0 32527 NULL
+disable_so_next_timer_tvec_base_32537 next_timer tvec_base 0 32537 NULL nohasharray
+disable_so_daddr_irlan_cb_32537 daddr irlan_cb 0 32537 &disable_so_next_timer_tvec_base_32537
+disable_so_demod_address_dib3000_config_32538 demod_address dib3000_config 0 32538 NULL
+disable_so_bc_blocklog_xfs_btree_cur_32544 bc_blocklog xfs_btree_cur 0 32544 NULL
+disable_so_delay_rts_before_send_serial_rs485_32545 delay_rts_before_send serial_rs485 0 32545 NULL
+disable_so___skb_tx_hash_fndecl_32547 __skb_tx_hash fndecl 0-3 32547 NULL
+disable_so_get_mac_address_qlcnic_hardware_ops_32567 get_mac_address qlcnic_hardware_ops 3 32567 NULL
+disable_so_cpu_clock_sample_fndecl_32583 cpu_clock_sample fndecl 1 32583 NULL
+disable_so_n__fll_div_32585 n _fll_div 0 32585 NULL
+disable_so_addr_l_qla2xxx_fce_chain_32589 addr_l qla2xxx_fce_chain 0 32589 NULL
+disable_so___bitmap_weight_fndecl_32591 __bitmap_weight fndecl 0-2 32591 NULL
+disable_so_cac_time_ms_wireless_dev_32596 cac_time_ms wireless_dev 0 32596 NULL
+disable_so_spi_pioavailaddr_ipath_base_info_32598 spi_pioavailaddr ipath_base_info 0 32598 NULL
+disable_so_timestamp_carm_msg_sync_time_32600 timestamp carm_msg_sync_time 0 32600 NULL
+disable_so_kstrtoint_from_user_fndecl_32601 kstrtoint_from_user fndecl 2-0 32601 NULL
+disable_so_rtc_read_time_fndecl_32605 rtc_read_time fndecl 0 32605 NULL
+disable_so_intel_fuzzy_clock_check_fndecl_32608 intel_fuzzy_clock_check fndecl 1-2 32608 NULL
+disable_so_beacon_interval_iwl_rxon_time_cmd_32609 beacon_interval iwl_rxon_time_cmd 0 32609 NULL nohasharray
+disable_so_ac_etime_taskstats_32609 ac_etime taskstats 0 32609 &disable_so_beacon_interval_iwl_rxon_time_cmd_32609
+disable_so_pcie_sbdf_set_error_type_with_address_32610 pcie_sbdf set_error_type_with_address 0 32610 NULL nohasharray
+disable_so_mwifiex_get_center_freq_index_fndecl_32610 mwifiex_get_center_freq_index fndecl 0-3 32610 &disable_so_pcie_sbdf_set_error_type_with_address_32610
+disable_so_table_instance_rehash_fndecl_32621 table_instance_rehash fndecl 2 32621 NULL
+disable_so_btrfs_timespec_nsec_fndecl_32628 btrfs_timespec_nsec fndecl 0 32628 NULL
+disable_so_pll2_r2_div_ad9523_platform_data_32641 pll2_r2_div ad9523_platform_data 0 32641 NULL
+disable_so_ahash_op_unaligned_fndecl_32645 ahash_op_unaligned fndecl 0 32645 NULL
+disable_so_pm3fb_calculate_clock_fndecl_32653 pm3fb_calculate_clock fndecl 1 32653 NULL
+disable_so___load_block_bitmap_fndecl_32655 __load_block_bitmap fndecl 0-3 32655 NULL
+disable_so_timeout_blk_mq_tag_set_32657 timeout blk_mq_tag_set 0 32657 NULL
+disable_so_rangelow_v4l2_frequency_band_32670 rangelow v4l2_frequency_band 0 32670 NULL
+disable_so_crypto_rng_get_bytes_fndecl_32675 crypto_rng_get_bytes fndecl 0-3 32675 NULL
+disable_so_ns_ctime_the_nilfs_32681 ns_ctime the_nilfs 0 32681 NULL
+disable_so_m41t80_sysfs_show_sqwfreq_fndecl_32683 m41t80_sysfs_show_sqwfreq fndecl 0 32683 NULL
+disable_so_level_irq_udelay_cyttsp4_core_platform_data_32688 level_irq_udelay cyttsp4_core_platform_data 0 32688 NULL nohasharray
+disable_so_gma_bus_addr__intel_private_32688 gma_bus_addr _intel_private 0 32688 &disable_so_level_irq_udelay_cyttsp4_core_platform_data_32688
+disable_so_e4000_sleep_fndecl_32694 e4000_sleep fndecl 0 32694 NULL
+disable_so_snd_riptide_interrupt_fndecl_32696 snd_riptide_interrupt fndecl 1 32696 NULL nohasharray
+disable_so_max_spi_freq_wm0010_priv_32696 max_spi_freq wm0010_priv 0 32696 &disable_so_snd_riptide_interrupt_fndecl_32696
+disable_so_s_mtime_ext4_super_block_32699 s_mtime ext4_super_block 0 32699 NULL
+disable_so_dma_addr_dm1105_dev_32704 dma_addr dm1105_dev 0 32704 NULL
+disable_so_vmx_preemption_timer_value_vmcs12_32707 vmx_preemption_timer_value vmcs12 0 32707 NULL nohasharray
+disable_so_uid_fileEntry_32707 uid fileEntry 0 32707 &disable_so_vmx_preemption_timer_value_vmcs12_32707
+disable_so_saffirepro_both_clk_freq_get_fndecl_32709 saffirepro_both_clk_freq_get fndecl 0 32709 NULL
+disable_so_cx231xx_s_frequency_fndecl_32713 cx231xx_s_frequency fndecl 0 32713 NULL
+disable_so_sys_getgid_fndecl_32720 sys_getgid fndecl 0 32720 NULL
+disable_so_tuner_address_zl10036_config_32733 tuner_address zl10036_config 0 32733 NULL
+disable_so_max_medium_access_timeouts_store_fndecl_32735 max_medium_access_timeouts_store fndecl 0-4 32735 NULL
+disable_so_cyapa_sleep_time_to_pwr_cmd_fndecl_32740 cyapa_sleep_time_to_pwr_cmd fndecl 0-1 32740 NULL
+disable_so_s5m_rtc_read_time_fndecl_32755 s5m_rtc_read_time fndecl 0 32755 NULL
+disable_so_i2c_read_le16_fndecl_32758 i2c_read_le16 fndecl 0 32758 NULL
+disable_so_sysctl_rose_ack_hold_back_timeout_vardecl_32768 sysctl_rose_ack_hold_back_timeout vardecl 0 32768 NULL
+disable_so_pentium4_get_frequency_fndecl_32777 pentium4_get_frequency fndecl 0 32777 NULL
+disable_so_divider_phase_ad9523_channel_spec_32779 divider_phase ad9523_channel_spec 0 32779 NULL
+disable_so_s_nr_groups_udf_bitmap_32784 s_nr_groups udf_bitmap 0 32784 NULL
+disable_so_acpi_dev_runtime_resume_fndecl_32787 acpi_dev_runtime_resume fndecl 0 32787 NULL
+disable_so_posted_intr_desc_addr_vmcs12_32788 posted_intr_desc_addr vmcs12 0 32788 NULL
+disable_so_acpi_enter_sleep_state_fndecl_32791 acpi_enter_sleep_state fndecl 0-1 32791 NULL
+disable_so_lola_init_clock_widget_fndecl_32800 lola_init_clock_widget fndecl 0 32800 NULL
+disable_so_blocksize_ablkcipher_walk_32810 blocksize ablkcipher_walk 0 32810 NULL
+disable_so_ctime_msdos_dir_entry_32811 ctime msdos_dir_entry 0 32811 NULL
+disable_so_hpi_tuner_get_frequency_fndecl_32813 hpi_tuner_get_frequency fndecl 0-1 32813 NULL
+disable_so_rhashtable_lookup_insert_fast_fndecl_32820 rhashtable_lookup_insert_fast fndecl 0 32820 NULL
+disable_so_sync_freq_max8952_platform_data_32822 sync_freq max8952_platform_data 0 32822 NULL
+disable_so_timeout_rc_dev_32826 timeout rc_dev 0 32826 NULL
+disable_so_to_c2_data_addr_32827 to c2_data_addr 0 32827 NULL
+disable_so_il4965_tfd_tb_get_addr_fndecl_32833 il4965_tfd_tb_get_addr fndecl 0 32833 NULL
+disable_so_ctnl_timeout_dump_fndecl_32835 ctnl_timeout_dump fndecl 0 32835 NULL nohasharray
+disable_so_nouveau_pmops_runtime_suspend_fndecl_32835 nouveau_pmops_runtime_suspend fndecl 0 32835 &disable_so_ctnl_timeout_dump_fndecl_32835
+disable_so_kvm_get_apic_interrupt_fndecl_32843 kvm_get_apic_interrupt fndecl 0 32843 NULL
+disable_so_do_bit_flips_fndecl_32848 do_bit_flips fndecl 2 32848 NULL
+disable_so_bitmap_xor_fndecl_32858 bitmap_xor fndecl 4 32858 NULL
+disable_so_vdelay_bttv_tvnorm_32863 vdelay bttv_tvnorm 0 32863 NULL
+disable_so_rt_dbmsignal_ipw_rt_hdr_32871 rt_dbmsignal ipw_rt_hdr 0 32871 NULL
+disable_so_rtc_set_ntp_time_fndecl_32881 rtc_set_ntp_time fndecl 0 32881 NULL
+disable_so_hash_conntrack_raw_fndecl_32882 hash_conntrack_raw fndecl 0 32882 NULL
+disable_so_find_mc_by_sys_addr_fndecl_32888 find_mc_by_sys_addr fndecl 2 32888 NULL
+disable_so_low_mcp_dma_addr_32890 low mcp_dma_addr 0 32890 NULL
+disable_so_rds_cmsg_atomic_fndecl_32895 rds_cmsg_atomic fndecl 0 32895 NULL
+disable_so___hw_addr_add_ex_fndecl_32899 __hw_addr_add_ex fndecl 0-3 32899 NULL
+disable_so_xfs_btree_decrement_fndecl_32925 xfs_btree_decrement fndecl 0 32925 NULL
+disable_so_nilfs_btree_prepare_propagate_v_fndecl_32937 nilfs_btree_prepare_propagate_v fndecl 0 32937 NULL
+disable_so_m41t80_rtc_read_time_fndecl_32947 m41t80_rtc_read_time fndecl 0 32947 NULL
+disable_so_address_ci_hdrc_32962 address ci_hdrc 0 32962 NULL
+disable_so_tua9001_sleep_fndecl_32966 tua9001_sleep fndecl 0 32966 NULL
+disable_so_pm_generic_runtime_resume_fndecl_32968 pm_generic_runtime_resume fndecl 0 32968 NULL
+disable_so_dma_addr_chunk_32969 dma_addr chunk 0 32969 NULL
+disable_so_dm_attr_uuid_show_fndecl_32981 dm_attr_uuid_show fndecl 0 32981 NULL
+disable_so_ac_stime_acct_v3_32985 ac_stime acct_v3 0 32985 NULL
+disable_so_int_freq_r820t_priv_32987 int_freq r820t_priv 0 32987 NULL
+disable_so_r8_pt_regs_32990 r8 pt_regs 0 32990 NULL
+disable_so_address_TAG_TW_SG_Entry_ISO_32992 address TAG_TW_SG_Entry_ISO 0 32992 NULL
+disable_so_segment0_blkaddr_f2fs_super_block_32995 segment0_blkaddr f2fs_super_block 0 32995 NULL
+disable_so_time_of_death_afs_vlocation_32996 time_of_death afs_vlocation 0 32996 NULL
+disable_so_addrm_unknown_feature_attrs_fndecl_33000 addrm_unknown_feature_attrs fndecl 0 33000 NULL
+disable_so_monotonic_time_sec_vsyscall_gtod_data_33004 monotonic_time_sec vsyscall_gtod_data 0 33004 NULL
+disable_so_tv_hsync_delay_nv04_crtc_reg_33012 tv_hsync_delay nv04_crtc_reg 0 33012 NULL
+disable_so_neigh_proc_base_reachable_time_fndecl_33013 neigh_proc_base_reachable_time fndecl 0 33013 NULL
+disable_so_ocfs2_unlink_subtree_fndecl_33022 ocfs2_unlink_subtree fndecl 5 33022 NULL
+disable_so_poll_time_max3100_port_33028 poll_time max3100_port 0 33028 NULL
+disable_so_compat_sys_time_fndecl_33034 compat_sys_time fndecl 0 33034 NULL nohasharray
+disable_so_m_osc_clock_freq_drxk_state_33034 m_osc_clock_freq drxk_state 0 33034 &disable_so_compat_sys_time_fndecl_33034
+disable_so_dev_addr_mmc_test_area_33044 dev_addr mmc_test_area 0 33044 NULL
+disable_so_ntp_tick_timekeeper_33046 ntp_tick timekeeper 0 33046 NULL
+disable_so_day_tomoyo_time_33064 day tomoyo_time 0 33064 NULL
+disable_so_wait_time_stamp_lpfc_bsg_event_33070 wait_time_stamp lpfc_bsg_event 0 33070 NULL
+disable_so_vblank_hi_lvds_dvo_timing_33077 vblank_hi lvds_dvo_timing 0 33077 NULL
+disable_so_cycle_last_timecounter_33078 cycle_last timecounter 0 33078 NULL
+disable_so_ql_write_page0_reg_fndecl_33082 ql_write_page0_reg fndecl 3 33082 NULL
+disable_so_dma_addr_mic_smpt_33090 dma_addr mic_smpt 0 33090 NULL
+disable_so_torture_random_fndecl_33096 torture_random fndecl 0 33096 NULL
+disable_so_collect_signal_fndecl_33097 collect_signal fndecl 1 33097 NULL
+disable_so_free_count_reiserfs_bitmap_info_33099 free_count reiserfs_bitmap_info 0 33099 NULL
+disable_so_sys_clock_gettime_fndecl_33100 sys_clock_gettime fndecl 1 33100 NULL
+disable_so_word_write_time_max_flchip_33105 word_write_time_max flchip 0 33105 NULL nohasharray
+disable_so_y_gsc_addr_33105 y gsc_addr 0 33105 &disable_so_word_write_time_max_flchip_33105
+disable_so_prdaddr_atp_id_33111 prdaddr atp_id 0 33111 NULL nohasharray
+disable_so_intel_fdi_link_freq_fndecl_33111 intel_fdi_link_freq fndecl 0 33111 &disable_so_prdaddr_atp_id_33111
+disable_so_soft_use_expires_seconds_xfrm_lifetime_cfg_33115 soft_use_expires_seconds xfrm_lifetime_cfg 0 33115 NULL
+disable_so_strtobool_fndecl_33116 strtobool fndecl 0 33116 NULL
+disable_so_smsc95xx_hash_fndecl_33122 smsc95xx_hash fndecl 0 33122 NULL
+disable_so_mce_device_create_fndecl_33128 mce_device_create fndecl 1-0 33128 NULL
+disable_so_ip6addrlbl_net_init_fndecl_33129 ip6addrlbl_net_init fndecl 0 33129 NULL
+disable_so_brcms_b_set_addrmatch_fndecl_33130 brcms_b_set_addrmatch fndecl 2 33130 NULL
+disable_so_tracer_tgid_ptrace_proc_event_33131 tracer_tgid ptrace_proc_event 0 33131 NULL
+disable_so_pretimeout_vardecl_kempld_wdt_c_33137 pretimeout vardecl_kempld_wdt.c 0 33137 NULL
+disable_so_o2net_set_usertimeout_fndecl_33145 o2net_set_usertimeout fndecl 0 33145 NULL nohasharray
+disable_so_cryptd_blkcipher_encrypt_enqueue_fndecl_33145 cryptd_blkcipher_encrypt_enqueue fndecl 0 33145 &disable_so_o2net_set_usertimeout_fndecl_33145
+disable_so_q_stime_msg_queue_33150 q_stime msg_queue 0 33150 NULL
+disable_so_cursor_cache_gpu_addr_ast_private_33160 cursor_cache_gpu_addr ast_private 0 33160 NULL
+disable_so_clockid_to_kclock_fndecl_33163 clockid_to_kclock fndecl 1 33163 NULL
+disable_so_address_ipr_ioadl64_desc_33170 address ipr_ioadl64_desc 0 33170 NULL
+disable_so_wl1271_acx_sleep_auth_fndecl_33172 wl1271_acx_sleep_auth fndecl 0 33172 NULL nohasharray
+disable_so_addr_mii_phy_33172 addr mii_phy 0 33172 &disable_so_wl1271_acx_sleep_auth_fndecl_33172
+disable_so_cr_camif_addr_33181 cr camif_addr 0 33181 NULL
+disable_so___bch_btree_mark_key_fndecl_33194 __bch_btree_mark_key fndecl 2 33194 NULL
+disable_so_mem_addr_m3_list_33199 mem_addr m3_list 0 33199 NULL
+disable_so_start_time_tx_traffic_info_33206 start_time tx_traffic_info 0 33206 NULL
+disable_so_crypto_aead_decrypt_fndecl_33207 crypto_aead_decrypt fndecl 0 33207 NULL
+disable_so_i_mtime_ext2_inode_33209 i_mtime ext2_inode 0 33209 NULL
+disable_so_mei_me_pm_runtime_resume_fndecl_33216 mei_me_pm_runtime_resume fndecl 0 33216 NULL
+disable_so_irq_free_descs_fndecl_33218 irq_free_descs fndecl 1-2 33218 NULL
+disable_so_tune_freq_si476x_radio_ops_33229 tune_freq si476x_radio_ops 0 33229 NULL
+disable_so_increase_address_space_fndecl_33247 increase_address_space fndecl 2 33247 NULL
+disable_so_ps_timeout_vardecl_pseudo_h_33252 ps_timeout vardecl_pseudo.h 0 33252 NULL
+disable_so_init_jiffies_clocksource_fndecl_33253 init_jiffies_clocksource fndecl 0 33253 NULL
+disable_so_do_cpu_nanosleep_fndecl_33255 do_cpu_nanosleep fndecl 1 33255 NULL
+disable_so_efi_thunk_set_virtual_address_map_fndecl_33273 efi_thunk_set_virtual_address_map fndecl 2-3 33273 NULL
+disable_so_ring_physaddr_fbr_lookup_33275 ring_physaddr fbr_lookup 0 33275 NULL
+disable_so_wakeup_prevent_sleep_time_show_fndecl_33280 wakeup_prevent_sleep_time_show fndecl 0 33280 NULL nohasharray
+disable_so_isi_camera_clock_start_fndecl_33280 isi_camera_clock_start fndecl 0 33280 &disable_so_wakeup_prevent_sleep_time_show_fndecl_33280 nohasharray
+disable_so_rsdt_physical_address_acpi_table_rsdp_33280 rsdt_physical_address acpi_table_rsdp 0 33280 &disable_so_isi_camera_clock_start_fndecl_33280 nohasharray
+disable_so_ccp_aes_rfc3686_setkey_fndecl_33280 ccp_aes_rfc3686_setkey fndecl 3 33280 &disable_so_rsdt_physical_address_acpi_table_rsdp_33280
+disable_so_jiffies_to_clock_t_fndecl_33285 jiffies_to_clock_t fndecl 0-1 33285 NULL
+disable_so_gpu_addr_radeon_ib_33291 gpu_addr radeon_ib 0 33291 NULL
+disable_so_crypto_rfc4106_setkey_fndecl_33297 crypto_rfc4106_setkey fndecl 0-3 33297 NULL
+disable_so_crypto_rfc4309_encrypt_fndecl_33306 crypto_rfc4309_encrypt fndecl 0 33306 NULL
+disable_so_xhci_calculate_lpm_timeout_fndecl_33310 xhci_calculate_lpm_timeout fndecl 0 33310 NULL
+disable_so_addr_high_mcp_kreq_ether_send_33319 addr_high mcp_kreq_ether_send 0 33319 NULL
+disable_so_calc_divisor_fndecl_33333 calc_divisor fndecl 0 33333 NULL
+disable_so_i2c_address_dib0070_config_33334 i2c_address dib0070_config 0 33334 NULL
+disable_so_alloc_sleep_millisecs_show_fndecl_33339 alloc_sleep_millisecs_show fndecl 0 33339 NULL nohasharray
+disable_so_hpi_tuner_set_frequency_fndecl_33339 hpi_tuner_set_frequency fndecl 0-1 33339 &disable_so_alloc_sleep_millisecs_show_fndecl_33339
+disable_so_sysctl_aarp_tick_time_vardecl_33343 sysctl_aarp_tick_time vardecl 0 33343 NULL
+disable_so_stv0367cab_set_derot_freq_fndecl_33348 stv0367cab_set_derot_freq fndecl 0-2-3 33348 NULL
+disable_so_pkt_phys_addr_mwl8k_tx_desc_33350 pkt_phys_addr mwl8k_tx_desc 0 33350 NULL
+disable_so_addr_low_lancer_cmd_req_write_object_33351 addr_low lancer_cmd_req_write_object 0 33351 NULL
+disable_so_posix_timer_id_signal_struct_33352 posix_timer_id signal_struct 0 33352 NULL
+disable_so_s_mtime_ext2_super_block_33353 s_mtime ext2_super_block 0 33353 NULL
+disable_so_freq_wmi_remain_on_chnl_event_33368 freq wmi_remain_on_chnl_event 0 33368 NULL
+disable_so_token_time_sfb_sched_data_33369 token_time sfb_sched_data 0 33369 NULL nohasharray
+disable_so_kvmclock_offset_kvm_arch_33369 kvmclock_offset kvm_arch 0 33369 &disable_so_token_time_sfb_sched_data_33369
+disable_so_pipelines_addr_device_queue_manager_33373 pipelines_addr device_queue_manager 0 33373 NULL
+disable_so_nilfs_btree_prepare_convert_and_insert_fndecl_33375 nilfs_btree_prepare_convert_and_insert fndecl 0-2 33375 NULL
+disable_so_hash_netnet6_expire_fndecl_33396 hash_netnet6_expire fndecl 4 33396 NULL
+disable_so_ticks_snd_timer_hardware_33398 ticks snd_timer_hardware 0 33398 NULL nohasharray
+disable_so_pci_bus_max_busnr_fndecl_33398 pci_bus_max_busnr fndecl 0 33398 &disable_so_ticks_snd_timer_hardware_33398
+disable_so_start_time_search_33410 start_time search 0 33410 NULL
+disable_so_flip_addr_intel_overlay_33431 flip_addr intel_overlay 0 33431 NULL
+disable_so_sync_single_for_cpu_dma_map_ops_33433 sync_single_for_cpu dma_map_ops 2-3 33433 NULL
+disable_so_di_ctime_logfs_disk_inode_33435 di_ctime logfs_disk_inode 0 33435 NULL
+disable_so_ocfs2_divide_xattr_bucket_fndecl_33455 ocfs2_divide_xattr_bucket fndecl 0 33455 NULL
+disable_so_sbp_tpg_attrib_show_mgt_orb_timeout_fndecl_33467 sbp_tpg_attrib_show_mgt_orb_timeout fndecl 0 33467 NULL
+disable_so_btrfs_set_free_space_bitmaps_fndecl_33481 btrfs_set_free_space_bitmaps fndecl 3 33481 NULL
+disable_so_demod_address_stv0299_config_33483 demod_address stv0299_config 0 33483 NULL
+disable_so_lbs_sleepparams_write_fndecl_33488 lbs_sleepparams_write fndecl 0-3 33488 NULL
+disable_so_start_time_edac_device_ctl_info_33489 start_time edac_device_ctl_info 0 33489 NULL
+disable_so_addr_f71805f_data_33493 addr f71805f_data 0 33493 NULL
+disable_so_mcgcap_mce_33500 mcgcap mce 0 33500 NULL
+disable_so___smp_spurious_interrupt_fndecl_33501 __smp_spurious_interrupt fndecl 1 33501 NULL
+disable_so_acpi_pad_rrtime_show_fndecl_33511 acpi_pad_rrtime_show fndecl 0 33511 NULL
+disable_so_crypto_ctr_module_init_fndecl_33512 crypto_ctr_module_init fndecl 0 33512 NULL
+disable_so_dtim_time_iwl_mac_data_sta_33519 dtim_time iwl_mac_data_sta 0 33519 NULL
+disable_so_start_signal_voltage_switch_mmc_host_ops_33520 start_signal_voltage_switch mmc_host_ops 0 33520 NULL
+disable_so_ui_atime_ufs2_inode_33541 ui_atime ufs2_inode 0 33541 NULL nohasharray
+disable_so_pll_prediv_dib0090_io_config_33541 pll_prediv dib0090_io_config 0 33541 &disable_so_ui_atime_ufs2_inode_33541
+disable_so_synchronize_irq_fndecl_33551 synchronize_irq fndecl 1 33551 NULL
+disable_so_addrconf_disable_ipv6_fndecl_33555 addrconf_disable_ipv6 fndecl 0 33555 NULL
+disable_so_addr_RxDesc_33558 addr RxDesc 0 33558 NULL
+disable_so_rtc_irq_set_freq_fndecl_33559 rtc_irq_set_freq fndecl 0 33559 NULL
+disable_so_md4_mod_init_fndecl_33560 md4_mod_init fndecl 0 33560 NULL
+disable_so_addr_1_qla8044_minidump_entry_pollwr_33561 addr_1 qla8044_minidump_entry_pollwr 0 33561 NULL
+disable_so_decnet_address_vardecl_33562 decnet_address vardecl 0 33562 NULL
+disable_so_tx_bseq_addr_bnx2_tx_ring_info_33563 tx_bseq_addr bnx2_tx_ring_info 0 33563 NULL
+disable_so_clock_sched_clock_data_33565 clock sched_clock_data 0 33565 NULL
+disable_so_va_uid_coda_vattr_33569 va_uid coda_vattr 0 33569 NULL
+disable_so_timeout_RioCommand_33570 timeout RioCommand 0 33570 NULL
+disable_so_ramp_time_pcf50633_bl_platform_data_33574 ramp_time pcf50633_bl_platform_data 0 33574 NULL
+disable_so_bitmap_init_from_disk_fndecl_33575 bitmap_init_from_disk fndecl 2 33575 NULL
+disable_so_startaddr_banshee_reg_33580 startaddr banshee_reg 0 33580 NULL
+disable_so_intel_pipe_to_cpu_transcoder_fndecl_33581 intel_pipe_to_cpu_transcoder fndecl 0-2 33581 NULL nohasharray
+disable_so_ctl_addr_ide_io_ports_33581 ctl_addr ide_io_ports 0 33581 &disable_so_intel_pipe_to_cpu_transcoder_fndecl_33581
+disable_so_ext4_read_inode_bitmap_fndecl_33583 ext4_read_inode_bitmap fndecl 2 33583 NULL
+disable_so_ims_pcu_ofn_bit_store_fndecl_33597 ims_pcu_ofn_bit_store fndecl 0-4 33597 NULL
+disable_so___bitmap_clear_bits_fndecl_33603 __bitmap_clear_bits fndecl 3-4 33603 NULL
+disable_so_cg_spll_spread_spectrum_2_rv730_clock_registers_33607 cg_spll_spread_spectrum_2 rv730_clock_registers 0 33607 NULL
+disable_so_cs5535_mfgpt_alloc_timer_fndecl_33609 cs5535_mfgpt_alloc_timer fndecl 1 33609 NULL
+disable_so_to_maxval_rpc_timeout_33618 to_maxval rpc_timeout 0 33618 NULL nohasharray
+disable_so_freq_freq_tbl_33618 freq freq_tbl 0 33618 &disable_so_to_maxval_rpc_timeout_33618
+disable_so_hpi_sample_clock_set_auto_fndecl_33619 hpi_sample_clock_set_auto fndecl 1-0 33619 NULL
+disable_so_addr_lo_freelQ_e_33620 addr_lo freelQ_e 0 33620 NULL
+disable_so_addr_via686a_data_33627 addr via686a_data 0 33627 NULL
+disable_so_seq_time_vardecl_33630 seq_time vardecl 0 33630 NULL
+disable_so_tgid_task_struct_33635 tgid task_struct 0 33635 NULL nohasharray
+disable_so_index_addr_read_data_fndecl_33635 index_addr_read_data fndecl 2 33635 &disable_so_tgid_task_struct_33635
+disable_so_random_fasync_fndecl_33642 random_fasync fndecl 1 33642 NULL
+disable_so_snd_usb_mixer_interrupt_v2_fndecl_33643 snd_usb_mixer_interrupt_v2 fndecl 3 33643 NULL
+disable_so_vq_vram_addr_viafb_shared_33653 vq_vram_addr viafb_shared 0 33653 NULL
+disable_so_key_index_wmi_add_cipher_key_cmd_33662 key_index wmi_add_cipher_key_cmd 0 33662 NULL
+disable_so_tpu_pwm_timer_start_fndecl_33663 tpu_pwm_timer_start fndecl 0 33663 NULL
+disable_so_interrupt_in_interval_lego_usb_tower_33664 interrupt_in_interval lego_usb_tower 0 33664 NULL
+disable_so_pr_gid_compat_elf_prpsinfo_33667 pr_gid compat_elf_prpsinfo 0 33667 NULL
+disable_so_sinit_max_init_timeo_sctp_initmsg_33681 sinit_max_init_timeo sctp_initmsg 0 33681 NULL
+disable_so_sdev_store_eh_timeout_fndecl_33688 sdev_store_eh_timeout fndecl 0-4 33688 NULL
+disable_so_uid_ceph_mds_caps_33696 uid ceph_mds_caps 0 33696 NULL
+disable_so_min_timeout_rc_dev_33699 min_timeout rc_dev 0 33699 NULL
+disable_so_addr_alx_rfd_33711 addr alx_rfd 0 33711 NULL
+disable_so_pwm_divisor_max77693_haptic_33724 pwm_divisor max77693_haptic 0 33724 NULL
+disable_so_cb710_mmc_select_clock_divider_fndecl_33732 cb710_mmc_select_clock_divider fndecl 2 33732 NULL
+disable_so_service_timer_previous_i40e_pf_33743 service_timer_previous i40e_pf 0 33743 NULL
+disable_so_btree_gc_count_keys_fndecl_33745 btree_gc_count_keys fndecl 0 33745 NULL
+disable_so_max_usec_vnic_intr_coal_timer_info_33753 max_usec vnic_intr_coal_timer_info 0 33753 NULL
+disable_so_force_hpet_address_vardecl_33758 force_hpet_address vardecl 0 33758 NULL
+disable_so_fl_addr_fib_result_nl_33759 fl_addr fib_result_nl 0 33759 NULL
+disable_so_cx231xx_i2c_recv_bytes_with_saddr_fndecl_33773 cx231xx_i2c_recv_bytes_with_saddr fndecl 0 33773 NULL
+disable_so_cursor_addr_radeon_crtc_33776 cursor_addr radeon_crtc 0 33776 NULL
+disable_so_btrfs_update_time_fndecl_33780 btrfs_update_time fndecl 0 33780 NULL
+disable_so_from_kuid_munged_fndecl_33783 from_kuid_munged fndecl 0 33783 NULL
+disable_so_irda_discover_daddr_and_lsap_sel_fndecl_33786 irda_discover_daddr_and_lsap_sel fndecl 0 33786 NULL
+disable_so_efx_probe_interrupts_fndecl_33793 efx_probe_interrupts fndecl 0 33793 NULL
+disable_so_custom_divisor_cyclades_port_33795 custom_divisor cyclades_port 0 33795 NULL
+disable_so_uli526x_interrupt_fndecl_33800 uli526x_interrupt fndecl 1 33800 NULL
+disable_so_ocrdma_add_stat_fndecl_33807 ocrdma_add_stat fndecl 0 33807 NULL
+disable_so_btrfs_set_token_inode_uid_fndecl_33810 btrfs_set_token_inode_uid fndecl 3 33810 NULL
+disable_so_iowrite32_rep_fndecl_33813 iowrite32_rep fndecl 3 33813 NULL
+disable_so_sys_setresgid_fndecl_33818 sys_setresgid fndecl 0-1-2-3 33818 NULL
+disable_so_radeon_dp_get_dp_link_clock_fndecl_33823 radeon_dp_get_dp_link_clock fndecl 0-3 33823 NULL
+disable_so_timeout__synclinkmp_info_33838 timeout _synclinkmp_info 0 33838 NULL
+disable_so_phys_addr_esas2r_mem_desc_33844 phys_addr esas2r_mem_desc 0 33844 NULL
+disable_so_cpufreq_register_notifier_fndecl_33845 cpufreq_register_notifier fndecl 0 33845 NULL
+disable_so_ufx_reg_write_fndecl_33849 ufx_reg_write fndecl 3 33849 NULL
+disable_so_kstrtou8_from_user_fndecl_33852 kstrtou8_from_user fndecl 0-2 33852 NULL
+disable_so_hpi_sample_clock_get_local_rate_fndecl_33857 hpi_sample_clock_get_local_rate fndecl 1-0 33857 NULL
+disable_so_hor_sync_start_via_display_timing_33861 hor_sync_start via_display_timing 0 33861 NULL
+disable_so_seq_netlbl_domhsh_walk_arg_33872 seq netlbl_domhsh_walk_arg 0 33872 NULL
+disable_so_wrmsrl_on_cpu_fndecl_33873 wrmsrl_on_cpu fndecl 0-1 33873 NULL
+disable_so_cpu_to_vringh32_fndecl_33880 cpu_to_vringh32 fndecl 0-2 33880 NULL
+disable_so_ni_do_program_memory_timing_parameters_fndecl_33886 ni_do_program_memory_timing_parameters fndecl 0 33886 NULL
+disable_so_comp_addr_hi_dmae_command_33889 comp_addr_hi dmae_command 0 33889 NULL
+disable_so_wl18xx_acx_interrupt_notify_config_fndecl_33899 wl18xx_acx_interrupt_notify_config fndecl 0 33899 NULL
+disable_so_creation_time_iscsi_session_33906 creation_time iscsi_session 0 33906 NULL nohasharray
+disable_so_via_clock_vardecl_pata_via_c_33906 via_clock vardecl_pata_via.c 0 33906 &disable_so_creation_time_iscsi_session_33906 nohasharray
+disable_so_bnx2x_get_rxhash_fndecl_33906 bnx2x_get_rxhash fndecl 0 33906 &disable_so_via_clock_vardecl_pata_via_c_33906
+disable_so_mmio_readl_intel_uncore_funcs_33910 mmio_readl intel_uncore_funcs 0-2 33910 NULL
+disable_so_refresh_time_e1000_fc_info_33911 refresh_time e1000_fc_info 0 33911 NULL
+disable_so_hash_fname_33923 hash fname 0 33923 NULL
+disable_so_sysctl_netrom_transport_timeout_vardecl_33929 sysctl_netrom_transport_timeout vardecl 0 33929 NULL
+disable_so_cg_spll_func_cntl_si_clock_registers_33932 cg_spll_func_cntl si_clock_registers 0 33932 NULL
+disable_so_img_ir_free_timing_fndecl_33939 img_ir_free_timing fndecl 0-2 33939 NULL
+disable_so_max_tsc_khz_vardecl_x86_c_33942 max_tsc_khz vardecl_x86.c 0 33942 NULL
+disable_so_timeout_a_tpm_vendor_specific_33951 timeout_a tpm_vendor_specific 0 33951 NULL
+disable_so_generic_cmd6_time_mmc_ext_csd_33957 generic_cmd6_time mmc_ext_csd 0 33957 NULL
+disable_so_subnet_timeout_qib_ibport_33973 subnet_timeout qib_ibport 0 33973 NULL nohasharray
+disable_so_ring_iowrite16desc_fndecl_33973 ring_iowrite16desc fndecl 2 33973 &disable_so_subnet_timeout_qib_ibport_33973 nohasharray
+disable_so_freq_tiny_spi_33973 freq tiny_spi 0 33973 &disable_so_ring_iowrite16desc_fndecl_33973
+disable_so_ip6addrlbl_del_fndecl_33977 ip6addrlbl_del fndecl 0-4 33977 NULL
+disable_so_btree_readpage_fndecl_33979 btree_readpage fndecl 0 33979 NULL
+disable_so_ifa_broadcast_in_ifaddr_33999 ifa_broadcast in_ifaddr 0 33999 NULL
+disable_so___cpuidle_register_device_fndecl_34012 __cpuidle_register_device fndecl 0 34012 NULL
+disable_so_hpfs_prefetch_bitmap_fndecl_34014 hpfs_prefetch_bitmap fndecl 2 34014 NULL
+disable_so_cur_freq_lbtf_private_34017 cur_freq lbtf_private 0 34017 NULL
+disable_so_pxa2xx_ssp_get_clk_div_fndecl_34021 pxa2xx_ssp_get_clk_div fndecl 0-3 34021 NULL
+disable_so_data_addr_acpi_ec_34022 data_addr acpi_ec 0 34022 NULL
+disable_so_sdev_runtime_resume_fndecl_34033 sdev_runtime_resume fndecl 0 34033 NULL nohasharray
+disable_so_get_aux_clock_divider_intel_dp_34033 get_aux_clock_divider intel_dp 0 34033 &disable_so_sdev_runtime_resume_fndecl_34033
+disable_so_proc_tgid_io_accounting_fndecl_34034 proc_tgid_io_accounting fndecl 0 34034 NULL
+disable_so_long_timeout_scsi_tape_34043 long_timeout scsi_tape 0 34043 NULL
+disable_so_crypto_authenc_esn_givencrypt_done_fndecl_34047 crypto_authenc_esn_givencrypt_done fndecl 2 34047 NULL
+disable_so_addr_wil_fw_data_dwrite_34059 addr wil_fw_data_dwrite 0 34059 NULL
+disable_so_shash_prepare_alg_fndecl_34073 shash_prepare_alg fndecl 0 34073 NULL
+disable_so_ccp_register_aes_algs_fndecl_34079 ccp_register_aes_algs fndecl 0 34079 NULL
+disable_so_addr_mwifiex_dma_mapping_34088 addr mwifiex_dma_mapping 0 34088 NULL
+disable_so_signal_level_hfa384x_comms_quality_34089 signal_level hfa384x_comms_quality 0 34089 NULL
+disable_so_per_jiffies_stats_dib7000p_state_34090 per_jiffies_stats dib7000p_state 0 34090 NULL nohasharray
+disable_so__ocrdma_pd_mgr_put_bitmap_fndecl_34090 _ocrdma_pd_mgr_put_bitmap fndecl 0-2 34090 &disable_so_per_jiffies_stats_dib7000p_state_34090
+disable_so_rt_mutex_timed_lock_fndecl_34096 rt_mutex_timed_lock fndecl 0 34096 NULL
+disable_so_addr_i2c_device_34103 addr i2c_device 0 34103 NULL
+disable_so_run_nmi_sleep_test_fndecl_34107 run_nmi_sleep_test fndecl 1 34107 NULL
+disable_so_distribute_cfs_runtime_fndecl_34121 distribute_cfs_runtime fndecl 0-2-3 34121 NULL
+disable_so_iscsi_nacl_attrib_store_nopin_response_timeout_fndecl_34124 iscsi_nacl_attrib_store_nopin_response_timeout fndecl 0-3 34124 NULL
+disable_so_bi_len_gfs2_bitmap_34126 bi_len gfs2_bitmap 0 34126 NULL
+disable_so_qdiv_mode_skl_wrpll_params_34127 qdiv_mode skl_wrpll_params 0 34127 NULL
+disable_so_cpuidle_enable_device_fndecl_34132 cpuidle_enable_device fndecl 0 34132 NULL
+disable_so_timer_slack_ns_task_struct_34139 timer_slack_ns task_struct 0 34139 NULL
+disable_so_mic_max_system_addr_fndecl_34141 mic_max_system_addr fndecl 0 34141 NULL nohasharray
+disable_so_ima_calc_file_shash_fndecl_34141 ima_calc_file_shash fndecl 0 34141 &disable_so_mic_max_system_addr_fndecl_34141
+disable_so_lm3533_led_get_hw_delay_fndecl_34142 lm3533_led_get_hw_delay fndecl 0 34142 NULL
+disable_so_nd_ipv4_address_o2nm_node_34144 nd_ipv4_address o2nm_node 0 34144 NULL
+disable_so_r28_val_fc2580_freq_regs_34150 r28_val fc2580_freq_regs 0 34150 NULL
+disable_so_musb_read_txfunaddr_fndecl_34175 musb_read_txfunaddr fndecl 2-0 34175 NULL
+disable_so_offset_addr_pch_udc_ep_34177 offset_addr pch_udc_ep 0 34177 NULL
+disable_so_stv0900_get_carr_freq_fndecl_34190 stv0900_get_carr_freq fndecl 0-2 34190 NULL
+disable_so_base_addr_user_desc_34191 base_addr user_desc 0 34191 NULL
+disable_so_hi_cfg_timing_div_drxj_data_34197 hi_cfg_timing_div drxj_data 0 34197 NULL
+disable_so_sha1_mb_async_finup_fndecl_34207 sha1_mb_async_finup fndecl 0 34207 NULL
+disable_so_hpi_outstream_set_time_scale_fndecl_34210 hpi_outstream_set_time_scale fndecl 1-0 34210 NULL
+disable_so_keyup_jiffies_rc_dev_34213 keyup_jiffies rc_dev 0 34213 NULL
+disable_so_inet_sk_reselect_saddr_fndecl_34214 inet_sk_reselect_saddr fndecl 0 34214 NULL
+disable_so_cm_ack_timeout_fndecl_34216 cm_ack_timeout fndecl 0-1-2 34216 NULL nohasharray
+disable_so_req_consumer_index_phy_addr_high_ql3_adapter_34216 req_consumer_index_phy_addr_high ql3_adapter 0 34216 &disable_so_cm_ack_timeout_fndecl_34216
+disable_so_nsec_to_clock_t_fndecl_34222 nsec_to_clock_t fndecl 0-1 34222 NULL
+disable_so_pch_systime_write_fndecl_34223 pch_systime_write fndecl 2 34223 NULL
+disable_so_addr_uio_mem_34242 addr uio_mem 0 34242 NULL
+disable_so_xfs_btree_split_fndecl_34248 xfs_btree_split fndecl 0 34248 NULL
+disable_so_address_acpi_pct_register_34258 address acpi_pct_register 0 34258 NULL
+disable_so_ci_otg_fsm_add_timer_fndecl_34261 ci_otg_fsm_add_timer fndecl 2 34261 NULL
+disable_so_snd_timer_resolution_fndecl_34272 snd_timer_resolution fndecl 0 34272 NULL
+disable_so_delay_rts_after_send_serial_rs485_34273 delay_rts_after_send serial_rs485 0 34273 NULL nohasharray
+disable_so_set_msr_interception_fndecl_34273 set_msr_interception fndecl 2 34273 &disable_so_delay_rts_after_send_serial_rs485_34273
+disable_so_qla4xxx_fw_ext_timestamp_show_fndecl_34274 qla4xxx_fw_ext_timestamp_show fndecl 0 34274 NULL
+disable_so_hash_ipport6_expire_fndecl_34286 hash_ipport6_expire fndecl 4 34286 NULL
+disable_so_da9063_rtc_set_time_fndecl_34291 da9063_rtc_set_time fndecl 0 34291 NULL nohasharray
+disable_so_early_cpu_to_node_fndecl_34291 early_cpu_to_node fndecl 0 34291 &disable_so_da9063_rtc_set_time_fndecl_34291
+disable_so_port_io_addr_34293 port io_addr 0 34293 NULL
+disable_so_nilfs_palloc_bitmap_blkoff_fndecl_34306 nilfs_palloc_bitmap_blkoff fndecl 0-2 34306 NULL
+disable_so_last_delaylps_stamp_jiffies_rtl_ps_ctl_34320 last_delaylps_stamp_jiffies rtl_ps_ctl 0 34320 NULL nohasharray
+disable_so_tunedfreq_s5h1420_state_34320 tunedfreq s5h1420_state 0 34320 &disable_so_last_delaylps_stamp_jiffies_rtl_ps_ctl_34320
+disable_so_rd16_nvkm_ofuncs_34339 rd16 nvkm_ofuncs 0-2 34339 NULL
+disable_so_cipher_cfg_offset_icp_qat_fw_cipher_cd_ctrl_hdr_34345 cipher_cfg_offset icp_qat_fw_cipher_cd_ctrl_hdr 0 34345 NULL
+disable_so_eeprom_delay_ipw_priv_34346 eeprom_delay ipw_priv 0 34346 NULL nohasharray
+disable_so_hpi_tone_detector_get_frequency_fndecl_34346 hpi_tone_detector_get_frequency fndecl 0-1 34346 &disable_so_eeprom_delay_ipw_priv_34346
+disable_so_intr_timer_type_vnic_fc_config_34351 intr_timer_type vnic_fc_config 0 34351 NULL
+disable_so_skcipher_null_crypt_fndecl_34354 skcipher_null_crypt fndecl 0-4 34354 NULL
+disable_so_ac_stime_taskstats_34355 ac_stime taskstats 0 34355 NULL
+disable_so_set_bit_to_user_fndecl_34358 set_bit_to_user fndecl 0 34358 NULL
+disable_so_sip_timeout_vardecl_nf_conntrack_sip_c_34365 sip_timeout vardecl_nf_conntrack_sip.c 0 34365 NULL
+disable_so_map_addr_fndecl_34371 map_addr fndecl 2-3-6-7 34371 NULL
+disable_so_rds_sysctl_reconnect_min_jiffies_vardecl_34380 rds_sysctl_reconnect_min_jiffies vardecl 0 34380 NULL
+disable_so_note_interrupt_fndecl_34381 note_interrupt fndecl 1 34381 NULL
+disable_so_addr_nv50_sync_34383 addr nv50_sync 0 34383 NULL
+disable_so_clock_gate_dis2_vlv_s0ix_state_34384 clock_gate_dis2 vlv_s0ix_state 0 34384 NULL
+disable_so_sctp_add_bind_addr_fndecl_34385 sctp_add_bind_addr fndecl 4 34385 NULL nohasharray
+disable_so_crypto_comp_decompress_fndecl_34385 crypto_comp_decompress fndecl 3 34385 &disable_so_sctp_add_bind_addr_fndecl_34385
+disable_so_s5h1409_sleep_fndecl_34392 s5h1409_sleep fndecl 2 34392 NULL
+disable_so_i2c_address_mt2266_config_34394 i2c_address mt2266_config 0 34394 NULL
+disable_so_ext4_inode_bitmap_csum_verify_fndecl_34396 ext4_inode_bitmap_csum_verify fndecl 2-5 34396 NULL
+disable_so_blocksize_crypto_report_cipher_34404 blocksize crypto_report_cipher 0 34404 NULL
+disable_so_min_dwell_time_active_conf_scan_settings_34406 min_dwell_time_active conf_scan_settings 0 34406 NULL
+disable_so_sec_ptp_clock_time_34411 sec ptp_clock_time 0 34411 NULL nohasharray
+disable_so_vxlan_nla_get_addr_fndecl_34411 vxlan_nla_get_addr fndecl 0 34411 &disable_so_sec_ptp_clock_time_34411
+disable_so_psb_intel_sdvo_create_preferred_input_timing_fndecl_34416 psb_intel_sdvo_create_preferred_input_timing fndecl 3-4 34416 NULL
+disable_so_decode_attr_bitmap_fndecl_34420 decode_attr_bitmap fndecl 0 34420 NULL
+disable_so_address_acpi_mem_space_context_34426 address acpi_mem_space_context 0 34426 NULL
+disable_so_netlbl_domhsh_hash_fndecl_34442 netlbl_domhsh_hash fndecl 0 34442 NULL
+disable_so_bdbar_addr_ichdev_34446 bdbar_addr ichdev 0 34446 NULL
+disable_so_ksm_thread_sleep_millisecs_vardecl_ksm_c_34451 ksm_thread_sleep_millisecs vardecl_ksm.c 0 34451 NULL
+disable_so_signal_ieee80211_rx_status_34458 signal ieee80211_rx_status 0 34458 NULL
+disable_so_dma_addr_cxio_hal_ctrl_qp_34469 dma_addr cxio_hal_ctrl_qp 0 34469 NULL
+disable_so_ata_lookup_timeout_table_fndecl_34470 ata_lookup_timeout_table fndecl 1 34470 NULL
+disable_so_sk_rmem_schedule_fndecl_34476 sk_rmem_schedule fndecl 3 34476 NULL
+disable_so_end_seq_tcp_sack_block_34486 end_seq tcp_sack_block 0 34486 NULL
+disable_so_min_delay_intel_ilk_power_mgmt_34505 min_delay intel_ilk_power_mgmt 0 34505 NULL
+disable_so_sol_time_fcoe_ctlr_34513 sol_time fcoe_ctlr 0 34513 NULL
+disable_so_spu_set_interrupt_mode_fndecl_34518 spu_set_interrupt_mode fndecl 0 34518 NULL
+disable_so_stmmac_interrupt_fndecl_34535 stmmac_interrupt fndecl 1 34535 NULL
+disable_so_sin6_family_sockaddr_in6_34544 sin6_family sockaddr_in6 0 34544 NULL
+disable_so_mem_addr__drm_via_descriptor_34550 mem_addr _drm_via_descriptor 0 34550 NULL
+disable_so_root_server_addr_vardecl_34556 root_server_addr vardecl 0 34556 NULL
+disable_so_pfkey_sadb_addr2xfrm_addr_fndecl_34565 pfkey_sadb_addr2xfrm_addr fndecl 0 34565 NULL
+disable_so_map_sip_addr_fndecl_34566 map_sip_addr fndecl 2-3 34566 NULL
+disable_so_path_refresh_time_mesh_config_34567 path_refresh_time mesh_config 0 34567 NULL nohasharray
+disable_so_ccp_register_sha_algs_fndecl_34567 ccp_register_sha_algs fndecl 0 34567 &disable_so_path_refresh_time_mesh_config_34567
+disable_so_max_tx_power_mwifiex_chan_freq_power_34571 max_tx_power mwifiex_chan_freq_power 0 34571 NULL
+disable_so_last_mlx4_bitmap_34590 last mlx4_bitmap 0 34590 NULL
+disable_so_alloc_cpumask_var_fndecl_34599 alloc_cpumask_var fndecl 2 34599 NULL
+disable_so_addr_macb_dma_desc_34600 addr macb_dma_desc 0 34600 NULL
+disable_so_eee_timer_vardecl_sxgbe_main_c_34602 eee_timer vardecl_sxgbe_main.c 0 34602 NULL nohasharray
+disable_so_rdx_kvm_regs_34602 rdx kvm_regs 0 34602 &disable_so_eee_timer_vardecl_sxgbe_main_c_34602
+disable_so_rsi_kvm_regs_34605 rsi kvm_regs 0 34605 NULL
+disable_so_task_tgid_nr_ns_fndecl_34623 task_tgid_nr_ns fndecl 0 34623 NULL
+disable_so_saddr_irnet_log_34630 saddr irnet_log 0 34630 NULL
+disable_so_timestart_edc_34631 timestart edc 0 34631 NULL
+disable_so_saddr_tcp4_pseudohdr_34636 saddr tcp4_pseudohdr 0 34636 NULL
+disable_so_ab3100_mask_and_set_register_interruptible_fndecl_34643 ab3100_mask_and_set_register_interruptible fndecl 0 34643 NULL
+disable_so_hsave_msr_nested_state_34651 hsave_msr nested_state 0 34651 NULL
+disable_so_schedule_timeout_uninterruptible_fndecl_34670 schedule_timeout_uninterruptible fndecl 1-0 34670 NULL
+disable_so_addr_tuner_i2c_props_34671 addr tuner_i2c_props 0 34671 NULL
+disable_so_hash_ip4_expire_fndecl_34676 hash_ip4_expire fndecl 4 34676 NULL
+disable_so_rxfunaddr_musb_csr_regs_34678 rxfunaddr musb_csr_regs 0 34678 NULL
+disable_so_timer_intv_tipc_link_req_34680 timer_intv tipc_link_req 0 34680 NULL
+disable_so_mounted_uid_ncp_fs_info_34684 mounted_uid ncp_fs_info 0 34684 NULL
+disable_so_crypto_ablkcipher_setkey_fndecl_34685 crypto_ablkcipher_setkey fndecl 0-3 34685 NULL
+disable_so_pm_qos_update_request_timeout_fndecl_34688 pm_qos_update_request_timeout fndecl 3-2 34688 NULL
+disable_so_max_interrupt_work_vardecl_starfire_c_34691 max_interrupt_work vardecl_starfire.c 0 34691 NULL nohasharray
+disable_so_register_dnaddr_notifier_fndecl_34691 register_dnaddr_notifier fndecl 0 34691 &disable_so_max_interrupt_work_vardecl_starfire_c_34691
+disable_so_incr_cpu_timer_list_34693 incr cpu_timer_list 0 34693 NULL
+disable_so_crypto_pcbc_decrypt_segment_fndecl_34695 crypto_pcbc_decrypt_segment fndecl 0 34695 NULL
+disable_so_sgid_index_ib_global_route_34700 sgid_index ib_global_route 0 34700 NULL
+disable_so_min_mtime_sit_info_34717 min_mtime sit_info 0 34717 NULL nohasharray
+disable_so_panel_power_down_delay_intel_dp_34717 panel_power_down_delay intel_dp 0 34717 &disable_so_min_mtime_sit_info_34717
+disable_so_i_hash_shift_vardecl_inode_c_34719 i_hash_shift vardecl_inode.c 0 34719 NULL
+disable_so_wusb_trust_timeout_show_fndecl_34721 wusb_trust_timeout_show fndecl 0 34721 NULL nohasharray
+disable_so_feed_div_min_matrox_pll_features_34721 feed_div_min matrox_pll_features 0 34721 &disable_so_wusb_trust_timeout_show_fndecl_34721
+disable_so_time_ntlmv2_resp_34723 time ntlmv2_resp 0 34723 NULL
+disable_so_cache_time_vardecl_sbs_c_34731 cache_time vardecl_sbs.c 0 34731 NULL
+disable_so_calc_eng_mem_clock_fndecl_34737 calc_eng_mem_clock fndecl 2-0 34737 NULL
+disable_so_rx_time_us_qlcnic_nic_intr_coalesce_34739 rx_time_us qlcnic_nic_intr_coalesce 0 34739 NULL
+disable_so_di_mtime_qnx4_inode_entry_34740 di_mtime qnx4_inode_entry 0 34740 NULL
+disable_so_ts_paddr_start_ath_hw_34743 ts_paddr_start ath_hw 0 34743 NULL
+disable_so_smsc95xx_enable_phy_wakeup_interrupts_fndecl_34747 smsc95xx_enable_phy_wakeup_interrupts fndecl 0-2 34747 NULL
+disable_so_ccp_sha_finup_fndecl_34752 ccp_sha_finup fndecl 0 34752 NULL
+disable_so_sdr_fm_freq_vivid_dev_34755 sdr_fm_freq vivid_dev 0 34755 NULL
+disable_so_out_n_analog_pcm_runtime_34756 out_n_analog pcm_runtime 0 34756 NULL
+disable_so_dmaaddr_net2280_dma_34761 dmaaddr net2280_dma 0 34761 NULL
+disable_so_wl12xx_tx_delayed_compl_fndecl_34763 wl12xx_tx_delayed_compl fndecl 0 34763 NULL
+disable_so_uv_rtc_set_timer_fndecl_34765 uv_rtc_set_timer fndecl 1 34765 NULL
+disable_so_switch_start_time_ath_chanctx_sched_34766 switch_start_time ath_chanctx_sched 0 34766 NULL
+disable_so_xhci_calculate_intel_u2_timeout_fndecl_34769 xhci_calculate_intel_u2_timeout fndecl 0 34769 NULL
+disable_so_addrconf_get_prefix_route_fndecl_34770 addrconf_get_prefix_route fndecl 2 34770 NULL nohasharray
+disable_so_cp_mqd_base_addr_hi_cik_mqd_34770 cp_mqd_base_addr_hi cik_mqd 0 34770 &disable_so_addrconf_get_prefix_route_fndecl_34770
+disable_so_ts_total_peak_time_ref_34800 ts_total peak_time_ref 0 34800 NULL nohasharray
+disable_so_airtime_link_metric_get_fndecl_34800 airtime_link_metric_get fndecl 0 34800 &disable_so_ts_total_peak_time_ref_34800
+disable_so_btrfsic_block_link_hashtable_lookup_fndecl_34807 btrfsic_block_link_hashtable_lookup fndecl 2-4 34807 NULL
+disable_so_posix_cpu_nsleep_fndecl_34821 posix_cpu_nsleep fndecl 1 34821 NULL
+disable_so_phys_addr_kvm_coalesced_mmio_34828 phys_addr kvm_coalesced_mmio 0 34828 NULL
+disable_so_baddr_sym_m_vtob_34832 baddr sym_m_vtob 0 34832 NULL
+disable_so_tp_set_timers_fndecl_34836 tp_set_timers fndecl 2 34836 NULL nohasharray
+disable_so_clock_t_to_jiffies_fndecl_34836 clock_t_to_jiffies fndecl 0-1 34836 &disable_so_tp_set_timers_fndecl_34836
+disable_so_bq2415x_sysfs_show_timer_fndecl_34838 bq2415x_sysfs_show_timer fndecl 0 34838 NULL
+disable_so_compat_sys_utimensat_fndecl_34845 compat_sys_utimensat fndecl 1-0 34845 NULL
+disable_so_be64_to_timespec_fndecl_34857 be64_to_timespec fndecl 1 34857 NULL
+disable_so_bus_addr_drm_ati_pcigart_info_34860 bus_addr drm_ati_pcigart_info 0 34860 NULL
+disable_so_rt2x00crypto_rx_insert_iv_fndecl_34864 rt2x00crypto_rx_insert_iv fndecl 2 34864 NULL
+disable_so___mmc_set_clock_fndecl_34870 __mmc_set_clock fndecl 2 34870 NULL
+disable_so_node_random_fndecl_34871 node_random fndecl 0 34871 NULL
+disable_so_timer_endnode_hello_message_34875 timer endnode_hello_message 0 34875 NULL
+disable_so_drbg_hash_df_fndecl_34876 drbg_hash_df fndecl 0-3 34876 NULL
+disable_so_xfs_btree_shift_keys_fndecl_34880 xfs_btree_shift_keys fndecl 4 34880 NULL
+disable_so_check_freqs_fndecl_34886 check_freqs fndecl 2 34886 NULL
+disable_so_zd_iowrite16_fndecl_34890 zd_iowrite16 fndecl 0 34890 NULL
+disable_so_timespec_to_be64_fndecl_34898 timespec_to_be64 fndecl 0 34898 NULL
+disable_so_random_frame_fotg210_hcd_34908 random_frame fotg210_hcd 0 34908 NULL
+disable_so___addrconf_sysctl_register_fndecl_34918 __addrconf_sysctl_register fndecl 0 34918 NULL
+disable_so_addr_sge_fl_34923 addr sge_fl 0 34923 NULL
+disable_so_irq_timeout_read_fndecl_34926 irq_timeout_read fndecl 3-0 34926 NULL
+disable_so_show_interrupt_enable_fndecl_34935 show_interrupt_enable fndecl 0 34935 NULL
+disable_so_sctp_getsockopt_paddr_thresholds_fndecl_34938 sctp_getsockopt_paddr_thresholds fndecl 0 34938 NULL
+disable_so_nilfs_superblock_sb_write_time_show_fndecl_34943 nilfs_superblock_sb_write_time_show fndecl 0 34943 NULL
+disable_so_emac_addr_bnx2x_mac_vals_34948 emac_addr bnx2x_mac_vals 0 34948 NULL
+disable_so_fs_tss_segment_32_34954 fs tss_segment_32 0 34954 NULL
+disable_so_twl6030_interrupt_mask_fndecl_34960 twl6030_interrupt_mask fndecl 2-0 34960 NULL
+disable_so_tda18271_sleep_fndecl_34961 tda18271_sleep fndecl 0 34961 NULL
+disable_so_smack_task_setscheduler_fndecl_34976 smack_task_setscheduler fndecl 0 34976 NULL
+disable_so_rp_ts_jiffies_xpc_activate_mq_msghdr_uv_34992 rp_ts_jiffies xpc_activate_mq_msghdr_uv 0 34992 NULL
+disable_so_p_vaddr_elf64_phdr_34996 p_vaddr elf64_phdr 0 34996 NULL
+disable_so_ath9k_hw_rf_set_freq_fndecl_35000 ath9k_hw_rf_set_freq fndecl 0 35000 NULL
+disable_so_regulator_set_voltage_time_sel_fndecl_35005 regulator_set_voltage_time_sel fndecl 2-3-0 35005 NULL
+disable_so_read_addr_stride___cache_35010 read_addr_stride __cache 0 35010 NULL
+disable_so_get_slave_base_gid_ix_fndecl_35011 get_slave_base_gid_ix fndecl 0-2-3 35011 NULL
+disable_so_sccb_reg_write_fndecl_35015 sccb_reg_write fndecl 2-3 35015 NULL
+disable_so_fsl_pwm_calculate_period_cycles_fndecl_35019 fsl_pwm_calculate_period_cycles fndecl 0-2 35019 NULL nohasharray
+disable_so_dn_hash_sock_fndecl_35019 dn_hash_sock fndecl 0 35019 &disable_so_fsl_pwm_calculate_period_cycles_fndecl_35019
+disable_so_lp8788_rtc_set_time_fndecl_35021 lp8788_rtc_set_time fndecl 0 35021 NULL
+disable_so_qos_ctl_libipw_hdr_3addrqos_35024 qos_ctl libipw_hdr_3addrqos 0 35024 NULL
+disable_so_clk_divider_set_rate_fndecl_35029 clk_divider_set_rate fndecl 2-3 35029 NULL
+disable_so_et1phyaddr_ssb_sprom_35034 et1phyaddr ssb_sprom 0 35034 NULL
+disable_so_tg3_hwclock_to_timestamp_fndecl_35038 tg3_hwclock_to_timestamp fndecl 2 35038 NULL
+disable_so_cipso_v4_bitmap_walk_fndecl_35041 cipso_v4_bitmap_walk fndecl 0-3 35041 NULL
+disable_so_wmi_set_mac_address_fndecl_35043 wmi_set_mac_address fndecl 0 35043 NULL
+disable_so_hpi_cobranet_get_macaddress_fndecl_35048 hpi_cobranet_get_macaddress fndecl 1 35048 NULL
+disable_so_rds_sysctl_reconnect_max_jiffies_vardecl_35052 rds_sysctl_reconnect_max_jiffies vardecl 0 35052 NULL
+disable_so_bg_inode_bitmap_ext2_group_desc_35053 bg_inode_bitmap ext2_group_desc 0 35053 NULL
+disable_so_jiffies_u132_endp_35057 jiffies u132_endp 0 35057 NULL
+disable_so_vivid_sdr_s_frequency_fndecl_35060 vivid_sdr_s_frequency fndecl 0 35060 NULL nohasharray
+disable_so_bnx2x_rearm_latch_signal_fndecl_35060 bnx2x_rearm_latch_signal fndecl 2 35060 &disable_so_vivid_sdr_s_frequency_fndecl_35060
+disable_so_SYSC_signalfd4_fndecl_35061 SYSC_signalfd4 fndecl 4 35061 NULL
+disable_so_qp_get_mtt_addr_fndecl_35062 qp_get_mtt_addr fndecl 0 35062 NULL nohasharray
+disable_so_put_dec_fndecl_35062 put_dec fndecl 2 35062 &disable_so_qp_get_mtt_addr_fndecl_35062
+disable_so_time_perf_cgroup_info_35063 time perf_cgroup_info 0 35063 NULL
+disable_so_xattr_datum_hashkey_fndecl_35065 xattr_datum_hashkey fndecl 4 35065 NULL
+disable_so_fandiv1_nct6775_data_35066 fandiv1 nct6775_data 0 35066 NULL
+disable_so_backbias_response_time_radeon_dpm_35069 backbias_response_time radeon_dpm 0 35069 NULL
+disable_so_wrmsrl_safe_on_cpu_fndecl_35071 wrmsrl_safe_on_cpu fndecl 0-1 35071 NULL
+disable_so_update_time_vardecl_page_writeback_c_35083 update_time vardecl_page-writeback.c 0 35083 NULL
+disable_so_fifo_copy_timeout_rtl8139_private_35085 fifo_copy_timeout rtl8139_private 0 35085 NULL
+disable_so_kstrtou16_from_user_fndecl_35089 kstrtou16_from_user fndecl 2 35089 NULL
+disable_so_atomic_check_drm_crtc_helper_funcs_35115 atomic_check drm_crtc_helper_funcs 0 35115 NULL
+disable_so_sprintf_fndecl_35121 sprintf fndecl 0 35121 NULL
+disable_so_ipv6_add_addr_fndecl_35131 ipv6_add_addr fndecl 4-5-7-8-6 35131 NULL
+disable_so_free_irq_fndecl_35135 free_irq fndecl 1 35135 NULL
+disable_so_inet_addr_onlink_fndecl_35142 inet_addr_onlink fndecl 2-3 35142 NULL
+disable_so_dbg_snprintf_key_fndecl_35144 dbg_snprintf_key fndecl 4 35144 NULL
+disable_so_compute_guest_tsc_fndecl_35147 compute_guest_tsc fndecl 0 35147 NULL
+disable_so_ieee80211_crypto_ccmp_decrypt_fndecl_35154 ieee80211_crypto_ccmp_decrypt fndecl 2 35154 NULL
+disable_so_start_time_task_struct_35158 start_time task_struct 0 35158 NULL
+disable_so__da9063_wdt_set_timeout_fndecl_35161 _da9063_wdt_set_timeout fndecl 2-0 35161 NULL
+disable_so_hard_add_expires_seconds_xfrm_lifetime_cfg_35162 hard_add_expires_seconds xfrm_lifetime_cfg 0 35162 NULL
+disable_so_page_address_ms_param_register_35167 page_address ms_param_register 0 35167 NULL nohasharray
+disable_so_rsaddr_irnet_socket_35167 rsaddr irnet_socket 0 35167 &disable_so_page_address_ms_param_register_35167
+disable_so_acpi_os_remove_interrupt_handler_fndecl_35171 acpi_os_remove_interrupt_handler fndecl 1 35171 NULL
+disable_so_hash_mac4_expire_fndecl_35179 hash_mac4_expire fndecl 4 35179 NULL
+disable_so_wd_timeout_irlap_cb_35189 wd_timeout irlap_cb 0 35189 NULL
+disable_so_bitmap_set_memory_bits_fndecl_35200 bitmap_set_memory_bits fndecl 2 35200 NULL
+disable_so_o2nm_cluster_attr_idle_timeout_ms_read_fndecl_35219 o2nm_cluster_attr_idle_timeout_ms_read fndecl 0 35219 NULL
+disable_so_set_clock_sdhci_ops_35233 set_clock sdhci_ops 2 35233 NULL
+disable_so_dib3000mc_set_timing_fndecl_35234 dib3000mc_set_timing fndecl 2-3 35234 NULL
+disable_so_ui_ctimensec_ufs2_inode_35235 ui_ctimensec ufs2_inode 0 35235 NULL nohasharray
+disable_so_timerfd_fget_fndecl_35235 timerfd_fget fndecl 1 35235 &disable_so_ui_ctimensec_ufs2_inode_35235
+disable_so_fat_time_fat2unix_fndecl_35238 fat_time_fat2unix fndecl 5-4-3 35238 NULL nohasharray
+disable_so_c_reconnect_jiffies_rds_connection_35238 c_reconnect_jiffies rds_connection 0 35238 &disable_so_fat_time_fat2unix_fndecl_35238
+disable_so_link_transition_jiffies_cas_35242 link_transition_jiffies cas 0 35242 NULL
+disable_so_nested_vmx_load_msr_fndecl_35245 nested_vmx_load_msr fndecl 2 35245 NULL
+disable_so_freqmax_snd_usb_endpoint_35248 freqmax snd_usb_endpoint 0 35248 NULL
+disable_so___ocfs2_write_remove_suid_fndecl_35250 __ocfs2_write_remove_suid fndecl 0 35250 NULL
+disable_so_si_parse_pplib_clock_info_fndecl_35257 si_parse_pplib_clock_info fndecl 3 35257 NULL
+disable_so_nfs_init_timeout_values_fndecl_35265 nfs_init_timeout_values fndecl 3-4-2 35265 NULL
+disable_so_pm_generic_runtime_suspend_fndecl_35268 pm_generic_runtime_suspend fndecl 0 35268 NULL
+disable_so_err_time_ip_tunnel_35271 err_time ip_tunnel 0 35271 NULL
+disable_so_addr_1_qla8044_minidump_entry_pollrdmwr_35274 addr_1 qla8044_minidump_entry_pollrdmwr 0 35274 NULL
+disable_so_simple_strtoull_fndecl_35278 simple_strtoull fndecl 0 35278 NULL
+disable_so_jiffies_to_wait_irctl_35279 jiffies_to_wait irctl 0 35279 NULL
+disable_so_delay_loop_fndecl_35280 delay_loop fndecl 1 35280 NULL
+disable_so_lbs_set_deep_sleep_fndecl_35287 lbs_set_deep_sleep fndecl 0 35287 NULL nohasharray
+disable_so_log_start_addr_client_hdr_35287 log_start_addr client_hdr 0 35287 &disable_so_lbs_set_deep_sleep_fndecl_35287
+disable_so_max_sleep_period_ieee80211_conf_35289 max_sleep_period ieee80211_conf 0 35289 NULL
+disable_so_default_mclk_radeon_clock_35306 default_mclk radeon_clock 0 35306 NULL nohasharray
+disable_so_clock_intel_sdvo_preferred_input_timing_args_35306 clock intel_sdvo_preferred_input_timing_args 0 35306 &disable_so_default_mclk_radeon_clock_35306
+disable_so_sctp_setsockopt_primary_addr_fndecl_35330 sctp_setsockopt_primary_addr fndecl 3-0 35330 NULL
+disable_so_sys_setreuid_fndecl_35338 sys_setreuid fndecl 0-1-2 35338 NULL
+disable_so_tailbuf_paddr_gr_ep_35341 tailbuf_paddr gr_ep 0 35341 NULL
+disable_so_hpi_write_words_le16_fndecl_35350 hpi_write_words_le16 fndecl 2-4 35350 NULL
+disable_so_kvm_set_irq_fndecl_35352 kvm_set_irq fndecl 3-2 35352 NULL
+disable_so_rq_pbl_addr_lo_fcoe_kwqe_conn_offload1_35353 rq_pbl_addr_lo fcoe_kwqe_conn_offload1 0 35353 NULL
+disable_so_trim_timeout_mmc_ext_csd_35357 trim_timeout mmc_ext_csd 0 35357 NULL
+disable_so_alps_get_bitmap_points_fndecl_35358 alps_get_bitmap_points fndecl 1 35358 NULL nohasharray
+disable_so_nilfs_btree_node_init_fndecl_35358 nilfs_btree_node_init fndecl 4 35358 &disable_so_alps_get_bitmap_points_fndecl_35358
+disable_so_fl_break_time_file_lock_35359 fl_break_time file_lock 0 35359 NULL
+disable_so_read_addr_qla82xx_md_entry_cache_35362 read_addr qla82xx_md_entry_cache 0 35362 NULL
+disable_so_maddr_xmaddr_35364 maddr xmaddr 0 35364 NULL
+disable_so_timeout_per_command_vscsiif_request_35368 timeout_per_command vscsiif_request 0 35368 NULL
+disable_so_fuse_read_interrupt_fndecl_35386 fuse_read_interrupt fndecl 3-0 35386 NULL
+disable_so_vsock_addr_init_fndecl_35395 vsock_addr_init fndecl 2 35395 NULL
+disable_so_khugepaged_alloc_sleep_millisecs_vardecl_huge_memory_c_35404 khugepaged_alloc_sleep_millisecs vardecl_huge_memory.c 0 35404 NULL
+disable_so_crypto_ahash_setkey_fndecl_35405 crypto_ahash_setkey fndecl 0-3 35405 NULL
+disable_so_en_addr1_nphy_rf_control_override_rev3_35419 en_addr1 nphy_rf_control_override_rev3 0 35419 NULL
+disable_so_rds_ib_update_ipaddr_fndecl_35431 rds_ib_update_ipaddr fndecl 0-2 35431 NULL
+disable_so_address_atto_vda_sge_35432 address atto_vda_sge 0 35432 NULL
+disable_so_w1_process_command_addremove_fndecl_35438 w1_process_command_addremove fndecl 0 35438 NULL
+disable_so_smp_cmd_pairing_random_fndecl_35441 smp_cmd_pairing_random fndecl 0 35441 NULL
+disable_so_crypto_gcm_module_init_fndecl_35446 crypto_gcm_module_init fndecl 0 35446 NULL
+disable_so_ath5k_hw_get_default_slottime_fndecl_35448 ath5k_hw_get_default_slottime fndecl 0 35448 NULL
+disable_so_ac_gid_acct_v3_35461 ac_gid acct_v3 0 35461 NULL nohasharray
+disable_so_bitmap_checkpage_fndecl_35461 bitmap_checkpage fndecl 2 35461 &disable_so_ac_gid_acct_v3_35461
+disable_so_bitmap_blkno_ocfs2_super_35475 bitmap_blkno ocfs2_super 0 35475 NULL
+disable_so_rate_dummy_systimer_pcm_35487 rate dummy_systimer_pcm 0 35487 NULL
+disable_so_moder_time_mlx4_en_cq_35496 moder_time mlx4_en_cq 0 35496 NULL
+disable_so_orion_spi_runtime_resume_fndecl_35506 orion_spi_runtime_resume fndecl 0 35506 NULL
+disable_so_monotonic_time_snsec_vsyscall_gtod_data_35513 monotonic_time_snsec vsyscall_gtod_data 0 35513 NULL
+disable_so_mceusb_process_ir_data_fndecl_35515 mceusb_process_ir_data fndecl 2 35515 NULL
+disable_so_dst_set_freq_fndecl_35516 dst_set_freq fndecl 2 35516 NULL
+disable_so_rtl8139_weird_interrupt_fndecl_35523 rtl8139_weird_interrupt fndecl 4-5 35523 NULL
+disable_so_irlmp_start_discovery_timer_fndecl_35529 irlmp_start_discovery_timer fndecl 2 35529 NULL
+disable_so_address_SGentry_35534 address SGentry 0 35534 NULL
+disable_so_src_clk_freq_msdc_host_35541 src_clk_freq msdc_host 0 35541 NULL
+disable_so_SYSC_signal_fndecl_35543 SYSC_signal fndecl 1 35543 NULL
+disable_so_current_frequency_lgdt3306a_state_35547 current_frequency lgdt3306a_state 0 35547 NULL
+disable_so_i_rt_spc_timelimit_qc_info_35555 i_rt_spc_timelimit qc_info 0 35555 NULL
+disable_so_host_kvm_shared_msr_values_35560 host kvm_shared_msr_values 0 35560 NULL
+disable_so_mapped_loc_addr_nes_cm_info_35561 mapped_loc_addr nes_cm_info 0 35561 NULL
+disable_so_ath6kl_set_addrwin_reg_fndecl_35566 ath6kl_set_addrwin_reg fndecl 0-2 35566 NULL
+disable_so_output_sleep_fndecl_35570 output_sleep fndecl 1 35570 NULL
+disable_so_aes_decrypt_fail_read_fndecl_35596 aes_decrypt_fail_read fndecl 0-3 35596 NULL
+disable_so_hw_timeout_redrat3_dev_35597 hw_timeout redrat3_dev 0 35597 NULL
+disable_so_cx231xx_set_analog_freq_fndecl_35598 cx231xx_set_analog_freq fndecl 2 35598 NULL
+disable_so_sctp_conn_schedule_fndecl_35608 sctp_conn_schedule fndecl 1 35608 NULL
+disable_so_runtime_suspend_sleep_time_cyapa_35610 runtime_suspend_sleep_time cyapa 0 35610 NULL
+disable_so_debug_dma_unmap_page_fndecl_35623 debug_dma_unmap_page fndecl 3-2 35623 NULL
+disable_so_timecounter_read_fndecl_35625 timecounter_read fndecl 0 35625 NULL
+disable_so_clock_mmc_ios_35630 clock mmc_ios 0 35630 NULL
+disable_so_pretimeout_kempld_wdt_data_35641 pretimeout kempld_wdt_data 0 35641 NULL
+disable_so_time_show_fndecl_35660 time_show fndecl 0 35660 NULL
+disable_so_div3_pll_div_35668 div3 pll_div 0 35668 NULL
+disable_so_btree_get_extent_fndecl_35670 btree_get_extent fndecl 4-5 35670 NULL
+disable_so_paddr_ath10k_skb_cb_35676 paddr ath10k_skb_cb 0 35676 NULL
+disable_so_pci_bus_mraid_hba_info_35677 pci_bus mraid_hba_info 0 35677 NULL
+disable_so_m41t80_get_datetime_fndecl_35678 m41t80_get_datetime fndecl 0 35678 NULL
+disable_so_sh_tmu_clock_event_next_fndecl_35683 sh_tmu_clock_event_next fndecl 1 35683 NULL
+disable_so_randomize_range_fndecl_35684 randomize_range fndecl 1-2-3-0 35684 NULL
+disable_so_complete_signal_fndecl_35696 complete_signal fndecl 1 35696 NULL
+disable_so_nft_hash_insert_fndecl_35701 nft_hash_insert fndecl 0 35701 NULL
+disable_so_kvm_vm_ioctl_set_tss_addr_fndecl_35702 kvm_vm_ioctl_set_tss_addr fndecl 2 35702 NULL
+disable_so_si2165_adjust_pll_divl_fndecl_35704 si2165_adjust_pll_divl fndecl 0 35704 NULL
+disable_so_addr_l_xfer_desc_35720 addr_l xfer_desc 0 35720 NULL
+disable_so_m_hash_dlm_message_35721 m_hash dlm_message 0 35721 NULL
+disable_so_end_freq_khz_ieee80211_freq_range_35730 end_freq_khz ieee80211_freq_range 0 35730 NULL
+disable_so_start_addr_vpdma_dtd_35734 start_addr vpdma_dtd 0 35734 NULL
+disable_so_red_calc_qavg_from_idle_time_fndecl_35745 red_calc_qavg_from_idle_time fndecl 0 35745 NULL
+disable_so_cg_spll_spread_spectrum_2_si_clock_registers_35754 cg_spll_spread_spectrum_2 si_clock_registers 0 35754 NULL
+disable_so_l2tp_flowinfo_sockaddr_l2tpip6_35758 l2tp_flowinfo sockaddr_l2tpip6 0 35758 NULL nohasharray
+disable_so_sk_txhash_sock_35758 sk_txhash sock 0 35758 &disable_so_l2tp_flowinfo_sockaddr_l2tpip6_35758
+disable_so_get_mac_address_efx_nic_type_35761 get_mac_address efx_nic_type 0 35761 NULL
+disable_so_crypto_aead_alg_ivsize_fndecl_35777 crypto_aead_alg_ivsize fndecl 0 35777 NULL
+disable_so_vga_switcheroo_runtime_suspend_fndecl_35778 vga_switcheroo_runtime_suspend fndecl 0 35778 NULL
+disable_so_sm_lookup_bitmap_fndecl_35780 sm_lookup_bitmap fndecl 2 35780 NULL
+disable_so_r6040_interrupt_fndecl_35784 r6040_interrupt fndecl 1 35784 NULL
+disable_so_timer_installed_vardecl_ad1848_c_35808 timer_installed vardecl_ad1848.c 0 35808 NULL
+disable_so_addr_to_kill_35815 addr to_kill 0 35815 NULL
+disable_so_postsleep_max_us_mmc_ioc_cmd_35817 postsleep_max_us mmc_ioc_cmd 0 35817 NULL
+disable_so_calc_hash_fndecl_35821 calc_hash fndecl 0-3 35821 NULL
+disable_so_testscript_addr_ath6kl_hw_35825 testscript_addr ath6kl_hw 0 35825 NULL
+disable_so_dma_addr_cpcs_trailer_desc_35826 dma_addr cpcs_trailer_desc 0 35826 NULL nohasharray
+disable_so_nr_threads_signal_struct_35826 nr_threads signal_struct 0 35826 &disable_so_dma_addr_cpcs_trailer_desc_35826
+disable_so_iwl_mvm_schedule_csa_period_fndecl_35828 iwl_mvm_schedule_csa_period fndecl 3-4-0 35828 NULL
+disable_so_nfs4_schedule_stateid_recovery_fndecl_35861 nfs4_schedule_stateid_recovery fndecl 0 35861 NULL
+disable_so_timeout_last_ncp_server_35864 timeout_last ncp_server 0 35864 NULL
+disable_so_send_utimes_fndecl_35871 send_utimes fndecl 3-0-2 35871 NULL nohasharray
+disable_so_remote_rp_ts_jiffies_xpc_partition_35871 remote_rp_ts_jiffies xpc_partition 0 35871 &disable_so_send_utimes_fndecl_35871
+disable_so_current_frequency_lgdt3305_state_35902 current_frequency lgdt3305_state 0 35902 NULL
+disable_so_dram_addr_to_input_addr_fndecl_35905 dram_addr_to_input_addr fndecl 0-2 35905 NULL nohasharray
+disable_so_ifa_local_dn_ifaddr_35905 ifa_local dn_ifaddr 0 35905 &disable_so_dram_addr_to_input_addr_fndecl_35905
+disable_so_proc_uid_map_write_fndecl_35919 proc_uid_map_write fndecl 0-3 35919 NULL
+disable_so_snd_timer_user_fasync_fndecl_35926 snd_timer_user_fasync fndecl 1 35926 NULL nohasharray
+disable_so_ecb_aes_encrypt_fndecl_35926 ecb_aes_encrypt fndecl 0-4 35926 &disable_so_snd_timer_user_fasync_fndecl_35926
+disable_so_st_ctime_sec_p9_stat_dotl_35932 st_ctime_sec p9_stat_dotl 0 35932 NULL
+disable_so_cg_spll_func_cntl_rv730_clock_registers_35937 cg_spll_func_cntl rv730_clock_registers 0 35937 NULL
+disable_so_phy_addr_niu_35946 phy_addr niu 0 35946 NULL
+disable_so_curr_freq_ufs_clk_info_35949 curr_freq ufs_clk_info 0 35949 NULL
+disable_so_ac_gid_taskstats_35951 ac_gid taskstats 0 35951 NULL
+disable_so_addr_hi_eth_rx_bd_35955 addr_hi eth_rx_bd 0 35955 NULL nohasharray
+disable_so_hw_dma_bit_mask_hptiop_adapter_ops_35955 hw_dma_bit_mask hptiop_adapter_ops 0 35955 &disable_so_addr_hi_eth_rx_bd_35955
+disable_so_crypto_cmac_digest_setkey_fndecl_35967 crypto_cmac_digest_setkey fndecl 0-3 35967 NULL
+disable_so_abort_mfi_phys_addr_hi_megasas_abort_frame_35969 abort_mfi_phys_addr_hi megasas_abort_frame 0 35969 NULL
+disable_so_pch_can_bit_set_fndecl_35970 pch_can_bit_set fndecl 2 35970 NULL
+disable_so_kvasprintf_fndecl_35976 kvasprintf fndecl 1 35976 NULL
+disable_so___bitmap_parse_fndecl_35977 __bitmap_parse fndecl 0-2-5 35977 NULL
+disable_so_nct6775_select_fan_div_fndecl_35983 nct6775_select_fan_div fndecl 3-4 35983 NULL
+disable_so_ip_hash_ip4_elem_35987 ip hash_ip4_elem 0 35987 NULL
+disable_so_nct6775_write_fan_div_common_fndecl_35989 nct6775_write_fan_div_common fndecl 2 35989 NULL nohasharray
+disable_so_get_mtime_fndecl_35989 get_mtime fndecl 0 35989 &disable_so_nct6775_write_fan_div_common_fndecl_35989
+disable_so_sctp_getsockopt_peer_addr_params_fndecl_35998 sctp_getsockopt_peer_addr_params fndecl 0 35998 NULL
+disable_so_tuner_frequency_stv0299_state_35999 tuner_frequency stv0299_state 0 35999 NULL
+disable_so_sinfo_timetolive_sctp_sndrcvinfo_36000 sinfo_timetolive sctp_sndrcvinfo 0 36000 NULL
+disable_so_h_start_jiffies_jbd2_journal_handle_36008 h_start_jiffies jbd2_journal_handle 0 36008 NULL nohasharray
+disable_so_ccp_aes_xts_setkey_fndecl_36008 ccp_aes_xts_setkey fndecl 0-3 36008 &disable_so_h_start_jiffies_jbd2_journal_handle_36008
+disable_so_uv_local_mmr_address_fndecl_36009 uv_local_mmr_address fndecl 1 36009 NULL
+disable_so_adxl34x_autosleep_show_fndecl_36014 adxl34x_autosleep_show fndecl 0 36014 NULL
+disable_so_tst_addr_ns_dev_36023 tst_addr ns_dev 0 36023 NULL
+disable_so_addr_acard_sg_36025 addr acard_sg 0 36025 NULL
+disable_so_pcxhr_sub_get_external_clock_fndecl_36041 pcxhr_sub_get_external_clock fndecl 0 36041 NULL
+disable_so_address_fault_36043 address fault 0 36043 NULL
+disable_so_s35390a_rtc_set_time_fndecl_36048 s35390a_rtc_set_time fndecl 0 36048 NULL nohasharray
+disable_so_rt5677_dsp_mode_i2c_read_addr_fndecl_36048 rt5677_dsp_mode_i2c_read_addr fndecl 0-2 36048 &disable_so_s35390a_rtc_set_time_fndecl_36048
+disable_so_mmd_addr_reg_val_36052 mmd_addr reg_val 0 36052 NULL
+disable_so_ips_flashbusaddr_vardecl_ips_c_36053 ips_flashbusaddr vardecl_ips.c 0 36053 NULL
+disable_so_i_spc_timelimit_qc_info_36081 i_spc_timelimit qc_info 0 36081 NULL
+disable_so_st_gid_stat_36085 st_gid stat 0 36085 NULL
+disable_so_acpi_ev_address_space_dispatch_fndecl_36089 acpi_ev_address_space_dispatch fndecl 0-4-5 36089 NULL
+disable_so_mpll_ad_func_cntl_2_ni_clock_registers_36093 mpll_ad_func_cntl_2 ni_clock_registers 0 36093 NULL
+disable_so_i_atime_ocfs2_dinode_36099 i_atime ocfs2_dinode 0 36099 NULL
+disable_so_setup_timer_IRQ0_pin_fndecl_36100 setup_timer_IRQ0_pin fndecl 3-2 36100 NULL
+disable_so_error_info_addr_mvm_alive_resp_36103 error_info_addr mvm_alive_resp 0 36103 NULL nohasharray
+disable_so_cma_bitmap_pages_to_bits_fndecl_36103 cma_bitmap_pages_to_bits fndecl 0-2 36103 &disable_so_error_info_addr_mvm_alive_resp_36103
+disable_so_kstrtoull_fndecl_36106 kstrtoull fndecl 0 36106 NULL
+disable_so_fax_head_line_time_fndecl_36108 fax_head_line_time fndecl 0 36108 NULL
+disable_so_rtl8152_set_mac_address_fndecl_36112 rtl8152_set_mac_address fndecl 0 36112 NULL
+disable_so_t_sleep_cycle_at86rf2xx_chip_data_36118 t_sleep_cycle at86rf2xx_chip_data 0 36118 NULL
+disable_so_no_quota_btrfs_delayed_ref_node_36121 no_quota btrfs_delayed_ref_node 0 36121 NULL nohasharray
+disable_so_ccp_register_aes_xts_algs_fndecl_36121 ccp_register_aes_xts_algs fndecl 0 36121 &disable_so_no_quota_btrfs_delayed_ref_node_36121
+disable_so_shutdown_time_vardecl_torture_c_36136 shutdown_time vardecl_torture.c 0 36136 NULL nohasharray
+disable_so_i40e_init_interrupt_scheme_fndecl_36136 i40e_init_interrupt_scheme fndecl 0 36136 &disable_so_shutdown_time_vardecl_torture_c_36136
+disable_so_ath5k_hw_clocktoh_fndecl_36137 ath5k_hw_clocktoh fndecl 0-2 36137 NULL
+disable_so_addr_off_bfa_flash_s_36155 addr_off bfa_flash_s 0 36155 NULL
+disable_so_mlx4_bitmap_free_fndecl_36158 mlx4_bitmap_free fndecl 2 36158 NULL
+disable_so_setup_cluster_no_bitmap_fndecl_36163 setup_cluster_no_bitmap fndecl 4-5-6-7 36163 NULL
+disable_so_last_queue_full_time_bfad_itnim_s_36172 last_queue_full_time bfad_itnim_s 0 36172 NULL
+disable_so_do_cpuid_ent_fndecl_36174 do_cpuid_ent fndecl 5 36174 NULL
+disable_so_lzo_compress_fndecl_36177 lzo_compress fndecl 3 36177 NULL
+disable_so_set_radio_freq_fndecl_36200 set_radio_freq fndecl 2 36200 NULL
+disable_so_get_random_bytes_arch_fndecl_36201 get_random_bytes_arch fndecl 2 36201 NULL
+disable_so_netlbl_unlhsh_add_addr4_fndecl_36206 netlbl_unlhsh_add_addr4 fndecl 4-0 36206 NULL
+disable_so_assert_file_addr_sdpcm_shared_36210 assert_file_addr sdpcm_shared 0 36210 NULL
+disable_so_timestamp_rxdone_entry_desc_36213 timestamp rxdone_entry_desc 0 36213 NULL
+disable_so_interrupts_open_fndecl_36230 interrupts_open fndecl 0 36230 NULL
+disable_so_nhash_jffs2_full_dirent_36231 nhash jffs2_full_dirent 0 36231 NULL
+disable_so_max_level_cpufreq_cooling_device_36241 max_level cpufreq_cooling_device 0 36241 NULL
+disable_so_ovl_set_timestamps_fndecl_36245 ovl_set_timestamps fndecl 0 36245 NULL
+disable_so_evtchn_interrupt_fndecl_36255 evtchn_interrupt fndecl 1 36255 NULL
+disable_so_timeout_ip_vs_service_36264 timeout ip_vs_service 0 36264 NULL
+disable_so_dwell_time_dfs_conf_scan_settings_36271 dwell_time_dfs conf_scan_settings 0 36271 NULL
+disable_so_drbd_send_uuids_fndecl_36274 drbd_send_uuids fndecl 0 36274 NULL
+disable_so_bd_list_addr_lo_bnx2i_logout_request_36277 bd_list_addr_lo bnx2i_logout_request 0 36277 NULL
+disable_so_rds_ib_add_ipaddr_fndecl_36278 rds_ib_add_ipaddr fndecl 2 36278 NULL nohasharray
+disable_so_nilfs_btree_assign_gc_fndecl_36278 nilfs_btree_assign_gc fndecl 0-3 36278 &disable_so_rds_ib_add_ipaddr_fndecl_36278
+disable_so_last_post_time_vardecl_hv_balloon_c_36289 last_post_time vardecl_hv_balloon.c 0 36289 NULL
+disable_so_skb_physaddr_macb_36295 skb_physaddr macb 0 36295 NULL
+disable_so_dq_hash_bits_vardecl_dquot_c_36296 dq_hash_bits vardecl_dquot.c 0 36296 NULL
+disable_so_rpfilter_get_saddr_fndecl_36300 rpfilter_get_saddr fndecl 0-1 36300 NULL
+disable_so_sys_setregid16_fndecl_36302 sys_setregid16 fndecl 0-1-2 36302 NULL
+disable_so_f_frequency_fc2580_dev_36307 f_frequency fc2580_dev 0 36307 NULL
+disable_so_address_r8a66597_td_36315 address r8a66597_td 0 36315 NULL
+disable_so_address_acpi_madt_local_apic_override_36325 address acpi_madt_local_apic_override 0 36325 NULL nohasharray
+disable_so_num_addresses_i40e_aqc_macvlan_36325 num_addresses i40e_aqc_macvlan 0 36325 &disable_so_address_acpi_madt_local_apic_override_36325
+disable_so_cache_time_vardecl_ds2760_battery_c_36329 cache_time vardecl_ds2760_battery.c 0 36329 NULL
+disable_so_ext_start_addr_hi_i740fb_par_36335 ext_start_addr_hi i740fb_par 0 36335 NULL
+disable_so_mlx4_get_slave_node_guid_fndecl_36336 mlx4_get_slave_node_guid fndecl 2 36336 NULL
+disable_so_reg_delay_fndecl_36338 reg_delay fndecl 5 36338 NULL
+disable_so_dev_addr_del_fndecl_36356 dev_addr_del fndecl 0 36356 NULL
+disable_so_address_low_b43_dmadesc64_36370 address_low b43_dmadesc64 0 36370 NULL
+disable_so_cpuid_seek_fndecl_36372 cpuid_seek fndecl 0-2 36372 NULL
+disable_so_mhash_entries_vardecl_namespace_c_36377 mhash_entries vardecl_namespace.c 0 36377 NULL
+disable_so_btree_grow_fndecl_36388 btree_grow fndecl 3 36388 NULL
+disable_so_ie6xx_wdt_set_timeout_fndecl_36389 ie6xx_wdt_set_timeout fndecl 2 36389 NULL
+disable_so_cq_page_table_addr_hi_iscsi_kwqe_conn_offload1_36403 cq_page_table_addr_hi iscsi_kwqe_conn_offload1 0 36403 NULL
+disable_so_phys_addr_ntb_mw_36409 phys_addr ntb_mw 0 36409 NULL
+disable_so_tsl2563_write_interrupt_config_fndecl_36415 tsl2563_write_interrupt_config fndecl 0 36415 NULL
+disable_so_bitmap_bitremap_fndecl_36419 bitmap_bitremap fndecl 4-0-1 36419 NULL
+disable_so_cryptd_hash_final_enqueue_fndecl_36420 cryptd_hash_final_enqueue fndecl 0 36420 NULL
+disable_so_addr_azx_rb_36425 addr azx_rb 0 36425 NULL
+disable_so_discov_timeout_hci_dev_36432 discov_timeout hci_dev 0 36432 NULL
+disable_so_interrupt_event_ixgbe_adapter_36433 interrupt_event ixgbe_adapter 0 36433 NULL
+disable_so_hpi_bitstream_set_clock_edge_fndecl_36438 hpi_bitstream_set_clock_edge fndecl 1-0 36438 NULL
+disable_so_atime_fuse_setattr_in_36441 atime fuse_setattr_in 0 36441 NULL
+disable_so_family_xfrm_usersa_info_36443 family xfrm_usersa_info 0 36443 NULL
+disable_so_wlc_phy_channel2freq_fndecl_36444 wlc_phy_channel2freq fndecl 1 36444 NULL
+disable_so_max_delay_intel_ilk_power_mgmt_36447 max_delay intel_ilk_power_mgmt 0 36447 NULL
+disable_so_sys_setregid_fndecl_36457 sys_setregid fndecl 0-1-2 36457 NULL
+disable_so_mpll_dq_func_cntl_rv770_clock_registers_36466 mpll_dq_func_cntl rv770_clock_registers 0 36466 NULL
+disable_so_shortcal_timer_ath_ani_36468 shortcal_timer ath_ani 0 36468 NULL
+disable_so_check_config_address_fndecl_36471 check_config_address fndecl 4 36471 NULL nohasharray
+disable_so_db_addr_mlx5_ib_create_srq_36471 db_addr mlx5_ib_create_srq 0 36471 &disable_so_check_config_address_fndecl_36471
+disable_so_sysctl_rose_reset_request_timeout_vardecl_36479 sysctl_rose_reset_request_timeout vardecl 0 36479 NULL
+disable_so_address_mspro_attr_entry_36482 address mspro_attr_entry 0 36482 NULL
+disable_so_min_discovery_timeout_mesh_config_36485 min_discovery_timeout mesh_config 0 36485 NULL
+disable_so_bitmap_il_ht_agg_36487 bitmap il_ht_agg 0 36487 NULL
+disable_so_crypto_ecb_crypt_fndecl_36489 crypto_ecb_crypt fndecl 0 36489 NULL
+disable_so_address_arch_hw_breakpoint_36491 address arch_hw_breakpoint 0 36491 NULL
+disable_so_flush_timer_iwl_lq_sta_36505 flush_timer iwl_lq_sta 0 36505 NULL
+disable_so_demod_address_sp8870_config_36507 demod_address sp8870_config 0 36507 NULL
+disable_so_hashbin_remove_fndecl_36512 hashbin_remove fndecl 2 36512 NULL
+disable_so_mpll_ad_func_cntl_ni_clock_registers_36523 mpll_ad_func_cntl ni_clock_registers 0 36523 NULL
+disable_so_timeout_usbdevfs_bulktransfer_36525 timeout usbdevfs_bulktransfer 0 36525 NULL
+disable_so_ctl_freq_cx231xx_36526 ctl_freq cx231xx 0 36526 NULL
+disable_so_last_isr_time_misc_stats_36527 last_isr_time misc_stats 0 36527 NULL
+disable_so_mlx4_gen_guid_change_eqe_fndecl_36529 mlx4_gen_guid_change_eqe fndecl 0-2-3 36529 NULL
+disable_so_addr_e1000_phy_info_36530 addr e1000_phy_info 0 36530 NULL nohasharray
+disable_so_misc_mce_36530 misc mce 0 36530 &disable_so_addr_e1000_phy_info_36530
+disable_so_align_addr_sdhci_host_36535 align_addr sdhci_host 0 36535 NULL
+disable_so_gran_sizek_mtrr_cleanup_result_36538 gran_sizek mtrr_cleanup_result 0 36538 NULL
+disable_so_mcryptd_hash_export_fndecl_36554 mcryptd_hash_export fndecl 0 36554 NULL
+disable_so_snd_opl3_timer_new_fndecl_36558 snd_opl3_timer_new fndecl 0-3-2 36558 NULL
+disable_so_alarmtimer_rtc_interface_setup_fndecl_36561 alarmtimer_rtc_interface_setup fndecl 0 36561 NULL
+disable_so_mb86a20s_read_signal_strength_fndecl_36562 mb86a20s_read_signal_strength fndecl 0 36562 NULL
+disable_so_devm_request_threaded_irq_fndecl_36564 devm_request_threaded_irq fndecl 0-2-5 36564 NULL
+disable_so_VDisplay_xtimings_36585 VDisplay xtimings 0 36585 NULL
+disable_so_delay_usec_e1000_eeprom_info_36611 delay_usec e1000_eeprom_info 0 36611 NULL
+disable_so_enabled_hrtimer_events_fusbh200_hcd_36613 enabled_hrtimer_events fusbh200_hcd 0 36613 NULL nohasharray
+disable_so_myaddr_sym_hcb_36613 myaddr sym_hcb 0 36613 &disable_so_enabled_hrtimer_events_fusbh200_hcd_36613
+disable_so_bmc150_accel_runtime_resume_fndecl_36616 bmc150_accel_runtime_resume fndecl 0 36616 NULL nohasharray
+disable_so_frequency_tuner_simple_priv_36616 frequency tuner_simple_priv 0 36616 &disable_so_bmc150_accel_runtime_resume_fndecl_36616
+disable_so_dll_cntl_ni_clock_registers_36640 dll_cntl ni_clock_registers 0 36640 NULL
+disable_so_phys_addr_high_qlcnic_tx_mbx_36646 phys_addr_high qlcnic_tx_mbx 0 36646 NULL
+disable_so_ntfs_bitmap_set_run_fndecl_36647 ntfs_bitmap_set_run fndecl 2-3 36647 NULL
+disable_so_hfs_btree_open_fndecl_36648 hfs_btree_open fndecl 2 36648 NULL
+disable_so_radio_tea5777_set_freq_fndecl_36650 radio_tea5777_set_freq fndecl 0 36650 NULL
+disable_so_default_timeout_cyclades_port_36652 default_timeout cyclades_port 0 36652 NULL
+disable_so_trinity_get_sleep_divider_id_from_clock_fndecl_36654 trinity_get_sleep_divider_id_from_clock fndecl 2 36654 NULL
+disable_so_timeout_osst_tape_36656 timeout osst_tape 0 36656 NULL
+disable_so_sda_falling_time_dw_i2c_dev_36665 sda_falling_time dw_i2c_dev 0 36665 NULL
+disable_so_libipw_freq_to_channel_fndecl_36675 libipw_freq_to_channel fndecl 0-2 36675 NULL
+disable_so_el3_interrupt_fndecl_36679 el3_interrupt fndecl 1 36679 NULL
+disable_so_cg_spll_func_cntl_3_rv770_clock_registers_36680 cg_spll_func_cntl_3 rv770_clock_registers 0 36680 NULL
+disable_so_resp_dma_addr_generic_pdu_resc_36683 resp_dma_addr generic_pdu_resc 0 36683 NULL
+disable_so_store_imon_clock_fndecl_36685 store_imon_clock fndecl 0-4 36685 NULL
+disable_so_kdbgetaddrarg_fndecl_36689 kdbgetaddrarg fndecl 0 36689 NULL
+disable_so_ahash_def_finup_done1_fndecl_36695 ahash_def_finup_done1 fndecl 2 36695 NULL
+disable_so_backlight_on_delay_intel_dp_36699 backlight_on_delay intel_dp 0 36699 NULL
+disable_so_daddr_ipq_36701 daddr ipq 0 36701 NULL
+disable_so_sha512_generic_mod_init_fndecl_36702 sha512_generic_mod_init fndecl 0 36702 NULL
+disable_so_HYPERVISOR_dom0_op_fndecl_36705 HYPERVISOR_dom0_op fndecl 0 36705 NULL
+disable_so_pll_ref_div_pll_ct_36716 pll_ref_div pll_ct 0 36716 NULL
+disable_so_timecounter_cyc2time_fndecl_36723 timecounter_cyc2time fndecl 0-2 36723 NULL
+disable_so_hello_time___bridge_info_36726 hello_time __bridge_info 0 36726 NULL
+disable_so___clockevents_update_freq_fndecl_36730 __clockevents_update_freq fndecl 2 36730 NULL
+disable_so_lvds_ssc_freq_intel_vbt_data_36732 lvds_ssc_freq intel_vbt_data 0 36732 NULL
+disable_so_mlx4_bitmap_alloc_range_fndecl_36733 mlx4_bitmap_alloc_range fndecl 0-2-3 36733 NULL
+disable_so_hmark_hash_fndecl_36743 hmark_hash fndecl 0 36743 NULL
+disable_so_atimensec_fuse_attr_36765 atimensec fuse_attr 0 36765 NULL
+disable_so_sys_getgid16_fndecl_36779 sys_getgid16 fndecl 0 36779 NULL
+disable_so_hash_32_fndecl_36780 hash_32 fndecl 0-3 36780 NULL
+disable_so_di_gid_qnx6_inode_entry_36804 di_gid qnx6_inode_entry 0 36804 NULL nohasharray
+disable_so_jhash_fndecl_36804 jhash fndecl 0-2-3 36804 &disable_so_di_gid_qnx6_inode_entry_36804
+disable_so_last_time1_intel_ilk_power_mgmt_36819 last_time1 intel_ilk_power_mgmt 0 36819 NULL
+disable_so_xen_clocksource_get_cycles_fndecl_36821 xen_clocksource_get_cycles fndecl 0 36821 NULL
+disable_so_address_show_fndecl_36822 address_show fndecl 0 36822 NULL
+disable_so_next_desc_addr_mm_dma_desc_36825 next_desc_addr mm_dma_desc 0 36825 NULL
+disable_so_update_time_acpi_battery_36827 update_time acpi_battery 0 36827 NULL
+disable_so_nla_put_le16_fndecl_36829 nla_put_le16 fndecl 0-3 36829 NULL
+disable_so_sense_buf_phys_addr_hi_megasas_pthru_frame_36842 sense_buf_phys_addr_hi megasas_pthru_frame 0 36842 NULL
+disable_so_vkdb_printf_fndecl_36847 vkdb_printf fndecl 0 36847 NULL
+disable_so_cpu_to_fs32_fndecl_36849 cpu_to_fs32 fndecl 0-2 36849 NULL
+disable_so_mxl301rf_sleep_fndecl_36864 mxl301rf_sleep fndecl 0 36864 NULL
+disable_so_nfqueue_hash_fndecl_36865 nfqueue_hash fndecl 0-2-3-4 36865 NULL
+disable_so_irq_set_irq_wake_fndecl_36876 irq_set_irq_wake fndecl 0-1 36876 NULL
+disable_so_topology_change_timer_value___bridge_info_36878 topology_change_timer_value __bridge_info 0 36878 NULL
+disable_so_settle_time_sym_shcb_36880 settle_time sym_shcb 0 36880 NULL
+disable_so_mei_wd_set_start_timeout_fndecl_36890 mei_wd_set_start_timeout fndecl 2 36890 NULL
+disable_so_inet6_dump_ifaddr_fndecl_36895 inet6_dump_ifaddr fndecl 0 36895 NULL
+disable_so_sh_msiof_get_delay_bit_fndecl_36896 sh_msiof_get_delay_bit fndecl 0-1 36896 NULL
+disable_so_pwm_uptime_w83793_data_36909 pwm_uptime w83793_data 0 36909 NULL nohasharray
+disable_so_zd_iowrite32a_locked_fndecl_36909 zd_iowrite32a_locked fndecl 0-3 36909 &disable_so_pwm_uptime_w83793_data_36909
+disable_so_usb_runtime_suspend_fndecl_36911 usb_runtime_suspend fndecl 0 36911 NULL
+disable_so_buf_addr_mlx5_ib_create_srq_36916 buf_addr mlx5_ib_create_srq 0 36916 NULL
+disable_so_sbp2_pointer_to_addr_fndecl_36918 sbp2_pointer_to_addr fndecl 0 36918 NULL
+disable_so_start_pcm_timer0_fndecl_36921 start_pcm_timer0 fndecl 2 36921 NULL
+disable_so_timestamp_il3945_rx_frame_end_36930 timestamp il3945_rx_frame_end 0 36930 NULL
+disable_so_nilfs_btree_node_broken_fndecl_36936 nilfs_btree_node_broken fndecl 2-3 36936 NULL
+disable_so_wm8991_set_dai_clkdiv_fndecl_36938 wm8991_set_dai_clkdiv fndecl 3 36938 NULL
+disable_so_timeout_ieee80211_mgd_auth_data_36943 timeout ieee80211_mgd_auth_data 0 36943 NULL
+disable_so_i2c_address_itd1000_config_36949 i2c_address itd1000_config 0 36949 NULL
+disable_so_nla_put_be16_fndecl_36955 nla_put_be16 fndecl 0-3 36955 NULL
+disable_so_dma_addr_bcm_sysport_cb_36958 dma_addr bcm_sysport_cb 0 36958 NULL
+disable_so_timeout_trf7970a_36959 timeout trf7970a 0 36959 NULL nohasharray
+disable_so_s35390a_get_datetime_fndecl_36959 s35390a_get_datetime fndecl 0 36959 &disable_so_timeout_trf7970a_36959
+disable_so_spn_dev_sockaddr_pn_36960 spn_dev sockaddr_pn 0 36960 NULL
+disable_so_dpp_page_addr_hi_ocrdma_alloc_pd_uresp_36964 dpp_page_addr_hi ocrdma_alloc_pd_uresp 0 36964 NULL
+disable_so_tv_sec_compat_timespec_36965 tv_sec compat_timespec 0 36965 NULL
+disable_so_get_dclk_freq_fndecl_36970 get_dclk_freq fndecl 0 36970 NULL
+disable_so_intlog2_fndecl_36975 intlog2 fndecl 0-1 36975 NULL
+disable_so_psb_intel_clock_fndecl_36993 psb_intel_clock fndecl 1 36993 NULL
+disable_so_i_uid_write_fndecl_36996 i_uid_write fndecl 2 36996 NULL
+disable_so_addr_st_sgitem_37005 addr st_sgitem 0 37005 NULL
+disable_so_do_usleep_range_fndecl_37008 do_usleep_range fndecl 1-2 37008 NULL
+disable_so_insert_entries_i915_address_space_37011 insert_entries i915_address_space 3 37011 NULL
+disable_so_ext4_init_inode_bitmap_fndecl_37017 ext4_init_inode_bitmap fndecl 0-3 37017 NULL
+disable_so_sp_pt_regs_37018 sp pt_regs 0 37018 NULL
+disable_so_addr_gsm_dlci_37020 addr gsm_dlci 0 37020 NULL
+disable_so_lbq_addr_cqicb_37033 lbq_addr cqicb 0 37033 NULL
+disable_so_stv090x_get_car_freq_fndecl_37041 stv090x_get_car_freq fndecl 0-2 37041 NULL
+disable_so_resp_sas_sha_m_spg_fndecl_37046 resp_sas_sha_m_spg fndecl 0 37046 NULL
+disable_so_cyc2ns_shift_cyc2ns_data_37055 cyc2ns_shift cyc2ns_data 0 37055 NULL
+disable_so_max8997_muic_set_debounce_time_fndecl_37057 max8997_muic_set_debounce_time fndecl 2-0 37057 NULL
+disable_so_tms_cutime_compat_tms_37072 tms_cutime compat_tms 0 37072 NULL
+disable_so_u2_timeout_store_fndecl_37082 u2_timeout_store fndecl 0-4 37082 NULL
+disable_so_addr2_unlock_addr_37100 addr2 unlock_addr 0 37100 NULL
+disable_so_pch_gbe_hal_read_mac_addr_fndecl_37101 pch_gbe_hal_read_mac_addr fndecl 0 37101 NULL
+disable_so_blkcipher_next_slow_fndecl_37102 blkcipher_next_slow fndecl 3-4 37102 NULL
+disable_so_addr_ata_bmdma_prd_37108 addr ata_bmdma_prd 0 37108 NULL
+disable_so_nl80211_valid_4addr_fndecl_37115 nl80211_valid_4addr fndecl 0-4 37115 NULL
+disable_so_dlm_lockres_hash_fndecl_37119 dlm_lockres_hash fndecl 2 37119 NULL
+disable_so_uid_ipc64_perm_37121 uid ipc64_perm 0 37121 NULL
+disable_so_paddr_gr_dma_desc_37127 paddr gr_dma_desc 0 37127 NULL
+disable_so_max_cb_time_fndecl_37133 max_cb_time fndecl 0 37133 NULL
+disable_so_smt_get_time_fndecl_37135 smt_get_time fndecl 0 37135 NULL
+disable_so_div_q1_pll_values_37147 div_q1 pll_values 0 37147 NULL
+disable_so_ufshcd_setup_clocks_fndecl_37162 ufshcd_setup_clocks fndecl 0 37162 NULL
+disable_so_gid_fuse_attr_37169 gid fuse_attr 0 37169 NULL
+disable_so_smsc75xx_hash_fndecl_37173 smsc75xx_hash fndecl 0 37173 NULL
+disable_so_crypto_skcipher_givencrypt_fndecl_37175 crypto_skcipher_givencrypt fndecl 0 37175 NULL
+disable_so_ip_vs_set_timeout_fndecl_37183 ip_vs_set_timeout fndecl 0 37183 NULL
+disable_so_pci_bus_cx25821_dev_37185 pci_bus cx25821_dev 0 37185 NULL
+disable_so_b43_set_slot_time_fndecl_37196 b43_set_slot_time fndecl 2 37196 NULL
+disable_so_af9013_sleep_fndecl_37201 af9013_sleep fndecl 0 37201 NULL
+disable_so_sock_check_timeo_net_conf_37210 sock_check_timeo net_conf 0 37210 NULL
+disable_so_tms_utime_tms_37217 tms_utime tms 0 37217 NULL
+disable_so_lx_interrupt_request_new_buffer_fndecl_37218 lx_interrupt_request_new_buffer fndecl 0 37218 NULL
+disable_so_cryptomgr_notify_fndecl_37232 cryptomgr_notify fndecl 0 37232 NULL
+disable_so_wm831x_wdt_set_timeout_fndecl_37238 wm831x_wdt_set_timeout fndecl 2-0 37238 NULL
+disable_so_qh_schedule_fndecl_37247 qh_schedule fndecl 0 37247 NULL
+disable_so_nilfs_segctor_last_nongc_write_time_secs_show_fndecl_37250 nilfs_segctor_last_nongc_write_time_secs_show fndecl 0 37250 NULL nohasharray
+disable_so_total_crypto_hash_walk_37250 total crypto_hash_walk 0 37250 &disable_so_nilfs_segctor_last_nongc_write_time_secs_show_fndecl_37250
+disable_so_fq_rehash_fndecl_37274 fq_rehash fndecl 3-5 37274 NULL
+disable_so_set_addr_dsa_switch_driver_37276 set_addr dsa_switch_driver 0 37276 NULL
+disable_so_tv_sec_timeval_37284 tv_sec timeval 0 37284 NULL
+disable_so_timestamp_nfs4_lockdata_37285 timestamp nfs4_lockdata 0 37285 NULL
+disable_so_ccp_register_aes_xts_alg_fndecl_37292 ccp_register_aes_xts_alg fndecl 0 37292 NULL
+disable_so_ssb_chipco_timing_init_fndecl_37295 ssb_chipco_timing_init fndecl 2 37295 NULL
+disable_so_atime_sec_ubifs_ino_node_37298 atime_sec ubifs_ino_node 0 37298 NULL
+disable_so_sel_addr___queue_37305 sel_addr __queue 0 37305 NULL
+disable_so_nla_put_shortaddr_fndecl_37306 nla_put_shortaddr fndecl 0 37306 NULL
+disable_so_snd_pcm_sgbuf_get_addr_fndecl_37310 snd_pcm_sgbuf_get_addr fndecl 0-2 37310 NULL
+disable_so_qla2x00_program_flash_address_fndecl_37312 qla2x00_program_flash_address fndecl 2 37312 NULL
+disable_so_linetime_skl_pipe_wm_37317 linetime skl_pipe_wm 0 37317 NULL
+disable_so_d_time_ptc_stats_37320 d_time ptc_stats 0 37320 NULL nohasharray
+disable_so_dst_slave_addr_rcar_dmac_chan_37320 dst_slave_addr rcar_dmac_chan 0 37320 &disable_so_d_time_ptc_stats_37320
+disable_so_edx_tss_segment_32_37322 edx tss_segment_32 0 37322 NULL
+disable_so_time_stamp_ixgbevf_tx_buffer_37332 time_stamp ixgbevf_tx_buffer 0 37332 NULL
+disable_so_dccpor_elapsed_time_dccp_options_received_37349 dccpor_elapsed_time dccp_options_received 0 37349 NULL nohasharray
+disable_so_rhine_interrupt_fndecl_37349 rhine_interrupt fndecl 1 37349 &disable_so_dccpor_elapsed_time_dccp_options_received_37349
+disable_so_cpufreq_get_policy_fndecl_37351 cpufreq_get_policy fndecl 0-2 37351 NULL
+disable_so_blocksize_ccp_aes_def_37352 blocksize ccp_aes_def 0 37352 NULL
+disable_so_disengage_timeout_xpc_partition_37353 disengage_timeout xpc_partition 0 37353 NULL
+disable_so_nilfs_btree_lookup_contig_fndecl_37360 nilfs_btree_lookup_contig fndecl 0-2 37360 NULL
+disable_so_timeo_rpc_rtt_37368 timeo rpc_rtt 0 37368 NULL
+disable_so_calc_divisor_fndecl_37379 calc_divisor fndecl 0-1 37379 NULL
+disable_so_uid_ncp_mount_data_37380 uid ncp_mount_data 0 37380 NULL nohasharray
+disable_so_ip_vs_conn_hashkey_conn_fndecl_37380 ip_vs_conn_hashkey_conn fndecl 0 37380 &disable_so_uid_ncp_mount_data_37380
+disable_so_clock_delay_adv7511_link_config_37390 clock_delay adv7511_link_config 0 37390 NULL nohasharray
+disable_so_mtrr_check_fndecl_37390 mtrr_check fndecl 1-2 37390 &disable_so_clock_delay_adv7511_link_config_37390
+disable_so_tuner_addr_cx231xx_37393 tuner_addr cx231xx 0 37393 NULL
+disable_so_minute_timestamp_37395 minute timestamp 0 37395 NULL
+disable_so_mthca_mr_alloc_fndecl_37397 mthca_mr_alloc fndecl 5-0-2-3 37397 NULL
+disable_so_cx24123_int_log2_fndecl_37405 cx24123_int_log2 fndecl 0-2 37405 NULL
+disable_so_s_def_resgid_ext2_super_block_37420 s_def_resgid ext2_super_block 0 37420 NULL nohasharray
+disable_so_fast_pwrup_delay_ssb_chipcommon_37420 fast_pwrup_delay ssb_chipcommon 0 37420 &disable_so_s_def_resgid_ext2_super_block_37420
+disable_so_nfs_key_timeout_notify_fndecl_37423 nfs_key_timeout_notify fndecl 0 37423 NULL nohasharray
+disable_so_netxen_schedule_work_fndecl_37423 netxen_schedule_work fndecl 3 37423 &disable_so_nfs_key_timeout_notify_fndecl_37423
+disable_so_rx8025_sysfs_store_clock_adjust_fndecl_37426 rx8025_sysfs_store_clock_adjust fndecl 0-4 37426 NULL
+disable_so_port_mlx4_alias_guid_work_context_37428 port mlx4_alias_guid_work_context 0 37428 NULL
+disable_so_lpfc_max_scsicmpl_time_set_fndecl_37433 lpfc_max_scsicmpl_time_set fndecl 2 37433 NULL
+disable_so_mld_ifc_start_timer_fndecl_37436 mld_ifc_start_timer fndecl 2 37436 NULL
+disable_so_guest_phys_addr_vhost_memory_region_37438 guest_phys_addr vhost_memory_region 0 37438 NULL nohasharray
+disable_so_tun1_maddress_stv0900_init_params_37438 tun1_maddress stv0900_init_params 0 37438 &disable_so_guest_phys_addr_vhost_memory_region_37438
+disable_so_i2c_addr_m88ds3103_config_37446 i2c_addr m88ds3103_config 0 37446 NULL
+disable_so_hd_phys_address_hpet_data_37448 hd_phys_address hpet_data 0 37448 NULL
+disable_so_ip_addr_c2_netaddr_37452 ip_addr c2_netaddr 0 37452 NULL
+disable_so_acpi_map_cpuid_fndecl_37455 acpi_map_cpuid fndecl 0-1-2 37455 NULL
+disable_so_regcache_lzo_block_count_fndecl_37459 regcache_lzo_block_count fndecl 0 37459 NULL
+disable_so_iwl_dbgfs_interrupt_write_fndecl_37470 iwl_dbgfs_interrupt_write fndecl 0-3 37470 NULL
+disable_so_freq_timex_37471 freq timex 0 37471 NULL
+disable_so_gk104_fifo_engidx_fndecl_37472 gk104_fifo_engidx fndecl 0 37472 NULL
+disable_so_ocfs2_write_remove_suid_fndecl_37473 ocfs2_write_remove_suid fndecl 0 37473 NULL
+disable_so_zd_iowrite16a_locked_fndecl_37478 zd_iowrite16a_locked fndecl 0 37478 NULL
+disable_so_base_clock_slgt_info_37486 base_clock slgt_info 0 37486 NULL
+disable_so_onenand_addr_fndecl_37493 onenand_addr fndecl 0-2 37493 NULL
+disable_so_bitmap_shift_right_fndecl_37507 bitmap_shift_right fndecl 3-4 37507 NULL
+disable_so_phys_addr_netxen_recv_context_37520 phys_addr netxen_recv_context 0 37520 NULL
+disable_so_dma_addr_vmxnet3_tx_buf_info_37524 dma_addr vmxnet3_tx_buf_info 0 37524 NULL
+disable_so_start_time_fnic_io_req_37530 start_time fnic_io_req 0 37530 NULL
+disable_so_hash_val_rss_header_37536 hash_val rss_header 0 37536 NULL
+disable_so_dev_addr_bdc_37537 dev_addr bdc 0 37537 NULL
+disable_so_cobalt_enum_dv_timings_fndecl_37539 cobalt_enum_dv_timings fndecl 0 37539 NULL
+disable_so_timestamp_cw1200_link_entry_37549 timestamp cw1200_link_entry 0 37549 NULL
+disable_so_c_resolution_snd_timer_hardware_37556 c_resolution snd_timer_hardware 0 37556 NULL
+disable_so_dummy_systimer_pointer_fndecl_37562 dummy_systimer_pointer fndecl 0 37562 NULL
+disable_so_cir_wake_addr_nvt_dev_37577 cir_wake_addr nvt_dev 0 37577 NULL
+disable_so_clients_bit_vector_mac_configuration_entry_37582 clients_bit_vector mac_configuration_entry 0 37582 NULL
+disable_so___round_jiffies_up_fndecl_37586 __round_jiffies_up fndecl 2-1-0 37586 NULL
+disable_so_xfs_btree_updkey_fndecl_37592 xfs_btree_updkey fndecl 0 37592 NULL
+disable_so_r6b_val_fc2580_freq_regs_37593 r6b_val fc2580_freq_regs 0 37593 NULL
+disable_so_audit_backlog_wait_time_master_vardecl_audit_c_37596 audit_backlog_wait_time_master vardecl_audit.c 0 37596 NULL
+disable_so_hhf_arrays_reset_timestamp_hhf_sched_data_37598 hhf_arrays_reset_timestamp hhf_sched_data 0 37598 NULL
+disable_so_rate_den_snd_pcm_runtime_37607 rate_den snd_pcm_runtime 0 37607 NULL
+disable_so_vdi_mtime_vxfs_inode_info_37613 vdi_mtime vxfs_inode_info 0 37613 NULL
+disable_so_tx_bufs_dma_addr_sc92031_priv_37616 tx_bufs_dma_addr sc92031_priv 0 37616 NULL
+disable_so_brcmf_msgbuf_schedule_txdata_fndecl_37619 brcmf_msgbuf_schedule_txdata fndecl 2 37619 NULL
+disable_so_pvr2_hdw_set_cur_freq_fndecl_37630 pvr2_hdw_set_cur_freq fndecl 2 37630 NULL
+disable_so_pixclock_fb_cvt_data_37637 pixclock fb_cvt_data 0 37637 NULL
+disable_so_ieee80211_if_read_beacon_timeout_fndecl_37639 ieee80211_if_read_beacon_timeout fndecl 3-0 37639 NULL
+disable_so_ds1374_read_time_fndecl_37640 ds1374_read_time fndecl 0 37640 NULL
+disable_so_addr_handler_fndecl_37652 addr_handler fndecl 1 37652 NULL
+disable_so_v_radeon_clock_voltage_dependency_entry_37656 v radeon_clock_voltage_dependency_entry 0 37656 NULL
+disable_so_bma150_set_high_g_interrupt_fndecl_37662 bma150_set_high_g_interrupt fndecl 4-5-3-0 37662 NULL
+disable_so_SYSC_setresuid_fndecl_37663 SYSC_setresuid fndecl 0 37663 NULL
+disable_so_sht15_interrupt_fired_fndecl_37668 sht15_interrupt_fired fndecl 1 37668 NULL
+disable_so_munge_address_falcon_spi_device_37671 munge_address falcon_spi_device 0 37671 NULL
+disable_so___hw_addr_unsync_fndecl_37673 __hw_addr_unsync fndecl 3 37673 NULL
+disable_so_uv_mmtimer_femtoperiod_vardecl_uv_mmtimer_c_37680 uv_mmtimer_femtoperiod vardecl_uv_mmtimer.c 0 37680 NULL
+disable_so_phy_addr_pxa168_eth_private_37687 phy_addr pxa168_eth_private 0 37687 NULL
+disable_so_pch_udc_read_ep_interrupts_fndecl_37692 pch_udc_read_ep_interrupts fndecl 0 37692 NULL
+disable_so_en_addr0_nphy_rf_control_override_rev3_37699 en_addr0 nphy_rf_control_override_rev3 0 37699 NULL
+disable_so_sense_phys_addr_megasas_cmd_37718 sense_phys_addr megasas_cmd 0 37718 NULL
+disable_so_dsc_poll_freq_ide_tape_obj_37730 dsc_poll_freq ide_tape_obj 0 37730 NULL
+disable_so_no_gc_sleep_time_f2fs_gc_kthread_37736 no_gc_sleep_time f2fs_gc_kthread 0 37736 NULL
+disable_so_b_addr_dma_data_buffer_37749 b_addr dma_data_buffer 0 37749 NULL
+disable_so_test_hash_jiffies_fndecl_37757 test_hash_jiffies fndecl 4 37757 NULL
+disable_so_bufptr_addr_nm256_stream_37759 bufptr_addr nm256_stream 0 37759 NULL nohasharray
+disable_so_gcm_hash_crypt_continue_fndecl_37759 gcm_hash_crypt_continue fndecl 0 37759 &disable_so_bufptr_addr_nm256_stream_37759
+disable_so_get_semotime_fndecl_37761 get_semotime fndecl 0 37761 NULL
+disable_so_ds_tss_segment_32_37770 ds tss_segment_32 0 37770 NULL nohasharray
+disable_so_ccp_run_aes_cmd_fndecl_37770 ccp_run_aes_cmd fndecl 0 37770 &disable_so_ds_tss_segment_32_37770
+disable_so_sys_signal_fndecl_37776 sys_signal fndecl 1 37776 NULL
+disable_so_jiffies_till_next_fqs_vardecl_tree_c_37778 jiffies_till_next_fqs vardecl_tree.c 0 37778 NULL
+disable_so_col_scan_delay_us_matrix_keypad_platform_data_37789 col_scan_delay_us matrix_keypad_platform_data 0 37789 NULL
+disable_so_small_buf_phy_addr_ql3_adapter_37791 small_buf_phy_addr ql3_adapter 0 37791 NULL
+disable_so_bitmap_intersects_fndecl_37795 bitmap_intersects fndecl 3 37795 NULL
+disable_so_clock_panel_info_37807 clock panel_info 0 37807 NULL
+disable_so_unix_gid_hash_fndecl_37822 unix_gid_hash fndecl 0 37822 NULL
+disable_so_btrfs_inode_uid_fndecl_37823 btrfs_inode_uid fndecl 0 37823 NULL
+disable_so_snd_usb_find_clock_multiplier_fndecl_37825 snd_usb_find_clock_multiplier fndecl 2 37825 NULL nohasharray
+disable_so_queue_show_random_fndecl_37825 queue_show_random fndecl 0 37825 &disable_so_snd_usb_find_clock_multiplier_fndecl_37825
+disable_so_intr_gen_timer_trigger_ath_hw_37826 intr_gen_timer_trigger ath_hw 0 37826 NULL
+disable_so_mvs_interrupt_fndecl_37840 mvs_interrupt fndecl 1 37840 NULL
+disable_so_aic7xxx_seltime_vardecl_aic7xxx_osm_c_37841 aic7xxx_seltime vardecl_aic7xxx_osm.c 0 37841 NULL
+disable_so_baud_uartdiv_baycom_state_37846 baud_uartdiv baycom_state 0 37846 NULL
+disable_so_ac97_clock_vardecl_intel8x0m_c_37848 ac97_clock vardecl_intel8x0m.c 0 37848 NULL nohasharray
+disable_so_rtl818x_iowrite8_idx_fndecl_37848 rtl818x_iowrite8_idx fndecl 3 37848 &disable_so_ac97_clock_vardecl_intel8x0m_c_37848
+disable_so_io_addr_kcq_info_37850 io_addr kcq_info 0 37850 NULL
+disable_so_last_signal_sta_info_37865 last_signal sta_info 0 37865 NULL
+disable_so_dccpor_timestamp_echo_dccp_options_received_37875 dccpor_timestamp_echo dccp_options_received 0 37875 NULL
+disable_so_ccp_aes_cmac_update_fndecl_37894 ccp_aes_cmac_update fndecl 0 37894 NULL
+disable_so_chip_delay_nand_chip_37901 chip_delay nand_chip 0 37901 NULL
+disable_so_saddr_irlap_cb_37910 saddr irlap_cb 0 37910 NULL
+disable_so_disk_timeout_disk_conf_37918 disk_timeout disk_conf 0 37918 NULL
+disable_so_show_time_in_state_fndecl_37923 show_time_in_state fndecl 0 37923 NULL
+disable_so_snd_timer_user_pause_fndecl_37928 snd_timer_user_pause fndecl 0 37928 NULL
+disable_so_is_valid_rtc_data_addr_il_ops_37930 is_valid_rtc_data_addr il_ops 1 37930 NULL
+disable_so_wl18xx_enable_interrupts_fndecl_37937 wl18xx_enable_interrupts fndecl 0 37937 NULL nohasharray
+disable_so_nested_vmx_store_msr_fndecl_37937 nested_vmx_store_msr fndecl 2 37937 &disable_so_wl18xx_enable_interrupts_fndecl_37937
+disable_so_last_ack_time_misc_stats_37946 last_ack_time misc_stats 0 37946 NULL
+disable_so_vblank_lo_lvds_dvo_timing_37949 vblank_lo lvds_dvo_timing 0 37949 NULL
+disable_so_ath6kl_get_hi_item_addr_fndecl_37951 ath6kl_get_hi_item_addr fndecl 0-2 37951 NULL
+disable_so_bitmap_word_used_fndecl_37955 bitmap_word_used fndecl 2 37955 NULL
+disable_so_process_tgid_coredump_proc_event_37962 process_tgid coredump_proc_event 0 37962 NULL
+disable_so_device_addr_net2280_tx_hdr_37967 device_addr net2280_tx_hdr 0 37967 NULL nohasharray
+disable_so_sctp_assoc_set_bind_addr_from_cookie_fndecl_37967 sctp_assoc_set_bind_addr_from_cookie fndecl 0-3 37967 &disable_so_device_addr_net2280_tx_hdr_37967
+disable_so_read_l1_tsc_kvm_x86_ops_37977 read_l1_tsc kvm_x86_ops 0-2 37977 NULL
+disable_so_ipqhashfn_fndecl_37983 ipqhashfn fndecl 1-4 37983 NULL
+disable_so_divider_get_val_fndecl_37994 divider_get_val fndecl 1-2-4-0 37994 NULL
+disable_so_rfc4106_set_hash_subkey_fndecl_37995 rfc4106_set_hash_subkey fndecl 3 37995 NULL
+disable_so_intel_overlay_recover_from_interrupt_fndecl_37996 intel_overlay_recover_from_interrupt fndecl 0 37996 NULL
+disable_so_demod_address_tda10023_config_37998 demod_address tda10023_config 0 37998 NULL nohasharray
+disable_so_addrconf_del_ifaddr_fndecl_37998 addrconf_del_ifaddr fndecl 0 37998 &disable_so_demod_address_tda10023_config_37998
+disable_so_clear_bit_unlock_fndecl_38002 clear_bit_unlock fndecl 1 38002 NULL
+disable_so_mactime_ieee80211_rx_status_38004 mactime ieee80211_rx_status 0 38004 NULL
+disable_so_conn_info_timestamp_hci_conn_38005 conn_info_timestamp hci_conn 0 38005 NULL
+disable_so_il_vsync_v4l2_bt_timings_38013 il_vsync v4l2_bt_timings 0 38013 NULL
+disable_so_bch_strtouint_h_fndecl_38016 bch_strtouint_h fndecl 0 38016 NULL
+disable_so_crypto_ccm_encrypt_fndecl_38019 crypto_ccm_encrypt fndecl 0 38019 NULL
+disable_so_beacon_timeout_ms_vardecl_38026 beacon_timeout_ms vardecl 0 38026 NULL
+disable_so_ima_calc_field_array_hash_fndecl_38044 ima_calc_field_array_hash fndecl 0-3 38044 NULL
+disable_so_mISDN_clock_update_fndecl_38046 mISDN_clock_update fndecl 2 38046 NULL
+disable_so_rv6xx_memory_clock_entry_set_post_divider_fndecl_38049 rv6xx_memory_clock_entry_set_post_divider fndecl 3 38049 NULL nohasharray
+disable_so_tuner_set_frequency_stb0899_config_38049 tuner_set_frequency stb0899_config 2 38049 &disable_so_rv6xx_memory_clock_entry_set_post_divider_fndecl_38049
+disable_so_bcma_pmu_get_cpu_clock_fndecl_38056 bcma_pmu_get_cpu_clock fndecl 0 38056 NULL
+disable_so_mei_irq_write_handler_fndecl_38063 mei_irq_write_handler fndecl 0 38063 NULL
+disable_so_follow_huge_addr_fndecl_38066 follow_huge_addr fndecl 2 38066 NULL
+disable_so_wait_for_completion_timeout_fndecl_38078 wait_for_completion_timeout fndecl 0-2 38078 NULL
+disable_so_wm8961_set_clkdiv_fndecl_38080 wm8961_set_clkdiv fndecl 3 38080 NULL
+disable_so_process_tgid_ptrace_proc_event_38081 process_tgid ptrace_proc_event 0 38081 NULL
+disable_so_blocknr_disk_bitmap_header_38088 blocknr disk_bitmap_header 0 38088 NULL
+disable_so_index_cnt_btrfs_delayed_node_38090 index_cnt btrfs_delayed_node 0 38090 NULL
+disable_so_bq32k_rtc_set_time_fndecl_38091 bq32k_rtc_set_time fndecl 0 38091 NULL nohasharray
+disable_so_apei_map_generic_address_fndecl_38091 apei_map_generic_address fndecl 0 38091 &disable_so_bq32k_rtc_set_time_fndecl_38091
+disable_so_xfs_iformat_btree_fndecl_38096 xfs_iformat_btree fndecl 0 38096 NULL
+disable_so_inet6_rtm_newaddr_fndecl_38099 inet6_rtm_newaddr fndecl 0 38099 NULL
+disable_so_tuner_set_frequency_stv090x_config_38105 tuner_set_frequency stv090x_config 2 38105 NULL
+disable_so_atomic_notifier_chain_register_fndecl_38114 atomic_notifier_chain_register fndecl 0 38114 NULL
+disable_so_timeout_parms_to_skb_fndecl_38116 timeout_parms_to_skb fndecl 0 38116 NULL
+disable_so_key_idx_off_ieee80211_cipher_scheme_38117 key_idx_off ieee80211_cipher_scheme 0 38117 NULL
+disable_so_qla2x00_zio_timer_store_fndecl_38118 qla2x00_zio_timer_store fndecl 0 38118 NULL
+disable_so_pch_udc_write_ep_interrupts_fndecl_38129 pch_udc_write_ep_interrupts fndecl 2 38129 NULL
+disable_so_ipv4addr_cxgbi_hba_38131 ipv4addr cxgbi_hba 0 38131 NULL
+disable_so_ep0_bounce_addr_dwc3_38133 ep0_bounce_addr dwc3 0 38133 NULL
+disable_so_br_ip_hash_fndecl_38135 br_ip_hash fndecl 0 38135 NULL
+disable_so_signal_to_av_fndecl_38146 signal_to_av fndecl 0 38146 NULL nohasharray
+disable_so_ext4_init_block_bitmap_fndecl_38146 ext4_init_block_bitmap fndecl 3 38146 &disable_so_signal_to_av_fndecl_38146
+disable_so_mapped_physical_address_acpi_mem_space_context_38147 mapped_physical_address acpi_mem_space_context 0 38147 NULL
+disable_so_uptime_dn_dev_38149 uptime dn_dev 0 38149 NULL nohasharray
+disable_so_btrfs_name_hash_fndecl_38149 btrfs_name_hash fndecl 0-2 38149 &disable_so_uptime_dn_dev_38149
+disable_so_snd_timer_pause_fndecl_38159 snd_timer_pause fndecl 0 38159 NULL
+disable_so_flash_addr_atto_vda_flash_req_38165 flash_addr atto_vda_flash_req 0 38165 NULL
+disable_so_bfa_fcs_lport_ns_sm_sending_gid_ft_fndecl_38173 bfa_fcs_lport_ns_sm_sending_gid_ft fndecl 2 38173 NULL
+disable_so_nla_put_flag_fndecl_38183 nla_put_flag fndecl 0 38183 NULL
+disable_so_fll_freq_in_wm8350_data_38185 fll_freq_in wm8350_data 0 38185 NULL
+disable_so_softdog_set_timeout_fndecl_38187 softdog_set_timeout fndecl 2 38187 NULL
+disable_so_i_uid_sysv_inode_38197 i_uid sysv_inode 0 38197 NULL
+disable_so_start_time_wl1271_tx_hw_descr_38213 start_time wl1271_tx_hw_descr 0 38213 NULL
+disable_so_address_callback_fw_address_handler_38224 address_callback fw_address_handler 6-9 38224 NULL
+disable_so_last_rsrc_error_time_lpfc_hba_38225 last_rsrc_error_time lpfc_hba 0 38225 NULL
+disable_so_val_addr1_nphy_rf_control_override_rev3_38228 val_addr1 nphy_rf_control_override_rev3 0 38228 NULL
+disable_so_ipr_transop_timeout_vardecl_ipr_c_38231 ipr_transop_timeout vardecl_ipr.c 0 38231 NULL
+disable_so_disk_events_poll_jiffies_fndecl_38233 disk_events_poll_jiffies fndecl 0 38233 NULL
+disable_so_s2mps11_set_ramp_delay_fndecl_38236 s2mps11_set_ramp_delay fndecl 0 38236 NULL
+disable_so_rdb_BlockBytes_RigidDiskBlock_38238 rdb_BlockBytes RigidDiskBlock 0 38238 NULL
+disable_so_bitmap_equal_fndecl_38239 bitmap_equal fndecl 3 38239 NULL
+disable_so_drm_mm_init_fndecl_38240 drm_mm_init fndecl 2-3 38240 NULL nohasharray
+disable_so_ring_info_addr_brcmf_pcie_shared_info_38240 ring_info_addr brcmf_pcie_shared_info 0 38240 &disable_so_drm_mm_init_fndecl_38240
+disable_so_cg_spll_spread_spectrum_ni_clock_registers_38241 cg_spll_spread_spectrum ni_clock_registers 0 38241 NULL
+disable_so_byt_gpu_freq_fndecl_38243 byt_gpu_freq fndecl 0-2 38243 NULL
+disable_so_hhf_evict_timeout_hhf_sched_data_38244 hhf_evict_timeout hhf_sched_data 0 38244 NULL
+disable_so_addr_unmap_notify_38247 addr unmap_notify 0 38247 NULL
+disable_so_xfs_btree_reada_bufl_fndecl_38248 xfs_btree_reada_bufl fndecl 2-3 38248 NULL
+disable_so_ip_vs_conn_hashkey_param_fndecl_38257 ip_vs_conn_hashkey_param fndecl 0 38257 NULL
+disable_so_prev_steal_time_rq_rq_38260 prev_steal_time_rq rq 0 38260 NULL
+disable_so_mapaddr_map_list_38266 mapaddr map_list 0 38266 NULL
+disable_so_reqoff_crypto_authenc_esn_ctx_38268 reqoff crypto_authenc_esn_ctx 0 38268 NULL
+disable_so_ui_mtimensec_ufs2_inode_38278 ui_mtimensec ufs2_inode 0 38278 NULL
+disable_so_scbbaddr_ahc_pci_softc_38281 scbbaddr ahc_pci_softc 0 38281 NULL
+disable_so_demod_address_dst_config_38283 demod_address dst_config 0 38283 NULL
+disable_so_pcc_cpufreq_init_fndecl_38287 pcc_cpufreq_init fndecl 0 38287 NULL
+disable_so_channel_divider_ad9523_channel_spec_38291 channel_divider ad9523_channel_spec 0 38291 NULL
+disable_so_time_in_ghes_estatus_cache_38306 time_in ghes_estatus_cache 0 38306 NULL
+disable_so_time_stamp_i40e_tx_buffer_38313 time_stamp i40e_tx_buffer 0 38313 NULL
+disable_so_show_signal_msg_fndecl_38336 show_signal_msg fndecl 3 38336 NULL
+disable_so_cma_bitmap_aligned_offset_fndecl_38343 cma_bitmap_aligned_offset fndecl 0-2 38343 NULL
+disable_so_digi_set_modem_signals_fndecl_38348 digi_set_modem_signals fndecl 0 38348 NULL
+disable_so_sum_blk_addr_fndecl_38356 sum_blk_addr fndecl 0-2-3 38356 NULL
+disable_so_gcm_hash_assoc_done_fndecl_38360 gcm_hash_assoc_done fndecl 2 38360 NULL
+disable_so_dma_headwb_addr_i40e_virtchnl_txq_info_38365 dma_headwb_addr i40e_virtchnl_txq_info 0 38365 NULL
+disable_so_cpu_cpufreq_policy_38366 cpu cpufreq_policy 0 38366 NULL nohasharray
+disable_so_shash_descsize_dm_verity_38366 shash_descsize dm_verity 0 38366 &disable_so_cpu_cpufreq_policy_38366
+disable_so_sleep_cookie_addr_lo_host_cmd_ds_pcie_details_38370 sleep_cookie_addr_lo host_cmd_ds_pcie_details 0 38370 NULL
+disable_so_bch_btree_keys_u64s_remaining_fndecl_38373 bch_btree_keys_u64s_remaining fndecl 0 38373 NULL
+disable_so_timeout_lp_struct_38387 timeout lp_struct 0 38387 NULL
+disable_so_x1205_set_datetime_fndecl_38391 x1205_set_datetime fndecl 4 38391 NULL
+disable_so_dma_addr_rxd_info_38410 dma_addr rxd_info 0 38410 NULL
+disable_so_copy_signaled_event_data_fndecl_38425 copy_signaled_event_data fndecl 1 38425 NULL
+disable_so_bcn_addr_carl9170_bcn_ctrl_cmd_38429 bcn_addr carl9170_bcn_ctrl_cmd 0 38429 NULL
+disable_so_rproc_vq_interrupt_fndecl_38432 rproc_vq_interrupt fndecl 2 38432 NULL
+disable_so_div_clk_div_table_38447 div clk_div_table 0 38447 NULL
+disable_so_seq_default_timer_resolution_vardecl_38451 seq_default_timer_resolution vardecl 0 38451 NULL
+disable_so_dma_ops_free_addresses_fndecl_38461 dma_ops_free_addresses fndecl 2-3 38461 NULL
+disable_so_time_zero_xfs_mru_cache_38463 time_zero xfs_mru_cache 0 38463 NULL
+disable_so_timeAdj_TCP_Server_Info_38464 timeAdj TCP_Server_Info 0 38464 NULL
+disable_so_curr_kvm_shared_msr_values_38468 curr kvm_shared_msr_values 0 38468 NULL
+disable_so_vhost_add_used_and_signal_fndecl_38469 vhost_add_used_and_signal fndecl 4-3 38469 NULL
+disable_so_mclk_pwrmgt_cntl_ni_clock_registers_38478 mclk_pwrmgt_cntl ni_clock_registers 0 38478 NULL
+disable_so_srp_reconnect_delay_vardecl_ib_srp_c_38484 srp_reconnect_delay vardecl_ib_srp.c 0 38484 NULL
+disable_so_i2c_clk_divider_au0828_board_38485 i2c_clk_divider au0828_board 0 38485 NULL
+disable_so_ark_set_pixclock_fndecl_38501 ark_set_pixclock fndecl 2 38501 NULL
+disable_so_use_time_xfrm_lifetime_cur_38505 use_time xfrm_lifetime_cur 0 38505 NULL nohasharray
+disable_so_musb_advance_schedule_fndecl_38505 musb_advance_schedule fndecl 4 38505 &disable_so_use_time_xfrm_lifetime_cur_38505
+disable_so_spinfo_mtu_sctp_paddrinfo_38516 spinfo_mtu sctp_paddrinfo 0 38516 NULL
+disable_so_sample_freq_tda10048_state_38521 sample_freq tda10048_state 0 38521 NULL
+disable_so_mapping_level_dirty_bitmap_fndecl_38527 mapping_level_dirty_bitmap fndecl 2 38527 NULL
+disable_so_rx_ring_dma_addr_sc92031_priv_38536 rx_ring_dma_addr sc92031_priv 0 38536 NULL
+disable_so___ipv6_addr_type_fndecl_38537 __ipv6_addr_type fndecl 0 38537 NULL
+disable_so_cstamp_inet6_ifaddr_38541 cstamp inet6_ifaddr 0 38541 NULL
+disable_so_arch_randomize_brk_fndecl_38542 arch_randomize_brk fndecl 0 38542 NULL
+disable_so_imon_mce_key_lookup_fndecl_38543 imon_mce_key_lookup fndecl 0-2 38543 NULL
+disable_so_amdgpu_mm_wreg_fndecl_38550 amdgpu_mm_wreg fndecl 2-3 38550 NULL
+disable_so_mgid_index_mthca_qp_path_38553 mgid_index mthca_qp_path 0 38553 NULL
+disable_so_i_gid_bfs_inode_38565 i_gid bfs_inode 0 38565 NULL
+disable_so_tx_delayed_compl_wlcore_ops_38572 tx_delayed_compl wlcore_ops 0 38572 NULL
+disable_so_split_scan_timeout_write_fndecl_38579 split_scan_timeout_write fndecl 3-0 38579 NULL
+disable_so_xfs_btree_change_owner_fndecl_38586 xfs_btree_change_owner fndecl 0-2 38586 NULL
+disable_so_hash_sendmsg_fndecl_38588 hash_sendmsg fndecl 0 38588 NULL
+disable_so_read_inode_bitmap_fndecl_38589 read_inode_bitmap fndecl 2 38589 NULL
+disable_so_before_ctime_sec_nfsd4_change_info_38591 before_ctime_sec nfsd4_change_info 0 38591 NULL
+disable_so_sys_clock_freq_drx_common_attr_38599 sys_clock_freq drx_common_attr 0 38599 NULL
+disable_so_kvm_x2apic_msr_write_fndecl_38601 kvm_x2apic_msr_write fndecl 3 38601 NULL
+disable_so_stored_addr_lo_amd_iommu_38609 stored_addr_lo amd_iommu 0 38609 NULL
+disable_so_udp_port_udp_media_addr_38613 udp_port udp_media_addr 0 38613 NULL
+disable_so_hashmask_Qdisc_class_hash_38621 hashmask Qdisc_class_hash 0 38621 NULL
+disable_so_i_gid_nilfs_inode_38625 i_gid nilfs_inode 0 38625 NULL
+disable_so__freq_tbl_determine_rate_fndecl_38627 _freq_tbl_determine_rate fndecl 0 38627 NULL
+disable_so_n__pll_div_38634 n _pll_div 0 38634 NULL
+disable_so_security_task_getpgid_fndecl_38635 security_task_getpgid fndecl 0 38635 NULL
+disable_so_dmsr_eg20t_port_38638 dmsr eg20t_port 0 38638 NULL
+disable_so_e4000_s_frequency_fndecl_38648 e4000_s_frequency fndecl 0 38648 NULL
+disable_so_timestamp_iwl_rx_phy_res_38650 timestamp iwl_rx_phy_res 0 38650 NULL
+disable_so_set_freq_fndecl_38651 set_freq fndecl 2 38651 NULL
+disable_so_technisat_usb2_set_led_timer_fndecl_38654 technisat_usb2_set_led_timer fndecl 3-2 38654 NULL
+disable_so_mthca_query_gid_fndecl_38656 mthca_query_gid fndecl 2-3 38656 NULL
+disable_so_mpihelp_addmul_1_fndecl_38658 mpihelp_addmul_1 fndecl 3 38658 NULL
+disable_so_press_adjust_channel_bit_mask_fndecl_38661 press_adjust_channel_bit_mask fndecl 3 38661 NULL
+disable_so_vdi_ctime_vxfs_inode_info_38664 vdi_ctime vxfs_inode_info 0 38664 NULL
+disable_so_afs_vlocation_update_timeout_vardecl_vlocation_c_38669 afs_vlocation_update_timeout vardecl_vlocation.c 0 38669 NULL nohasharray
+disable_so_last_semaphore_signal_addr_radeon_ring_38669 last_semaphore_signal_addr radeon_ring 0 38669 &disable_so_afs_vlocation_update_timeout_vardecl_vlocation_c_38669
+disable_so_rhashtable_check_elasticity_fndecl_38676 rhashtable_check_elasticity fndecl 3 38676 NULL
+disable_so_addr_bus_sg_simple_element_38677 addr_bus sg_simple_element 0 38677 NULL
+disable_so_pcxhr_get_external_clock_fndecl_38682 pcxhr_get_external_clock fndecl 0 38682 NULL
+disable_so_ahd_timer_reset_fndecl_38702 ahd_timer_reset fndecl 2 38702 NULL nohasharray
+disable_so_nr_uninterruptible_rq_38702 nr_uninterruptible rq 0 38702 &disable_so_ahd_timer_reset_fndecl_38702
+disable_so_dp_saddr_rds_ib_connect_private_38707 dp_saddr rds_ib_connect_private 0 38707 NULL
+disable_so_dsp_spl_jiffies_vardecl_38710 dsp_spl_jiffies vardecl 0 38710 NULL
+disable_so_mtrr_lookup_init_fndecl_38724 mtrr_lookup_init fndecl 4-3 38724 NULL
+disable_so_qdisc_watchdog_schedule_fndecl_38729 qdisc_watchdog_schedule fndecl 2 38729 NULL
+disable_so_authenc_esn_verify_ahash_update_done_fndecl_38734 authenc_esn_verify_ahash_update_done fndecl 2 38734 NULL
+disable_so_hactive_hi_oaktrail_timing_info_38738 hactive_hi oaktrail_timing_info 0 38738 NULL
+disable_so_i2c_address_xc5000_config_38739 i2c_address xc5000_config 0 38739 NULL
+disable_so_address_fw_hdr_38754 address fw_hdr 0 38754 NULL
+disable_so_radio_addr_saa7134_dev_38765 radio_addr saa7134_dev 0 38765 NULL
+disable_so_i2c_address_max2165_config_38766 i2c_address max2165_config 0 38766 NULL nohasharray
+disable_so_lcq_addr_lo_fcoe_kwqe_conn_offload4_38766 lcq_addr_lo fcoe_kwqe_conn_offload4 0 38766 &disable_so_i2c_address_max2165_config_38766
+disable_so_fan1_div_amc6821_data_38770 fan1_div amc6821_data 0 38770 NULL
+disable_so_sd_blocks_per_bitmap_gfs2_sbd_38771 sd_blocks_per_bitmap gfs2_sbd 0 38771 NULL
+disable_so_cryptd_hash_finup_fndecl_38778 cryptd_hash_finup fndecl 2 38778 NULL
+disable_so_mnamehash_dlm_master_list_entry_38791 mnamehash dlm_master_list_entry 0 38791 NULL
+disable_so_compat_sys_clock_nanosleep_fndecl_38793 compat_sys_clock_nanosleep fndecl 1 38793 NULL
+disable_so_minutes_v4l2_timecode_38804 minutes v4l2_timecode 0 38804 NULL
+disable_so_mtrr_type_lookup_variable_fndecl_38806 mtrr_type_lookup_variable fndecl 1-2 38806 NULL
+disable_so_pch_uart_hal_disable_interrupt_fndecl_38820 pch_uart_hal_disable_interrupt fndecl 2 38820 NULL nohasharray
+disable_so_addr_azx_38820 addr azx 0 38820 &disable_so_pch_uart_hal_disable_interrupt_fndecl_38820
+disable_so_num_addresses_at24_data_38822 num_addresses at24_data 0 38822 NULL
+disable_so_delay_reg_anatop_regulator_38823 delay_reg anatop_regulator 0 38823 NULL
+disable_so_table_addr_radeon_gart_38825 table_addr radeon_gart 0 38825 NULL
+disable_so_random_ioctl_fndecl_38846 random_ioctl fndecl 0 38846 NULL
+disable_so_iwl_count_chain_bitmap_fndecl_38847 iwl_count_chain_bitmap fndecl 0-1 38847 NULL
+disable_so_phy_pm_runtime_get_fndecl_38865 phy_pm_runtime_get fndecl 0 38865 NULL
+disable_so_interrupt_level_mask_kszphy_type_38870 interrupt_level_mask kszphy_type 0 38870 NULL nohasharray
+disable_so_r25_val_fc2580_freq_regs_38870 r25_val fc2580_freq_regs 0 38870 &disable_so_interrupt_level_mask_kszphy_type_38870
+disable_so_cc770_tx_interrupt_fndecl_38879 cc770_tx_interrupt fndecl 2 38879 NULL
+disable_so_rq_first_pbe_addr_lo_fcoe_kwqe_conn_offload1_38880 rq_first_pbe_addr_lo fcoe_kwqe_conn_offload1 0 38880 NULL
+disable_so_hpi_compander_get_attack_time_constant_fndecl_38881 hpi_compander_get_attack_time_constant fndecl 1-0 38881 NULL
+disable_so_get_clock_info_fndecl_38883 get_clock_info fndecl 4-0 38883 NULL
+disable_so_ieee80211_aes_gmac_fndecl_38891 ieee80211_aes_gmac fndecl 5 38891 NULL
+disable_so_port_mlx4_sriov_alias_guid_port_rec_det_38897 port mlx4_sriov_alias_guid_port_rec_det 0 38897 NULL
+disable_so_fd_pppol2tpv3_addr_38898 fd pppol2tpv3_addr 0 38898 NULL nohasharray
+disable_so_bcm3510_set_freq_fndecl_38898 bcm3510_set_freq fndecl 2 38898 &disable_so_fd_pppol2tpv3_addr_38898
+disable_so_irq_dispose_mapping_fndecl_38902 irq_dispose_mapping fndecl 1 38902 NULL
+disable_so_crypto_ccm_decrypt_done_fndecl_38904 crypto_ccm_decrypt_done fndecl 2 38904 NULL
+disable_so_cw1200_queue_get_xmit_timestamp_fndecl_38907 cw1200_queue_get_xmit_timestamp fndecl 3 38907 NULL nohasharray
+disable_so_s_addr_per_block_bits_ext4_sb_info_38907 s_addr_per_block_bits ext4_sb_info 0 38907 &disable_so_cw1200_queue_get_xmit_timestamp_fndecl_38907
+disable_so_check_num_extents_and_bitmaps_fndecl_38927 check_num_extents_and_bitmaps fndecl 0 38927 NULL
+disable_so_timekeeping_get_tai_offset_fndecl_38933 timekeeping_get_tai_offset fndecl 0 38933 NULL nohasharray
+disable_so_ccp_register_aes_cmac_algs_fndecl_38933 ccp_register_aes_cmac_algs fndecl 0 38933 &disable_so_timekeeping_get_tai_offset_fndecl_38933
+disable_so_mlx4_get_base_gid_ix_fndecl_38938 mlx4_get_base_gid_ix fndecl 0-2-3 38938 NULL
+disable_so_default_i2c_addr_dib7000p_config_38941 default_i2c_addr dib7000p_config 0 38941 NULL
+disable_so_nilfs_btree_get_next_key_fndecl_38942 nilfs_btree_get_next_key fndecl 0 38942 NULL
+disable_so_eoc_delay_ns_cc10001_adc_device_38943 eoc_delay_ns cc10001_adc_device 0 38943 NULL
+disable_so_get_clock_desc_fndecl_38944 get_clock_desc fndecl 1 38944 NULL
+disable_so_hdsp_set_interrupt_interval_fndecl_38947 hdsp_set_interrupt_interval fndecl 2 38947 NULL
+disable_so_sysctl_sched_time_avg_vardecl_38969 sysctl_sched_time_avg vardecl 0 38969 NULL
+disable_so_vivid_radio_s_frequency_fndecl_38975 vivid_radio_s_frequency fndecl 0 38975 NULL
+disable_so_sha1_pad_fndecl_38979 sha1_pad fndecl 0-2 38979 NULL
+disable_so_hash_mask_deflate_state_38981 hash_mask deflate_state 0 38981 NULL
+disable_so_pos_dmaengine_pcm_runtime_data_38984 pos dmaengine_pcm_runtime_data 0 38984 NULL
+disable_so_set_dma_addr_fndecl_38989 set_dma_addr fndecl 1-2 38989 NULL
+disable_so_caller_gid_ceph_mds_request_head_38991 caller_gid ceph_mds_request_head 0 38991 NULL
+disable_so_bf_paddr_ath_mci_buf_38995 bf_paddr ath_mci_buf 0 38995 NULL
+disable_so_x86_setup_var_mtrrs_fndecl_39006 x86_setup_var_mtrrs fndecl 4-3-2 39006 NULL nohasharray
+disable_so_uv_global_mmr64_address_fndecl_39006 uv_global_mmr64_address fndecl 1 39006 &disable_so_x86_setup_var_mtrrs_fndecl_39006
+disable_so_interrupt_out_interval_lego_usb_tower_39007 interrupt_out_interval lego_usb_tower 0 39007 NULL
+disable_so_di_uid_logfs_disk_inode_39011 di_uid logfs_disk_inode 0 39011 NULL
+disable_so_cfag12864b_address_fndecl_39018 cfag12864b_address fndecl 1 39018 NULL
+disable_so_dmaaddr_b43legacy_dmadesc_meta_39023 dmaaddr b43legacy_dmadesc_meta 0 39023 NULL
+disable_so_dce_v10_0_crtc_set_base_atomic_fndecl_39025 dce_v10_0_crtc_set_base_atomic fndecl 0 39025 NULL
+disable_so_dst_addr_l_wcn36xx_dxe_desc_39037 dst_addr_l wcn36xx_dxe_desc 0 39037 NULL
+disable_so_show_fan_div_fndecl_39039 show_fan_div fndecl 0 39039 NULL
+disable_so_set_timer_slack_fndecl_39051 set_timer_slack fndecl 2 39051 NULL
+disable_so_seq_xfrm_usersa_info_39054 seq xfrm_usersa_info 0 39054 NULL
+disable_so_freq_wmi_send_action_cmd_39065 freq wmi_send_action_cmd 0 39065 NULL
+disable_so_addr_ksz_hw_desc_39069 addr ksz_hw_desc 0 39069 NULL
+disable_so_fll_refclk_div__fll_div_39071 fll_refclk_div _fll_div 0 39071 NULL
+disable_so_atime_nsec_ubifs_ino_node_39079 atime_nsec ubifs_ino_node 0 39079 NULL
+disable_so_p2m_jiffies_solo_dev_39094 p2m_jiffies solo_dev 0 39094 NULL
+disable_so_cl_time_nfs4_client_39095 cl_time nfs4_client 0 39095 NULL
+disable_so_addr_inet_cork_39099 addr inet_cork 0 39099 NULL nohasharray
+disable_so_get_cur_freq_on_cpu_fndecl_39099 get_cur_freq_on_cpu fndecl 0 39099 &disable_so_addr_inet_cork_39099
+disable_so_addr_radeon_dummy_page_39105 addr radeon_dummy_page 0 39105 NULL
+disable_so_dmar_set_interrupt_fndecl_39106 dmar_set_interrupt fndecl 0 39106 NULL
+disable_so_read_position_register_address_sst_hsw_ipc_stream_alloc_reply_39122 read_position_register_address sst_hsw_ipc_stream_alloc_reply 0 39122 NULL
+disable_so_atomic_set_property_drm_plane_funcs_39123 atomic_set_property drm_plane_funcs 0-4 39123 NULL nohasharray
+disable_so_sisfb_mode_rate_to_dclock_fndecl_39123 sisfb_mode_rate_to_dclock fndecl 2-3-0 39123 &disable_so_atomic_set_property_drm_plane_funcs_39123
+disable_so_div_sync_wait_dib7000p_state_39125 div_sync_wait dib7000p_state 0 39125 NULL nohasharray
+disable_so_enic_dev_add_station_addr_fndecl_39125 enic_dev_add_station_addr fndecl 0 39125 &disable_so_div_sync_wait_dib7000p_state_39125
+disable_so_regcache_rbtree_write_fndecl_39126 regcache_rbtree_write fndecl 2-3 39126 NULL
+disable_so_boot_addr_nvbios_pmuR_39136 boot_addr nvbios_pmuR 0 39136 NULL
+disable_so_slack_timer_list_39142 slack timer_list 0 39142 NULL
+disable_so_qat_alg_ablkcipher_decrypt_fndecl_39147 qat_alg_ablkcipher_decrypt fndecl 0 39147 NULL
+disable_so_security_task_fix_setuid_fndecl_39149 security_task_fix_setuid fndecl 0 39149 NULL
+disable_so_result_xfs_btree_split_args_39161 result xfs_btree_split_args 0 39161 NULL
+disable_so_max_medium_access_timeouts_show_fndecl_39174 max_medium_access_timeouts_show fndecl 0 39174 NULL
+disable_so_rx_rx_timeout_wa_read_fndecl_39183 rx_rx_timeout_wa_read fndecl 3 39183 NULL nohasharray
+disable_so_store_falltime_fndecl_39183 store_falltime fndecl 4-0 39183 &disable_so_rx_rx_timeout_wa_read_fndecl_39183
+disable_so_n_gma_clock_t_39192 n gma_clock_t 0 39192 NULL
+disable_so_phy_addr_wcn36xx_dxe_mem_pool_39193 phy_addr wcn36xx_dxe_mem_pool 0 39193 NULL
+disable_so_r6c_val_fc2580_freq_regs_39202 r6c_val fc2580_freq_regs 0 39202 NULL
+disable_so_adis16480_get_freq_fndecl_39205 adis16480_get_freq fndecl 0 39205 NULL
+disable_so_stv0367_get_tuner_freq_fndecl_39210 stv0367_get_tuner_freq fndecl 0 39210 NULL
+disable_so_loadtime_init_fndecl_39230 loadtime_init fndecl 0 39230 NULL
+disable_so_vcc_timeout_period_lec_priv_39232 vcc_timeout_period lec_priv 0 39232 NULL nohasharray
+disable_so_ciu_div_dw_mci_exynos_priv_data_39232 ciu_div dw_mci_exynos_priv_data 0 39232 &disable_so_vcc_timeout_period_lec_priv_39232
+disable_so_rxhubaddr_musb_csr_regs_39234 rxhubaddr musb_csr_regs 0 39234 NULL
+disable_so_igb_init_interrupt_scheme_fndecl_39237 igb_init_interrupt_scheme fndecl 0 39237 NULL
+disable_so_decrypt_mpdu_lib80211_crypto_ops_39245 decrypt_mpdu lib80211_crypto_ops 2 39245 NULL
+disable_so_enc_cd_paddr_qat_alg_ablkcipher_ctx_39246 enc_cd_paddr qat_alg_ablkcipher_ctx 0 39246 NULL
+disable_so_ax_tss_segment_16_39248 ax tss_segment_16 0 39248 NULL
+disable_so___crypto_memneq_fndecl_39251 __crypto_memneq fndecl 3 39251 NULL
+disable_so_core_freq_drm_psb_private_39252 core_freq drm_psb_private 0 39252 NULL
+disable_so_i_gid_minix_inode_39253 i_gid minix_inode 0 39253 NULL
+disable_so_sllc_arphrd_sockaddr_llc_39261 sllc_arphrd sockaddr_llc 0 39261 NULL
+disable_so_bind_virq_for_mce_fndecl_39266 bind_virq_for_mce fndecl 0 39266 NULL
+disable_so_poll_timeout_hwif_s_39267 poll_timeout hwif_s 0 39267 NULL
+disable_so_cik_set_uvd_clock_fndecl_39276 cik_set_uvd_clock fndecl 2-0 39276 NULL
+disable_so_watchdog_get_timeleft_fndecl_39280 watchdog_get_timeleft fndecl 0 39280 NULL
+disable_so_pti_addr_pti_dev_39288 pti_addr pti_dev 0 39288 NULL
+disable_so_last_guest_tsc_kvm_vcpu_arch_39290 last_guest_tsc kvm_vcpu_arch 0 39290 NULL
+disable_so_crypto_cts_encrypt_fndecl_39299 crypto_cts_encrypt fndecl 0-4 39299 NULL
+disable_so_set_timer_mode_fndecl_39306 set_timer_mode fndecl 1 39306 NULL
+disable_so_vref_delay_usecs_ads7846_39307 vref_delay_usecs ads7846 0 39307 NULL nohasharray
+disable_so_signal_rxdone_entry_desc_39307 signal rxdone_entry_desc 0 39307 &disable_so_vref_delay_usecs_ads7846_39307
+disable_so_kr_rcvhdrtailaddr_ipath_kregs_39311 kr_rcvhdrtailaddr ipath_kregs 0 39311 NULL
+disable_so_cyapa_pwr_cmd_to_sleep_time_fndecl_39315 cyapa_pwr_cmd_to_sleep_time fndecl 0-1 39315 NULL nohasharray
+disable_so_sleep_time_packet_data_39315 sleep_time packet_data 0 39315 &disable_so_cyapa_pwr_cmd_to_sleep_time_fndecl_39315 nohasharray
+disable_so_sdhci_runtime_pm_get_fndecl_39315 sdhci_runtime_pm_get fndecl 0 39315 &disable_so_sleep_time_packet_data_39315
+disable_so___request_region_fndecl_39330 __request_region fndecl 3-2-5 39330 NULL
+disable_so_hash_next_entry_39332 hash_next entry 0 39332 NULL
+disable_so_timeout_dmx_sct_filter_params_39333 timeout dmx_sct_filter_params 0 39333 NULL
+disable_so_dma_in_mceusb_dev_39335 dma_in mceusb_dev 0 39335 NULL
+disable_so_address_acpi_resource_fixed_io_39338 address acpi_resource_fixed_io 0 39338 NULL
+disable_so_adjusted_clock_radeon_crtc_39340 adjusted_clock radeon_crtc 0 39340 NULL
+disable_so_busaddr_drm_dma_handle_39348 busaddr drm_dma_handle 0 39348 NULL
+disable_so_gid_ok_fndecl_39349 gid_ok fndecl 3 39349 NULL
+disable_so_sched_clock_remote_fndecl_39352 sched_clock_remote fndecl 0 39352 NULL
+disable_so_i_ctime_extra_ext4_inode_39365 i_ctime_extra ext4_inode 0 39365 NULL
+disable_so_mISDN_inittimer_fndecl_39396 mISDN_inittimer fndecl 0 39396 NULL
+disable_so_status_addr_efx_vf_39401 status_addr efx_vf 0 39401 NULL nohasharray
+disable_so_freq_ieee80211_rx_status_39401 freq ieee80211_rx_status 0 39401 &disable_so_status_addr_efx_vf_39401
+disable_so_validate_acl_mac_addrs_fndecl_39406 validate_acl_mac_addrs fndecl 0 39406 NULL nohasharray
+disable_so_encrypt_mpdu_lib80211_crypto_ops_39406 encrypt_mpdu lib80211_crypto_ops 2 39406 &disable_so_validate_acl_mac_addrs_fndecl_39406
+disable_so_max_idle_ns_clocksource_39415 max_idle_ns clocksource 0 39415 NULL
+disable_so_sys_setreuid16_fndecl_39425 sys_setreuid16 fndecl 0-1-2 39425 NULL
+disable_so_typhoon_start_runtime_fndecl_39437 typhoon_start_runtime fndecl 0 39437 NULL nohasharray
+disable_so_frequency_dtv_frontend_properties_39437 frequency dtv_frontend_properties 0 39437 &disable_so_typhoon_start_runtime_fndecl_39437
+disable_so_addr_init_table_39442 addr init_table 0 39442 NULL
+disable_so_gru_end_paddr_vardecl_x2apic_uv_x_c_39443 gru_end_paddr vardecl_x2apic_uv_x.c 0 39443 NULL
+disable_so_irq_timeout_write_fndecl_39445 irq_timeout_write fndecl 3-0 39445 NULL
+disable_so_uwb_rc_mac_addr_set_fndecl_39450 uwb_rc_mac_addr_set fndecl 0 39450 NULL
+disable_so_ext4_es_find_delayed_extent_range_fndecl_39461 ext4_es_find_delayed_extent_range fndecl 2-3 39461 NULL
+disable_so_conn_timeout_hci_conn_39470 conn_timeout hci_conn 0 39470 NULL nohasharray
+disable_so_compat_sys_rt_sigtimedwait_fndecl_39470 compat_sys_rt_sigtimedwait fndecl 0 39470 &disable_so_conn_timeout_hci_conn_39470
+disable_so_snd_usb_pcm_delay_fndecl_39473 snd_usb_pcm_delay fndecl 0-2 39473 NULL nohasharray
+disable_so_freq_offset_khz_vhf_dib0070_config_39473 freq_offset_khz_vhf dib0070_config 0 39473 &disable_so_snd_usb_pcm_delay_fndecl_39473
+disable_so_sz_out_qat_crypto_request_buffs_39477 sz_out qat_crypto_request_buffs 0 39477 NULL
+disable_so_tx_abs_int_delay_e1000_adapter_39481 tx_abs_int_delay e1000_adapter 0 39481 NULL
+disable_so_nilfs_btree_node_delete_fndecl_39483 nilfs_btree_node_delete fndecl 2 39483 NULL
+disable_so_timeout_write_fndecl_39484 timeout_write fndecl 3-0 39484 NULL
+disable_so_ac97_clock_vardecl_intel8x0_c_39489 ac97_clock vardecl_intel8x0.c 0 39489 NULL
+disable_so_get_clock_info_fndecl_39492 get_clock_info fndecl 0 39492 NULL
+disable_so_buf_paddr_uioc_39504 buf_paddr uioc 0 39504 NULL
+disable_so_mpll_ss2_rv770_clock_registers_39508 mpll_ss2 rv770_clock_registers 0 39508 NULL
+disable_so_fc_exch_timer_set_fndecl_39511 fc_exch_timer_set fndecl 2 39511 NULL
+disable_so_stv0900_write_reg_fndecl_39517 stv0900_write_reg fndecl 2-3 39517 NULL
+disable_so_divf_ide_proc_devset_39528 divf ide_proc_devset 0 39528 NULL
+disable_so_wm_adsp_create_region_fndecl_39536 wm_adsp_create_region fndecl 2 39536 NULL
+disable_so_pl2303_encode_baud_rate_divisor_fndecl_39544 pl2303_encode_baud_rate_divisor fndecl 0-2 39544 NULL
+disable_so_mlx4_put_slave_node_guid_fndecl_39546 mlx4_put_slave_node_guid fndecl 3 39546 NULL
+disable_so_sgl_addr_lo_fw_flash_Update_req_39547 sgl_addr_lo fw_flash_Update_req 0 39547 NULL
+disable_so_m41t93_set_time_fndecl_39562 m41t93_set_time fndecl 0 39562 NULL
+disable_so_width_intel_sdvo_preferred_input_timing_args_39563 width intel_sdvo_preferred_input_timing_args 0 39563 NULL
+disable_so_RF_SYN_reserved_addr29_chan_info_nphy_radio205x_39569 RF_SYN_reserved_addr29 chan_info_nphy_radio205x 0 39569 NULL
+disable_so_delay_vardecl_wm9712_c_39574 delay vardecl_wm9712.c 0 39574 NULL
+disable_so_usb_sleep_charge_show_fndecl_39578 usb_sleep_charge_show fndecl 0 39578 NULL
+disable_so_cpu_to_virtio16_fndecl_39582 cpu_to_virtio16 fndecl 0-2 39582 NULL
+disable_so_e1000e_init_rx_addrs_fndecl_39608 e1000e_init_rx_addrs fndecl 2 39608 NULL
+disable_so_wss_random_offset_tpg_draw_params_39616 wss_random_offset tpg_draw_params 0 39616 NULL
+disable_so_ib_qib_sys_image_guid_vardecl_39617 ib_qib_sys_image_guid vardecl 0 39617 NULL
+disable_so_m_gma_clock_t_39618 m gma_clock_t 0 39618 NULL
+disable_so_nilfs_btree_node_move_right_fndecl_39627 nilfs_btree_node_move_right fndecl 3 39627 NULL
+disable_so_max14577_muic_set_debounce_time_fndecl_39632 max14577_muic_set_debounce_time fndecl 2-0 39632 NULL nohasharray
+disable_so_shash_compat_final_fndecl_39632 shash_compat_final fndecl 0 39632 &disable_so_max14577_muic_set_debounce_time_fndecl_39632
+disable_so_tx_coal_timer_sxgbe_tx_queue_39639 tx_coal_timer sxgbe_tx_queue 0 39639 NULL
+disable_so_antsignal_rx_radiotap_hdr_39653 antsignal rx_radiotap_hdr 0 39653 NULL
+disable_so_vaddr_gru_dump_context_header_39663 vaddr gru_dump_context_header 0 39663 NULL
+disable_so_cap_task_setscheduler_fndecl_39664 cap_task_setscheduler fndecl 0 39664 NULL
+disable_so_bt_inq_page_start_time_bt_coexist_8723_39665 bt_inq_page_start_time bt_coexist_8723 0 39665 NULL
+disable_so_last_beacon_signal_ieee80211_if_managed_39670 last_beacon_signal ieee80211_if_managed 0 39670 NULL
+disable_so_ni_ipv4_address_dlm_node_info_39675 ni_ipv4_address dlm_node_info 0 39675 NULL
+disable_so_i_gid_minix2_inode_39680 i_gid minix2_inode 0 39680 NULL
+disable_so_mx51_ecspi_clkdiv_fndecl_39681 mx51_ecspi_clkdiv fndecl 1-2-0 39681 NULL
+disable_so_mld_dad_start_timer_fndecl_39685 mld_dad_start_timer fndecl 2 39685 NULL
+disable_so_fm10k_read_systime_vf_fndecl_39687 fm10k_read_systime_vf fndecl 0 39687 NULL
+disable_so_cp_hqd_pq_wptr_poll_addr_hi_hqd_registers_39692 cp_hqd_pq_wptr_poll_addr_hi hqd_registers 0 39692 NULL
+disable_so_i2c_smbus_read_byte_data_fndecl_39698 i2c_smbus_read_byte_data fndecl 0-2 39698 NULL
+disable_so_abort_mfi_phys_addr_lo_megasas_abort_frame_39699 abort_mfi_phys_addr_lo megasas_abort_frame 0 39699 NULL
+disable_so_sclk_radeon_pm_clock_info_39706 sclk radeon_pm_clock_info 0 39706 NULL
+disable_so_dma_addr_pch_udc_dev_39708 dma_addr pch_udc_dev 0 39708 NULL
+disable_so_word_write_time_flchip_39711 word_write_time flchip 0 39711 NULL nohasharray
+disable_so_acpi_dev_runtime_suspend_fndecl_39711 acpi_dev_runtime_suspend fndecl 0 39711 &disable_so_word_write_time_flchip_39711
+disable_so_poll_time_us_sccnxp_pdata_39712 poll_time_us sccnxp_pdata 0 39712 NULL
+disable_so_div2_wm8978_pll_div_39713 div2 wm8978_pll_div 0 39713 NULL nohasharray
+disable_so_ssb_chipco_alp_clock_fndecl_39713 ssb_chipco_alp_clock fndecl 0 39713 &disable_so_div2_wm8978_pll_div_39713
+disable_so_chan_get_sndtimeo_cb_fndecl_39717 chan_get_sndtimeo_cb fndecl 0 39717 NULL nohasharray
+disable_so_sys_image_guid_vardecl_ipath_verbs_c_39717 sys_image_guid vardecl_ipath_verbs.c 0 39717 &disable_so_chan_get_sndtimeo_cb_fndecl_39717 nohasharray
+disable_so_address_start_unity_map_entry_39717 address_start unity_map_entry 0 39717 &disable_so_sys_image_guid_vardecl_ipath_verbs_c_39717
+disable_so___ew32_fndecl_39722 __ew32 fndecl 2-3 39722 NULL
+disable_so_schedule_sequence_fndecl_39726 schedule_sequence fndecl 3 39726 NULL
+disable_so_bitmap_cond_end_sync_fndecl_39734 bitmap_cond_end_sync fndecl 2 39734 NULL
+disable_so_mc13xxx_rtc_read_time_fndecl_39742 mc13xxx_rtc_read_time fndecl 0 39742 NULL
+disable_so_time_out_ncp_mount_data_kernel_39747 time_out ncp_mount_data_kernel 0 39747 NULL
+disable_so_address_khugepaged_scan_39752 address khugepaged_scan 0 39752 NULL
+disable_so_ab3100_set_register_interruptible_fndecl_39767 ab3100_set_register_interruptible fndecl 0 39767 NULL
+disable_so_ixgbe_write_uc_addr_list_fndecl_39773 ixgbe_write_uc_addr_list fndecl 2 39773 NULL
+disable_so_i2c_udelay_vardecl_cx88_i2c_c_39777 i2c_udelay vardecl_cx88-i2c.c 0 39777 NULL
+disable_so_pm_test_delay_vardecl_suspend_c_39779 pm_test_delay vardecl_suspend.c 0 39779 NULL
+disable_so___mt7601u_phy_freq_cal_fndecl_39782 __mt7601u_phy_freq_cal fndecl 3 39782 NULL
+disable_so_s2mpa01_regulator_set_voltage_time_sel_fndecl_39788 s2mpa01_regulator_set_voltage_time_sel fndecl 0-2-3 39788 NULL
+disable_so_mlx4_get_admin_guid_fndecl_39797 mlx4_get_admin_guid fndecl 2-3 39797 NULL
+disable_so_enic_dev_intr_coal_timer_info_fndecl_39803 enic_dev_intr_coal_timer_info fndecl 0 39803 NULL
+disable_so_freq_can_clock_39804 freq can_clock 0 39804 NULL
+disable_so_ktime_set_fndecl_39816 ktime_set fndecl 1-2 39816 NULL
+disable_so_bitmap_set_fndecl_39820 bitmap_set fndecl 2-3 39820 NULL
+disable_so_ttm_bo_delayed_delete_fndecl_39822 ttm_bo_delayed_delete fndecl 0 39822 NULL nohasharray
+disable_so_ath_force_clear_no_ir_freq_fndecl_39822 ath_force_clear_no_ir_freq fndecl 2 39822 &disable_so_ttm_bo_delayed_delete_fndecl_39822
+disable_so_ipw_set_random_seed_fndecl_39834 ipw_set_random_seed fndecl 0 39834 NULL
+disable_so_tpm2_gen_interrupt_fndecl_39854 tpm2_gen_interrupt fndecl 0 39854 NULL
+disable_so_addr_sch5627_data_39866 addr sch5627_data 0 39866 NULL
+disable_so_governor_cpufreq_governor_39867 governor cpufreq_governor 0 39867 NULL
+disable_so_jhash_3words_fndecl_39870 jhash_3words fndecl 0-1-3 39870 NULL
+disable_so_lvb_iatime_packed_ocfs2_meta_lvb_39885 lvb_iatime_packed ocfs2_meta_lvb 0 39885 NULL
+disable_so_delay_zl6100_data_39886 delay zl6100_data 0 39886 NULL
+disable_so_nla_put_string_fndecl_39892 nla_put_string fndecl 0 39892 NULL
+disable_so_ctime_mddev_39904 ctime mddev 0 39904 NULL
+disable_so_set_output_clock_fndecl_39910 set_output_clock fndecl 0 39910 NULL
+disable_so_clear_bit_le_fndecl_39918 clear_bit_le fndecl 1 39918 NULL
+disable_so_target_burst_mode_freq_mipi_config_39926 target_burst_mode_freq mipi_config 0 39926 NULL
+disable_so_host_addr_gnttab_map_grant_ref_39935 host_addr gnttab_map_grant_ref 0 39935 NULL
+disable_so_esd_timeout_tsc2005_39938 esd_timeout tsc2005 0 39938 NULL
+disable_so_nr_parts_latch_addr_flash_data_39945 nr_parts latch_addr_flash_data 0 39945 NULL
+disable_so_efx_test_interrupts_fndecl_39946 efx_test_interrupts fndecl 0 39946 NULL
+disable_so_ds1685_rtc_read_time_fndecl_39947 ds1685_rtc_read_time fndecl 0 39947 NULL nohasharray
+disable_so_ctxbitmap_gru_tlb_global_handle_39947 ctxbitmap gru_tlb_global_handle 0 39947 &disable_so_ds1685_rtc_read_time_fndecl_39947
+disable_so_si_program_memory_timing_parameters_fndecl_39954 si_program_memory_timing_parameters fndecl 0 39954 NULL
+disable_so___mce_read_apei_fndecl_39956 __mce_read_apei fndecl 0 39956 NULL
+disable_so_xtime_nsec_tk_read_base_39961 xtime_nsec tk_read_base 0 39961 NULL
+disable_so_plldiv_clk_coeff_39962 plldiv clk_coeff 0 39962 NULL
+disable_so_iscsi_nacl_attrib_show_random_r2t_offsets_fndecl_39965 iscsi_nacl_attrib_show_random_r2t_offsets fndecl 0 39965 NULL
+disable_so_crtc_clock_drm_display_mode_39969 crtc_clock drm_display_mode 0 39969 NULL
+disable_so_qat_alg_ablkcipher_encrypt_fndecl_40005 qat_alg_ablkcipher_encrypt fndecl 0 40005 NULL
+disable_so_dib7000p_write_word_fndecl_40007 dib7000p_write_word fndecl 2-3 40007 NULL
+disable_so_crypto_register_shash_fndecl_40011 crypto_register_shash fndecl 0 40011 NULL
+disable_so_acpi_os_signal_semaphore_fndecl_40013 acpi_os_signal_semaphore fndecl 0 40013 NULL
+disable_so_w1_delay_fndecl_40014 w1_delay fndecl 1 40014 NULL
+disable_so_tda10071_sleep_fndecl_40017 tda10071_sleep fndecl 0 40017 NULL
+disable_so_blkcipher_walk_phys_fndecl_40019 blkcipher_walk_phys fndecl 0 40019 NULL
+disable_so_aes_cmac_fndecl_40025 aes_cmac fndecl 0-4 40025 NULL
+disable_so_dwell_time_passive_conf_scan_settings_40029 dwell_time_passive conf_scan_settings 0 40029 NULL nohasharray
+disable_so_freq_wmi_channel_arg_40029 freq wmi_channel_arg 0 40029 &disable_so_dwell_time_passive_conf_scan_settings_40029
+disable_so_ip_tss_segment_16_40046 ip tss_segment_16 0 40046 NULL
+disable_so_recent_entry_hash6_fndecl_40053 recent_entry_hash6 fndecl 0 40053 NULL
+disable_so_pci_addr_mm_dma_desc_40056 pci_addr mm_dma_desc 0 40056 NULL
+disable_so_mwifiex_get_random_ba_threshold_fndecl_40074 mwifiex_get_random_ba_threshold fndecl 0 40074 NULL nohasharray
+disable_so_ccp_aes_xts_decrypt_fndecl_40074 ccp_aes_xts_decrypt fndecl 0 40074 &disable_so_mwifiex_get_random_ba_threshold_fndecl_40074
+disable_so_nilfs_btree_delete_fndecl_40077 nilfs_btree_delete fndecl 0-2 40077 NULL
+disable_so_db_page_addr_ocrdma_create_qp_uresp_40086 db_page_addr ocrdma_create_qp_uresp 0 40086 NULL
+disable_so_bitmap_empty_fndecl_40098 bitmap_empty fndecl 2 40098 NULL
+disable_so_crypto_aes_expand_key_fndecl_40101 crypto_aes_expand_key fndecl 0-3 40101 NULL
+disable_so_sclk_radeon_clock_and_voltage_limits_40103 sclk radeon_clock_and_voltage_limits 0 40103 NULL
+disable_so_daddr_irda_sock_40107 daddr irda_sock 0 40107 NULL
+disable_so_efx_phc_settime_fndecl_40110 efx_phc_settime fndecl 0 40110 NULL nohasharray
+disable_so_w1_gpio_write_bit_val_fndecl_40110 w1_gpio_write_bit_val fndecl 2 40110 &disable_so_efx_phc_settime_fndecl_40110
+disable_so_memsize_bitmap_port_40111 memsize bitmap_port 0 40111 NULL
+disable_so_freq_channel_detector_40125 freq channel_detector 0 40125 NULL
+disable_so_bitmap_port_do_list_fndecl_40145 bitmap_port_do_list fndecl 0 40145 NULL
+disable_so_mcs7830_hif_set_mac_address_fndecl_40149 mcs7830_hif_set_mac_address fndecl 0 40149 NULL
+disable_so_musb_write_rxfunaddr_fndecl_40150 musb_write_rxfunaddr fndecl 2-3 40150 NULL
+disable_so_ioaddr_set_address_info_40154 ioaddr set_address_info 0 40154 NULL nohasharray
+disable_so_mmap_kvaddr_fndecl_40154 mmap_kvaddr fndecl 0-2-4 40154 &disable_so_ioaddr_set_address_info_40154
+disable_so_hr_timeout_ms_o2hb_region_40157 hr_timeout_ms o2hb_region 0 40157 NULL
+disable_so_startbit_ebitmap_node_40162 startbit ebitmap_node 0 40162 NULL
+disable_so_phys_addr_sfi_apic_table_entry_40169 phys_addr sfi_apic_table_entry 0 40169 NULL
+disable_so_hw_settle_time_vadc_channel_prop_40184 hw_settle_time vadc_channel_prop 0 40184 NULL
+disable_so_pio_address_scsi_qla_host_40189 pio_address scsi_qla_host 0 40189 NULL
+disable_so_iffreq_dvb_pll_desc_40199 iffreq dvb_pll_desc 0 40199 NULL nohasharray
+disable_so_cobalt_g_dv_timings_fndecl_40199 cobalt_g_dv_timings fndecl 0 40199 &disable_so_iffreq_dvb_pll_desc_40199
+disable_so_to_addr_conv_fndecl_40204 to_addr_conv fndecl 3 40204 NULL
+disable_so_fm10k_update_uc_addr_vf_fndecl_40219 fm10k_update_uc_addr_vf fndecl 4 40219 NULL
+disable_so_empress_addr_saa7134_board_40236 empress_addr saa7134_board 0 40236 NULL
+disable_so_lm3533_led_delay_on_set_fndecl_40245 lm3533_led_delay_on_set fndecl 0 40245 NULL
+disable_so_cryptd_hash_digest_fndecl_40277 cryptd_hash_digest fndecl 2 40277 NULL
+disable_so_p2m_timeouts_show_fndecl_40284 p2m_timeouts_show fndecl 0 40284 NULL
+disable_so_decrypt_blkcipher_tfm_40300 decrypt blkcipher_tfm 0-4 40300 NULL
+disable_so_freq_radio_tea5777_40301 freq radio_tea5777 0 40301 NULL
+disable_so_height_v4l2_bt_timings_40304 height v4l2_bt_timings 0 40304 NULL
+disable_so_set_channels_control_runtime_40305 set_channels control_runtime 0 40305 NULL
+disable_so_mpll_ss1_si_clock_registers_40320 mpll_ss1 si_clock_registers 0 40320 NULL
+disable_so_address_drm_radeon_surface_free_40326 address drm_radeon_surface_free 0 40326 NULL
+disable_so_scopedist_ipv6_saddr_score_40339 scopedist ipv6_saddr_score 0 40339 NULL
+disable_so_eeprom_addr_pvr2_hdw_40343 eeprom_addr pvr2_hdw 0 40343 NULL
+disable_so_phys_addr_low_qlcnic_tx_mbx_40351 phys_addr_low qlcnic_tx_mbx 0 40351 NULL
+disable_so_i_ctime_nsec_nilfs_inode_40368 i_ctime_nsec nilfs_inode 0 40368 NULL
+disable_so_crypto_set_driver_name_fndecl_40369 crypto_set_driver_name fndecl 0 40369 NULL
+disable_so_gid_args_requester_40377 gid args_requester 0 40377 NULL
+disable_so_ds1343_set_time_fndecl_40381 ds1343_set_time fndecl 0 40381 NULL nohasharray
+disable_so_p2_mt9t112_pll_divider_40381 p2 mt9t112_pll_divider 0 40381 &disable_so_ds1343_set_time_fndecl_40381
+disable_so_get_phys_to_machine_fndecl_40384 get_phys_to_machine fndecl 0-1 40384 NULL
+disable_so_irlmp_start_watchdog_timer_fndecl_40386 irlmp_start_watchdog_timer fndecl 2 40386 NULL
+disable_so_it_id_k_itimer_40394 it_id k_itimer 0 40394 NULL
+disable_so_proc_gid_vardecl_airo_c_40395 proc_gid vardecl_airo.c 0 40395 NULL
+disable_so_vf_addr_lo_bnx2x_vf_mbx_40423 vf_addr_lo bnx2x_vf_mbx 0 40423 NULL
+disable_so_hsw_get_aux_clock_divider_fndecl_40428 hsw_get_aux_clock_divider fndecl 0 40428 NULL
+disable_so_uid_coda_in_hdr_40430 uid coda_in_hdr 0 40430 NULL
+disable_so_il4965_sta_modify_sleep_tx_count_fndecl_40431 il4965_sta_modify_sleep_tx_count fndecl 2 40431 NULL
+disable_so_op_nmi_timer_init_fndecl_40444 op_nmi_timer_init fndecl 0 40444 NULL
+disable_so_reply_dma_min_address_MPT3SAS_ADAPTER_40450 reply_dma_min_address MPT3SAS_ADAPTER 0 40450 NULL
+disable_so_clock_elmer0_board_info_40451 clock_elmer0 board_info 0 40451 NULL
+disable_so_drift_time_trackpoint_data_40460 drift_time trackpoint_data 0 40460 NULL
+disable_so_tpm_get_random_fndecl_40461 tpm_get_random fndecl 0-3 40461 NULL
+disable_so_HDisplay_xtimings_40462 HDisplay xtimings 0 40462 NULL
+disable_so_addr_desc_frag_40463 addr desc_frag 0 40463 NULL
+disable_so___scrub_mark_bitmap_fndecl_40465 __scrub_mark_bitmap fndecl 3-4 40465 NULL
+disable_so_da9063_wdt_timeout_to_sel_fndecl_40469 da9063_wdt_timeout_to_sel fndecl 0-1 40469 NULL
+disable_so_hactive___fb_timings_40471 hactive __fb_timings 0 40471 NULL
+disable_so_next_blkaddr_of_node_fndecl_40477 next_blkaddr_of_node fndecl 0 40477 NULL
+disable_so_gk20a_timer_init_fndecl_40478 gk20a_timer_init fndecl 0 40478 NULL
+disable_so_saa7164_i2caddr_to_unitid_fndecl_40486 saa7164_i2caddr_to_unitid fndecl 2 40486 NULL
+disable_so___hw_addr_unsync_one_fndecl_40488 __hw_addr_unsync_one fndecl 4 40488 NULL
+disable_so_uncore_msr_box_offset_fndecl_40489 uncore_msr_box_offset fndecl 0 40489 NULL
+disable_so_kgdbdbgp_wait_time_vardecl_ehci_dbgp_c_40510 kgdbdbgp_wait_time vardecl_ehci-dbgp.c 0 40510 NULL
+disable_so_sys_time_fndecl_40516 sys_time fndecl 0 40516 NULL
+disable_so_addrconf_sysctl_proxy_ndp_fndecl_40521 addrconf_sysctl_proxy_ndp fndecl 0 40521 NULL
+disable_so_jiffies_64_vardecl_40530 jiffies_64 vardecl 0 40530 NULL
+disable_so_time_fcoe_rport_40540 time fcoe_rport 0 40540 NULL nohasharray
+disable_so_i_time_fuse_inode_40540 i_time fuse_inode 0 40540 &disable_so_time_fcoe_rport_40540
+disable_so_fllclk_div__fll_div_40542 fllclk_div _fll_div 0 40542 NULL
+disable_so_mmc_sleep_fndecl_40550 mmc_sleep fndecl 0 40550 NULL
+disable_so_swap_activate_address_space_operations_40556 swap_activate address_space_operations 0 40556 NULL
+disable_so_snd_timer_reschedule_fndecl_40558 snd_timer_reschedule fndecl 2 40558 NULL
+disable_so_register_inetaddr_notifier_fndecl_40563 register_inetaddr_notifier fndecl 0 40563 NULL nohasharray
+disable_so_shash_async_export_fndecl_40563 shash_async_export fndecl 0 40563 &disable_so_register_inetaddr_notifier_fndecl_40563
+disable_so_tx_duty_cycle_ene_device_40568 tx_duty_cycle ene_device 0 40568 NULL
+disable_so_delay_cfg80211_sched_scan_request_40582 delay cfg80211_sched_scan_request 0 40582 NULL
+disable_so_sctp_copy_local_addr_list_fndecl_40597 sctp_copy_local_addr_list fndecl 0-4 40597 NULL
+disable_so_can_clock_plx_pci_card_info_40599 can_clock plx_pci_card_info 0 40599 NULL
+disable_so_last_semaphore_signal_addr_amdgpu_ring_40601 last_semaphore_signal_addr amdgpu_ring 0 40601 NULL
+disable_so_slave_addr_radeon_encoder_ext_tmds_40618 slave_addr radeon_encoder_ext_tmds 0 40618 NULL
+disable_so_lrg_buf_q_phy_addr_ql3_adapter_40620 lrg_buf_q_phy_addr ql3_adapter 0 40620 NULL
+disable_so_slave_addr_sdvo_device_mapping_40627 slave_addr sdvo_device_mapping 0 40627 NULL
+disable_so_raddr_fw_ldst_mdio_40629 raddr fw_ldst_mdio 0 40629 NULL
+disable_so_soc_dpcm_runtime_update_fndecl_40639 soc_dpcm_runtime_update fndecl 0 40639 NULL
+disable_so_md_timestamp_netxen_minidump_40640 md_timestamp netxen_minidump 0 40640 NULL
+disable_so_freq_magnitude_fndecl_40641 freq_magnitude fndecl 0-2-3 40641 NULL
+disable_so_asd_write_reg_addr_fndecl_40648 asd_write_reg_addr fndecl 2-3 40648 NULL
+disable_so_ndiv_frac_pmu1_plltab_entry_40664 ndiv_frac pmu1_plltab_entry 0 40664 NULL
+disable_so___percpu_counter_add_fndecl_40667 __percpu_counter_add fndecl 2 40667 NULL
+disable_so_r600_set_mpll_lock_time_fndecl_40677 r600_set_mpll_lock_time fndecl 2 40677 NULL
+disable_so_m_daddr_rds_message_40687 m_daddr rds_message 0 40687 NULL
+disable_so_tbl_addr_hi_ahci_cmd_hdr_40697 tbl_addr_hi ahci_cmd_hdr 0 40697 NULL
+disable_so___cfq_update_io_thinktime_fndecl_40698 __cfq_update_io_thinktime fndecl 2 40698 NULL
+disable_so_sense_addr_snic_icmnd_40701 sense_addr snic_icmnd 0 40701 NULL
+disable_so_addr_mlx5e_sq_dma_40707 addr mlx5e_sq_dma 0 40707 NULL
+disable_so_lp872x_is_valid_buck_addr_fndecl_40709 lp872x_is_valid_buck_addr fndecl 1 40709 NULL
+disable_so_dma_addr_respQ_40711 dma_addr respQ 0 40711 NULL
+disable_so_mclkdiv_cs4265_clk_para_40714 mclkdiv cs4265_clk_para 0 40714 NULL
+disable_so_sh_tmu_clocksource_read_fndecl_40723 sh_tmu_clocksource_read fndecl 0 40723 NULL nohasharray
+disable_so_mthca_cmd_poll_fndecl_40723 mthca_cmd_poll fndecl 0-2 40723 &disable_so_sh_tmu_clocksource_read_fndecl_40723
+disable_so_radio_si4713_s_frequency_fndecl_40725 radio_si4713_s_frequency fndecl 0 40725 NULL
+disable_so_onecputick_vardecl_posix_cpu_timers_c_40726 onecputick vardecl_posix-cpu-timers.c 0 40726 NULL
+disable_so_v_freq_adv7842_video_standards_40728 v_freq adv7842_video_standards 0 40728 NULL
+disable_so___ip6addrlbl_del_fndecl_40742 __ip6addrlbl_del fndecl 0-4 40742 NULL
+disable_so_encrypt_msdu_lib80211_crypto_ops_40743 encrypt_msdu lib80211_crypto_ops 2 40743 NULL
+disable_so_rolloff_stv0900_signal_info_40745 rolloff stv0900_signal_info 0 40745 NULL
+disable_so_pci_finish_runtime_suspend_fndecl_40755 pci_finish_runtime_suspend fndecl 0 40755 NULL
+disable_so_tcp_sacktag_walk_fndecl_40756 tcp_sacktag_walk fndecl 6-5 40756 NULL
+disable_so_vnic_dev_add_addr_fndecl_40765 vnic_dev_add_addr fndecl 0 40765 NULL
+disable_so_zd_usb_iowrite16v_fndecl_40771 zd_usb_iowrite16v fndecl 3-0 40771 NULL nohasharray
+disable_so_frequency_mb86a16_state_40771 frequency mb86a16_state 0 40771 &disable_so_zd_usb_iowrite16v_fndecl_40771
+disable_so_clk_ref_div_fll_div_40776 clk_ref_div fll_div 0 40776 NULL
+disable_so_lifetime_write_kbytes_show_fndecl_40777 lifetime_write_kbytes_show fndecl 0 40777 NULL nohasharray
+disable_so_smp_send_reschedule_fndecl_40777 smp_send_reschedule fndecl 1 40777 &disable_so_lifetime_write_kbytes_show_fndecl_40777
+disable_so_crypto_ccm_auth_fndecl_40795 crypto_ccm_auth fndecl 0-3 40795 NULL
+disable_so_get_option_uid_fndecl_40799 get_option_uid fndecl 0 40799 NULL
+disable_so_be_mac_addr_set_fndecl_40804 be_mac_addr_set fndecl 0 40804 NULL
+disable_so_frac_timecounter_40806 frac timecounter 0 40806 NULL
+disable_so_pid_pppol2tpin6_addr_40809 pid pppol2tpin6_addr 0 40809 NULL
+disable_so_i40e_vc_del_mac_addr_msg_fndecl_40824 i40e_vc_del_mac_addr_msg fndecl 0-3 40824 NULL nohasharray
+disable_so_uncore_msr_box_ctl_fndecl_40824 uncore_msr_box_ctl fndecl 0 40824 &disable_so_i40e_vc_del_mac_addr_msg_fndecl_40824
+disable_so_ahd_delay_fndecl_40826 ahd_delay fndecl 1 40826 NULL
+disable_so_read_addr___queue_40832 read_addr __queue 0 40832 NULL
+disable_so_ring_iowrite32desc_fndecl_40836 ring_iowrite32desc fndecl 2 40836 NULL
+disable_so_mma8452_get_samp_freq_index_fndecl_40841 mma8452_get_samp_freq_index fndecl 0-2-3 40841 NULL
+disable_so_nouveau_bo_wr32_fndecl_40847 nouveau_bo_wr32 fndecl 2-3 40847 NULL
+disable_so_drm_object_attach_property_fndecl_40853 drm_object_attach_property fndecl 3 40853 NULL
+disable_so_sched_rr_timeslice_vardecl_40858 sched_rr_timeslice vardecl 0 40858 NULL
+disable_so_hash_recvmsg_fndecl_40871 hash_recvmsg fndecl 0-3 40871 NULL
+disable_so_timeradd_entry_fndecl_40873 timeradd_entry fndecl 0-3 40873 NULL
+disable_so_pages_per_bnode_hfs_btree_40875 pages_per_bnode hfs_btree 0 40875 NULL
+disable_so_ubifs_destroy_tnc_subtree_fndecl_40878 ubifs_destroy_tnc_subtree fndecl 0 40878 NULL
+disable_so_add_uuid_fndecl_40884 add_uuid fndecl 4 40884 NULL nohasharray
+disable_so_make_checksum_hmac_md5_fndecl_40884 make_checksum_hmac_md5 fndecl 3-5 40884 &disable_so_add_uuid_fndecl_40884
+disable_so_sync_bmp_nbits_regcache_lzo_ctx_40890 sync_bmp_nbits regcache_lzo_ctx 0 40890 NULL
+disable_so_crypto_fpu_decrypt_fndecl_40907 crypto_fpu_decrypt fndecl 0-4 40907 NULL
+disable_so_qce_ahash_final_fndecl_40916 qce_ahash_final fndecl 0 40916 NULL
+disable_so_auto_stop_time_uhci_hcd_40917 auto_stop_time uhci_hcd 0 40917 NULL
+disable_so_sys_rt_sigtimedwait_fndecl_40920 sys_rt_sigtimedwait fndecl 0 40920 NULL
+disable_so_dec_cd_paddr_qat_alg_ablkcipher_ctx_40923 dec_cd_paddr qat_alg_ablkcipher_ctx 0 40923 NULL nohasharray
+disable_so_i2cdev_check_addr_fndecl_40923 i2cdev_check_addr fndecl 2 40923 &disable_so_dec_cd_paddr_qat_alg_ablkcipher_ctx_40923
+disable_so_inode_bitmap_ext3_new_group_data_40928 inode_bitmap ext3_new_group_data 0 40928 NULL
+disable_so_inet_select_addr_fndecl_40940 inet_select_addr fndecl 0-2-3 40940 NULL nohasharray
+disable_so_curfreq_keene_device_40940 curfreq keene_device 0 40940 &disable_so_inet_select_addr_fndecl_40940
+disable_so_w83627ehf_write_fan_div_common_fndecl_40945 w83627ehf_write_fan_div_common fndecl 3 40945 NULL
+disable_so_req_addr_efx_vf_40947 req_addr efx_vf 0 40947 NULL
+disable_so_get_crandom_fndecl_40951 get_crandom fndecl 0 40951 NULL
+disable_so_authenc_esn_geniv_ahash_update_done2_fndecl_40965 authenc_esn_geniv_ahash_update_done2 fndecl 2 40965 NULL
+disable_so_bt3c_address_fndecl_40975 bt3c_address fndecl 1 40975 NULL
+disable_so_tx_bidx_addr_bnx2_tx_ring_info_40977 tx_bidx_addr bnx2_tx_ring_info 0 40977 NULL
+disable_so_cs5520_set_timings_fndecl_40978 cs5520_set_timings fndecl 3 40978 NULL
+disable_so_addrLow_ULP_BDL_40980 addrLow ULP_BDL 0 40980 NULL
+disable_so_last_wakeup_time_rtl_ps_ctl_40987 last_wakeup_time rtl_ps_ctl 0 40987 NULL
+disable_so_kstrtos8_fndecl_40989 kstrtos8 fndecl 0 40989 NULL nohasharray
+disable_so_drbg_hash_generate_fndecl_40989 drbg_hash_generate fndecl 0-3 40989 &disable_so_kstrtos8_fndecl_40989
+disable_so_vaddr_get_pfn_fndecl_40993 vaddr_get_pfn fndecl 0-1 40993 NULL
+disable_so_s_def_resgid_ext3_super_block_40996 s_def_resgid ext3_super_block 0 40996 NULL
+disable_so_sr_nongc_ctime_nilfs_super_root_40997 sr_nongc_ctime nilfs_super_root 0 40997 NULL
+disable_so_rsp_producer_index_phy_addr_high_ql3_adapter_40998 rsp_producer_index_phy_addr_high ql3_adapter 0 40998 NULL
+disable_so_per_jiffies_stats_dib8000_state_40999 per_jiffies_stats dib8000_state 0 40999 NULL
+disable_so_cobalt_dv_timings_cap_fndecl_41001 cobalt_dv_timings_cap fndecl 0 41001 NULL
+disable_so_encrypt_blkcipher_tfm_41013 encrypt blkcipher_tfm 0-4 41013 NULL
+disable_so_max_dwell_time_active_conf_scan_settings_41024 max_dwell_time_active conf_scan_settings 0 41024 NULL
+disable_so_gpu_addr_radeon_fence_driver_41046 gpu_addr radeon_fence_driver 0 41046 NULL
+disable_so_read_cache_jiffies_nfs_inode_41071 read_cache_jiffies nfs_inode 0 41071 NULL
+disable_so_curfreq_ma901radio_device_41079 curfreq ma901radio_device 0 41079 NULL
+disable_so_show_constraint_max_time_window_us_fndecl_41080 show_constraint_max_time_window_us fndecl 0 41080 NULL
+disable_so_acpi_tables_addr_vardecl_osl_c_41081 acpi_tables_addr vardecl_osl.c 0 41081 NULL
+disable_so_gdth_delay_fndecl_41096 gdth_delay fndecl 1 41096 NULL
+disable_so_wq_calc_node_cpumask_fndecl_41102 wq_calc_node_cpumask fndecl 2 41102 NULL
+disable_so_qp_bitmap_free_ntb_transport_ctx_41105 qp_bitmap_free ntb_transport_ctx 0 41105 NULL
+disable_so_show_admin_alias_guid_fndecl_41106 show_admin_alias_guid fndecl 0 41106 NULL
+disable_so_freq_vardecl_mxb_c_41108 freq vardecl_mxb.c 0 41108 NULL
+disable_so_vx_set_internal_clock_fndecl_41114 vx_set_internal_clock fndecl 2 41114 NULL
+disable_so_jiffies_at_alloc_qla_tgt_cmd_41119 jiffies_at_alloc qla_tgt_cmd 0 41119 NULL
+disable_so_timestamp_ath9k_htc_tx_ctl_41124 timestamp ath9k_htc_tx_ctl 0 41124 NULL
+disable_so_ib_baseaddr_h_mvumi_hs_page4_41130 ib_baseaddr_h mvumi_hs_page4 0 41130 NULL
+disable_so_cherryview_rps_guar_freq_fndecl_41132 cherryview_rps_guar_freq fndecl 0 41132 NULL
+disable_so_time_survey_info_41134 time survey_info 0 41134 NULL
+disable_so_child_tgid_fork_proc_event_41148 child_tgid fork_proc_event 0 41148 NULL
+disable_so_companion_addr_pm860x_platform_data_41156 companion_addr pm860x_platform_data 0 41156 NULL
+disable_so_lgdt330x_read_signal_strength_fndecl_41159 lgdt330x_read_signal_strength fndecl 0 41159 NULL
+disable_so_genwqe_curr_dbg_uid1_show_fndecl_41164 genwqe_curr_dbg_uid1_show fndecl 0 41164 NULL
+disable_so_addr_nct6775_data_41165 addr nct6775_data 0 41165 NULL
+disable_so_assoc_id_sctp_getaddrs_41169 assoc_id sctp_getaddrs 0 41169 NULL
+disable_so_set_addr_fndecl_41173 set_addr fndecl 2 41173 NULL
+disable_so_fairness_timeout_fairness_vars_per_port_41174 fairness_timeout fairness_vars_per_port 0 41174 NULL
+disable_so_acpi_os_install_interrupt_handler_fndecl_41179 acpi_os_install_interrupt_handler fndecl 1 41179 NULL
+disable_so_ref_freq_vardecl_tsc_c_41183 ref_freq vardecl_tsc.c 0 41183 NULL
+disable_so_latest_ip_addr_eg_cache_entry_41198 latest_ip_addr eg_cache_entry 0 41198 NULL
+disable_so_long_timeout_osst_tape_41205 long_timeout osst_tape 0 41205 NULL
+disable_so_dma_addr_mcam_dma_desc_41206 dma_addr mcam_dma_desc 0 41206 NULL
+disable_so_address_lower_scu_sgl_element_41221 address_lower scu_sgl_element 0 41221 NULL
+disable_so_paravirt_read_tsc_fndecl_41239 paravirt_read_tsc fndecl 0 41239 NULL
+disable_so_posix_clock_realtime_set_fndecl_41245 posix_clock_realtime_set fndecl 0 41245 NULL
+disable_so_phys_addr_netxen_dummy_dma_41248 phys_addr netxen_dummy_dma 0 41248 NULL
+disable_so_addr_port_fndecl_41249 addr_port fndecl 0 41249 NULL nohasharray
+disable_so_ip_vs_svc_hashkey_fndecl_41249 ip_vs_svc_hashkey fndecl 2-3 41249 &disable_so_addr_port_fndecl_41249
+disable_so_kstrtoul_from_user_fndecl_41258 kstrtoul_from_user fndecl 0-2 41258 NULL
+disable_so_xfrm_state_lookup_byaddr_fndecl_41260 xfrm_state_lookup_byaddr fndecl 2-5-6 41260 NULL
+disable_so_ns_sbwtime_the_nilfs_41268 ns_sbwtime the_nilfs 0 41268 NULL
+disable_so_max_delta_ns_clock_event_device_41269 max_delta_ns clock_event_device 0 41269 NULL
+disable_so_mcryptd_hash_init_enqueue_fndecl_41273 mcryptd_hash_init_enqueue fndecl 0 41273 NULL
+disable_so_enic_set_mac_address_dynamic_fndecl_41279 enic_set_mac_address_dynamic fndecl 0 41279 NULL
+disable_so_igb_ptp_adjtime_i210_fndecl_41280 igb_ptp_adjtime_i210 fndecl 2 41280 NULL
+disable_so_timestamp_cper_record_header_41286 timestamp cper_record_header 0 41286 NULL
+disable_so_mtt_base_addr_l_mlx4_cq_context_41294 mtt_base_addr_l mlx4_cq_context 0 41294 NULL
+disable_so_base_lo_mtrr_var_range_41296 base_lo mtrr_var_range 0 41296 NULL
+disable_so_ucma_query_gid_fndecl_41299 ucma_query_gid fndecl 3 41299 NULL
+disable_so_ioat_dma_setup_interrupts_fndecl_41304 ioat_dma_setup_interrupts fndecl 0 41304 NULL
+disable_so_cmaj_flt_signal_struct_41306 cmaj_flt signal_struct 0 41306 NULL
+disable_so_wlc_phy_ant_rxdiv_set_fndecl_41312 wlc_phy_ant_rxdiv_set fndecl 2 41312 NULL
+disable_so_ata_timing_compute_fndecl_41314 ata_timing_compute fndecl 2 41314 NULL
+disable_so_jiffies_resched_rcu_state_41320 jiffies_resched rcu_state 0 41320 NULL
+disable_so_cc770_rx_interrupt_fndecl_41322 cc770_rx_interrupt fndecl 2 41322 NULL
+disable_so_configure_clock_fndecl_41329 configure_clock fndecl 0 41329 NULL
+disable_so_timeout_ip_set_41331 timeout ip_set 0 41331 NULL
+disable_so_dcbnl_getperm_hwaddr_fndecl_41338 dcbnl_getperm_hwaddr fndecl 0 41338 NULL
+disable_so_cfg80211_set_cipher_group_fndecl_41343 cfg80211_set_cipher_group fndecl 2 41343 NULL
+disable_so_time_ipr_trace_entry_41350 time ipr_trace_entry 0 41350 NULL
+disable_so_csize_lattime_ahc_pci_softc_41352 csize_lattime ahc_pci_softc 0 41352 NULL
+disable_so_bind_to_cpu_evtchn_ops_41358 bind_to_cpu evtchn_ops 2 41358 NULL
+disable_so_init_lib80211_crypto_ops_41363 init lib80211_crypto_ops 1 41363 NULL
+disable_so_xhci_get_timeout_no_hub_lpm_fndecl_41382 xhci_get_timeout_no_hub_lpm fndecl 0 41382 NULL
+disable_so_ast_set_index_reg_mask_fndecl_41386 ast_set_index_reg_mask fndecl 5 41386 NULL nohasharray
+disable_so_iwl_send_rxon_timing_fndecl_41386 iwl_send_rxon_timing fndecl 0 41386 &disable_so_ast_set_index_reg_mask_fndecl_41386
+disable_so_last_can_queue_ramp_down_time_fc_fcp_internal_41400 last_can_queue_ramp_down_time fc_fcp_internal 0 41400 NULL
+disable_so_bClockID_uac_clock_selector_descriptor_41403 bClockID uac_clock_selector_descriptor 0 41403 NULL
+disable_so_sys_setuid_fndecl_41415 sys_setuid fndecl 0-1 41415 NULL
+disable_so_i2c_address_tda826x_priv_41421 i2c_address tda826x_priv 0 41421 NULL
+disable_so_dma_addr_efx_rx_buffer_41422 dma_addr efx_rx_buffer 0 41422 NULL
+disable_so_retrans_timeout_l2cap_chan_41431 retrans_timeout l2cap_chan 0 41431 NULL
+disable_so_musb_read_rxhubaddr_fndecl_41435 musb_read_rxhubaddr fndecl 2-0 41435 NULL
+disable_so_pll_reference_div_radeon_crtc_41437 pll_reference_div radeon_crtc 0 41437 NULL
+disable_so_macvlan_set_mac_address_fndecl_41439 macvlan_set_mac_address fndecl 0 41439 NULL
+disable_so_i_uid_read_fndecl_41443 i_uid_read fndecl 0 41443 NULL
+disable_so_hpi_silence_detector_get_delay_fndecl_41450 hpi_silence_detector_get_delay fndecl 0-1 41450 NULL
+disable_so__div_round_up_fndecl_41453 _div_round_up fndecl 0-3-2 41453 NULL
+disable_so_br_timer_value_fndecl_41454 br_timer_value fndecl 0 41454 NULL
+disable_so_compat_sys_utimes_fndecl_41459 compat_sys_utimes fndecl 0 41459 NULL
+disable_so_tx_duty_cycle_ofdm_brcms_c_info_41464 tx_duty_cycle_ofdm brcms_c_info 0 41464 NULL
+disable_so_crypto_authenc_verify_fndecl_41468 crypto_authenc_verify fndecl 0 41468 NULL
+disable_so_signalQuality_StatusRid_41475 signalQuality StatusRid 0 41475 NULL
+disable_so_storvsc_timeout_vardecl_storvsc_drv_c_41479 storvsc_timeout vardecl_storvsc_drv.c 0 41479 NULL
+disable_so_sctp_v6_from_addr_param_fndecl_41480 sctp_v6_from_addr_param fndecl 3-4 41480 NULL
+disable_so_xfs_btree_check_ptr_fndecl_41490 xfs_btree_check_ptr fndecl 3-0 41490 NULL
+disable_so___anon_vma_interval_tree_compute_subtree_last_fndecl_41494 __anon_vma_interval_tree_compute_subtree_last fndecl 0 41494 NULL
+disable_so_drive_jiffies_skd_device_41506 drive_jiffies skd_device 0 41506 NULL
+disable_so_last_dock_time_dock_station_41508 last_dock_time dock_station 0 41508 NULL
+disable_so_common_nsleep_fndecl_41534 common_nsleep fndecl 1 41534 NULL
+disable_so_sun4i_spi_runtime_resume_fndecl_41538 sun4i_spi_runtime_resume fndecl 0 41538 NULL
+disable_so_src_nents_qce_cipher_reqctx_41541 src_nents qce_cipher_reqctx 0 41541 NULL
+disable_so_daddr_irda_ias_set_41547 daddr irda_ias_set 0 41547 NULL
+disable_so_cpufreq_frequency_get_table_fndecl_41548 cpufreq_frequency_get_table fndecl 1 41548 NULL
+disable_so_bd_list_addr_lo_bnx2i_tmf_request_41551 bd_list_addr_lo bnx2i_tmf_request 0 41551 NULL
+disable_so_mkey_lease_timeout_qib_ibport_41552 mkey_lease_timeout qib_ibport 0 41552 NULL
+disable_so_dma_addr_efx_rx_page_state_41558 dma_addr efx_rx_page_state 0 41558 NULL
+disable_so_igb_runtime_resume_fndecl_41565 igb_runtime_resume fndecl 0 41565 NULL
+disable_so_wait_on_page_bit_killable_fndecl_41573 wait_on_page_bit_killable fndecl 0 41573 NULL
+disable_so_time_js_event_41583 time js_event 0 41583 NULL nohasharray
+disable_so_lzo_mod_init_fndecl_41583 lzo_mod_init fndecl 0 41583 &disable_so_time_js_event_41583
+disable_so_cg_spll_func_cntl_2_si_clock_registers_41584 cg_spll_func_cntl_2 si_clock_registers 0 41584 NULL
+disable_so_swa_base_asd_ha_addrspace_41593 swa_base asd_ha_addrspace 0 41593 NULL
+disable_so_flow_get_skgid_fndecl_41594 flow_get_skgid fndecl 0 41594 NULL nohasharray
+disable_so_fib_sync_down_addr_fndecl_41594 fib_sync_down_addr fndecl 2 41594 &disable_so_flow_get_skgid_fndecl_41594
+disable_so_fl0addr_csio_iq_params_41595 fl0addr csio_iq_params 0 41595 NULL
+disable_so_cpufreq_stat_notifier_policy_fndecl_41604 cpufreq_stat_notifier_policy fndecl 0 41604 NULL nohasharray
+disable_so_hash_by_src_fndecl_41604 hash_by_src fndecl 0 41604 &disable_so_cpufreq_stat_notifier_policy_fndecl_41604
+disable_so_read_nvkm_timer_41609 read nvkm_timer 0 41609 NULL
+disable_so_shm32read_addr_next_b43_dfsentry_41611 shm32read_addr_next b43_dfsentry 0 41611 NULL
+disable_so_lo_regpair_41616 lo regpair 0 41616 NULL
+disable_so_addr_netdev_desc_41619 addr netdev_desc 0 41619 NULL
+disable_so_ndesc_get_timestamp_fndecl_41626 ndesc_get_timestamp fndecl 0 41626 NULL
+disable_so_gid_cramfs_inode_41627 gid cramfs_inode 0 41627 NULL
+disable_so___sw_hweight8_fndecl_41629 __sw_hweight8 fndecl 1-0 41629 NULL
+disable_so_kvm_mtrr_get_guest_memory_type_fndecl_41633 kvm_mtrr_get_guest_memory_type fndecl 2-0 41633 NULL
+disable_so___xfrm6_addr_hash_fndecl_41637 __xfrm6_addr_hash fndecl 0 41637 NULL
+disable_so_phys_reg_addr_slgt_info_41642 phys_reg_addr slgt_info 0 41642 NULL
+disable_so_il_dbgfs_wd_timeout_write_fndecl_41643 il_dbgfs_wd_timeout_write fndecl 3 41643 NULL
+disable_so_count_sha256_state_41648 count sha256_state 0 41648 NULL
+disable_so_ironlake_check_encoder_dotclock_fndecl_41660 ironlake_check_encoder_dotclock fndecl 2 41660 NULL
+disable_so_af9015_eeprom_hash_fndecl_41666 af9015_eeprom_hash fndecl 0 41666 NULL
+disable_so_intel_dotclock_calculate_fndecl_41668 intel_dotclock_calculate fndecl 1-0 41668 NULL
+disable_so_rdmsrl_amd_safe_fndecl_41672 rdmsrl_amd_safe fndecl 0 41672 NULL
+disable_so_crypto_ablkcipher_encrypt_fndecl_41682 crypto_ablkcipher_encrypt fndecl 0 41682 NULL
+disable_so_bcma_pmu_pll_clock_bcm4706_fndecl_41683 bcma_pmu_pll_clock_bcm4706 fndecl 0-2 41683 NULL
+disable_so_regmap_write_fndecl_41685 regmap_write fndecl 0-2-3 41685 NULL
+disable_so_setup_APIC_mce_threshold_fndecl_41686 setup_APIC_mce_threshold fndecl 0-1-2 41686 NULL
+disable_so_copy_signal_fndecl_41687 copy_signal fndecl 1 41687 NULL
+disable_so_dma_addr_dw_spi_41693 dma_addr dw_spi 0 41693 NULL
+disable_so_leave_oper_channel_time_ieee80211_local_41701 leave_oper_channel_time ieee80211_local 0 41701 NULL
+disable_so_bit_putcs_fndecl_41704 bit_putcs fndecl 4-5-6-7-8 41704 NULL
+disable_so_nbpf_runtime_resume_fndecl_41706 nbpf_runtime_resume fndecl 0 41706 NULL
+disable_so_force_addr_vardecl_vt8231_c_41714 force_addr vardecl_vt8231.c 0 41714 NULL
+disable_so_radio_syn_pll_refdiv_b43_nphy_channeltab_entry_rev3_41738 radio_syn_pll_refdiv b43_nphy_channeltab_entry_rev3 0 41738 NULL
+disable_so_epoch_time_atto_vda_cfg_init_41739 epoch_time atto_vda_cfg_init 0 41739 NULL
+disable_so_node_size_shift_hfs_btree_41753 node_size_shift hfs_btree 0 41753 NULL
+disable_so_gfx_addr_intel_hw_status_page_41756 gfx_addr intel_hw_status_page 0 41756 NULL
+disable_so_mtrr_trim_uncached_memory_fndecl_41757 mtrr_trim_uncached_memory fndecl 1 41757 NULL
+disable_so_start_idle_time_cfqg_stats_41767 start_idle_time cfqg_stats 0 41767 NULL
+disable_so_receive_bitmap_plain_fndecl_41772 receive_bitmap_plain fndecl 0-2 41772 NULL
+disable_so___set_port_dev_addr_fndecl_41787 __set_port_dev_addr fndecl 0 41787 NULL
+disable_so_max_delta_ticks_clock_event_device_41796 max_delta_ticks clock_event_device 0 41796 NULL
+disable_so_register_ip_vs_scheduler_fndecl_41797 register_ip_vs_scheduler fndecl 0 41797 NULL
+disable_so_lcd_pixclock_atyfb_par_41804 lcd_pixclock atyfb_par 0 41804 NULL
+disable_so_mwl8k_cmd_set_mac_addr_fndecl_41809 mwl8k_cmd_set_mac_addr fndecl 0 41809 NULL
+disable_so_mktime64_fndecl_41810 mktime64 fndecl 0-6-5-4-3-2-1 41810 NULL
+disable_so_brcmf_pcie_buscore_prep_addr_fndecl_41821 brcmf_pcie_buscore_prep_addr fndecl 0-2 41821 NULL
+disable_so_s_bitmap_ino_omfs_sb_info_41835 s_bitmap_ino omfs_sb_info 0 41835 NULL
+disable_so_tlan_handle_interrupt_fndecl_41866 tlan_handle_interrupt fndecl 1 41866 NULL
+disable_so_crypto_authenc_esn_genicv_fndecl_41873 crypto_authenc_esn_genicv fndecl 0 41873 NULL
+disable_so_bfad_iocmd_rport_get_addr_fndecl_41879 bfad_iocmd_rport_get_addr fndecl 0 41879 NULL
+disable_so_xhci_del_comp_mod_timer_fndecl_41881 xhci_del_comp_mod_timer fndecl 3 41881 NULL
+disable_so_raddr_c2wr_ae_connection_request_41889 raddr c2wr_ae_connection_request 0 41889 NULL
+disable_so_btrfs_run_delayed_items_nr_fndecl_41895 btrfs_run_delayed_items_nr fndecl 0-3 41895 NULL nohasharray
+disable_so_isac_interrupt_fndecl_41895 isac_interrupt fndecl 2 41895 &disable_so_btrfs_run_delayed_items_nr_fndecl_41895
+disable_so_address_b43_dmadesc32_41900 address b43_dmadesc32 0 41900 NULL
+disable_so_i_gid_ext4_inode_41907 i_gid ext4_inode 0 41907 NULL
+disable_so_sil24_exec_polled_cmd_fndecl_41911 sil24_exec_polled_cmd fndecl 2 41911 NULL
+disable_so_cp_hqd_pq_rptr_report_addr_hqd_registers_41912 cp_hqd_pq_rptr_report_addr hqd_registers 0 41912 NULL
+disable_so_uuid_hash_ocfs2_super_41922 uuid_hash ocfs2_super 0 41922 NULL
+disable_so_connect_time_usb_device_41926 connect_time usb_device 0 41926 NULL
+disable_so_hard_byte_limit_xfrm_lifetime_cfg_41928 hard_byte_limit xfrm_lifetime_cfg 0 41928 NULL nohasharray
+disable_so_q_rtime_msg_queue_41928 q_rtime msg_queue 0 41928 &disable_so_hard_byte_limit_xfrm_lifetime_cfg_41928 nohasharray
+disable_so_saddr_iphdr_41928 saddr iphdr 0 41928 &disable_so_q_rtime_msg_queue_41928
+disable_so_nfs4_schedule_session_recovery_fndecl_41930 nfs4_schedule_session_recovery fndecl 2 41930 NULL
+disable_so_desc_card_addr_qla8044_minidump_entry_rdmem_pex_dma_41937 desc_card_addr qla8044_minidump_entry_rdmem_pex_dma 0 41937 NULL
+disable_so_freq_ar9170_calibration_target_power_ht_41939 freq ar9170_calibration_target_power_ht 0 41939 NULL
+disable_so_ino_timelimit_qc_type_state_41942 ino_timelimit qc_type_state 0 41942 NULL
+disable_so_ifa_local_in_ifaddr_41951 ifa_local in_ifaddr 0 41951 NULL
+disable_so_seq_radeon_fence_41952 seq radeon_fence 0 41952 NULL
+disable_so_mmc_interrupt_hpi_fndecl_41967 mmc_interrupt_hpi fndecl 0 41967 NULL
+disable_so_addr_nvbios_xpio_41977 addr nvbios_xpio 0 41977 NULL
+disable_so_mlx4_test_interrupts_fndecl_41979 mlx4_test_interrupts fndecl 0 41979 NULL
+disable_so_alps_process_bitmap_fndecl_41983 alps_process_bitmap fndecl 0 41983 NULL
+disable_so_enter_deep_sleep_lbs_private_41984 enter_deep_sleep lbs_private 0 41984 NULL
+disable_so_freq_detected_vx_core_41987 freq_detected vx_core 0 41987 NULL
+disable_so_sig_ksignal_41988 sig ksignal 0 41988 NULL
+disable_so_kvm_clock_get_cycles_fndecl_41992 kvm_clock_get_cycles fndecl 0 41992 NULL
+disable_so_mthca_setup_hca_fndecl_41999 mthca_setup_hca fndecl 0 41999 NULL
+disable_so_ipath_led_override_timeoff_ipath_devdata_42003 ipath_led_override_timeoff ipath_devdata 0 42003 NULL nohasharray
+disable_so_authenc_geniv_ahash_done_fndecl_42003 authenc_geniv_ahash_done fndecl 2 42003 &disable_so_ipath_led_override_timeoff_ipath_devdata_42003
+disable_so_cxgb4vf_set_mac_addr_fndecl_42004 cxgb4vf_set_mac_addr fndecl 0 42004 NULL
+disable_so_poly_cipher_fndecl_42005 poly_cipher fndecl 0 42005 NULL
+disable_so_lfo2delay_soundfont_voice_parm_42007 lfo2delay soundfont_voice_parm 0 42007 NULL
+disable_so_cik_get_cu_active_bitmap_fndecl_42010 cik_get_cu_active_bitmap fndecl 0-2-3 42010 NULL
+disable_so_get_max_clock_sdhci_ops_42015 get_max_clock sdhci_ops 0 42015 NULL
+disable_so_svm_read_l1_tsc_fndecl_42018 svm_read_l1_tsc fndecl 0-2 42018 NULL
+disable_so_dccp_feat_signal_nn_change_fndecl_42022 dccp_feat_signal_nn_change fndecl 3 42022 NULL
+disable_so_e1000_test_msi_interrupt_fndecl_42028 e1000_test_msi_interrupt fndecl 0 42028 NULL
+disable_so_uv_rtc_setup_clock_fndecl_42030 uv_rtc_setup_clock fndecl 0 42030 NULL
+disable_so_rsa_get_e_fndecl_42032 rsa_get_e fndecl 5 42032 NULL
+disable_so_set_h225_addr_fndecl_42039 set_h225_addr fndecl 2-4 42039 NULL
+disable_so_next_hrtimer_event_fotg210_hcd_42040 next_hrtimer_event fotg210_hcd 0 42040 NULL
+disable_so_baseaddr_m48t35_priv_42042 baseaddr m48t35_priv 0 42042 NULL
+disable_so_src_high_addr_mvumi_dyn_list_entry_42046 src_high_addr mvumi_dyn_list_entry 0 42046 NULL
+disable_so_address_x86_exception_42048 address x86_exception 0 42048 NULL nohasharray
+disable_so_adis16480_set_freq_fndecl_42048 adis16480_set_freq fndecl 0 42048 &disable_so_address_x86_exception_42048
+disable_so_skcipher_recvmsg_fndecl_42050 skcipher_recvmsg fndecl 0 42050 NULL
+disable_so_uid_ncp_mount_data_v4_42052 uid ncp_mount_data_v4 0 42052 NULL
+disable_so_guid_qib_pportdata_42064 guid qib_pportdata 0 42064 NULL
+disable_so_usb_find_address_fndecl_42069 usb_find_address fndecl 0 42069 NULL
+disable_so_crypto_comp_compress_fndecl_42075 crypto_comp_compress fndecl 3 42075 NULL
+disable_so_xcan_state_interrupt_fndecl_42076 xcan_state_interrupt fndecl 2 42076 NULL
+disable_so_xfs_dir2_leaf_search_hash_fndecl_42097 xfs_dir2_leaf_search_hash fndecl 0 42097 NULL
+disable_so_rtl8169_interrupt_fndecl_42115 rtl8169_interrupt fndecl 1 42115 NULL
+disable_so_ip_list_uid_vardecl_xt_recent_c_42144 ip_list_uid vardecl_xt_recent.c 0 42144 NULL
+disable_so_request_sound_timer_fndecl_42149 request_sound_timer fndecl 1 42149 NULL nohasharray
+disable_so_sof_search_timeout_stb0899_config_42149 sof_search_timeout stb0899_config 0 42149 &disable_so_request_sound_timer_fndecl_42149
+disable_so_uvc_timeout_param_vardecl_42158 uvc_timeout_param vardecl 0 42158 NULL
+disable_so_stv0900_get_mclk_freq_fndecl_42161 stv0900_get_mclk_freq fndecl 0-2 42161 NULL
+disable_so_pch_systime_read_fndecl_42169 pch_systime_read fndecl 0 42169 NULL
+disable_so_accumulate_16bit_val_fndecl_42178 accumulate_16bit_val fndecl 2 42178 NULL
+disable_so_cryptd_blkcipher_enqueue_fndecl_42182 cryptd_blkcipher_enqueue fndecl 0 42182 NULL
+disable_so_sjw_can_bittiming_42187 sjw can_bittiming 0 42187 NULL
+disable_so_vortex_interrupt_fndecl_42189 vortex_interrupt fndecl 1 42189 NULL
+disable_so_ar_addr_qla4_83xx_quad_entry_42190 ar_addr qla4_83xx_quad_entry 0 42190 NULL
+disable_so_sctp_v4_from_addr_param_fndecl_42197 sctp_v4_from_addr_param fndecl 3 42197 NULL
+disable_so_sda_hold_time_dw_i2c_dev_42198 sda_hold_time dw_i2c_dev 0 42198 NULL
+disable_so_proc_doulongvec_ms_jiffies_minmax_fndecl_42211 proc_doulongvec_ms_jiffies_minmax fndecl 0 42211 NULL
+disable_so_monitor_timeout_l2cap_chan_42212 monitor_timeout l2cap_chan 0 42212 NULL
+disable_so_sys_setfsuid16_fndecl_42222 sys_setfsuid16 fndecl 0-1 42222 NULL
+disable_so_rrd_ret_timer_atl1_hw_42226 rrd_ret_timer atl1_hw 0 42226 NULL nohasharray
+disable_so__get_table_mindiv_fndecl_42226 _get_table_mindiv fndecl 0 42226 &disable_so_rrd_ret_timer_atl1_hw_42226
+disable_so_ext4_block_bitmap_set_fndecl_42228 ext4_block_bitmap_set fndecl 3 42228 NULL
+disable_so_select_timeout_pca9541_42231 select_timeout pca9541 0 42231 NULL
+disable_so_id_and_color_iwl_time_event_cmd_42237 id_and_color iwl_time_event_cmd 0 42237 NULL
+disable_so_map_id_down_fndecl_42241 map_id_down fndecl 0-2 42241 NULL
+disable_so_usb_sleep_music_store_fndecl_42245 usb_sleep_music_store fndecl 0-4 42245 NULL
+disable_so_ath6kl_sdio_func0_cmd52_wr_byte_fndecl_42251 ath6kl_sdio_func0_cmd52_wr_byte fndecl 0 42251 NULL
+disable_so_bitmap_and_fndecl_42267 bitmap_and fndecl 4 42267 NULL
+disable_so_tx_frame_ath_cycle_counters_42275 tx_frame ath_cycle_counters 0 42275 NULL
+disable_so_hasht_dcb_output_42279 hasht dcb_output 0 42279 NULL
+disable_so_xfs_btree_key_addr_fndecl_42282 xfs_btree_key_addr fndecl 2 42282 NULL
+disable_so_lpfc_max_scsicmpl_time_store_fndecl_42289 lpfc_max_scsicmpl_time_store fndecl 0 42289 NULL
+disable_so_ltr501_ps_write_samp_freq_fndecl_42298 ltr501_ps_write_samp_freq fndecl 0 42298 NULL
+disable_so_time_zero_perf_event_mmap_page_42309 time_zero perf_event_mmap_page 0 42309 NULL nohasharray
+disable_so_dmatest_random_fndecl_42309 dmatest_random fndecl 0 42309 &disable_so_time_zero_perf_event_mmap_page_42309
+disable_so_sm_addr_sm501_mem_42315 sm_addr sm501_mem 0 42315 NULL
+disable_so_snd_rme32_info_clockmode_control_fndecl_42323 snd_rme32_info_clockmode_control fndecl 0 42323 NULL
+disable_so_max8997_rtc_set_time_fndecl_42326 max8997_rtc_set_time fndecl 0 42326 NULL nohasharray
+disable_so_freq_ath6kl_mgmt_buff_42326 freq ath6kl_mgmt_buff 0 42326 &disable_so_max8997_rtc_set_time_fndecl_42326
+disable_so_clk_register_divider_table_fndecl_42329 clk_register_divider_table fndecl 7-6 42329 NULL
+disable_so_guid_indexes_mlx4_sriov_alias_guid_info_rec_det_42332 guid_indexes mlx4_sriov_alias_guid_info_rec_det 0 42332 NULL
+disable_so_addr_cis_cache_entry_42335 addr cis_cache_entry 0 42335 NULL
+disable_so_dma_addr_bnad_tx_vector_42337 dma_addr bnad_tx_vector 0 42337 NULL
+disable_so_mgid_index_mlx5_qp_path_42339 mgid_index mlx5_qp_path 0 42339 NULL
+disable_so_tcm_base_address_brcmf_pcie_shared_info_42357 tcm_base_address brcmf_pcie_shared_info 0 42357 NULL
+disable_so_mod_timer_fndecl_42361 mod_timer fndecl 2-0 42361 NULL
+disable_so_srpt_service_guid_vardecl_ib_srpt_c_42363 srpt_service_guid vardecl_ib_srpt.c 0 42363 NULL
+disable_so_qat_alg_ablkcipher_init_enc_fndecl_42373 qat_alg_ablkcipher_init_enc fndecl 4 42373 NULL
+disable_so_mdiv_gf100_clk_info_42375 mdiv gf100_clk_info 0 42375 NULL
+disable_so__ubh_find_next_zero_bit__fndecl_42379 _ubh_find_next_zero_bit_ fndecl 0-3-4-5 42379 NULL
+disable_so_tv_nsec_timespec_42383 tv_nsec timespec 0 42383 NULL
+disable_so_last_timestamp_iso_context_42389 last_timestamp iso_context 0 42389 NULL
+disable_so_iqaddr_fw_ri_res_cq_42408 iqaddr fw_ri_res_cq 0 42408 NULL
+disable_so_proc_loginuid_write_fndecl_42419 proc_loginuid_write fndecl 3 42419 NULL
+disable_so_mpeg_output_clock_rate_drxj_data_42421 mpeg_output_clock_rate drxj_data 0 42421 NULL
+disable_so_fref_clock_ratio_dib0090_config_42426 fref_clock_ratio dib0090_config 0 42426 NULL
+disable_so_virtnet_set_mac_address_fndecl_42429 virtnet_set_mac_address fndecl 0 42429 NULL
+disable_so_panel_pwr_delay_radeon_encoder_atom_dig_42430 panel_pwr_delay radeon_encoder_atom_dig 0 42430 NULL
+disable_so_timeo_nfs_parsed_mount_data_42431 timeo nfs_parsed_mount_data 0 42431 NULL
+disable_so_correction_snd_timer_system_private_42446 correction snd_timer_system_private 0 42446 NULL
+disable_so_intr_timer_usec_vnic_enet_config_42448 intr_timer_usec vnic_enet_config 0 42448 NULL
+disable_so_id_mISDNtimer_42453 id mISDNtimer 0 42453 NULL
+disable_so_i2c_algo_dp_aux_address_fndecl_42460 i2c_algo_dp_aux_address fndecl 2 42460 NULL
+disable_so__register_divider_fndecl_42464 _register_divider fndecl 7-6 42464 NULL
+disable_so_max8998_rtc_read_time_fndecl_42466 max8998_rtc_read_time fndecl 0 42466 NULL
+disable_so_sctp_setsockopt_paddr_thresholds_fndecl_42474 sctp_setsockopt_paddr_thresholds fndecl 3-0 42474 NULL nohasharray
+disable_so_stv0900_get_tuner_freq_fndecl_42474 stv0900_get_tuner_freq fndecl 0 42474 &disable_so_sctp_setsockopt_paddr_thresholds_fndecl_42474
+disable_so_rt2x00crypto_tx_overhead_fndecl_42475 rt2x00crypto_tx_overhead fndecl 0 42475 NULL
+disable_so_lm3533_led_delay_off_set_fndecl_42481 lm3533_led_delay_off_set fndecl 0 42481 NULL
+disable_so_time_blocked_xen_spinlock_stats_42482 time_blocked xen_spinlock_stats 0 42482 NULL
+disable_so_nat_ver_bitmap_bytesize_f2fs_checkpoint_42483 nat_ver_bitmap_bytesize f2fs_checkpoint 0 42483 NULL
+disable_so_reg_write_fndecl_42487 reg_write fndecl 0 42487 NULL
+disable_so_btrfs_insert_delayed_dir_index_fndecl_42491 btrfs_insert_delayed_dir_index fndecl 0-4-7-8 42491 NULL
+disable_so_r53_val_fc2580_freq_regs_42497 r53_val fc2580_freq_regs 0 42497 NULL
+disable_so_txerr_interrupt_mask_ath_hw_42499 txerr_interrupt_mask ath_hw 0 42499 NULL
+disable_so_avail_max_snd_pcm_runtime_42523 avail_max snd_pcm_runtime 0 42523 NULL nohasharray
+disable_so_ibx_display_interrupt_update_fndecl_42523 ibx_display_interrupt_update fndecl 3-2 42523 &disable_so_avail_max_snd_pcm_runtime_42523
+disable_so_addr_hi_freelQ_e_42531 addr_hi freelQ_e 0 42531 NULL
+disable_so_wrmsr_safe_regs_on_cpu_fndecl_42539 wrmsr_safe_regs_on_cpu fndecl 0-1 42539 NULL
+disable_so_initial_apicid_cpuinfo_x86_42542 initial_apicid cpuinfo_x86 0 42542 NULL
+disable_so_rx_ring_dma_addr_pcnet32_private_42551 rx_ring_dma_addr pcnet32_private 0 42551 NULL
+disable_so_max_sleep_time_f2fs_gc_kthread_42557 max_sleep_time f2fs_gc_kthread 0 42557 NULL nohasharray
+disable_so_addr_high_vring_dma_addr_42557 addr_high vring_dma_addr 0 42557 &disable_so_max_sleep_time_f2fs_gc_kthread_42557
+disable_so_db_rec_addr_mlx4_srq_context_42559 db_rec_addr mlx4_srq_context 0 42559 NULL
+disable_so_mmc_clock_opt_set_fndecl_42561 mmc_clock_opt_set fndecl 2 42561 NULL
+disable_so_sys_setgid16_fndecl_42562 sys_setgid16 fndecl 0-1 42562 NULL
+disable_so_command_width_atiixp_ide_timing_42566 command_width atiixp_ide_timing 0 42566 NULL
+disable_so_cgroup_addrm_files_fndecl_42568 cgroup_addrm_files fndecl 0 42568 NULL
+disable_so_nla_put_via_fndecl_42571 nla_put_via fndecl 4 42571 NULL
+disable_so_flow_get_rxhash_fndecl_42572 flow_get_rxhash fndecl 0 42572 NULL
+disable_so_ves1820_set_tv_freq_fndecl_42581 ves1820_set_tv_freq fndecl 2 42581 NULL
+disable_so_clk_calc_subtree_fndecl_42586 clk_calc_subtree fndecl 2-4 42586 NULL
+disable_so_demod_address_stb0899_config_42587 demod_address stb0899_config 0 42587 NULL
+disable_so_thash_entries_vardecl_tcp_c_42589 thash_entries vardecl_tcp.c 0 42589 NULL
+disable_so_clock_freq_ushc_data_42599 clock_freq ushc_data 0 42599 NULL
+disable_so_VSyncEnd_xtimings_42606 VSyncEnd xtimings 0 42606 NULL
+disable_so_hv_need_to_signal_fndecl_42615 hv_need_to_signal fndecl 1 42615 NULL
+disable_so_rsa_get_n_fndecl_42620 rsa_get_n fndecl 5 42620 NULL
+disable_so_pci_bus_write_config_dword_fndecl_42624 pci_bus_write_config_dword fndecl 0-2-3-4 42624 NULL
+disable_so_gen_pool_virt_to_phys_fndecl_42628 gen_pool_virt_to_phys fndecl 2-0 42628 NULL
+disable_so_brcmf_sdiod_addrprep_fndecl_42643 brcmf_sdiod_addrprep fndecl 0 42643 NULL
+disable_so_mpt_loadtime_max_sectors_vardecl_mptsas_c_42653 mpt_loadtime_max_sectors vardecl_mptsas.c 0 42653 NULL
+disable_so_iscsi_stat_tgt_attr_show_attr_last_fail_time_fndecl_42661 iscsi_stat_tgt_attr_show_attr_last_fail_time fndecl 0 42661 NULL
+disable_so_rx_antdiv_shared_phy_42665 rx_antdiv shared_phy 0 42665 NULL
+disable_so_uart_get_attr_custom_divisor_fndecl_42667 uart_get_attr_custom_divisor fndecl 0 42667 NULL nohasharray
+disable_so_bch_btree_map_nodes_recurse_fndecl_42667 bch_btree_map_nodes_recurse fndecl 0 42667 &disable_so_uart_get_attr_custom_divisor_fndecl_42667
+disable_so_dib0090_write_reg_fndecl_42668 dib0090_write_reg fndecl 3 42668 NULL nohasharray
+disable_so_hv_need_to_signal_on_read_fndecl_42668 hv_need_to_signal_on_read fndecl 1 42668 &disable_so_dib0090_write_reg_fndecl_42668
+disable_so_bs_freqcnt_cx24113_state_42672 bs_freqcnt cx24113_state 0 42672 NULL
+disable_so_netlbl_unlhsh_remove_addr6_fndecl_42673 netlbl_unlhsh_remove_addr6 fndecl 0 42673 NULL
+disable_so_authenc_esn_verify_ahash_update_done2_fndecl_42674 authenc_esn_verify_ahash_update_done2 fndecl 2 42674 NULL
+disable_so_last_time_megasas_instance_42679 last_time megasas_instance 0 42679 NULL
+disable_so_hashval1_1_rx_pkt_hdr1_42687 hashval1_1 rx_pkt_hdr1 0 42687 NULL
+disable_so_nilfs_btree_do_lookup_fndecl_42696 nilfs_btree_do_lookup fndecl 0-3 42696 NULL
+disable_so_ip_vs_create_timeout_table_fndecl_42701 ip_vs_create_timeout_table fndecl 2 42701 NULL
+disable_so_mesh_table_hash_fndecl_42703 mesh_table_hash fndecl 0 42703 NULL
+disable_so_divide_fndecl_42710 divide fndecl 1 42710 NULL
+disable_so_nilfs_btree_node_insert_fndecl_42712 nilfs_btree_node_insert fndecl 2-3 42712 NULL
+disable_so_set_div_fndecl_42720 set_div fndecl 0-4 42720 NULL
+disable_so_current_uuid_show_fndecl_42727 current_uuid_show fndecl 0 42727 NULL nohasharray
+disable_so_nfs4_decode_mp_ds_addr_fndecl_42727 nfs4_decode_mp_ds_addr fndecl 3 42727 &disable_so_current_uuid_show_fndecl_42727
+disable_so_remove_uuid_fndecl_42730 remove_uuid fndecl 0-4 42730 NULL
+disable_so_bd_list_addr_lo_bnx2i_text_request_42732 bd_list_addr_lo bnx2i_text_request 0 42732 NULL
+disable_so_pch_gbe_mac_mc_addr_list_update_fndecl_42738 pch_gbe_mac_mc_addr_list_update fndecl 4 42738 NULL
+disable_so_tbl_addr_brcms_phy_42754 tbl_addr brcms_phy 0 42754 NULL
+disable_so_addr_sch5636_data_42756 addr sch5636_data 0 42756 NULL
+disable_so_hpfa_freq_cs42l56_platform_data_42759 hpfa_freq cs42l56_platform_data 0 42759 NULL
+disable_so_fanout_demux_hash_fndecl_42764 fanout_demux_hash fndecl 0-3 42764 NULL
+disable_so_cxgb_set_mac_addr_fndecl_42780 cxgb_set_mac_addr fndecl 0 42780 NULL
+disable_so_dn_addr2asc_fndecl_42781 dn_addr2asc fndecl 1 42781 NULL
+disable_so_mt9t031_runtime_resume_fndecl_42782 mt9t031_runtime_resume fndecl 0 42782 NULL
+disable_so_nla_put_le64_fndecl_42786 nla_put_le64 fndecl 0 42786 NULL
+disable_so_dell_rbu_dmaaddr_vardecl_dell_rbu_c_42794 dell_rbu_dmaaddr vardecl_dell_rbu.c 0 42794 NULL
+disable_so_ocfs2_update_inode_atime_fndecl_42799 ocfs2_update_inode_atime fndecl 0 42799 NULL nohasharray
+disable_so_pfkey_sockaddr_fill_fndecl_42799 pfkey_sockaddr_fill fndecl 2-4 42799 &disable_so_ocfs2_update_inode_atime_fndecl_42799
+disable_so_vga_get_interruptible_fndecl_42803 vga_get_interruptible fndecl 0 42803 NULL
+disable_so_lookup_pmd_address_fndecl_42804 lookup_pmd_address fndecl 1 42804 NULL
+disable_so_i40e_set_rss_hash_opt_fndecl_42810 i40e_set_rss_hash_opt fndecl 0 42810 NULL
+disable_so_from_kuid_fndecl_42812 from_kuid fndecl 0 42812 NULL
+disable_so_resolution_snd_timer_gstatus_42814 resolution snd_timer_gstatus 0 42814 NULL
+disable_so_demod_address_cx22700_config_42828 demod_address cx22700_config 0 42828 NULL
+disable_so_mpu_start_timer_fndecl_42840 mpu_start_timer fndecl 1 42840 NULL nohasharray
+disable_so_end_point_addr_cx231xx_audio_42840 end_point_addr cx231xx_audio 0 42840 &disable_so_mpu_start_timer_fndecl_42840
+disable_so_hpwdt_change_timer_fndecl_42850 hpwdt_change_timer fndecl 1 42850 NULL nohasharray
+disable_so_host_addr_hw_cmd_42850 host_addr hw_cmd 0 42850 &disable_so_hpwdt_change_timer_fndecl_42850
+disable_so_update_gid_fndecl_42874 update_gid fndecl 3 42874 NULL
+disable_so_read_div_fndecl_42880 read_div fndecl 0 42880 NULL nohasharray
+disable_so_SYSC_setpgid_fndecl_42880 SYSC_setpgid fndecl 1-2 42880 &disable_so_read_div_fndecl_42880
+disable_so_exptime_mpath_info_42881 exptime mpath_info 0 42881 NULL
+disable_so_count_netdev_hw_addr_list_42886 count netdev_hw_addr_list 0 42886 NULL
+disable_so___sel_hash_fndecl_42890 __sel_hash fndecl 0-2-3 42890 NULL
+disable_so_cipher_rt2x00lib_crypto_42894 cipher rt2x00lib_crypto 0 42894 NULL
+disable_so___dequeue_signal_fndecl_42904 __dequeue_signal fndecl 0 42904 NULL
+disable_so_uid_dpot_data_42905 uid dpot_data 0 42905 NULL
+disable_so_tc_index_bitmap_bits_asd_seq_data_42910 tc_index_bitmap_bits asd_seq_data 0 42910 NULL
+disable_so_ablkcipher_copy_iv_fndecl_42911 ablkcipher_copy_iv fndecl 3 42911 NULL
+disable_so_pci_pm_runtime_resume_fndecl_42917 pci_pm_runtime_resume fndecl 0 42917 NULL
+disable_so_default_sclk_radeon_clock_42919 default_sclk radeon_clock 0 42919 NULL
+disable_so_register_inet6addr_notifier_fndecl_42932 register_inet6addr_notifier fndecl 0 42932 NULL nohasharray
+disable_so_e1000_rx_hash_fndecl_42932 e1000_rx_hash fndecl 2 42932 &disable_so_register_inet6addr_notifier_fndecl_42932
+disable_so_isl1208_rtc_set_time_fndecl_42933 isl1208_rtc_set_time fndecl 0 42933 NULL nohasharray
+disable_so_ringid_wmi_vring_ba_en_cmd_42933 ringid wmi_vring_ba_en_cmd 0 42933 &disable_so_isl1208_rtc_set_time_fndecl_42933 nohasharray
+disable_so_host_addr_io_accel1_cmd_42933 host_addr io_accel1_cmd 0 42933 &disable_so_ringid_wmi_vring_ba_en_cmd_42933
+disable_so_uwb_rc_dev_addr_assign_fndecl_42936 uwb_rc_dev_addr_assign fndecl 0 42936 NULL
+disable_so_address_vme_bus_error_42937 address vme_bus_error 0 42937 NULL nohasharray
+disable_so_cma_bind_addr_fndecl_42937 cma_bind_addr fndecl 0 42937 &disable_so_address_vme_bus_error_42937
+disable_so_cyapa_gen5_set_interval_time_fndecl_42941 cyapa_gen5_set_interval_time fndecl 0-3 42941 NULL
+disable_so_ecx_tss_segment_32_42952 ecx tss_segment_32 0 42952 NULL
+disable_so_percentage_divider_radeon_atom_ss_42955 percentage_divider radeon_atom_ss 0 42955 NULL
+disable_so_timeout_sg_fd_42956 timeout sg_fd 0 42956 NULL
+disable_so_ftdi_2232h_baud_base_to_divisor_fndecl_42957 ftdi_2232h_baud_base_to_divisor fndecl 0-1-2 42957 NULL
+disable_so_mcryptd_hash_update_fndecl_42959 mcryptd_hash_update fndecl 2 42959 NULL
+disable_so_iqaddr_csio_iq_params_42960 iqaddr csio_iq_params 0 42960 NULL
+disable_so_head_wb_addr_i40e_hmc_obj_txq_42977 head_wb_addr i40e_hmc_obj_txq 0 42977 NULL nohasharray
+disable_so_written_btree_42977 written btree 0 42977 &disable_so_head_wb_addr_i40e_hmc_obj_txq_42977
+disable_so___btrfs_update_delayed_inode_fndecl_42987 __btrfs_update_delayed_inode fndecl 0 42987 NULL
+disable_so_af9005_fe_sleep_fndecl_42988 af9005_fe_sleep fndecl 0 42988 NULL nohasharray
+disable_so_counter_address_p4_counter_binding_42988 counter_address p4_counter_binding 0 42988 &disable_so_af9005_fe_sleep_fndecl_42988
+disable_so_alt_timeout_ib_qp_attr_42989 alt_timeout ib_qp_attr 0 42989 NULL
+disable_so_db_record_addr_mlx5_cq_context_43002 db_record_addr mlx5_cq_context 0 43002 NULL nohasharray
+disable_so_rhashtable_insert_rehash_fndecl_43002 rhashtable_insert_rehash fndecl 0 43002 &disable_so_db_record_addr_mlx5_cq_context_43002
+disable_so_zd1201_set_mac_address_fndecl_43003 zd1201_set_mac_address fndecl 0 43003 NULL
+disable_so_scs_init_hss_address_fndecl_43016 scs_init_hss_address fndecl 0 43016 NULL
+disable_so_hash_fndecl_43020 hash fndecl 0 43020 NULL
+disable_so_hpi_tuner_get_hd_radio_signal_blend_fndecl_43025 hpi_tuner_get_hd_radio_signal_blend fndecl 0-1 43025 NULL
+disable_so_rt_runtime_rt_rq_43033 rt_runtime rt_rq 0 43033 NULL
+disable_so_dbi_bw_timer_mipi_config_43043 dbi_bw_timer mipi_config 0 43043 NULL
+disable_so_bch_btree_op_init_fndecl_43045 bch_btree_op_init fndecl 2 43045 NULL
+disable_so_ctl_mce_bank_43048 ctl mce_bank 0 43048 NULL
+disable_so_io_addr_ips_ha_43051 io_addr ips_ha 0 43051 NULL
+disable_so_ucode_beacon_time_iwl_priv_43063 ucode_beacon_time iwl_priv 0 43063 NULL
+disable_so_fast_clip_ctrl_delay_s_cfg_agc_43064 fast_clip_ctrl_delay s_cfg_agc 0 43064 NULL
+disable_so_read_interrupt_status_fndecl_43075 read_interrupt_status fndecl 0 43075 NULL
+disable_so_suspend_time_nv04_timer_priv_43078 suspend_time nv04_timer_priv 0 43078 NULL
+disable_so_nl80211_send_mlme_timeout_fndecl_43081 nl80211_send_mlme_timeout fndecl 5 43081 NULL
+disable_so_xfs_uuid_table_size_vardecl_xfs_mount_c_43090 xfs_uuid_table_size vardecl_xfs_mount.c 0 43090 NULL
+disable_so_bitmap_allocate_region_fndecl_43093 bitmap_allocate_region fndecl 2-3 43093 NULL
+disable_so_timeouts_show_fndecl_43114 timeouts_show fndecl 0 43114 NULL
+disable_so_lm8323_pwm_store_time_fndecl_43123 lm8323_pwm_store_time fndecl 0 43123 NULL nohasharray
+disable_so_crypto_register_instance_fndecl_43123 crypto_register_instance fndecl 0 43123 &disable_so_lm8323_pwm_store_time_fndecl_43123
+disable_so_acpi_map_vaddr_lookup_fndecl_43126 acpi_map_vaddr_lookup fndecl 1-2 43126 NULL nohasharray
+disable_so_bitclk_freq_fsl_ssi_private_43126 bitclk_freq fsl_ssi_private 0 43126 &disable_so_acpi_map_vaddr_lookup_fndecl_43126
+disable_so_retranscount_nes_timer_entry_43129 retranscount nes_timer_entry 0 43129 NULL
+disable_so_driver_timestamp_qla8044_minidump_template_hdr_43138 driver_timestamp qla8044_minidump_template_hdr 0 43138 NULL
+disable_so_rtl8187_iowrite_async_fndecl_43147 rtl8187_iowrite_async fndecl 4-2 43147 NULL
+disable_so_gcm_hash_crypt_remain_continue_fndecl_43164 gcm_hash_crypt_remain_continue fndecl 0 43164 NULL
+disable_so_timeout_usbdevfs_ctrltransfer_43171 timeout usbdevfs_ctrltransfer 0 43171 NULL
+disable_so_addr_snd_ac97_43179 addr snd_ac97 0 43179 NULL
+disable_so_snd_timer_user_start_fndecl_43188 snd_timer_user_start fndecl 0 43188 NULL
+disable_so_div_f0_pll_values_43197 div_f0 pll_values 0 43197 NULL
+disable_so_tx_watchdog_timeout_conf_tx_settings_43198 tx_watchdog_timeout conf_tx_settings 0 43198 NULL
+disable_so_demod_address_stv0297_config_43206 demod_address stv0297_config 0 43206 NULL nohasharray
+disable_so_stv090x_write_reg_fndecl_43206 stv090x_write_reg fndecl 3-0 43206 &disable_so_demod_address_stv0297_config_43206
+disable_so_atomic64_sub_return_fndecl_43214 atomic64_sub_return fndecl 0-1 43214 NULL
+disable_so_select_addr_2_qla8044_minidump_entry_rdmux2_43220 select_addr_2 qla8044_minidump_entry_rdmux2 0 43220 NULL
+disable_so_pixel_clock_radeon_encoder_43221 pixel_clock radeon_encoder 0 43221 NULL
+disable_so_rdmsr_safe_on_cpu_fndecl_43222 rdmsr_safe_on_cpu fndecl 0-1 43222 NULL
+disable_so_adav80x_set_dac_clock_fndecl_43226 adav80x_set_dac_clock fndecl 2 43226 NULL
+disable_so_rc5t583_rtc_read_time_fndecl_43238 rc5t583_rtc_read_time fndecl 0 43238 NULL nohasharray
+disable_so_bitmap_zero_fndecl_43238 bitmap_zero fndecl 2 43238 &disable_so_rc5t583_rtc_read_time_fndecl_43238
+disable_so_vid_from_reg_fndecl_43258 vid_from_reg fndecl 0-1 43258 NULL
+disable_so_page_dp83640_clock_43262 page dp83640_clock 0 43262 NULL
+disable_so_mthca_SW2HW_SRQ_fndecl_43263 mthca_SW2HW_SRQ fndecl 0-3 43263 NULL
+disable_so_tea5777_freq_to_v4l2_freq_fndecl_43267 tea5777_freq_to_v4l2_freq fndecl 0-2 43267 NULL
+disable_so_addr_lo_eth_rx_bd_43268 addr_lo eth_rx_bd 0 43268 NULL
+disable_so_timeout_nf_conntrack_expect_policy_43269 timeout nf_conntrack_expect_policy 0 43269 NULL
+disable_so_read_addr___mux_43284 read_addr __mux 0 43284 NULL
+disable_so_start_address___osdv2_cdb_addr_len_43285 start_address __osdv2_cdb_addr_len 0 43285 NULL
+disable_so_frac_bot_pll_div_43287 frac_bot pll_div 0 43287 NULL
+disable_so_batadv_bitmap_shift_left_fndecl_43296 batadv_bitmap_shift_left fndecl 2 43296 NULL
+disable_so_btrfs_timespec_sec_fndecl_43304 btrfs_timespec_sec fndecl 0 43304 NULL
+disable_so_atime_cifs_unix_set_info_args_43311 atime cifs_unix_set_info_args 0 43311 NULL
+disable_so_id_bitmap_port_adt_elem_43312 id bitmap_port_adt_elem 0 43312 NULL
+disable_so_hsize_std_timing_43315 hsize std_timing 0 43315 NULL
+disable_so_addr_wusb_dev_43323 addr wusb_dev 0 43323 NULL
+disable_so_dma_addr_zynqmp_qspi_43329 dma_addr zynqmp_qspi 0 43329 NULL
+disable_so_flash_timeout_max77693_sub_led_43338 flash_timeout max77693_sub_led 0 43338 NULL nohasharray
+disable_so_save_restore_gpu_addr_radeon_rlc_43338 save_restore_gpu_addr radeon_rlc 0 43338 &disable_so_flash_timeout_max77693_sub_led_43338
+disable_so_cypress_get_mclk_frequency_ratio_fndecl_43339 cypress_get_mclk_frequency_ratio fndecl 0-2 43339 NULL
+disable_so_running_clock_fndecl_43341 running_clock fndecl 0 43341 NULL
+disable_so_snd_echo_clock_source_info_fndecl_43348 snd_echo_clock_source_info fndecl 0 43348 NULL
+disable_so_random_id_operand_ib_cm_43350 random_id_operand ib_cm 0 43350 NULL
+disable_so_il3945_build_tx_cmd_hwcrypto_fndecl_43368 il3945_build_tx_cmd_hwcrypto fndecl 5 43368 NULL
+disable_so_regcache_lzo_decompress_cache_block_fndecl_43370 regcache_lzo_decompress_cache_block fndecl 0 43370 NULL
+disable_so_rv6xx_memory_clock_entry_set_feedback_divider_fndecl_43374 rv6xx_memory_clock_entry_set_feedback_divider fndecl 3 43374 NULL
+disable_so_timer_expires_rts51x_chip_43381 timer_expires rts51x_chip 0 43381 NULL
+disable_so_bond_alb_set_mac_address_fndecl_43392 bond_alb_set_mac_address fndecl 0 43392 NULL
+disable_so_write_leasetime_fndecl_43394 write_leasetime fndecl 0 43394 NULL
+disable_so_ftdi_232am_baud_to_divisor_fndecl_43399 ftdi_232am_baud_to_divisor fndecl 0-1 43399 NULL
+disable_so_jiffies_be_aic_obj_43400 jiffies be_aic_obj 0 43400 NULL
+disable_so_timer_jiffies_tvec_base_43403 timer_jiffies tvec_base 0 43403 NULL
+disable_so___ip6addrlbl_add_fndecl_43404 __ip6addrlbl_add fndecl 0 43404 NULL
+disable_so_sd_ctime_stat_data_v1_43407 sd_ctime stat_data_v1 0 43407 NULL
+disable_so_check_timers_list_fndecl_43411 check_timers_list fndecl 0-3 43411 NULL
+disable_so_addr2_dir_table_slot_43416 addr2 dir_table_slot 0 43416 NULL
+disable_so_bch_btree_map_nodes_fndecl_43426 bch_btree_map_nodes fndecl 0 43426 NULL
+disable_so_burst_bclkdiv_tlv320dac33_priv_43428 burst_bclkdiv tlv320dac33_priv 0 43428 NULL
+disable_so_cx24116_read_signal_strength_fndecl_43436 cx24116_read_signal_strength fndecl 0 43436 NULL
+disable_so_xferq_addr_lo_fcoe_kwqe_conn_offload2_43439 xferq_addr_lo fcoe_kwqe_conn_offload2 0 43439 NULL
+disable_so_timeout_bfa_timer_s_43448 timeout bfa_timer_s 0 43448 NULL
+disable_so_ocfs2_wait_for_mask_interruptible_fndecl_43456 ocfs2_wait_for_mask_interruptible fndecl 0 43456 NULL
+disable_so_stream_timeout_nf_ct_gre_43468 stream_timeout nf_ct_gre 0 43468 NULL
+disable_so_sample_div_st_rc_device_43474 sample_div st_rc_device 0 43474 NULL
+disable_so_crypto_shash_finup_fndecl_43475 crypto_shash_finup fndecl 0-3 43475 NULL
+disable_so_current_frequency_lg216x_state_43480 current_frequency lg216x_state 0 43480 NULL
+disable_so_error_sha1_hash_ctx_43486 error sha1_hash_ctx 0 43486 NULL
+disable_so_link_up_time_swStat_43487 link_up_time swStat 0 43487 NULL
+disable_so_qce_ablkcipher_setkey_fndecl_43494 qce_ablkcipher_setkey fndecl 0-3 43494 NULL
+disable_so_timeout_msec_TAG_TW_Lock_43496 timeout_msec TAG_TW_Lock 0 43496 NULL
+disable_so_mcs7830_hif_get_mac_address_fndecl_43507 mcs7830_hif_get_mac_address fndecl 0 43507 NULL
+disable_so_show_fan_time_fndecl_43512 show_fan_time fndecl 0 43512 NULL
+disable_so_x25_display_timer_fndecl_43519 x25_display_timer fndecl 0 43519 NULL
+disable_so_address_m920x_inits_43524 address m920x_inits 0 43524 NULL
+disable_so_msr_extra_reg_43525 msr extra_reg 0 43525 NULL
+disable_so_hashm_nv50_disp_mthd_v1_43528 hashm nv50_disp_mthd_v1 0 43528 NULL
+disable_so_get_dvbt_signal_to_noise_fndecl_43531 get_dvbt_signal_to_noise fndecl 0 43531 NULL
+disable_so_snd_seq_oss_timer_start_fndecl_43533 snd_seq_oss_timer_start fndecl 0 43533 NULL
+disable_so_ath5k_hw_register_timeout_fndecl_43537 ath5k_hw_register_timeout fndecl 0-3-4 43537 NULL
+disable_so_slave_addr_intel_sdvo_43549 slave_addr intel_sdvo 0 43549 NULL
+disable_so_buf_addr_rocker_desc_43555 buf_addr rocker_desc 0 43555 NULL
+disable_so_bCSourceID_uac_clock_multiplier_descriptor_43558 bCSourceID uac_clock_multiplier_descriptor 0 43558 NULL nohasharray
+disable_so_scsi_reset_delay_adveep_38C1600_config_43558 scsi_reset_delay adveep_38C1600_config 0 43558 &disable_so_bCSourceID_uac_clock_multiplier_descriptor_43558 nohasharray
+disable_so_nla_put_u8_fndecl_43558 nla_put_u8 fndecl 0-3 43558 &disable_so_scsi_reset_delay_adveep_38C1600_config_43558
+disable_so_udp4_portaddr_hash_fndecl_43560 udp4_portaddr_hash fndecl 0-2-3 43560 NULL
+disable_so_port_clock_intel_crtc_state_43564 port_clock intel_crtc_state 0 43564 NULL
+disable_so_cpufreq_update_policy_fndecl_43580 cpufreq_update_policy fndecl 0-1 43580 NULL nohasharray
+disable_so_crypto_rfc4106_setauthsize_fndecl_43580 crypto_rfc4106_setauthsize fndecl 2 43580 &disable_so_cpufreq_update_policy_fndecl_43580
+disable_so_pm_schedule_suspend_fndecl_43585 pm_schedule_suspend fndecl 2-0 43585 NULL
+disable_so_HSyncStart_xtimings_43588 HSyncStart xtimings 0 43588 NULL
+disable_so_write_seq_tcp_sock_43590 write_seq tcp_sock 0 43590 NULL
+disable_so_orion_spi_50mhz_ac_timing_erratum_fndecl_43600 orion_spi_50mhz_ac_timing_erratum fndecl 2 43600 NULL
+disable_so_set_clock_vml_sys_43602 set_clock vml_sys 2 43602 NULL
+disable_so_sample_to_timespec_fndecl_43603 sample_to_timespec fndecl 2-1 43603 NULL
+disable_so_ib_find_gid_fndecl_43614 ib_find_gid fndecl 0 43614 NULL
+disable_so_ath9k_hw_set_sifs_time_fndecl_43616 ath9k_hw_set_sifs_time fndecl 2 43616 NULL
+disable_so_snd_als4000_set_addr_fndecl_43620 snd_als4000_set_addr fndecl 1 43620 NULL
+disable_so_dma_addr_as102_dev_t_43627 dma_addr as102_dev_t 0 43627 NULL
+disable_so_gcm_hash_crypt_remain_done_fndecl_43636 gcm_hash_crypt_remain_done fndecl 2 43636 NULL
+disable_so_msm6242_read_time_fndecl_43640 msm6242_read_time fndecl 0 43640 NULL
+disable_so_last_tick_timer_local_info_43641 last_tick_timer local_info 0 43641 NULL
+disable_so_guid_show_fndecl_43648 guid_show fndecl 0 43648 NULL
+disable_so_key_set_timeout_fndecl_43649 key_set_timeout fndecl 2 43649 NULL
+disable_so_abx80x_rtc_read_time_fndecl_43656 abx80x_rtc_read_time fndecl 0 43656 NULL
+disable_so_freq_wmi_ch_info_ev_arg_43659 freq wmi_ch_info_ev_arg 0 43659 NULL
+disable_so___delayacct_blkio_ticks_fndecl_43660 __delayacct_blkio_ticks fndecl 0 43660 NULL
+disable_so_base_dwell_time_conf_sched_scan_settings_43662 base_dwell_time conf_sched_scan_settings 0 43662 NULL
+disable_so_ps_upsd_max_sptime_read_fndecl_43665 ps_upsd_max_sptime_read fndecl 3-0 43665 NULL
+disable_so_sis190_get_mac_addr_fndecl_43671 sis190_get_mac_addr fndecl 0 43671 NULL
+disable_so_pll_loopdiv_dibx090p_best_adc_43673 pll_loopdiv dibx090p_best_adc 0 43673 NULL
+disable_so_first_uid_gid_extent_43687 first uid_gid_extent 0 43687 NULL
+disable_so_des2_idmac_desc_64addr_43704 des2 idmac_desc_64addr 0 43704 NULL
+disable_so_irq_get_irq_data_fndecl_43708 irq_get_irq_data fndecl 1 43708 NULL
+disable_so_mask_mlx4_bitmap_43716 mask mlx4_bitmap 0 43716 NULL
+disable_so_time_stamp_ixgbe_tx_buffer_43717 time_stamp ixgbe_tx_buffer 0 43717 NULL
+disable_so_tx_frequency_wl1273_device_43727 tx_frequency wl1273_device 0 43727 NULL
+disable_so_divider_round_rate_fndecl_43731 divider_round_rate fndecl 2-0-5 43731 NULL
+disable_so_delay_bfa_iocfc_intr_attr_s_43734 delay bfa_iocfc_intr_attr_s 0 43734 NULL
+disable_so_dccp_elapsed_time_len_fndecl_43735 dccp_elapsed_time_len fndecl 0 43735 NULL
+disable_so_uwb_rc_addr_set_fndecl_43736 uwb_rc_addr_set fndecl 0 43736 NULL
+disable_so_add_delayed_data_ref_fndecl_43738 add_delayed_data_ref fndecl 10-12-5-6-7-8-9 43738 NULL
+disable_so_double_bit_error_detect_fndecl_43740 double_bit_error_detect fndecl 4 43740 NULL
+disable_so_pc_clock_gettime_fndecl_43750 pc_clock_gettime fndecl 1 43750 NULL
+disable_so_ts_tgid_owner_gru_thread_state_43760 ts_tgid_owner gru_thread_state 0 43760 NULL
+disable_so_hpet_set_periodic_freq_fndecl_43764 hpet_set_periodic_freq fndecl 1 43764 NULL
+disable_so___vmw_piter_sg_addr_fndecl_43770 __vmw_piter_sg_addr fndecl 0 43770 NULL
+disable_so_ipmi_validate_addr_fndecl_43771 ipmi_validate_addr fndecl 2 43771 NULL
+disable_so_delay_fb_deferred_io_43773 delay fb_deferred_io 0 43773 NULL
+disable_so_fixed_mtrr_addr_to_seg_fndecl_43774 fixed_mtrr_addr_to_seg fndecl 1 43774 NULL nohasharray
+disable_so___bitmap_equal_fndecl_43774 __bitmap_equal fndecl 3 43774 &disable_so_fixed_mtrr_addr_to_seg_fndecl_43774
+disable_so_igb_check_for_bit_pf_fndecl_43775 igb_check_for_bit_pf fndecl 2 43775 NULL
+disable_so_led_override_timeoff_qib_pportdata_43779 led_override_timeoff qib_pportdata 0 43779 NULL
+disable_so_wd_timeout_il_cfg_43781 wd_timeout il_cfg 0 43781 NULL
+disable_so_addr_kvm_io_range_43786 addr kvm_io_range 0 43786 NULL
+disable_so_sleep_millisecs_show_fndecl_43792 sleep_millisecs_show fndecl 0 43792 NULL
+disable_so_rpc_set_queue_timer_fndecl_43797 rpc_set_queue_timer fndecl 2 43797 NULL
+disable_so_ksz9031_center_flp_timing_fndecl_43804 ksz9031_center_flp_timing fndecl 0 43804 NULL
+disable_so_kstrtoull_from_user_fndecl_43809 kstrtoull_from_user fndecl 2 43809 NULL
+disable_so_numa_get_avg_runtime_fndecl_43810 numa_get_avg_runtime fndecl 0 43810 NULL
+disable_so_max77693_led_flash_timeout_set_fndecl_43811 max77693_led_flash_timeout_set fndecl 2 43811 NULL
+disable_so_mlx4_reset_roce_port_gids_fndecl_43816 mlx4_reset_roce_port_gids fndecl 0-2-3 43816 NULL
+disable_so_interrupt_level_vardecl_fdomain_c_43820 interrupt_level vardecl_fdomain.c 0 43820 NULL nohasharray
+disable_so_crypto_ahash_finup_fndecl_43820 crypto_ahash_finup fndecl 0 43820 &disable_so_interrupt_level_vardecl_fdomain_c_43820
+disable_so_block_bitmap_ext4_new_group_data_43822 block_bitmap ext4_new_group_data 0 43822 NULL
+disable_so_timer_stats_update_stats_fndecl_43829 timer_stats_update_stats fndecl 2 43829 NULL
+disable_so___nilfs_btree_get_block_fndecl_43845 __nilfs_btree_get_block fndecl 0-2 43845 NULL
+disable_so_wait_on_bit_lock_io_fndecl_43852 wait_on_bit_lock_io fndecl 0 43852 NULL
+disable_so_authenc_esn_geniv_ahash_update_done_fndecl_43855 authenc_esn_geniv_ahash_update_done fndecl 2 43855 NULL
+disable_so_pre_event_timeout_vardecl_sequencer_c_43856 pre_event_timeout vardecl_sequencer.c 0 43856 NULL nohasharray
+disable_so_last_rx_time_net_local_43856 last_rx_time net_local 0 43856 &disable_so_pre_event_timeout_vardecl_sequencer_c_43856
+disable_so_run_delayed_tree_ref_fndecl_43857 run_delayed_tree_ref fndecl 0 43857 NULL
+disable_so_radio_addr_saa7134_board_43862 radio_addr saa7134_board 0 43862 NULL
+disable_so_hor_total_via_display_timing_43866 hor_total via_display_timing 0 43866 NULL
+disable_so_mem_addr_pch_dma_desc_regs_43867 mem_addr pch_dma_desc_regs 0 43867 NULL
+disable_so_addr_Vmxnet3_TxDesc_43868 addr Vmxnet3_TxDesc 0 43868 NULL
+disable_so_set_ras_addr_fndecl_43869 set_ras_addr fndecl 4 43869 NULL
+disable_so_cpuidle_register_fndecl_43887 cpuidle_register fndecl 0 43887 NULL
+disable_so_start_seq_tcp_sack_block_43898 start_seq tcp_sack_block 0 43898 NULL
+disable_so_seq_default_timer_subdevice_vardecl_43912 seq_default_timer_subdevice vardecl 0 43912 NULL
+disable_so_pci_bus_update_busn_res_end_fndecl_43918 pci_bus_update_busn_res_end fndecl 2-0 43918 NULL
+disable_so_qdisc_watchdog_schedule_ns_fndecl_43926 qdisc_watchdog_schedule_ns fndecl 2 43926 NULL
+disable_so_sys_timer_create_fndecl_43937 sys_timer_create fndecl 1 43937 NULL
+disable_so_atmel_spi_runtime_resume_fndecl_43938 atmel_spi_runtime_resume fndecl 0 43938 NULL nohasharray
+disable_so_zd1201_set_freq_fndecl_43938 zd1201_set_freq fndecl 0 43938 &disable_so_atmel_spi_runtime_resume_fndecl_43938
+disable_so_gid_fuse_setattr_in_43939 gid fuse_setattr_in 0 43939 NULL
+disable_so_bit_putcs_aligned_fndecl_43966 bit_putcs_aligned fndecl 5-6-7-8 43966 NULL
+disable_so_log_mc_hash_sz_mlx4_init_hca_param_43973 log_mc_hash_sz mlx4_init_hca_param 0 43973 NULL
+disable_so_igb_write_8bit_ctrl_reg_fndecl_43984 igb_write_8bit_ctrl_reg fndecl 2 43984 NULL
+disable_so_r50_val_fc2580_freq_regs_43992 r50_val fc2580_freq_regs 0 43992 NULL
+disable_so_ccp_aes_xts_encrypt_fndecl_43996 ccp_aes_xts_encrypt fndecl 0 43996 NULL
+disable_so_tty_unregister_device_fndecl_44000 tty_unregister_device fndecl 2 44000 NULL
+disable_so_bus_addr_vnic_dev_bar_44006 bus_addr vnic_dev_bar 0 44006 NULL
+disable_so_pcf8523_rtc_set_time_fndecl_44007 pcf8523_rtc_set_time fndecl 0 44007 NULL
+disable_so_dq_hash_mask_vardecl_dquot_c_44015 dq_hash_mask vardecl_dquot.c 0 44015 NULL
+disable_so_device_addr_lm87_tx_hdr_44016 device_addr lm87_tx_hdr 0 44016 NULL
+disable_so__kstrtoull_fndecl_44018 _kstrtoull fndecl 0 44018 NULL
+disable_so_brcmf_sdiod_set_sbaddr_window_fndecl_44019 brcmf_sdiod_set_sbaddr_window fndecl 0-2 44019 NULL
+disable_so_drbd_adm_new_c_uuid_fndecl_44035 drbd_adm_new_c_uuid fndecl 0 44035 NULL
+disable_so_signal_hostap_80211_rx_status_44041 signal hostap_80211_rx_status 0 44041 NULL
+disable_so_enqueue_time_codel_skb_cb_44046 enqueue_time codel_skb_cb 0 44046 NULL
+disable_so_conv_clk_and_div_n_pcr_ops_44049 conv_clk_and_div_n pcr_ops 0-1 44049 NULL
+disable_so_ep93xx_spi_calc_divisors_fndecl_44051 ep93xx_spi_calc_divisors fndecl 0-2 44051 NULL
+disable_so_j_trans_start_time_reiserfs_journal_44058 j_trans_start_time reiserfs_journal 0 44058 NULL
+disable_so_cvt_kvaddr_fndecl_44079 cvt_kvaddr fndecl 0 44079 NULL
+disable_so_tm_mon_rtc_time_44080 tm_mon rtc_time 0 44080 NULL
+disable_so_uart_get_divisor_fndecl_44085 uart_get_divisor fndecl 0-2 44085 NULL
+disable_so_spn_obj_sockaddr_pn_44086 spn_obj sockaddr_pn 0 44086 NULL
+disable_so_cur_start_addr_sisusb_usb_data_44091 cur_start_addr sisusb_usb_data 0 44091 NULL nohasharray
+disable_so___vma_address_fndecl_44091 __vma_address fndecl 0 44091 &disable_so_cur_start_addr_sisusb_usb_data_44091
+disable_so_read_systime_fm10k_mac_ops_44092 read_systime fm10k_mac_ops 0 44092 NULL
+disable_so_nfsd_map_name_to_gid_fndecl_44096 nfsd_map_name_to_gid fndecl 0 44096 NULL
+disable_so_mthca_cmd_box_fndecl_44108 mthca_cmd_box fndecl 7-0-2-4-3 44108 NULL nohasharray
+disable_so_chv_clock_fndecl_44108 chv_clock fndecl 1 44108 &disable_so_mthca_cmd_box_fndecl_44108
+disable_so_ironlake_pch_transcoder_set_timings_fndecl_44115 ironlake_pch_transcoder_set_timings fndecl 2 44115 NULL
+disable_so___br_ip4_hash_fndecl_44134 __br_ip4_hash fndecl 0 44134 NULL
+disable_so_divider_recalc_rate_fndecl_44140 divider_recalc_rate fndecl 3-0-2 44140 NULL nohasharray
+disable_so_reg_id_res_gid_44140 reg_id res_gid 0 44140 &disable_so_divider_recalc_rate_fndecl_44140
+disable_so_dev_rst_time_qlcnic_adapter_44150 dev_rst_time qlcnic_adapter 0 44150 NULL
+disable_so_nsec_ptp_clock_time_44160 nsec ptp_clock_time 0 44160 NULL
+disable_so_node_count_hfs_btree_44162 node_count hfs_btree 0 44162 NULL
+disable_so_iscsit_na_dataout_timeout_fndecl_44167 iscsit_na_dataout_timeout fndecl 2-0 44167 NULL nohasharray
+disable_so_idletimer_ax25_info_struct_44167 idletimer ax25_info_struct 0 44167 &disable_so_iscsit_na_dataout_timeout_fndecl_44167
+disable_so_btrfs_delayed_qgroup_accounting_fndecl_44171 btrfs_delayed_qgroup_accounting fndecl 0 44171 NULL
+disable_so_t4_wr_mbox_timeout_fndecl_44177 t4_wr_mbox_timeout fndecl 2 44177 NULL
+disable_so_db_addr_mlx4_ib_create_qp_44182 db_addr mlx4_ib_create_qp 0 44182 NULL nohasharray
+disable_so_mxl111sf_streaming_ctrl_atsc_mh_fndecl_44182 mxl111sf_streaming_ctrl_atsc_mh fndecl 0 44182 &disable_so_db_addr_mlx4_ib_create_qp_44182
+disable_so_ipath_pkt_delay_fndecl_44185 ipath_pkt_delay fndecl 0-1-2-3 44185 NULL nohasharray
+disable_so_cycle_state_xhci_ring_44185 cycle_state xhci_ring 0 44185 &disable_so_ipath_pkt_delay_fndecl_44185
+disable_so_phys_dma_addr_r852_device_44187 phys_dma_addr r852_device 0 44187 NULL
+disable_so_nopin_response_timeout_iscsi_node_attrib_44188 nopin_response_timeout iscsi_node_attrib 0 44188 NULL
+disable_so_lkey_mthca_resize_cq_44197 lkey mthca_resize_cq 0 44197 NULL
+disable_so_rx_timeout_netdev_private_44200 rx_timeout netdev_private 0 44200 NULL
+disable_so_naddr_qib_user_sdma_pkt_44203 naddr qib_user_sdma_pkt 0 44203 NULL
+disable_so_block_to_cpu_fndecl_44212 block_to_cpu fndecl 0 44212 NULL
+disable_so_read_tail_n_tty_data_44226 read_tail n_tty_data 0 44226 NULL
+disable_so_bssidx_rt2x00lib_crypto_44239 bssidx rt2x00lib_crypto 0 44239 NULL
+disable_so_number_pci_bus_44243 number pci_bus 0 44243 NULL
+disable_so_watchdog_timeout_w83793_data_44253 watchdog_timeout w83793_data 0 44253 NULL
+disable_so_cz_clock_intel_rps_ei_44276 cz_clock intel_rps_ei 0 44276 NULL
+disable_so_proc_gid_map_open_fndecl_44293 proc_gid_map_open fndecl 0 44293 NULL
+disable_so_r2d_val_fc2580_freq_regs_44295 r2d_val fc2580_freq_regs 0 44295 NULL
+disable_so_wm8510_set_dai_clkdiv_fndecl_44299 wm8510_set_dai_clkdiv fndecl 3 44299 NULL
+disable_so_otime_jfs_inode_info_44300 otime jfs_inode_info 0 44300 NULL
+disable_so_rss_hash_be_rx_compl_info_44306 rss_hash be_rx_compl_info 0 44306 NULL
+disable_so_radio_tx_freq_vivid_dev_44308 radio_tx_freq vivid_dev 0 44308 NULL
+disable_so_smbhash_fndecl_44311 smbhash fndecl 0 44311 NULL
+disable_so_nla_put_in6_addr_fndecl_44317 nla_put_in6_addr fndecl 0 44317 NULL
+disable_so_fll_ref_freq__fll_div_44318 fll_ref_freq _fll_div 0 44318 NULL
+disable_so_prandom_bytes_state_fndecl_44332 prandom_bytes_state fndecl 3 44332 NULL
+disable_so_base_dma_addr_srp_map_state_44343 base_dma_addr srp_map_state 0 44343 NULL
+disable_so_addr_intel_plane_error_state_44366 addr intel_plane_error_state 0 44366 NULL
+disable_so_start_addr_acpi_memory_info_44372 start_addr acpi_memory_info 0 44372 NULL
+disable_so_bitmap_cpg_ocfs2_super_44373 bitmap_cpg ocfs2_super 0 44373 NULL
+disable_so_interval_zd_usb_interrupt_44381 interval zd_usb_interrupt 0 44381 NULL
+disable_so_neigh_proc_dointvec_ms_jiffies_fndecl_44384 neigh_proc_dointvec_ms_jiffies fndecl 0 44384 NULL
+disable_so_fsl_esai_divisor_cal_fndecl_44386 fsl_esai_divisor_cal fndecl 5-3 44386 NULL
+disable_so_sync_single_for_device_dma_map_ops_44393 sync_single_for_device dma_map_ops 2-3 44393 NULL
+disable_so_cl_lease_time_nfs_client_44400 cl_lease_time nfs_client 0 44400 NULL
+disable_so_asd_get_user_sas_addr_fndecl_44401 asd_get_user_sas_addr fndecl 0 44401 NULL
+disable_so_ss_tss_segment_16_44415 ss tss_segment_16 0 44415 NULL
+disable_so_ave_beacon_signal_ieee80211_if_managed_44440 ave_beacon_signal ieee80211_if_managed 0 44440 NULL
+disable_so_smsc911x_hash_fndecl_44443 smsc911x_hash fndecl 0 44443 NULL
+disable_so_flow_hash_from_keys_fndecl_44444 flow_hash_from_keys fndecl 0 44444 NULL
+disable_so_addr_vt8231_data_44455 addr vt8231_data 0 44455 NULL
+disable_so_drm_fixp_mul_fndecl_44461 drm_fixp_mul fndecl 0-1-2 44461 NULL
+disable_so_bind_evtchn_to_cpu_fndecl_44464 bind_evtchn_to_cpu fndecl 2-1 44464 NULL
+disable_so_rdma_set_reuseaddr_fndecl_44469 rdma_set_reuseaddr fndecl 0 44469 NULL
+disable_so_vx_calc_clock_from_freq_fndecl_44479 vx_calc_clock_from_freq fndecl 0-2 44479 NULL
+disable_so_rs_conn_addr_rds_sock_44482 rs_conn_addr rds_sock 0 44482 NULL
+disable_so_decode_attr_time_delta_fndecl_44484 decode_attr_time_delta fndecl 0 44484 NULL nohasharray
+disable_so_xfs_btree_get_bufs_fndecl_44484 xfs_btree_get_bufs fndecl 3-4 44484 &disable_so_decode_attr_time_delta_fndecl_44484
+disable_so_zd_chip_set_multicast_hash_fndecl_44491 zd_chip_set_multicast_hash fndecl 0 44491 NULL
+disable_so_write32_async_rtl_io_44499 write32_async rtl_io 2-3 44499 NULL
+disable_so_tcf_hashinfo_init_fndecl_44504 tcf_hashinfo_init fndecl 2 44504 NULL
+disable_so_buffer_addr_atl1c_rx_free_desc_44505 buffer_addr atl1c_rx_free_desc 0 44505 NULL
+disable_so_rqq_addr_hi_addr_ctrl_blk_44511 rqq_addr_hi addr_ctrl_blk 0 44511 NULL
+disable_so_max_pll_spi_speed_pll_clock_map_44513 max_pll_spi_speed pll_clock_map 0 44513 NULL
+disable_so_read_addr_qla8xxx_minidump_entry_mux_44516 read_addr qla8xxx_minidump_entry_mux 0 44516 NULL
+disable_so_abx500_set_register_interruptible_fndecl_44521 abx500_set_register_interruptible fndecl 0-4 44521 NULL
+disable_so_range_startk_var_mtrr_state_44530 range_startk var_mtrr_state 0 44530 NULL
+disable_so_dev_idx_sockaddr_nfc_44533 dev_idx sockaddr_nfc 0 44533 NULL
+disable_so_query_dv_timings_vivid_dev_44543 query_dv_timings vivid_dev 0 44543 NULL
+disable_so_saddr_ircomm_tty_cb_44557 saddr ircomm_tty_cb 0 44557 NULL
+disable_so_schedule_delay_balloon_stats_44561 schedule_delay balloon_stats 0 44561 NULL
+disable_so___start_cp_addr_fndecl_44569 __start_cp_addr fndecl 0 44569 NULL
+disable_so_m41t94_read_time_fndecl_44577 m41t94_read_time fndecl 0 44577 NULL
+disable_so_set_pte_vaddr_fndecl_44586 set_pte_vaddr fndecl 1 44586 NULL
+disable_so_sctp_getsockopt_peer_addrs_fndecl_44593 sctp_getsockopt_peer_addrs fndecl 0 44593 NULL
+disable_so_lu_reset_timeout_iscsi_session_44595 lu_reset_timeout iscsi_session 0 44595 NULL
+disable_so_jade_interrupt_fndecl_44602 jade_interrupt fndecl 2 44602 NULL nohasharray
+disable_so_ebx_smm_regs_44602 ebx smm_regs 0 44602 &disable_so_jade_interrupt_fndecl_44602 nohasharray
+disable_so_nilfs_btree_prepare_insert_fndecl_44602 nilfs_btree_prepare_insert fndecl 0-4 44602 &disable_so_ebx_smm_regs_44602
+disable_so_pcf50633_rtc_read_time_fndecl_44606 pcf50633_rtc_read_time fndecl 0 44606 NULL
+disable_so_active_time_evergreen_wm_params_44608 active_time evergreen_wm_params 0 44608 NULL
+disable_so_flags_inet6_ifaddr_44611 flags inet6_ifaddr 0 44611 NULL
+disable_so_sioaddr_watchdog_data_44614 sioaddr watchdog_data 0 44614 NULL
+disable_so_sense_addr_adv_scsi_req_q_44624 sense_addr adv_scsi_req_q 0 44624 NULL
+disable_so_maxfrags_snd_pcm_oss_runtime_44625 maxfrags snd_pcm_oss_runtime 0 44625 NULL
+disable_so_settle_delay_usecs_ads7846_platform_data_44627 settle_delay_usecs ads7846_platform_data 0 44627 NULL
+disable_so_get_random_int_fndecl_44628 get_random_int fndecl 0 44628 NULL
+disable_so_ahash_def_finup_finish1_fndecl_44631 ahash_def_finup_finish1 fndecl 0-2 44631 NULL
+disable_so_calib_time_b43_lo_calib_44633 calib_time b43_lo_calib 0 44633 NULL
+disable_so_timespec_to_jiffies_fndecl_44642 timespec_to_jiffies fndecl 0 44642 NULL
+disable_so_secid_netlbl_unlhsh_addr4_44654 secid netlbl_unlhsh_addr4 0 44654 NULL
+disable_so_tcp_init_nondata_skb_fndecl_44656 tcp_init_nondata_skb fndecl 2 44656 NULL
+disable_so_time_start_nfs_fattr_44666 time_start nfs_fattr 0 44666 NULL
+disable_so_nilfs_dev_uuid_show_fndecl_44683 nilfs_dev_uuid_show fndecl 0 44683 NULL
+disable_so_prctl_get_tid_address_fndecl_44684 prctl_get_tid_address fndecl 0 44684 NULL
+disable_so_rq_addr_t3_wq_44688 rq_addr t3_wq 0 44688 NULL
+disable_so_lpfc_max_scsicmpl_time_vardecl_lpfc_attr_c_44694 lpfc_max_scsicmpl_time vardecl_lpfc_attr.c 0 44694 NULL
+disable_so_show_guid_fndecl_44695 show_guid fndecl 0 44695 NULL
+disable_so_rsi_cmd52writebyte_fndecl_44700 rsi_cmd52writebyte fndecl 0-2-3 44700 NULL
+disable_so_rx_rx_timeout_read_fndecl_44710 rx_rx_timeout_read fndecl 3 44710 NULL
+disable_so_fw_localtime_wl_fw_status_44711 fw_localtime wl_fw_status 0 44711 NULL
+disable_so_sm501_calc_clock_fndecl_44717 sm501_calc_clock fndecl 1-4 44717 NULL
+disable_so_address_radio_20xx_regs_44719 address radio_20xx_regs 0 44719 NULL
+disable_so_round_jiffies_common_fndecl_44723 round_jiffies_common fndecl 0-2-1 44723 NULL
+disable_so_offtime_cbq_class_44730 offtime cbq_class 0 44730 NULL
+disable_so_cur_clock_rtsx_pcr_44731 cur_clock rtsx_pcr 0 44731 NULL
+disable_so_cik_set_uvd_clocks_fndecl_44739 cik_set_uvd_clocks fndecl 3-2-0 44739 NULL
+disable_so_write_reg_sja1000_priv_44741 write_reg sja1000_priv 3 44741 NULL
+disable_so_leaf_tail_hfs_btree_44745 leaf_tail hfs_btree 0 44745 NULL
+disable_so_ui_ctime_ufs2_inode_44748 ui_ctime ufs2_inode 0 44748 NULL nohasharray
+disable_so_addr_it87_data_44748 addr it87_data 0 44748 &disable_so_ui_ctime_ufs2_inode_44748
+disable_so_add_time_xfrm_lifetime_cur_44766 add_time xfrm_lifetime_cur 0 44766 NULL
+disable_so_genwqe_debugfs_curr_dbg_uid1_open_fndecl_44769 genwqe_debugfs_curr_dbg_uid1_open fndecl 0 44769 NULL
+disable_so_espibug_timeout_sge_44778 espibug_timeout sge 0 44778 NULL
+disable_so_buffer_addr_pch_gbe_tx_desc_44790 buffer_addr pch_gbe_tx_desc 0 44790 NULL
+disable_so_crypto_shash_init_fndecl_44815 crypto_shash_init fndecl 0 44815 NULL
+disable_so_get_evtchn_to_irq_fndecl_44824 get_evtchn_to_irq fndecl 0-1 44824 NULL nohasharray
+disable_so_jhash2_fndecl_44824 jhash2 fndecl 0-2-3 44824 &disable_so_get_evtchn_to_irq_fndecl_44824
+disable_so_s_mtime_nilfs_super_block_44839 s_mtime nilfs_super_block 0 44839 NULL
+disable_so_nilfs_segctor_last_nongc_write_time_show_fndecl_44843 nilfs_segctor_last_nongc_write_time_show fndecl 0 44843 NULL
+disable_so_usec_delay_ixgbe_mbx_info_44850 usec_delay ixgbe_mbx_info 0 44850 NULL
+disable_so_ecryptfs_cipher_code_to_string_fndecl_44859 ecryptfs_cipher_code_to_string fndecl 0 44859 NULL
+disable_so_ieee802154_hdr_get_addr_fndecl_44863 ieee802154_hdr_get_addr fndecl 0 44863 NULL
+disable_so_ecp_write_addr_parport_operations_44867 ecp_write_addr parport_operations 0 44867 NULL
+disable_so_mtrr_add_page_fndecl_44881 mtrr_add_page fndecl 1-2 44881 NULL
+disable_so_snd_via686_interrupt_fndecl_44897 snd_via686_interrupt fndecl 1 44897 NULL nohasharray
+disable_so_minor_hash_dx_hash_info_44897 minor_hash dx_hash_info 0 44897 &disable_so_snd_via686_interrupt_fndecl_44897
+disable_so_i2c_addr_dmi_onboard_device_info_44901 i2c_addr dmi_onboard_device_info 0 44901 NULL
+disable_so_tcp_conn_schedule_fndecl_44909 tcp_conn_schedule fndecl 1 44909 NULL nohasharray
+disable_so_udelay_fm10k_mbx_info_44909 udelay fm10k_mbx_info 0 44909 &disable_so_tcp_conn_schedule_fndecl_44909
+disable_so_c_timestamp_svc_cacherep_44918 c_timestamp svc_cacherep 0 44918 NULL
+disable_so_timeout_mpt2_ioctl_command_44920 timeout mpt2_ioctl_command 0 44920 NULL
+disable_so_sk_lingertime_sock_44923 sk_lingertime sock 0 44923 NULL
+disable_so_latency_timer_hpp_type0_44929 latency_timer hpp_type0 0 44929 NULL
+disable_so_mtime_squashfs_base_inode_44930 mtime squashfs_base_inode 0 44930 NULL
+disable_so_rpc_peeraddr_fndecl_44940 rpc_peeraddr fndecl 0-3 44940 NULL
+disable_so_dsap_sockaddr_nfc_llcp_44945 dsap sockaddr_nfc_llcp 0 44945 NULL
+disable_so_shash_ahash_mcryptd_finup_fndecl_44946 shash_ahash_mcryptd_finup fndecl 0 44946 NULL
+disable_so_SiS_SetRegANDOR_fndecl_44947 SiS_SetRegANDOR fndecl 1-2-3-4 44947 NULL
+disable_so_cpu_timer_sample_group_fndecl_44962 cpu_timer_sample_group fndecl 1 44962 NULL
+disable_so_key_timeout_rpc_authops_44963 key_timeout rpc_authops 0 44963 NULL
+disable_so_proc_uid_map_open_fndecl_44967 proc_uid_map_open fndecl 0 44967 NULL
+disable_so_spp_pathmtu_sctp_paddrparams_44974 spp_pathmtu sctp_paddrparams 0 44974 NULL
+disable_so_b43_radio_write_fndecl_44980 b43_radio_write fndecl 3 44980 NULL
+disable_so_level_btree_44981 level btree 0 44981 NULL
+disable_so_shift_clocksource_44992 shift clocksource 0 44992 NULL
+disable_so_mount_timeout_ceph_options_44999 mount_timeout ceph_options 0 44999 NULL
+disable_so_igmp_start_timer_fndecl_45000 igmp_start_timer fndecl 2 45000 NULL
+disable_so_force_addr_vardecl_via686a_c_45006 force_addr vardecl_via686a.c 0 45006 NULL
+disable_so_ahash_wait_fndecl_45017 ahash_wait fndecl 0-1 45017 NULL
+disable_so_acpi_pm_device_sleep_wake_fndecl_45036 acpi_pm_device_sleep_wake fndecl 0 45036 NULL
+disable_so_palette_qxl_bitmap_45040 palette qxl_bitmap 0 45040 NULL
+disable_so_subdevice_snd_timer_id_45046 subdevice snd_timer_id 0 45046 NULL
+disable_so_demod_address_sp887x_config_45051 demod_address sp887x_config 0 45051 NULL
+disable_so_end_address_acpi_address_range_45053 end_address acpi_address_range 0 45053 NULL
+disable_so_fm_rx_get_band_freq_range_fndecl_45055 fm_rx_get_band_freq_range fndecl 0 45055 NULL
+disable_so_tcp_time_wait_fndecl_45056 tcp_time_wait fndecl 3-2 45056 NULL nohasharray
+disable_so_mlx4_ib_gen_node_guid_fndecl_45056 mlx4_ib_gen_node_guid fndecl 0 45056 &disable_so_tcp_time_wait_fndecl_45056
+disable_so_gpio_get_value_cansleep_fndecl_45065 gpio_get_value_cansleep fndecl 0-1 45065 NULL
+disable_so_max6900_i2c_read_time_fndecl_45069 max6900_i2c_read_time fndecl 0 45069 NULL
+disable_so_sys_futimesat_fndecl_45070 sys_futimesat fndecl 1 45070 NULL
+disable_so_genwqe_debugfs_prev_dbg_uid2_open_fndecl_45072 genwqe_debugfs_prev_dbg_uid2_open fndecl 0 45072 NULL
+disable_so_cmd_attr_register_cpumask_fndecl_45074 cmd_attr_register_cpumask fndecl 0 45074 NULL
+disable_so_hdspm_get_aes_sample_rate_fndecl_45076 hdspm_get_aes_sample_rate fndecl 2 45076 NULL
+disable_so_set_magic_time_fndecl_45079 set_magic_time fndecl 3-2-1 45079 NULL
+disable_so_pci_bus_alloc_from_region_fndecl_45084 pci_bus_alloc_from_region fndecl 5-3-4 45084 NULL
+disable_so_set_pending_timer_val_fndecl_45111 set_pending_timer_val fndecl 2 45111 NULL
+disable_so_i_ctime_nsec_f2fs_inode_45121 i_ctime_nsec f2fs_inode 0 45121 NULL nohasharray
+disable_so_s_mtime_ext3_super_block_45121 s_mtime ext3_super_block 0 45121 &disable_so_i_ctime_nsec_f2fs_inode_45121
+disable_so_inet_csk_reset_keepalive_timer_fndecl_45127 inet_csk_reset_keepalive_timer fndecl 2 45127 NULL
+disable_so_x25_addr_ntoa_fndecl_45136 x25_addr_ntoa fndecl 0 45136 NULL
+disable_so_ltimeout_ia_vcc_45137 ltimeout ia_vcc 0 45137 NULL
+disable_so_high_addr_msgbuf_buf_addr_45142 high_addr msgbuf_buf_addr 0 45142 NULL
+disable_so_pit_calibrate_tsc_fndecl_45149 pit_calibrate_tsc fndecl 0-2 45149 NULL
+disable_so_fw_dma_addr_sproc_45154 fw_dma_addr sproc 0 45154 NULL
+disable_so_addr_lola_bar_45160 addr lola_bar 0 45160 NULL
+disable_so_set_normalized_timespec_fndecl_45161 set_normalized_timespec fndecl 2-3 45161 NULL
+disable_so_lp8788_show_eoc_time_fndecl_45162 lp8788_show_eoc_time fndecl 0 45162 NULL
+disable_so_set_ageing_time_fndecl_45172 set_ageing_time fndecl 2 45172 NULL
+disable_so_address_radio_regs_45181 address radio_regs 0 45181 NULL
+disable_so_do_set_sock_timeout_fndecl_45197 do_set_sock_timeout fndecl 0-5 45197 NULL
+disable_so_bootaddr_mic_device_45198 bootaddr mic_device 0 45198 NULL
+disable_so_ext4_max_bitmap_size_fndecl_45201 ext4_max_bitmap_size fndecl 0-1 45201 NULL
+disable_so_rapl_compute_time_window_atom_fndecl_45202 rapl_compute_time_window_atom fndecl 0-2 45202 NULL
+disable_so_di_atime_nsec_gfs2_dinode_45214 di_atime_nsec gfs2_dinode 0 45214 NULL
+disable_so_watchdog_get_timeout_fndecl_45215 watchdog_get_timeout fndecl 0 45215 NULL
+disable_so_undertime_tc_cbq_xstats_45217 undertime tc_cbq_xstats 0 45217 NULL
+disable_so_trace_clock_fndecl_45219 trace_clock fndecl 0 45219 NULL
+disable_so_usb_bulk_msg_fndecl_45230 usb_bulk_msg fndecl 0-4-2-6 45230 NULL
+disable_so_clock_es1968_45231 clock es1968 0 45231 NULL
+disable_so_fillvaddr_gru_tlb_fault_handle_45245 fillvaddr gru_tlb_fault_handle 0 45245 NULL
+disable_so_blocksize_crypto_report_blkcipher_45248 blocksize crypto_report_blkcipher 0 45248 NULL
+disable_so_cdc_ncm_store_tx_timer_usecs_fndecl_45252 cdc_ncm_store_tx_timer_usecs fndecl 0-4 45252 NULL
+disable_so_uv_nmi_loop_delay_vardecl_uv_nmi_c_45253 uv_nmi_loop_delay vardecl_uv_nmi.c 0 45253 NULL
+disable_so_default_timer_slack_ns_task_struct_45261 default_timer_slack_ns task_struct 0 45261 NULL
+disable_so_tsc_offset_adjustment_kvm_vcpu_arch_45263 tsc_offset_adjustment kvm_vcpu_arch 0 45263 NULL
+disable_so_bf_buf_addr_ath_buf_45279 bf_buf_addr ath_buf 0 45279 NULL
+disable_so_xen_clocksource_read_fndecl_45285 xen_clocksource_read fndecl 0 45285 NULL
+disable_so_iscsi_nacl_attrib_store_dataout_timeout_fndecl_45292 iscsi_nacl_attrib_store_dataout_timeout fndecl 0-3 45292 NULL
+disable_so_r8_kvm_regs_45295 r8 kvm_regs 0 45295 NULL
+disable_so_w1_master_attribute_show_timeout_fndecl_45297 w1_master_attribute_show_timeout fndecl 0 45297 NULL
+disable_so_uuid_show_fallback_fndecl_45299 uuid_show_fallback fndecl 0 45299 NULL
+disable_so_nv04_timer_read_fndecl_45300 nv04_timer_read fndecl 0 45300 NULL
+disable_so_write_port_cfg_addr_mvs_dispatch_45302 write_port_cfg_addr mvs_dispatch 2 45302 NULL
+disable_so_ixgbevf_check_for_bit_vf_fndecl_45303 ixgbevf_check_for_bit_vf fndecl 2 45303 NULL
+disable_so_radio_syn_reserved_addr29_b43_nphy_channeltab_entry_rev3_45310 radio_syn_reserved_addr29 b43_nphy_channeltab_entry_rev3 0 45310 NULL
+disable_so_blkcipher_walk_first_fndecl_45312 blkcipher_walk_first fndecl 0 45312 NULL
+disable_so_add_interrupt_randomness_fndecl_45315 add_interrupt_randomness fndecl 1-2 45315 NULL
+disable_so_lg2160_set_spi_clock_fndecl_45319 lg2160_set_spi_clock fndecl 0 45319 NULL
+disable_so_scaled_div32_fndecl_45321 scaled_div32 fndecl 0-1-2 45321 NULL
+disable_so_spkt_protocol_sockaddr_pkt_45330 spkt_protocol sockaddr_pkt 0 45330 NULL
+disable_so_drain_timeout_xenvif_45332 drain_timeout xenvif 0 45332 NULL
+disable_so_sysctl_tcp_fin_timeout_vardecl_45335 sysctl_tcp_fin_timeout vardecl 0 45335 NULL
+disable_so_dlm_dump_rsb_hash_fndecl_45352 dlm_dump_rsb_hash fndecl 2 45352 NULL
+disable_so_get_idle_time_fndecl_45358 get_idle_time fndecl 1-0 45358 NULL
+disable_so_demod_address_ves1x93_config_45359 demod_address ves1x93_config 0 45359 NULL
+disable_so_hid_sensor_write_samp_freq_value_fndecl_45374 hid_sensor_write_samp_freq_value fndecl 2-3 45374 NULL
+disable_so_tuner_addr_saa7134_dev_45377 tuner_addr saa7134_dev 0 45377 NULL
+disable_so_index_ptp_clock_45382 index ptp_clock 0 45382 NULL
+disable_so_rbd_dev_v2_header_onetime_fndecl_45386 rbd_dev_v2_header_onetime fndecl 0 45386 NULL
+disable_so_xfs_btree_make_block_unfull_fndecl_45388 xfs_btree_make_block_unfull fndecl 3-0 45388 NULL
+disable_so_crypto_shash_setkey_fndecl_45392 crypto_shash_setkey fndecl 0-3 45392 NULL
+disable_so_seq_devkmsg_user_45410 seq devkmsg_user 0 45410 NULL
+disable_so_ad799x_read_frequency_fndecl_45414 ad799x_read_frequency fndecl 0 45414 NULL
+disable_so_gid_ceph_mds_reply_inode_45416 gid ceph_mds_reply_inode 0 45416 NULL
+disable_so_zl10036_set_frequency_fndecl_45420 zl10036_set_frequency fndecl 2 45420 NULL
+disable_so_backlight_duty_cycle_drm_psb_private_45424 backlight_duty_cycle drm_psb_private 0 45424 NULL
+disable_so_devm_kvasprintf_fndecl_45431 devm_kvasprintf fndecl 2 45431 NULL
+disable_so_nvif_object_wr_fndecl_45438 nvif_object_wr fndecl 4-3 45438 NULL
+disable_so_expires_rpc_timer_45444 expires rpc_timer 0 45444 NULL
+disable_so_resource_address_pmcraid_config_table_entry_45452 resource_address pmcraid_config_table_entry 0 45452 NULL nohasharray
+disable_so_timer_active_bfa_fcdiag_qtest_s_45452 timer_active bfa_fcdiag_qtest_s 0 45452 &disable_so_resource_address_pmcraid_config_table_entry_45452 nohasharray
+disable_so_dev_addr_c67x00_td_45452 dev_addr c67x00_td 0 45452 &disable_so_timer_active_bfa_fcdiag_qtest_s_45452
+disable_so_asd_write_reg_word_fndecl_45465 asd_write_reg_word fndecl 2-3 45465 NULL
+disable_so_time_started_btrfs_dev_replace_45480 time_started btrfs_dev_replace 0 45480 NULL
+disable_so_btrfs_add_delayed_tree_ref_fndecl_45481 btrfs_add_delayed_tree_ref fndecl 0-10-3-4-5-6-7 45481 NULL
+disable_so_i2c_addr_fc2580_config_45482 i2c_addr fc2580_config 0 45482 NULL
+disable_so_device_missing_delay__MPT_ADAPTER_45485 device_missing_delay _MPT_ADAPTER 0 45485 NULL
+disable_so_pdiv_skl_wrpll_params_45498 pdiv skl_wrpll_params 0 45498 NULL
+disable_so_fast_RR_timeout_irlap_cb_45499 fast_RR_timeout irlap_cb 0 45499 NULL
+disable_so_usb_control_msg_fndecl_45507 usb_control_msg fndecl 8-0-2-9-5-4-6-3 45507 NULL
+disable_so_cpu_to_vhost16_fndecl_45510 cpu_to_vhost16 fndecl 2 45510 NULL
+disable_so_vma_interval_tree_compute_subtree_last_fndecl_45515 vma_interval_tree_compute_subtree_last fndecl 0 45515 NULL
+disable_so_paddr_mwifiex_evt_buf_desc_45527 paddr mwifiex_evt_buf_desc 0 45527 NULL nohasharray
+disable_so_saddr_lap_cb_45527 saddr lap_cb 0 45527 &disable_so_paddr_mwifiex_evt_buf_desc_45527
+disable_so_nilfs_btree_find_target_v_fndecl_45528 nilfs_btree_find_target_v fndecl 0-3 45528 NULL
+disable_so_pagf_btreeblks_xfs_perag_45534 pagf_btreeblks xfs_perag 0 45534 NULL
+disable_so_reestablish_timeout_rpc_xprt_45538 reestablish_timeout rpc_xprt 0 45538 NULL
+disable_so_show_falltime_fndecl_45545 show_falltime fndecl 0 45545 NULL
+disable_so_tl_time_tcon_link_45553 tl_time tcon_link 0 45553 NULL nohasharray
+disable_so_address_ips_sglist_45553 address ips_sglist 0 45553 &disable_so_tl_time_tcon_link_45553
+disable_so_phy_address_bcmgenet_platform_data_45558 phy_address bcmgenet_platform_data 0 45558 NULL
+disable_so_seq_kern_ipc_perm_45559 seq kern_ipc_perm 0 45559 NULL
+disable_so_verify_cpufreq_driver_45564 verify cpufreq_driver 0 45564 NULL
+disable_so_mcp795_set_time_fndecl_45573 mcp795_set_time fndecl 0 45573 NULL
+disable_so_sw_beacon_response_time_ath9k_ops_config_45576 sw_beacon_response_time ath9k_ops_config 0 45576 NULL
+disable_so_postsleep_min_us_mmc_ioc_cmd_45584 postsleep_min_us mmc_ioc_cmd 0 45584 NULL
+disable_so_write_reg_c_can_priv_45594 write_reg c_can_priv 3 45594 NULL
+disable_so_first_frag_time_prism2_frag_entry_45596 first_frag_time prism2_frag_entry 0 45596 NULL
+disable_so_rsa_init_fndecl_45605 rsa_init fndecl 0 45605 NULL
+disable_so_laddr_c2wr_ae_active_connect_results_45607 laddr c2wr_ae_active_connect_results 0 45607 NULL nohasharray
+disable_so_base_kvm_mtrr_range_45607 base kvm_mtrr_range 0 45607 &disable_so_laddr_c2wr_ae_active_connect_results_45607
+disable_so_readfreq_si476x_rsq_status_report_45610 readfreq si476x_rsq_status_report 0 45610 NULL
+disable_so_gss_krb5_aes_encrypt_fndecl_45613 gss_krb5_aes_encrypt fndecl 0-2 45613 NULL
+disable_so_igmp_ifc_start_timer_fndecl_45616 igmp_ifc_start_timer fndecl 2 45616 NULL
+disable_so_usb_addr_u132_endp_45622 usb_addr u132_endp 0 45622 NULL
+disable_so_manage_tempaddrs_fndecl_45628 manage_tempaddrs fndecl 3-4-6 45628 NULL
+disable_so_win_mask_latch_addr_flash_info_45634 win_mask latch_addr_flash_info 0 45634 NULL
+disable_so_tx_delay_rk_priv_data_45645 tx_delay rk_priv_data 0 45645 NULL
+disable_so_addr_high_viafb_vx855_dma_descr_45656 addr_high viafb_vx855_dma_descr 0 45656 NULL
+disable_so_snd_asihpi_tuner_freq_info_fndecl_45664 snd_asihpi_tuner_freq_info fndecl 0 45664 NULL
+disable_so_spt_assoc_id_sctp_paddrthlds_45665 spt_assoc_id sctp_paddrthlds 0 45665 NULL
+disable_so_xtfpga_i2s_runtime_resume_fndecl_45670 xtfpga_i2s_runtime_resume fndecl 0 45670 NULL
+disable_so_T44_address_mxt_data_45677 T44_address mxt_data 0 45677 NULL
+disable_so_crypto_cbc_encrypt_fndecl_45683 crypto_cbc_encrypt fndecl 0-4 45683 NULL
+disable_so_clockrate_ath_common_45695 clockrate ath_common 0 45695 NULL
+disable_so_wakeup_timer_p54_common_45703 wakeup_timer p54_common 0 45703 NULL
+disable_so_regulator_set_voltage_time_fndecl_45707 regulator_set_voltage_time fndecl 0 45707 NULL
+disable_so_i2c_addr_isl6405_45720 i2c_addr isl6405 0 45720 NULL
+disable_so_allocate_va_range_i915_address_space_45728 allocate_va_range i915_address_space 2-3 45728 NULL
+disable_so_lx_interrupt_test_ack_fndecl_45736 lx_interrupt_test_ack fndecl 0 45736 NULL
+disable_so_set_msr_mce_fndecl_45738 set_msr_mce fndecl 3 45738 NULL
+disable_so_ircomm_tty_start_watchdog_timer_fndecl_45741 ircomm_tty_start_watchdog_timer fndecl 2 45741 NULL
+disable_so_mount_time_nfs_server_45742 mount_time nfs_server 0 45742 NULL
+disable_so_padata_cpu_hash_fndecl_45743 padata_cpu_hash fndecl 0 45743 NULL
+disable_so_mtime_sec_ubifs_ino_node_45747 mtime_sec ubifs_ino_node 0 45747 NULL nohasharray
+disable_so_f1x_map_sysaddr_to_csrow_fndecl_45747 f1x_map_sysaddr_to_csrow fndecl 2 45747 &disable_so_mtime_sec_ubifs_ino_node_45747
+disable_so_set_static_address_fndecl_45752 set_static_address fndecl 0 45752 NULL
+disable_so_cmos_interrupt_fndecl_45753 cmos_interrupt fndecl 1 45753 NULL
+disable_so_addr_buffer_rcv_desc_45761 addr_buffer rcv_desc 0 45761 NULL
+disable_so_leddc_off_time_ssb_sprom_45764 leddc_off_time ssb_sprom 0 45764 NULL
+disable_so_ext4_page_crypto_fndecl_45770 ext4_page_crypto fndecl 4 45770 NULL
+disable_so_dqb_itime_if_dqblk_45773 dqb_itime if_dqblk 0 45773 NULL
+disable_so_addr_nvme_user_io_45777 addr nvme_user_io 0 45777 NULL
+disable_so_split_timeout_jiffies_fw_card_45779 split_timeout_jiffies fw_card 0 45779 NULL
+disable_so_buf_addr_mlx4_ib_create_qp_45781 buf_addr mlx4_ib_create_qp 0 45781 NULL
+disable_so_dax_get_addr_fndecl_45788 dax_get_addr fndecl 0-3 45788 NULL
+disable_so_select_addr_qla8044_minidump_entry_pollrd_45815 select_addr qla8044_minidump_entry_pollrd 0 45815 NULL nohasharray
+disable_so_sis190_get_mac_addr_from_eeprom_fndecl_45815 sis190_get_mac_addr_from_eeprom fndecl 0 45815 &disable_so_select_addr_qla8044_minidump_entry_pollrd_45815
+disable_so_hwt_wait_time_fndecl_45826 hwt_wait_time fndecl 2 45826 NULL
+disable_so_j_timestamp_reiserfs_journal_list_45839 j_timestamp reiserfs_journal_list 0 45839 NULL
+disable_so_kxcjk1013_setup_new_data_interrupt_fndecl_45841 kxcjk1013_setup_new_data_interrupt fndecl 0 45841 NULL
+disable_so_c2_add_addr_fndecl_45842 c2_add_addr fndecl 2-3 45842 NULL
+disable_so_saddr_ip_tunnel_dst_45850 saddr ip_tunnel_dst 0 45850 NULL
+disable_so_timeout_cdrom_generic_command_45854 timeout cdrom_generic_command 0 45854 NULL
+disable_so_tdm_delay_aic3x_priv_45859 tdm_delay aic3x_priv 0 45859 NULL
+disable_so_toshiba_usb_sleep_charge_get_fndecl_45863 toshiba_usb_sleep_charge_get fndecl 0 45863 NULL
+disable_so_acpi_subsys_runtime_resume_fndecl_45871 acpi_subsys_runtime_resume fndecl 0 45871 NULL
+disable_so_azx_command_addr_fndecl_45877 azx_command_addr fndecl 0-1 45877 NULL
+disable_so_node_guid_ib_device_45878 node_guid ib_device 0 45878 NULL
+disable_so_time_unit_rapl_package_45880 time_unit rapl_package 0 45880 NULL
+disable_so_bw_timer_intel_dsi_45883 bw_timer intel_dsi 0 45883 NULL nohasharray
+disable_so_sys_signalfd4_fndecl_45883 sys_signalfd4 fndecl 4 45883 &disable_so_bw_timer_intel_dsi_45883
+disable_so_addr_st_ss_sgitem_45905 addr st_ss_sgitem 0 45905 NULL
+disable_so_setlightfreq_fndecl_45914 setlightfreq fndecl 2 45914 NULL
+disable_so_sis_ata33_program_udma_timings_fndecl_45916 sis_ata33_program_udma_timings fndecl 2 45916 NULL nohasharray
+disable_so_str2hashbuf_fndecl_45916 str2hashbuf fndecl 2 45916 &disable_so_sis_ata33_program_udma_timings_fndecl_45916
+disable_so_presentation_position_register_address_sst_hsw_ipc_stream_alloc_reply_45919 presentation_position_register_address sst_hsw_ipc_stream_alloc_reply 0 45919 NULL
+disable_so_dbm_antsignal_hostap_radiotap_rx_45933 dbm_antsignal hostap_radiotap_rx 0 45933 NULL
+disable_so_time_s5m_rtc_reg_config_45934 time s5m_rtc_reg_config 0 45934 NULL
+disable_so_gro_flush_timeout_show_fndecl_45944 gro_flush_timeout_show fndecl 0 45944 NULL
+disable_so_suid_dumpable_vardecl_45948 suid_dumpable vardecl 0 45948 NULL
+disable_so_sel_addr___pollrd_45957 sel_addr __pollrd 0 45957 NULL
+disable_so_st_atime_nsec_stat_45960 st_atime_nsec stat 0 45960 NULL
+disable_so_mb862xx_i2c_do_address_fndecl_45962 mb862xx_i2c_do_address fndecl 2 45962 NULL nohasharray
+disable_so_radeon_atom_set_engine_dram_timings_fndecl_45962 radeon_atom_set_engine_dram_timings fndecl 2-3 45962 &disable_so_mb862xx_i2c_do_address_fndecl_45962
+disable_so_last_rx_signal_sta_info_45967 last_rx_signal sta_info 0 45967 NULL
+disable_so_current_frequency_lgdt330x_state_45968 current_frequency lgdt330x_state 0 45968 NULL
+disable_so_gpu_addr_radeon_semaphore_45975 gpu_addr radeon_semaphore 0 45975 NULL
+disable_so_hello_time_net_bridge_45982 hello_time net_bridge 0 45982 NULL
+disable_so_suspend_time_ipw2100_priv_45995 suspend_time ipw2100_priv 0 45995 NULL
+disable_so_mtime_nsec_ubifs_ino_node_46001 mtime_nsec ubifs_ino_node 0 46001 NULL
+disable_so_group_cipher_suite_atmel_private_46009 group_cipher_suite atmel_private 0 46009 NULL
+disable_so_fw_hash_fndecl_46017 fw_hash fndecl 0-1 46017 NULL
+disable_so_dualwatch_jiffies_cx18_46022 dualwatch_jiffies cx18 0 46022 NULL nohasharray
+disable_so_ufs_set_inode_gid_fndecl_46022 ufs_set_inode_gid fndecl 3 46022 &disable_so_dualwatch_jiffies_cx18_46022
+disable_so_hw_ptr_snd_rawmidi_runtime_46024 hw_ptr snd_rawmidi_runtime 0 46024 NULL
+disable_so_erst_exec_set_dst_address_base_fndecl_46025 erst_exec_set_dst_address_base fndecl 0 46025 NULL
+disable_so_port_expander_addr_mxl111sf_state_46026 port_expander_addr mxl111sf_state 0 46026 NULL
+disable_so_tea5764_set_freq_fndecl_46030 tea5764_set_freq fndecl 2 46030 NULL
+disable_so_timestamp_nfs4_delegreturndata_46035 timestamp nfs4_delegreturndata 0 46035 NULL
+disable_so_crypto_blkcipher_encrypt_fndecl_46038 crypto_blkcipher_encrypt fndecl 0-4 46038 NULL
+disable_so_sd_set_timing_fndecl_46047 sd_set_timing fndecl 0 46047 NULL
+disable_so_eflags_user_regs_struct32_46056 eflags user_regs_struct32 0 46056 NULL nohasharray
+disable_so_set_wqe_64bit_value_fndecl_46056 set_wqe_64bit_value fndecl 3 46056 &disable_so_eflags_user_regs_struct32_46056
+disable_so_crypto_cbc_encrypt_segment_fndecl_46064 crypto_cbc_encrypt_segment fndecl 0 46064 NULL
+disable_so_f_bavail_kstatfs_46066 f_bavail kstatfs 0 46066 NULL
+disable_so_inet6_dump_ifacaddr_fndecl_46071 inet6_dump_ifacaddr fndecl 0 46071 NULL
+disable_so_dma_addr_ipw_rx_mem_buffer_46073 dma_addr ipw_rx_mem_buffer 0 46073 NULL
+disable_so_rfkill_last_scheduled_vardecl_input_c_46074 rfkill_last_scheduled vardecl_input.c 0 46074 NULL
+disable_so_dma_addr_ntb_transport_mw_46085 dma_addr ntb_transport_mw 0 46085 NULL
+disable_so_qce_ahash_init_fndecl_46087 qce_ahash_init fndecl 0 46087 NULL
+disable_so_lambda_fll_div_46091 lambda fll_div 0 46091 NULL
+disable_so_amd_iommu_enable_interrupts_fndecl_46110 amd_iommu_enable_interrupts fndecl 0 46110 NULL
+disable_so_pineview_clock_fndecl_46122 pineview_clock fndecl 1 46122 NULL
+disable_so_aes_set_key_common_fndecl_46123 aes_set_key_common fndecl 0-4 46123 NULL
+disable_so_max_dwell_time_active_long_conf_scan_settings_46124 max_dwell_time_active_long conf_scan_settings 0 46124 NULL nohasharray
+disable_so_clock_khz_sym_hcb_46124 clock_khz sym_hcb 0 46124 &disable_so_max_dwell_time_active_long_conf_scan_settings_46124
+disable_so_mrp_periodic_time_vardecl_mrp_c_46127 mrp_periodic_time vardecl_mrp.c 0 46127 NULL
+disable_so_mlx5_query_hca_vport_node_guid_fndecl_46128 mlx5_query_hca_vport_node_guid fndecl 0 46128 NULL
+disable_so_xfs_kgid_to_gid_fndecl_46136 xfs_kgid_to_gid fndecl 0 46136 NULL
+disable_so_ata_msleep_fndecl_46137 ata_msleep fndecl 2 46137 NULL
+disable_so_ccp_sha_init_fndecl_46144 ccp_sha_init fndecl 0 46144 NULL
+disable_so___mv88e6xxx_write_addr_fndecl_46145 __mv88e6xxx_write_addr fndecl 0 46145 NULL
+disable_so_wdt_set_time_fndecl_46151 wdt_set_time fndecl 1-0 46151 NULL
+disable_so_first_above_time_codel_vars_46152 first_above_time codel_vars 0 46152 NULL
+disable_so_extclk_freq_max8649_platform_data_46157 extclk_freq max8649_platform_data 0 46157 NULL
+disable_so_init_clocksource_sysfs_fndecl_46161 init_clocksource_sysfs fndecl 0 46161 NULL
+disable_so_escape_clk_div_intel_dsi_46167 escape_clk_div intel_dsi 0 46167 NULL
+disable_so_l2cap_sock_get_sndtimeo_cb_fndecl_46168 l2cap_sock_get_sndtimeo_cb fndecl 0 46168 NULL
+disable_so_ebx_tss_segment_32_46181 ebx tss_segment_32 0 46181 NULL
+disable_so_freq_in_rule_band_fndecl_46182 freq_in_rule_band fndecl 2 46182 NULL
+disable_so_get_signal_to_noise_fndecl_46189 get_signal_to_noise fndecl 0 46189 NULL
+disable_so_bitmap_parse_user_fndecl_46193 bitmap_parse_user fndecl 0-2-4 46193 NULL
+disable_so_queue_delayed_work_fndecl_46205 queue_delayed_work fndecl 3 46205 NULL nohasharray
+e_rtt_us_ack_sample_46205 rtt_us ack_sample 0 46205 &disable_so_queue_delayed_work_fndecl_46205
+disable_so_phy_addr_adf_admin_comms_46206 phy_addr adf_admin_comms 0 46206 NULL nohasharray
+disable_so_hblank_lo_detailed_pixel_timing_46206 hblank_lo detailed_pixel_timing 0 46206 &disable_so_phy_addr_adf_admin_comms_46206
+disable_so_delay_time_NvRamType_46210 delay_time NvRamType 0 46210 NULL
+disable_so_subtree_max_end_memtype_46217 subtree_max_end memtype 0 46217 NULL
+disable_so_i_gid_ext3_inode_46225 i_gid ext3_inode 0 46225 NULL
+disable_so_dma_addr_rx_sw_desc_46234 dma_addr rx_sw_desc 0 46234 NULL
+disable_so_smsc_phy_ack_interrupt_fndecl_46236 smsc_phy_ack_interrupt fndecl 0 46236 NULL
+disable_so_crypto_ctr_setkey_fndecl_46238 crypto_ctr_setkey fndecl 0-3 46238 NULL
+disable_so_ap_beacon_time_iwl_mvm_vif_46241 ap_beacon_time iwl_mvm_vif 0 46241 NULL
+disable_so_phy_addr_base_niu_phy_template_46243 phy_addr_base niu_phy_template 0 46243 NULL
+disable_so_dev_getbyhwaddr_rcu_fndecl_46248 dev_getbyhwaddr_rcu fndecl 2 46248 NULL
+disable_so_delay_time_vardecl_pcnet_cs_c_46250 delay_time vardecl_pcnet_cs.c 0 46250 NULL
+disable_so_from_hash_fndecl_46264 from_hash fndecl 0-1 46264 NULL
+disable_so_lapic_timer_frequency_vardecl_46265 lapic_timer_frequency vardecl 0 46265 NULL
+disable_so_cs35l32_runtime_resume_fndecl_46274 cs35l32_runtime_resume fndecl 0 46274 NULL
+disable_so_clock_high_l3_pins_46276 clock_high l3_pins 0 46276 NULL
+disable_so_snd_opl3_timer2_init_fndecl_46281 snd_opl3_timer2_init fndecl 0-2 46281 NULL
+disable_so_demod_address_mb86a16_config_46282 demod_address mb86a16_config 0 46282 NULL
+disable_so_atime_fuse_attr_46283 atime fuse_attr 0 46283 NULL
+disable_so_blink_time_wm831x_status_46292 blink_time wm831x_status 0 46292 NULL
+disable_so_dm_btree_insert_notify_fndecl_46297 dm_btree_insert_notify fndecl 0-2 46297 NULL
+disable_so__rtl92c_signal_scale_mapping_fndecl_46298 _rtl92c_signal_scale_mapping fndecl 0-2 46298 NULL
+disable_so_usb_port_runtime_suspend_fndecl_46299 usb_port_runtime_suspend fndecl 0 46299 NULL
+disable_so___bitmap_start_sync_fndecl_46300 __bitmap_start_sync fndecl 2-4 46300 NULL
+disable_so_ep_timeout_secs_vardecl_cm_c_46302 ep_timeout_secs vardecl_cm.c 0 46302 NULL
+disable_so_prop_seg_can_bittiming_46312 prop_seg can_bittiming 0 46312 NULL
+disable_so_signalstrength_rtl_stats_46320 signalstrength rtl_stats 0 46320 NULL
+disable_so_xpc_hb_check_timeout_vardecl_xpc_main_c_46327 xpc_hb_check_timeout vardecl_xpc_main.c 0 46327 NULL
+disable_so_creation_time_se_dev_entry_46338 creation_time se_dev_entry 0 46338 NULL
+disable_so_ene_set_tx_duty_cycle_fndecl_46344 ene_set_tx_duty_cycle fndecl 2 46344 NULL
+disable_so_atimensec_fuse_setattr_in_46351 atimensec fuse_setattr_in 0 46351 NULL
+disable_so_ip_mce_46362 ip mce 0 46362 NULL
+disable_so_ntfs_bitmap_clear_run_fndecl_46364 ntfs_bitmap_clear_run fndecl 2-3 46364 NULL
+disable_so_ds1286_read_time_fndecl_46365 ds1286_read_time fndecl 0 46365 NULL
+disable_so_sd_uid_stat_data_v1_46367 sd_uid stat_data_v1 0 46367 NULL
+disable_so_bfa_fcs_lport_ns_sm_gid_ft_fndecl_46369 bfa_fcs_lport_ns_sm_gid_ft fndecl 2 46369 NULL
+disable_so_address_usb_ep_46374 address usb_ep 0 46374 NULL
+disable_so_txctl_measured_time_b43_txpower_lo_control_46377 txctl_measured_time b43_txpower_lo_control 0 46377 NULL
+disable_so_gru_start_paddr_vardecl_46378 gru_start_paddr vardecl 0 46378 NULL
+disable_so_second_timestamp_46379 second timestamp 0 46379 NULL
+disable_so_code_acpi_signal_fatal_info_46389 code acpi_signal_fatal_info 0 46389 NULL
+disable_so_cpu_hrtimer_cpu_base_46390 cpu hrtimer_cpu_base 0 46390 NULL
+disable_so_bcma_chipco_watchdog_timer_set_wdt_fndecl_46396 bcma_chipco_watchdog_timer_set_wdt fndecl 2-0 46396 NULL
+disable_so_check_intr_schedule_fndecl_46403 check_intr_schedule fndecl 2-3-0 46403 NULL
+disable_so_start_mtrr_iter_46427 start mtrr_iter 0 46427 NULL
+disable_so_cp_hqd_pq_wptr_poll_addr_hqd_registers_46430 cp_hqd_pq_wptr_poll_addr hqd_registers 0 46430 NULL
+disable_so_irlap_start_final_timer_fndecl_46431 irlap_start_final_timer fndecl 2 46431 NULL
+disable_so_tuner_pll_address_budget_ci_46436 tuner_pll_address budget_ci 0 46436 NULL
+disable_so_mmc35240_get_samp_freq_index_fndecl_46439 mmc35240_get_samp_freq_index fndecl 0 46439 NULL
+disable_so_addr_qat_alg_buf_46445 addr qat_alg_buf 0 46445 NULL
+disable_so_set_ifa_lifetime_fndecl_46447 set_ifa_lifetime fndecl 3-2 46447 NULL
+disable_so_crypto_authenc_module_init_fndecl_46455 crypto_authenc_module_init fndecl 0 46455 NULL
+disable_so_start_fw_address_region_46456 start fw_address_region 0 46456 NULL
+disable_so_snd_seq_queue_timer_open_fndecl_46460 snd_seq_queue_timer_open fndecl 1 46460 NULL
+disable_so_rt_mutex_lock_interruptible_fndecl_46473 rt_mutex_lock_interruptible fndecl 0 46473 NULL
+disable_so_link_set_timer_fndecl_46475 link_set_timer fndecl 2 46475 NULL
+disable_so_pci_bus_check_dev_fndecl_46486 pci_bus_check_dev fndecl 2 46486 NULL
+disable_so_header_dma_addr_tso_state_46489 header_dma_addr tso_state 0 46489 NULL
+disable_so_get_frequency_dvb_tuner_ops_46496 get_frequency dvb_tuner_ops 0 46496 NULL
+disable_so_eth_prepare_mac_addr_change_fndecl_46501 eth_prepare_mac_addr_change fndecl 0 46501 NULL
+disable_so_nfs_direct_write_schedule_iovec_fndecl_46504 nfs_direct_write_schedule_iovec fndecl 0-3 46504 NULL
+disable_so_sib_sid_mask_sockaddr_ib_46511 sib_sid_mask sockaddr_ib 0 46511 NULL
+disable_so_gc_upcall_timestamp_gss_cred_46522 gc_upcall_timestamp gss_cred 0 46522 NULL
+disable_so_zd_iowrite32a_fndecl_46529 zd_iowrite32a fndecl 0-3 46529 NULL
+disable_so_btrfs_delayed_item_reserve_metadata_fndecl_46535 btrfs_delayed_item_reserve_metadata fndecl 0 46535 NULL
+disable_so_qi_btimelimit_xfs_quotainfo_46536 qi_btimelimit xfs_quotainfo 0 46536 NULL
+disable_so_tick_do_timer_cpu_vardecl_46549 tick_do_timer_cpu vardecl 0 46549 NULL
+disable_so_dma_addr_rsxx_cs_buffer_46558 dma_addr rsxx_cs_buffer 0 46558 NULL
+disable_so_niu_set_hash_opts_fndecl_46560 niu_set_hash_opts fndecl 0 46560 NULL
+disable_so_ext_start_addr_i740fb_par_46564 ext_start_addr i740fb_par 0 46564 NULL nohasharray
+disable_so_s5h1420_setfreqoffset_fndecl_46564 s5h1420_setfreqoffset fndecl 2 46564 &disable_so_ext_start_addr_i740fb_par_46564
+disable_so_find_first_zero_bit_fndecl_46567 find_first_zero_bit fndecl 0-2 46567 NULL
+disable_so_ahd_print_register_fndecl_46568 ahd_print_register fndecl 5 46568 NULL
+disable_so_uid_autofs_v5_packet_46569 uid autofs_v5_packet 0 46569 NULL nohasharray
+disable_so_btrfs_find_delayed_ref_head_fndecl_46569 btrfs_find_delayed_ref_head fndecl 2 46569 &disable_so_uid_autofs_v5_packet_46569
+disable_so_beacon_time_stamp_iwl_rx_phy_res_46571 beacon_time_stamp iwl_rx_phy_res 0 46571 NULL
+disable_so_file_update_time_fndecl_46572 file_update_time fndecl 0 46572 NULL nohasharray
+disable_so_mlx4_bitmap_avail_fndecl_46572 mlx4_bitmap_avail fndecl 0 46572 &disable_so_file_update_time_fndecl_46572
+disable_so_lbase_mtrr_value_46577 lbase mtrr_value 0 46577 NULL
+disable_so_frame_bits_snd_pcm_runtime_46580 frame_bits snd_pcm_runtime 0 46580 NULL
+disable_so_mtrr_write_fndecl_46581 mtrr_write fndecl 3 46581 NULL
+disable_so_dm_btree_find_key_fndecl_46584 dm_btree_find_key fndecl 0-2 46584 NULL
+disable_so_timekeeping_set_tai_offset_fndecl_46587 timekeeping_set_tai_offset fndecl 1 46587 NULL
+disable_so_di_tss_segment_16_46594 di tss_segment_16 0 46594 NULL
+disable_so_tda10071_read_signal_strength_fndecl_46598 tda10071_read_signal_strength fndecl 0 46598 NULL
+disable_so___ipv6_addr_diff64_fndecl_46599 __ipv6_addr_diff64 fndecl 0 46599 NULL
+disable_so_ieee80211_runtime_change_iftype_fndecl_46603 ieee80211_runtime_change_iftype fndecl 0 46603 NULL
+disable_so_get_cpu_idle_time_fndecl_46620 get_cpu_idle_time fndecl 1-0 46620 NULL
+disable_so_max6900_i2c_set_time_fndecl_46626 max6900_i2c_set_time fndecl 0 46626 NULL nohasharray
+disable_so_sha1_ctx_mgr_submit_fndecl_46626 sha1_ctx_mgr_submit fndecl 4 46626 &disable_so_max6900_i2c_set_time_fndecl_46626
+disable_so_effective_len_mlx4_bitmap_46628 effective_len mlx4_bitmap 0 46628 NULL
+disable_so_hours_v4l2_timecode_46630 hours v4l2_timecode 0 46630 NULL
+disable_so_vivid_video_s_frequency_fndecl_46635 vivid_video_s_frequency fndecl 0 46635 NULL
+disable_so_rtpm_active_time_show_fndecl_46638 rtpm_active_time_show fndecl 0 46638 NULL
+disable_so___hw_addr_del_fndecl_46652 __hw_addr_del fndecl 0-3 46652 NULL
+disable_so_lp8788_select_buck_vout_addr_fndecl_46658 lp8788_select_buck_vout_addr fndecl 0-2 46658 NULL
+disable_so___flow_hash_from_keys_fndecl_46659 __flow_hash_from_keys fndecl 0 46659 NULL
+disable_so_addrconf_prefix_route_fndecl_46665 addrconf_prefix_route fndecl 2 46665 NULL
+disable_so_bmg160_runtime_resume_fndecl_46671 bmg160_runtime_resume fndecl 0 46671 NULL
+disable_so_msg_ctime_msqid64_ds_46672 msg_ctime msqid64_ds 0 46672 NULL
+disable_so_pvclock_scale_delta_fndecl_46676 pvclock_scale_delta fndecl 0 46676 NULL
+disable_so_rtsx_usb_switch_clock_fndecl_46677 rtsx_usb_switch_clock fndecl 3-2-0 46677 NULL
+disable_so_kstrtouint_fndecl_46682 kstrtouint fndecl 0 46682 NULL
+disable_so_read_addr_qla82xx_md_entry_queue_46684 read_addr qla82xx_md_entry_queue 0 46684 NULL
+disable_so_depth_blk_align_bitmap_46713 depth blk_align_bitmap 0 46713 NULL
+disable_so_sysctl_aarp_resolve_time_vardecl_46714 sysctl_aarp_resolve_time vardecl 0 46714 NULL nohasharray
+disable_so_zd_iowrite16_locked_fndecl_46714 zd_iowrite16_locked fndecl 0 46714 &disable_so_sysctl_aarp_resolve_time_vardecl_46714
+disable_so_rio_addr_tsi721_tx_desc_46721 rio_addr tsi721_tx_desc 0 46721 NULL
+disable_so_addr_mv_sg_46722 addr mv_sg 0 46722 NULL
+disable_so_plat_get_static_power_cpufreq_cooling_device_46723 plat_get_static_power cpufreq_cooling_device 3 46723 NULL
+disable_so_ebitmap_get_bit_fndecl_46726 ebitmap_get_bit fndecl 2 46726 NULL
+disable_so_st_mtime_compat_stat_46734 st_mtime compat_stat 0 46734 NULL
+disable_so_fw_core_add_address_handler_fndecl_46736 fw_core_add_address_handler fndecl 0 46736 NULL
+disable_so_spc_timelimit_qc_type_state_46739 spc_timelimit qc_type_state 0 46739 NULL
+disable_so_tcp_v4_md5_hash_pseudoheader_fndecl_46749 tcp_v4_md5_hash_pseudoheader fndecl 4 46749 NULL
+disable_so_bfa_get_log_time_fndecl_46750 bfa_get_log_time fndecl 0 46750 NULL
+disable_so_ghash_async_final_fndecl_46752 ghash_async_final fndecl 0 46752 NULL
+disable_so_sadb_address_proto_sadb_address_46755 sadb_address_proto sadb_address 0 46755 NULL
+disable_so_hard_use_expires_seconds_xfrm_lifetime_cfg_46763 hard_use_expires_seconds xfrm_lifetime_cfg 0 46763 NULL nohasharray
+disable_so_addrtype_mt_init_fndecl_46763 addrtype_mt_init fndecl 0 46763 &disable_so_hard_use_expires_seconds_xfrm_lifetime_cfg_46763
+disable_so_ipv6_addr_label_init_fndecl_46770 ipv6_addr_label_init fndecl 0 46770 NULL
+disable_so_nbytes_ccp_sha_req_ctx_46772 nbytes ccp_sha_req_ctx 0 46772 NULL
+disable_so_dr_addr_qla4_83xx_quad_entry_46781 dr_addr qla4_83xx_quad_entry 0 46781 NULL
+disable_so_s_csaddr_ufs_sb_private_info_46789 s_csaddr ufs_sb_private_info 0 46789 NULL
+disable_so_ubi_eba_atomic_leb_change_fndecl_46792 ubi_eba_atomic_leb_change fndecl 0 46792 NULL
+disable_so_qce_crypto_driver_init_fndecl_46810 qce_crypto_driver_init fndecl 0 46810 NULL
+disable_so_uuid_tree_generation_btrfs_super_block_46815 uuid_tree_generation btrfs_super_block 0 46815 NULL
+disable_so_panel_pwr_delay_radeon_encoder_lvds_46816 panel_pwr_delay radeon_encoder_lvds 0 46816 NULL
+disable_so_lambda__fll_div_46826 lambda _fll_div 0 46826 NULL
+disable_so_pre_div__pll_div_46827 pre_div _pll_div 0 46827 NULL
+disable_so_paging32_walk_addr_generic_fndecl_46828 paging32_walk_addr_generic fndecl 4-5 46828 NULL
+disable_so_timeout_brcmf_btcoex_info_46840 timeout brcmf_btcoex_info 0 46840 NULL
+disable_so_toshiba_sleep_functions_status_set_fndecl_46848 toshiba_sleep_functions_status_set fndecl 0 46848 NULL
+disable_so_i_gid_exofs_fcb_46849 i_gid exofs_fcb 0 46849 NULL
+disable_so_mounted_uid_compat_ncp_fs_info_v2_46851 mounted_uid compat_ncp_fs_info_v2 0 46851 NULL
+disable_so_ecryptfs_process_key_cipher_fndecl_46863 ecryptfs_process_key_cipher fndecl 0 46863 NULL
+disable_so_tuner_address_stb6100_config_46865 tuner_address stb6100_config 0 46865 NULL
+disable_so_clk_div_ti_tscadc_dev_46872 clk_div ti_tscadc_dev 0 46872 NULL
+disable_so_last_change_time_lpfc_nodelist_46878 last_change_time lpfc_nodelist 0 46878 NULL
+disable_so_addr_mthca_catas_err_46893 addr mthca_catas_err 0 46893 NULL
+disable_so_card_snd_timer_ginfo_46895 card snd_timer_ginfo 0 46895 NULL
+disable_so_svm_set_tsc_khz_fndecl_46900 svm_set_tsc_khz fndecl 2 46900 NULL
+disable_so_buffer_addr_atl1c_tpd_desc_46908 buffer_addr atl1c_tpd_desc 0 46908 NULL
+disable_so_last_expires_snd_timer_system_private_46917 last_expires snd_timer_system_private 0 46917 NULL
+disable_so___arch_hweight16_fndecl_46932 __arch_hweight16 fndecl 0-1 46932 NULL
+disable_so_clockevent_delta2ns_fndecl_46934 clockevent_delta2ns fndecl 1-0 46934 NULL
+disable_so_addr_PVSCSISGElement_46942 addr PVSCSISGElement 0 46942 NULL nohasharray
+disable_so_bg_inode_bitmap_hi_ext4_group_desc_46942 bg_inode_bitmap_hi ext4_group_desc 0 46942 &disable_so_addr_PVSCSISGElement_46942
+disable_so_ai_clkctl_fast_pwrup_delay_fndecl_46950 ai_clkctl_fast_pwrup_delay fndecl 0 46950 NULL
+disable_so_demod_address_mb86a20s_config_46954 demod_address mb86a20s_config 0 46954 NULL
+disable_so_ebitmap_set_bit_fndecl_46955 ebitmap_set_bit fndecl 0-2 46955 NULL
+disable_so_set_eth_addr_fndecl_46958 set_eth_addr fndecl 0 46958 NULL
+disable_so_ghash_async_setkey_fndecl_46962 ghash_async_setkey fndecl 0-3 46962 NULL
+disable_so_hid_time_platform_driver_init_fndecl_46963 hid_time_platform_driver_init fndecl 0 46963 NULL
+disable_so_ad9523_set_clock_provider_fndecl_46979 ad9523_set_clock_provider fndecl 2-0-3 46979 NULL
+disable_so_pbl_addr_tpt_attributes_46980 pbl_addr tpt_attributes 0 46980 NULL
+disable_so_ts_dev_1_peak_time_ref_46981 ts_dev_1 peak_time_ref 0 46981 NULL
+disable_so_buff_phy_addr_amd8111e_rx_dr_46984 buff_phy_addr amd8111e_rx_dr 0 46984 NULL
+disable_so_scan_index_timestamp_iio_dev_46989 scan_index_timestamp iio_dev 0 46989 NULL
+disable_so_ceph_str_hash_linux_fndecl_46991 ceph_str_hash_linux fndecl 0-2 46991 NULL
+disable_so_compq_addr_hi_addr_ctrl_blk_46993 compq_addr_hi addr_ctrl_blk 0 46993 NULL
+disable_so_ctime_sec_ubifs_ino_node_46994 ctime_sec ubifs_ino_node 0 46994 NULL
+disable_so_ring_addr_fe_priv_46998 ring_addr fe_priv 0 46998 NULL
+disable_so_scratch_addr_dwc3_47001 scratch_addr dwc3 0 47001 NULL
+disable_so_be_vf_eth_addr_config_fndecl_47005 be_vf_eth_addr_config fndecl 0 47005 NULL
+disable_so_timeout_pardevice_47010 timeout pardevice 0 47010 NULL
+disable_so_crypto_aes_set_key_fndecl_47018 crypto_aes_set_key fndecl 3 47018 NULL
+disable_so_esp_cur_dma_addr_fndecl_47025 esp_cur_dma_addr fndecl 0 47025 NULL
+disable_so_ba1_addr_snd_cs46xx_47035 ba1_addr snd_cs46xx 0 47035 NULL
+disable_so_decode_bitmap_c_fndecl_47038 decode_bitmap_c fndecl 0-4 47038 NULL
+disable_so_NCR5380_set_timer_fndecl_47039 NCR5380_set_timer fndecl 2 47039 NULL
+disable_so_schedule_copy_fndecl_47040 schedule_copy fndecl 2-4-5-8 47040 NULL
+disable_so_ipath_sdma_abort_jiffies_ipath_devdata_47057 ipath_sdma_abort_jiffies ipath_devdata 0 47057 NULL nohasharray
+disable_so_rpi_paddr_hi_lpfc_mbx_post_hdr_tmpl_47057 rpi_paddr_hi lpfc_mbx_post_hdr_tmpl 0 47057 &disable_so_ipath_sdma_abort_jiffies_ipath_devdata_47057
+disable_so_address_acpi_dmar_hardware_unit_47065 address acpi_dmar_hardware_unit 0 47065 NULL
+disable_so_try_address_fndecl_47083 try_address fndecl 2-3 47083 NULL
+disable_so_mclk_freq_codec_priv_47084 mclk_freq codec_priv 0 47084 NULL
+disable_so_diva_os_get_pci_bus_fndecl_47095 diva_os_get_pci_bus fndecl 0 47095 NULL
+disable_so_shm_atime_shmid64_ds_47100 shm_atime shmid64_ds 0 47100 NULL
+disable_so_tag_reg_addr_qla8044_minidump_entry_cache_47106 tag_reg_addr qla8044_minidump_entry_cache 0 47106 NULL
+disable_so_timestamp_hi_mlx4_ts_cqe_47113 timestamp_hi mlx4_ts_cqe 0 47113 NULL nohasharray
+disable_so_pcap_rtc_read_time_fndecl_47113 pcap_rtc_read_time fndecl 0 47113 &disable_so_timestamp_hi_mlx4_ts_cqe_47113
+disable_so_xircom_interrupt_fndecl_47114 xircom_interrupt fndecl 1 47114 NULL
+disable_so_atombios_crtc_set_base_atomic_fndecl_47122 atombios_crtc_set_base_atomic fndecl 0-3-4 47122 NULL
+disable_so_ath5k_eeprom_init_11a_pcal_freq_fndecl_47134 ath5k_eeprom_init_11a_pcal_freq fndecl 0 47134 NULL
+disable_so_tcs3472_show_int_time_available_fndecl_47135 tcs3472_show_int_time_available fndecl 0 47135 NULL
+disable_so_freq_cx88_core_47137 freq cx88_core 0 47137 NULL
+disable_so_gen6_signal_fndecl_47138 gen6_signal fndecl 0-2 47138 NULL
+disable_so_wlc_lcnphy_rx_signal_power_fndecl_47140 wlc_lcnphy_rx_signal_power fndecl 0 47140 NULL
+disable_so_sq_size_log2_t3_wq_47146 sq_size_log2 t3_wq 0 47146 NULL
+disable_so_rht_head_hashfn_fndecl_47148 rht_head_hashfn fndecl 0 47148 NULL
+disable_so_core_frequency_acpi_processor_px_47149 core_frequency acpi_processor_px 0 47149 NULL
+disable_so_nilfs_btree_do_lookup_last_fndecl_47151 nilfs_btree_do_lookup_last fndecl 0 47151 NULL
+disable_so_last_intr_timestamp_ctlr_info_47154 last_intr_timestamp ctlr_info 0 47154 NULL
+disable_so_curr_freq_rt2x00_dev_47156 curr_freq rt2x00_dev 0 47156 NULL
+disable_so_uid_cf_mod_47160 uid cf_mod 0 47160 NULL
+disable_so_rem_mceusb_dev_47168 rem mceusb_dev 0 47168 NULL
+disable_so_lpphy_qdiv_roundup_fndecl_47185 lpphy_qdiv_roundup fndecl 0-2-1 47185 NULL
+disable_so_start_phys_addr_qxl_memslot_47196 start_phys_addr qxl_memslot 0 47196 NULL
+disable_so_update_ia32_tsc_adjust_msr_fndecl_47211 update_ia32_tsc_adjust_msr fndecl 2 47211 NULL
+disable_so_radeon_atom_set_engine_clock_fndecl_47215 radeon_atom_set_engine_clock fndecl 2 47215 NULL
+disable_so_mtt_base_addr_l_mlx4_qp_context_47232 mtt_base_addr_l mlx4_qp_context 0 47232 NULL
+disable_so_mtt_base_addr_h_mlx4_srq_context_47233 mtt_base_addr_h mlx4_srq_context 0 47233 NULL
+disable_so_init_cpufreq_driver_47242 init cpufreq_driver 0 47242 NULL
+disable_so_gpio_nsleep_auok190x_board_47243 gpio_nsleep auok190x_board 0 47243 NULL
+disable_so_il4965_count_chain_bitmap_fndecl_47252 il4965_count_chain_bitmap fndecl 0-1 47252 NULL
+disable_so_fl_downgrade_time_file_lock_47257 fl_downgrade_time file_lock 0 47257 NULL
+disable_so_get_low_record_time_index_fndecl_47259 get_low_record_time_index fndecl 2 47259 NULL
+disable_so_efx_ptp_get_timestamp_corrections_fndecl_47266 efx_ptp_get_timestamp_corrections fndecl 0 47266 NULL nohasharray
+disable_so_hactive_timing_47266 hactive timing 0 47266 &disable_so_efx_ptp_get_timestamp_corrections_fndecl_47266
+disable_so_feedback_divider_aty128_pll_47275 feedback_divider aty128_pll 0 47275 NULL
+disable_so_daddr_max_pktgen_dev_47293 daddr_max pktgen_dev 0 47293 NULL
+disable_so_addr_ce_desc_47294 addr ce_desc 0 47294 NULL
+disable_so_val_addr0_nphy_rf_control_override_rev3_47315 val_addr0 nphy_rf_control_override_rev3 0 47315 NULL
+disable_so_SYSC_time_fndecl_47318 SYSC_time fndecl 0 47318 NULL
+disable_so_device_addr_hw_cmd_47322 device_addr hw_cmd 0 47322 NULL
+disable_so_cryptd_hash_init_fndecl_47329 cryptd_hash_init fndecl 2 47329 NULL
+disable_so_hpfs_add_sector_to_btree_fndecl_47344 hpfs_add_sector_to_btree fndecl 0-2-4 47344 NULL
+disable_so_vref_delay_usecs_ad7877_47346 vref_delay_usecs ad7877 0 47346 NULL
+disable_so_jiftime_fndecl_47359 jiftime fndecl 2 47359 NULL
+disable_so_year_timestamp_47377 year timestamp 0 47377 NULL
+disable_so_rt_runtime_rt_bandwidth_47380 rt_runtime rt_bandwidth 0 47380 NULL
+disable_so_team_port_set_orig_dev_addr_fndecl_47381 team_port_set_orig_dev_addr fndecl 0 47381 NULL
+disable_so_ldt_selector_tss_segment_32_47382 ldt_selector tss_segment_32 0 47382 NULL
+disable_so_atomic_check_drm_plane_helper_funcs_47383 atomic_check drm_plane_helper_funcs 0 47383 NULL
+disable_so_ath9k_hw_set_global_txtimeout_fndecl_47387 ath9k_hw_set_global_txtimeout fndecl 2 47387 NULL
+disable_so_crypto_blkcipher_setkey_fndecl_47393 crypto_blkcipher_setkey fndecl 0-3 47393 NULL
+disable_so_signal_libipw_rx_stats_47394 signal libipw_rx_stats 0 47394 NULL
+disable_so_wm831x_rtc_readtime_fndecl_47406 wm831x_rtc_readtime fndecl 0 47406 NULL nohasharray
+disable_so_reg_write_fndecl_47406 reg_write fndecl 2 47406 &disable_so_wm831x_rtc_readtime_fndecl_47406
+disable_so_rx_int_delay_e1000_adapter_47412 rx_int_delay e1000_adapter 0 47412 NULL
+disable_so_watchdog_timeo_net_device_47415 watchdog_timeo net_device 0 47415 NULL
+disable_so_m_hi_cfg_bridge_delay_drxk_state_47416 m_hi_cfg_bridge_delay drxk_state 0 47416 NULL
+disable_so_xfs_btree_get_rec_fndecl_47417 xfs_btree_get_rec fndecl 0 47417 NULL
+disable_so_del_timer_fndecl_47421 del_timer fndecl 0 47421 NULL
+disable_so_cq_dma_addr_nvme_queue_47424 cq_dma_addr nvme_queue 0 47424 NULL nohasharray
+disable_so_pci_bus_write_config_byte_fndecl_47424 pci_bus_write_config_byte fndecl 0-2-3-4 47424 &disable_so_cq_dma_addr_nvme_queue_47424
+disable_so_printk_timed_ratelimit_fndecl_47432 printk_timed_ratelimit fndecl 2 47432 NULL
+disable_so_addr_high_bufq_addr_element_47437 addr_high bufq_addr_element 0 47437 NULL
+disable_so_snd_seq_oss_timer_tempo_fndecl_47444 snd_seq_oss_timer_tempo fndecl 0 47444 NULL
+disable_so_radeon_atom_get_memory_pll_dividers_fndecl_47447 radeon_atom_get_memory_pll_dividers fndecl 0-2 47447 NULL
+disable_so_vdi_atime_vxfs_inode_info_47463 vdi_atime vxfs_inode_info 0 47463 NULL nohasharray
+disable_so_timestamp_iwl_priv_47463 timestamp iwl_priv 0 47463 &disable_so_vdi_atime_vxfs_inode_info_47463
+disable_so_ts_steal_jiffies_gru_thread_state_47477 ts_steal_jiffies gru_thread_state 0 47477 NULL
+disable_so_brcms_c_set_addrmatch_fndecl_47479 brcms_c_set_addrmatch fndecl 2 47479 NULL
+disable_so_cia_max_keysize_cipher_alg_47480 cia_max_keysize cipher_alg 0 47480 NULL
+disable_so_inet_addr_type_fndecl_47499 inet_addr_type fndecl 2 47499 NULL
+disable_so_sd_atime_stat_data_47502 sd_atime stat_data 0 47502 NULL
+disable_so_tcf_hash_create_fndecl_47512 tcf_hash_create fndecl 0-4 47512 NULL
+disable_so_addr_low_ssp_ini_io_start_req_47520 addr_low ssp_ini_io_start_req 0 47520 NULL nohasharray
+disable_so_mlx4_bitmap_free_range_fndecl_47520 mlx4_bitmap_free_range fndecl 2-3 47520 &disable_so_addr_low_ssp_ini_io_start_req_47520
+disable_so___xfrm4_dpref_spref_hash_fndecl_47524 __xfrm4_dpref_spref_hash fndecl 0 47524 NULL
+disable_so_error_info_addr_mvm_alive_resp_ver2_47529 error_info_addr mvm_alive_resp_ver2 0 47529 NULL
+disable_so_idle_freq_intel_gen6_power_mgmt_47531 idle_freq intel_gen6_power_mgmt 0 47531 NULL
+disable_so_regidx_ath9k_debug_47533 regidx ath9k_debug 0 47533 NULL
+disable_so___delay_fndecl_47535 __delay fndecl 1 47535 NULL
+disable_so_gid_vardecl_initramfs_c_47557 gid vardecl_initramfs.c 0 47557 NULL
+disable_so_channel_freq_wmi_scan_ev_arg_47561 channel_freq wmi_scan_ev_arg 0 47561 NULL nohasharray
+disable_so_rx_hash_log_tbl_sz_mlx5e_params_47561 rx_hash_log_tbl_sz mlx5e_params 0 47561 &disable_so_channel_freq_wmi_scan_ev_arg_47561
+disable_so_addr_high_sata_start_req_47563 addr_high sata_start_req 0 47563 NULL nohasharray
+disable_so_addr_pages_devres_47563 addr pages_devres 0 47563 &disable_so_addr_high_sata_start_req_47563
+disable_so_min_align_snd_pcm_runtime_47579 min_align snd_pcm_runtime 0 47579 NULL nohasharray
+disable_so_dev_set_mac_address_fndecl_47579 dev_set_mac_address fndecl 0 47579 &disable_so_min_align_snd_pcm_runtime_47579
+disable_so_sip_sprintf_addr_port_fndecl_47581 sip_sprintf_addr_port fndecl 0-4 47581 NULL
+disable_so_physical_addr_cper_sec_mem_err_47582 physical_addr cper_sec_mem_err 0 47582 NULL nohasharray
+disable_so_log2taps_oslec_state_47582 log2taps oslec_state 0 47582 &disable_so_physical_addr_cper_sec_mem_err_47582
+disable_so_rehash_time_sfb_sched_data_47586 rehash_time sfb_sched_data 0 47586 NULL nohasharray
+disable_so_x25_parse_address_block_fndecl_47586 x25_parse_address_block fndecl 0 47586 &disable_so_rehash_time_sfb_sched_data_47586
+disable_so_write_reg_fndecl_47589 write_reg fndecl 3-2 47589 NULL
+disable_so_buffer_addr_tx_packet_desc_47592 buffer_addr tx_packet_desc 0 47592 NULL
+disable_so_xfs_iomap_write_delay_fndecl_47595 xfs_iomap_write_delay fndecl 0-2-3 47595 NULL
+disable_so_valleyview_rps_min_freq_fndecl_47598 valleyview_rps_min_freq fndecl 0 47598 NULL
+disable_so_eft_addr_h_qla2xxx_fw_dump_47600 eft_addr_h qla2xxx_fw_dump 0 47600 NULL
+disable_so_tms_cstime_tms_47604 tms_cstime tms 0 47604 NULL nohasharray
+disable_so_btrfs_node_key_to_cpu_fndecl_47604 btrfs_node_key_to_cpu fndecl 3 47604 &disable_so_tms_cstime_tms_47604
+disable_so_base_reg_regcache_rbtree_node_47612 base_reg regcache_rbtree_node 0 47612 NULL
+disable_so_bd_list_addr_lo_bnx2i_cmd_request_47615 bd_list_addr_lo bnx2i_cmd_request 0 47615 NULL
+disable_so_ltr501_ps_read_samp_freq_fndecl_47616 ltr501_ps_read_samp_freq fndecl 0 47616 NULL
+disable_so_freq_pulse_event_47630 freq pulse_event 0 47630 NULL
+disable_so_ixgbe_set_rss_hash_opt_fndecl_47632 ixgbe_set_rss_hash_opt fndecl 0 47632 NULL
+disable_so_timeout_vardecl_hvc_console_c_47646 timeout vardecl_hvc_console.c 0 47646 NULL
+disable_so_buffer_addr_e1000_tx_desc_47648 buffer_addr e1000_tx_desc 0 47648 NULL
+disable_so_keyctl_set_timeout_fndecl_47649 keyctl_set_timeout fndecl 2-1-0 47649 NULL
+disable_so_cfg80211_wext_siwfreq_fndecl_47653 cfg80211_wext_siwfreq fndecl 0 47653 NULL
+disable_so_dw_wdt_time_left_fndecl_47654 dw_wdt_time_left fndecl 0 47654 NULL
+disable_so_tstep_addr_palmas_regs_info_47657 tstep_addr palmas_regs_info 0 47657 NULL
+disable_so_frac_period_rest_dummy_systimer_pcm_47674 frac_period_rest dummy_systimer_pcm 0 47674 NULL
+disable_so_fill_bitmap_rle_bits_fndecl_47678 fill_bitmap_rle_bits fndecl 0 47678 NULL
+disable_so_set_timebase_fndecl_47679 set_timebase fndecl 1 47679 NULL
+disable_so_i2c_addr_tua9001_config_47682 i2c_addr tua9001_config 0 47682 NULL
+disable_so_time_scan_survey_info_47684 time_scan survey_info 0 47684 NULL
+disable_so_lzo_decompress_fndecl_47694 lzo_decompress fndecl 2 47694 NULL
+disable_so_hsync_pulse_width_lvds_dvo_timing_47698 hsync_pulse_width lvds_dvo_timing 0 47698 NULL
+disable_so_bdc_address_device_fndecl_47704 bdc_address_device fndecl 0-2 47704 NULL
+disable_so_base_addr_ivtv_47705 base_addr ivtv 0 47705 NULL
+disable_so_clock_start_soc_camera_host_ops_47707 clock_start soc_camera_host_ops 0 47707 NULL
+disable_so_enum_dv_timings_v4l2_subdev_pad_ops_47708 enum_dv_timings v4l2_subdev_pad_ops 0 47708 NULL nohasharray
+disable_so_crypto_authenc_esn_encrypt_fndecl_47708 crypto_authenc_esn_encrypt fndecl 0 47708 &disable_so_enum_dv_timings_v4l2_subdev_pad_ops_47708
+disable_so_rv740_get_mclk_frequency_ratio_fndecl_47715 rv740_get_mclk_frequency_ratio fndecl 0-1 47715 NULL
+disable_so_lola_set_clock_fndecl_47716 lola_set_clock fndecl 0 47716 NULL
+disable_so_hid_rtc_read_time_fndecl_47725 hid_rtc_read_time fndecl 0 47725 NULL
+disable_so_ext4_update_other_inodes_time_fndecl_47730 ext4_update_other_inodes_time fndecl 2 47730 NULL
+disable_so_uartlite_inbe32_fndecl_47739 uartlite_inbe32 fndecl 0 47739 NULL
+disable_so_tm_yday_rtc_time_47740 tm_yday rtc_time 0 47740 NULL
+disable_so_snd_azf3328_timer_fndecl_47746 snd_azf3328_timer fndecl 0-2 47746 NULL
+disable_so_pci_bus_atto_channel_info_47747 pci_bus atto_channel_info 0 47747 NULL
+disable_so_control_addr_qla8044_minidump_entry_cache_47750 control_addr qla8044_minidump_entry_cache 0 47750 NULL
+disable_so_bit_enables_uv1h_lb_target_physical_apic_id_mask_s_47755 bit_enables uv1h_lb_target_physical_apic_id_mask_s 0 47755 NULL
+disable_so_tx_ring_dma_addr_amd8111e_priv_47757 tx_ring_dma_addr amd8111e_priv 0 47757 NULL
+disable_so_frac_period_size_dummy_systimer_pcm_47758 frac_period_size dummy_systimer_pcm 0 47758 NULL
+disable_so_inet6_addr_add_fndecl_47759 inet6_addr_add fndecl 0-2-5-7-8-6 47759 NULL
+disable_so_initial_descriptor_timeout_vardecl_hub_c_47763 initial_descriptor_timeout vardecl_hub.c 0 47763 NULL
+disable_so_nbytes_ccp_aes_cmac_req_ctx_47773 nbytes ccp_aes_cmac_req_ctx 0 47773 NULL
+disable_so_account_idle_time_fndecl_47777 account_idle_time fndecl 1 47777 NULL
+disable_so_ip_addr_nes_arp_entry_47790 ip_addr nes_arp_entry 0 47790 NULL
+disable_so_sha1_generic_mod_init_fndecl_47800 sha1_generic_mod_init fndecl 0 47800 NULL
+disable_so_nla_validate_nested_fndecl_47801 nla_validate_nested fndecl 2-0 47801 NULL
+disable_so_enable_refdiv_dibx000_bandwidth_config_47815 enable_refdiv dibx000_bandwidth_config 0 47815 NULL
+disable_so_demod_address_cx24123_config_47819 demod_address cx24123_config 0 47819 NULL
+disable_so_alloc_usb_address_fndecl_47822 alloc_usb_address fndecl 0 47822 NULL
+disable_so_compat_sys_signalfd_fndecl_47830 compat_sys_signalfd fndecl 0 47830 NULL
+disable_so_silence_filled_snd_pcm_runtime_47852 silence_filled snd_pcm_runtime 0 47852 NULL nohasharray
+disable_so_demod_addr_tm6000_core_47852 demod_addr tm6000_core 0 47852 &disable_so_silence_filled_snd_pcm_runtime_47852
+disable_so___net_get_random_once_fndecl_47854 __net_get_random_once fndecl 2 47854 NULL
+disable_so_add_device_randomness_fndecl_47860 add_device_randomness fndecl 2 47860 NULL nohasharray
+disable_so_put_dec_trunc8_fndecl_47860 put_dec_trunc8 fndecl 2 47860 &disable_so_add_device_randomness_fndecl_47860
+disable_so___ntfs_bitmap_set_bits_in_run_fndecl_47864 __ntfs_bitmap_set_bits_in_run fndecl 2-3 47864 NULL
+disable_so_qce_ahash_digest_fndecl_47873 qce_ahash_digest fndecl 0 47873 NULL
+disable_so_i_gid_f2fs_inode_47888 i_gid f2fs_inode 0 47888 NULL
+disable_so_currentfreq_s921_state_47895 currentfreq s921_state 0 47895 NULL
+disable_so_dma_ring_addr_i40e_virtchnl_rxq_info_47897 dma_ring_addr i40e_virtchnl_rxq_info 0 47897 NULL
+disable_so_qla82xx_decode_crb_addr_fndecl_47901 qla82xx_decode_crb_addr fndecl 0-1 47901 NULL
+disable_so_xtal_cap20p_r820t_freq_range_47903 xtal_cap20p r820t_freq_range 0 47903 NULL
+disable_so_drbd_uuid_dump_fndecl_47904 drbd_uuid_dump fndecl 4 47904 NULL
+disable_so_host_addr_gnttab_unmap_grant_ref_47911 host_addr gnttab_unmap_grant_ref 0 47911 NULL
+disable_so_crypto_ccm_setkey_fndecl_47913 crypto_ccm_setkey fndecl 0-3 47913 NULL
+disable_so_ipath_sdma_abort_intr_timeout_ipath_devdata_47922 ipath_sdma_abort_intr_timeout ipath_devdata 0 47922 NULL
+disable_so_think_time_usb_tt_47928 think_time usb_tt 0 47928 NULL
+disable_so_vaddr_ib_reth_47929 vaddr ib_reth 0 47929 NULL
+disable_so_num_clock_sources_echoaudio_47930 num_clock_sources echoaudio 0 47930 NULL nohasharray
+disable_so_shutdwn_delay_cs42l73_private_47930 shutdwn_delay cs42l73_private 0 47930 &disable_so_num_clock_sources_echoaudio_47930
+disable_so_count_bitmaps_fndecl_47942 count_bitmaps fndecl 0 47942 NULL
+disable_so_crypto_aead_ivsize_fndecl_47945 crypto_aead_ivsize fndecl 0 47945 NULL
+disable_so_rs5c348_rtc_read_time_fndecl_47948 rs5c348_rtc_read_time fndecl 0 47948 NULL
+disable_so_kvm_set_lapic_tscdeadline_msr_fndecl_47952 kvm_set_lapic_tscdeadline_msr fndecl 2 47952 NULL
+disable_so_ext4_inode_bitmap_set_fndecl_47957 ext4_inode_bitmap_set fndecl 3 47957 NULL
+disable_so_sysctl_llc2_busy_timeout_vardecl_47965 sysctl_llc2_busy_timeout vardecl 0 47965 NULL
+disable_so_atl2_hash_mc_addr_fndecl_47966 atl2_hash_mc_addr fndecl 0 47966 NULL
+disable_so_wm97xx_reg_write_fndecl_47973 wm97xx_reg_write fndecl 3-2 47973 NULL
+disable_so_isci_setup_interrupts_fndecl_47977 isci_setup_interrupts fndecl 0 47977 NULL
+disable_so_hdmi_mode_alternate_clock_fndecl_47981 hdmi_mode_alternate_clock fndecl 0 47981 NULL
+disable_so_xhci_address_device_fndecl_47987 xhci_address_device fndecl 0 47987 NULL
+disable_so_snd_timer_start1_fndecl_47992 snd_timer_start1 fndecl 3-0 47992 NULL
+disable_so_timing_setup_fndecl_48002 timing_setup fndecl 3-4 48002 NULL
+disable_so_clk_freq_g762_platform_data_48004 clk_freq g762_platform_data 0 48004 NULL
+disable_so_sh_addralign_elf64_shdr_48012 sh_addralign elf64_shdr 0 48012 NULL nohasharray
+disable_so_crypto_aead_reqsize_fndecl_48012 crypto_aead_reqsize fndecl 0 48012 &disable_so_sh_addralign_elf64_shdr_48012
+disable_so_qlcnic_82xx_get_mac_address_fndecl_48015 qlcnic_82xx_get_mac_address fndecl 0 48015 NULL
+disable_so_frequency_dvb_pll_priv_48016 frequency dvb_pll_priv 0 48016 NULL
+disable_so_i915_min_freq_set_fndecl_48019 i915_min_freq_set fndecl 2-0 48019 NULL
+disable_so_slave_addr_psb_intel_sdvo_48022 slave_addr psb_intel_sdvo 0 48022 NULL
+disable_so_si_get_ddr3_mclk_frequency_ratio_fndecl_48025 si_get_ddr3_mclk_frequency_ratio fndecl 0-1 48025 NULL
+disable_so_lgdt3306a_fe_sleep_fndecl_48026 lgdt3306a_fe_sleep fndecl 0 48026 NULL
+disable_so_ctnl_timeout_fill_info_fndecl_48030 ctnl_timeout_fill_info fndecl 3-5-0-2 48030 NULL
+disable_so_r69_val_fc2580_freq_regs_48037 r69_val fc2580_freq_regs 0 48037 NULL nohasharray
+disable_so_btree_lookup32_fndecl_48037 btree_lookup32 fndecl 2 48037 &disable_so_r69_val_fc2580_freq_regs_48037
+disable_so_reservation_object_wait_timeout_rcu_fndecl_48039 reservation_object_wait_timeout_rcu fndecl 0-4 48039 NULL
+disable_so_utimescaled_task_struct_48041 utimescaled task_struct 0 48041 NULL
+disable_so_hrtimer_init_fndecl_48048 hrtimer_init fndecl 2 48048 NULL
+disable_so_regmap_bulk_write_fndecl_48058 regmap_bulk_write fndecl 0-2-4 48058 NULL
+disable_so_rt_saddr_dn_route_48062 rt_saddr dn_route 0 48062 NULL
+disable_so_ring_interrupt_index_fndecl_48065 ring_interrupt_index fndecl 0 48065 NULL nohasharray
+disable_so_dclk_freq_i7core_pvt_48065 dclk_freq i7core_pvt 0 48065 &disable_so_ring_interrupt_index_fndecl_48065
+disable_so_di_atime_gfs2_dinode_48066 di_atime gfs2_dinode 0 48066 NULL
+disable_so_be32_add_cpu_fndecl_48069 be32_add_cpu fndecl 2 48069 NULL
+disable_so_keepalive_time_tcp_sock_48076 keepalive_time tcp_sock 0 48076 NULL nohasharray
+disable_so_mptscsih_get_tm_timeout_fndecl_48076 mptscsih_get_tm_timeout fndecl 0 48076 &disable_so_keepalive_time_tcp_sock_48076
+disable_so_set_channel_address_fndecl_48079 set_channel_address fndecl 2-3 48079 NULL
+disable_so_clock_vardecl_max6650_c_48080 clock vardecl_max6650.c 0 48080 NULL
+disable_so_mapped_loc_addr_nes_cm_node_48083 mapped_loc_addr nes_cm_node 0 48083 NULL
+disable_so___br_ip6_hash_fndecl_48084 __br_ip6_hash fndecl 0 48084 NULL
+disable_so_si4713_tx_tune_freq_fndecl_48092 si4713_tx_tune_freq fndecl 0-2 48092 NULL
+disable_so_wait_for_completion_killable_timeout_fndecl_48103 wait_for_completion_killable_timeout fndecl 2-0 48103 NULL
+disable_so_lpfc_max_scsicmpl_time_init_fndecl_48110 lpfc_max_scsicmpl_time_init fndecl 2 48110 NULL
+disable_so_lib80211_register_crypto_ops_fndecl_48112 lib80211_register_crypto_ops fndecl 0 48112 NULL
+disable_so_get_error_address_fndecl_48129 get_error_address fndecl 0 48129 NULL nohasharray
+disable_so_sfreq_sst_byt_pcm_params_48129 sfreq sst_byt_pcm_params 0 48129 &disable_so_get_error_address_fndecl_48129
+disable_so_vsync_off_lvds_dvo_timing_48134 vsync_off lvds_dvo_timing 0 48134 NULL
+disable_so_transop_timeout_ipr_ioa_cfg_48141 transop_timeout ipr_ioa_cfg 0 48141 NULL
+disable_so_addrconf_prefix_rcv_fndecl_48148 addrconf_prefix_rcv fndecl 3 48148 NULL
+disable_so_copied_seq_tcp_sock_48149 copied_seq tcp_sock 0 48149 NULL
+disable_so_pm_autosleep_set_state_fndecl_48154 pm_autosleep_set_state fndecl 0 48154 NULL
+disable_so_mlx4_en_read_clock_fndecl_48159 mlx4_en_read_clock fndecl 0 48159 NULL
+disable_so_ipmi_request_settime_fndecl_48166 ipmi_request_settime fndecl 0 48166 NULL
+disable_so_atime_p9_wstat_48170 atime p9_wstat 0 48170 NULL
+disable_so_sys_mq_timedsend_fndecl_48174 sys_mq_timedsend fndecl 3-1 48174 NULL
+disable_so_td_base_addr_c67x00_hcd_48184 td_base_addr c67x00_hcd 0 48184 NULL
+disable_so_mca_tstamp_ifmcaddr6_48186 mca_tstamp ifmcaddr6 0 48186 NULL
+disable_so_tobe_rx_coal_timeval_vnic_cq_48199 tobe_rx_coal_timeval vnic_cq 0 48199 NULL nohasharray
+disable_so_read_msr_fndecl_48199 read_msr fndecl 0 48199 &disable_so_tobe_rx_coal_timeval_vnic_cq_48199
+disable_so_main_blkaddr_f2fs_sm_info_48201 main_blkaddr f2fs_sm_info 0 48201 NULL
+disable_so_doorbell_physical_address_kgd2kfd_shared_resources_48202 doorbell_physical_address kgd2kfd_shared_resources 0 48202 NULL
+disable_so_aa_fs_seq_hash_open_fndecl_48204 aa_fs_seq_hash_open fndecl 0 48204 NULL
+disable_so_skcipher_all_sg_nents_fndecl_48207 skcipher_all_sg_nents fndecl 0 48207 NULL
+disable_so_addr_r10dev_48214 addr r10dev 0 48214 NULL
+disable_so_btc_set_ulv_dram_timing_fndecl_48216 btc_set_ulv_dram_timing fndecl 0 48216 NULL
+disable_so_gid_btrfs_inode_item_48221 gid btrfs_inode_item 0 48221 NULL
+disable_so_time_offset_vardecl_ntp_c_48224 time_offset vardecl_ntp.c 0 48224 NULL
+disable_so_bitmaps_hpfs_super_block_48227 bitmaps hpfs_super_block 0 48227 NULL
+disable_so_tpg_hdiv_fndecl_48235 tpg_hdiv fndecl 0-3 48235 NULL
+disable_so_nextmsg_time_vardecl_ipath_intr_c_48236 nextmsg_time vardecl_ipath_intr.c 0 48236 NULL
+disable_so_src_bitmap_qxl_copy_48243 src_bitmap qxl_copy 0 48243 NULL nohasharray
+disable_so_btree_split_sibling_fndecl_48243 btree_split_sibling fndecl 0-3 48243 &disable_so_src_bitmap_qxl_copy_48243
+disable_so_sm1_runtime_sc_48251 sm1 runtime_sc 0 48251 NULL nohasharray
+disable_so_r6f_val_fc2580_freq_regs_48251 r6f_val fc2580_freq_regs 0 48251 &disable_so_sm1_runtime_sc_48251
+disable_so_dp_daddr_rds_iw_connect_private_48258 dp_daddr rds_iw_connect_private 0 48258 NULL nohasharray
+disable_so_ceph_dentry_hash_fndecl_48258 ceph_dentry_hash fndecl 0 48258 &disable_so_dp_daddr_rds_iw_connect_private_48258
+disable_so_tm_delta_smt_timer_48263 tm_delta smt_timer 0 48263 NULL nohasharray
+disable_so_enabled_hrtimer_events_ehci_hcd_48263 enabled_hrtimer_events ehci_hcd 0 48263 &disable_so_tm_delta_smt_timer_48263
+disable_so_clock_task_rq_48277 clock_task rq 0 48277 NULL
+disable_so_ui_mtime_ufs2_inode_48286 ui_mtime ufs2_inode 0 48286 NULL
+disable_so_sumo_parse_pplib_clock_info_fndecl_48288 sumo_parse_pplib_clock_info fndecl 3 48288 NULL
+disable_so_crypto_shash_final_fndecl_48296 crypto_shash_final fndecl 0 48296 NULL
+disable_so_tproxy_handle_time_wait4_fndecl_48305 tproxy_handle_time_wait4 fndecl 2-3 48305 NULL
+disable_so_timeout_pg_48333 timeout pg 0 48333 NULL
+disable_so_set_next_event_clock_event_device_48353 set_next_event clock_event_device 1 48353 NULL
+disable_so_VCOdivider_cx24123_bandselect_val_48358 VCOdivider cx24123_bandselect_val 0 48358 NULL
+disable_so_pch_mac_start_address_pch_phub_reg_48361 pch_mac_start_address pch_phub_reg 0 48361 NULL nohasharray
+disable_so_dib8000_write_word_fndecl_48361 dib8000_write_word fndecl 2-3 48361 &disable_so_pch_mac_start_address_pch_phub_reg_48361
+disable_so_skcipher_wait_for_wmem_fndecl_48362 skcipher_wait_for_wmem fndecl 0-2 48362 NULL
+disable_so_num_mc_addrs_ixgb_hw_48363 num_mc_addrs ixgb_hw 0 48363 NULL
+disable_so_timeout_net_conf_48365 timeout net_conf 0 48365 NULL
+disable_so_last_awake_jiffies_rtl_ps_ctl_48378 last_awake_jiffies rtl_ps_ctl 0 48378 NULL
+disable_so_mphash_entries_vardecl_namespace_c_48379 mphash_entries vardecl_namespace.c 0 48379 NULL
+disable_so_dbs_freq_increase_fndecl_48380 dbs_freq_increase fndecl 2 48380 NULL nohasharray
+disable_so_crypto_register_rngs_fndecl_48380 crypto_register_rngs fndecl 0 48380 &disable_so_dbs_freq_increase_fndecl_48380
+disable_so_lgdt3306a_read_signal_strength_fndecl_48382 lgdt3306a_read_signal_strength fndecl 0 48382 NULL
+disable_so_di_atime_efs_dinode_48386 di_atime efs_dinode 0 48386 NULL
+disable_so_iscsi_nacl_attrib_show_nopin_timeout_fndecl_48391 iscsi_nacl_attrib_show_nopin_timeout fndecl 0 48391 NULL
+disable_so_update_streaming_control_runtime_48422 update_streaming control_runtime 0 48422 NULL
+disable_so_setpolicy_cpufreq_driver_48433 setpolicy cpufreq_driver 0 48433 NULL
+disable_so_clockid_timerfd_ctx_48442 clockid timerfd_ctx 0 48442 NULL
+disable_so_set_bau_on_time_bau_control_48444 set_bau_on_time bau_control 0 48444 NULL nohasharray
+disable_so_vclk_post_div_pll_ct_48444 vclk_post_div pll_ct 0 48444 &disable_so_set_bau_on_time_bau_control_48444
+disable_so_test_acipher_jiffies_fndecl_48452 test_acipher_jiffies fndecl 0 48452 NULL
+disable_so_radio_syn_reserved_addr27_b43_nphy_channeltab_entry_rev3_48453 radio_syn_reserved_addr27 b43_nphy_channeltab_entry_rev3 0 48453 NULL
+disable_so_fan_timer_f75375_data_48461 fan_timer f75375_data 0 48461 NULL nohasharray
+disable_so_address_ksm_scan_48461 address ksm_scan 0 48461 &disable_so_fan_timer_f75375_data_48461
+disable_so_elements_bitmap_port_48466 elements bitmap_port 0 48466 NULL
+disable_so_zd_chip_read_mac_addr_fw_fndecl_48469 zd_chip_read_mac_addr_fw fndecl 0 48469 NULL
+disable_so___round_jiffies_up_relative_fndecl_48487 __round_jiffies_up_relative fndecl 2-1-0 48487 NULL
+disable_so_gfs2_disk_hash_fndecl_48491 gfs2_disk_hash fndecl 2 48491 NULL
+disable_so_max6900_rtc_read_time_fndecl_48493 max6900_rtc_read_time fndecl 0 48493 NULL nohasharray
+disable_so_bsscfgidx_brcmf_mbss_ssid_le_48493 bsscfgidx brcmf_mbss_ssid_le 0 48493 &disable_so_max6900_rtc_read_time_fndecl_48493
+disable_so_kvm_set_tsc_khz_fndecl_48520 kvm_set_tsc_khz fndecl 2 48520 NULL
+disable_so_rx8025_set_time_fndecl_48524 rx8025_set_time fndecl 0 48524 NULL
+disable_so_usbvision_stream_interrupt_fndecl_48527 usbvision_stream_interrupt fndecl 0 48527 NULL nohasharray
+disable_so_ip_vs_lblc_hashkey_fndecl_48527 ip_vs_lblc_hashkey fndecl 1 48527 &disable_so_usbvision_stream_interrupt_fndecl_48527
+disable_so_timeout_cm_av_48528 timeout cm_av 0 48528 NULL nohasharray
+disable_so_ww_mutex_lock_slow_interruptible_fndecl_48528 ww_mutex_lock_slow_interruptible fndecl 0 48528 &disable_so_timeout_cm_av_48528
+disable_so___rmid_queue_time_ms_vardecl_perf_event_intel_cqm_c_48542 __rmid_queue_time_ms vardecl_perf_event_intel_cqm.c 0 48542 NULL
+disable_so_blk_addr_node_info_48545 blk_addr node_info 0 48545 NULL
+disable_so_SYSC_sched_getscheduler_fndecl_48547 SYSC_sched_getscheduler fndecl 0-1 48547 NULL
+disable_so_i915_max_freq_get_fndecl_48551 i915_max_freq_get fndecl 0 48551 NULL
+disable_so_min_dwell_time_active_long_conf_scan_settings_48560 min_dwell_time_active_long conf_scan_settings 0 48560 NULL nohasharray
+disable_so_set_memclock_fndecl_48560 set_memclock fndecl 2 48560 &disable_so_min_dwell_time_active_long_conf_scan_settings_48560
+disable_so_ext4_get_bitmap_fndecl_48566 ext4_get_bitmap fndecl 2 48566 NULL
+disable_so_read_addr___pollrd_48572 read_addr __pollrd 0 48572 NULL
+disable_so_cn_esc_printf_fndecl_48573 cn_esc_printf fndecl 0 48573 NULL
+disable_so_osd_keepalive_timeout_ceph_options_48576 osd_keepalive_timeout ceph_options 0 48576 NULL nohasharray
+disable_so_freq_cea_sad_48576 freq cea_sad 0 48576 &disable_so_osd_keepalive_timeout_ceph_options_48576
+disable_so_rp_down_timeout_vlv_s0ix_state_48583 rp_down_timeout vlv_s0ix_state 0 48583 NULL
+disable_so_x86_coreid_bits_cpuinfo_x86_48589 x86_coreid_bits cpuinfo_x86 0 48589 NULL nohasharray
+disable_so_radeon_fence_seq_signaled_fndecl_48589 radeon_fence_seq_signaled fndecl 3 48589 &disable_so_x86_coreid_bits_cpuinfo_x86_48589
+disable_so_timeval_to_jiffies_fndecl_48593 timeval_to_jiffies fndecl 0 48593 NULL
+disable_so_addr_hash_fndecl_48596 addr_hash fndecl 0-2-3 48596 NULL
+disable_so_frame_timestamp_iwl_tdls_channel_switch_timing_48601 frame_timestamp iwl_tdls_channel_switch_timing 0 48601 NULL
+disable_so_post_divider_pll_18818_48604 post_divider pll_18818 0 48604 NULL
+disable_so_mapaddr_ql_rcv_buf_cb_48606 mapaddr ql_rcv_buf_cb 0 48606 NULL
+disable_so_get_tsc_mode_fndecl_48608 get_tsc_mode fndecl 0-1 48608 NULL
+disable_so_parse_nl_saddr_fndecl_48609 parse_nl_saddr fndecl 0 48609 NULL
+disable_so_il_dbgfs_interrupt_write_fndecl_48612 il_dbgfs_interrupt_write fndecl 0-3 48612 NULL
+disable_so_timer_ticks_snd_ymfpci_48615 timer_ticks snd_ymfpci 0 48615 NULL
+disable_so_pause_time_e1000_fc_info_48619 pause_time e1000_fc_info 0 48619 NULL
+disable_so_curspataddr_banshee_reg_48622 curspataddr banshee_reg 0 48622 NULL
+disable_so_sysctl_discovery_timeout_vardecl_48636 sysctl_discovery_timeout vardecl 0 48636 NULL
+disable_so_pch_opt_rom_start_address_pch_phub_reg_48637 pch_opt_rom_start_address pch_phub_reg 0 48637 NULL
+disable_so_ocfs2_test_bg_bit_allocatable_fndecl_48640 ocfs2_test_bg_bit_allocatable fndecl 2 48640 NULL nohasharray
+disable_so_bit_count_syscon_gpio_data_48640 bit_count syscon_gpio_data 0 48640 &disable_so_ocfs2_test_bg_bit_allocatable_fndecl_48640
+disable_so_st_uid_compat_stat_48641 st_uid compat_stat 0 48641 NULL
+disable_so_zd1201_get_freq_fndecl_48656 zd1201_get_freq fndecl 0 48656 NULL nohasharray
+disable_so_set_key_lib80211_crypto_ops_48656 set_key lib80211_crypto_ops 2 48656 &disable_so_zd1201_get_freq_fndecl_48656
+disable_so_padata_set_cpumask_fndecl_48659 padata_set_cpumask fndecl 0 48659 NULL
+disable_so_addrconf_sysctl_mtu_fndecl_48662 addrconf_sysctl_mtu fndecl 0 48662 NULL
+disable_so_elapsed_time_sit_info_48663 elapsed_time sit_info 0 48663 NULL
+disable_so_irq_uart_port_48670 irq uart_port 0 48670 NULL
+disable_so_timeout_ib_qp_attr_48674 timeout ib_qp_attr 0 48674 NULL
+disable_so_read_addr_mdc_hw_list_desc_48675 read_addr mdc_hw_list_desc 0 48675 NULL
+disable_so_xfs_btree_update_fndecl_48676 xfs_btree_update fndecl 0 48676 NULL
+disable_so_phy_pm_runtime_put_sync_fndecl_48680 phy_pm_runtime_put_sync fndecl 0 48680 NULL
+disable_so_pcc_cpufreq_target_fndecl_48684 pcc_cpufreq_target fndecl 2 48684 NULL
+disable_so_call_timer_fn_fndecl_48686 call_timer_fn fndecl 3 48686 NULL
+disable_so_xfs_bmap_add_extent_delay_real_fndecl_48692 xfs_bmap_add_extent_delay_real fndecl 0 48692 NULL
+disable_so_bdi_position_ratio_fndecl_48698 bdi_position_ratio fndecl 0-2-3-4-5-6 48698 NULL
+disable_so_rcq_np_addr_vf_pf_rxq_params_48718 rcq_np_addr vf_pf_rxq_params 0 48718 NULL
+disable_so_rp_gid_ubifs_sb_node_48723 rp_gid ubifs_sb_node 0 48723 NULL
+disable_so_phys_addr_gen_pool_chunk_48730 phys_addr gen_pool_chunk 0 48730 NULL
+disable_so_addr_qla8044_minidump_entry_crb_48734 addr qla8044_minidump_entry_crb 0 48734 NULL
+disable_so_mt7601u_wr_fndecl_48735 mt7601u_wr fndecl 3-2 48735 NULL nohasharray
+disable_so_cpufreq_policy_restore_fndecl_48735 cpufreq_policy_restore fndecl 1 48735 &disable_so_mt7601u_wr_fndecl_48735
+disable_so_cpuid_read_fndecl_48739 cpuid_read fndecl 0 48739 NULL
+disable_so_be_cmd_modify_eq_delay_fndecl_48751 be_cmd_modify_eq_delay fndecl 0 48751 NULL
+disable_so_time_shift_perf_event_mmap_page_48757 time_shift perf_event_mmap_page 0 48757 NULL
+disable_so_i_ctime_ext2_inode_48758 i_ctime ext2_inode 0 48758 NULL nohasharray
+disable_so_ide_timing_find_mode_fndecl_48758 ide_timing_find_mode fndecl 1 48758 &disable_so_i_ctime_ext2_inode_48758
+disable_so_err_crypto_gcm_setkey_result_48768 err crypto_gcm_setkey_result 0 48768 NULL
+disable_so_baddr_videobuf_buffer_48769 baddr videobuf_buffer 0 48769 NULL
+disable_so_sys_utimes_fndecl_48778 sys_utimes fndecl 0 48778 NULL
+disable_so_kstrtos8_from_user_fndecl_48783 kstrtos8_from_user fndecl 2 48783 NULL
+disable_so_regmap_raw_read_fndecl_48789 regmap_raw_read fndecl 4-0-2 48789 NULL
+disable_so_map_sysaddr_to_csrow_low_ops_48803 map_sysaddr_to_csrow low_ops 2 48803 NULL
+disable_so_tg3_get_device_address_fndecl_48809 tg3_get_device_address fndecl 0 48809 NULL
+disable_so_mfgid_sz_cyttsp4_cydata_48812 mfgid_sz cyttsp4_cydata 0 48812 NULL
+disable_so_mceusb_cmd_datasize_fndecl_48817 mceusb_cmd_datasize fndecl 0 48817 NULL
+disable_so_tv_freq_vivid_dev_48830 tv_freq vivid_dev 0 48830 NULL
+disable_so_timecounter_init_fndecl_48837 timecounter_init fndecl 3 48837 NULL
+disable_so_udf_bitmap_free_blocks_fndecl_48841 udf_bitmap_free_blocks fndecl 4-5 48841 NULL
+disable_so__snd_timer_stop_fndecl_48842 _snd_timer_stop fndecl 0 48842 NULL
+disable_so_hash_bits_deflate_state_48850 hash_bits deflate_state 0 48850 NULL
+disable_so_if_freq_mb86a20s_state_48853 if_freq mb86a20s_state 0 48853 NULL
+disable_so_ieee80211_aes_ccm_encrypt_fndecl_48857 ieee80211_aes_ccm_encrypt fndecl 5-7 48857 NULL
+disable_so_msec20_to_jiffies_vardecl_enc28j60_c_48860 msec20_to_jiffies vardecl_enc28j60.c 0 48860 NULL
+disable_so_mmc_sd_get_max_clock_fndecl_48866 mmc_sd_get_max_clock fndecl 0 48866 NULL
+disable_so_s_def_resuid_ext4_super_block_48868 s_def_resuid ext4_super_block 0 48868 NULL
+disable_so_get_physaddr_fs_api_fndecl_48871 get_physaddr_fs_api fndecl 0 48871 NULL
+disable_so_selinux_task_setscheduler_fndecl_48872 selinux_task_setscheduler fndecl 0 48872 NULL
+disable_so_snd_timer_new_fndecl_48873 snd_timer_new fndecl 0 48873 NULL
+disable_so_register_write_rt2800_ops_48876 register_write rt2800_ops 2-3 48876 NULL
+disable_so_client_snd_seq_addr_48879 client snd_seq_addr 0 48879 NULL
+disable_so_saddr_iriap_cb_48880 saddr iriap_cb 0 48880 NULL
+disable_so_error_cpu_itimer_48884 error cpu_itimer 0 48884 NULL
+disable_so_buffer_write_time_flchip_48888 buffer_write_time flchip 0 48888 NULL
+disable_so_valleyview_rps_rpe_freq_fndecl_48901 valleyview_rps_rpe_freq fndecl 0 48901 NULL
+disable_so_bmg160_setup_any_motion_interrupt_fndecl_48906 bmg160_setup_any_motion_interrupt fndecl 0 48906 NULL
+disable_so_min_timing_entry_48911 min timing_entry 0 48911 NULL
+disable_so_tx_coalescing_timeo_bnad_48916 tx_coalescing_timeo bnad 0 48916 NULL
+disable_so___clockevents_try_unbind_fndecl_48918 __clockevents_try_unbind fndecl 2 48918 NULL
+disable_so_cyapa_get_wait_time_for_pwr_cmd_fndecl_48920 cyapa_get_wait_time_for_pwr_cmd fndecl 0-1 48920 NULL
+disable_so_uid_ubifs_ino_node_48950 uid ubifs_ino_node 0 48950 NULL nohasharray
+disable_so_missing_pages_bitmap_counts_48950 missing_pages bitmap_counts 0 48950 &disable_so_uid_ubifs_ino_node_48950
+disable_so_snd_es1968_interrupt_fndecl_48965 snd_es1968_interrupt fndecl 1 48965 NULL
+disable_so_img_ir_symbol_timing_preprocess_fndecl_48967 img_ir_symbol_timing_preprocess fndecl 2 48967 NULL
+disable_so_cryptomgr_init_fndecl_48976 cryptomgr_init fndecl 0 48976 NULL
+disable_so_sync_offset_clockdrift_max_ieee80211_if_mesh_48977 sync_offset_clockdrift_max ieee80211_if_mesh 0 48977 NULL nohasharray
+disable_so_br_mac_hash_fndecl_48977 br_mac_hash fndecl 2 48977 &disable_so_sync_offset_clockdrift_max_ieee80211_if_mesh_48977
+disable_so_rt_daddr_dn_route_48981 rt_daddr dn_route 0 48981 NULL
+disable_so_acpi_get_sleep_type_data_fndecl_48985 acpi_get_sleep_type_data fndecl 0-1 48985 NULL nohasharray
+disable_so_nilfs_btree_mark_fndecl_48985 nilfs_btree_mark fndecl 0-2 48985 &disable_so_acpi_get_sleep_type_data_fndecl_48985
+disable_so_led_on_time_adp8860_backlight_platform_data_48994 led_on_time adp8860_backlight_platform_data 0 48994 NULL nohasharray
+disable_so_jdvbt90502_pll_set_freq_fndecl_48994 jdvbt90502_pll_set_freq fndecl 2 48994 &disable_so_led_on_time_adp8860_backlight_platform_data_48994
+disable_so_max_duration_time_stats_48998 max_duration time_stats 0 48998 NULL
+disable_so_update_debugctlmsr_fndecl_49008 update_debugctlmsr fndecl 1 49008 NULL
+disable_so_default_dclk_div_ssd1307fb_deviceinfo_49014 default_dclk_div ssd1307fb_deviceinfo 0 49014 NULL
+disable_so_bound_addr_rds_info_socket_49019 bound_addr rds_info_socket 0 49019 NULL
+disable_so_output_mute_control_runtime_49021 output_mute control_runtime 0 49021 NULL
+disable_so_btree_csum_one_bio_fndecl_49026 btree_csum_one_bio fndecl 0 49026 NULL
+disable_so_xfs_btree_ptr_addr_fndecl_49031 xfs_btree_ptr_addr fndecl 2 49031 NULL
+disable_so_qs_rtbtimelimit_fs_quota_statv_49033 qs_rtbtimelimit fs_quota_statv 0 49033 NULL
+disable_so_min_cpufreq_policy_49035 min cpufreq_policy 0 49035 NULL nohasharray
+disable_so_semaphore_wait_to_signaller_ring_fndecl_49035 semaphore_wait_to_signaller_ring fndecl 3 49035 &disable_so_min_cpufreq_policy_49035
+disable_so_intr_coal_delay_myri10ge_priv_49037 intr_coal_delay myri10ge_priv 0 49037 NULL
+disable_so_set_public_address_fndecl_49049 set_public_address fndecl 0 49049 NULL
+disable_so_rtc_tm_to_time64_fndecl_49056 rtc_tm_to_time64 fndecl 0 49056 NULL
+disable_so_ext4_block_bitmap_fndecl_49058 ext4_block_bitmap fndecl 0 49058 NULL
+disable_so_nft_hash_key_fndecl_49062 nft_hash_key fndecl 0-2 49062 NULL
+disable_so_dma_addr_cb_49079 dma_addr cb 0 49079 NULL nohasharray
+disable_so_inet6_addr_modify_fndecl_49079 inet6_addr_modify fndecl 0-3-4-2 49079 &disable_so_dma_addr_cb_49079
+disable_so_rhashtable_walk_start_fndecl_49080 rhashtable_walk_start fndecl 0 49080 NULL
+disable_so_sctp_transport_timeout_fndecl_49094 sctp_transport_timeout fndecl 0 49094 NULL
+disable_so_hfdiv_dib0070_tuning_49097 hfdiv dib0070_tuning 0 49097 NULL
+disable_so_u132_hcd_interrupt_recv_fndecl_49098 u132_hcd_interrupt_recv fndecl 5 49098 NULL
+disable_so_test_ahash_jiffies_fndecl_49109 test_ahash_jiffies fndecl 0-3 49109 NULL
+disable_so_result_scsi_cmnd_49113 result scsi_cmnd 0 49113 NULL nohasharray
+disable_so_codel_get_time_fndecl_49113 codel_get_time fndecl 0 49113 &disable_so_result_scsi_cmnd_49113
+disable_so_mce_async_out_fndecl_49115 mce_async_out fndecl 3 49115 NULL
+disable_so_reg_write_fndecl_49116 reg_write fndecl 2-3 49116 NULL nohasharray
+disable_so_hash_htab_elem_49116 hash htab_elem 0 49116 &disable_so_reg_write_fndecl_49116
+disable_so_interrupt_r8a66597_49118 interrupt r8a66597 0 49118 NULL
+disable_so_start_threshold_snd_pcm_runtime_49130 start_threshold snd_pcm_runtime 0 49130 NULL
+disable_so_mt9m111_reg_write_fndecl_49148 mt9m111_reg_write fndecl 0-2-3 49148 NULL
+disable_so_ci_otg_add_timer_fndecl_49151 ci_otg_add_timer fndecl 2 49151 NULL
+disable_so_refa_r_div_ad9523_platform_data_49157 refa_r_div ad9523_platform_data 0 49157 NULL
+disable_so_paddr_setup_data_node_49166 paddr setup_data_node 0 49166 NULL
+disable_so_vactive_lo_lvds_dvo_timing_49180 vactive_lo lvds_dvo_timing 0 49180 NULL
+disable_so_init_dma_addr_pcnet32_private_49182 init_dma_addr pcnet32_private 0 49182 NULL
+disable_so_sh_dmae_runtime_resume_fndecl_49185 sh_dmae_runtime_resume fndecl 0 49185 NULL
+disable_so_timeout_tid_ampdu_tx_49186 timeout tid_ampdu_tx 0 49186 NULL nohasharray
+disable_so_read_peer_guid_fndecl_49186 read_peer_guid fndecl 0 49186 &disable_so_timeout_tid_ampdu_tx_49186
+disable_so_if_freq_tda18271_std_map_item_49207 if_freq tda18271_std_map_item 0 49207 NULL nohasharray
+disable_so_sd_hash_ptrs_gfs2_sbd_49207 sd_hash_ptrs gfs2_sbd 0 49207 &disable_so_if_freq_tda18271_std_map_item_49207
+disable_so_dma_addr_t4_sq_49217 dma_addr t4_sq 0 49217 NULL
+disable_so_suspend_sleep_time_cyapa_49219 suspend_sleep_time cyapa 0 49219 NULL
+disable_so_mtime_nsec_p9_iattr_dotl_49224 mtime_nsec p9_iattr_dotl 0 49224 NULL nohasharray
+disable_so_schedule_external_copy_fndecl_49224 schedule_external_copy fndecl 2-3 49224 &disable_so_mtime_nsec_p9_iattr_dotl_49224
+disable_so_clockevents_init_sysfs_fndecl_49238 clockevents_init_sysfs fndecl 0 49238 NULL
+disable_so_bus_settle_time_blogic_drvr_options_49241 bus_settle_time blogic_drvr_options 0 49241 NULL
+disable_so_nf_ct_timeout_ext_add_fndecl_49245 nf_ct_timeout_ext_add fndecl 3 49245 NULL
+disable_so_wm8350_rtc_readtime_fndecl_49258 wm8350_rtc_readtime fndecl 0 49258 NULL
+disable_so_wm8753_set_dai_clkdiv_fndecl_49259 wm8753_set_dai_clkdiv fndecl 3 49259 NULL nohasharray
+disable_so_di_gid_xfs_icdinode_49259 di_gid xfs_icdinode 0 49259 &disable_so_wm8753_set_dai_clkdiv_fndecl_49259
+disable_so_acpi_lapic_addr_vardecl_boot_c_49264 acpi_lapic_addr vardecl_boot.c 0 49264 NULL
+disable_so_ifa_tstamp_in_ifaddr_49266 ifa_tstamp in_ifaddr 0 49266 NULL
+disable_so_tboot_addr_boot_params_49267 tboot_addr boot_params 0 49267 NULL
+disable_so_rt5677_dsp_mode_i2c_write_addr_fndecl_49301 rt5677_dsp_mode_i2c_write_addr fndecl 0-2-3-4 49301 NULL
+disable_so_il_vbackporch_v4l2_bt_timings_49302 il_vbackporch v4l2_bt_timings 0 49302 NULL
+disable_so_jiffies_64_to_clock_t_fndecl_49307 jiffies_64_to_clock_t fndecl 0-1 49307 NULL nohasharray
+disable_so_crypto_ahash_extsize_fndecl_49307 crypto_ahash_extsize fndecl 0 49307 &disable_so_jiffies_64_to_clock_t_fndecl_49307
+disable_so_disptime_throtl_grp_49308 disptime throtl_grp 0 49308 NULL
+disable_so_k_fll_div_49317 k fll_div 0 49317 NULL
+disable_so_last_time_bictcp_49322 last_time bictcp 0 49322 NULL
+disable_so_qm1d1c0042_sleep_fndecl_49326 qm1d1c0042_sleep fndecl 0 49326 NULL
+disable_so_crypto_register_aeads_fndecl_49338 crypto_register_aeads fndecl 0 49338 NULL nohasharray
+disable_so_gcm_hash_init_continue_fndecl_49338 gcm_hash_init_continue fndecl 0 49338 &disable_so_crypto_register_aeads_fndecl_49338
+disable_so_rds_ib_laddr_check_fndecl_49343 rds_ib_laddr_check fndecl 0-1 49343 NULL
+disable_so_rv6xx_convert_clock_to_stepping_fndecl_49345 rv6xx_convert_clock_to_stepping fndecl 2-0 49345 NULL
+disable_so_io_addr_uhci_hcd_49351 io_addr uhci_hcd 0 49351 NULL
+disable_so_mcryptd_hash_update_enqueue_fndecl_49367 mcryptd_hash_update_enqueue fndecl 0 49367 NULL
+disable_so_dll_cntl_ci_clock_registers_49369 dll_cntl ci_clock_registers 0 49369 NULL
+disable_so_d_btimer_fs_disk_quota_49376 d_btimer fs_disk_quota 0 49376 NULL nohasharray
+disable_so_uv_nmi_initial_delay_vardecl_uv_nmi_c_49376 uv_nmi_initial_delay vardecl_uv_nmi.c 0 49376 &disable_so_d_btimer_fs_disk_quota_49376 nohasharray
+disable_so_s_addr_in_addr_49376 s_addr in_addr 0 49376 &disable_so_uv_nmi_initial_delay_vardecl_uv_nmi_c_49376
+disable_so_addrlow_dma64desc_49384 addrlow dma64desc 0 49384 NULL
+disable_so_tcn_timer_show_fndecl_49401 tcn_timer_show fndecl 0 49401 NULL
+disable_so_query_gid_ib_device_49415 query_gid ib_device 0-2-3 49415 NULL nohasharray
+disable_so_physaddr_qib_devdata_49415 physaddr qib_devdata 0 49415 &disable_so_query_gid_ib_device_49415
+disable_so_descsize_crypto_shash_49421 descsize crypto_shash 0 49421 NULL
+disable_so_gatt_bus_addr_agp_bridge_data_49422 gatt_bus_addr agp_bridge_data 0 49422 NULL
+disable_so_confq_pbl_base_addr_lo_fcoe_kwqe_conn_offload4_49427 confq_pbl_base_addr_lo fcoe_kwqe_conn_offload4 0 49427 NULL
+disable_so_fm_v4l2_vidioc_s_freq_fndecl_49444 fm_v4l2_vidioc_s_freq fndecl 0 49444 NULL
+disable_so_tidvaddr_qib_tid_info_49445 tidvaddr qib_tid_info 0 49445 NULL
+disable_so_hpi_cobranet_get_ip_address_fndecl_49449 hpi_cobranet_get_ip_address fndecl 1 49449 NULL
+disable_so_nla_put_s32_fndecl_49455 nla_put_s32 fndecl 0-3 49455 NULL
+disable_so_saa711x_s_clock_freq_fndecl_49457 saa711x_s_clock_freq fndecl 2 49457 NULL
+disable_so_timestamp_mwl8k_tx_desc_49459 timestamp mwl8k_tx_desc 0 49459 NULL
+disable_so___xfrm6_dpref_spref_hash_fndecl_49463 __xfrm6_dpref_spref_hash fndecl 0 49463 NULL
+disable_so_dn_hash_fndecl_49465 dn_hash fndecl 0-1-2 49465 NULL
+disable_so_x_runtime_sc_49473 x runtime_sc 0 49473 NULL
+disable_so_sgl_pg1_addr_hi_sgl_page_pairs_49474 sgl_pg1_addr_hi sgl_page_pairs 0 49474 NULL
+disable_so_mtime_sec_p9_iattr_dotl_49482 mtime_sec p9_iattr_dotl 0 49482 NULL
+disable_so_mpll_ad_func_cntl_ci_clock_registers_49490 mpll_ad_func_cntl ci_clock_registers 0 49490 NULL nohasharray
+disable_so_mounted_uid_ncp_mount_data_v4_49490 mounted_uid ncp_mount_data_v4 0 49490 &disable_so_mpll_ad_func_cntl_ci_clock_registers_49490
+disable_so_i2c_write_le16_fndecl_49491 i2c_write_le16 fndecl 0 49491 NULL nohasharray
+disable_so_svm_compute_tsc_offset_fndecl_49491 svm_compute_tsc_offset fndecl 0-2 49491 &disable_so_i2c_write_le16_fndecl_49491
+disable_so_d_rtbtimer_xfs_disk_dquot_49495 d_rtbtimer xfs_disk_dquot 0 49495 NULL
+disable_so_parport_set_timeout_fndecl_49497 parport_set_timeout fndecl 2-0 49497 NULL
+disable_so_radelay_esp_49498 radelay esp 0 49498 NULL
+disable_so_addr_i2c_board_info_49507 addr i2c_board_info 0 49507 NULL
+disable_so_adma_addr_sdhci_host_49508 adma_addr sdhci_host 0 49508 NULL
+disable_so_rq_addr_t3_rdma_init_wr_49515 rq_addr t3_rdma_init_wr 0 49515 NULL
+disable_so_runtime_remaining_cfs_rq_49516 runtime_remaining cfs_rq 0 49516 NULL
+disable_so_dreq_timestamp_time_dccp_request_sock_49520 dreq_timestamp_time dccp_request_sock 0 49520 NULL
+disable_so_regmap_add_irq_chip_fndecl_49529 regmap_add_irq_chip fndecl 4-0-2-3 49529 NULL
+disable_so_drm_fixp_div_fndecl_49535 drm_fixp_div fndecl 0-1-2 49535 NULL
+disable_so_ar_addr_qla8044_quad_entry_49543 ar_addr qla8044_quad_entry 0 49543 NULL
+disable_so_regcache_lzo_compress_cache_block_fndecl_49544 regcache_lzo_compress_cache_block fndecl 0 49544 NULL
+disable_so___subtree_last_interval_tree_node_49547 __subtree_last interval_tree_node 0 49547 NULL
+disable_so_pll1_feedback_div_ad9523_platform_data_49550 pll1_feedback_div ad9523_platform_data 0 49550 NULL nohasharray
+disable_so_uncore_get_attr_cpumask_fndecl_49550 uncore_get_attr_cpumask fndecl 0 49550 &disable_so_pll1_feedback_div_ad9523_platform_data_49550
+disable_so_read_clocksource_49555 read clocksource 0 49555 NULL
+disable_so_hash_sk_buff_49561 hash sk_buff 0 49561 NULL
+disable_so_I_T_nexus_loss_timeout_sas_end_device_49562 I_T_nexus_loss_timeout sas_end_device 0 49562 NULL nohasharray
+disable_so_enc_addr_high_ssp_ini_io_start_req_49562 enc_addr_high ssp_ini_io_start_req 0 49562 &disable_so_I_T_nexus_loss_timeout_sas_end_device_49562
+disable_so_alarm_clock_getres_fndecl_49575 alarm_clock_getres fndecl 1 49575 NULL
+disable_so_regcache_lzo_get_blkpos_fndecl_49577 regcache_lzo_get_blkpos fndecl 0-2 49577 NULL
+disable_so_atyfb_get_pixclock_fndecl_49582 atyfb_get_pixclock fndecl 0 49582 NULL
+disable_so_mclkdiv_pll_div_49594 mclkdiv pll_div 0 49594 NULL
+disable_so_frame_phys_addr_megasas_cmd_49601 frame_phys_addr megasas_cmd 0 49601 NULL nohasharray
+disable_so_ccp_sha_digest_fndecl_49601 ccp_sha_digest fndecl 0 49601 &disable_so_frame_phys_addr_megasas_cmd_49601
+disable_so_si476x_core_cmd_am_tune_freq_a10_fndecl_49610 si476x_core_cmd_am_tune_freq_a10 fndecl 0 49610 NULL
+disable_so_sctp_setsockopt_delayed_ack_fndecl_49618 sctp_setsockopt_delayed_ack fndecl 3-0 49618 NULL
+disable_so_gpu_addr_radeon_ring_49632 gpu_addr radeon_ring 0 49632 NULL
+disable_so_uac_clock_selector_get_val_fndecl_49639 uac_clock_selector_get_val fndecl 0-2 49639 NULL nohasharray
+disable_so_osc_clock_freq_drxd_state_49639 osc_clock_freq drxd_state 0 49639 &disable_so_uac_clock_selector_get_val_fndecl_49639
+disable_so_addr_rx_desc_49640 addr rx_desc 0 49640 NULL
+disable_so_r600_engine_clock_entry_set_reference_divider_fndecl_49644 r600_engine_clock_entry_set_reference_divider fndecl 3 49644 NULL
+disable_so_set_fan_div_fndecl_49645 set_fan_div fndecl 0-4 49645 NULL nohasharray
+disable_so_intermediate_freq_drx_common_attr_49645 intermediate_freq drx_common_attr 0 49645 &disable_so_set_fan_div_fndecl_49645
+disable_so_wr32_nvkm_ofuncs_49648 wr32 nvkm_ofuncs 2-3 49648 NULL
+disable_so__rtl8821ae_phy_calculate_bit_shift_fndecl_49649 _rtl8821ae_phy_calculate_bit_shift fndecl 0-1 49649 NULL
+disable_so_cpufreq_governor_start_fndecl_49658 cpufreq_governor_start fndecl 0 49658 NULL
+disable_so_mcgstatus_mce_49682 mcgstatus mce 0 49682 NULL
+disable_so_bitmap_size_f2fs_nm_info_49684 bitmap_size f2fs_nm_info 0 49684 NULL
+disable_so_SYSC_setgid_fndecl_49688 SYSC_setgid fndecl 0 49688 NULL
+disable_so_dx_tss_segment_16_49692 dx tss_segment_16 0 49692 NULL
+disable_so_tg3_test_interrupt_fndecl_49694 tg3_test_interrupt fndecl 0 49694 NULL
+disable_so_rv6xx_compute_count_for_delay_fndecl_49697 rv6xx_compute_count_for_delay fndecl 0-2-3 49697 NULL
+disable_so_read_time_mei_cl_cb_49706 read_time mei_cl_cb 0 49706 NULL
+disable_so_addrconf_forward_change_fndecl_49711 addrconf_forward_change fndecl 2 49711 NULL
+disable_so_cx24113_writereg_fndecl_49714 cx24113_writereg fndecl 0-3 49714 NULL
+disable_so_demod_address_tda1004x_config_49721 demod_address tda1004x_config 0 49721 NULL
+disable_so_device_timestamp_ieee80211_channel_switch_49722 device_timestamp ieee80211_channel_switch 0 49722 NULL
+disable_so_gid_fileEntry_49725 gid fileEntry 0 49725 NULL
+disable_so_dma_addr_clx2_queue_49729 dma_addr clx2_queue 0 49729 NULL
+disable_so_extsize_crypto_type_49730 extsize crypto_type 0 49730 NULL
+disable_so_k__fll_div_49732 k _fll_div 0 49732 NULL
+disable_so_sumo_set_ss_dividers_fndecl_49747 sumo_set_ss_dividers fndecl 2-3 49747 NULL
+disable_so_i2c_clock_i2c_algo_pca_data_49751 i2c_clock i2c_algo_pca_data 0 49751 NULL nohasharray
+disable_so_skb_get_hash_perturb_fndecl_49751 skb_get_hash_perturb fndecl 0 49751 &disable_so_i2c_clock_i2c_algo_pca_data_49751
+disable_so_expire_llc_timer_49752 expire llc_timer 0 49752 NULL
+disable_so_rdma_copy_addr_fndecl_49754 rdma_copy_addr fndecl 0 49754 NULL
+disable_so_hblank___fb_timings_49755 hblank __fb_timings 0 49755 NULL
+disable_so_stripe_count_nfs4_file_layout_dsaddr_49758 stripe_count nfs4_file_layout_dsaddr 0 49758 NULL
+disable_so_inet_rtm_newaddr_fndecl_49766 inet_rtm_newaddr fndecl 0 49766 NULL nohasharray
+disable_so_generic_handle_irq_fndecl_49766 generic_handle_irq fndecl 1 49766 &disable_so_inet_rtm_newaddr_fndecl_49766
+disable_so_parport_ieee1284_ecp_write_addr_fndecl_49769 parport_ieee1284_ecp_write_addr fndecl 0 49769 NULL
+disable_so_dl_runtime_sched_dl_entity_49775 dl_runtime sched_dl_entity 0 49775 NULL
+disable_so_cur_saddr_pktgen_dev_49776 cur_saddr pktgen_dev 0 49776 NULL
+disable_so_nf_ct_expect_dst_hash_fndecl_49778 nf_ct_expect_dst_hash fndecl 0 49778 NULL
+disable_so_compat_sys_times_fndecl_49783 compat_sys_times fndecl 0 49783 NULL nohasharray
+disable_so___bitmap_shift_left_fndecl_49783 __bitmap_shift_left fndecl 3-4 49783 &disable_so_compat_sys_times_fndecl_49783
+disable_so_sq_addr_high_nes_qp_context_49784 sq_addr_high nes_qp_context 0 49784 NULL
+disable_so_phy_address_ethtool_cmd_49790 phy_address ethtool_cmd 0 49790 NULL
+disable_so_intr_timer_type_vnic_enet_config_49793 intr_timer_type vnic_enet_config 0 49793 NULL
+disable_so_end_time_bfa_diag_dport_result_s_49798 end_time bfa_diag_dport_result_s 0 49798 NULL
+disable_so_prot_addr_saa7146_video_dma_49808 prot_addr saa7146_video_dma 0 49808 NULL
+disable_so_p2m_timeout_show_fndecl_49814 p2m_timeout_show fndecl 0 49814 NULL
+disable_so_pr_uid_compat_elf_prpsinfo_49815 pr_uid compat_elf_prpsinfo 0 49815 NULL
+disable_so_pch_udc_disable_ep_interrupts_fndecl_49816 pch_udc_disable_ep_interrupts fndecl 2 49816 NULL
+disable_so_bd_list_addr_lo_bnx2i_login_request_49817 bd_list_addr_lo bnx2i_login_request 0 49817 NULL
+disable_so_nsec_pvclock_wall_clock_49833 nsec pvclock_wall_clock 0 49833 NULL
+disable_so_bss_lose_timeout_conf_conn_settings_49850 bss_lose_timeout conf_conn_settings 0 49850 NULL
+disable_so_snd_opl3_timer1_init_fndecl_49852 snd_opl3_timer1_init fndecl 0-2 49852 NULL
+disable_so_data_crb_addr_pair_49859 data crb_addr_pair 0 49859 NULL
+disable_so_txeol_interrupt_mask_ath_hw_49864 txeol_interrupt_mask ath_hw 0 49864 NULL
+disable_so_ctrl_freq_set_fndecl_49865 ctrl_freq_set fndecl 3 49865 NULL
+disable_so_freq_pda_iq_autocal_entry_49869 freq pda_iq_autocal_entry 0 49869 NULL
+disable_so_kempld_wdt_set_timeout_fndecl_49893 kempld_wdt_set_timeout fndecl 2 49893 NULL
+disable_so_nilfs_btree_node_set_ptr_fndecl_49897 nilfs_btree_node_set_ptr fndecl 2-3 49897 NULL
+disable_so_time_to_val_fndecl_49902 time_to_val fndecl 0-4-2-3 49902 NULL
+disable_so_capture_timestamp_qla27xx_fwdt_template_49904 capture_timestamp qla27xx_fwdt_template 0 49904 NULL nohasharray
+disable_so_wl1273_fm_set_rx_freq_fndecl_49904 wl1273_fm_set_rx_freq fndecl 2 49904 &disable_so_capture_timestamp_qla27xx_fwdt_template_49904
+disable_so_set_spdif_clock_snd_ice1712_49905 set_spdif_clock snd_ice1712 2 49905 NULL
+disable_so_nmi_evntsel_msr_to_bit_fndecl_49906 nmi_evntsel_msr_to_bit fndecl 0-1 49906 NULL
+disable_so_get_ipv6_addr_fndecl_49909 get_ipv6_addr fndecl 2 49909 NULL
+disable_so_bitstream_cursor_advance_fndecl_49911 bitstream_cursor_advance fndecl 2 49911 NULL
+disable_so_trap_addr_sdpcm_shared_49924 trap_addr sdpcm_shared 0 49924 NULL
+disable_so_show_port_gid_fndecl_49927 show_port_gid fndecl 0 49927 NULL
+disable_so_ib_sa_guid_info_rec_query_fndecl_49928 ib_sa_guid_info_rec_query fndecl 0-3-5-7-8 49928 NULL
+disable_so_mtrr_type_lookup_fndecl_49929 mtrr_type_lookup fndecl 1-2 49929 NULL
+disable_so_persistent_offset_sst_module_runtime_49933 persistent_offset sst_module_runtime 0 49933 NULL
+disable_so_lvb_ictime_packed_ocfs2_meta_lvb_49940 lvb_ictime_packed ocfs2_meta_lvb 0 49940 NULL
+enable_so_inode_number_squashfs_dir_entry_49943 inode_number squashfs_dir_entry 0 49943 NULL nohasharray
+disable_so_boost_freq_lm3533_platform_data_49943 boost_freq lm3533_platform_data 0 49943 &enable_so_inode_number_squashfs_dir_entry_49943
+disable_so_inet_twsk_schedule_fndecl_49946 inet_twsk_schedule fndecl 2 49946 NULL
+disable_so_host_time_adj_time_work_49952 host_time adj_time_work 0 49952 NULL
+disable_so_b43_dma_address_fndecl_49953 b43_dma_address fndecl 0-2 49953 NULL
+disable_so_max_delay_iwl_time_event_cmd_49957 max_delay iwl_time_event_cmd 0 49957 NULL
+disable_so_shash_final_unaligned_fndecl_49961 shash_final_unaligned fndecl 0 49961 NULL
+disable_so_mpll_func_cntl_si_clock_registers_49965 mpll_func_cntl si_clock_registers 0 49965 NULL
+disable_so_nfsd4_write_time_fndecl_49969 nfsd4_write_time fndecl 0 49969 NULL
+disable_so_ds1374_set_time_fndecl_49975 ds1374_set_time fndecl 0 49975 NULL
+disable_so_batadv_hash_new_fndecl_49976 batadv_hash_new fndecl 1 49976 NULL
+disable_so_timeout_i2c_adapter_49981 timeout i2c_adapter 0 49981 NULL nohasharray
+disable_so_delay_radeon_voltage_49981 delay radeon_voltage 0 49981 &disable_so_timeout_i2c_adapter_49981 nohasharray
+disable_so___cpufreq_stats_create_table_fndecl_49981 __cpufreq_stats_create_table fndecl 0 49981 &disable_so_delay_radeon_voltage_49981
+disable_so_op_x86_virt_to_phys_fndecl_49986 op_x86_virt_to_phys fndecl 0-1 49986 NULL nohasharray
+disable_so_freq_time_stamp_hw_perf_event_49986 freq_time_stamp hw_perf_event 0 49986 &disable_so_op_x86_virt_to_phys_fndecl_49986
+disable_so_dib7000p_get_internal_freq_fndecl_49987 dib7000p_get_internal_freq fndecl 0 49987 NULL nohasharray
+disable_so_msr_daio_desc_49987 msr daio_desc 0 49987 &disable_so_dib7000p_get_internal_freq_fndecl_49987
+disable_so_RF_SYN_reserved_addr28_chan_info_nphy_radio205x_49990 RF_SYN_reserved_addr28 chan_info_nphy_radio205x 0 49990 NULL
+disable_so_timer_vardecl_iphase_c_49991 timer vardecl_iphase.c 0 49991 NULL
+disable_so_typhoon_sleep_fndecl_49999 typhoon_sleep fndecl 0-2 49999 NULL
+disable_so_confq_first_pbe_addr_lo_fcoe_kwqe_conn_offload3_50012 confq_first_pbe_addr_lo fcoe_kwqe_conn_offload3 0 50012 NULL
+disable_so__rtl92d_phy_calculate_bit_shift_fndecl_50016 _rtl92d_phy_calculate_bit_shift fndecl 0-1 50016 NULL
+disable_so_ds1307_set_time_fndecl_50017 ds1307_set_time fndecl 0 50017 NULL
+disable_so_dma_addr__DMABUFFERENTRY_50032 dma_addr _DMABUFFERENTRY 0 50032 NULL
+disable_so_payload_addr_isp1760_qtd_50045 payload_addr isp1760_qtd 0 50045 NULL
+disable_so_crypto_pcbc_encrypt_fndecl_50054 crypto_pcbc_encrypt fndecl 0-4 50054 NULL
+disable_so_tcp_shift_skb_data_fndecl_50056 tcp_shift_skb_data fndecl 5-4 50056 NULL
+disable_so_reference_div_radeon_pll_50062 reference_div radeon_pll 0 50062 NULL
+disable_so_io_addr_blogic_adapter_50066 io_addr blogic_adapter 0 50066 NULL
+disable_so_bfs_paprd_timestamp_ath_buf_state_50090 bfs_paprd_timestamp ath_buf_state 0 50090 NULL
+disable_so_address_bau_msg_payload_50110 address bau_msg_payload 0 50110 NULL
+disable_so_scsi_reset_delay_adveep_3550_config_50118 scsi_reset_delay adveep_3550_config 0 50118 NULL
+disable_so_start_bit_alps_bitmap_point_50119 start_bit alps_bitmap_point 0 50119 NULL
+disable_so_i_atime_ext2_inode_50120 i_atime ext2_inode 0 50120 NULL nohasharray
+disable_so_link_down_time_swStat_50120 link_down_time swStat 0 50120 &disable_so_i_atime_ext2_inode_50120
+disable_so_sys_timerfd_settime_fndecl_50127 sys_timerfd_settime fndecl 1 50127 NULL nohasharray
+disable_so_t1timer_lapb_parms_struct_50127 t1timer lapb_parms_struct 0 50127 &disable_so_sys_timerfd_settime_fndecl_50127
+disable_so_lp8755_buck_enable_time_fndecl_50128 lp8755_buck_enable_time fndecl 0 50128 NULL
+disable_so_hash_v4_fndecl_50129 hash_v4 fndecl 0 50129 NULL
+disable_so_btree_lookup128_fndecl_50132 btree_lookup128 fndecl 3 50132 NULL
+disable_so_data_msr_data_50133 data msr_data 0 50133 NULL
+disable_so_max_freq_ufs_clk_info_50134 max_freq ufs_clk_info 0 50134 NULL
+disable_so_carl9170_debugfs_tx_ampdu_scheduler_read_fndecl_50136 carl9170_debugfs_tx_ampdu_scheduler_read fndecl 3 50136 NULL nohasharray
+disable_so_write32_tg3_50136 write32 tg3 3 50136 &disable_so_carl9170_debugfs_tx_ampdu_scheduler_read_fndecl_50136
+disable_so_vm_addr_fndecl_50143 vm_addr fndecl 0-2-3-4 50143 NULL
+disable_so_mmc_sd_runtime_suspend_fndecl_50164 mmc_sd_runtime_suspend fndecl 0 50164 NULL
+disable_so_msr_pcap_chip_50171 msr pcap_chip 0 50171 NULL
+disable_so_ptp_clock_index_fndecl_50179 ptp_clock_index fndecl 0 50179 NULL nohasharray
+disable_so_str2hashbuf_signed_fndecl_50179 str2hashbuf_signed fndecl 2 50179 &disable_so_ptp_clock_index_fndecl_50179
+disable_so_dapm_clock_event_fndecl_50184 dapm_clock_event fndecl 0 50184 NULL nohasharray
+disable_so_skcipher_null_givdecrypt_fndecl_50184 skcipher_null_givdecrypt fndecl 0 50184 &disable_so_dapm_clock_event_fndecl_50184
+disable_so_nlm_timeout_vardecl_svc_c_50197 nlm_timeout vardecl_svc.c 0 50197 NULL
+disable_so_st_mtime_nsec_stat_50200 st_mtime_nsec stat 0 50200 NULL
+disable_so_haddr_tpd_haddr_50202 haddr tpd_haddr 0 50202 NULL
+disable_so_cx24116_sleep_fndecl_50204 cx24116_sleep fndecl 0 50204 NULL
+disable_so_printframe_fndecl_50210 printframe fndecl 3 50210 NULL nohasharray
+disable_so_pch_udc_write_device_interrupts_fndecl_50210 pch_udc_write_device_interrupts fndecl 2 50210 &disable_so_printframe_fndecl_50210
+disable_so_measure_12bit_voltage_fndecl_50211 measure_12bit_voltage fndecl 0-2 50211 NULL
+disable_so_mcheck_init_device_fndecl_50223 mcheck_init_device fndecl 0 50223 NULL
+disable_so_igb_init_rx_addrs_fndecl_50228 igb_init_rx_addrs fndecl 2 50228 NULL
+disable_so_s11_img_ir_timing_regvals_50232 s11 img_ir_timing_regvals 0 50232 NULL
+disable_so_paddr_mwifiex_pcie_buf_desc_50236 paddr mwifiex_pcie_buf_desc 0 50236 NULL
+disable_so_rdma_resolve_addr_fndecl_50240 rdma_resolve_addr fndecl 0 50240 NULL
+disable_so_mlx4_ib_notify_slaves_on_guid_change_fndecl_50248 mlx4_ib_notify_slaves_on_guid_change fndecl 2-3 50248 NULL
+disable_so_si476x_core_cmd_am_tune_freq_a20_fndecl_50250 si476x_core_cmd_am_tune_freq_a20 fndecl 0 50250 NULL
+disable_so_addr_lo_dma_address_50252 addr_lo dma_address 0 50252 NULL
+disable_so_scsi_runtime_resume_fndecl_50254 scsi_runtime_resume fndecl 0 50254 NULL
+disable_so_pkt_rbtree_find_fndecl_50259 pkt_rbtree_find fndecl 2 50259 NULL
+disable_so_p_div_aic31xx_priv_50261 p_div aic31xx_priv 0 50261 NULL
+disable_so_da9052_rtc_set_time_fndecl_50269 da9052_rtc_set_time fndecl 0 50269 NULL
+disable_so_read_addr_qla4_83xx_minidump_entry_rdmem_pex_dma_50271 read_addr qla4_83xx_minidump_entry_rdmem_pex_dma 0 50271 NULL
+disable_so_timeout_jiffies_qib_qp_50276 timeout_jiffies qib_qp 0 50276 NULL
+disable_so_tmr_restart_sound_lowlev_timer_50278 tmr_restart sound_lowlev_timer 1 50278 NULL
+disable_so_irq_domain_free_irqs_common_fndecl_50279 irq_domain_free_irqs_common fndecl 2-3 50279 NULL nohasharray
+disable_so_hsync_vsync_offset_pulse_width_hi_detailed_pixel_timing_50279 hsync_vsync_offset_pulse_width_hi detailed_pixel_timing 0 50279 &disable_so_irq_domain_free_irqs_common_fndecl_50279
+disable_so_eop_ring_buffer_address_queue_properties_50280 eop_ring_buffer_address queue_properties 0 50280 NULL
+disable_so_bna_rx_coalescing_timeo_set_fndecl_50282 bna_rx_coalescing_timeo_set fndecl 2 50282 NULL
+disable_so_shash_compat_update_fndecl_50285 shash_compat_update fndecl 0-3 50285 NULL
+disable_so_get_physaddr_buffered_ioctl_fndecl_50286 get_physaddr_buffered_ioctl fndecl 0 50286 NULL
+disable_so_snd_hrtimer_init_fndecl_50291 snd_hrtimer_init fndecl 0 50291 NULL
+disable_so_cpuidle_add_state_sysfs_fndecl_50292 cpuidle_add_state_sysfs fndecl 0 50292 NULL
+disable_so_bitmap_set_bits_fndecl_50299 bitmap_set_bits fndecl 3-4 50299 NULL
+disable_so_cur_sge_off_fcoe_mul_sges_ctx_50300 cur_sge_off fcoe_mul_sges_ctx 0 50300 NULL
+disable_so_mpll_func_cntl_1_si_clock_registers_50301 mpll_func_cntl_1 si_clock_registers 0 50301 NULL
+disable_so_genwqe_debugfs_curr_dbg_uid0_open_fndecl_50304 genwqe_debugfs_curr_dbg_uid0_open fndecl 0 50304 NULL
+disable_so_tx_interframe_timeout_wil6210_priv_50305 tx_interframe_timeout wil6210_priv 0 50305 NULL
+disable_so_pending_csums_btrfs_delayed_ref_root_50311 pending_csums btrfs_delayed_ref_root 0 50311 NULL
+disable_so_addr_count_blogic_adapter_50326 addr_count blogic_adapter 0 50326 NULL
+disable_so_cpufreq_out_of_sync_fndecl_50327 cpufreq_out_of_sync fndecl 2 50327 NULL nohasharray
+disable_so_typ_timing_entry_50327 typ timing_entry 0 50327 &disable_so_cpufreq_out_of_sync_fndecl_50327
+disable_so_used_skcipher_ctx_50342 used skcipher_ctx 0 50342 NULL
+disable_so_iscsit_create_random_array_fndecl_50360 iscsit_create_random_array fndecl 2 50360 NULL
+disable_so_current_frequency_s5h1409_state_50366 current_frequency s5h1409_state 0 50366 NULL
+disable_so_cb_camif_addr_50371 cb camif_addr 0 50371 NULL
+disable_so_prepare_kswapd_sleep_fndecl_50377 prepare_kswapd_sleep fndecl 2-3 50377 NULL
+disable_so___tcf_hash_release_fndecl_50380 __tcf_hash_release fndecl 0 50380 NULL
+disable_so_ntfs_bitmap_clear_bit_fndecl_50382 ntfs_bitmap_clear_bit fndecl 2 50382 NULL
+disable_so_tg3_ptp_adjtime_fndecl_50384 tg3_ptp_adjtime fndecl 2 50384 NULL
+disable_so_xfs_btree_copy_recs_fndecl_50385 xfs_btree_copy_recs fndecl 4 50385 NULL
+disable_so___cpufreq_get_fndecl_50397 __cpufreq_get fndecl 0 50397 NULL
+disable_so_rtl821x_ack_interrupt_fndecl_50399 rtl821x_ack_interrupt fndecl 0 50399 NULL
+disable_so_ss_divider_index_sumo_pl_50401 ss_divider_index sumo_pl 0 50401 NULL
+disable_so_igb_runtime_suspend_fndecl_50408 igb_runtime_suspend fndecl 0 50408 NULL nohasharray
+disable_so_hash_ipmark4_expire_fndecl_50408 hash_ipmark4_expire fndecl 4 50408 &disable_so_igb_runtime_suspend_fndecl_50408
+disable_so_addr_TxDesc_50413 addr TxDesc 0 50413 NULL
+disable_so_xfs_btree_dup_cursor_fndecl_50417 xfs_btree_dup_cursor fndecl 0 50417 NULL
+disable_so_channel2freq_bg_fndecl_50421 channel2freq_bg fndecl 0-1 50421 NULL
+disable_so_freq_lo_jiffies_od_cpu_dbs_info_s_50424 freq_lo_jiffies od_cpu_dbs_info_s 0 50424 NULL
+disable_so_time_cifsInodeInfo_50431 time cifsInodeInfo 0 50431 NULL
+disable_so_tps65910_rtc_read_time_fndecl_50446 tps65910_rtc_read_time fndecl 0 50446 NULL
+disable_so_freq_wmi_p2p_rx_probe_req_event_50455 freq wmi_p2p_rx_probe_req_event 0 50455 NULL
+disable_so_ifa_cstamp_in_ifaddr_50464 ifa_cstamp in_ifaddr 0 50464 NULL
+disable_so_reg_ds1685_rtc_time_regs_50466 reg ds1685_rtc_time_regs 0 50466 NULL
+disable_so_n_freq_tbl_50468 n freq_tbl 0 50468 NULL
+disable_so_hash_code_f2fs_dir_entry_50474 hash_code f2fs_dir_entry 0 50474 NULL
+disable_so_link_check_timeout_i40e_pf_50476 link_check_timeout i40e_pf 0 50476 NULL
+disable_so_addr_lo_eth_rx_cqe_next_page_50479 addr_lo eth_rx_cqe_next_page 0 50479 NULL
+disable_so_sr_timestamp_nfs4_sequence_res_50481 sr_timestamp nfs4_sequence_res 0 50481 NULL nohasharray
+disable_so_cpumask_parse_fndecl_50481 cpumask_parse fndecl 0 50481 &disable_so_sr_timestamp_nfs4_sequence_res_50481
+disable_so_set_pte_vaddr_pud_fndecl_50497 set_pte_vaddr_pud fndecl 2 50497 NULL
+disable_so_pa_rxrf_lna1_freq_tune_chan_info_2064_lcnphy_50502 pa_rxrf_lna1_freq_tune chan_info_2064_lcnphy 0 50502 NULL
+disable_so_uv_global_gru_mmr_address_fndecl_50507 uv_global_gru_mmr_address fndecl 0-1-2 50507 NULL
+disable_so_address_desc_ptr_50509 address desc_ptr 0 50509 NULL
+disable_so_crypto_aead_alg_maxauthsize_fndecl_50510 crypto_aead_alg_maxauthsize fndecl 0 50510 NULL
+disable_so_pci_get_interrupt_pin_fndecl_50512 pci_get_interrupt_pin fndecl 0 50512 NULL
+disable_so_addr_assign_type_show_fndecl_50513 addr_assign_type_show fndecl 0 50513 NULL
+disable_so_frequency_si4713_device_50518 frequency si4713_device 0 50518 NULL
+disable_so__iommu_cpumask_show_fndecl_50522 _iommu_cpumask_show fndecl 0 50522 NULL
+disable_so_mma9551_runtime_resume_fndecl_50531 mma9551_runtime_resume fndecl 0 50531 NULL
+disable_so_mvs_set_sas_addr_fndecl_50535 mvs_set_sas_addr fndecl 2-5 50535 NULL
+disable_so_rv3029c2_rtc_set_time_fndecl_50537 rv3029c2_rtc_set_time fndecl 0 50537 NULL nohasharray
+disable_so__zd_iowrite32v_async_locked_fndecl_50537 _zd_iowrite32v_async_locked fndecl 3-0 50537 &disable_so_rv3029c2_rtc_set_time_fndecl_50537
+disable_so_demod_addr_m88rs2000_config_50543 demod_addr m88rs2000_config 0 50543 NULL
+disable_so_mv88e6xxx_set_addr_indirect_fndecl_50547 mv88e6xxx_set_addr_indirect fndecl 0 50547 NULL nohasharray
+disable_so_bind_evtchn_to_irqhandler_fndecl_50547 bind_evtchn_to_irqhandler fndecl 0-1 50547 &disable_so_mv88e6xxx_set_addr_indirect_fndecl_50547
+disable_so_twl6030_interrupt_unmask_fndecl_50550 twl6030_interrupt_unmask fndecl 2-0 50550 NULL
+disable_so_recovery_pio_clocks_50551 recovery pio_clocks 0 50551 NULL
+disable_so_lp8788_rtc_read_time_fndecl_50573 lp8788_rtc_read_time fndecl 0 50573 NULL nohasharray
+disable_so_dummy_buffer_addr_hi_fcoe_kwqe_init1_50573 dummy_buffer_addr_hi fcoe_kwqe_init1 0 50573 &disable_so_lp8788_rtc_read_time_fndecl_50573 nohasharray
+disable_so_power_page_addr_pm80x_subchip_50573 power_page_addr pm80x_subchip 0 50573 &disable_so_dummy_buffer_addr_hi_fcoe_kwqe_init1_50573
+disable_so_beacon_timeout_ieee80211_if_managed_50580 beacon_timeout ieee80211_if_managed 0 50580 NULL
+disable_so_mag3110_get_samp_freq_index_fndecl_50581 mag3110_get_samp_freq_index fndecl 0 50581 NULL
+disable_so_sock_get_timestamp_fndecl_50582 sock_get_timestamp fndecl 0 50582 NULL
+disable_so_addr_low_lancer_cmd_req_read_object_50585 addr_low lancer_cmd_req_read_object 0 50585 NULL
+disable_so_regcache_lzo_write_fndecl_50595 regcache_lzo_write fndecl 0-2-3 50595 NULL
+disable_so_enable_time_regulator_desc_50604 enable_time regulator_desc 0 50604 NULL
+disable_so___cpufreq_driver_target_fndecl_50610 __cpufreq_driver_target fndecl 2 50610 NULL
+disable_so_mt_ctxbitmap_gru_mm_tracker_50612 mt_ctxbitmap gru_mm_tracker 0 50612 NULL
+disable_so_compat_sys_futimesat_fndecl_50617 compat_sys_futimesat fndecl 1-0 50617 NULL
+disable_so_bind_timeout_rpc_xprt_50622 bind_timeout rpc_xprt 0 50622 NULL
+disable_so_wait_conversion_complete_interrupt_fndecl_50628 wait_conversion_complete_interrupt fndecl 0 50628 NULL
+disable_so_minimum_acpi_address64_attribute_50631 minimum acpi_address64_attribute 0 50631 NULL
+disable_so_radix_tree_delete_fndecl_50632 radix_tree_delete fndecl 2 50632 NULL
+disable_so_snd_timer_user_stop_fndecl_50656 snd_timer_user_stop fndecl 0 50656 NULL
+disable_so_m_hi_cfg_timing_div_drxk_state_50665 m_hi_cfg_timing_div drxk_state 0 50665 NULL
+disable_so_r_timeout_ceph_mds_request_50669 r_timeout ceph_mds_request 0 50669 NULL
+disable_so_snd_timer_continue_fndecl_50670 snd_timer_continue fndecl 0 50670 NULL
+disable_so_dwc3_ep0_set_isoch_delay_fndecl_50672 dwc3_ep0_set_isoch_delay fndecl 0 50672 NULL
+disable_so_btree_submit_bio_hook_fndecl_50677 btree_submit_bio_hook fndecl 0-2-6 50677 NULL
+disable_so_start_pid_hrtimer_50687 start_pid hrtimer 0 50687 NULL
+disable_so_deliver_posted_interrupt_kvm_x86_ops_50698 deliver_posted_interrupt kvm_x86_ops 2 50698 NULL
+disable_so_pwm_divisor_max8997_haptic_50704 pwm_divisor max8997_haptic 0 50704 NULL
+disable_so_dma_addr_iwl_queue_50725 dma_addr iwl_queue 0 50725 NULL
+disable_so_di_uid_qnx4_inode_entry_50728 di_uid qnx4_inode_entry 0 50728 NULL
+disable_so_nfs_idmap_cache_timeout_vardecl_50733 nfs_idmap_cache_timeout vardecl 0 50733 NULL
+disable_so_carl9170_set_beacon_timers_fndecl_50741 carl9170_set_beacon_timers fndecl 0 50741 NULL
+disable_so_msg_addr_hi_vf_pf_event_data_50756 msg_addr_hi vf_pf_event_data 0 50756 NULL
+disable_so_jiffies_vid_cap_vivid_dev_50760 jiffies_vid_cap vivid_dev 0 50760 NULL
+disable_so_addr_amdgpu_dummy_page_50765 addr amdgpu_dummy_page 0 50765 NULL
+disable_so_img_i2c_raw_atomic_delay_handler_fndecl_50779 img_i2c_raw_atomic_delay_handler fndecl 0 50779 NULL
+disable_so_dst_addr_filter_ipv4_5tuple_50793 dst_addr filter_ipv4_5tuple 0 50793 NULL
+disable_so_remote_ca_guid_ib_cm_rep_event_param_50795 remote_ca_guid ib_cm_rep_event_param 0 50795 NULL nohasharray
+disable_so_ioaddr_physical_voice_info_50795 ioaddr physical_voice_info 0 50795 &disable_so_remote_ca_guid_ib_cm_rep_event_param_50795
+disable_so_xfs_btree_log_recs_fndecl_50800 xfs_btree_log_recs fndecl 3-4 50800 NULL
+disable_so_iwl_sta_modify_sleep_tx_count_fndecl_50811 iwl_sta_modify_sleep_tx_count fndecl 2 50811 NULL nohasharray
+disable_so_ldt_tss_segment_16_50811 ldt tss_segment_16 0 50811 &disable_so_iwl_sta_modify_sleep_tx_count_fndecl_50811
+disable_so_adxl34x_autosleep_store_fndecl_50816 adxl34x_autosleep_store fndecl 0-4 50816 NULL
+disable_so_io_schedule_timeout_fndecl_50822 io_schedule_timeout fndecl 1-0 50822 NULL
+disable_so_addr_pm8001_prd_50827 addr pm8001_prd 0 50827 NULL
+disable_so_hfsplus_btree_write_fndecl_50829 hfsplus_btree_write fndecl 0 50829 NULL
+disable_so_jfs_strfromUCS_le_fndecl_50830 jfs_strfromUCS_le fndecl 0-3 50830 NULL
+disable_so_dmaaddr_b43_dmadesc_meta_50842 dmaaddr b43_dmadesc_meta 0 50842 NULL
+disable_so_eh_timeout_scsi_device_50843 eh_timeout scsi_device 0 50843 NULL
+disable_so_max_buffer_time_batadv_priv_nc_50848 max_buffer_time batadv_priv_nc 0 50848 NULL
+disable_so_mask_timecounter_50851 mask timecounter 0 50851 NULL
+disable_so_i2c_addr_cx24113_config_50855 i2c_addr cx24113_config 0 50855 NULL
+disable_so_clock_khz_ocores_i2c_platform_data_50856 clock_khz ocores_i2c_platform_data 0 50856 NULL nohasharray
+disable_so_i2c_addr_i2c_device_addr_50856 i2c_addr i2c_device_addr 0 50856 &disable_so_clock_khz_ocores_i2c_platform_data_50856
+disable_so_lp_rx_timeout_intel_dsi_50859 lp_rx_timeout intel_dsi 0 50859 NULL nohasharray
+disable_so_crypto_authenc_givencrypt_done_fndecl_50859 crypto_authenc_givencrypt_done fndecl 2 50859 &disable_so_lp_rx_timeout_intel_dsi_50859
+disable_so_origninator_host_cmd_ds_11n_batimeout_50866 origninator host_cmd_ds_11n_batimeout 0 50866 NULL
+disable_so_ip_vs_conn_hashkey_fndecl_50872 ip_vs_conn_hashkey fndecl 0-2-3 50872 NULL
+disable_so_twa_aen_sync_time_fndecl_50875 twa_aen_sync_time fndecl 2 50875 NULL
+disable_so_cachedaddr_irda_sock_50876 cachedaddr irda_sock 0 50876 NULL
+disable_so_carl9170_find_freq_idx_fndecl_50881 carl9170_find_freq_idx fndecl 3 50881 NULL
+disable_so___next_timer_interrupt_fndecl_50887 __next_timer_interrupt fndecl 0 50887 NULL
+disable_so_reg_addr_reg_val_50891 reg_addr reg_val 0 50891 NULL
+disable_so_dma_ring_addr_i40e_virtchnl_txq_info_50900 dma_ring_addr i40e_virtchnl_txq_info 0 50900 NULL
+disable_so_interval_tree_subtree_search_fndecl_50901 interval_tree_subtree_search fndecl 2-3 50901 NULL
+disable_so_xfs_btree_log_ptrs_fndecl_50906 xfs_btree_log_ptrs fndecl 3-4 50906 NULL
+disable_so_dib8000_get_time_us_fndecl_50908 dib8000_get_time_us fndecl 0 50908 NULL
+disable_so_iscsi_nacl_attrib_store_random_datain_pdu_offsets_fndecl_50909 iscsi_nacl_attrib_store_random_datain_pdu_offsets fndecl 0-3 50909 NULL nohasharray
+disable_so_seq_ceph_snap_context_50909 seq ceph_snap_context 0 50909 &disable_so_iscsi_nacl_attrib_store_random_datain_pdu_offsets_fndecl_50909
+disable_so_v_radeon_vce_clock_voltage_dependency_entry_50914 v radeon_vce_clock_voltage_dependency_entry 0 50914 NULL
+disable_so_authenc_verify_ahash_update_done_fndecl_50918 authenc_verify_ahash_update_done fndecl 2 50918 NULL
+disable_so___get_order_fndecl_50924 __get_order fndecl 0-1 50924 NULL
+disable_so_ahash_complete_fndecl_50926 ahash_complete fndecl 2 50926 NULL
+disable_so_aes_encrypt_interrupt_read_fndecl_50940 aes_encrypt_interrupt_read fndecl 3-0 50940 NULL
+disable_so_m_freq_tbl_50942 m freq_tbl 0 50942 NULL
+disable_so_faddr_ptd_50953 faddr ptd 0 50953 NULL
+disable_so_ceph_mdsmap_get_addr_fndecl_50967 ceph_mdsmap_get_addr fndecl 2 50967 NULL
+disable_so_cma_bitmap_aligned_mask_fndecl_50977 cma_bitmap_aligned_mask fndecl 0-2 50977 NULL
+disable_so_iscsi_tpg_attrib_show_login_timeout_fndecl_50979 iscsi_tpg_attrib_show_login_timeout fndecl 0 50979 NULL
+disable_so_send_set_imon_clock_fndecl_50982 send_set_imon_clock fndecl 0 50982 NULL
+disable_so_inet_saddr_inet_sock_50990 inet_saddr inet_sock 0 50990 NULL
+disable_so_qlcnic_get_mac_address_fndecl_50991 qlcnic_get_mac_address fndecl 3 50991 NULL
+disable_so_afs_get_MAC_address_fndecl_50999 afs_get_MAC_address fndecl 0 50999 NULL
+disable_so_timestamp_batadv_frag_table_entry_51002 timestamp batadv_frag_table_entry 0 51002 NULL nohasharray
+disable_so_dn_rt_hash_mask_vardecl_dn_route_c_51002 dn_rt_hash_mask vardecl_dn_route.c 0 51002 &disable_so_timestamp_batadv_frag_table_entry_51002
+disable_so_phy_addr_tg3_51010 phy_addr tg3 0 51010 NULL
+disable_so_vmx_set_tss_addr_fndecl_51020 vmx_set_tss_addr fndecl 0-2 51020 NULL
+disable_so_dialed_frequency_ptp_clock_51022 dialed_frequency ptp_clock 0 51022 NULL nohasharray
+disable_so_get_std_timing_fndecl_51022 get_std_timing fndecl 0 51022 &disable_so_dialed_frequency_ptp_clock_51022
+disable_so_hdspm_get_pll_freq_fndecl_51023 hdspm_get_pll_freq fndecl 0 51023 NULL
+disable_so_sb_timeshift_hpfs_sb_info_51027 sb_timeshift hpfs_sb_info 0 51027 NULL
+disable_so_ob_baseaddr_l_mvumi_hs_page4_51028 ob_baseaddr_l mvumi_hs_page4 0 51028 NULL
+disable_so_tw_snd_nxt_tcp_timewait_sock_51035 tw_snd_nxt tcp_timewait_sock 0 51035 NULL
+disable_so_buffer_used_snd_pcm_oss_runtime_51041 buffer_used snd_pcm_oss_runtime 0 51041 NULL
+disable_so_read_addr_qla8xxx_minidump_entry_queue_51046 read_addr qla8xxx_minidump_entry_queue 0 51046 NULL
+disable_so_address_vardecl_it8712f_wdt_c_51057 address vardecl_it8712f_wdt.c 0 51057 NULL
+disable_so_kr_rcvhdraddr_ipath_kregs_51063 kr_rcvhdraddr ipath_kregs 0 51063 NULL
+disable_so_wlcore_hw_ap_sleep_fndecl_51069 wlcore_hw_ap_sleep fndecl 0 51069 NULL
+disable_so_vnic_dev_intr_coal_timer_info_fndecl_51076 vnic_dev_intr_coal_timer_info fndecl 0 51076 NULL
+disable_so_table2_addr_ipw2100_ordinals_51081 table2_addr ipw2100_ordinals 0 51081 NULL
+disable_so_addr_bnx2x_phy_51087 addr bnx2x_phy 0 51087 NULL
+disable_so_xfs_btree_copy_ptrs_fndecl_51093 xfs_btree_copy_ptrs fndecl 4 51093 NULL
+disable_so_core_frequency_transition_fndecl_51097 core_frequency_transition fndecl 2 51097 NULL
+disable_so_msr_ioctl_fndecl_51103 msr_ioctl fndecl 0 51103 NULL
+disable_so_split_timeout_hi_fw_card_51105 split_timeout_hi fw_card 0 51105 NULL
+disable_so_msg_bits_ccp_sha_req_ctx_51106 msg_bits ccp_sha_req_ctx 0 51106 NULL
+disable_so_page_order_btree_keys_51110 page_order btree_keys 0 51110 NULL
+disable_so_pvclock_gtod_register_notifier_fndecl_51113 pvclock_gtod_register_notifier fndecl 0 51113 NULL
+disable_so_cfg80211_ibss_wext_siwfreq_fndecl_51119 cfg80211_ibss_wext_siwfreq fndecl 0 51119 NULL
+disable_so_pan_id_ieee802154_hw_addr_filt_51121 pan_id ieee802154_hw_addr_filt 0 51121 NULL
+disable_so_alignmask_blkcipher_walk_51130 alignmask blkcipher_walk 0 51130 NULL
+disable_so_i2c_master_send_fndecl_51152 i2c_master_send fndecl 3-0 51152 NULL
+disable_so_skcipher_null_givencrypt_fndecl_51153 skcipher_null_givencrypt fndecl 0 51153 NULL
+disable_so_hr_last_timeout_start_o2hb_region_51155 hr_last_timeout_start o2hb_region 0 51155 NULL
+disable_so_cycles_ath_cycle_counters_51156 cycles ath_cycle_counters 0 51156 NULL
+disable_so_notify_remote_via_irq_fndecl_51164 notify_remote_via_irq fndecl 1 51164 NULL
+disable_so_onenand_block_address_fndecl_51167 onenand_block_address fndecl 0-2 51167 NULL
+disable_so_ctimensec_fuse_setattr_in_51177 ctimensec fuse_setattr_in 0 51177 NULL
+disable_so_exp_time_mesh_path_51180 exp_time mesh_path 0 51180 NULL
+disable_so_tcp_try_rmem_schedule_fndecl_51194 tcp_try_rmem_schedule fndecl 3 51194 NULL
+disable_so_avail_mlx4_bitmap_51198 avail mlx4_bitmap 0 51198 NULL
+disable_so_s2mpa01_set_ramp_delay_fndecl_51200 s2mpa01_set_ramp_delay fndecl 0 51200 NULL
+disable_so_addr_e820entry_51224 addr e820entry 0 51224 NULL
+disable_so_rx_dma_addr_smsc9420_pdata_51225 rx_dma_addr smsc9420_pdata 0 51225 NULL
+disable_so_trf7970a_pm_runtime_resume_fndecl_51233 trf7970a_pm_runtime_resume fndecl 0 51233 NULL
+disable_so_pfkey_sockaddr_extract_fndecl_51238 pfkey_sockaddr_extract fndecl 0 51238 NULL
+disable_so_clock_snd_ac97_bus_51245 clock snd_ac97_bus 0 51245 NULL
+disable_so_mtime_dir_entry_51261 mtime dir_entry 0 51261 NULL
+disable_so_address_upper_scu_sgl_element_51271 address_upper scu_sgl_element 0 51271 NULL
+disable_so_resolution_vardecl_hrtimer_c_51279 resolution vardecl_hrtimer.c 0 51279 NULL nohasharray
+disable_so_r600_dpm_get_vblank_time_fndecl_51279 r600_dpm_get_vblank_time fndecl 0 51279 &disable_so_resolution_vardecl_hrtimer_c_51279
+disable_so___ndelay_fndecl_51287 __ndelay fndecl 1 51287 NULL
+disable_so_hashbin_lock_find_fndecl_51294 hashbin_lock_find fndecl 2 51294 NULL
+disable_so_snd_es1968_apu_set_freq_fndecl_51295 snd_es1968_apu_set_freq fndecl 3 51295 NULL
+disable_so_lvb_iuid_ocfs2_meta_lvb_51297 lvb_iuid ocfs2_meta_lvb 0 51297 NULL
+disable_so_usb2_lpm_l1_timeout_show_fndecl_51308 usb2_lpm_l1_timeout_show fndecl 0 51308 NULL
+disable_so_addrHigh_ULP_BDL_51312 addrHigh ULP_BDL 0 51312 NULL
+disable_so_alarm_timer_nsleep_fndecl_51313 alarm_timer_nsleep fndecl 1 51313 NULL nohasharray
+disable_so_cpufreq_get_max_state_fndecl_51313 cpufreq_get_max_state fndecl 1 51313 &disable_so_alarm_timer_nsleep_fndecl_51313
+disable_so_addr_buffer2_cmd_desc_type0_51316 addr_buffer2 cmd_desc_type0 0 51316 NULL
+disable_so___mlx4_cmd_fndecl_51319 __mlx4_cmd fndecl 0-2-5 51319 NULL
+disable_so_addr_nvif_ioctl_rd_v0_51321 addr nvif_ioctl_rd_v0 0 51321 NULL
+disable_so_register_write_lock_rt2800_ops_51323 register_write_lock rt2800_ops 3 51323 NULL
+disable_so_addr_host_sg_desc_51324 addr host_sg_desc 0 51324 NULL
+disable_so_swc_base_addr_vardecl_pc87413_wdt_c_51328 swc_base_addr vardecl_pc87413_wdt.c 0 51328 NULL
+disable_so_myri10ge_set_mac_address_fndecl_51332 myri10ge_set_mac_address fndecl 0 51332 NULL
+disable_so_xt_ct_set_timeout_fndecl_51333 xt_ct_set_timeout fndecl 0 51333 NULL
+disable_so_crypto_ahash_digest_fndecl_51343 crypto_ahash_digest fndecl 0 51343 NULL
+disable_so_calculate_next_time_fndecl_51345 calculate_next_time fndecl 0 51345 NULL
+disable_so_from_kgid_fndecl_51359 from_kgid fndecl 0 51359 NULL
+disable_so_dm9161_ack_interrupt_fndecl_51361 dm9161_ack_interrupt fndecl 0 51361 NULL nohasharray
+disable_so_write_addr_mdc_hw_list_desc_51361 write_addr mdc_hw_list_desc 0 51361 &disable_so_dm9161_ack_interrupt_fndecl_51361
+disable_so_clock_kvm_clock_data_51363 clock kvm_clock_data 0 51363 NULL
+disable_so_sapi_sockaddr_mISDN_51369 sapi sockaddr_mISDN 0 51369 NULL
+disable_so_act8b_ide_timing_51373 act8b ide_timing 0 51373 NULL
+disable_so_driver_data_cpufreq_frequency_table_51376 driver_data cpufreq_frequency_table 0 51376 NULL
+disable_so_timeout_clk_sdhci_host_51378 timeout_clk sdhci_host 0 51378 NULL
+disable_so_ref_div_rv7xx_power_info_51381 ref_div rv7xx_power_info 0 51381 NULL
+disable_so_event_jiffies_atkbd_51387 event_jiffies atkbd 0 51387 NULL
+disable_so_addr_kvm_coalesced_mmio_zone_51392 addr kvm_coalesced_mmio_zone 0 51392 NULL
+disable_so_print_fatal_signal_fndecl_51397 print_fatal_signal fndecl 1 51397 NULL
+disable_so_de_media_interrupt_fndecl_51410 de_media_interrupt fndecl 2 51410 NULL nohasharray
+disable_so_cryptomgr_schedule_probe_fndecl_51410 cryptomgr_schedule_probe fndecl 0 51410 &disable_so_de_media_interrupt_fndecl_51410
+disable_so_ql_set_mac_addr_reg_fndecl_51414 ql_set_mac_addr_reg fndecl 0-4 51414 NULL
+disable_so_iscsi_stat_sess_show_attr_conn_timeout_errors_fndecl_51417 iscsi_stat_sess_show_attr_conn_timeout_errors fndecl 0 51417 NULL
+disable_so_read_addr_qla8044_minidump_entry_cache_51419 read_addr qla8044_minidump_entry_cache 0 51419 NULL
+disable_so_clk_freq_khz_pll_tab_51420 clk_freq_khz pll_tab 0 51420 NULL
+disable_so_pll_d_aic32x4_rate_divs_51425 pll_d aic32x4_rate_divs 0 51425 NULL
+disable_so_T6_address_mxt_data_51429 T6_address mxt_data 0 51429 NULL
+disable_so_q_addr_ioat_pq_descriptor_51439 q_addr ioat_pq_descriptor 0 51439 NULL
+disable_so_imx_phy_crbit_assert_fndecl_51461 imx_phy_crbit_assert fndecl 0 51461 NULL
+disable_so_soc_camera_clock_start_fndecl_51464 soc_camera_clock_start fndecl 0 51464 NULL
+disable_so_after_ctime_nsec_nfsd4_change_info_51470 after_ctime_nsec nfsd4_change_info 0 51470 NULL
+disable_so_free_fall_time_adxl34x_platform_data_51477 free_fall_time adxl34x_platform_data 0 51477 NULL
+disable_so_new_c_uuid_parms_from_attrs_fndecl_51480 new_c_uuid_parms_from_attrs fndecl 0 51480 NULL
+disable_so_addr_high_mcp_kreq_ether_recv_51484 addr_high mcp_kreq_ether_recv 0 51484 NULL
+disable_so_min_freq_ufs_clk_info_51485 min_freq ufs_clk_info 0 51485 NULL
+disable_so_force_addr_vardecl_sis5595_c_51490 force_addr vardecl_sis5595.c 0 51490 NULL
+disable_so_byt_freq_opcode_fndecl_51497 byt_freq_opcode fndecl 0-2 51497 NULL
+disable_so_vco_gma_clock_t_51506 vco gma_clock_t 0 51506 NULL
+disable_so_saddr_irlan_cb_51519 saddr irlan_cb 0 51519 NULL
+disable_so_r14_kvm_regs_51526 r14 kvm_regs 0 51526 NULL
+disable_so_sys_image_guid_ib_device_modify_51537 sys_image_guid ib_device_modify 0 51537 NULL
+disable_so_abx500_mask_and_set_register_interruptible_fndecl_51542 abx500_mask_and_set_register_interruptible fndecl 0-5 51542 NULL
+disable_so_show_constraint_min_time_window_us_fndecl_51544 show_constraint_min_time_window_us fndecl 0 51544 NULL
+disable_so_phys_addr_sge_rspq_51550 phys_addr sge_rspq 0 51550 NULL
+disable_so_tw_substate_inet_timewait_sock_51564 tw_substate inet_timewait_sock 0 51564 NULL
+disable_so_ebx_user_regs_struct32_51572 ebx user_regs_struct32 0 51572 NULL
+disable_so_snd_azf3328_interrupt_fndecl_51583 snd_azf3328_interrupt fndecl 1 51583 NULL
+disable_so_wl1251_acx_rx_msdu_life_time_fndecl_51591 wl1251_acx_rx_msdu_life_time fndecl 0 51591 NULL
+disable_so_grh_gid_fl_mlx5_av_51610 grh_gid_fl mlx5_av 0 51610 NULL
+disable_so_space_id_acpi_object_addr_handler_51611 space_id acpi_object_addr_handler 0 51611 NULL
+disable_so_pick_local_ip6addrs_fndecl_51615 pick_local_ip6addrs fndecl 0 51615 NULL
+disable_so_nmi_perfctr_msr_to_bit_fndecl_51618 nmi_perfctr_msr_to_bit fndecl 0-1 51618 NULL
+disable_so_dcc_timeout_vardecl_nf_conntrack_irc_c_51622 dcc_timeout vardecl_nf_conntrack_irc.c 0 51622 NULL
+disable_so_ath9k_hw_fbin2freq_fndecl_51628 ath9k_hw_fbin2freq fndecl 0-1 51628 NULL
+disable_so_audit_signal_info_fndecl_51630 audit_signal_info fndecl 0-1 51630 NULL
+disable_so_sirdev_schedule_request_fndecl_51632 sirdev_schedule_request fndecl 3-0 51632 NULL
+disable_so_stb0899_write_s2reg_fndecl_51642 stb0899_write_s2reg fndecl 5-0 51642 NULL nohasharray
+disable_so_sha512_ssse3_mod_init_fndecl_51642 sha512_ssse3_mod_init fndecl 0 51642 &disable_so_stb0899_write_s2reg_fndecl_51642
+disable_so_get_bitmap_fndecl_51645 get_bitmap fndecl 0-2 51645 NULL
+disable_so_total_bitmaps_btrfs_free_space_ctl_51648 total_bitmaps btrfs_free_space_ctl 0 51648 NULL
+disable_so_sk_wmem_schedule_fndecl_51651 sk_wmem_schedule fndecl 2 51651 NULL
+disable_so_btree_readpage_end_io_hook_fndecl_51654 btree_readpage_end_io_hook fndecl 0 51654 NULL
+disable_so_delay_pi_adapter_51655 delay pi_adapter 0 51655 NULL
+disable_so_snd_pcm_new_fndecl_51660 snd_pcm_new fndecl 0-3-4-5 51660 NULL
+disable_so_soft_add_expires_seconds_xfrm_lifetime_cfg_51674 soft_add_expires_seconds xfrm_lifetime_cfg 0 51674 NULL
+disable_so_ib_query_gid_fndecl_51677 ib_query_gid fndecl 0-2-3 51677 NULL
+disable_so_m_hi_cfg_timeout_drxk_state_51689 m_hi_cfg_timeout drxk_state 0 51689 NULL
+disable_so_mma9553_runtime_resume_fndecl_51690 mma9553_runtime_resume fndecl 0 51690 NULL
+disable_so_phy_pm_runtime_put_fndecl_51692 phy_pm_runtime_put fndecl 0 51692 NULL
+disable_so_cdclk_freq_drm_i915_private_51693 cdclk_freq drm_i915_private 0 51693 NULL
+disable_so__get_div_fndecl_51696 _get_div fndecl 2-0 51696 NULL
+disable_so_sit_ver_bitmap_bytesize_f2fs_checkpoint_51697 sit_ver_bitmap_bytesize f2fs_checkpoint 0 51697 NULL
+disable_so_seq_framebuf_51700 seq framebuf 0 51700 NULL nohasharray
+disable_so_tsc_drv_init_fndecl_51700 tsc_drv_init fndecl 0 51700 &disable_so_seq_framebuf_51700
+disable_so_lower_first_uid_gid_extent_51714 lower_first uid_gid_extent 0 51714 NULL
+disable_so_acpi_enter_sleep_state_prep_fndecl_51716 acpi_enter_sleep_state_prep fndecl 0-1 51716 NULL
+disable_so_set_data_timeout_fndecl_51718 set_data_timeout fndecl 2-3 51718 NULL
+disable_so_suspend_test_start_time_vardecl_suspend_test_c_51720 suspend_test_start_time vardecl_suspend_test.c 0 51720 NULL
+disable_so_phy_addr_uli526x_board_info_51722 phy_addr uli526x_board_info 0 51722 NULL
+disable_so_vdelay_bttv_geometry_51725 vdelay bttv_geometry 0 51725 NULL
+disable_so_rv6xx_find_memory_clock_with_highest_vco_fndecl_51726 rv6xx_find_memory_clock_with_highest_vco fndecl 2-3 51726 NULL
+disable_so_blocksize_crypto_report_hash_51730 blocksize crypto_report_hash 0 51730 NULL
+disable_so_set_param_timeout_fndecl_51735 set_param_timeout fndecl 0 51735 NULL
+disable_so_iowrite16be_fndecl_51739 iowrite16be fndecl 1 51739 NULL
+disable_so_lvds_chip_slave_addr_lvds_chip_information_51750 lvds_chip_slave_addr lvds_chip_information 0 51750 NULL
+disable_so_xhci_queue_address_device_fndecl_51755 xhci_queue_address_device fndecl 0-3-4 51755 NULL
+disable_so_rx_abs_int_delay_e1000_adapter_51763 rx_abs_int_delay e1000_adapter 0 51763 NULL
+disable_so_ext4_wait_block_bitmap_fndecl_51764 ext4_wait_block_bitmap fndecl 2 51764 NULL
+disable_so_tid_host_cmd_ds_11n_batimeout_51772 tid host_cmd_ds_11n_batimeout 0 51772 NULL
+disable_so_mpll_ss1_rv770_clock_registers_51773 mpll_ss1 rv770_clock_registers 0 51773 NULL
+disable_so_xpc_disengage_timelimit_vardecl_51789 xpc_disengage_timelimit vardecl 0 51789 NULL
+disable_so_current_dispclk_radeon_clock_51795 current_dispclk radeon_clock 0 51795 NULL
+disable_so_mclk_sm501_clock_51799 mclk sm501_clock 0 51799 NULL
+disable_so_frequency_mixart_clock_properties_51800 frequency mixart_clock_properties 0 51800 NULL nohasharray
+disable_so_freq_p54_rssi_db_entry_51800 freq p54_rssi_db_entry 0 51800 &disable_so_frequency_mixart_clock_properties_51800
+disable_so_display_delay_enable_s5p_mfc_ctx_51814 display_delay_enable s5p_mfc_ctx 0 51814 NULL
+disable_so_phys_to_virt_fndecl_51830 phys_to_virt fndecl 1 51830 NULL
+disable_so___lock_timer_fndecl_51836 __lock_timer fndecl 1 51836 NULL
+disable_so_gid_index_mthca_av_51840 gid_index mthca_av 0 51840 NULL
+disable_so_physical_address_smbios_cru64_info_51854 physical_address smbios_cru64_info 0 51854 NULL
+disable_so_sleep_em28xx_reg_seq_51857 sleep em28xx_reg_seq 0 51857 NULL
+disable_so_current_frequency_or51211_state_51860 current_frequency or51211_state 0 51860 NULL
+disable_so_timer_trig_init_fndecl_51865 timer_trig_init fndecl 0 51865 NULL
+disable_so___posix_timers_find_fndecl_51867 __posix_timers_find fndecl 3 51867 NULL
+disable_so_xattr_hash_fndecl_51881 xattr_hash fndecl 2 51881 NULL
+disable_so_ntfs_bitmap_set_bit_fndecl_51888 ntfs_bitmap_set_bit fndecl 2 51888 NULL
+disable_so_hp_ntimer_hpets_51897 hp_ntimer hpets 0 51897 NULL
+disable_so_crypto_blkcipher_decrypt_iv_fndecl_51901 crypto_blkcipher_decrypt_iv fndecl 0-4 51901 NULL
+disable_so_emitted_jiffies_drm_i915_gem_request_51929 emitted_jiffies drm_i915_gem_request 0 51929 NULL
+disable_so_PageAddress__MPI2_CONFIG_REQUEST_51930 PageAddress _MPI2_CONFIG_REQUEST 0 51930 NULL
+disable_so_mlx4_read_clock_fndecl_51933 mlx4_read_clock fndecl 0 51933 NULL
+disable_so_plh_retry_timestamp_pnfs_layout_hdr_51936 plh_retry_timestamp pnfs_layout_hdr 0 51936 NULL nohasharray
+disable_so_ext4_set_bitmap_checksums_fndecl_51936 ext4_set_bitmap_checksums fndecl 0-2 51936 &disable_so_plh_retry_timestamp_pnfs_layout_hdr_51936
+disable_so_padlock_sha256_finup_fndecl_51938 padlock_sha256_finup fndecl 0 51938 NULL
+disable_so_delay_usec_e1000_nvm_info_51943 delay_usec e1000_nvm_info 0 51943 NULL
+disable_so_guest_phys_addr_kvm_userspace_memory_region_51947 guest_phys_addr kvm_userspace_memory_region 0 51947 NULL
+disable_so_addr_drm_radeon_gem_userptr_51948 addr drm_radeon_gem_userptr 0 51948 NULL
+disable_so__regulator_enable_delay_fndecl_51949 _regulator_enable_delay fndecl 1 51949 NULL
+disable_so_grp_time_xfs_mru_cache_51952 grp_time xfs_mru_cache 0 51952 NULL
+disable_so_clock_realtek_pci_ms_51953 clock realtek_pci_ms 0 51953 NULL
+disable_so_sm_ll_lookup_bitmap_fndecl_51973 sm_ll_lookup_bitmap fndecl 0-2 51973 NULL
+disable_so_sa_family_sockaddr_51986 sa_family sockaddr 0 51986 NULL
+disable_so_i_dtime_ext3_inode_info_51992 i_dtime ext3_inode_info 0 51992 NULL
+disable_so_bitmap_ipmac_gc_test_fndecl_51993 bitmap_ipmac_gc_test fndecl 3 51993 NULL
+disable_so_ocfs2_change_ctime_fndecl_52000 ocfs2_change_ctime fndecl 0 52000 NULL
+disable_so_sadb_lifetime_usetime_sadb_lifetime_52005 sadb_lifetime_usetime sadb_lifetime 0 52005 NULL
+disable_so_sysctl_lap_keepalive_time_vardecl_52006 sysctl_lap_keepalive_time vardecl 0 52006 NULL nohasharray
+disable_so_address_u132_command_52006 address u132_command 0 52006 &disable_so_sysctl_lap_keepalive_time_vardecl_52006
+disable_so_txdesc_interrupt_mask_ath_hw_52011 txdesc_interrupt_mask ath_hw 0 52011 NULL
+disable_so_rebind_irq_to_cpu_fndecl_52013 rebind_irq_to_cpu fndecl 1-2 52013 NULL
+disable_so_gid_numa_group_52023 gid numa_group 0 52023 NULL
+disable_so_cpuidle_add_sysfs_fndecl_52026 cpuidle_add_sysfs fndecl 0 52026 NULL
+disable_so_selinux_task_getpgid_fndecl_52032 selinux_task_getpgid fndecl 0 52032 NULL
+disable_so_demod_address_cx24116_config_52035 demod_address cx24116_config 0 52035 NULL
+disable_so_sched_group_set_rt_runtime_fndecl_52036 sched_group_set_rt_runtime fndecl 2-0 52036 NULL
+disable_so_ntp_error_timekeeper_52044 ntp_error timekeeper 0 52044 NULL
+disable_so_sys_addr_to_dram_addr_fndecl_52052 sys_addr_to_dram_addr fndecl 0-2 52052 NULL
+disable_so_shared_data_busaddr_ahc_softc_52059 shared_data_busaddr ahc_softc 0 52059 NULL
+disable_so_gl_demote_time_gfs2_glock_52068 gl_demote_time gfs2_glock 0 52068 NULL
+disable_so_m41t93_get_time_fndecl_52075 m41t93_get_time fndecl 0 52075 NULL
+disable_so_reg_val_coeff_clk_div_52082 reg_val coeff_clk_div 0 52082 NULL
+disable_so_dap_fcgs_gidpn_resp_s_52084 dap fcgs_gidpn_resp_s 0 52084 NULL
+disable_so_kbd_backlight_timeout_show_fndecl_52086 kbd_backlight_timeout_show fndecl 0 52086 NULL
+disable_so_ifa_address_in_ifaddr_52095 ifa_address in_ifaddr 0 52095 NULL
+disable_so_mmc_set_clock_fndecl_52096 mmc_set_clock fndecl 2 52096 NULL
+disable_so_constant_timex_52100 constant timex 0 52100 NULL
+disable_so_rds_ib_remove_ipaddr_fndecl_52103 rds_ib_remove_ipaddr fndecl 2 52103 NULL
+disable_so_adf4350_set_freq_fndecl_52106 adf4350_set_freq fndecl 0-2 52106 NULL
+disable_so_max_mtime_sit_info_52107 max_mtime sit_info 0 52107 NULL
+disable_so_retry_delay_timestamp_fc_port_52109 retry_delay_timestamp fc_port 0 52109 NULL
+disable_so_sha256_ssse3_mod_init_fndecl_52112 sha256_ssse3_mod_init fndecl 0 52112 NULL
+disable_so_nilfs_btree_init_fndecl_52115 nilfs_btree_init fndecl 0 52115 NULL
+disable_so_baseaddr_ds1685_priv_52117 baseaddr ds1685_priv 0 52117 NULL
+disable_so_vga_get_uninterruptible_fndecl_52134 vga_get_uninterruptible fndecl 0 52134 NULL
+disable_so_gr_handle_signal_fndecl_52137 gr_handle_signal fndecl 2 52137 NULL
+disable_so_sample_bits_snd_pcm_runtime_52138 sample_bits snd_pcm_runtime 0 52138 NULL
+disable_so_make_kgid_fndecl_52149 make_kgid fndecl 2 52149 NULL
+disable_so_skcipher_sendmsg_fndecl_52153 skcipher_sendmsg fndecl 0-3 52153 NULL
+disable_so_base_addr_ce_space_ath10k_ce_ring_52154 base_addr_ce_space ath10k_ce_ring 0 52154 NULL
+disable_so_msr_guest_kernel_gs_base_vcpu_vmx_52157 msr_guest_kernel_gs_base vcpu_vmx 0 52157 NULL
+disable_so_mpll_func_cntl_rv730_clock_registers_52160 mpll_func_cntl rv730_clock_registers 0 52160 NULL
+disable_so_system_time_xenpf_settime_52164 system_time xenpf_settime 0 52164 NULL
+disable_so_ddiv_gk104_clk_info_52171 ddiv gk104_clk_info 0 52171 NULL
+disable_so_detect_pll_input_clock_fndecl_52172 detect_pll_input_clock fndecl 1-0 52172 NULL
+disable_so_mpll_dq_func_cntl_2_ni_clock_registers_52173 mpll_dq_func_cntl_2 ni_clock_registers 0 52173 NULL
+disable_so_opmode_delay_picolcd_data_52176 opmode_delay picolcd_data 0 52176 NULL
+disable_so_get_display_clock_speed_drm_i915_display_funcs_52177 get_display_clock_speed drm_i915_display_funcs 0 52177 NULL
+disable_so_addr_lp8788_chg_param_52185 addr lp8788_chg_param 0 52185 NULL
+disable_so_beacon_interval_il_rxon_time_cmd_52191 beacon_interval il_rxon_time_cmd 0 52191 NULL
+disable_so_threshold_high_nes_hw_tune_timer_52193 threshold_high nes_hw_tune_timer 0 52193 NULL
+disable_so_timeout_ms_rdma_ucm_resolve_route_52203 timeout_ms rdma_ucm_resolve_route 0 52203 NULL
+disable_so___mmc_set_signal_voltage_fndecl_52208 __mmc_set_signal_voltage fndecl 0 52208 NULL
+disable_so_jhash_2words_fndecl_52211 jhash_2words fndecl 0-1-2 52211 NULL
+disable_so_suspend_time_iwl_scan_cmd_52218 suspend_time iwl_scan_cmd 0 52218 NULL
+disable_so_sha1_mb_async_update_fndecl_52220 sha1_mb_async_update fndecl 0 52220 NULL
+disable_so_sleep_cx231xx_reg_seq_52228 sleep cx231xx_reg_seq 0 52228 NULL
+disable_so_select_addr_1_qla8044_minidump_entry_rdmux2_52243 select_addr_1 qla8044_minidump_entry_rdmux2 0 52243 NULL nohasharray
+disable_so_SYSC_setregid_fndecl_52243 SYSC_setregid fndecl 0 52243 &disable_so_select_addr_1_qla8044_minidump_entry_rdmux2_52243
+disable_so_snd_pcm_timer_resolution_fndecl_52247 snd_pcm_timer_resolution fndecl 0 52247 NULL
+disable_so_s_hash_function_reiserfs_sb_info_52248 s_hash_function reiserfs_sb_info 0-2 52248 NULL
+disable_so_read_addr_qla8044_minidump_entry_rdmux2_52249 read_addr qla8044_minidump_entry_rdmux2 0 52249 NULL
+disable_so_comp_addr_lo_dmae_command_52260 comp_addr_lo dmae_command 0 52260 NULL
+disable_so_tsl2563_read_interrupt_config_fndecl_52267 tsl2563_read_interrupt_config fndecl 0 52267 NULL
+disable_so_mlx4_ib_init_alias_guid_service_fndecl_52269 mlx4_ib_init_alias_guid_service fndecl 0 52269 NULL
+disable_so_pvr2_hdw_get_eeprom_addr_fndecl_52271 pvr2_hdw_get_eeprom_addr fndecl 0 52271 NULL
+disable_so_coalescing_timeo_bna_ib_52276 coalescing_timeo bna_ib 0 52276 NULL
+disable_so_sll_protocol_sockaddr_ll_52284 sll_protocol sockaddr_ll 0 52284 NULL nohasharray
+disable_so_cmd64x_set_timing_fndecl_52284 cmd64x_set_timing fndecl 3 52284 &disable_so_sll_protocol_sockaddr_ll_52284
+disable_so_entrytime_batadv_bcast_duplist_entry_52297 entrytime batadv_bcast_duplist_entry 0 52297 NULL
+disable_so_cumul_ack_westwood_52298 cumul_ack westwood 0 52298 NULL
+disable_so_r2b_val_fc2580_freq_regs_52299 r2b_val fc2580_freq_regs 0 52299 NULL
+disable_so_btree_remove32_fndecl_52302 btree_remove32 fndecl 2 52302 NULL
+disable_so_btrfs_insert_delayed_items_fndecl_52308 btrfs_insert_delayed_items fndecl 0 52308 NULL
+disable_so_bios_limit_cpufreq_driver_52312 bios_limit cpufreq_driver 1 52312 NULL
+disable_so___nf_conntrack_hash_insert_fndecl_52323 __nf_conntrack_hash_insert fndecl 2-3 52323 NULL
+disable_so_rapl_get_attr_cpumask_fndecl_52324 rapl_get_attr_cpumask fndecl 0 52324 NULL
+disable_so_frequency_dst_state_52328 frequency dst_state 0 52328 NULL
+disable_so_status_fifo_addr_sbp_login_descriptor_52353 status_fifo_addr sbp_login_descriptor 0 52353 NULL
+disable_so_musb_write_txhubaddr_fndecl_52354 musb_write_txhubaddr fndecl 2-3 52354 NULL
+disable_so_cx18_msleep_timeout_fndecl_52356 cx18_msleep_timeout fndecl 1 52356 NULL
+disable_so_input_event_fndecl_52364 input_event fndecl 3-4 52364 NULL
+disable_so_timeout_ip_vs_sync_v6_52374 timeout ip_vs_sync_v6 0 52374 NULL
+disable_so_wait_on_bit_io_fndecl_52381 wait_on_bit_io fndecl 0 52381 NULL
+disable_so_mthca_mr_alloc_notrans_fndecl_52385 mthca_mr_alloc_notrans fndecl 0-2 52385 NULL
+disable_so_pwm_divisor_nvbios_perf_fan_52386 pwm_divisor nvbios_perf_fan 0 52386 NULL nohasharray
+disable_so_iscsi_ipv4addr_port_info_52386 iscsi_ipv4addr port_info 0 52386 &disable_so_pwm_divisor_nvbios_perf_fan_52386
+disable_so_dpp_unmapped_addr_be_dev_info_52388 dpp_unmapped_addr be_dev_info 0 52388 NULL nohasharray
+disable_so_request_threaded_irq_fndecl_52388 request_threaded_irq fndecl 0-1-4 52388 &disable_so_dpp_unmapped_addr_be_dev_info_52388
+disable_so_g84_cipher_ctor_fndecl_52389 g84_cipher_ctor fndecl 0 52389 NULL
+disable_so_time_constant_vardecl_ntp_c_52392 time_constant vardecl_ntp.c 0 52392 NULL nohasharray
+disable_so_sis_ata100_program_timings_fndecl_52392 sis_ata100_program_timings fndecl 2 52392 &disable_so_time_constant_vardecl_ntp_c_52392
+disable_so_hbqaddrHigh_config_hbq_var_52395 hbqaddrHigh config_hbq_var 0 52395 NULL
+disable_so_objectid_btrfs_delayed_data_ref_52398 objectid btrfs_delayed_data_ref 0 52398 NULL
+disable_so_btrfs_schedule_bio_fndecl_52412 btrfs_schedule_bio fndecl 3 52412 NULL
+disable_so_wm8804_set_clkdiv_fndecl_52423 wm8804_set_clkdiv fndecl 3 52423 NULL
+disable_so_tm_year_rtc_time_52437 tm_year rtc_time 0 52437 NULL
+disable_so_message_age_timer_value___port_info_52442 message_age_timer_value __port_info 0 52442 NULL nohasharray
+disable_so_genwqe_debugfs_prev_dbg_uid0_open_fndecl_52442 genwqe_debugfs_prev_dbg_uid0_open fndecl 0 52442 &disable_so_message_age_timer_value___port_info_52442
+disable_so_time_stamp_pch_gbe_buffer_52453 time_stamp pch_gbe_buffer 0 52453 NULL
+disable_so_fsl_pwm_calculate_cycles_fndecl_52454 fsl_pwm_calculate_cycles fndecl 0-2 52454 NULL
+disable_so_default_timetolive_sctp_association_52455 default_timetolive sctp_association 0 52455 NULL
+disable_so_xc2028_sleep_fndecl_52469 xc2028_sleep fndecl 0 52469 NULL
+disable_so_regulator_map_voltage_linear_fndecl_52488 regulator_map_voltage_linear fndecl 0-2-3 52488 NULL
+disable_so_nsecs_to_jiffies64_fndecl_52497 nsecs_to_jiffies64 fndecl 0-1 52497 NULL
+disable_so_pm_runtime_resume_fndecl_52501 pm_runtime_resume fndecl 0 52501 NULL
+disable_so_stop_threshold_snd_pcm_runtime_52503 stop_threshold snd_pcm_runtime 0 52503 NULL
+disable_so_il_get_passive_dwell_time_fndecl_52511 il_get_passive_dwell_time fndecl 0 52511 NULL nohasharray
+disable_so_show_src_clock_sel_fndecl_52511 show_src_clock_sel fndecl 0 52511 &disable_so_il_get_passive_dwell_time_fndecl_52511
+disable_so_mxl111sf_frontend_attach_atsc_mh_fndecl_52518 mxl111sf_frontend_attach_atsc_mh fndecl 0 52518 NULL
+disable_so_gcm_hash_assoc_continue_fndecl_52527 gcm_hash_assoc_continue fndecl 0 52527 NULL
+disable_so_time_next_packet_fq_flow_52535 time_next_packet fq_flow 0 52535 NULL nohasharray
+disable_so_exit_deep_sleep_lbs_private_52535 exit_deep_sleep lbs_private 0 52535 &disable_so_time_next_packet_fq_flow_52535
+disable_so_page_check_address_pmd_fndecl_52537 page_check_address_pmd fndecl 3 52537 NULL
+disable_so_stime_signal_struct_52540 stime signal_struct 0 52540 NULL nohasharray
+disable_so_hblank_lo_oaktrail_timing_info_52540 hblank_lo oaktrail_timing_info 0 52540 &disable_so_stime_signal_struct_52540
+disable_so_sgl_pg1_addr_lo_sgl_page_pairs_52550 sgl_pg1_addr_lo sgl_page_pairs 0 52550 NULL
+disable_so_tx_timeout_last_recovery_i40e_pf_52564 tx_timeout_last_recovery i40e_pf 0 52564 NULL nohasharray
+disable_so_clock_name_show_fndecl_52564 clock_name_show fndecl 0 52564 &disable_so_tx_timeout_last_recovery_i40e_pf_52564
+disable_so_c67x00_sched_start_scheduler_fndecl_52570 c67x00_sched_start_scheduler fndecl 0 52570 NULL
+disable_so_acpi_sleep_tts_switch_fndecl_52575 acpi_sleep_tts_switch fndecl 1 52575 NULL
+disable_so_addr0_nphy_rf_control_override_rev2_52577 addr0 nphy_rf_control_override_rev2 0 52577 NULL
+disable_so_tv_nsec_xfs_bstime_52584 tv_nsec xfs_bstime 0 52584 NULL
+disable_so_xfs_btree_check_sptr_fndecl_52587 xfs_btree_check_sptr fndecl 0 52587 NULL
+disable_so_get_vmx_mem_address_fndecl_52590 get_vmx_mem_address fndecl 3 52590 NULL
+disable_so_suspend_time_il3945_scan_cmd_52601 suspend_time il3945_scan_cmd 0 52601 NULL nohasharray
+disable_so_ahash_def_finup_finish2_fndecl_52601 ahash_def_finup_finish2 fndecl 2 52601 &disable_so_suspend_time_il3945_scan_cmd_52601
+disable_so_si4713_s_frequency_fndecl_52608 si4713_s_frequency fndecl 0 52608 NULL
+disable_so_icsk_timeout_inet_connection_sock_52623 icsk_timeout inet_connection_sock 0 52623 NULL
+disable_so____skb_get_hash_fndecl_52630 ___skb_get_hash fndecl 0 52630 NULL
+disable_so_dn_nl_fill_ifaddr_fndecl_52641 dn_nl_fill_ifaddr fndecl 0-3-5 52641 NULL
+disable_so_physical_reg_addr_wl1251_52646 physical_reg_addr wl1251 0 52646 NULL
+disable_so_setup_ata_timing_52661 setup ata_timing 0 52661 NULL
+disable_so_delay_tc_pie_xstats_52665 delay tc_pie_xstats 0 52665 NULL
+disable_so_sys_utimensat_fndecl_52666 sys_utimensat fndecl 1 52666 NULL
+disable_so_ringid_wmi_vring_cfg_52670 ringid wmi_vring_cfg 0 52670 NULL
+disable_so_cmd_timeout_ms_mmc_ioc_cmd_52681 cmd_timeout_ms mmc_ioc_cmd 0 52681 NULL
+disable_so_fr_timer_fndecl_52687 fr_timer fndecl 1 52687 NULL
+disable_so_if_sdio_enter_deep_sleep_fndecl_52688 if_sdio_enter_deep_sleep fndecl 0 52688 NULL
+disable_so_set_rate_control_runtime_52697 set_rate control_runtime 0 52697 NULL
+disable_so_req_consumer_index_phy_addr_low_ql3_adapter_52703 req_consumer_index_phy_addr_low ql3_adapter 0 52703 NULL
+disable_so_addr_max17042_reg_data_52712 addr max17042_reg_data 0 52712 NULL
+disable_so_cit_get_clock_div_fndecl_52713 cit_get_clock_div fndecl 0 52713 NULL nohasharray
+disable_so_mpll_ss2_si_clock_registers_52713 mpll_ss2 si_clock_registers 0 52713 &disable_so_cit_get_clock_div_fndecl_52713
+disable_so_addr_pt1_table_52714 addr pt1_table 0 52714 NULL
+disable_so_ds1742_rtc_read_time_fndecl_52716 ds1742_rtc_read_time fndecl 0 52716 NULL nohasharray
+disable_so_control_cache_address_on_dsp_dsp_obj_52716 control_cache_address_on_dsp dsp_obj 0 52716 &disable_so_ds1742_rtc_read_time_fndecl_52716
+disable_so_ide_get_lba_addr_fndecl_52722 ide_get_lba_addr fndecl 0 52722 NULL
+disable_so_msi_addr_drm_psb_private_52725 msi_addr drm_psb_private 0 52725 NULL
+disable_so_migratepage_address_space_operations_52735 migratepage address_space_operations 0 52735 NULL
+disable_so_apicid_cpuinfo_x86_52743 apicid cpuinfo_x86 0 52743 NULL
+disable_so_ageing_time_show_fndecl_52746 ageing_time_show fndecl 0 52746 NULL
+disable_so___hw_addr_add_fndecl_52752 __hw_addr_add fndecl 0-3 52752 NULL
+disable_so_addr_end_vardecl_init_64_c_52755 addr_end vardecl_init_64.c 0 52755 NULL
+disable_so_cmd_box_addr_wl1271_52756 cmd_box_addr wl1271 0 52756 NULL
+disable_so_crypto_cipher_setkey_fndecl_52762 crypto_cipher_setkey fndecl 0-3 52762 NULL
+disable_so_wmi_del_cipher_key_fndecl_52767 wmi_del_cipher_key fndecl 0 52767 NULL
+disable_so_ptp_dp83640_adjtime_fndecl_52770 ptp_dp83640_adjtime fndecl 2 52770 NULL nohasharray
+disable_so___hw_addr_del_ex_fndecl_52770 __hw_addr_del_ex fndecl 0-3 52770 &disable_so_ptp_dp83640_adjtime_fndecl_52770
+disable_so_reiserfs_init_bitmap_cache_fndecl_52773 reiserfs_init_bitmap_cache fndecl 0 52773 NULL
+disable_so_time_to_jiffies_fndecl_52778 time_to_jiffies fndecl 1-2-0 52778 NULL nohasharray
+disable_so_cleanup_addr_jit_context_52778 cleanup_addr jit_context 0 52778 &disable_so_time_to_jiffies_fndecl_52778 nohasharray
+disable_so_vmx_set_apic_access_page_addr_fndecl_52778 vmx_set_apic_access_page_addr fndecl 2 52778 &disable_so_cleanup_addr_jit_context_52778
+disable_so_sxgbe_rx_interrupt_fndecl_52784 sxgbe_rx_interrupt fndecl 1 52784 NULL
+disable_so_twl_rtc_set_time_fndecl_52785 twl_rtc_set_time fndecl 0 52785 NULL
+disable_so_mwifiex_set_aes_key_v2_fndecl_52787 mwifiex_set_aes_key_v2 fndecl 0 52787 NULL
+disable_so_start_address_rtl2832_reg_entry_52792 start_address rtl2832_reg_entry 0 52792 NULL nohasharray
+disable_so_encrypt_crypto_aead_52792 encrypt crypto_aead 0 52792 &disable_so_start_address_rtl2832_reg_entry_52792
+disable_so_dynamic_ps_timeout_write_fndecl_52802 dynamic_ps_timeout_write fndecl 3-0 52802 NULL
+disable_so_sge_addr_vf_pf_rxq_params_52803 sge_addr vf_pf_rxq_params 0 52803 NULL
+disable_so_rtc_time64_to_tm_fndecl_52820 rtc_time64_to_tm fndecl 1 52820 NULL
+disable_so_fwnet_hwaddr_fifo_fndecl_52824 fwnet_hwaddr_fifo fndecl 0 52824 NULL
+disable_so_clock_khz_dib0090_io_config_52827 clock_khz dib0090_io_config 0 52827 NULL
+disable_so_tuner_frequency_m88rs2000_state_52828 tuner_frequency m88rs2000_state 0 52828 NULL
+disable_so_twl4030_wdt_set_timeout_fndecl_52829 twl4030_wdt_set_timeout fndecl 2 52829 NULL
+disable_so_min_vruntime_cfs_rq_52838 min_vruntime cfs_rq 0 52838 NULL
+disable_so_nv04_timer_alarm_fndecl_52840 nv04_timer_alarm fndecl 2 52840 NULL
+disable_so_sched_runtime_sched_attr_52849 sched_runtime sched_attr 0 52849 NULL
+disable_so_seq_netlink_callback_52857 seq netlink_callback 0 52857 NULL
+disable_so_addr_hi_tg3_tx_buffer_desc_52858 addr_hi tg3_tx_buffer_desc 0 52858 NULL
+disable_so_dev_addr_add_fndecl_52865 dev_addr_add fndecl 0 52865 NULL
+disable_so_mxt_lookup_bootloader_address_fndecl_52874 mxt_lookup_bootloader_address fndecl 0 52874 NULL
+disable_so_rhashtable_init_fndecl_52886 rhashtable_init fndecl 0 52886 NULL
+disable_so_log_unit_to_scsi3addr_fndecl_52888 log_unit_to_scsi3addr fndecl 3 52888 NULL
+disable_so_warmup_time_tc_sfb_qopt_52893 warmup_time tc_sfb_qopt 0 52893 NULL
+disable_so_acpi_ex_system_signal_event_fndecl_52910 acpi_ex_system_signal_event fndecl 0 52910 NULL
+disable_so_ccp_aes_rfc3686_crypt_fndecl_52911 ccp_aes_rfc3686_crypt fndecl 0 52911 NULL
+disable_so_bf_daddr_ath_rxbuf_52915 bf_daddr ath_rxbuf 0 52915 NULL
+disable_so_addr_aac_entry_52921 addr aac_entry 0 52921 NULL
+disable_so_slack_start_time_dql_52922 slack_start_time dql 0 52922 NULL
+disable_so_mma8452_set_hp_filter_frequency_fndecl_52927 mma8452_set_hp_filter_frequency fndecl 0-2-3 52927 NULL
+disable_so_dqb_btime_mem_dqblk_52929 dqb_btime mem_dqblk 0 52929 NULL
+disable_so_mthca_cmd_fndecl_52930 mthca_cmd fndecl 0-2-3 52930 NULL
+disable_so_signal_nr_nvkm_specdom_52941 signal_nr nvkm_specdom 0 52941 NULL
+disable_so_bitmap_find_next_zero_area_fndecl_52944 bitmap_find_next_zero_area fndecl 0-2-3-4-5 52944 NULL
+disable_so_host_addr_p54p_desc_52948 host_addr p54p_desc 0 52948 NULL
+disable_so_signal_strength_wireless_stats_52949 signal_strength wireless_stats 0 52949 NULL
+disable_so_vnic_dev_intr_coal_timer_hw_to_usec_fndecl_52950 vnic_dev_intr_coal_timer_hw_to_usec fndecl 0-2 52950 NULL
+disable_so_base_time_dummy_systimer_pcm_52952 base_time dummy_systimer_pcm 0 52952 NULL
+disable_so_setkey_crypto_ahash_52959 setkey crypto_ahash 0-3 52959 NULL
+disable_so_sll_hatype_sockaddr_ll_52974 sll_hatype sockaddr_ll 0 52974 NULL
+disable_so_ktime_get_raw_fast_ns_fndecl_52986 ktime_get_raw_fast_ns fndecl 0 52986 NULL
+disable_so_tv_freq_tuner_52988 tv_freq tuner 0 52988 NULL
+disable_so_cifs_ci_hash_fndecl_52999 cifs_ci_hash fndecl 0 52999 NULL
+disable_so_last_jiffies_rtc_plat_data_53004 last_jiffies rtc_plat_data 0 53004 NULL
+disable_so_base_addr_eisa_device_53008 base_addr eisa_device 0 53008 NULL
+disable_so_vbaddr_drm_savage_common_state_53015 vbaddr drm_savage_common_state 0 53015 NULL
+disable_so_cal_timeout_at86rf230_local_53017 cal_timeout at86rf230_local 0 53017 NULL
+disable_so_alarmtimer_init_fndecl_53028 alarmtimer_init fndecl 0 53028 NULL
+disable_so_compat_sys_timerfd_gettime_fndecl_53031 compat_sys_timerfd_gettime fndecl 1 53031 NULL
+disable_so_gpu_addr_radeon_vce_53033 gpu_addr radeon_vce 0 53033 NULL
+disable_so_valleyview_get_display_clock_speed_fndecl_53041 valleyview_get_display_clock_speed fndecl 0 53041 NULL
+disable_so__base_interrupt_fndecl_53046 _base_interrupt fndecl 1 53046 NULL
+disable_so_qtail_snd_timer_user_53048 qtail snd_timer_user 0 53048 NULL
+disable_so_max14577_set_fast_charge_timer_fndecl_53049 max14577_set_fast_charge_timer fndecl 2-0 53049 NULL nohasharray
+disable_so_addr_mce_53049 addr mce 0 53049 &disable_so_max14577_set_fast_charge_timer_fndecl_53049
+disable_so_find_next_bit_fndecl_53053 find_next_bit fndecl 0-2-3 53053 NULL
+disable_so_sci_apc_agent_start_timer_fndecl_53055 sci_apc_agent_start_timer fndecl 2 53055 NULL
+disable_so_padlock_sha_update_fndecl_53061 padlock_sha_update fndecl 0-3 53061 NULL
+disable_so_soft_byte_limit_xfrm_lifetime_cfg_53071 soft_byte_limit xfrm_lifetime_cfg 0 53071 NULL
+disable_so_addr_ahd_dma64_seg_53072 addr ahd_dma64_seg 0 53072 NULL
+disable_so_address_bus_request_53084 address bus_request 0 53084 NULL
+disable_so_xfs_btree_dec_cursor_fndecl_53087 xfs_btree_dec_cursor fndecl 0 53087 NULL
+disable_so_gro_flush_timeout_store_fndecl_53088 gro_flush_timeout_store fndecl 4-0 53088 NULL
+disable_so_handle_nested_irq_fndecl_53092 handle_nested_irq fndecl 1 53092 NULL
+disable_so_hi_cfg_bridge_delay_drxd_state_53095 hi_cfg_bridge_delay drxd_state 0 53095 NULL nohasharray
+disable_so___scale_tsc_fndecl_53095 __scale_tsc fndecl 0-1-2 53095 &disable_so_hi_cfg_bridge_delay_drxd_state_53095
+disable_so_bitmap_dirty_bits_fndecl_53100 bitmap_dirty_bits fndecl 2 53100 NULL
+disable_so_ufs_data_ptr_to_cpu_fndecl_53104 ufs_data_ptr_to_cpu fndecl 0 53104 NULL
+disable_so_i_mtime_ocfs2_dinode_53106 i_mtime ocfs2_dinode 0 53106 NULL
+disable_so_raddr_c2wr_ae_active_connect_results_53114 raddr c2wr_ae_active_connect_results 0 53114 NULL
+disable_so_freerunning_timer_show_fndecl_53117 freerunning_timer_show fndecl 0 53117 NULL
+disable_so_get_est_timing_fndecl_53119 get_est_timing fndecl 0 53119 NULL
+disable_so_irq_clock_event_device_53122 irq clock_event_device 0 53122 NULL nohasharray
+disable_so_address_iio_dev_attr_53122 address iio_dev_attr 0 53122 &disable_so_irq_clock_event_device_53122
+disable_so__get_maxdiv_fndecl_53128 _get_maxdiv fndecl 0-2 53128 NULL
+disable_so_boot_time_nfsd_net_53147 boot_time nfsd_net 0 53147 NULL
+disable_so_fl_init_hashtable_fndecl_53150 fl_init_hashtable fndecl 0 53150 NULL
+disable_so_nh_saddr_fib_nh_53152 nh_saddr fib_nh 0 53152 NULL
+disable_so_direct_IO_address_space_operations_53153 direct_IO address_space_operations 0-3 53153 NULL
+disable_so_db_addr_mlx5_ib_create_cq_53177 db_addr mlx5_ib_create_cq 0 53177 NULL nohasharray
+disable_so_page_address_in_vma_fndecl_53177 page_address_in_vma fndecl 0 53177 &disable_so_db_addr_mlx5_ib_create_cq_53177
+disable_so_current_freq_av7110_53182 current_freq av7110 0 53182 NULL
+disable_so_wdt_set_timeout_fndecl_53183 wdt_set_timeout fndecl 2 53183 NULL
+disable_so_uid_min_xt_owner_match_info_53195 uid_min xt_owner_match_info 0 53195 NULL
+disable_so_clear_range_i915_address_space_53198 clear_range i915_address_space 2-3 53198 NULL nohasharray
+disable_so_mipi_dsi_dcs_set_page_address_fndecl_53198 mipi_dsi_dcs_set_page_address fndecl 0 53198 &disable_so_clear_range_i915_address_space_53198
+disable_so_timestamp_il_priv_53208 timestamp il_priv 0 53208 NULL
+disable_so_nbytes_ablkcipher_request_53222 nbytes ablkcipher_request 0 53222 NULL
+disable_so_bitmap_size_sit_info_53224 bitmap_size sit_info 0 53224 NULL
+disable_so_minlen_img_ir_free_timing_53227 minlen img_ir_free_timing 0 53227 NULL
+disable_so_btrfs_alloc_from_bitmap_fndecl_53249 btrfs_alloc_from_bitmap fndecl 0-4-5 53249 NULL
+disable_so_micd_timeout_arizona_extcon_info_53253 micd_timeout arizona_extcon_info 0 53253 NULL
+disable_so_mipi_dsi_dcs_exit_sleep_mode_fndecl_53255 mipi_dsi_dcs_exit_sleep_mode fndecl 0 53255 NULL
+disable_so_btc_find_valid_clock_fndecl_53267 btc_find_valid_clock fndecl 0-3-2 53267 NULL nohasharray
+disable_so_cnsmr_idx_addr_wqicb_53267 cnsmr_idx_addr wqicb 0 53267 &disable_so_btc_find_valid_clock_fndecl_53267
+disable_so_cg_spll_func_cntl_3_rv730_clock_registers_53272 cg_spll_func_cntl_3 rv730_clock_registers 0 53272 NULL
+disable_so_switch_time_il4965_channel_switch_cmd_53281 switch_time il4965_channel_switch_cmd 0 53281 NULL
+disable_so_mic_x100_ack_interrupt_fndecl_53283 mic_x100_ack_interrupt fndecl 0 53283 NULL nohasharray
+disable_so_bitmap_set_ll_fndecl_53283 bitmap_set_ll fndecl 0-2-3 53283 &disable_so_mic_x100_ack_interrupt_fndecl_53283
+disable_so_ci_otg_del_timer_fndecl_53284 ci_otg_del_timer fndecl 2 53284 NULL
+disable_so_elapsed_jiffies_msecs_fndecl_53288 elapsed_jiffies_msecs fndecl 0 53288 NULL
+disable_so_neigh_add_timer_fndecl_53296 neigh_add_timer fndecl 2 53296 NULL
+disable_so_chunk_sizek_var_mtrr_state_53302 chunk_sizek var_mtrr_state 0 53302 NULL
+disable_so_set_flexbg_block_bitmap_fndecl_53307 set_flexbg_block_bitmap fndecl 0-4-5 53307 NULL
+disable_so_tw_rcv_wscale_inet_timewait_sock_53312 tw_rcv_wscale inet_timewait_sock 0 53312 NULL
+disable_so_ablkcipher_walk_next_fndecl_53328 ablkcipher_walk_next fndecl 0 53328 NULL
+disable_so_xen_mce_chrdev_open_fndecl_53331 xen_mce_chrdev_open fndecl 0 53331 NULL
+disable_so_be16_add_cpu_fndecl_53336 be16_add_cpu fndecl 2 53336 NULL
+disable_so_write_end_address_space_operations_53339 write_end address_space_operations 0-3-4-5 53339 NULL
+disable_so_kobj_cpu_cpufreq_policy_53349 kobj_cpu cpufreq_policy 0 53349 NULL
+disable_so_cticks_snd_timer_instance_53353 cticks snd_timer_instance 0 53353 NULL
+disable_so_bus_num_atto_csmi_get_pci_bus_addr_53363 bus_num atto_csmi_get_pci_bus_addr 0 53363 NULL
+disable_so_wall_time_sec_vsyscall_gtod_data_53364 wall_time_sec vsyscall_gtod_data 0 53364 NULL
+disable_so_vfrontporch_v4l2_bt_timings_53369 vfrontporch v4l2_bt_timings 0 53369 NULL
+disable_so_dataset_patch_addr_ath6kl_hw_53371 dataset_patch_addr ath6kl_hw 0 53371 NULL
+disable_so___bitmap_subset_fndecl_53372 __bitmap_subset fndecl 3 53372 NULL
+disable_so_sii9234_runtime_resume_fndecl_53375 sii9234_runtime_resume fndecl 0 53375 NULL
+disable_so_ccp_crypto_init_fndecl_53377 ccp_crypto_init fndecl 0 53377 NULL
+disable_so_inaddr_usnic_fwd_dev_53382 inaddr usnic_fwd_dev 0 53382 NULL
+disable_so_ndo_validate_addr_net_device_ops_53392 ndo_validate_addr net_device_ops 0 53392 NULL nohasharray
+disable_so_valid_msr_intercept_fndecl_53392 valid_msr_intercept fndecl 1 53392 &disable_so_ndo_validate_addr_net_device_ops_53392
+disable_so_ept_walk_addr_fndecl_53393 ept_walk_addr fndecl 3-4 53393 NULL
+disable_so_dma_alloc_attrs_fndecl_53394 dma_alloc_attrs fndecl 2-4 53394 NULL
+disable_so_btrfs_delayed_inode_init_fndecl_53395 btrfs_delayed_inode_init fndecl 0 53395 NULL
+disable_so_atomic_stats_read_fndecl_53399 atomic_stats_read fndecl 3-0 53399 NULL
+disable_so_src_slave_addr_rcar_dmac_chan_53400 src_slave_addr rcar_dmac_chan 0 53400 NULL
+disable_so_sys_guid_ib_node_info_53401 sys_guid ib_node_info 0 53401 NULL
+disable_so_freqValTelevision_pvr2_hdw_53403 freqValTelevision pvr2_hdw 0 53403 NULL
+disable_so_quotad_check_timeo_fndecl_53409 quotad_check_timeo fndecl 4 53409 NULL
+disable_so_smp_size_set_mtrr_data_53411 smp_size set_mtrr_data 0 53411 NULL
+disable_so_addr_wil_fw_data_gw_53417 addr wil_fw_data_gw 0 53417 NULL
+disable_so_irlap_start_wd_timer_fndecl_53423 irlap_start_wd_timer fndecl 2 53423 NULL
+disable_so_nla_put_u32_fndecl_53424 nla_put_u32 fndecl 0-3 53424 NULL
+disable_so_ucode_start_addr_smc_firmware_header_v1_0_53438 ucode_start_addr smc_firmware_header_v1_0 0 53438 NULL
+disable_so_dma_addr_tso_state_53442 dma_addr tso_state 0 53442 NULL
+disable_so___down_common_fndecl_53444 __down_common fndecl 2 53444 NULL
+disable_so_bma180_set_sleep_state_fndecl_53447 bma180_set_sleep_state fndecl 0 53447 NULL
+disable_so_reqsize_crypto_ahash_53448 reqsize crypto_ahash 0 53448 NULL
+disable_so_qs_rtbtimelimit_fs_quota_stat_53453 qs_rtbtimelimit fs_quota_stat 0 53453 NULL
+disable_so_mmc_set_relative_addr_fndecl_53454 mmc_set_relative_addr fndecl 0 53454 NULL
+disable_so_genwqe_debugfs_jtimer_open_fndecl_53455 genwqe_debugfs_jtimer_open fndecl 0 53455 NULL
+disable_so_xruns_snd_rawmidi_runtime_53458 xruns snd_rawmidi_runtime 0 53458 NULL
+disable_so_cpumask_local_spread_fndecl_53460 cpumask_local_spread fndecl 0-1-2 53460 NULL
+disable_so_peer_addr_rds_info_tcp_socket_53463 peer_addr rds_info_tcp_socket 0 53463 NULL
+disable_so_do_set_fan_div_fndecl_53464 do_set_fan_div fndecl 0 53464 NULL
+disable_so_nfs_map_uid_to_name_fndecl_53467 nfs_map_uid_to_name fndecl 4-0 53467 NULL
+disable_so_handle_drm_vmw_fence_signaled_arg_53472 handle drm_vmw_fence_signaled_arg 0 53472 NULL
+disable_so_guest_perf_guest_switch_msr_53477 guest perf_guest_switch_msr 0 53477 NULL
+disable_so_encrypt_blkcipher_alg_53493 encrypt blkcipher_alg 4 53493 NULL
+disable_so_tmr_disable_sound_lowlev_timer_53495 tmr_disable sound_lowlev_timer 1 53495 NULL nohasharray
+disable_so_shim_phy_addr_sst_res_info_53495 shim_phy_addr sst_res_info 0 53495 &disable_so_tmr_disable_sound_lowlev_timer_53495
+disable_so_conversion_time_smm665_data_53516 conversion_time smm665_data 0 53516 NULL
+disable_so_iscsi_tpg_attrib_store_netif_timeout_fndecl_53517 iscsi_tpg_attrib_store_netif_timeout fndecl 0-3 53517 NULL
+disable_so_address_ib_umem_53524 address ib_umem 0 53524 NULL
+disable_so_di_gid_gfs2_dinode_53528 di_gid gfs2_dinode 0 53528 NULL
+disable_so_mem_busaddr_ahc_platform_data_53533 mem_busaddr ahc_platform_data 0 53533 NULL nohasharray
+disable_so_sg_list_busaddr_scb_53533 sg_list_busaddr scb 0 53533 &disable_so_mem_busaddr_ahc_platform_data_53533
+disable_so_vactive_hi_lvds_dvo_timing_53549 vactive_hi lvds_dvo_timing 0 53549 NULL
+disable_so_block_dma_addr_rx_block_info_53550 block_dma_addr rx_block_info 0 53550 NULL
+disable_so_st_ctime_nsec_compat_stat_53567 st_ctime_nsec compat_stat 0 53567 NULL
+disable_so_storm_memset_hc_timeout_fndecl_53596 storm_memset_hc_timeout fndecl 2-3-5 53596 NULL
+disable_so_vapic_addr_kvm_lapic_53599 vapic_addr kvm_lapic 0 53599 NULL
+disable_so_schedule_irq_fndecl_53600 schedule_irq fndecl 2 53600 NULL
+disable_so_smp_cmd_ident_addr_info_fndecl_53602 smp_cmd_ident_addr_info fndecl 0 53602 NULL
+disable_so_rsp_dmaaddr_fw_scsi_cmd_wr_53609 rsp_dmaaddr fw_scsi_cmd_wr 0 53609 NULL
+disable_so_device_addr_p54p_desc_53612 device_addr p54p_desc 0 53612 NULL nohasharray
+disable_so_wm8350_reg_write_fndecl_53612 wm8350_reg_write fndecl 2-3-0 53612 &disable_so_device_addr_p54p_desc_53612
+disable_so_ringid_wil_back_tx_53620 ringid wil_back_tx 0 53620 NULL nohasharray
+disable_so_ahd_resolve_seqaddr_fndecl_53620 ahd_resolve_seqaddr fndecl 0-2 53620 &disable_so_ringid_wil_back_tx_53620
+disable_so_sleep_control_elan_transport_ops_53622 sleep_control elan_transport_ops 0 53622 NULL
+disable_so_btrfs_set_token_inode_gid_fndecl_53628 btrfs_set_token_inode_gid fndecl 3 53628 NULL
+disable_so_format_gro_flush_timeout_fndecl_53638 format_gro_flush_timeout fndecl 0 53638 NULL
+disable_so_one_bits_word_at_a_time_53641 one_bits word_at_a_time 0 53641 NULL
+disable_so_i2c_addr_xc2028_config_53658 i2c_addr xc2028_config 0 53658 NULL
+disable_so_ss_tss_segment_32_53663 ss tss_segment_32 0 53663 NULL
+disable_so_backlight_off_delay_cdv_intel_dp_53664 backlight_off_delay cdv_intel_dp 0 53664 NULL
+disable_so_genwqe_debugfs_prev_dbg_uid1_open_fndecl_53665 genwqe_debugfs_prev_dbg_uid1_open fndecl 0 53665 NULL
+disable_so_mult_clocksource_53667 mult clocksource 0 53667 NULL nohasharray
+disable_so_parse_nl_addr_fndecl_53667 parse_nl_addr fndecl 0 53667 &disable_so_mult_clocksource_53667
+disable_so_irq_parport_53669 irq parport 0 53669 NULL
+disable_so_apparmor_hash_size_vardecl_crypto_c_53670 apparmor_hash_size vardecl_crypto.c 0 53670 NULL
+disable_so_vnic_dev_intr_coal_timer_usec_to_hw_fndecl_53671 vnic_dev_intr_coal_timer_usec_to_hw fndecl 0-2 53671 NULL
+disable_so_si_do_program_memory_timing_parameters_fndecl_53672 si_do_program_memory_timing_parameters fndecl 0 53672 NULL
+disable_so_addr_tx_desc_53676 addr tx_desc 0 53676 NULL
+disable_so_put_unaligned_be16_fndecl_53677 put_unaligned_be16 fndecl 1 53677 NULL
+disable_so_family_xfrm_usersa_id_53678 family xfrm_usersa_id 0 53678 NULL
+disable_so_bcm54xx_ack_interrupt_fndecl_53685 bcm54xx_ack_interrupt fndecl 0 53685 NULL nohasharray
+disable_so_svga_check_timings_fndecl_53685 svga_check_timings fndecl 3 53685 &disable_so_bcm54xx_ack_interrupt_fndecl_53685
+disable_so_i40e_vc_add_mac_addr_msg_fndecl_53688 i40e_vc_add_mac_addr_msg fndecl 0-3 53688 NULL
+disable_so_addr_mvfrey_inlist_entry_53690 addr mvfrey_inlist_entry 0 53690 NULL
+disable_so_pch_src_uuid_hi_read_fndecl_53692 pch_src_uuid_hi_read fndecl 0 53692 NULL
+disable_so___bitmap_intersects_fndecl_53698 __bitmap_intersects fndecl 3 53698 NULL
+disable_so_atomic_open_fndecl_53702 atomic_open fndecl 0 53702 NULL
+disable_so_address_dsp_scb_descriptor_53708 address dsp_scb_descriptor 0 53708 NULL
+disable_so_timestamp_il_rx_phy_res_53714 timestamp il_rx_phy_res 0 53714 NULL
+disable_so_start_time_edac_pci_ctl_info_53715 start_time edac_pci_ctl_info 0 53715 NULL
+disable_so_show_forward_delay_timer_fndecl_53717 show_forward_delay_timer fndecl 0 53717 NULL nohasharray
+disable_so_iscsi_nacl_attrib_show_random_datain_pdu_offsets_fndecl_53717 iscsi_nacl_attrib_show_random_datain_pdu_offsets fndecl 0 53717 &disable_so_show_forward_delay_timer_fndecl_53717
+disable_so_memory_address_range_set_error_type_with_address_53722 memory_address_range set_error_type_with_address 0 53722 NULL
+disable_so_sm501_find_clock_fndecl_53729 sm501_find_clock fndecl 3-0 53729 NULL
+disable_so___round_jiffies_relative_fndecl_53743 __round_jiffies_relative fndecl 2-0-1 53743 NULL
+disable_so_ccp_aes_xts_crypt_fndecl_53745 ccp_aes_xts_crypt fndecl 0 53745 NULL
+disable_so_buf_addr_mlx5_ib_create_cq_53754 buf_addr mlx5_ib_create_cq 0 53754 NULL
+disable_so_i_gid_sysv_inode_53757 i_gid sysv_inode 0 53757 NULL
+disable_so_address_fm10k_fault_53764 address fm10k_fault 0 53764 NULL
+disable_so_ntb_set_mw_addr_fndecl_53775 ntb_set_mw_addr fndecl 3 53775 NULL
+disable_so_rx_bd_haddr_lo_bnx2_rx_bd_53781 rx_bd_haddr_lo bnx2_rx_bd 0 53781 NULL
+disable_so_set_rfreg_rtl_hal_ops_53782 set_rfreg rtl_hal_ops 3-5 53782 NULL
+disable_so_kstrtoll_fndecl_53783 kstrtoll fndecl 0 53783 NULL
+disable_so_btrfs_set_token_64_fndecl_53792 btrfs_set_token_64 fndecl 3-4 53792 NULL
+disable_so_clock_dw_mci_slot_53801 clock dw_mci_slot 0 53801 NULL nohasharray
+disable_so_i_uid_nilfs_inode_53801 i_uid nilfs_inode 0 53801 &disable_so_clock_dw_mci_slot_53801
+disable_so_packet_len_2_sched_time_fndecl_53809 packet_len_2_sched_time fndecl 0-1 53809 NULL
+disable_so_calc_div_fndecl_53821 calc_div fndecl 0-1 53821 NULL
+disable_so_rsvd_pbl_addr_tpt_entry_53834 rsvd_pbl_addr tpt_entry 0 53834 NULL nohasharray
+disable_so_dsc_rw_frequency_idetape_config_53834 dsc_rw_frequency idetape_config 0 53834 &disable_so_rsvd_pbl_addr_tpt_entry_53834
+disable_so_ahc_get_sense_bufaddr_fndecl_53837 ahc_get_sense_bufaddr fndecl 0 53837 NULL
+disable_so_jiffies_at_alloc_scsi_cmnd_53839 jiffies_at_alloc scsi_cmnd 0 53839 NULL
+disable_so_sense_addr_orc_scb_53841 sense_addr orc_scb 0 53841 NULL
+disable_so_stall_timeout_xenvif_53851 stall_timeout xenvif 0 53851 NULL
+disable_so_tlv_put_btrfs_timespec_fndecl_53854 tlv_put_btrfs_timespec fndecl 0 53854 NULL
+disable_so_nfsd4_decode_time_fndecl_53864 nfsd4_decode_time fndecl 0 53864 NULL
+disable_so_threshold_target_nes_hw_tune_timer_53868 threshold_target nes_hw_tune_timer 0 53868 NULL
+disable_so_i_uid_bfs_inode_53869 i_uid bfs_inode 0 53869 NULL
+disable_so_vidioc_query_dv_timings_fndecl_53872 vidioc_query_dv_timings fndecl 0 53872 NULL
+disable_so_rtl2832_sleep_fndecl_53873 rtl2832_sleep fndecl 0 53873 NULL
+disable_so_snd_soc_update_bits_fndecl_53881 snd_soc_update_bits fndecl 0-2-4-3 53881 NULL
+disable_so_sched_clock_fndecl_53886 sched_clock fndecl 0 53886 NULL
+disable_so_ps_poll_upsd_timeouts_read_fndecl_53888 ps_poll_upsd_timeouts_read fndecl 3 53888 NULL
+disable_so_pmdown_time_set_fndecl_53891 pmdown_time_set fndecl 0-4 53891 NULL
+disable_so_sync_endtime_ip_vs_conn_53903 sync_endtime ip_vs_conn 0 53903 NULL
+disable_so_timeout_c_tpm_vendor_specific_53905 timeout_c tpm_vendor_specific 0 53905 NULL
+disable_so_i2c_address_mxl5005s_config_53906 i2c_address mxl5005s_config 0 53906 NULL
+disable_so_bin_dn_node_address_fndecl_53909 bin_dn_node_address fndecl 0 53909 NULL
+disable_so_i2c_addr_dib3000mc_state_53912 i2c_addr dib3000mc_state 0 53912 NULL
+disable_so_musb_schedule_fndecl_53920 musb_schedule fndecl 3-0 53920 NULL
+disable_so_card_addr_pcmcia_device_53921 card_addr pcmcia_device 0 53921 NULL
+disable_so_freq_si476x_tune_freq_args_53927 freq si476x_tune_freq_args 0 53927 NULL
+disable_so_xfrm_dst_hash_transfer_fndecl_53935 xfrm_dst_hash_transfer fndecl 4 53935 NULL
+disable_so_fs_time_ufs_super_block_first_53936 fs_time ufs_super_block_first 0 53936 NULL
+disable_so_buffer_addr_ath6kl_dbglog_buf_53947 buffer_addr ath6kl_dbglog_buf 0 53947 NULL
+disable_so_drbd_send_bitmap_fndecl_53952 drbd_send_bitmap fndecl 0 53952 NULL
+disable_so_xfs_kuid_to_uid_fndecl_53958 xfs_kuid_to_uid fndecl 0 53958 NULL
+disable_so_addr_off_bfa_flash_53970 addr_off bfa_flash 0 53970 NULL
+disable_so_string_langid_usb_device_53974 string_langid usb_device 0 53974 NULL
+disable_so_src_addr_qla4_83xx_pex_dma_descriptor_53995 src_addr qla4_83xx_pex_dma_descriptor 0 53995 NULL
+disable_so_crc32_pclmul_mod_init_fndecl_53996 crc32_pclmul_mod_init fndecl 0 53996 NULL
+disable_so_range_to_mtrr_with_hole_fndecl_53998 range_to_mtrr_with_hole fndecl 0-2-3 53998 NULL
+disable_so_cpu_cpufreq_freqs_54025 cpu cpufreq_freqs 0 54025 NULL
+disable_so_read_addr_qla83xx_minidump_entry_pollrd_54033 read_addr qla83xx_minidump_entry_pollrd 0 54033 NULL
+disable_so_wall_time_coarse_nsec_vsyscall_gtod_data_54044 wall_time_coarse_nsec vsyscall_gtod_data 0 54044 NULL
+disable_so_HTotal_xtimings_54045 HTotal xtimings 0 54045 NULL
+disable_so_hpi_cobranet_get_static_ip_address_fndecl_54046 hpi_cobranet_get_static_ip_address fndecl 1 54046 NULL
+disable_so_device_reset_timer_mipi_config_54052 device_reset_timer mipi_config 0 54052 NULL
+disable_so_myri10ge_watchdog_timeout_vardecl_myri10ge_c_54061 myri10ge_watchdog_timeout vardecl_myri10ge.c 0 54061 NULL
+disable_so_slope_div_nvbios_therm_sensor_54063 slope_div nvbios_therm_sensor 0 54063 NULL
+disable_so_cg_spll_func_cntl_rv770_clock_registers_54065 cg_spll_func_cntl rv770_clock_registers 0 54065 NULL
+disable_so_custom_divisor_serial_struct_54066 custom_divisor serial_struct 0 54066 NULL
+disable_so_cq_get_mtt_addr_fndecl_54071 cq_get_mtt_addr fndecl 0 54071 NULL
+disable_so_stack_maxrandom_size_fndecl_54078 stack_maxrandom_size fndecl 0 54078 NULL
+disable_so_ktime_get_mono_fast_ns_fndecl_54083 ktime_get_mono_fast_ns fndecl 0 54083 NULL
+disable_so_reachable_time_neigh_parms_54094 reachable_time neigh_parms 0 54094 NULL
+disable_so_hid_time_parse_report_fndecl_54114 hid_time_parse_report fndecl 0 54114 NULL
+disable_so_baddr0_gru_instruction_54117 baddr0 gru_instruction 0 54117 NULL
+disable_so_time_in_queue_disk_stats_54131 time_in_queue disk_stats 0 54131 NULL
+disable_so_smsc95xx_set_mac_address_fndecl_54135 smsc95xx_set_mac_address fndecl 0 54135 NULL
+disable_so_sysctl_numa_balancing_scan_delay_vardecl_54140 sysctl_numa_balancing_scan_delay vardecl 0 54140 NULL nohasharray
+disable_so_tun16_to_cpu_fndecl_54140 tun16_to_cpu fndecl 0-2 54140 &disable_so_sysctl_numa_balancing_scan_delay_vardecl_54140
+disable_so_addr_2_qla8044_minidump_entry_pollrdmwr_54142 addr_2 qla8044_minidump_entry_pollrdmwr 0 54142 NULL
+disable_so___xfrm6_pref_hash_fndecl_54144 __xfrm6_pref_hash fndecl 0 54144 NULL
+disable_so_sm501_select_clock_fndecl_54146 sm501_select_clock fndecl 1-0 54146 NULL
+disable_so_x86_acpi_enter_sleep_state_fndecl_54149 x86_acpi_enter_sleep_state fndecl 0-1 54149 NULL
+disable_so_ips_fix_ffdc_time_fndecl_54151 ips_fix_ffdc_time fndecl 3 54151 NULL
+disable_so_set_var_mtrr_range_fndecl_54160 set_var_mtrr_range fndecl 2-3 54160 NULL nohasharray
+disable_so_bi_blocks_gfs2_bitmap_54160 bi_blocks gfs2_bitmap 0 54160 &disable_so_set_var_mtrr_range_fndecl_54160
+disable_so_ath10k_recalc_rtscts_prot_fndecl_54161 ath10k_recalc_rtscts_prot fndecl 0 54161 NULL
+disable_so_i915_frequency_info_fndecl_54168 i915_frequency_info fndecl 0 54168 NULL
+disable_so_store_fast_charge_timer_fndecl_54173 store_fast_charge_timer fndecl 0-4 54173 NULL
+disable_so_compat_put_bitmap_fndecl_54182 compat_put_bitmap fndecl 0-3 54182 NULL
+disable_so_cccr_address_p4_counter_binding_54184 cccr_address p4_counter_binding 0 54184 NULL
+disable_so_extra_buf2_address_ene_device_54188 extra_buf2_address ene_device 0 54188 NULL
+disable_so_gr_insert_uid_fndecl_54189 gr_insert_uid fndecl 2 54189 NULL
+disable_so_addr_wil_fw_record_data_54198 addr wil_fw_record_data 0 54198 NULL
+disable_so_hash_mask_dm_exception_table_54212 hash_mask dm_exception_table 0 54212 NULL
+disable_so_cir_addr_ite_dev_54217 cir_addr ite_dev 0 54217 NULL
+disable_so_end_fixed_mtrr_segment_54218 end fixed_mtrr_segment 0 54218 NULL
+disable_so_timer_in_use_min_nes_hw_tune_timer_54220 timer_in_use_min nes_hw_tune_timer 0 54220 NULL
+disable_so_act8b_ata_timing_54221 act8b ata_timing 0 54221 NULL
+disable_so_psmouse_interrupt_fndecl_54222 psmouse_interrupt fndecl 2 54222 NULL
+disable_so_reply_queue_start_phys_addr_lo_megasas_init_queue_info_54244 reply_queue_start_phys_addr_lo megasas_init_queue_info 0 54244 NULL
+disable_so__freq_tbl_determine_rate_fndecl_54245 _freq_tbl_determine_rate fndecl 0 54245 NULL
+disable_so_tm_hour_rtc_time_54254 tm_hour rtc_time 0 54254 NULL
+disable_so_efx_nic_init_interrupt_fndecl_54259 efx_nic_init_interrupt fndecl 0 54259 NULL
+disable_so_dr_addr_qla8044_quad_entry_54260 dr_addr qla8044_quad_entry 0 54260 NULL
+disable_so_integer_pll_div_54261 integer pll_div 0 54261 NULL nohasharray
+disable_so_buf_addr_brcmf_pcie_console_54261 buf_addr brcmf_pcie_console 0 54261 &disable_so_integer_pll_div_54261
+disable_so_fandiv2_w83627ehf_data_54263 fandiv2 w83627ehf_data 0 54263 NULL
+disable_so_gf_numsrc_group_filter_54274 gf_numsrc group_filter 0 54274 NULL
+disable_so_adis_write_reg_fndecl_54282 adis_write_reg fndecl 0 54282 NULL
+disable_so_last_commit_jiffies_pool_54290 last_commit_jiffies pool 0 54290 NULL nohasharray
+disable_so_btree_cache_used_cache_set_54290 btree_cache_used cache_set 0 54290 &disable_so_last_commit_jiffies_pool_54290
+disable_so_hid_time_probe_fndecl_54292 hid_time_probe fndecl 0 54292 NULL
+disable_so_cgroup_subtree_control_write_fndecl_54294 cgroup_subtree_control_write fndecl 0-3 54294 NULL
+disable_so_hpt3x2n_set_clock_fndecl_54295 hpt3x2n_set_clock fndecl 2 54295 NULL
+disable_so_timestamp_nfs4_layoutget_args_54296 timestamp nfs4_layoutget_args 0 54296 NULL
+disable_so_mic_setup_interrupts_fndecl_54300 mic_setup_interrupts fndecl 0 54300 NULL
+disable_so_imsf_numsrc_ip_msfilter_54312 imsf_numsrc ip_msfilter 0 54312 NULL
+disable_so_dma_addr_solos_skb_cb_54324 dma_addr solos_skb_cb 0 54324 NULL
+disable_so_irq_domain_set_info_fndecl_54334 irq_domain_set_info fndecl 3-2 54334 NULL
+disable_so_ks108_set_yaddr_fndecl_54335 ks108_set_yaddr fndecl 2-3 54335 NULL
+disable_so_lfo1delay_soundfont_voice_parm_54350 lfo1delay soundfont_voice_parm 0 54350 NULL
+disable_so_netxen_get_ioaddr_fndecl_54354 netxen_get_ioaddr fndecl 2 54354 NULL
+disable_so_addrs_per_inode_fndecl_54364 addrs_per_inode fndecl 0 54364 NULL
+disable_so_msr_rsc_54369 msr rsc 0 54369 NULL
+disable_so_busaddr_CommandList_54370 busaddr CommandList 0 54370 NULL
+disable_so_paddr_mwifiex_pfu_buf_desc_54374 paddr mwifiex_pfu_buf_desc 0 54374 NULL
+disable_so_ieee80211_aes_key_setup_encrypt_fndecl_54383 ieee80211_aes_key_setup_encrypt fndecl 2-3 54383 NULL
+disable_so_cpumask_parse_user_fndecl_54390 cpumask_parse_user fndecl 0-2 54390 NULL
+disable_so_ack_signal_zd_mac_54391 ack_signal zd_mac 0 54391 NULL
+disable_so_addr_lp855x_rom_data_54408 addr lp855x_rom_data 0 54408 NULL
+disable_so_ar9003_mci_wait_for_interrupt_fndecl_54411 ar9003_mci_wait_for_interrupt fndecl 2-3 54411 NULL
+disable_so_enable_timeout_sdio_func_54417 enable_timeout sdio_func 0 54417 NULL
+disable_so_overrun_time_n_tty_data_54426 overrun_time n_tty_data 0 54426 NULL
+disable_so_seq_netlbl_cipsov4_doiwalk_arg_54427 seq netlbl_cipsov4_doiwalk_arg 0 54427 NULL
+disable_so_addr_hi_ocrdma_sge_54434 addr_hi ocrdma_sge 0 54434 NULL
+disable_so_lcq_addr_hi_fcoe_kwqe_conn_offload4_54436 lcq_addr_hi fcoe_kwqe_conn_offload4 0 54436 NULL
+disable_so_avc_ca_get_time_date_fndecl_54437 avc_ca_get_time_date fndecl 0 54437 NULL
+disable_so_msg_rtime_msqid64_ds_54442 msg_rtime msqid64_ds 0 54442 NULL
+disable_so_delay_vardecl_wm9705_c_54454 delay vardecl_wm9705.c 0 54454 NULL
+disable_so_hpi_set_address_fndecl_54461 hpi_set_address fndecl 2 54461 NULL
+disable_so_seq_nft_ctx_54462 seq nft_ctx 0 54462 NULL
+disable_so_dm_btree_remove_fndecl_54463 dm_btree_remove fndecl 0-2 54463 NULL
+disable_so_stv0297_set_initialdemodfreq_fndecl_54465 stv0297_set_initialdemodfreq fndecl 2 54465 NULL
+disable_so_shdwreg_addr_lo_addr_ctrl_blk_54466 shdwreg_addr_lo addr_ctrl_blk 0 54466 NULL
+disable_so_i2c_dev_addr_au0828_rc_54470 i2c_dev_addr au0828_rc 0 54470 NULL
+disable_so_sha256_generic_mod_init_fndecl_54474 sha256_generic_mod_init fndecl 0 54474 NULL
+disable_so_kdiv_skl_wrpll_params_54475 kdiv skl_wrpll_params 0 54475 NULL
+disable_so_ocfs2_divide_xattr_cluster_fndecl_54477 ocfs2_divide_xattr_cluster fndecl 0 54477 NULL
+disable_so_addr_gsm_msg_54481 addr gsm_msg 0 54481 NULL
+disable_so_select_delay_floppy_drive_params_54487 select_delay floppy_drive_params 0 54487 NULL
+disable_so_dm_btree_find_highest_key_fndecl_54489 dm_btree_find_highest_key fndecl 0-2 54489 NULL
+disable_so_last_retry_addr_kvm_vcpu_arch_54492 last_retry_addr kvm_vcpu_arch 0 54492 NULL
+disable_so_default_delay_pi_protocol_54493 default_delay pi_protocol 0 54493 NULL
+disable_so_dummy_dma_page_physical_address_r592_device_54497 dummy_dma_page_physical_address r592_device 0 54497 NULL
+disable_so_drbg_hash_update_fndecl_54501 drbg_hash_update fndecl 0 54501 NULL
+disable_so_cryptd_blkcipher_setkey_fndecl_54506 cryptd_blkcipher_setkey fndecl 0-3 54506 NULL
+disable_so_mounted_uid_ncp_fs_info_v2_54511 mounted_uid ncp_fs_info_v2 0 54511 NULL
+disable_so_htc_ext_addr_ath6kl_mbox_info_54517 htc_ext_addr ath6kl_mbox_info 0 54517 NULL
+disable_so_xen_pmd_val_fndecl_54519 xen_pmd_val fndecl 0 54519 NULL
+disable_so_incr_cpu_itimer_54530 incr cpu_itimer 0 54530 NULL
+disable_so_fw_blob_dest_addr_pn544_i2c_phy_54532 fw_blob_dest_addr pn544_i2c_phy 0 54532 NULL
+disable_so_ip_addr_nx_ip_list_54540 ip_addr nx_ip_list 0 54540 NULL
+disable_so_test_ahash_cycles_digest_fndecl_54541 test_ahash_cycles_digest fndecl 0 54541 NULL
+disable_so_tegra_sflash_runtime_resume_fndecl_54543 tegra_sflash_runtime_resume fndecl 0 54543 NULL
+disable_so_start_addr_qlcnic_flt_entry_54564 start_addr qlcnic_flt_entry 0 54564 NULL
+disable_so_addr_lo_tg3_rx_buffer_desc_54565 addr_lo tg3_rx_buffer_desc 0 54565 NULL
+disable_so_btrfs_free_space_bitmaps_fndecl_54566 btrfs_free_space_bitmaps fndecl 0 54566 NULL nohasharray
+disable_so_crypto_rfc4309_decrypt_fndecl_54566 crypto_rfc4309_decrypt fndecl 0 54566 &disable_so_btrfs_free_space_bitmaps_fndecl_54566
+disable_so_crypto_ahash_op_fndecl_54569 crypto_ahash_op fndecl 0 54569 NULL
+disable_so_rbt_ib_umem_compute_subtree_last_fndecl_54589 rbt_ib_umem_compute_subtree_last fndecl 0 54589 NULL
+disable_so_ap_sleep_wlcore_ops_54591 ap_sleep wlcore_ops 0 54591 NULL
+disable_so_get_freq_adis16400_chip_info_54596 get_freq adis16400_chip_info 0 54596 NULL
+disable_so_entries_dmaaddr_snd_trident_tlb_54601 entries_dmaaddr snd_trident_tlb 0 54601 NULL
+disable_so_hwrqaddr_fw_ri_init_54619 hwrqaddr fw_ri_init 0 54619 NULL
+disable_so_rs_user_addr_rds_sock_54620 rs_user_addr rds_sock 0 54620 NULL
+disable_so_snd_timer_global_new_fndecl_54623 snd_timer_global_new fndecl 2-0 54623 NULL
+disable_so_rsi_setclock_fndecl_54628 rsi_setclock fndecl 2 54628 NULL
+disable_so_addr_ct_vm_block_54632 addr ct_vm_block 0 54632 NULL
+disable_so_read_addr_qla8044_minidump_entry_mux_54633 read_addr qla8044_minidump_entry_mux 0 54633 NULL
+disable_so_queue_delayed_work_on_fndecl_54644 queue_delayed_work_on fndecl 1-4 54644 NULL
+disable_so_arcmsr_adjust_disk_queue_depth_fndecl_54647 arcmsr_adjust_disk_queue_depth fndecl 0-2 54647 NULL
+disable_so_mpihelp_mul_1_fndecl_54658 mpihelp_mul_1 fndecl 3 54658 NULL
+disable_so_bitmap_ipmac_do_add_fndecl_54672 bitmap_ipmac_do_add fndecl 4 54672 NULL
+disable_so_paddr_fsl_asrc_54677 paddr fsl_asrc 0 54677 NULL
+disable_so_sil_iowrite32_fndecl_54679 sil_iowrite32 fndecl 3-2 54679 NULL
+disable_so_adv_smbus_write_byte_data_fndecl_54684 adv_smbus_write_byte_data fndecl 2-3-0 54684 NULL
+disable_so_delay_snd_pcm_runtime_54685 delay snd_pcm_runtime 0 54685 NULL
+disable_so_cp_blkaddr_f2fs_super_block_54690 cp_blkaddr f2fs_super_block 0 54690 NULL
+disable_so_schedule_erase_fndecl_54695 schedule_erase fndecl 4-3 54695 NULL
+disable_so_mesh_set_short_slot_time_fndecl_54696 mesh_set_short_slot_time fndecl 0 54696 NULL
+disable_so_pll2_ndiv_a_cnt_ad9523_platform_data_54701 pll2_ndiv_a_cnt ad9523_platform_data 0 54701 NULL
+disable_so_dirtytime_expire_interval_vardecl_54714 dirtytime_expire_interval vardecl 0 54714 NULL nohasharray
+disable_so_cdv_intel_crtc_clock_get_fndecl_54714 cdv_intel_crtc_clock_get fndecl 0 54714 &disable_so_dirtytime_expire_interval_vardecl_54714
+disable_so_timeout_vardecl_w83627hf_wdt_c_54716 timeout vardecl_w83627hf_wdt.c 0 54716 NULL
+disable_so_ccp_addr_hi_fndecl_54724 ccp_addr_hi fndecl 0 54724 NULL nohasharray
+disable_so_usnic_fwd_add_ipaddr_fndecl_54724 usnic_fwd_add_ipaddr fndecl 2 54724 &disable_so_ccp_addr_hi_fndecl_54724
+disable_so_encrypt_ablkcipher_tfm_54728 encrypt ablkcipher_tfm 0 54728 NULL
+disable_so_dp83640_ack_interrupt_fndecl_54729 dp83640_ack_interrupt fndecl 0 54729 NULL
+disable_so_crypto_pcbc_decrypt_fndecl_54732 crypto_pcbc_decrypt fndecl 0-4 54732 NULL
+disable_so_jackdetect_debounce_time_adau1761_platform_data_54736 jackdetect_debounce_time adau1761_platform_data 0 54736 NULL
+disable_so_ism1_runtime_sc_54739 ism1 runtime_sc 0 54739 NULL
+disable_so___hw_addr_sync_multiple_fndecl_54744 __hw_addr_sync_multiple fndecl 0-3 54744 NULL nohasharray
+disable_so_irq_modify_status_fndecl_54744 irq_modify_status fndecl 1 54744 &disable_so___hw_addr_sync_multiple_fndecl_54744
+disable_so_vfreq_aspect_std_timing_54751 vfreq_aspect std_timing 0 54751 NULL
+disable_so_sd_gid_stat_data_54756 sd_gid stat_data 0 54756 NULL
+disable_so_buffer_addr_m3_dma_54757 buffer_addr m3_dma 0 54757 NULL
+disable_so_driver_timestamp_qla4_8xxx_minidump_template_hdr_54761 driver_timestamp qla4_8xxx_minidump_template_hdr 0 54761 NULL
+disable_so_bitmap_root_ll_disk_54791 bitmap_root ll_disk 0 54791 NULL
+disable_so_addr_to_sbp2_pointer_fndecl_54805 addr_to_sbp2_pointer fndecl 1 54805 NULL
+disable_so_i2c_addr_af9013_config_54806 i2c_addr af9013_config 0 54806 NULL
+disable_so_runtime_sched_dl_entity_54815 runtime sched_dl_entity 0 54815 NULL
+disable_so_signal_rtl8187_rx_hdr_54828 signal rtl8187_rx_hdr 0 54828 NULL
+disable_so_gid_list_dma_qla_hw_data_54829 gid_list_dma qla_hw_data 0 54829 NULL
+disable_so_tsi721_omsg_interrupt_enable_fndecl_54831 tsi721_omsg_interrupt_enable fndecl 3-2 54831 NULL
+disable_so_nsec_pps_ktime_54835 nsec pps_ktime 0 54835 NULL
+disable_so_timeout_xfrm_policy_queue_54847 timeout xfrm_policy_queue 0 54847 NULL
+disable_so_uid_used_vardecl_gracl_segv_c_54850 uid_used vardecl_gracl_segv.c 0 54850 NULL
+disable_so_regmap_update_bits_fndecl_54855 regmap_update_bits fndecl 0-2-4-3 54855 NULL
+disable_so_next_status_checked_time_netup_ci_state_54858 next_status_checked_time netup_ci_state 0 54858 NULL
+disable_so_dma_addr_s_txd_os_54860 dma_addr s_txd_os 0 54860 NULL
+disable_so_tms_cstime_compat_tms_54864 tms_cstime compat_tms 0 54864 NULL
+disable_so_reply_dma_max_address_MPT3SAS_ADAPTER_54869 reply_dma_max_address MPT3SAS_ADAPTER 0 54869 NULL
+disable_so_tsc_read_refs_fndecl_54873 tsc_read_refs fndecl 0 54873 NULL
+disable_so_tpm_get_timeouts_fndecl_54878 tpm_get_timeouts fndecl 0 54878 NULL
+disable_so_dn_hash_dump_bucket_fndecl_54884 dn_hash_dump_bucket fndecl 0 54884 NULL
+disable_so_queue_timeout_fndecl_54887 queue_timeout fndecl 2 54887 NULL
+disable_so_T5_address_mxt_data_54888 T5_address mxt_data 0 54888 NULL
+disable_so_arizona_runtime_resume_fndecl_54897 arizona_runtime_resume fndecl 0 54897 NULL
+disable_so_udp_timeout_ip_vs_timeout_user_54908 udp_timeout ip_vs_timeout_user 0 54908 NULL
+disable_so_idiag_uid_inet_diag_msg_54913 idiag_uid inet_diag_msg 0 54913 NULL nohasharray
+disable_so_last_semaphore_wait_addr_radeon_ring_54913 last_semaphore_wait_addr radeon_ring 0 54913 &disable_so_idiag_uid_inet_diag_msg_54913
+disable_so_aty_st_le32_fndecl_54925 aty_st_le32 fndecl 2 54925 NULL
+disable_so_saffirepro_both_clk_freq_set_fndecl_54935 saffirepro_both_clk_freq_set fndecl 0 54935 NULL
+disable_so_mcryptd_hash_finup_fndecl_54940 mcryptd_hash_finup fndecl 2 54940 NULL
+disable_so_nla_put_be64_fndecl_54942 nla_put_be64 fndecl 0 54942 NULL
+disable_so_delay_qlc_83xx_entry_hdr_54949 delay qlc_83xx_entry_hdr 0 54949 NULL
+disable_so_dac33_dai_delay_fndecl_54952 dac33_dai_delay fndecl 0 54952 NULL nohasharray
+disable_so_dmaaddr_cafe_priv_54952 dmaaddr cafe_priv 0 54952 &disable_so_dac33_dai_delay_fndecl_54952
+disable_so_addr_hda_codec_54956 addr hda_codec 0 54956 NULL
+disable_so_dummy_buffer_addr_lo_fcoe_kwqe_init1_54962 dummy_buffer_addr_lo fcoe_kwqe_init1 0 54962 NULL nohasharray
+disable_so_magn_3d_adjust_channel_bit_mask_fndecl_54962 magn_3d_adjust_channel_bit_mask fndecl 3 54962 &disable_so_dummy_buffer_addr_lo_fcoe_kwqe_init1_54962
+disable_so_default_timetolive_sctp_sock_54963 default_timetolive sctp_sock 0 54963 NULL
+disable_so_test_acipher_cycles_fndecl_54972 test_acipher_cycles fndecl 0 54972 NULL
+disable_so_last_jiffies_tick_sched_54974 last_jiffies tick_sched 0 54974 NULL
+disable_so_offset_btrfs_delayed_data_ref_54980 offset btrfs_delayed_data_ref 0 54980 NULL
+disable_so_toshiba_usb_sleep_music_set_fndecl_54986 toshiba_usb_sleep_music_set fndecl 0 54986 NULL
+disable_so_addr_start_vardecl_init_64_c_54989 addr_start vardecl_init_64.c 0 54989 NULL
+disable_so_seq_xfrm_user_acquire_54990 seq xfrm_user_acquire 0 54990 NULL
+disable_so_setup_ide_timing_54997 setup ide_timing 0 54997 NULL
+disable_so_dirtytime_interval_handler_fndecl_54998 dirtytime_interval_handler fndecl 0 54998 NULL
+disable_so_last_heartbeat_timestamp_ctlr_info_55000 last_heartbeat_timestamp ctlr_info 0 55000 NULL
+disable_so_bond_set_mac_address_fndecl_55006 bond_set_mac_address fndecl 0 55006 NULL
+disable_so_curfreq_amradio_device_55017 curfreq amradio_device 0 55017 NULL
+disable_so_time_mult_perf_event_mmap_page_55031 time_mult perf_event_mmap_page 0 55031 NULL nohasharray
+disable_so___i2c_bit_add_bus_fndecl_55031 __i2c_bit_add_bus fndecl 0 55031 &disable_so_time_mult_perf_event_mmap_page_55031
+disable_so_addr_f71882fg_data_55035 addr f71882fg_data 0 55035 NULL
+disable_so_time_stamp_igb_tx_buffer_55041 time_stamp igb_tx_buffer 0 55041 NULL
+disable_so_fsl_spdif_txclk_caldiv_fndecl_55042 fsl_spdif_txclk_caldiv fndecl 3-0 55042 NULL
+disable_so_wall_time_coarse_sec_vsyscall_gtod_data_55048 wall_time_coarse_sec vsyscall_gtod_data 0 55048 NULL nohasharray
+disable_so_rv770_set_smc_sram_address_fndecl_55048 rv770_set_smc_sram_address fndecl 0-2 55048 &disable_so_wall_time_coarse_sec_vsyscall_gtod_data_55048
+disable_so_enic_set_mac_address_fndecl_55049 enic_set_mac_address fndecl 0 55049 NULL
+disable_so_bitmap_shift_left_fndecl_55055 bitmap_shift_left fndecl 3-4 55055 NULL
+disable_so_uea_set_bulk_timeout_fndecl_55059 uea_set_bulk_timeout fndecl 2 55059 NULL
+disable_so_xfs_btree_check_lblock_fndecl_55062 xfs_btree_check_lblock fndecl 0 55062 NULL
+disable_so_addr_num_sctp_getaddrs_old_55065 addr_num sctp_getaddrs_old 0 55065 NULL
+disable_so_random_ri_fndecl_55094 random_ri fndecl 0 55094 NULL
+disable_so_rhashtable_insert_fast_fndecl_55105 rhashtable_insert_fast fndecl 0 55105 NULL
+disable_so_val_nla_map_55108 val nla_map 0 55108 NULL
+disable_so_sis_program_timings_fndecl_55111 sis_program_timings fndecl 2 55111 NULL
+disable_so_crypto_authenc_esn_module_init_fndecl_55112 crypto_authenc_esn_module_init fndecl 0 55112 NULL
+disable_so_open_d_r820t_freq_range_55124 open_d r820t_freq_range 0 55124 NULL
+disable_so_b43legacy_set_slot_time_fndecl_55128 b43legacy_set_slot_time fndecl 2 55128 NULL nohasharray
+disable_so_rowaddr_fndecl_55128 rowaddr fndecl 2 55128 &disable_so_b43legacy_set_slot_time_fndecl_55128 nohasharray
+disable_so_iscsit_do_crypto_hash_sg_fndecl_55128 iscsit_do_crypto_hash_sg fndecl 4-5 55128 &disable_so_rowaddr_fndecl_55128 nohasharray
+disable_so_padlock_sha1_final_fndecl_55128 padlock_sha1_final fndecl 0 55128 &disable_so_iscsit_do_crypto_hash_sg_fndecl_55128
+disable_so_st_ctime_stat_55144 st_ctime stat 0 55144 NULL
+disable_so_bma150_set_low_g_interrupt_fndecl_55166 bma150_set_low_g_interrupt fndecl 4-5-3-0 55166 NULL
+disable_so_atomic_commit_drm_mode_config_funcs_55169 atomic_commit drm_mode_config_funcs 0 55169 NULL
+disable_so_timeout_ns_mmc_data_55170 timeout_ns mmc_data 0 55170 NULL
+disable_so_rq_addr_low_nes_qp_context_55197 rq_addr_low nes_qp_context 0 55197 NULL
+disable_so_gaintime_tsl2563_gainlevel_coeff_55201 gaintime tsl2563_gainlevel_coeff 0 55201 NULL
+disable_so_attr_timeout_fndecl_55204 attr_timeout fndecl 0 55204 NULL
+disable_so_tx_addr_happy_meal_txd_55205 tx_addr happy_meal_txd 0 55205 NULL nohasharray
+disable_so_hsync_v4l2_bt_timings_55205 hsync v4l2_bt_timings 0 55205 &disable_so_tx_addr_happy_meal_txd_55205
+disable_so_decode_bitmap_fndecl_55218 decode_bitmap fndecl 0 55218 NULL
+disable_so_p1_gma_clock_t_55221 p1 gma_clock_t 0 55221 NULL
+disable_so_bitrate_can_bittiming_55225 bitrate can_bittiming 0 55225 NULL
+disable_so_tqi_ready_time_ath5k_txq_info_55226 tqi_ready_time ath5k_txq_info 0 55226 NULL
+disable_so_msr_seek_fndecl_55235 msr_seek fndecl 0-2 55235 NULL
+disable_so_fw_mon_cycle_cnt_iwl_fw_error_dump_fw_mon_55239 fw_mon_cycle_cnt iwl_fw_error_dump_fw_mon 0 55239 NULL
+disable_so_ac97_clock_vardecl_via82xx_c_55242 ac97_clock vardecl_via82xx.c 0 55242 NULL
+disable_so_si2157_sleep_fndecl_55246 si2157_sleep fndecl 0 55246 NULL
+disable_so_max8925_rtc_read_time_fndecl_55254 max8925_rtc_read_time fndecl 0 55254 NULL
+disable_so_di_gid_efs_dinode_55256 di_gid efs_dinode 0 55256 NULL
+disable_so_elan_i2c_sleep_control_fndecl_55264 elan_i2c_sleep_control fndecl 0 55264 NULL
+disable_so_freq_reg_info_regd_fndecl_55266 freq_reg_info_regd fndecl 2 55266 NULL
+disable_so_int_coalescing_timer_ahd_softc_55267 int_coalescing_timer ahd_softc 0 55267 NULL
+disable_so_grsec_alert_wtime_vardecl_55279 grsec_alert_wtime vardecl 0 55279 NULL
+disable_so_btrfs_inode_gid_fndecl_55281 btrfs_inode_gid fndecl 0 55281 NULL
+disable_so_ebitmap_node_set_bit_fndecl_55285 ebitmap_node_set_bit fndecl 2 55285 NULL
+disable_so_gpu_addr_kfd_mem_obj_55286 gpu_addr kfd_mem_obj 0 55286 NULL
+disable_so_smp_random_fndecl_55288 smp_random fndecl 0 55288 NULL
+disable_so_start_rmt_timer1_fndecl_55290 start_rmt_timer1 fndecl 2 55290 NULL
+disable_so_cit_setkey_cipher_tfm_55304 cit_setkey cipher_tfm 0-3 55304 NULL
+disable_so_grpfreq_pca963x_chipdef_55310 grpfreq pca963x_chipdef 0 55310 NULL
+disable_so_mb_dma_address_skd_special_context_55312 mb_dma_address skd_special_context 0 55312 NULL
+disable_so_t4_fwaddrspace_write_fndecl_55313 t4_fwaddrspace_write fndecl 0-2 55313 NULL
+disable_so_num_msrs_to_save_vardecl_x86_c_55317 num_msrs_to_save vardecl_x86.c 0 55317 NULL
+disable_so_cdc_ncm_show_tx_timer_usecs_fndecl_55319 cdc_ncm_show_tx_timer_usecs fndecl 0 55319 NULL
+disable_so_sum_exec_runtime_task_cputime_55320 sum_exec_runtime task_cputime 0 55320 NULL
+disable_so_crypto_hash_final_fndecl_55327 crypto_hash_final fndecl 0 55327 NULL
+disable_so___irq_domain_add_fndecl_55334 __irq_domain_add fndecl 2-3 55334 NULL
+disable_so_end_addr_p54_tx_info_55335 end_addr p54_tx_info 0 55335 NULL
+disable_so_pre_div_pll__55336 pre_div pll_ 0 55336 NULL nohasharray
+disable_so_als_adjust_channel_bit_mask_fndecl_55336 als_adjust_channel_bit_mask fndecl 3 55336 &disable_so_pre_div_pll__55336
+disable_so_write_timeout_cdrom_info_55346 write_timeout cdrom_info 0 55346 NULL nohasharray
+disable_so_crypto_ecb_decrypt_fndecl_55346 crypto_ecb_decrypt fndecl 0-4 55346 &disable_so_write_timeout_cdrom_info_55346
+disable_so_audit_set_backlog_wait_time_fndecl_55349 audit_set_backlog_wait_time fndecl 1-0 55349 NULL
+disable_so_show_risefalltime_fndecl_55351 show_risefalltime fndecl 4-0 55351 NULL
+disable_so_ahash_def_finup_done2_fndecl_55353 ahash_def_finup_done2 fndecl 2 55353 NULL
+disable_so_dm_btree_lookup_fndecl_55361 dm_btree_lookup fndecl 0-2 55361 NULL
+disable_so_drm_prime_sg_to_page_addr_arrays_fndecl_55369 drm_prime_sg_to_page_addr_arrays fndecl 4 55369 NULL
+disable_so_real_clock_atom_clock_dividers_55377 real_clock atom_clock_dividers 0 55377 NULL
+disable_so_div_f1_pll_values_55378 div_f1 pll_values 0 55378 NULL
+disable_so_pci_address_hpt_iopsg_55384 pci_address hpt_iopsg 0 55384 NULL
+disable_so_inode_id_btrfs_delayed_node_55390 inode_id btrfs_delayed_node 0 55390 NULL
+disable_so_write32_bcma_host_ops_55392 write32 bcma_host_ops 3 55392 NULL
+disable_so_freq_libipw_channel_55395 freq libipw_channel 0 55395 NULL nohasharray
+disable_so_maxlen_img_ir_free_timing_55395 maxlen img_ir_free_timing 0 55395 &disable_so_freq_libipw_channel_55395
+disable_so_tgid_autofs_wait_queue_55396 tgid autofs_wait_queue 0 55396 NULL
+disable_so_init_latch_addr_flash_data_55405 init latch_addr_flash_data 2 55405 NULL
+disable_so_di_ctime_nsec_gfs2_dinode_55408 di_ctime_nsec gfs2_dinode 0 55408 NULL nohasharray
+disable_so_hdspm_round_frequency_fndecl_55408 hdspm_round_frequency fndecl 0-1 55408 &disable_so_di_ctime_nsec_gfs2_dinode_55408
+disable_so_time_expires_NCR5380_hostdata_55415 time_expires NCR5380_hostdata 0 55415 NULL
+disable_so___cpu_to_virtio16_fndecl_55418 __cpu_to_virtio16 fndecl 0-2 55418 NULL
+disable_so_ktime_get_seconds_fndecl_55426 ktime_get_seconds fndecl 0 55426 NULL
+disable_so_start_pci_bus_region_55432 start pci_bus_region 0 55432 NULL
+disable_so_uid_h_misc_55433 uid h_misc 0 55433 NULL
+disable_so_clock_drm_display_mode_55440 clock drm_display_mode 0 55440 NULL
+disable_so_show_pci_clock_fndecl_55445 show_pci_clock fndecl 0 55445 NULL
+disable_so_locks_mul_rhashtable_params_55448 locks_mul rhashtable_params 0 55448 NULL
+disable_so_ds2404_read_time_fndecl_55458 ds2404_read_time fndecl 0 55458 NULL
+disable_so_freq_reg_info_fndecl_55465 freq_reg_info fndecl 2 55465 NULL
+disable_so_buffer_addr_nm256_55469 buffer_addr nm256 0 55469 NULL
+disable_so_gr_find_uid_fndecl_55479 gr_find_uid fndecl 0-1 55479 NULL
+disable_so_crypto_report_fndecl_55482 crypto_report fndecl 0 55482 NULL
+disable_so_si470x_set_freq_fndecl_55487 si470x_set_freq fndecl 2 55487 NULL
+disable_so_addr_nvif_ioctl_wr_v0_55489 addr nvif_ioctl_wr_v0 0 55489 NULL
+disable_so_vruntime_sched_entity_55490 vruntime sched_entity 0 55490 NULL nohasharray
+disable_so_hdelay_bttv_geometry_55490 hdelay bttv_geometry 0 55490 &disable_so_vruntime_sched_entity_55490 nohasharray
+disable_so_btrfs_bitmap_cluster_fndecl_55490 btrfs_bitmap_cluster fndecl 4-5-6-7 55490 &disable_so_hdelay_bttv_geometry_55490
+disable_so_height_intel_sdvo_preferred_input_timing_args_55498 height intel_sdvo_preferred_input_timing_args 0 55498 NULL
+disable_so_bosr__coeff_div_55501 bosr _coeff_div 0 55501 NULL
+disable_so_logical_address_ms_extra_data_register_55503 logical_address ms_extra_data_register 0 55503 NULL
+disable_so_last_timeout_iscsi_task_55509 last_timeout iscsi_task 0 55509 NULL
+disable_so_ip_vs_addr_set_fndecl_55530 ip_vs_addr_set fndecl 1 55530 NULL
+disable_so_cg_spll_func_cntl_3_si_clock_registers_55541 cg_spll_func_cntl_3 si_clock_registers 0 55541 NULL nohasharray
+disable_so_pwr_delay_panel_info_55541 pwr_delay panel_info 0 55541 &disable_so_cg_spll_func_cntl_3_si_clock_registers_55541 nohasharray
+disable_so_desc_card_addr___mem_55541 desc_card_addr __mem 0 55541 &disable_so_pwr_delay_panel_info_55541
+disable_so_read_addr_qla8xxx_minidump_entry_rdmem_55551 read_addr qla8xxx_minidump_entry_rdmem 0 55551 NULL nohasharray
+disable_so_xgmac_reg_addr_write_fndecl_55551 xgmac_reg_addr_write fndecl 3-0 55551 &disable_so_read_addr_qla8xxx_minidump_entry_rdmem_55551
+disable_so_timing_hpt_clock_55565 timing hpt_clock 0 55565 NULL
+disable_so_kvm_get_tsc_khz_fndecl_55570 kvm_get_tsc_khz fndecl 0 55570 NULL
+disable_so_demod_address_tda8083_config_55572 demod_address tda8083_config 0 55572 NULL
+disable_so_ql_set_mac_addr_fndecl_55574 ql_set_mac_addr fndecl 0 55574 NULL
+disable_so_lzo1x_1_compress_fndecl_55575 lzo1x_1_compress fndecl 2 55575 NULL
+disable_so_psb_intel_sdvo_get_slave_addr_fndecl_55586 psb_intel_sdvo_get_slave_addr fndecl 0 55586 NULL
+disable_so_tseg1_max_can_bittiming_const_55596 tseg1_max can_bittiming_const 0 55596 NULL
+disable_so_cap_mmap_addr_fndecl_55598 cap_mmap_addr fndecl 0 55598 NULL nohasharray
+disable_so_i_saddr_rds_incoming_55598 i_saddr rds_incoming 0 55598 &disable_so_cap_mmap_addr_fndecl_55598
+disable_so_scan_cycle_time_adp5589_kpad_platform_data_55611 scan_cycle_time adp5589_kpad_platform_data 0 55611 NULL
+disable_so_timeout_usb3_lpm_parameters_55617 timeout usb3_lpm_parameters 0 55617 NULL
+disable_so_dma_addr0_flexcop_dma_55619 dma_addr0 flexcop_dma 0 55619 NULL nohasharray
+disable_so_pci_bus_alloc_resource_fndecl_55619 pci_bus_alloc_resource fndecl 5-3-4 55619 &disable_so_dma_addr0_flexcop_dma_55619
+disable_so_drm_legacy_ctxbitmap_free_fndecl_55620 drm_legacy_ctxbitmap_free fndecl 2 55620 NULL
+disable_so_dp_saddr_rds_iw_connect_private_55621 dp_saddr rds_iw_connect_private 0 55621 NULL
+disable_so_get_fan1_div_fndecl_55629 get_fan1_div fndecl 0 55629 NULL
+disable_so_cfg_rrq_xri_bitmap_sz_lpfc_hba_55637 cfg_rrq_xri_bitmap_sz lpfc_hba 0 55637 NULL
+disable_so_timeout_ms_rdma_ucm_resolve_addr_55643 timeout_ms rdma_ucm_resolve_addr 0 55643 NULL
+disable_so_elv_rqhash_find_fndecl_55656 elv_rqhash_find fndecl 2 55656 NULL
+disable_so_addrconf_sysctl_disable_fndecl_55663 addrconf_sysctl_disable fndecl 0 55663 NULL
+disable_so_cx24117_read_signal_strength_fndecl_55668 cx24117_read_signal_strength fndecl 0 55668 NULL
+disable_so_table2_addr_ipw_priv_55672 table2_addr ipw_priv 0 55672 NULL
+disable_so_lock_time_drm_lock_data_55680 lock_time drm_lock_data 0 55680 NULL
+disable_so_timeout_init_vardecl_ch_c_55683 timeout_init vardecl_ch.c 0 55683 NULL
+disable_so_btrfs_uuid_tree_rem_fndecl_55691 btrfs_uuid_tree_rem fndecl 0-4-5 55691 NULL
+disable_so_n_cipher_schemes_ieee80211_hw_55692 n_cipher_schemes ieee80211_hw 0 55692 NULL
+disable_so_wcid_rt2x00lib_crypto_55695 wcid rt2x00lib_crypto 0 55695 NULL
+disable_so_beiscsi_get_macaddr_fndecl_55699 beiscsi_get_macaddr fndecl 0 55699 NULL
+disable_so_fdb_delete_by_addr_fndecl_55704 fdb_delete_by_addr fndecl 3 55704 NULL
+disable_so_hpi_compander_get_decay_time_constant_fndecl_55715 hpi_compander_get_decay_time_constant fndecl 1-0 55715 NULL
+disable_so_pcc_get_freq_fndecl_55717 pcc_get_freq fndecl 0 55717 NULL
+disable_so_mca_cstamp_ifmcaddr6_55724 mca_cstamp ifmcaddr6 0 55724 NULL
+disable_so_seltime_ahd_softc_55725 seltime ahd_softc 0 55725 NULL nohasharray
+disable_so_addr_2_qla8044_minidump_entry_pollwr_55725 addr_2 qla8044_minidump_entry_pollwr 0 55725 &disable_so_seltime_ahd_softc_55725
+disable_so_vm_exit_msr_load_addr_vmcs12_55733 vm_exit_msr_load_addr vmcs12 0 55733 NULL
+disable_so_mclk_pwrmgt_cntl_ci_clock_registers_55735 mclk_pwrmgt_cntl ci_clock_registers 0 55735 NULL
+disable_so_gcm_hash_update_fndecl_55740 gcm_hash_update fndecl 0-4 55740 NULL
+disable_so_ab3100_set_test_register_interruptible_fndecl_55741 ab3100_set_test_register_interruptible fndecl 0 55741 NULL
+disable_so_ieee802154_hdr_get_addrs_fndecl_55743 ieee802154_hdr_get_addrs fndecl 0 55743 NULL
+disable_so_devfreq_userspace_handler_fndecl_55748 devfreq_userspace_handler fndecl 0 55748 NULL
+disable_so_host_sg_tbl_addr_rtsx_pcr_55750 host_sg_tbl_addr rtsx_pcr 0 55750 NULL
+disable_so_crypto_hash_walk_first_compat_fndecl_55757 crypto_hash_walk_first_compat fndecl 0-4 55757 NULL
+disable_so_mpll_dq_func_cntl_si_clock_registers_55759 mpll_dq_func_cntl si_clock_registers 0 55759 NULL
+disable_so_check_gran_clock_compatibility_fndecl_55761 check_gran_clock_compatibility fndecl 2 55761 NULL
+disable_so_watchdog_set_timeout_fndecl_55765 watchdog_set_timeout fndecl 2-0 55765 NULL
+disable_so_c_laddr_rds_connection_55766 c_laddr rds_connection 0 55766 NULL
+disable_so_slot_timeout_irlap_cb_55778 slot_timeout irlap_cb 0 55778 NULL
+disable_so_timer_quantum_ns_efx_nic_55779 timer_quantum_ns efx_nic 0 55779 NULL
+disable_so_me_addr_hbm_props_request_55786 me_addr hbm_props_request 0 55786 NULL
+disable_so_snd_timer_user_continue_fndecl_55796 snd_timer_user_continue fndecl 0 55796 NULL
+disable_so_last_rx_timestamp_ixgbe_adapter_55801 last_rx_timestamp ixgbe_adapter 0 55801 NULL
+disable_so_di_mtime_logfs_disk_inode_55807 di_mtime logfs_disk_inode 0 55807 NULL
+disable_so_mxr_runtime_resume_fndecl_55814 mxr_runtime_resume fndecl 0 55814 NULL
+disable_so_write_tsc_offset_kvm_x86_ops_55825 write_tsc_offset kvm_x86_ops 2 55825 NULL
+disable_so_suspended_jiffies_dev_pm_info_55833 suspended_jiffies dev_pm_info 0 55833 NULL
+disable_so_daddr_flowi4_55835 daddr flowi4 0 55835 NULL
+disable_so_arcmsr_Read_iop_rqbuffer_data_fndecl_55838 arcmsr_Read_iop_rqbuffer_data fndecl 0 55838 NULL
+disable_so_ac_utime_pacct_struct_55849 ac_utime pacct_struct 0 55849 NULL
+disable_so_si476x_radio_s_frequency_fndecl_55854 si476x_radio_s_frequency fndecl 0 55854 NULL
+disable_so_tg3_nvram_logical_addr_fndecl_55858 tg3_nvram_logical_addr fndecl 0-2 55858 NULL
+disable_so_last_delay_mult_qib_chippport_specific_55859 last_delay_mult qib_chippport_specific 0 55859 NULL nohasharray
+disable_so_addr_offset_x86_pmu_55859 addr_offset x86_pmu 0-1 55859 &disable_so_last_delay_mult_qib_chippport_specific_55859
+disable_so_nvkm_timer_alarm_fndecl_55870 nvkm_timer_alarm fndecl 2 55870 NULL
+disable_so_num_mc_addrs_ixgbe_addr_filter_info_55888 num_mc_addrs ixgbe_addr_filter_info 0 55888 NULL
+disable_so_snd_interval_muldivk_fndecl_55894 snd_interval_muldivk fndecl 3 55894 NULL
+disable_so_read_time_rtc_class_ops_55898 read_time rtc_class_ops 0 55898 NULL
+disable_so_timeouts_size_ip_vs_app_55902 timeouts_size ip_vs_app 0 55902 NULL
+disable_so_mwifiex_process_sleep_confirm_resp_fndecl_55909 mwifiex_process_sleep_confirm_resp fndecl 3 55909 NULL
+disable_so_sleep_auth_write_fndecl_55911 sleep_auth_write fndecl 0-3 55911 NULL
+disable_so_addr_hi_pm4_query_status_55924 addr_hi pm4_query_status 0 55924 NULL
+disable_so_rpc_anyaddr_fndecl_55925 rpc_anyaddr fndecl 0-1 55925 NULL
+disable_so_fence_gpu_addr_device_queue_manager_55932 fence_gpu_addr device_queue_manager 0 55932 NULL
+disable_so_send_guid_cmd_fndecl_55933 send_guid_cmd fndecl 0 55933 NULL
+disable_so_next_id_mISDNtimerdev_55935 next_id mISDNtimerdev 0 55935 NULL
+disable_so_ref_freq_arizona_fll_55939 ref_freq arizona_fll 0 55939 NULL
+disable_so_find_prop_handlers_by_hash_fndecl_55957 find_prop_handlers_by_hash fndecl 1 55957 NULL
+disable_so_cg_spll_spread_spectrum_ci_clock_registers_55960 cg_spll_spread_spectrum ci_clock_registers 0 55960 NULL
+disable_so___xfrm_src_hash_fndecl_55965 __xfrm_src_hash fndecl 0-3-4 55965 NULL
+disable_so_tps80031_rtc_read_time_fndecl_55978 tps80031_rtc_read_time fndecl 0 55978 NULL
+disable_so_dvb_pll_sleep_fndecl_55979 dvb_pll_sleep fndecl 0 55979 NULL
+disable_so_lose_cover_sizek_mtrr_cleanup_result_55990 lose_cover_sizek mtrr_cleanup_result 0 55990 NULL
+disable_so_wil_ioc_addr_fndecl_55992 wil_ioc_addr fndecl 2-3 55992 NULL
+disable_so_ste10Xp_ack_interrupt_fndecl_55999 ste10Xp_ack_interrupt fndecl 0 55999 NULL
+disable_so_btc_skip_blacklist_clocks_fndecl_56010 btc_skip_blacklist_clocks fndecl 2-3 56010 NULL
+disable_so_sleep_mask_palmas_clk32k_desc_56015 sleep_mask palmas_clk32k_desc 0 56015 NULL
+disable_so_cs_pt_regs_56018 cs pt_regs 0 56018 NULL nohasharray
+disable_so_vmcs_writel_fndecl_56018 vmcs_writel fndecl 2 56018 &disable_so_cs_pt_regs_56018
+disable_so_i_mtime_nsec_f2fs_inode_56019 i_mtime_nsec f2fs_inode 0 56019 NULL
+disable_so_ecx_user_regs_struct32_56025 ecx user_regs_struct32 0 56025 NULL
+disable_so_k8_map_sysaddr_to_csrow_fndecl_56032 k8_map_sysaddr_to_csrow fndecl 2 56032 NULL
+disable_so_max_busy_timeout_mmc_host_56037 max_busy_timeout mmc_host 0 56037 NULL
+disable_so_snd_tea575x_get_freq_fndecl_56045 snd_tea575x_get_freq fndecl 0 56045 NULL
+disable_so_timer_interval_r8a66597_pipe_info_56047 timer_interval r8a66597_pipe_info 0 56047 NULL nohasharray
+disable_so_wc_ct_timer_56047 wc ct_timer 0 56047 &disable_so_timer_interval_r8a66597_pipe_info_56047
+disable_so_gs_tss_segment_32_56052 gs tss_segment_32 0 56052 NULL
+disable_so_bg_inode_bitmap_lo_ext4_group_desc_56060 bg_inode_bitmap_lo ext4_group_desc 0 56060 NULL
+disable_so_debounce_jiffies_gpio_extcon_data_56062 debounce_jiffies gpio_extcon_data 0 56062 NULL
+disable_so_timestamp_perf_event_context_56076 timestamp perf_event_context 0 56076 NULL
+disable_so_s10_img_ir_timing_regvals_56082 s10 img_ir_timing_regvals 0 56082 NULL
+disable_so_addr_nv50_instmem_priv_56092 addr nv50_instmem_priv 0 56092 NULL
+disable_so_stock_freq_vardecl_p4_clockmod_c_56103 stock_freq vardecl_p4-clockmod.c 0 56103 NULL
+disable_so_nfs4_xdr_dec_get_lease_time_fndecl_56110 nfs4_xdr_dec_get_lease_time fndecl 0 56110 NULL
+disable_so_dclk_div_ssd1307fb_par_56111 dclk_div ssd1307fb_par 0 56111 NULL
+disable_so_ad1889_load_wave_interrupt_count_fndecl_56114 ad1889_load_wave_interrupt_count fndecl 2 56114 NULL
+disable_so_tm_sec_rtc_time_56120 tm_sec rtc_time 0 56120 NULL
+disable_so_setsck_fndecl_56125 setsck fndecl 2 56125 NULL
+disable_so_acpi_ut_remove_address_range_fndecl_56141 acpi_ut_remove_address_range fndecl 1 56141 NULL
+disable_so_ssa_blkaddr_f2fs_sm_info_56145 ssa_blkaddr f2fs_sm_info 0 56145 NULL
+disable_so_ack_time_rtl8180_priv_56151 ack_time rtl8180_priv 0 56151 NULL
+disable_so_updelay_bond_params_56155 updelay bond_params 0 56155 NULL
+disable_so_pch_can_bit_clear_fndecl_56156 pch_can_bit_clear fndecl 2 56156 NULL
+disable_so_i2c_addr_si2165_config_56160 i2c_addr si2165_config 0 56160 NULL
+disable_so_gen8_rcs_signal_fndecl_56195 gen8_rcs_signal fndecl 0-2 56195 NULL
+disable_so_bmg160_setup_new_data_interrupt_fndecl_56196 bmg160_setup_new_data_interrupt fndecl 0 56196 NULL
+disable_so_addrhigh_dma64desc_56199 addrhigh dma64desc 0 56199 NULL
+disable_so_kvm_get_time_scale_fndecl_56201 kvm_get_time_scale fndecl 1 56201 NULL
+disable_so_post_divider_atom_clock_dividers_56220 post_divider atom_clock_dividers 0 56220 NULL
+disable_so_max6900_rtc_set_time_fndecl_56236 max6900_rtc_set_time fndecl 0 56236 NULL
+disable_so_crypto_rfc3686_setkey_fndecl_56237 crypto_rfc3686_setkey fndecl 0-3 56237 NULL
+disable_so_mtt_base_addr_l_mlx4_eq_context_56245 mtt_base_addr_l mlx4_eq_context 0 56245 NULL nohasharray
+disable_so_sq_read_base_addr_a0_btmrvl_sdio_card_reg_56245 sq_read_base_addr_a0 btmrvl_sdio_card_reg 0 56245 &disable_so_mtt_base_addr_l_mlx4_eq_context_56245
+disable_so_lbs_cmd_802_11_sleep_params_fndecl_56246 lbs_cmd_802_11_sleep_params fndecl 0 56246 NULL
+disable_so_verity_hash_at_level_fndecl_56248 verity_hash_at_level fndecl 2 56248 NULL
+disable_so_sk_reset_timer_fndecl_56251 sk_reset_timer fndecl 3 56251 NULL
+disable_so_skcipher_sndbuf_fndecl_56255 skcipher_sndbuf fndecl 0 56255 NULL
+disable_so_st_ctime_nsec_p9_stat_dotl_56256 st_ctime_nsec p9_stat_dotl 0 56256 NULL nohasharray
+disable_so_r29_val_fc2580_freq_regs_56256 r29_val fc2580_freq_regs 0 56256 &disable_so_st_ctime_nsec_p9_stat_dotl_56256
+disable_so_qmi_wwan_mac_addr_fndecl_56258 qmi_wwan_mac_addr fndecl 0 56258 NULL
+disable_so_cik_set_vce_clocks_fndecl_56266 cik_set_vce_clocks fndecl 3-0 56266 NULL nohasharray
+disable_so_bitmap_copy_from_slot_fndecl_56266 bitmap_copy_from_slot fndecl 0-2 56266 &disable_so_cik_set_vce_clocks_fndecl_56266
+disable_so_delay_mult_ipath_devdata_56277 delay_mult ipath_devdata 0 56277 NULL
+disable_so_esas2r_disc_get_phys_addr_fndecl_56278 esas2r_disc_get_phys_addr fndecl 0 56278 NULL
+disable_so_sst_module_runtime_get_from_id_fndecl_56286 sst_module_runtime_get_from_id fndecl 2 56286 NULL
+disable_so_freq_req_adf4350_state_56294 freq_req adf4350_state 0 56294 NULL
+disable_so_max_bandwidth_khz_ieee80211_freq_range_56300 max_bandwidth_khz ieee80211_freq_range 0 56300 NULL
+disable_so_faddr_rds_info_connection_56313 faddr rds_info_connection 0 56313 NULL
+disable_so_pcm_delay_pcm_stream_info_56329 pcm_delay pcm_stream_info 0 56329 NULL nohasharray
+disable_so_dev_addr_pch_dma_desc_regs_56329 dev_addr pch_dma_desc_regs 0 56329 &disable_so_pcm_delay_pcm_stream_info_56329
+disable_so_show_sgid_fndecl_56331 show_sgid fndecl 0 56331 NULL
+disable_so_sumo_get_valid_engine_clock_fndecl_56332 sumo_get_valid_engine_clock fndecl 0 56332 NULL
+disable_so_bitmap_resize_fndecl_56333 bitmap_resize fndecl 0-2 56333 NULL
+disable_so_get_cpufreq_driver_56334 get cpufreq_driver 0-1 56334 NULL
+disable_so_cg_spll_spread_spectrum_2_rv770_clock_registers_56343 cg_spll_spread_spectrum_2 rv770_clock_registers 0 56343 NULL
+disable_so_dsa_slave_set_mac_address_fndecl_56363 dsa_slave_set_mac_address fndecl 0 56363 NULL nohasharray
+disable_so_log2secsize_adfs_discrecord_56363 log2secsize adfs_discrecord 0 56363 &disable_so_dsa_slave_set_mac_address_fndecl_56363 nohasharray
+enable_so_i_ino_xfs_inode_56363 i_ino xfs_inode 0 56363 &disable_so_log2secsize_adfs_discrecord_56363
+disable_so_offset_bit_entry_56370 offset bit_entry 0 56370 NULL
+disable_so_serio_interrupt_fndecl_56371 serio_interrupt fndecl 2 56371 NULL
+disable_so_nla_put_s8_fndecl_56378 nla_put_s8 fndecl 0 56378 NULL
+disable_so_max_timing_entry_56381 max timing_entry 0 56381 NULL
+disable_so_clk_div_chip_data_56404 clk_div chip_data 0 56404 NULL
+disable_so_index_addr_fndecl_56405 index_addr fndecl 2-3 56405 NULL
+disable_so_sysctl_tipc_named_timeout_vardecl_56406 sysctl_tipc_named_timeout vardecl 0 56406 NULL nohasharray
+disable_so_pci_bus_clock_list_ultra_fndecl_56406 pci_bus_clock_list_ultra fndecl 0-1 56406 &disable_so_sysctl_tipc_named_timeout_vardecl_56406
+disable_so_pwm_freq_to_reg_fndecl_56419 pwm_freq_to_reg fndecl 0-1 56419 NULL
+disable_so_compaq_ioaddr_vardecl_3c59x_c_56423 compaq_ioaddr vardecl_3c59x.c 0 56423 NULL
+disable_so_nv04_timer_ctor_fndecl_56428 nv04_timer_ctor fndecl 0 56428 NULL
+disable_so_last_jiffies_dm_kcopyd_throttle_56429 last_jiffies dm_kcopyd_throttle 0 56429 NULL
+disable_so_prev_xfer_time_if_spi_card_56430 prev_xfer_time if_spi_card 0 56430 NULL
+disable_so_cpufreq_governor_dbs_fndecl_56433 cpufreq_governor_dbs fndecl 0 56433 NULL
+disable_so_align_vdso_addr_fndecl_56438 align_vdso_addr fndecl 0-1 56438 NULL
+disable_so_addresshigh_SG64ENTRY_56440 addresshigh SG64ENTRY 0 56440 NULL
+disable_so_freq_nvbios_M0205T_56458 freq nvbios_M0205T 0 56458 NULL
+disable_so_hfs_bnode_hash_fndecl_56462 hfs_bnode_hash fndecl 0-1 56462 NULL
+disable_so_address_rmap_item_56465 address rmap_item 0 56465 NULL
+disable_so_tseg1_pucan_timing_fast_56466 tseg1 pucan_timing_fast 0 56466 NULL
+disable_so_read_reg_qlcnic_hardware_ops_56470 read_reg qlcnic_hardware_ops 0-2 56470 NULL
+disable_so_ba0_addr_cs4281_56471 ba0_addr cs4281 0 56471 NULL
+disable_so_seltime_ahc_softc_56482 seltime ahc_softc 0 56482 NULL
+disable_so_preferred_resolution_snd_seq_timer_56486 preferred_resolution snd_seq_timer 0 56486 NULL
+disable_so_rtl8723e_dm_bt_set_sw_full_time_dac_swing_fndecl_56491 rtl8723e_dm_bt_set_sw_full_time_dac_swing fndecl 3 56491 NULL
+disable_so_compat_sys_utime_fndecl_56499 compat_sys_utime fndecl 0 56499 NULL
+disable_so_max_cpufreq_policy_56505 max cpufreq_policy 0 56505 NULL
+disable_so_gpm_addr_ath9k_hw_mci_56507 gpm_addr ath9k_hw_mci 0 56507 NULL
+disable_so_local_cm_response_timeout_ib_cm_req_event_param_56527 local_cm_response_timeout ib_cm_req_event_param 0 56527 NULL
+disable_so_di_ctime_qnx4_inode_entry_56528 di_ctime qnx4_inode_entry 0 56528 NULL
+disable_so_check_object_size_fndecl_56537 check_object_size fndecl 2 56537 NULL
+disable_so_netlbl_unlhsh_remove_addr4_fndecl_56540 netlbl_unlhsh_remove_addr4 fndecl 0 56540 NULL
+disable_so_pio_address_qla_hw_data_56550 pio_address qla_hw_data 0 56550 NULL
+disable_so_clockdelay_te_vardecl_hfcmulti_c_56569 clockdelay_te vardecl_hfcmulti.c 0 56569 NULL
+disable_so_cfg80211_get_start_freq_fndecl_56579 cfg80211_get_start_freq fndecl 0-1-2 56579 NULL
+disable_so_crypto_info_open_fndecl_56585 crypto_info_open fndecl 0 56585 NULL
+disable_so_iio_interrupt_trigger_probe_fndecl_56586 iio_interrupt_trigger_probe fndecl 0 56586 NULL
+disable_so_csize_lattime_ahd_suspend_pci_state_56599 csize_lattime ahd_suspend_pci_state 0 56599 NULL
+disable_so_pcxhr_get_clock_reg_fndecl_56600 pcxhr_get_clock_reg fndecl 2-0 56600 NULL
+disable_so_ib_find_cached_gid_fndecl_56608 ib_find_cached_gid fndecl 0 56608 NULL
+disable_so_btree_node_write_endio_fndecl_56609 btree_node_write_endio fndecl 2 56609 NULL
+disable_so_rxdescmem_busaddr_altera_tse_private_56610 rxdescmem_busaddr altera_tse_private 0 56610 NULL
+disable_so_pwm_downtime_w83793_data_56624 pwm_downtime w83793_data 0 56624 NULL
+disable_so_nl80211_crypto_settings_fndecl_56625 nl80211_crypto_settings fndecl 0 56625 NULL
+disable_so_freq_pmu0_plltab_entry_56630 freq pmu0_plltab_entry 0 56630 NULL
+disable_so_get_register_page_interruptible_fndecl_56634 get_register_page_interruptible fndecl 0 56634 NULL
+disable_so_time_rx_survey_info_56644 time_rx survey_info 0 56644 NULL
+disable_so_isp1362_write_diraddr_fndecl_56658 isp1362_write_diraddr fndecl 2-3 56658 NULL
+disable_so_utime_task_cputime_56665 utime task_cputime 0 56665 NULL
+disable_so_blogic_add_probeaddr_isa_fndecl_56669 blogic_add_probeaddr_isa fndecl 1 56669 NULL
+disable_so_memsize_bitmap_ip_56671 memsize bitmap_ip 0 56671 NULL
+disable_so_ssb_pmu_get_alp_clock_fndecl_56673 ssb_pmu_get_alp_clock fndecl 0 56673 NULL nohasharray
+disable_so_crypto_xor_fndecl_56673 crypto_xor fndecl 3 56673 &disable_so_ssb_pmu_get_alp_clock_fndecl_56673
+disable_so_addr_wqicb_56680 addr wqicb 0 56680 NULL
+disable_so_post_div_atom_clock_dividers_56686 post_div atom_clock_dividers 0 56686 NULL
+disable_so_local_ca_guid_cm_req_msg_56691 local_ca_guid cm_req_msg 0 56691 NULL
+disable_so_ath5k_hw_check_beacon_timers_fndecl_56701 ath5k_hw_check_beacon_timers fndecl 2 56701 NULL
+disable_so_resultjiffies_vardecl_floppy_c_56702 resultjiffies vardecl_floppy.c 0 56702 NULL
+disable_so_snd_tea575x_s_hw_freq_seek_fndecl_56703 snd_tea575x_s_hw_freq_seek fndecl 0 56703 NULL
+disable_so_ir_clock_mhz_vardecl_tm6000_input_c_56706 ir_clock_mhz vardecl_tm6000-input.c 0 56706 NULL
+disable_so_mei_me_pm_runtime_suspend_fndecl_56711 mei_me_pm_runtime_suspend fndecl 0 56711 NULL
+disable_so_deftype_kvm_mtrr_56712 deftype kvm_mtrr 0 56712 NULL
+disable_so_base_addr_phys__adpt_hba_56713 base_addr_phys _adpt_hba 0 56713 NULL
+disable_so_addr_nvkm_instobj_56715 addr nvkm_instobj 0 56715 NULL
+disable_so_do_wait_for_common_fndecl_56721 do_wait_for_common fndecl 4 56721 NULL
+disable_so_i_uid_minix_inode_56733 i_uid minix_inode 0 56733 NULL
+disable_so_addr_nvkm_engctx_56734 addr nvkm_engctx 0 56734 NULL nohasharray
+disable_so_RF_SYN_reserved_addr27_chan_info_nphy_radio205x_56734 RF_SYN_reserved_addr27 chan_info_nphy_radio205x 0 56734 &disable_so_addr_nvkm_engctx_56734
+disable_so_bp_pt_regs_56736 bp pt_regs 0 56736 NULL
+disable_so_hor_blank_end_via_display_timing_56738 hor_blank_end via_display_timing 0 56738 NULL
+disable_so_panel_power_cycle_delay_intel_dp_56739 panel_power_cycle_delay intel_dp 0 56739 NULL
+disable_so_dib8000_sleep_fndecl_56740 dib8000_sleep fndecl 0 56740 NULL
+disable_so_ext4_valid_block_bitmap_fndecl_56749 ext4_valid_block_bitmap fndecl 0-3 56749 NULL
+disable_so_func_bit_map_vif_list_event_data_56753 func_bit_map vif_list_event_data 0 56753 NULL
+disable_so_netxen_nic_set_mcast_addr_fndecl_56754 netxen_nic_set_mcast_addr fndecl 2 56754 NULL
+disable_so_wrmsr_on_cpu_fndecl_56757 wrmsr_on_cpu fndecl 0-1-3-4 56757 NULL
+disable_so_rmap_recycle_fndecl_56761 rmap_recycle fndecl 3 56761 NULL
+disable_so_cyapa_gen5_get_interval_time_fndecl_56783 cyapa_gen5_get_interval_time fndecl 0 56783 NULL nohasharray
+disable_so_laddr_rds_info_message_56783 laddr rds_info_message 0 56783 &disable_so_cyapa_gen5_get_interval_time_fndecl_56783
+disable_so_btrfs_set_inode_uid_fndecl_56785 btrfs_set_inode_uid fndecl 3 56785 NULL
+disable_so_wl1251_acx_group_address_tbl_fndecl_56786 wl1251_acx_group_address_tbl fndecl 0 56786 NULL
+disable_so_idletimer_tg_show_fndecl_56792 idletimer_tg_show fndecl 0 56792 NULL
+disable_so_ofdmtab_addr_b43_phy_g_56793 ofdmtab_addr b43_phy_g 0 56793 NULL
+disable_so_count_radeon_clock_voltage_dependency_table_56794 count radeon_clock_voltage_dependency_table 0 56794 NULL
+disable_so_nla_put_in_addr_fndecl_56802 nla_put_in_addr fndecl 0 56802 NULL
+disable_so_br_multicast_set_hash_max_fndecl_56807 br_multicast_set_hash_max fndecl 0-2 56807 NULL
+disable_so_runtime_expires_cfs_rq_56808 runtime_expires cfs_rq 0 56808 NULL nohasharray
+disable_so_write_file_bt_ant_diversity_fndecl_56808 write_file_bt_ant_diversity fndecl 0 56808 &disable_so_runtime_expires_cfs_rq_56808
+disable_so_sisfb_post_xgi_setclocks_fndecl_56821 sisfb_post_xgi_setclocks fndecl 2 56821 NULL
+disable_so_ipath_signal_procs_fndecl_56823 ipath_signal_procs fndecl 2 56823 NULL
+disable_so_seqtimer_scaling_vardecl_azt3328_c_56829 seqtimer_scaling vardecl_azt3328.c 0 56829 NULL
+disable_so_bar_bus_addr_usnic_ib_create_qp_resp_56831 bar_bus_addr usnic_ib_create_qp_resp 0 56831 NULL
+disable_so_fib_laddr_hashfn_fndecl_56832 fib_laddr_hashfn fndecl 0-1 56832 NULL
+disable_so_qlcnic_82xx_sre_macaddr_change_fndecl_56836 qlcnic_82xx_sre_macaddr_change fndecl 0 56836 NULL
+disable_so_dm_btree_find_lowest_key_fndecl_56845 dm_btree_find_lowest_key fndecl 0-2 56845 NULL
+disable_so_get_fan_div_fndecl_56857 get_fan_div fndecl 0 56857 NULL
+disable_so_neigh_proc_dointvec_jiffies_fndecl_56860 neigh_proc_dointvec_jiffies fndecl 0 56860 NULL
+disable_so_last_delay_snd_usb_substream_56861 last_delay snd_usb_substream 0 56861 NULL
+disable_so_memory_address_set_error_type_with_address_56863 memory_address set_error_type_with_address 0 56863 NULL
+disable_so_seq_b43_txstatus_56873 seq b43_txstatus 0 56873 NULL
+disable_so_phonet_address_notify_fndecl_56877 phonet_address_notify fndecl 1-3 56877 NULL
+disable_so_msp_sleep_fndecl_56878 msp_sleep fndecl 2 56878 NULL nohasharray
+disable_so_ltr501_match_samp_freq_fndecl_56878 ltr501_match_samp_freq fndecl 0 56878 &disable_so_msp_sleep_fndecl_56878
+disable_so_signalled_used_vhost_virtqueue_56881 signalled_used vhost_virtqueue 0 56881 NULL
+disable_so_titsc_probe_fndecl_56883 titsc_probe fndecl 0 56883 NULL
+disable_so_xfs_btree_check_sblock_fndecl_56897 xfs_btree_check_sblock fndecl 0 56897 NULL
+disable_so_jiffies_next_hackrf_dev_56900 jiffies_next hackrf_dev 0 56900 NULL
+disable_so_bpf_get_prandom_u32_fndecl_56904 bpf_get_prandom_u32 fndecl 0 56904 NULL
+disable_so_rt_lifetime_icmpv6_nd_ra_56907 rt_lifetime icmpv6_nd_ra 0 56907 NULL
+disable_so_base_addr_ufshcd_sg_entry_56924 base_addr ufshcd_sg_entry 0 56924 NULL
+disable_so_crypto_gcm_decrypt_fndecl_56932 crypto_gcm_decrypt fndecl 0 56932 NULL
+disable_so_pll_d_aic31xx_rate_divs_56933 pll_d aic31xx_rate_divs 0 56933 NULL
+disable_so_mc_arb_burst_time_SMC_SIslands_MCArbDramTimingRegisterSet_56938 mc_arb_burst_time SMC_SIslands_MCArbDramTimingRegisterSet 0 56938 NULL
+disable_so_hfc_jiffies_vardecl_hfcpci_c_56949 hfc_jiffies vardecl_hfcpci.c 0 56949 NULL
+disable_so_pm_timeout_orinoco_private_56953 pm_timeout orinoco_private 0 56953 NULL
+disable_so_cpu_delayed_work_56959 cpu delayed_work 0 56959 NULL
+disable_so_sys_sched_setscheduler_fndecl_56964 sys_sched_setscheduler fndecl 2-1-0 56964 NULL
+disable_so_ucode_beacon_time_il_priv_56968 ucode_beacon_time il_priv 0 56968 NULL
+disable_so_ntsc_tvdac_adj_radeon_encoder_tv_dac_56984 ntsc_tvdac_adj radeon_encoder_tv_dac 0 56984 NULL
+disable_so_hbqaddrLow_config_hbq_var_56996 hbqaddrLow config_hbq_var 0 56996 NULL
+disable_so_hpios_delay_micro_seconds_fndecl_57000 hpios_delay_micro_seconds fndecl 1 57000 NULL
+disable_so_pwm_freq_nvbios_therm_fan_57021 pwm_freq nvbios_therm_fan 0 57021 NULL
+disable_so_cycle_interval_timekeeper_57030 cycle_interval timekeeper 0 57030 NULL
+disable_so_qce_ablkcipher_register_fndecl_57031 qce_ablkcipher_register fndecl 0 57031 NULL
+disable_so_posix_cpu_clock_set_fndecl_57033 posix_cpu_clock_set fndecl 1 57033 NULL
+disable_so_ac97_clock_via82xx_modem_57034 ac97_clock via82xx_modem 0 57034 NULL
+disable_so_ip_set_get_ipaddr4_fndecl_57035 ip_set_get_ipaddr4 fndecl 0 57035 NULL
+disable_so_mmap_min_addr_handler_fndecl_57042 mmap_min_addr_handler fndecl 0 57042 NULL
+disable_so___mutex_lock_interruptible_slowpath_fndecl_57044 __mutex_lock_interruptible_slowpath fndecl 0 57044 NULL
+disable_so_round_jiffies_relative_fndecl_57045 round_jiffies_relative fndecl 0-1 57045 NULL
+disable_so_addr2___pollrdmwr_57048 addr2 __pollrdmwr 0 57048 NULL
+disable_so_opmode_ioaddr_mxser_port_57052 opmode_ioaddr mxser_port 0 57052 NULL nohasharray
+disable_so_xfrm_hash_transfer_fndecl_57052 xfrm_hash_transfer fndecl 5 57052 &disable_so_opmode_ioaddr_mxser_port_57052
+disable_so_hpi_sample_clock_query_source_index_fndecl_57055 hpi_sample_clock_query_source_index fndecl 1-0 57055 NULL
+disable_so_bitmap_full_fndecl_57072 bitmap_full fndecl 2 57072 NULL
+disable_so_cmd_attr_deregister_cpumask_fndecl_57077 cmd_attr_deregister_cpumask fndecl 0 57077 NULL
+disable_so_hashtab_create_fndecl_57082 hashtab_create fndecl 3 57082 NULL
+disable_so_laddr_c2wr_ae_connection_request_57084 laddr c2wr_ae_connection_request 0 57084 NULL
+disable_so_alarmtimer_suspend_fndecl_57099 alarmtimer_suspend fndecl 0 57099 NULL
+disable_so___cpufreq_cooling_register_fndecl_57101 __cpufreq_cooling_register fndecl 3 57101 NULL
+disable_so_fll_clk_ref_div__fll_div_57104 fll_clk_ref_div _fll_div 0 57104 NULL
+disable_so_tsc_to_system_mul_pvclock_vcpu_time_info_57110 tsc_to_system_mul pvclock_vcpu_time_info 0 57110 NULL nohasharray
+disable_so_dp_clock_radeon_dp_link_train_info_57110 dp_clock radeon_dp_link_train_info 0 57110 &disable_so_tsc_to_system_mul_pvclock_vcpu_time_info_57110
+disable_so_d_spc_timer_qc_dqblk_57112 d_spc_timer qc_dqblk 0 57112 NULL
+disable_so_ntp_error_shift_timekeeper_57130 ntp_error_shift timekeeper 0 57130 NULL
+disable_so_tuner_addr_cx88_board_57133 tuner_addr cx88_board 0 57133 NULL
+disable_so_width_v4l2_bt_timings_57137 width v4l2_bt_timings 0 57137 NULL
+disable_so_function_timer_list_57140 function timer_list 1 57140 NULL
+disable_so_tuner_address_ts2020_config_57154 tuner_address ts2020_config 0 57154 NULL
+disable_so_sm501_set_clock_fndecl_57155 sm501_set_clock fndecl 3-0 57155 NULL
+disable_so_addrlimit_qib_user_sdma_pkt_57160 addrlimit qib_user_sdma_pkt 0 57160 NULL
+disable_so_read_file_regidx_fndecl_57161 read_file_regidx fndecl 3-0 57161 NULL
+disable_so_slot_time_rt2x00lib_erp_57170 slot_time rt2x00lib_erp 0 57170 NULL
+disable_so_bx_pt_regs_57172 bx pt_regs 0 57172 NULL
+disable_so_ssb_pmu_get_controlclock_fndecl_57187 ssb_pmu_get_controlclock fndecl 0 57187 NULL
+disable_so_inet_fill_ifaddr_fndecl_57209 inet_fill_ifaddr fndecl 0-3-5 57209 NULL
+disable_so_mem_addr_vardecl_debugfs_c_57210 mem_addr vardecl_debugfs.c 0 57210 NULL
+disable_so_iwl_static_sleep_cmd_fndecl_57211 iwl_static_sleep_cmd fndecl 4 57211 NULL
+disable_so_frequency_khz_ts2020_priv_57218 frequency_khz ts2020_priv 0 57218 NULL
+disable_so_hashm_dcb_output_57225 hashm dcb_output 0 57225 NULL
+disable_so_show_risetime_fndecl_57236 show_risetime fndecl 0 57236 NULL
+disable_so_iscsi_nacl_attrib_store_random_r2t_offsets_fndecl_57241 iscsi_nacl_attrib_store_random_r2t_offsets fndecl 0-3 57241 NULL
+disable_so_hash_netiface6_expire_fndecl_57246 hash_netiface6_expire fndecl 4 57246 NULL
+disable_so_delayed_ack_bictcp_57249 delayed_ack bictcp 0 57249 NULL
+disable_so_addr_he_ioctl_reg_57251 addr he_ioctl_reg 0 57251 NULL
+disable_so_crystalfreq_ssb_chipcommon_pmu_57260 crystalfreq ssb_chipcommon_pmu 0 57260 NULL
+disable_so_i_dtime_ext4_inode_info_57265 i_dtime ext4_inode_info 0 57265 NULL
+disable_so_qlcnic_schedule_work_fndecl_57272 qlcnic_schedule_work fndecl 3 57272 NULL
+disable_so_uid_affs_tail_57279 uid affs_tail 0 57279 NULL nohasharray
+disable_so_delay_slave_57279 delay slave 0 57279 &disable_so_uid_affs_tail_57279 nohasharray
+disable_so_pwm_freq_to_reg_627hf_fndecl_57279 pwm_freq_to_reg_627hf fndecl 0 57279 &disable_so_delay_slave_57279
+disable_so_sock_set_timeout_fndecl_57281 sock_set_timeout fndecl 0-3 57281 NULL
+disable_so_phys_addr_fndecl_57284 phys_addr fndecl 0 57284 NULL
+disable_so_i_uid_minix2_inode_57288 i_uid minix2_inode 0 57288 NULL
+disable_so_hash_netnet4_expire_fndecl_57295 hash_netnet4_expire fndecl 4 57295 NULL
+disable_so_mtrr_file_add_fndecl_57296 mtrr_file_add fndecl 1-2 57296 NULL
+disable_so_rd_addr_gfs2_rgrpd_57301 rd_addr gfs2_rgrpd 0 57301 NULL
+disable_so_elf_map_fndecl_57308 elf_map fndecl 0-2-4-5 57308 NULL
+disable_so_frame_len_stv0900_signal_info_57310 frame_len stv0900_signal_info 0 57310 NULL nohasharray
+disable_so_crypto_pcbc_encrypt_segment_fndecl_57310 crypto_pcbc_encrypt_segment fndecl 0 57310 &disable_so_frame_len_stv0900_signal_info_57310
+disable_so_xs_init_anyaddr_fndecl_57311 xs_init_anyaddr fndecl 1 57311 NULL
+disable_so_ahash_setkey_unaligned_fndecl_57314 ahash_setkey_unaligned fndecl 3 57314 NULL
+disable_so_active_time_lm8333_platform_data_57318 active_time lm8333_platform_data 0 57318 NULL
+disable_so_snd_timer_start_slave_fndecl_57320 snd_timer_start_slave fndecl 0 57320 NULL
+disable_so_dma_addr_pluto_57323 dma_addr pluto 0 57323 NULL nohasharray
+disable_so_bitmap_print_to_pagebuf_fndecl_57323 bitmap_print_to_pagebuf fndecl 4 57323 &disable_so_dma_addr_pluto_57323
+disable_so_sgl_pg0_addr_hi_sgl_page_pairs_57333 sgl_pg0_addr_hi sgl_page_pairs 0 57333 NULL
+disable_so_scd_base_addr_iwl_trans_pcie_57336 scd_base_addr iwl_trans_pcie 0 57336 NULL
+disable_so_vfio_msi_set_vector_signal_fndecl_57339 vfio_msi_set_vector_signal fndecl 0-2 57339 NULL
+disable_so_sfq_hash_fndecl_57343 sfq_hash fndecl 0 57343 NULL
+disable_so_security_task_getscheduler_fndecl_57345 security_task_getscheduler fndecl 0 57345 NULL
+disable_so_xfrm_idx_hash_transfer_fndecl_57346 xfrm_idx_hash_transfer fndecl 3 57346 NULL
+disable_so_hblank_hi_lvds_dvo_timing_57349 hblank_hi lvds_dvo_timing 0 57349 NULL
+disable_so_try_cancel_split_timeout_fndecl_57358 try_cancel_split_timeout fndecl 0 57358 NULL
+disable_so_node_read_cpumask_fndecl_57363 node_read_cpumask fndecl 0 57363 NULL
+disable_so_module_addr_max_rw_vardecl_module_c_57377 module_addr_max_rw vardecl_module.c 0 57377 NULL
+disable_so_timecounter_read_delta_fndecl_57378 timecounter_read_delta fndecl 0 57378 NULL
+disable_so_addr_hi_ahci_sg_57386 addr_hi ahci_sg 0 57386 NULL
+disable_so_rpi_paddr_lo_lpfc_mbx_post_hdr_tmpl_57387 rpi_paddr_lo lpfc_mbx_post_hdr_tmpl 0 57387 NULL
+disable_so_read_signal_strength_dvb_frontend_ops_57393 read_signal_strength dvb_frontend_ops 0 57393 NULL nohasharray
+disable_so_aes_init_fndecl_57393 aes_init fndecl 0 57393 &disable_so_read_signal_strength_dvb_frontend_ops_57393
+disable_so_iscsi_stat_instance_show_attr_disc_time_fndecl_57397 iscsi_stat_instance_show_attr_disc_time fndecl 0 57397 NULL nohasharray
+disable_so_inblock_signal_struct_57397 inblock signal_struct 0 57397 &disable_so_iscsi_stat_instance_show_attr_disc_time_fndecl_57397
+disable_so_ks0108_address_fndecl_57399 ks0108_address fndecl 1 57399 NULL
+disable_so_set_mtrr_fndecl_57402 set_mtrr fndecl 2-3 57402 NULL
+disable_so___hw_addr_del_entry_fndecl_57405 __hw_addr_del_entry fndecl 0 57405 NULL
+disable_so_adis16136_write_frequency_fndecl_57414 adis16136_write_frequency fndecl 0-4 57414 NULL
+disable_so_addr_hi_eth_rx_cqe_next_page_57432 addr_hi eth_rx_cqe_next_page 0 57432 NULL
+disable_so_vp_iowrite64_twopart_fndecl_57440 vp_iowrite64_twopart fndecl 1 57440 NULL
+disable_so_demod_i2c_addr_tda10071_config_57445 demod_i2c_addr tda10071_config 0 57445 NULL
+disable_so___mcheck_cpu_mce_banks_init_fndecl_57446 __mcheck_cpu_mce_banks_init fndecl 0 57446 NULL
+disable_so_reference_freq_amdgpu_pll_57451 reference_freq amdgpu_pll 0 57451 NULL
+disable_so_default_dispclk_radeon_clock_57469 default_dispclk radeon_clock 0 57469 NULL
+disable_so_dma_pool_free_fndecl_57472 dma_pool_free fndecl 3 57472 NULL
+disable_so_ds1307_get_time_fndecl_57477 ds1307_get_time fndecl 0 57477 NULL
+disable_so_addr_ch_mem_range_57497 addr ch_mem_range 0 57497 NULL
+disable_so_ip_hash_netiface4_elem_57501 ip hash_netiface4_elem 0 57501 NULL
+disable_so_dt_cpufreq_platdrv_init_fndecl_57502 dt_cpufreq_platdrv_init fndecl 0 57502 NULL
+disable_so_fuse_flush_times_fndecl_57514 fuse_flush_times fndecl 0 57514 NULL
+disable_so_nl_pid_sockaddr_nl_57515 nl_pid sockaddr_nl 0 57515 NULL
+disable_so_plane_vaddr_fndecl_57531 plane_vaddr fndecl 5 57531 NULL
+disable_so_addr_nv_adma_prd_57534 addr nv_adma_prd 0 57534 NULL
+disable_so_task_tgid_vnr_fndecl_57539 task_tgid_vnr fndecl 0 57539 NULL
+disable_so_get_register_interruptible_fndecl_57541 get_register_interruptible fndecl 0 57541 NULL
+disable_so_spi_rcvhdr_tailaddr_ipath_base_info_57542 spi_rcvhdr_tailaddr ipath_base_info 0 57542 NULL
+disable_so_ath9k_hw_clear_queue_interrupts_fndecl_57543 ath9k_hw_clear_queue_interrupts fndecl 2 57543 NULL
+disable_so_cl_recover_timer_dlm_cluster_57553 cl_recover_timer dlm_cluster 0 57553 NULL nohasharray
+disable_so_boot_addr_pmu_nvbios_pmuR_57553 boot_addr_pmu nvbios_pmuR 0 57553 &disable_so_cl_recover_timer_dlm_cluster_57553 nohasharray
+disable_so___mod_timer_fndecl_57553 __mod_timer fndecl 2 57553 &disable_so_boot_addr_pmu_nvbios_pmuR_57553
+disable_so_hpfb_freq_cs42l56_platform_data_57565 hpfb_freq cs42l56_platform_data 0 57565 NULL nohasharray
+disable_so_i915_max_freq_set_fndecl_57565 i915_max_freq_set fndecl 2-0 57565 &disable_so_hpfb_freq_cs42l56_platform_data_57565
+disable_so_frequency_v4l2_frequency_57580 frequency v4l2_frequency 0 57580 NULL
+disable_so_time_mce_57593 time mce 0 57593 NULL
+disable_so_addr_abituguru3_data_57605 addr abituguru3_data 0 57605 NULL
+disable_so_bitmap_onto_fndecl_57611 bitmap_onto fndecl 4 57611 NULL
+disable_so_rx4581_get_datetime_fndecl_57612 rx4581_get_datetime fndecl 0 57612 NULL
+disable_so_rem_addr_nes_cm_info_57615 rem_addr nes_cm_info 0 57615 NULL
+disable_so_lease_time_nfs_fsinfo_57627 lease_time nfs_fsinfo 0 57627 NULL
+disable_so_hash_tbl_pbl_addr_hi_fcoe_kwqe_init2_57631 hash_tbl_pbl_addr_hi fcoe_kwqe_init2 0 57631 NULL
+disable_so_pci_addr_blogic_probeinfo_57646 pci_addr blogic_probeinfo 0 57646 NULL
+disable_so_intel_gpio_runtime_idle_fndecl_57650 intel_gpio_runtime_idle fndecl 0 57650 NULL
+disable_so_clock_div_par_info_57652 clock_div par_info 0 57652 NULL
+disable_so_overflowuid_vardecl_57653 overflowuid vardecl 0 57653 NULL
+disable_so_start_time_request_57657 start_time request 0 57657 NULL nohasharray
+disable_so_wil_freq_seq_open_fndecl_57657 wil_freq_seq_open fndecl 0 57657 &disable_so_start_time_request_57657 nohasharray
+disable_so_ocfs2_find_next_zero_bit_unaligned_fndecl_57657 ocfs2_find_next_zero_bit_unaligned fndecl 0-2 57657 &disable_so_wil_freq_seq_open_fndecl_57657
+disable_so_addr_hi_dma_address_57659 addr_hi dma_address 0 57659 NULL
+disable_so_wm2200_runtime_resume_fndecl_57661 wm2200_runtime_resume fndecl 0 57661 NULL nohasharray
+disable_so_w_idx_addr_brcmf_pcie_ringbuf_57661 w_idx_addr brcmf_pcie_ringbuf 0 57661 &disable_so_wm2200_runtime_resume_fndecl_57661
+disable_so_timeout_us_vardecl_tlb_uv_c_57666 timeout_us vardecl_tlb_uv.c 0 57666 NULL
+disable_so_fence_wait_timeout_fndecl_57667 fence_wait_timeout fndecl 0-3 57667 NULL nohasharray
+disable_so_signal_cfg80211_bss_57667 signal cfg80211_bss 0 57667 &disable_so_fence_wait_timeout_fndecl_57667
+disable_so_admin_timeout_vardecl_nvme_core_c_57668 admin_timeout vardecl_nvme-core.c 0 57668 NULL
+disable_so_next_gid_index_mlx4_mgm_57670 next_gid_index mlx4_mgm 0 57670 NULL
+disable_so_sdn_objnamel_sockaddr_dn_57674 sdn_objnamel sockaddr_dn 0 57674 NULL
+disable_so_diolan_set_clock_synch_timeout_fndecl_57678 diolan_set_clock_synch_timeout fndecl 0 57678 NULL
+disable_so_pioaddr_rhine_private_57682 pioaddr rhine_private 0 57682 NULL nohasharray
+disable_so_or51132_read_signal_strength_fndecl_57682 or51132_read_signal_strength fndecl 0 57682 &disable_so_pioaddr_rhine_private_57682
+disable_so_np_oaktrail_hdmi_clock_57683 np oaktrail_hdmi_clock 0 57683 NULL
+disable_so_laddr_check_rds_transport_57695 laddr_check rds_transport 1 57695 NULL
+disable_so_pause_time_ixgbe_fc_info_57702 pause_time ixgbe_fc_info 0 57702 NULL
+disable_so_img_spfi_runtime_resume_fndecl_57703 img_spfi_runtime_resume fndecl 0 57703 NULL
+disable_so_y_runtime_sc_57719 y runtime_sc 0 57719 NULL nohasharray
+disable_so_tscdeadline_kvm_timer_57719 tscdeadline kvm_timer 0 57719 &disable_so_y_runtime_sc_57719
+disable_so_dmaaddr_avmcard_dmabuf_57720 dmaaddr avmcard_dmabuf 0 57720 NULL nohasharray
+disable_so_cg_spll_func_cntl_4_ni_clock_registers_57720 cg_spll_func_cntl_4 ni_clock_registers 0 57720 &disable_so_dmaaddr_avmcard_dmabuf_57720
+disable_so_xgene_rtc_read_time_fndecl_57728 xgene_rtc_read_time fndecl 0 57728 NULL
+disable_so_dma_addr_vnic_wq_buf_57732 dma_addr vnic_wq_buf 0 57732 NULL
+disable_so_E_md4hash_fndecl_57735 E_md4hash fndecl 0 57735 NULL
+disable_so_azx_timecounter_init_fndecl_57762 azx_timecounter_init fndecl 3 57762 NULL
+disable_so_pcibios_save_fw_addr_fndecl_57765 pcibios_save_fw_addr fndecl 3 57765 NULL nohasharray
+disable_so_hash_setkey_fndecl_57765 hash_setkey fndecl 0-3 57765 &disable_so_pcibios_save_fw_addr_fndecl_57765
+disable_so_dlm_master_hash_fndecl_57794 dlm_master_hash fndecl 2 57794 NULL
+disable_so_bitmap_or_fndecl_57806 bitmap_or fndecl 4 57806 NULL
+disable_so_iso_stream_schedule_fndecl_57815 iso_stream_schedule fndecl 0 57815 NULL nohasharray
+disable_so_crypto_register_rng_fndecl_57815 crypto_register_rng fndecl 0 57815 &disable_so_iso_stream_schedule_fndecl_57815
+disable_so_authenc_verify_ahash_done_fndecl_57820 authenc_verify_ahash_done fndecl 2 57820 NULL
+disable_so___timespec_to_jiffies_fndecl_57822 __timespec_to_jiffies fndecl 0-2-1 57822 NULL
+disable_so_sys_addr_to_csrow_fndecl_57824 sys_addr_to_csrow fndecl 0-2 57824 NULL
+disable_so_req_q_phy_addr_ql3_adapter_57830 req_q_phy_addr ql3_adapter 0 57830 NULL
+disable_so_htod_mb_data_addr_brcmf_pcie_shared_info_57843 htod_mb_data_addr brcmf_pcie_shared_info 0 57843 NULL
+disable_so_xfs_btree_rec_offset_fndecl_57864 xfs_btree_rec_offset fndecl 0-2 57864 NULL
+disable_so_write_phy_reg_fndecl_57868 write_phy_reg fndecl 3-2 57868 NULL
+disable_so_bg_block_bitmap_lo_ext4_group_desc_57870 bg_block_bitmap_lo ext4_group_desc 0 57870 NULL
+disable_so_s_wtime_ext4_super_block_57871 s_wtime ext4_super_block 0 57871 NULL
+disable_so_bridge_hello_time_net_bridge_57884 bridge_hello_time net_bridge 0 57884 NULL
+disable_so_gpu_addr_radeon_wb_57894 gpu_addr radeon_wb 0 57894 NULL
+disable_so_addr_vxge_hw_mempool_dma_57895 addr vxge_hw_mempool_dma 0 57895 NULL nohasharray
+disable_so_command_setecptiming_fndecl_57895 command_setecptiming fndecl 0 57895 &disable_so_addr_vxge_hw_mempool_dma_57895
+disable_so_kbd_led_timeout_show_fndecl_57896 kbd_led_timeout_show fndecl 0 57896 NULL
+disable_so_ceph_aes_encrypt2_fndecl_57897 ceph_aes_encrypt2 fndecl 2-6-8 57897 NULL
+disable_so_mask_lo_mtrr_var_range_57901 mask_lo mtrr_var_range 0 57901 NULL
+disable_so_family_xfrm_kmaddress_57907 family xfrm_kmaddress 0 57907 NULL
+disable_so_ks0108_delay_vardecl_ks0108_c_57914 ks0108_delay vardecl_ks0108.c 0 57914 NULL
+disable_so_mtime_server_afs_file_status_57920 mtime_server afs_file_status 0 57920 NULL
+disable_so_base_guid_qib_devdata_57924 base_guid qib_devdata 0 57924 NULL
+disable_so_btrfs_delete_delayed_insertion_item_fndecl_57926 btrfs_delete_delayed_insertion_item fndecl 0 57926 NULL
+disable_so_atime_sec_p9_iattr_dotl_57931 atime_sec p9_iattr_dotl 0 57931 NULL
+disable_so_io_bitmap_max_thread_struct_57932 io_bitmap_max thread_struct 0 57932 NULL
+disable_so_cpu_has_cpufreq_fndecl_57939 cpu_has_cpufreq fndecl 1 57939 NULL
+disable_so_discov_interleaved_timeout_hci_dev_57944 discov_interleaved_timeout hci_dev 0 57944 NULL
+disable_so_batadv_orig_hash_del_if_fndecl_57951 batadv_orig_hash_del_if fndecl 2 57951 NULL
+disable_so_vapic_addr_kvm_vapic_addr_57958 vapic_addr kvm_vapic_addr 0 57958 NULL
+disable_so_qce_ahash_update_fndecl_57959 qce_ahash_update fndecl 0 57959 NULL
+disable_so_work_base_addr_snd_ymfpci_57965 work_base_addr snd_ymfpci 0 57965 NULL
+disable_so_enable_cpuidle_governor_57967 enable cpuidle_governor 0 57967 NULL
+disable_so_hash_write_fndecl_57980 hash_write fndecl 0 57980 NULL
+disable_so_addr_cs5535audio_dma_desc_57981 addr cs5535audio_dma_desc 0 57981 NULL nohasharray
+disable_so_wdt_set_timeout_fndecl_57981 wdt_set_timeout fndecl 0 57981 &disable_so_addr_cs5535audio_dma_desc_57981
+disable_so_memaddr_velocity_info_57982 memaddr velocity_info 0 57982 NULL
+disable_so_uuids_open_fndecl_57986 uuids_open fndecl 0 57986 NULL
+disable_so_p6_mt9t112_pll_divider_58006 p6 mt9t112_pll_divider 0 58006 NULL
+disable_so_buffer_addr_lo_iscsi_bd_58012 buffer_addr_lo iscsi_bd 0 58012 NULL
+disable_so_piix_set_timings_fndecl_58017 piix_set_timings fndecl 3 58017 NULL
+disable_so_rqt_hwaddr_t4_rq_58021 rqt_hwaddr t4_rq 0 58021 NULL
+disable_so_fc_gidpn_build_fndecl_58022 fc_gidpn_build fndecl 0-3-5 58022 NULL nohasharray
+disable_so_ia32_misc_enable_msr_kvm_vcpu_arch_58022 ia32_misc_enable_msr kvm_vcpu_arch 0 58022 &disable_so_fc_gidpn_build_fndecl_58022
+disable_so_sdev_runtime_suspend_fndecl_58023 sdev_runtime_suspend fndecl 0 58023 NULL
+disable_so_check_msr_fndecl_58027 check_msr fndecl 2 58027 NULL
+disable_so_init_addr_pmu_nvbios_pmuR_58030 init_addr_pmu nvbios_pmuR 0 58030 NULL
+disable_so_read_addr_qla82xx_md_entry_mux_58034 read_addr qla82xx_md_entry_mux 0 58034 NULL
+disable_so_vclk_post_div_real_pll_ct_58036 vclk_post_div_real pll_ct 0 58036 NULL
+disable_so_mv88e6060_set_addr_fndecl_58039 mv88e6060_set_addr fndecl 0 58039 NULL
+disable_so_skb_tx_hash_fndecl_58044 skb_tx_hash fndecl 0 58044 NULL
+disable_so_kvm_mtrr_valid_fndecl_58049 kvm_mtrr_valid fndecl 3 58049 NULL
+disable_so_enic_dev_del_station_addr_fndecl_58050 enic_dev_del_station_addr fndecl 0 58050 NULL
+disable_so_divisor_flow_filter_58055 divisor flow_filter 0 58055 NULL nohasharray
+disable_so_sg_addr_orc_scb_58055 sg_addr orc_scb 0 58055 &disable_so_divisor_flow_filter_58055
+disable_so_read_addr_qla8xxx_minidump_entry_rdrom_58060 read_addr qla8xxx_minidump_entry_rdrom 0 58060 NULL
+disable_so_op2_value_baddr1_gru_instruction_58062 op2_value_baddr1 gru_instruction 0 58062 NULL
+disable_so_wait_table_hash_nr_entries_zone_58067 wait_table_hash_nr_entries zone 0 58067 NULL
+disable_so_write_delay_adis_data_58068 write_delay adis_data 0 58068 NULL
+disable_so_paging64_walk_addr_nested_fndecl_58079 paging64_walk_addr_nested fndecl 3-4 58079 NULL
+disable_so_pm860x_rtc_set_time_fndecl_58084 pm860x_rtc_set_time fndecl 0 58084 NULL nohasharray
+disable_so_setup_clock_dw_mci_drv_data_58084 setup_clock dw_mci_drv_data 0 58084 &disable_so_pm860x_rtc_set_time_fndecl_58084
+disable_so_regvalue__coeff_div_58086 regvalue _coeff_div 0 58086 NULL
+disable_so_ext_addr_solo_p2m_desc_58103 ext_addr solo_p2m_desc 0 58103 NULL
+disable_so_vclk_radeon_uvd_clock_voltage_dependency_entry_58107 vclk radeon_uvd_clock_voltage_dependency_entry 0 58107 NULL
+disable_so_freq_ath5k_chan_pcal_info_58109 freq ath5k_chan_pcal_info 0 58109 NULL
+disable_so_d_ino_timer_qc_dqblk_58112 d_ino_timer qc_dqblk 0 58112 NULL nohasharray
+disable_so_hpi_sample_clock_get_source_index_fndecl_58112 hpi_sample_clock_get_source_index fndecl 1-0 58112 &disable_so_d_ino_timer_qc_dqblk_58112
+disable_so_src_addr_low_qlcnic_pex_dma_descriptor_58115 src_addr_low qlcnic_pex_dma_descriptor 0 58115 NULL
+disable_so_dvb_buf_tscnt_vardecl_cx88_dvb_c_58119 dvb_buf_tscnt vardecl_cx88-dvb.c 0 58119 NULL
+disable_so_aes_encrypt_packets_read_fndecl_58121 aes_encrypt_packets_read fndecl 0-3 58121 NULL
+disable_so_cq_dma_address_skd_device_58128 cq_dma_address skd_device 0 58128 NULL
+disable_so_mtrr_type_lookup_fixed_fndecl_58157 mtrr_type_lookup_fixed fndecl 1 58157 NULL
+disable_so_start_rmt_timer0_fndecl_58158 start_rmt_timer0 fndecl 2 58158 NULL nohasharray
+disable_so_pneigh_hash_fndecl_58158 pneigh_hash fndecl 2 58158 &disable_so_start_rmt_timer0_fndecl_58158
+disable_so_spi_rcvhdr_tailaddr_qib_base_info_58167 spi_rcvhdr_tailaddr qib_base_info 0 58167 NULL
+disable_so_high_bkey_58171 high bkey 0 58171 NULL
+disable_so_remove_journal_hash_fndecl_58179 remove_journal_hash fndecl 4 58179 NULL
+disable_so_snd_sgbuf_get_addr_fndecl_58188 snd_sgbuf_get_addr fndecl 0-2 58188 NULL
+disable_so_get_cpu_topology_fndecl_58189 get_cpu_topology fndecl 1 58189 NULL
+disable_so_mwl8k_cmd_update_mac_addr_fndecl_58193 mwl8k_cmd_update_mac_addr fndecl 0 58193 NULL
+disable_so_i_mode_inode_58204 i_mode inode 0 58204 NULL
+disable_so_qla4xxx_fw_uptime_show_fndecl_58212 qla4xxx_fw_uptime_show fndecl 0 58212 NULL
+disable_so_ct_xfitimer_irq_rearm_fndecl_58216 ct_xfitimer_irq_rearm fndecl 2 58216 NULL
+disable_so_r820t_set_analog_freq_fndecl_58223 r820t_set_analog_freq fndecl 0 58223 NULL
+disable_so_devlink_sound_timer_operations_58261 devlink sound_timer_operations 0 58261 NULL
+disable_so_lx_dsp_get_clock_frequency_fndecl_58263 lx_dsp_get_clock_frequency fndecl 0 58263 NULL
+disable_so_qdr_dfe_time_qib_chippport_specific_58265 qdr_dfe_time qib_chippport_specific 0 58265 NULL
+disable_so_boottime_set_fndecl_58270 boottime_set fndecl 0 58270 NULL
+disable_so_unhandled_signal_fndecl_58272 unhandled_signal fndecl 2 58272 NULL
+disable_so_nested_vmx_check_msr_switch_fndecl_58274 nested_vmx_check_msr_switch fndecl 2-3 58274 NULL
+disable_so_atomic_counters_read_fndecl_58280 atomic_counters_read fndecl 3-0 58280 NULL
+disable_so_read_delay_adis_data_58281 read_delay adis_data 0 58281 NULL
+disable_so_rsi_sdio_set_cmd52_arg_fndecl_58288 rsi_sdio_set_cmd52_arg fndecl 0-2-3-4-5 58288 NULL
+disable_so_ipv6_dev_get_saddr_fndecl_58290 ipv6_dev_get_saddr fndecl 0 58290 NULL
+disable_so_futex_atomic_cmpxchg_inatomic_fndecl_58294 futex_atomic_cmpxchg_inatomic fndecl 4 58294 NULL
+disable_so_gcm_hash_assoc_remain_done_fndecl_58296 gcm_hash_assoc_remain_done fndecl 2 58296 NULL
+disable_so_regmap_update_bits_async_fndecl_58298 regmap_update_bits_async fndecl 2-4-3-0 58298 NULL
+disable_so_dialwait_timer_isdn_net_local_s_58300 dialwait_timer isdn_net_local_s 0 58300 NULL
+disable_so_addr_mISDNchannel_58316 addr mISDNchannel 0 58316 NULL
+disable_so_incr_error_cpu_itimer_58327 incr_error cpu_itimer 0 58327 NULL
+disable_so_tai_offset_timekeeper_58331 tai_offset timekeeper 0 58331 NULL
+disable_so_mce_rdmsrl_fndecl_58332 mce_rdmsrl fndecl 0 58332 NULL
+disable_so_start_ecm_timer_fndecl_58359 start_ecm_timer fndecl 2 58359 NULL
+disable_so_autoconfig_read_divisor_id_fndecl_58367 autoconfig_read_divisor_id fndecl 0 58367 NULL
+disable_so_x86_get_mtrr_mem_range_fndecl_58379 x86_get_mtrr_mem_range fndecl 3-4-2-0 58379 NULL
+disable_so_mpc_ioapic_addr_fndecl_58384 mpc_ioapic_addr fndecl 0 58384 NULL
+disable_so_addr_type_ipv6_saddr_score_58395 addr_type ipv6_saddr_score 0 58395 NULL
+disable_so_setfreq_i_fndecl_58400 setfreq_i fndecl 2 58400 NULL
+disable_so_tcp_md5_hash_skb_data_fndecl_58401 tcp_md5_hash_skb_data fndecl 3 58401 NULL
+disable_so_aca_cstamp_ifacaddr6_58402 aca_cstamp ifacaddr6 0 58402 NULL
+disable_so_old_cpufreq_freqs_58403 old cpufreq_freqs 0 58403 NULL
+disable_so_jiffies_to_timeval_fndecl_58407 jiffies_to_timeval fndecl 1 58407 NULL
+disable_so_vnic_dev_set_mac_addr_fndecl_58408 vnic_dev_set_mac_addr fndecl 0 58408 NULL
+disable_so_sadb_lifetime_addtime_sadb_lifetime_58416 sadb_lifetime_addtime sadb_lifetime 0 58416 NULL
+disable_so_addr_smsc47m1_data_58419 addr smsc47m1_data 0 58419 NULL
+disable_so_clk_freq_g762_data_58420 clk_freq g762_data 0 58420 NULL
+disable_so_khugepaged_scan_sleep_millisecs_vardecl_huge_memory_c_58427 khugepaged_scan_sleep_millisecs vardecl_huge_memory.c 0 58427 NULL nohasharray
+disable_so_pairwise_cipher_suite_atmel_private_58427 pairwise_cipher_suite atmel_private 0 58427 &disable_so_khugepaged_scan_sleep_millisecs_vardecl_huge_memory_c_58427
+disable_so_max_addr_dmar_domain_58431 max_addr dmar_domain 0 58431 NULL
+disable_so_snd_ice1712_pro_internal_clock_default_info_fndecl_58437 snd_ice1712_pro_internal_clock_default_info fndecl 0 58437 NULL nohasharray
+disable_so_memory_add_physaddr_to_nid_fndecl_58437 memory_add_physaddr_to_nid fndecl 0-1 58437 &disable_so_snd_ice1712_pro_internal_clock_default_info_fndecl_58437
+disable_so_bnx2fc_cmd_timer_set_fndecl_58441 bnx2fc_cmd_timer_set fndecl 2 58441 NULL
+disable_so_do_settimeofday64_fndecl_58445 do_settimeofday64 fndecl 0 58445 NULL
+disable_so_uv_mmtimer_ioctl_fndecl_58452 uv_mmtimer_ioctl fndecl 0 58452 NULL
+disable_so_r61_val_fc2580_freq_regs_58455 r61_val fc2580_freq_regs 0 58455 NULL
+disable_so_epp_read_addr_parport_operations_58468 epp_read_addr parport_operations 0-3 58468 NULL
+disable_so_audio_config_hdmi_pixel_clock_fndecl_58471 audio_config_hdmi_pixel_clock fndecl 0 58471 NULL
+disable_so_bufaddr_epic_tx_desc_58478 bufaddr epic_tx_desc 0 58478 NULL nohasharray
+disable_so_qlcnic_sre_macaddr_change_fndecl_58478 qlcnic_sre_macaddr_change fndecl 0 58478 &disable_so_bufaddr_epic_tx_desc_58478
+disable_so_gtime_task_struct_58480 gtime task_struct 0 58480 NULL nohasharray
+disable_so_dma_addr_vpdma_buf_58480 dma_addr vpdma_buf 0 58480 &disable_so_gtime_task_struct_58480
+disable_so_div_sync_wait_dib7000m_state_58486 div_sync_wait dib7000m_state 0 58486 NULL
+disable_so_long_press_time_val_palmas_pwron_config_58497 long_press_time_val palmas_pwron_config 0 58497 NULL
+disable_so_primary_pci_bus_58515 primary pci_bus 0 58515 NULL
+disable_so_clk_frequency_imx_wm8962_data_58525 clk_frequency imx_wm8962_data 0 58525 NULL
+disable_so_ieee80211_if_fmt_min_discovery_timeout_fndecl_58528 ieee80211_if_fmt_min_discovery_timeout fndecl 0-3 58528 NULL
+disable_so_vidioc_s_frequency_fndecl_58543 vidioc_s_frequency fndecl 0 58543 NULL
+disable_so_bitstream_put_bits_fndecl_58552 bitstream_put_bits fndecl 0-3 58552 NULL
+disable_so_rbp_kvm_regs_58553 rbp kvm_regs 0 58553 NULL
+disable_so_dosr_aic32x4_rate_divs_58555 dosr aic32x4_rate_divs 0 58555 NULL
+disable_so_vscnprintf_fndecl_58558 vscnprintf fndecl 0-2 58558 NULL
+disable_so_static_address_open_fndecl_58572 static_address_open fndecl 0 58572 NULL
+disable_so_sysctl_rose_clear_request_timeout_vardecl_58580 sysctl_rose_clear_request_timeout vardecl 0 58580 NULL
+disable_so_di_uid_dinode_58581 di_uid dinode 0 58581 NULL
+disable_so_crypto_cts_decrypt_fndecl_58584 crypto_cts_decrypt fndecl 0-4 58584 NULL
+disable_so_igu_base_addr_bnx2x_58589 igu_base_addr bnx2x 0 58589 NULL
+disable_so_ifa_address_dn_ifaddr_58593 ifa_address dn_ifaddr 0 58593 NULL
+disable_so_p54_get_band_from_freq_fndecl_58594 p54_get_band_from_freq fndecl 1 58594 NULL
+disable_so_csk_ddp_setup_pgidx_cxgbi_device_58611 csk_ddp_setup_pgidx cxgbi_device 2 58611 NULL
+disable_so_ref_mod_btrfs_delayed_ref_node_58614 ref_mod btrfs_delayed_ref_node 0 58614 NULL
+disable_so_gr_remove_uid_fndecl_58619 gr_remove_uid fndecl 1 58619 NULL
+disable_so_i2c_address_fc0012_config_58626 i2c_address fc0012_config 0 58626 NULL nohasharray
+disable_so_ablkcipher_done_slow_fndecl_58626 ablkcipher_done_slow fndecl 0-2 58626 &disable_so_i2c_address_fc0012_config_58626
+disable_so_address_b43legacy_dmadesc32_58627 address b43legacy_dmadesc32 0 58627 NULL
+disable_so_di_atime_qnx6_inode_entry_58654 di_atime qnx6_inode_entry 0 58654 NULL nohasharray
+disable_so_hactive_lo_lvds_dvo_timing_58654 hactive_lo lvds_dvo_timing 0 58654 &disable_so_di_atime_qnx6_inode_entry_58654
+disable_so_ack_seq_tcp_skb_cb_58657 ack_seq tcp_skb_cb 0 58657 NULL
+disable_so_matroxfb_PLL_mavenclock_fndecl_58658 matroxfb_PLL_mavenclock fndecl 3-4 58658 NULL nohasharray
+disable_so_assert_exp_addr_sdpcm_shared_58658 assert_exp_addr sdpcm_shared 0 58658 &disable_so_matroxfb_PLL_mavenclock_fndecl_58658
+disable_so_pre_div_freq_tbl_58661 pre_div freq_tbl 0 58661 NULL
+disable_so_alsa_timer_init_fndecl_58667 alsa_timer_init fndecl 0 58667 NULL
+disable_so_alloc_cpumask_var_node_fndecl_58668 alloc_cpumask_var_node fndecl 2-3 58668 NULL
+disable_so_genwqe_debugfs_curr_dbg_uid2_open_fndecl_58673 genwqe_debugfs_curr_dbg_uid2_open fndecl 0 58673 NULL
+disable_so_pixclock_fb_videomode_58678 pixclock fb_videomode 0 58678 NULL
+disable_so_h_addr_reg_musb_qh_58681 h_addr_reg musb_qh 0 58681 NULL
+disable_so_timeout_cyclades_port_58683 timeout cyclades_port 0 58683 NULL
+disable_so_cxio_init_resource_fifo_random_fndecl_58684 cxio_init_resource_fifo_random fndecl 3 58684 NULL
+disable_so_dib8000_get_timeout_fndecl_58702 dib8000_get_timeout fndecl 2-0 58702 NULL nohasharray
+disable_so_xfs_btree_get_buf_block_fndecl_58702 xfs_btree_get_buf_block fndecl 0 58702 &disable_so_dib8000_get_timeout_fndecl_58702
+disable_so_apds9300_write_interrupt_config_fndecl_58703 apds9300_write_interrupt_config fndecl 0 58703 NULL
+disable_so_ath9k_hw_computetxtime_fndecl_58711 ath9k_hw_computetxtime fndecl 0-3-4-5 58711 NULL
+disable_so_bus_address_drm_buf_58716 bus_address drm_buf 0 58716 NULL
+disable_so_nr_irqs_vardecl_58723 nr_irqs vardecl 0 58723 NULL nohasharray
+disable_so_hashbin_find_next_fndecl_58723 hashbin_find_next fndecl 2 58723 &disable_so_nr_irqs_vardecl_58723
+disable_so_snd_usb_find_clock_selector_fndecl_58728 snd_usb_find_clock_selector fndecl 2 58728 NULL
+disable_so_radio_freq_bttv_58729 radio_freq bttv 0 58729 NULL
+disable_so_xc_set_signal_source_fndecl_58733 xc_set_signal_source fndecl 0 58733 NULL
+disable_so_doorbell_write_vardecl_pcc_cpufreq_c_58745 doorbell_write vardecl_pcc-cpufreq.c 0 58745 NULL
+disable_so_cpu_clock_counter_kfd_ioctl_get_clock_counters_args_58758 cpu_clock_counter kfd_ioctl_get_clock_counters_args 0 58758 NULL
+disable_so_btrfs_set_dev_replace_time_started_fndecl_58761 btrfs_set_dev_replace_time_started fndecl 3 58761 NULL
+disable_so_i_hash_mask_vardecl_inode_c_58762 i_hash_mask vardecl_inode.c 0 58762 NULL
+disable_so_gr_set_address_fndecl_58765 gr_set_address fndecl 2 58765 NULL
+disable_so_perfect_tx_time_minstrel_rate_58766 perfect_tx_time minstrel_rate 0 58766 NULL
+disable_so_min_ref_div_radeon_pll_58768 min_ref_div radeon_pll 0 58768 NULL
+disable_so_demod_address_ec100_config_58771 demod_address ec100_config 0 58771 NULL
+disable_so_phys_addr_vm_struct_58777 phys_addr vm_struct 0 58777 NULL
+disable_so_addr_ramfuc_reg_58780 addr ramfuc_reg 0 58780 NULL nohasharray
+disable_so_start_addr_p54_tx_info_58780 start_addr p54_tx_info 0 58780 &disable_so_addr_ramfuc_reg_58780
+disable_so_interrupt_mask_oxygen_58792 interrupt_mask oxygen 0 58792 NULL
+disable_so_time_to_tm_fndecl_58793 time_to_tm fndecl 2-1 58793 NULL
+disable_so_irq_pci_dev_58794 irq pci_dev 0 58794 NULL
+disable_so_reg_write_fndecl_58795 reg_write fndecl 0-2-3-4 58795 NULL
+disable_so_eof_uid_xfs_fs_eofblocks_58796 eof_uid xfs_fs_eofblocks 0 58796 NULL
+disable_so_s_dv_timings_v4l2_subdev_video_ops_58798 s_dv_timings v4l2_subdev_video_ops 0 58798 NULL
+disable_so_iscsit_do_crypto_hash_buf_fndecl_58805 iscsit_do_crypto_hash_buf fndecl 3-4 58805 NULL
+disable_so_ablkcipher_next_slow_fndecl_58809 ablkcipher_next_slow fndecl 3-4 58809 NULL
+disable_so_set_process_cpu_timer_fndecl_58820 set_process_cpu_timer fndecl 2 58820 NULL
+disable_so_btbcm_check_bdaddr_fndecl_58825 btbcm_check_bdaddr fndecl 0 58825 NULL
+disable_so_seek_timeout_vardecl_radio_si470x_common_c_58832 seek_timeout vardecl_radio-si470x-common.c 0 58832 NULL
+disable_so_rhashtable_rehash_attach_fndecl_58833 rhashtable_rehash_attach fndecl 0 58833 NULL
+disable_so_read_posix_clock_operations_58837 read posix_clock_operations 2 58837 NULL
+disable_so_atomic_open_inode_operations_58838 atomic_open inode_operations 4-5 58838 NULL nohasharray
+disable_so_vnic_dev_get_intr_coal_timer_max_fndecl_58838 vnic_dev_get_intr_coal_timer_max fndecl 0 58838 &disable_so_atomic_open_inode_operations_58838
+disable_so_timeout_cmd_bidir_58846 timeout cmd_bidir 0 58846 NULL
+disable_so_bank_mce_58847 bank mce 0 58847 NULL
+disable_so_hw_ptr_wrap_snd_pcm_runtime_58849 hw_ptr_wrap snd_pcm_runtime 0 58849 NULL
+disable_so_batadv_iv_ogm_fwd_send_time_fndecl_58851 batadv_iv_ogm_fwd_send_time fndecl 0 58851 NULL
+disable_so_lrg_buf_q_alloc_phy_addr_ql3_adapter_58856 lrg_buf_q_alloc_phy_addr ql3_adapter 0 58856 NULL
+disable_so_avc_get_hash_stats_fndecl_58860 avc_get_hash_stats fndecl 0 58860 NULL
+disable_so_do_utimes_fndecl_58870 do_utimes fndecl 0-1 58870 NULL
+disable_so_get_max_timeout_count_sdhci_ops_58875 get_max_timeout_count sdhci_ops 0 58875 NULL
+disable_so_sys_setuid16_fndecl_58881 sys_setuid16 fndecl 0-1 58881 NULL
+disable_so_pq_gpu_addr_kernel_queue_58891 pq_gpu_addr kernel_queue 0 58891 NULL
+disable_so_suspend_time_ipw_priv_58911 suspend_time ipw_priv 0 58911 NULL
+disable_so_Ti3026_calcclock_fndecl_58917 Ti3026_calcclock fndecl 2-3-0 58917 NULL
+disable_so_virtual_reg_addr_wl1251_58918 virtual_reg_addr wl1251 0 58918 NULL
+disable_so_timeout_read_fndecl_58936 timeout_read fndecl 3 58936 NULL
+disable_so_bank_base_playback_addr_snd_ymfpci_58940 bank_base_playback_addr snd_ymfpci 0 58940 NULL
+disable_so_sunkbd_interrupt_fndecl_58943 sunkbd_interrupt fndecl 2 58943 NULL
+disable_so_cpufreq_add_policy_cpu_fndecl_58948 cpufreq_add_policy_cpu fndecl 0-2 58948 NULL
+disable_so_vfreq___fb_timings_58967 vfreq __fb_timings 0 58967 NULL
+disable_so___fdget_fndecl_58975 __fdget fndecl 1 58975 NULL
+disable_so_log_addr_vhost_virtqueue_58983 log_addr vhost_virtqueue 0 58983 NULL
+disable_so_start_addr_bnx2_mips_fw_file_entry_58985 start_addr bnx2_mips_fw_file_entry 0 58985 NULL
+disable_so_wt_timeout_st21nfca_se_info_58988 wt_timeout st21nfca_se_info 0 58988 NULL
+disable_so_sg_physaddr_sg_map_node_59010 sg_physaddr sg_map_node 0 59010 NULL
+disable_so_hsync_pulse_width_hi_oaktrail_timing_info_59019 hsync_pulse_width_hi oaktrail_timing_info 0 59019 NULL
+disable_so_cx88_set_freq_fndecl_59030 cx88_set_freq fndecl 0 59030 NULL
+disable_so_daddr_ircomm_info_59034 daddr ircomm_info 0 59034 NULL
+disable_so_iscsit_ta_netif_timeout_fndecl_59038 iscsit_ta_netif_timeout fndecl 0 59038 NULL
+disable_so_frequency_stv090x_state_59044 frequency stv090x_state 0 59044 NULL
+disable_so_slave_address_cp2112_write_req_report_59049 slave_address cp2112_write_req_report 0 59049 NULL
+disable_so_ipath_hol_timeout_ms_vardecl_ipath_driver_c_59051 ipath_hol_timeout_ms vardecl_ipath_driver.c 0 59051 NULL
+disable_so_acpi_throttling_wrmsr_fndecl_59058 acpi_throttling_wrmsr fndecl 1 59058 NULL
+disable_so_acpi_cpufreq_init_fndecl_59061 acpi_cpufreq_init fndecl 0 59061 NULL
+disable_so_evtbd_addr_hi_host_cmd_ds_pcie_details_59067 evtbd_addr_hi host_cmd_ds_pcie_details 0 59067 NULL
+disable_so_addr_lo_dma_desc_59074 addr_lo dma_desc 0 59074 NULL
+disable_so_xen_mce_chrdev_read_fndecl_59076 xen_mce_chrdev_read fndecl 0 59076 NULL
+disable_so_addr_max8998_reg_dump_59086 addr max8998_reg_dump 0 59086 NULL
+disable_so_card_snd_timer_id_59096 card snd_timer_id 0 59096 NULL
+disable_so_addr_qib_sdma_txreq_59099 addr qib_sdma_txreq 0 59099 NULL
+disable_so_rx_coalescing_timeo_bnad_59109 rx_coalescing_timeo bnad 0 59109 NULL
+disable_so_dm_btree_del_fndecl_59119 dm_btree_del fndecl 0-2 59119 NULL
+disable_so_topology_change_timer_show_fndecl_59122 topology_change_timer_show fndecl 0 59122 NULL
+disable_so_ip_vs_addr_copy_fndecl_59129 ip_vs_addr_copy fndecl 1 59129 NULL
+disable_so_i2c_address_cxd2820r_config_59130 i2c_address cxd2820r_config 0 59130 NULL
+disable_so_panel_ref_divider_radeon_encoder_lvds_59134 panel_ref_divider radeon_encoder_lvds 0 59134 NULL nohasharray
+disable_so_clock_lvds_dvo_timing_59134 clock lvds_dvo_timing 0 59134 &disable_so_panel_ref_divider_radeon_encoder_lvds_59134
+disable_so_skcipher_setkey_fndecl_59135 skcipher_setkey fndecl 0-3 59135 NULL
+disable_so_pcxhr_clock_type_info_fndecl_59137 pcxhr_clock_type_info fndecl 0 59137 NULL
+disable_so_ccp_sha_setkey_fndecl_59138 ccp_sha_setkey fndecl 3 59138 NULL
+disable_so_xfs_btree_shift_recs_fndecl_59139 xfs_btree_shift_recs fndecl 4 59139 NULL
+disable_so_irq_set_chip_fndecl_59141 irq_set_chip fndecl 1 59141 NULL
+disable_so_prech_timeout_midi_parms_59145 prech_timeout midi_parms 0 59145 NULL
+disable_so_ecryptfs_message_wait_timeout_vardecl_59150 ecryptfs_message_wait_timeout vardecl 0 59150 NULL
+disable_so_max_time_dib3000mc_config_59165 max_time dib3000mc_config 0 59165 NULL
+disable_so_freq_snd_tea575x_59172 freq snd_tea575x 0 59172 NULL nohasharray
+disable_so_hactive_hblank_hi_detailed_pixel_timing_59172 hactive_hblank_hi detailed_pixel_timing 0 59172 &disable_so_freq_snd_tea575x_59172
+disable_so_last_port_bitmap_port_59176 last_port bitmap_port 0 59176 NULL
+disable_so_svm_cid_sockaddr_vm_59186 svm_cid sockaddr_vm 0 59186 NULL
+disable_so_divisor_tc_u_hnode_59196 divisor tc_u_hnode 0 59196 NULL
+disable_so_address_r8a66597_pipe_info_59198 address r8a66597_pipe_info 0 59198 NULL
+disable_so_val_addr_core0_nphy_rf_control_override_rev7_59213 val_addr_core0 nphy_rf_control_override_rev7 0 59213 NULL
+disable_so_hv_signal_event_fndecl_59215 hv_signal_event fndecl 0 59215 NULL
+disable_so_rv740_get_decoded_reference_divider_fndecl_59216 rv740_get_decoded_reference_divider fndecl 0-1 59216 NULL
+disable_so_ecb_aes_decrypt_fndecl_59224 ecb_aes_decrypt fndecl 0-4 59224 NULL
+disable_so_b44_interrupt_fndecl_59225 b44_interrupt fndecl 1 59225 NULL
+disable_so_cpufreq_sysfs_create_file_fndecl_59228 cpufreq_sysfs_create_file fndecl 0 59228 NULL
+disable_so_err_msr_regs_info_59233 err msr_regs_info 0 59233 NULL
+disable_so_hci_dev_sockaddr_hci_59237 hci_dev sockaddr_hci 0 59237 NULL
+disable_so_paddr_scq_info_59242 paddr scq_info 0 59242 NULL
+disable_so_saddr_dat_cx231xx_i2c_xfer_data_59247 saddr_dat cx231xx_i2c_xfer_data 0 59247 NULL
+disable_so_hash_cnt_ccp_aes_cmac_req_ctx_59249 hash_cnt ccp_aes_cmac_req_ctx 0 59249 NULL
+disable_so_read_addr___cache_59255 read_addr __cache 0 59255 NULL
+disable_so_freq_wmi_p2p_probe_response_cmd_59256 freq wmi_p2p_probe_response_cmd 0 59256 NULL
+disable_so_ack_seq_tcphdr_59257 ack_seq tcphdr 0 59257 NULL
+disable_so_i_uid_ext4_inode_59259 i_uid ext4_inode 0 59259 NULL
+disable_so_prandom_seed_fndecl_59265 prandom_seed fndecl 1 59265 NULL nohasharray
+disable_so_table1_addr_ipw_priv_59265 table1_addr ipw_priv 0 59265 &disable_so_prandom_seed_fndecl_59265
+disable_so_set_mtrr_ops_59267 set mtrr_ops 2-3 59267 NULL
+disable_so_signal_adm8211_tx_hdr_59276 signal adm8211_tx_hdr 0 59276 NULL
+disable_so_n_pll_div_59277 n pll_div 0 59277 NULL
+disable_so_burst_time_pie_vars_59278 burst_time pie_vars 0 59278 NULL
+disable_so_atp867x_get_active_clocks_shifted_fndecl_59292 atp867x_get_active_clocks_shifted fndecl 0-2 59292 NULL
+disable_so_hello_timer_show_fndecl_59304 hello_timer_show fndecl 0 59304 NULL
+disable_so_pc_timeout_ubifs_debug_info_59317 pc_timeout ubifs_debug_info 0 59317 NULL
+disable_so_reg_se_cache_ti_tscadc_dev_59318 reg_se_cache ti_tscadc_dev 0 59318 NULL
+disable_so_hv_init_clockevent_device_fndecl_59324 hv_init_clockevent_device fndecl 2 59324 NULL nohasharray
+disable_so_error_async_delayed_refs_59324 error async_delayed_refs 0 59324 &disable_so_hv_init_clockevent_device_fndecl_59324
+disable_so_query_dv_timings_v4l2_subdev_video_ops_59327 query_dv_timings v4l2_subdev_video_ops 0 59327 NULL
+disable_so_pwr_vec_read_time_b43_txpower_lo_control_59329 pwr_vec_read_time b43_txpower_lo_control 0 59329 NULL
+disable_so_proc_do_uuid_fndecl_59345 proc_do_uuid fndecl 0 59345 NULL
+disable_so_nilfs_segctor_last_seg_write_time_show_fndecl_59356 nilfs_segctor_last_seg_write_time_show fndecl 0 59356 NULL nohasharray
+disable_so_hpi_tuner_get_hd_radio_signal_quality_fndecl_59356 hpi_tuner_get_hd_radio_signal_quality fndecl 0-1 59356 &disable_so_nilfs_segctor_last_seg_write_time_show_fndecl_59356
+disable_so_usb_start_wait_urb_fndecl_59365 usb_start_wait_urb fndecl 0 59365 NULL
+disable_so_cpuid_xenpf_cpu_ol_59386 cpuid xenpf_cpu_ol 0 59386 NULL
+disable_so_mem_addr_ips_ha_59397 mem_addr ips_ha 0 59397 NULL
+disable_so_ip6addrlbl_fill_fndecl_59401 ip6addrlbl_fill fndecl 0-4-6 59401 NULL
+disable_so_cq_addr_lo_fcoe_kwqe_conn_offload2_59405 cq_addr_lo fcoe_kwqe_conn_offload2 0 59405 NULL
+disable_so_l_pll_freq_tbl_59406 l pll_freq_tbl 0 59406 NULL
+disable_so_sgid_idx_ocrdma_qp_59415 sgid_idx ocrdma_qp 0 59415 NULL
+disable_so_i2c_bit_add_numbered_bus_fndecl_59416 i2c_bit_add_numbered_bus fndecl 0 59416 NULL
+disable_so_trb_addr_lo_mv_u3d_ep_context_59424 trb_addr_lo mv_u3d_ep_context 0 59424 NULL
+disable_so_shash_compat_init_fndecl_59445 shash_compat_init fndecl 0 59445 NULL
+disable_so_currentfreq_cx24123_state_59448 currentfreq cx24123_state 0 59448 NULL
+disable_so_neigh_proc_dointvec_userhz_jiffies_fndecl_59453 neigh_proc_dointvec_userhz_jiffies fndecl 0 59453 NULL
+disable_so_panel_fb_divider_radeon_encoder_lvds_59458 panel_fb_divider radeon_encoder_lvds 0 59458 NULL nohasharray
+disable_so_sec_pvclock_wall_clock_59458 sec pvclock_wall_clock 0 59458 &disable_so_panel_fb_divider_radeon_encoder_lvds_59458
+disable_so_wl18xx_acx_host_if_cfg_bitmap_fndecl_59465 wl18xx_acx_host_if_cfg_bitmap fndecl 0 59465 NULL
+disable_so_addr_erase_info_59472 addr erase_info 0 59472 NULL nohasharray
+disable_so_ath9k_hw_addrxbuf_edma_fndecl_59472 ath9k_hw_addrxbuf_edma fndecl 2 59472 &disable_so_addr_erase_info_59472
+disable_so_hour_timestamp_59476 hour timestamp 0 59476 NULL
+disable_so_check_cpu_itimer_fndecl_59478 check_cpu_itimer fndecl 5-4 59478 NULL
+disable_so_flush_time_cache_detail_59492 flush_time cache_detail 0 59492 NULL
+disable_so_error0_timeout_si_sm_data_59495 error0_timeout si_sm_data 0 59495 NULL
+disable_so_sampling_freq_mixart_stream_param_desc_59502 sampling_freq mixart_stream_param_desc 0 59502 NULL
+disable_so_enc_addr_low_sata_start_req_59503 enc_addr_low sata_start_req 0 59503 NULL
+disable_so_hash_unix_address_59504 hash unix_address 0 59504 NULL nohasharray
+disable_so_ufs_get_inode_uid_fndecl_59504 ufs_get_inode_uid fndecl 0 59504 &disable_so_hash_unix_address_59504
+disable_so_demod_address_tda1002x_config_59516 demod_address tda1002x_config 0 59516 NULL
+disable_so_getaddr_dumpit_fndecl_59518 getaddr_dumpit fndecl 0 59518 NULL
+disable_so_tg3_interrupt_fndecl_59519 tg3_interrupt fndecl 1 59519 NULL
+disable_so_utime_task_struct_59526 utime task_struct 0 59526 NULL
+disable_so_decrypt_ablkcipher_tfm_59537 decrypt ablkcipher_tfm 0 59537 NULL
+disable_so_dma_addr_bnad_rx_vector_59551 dma_addr bnad_rx_vector 0 59551 NULL
+disable_so_vram_addr_viafb_par_59552 vram_addr viafb_par 0 59552 NULL
+disable_so_s00_img_ir_timing_regvals_59579 s00 img_ir_timing_regvals 0 59579 NULL
+disable_so_pci_swizzle_interrupt_pin_fndecl_59580 pci_swizzle_interrupt_pin fndecl 0-2 59580 NULL
+disable_so_iscsi_nacl_attrib_store_random_datain_seq_offsets_fndecl_59581 iscsi_nacl_attrib_store_random_datain_seq_offsets fndecl 0-3 59581 NULL
+disable_so_time_next_delayed_flow_fq_sched_data_59598 time_next_delayed_flow fq_sched_data 0 59598 NULL
+disable_so_signal_ttm_lock_59613 signal ttm_lock 0 59613 NULL
+disable_so_trap_timeout_qib_ibport_59624 trap_timeout qib_ibport 0 59624 NULL
+disable_so_hash_sendpage_fndecl_59633 hash_sendpage fndecl 0-3-4 59633 NULL
+disable_so_address_i2c_algo_dp_aux_data_59643 address i2c_algo_dp_aux_data 0 59643 NULL
+disable_so_baddr_pmcraid_hostrcb_59651 baddr pmcraid_hostrcb 0 59651 NULL
+disable_so_jiffies_drm_i915_error_request_59653 jiffies drm_i915_error_request 0 59653 NULL
+disable_so_niu_enable_interrupts_fndecl_59655 niu_enable_interrupts fndecl 0 59655 NULL nohasharray
+disable_so_addr_nvkm_gpuobj_59655 addr nvkm_gpuobj 0 59655 &disable_so_niu_enable_interrupts_fndecl_59655
+disable_so_irlap_start_backoff_timer_fndecl_59668 irlap_start_backoff_timer fndecl 2 59668 NULL
+disable_so_cs_chp_time_transaction_chp_stats_s_59671 cs_chp_time transaction_chp_stats_s 0 59671 NULL nohasharray
+disable_so_bufferinfo_array_phy_address_mixart_flowinfo_59671 bufferinfo_array_phy_address mixart_flowinfo 0 59671 &disable_so_cs_chp_time_transaction_chp_stats_s_59671
+disable_so_start_time_bfa_ioim_s_59693 start_time bfa_ioim_s 0 59693 NULL nohasharray
+disable_so_nilfs_btree_assign_p_fndecl_59693 nilfs_btree_assign_p fndecl 0-5 59693 &disable_so_start_time_bfa_ioim_s_59693
+disable_so_pid_pppol2tp_addr_59696 pid pppol2tp_addr 0 59696 NULL
+disable_so_paging32_walk_addr_nested_fndecl_59706 paging32_walk_addr_nested fndecl 3-4 59706 NULL
+disable_so_set_timer_tick_hw_59707 set_timer_tick hw 2 59707 NULL
+disable_so_irq_domain_alloc_irqs_parent_fndecl_59718 irq_domain_alloc_irqs_parent fndecl 2-3-0 59718 NULL
+disable_so_pcf8583_rtc_read_time_fndecl_59722 pcf8583_rtc_read_time fndecl 0 59722 NULL
+disable_so_i_rx_jiffies_rds_incoming_59727 i_rx_jiffies rds_incoming 0 59727 NULL
+disable_so_addr_pt1_buffer_59731 addr pt1_buffer 0 59731 NULL
+disable_so_od_cpufreq_governor_dbs_fndecl_59745 od_cpufreq_governor_dbs fndecl 0 59745 NULL
+disable_so_atmel_set_mac_address_fndecl_59747 atmel_set_mac_address fndecl 0 59747 NULL nohasharray
+disable_so_ioaddr_mxser_port_59747 ioaddr mxser_port 0 59747 &disable_so_atmel_set_mac_address_fndecl_59747
+disable_so_kvm_mtrr_check_gfn_range_consistency_fndecl_59759 kvm_mtrr_check_gfn_range_consistency fndecl 3-2 59759 NULL
+disable_so_mul_n_fndecl_59766 mul_n fndecl 4 59766 NULL
+disable_so_mlx4_bitmap_alloc_fndecl_59767 mlx4_bitmap_alloc fndecl 0 59767 NULL
+disable_so_device_num_atto_csmi_get_pci_bus_addr_59770 device_num atto_csmi_get_pci_bus_addr 0 59770 NULL
+disable_so_ksz_init_timer_fndecl_59771 ksz_init_timer fndecl 2 59771 NULL
+disable_so_signr_usbdevfs_disconnectsignal_59774 signr usbdevfs_disconnectsignal 0 59774 NULL
+disable_so_hash_netiface4_expire_fndecl_59777 hash_netiface4_expire fndecl 4 59777 NULL
+disable_so_timeoutValue_RAID_CONTEXT_59780 timeoutValue RAID_CONTEXT 0 59780 NULL
+disable_so_vsync_pulse_width_hi_oaktrail_timing_info_59785 vsync_pulse_width_hi oaktrail_timing_info 0 59785 NULL
+disable_so_macvtap16_to_cpu_fndecl_59790 macvtap16_to_cpu fndecl 0-2 59790 NULL
+disable_so_ns_ack_interrupt_fndecl_59791 ns_ack_interrupt fndecl 0 59791 NULL
+disable_so_btrfs_commit_inode_delayed_inode_fndecl_59792 btrfs_commit_inode_delayed_inode fndecl 0 59792 NULL
+disable_so_lg_addr_ns_dev_59797 lg_addr ns_dev 0 59797 NULL
+disable_so_nr_divisor_sym_chip_59803 nr_divisor sym_chip 0 59803 NULL
+disable_so_cpu_power_to_freq_fndecl_59806 cpu_power_to_freq fndecl 2 59806 NULL nohasharray
+disable_so_hash_sfq_slot_59806 hash sfq_slot 0 59806 &disable_so_cpu_power_to_freq_fndecl_59806
+disable_so_netvsc_set_mac_addr_fndecl_59822 netvsc_set_mac_addr fndecl 0 59822 NULL
+disable_so_kxcjk1013_get_startup_times_fndecl_59827 kxcjk1013_get_startup_times fndecl 0 59827 NULL nohasharray
+disable_so_bitmap_ipmac_do_test_fndecl_59827 bitmap_ipmac_do_test fndecl 3 59827 &disable_so_kxcjk1013_get_startup_times_fndecl_59827
+disable_so_decnet_time_wait_vardecl_59833 decnet_time_wait vardecl 0 59833 NULL
+disable_so_delay_multiplier_be_set_eqd_59834 delay_multiplier be_set_eqd 0 59834 NULL
+disable_so_asr_get_base_address_fndecl_59835 asr_get_base_address fndecl 0 59835 NULL
+disable_so_timeout_nouveau_fence_59837 timeout nouveau_fence 0 59837 NULL
+disable_so_m_pll_freq_tbl_59838 m pll_freq_tbl 0 59838 NULL
+disable_so_tea5764_get_freq_fndecl_59848 tea5764_get_freq fndecl 0 59848 NULL
+disable_so_seq_km_event_59849 seq km_event 0 59849 NULL nohasharray
+disable_so_dst_addr_lo_dmae_command_59849 dst_addr_lo dmae_command 0 59849 &disable_so_seq_km_event_59849
+disable_so_get_ep_by_addr_fndecl_59856 get_ep_by_addr fndecl 2 59856 NULL
+disable_so_txbd_addr_hi_host_cmd_ds_pcie_details_59885 txbd_addr_hi host_cmd_ds_pcie_details 0 59885 NULL
+disable_so_hash_v6_fndecl_59887 hash_v6 fndecl 0 59887 NULL
+disable_so_sst_module_runtime_restore_fndecl_59893 sst_module_runtime_restore fndecl 0 59893 NULL
+disable_so_pvclock_clocksource_read_fndecl_59895 pvclock_clocksource_read fndecl 0 59895 NULL nohasharray
+disable_so_hdspm_set_interrupt_interval_fndecl_59895 hdspm_set_interrupt_interval fndecl 2-0 59895 &disable_so_pvclock_clocksource_read_fndecl_59895
+disable_so_i2c_addr_r820t_config_59896 i2c_addr r820t_config 0 59896 NULL
+disable_so_i2400m_check_mac_addr_fndecl_59899 i2400m_check_mac_addr fndecl 0 59899 NULL
+disable_so_get_uuid_export_operations_59904 get_uuid export_operations 0 59904 NULL
+disable_so_last_tx_jiffies_fmdev_59908 last_tx_jiffies fmdev 0 59908 NULL nohasharray
+disable_so_delay_use_vardecl_usb_c_59908 delay_use vardecl_usb.c 0 59908 &disable_so_last_tx_jiffies_fmdev_59908
+disable_so_show_telclock_version_fndecl_59913 show_telclock_version fndecl 0 59913 NULL
+disable_so_flush_time_il3945_rs_sta_59914 flush_time il3945_rs_sta 0 59914 NULL
+disable_so_sip_sprintf_addr_fndecl_59915 sip_sprintf_addr fndecl 0 59915 NULL
+disable_so_lola_set_clock_index_fndecl_59921 lola_set_clock_index fndecl 0 59921 NULL nohasharray
+disable_so_addr_stv0900_reg_59921 addr stv0900_reg 0 59921 &disable_so_lola_set_clock_index_fndecl_59921
+disable_so_vsnprintf_fndecl_59932 vsnprintf fndecl 0-2 59932 NULL
+disable_so_nfs4_delay_fndecl_59938 nfs4_delay fndecl 0 59938 NULL nohasharray
+disable_so___bch_btree_map_nodes_fndecl_59938 __bch_btree_map_nodes fndecl 0 59938 &disable_so_nfs4_delay_fndecl_59938
+disable_so_freq_before_jump_fm_rx_59940 freq_before_jump fm_rx 0 59940 NULL
+disable_so_vt8623_set_pixclock_fndecl_59944 vt8623_set_pixclock fndecl 2 59944 NULL
+disable_so_seq_ieee80211_fragment_entry_59945 seq ieee80211_fragment_entry 0 59945 NULL
+disable_so_map_nr_blk_mq_bitmap_tags_59947 map_nr blk_mq_bitmap_tags 0 59947 NULL nohasharray
+disable_so_r5_hash_fndecl_59947 r5_hash fndecl 2 59947 &disable_so_map_nr_blk_mq_bitmap_tags_59947
+disable_so_s_first_error_time_ext4_super_block_59952 s_first_error_time ext4_super_block 0 59952 NULL
+disable_so_crypto_ablkcipher_decrypt_fndecl_59964 crypto_ablkcipher_decrypt fndecl 0 59964 NULL
+disable_so_i_gid_write_fndecl_59978 i_gid_write fndecl 2 59978 NULL
+disable_so_dst_nents_qce_cipher_reqctx_59989 dst_nents qce_cipher_reqctx 0 59989 NULL
+disable_so_addr_nvme_passthru_cmd_59990 addr nvme_passthru_cmd 0 59990 NULL
+disable_so_vsprintf_fndecl_59994 vsprintf fndecl 0 59994 NULL
+disable_so_desc_daddr_ath5k_hw_59995 desc_daddr ath5k_hw 0 59995 NULL
+disable_so_n_pll_freq_tbl_60004 n pll_freq_tbl 0 60004 NULL
+disable_so_ufshcd_parse_clock_info_fndecl_60006 ufshcd_parse_clock_info fndecl 0 60006 NULL
+disable_so_max_timer_ms_bcm47xx_wdt_60015 max_timer_ms bcm47xx_wdt 0 60015 NULL
+disable_so_add_monitor_signal_fndecl_60038 add_monitor_signal fndecl 4 60038 NULL
+disable_so_check_matrix_bitmap_fndecl_60054 check_matrix_bitmap fndecl 0-2-3-4 60054 NULL
+disable_so_bitmap_file_clear_bit_fndecl_60061 bitmap_file_clear_bit fndecl 2 60061 NULL nohasharray
+disable_so_nvkm_ramht_hash_fndecl_60061 nvkm_ramht_hash fndecl 0-2-3 60061 &disable_so_bitmap_file_clear_bit_fndecl_60061
+disable_so_radeon_ib_schedule_fndecl_60075 radeon_ib_schedule fndecl 0 60075 NULL
+disable_so_sleep_cookie_addr_hi_host_cmd_ds_pcie_details_60083 sleep_cookie_addr_hi host_cmd_ds_pcie_details 0 60083 NULL
+disable_so_crypto_cbc_decrypt_fndecl_60087 crypto_cbc_decrypt fndecl 0-4 60087 NULL
+disable_so_calc_mode_timings_fndecl_60088 calc_mode_timings fndecl 1-2-3 60088 NULL
+disable_so_jiffies_till_first_fqs_vardecl_tree_c_60090 jiffies_till_first_fqs vardecl_tree.c 0 60090 NULL
+disable_so_reorder_timeout_l2tp_session_60091 reorder_timeout l2tp_session 0 60091 NULL
+disable_so_ieee80211_get_noa_absent_time_fndecl_60093 ieee80211_get_noa_absent_time fndecl 0-2 60093 NULL
+disable_so_vsync_offset_lo_oaktrail_timing_info_60096 vsync_offset_lo oaktrail_timing_info 0 60096 NULL
+disable_so_daddr_flowidn_60098 daddr flowidn 0 60098 NULL
+disable_so_mwifiex_set_mac_address_fndecl_60110 mwifiex_set_mac_address fndecl 0 60110 NULL
+disable_so_xgbe_get_tstamp_time_fndecl_60114 xgbe_get_tstamp_time fndecl 0 60114 NULL
+disable_so_end_seq_bictcp_60116 end_seq bictcp 0 60116 NULL
+disable_so_rv770_calculate_fractional_mpll_feedback_divider_fndecl_60119 rv770_calculate_fractional_mpll_feedback_divider fndecl 1-2 60119 NULL nohasharray
+disable_so_set_msr_x86_emulate_ops_60119 set_msr x86_emulate_ops 2-3 60119 &disable_so_rv770_calculate_fractional_mpll_feedback_divider_fndecl_60119
+disable_so_radeon_vm_bo_set_addr_fndecl_60122 radeon_vm_bo_set_addr fndecl 3-0 60122 NULL
+disable_so_reload_jiffies_iwl_priv_60123 reload_jiffies iwl_priv 0 60123 NULL
+disable_so_shdntimer_max17042_config_data_60124 shdntimer max17042_config_data 0 60124 NULL nohasharray
+disable_so_timestamp_lec_arp_table_60124 timestamp lec_arp_table 0 60124 &disable_so_shdntimer_max17042_config_data_60124
+disable_so_reg_duty_cycle_pm860x_backlight_data_60125 reg_duty_cycle pm860x_backlight_data 0 60125 NULL
+disable_so_buff_phy_addr_amd8111e_tx_dr_60126 buff_phy_addr amd8111e_tx_dr 0 60126 NULL
+disable_so_nilfs_btree_seek_key_fndecl_60131 nilfs_btree_seek_key fndecl 0-2 60131 NULL
+disable_so_local_addr_mm_dma_desc_60141 local_addr mm_dma_desc 0 60141 NULL
+disable_so_cmd_attr_tgid_fndecl_60158 cmd_attr_tgid fndecl 0 60158 NULL
+disable_so_read_addr_qla8044_minidump_entry_queue_60166 read_addr qla8044_minidump_entry_queue 0 60166 NULL
+disable_so_snd_soc_runtime_deactivate_fndecl_60170 snd_soc_runtime_deactivate fndecl 2 60170 NULL
+disable_so_addr_lo_tg3_tx_buffer_desc_60173 addr_lo tg3_tx_buffer_desc 0 60173 NULL
+disable_so_addr_c4iw_mm_entry_60182 addr c4iw_mm_entry 0 60182 NULL
+disable_so_gid_index_ib_user_mad_hdr_60188 gid_index ib_user_mad_hdr 0 60188 NULL
+disable_so_div_vnic_intr_coal_timer_info_60192 div vnic_intr_coal_timer_info 0 60192 NULL
+disable_so_udf_bitmap_prealloc_blocks_fndecl_60195 udf_bitmap_prealloc_blocks fndecl 0-4-5 60195 NULL
+disable_so_i_atime_nsec_ocfs2_dinode_60196 i_atime_nsec ocfs2_dinode 0 60196 NULL
+disable_so_addr_buffer3_cmd_desc_type0_60201 addr_buffer3 cmd_desc_type0 0 60201 NULL
+disable_so_mac_time_rtl8187b_rx_hdr_60213 mac_time rtl8187b_rx_hdr 0 60213 NULL
+disable_so_regmap_read_fndecl_60217 regmap_read fndecl 0-2 60217 NULL
+disable_so_oprofile_time_slice_vardecl_60220 oprofile_time_slice vardecl 0 60220 NULL
+disable_so_monotonic_time_coarse_nsec_vsyscall_gtod_data_60224 monotonic_time_coarse_nsec vsyscall_gtod_data 0 60224 NULL
+disable_so_toshiba_usb_sleep_music_get_fndecl_60227 toshiba_usb_sleep_music_get fndecl 0 60227 NULL
+disable_so_msr_read_fndecl_60228 msr_read fndecl 0 60228 NULL
+disable_so_via_set_primary_address_fndecl_60230 via_set_primary_address fndecl 1 60230 NULL
+disable_so_hpfs_stop_cycles_fndecl_60236 hpfs_stop_cycles fndecl 2 60236 NULL
+disable_so_cpumask_any_but_fndecl_60246 cpumask_any_but fndecl 0-2 60246 NULL
+disable_so_hash_cnt_ccp_sha_req_ctx_60248 hash_cnt ccp_sha_req_ctx 0 60248 NULL
+disable_so_atime_nsec_p9_iattr_dotl_60254 atime_nsec p9_iattr_dotl 0 60254 NULL
+disable_so___ilog2_u32_fndecl_60257 __ilog2_u32 fndecl 0-1 60257 NULL
+disable_so_it_clock_k_itimer_60276 it_clock k_itimer 0 60276 NULL
+disable_so_stats_addr_vfpf_init_tlv_60282 stats_addr vfpf_init_tlv 0 60282 NULL
+disable_so_zd1201_set_freq_fndecl_60293 zd1201_set_freq fndecl 0 60293 NULL
+disable_so_freq_sc18is602_60297 freq sc18is602 0 60297 NULL
+disable_so_imr_multiaddr_ip_mreq_source_60300 imr_multiaddr ip_mreq_source 0 60300 NULL
+disable_so_skbaddr_ath5k_buf_60306 skbaddr ath5k_buf 0 60306 NULL
+disable_so_bus_addr_sg_el_60307 bus_addr sg_el 0 60307 NULL
+disable_so_iwl_add_beacon_time_fndecl_60324 iwl_add_beacon_time fndecl 0-4-3-2 60324 NULL
+disable_so_regcache_lzo_sync_fndecl_60330 regcache_lzo_sync fndecl 0 60330 NULL
+disable_so___mlx4_find_zone_by_uid_unique_fndecl_60331 __mlx4_find_zone_by_uid_unique fndecl 2 60331 NULL nohasharray
+disable_so_ucma_query_addr_fndecl_60331 ucma_query_addr fndecl 3 60331 &disable_so___mlx4_find_zone_by_uid_unique_fndecl_60331
+disable_so_nilfs_btree_commit_insert_fndecl_60335 nilfs_btree_commit_insert fndecl 4 60335 NULL
+disable_so_rbtree_open_fndecl_60337 rbtree_open fndecl 0 60337 NULL
+disable_so_addr_off_bfa_phy_s_60341 addr_off bfa_phy_s 0 60341 NULL
+disable_so_rj54n1_set_clock_fndecl_60342 rj54n1_set_clock fndecl 0 60342 NULL nohasharray
+disable_so___udelay_fndecl_60342 __udelay fndecl 1 60342 &disable_so_rj54n1_set_clock_fndecl_60342
+disable_so_sysctl_llc2_p_timeout_vardecl_60348 sysctl_llc2_p_timeout vardecl 0 60348 NULL
+disable_so_dwc3_ep0_set_address_fndecl_60355 dwc3_ep0_set_address fndecl 0 60355 NULL
+disable_so_nla_put_msecs_fndecl_60358 nla_put_msecs fndecl 0 60358 NULL
+disable_so_div_factor_fndecl_60362 div_factor fndecl 0-1 60362 NULL
+disable_so_sense_busaddr_scb_60364 sense_busaddr scb 0 60364 NULL
+disable_so_ufshcd_pltfrm_runtime_resume_fndecl_60367 ufshcd_pltfrm_runtime_resume fndecl 0 60367 NULL
+disable_so_pixel_clock_vbe_crtc_ib_60373 pixel_clock vbe_crtc_ib 0 60373 NULL
+disable_so_erst_timedout_fndecl_60378 erst_timedout fndecl 2 60378 NULL
+disable_so_crypto_ecb_encrypt_fndecl_60388 crypto_ecb_encrypt fndecl 0-4 60388 NULL
+disable_so_rtsx_resv_buf_addr_rtsx_pcr_60399 rtsx_resv_buf_addr rtsx_pcr 0 60399 NULL
+disable_so_i2c_address_mc44s803_config_60409 i2c_address mc44s803_config 0 60409 NULL
+disable_so_ath_hw_get_listen_time_fndecl_60410 ath_hw_get_listen_time fndecl 0 60410 NULL
+disable_so_rpc_sockaddr2uaddr_fndecl_60418 rpc_sockaddr2uaddr fndecl 2 60418 NULL
+disable_so_sys_setresgid16_fndecl_60419 sys_setresgid16 fndecl 0-1-2-3 60419 NULL
+disable_so_mc_addr_inet_sock_60425 mc_addr inet_sock 0 60425 NULL
+disable_so_txqueue_timer_velocity_opt_60430 txqueue_timer velocity_opt 0 60430 NULL
+disable_so_set_mtrr_from_inactive_cpu_fndecl_60437 set_mtrr_from_inactive_cpu fndecl 2-3 60437 NULL
+disable_so_i915_interrupt_info_fndecl_60441 i915_interrupt_info fndecl 0 60441 NULL
+disable_so_bmiss_timeout_ath_beacon_config_60451 bmiss_timeout ath_beacon_config 0 60451 NULL
+disable_so_callback_addr_req_60459 callback addr_req 1 60459 NULL
+disable_so_vmx_compute_tsc_offset_fndecl_60461 vmx_compute_tsc_offset fndecl 0-2 60461 NULL
+disable_so_ncpus_uv_rtc_timer_head_60462 ncpus uv_rtc_timer_head 0 60462 NULL
+disable_so_passed_seqno_drm_vmw_fence_signaled_arg_60464 passed_seqno drm_vmw_fence_signaled_arg 0 60464 NULL
+disable_so_send_signal_fndecl_60468 send_signal fndecl 0-1 60468 NULL
+disable_so_isl1208_rtc_read_time_fndecl_60479 isl1208_rtc_read_time fndecl 0 60479 NULL
+disable_so_cbs_dma_addr_nic_60500 cbs_dma_addr nic 0 60500 NULL
+disable_so_mpihelp_divrem_fndecl_60501 mpihelp_divrem fndecl 6-0-4 60501 NULL
+disable_so_branch_address_descriptor_60510 branch_address descriptor 0 60510 NULL
+disable_so_hash_lock_index_stripe_head_60512 hash_lock_index stripe_head 0 60512 NULL
+disable_so_brl_timeout_vardecl_keyboard_c_60524 brl_timeout vardecl_keyboard.c 0 60524 NULL
+disable_so_chip_addr_dsp_image_seg_60530 chip_addr dsp_image_seg 0 60530 NULL
+disable_so_test_hash_cycles_fndecl_60535 test_hash_cycles fndecl 4 60535 NULL
+disable_so_dma_addr_srr_60537 dma_addr srr 0 60537 NULL
+disable_so_spinfo_assoc_id_sctp_paddrinfo_60539 spinfo_assoc_id sctp_paddrinfo 0 60539 NULL
+disable_so_nvkm_timer_wait_eq_fndecl_60542 nvkm_timer_wait_eq fndecl 3-4-5 60542 NULL
+disable_so_eq_get_mtt_addr_fndecl_60544 eq_get_mtt_addr fndecl 0 60544 NULL
+disable_so_cq_page_table_addr_lo_iscsi_kwqe_conn_offload1_60567 cq_page_table_addr_lo iscsi_kwqe_conn_offload1 0 60567 NULL
+disable_so_tk_timeout_rpc_task_60572 tk_timeout rpc_task 0 60572 NULL
+disable_so_cn_printf_fndecl_60575 cn_printf fndecl 0 60575 NULL nohasharray
+disable_so_sgl_addr_hi_fw_flash_Update_req_60575 sgl_addr_hi fw_flash_Update_req 0 60575 &disable_so_cn_printf_fndecl_60575 nohasharray
+disable_so_sysfs_idx_addr_vardecl_nes_c_60575 sysfs_idx_addr vardecl_nes.c 0 60575 &disable_so_sgl_addr_hi_fw_flash_Update_req_60575
+disable_so___xfs_btree_split_fndecl_60576 __xfs_btree_split fndecl 0 60576 NULL
+disable_so_lun_atto_csmi_get_dev_addr_60579 lun atto_csmi_get_dev_addr 0 60579 NULL
+disable_so_xfs_btree_block_change_owner_fndecl_60599 xfs_btree_block_change_owner fndecl 0-3 60599 NULL
+disable_so_k_wm8978_pll_div_60623 k wm8978_pll_div 0 60623 NULL
+disable_so_saved_clock_vardecl_cr_pll_c_60624 saved_clock vardecl_cr_pll.c 0 60624 NULL
+disable_so_mapaddr_tx_ring_info_60630 mapaddr tx_ring_info 0 60630 NULL nohasharray
+disable_so_derot_freq_stb0899_internal_60630 derot_freq stb0899_internal 0 60630 &disable_so_mapaddr_tx_ring_info_60630
+disable_so_edx_user_regs_struct32_60635 edx user_regs_struct32 0 60635 NULL
+disable_so_cgtime_signal_struct_60641 cgtime signal_struct 0 60641 NULL
+disable_so_ide_timing_compute_fndecl_60642 ide_timing_compute fndecl 2 60642 NULL
+disable_so_btree_read_extent_buffer_pages_fndecl_60645 btree_read_extent_buffer_pages fndecl 0-4 60645 NULL
+disable_so_sys_sched_getscheduler_fndecl_60650 sys_sched_getscheduler fndecl 1-0 60650 NULL
+disable_so_hpi_compander_set_decay_time_constant_fndecl_60651 hpi_compander_set_decay_time_constant fndecl 1-0 60651 NULL
+disable_so_uwb_rc_addr_get_fndecl_60653 uwb_rc_addr_get fndecl 0 60653 NULL
+disable_so_max_chan_time_wsm_scan_ch_60669 max_chan_time wsm_scan_ch 0 60669 NULL
+disable_so_ci_otg_fsm_del_timer_fndecl_60676 ci_otg_fsm_del_timer fndecl 2 60676 NULL
+disable_so_clockdelay_nt_vardecl_hfcmulti_c_60678 clockdelay_nt vardecl_hfcmulti.c 0 60678 NULL
+disable_so_hsync_off_lo_lvds_dvo_timing_60681 hsync_off_lo lvds_dvo_timing 0 60681 NULL
+disable_so_leaf_head_hfs_btree_60686 leaf_head hfs_btree 0 60686 NULL
+disable_so_signal_user32_60695 signal user32 0 60695 NULL
+disable_so_timeout_netns_frags_60708 timeout netns_frags 0 60708 NULL
+disable_so_time_to_send_netem_skb_cb_60711 time_to_send netem_skb_cb 0 60711 NULL nohasharray
+disable_so_ref_div_atom_clock_dividers_60711 ref_div atom_clock_dividers 0 60711 &disable_so_time_to_send_netem_skb_cb_60711
+disable_so_dev_sof_uvc_clock_sample_60716 dev_sof uvc_clock_sample 0 60716 NULL
+disable_so_addr_reg_musb_qh_60718 addr_reg musb_qh 0 60718 NULL nohasharray
+enable_so_acpi_ex_do_math_op_fndecl_60718 acpi_ex_do_math_op fndecl 0-3-2 60718 &disable_so_addr_reg_musb_qh_60718
+disable_so_reg_clock_sx150x_789_pri_60721 reg_clock sx150x_789_pri 0 60721 NULL
+disable_so___parse_nl_addr_fndecl_60734 __parse_nl_addr fndecl 0 60734 NULL
+disable_so_frequency_zl10036_state_60737 frequency zl10036_state 0 60737 NULL
+disable_so_acpi_sleep_state_supported_fndecl_60743 acpi_sleep_state_supported fndecl 1 60743 NULL
+disable_so_put_dec_full8_fndecl_60744 put_dec_full8 fndecl 2 60744 NULL
+disable_so_atkbd_interrupt_fndecl_60746 atkbd_interrupt fndecl 2 60746 NULL
+disable_so_signal_station_info_60755 signal station_info 0 60755 NULL
+disable_so_r15_kvm_regs_60757 r15 kvm_regs 0 60757 NULL
+disable_so_tx_dma_addr_sh_msiof_spi_priv_60773 tx_dma_addr sh_msiof_spi_priv 0 60773 NULL
+disable_so_handler_acpi_object_addr_handler_60775 handler acpi_object_addr_handler 0-2-3 60775 NULL nohasharray
+disable_so_sctp_bind_addr_init_fndecl_60775 sctp_bind_addr_init fndecl 2 60775 &disable_so_handler_acpi_object_addr_handler_60775
+disable_so_hfsplus_calc_btree_clump_size_fndecl_60777 hfsplus_calc_btree_clump_size fndecl 0-1-2-3 60777 NULL
+disable_so_xc2028_set_analog_freq_fndecl_60787 xc2028_set_analog_freq fndecl 0 60787 NULL
+disable_so_reg_w_val_fndecl_60792 reg_w_val fndecl 2-3 60792 NULL
+disable_so_mlx4_mtt_addr_fndecl_60804 mlx4_mtt_addr fndecl 0 60804 NULL
+disable_so_kstrtos16_fndecl_60808 kstrtos16 fndecl 0 60808 NULL
+disable_so_demod_address_bcm3510_config_60810 demod_address bcm3510_config 0 60810 NULL
+disable_so_xt_addr_cmp_fndecl_60817 xt_addr_cmp fndecl 4 60817 NULL
+disable_so_kstrtou16_fndecl_60828 kstrtou16 fndecl 0 60828 NULL
+disable_so_crypto_cbc_decrypt_segment_fndecl_60829 crypto_cbc_decrypt_segment fndecl 0 60829 NULL
+disable_so_cs_last_clocksource_60836 cs_last clocksource 0 60836 NULL
+disable_so_decrypt_blkcipher_alg_60844 decrypt blkcipher_alg 4 60844 NULL
+disable_so_demod_address_drxd_config_60850 demod_address drxd_config 0 60850 NULL
+disable_so_rs_bound_addr_rds_sock_60851 rs_bound_addr rds_sock 0 60851 NULL
+disable_so_pcxhr_sub_set_clock_fndecl_60853 pcxhr_sub_set_clock fndecl 2-0 60853 NULL nohasharray
+disable_so_inet6_dump_ifmcaddr_fndecl_60853 inet6_dump_ifmcaddr fndecl 0 60853 &disable_so_pcxhr_sub_set_clock_fndecl_60853
+disable_so_mpll_ref_div_rv6xx_power_info_60865 mpll_ref_div rv6xx_power_info 0 60865 NULL
+disable_so_clk_mul_sdhci_host_60866 clk_mul sdhci_host 0 60866 NULL
+disable_so_cryptd_hash_finup_enqueue_fndecl_60873 cryptd_hash_finup_enqueue fndecl 0 60873 NULL
+disable_so_pc87360_autodiv_fndecl_60877 pc87360_autodiv fndecl 2 60877 NULL nohasharray
+disable_so_si_get_gpu_clock_counter_fndecl_60877 si_get_gpu_clock_counter fndecl 0 60877 &disable_so_pc87360_autodiv_fndecl_60877
+disable_so_dma_addr___vxge_hw_blockpool_entry_60895 dma_addr __vxge_hw_blockpool_entry 0 60895 NULL
+disable_so_write32_ssb_bus_ops_60906 write32 ssb_bus_ops 3 60906 NULL
+disable_so_bfa_fcs_lport_ns_process_gidft_pids_fndecl_60914 bfa_fcs_lport_ns_process_gidft_pids fndecl 3 60914 NULL
+disable_so_hash_walk_next_fndecl_60955 hash_walk_next fndecl 0 60955 NULL
+disable_so_tm_min_rtc_time_60965 tm_min rtc_time 0 60965 NULL
+disable_so_m48t86_rtc_read_time_fndecl_60966 m48t86_rtc_read_time fndecl 0 60966 NULL
+disable_so_alloc_gen8_temp_bitmaps_fndecl_60972 alloc_gen8_temp_bitmaps fndecl 0 60972 NULL
+disable_so_max_dwell_time_delta_conf_sched_scan_settings_60976 max_dwell_time_delta conf_sched_scan_settings 0 60976 NULL
+disable_so_src_addr_filter_ipv4_5tuple_60977 src_addr filter_ipv4_5tuple 0 60977 NULL nohasharray
+disable_so_intel_freq_opcode_fndecl_60977 intel_freq_opcode fndecl 0-2 60977 &disable_so_src_addr_filter_ipv4_5tuple_60977
+disable_so_btree_pages_cache_set_60979 btree_pages cache_set 0 60979 NULL
+disable_so_pop_time_snd_soc_card_60984 pop_time snd_soc_card 0 60984 NULL
+disable_so_v4l2_i2c_subdev_addr_fndecl_60994 v4l2_i2c_subdev_addr fndecl 0 60994 NULL
+disable_so_find_and_set_predefined_video_timings_fndecl_61004 find_and_set_predefined_video_timings fndecl 2 61004 NULL
+disable_so_bus_ipr_res_addr_61007 bus ipr_res_addr 0 61007 NULL
+disable_so_t2timer_lapb_parms_struct_61011 t2timer lapb_parms_struct 0 61011 NULL nohasharray
+disable_so_size_log2_t3_cq_61011 size_log2 t3_cq 0 61011 &disable_so_t2timer_lapb_parms_struct_61011
+disable_so_virtual_apic_page_addr_vmcs12_61020 virtual_apic_page_addr vmcs12 0 61020 NULL
+disable_so_show_sas_end_dev_I_T_nexus_loss_timeout_fndecl_61033 show_sas_end_dev_I_T_nexus_loss_timeout fndecl 0 61033 NULL
+disable_so_first_time_batadv_tt_roam_node_61055 first_time batadv_tt_roam_node 0 61055 NULL
+disable_so_blank_time_evergreen_wm_params_61058 blank_time evergreen_wm_params 0 61058 NULL
+disable_so_crypto_hash_walk_done_fndecl_61061 crypto_hash_walk_done fndecl 0-2 61061 NULL
+disable_so_qi_rtbtimelimit_xfs_quotainfo_61067 qi_rtbtimelimit xfs_quotainfo 0 61067 NULL
+disable_so_dma_addr_freelQ_61069 dma_addr freelQ 0 61069 NULL
+disable_so_gateway_value_addr_wil_fw_record_gateway_data_61071 gateway_value_addr wil_fw_record_gateway_data 0 61071 NULL
+disable_so_ndisc_opt_addr_space_fndecl_61076 ndisc_opt_addr_space fndecl 0 61076 NULL nohasharray
+disable_so_pcan_usb_fd_set_bittiming_fast_fndecl_61076 pcan_usb_fd_set_bittiming_fast fndecl 0 61076 &disable_so_ndisc_opt_addr_space_fndecl_61076
+disable_so_wl1251_translate_reg_addr_fndecl_61077 wl1251_translate_reg_addr fndecl 0-2 61077 NULL
+disable_so_irq_set_handler_data_fndecl_61096 irq_set_handler_data fndecl 1 61096 NULL nohasharray
+disable_so_be64_add_cpu_fndecl_61096 be64_add_cpu fndecl 2 61096 &disable_so_irq_set_handler_data_fndecl_61096
+disable_so_find_first_extent_bit_state_fndecl_61098 find_first_extent_bit_state fndecl 2 61098 NULL
+disable_so_confirm_addr_indev_fndecl_61106 confirm_addr_indev fndecl 0 61106 NULL
+disable_so_ci_otg_init_timers_fndecl_61122 ci_otg_init_timers fndecl 0 61122 NULL
+disable_so_rangehigh_v4l2_frequency_band_61125 rangehigh v4l2_frequency_band 0 61125 NULL
+disable_so_rdb_PartitionList_RigidDiskBlock_61126 rdb_PartitionList RigidDiskBlock 0 61126 NULL
+disable_so_qat_alg_ablkcipher_setkey_fndecl_61127 qat_alg_ablkcipher_setkey fndecl 3 61127 NULL
+disable_so_ath6kl_cfg80211_deepsleep_suspend_fndecl_61128 ath6kl_cfg80211_deepsleep_suspend fndecl 0 61128 NULL
+disable_so_phase_seg2_can_bittiming_61132 phase_seg2 can_bittiming 0 61132 NULL
+disable_so_mii_address_fndecl_61157 mii_address fndecl 1-2 61157 NULL
+disable_so_dent_key_init_hash_fndecl_61159 dent_key_init_hash fndecl 3-4 61159 NULL
+disable_so__drbd_send_uuids_fndecl_61164 _drbd_send_uuids fndecl 0 61164 NULL
+disable_so_addr_gf100_gr_mmio_61167 addr gf100_gr_mmio 0 61167 NULL
+disable_so_xfrm_dst_hash_fndecl_61174 xfrm_dst_hash fndecl 0-4-5 61174 NULL
+disable_so_i2c_smbus_read_i2c_block_data_fndecl_61176 i2c_smbus_read_i2c_block_data fndecl 0-2-3 61176 NULL
+disable_so_mthca_HW2SW_SRQ_fndecl_61199 mthca_HW2SW_SRQ fndecl 0-3 61199 NULL
+disable_so_bit_fields_len_ocrdma_srq_61200 bit_fields_len ocrdma_srq 0 61200 NULL
+disable_so_cpuidle_add_device_sysfs_fndecl_61204 cpuidle_add_device_sysfs fndecl 0 61204 NULL
+disable_so_avail_snd_rawmidi_runtime_61205 avail snd_rawmidi_runtime 0 61205 NULL
+disable_so_fib_info_hashfn_fndecl_61213 fib_info_hashfn fndecl 0 61213 NULL
+disable_so_zd_usb_iowrite16v_async_end_fndecl_61215 zd_usb_iowrite16v_async_end fndecl 0 61215 NULL nohasharray
+disable_so_shash_ahash_mcryptd_update_fndecl_61215 shash_ahash_mcryptd_update fndecl 0 61215 &disable_so_zd_usb_iowrite16v_async_end_fndecl_61215
+disable_so_buf_addr_mlx4_ib_create_srq_61216 buf_addr mlx4_ib_create_srq 0 61216 NULL
+disable_so_post_divider_panel_info_61220 post_divider panel_info 0 61220 NULL
+disable_so_wrmsr_safe_regs_fndecl_61235 wrmsr_safe_regs fndecl 0 61235 NULL
+disable_so_get_stats_jiffies_smsdvb_client_t_61240 get_stats_jiffies smsdvb_client_t 0 61240 NULL
+disable_so_ebitmap_next_positive_fndecl_61248 ebitmap_next_positive fndecl 0-3 61248 NULL
+disable_so_ieee80211_aes_gcm_decrypt_fndecl_61254 ieee80211_aes_gcm_decrypt fndecl 0-5 61254 NULL
+disable_so_sprintf_string_fndecl_61260 sprintf_string fndecl 0 61260 NULL nohasharray
+disable_so_ci_do_program_memory_timing_parameters_fndecl_61260 ci_do_program_memory_timing_parameters fndecl 0 61260 &disable_so_sprintf_string_fndecl_61260
+disable_so_be32_to_cpu_array_fndecl_61277 be32_to_cpu_array fndecl 3 61277 NULL
+disable_so_ds_tss_segment_16_61290 ds tss_segment_16 0 61290 NULL
+disable_so_start_delay_ns_cc10001_adc_device_61303 start_delay_ns cc10001_adc_device 0 61303 NULL
+disable_so_data_addr_nvbios_pmuR_61307 data_addr nvbios_pmuR 0 61307 NULL
+disable_so_time_stamp_il_traffic_load_61308 time_stamp il_traffic_load 0 61308 NULL nohasharray
+disable_so_crypto_ccm_encrypt_done_fndecl_61308 crypto_ccm_encrypt_done fndecl 2 61308 &disable_so_time_stamp_il_traffic_load_61308
+disable_so_max_pixclock_tdfx_par_61310 max_pixclock tdfx_par 0 61310 NULL
+disable_so_nilfs_btree_node_get_key_fndecl_61317 nilfs_btree_node_get_key fndecl 0-2 61317 NULL
+disable_so_sk_forced_wmem_schedule_fndecl_61322 sk_forced_wmem_schedule fndecl 2 61322 NULL
+disable_so_rxhash_tun_flow_entry_61325 rxhash tun_flow_entry 0 61325 NULL
+disable_so___spin_time_accum_fndecl_61328 __spin_time_accum fndecl 1 61328 NULL
+disable_so_iscsi_nacl_attrib_store_nopin_timeout_fndecl_61329 iscsi_nacl_attrib_store_nopin_timeout fndecl 0-3 61329 NULL
+disable_so_dqb_itime_v1_disk_dqblk_61340 dqb_itime v1_disk_dqblk 0 61340 NULL nohasharray
+disable_so_rds_iw_laddr_check_fndecl_61340 rds_iw_laddr_check fndecl 0-1 61340 &disable_so_dqb_itime_v1_disk_dqblk_61340
+disable_so_pcibios_retrieve_fw_addr_fndecl_61341 pcibios_retrieve_fw_addr fndecl 0-2 61341 NULL
+disable_so_iwl_scan_cancel_timeout_fndecl_61342 iwl_scan_cancel_timeout fndecl 2 61342 NULL
+disable_so_m41t80_sysfs_set_sqwfreq_fndecl_61345 m41t80_sysfs_set_sqwfreq fndecl 0-4 61345 NULL
+disable_so_atl1_hash_mc_addr_fndecl_61348 atl1_hash_mc_addr fndecl 0 61348 NULL
+disable_so_daddr_irda_device_info_61349 daddr irda_device_info 0 61349 NULL
+disable_so_read_addr_qla82xx_md_entry_rdmem_61354 read_addr qla82xx_md_entry_rdmem 0 61354 NULL
+disable_so_wm8990_set_dai_clkdiv_fndecl_61357 wm8990_set_dai_clkdiv fndecl 3 61357 NULL
+disable_so_btrfs_delete_delayed_dir_index_fndecl_61358 btrfs_delete_delayed_dir_index fndecl 0-4 61358 NULL
+disable_so_disable_irq_fndecl_61372 disable_irq fndecl 1 61372 NULL
+disable_so_parport_ieee1284_epp_read_addr_fndecl_61382 parport_ieee1284_epp_read_addr fndecl 0 61382 NULL nohasharray
+disable_so_num_to_str_fndecl_61382 num_to_str fndecl 0-3-2 61382 &disable_so_parport_ieee1284_epp_read_addr_fndecl_61382
+disable_so_period_timeriomem_rng_data_61395 period timeriomem_rng_data 0 61395 NULL
+disable_so_crypto_gcm_setkey_done_fndecl_61396 crypto_gcm_setkey_done fndecl 2 61396 NULL
+disable_so_ocfs2_journal_addressable_fndecl_61399 ocfs2_journal_addressable fndecl 0 61399 NULL
+disable_so_smsdvb_read_signal_strength_fndecl_61408 smsdvb_read_signal_strength fndecl 0 61408 NULL
+disable_so_flash_busaddr_ips_ha_61415 flash_busaddr ips_ha 0 61415 NULL
+disable_so_enable_time_us_tps_info_61417 enable_time_us tps_info 0 61417 NULL
+disable_so_mtrr_chunk_size_vardecl_cleanup_c_61418 mtrr_chunk_size vardecl_cleanup.c 0 61418 NULL
+disable_so_show_dock_uid_fndecl_61419 show_dock_uid fndecl 0 61419 NULL
+disable_so_get_pageblock_bitmap_fndecl_61435 get_pageblock_bitmap fndecl 2 61435 NULL
+disable_so_s5p_jpeg_runtime_resume_fndecl_61449 s5p_jpeg_runtime_resume fndecl 0 61449 NULL nohasharray
+disable_so_last_ramp_down_time_lpfc_hba_61449 last_ramp_down_time lpfc_hba 0 61449 &disable_so_s5p_jpeg_runtime_resume_fndecl_61449
+disable_so_rsp_dmaaddr_fw_fcoe_els_ct_wr_61457 rsp_dmaaddr fw_fcoe_els_ct_wr 0 61457 NULL
+disable_so_pcsp_timer_update_fndecl_61473 pcsp_timer_update fndecl 0 61473 NULL
+disable_so_i8042_start_time_vardecl_i8042_h_61479 i8042_start_time vardecl_i8042.h 0 61479 NULL nohasharray
+disable_so_insert_into_bitmap_fndecl_61479 insert_into_bitmap fndecl 0 61479 &disable_so_i8042_start_time_vardecl_i8042_h_61479
+disable_so_xclkmaxrasdelay_pll_ct_61489 xclkmaxrasdelay pll_ct 0 61489 NULL
+disable_so_ioa_cb_bus_addr_pmcraid_cmd_61490 ioa_cb_bus_addr pmcraid_cmd 0 61490 NULL
+disable_so_sis_ata16_program_timings_fndecl_61491 sis_ata16_program_timings fndecl 2 61491 NULL
+disable_so_read_addr_stride___queue_61493 read_addr_stride __queue 0 61493 NULL
+disable_so_w1_timeout_vardecl_w1_c_61497 w1_timeout vardecl_w1.c 0 61497 NULL nohasharray
+disable_so_beacon_init_val_iwl_rxon_time_cmd_61497 beacon_init_val iwl_rxon_time_cmd 0 61497 &disable_so_w1_timeout_vardecl_w1_c_61497
+disable_so_split_timeout_lo_fw_card_61499 split_timeout_lo fw_card 0 61499 NULL
+disable_so_nla_find_fndecl_61508 nla_find fndecl 2 61508 NULL
+disable_so_timer_period_frag_pcxhr_stream_61512 timer_period_frag pcxhr_stream 0 61512 NULL
+disable_so_addr_hi_tg3_rx_buffer_desc_61522 addr_hi tg3_rx_buffer_desc 0 61522 NULL
+disable_so_i_uid_ext3_inode_61529 i_uid ext3_inode 0 61529 NULL nohasharray
+disable_so_r30_val_fc2580_freq_regs_61529 r30_val fc2580_freq_regs 0 61529 &disable_so_i_uid_ext3_inode_61529
+disable_so_i_delayed_blks_xfs_inode_61540 i_delayed_blks xfs_inode 0 61540 NULL nohasharray
+disable_so_aes_set_key_fndecl_61540 aes_set_key fndecl 0-3 61540 &disable_so_i_delayed_blks_xfs_inode_61540
+disable_so_loc_addr_nes_cm_listener_61541 loc_addr nes_cm_listener 0 61541 NULL
+disable_so_addr_w6692_hw_61546 addr w6692_hw 0 61546 NULL
+disable_so_mvs_write_port_vsr_addr_fndecl_61549 mvs_write_port_vsr_addr fndecl 3 61549 NULL
+disable_so_s_addr_per_block_bits_ext3_sb_info_61550 s_addr_per_block_bits ext3_sb_info 0 61550 NULL
+disable_so_o2net_set_nodelay_fndecl_61551 o2net_set_nodelay fndecl 0 61551 NULL
+disable_so_mlx5_ib_query_gid_fndecl_61553 mlx5_ib_query_gid fndecl 2-3 61553 NULL
+disable_so_pdl_paddr_hp100_ring_61561 pdl_paddr hp100_ring 0 61561 NULL
+disable_so_pci_bus_read_dev_vendor_id_fndecl_61562 pci_bus_read_dev_vendor_id fndecl 2 61562 NULL
+disable_so_fs16_to_cpu_fndecl_61568 fs16_to_cpu fndecl 0-2 61568 NULL
+disable_so_prandom_u32_state_fndecl_61582 prandom_u32_state fndecl 0 61582 NULL
+disable_so_high_bits_word_at_a_time_61595 high_bits word_at_a_time 0 61595 NULL
+disable_so_broadsheet_spiflash_op_on_address_fndecl_61596 broadsheet_spiflash_op_on_address fndecl 0-2-3 61596 NULL
+disable_so_device_create_fndecl_61600 device_create fndecl 3 61600 NULL
+disable_so_mce_wrmsrl_fndecl_61602 mce_wrmsrl fndecl 2 61602 NULL
+disable_so_jiffies_to_msecs_fndecl_61603 jiffies_to_msecs fndecl 0-1 61603 NULL
+disable_so_desc_card_addr_qla4_83xx_minidump_entry_rdmem_pex_dma_61605 desc_card_addr qla4_83xx_minidump_entry_rdmem_pex_dma 0 61605 NULL
+disable_so_remote_cm_response_timeout_ib_cm_req_param_61617 remote_cm_response_timeout ib_cm_req_param 0 61617 NULL
+disable_so_i_ctime_ocfs2_dinode_61629 i_ctime ocfs2_dinode 0 61629 NULL
+disable_so_uac_clock_selector_set_val_fndecl_61640 uac_clock_selector_set_val fndecl 2-0 61640 NULL
+disable_so_throtl_schedule_pending_timer_fndecl_61645 throtl_schedule_pending_timer fndecl 2 61645 NULL
+disable_so_t_nsec_xfs_ictimestamp_61648 t_nsec xfs_ictimestamp 0 61648 NULL
+disable_so_hashbits_rpc_cred_cache_61651 hashbits rpc_cred_cache 0 61651 NULL
+disable_so_iscsi_nacl_attrib_show_nopin_response_timeout_fndecl_61655 iscsi_nacl_attrib_show_nopin_response_timeout fndecl 0 61655 NULL
+disable_so_address_SG64ENTRY_61656 address SG64ENTRY 0 61656 NULL
+disable_so_cputime_advance_fndecl_61661 cputime_advance fndecl 2 61661 NULL
+disable_so_ts_delay_pressure_vardecl_ucb1400_ts_c_61663 ts_delay_pressure vardecl_ucb1400_ts.c 0 61663 NULL
+disable_so_mapaddr_skge_element_61673 mapaddr skge_element 0 61673 NULL
+disable_so_resetcal_timer_ath_ani_61692 resetcal_timer ath_ani 0 61692 NULL
+disable_so_btrfs_check_uuid_tree_entry_fndecl_61694 btrfs_check_uuid_tree_entry fndecl 4 61694 NULL
+disable_so_tuner_addr_tm6000_core_61695 tuner_addr tm6000_core 0 61695 NULL
+disable_so_last_msgtime_vardecl_ide_io_c_61702 last_msgtime vardecl_ide-io.c 0 61702 NULL
+disable_so_hpi_sample_clock_get_auto_fndecl_61704 hpi_sample_clock_get_auto fndecl 1-0 61704 NULL
+disable_so_ext4_find_delayed_extent_fndecl_61709 ext4_find_delayed_extent fndecl 0 61709 NULL
+disable_so_freq_offset_khz_uhf_dib0090_config_61716 freq_offset_khz_uhf dib0090_config 0 61716 NULL
+disable_so_sha1_generic_block_fn_fndecl_61724 sha1_generic_block_fn fndecl 3 61724 NULL
+disable_so_xc4000_get_signal_fndecl_61727 xc4000_get_signal fndecl 0 61727 NULL
+disable_so_vf_addr_hi_bnx2x_vf_mbx_61734 vf_addr_hi bnx2x_vf_mbx 0 61734 NULL nohasharray
+enable_so_exit_info_2_vmcb_control_area_61734 exit_info_2 vmcb_control_area 0 61734 &disable_so_vf_addr_hi_bnx2x_vf_mbx_61734
+disable_so_pcxhr_update_timer_pos_fndecl_61736 pcxhr_update_timer_pos fndecl 3 61736 NULL nohasharray
+disable_so_adis16480_set_filter_freq_fndecl_61736 adis16480_set_filter_freq fndecl 0 61736 &disable_so_pcxhr_update_timer_pos_fndecl_61736 nohasharray
+disable_so_xfs_daddr_to_agbno_fndecl_61736 xfs_daddr_to_agbno fndecl 0-2 61736 &disable_so_adis16480_set_filter_freq_fndecl_61736
+disable_so_stb0899_calc_derot_time_fndecl_61753 stb0899_calc_derot_time fndecl 0-1 61753 NULL nohasharray
+disable_so_fb_end_aligned_physaddr_osd_info_61753 fb_end_aligned_physaddr osd_info 0 61753 &disable_so_stb0899_calc_derot_time_fndecl_61753
+disable_so_ssb_calc_clock_rate_fndecl_61754 ssb_calc_clock_rate fndecl 0-3-2 61754 NULL nohasharray
+disable_so_seq_amdgpu_fence_61754 seq amdgpu_fence 0 61754 &disable_so_ssb_calc_clock_rate_fndecl_61754
+disable_so_disable_irq_nosync_fndecl_61758 disable_irq_nosync fndecl 1 61758 NULL
+disable_so_nft_dump_register_fndecl_61766 nft_dump_register fndecl 0 61766 NULL
+disable_so_file_remove_suid_fndecl_61769 file_remove_suid fndecl 0 61769 NULL
+disable_so_ltr501_als_write_samp_freq_fndecl_61771 ltr501_als_write_samp_freq fndecl 0 61771 NULL
+disable_so_pixclock_my_timming_61772 pixclock my_timming 0 61772 NULL
+disable_so_rtl818x_iowrite8_fndecl_61778 rtl818x_iowrite8 fndecl 3 61778 NULL
+disable_so_bql_show_hold_time_fndecl_61783 bql_show_hold_time fndecl 0 61783 NULL
+disable_so_db_addr_mlx4_ib_create_srq_61795 db_addr mlx4_ib_create_srq 0 61795 NULL
+disable_so_lgdt3306a_sleep_fndecl_61796 lgdt3306a_sleep fndecl 0 61796 NULL
+disable_so_cpuid_nent_kvm_vcpu_arch_61798 cpuid_nent kvm_vcpu_arch 0 61798 NULL
+disable_so_addr_hdac_device_61804 addr hdac_device 0 61804 NULL
+disable_so_center_freq_stb0899_internal_61821 center_freq stb0899_internal 0 61821 NULL
+disable_so_addr_cqicb_61823 addr cqicb 0 61823 NULL
+disable_so_oprofile_hrtimer_setup_fndecl_61824 oprofile_hrtimer_setup fndecl 0 61824 NULL
+disable_so_tvaudio_addr_em28xx_board_61828 tvaudio_addr em28xx_board 0 61828 NULL
+disable_so__ocrdma_pd_mgr_get_bitmap_fndecl_61833 _ocrdma_pd_mgr_get_bitmap fndecl 0 61833 NULL
+disable_so_rd08_nvkm_ofuncs_61836 rd08 nvkm_ofuncs 0-2 61836 NULL
+disable_so_clipped_freq_cpufreq_cooling_device_61837 clipped_freq cpufreq_cooling_device 0 61837 NULL
+disable_so_config_addend_stmmac_hwtimestamp_61840 config_addend stmmac_hwtimestamp 2 61840 NULL
+disable_so_crypto_authenc_givencrypt_fndecl_61841 crypto_authenc_givencrypt fndecl 0 61841 NULL
+disable_so_freq_table_get_index_fndecl_61842 freq_table_get_index fndecl 2 61842 NULL
+disable_so_qla2x00_issue_iocb_timeout_fndecl_61848 qla2x00_issue_iocb_timeout fndecl 0-3-5 61848 NULL
+disable_so_afs_vlocation_timeout_vardecl_vlocation_c_61850 afs_vlocation_timeout vardecl_vlocation.c 0 61850 NULL
+disable_so_dev_addr__drm_via_descriptor_61860 dev_addr _drm_via_descriptor 0 61860 NULL
+disable_so_inet_confirm_addr_fndecl_61869 inet_confirm_addr fndecl 0 61869 NULL nohasharray
+enable_so__eip_x86_emulate_ctxt_61869 _eip x86_emulate_ctxt 0 61869 &disable_so_inet_confirm_addr_fndecl_61869
+disable_so_ethtool_get_perm_addr_fndecl_61870 ethtool_get_perm_addr fndecl 0 61870 NULL
+disable_so_sctp_ulpevent_make_peer_addr_change_fndecl_61876 sctp_ulpevent_make_peer_addr_change fndecl 6 61876 NULL nohasharray
+disable_so_calc_lanman_hash_fndecl_61876 calc_lanman_hash fndecl 0 61876 &disable_so_sctp_ulpevent_make_peer_addr_change_fndecl_61876
+disable_so_init_blkcipher_desc_fndecl_61877 init_blkcipher_desc fndecl 0-3-5 61877 NULL
+disable_so_address_acpi_pci_routing_table_61886 address acpi_pci_routing_table 0 61886 NULL
+disable_so_tx_tone_freq_b43_phy_lp_61888 tx_tone_freq b43_phy_lp 0 61888 NULL
+disable_so___ip6addrlbl_match_fndecl_61894 __ip6addrlbl_match fndecl 4-5 61894 NULL
+disable_so_irq_domain_free_irqs_top_fndecl_61898 irq_domain_free_irqs_top fndecl 2-3 61898 NULL
+disable_so_freq_tm6000_core_61902 freq tm6000_core 0 61902 NULL
+disable_so_addr_lo_ocrdma_sge_61909 addr_lo ocrdma_sge 0 61909 NULL
+disable_so_ctlr_ka_time_fcoe_ctlr_61922 ctlr_ka_time fcoe_ctlr 0 61922 NULL
+disable_so_mcryptd_hash_final_enqueue_fndecl_61941 mcryptd_hash_final_enqueue fndecl 0 61941 NULL
+disable_so_dn_match_addr_fndecl_61944 dn_match_addr fndecl 1 61944 NULL
+disable_so_mac_time_b43legacy_rxhdr_fw3_61952 mac_time b43legacy_rxhdr_fw3 0 61952 NULL nohasharray
+disable_so_force_static_address_write_fndecl_61952 force_static_address_write fndecl 3 61952 &disable_so_mac_time_b43legacy_rxhdr_fw3_61952
+disable_so_delay_adp5588_kpad_61963 delay adp5588_kpad 0 61963 NULL
+disable_so_cg_time_ufs_cylinder_group_61969 cg_time ufs_cylinder_group 0 61969 NULL
+disable_so_pll_freq_ene_device_61971 pll_freq ene_device 0 61971 NULL
+disable_so_iscsit_na_random_datain_seq_offsets_fndecl_61975 iscsit_na_random_datain_seq_offsets fndecl 0 61975 NULL
+disable_so_addr_dme1737_data_61978 addr dme1737_data 0 61978 NULL
+disable_so_crypto_probing_notify_fndecl_61991 crypto_probing_notify fndecl 0-1 61991 NULL
+disable_so_offset_fw_address_handler_61992 offset fw_address_handler 0 61992 NULL
+disable_so_vsel_addr_palmas_regs_info_61997 vsel_addr palmas_regs_info 0 61997 NULL
+disable_so_last_time_ecne_reduced_sctp_transport_61998 last_time_ecne_reduced sctp_transport 0 61998 NULL
+disable_so_units_sprintf_fndecl_62002 units_sprintf fndecl 0 62002 NULL
+disable_so_gpu_addr_radeon_uvd_62004 gpu_addr radeon_uvd 0 62004 NULL
+disable_so_adc_freq_stmpe_touch_62006 adc_freq stmpe_touch 0 62006 NULL
+disable_so_dosr_aic31xx_rate_divs_62015 dosr aic31xx_rate_divs 0 62015 NULL
+disable_so_tsc_khz_vardecl_62031 tsc_khz vardecl 0 62031 NULL
+disable_so_accounting_timestamp_dev_pm_info_62040 accounting_timestamp dev_pm_info 0 62040 NULL nohasharray
+disable_so_sensor_addr_mcam_camera_62040 sensor_addr mcam_camera 0 62040 &disable_so_accounting_timestamp_dev_pm_info_62040
+disable_so___sw_hweight16_fndecl_62046 __sw_hweight16 fndecl 1-0 62046 NULL
+disable_so_st_atime_stat_62052 st_atime stat 0 62052 NULL nohasharray
+disable_so_dsi_pll_div_dsi_mnp_62052 dsi_pll_div dsi_mnp 0 62052 &disable_so_st_atime_stat_62052
+disable_so_ath5k_hw_write_ofdm_timings_fndecl_62063 ath5k_hw_write_ofdm_timings fndecl 0 62063 NULL
+disable_so_addr_dn_neigh_62067 addr dn_neigh 0 62067 NULL
+disable_so_small_buf_q_alloc_phy_addr_ql3_adapter_62071 small_buf_q_alloc_phy_addr ql3_adapter 0 62071 NULL
+disable_so_in6_dump_addrs_fndecl_62073 in6_dump_addrs fndecl 0 62073 NULL nohasharray
+disable_so_toggle_hw_mce_inject_fndecl_62073 toggle_hw_mce_inject fndecl 0-1 62073 &disable_so_in6_dump_addrs_fndecl_62073
+disable_so_addr_mthca_data_seg_62083 addr mthca_data_seg 0 62083 NULL
+disable_so_err_interrupt_orion_mdio_dev_62099 err_interrupt orion_mdio_dev 0 62099 NULL
+disable_so_callback_snd_timer_instance_62100 callback snd_timer_instance 2-3 62100 NULL
+disable_so_acc_jiffies_ati_remote_62109 acc_jiffies ati_remote 0 62109 NULL
+disable_so_regcache_rbtree_drop_fndecl_62111 regcache_rbtree_drop fndecl 2-3 62111 NULL
+disable_so_post_div_radeon_pll_62120 post_div radeon_pll 0 62120 NULL
+disable_so_local_addr_rds_atomic_args_62123 local_addr rds_atomic_args 0 62123 NULL
+disable_so_rds_tcp_laddr_check_fndecl_62131 rds_tcp_laddr_check fndecl 1 62131 NULL
+disable_so_sock_get_timestampns_fndecl_62145 sock_get_timestampns fndecl 0 62145 NULL
+disable_so_beacon_time_stamp_il_rx_phy_res_62147 beacon_time_stamp il_rx_phy_res 0 62147 NULL
+disable_so_panel_power_up_delay_cdv_intel_dp_62150 panel_power_up_delay cdv_intel_dp 0 62150 NULL
+disable_so_dma_addr_solo_p2m_desc_62151 dma_addr solo_p2m_desc 0 62151 NULL
+disable_so_hangcheck_tick_vardecl_hangcheck_timer_c_62154 hangcheck_tick vardecl_hangcheck-timer.c 0 62154 NULL nohasharray
+disable_so_kbd_backlight_timeout_store_fndecl_62154 kbd_backlight_timeout_store fndecl 0-4 62154 &disable_so_hangcheck_tick_vardecl_hangcheck_timer_c_62154
+disable_so_xhci_call_host_update_timeout_for_endpoint_fndecl_62155 xhci_call_host_update_timeout_for_endpoint fndecl 0 62155 NULL
+disable_so_read_block_bitmap_fndecl_62158 read_block_bitmap fndecl 2 62158 NULL
+disable_so_ceph_aes_decrypt_fndecl_62159 ceph_aes_decrypt fndecl 2-6 62159 NULL
+disable_so_mpll_func_cntl_2_si_clock_registers_62165 mpll_func_cntl_2 si_clock_registers 0 62165 NULL
+disable_so_s01_img_ir_timing_regvals_62168 s01 img_ir_timing_regvals 0 62168 NULL
+disable_so_xmit_hashtype_vardecl_bond_main_c_62175 xmit_hashtype vardecl_bond_main.c 0 62175 NULL
+disable_so_seconds_v4l2_timecode_62177 seconds v4l2_timecode 0 62177 NULL
+disable_so_dma_addr_t3_wq_62178 dma_addr t3_wq 0 62178 NULL
+disable_so_cryptd_hash_export_fndecl_62185 cryptd_hash_export fndecl 0 62185 NULL
+disable_so_get_qam_signal_to_noise_fndecl_62191 get_qam_signal_to_noise fndecl 0 62191 NULL
+disable_so_dp_daddr_rds_ib_connect_private_62196 dp_daddr rds_ib_connect_private 0 62196 NULL
+disable_so_max77693_muic_set_debounce_time_fndecl_62200 max77693_muic_set_debounce_time fndecl 0-2 62200 NULL
+disable_so_bch_time_stats_update_fndecl_62214 bch_time_stats_update fndecl 2 62214 NULL
+disable_so_t4_set_addr_hash_fndecl_62216 t4_set_addr_hash fndecl 0-2-3 62216 NULL
+disable_so_proc_disconnectsignal_compat_fndecl_62217 proc_disconnectsignal_compat fndecl 0 62217 NULL
+disable_so_rtsx_pci_switch_clock_fndecl_62219 rtsx_pci_switch_clock fndecl 2-0 62219 NULL
+disable_so_addr_chip_data_62229 addr chip_data 0 62229 NULL
+disable_so_timer_abs_periods_pcxhr_stream_62230 timer_abs_periods pcxhr_stream 0 62230 NULL
+disable_so_tty_ldisc_lock_pair_timeout_fndecl_62232 tty_ldisc_lock_pair_timeout fndecl 3 62232 NULL
+disable_so_fd_pppol2tpv3in6_addr_62243 fd pppol2tpv3in6_addr 0 62243 NULL
+disable_so_hrtimer_start_range_ns_fndecl_62253 hrtimer_start_range_ns fndecl 3 62253 NULL
+disable_so_r9_kvm_regs_62259 r9 kvm_regs 0 62259 NULL
+disable_so_supported_addrs_sctp_pf_62261 supported_addrs sctp_pf 0 62261 NULL
+disable_so_xfs_bmapi_delay_fndecl_62277 xfs_bmapi_delay fndecl 0-2-3 62277 NULL
+disable_so_tseg2_pucan_timing_slow_62290 tseg2 pucan_timing_slow 0 62290 NULL
+disable_so_mtime_ncp_cache_head_62294 mtime ncp_cache_head 0 62294 NULL
+disable_so_get_ramp_delay_fndecl_62302 get_ramp_delay fndecl 0 62302 NULL
+disable_so_decrypt_crypto_aead_62305 decrypt crypto_aead 0 62305 NULL
+disable_so_paddr_mmd_fw_ldst_mdio_62306 paddr_mmd fw_ldst_mdio 0 62306 NULL
+disable_so_start_address___osdv1_cdb_addr_len_62309 start_address __osdv1_cdb_addr_len 0 62309 NULL
+disable_so_freq_as10x_tune_args_62312 freq as10x_tune_args 0 62312 NULL nohasharray
+e_rtt_min_westwood_62312 rtt_min westwood 0 62312 &disable_so_freq_as10x_tune_args_62312
+disable_so_timestamp_low_rtl_stats_62314 timestamp_low rtl_stats 0 62314 NULL
+disable_so_uid_fuse_in_header_62319 uid fuse_in_header 0 62319 NULL
+disable_so_bfa_fcs_rport_del_timeout_vardecl_bfa_fcs_rport_c_62320 bfa_fcs_rport_del_timeout vardecl_bfa_fcs_rport.c 0 62320 NULL nohasharray
+disable_so_argidx_mc_buffer_62320 argidx mc_buffer 0 62320 &disable_so_bfa_fcs_rport_del_timeout_vardecl_bfa_fcs_rport_c_62320
+disable_so_ci_recover_timer_dlm_config_info_62321 ci_recover_timer dlm_config_info 0 62321 NULL nohasharray
+disable_so_gart_bus_addr_agp_bridge_data_62321 gart_bus_addr agp_bridge_data 0 62321 &disable_so_ci_recover_timer_dlm_config_info_62321
+disable_so_ci_get_ddr3_mclk_frequency_ratio_fndecl_62335 ci_get_ddr3_mclk_frequency_ratio fndecl 0-1 62335 NULL
+disable_so_addr_flags_ec_params_i2c_passthru_msg_62337 addr_flags ec_params_i2c_passthru_msg 0 62337 NULL
+disable_so_mISDN_clock_get_fndecl_62339 mISDN_clock_get fndecl 0 62339 NULL nohasharray
+disable_so_beacon_paddr_ath10k_vif_62339 beacon_paddr ath10k_vif 0 62339 &disable_so_mISDN_clock_get_fndecl_62339 nohasharray
+disable_so_tda10023_writereg_fndecl_62339 tda10023_writereg fndecl 3 62339 &disable_so_beacon_paddr_ath10k_vif_62339
+disable_so___iowrite32_copy_fndecl_62342 __iowrite32_copy fndecl 3 62342 NULL
+disable_so_bit_offset_acpi_pct_register_62348 bit_offset acpi_pct_register 0 62348 NULL
+disable_so_ccp_aes_encrypt_fndecl_62350 ccp_aes_encrypt fndecl 0 62350 NULL
+disable_so_crypto_cbc_module_init_fndecl_62352 crypto_cbc_module_init fndecl 0 62352 NULL
+disable_so_decode_attr_time_fndecl_62359 decode_attr_time fndecl 0 62359 NULL
+disable_so_btrfs_set_dev_replace_time_stopped_fndecl_62364 btrfs_set_dev_replace_time_stopped fndecl 3 62364 NULL
+disable_so_i2c_addr_stv0900_internal_62365 i2c_addr stv0900_internal 0 62365 NULL
+disable_so_sys_setfsgid16_fndecl_62369 sys_setfsgid16 fndecl 0-1 62369 NULL
+disable_so__zd_iowrite32v_locked_fndecl_62374 _zd_iowrite32v_locked fndecl 3-0 62374 NULL nohasharray
+disable_so_C_SYSC_semtimedop_fndecl_62374 C_SYSC_semtimedop fndecl 0-1-3 62374 &disable_so__zd_iowrite32v_locked_fndecl_62374
+disable_so_native_mode_display_timings_62375 native_mode display_timings 0 62375 NULL
+disable_so_wm8400_set_dai_clkdiv_fndecl_62376 wm8400_set_dai_clkdiv fndecl 3 62376 NULL
+disable_so_phy_fixed_addr_vardecl_fixed_phy_c_62380 phy_fixed_addr vardecl_fixed_phy.c 0 62380 NULL
+disable_so_lo_phys_addr_62383 lo phys_addr 0 62383 NULL
+disable_so_schedule_resp_fndecl_62394 schedule_resp fndecl 4-3 62394 NULL
+disable_so_tw_ts_recent_tcp_timewait_sock_62395 tw_ts_recent tcp_timewait_sock 0 62395 NULL
+disable_so_bus_addr_videobuf_dmabuf_62402 bus_addr videobuf_dmabuf 0 62402 NULL
+disable_so_i_uid_exofs_fcb_62409 i_uid exofs_fcb 0 62409 NULL
+disable_so_pc_clock_getres_fndecl_62422 pc_clock_getres fndecl 1 62422 NULL
+disable_so_lock_addr_ulp_mem_io_62424 lock_addr ulp_mem_io 0 62424 NULL
+disable_so___set_radio_freq_fndecl_62425 __set_radio_freq fndecl 2 62425 NULL
+disable_so_ath5k_hw_set_cts_timeout_fndecl_62429 ath5k_hw_set_cts_timeout fndecl 2 62429 NULL
+disable_so_ni_program_memory_timing_parameters_fndecl_62435 ni_program_memory_timing_parameters fndecl 0 62435 NULL
+disable_so_stv6110_set_frequency_fndecl_62438 stv6110_set_frequency fndecl 2 62438 NULL
+disable_so_padata_index_to_cpu_fndecl_62451 padata_index_to_cpu fndecl 0-2 62451 NULL
+disable_so_btree_insert_fndecl_62456 btree_insert fndecl 5 62456 NULL
+disable_so_time_hfa384x_rx_frame_62462 time hfa384x_rx_frame 0 62462 NULL
+disable_so_qat_alg_ablkcipher_init_dec_fndecl_62464 qat_alg_ablkcipher_init_dec fndecl 4 62464 NULL
+disable_so_addr_mcp23s08_62465 addr mcp23s08 0 62465 NULL
+disable_so_faddr_ip_options_62466 faddr ip_options 0 62466 NULL nohasharray
+disable_so_ufs_get_inode_gid_fndecl_62466 ufs_get_inode_gid fndecl 0 62466 &disable_so_faddr_ip_options_62466
+disable_so_min_rnr_timer_ib_qp_attr_62467 min_rnr_timer ib_qp_attr 0 62467 NULL
+disable_so_update_timestamp_of_queue_fndecl_62482 update_timestamp_of_queue fndecl 2 62482 NULL
+disable_so_center_freq1_cfg80211_chan_def_62486 center_freq1 cfg80211_chan_def 0 62486 NULL
+disable_so_watchdog_set_timeout_fndecl_62487 watchdog_set_timeout fndecl 0 62487 NULL
+disable_so_bitmap_parselist_user_fndecl_62492 bitmap_parselist_user fndecl 0-2-4 62492 NULL
+disable_so_tuner_address_tda1004x_config_62514 tuner_address tda1004x_config 0 62514 NULL
+disable_so_src_addr_l_wcn36xx_dxe_desc_62516 src_addr_l wcn36xx_dxe_desc 0 62516 NULL
+disable_so_loadaddr_object_info_62521 loadaddr object_info 0 62521 NULL
+disable_so_store_cpumask_fndecl_62525 store_cpumask fndecl 4-0 62525 NULL
+disable_so_sysctl_llc2_rej_timeout_vardecl_62533 sysctl_llc2_rej_timeout vardecl 0 62533 NULL nohasharray
+disable_so_symbol_rate_stv0900_signal_info_62533 symbol_rate stv0900_signal_info 0 62533 &disable_so_sysctl_llc2_rej_timeout_vardecl_62533
+disable_so_get_pending_timer_val_fndecl_62535 get_pending_timer_val fndecl 0-1 62535 NULL
+disable_so_acpi_tb_init_generic_address_fndecl_62545 acpi_tb_init_generic_address fndecl 2-3-4 62545 NULL
+disable_so_laddr_xt_tproxy_target_info_62546 laddr xt_tproxy_target_info 0 62546 NULL
+disable_so_bitmaps_btrfs_io_ctl_62547 bitmaps btrfs_io_ctl 0 62547 NULL
+disable_so_phy_tx_tone_freq_brcms_phy_62552 phy_tx_tone_freq brcms_phy 0 62552 NULL
+disable_so_rdaddr_irnet_socket_62558 rdaddr irnet_socket 0 62558 NULL
+disable_so_uid_ucred_62560 uid ucred 0 62560 NULL
+disable_so_mod_delayed_work_fndecl_62563 mod_delayed_work fndecl 3 62563 NULL
+disable_so_base_pfn_var_mtrr_range_state_62564 base_pfn var_mtrr_range_state 0 62564 NULL
+disable_so_cx_pt_regs_62574 cx pt_regs 0 62574 NULL
+disable_so_cpuid_device_destroy_fndecl_62575 cpuid_device_destroy fndecl 1 62575 NULL
+disable_so_pm_print_times_show_fndecl_62583 pm_print_times_show fndecl 0 62583 NULL
+disable_so_blkaddr_discard_entry_62585 blkaddr discard_entry 0 62585 NULL
+disable_so_wl1271_acx_group_address_tbl_fndecl_62591 wl1271_acx_group_address_tbl fndecl 0 62591 NULL nohasharray
+disable_so_rangelow_v4l2_hw_freq_seek_62591 rangelow v4l2_hw_freq_seek 0 62591 &disable_so_wl1271_acx_group_address_tbl_fndecl_62591
+disable_so_crc32_le_fndecl_62601 crc32_le fndecl 0-1-3 62601 NULL
+disable_so_freq_cx23885_dev_62605 freq cx23885_dev 0 62605 NULL
+disable_so_sysctl_netrom_transport_no_activity_timeout_vardecl_62608 sysctl_netrom_transport_no_activity_timeout vardecl 0 62608 NULL
+disable_so_xfs_btree_new_iroot_fndecl_62611 xfs_btree_new_iroot fndecl 0 62611 NULL
+disable_so_tproxy_handle_time_wait6_fndecl_62612 tproxy_handle_time_wait6 fndecl 3-2 62612 NULL
+disable_so_sys_getpgid_fndecl_62613 sys_getpgid fndecl 0-1 62613 NULL
+disable_so_next_td_addr_c67x00_hcd_62615 next_td_addr c67x00_hcd 0 62615 NULL
+disable_so_hdspm_aes_sync_check_fndecl_62629 hdspm_aes_sync_check fndecl 2 62629 NULL
+disable_so_ebitmap_node_get_bit_fndecl_62633 ebitmap_node_get_bit fndecl 2 62633 NULL
+disable_so_nilfs_palloc_get_bitmap_block_fndecl_62635 nilfs_palloc_get_bitmap_block fndecl 0-2 62635 NULL
+disable_so_spll_ref_div_rv6xx_power_info_62638 spll_ref_div rv6xx_power_info 0 62638 NULL nohasharray
+disable_so_center_freq_seg1_idx_ieee80211_vht_operation_62638 center_freq_seg1_idx ieee80211_vht_operation 0 62638 &disable_so_spll_ref_div_rv6xx_power_info_62638
+disable_so_swc_base_asd_ha_addrspace_62642 swc_base asd_ha_addrspace 0 62642 NULL nohasharray
+disable_so__abb5zes3_rtc_update_timer_fndecl_62642 _abb5zes3_rtc_update_timer fndecl 0 62642 &disable_so_swc_base_asd_ha_addrspace_62642
+disable_so_cgcdiv_saa711x_state_62643 cgcdiv saa711x_state 0 62643 NULL
+disable_so_igmp_mod_timer_fndecl_62656 igmp_mod_timer fndecl 2 62656 NULL
+disable_so_write16_comm_runtime_62657 write16 comm_runtime 0 62657 NULL
+disable_so_sib_sid_sockaddr_ib_62658 sib_sid sockaddr_ib 0 62658 NULL
+disable_so_srx_service_sockaddr_rxrpc_62661 srx_service sockaddr_rxrpc 0 62661 NULL
+disable_so_sh_cmt_clocksource_read_fndecl_62671 sh_cmt_clocksource_read fndecl 0 62671 NULL
+disable_so_freq_saa7164_port_62674 freq saa7164_port 0 62674 NULL
+disable_so_nilfs_btree_node_lookup_fndecl_62675 nilfs_btree_node_lookup fndecl 2 62675 NULL
+disable_so_addr_1_qla8044_minidump_entry_rddfe_62676 addr_1 qla8044_minidump_entry_rddfe 0 62676 NULL
+disable_so_rtl_udelay_fndecl_62677 rtl_udelay fndecl 1 62677 NULL nohasharray
+disable_so_VTotal_xtimings_62677 VTotal xtimings 0 62677 &disable_so_rtl_udelay_fndecl_62677
+disable_so_ib_get_cached_gid_fndecl_62698 ib_get_cached_gid fndecl 2-3 62698 NULL
+disable_so_dvb_frontend_sleep_until_fndecl_62701 dvb_frontend_sleep_until fndecl 2 62701 NULL
+disable_so_i2c_address_stv6110_config_62706 i2c_address stv6110_config 0 62706 NULL
+disable_so_address_ihex_record_62713 address ihex_record 0 62713 NULL
+disable_so_next_rptr_gpu_addr_radeon_ring_62716 next_rptr_gpu_addr radeon_ring 0 62716 NULL
+disable_so_wusb_trust_timeout_store_fndecl_62719 wusb_trust_timeout_store fndecl 0-4 62719 NULL
+disable_so_add_bytes_to_bitmap_fndecl_62721 add_bytes_to_bitmap fndecl 0-3-4 62721 NULL
+disable_so_set_ethernet_addr_fndecl_62733 set_ethernet_addr fndecl 0 62733 NULL
+disable_so_nmsrs_kvm_msrs_62744 nmsrs kvm_msrs 0 62744 NULL
+disable_so_ant_div_control_ar9300_BaseExtension_1_62759 ant_div_control ar9300_BaseExtension_1 0 62759 NULL
+disable_so_padlock_sha_import_fndecl_62760 padlock_sha_import fndecl 0 62760 NULL
+disable_so_do_timerfd_settime_fndecl_62764 do_timerfd_settime fndecl 1 62764 NULL nohasharray
+disable_so_phy_addr_netdev_private_62764 phy_addr netdev_private 0 62764 &disable_so_do_timerfd_settime_fndecl_62764
+disable_so_bd_list_addr_lo_bnx2i_nop_out_request_62766 bd_list_addr_lo bnx2i_nop_out_request 0 62766 NULL
+disable_so_get_sndtimeo_l2cap_ops_62767 get_sndtimeo l2cap_ops 0 62767 NULL
+disable_so_active_jiffies_dev_pm_info_62774 active_jiffies dev_pm_info 0 62774 NULL
+disable_so_r5f_val_fc2580_freq_regs_62778 r5f_val fc2580_freq_regs 0 62778 NULL
+disable_so_ac97_clock_vardecl_via82xx_modem_c_62781 ac97_clock vardecl_via82xx_modem.c 0 62781 NULL
+disable_so_after_ctime_sec_nfsd4_change_info_62785 after_ctime_sec nfsd4_change_info 0 62785 NULL
+disable_so_vma_compute_subtree_gap_fndecl_62794 vma_compute_subtree_gap fndecl 0 62794 NULL
+disable_so_fll_freq_out_wm8350_data_62801 fll_freq_out wm8350_data 0 62801 NULL
+disable_so_nfs_map_group_to_gid_fndecl_62809 nfs_map_group_to_gid fndecl 0-3 62809 NULL
+disable_so_saddr_irnet_socket_62828 saddr irnet_socket 0 62828 NULL
+disable_so_fixed_mtrr_range_end_addr_fndecl_62835 fixed_mtrr_range_end_addr fndecl 2-0 62835 NULL
+disable_so_sis_program_udma_timings_fndecl_62837 sis_program_udma_timings fndecl 2 62837 NULL
+disable_so_timeout_lpfc_scsi_buf_62845 timeout lpfc_scsi_buf 0 62845 NULL
+disable_so_brp_inc_can_bittiming_const_62858 brp_inc can_bittiming_const 0 62858 NULL
+disable_so_timer_counter_tg3_62864 timer_counter tg3 0 62864 NULL
+disable_so_slave_addr_psb_intel_i2c_chan_62869 slave_addr psb_intel_i2c_chan 0 62869 NULL
+disable_so_mapaddr_rocker_desc_info_62870 mapaddr rocker_desc_info 0 62870 NULL
+disable_so_cid_addr_drv_ctl_io_62879 cid_addr drv_ctl_io 0 62879 NULL
+disable_so_ifreq_dibx000_bandwidth_config_62891 ifreq dibx000_bandwidth_config 0 62891 NULL
+disable_so_m_iw_freq_62894 m iw_freq 0 62894 NULL
+disable_so___nci_request_fndecl_62899 __nci_request fndecl 0 62899 NULL
+disable_so_tuner_addr_cx23885_dev_62908 tuner_addr cx23885_dev 0 62908 NULL
+disable_so_acpi_remove_address_space_handler_fndecl_62916 acpi_remove_address_space_handler fndecl 0-2 62916 NULL
+disable_so_vma_address_fndecl_62917 vma_address fndecl 0 62917 NULL
+disable_so_cg_spll_func_cntl_2_rv770_clock_registers_62925 cg_spll_func_cntl_2 rv770_clock_registers 0 62925 NULL
+disable_so_clear_state_gpu_addr_radeon_rlc_62934 clear_state_gpu_addr radeon_rlc 0 62934 NULL
+disable_so_timeout__x_config_parms_62944 timeout _x_config_parms 0 62944 NULL
+disable_so_vbackporch_v4l2_bt_timings_62951 vbackporch v4l2_bt_timings 0 62951 NULL
+disable_so_crypto_rfc4543_setkey_fndecl_62960 crypto_rfc4543_setkey fndecl 0-3 62960 NULL
+disable_so_xc_get_hsync_freq_fndecl_62961 xc_get_hsync_freq fndecl 0 62961 NULL
+disable_so_run_delayed_start_btrfs_delayed_ref_root_62962 run_delayed_start btrfs_delayed_ref_root 0 62962 NULL nohasharray
+disable_so_netxen_nic_pci_get_crb_addr_2M_fndecl_62962 netxen_nic_pci_get_crb_addr_2M fndecl 2 62962 &disable_so_run_delayed_start_btrfs_delayed_ref_root_62962
+disable_so_frac_top_pll_div_62988 frac_top pll_div 0 62988 NULL nohasharray
+disable_so_busaddr__CommandList_struct_62988 busaddr _CommandList_struct 0 62988 &disable_so_frac_top_pll_div_62988
+disable_so_buffer_paddr_ghes_62992 buffer_paddr ghes 0 62992 NULL
+disable_so_be32_to_cpu_n_fndecl_62994 be32_to_cpu_n fndecl 3 62994 NULL
+disable_so_ccp_sha_update_fndecl_63000 ccp_sha_update fndecl 0 63000 NULL
+disable_so_chipco_pctl_clockfreqlimit_fndecl_63008 chipco_pctl_clockfreqlimit fndecl 0 63008 NULL
+disable_so_sys_gettimeofday_fndecl_63009 sys_gettimeofday fndecl 0 63009 NULL
+disable_so_ext4_read_block_bitmap_fndecl_63029 ext4_read_block_bitmap fndecl 2 63029 NULL
+disable_so_sis900_interrupt_fndecl_63044 sis900_interrupt fndecl 1 63044 NULL
+disable_so_tv_usec_compat_timeval_63056 tv_usec compat_timeval 0 63056 NULL
+disable_so_timeout_ct_entry_24xx_63060 timeout ct_entry_24xx 0 63060 NULL
+disable_so_ib_reset_mad_timeout_fndecl_63061 ib_reset_mad_timeout fndecl 2 63061 NULL
+disable_so_register_lapic_address_fndecl_63066 register_lapic_address fndecl 1 63066 NULL
+disable_so_sgl_dma_addr_genwqe_sgl_63082 sgl_dma_addr genwqe_sgl 0 63082 NULL
+disable_so_nf_conntrack_hash_rnd_vardecl_63088 nf_conntrack_hash_rnd vardecl 0 63088 NULL
+disable_so_snd_emu10k1_ptr_write_fndecl_63094 snd_emu10k1_ptr_write fndecl 2-3-4 63094 NULL
+disable_so_index_svm_direct_access_msrs_63098 index svm_direct_access_msrs 0 63098 NULL
+disable_so_crypto_authenc_genicv_fndecl_63111 crypto_authenc_genicv fndecl 0 63111 NULL
+disable_so_pcf50633_rtc_set_time_fndecl_63123 pcf50633_rtc_set_time fndecl 0 63123 NULL
+disable_so_hsyn_pol_hdmi_timings_63136 hsyn_pol hdmi_timings 0 63136 NULL
+disable_so_ri_addr_gfs2_rindex_63138 ri_addr gfs2_rindex 0 63138 NULL
+disable_so_nr_oaktrail_hdmi_clock_63155 nr oaktrail_hdmi_clock 0 63155 NULL nohasharray
+disable_so_dma_addr_nic_63155 dma_addr nic 0 63155 &disable_so_nr_oaktrail_hdmi_clock_63155
+disable_so_dlm_hash2nodeid_fndecl_63162 dlm_hash2nodeid fndecl 2 63162 NULL
+disable_so_efx_enable_interrupts_fndecl_63163 efx_enable_interrupts fndecl 0 63163 NULL nohasharray
+disable_so_freq_offset_rt2x00_dev_63163 freq_offset rt2x00_dev 0 63163 &disable_so_efx_enable_interrupts_fndecl_63163
+disable_so_dma_addr_il_queue_63172 dma_addr il_queue 0 63172 NULL
+disable_so_buf_addr_hi_fcoe_bd_ctx_63176 buf_addr_hi fcoe_bd_ctx 0 63176 NULL
+disable_so_i2c_addr_lgdt3305_config_63179 i2c_addr lgdt3305_config 0 63179 NULL nohasharray
+disable_so_sched_addr_ath9k_hw_mci_63179 sched_addr ath9k_hw_mci 0 63179 &disable_so_i2c_addr_lgdt3305_config_63179
+disable_so_mic_x100_get_boot_addr_fndecl_63190 mic_x100_get_boot_addr fndecl 0 63190 NULL
+disable_so_i2c_clock_period_ivtv_options_63202 i2c_clock_period ivtv_options 0 63202 NULL
+disable_so_f2fs_init_crypto_fndecl_63218 f2fs_init_crypto fndecl 0 63218 NULL
+disable_so_snd_ymfpci_interrupt_fndecl_63224 snd_ymfpci_interrupt fndecl 1 63224 NULL
+disable_so_set_tsc_mode_fndecl_63231 set_tsc_mode fndecl 0-1 63231 NULL
+disable_so_update_crypto_ahash_63235 update crypto_ahash 0 63235 NULL
+disable_so_base_freq_stv0297_state_63242 base_freq stv0297_state 0 63242 NULL
+disable_so_mounted_uid_ncp_mount_data_63250 mounted_uid ncp_mount_data 0 63250 NULL
+disable_so_wall_clock_kvm_arch_63252 wall_clock kvm_arch 0 63252 NULL nohasharray
+disable_so_system_clock_counter_kfd_ioctl_get_clock_counters_args_63252 system_clock_counter kfd_ioctl_get_clock_counters_args 0 63252 &disable_so_wall_clock_kvm_arch_63252
+disable_so_r100_mm_wreg_slow_fndecl_63255 r100_mm_wreg_slow fndecl 2-3 63255 NULL
+disable_so_ocrdma_query_gid_fndecl_63259 ocrdma_query_gid fndecl 0-3 63259 NULL
+disable_so_sha1_mb_async_init_fndecl_63263 sha1_mb_async_init fndecl 0 63263 NULL
+disable_so_i_mtime_nsec_nilfs_inode_63266 i_mtime_nsec nilfs_inode 0 63266 NULL
+disable_so_s_pkt_delay_ipath_qp_63270 s_pkt_delay ipath_qp 0 63270 NULL
+disable_so_ecryptfs_read_update_atime_fndecl_63272 ecryptfs_read_update_atime fndecl 0 63272 NULL
+disable_so_seq_auto_out_pin_63274 seq auto_out_pin 0 63274 NULL
+disable_so_pmdown_time_show_fndecl_63283 pmdown_time_show fndecl 0 63283 NULL
+disable_so_pwm_freq_div_dib7000m_config_63285 pwm_freq_div dib7000m_config 0 63285 NULL
+disable_so_bit_width_acpi_generic_address_63286 bit_width acpi_generic_address 0 63286 NULL
+disable_so_addr_sg_entry_63287 addr sg_entry 0 63287 NULL
+disable_so_ocfs2_pack_timespec_fndecl_63293 ocfs2_pack_timespec fndecl 0 63293 NULL
+disable_so_ipv6_addr_label_fndecl_63298 ipv6_addr_label fndecl 3-4 63298 NULL
+disable_so_chgfreq_cs42l56_platform_data_63299 chgfreq cs42l56_platform_data 0 63299 NULL
+disable_so_sco_sock_set_timer_fndecl_63304 sco_sock_set_timer fndecl 2 63304 NULL nohasharray
+disable_so_skb_get_hash_fndecl_63304 skb_get_hash fndecl 0 63304 &disable_so_sco_sock_set_timer_fndecl_63304
+disable_so_timeout_tsk_mgmt_entry_63307 timeout tsk_mgmt_entry 0 63307 NULL
+disable_so_sysctl_slot_timeout_vardecl_63317 sysctl_slot_timeout vardecl 0 63317 NULL
+disable_so_set_sadb_address_fndecl_63320 set_sadb_address fndecl 2 63320 NULL
+disable_so_handle_frequent_errors_fndecl_63324 handle_frequent_errors fndecl 4 63324 NULL
+disable_so_last_ramp_up_time_bfad_itnim_s_63328 last_ramp_up_time bfad_itnim_s 0 63328 NULL
+disable_so_timeout_vardecl_xen_wdt_c_63339 timeout vardecl_xen_wdt.c 0 63339 NULL nohasharray
+disable_so_padlock_sha_export_fndecl_63339 padlock_sha_export fndecl 0 63339 &disable_so_timeout_vardecl_xen_wdt_c_63339
+disable_so_mt9t112_set_pll_dividers_fndecl_63341 mt9t112_set_pll_dividers fndecl 2-3-4-5-6-7-8-9-10-0 63341 NULL
+disable_so_uv_cpu_to_pnode_fndecl_63343 uv_cpu_to_pnode fndecl 0 63343 NULL
+disable_so_gsc_runtime_resume_fndecl_63355 gsc_runtime_resume fndecl 0 63355 NULL
+disable_so_pci_bus_find_capability_fndecl_63357 pci_bus_find_capability fndecl 0-2 63357 NULL
+disable_so_addr_af9013_reg_bit_63363 addr af9013_reg_bit 0 63363 NULL
+disable_so_ath5k_eeprom_bin2freq_fndecl_63364 ath5k_eeprom_bin2freq fndecl 0-2 63364 NULL
+disable_so_sd_mtime_stat_data_63370 sd_mtime stat_data 0 63370 NULL
+disable_so_next_hscb_busaddr_hardware_scb_63375 next_hscb_busaddr hardware_scb 0 63375 NULL nohasharray
+disable_so_cpufreq_set_policy_fndecl_63375 cpufreq_set_policy fndecl 0 63375 &disable_so_next_hscb_busaddr_hardware_scb_63375
+disable_so_cache_tsc_vardecl_max8925_core_c_63377 cache_tsc vardecl_max8925-core.c 0 63377 NULL
+disable_so_xtime_remainder_timekeeper_63380 xtime_remainder timekeeper 0 63380 NULL
+disable_so_st_uid___old_kernel_stat_63381 st_uid __old_kernel_stat 0 63381 NULL
+disable_so_timeout_b_tpm_vendor_specific_63382 timeout_b tpm_vendor_specific 0 63382 NULL
+disable_so_vol_bit_shift_anatop_regulator_63384 vol_bit_shift anatop_regulator 0 63384 NULL
+disable_so_msr_offset_intel_uncore_type_63385 msr_offset intel_uncore_type 0 63385 NULL
+disable_so_random_write_fndecl_63387 random_write fndecl 0-3 63387 NULL
+disable_so_bcma_chipco_watchdog_timer_set_ms_wdt_fndecl_63389 bcma_chipco_watchdog_timer_set_ms_wdt fndecl 2-0 63389 NULL
+disable_so__div_round_closest_fndecl_63400 _div_round_closest fndecl 0-3-2 63400 NULL
+disable_so_acpi_ut_strtoul64_fndecl_63410 acpi_ut_strtoul64 fndecl 0 63410 NULL
+disable_so_alarm_time_xgene_rtc_dev_63411 alarm_time xgene_rtc_dev 0 63411 NULL nohasharray
+disable_so_dynamic_ps_timeout_ieee80211_conf_63411 dynamic_ps_timeout ieee80211_conf 0 63411 &disable_so_alarm_time_xgene_rtc_dev_63411 nohasharray
+disable_so_split_timeout_cycles_fw_card_63411 split_timeout_cycles fw_card 0 63411 &disable_so_dynamic_ps_timeout_ieee80211_conf_63411
+disable_so_bitstream_get_bits_fndecl_63423 bitstream_get_bits fndecl 0-3 63423 NULL
+disable_so_tw_timeout_inet_timewait_sock_63424 tw_timeout inet_timewait_sock 0 63424 NULL
+disable_so_drbg_kcapi_hash_fndecl_63433 drbg_kcapi_hash fndecl 0 63433 NULL
+disable_so_wait_for_completion_interruptible_fndecl_63448 wait_for_completion_interruptible fndecl 0 63448 NULL
+disable_so_sys_clock_nanosleep_fndecl_63449 sys_clock_nanosleep fndecl 1 63449 NULL
+disable_so_nouveau_hw_get_clock_fndecl_63456 nouveau_hw_get_clock fndecl 0-2 63456 NULL
+disable_so_nilfs_btree_propagate_gc_fndecl_63460 nilfs_btree_propagate_gc fndecl 0 63460 NULL
+disable_so_crypto_xcbc_module_init_fndecl_63471 crypto_xcbc_module_init fndecl 0 63471 NULL
+disable_so_amradio_set_freq_fndecl_63479 amradio_set_freq fndecl 0-2 63479 NULL
+disable_so_task_getpgid_security_operations_63489 task_getpgid security_operations 0 63489 NULL nohasharray
+disable_so_crypto_register_akcipher_fndecl_63489 crypto_register_akcipher fndecl 0 63489 &disable_so_task_getpgid_security_operations_63489
+disable_so_netxen_nic_map_indirect_address_128M_fndecl_63490 netxen_nic_map_indirect_address_128M fndecl 2 63490 NULL
+disable_so_vnic_intr_coalescing_timer_set_fndecl_63494 vnic_intr_coalescing_timer_set fndecl 2 63494 NULL
+disable_so_chipset_settings_chipset_bus_clock_list_entry_63497 chipset_settings chipset_bus_clock_list_entry 0 63497 NULL
+disable_so_new_cycle_state_xhci_dequeue_state_63499 new_cycle_state xhci_dequeue_state 0 63499 NULL
+disable_so_radeon_legacy_set_engine_clock_fndecl_63512 radeon_legacy_set_engine_clock fndecl 2 63512 NULL
+disable_so_addr___ctrl_63513 addr __ctrl 0 63513 NULL
+disable_so_asix_get_phy_addr_fndecl_63534 asix_get_phy_addr fndecl 0 63534 NULL
+disable_so_time_in_queue_dm_stat_percpu_63541 time_in_queue dm_stat_percpu 0 63541 NULL
+disable_so_ufshcd_pltfrm_runtime_suspend_fndecl_63543 ufshcd_pltfrm_runtime_suspend fndecl 0 63543 NULL
+disable_so_spu_port_delay_if_spi_card_63548 spu_port_delay if_spi_card 0 63548 NULL nohasharray
+disable_so_cs_cpufreq_governor_dbs_fndecl_63548 cs_cpufreq_governor_dbs fndecl 0 63548 &disable_so_spu_port_delay_if_spi_card_63548
+disable_so_type_ceph_crypto_key_63565 type ceph_crypto_key 0 63565 NULL
+disable_so_bus_settle_time_blogic_adapter_63575 bus_settle_time blogic_adapter 0 63575 NULL
+disable_so_ref_divider_aty128_constants_63576 ref_divider aty128_constants 0 63576 NULL
+disable_so_remote_qpn_cm_timewait_info_63581 remote_qpn cm_timewait_info 0 63581 NULL
+disable_so_boot_time_fc_lport_63585 boot_time fc_lport 0 63585 NULL
+disable_so_imx_phy_reg_addressing_fndecl_63588 imx_phy_reg_addressing fndecl 0 63588 NULL
+disable_so_irq_set_irq_type_fndecl_63590 irq_set_irq_type fndecl 2-1 63590 NULL
+disable_so_appl_ptr_snd_rawmidi_runtime_63609 appl_ptr snd_rawmidi_runtime 0 63609 NULL
+disable_so_snd_hdac_regmap_write_raw_fndecl_63613 snd_hdac_regmap_write_raw fndecl 0-3-2 63613 NULL
+disable_so_control_addr_qla82xx_md_entry_cache_63615 control_addr qla82xx_md_entry_cache 0 63615 NULL
+disable_so_nla_put_ipaddr6_fndecl_63618 nla_put_ipaddr6 fndecl 0 63618 NULL
+disable_so_da9052_wdt_set_timeout_fndecl_63621 da9052_wdt_set_timeout fndecl 2-0 63621 NULL
+disable_so_cstime_signal_struct_63629 cstime signal_struct 0 63629 NULL
+disable_so_dm_region_hash_create_fndecl_63649 dm_region_hash_create fndecl 5-8-9 63649 NULL
+disable_so_krng_get_random_fndecl_63655 krng_get_random fndecl 3 63655 NULL
+disable_so_r9701_get_datetime_fndecl_63665 r9701_get_datetime fndecl 0 63665 NULL
+disable_so_crypto_rfc3686_crypt_fndecl_63668 crypto_rfc3686_crypt fndecl 0 63668 NULL
+disable_so_xen_late_init_mcelog_fndecl_63669 xen_late_init_mcelog fndecl 0 63669 NULL
+disable_so_prot_res_gid_63673 prot res_gid 0 63673 NULL
+disable_so_ext3_valid_block_bitmap_fndecl_63688 ext3_valid_block_bitmap fndecl 3 63688 NULL
+disable_so_smt_timer_start_fndecl_63691 smt_timer_start fndecl 3 63691 NULL nohasharray
+disable_so_port_tomoyo_inet_addr_info_63691 port tomoyo_inet_addr_info 0 63691 &disable_so_smt_timer_start_fndecl_63691
+disable_so_generic_check_addressable_fndecl_63696 generic_check_addressable fndecl 1-2 63696 NULL nohasharray
+disable_so___check_object_size_fndecl_63696 __check_object_size fndecl 2 63696 &disable_so_generic_check_addressable_fndecl_63696
+disable_so_r820t_sleep_fndecl_63717 r820t_sleep fndecl 0 63717 NULL
+disable_so_lgdt3305_read_signal_strength_fndecl_63720 lgdt3305_read_signal_strength fndecl 0 63720 NULL
+disable_so_wl1251_acx_sleep_auth_fndecl_63727 wl1251_acx_sleep_auth fndecl 0 63727 NULL
+disable_so_clk_out_div_ts2020_priv_63728 clk_out_div ts2020_priv 0 63728 NULL
+disable_so_sys_clock_adjtime_fndecl_63736 sys_clock_adjtime fndecl 1 63736 NULL
+disable_so_radio_addr_cx88_board_63745 radio_addr cx88_board 0 63745 NULL
+disable_so_input_print_bitmap_fndecl_63755 input_print_bitmap fndecl 0-2 63755 NULL
+disable_so_memstick_set_rw_addr_fndecl_63757 memstick_set_rw_addr fndecl 0 63757 NULL
+disable_so_simple_strtoll_fndecl_63758 simple_strtoll fndecl 0 63758 NULL
+disable_so___mv88e6xxx_read_addr_fndecl_63766 __mv88e6xxx_read_addr fndecl 0 63766 NULL
+disable_so_nf_conntrack_timeout_init_fndecl_63771 nf_conntrack_timeout_init fndecl 0 63771 NULL
+disable_so_ob_baseaddr_h_mvumi_hs_page4_63775 ob_baseaddr_h mvumi_hs_page4 0 63775 NULL
+disable_so_stored_addr_hi_amd_iommu_63784 stored_addr_hi amd_iommu 0 63784 NULL
+disable_so_HSyncEnd_xtimings_63785 HSyncEnd xtimings 0 63785 NULL
+disable_so_addr_h_xfer_desc_63789 addr_h xfer_desc 0 63789 NULL
+disable_so_i2c_address_stb6000_priv_63790 i2c_address stb6000_priv 0 63790 NULL
+disable_so_runtime_expires_cfs_bandwidth_63800 runtime_expires cfs_bandwidth 0 63800 NULL
+disable_so_account_steal_time_fndecl_63806 account_steal_time fndecl 1 63806 NULL
+disable_so_sleep_max_sched_statistics_63826 sleep_max sched_statistics 0 63826 NULL
+disable_so_usecs_to_jiffies_fndecl_63832 usecs_to_jiffies fndecl 0-1 63832 NULL
+disable_so_dsp_iram_offset_sst_addr_63833 dsp_iram_offset sst_addr 0 63833 NULL
+disable_so_central_freq_skl_wrpll_params_63836 central_freq skl_wrpll_params 0 63836 NULL
+disable_so_bitmap_release_region_fndecl_63837 bitmap_release_region fndecl 2-3 63837 NULL
+disable_so_dx_hack_hash_signed_fndecl_63847 dx_hack_hash_signed fndecl 0-2 63847 NULL
+disable_so_qhead_snd_timer_user_63855 qhead snd_timer_user 0 63855 NULL
+disable_so_table1_addr_ipw2100_ordinals_63856 table1_addr ipw2100_ordinals 0 63856 NULL
+disable_so_dec_cd_paddr_qat_alg_aead_ctx_63860 dec_cd_paddr qat_alg_aead_ctx 0 63860 NULL
+disable_so_ppll_div_3_radeon_regs_63862 ppll_div_3 radeon_regs 0 63862 NULL
+disable_so_sys_addr_to_input_addr_fndecl_63863 sys_addr_to_input_addr fndecl 0-2 63863 NULL
+disable_so_dma_rx_timeout_lpuart_port_63878 dma_rx_timeout lpuart_port 0 63878 NULL
+disable_so_dma_addr_t4_rq_63886 dma_addr t4_rq 0 63886 NULL
+disable_so_radeon_semaphore_emit_signal_fndecl_63895 radeon_semaphore_emit_signal fndecl 2 63895 NULL
+disable_so_probe_timeout_ieee80211_if_managed_63910 probe_timeout ieee80211_if_managed 0 63910 NULL
+disable_so_mthca_MAD_IFC_fndecl_63923 mthca_MAD_IFC fndecl 4-0 63923 NULL
+disable_so_get_strength_time_mb86a20s_state_63926 get_strength_time mb86a20s_state 0 63926 NULL
+disable_so_rx_frequency_wl1273_device_63933 rx_frequency wl1273_device 0 63933 NULL nohasharray
+disable_so_arcmsr_module_init_fndecl_63933 arcmsr_module_init fndecl 0 63933 &disable_so_rx_frequency_wl1273_device_63933
+disable_so_timeout_vardecl_alim1535_wdt_c_63935 timeout vardecl_alim1535_wdt.c 0 63935 NULL
+disable_so_query_dv_timings_size_vivid_dev_63943 query_dv_timings_size vivid_dev 0 63943 NULL
+disable_so_nf_nat_sdp_addr_fndecl_63949 nf_nat_sdp_addr fndecl 2-3 63949 NULL
+disable_so_shash_finup_unaligned_fndecl_63955 shash_finup_unaligned fndecl 0-3 63955 NULL
+disable_so_rdmsr_on_cpu_fndecl_63956 rdmsr_on_cpu fndecl 0-1 63956 NULL
+disable_so_qlge_set_mac_address_fndecl_63968 qlge_set_mac_address fndecl 0 63968 NULL
+disable_so_config_ipaddr_qlcnic_nic_template_63973 config_ipaddr qlcnic_nic_template 2 63973 NULL
+disable_so_timer_enable_snd_opl3_63986 timer_enable snd_opl3 0 63986 NULL
+disable_so_virtio16_to_cpu_fndecl_63994 virtio16_to_cpu fndecl 0-2 63994 NULL
+disable_so_ecryptfs_init_crypto_fndecl_63995 ecryptfs_init_crypto fndecl 0 63995 NULL
+disable_so_address_ccp_dma_info_64001 address ccp_dma_info 0 64001 NULL
+disable_so_rx_packet_ring_addr_acx_data_path_params_resp_64002 rx_packet_ring_addr acx_data_path_params_resp 0 64002 NULL nohasharray
+disable_so_cfg80211_wext_siwfreq_fndecl_64002 cfg80211_wext_siwfreq fndecl 0 64002 &disable_so_rx_packet_ring_addr_acx_data_path_params_resp_64002
+disable_so_settime_security_operations_64006 settime security_operations 0 64006 NULL nohasharray
+disable_so_SYSC_timerfd_create_fndecl_64006 SYSC_timerfd_create fndecl 2 64006 &disable_so_settime_security_operations_64006
+disable_so_cryptd_hash_setkey_fndecl_64014 cryptd_hash_setkey fndecl 0-3 64014 NULL
+disable_so_irq_net_device_64015 irq net_device 0 64015 NULL
+disable_so_sysfs_show_available_clocksources_fndecl_64024 sysfs_show_available_clocksources fndecl 0 64024 NULL
+disable_so_s_frequency_v4l2_subdev_tuner_ops_64037 s_frequency v4l2_subdev_tuner_ops 0 64037 NULL
+disable_so_tcp_v6_md5_hash_pseudoheader_fndecl_64051 tcp_v6_md5_hash_pseudoheader fndecl 4 64051 NULL
+disable_so_ieee80211_queue_delayed_work_fndecl_64056 ieee80211_queue_delayed_work fndecl 3 64056 NULL
+disable_so_rtc_set_time_fndecl_64057 rtc_set_time fndecl 0 64057 NULL
+disable_so_addr_i2c_msg_64074 addr i2c_msg 0 64074 NULL
+disable_so_cea_mode_alternate_clock_fndecl_64078 cea_mode_alternate_clock fndecl 0 64078 NULL
+disable_so_cfreq_esp_64080 cfreq esp 0 64080 NULL
+disable_so___irq_get_desc_lock_fndecl_64081 __irq_get_desc_lock fndecl 1 64081 NULL
+disable_so_pticks_snd_timer_instance_64084 pticks snd_timer_instance 0 64084 NULL
+disable_so_ip6addrlbl_get_fndecl_64092 ip6addrlbl_get fndecl 0 64092 NULL nohasharray
+disable_so_ocfs2_desc_bitmap_to_cluster_off_fndecl_64092 ocfs2_desc_bitmap_to_cluster_off fndecl 0-2-3 64092 &disable_so_ip6addrlbl_get_fndecl_64092
+disable_so_nilfs_btree_commit_convert_and_insert_fndecl_64095 nilfs_btree_commit_convert_and_insert fndecl 2-6 64095 NULL
+disable_so_prandom_u32_fndecl_64118 prandom_u32 fndecl 0 64118 NULL
+disable_so_mask_ds1685_rtc_time_regs_64121 mask ds1685_rtc_time_regs 0 64121 NULL
+disable_so_ic_servaddr_vardecl_64122 ic_servaddr vardecl 0 64122 NULL
+disable_so_hashval2_0_rx_pkt_hdr1_64124 hashval2_0 rx_pkt_hdr1 0 64124 NULL
+disable_so_xfrm_addr_equal_fndecl_64155 xfrm_addr_equal fndecl 3 64155 NULL
+disable_so_cq_addr_hi_fcoe_kwqe_conn_offload2_64157 cq_addr_hi fcoe_kwqe_conn_offload2 0 64157 NULL
+disable_so_rq_tmo_jiffies_srp_target_port_64158 rq_tmo_jiffies srp_target_port 0 64158 NULL
+disable_so_xen_sysfs_uuid_init_fndecl_64160 xen_sysfs_uuid_init fndecl 0 64160 NULL
+disable_so___dm_stat_init_temporary_percpu_totals_fndecl_64162 __dm_stat_init_temporary_percpu_totals fndecl 3 64162 NULL
+disable_so_pcxhr_set_clock_fndecl_64184 pcxhr_set_clock fndecl 2-0 64184 NULL
+disable_so_bitmap_endwrite_fndecl_64188 bitmap_endwrite fndecl 2-3 64188 NULL
+disable_so_pages_bitmap_counts_64197 pages bitmap_counts 0 64197 NULL
+disable_so_base_address_dmar_rmrr_unit_64199 base_address dmar_rmrr_unit 0 64199 NULL
+disable_so_udp_conn_schedule_fndecl_64203 udp_conn_schedule fndecl 1 64203 NULL
+disable_so_max_timebase_img_pwm_soc_data_64210 max_timebase img_pwm_soc_data 0 64210 NULL
+disable_so_cycles_at_suspend_vardecl_timekeeping_c_64211 cycles_at_suspend vardecl_timekeeping.c 0 64211 NULL nohasharray
+disable_so_get_unmapped_area_fndecl_64211 get_unmapped_area fndecl 0-2-4-5 64211 &disable_so_cycles_at_suspend_vardecl_timekeeping_c_64211
+disable_so_addr_psb_pipe_64215 addr psb_pipe 0 64215 NULL
+disable_so_acpi_subsys_runtime_suspend_fndecl_64232 acpi_subsys_runtime_suspend fndecl 0 64232 NULL
+disable_so_pci_bus_read_config_word_fndecl_64248 pci_bus_read_config_word fndecl 0-2-3 64248 NULL
+disable_so_last_rx_timestamp_igb_adapter_64249 last_rx_timestamp igb_adapter 0 64249 NULL
+disable_so_snd_timer_user_ioctl_compat_fndecl_64250 snd_timer_user_ioctl_compat fndecl 0 64250 NULL
+disable_so_tag_reg_addr_qla82xx_md_entry_cache_64251 tag_reg_addr qla82xx_md_entry_cache 0 64251 NULL
+disable_so_cond_wait_interruptible_timeout_irqrestore_fndecl_64253 cond_wait_interruptible_timeout_irqrestore fndecl 2-0 64253 NULL
+disable_so_signr_usbdevfs_disconnectsignal32_64254 signr usbdevfs_disconnectsignal32 0 64254 NULL
+disable_so_inet6_addr_del_fndecl_64255 inet6_addr_del fndecl 0-2-5-3 64255 NULL
+disable_so_pci_quatech_clock_fndecl_64264 pci_quatech_clock fndecl 0 64264 NULL nohasharray
+disable_so_crypto_null_mod_init_fndecl_64264 crypto_null_mod_init fndecl 0 64264 &disable_so_pci_quatech_clock_fndecl_64264
+disable_so_kvm_write_wall_clock_fndecl_64267 kvm_write_wall_clock fndecl 2 64267 NULL
+disable_so_smk_write_netlbladdr_fndecl_64270 smk_write_netlbladdr fndecl 3 64270 NULL
+disable_so_iscsi_nacl_attrib_show_dataout_timeout_fndecl_64272 iscsi_nacl_attrib_show_dataout_timeout fndecl 0 64272 NULL
+disable_so_sched_setscheduler_nocheck_fndecl_64274 sched_setscheduler_nocheck fndecl 2-0 64274 NULL
+disable_so_target_stat_scsi_auth_intr_show_attr_creation_time_fndecl_64275 target_stat_scsi_auth_intr_show_attr_creation_time fndecl 0 64275 NULL
+disable_so_dx_hack_hash_unsigned_fndecl_64277 dx_hack_hash_unsigned fndecl 0-2 64277 NULL
+disable_so_xsdt_physical_address_acpi_table_rsdp_64302 xsdt_physical_address acpi_table_rsdp 0 64302 NULL
+disable_so_timeout_watchdog_device_64303 timeout watchdog_device 0 64303 NULL
+disable_so_crypto_shash_digest_fndecl_64307 crypto_shash_digest fndecl 0-3 64307 NULL
+disable_so_jiffies_ati_remote2_64334 jiffies ati_remote2 0 64334 NULL
+disable_so_target_stat_scsi_lu_show_attr_creation_time_fndecl_64336 target_stat_scsi_lu_show_attr_creation_time fndecl 0 64336 NULL
+disable_so_intel_increase_pllclock_fndecl_64342 intel_increase_pllclock fndecl 2 64342 NULL
+disable_so_wm8350_rtc_settime_fndecl_64353 wm8350_rtc_settime fndecl 0 64353 NULL
+disable_so_saa711x_s_crystal_freq_fndecl_64358 saa711x_s_crystal_freq fndecl 2 64358 NULL
+disable_so_get_div_fndecl_64359 get_div fndecl 0 64359 NULL
+disable_so_dln2_spi_runtime_resume_fndecl_64364 dln2_spi_runtime_resume fndecl 0 64364 NULL
+disable_so_register_address_fndecl_64366 register_address fndecl 0-2 64366 NULL
+disable_so_ipath_guid_ipath_devdata_64367 ipath_guid ipath_devdata 0 64367 NULL
+disable_so_dma_address_edgeport_port_64376 dma_address edgeport_port 0 64376 NULL
+disable_so_tlb_rd_addr_vlv_s0ix_state_64377 tlb_rd_addr vlv_s0ix_state 0 64377 NULL
+disable_so_br_mdb_rehash_fndecl_64384 br_mdb_rehash fndecl 2 64384 NULL
+disable_so_irq_ti_tscadc_dev_64390 irq ti_tscadc_dev 0 64390 NULL
+disable_so_rh_hash_fndecl_64392 rh_hash fndecl 0-2 64392 NULL
+disable_so_addr_Vmxnet3_RxDesc_64395 addr Vmxnet3_RxDesc 0 64395 NULL
+disable_so_wptr_gpu_addr_kernel_queue_64396 wptr_gpu_addr kernel_queue 0 64396 NULL
+disable_so__regmap_raw_write_fndecl_64399 _regmap_raw_write fndecl 2-4-0 64399 NULL
+disable_so_crypto_ahash_walk_first_fndecl_64405 crypto_ahash_walk_first fndecl 0 64405 NULL
+disable_so_host_start_efx_ptp_timeset_64407 host_start efx_ptp_timeset 0 64407 NULL
+disable_so___compat_put_timeval_fndecl_64422 __compat_put_timeval fndecl 0 64422 NULL nohasharray
+disable_so_img_ir_timings_preprocess_fndecl_64422 img_ir_timings_preprocess fndecl 2 64422 &disable_so___compat_put_timeval_fndecl_64422
+disable_so_addr_sst_byt_address_info_64439 addr sst_byt_address_info 0 64439 NULL nohasharray
+disable_so_hashhi_smsc911x_data_64439 hashhi smsc911x_data 0 64439 &disable_so_addr_sst_byt_address_info_64439
+disable_so_do_set_clk_freq_fndecl_64447 do_set_clk_freq fndecl 2 64447 NULL
+disable_so_sctp_bind_addr_dup_fndecl_64448 sctp_bind_addr_dup fndecl 3 64448 NULL
+disable_so_rtsc_init_fndecl_64458 rtsc_init fndecl 3-4 64458 NULL
+disable_so_bg_inode_bitmap_ext3_group_desc_64471 bg_inode_bitmap ext3_group_desc 0 64471 NULL
+disable_so_qla8044_wr_reg_indirect_fndecl_64475 qla8044_wr_reg_indirect fndecl 2-3 64475 NULL
+disable_so_switch_time_wl18xx_cmd_channel_switch_64491 switch_time wl18xx_cmd_channel_switch 0 64491 NULL
+disable_so_address_acpi_table_desc_64497 address acpi_table_desc 0 64497 NULL
+disable_so_loading_timeout_vardecl_firmware_class_c_64498 loading_timeout vardecl_firmware_class.c 0 64498 NULL nohasharray
+disable_so_ceph_aes_encrypt_fndecl_64498 ceph_aes_encrypt fndecl 2-6 64498 &disable_so_loading_timeout_vardecl_firmware_class_c_64498
+disable_so_xfrm_state_addr_cmp_fndecl_64504 xfrm_state_addr_cmp fndecl 3 64504 NULL
+disable_so_gc_timer_value___bridge_info_64506 gc_timer_value __bridge_info 0 64506 NULL
+disable_so_x25_addr_aton_fndecl_64507 x25_addr_aton fndecl 0 64507 NULL
+disable_so_nci_request_fndecl_64508 nci_request fndecl 0-4 64508 NULL
+disable_so_ufs_get_de_namlen_fndecl_64510 ufs_get_de_namlen fndecl 0 64510 NULL
+disable_so_crypto_blkcipher_encrypt_iv_fndecl_64517 crypto_blkcipher_encrypt_iv fndecl 0-4 64517 NULL
+disable_so_bfa_fcs_lport_ns_gid_ft_response_fndecl_64527 bfa_fcs_lport_ns_gid_ft_response fndecl 4-5-6 64527 NULL
+disable_so_memtype_devlog_memaddr16_devlog_fw_devlog_cmd_64529 memtype_devlog_memaddr16_devlog fw_devlog_cmd 0 64529 NULL
+disable_so_osc_clock_deviation_drxd_state_64533 osc_clock_deviation drxd_state 0 64533 NULL
+disable_so_mwl8k_cmd_del_mac_addr_fndecl_64540 mwl8k_cmd_del_mac_addr fndecl 0 64540 NULL
+disable_so_sysctl_llc2_ack_timeout_vardecl_64541 sysctl_llc2_ack_timeout vardecl 0 64541 NULL
+disable_so_dm_hash_init_fndecl_64547 dm_hash_init fndecl 0 64547 NULL
+disable_so_setup_cluster_bitmap_fndecl_64549 setup_cluster_bitmap fndecl 4-5-6-7 64549 NULL
+disable_so_regcache_rbtree_get_register_fndecl_64551 regcache_rbtree_get_register fndecl 0-3 64551 NULL
+disable_so_seq_put_decimal_ll_fndecl_64554 seq_put_decimal_ll fndecl 3 64554 NULL
+disable_so_do_timerfd_gettime_fndecl_64594 do_timerfd_gettime fndecl 1 64594 NULL
+disable_so_ctrl_addr___cache_64596 ctrl_addr __cache 0 64596 NULL
+disable_so_writepage_address_space_operations_64597 writepage address_space_operations 0 64597 NULL
+disable_so_hcd_pci_runtime_suspend_fndecl_64602 hcd_pci_runtime_suspend fndecl 0 64602 NULL
+disable_so_maxadj_clocksource_64615 maxadj clocksource 0 64615 NULL nohasharray
+disable_so_delay_lms283gf05_seq_64615 delay lms283gf05_seq 0 64615 &disable_so_maxadj_clocksource_64615
+disable_so_stv0900_get_lock_timeout_fndecl_64620 stv0900_get_lock_timeout fndecl 3 64620 NULL
+disable_so_clk_div_tifm_sd_64621 clk_div tifm_sd 0 64621 NULL
+disable_so_sleep_dvb_frontend_ops_64644 sleep dvb_frontend_ops 0 64644 NULL
+disable_so_tuner_addr_au0828_board_64647 tuner_addr au0828_board 0 64647 NULL
+disable_so_ds1305_get_time_fndecl_64652 ds1305_get_time fndecl 0 64652 NULL
+disable_so_efx_soft_enable_interrupts_fndecl_64659 efx_soft_enable_interrupts fndecl 0 64659 NULL
+disable_so_elements_bitmap_ip_64674 elements bitmap_ip 0 64674 NULL
+disable_so_pcf8563_get_datetime_fndecl_64678 pcf8563_get_datetime fndecl 0 64678 NULL
+disable_so_buf_dma_addr_slgt_desc_64694 buf_dma_addr slgt_desc 0 64694 NULL
+disable_so_twl_aen_sync_time_fndecl_64703 twl_aen_sync_time fndecl 2 64703 NULL
+disable_so_exit_signal_task_struct_64705 exit_signal task_struct 0 64705 NULL
+disable_so_wm8804_runtime_resume_fndecl_64707 wm8804_runtime_resume fndecl 0 64707 NULL
+disable_so_adis16334_set_freq_fndecl_64712 adis16334_set_freq fndecl 0 64712 NULL
+disable_so_menf21bmc_wdt_settimeout_fndecl_64721 menf21bmc_wdt_settimeout fndecl 2-0 64721 NULL
+disable_so_sec_pps_ktime_64728 sec pps_ktime 0 64728 NULL nohasharray
+disable_so_virtual_tsc_khz_kvm_vcpu_arch_64728 virtual_tsc_khz kvm_vcpu_arch 0 64728 &disable_so_sec_pps_ktime_64728
+disable_so_set_timeout_fndecl_64741 set_timeout fndecl 1 64741 NULL
+disable_so_posix_timer_by_id_fndecl_64744 posix_timer_by_id fndecl 1 64744 NULL
+disable_so_sclk_fb_div_pll_ct_64751 sclk_fb_div pll_ct 0 64751 NULL nohasharray
+disable_so_add_msr_offset_fndecl_64751 add_msr_offset fndecl 1 64751 &disable_so_sclk_fb_div_pll_ct_64751
+disable_so_il_get_active_dwell_time_fndecl_64753 il_get_active_dwell_time fndecl 0-3 64753 NULL
+disable_so_crypto_cbc_decrypt_inplace_fndecl_64755 crypto_cbc_decrypt_inplace fndecl 0 64755 NULL
+disable_so_undertime_cbq_class_64773 undertime cbq_class 0 64773 NULL nohasharray
+disable_so_beacon_time_iwl_mac_data_ap_64773 beacon_time iwl_mac_data_ap 0 64773 &disable_so_undertime_cbq_class_64773
+disable_so_gpio_to_desc_fndecl_64785 gpio_to_desc fndecl 1 64785 NULL nohasharray
+disable_so_rtl8723_phy_calculate_bit_shift_fndecl_64785 rtl8723_phy_calculate_bit_shift fndecl 0-1 64785 &disable_so_gpio_to_desc_fndecl_64785
+disable_so_cherryview_rps_rpe_freq_fndecl_64792 cherryview_rps_rpe_freq fndecl 0 64792 NULL
+disable_so_phys_addr_matrox_device_64795 phys_addr matrox_device 0 64795 NULL
+disable_so_iwl_mvm_time_event_send_add_fndecl_64805 iwl_mvm_time_event_send_add fndecl 0 64805 NULL nohasharray
+disable_so_p_addr_ioat_pq_descriptor_64805 p_addr ioat_pq_descriptor 0 64805 &disable_so_iwl_mvm_time_event_send_add_fndecl_64805
+disable_so_hub_set_address_fndecl_64806 hub_set_address fndecl 2 64806 NULL
+disable_so_tegra_slink_runtime_resume_fndecl_64822 tegra_slink_runtime_resume fndecl 0 64822 NULL
+disable_so_head_hashfn_fndecl_64825 head_hashfn fndecl 0 64825 NULL
+disable_so_time_queue_snd_seq_client_port_64827 time_queue snd_seq_client_port 0 64827 NULL
+disable_so_bitmap_clear_ll_fndecl_64837 bitmap_clear_ll fndecl 0-2-3 64837 NULL
+disable_so_dma_beacon_response_time_ath9k_ops_config_64844 dma_beacon_response_time ath9k_ops_config 0 64844 NULL
+disable_so_aic_cal_start_time_ath9k_hw_aic_64848 aic_cal_start_time ath9k_hw_aic 0 64848 NULL
+disable_so_dram_freq_ast2300_dram_param_64872 dram_freq ast2300_dram_param 0 64872 NULL
+disable_so_uv_rtc_unset_timer_fndecl_64879 uv_rtc_unset_timer fndecl 1 64879 NULL
+disable_so_xclkpagefaultdelay_pll_ct_64883 xclkpagefaultdelay pll_ct 0 64883 NULL
+disable_so_ipvs_mt_addrcmp_fndecl_64884 ipvs_mt_addrcmp fndecl 4 64884 NULL
+disable_so_base_addr_adf_bar_64885 base_addr adf_bar 0 64885 NULL
+disable_so_ctimensec_fuse_attr_64891 ctimensec fuse_attr 0 64891 NULL
+disable_so_ims_pcu_ofn_bit_show_fndecl_64893 ims_pcu_ofn_bit_show fndecl 0 64893 NULL
+disable_so_regvalue__pll_div_64897 regvalue _pll_div 0 64897 NULL
+disable_so_mode_ata_timing_64902 mode ata_timing 0 64902 NULL
+disable_so_size_mtrr_sentry_64908 size mtrr_sentry 0 64908 NULL
+disable_so_i2c_addr_dibx000_i2c_master_64923 i2c_addr dibx000_i2c_master 0 64923 NULL
+disable_so_go7007_usb_read_interrupt_fndecl_64943 go7007_usb_read_interrupt fndecl 0 64943 NULL
+disable_so_db_page_addr_ocrdma_create_srq_uresp_64946 db_page_addr ocrdma_create_srq_uresp 0 64946 NULL
+disable_so_resolution_snd_timer_hardware_64953 resolution snd_timer_hardware 0 64953 NULL
+disable_so___virt_addr_valid_fndecl_64955 __virt_addr_valid fndecl 1 64955 NULL
+disable_so_nilfs_btree_insert_fndecl_64974 nilfs_btree_insert fndecl 0-2 64974 NULL
+disable_so_nearest_clock_vml_sys_64980 nearest_clock vml_sys 2-0 64980 NULL
+disable_so_crypto_cmac_module_init_fndecl_64981 crypto_cmac_module_init fndecl 0 64981 NULL
+disable_so_cx23885_set_freq_via_ops_fndecl_64991 cx23885_set_freq_via_ops fndecl 0 64991 NULL
+disable_so_hfdiv_code_dib0090_pll_64992 hfdiv_code dib0090_pll 0 64992 NULL
+disable_so_phonet_address_get_fndecl_65002 phonet_address_get fndecl 0-2 65002 NULL
+disable_so_xtime_sec_timekeeper_65003 xtime_sec timekeeper 0 65003 NULL
+disable_so_fll_outdiv__fll_div_65007 fll_outdiv _fll_div 0 65007 NULL
+disable_so_spi_max_frequency_ti_qspi_65008 spi_max_frequency ti_qspi 0 65008 NULL
+disable_so_switch_time_iwl6000_channel_switch_cmd_65010 switch_time iwl6000_channel_switch_cmd 0 65010 NULL
+disable_so_timeout_usdhi6_host_65012 timeout usdhi6_host 0 65012 NULL nohasharray
+disable_so_dirtied_time_when_inode_65012 dirtied_time_when inode 0 65012 &disable_so_timeout_usdhi6_host_65012
+disable_so_sys_settimeofday_fndecl_65021 sys_settimeofday fndecl 0 65021 NULL
+disable_so_dummy_clock_read_fndecl_65029 dummy_clock_read fndecl 0 65029 NULL
+disable_so_bitmap_load_fndecl_65032 bitmap_load fndecl 0 65032 NULL
+disable_so_crypto_register_aead_fndecl_65065 crypto_register_aead fndecl 0 65065 NULL
+disable_so_clock_frequency_sc18is602_platform_data_65066 clock_frequency sc18is602_platform_data 0 65066 NULL
+disable_so_zd1201_get_freq_fndecl_65079 zd1201_get_freq fndecl 0 65079 NULL
+disable_so_test_bitmaps_fndecl_65080 test_bitmaps fndecl 0 65080 NULL
+disable_so_before_ctime_nsec_nfsd4_change_info_65085 before_ctime_nsec nfsd4_change_info 0 65085 NULL
+disable_so_evtbd_addr_lo_host_cmd_ds_pcie_details_65086 evtbd_addr_lo host_cmd_ds_pcie_details 0 65086 NULL
+disable_so_cursor_addr_gma_crtc_65091 cursor_addr gma_crtc 0 65091 NULL
+disable_so_atomic_set_property_drm_crtc_funcs_65096 atomic_set_property drm_crtc_funcs 0-4 65096 NULL
+disable_so_add_timer_on_fndecl_65097 add_timer_on fndecl 2 65097 NULL
+disable_so_ccp_sha_final_fndecl_65104 ccp_sha_final fndecl 0 65104 NULL
+disable_so_ip_vs_dbg_addr_fndecl_65105 ip_vs_dbg_addr fndecl 1 65105 NULL
+disable_so_gl_hold_time_gfs2_glock_65107 gl_hold_time gfs2_glock 0 65107 NULL
+disable_so_crypto_shash_update_fndecl_65113 crypto_shash_update fndecl 0-3 65113 NULL
+disable_so_sleep_wake_pci_platform_pm_ops_65121 sleep_wake pci_platform_pm_ops 0 65121 NULL
+disable_so_snd_hdsp_info_clock_source_fndecl_65123 snd_hdsp_info_clock_source fndecl 0 65123 NULL
+disable_so_trace_clock_global_fndecl_65145 trace_clock_global fndecl 0 65145 NULL
+disable_so_timestamp_iwl_rx_phy_info_65153 timestamp iwl_rx_phy_info 0 65153 NULL
+disable_so_d_btimer_xfs_disk_dquot_65155 d_btimer xfs_disk_dquot 0 65155 NULL
+disable_so_mthca_mr_alloc_phys_fndecl_65161 mthca_mr_alloc_phys fndecl 7-5-2-4-0 65161 NULL
+disable_so_var_to_timing_fndecl_65170 var_to_timing fndecl 2-3 65170 NULL
+disable_so_p2div_pmu1_plltab_entry_65173 p2div pmu1_plltab_entry 0 65173 NULL nohasharray
+disable_so_kszphy_ack_interrupt_fndecl_65173 kszphy_ack_interrupt fndecl 0 65173 &disable_so_p2div_pmu1_plltab_entry_65173
+disable_so_timeout_mgsl_struct_65176 timeout mgsl_struct 0 65176 NULL nohasharray
+disable_so_amd_uncore_attr_show_cpumask_fndecl_65176 amd_uncore_attr_show_cpumask fndecl 0 65176 &disable_so_timeout_mgsl_struct_65176
+disable_so_padata_register_cpumask_notifier_fndecl_65178 padata_register_cpumask_notifier fndecl 0 65178 NULL
+disable_so_bit_clear_fndecl_65181 bit_clear fndecl 3-4-5-6 65181 NULL
+disable_so_addr_wil_fw_data_gw4_65184 addr wil_fw_data_gw4 0 65184 NULL
+disable_so_phy_addr_skge_hw_65197 phy_addr skge_hw 0 65197 NULL
+disable_so_xen_cpuid_xenpf_pcpuinfo_65200 xen_cpuid xenpf_pcpuinfo 0 65200 NULL
+disable_so_vsync_v4l2_bt_timings_65208 vsync v4l2_bt_timings 0 65208 NULL nohasharray
+disable_so_vmcb_msrpm_nested_state_65208 vmcb_msrpm nested_state 0 65208 &disable_so_vsync_v4l2_bt_timings_65208
+disable_so_determine_event_timeout_rsi_hw_65216 determine_event_timeout rsi_hw 0 65216 NULL
+disable_so_rax_kvm_regs_65218 rax kvm_regs 0 65218 NULL
+disable_so_tms_utime_compat_tms_65221 tms_utime compat_tms 0 65221 NULL
+disable_so_ip_vs_ftp_get_addrport_fndecl_65224 ip_vs_ftp_get_addrport fndecl 4 65224 NULL
+disable_so_dclk_radeon_uvd_clock_voltage_dependency_entry_65235 dclk radeon_uvd_clock_voltage_dependency_entry 0 65235 NULL
+disable_so_sin6_port_sockaddr_in6_65238 sin6_port sockaddr_in6 0 65238 NULL
+disable_so_mtrr_del_page_fndecl_65239 mtrr_del_page fndecl 2-3 65239 NULL
+disable_so_timestamp_sec_rt2x00dump_hdr_65245 timestamp_sec rt2x00dump_hdr 0 65245 NULL
+disable_so_snd_interval_mulkdiv_fndecl_65264 snd_interval_mulkdiv fndecl 2 65264 NULL
+disable_so_ktime_sec_timekeeper_65270 ktime_sec timekeeper 0 65270 NULL nohasharray
+disable_so_pid_fcgs_gidft_resp_s_65270 pid fcgs_gidft_resp_s 0 65270 &disable_so_ktime_sec_timekeeper_65270
+disable_so_mmc_set_signal_voltage_fndecl_65277 mmc_set_signal_voltage fndecl 0-3 65277 NULL
+disable_so_addr_lo_pm4_query_status_65283 addr_lo pm4_query_status 0 65283 NULL
+disable_so_wep_interrupt_read_fndecl_65287 wep_interrupt_read fndecl 3-0 65287 NULL
+disable_so_timeout_qib_qp_65289 timeout qib_qp 0 65289 NULL
+disable_so_cpuid_edx_fndecl_65291 cpuid_edx fndecl 0 65291 NULL
+disable_so_q2_addr_high_nes_qp_context_65298 q2_addr_high nes_qp_context 0 65298 NULL
+disable_so_addr_f7188x_sio_65304 addr f7188x_sio 0 65304 NULL
+disable_so_st_mtime___old_kernel_stat_65306 st_mtime __old_kernel_stat 0 65306 NULL
+disable_so_radeon_fence_wait_seq_timeout_fndecl_65307 radeon_fence_wait_seq_timeout fndecl 4-0 65307 NULL
+disable_so_runtime_suspend_power_mode_cyapa_65317 runtime_suspend_power_mode cyapa 0 65317 NULL
+disable_so_ieee80211_crypto_ccmp_encrypt_fndecl_65319 ieee80211_crypto_ccmp_encrypt fndecl 2 65319 NULL
+disable_so_bbaddr_drm_i915_error_ring_65323 bbaddr drm_i915_error_ring 0 65323 NULL
+disable_so_nmi_timer_stop_cpu_fndecl_65325 nmi_timer_stop_cpu fndecl 1 65325 NULL
+disable_so_crypto_aead_encrypt_fndecl_65326 crypto_aead_encrypt fndecl 0 65326 NULL
+disable_so_d_rtbtimer_fs_disk_quota_65332 d_rtbtimer fs_disk_quota 0 65332 NULL
+disable_so_si_calculate_cac_wintime_fndecl_65336 si_calculate_cac_wintime fndecl 0 65336 NULL
+disable_so_baseaddr_l_mvumi_sgl_65375 baseaddr_l mvumi_sgl 0 65375 NULL
+disable_so_current_flash_timeout_max77693_led_device_65379 current_flash_timeout max77693_led_device 0 65379 NULL
+disable_so_shunt_div_ina2xx_config_65385 shunt_div ina2xx_config 0 65385 NULL
+disable_so_waiting_set_timer_fndecl_65387 waiting_set_timer fndecl 2 65387 NULL
+disable_so_tms_cutime_tms_65396 tms_cutime tms 0 65396 NULL
+disable_so_wl1271_acx_rx_msdu_life_time_fndecl_65398 wl1271_acx_rx_msdu_life_time fndecl 0 65398 NULL
+disable_so_phy_addr_ax88172a_private_65403 phy_addr ax88172a_private 0 65403 NULL
+disable_so_vm_exit_msr_store_addr_vmcs12_65409 vm_exit_msr_store_addr vmcs12 0 65409 NULL
+disable_so_reorder_timeout_l2tp_session_cfg_65412 reorder_timeout l2tp_session_cfg 0 65412 NULL nohasharray
+disable_so_bit_spin_lock_fndecl_65412 bit_spin_lock fndecl 1 65412 &disable_so_reorder_timeout_l2tp_session_cfg_65412
+disable_so_data_address_mspro_param_register_65413 data_address mspro_param_register 0 65413 NULL
+disable_so_addr_hwsq_reg_65417 addr hwsq_reg 0 65417 NULL
+disable_so_nla_put_u64_fndecl_65419 nla_put_u64 fndecl 3-0 65419 NULL
+disable_so_dma_addr_vb2_dc_buf_65420 dma_addr vb2_dc_buf 0 65420 NULL
+disable_so_snd_timer_stop_fndecl_65441 snd_timer_stop fndecl 0 65441 NULL
+disable_so_down_timeout_fndecl_65445 down_timeout fndecl 2-0 65445 NULL
+disable_so_sys_timer_gettime_fndecl_65465 sys_timer_gettime fndecl 1 65465 NULL
+disable_so_pnp_printf_fndecl_65468 pnp_printf fndecl 0 65468 NULL
+disable_so_write_reg_cc770_priv_65479 write_reg cc770_priv 3 65479 NULL
+disable_so_create_time_stateowner_id_65480 create_time stateowner_id 0 65480 NULL
+disable_so_q2_addr_low_nes_qp_context_65481 q2_addr_low nes_qp_context 0 65481 NULL
+disable_so_nvme_io_timeout_vardecl_65489 nvme_io_timeout vardecl 0 65489 NULL nohasharray
+disable_so_index_nilfs_btree_readahead_info_65489 index nilfs_btree_readahead_info 0 65489 &disable_so_nvme_io_timeout_vardecl_65489
+disable_so_i_uid_f2fs_inode_65496 i_uid f2fs_inode 0 65496 NULL
+disable_so_enc_cd_paddr_qat_alg_aead_ctx_65505 enc_cd_paddr qat_alg_aead_ctx 0 65505 NULL
+disable_so_s5m_rtc_set_time_fndecl_65518 s5m_rtc_set_time fndecl 0 65518 NULL
+disable_so_addr_w83627hf_data_65526 addr w83627hf_data 0 65526 NULL
+disable_so_si_pt_regs_65527 si pt_regs 0 65527 NULL
+enable_so_rts_threshold_wiphy_15170 rts_threshold wiphy 0 15170 NULL
+enable_so_value_iw_param_65472 value iw_param 0 65472 NULL
+enable_so_value_acpi_object_integer_44755 value acpi_object_integer 0 44755 NULL
+enable_so_idx_ieee80211_tx_rate_64646 idx ieee80211_tx_rate 0 64646 NULL
+enable_so_rs_get_adjacent_rate_fndecl_28334 rs_get_adjacent_rate fndecl 0-2 28334 NULL
+enable_so_index_rs_rate_53 index rs_rate 0 53 NULL
+enable_so_l1_xfs_bmbt_rec_host_22094 l1 xfs_bmbt_rec_host 0 22094 NULL
+enable_so_l0_xfs_bmbt_rec_host_34805 l0 xfs_bmbt_rec_host 0 34805 NULL
+enable_so_max_scsi_cmds_megasas_instance_35835 max_scsi_cmds megasas_instance 0 35835 NULL
+enable_so_throttlequeuedepth_megasas_instance_42316 throttlequeuedepth megasas_instance 0 42316 NULL
+enable_so_max_fw_cmds_megasas_instance_53309 max_fw_cmds megasas_instance 0 53309 NULL
+enable_so_max_num_sge_megasas_instance_55755 max_num_sge megasas_instance 0 55755 NULL
+enable_so_max_sectors_per_req_megasas_instance_56408 max_sectors_per_req megasas_instance 0 56408 NULL
+enable_so_max_mfi_cmds_megasas_instance_19731 max_mfi_cmds megasas_instance 0 19731 NULL
+enable_so_read_fw_status_reg_megasas_instance_template_13572 read_fw_status_reg megasas_instance_template 0 13572 NULL
+enable_so_eip_x86_emulate_ctxt_12354 eip x86_emulate_ctxt 0 12354 NULL
+enable_so_next_rip_x86_instruction_info_56868 next_rip x86_instruction_info 0 56868 NULL
+enable_so_exit_int_info_vmcb_control_area_18357 exit_int_info vmcb_control_area 0 18357 NULL
+enable_so_exit_info_1_vmcb_control_area_20200 exit_info_1 vmcb_control_area 0 20200 NULL
+enable_so_event_inj_vmcb_control_area_23434 event_inj vmcb_control_area 0 23434 NULL
+enable_so_iopm_base_pa_vmcb_control_area_57998 iopm_base_pa vmcb_control_area 0 57998 NULL
+enable_so_i_size_lo_ext4_inode_40153 i_size_lo ext4_inode 0 40153 NULL
+enable_so_i_size_high_ext4_inode_18545 i_size_high ext4_inode 0 18545 NULL
+enable_so_nr_kvm_queued_interrupt_34927 nr kvm_queued_interrupt 0 34927 NULL
+enable_so_last_used_idx_vhost_virtqueue_40059 last_used_idx vhost_virtqueue 0 40059 NULL
+enable_so___load_segment_descriptor_fndecl_30833 __load_segment_descriptor fndecl 2-4 30833 NULL
+enable_so_resource_size_38580 resource_size nvkm_device_func 0 38580 NULL
+enable_so_rate_n_flags_iwlagn_tx_resp_63401 rate_n_flags iwlagn_tx_resp 0 63401 NULL
+enable_so_iwlagn_hwrate_to_mac80211_idx_fndecl_57485 iwlagn_hwrate_to_mac80211_idx fndecl 0-1 57485 NULL
+enable_so_rate_n_flags_iwl_rx_phy_info_45542 rate_n_flags iwl_rx_phy_info 0 45542 NULL
+enable_so_deh_location_reiserfs_de_head_7682 deh_location reiserfs_de_head 0 7682 NULL
+enable_so_deh_offset_reiserfs_de_head_42314 deh_offset reiserfs_de_head 0 42314 NULL
+enable_so_dsack_tcp_options_received_27706 dsack tcp_options_received 0 27706 NULL
+enable_so_inbufBits_bunzip_data_13788 inbufBits bunzip_data 0 13788 NULL
+enable_so_i_ino_inode_8428 i_ino inode 0 8428 NULL
+enable_so_squashfs_iget_fndecl_37485 squashfs_iget fndecl 3 37485 NULL
+enable_so_new_offset_mdp_superblock_1_6501 new_offset mdp_superblock_1 0 6501 NULL
+enable_so_lookup_memtype_fndecl_20192 lookup_memtype fndecl 1 20192 NULL
+enable_so_inofree_iagctl_5194 inofree iagctl 0 5194 NULL
+enable_so_inofreefwd_iag_4921 inofreefwd iag 0 4921 NULL
+enable_so_iagnum_iag_23227 iagnum iag 0 23227 NULL
+enable_so_offset_lv_35617 offset lv 0 35617 NULL
+e_cnt_bictcp_9780 cnt bictcp 0 9780 NULL
+e_last_max_cwnd_bictcp_22377 last_max_cwnd bictcp 0 22377 NULL
+e_bic_K_bictcp_33591 bic_K bictcp 0 33591 NULL
+e_tcp_cwnd_bictcp_64346 tcp_cwnd bictcp 0 64346 NULL
+e_bic_origin_point_bictcp_64414 bic_origin_point bictcp 0 64414 NULL
+e_srtt_us_tcp_sock_62907 srtt_us tcp_sock 0 62907 NULL
+e_tcp_rtt_estimator_fndecl_7853 tcp_rtt_estimator fndecl 2 7853 NULL
+e_tcp_ack_update_rtt_fndecl_26581 tcp_ack_update_rtt fndecl 4-3 26581 NULL
+e_rtt_westwood_52592 rtt westwood 0 52592 NULL
+e_minRTT_vegas_62707 minRTT vegas 0 62707 NULL
+e_tcp_westwood_bw_rttmin_fndecl_63713 tcp_westwood_bw_rttmin fndecl 0 63713 NULL
+e_cube_rtt_scale_vardecl_tcp_cubic_c_2638 cube_rtt_scale vardecl_tcp_cubic.c 0 2638 NULL
+e_rtt0_vardecl_tcp_hybla_c_51134 rtt0 vardecl_tcp_hybla.c 0 51134 NULL
+e_rtt_win_sx_westwood_41723 rtt_win_sx westwood 0 41723 NULL
+e_baseRTT_vegas_18174 baseRTT vegas 0 18174 NULL
+e_init_special_inode_fndecl_7054 init_special_inode fndecl 3 7054 NULL
+e_new_decode_dev_fndecl_38477 new_decode_dev fndecl 0-1 38477 NULL
+e_new_encode_dev_fndecl_48964 new_encode_dev fndecl 0-1 48964 NULL
+e_jffs2_encode_dev_fndecl_39156 jffs2_encode_dev fndecl 2-0 39156 NULL
+btrfs_get_token_32_fndecl_7192_fns btrfs_get_token_32 fndecl 0 7192 NULL
+btrfs_get_token_16_fndecl_46639_fns btrfs_get_token_16 fndecl 0 46639 NULL
+btrfs_get_token_64_fndecl_54223_fns btrfs_get_token_64 fndecl 0 54223 NULL
+qdisc_tree_reduce_backlog_fndecl_3865_fields qdisc_tree_reduce_backlog fndecl 2 3865 NULL
diff --git b/scripts/gcc-plugins/size_overflow_plugin/e_aux.data b/scripts/gcc-plugins/size_overflow_plugin/e_aux.data
new file mode 100644
index 000000000..74e91b2a1
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_aux.data
@@ -0,0 +1,97 @@
+enable_so_spa_set_aux_vdevs_fndecl_746 spa_set_aux_vdevs fndecl 3 746 NULL
+enable_so_zfs_lookup_fndecl_2144 zfs_lookup fndecl 0 2144 NULL
+enable_so_mappedread_fndecl_2627 mappedread fndecl 2 2627 NULL
+enable_so_SMACL_Alloc_fndecl_2775 SMACL_Alloc fndecl 1 2775 NULL
+enable_so_vdev_disk_dio_alloc_fndecl_2957 vdev_disk_dio_alloc fndecl 1 2957 NULL
+enable_so_nv_alloc_pushpage_spl_fndecl_4286 nv_alloc_pushpage_spl fndecl 2 4286 NULL
+enable_so_zpl_xattr_get_fndecl_4574 zpl_xattr_get fndecl 0 4574 NULL
+enable_so_sa_replace_all_by_template_fndecl_5699 sa_replace_all_by_template fndecl 3 5699 NULL
+enable_so_dmu_write_fndecl_6048 dmu_write fndecl 4-3 6048 NULL
+enable_so_dmu_buf_hold_array_fndecl_6095 dmu_buf_hold_array fndecl 4-3 6095 NULL
+enable_so_update_pages_fndecl_6225 update_pages fndecl 2-3 6225 NULL
+enable_so_bio_nr_pages_fndecl_7117 bio_nr_pages fndecl 0-2 7117 NULL
+enable_so_dmu_buf_hold_array_by_bonus_fndecl_8562 dmu_buf_hold_array_by_bonus fndecl 3-2 8562 NULL
+enable_so_zpios_dmu_write_fndecl_8858 zpios_dmu_write fndecl 4-5 8858 NULL
+enable_so_ddi_copyout_fndecl_9401 ddi_copyout fndecl 3 9401 NULL
+enable_so_avl_numnodes_fndecl_12384 avl_numnodes fndecl 0 12384 NULL
+enable_so_dmu_write_uio_dnode_fndecl_12473 dmu_write_uio_dnode fndecl 3 12473 NULL
+enable_so_dmu_xuio_init_fndecl_12866 dmu_xuio_init fndecl 2 12866 NULL
+enable_so_zpl_read_common_fndecl_14389 zpl_read_common fndecl 0 14389 NULL
+enable_so_dmu_snapshot_realname_fndecl_14632 dmu_snapshot_realname fndecl 4 14632 NULL
+enable_so_kmem_alloc_debug_fndecl_14852 kmem_alloc_debug fndecl 1 14852 NULL
+enable_so_kmalloc_node_nofail_fndecl_15151 kmalloc_node_nofail fndecl 1 15151 NULL
+enable_so_size_VNet_EventHeader_15382 size VNet_EventHeader 0 15382 NULL
+enable_so_dmu_write_uio_fndecl_16351 dmu_write_uio fndecl 4 16351 NULL
+enable_so_zfs_log_write_fndecl_16524 zfs_log_write fndecl 6-5 16524 NULL
+enable_so_sa_build_layouts_fndecl_16910 sa_build_layouts fndecl 3 16910 NULL
+enable_so_dsl_dir_namelen_fndecl_17053 dsl_dir_namelen fndecl 0 17053 NULL
+enable_so_kcopy_copy_to_user_fndecl_17336 kcopy_copy_to_user fndecl 5 17336 NULL
+enable_so_sa_add_layout_entry_fndecl_17507 sa_add_layout_entry fndecl 3 17507 NULL
+enable_so_sa_attr_table_setup_fndecl_18029 sa_attr_table_setup fndecl 3 18029 NULL
+enable_so_uiocopy_fndecl_18680 uiocopy fndecl 2 18680 NULL
+enable_so_dmu_buf_hold_array_by_dnode_fndecl_19125 dmu_buf_hold_array_by_dnode fndecl 2-3 19125 NULL
+enable_so_zpl_acl_from_xattr_fndecl_21141 zpl_acl_from_xattr fndecl 2 21141 NULL
+enable_so_dsl_pool_tx_assign_init_fndecl_22518 dsl_pool_tx_assign_init fndecl 2 22518 NULL
+enable_so_nvlist_lookup_byte_array_fndecl_22527 nvlist_lookup_byte_array fndecl 0 22527 NULL
+enable_so_sa_replace_all_by_template_locked_fndecl_22533 sa_replace_all_by_template_locked fndecl 3 22533 NULL
+enable_so_tsd_hash_table_init_fndecl_22559 tsd_hash_table_init fndecl 1 22559 NULL
+enable_so_spa_vdev_remove_aux_fndecl_23966 spa_vdev_remove_aux fndecl 4 23966 NULL
+enable_so_zpl_xattr_acl_set_access_fndecl_24129 zpl_xattr_acl_set_access fndecl 4 24129 NULL
+enable_so_dmu_assign_arcbuf_fndecl_24622 dmu_assign_arcbuf fndecl 2 24622 NULL
+enable_so_zap_lookup_norm_fndecl_25166 zap_lookup_norm fndecl 9 25166 NULL
+enable_so_dmu_prealloc_fndecl_25456 dmu_prealloc fndecl 4-3 25456 NULL
+enable_so_kmalloc_nofail_fndecl_26347 kmalloc_nofail fndecl 1 26347 NULL
+enable_so_zfsctl_snapshot_zpath_fndecl_27578 zfsctl_snapshot_zpath fndecl 2 27578 NULL
+enable_so_zpios_dmu_read_fndecl_30015 zpios_dmu_read fndecl 4-5 30015 NULL
+enable_so_splat_write_fndecl_30943 splat_write fndecl 3 30943 NULL
+enable_so_zpl_xattr_get_sa_fndecl_31183 zpl_xattr_get_sa fndecl 0 31183 NULL
+enable_so_dmu_read_uio_fndecl_31467 dmu_read_uio fndecl 4 31467 NULL
+enable_so_zfs_replay_fuids_fndecl_31479 zfs_replay_fuids fndecl 4 31479 NULL
+enable_so_spa_history_log_to_phys_fndecl_31632 spa_history_log_to_phys fndecl 0-1 31632 NULL
+enable_so___zpl_xattr_get_fndecl_32601 __zpl_xattr_get fndecl 0 32601 NULL
+enable_so_VNetUserListenerRead_fndecl_34039 VNetUserListenerRead fndecl 4 34039 NULL
+enable_so_proc_copyout_string_fndecl_34049 proc_copyout_string fndecl 2 34049 NULL
+enable_so_nv_alloc_sleep_spl_fndecl_34544 nv_alloc_sleep_spl fndecl 2 34544 NULL
+enable_so_nv_alloc_nosleep_spl_fndecl_34761 nv_alloc_nosleep_spl fndecl 2 34761 NULL
+enable_so_zap_leaf_array_match_fndecl_36922 zap_leaf_array_match fndecl 4 36922 NULL
+enable_so_copyinstr_fndecl_36980 copyinstr fndecl 3 36980 NULL
+enable_so_zpl_xattr_acl_set_default_fndecl_37864 zpl_xattr_acl_set_default fndecl 4 37864 NULL
+enable_so_splat_read_fndecl_38116 splat_read fndecl 3 38116 NULL
+enable_so_sa_setup_fndecl_38756 sa_setup fndecl 4 38756 NULL
+enable_so_vdev_disk_physio_fndecl_39898 vdev_disk_physio fndecl 3 39898 NULL
+enable_so_arc_buf_size_fndecl_39982 arc_buf_size fndecl 0 39982 NULL
+enable_so_kzalloc_nofail_fndecl_40719 kzalloc_nofail fndecl 1 40719 NULL
+enable_so_fuidstr_to_sid_fndecl_40777 fuidstr_to_sid fndecl 4 40777 NULL
+enable_so_vdev_raidz_matrix_reconstruct_fndecl_40852 vdev_raidz_matrix_reconstruct fndecl 2-3 40852 NULL
+enable_so_sa_find_layout_fndecl_40892 sa_find_layout fndecl 4 40892 NULL
+enable_so_zpl_xattr_get_dir_fndecl_41918 zpl_xattr_get_dir fndecl 0 41918 NULL
+enable_so_zfs_sa_get_xattr_fndecl_42600 zfs_sa_get_xattr fndecl 0 42600 NULL
+enable_so_zpl_xattr_acl_set_fndecl_42808 zpl_xattr_acl_set fndecl 4 42808 NULL
+enable_so_xdr_dec_array_fndecl_43091 xdr_dec_array fndecl 5 43091 NULL
+enable_so_dsl_dataset_namelen_fndecl_43136 dsl_dataset_namelen fndecl 0 43136 NULL
+enable_so_kcopy_write_fndecl_43683 kcopy_write fndecl 3 43683 NULL
+enable_so_uiomove_fndecl_44355 uiomove fndecl 2 44355 NULL
+enable_so_dmu_read_fndecl_44418 dmu_read fndecl 4-3 44418 NULL
+enable_so_ddi_copyin_fndecl_44846 ddi_copyin fndecl 3 44846 NULL
+enable_so_kcopy_do_get_fndecl_45061 kcopy_do_get fndecl 5 45061 NULL
+enable_so_copyin_fndecl_45945 copyin fndecl 3 45945 NULL
+enable_so_zil_itx_create_fndecl_46555 zil_itx_create fndecl 2 46555 NULL
+enable_so_dmu_write_uio_dbuf_fndecl_48064 dmu_write_uio_dbuf fndecl 3 48064 NULL
+enable_so_blk_rq_pos_fndecl_48233 blk_rq_pos fndecl 0 48233 NULL
+enable_so_spa_history_write_fndecl_49650 spa_history_write fndecl 3 49650 NULL
+enable_so_kcopy_copy_pages_to_user_fndecl_49823 kcopy_copy_pages_to_user fndecl 3-4 49823 NULL
+enable_so_zfs_log_write_fndecl_50162 zfs_log_write fndecl 6-5 50162 NULL
+enable_so_i_fm_alloc_fndecl_51038 i_fm_alloc fndecl 2 51038 NULL
+enable_so_copyout_fndecl_51409 copyout fndecl 3 51409 NULL
+enable_so_VNetKernel_MemoryAllocate_fndecl_53131 VNetKernel_MemoryAllocate fndecl 1 53131 NULL
+enable_so_VNetUserIfWrite_fndecl_54044 VNetUserIfWrite fndecl 4 54044 NULL
+enable_so_zvol_log_write_fndecl_54898 zvol_log_write fndecl 4-3 54898 NULL
+enable_so_zfs_acl_node_alloc_fndecl_55641 zfs_acl_node_alloc fndecl 1 55641 NULL
+enable_so_get_nvlist_fndecl_56685 get_nvlist fndecl 2 56685 NULL
+enable_so_zprop_get_numprops_fndecl_56820 zprop_get_numprops fndecl 0 56820 NULL
+enable_so_splat_taskq_test4_common_fndecl_59829 splat_taskq_test4_common fndecl 5 59829 NULL
+enable_so_zfs_replay_domain_cnt_fndecl_61399 zfs_replay_domain_cnt fndecl 0 61399 NULL
+enable_so_zpios_write_fndecl_61823 zpios_write fndecl 3 61823 NULL
+enable_so_proc_copyin_string_fndecl_62019 proc_copyin_string fndecl 4 62019 NULL
+enable_so_random_get_pseudo_bytes_fndecl_64611 random_get_pseudo_bytes fndecl 2 64611 NULL
+enable_so_zpios_read_fndecl_64734 zpios_read fndecl 3 64734 NULL
diff --git b/scripts/gcc-plugins/size_overflow_plugin/e_fields.data b/scripts/gcc-plugins/size_overflow_plugin/e_fields.data
new file mode 100644
index 000000000..6b5367dba
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_fields.data
@@ -0,0 +1,16261 @@
+recv_ctrl_pipe_us_data_0_fields recv_ctrl_pipe us_data 0 0 NULL
+__earlyonly_bootmem_alloc_fndecl_3_fields __earlyonly_bootmem_alloc fndecl 2-3-4 3 NULL
+size_ttm_mem_reg_8_fields size ttm_mem_reg 0 8 NULL
+char2uni_nls_table_12_fields char2uni nls_table 0 12 NULL
+nrbufs_pipe_inode_info_13_fields nrbufs pipe_inode_info 0 13 NULL
+NumPhys__EVENT_DATA_SAS_EXPANDER_STATUS_CHANGE_17_fields NumPhys _EVENT_DATA_SAS_EXPANDER_STATUS_CHANGE 0 17 NULL
+pci_mem_start_qed_dev_info_18_fields pci_mem_start qed_dev_info 0 18 NULL
+ext4_seek_data_fndecl_21_fields ext4_seek_data fndecl 2 21 NULL
+dma_buf_sz_sxgbe_priv_data_24_fields dma_buf_sz sxgbe_priv_data 0 24 NULL nohasharray
+max_cache_pages_snd_emu10k1_24_fields max_cache_pages snd_emu10k1 0 24 &dma_buf_sz_sxgbe_priv_data_24_fields
+T9_reportid_max_mxt_data_25_fields T9_reportid_max mxt_data 0 25 NULL
+max_frags_vxge_hw_fifo_config_26_fields max_frags vxge_hw_fifo_config 0 26 NULL
+ocfs2_xattr_get_clusters_fndecl_34_fields ocfs2_xattr_get_clusters fndecl 0 34 NULL nohasharray
+ath10k_core_create_fndecl_34_fields ath10k_core_create fndecl 1 34 &ocfs2_xattr_get_clusters_fndecl_34_fields
+total_drm_buf_35_fields total drm_buf 0 35 NULL
+sis5595_device_add_fndecl_39_fields sis5595_device_add fndecl 1 39 NULL
+nr_rings_blkfront_info_42_fields nr_rings blkfront_info 0 42 NULL
+mc_vram_size_amdgpu_mc_45_fields mc_vram_size amdgpu_mc 0 45 NULL
+pattern_len_tcf_em_text_57_fields pattern_len tcf_em_text 0 57 NULL nohasharray
+p54_init_common_fndecl_57_fields p54_init_common fndecl 1 57 &pattern_len_tcf_em_text_57_fields
+rx_desc_count_i40evf_adapter_62_fields rx_desc_count i40evf_adapter 0 62 NULL
+len_nf_ct_ext_63_fields len nf_ct_ext 0 63 NULL
+sl811_hc_init_fndecl_66_fields sl811_hc_init fndecl 2-3 66 NULL
+cipso_v4_delopt_fndecl_67_fields cipso_v4_delopt fndecl 0 67 NULL
+mtt_seg_size_mthca_limits_72_fields mtt_seg_size mthca_limits 0 72 NULL
+iov_iter_get_pages_alloc_fndecl_76_fields iov_iter_get_pages_alloc fndecl 0 76 NULL
+iwch_reject_cr_fndecl_78_fields iwch_reject_cr fndecl 3 78 NULL
+data_size_data_queue_85_fields data_size data_queue 0 85 NULL
+ceph_dir_llseek_fndecl_99_fields ceph_dir_llseek fndecl 2 99 NULL
+erase_size_flash_info_100_fields erase_size flash_info 0 100 NULL
+ncp_do_request_fndecl_102_fields ncp_do_request fndecl 2-4-0 102 NULL
+fi_blkno_ocfs2_find_inode_args_104_fields fi_blkno ocfs2_find_inode_args 0 104 NULL
+phase_snd_usb_endpoint_106_fields phase snd_usb_endpoint 0 106 NULL
+num_leds_hidled_config_108_fields num_leds hidled_config 0 108 NULL
+add_new_gdb_meta_bg_fndecl_116_fields add_new_gdb_meta_bg fndecl 3 116 NULL
+buffer_min_vardecl_floppy_c_117_fields buffer_min vardecl_floppy.c 0 117 NULL
+needed_tailroom_net_device_118_fields needed_tailroom net_device 0 118 NULL
+send_remove_xattr_fndecl_122_fields send_remove_xattr fndecl 4 122 NULL
+in_ep_rtl_usb_128_fields in_ep rtl_usb 0 128 NULL nohasharray
+number_i40e_aqc_list_capabilities_element_resp_128_fields number i40e_aqc_list_capabilities_element_resp 0 128 &in_ep_rtl_usb_128_fields
+in_num_nct6683_data_132_fields in_num nct6683_data 0 132 NULL
+xfs_dir_removename_fndecl_133_fields xfs_dir_removename fndecl 7 133 NULL
+nr_pages_dma_mapping_136_fields nr_pages dma_mapping 0 136 NULL
+data_offset_netup_dma_139_fields data_offset netup_dma 0 139 NULL nohasharray
+len_io_failure_record_139_fields len io_failure_record 0 139 &data_offset_netup_dma_139_fields
+n_mac_vlan_filters_vfpf_set_q_filters_tlv_142_fields n_mac_vlan_filters vfpf_set_q_filters_tlv 0 142 NULL
+leaf_move_items_fndecl_145_fields leaf_move_items fndecl 4 145 NULL
+ir_context_support_fw_ohci_147_fields ir_context_support fw_ohci 0 147 NULL
+uvc_endpoint_max_bpi_fndecl_155_fields uvc_endpoint_max_bpi fndecl 0 155 NULL
+ext4_ext_remove_space_fndecl_170_fields ext4_ext_remove_space fndecl 3-2 170 NULL
+vfs_write_fndecl_176_fields vfs_write fndecl 3-0 176 NULL
+length_sl811h_ep_186_fields length sl811h_ep 0 186 NULL
+sddr55_write_data_fndecl_188_fields sddr55_write_data fndecl 3 188 NULL
+sys_pwrite64_fndecl_206_fields sys_pwrite64 fndecl 3 206 NULL
+xfs_zero_file_space_fndecl_211_fields xfs_zero_file_space fndecl 2-3 211 NULL nohasharray
+bn_shadow_fndecl_211_fields bn_shadow fndecl 2 211 &xfs_zero_file_space_fndecl_211_fields
+copies_r10conf_216_fields copies r10conf 0 216 NULL
+drm_universal_plane_init_fndecl_219_fields drm_universal_plane_init fndecl 6 219 NULL
+encap_hlen_ip6_tnl_encap_ops_223_fields encap_hlen ip6_tnl_encap_ops 0 223 NULL
+optrom_size_qla_hw_data_230_fields optrom_size qla_hw_data 0 230 NULL
+ad9523_write_fndecl_233_fields ad9523_write fndecl 2 233 NULL
+ocfs2_mark_extent_refcounted_fndecl_240_fields ocfs2_mark_extent_refcounted fndecl 6-4 240 NULL
+musb_readw_vardecl_241_fields musb_readw vardecl 0 241 NULL
+sysv_inode_by_name_fndecl_242_fields sysv_inode_by_name fndecl 0 242 NULL
+offset_nvkm_vma_248_fields offset nvkm_vma 0 248 NULL
+amdgpu_vm_directory_size_fndecl_249_fields amdgpu_vm_directory_size fndecl 0 249 NULL
+ixgbevf_change_mtu_fndecl_251_fields ixgbevf_change_mtu fndecl 2 251 NULL nohasharray
+pclk_limit_ov6650_251_fields pclk_limit ov6650 0 251 &ixgbevf_change_mtu_fndecl_251_fields
+minimum_acpi_address32_attribute_256_fields minimum acpi_address32_attribute 0 256 NULL
+l2cap_parse_conf_req_fndecl_260_fields l2cap_parse_conf_req fndecl 0 260 NULL
+max_can_queue_fc_fcp_internal_270_fields max_can_queue fc_fcp_internal 0 270 NULL
+dbg_leb_change_fndecl_272_fields dbg_leb_change fndecl 4 272 NULL
+tcp_current_mss_fndecl_275_fields tcp_current_mss fndecl 0 275 NULL
+vmbus_sendpacket_multipagebuffer_fndecl_276_fields vmbus_sendpacket_multipagebuffer fndecl 4 276 NULL
+es_lblk_extent_status_280_fields es_lblk extent_status 0 280 NULL
+bytesperline_sh_veu_vfmt_288_fields bytesperline sh_veu_vfmt 0 288 NULL nohasharray
+vmscsi_size_delta_vardecl_storvsc_drv_c_288_fields vmscsi_size_delta vardecl_storvsc_drv.c 0 288 &bytesperline_sh_veu_vfmt_288_fields
+xfs_qm_dqread_fndecl_302_fields xfs_qm_dqread fndecl 0 302 NULL nohasharray
+num_targets_dm_table_302_fields num_targets dm_table 0 302 &xfs_qm_dqread_fndecl_302_fields
+tx_ring_size_mvneta_port_307_fields tx_ring_size mvneta_port 0 307 NULL
+omapdss_update_prop_fndecl_309_fields omapdss_update_prop fndecl 3 309 NULL
+cfpkt_create_pfx_fndecl_313_fields cfpkt_create_pfx fndecl 2 313 NULL
+MaxBufferSize_negotiate_rsp_314_fields MaxBufferSize negotiate_rsp 0 314 NULL
+name_len_jffs2_raw_xattr_318_fields name_len jffs2_raw_xattr 0 318 NULL
+bo_handle_count_drm_vc4_submit_cl_326_fields bo_handle_count drm_vc4_submit_cl 0 326 NULL
+start_fb_cmap_user_333_fields start fb_cmap_user 0 333 NULL
+block_size_se_dev_attrib_334_fields block_size se_dev_attrib 0 334 NULL
+xfs_file_iomap_begin_fndecl_341_fields xfs_file_iomap_begin fndecl 2-3 341 NULL
+udl_submit_urb_fndecl_353_fields udl_submit_urb fndecl 3 353 NULL
+tx_idx_bchannel_355_fields tx_idx bchannel 0 355 NULL
+link_buf_size_dvb_ca_slot_365_fields link_buf_size dvb_ca_slot 0 365 NULL
+length_st21nfca_atr_req_366_fields length st21nfca_atr_req 0 366 NULL
+setup_ctxt_fndecl_374_fields setup_ctxt fndecl 2 374 NULL
+cxgbit_ppod_init_idata_fndecl_384_fields cxgbit_ppod_init_idata fndecl 4 384 NULL
+duplex_tg3_link_config_395_fields duplex tg3_link_config 0 395 NULL
+keyspan_pda_write_fndecl_398_fields keyspan_pda_write fndecl 4 398 NULL
+cyberjack_write_fndecl_399_fields cyberjack_write fndecl 4 399 NULL
+fcp_resid_bnx2fc_cmd_412_fields fcp_resid bnx2fc_cmd 0 412 NULL
+base_cbuf_417_fields base cbuf 0 417 NULL
+mp_config_acpi_gsi_fndecl_419_fields mp_config_acpi_gsi fndecl 2 419 NULL
+fat_short2uni_fndecl_423_fields fat_short2uni fndecl 0 423 NULL
+vol_reg_size_tas571x_chip_426_fields vol_reg_size tas571x_chip 0 426 NULL
+status_netdev_desc_430_fields status netdev_desc 0 430 NULL
+twsk_obj_size_timewait_sock_ops_433_fields twsk_obj_size timewait_sock_ops 0 433 NULL
+rx_buf_sz_rhine_private_435_fields rx_buf_sz rhine_private 0 435 NULL
+id_alias_prop_438_fields id alias_prop 0 438 NULL
+get_conn_info_fndecl_440_fields get_conn_info fndecl 4 440 NULL
+intr_count_ql_adapter_442_fields intr_count ql_adapter 0 442 NULL nohasharray
+pdata_size_mfd_cell_442_fields pdata_size mfd_cell 0 442 &intr_count_ql_adapter_442_fields
+challenge_len_ieee802_11_elems_444_fields challenge_len ieee802_11_elems 0 444 NULL nohasharray
+btrfs_map_bio_fndecl_444_fields btrfs_map_bio fndecl 0 444 &challenge_len_ieee802_11_elems_444_fields
+cem_build_path_fndecl_451_fields cem_build_path fndecl 0 451 NULL
+pkts_acked_yeah_452_fields pkts_acked yeah 0 452 NULL
+root_entry_lctp_fndecl_459_fields root_entry_lctp fndecl 0 459 NULL
+e_shnum_elf64_hdr_461_fields e_shnum elf64_hdr 0 461 NULL
+udf_load_logicalvol_fndecl_471_fields udf_load_logicalvol fndecl 2 471 NULL
+mlx5_ib_rereg_user_mr_fndecl_473_fields mlx5_ib_rereg_user_mr fndecl 5-4 473 NULL
+make_checksum_v2_fndecl_475_fields make_checksum_v2 fndecl 3-5 475 NULL
+map_write_fndecl_480_fields map_write fndecl 3 480 NULL
+diva_alloc_dma_map_fndecl_485_fields diva_alloc_dma_map fndecl 2 485 NULL
+ext_start_xfs_extent_486_fields ext_start xfs_extent 0 486 NULL
+consumed_sg_mapping_iter_487_fields consumed sg_mapping_iter 0 487 NULL
+nr_local_rds_rdma_args_488_fields nr_local rds_rdma_args 0 488 NULL
+sp2_read_i2c_fndecl_489_fields sp2_read_i2c fndecl 4 489 NULL
+edid_store_fndecl_491_fields edid_store fndecl 6 491 NULL
+max_seg_sz_mmc_test_area_502_fields max_seg_sz mmc_test_area 0 502 NULL
+tracing_map_create_fndecl_506_fields tracing_map_create fndecl 2-1 506 NULL nohasharray
+wa_xfer_status_to_errno_fndecl_506_fields wa_xfer_status_to_errno fndecl 0 506 &tracing_map_create_fndecl_506_fields
+hlen_ip6_tnl_510_fields hlen ip6_tnl 0 510 NULL
+gfn_guest_walkerEPT_517_fields gfn guest_walkerEPT 0 517 NULL
+dig_rate_snd_bt87x_board_522_fields dig_rate snd_bt87x_board 0 522 NULL
+read_mv88e6xxx_ops_525_fields read mv88e6xxx_ops 0 525 NULL
+v9fs_xattr_set_acl_fndecl_526_fields v9fs_xattr_set_acl fndecl 6 526 NULL
+videobuf_read_zerocopy_fndecl_546_fields videobuf_read_zerocopy fndecl 3 546 NULL
+iscsi_add_hdr_fndecl_551_fields iscsi_add_hdr fndecl 2 551 NULL
+leaf_paste_in_buffer_fndecl_552_fields leaf_paste_in_buffer fndecl 4 552 NULL
+behind_page_count_r1bio_557_fields behind_page_count r1bio 0 557 NULL
+cmd_amdkfd_ioctl_desc_560_fields cmd amdkfd_ioctl_desc 0 560 NULL
+disk_secno_bplus_leaf_node_574_fields disk_secno bplus_leaf_node 0 574 NULL
+ext4_swap_extents_fndecl_577_fields ext4_swap_extents fndecl 6-0-5-4 577 NULL
+log_mc_entry_sz_mlx4_init_hca_param_595_fields log_mc_entry_sz mlx4_init_hca_param 0 595 NULL
+max_send_sge_ib_qp_cap_601_fields max_send_sge ib_qp_cap 0 601 NULL
+nr_groups_pcpu_alloc_info_602_fields nr_groups pcpu_alloc_info 0 602 NULL
+xfs_bmapi_read_fndecl_603_fields xfs_bmapi_read fndecl 0-3-2 603 NULL nohasharray
+lcm_not_zero_fndecl_603_fields lcm_not_zero fndecl 0-1-2 603 &xfs_bmapi_read_fndecl_603_fields nohasharray
+sock_xmit_fndecl_603_fields sock_xmit fndecl 4 603 &lcm_not_zero_fndecl_603_fields
+ceph_oloc_encoding_size_fndecl_604_fields ceph_oloc_encoding_size fndecl 0 604 NULL nohasharray
+FormattedSize_erase_unit_header_t_604_fields FormattedSize erase_unit_header_t 0 604 &ceph_oloc_encoding_size_fndecl_604_fields
+pvr2_v4l2_ioctl_fndecl_605_fields pvr2_v4l2_ioctl fndecl 2 605 NULL
+num_queue_pairs_i40e_virtchnl_vf_resource_613_fields num_queue_pairs i40e_virtchnl_vf_resource 0 613 NULL
+virt_end_dm_thin_new_mapping_616_fields virt_end dm_thin_new_mapping 0 616 NULL
+maxsize_tm6000_endpoint_618_fields maxsize tm6000_endpoint 0 618 NULL
+priv_size_mlxsw_driver_636_fields priv_size mlxsw_driver 0 636 NULL nohasharray
+hfi1_make_grh_fndecl_636_fields hfi1_make_grh fndecl 0 636 &priv_size_mlxsw_driver_636_fields
+ieee80211_rx_mgmt_beacon_fndecl_637_fields ieee80211_rx_mgmt_beacon fndecl 3 637 NULL
+msg_len_dvb_diseqc_master_cmd_643_fields msg_len dvb_diseqc_master_cmd 0 643 NULL nohasharray
+d1_vring_rx_mac_643_fields d1 vring_rx_mac 0 643 &msg_len_dvb_diseqc_master_cmd_643_fields
+size_si_sm_handlers_648_fields size si_sm_handlers 0 648 NULL
+ddp_ppod_write_idata_fndecl_649_fields ddp_ppod_write_idata fndecl 5 649 NULL nohasharray
+set_vmcore_list_offsets_fndecl_649_fields set_vmcore_list_offsets fndecl 2-1 649 &ddp_ppod_write_idata_fndecl_649_fields
+fat_sync_bhs_fndecl_655_fields fat_sync_bhs fndecl 0 655 NULL
+rtsx_usb_read_ppbuf_fndecl_659_fields rtsx_usb_read_ppbuf fndecl 3 659 NULL
+start_async_extent_663_fields start async_extent 0 663 NULL
+tx_max_size_cxgbi_device_664_fields tx_max_size cxgbi_device 0 664 NULL
+cw_cursor_fndecl_666_fields cw_cursor fndecl 4 666 NULL
+__push_leaf_left_fndecl_667_fields __push_leaf_left fndecl 8 667 NULL
+dccph_seq2_dccp_hdr_669_fields dccph_seq2 dccp_hdr 0 669 NULL
+num_leds_led_pwm_platform_data_670_fields num_leds led_pwm_platform_data 0 670 NULL
+lbs_highsnr_write_fndecl_671_fields lbs_highsnr_write fndecl 3 671 NULL
+skb_size_nx_host_rds_ring_672_fields skb_size nx_host_rds_ring 0 672 NULL
+bond_change_mtu_fndecl_674_fields bond_change_mtu fndecl 2 674 NULL
+mac_len_sk_buff_676_fields mac_len sk_buff 0 676 NULL
+mbox_offset_sst_res_info_678_fields mbox_offset sst_res_info 0 678 NULL
+page_order_sg_scatter_hold_679_fields page_order sg_scatter_hold 0 679 NULL
+stats_count_smsdvb_debugfs_683_fields stats_count smsdvb_debugfs 0 683 NULL
+get_eeprom_len_ethtool_ops_686_fields get_eeprom_len ethtool_ops 0 686 NULL
+follow_page_pte_fndecl_687_fields follow_page_pte fndecl 2 687 NULL
+mchip_get_frame_fndecl_692_fields mchip_get_frame fndecl 0 692 NULL
+sig_size_s3fwrn5_fw_info_719_fields sig_size s3fwrn5_fw_info 0 719 NULL
+qib_ib_rcv_fndecl_734_fields qib_ib_rcv fndecl 4 734 NULL
+tsi148_alloc_resource_fndecl_736_fields tsi148_alloc_resource fndecl 2 736 NULL
+write_cache_pages_fndecl_737_fields write_cache_pages fndecl 0 737 NULL
+count_TxFifo_750_fields count TxFifo 0 750 NULL
+add_falloc_range_fndecl_751_fields add_falloc_range fndecl 2-3 751 NULL
+DataBufsSize_snd_korg1212_758_fields DataBufsSize snd_korg1212 0 758 NULL
+ilf_len_xfs_inode_log_format_759_fields ilf_len xfs_inode_log_format 0 759 NULL
+tda8083_readregs_fndecl_764_fields tda8083_readregs fndecl 4 764 NULL nohasharray
+controller_code_mspro_sys_info_764_fields controller_code mspro_sys_info 0 764 &tda8083_readregs_fndecl_764_fields
+iwl_trans_alloc_fndecl_767_fields iwl_trans_alloc fndecl 5 767 NULL
+len_vnic_dev_bar_768_fields len vnic_dev_bar 0 768 NULL
+vb2_fop_read_fndecl_771_fields vb2_fop_read fndecl 3 771 NULL
+truncate_one_csum_fndecl_777_fields truncate_one_csum fndecl 4-5 777 NULL
+gem_change_mtu_fndecl_785_fields gem_change_mtu fndecl 2 785 NULL
+prepare_reply_buffer_fndecl_793_fields prepare_reply_buffer fndecl 4-3-5 793 NULL
+extent_direct_795_fields extent direct 0 795 NULL
+height_qxl_head_799_fields height qxl_head 0 799 NULL
+pci_iomap_range_fndecl_809_fields pci_iomap_range fndecl 4-3 809 NULL
+sdp1length__SpiCfgData_813_fields sdp1length _SpiCfgData 0 813 NULL
+alloc_nvdimm_map_fndecl_828_fields alloc_nvdimm_map fndecl 3-2 828 NULL
+mdata_ofsh_cyttsp4_sysinfo_data_844_fields mdata_ofsh cyttsp4_sysinfo_data 0 844 NULL
+s_inopb_ufs_sb_private_info_849_fields s_inopb ufs_sb_private_info 0 849 NULL
+rsi_copy_to_card_fndecl_858_fields rsi_copy_to_card fndecl 3 858 NULL
+unix_seqpacket_recvmsg_fndecl_861_fields unix_seqpacket_recvmsg fndecl 3 861 NULL
+qi_dqperchunk_xfs_quotainfo_863_fields qi_dqperchunk xfs_quotainfo 0 863 NULL
+adu_read_fndecl_866_fields adu_read fndecl 3 866 NULL
+safe_prepare_write_buffer_fndecl_872_fields safe_prepare_write_buffer fndecl 3 872 NULL
+orinoco_change_mtu_fndecl_895_fields orinoco_change_mtu fndecl 2 895 NULL nohasharray
+forw_xfs_attr3_icleaf_hdr_895_fields forw xfs_attr3_icleaf_hdr 0 895 &orinoco_change_mtu_fndecl_895_fields
+p_srate_f_uac2_opts_896_fields p_srate f_uac2_opts 0 896 NULL
+vm_normal_page_fndecl_897_fields vm_normal_page fndecl 2 897 NULL
+rdma_copy_tail_fndecl_898_fields rdma_copy_tail fndecl 3 898 NULL nohasharray
+cpu_mask_len_res_opts_898_fields cpu_mask_len res_opts 0 898 &rdma_copy_tail_fndecl_898_fields
+user_bs_factor_ide_tape_obj_906_fields user_bs_factor ide_tape_obj 0 906 NULL
+good_bytes_nfs_pgio_header_909_fields good_bytes nfs_pgio_header 0 909 NULL
+num_channels_wmi_start_scan_cmd_915_fields num_channels wmi_start_scan_cmd 0 915 NULL
+set_args_iw_priv_args_916_fields set_args iw_priv_args 0 916 NULL
+post_fifo_size__adpt_hba_919_fields post_fifo_size _adpt_hba 0 919 NULL
+nci_nfcc_loopback_fndecl_923_fields nci_nfcc_loopback fndecl 3 923 NULL
+status_word_gem_rxd_925_fields status_word gem_rxd 0 925 NULL nohasharray
+video_hsize_solo_dev_925_fields video_hsize solo_dev 0 925 &status_word_gem_rxd_925_fields nohasharray
+amt_complete_orangefs_io_response_925_fields amt_complete orangefs_io_response 0 925 &video_hsize_solo_dev_925_fields
+isofs_bread_fndecl_929_fields isofs_bread fndecl 2 929 NULL
+xpnet_dev_change_mtu_fndecl_932_fields xpnet_dev_change_mtu fndecl 2 932 NULL
+nfrags_pkt_gl_937_fields nfrags pkt_gl 0 937 NULL
+size_skl_algo_data_942_fields size skl_algo_data 0 942 NULL nohasharray
+num_spis_alpine_msix_data_942_fields num_spis alpine_msix_data 0 942 &size_skl_algo_data_942_fields
+pci_num_vf_fndecl_952_fields pci_num_vf fndecl 0 952 NULL
+ssid_len_wireless_dev_954_fields ssid_len wireless_dev 0 954 NULL
+length_ndis_80211_bssid_ex_955_fields length ndis_80211_bssid_ex 0 955 NULL
+xfs_bmap_rtalloc_fndecl_958_fields xfs_bmap_rtalloc fndecl 0 958 NULL
+size_wl3501_md_ind_961_fields size wl3501_md_ind 0 961 NULL
+calculate_sizes_fndecl_962_fields calculate_sizes fndecl 2 962 NULL
+compat_sys_preadv64_fndecl_968_fields compat_sys_preadv64 fndecl 3 968 NULL
+tx_ring_size_tx_queue_982_fields tx_ring_size tx_queue 0 982 NULL
+s_blocks_count_hi_ext4_super_block_983_fields s_blocks_count_hi ext4_super_block 0 983 NULL nohasharray
+em28xx_alloc_urbs_fndecl_983_fields em28xx_alloc_urbs fndecl 5-6 983 &s_blocks_count_hi_ext4_super_block_983_fields
+nd_integrity_init_fndecl_985_fields nd_integrity_init fndecl 2 985 NULL nohasharray
+sm501_create_subio_fndecl_985_fields sm501_create_subio fndecl 4-3 985 &nd_integrity_init_fndecl_985_fields
+esp6_get_mtu_fndecl_987_fields esp6_get_mtu fndecl 0-2 987 NULL
+acc_userl_accessdata_dn_989_fields acc_userl accessdata_dn 0 989 NULL
+gtt_size_amdgpu_mc_994_fields gtt_size amdgpu_mc 0 994 NULL
+ContainerSwitchEntries_aac_get_container_count_resp_1001_fields ContainerSwitchEntries aac_get_container_count_resp 0 1001 NULL
+reserve_metadata_bytes_fndecl_1002_fields reserve_metadata_bytes fndecl 0 1002 NULL
+cpu_count_MPT3SAS_ADAPTER_1003_fields cpu_count MPT3SAS_ADAPTER 0 1003 NULL
+xfs_dir3_leafn_read_fndecl_1004_fields xfs_dir3_leafn_read fndecl 3 1004 NULL
+__dm_get_module_param_fndecl_1008_fields __dm_get_module_param fndecl 2-3-0 1008 NULL
+assoc_req_len_wmi_connect_event_1014_fields assoc_req_len wmi_connect_event 0 1014 NULL
+i2c_smbus_check_pec_fndecl_1018_fields i2c_smbus_check_pec fndecl 0 1018 NULL
+nvram_size_chip_desc_1022_fields nvram_size chip_desc 0 1022 NULL
+len_wcn36xx_hal_msg_header_1023_fields len wcn36xx_hal_msg_header 0 1023 NULL
+dlm_len_mt76_fw_header_1030_fields dlm_len mt76_fw_header 0 1030 NULL
+pci_scan_single_device_fndecl_1034_fields pci_scan_single_device fndecl 2 1034 NULL
+wq_ecount_lpfc_sli4_hba_1039_fields wq_ecount lpfc_sli4_hba 0 1039 NULL
+page_shift_mlx5_buf_1041_fields page_shift mlx5_buf 0 1041 NULL nohasharray
+ssb_admatch_size_fndecl_1041_fields ssb_admatch_size fndecl 0-1 1041 &page_shift_mlx5_buf_1041_fields
+iv_len_txentry_desc_1042_fields iv_len txentry_desc 0 1042 NULL nohasharray
+address_length_acpi_resource_fixed_io_1042_fields address_length acpi_resource_fixed_io 0 1042 &iv_len_txentry_desc_1042_fields
+read_data_done_iscsi_datain_req_1049_fields read_data_done iscsi_datain_req 0 1049 NULL nohasharray
+registers_gen_74x164_chip_1049_fields registers gen_74x164_chip 0 1049 &read_data_done_iscsi_datain_req_1049_fields
+amdgpu_cgs_alloc_gpu_mem_fndecl_1052_fields amdgpu_cgs_alloc_gpu_mem fndecl 3 1052 NULL nohasharray
+m5602_urb_complete_fndecl_1052_fields m5602_urb_complete fndecl 3 1052 &amdgpu_cgs_alloc_gpu_mem_fndecl_1052_fields
+nentries_ebt_replace_1059_fields nentries ebt_replace 0 1059 NULL
+ch_r_tail_jsm_channel_1063_fields ch_r_tail jsm_channel 0 1063 NULL
+data_ep_set_params_fndecl_1064_fields data_ep_set_params fndecl 3-4 1064 NULL
+cw_clear_fndecl_1066_fields cw_clear fndecl 5-3-4-6 1066 NULL
+len_left_brcmf_sdio_hdrinfo_1067_fields len_left brcmf_sdio_hdrinfo 0 1067 NULL nohasharray
+tcp_scalable_cong_avoid_fndecl_1067_fields tcp_scalable_cong_avoid fndecl 3 1067 &len_left_brcmf_sdio_hdrinfo_1067_fields
+i_dno_hpfs_inode_info_1070_fields i_dno hpfs_inode_info 0 1070 NULL nohasharray
+line__mgslpc_info_1070_fields line _mgslpc_info 0 1070 &i_dno_hpfs_inode_info_1070_fields
+num_min_snd_ratden_1071_fields num_min snd_ratden 0 1071 NULL
+private_data_len_iw_cm_conn_param_1076_fields private_data_len iw_cm_conn_param 0 1076 NULL
+rq_wqe_count_mlx5_ib_create_qp_1079_fields rq_wqe_count mlx5_ib_create_qp 0 1079 NULL
+ReadEEProm_fndecl_1081_fields ReadEEProm fndecl 3 1081 NULL
+max_srq_sz_mthca_dev_lim_1088_fields max_srq_sz mthca_dev_lim 0 1088 NULL
+libipw_classify_fndecl_1089_fields libipw_classify fndecl 0 1089 NULL
+data_start_msdos_sb_info_1100_fields data_start msdos_sb_info 0 1100 NULL
+rx_ring_count_e1000_adapter_1107_fields rx_ring_count e1000_adapter 0 1107 NULL
+ResponseDataLength__MPI2_SMP_PASSTHROUGH_REPLY_1113_fields ResponseDataLength _MPI2_SMP_PASSTHROUGH_REPLY 0 1113 NULL
+io_free_memtype_fndecl_1116_fields io_free_memtype fndecl 1-2 1116 NULL
+slave_cnt_bonding_1119_fields slave_cnt bonding 0 1119 NULL
+rxkad_decrypt_ticket_fndecl_1120_fields rxkad_decrypt_ticket fndecl 3 1120 NULL
+ctl_in_pipe_brcmf_usbdev_info_1124_fields ctl_in_pipe brcmf_usbdev_info 0 1124 NULL
+forw_xfs_dir3_icleaf_hdr_1136_fields forw xfs_dir3_icleaf_hdr 0 1136 NULL
+log_num_mlx4_resource_1137_fields log_num mlx4_resource 0 1137 NULL
+alloc_rss_size_i40e_pf_1138_fields alloc_rss_size i40e_pf 0 1138 NULL
+p54spi_spi_read_fndecl_1149_fields p54spi_spi_read fndecl 4 1149 NULL
+offset_mirror_1150_fields offset mirror 0 1150 NULL
+ntfs_rl_vcn_to_lcn_fndecl_1155_fields ntfs_rl_vcn_to_lcn fndecl 0-2 1155 NULL
+cbuf_data_fndecl_1158_fields cbuf_data fndecl 0 1158 NULL
+sysctl_tcp_max_reordering_vardecl_1161_fields sysctl_tcp_max_reordering vardecl 0 1161 NULL
+rtsx_usb_write_ppbuf_fndecl_1165_fields rtsx_usb_write_ppbuf fndecl 3 1165 NULL
+nfs4_acl_bytes_fndecl_1168_fields nfs4_acl_bytes fndecl 1 1168 NULL nohasharray
+sg_len_mmc_data_1168_fields sg_len mmc_data 0 1168 &nfs4_acl_bytes_fndecl_1168_fields
+__set_xattr_fndecl_1176_fields __set_xattr fndecl 5-3 1176 NULL nohasharray
+indata_len_ceph_osd_req_op_1176_fields indata_len ceph_osd_req_op 0 1176 &__set_xattr_fndecl_1176_fields
+br_vlan_add_fndecl_1177_fields br_vlan_add fndecl 2 1177 NULL
+nr_push_drm_nouveau_gem_pushbuf_1184_fields nr_push drm_nouveau_gem_pushbuf 0 1184 NULL
+probe_resp_len_cfg80211_beacon_data_1195_fields probe_resp_len cfg80211_beacon_data 0 1195 NULL
+rdmarc_per_qp_mlx4_profile_1197_fields rdmarc_per_qp mlx4_profile 0 1197 NULL
+nfs4_get_security_label_fndecl_1201_fields nfs4_get_security_label fndecl 3 1201 NULL nohasharray
+rx_sdu_size_tsap_cb_1201_fields rx_sdu_size tsap_cb 0 1201 &nfs4_get_security_label_fndecl_1201_fields
+pvscsi_ring_pages_vardecl_vmw_pvscsi_c_1202_fields pvscsi_ring_pages vardecl_vmw_pvscsi.c 0 1202 NULL
+max_sge_mvumi_hba_1213_fields max_sge mvumi_hba 0 1213 NULL
+max_transfer_bytes_storvsc_device_1221_fields max_transfer_bytes storvsc_device 0 1221 NULL
+max_pkt_size_au0828_dev_1222_fields max_pkt_size au0828_dev 0 1222 NULL nohasharray
+tcp_synack_options_fndecl_1222_fields tcp_synack_options fndecl 0 1222 &max_pkt_size_au0828_dev_1222_fields
+segno_curseg_info_1223_fields segno curseg_info 0 1223 NULL
+pfkey_sendmsg_fndecl_1225_fields pfkey_sendmsg fndecl 3 1225 NULL
+i_sblock_bfs_inode_info_1228_fields i_sblock bfs_inode_info 0 1228 NULL
+cached_dev_cache_miss_fndecl_1232_fields cached_dev_cache_miss fndecl 4 1232 NULL
+prev_chunk_sectors_r5conf_1237_fields prev_chunk_sectors r5conf 0 1237 NULL
+elf_headers_sz_kimage_arch_1238_fields elf_headers_sz kimage_arch 0 1238 NULL
+buffer_dma_zd_usb_interrupt_1239_fields buffer_dma zd_usb_interrupt 0 1239 NULL
+iwl_mvm_sta_tx_agg_start_fndecl_1243_fields iwl_mvm_sta_tx_agg_start fndecl 4 1243 NULL
+dlc_leaf_msg_log_message_1244_fields dlc leaf_msg_log_message 0 1244 NULL
+max_vports_lpfc_hba_1253_fields max_vports lpfc_hba 0 1253 NULL
+find_highest_prio_tid_fndecl_1254_fields find_highest_prio_tid fndecl 0 1254 NULL
+num_slaves_mlx4_dev_1258_fields num_slaves mlx4_dev 0 1258 NULL
+alloc32_mon_bin_get32_1260_fields alloc32 mon_bin_get32 0 1260 NULL
+nfs_readdir_xdr_filler_fndecl_1265_fields nfs_readdir_xdr_filler fndecl 0 1265 NULL
+nlmsg_len_nlmsghdr_1272_fields nlmsg_len nlmsghdr 0 1272 NULL
+bictcp_cong_avoid_fndecl_1278_fields bictcp_cong_avoid fndecl 3 1278 NULL
+__lbtf_cmd_async_fndecl_1280_fields __lbtf_cmd_async fndecl 4 1280 NULL
+ocfs2_read_extent_block_fndecl_1285_fields ocfs2_read_extent_block fndecl 0-2 1285 NULL
+fw_epd_frame_1293_fields fw epd_frame 0 1293 NULL
+ieee80211_stop_rx_ba_session_offl_fndecl_1297_fields ieee80211_stop_rx_ba_session_offl fndecl 3 1297 NULL
+prv_size_override_lpss_device_desc_1301_fields prv_size_override lpss_device_desc 0 1301 NULL
+wMaxControlMessage_usb_cdc_mbim_desc_1308_fields wMaxControlMessage usb_cdc_mbim_desc 0 1308 NULL
+vmw_kms_stdu_surface_dirty_fndecl_1310_fields vmw_kms_stdu_surface_dirty fndecl 8 1310 NULL
+txhdr_len_mlxsw_driver_1313_fields txhdr_len mlxsw_driver 0 1313 NULL nohasharray
+number_snd_pcm_substream_1313_fields number snd_pcm_substream 0 1313 &txhdr_len_mlxsw_driver_1313_fields nohasharray
+curr_resync_mddev_1313_fields curr_resync mddev 0 1313 &number_snd_pcm_substream_1313_fields
+vd_cbr_au_count_gru_vma_data_1314_fields vd_cbr_au_count gru_vma_data 0 1314 NULL
+win_size_async_state_1326_fields win_size async_state 0 1326 NULL
+ufs_alloc_lastblock_fndecl_1339_fields ufs_alloc_lastblock fndecl 2 1339 NULL
+fat_parse_short_fndecl_1348_fields fat_parse_short fndecl 0 1348 NULL
+current_limit_memblock_1350_fields current_limit memblock 0 1350 NULL
+ccp_set_dm_area_fndecl_1351_fields ccp_set_dm_area fndecl 4 1351 NULL
+found_index_locate_info_1355_fields found_index locate_info 0 1355 NULL
+smaps_pte_entry_fndecl_1359_fields smaps_pte_entry fndecl 2 1359 NULL
+MemReadHSCX_fndecl_1364_fields MemReadHSCX fndecl 0 1364 NULL
+len_btrfs_ordered_sum_1365_fields len btrfs_ordered_sum 0 1365 NULL nohasharray
+ssram_size_telemetry_unit_config_1365_fields ssram_size telemetry_unit_config 0 1365 &len_btrfs_ordered_sum_1365_fields
+tx_ring_count_xgbe_prv_data_1366_fields tx_ring_count xgbe_prv_data 0 1366 NULL
+len_orinoco_scan_data_1370_fields len orinoco_scan_data 0 1370 NULL nohasharray
+dlen_hci_sco_hdr_1370_fields dlen hci_sco_hdr 0 1370 &len_orinoco_scan_data_1370_fields
+v_total_aty128_crtc_1375_fields v_total aty128_crtc 0 1375 NULL
+rx_tpa_start_cmp_hdr_info_rx_tpa_start_cmp_ext_1380_fields rx_tpa_start_cmp_hdr_info rx_tpa_start_cmp_ext 0 1380 NULL
+w_drm_vmw_rect_1383_fields w drm_vmw_rect 0 1383 NULL
+ieee80211_probereq_get_fndecl_1384_fields ieee80211_probereq_get fndecl 5-4 1384 NULL
+vlen_nfsd3_writeargs_1388_fields vlen nfsd3_writeargs 0 1388 NULL
+smsc911x_rx_get_rxstatus_fndecl_1389_fields smsc911x_rx_get_rxstatus fndecl 0 1389 NULL
+stepped_offset_skb_seq_state_1395_fields stepped_offset skb_seq_state 0 1395 NULL
+len_wsm_hdr_1398_fields len wsm_hdr 0 1398 NULL
+dev_size_amd_flash_info_1399_fields dev_size amd_flash_info 0 1399 NULL
+cmd_size_scsi_host_template_1404_fields cmd_size scsi_host_template 0 1404 NULL
+num_hsi_port_1406_fields num hsi_port 0 1406 NULL
+ec_hdr_alsize_ubi_device_1411_fields ec_hdr_alsize ubi_device 0 1411 NULL
+ubifs_leb_write_fndecl_1412_fields ubifs_leb_write fndecl 5-4 1412 NULL
+copy_pages_to_kvecs_fndecl_1417_fields copy_pages_to_kvecs fndecl 0 1417 NULL
+fill_gap_fndecl_1418_fields fill_gap fndecl 4-3 1418 NULL
+wpa_ie_len_orinoco_private_1421_fields wpa_ie_len orinoco_private 0 1421 NULL nohasharray
+reg_umr_fndecl_1421_fields reg_umr fndecl 3 1421 &wpa_ie_len_orinoco_private_1421_fields
+bch_dump_read_fndecl_1422_fields bch_dump_read fndecl 3 1422 NULL
+tnc_insert_fndecl_1431_fields tnc_insert fndecl 4 1431 NULL
+relocation_count_drm_i915_gem_exec_object2_1435_fields relocation_count drm_i915_gem_exec_object2 0 1435 NULL
+security_set_fndecl_1439_fields security_set fndecl 6 1439 NULL
+loc_addr_rio_transfer_io_1447_fields loc_addr rio_transfer_io 0 1447 NULL nohasharray
+alloc_libipw_fndecl_1447_fields alloc_libipw fndecl 1 1447 &loc_addr_rio_transfer_io_1447_fields
+fixup_user_fault_fndecl_1456_fields fixup_user_fault fndecl 3 1456 NULL
+size_fw_sec_1464_fields size fw_sec 0 1464 NULL
+net_header_len_sctp_af_1467_fields net_header_len sctp_af 0 1467 NULL
+btrfs_del_inode_ref_in_log_fndecl_1471_fields btrfs_del_inode_ref_in_log fndecl 4 1471 NULL
+ceph_decode_32_fndecl_1473_fields ceph_decode_32 fndecl 0 1473 NULL
+xenbus_map_ring_valloc_pv_fndecl_1474_fields xenbus_map_ring_valloc_pv fndecl 3 1474 NULL
+ax25_output_fndecl_1475_fields ax25_output fndecl 2 1475 NULL
+pbus_size_io_fndecl_1478_fields pbus_size_io fndecl 2 1478 NULL
+nfs3_proc_symlink_fndecl_1479_fields nfs3_proc_symlink fndecl 4 1479 NULL
+iscsi_sw_tcp_send_data_prep_fndecl_1485_fields iscsi_sw_tcp_send_data_prep fndecl 5-4 1485 NULL
+irq_base_max8925_chip_1487_fields irq_base max8925_chip 0 1487 NULL
+ecryptfs_write_metadata_to_contents_fndecl_1490_fields ecryptfs_write_metadata_to_contents fndecl 3 1490 NULL
+de4x5_alloc_rx_buff_fndecl_1491_fields de4x5_alloc_rx_buff fndecl 3 1491 NULL
+n_channels_ieee80211_supported_band_1494_fields n_channels ieee80211_supported_band 0 1494 NULL
+blocks_count_ext4_new_group_data_1496_fields blocks_count ext4_new_group_data 0 1496 NULL
+ext4_mpage_readpages_fndecl_1499_fields ext4_mpage_readpages fndecl 4 1499 NULL
+cx18_copy_buf_to_user_fndecl_1500_fields cx18_copy_buf_to_user fndecl 4 1500 NULL nohasharray
+num_step_snd_ratden_1500_fields num_step snd_ratden 0 1500 &cx18_copy_buf_to_user_fndecl_1500_fields
+bo_info_size_drm_amdgpu_bo_list_in_1510_fields bo_info_size drm_amdgpu_bo_list_in 0 1510 NULL
+dma_data_req_size_ivtv_1512_fields dma_data_req_size ivtv 0 1512 NULL
+initiate_new_session_fndecl_1514_fields initiate_new_session fndecl 6 1514 NULL nohasharray
+__break_lease_fndecl_1514_fields __break_lease fndecl 0 1514 &initiate_new_session_fndecl_1514_fields
+sk_sndbuf_sock_1516_fields sk_sndbuf sock 0 1516 NULL
+shmem_file_setup_fndecl_1517_fields shmem_file_setup fndecl 2 1517 NULL
+buf_size_mlx4_ib_qp_1529_fields buf_size mlx4_ib_qp 0 1529 NULL
+max_rqe_ocrdma_dev_attr_1534_fields max_rqe ocrdma_dev_attr 0 1534 NULL
+grcan_allocate_dma_buffers_fndecl_1535_fields grcan_allocate_dma_buffers fndecl 2-3 1535 NULL
+readlink_inode_operations_1540_fields readlink inode_operations 0 1540 NULL
+__es_remove_extent_fndecl_1544_fields __es_remove_extent fndecl 0-3-2 1544 NULL
+max_gs_mlx4_srq_1550_fields max_gs mlx4_srq 0 1550 NULL
+prio_read_fndecl_1564_fields prio_read fndecl 2 1564 NULL
+i2cdev_write_fndecl_1565_fields i2cdev_write fndecl 3 1565 NULL
+alignment_acpi_resource_io_1569_fields alignment acpi_resource_io 0 1569 NULL
+mc13xxx_get_num_regulators_dt_fndecl_1571_fields mc13xxx_get_num_regulators_dt fndecl 0 1571 NULL
+size_drm_qxl_alloc_1578_fields size drm_qxl_alloc 0 1578 NULL
+ndesc_srp_map_state_1582_fields ndesc srp_map_state 0 1582 NULL
+sector_clone_info_1593_fields sector clone_info 0 1593 NULL
+size_icp_qat_uof_batch_init_1600_fields size icp_qat_uof_batch_init 0 1600 NULL nohasharray
+length_cpc_can_msg_1600_fields length cpc_can_msg 0 1600 &size_icp_qat_uof_batch_init_1600_fields
+block_size_c2port_ops_1610_fields block_size c2port_ops 0 1610 NULL
+pppoe_sendmsg_fndecl_1612_fields pppoe_sendmsg fndecl 3 1612 NULL
+rawv6_send_hdrinc_fndecl_1625_fields rawv6_send_hdrinc fndecl 3 1625 NULL nohasharray
+max_frame_size_usb_usbvision_1625_fields max_frame_size usb_usbvision 0 1625 &rawv6_send_hdrinc_fndecl_1625_fields
+dt_num_devices_exofs_device_table_1626_fields dt_num_devices exofs_device_table 0 1626 NULL
+size_bin_attribute_1632_fields size bin_attribute 0 1632 NULL
+num_fw_rsc_vdev_vring_1645_fields num fw_rsc_vdev_vring 0 1645 NULL
+cblock_policy_result_1648_fields cblock policy_result 0 1648 NULL
+kobil_write_fndecl_1651_fields kobil_write fndecl 4 1651 NULL
+st_set_pages_fndecl_1655_fields st_set_pages fndecl 3 1655 NULL
+onenand_fill_auto_oob_fndecl_1663_fields onenand_fill_auto_oob fndecl 4 1663 NULL
+rds_tcp_sendmsg_fndecl_1668_fields rds_tcp_sendmsg fndecl 3 1668 NULL
+num_clips_drm_vmw_present_arg_1671_fields num_clips drm_vmw_present_arg 0 1671 NULL
+hidraw_send_report_fndecl_1674_fields hidraw_send_report fndecl 3 1674 NULL
+rsrc_len_usb_hcd_1686_fields rsrc_len usb_hcd 0 1686 NULL
+file_size_squashfs_ldir_inode_1687_fields file_size squashfs_ldir_inode 0 1687 NULL
+remain_bytes_asc_q_done_info_1696_fields remain_bytes asc_q_done_info 0 1696 NULL
+size_grcan_dma_buffer_1702_fields size grcan_dma_buffer 0 1702 NULL
+divasa_remap_pci_bar_fndecl_1710_fields divasa_remap_pci_bar fndecl 4-3 1710 NULL nohasharray
+get_cap_size_qlcnic_hardware_ops_1710_fields get_cap_size qlcnic_hardware_ops 0 1710 &divasa_remap_pci_bar_fndecl_1710_fields
+ext4_getblk_fndecl_1720_fields ext4_getblk fndecl 3 1720 NULL
+osd_req_op_notify_init_fndecl_1721_fields osd_req_op_notify_init fndecl 7 1721 NULL
+yres_drm_cmdline_mode_1722_fields yres drm_cmdline_mode 0 1722 NULL
+qtd_fill_fndecl_1725_fields qtd_fill fndecl 4-5-2-0-3 1725 NULL
+submit_io_fndecl_1726_fields submit_io fndecl 3 1726 NULL
+ts_num_ids_nfsd4_test_stateid_1732_fields ts_num_ids nfsd4_test_stateid 0 1732 NULL nohasharray
+xfs_rmap_get_rec_fndecl_1732_fields xfs_rmap_get_rec fndecl 0 1732 &ts_num_ids_nfsd4_test_stateid_1732_fields
+state_hmask_netns_xfrm_1733_fields state_hmask netns_xfrm 0 1733 NULL
+__gfn_to_hva_many_fndecl_1735_fields __gfn_to_hva_many fndecl 0-2 1735 NULL
+l4_hdr_size_vmxnet3_tx_ctx_1737_fields l4_hdr_size vmxnet3_tx_ctx 0 1737 NULL
+userspace_do_request_fndecl_1738_fields userspace_do_request fndecl 5 1738 NULL
+size_nhlt_specific_cfg_1740_fields size nhlt_specific_cfg 0 1740 NULL
+reg_list_format_size_bytes_amdgpu_rlc_1742_fields reg_list_format_size_bytes amdgpu_rlc 0 1742 NULL
+nr_packets_saa7134_ts_1743_fields nr_packets saa7134_ts 0 1743 NULL nohasharray
+ad_sd_write_reg_fndecl_1743_fields ad_sd_write_reg fndecl 3 1743 &nr_packets_saa7134_ts_1743_fields
+sectorsize_btrfs_root_1747_fields sectorsize btrfs_root 0 1747 NULL
+si4713_send_command_fndecl_1750_fields si4713_send_command fndecl 6 1750 NULL
+hugetlbfs_fallocate_fndecl_1752_fields hugetlbfs_fallocate fndecl 3 1752 NULL
+ext4_remove_blocks_fndecl_1754_fields ext4_remove_blocks fndecl 5 1754 NULL nohasharray
+st_nci_hci_dm_field_generator_fndecl_1754_fields st_nci_hci_dm_field_generator fndecl 3 1754 &ext4_remove_blocks_fndecl_1754_fields
+len_pda_custom_wrapper_1757_fields len pda_custom_wrapper 0 1757 NULL
+offset_scrub_nocow_inode_1762_fields offset scrub_nocow_inode 0 1762 NULL
+__es_insert_extent_fndecl_1764_fields __es_insert_extent fndecl 0 1764 NULL
+nentries_hfi1_user_sdma_comp_q_1768_fields nentries hfi1_user_sdma_comp_q 0 1768 NULL
+eqe_size_mlx4_caps_1775_fields eqe_size mlx4_caps 0 1775 NULL
+overlay_num_mmp_path_info_1781_fields overlay_num mmp_path_info 0 1781 NULL
+key_length_mwifiex_wep_key_1784_fields key_length mwifiex_wep_key 0 1784 NULL
+__of_translate_address_fndecl_1786_fields __of_translate_address fndecl 0 1786 NULL
+pitch_radeonfb_info_1792_fields pitch radeonfb_info 0 1792 NULL
+vub300_usb_bulk_msg_fndecl_1799_fields vub300_usb_bulk_msg fndecl 4-2 1799 NULL nohasharray
+security_inode_killpriv_fndecl_1799_fields security_inode_killpriv fndecl 0 1799 &vub300_usb_bulk_msg_fndecl_1799_fields
+wl1273_fm_write_data_fndecl_1803_fields wl1273_fm_write_data fndecl 3 1803 NULL
+num_mtt_segs_mthca_limits_1806_fields num_mtt_segs mthca_limits 0 1806 NULL
+dataInSize_mpt_ioctl_command_1808_fields dataInSize mpt_ioctl_command 0 1808 NULL
+udl_gem_alloc_object_fndecl_1811_fields udl_gem_alloc_object fndecl 2 1811 NULL
+__hugepage_set_anon_rmap_fndecl_1814_fields __hugepage_set_anon_rmap fndecl 3 1814 NULL nohasharray
+sv_nrpools_svc_serv_1814_fields sv_nrpools svc_serv 0 1814 &__hugepage_set_anon_rmap_fndecl_1814_fields
+fuse_dir_ioctl_fndecl_1818_fields fuse_dir_ioctl fndecl 2 1818 NULL
+bufsize_saa7134_dmasound_1821_fields bufsize saa7134_dmasound 0 1821 NULL
+lleft_ext4_allocation_request_1823_fields lleft ext4_allocation_request 0 1823 NULL
+__add_prelim_ref_fndecl_1828_fields __add_prelim_ref fndecl 6-5 1828 NULL
+dev_number_vardecl_rio_mport_cdev_c_1836_fields dev_number vardecl_rio_mport_cdev.c 0 1836 NULL
+cpu_port_b53_device_1841_fields cpu_port b53_device 0 1841 NULL
+walk_system_ram_range_fndecl_1842_fields walk_system_ram_range fndecl 2-1 1842 NULL
+check_free_sectors_fndecl_1843_fields check_free_sectors fndecl 2 1843 NULL
+ncpus_xen_mc_physcpuinfo_1849_fields ncpus xen_mc_physcpuinfo 0 1849 NULL
+qla4_82xx_pci_mem_read_2M_fndecl_1850_fields qla4_82xx_pci_mem_read_2M fndecl 2 1850 NULL
+maximum_cx88_ctrl_1852_fields maximum cx88_ctrl 0 1852 NULL
+dm_write_async_fndecl_1859_fields dm_write_async fndecl 3 1859 NULL
+rxq_req_tg3_1873_fields rxq_req tg3 0 1873 NULL
+buf_size_cx18_stream_1878_fields buf_size cx18_stream 0 1878 NULL nohasharray
+sisusb_bulkin_msg_fndecl_1878_fields sisusb_bulkin_msg fndecl 4-2 1878 &buf_size_cx18_stream_1878_fields
+__clear_user_fndecl_1885_fields __clear_user fndecl 0 1885 NULL nohasharray
+menu_count_uvc_control_mapping_1885_fields menu_count uvc_control_mapping 0 1885 &__clear_user_fndecl_1885_fields
+vmxnet3_get_hdr_len_fndecl_1891_fields vmxnet3_get_hdr_len fndecl 0 1891 NULL
+cq_ecount_lpfc_sli4_hba_1907_fields cq_ecount lpfc_sli4_hba 0 1907 NULL
+ca91cx42_master_set_fndecl_1913_fields ca91cx42_master_set fndecl 4 1913 NULL
+fix_unclean_leb_fndecl_1927_fields fix_unclean_leb fndecl 3 1927 NULL
+convert_ip_to_linear_fndecl_1933_fields convert_ip_to_linear fndecl 0 1933 NULL
+sv_resid_sym_ccb_1947_fields sv_resid sym_ccb 0 1947 NULL
+ieee80211_get_mesh_hdrlen_fndecl_1948_fields ieee80211_get_mesh_hdrlen fndecl 0 1948 NULL
+num_adcs_cs42xx8_driver_data_1953_fields num_adcs cs42xx8_driver_data 0 1953 NULL
+dax_major_vardecl_dax_c_1960_fields dax_major vardecl_dax.c 0 1960 NULL
+shmem_getpage_fndecl_1965_fields shmem_getpage fndecl 2 1965 NULL
+xlog_get_bp_fndecl_1966_fields xlog_get_bp fndecl 2 1966 NULL
+partitionLength_partitionDesc_1977_fields partitionLength partitionDesc 0 1977 NULL nohasharray
+to_dio_submit_1977_fields to dio_submit 0 1977 &partitionLength_partitionDesc_1977_fields nohasharray
+of_irq_get_byname_fndecl_1977_fields of_irq_get_byname fndecl 0 1977 &to_dio_submit_1977_fields
+tipc_sendmcast_fndecl_1981_fields tipc_sendmcast fndecl 4 1981 NULL nohasharray
+ll_md_brw_size_ll_sb_info_1981_fields ll_md_brw_size ll_sb_info 0 1981 &tipc_sendmcast_fndecl_1981_fields
+i5k_find_amb_registers_fndecl_1986_fields i5k_find_amb_registers fndecl 2 1986 NULL
+acpi_dev_gpio_irq_get_fndecl_1997_fields acpi_dev_gpio_irq_get fndecl 0 1997 NULL
+total_memory_vbe_ib_1999_fields total_memory vbe_ib 0 1999 NULL
+idx_len_tg3_rx_buffer_desc_2006_fields idx_len tg3_rx_buffer_desc 0 2006 NULL
+ipv6_skip_exthdr_fndecl_2016_fields ipv6_skip_exthdr fndecl 0-2 2016 NULL
+madvise_vma_fndecl_2019_fields madvise_vma fndecl 4-3 2019 NULL
+complicated_alloc_urb_fndecl_2022_fields complicated_alloc_urb fndecl 2 2022 NULL nohasharray
+doc_probe_fndecl_2022_fields doc_probe fndecl 1 2022 &complicated_alloc_urb_fndecl_2022_fields
+vga_vram_base_vardecl_vgacon_c_2024_fields vga_vram_base vardecl_vgacon.c 0 2024 NULL
+max_write_fuse_conn_2028_fields max_write fuse_conn 0 2028 NULL
+process_adv_report_fndecl_2030_fields process_adv_report fndecl 9 2030 NULL
+ib_umem_odp_map_dma_single_page_fndecl_2040_fields ib_umem_odp_map_dma_single_page fndecl 0 2040 NULL
+num_phy_chans_d40_base_2049_fields num_phy_chans d40_base 0 2049 NULL
+gss_encrypt_xdr_buf_fndecl_2050_fields gss_encrypt_xdr_buf fndecl 3 2050 NULL
+set_sock_size_fndecl_2051_fields set_sock_size fndecl 3 2051 NULL
+fscrypt_zeroout_range_fndecl_2052_fields fscrypt_zeroout_range fndecl 3 2052 NULL
+xfs_da_grow_inode_int_fndecl_2058_fields xfs_da_grow_inode_int fndecl 3 2058 NULL
+rt2x00queue_remove_l2pad_fndecl_2059_fields rt2x00queue_remove_l2pad fndecl 2 2059 NULL nohasharray
+wdt87xx_i2c_xfer_fndecl_2059_fields wdt87xx_i2c_xfer fndecl 3-5 2059 &rt2x00queue_remove_l2pad_fndecl_2059_fields nohasharray
+getgain_fndecl_2059_fields getgain fndecl 0 2059 &wdt87xx_i2c_xfer_fndecl_2059_fields
+receive_n_bytes_fndecl_2063_fields receive_n_bytes fndecl 3 2063 NULL
+val_bytes_regmap_format_2064_fields val_bytes regmap_format 0 2064 NULL
+total_copied_iscsi_segment_2071_fields total_copied iscsi_segment 0 2071 NULL
+mei_io_cb_alloc_buf_fndecl_2088_fields mei_io_cb_alloc_buf fndecl 0 2088 NULL
+__kernel_write_fndecl_2090_fields __kernel_write fndecl 3-0 2090 NULL
+rxd_size_bdx_priv_2091_fields rxd_size bdx_priv 0 2091 NULL
+sensor_xres_em28xx_v4l2_2095_fields sensor_xres em28xx_v4l2 0 2095 NULL
+size_nfs_fattr_2101_fields size nfs_fattr 0 2101 NULL
+namelen_extended_attribute_2109_fields namelen extended_attribute 0 2109 NULL
+dlen_nft_immediate_expr_2110_fields dlen nft_immediate_expr 0 2110 NULL
+max_pkt_payload_len_nci_conn_info_2111_fields max_pkt_payload_len nci_conn_info 0 2111 NULL
+ecryptfs_truncate_fndecl_2118_fields ecryptfs_truncate fndecl 2 2118 NULL
+untrack_pfn_fndecl_2124_fields untrack_pfn fndecl 3 2124 NULL
+hdrs_min_io_size_ubi_device_2134_fields hdrs_min_io_size ubi_device 0 2134 NULL
+offset_resp_ies_ndis_80211_assoc_info_2135_fields offset_resp_ies ndis_80211_assoc_info 0 2135 NULL
+count_skge_ring_2140_fields count skge_ring 0 2140 NULL
+capacity_p9_fcall_2144_fields capacity p9_fcall 0 2144 NULL nohasharray
+xfs_do_writepage_fndecl_2144_fields xfs_do_writepage fndecl 0 2144 &capacity_p9_fcall_2144_fields
+multi_ios_hda_gen_spec_2147_fields multi_ios hda_gen_spec 0 2147 NULL
+ioc_len_obd_ioctl_hdr_2148_fields ioc_len obd_ioctl_hdr 0 2148 NULL
+mpc_new_length_vardecl_mpparse_c_2163_fields mpc_new_length vardecl_mpparse.c 0 2163 NULL nohasharray
+block_size__drive_info_struct_2163_fields block_size _drive_info_struct 0 2163 &mpc_new_length_vardecl_mpparse_c_2163_fields
+log_early_fndecl_2170_fields log_early fndecl 3 2170 NULL
+read_size_perf_event_2173_fields read_size perf_event 0 2173 NULL
+ext4_setup_next_flex_gd_fndecl_2174_fields ext4_setup_next_flex_gd fndecl 4 2174 NULL
+rate_max_audioformat_2186_fields rate_max audioformat 0 2186 NULL nohasharray
+max_txsz_ulp_iscsi_info_2186_fields max_txsz ulp_iscsi_info 0 2186 &rate_max_audioformat_2186_fields
+ast_ttm_tt_create_fndecl_2190_fields ast_ttm_tt_create fndecl 2 2190 NULL
+__alloc_reserved_percpu_fndecl_2196_fields __alloc_reserved_percpu fndecl 1 2196 NULL
+max_header_size_irlan_provider_cb_2198_fields max_header_size irlan_provider_cb 0 2198 NULL nohasharray
+num_vlans_b53_device_2198_fields num_vlans b53_device 0 2198 &max_header_size_irlan_provider_cb_2198_fields
+ib_map_mr_sg_fndecl_2213_fields ib_map_mr_sg fndecl 0-5 2213 NULL
+valuelen_xfs_attr_inactive_list_2216_fields valuelen xfs_attr_inactive_list 0 2216 NULL
+DH_length_eg_ctrl_info_2234_fields DH_length eg_ctrl_info 0 2234 NULL
+nfs_proc_readdir_fndecl_2240_fields nfs_proc_readdir fndecl 5 2240 NULL
+macb_change_mtu_fndecl_2242_fields macb_change_mtu fndecl 2 2242 NULL
+s_mb_group_prealloc_ext4_sb_info_2246_fields s_mb_group_prealloc ext4_sb_info 0 2246 NULL
+d_reclen_ufs_dir_entry_2247_fields d_reclen ufs_dir_entry 0 2247 NULL
+xfs_rmap_finish_one_fndecl_2257_fields xfs_rmap_finish_one fndecl 6 2257 NULL
+ncommunities_intel_pinctrl_soc_data_2270_fields ncommunities intel_pinctrl_soc_data 0 2270 NULL
+transport_init_se_cmd_fndecl_2277_fields transport_init_se_cmd fndecl 4 2277 NULL
+num_touchids_mxt_data_2284_fields num_touchids mxt_data 0 2284 NULL
+write_phy_fndecl_2290_fields write_phy fndecl 3 2290 NULL
+scrub_extent_fndecl_2293_fields scrub_extent fndecl 3-2-9-4 2293 NULL
+bulk_out_endpointAddr_usb_lcd_2303_fields bulk_out_endpointAddr usb_lcd 0 2303 NULL
+sensf_res_len_nfc_target_2304_fields sensf_res_len nfc_target 0 2304 NULL
+af9033_wr_regs_fndecl_2314_fields af9033_wr_regs fndecl 4 2314 NULL
+clipcount_v4l2_window_2316_fields clipcount v4l2_window 0 2316 NULL
+ieee80211_tdls_prep_mgmt_packet_fndecl_2320_fields ieee80211_tdls_prep_mgmt_packet fndecl 10 2320 NULL
+i915_gem_object_create_from_data_fndecl_2325_fields i915_gem_object_create_from_data fndecl 3 2325 NULL
+sendmsg_proto_ops_2329_fields sendmsg proto_ops 0 2329 NULL
+gfx_partition_size_amdgpu_gds_asic_info_2339_fields gfx_partition_size amdgpu_gds_asic_info 0 2339 NULL nohasharray
+wait_for_matching_downcall_fndecl_2339_fields wait_for_matching_downcall fndecl 0 2339 &gfx_partition_size_amdgpu_gds_asic_info_2339_fields
+memsz_kexec_segment_2340_fields memsz kexec_segment 0 2340 NULL
+sg_copy_to_buffer_fndecl_2349_fields sg_copy_to_buffer fndecl 4 2349 NULL
+sk_gso_max_size_sock_2353_fields sk_gso_max_size sock 0 2353 NULL
+internal_set_rx_headroom_fndecl_2359_fields internal_set_rx_headroom fndecl 2 2359 NULL
+ReplUnitNum_nftl_uci0_2366_fields ReplUnitNum nftl_uci0 0 2366 NULL
+packet_size_st5481_in_2373_fields packet_size st5481_in 0 2373 NULL nohasharray
+count_brcmf_pno_scanresults_le_2373_fields count brcmf_pno_scanresults_le 0 2373 &packet_size_st5481_in_2373_fields
+d_reclen_vxfs_direct_2382_fields d_reclen vxfs_direct 0 2382 NULL
+cache_block_lba_msb_data_2385_fields cache_block_lba msb_data 0 2385 NULL
+tx_buffer_size_peak_usb_adapter_2386_fields tx_buffer_size peak_usb_adapter 0 2386 NULL
+pcifront_rescan_root_fndecl_2389_fields pcifront_rescan_root fndecl 2-3 2389 NULL
+check_and_mark_free_block_fndecl_2391_fields check_and_mark_free_block fndecl 2 2391 NULL
+xfs_bmap_add_free_fndecl_2392_fields xfs_bmap_add_free fndecl 3-4 2392 NULL
+asd_get_cmdctx_size_fndecl_2408_fields asd_get_cmdctx_size fndecl 0 2408 NULL
+pci_cardbus_resource_alignment_fndecl_2410_fields pci_cardbus_resource_alignment fndecl 0 2410 NULL
+cfi_intelext_write_buffers_fndecl_2417_fields cfi_intelext_write_buffers fndecl 3 2417 NULL
+get_count_dm_space_map_2419_fields get_count dm_space_map 0 2419 NULL
+phys_addr_sfi_rtc_table_entry_2421_fields phys_addr sfi_rtc_table_entry 0 2421 NULL
+ocfs2_acl_from_xattr_fndecl_2423_fields ocfs2_acl_from_xattr fndecl 2 2423 NULL
+omtu_l2cap_chan_2424_fields omtu l2cap_chan 0 2424 NULL
+len_xpad_output_packet_2430_fields len xpad_output_packet 0 2430 NULL
+ib_umem_copy_from_fndecl_2435_fields ib_umem_copy_from fndecl 3-4 2435 NULL
+bcm3510_writebytes_fndecl_2436_fields bcm3510_writebytes fndecl 4 2436 NULL
+init_asiliant_fndecl_2438_fields init_asiliant fndecl 2 2438 NULL
+carl9170_rx_copy_data_fndecl_2443_fields carl9170_rx_copy_data fndecl 2 2443 NULL
+key_len_key_params_2447_fields key_len key_params 0 2447 NULL nohasharray
+hrqsize_nvme_rdma_cm_req_2447_fields hrqsize nvme_rdma_cm_req 0 2447 &key_len_key_params_2447_fields
+fb_base_bochs_device_2461_fields fb_base bochs_device 0 2461 NULL
+tcp_tso_autosize_fndecl_2464_fields tcp_tso_autosize fndecl 0-2 2464 NULL
+proc_maps_open_fndecl_2468_fields proc_maps_open fndecl 4 2468 NULL
+maxpacket_usb_ep_2473_fields maxpacket usb_ep 0 2473 NULL
+gpio_devt_vardecl_gpiolib_c_2478_fields gpio_devt vardecl_gpiolib.c 0 2478 NULL
+ixgb_change_mtu_fndecl_2482_fields ixgb_change_mtu fndecl 2 2482 NULL
+num_vf_en_nicpf_2486_fields num_vf_en nicpf 0 2486 NULL
+tcp_sacktag_one_fndecl_2487_fields tcp_sacktag_one fndecl 7 2487 NULL
+in_ports_f_midi_opts_2502_fields in_ports f_midi_opts 0 2502 NULL
+vfs_copy_file_range_fndecl_2503_fields vfs_copy_file_range fndecl 0-5 2503 NULL
+hard_mtu_lan78xx_net_2507_fields hard_mtu lan78xx_net 0 2507 NULL
+size_arpt_replace_2509_fields size arpt_replace 0 2509 NULL
+unmap_alignment_scsi_disk_2514_fields unmap_alignment scsi_disk 0 2514 NULL
+usbpn_set_mtu_fndecl_2527_fields usbpn_set_mtu fndecl 2 2527 NULL
+__nf_nat_mangle_tcp_packet_fndecl_2531_fields __nf_nat_mangle_tcp_packet fndecl 6-8 2531 NULL
+should_remove_suid_fndecl_2532_fields should_remove_suid fndecl 0 2532 NULL
+l2down_create_fndecl_2536_fields l2down_create fndecl 4 2536 NULL
+mthca_alloc_init_fndecl_2537_fields mthca_alloc_init fndecl 3 2537 NULL
+tcp_shifted_skb_fndecl_2543_fields tcp_shifted_skb fndecl 4 2543 NULL
+__wa_seg_submit_fndecl_2547_fields __wa_seg_submit fndecl 0 2547 NULL
+__kmem_cache_alias_fndecl_2551_fields __kmem_cache_alias fndecl 2 2551 NULL
+vm_brk_fndecl_2552_fields vm_brk fndecl 1-2 2552 NULL
+off_fuse_dirent_2561_fields off fuse_dirent 0 2561 NULL
+b_error_xfs_buf_2563_fields b_error xfs_buf 0 2563 NULL
+active_duplex_niu_link_config_2566_fields active_duplex niu_link_config 0 2566 NULL
+hdsp_external_sample_rate_fndecl_2568_fields hdsp_external_sample_rate fndecl 0 2568 NULL
+extend_brk_fndecl_2574_fields extend_brk fndecl 2-1 2574 NULL
+skb_checksum_trimmed_fndecl_2576_fields skb_checksum_trimmed fndecl 2 2576 NULL nohasharray
+aio_offset_iocb_2576_fields aio_offset iocb 0 2576 &skb_checksum_trimmed_fndecl_2576_fields
+ieee80211_reserve_tid_fndecl_2578_fields ieee80211_reserve_tid fndecl 2 2578 NULL
+len_patch_info_2583_fields len patch_info 0 2583 NULL
+nr_pages_scif_pinned_pages_2586_fields nr_pages scif_pinned_pages 0 2586 NULL
+page_cache_tree_insert_fndecl_2600_fields page_cache_tree_insert fndecl 0 2600 NULL
+maxfrsize_bfa_fcs_rport_s_2601_fields maxfrsize bfa_fcs_rport_s 0 2601 NULL
+ld_active_tgt_count_lov_desc_2613_fields ld_active_tgt_count lov_desc 0 2613 NULL
+of_phandle_iterator_init_fndecl_2614_fields of_phandle_iterator_init fndecl 0 2614 NULL
+dst_maxburst_dma_slave_config_2619_fields dst_maxburst dma_slave_config 0 2619 NULL
+ptn3460_read_bytes_fndecl_2627_fields ptn3460_read_bytes fndecl 4 2627 NULL
+snd_soc_params_to_frame_size_fndecl_2630_fields snd_soc_params_to_frame_size fndecl 0 2630 NULL
+radeon_vram_location_fndecl_2634_fields radeon_vram_location fndecl 3 2634 NULL
+regmap_spi_gather_write_fndecl_2639_fields regmap_spi_gather_write fndecl 3-5 2639 NULL
+rx_bufshift_rtl_stats_2641_fields rx_bufshift rtl_stats 0 2641 NULL
+sys_read_fndecl_2644_fields sys_read fndecl 3 2644 NULL
+bitmap_cond_end_sync_fndecl_2649_fields bitmap_cond_end_sync fndecl 2 2649 NULL
+max_low_pfn_mapped_vardecl_2650_fields max_low_pfn_mapped vardecl 0 2650 NULL
+resync_max_mddev_2658_fields resync_max mddev 0 2658 NULL nohasharray
+pktgen_alloc_skb_fndecl_2658_fields pktgen_alloc_skb fndecl 3 2658 &resync_max_mddev_2658_fields
+dlen_hci_acl_hdr_2672_fields dlen hci_acl_hdr 0 2672 NULL
+ee_block_ext4_extent_2673_fields ee_block ext4_extent 0 2673 NULL
+bbt_erase_shift_bbm_info_2675_fields bbt_erase_shift bbm_info 0 2675 NULL
+TmpDcm_zoran_jpg_settings_2679_fields TmpDcm zoran_jpg_settings 0 2679 NULL
+mad_len_ib_mad_recv_wc_2683_fields mad_len ib_mad_recv_wc 0 2683 NULL
+logo_lines_vardecl_fbcon_c_2685_fields logo_lines vardecl_fbcon.c 0 2685 NULL
+pkt_finish_packet_fndecl_2701_fields pkt_finish_packet fndecl 2 2701 NULL
+crash_shrink_memory_fndecl_2706_fields crash_shrink_memory fndecl 1 2706 NULL
+src_len_ccp_sha_engine_2711_fields src_len ccp_sha_engine 0 2711 NULL
+u132_hcd_bulk_output_sent_fndecl_2715_fields u132_hcd_bulk_output_sent fndecl 4 2715 NULL
+mt7601u_usb_alloc_buf_fndecl_2716_fields mt7601u_usb_alloc_buf fndecl 2 2716 NULL
+bytesused_v4l2_buffer_2717_fields bytesused v4l2_buffer 0 2717 NULL
+get_res_add_size_fndecl_2740_fields get_res_add_size fndecl 0 2740 NULL
+iov_iter_get_pages_fndecl_2747_fields iov_iter_get_pages fndecl 0-4-3 2747 NULL
+of_flat_dt_translate_address_fndecl_2750_fields of_flat_dt_translate_address fndecl 0 2750 NULL
+mem_vardecl_applicom_c_2753_fields mem vardecl_applicom.c 0 2753 NULL
+rfcomm_send_test_fndecl_2760_fields rfcomm_send_test fndecl 4 2760 NULL
+next_swap_swap_map_page_2761_fields next_swap swap_map_page 0 2761 NULL
+size_rx_module_layout_2762_fields size_rx module_layout 0 2762 NULL
+ecryptfs_write_fndecl_2763_fields ecryptfs_write fndecl 4-3 2763 NULL
+u_ssize_user32_2770_fields u_ssize user32 0 2770 NULL
+ieee80211_alloc_hw_nm_fndecl_2774_fields ieee80211_alloc_hw_nm fndecl 1 2774 NULL
+batadv_check_unicast_packet_fndecl_2775_fields batadv_check_unicast_packet fndecl 3 2775 NULL nohasharray
+fw_mon_size_iwl_trans_pcie_2775_fields fw_mon_size iwl_trans_pcie 0 2775 &batadv_check_unicast_packet_fndecl_2775_fields
+num_bo_handles_drm_virtgpu_execbuffer_2779_fields num_bo_handles drm_virtgpu_execbuffer 0 2779 NULL
+uhci_result_common_fndecl_2788_fields uhci_result_common fndecl 0 2788 NULL
+pkcs7_sig_note_skid_fndecl_2795_fields pkcs7_sig_note_skid fndecl 5 2795 NULL
+iobase_vardecl_l440gx_c_2797_fields iobase vardecl_l440gx.c 0 2797 NULL
+sb_inodelog_xfs_sb_2799_fields sb_inodelog xfs_sb 0 2799 NULL
+st21nfca_hci_se_io_fndecl_2800_fields st21nfca_hci_se_io fndecl 4 2800 NULL nohasharray
+mp_find_ioapic_pin_fndecl_2800_fields mp_find_ioapic_pin fndecl 0-2 2800 &st21nfca_hci_se_io_fndecl_2800_fields
+put_chars_fndecl_2801_fields put_chars fndecl 3 2801 NULL
+bytesused_vb2_plane_2804_fields bytesused vb2_plane 0 2804 NULL
+usb_stor_set_xfer_buf_fndecl_2809_fields usb_stor_set_xfer_buf fndecl 2 2809 NULL
+num_active_queues_i40evf_adapter_2813_fields num_active_queues i40evf_adapter 0 2813 NULL
+num_cnic_queues_bnx2x_2816_fields num_cnic_queues bnx2x 0 2816 NULL
+lo_offset_loop_device_2817_fields lo_offset loop_device 0 2817 NULL
+VerDcm_zoran_jpg_settings_2823_fields VerDcm zoran_jpg_settings 0 2823 NULL
+nbufs_dm_verity_fec_io_2825_fields nbufs dm_verity_fec_io 0 2825 NULL
+ureg_align_qib_devdata_2841_fields ureg_align qib_devdata 0 2841 NULL
+max_data_size_ath6kl_bmi_2842_fields max_data_size ath6kl_bmi 0 2842 NULL
+dccm2_len_iwl_cfg_2852_fields dccm2_len iwl_cfg 0 2852 NULL
+bit_offset_nvmem_cell_2856_fields bit_offset nvmem_cell 0 2856 NULL nohasharray
+phys_size_hfs_inode_info_2856_fields phys_size hfs_inode_info 0 2856 &bit_offset_nvmem_cell_2856_fields
+btrfs_reloc_clone_csums_fndecl_2862_fields btrfs_reloc_clone_csums fndecl 3-2 2862 NULL
+q_depth_nvme_dev_2866_fields q_depth nvme_dev 0 2866 NULL
+max_sst_algo_control_2868_fields max sst_algo_control 0 2868 NULL
+secondary_bin_size_drm_mga_dma_bootstrap_2869_fields secondary_bin_size drm_mga_dma_bootstrap 0 2869 NULL nohasharray
+sys_recvfrom_fndecl_2869_fields sys_recvfrom fndecl 3 2869 &secondary_bin_size_drm_mga_dma_bootstrap_2869_fields
+cmodio_id_vardecl_janz_cmodio_c_2872_fields cmodio_id vardecl_janz-cmodio.c 0 2872 NULL
+drm_gem_object_init_fndecl_2882_fields drm_gem_object_init fndecl 3 2882 NULL nohasharray
+sg_init_one_fndecl_2882_fields sg_init_one fndecl 3 2882 &drm_gem_object_init_fndecl_2882_fields
+qlcnic_sriov_pf_enable_fndecl_2884_fields qlcnic_sriov_pf_enable fndecl 2 2884 NULL
+len_falloc_range_2886_fields len falloc_range 0 2886 NULL
+n_notifiers_vmci_ctx_2889_fields n_notifiers vmci_ctx 0 2889 NULL
+pca953x_setup_gpio_fndecl_2892_fields pca953x_setup_gpio fndecl 2 2892 NULL nohasharray
+ieee80211_tdls_add_chan_switch_resp_ies_fndecl_2892_fields ieee80211_tdls_add_chan_switch_resp_ies fndecl 7 2892 &pca953x_setup_gpio_fndecl_2892_fields
+set_max_cos_est_fndecl_2893_fields set_max_cos_est fndecl 0 2893 NULL
+xfs_bmapi_reserve_delalloc_fndecl_2901_fields xfs_bmapi_reserve_delalloc fndecl 2 2901 NULL nohasharray
+nf_ct_seq_adjust_fndecl_2901_fields nf_ct_seq_adjust fndecl 4 2901 &xfs_bmapi_reserve_delalloc_fndecl_2901_fields
+tda1004x_do_upload_fndecl_2916_fields tda1004x_do_upload fndecl 3 2916 NULL
+snd_hdac_acomp_get_eld_fndecl_2924_fields snd_hdac_acomp_get_eld fndecl 0 2924 NULL
+discard_swap_cluster_fndecl_2926_fields discard_swap_cluster fndecl 3-2 2926 NULL
+bytes_left_nfs_direct_req_2928_fields bytes_left nfs_direct_req 0 2928 NULL nohasharray
+rx_buf_size_octeon_nic_if_config_2928_fields rx_buf_size octeon_nic_if_config 0 2928 &bytes_left_nfs_direct_req_2928_fields
+rx_num_pgs_tp_params_2929_fields rx_num_pgs tp_params 0 2929 NULL
+tx_cnt_isac_2931_fields tx_cnt isac 0 2931 NULL nohasharray
+pno_blkpg_partition_2931_fields pno blkpg_partition 0 2931 &tx_cnt_isac_2931_fields
+fnic_fc_trace_max_pages_vardecl_2932_fields fnic_fc_trace_max_pages vardecl 0 2932 NULL
+tx_ring_count_ixgbevf_adapter_2933_fields tx_ring_count ixgbevf_adapter 0 2933 NULL
+max_ndp_size_cdc_ncm_ctx_2942_fields max_ndp_size cdc_ncm_ctx 0 2942 NULL
+sys_remap_file_pages_fndecl_2943_fields sys_remap_file_pages fndecl 2-1-4 2943 NULL
+devm_ioremap_wc_fndecl_2945_fields devm_ioremap_wc fndecl 3-2 2945 NULL
+HorDcm_zoran_jpg_settings_2947_fields HorDcm zoran_jpg_settings 0 2947 NULL nohasharray
+tx_idx_dchannel_2947_fields tx_idx dchannel 0 2947 &HorDcm_zoran_jpg_settings_2947_fields
+cydata_ofs_cyttsp4_sysinfo_ofs_2952_fields cydata_ofs cyttsp4_sysinfo_ofs 0 2952 NULL
+alloc_blksz_hfsplus_sb_info_2955_fields alloc_blksz hfsplus_sb_info 0 2955 NULL
+__kfifo_alloc_fndecl_2958_fields __kfifo_alloc fndecl 3 2958 NULL
+info_len_ib_ucm_event_2963_fields info_len ib_ucm_event 0 2963 NULL
+s_ipg_ufs_sb_private_info_2965_fields s_ipg ufs_sb_private_info 0 2965 NULL
+do_tcp_sendpages_fndecl_2968_fields do_tcp_sendpages fndecl 4-3 2968 NULL
+pn533_dep_link_up_fndecl_2969_fields pn533_dep_link_up fndecl 5 2969 NULL
+align_ip_set_ext_type_2975_fields align ip_set_ext_type 0 2975 NULL
+mrp_pdu_append_vecattr_hdr_fndecl_2982_fields mrp_pdu_append_vecattr_hdr fndecl 3 2982 NULL
+reiserfs_cut_from_item_fndecl_2988_fields reiserfs_cut_from_item fndecl 6 2988 NULL
+iscsi_start_cid_cnic_local_2995_fields iscsi_start_cid cnic_local 0 2995 NULL
+offset_fuse_notify_retrieve_out_2999_fields offset fuse_notify_retrieve_out 0 2999 NULL
+page_cnt_qed_chain_3000_fields page_cnt qed_chain 0 3000 NULL
+hdr_len_iscsi_task_3003_fields hdr_len iscsi_task 0 3003 NULL
+id_rio_mport_3010_fields id rio_mport 0 3010 NULL
+rdma_build_arg_xdr_fndecl_3012_fields rdma_build_arg_xdr fndecl 3 3012 NULL
+acpi_rsdp_vardecl_osl_c_3017_fields acpi_rsdp vardecl_osl.c 0 3017 NULL
+de_rec_len_gfs2_dirent_3029_fields de_rec_len gfs2_dirent 0 3029 NULL
+dual_channel_active_fndecl_3033_fields dual_channel_active fndecl 0 3033 NULL
+num_hwfns_qed_dev_3034_fields num_hwfns qed_dev 0 3034 NULL
+xfs_bulkstat_grab_ichunk_fndecl_3041_fields xfs_bulkstat_grab_ichunk fndecl 2 3041 NULL
+ping_common_sendmsg_fndecl_3046_fields ping_common_sendmsg fndecl 5 3046 NULL
+skb_seq_read_fndecl_3054_fields skb_seq_read fndecl 0-1 3054 NULL
+size_ecryptfs_cache_info_3056_fields size ecryptfs_cache_info 0 3056 NULL
+prepare_to_wait_event_fndecl_3060_fields prepare_to_wait_event fndecl 0 3060 NULL
+ntfs_map_runlist_fndecl_3068_fields ntfs_map_runlist fndecl 2 3068 NULL nohasharray
+dst_addr_width_dma_slave_config_3068_fields dst_addr_width dma_slave_config 0 3068 &ntfs_map_runlist_fndecl_3068_fields
+compat_process_vm_rw_fndecl_3069_fields compat_process_vm_rw fndecl 3 3069 NULL
+punch_hole_fndecl_3070_fields punch_hole fndecl 2-3 3070 NULL
+hbuf_max_len_mei_hw_ops_3071_fields hbuf_max_len mei_hw_ops 0 3071 NULL
+height_au0828_dev_3073_fields height au0828_dev 0 3073 NULL
+tpm_tis_spi_write_bytes_fndecl_3074_fields tpm_tis_spi_write_bytes fndecl 3 3074 NULL
+sg_addr_size__MPT_ADAPTER_3079_fields sg_addr_size _MPT_ADAPTER 0 3079 NULL
+mnt_clone_write_fndecl_3080_fields mnt_clone_write fndecl 0 3080 NULL
+cluster_next_swap_info_struct_3087_fields cluster_next swap_info_struct 0 3087 NULL
+total_h_mt9t031_3088_fields total_h mt9t031 0 3088 NULL
+gtt_mappable_entries__intel_private_3099_fields gtt_mappable_entries _intel_private 0 3099 NULL
+vol_cdev_direct_write_fndecl_3100_fields vol_cdev_direct_write fndecl 3 3100 NULL
+mt76_init_sband_fndecl_3112_fields mt76_init_sband fndecl 4 3112 NULL
+fb_alloc_cmap_gfp_fndecl_3115_fields fb_alloc_cmap_gfp fndecl 2 3115 NULL
+edid_write_fndecl_3118_fields edid_write fndecl 3 3118 NULL
+key_size_tracing_map_3119_fields key_size tracing_map 0 3119 NULL nohasharray
+ipip6_tunnel_change_mtu_fndecl_3119_fields ipip6_tunnel_change_mtu fndecl 2 3119 &key_size_tracing_map_3119_fields nohasharray
+blk_rq_map_user_fndecl_3119_fields blk_rq_map_user fndecl 5 3119 &ipip6_tunnel_change_mtu_fndecl_3119_fields nohasharray
+controller_function_ms_boot_attr_info_3119_fields controller_function ms_boot_attr_info 0 3119 &blk_rq_map_user_fndecl_3119_fields
+status_whc_qhead_3133_fields status whc_qhead 0 3133 NULL
+ext4_block_zero_page_range_fndecl_3135_fields ext4_block_zero_page_range fndecl 3 3135 NULL
+strndup_user_fndecl_3136_fields strndup_user fndecl 2 3136 NULL
+brcmf_usb_dlstart_fndecl_3138_fields brcmf_usb_dlstart fndecl 3 3138 NULL
+fotg210_urb_done_fndecl_3144_fields fotg210_urb_done fndecl 3 3144 NULL
+tx_room_keyspan_pda_private_3146_fields tx_room keyspan_pda_private 0 3146 NULL
+fragment_length_zd_usb_rx_3148_fields fragment_length zd_usb_rx 0 3148 NULL nohasharray
+nilfs_scan_dsync_log_fndecl_3148_fields nilfs_scan_dsync_log fndecl 2 3148 &fragment_length_zd_usb_rx_3148_fields
+iseg_base_mlx5_core_dev_3151_fields iseg_base mlx5_core_dev 0 3151 NULL
+udf_get_last_session_fndecl_3152_fields udf_get_last_session fndecl 0 3152 NULL
+mmio_size_drm_mga_private_3160_fields mmio_size drm_mga_private 0 3160 NULL
+prealloc_size_ich_pcm_table_3162_fields prealloc_size ich_pcm_table 0 3162 NULL nohasharray
+sys_sendto_fndecl_3162_fields sys_sendto fndecl 3 3162 &prealloc_size_ich_pcm_table_3162_fields
+send_ext_msg_udp_fndecl_3163_fields send_ext_msg_udp fndecl 3 3163 NULL
+cfv_alloc_and_copy_skb_fndecl_3167_fields cfv_alloc_and_copy_skb fndecl 4 3167 NULL
+bytes_per_pixel_vivid_dev_3174_fields bytes_per_pixel vivid_dev 0 3174 NULL
+keyspan_write_fndecl_3189_fields keyspan_write fndecl 4 3189 NULL
+min_io_size_ubi_device_3191_fields min_io_size ubi_device 0 3191 NULL
+mspi_apply_cpu_mode_quirks_fndecl_3197_fields mspi_apply_cpu_mode_quirks fndecl 0-4 3197 NULL
+lcd_hblank_len_atyfb_par_3198_fields lcd_hblank_len atyfb_par 0 3198 NULL
+import_iovec_fndecl_3201_fields import_iovec fndecl 3 3201 NULL
+num_leds_led_platform_data_3203_fields num_leds led_platform_data 0 3203 NULL
+bus_count_i2c_mux_pinctrl_platform_data_3204_fields bus_count i2c_mux_pinctrl_platform_data 0 3204 NULL
+chunk_size_mdu_array_info_s_3205_fields chunk_size mdu_array_info_s 0 3205 NULL
+usbvision_set_output_fndecl_3216_fields usbvision_set_output fndecl 2-3 3216 NULL
+rx_buffer_len_ixgb_adapter_3217_fields rx_buffer_len ixgb_adapter 0 3217 NULL nohasharray
+cw1200_sdio_memcpy_fromio_fndecl_3217_fields cw1200_sdio_memcpy_fromio fndecl 4 3217 &rx_buffer_len_ixgb_adapter_3217_fields
+mad_size_ib_mad_private_3230_fields mad_size ib_mad_private 0 3230 NULL
+sq_num_entries_c4iw_qp_attributes_3234_fields sq_num_entries c4iw_qp_attributes 0 3234 NULL
+lbs_rdbbp_write_fndecl_3237_fields lbs_rdbbp_write fndecl 3 3237 NULL
+inlen_ib_udata_3242_fields inlen ib_udata 0 3242 NULL
+uniforms_size_drm_vc4_submit_cl_3245_fields uniforms_size drm_vc4_submit_cl 0 3245 NULL
+max_wqe_ocrdma_dev_attr_3246_fields max_wqe ocrdma_dev_attr 0 3246 NULL
+s_max_sge_rvt_qp_3248_fields s_max_sge rvt_qp 0 3248 NULL
+of_property_match_string_fndecl_3250_fields of_property_match_string fndecl 0 3250 NULL
+shmem_kernel_file_setup_fndecl_3251_fields shmem_kernel_file_setup fndecl 2 3251 NULL
+taglen_cb_compound_hdr_res_3259_fields taglen cb_compound_hdr_res 0 3259 NULL
+compat_sys_readv_fndecl_3260_fields compat_sys_readv fndecl 3 3260 NULL
+altera_set_ir_post_fndecl_3271_fields altera_set_ir_post fndecl 2 3271 NULL
+doff_tcphdr_3280_fields doff tcphdr 0 3280 NULL nohasharray
+ds1305_nvram_read_fndecl_3280_fields ds1305_nvram_read fndecl 6 3280 &doff_tcphdr_3280_fields
+stolen_base_drm_psb_private_3285_fields stolen_base drm_psb_private 0 3285 NULL nohasharray
+cfg80211_rx_assoc_resp_fndecl_3285_fields cfg80211_rx_assoc_resp fndecl 4 3285 &stolen_base_drm_psb_private_3285_fields
+read_configfs_bin_attribute_3290_fields read configfs_bin_attribute 0 3290 NULL
+check_eofblocks_fl_fndecl_3293_fields check_eofblocks_fl fndecl 0 3293 NULL
+iov_count_iscsi_data_count_3301_fields iov_count iscsi_data_count 0 3301 NULL
+rds_page_remainder_alloc_fndecl_3303_fields rds_page_remainder_alloc fndecl 2 3303 NULL
+transfer_size_zr364xx_pipeinfo_3312_fields transfer_size zr364xx_pipeinfo 0 3312 NULL
+bulk_out_ep_irda_usb_cb_3322_fields bulk_out_ep irda_usb_cb 0 3322 NULL
+length_ima_digest_data_3329_fields length ima_digest_data 0 3329 NULL
+i_xattr_loc_ocfs2_dinode_3335_fields i_xattr_loc ocfs2_dinode 0 3335 NULL
+fc_cpu_mask_vardecl_3336_fields fc_cpu_mask vardecl 0 3336 NULL
+amdtp_dot_set_parameters_fndecl_3341_fields amdtp_dot_set_parameters fndecl 3 3341 NULL
+base_drm_agp_head_3348_fields base drm_agp_head 0 3348 NULL nohasharray
+curchunk_hdrlen_drm_dp_sideband_msg_rx_3348_fields curchunk_hdrlen drm_dp_sideband_msg_rx 0 3348 &base_drm_agp_head_3348_fields
+ext4_finish_convert_inline_dir_fndecl_3350_fields ext4_finish_convert_inline_dir fndecl 5 3350 NULL
+pgt_bits_nvkm_mmu_func_3353_fields pgt_bits nvkm_mmu_func 0 3353 NULL nohasharray
+max_bands_multiq_sched_data_3353_fields max_bands multiq_sched_data 0 3353 &pgt_bits_nvkm_mmu_func_3353_fields
+__process_changed_new_xattr_fndecl_3360_fields __process_changed_new_xattr fndecl 6-4 3360 NULL
+essidlen_zd1201_3366_fields essidlen zd1201 0 3366 NULL
+xfs_dir3_leaf_get_buf_fndecl_3380_fields xfs_dir3_leaf_get_buf fndecl 2 3380 NULL
+phys_hw_bank_3381_fields phys hw_bank 0 3381 NULL
+udf_split_extents_fndecl_3382_fields udf_split_extents fndecl 3 3382 NULL
+pgoff_vm_fault_3385_fields pgoff vm_fault 0 3385 NULL
+xfs_iext_realloc_direct_fndecl_3386_fields xfs_iext_realloc_direct fndecl 2 3386 NULL
+rport_priv_size_fc_lport_3388_fields rport_priv_size fc_lport 0 3388 NULL nohasharray
+beacon_ie_len_wmi_connect_event_3388_fields beacon_ie_len wmi_connect_event 0 3388 &rport_priv_size_fc_lport_3388_fields
+xz_dec_lzma2_reset_fndecl_3390_fields xz_dec_lzma2_reset fndecl 2 3390 NULL
+max_frame_size_nes_vnic_3395_fields max_frame_size nes_vnic 0 3395 NULL nohasharray
+st_nci_hci_dm_get_data_fndecl_3395_fields st_nci_hci_dm_get_data fndecl 3 3395 &max_frame_size_nes_vnic_3395_fields
+xfs_bmap_isaeof_fndecl_3401_fields xfs_bmap_isaeof fndecl 0 3401 NULL
+pos_in_item_treepath_3409_fields pos_in_item treepath 0 3409 NULL
+minLen_group_data_3411_fields minLen group_data 0 3411 NULL
+scsi_report_opcode_fndecl_3412_fields scsi_report_opcode fndecl 3 3412 NULL
+mtu_tipc_link_entry_3415_fields mtu tipc_link_entry 0 3415 NULL
+opts1_RxDesc_3421_fields opts1 RxDesc 0 3421 NULL
+rionet_change_mtu_fndecl_3422_fields rionet_change_mtu fndecl 2 3422 NULL
+rlim_cur_rlimit_3431_fields rlim_cur rlimit 0 3431 NULL nohasharray
+set_secure_conn_fndecl_3431_fields set_secure_conn fndecl 4 3431 &rlim_cur_rlimit_3431_fields
+gtp_check_src_ms_ipv4_fndecl_3432_fields gtp_check_src_ms_ipv4 fndecl 3 3432 NULL
+gfs2_meta_read_fndecl_3434_fields gfs2_meta_read fndecl 2 3434 NULL
+len_nft_bitwise_3441_fields len nft_bitwise 0 3441 NULL
+uc_inSize_upc_req_3444_fields uc_inSize upc_req 0 3444 NULL
+cifs_read_page_from_socket_fndecl_3452_fields cifs_read_page_from_socket fndecl 3 3452 NULL
+rpipe_check_aim_fndecl_3456_fields rpipe_check_aim fndecl 0 3456 NULL
+s_itb_per_group_ext4_sb_info_3459_fields s_itb_per_group ext4_sb_info 0 3459 NULL
+adfs_dir_read_fndecl_3464_fields adfs_dir_read fndecl 2 3464 NULL
+intel_th_populate_fndecl_3473_fields intel_th_populate fndecl 4 3473 NULL
+acpi_aml_write_fndecl_3476_fields acpi_aml_write fndecl 3 3476 NULL nohasharray
+ngpios_chv_community_3476_fields ngpios chv_community 0 3476 &acpi_aml_write_fndecl_3476_fields
+chip_send_contexts_hfi1_devdata_3481_fields chip_send_contexts hfi1_devdata 0 3481 NULL nohasharray
+namelen_xfs_dir2_sf_entry_3481_fields namelen xfs_dir2_sf_entry 0 3481 &chip_send_contexts_hfi1_devdata_3481_fields
+xfer_len_nvme_trans_io_cdb_3486_fields xfer_len nvme_trans_io_cdb 0 3486 NULL
+from_dio_submit_3494_fields from dio_submit 0 3494 NULL
+hs_bkt_bits_cfs_hash_3509_fields hs_bkt_bits cfs_hash 0 3509 NULL
+statesize_hash_alg_common_3517_fields statesize hash_alg_common 0 3517 NULL
+gru_vtop_fndecl_3522_fields gru_vtop fndecl 2 3522 NULL
+cl_out_max_entry_size_mvumi_hs_page1_3540_fields cl_out_max_entry_size mvumi_hs_page1 0 3540 NULL
+mult_count_ide_drive_s_3550_fields mult_count ide_drive_s 0 3550 NULL
+ocfs2_read_xattr_bucket_fndecl_3553_fields ocfs2_read_xattr_bucket fndecl 2 3553 NULL
+sg_copy_from_buffer_fndecl_3557_fields sg_copy_from_buffer fndecl 0-4 3557 NULL
+mt2063_write_fndecl_3567_fields mt2063_write fndecl 4 3567 NULL
+page_cache_sync_readahead_fndecl_3569_fields page_cache_sync_readahead fndecl 4 3569 NULL nohasharray
+nr_clk_ids_samsung_cmu_info_3569_fields nr_clk_ids samsung_cmu_info 0 3569 &page_cache_sync_readahead_fndecl_3569_fields
+encode_diropargs3_fndecl_3574_fields encode_diropargs3 fndecl 4 3574 NULL
+len_capiloaddatapart_3577_fields len capiloaddatapart 0 3577 NULL
+pkcs7_view_content_fndecl_3589_fields pkcs7_view_content fndecl 3 3589 NULL nohasharray
+ddr_av_base_mthca_av_table_3589_fields ddr_av_base mthca_av_table 0 3589 &pkcs7_view_content_fndecl_3589_fields
+ip_vs_icmp_xmit_fndecl_3590_fields ip_vs_icmp_xmit fndecl 4 3590 NULL nohasharray
+npads_xtpg_device_3590_fields npads xtpg_device 0 3590 &ip_vs_icmp_xmit_fndecl_3590_fields
+get_tmp_page_fndecl_3591_fields get_tmp_page fndecl 2 3591 NULL
+buf_size_i1480_3593_fields buf_size i1480 0 3593 NULL
+xfs_alloc_ag_vextent_size_fndecl_3599_fields xfs_alloc_ag_vextent_size fndecl 0 3599 NULL nohasharray
+brcmf_chip_tcm_rambase_fndecl_3599_fields brcmf_chip_tcm_rambase fndecl 0 3599 &xfs_alloc_ag_vextent_size_fndecl_3599_fields
+e820_update_range_fndecl_3600_fields e820_update_range fndecl 1-2 3600 NULL
+cdns_uart_get_port_fndecl_3601_fields cdns_uart_get_port fndecl 1 3601 NULL
+xdr_extend_head_fndecl_3606_fields xdr_extend_head fndecl 3 3606 NULL
+engine_len_viafb_dev_3608_fields engine_len viafb_dev 0 3608 NULL
+ss_out_channels_hdsp_3619_fields ss_out_channels hdsp 0 3619 NULL
+ns_blocksize_the_nilfs_3624_fields ns_blocksize the_nilfs 0 3624 NULL nohasharray
+bytes_btrfs_dio_private_3624_fields bytes btrfs_dio_private 0 3624 &ns_blocksize_the_nilfs_3624_fields
+tail_timestamp_event_queue_3626_fields tail timestamp_event_queue 0 3626 NULL
+cbuf_eat_fndecl_3631_fields cbuf_eat fndecl 2 3631 NULL
+out_words_ib_uverbs_cmd_hdr_3637_fields out_words ib_uverbs_cmd_hdr 0 3637 NULL
+xfs_attr3_leaf_freextent_fndecl_3639_fields xfs_attr3_leaf_freextent fndecl 4-3 3639 NULL nohasharray
+vmci_transport_queue_pair_alloc_fndecl_3639_fields vmci_transport_queue_pair_alloc fndecl 3-4 3639 &xfs_attr3_leaf_freextent_fndecl_3639_fields
+count_phm_clock_voltage_dependency_table_3642_fields count phm_clock_voltage_dependency_table 0 3642 NULL
+pci_id_imc_uncore_pci_dev_3656_fields pci_id imc_uncore_pci_dev 0 3656 NULL
+c_plan_ahead_disk_conf_3660_fields c_plan_ahead disk_conf 0 3660 NULL
+im_len_xfs_imap_3661_fields im_len xfs_imap 0 3661 NULL nohasharray
+ext2_get_blocks_fndecl_3661_fields ext2_get_blocks fndecl 0 3661 &im_len_xfs_imap_3661_fields
+arch_reserve_mem_area_fndecl_3662_fields arch_reserve_mem_area fndecl 2 3662 NULL
+aper_base_amdgpu_mc_3664_fields aper_base amdgpu_mc 0 3664 NULL
+child_cnt_ubifs_znode_3667_fields child_cnt ubifs_znode 0 3667 NULL
+bio_find_or_create_slab_fndecl_3671_fields bio_find_or_create_slab fndecl 1 3671 NULL
+interfaces_count_ffs_data_3677_fields interfaces_count ffs_data 0 3677 NULL
+alloc_orinocodev_fndecl_3688_fields alloc_orinocodev fndecl 1 3688 NULL
+len_mic_mw_3689_fields len mic_mw 0 3689 NULL
+ath10k_wmi_tlv_op_gen_vdev_sta_uapsd_fndecl_3692_fields ath10k_wmi_tlv_op_gen_vdev_sta_uapsd fndecl 5 3692 NULL
+vmw_cmdbuf_space_pool_fndecl_3702_fields vmw_cmdbuf_space_pool fndecl 3 3702 NULL nohasharray
+get_urb_error_fndecl_3702_fields get_urb_error fndecl 0 3702 &vmw_cmdbuf_space_pool_fndecl_3702_fields
+ceph_msg_data_add_pages_fndecl_3704_fields ceph_msg_data_add_pages fndecl 3 3704 NULL
+vlan_netdev_private_3705_fields vlan netdev_private 0 3705 NULL
+len_sctp_auth_bytes_3715_fields len sctp_auth_bytes 0 3715 NULL
+byte_len_ib_wc_3716_fields byte_len ib_wc 0 3716 NULL
+test_find_delalloc_fndecl_3723_fields test_find_delalloc fndecl 1 3723 NULL
+len_amp_assoc_3724_fields len amp_assoc 0 3724 NULL
+__v4l2_ctrl_modify_range_fndecl_3726_fields __v4l2_ctrl_modify_range fndecl 2-5 3726 NULL
+mcs_wrap_fir_skb_fndecl_3729_fields mcs_wrap_fir_skb fndecl 0 3729 NULL
+peer_buf_alloc_virtio_vsock_sock_3738_fields peer_buf_alloc virtio_vsock_sock 0 3738 NULL
+nr_reserved_tags_blk_mq_tags_3751_fields nr_reserved_tags blk_mq_tags 0 3751 NULL
+e_value_size_f2fs_xattr_entry_3755_fields e_value_size f2fs_xattr_entry 0 3755 NULL
+vchnl_vf_send_del_hmc_objs_req_fndecl_3761_fields vchnl_vf_send_del_hmc_objs_req fndecl 5 3761 NULL
+private_value_sbmix_elem_3773_fields private_value sbmix_elem 0 3773 NULL
+size_m48t35_priv_3775_fields size m48t35_priv 0 3775 NULL
+ag_shift_befs_sb_info_3778_fields ag_shift befs_sb_info 0 3778 NULL
+fl_starve_thres_sge_3779_fields fl_starve_thres sge 0 3779 NULL
+cxgbi_ppm_init_fndecl_3787_fields cxgbi_ppm_init fndecl 6 3787 NULL
+rx_status_len_ath9k_hw_capabilities_3793_fields rx_status_len ath9k_hw_capabilities 0 3793 NULL
+concat_writev_fndecl_3800_fields concat_writev fndecl 4-3 3800 NULL
+nfc_hci_send_event_fndecl_3807_fields nfc_hci_send_event fndecl 5 3807 NULL
+nextLineNumber_vardecl_rocket_c_3809_fields nextLineNumber vardecl_rocket.c 0 3809 NULL
+ip_last_used_group_ocfs2_inode_info_3814_fields ip_last_used_group ocfs2_inode_info 0 3814 NULL
+e_cpos_ocfs2_extent_rec_3815_fields e_cpos ocfs2_extent_rec 0 3815 NULL
+fnic_trace_debugfs_lseek_fndecl_3819_fields fnic_trace_debugfs_lseek fndecl 2 3819 NULL nohasharray
+dccp_recvmsg_fndecl_3819_fields dccp_recvmsg fndecl 3 3819 &fnic_trace_debugfs_lseek_fndecl_3819_fields
+bits_per_word_spi_device_3828_fields bits_per_word spi_device 0 3828 NULL
+bnxt_gro_func_5730x_fndecl_3830_fields bnxt_gro_func_5730x fndecl 2 3830 NULL
+num_counters_ipt_replace_3837_fields num_counters ipt_replace 0 3837 NULL
+error_btrfs_end_io_wq_3838_fields error btrfs_end_io_wq 0 3838 NULL
+find_end_of_node_fndecl_3843_fields find_end_of_node fndecl 0-3-1-2 3843 NULL
+bg_inode_table_hi_ext4_group_desc_3844_fields bg_inode_table_hi ext4_group_desc 0 3844 NULL
+btrfs_dirty_pages_fndecl_3848_fields btrfs_dirty_pages fndecl 6-5 3848 NULL
+ocfs2_free_clusters_fndecl_3866_fields ocfs2_free_clusters fndecl 4 3866 NULL
+minlen_fstrim_range_3870_fields minlen fstrim_range 0 3870 NULL
+size_of_priv_dvb_usb_adapter_fe_properties_3875_fields size_of_priv dvb_usb_adapter_fe_properties 0 3875 NULL
+fs_div_hfs_sb_info_3890_fields fs_div hfs_sb_info 0 3890 NULL
+snd_pcm_lib_preallocate_pages_fndecl_3892_fields snd_pcm_lib_preallocate_pages fndecl 4 3892 NULL
+rootdir_empty_fndecl_3895_fields rootdir_empty fndecl 2 3895 NULL
+xfs_extent_busy_trim_fndecl_3898_fields xfs_extent_busy_trim fndecl 3-2 3898 NULL
+gfs2_meta_wipe_fndecl_3900_fields gfs2_meta_wipe fndecl 2 3900 NULL
+endpoint_usb_data_stream_properties_3909_fields endpoint usb_data_stream_properties 0 3909 NULL
+mp_map_gsi_to_irq_fndecl_3923_fields mp_map_gsi_to_irq fndecl 1 3923 NULL
+me_startblock_xfs_map_extent_3934_fields me_startblock xfs_map_extent 0 3934 NULL
+cfpkt_set_prio_fndecl_3935_fields cfpkt_set_prio fndecl 2 3935 NULL
+unix_dgram_sendmsg_fndecl_3944_fields unix_dgram_sendmsg fndecl 3 3944 NULL
+atalk_recvmsg_fndecl_3950_fields atalk_recvmsg fndecl 3 3950 NULL
+mem_end_pci_params_3955_fields mem_end pci_params 0 3955 NULL
+backup_src_sz_kimage_arch_3957_fields backup_src_sz kimage_arch 0 3957 NULL nohasharray
+resync_min_mddev_3957_fields resync_min mddev 0 3957 &backup_src_sz_kimage_arch_3957_fields
+make_le_item_head_fndecl_3961_fields make_le_item_head fndecl 4-5-6 3961 NULL
+hpfs_de_as_down_as_possible_fndecl_3967_fields hpfs_de_as_down_as_possible fndecl 0-2 3967 NULL
+dgram_sendmsg_fndecl_3972_fields dgram_sendmsg fndecl 3 3972 NULL
+wrbs_per_cxn_hba_parameters_3974_fields wrbs_per_cxn hba_parameters 0 3974 NULL
+uc_cnt_ncsi_rsp_gc_pkt_3982_fields uc_cnt ncsi_rsp_gc_pkt 0 3982 NULL nohasharray
+r_len_rvt_qp_3982_fields r_len rvt_qp 0 3982 &uc_cnt_ncsi_rsp_gc_pkt_3982_fields
+num_entries_aper_size_info_lvl2_3983_fields num_entries aper_size_info_lvl2 0 3983 NULL
+num_pages_ttm_mem_reg_3986_fields num_pages ttm_mem_reg 0 3986 NULL nohasharray
+nv50_chan_create_fndecl_3986_fields nv50_chan_create fndecl 6 3986 &num_pages_ttm_mem_reg_3986_fields
+i2400m_rx_trace_fndecl_3988_fields i2400m_rx_trace fndecl 3 3988 NULL
+tp_len_tpacket2_hdr_3990_fields tp_len tpacket2_hdr 0 3990 NULL nohasharray
+__acpi_register_gsi_vardecl_3990_fields __acpi_register_gsi vardecl 0 3990 &tp_len_tpacket2_hdr_3990_fields
+rfcomm_sock_recvmsg_fndecl_3992_fields rfcomm_sock_recvmsg fndecl 3 3992 NULL
+opt_nflen_ipv6_txoptions_3998_fields opt_nflen ipv6_txoptions 0 3998 NULL nohasharray
+len_be_queue_info_3998_fields len be_queue_info 0 3998 &opt_nflen_ipv6_txoptions_3998_fields
+buffer_bytes_max_snd_pcm_hardware_4001_fields buffer_bytes_max snd_pcm_hardware 0 4001 NULL
+t4_init_clip_tbl_fndecl_4007_fields t4_init_clip_tbl fndecl 1-2 4007 NULL nohasharray
+format_supported_num_psb_intel_sdvo_connector_4007_fields format_supported_num psb_intel_sdvo_connector 0 4007 &t4_init_clip_tbl_fndecl_4007_fields
+rx_data_max_size_sst_generic_ipc_4011_fields rx_data_max_size sst_generic_ipc 0 4011 NULL nohasharray
+onenand_default_block_markbad_fndecl_4011_fields onenand_default_block_markbad fndecl 2 4011 &rx_data_max_size_sst_generic_ipc_4011_fields
+bioset_create_nobvec_fndecl_4015_fields bioset_create_nobvec fndecl 2-1 4015 NULL
+f1_id_amd64_family_type_4017_fields f1_id amd64_family_type 0 4017 NULL
+rtl2830_regmap_gather_write_fndecl_4018_fields rtl2830_regmap_gather_write fndecl 5 4018 NULL
+b_size_mon_reader_bin_4021_fields b_size mon_reader_bin 0 4021 NULL
+j_start_reiserfs_journal_list_4030_fields j_start reiserfs_journal_list 0 4030 NULL
+length_usb_request_4031_fields length usb_request 0 4031 NULL
+rx_buf_sz_netdev_private_4035_fields rx_buf_sz netdev_private 0 4035 NULL
+MsgLength__MSG_EVENT_NOTIFY_REPLY_4038_fields MsgLength _MSG_EVENT_NOTIFY_REPLY 0 4038 NULL
+brcmf_sdio_txpkt_hdalign_fndecl_4040_fields brcmf_sdio_txpkt_hdalign fndecl 0 4040 NULL
+user_mss_tcp_options_received_4043_fields user_mss tcp_options_received 0 4043 NULL
+scsi_execute_req_flags_fndecl_4044_fields scsi_execute_req_flags fndecl 5 4044 NULL
+tx_data_count_hso_serial_4046_fields tx_data_count hso_serial 0 4046 NULL
+prepare_header_fndecl_4047_fields prepare_header fndecl 0 4047 NULL
+ssid_len_cfg80211_connect_params_4052_fields ssid_len cfg80211_connect_params 0 4052 NULL
+isoc_packet_size_usb_usbvision_4066_fields isoc_packet_size usb_usbvision 0 4066 NULL
+cfg80211_notify_new_peer_candidate_fndecl_4073_fields cfg80211_notify_new_peer_candidate fndecl 4 4073 NULL
+iscsi_max_snd_data_seg_len_dev_db_entry_4074_fields iscsi_max_snd_data_seg_len dev_db_entry 0 4074 NULL
+do_validate_mem_fndecl_4075_fields do_validate_mem fndecl 3-2 4075 NULL
+mlx4_en_get_num_flows_fndecl_4078_fields mlx4_en_get_num_flows fndecl 0 4078 NULL
+IOCRequestFrameSize_mpt3sas_facts_4079_fields IOCRequestFrameSize mpt3sas_facts 0 4079 NULL
+__set_extent_bit_fndecl_4083_fields __set_extent_bit fndecl 0-3-2 4083 NULL
+n_drm_r128_depth_4085_fields n drm_r128_depth 0 4085 NULL
+skb_copy_and_csum_datagram_fndecl_4086_fields skb_copy_and_csum_datagram fndecl 4-2 4086 NULL
+_ocfs2_free_clusters_fndecl_4087_fields _ocfs2_free_clusters fndecl 4 4087 NULL
+base_intel_initial_plane_config_4088_fields base intel_initial_plane_config 0 4088 NULL
+num_pipes_intel_device_info_4092_fields num_pipes intel_device_info 0 4092 NULL
+sca_keylength_sctp_authkey_4095_fields sca_keylength sctp_authkey 0 4095 NULL
+ae_res_sd_4099_fields ae_res sd 0 4099 NULL
+nbuttons_tca6416_keys_platform_data_4107_fields nbuttons tca6416_keys_platform_data 0 4107 NULL nohasharray
+special_ixgb_rx_desc_4107_fields special ixgb_rx_desc 0 4107 &nbuttons_tca6416_keys_platform_data_4107_fields
+blkno_xfs_da_args_4112_fields blkno xfs_da_args 0 4112 NULL
+vringh_iov_pull_kern_fndecl_4115_fields vringh_iov_pull_kern fndecl 3 4115 NULL
+read_reg_fndecl_4120_fields read_reg fndecl 0 4120 NULL
+jffs2_acl_from_medium_fndecl_4129_fields jffs2_acl_from_medium fndecl 2 4129 NULL
+tx_desc_size_rtl8xxxu_fileops_4133_fields tx_desc_size rtl8xxxu_fileops 0 4133 NULL
+ocfs2_read_group_descriptor_fndecl_4136_fields ocfs2_read_group_descriptor fndecl 3 4136 NULL
+v9fs_xattr_handler_get_fndecl_4139_fields v9fs_xattr_handler_get fndecl 6 4139 NULL nohasharray
+ssid_len_mwifiex_802_11_ssid_4139_fields ssid_len mwifiex_802_11_ssid 0 4139 &v9fs_xattr_handler_get_fndecl_4139_fields
+size_badblocks_4142_fields size badblocks 0 4142 NULL
+interleave_cfi_private_4153_fields interleave cfi_private 0 4153 NULL
+ocfs2_readpages_fndecl_4156_fields ocfs2_readpages fndecl 4 4156 NULL nohasharray
+num_msix_vec_be_adapter_4156_fields num_msix_vec be_adapter 0 4156 &ocfs2_readpages_fndecl_4156_fields
+team_change_mtu_fndecl_4186_fields team_change_mtu fndecl 2 4186 NULL
+iin_ep_usbtmc_device_data_4195_fields iin_ep usbtmc_device_data 0 4195 NULL
+xfs_bmap_add_extent_hole_real_fndecl_4199_fields xfs_bmap_add_extent_hole_real fndecl 0 4199 NULL
+wBeaconInfoLength_uwb_rc_evt_beacon_WUSB_0100_4200_fields wBeaconInfoLength uwb_rc_evt_beacon_WUSB_0100 0 4200 NULL
+bd_dev_block_device_4202_fields bd_dev block_device 0 4202 NULL
+parent___prelim_ref_4206_fields parent __prelim_ref 0 4206 NULL nohasharray
+sample_bits_snd_soc_dai_4206_fields sample_bits snd_soc_dai 0 4206 &parent___prelim_ref_4206_fields
+rx_page_order_il_hw_params_4208_fields rx_page_order il_hw_params 0 4208 NULL
+rx_pkt_offset_rxpd_4210_fields rx_pkt_offset rxpd 0 4210 NULL
+max_vectors_i40e_virtchnl_vf_resource_4213_fields max_vectors i40e_virtchnl_vf_resource 0 4213 NULL
+ext2_setsize_fndecl_4215_fields ext2_setsize fndecl 2 4215 NULL
+count_sc_config_sizes_4217_fields count sc_config_sizes 0 4217 NULL
+store_pending_adv_report_fndecl_4222_fields store_pending_adv_report fndecl 7 4222 NULL
+nilfs_segbuf_map_fndecl_4225_fields nilfs_segbuf_map fndecl 3 4225 NULL
+__nla_put_fndecl_4226_fields __nla_put fndecl 3 4226 NULL
+data_len_nci_data_4237_fields data_len nci_data 0 4237 NULL
+ip6gre_err_fndecl_4238_fields ip6gre_err fndecl 5 4238 NULL
+alloc_size_debug_buffer_4240_fields alloc_size debug_buffer 0 4240 NULL
+subpage_sft_mtd_info_4249_fields subpage_sft mtd_info 0 4249 NULL
+ieee80211_mesh_rx_mgmt_action_fndecl_4250_fields ieee80211_mesh_rx_mgmt_action fndecl 3 4250 NULL nohasharray
+duplex_ethtool_cmd_4250_fields duplex ethtool_cmd 0 4250 &ieee80211_mesh_rx_mgmt_action_fndecl_4250_fields
+fb_y_vmw_fb_par_4260_fields fb_y vmw_fb_par 0 4260 NULL
+user_width_soc_camera_device_4262_fields user_width soc_camera_device 0 4262 NULL
+nilfs_gccache_submit_read_node_fndecl_4267_fields nilfs_gccache_submit_read_node fndecl 2-3 4267 NULL
+ide_set_pio_fndecl_4272_fields ide_set_pio fndecl 2 4272 NULL
+mp_map_pin_to_irq_fndecl_4276_fields mp_map_pin_to_irq fndecl 1 4276 NULL
+fuse_ioctl_copy_user_fndecl_4279_fields fuse_ioctl_copy_user fndecl 4-3 4279 NULL
+rx_packet_len_nci_uart_4280_fields rx_packet_len nci_uart 0 4280 NULL
+gfs2_getbuf_fndecl_4283_fields gfs2_getbuf fndecl 2 4283 NULL
+route_mtu_cached_xfrm_dst_4288_fields route_mtu_cached xfrm_dst 0 4288 NULL
+connector_count_drm_fb_helper_4290_fields connector_count drm_fb_helper 0 4290 NULL
+h_next_leaf_blk_ocfs2_extent_block_4292_fields h_next_leaf_blk ocfs2_extent_block 0 4292 NULL
+src_h_drm_plane_state_4303_fields src_h drm_plane_state 0 4303 NULL nohasharray
+maxpacket_musb_qh_4303_fields maxpacket musb_qh 0 4303 &src_h_drm_plane_state_4303_fields
+nr_gpios_gpio_regulator_config_4306_fields nr_gpios gpio_regulator_config 0 4306 NULL
+rx_frm_len_mask_macb_4310_fields rx_frm_len_mask macb 0 4310 NULL
+bufsize_i2c_hid_4318_fields bufsize i2c_hid 0 4318 NULL
+old_chunk_dm_exception_4333_fields old_chunk dm_exception 0 4333 NULL
+length_rbd_obj_request_4337_fields length rbd_obj_request 0 4337 NULL
+stripe_len_btrfs_raid_bio_4340_fields stripe_len btrfs_raid_bio 0 4340 NULL
+v4l2_ctrl_new_fndecl_4341_fields v4l2_ctrl_new fndecl 8-12-7-10 4341 NULL
+key_len_neigh_table_4347_fields key_len neigh_table 0 4347 NULL
+scrbuf_size_sisusb_usb_data_4350_fields scrbuf_size sisusb_usb_data 0 4350 NULL
+len_mwifiex_ds_misc_gen_ie_4351_fields len mwifiex_ds_misc_gen_ie 0 4351 NULL
+musb_giveback_fndecl_4352_fields musb_giveback fndecl 3 4352 NULL
+o_size_x509_parse_context_4358_fields o_size x509_parse_context 0 4358 NULL
+snd_emu10k1_synth_alloc_fndecl_4366_fields snd_emu10k1_synth_alloc fndecl 2 4366 NULL
+size_rio_cm_msg_4375_fields size rio_cm_msg 0 4375 NULL
+isdn_tty_edit_at_fndecl_4376_fields isdn_tty_edit_at fndecl 0 4376 NULL nohasharray
+nilfs_sufile_resize_fndecl_4376_fields nilfs_sufile_resize fndecl 2 4376 &isdn_tty_edit_at_fndecl_4376_fields
+ip_vs_conn_tab_bits_vardecl_ip_vs_conn_c_4379_fields ip_vs_conn_tab_bits vardecl_ip_vs_conn.c 0 4379 NULL
+ts_packet_size_cx8802_dev_4383_fields ts_packet_size cx8802_dev 0 4383 NULL nohasharray
+dir_entries_msdos_sb_info_4383_fields dir_entries msdos_sb_info 0 4383 &ts_packet_size_cx8802_dev_4383_fields
+ext4_add_new_descs_fndecl_4390_fields ext4_add_new_descs fndecl 3 4390 NULL
+err_vlan_tg3_rx_buffer_desc_4391_fields err_vlan tg3_rx_buffer_desc 0 4391 NULL
+ivtv_udma_setup_fndecl_4395_fields ivtv_udma_setup fndecl 4 4395 NULL
+mgag200_bo_create_fndecl_4398_fields mgag200_bo_create fndecl 2 4398 NULL
+skb_realloc_headroom_fndecl_4399_fields skb_realloc_headroom fndecl 2 4399 NULL
+leadin_ignore_xpnet_message_4402_fields leadin_ignore xpnet_message 0 4402 NULL
+page_ofs__ntfs_inode_4407_fields page_ofs _ntfs_inode 0 4407 NULL
+rxe_reg_user_mr_fndecl_4415_fields rxe_reg_user_mr fndecl 2-3 4415 NULL
+new_bytenr_backref_node_4416_fields new_bytenr backref_node 0 4416 NULL
+bRefresh_usb_endpoint_descriptor_4444_fields bRefresh usb_endpoint_descriptor 0 4444 NULL
+number_mdu_disk_info_s_4445_fields number mdu_disk_info_s 0 4445 NULL
+width_simplefb_params_4449_fields width simplefb_params 0 4449 NULL
+nfsd_read_fndecl_4451_fields nfsd_read fndecl 3-5 4451 NULL
+ieee80211_key_alloc_fndecl_4452_fields ieee80211_key_alloc fndecl 3 4452 NULL
+mnt_want_write_file_fndecl_4456_fields mnt_want_write_file fndecl 0 4456 NULL
+sftid_base_tid_info_4462_fields sftid_base tid_info 0 4462 NULL
+fifo_size_fritz_bcs_4463_fields fifo_size fritz_bcs 0 4463 NULL
+kernel_read_fndecl_4468_fields kernel_read fndecl 0-4 4468 NULL nohasharray
+filemap_map_pages_fndecl_4468_fields filemap_map_pages fndecl 2 4468 &kernel_read_fndecl_4468_fields
+complete_request_fndecl_4479_fields complete_request fndecl 2 4479 NULL
+hdmi_create_eld_ctl_fndecl_4485_fields hdmi_create_eld_ctl fndecl 2 4485 NULL
+hdr_len_l2tp_session_4486_fields hdr_len l2tp_session 0 4486 NULL nohasharray
+fragments_squashfs_super_block_4486_fields fragments squashfs_super_block 0 4486 &hdr_len_l2tp_session_4486_fields
+fw_size_amdgpu_firmware_4488_fields fw_size amdgpu_firmware 0 4488 NULL
+fallocate_chunk_fndecl_4489_fields fallocate_chunk fndecl 3 4489 NULL
+load_xattr_datum_fndecl_4505_fields load_xattr_datum fndecl 0 4505 NULL
+__mei_cl_recv_fndecl_4519_fields __mei_cl_recv fndecl 0-3 4519 NULL
+result_MOSDOpReply_4530_fields result MOSDOpReply 0 4530 NULL
+to_irq_gpio_chip_4534_fields to_irq gpio_chip 0 4534 NULL
+ovl_posix_acl_xattr_set_fndecl_4535_fields ovl_posix_acl_xattr_set fndecl 6 4535 NULL
+log_ind_tbl_size_ib_rwq_ind_table_init_attr_4542_fields log_ind_tbl_size ib_rwq_ind_table_init_attr 0 4542 NULL
+nfs3_proc_readdir_fndecl_4544_fields nfs3_proc_readdir fndecl 5 4544 NULL
+BlocksPerUnit_partition_t_4545_fields BlocksPerUnit partition_t 0 4545 NULL
+uhci_giveback_urb_fndecl_4547_fields uhci_giveback_urb fndecl 4 4547 NULL
+data_size_cz_buffer_entry_4548_fields data_size cz_buffer_entry 0 4548 NULL
+qdepth_uas_dev_info_4551_fields qdepth uas_dev_info 0 4551 NULL
+__collapse_huge_page_swapin_fndecl_4553_fields __collapse_huge_page_swapin fndecl 3 4553 NULL nohasharray
+data_len_o2net_msg_4553_fields data_len o2net_msg 0 4553 &__collapse_huge_page_swapin_fndecl_4553_fields
+usbnet_write_cmd_fndecl_4556_fields usbnet_write_cmd fndecl 7 4556 NULL
+hwcursor_size_sis_video_info_4560_fields hwcursor_size sis_video_info 0 4560 NULL
+channels_snd_korg1212_4562_fields channels snd_korg1212 0 4562 NULL
+usbvision_rvmalloc_fndecl_4564_fields usbvision_rvmalloc fndecl 1 4564 NULL
+word1_pkt_stat_desc_4565_fields word1 pkt_stat_desc 0 4565 NULL
+far_copies_geom_4570_fields far_copies geom 0 4570 NULL
+dlen_nft_set_4577_fields dlen nft_set 0 4577 NULL
+netvsc_recv_callback_fndecl_4592_fields netvsc_recv_callback fndecl 6 4592 NULL
+rx_buf_sz_gem_4593_fields rx_buf_sz gem 0 4593 NULL nohasharray
+cxd2841er_read_regs_fndecl_4593_fields cxd2841er_read_regs fndecl 5 4593 &rx_buf_sz_gem_4593_fields
+header_size_partition_4606_fields header_size partition 0 4606 NULL
+btrfs_del_inode_extref_fndecl_4607_fields btrfs_del_inode_extref fndecl 4 4607 NULL
+hdr_dwords_verbs_txreq_4608_fields hdr_dwords verbs_txreq 0 4608 NULL
+max_event_log_size_iwl_base_params_4612_fields max_event_log_size iwl_base_params 0 4612 NULL
+sxgbe_change_mtu_fndecl_4613_fields sxgbe_change_mtu fndecl 2 4613 NULL
+tm6000_i2c_send_regs_fndecl_4617_fields tm6000_i2c_send_regs fndecl 5 4617 NULL
+cksumlength_gss_krb5_enctype_4630_fields cksumlength gss_krb5_enctype 0 4630 NULL
+tcam_size_mc5_4631_fields tcam_size mc5 0 4631 NULL nohasharray
+size_minus_one_mxt_object_4631_fields size_minus_one mxt_object 0 4631 &tcam_size_mc5_4631_fields
+total_bytes__osd_req_data_segment_4634_fields total_bytes _osd_req_data_segment 0 4634 NULL
+setup_efi_state_fndecl_4639_fields setup_efi_state fndecl 4-5-2-3 4639 NULL
+irq_nvecs_bnx2_4644_fields irq_nvecs bnx2 0 4644 NULL
+read_eeprom_bytes_fndecl_4649_fields read_eeprom_bytes fndecl 4 4649 NULL
+size_simple_transaction_argresp_4650_fields size simple_transaction_argresp 0 4650 NULL
+ie_len_mesh_setup_4661_fields ie_len mesh_setup 0 4661 NULL
+buffer_size_smsusb_device_t_4667_fields buffer_size smsusb_device_t 0 4667 NULL
+overridesize_vardecl_nandsim_c_4668_fields overridesize vardecl_nandsim.c 0 4668 NULL
+r10_sync_page_io_fndecl_4672_fields r10_sync_page_io fndecl 3-2 4672 NULL
+bytenr_btrfs_ordered_sum_4679_fields bytenr btrfs_ordered_sum 0 4679 NULL
+dm_get_reserved_bio_based_ios_fndecl_4680_fields dm_get_reserved_bio_based_ios fndecl 0 4680 NULL
+l1_dirbase_vardecl_acpi_extlog_c_4681_fields l1_dirbase vardecl_acpi_extlog.c 0 4681 NULL
+_rtl92s_get_h2c_cmdlen_fndecl_4683_fields _rtl92s_get_h2c_cmdlen fndecl 0 4683 NULL
+snd_pcm_hw_param_near_fndecl_4691_fields snd_pcm_hw_param_near fndecl 4 4691 NULL
+optlen_ip_options_4698_fields optlen ip_options 0 4698 NULL
+bpf_func_bpf_prog_4701_fields bpf_func bpf_prog 0 4701 NULL
+xdr_decode_word_fndecl_4707_fields xdr_decode_word fndecl 2 4707 NULL
+count_user_sgentry64_4714_fields count user_sgentry64 0 4714 NULL
+hpfs_ea_remove_fndecl_4717_fields hpfs_ea_remove fndecl 4-2 4717 NULL
+bits_pca955x_chipdef_4718_fields bits pca955x_chipdef 0 4718 NULL
+next_fpm_addr_i40iw_hmc_pble_rsrc_4719_fields next_fpm_addr i40iw_hmc_pble_rsrc 0 4719 NULL
+cur_swap_swap_map_handle_4724_fields cur_swap swap_map_handle 0 4724 NULL
+next_page_mpage_da_data_4726_fields next_page mpage_da_data 0 4726 NULL
+displacement_bts_phys_4728_fields displacement bts_phys 0 4728 NULL
+net2272_read_packet_fndecl_4735_fields net2272_read_packet fndecl 4 4735 NULL
+ndigits_ecdh_ctx_4737_fields ndigits ecdh_ctx 0 4737 NULL
+qla82xx_pci_mem_read_direct_fndecl_4739_fields qla82xx_pci_mem_read_direct fndecl 2 4739 NULL
+smk_set_cipso_fndecl_4744_fields smk_set_cipso fndecl 3 4744 NULL
+num_srq_mthca_profile_4747_fields num_srq mthca_profile 0 4747 NULL
+netlbl_catmap_setrng_fndecl_4749_fields netlbl_catmap_setrng fndecl 2 4749 NULL
+page_offset_i40e_rx_buffer_4750_fields page_offset i40e_rx_buffer 0 4750 NULL
+format_count_drm_plane_4754_fields format_count drm_plane 0 4754 NULL
+maxpacket_sl811h_ep_4755_fields maxpacket sl811h_ep 0 4755 NULL
+igbvf_receive_skb_fndecl_4757_fields igbvf_receive_skb fndecl 5 4757 NULL
+read_reg_cc770_priv_4760_fields read_reg cc770_priv 0 4760 NULL
+max_i2s_chan_img_i2s_in_4765_fields max_i2s_chan img_i2s_in 0 4765 NULL
+iomap_begin_iomap_ops_4769_fields iomap_begin iomap_ops 0 4769 NULL nohasharray
+map_sz_cyttsp4_sysinfo_ofs_4769_fields map_sz cyttsp4_sysinfo_ofs 0 4769 &iomap_begin_iomap_ops_4769_fields
+length_property_4777_fields length property 0 4777 NULL
+stride_snd_usb_endpoint_4779_fields stride snd_usb_endpoint 0 4779 NULL
+qed_ilt_cli_blk_fill_fndecl_4780_fields qed_ilt_cli_blk_fill fndecl 4-5 4780 NULL
+n_channels_cfg80211_scan_request_4785_fields n_channels cfg80211_scan_request 0 4785 NULL nohasharray
+crtc_vsync_start_drm_display_mode_4785_fields crtc_vsync_start drm_display_mode 0 4785 &n_channels_cfg80211_scan_request_4785_fields
+fmc_send_cmd_fndecl_4800_fields fmc_send_cmd fndecl 5-0 4800 NULL
+drbd_issue_discard_or_zero_out_fndecl_4809_fields drbd_issue_discard_or_zero_out fndecl 2-3 4809 NULL
+set_indirect_ea_fndecl_4810_fields set_indirect_ea fndecl 5-3 4810 NULL
+INFTL_deleteblock_fndecl_4811_fields INFTL_deleteblock fndecl 2 4811 NULL
+length_reiserfs_security_handle_4813_fields length reiserfs_security_handle 0 4813 NULL
+buffer_size_ide_tape_obj_4815_fields buffer_size ide_tape_obj 0 4815 NULL nohasharray
+width_tw686x_video_channel_4815_fields width tw686x_video_channel 0 4815 &buffer_size_ide_tape_obj_4815_fields
+drm_mode_vrefresh_fndecl_4817_fields drm_mode_vrefresh fndecl 0 4817 NULL
+ov534_reg_read_fndecl_4820_fields ov534_reg_read fndecl 0 4820 NULL
+ext4_dir_llseek_fndecl_4826_fields ext4_dir_llseek fndecl 2 4826 NULL
+new_orphans_ubifs_info_4827_fields new_orphans ubifs_info 0 4827 NULL
+i2c_read_fndecl_4828_fields i2c_read fndecl 4-6 4828 NULL nohasharray
+find_skb_fndecl_4828_fields find_skb fndecl 3 4828 &i2c_read_fndecl_4828_fields nohasharray
+period_bytes_snd_card_asihpi_pcm_4828_fields period_bytes snd_card_asihpi_pcm 0 4828 &find_skb_fndecl_4828_fields
+nelems_cciss_scsi_cmd_stack_t_4829_fields nelems cciss_scsi_cmd_stack_t 0 4829 NULL
+compat_ipv6_setsockopt_fndecl_4839_fields compat_ipv6_setsockopt fndecl 5 4839 NULL
+bio_trim_fndecl_4843_fields bio_trim fndecl 2-3 4843 NULL
+start_service_discovery_fndecl_4846_fields start_service_discovery fndecl 4 4846 NULL
+hash_size_cache_detail_4852_fields hash_size cache_detail 0 4852 NULL
+iommu_bit_gk20a_instmem_4857_fields iommu_bit gk20a_instmem 0 4857 NULL nohasharray
+start__iohandle_4857_fields start _iohandle 0 4857 &iommu_bit_gk20a_instmem_4857_fields
+max_tgts_snic_fw_info_4861_fields max_tgts snic_fw_info 0 4861 NULL
+encode_path_fndecl_4865_fields encode_path fndecl 3 4865 NULL
+i40e_reserve_msix_vectors_fndecl_4870_fields i40e_reserve_msix_vectors fndecl 0 4870 NULL
+i_lenEAttr_udf_inode_info_4872_fields i_lenEAttr udf_inode_info 0 4872 NULL nohasharray
+find_overflow_devnum_fndecl_4872_fields find_overflow_devnum fndecl 0 4872 &i_lenEAttr_udf_inode_info_4872_fields
+out_args_qlcnic_mailbox_metadata_4881_fields out_args qlcnic_mailbox_metadata 0 4881 NULL
+op_remote_addr_rm_atomic_op_4890_fields op_remote_addr rm_atomic_op 0 4890 NULL
+mlx4_get_eqs_per_port_fndecl_4892_fields mlx4_get_eqs_per_port fndecl 0 4892 NULL
+credits_send_context_info_4894_fields credits send_context_info 0 4894 NULL nohasharray
+snd_interval_refine_min_fndecl_4894_fields snd_interval_refine_min fndecl 2 4894 &credits_send_context_info_4894_fields nohasharray
+sc_datablk_cnt_nilfs_sc_info_4894_fields sc_datablk_cnt nilfs_sc_info 0 4894 &snd_interval_refine_min_fndecl_4894_fields
+head_circ_buf_4897_fields head circ_buf 0 4897 NULL
+wMaxSegmentSize_usb_cdc_ether_desc_4898_fields wMaxSegmentSize usb_cdc_ether_desc 0 4898 NULL
+upper_size_to_lower_size_fndecl_4899_fields upper_size_to_lower_size fndecl 2-0 4899 NULL
+need_tx_headroom_prism2_helper_functions_4902_fields need_tx_headroom prism2_helper_functions 0 4902 NULL
+build_verbs_ulp_payload_fndecl_4906_fields build_verbs_ulp_payload fndecl 3 4906 NULL
+rcvhdrq_size_hfi1_ctxtdata_4912_fields rcvhdrq_size hfi1_ctxtdata 0 4912 NULL
+leaf_copy_items_fndecl_4923_fields leaf_copy_items fndecl 5 4923 NULL
+ui_size_ubifs_inode_4934_fields ui_size ubifs_inode 0 4934 NULL
+bpp_drm_mode_fb_cmd_4936_fields bpp drm_mode_fb_cmd 0 4936 NULL
+mlx5_ib_db_map_user_fndecl_4950_fields mlx5_ib_db_map_user fndecl 2 4950 NULL nohasharray
+update_tind_extent_range_fndecl_4950_fields update_tind_extent_range fndecl 3 4950 &mlx5_ib_db_map_user_fndecl_4950_fields
+myri10ge_get_txrx_fndecl_4953_fields myri10ge_get_txrx fndecl 2 4953 NULL
+radeon_align_pitch_fndecl_4969_fields radeon_align_pitch fndecl 0-2 4969 NULL
+len_htc_record_hdr_4978_fields len htc_record_hdr 0 4978 NULL
+len_i40iw_sge_4979_fields len i40iw_sge 0 4979 NULL
+t_data_nents_se_cmd_4981_fields t_data_nents se_cmd 0 4981 NULL
+buffer_size_most_channel_config_4986_fields buffer_size most_channel_config 0 4986 NULL
+stripe_unit_ore_layout_4991_fields stripe_unit ore_layout 0 4991 NULL
+__mt7601u_dma_fw_fndecl_4994_fields __mt7601u_dma_fw fndecl 4 4994 NULL
+kmem_cache_create_fndecl_5007_fields kmem_cache_create fndecl 2-3 5007 NULL
+read_int_fndecl_5009_fields read_int fndecl 0 5009 NULL
+numEntries__ATOM_PPLIB_SAMClk_Voltage_Limit_Table_5010_fields numEntries _ATOM_PPLIB_SAMClk_Voltage_Limit_Table 0 5010 NULL
+xfs_qm_dqget_fndecl_5012_fields xfs_qm_dqget fndecl 0 5012 NULL nohasharray
+o2net_send_message_fndecl_5012_fields o2net_send_message fndecl 4 5012 &xfs_qm_dqget_fndecl_5012_fields nohasharray
+mgmt_limited_event_fndecl_5012_fields mgmt_limited_event fndecl 4 5012 &o2net_send_message_fndecl_5012_fields
+xenvif_gop_skb_fndecl_5015_fields xenvif_gop_skb fndecl 0 5015 NULL
+info1_htt_rx_indication_hdr_5016_fields info1 htt_rx_indication_hdr 0 5016 NULL
+hard_header_len_net_device_5025_fields hard_header_len net_device 0 5025 NULL
+ubifs_unpack_bits_fndecl_5033_fields ubifs_unpack_bits fndecl 0-3 5033 NULL
+ext2_xattr_security_set_fndecl_5039_fields ext2_xattr_security_set fndecl 6 5039 NULL nohasharray
+nr_pages_firmware_buf_5039_fields nr_pages firmware_buf 0 5039 &ext2_xattr_security_set_fndecl_5039_fields
+device_tg3_dev_id_5042_fields device tg3_dev_id 0 5042 NULL nohasharray
+mlx4_log_num_mgm_entry_size_vardecl_5042_fields mlx4_log_num_mgm_entry_size vardecl 0 5042 &device_tg3_dev_id_5042_fields
+start_vhost_umem_node_5046_fields start vhost_umem_node 0 5046 NULL
+index_squashfs_dir_index_5053_fields index squashfs_dir_index 0 5053 NULL
+rcvidx_IsdnCardState_5055_fields rcvidx IsdnCardState 0 5055 NULL nohasharray
+compress_raw_buf_fndecl_5055_fields compress_raw_buf fndecl 0 5055 &rcvidx_IsdnCardState_5055_fields
+ext4_llseek_fndecl_5060_fields ext4_llseek fndecl 2 5060 NULL
+len_BufferControl_5068_fields len BufferControl 0 5068 NULL
+cmd_q_count_ccp_device_5069_fields cmd_q_count ccp_device 0 5069 NULL
+size_compat_arpt_replace_5071_fields size compat_arpt_replace 0 5071 NULL
+ie_len_cfg80211_scan_request_5073_fields ie_len cfg80211_scan_request 0 5073 NULL
+brcmf_sdiod_txglomsz_vardecl_common_c_5079_fields brcmf_sdiod_txglomsz vardecl_common.c 0 5079 NULL
+udf_do_extend_file_fndecl_5093_fields udf_do_extend_file fndecl 4 5093 NULL nohasharray
+domain_a_len_ccp_ecc_point_math_5093_fields domain_a_len ccp_ecc_point_math 0 5093 &udf_do_extend_file_fndecl_5093_fields
+at25_ee_write_fndecl_5099_fields at25_ee_write fndecl 4-2 5099 NULL
+default_file_splice_write_fndecl_5103_fields default_file_splice_write fndecl 4 5103 NULL
+efi_get_runtime_map_desc_size_fndecl_5111_fields efi_get_runtime_map_desc_size fndecl 0 5111 NULL
+mem_eni_dev_5112_fields mem eni_dev 0 5112 NULL
+num_banks_adf_hw_device_data_5115_fields num_banks adf_hw_device_data 0 5115 NULL
+__link_buffer_fndecl_5117_fields __link_buffer fndecl 2 5117 NULL nohasharray
+spi_bits_per_word_cw1200_platform_data_spi_5117_fields spi_bits_per_word cw1200_platform_data_spi 0 5117 &__link_buffer_fndecl_5117_fields
+num_gpio_tc3589x_5118_fields num_gpio tc3589x 0 5118 NULL
+replay_log_leb_fndecl_5123_fields replay_log_leb fndecl 3 5123 NULL
+ocfs2_trim_extent_fndecl_5124_fields ocfs2_trim_extent fndecl 0-4-3 5124 NULL
+ccp_init_sg_workarea_fndecl_5128_fields ccp_init_sg_workarea fndecl 4 5128 NULL
+fuse_dev_splice_write_fndecl_5131_fields fuse_dev_splice_write fndecl 4 5131 NULL
+nfs4_init_callback_netid_fndecl_5134_fields nfs4_init_callback_netid fndecl 0 5134 NULL
+rate_num_snd_pcm_hw_params_5135_fields rate_num snd_pcm_hw_params 0 5135 NULL
+channel_count_il_priv_5138_fields channel_count il_priv 0 5138 NULL nohasharray
+rlen_si2157_cmd_5138_fields rlen si2157_cmd 0 5138 &channel_count_il_priv_5138_fields
+__nvme_submit_user_cmd_fndecl_5142_fields __nvme_submit_user_cmd fndecl 4-7 5142 NULL
+xefi_blockcount_xfs_extent_free_item_5146_fields xefi_blockcount xfs_extent_free_item 0 5146 NULL nohasharray
+csio_scsi_eqsize_vardecl_5146_fields csio_scsi_eqsize vardecl 0 5146 &xefi_blockcount_xfs_extent_free_item_5146_fields
+ocfs2_iget_fndecl_5154_fields ocfs2_iget fndecl 2 5154 NULL
+stv0297_readregs_fndecl_5156_fields stv0297_readregs fndecl 4 5156 NULL nohasharray
+fw_cfg_p_base_vardecl_qemu_fw_cfg_c_5156_fields fw_cfg_p_base vardecl_qemu_fw_cfg.c 0 5156 &stv0297_readregs_fndecl_5156_fields
+tx_hdr_len_p54_common_5164_fields tx_hdr_len p54_common 0 5164 NULL
+indices_ixgbe_ring_feature_5170_fields indices ixgbe_ring_feature 0 5170 NULL
+ext4_es_insert_extent_fndecl_5178_fields ext4_es_insert_extent fndecl 0-3-2 5178 NULL nohasharray
+len_bts_file_action_5178_fields len bts_file_action 0 5178 &ext4_es_insert_extent_fndecl_5178_fields
+lpfc_issue_ct_rsp_fndecl_5182_fields lpfc_issue_ct_rsp fndecl 6 5182 NULL
+size_drm_amdgpu_gem_userptr_5196_fields size drm_amdgpu_gem_userptr 0 5196 NULL
+hidp_raw_request_fndecl_5198_fields hidp_raw_request fndecl 4 5198 NULL
+nr_nvkm_fifo_5199_fields nr nvkm_fifo 0 5199 NULL nohasharray
+alloc_fcdev_fndecl_5199_fields alloc_fcdev fndecl 1 5199 &nr_nvkm_fifo_5199_fields
+vtbl_size_ubi_device_5209_fields vtbl_size ubi_device 0 5209 NULL
+snd_midi_event_encode_fndecl_5210_fields snd_midi_event_encode fndecl 0 5210 NULL
+drm_gem_private_object_init_fndecl_5217_fields drm_gem_private_object_init fndecl 3 5217 NULL
+phys_ichxrom_window_5221_fields phys ichxrom_window 0 5221 NULL
+mmc_test_broken_transfer_fndecl_5224_fields mmc_test_broken_transfer fndecl 3-2 5224 NULL
+madvise_hwpoison_fndecl_5231_fields madvise_hwpoison fndecl 2 5231 NULL
+__ieee80211_stop_rx_ba_session_fndecl_5236_fields __ieee80211_stop_rx_ba_session fndecl 2 5236 NULL
+__scif_pin_pages_fndecl_5243_fields __scif_pin_pages fndecl 2 5243 NULL
+feednum_dvb_demux_5252_fields feednum dvb_demux 0 5252 NULL
+len_fstrim_range_5265_fields len fstrim_range 0 5265 NULL
+h_total_aty128_crtc_5275_fields h_total aty128_crtc 0 5275 NULL
+upload_data_fndecl_5277_fields upload_data fndecl 2 5277 NULL
+xlog_find_verify_log_record_fndecl_5285_fields xlog_find_verify_log_record fndecl 2 5285 NULL
+count_mpc8xxx_spi_5287_fields count mpc8xxx_spi 0 5287 NULL
+slba_nvme_dsm_range_5292_fields slba nvme_dsm_range 0 5292 NULL
+lpt_hght_ubifs_info_5299_fields lpt_hght ubifs_info 0 5299 NULL nohasharray
+dma_offset_freelQ_5299_fields dma_offset freelQ 0 5299 &lpt_hght_ubifs_info_5299_fields
+beep_amp_alc_spec_5315_fields beep_amp alc_spec 0 5315 NULL
+matchsize_xt_match_5320_fields matchsize xt_match 0 5320 NULL
+___alloc_bootmem_node_fndecl_5329_fields ___alloc_bootmem_node fndecl 3-4-5 5329 NULL
+devcd_read_from_sgtable_fndecl_5341_fields devcd_read_from_sgtable fndecl 2-5-3 5341 NULL nohasharray
+jfs_quota_read_fndecl_5341_fields jfs_quota_read fndecl 5 5341 &devcd_read_from_sgtable_fndecl_5341_fields
+lock_and_cleanup_extent_if_need_fndecl_5347_fields lock_and_cleanup_extent_if_need fndecl 5-4 5347 NULL
+data_count_iscsi_task_5350_fields data_count iscsi_task 0 5350 NULL
+brcmf_usb_send_ctl_fndecl_5357_fields brcmf_usb_send_ctl fndecl 3 5357 NULL nohasharray
+fmc_device_register_n_fndecl_5357_fields fmc_device_register_n fndecl 2 5357 &brcmf_usb_send_ctl_fndecl_5357_fields
+michael_mic_fndecl_5363_fields michael_mic fndecl 5 5363 NULL
+nfs4_proc_readdir_fndecl_5367_fields nfs4_proc_readdir fndecl 5 5367 NULL
+xfs_buf_read_uncached_fndecl_5369_fields xfs_buf_read_uncached fndecl 2-3 5369 NULL
+max_skl_dfw_algo_data_5374_fields max skl_dfw_algo_data 0 5374 NULL
+mwifiex_write_data_to_card_fndecl_5375_fields mwifiex_write_data_to_card fndecl 3 5375 NULL
+max_header_size_irlan_client_cb_5378_fields max_header_size irlan_client_cb 0 5378 NULL nohasharray
+block_size_squashfs_sb_info_5378_fields block_size squashfs_sb_info 0 5378 &max_header_size_irlan_client_cb_5378_fields
+skbprio_ip_set_ext_5381_fields skbprio ip_set_ext 0 5381 NULL nohasharray
+flash_dev_cache_miss_fndecl_5381_fields flash_dev_cache_miss fndecl 4 5381 &skbprio_ip_set_ext_5381_fields
+fuse_perform_write_fndecl_5386_fields fuse_perform_write fndecl 0-4 5386 NULL
+max_gen_clk_probe_fndecl_5389_fields max_gen_clk_probe fndecl 5 5389 NULL
+check_iommu_size_fndecl_5390_fields check_iommu_size fndecl 0-2-1 5390 NULL
+pcibios_window_alignment_fndecl_5391_fields pcibios_window_alignment fndecl 0 5391 NULL
+error_thin_bio_list_fndecl_5394_fields error_thin_bio_list fndecl 3 5394 NULL
+remap_oldmem_pfn_checked_fndecl_5398_fields remap_oldmem_pfn_checked fndecl 2-3 5398 NULL nohasharray
+snd_hda_get_connections_fndecl_5398_fields snd_hda_get_connections fndecl 0 5398 &remap_oldmem_pfn_checked_fndecl_5398_fields
+len_iw_mgmt_info_element_5411_fields len iw_mgmt_info_element 0 5411 NULL
+rq_size_i40iw_puda_rsrc_info_5413_fields rq_size i40iw_puda_rsrc_info 0 5413 NULL
+ies_len_user_conn_req_5414_fields ies_len user_conn_req 0 5414 NULL
+value_xen_pci_op_5416_fields value xen_pci_op 0 5416 NULL
+allocmin_nilfs_sufile_info_5418_fields allocmin nilfs_sufile_info 0 5418 NULL
+reg_size_intel_iommu_5423_fields reg_size intel_iommu 0 5423 NULL nohasharray
+nilfs_sufile_truncate_range_fndecl_5423_fields nilfs_sufile_truncate_range fndecl 3-2 5423 &reg_size_intel_iommu_5423_fields
+sigmadsp_read_i2c_fndecl_5435_fields sigmadsp_read_i2c fndecl 4 5435 NULL
+size_drm_radeon_gem_create_5440_fields size drm_radeon_gem_create 0 5440 NULL
+cap_nvme_loop_ctrl_5458_fields cap nvme_loop_ctrl 0 5458 NULL
+vlen_nfsd_writeargs_5461_fields vlen nfsd_writeargs 0 5461 NULL
+btrfs_fiemap_fndecl_5462_fields btrfs_fiemap fndecl 4-3 5462 NULL
+num_stations_il_priv_5465_fields num_stations il_priv 0 5465 NULL
+acpi_register_gsi_ioapic_fndecl_5477_fields acpi_register_gsi_ioapic fndecl 2 5477 NULL
+max_pkeys_mthca_dev_lim_5481_fields max_pkeys mthca_dev_lim 0 5481 NULL
+virtio_transport_put_credit_fndecl_5482_fields virtio_transport_put_credit fndecl 2 5482 NULL
+valuelen_xfs_attr_sf_entry_5490_fields valuelen xfs_attr_sf_entry 0 5490 NULL
+block_isofs_fid_5500_fields block isofs_fid 0 5500 NULL
+s_fpb_ufs_sb_private_info_5504_fields s_fpb ufs_sb_private_info 0 5504 NULL
+__tipc_sendmsg_fndecl_5510_fields __tipc_sendmsg fndecl 3 5510 NULL
+vmw_execbuf_submit_cmdbuf_fndecl_5516_fields vmw_execbuf_submit_cmdbuf fndecl 3 5516 NULL
+smk_write_rules_list_fndecl_5526_fields smk_write_rules_list fndecl 3 5526 NULL
+line_slgt_info_5527_fields line slgt_info 0 5527 NULL
+ceph_tcp_sendpage_fndecl_5531_fields ceph_tcp_sendpage fndecl 0-4 5531 NULL
+batadv_arp_get_type_fndecl_5538_fields batadv_arp_get_type fndecl 3 5538 NULL nohasharray
+__vmalloc_node_range_fndecl_5538_fields __vmalloc_node_range fndecl 1-3 5538 &batadv_arp_get_type_fndecl_5538_fields
+vector_acpi_hest_notify_5540_fields vector acpi_hest_notify 0 5540 NULL
+logical_ext4_allocation_request_5548_fields logical ext4_allocation_request 0 5548 NULL
+__netdev_alloc_skb_fndecl_5552_fields __netdev_alloc_skb fndecl 2 5552 NULL
+hpfs_search_hotfix_map_fndecl_5559_fields hpfs_search_hotfix_map fndecl 0-2 5559 NULL
+filemap_fdatawait_range_fndecl_5563_fields filemap_fdatawait_range fndecl 0 5563 NULL
+nfs41_maxread_overhead_vardecl_5564_fields nfs41_maxread_overhead vardecl 0 5564 NULL
+raid10_format_to_md_layout_fndecl_5567_fields raid10_format_to_md_layout fndecl 0-3 5567 NULL
+ihl_xfrm_mode_skb_cb_5571_fields ihl xfrm_mode_skb_cb 0 5571 NULL nohasharray
+session_udf_options_5571_fields session udf_options 0 5571 &ihl_xfrm_mode_skb_cb_5571_fields
+__dev_set_mtu_fndecl_5572_fields __dev_set_mtu fndecl 2 5572 NULL
+nblocks_range2trim_5574_fields nblocks range2trim 0 5574 NULL
+target_check_max_data_sg_nents_fndecl_5575_fields target_check_max_data_sg_nents fndecl 3 5575 NULL
+i2c_read_eeprom_fndecl_5583_fields i2c_read_eeprom fndecl 5 5583 NULL
+nfqnl_get_sk_secctx_fndecl_5586_fields nfqnl_get_sk_secctx fndecl 0 5586 NULL
+bg_itable_unused_lo_ext4_group_desc_5594_fields bg_itable_unused_lo ext4_group_desc 0 5594 NULL
+memory_map_bottom_up_fndecl_5599_fields memory_map_bottom_up fndecl 1 5599 NULL
+scsiback_send_response_fndecl_5601_fields scsiback_send_response fndecl 4 5601 NULL
+nftl_write_fndecl_5605_fields nftl_write fndecl 2 5605 NULL
+pbl_base_rdma_info_5607_fields pbl_base rdma_info 0 5607 NULL
+odata_dma_usb_xpad_5619_fields odata_dma usb_xpad 0 5619 NULL
+shmem_fallocate_fndecl_5621_fields shmem_fallocate fndecl 3-4 5621 NULL
+xfs_iext_insert_fndecl_5624_fields xfs_iext_insert fndecl 3 5624 NULL
+gtt_end_radeon_mc_5628_fields gtt_end radeon_mc 0 5628 NULL
+max_sectors_ide_port_info_5629_fields max_sectors ide_port_info 0 5629 NULL
+id_iio_dev_5631_fields id iio_dev 0 5631 NULL
+screen_width_vardecl_hyperv_fb_c_5635_fields screen_width vardecl_hyperv_fb.c 0 5635 NULL nohasharray
+platform_mmio_alloc_vardecl_platform_pci_c_5635_fields platform_mmio_alloc vardecl_platform-pci.c 0 5635 &screen_width_vardecl_hyperv_fb_c_5635_fields
+num_counters_compat_ip6t_replace_5636_fields num_counters compat_ip6t_replace 0 5636 NULL
+udpv6_recvmsg_fndecl_5638_fields udpv6_recvmsg fndecl 3 5638 NULL
+efi_memdesc_size_efi_info_5654_fields efi_memdesc_size efi_info 0 5654 NULL
+__spi_map_msg_fndecl_5657_fields __spi_map_msg fndecl 0 5657 NULL nohasharray
+dev_id_pci_id_descr_5657_fields dev_id pci_id_descr 0 5657 &__spi_map_msg_fndecl_5657_fields
+vmw_kms_stdu_dma_fndecl_5659_fields vmw_kms_stdu_dma fndecl 7 5659 NULL
+isert_put_login_tx_fndecl_5660_fields isert_put_login_tx fndecl 3 5660 NULL
+block_mask_htc_target_5671_fields block_mask htc_target 0 5671 NULL
+sgl_read_to_frags_fndecl_5672_fields sgl_read_to_frags fndecl 3-2 5672 NULL
+blklen_regcache_rbtree_node_5679_fields blklen regcache_rbtree_node 0 5679 NULL nohasharray
+mtu_ppp_channel_5679_fields mtu ppp_channel 0 5679 &blklen_regcache_rbtree_node_5679_fields
+ext4_es_alloc_extent_fndecl_5681_fields ext4_es_alloc_extent fndecl 2-3 5681 NULL
+_find_first_zero_bit_le_fndecl_5684_fields _find_first_zero_bit_le fndecl 0 5684 NULL
+bio_alloc_mddev_fndecl_5685_fields bio_alloc_mddev fndecl 2 5685 NULL
+lbtf_cmd_async_fndecl_5691_fields lbtf_cmd_async fndecl 4 5691 NULL
+s_blocks_count_ext2_super_block_5695_fields s_blocks_count ext2_super_block 0 5695 NULL
+write_bytes_to_xdr_buf_fndecl_5702_fields write_bytes_to_xdr_buf fndecl 4-2 5702 NULL
+virtnet_change_mtu_fndecl_5709_fields virtnet_change_mtu fndecl 2 5709 NULL
+zm_wmfw_adsp1_alg_hdr_5710_fields zm wmfw_adsp1_alg_hdr 0 5710 NULL
+vt_hdr_vxfs_typed_5715_fields vt_hdr vxfs_typed 0 5715 NULL
+hfsplus_get_block_fndecl_5725_fields hfsplus_get_block fndecl 2 5725 NULL
+max_phys_sect_nvm_dev_ops_5745_fields max_phys_sect nvm_dev_ops 0 5745 NULL
+scrbuf_sisusb_usb_data_5749_fields scrbuf sisusb_usb_data 0 5749 NULL
+skb_checksum_maybe_trim_fndecl_5755_fields skb_checksum_maybe_trim fndecl 2 5755 NULL
+nci_prop_cmd_fndecl_5756_fields nci_prop_cmd fndecl 3 5756 NULL
+setup_extent_mapping_fndecl_5768_fields setup_extent_mapping fndecl 3-2-4 5768 NULL
+xfs_map_at_offset_fndecl_5785_fields xfs_map_at_offset fndecl 4 5785 NULL
+mc_handle_file_pte_fndecl_5787_fields mc_handle_file_pte fndecl 2 5787 NULL
+bq32k_read_fndecl_5789_fields bq32k_read fndecl 4 5789 NULL
+pci_mem_start_vardecl_5790_fields pci_mem_start vardecl 0 5790 NULL
+msix_count_i40e_info_5794_fields msix_count i40e_info 0 5794 NULL nohasharray
+init_req_packet_fndecl_5794_fields init_req_packet fndecl 4 5794 &msix_count_i40e_info_5794_fields
+p9_check_zc_errors_fndecl_5806_fields p9_check_zc_errors fndecl 4 5806 NULL
+usb_ftdi_elan_edset_output_fndecl_5808_fields usb_ftdi_elan_edset_output fndecl 0 5808 NULL
+NumPhys__CONFIG_PAGE_SAS_EXPANDER_0_5809_fields NumPhys _CONFIG_PAGE_SAS_EXPANDER_0 0 5809 NULL nohasharray
+ubifs_recover_size_accum_fndecl_5809_fields ubifs_recover_size_accum fndecl 4 5809 &NumPhys__CONFIG_PAGE_SAS_EXPANDER_0_5809_fields
+length_uwb_ie_hdr_5811_fields length uwb_ie_hdr 0 5811 NULL nohasharray
+firmware_data_write_fndecl_5811_fields firmware_data_write fndecl 6-5 5811 &length_uwb_ie_hdr_5811_fields
+ncp_read_bounce_fndecl_5812_fields ncp_read_bounce fndecl 8 5812 NULL
+compr_flush_fndecl_5826_fields compr_flush fndecl 2 5826 NULL
+dvbdmx_write_fndecl_5836_fields dvbdmx_write fndecl 3 5836 NULL
+start_uffdio_range_5837_fields start uffdio_range 0 5837 NULL nohasharray
+synproxy_options_size_fndecl_5837_fields synproxy_options_size fndecl 0 5837 &start_uffdio_range_5837_fields
+i2c_mux_add_adapter_fndecl_5840_fields i2c_mux_add_adapter fndecl 2 5840 NULL
+transferred_vardecl_shuttle_usbat_c_5845_fields transferred vardecl_shuttle_usbat.c 0 5845 NULL
+sound_insert_unit_fndecl_5861_fields sound_insert_unit fndecl 3-4 5861 NULL
+len_hv_mpb_array_5864_fields len hv_mpb_array 0 5864 NULL
+um_size_bcm5974_config_5867_fields um_size bcm5974_config 0 5867 NULL
+e1000_receive_skb_fndecl_5875_fields e1000_receive_skb fndecl 5 5875 NULL
+get_rx_status_altera_dmaops_5878_fields get_rx_status altera_dmaops 0 5878 NULL nohasharray
+sq_db_page_mthca_create_qp_5878_fields sq_db_page mthca_create_qp 0 5878 &get_rx_status_altera_dmaops_5878_fields
+cydata_ofsh_cyttsp4_sysinfo_data_5887_fields cydata_ofsh cyttsp4_sysinfo_data 0 5887 NULL
+entity_internal_idx_max_media_device_5890_fields entity_internal_idx_max media_device 0 5890 NULL nohasharray
+max_sg_count_hpt_iop_request_get_config_5890_fields max_sg_count hpt_iop_request_get_config 0 5890 &entity_internal_idx_max_media_device_5890_fields
+force_max_req_size_vardecl_vub300_c_5891_fields force_max_req_size vardecl_vub300.c 0 5891 NULL
+dma_common_pages_remap_fndecl_5893_fields dma_common_pages_remap fndecl 2 5893 NULL
+size_squashfs_dir_entry_5896_fields size squashfs_dir_entry 0 5896 NULL
+__nla_reserve_fndecl_5901_fields __nla_reserve fndecl 3 5901 NULL
+alloc_rx_slot_fndecl_5908_fields alloc_rx_slot fndecl 0 5908 NULL
+bytes_drm_i915_error_state_buf_5909_fields bytes drm_i915_error_state_buf 0 5909 NULL
+sctp_tsnmap_num_gabs_fndecl_5915_fields sctp_tsnmap_num_gabs fndecl 0 5915 NULL
+ocfs2_reflink_xattr_buckets_fndecl_5931_fields ocfs2_reflink_xattr_buckets fndecl 7 5931 NULL
+sq_size_i40iw_puda_rsrc_info_5933_fields sq_size i40iw_puda_rsrc_info 0 5933 NULL
+intel_gtt_unmap_memory_fndecl_5935_fields intel_gtt_unmap_memory fndecl 2 5935 NULL
+num_of_paging_blk_iwl_mvm_5936_fields num_of_paging_blk iwl_mvm 0 5936 NULL
+max_attributes_pmbus_data_5939_fields max_attributes pmbus_data 0 5939 NULL
+ide_config_drive_speed_fndecl_5940_fields ide_config_drive_speed fndecl 2 5940 NULL
+buffer_blocks_osst_buffer_5944_fields buffer_blocks osst_buffer 0 5944 NULL
+max_header_size_irda_sock_5950_fields max_header_size irda_sock 0 5950 NULL
+height_tm6000_fh_5952_fields height tm6000_fh 0 5952 NULL
+count_w6692B_hw_5953_fields count w6692B_hw 0 5953 NULL
+len_ias_value_5959_fields len ias_value 0 5959 NULL
+tx_hdrlen_brcmf_sdio_5961_fields tx_hdrlen brcmf_sdio 0 5961 NULL
+viafb_second_size_vardecl_viafbdev_c_5965_fields viafb_second_size vardecl_viafbdev.c 0 5965 NULL
+allocmax_nilfs_sufile_info_5969_fields allocmax nilfs_sufile_info 0 5969 NULL
+f2fs_setxattr_fndecl_5975_fields f2fs_setxattr fndecl 5 5975 NULL
+xfs_trans_roll_fndecl_5977_fields xfs_trans_roll fndecl 0 5977 NULL
+nfsd4_encode_dirent_fndecl_5983_fields nfsd4_encode_dirent fndecl 3 5983 NULL nohasharray
+do_rc_ack_fndecl_5983_fields do_rc_ack fndecl 3 5983 &nfsd4_encode_dirent_fndecl_5983_fields
+snd_hdac_read_parm_uncached_fndecl_6000_fields snd_hdac_read_parm_uncached fndecl 0 6000 NULL
+clk_recalc_fndecl_6001_fields clk_recalc fndecl 0-2 6001 NULL
+afs_vnode_store_data_fndecl_6011_fields afs_vnode_store_data fndecl 4-5 6011 NULL
+code_size_fw_bl_desc_6013_fields code_size fw_bl_desc 0 6013 NULL
+max_discard_sectors_queue_limits_6023_fields max_discard_sectors queue_limits 0 6023 NULL nohasharray
+status_register_read_fndecl_6023_fields status_register_read fndecl 4 6023 &max_discard_sectors_queue_limits_6023_fields
+wqe_cnt_mlx5_ib_wq_6024_fields wqe_cnt mlx5_ib_wq 0 6024 NULL
+flags_rtl8180_rx_desc_6025_fields flags rtl8180_rx_desc 0 6025 NULL
+xlog_bwrite_fndecl_6028_fields xlog_bwrite fndecl 2 6028 NULL
+size_drm_vc4_create_shader_bo_6033_fields size drm_vc4_create_shader_bo 0 6033 NULL
+msix_map_region_fndecl_6035_fields msix_map_region fndecl 2 6035 NULL
+cmipci_sb_reg_decode_fndecl_6048_fields cmipci_sb_reg_decode fndecl 2 6048 NULL
+n_ssids_cfg80211_scan_request_6049_fields n_ssids cfg80211_scan_request 0 6049 NULL
+dmi_len_vardecl_dmi_scan_c_6054_fields dmi_len vardecl_dmi_scan.c 0 6054 NULL nohasharray
+ext4_inode_table_fndecl_6054_fields ext4_inode_table fndecl 0 6054 &dmi_len_vardecl_dmi_scan_c_6054_fields
+map_base_tpm_inf_dev_6056_fields map_base tpm_inf_dev 0 6056 NULL
+reqsize_kpp_alg_6064_fields reqsize kpp_alg 0 6064 NULL
+length_hci_ev_le_advertising_info_6074_fields length hci_ev_le_advertising_info 0 6074 NULL
+elog_len_extlog_l1_head_6075_fields elog_len extlog_l1_head 0 6075 NULL
+ioctx_alloc_fndecl_6081_fields ioctx_alloc fndecl 1 6081 NULL
+remote_miu_nfc_llcp_sock_6088_fields remote_miu nfc_llcp_sock 0 6088 NULL nohasharray
+pcifront_scan_root_fndecl_6088_fields pcifront_scan_root fndecl 2-3 6088 &remote_miu_nfc_llcp_sock_6088_fields
+channel_num_ad9523_channel_spec_6095_fields channel_num ad9523_channel_spec 0 6095 NULL
+__gfs2_xattr_set_fndecl_6098_fields __gfs2_xattr_set fndecl 4 6098 NULL
+alloc_irdadev_fndecl_6103_fields alloc_irdadev fndecl 1 6103 NULL
+rate_min_snd_pcm_hardware_6109_fields rate_min snd_pcm_hardware 0 6109 NULL nohasharray
+blkdev_issue_discard_fndecl_6109_fields blkdev_issue_discard fndecl 0-3-2 6109 &rate_min_snd_pcm_hardware_6109_fields
+resid_scsi_data_buffer_6113_fields resid scsi_data_buffer 0 6113 NULL
+ilf_blkno_xfs_inode_log_format_6118_fields ilf_blkno xfs_inode_log_format 0 6118 NULL
+hblank_panel_info_6122_fields hblank panel_info 0 6122 NULL
+max_gs_mlx5_ib_wq_6148_fields max_gs mlx5_ib_wq 0 6148 NULL
+bytes_per_sector_mspro_devinfo_6149_fields bytes_per_sector mspro_devinfo 0 6149 NULL
+fts_ieee80211_device_6153_fields fts ieee80211_device 0 6153 NULL
+name_len_f2fs_dir_entry_6154_fields name_len f2fs_dir_entry 0 6154 NULL
+buf_size_rte_log_le_6160_fields buf_size rte_log_le 0 6160 NULL nohasharray
+udf_read_tagged_fndecl_6160_fields udf_read_tagged fndecl 2 6160 &buf_size_rte_log_le_6160_fields
+kernel_write_fndecl_6162_fields kernel_write fndecl 3-0 6162 NULL
+dsp_tone_hw_message_fndecl_6173_fields dsp_tone_hw_message fndecl 3 6173 NULL
+m_agirotor_xfs_mount_6177_fields m_agirotor xfs_mount 0 6177 NULL
+fs_descs_count_ffs_data_6179_fields fs_descs_count ffs_data 0 6179 NULL
+ubifs_xattr_set_fndecl_6192_fields ubifs_xattr_set fndecl 6 6192 NULL
+start_mtd_oob_buf64_6198_fields start mtd_oob_buf64 0 6198 NULL
+__geneve_change_mtu_fndecl_6199_fields __geneve_change_mtu fndecl 2 6199 NULL
+__einj_error_trigger_fndecl_6200_fields __einj_error_trigger fndecl 1 6200 NULL
+__send_write_same_fndecl_6201_fields __send_write_same fndecl 0 6201 NULL
+height_linux_logo_6207_fields height linux_logo 0 6207 NULL nohasharray
+digi_write_oob_command_fndecl_6207_fields digi_write_oob_command fndecl 3 6207 &height_linux_logo_6207_fields
+index_lola_stream_6210_fields index lola_stream 0 6210 NULL nohasharray
+dac_channels_pcm_oxygen_model_6210_fields dac_channels_pcm oxygen_model 0 6210 &index_lola_stream_6210_fields
+bnxt_calc_nr_ring_pages_fndecl_6213_fields bnxt_calc_nr_ring_pages fndecl 1-2-0 6213 NULL
+val_bits_regmap_config_6218_fields val_bits regmap_config 0 6218 NULL
+sc_ssid_len_wl18xx_event_mailbox_6223_fields sc_ssid_len wl18xx_event_mailbox 0 6223 NULL
+nr_sects_rrpc_6227_fields nr_sects rrpc 0 6227 NULL
+bytenr_backref_node_6238_fields bytenr backref_node 0 6238 NULL
+ag_xfs_fstrm_item_6243_fields ag xfs_fstrm_item 0 6243 NULL
+mode_offset_pktcdvd_device_6248_fields mode_offset pktcdvd_device 0 6248 NULL
+rxq_cnt_tg3_6249_fields rxq_cnt tg3 0 6249 NULL
+ubifs_leb_change_fndecl_6254_fields ubifs_leb_change fndecl 4 6254 NULL
+bNumInterfaces_usb_config_descriptor_6265_fields bNumInterfaces usb_config_descriptor 0 6265 NULL nohasharray
+blkno_xfs_bmalloca_6265_fields blkno xfs_bmalloca 0 6265 &bNumInterfaces_usb_config_descriptor_6265_fields
+xs_setup_xprt_fndecl_6266_fields xs_setup_xprt fndecl 3-2 6266 NULL
+size_drm_vmw_alloc_dmabuf_req_6273_fields size drm_vmw_alloc_dmabuf_req 0 6273 NULL
+dm_cell_error_fndecl_6277_fields dm_cell_error fndecl 3 6277 NULL
+copy_out_args_fndecl_6283_fields copy_out_args fndecl 3 6283 NULL
+regmap_i2c_gather_write_fndecl_6284_fields regmap_i2c_gather_write fndecl 3-5 6284 NULL
+gnet_stats_copy_app_fndecl_6286_fields gnet_stats_copy_app fndecl 3 6286 NULL
+_snd_pcm_lib_alloc_vmalloc_buffer_fndecl_6287_fields _snd_pcm_lib_alloc_vmalloc_buffer fndecl 2 6287 NULL
+hOver_plus_panel_info_6297_fields hOver_plus panel_info 0 6297 NULL
+lpuart_copy_rx_to_tty_fndecl_6298_fields lpuart_copy_rx_to_tty fndecl 3 6298 NULL
+sectors_r1bio_6323_fields sectors r1bio 0 6323 NULL
+max_ustore_icp_qat_fw_loader_hal_handle_6327_fields max_ustore icp_qat_fw_loader_hal_handle 0 6327 NULL nohasharray
+totalhigh_sysinfo_6327_fields totalhigh sysinfo 0 6327 &max_ustore_icp_qat_fw_loader_hal_handle_6327_fields
+asd_get_devctx_size_fndecl_6335_fields asd_get_devctx_size fndecl 0 6335 NULL nohasharray
+raid5_build_block_fndecl_6335_fields raid5_build_block fndecl 2 6335 &asd_get_devctx_size_fndecl_6335_fields
+h_max_out_saa7146_standard_6339_fields h_max_out saa7146_standard 0 6339 NULL
+orinoco_set_key_fndecl_6341_fields orinoco_set_key fndecl 5 6341 NULL nohasharray
+i40e_align_l2obj_base_fndecl_6341_fields i40e_align_l2obj_base fndecl 0-1 6341 &orinoco_set_key_fndecl_6341_fields
+n_o_ps_usb_stream_kernel_6346_fields n_o_ps usb_stream_kernel 0 6346 NULL
+wbuf_ofs_jffs2_sb_info_6347_fields wbuf_ofs jffs2_sb_info 0 6347 NULL
+chipid_to_nrcores_fndecl_6352_fields chipid_to_nrcores fndecl 0 6352 NULL
+pci_mmconfig_insert_fndecl_6353_fields pci_mmconfig_insert fndecl 3-4-5 6353 NULL
+lrf_body_len_nfsd4_layoutreturn_6359_fields lrf_body_len nfsd4_layoutreturn 0 6359 NULL
+len_p54_rx_data_6362_fields len p54_rx_data 0 6362 NULL
+sisusb_send_bulk_msg_fndecl_6363_fields sisusb_send_bulk_msg fndecl 2 6363 NULL
+alloc_sja1000dev_fndecl_6367_fields alloc_sja1000dev fndecl 1 6367 NULL
+elants_i2c_execute_command_fndecl_6371_fields elants_i2c_execute_command fndecl 3-5 6371 NULL nohasharray
+recover_head_fndecl_6371_fields recover_head fndecl 3 6371 &elants_i2c_execute_command_fndecl_6371_fields
+xfs_buf_associate_memory_fndecl_6376_fields xfs_buf_associate_memory fndecl 3 6376 NULL
+blkfactor_dio_submit_6380_fields blkfactor dio_submit 0 6380 NULL nohasharray
+cur_inode_size_send_ctx_6380_fields cur_inode_size send_ctx 0 6380 &blkfactor_dio_submit_6380_fields
+tail_hid_debug_list_6381_fields tail hid_debug_list 0 6381 NULL
+xfs_rtallocate_extent_near_fndecl_6383_fields xfs_rtallocate_extent_near fndecl 3-5-9-0 6383 NULL
+snd_info_entry_llseek_fndecl_6384_fields snd_info_entry_llseek fndecl 2 6384 NULL
+wps_probe_req_ie_len_mlme_priv_6393_fields wps_probe_req_ie_len mlme_priv 0 6393 NULL
+max_agbno_xfs_alloc_arg_6395_fields max_agbno xfs_alloc_arg 0 6395 NULL
+i_file_acl_ext2_inode_info_6396_fields i_file_acl ext2_inode_info 0 6396 NULL
+compat_sys_ppoll_fndecl_6405_fields compat_sys_ppoll fndecl 2 6405 NULL
+alloc_blocks_hfs_inode_info_6406_fields alloc_blocks hfs_inode_info 0 6406 NULL
+brcmf_chip_sysmem_ramsize_fndecl_6407_fields brcmf_chip_sysmem_ramsize fndecl 0 6407 NULL
+copy_from_iter_fndecl_6410_fields copy_from_iter fndecl 2-0 6410 NULL
+fwnet_change_mtu_fndecl_6424_fields fwnet_change_mtu fndecl 2 6424 NULL nohasharray
+x509_note_serial_fndecl_6424_fields x509_note_serial fndecl 5 6424 &fwnet_change_mtu_fndecl_6424_fields
+de_entrylen_reiserfs_dir_entry_6426_fields de_entrylen reiserfs_dir_entry 0 6426 NULL
+sys_brk_fndecl_6435_fields sys_brk fndecl 1 6435 NULL
+parse_dcb20_entry_fndecl_6440_fields parse_dcb20_entry fndecl 3 6440 NULL
+i40iw_qp_roundup_fndecl_6447_fields i40iw_qp_roundup fndecl 0 6447 NULL
+max_packet_sz_tx_musb_hw_ep_6448_fields max_packet_sz_tx musb_hw_ep 0 6448 NULL
+snd_hammerfall_get_buffer_fndecl_6450_fields snd_hammerfall_get_buffer fndecl 3 6450 NULL
+out_epnum_usb_gadget_6453_fields out_epnum usb_gadget 0 6453 NULL
+iov_iter_advance_fndecl_6457_fields iov_iter_advance fndecl 2 6457 NULL
+xtTruncate_fndecl_6468_fields xtTruncate fndecl 3 6468 NULL
+dx_fb_image_6483_fields dx fb_image 0 6483 NULL
+datasize_vub300_mmc_host_6490_fields datasize vub300_mmc_host 0 6490 NULL nohasharray
+beep_amp_ad198x_spec_6490_fields beep_amp ad198x_spec 0 6490 &datasize_vub300_mmc_host_6490_fields
+inc_remap_and_issue_cell_fndecl_6505_fields inc_remap_and_issue_cell fndecl 3 6505 NULL
+hugetlb_file_setup_fndecl_6506_fields hugetlb_file_setup fndecl 2 6506 NULL
+vfs_setpos_fndecl_6511_fields vfs_setpos fndecl 2 6511 NULL
+base_size_aac_dev_6512_fields base_size aac_dev 0 6512 NULL
+l2_fhdr_vlan_tag_l2_fhdr_6516_fields l2_fhdr_vlan_tag l2_fhdr 0 6516 NULL
+lbs_highrssi_write_fndecl_6520_fields lbs_highrssi_write fndecl 3 6520 NULL
+copy_page_from_iter_fndecl_6523_fields copy_page_from_iter fndecl 3-0 6523 NULL
+sector_start_dm_target_spec_6526_fields sector_start dm_target_spec 0 6526 NULL
+size_i40iw_kmem_info_6537_fields size i40iw_kmem_info 0 6537 NULL nohasharray
+size_ubifs_wbuf_6537_fields size ubifs_wbuf 0 6537 &size_i40iw_kmem_info_6537_fields
+tx_ring_size_vmxnet3_adapter_6541_fields tx_ring_size vmxnet3_adapter 0 6541 NULL
+fe_logical_ext4_free_extent_6542_fields fe_logical ext4_free_extent 0 6542 NULL
+sent_user_sdma_request_6545_fields sent user_sdma_request 0 6545 NULL
+pcm_snd_bebob_stream_formation_6548_fields pcm snd_bebob_stream_formation 0 6548 NULL nohasharray
+count_ixgb_desc_ring_6548_fields count ixgb_desc_ring 0 6548 &pcm_snd_bebob_stream_formation_6548_fields
+jffs2_security_setxattr_fndecl_6550_fields jffs2_security_setxattr fndecl 6 6550 NULL
+xlog_do_log_recovery_fndecl_6557_fields xlog_do_log_recovery fndecl 3 6557 NULL
+active_duplex_tg3_link_config_6559_fields active_duplex tg3_link_config 0 6559 NULL
+cxgbit_xmit_pdu_fndecl_6562_fields cxgbit_xmit_pdu fndecl 5 6562 NULL
+verity_verify_io_fndecl_6564_fields verity_verify_io fndecl 0 6564 NULL
+num_x_edt_ft5x06_ts_data_6566_fields num_x edt_ft5x06_ts_data 0 6566 NULL
+ath6kl_wmi_connect_cmd_fndecl_6571_fields ath6kl_wmi_connect_cmd fndecl 2 6571 NULL
+rts51x_write_mem_fndecl_6573_fields rts51x_write_mem fndecl 4 6573 NULL
+log_num_qps_mlx4_init_hca_param_6574_fields log_num_qps mlx4_init_hca_param 0 6574 NULL
+vmcore_remap_oldmem_pfn_fndecl_6577_fields vmcore_remap_oldmem_pfn fndecl 2-3-4 6577 NULL
+gcd_fndecl_6579_fields gcd fndecl 0 6579 NULL
+argc_tomoyo_condition_6587_fields argc tomoyo_condition 0 6587 NULL
+wil_write_file_rxon_fndecl_6590_fields wil_write_file_rxon fndecl 3 6590 NULL
+capture_frlog_rme96_6593_fields capture_frlog rme96 0 6593 NULL
+pci_get_device_fndecl_6606_fields pci_get_device fndecl 2 6606 NULL
+dma_map_page_fndecl_6607_fields dma_map_page fndecl 0 6607 NULL
+irda_sendmsg_ultra_fndecl_6612_fields irda_sendmsg_ultra fndecl 3 6612 NULL nohasharray
+osst_execute_fndecl_6612_fields osst_execute fndecl 6-3 6612 &irda_sendmsg_ultra_fndecl_6612_fields
+num_tasks_qed_iscsi_pf_params_6614_fields num_tasks qed_iscsi_pf_params 0 6614 NULL
+size_synthhid_msg_hdr_6615_fields size synthhid_msg_hdr 0 6615 NULL
+ocfs2_mark_extent_written_fndecl_6620_fields ocfs2_mark_extent_written fndecl 6-4 6620 NULL
+ath_recv_fndecl_6621_fields ath_recv fndecl 3 6621 NULL
+num_outputs_drm_vmw_update_layout_arg_6623_fields num_outputs drm_vmw_update_layout_arg 0 6623 NULL
+hw_queue_depth_vardecl_null_blk_c_6624_fields hw_queue_depth vardecl_null_blk.c 0 6624 NULL
+copy_for_split_fndecl_6630_fields copy_for_split fndecl 7-8 6630 NULL nohasharray
+cifs_setsize_fndecl_6630_fields cifs_setsize fndecl 2 6630 &copy_for_split_fndecl_6630_fields
+sample_rate_echoaudio_6631_fields sample_rate echoaudio 0 6631 NULL
+integrity_read_file_fndecl_6633_fields integrity_read_file fndecl 0 6633 NULL
+xmit_count_modem_info_6639_fields xmit_count modem_info 0 6639 NULL
+bpp_xvip_video_format_6640_fields bpp xvip_video_format 0 6640 NULL
+irlan_provider_connect_indication_fndecl_6644_fields irlan_provider_connect_indication fndecl 5 6644 NULL
+local_payload_max_nfc_digital_dev_6651_fields local_payload_max nfc_digital_dev 0 6651 NULL
+length_acpi_namestring_info_6654_fields length acpi_namestring_info 0 6654 NULL
+async_error_osd_request_6658_fields async_error osd_request 0 6658 NULL
+persistent_commit_merge_fndecl_6660_fields persistent_commit_merge fndecl 2 6660 NULL
+orinoco_add_extscan_result_fndecl_6668_fields orinoco_add_extscan_result fndecl 3 6668 NULL nohasharray
+io_reserve_memtype_fndecl_6668_fields io_reserve_memtype fndecl 1-2 6668 &orinoco_add_extscan_result_fndecl_6668_fields
+pkt_size_meta_sock_cmd_6669_fields pkt_size meta_sock_cmd 0 6669 NULL
+img_imem_size_fw_hdr_6675_fields img_imem_size fw_hdr 0 6675 NULL
+compatsize_xt_match_6677_fields compatsize xt_match 0 6677 NULL
+lpfc_debugfs_lseek_fndecl_6679_fields lpfc_debugfs_lseek fndecl 2 6679 NULL
+issue_discard_fndecl_6682_fields issue_discard fndecl 0-2-3 6682 NULL
+present_pages_zone_6685_fields present_pages zone 0 6685 NULL
+ac_2order_ext4_allocation_context_6690_fields ac_2order ext4_allocation_context 0 6690 NULL
+param_ssp_completion_resp_6691_fields param ssp_completion_resp 0 6691 NULL
+esize___kfifo_6692_fields esize __kfifo 0 6692 NULL
+max_recvmsg_len_netlink_sock_6699_fields max_recvmsg_len netlink_sock 0 6699 NULL
+length_p_header80_6708_fields length p_header80 0 6708 NULL
+raw_recvmsg_fndecl_6710_fields raw_recvmsg fndecl 3 6710 NULL
+sample_rate_mixart_mgr_6716_fields sample_rate mixart_mgr 0 6716 NULL
+ssb_sdio_block_read_fndecl_6721_fields ssb_sdio_block_read fndecl 3 6721 NULL
+ieee_il_rate_info_6732_fields ieee il_rate_info 0 6732 NULL
+mtd_ooblayout_set_databytes_fndecl_6733_fields mtd_ooblayout_set_databytes fndecl 4 6733 NULL
+end_discard_fndecl_6736_fields end_discard fndecl 2 6736 NULL nohasharray
+size_ORANGEFS_sys_attr_s_6736_fields size ORANGEFS_sys_attr_s 0 6736 &end_discard_fndecl_6736_fields
+alloc_size__osd_req_data_segment_6757_fields alloc_size _osd_req_data_segment 0 6757 NULL
+tun_opts_len_sw_flow_key_6759_fields tun_opts_len sw_flow_key 0 6759 NULL
+al_stripe_size_resize_parms_6766_fields al_stripe_size resize_parms 0 6766 NULL
+start_mtd_oob_buf_6767_fields start mtd_oob_buf 0 6767 NULL
+rx_pkt_ram_iadev_priv_6768_fields rx_pkt_ram iadev_priv 0 6768 NULL
+sg_tablesize_Scsi_Host_6769_fields sg_tablesize Scsi_Host 0 6769 NULL
+xhci_align_td_fndecl_6773_fields xhci_align_td fndecl 3 6773 NULL
+dn_recvmsg_fndecl_6774_fields dn_recvmsg fndecl 3 6774 NULL
+ext4_readpages_fndecl_6776_fields ext4_readpages fndecl 4 6776 NULL
+asn_1_decode_fndecl_6777_fields asn_1_decode fndecl 0 6777 NULL
+bio_phys_segments_fndecl_6778_fields bio_phys_segments fndecl 0 6778 NULL
+ecryptfs_send_message_fndecl_6785_fields ecryptfs_send_message fndecl 2 6785 NULL
+bio_integrity_advance_fndecl_6791_fields bio_integrity_advance fndecl 2 6791 NULL
+st21nfca_im_send_atr_req_fndecl_6792_fields st21nfca_im_send_atr_req fndecl 3 6792 NULL
+xfs_da_shrink_inode_fndecl_6796_fields xfs_da_shrink_inode fndecl 2 6796 NULL
+pop_tx_fndecl_6799_fields pop_tx fndecl 2 6799 NULL
+bankwidth_map_info_6800_fields bankwidth map_info 0 6800 NULL
+pfn_mlx4_uar_6801_fields pfn mlx4_uar 0 6801 NULL
+ctrl_dma_acm_6806_fields ctrl_dma acm 0 6806 NULL
+ip6ip6_err_fndecl_6807_fields ip6ip6_err fndecl 5 6807 NULL
+nfc_digital_allocate_device_fndecl_6810_fields nfc_digital_allocate_device fndecl 4 6810 NULL
+tx_pipe_at76_priv_6815_fields tx_pipe at76_priv 0 6815 NULL
+minor_miscdevice_6818_fields minor miscdevice 0 6818 NULL
+hs_rehash_bits_cfs_hash_6820_fields hs_rehash_bits cfs_hash 0 6820 NULL
+bfs_iget_fndecl_6821_fields bfs_iget fndecl 2 6821 NULL
+chip_rcv_contexts_hfi1_devdata_6824_fields chip_rcv_contexts hfi1_devdata 0 6824 NULL
+centre_vertically_fndecl_6833_fields centre_vertically fndecl 2 6833 NULL
+xfs_dialloc_ag_finobt_near_fndecl_6835_fields xfs_dialloc_ag_finobt_near fndecl 1 6835 NULL
+copy_page_to_iter_fndecl_6842_fields copy_page_to_iter fndecl 3-0 6842 NULL
+intel_framebuffer_size_for_mode_fndecl_6849_fields intel_framebuffer_size_for_mode fndecl 0-2 6849 NULL
+kclist_add_private_fndecl_6853_fields kclist_add_private fndecl 1-2 6853 NULL
+bg_channels_libipw_geo_6854_fields bg_channels libipw_geo 0 6854 NULL
+hdlc_empty_fifo_fndecl_6862_fields hdlc_empty_fifo fndecl 2 6862 NULL
+qib_user_sdma_num_pages_fndecl_6864_fields qib_user_sdma_num_pages fndecl 0 6864 NULL
+offset_amp_assoc_6875_fields offset amp_assoc 0 6875 NULL
+ima_collect_measurement_fndecl_6876_fields ima_collect_measurement fndecl 4 6876 NULL
+xres_fb_videomode_6878_fields xres fb_videomode 0 6878 NULL
+rxbufferhandle_kaweth_device_6883_fields rxbufferhandle kaweth_device 0 6883 NULL
+usbnet_write_cmd_nopm_fndecl_6889_fields usbnet_write_cmd_nopm fndecl 7 6889 NULL
+hpfs_bplus_lookup_fndecl_6896_fields hpfs_bplus_lookup fndecl 0-4 6896 NULL nohasharray
+index_mlx5_uar_6896_fields index mlx5_uar 0 6896 &hpfs_bplus_lookup_fndecl_6896_fields
+link_duplex_e1000_adapter_6902_fields link_duplex e1000_adapter 0 6902 NULL
+jfs_quota_write_fndecl_6903_fields jfs_quota_write fndecl 5 6903 NULL
+offset_clone_root_6907_fields offset clone_root 0 6907 NULL
+table_size_radeon_gart_6911_fields table_size radeon_gart 0 6911 NULL
+error_dm_io_6915_fields error dm_io 0 6915 NULL
+maxbufsize__isdn_driver_6917_fields maxbufsize _isdn_driver 0 6917 NULL
+drm_gtf_mode_complex_fndecl_6918_fields drm_gtf_mode_complex fndecl 3-2-4-7-9-10-8 6918 NULL
+buflen_packet_command_6926_fields buflen packet_command 0 6926 NULL
+multi_src_desc_6933_fields multi src_desc 0 6933 NULL
+nbytes_ide_cmd_6945_fields nbytes ide_cmd 0 6945 NULL
+spare_per_sector_mtk_nfc_nand_chip_6948_fields spare_per_sector mtk_nfc_nand_chip 0 6948 NULL
+max_namelen_fscrypt_operations_6956_fields max_namelen fscrypt_operations 0 6956 NULL
+enic_rxcopybreak_fndecl_6960_fields enic_rxcopybreak fndecl 4 6960 NULL nohasharray
+doffset_cxgbit_lro_pdu_cb_6960_fields doffset cxgbit_lro_pdu_cb 0 6960 &enic_rxcopybreak_fndecl_6960_fields
+af9013_write_ofsm_regs_fndecl_6965_fields af9013_write_ofsm_regs fndecl 4 6965 NULL
+ufs_free_blocks_fndecl_6968_fields ufs_free_blocks fndecl 3-2 6968 NULL
+odm_group_width_pnfs_osd_data_map_6977_fields odm_group_width pnfs_osd_data_map 0 6977 NULL
+async_set_registers_fndecl_6987_fields async_set_registers fndecl 3 6987 NULL
+log_start_r5l_log_6989_fields log_start r5l_log 0 6989 NULL
+sq_spare_wqes_mlx4_ib_qp_6994_fields sq_spare_wqes mlx4_ib_qp 0 6994 NULL
+rx_agg_nr_pages_bnxt_7000_fields rx_agg_nr_pages bnxt 0 7000 NULL
+mpa_frame_size_nes_cm_node_7002_fields mpa_frame_size nes_cm_node 0 7002 NULL
+p_start_nilfs_period_7008_fields p_start nilfs_period 0 7008 NULL
+s_groups_count_ext4_sb_info_7012_fields s_groups_count ext4_sb_info 0 7012 NULL
+ocfs2_cache_cluster_dealloc_fndecl_7016_fields ocfs2_cache_cluster_dealloc fndecl 3-2 7016 NULL
+attr_bytes_osdv2_attributes_list_element_7018_fields attr_bytes osdv2_attributes_list_element 0 7018 NULL
+channels_snd_pcm_plugin_format_7026_fields channels snd_pcm_plugin_format 0 7026 NULL
+ip_tun_to_nlattr_fndecl_7028_fields ip_tun_to_nlattr fndecl 4 7028 NULL
+virtio_gpu_alloc_object_fndecl_7030_fields virtio_gpu_alloc_object fndecl 2 7030 NULL
+h_sync_strt_wid_crtc_7033_fields h_sync_strt_wid crtc 0 7033 NULL
+fat_short2lower_uni_fndecl_7036_fields fat_short2lower_uni fndecl 0 7036 NULL
+n_krcv_queues_hfi1_devdata_7042_fields n_krcv_queues hfi1_devdata 0 7042 NULL
+fp_msix_cnt_qed_int_params_7045_fields fp_msix_cnt qed_int_params 0 7045 NULL
+iforce_send_packet_fndecl_7050_fields iforce_send_packet fndecl 2 7050 NULL
+srq_entry_sz_mlx4_dev_cap_7052_fields srq_entry_sz mlx4_dev_cap 0 7052 NULL
+packet_size_usbatm_channel_7056_fields packet_size usbatm_channel 0 7056 NULL
+__btrfs_drop_extents_fndecl_7058_fields __btrfs_drop_extents fndecl 6-5 7058 NULL
+dccph_doff_dccp_hdr_7060_fields dccph_doff dccp_hdr 0 7060 NULL nohasharray
+ddebug_proc_write_fndecl_7060_fields ddebug_proc_write fndecl 3 7060 &dccph_doff_dccp_hdr_7060_fields
+total_VFs_pci_sriov_7061_fields total_VFs pci_sriov 0 7061 NULL
+i_dir_start_lookup_ext4_inode_info_7062_fields i_dir_start_lookup ext4_inode_info 0 7062 NULL
+jt_size_gfx_firmware_header_v1_0_7064_fields jt_size gfx_firmware_header_v1_0 0 7064 NULL
+lua_sysfs_read_fndecl_7069_fields lua_sysfs_read fndecl 6 7069 NULL
+command_hdac_bus_ops_7079_fields command hdac_bus_ops 0 7079 NULL
+orangefs_bufmap_size_query_fndecl_7085_fields orangefs_bufmap_size_query fndecl 0 7085 NULL
+pref_height_vmw_display_unit_7089_fields pref_height vmw_display_unit 0 7089 NULL
+dma_mt7601u_dma_buf_7098_fields dma mt7601u_dma_buf 0 7098 NULL
+rtl8139_change_mtu_fndecl_7099_fields rtl8139_change_mtu fndecl 2 7099 NULL
+nvkm_fifo_chan_ctor_fndecl_7101_fields nvkm_fifo_chan_ctor fndecl 11 7101 NULL
+scan_ies_len_ieee80211_local_7104_fields scan_ies_len ieee80211_local 0 7104 NULL
+nfsd4_encode_readv_fndecl_7110_fields nfsd4_encode_readv fndecl 4 7110 NULL
+udf_table_free_blocks_fndecl_7114_fields udf_table_free_blocks fndecl 4-5 7114 NULL
+rsxx_dma_queue_bio_fndecl_7118_fields rsxx_dma_queue_bio fndecl 0 7118 NULL
+svc_getnl_fndecl_7131_fields svc_getnl fndecl 0 7131 NULL
+vc_origin_vc_data_7148_fields vc_origin vc_data 0 7148 NULL
+ea_secno_fnode_7151_fields ea_secno fnode 0 7151 NULL nohasharray
+privsize_nft_set_ops_7151_fields privsize nft_set_ops 0 7151 &ea_secno_fnode_7151_fields
+nv50_disp_new__fndecl_7152_fields nv50_disp_new_ fndecl 4 7152 NULL
+newblocks_xfs_growfs_rt_7154_fields newblocks xfs_growfs_rt 0 7154 NULL
+num_packets_st5481_in_7161_fields num_packets st5481_in 0 7161 NULL
+__add_to_page_cache_locked_fndecl_7168_fields __add_to_page_cache_locked fndecl 0 7168 NULL
+setup_sg_fndecl_7174_fields setup_sg fndecl 0-3 7174 NULL
+get_rxfh_key_size_ethtool_ops_7178_fields get_rxfh_key_size ethtool_ops 0 7178 NULL
+ax88179_write_cmd_async_fndecl_7180_fields ax88179_write_cmd_async fndecl 5 7180 NULL
+vdisplay_moderec_7183_fields vdisplay moderec 0 7183 NULL nohasharray
+mfd_add_devices_fndecl_7183_fields mfd_add_devices fndecl 6-2 7183 &vdisplay_moderec_7183_fields
+ino_node_footer_7185_fields ino node_footer 0 7185 NULL
+acc_accl_accessdata_dn_7186_fields acc_accl accessdata_dn 0 7186 NULL
+vc_rows_vc_data_7192_fields vc_rows vc_data 0 7192 NULL nohasharray
+__shmem_file_setup_fndecl_7192_fields __shmem_file_setup fndecl 2 7192 &vc_rows_vc_data_7192_fields nohasharray
+ic_size_xlog_in_core_7192_fields ic_size xlog_in_core 0 7192 &__shmem_file_setup_fndecl_7192_fields nohasharray
+remote_addr_ib_atomic_wr_7192_fields remote_addr ib_atomic_wr 0 7192 &ic_size_xlog_in_core_7192_fields
+mmc_calc_max_discard_fndecl_7198_fields mmc_calc_max_discard fndecl 0 7198 NULL
+length_pnfs_layout_range_7207_fields length pnfs_layout_range 0 7207 NULL
+__wa_populate_dto_urb_fndecl_7208_fields __wa_populate_dto_urb fndecl 3-4 7208 NULL
+size_srp_iu_7210_fields size srp_iu 0 7210 NULL nohasharray
+drbd_drain_block_fndecl_7210_fields drbd_drain_block fndecl 2 7210 &size_srp_iu_7210_fields
+rivafb_do_maximize_fndecl_7212_fields rivafb_do_maximize fndecl 3-4 7212 NULL nohasharray
+eq_ecount_lpfc_sli4_hba_7212_fields eq_ecount lpfc_sli4_hba 0 7212 &rivafb_do_maximize_fndecl_7212_fields
+max_id_Scsi_Host_7217_fields max_id Scsi_Host 0 7217 NULL
+num_chipselect_spi_gpio_platform_data_7218_fields num_chipselect spi_gpio_platform_data 0 7218 NULL
+__inet_lookup_listener_fndecl_7235_fields __inet_lookup_listener fndecl 4 7235 NULL
+s_mb_last_group_ext4_sb_info_7240_fields s_mb_last_group ext4_sb_info 0 7240 NULL
+xfs_attr3_leaf_create_fndecl_7243_fields xfs_attr3_leaf_create fndecl 2 7243 NULL
+len_session_key_7253_fields len session_key 0 7253 NULL
+ddcb_max_ddcb_queue_7260_fields ddcb_max ddcb_queue 0 7260 NULL
+bpp_cobalt_stream_7263_fields bpp cobalt_stream 0 7263 NULL
+iscsi_recv_pdu_fndecl_7264_fields iscsi_recv_pdu fndecl 4 7264 NULL
+xlog_bread_fndecl_7272_fields xlog_bread fndecl 2 7272 NULL
+vc_saved_x_vc_data_7275_fields vc_saved_x vc_data 0 7275 NULL
+num_asq_entries_i40e_adminq_info_7278_fields num_asq_entries i40e_adminq_info 0 7278 NULL
+hsync_psb_pipe_7286_fields hsync psb_pipe 0 7286 NULL
+trailer_len_dst_entry_7294_fields trailer_len dst_entry 0 7294 NULL
+cmd_size_vmw_view_7295_fields cmd_size vmw_view 0 7295 NULL nohasharray
+ubifs_update_one_lp_fndecl_7295_fields ubifs_update_one_lp fndecl 3 7295 &cmd_size_vmw_view_7295_fields
+num_channels_lp55xx_platform_data_7299_fields num_channels lp55xx_platform_data 0 7299 NULL
+value_apei_exec_context_7318_fields value apei_exec_context 0 7318 NULL
+fdir_filter_count_ixgbe_adapter_7322_fields fdir_filter_count ixgbe_adapter 0 7322 NULL
+check_index_in_prev_nodes_fndecl_7324_fields check_index_in_prev_nodes fndecl 2 7324 NULL nohasharray
+bus_num_dw_pci_controller_7324_fields bus_num dw_pci_controller 0 7324 &check_index_in_prev_nodes_fndecl_7324_fields
+generic_write_end_fndecl_7325_fields generic_write_end fndecl 0-5 7325 NULL
+mtd_ooblayout_get_databytes_fndecl_7335_fields mtd_ooblayout_get_databytes fndecl 4 7335 NULL nohasharray
+control_cnt_pvr2_hdw_7335_fields control_cnt pvr2_hdw 0 7335 &mtd_ooblayout_get_databytes_fndecl_7335_fields
+name_len_ubi_volume_info_7350_fields name_len ubi_volume_info 0 7350 NULL
+btusb_recv_intr_fndecl_7351_fields btusb_recv_intr fndecl 3 7351 NULL nohasharray
+jpegqual_s2255_vc_7351_fields jpegqual s2255_vc 0 7351 &btusb_recv_intr_fndecl_7351_fields
+mesh_fwd_csa_frame_fndecl_7353_fields mesh_fwd_csa_frame fndecl 3 7353 NULL
+mcp251x_spi_trans_fndecl_7356_fields mcp251x_spi_trans fndecl 2 7356 NULL
+dm_vcalloc_fndecl_7357_fields dm_vcalloc fndecl 2-1 7357 NULL
+sysctl_tcp_base_mss_netns_ipv4_7363_fields sysctl_tcp_base_mss netns_ipv4 0 7363 NULL
+sys_fadvise64_fndecl_7365_fields sys_fadvise64 fndecl 2-3 7365 NULL
+check_left_item_operations_7369_fields check_left item_operations 0 7369 NULL
+e_value_size_ext2_xattr_entry_7373_fields e_value_size ext2_xattr_entry 0 7373 NULL
+bufsize_pstore_info_7375_fields bufsize pstore_info 0 7375 NULL
+shmem_swapin_fndecl_7376_fields shmem_swapin fndecl 4 7376 NULL nohasharray
+scsi_mode_sense_fndecl_7376_fields scsi_mode_sense fndecl 5 7376 &shmem_swapin_fndecl_7376_fields
+c67x00_create_td_fndecl_7377_fields c67x00_create_td fndecl 4 7377 NULL
+fs_ablocks_hfs_sb_info_7381_fields fs_ablocks hfs_sb_info 0 7381 NULL
+amd8111e_change_mtu_fndecl_7389_fields amd8111e_change_mtu fndecl 2 7389 NULL
+qed_eq_alloc_fndecl_7396_fields qed_eq_alloc fndecl 2 7396 NULL
+v_tot_disp_crtc_7400_fields v_tot_disp crtc 0 7400 NULL
+ext4_ext_zeroout_fndecl_7404_fields ext4_ext_zeroout fndecl 0 7404 NULL
+fw_sent_bcm203x_data_7405_fields fw_sent bcm203x_data 0 7405 NULL
+__ip_append_data_fndecl_7411_fields __ip_append_data fndecl 9-8 7411 NULL
+default_value_cx88_ctrl_7412_fields default_value cx88_ctrl 0 7412 NULL
+block_ack_param_set_host_cmd_ds_11n_addba_req_7415_fields block_ack_param_set host_cmd_ds_11n_addba_req 0 7415 NULL nohasharray
+htotal_psb_pipe_7415_fields htotal psb_pipe 0 7415 &block_ack_param_set_host_cmd_ds_11n_addba_req_7415_fields nohasharray
+xfs_dialloc_ag_fndecl_7415_fields xfs_dialloc_ag fndecl 3 7415 &htotal_psb_pipe_7415_fields
+mirror_sd_gl860_7430_fields mirror sd_gl860 0 7430 NULL
+hdrsize_genl_family_7432_fields hdrsize genl_family 0 7432 NULL nohasharray
+residue_dma_tx_state_7432_fields residue dma_tx_state 0 7432 &hdrsize_genl_family_7432_fields
+data_len_sk_buff_7447_fields data_len sk_buff 0 7447 NULL
+size_vmci_handle_arr_7457_fields size vmci_handle_arr 0 7457 NULL
+__multipath_map_bio_fndecl_7459_fields __multipath_map_bio fndecl 0 7459 NULL
+len_sk_buff_7460_fields len sk_buff 0 7460 NULL
+hpfs_alloc_sector_fndecl_7462_fields hpfs_alloc_sector fndecl 0-4-3-2 7462 NULL
+Length__SECURITY_BUFFER_7467_fields Length _SECURITY_BUFFER 0 7467 NULL
+buffer_dma_ehci_qtd_7468_fields buffer_dma ehci_qtd 0 7468 NULL
+block_to_sectors_fndecl_7472_fields block_to_sectors fndecl 0-2 7472 NULL
+devmem_is_allowed_fndecl_7475_fields devmem_is_allowed fndecl 1 7475 NULL
+status_c67x00_urb_priv_7480_fields status c67x00_urb_priv 0 7480 NULL
+rxrpc_server_keyring_fndecl_7484_fields rxrpc_server_keyring fndecl 3 7484 NULL
+header_len_eth_fast_path_rx_tpa_start_cqe_7488_fields header_len eth_fast_path_rx_tpa_start_cqe 0 7488 NULL
+s_log_block_size_ext2_super_block_7490_fields s_log_block_size ext2_super_block 0 7490 NULL
+cookie_rds_atomic_args_7495_fields cookie rds_atomic_args 0 7495 NULL
+ri_lsegs_start_nilfs_recovery_info_7501_fields ri_lsegs_start nilfs_recovery_info 0 7501 NULL
+all_tables_size_vardecl_tables_c_7504_fields all_tables_size vardecl_tables.c 0 7504 NULL
+btrfs_truncate_inode_items_fndecl_7511_fields btrfs_truncate_inode_items fndecl 4 7511 NULL
+ext4_mb_load_buddy_gfp_fndecl_7524_fields ext4_mb_load_buddy_gfp fndecl 2-0 7524 NULL
+xfs_iomap_eof_want_preallocate_fndecl_7527_fields xfs_iomap_eof_want_preallocate fndecl 4-3 7527 NULL
+cfg_hba_queue_depth_lpfc_hba_7534_fields cfg_hba_queue_depth lpfc_hba 0 7534 NULL
+delta_mmap_mm_struct_7536_fields delta_mmap mm_struct 0 7536 NULL
+length_ndis_80211_ssid_7537_fields length ndis_80211_ssid 0 7537 NULL
+raid10_resize_fndecl_7562_fields raid10_resize fndecl 2 7562 NULL
+max_channels_snd_pcm_chmap_7565_fields max_channels snd_pcm_chmap 0 7565 NULL
+duplicateIXtree_fndecl_7568_fields duplicateIXtree fndecl 3-2 7568 NULL
+wqe_fcoe_cqe_7572_fields wqe fcoe_cqe 0 7572 NULL
+mISDN_sock_sendmsg_fndecl_7584_fields mISDN_sock_sendmsg fndecl 3 7584 NULL nohasharray
+tcp_manip_pkt_fndecl_7584_fields tcp_manip_pkt fndecl 4 7584 &mISDN_sock_sendmsg_fndecl_7584_fields
+tuple_size_blk_integrity_7585_fields tuple_size blk_integrity 0 7585 NULL
+length_sctp_chunkhdr_7587_fields length sctp_chunkhdr 0 7587 NULL
+ftdi_elan_edset_input_fndecl_7588_fields ftdi_elan_edset_input fndecl 0 7588 NULL
+scan_index_iio_chan_spec_7597_fields scan_index iio_chan_spec 0 7597 NULL nohasharray
+num_regions_wm_adsp_fw_caps_7597_fields num_regions wm_adsp_fw_caps 0 7597 &scan_index_iio_chan_spec_7597_fields
+q_blkno_xfs_dquot_7601_fields q_blkno xfs_dquot 0 7601 NULL
+pathmtu_sctp_transport_7603_fields pathmtu sctp_transport 0 7603 NULL
+fuse_listxattr_fndecl_7605_fields fuse_listxattr fndecl 3 7605 NULL
+pzl_urb_dequeue_fndecl_7607_fields pzl_urb_dequeue fndecl 3 7607 NULL
+report_size_hid_field_7609_fields report_size hid_field 0 7609 NULL
+rcvidx_w6692B_hw_7613_fields rcvidx w6692B_hw 0 7613 NULL
+id_hid_report_7618_fields id hid_report 0 7618 NULL
+drm_fb_helper_fill_var_fndecl_7619_fields drm_fb_helper_fill_var fndecl 4-3 7619 NULL
+physical_scrub_page_7621_fields physical scrub_page 0 7621 NULL
+block_udf_vds_record_7623_fields block udf_vds_record 0 7623 NULL
+ocfs2_free_suballoc_bits_fndecl_7627_fields ocfs2_free_suballoc_bits fndecl 5 7627 NULL
+agp_allocate_memory_wrap_fndecl_7635_fields agp_allocate_memory_wrap fndecl 1 7635 NULL
+virt_to_scatterlist_fndecl_7637_fields virt_to_scatterlist fndecl 2 7637 NULL
+read_cable_det_adv76xx_chip_info_7641_fields read_cable_det adv76xx_chip_info 0 7641 NULL
+num_sge_ib_uverbs_recv_wr_7647_fields num_sge ib_uverbs_recv_wr 0 7647 NULL
+s_fsize_ufs_sb_private_info_7659_fields s_fsize ufs_sb_private_info 0 7659 NULL
+brcmf_proto_bcdc_txdata_fndecl_7662_fields brcmf_proto_bcdc_txdata fndecl 3 7662 NULL
+to_perf_branch_entry_7663_fields to perf_branch_entry 0 7663 NULL
+rds_sendmsg_fndecl_7675_fields rds_sendmsg fndecl 3 7675 NULL
+nfsd_max_blksize_vardecl_7678_fields nfsd_max_blksize vardecl 0 7678 NULL
+shmem_read_mapping_page_gfp_fndecl_7681_fields shmem_read_mapping_page_gfp fndecl 2 7681 NULL
+l1oip_socket_send_fndecl_7685_fields l1oip_socket_send fndecl 7 7685 NULL nohasharray
+pm860x_page_bulk_read_fndecl_7685_fields pm860x_page_bulk_read fndecl 3 7685 &l1oip_socket_send_fndecl_7685_fields
+num_gpios_stmpe_7689_fields num_gpios stmpe 0 7689 NULL
+di_extsize_xfs_icdinode_7693_fields di_extsize xfs_icdinode 0 7693 NULL
+n_tty_receive_buf_real_raw_fndecl_7696_fields n_tty_receive_buf_real_raw fndecl 4 7696 NULL
+hdr_len_virtio_net_hdr_7704_fields hdr_len virtio_net_hdr 0 7704 NULL nohasharray
+rf_cpos_ocfs2_refcount_block_7704_fields rf_cpos ocfs2_refcount_block 0 7704 &hdr_len_virtio_net_hdr_7704_fields
+stride_pci_sriov_7712_fields stride pci_sriov 0 7712 NULL
+i915_gem_get_gtt_size_fndecl_7714_fields i915_gem_get_gtt_size fndecl 0-2 7714 NULL
+controller_number_ms_boot_attr_info_7716_fields controller_number ms_boot_attr_info 0 7716 NULL
+ceph_pool_perm_check_fndecl_7729_fields ceph_pool_perm_check fndecl 0 7729 NULL nohasharray
+if_ipx_offset_ipx_interface_7729_fields if_ipx_offset ipx_interface 0 7729 &ceph_pool_perm_check_fndecl_7729_fields
+get_num_rx_queues_rtnl_link_ops_7733_fields get_num_rx_queues rtnl_link_ops 0 7733 NULL
+access_remote_vm_fndecl_7734_fields access_remote_vm fndecl 4-2 7734 NULL
+vxres_aty128_crtc_7753_fields vxres aty128_crtc 0 7753 NULL
+mlx4_enable_sriov_fndecl_7756_fields mlx4_enable_sriov fndecl 3-4 7756 NULL nohasharray
+max_eq_lpfc_max_cfg_param_7756_fields max_eq lpfc_max_cfg_param 0 7756 &mlx4_enable_sriov_fndecl_7756_fields nohasharray
+ide_get_best_pio_mode_fndecl_7756_fields ide_get_best_pio_mode fndecl 0-2-3 7756 &max_eq_lpfc_max_cfg_param_7756_fields
+xfs_dir2_free_read_fndecl_7759_fields xfs_dir2_free_read fndecl 3 7759 NULL
+pps_devt_vardecl_pps_c_7772_fields pps_devt vardecl_pps.c 0 7772 NULL
+maxcmd_nvme_ctrl_7774_fields maxcmd nvme_ctrl 0 7774 NULL
+t_data_nents_orig_se_cmd_7775_fields t_data_nents_orig se_cmd 0 7775 NULL nohasharray
+len_aqm_info_7775_fields len aqm_info 0 7775 &t_data_nents_orig_se_cmd_7775_fields
+mode_size_cyttsp4_sysinfo_ofs_7780_fields mode_size cyttsp4_sysinfo_ofs 0 7780 NULL
+mmu_private_affs_inode_info_7785_fields mmu_private affs_inode_info 0 7785 NULL
+read_index_wm_adsp_compr_buf_7788_fields read_index wm_adsp_compr_buf 0 7788 NULL
+qxl_framebuffer_surface_dirty_fndecl_7791_fields qxl_framebuffer_surface_dirty fndecl 6 7791 NULL
+inode_getblk_fndecl_7794_fields inode_getblk fndecl 2-0 7794 NULL
+__clk_speculate_rates_fndecl_7795_fields __clk_speculate_rates fndecl 2 7795 NULL
+remove_advertising_fndecl_7798_fields remove_advertising fndecl 4 7798 NULL
+qnx4_get_block_fndecl_7810_fields qnx4_get_block fndecl 2 7810 NULL
+cciss_max_sectors_ctlr_info_7811_fields cciss_max_sectors ctlr_info 0 7811 NULL nohasharray
+len_nfs_diropargs_7811_fields len nfs_diropargs 0 7811 &cciss_max_sectors_ctlr_info_7811_fields
+plen_hci_event_hdr_7815_fields plen hci_event_hdr 0 7815 NULL
+length_scsi_mode_data_7819_fields length scsi_mode_data 0 7819 NULL
+get_pipe_fndecl_7825_fields get_pipe fndecl 0-2 7825 NULL
+x1_virtio_gpu_framebuffer_7830_fields x1 virtio_gpu_framebuffer 0 7830 NULL
+rtpref_nfs_fsinfo_7835_fields rtpref nfs_fsinfo 0 7835 NULL
+nonstatic_find_mem_region_fndecl_7838_fields nonstatic_find_mem_region fndecl 1-2 7838 NULL
+sys_truncate_fndecl_7846_fields sys_truncate fndecl 2 7846 NULL
+pcf2123_write_fndecl_7856_fields pcf2123_write fndecl 3 7856 NULL
+sl_datalen_nfsd4_slot_7859_fields sl_datalen nfsd4_slot 0 7859 NULL
+wqe_shift_mlx4_ib_wq_7860_fields wqe_shift mlx4_ib_wq 0 7860 NULL
+n_vifs_ath10k_mac_change_chanctx_arg_7864_fields n_vifs ath10k_mac_change_chanctx_arg 0 7864 NULL
+s_fpbshift_ufs_sb_private_info_7865_fields s_fpbshift ufs_sb_private_info 0 7865 NULL
+cyapa_i2c_read_fndecl_7870_fields cyapa_i2c_read fndecl 3 7870 NULL nohasharray
+ata_host_alloc_pinfo_fndecl_7870_fields ata_host_alloc_pinfo fndecl 3 7870 &cyapa_i2c_read_fndecl_7870_fields
+mapped_vram_mb862xxfb_par_7872_fields mapped_vram mb862xxfb_par 0 7872 NULL
+iscsi_tcp_dgst_header_fndecl_7878_fields iscsi_tcp_dgst_header fndecl 3 7878 NULL
+rxstatus_epic_rx_desc_7884_fields rxstatus epic_rx_desc 0 7884 NULL nohasharray
+sd_read_data_fndecl_7884_fields sd_read_data fndecl 3 7884 &rxstatus_epic_rx_desc_7884_fields nohasharray
+freecom_readdata_fndecl_7884_fields freecom_readdata fndecl 4 7884 &sd_read_data_fndecl_7884_fields
+ath6kl_wmi_send_mgmt_cmd_fndecl_7888_fields ath6kl_wmi_send_mgmt_cmd fndecl 2 7888 NULL
+ath6kl_wmi_info_req_cmd_fndecl_7906_fields ath6kl_wmi_info_req_cmd fndecl 2 7906 NULL
+mode_id_vbe_mode_ib_7913_fields mode_id vbe_mode_ib 0 7913 NULL
+rx_ring_size_vmxnet3_adapter_7917_fields rx_ring_size vmxnet3_adapter 0 7917 NULL
+ccw_bmove_fndecl_7918_fields ccw_bmove fndecl 5-7-3-8-6-4 7918 NULL nohasharray
+remote_addr_ib_rdma_wr_7918_fields remote_addr ib_rdma_wr 0 7918 &ccw_bmove_fndecl_7918_fields
+raid5_size_fndecl_7933_fields raid5_size fndecl 0-3-2 7933 NULL
+hfi1_max_sges_vardecl_7935_fields hfi1_max_sges vardecl 0 7935 NULL
+__locate_fndecl_7939_fields __locate fndecl 3-0 7939 NULL
+jp_journal_size_journal_params_7943_fields jp_journal_size journal_params 0 7943 NULL
+psb_unlocked_ioctl_fndecl_7949_fields psb_unlocked_ioctl fndecl 2 7949 NULL
+num_sdma_hfi1_devdata_7951_fields num_sdma hfi1_devdata 0 7951 NULL
+jme_change_mtu_fndecl_7964_fields jme_change_mtu fndecl 2 7964 NULL
+ticket_len_rxk5_key_7970_fields ticket_len rxk5_key 0 7970 NULL
+peb_count_ubi_device_7987_fields peb_count ubi_device 0 7987 NULL
+bin_buffer_size_configfs_buffer_7988_fields bin_buffer_size configfs_buffer 0 7988 NULL
+initrd_end_vardecl_7989_fields initrd_end vardecl 0 7989 NULL
+ip_append_data_fndecl_7997_fields ip_append_data fndecl 6-5 7997 NULL
+ieee80211_agg_tx_operational_fndecl_8006_fields ieee80211_agg_tx_operational fndecl 3 8006 NULL
+find_resource_fndecl_8013_fields find_resource fndecl 3 8013 NULL nohasharray
+encode_opaque_fixed_fndecl_8013_fields encode_opaque_fixed fndecl 3 8013 &find_resource_fndecl_8013_fields nohasharray
+ocfs2_read_quota_phys_block_fndecl_8013_fields ocfs2_read_quota_phys_block fndecl 2 8013 &encode_opaque_fixed_fndecl_8013_fields
+max_mtu_mlx4_en_priv_8015_fields max_mtu mlx4_en_priv 0 8015 NULL
+keyctl_instantiate_key_iov_fndecl_8026_fields keyctl_instantiate_key_iov fndecl 3 8026 NULL
+period_size_snd_pcm_runtime_8027_fields period_size snd_pcm_runtime 0 8027 NULL
+length_e1000_rx_desc_8032_fields length e1000_rx_desc 0 8032 NULL
+mcast_mtu_ipoib_dev_priv_8033_fields mcast_mtu ipoib_dev_priv 0 8033 NULL
+gtt_base_align_radeon_mc_8035_fields gtt_base_align radeon_mc 0 8035 NULL
+vbi_width_au0828_dev_8038_fields vbi_width au0828_dev 0 8038 NULL
+len_ff_idmap_8039_fields len ff_idmap 0 8039 NULL
+size_nvkm_fifo_chan_8052_fields size nvkm_fifo_chan 0 8052 NULL
+ieee80211_tdls_build_mgmt_packet_data_fndecl_8053_fields ieee80211_tdls_build_mgmt_packet_data fndecl 8 8053 NULL
+memmap_entry_callback_fndecl_8054_fields memmap_entry_callback fndecl 1-2 8054 NULL
+mmio_megabytes_vmbus_channel_offer_8058_fields mmio_megabytes vmbus_channel_offer 0 8058 NULL
+btrfs_unlink_inode_fndecl_8064_fields btrfs_unlink_inode fndecl 6 8064 NULL
+num_counters_mlx4_ib_diag_counters_8069_fields num_counters mlx4_ib_diag_counters 0 8069 NULL
+savage_map_video_fndecl_8078_fields savage_map_video fndecl 2 8078 NULL
+encode_string_fndecl_8079_fields encode_string fndecl 2 8079 NULL
+out_pipe_usbtest_dev_8085_fields out_pipe usbtest_dev 0 8085 NULL
+length_packet_8086_fields length packet 0 8086 NULL
+lpt_lnum_bits_ubifs_info_8094_fields lpt_lnum_bits ubifs_info 0 8094 NULL
+ali1535_smba_vardecl_i2c_ali1535_c_8095_fields ali1535_smba vardecl_i2c-ali1535.c 0 8095 NULL
+sd_complete_frame_fndecl_8096_fields sd_complete_frame fndecl 3 8096 NULL
+batchcount_kmem_cache_8098_fields batchcount kmem_cache 0 8098 NULL
+sddr55_read_data_fndecl_8099_fields sddr55_read_data fndecl 3 8099 NULL
+rx_cmp_meta_data_rx_cmp_ext_8103_fields rx_cmp_meta_data rx_cmp_ext 0 8103 NULL
+__kmalloc_reserve_fndecl_8107_fields __kmalloc_reserve fndecl 1 8107 NULL
+tgt_count_blogic_adapter_8109_fields tgt_count blogic_adapter 0 8109 NULL nohasharray
+nr_relocs_drm_etnaviv_gem_submit_8109_fields nr_relocs drm_etnaviv_gem_submit 0 8109 &tgt_count_blogic_adapter_8109_fields
+speed_channel_8113_fields speed channel 0 8113 NULL
+up_dnode_8116_fields up dnode 0 8116 NULL
+m_pblk_f2fs_map_blocks_8129_fields m_pblk f2fs_map_blocks 0 8129 NULL
+jffs2_scan_inode_node_fndecl_8132_fields jffs2_scan_inode_node fndecl 4 8132 NULL
+cfg_size_pci_dev_8134_fields cfg_size pci_dev 0 8134 NULL
+ucNumDPMLevels__ATOM_PPLIB_STATE_V2_8137_fields ucNumDPMLevels _ATOM_PPLIB_STATE_V2 0 8137 NULL nohasharray
+wpa_ie_len_libipw_network_8137_fields wpa_ie_len libipw_network 0 8137 &ucNumDPMLevels__ATOM_PPLIB_STATE_V2_8137_fields
+max_xmit_dlength_iscsi_conn_8139_fields max_xmit_dlength iscsi_conn 0 8139 NULL nohasharray
+nct6683_find_fndecl_8139_fields nct6683_find fndecl 0 8139 &max_xmit_dlength_iscsi_conn_8139_fields
+iic_tpm_write_long_fndecl_8143_fields iic_tpm_write_long fndecl 3 8143 NULL
+sys_preadv_fndecl_8159_fields sys_preadv fndecl 3 8159 NULL
+hr_start_block_o2hb_region_8162_fields hr_start_block o2hb_region 0 8162 NULL
+num_custom_params_pinctrl_desc_8163_fields num_custom_params pinctrl_desc 0 8163 NULL
+read_len_ddb_flashio_8164_fields read_len ddb_flashio 0 8164 NULL nohasharray
+devnum_denali_nand_info_8164_fields devnum denali_nand_info 0 8164 &read_len_ddb_flashio_8164_fields
+tidoffset_user_sdma_request_8166_fields tidoffset user_sdma_request 0 8166 NULL
+tx_ring_count_igb_adapter_8171_fields tx_ring_count igb_adapter 0 8171 NULL
+blksz_mmc_data_8174_fields blksz mmc_data 0 8174 NULL nohasharray
+ptr_mask_efx_tx_queue_8174_fields ptr_mask efx_tx_queue 0 8174 &blksz_mmc_data_8174_fields
+avail_ubifs_wbuf_8176_fields avail ubifs_wbuf 0 8176 NULL
+pdu_read_fndecl_8183_fields pdu_read fndecl 3 8183 NULL
+mwifiex_get_common_rates_fndecl_8184_fields mwifiex_get_common_rates fndecl 3 8184 NULL
+brcms_c_get_header_len_fndecl_8189_fields brcms_c_get_header_len fndecl 0 8189 NULL
+resource_alignment_fndecl_8199_fields resource_alignment fndecl 0 8199 NULL
+tx_ring_count_fm10k_intfc_8210_fields tx_ring_count fm10k_intfc 0 8210 NULL
+mmap_size_kioctx_8213_fields mmap_size kioctx 0 8213 NULL
+clear_extent_bit_fndecl_8215_fields clear_extent_bit fndecl 2-3 8215 NULL nohasharray
+pci_scan_bus_fndecl_8215_fields pci_scan_bus fndecl 1 8215 &clear_extent_bit_fndecl_8215_fields
+cfg_num_rx_irqs_be_adapter_8218_fields cfg_num_rx_irqs be_adapter 0 8218 NULL
+be_f_offset_pnfs_block_extent_8222_fields be_f_offset pnfs_block_extent 0 8222 NULL
+eeprom_size_iwl_base_params_8231_fields eeprom_size iwl_base_params 0 8231 NULL
+ir_freecount_xfs_inobt_rec_incore_8237_fields ir_freecount xfs_inobt_rec_incore 0 8237 NULL
+ocfs2_remove_extent_fndecl_8243_fields ocfs2_remove_extent fndecl 4-3 8243 NULL
+num_tasks_per_conn_iscsi_kwqe_init1_8249_fields num_tasks_per_conn iscsi_kwqe_init1 0 8249 NULL
+vmw_cursor_update_dmabuf_fndecl_8254_fields vmw_cursor_update_dmabuf fndecl 4-3 8254 NULL
+default_erasesize_fndecl_8255_fields default_erasesize fndecl 0 8255 NULL
+address_acpi_table_bert_8260_fields address acpi_table_bert 0 8260 NULL
+xfs_unmap_extent_fndecl_8261_fields xfs_unmap_extent fndecl 2-3 8261 NULL
+buf_size_ispstat_buffer_8262_fields buf_size ispstat_buffer 0 8262 NULL
+datablkcnt_capi_register_params_8263_fields datablkcnt capi_register_params 0 8263 NULL
+cow_file_range_inline_fndecl_8264_fields cow_file_range_inline fndecl 4-3 8264 NULL
+num_u3_ports_xhci_hcd_mtk_8272_fields num_u3_ports xhci_hcd_mtk 0 8272 NULL
+datablklen_capi_register_params_8275_fields datablklen capi_register_params 0 8275 NULL
+cdc_ncm_check_tx_max_fndecl_8278_fields cdc_ncm_check_tx_max fndecl 0-2 8278 NULL
+msg_len_rndis_message_8281_fields msg_len rndis_message 0 8281 NULL
+__sg_free_table_fndecl_8283_fields __sg_free_table fndecl 2 8283 NULL nohasharray
+expectedlen_drbg_testvec_8283_fields expectedlen drbg_testvec 0 8283 &__sg_free_table_fndecl_8283_fields
+tail_len_cfg80211_beacon_data_8293_fields tail_len cfg80211_beacon_data 0 8293 NULL nohasharray
+ixgbe_read_pci_cfg_word_fndecl_8293_fields ixgbe_read_pci_cfg_word fndecl 0 8293 &tail_len_cfg80211_beacon_data_8293_fields
+ns_blocks_per_segment_the_nilfs_8295_fields ns_blocks_per_segment the_nilfs 0 8295 NULL nohasharray
+f2fs_grab_bio_fndecl_8295_fields f2fs_grab_bio fndecl 2-3 8295 &ns_blocks_per_segment_the_nilfs_8295_fields
+c_data_len_pvr2_ioread_8300_fields c_data_len pvr2_ioread 0 8300 NULL nohasharray
+offset_nft_payload_set_8300_fields offset nft_payload_set 0 8300 &c_data_len_pvr2_ioread_8300_fields
+iova_mlx5_core_mkey_8304_fields iova mlx5_core_mkey 0 8304 NULL
+ath6kl_fwlog_read_fndecl_8310_fields ath6kl_fwlog_read fndecl 3 8310 NULL
+max_data_size_ircomm_tty_cb_8316_fields max_data_size ircomm_tty_cb 0 8316 NULL nohasharray
+group_trans_num_acl_subject_label_8316_fields group_trans_num acl_subject_label 0 8316 &max_data_size_ircomm_tty_cb_8316_fields
+depth_vim2m_fmt_8319_fields depth vim2m_fmt 0 8319 NULL nohasharray
+msg_len_drm_dp_sideband_msg_hdr_8319_fields msg_len drm_dp_sideband_msg_hdr 0 8319 &depth_vim2m_fmt_8319_fields
+sv_max_payload_svc_serv_8322_fields sv_max_payload svc_serv 0 8322 NULL
+vga_video_font_height_vardecl_vgacon_c_8324_fields vga_video_font_height vardecl_vgacon.c 0 8324 NULL
+xfs_bmap_longest_free_extent_fndecl_8327_fields xfs_bmap_longest_free_extent fndecl 2-0 8327 NULL
+vhci_urb_dequeue_fndecl_8333_fields vhci_urb_dequeue fndecl 3 8333 NULL
+sec_per_lun_nvm_dev_8335_fields sec_per_lun nvm_dev 0 8335 NULL
+disks_stripe_head_8349_fields disks stripe_head 0 8349 NULL
+req_pay_size_qlcnic_bc_trans_8353_fields req_pay_size qlcnic_bc_trans 0 8353 NULL nohasharray
+ch_do_scsi_fndecl_8353_fields ch_do_scsi fndecl 5 8353 &req_pay_size_qlcnic_bc_trans_8353_fields
+__nvm_submit_ppa_fndecl_8355_fields __nvm_submit_ppa fndecl 6 8355 NULL
+srp_map_sg_entry_fndecl_8356_fields srp_map_sg_entry fndecl 0 8356 NULL
+qat_rsa_set_n_fndecl_8373_fields qat_rsa_set_n fndecl 3 8373 NULL
+rx_size_i2400mu_8374_fields rx_size i2400mu 0 8374 NULL
+height_deinterlace_q_data_8376_fields height deinterlace_q_data 0 8376 NULL
+do_writepages_fndecl_8382_fields do_writepages fndecl 0 8382 NULL
+current_read_offset_scif_rb_8387_fields current_read_offset scif_rb 0 8387 NULL
+depth_tc_sfq_qopt_v1_8394_fields depth tc_sfq_qopt_v1 0 8394 NULL
+ceph_pagelist_append_fndecl_8397_fields ceph_pagelist_append fndecl 3 8397 NULL
+pkt_size_data_cmd_8407_fields pkt_size data_cmd 0 8407 NULL
+wNdpOutPayloadRemainder_usb_cdc_ncm_ntb_parameters_8415_fields wNdpOutPayloadRemainder usb_cdc_ncm_ntb_parameters 0 8415 NULL
+ring_blocks_vxge_hw_ring_config_8417_fields ring_blocks vxge_hw_ring_config 0 8417 NULL nohasharray
+get_power_state_size_pp_hwmgr_func_8417_fields get_power_state_size pp_hwmgr_func 0 8417 &ring_blocks_vxge_hw_ring_config_8417_fields
+numdu_nvme_get_log_page_command_8433_fields numdu nvme_get_log_page_command 0 8433 NULL
+block_dm_buffer_8440_fields block dm_buffer 0 8440 NULL
+offset_l2tp_session_8443_fields offset l2tp_session 0 8443 NULL
+frame_size_tlan_list_8446_fields frame_size tlan_list 0 8446 NULL
+numqueues_tun_struct_8450_fields numqueues tun_struct 0 8450 NULL
+ql_process_mac_split_rx_intr_fndecl_8452_fields ql_process_mac_split_rx_intr fndecl 4 8452 NULL nohasharray
+len_scifioctl_msg_8452_fields len scifioctl_msg 0 8452 &ql_process_mac_split_rx_intr_fndecl_8452_fields
+parport_pc_probe_port_fndecl_8454_fields parport_pc_probe_port fndecl 1 8454 NULL
+extra_bytes_asc_q_done_info_8460_fields extra_bytes asc_q_done_info 0 8460 NULL
+free_enic_rfs_flw_tbl_8469_fields free enic_rfs_flw_tbl 0 8469 NULL
+drm_gem_create_mmap_offset_size_fndecl_8471_fields drm_gem_create_mmap_offset_size fndecl 2 8471 NULL nohasharray
+shmem_truncate_range_fndecl_8471_fields shmem_truncate_range fndecl 2-3 8471 &drm_gem_create_mmap_offset_size_fndecl_8471_fields
+lbytes_tree_balance_8472_fields lbytes tree_balance 0 8472 NULL
+screen_size_fb_info_8480_fields screen_size fb_info 0 8480 NULL
+length_btrfs_bio_stripe_8481_fields length btrfs_bio_stripe 0 8481 NULL
+i915_gem_get_gtt_alignment_fndecl_8484_fields i915_gem_get_gtt_alignment fndecl 2 8484 NULL
+max_feed_count_dvb_usb_fe_adapter_8487_fields max_feed_count dvb_usb_fe_adapter 0 8487 NULL
+ecryptfs_send_message_locked_fndecl_8490_fields ecryptfs_send_message_locked fndecl 2 8490 NULL
+tid_iwl_compressed_ba_resp_8492_fields tid iwl_compressed_ba_resp 0 8492 NULL
+vmw_gmr2_bind_fndecl_8503_fields vmw_gmr2_bind fndecl 3 8503 NULL
+id_da903x_subdev_info_8507_fields id da903x_subdev_info 0 8507 NULL
+dy_fb_copyarea_8510_fields dy fb_copyarea 0 8510 NULL
+num_processors_vardecl_8512_fields num_processors vardecl 0 8512 NULL
+st_nci_hci_dm_direct_load_fndecl_8517_fields st_nci_hci_dm_direct_load fndecl 3 8517 NULL
+follows_u132_command_8527_fields follows u132_command 0 8527 NULL
+alloc_blksz_shift_hfsplus_sb_info_8530_fields alloc_blksz_shift hfsplus_sb_info 0 8530 NULL
+strnlen_user_fndecl_8532_fields strnlen_user fndecl 2 8532 NULL
+hfi1_seq_lseek_fndecl_8536_fields hfi1_seq_lseek fndecl 2 8536 NULL
+r5l_recovery_flush_one_stripe_fndecl_8538_fields r5l_recovery_flush_one_stripe fndecl 3 8538 NULL
+overlay_out_left_vivid_dev_8540_fields overlay_out_left vivid_dev 0 8540 NULL
+limit_kmem_cache_8541_fields limit kmem_cache 0 8541 NULL
+num_gfx_vgastate_8542_fields num_gfx vgastate 0 8542 NULL
+sysminor_aoedev_8549_fields sysminor aoedev 0 8549 NULL
+vfront_porch_videomode_8550_fields vfront_porch videomode 0 8550 NULL nohasharray
+memsize_vardecl_tridentfb_c_8550_fields memsize vardecl_tridentfb.c 0 8550 &vfront_porch_videomode_8550_fields
+mailbox_add_intel_sst_drv_8554_fields mailbox_add intel_sst_drv 0 8554 NULL
+caps_size_skl_specific_cfg_8559_fields caps_size skl_specific_cfg 0 8559 NULL
+len_vmxnet3_rx_buf_info_8575_fields len vmxnet3_rx_buf_info 0 8575 NULL nohasharray
+mlx5_ib_update_mtt_fndecl_8575_fields mlx5_ib_update_mtt fndecl 3-2 8575 &len_vmxnet3_rx_buf_info_8575_fields
+rmi_i2c_read_block_fndecl_8583_fields rmi_i2c_read_block fndecl 4 8583 NULL
+num_module_param_attrs_8584_fields num module_param_attrs 0 8584 NULL
+max_request_size_brcmf_sdio_dev_8586_fields max_request_size brcmf_sdio_dev 0 8586 NULL
+ddb_output_write_fndecl_8589_fields ddb_output_write fndecl 3 8589 NULL
+height_efifb_dmi_info_8596_fields height efifb_dmi_info 0 8596 NULL nohasharray
+gss_unwrap_kerberos_v2_fndecl_8596_fields gss_unwrap_kerberos_v2 fndecl 2 8596 &height_efifb_dmi_info_8596_fields
+size_hw_bank_8604_fields size hw_bank 0 8604 NULL
+uar_scratch_entry_sz_mthca_dev_lim_8606_fields uar_scratch_entry_sz mthca_dev_lim 0 8606 NULL
+seq_buf_commit_fndecl_8608_fields seq_buf_commit fndecl 2 8608 NULL
+irq_spi_device_8610_fields irq spi_device 0 8610 NULL
+transfer_size_fndecl_8623_fields transfer_size fndecl 1-2-0-3 8623 NULL
+block_size_cache_args_8648_fields block_size cache_args 0 8648 NULL
+e_value_offs_ext4_xattr_entry_8650_fields e_value_offs ext4_xattr_entry 0 8650 NULL
+xfs_bmap_worst_indlen_fndecl_8651_fields xfs_bmap_worst_indlen fndecl 0 8651 NULL
+truncate_size_ceph_mds_reply_inode_8652_fields truncate_size ceph_mds_reply_inode 0 8652 NULL nohasharray
+mr_len_rpcrdma_mr_seg_8652_fields mr_len rpcrdma_mr_seg 0 8652 &truncate_size_ceph_mds_reply_inode_8652_fields
+mtd_ooblayout_count_bytes_fndecl_8654_fields mtd_ooblayout_count_bytes fndecl 0 8654 NULL
+__alloc_percpu_gfp_fndecl_8664_fields __alloc_percpu_gfp fndecl 1 8664 NULL
+vbi_end_bttv_8666_fields vbi_end bttv 0 8666 NULL
+ext4_zero_range_fndecl_8667_fields ext4_zero_range fndecl 2-3 8667 NULL
+reserve_pfn_range_fndecl_8670_fields reserve_pfn_range fndecl 1-2 8670 NULL
+vb2_write_fndecl_8671_fields vb2_write fndecl 3 8671 NULL
+write_data_done_iscsi_cmd_8676_fields write_data_done iscsi_cmd 0 8676 NULL
+aml_offset_acpi_rsconvert_info_8678_fields aml_offset acpi_rsconvert_info 0 8678 NULL
+status_whc_urb_8685_fields status whc_urb 0 8685 NULL
+mtd_add_partition_fndecl_8688_fields mtd_add_partition fndecl 3 8688 NULL
+env_start_mm_struct_8690_fields env_start mm_struct 0 8690 NULL
+mpeglines_vardecl_cx231xx_417_c_8691_fields mpeglines vardecl_cx231xx-417.c 0 8691 NULL
+blk_mq_update_nr_requests_fndecl_8694_fields blk_mq_update_nr_requests fndecl 2 8694 NULL
+NumEraseUnits_erase_unit_header_t_8696_fields NumEraseUnits erase_unit_header_t 0 8696 NULL
+iblock_execute_rw_fndecl_8701_fields iblock_execute_rw fndecl 3 8701 NULL
+hpfs_prefetch_sectors_fndecl_8708_fields hpfs_prefetch_sectors fndecl 2 8708 NULL
+max_unmap_blocks_scsi_disk_8709_fields max_unmap_blocks scsi_disk 0 8709 NULL
+ieee80211_send_auth_fndecl_8716_fields ieee80211_send_auth fndecl 6 8716 NULL nohasharray
+adf7242_upload_firmware_fndecl_8716_fields adf7242_upload_firmware fndecl 3 8716 &ieee80211_send_auth_fndecl_8716_fields
+iram_end_intel_sst_drv_8725_fields iram_end intel_sst_drv 0 8725 NULL
+__xfs_trans_roll_fndecl_8728_fields __xfs_trans_roll fndecl 0 8728 NULL
+read_hdlc_status_fritz_adapter_8730_fields read_hdlc_status fritz_adapter 0 8730 NULL nohasharray
+disconnect_fndecl_8730_fields disconnect fndecl 4 8730 &read_hdlc_status_fritz_adapter_8730_fields nohasharray
+ip_set_elem_len_fndecl_8730_fields ip_set_elem_len fndecl 4-3 8730 &disconnect_fndecl_8730_fields
+iwl_mvm_sta_rx_agg_fndecl_8734_fields iwl_mvm_sta_rx_agg fndecl 3 8734 NULL
+ext_param_page_length_nand_onfi_params_8736_fields ext_param_page_length nand_onfi_params 0 8736 NULL
+size_kmem_cache_8740_fields size kmem_cache 0 8740 NULL
+fd_execute_unmap_fndecl_8745_fields fd_execute_unmap fndecl 3-2 8745 NULL
+perf_ustack_task_size_fndecl_8746_fields perf_ustack_task_size fndecl 0 8746 NULL
+_netlbl_catmap_getnode_fndecl_8754_fields _netlbl_catmap_getnode fndecl 2 8754 NULL
+my_skb_align_fndecl_8755_fields my_skb_align fndecl 2 8755 NULL
+snd_pcm_hw_param_set_fndecl_8761_fields snd_pcm_hw_param_set fndecl 4 8761 NULL
+length_acpi_nfit_system_address_8762_fields length acpi_nfit_system_address 0 8762 NULL
+max_swap_info_struct_8767_fields max swap_info_struct 0 8767 NULL
+max_pfn_radeon_vm_manager_8768_fields max_pfn radeon_vm_manager 0 8768 NULL
+amdtp_stream_set_parameters_fndecl_8769_fields amdtp_stream_set_parameters fndecl 3 8769 NULL
+data_dma_powermate_device_8783_fields data_dma powermate_device 0 8783 NULL
+rx_tr_cfv_info_8786_fields rx_tr cfv_info 0 8786 NULL nohasharray
+__pg_advance_sg_page_iter_8786_fields __pg_advance sg_page_iter 0 8786 &rx_tr_cfv_info_8786_fields
+nfs_setup_write_request_fndecl_8793_fields nfs_setup_write_request fndecl 3-4 8793 NULL
+lcd_vblank_len_atyfb_par_8796_fields lcd_vblank_len atyfb_par 0 8796 NULL
+logic_start_scrub_parity_8798_fields logic_start scrub_parity 0 8798 NULL
+dio_read_error_fndecl_8803_fields dio_read_error fndecl 5-6-4 8803 NULL
+write_ext_msg_fndecl_8804_fields write_ext_msg fndecl 3 8804 NULL
+amdgpu_gart_size_vardecl_8805_fields amdgpu_gart_size vardecl 0 8805 NULL
+info3_wmi_data_hdr_8808_fields info3 wmi_data_hdr 0 8808 NULL
+ieee80211_hdrlen_fndecl_8814_fields ieee80211_hdrlen fndecl 0 8814 NULL
+dma_alloc_pages_fndecl_8819_fields dma_alloc_pages fndecl 3 8819 NULL
+shmem_user_xattr_handler_set_fndecl_8823_fields shmem_user_xattr_handler_set fndecl 6 8823 NULL
+dma_buf_mmap_fndecl_8825_fields dma_buf_mmap fndecl 3 8825 NULL
+nfs4_xattr_get_nfs4_label_fndecl_8827_fields nfs4_xattr_get_nfs4_label fndecl 6 8827 NULL
+buflow_ring_desc_ex_8829_fields buflow ring_desc_ex 0 8829 NULL
+vsync_len_videomode_8830_fields vsync_len videomode 0 8830 NULL
+rel_pd_idx_sd_pd_idx_8842_fields rel_pd_idx sd_pd_idx 0 8842 NULL
+iscsi_tcp_segment_recv_fndecl_8845_fields iscsi_tcp_segment_recv fndecl 4-0 8845 NULL
+max_packet_size_ftdi_private_8847_fields max_packet_size ftdi_private 0 8847 NULL
+ibufsize_sisusb_usb_data_8851_fields ibufsize sisusb_usb_data 0 8851 NULL
+blkno2_xfs_da_args_8858_fields blkno2 xfs_da_args 0 8858 NULL
+alloc_extent_buffer_fndecl_8862_fields alloc_extent_buffer fndecl 2 8862 NULL
+__memblock_free_early_fndecl_8876_fields __memblock_free_early fndecl 2-1 8876 NULL
+fill_packet_fndecl_8877_fields fill_packet fndecl 5 8877 NULL nohasharray
+jfs_readpages_fndecl_8877_fields jfs_readpages fndecl 4 8877 &fill_packet_fndecl_8877_fields
+root_entry_uctp_fndecl_8878_fields root_entry_uctp fndecl 0 8878 NULL
+icsk_ext_hdr_len_inet_connection_sock_8885_fields icsk_ext_hdr_len inet_connection_sock 0 8885 NULL
+playback_frlog_rme32_8891_fields playback_frlog rme32 0 8891 NULL
+via_lock_rate_fndecl_8895_fields via_lock_rate fndecl 2 8895 NULL
+a_data_exec_8906_fields a_data exec 0 8906 NULL
+xfs_filestream_new_ag_fndecl_8916_fields xfs_filestream_new_ag fndecl 0 8916 NULL
+_xfs_buf_get_pages_fndecl_8920_fields _xfs_buf_get_pages fndecl 2 8920 NULL
+xfs_bmbt_update_fndecl_8922_fields xfs_bmbt_update fndecl 0 8922 NULL
+data_size_mdp_superblock_1_8925_fields data_size mdp_superblock_1 0 8925 NULL
+nbufread_gspca_dev_8934_fields nbufread gspca_dev 0 8934 NULL
+tree_root_btrfs_root_backup_8950_fields tree_root btrfs_root_backup 0 8950 NULL
+get_arg_page_fndecl_8953_fields get_arg_page fndecl 2 8953 NULL
+rx_metadata_offset_brcmf_msgbuf_8954_fields rx_metadata_offset brcmf_msgbuf 0 8954 NULL
+nfrags_pktgen_dev_8956_fields nfrags pktgen_dev 0 8956 NULL
+pkt_align_fndecl_8963_fields pkt_align fndecl 2-3 8963 NULL
+ncommunities_byt_pinctrl_soc_data_8965_fields ncommunities byt_pinctrl_soc_data 0 8965 NULL
+fromlen_nfs_symlinkargs_8967_fields fromlen nfs_symlinkargs 0 8967 NULL
+wm8776_field_set_fndecl_8970_fields wm8776_field_set fndecl 2 8970 NULL
+size_sg_pool_8971_fields size sg_pool 0 8971 NULL
+area_length_dmi_system_event_log_8974_fields area_length dmi_system_event_log 0 8974 NULL
+fanout_ubifs_info_8981_fields fanout ubifs_info 0 8981 NULL
+ocfs2_xattr_find_entry_fndecl_8983_fields ocfs2_xattr_find_entry fndecl 0 8983 NULL
+iomap_file_buffered_write_fndecl_8986_fields iomap_file_buffered_write fndecl 0 8986 NULL
+link_duplex_netxen_adapter_8988_fields link_duplex netxen_adapter 0 8988 NULL
+block_begin_dm_cell_key_8992_fields block_begin dm_cell_key 0 8992 NULL
+scatterwalk_map_and_copy_fndecl_9005_fields scatterwalk_map_and_copy fndecl 3 9005 NULL
+pcan_usb_decode_data_fndecl_9023_fields pcan_usb_decode_data fndecl 2 9023 NULL
+xen_del_extra_mem_fndecl_9024_fields xen_del_extra_mem fndecl 2-1 9024 NULL nohasharray
+cdrom_read_cd_fndecl_9024_fields cdrom_read_cd fndecl 5-4 9024 &xen_del_extra_mem_fndecl_9024_fields
+xfs_bmap_extsize_align_fndecl_9025_fields xfs_bmap_extsize_align fndecl 0 9025 NULL
+report_desc_size_mousevsc_dev_9027_fields report_desc_size mousevsc_dev 0 9027 NULL
+nextread_isowbuf_t_9028_fields nextread isowbuf_t 0 9028 NULL nohasharray
+offset_gro_remcsum_9028_fields offset gro_remcsum 0 9028 &nextread_isowbuf_t_9028_fields
+wDescriptorLength_hid_class_descriptor_9030_fields wDescriptorLength hid_class_descriptor 0 9030 NULL
+svc_create_pooled_fndecl_9043_fields svc_create_pooled fndecl 2 9043 NULL
+raid_disks_geom_9044_fields raid_disks geom 0 9044 NULL
+ath6kl_wmi_delete_pstream_cmd_fndecl_9048_fields ath6kl_wmi_delete_pstream_cmd fndecl 2 9048 NULL
+_drbd_bm_find_next_fndecl_9063_fields _drbd_bm_find_next fndecl 2-0 9063 NULL nohasharray
+keys_bset_9063_fields keys bset 0 9063 &_drbd_bm_find_next_fndecl_9063_fields nohasharray
+tx_buf_sz_iadev_priv_9063_fields tx_buf_sz iadev_priv 0 9063 &keys_bset_9063_fields nohasharray
+send_mpa_reply_fndecl_9063_fields send_mpa_reply fndecl 3 9063 &tx_buf_sz_iadev_priv_9063_fields
+buflen_compat_xfs_fsop_attrlist_handlereq_9071_fields buflen compat_xfs_fsop_attrlist_handlereq 0 9071 NULL
+current_sg_offset_msb_data_9075_fields current_sg_offset msb_data 0 9075 NULL nohasharray
+nr_inport_coresight_platform_data_9075_fields nr_inport coresight_platform_data 0 9075 &current_sg_offset_msb_data_9075_fields
+nilfs_dat_read_fndecl_9076_fields nilfs_dat_read fndecl 2 9076 NULL
+advertised_mtu_tipc_link_9077_fields advertised_mtu tipc_link 0 9077 NULL
+out_int_pipe_usbtest_dev_9078_fields out_int_pipe usbtest_dev 0 9078 NULL
+start_brk_mm_struct_9085_fields start_brk mm_struct 0 9085 NULL
+optlen_rdma_ucm_set_option_9087_fields optlen rdma_ucm_set_option 0 9087 NULL
+event_count_Fsm_9088_fields event_count Fsm 0 9088 NULL
+width_fb_fillrect_9090_fields width fb_fillrect 0 9090 NULL
+vmci_qp_alloc_fndecl_9094_fields vmci_qp_alloc fndecl 5-3 9094 NULL
+limit_parsed_partitions_9099_fields limit parsed_partitions 0 9099 NULL
+logical_id_i40e_aqc_list_capabilities_element_resp_9102_fields logical_id i40e_aqc_list_capabilities_element_resp 0 9102 NULL
+keylen_ieee80211_key_conf_9103_fields keylen ieee80211_key_conf 0 9103 NULL
+s_blocks_count_lo_ext4_super_block_9106_fields s_blocks_count_lo ext4_super_block 0 9106 NULL nohasharray
+fragment_size_cfrfml_9106_fields fragment_size cfrfml 0 9106 &s_blocks_count_lo_ext4_super_block_9106_fields
+x38_channel_num_vardecl_x38_edac_c_9109_fields x38_channel_num vardecl_x38_edac.c 0 9109 NULL
+qla4_82xx_pci_mem_write_2M_fndecl_9117_fields qla4_82xx_pci_mem_write_2M fndecl 2 9117 NULL
+numEntries__ATOM_PPLIB_VCE_Clock_Voltage_Limit_Table_9118_fields numEntries _ATOM_PPLIB_VCE_Clock_Voltage_Limit_Table 0 9118 NULL
+break_ksm_fndecl_9124_fields break_ksm fndecl 2 9124 NULL
+skl_substream_alloc_pages_fndecl_9125_fields skl_substream_alloc_pages fndecl 3 9125 NULL
+xfs_alloc_put_freelist_fndecl_9126_fields xfs_alloc_put_freelist fndecl 0 9126 NULL
+compat_readv_fndecl_9127_fields compat_readv fndecl 3 9127 NULL
+neigh_priv_len_net_device_9133_fields neigh_priv_len net_device 0 9133 NULL
+read_buffer_length_adu_device_9140_fields read_buffer_length adu_device 0 9140 NULL
+size_ip6t_replace_9148_fields size ip6t_replace 0 9148 NULL
+cifs_uncached_read_into_pages_fndecl_9150_fields cifs_uncached_read_into_pages fndecl 3 9150 NULL
+ext_capab_len_station_parameters_9152_fields ext_capab_len station_parameters 0 9152 NULL
+fill_readbuf_fndecl_9155_fields fill_readbuf fndecl 3 9155 NULL
+percpu_max_size_percpu_ida_9157_fields percpu_max_size percpu_ida 0 9157 NULL
+depth_saa7134_format_9167_fields depth saa7134_format 0 9167 NULL
+ib_qib_max_sges_vardecl_9168_fields ib_qib_max_sges vardecl 0 9168 NULL
+alloc_queue_pairs_i40e_vsi_9174_fields alloc_queue_pairs i40e_vsi 0 9174 NULL
+offset_hv_multipage_buffer_9175_fields offset hv_multipage_buffer 0 9175 NULL
+__ext4_handle_dirty_super_fndecl_9177_fields __ext4_handle_dirty_super fndecl 0 9177 NULL nohasharray
+hid_input_report_fndecl_9177_fields hid_input_report fndecl 4 9177 &__ext4_handle_dirty_super_fndecl_9177_fields
+b_size_buffer_head_9178_fields b_size buffer_head 0 9178 NULL
+max_vfio_pci_fill_info_9182_fields max vfio_pci_fill_info 0 9182 NULL
+chunk_sectors_queue_limits_9183_fields chunk_sectors queue_limits 0 9183 NULL
+form_cm_frame_fndecl_9184_fields form_cm_frame fndecl 4-6 9184 NULL
+requested_headroom_veth_priv_9187_fields requested_headroom veth_priv 0 9187 NULL
+device_sis_chipset_9193_fields device sis_chipset 0 9193 NULL
+stb0899_write_regs_fndecl_9197_fields stb0899_write_regs fndecl 4 9197 NULL
+buflen_xfs_fsop_attrlist_handlereq_9199_fields buflen xfs_fsop_attrlist_handlereq 0 9199 NULL
+efx_rx_packet_fndecl_9200_fields efx_rx_packet fndecl 4-3 9200 NULL
+byte_per_page_nand_onfi_params_9202_fields byte_per_page nand_onfi_params 0 9202 NULL
+max_pages_ib_fmr_attr_9206_fields max_pages ib_fmr_attr 0 9206 NULL nohasharray
+tx_max_datagrams_cdc_ncm_ctx_9206_fields tx_max_datagrams cdc_ncm_ctx 0 9206 &max_pages_ib_fmr_attr_9206_fields
+hw_token_ehci_qh_hw_9208_fields hw_token ehci_qh_hw 0 9208 NULL
+mesh_rx_path_sel_frame_fndecl_9210_fields mesh_rx_path_sel_frame fndecl 3 9210 NULL
+sae_data_len_cfg80211_auth_request_9212_fields sae_data_len cfg80211_auth_request 0 9212 NULL nohasharray
+num_pin_hdac_hdmi_priv_9212_fields num_pin hdac_hdmi_priv 0 9212 &sae_data_len_cfg80211_auth_request_9212_fields
+num_msix_vectors_vf_i40e_hw_capabilities_9215_fields num_msix_vectors_vf i40e_hw_capabilities 0 9215 NULL
+zram_meta_alloc_fndecl_9221_fields zram_meta_alloc fndecl 2 9221 NULL
+pcicfg_size_sst_pdata_9222_fields pcicfg_size sst_pdata 0 9222 NULL
+ext4_create_inline_data_fndecl_9231_fields ext4_create_inline_data fndecl 3 9231 NULL
+supported_rates_len_station_parameters_9235_fields supported_rates_len station_parameters 0 9235 NULL
+i2400mu_rx_size_grow_fndecl_9246_fields i2400mu_rx_size_grow fndecl 0 9246 NULL
+phys_pmd_init_fndecl_9251_fields phys_pmd_init fndecl 0-2-3 9251 NULL nohasharray
+vram_start_vml_info_9251_fields vram_start vml_info 0 9251 &phys_pmd_init_fndecl_9251_fields
+sk_priority_sock_9258_fields sk_priority sock 0 9258 NULL
+nsid_nvmet_ns_9259_fields nsid nvmet_ns 0 9259 NULL
+buffer_size_snd_rawmidi_runtime_9267_fields buffer_size snd_rawmidi_runtime 0 9267 NULL
+netlbl_bitmap_walk_fndecl_9270_fields netlbl_bitmap_walk fndecl 0-3 9270 NULL
+wl1251_sdio_write_fndecl_9274_fields wl1251_sdio_write fndecl 4 9274 NULL
+ResponseDataLength__MSG_SMP_PASSTHROUGH_REPLY_9278_fields ResponseDataLength _MSG_SMP_PASSTHROUGH_REPLY 0 9278 NULL
+nr_pages_start_info_9283_fields nr_pages start_info 0 9283 NULL nohasharray
+regmap_encx24j600_write_fndecl_9283_fields regmap_encx24j600_write fndecl 3 9283 &nr_pages_start_info_9283_fields
+offset_ivtv_dma_page_info_9286_fields offset ivtv_dma_page_info 0 9286 NULL
+rx_cmd_ep_usb_card_rec_9290_fields rx_cmd_ep usb_card_rec 0 9290 NULL nohasharray
+get_ramsize_brcmf_bus_ops_9290_fields get_ramsize brcmf_bus_ops 0 9290 &rx_cmd_ep_usb_card_rec_9290_fields nohasharray
+format_reserved_ms_boot_header_9290_fields format_reserved ms_boot_header 0 9290 &get_ramsize_brcmf_bus_ops_9290_fields
+cxd2820r_wr_regs_fndecl_9307_fields cxd2820r_wr_regs fndecl 4 9307 NULL
+sys_splice_fndecl_9308_fields sys_splice fndecl 5 9308 NULL
+fcoe_conn_context_id_fcoe_kcqe_9316_fields fcoe_conn_context_id fcoe_kcqe 0 9316 NULL
+find_mergeable_fndecl_9318_fields find_mergeable fndecl 2 9318 NULL
+in_packet_size_pcm_runtime_9321_fields in_packet_size pcm_runtime 0 9321 NULL
+pages_in_io_dio_submit_9326_fields pages_in_io dio_submit 0 9326 NULL
+extLength_long_ad_9328_fields extLength long_ad 0 9328 NULL
+ttm_bo_ioremap_fndecl_9337_fields ttm_bo_ioremap fndecl 3-2 9337 NULL
+htree_dirblock_to_tree_fndecl_9339_fields htree_dirblock_to_tree fndecl 3 9339 NULL
+di_size_xfs_icdinode_9350_fields di_size xfs_icdinode 0 9350 NULL
+tse_init_rx_buffer_fndecl_9354_fields tse_init_rx_buffer fndecl 3 9354 NULL
+length_property_entry_9357_fields length property_entry 0 9357 NULL nohasharray
+offset_ore_io_state_9357_fields offset ore_io_state 0 9357 &length_property_entry_9357_fields
+stv6110x_write_regs_fndecl_9359_fields stv6110x_write_regs fndecl 4 9359 NULL
+qib_qp_rcv_fndecl_9365_fields qib_qp_rcv fndecl 5 9365 NULL
+compat_sys_get_mempolicy_fndecl_9366_fields compat_sys_get_mempolicy fndecl 4 9366 NULL
+mt2060_writeregs_fndecl_9371_fields mt2060_writeregs fndecl 3 9371 NULL
+le_adv_data_len_hci_conn_9377_fields le_adv_data_len hci_conn 0 9377 NULL
+mss_clamp_tcp_options_received_9378_fields mss_clamp tcp_options_received 0 9378 NULL
+fix_priv_head_fndecl_9385_fields fix_priv_head fndecl 2 9385 NULL
+nr_uart_driver_9391_fields nr uart_driver 0 9391 NULL
+dr_pre_altera_jtag_9393_fields dr_pre altera_jtag 0 9393 NULL
+ubifs_tnc_add_nm_fndecl_9397_fields ubifs_tnc_add_nm fndecl 5-4 9397 NULL
+sr_bg_blkno_ocfs2_suballoc_result_9401_fields sr_bg_blkno ocfs2_suballoc_result 0 9401 NULL
+caif_seqpkt_recvmsg_fndecl_9402_fields caif_seqpkt_recvmsg fndecl 3 9402 NULL
+sht3x_read_from_command_fndecl_9403_fields sht3x_read_from_command fndecl 5 9403 NULL
+exclude_mem_range_fndecl_9404_fields exclude_mem_range fndecl 2-3 9404 NULL
+blk_queue_physical_block_size_fndecl_9410_fields blk_queue_physical_block_size fndecl 2 9410 NULL nohasharray
+goodix_get_cfg_len_fndecl_9410_fields goodix_get_cfg_len fndecl 0 9410 &blk_queue_physical_block_size_fndecl_9410_fields
+return_size_drm_amdgpu_info_9414_fields return_size drm_amdgpu_info 0 9414 NULL
+acpi_ex_system_memory_space_handler_fndecl_9419_fields acpi_ex_system_memory_space_handler fndecl 2 9419 NULL
+r592_read_fifo_pio_fndecl_9421_fields r592_read_fifo_pio fndecl 3 9421 NULL
+dlen_garp_attr_9422_fields dlen garp_attr 0 9422 NULL
+bcma_hcd_create_pdev_fndecl_9430_fields bcma_hcd_create_pdev fndecl 3-5 9430 NULL
+ext4_restore_inline_data_fndecl_9436_fields ext4_restore_inline_data fndecl 5 9436 NULL
+height_stk1160_9446_fields height stk1160 0 9446 NULL
+mtdchar_readoob_fndecl_9459_fields mtdchar_readoob fndecl 3 9459 NULL
+si21_writeregs_fndecl_9460_fields si21_writeregs fndecl 4 9460 NULL
+async_wrap_skb_fndecl_9465_fields async_wrap_skb fndecl 0 9465 NULL
+height_cobalt_stream_9490_fields height cobalt_stream 0 9490 NULL
+bpp_mcam_format_struct_9503_fields bpp mcam_format_struct 0 9503 NULL
+mlxsw_emad_trans_finish_fndecl_9506_fields mlxsw_emad_trans_finish fndecl 2 9506 NULL
+s_clustersize_bits_ocfs2_super_block_9516_fields s_clustersize_bits ocfs2_super_block 0 9516 NULL nohasharray
+zero_disk_area_fndecl_9516_fields zero_disk_area fndecl 2 9516 &s_clustersize_bits_ocfs2_super_block_9516_fields
+cap_width_usbtv_norm_params_9538_fields cap_width usbtv_norm_params 0 9538 NULL
+nilfs_mdt_forget_block_fndecl_9543_fields nilfs_mdt_forget_block fndecl 2 9543 NULL
+cnt_i40iw_hmc_obj_info_9546_fields cnt i40iw_hmc_obj_info 0 9546 NULL
+__bio_alloc_fndecl_9552_fields __bio_alloc fndecl 2-3 9552 NULL
+rt2x00queue_insert_l2pad_fndecl_9553_fields rt2x00queue_insert_l2pad fndecl 2 9553 NULL
+display_byte_stride_vivid_dev_9554_fields display_byte_stride vivid_dev 0 9554 NULL
+rx_skb_reserve_vardecl_he_c_9559_fields rx_skb_reserve vardecl_he.c 0 9559 NULL
+glocont_endpoint_keyspan_device_details_9560_fields glocont_endpoint keyspan_device_details 0 9560 NULL
+p9_client_statsize_fndecl_9568_fields p9_client_statsize fndecl 0 9568 NULL
+page_order_cas_9572_fields page_order cas 0 9572 NULL
+width_drm_mode_create_dumb_9575_fields width drm_mode_create_dumb 0 9575 NULL
+mpage_add_bh_to_extent_fndecl_9577_fields mpage_add_bh_to_extent fndecl 2 9577 NULL
+mode_buf_len_udl_device_9578_fields mode_buf_len udl_device 0 9578 NULL
+cfg80211_rx_mgmt_fndecl_9583_fields cfg80211_rx_mgmt fndecl 5 9583 NULL
+crtc_vblank_start_drm_display_mode_9587_fields crtc_vblank_start drm_display_mode 0 9587 NULL
+per_vf_tids_qed_tm_iids_9589_fields per_vf_tids qed_tm_iids 0 9589 NULL
+tool_setup_mw_fndecl_9597_fields tool_setup_mw fndecl 3 9597 NULL
+xlog_grant_head_wait_fndecl_9598_fields xlog_grant_head_wait fndecl 0 9598 NULL
+ileb_len_ubifs_info_9607_fields ileb_len ubifs_info 0 9607 NULL
+free_bg_ocfs2_cached_block_free_9619_fields free_bg ocfs2_cached_block_free 0 9619 NULL
+geneve_change_mtu_fndecl_9620_fields geneve_change_mtu fndecl 2 9620 NULL
+size_scif_rb_9622_fields size scif_rb 0 9622 NULL
+hpfs_ea_write_fndecl_9626_fields hpfs_ea_write fndecl 5-4-2 9626 NULL
+cur_can_queue_megasas_instance_9627_fields cur_can_queue megasas_instance 0 9627 NULL
+num_fcxps_vardecl_9630_fields num_fcxps vardecl 0 9630 NULL
+ubifs_wbuf_seek_nolock_fndecl_9634_fields ubifs_wbuf_seek_nolock fndecl 3 9634 NULL
+fc_host_post_vendor_event_fndecl_9636_fields fc_host_post_vendor_event fndecl 3 9636 NULL
+copy_to_iter_fndecl_9638_fields copy_to_iter fndecl 2 9638 NULL
+fd_do_prot_unmap_fndecl_9639_fields fd_do_prot_unmap fndecl 3 9639 NULL
+num_nodes_hdac_device_9647_fields num_nodes hdac_device 0 9647 NULL
+dict_size_lzma_header_9654_fields dict_size lzma_header 0 9654 NULL nohasharray
+height_drm_vmw_size_9654_fields height drm_vmw_size 0 9654 &dict_size_lzma_header_9654_fields
+x509_akid_note_name_fndecl_9656_fields x509_akid_note_name fndecl 5 9656 NULL
+wm8400_register_regulator_fndecl_9660_fields wm8400_register_regulator fndecl 2 9660 NULL
+hugetlb_cow_fndecl_9665_fields hugetlb_cow fndecl 3 9665 NULL
+hr_slots_per_page_o2hb_region_9668_fields hr_slots_per_page o2hb_region 0 9668 NULL
+PCI_Address_DAC960_Controller_9669_fields PCI_Address DAC960_Controller 0 9669 NULL
+xen_blkif_max_ring_order_vardecl_xen_blkfront_c_9681_fields xen_blkif_max_ring_order vardecl_xen-blkfront.c 0 9681 NULL
+length_hpfs_dirent_9682_fields length hpfs_dirent 0 9682 NULL
+scrub_pages_for_parity_fndecl_9684_fields scrub_pages_for_parity fndecl 3-2-4 9684 NULL
+osd_req_decode_sense_full_fndecl_9685_fields osd_req_decode_sense_full fndecl 0 9685 NULL
+s3fwrn5_fw_prep_msg_fndecl_9686_fields s3fwrn5_fw_prep_msg fndecl 6 9686 NULL
+ba_param_set_wmi_rcp_addba_req_event_9687_fields ba_param_set wmi_rcp_addba_req_event 0 9687 NULL
+xresstep_svga_fb_format_9690_fields xresstep svga_fb_format 0 9690 NULL
+max_num_pmkids_wiphy_9691_fields max_num_pmkids wiphy 0 9691 NULL
+fill_from_dev_buffer_fndecl_9695_fields fill_from_dev_buffer fndecl 3 9695 NULL
+adp5589_build_gpiomap_fndecl_9697_fields adp5589_build_gpiomap fndecl 0 9697 NULL
+phys_addr_ntb_transport_mw_9704_fields phys_addr ntb_transport_mw 0 9704 NULL
+payload_len_cfg80211_wowlan_tcp_9706_fields payload_len cfg80211_wowlan_tcp 0 9706 NULL
+sr_write_async_fndecl_9707_fields sr_write_async fndecl 3 9707 NULL
+xprt_rdma_max_inline_write_vardecl_transport_c_9715_fields xprt_rdma_max_inline_write vardecl_transport.c 0 9715 NULL
+n_functions_gcov_info_9722_fields n_functions gcov_info 0 9722 NULL nohasharray
+page_size_dataflash_9722_fields page_size dataflash 0 9722 &n_functions_gcov_info_9722_fields
+setup_port_fndecl_9724_fields setup_port fndecl 5-4 9724 NULL nohasharray
+start_bidx_of_node_fndecl_9724_fields start_bidx_of_node fndecl 0-1 9724 &setup_port_fndecl_9724_fields nohasharray
+ieee80211_build_preq_ies_band_fndecl_9724_fields ieee80211_build_preq_ies_band fndecl 0 9724 &start_bidx_of_node_fndecl_9724_fields
+mask_myri10ge_tx_buf_9725_fields mask myri10ge_tx_buf 0 9725 NULL
+midi_out_ports_snd_efw_9740_fields midi_out_ports snd_efw 0 9740 NULL
+sg_cnt_nvmet_req_9742_fields sg_cnt nvmet_req 0 9742 NULL
+key_sz_qat_rsa_ctx_9743_fields key_sz qat_rsa_ctx 0 9743 NULL
+__alloc_bootmem_fndecl_9753_fields __alloc_bootmem fndecl 2-3 9753 NULL
+hbuf_free_slots_mei_hw_ops_9760_fields hbuf_free_slots mei_hw_ops 0 9760 NULL
+hidraw_write_fndecl_9763_fields hidraw_write fndecl 3 9763 NULL
+index_sdio_uart_port_9769_fields index sdio_uart_port 0 9769 NULL
+stat_ethoc_bd_9775_fields stat ethoc_bd 0 9775 NULL
+vmlfb_alloc_vram_area_fndecl_9776_fields vmlfb_alloc_vram_area fndecl 2 9776 NULL
+ctl_dev_e752x_dev_info_9777_fields ctl_dev e752x_dev_info 0 9777 NULL
+encap_hlen_ip_tunnel_9779_fields encap_hlen ip_tunnel 0 9779 NULL
+valuelen_xfs_da_args_9786_fields valuelen xfs_da_args 0 9786 NULL
+irda_recvmsg_dgram_fndecl_9788_fields irda_recvmsg_dgram fndecl 3 9788 NULL
+vci_atm_vcc_9797_fields vci atm_vcc 0 9797 NULL
+aper_base_agp_kern_info_9798_fields aper_base agp_kern_info 0 9798 NULL
+irlan_insert_array_param_fndecl_9800_fields irlan_insert_array_param fndecl 4 9800 NULL
+rq_callsize_rpc_rqst_9803_fields rq_callsize rpc_rqst 0 9803 NULL
+osst_write_fndecl_9806_fields osst_write fndecl 3 9806 NULL
+in_size_ViceIoctl_9808_fields in_size ViceIoctl 0 9808 NULL
+num_private_args_iw_handler_def_9810_fields num_private_args iw_handler_def 0 9810 NULL
+update_backref_node_fndecl_9811_fields update_backref_node fndecl 3 9811 NULL
+pathmtu_sctp_association_9815_fields pathmtu sctp_association 0 9815 NULL
+brcmf_proto_bcdc_hdrpush_fndecl_9818_fields brcmf_proto_bcdc_hdrpush fndecl 3 9818 NULL
+ppm_find_unused_entries_fndecl_9823_fields ppm_find_unused_entries fndecl 0 9823 NULL
+pref_erase_mmc_card_9824_fields pref_erase mmc_card 0 9824 NULL
+flags_rtl8187se_rx_desc_9826_fields flags rtl8187se_rx_desc 0 9826 NULL
+section_count_f2fs_super_block_9832_fields section_count f2fs_super_block 0 9832 NULL
+sectors_r10bio_9834_fields sectors r10bio 0 9834 NULL
+msc_buffer_contig_alloc_fndecl_9835_fields msc_buffer_contig_alloc fndecl 2 9835 NULL
+msg_length_sms_msg_hdr_9842_fields msg_length sms_msg_hdr 0 9842 NULL
+complete_read_super_fndecl_9844_fields complete_read_super fndecl 3 9844 NULL
+sge_length_rvt_sge_9845_fields sge_length rvt_sge 0 9845 NULL
+pg_count_agp_allocate_9853_fields pg_count agp_allocate 0 9853 NULL
+data_size_virtio_gpu_vbuffer_9856_fields data_size virtio_gpu_vbuffer 0 9856 NULL
+vlan_id_rlb_client_info_9858_fields vlan_id rlb_client_info 0 9858 NULL
+videobuf_read_one_fndecl_9862_fields videobuf_read_one fndecl 3 9862 NULL
+arvo_sysfs_read_fndecl_9874_fields arvo_sysfs_read fndecl 6 9874 NULL
+xfs_seek_hole_data_fndecl_9883_fields xfs_seek_hole_data fndecl 2 9883 NULL
+v4l_nbufs_vardecl_9889_fields v4l_nbufs vardecl 0 9889 NULL
+ovfx2_pkt_scan_fndecl_9901_fields ovfx2_pkt_scan fndecl 3 9901 NULL nohasharray
+begin_entry_alloc_9901_fields begin entry_alloc 0 9901 &ovfx2_pkt_scan_fndecl_9901_fields
+nkeys_tc_u32_sel_9905_fields nkeys tc_u32_sel 0 9905 NULL
+prism54_wpa_bss_ie_add_fndecl_9910_fields prism54_wpa_bss_ie_add fndecl 4 9910 NULL
+stat_ddb_output_9913_fields stat ddb_output 0 9913 NULL
+ep_in_ksdazzle_cb_9917_fields ep_in ksdazzle_cb 0 9917 NULL
+__ceph_do_getattr_fndecl_9918_fields __ceph_do_getattr fndecl 0 9918 NULL
+audit_log_n_string_fndecl_9930_fields audit_log_n_string fndecl 3 9930 NULL
+num_wsm_set_tx_rate_retry_policy_9933_fields num wsm_set_tx_rate_retry_policy 0 9933 NULL
+_usb_writeN_sync_fndecl_9937_fields _usb_writeN_sync fndecl 4 9937 NULL
+r_rcv_len_rvt_qp_9940_fields r_rcv_len rvt_qp 0 9940 NULL
+num_chan_pl330_config_9943_fields num_chan pl330_config 0 9943 NULL
+buffer_len_bnad_debug_info_9948_fields buffer_len bnad_debug_info 0 9948 NULL
+error_dm_crypt_io_9949_fields error dm_crypt_io 0 9949 NULL
+ath6kl_wmi_send_probe_response_cmd_fndecl_9955_fields ath6kl_wmi_send_probe_response_cmd fndecl 6-2 9955 NULL
+utf16s_to_utf8s_fndecl_9956_fields utf16s_to_utf8s fndecl 0 9956 NULL
+build_request_ceph_auth_client_ops_9960_fields build_request ceph_auth_client_ops 0 9960 NULL
+xfs_difree_inobt_fndecl_9961_fields xfs_difree_inobt fndecl 4 9961 NULL
+rt2x00dev_extra_tx_headroom_fndecl_9971_fields rt2x00dev_extra_tx_headroom fndecl 0 9971 NULL
+reada_find_extent_fndecl_9973_fields reada_find_extent fndecl 2 9973 NULL
+count_tun_filter_9984_fields count tun_filter 0 9984 NULL
+start_extent_buffer_9986_fields start extent_buffer 0 9986 NULL
+map_sg_ib_dma_mapping_ops_9988_fields map_sg ib_dma_mapping_ops 0 9988 NULL
+hugepage_add_anon_rmap_fndecl_9989_fields hugepage_add_anon_rmap fndecl 3 9989 NULL
+dm_rh_region_to_sector_fndecl_9992_fields dm_rh_region_to_sector fndecl 0-2 9992 NULL
+cyy_readb_fndecl_10011_fields cyy_readb fndecl 0 10011 NULL
+setifbcnt_fndecl_10012_fields setifbcnt fndecl 3 10012 NULL
+_create_sg_bios_fndecl_10015_fields _create_sg_bios fndecl 4 10015 NULL
+nouveau_sgdma_create_ttm_fndecl_10022_fields nouveau_sgdma_create_ttm fndecl 2 10022 NULL
+skb_append_datato_frags_fndecl_10028_fields skb_append_datato_frags fndecl 5 10028 NULL
+add_dataflash_otp_fndecl_10031_fields add_dataflash_otp fndecl 4-3 10031 NULL
+__cookie_v6_check_fndecl_10035_fields __cookie_v6_check fndecl 0 10035 NULL
+mwifiex_send_tdls_action_frame_fndecl_10044_fields mwifiex_send_tdls_action_frame fndecl 7 10044 NULL
+sisusbcon_scroll_fndecl_10048_fields sisusbcon_scroll fndecl 5-2-3 10048 NULL
+ath6kl_wmi_powermode_cmd_fndecl_10052_fields ath6kl_wmi_powermode_cmd fndecl 2 10052 NULL
+musb_urb_dequeue_fndecl_10056_fields musb_urb_dequeue fndecl 3 10056 NULL
+dm_bufio_prefetch_fndecl_10057_fields dm_bufio_prefetch fndecl 2 10057 NULL
+bio_detain_range_fndecl_10064_fields bio_detain_range fndecl 2-3 10064 NULL
+rx_buf_sz_sis190_private_10068_fields rx_buf_sz sis190_private 0 10068 NULL
+max_pages_fuse_req_10069_fields max_pages fuse_req 0 10069 NULL
+num_channels_cap11xx_hw_model_10072_fields num_channels cap11xx_hw_model 0 10072 NULL
+sg_size_octnic_gather_10076_fields sg_size octnic_gather 0 10076 NULL
+ocfs2_refcount_xattr_tree_rec_fndecl_10077_fields ocfs2_refcount_xattr_tree_rec fndecl 3 10077 NULL
+read_csr_fndecl_10078_fields read_csr fndecl 0 10078 NULL
+nbr_fingers_rmi_2d_sensor_10079_fields nbr_fingers rmi_2d_sensor 0 10079 NULL
+mlxsw_emad_process_status_fndecl_10083_fields mlxsw_emad_process_status fndecl 0 10083 NULL
+height_virtio_gpu_rect_10085_fields height virtio_gpu_rect 0 10085 NULL
+ssb_admatch_base_fndecl_10086_fields ssb_admatch_base fndecl 0-1 10086 NULL
+__send_changing_extent_only_fndecl_10090_fields __send_changing_extent_only fndecl 0 10090 NULL
+pskb_extract_fndecl_10092_fields pskb_extract fndecl 2-3 10092 NULL nohasharray
+pinctrl_utils_add_map_configs_fndecl_10092_fields pinctrl_utils_add_map_configs fndecl 7 10092 &pskb_extract_fndecl_10092_fields
+em28xx_init_usb_xfer_fndecl_10106_fields em28xx_init_usb_xfer fndecl 5-6 10106 NULL
+req_sz__MPT_ADAPTER_10113_fields req_sz _MPT_ADAPTER 0 10113 NULL
+total_len_extlog_l1_head_10117_fields total_len extlog_l1_head 0 10117 NULL nohasharray
+uvc_video_encode_data_fndecl_10117_fields uvc_video_encode_data fndecl 0-4 10117 &total_len_extlog_l1_head_10117_fields
+pxa2xx_spi_get_port_id_fndecl_10119_fields pxa2xx_spi_get_port_id fndecl 0 10119 NULL
+len_pda_entry_10121_fields len pda_entry 0 10121 NULL
+data_dma_usbtouch_usb_10124_fields data_dma usbtouch_usb 0 10124 NULL nohasharray
+MaxBlocksPerCommand_DAC960_Controller_10124_fields MaxBlocksPerCommand DAC960_Controller 0 10124 &data_dma_usbtouch_usb_10124_fields
+parent_overlap_rbd_device_10127_fields parent_overlap rbd_device 0 10127 NULL
+max_bu_buf_len_ubifs_info_10130_fields max_bu_buf_len ubifs_info 0 10130 NULL
+ieee80211_rx_mgmt_auth_fndecl_10133_fields ieee80211_rx_mgmt_auth fndecl 3 10133 NULL
+qlcnic_83xx_diag_alloc_res_fndecl_10139_fields qlcnic_83xx_diag_alloc_res fndecl 3 10139 NULL
+xprt_rdma_allocate_fndecl_10143_fields xprt_rdma_allocate fndecl 2 10143 NULL
+ns_cno_the_nilfs_10144_fields ns_cno the_nilfs 0 10144 NULL
+mcs7830_set_reg_fndecl_10150_fields mcs7830_set_reg fndecl 3 10150 NULL
+udp_tun_rx_dst_fndecl_10154_fields udp_tun_rx_dst fndecl 5 10154 NULL
+error_block_length_acpi_hest_generic_10170_fields error_block_length acpi_hest_generic 0 10170 NULL
+cluster_size_msdos_sb_info_10172_fields cluster_size msdos_sb_info 0 10172 NULL
+s_inopf_ufs_sb_private_info_10174_fields s_inopf ufs_sb_private_info 0 10174 NULL nohasharray
+count_i40iw_hmc_del_obj_info_10174_fields count i40iw_hmc_del_obj_info 0 10174 &s_inopf_ufs_sb_private_info_10174_fields nohasharray
+substream_count_snd_rawmidi_str_10174_fields substream_count snd_rawmidi_str 0 10174 &count_i40iw_hmc_del_obj_info_10174_fields
+acpi_sci_ioapic_setup_fndecl_10182_fields acpi_sci_ioapic_setup fndecl 4 10182 NULL
+xfrm6_init_path_fndecl_10187_fields xfrm6_init_path fndecl 3 10187 NULL
+size_erst_erange_10188_fields size erst_erange 0 10188 NULL
+PagesPerBlock_ms_lib_ctrl_10191_fields PagesPerBlock ms_lib_ctrl 0 10191 NULL
+tx_buf_size_mwifiex_adapter_10198_fields tx_buf_size mwifiex_adapter 0 10198 NULL
+valid_super_block_f2fs_sb_info_10206_fields valid_super_block f2fs_sb_info 0 10206 NULL
+xfs_trans_commit_fndecl_10211_fields xfs_trans_commit fndecl 0 10211 NULL
+old_log_size_persistent_ram_zone_10215_fields old_log_size persistent_ram_zone 0 10215 NULL
+__ext4_journal_get_write_access_fndecl_10217_fields __ext4_journal_get_write_access fndecl 0 10217 NULL
+ext4_xattr_set_handle_fndecl_10221_fields ext4_xattr_set_handle fndecl 6 10221 NULL
+uac2_ctl_value_size_fndecl_10224_fields uac2_ctl_value_size fndecl 0 10224 NULL
+pci_hotplug_bus_size_vardecl_10230_fields pci_hotplug_bus_size vardecl 0 10230 NULL
+input_get_new_minor_fndecl_10235_fields input_get_new_minor fndecl 0 10235 NULL
+iio_devt_vardecl_industrialio_core_c_10237_fields iio_devt vardecl_industrialio-core.c 0 10237 NULL nohasharray
+req_pages_pvscsi_adapter_10237_fields req_pages pvscsi_adapter 0 10237 &iio_devt_vardecl_industrialio_core_c_10237_fields
+uarc_size_mthca_uar_table_10238_fields uarc_size mthca_uar_table 0 10238 NULL
+bv_len_bio_vec_10239_fields bv_len bio_vec 0 10239 NULL
+q1_depth_bna_rx_config_10241_fields q1_depth bna_rx_config 0 10241 NULL
+smallpageshift_sddr55_card_info_10244_fields smallpageshift sddr55_card_info 0 10244 NULL
+irias_add_octseq_attrib_fndecl_10252_fields irias_add_octseq_attrib fndecl 4 10252 NULL nohasharray
+diva_os_get_context_size_fndecl_10252_fields diva_os_get_context_size fndecl 0 10252 &irias_add_octseq_attrib_fndecl_10252_fields
+filelayout_get_dense_offset_fndecl_10253_fields filelayout_get_dense_offset fndecl 0 10253 NULL
+iscsi_sw_tcp_send_hdr_prep_fndecl_10261_fields iscsi_sw_tcp_send_hdr_prep fndecl 3 10261 NULL
+sdebug_store_sectors_vardecl_scsi_debug_c_10267_fields sdebug_store_sectors vardecl_scsi_debug.c 0 10267 NULL
+jffs2_scan_dirent_node_fndecl_10268_fields jffs2_scan_dirent_node fndecl 4 10268 NULL
+dn_sendmsg_fndecl_10269_fields dn_sendmsg fndecl 3 10269 NULL
+rxd_process_rxd_ops_10271_fields rxd_process rxd_ops 0 10271 NULL
+vmci_host_setup_notify_fndecl_10273_fields vmci_host_setup_notify fndecl 2 10273 NULL
+num_vfs_i40e_hw_capabilities_10302_fields num_vfs i40e_hw_capabilities 0 10302 NULL
+ieee80211_tdls_add_chan_switch_req_ies_fndecl_10304_fields ieee80211_tdls_add_chan_switch_req_ies fndecl 6 10304 NULL
+qede_fill_frag_skb_fndecl_10307_fields qede_fill_frag_skb fndecl 4 10307 NULL
+drm_dp_dual_mode_read_fndecl_10313_fields drm_dp_dual_mode_read fndecl 4 10313 NULL
+scsi_vpd_inquiry_fndecl_10315_fields scsi_vpd_inquiry fndecl 4 10315 NULL
+xfs_rmap_map_extent_fndecl_10318_fields xfs_rmap_map_extent fndecl 0 10318 NULL
+blk_stack_limits_fndecl_10332_fields blk_stack_limits fndecl 3 10332 NULL
+xfs_get_blocks_dax_fault_fndecl_10335_fields xfs_get_blocks_dax_fault fndecl 2 10335 NULL
+down_bplus_internal_node_10336_fields down bplus_internal_node 0 10336 NULL
+len_xdr_buf_10338_fields len xdr_buf 0 10338 NULL
+sector_size_btt_10339_fields sector_size btt 0 10339 NULL
+s_no_blocks_logfs_super_10354_fields s_no_blocks logfs_super 0 10354 NULL
+num_mgms_mlx4_caps_10367_fields num_mgms mlx4_caps 0 10367 NULL
+vmcoreinfo_max_size_vardecl_10370_fields vmcoreinfo_max_size vardecl 0 10370 NULL
+len_mt7601u_dma_buf_10376_fields len mt7601u_dma_buf 0 10376 NULL nohasharray
+ssid_len_libipw_network_10376_fields ssid_len libipw_network 0 10376 &len_mt7601u_dma_buf_10376_fields
+size_synthvid_msg_hdr_10391_fields size synthvid_msg_hdr 0 10391 NULL
+arg_ax25_ctl_struct_10392_fields arg ax25_ctl_struct 0 10392 NULL
+iomem_base_myri10ge_priv_10393_fields iomem_base myri10ge_priv 0 10393 NULL
+tg3_run_loopback_fndecl_10398_fields tg3_run_loopback fndecl 2 10398 NULL nohasharray
+generic_write_checks_fndecl_10398_fields generic_write_checks fndecl 0 10398 &tg3_run_loopback_fndecl_10398_fields
+ihead_offs_ubifs_info_10400_fields ihead_offs ubifs_info 0 10400 NULL
+length_p_header95_10401_fields length p_header95 0 10401 NULL
+romfs_blk_strnlen_fndecl_10402_fields romfs_blk_strnlen fndecl 3-2-0 10402 NULL
+_osd_req_sizeof_alist_header_fndecl_10405_fields _osd_req_sizeof_alist_header fndecl 0 10405 NULL nohasharray
+num_vss_cfgs_wm8994_pdata_10405_fields num_vss_cfgs wm8994_pdata 0 10405 &_osd_req_sizeof_alist_header_fndecl_10405_fields
+zap_vma_ptes_fndecl_10406_fields zap_vma_ptes fndecl 3-2 10406 NULL
+addr_page_req_dsc_10411_fields addr page_req_dsc 0 10411 NULL
+off_xtsplit_10412_fields off xtsplit 0 10412 NULL
+max_ctrl_size_ims_pcu_10413_fields max_ctrl_size ims_pcu 0 10413 NULL
+nent_mlx4_eq_10414_fields nent mlx4_eq 0 10414 NULL
+size_xt_table_info_10415_fields size xt_table_info 0 10415 NULL
+num_chipselect_spi_master_10420_fields num_chipselect spi_master 0 10420 NULL
+spi_async_locked_fndecl_10422_fields spi_async_locked fndecl 0 10422 NULL
+byte_count_iwl_rx_mpdu_res_start_10437_fields byte_count iwl_rx_mpdu_res_start 0 10437 NULL nohasharray
+flip_sd_gl860_10437_fields flip sd_gl860 0 10437 &byte_count_iwl_rx_mpdu_res_start_10437_fields
+alloc_switch_ctx_fndecl_10438_fields alloc_switch_ctx fndecl 3 10438 NULL
+radeon_gem_object_create_fndecl_10441_fields radeon_gem_object_create fndecl 2 10441 NULL
+expand_inode_data_fndecl_10442_fields expand_inode_data fndecl 2-3 10442 NULL
+wrfilled_cyberjack_private_10444_fields wrfilled cyberjack_private 0 10444 NULL
+p9dirent_read_fndecl_10450_fields p9dirent_read fndecl 3-0 10450 NULL
+ext4_write_inline_data_end_fndecl_10452_fields ext4_write_inline_data_end fndecl 0-4 10452 NULL
+page_shift_nand_chip_10453_fields page_shift nand_chip 0 10453 NULL
+length_acpi_mem_space_context_10460_fields length acpi_mem_space_context 0 10460 NULL
+vxlan_change_mtu_fndecl_10464_fields vxlan_change_mtu fndecl 2 10464 NULL nohasharray
+__btt_map_write_fndecl_10464_fields __btt_map_write fndecl 0 10464 &vxlan_change_mtu_fndecl_10464_fields
+notesize_fndecl_10467_fields notesize fndecl 0 10467 NULL nohasharray
+wNdpOutDivisor_usb_cdc_ncm_ntb_parameters_10467_fields wNdpOutDivisor usb_cdc_ncm_ntb_parameters 0 10467 &notesize_fndecl_10467_fields
+__genwqe_readq_fndecl_10470_fields __genwqe_readq fndecl 0 10470 NULL
+devnum_usb_device_10474_fields devnum usb_device 0 10474 NULL
+signature_mspro_attribute_10483_fields signature mspro_attribute 0 10483 NULL
+out_min_chans_snd_card_asihpi_10490_fields out_min_chans snd_card_asihpi 0 10490 NULL
+msb_cache_read_fndecl_10494_fields msb_cache_read fndecl 5 10494 NULL
+xfs_bmap_punch_delalloc_range_fndecl_10503_fields xfs_bmap_punch_delalloc_range fndecl 2 10503 NULL
+cidlen_he_rbrq_10504_fields cidlen he_rbrq 0 10504 NULL
+nouveau_channel_prep_fndecl_10506_fields nouveau_channel_prep fndecl 3 10506 NULL
+cr_namelen_nfsd4_create_10516_fields cr_namelen nfsd4_create 0 10516 NULL
+dma_burst_size_chip_data_10519_fields dma_burst_size chip_data 0 10519 NULL nohasharray
+ipmi_major_vardecl_ipmi_devintf_c_10519_fields ipmi_major vardecl_ipmi_devintf.c 0 10519 &dma_burst_size_chip_data_10519_fields
+slba_nvme_rw_command_10529_fields slba nvme_rw_command 0 10529 NULL
+rsa_offset_intel_guc_fw_10530_fields rsa_offset intel_guc_fw 0 10530 NULL
+stride_cobalt_stream_10537_fields stride cobalt_stream 0 10537 NULL
+logical_scrub_page_10540_fields logical scrub_page 0 10540 NULL
+xen_set_callback_via_fndecl_10541_fields xen_set_callback_via fndecl 1 10541 NULL
+emi62_writememory_fndecl_10544_fields emi62_writememory fndecl 4 10544 NULL
+isofs_get_last_session_fndecl_10547_fields isofs_get_last_session fndecl 0 10547 NULL nohasharray
+y_skip_top_mt9m001_10547_fields y_skip_top mt9m001 0 10547 &isofs_get_last_session_fndecl_10547_fields
+nv_change_mtu_fndecl_10551_fields nv_change_mtu fndecl 2 10551 NULL
+new_leaf_fndecl_10553_fields new_leaf fndecl 3 10553 NULL
+id_hsi_controller_10557_fields id hsi_controller 0 10557 NULL
+tcf_csum_ipv6_icmp_fndecl_10562_fields tcf_csum_ipv6_icmp fndecl 3 10562 NULL
+dbg_dest_reg_num_iwl_fw_10568_fields dbg_dest_reg_num iwl_fw 0 10568 NULL
+num_send_contexts_hfi1_devdata_10569_fields num_send_contexts hfi1_devdata 0 10569 NULL
+cnt_rsxx_reg_access_10573_fields cnt rsxx_reg_access 0 10573 NULL
+sb_bsize_shift_gfs2_sb_host_10575_fields sb_bsize_shift gfs2_sb_host 0 10575 NULL nohasharray
+ds_write_shift_logfs_disk_super_10575_fields ds_write_shift logfs_disk_super 0 10575 &sb_bsize_shift_gfs2_sb_host_10575_fields
+initialized_size__ntfs_inode_10576_fields initialized_size _ntfs_inode 0 10576 NULL
+resource_addr_nvkm_device_func_10582_fields resource_addr nvkm_device_func 0 10582 NULL
+buf_idx_mei_cl_cb_10585_fields buf_idx mei_cl_cb 0 10585 NULL nohasharray
+vmw_compat_shader_add_fndecl_10585_fields vmw_compat_shader_add fndecl 6 10585 &buf_idx_mei_cl_cb_10585_fields
+pcmcia_make_resource_fndecl_10591_fields pcmcia_make_resource fndecl 2-1 10591 NULL
+size_ib_uverbs_flow_attr_10597_fields size ib_uverbs_flow_attr 0 10597 NULL
+max_frame_size_atl1_hw_10601_fields max_frame_size atl1_hw 0 10601 NULL
+uremainder64_st_cmdstatus_10606_fields uremainder64 st_cmdstatus 0 10606 NULL
+inst_size_il4965_firmware_pieces_10607_fields inst_size il4965_firmware_pieces 0 10607 NULL
+rq_depth_p9_rdma_opts_10608_fields rq_depth p9_rdma_opts 0 10608 NULL nohasharray
+index_vardecl_mtpav_c_10608_fields index vardecl_mtpav.c 0 10608 &rq_depth_p9_rdma_opts_10608_fields
+brightness_sd_gl860_10611_fields brightness sd_gl860 0 10611 NULL
+ext4_trim_all_free_fndecl_10621_fields ext4_trim_all_free fndecl 4-2-0 10621 NULL
+rx_queues_nicvf_10628_fields rx_queues nicvf 0 10628 NULL
+pkt_alignment_factor_rndis_initialize_complete_10633_fields pkt_alignment_factor rndis_initialize_complete 0 10633 NULL
+pgbase_nfs_pgio_args_10636_fields pgbase nfs_pgio_args 0 10636 NULL
+length_iomap_10641_fields length iomap 0 10641 NULL
+tcp_sendpage_fndecl_10646_fields tcp_sendpage fndecl 4-3 10646 NULL
+cxgbit_map_skb_fndecl_10650_fields cxgbit_map_skb fndecl 4-3 10650 NULL
+smk_write_relabel_self_fndecl_10657_fields smk_write_relabel_self fndecl 3 10657 NULL
+memory_size_vhost_memory_region_10658_fields memory_size vhost_memory_region 0 10658 NULL
+tlv_put_fndecl_10659_fields tlv_put fndecl 4 10659 NULL
+start_mtd_oob_buf32_10664_fields start mtd_oob_buf32 0 10664 NULL
+len_ahd_dma_seg_10667_fields len ahd_dma_seg 0 10667 NULL
+nfc_targets_found_fndecl_10669_fields nfc_targets_found fndecl 3 10669 NULL
+radeon_ttm_tt_create_fndecl_10672_fields radeon_ttm_tt_create fndecl 2 10672 NULL
+word_size_e1000_nvm_info_10681_fields word_size e1000_nvm_info 0 10681 NULL nohasharray
+xfs_rtfind_forw_fndecl_10681_fields xfs_rtfind_forw fndecl 3-0 10681 &word_size_e1000_nvm_info_10681_fields
+tlen_sc18is602_10682_fields tlen sc18is602 0 10682 NULL
+sb_bsize_gfs2_sb_host_10683_fields sb_bsize gfs2_sb_host 0 10683 NULL
+extract_icmp6_fields_fndecl_10685_fields extract_icmp6_fields fndecl 2 10685 NULL
+num_frames_usb_usbvision_10687_fields num_frames usb_usbvision 0 10687 NULL
+alauda_read_block_raw_fndecl_10688_fields alauda_read_block_raw fndecl 4 10688 NULL
+rx_ba_win_size_conf_ht_setting_10692_fields rx_ba_win_size conf_ht_setting 0 10692 NULL
+gigaset_initbcs_fndecl_10693_fields gigaset_initbcs fndecl 3 10693 NULL
+afs_write_begin_fndecl_10704_fields afs_write_begin fndecl 3-4 10704 NULL
+xfs_alloc_read_agf_fndecl_10710_fields xfs_alloc_read_agf fndecl 3-0 10710 NULL
+iio_set_bytes_per_datum_kfifo_fndecl_10712_fields iio_set_bytes_per_datum_kfifo fndecl 2 10712 NULL
+key_size_dw_guc_css_header_10714_fields key_size_dw guc_css_header 0 10714 NULL
+set_le_key_k_offset_fndecl_10721_fields set_le_key_k_offset fndecl 3 10721 NULL
+ipv6_recv_error_fndecl_10728_fields ipv6_recv_error fndecl 3 10728 NULL nohasharray
+blocks_dm_verity_fec_10728_fields blocks dm_verity_fec 0 10728 &ipv6_recv_error_fndecl_10728_fields
+xen_p2m_size_vardecl_10730_fields xen_p2m_size vardecl 0 10730 NULL
+iomem_reg_shift_serial_struct_10733_fields iomem_reg_shift serial_struct 0 10733 NULL
+ntp_fltr_count_bnxt_10734_fields ntp_fltr_count bnxt 0 10734 NULL
+sb_dirblklog_xfs_sb_10738_fields sb_dirblklog xfs_sb 0 10738 NULL
+__memblock_find_range_bottom_up_fndecl_10739_fields __memblock_find_range_bottom_up fndecl 0-4-1-2 10739 NULL
+BufSizeShift_qinfo_chip_10746_fields BufSizeShift qinfo_chip 0 10746 NULL nohasharray
+page_errors_dio_10746_fields page_errors dio 0 10746 &BufSizeShift_qinfo_chip_10746_fields
+next_blkoff_curseg_info_10751_fields next_blkoff curseg_info 0 10751 NULL
+NumEraseRegions_cfi_ident_10753_fields NumEraseRegions cfi_ident 0 10753 NULL
+write_head_fndecl_10754_fields write_head fndecl 4 10754 NULL
+adu_write_fndecl_10756_fields adu_write fndecl 3 10756 NULL
+data_start_dm_verity_10759_fields data_start dm_verity 0 10759 NULL
+new_chunk_core_exception_10765_fields new_chunk core_exception 0 10765 NULL
+ocrdma_reg_user_mr_fndecl_10777_fields ocrdma_reg_user_mr fndecl 2-3 10777 NULL
+amdgpu_ttm_tt_create_fndecl_10779_fields amdgpu_ttm_tt_create fndecl 2 10779 NULL
+unallocated_pble_i40iw_hmc_pble_rsrc_10784_fields unallocated_pble i40iw_hmc_pble_rsrc 0 10784 NULL
+pnode_sz_ubifs_info_10791_fields pnode_sz ubifs_info 0 10791 NULL nohasharray
+ea_write_fndecl_10791_fields ea_write fndecl 3 10791 &pnode_sz_ubifs_info_10791_fields
+read32_brcmf_buscore_ops_10795_fields read32 brcmf_buscore_ops 0 10795 NULL
+set_config_fndecl_10797_fields set_config fndecl 0 10797 NULL
+num_events_kfd_ioctl_wait_events_args_10811_fields num_events kfd_ioctl_wait_events_args 0 10811 NULL
+hstcp_cong_avoid_fndecl_10814_fields hstcp_cong_avoid fndecl 3 10814 NULL nohasharray
+page_offset_sw_rx_data_10814_fields page_offset sw_rx_data 0 10814 &hstcp_cong_avoid_fndecl_10814_fields
+ssb_sdio_block_write_fndecl_10815_fields ssb_sdio_block_write fndecl 3 10815 NULL nohasharray
+num_rxd_netxen_adapter_10815_fields num_rxd netxen_adapter 0 10815 &ssb_sdio_block_write_fndecl_10815_fields
+add_regulator_linked_fndecl_10819_fields add_regulator_linked fndecl 1 10819 NULL
+read_reg_ipac_hw_10828_fields read_reg ipac_hw 0 10828 NULL
+num_mpt_mthca_profile_10833_fields num_mpt mthca_profile 0 10833 NULL
+rsrc_start_usb_hcd_10839_fields rsrc_start usb_hcd 0 10839 NULL
+do_generic_file_read_fndecl_10842_fields do_generic_file_read fndecl 0-4 10842 NULL
+set_record_extent_bits_fndecl_10845_fields set_record_extent_bits fndecl 0-3-2 10845 NULL
+get_cmdline_fndecl_10847_fields get_cmdline fndecl 3 10847 NULL
+dma_last_offset_ivtv_stream_10849_fields dma_last_offset ivtv_stream 0 10849 NULL
+set_le_fndecl_10854_fields set_le fndecl 4 10854 NULL
+v_size_nilfs_argv_10857_fields v_size nilfs_argv 0 10857 NULL
+h_stk_size_10859_fields h stk_size 0 10859 NULL
+size_fuse_notify_retrieve_out_10862_fields size fuse_notify_retrieve_out 0 10862 NULL
+ezusb_fill_req_fndecl_10868_fields ezusb_fill_req fndecl 0-2 10868 NULL nohasharray
+ts_packet_count_cx23885_tsport_10868_fields ts_packet_count cx23885_tsport 0 10868 &ezusb_fill_req_fndecl_10868_fields
+p9stat_read_fndecl_10869_fields p9stat_read fndecl 3 10869 NULL
+pci_mmconfig_alloc_fndecl_10875_fields pci_mmconfig_alloc fndecl 2-3-4 10875 NULL
+w9968cf_pkt_scan_fndecl_10878_fields w9968cf_pkt_scan fndecl 3 10878 NULL
+sgl_map_user_pages_fndecl_10881_fields sgl_map_user_pages fndecl 3 10881 NULL
+num_streams_lola_pcm_10882_fields num_streams lola_pcm 0 10882 NULL
+run_apei_exec_ins_type_10886_fields run apei_exec_ins_type 0 10886 NULL
+drv_tss_rings_qlcnic_adapter_10887_fields drv_tss_rings qlcnic_adapter 0 10887 NULL
+spu_write_fndecl_10889_fields spu_write fndecl 4 10889 NULL
+max_sge_per_wr_iwch_rnic_attributes_10892_fields max_sge_per_wr iwch_rnic_attributes 0 10892 NULL
+ecryptfs_lower_header_size_fndecl_10894_fields ecryptfs_lower_header_size fndecl 0 10894 NULL
+slot_device_offset_controller_10895_fields slot_device_offset controller 0 10895 NULL
+table_size_acpi_einj_trigger_10899_fields table_size acpi_einj_trigger 0 10899 NULL
+i2c_hid_get_report_length_fndecl_10901_fields i2c_hid_get_report_length fndecl 0 10901 NULL nohasharray
+n_cell_devs_intel_soc_pmic_config_10901_fields n_cell_devs intel_soc_pmic_config 0 10901 &i2c_hid_get_report_length_fndecl_10901_fields
+udf_read_ptagged_fndecl_10905_fields udf_read_ptagged fndecl 3 10905 NULL
+auxdev_llseek_fndecl_10911_fields auxdev_llseek fndecl 2 10911 NULL
+data_len_rndis_packet_10918_fields data_len rndis_packet 0 10918 NULL nohasharray
+compat_sys_msgsnd_fndecl_10918_fields compat_sys_msgsnd fndecl 3 10918 &data_len_rndis_packet_10918_fields
+isdn_audio_adpcm2xlaw_fndecl_10927_fields isdn_audio_adpcm2xlaw fndecl 0 10927 NULL
+ieee802154_max_payload_fndecl_10928_fields ieee802154_max_payload fndecl 0 10928 NULL
+ud_bmove_fndecl_10929_fields ud_bmove fndecl 8-6-4-7-5-3 10929 NULL
+dma_acm_rb_10934_fields dma acm_rb 0 10934 NULL
+l_offset_lbuf_10935_fields l_offset lbuf 0 10935 NULL
+bmp_len_xfrm_replay_state_esn_10945_fields bmp_len xfrm_replay_state_esn 0 10945 NULL
+max_i2c_msg_len_r820t_config_10951_fields max_i2c_msg_len r820t_config 0 10951 NULL nohasharray
+acc_passl_accessdata_dn_10951_fields acc_passl accessdata_dn 0 10951 &max_i2c_msg_len_r820t_config_10951_fields
+num_lan_qps_i40e_pf_10953_fields num_lan_qps i40e_pf 0 10953 NULL
+iov_iter_init_fndecl_10954_fields iov_iter_init fndecl 5-4 10954 NULL
+drm_fb_helper_fill_fix_fndecl_10963_fields drm_fb_helper_fill_fix fndecl 2 10963 NULL
+jffs2_flash_read_fndecl_10968_fields jffs2_flash_read fndecl 0 10968 NULL
+agp_remap_fndecl_10970_fields agp_remap fndecl 2 10970 NULL
+sys_ftruncate_fndecl_10972_fields sys_ftruncate fndecl 2 10972 NULL
+buffer_count_drm_i915_gem_execbuffer_10978_fields buffer_count drm_i915_gem_execbuffer 0 10978 NULL
+ssid_len_wl1271_scan_10981_fields ssid_len wl1271_scan 0 10981 NULL
+lbs_wrbbp_write_fndecl_10987_fields lbs_wrbbp_write fndecl 3 10987 NULL
+l2cap_build_conf_rsp_fndecl_10988_fields l2cap_build_conf_rsp fndecl 0 10988 NULL
+msize_vardecl_pmc551_c_10989_fields msize vardecl_pmc551.c 0 10989 NULL nohasharray
+vxfs_blkiget_fndecl_10989_fields vxfs_blkiget fndecl 3-2 10989 &msize_vardecl_pmc551_c_10989_fields
+height_v4l2_rect_10995_fields height v4l2_rect 0 10995 NULL
+bitmap_size_dma_iommu_mapping_10997_fields bitmap_size dma_iommu_mapping 0 10997 NULL
+l2nbperpage_jfs_sb_info_11000_fields l2nbperpage jfs_sb_info 0 11000 NULL
+il4965_tx_agg_stop_fndecl_11004_fields il4965_tx_agg_stop fndecl 4 11004 NULL
+xfs_bmap_add_extent_unwritten_real_fndecl_11006_fields xfs_bmap_add_extent_unwritten_real fndecl 0 11006 NULL nohasharray
+dccp_setsockopt_ccid_fndecl_11006_fields dccp_setsockopt_ccid fndecl 4 11006 &xfs_bmap_add_extent_unwritten_real_fndecl_11006_fields
+drm_gtf2_m_fndecl_11007_fields drm_gtf2_m fndecl 0 11007 NULL
+height_v4l2_pix_format_mplane_11015_fields height v4l2_pix_format_mplane 0 11015 NULL
+xferred_ScsiReqBlk_11017_fields xferred ScsiReqBlk 0 11017 NULL
+target_cmd_size_check_fndecl_11019_fields target_cmd_size_check fndecl 2 11019 NULL
+rx_pkt_pad_sge_11020_fields rx_pkt_pad sge 0 11020 NULL
+len_hif_scatter_req_11022_fields len hif_scatter_req 0 11022 NULL
+preallocate_pcm_pages_fndecl_11026_fields preallocate_pcm_pages fndecl 2 11026 NULL
+count_vfio_irq_set_11027_fields count vfio_irq_set 0 11027 NULL
+len_nfs3_mknodargs_11030_fields len nfs3_mknodargs 0 11030 NULL
+sectors_per_block_pool_11035_fields sectors_per_block pool 0 11035 NULL
+namelen_xfs_dir2_data_entry_11036_fields namelen xfs_dir2_data_entry 0 11036 NULL nohasharray
+ep_msg_in_peak_usb_device_11036_fields ep_msg_in peak_usb_device 0 11036 &namelen_xfs_dir2_data_entry_11036_fields
+iic_tpm_write_fndecl_11039_fields iic_tpm_write fndecl 3 11039 NULL
+DataTransferLength_DAC960_V2_UserCommand_11040_fields DataTransferLength DAC960_V2_UserCommand 0 11040 NULL
+xlog_write_log_records_fndecl_11042_fields xlog_write_log_records fndecl 4-3 11042 NULL
+va_size_coda_vattr_11053_fields va_size coda_vattr 0 11053 NULL
+do_mlock_fndecl_11062_fields do_mlock fndecl 1-2 11062 NULL
+i2c_writebytes_fndecl_11073_fields i2c_writebytes fndecl 4 11073 NULL
+entry_fat_entry_11079_fields entry fat_entry 0 11079 NULL
+irda_sendmsg_dgram_fndecl_11080_fields irda_sendmsg_dgram fndecl 3 11080 NULL
+do_brk_fndecl_11101_fields do_brk fndecl 1-2 11101 NULL
+acpi_processor_power_verify_fndecl_11105_fields acpi_processor_power_verify fndecl 0 11105 NULL
+__getblk_gfp_fndecl_11107_fields __getblk_gfp fndecl 3-2 11107 NULL nohasharray
+ext4_acl_from_disk_fndecl_11107_fields ext4_acl_from_disk fndecl 2 11107 &__getblk_gfp_fndecl_11107_fields
+wTotalBlockNumber_ms_bootblock_sysinf_11108_fields wTotalBlockNumber ms_bootblock_sysinf 0 11108 NULL
+addr_last_netup_dma_11114_fields addr_last netup_dma 0 11114 NULL
+hpfs_ea_read_fndecl_11118_fields hpfs_ea_read fndecl 5-4-2 11118 NULL
+whitebal_sd_gl860_11124_fields whitebal sd_gl860 0 11124 NULL
+tcp_try_undo_partial_fndecl_11125_fields tcp_try_undo_partial fndecl 2 11125 NULL
+n_channels_iwl_mcc_update_resp_11128_fields n_channels iwl_mcc_update_resp 0 11128 NULL
+ies_len_connect_resp_info_11130_fields ies_len connect_resp_info 0 11130 NULL
+num__cdrp_cmd_11142_fields num _cdrp_cmd 0 11142 NULL
+pageshift_nand_flash_dev_11144_fields pageshift nand_flash_dev 0 11144 NULL
+queue_depth_nullb_queue_11148_fields queue_depth nullb_queue 0 11148 NULL
+max_voices_snd_emux_11150_fields max_voices snd_emux 0 11150 NULL
+generic_ptrace_pokedata_fndecl_11153_fields generic_ptrace_pokedata fndecl 2 11153 NULL
+o2nm_this_node_fndecl_11157_fields o2nm_this_node fndecl 0 11157 NULL
+tclass_mlx5_av_11167_fields tclass mlx5_av 0 11167 NULL
+rmtvaluelen2_xfs_da_args_11168_fields rmtvaluelen2 xfs_da_args 0 11168 NULL
+drv_rss_rings_qlcnic_adapter_11169_fields drv_rss_rings qlcnic_adapter 0 11169 NULL
+udf_tread_fndecl_11173_fields udf_tread fndecl 2 11173 NULL
+payload_len_fc_bsg_buffer_11175_fields payload_len fc_bsg_buffer 0 11175 NULL
+c4iw_init_resource_fndecl_11178_fields c4iw_init_resource fndecl 2-3 11178 NULL
+jp_journal_1st_block_journal_params_11180_fields jp_journal_1st_block journal_params 0 11180 NULL
+ilo_major_vardecl_hpilo_c_11181_fields ilo_major vardecl_hpilo.c 0 11181 NULL
+xtInsert_fndecl_11182_fields xtInsert fndecl 5-4 11182 NULL
+fwd_cnt_virtio_vsock_hdr_11188_fields fwd_cnt virtio_vsock_hdr 0 11188 NULL
+sys_get_mempolicy_fndecl_11192_fields sys_get_mempolicy fndecl 4 11192 NULL
+resid_virtio_scsi_cmd_resp_11193_fields resid virtio_scsi_cmd_resp 0 11193 NULL
+get_user_pages_remote_fndecl_11197_fields get_user_pages_remote fndecl 0-3 11197 NULL
+t4vf_fl_pkt_align_fndecl_11203_fields t4vf_fl_pkt_align fndecl 0 11203 NULL nohasharray
+perf_output_begin_fndecl_11203_fields perf_output_begin fndecl 3 11203 &t4vf_fl_pkt_align_fndecl_11203_fields
+vb2_fop_write_fndecl_11207_fields vb2_fop_write fndecl 3 11207 NULL
+wipers_mcp4531_cfg_11208_fields wipers mcp4531_cfg 0 11208 NULL
+used_bytes_ubi_volume_info_11209_fields used_bytes ubi_volume_info 0 11209 NULL
+mq_create_fndecl_11210_fields mq_create fndecl 1 11210 NULL
+vid_end_switchdev_obj_port_vlan_11218_fields vid_end switchdev_obj_port_vlan 0 11218 NULL
+num_encoder_drm_mode_config_11220_fields num_encoder drm_mode_config 0 11220 NULL
+hdr_len_ieee80211_cipher_scheme_11241_fields hdr_len ieee80211_cipher_scheme 0 11241 NULL
+nfsd_get_default_max_blksize_fndecl_11251_fields nfsd_get_default_max_blksize fndecl 0 11251 NULL
+ds1305_nvram_write_fndecl_11267_fields ds1305_nvram_write fndecl 6 11267 NULL
+hactive_videomode_11268_fields hactive videomode 0 11268 NULL
+btcx_align_fndecl_11269_fields btcx_align fndecl 4 11269 NULL nohasharray
+vii_size_vxfs_inode_info_11269_fields vii_size vxfs_inode_info 0 11269 &btcx_align_fndecl_11269_fields
+snd_midi_event_encode_byte_fndecl_11281_fields snd_midi_event_encode_byte fndecl 0 11281 NULL
+btrfs_set_prop_fndecl_11284_fields btrfs_set_prop fndecl 4 11284 NULL
+mxuport_prepare_write_buffer_fndecl_11292_fields mxuport_prepare_write_buffer fndecl 3 11292 NULL
+newkey_nilfs_btnode_chkey_ctxt_11296_fields newkey nilfs_btnode_chkey_ctxt 0 11296 NULL
+max_pkt_size_stk1160_11297_fields max_pkt_size stk1160 0 11297 NULL
+wqe_shift_mthca_wq_11298_fields wqe_shift mthca_wq 0 11298 NULL
+remap_pfn_range_fndecl_11299_fields remap_pfn_range fndecl 3-4 11299 NULL
+xfs_alloc_update_fndecl_11301_fields xfs_alloc_update fndecl 0 11301 NULL
+buf_len_mwifiex_sdio_mpa_tx_11323_fields buf_len mwifiex_sdio_mpa_tx 0 11323 NULL
+len_brcmf_vndr_dcmd_hdr_11327_fields len brcmf_vndr_dcmd_hdr 0 11327 NULL
+len_skl_ext_manifest_hdr_11331_fields len skl_ext_manifest_hdr 0 11331 NULL
+page_size_ib_umem_11335_fields page_size ib_umem 0 11335 NULL
+charcount_console_font_11338_fields charcount console_font 0 11338 NULL
+s_sbbase_ufs_sb_private_info_11344_fields s_sbbase ufs_sb_private_info 0 11344 NULL
+update_devnum_fndecl_11348_fields update_devnum fndecl 2 11348 NULL
+vlanid_full_rx_done_desc_11354_fields vlanid full_rx_done_desc 0 11354 NULL
+n_pfns_xen_memory_region_11357_fields n_pfns xen_memory_region 0 11357 NULL
+amdgpu_gem_object_create_fndecl_11366_fields amdgpu_gem_object_create fndecl 2 11366 NULL
+tso_fragment_fndecl_11369_fields tso_fragment fndecl 3 11369 NULL
+build_dpcd_write_fndecl_11376_fields build_dpcd_write fndecl 4 11376 NULL
+xz_dec_init_fndecl_11382_fields xz_dec_init fndecl 2 11382 NULL
+alloc_streams_hc_driver_11390_fields alloc_streams hc_driver 0 11390 NULL
+xfs_alloc_ag_vextent_small_fndecl_11407_fields xfs_alloc_ag_vextent_small fndecl 0 11407 NULL
+setup_data_setup_header_11411_fields setup_data setup_header 0 11411 NULL
+in_args_qlcnic_mailbox_metadata_11413_fields in_args qlcnic_mailbox_metadata 0 11413 NULL
+iso_packets_buffer_init_fndecl_11414_fields iso_packets_buffer_init fndecl 4 11414 NULL
+mc13xxx_add_subdevice_pdata_fndecl_11426_fields mc13xxx_add_subdevice_pdata fndecl 4 11426 NULL
+smt_build_frame_fndecl_11428_fields smt_build_frame fndecl 4 11428 NULL
+rule_cnt_ethtool_rxnfc_11436_fields rule_cnt ethtool_rxnfc 0 11436 NULL nohasharray
+rxBytesRemaining_edgeport_serial_11436_fields rxBytesRemaining edgeport_serial 0 11436 &rule_cnt_ethtool_rxnfc_11436_fields
+sys_preadv2_fndecl_11439_fields sys_preadv2 fndecl 3 11439 NULL
+NFTL_findfreeblock_fndecl_11466_fields NFTL_findfreeblock fndecl 0 11466 NULL
+lower_margin_fb_var_screeninfo_11469_fields lower_margin fb_var_screeninfo 0 11469 NULL
+id_header_size_perf_event_11470_fields id_header_size perf_event 0 11470 NULL
+ieee80211_send_bar_fndecl_11472_fields ieee80211_send_bar fndecl 3 11472 NULL
+hsync_len_videomode_11474_fields hsync_len videomode 0 11474 NULL
+iov_shorten_fndecl_11481_fields iov_shorten fndecl 3 11481 NULL nohasharray
+c_cpos_ocfs2_write_cluster_desc_11481_fields c_cpos ocfs2_write_cluster_desc 0 11481 &iov_shorten_fndecl_11481_fields
+num_crtc_drm_mode_config_11484_fields num_crtc drm_mode_config 0 11484 NULL
+length_RioCommand_11495_fields length RioCommand 0 11495 NULL nohasharray
+get_ablock_fndecl_11495_fields get_ablock fndecl 2 11495 &length_RioCommand_11495_fields
+batadv_max_header_len_fndecl_11496_fields batadv_max_header_len fndecl 0 11496 NULL
+qcaspi_write_burst_fndecl_11497_fields qcaspi_write_burst fndecl 3 11497 NULL
+prepare_write_buffer_usb_serial_driver_11498_fields prepare_write_buffer usb_serial_driver 0 11498 NULL
+w_cpos_ocfs2_write_ctxt_11503_fields w_cpos ocfs2_write_ctxt 0 11503 NULL
+period_bytes_max_snd_pcm_hardware_11507_fields period_bytes_max snd_pcm_hardware 0 11507 NULL
+adau1701_register_size_fndecl_11523_fields adau1701_register_size fndecl 0 11523 NULL
+ccw_putcs_fndecl_11532_fields ccw_putcs fndecl 4-5-6 11532 NULL
+llcp_add_tlv_fndecl_11542_fields llcp_add_tlv fndecl 3 11542 NULL
+screen_height_vardecl_hyperv_fb_c_11550_fields screen_height vardecl_hyperv_fb.c 0 11550 NULL
+dm_startbit_adfs_discmap_11559_fields dm_startbit adfs_discmap 0 11559 NULL
+dataxfer_length_hpt_iop_request_scsi_command_11566_fields dataxfer_length hpt_iop_request_scsi_command 0 11566 NULL
+rec_len_nilfs_dir_entry_11567_fields rec_len nilfs_dir_entry 0 11567 NULL
+cur_transfer_size_s2255_pipeinfo_11571_fields cur_transfer_size s2255_pipeinfo 0 11571 NULL nohasharray
+rx_remain_len_hif_device_usb_11571_fields rx_remain_len hif_device_usb 0 11571 &cur_transfer_size_s2255_pipeinfo_11571_fields
+find_compression_threshold_fndecl_11575_fields find_compression_threshold fndecl 3 11575 NULL nohasharray
+__ocfs2_add_entry_fndecl_11575_fields __ocfs2_add_entry fndecl 4 11575 &find_compression_threshold_fndecl_11575_fields
+ram_header_offset_qxl_rom_11576_fields ram_header_offset qxl_rom 0 11576 NULL
+next_index_jfs_inode_info_11588_fields next_index jfs_inode_info 0 11588 NULL
+add_advertising_fndecl_11602_fields add_advertising fndecl 4 11602 NULL
+prev_free_msdos_sb_info_11603_fields prev_free msdos_sb_info 0 11603 NULL nohasharray
+spi_execute_fndecl_11603_fields spi_execute fndecl 5 11603 &prev_free_msdos_sb_info_11603_fields
+desc_num_hnae_ring_11610_fields desc_num hnae_ring 0 11610 NULL
+frame_length_spi_message_11612_fields frame_length spi_message 0 11612 NULL
+word1_atl1e_recv_ret_status_11620_fields word1 atl1e_recv_ret_status 0 11620 NULL
+btrfs_add_ordered_extent_dio_fndecl_11621_fields btrfs_add_ordered_extent_dio fndecl 4-2-3 11621 NULL
+dataLen_PVSCSIRingCmpDesc_11627_fields dataLen PVSCSIRingCmpDesc 0 11627 NULL
+acpi_register_ioapic_fndecl_11630_fields acpi_register_ioapic fndecl 3 11630 NULL
+posix_acl_init_fndecl_11632_fields posix_acl_init fndecl 2 11632 NULL nohasharray
+peek_head_len_fndecl_11632_fields peek_head_len fndecl 0 11632 &posix_acl_init_fndecl_11632_fields nohasharray
+dtl1_write_fndecl_11632_fields dtl1_write fndecl 0 11632 &peek_head_len_fndecl_11632_fields
+num_mon_ceph_options_11640_fields num_mon ceph_options 0 11640 NULL
+ath6kl_get_num_reg_fndecl_11647_fields ath6kl_get_num_reg fndecl 0 11647 NULL
+bulk_size_cam_11663_fields bulk_size cam 0 11663 NULL
+__setup_root_fndecl_11664_fields __setup_root fndecl 2-1 11664 NULL nohasharray
+num_snd_ratnum_11664_fields num snd_ratnum 0 11664 &__setup_root_fndecl_11664_fields
+align_pnp_mem_11669_fields align pnp_mem 0 11669 NULL
+i915_stolen_to_physical_fndecl_11685_fields i915_stolen_to_physical fndecl 0 11685 NULL nohasharray
+erasesize_mtd_erase_region_info_11685_fields erasesize mtd_erase_region_info 0 11685 &i915_stolen_to_physical_fndecl_11685_fields
+tx_tail_len_pn533_frame_ops_11694_fields tx_tail_len pn533_frame_ops 0 11694 NULL
+stride_efifb_dmi_info_11695_fields stride efifb_dmi_info 0 11695 NULL
+num_rates_wmi_rate_set_arg_11696_fields num_rates wmi_rate_set_arg 0 11696 NULL
+__i2c_read_fndecl_11698_fields __i2c_read fndecl 6-3 11698 NULL
+shared_mic_nid_ca0132_spec_11702_fields shared_mic_nid ca0132_spec 0 11702 NULL
+__vma_reservation_common_fndecl_11707_fields __vma_reservation_common fndecl 3 11707 NULL nohasharray
+mwifiex_debug_mask_write_fndecl_11707_fields mwifiex_debug_mask_write fndecl 3 11707 &__vma_reservation_common_fndecl_11707_fields
+phys_lcr_base__synclinkmp_info_11713_fields phys_lcr_base _synclinkmp_info 0 11713 NULL nohasharray
+logical_packages_vardecl_smpboot_c_11713_fields logical_packages vardecl_smpboot.c 0 11713 &phys_lcr_base__synclinkmp_info_11713_fields
+sizeof_partition_entry__gpt_header_11718_fields sizeof_partition_entry _gpt_header 0 11718 NULL
+ocfs2_write_cluster_fndecl_11719_fields ocfs2_write_cluster fndecl 9 11719 NULL
+ov511_pkt_scan_fndecl_11737_fields ov511_pkt_scan fndecl 3 11737 NULL
+gart_pin_size_radeon_device_11745_fields gart_pin_size radeon_device 0 11745 NULL
+symlink_size_squashfs_symlink_inode_11747_fields symlink_size squashfs_symlink_inode 0 11747 NULL nohasharray
+psn_modify_mask_rvt_driver_params_11747_fields psn_modify_mask rvt_driver_params 0 11747 &symlink_size_squashfs_symlink_inode_11747_fields
+log_num_cqs_mlx4_init_hca_param_11748_fields log_num_cqs mlx4_init_hca_param 0 11748 NULL
+lba_shift_nvme_ns_11763_fields lba_shift nvme_ns 0 11763 NULL nohasharray
+count_nfs_pgio_res_11763_fields count nfs_pgio_res 0 11763 &lba_shift_nvme_ns_11763_fields
+num_mtt_mthca_profile_11767_fields num_mtt mthca_profile 0 11767 NULL
+length_acpi_dmar_header_11768_fields length acpi_dmar_header 0 11768 NULL
+grow_buffers_fndecl_11774_fields grow_buffers fndecl 3-2 11774 NULL
+num_fences_sync_file_11779_fields num_fences sync_file 0 11779 NULL
+pci_scan_child_bus_fndecl_11784_fields pci_scan_child_bus fndecl 0 11784 NULL
+svc_pool_map_init_percpu_fndecl_11792_fields svc_pool_map_init_percpu fndecl 0 11792 NULL nohasharray
+iscsi_sw_tcp_session_create_fndecl_11792_fields iscsi_sw_tcp_session_create fndecl 3 11792 &svc_pool_map_init_percpu_fndecl_11792_fields
+depth_cx23885_fmt_11806_fields depth cx23885_fmt 0 11806 NULL
+max_hw_sectors_queue_limits_11815_fields max_hw_sectors queue_limits 0 11815 NULL nohasharray
+depth_tw686x_format_11815_fields depth tw686x_format 0 11815 &max_hw_sectors_queue_limits_11815_fields nohasharray
+num_resources_nd_namespace_blk_11815_fields num_resources nd_namespace_blk 0 11815 &depth_tw686x_format_11815_fields
+be_change_mtu_fndecl_11828_fields be_change_mtu fndecl 2 11828 NULL
+acpi_allocate_root_table_fndecl_11829_fields acpi_allocate_root_table fndecl 1 11829 NULL
+length_TAG_TW_SG_Entry_ISO_11846_fields length TAG_TW_SG_Entry_ISO 0 11846 NULL
+number_of_packets_urb_11853_fields number_of_packets urb 0 11853 NULL nohasharray
+add_to_page_cache_lru_fndecl_11853_fields add_to_page_cache_lru fndecl 0 11853 &number_of_packets_urb_11853_fields
+s_nsegments_nilfs_super_block_11865_fields s_nsegments nilfs_super_block 0 11865 NULL
+heads_ssfdcr_record_11869_fields heads ssfdcr_record 0 11869 NULL
+domain_child_num_acl_role_label_11875_fields domain_child_num acl_role_label 0 11875 NULL
+dm_btree_lookup_next_fndecl_11876_fields dm_btree_lookup_next fndecl 2 11876 NULL
+idetape_queue_rw_tail_fndecl_11881_fields idetape_queue_rw_tail fndecl 3 11881 NULL
+bochs_dispi_read_fndecl_11885_fields bochs_dispi_read fndecl 0 11885 NULL nohasharray
+leaf_dealloc_fndecl_11885_fields leaf_dealloc fndecl 4 11885 &bochs_dispi_read_fndecl_11885_fields
+num_channels_iw_scan_req_11889_fields num_channels iw_scan_req 0 11889 NULL nohasharray
+create_object_fndecl_11889_fields create_object fndecl 1-2 11889 &num_channels_iw_scan_req_11889_fields
+vfs_read_fndecl_11892_fields vfs_read fndecl 0-3 11892 NULL
+llcp_tlv16_fndecl_11893_fields llcp_tlv16 fndecl 0 11893 NULL
+flaglen_ring_desc_ex_11894_fields flaglen ring_desc_ex 0 11894 NULL
+libipw_change_mtu_fndecl_11901_fields libipw_change_mtu fndecl 2 11901 NULL
+fw_dump_size_scsi_qla_host_11903_fields fw_dump_size scsi_qla_host 0 11903 NULL
+dio_set_defer_completion_fndecl_11916_fields dio_set_defer_completion fndecl 0 11916 NULL
+fw_cfg_p_size_vardecl_qemu_fw_cfg_c_11917_fields fw_cfg_p_size vardecl_qemu_fw_cfg.c 0 11917 NULL
+residual_length_atto_vda_scsi_rsp_11918_fields residual_length atto_vda_scsi_rsp 0 11918 NULL
+p9_fd_read_fndecl_11921_fields p9_fd_read fndecl 0-3 11921 NULL
+tx_buffer_count_hso_serial_11927_fields tx_buffer_count hso_serial 0 11927 NULL
+orig_start_move_extent_11928_fields orig_start move_extent 0 11928 NULL
+length_p_header100_11933_fields length p_header100 0 11933 NULL
+ext4_move_extents_fndecl_11935_fields ext4_move_extents fndecl 5-3-4 11935 NULL
+alloc_low_pages_fndecl_11940_fields alloc_low_pages fndecl 1 11940 NULL
+mss_request_sock_11943_fields mss request_sock 0 11943 NULL
+choose_data_offset_fndecl_11950_fields choose_data_offset fndecl 0 11950 NULL
+max_rdma_atomic_rvt_driver_params_11957_fields max_rdma_atomic rvt_driver_params 0 11957 NULL
+qla4_82xx_pci_set_window_fndecl_11958_fields qla4_82xx_pci_set_window fndecl 0-2 11958 NULL
+per_vf_cids_qed_tm_iids_11959_fields per_vf_cids qed_tm_iids 0 11959 NULL
+bsg_major_vardecl_bsg_c_11972_fields bsg_major vardecl_bsg.c 0 11972 NULL
+pcpu_nr_groups_vardecl_percpu_c_11974_fields pcpu_nr_groups vardecl_percpu.c 0 11974 NULL
+i_xattr_nid_f2fs_inode_info_11976_fields i_xattr_nid f2fs_inode_info 0 11976 NULL
+ath10k_htt_rx_crypto_param_len_fndecl_11982_fields ath10k_htt_rx_crypto_param_len fndecl 0 11982 NULL
+total_mapping_size_fndecl_11985_fields total_mapping_size fndecl 0 11985 NULL
+virtualUnits_INFTLPartition_11994_fields virtualUnits INFTLPartition 0 11994 NULL
+rx_buffer_size_peak_usb_adapter_11997_fields rx_buffer_size peak_usb_adapter 0 11997 NULL
+error_data_insert_op_12006_fields error data_insert_op 0 12006 NULL
+__btrfs_setxattr_fndecl_12010_fields __btrfs_setxattr fndecl 5 12010 NULL
+__nlmsg_put_fndecl_12014_fields __nlmsg_put fndecl 5 12014 NULL nohasharray
+s_next_psn_rvt_qp_12014_fields s_next_psn rvt_qp 0 12014 &__nlmsg_put_fndecl_12014_fields
+br_send_bpdu_fndecl_12022_fields br_send_bpdu fndecl 3 12022 NULL nohasharray
+rfcomm_sock_sendmsg_fndecl_12022_fields rfcomm_sock_sendmsg fndecl 3 12022 &br_send_bpdu_fndecl_12022_fields
+yres_fb_var_screeninfo_12023_fields yres fb_var_screeninfo 0 12023 NULL
+xfs_dir2_sf_addname_easy_fndecl_12024_fields xfs_dir2_sf_addname_easy fndecl 4 12024 NULL
+arm_iommu_create_mapping_fndecl_12027_fields arm_iommu_create_mapping fndecl 3 12027 NULL
+scsi_cmds_max_iscsi_session_12037_fields scsi_cmds_max iscsi_session 0 12037 NULL
+rf_suballoc_bit_ocfs2_refcount_block_12038_fields rf_suballoc_bit ocfs2_refcount_block 0 12038 NULL
+__mm_populate_fndecl_12039_fields __mm_populate fndecl 2-1 12039 NULL
+regsize_si_sm_io_12043_fields regsize si_sm_io 0 12043 NULL
+physical_btrfs_bio_stripe_12047_fields physical btrfs_bio_stripe 0 12047 NULL
+len_brcmf_sdio_hdrinfo_12048_fields len brcmf_sdio_hdrinfo 0 12048 NULL nohasharray
+order_ipr_sglist_12048_fields order ipr_sglist 0 12048 &len_brcmf_sdio_hdrinfo_12048_fields
+prio_io_fndecl_12053_fields prio_io fndecl 2 12053 NULL
+ata_exec_internal_fndecl_12059_fields ata_exec_internal fndecl 6 12059 NULL
+l1oip_law_to_4bit_fndecl_12061_fields l1oip_law_to_4bit fndecl 0 12061 NULL
+bufsize_st5481_in_12064_fields bufsize st5481_in 0 12064 NULL nohasharray
+devm_ioremap_fndecl_12064_fields devm_ioremap fndecl 3-2 12064 &bufsize_st5481_in_12064_fields
+recover_peb_fndecl_12069_fields recover_peb fndecl 7-6 12069 NULL
+count_afs_permits_12072_fields count afs_permits 0 12072 NULL nohasharray
+rw_verify_area_fndecl_12072_fields rw_verify_area fndecl 0 12072 &count_afs_permits_12072_fields
+lirc_register_driver_fndecl_12073_fields lirc_register_driver fndecl 0 12073 NULL
+ttm_pool_update_free_locked_fndecl_12074_fields ttm_pool_update_free_locked fndecl 2 12074 NULL
+cirrus_bo_create_fndecl_12083_fields cirrus_bo_create fndecl 2 12083 NULL
+d_size_size_entry_12084_fields d_size size_entry 0 12084 NULL
+nr_relocs_drm_nouveau_gem_pushbuf_12085_fields nr_relocs drm_nouveau_gem_pushbuf 0 12085 NULL
+security_socket_recvmsg_fndecl_12091_fields security_socket_recvmsg fndecl 0 12091 NULL
+nla_len_nlattr_12092_fields nla_len nlattr 0 12092 NULL nohasharray
+iwl_mvm_check_ratid_empty_fndecl_12092_fields iwl_mvm_check_ratid_empty fndecl 3 12092 &nla_len_nlattr_12092_fields
+n_posix_ace_state_array_12096_fields n posix_ace_state_array 0 12096 NULL
+pad_size_asd_flash_de_12100_fields pad_size asd_flash_de 0 12100 NULL
+lpfc_debugfs_dumpHostSlim_data_fndecl_12108_fields lpfc_debugfs_dumpHostSlim_data fndecl 0 12108 NULL nohasharray
+__ipgre_rcv_fndecl_12108_fields __ipgre_rcv fndecl 4 12108 &lpfc_debugfs_dumpHostSlim_data_fndecl_12108_fields
+mirror_array_cnt_nfs4_ff_layout_segment_12109_fields mirror_array_cnt nfs4_ff_layout_segment 0 12109 NULL
+length_framebuf_12110_fields length framebuf 0 12110 NULL nohasharray
+prism2_set_genericelement_fndecl_12110_fields prism2_set_genericelement fndecl 3 12110 &length_framebuf_12110_fields
+ocfs2_dio_get_block_fndecl_12116_fields ocfs2_dio_get_block fndecl 2 12116 NULL
+vb2_dc_get_userptr_fndecl_12119_fields vb2_dc_get_userptr fndecl 2-3 12119 NULL nohasharray
+get_num_tx_queues_rtnl_link_ops_12119_fields get_num_tx_queues rtnl_link_ops 0 12119 &vb2_dc_get_userptr_fndecl_12119_fields
+super_1_rdev_size_change_fndecl_12120_fields super_1_rdev_size_change fndecl 2 12120 NULL
+ies_len_network_info_12121_fields ies_len network_info 0 12121 NULL
+mwifiex_hscfg_write_fndecl_12125_fields mwifiex_hscfg_write fndecl 3 12125 NULL
+key_size_ccp_rsa_engine_12126_fields key_size ccp_rsa_engine 0 12126 NULL
+ProgRegShift_cfi_intelext_programming_regioninfo_12129_fields ProgRegShift cfi_intelext_programming_regioninfo 0 12129 NULL
+ext4_fiemap_fndecl_12131_fields ext4_fiemap fndecl 4-3 12131 NULL
+metablock_size_btrfsic_state_12137_fields metablock_size btrfsic_state 0 12137 NULL
+writeset_alloc_fndecl_12139_fields writeset_alloc fndecl 2 12139 NULL
+service_name_len_sockaddr_nfc_llcp_12145_fields service_name_len sockaddr_nfc_llcp 0 12145 NULL
+gfs2_rgrp_send_discards_fndecl_12149_fields gfs2_rgrp_send_discards fndecl 2 12149 NULL
+ql_is_link_full_dup_fndecl_12152_fields ql_is_link_full_dup fndecl 0 12152 NULL
+find_block_fndecl_12156_fields find_block fndecl 0-3 12156 NULL
+ip_vs_receive_fndecl_12161_fields ip_vs_receive fndecl 3 12161 NULL
+set_page_fndecl_12165_fields set_page fndecl 0 12165 NULL
+nfs42_proc_copy_fndecl_12169_fields nfs42_proc_copy fndecl 4 12169 NULL nohasharray
+__alloc_ei_netdev_fndecl_12169_fields __alloc_ei_netdev fndecl 1 12169 &nfs42_proc_copy_fndecl_12169_fields
+index_cosm_device_12170_fields index cosm_device 0 12170 NULL
+of_phandle_iterator_next_fndecl_12171_fields of_phandle_iterator_next fndecl 0 12171 NULL
+num_ch_nvm_id_group_12177_fields num_ch nvm_id_group 0 12177 NULL nohasharray
+brcmf_sdio_tx_ctrlframe_fndecl_12177_fields brcmf_sdio_tx_ctrlframe fndecl 3 12177 &num_ch_nvm_id_group_12177_fields
+hsqsize_nvme_rdma_cm_req_12178_fields hsqsize nvme_rdma_cm_req 0 12178 NULL
+rx_count_rx_header_12180_fields rx_count rx_header 0 12180 NULL
+default_file_splice_read_fndecl_12182_fields default_file_splice_read fndecl 4 12182 NULL
+nci_conn_max_data_pkt_payload_size_fndecl_12183_fields nci_conn_max_data_pkt_payload_size fndecl 0 12183 NULL
+se_callback_addr_len_nfsd4_setclientid_12186_fields se_callback_addr_len nfsd4_setclientid 0 12186 NULL
+alignment_acpi_resource_memory24_12188_fields alignment acpi_resource_memory24 0 12188 NULL
+max_qp_sz_mlx4_dev_cap_12189_fields max_qp_sz mlx4_dev_cap 0 12189 NULL
+tipc_max_domain_size_vardecl_12193_fields tipc_max_domain_size vardecl 0 12193 NULL
+handle_gk20a_instobj_dma_12206_fields handle gk20a_instobj_dma 0 12206 NULL
+lmc_crcSize_lmc___softc_12208_fields lmc_crcSize lmc___softc 0 12208 NULL
+length_cifs_io_parms_12209_fields length cifs_io_parms 0 12209 NULL
+vmci_transport_set_min_buffer_size_fndecl_12216_fields vmci_transport_set_min_buffer_size fndecl 2 12216 NULL
+virtscsi_kick_cmd_fndecl_12237_fields virtscsi_kick_cmd fndecl 3-4 12237 NULL
+btrfs_alloc_data_chunk_ondemand_fndecl_12238_fields btrfs_alloc_data_chunk_ondemand fndecl 0 12238 NULL
+generic_file_llseek_size_fndecl_12242_fields generic_file_llseek_size fndecl 2-5 12242 NULL
+synproxy_tstamp_adjust_fndecl_12243_fields synproxy_tstamp_adjust fndecl 2 12243 NULL
+tipc_bearer_mtu_fndecl_12247_fields tipc_bearer_mtu fndecl 0 12247 NULL
+max_pkt_size_em28xx_usb_bufs_12248_fields max_pkt_size em28xx_usb_bufs 0 12248 NULL
+write_block_fndecl_12253_fields write_block fndecl 3 12253 NULL
+hpfs_map_fnode_fndecl_12255_fields hpfs_map_fnode fndecl 2 12255 NULL
+endpoint_snd_usX2Y_substream_12267_fields endpoint snd_usX2Y_substream 0 12267 NULL
+cur_page_len_dio_submit_12271_fields cur_page_len dio_submit 0 12271 NULL
+sb_sectsize_xfs_sb_12294_fields sb_sectsize xfs_sb 0 12294 NULL
+ino_num_inode_management_12296_fields ino_num inode_management 0 12296 NULL
+bm_find_next_fndecl_12298_fields bm_find_next fndecl 0-2 12298 NULL
+size_btrfs_ioctl_logical_ino_args_12299_fields size btrfs_ioctl_logical_ino_args 0 12299 NULL
+max_y_fb_monspecs_12303_fields max_y fb_monspecs 0 12303 NULL
+hib_submit_io_fndecl_12308_fields hib_submit_io fndecl 3 12308 NULL
+hr_blocks_o2hb_region_12318_fields hr_blocks o2hb_region 0 12318 NULL nohasharray
+mthca_max_data_size_fndecl_12318_fields mthca_max_data_size fndecl 0-3 12318 &hr_blocks_o2hb_region_12318_fields
+length_sg_mapping_iter_12324_fields length sg_mapping_iter 0 12324 NULL nohasharray
+sctp_make_abort_violation_fndecl_12324_fields sctp_make_abort_violation fndecl 4 12324 &length_sg_mapping_iter_12324_fields
+ubifs_change_lp_fndecl_12325_fields ubifs_change_lp fndecl 3 12325 NULL
+no_of_triplet_mwifiex_802_11d_domain_reg_12326_fields no_of_triplet mwifiex_802_11d_domain_reg 0 12326 NULL
+s_log_block_size_nilfs_super_block_12332_fields s_log_block_size nilfs_super_block 0 12332 NULL
+read_regr_pi_protocol_12333_fields read_regr pi_protocol 0 12333 NULL
+status_w840_rx_desc_12335_fields status w840_rx_desc 0 12335 NULL nohasharray
+snd_hdac_bus_exec_verb_unlocked_fndecl_12335_fields snd_hdac_bus_exec_verb_unlocked fndecl 0 12335 &status_w840_rx_desc_12335_fields
+out_usbnet_12337_fields out usbnet 0 12337 NULL
+base_shift_iwl_fw_dbg_dest_tlv_12341_fields base_shift iwl_fw_dbg_dest_tlv 0 12341 NULL
+dccps_iss_dccp_sock_12346_fields dccps_iss dccp_sock 0 12346 NULL
+ocfs2_symlink_get_block_fndecl_12352_fields ocfs2_symlink_get_block fndecl 2 12352 NULL
+td_done_fndecl_12358_fields td_done fndecl 0 12358 NULL
+limit_scaled_size_lock_fndecl_12359_fields limit_scaled_size_lock fndecl 5-6 12359 NULL
+ioremap_uc_fndecl_12363_fields ioremap_uc fndecl 2-1 12363 NULL
+xb_blkno_ocfs2_xattr_block_12365_fields xb_blkno ocfs2_xattr_block 0 12365 NULL
+num_subdevs_v4l2_async_notifier_12368_fields num_subdevs v4l2_async_notifier 0 12368 NULL
+xfs_alloc_fixup_trees_fndecl_12372_fields xfs_alloc_fixup_trees fndecl 0 12372 NULL
+iscsi_segment_seek_sg_fndecl_12378_fields iscsi_segment_seek_sg fndecl 5-4 12378 NULL
+rx_prefix_size_efx_nic_12381_fields rx_prefix_size efx_nic 0 12381 NULL
+serial8250_port_size_fndecl_12384_fields serial8250_port_size fndecl 0 12384 NULL nohasharray
+if_usb_host_to_card_fndecl_12384_fields if_usb_host_to_card fndecl 4 12384 &serial8250_port_size_fndecl_12384_fields
+get_packet_pg_fndecl_12388_fields get_packet_pg fndecl 4 12388 NULL
+stb6100_write_reg_range_fndecl_12391_fields stb6100_write_reg_range fndecl 4 12391 NULL nohasharray
+frag_size_mlx4_en_frag_info_12391_fields frag_size mlx4_en_frag_info 0 12391 &stb6100_write_reg_range_fndecl_12391_fields
+data_segment_bytes_gru_create_context_req_12392_fields data_segment_bytes gru_create_context_req 0 12392 NULL
+num_ufbufs_vardecl_12394_fields num_ufbufs vardecl 0 12394 NULL
+buffer_size_zoran_buffer_col_12398_fields buffer_size zoran_buffer_col 0 12398 NULL
+ieee802154_alloc_hw_fndecl_12400_fields ieee802154_alloc_hw fndecl 1 12400 NULL
+acl_len_nfs_setaclargs_12402_fields acl_len nfs_setaclargs 0 12402 NULL
+length_iw_point_12404_fields length iw_point 0 12404 NULL
+reg_read_fndecl_12405_fields reg_read fndecl 4 12405 NULL
+p9_fd_write_fndecl_12417_fields p9_fd_write fndecl 3-0 12417 NULL
+dccp_insert_fn_opt_fndecl_12419_fields dccp_insert_fn_opt fndecl 5 12419 NULL
+len_SL_component_12428_fields len SL_component 0 12428 NULL
+ext4_quota_read_fndecl_12429_fields ext4_quota_read fndecl 5 12429 NULL
+pkey_tbl_len_ib_port_attr_12434_fields pkey_tbl_len ib_port_attr 0 12434 NULL
+hcd_priv_size_hc_driver_12440_fields hcd_priv_size hc_driver 0 12440 NULL
+radix_tree_load_root_fndecl_12442_fields radix_tree_load_root fndecl 0 12442 NULL nohasharray
+informationLength_fileEntry_12442_fields informationLength fileEntry 0 12442 &radix_tree_load_root_fndecl_12442_fields
+divisor_tc_sfq_qopt_12444_fields divisor tc_sfq_qopt 0 12444 NULL
+ie_len_cfg80211_connect_params_12446_fields ie_len cfg80211_connect_params 0 12446 NULL
+ceph_sync_write_fndecl_12447_fields ceph_sync_write fndecl 3-0 12447 NULL nohasharray
+u132_endp_urb_dequeue_fndecl_12447_fields u132_endp_urb_dequeue fndecl 4 12447 &ceph_sync_write_fndecl_12447_fields
+length_iwl_wipan_noa_attribute_12449_fields length iwl_wipan_noa_attribute 0 12449 NULL nohasharray
+GetRecvByte_fndecl_12449_fields GetRecvByte fndecl 0 12449 &length_iwl_wipan_noa_attribute_12449_fields
+len_qlcnic_flt_header_12450_fields len qlcnic_flt_header 0 12450 NULL
+rx_padding_usbatm_driver_12455_fields rx_padding usbatm_driver 0 12455 NULL
+platform_get_irq_fndecl_12459_fields platform_get_irq fndecl 0 12459 NULL
+keyspan_setup_urb_fndecl_12461_fields keyspan_setup_urb fndecl 6-3-2 12461 NULL
+num_cq_mthca_profile_12463_fields num_cq mthca_profile 0 12463 NULL
+tp_block_nr_tpacket_req_12465_fields tp_block_nr tpacket_req 0 12465 NULL
+num_leds_pca9532_chip_info_12471_fields num_leds pca9532_chip_info 0 12471 NULL
+tcp_cong_avoid_ai_fndecl_12478_fields tcp_cong_avoid_ai fndecl 2-3 12478 NULL
+ih_item_len_item_head_12495_fields ih_item_len item_head 0 12495 NULL nohasharray
+vgacon_adjust_height_fndecl_12495_fields vgacon_adjust_height fndecl 2 12495 &ih_item_len_item_head_12495_fields
+blk_update_nr_requests_fndecl_12497_fields blk_update_nr_requests fndecl 2 12497 NULL
+map_off_xfs_dir2_leaf_map_info_12499_fields map_off xfs_dir2_leaf_map_info 0 12499 NULL
+dccp_feat_valid_nn_length_fndecl_12500_fields dccp_feat_valid_nn_length fndecl 0 12500 NULL
+response_length_be_cmd_resp_hdr_12501_fields response_length be_cmd_resp_hdr 0 12501 NULL
+nclips_saa7134_dev_12507_fields nclips saa7134_dev 0 12507 NULL
+udlen_nft_set_12510_fields udlen nft_set 0 12510 NULL
+brcmf_chip_tcm_ramsize_fndecl_12513_fields brcmf_chip_tcm_ramsize fndecl 0 12513 NULL
+max_tchs_cyttsp4_sysinfo_ofs_12516_fields max_tchs cyttsp4_sysinfo_ofs 0 12516 NULL
+madvise_dontneed_fndecl_12517_fields madvise_dontneed fndecl 3-4 12517 NULL
+alloc_skb_with_frags_fndecl_12518_fields alloc_skb_with_frags fndecl 2 12518 NULL nohasharray
+num_pointers_whc_std_12518_fields num_pointers whc_std 0 12518 &alloc_skb_with_frags_fndecl_12518_fields
+video_read_fndecl_12519_fields video_read fndecl 3 12519 NULL
+index_mtd_info_12524_fields index mtd_info 0 12524 NULL
+al_tr_number_to_on_disk_sector_fndecl_12526_fields al_tr_number_to_on_disk_sector fndecl 0 12526 NULL
+depth_fb_image_12530_fields depth fb_image 0 12530 NULL
+lpc_sch_populate_cell_fndecl_12532_fields lpc_sch_populate_cell fndecl 5-4-6 12532 NULL
+write_isowbuf_t_12533_fields write isowbuf_t 0 12533 NULL
+m25p80_read_reg_fndecl_12535_fields m25p80_read_reg fndecl 4 12535 NULL
+qword_get_fndecl_12549_fields qword_get fndecl 0 12549 NULL
+recv_dless_read_fndecl_12554_fields recv_dless_read fndecl 4 12554 NULL
+qnx6_readpages_fndecl_12570_fields qnx6_readpages fndecl 4 12570 NULL
+address_length_acpi_resource_memory32_12576_fields address_length acpi_resource_memory32 0 12576 NULL
+rate_den_snd_pcm_hw_params_12586_fields rate_den snd_pcm_hw_params 0 12586 NULL
+acpi_tb_acquire_temp_table_fndecl_12590_fields acpi_tb_acquire_temp_table fndecl 2 12590 NULL nohasharray
+raid_disk_md_rdev_12590_fields raid_disk md_rdev 0 12590 &acpi_tb_acquire_temp_table_fndecl_12590_fields
+pt1_nr_tables_vardecl_pt1_c_12591_fields pt1_nr_tables vardecl_pt1.c 0 12591 NULL
+pci_scan_root_bus_msi_fndecl_12593_fields pci_scan_root_bus_msi fndecl 2 12593 NULL nohasharray
+offset_rvt_mregion_12593_fields offset rvt_mregion 0 12593 &pci_scan_root_bus_msi_fndecl_12593_fields
+pn544_hci_probe_fndecl_12594_fields pn544_hci_probe fndecl 6-4 12594 NULL
+dev_rsize_hid_device_12597_fields dev_rsize hid_device 0 12597 NULL
+sx_fb_copyarea_12600_fields sx fb_copyarea 0 12600 NULL
+wqe_sz_mlx5e_rq_12601_fields wqe_sz mlx5e_rq 0 12601 NULL
+desc_shift_orangefs_bufmap_12603_fields desc_shift orangefs_bufmap 0 12603 NULL
+blk_limits_io_opt_fndecl_12606_fields blk_limits_io_opt fndecl 2 12606 NULL
+a4t_cs_init_fndecl_12613_fields a4t_cs_init fndecl 3 12613 NULL
+pty_vivid_rds_gen_12619_fields pty vivid_rds_gen 0 12619 NULL
+maxpacket_r8a66597_td_12628_fields maxpacket r8a66597_td 0 12628 NULL
+nilfs_btnode_submit_block_fndecl_12635_fields nilfs_btnode_submit_block fndecl 3-2 12635 NULL nohasharray
+length_wep_key_12635_fields length wep_key 0 12635 &nilfs_btnode_submit_block_fndecl_12635_fields
+xfs_dir2_block_sfsize_fndecl_12636_fields xfs_dir2_block_sfsize fndecl 0 12636 NULL
+pattern_len_cfg80211_pkt_pattern_12639_fields pattern_len cfg80211_pkt_pattern 0 12639 NULL nohasharray
+reg_w_buf_fndecl_12639_fields reg_w_buf fndecl 3 12639 &pattern_len_cfg80211_pkt_pattern_12639_fields
+current_count_sectors_vardecl_floppy_c_12647_fields current_count_sectors vardecl_floppy.c 0 12647 NULL nohasharray
+size_of_pci_range_12647_fields size of_pci_range 0 12647 &current_count_sectors_vardecl_floppy_c_12647_fields
+local_nentries_xpc_openclose_args_12648_fields local_nentries xpc_openclose_args 0 12648 NULL
+fdir_pf_active_filters_i40e_pf_12654_fields fdir_pf_active_filters i40e_pf 0 12654 NULL
+sl_encaps_fndecl_12658_fields sl_encaps fndecl 3 12658 NULL
+get_index_fndecl_12660_fields get_index fndecl 0 12660 NULL
+onenand_transfer_auto_oob_fndecl_12663_fields onenand_transfer_auto_oob fndecl 3 12663 NULL
+linear_hugepage_index_fndecl_12664_fields linear_hugepage_index fndecl 0-2 12664 NULL
+sg_offset_iscsi_segment_12667_fields sg_offset iscsi_segment 0 12667 NULL
+beacon_buf_size_mwifiex_bssdescriptor_12674_fields beacon_buf_size mwifiex_bssdescriptor 0 12674 NULL nohasharray
+last_page_snd_trident_memblk_arg_12674_fields last_page snd_trident_memblk_arg 0 12674 &beacon_buf_size_mwifiex_bssdescriptor_12674_fields
+doorbell_base_kfd_dev_12677_fields doorbell_base kfd_dev 0 12677 NULL
+eeec_entry_sz_mthca_dev_lim_12679_fields eeec_entry_sz mthca_dev_lim 0 12679 NULL
+HST_kyrofb_info_12685_fields HST kyrofb_info 0 12685 NULL
+src_height_tpg_data_12686_fields src_height tpg_data 0 12686 NULL
+ttm_object_file_init_fndecl_12687_fields ttm_object_file_init fndecl 2 12687 NULL
+ns_nsegments_the_nilfs_12690_fields ns_nsegments the_nilfs 0 12690 NULL
+dn_neigh_elist_fndecl_12712_fields dn_neigh_elist fndecl 0 12712 NULL
+total_len_ocrdma_hdr_wqe_12714_fields total_len ocrdma_hdr_wqe 0 12714 NULL
+rdma_rw_init_mr_wrs_fndecl_12719_fields rdma_rw_init_mr_wrs fndecl 7 12719 NULL
+ss_in_channels_hdsp_12726_fields ss_in_channels hdsp 0 12726 NULL nohasharray
+apbt_address_vardecl_apb_timer_c_12726_fields apbt_address vardecl_apb_timer.c 0 12726 &ss_in_channels_hdsp_12726_fields
+btrfs_truncate_item_fndecl_12731_fields btrfs_truncate_item fndecl 3 12731 NULL
+xfs_iomap_write_direct_fndecl_12733_fields xfs_iomap_write_direct fndecl 2 12733 NULL
+count_nfsd3_readres_12745_fields count nfsd3_readres 0 12745 NULL
+aead_assoclen_aead_ctx_12755_fields aead_assoclen aead_ctx 0 12755 NULL nohasharray
+nfsd4_encode_splice_read_fndecl_12755_fields nfsd4_encode_splice_read fndecl 4 12755 &aead_assoclen_aead_ctx_12755_fields
+reserve_memtype_fndecl_12762_fields reserve_memtype fndecl 1-2 12762 NULL
+offset_kcm_rx_msg_12764_fields offset kcm_rx_msg 0 12764 NULL
+wl1251_sdio_read_fndecl_12773_fields wl1251_sdio_read fndecl 4 12773 NULL
+rx_max_pg_ring_bnx2_12789_fields rx_max_pg_ring bnx2 0 12789 NULL
+sb_fseg_start_nilfs_segment_buffer_12802_fields sb_fseg_start nilfs_segment_buffer 0 12802 NULL
+mpage_readpages_fndecl_12807_fields mpage_readpages fndecl 3 12807 NULL
+object_num_mxt_info_12810_fields object_num mxt_info 0 12810 NULL
+psn_rxe_req_info_12812_fields psn rxe_req_info 0 12812 NULL
+new_stripe_sectors_dm_raid_superblock_12813_fields new_stripe_sectors dm_raid_superblock 0 12813 NULL
+subdev_ioctl_fndecl_12818_fields subdev_ioctl fndecl 2 12818 NULL
+xen_pirq_from_irq_fndecl_12820_fields xen_pirq_from_irq fndecl 0 12820 NULL
+__videobuf_mmap_setup_fndecl_12822_fields __videobuf_mmap_setup fndecl 3-0 12822 NULL
+falcon_spi_device_init_fndecl_12835_fields falcon_spi_device_init fndecl 4 12835 NULL
+xfs_rtfind_back_fndecl_12849_fields xfs_rtfind_back fndecl 3-0 12849 NULL
+rx_buffer_size_macb_12864_fields rx_buffer_size macb 0 12864 NULL
+snd_interval_refine_max_fndecl_12865_fields snd_interval_refine_max fndecl 2 12865 NULL
+badblockpos_bbm_info_12867_fields badblockpos bbm_info 0 12867 NULL
+frameoffset_b43legacy_dmaring_12869_fields frameoffset b43legacy_dmaring 0 12869 NULL
+dt_remember_or_free_map_fndecl_12872_fields dt_remember_or_free_map fndecl 5 12872 NULL
+max_ddbs_hw_profile_12873_fields max_ddbs hw_profile 0 12873 NULL
+tcp_remove_reno_sacks_fndecl_12874_fields tcp_remove_reno_sacks fndecl 2 12874 NULL
+rx_buf_size_qede_rx_queue_12878_fields rx_buf_size qede_rx_queue 0 12878 NULL
+length_i2c_hid_cmd_12879_fields length i2c_hid_cmd 0 12879 NULL
+response_length_ib_uverbs_ex_create_cq_resp_12889_fields response_length ib_uverbs_ex_create_cq_resp 0 12889 NULL
+udp_uncompress_fndecl_12890_fields udp_uncompress fndecl 2 12890 NULL
+offset_ceph_dentry_info_12896_fields offset ceph_dentry_info 0 12896 NULL
+early_init_dt_alloc_memory_arch_fndecl_12899_fields early_init_dt_alloc_memory_arch fndecl 2-1 12899 NULL
+ccw_cursor_fndecl_12903_fields ccw_cursor fndecl 4 12903 NULL
+capinc_tty_write_fndecl_12904_fields capinc_tty_write fndecl 3 12904 NULL
+physaddr_hfi1_devdata_12906_fields physaddr hfi1_devdata 0 12906 NULL nohasharray
+add_children_fndecl_12906_fields add_children fndecl 2 12906 &physaddr_hfi1_devdata_12906_fields
+max_reportid_mxt_data_12917_fields max_reportid mxt_data 0 12917 NULL
+m_lblk_ext4_map_blocks_12920_fields m_lblk ext4_map_blocks 0 12920 NULL
+qs_out_channels_hdspm_12922_fields qs_out_channels hdspm 0 12922 NULL
+idetape_mtioctop_fndecl_12923_fields idetape_mtioctop fndecl 3 12923 NULL
+ath6kl_wmi_disconnect_cmd_fndecl_12926_fields ath6kl_wmi_disconnect_cmd fndecl 2 12926 NULL
+asymmetric_verify_fndecl_12932_fields asymmetric_verify fndecl 3 12932 NULL
+ext4_split_extent_at_fndecl_12936_fields ext4_split_extent_at fndecl 4 12936 NULL
+vlan_id_vlan_dev_priv_12939_fields vlan_id vlan_dev_priv 0 12939 NULL
+xlog_clear_stale_blocks_fndecl_12940_fields xlog_clear_stale_blocks fndecl 2 12940 NULL
+phys_pud_init_fndecl_12941_fields phys_pud_init fndecl 0-2-3 12941 NULL
+gfs2_meta_indirect_buffer_fndecl_12942_fields gfs2_meta_indirect_buffer fndecl 3 12942 NULL
+get_rate_snd_ice1712_12947_fields get_rate snd_ice1712 0 12947 NULL
+st_nci_se_io_fndecl_12948_fields st_nci_se_io fndecl 4 12948 NULL
+vb2_dc_attach_dmabuf_fndecl_12950_fields vb2_dc_attach_dmabuf fndecl 3 12950 NULL nohasharray
+nr_segments_blkif_request_rw_12950_fields nr_segments blkif_request_rw 0 12950 &vb2_dc_attach_dmabuf_fndecl_12950_fields
+verity_verify_level_fndecl_12951_fields verity_verify_level fndecl 0 12951 NULL
+dom_size_fndecl_12958_fields dom_size fndecl 0 12958 NULL
+vm_start_vm_area_struct_12960_fields vm_start vm_area_struct 0 12960 NULL
+data_pipe_mts_transfer_context_12962_fields data_pipe mts_transfer_context 0 12962 NULL
+apei_exec_ctx_set_input_fndecl_12968_fields apei_exec_ctx_set_input fndecl 2 12968 NULL
+clone_update_extent_map_fndecl_12984_fields clone_update_extent_map fndecl 4-5 12984 NULL
+rohm_i2c_burst_read_fndecl_12996_fields rohm_i2c_burst_read fndecl 4 12996 NULL
+xdr_reserve_space_fndecl_12997_fields xdr_reserve_space fndecl 2 12997 NULL
+end_file_extent_cluster_13001_fields end file_extent_cluster 0 13001 NULL
+pm3fb_size_memory_fndecl_13002_fields pm3fb_size_memory fndecl 0 13002 NULL
+gfs2_fsync_fndecl_13014_fields gfs2_fsync fndecl 2-3 13014 NULL nohasharray
+mcp795_rtcc_write_fndecl_13014_fields mcp795_rtcc_write fndecl 4 13014 &gfs2_fsync_fndecl_13014_fields
+sg_alloc_table_from_pages_fndecl_13015_fields sg_alloc_table_from_pages fndecl 5-4 13015 NULL
+arg_end_mm_struct_13016_fields arg_end mm_struct 0 13016 NULL
+mp_override_legacy_irq_fndecl_13017_fields mp_override_legacy_irq fndecl 4 13017 NULL
+do_mbind_fndecl_13022_fields do_mbind fndecl 2-1 13022 NULL
+format_supported_num_intel_sdvo_connector_13024_fields format_supported_num intel_sdvo_connector 0 13024 NULL
+__free_memory_core_fndecl_13029_fields __free_memory_core fndecl 0-1-2 13029 NULL
+copy_align_dma_device_13054_fields copy_align dma_device 0 13054 NULL
+sco_sock_recvmsg_fndecl_13055_fields sco_sock_recvmsg fndecl 3 13055 NULL
+hfront_porch_videomode_13056_fields hfront_porch videomode 0 13056 NULL
+p_offset_elf64_phdr_13061_fields p_offset elf64_phdr 0 13061 NULL
+xfs_bunmapi_fndecl_13063_fields xfs_bunmapi fndecl 3-4 13063 NULL
+__ocfs2_dx_dir_leaf_insert_fndecl_13066_fields __ocfs2_dx_dir_leaf_insert fndecl 4 13066 NULL
+read_disk_sb_fndecl_13071_fields read_disk_sb fndecl 2 13071 NULL
+amd756_ioport_vardecl_i2c_amd756_c_13072_fields amd756_ioport vardecl_i2c-amd756.c 0 13072 NULL
+first_p2m_pfn_start_info_13081_fields first_p2m_pfn start_info 0 13081 NULL
+envc_tomoyo_condition_13082_fields envc tomoyo_condition 0 13082 NULL
+c4iw_reject_cr_fndecl_13085_fields c4iw_reject_cr fndecl 3 13085 NULL
+hard_mtu_usbnet_13093_fields hard_mtu usbnet 0 13093 NULL nohasharray
+cursg_ofs_ide_cmd_13093_fields cursg_ofs ide_cmd 0 13093 &hard_mtu_usbnet_13093_fields
+set_wep_key_fndecl_13094_fields set_wep_key fndecl 4 13094 NULL
+ocfs2_cow_sync_writeback_fndecl_13102_fields ocfs2_cow_sync_writeback fndecl 3-4 13102 NULL nohasharray
+user_trans_num_acl_subject_label_13102_fields user_trans_num acl_subject_label 0 13102 &ocfs2_cow_sync_writeback_fndecl_13102_fields
+__qp_memcpy_from_queue_fndecl_13103_fields __qp_memcpy_from_queue fndecl 4-3 13103 NULL
+cx24117_readregN_fndecl_13105_fields cx24117_readregN fndecl 4 13105 NULL
+num_qp_mlx4_profile_13106_fields num_qp mlx4_profile 0 13106 NULL
+au_verfsize_rpc_auth_13110_fields au_verfsize rpc_auth 0 13110 NULL
+wIELength_uwb_rc_evt_drp_WUSB_0100_13117_fields wIELength uwb_rc_evt_drp_WUSB_0100 0 13117 NULL nohasharray
+DecodeMatrix_fndecl_13117_fields DecodeMatrix fndecl 0 13117 &wIELength_uwb_rc_evt_drp_WUSB_0100_13117_fields
+source_pad_adv76xx_state_13133_fields source_pad adv76xx_state 0 13133 NULL
+genwqe_sriov_configure_fndecl_13139_fields genwqe_sriov_configure fndecl 2 13139 NULL
+mousedev_reserve_minor_fndecl_13143_fields mousedev_reserve_minor fndecl 0 13143 NULL
+viafb_bpp_vardecl_viafbdev_c_13145_fields viafb_bpp vardecl_viafbdev.c 0 13145 NULL
+max_response_packet_size_ec_response_get_protocol_info_13148_fields max_response_packet_size ec_response_get_protocol_info 0 13148 NULL
+key_affs_ext_key_13149_fields key affs_ext_key 0 13149 NULL
+calc_available_memory_size_fndecl_13151_fields calc_available_memory_size fndecl 0 13151 NULL
+EraseUnitSize_erase_unit_header_t_13154_fields EraseUnitSize erase_unit_header_t 0 13154 NULL nohasharray
+len_mtd_write_req_13154_fields len mtd_write_req 0 13154 &EraseUnitSize_erase_unit_header_t_13154_fields
+header_size_dw_guc_css_header_13157_fields header_size_dw guc_css_header 0 13157 NULL
+num_pg_nvm_id_group_13160_fields num_pg nvm_id_group 0 13160 NULL
+nr_possible_cpus_uv_hub_info_s_13164_fields nr_possible_cpus uv_hub_info_s 0 13164 NULL
+hpfs_add_to_dnode_fndecl_13167_fields hpfs_add_to_dnode fndecl 4-2 13167 NULL
+len_rsv_13186_fields len rsv 0 13186 NULL nohasharray
+nouveau_compat_ioctl_fndecl_13186_fields nouveau_compat_ioctl fndecl 2 13186 &len_rsv_13186_fields
+blocksize_f2fs_sb_info_13191_fields blocksize f2fs_sb_info 0 13191 NULL
+pos_out_f2fs_move_range_13192_fields pos_out f2fs_move_range 0 13192 NULL
+generic_access_phys_fndecl_13197_fields generic_access_phys fndecl 2-4 13197 NULL
+roots_dm_verity_fec_13203_fields roots dm_verity_fec 0 13203 NULL
+buf_size_in_bytes_kfd_ioctl_dbg_address_watch_args_13210_fields buf_size_in_bytes kfd_ioctl_dbg_address_watch_args 0 13210 NULL
+height_usbtv_13217_fields height usbtv 0 13217 NULL nohasharray
+vmd_find_free_domain_fndecl_13217_fields vmd_find_free_domain fndecl 0 13217 &height_usbtv_13217_fields
+create_boot_cache_fndecl_13218_fields create_boot_cache fndecl 3 13218 NULL
+total_xfer_len_sas_task_13219_fields total_xfer_len sas_task 0 13219 NULL
+ath5k_common_padpos_fndecl_13221_fields ath5k_common_padpos fndecl 0 13221 NULL
+tcp_copy_to_iovec_fndecl_13227_fields tcp_copy_to_iovec fndecl 3 13227 NULL
+len_hi_sigma_action_13229_fields len_hi sigma_action 0 13229 NULL
+mtdram_init_device_fndecl_13236_fields mtdram_init_device fndecl 3 13236 NULL
+ipxitf_alloc_fndecl_13238_fields ipxitf_alloc fndecl 6 13238 NULL
+max_mthca_wq_13240_fields max mthca_wq 0 13240 NULL
+update_sge_fndecl_13245_fields update_sge fndecl 2 13245 NULL
+sq_psn_ib_qp_attr_13249_fields sq_psn ib_qp_attr 0 13249 NULL
+dst_base_apei_exec_context_13252_fields dst_base apei_exec_context 0 13252 NULL
+maxsize_p9_trans_module_13254_fields maxsize p9_trans_module 0 13254 NULL
+drvinfo_sz_rtl8xxxu_rxdesc24_13257_fields drvinfo_sz rtl8xxxu_rxdesc24 0 13257 NULL
+pid_filter_count_dvb_usb_adapter_properties_13258_fields pid_filter_count dvb_usb_adapter_properties 0 13258 NULL
+blocklen_bytes_drbg_core_13259_fields blocklen_bytes drbg_core 0 13259 NULL nohasharray
+maxid_scif_info_13259_fields maxid scif_info 0 13259 &blocklen_bytes_drbg_core_13259_fields
+rsp_pay_size_qlcnic_bc_trans_13274_fields rsp_pay_size qlcnic_bc_trans 0 13274 NULL
+xfs_iomap_write_unwritten_fndecl_13278_fields xfs_iomap_write_unwritten fndecl 3-2 13278 NULL
+status_usb_iso_packet_descriptor_13287_fields status usb_iso_packet_descriptor 0 13287 NULL
+num_bytes_sigma_fw_chunk_control_13289_fields num_bytes sigma_fw_chunk_control 0 13289 NULL
+ioc_plen1_libcfs_ioctl_data_13297_fields ioc_plen1 libcfs_ioctl_data 0 13297 NULL
+sys_writev_fndecl_13299_fields sys_writev fndecl 3 13299 NULL
+alloc_page_buffers_fndecl_13304_fields alloc_page_buffers fndecl 2 13304 NULL
+__vhost_get_user_fndecl_13313_fields __vhost_get_user fndecl 3 13313 NULL
+token_size_iw_ioctl_description_13319_fields token_size iw_ioctl_description 0 13319 NULL
+gfs2_submit_bhs_fndecl_13320_fields gfs2_submit_bhs fndecl 4 13320 NULL
+slhc_uncompress_fndecl_13322_fields slhc_uncompress fndecl 0-3 13322 NULL
+skb_zerocopy_headlen_fndecl_13325_fields skb_zerocopy_headlen fndecl 0 13325 NULL
+ver_tid_offset_hfi1_kdeth_header_13330_fields ver_tid_offset hfi1_kdeth_header 0 13330 NULL
+csum_and_copy_from_iter_fndecl_13338_fields csum_and_copy_from_iter fndecl 2 13338 NULL
+copy_buffer_fndecl_13339_fields copy_buffer fndecl 1-2-3 13339 NULL
+compat_mtw_from_user_fndecl_13351_fields compat_mtw_from_user fndecl 0 13351 NULL
+subctxt_cnt_hfi1_ctxtdata_13355_fields subctxt_cnt hfi1_ctxtdata 0 13355 NULL
+carl9170_handle_mpdu_fndecl_13359_fields carl9170_handle_mpdu fndecl 3 13359 NULL
+data_len_user_sdma_request_13365_fields data_len user_sdma_request 0 13365 NULL nohasharray
+unit_mddev_13365_fields unit mddev 0 13365 &data_len_user_sdma_request_13365_fields
+ihl_iphdr_13367_fields ihl iphdr 0 13367 NULL
+len_nft_payload_set_13371_fields len nft_payload_set 0 13371 NULL
+ep_response_mts_desc_13372_fields ep_response mts_desc 0 13372 NULL
+num_pages_ttm_tt_13376_fields num_pages ttm_tt 0 13376 NULL
+xfs_trans_alloc_fndecl_13381_fields xfs_trans_alloc fndecl 3-0 13381 NULL
+ds_in_channels_hdspm_13382_fields ds_in_channels hdspm 0 13382 NULL
+rules_all_snd_pcm_hw_constraints_13387_fields rules_all snd_pcm_hw_constraints 0 13387 NULL
+chunk_size_lirc_buffer_13388_fields chunk_size lirc_buffer 0 13388 NULL
+beep_amp_conexant_spec_13390_fields beep_amp conexant_spec 0 13390 NULL
+ic_offset_xlog_in_core_13393_fields ic_offset xlog_in_core 0 13393 NULL nohasharray
+cmdsts__BufferDesc_13393_fields cmdsts _BufferDesc 0 13393 &ic_offset_xlog_in_core_13393_fields
+memblock_add_fndecl_13394_fields memblock_add fndecl 1-2 13394 NULL
+nfs42_fallocate_fndecl_13396_fields nfs42_fallocate fndecl 3-4 13396 NULL
+i_size_write_fndecl_13397_fields i_size_write fndecl 2 13397 NULL nohasharray
+mp_payload_len_fcoe_mp_rsp_union_13397_fields mp_payload_len fcoe_mp_rsp_union 0 13397 &i_size_write_fndecl_13397_fields
+microread_probe_fndecl_13400_fields microread_probe fndecl 6-4 13400 NULL nohasharray
+slgt_device_count_vardecl_synclink_gt_c_13400_fields slgt_device_count vardecl_synclink_gt.c 0 13400 &microread_probe_fndecl_13400_fields
+rmmio_base_cirrus_device_13402_fields rmmio_base cirrus_device 0 13402 NULL
+nfs_proc_readlink_fndecl_13404_fields nfs_proc_readlink fndecl 4-3 13404 NULL
+subdevices_count_snd_rawmidi_info_13408_fields subdevices_count snd_rawmidi_info 0 13408 NULL
+add_free_nid_fndecl_13412_fields add_free_nid fndecl 2 13412 NULL
+extra_len_request_13419_fields extra_len request 0 13419 NULL
+cp210x_write_reg_block_fndecl_13420_fields cp210x_write_reg_block fndecl 4 13420 NULL
+i2c_smbus_xfer_fndecl_13421_fields i2c_smbus_xfer fndecl 0 13421 NULL
+tx_headroom_ieee80211_local_13423_fields tx_headroom ieee80211_local 0 13423 NULL
+do_direct_IO_fndecl_13424_fields do_direct_IO fndecl 0 13424 NULL
+mtd_ooblayout_set_bytes_fndecl_13425_fields mtd_ooblayout_set_bytes fndecl 4 13425 NULL
+di_nblocks_xfs_icdinode_13426_fields di_nblocks xfs_icdinode 0 13426 NULL
+get_origin_minimum_chunksize_fndecl_13432_fields get_origin_minimum_chunksize fndecl 0 13432 NULL
+promote_fndecl_13442_fields promote fndecl 4-3 13442 NULL nohasharray
+mwifiex_memrw_write_fndecl_13442_fields mwifiex_memrw_write fndecl 3 13442 &promote_fndecl_13442_fields
+nports_adapter_params_13446_fields nports adapter_params 0 13446 NULL
+fill_read_buf_fndecl_13455_fields fill_read_buf fndecl 0 13455 NULL
+max_eq_mlx4_func_cap_13461_fields max_eq mlx4_func_cap 0 13461 NULL nohasharray
+me_start_ocfs2_move_extents_13461_fields me_start ocfs2_move_extents 0 13461 &max_eq_mlx4_func_cap_13461_fields
+flaglen_ring_desc_13468_fields flaglen ring_desc 0 13468 NULL
+ufs_alloc_fragments_fndecl_13472_fields ufs_alloc_fragments fndecl 2-0 13472 NULL
+height_bttv_fh_13473_fields height bttv_fh 0 13473 NULL
+multipath_end_bh_io_fndecl_13474_fields multipath_end_bh_io fndecl 2 13474 NULL
+req_ie_length_ndis_80211_assoc_info_13477_fields req_ie_length ndis_80211_assoc_info 0 13477 NULL
+n_regulators_da9063_dev_model_13479_fields n_regulators da9063_dev_model 0 13479 NULL
+ext4_convert_unwritten_extents_fndecl_13483_fields ext4_convert_unwritten_extents fndecl 3-4 13483 NULL
+size_jffs2_full_dnode_13487_fields size jffs2_full_dnode 0 13487 NULL
+sk_datalen_svc_sock_13490_fields sk_datalen svc_sock 0 13490 NULL nohasharray
+i_section_size_iso_inode_info_13490_fields i_section_size iso_inode_info 0 13490 &sk_datalen_svc_sock_13490_fields
+dax_dev_pmd_fault_fndecl_13498_fields dax_dev_pmd_fault fndecl 2 13498 NULL
+curchunk_len_drm_dp_sideband_msg_rx_13501_fields curchunk_len drm_dp_sideband_msg_rx 0 13501 NULL
+sendpage_proto_ops_13505_fields sendpage proto_ops 0 13505 NULL
+il4965_txq_check_empty_fndecl_13515_fields il4965_txq_check_empty fndecl 3 13515 NULL
+scif_vreadfrom_fndecl_13516_fields scif_vreadfrom fndecl 4-3 13516 NULL
+len_unix_address_13517_fields len unix_address 0 13517 NULL nohasharray
+max_channels_cmipci_13517_fields max_channels cmipci 0 13517 &len_unix_address_13517_fields
+av_buf_head_dccp_ackvec_13528_fields av_buf_head dccp_ackvec 0 13528 NULL
+max_index_rxe_type_info_13532_fields max_index rxe_type_info 0 13532 NULL
+max_ws_blocks_scsi_disk_13533_fields max_ws_blocks scsi_disk 0 13533 NULL
+find_rsb_nodir_fndecl_13537_fields find_rsb_nodir fndecl 3 13537 NULL
+nes_reg_user_mr_fndecl_13553_fields nes_reg_user_mr fndecl 2-3 13553 NULL nohasharray
+nvme_trans_send_download_fw_cmd_fndecl_13553_fields nvme_trans_send_download_fw_cmd fndecl 4 13553 &nes_reg_user_mr_fndecl_13553_fields
+context_id_fcoe_kwqe_conn_destroy_13555_fields context_id fcoe_kwqe_conn_destroy 0 13555 NULL
+__devcgroup_inode_permission_fndecl_13559_fields __devcgroup_inode_permission fndecl 0 13559 NULL nohasharray
+retrans_out_tcp_sock_13559_fields retrans_out tcp_sock 0 13559 &__devcgroup_inode_permission_fndecl_13559_fields nohasharray
+iomap_apply_fndecl_13559_fields iomap_apply fndecl 0 13559 &retrans_out_tcp_sock_13559_fields
+capture_periodsize_rme96_13564_fields capture_periodsize rme96 0 13564 NULL
+edt_ft5x06_ts_readwrite_fndecl_13570_fields edt_ft5x06_ts_readwrite fndecl 2-4 13570 NULL
+pitch_drm_mode_create_dumb_13574_fields pitch drm_mode_create_dumb 0 13574 NULL nohasharray
+amdtp_stream_get_max_payload_fndecl_13574_fields amdtp_stream_get_max_payload fndecl 0 13574 &pitch_drm_mode_create_dumb_13574_fields
+fd_do_prot_fill_fndecl_13583_fields fd_do_prot_fill fndecl 5-3 13583 NULL
+ring_size_r600_ih_13586_fields ring_size r600_ih 0 13586 NULL
+ceph_renew_caps_fndecl_13593_fields ceph_renew_caps fndecl 0 13593 NULL nohasharray
+lines_nvkm_gpio_func_13593_fields lines nvkm_gpio_func 0 13593 &ceph_renew_caps_fndecl_13593_fields nohasharray
+vfio_info_cap_add_fndecl_13593_fields vfio_info_cap_add fndecl 2 13593 &lines_nvkm_gpio_func_13593_fields
+__skb_flow_dissect_fndecl_13594_fields __skb_flow_dissect fndecl 6 13594 NULL nohasharray
+video_v_start_saa7134_tvnorm_13594_fields video_v_start saa7134_tvnorm 0 13594 &__skb_flow_dissect_fndecl_13594_fields
+sysctl_wmem_default_vardecl_13596_fields sysctl_wmem_default vardecl 0 13596 NULL
+fb_x_vmw_fb_par_13597_fields fb_x vmw_fb_par 0 13597 NULL
+size_drm_mm_node_13605_fields size drm_mm_node 0 13605 NULL
+id_pcap_subdev_13609_fields id pcap_subdev 0 13609 NULL
+size_sm501_mem_13611_fields size sm501_mem 0 13611 NULL
+nvoices_snd_seq_oss_reg_13613_fields nvoices snd_seq_oss_reg 0 13613 NULL
+us122l_start_fndecl_13617_fields us122l_start fndecl 2-3 13617 NULL
+softback_top_vardecl_fbcon_c_13621_fields softback_top vardecl_fbcon.c 0 13621 NULL nohasharray
+mpt_entry_sz_mthca_dev_lim_13621_fields mpt_entry_sz mthca_dev_lim 0 13621 &softback_top_vardecl_fbcon_c_13621_fields
+desc_size_efi_memory_map_13622_fields desc_size efi_memory_map 0 13622 NULL
+num_mgms_mthca_limits_13629_fields num_mgms mthca_limits 0 13629 NULL
+w5100_probe_fndecl_13635_fields w5100_probe fndecl 3 13635 NULL
+x1_drm_clip_rect_13637_fields x1 drm_clip_rect 0 13637 NULL
+xenbus_map_ring_valloc_hvm_fndecl_13638_fields xenbus_map_ring_valloc_hvm fndecl 3 13638 NULL
+nbytes_ata_queued_cmd_13642_fields nbytes ata_queued_cmd 0 13642 NULL
+npools_svc_pool_map_13643_fields npools svc_pool_map 0 13643 NULL nohasharray
+nilfs_compute_checksum_fndecl_13643_fields nilfs_compute_checksum fndecl 6 13643 &npools_svc_pool_map_13643_fields
+number_mdp_device_descriptor_s_13645_fields number mdp_device_descriptor_s 0 13645 NULL
+unicast_mac_count_be_nic_res_desc_13650_fields unicast_mac_count be_nic_res_desc 0 13650 NULL
+page_len_xdr_buf_13652_fields page_len xdr_buf 0 13652 NULL
+width_s2255_vc_13661_fields width s2255_vc 0 13661 NULL
+length_rbd_img_request_13674_fields length rbd_img_request 0 13674 NULL
+vsync_psb_pipe_13675_fields vsync psb_pipe 0 13675 NULL
+fixup_pmc551_fndecl_13679_fields fixup_pmc551 fndecl 0 13679 NULL
+nfc_hci_send_cmd_async_fndecl_13680_fields nfc_hci_send_cmd_async fndecl 5 13680 NULL
+receive_big_fndecl_13686_fields receive_big fndecl 5 13686 NULL
+writing_osst_buffer_13689_fields writing osst_buffer 0 13689 NULL
+hpfs_free_sectors_fndecl_13696_fields hpfs_free_sectors fndecl 3 13696 NULL
+skb_size_qlcnic_host_rds_ring_13698_fields skb_size qlcnic_host_rds_ring 0 13698 NULL
+bos_desc_fndecl_13715_fields bos_desc fndecl 0 13715 NULL
+valuelen_lo_extended_attribute_13722_fields valuelen_lo extended_attribute 0 13722 NULL
+wsm_buf_reserve_fndecl_13730_fields wsm_buf_reserve fndecl 2 13730 NULL
+channels_max_snd_soc_pcm_stream_13737_fields channels_max snd_soc_pcm_stream 0 13737 NULL nohasharray
+mfd_add_device_fndecl_13737_fields mfd_add_device fndecl 6-2 13737 &channels_max_snd_soc_pcm_stream_13737_fields
+nr_segments_vscsiif_request_13741_fields nr_segments vscsiif_request 0 13741 NULL
+len_tcf_em_nbyte_13742_fields len tcf_em_nbyte 0 13742 NULL
+write_pipe_ezusb_priv_13743_fields write_pipe ezusb_priv 0 13743 NULL
+level_guest_walker32_13749_fields level guest_walker32 0 13749 NULL
+length_rio_mport_maint_io_13751_fields length rio_mport_maint_io 0 13751 NULL
+txglomsz_brcmfmac_sdio_pd_13752_fields txglomsz brcmfmac_sdio_pd 0 13752 NULL
+compat_sys_recv_fndecl_13753_fields compat_sys_recv fndecl 3 13753 NULL
+numrx_velocity_opt_13754_fields numrx velocity_opt 0 13754 NULL nohasharray
+length_core_conn_create_data_13754_fields length core_conn_create_data 0 13754 &numrx_velocity_opt_13754_fields
+xfs_alloc_pagf_init_fndecl_13761_fields xfs_alloc_pagf_init fndecl 3-0 13761 NULL
+encrypt_headroom_ieee80211_sub_if_data_13764_fields encrypt_headroom ieee80211_sub_if_data 0 13764 NULL
+ar5523_cmd_read_fndecl_13766_fields ar5523_cmd_read fndecl 4 13766 NULL
+len_nci_set_config_param_13768_fields len nci_set_config_param 0 13768 NULL
+ecryptfs_miscdev_write_fndecl_13772_fields ecryptfs_miscdev_write fndecl 3 13772 NULL
+do_tcp_rcv_fndecl_13775_fields do_tcp_rcv fndecl 3 13775 NULL
+check_extent_to_block_fndecl_13780_fields check_extent_to_block fndecl 2-3 13780 NULL
+ue_size_asd_bios_chim_struct_13782_fields ue_size asd_bios_chim_struct 0 13782 NULL
+build_data_key_fndecl_13784_fields build_data_key fndecl 2 13784 NULL
+num_channels_xilly_endpoint_13791_fields num_channels xilly_endpoint 0 13791 NULL
+tipc_conn_sendmsg_fndecl_13792_fields tipc_conn_sendmsg fndecl 5 13792 NULL
+reply_sz__MPT_ADAPTER_13794_fields reply_sz _MPT_ADAPTER 0 13794 NULL
+riocm_cdev_add_fndecl_13803_fields riocm_cdev_add fndecl 1 13803 NULL
+fifo_size_sram_channel_13811_fields fifo_size sram_channel 0 13811 NULL
+shared_kmem_cache_13812_fields shared kmem_cache 0 13812 NULL
+fifo_depth_fsl_ssi_private_13814_fields fifo_depth fsl_ssi_private 0 13814 NULL
+den_min_snd_ratnum_13815_fields den_min snd_ratnum 0 13815 NULL
+rt6i_nfheader_len_rt6_info_13820_fields rt6i_nfheader_len rt6_info 0 13820 NULL
+phys_pte_init_fndecl_13824_fields phys_pte_init fndecl 0-2-3 13824 NULL
+brcmf_sdio_firmware_callback_fndecl_13829_fields brcmf_sdio_firmware_callback fndecl 4 13829 NULL
+vmem_size_bnxt_ring_struct_13831_fields vmem_size bnxt_ring_struct 0 13831 NULL
+inet6_lookup_fndecl_13832_fields inet6_lookup fndecl 4 13832 NULL
+logical_offset_btrfs_dio_private_13833_fields logical_offset btrfs_dio_private 0 13833 NULL
+acpi_os_get_root_pointer_fndecl_13835_fields acpi_os_get_root_pointer fndecl 0 13835 NULL
+cypress_write_fndecl_13836_fields cypress_write fndecl 4 13836 NULL
+ceph_fallocate_fndecl_13837_fields ceph_fallocate fndecl 4-3 13837 NULL
+nr_vecs_biovec_slab_13838_fields nr_vecs biovec_slab 0 13838 NULL
+init_memory_mapping_fndecl_13840_fields init_memory_mapping fndecl 0 13840 NULL
+resize_user_fndecl_13857_fields resize_user fndecl 3 13857 NULL
+sddr09_read_data_fndecl_13860_fields sddr09_read_data fndecl 2 13860 NULL
+starting_offset_mpt3_diag_read_buffer_13869_fields starting_offset mpt3_diag_read_buffer 0 13869 NULL
+pack_sg_list_fndecl_13874_fields pack_sg_list fndecl 5 13874 NULL
+front_len_ceph_msg_header_13876_fields front_len ceph_msg_header 0 13876 NULL
+gfs2_add_jextent_fndecl_13879_fields gfs2_add_jextent fndecl 2-3 13879 NULL
+analog_ep_bulk_em28xx_13880_fields analog_ep_bulk em28xx 0 13880 NULL
+layers_idr_13889_fields layers idr 0 13889 NULL
+__btt_log_write_fndecl_13893_fields __btt_log_write fndecl 0 13893 NULL
+v9fs_xattr_get_acl_fndecl_13894_fields v9fs_xattr_get_acl fndecl 6 13894 NULL nohasharray
+cblock_per_bio_data_13894_fields cblock per_bio_data 0 13894 &v9fs_xattr_get_acl_fndecl_13894_fields
+s_ncg_ufs_sb_private_info_13899_fields s_ncg ufs_sb_private_info 0 13899 NULL
+do_read_fault_fndecl_13905_fields do_read_fault fndecl 2 13905 NULL
+size_qlcnic_83xx_dump_template_hdr_13912_fields size qlcnic_83xx_dump_template_hdr 0 13912 NULL
+vt_block_vxfs_typed_13924_fields vt_block vxfs_typed 0 13924 NULL
+unix_stream_read_actor_fndecl_13931_fields unix_stream_read_actor fndecl 2-3 13931 NULL
+s_firstdatazone_minix_sb_info_13932_fields s_firstdatazone minix_sb_info 0 13932 NULL
+service_operation_fndecl_13940_fields service_operation fndecl 0 13940 NULL
+kvirt_to_phys_fndecl_13941_fields kvirt_to_phys fndecl 0 13941 NULL
+__usbnet_write_cmd_fndecl_13951_fields __usbnet_write_cmd fndecl 7 13951 NULL
+start_ubifs_bud_13964_fields start ubifs_bud 0 13964 NULL
+u132_hcd_configure_input_recv_fndecl_13969_fields u132_hcd_configure_input_recv fndecl 4 13969 NULL
+nla_append_fndecl_13971_fields nla_append fndecl 2 13971 NULL
+yres_panel_info_13976_fields yres panel_info 0 13976 NULL
+isdn_tty_handleDLEdown_fndecl_13981_fields isdn_tty_handleDLEdown fndecl 0 13981 NULL
+rd_size_uhid_device_13986_fields rd_size uhid_device 0 13986 NULL
+libipw_alloc_txb_fndecl_13992_fields libipw_alloc_txb fndecl 3-2 13992 NULL
+size_urb_list_13995_fields size urb_list 0 13995 NULL
+n_channels_iwl_mcc_update_resp_v1_13997_fields n_channels iwl_mcc_update_resp_v1 0 13997 NULL
+pnp_add_io_resource_fndecl_14000_fields pnp_add_io_resource fndecl 3-2 14000 NULL
+blkno_xfs_da_state_blk_14003_fields blkno xfs_da_state_blk 0 14003 NULL nohasharray
+wanted_disk_byte___prelim_ref_14003_fields wanted_disk_byte __prelim_ref 0 14003 &blkno_xfs_da_state_blk_14003_fields nohasharray
+i_len_xfs_log_iovec_14003_fields i_len xfs_log_iovec 0 14003 &wanted_disk_byte___prelim_ref_14003_fields nohasharray
+nilfs_read_super_root_block_fndecl_14003_fields nilfs_read_super_root_block fndecl 2 14003 &i_len_xfs_log_iovec_14003_fields
+buffer_top_vardecl_nm256_c_14008_fields buffer_top vardecl_nm256.c 0 14008 NULL
+n_phy_mvs_chip_info_14009_fields n_phy mvs_chip_info 0 14009 NULL
+queue_userspace_packet_fndecl_14011_fields queue_userspace_packet fndecl 5 14011 NULL
+__find_max_addr_fndecl_14012_fields __find_max_addr fndecl 0-1 14012 NULL
+e820_update_range_saved_fndecl_14017_fields e820_update_range_saved fndecl 1-2 14017 NULL
+btrfs_find_create_tree_block_fndecl_14018_fields btrfs_find_create_tree_block fndecl 2 14018 NULL
+nct6775_find_fndecl_14019_fields nct6775_find fndecl 0 14019 NULL
+security_enabled_ieee802154_hdr_fc_14024_fields security_enabled ieee802154_hdr_fc 0 14024 NULL
+mst_offs_ubifs_info_14045_fields mst_offs ubifs_info 0 14045 NULL
+nr_perf_callchain_entry_14049_fields nr perf_callchain_entry 0 14049 NULL
+xdr_shift_buf_fndecl_14055_fields xdr_shift_buf fndecl 2 14055 NULL nohasharray
+drbd_recv_fndecl_14055_fields drbd_recv fndecl 3-0 14055 &xdr_shift_buf_fndecl_14055_fields
+add_new_gdb_fndecl_14056_fields add_new_gdb fndecl 3 14056 NULL nohasharray
+nr_ring_pages_blkfront_info_14056_fields nr_ring_pages blkfront_info 0 14056 &add_new_gdb_fndecl_14056_fields
+ocfs2_xattr_ibody_get_fndecl_14057_fields ocfs2_xattr_ibody_get fndecl 0 14057 NULL nohasharray
+xfs_alloc_vextent_fndecl_14057_fields xfs_alloc_vextent fndecl 0 14057 &ocfs2_xattr_ibody_get_fndecl_14057_fields nohasharray
+nl80211_send_connect_result_fndecl_14057_fields nl80211_send_connect_result fndecl 5-7 14057 &xfs_alloc_vextent_fndecl_14057_fields
+btrfs_fallocate_fndecl_14060_fields btrfs_fallocate fndecl 4-3 14060 NULL
+entry_number_user_desc_14065_fields entry_number user_desc 0 14065 NULL nohasharray
+mgmt_device_connected_fndecl_14065_fields mgmt_device_connected fndecl 5 14065 &entry_number_user_desc_14065_fields
+cyttsp_spi_write_block_data_fndecl_14068_fields cyttsp_spi_write_block_data fndecl 4 14068 NULL
+error_async_submit_bio_14075_fields error async_submit_bio 0 14075 NULL
+end_switchdev_vlan_dump_14086_fields end switchdev_vlan_dump 0 14086 NULL
+phantom_major_vardecl_phantom_c_14093_fields phantom_major vardecl_phantom.c 0 14093 NULL
+__ext4_handle_dirty_metadata_fndecl_14098_fields __ext4_handle_dirty_metadata fndecl 0 14098 NULL
+data_len_vscsibk_pend_14106_fields data_len vscsibk_pend 0 14106 NULL
+gue_gro_remcsum_fndecl_14109_fields gue_gro_remcsum fndecl 5-2 14109 NULL
+elem_size_xdr_array2_desc_14114_fields elem_size xdr_array2_desc 0 14114 NULL
+adaption_gsm_dlci_14123_fields adaption gsm_dlci 0 14123 NULL
+size_mlx4_en_rx_ring_14125_fields size mlx4_en_rx_ring 0 14125 NULL
+efd_count_ext4_free_data_14128_fields efd_count ext4_free_data 0 14128 NULL
+i2400m_net_rx_fndecl_14129_fields i2400m_net_rx fndecl 5 14129 NULL
+size_uhid_input2_req_14140_fields size uhid_input2_req 0 14140 NULL
+cros_ec_spi_receive_packet_fndecl_14142_fields cros_ec_spi_receive_packet fndecl 2 14142 NULL
+vmcoreinfo_size_vardecl_14149_fields vmcoreinfo_size vardecl 0 14149 NULL
+dqi_entry_size_qtree_mem_dqinfo_14150_fields dqi_entry_size qtree_mem_dqinfo 0 14150 NULL
+short_len_fat_ioctl_filldir_callback_14151_fields short_len fat_ioctl_filldir_callback 0 14151 NULL
+page_size_at24_platform_data_14152_fields page_size at24_platform_data 0 14152 NULL
+num_ratios_coreclk_soc_desc_14154_fields num_ratios coreclk_soc_desc 0 14154 NULL
+range_min_regmap_range_node_14166_fields range_min regmap_range_node 0 14166 NULL
+vfs_writev_fndecl_14168_fields vfs_writev fndecl 3 14168 NULL
+ocfs2_read_blocks_sync_fndecl_14169_fields ocfs2_read_blocks_sync fndecl 2 14169 NULL
+cmd_len_scsi_cmnd_14171_fields cmd_len scsi_cmnd 0 14171 NULL nohasharray
+nd_size_in_nd_cmd_pkg_14171_fields nd_size_in nd_cmd_pkg 0 14171 &cmd_len_scsi_cmnd_14171_fields
+ath6kl_wmi_sync_point_fndecl_14172_fields ath6kl_wmi_sync_point fndecl 2 14172 NULL
+len_hermes_idstring_14173_fields len hermes_idstring 0 14173 NULL
+brcmf_usb_recv_ctl_fndecl_14174_fields brcmf_usb_recv_ctl fndecl 3 14174 NULL
+__conn_send_command_fndecl_14180_fields __conn_send_command fndecl 4-6 14180 NULL
+cmbox_vardecl_rio_cm_c_14182_fields cmbox vardecl_rio_cm.c 0 14182 NULL
+curr_tx_buf_size_mwifiex_adapter_14186_fields curr_tx_buf_size mwifiex_adapter 0 14186 NULL
+cfpkt_add_trail_fndecl_14191_fields cfpkt_add_trail fndecl 3 14191 NULL
+rxrpc_request_key_fndecl_14192_fields rxrpc_request_key fndecl 3 14192 NULL
+offset_iscsi_datain_14195_fields offset iscsi_datain 0 14195 NULL
+middle_len_ceph_msg_header_14196_fields middle_len ceph_msg_header 0 14196 NULL
+len_hv_multipage_buffer_14208_fields len hv_multipage_buffer 0 14208 NULL nohasharray
+get_rx_fifo_content_fndecl_14208_fields get_rx_fifo_content fndecl 0 14208 &len_hv_multipage_buffer_14208_fields
+cmd_bounce_size_vmw_sw_context_14217_fields cmd_bounce_size vmw_sw_context 0 14217 NULL
+num_gsm_mux_14221_fields num gsm_mux 0 14221 NULL
+e1000_copybreak_fndecl_14223_fields e1000_copybreak fndecl 3 14223 NULL
+hpfs_remove_dtree_fndecl_14224_fields hpfs_remove_dtree fndecl 2 14224 NULL
+hw_token_fotg210_qtd_14233_fields hw_token fotg210_qtd 0 14233 NULL
+create_lease_size_smb_version_values_14240_fields create_lease_size smb_version_values 0 14240 NULL
+backup_load_addr_kimage_arch_14243_fields backup_load_addr kimage_arch 0 14243 NULL nohasharray
+ath6kl_wmi_test_cmd_fndecl_14243_fields ath6kl_wmi_test_cmd fndecl 3 14243 &backup_load_addr_kimage_arch_14243_fields nohasharray
+virtqueue_add_inbuf_fndecl_14243_fields virtqueue_add_inbuf fndecl 3 14243 &ath6kl_wmi_test_cmd_fndecl_14243_fields
+write_buf_fndecl_14247_fields write_buf fndecl 3 14247 NULL
+__wmi_send_fndecl_14259_fields __wmi_send fndecl 4 14259 NULL nohasharray
+cy8ctmg110_read_regs_fndecl_14259_fields cy8ctmg110_read_regs fndecl 3 14259 &__wmi_send_fndecl_14259_fields nohasharray
+octeon_allocate_device_mem_fndecl_14259_fields octeon_allocate_device_mem fndecl 2 14259 &cy8ctmg110_read_regs_fndecl_14259_fields
+nr_blocks_msc_window_14262_fields nr_blocks msc_window 0 14262 NULL
+size_drm_scatter_gather_14264_fields size drm_scatter_gather 0 14264 NULL
+nilfs_sufile_block_get_segment_usage_fndecl_14278_fields nilfs_sufile_block_get_segment_usage fndecl 2 14278 NULL
+transfer_spi_master_14283_fields transfer spi_master 0 14283 NULL
+yscroll_display_14301_fields yscroll display 0 14301 NULL
+size_ldt_struct_14303_fields size ldt_struct 0 14303 NULL
+scif_p2p_setsg_fndecl_14314_fields scif_p2p_setsg fndecl 2 14314 NULL
+udf_table_prealloc_blocks_fndecl_14325_fields udf_table_prealloc_blocks fndecl 0-5 14325 NULL
+gfn_kvm_mmu_page_14326_fields gfn kvm_mmu_page 0 14326 NULL
+rhf_hfi1_packet_14327_fields rhf hfi1_packet 0 14327 NULL
+ath6kl_wmi_ap_profile_commit_fndecl_14329_fields ath6kl_wmi_ap_profile_commit fndecl 2 14329 NULL
+data_offset_md_rdev_14330_fields data_offset md_rdev 0 14330 NULL
+mask_myri10ge_rx_buf_14339_fields mask myri10ge_rx_buf 0 14339 NULL
+loop_start_patch_info_14350_fields loop_start patch_info 0 14350 NULL
+vnet_hdr_sz_macvtap_queue_14351_fields vnet_hdr_sz macvtap_queue 0 14351 NULL
+do_sys_truncate_fndecl_14355_fields do_sys_truncate fndecl 2 14355 NULL
+current_committed_pstore_14356_fields current_committed pstore 0 14356 NULL
+blkno_attrlist_cursor_kern_14361_fields blkno attrlist_cursor_kern 0 14361 NULL
+max_tokens_iw_ioctl_description_14373_fields max_tokens iw_ioctl_description 0 14373 NULL nohasharray
+do_jffs2_setxattr_fndecl_14373_fields do_jffs2_setxattr fndecl 5 14373 &max_tokens_iw_ioctl_description_14373_fields nohasharray
+dm_bufio_get_fndecl_14373_fields dm_bufio_get fndecl 2 14373 &do_jffs2_setxattr_fndecl_14373_fields
+length_scsiif_request_segment_14376_fields length scsiif_request_segment 0 14376 NULL
+start_extent_map_14377_fields start extent_map 0 14377 NULL
+num_phys__sas_node_14384_fields num_phys _sas_node 0 14384 NULL
+blks_per_lun_nvm_dev_14387_fields blks_per_lun nvm_dev 0 14387 NULL nohasharray
+word15_lpfc_mbx_read_config_14387_fields word15 lpfc_mbx_read_config 0 14387 &blks_per_lun_nvm_dev_14387_fields
+dma_in_iguanair_14391_fields dma_in iguanair 0 14391 NULL
+sisusbcon_scroll_area_fndecl_14392_fields sisusbcon_scroll_area fndecl 3-4 14392 NULL
+run_delalloc_nocow_fndecl_14395_fields run_delalloc_nocow fndecl 3-4 14395 NULL
+jffs2_add_physical_node_ref_fndecl_14406_fields jffs2_add_physical_node_ref fndecl 3-2 14406 NULL
+min_snd_interval_14412_fields min snd_interval 0 14412 NULL nohasharray
+rl_space_gfs2_rgrp_list_14412_fields rl_space gfs2_rgrp_list 0 14412 &min_snd_interval_14412_fields nohasharray
+crtc_hblank_start_drm_display_mode_14412_fields crtc_hblank_start drm_display_mode 0 14412 &rl_space_gfs2_rgrp_list_14412_fields
+num_channels_hsi_config_14414_fields num_channels hsi_config 0 14414 NULL
+bigdirlen_adfs_bigdirentry_14420_fields bigdirlen adfs_bigdirentry 0 14420 NULL
+xlog_recover_process_one_iunlink_fndecl_14426_fields xlog_recover_process_one_iunlink fndecl 2 14426 NULL
+snd_cwnd_used_tcp_sock_14431_fields snd_cwnd_used tcp_sock 0 14431 NULL
+up_cfg80211_dscp_exception_14433_fields up cfg80211_dscp_exception 0 14433 NULL
+offset_brcmf_vndr_dcmd_hdr_14440_fields offset brcmf_vndr_dcmd_hdr 0 14440 NULL
+size_dictionary_14455_fields size dictionary 0 14455 NULL
+residual_data_length_pmcraid_ioasa_14459_fields residual_data_length pmcraid_ioasa 0 14459 NULL
+skb_to_sgvec_nomark_fndecl_14461_fields skb_to_sgvec_nomark fndecl 4-3 14461 NULL
+data_inp_ep_vub300_mmc_host_14468_fields data_inp_ep vub300_mmc_host 0 14468 NULL
+ntfs_sync_mft_mirror_fndecl_14470_fields ntfs_sync_mft_mirror fndecl 2 14470 NULL
+lpfc_sli_probe_sriov_nr_virtfn_fndecl_14471_fields lpfc_sli_probe_sriov_nr_virtfn fndecl 2 14471 NULL
+cache_nat_entry_fndecl_14475_fields cache_nat_entry fndecl 2 14475 NULL nohasharray
+num_chn_netvsc_device_14475_fields num_chn netvsc_device 0 14475 &cache_nat_entry_fndecl_14475_fields nohasharray
+rdmarc_entry_sz_mlx4_dev_cap_14475_fields rdmarc_entry_sz mlx4_dev_cap 0 14475 &num_chn_netvsc_device_14475_fields
+groups_netlink_table_14476_fields groups netlink_table 0 14476 NULL
+acpi_hw_get_access_bit_width_fndecl_14478_fields acpi_hw_get_access_bit_width fndecl 0-2 14478 NULL nohasharray
+t1_change_mtu_fndecl_14478_fields t1_change_mtu fndecl 2 14478 &acpi_hw_get_access_bit_width_fndecl_14478_fields
+len_nci_cmd_param_14480_fields len nci_cmd_param 0 14480 NULL
+rx_unit_if_sdio_card_14483_fields rx_unit if_sdio_card 0 14483 NULL
+ntfs_perform_write_fndecl_14496_fields ntfs_perform_write fndecl 3-0 14496 NULL
+btrfs_lookup_bio_sums_dio_fndecl_14498_fields btrfs_lookup_bio_sums_dio fndecl 4 14498 NULL
+free_area_init_node_fndecl_14500_fields free_area_init_node fndecl 3 14500 NULL
+num_vq_mic_device_desc_14503_fields num_vq mic_device_desc 0 14503 NULL
+end_code_mm_struct_14519_fields end_code mm_struct 0 14519 NULL
+viafb_second_offset_vardecl_viafbdev_c_14533_fields viafb_second_offset vardecl_viafbdev.c 0 14533 NULL
+size_ichxrom_window_14540_fields size ichxrom_window 0 14540 NULL
+len_extent_info_14542_fields len extent_info 0 14542 NULL
+ieee80211_get_hdrlen_from_skb_fndecl_14543_fields ieee80211_get_hdrlen_from_skb fndecl 0 14543 NULL
+word17_lpfc_mbx_read_config_14545_fields word17 lpfc_mbx_read_config 0 14545 NULL nohasharray
+ctrl_set_croph_fndecl_14545_fields ctrl_set_croph fndecl 3 14545 &word17_lpfc_mbx_read_config_14545_fields
+snd_ftu_create_effect_switch_fndecl_14546_fields snd_ftu_create_effect_switch fndecl 3-2 14546 NULL
+lsave_cnt_ubifs_info_14547_fields lsave_cnt ubifs_info 0 14547 NULL
+len_btrfsic_block_data_ctx_14548_fields len btrfsic_block_data_ctx 0 14548 NULL
+__alloc_memory_core_early_fndecl_14550_fields __alloc_memory_core_early fndecl 3-4-5 14550 NULL nohasharray
+bus_shift_altera_uart_platform_uart_14550_fields bus_shift altera_uart_platform_uart 0 14550 &__alloc_memory_core_early_fndecl_14550_fields
+rn_snamelen_nfsd4_rename_14552_fields rn_snamelen nfsd4_rename 0 14552 NULL
+size_tso_t_14553_fields size tso_t 0 14553 NULL
+set_ep_max_packet_size_fndecl_14569_fields set_ep_max_packet_size fndecl 3 14569 NULL
+data_sector_size_mmc_ext_csd_14571_fields data_sector_size mmc_ext_csd 0 14571 NULL
+buffer_size_ncp_server_14574_fields buffer_size ncp_server 0 14574 NULL
+acpi_io_base_intel_pmc_ipc_dev_14580_fields acpi_io_base intel_pmc_ipc_dev 0 14580 NULL
+btrfs_wait_ordered_range_fndecl_14581_fields btrfs_wait_ordered_range fndecl 2-3 14581 NULL
+be_length_pnfs_block_extent_14586_fields be_length pnfs_block_extent 0 14586 NULL
+link_pipe_fndecl_14595_fields link_pipe fndecl 3 14595 NULL
+static_start_pccard_mem_map_14601_fields static_start pccard_mem_map 0 14601 NULL
+nes_netdev_change_mtu_fndecl_14604_fields nes_netdev_change_mtu fndecl 2 14604 NULL
+__get_user_pages_fndecl_14607_fields __get_user_pages fndecl 0-3 14607 NULL
+mqd_size_aligned_kfd_device_info_14609_fields mqd_size_aligned kfd_device_info 0 14609 NULL nohasharray
+get_next_sit_page_fndecl_14609_fields get_next_sit_page fndecl 2 14609 &mqd_size_aligned_kfd_device_info_14609_fields nohasharray
+skb_split_fndecl_14609_fields skb_split fndecl 3 14609 &get_next_sit_page_fndecl_14609_fields
+alb_send_lp_vid_fndecl_14613_fields alb_send_lp_vid fndecl 4 14613 NULL
+recv_bulk_pipe_us_data_14615_fields recv_bulk_pipe us_data 0 14615 NULL
+node_scif_dev_14623_fields node scif_dev 0 14623 NULL
+length_comedi_lrange_14641_fields length comedi_lrange 0 14641 NULL
+SSIDsize_bss_info_14644_fields SSIDsize bss_info 0 14644 NULL
+dln2_gpio_get_pin_count_fndecl_14646_fields dln2_gpio_get_pin_count fndecl 0 14646 NULL
+endpoint_usbdevfs_urb_14649_fields endpoint usbdevfs_urb 0 14649 NULL
+tid_ieee80211_ampdu_params_14651_fields tid ieee80211_ampdu_params 0 14651 NULL
+get_sb_block_fndecl_14653_fields get_sb_block fndecl 0 14653 NULL nohasharray
+write_dst_fndecl_14653_fields write_dst fndecl 3 14653 &get_sb_block_fndecl_14653_fields
+wNdpOutAlignment_usb_cdc_ncm_ntb_parameters_14656_fields wNdpOutAlignment usb_cdc_ncm_ntb_parameters 0 14656 NULL
+__btrfs_qgroup_release_data_fndecl_14664_fields __btrfs_qgroup_release_data fndecl 2-3 14664 NULL
+log_pmtu_rvt_qp_14669_fields log_pmtu rvt_qp 0 14669 NULL
+ext2_try_to_allocate_fndecl_14672_fields ext2_try_to_allocate fndecl 0-4 14672 NULL
+sg_tablesize_usb_bus_14673_fields sg_tablesize usb_bus 0 14673 NULL
+aircable_prepare_write_buffer_fndecl_14678_fields aircable_prepare_write_buffer fndecl 3 14678 NULL
+file_size_squashfs_reg_inode_14679_fields file_size squashfs_reg_inode 0 14679 NULL
+x86_virt_bits_cpuinfo_x86_14680_fields x86_virt_bits cpuinfo_x86 0 14680 NULL
+mtu_vnic_devcmd_notify_14682_fields mtu vnic_devcmd_notify 0 14682 NULL
+rx_queue_entry_next_fndecl_14688_fields rx_queue_entry_next fndecl 0 14688 NULL
+max_srq_sge_ib_device_attr_14690_fields max_srq_sge ib_device_attr 0 14690 NULL
+smt_fill_path_fndecl_14692_fields smt_fill_path fndecl 0 14692 NULL
+ttm_tt_init_fndecl_14694_fields ttm_tt_init fndecl 3 14694 NULL
+sq_depth_p9_rdma_opts_14698_fields sq_depth p9_rdma_opts 0 14698 NULL
+__do_fault_fndecl_14700_fields __do_fault fndecl 2 14700 NULL
+__alloc_bootmem_low_node_fndecl_14701_fields __alloc_bootmem_low_node fndecl 3-4 14701 NULL
+AdapterFibsSize_aac_init_14712_fields AdapterFibsSize aac_init 0 14712 NULL
+p_fill_from_dev_buffer_fndecl_14716_fields p_fill_from_dev_buffer fndecl 4-3 14716 NULL
+ftop_swregs_state_14719_fields ftop swregs_state 0 14719 NULL
+frag_id_qede_agg_info_14725_fields frag_id qede_agg_info 0 14725 NULL
+mmc_spi_data_do_fndecl_14728_fields mmc_spi_data_do fndecl 4 14728 NULL
+or51132_writebuf_fndecl_14730_fields or51132_writebuf fndecl 3 14730 NULL
+hdrlen_ppp_file_14734_fields hdrlen ppp_file 0 14734 NULL nohasharray
+ath9k_htc_rx_msg_fndecl_14734_fields ath9k_htc_rx_msg fndecl 3 14734 &hdrlen_ppp_file_14734_fields
+ext2_find_near_fndecl_14741_fields ext2_find_near fndecl 0 14741 NULL nohasharray
+channels_usb_mixer_elem_info_14741_fields channels usb_mixer_elem_info 0 14741 &ext2_find_near_fndecl_14741_fields
+mcs_unwrap_fir_fndecl_14742_fields mcs_unwrap_fir fndecl 3 14742 NULL
+cifs_read_from_socket_fndecl_14743_fields cifs_read_from_socket fndecl 0-3 14743 NULL
+mlx4_alloc_icm_coherent_fndecl_14745_fields mlx4_alloc_icm_coherent fndecl 3 14745 NULL
+ivtvfb_prep_frame_fndecl_14770_fields ivtvfb_prep_frame fndecl 5 14770 NULL
+size_snd_seq_pool_14782_fields size snd_seq_pool 0 14782 NULL
+xfs_alloc_ag_vextent_exact_fndecl_14785_fields xfs_alloc_ag_vextent_exact fndecl 0 14785 NULL
+dev_cmd_headroom_iwl_trans_14787_fields dev_cmd_headroom iwl_trans 0 14787 NULL
+td_fill_fndecl_14788_fields td_fill fndecl 3 14788 NULL
+brcmf_sdio_verifymemory_fndecl_14795_fields brcmf_sdio_verifymemory fndecl 4-2 14795 NULL nohasharray
+snd_ssthresh_tcp_sock_14795_fields snd_ssthresh tcp_sock 0 14795 &brcmf_sdio_verifymemory_fndecl_14795_fields
+mthca_map_user_db_fndecl_14796_fields mthca_map_user_db fndecl 5 14796 NULL
+alloc_component_match_14799_fields alloc component_match 0 14799 NULL
+sb_max_fwd_alloc_hpfs_sb_info_14807_fields sb_max_fwd_alloc hpfs_sb_info 0 14807 NULL
+nr_sectors_fat_floppy_defaults_14809_fields nr_sectors fat_floppy_defaults 0 14809 NULL
+read_fn_xusb_udc_14819_fields read_fn xusb_udc 0 14819 NULL
+wDescriptorLength_hid_descriptor_14825_fields wDescriptorLength hid_descriptor 0 14825 NULL
+tg3_change_mtu_fndecl_14826_fields tg3_change_mtu fndecl 2 14826 NULL
+residual_length_response_14830_fields residual_length response 0 14830 NULL
+sis5595_base_vardecl_i2c_sis5595_c_14832_fields sis5595_base vardecl_i2c-sis5595.c 0 14832 NULL
+shift_arg_pages_fndecl_14835_fields shift_arg_pages fndecl 2 14835 NULL
+vram_contig_size_vml_info_14851_fields vram_contig_size vml_info 0 14851 NULL
+sample_rate_max_lola_14860_fields sample_rate_max lola 0 14860 NULL
+channels_cea_sad_14862_fields channels cea_sad 0 14862 NULL
+verity_hash_for_block_fndecl_14864_fields verity_hash_for_block fndecl 0 14864 NULL
+iwl_pcie_alloc_fw_monitor_fndecl_14872_fields iwl_pcie_alloc_fw_monitor fndecl 2 14872 NULL
+pg_first_page_collect_14888_fields pg_first page_collect 0 14888 NULL
+invalidate_inode_pages2_range_fndecl_14896_fields invalidate_inode_pages2_range fndecl 0-3 14896 NULL
+crtc_vsync_end_drm_display_mode_14898_fields crtc_vsync_end drm_display_mode 0 14898 NULL
+nkeys_tc_pedit_sel_14899_fields nkeys tc_pedit_sel 0 14899 NULL
+len_move_extent_14902_fields len move_extent 0 14902 NULL
+ntty_write_fndecl_14903_fields ntty_write fndecl 3 14903 NULL
+vringh_init_user_fndecl_14905_fields vringh_init_user fndecl 3 14905 NULL
+entry_size_neigh_table_14911_fields entry_size neigh_table 0 14911 NULL
+in_pipe_usbtest_dev_14914_fields in_pipe usbtest_dev 0 14914 NULL
+blocksize_bcma_sflash_tbl_e_14917_fields blocksize bcma_sflash_tbl_e 0 14917 NULL
+pskb_carve_inside_nonlinear_fndecl_14925_fields pskb_carve_inside_nonlinear fndecl 2-3 14925 NULL
+e1000_frag_len_fndecl_14930_fields e1000_frag_len fndecl 0 14930 NULL
+insert_mappable_node_fndecl_14938_fields insert_mappable_node fndecl 3 14938 NULL nohasharray
+get_allocated_memblock_reserved_regions_info_fndecl_14938_fields get_allocated_memblock_reserved_regions_info fndecl 0 14938 &insert_mappable_node_fndecl_14938_fields
+decrypted_datalen_encrypted_key_payload_14939_fields decrypted_datalen encrypted_key_payload 0 14939 NULL
+len_hif_scatter_item_14940_fields len hif_scatter_item 0 14940 NULL
+tailout_ignore_xpnet_message_14949_fields tailout_ignore xpnet_message 0 14949 NULL
+dvb_ca_en50221_io_ioctl_fndecl_14953_fields dvb_ca_en50221_io_ioctl fndecl 2 14953 NULL
+ext4_mb_get_buddy_page_lock_fndecl_14972_fields ext4_mb_get_buddy_page_lock fndecl 0 14972 NULL
+l2cap_build_conf_req_fndecl_14978_fields l2cap_build_conf_req fndecl 0 14978 NULL
+romfs_iget_fndecl_14980_fields romfs_iget fndecl 2 14980 NULL
+fuse_read_update_size_fndecl_14982_fields fuse_read_update_size fndecl 2 14982 NULL
+canon_head_n_tty_data_14983_fields canon_head n_tty_data 0 14983 NULL nohasharray
+icv_len_ieee80211_key_conf_14983_fields icv_len ieee80211_key_conf 0 14983 &canon_head_n_tty_data_14983_fields
+raid_disks_raid_set_14993_fields raid_disks raid_set 0 14993 NULL
+drbd_bm_words_fndecl_15003_fields drbd_bm_words fndecl 0 15003 NULL
+alloc_gtt_mem_fndecl_15005_fields alloc_gtt_mem fndecl 2 15005 NULL
+cxgbi_ddp_ppm_setup_fndecl_15008_fields cxgbi_ddp_ppm_setup fndecl 4 15008 NULL
+buffers_ivtv_stream_15020_fields buffers ivtv_stream 0 15020 NULL
+macvtap_do_read_fndecl_15021_fields macvtap_do_read fndecl 0 15021 NULL
+iotlb_access_ok_fndecl_15032_fields iotlb_access_ok fndecl 3 15032 NULL
+saddr_fsl_edma_hw_tcd_15034_fields saddr fsl_edma_hw_tcd 0 15034 NULL
+orangefs_inode_getxattr_fndecl_15036_fields orangefs_inode_getxattr fndecl 0 15036 NULL
+num_rar_entries_ixgbe_mac_info_15039_fields num_rar_entries ixgbe_mac_info 0 15039 NULL
+mpeglines_vardecl_cx23885_417_c_15042_fields mpeglines vardecl_cx23885-417.c 0 15042 NULL nohasharray
+partitionStartingLocation_partitionDesc_15042_fields partitionStartingLocation partitionDesc 0 15042 &mpeglines_vardecl_cx23885_417_c_15042_fields
+dec_pending_fndecl_15045_fields dec_pending fndecl 2 15045 NULL
+handle_event_fsnotify_ops_15054_fields handle_event fsnotify_ops 0 15054 NULL nohasharray
+buf_len_htc_packet_15054_fields buf_len htc_packet 0 15054 &handle_event_fsnotify_ops_15054_fields
+tpacket_parse_header_fndecl_15057_fields tpacket_parse_header fndecl 0 15057 NULL
+sc_netid_len_nfs4_setclientid_15059_fields sc_netid_len nfs4_setclientid 0 15059 NULL
+height_cx2341x_handler_15060_fields height cx2341x_handler 0 15060 NULL
+num_widgets_snd_soc_dapm_widget_list_15064_fields num_widgets snd_soc_dapm_widget_list 0 15064 NULL
+vid_hdr_alsize_ubi_device_15065_fields vid_hdr_alsize ubi_device 0 15065 NULL
+ctrlbuf_dma_usbhid_device_15067_fields ctrlbuf_dma usbhid_device 0 15067 NULL nohasharray
+lpt_offs_bits_ubifs_info_15067_fields lpt_offs_bits ubifs_info 0 15067 &ctrlbuf_dma_usbhid_device_15067_fields
+write_len_ddb_flashio_15069_fields write_len ddb_flashio 0 15069 NULL
+n_values_i2c_mux_reg_platform_data_15073_fields n_values i2c_mux_reg_platform_data 0 15073 NULL
+saturation_sd_gl860_15076_fields saturation sd_gl860 0 15076 NULL
+xfs_rtcheck_range_fndecl_15077_fields xfs_rtcheck_range fndecl 3-0 15077 NULL
+bm_words_bm_xfer_ctx_15081_fields bm_words bm_xfer_ctx 0 15081 NULL
+offs_ubifs_ref_node_15088_fields offs ubifs_ref_node 0 15088 NULL
+cirrusfb_get_memsize_fndecl_15094_fields cirrusfb_get_memsize fndecl 0 15094 NULL nohasharray
+ia32_arch_ptrace_fndecl_15094_fields ia32_arch_ptrace fndecl 3 15094 &cirrusfb_get_memsize_fndecl_15094_fields
+xlog_seek_logrec_hdr_fndecl_15099_fields xlog_seek_logrec_hdr fndecl 3 15099 NULL
+drm_mm_insert_node_in_range_generic_fndecl_15103_fields drm_mm_insert_node_in_range_generic fndecl 3 15103 NULL
+split_nodes_size_interleave_fndecl_15116_fields split_nodes_size_interleave fndecl 3-4-5 15116 NULL
+batadv_bla_is_backbone_gw_fndecl_15121_fields batadv_bla_is_backbone_gw fndecl 3 15121 NULL
+ubifs_tnc_replace_fndecl_15122_fields ubifs_tnc_replace fndecl 7-6 15122 NULL
+read_sb_page_fndecl_15124_fields read_sb_page fndecl 5-4-2 15124 NULL
+macvlan_change_mtu_fndecl_15125_fields macvlan_change_mtu fndecl 2 15125 NULL
+first_offset_afs_call_15128_fields first_offset afs_call 0 15128 NULL
+bytes_rds_iovec_15133_fields bytes rds_iovec 0 15133 NULL
+vcpu_id_kvm_vcpu_15135_fields vcpu_id kvm_vcpu 0 15135 NULL
+copy_oldmem_page_fndecl_15143_fields copy_oldmem_page fndecl 1 15143 NULL
+mid_get_vbt_data_r1_fndecl_15145_fields mid_get_vbt_data_r1 fndecl 2 15145 NULL
+sysctl_tcp_min_tso_segs_vardecl_15146_fields sysctl_tcp_min_tso_segs vardecl 0 15146 NULL
+elem_size_snd_array_15155_fields elem_size snd_array 0 15155 NULL
+i_disk_sec_hpfs_inode_info_15165_fields i_disk_sec hpfs_inode_info 0 15165 NULL
+ovl_dir_llseek_fndecl_15169_fields ovl_dir_llseek fndecl 2 15169 NULL
+xfs_idata_realloc_fndecl_15172_fields xfs_idata_realloc fndecl 2 15172 NULL
+si_namelen_nfsd4_secinfo_15174_fields si_namelen nfsd4_secinfo 0 15174 NULL
+perform_sglist_fndecl_15184_fields perform_sglist fndecl 3-6 15184 NULL
+nr_pages_videobuf_dmabuf_15190_fields nr_pages videobuf_dmabuf 0 15190 NULL
+ucStateEntrySize__ATOM_PPLIB_POWERPLAYTABLE_15196_fields ucStateEntrySize _ATOM_PPLIB_POWERPLAYTABLE 0 15196 NULL
+p9_client_write_fndecl_15200_fields p9_client_write fndecl 0 15200 NULL
+mwifiex_regrdwr_write_fndecl_15202_fields mwifiex_regrdwr_write fndecl 3 15202 NULL
+size_nforce2_smbus_15203_fields size nforce2_smbus 0 15203 NULL
+top_qxl_urect_15205_fields top qxl_urect 0 15205 NULL
+simple_setattr_fndecl_15209_fields simple_setattr fndecl 0 15209 NULL
+gso_max_size_net_device_15213_fields gso_max_size net_device 0 15213 NULL
+sge_control_sge_params_15216_fields sge_control sge_params 0 15216 NULL
+vals_size_ceph_inode_xattrs_info_15217_fields vals_size ceph_inode_xattrs_info 0 15217 NULL
+len_policydb_15230_fields len policydb 0 15230 NULL nohasharray
+mtd_ooblayout_get_eccbytes_fndecl_15230_fields mtd_ooblayout_get_eccbytes fndecl 4 15230 &len_policydb_15230_fields
+sisusb_bulkout_msg_fndecl_15233_fields sisusb_bulkout_msg fndecl 5-3 15233 NULL nohasharray
+hfsplus_ext_lastblock_fndecl_15233_fields hfsplus_ext_lastblock fndecl 0 15233 &sisusb_bulkout_msg_fndecl_15233_fields
+surface_width_drm_fb_helper_surface_size_15237_fields surface_width drm_fb_helper_surface_size 0 15237 NULL
+len_sock_fprog_15239_fields len sock_fprog 0 15239 NULL
+do_setxattr_fndecl_15243_fields do_setxattr fndecl 5 15243 NULL
+result_wa_seg_15248_fields result wa_seg 0 15248 NULL nohasharray
+ide_cdrom_register_fndecl_15248_fields ide_cdrom_register fndecl 2 15248 &result_wa_seg_15248_fields
+sb_rextsize_xfs_sb_15250_fields sb_rextsize xfs_sb 0 15250 NULL
+ecryptfs_read_lower_page_segment_fndecl_15255_fields ecryptfs_read_lower_page_segment fndecl 4 15255 NULL
+rmsg_size_hv_netvsc_packet_15256_fields rmsg_size hv_netvsc_packet 0 15256 NULL
+dm_block_location_fndecl_15260_fields dm_block_location fndecl 0 15260 NULL
+writequeue_entry_complete_fndecl_15264_fields writequeue_entry_complete fndecl 2 15264 NULL
+inode_bmap_fndecl_15269_fields inode_bmap fndecl 0 15269 NULL
+bstr_printf_fndecl_15271_fields bstr_printf fndecl 0 15271 NULL
+recursive_scan_fndecl_15275_fields recursive_scan fndecl 5 15275 NULL
+num_connectors_ucsi_capability_15281_fields num_connectors ucsi_capability 0 15281 NULL
+nsect_ide_taskfile_15283_fields nsect ide_taskfile 0 15283 NULL
+srp_max_req_size_vardecl_ib_srpt_c_15291_fields srp_max_req_size vardecl_ib_srpt.c 0 15291 NULL
+residual_virtio_scsi_inhdr_15299_fields residual virtio_scsi_inhdr 0 15299 NULL
+scd_size_idt77252_dev_15300_fields scd_size idt77252_dev 0 15300 NULL
+fm10k_get_pcie_msix_count_generic_fndecl_15305_fields fm10k_get_pcie_msix_count_generic fndecl 0 15305 NULL
+__sg_alloc_table_fndecl_15308_fields __sg_alloc_table fndecl 2-3-0 15308 NULL
+channels_max_hdac_chmap_15316_fields channels_max hdac_chmap 0 15316 NULL
+hpfs_dir_lseek_fndecl_15324_fields hpfs_dir_lseek fndecl 2 15324 NULL
+__smq_create_fndecl_15325_fields __smq_create fndecl 1 15325 NULL
+ehci_urb_dequeue_fndecl_15333_fields ehci_urb_dequeue fndecl 3 15333 NULL
+dup_to_netobj_fndecl_15336_fields dup_to_netobj fndecl 3 15336 NULL
+min_io_size_ubifs_info_15340_fields min_io_size ubifs_info 0 15340 NULL
+num_subdevs_xvip_composite_device_15342_fields num_subdevs xvip_composite_device 0 15342 NULL
+sc18is602_txrx_fndecl_15346_fields sc18is602_txrx fndecl 0 15346 NULL
+check_can_nocow_fndecl_15347_fields check_can_nocow fndecl 2 15347 NULL
+efx_rx_mk_skb_fndecl_15349_fields efx_rx_mk_skb fndecl 5-3 15349 NULL
+s_cluster_bits_ext4_sb_info_15353_fields s_cluster_bits ext4_sb_info 0 15353 NULL
+num_total_plane_drm_mode_config_15377_fields num_total_plane drm_mode_config 0 15377 NULL
+s_last_psn_rvt_qp_15390_fields s_last_psn rvt_qp 0 15390 NULL
+size_mtd_info_15393_fields size mtd_info 0 15393 NULL
+iomap_to_bh_fndecl_15399_fields iomap_to_bh fndecl 2 15399 NULL
+rds_ib_ring_init_fndecl_15404_fields rds_ib_ring_init fndecl 2 15404 NULL
+get_perf_callchain_fndecl_15408_fields get_perf_callchain fndecl 2 15408 NULL
+count_nfs42_write_res_15421_fields count nfs42_write_res 0 15421 NULL
+logical_reada_extent_15426_fields logical reada_extent 0 15426 NULL
+num_saved_mc_saved_data_15429_fields num_saved mc_saved_data 0 15429 NULL nohasharray
+size_cmd_header_15429_fields size cmd_header 0 15429 &num_saved_mc_saved_data_15429_fields
+ddr_base_intel_sst_drv_15431_fields ddr_base intel_sst_drv 0 15431 NULL
+set_nat_entry_set_15434_fields set nat_entry_set 0 15434 NULL
+ati_remote_sendpacket_fndecl_15435_fields ati_remote_sendpacket fndecl 2 15435 NULL
+xfs_qm_dqattach_fndecl_15441_fields xfs_qm_dqattach fndecl 0 15441 NULL
+max_vpi_lpfc_hba_15442_fields max_vpi lpfc_hba 0 15442 NULL
+code_page_dir_hpfs_spare_block_15449_fields code_page_dir hpfs_spare_block 0 15449 NULL
+regmap_spi_write_fndecl_15476_fields regmap_spi_write fndecl 3 15476 NULL
+mmio_len_fb_fix_screeninfo_15477_fields mmio_len fb_fix_screeninfo 0 15477 NULL
+hidma_ll_init_fndecl_15486_fields hidma_ll_init fndecl 2 15486 NULL
+__ext_tree_remove_fndecl_15489_fields __ext_tree_remove fndecl 2-3 15489 NULL nohasharray
+priv_size_iscsit_transport_15489_fields priv_size iscsit_transport 0 15489 &__ext_tree_remove_fndecl_15489_fields
+old_oblock_policy_result_15494_fields old_oblock policy_result 0 15494 NULL
+cached_start_hfs_inode_info_15502_fields cached_start hfs_inode_info 0 15502 NULL
+size_videobuf_buffer_15508_fields size videobuf_buffer 0 15508 NULL
+gfs2_fallocate_fndecl_15515_fields gfs2_fallocate fndecl 4-3 15515 NULL
+max_pkt_size_cx231xx_video_mode_15531_fields max_pkt_size cx231xx_video_mode 0 15531 NULL
+btrfs_clone_files_fndecl_15534_fields btrfs_clone_files fndecl 5-3-4 15534 NULL nohasharray
+wl1273_fm_get_tx_ctune_fndecl_15534_fields wl1273_fm_get_tx_ctune fndecl 0 15534 &btrfs_clone_files_fndecl_15534_fields
+xlog_do_recovery_pass_fndecl_15537_fields xlog_do_recovery_pass fndecl 3 15537 NULL
+space_bits_ubifs_info_15538_fields space_bits ubifs_info 0 15538 NULL
+index_btframe_15545_fields index btframe 0 15545 NULL
+data_length_mts_transfer_context_15546_fields data_length mts_transfer_context 0 15546 NULL
+kernfs_iop_setxattr_fndecl_15550_fields kernfs_iop_setxattr fndecl 5 15550 NULL
+lowpan_xmit_fragment_fndecl_15552_fields lowpan_xmit_fragment fndecl 4-6 15552 NULL
+ep_in_kingsun_cb_15553_fields ep_in kingsun_cb 0 15553 NULL
+num_odfs_clkgen_pll_data_15554_fields num_odfs clkgen_pll_data 0 15554 NULL
+video_buffer_size_vivid_dev_15556_fields video_buffer_size vivid_dev 0 15556 NULL
+node_start_pfn_pglist_data_15561_fields node_start_pfn pglist_data 0 15561 NULL
+swiotlb_late_init_with_tbl_fndecl_15566_fields swiotlb_late_init_with_tbl fndecl 2 15566 NULL nohasharray
+push_frame_fndecl_15566_fields push_frame fndecl 2 15566 &swiotlb_late_init_with_tbl_fndecl_15566_fields
+s_map2blk_adfs_sb_info_15569_fields s_map2blk adfs_sb_info 0 15569 NULL
+nsblk_do_bvec_fndecl_15572_fields nsblk_do_bvec fndecl 0 15572 NULL
+acpi20_efi_15582_fields acpi20 efi 0 15582 NULL
+NumTransferUnits_erase_unit_header_t_15585_fields NumTransferUnits erase_unit_header_t 0 15585 NULL
+__split_and_process_non_flush_fndecl_15587_fields __split_and_process_non_flush fndecl 0 15587 NULL
+tx_ring_count_ixgbe_adapter_15595_fields tx_ring_count ixgbe_adapter 0 15595 NULL
+memsz_fifo_15603_fields memsz fifo 0 15603 NULL
+len_nfs3_createargs_15604_fields len nfs3_createargs 0 15604 NULL
+do_add_page_to_bio_fndecl_15612_fields do_add_page_to_bio fndecl 10-4-2 15612 NULL
+ch_r_head_jsm_channel_15625_fields ch_r_head jsm_channel 0 15625 NULL
+nents_sg_table_15627_fields nents sg_table 0 15627 NULL nohasharray
+drm_addmap_core_fndecl_15627_fields drm_addmap_core fndecl 3-2 15627 &nents_sg_table_15627_fields
+sensor_hub_get_physical_device_count_fndecl_15630_fields sensor_hub_get_physical_device_count fndecl 0 15630 NULL nohasharray
+i915_error_state_buf_init_fndecl_15630_fields i915_error_state_buf_init fndecl 4 15630 &sensor_hub_get_physical_device_count_fndecl_15630_fields
+mcs_wrap_mir_skb_fndecl_15633_fields mcs_wrap_mir_skb fndecl 0 15633 NULL
+end_bttv_vbi_fmt_15637_fields end bttv_vbi_fmt 0 15637 NULL
+dma_in_redrat3_dev_15639_fields dma_in redrat3_dev 0 15639 NULL
+akid_raw_issuer_size_x509_parse_context_15651_fields akid_raw_issuer_size x509_parse_context 0 15651 NULL
+extra_msdu_prefix_len_lib80211_crypto_ops_15654_fields extra_msdu_prefix_len lib80211_crypto_ops 0 15654 NULL nohasharray
+mapped_vram_radeonfb_info_15654_fields mapped_vram radeonfb_info 0 15654 &extra_msdu_prefix_len_lib80211_crypto_ops_15654_fields nohasharray
+read_bytes_from_xdr_buf_fndecl_15654_fields read_bytes_from_xdr_buf fndecl 4-2 15654 &mapped_vram_radeonfb_info_15654_fields
+kvm_pv_enable_async_pf_fndecl_15662_fields kvm_pv_enable_async_pf fndecl 2 15662 NULL
+sb_rblocks_xfs_sb_15668_fields sb_rblocks xfs_sb 0 15668 NULL
+wsize_p9_conn_15686_fields wsize p9_conn 0 15686 NULL
+total_bnx2x_sriov_15692_fields total bnx2x_sriov 0 15692 NULL
+num_bytes_sigmadsp_control_15699_fields num_bytes sigmadsp_control 0 15699 NULL
+btrfs_test_extent_io_fndecl_15701_fields btrfs_test_extent_io fndecl 2 15701 NULL
+iov_len_kvec_15702_fields iov_len kvec 0 15702 NULL
+xprt_rdma_max_inline_read_vardecl_15703_fields xprt_rdma_max_inline_read vardecl 0 15703 NULL
+numa_scan_offset_mm_struct_15710_fields numa_scan_offset mm_struct 0 15710 NULL
+name_len_nilfs_dir_entry_15715_fields name_len nilfs_dir_entry 0 15715 NULL
+user_size_drm_i915_gem_userptr_15716_fields user_size drm_i915_gem_userptr 0 15716 NULL
+di_xblk_qnx4_inode_entry_15719_fields di_xblk qnx4_inode_entry 0 15719 NULL
+n_window_iwl_queue_15731_fields n_window iwl_queue 0 15731 NULL
+setup_boot_parameters_fndecl_15734_fields setup_boot_parameters fndecl 5-6-3-4 15734 NULL
+amdtp_am824_set_parameters_fndecl_15737_fields amdtp_am824_set_parameters fndecl 4-3 15737 NULL
+lcd_height_atyfb_par_15743_fields lcd_height atyfb_par 0 15743 NULL
+num_locks_dlm_migratable_lockres_15745_fields num_locks dlm_migratable_lockres 0 15745 NULL
+hotfix_map_hpfs_spare_block_15748_fields hotfix_map hpfs_spare_block 0 15748 NULL
+remote_miu_nfc_llcp_local_15749_fields remote_miu nfc_llcp_local 0 15749 NULL
+st_int_ioctl_fndecl_15750_fields st_int_ioctl fndecl 3 15750 NULL nohasharray
+base_nr_i2c_mux_reg_platform_data_15750_fields base_nr i2c_mux_reg_platform_data 0 15750 &st_int_ioctl_fndecl_15750_fields
+ip_tunnel_change_mtu_fndecl_15752_fields ip_tunnel_change_mtu fndecl 2 15752 NULL
+transfer_done_snd_usb_substream_15753_fields transfer_done snd_usb_substream 0 15753 NULL nohasharray
+con_out_kvec_skip_fndecl_15753_fields con_out_kvec_skip fndecl 0 15753 &transfer_done_snd_usb_substream_15753_fields
+xres__sisbios_mode_15754_fields xres _sisbios_mode 0 15754 NULL
+sockid_uv_gam_range_entry_15756_fields sockid uv_gam_range_entry 0 15756 NULL
+udf_add_aext_fndecl_15762_fields udf_add_aext fndecl 4 15762 NULL nohasharray
+devm_kmalloc_fndecl_15762_fields devm_kmalloc fndecl 2 15762 &udf_add_aext_fndecl_15762_fields
+niu_change_mtu_fndecl_15765_fields niu_change_mtu fndecl 2 15765 NULL
+header_read_sd_15767_fields header_read sd 0 15767 NULL
+mc13xxx_spi_write_fndecl_15768_fields mc13xxx_spi_write fndecl 3 15768 NULL
+irttp_connect_confirm_fndecl_15769_fields irttp_connect_confirm fndecl 4-5 15769 NULL
+rdma_read_chunk_lcl_fndecl_15778_fields rdma_read_chunk_lcl fndecl 7-8 15778 NULL nohasharray
+ntfs_copy_from_user_iter_fndecl_15778_fields ntfs_copy_from_user_iter fndecl 5-3 15778 &rdma_read_chunk_lcl_fndecl_15778_fields
+xfs_bmap_split_extent_at_fndecl_15780_fields xfs_bmap_split_extent_at fndecl 3 15780 NULL
+PacketLength_wa_xfer_packet_status_len_hwaiso_15781_fields PacketLength wa_xfer_packet_status_len_hwaiso 0 15781 NULL
+vde_ast_vbios_enhtable_15784_fields vde ast_vbios_enhtable 0 15784 NULL
+count_nfs4_readdir_arg_15790_fields count nfs4_readdir_arg 0 15790 NULL
+region_size_dm_region_hash_15798_fields region_size dm_region_hash 0 15798 NULL
+fi_ndatablk_nilfs_finfo_15799_fields fi_ndatablk nilfs_finfo 0 15799 NULL
+ath_rxbuf_alloc_fndecl_15802_fields ath_rxbuf_alloc fndecl 2 15802 NULL
+btintel_secure_send_fndecl_15805_fields btintel_secure_send fndecl 3 15805 NULL
+st33zp24_spi_recv_fndecl_15816_fields st33zp24_spi_recv fndecl 4 15816 NULL
+copy_perf_raw_frag_15819_fields copy perf_raw_frag 0 15819 NULL
+unpack_str_fndecl_15821_fields unpack_str fndecl 0 15821 NULL
+length_idma64_desc_15822_fields length idma64_desc 0 15822 NULL
+n_match_sets_cfg80211_sched_scan_request_15823_fields n_match_sets cfg80211_sched_scan_request 0 15823 NULL
+provider_out_words_ib_uverbs_ex_cmd_hdr_15828_fields provider_out_words ib_uverbs_ex_cmd_hdr 0 15828 NULL
+word13_lpfc_mbx_read_config_15832_fields word13 lpfc_mbx_read_config 0 15832 NULL
+ocfs2_read_blocks_fndecl_15834_fields ocfs2_read_blocks fndecl 0-2 15834 NULL
+skb_make_writable_fndecl_15836_fields skb_make_writable fndecl 2 15836 NULL
+rx_num_pg_ch_pm_15838_fields rx_num_pg ch_pm 0 15838 NULL
+block_llseek_fndecl_15846_fields block_llseek fndecl 2 15846 NULL
+ssthresh_tcp_congestion_ops_15847_fields ssthresh tcp_congestion_ops 0 15847 NULL
+pnp_register_mem_resource_fndecl_15849_fields pnp_register_mem_resource fndecl 6-3-5 15849 NULL
+net2272_read_fndecl_15850_fields net2272_read fndecl 0 15850 NULL
+sb_set_blocksize_fndecl_15860_fields sb_set_blocksize fndecl 2-0 15860 NULL
+period_bytes_min_snd_pcm_hardware_15864_fields period_bytes_min snd_pcm_hardware 0 15864 NULL
+msg_ctlmax_ipc_namespace_15868_fields msg_ctlmax ipc_namespace 0 15868 NULL
+o2net_send_tcp_msg_fndecl_15876_fields o2net_send_tcp_msg fndecl 4-3 15876 NULL
+ie_len_cfg80211_auth_request_15886_fields ie_len cfg80211_auth_request 0 15886 NULL nohasharray
+dp_init_fndecl_15886_fields dp_init fndecl 0 15886 &ie_len_cfg80211_auth_request_15886_fields
+ext4_get_block_trans_fndecl_15889_fields ext4_get_block_trans fndecl 2 15889 NULL
+num_pds_mthca_limits_15899_fields num_pds mthca_limits 0 15899 NULL nohasharray
+size_drm_i915_error_state_buf_15899_fields size drm_i915_error_state_buf 0 15899 &num_pds_mthca_limits_15899_fields
+vgem_gem_create_fndecl_15901_fields vgem_gem_create fndecl 4 15901 NULL
+usb_alloc_dev_fndecl_15902_fields usb_alloc_dev fndecl 3 15902 NULL
+flags_v4l2_ioctl_info_15905_fields flags v4l2_ioctl_info 0 15905 NULL
+status_pch_udc_data_dma_desc_15911_fields status pch_udc_data_dma_desc 0 15911 NULL
+rh_queue_status_fndecl_15921_fields rh_queue_status fndecl 0 15921 NULL
+group_width_ore_layout_15927_fields group_width ore_layout 0 15927 NULL nohasharray
+btt_do_bvec_fndecl_15927_fields btt_do_bvec fndecl 0 15927 &group_width_ore_layout_15927_fields
+npages_gssx_arg_accept_sec_context_15939_fields npages gssx_arg_accept_sec_context 0 15939 NULL
+netlink_sendmsg_fndecl_15943_fields netlink_sendmsg fndecl 3 15943 NULL
+num_rss_qs_be_adapter_15944_fields num_rss_qs be_adapter 0 15944 NULL
+xfs_ialloc_pagi_init_fndecl_15952_fields xfs_ialloc_pagi_init fndecl 3 15952 NULL
+mcp795_rtcc_read_fndecl_15956_fields mcp795_rtcc_read fndecl 4 15956 NULL
+ebt_buf_add_pad_fndecl_15958_fields ebt_buf_add_pad fndecl 0 15958 NULL nohasharray
+nr_rtc_mem_15958_fields nr rtc_mem 0 15958 &ebt_buf_add_pad_fndecl_15958_fields
+data_dma_usb_acecad_15962_fields data_dma usb_acecad 0 15962 NULL
+splice_pipe_to_pipe_fndecl_15964_fields splice_pipe_to_pipe fndecl 3 15964 NULL
+brcmf_bus_add_txhdrlen_fndecl_15969_fields brcmf_bus_add_txhdrlen fndecl 2 15969 NULL
+ath6kl_wmi_beginscan_cmd_fndecl_15973_fields ath6kl_wmi_beginscan_cmd fndecl 8-2 15973 NULL
+first_burst_iscsi_session_15974_fields first_burst iscsi_session 0 15974 NULL
+mmc_test_area_io_fndecl_15982_fields mmc_test_area_io fndecl 2 15982 NULL
+nb_blocks_INFTLrecord_15986_fields nb_blocks INFTLrecord 0 15986 NULL
+data_len_usb_req_15991_fields data_len usb_req 0 15991 NULL
+xfs_qm_dqtobp_fndecl_15995_fields xfs_qm_dqtobp fndecl 0 15995 NULL
+num_mem_chunks_ath10k_wmi_16005_fields num_mem_chunks ath10k_wmi 0 16005 NULL
+last_offset_inode_defrag_16007_fields last_offset inode_defrag 0 16007 NULL
+ivtv_buf_copy_from_user_fndecl_16013_fields ivtv_buf_copy_from_user fndecl 4 16013 NULL
+payload_len_bsg_buffer_16019_fields payload_len bsg_buffer 0 16019 NULL
+bo_size_drm_amdgpu_gem_create_in_16025_fields bo_size drm_amdgpu_gem_create_in 0 16025 NULL nohasharray
+xhci_urb_dequeue_fndecl_16025_fields xhci_urb_dequeue fndecl 3 16025 &bo_size_drm_amdgpu_gem_create_in_16025_fields nohasharray
+jfs_truncate_nolock_fndecl_16025_fields jfs_truncate_nolock fndecl 2 16025 &xhci_urb_dequeue_fndecl_16025_fields
+len_brcmf_tlv_16031_fields len brcmf_tlv 0 16031 NULL
+sb_permission_fndecl_16032_fields sb_permission fndecl 0 16032 NULL
+ct_atc_create_fndecl_16033_fields ct_atc_create fndecl 3 16033 NULL nohasharray
+channels_max_hda_pcm_stream_16033_fields channels_max hda_pcm_stream 0 16033 &ct_atc_create_fndecl_16033_fields
+count_connectors_drm_mode_crtc_16038_fields count_connectors drm_mode_crtc 0 16038 NULL nohasharray
+check_presence_tcf_meta_ops_16038_fields check_presence tcf_meta_ops 0 16038 &count_connectors_drm_mode_crtc_16038_fields
+ht_multiplier_i40iw_hmc_fpm_misc_16040_fields ht_multiplier i40iw_hmc_fpm_misc 0 16040 NULL
+vxfs_try_sb_magic_fndecl_16048_fields vxfs_try_sb_magic fndecl 3 16048 NULL
+nsec_seg_buf_16050_fields nsec seg_buf 0 16050 NULL
+nouveau_bo_new_fndecl_16051_fields nouveau_bo_new fndecl 2 16051 NULL
+len_ahc_dma_seg_16052_fields len ahc_dma_seg 0 16052 NULL
+ue_phys_ocfs2_unwritten_extent_16054_fields ue_phys ocfs2_unwritten_extent 0 16054 NULL
+n_insns_comedi_insnlist_16056_fields n_insns comedi_insnlist 0 16056 NULL
+xfs_alloc_fix_freelist_fndecl_16057_fields xfs_alloc_fix_freelist fndecl 0 16057 NULL
+ts_packet_size_cx231xx_tsport_16063_fields ts_packet_size cx231xx_tsport 0 16063 NULL
+ddp_ppod_init_idata_fndecl_16064_fields ddp_ppod_init_idata fndecl 4 16064 NULL
+set_parameters_fndecl_16066_fields set_parameters fndecl 8-7 16066 NULL nohasharray
+compat_sys_sendfile64_fndecl_16066_fields compat_sys_sendfile64 fndecl 4 16066 &set_parameters_fndecl_16066_fields
+post_one_send_fndecl_16067_fields post_one_send fndecl 4 16067 NULL
+max_rxd_qlcnic_adapter_16074_fields max_rxd qlcnic_adapter 0 16074 NULL
+target_set_nacl_queue_depth_fndecl_16084_fields target_set_nacl_queue_depth fndecl 3 16084 NULL
+mgag200_ttm_tt_create_fndecl_16093_fields mgag200_ttm_tt_create fndecl 2 16093 NULL
+pci_add_resource_offset_fndecl_16095_fields pci_add_resource_offset fndecl 3 16095 NULL
+w_mode_size_16096_fields w mode_size 0 16096 NULL
+param_len_mgmt_pending_cmd_16099_fields param_len mgmt_pending_cmd 0 16099 NULL
+grow_dev_page_fndecl_16100_fields grow_dev_page fndecl 4-5-3 16100 NULL
+instances_minus_one_mxt_object_16107_fields instances_minus_one mxt_object 0 16107 NULL
+find_extend_vma_fndecl_16110_fields find_extend_vma fndecl 2 16110 NULL
+brcmf_usb_dl_send_bulk_fndecl_16113_fields brcmf_usb_dl_send_bulk fndecl 3 16113 NULL nohasharray
+xillybus_llseek_fndecl_16113_fields xillybus_llseek fndecl 2 16113 &brcmf_usb_dl_send_bulk_fndecl_16113_fields
+tx_bytes_queued_ipw_tty_16114_fields tx_bytes_queued ipw_tty 0 16114 NULL
+mip4_i2c_xfer_fndecl_16131_fields mip4_i2c_xfer fndecl 3-5 16131 NULL
+vf_count_efx_nic_16134_fields vf_count efx_nic 0 16134 NULL
+hci_req_add_ev_fndecl_16136_fields hci_req_add_ev fndecl 3 16136 NULL
+port_length_c67x00_td_16141_fields port_length c67x00_td 0 16141 NULL
+len_virtio_vsock_pkt_16148_fields len virtio_vsock_pkt 0 16148 NULL nohasharray
+samples_per_line_v4l2_vbi_format_16148_fields samples_per_line v4l2_vbi_format 0 16148 &len_virtio_vsock_pkt_16148_fields
+vlan_tag_eth_fast_path_rx_reg_cqe_16155_fields vlan_tag eth_fast_path_rx_reg_cqe 0 16155 NULL
+max_packet_length_mv_dqh_16157_fields max_packet_length mv_dqh 0 16157 NULL
+beep_amp_via_spec_16168_fields beep_amp via_spec 0 16168 NULL
+read_for_csum_fndecl_16170_fields read_for_csum fndecl 2-3 16170 NULL
+ath6kl_wmi_set_keepalive_cmd_fndecl_16174_fields ath6kl_wmi_set_keepalive_cmd fndecl 2 16174 NULL
+rxrpc_recvmsg_fndecl_16178_fields rxrpc_recvmsg fndecl 3 16178 NULL
+board_span_myri10ge_priv_16182_fields board_span myri10ge_priv 0 16182 NULL nohasharray
+minor_lirc_driver_16182_fields minor lirc_driver 0 16182 &board_span_myri10ge_priv_16182_fields
+pathlen_nfs_symlinkargs_16183_fields pathlen nfs_symlinkargs 0 16183 NULL
+width_drm_mode_fb_cmd2_16185_fields width drm_mode_fb_cmd2 0 16185 NULL
+h_input_res_16191_fields h input_res 0 16191 NULL
+offset_user_sdma_iovec_16195_fields offset user_sdma_iovec 0 16195 NULL
+vid_hdr_offs_mtd_dev_param_16199_fields vid_hdr_offs mtd_dev_param 0 16199 NULL
+blksize_mtd_blktrans_ops_16221_fields blksize mtd_blktrans_ops 0 16221 NULL
+port_hdspm_16225_fields port hdspm 0 16225 NULL
+mmio_vardecl_via_wdt_c_16227_fields mmio vardecl_via_wdt.c 0 16227 NULL
+m_in_maxlevels_xfs_mount_16231_fields m_in_maxlevels xfs_mount 0 16231 NULL
+n_targets_nci_dev_16233_fields n_targets nci_dev 0 16233 NULL
+operand_1_len_ccp_ecc_modular_math_16234_fields operand_1_len ccp_ecc_modular_math 0 16234 NULL
+ks8851_rdreg32_fndecl_16240_fields ks8851_rdreg32 fndecl 0 16240 NULL
+len_wmi_p2p_rx_probe_req_event_16241_fields len wmi_p2p_rx_probe_req_event 0 16241 NULL
+__wl12xx_spi_raw_write_fndecl_16246_fields __wl12xx_spi_raw_write fndecl 4 16246 NULL nohasharray
+used_count_pvr2_buffer_16246_fields used_count pvr2_buffer 0 16246 &__wl12xx_spi_raw_write_fndecl_16246_fields
+num_r_vecs_nfp_net_16247_fields num_r_vecs nfp_net 0 16247 NULL
+offs_ubifs_scan_node_16253_fields offs ubifs_scan_node 0 16253 NULL
+xfs_getbmapx_fix_eof_hole_fndecl_16255_fields xfs_getbmapx_fix_eof_hole fndecl 5 16255 NULL
+num_desc__drm_via_sg_info_16262_fields num_desc _drm_via_sg_info 0 16262 NULL
+length_scsi_data_buffer_16267_fields length scsi_data_buffer 0 16267 NULL
+s_fpg_ufs_sb_private_info_16269_fields s_fpg ufs_sb_private_info 0 16269 NULL
+s_inodes_per_group_ext2_sb_info_16273_fields s_inodes_per_group ext2_sb_info 0 16273 NULL
+_max_length_ieee80211_radiotap_iterator_16274_fields _max_length ieee80211_radiotap_iterator 0 16274 NULL
+hfi1_skip_sge_fndecl_16275_fields hfi1_skip_sge fndecl 2 16275 NULL
+mmio_size_sis_video_info_16284_fields mmio_size sis_video_info 0 16284 NULL
+find_ibft_region_fndecl_16285_fields find_ibft_region fndecl 0 16285 NULL
+isdn_tty_countDLE_fndecl_16304_fields isdn_tty_countDLE fndecl 0 16304 NULL
+len_ieee80211_vendor_radiotap_16308_fields len ieee80211_vendor_radiotap 0 16308 NULL nohasharray
+wm_adsp_compr_copy_fndecl_16308_fields wm_adsp_compr_copy fndecl 3 16308 &len_ieee80211_vendor_radiotap_16308_fields
+aac_fib_send_fndecl_16315_fields aac_fib_send fndecl 3 16315 NULL
+memblock_mark_mirror_fndecl_16321_fields memblock_mark_mirror fndecl 2-1 16321 NULL
+major_tty_driver_16323_fields major tty_driver 0 16323 NULL
+AscGetMaxDmaCount_fndecl_16326_fields AscGetMaxDmaCount fndecl 0 16326 NULL
+__ax88179_write_cmd_fndecl_16341_fields __ax88179_write_cmd fndecl 5 16341 NULL
+max_vfs_be_resources_16343_fields max_vfs be_resources 0 16343 NULL
+fuse_dir_compat_ioctl_fndecl_16346_fields fuse_dir_compat_ioctl fndecl 2 16346 NULL
+channels_snd_emu10k1_fx8010_pcm_16368_fields channels snd_emu10k1_fx8010_pcm 0 16368 NULL
+udf_get_pblock_virt15_fndecl_16373_fields udf_get_pblock_virt15 fndecl 4 16373 NULL
+ssram_base_addr_telemetry_unit_config_16377_fields ssram_base_addr telemetry_unit_config 0 16377 NULL
+len_iwl_mvm_dump_desc_16383_fields len iwl_mvm_dump_desc 0 16383 NULL
+sr_set_blocklength_fndecl_16390_fields sr_set_blocklength fndecl 2 16390 NULL
+max_nr_frames_gnttab_query_size_16393_fields max_nr_frames gnttab_query_size 0 16393 NULL
+pci_map_page_fndecl_16395_fields pci_map_page fndecl 0 16395 NULL nohasharray
+set_pio_mode_fndecl_16395_fields set_pio_mode fndecl 2 16395 &pci_map_page_fndecl_16395_fields
+usbat_execute_command_fndecl_16400_fields usbat_execute_command fndecl 3 16400 NULL
+compress_sliced_buf_fndecl_16402_fields compress_sliced_buf fndecl 0-2 16402 NULL
+statelen_drbg_core_16405_fields statelen drbg_core 0 16405 NULL
+controller_number_mspro_sys_info_16408_fields controller_number mspro_sys_info 0 16408 NULL
+romfs_dev_read_fndecl_16412_fields romfs_dev_read fndecl 2-4 16412 NULL
+bcnt_aoeif_16414_fields bcnt aoeif 0 16414 NULL
+n_sectors_hpfs_super_block_16421_fields n_sectors hpfs_super_block 0 16421 NULL
+bNrInPins_uac_selector_unit_descriptor_16423_fields bNrInPins uac_selector_unit_descriptor 0 16423 NULL nohasharray
+per_vf_cids_qed_cdu_iids_16423_fields per_vf_cids qed_cdu_iids 0 16423 &bNrInPins_uac_selector_unit_descriptor_16423_fields
+gem_allocate_guc_obj_fndecl_16428_fields gem_allocate_guc_obj fndecl 2 16428 NULL
+vm_start_usb_memory_16438_fields vm_start usb_memory 0 16438 NULL
+numa_emulation_fndecl_16441_fields numa_emulation fndecl 2 16441 NULL
+ep_in_usbtest_info_16442_fields ep_in usbtest_info 0 16442 NULL
+pcmcia_irq_pcmcia_socket_16443_fields pcmcia_irq pcmcia_socket 0 16443 NULL
+ReadHSCX_fndecl_16444_fields ReadHSCX fndecl 0 16444 NULL
+mpu3050_xyz_read_reg_fndecl_16445_fields mpu3050_xyz_read_reg fndecl 3 16445 NULL
+endp_in_zd1201_16446_fields endp_in zd1201 0 16446 NULL
+frame_size_au0828_dev_16447_fields frame_size au0828_dev 0 16447 NULL
+sdhci_alloc_host_fndecl_16454_fields sdhci_alloc_host fndecl 2 16454 NULL
+wiimote_queue_fndecl_16469_fields wiimote_queue fndecl 3 16469 NULL
+sec_per_pg_nvm_dev_16472_fields sec_per_pg nvm_dev 0 16472 NULL
+prism2_change_mtu_fndecl_16473_fields prism2_change_mtu fndecl 2 16473 NULL
+m_sectbb_log_xfs_mount_16477_fields m_sectbb_log xfs_mount 0 16477 NULL nohasharray
+nfs_proc_symlink_fndecl_16477_fields nfs_proc_symlink fndecl 4 16477 &m_sectbb_log_xfs_mount_16477_fields
+msg_count_amd8111e_rx_dr_16493_fields msg_count amd8111e_rx_dr 0 16493 NULL
+sq_size_i40iw_qp_uk_init_info_16496_fields sq_size i40iw_qp_uk_init_info 0 16496 NULL
+blksz_fw_dl_mwifiex_pcie_device_16498_fields blksz_fw_dl mwifiex_pcie_device 0 16498 NULL
+max_srq_wqes_mthca_limits_16499_fields max_srq_wqes mthca_limits 0 16499 NULL
+stride_simplefb_platform_data_16503_fields stride simplefb_platform_data 0 16503 NULL
+crypt_alloc_buffer_fndecl_16511_fields crypt_alloc_buffer fndecl 2 16511 NULL
+size_i40iw_chunk_16517_fields size i40iw_chunk 0 16517 NULL
+btrfs_block_rsv_add_fndecl_16520_fields btrfs_block_rsv_add fndecl 0 16520 NULL
+blocks_available_dio_submit_16522_fields blocks_available dio_submit 0 16522 NULL
+xb_suballoc_loc_ocfs2_xattr_block_16523_fields xb_suballoc_loc ocfs2_xattr_block 0 16523 NULL
+io_throttle_count_vnic_snic_config_16529_fields io_throttle_count vnic_snic_config 0 16529 NULL
+hfi1_max_qp_wrs_vardecl_16533_fields hfi1_max_qp_wrs vardecl 0 16533 NULL nohasharray
+comm_size_perf_comm_event_16533_fields comm_size perf_comm_event 0 16533 &hfi1_max_qp_wrs_vardecl_16533_fields
+lpt_lebs_ubifs_info_16535_fields lpt_lebs ubifs_info 0 16535 NULL
+tmds_register_read_bytes_fndecl_16541_fields tmds_register_read_bytes fndecl 3 16541 NULL
+MaxSimpleVolumes_aac_get_container_count_resp_16542_fields MaxSimpleVolumes aac_get_container_count_resp 0 16542 NULL
+mlxsw_sp_port_change_mtu_fndecl_16550_fields mlxsw_sp_port_change_mtu fndecl 2 16550 NULL
+max_mthca_srq_16551_fields max mthca_srq 0 16551 NULL
+max_srq_sz_mlx4_dev_cap_16554_fields max_srq_sz mlx4_dev_cap 0 16554 NULL
+result_wa_xfer_16568_fields result wa_xfer 0 16568 NULL
+descriptor_elements_timb_dma_platform_data_channel_16581_fields descriptor_elements timb_dma_platform_data_channel 0 16581 NULL
+segment_count_sit_f2fs_super_block_16582_fields segment_count_sit f2fs_super_block 0 16582 NULL
+n_phy_pm8001_chip_info_16585_fields n_phy pm8001_chip_info 0 16585 NULL
+len_atmel_priv_ioctl_16592_fields len atmel_priv_ioctl 0 16592 NULL
+send_to_group_fndecl_16600_fields send_to_group fndecl 0 16600 NULL
+ext4_group_extend_fndecl_16613_fields ext4_group_extend fndecl 3 16613 NULL
+coda_upcall_fndecl_16614_fields coda_upcall fndecl 2 16614 NULL
+uc_outSize_upc_req_16629_fields uc_outSize upc_req 0 16629 NULL nohasharray
+xfs_bmap_btalloc_nullfb_fndecl_16629_fields xfs_bmap_btalloc_nullfb fndecl 0 16629 &uc_outSize_upc_req_16629_fields nohasharray
+ext_tree_remove_fndecl_16629_fields ext_tree_remove fndecl 3-4 16629 &xfs_bmap_btalloc_nullfb_fndecl_16629_fields
+crtc_hsync_start_drm_display_mode_16643_fields crtc_hsync_start drm_display_mode 0 16643 NULL
+svc_pool_map_init_pernode_fndecl_16648_fields svc_pool_map_init_pernode fndecl 0 16648 NULL
+nfc_hci_allocate_device_fndecl_16649_fields nfc_hci_allocate_device fndecl 8-6 16649 NULL
+wpa_ie_len_mwifiex_private_16651_fields wpa_ie_len mwifiex_private 0 16651 NULL
+notify_uva_vmci_set_notify_info_16655_fields notify_uva vmci_set_notify_info 0 16655 NULL
+rxHeader1_edgeport_serial_16658_fields rxHeader1 edgeport_serial 0 16658 NULL
+core_alua_write_tpg_metadata_fndecl_16659_fields core_alua_write_tpg_metadata fndecl 3 16659 NULL
+li_total_channels_vardecl_16663_fields li_total_channels vardecl 0 16663 NULL
+memblock_remove_fndecl_16669_fields memblock_remove fndecl 2-1 16669 NULL
+of_dma_match_channel_fndecl_16675_fields of_dma_match_channel fndecl 3 16675 NULL
+dlfb_get_edid_fndecl_16677_fields dlfb_get_edid fndecl 0 16677 NULL nohasharray
+ext_mem_k_screen_info_16677_fields ext_mem_k screen_info 0 16677 &dlfb_get_edid_fndecl_16677_fields
+smaps_pte_range_fndecl_16684_fields smaps_pte_range fndecl 2 16684 NULL
+hue_sd_gl860_16686_fields hue sd_gl860 0 16686 NULL
+__alloc_objio_seg_fndecl_16688_fields __alloc_objio_seg fndecl 1 16688 NULL
+jffs2_scan_xref_node_fndecl_16692_fields jffs2_scan_xref_node fndecl 4 16692 NULL
+llcp_tlv_miux_fndecl_16699_fields llcp_tlv_miux fndecl 0 16699 NULL
+ad714x_spi_read_fndecl_16700_fields ad714x_spi_read fndecl 4 16700 NULL
+tlv_buf_len_mwifiex_scan_cmd_config_16702_fields tlv_buf_len mwifiex_scan_cmd_config 0 16702 NULL
+hdlc_loop_fndecl_16708_fields hdlc_loop fndecl 0 16708 NULL
+vm_mmap_pgoff_fndecl_16712_fields vm_mmap_pgoff fndecl 3 16712 NULL nohasharray
+ima_appraise_measurement_fndecl_16712_fields ima_appraise_measurement fndecl 6 16712 &vm_mmap_pgoff_fndecl_16712_fields
+ntargets_ips_ha_16718_fields ntargets ips_ha 0 16718 NULL
+pcm_buf_host_rw_ofs_snd_card_asihpi_pcm_16719_fields pcm_buf_host_rw_ofs snd_card_asihpi_pcm 0 16719 NULL
+opcfg_ofsl_cyttsp4_sysinfo_data_16723_fields opcfg_ofsl cyttsp4_sysinfo_data 0 16723 NULL
+multi_io_quirk_mmc_host_ops_16729_fields multi_io_quirk mmc_host_ops 0 16729 NULL
+fat_length_fat_boot_sector_16730_fields fat_length fat_boot_sector 0 16730 NULL
+shader_rec_size_drm_vc4_submit_cl_16731_fields shader_rec_size drm_vc4_submit_cl 0 16731 NULL
+width_qxl_head_16734_fields width qxl_head 0 16734 NULL
+nchannels_twl6030_gpadc_platform_data_16736_fields nchannels twl6030_gpadc_platform_data 0 16736 NULL
+udf_add_extendedattr_fndecl_16737_fields udf_add_extendedattr fndecl 2 16737 NULL
+blockshift_sddr55_card_info_16749_fields blockshift sddr55_card_info 0 16749 NULL
+lib80211_wep_encrypt_fndecl_16752_fields lib80211_wep_encrypt fndecl 2 16752 NULL
+skb_pull_rcsum_fndecl_16757_fields skb_pull_rcsum fndecl 2 16757 NULL
+discard_next_dnode_fndecl_16758_fields discard_next_dnode fndecl 2 16758 NULL
+ucNumEntries__ATOM_Tonga_PCIE_Table_16761_fields ucNumEntries _ATOM_Tonga_PCIE_Table 0 16761 NULL
+__vfs_write_fndecl_16765_fields __vfs_write fndecl 3-0 16765 NULL
+num_q_csio_wrm_16770_fields num_q csio_wrm 0 16770 NULL nohasharray
+cluster_vardecl_pd_c_16770_fields cluster vardecl_pd.c 0 16770 &num_q_csio_wrm_16770_fields
+cfg80211_classify8021d_fndecl_16771_fields cfg80211_classify8021d fndecl 0 16771 NULL
+security_inode_need_killpriv_fndecl_16777_fields security_inode_need_killpriv fndecl 0 16777 NULL
+qxl_draw_opaque_fb_fndecl_16781_fields qxl_draw_opaque_fb fndecl 2 16781 NULL
+u132_hcd_giveback_urb_fndecl_16783_fields u132_hcd_giveback_urb fndecl 4 16783 NULL nohasharray
+extra_prefix_len_ieee80211_crypto_ops_16783_fields extra_prefix_len ieee80211_crypto_ops 0 16783 &u132_hcd_giveback_urb_fndecl_16783_fields
+iscsit_build_text_rsp_fndecl_16784_fields iscsit_build_text_rsp fndecl 0 16784 NULL nohasharray
+num_pfns_virtio_balloon_16784_fields num_pfns virtio_balloon 0 16784 &iscsit_build_text_rsp_fndecl_16784_fields
+get_string_fndecl_16789_fields get_string fndecl 0 16789 NULL
+batch_shrinker_16806_fields batch shrinker 0 16806 NULL
+ieee80211_tx_ba_session_handle_start_fndecl_16807_fields ieee80211_tx_ba_session_handle_start fndecl 2 16807 NULL
+spu_subctxt_cnt_qib_user_info_16810_fields spu_subctxt_cnt qib_user_info 0 16810 NULL nohasharray
+iscsit_map_iovec_fndecl_16810_fields iscsit_map_iovec fndecl 4-3-0 16810 &spu_subctxt_cnt_qib_user_info_16810_fields
+csecs_nvm_id_group_16817_fields csecs nvm_id_group 0 16817 NULL
+offset_btrfs_disk_key_16819_fields offset btrfs_disk_key 0 16819 NULL
+vxlan_gro_remcsum_fndecl_16823_fields vxlan_gro_remcsum fndecl 4-2 16823 NULL
+count_range_bits_fndecl_16830_fields count_range_bits fndecl 0-3 16830 NULL
+audit_send_reply_fndecl_16835_fields audit_send_reply fndecl 7 16835 NULL
+nr_p2m_frames_start_info_16837_fields nr_p2m_frames start_info 0 16837 NULL
+alignment_ubi_mkvol_req_16842_fields alignment ubi_mkvol_req 0 16842 NULL
+tx_headroom_nfc_digital_dev_16844_fields tx_headroom nfc_digital_dev 0 16844 NULL
+ccp_do_cmac_update_fndecl_16848_fields ccp_do_cmac_update fndecl 2 16848 NULL
+base_jfs_log_16858_fields base jfs_log 0 16858 NULL
+radeon_bo_create_fndecl_16863_fields radeon_bo_create fndecl 2 16863 NULL
+no_channels_ltr501_chip_info_16866_fields no_channels ltr501_chip_info 0 16866 NULL nohasharray
+cnic_alloc_new_id_fndecl_16866_fields cnic_alloc_new_id fndecl 0 16866 &no_channels_ltr501_chip_info_16866_fields
+size_nvs_page_16880_fields size nvs_page 0 16880 NULL
+cik_get_csb_size_fndecl_16882_fields cik_get_csb_size fndecl 0 16882 NULL
+odm_stripe_unit_pnfs_osd_data_map_16884_fields odm_stripe_unit pnfs_osd_data_map 0 16884 NULL
+dma_buf_size_ddb_output_16886_fields dma_buf_size ddb_output 0 16886 NULL nohasharray
+from_offset_xt_string_info_16886_fields from_offset xt_string_info 0 16886 &dma_buf_size_ddb_output_16886_fields
+register_sound_special_device_fndecl_16891_fields register_sound_special_device fndecl 2 16891 NULL
+buf_sz_ath10k_pci_pipe_16896_fields buf_sz ath10k_pci_pipe 0 16896 NULL
+cqe_size_mlx4_caps_16902_fields cqe_size mlx4_caps 0 16902 NULL
+integrity_digsig_verify_fndecl_16903_fields integrity_digsig_verify fndecl 3 16903 NULL
+msi2500_ctrl_msg_fndecl_16907_fields msi2500_ctrl_msg fndecl 0 16907 NULL
+tx_ring_order_vardecl_main_c_16915_fields tx_ring_order vardecl_main.c 0 16915 NULL
+fsnotify_fndecl_16916_fields fsnotify fndecl 0 16916 NULL nohasharray
+idx_mxser_board_16916_fields idx mxser_board 0 16916 &fsnotify_fndecl_16916_fields
+geneve_build_header_fndecl_16917_fields geneve_build_header fndecl 4 16917 NULL
+bpf_program_num_elem_xt_bpf_info_16920_fields bpf_program_num_elem xt_bpf_info 0 16920 NULL
+gpp_size_intel_community_16924_fields gpp_size intel_community 0 16924 NULL
+cont_size_rock_state_16925_fields cont_size rock_state 0 16925 NULL
+snd_rawmidi_transmit_fndecl_16928_fields snd_rawmidi_transmit fndecl 0-3 16928 NULL
+sys_mbind_fndecl_16933_fields sys_mbind fndecl 2-1 16933 NULL
+size_intel_ringbuffer_16937_fields size intel_ringbuffer 0 16937 NULL
+ath10k_wmi_alloc_skb_fndecl_16949_fields ath10k_wmi_alloc_skb fndecl 2 16949 NULL nohasharray
+rrpc_map_page_fndecl_16949_fields rrpc_map_page fndecl 2 16949 &ath10k_wmi_alloc_skb_fndecl_16949_fields
+len_pcan_usb_pro_rxmsg_16950_fields len pcan_usb_pro_rxmsg 0 16950 NULL
+intel_framebuffer_pitch_for_width_fndecl_16956_fields intel_framebuffer_pitch_for_width fndecl 0-2-1 16956 NULL
+minor_oss_minor_dev_16965_fields minor oss_minor_dev 0 16965 NULL
+__alloc_dummy_extent_buffer_fndecl_16969_fields __alloc_dummy_extent_buffer fndecl 2-3 16969 NULL
+cifs_sync_write_fndecl_16972_fields cifs_sync_write fndecl 6 16972 NULL
+fat_reserved_fat_bios_param_block_16977_fields fat_reserved fat_bios_param_block 0 16977 NULL
+virtio_gpu_alloc_cmd_fndecl_16978_fields virtio_gpu_alloc_cmd fndecl 3 16978 NULL
+size_drm_vmw_shader_create_arg_16979_fields size drm_vmw_shader_create_arg 0 16979 NULL
+inquiry_len_scsi_device_16981_fields inquiry_len scsi_device 0 16981 NULL
+num_cs_dw_spi_16989_fields num_cs dw_spi 0 16989 NULL
+src_base_apei_exec_context_16995_fields src_base apei_exec_context 0 16995 NULL
+endp_out2_zd1201_16998_fields endp_out2 zd1201 0 16998 NULL
+cifs_min_rcv_vardecl_17001_fields cifs_min_rcv vardecl 0 17001 NULL
+xfs_dir_replace_fndecl_17002_fields xfs_dir_replace fndecl 7 17002 NULL
+id_rtc_device_17005_fields id rtc_device 0 17005 NULL
+snd_hdac_bus_exec_verb_fndecl_17009_fields snd_hdac_bus_exec_verb fndecl 0 17009 NULL
+consumed_unix_skb_parms_17012_fields consumed unix_skb_parms 0 17012 NULL
+ds_segment_shift_logfs_disk_super_17013_fields ds_segment_shift logfs_disk_super 0 17013 NULL
+rq_size_i40iw_qp_uk_init_info_17016_fields rq_size i40iw_qp_uk_init_info 0 17016 NULL nohasharray
+u132_hcd_abandon_urb_fndecl_17016_fields u132_hcd_abandon_urb fndecl 4 17016 &rq_size_i40iw_qp_uk_init_info_17016_fields
+num_pads_media_entity_17022_fields num_pads media_entity 0 17022 NULL
+ext4_mb_load_buddy_fndecl_17030_fields ext4_mb_load_buddy fndecl 2-0 17030 NULL
+ast_get_vram_info_fndecl_17034_fields ast_get_vram_info fndecl 0 17034 NULL
+hw_context_size_drm_i915_private_17036_fields hw_context_size drm_i915_private 0 17036 NULL
+inuse_kmem_cache_17038_fields inuse kmem_cache 0 17038 NULL
+alloc_targets_fndecl_17049_fields alloc_targets fndecl 2 17049 NULL
+ext4_ext_map_blocks_fndecl_17053_fields ext4_ext_map_blocks fndecl 0 17053 NULL nohasharray
+max_sge_rds_ib_device_17053_fields max_sge rds_ib_device 0 17053 &ext4_ext_map_blocks_fndecl_17053_fields
+ufx_submit_urb_fndecl_17065_fields ufx_submit_urb fndecl 3 17065 NULL
+number_of_packets_usbip_header_cmd_submit_17069_fields number_of_packets usbip_header_cmd_submit 0 17069 NULL
+ext2_commit_chunk_fndecl_17074_fields ext2_commit_chunk fndecl 3 17074 NULL
+vmbus_sendpacket_pagebuffer_ctl_fndecl_17076_fields vmbus_sendpacket_pagebuffer_ctl fndecl 5 17076 NULL
+offset_xen_netif_tx_request_17081_fields offset xen_netif_tx_request 0 17081 NULL
+rsp_que_len_qla_hw_data_17082_fields rsp_que_len qla_hw_data 0 17082 NULL nohasharray
+ax88179_read_cmd_fndecl_17082_fields ax88179_read_cmd fndecl 5 17082 &rsp_que_len_qla_hw_data_17082_fields
+ccp_prepare_data_fndecl_17091_fields ccp_prepare_data fndecl 4 17091 NULL
+xfs_file_fallocate_fndecl_17093_fields xfs_file_fallocate fndecl 3-4 17093 NULL
+obfuscate_tx_buffer_fndecl_17095_fields obfuscate_tx_buffer fndecl 0-2 17095 NULL nohasharray
+copy_data_fndecl_17095_fields copy_data fndecl 6 17095 &obfuscate_tx_buffer_fndecl_17095_fields
+size_ipack_region_17100_fields size ipack_region 0 17100 NULL nohasharray
+phys_base_fore200e_17100_fields phys_base fore200e 0 17100 &size_ipack_region_17100_fields
+nr_voices_seq_oss_synth_17102_fields nr_voices seq_oss_synth 0 17102 NULL
+len_st_fifo_entry_17104_fields len st_fifo_entry 0 17104 NULL nohasharray
+ro_step_fndecl_17104_fields ro_step fndecl 2 17104 &len_st_fifo_entry_17104_fields
+sdio_readsb_fndecl_17108_fields sdio_readsb fndecl 4 17108 NULL
+count_stframe_17112_fields count stframe 0 17112 NULL
+zoneshift_alauda_media_info_17115_fields zoneshift alauda_media_info 0 17115 NULL
+xfs_iomap_prealloc_size_fndecl_17118_fields xfs_iomap_prealloc_size fndecl 3 17118 NULL
+sample_rate_pcxhr_mgr_17120_fields sample_rate pcxhr_mgr 0 17120 NULL
+ixgbe_get_pcie_msix_count_generic_fndecl_17122_fields ixgbe_get_pcie_msix_count_generic fndecl 0 17122 NULL
+hci_sock_recvmsg_fndecl_17131_fields hci_sock_recvmsg fndecl 3 17131 NULL
+fsl_edma_desc_residue_fndecl_17134_fields fsl_edma_desc_residue fndecl 0 17134 NULL
+irq_stmpe_variant_block_17137_fields irq stmpe_variant_block 0 17137 NULL
+irq_dma_yealink_dev_17149_fields irq_dma yealink_dev 0 17149 NULL
+size_buf_image_desc_17151_fields size_buf image_desc 0 17151 NULL
+unmap_region_fndecl_17166_fields unmap_region fndecl 1 17166 NULL
+x86_clflush_size_cpuinfo_x86_17167_fields x86_clflush_size cpuinfo_x86 0 17167 NULL
+mcp251x_hw_tx_frame_fndecl_17170_fields mcp251x_hw_tx_frame fndecl 3 17170 NULL
+skb_copy_expand_fndecl_17174_fields skb_copy_expand fndecl 2 17174 NULL
+mtu_vnic_enet_config_17176_fields mtu vnic_enet_config 0 17176 NULL nohasharray
+ip_options_get_finish_fndecl_17176_fields ip_options_get_finish fndecl 4 17176 &mtu_vnic_enet_config_17176_fields
+start_block_swap_extent_17179_fields start_block swap_extent 0 17179 NULL
+read_normal_summaries_fndecl_17185_fields read_normal_summaries fndecl 2 17185 NULL
+num_component_match_17187_fields num component_match 0 17187 NULL
+sys_pread64_fndecl_17210_fields sys_pread64 fndecl 3 17210 NULL
+logical_blk_num_osst_tape_17216_fields logical_blk_num osst_tape 0 17216 NULL
+ud_clear_fndecl_17219_fields ud_clear fndecl 6-4-5-3 17219 NULL nohasharray
+srp_map_finish_fmr_fndecl_17219_fields srp_map_finish_fmr fndecl 0 17219 &ud_clear_fndecl_17219_fields
+vsync_start_drm_display_mode_17229_fields vsync_start drm_display_mode 0 17229 NULL
+ioread32be_fndecl_17230_fields ioread32be fndecl 0 17230 NULL
+__btrfs_add_ordered_extent_fndecl_17234_fields __btrfs_add_ordered_extent fndecl 4-2-3 17234 NULL
+alloc_isa_irq_from_domain_fndecl_17243_fields alloc_isa_irq_from_domain fndecl 2 17243 NULL
+relocated_ramdisk_vardecl_17246_fields relocated_ramdisk vardecl 0 17246 NULL
+count_acpi_object_package_17250_fields count acpi_object_package 0 17250 NULL
+len_spi_ioc_transfer_17252_fields len spi_ioc_transfer 0 17252 NULL
+bm_resync_fo_drbd_device_17253_fields bm_resync_fo drbd_device 0 17253 NULL nohasharray
+LastFreeEUN_INFTLrecord_17253_fields LastFreeEUN INFTLrecord 0 17253 &bm_resync_fo_drbd_device_17253_fields
+num_vfs_be_adapter_17257_fields num_vfs be_adapter 0 17257 NULL nohasharray
+sctp_v6_err_fndecl_17257_fields sctp_v6_err fndecl 5 17257 &num_vfs_be_adapter_17257_fields
+page_to_skb_fndecl_17261_fields page_to_skb fndecl 5-4-6 17261 NULL
+line_uart_port_17263_fields line uart_port 0 17263 NULL
+fat_sec_per_clus_fat_bios_param_block_17264_fields fat_sec_per_clus fat_bios_param_block 0 17264 NULL
+alloc_candev_fndecl_17267_fields alloc_candev fndecl 2-1 17267 NULL
+macsec_finalize_skb_fndecl_17269_fields macsec_finalize_skb fndecl 2-3 17269 NULL
+bnx2_rx_skb_fndecl_17272_fields bnx2_rx_skb fndecl 5-4 17272 NULL nohasharray
+offs_nand_bbt_descr_17272_fields offs nand_bbt_descr 0 17272 &bnx2_rx_skb_fndecl_17272_fields
+w_stk_size_17273_fields w stk_size 0 17273 NULL nohasharray
+size_msdos_dir_entry_17273_fields size msdos_dir_entry 0 17273 &w_stk_size_17273_fields
+desired_speed_ide_drive_s_17293_fields desired_speed ide_drive_s 0 17293 NULL
+xfs_alloc_find_best_extent_fndecl_17294_fields xfs_alloc_find_best_extent fndecl 0 17294 NULL
+sup_segnum_nilfs_suinfo_update_17298_fields sup_segnum nilfs_suinfo_update 0 17298 NULL
+div_round_integer_fndecl_17300_fields div_round_integer fndecl 0-2-1 17300 NULL
+read_reg_sja1000_priv_17306_fields read_reg sja1000_priv 0 17306 NULL
+bytes_per_scan_line_vbe_mode_ib_17308_fields bytes_per_scan_line vbe_mode_ib 0 17308 NULL
+dlen_isdn_ppp_resetparams_17312_fields dlen isdn_ppp_resetparams 0 17312 NULL
+top_mthca_alloc_17324_fields top mthca_alloc 0 17324 NULL nohasharray
+fw_memory_size_qla_hw_data_17324_fields fw_memory_size qla_hw_data 0 17324 &top_mthca_alloc_17324_fields
+blockmask_sddr09_card_info_17325_fields blockmask sddr09_card_info 0 17325 NULL
+mru_ipw_network_17329_fields mru ipw_network 0 17329 NULL
+reserved_eqs_mlx4_caps_17333_fields reserved_eqs mlx4_caps 0 17333 NULL
+freeblk_xfs_da_geometry_17334_fields freeblk xfs_da_geometry 0 17334 NULL
+dev_count_kvm_io_bus_17340_fields dev_count kvm_io_bus 0 17340 NULL
+MaxBuses__MSG_IOC_FACTS_REPLY_17350_fields MaxBuses _MSG_IOC_FACTS_REPLY 0 17350 NULL
+tipc_alloc_entry_fndecl_17360_fields tipc_alloc_entry fndecl 2 17360 NULL
+udf_tgetblk_fndecl_17362_fields udf_tgetblk fndecl 2 17362 NULL nohasharray
+cxgb4i_max_connect_vardecl_cxgb4i_c_17362_fields cxgb4i_max_connect vardecl_cxgb4i.c 0 17362 &udf_tgetblk_fndecl_17362_fields
+config_desc_fndecl_17365_fields config_desc fndecl 0 17365 NULL
+pn533_set_configuration_fndecl_17370_fields pn533_set_configuration fndecl 4 17370 NULL nohasharray
+num_txd_qlcnic_adapter_17370_fields num_txd qlcnic_adapter 0 17370 &pn533_set_configuration_fndecl_17370_fields
+name_len_vardecl_initramfs_c_17373_fields name_len vardecl_initramfs.c 0 17373 NULL
+acl_len_nfs_getaclargs_17378_fields acl_len nfs_getaclargs 0 17378 NULL
+vram_total_vardecl_uvesafb_c_17381_fields vram_total vardecl_uvesafb.c 0 17381 NULL
+hw_hdr_len_cardstate_17385_fields hw_hdr_len cardstate 0 17385 NULL
+ata_read_log_page_fndecl_17386_fields ata_read_log_page fndecl 5 17386 NULL
+mtd_ooblayout_count_freebytes_fndecl_17388_fields mtd_ooblayout_count_freebytes fndecl 0 17388 NULL
+raw_issuer_size_pkcs7_parse_context_17399_fields raw_issuer_size pkcs7_parse_context 0 17399 NULL
+cxgbit_put_login_tx_fndecl_17403_fields cxgbit_put_login_tx fndecl 3 17403 NULL
+num_channels_ad5592r_state_17408_fields num_channels ad5592r_state 0 17408 NULL
+snd_hda_create_spdif_in_ctls_fndecl_17414_fields snd_hda_create_spdif_in_ctls fndecl 2 17414 NULL
+dlm_master_lookup_fndecl_17417_fields dlm_master_lookup fndecl 4 17417 NULL
+l2up_create_fndecl_17421_fields l2up_create fndecl 3 17421 NULL
+max_in_queue_skl_module_cfg_17438_fields max_in_queue skl_module_cfg 0 17438 NULL
+dd_fcvport_size_fc_function_template_17449_fields dd_fcvport_size fc_function_template 0 17449 NULL
+nvme_char_major_vardecl_core_c_17452_fields nvme_char_major vardecl_core.c 0 17452 NULL
+reply_size_ncp_server_17456_fields reply_size ncp_server 0 17456 NULL
+bufsz_kexec_segment_17458_fields bufsz kexec_segment 0 17458 NULL
+__alloc_bootmem_node_nopanic_fndecl_17459_fields __alloc_bootmem_node_nopanic fndecl 3-4 17459 NULL
+custom_sig_size_s3fwrn5_fw_image_17467_fields custom_sig_size s3fwrn5_fw_image 0 17467 NULL
+sddr09_write_inplace_fndecl_17484_fields sddr09_write_inplace fndecl 4-3 17484 NULL
+e_block_mb_cache_entry_17485_fields e_block mb_cache_entry 0 17485 NULL
+mlx4_ib_reg_user_mr_fndecl_17492_fields mlx4_ib_reg_user_mr fndecl 2-3 17492 NULL
+qp_memcpy_from_queue_fndecl_17500_fields qp_memcpy_from_queue fndecl 5-4 17500 NULL
+user_buffer_offset_binder_proc_17508_fields user_buffer_offset binder_proc 0 17508 NULL
+invalidate_fndecl_17509_fields invalidate fndecl 4-3 17509 NULL
+npages_free_dma_pool_17513_fields npages_free dma_pool 0 17513 NULL nohasharray
+read_dst_fndecl_17513_fields read_dst fndecl 3 17513 &npages_free_dma_pool_17513_fields
+id_rtsx_pcr_17526_fields id rtsx_pcr 0 17526 NULL
+max3421_urb_dequeue_fndecl_17530_fields max3421_urb_dequeue fndecl 3 17530 NULL
+start_nilfs_write_info_17534_fields start nilfs_write_info 0 17534 NULL
+encode_nfspath3_fndecl_17536_fields encode_nfspath3 fndecl 3 17536 NULL
+how_many_channels_fndecl_17540_fields how_many_channels fndecl 0 17540 NULL
+wdm_read_fndecl_17542_fields wdm_read fndecl 3 17542 NULL nohasharray
+num_pln_nvm_id_group_17542_fields num_pln nvm_id_group 0 17542 &wdm_read_fndecl_17542_fields
+root_cluster_msdos_sb_info_17547_fields root_cluster msdos_sb_info 0 17547 NULL
+mlx4_en_rx_skb_fndecl_17554_fields mlx4_en_rx_skb fndecl 4 17554 NULL
+mchip_comp_read_frame_fndecl_17555_fields mchip_comp_read_frame fndecl 0-1 17555 NULL
+ufs_truncate_fndecl_17556_fields ufs_truncate fndecl 2 17556 NULL
+channels_cardstate_17560_fields channels cardstate 0 17560 NULL
+qcaspi_read_legacy_fndecl_17563_fields qcaspi_read_legacy fndecl 3 17563 NULL
+lcd_vsync_len_atyfb_par_17565_fields lcd_vsync_len atyfb_par 0 17565 NULL
+wMaxPacketSize_usb_rpipe_descriptor_17578_fields wMaxPacketSize usb_rpipe_descriptor 0 17578 NULL
+sb_fs_size_hpfs_sb_info_17581_fields sb_fs_size hpfs_sb_info 0 17581 NULL
+history_uuids_len_device_statistics_17597_fields history_uuids_len device_statistics 0 17597 NULL
+reg_bytes_regmap_format_17598_fields reg_bytes regmap_format 0 17598 NULL
+qlf_len_xfs_dq_logformat_17603_fields qlf_len xfs_dq_logformat 0 17603 NULL nohasharray
+ent_bread_fatent_operations_17603_fields ent_bread fatent_operations 0 17603 &qlf_len_xfs_dq_logformat_17603_fields
+isoc_ep_stk_camera_17604_fields isoc_ep stk_camera 0 17604 NULL
+nr_planes_nvm_dev_17609_fields nr_planes nvm_dev 0 17609 NULL
+nes_reject_fndecl_17612_fields nes_reject fndecl 3 17612 NULL
+min_alloc_order_gen_pool_17628_fields min_alloc_order gen_pool 0 17628 NULL
+num_peri_pl330_config_17630_fields num_peri pl330_config 0 17630 NULL
+num_channels_iio_hwmon_state_17633_fields num_channels iio_hwmon_state 0 17633 NULL
+zero_pfn_vardecl_17635_fields zero_pfn vardecl 0 17635 NULL
+video_linelength_sis_video_info_17642_fields video_linelength sis_video_info 0 17642 NULL
+wl12xx_sdio_raw_read_fndecl_17648_fields wl12xx_sdio_raw_read fndecl 4 17648 NULL
+mscode_note_digest_fndecl_17651_fields mscode_note_digest fndecl 5 17651 NULL
+buf_len_ceph_none_authorizer_17652_fields buf_len ceph_none_authorizer 0 17652 NULL
+size_mem_array_17655_fields size mem_array 0 17655 NULL
+btrfs_dedupe_file_range_fndecl_17658_fields btrfs_dedupe_file_range fndecl 2-5 17658 NULL nohasharray
+snd_wscale_tcp_options_received_17658_fields snd_wscale tcp_options_received 0 17658 &btrfs_dedupe_file_range_fndecl_17658_fields
+stereo_cmipci_sb_reg_17667_fields stereo cmipci_sb_reg 0 17667 NULL
+maybe_insert_hole_fndecl_17668_fields maybe_insert_hole fndecl 4-3 17668 NULL
+f2fs_update_extent_cache_range_fndecl_17671_fields f2fs_update_extent_cache_range fndecl 4-2-3 17671 NULL
+vdma_mem_alloc_fndecl_17672_fields vdma_mem_alloc fndecl 1 17672 NULL
+whci_capdata_quirks_fndecl_17683_fields whci_capdata_quirks fndecl 0-2 17683 NULL
+NFTL_formatblock_fndecl_17684_fields NFTL_formatblock fndecl 2 17684 NULL nohasharray
+iov_misc_count_iscsi_cmd_17684_fields iov_misc_count iscsi_cmd 0 17684 &NFTL_formatblock_fndecl_17684_fields
+ivtv_copy_buf_to_user_fndecl_17692_fields ivtv_copy_buf_to_user fndecl 4 17692 NULL
+opcfg_ofs_cyttsp4_sysinfo_ofs_17693_fields opcfg_ofs cyttsp4_sysinfo_ofs 0 17693 NULL
+bytes_left_ccp_sg_workarea_17701_fields bytes_left ccp_sg_workarea 0 17701 NULL
+_snd_pcm_hw_param_max_fndecl_17702_fields _snd_pcm_hw_param_max fndecl 3 17702 NULL nohasharray
+o2hb_setup_one_bio_fndecl_17702_fields o2hb_setup_one_bio fndecl 4 17702 &_snd_pcm_hw_param_max_fndecl_17702_fields
+rx_dma_buf_sz_altera_tse_private_17708_fields rx_dma_buf_sz altera_tse_private 0 17708 NULL
+index_mask_rxe_queue_buf_17709_fields index_mask rxe_queue_buf 0 17709 NULL
+u132_urb_dequeue_fndecl_17714_fields u132_urb_dequeue fndecl 3 17714 NULL
+csio_wr_alloc_q_fndecl_17717_fields csio_wr_alloc_q fndecl 3-2-6 17717 NULL
+rx_max_ring_bnx2_17721_fields rx_max_ring bnx2 0 17721 NULL
+st21nfca_hci_probe_fndecl_17724_fields st21nfca_hci_probe fndecl 6-4 17724 NULL
+qp_host_get_user_memory_fndecl_17726_fields qp_host_get_user_memory fndecl 1-2 17726 NULL
+xdr_write_pages_fndecl_17729_fields xdr_write_pages fndecl 4-3 17729 NULL
+minor_video_device_17733_fields minor video_device 0 17733 NULL
+ios_per_ctrl_hba_parameters_17734_fields ios_per_ctrl hba_parameters 0 17734 NULL
+f_hidg_read_fndecl_17741_fields f_hidg_read fndecl 3 17741 NULL
+num_desc_blocks_fndecl_17744_fields num_desc_blocks fndecl 0-2 17744 NULL
+set_le_ih_k_offset_fndecl_17745_fields set_le_ih_k_offset fndecl 2 17745 NULL
+pkg_len_hanwang_features_17749_fields pkg_len hanwang_features 0 17749 NULL nohasharray
+sock_no_sendpage_fndecl_17749_fields sock_no_sendpage fndecl 0-4 17749 &pkg_len_hanwang_features_17749_fields
+sector_size_scsi_device_17750_fields sector_size scsi_device 0 17750 NULL
+cmd_per_lun_Scsi_Host_17757_fields cmd_per_lun Scsi_Host 0 17757 NULL
+g_token_size_fndecl_17759_fields g_token_size fndecl 0-2 17759 NULL nohasharray
+actual_length_spi_message_17759_fields actual_length spi_message 0 17759 &g_token_size_fndecl_17759_fields
+max_queues_fm10k_mac_info_17760_fields max_queues fm10k_mac_info 0 17760 NULL
+fbcon_prepare_logo_fndecl_17781_fields fbcon_prepare_logo fndecl 4 17781 NULL
+__e820_update_range_fndecl_17791_fields __e820_update_range fndecl 2-3 17791 NULL
+db_to_fdb_xfs_dir_ops_17792_fields db_to_fdb xfs_dir_ops 0 17792 NULL nohasharray
+usX2Y_audio_stream_new_fndecl_17792_fields usX2Y_audio_stream_new fndecl 2-3 17792 &db_to_fdb_xfs_dir_ops_17792_fields
+nf_nat_ipv6_manip_pkt_fndecl_17794_fields nf_nat_ipv6_manip_pkt fndecl 2 17794 NULL
+number_of_blocks_ms_boot_attr_info_17802_fields number_of_blocks ms_boot_attr_info 0 17802 NULL
+sr_read_cd_fndecl_17813_fields sr_read_cd fndecl 5 17813 NULL
+list_size_acpi_pnp_device_id_list_17814_fields list_size acpi_pnp_device_id_list 0 17814 NULL
+b_page_count_xfs_buf_17815_fields b_page_count xfs_buf 0 17815 NULL nohasharray
+acpi_unregister_gsi_ioapic_fndecl_17815_fields acpi_unregister_gsi_ioapic fndecl 1 17815 &b_page_count_xfs_buf_17815_fields
+telem_punit_ssram_base_intel_pmc_ipc_dev_17821_fields telem_punit_ssram_base intel_pmc_ipc_dev 0 17821 NULL
+i_blkbits_inode_17823_fields i_blkbits inode 0 17823 NULL
+tipc_recvmsg_fndecl_17825_fields tipc_recvmsg fndecl 3 17825 NULL
+mid_get_vbt_data_r10_fndecl_17847_fields mid_get_vbt_data_r10 fndecl 2 17847 NULL
+cifs_lockv_fndecl_17853_fields cifs_lockv fndecl 6-5 17853 NULL
+discard_alignment_queue_limits_17856_fields discard_alignment queue_limits 0 17856 NULL
+current_table_count_acpi_table_list_17862_fields current_table_count acpi_table_list 0 17862 NULL
+bip_vcnt_bio_integrity_payload_17865_fields bip_vcnt bio_integrity_payload 0 17865 NULL
+secondary_tail_adu_device_17874_fields secondary_tail adu_device 0 17874 NULL
+max_pkt_size_au0828_usb_isoc_ctl_17891_fields max_pkt_size au0828_usb_isoc_ctl 0 17891 NULL
+next_portid_vardecl_rio_c_17897_fields next_portid vardecl_rio.c 0 17897 NULL
+del_ba_param_set_host_cmd_ds_11n_delba_17899_fields del_ba_param_set host_cmd_ds_11n_delba 0 17899 NULL
+s_firstinodezone_sysv_sb_info_17901_fields s_firstinodezone sysv_sb_info 0 17901 NULL
+used_aead_ctx_17910_fields used aead_ctx 0 17910 NULL
+leb_start_ubifs_info_17911_fields leb_start ubifs_info 0 17911 NULL
+msb_write_block_fndecl_17912_fields msb_write_block fndecl 5-2-3 17912 NULL
+osd_req_read_sg_kern_fndecl_17913_fields osd_req_read_sg_kern fndecl 5 17913 NULL
+rx_agg_cmp_len_flags_type_rx_agg_cmp_17914_fields rx_agg_cmp_len_flags_type rx_agg_cmp 0 17914 NULL nohasharray
+sg_pcopy_to_buffer_fndecl_17914_fields sg_pcopy_to_buffer fndecl 5-4 17914 &rx_agg_cmp_len_flags_type_rx_agg_cmp_17914_fields
+br_blockcount_xfs_bmbt_irec_17931_fields br_blockcount xfs_bmbt_irec 0 17931 NULL
+mmio_base_sis_video_info_17941_fields mmio_base sis_video_info 0 17941 NULL
+__vxge_hw_mempool_create_fndecl_17944_fields __vxge_hw_mempool_create fndecl 3-6-4 17944 NULL
+do_msgrcv_fndecl_17946_fields do_msgrcv fndecl 3 17946 NULL
+rtl2830_regmap_read_fndecl_17947_fields rtl2830_regmap_read fndecl 3-5 17947 NULL
+ath6kl_wmi_data_sync_send_fndecl_17951_fields ath6kl_wmi_data_sync_send fndecl 4 17951 NULL
+dm_io_fndecl_17953_fields dm_io fndecl 0 17953 NULL
+pkt_align_netvsc_device_17961_fields pkt_align netvsc_device 0 17961 NULL nohasharray
+cydata_size_cyttsp4_sysinfo_ofs_17961_fields cydata_size cyttsp4_sysinfo_ofs 0 17961 &pkt_align_netvsc_device_17961_fields
+scan_async_group_fndecl_17964_fields scan_async_group fndecl 3 17964 NULL
+do_tee_fndecl_17969_fields do_tee fndecl 3 17969 NULL
+ab3100_get_register_page_interruptible_fndecl_17972_fields ab3100_get_register_page_interruptible fndecl 4 17972 NULL
+length_ore_io_state_17977_fields length ore_io_state 0 17977 NULL
+nilfs_set_last_segment_fndecl_17983_fields nilfs_set_last_segment fndecl 2 17983 NULL
+data3_sisusb_command_17984_fields data3 sisusb_command 0 17984 NULL nohasharray
+pci_addr_of_pci_range_17984_fields pci_addr of_pci_range 0 17984 &data3_sisusb_command_17984_fields
+fill_inquiry_response_fndecl_17994_fields fill_inquiry_response fndecl 3 17994 NULL
+get_context_size_fndecl_17999_fields get_context_size fndecl 0 17999 NULL
+target_xcopy_read_source_fndecl_18003_fields target_xcopy_read_source fndecl 5 18003 NULL
+data_xfer_length_aac_srb_reply_18012_fields data_xfer_length aac_srb_reply 0 18012 NULL nohasharray
+size_aper_size_info_8_18012_fields size aper_size_info_8 0 18012 &data_xfer_length_aac_srb_reply_18012_fields
+rx_frag_size_vardecl_be_main_c_18017_fields rx_frag_size vardecl_be_main.c 0 18017 NULL
+raid56_parity_recover_fndecl_18019_fields raid56_parity_recover fndecl 0 18019 NULL
+wimax_msg_fndecl_18021_fields wimax_msg fndecl 4 18021 NULL
+sl811h_urb_dequeue_fndecl_18025_fields sl811h_urb_dequeue fndecl 3 18025 NULL
+rawv6_recvmsg_fndecl_18026_fields rawv6_recvmsg fndecl 3 18026 NULL
+fcoe_hmc_filt_num_i40e_pf_18027_fields fcoe_hmc_filt_num i40e_pf 0 18027 NULL
+splice_read_file_operations_18028_fields splice_read file_operations 0 18028 NULL
+virtio_gpu_cmd_transfer_to_host_2d_fndecl_18040_fields virtio_gpu_cmd_transfer_to_host_2d fndecl 5-4 18040 NULL
+read_device_fndecl_18043_fields read_device fndecl 3 18043 NULL
+len_ib_ucm_private_data_18046_fields len ib_ucm_private_data 0 18046 NULL
+xfer_len_iscsi_seq_18047_fields xfer_len iscsi_seq 0 18047 NULL
+sctp_make_op_error_fndecl_18050_fields sctp_make_op_error fndecl 5-6 18050 NULL
+ts_packet_size_cx23885_tsport_18052_fields ts_packet_size cx23885_tsport 0 18052 NULL
+vb2_vmalloc_attach_dmabuf_fndecl_18073_fields vb2_vmalloc_attach_dmabuf fndecl 3 18073 NULL
+req_ie_len_brcmf_cfg80211_connect_info_18083_fields req_ie_len brcmf_cfg80211_connect_info 0 18083 NULL
+bits_per_pixel_drm_framebuffer_18087_fields bits_per_pixel drm_framebuffer 0 18087 NULL
+di_nextents_xfs_icdinode_18090_fields di_nextents xfs_icdinode 0 18090 NULL
+mv88e6xxx_smi_read_fndecl_18107_fields mv88e6xxx_smi_read fndecl 0 18107 NULL
+btrfs_qgroup_reserve_data_fndecl_18109_fields btrfs_qgroup_reserve_data fndecl 0-3-2 18109 NULL
+addr_width_fsl_edma_slave_config_18115_fields addr_width fsl_edma_slave_config 0 18115 NULL
+befs_read_datastream_fndecl_18116_fields befs_read_datastream fndecl 3 18116 NULL
+mod_len_ccp_ecc_engine_18119_fields mod_len ccp_ecc_engine 0 18119 NULL nohasharray
+index_vardecl_ali5451_c_18119_fields index vardecl_ali5451.c 0 18119 &mod_len_ccp_ecc_engine_18119_fields
+send_mpa_reject_fndecl_18124_fields send_mpa_reject fndecl 3 18124 NULL
+bnx2x_num_queues_vardecl_18126_fields bnx2x_num_queues vardecl 0 18126 NULL
+reshape_request_fndecl_18130_fields reshape_request fndecl 2 18130 NULL
+fs_start_hfs_sb_info_18132_fields fs_start hfs_sb_info 0 18132 NULL
+num_ddr_avs_mthca_av_table_18139_fields num_ddr_avs mthca_av_table 0 18139 NULL
+i_iget5_block_iso_inode_info_18143_fields i_iget5_block iso_inode_info 0 18143 NULL
+mtu_net_device_18148_fields mtu net_device 0 18148 NULL nohasharray
+softback_in_vardecl_fbcon_c_18148_fields softback_in vardecl_fbcon.c 0 18148 &mtu_net_device_18148_fields
+send_max_size_send_ctx_18149_fields send_max_size send_ctx 0 18149 NULL
+read_word_onenand_chip_18150_fields read_word onenand_chip 0 18150 NULL
+bmv_length_getbmapx_18151_fields bmv_length getbmapx 0 18151 NULL
+nfs_dreq_bytes_left_fndecl_18154_fields nfs_dreq_bytes_left fndecl 0 18154 NULL
+cxgbi_ppm_ppods_reserve_fndecl_18157_fields cxgbi_ppm_ppods_reserve fndecl 0-2 18157 NULL
+iscsi_sw_tcp_pdu_init_fndecl_18173_fields iscsi_sw_tcp_pdu_init fndecl 3-2 18173 NULL
+num_gpu_pages_radeon_gart_18177_fields num_gpu_pages radeon_gart 0 18177 NULL
+ocfs2_test_suballoc_bit_fndecl_18180_fields ocfs2_test_suballoc_bit fndecl 6-5-4 18180 NULL nohasharray
+process_rcvd_data_fndecl_18180_fields process_rcvd_data fndecl 3 18180 &ocfs2_test_suballoc_bit_fndecl_18180_fields
+offset_pktcdvd_device_18183_fields offset pktcdvd_device 0 18183 NULL
+hdac_ext_dma_alloc_pages_fndecl_18184_fields hdac_ext_dma_alloc_pages fndecl 3 18184 NULL
+aac_srcv_ioremap_fndecl_18192_fields aac_srcv_ioremap fndecl 2 18192 NULL
+natsemi_change_mtu_fndecl_18207_fields natsemi_change_mtu fndecl 2 18207 NULL
+fw_size_intel_dmc_header_18214_fields fw_size intel_dmc_header 0 18214 NULL
+ext4_issue_zeroout_fndecl_18225_fields ext4_issue_zeroout fndecl 4-0-3 18225 NULL
+ql_process_mac_rx_skb_fndecl_18226_fields ql_process_mac_rx_skb fndecl 5-4 18226 NULL
+xf_block_size_i40iw_hmc_fpm_misc_18228_fields xf_block_size i40iw_hmc_fpm_misc 0 18228 NULL
+nvkm_fifo_ctor_fndecl_18233_fields nvkm_fifo_ctor fndecl 4 18233 NULL
+vol_id_ubi_volume_18238_fields vol_id ubi_volume 0 18238 NULL
+ocfs2_insert_extent_fndecl_18242_fields ocfs2_insert_extent fndecl 4-3 18242 NULL
+payload_size_vmci_datagram_18243_fields payload_size vmci_datagram 0 18243 NULL
+scif_writeto_fndecl_18246_fields scif_writeto fndecl 2-4-3 18246 NULL
+next_free_transient_c_18248_fields next_free transient_c 0 18248 NULL
+inet_recv_error_fndecl_18251_fields inet_recv_error fndecl 3 18251 NULL
+rxf_size_bdx_priv_18260_fields rxf_size bdx_priv 0 18260 NULL
+end_extent_state_18270_fields end extent_state 0 18270 NULL
+sfi_check_table_fndecl_18279_fields sfi_check_table fndecl 1 18279 NULL
+_nfs4_get_security_label_fndecl_18285_fields _nfs4_get_security_label fndecl 3 18285 NULL
+scif_create_window_fndecl_18291_fields scif_create_window fndecl 2 18291 NULL
+tda18218_rd_regs_fndecl_18293_fields tda18218_rd_regs fndecl 4-2 18293 NULL
+mlx5_core_create_vfs_fndecl_18298_fields mlx5_core_create_vfs fndecl 2 18298 NULL
+index_sg_device_18304_fields index sg_device 0 18304 NULL
+essid_len_iw_scan_req_18306_fields essid_len iw_scan_req 0 18306 NULL nohasharray
+offset_cxgbit_lro_cb_18306_fields offset cxgbit_lro_cb 0 18306 &essid_len_iw_scan_req_18306_fields
+add_pfn_range_mapped_fndecl_18307_fields add_pfn_range_mapped fndecl 2 18307 NULL
+twl4030_init_irq_fndecl_18308_fields twl4030_init_irq fndecl 0 18308 NULL
+e820_end_of_low_ram_pfn_fndecl_18324_fields e820_end_of_low_ram_pfn fndecl 0 18324 NULL
+radeon_sa_bo_manager_init_fndecl_18326_fields radeon_sa_bo_manager_init fndecl 3 18326 NULL
+unit_hfi1_devdata_18328_fields unit hfi1_devdata 0 18328 NULL nohasharray
+page_shift_rvt_mregion_18328_fields page_shift rvt_mregion 0 18328 &unit_hfi1_devdata_18328_fields
+hdlcdrv_register_fndecl_18331_fields hdlcdrv_register fndecl 2 18331 NULL
+taps_oslec_state_18332_fields taps oslec_state 0 18332 NULL
+m_blockmask_xfs_mount_18334_fields m_blockmask xfs_mount 0 18334 NULL
+xfs_da_reada_buf_fndecl_18349_fields xfs_da_reada_buf fndecl 2 18349 NULL
+rfcomm_send_frame_fndecl_18352_fields rfcomm_send_frame fndecl 3 18352 NULL
+elfnotes_sz_vardecl_vmcore_c_18357_fields elfnotes_sz vardecl_vmcore.c 0 18357 NULL nohasharray
+vm_pgoff_vm_area_struct_18357_fields vm_pgoff vm_area_struct 0 18357 &elfnotes_sz_vardecl_vmcore_c_18357_fields
+lbs_rdrf_write_fndecl_18361_fields lbs_rdrf_write fndecl 3 18361 NULL
+tso_build_data_fndecl_18365_fields tso_build_data fndecl 3 18365 NULL
+ascii2desc_fndecl_18370_fields ascii2desc fndecl 0-3 18370 NULL
+ecryptfs_write_lower_fndecl_18373_fields ecryptfs_write_lower fndecl 4 18373 NULL
+extent_write_locked_range_fndecl_18375_fields extent_write_locked_range fndecl 3-4 18375 NULL nohasharray
+perf_output_sample_ustack_fndecl_18375_fields perf_output_sample_ustack fndecl 2 18375 &extent_write_locked_range_fndecl_18375_fields
+len_btrfs_ordered_extent_18377_fields len btrfs_ordered_extent 0 18377 NULL
+lc_last_wr_nfsd4_layoutcommit_18378_fields lc_last_wr nfsd4_layoutcommit 0 18378 NULL nohasharray
+n_bssids_wmi_start_scan_arg_18378_fields n_bssids wmi_start_scan_arg 0 18378 &lc_last_wr_nfsd4_layoutcommit_18378_fields
+rss_size_port_info_18379_fields rss_size port_info 0 18379 NULL
+e820_end_pfn_fndecl_18384_fields e820_end_pfn fndecl 0-1 18384 NULL nohasharray
+xfs_rtany_summary_fndecl_18384_fields xfs_rtany_summary fndecl 5-3-0 18384 &e820_end_pfn_fndecl_18384_fields
+raydium_i2c_read_message_fndecl_18385_fields raydium_i2c_read_message fndecl 4 18385 NULL
+reply_payload_rcv_len_fc_bsg_reply_18392_fields reply_payload_rcv_len fc_bsg_reply 0 18392 NULL
+veth_change_mtu_fndecl_18405_fields veth_change_mtu fndecl 2 18405 NULL nohasharray
+lo_offset_loop_info64_18405_fields lo_offset loop_info64 0 18405 &veth_change_mtu_fndecl_18405_fields
+max_psize_uac2_rtd_params_18407_fields max_psize uac2_rtd_params 0 18407 NULL
+acm_alloc_minor_fndecl_18412_fields acm_alloc_minor fndecl 0 18412 NULL
+bNrChannels_uac2_as_header_descriptor_18413_fields bNrChannels uac2_as_header_descriptor 0 18413 NULL
+ath6kl_wmi_ap_set_mlme_fndecl_18414_fields ath6kl_wmi_ap_set_mlme fndecl 2 18414 NULL
+hlen_hfi1_packet_18431_fields hlen hfi1_packet 0 18431 NULL
+fb_find_mode_fndecl_18438_fields fb_find_mode fndecl 7 18438 NULL
+device_pci_device_id_18441_fields device pci_device_id 0 18441 NULL
+count_iov_iter_18447_fields count iov_iter 0 18447 NULL
+data_len_hfa384x_tx_frame_18449_fields data_len hfa384x_tx_frame 0 18449 NULL nohasharray
+mp_tx_agg_buf_size_sdio_mmc_card_18449_fields mp_tx_agg_buf_size sdio_mmc_card 0 18449 &data_len_hfa384x_tx_frame_18449_fields
+copy_range_nfulnl_instance_18460_fields copy_range nfulnl_instance 0 18460 NULL nohasharray
+max_entries_bpf_map_18460_fields max_entries bpf_map 0 18460 &copy_range_nfulnl_instance_18460_fields
+bsize_jfs_sb_info_18477_fields bsize jfs_sb_info 0 18477 NULL
+ring_buffer_size_netup_dma_18485_fields ring_buffer_size netup_dma 0 18485 NULL
+mdata_ofsl_cyttsp4_sysinfo_data_18486_fields mdata_ofsl cyttsp4_sysinfo_data 0 18486 NULL
+sfi_map_table_fndecl_18501_fields sfi_map_table fndecl 1 18501 NULL
+run_test_both_formats_fndecl_18505_fields run_test_both_formats fndecl 2-3 18505 NULL
+vxfs_getfsh_fndecl_18506_fields vxfs_getfsh fndecl 2 18506 NULL
+tx_queue_len_net_device_18511_fields tx_queue_len net_device 0 18511 NULL
+iwl_queue_init_fndecl_18522_fields iwl_queue_init fndecl 2 18522 NULL nohasharray
+scat_entries_hif_scatter_req_18522_fields scat_entries hif_scatter_req 0 18522 &iwl_queue_init_fndecl_18522_fields
+ttm_bo_init_fndecl_18524_fields ttm_bo_init fndecl 3 18524 NULL
+progress_kcopyd_job_18540_fields progress kcopyd_job 0 18540 NULL
+sect_floppy_struct_18543_fields sect floppy_struct 0 18543 NULL
+ubi_leb_write_fndecl_18549_fields ubi_leb_write fndecl 5-4 18549 NULL
+xfs_efi_init_fndecl_18551_fields xfs_efi_init fndecl 2 18551 NULL
+inodes_squashfs_sb_info_18553_fields inodes squashfs_sb_info 0 18553 NULL
+single_sz_msc_18554_fields single_sz msc 0 18554 NULL nohasharray
+ucode_size_bytes_common_firmware_header_18554_fields ucode_size_bytes common_firmware_header 0 18554 &single_sz_msc_18554_fields
+memblock_reserve_fndecl_18556_fields memblock_reserve fndecl 1-2 18556 NULL
+riva_get_memlen_fndecl_18562_fields riva_get_memlen fndecl 0 18562 NULL
+change_protection_fndecl_18568_fields change_protection fndecl 3-2 18568 NULL
+index_xtsplit_18586_fields index xtsplit 0 18586 NULL
+nbuttons_gpio_keys_platform_data_18590_fields nbuttons gpio_keys_platform_data 0 18590 NULL
+omfs_fill_chain_fndecl_18591_fields omfs_fill_chain fndecl 3 18591 NULL
+brcmu_pkt_buf_get_skb_fndecl_18599_fields brcmu_pkt_buf_get_skb fndecl 1 18599 NULL
+extLocation_extent_ad_18601_fields extLocation extent_ad 0 18601 NULL
+num_of_queues_iwl_base_params_18606_fields num_of_queues iwl_base_params 0 18606 NULL
+size_uhid_input_req_18611_fields size uhid_input_req 0 18611 NULL
+befs_get_block_fndecl_18612_fields befs_get_block fndecl 2 18612 NULL
+dstpos_isdnhdlc_vars_18616_fields dstpos isdnhdlc_vars 0 18616 NULL nohasharray
+iwl_pcie_txq_init_fndecl_18616_fields iwl_pcie_txq_init fndecl 3 18616 &dstpos_isdnhdlc_vars_18616_fields
+ks8995_registers_write_fndecl_18618_fields ks8995_registers_write fndecl 6 18618 NULL
+ctxt_qib_ctxtdata_18626_fields ctxt qib_ctxtdata 0 18626 NULL
+sec_per_clus_fat_boot_sector_18633_fields sec_per_clus fat_boot_sector 0 18633 NULL
+store_bss_info_fndecl_18643_fields store_bss_info fndecl 7 18643 NULL
+rbd_parent_request_create_fndecl_18646_fields rbd_parent_request_create fndecl 3-2 18646 NULL
+speaker_outs_auto_pin_cfg_18648_fields speaker_outs auto_pin_cfg 0 18648 NULL
+ax25_sendmsg_fndecl_18649_fields ax25_sendmsg fndecl 3 18649 NULL
+bioset_create_fndecl_18655_fields bioset_create fndecl 2-1 18655 NULL
+MaxDevices__MSG_IOC_FACTS_REPLY_18656_fields MaxDevices _MSG_IOC_FACTS_REPLY 0 18656 NULL nohasharray
+ext2_xattr_set_fndecl_18656_fields ext2_xattr_set fndecl 5 18656 &MaxDevices__MSG_IOC_FACTS_REPLY_18656_fields
+compat_copy_entries_fndecl_18658_fields compat_copy_entries fndecl 0 18658 NULL
+length_vb2_plane_18662_fields length vb2_plane 0 18662 NULL
+gfs2_unstuffer_page_fndecl_18663_fields gfs2_unstuffer_page fndecl 3 18663 NULL
+num_ccells_per_conn_iscsi_kwqe_init1_18665_fields num_ccells_per_conn iscsi_kwqe_init1 0 18665 NULL
+nilfs_move_2nd_super_fndecl_18666_fields nilfs_move_2nd_super fndecl 2 18666 NULL
+len_xdr_netobj_18672_fields len xdr_netobj 0 18672 NULL
+pn_recvmsg_fndecl_18676_fields pn_recvmsg fndecl 3 18676 NULL
+nr_clk_regs_samsung_cmu_info_18678_fields nr_clk_regs samsung_cmu_info 0 18678 NULL
+ldm_frag_add_fndecl_18680_fields ldm_frag_add fndecl 2 18680 NULL
+ocd_max_easize_obd_connect_data_18682_fields ocd_max_easize obd_connect_data 0 18682 NULL
+domain_pci_sysdata_18686_fields domain pci_sysdata 0 18686 NULL
+i2c_wr_max_cx24120_config_18687_fields i2c_wr_max cx24120_config 0 18687 NULL nohasharray
+length_iwl_nvm_access_resp_18687_fields length iwl_nvm_access_resp 0 18687 &i2c_wr_max_cx24120_config_18687_fields
+num_tc_net_device_18703_fields num_tc net_device 0 18703 NULL
+size_rxdone_entry_desc_18704_fields size rxdone_entry_desc 0 18704 NULL
+den_step_snd_ratnum_18705_fields den_step snd_ratnum 0 18705 NULL nohasharray
+num_dup_tsns_sctp_tsnmap_18705_fields num_dup_tsns sctp_tsnmap 0 18705 &den_step_snd_ratnum_18705_fields
+ent_get_fatent_operations_18715_fields ent_get fatent_operations 0 18715 NULL
+read_reg_isar_hw_18717_fields read_reg isar_hw 0 18717 NULL
+feature_len_mic_device_desc_18719_fields feature_len mic_device_desc 0 18719 NULL
+max_pkeys_ib_device_attr_18722_fields max_pkeys ib_device_attr 0 18722 NULL
+trf7970a_read_cont_fndecl_18728_fields trf7970a_read_cont fndecl 4 18728 NULL
+ioapic_copy_alloc_attr_fndecl_18729_fields ioapic_copy_alloc_attr fndecl 3 18729 NULL
+sfi_map_memory_fndecl_18732_fields sfi_map_memory fndecl 2-1 18732 NULL
+sinit_num_ostreams_sctp_cookie_18733_fields sinit_num_ostreams sctp_cookie 0 18733 NULL
+pkcs7_sig_note_serial_fndecl_18735_fields pkcs7_sig_note_serial fndecl 5 18735 NULL
+rdb_per_qp_mthca_profile_18738_fields rdb_per_qp mthca_profile 0 18738 NULL
+bulk_out_ipheth_device_18739_fields bulk_out ipheth_device 0 18739 NULL
+o2net_recv_tcp_msg_fndecl_18741_fields o2net_recv_tcp_msg fndecl 3-0 18741 NULL
+count_configs_fndecl_18742_fields count_configs fndecl 0 18742 NULL
+max_sges_ocrdma_qp_hwq_info_18746_fields max_sges ocrdma_qp_hwq_info 0 18746 NULL
+seq_end_offset_iscsi_cmd_18748_fields seq_end_offset iscsi_cmd 0 18748 NULL
+max_in_size_ims_pcu_18752_fields max_in_size ims_pcu 0 18752 NULL
+__ocfs2_error_fndecl_18758_fields __ocfs2_error fndecl 0 18758 NULL
+i_pos_msdos_inode_info_18764_fields i_pos msdos_inode_info 0 18764 NULL
+xdr_get_next_encode_buffer_fndecl_18770_fields xdr_get_next_encode_buffer fndecl 2 18770 NULL nohasharray
+adjust_memory_fndecl_18770_fields adjust_memory fndecl 3-4 18770 &xdr_get_next_encode_buffer_fndecl_18770_fields
+data_len_ieee80211_mgd_auth_data_18778_fields data_len ieee80211_mgd_auth_data 0 18778 NULL
+nvif_device_init_fndecl_18779_fields nvif_device_init fndecl 5 18779 NULL
+cur_len_drm_dp_sideband_msg_tx_18787_fields cur_len drm_dp_sideband_msg_tx 0 18787 NULL
+mcopy_atomic_fndecl_18790_fields mcopy_atomic fndecl 2 18790 NULL
+isdn_ppp_skb_push_fndecl_18791_fields isdn_ppp_skb_push fndecl 2 18791 NULL
+sctp_abort_pkt_new_fndecl_18794_fields sctp_abort_pkt_new fndecl 6 18794 NULL
+max_low_pfn_vardecl_18798_fields max_low_pfn vardecl 0 18798 NULL
+usb_ep_set_maxpacket_limit_fndecl_18800_fields usb_ep_set_maxpacket_limit fndecl 2 18800 NULL
+readbuffers_v4l2_captureparm_18801_fields readbuffers v4l2_captureparm 0 18801 NULL
+md_capture_size_netxen_minidump_18805_fields md_capture_size netxen_minidump 0 18805 NULL
+ssb_ioremap_fndecl_18815_fields ssb_ioremap fndecl 2 18815 NULL
+length_xfs_extent_busy_18817_fields length xfs_extent_busy 0 18817 NULL
+tx_cnt_IsdnCardState_18819_fields tx_cnt IsdnCardState 0 18819 NULL
+shmem_seek_hole_data_fndecl_18824_fields shmem_seek_hole_data fndecl 0-2-3 18824 NULL
+p_memsz_elf32_phdr_18830_fields p_memsz elf32_phdr 0 18830 NULL nohasharray
+clk_num_clk_onecell_data_18830_fields clk_num clk_onecell_data 0 18830 &p_memsz_elf32_phdr_18830_fields
+num_entries_compat_ipt_replace_18835_fields num_entries compat_ipt_replace 0 18835 NULL
+xfs_inobt_insert_rec_fndecl_18839_fields xfs_inobt_insert_rec fndecl 4 18839 NULL
+rsn_ie_len_hostap_bss_info_18840_fields rsn_ie_len hostap_bss_info 0 18840 NULL
+number_snd_card_18845_fields number snd_card 0 18845 NULL
+exynos_drm_gem_init_fndecl_18846_fields exynos_drm_gem_init fndecl 2 18846 NULL
+n_targets_rsxx_cardinfo_18847_fields n_targets rsxx_cardinfo 0 18847 NULL nohasharray
+process_measurement_fndecl_18847_fields process_measurement fndecl 3 18847 &n_targets_rsxx_cardinfo_18847_fields
+taglen_nfsd4_compoundargs_18849_fields taglen nfsd4_compoundargs 0 18849 NULL nohasharray
+master_xfer_i2c_algorithm_18849_fields master_xfer i2c_algorithm 0 18849 &taglen_nfsd4_compoundargs_18849_fields
+usb_descriptor_fillbuf_fndecl_18853_fields usb_descriptor_fillbuf fndecl 0 18853 NULL nohasharray
+sco_sock_sendmsg_fndecl_18853_fields sco_sock_sendmsg fndecl 3 18853 &usb_descriptor_fillbuf_fndecl_18853_fields
+max_payload_fwnet_packet_task_18867_fields max_payload fwnet_packet_task 0 18867 NULL
+alloc_cache_blocks_with_hash_fndecl_18870_fields alloc_cache_blocks_with_hash fndecl 2 18870 NULL
+osd_y_pan_yuv_playback_info_18877_fields osd_y_pan yuv_playback_info 0 18877 NULL
+rx_buffer_len_atl1_adapter_18882_fields rx_buffer_len atl1_adapter 0 18882 NULL nohasharray
+allocate_cnodes_fndecl_18882_fields allocate_cnodes fndecl 1 18882 &rx_buffer_len_atl1_adapter_18882_fields
+min_index_rxe_type_info_18888_fields min_index rxe_type_info 0 18888 NULL
+rxd_rfsw_s_smt_fp_rxd_18889_fields rxd_rfsw s_smt_fp_rxd 0 18889 NULL
+nr_stripes_bcache_device_18895_fields nr_stripes bcache_device 0 18895 NULL
+rx_ps_hdr_size_igbvf_adapter_18896_fields rx_ps_hdr_size igbvf_adapter 0 18896 NULL nohasharray
+r592_write_fifo_pio_fndecl_18896_fields r592_write_fifo_pio fndecl 3 18896 &rx_ps_hdr_size_igbvf_adapter_18896_fields
+nilfs_max_size_fndecl_18901_fields nilfs_max_size fndecl 0-1 18901 NULL nohasharray
+op_dmaoff_rm_data_op_18901_fields op_dmaoff rm_data_op 0 18901 &nilfs_max_size_fndecl_18901_fields
+pep_sendmsg_fndecl_18903_fields pep_sendmsg fndecl 3 18903 NULL
+extent_invalidatepage_fndecl_18906_fields extent_invalidatepage fndecl 3 18906 NULL
+sectors_ssfdcr_record_18912_fields sectors ssfdcr_record 0 18912 NULL
+dccpd_opt_len_dccp_skb_cb_18917_fields dccpd_opt_len dccp_skb_cb 0 18917 NULL
+fuse_write_update_size_fndecl_18918_fields fuse_write_update_size fndecl 2 18918 NULL
+cciss_allocate_sg_chain_blocks_fndecl_18923_fields cciss_allocate_sg_chain_blocks fndecl 2 18923 NULL
+capacity_vmci_handle_arr_18924_fields capacity vmci_handle_arr 0 18924 NULL
+segment_size_kaweth_ethernet_configuration_18925_fields segment_size kaweth_ethernet_configuration 0 18925 NULL nohasharray
+vxfs_bread_fndecl_18925_fields vxfs_bread fndecl 2 18925 &segment_size_kaweth_ethernet_configuration_18925_fields
+size_gf100_gr_18928_fields size gf100_gr 0 18928 NULL
+ad714x_i2c_read_fndecl_18930_fields ad714x_i2c_read fndecl 4 18930 NULL
+maxReplyBytes_mpt_ioctl_command_18942_fields maxReplyBytes mpt_ioctl_command 0 18942 NULL
+read_pci_config_fndecl_18943_fields read_pci_config fndecl 0 18943 NULL
+rbd_segment_length_fndecl_18944_fields rbd_segment_length fndecl 0-2-3 18944 NULL
+cram_hmac_alg_len_net_conf_18947_fields cram_hmac_alg_len net_conf 0 18947 NULL
+length_rsp_que_18950_fields length rsp_que 0 18950 NULL
+btrfs_test_extent_buffer_operations_fndecl_18951_fields btrfs_test_extent_buffer_operations fndecl 1-2 18951 NULL
+qla82xx_pci_mem_read_2M_fndecl_18955_fields qla82xx_pci_mem_read_2M fndecl 2 18955 NULL
+encx24j600_raw_write_fndecl_18957_fields encx24j600_raw_write fndecl 4 18957 NULL nohasharray
+rss_queues_igb_adapter_18957_fields rss_queues igb_adapter 0 18957 &encx24j600_raw_write_fndecl_18957_fields
+new_sync_read_fndecl_18960_fields new_sync_read fndecl 0-3 18960 NULL nohasharray
+clear_refs_pte_range_fndecl_18960_fields clear_refs_pte_range fndecl 2 18960 &new_sync_read_fndecl_18960_fields
+file_offset_btrfs_ordered_extent_18963_fields file_offset btrfs_ordered_extent 0 18963 NULL
+len_dm_target_18965_fields len dm_target 0 18965 NULL
+read_off_videobuf_queue_18978_fields read_off videobuf_queue 0 18978 NULL
+rcount_mkiss_18984_fields rcount mkiss 0 18984 NULL nohasharray
+l2cap_sock_sendmsg_fndecl_18984_fields l2cap_sock_sendmsg fndecl 3 18984 &rcount_mkiss_18984_fields
+preferred_bpp_intel_fbdev_18985_fields preferred_bpp intel_fbdev 0 18985 NULL
+p9_get_mapped_pages_fndecl_18988_fields p9_get_mapped_pages fndecl 0 18988 NULL
+ttm_bo_kmap_ttm_fndecl_18993_fields ttm_bo_kmap_ttm fndecl 3 18993 NULL
+virtio_gpu_alloc_cmd_resp_fndecl_18996_fields virtio_gpu_alloc_cmd_resp fndecl 4-5 18996 NULL
+end_sk_buff_18998_fields end sk_buff 0 18998 NULL
+usb_hcd_check_unlink_urb_fndecl_18999_fields usb_hcd_check_unlink_urb fndecl 3 18999 NULL
+dm_alloc_md_mempools_fndecl_19008_fields dm_alloc_md_mempools fndecl 4 19008 NULL
+max_sectors_ata_device_19016_fields max_sectors ata_device 0 19016 NULL
+generic_splice_sendpage_fndecl_19018_fields generic_splice_sendpage fndecl 4 19018 NULL
+prevUnitNo_inftl_unithead1_19020_fields prevUnitNo inftl_unithead1 0 19020 NULL
+rsxx_queue_discard_fndecl_19027_fields rsxx_queue_discard fndecl 0 19027 NULL
+tcp_recvmsg_fndecl_19029_fields tcp_recvmsg fndecl 3 19029 NULL
+sge_size_MPT3SAS_ADAPTER_19030_fields sge_size MPT3SAS_ADAPTER 0 19030 NULL
+next_scan_nid_f2fs_nm_info_19036_fields next_scan_nid f2fs_nm_info 0 19036 NULL
+scrollback_max_vardecl_fbcon_c_19040_fields scrollback_max vardecl_fbcon.c 0 19040 NULL
+tsize_nfs2_fsstat_19041_fields tsize nfs2_fsstat 0 19041 NULL
+len_ath10k_dump_file_data_19052_fields len ath10k_dump_file_data 0 19052 NULL
+dma_usb_request_19054_fields dma usb_request 0 19054 NULL
+mod_len_extent_map_19058_fields mod_len extent_map 0 19058 NULL
+count_sgmapraw_19066_fields count sgmapraw 0 19066 NULL
+mem_size_memory_type_mapping_19073_fields mem_size memory_type_mapping 0 19073 NULL
+offs_ubifs_zbranch_19074_fields offs ubifs_zbranch 0 19074 NULL
+mei_cl_read_start_fndecl_19077_fields mei_cl_read_start fndecl 0 19077 NULL
+s_blocksize_super_block_19081_fields s_blocksize super_block 0 19081 NULL
+data_size_hpi_msg_data_19086_fields data_size hpi_msg_data 0 19086 NULL
+mei_hbm_cl_flow_control_req_fndecl_19089_fields mei_hbm_cl_flow_control_req fndecl 0 19089 NULL
+sb_logsectsize_xfs_sb_19098_fields sb_logsectsize xfs_sb 0 19098 NULL
+walk_node_fndecl_19114_fields walk_node fndecl 2 19114 NULL
+ceph_entity_name_encode_fndecl_19115_fields ceph_entity_name_encode fndecl 0 19115 NULL
+mv88e6xxx_read_fndecl_19142_fields mv88e6xxx_read fndecl 0 19142 NULL
+ssid_len_ieee80211_mgd_assoc_data_19143_fields ssid_len ieee80211_mgd_assoc_data 0 19143 NULL
+ctrl_set_res_hor_fndecl_19146_fields ctrl_set_res_hor fndecl 3 19146 NULL
+pgbase_nfs_readlinkargs_19150_fields pgbase nfs_readlinkargs 0 19150 NULL
+inftl_write_oob_fndecl_19154_fields inftl_write_oob fndecl 2-3 19154 NULL
+do_get_thread_area_fndecl_19157_fields do_get_thread_area fndecl 2 19157 NULL
+__mnt_want_write_fndecl_19160_fields __mnt_want_write fndecl 0 19160 NULL
+page_array_size_firmware_buf_19163_fields page_array_size firmware_buf 0 19163 NULL
+ve_attrlen_nfsd4_verify_19164_fields ve_attrlen nfsd4_verify 0 19164 NULL
+dma_start_hi_rx_buf_desc_19167_fields dma_start_hi rx_buf_desc 0 19167 NULL
+isp116x_urb_dequeue_fndecl_19169_fields isp116x_urb_dequeue fndecl 3 19169 NULL
+xfs_mru_cache_insert_fndecl_19180_fields xfs_mru_cache_insert fndecl 0 19180 NULL
+mic_read_spad_fndecl_19184_fields mic_read_spad fndecl 0 19184 NULL
+crypto_authenc_esn_copy_fndecl_19188_fields crypto_authenc_esn_copy fndecl 2 19188 NULL nohasharray
+vmw_user_shader_alloc_fndecl_19188_fields vmw_user_shader_alloc fndecl 3 19188 &crypto_authenc_esn_copy_fndecl_19188_fields
+st21nfca_hci_dm_get_info_fndecl_19189_fields st21nfca_hci_dm_get_info fndecl 3 19189 NULL nohasharray
+xen_max_p2m_pfn_vardecl_19189_fields xen_max_p2m_pfn vardecl 0 19189 &st21nfca_hci_dm_get_info_fndecl_19189_fields
+nci_allocate_device_fndecl_19192_fields nci_allocate_device fndecl 3 19192 NULL
+slot_nr_nfs4_slot_19196_fields slot_nr nfs4_slot 0 19196 NULL
+decode_height_yuv_playback_info_19201_fields decode_height yuv_playback_info 0 19201 NULL
+extent_clear_unlock_delalloc_fndecl_19205_fields extent_clear_unlock_delalloc fndecl 2-3 19205 NULL
+irq_dma_handle_ttusb_dec_19208_fields irq_dma_handle ttusb_dec 0 19208 NULL
+m25p80_write_reg_fndecl_19209_fields m25p80_write_reg fndecl 4 19209 NULL
+size_afs_file_status_19215_fields size afs_file_status 0 19215 NULL
+extensions_edid_19218_fields extensions edid 0 19218 NULL
+lfb_size_screen_info_19219_fields lfb_size screen_info 0 19219 NULL
+vmw_cmdbuf_alloc_fndecl_19226_fields vmw_cmdbuf_alloc fndecl 2 19226 NULL
+csio_add_debugfs_mem_fndecl_19228_fields csio_add_debugfs_mem fndecl 4 19228 NULL
+__ai_size_pcpu_alloc_info_19229_fields __ai_size pcpu_alloc_info 0 19229 NULL
+offset_iomap_19237_fields offset iomap 0 19237 NULL
+spi_populate_ppr_msg_fndecl_19239_fields spi_populate_ppr_msg fndecl 0 19239 NULL
+matroxfb_pitch_adjust_fndecl_19243_fields matroxfb_pitch_adjust fndecl 0-2 19243 NULL
+mthca_map_reg_fndecl_19251_fields mthca_map_reg fndecl 3-2 19251 NULL
+ieee802154_hdr_push_sechdr_fndecl_19265_fields ieee802154_hdr_push_sechdr fndecl 0 19265 NULL
+batadv_frag_create_fndecl_19270_fields batadv_frag_create fndecl 3 19270 NULL
+tail_aio_ring_19271_fields tail aio_ring 0 19271 NULL
+vmw_kms_readback_fndecl_19276_fields vmw_kms_readback fndecl 6 19276 NULL
+early_init_dt_reserve_memory_arch_fndecl_19285_fields early_init_dt_reserve_memory_arch fndecl 2-1 19285 NULL
+virtio_gpu_cmd_resource_flush_fndecl_19291_fields virtio_gpu_cmd_resource_flush fndecl 5-6 19291 NULL nohasharray
+index_scsi_tape_19291_fields index scsi_tape 0 19291 &virtio_gpu_cmd_resource_flush_fndecl_19291_fields
+get_packet_fndecl_19296_fields get_packet fndecl 3 19296 NULL
+vxge_change_mtu_fndecl_19297_fields vxge_change_mtu fndecl 2 19297 NULL
+ext_len_xfs_extent_19299_fields ext_len xfs_extent 0 19299 NULL
+num_alt_cx231xx_video_mode_19301_fields num_alt cx231xx_video_mode 0 19301 NULL
+ubi_calc_fm_size_fndecl_19302_fields ubi_calc_fm_size fndecl 0 19302 NULL
+copy_vma_fndecl_19303_fields copy_vma fndecl 2-3-4 19303 NULL
+port_priv_size_rocker_world_ops_19308_fields port_priv_size rocker_world_ops 0 19308 NULL nohasharray
+cl_cpg_ocfs2_chain_list_19308_fields cl_cpg ocfs2_chain_list 0 19308 &port_priv_size_rocker_world_ops_19308_fields
+ve4_indsize_vxfs_ext4_19315_fields ve4_indsize vxfs_ext4 0 19315 NULL
+reply_sz_MPT3SAS_ADAPTER_19317_fields reply_sz MPT3SAS_ADAPTER 0 19317 NULL
+bpp_vardecl_nvidia_c_19325_fields bpp vardecl_nvidia.c 0 19325 NULL
+meta_dev_len_disk_conf_19326_fields meta_dev_len disk_conf 0 19326 NULL
+mlx4_alloc_resize_buf_fndecl_19329_fields mlx4_alloc_resize_buf fndecl 3 19329 NULL
+pkt_len_or_gro_seg_len_eth_fast_path_rx_cqe_19330_fields pkt_len_or_gro_seg_len eth_fast_path_rx_cqe 0 19330 NULL nohasharray
+finish_request_fndecl_19330_fields finish_request fndecl 4 19330 &pkt_len_or_gro_seg_len_eth_fast_path_rx_cqe_19330_fields
+rule_size_fib_rules_ops_19335_fields rule_size fib_rules_ops 0 19335 NULL
+do_writev_fndecl_19339_fields do_writev fndecl 3 19339 NULL
+sock_alloc_send_pskb_fndecl_19354_fields sock_alloc_send_pskb fndecl 3 19354 NULL
+ds_channels_snd_rme9652_19357_fields ds_channels snd_rme9652 0 19357 NULL
+lpfc_sriov_nr_virtfn_init_fndecl_19359_fields lpfc_sriov_nr_virtfn_init fndecl 2 19359 NULL nohasharray
+minimum_acpi_resource_io_19359_fields minimum acpi_resource_io 0 19359 &lpfc_sriov_nr_virtfn_init_fndecl_19359_fields
+nodesize_scrub_ctx_19371_fields nodesize scrub_ctx 0 19371 NULL
+size_mdu_array_info_s_19374_fields size mdu_array_info_s 0 19374 NULL
+cx25840_read_fndecl_19386_fields cx25840_read fndecl 0 19386 NULL
+padlen_ip_beet_phdr_19393_fields padlen ip_beet_phdr 0 19393 NULL
+ixgb_check_copybreak_fndecl_19396_fields ixgb_check_copybreak fndecl 3 19396 NULL
+ceph_msg_new_fndecl_19397_fields ceph_msg_new fndecl 2 19397 NULL
+ext4_xattr_set_fndecl_19403_fields ext4_xattr_set fndecl 5 19403 NULL
+max_sqes_bnx2i_hba_19405_fields max_sqes bnx2i_hba 0 19405 NULL
+rec_len_ocfs2_dir_entry_19408_fields rec_len ocfs2_dir_entry 0 19408 NULL
+shmem_alloc_hugepage_fndecl_19415_fields shmem_alloc_hugepage fndecl 3 19415 NULL
+num_ip_blocks_amdgpu_device_19419_fields num_ip_blocks amdgpu_device 0 19419 NULL
+size_mthca_resource_19420_fields size mthca_resource 0 19420 NULL
+fw_card_add_fndecl_19423_fields fw_card_add fndecl 2 19423 NULL
+mixer_nid_hda_gen_spec_19429_fields mixer_nid hda_gen_spec 0 19429 NULL
+btrfs_test_free_space_tree_fndecl_19430_fields btrfs_test_free_space_tree fndecl 1-2 19430 NULL
+chip_rcv_array_count_hfi1_devdata_19432_fields chip_rcv_array_count hfi1_devdata 0 19432 NULL
+tid_il_compressed_ba_resp_19443_fields tid il_compressed_ba_resp 0 19443 NULL nohasharray
+phys_addr_sfi_timer_table_entry_19443_fields phys_addr sfi_timer_table_entry 0 19443 &tid_il_compressed_ba_resp_19443_fields
+config_buf_fndecl_19445_fields config_buf fndecl 0 19445 NULL
+clone_bio_fndecl_19454_fields clone_bio fndecl 3-0-4 19454 NULL
+i965_gtt_total_entries_fndecl_19464_fields i965_gtt_total_entries fndecl 0 19464 NULL
+vcc_connect_fndecl_19469_fields vcc_connect fndecl 4-3 19469 NULL nohasharray
+size_nvbios_image_19469_fields size nvbios_image 0 19469 &vcc_connect_fndecl_19469_fields
+kclist_add_fndecl_19472_fields kclist_add fndecl 3 19472 NULL nohasharray
+dvb_ep_bulk_em28xx_19472_fields dvb_ep_bulk em28xx 0 19472 &kclist_add_fndecl_19472_fields
+dma_xfer_cnt_ivtv_buffer_19475_fields dma_xfer_cnt ivtv_buffer 0 19475 NULL
+orig_block_len_extent_map_19476_fields orig_block_len extent_map 0 19476 NULL
+ath6kl_wmi_ap_hidden_ssid_fndecl_19481_fields ath6kl_wmi_ap_hidden_ssid fndecl 2 19481 NULL
+fackets_out_tcp_sock_19484_fields fackets_out tcp_sock 0 19484 NULL
+nvme_pci_sriov_configure_fndecl_19485_fields nvme_pci_sriov_configure fndecl 2 19485 NULL
+ieee80211_change_mtu_fndecl_19486_fields ieee80211_change_mtu fndecl 2 19486 NULL nohasharray
+lookup_string_fndecl_19486_fields lookup_string fndecl 0 19486 &ieee80211_change_mtu_fndecl_19486_fields
+ath6kl_set_bitrate_mask32_fndecl_19488_fields ath6kl_set_bitrate_mask32 fndecl 2 19488 NULL
+drm_gtf_mode_fndecl_19489_fields drm_gtf_mode fndecl 3-2-4 19489 NULL nohasharray
+add_device_fndecl_19489_fields add_device fndecl 2 19489 &drm_gtf_mode_fndecl_19489_fields
+length_mwifiex_types_power_group_19491_fields length mwifiex_types_power_group 0 19491 NULL
+len_ib_ucm_sidr_req_19499_fields len ib_ucm_sidr_req 0 19499 NULL
+libfc_vport_create_fndecl_19500_fields libfc_vport_create fndecl 2 19500 NULL
+access_process_vm_fndecl_19503_fields access_process_vm fndecl 4-2 19503 NULL
+size_rvt_rq_19507_fields size rvt_rq 0 19507 NULL
+sctp_sendmsg_fndecl_19508_fields sctp_sendmsg fndecl 3 19508 NULL
+dev_cdev_19510_fields dev cdev 0 19510 NULL
+count_sgmap64_19513_fields count sgmap64 0 19513 NULL
+pglen_nfs_readlinkargs_19521_fields pglen nfs_readlinkargs 0 19521 NULL
+i40e_reconfig_rss_queues_fndecl_19528_fields i40e_reconfig_rss_queues fndecl 2 19528 NULL
+height_simplefb_platform_data_19532_fields height simplefb_platform_data 0 19532 NULL
+memparse_fndecl_19535_fields memparse fndecl 0 19535 NULL
+in_dma_usb_keyspan_19540_fields in_dma usb_keyspan 0 19540 NULL
+entries_size_ebt_table_info_19543_fields entries_size ebt_table_info 0 19543 NULL nohasharray
+nilfs_sufile_set_alloc_range_fndecl_19543_fields nilfs_sufile_set_alloc_range fndecl 3-2 19543 &entries_size_ebt_table_info_19543_fields
+get_response_hdac_bus_ops_19545_fields get_response hdac_bus_ops 0 19545 NULL
+read_code_fndecl_19550_fields read_code fndecl 4 19550 NULL
+send_size_send_ctx_19552_fields send_size send_ctx 0 19552 NULL
+softback_curr_vardecl_fbcon_c_19553_fields softback_curr vardecl_fbcon.c 0 19553 NULL
+cmpt_entry_sz_mlx4_dev_cap_19564_fields cmpt_entry_sz mlx4_dev_cap 0 19564 NULL
+uni16_to_x8_fndecl_19571_fields uni16_to_x8 fndecl 0 19571 NULL
+sd_pkt_scan_bayer_fndecl_19581_fields sd_pkt_scan_bayer fndecl 3 19581 NULL
+ath6kl_wmi_set_txe_notify_fndecl_19582_fields ath6kl_wmi_set_txe_notify fndecl 2 19582 NULL
+bytes_per_track_mspro_devinfo_19584_fields bytes_per_track mspro_devinfo 0 19584 NULL
+set_link_security_fndecl_19589_fields set_link_security fndecl 4 19589 NULL
+rx_max_pending_ethtool_ringparam_19591_fields rx_max_pending ethtool_ringparam 0 19591 NULL
+l1oip_socket_parse_fndecl_19592_fields l1oip_socket_parse fndecl 4 19592 NULL
+icc_empty_fifo_fndecl_19594_fields icc_empty_fifo fndecl 2 19594 NULL
+xdr_stream_pos_fndecl_19598_fields xdr_stream_pos fndecl 0 19598 NULL
+command_size_drm_qxl_command_19601_fields command_size drm_qxl_command 0 19601 NULL
+readpos_seq_buf_19607_fields readpos seq_buf 0 19607 NULL
+gspca_frame_add_fndecl_19612_fields gspca_frame_add fndecl 4 19612 NULL
+logical_btrfs_io_bio_19616_fields logical btrfs_io_bio 0 19616 NULL
+name_len_ext4_dir_entry_2_19628_fields name_len ext4_dir_entry_2 0 19628 NULL
+logical_io_failure_record_19631_fields logical io_failure_record 0 19631 NULL
+softback_buf_vardecl_fbcon_c_19637_fields softback_buf vardecl_fbcon.c 0 19637 NULL
+sdio_io_rw_ext_helper_fndecl_19641_fields sdio_io_rw_ext_helper fndecl 6 19641 NULL
+set_fp_int_qed_common_ops_19644_fields set_fp_int qed_common_ops 0 19644 NULL nohasharray
+pcfg_ofsh_cyttsp4_sysinfo_data_19644_fields pcfg_ofsh cyttsp4_sysinfo_data 0 19644 &set_fp_int_qed_common_ops_19644_fields
+memory_maker_code_mspro_sys_info_19650_fields memory_maker_code mspro_sys_info 0 19650 NULL
+af9033_rd_regs_fndecl_19652_fields af9033_rd_regs fndecl 4 19652 NULL
+hr_itemcount_hsm_request_19657_fields hr_itemcount hsm_request 0 19657 NULL
+configfs_dir_lseek_fndecl_19658_fields configfs_dir_lseek fndecl 2 19658 NULL
+peer_fwd_cnt_virtio_vsock_sock_19661_fields peer_fwd_cnt virtio_vsock_sock 0 19661 NULL
+tty_register_device_fndecl_19667_fields tty_register_device fndecl 2 19667 NULL
+videobuf_vmalloc_to_sg_fndecl_19671_fields videobuf_vmalloc_to_sg fndecl 2 19671 NULL
+recv_intr_pipe_us_data_19678_fields recv_intr_pipe us_data 0 19678 NULL
+num_leds_adp8860_backlight_platform_data_19687_fields num_leds adp8860_backlight_platform_data 0 19687 NULL
+depth_em28xx_fmt_19696_fields depth em28xx_fmt 0 19696 NULL nohasharray
+size_pkt_hdr_19696_fields size pkt_hdr 0 19696 &depth_em28xx_fmt_19696_fields nohasharray
+pcnt_bits_ubifs_info_19696_fields pcnt_bits ubifs_info 0 19696 &size_pkt_hdr_19696_fields nohasharray
+prealloc_bufsz_comedi_async_19696_fields prealloc_bufsz comedi_async 0 19696 &pcnt_bits_ubifs_info_19696_fields
+gfs2_file_splice_write_fndecl_19705_fields gfs2_file_splice_write fndecl 4 19705 NULL
+max_blksize_sdio_func_19715_fields max_blksize sdio_func 0 19715 NULL
+LastFreeEUN_NFTLrecord_19717_fields LastFreeEUN NFTLrecord 0 19717 NULL
+slots_end_qxl_rom_19718_fields slots_end qxl_rom 0 19718 NULL
+fat32_info_sector_fat_bios_param_block_19727_fields fat32_info_sector fat_bios_param_block 0 19727 NULL
+writelen_iuu_private_19742_fields writelen iuu_private 0 19742 NULL
+drbd_csum_ee_size_fndecl_19743_fields drbd_csum_ee_size fndecl 4 19743 NULL
+ntb_netdev_change_mtu_fndecl_19744_fields ntb_netdev_change_mtu fndecl 2 19744 NULL
+nmap_ib_umem_19745_fields nmap ib_umem 0 19745 NULL nohasharray
+nftl_write_oob_fndecl_19745_fields nftl_write_oob fndecl 2-3 19745 &nmap_ib_umem_19745_fields
+f2fs_i_size_write_fndecl_19746_fields f2fs_i_size_write fndecl 2 19746 NULL
+c67x00_giveback_urb_fndecl_19761_fields c67x00_giveback_urb fndecl 3 19761 NULL
+vram_base_qxl_device_19773_fields vram_base qxl_device 0 19773 NULL
+onenand_read_ops_nolock_fndecl_19774_fields onenand_read_ops_nolock fndecl 2 19774 NULL
+gss_decrypt_xdr_buf_fndecl_19786_fields gss_decrypt_xdr_buf fndecl 3 19786 NULL
+rcvbuf_size_rds_tcp_net_19796_fields rcvbuf_size rds_tcp_net 0 19796 NULL
+num_u2_ports_xhci_hcd_mtk_19801_fields num_u2_ports xhci_hcd_mtk 0 19801 NULL
+fromlen_nfs3_symlinkargs_19803_fields fromlen nfs3_symlinkargs 0 19803 NULL
+btrfs_test_inodes_fndecl_19807_fields btrfs_test_inodes fndecl 1-2 19807 NULL
+len_rpcsec_gss_oid_19814_fields len rpcsec_gss_oid 0 19814 NULL
+eeprom_len_niu_19815_fields eeprom_len niu 0 19815 NULL
+svcrdma_max_bc_requests_vardecl_19819_fields svcrdma_max_bc_requests vardecl 0 19819 NULL
+oid_printf_vargs_fndecl_19821_fields oid_printf_vargs fndecl 0 19821 NULL
+vring_new_virtqueue_fndecl_19828_fields vring_new_virtqueue fndecl 2 19828 NULL
+_osd_req_list_objects_fndecl_19839_fields _osd_req_list_objects fndecl 6 19839 NULL
+buf_used_uvc_video_queue_19843_fields buf_used uvc_video_queue 0 19843 NULL
+fbmem_start_viafb_dev_19849_fields fbmem_start viafb_dev 0 19849 NULL
+num_jumbo_rxd_qlcnic_adapter_19850_fields num_jumbo_rxd qlcnic_adapter 0 19850 NULL
+qp_guest_endpoint_create_fndecl_19852_fields qp_guest_endpoint_create fndecl 5-4 19852 NULL nohasharray
+real_size_in_page_qed_ilt_cli_blk_19852_fields real_size_in_page qed_ilt_cli_blk 0 19852 &qp_guest_endpoint_create_fndecl_19852_fields
+i5k_channel_probe_fndecl_19853_fields i5k_channel_probe fndecl 2 19853 NULL
+max_msix_vectors_ixgbe_mac_info_19874_fields max_msix_vectors ixgbe_mac_info 0 19874 NULL
+msb_do_write_request_fndecl_19885_fields msb_do_write_request fndecl 2 19885 NULL
+size_sst_block_19887_fields size sst_block 0 19887 NULL
+ide_find_dma_mode_fndecl_19889_fields ide_find_dma_mode fndecl 0 19889 NULL
+kmemleak_alloc_fndecl_19891_fields kmemleak_alloc fndecl 2 19891 NULL
+register_sound_midi_fndecl_19894_fields register_sound_midi fndecl 2 19894 NULL
+i915_gem_object_pin_fndecl_19904_fields i915_gem_object_pin fndecl 4 19904 NULL
+truncate_inline_extent_fndecl_19906_fields truncate_inline_extent fndecl 5 19906 NULL
+__pool_find_fndecl_19911_fields __pool_find fndecl 3 19911 NULL
+slot_dlm_slot_19913_fields slot dlm_slot 0 19913 NULL
+maxLen_group_data_19920_fields maxLen group_data 0 19920 NULL
+xt_compat_add_offset_fndecl_19922_fields xt_compat_add_offset fndecl 0 19922 NULL nohasharray
+cp_change_mtu_fndecl_19922_fields cp_change_mtu fndecl 2 19922 &xt_compat_add_offset_fndecl_19922_fields nohasharray
+do_readv_fndecl_19922_fields do_readv fndecl 3 19922 &cp_change_mtu_fndecl_19922_fields
+sector_number_phys_req_19923_fields sector_number phys_req 0 19923 NULL
+xfs_rmap_btrec_to_irec_fndecl_19931_fields xfs_rmap_btrec_to_irec fndecl 0 19931 NULL nohasharray
+iic_tpm_write_generic_fndecl_19931_fields iic_tpm_write_generic fndecl 3 19931 &xfs_rmap_btrec_to_irec_fndecl_19931_fields
+unix_stream_sendmsg_fndecl_19940_fields unix_stream_sendmsg fndecl 3 19940 NULL
+wusbhc_giveback_urb_fndecl_19954_fields wusbhc_giveback_urb fndecl 3 19954 NULL
+ipoib_sendq_size_vardecl_19969_fields ipoib_sendq_size vardecl 0 19969 NULL
+src_len_ccp_passthru_engine_19970_fields src_len ccp_passthru_engine 0 19970 NULL
+end_iwl_prph_range_19976_fields end iwl_prph_range 0 19976 NULL
+size_packet_settings_19984_fields size packet_settings 0 19984 NULL
+palign_qib_devdata_19988_fields palign qib_devdata 0 19988 NULL
+ocfs2_defrag_extent_fndecl_19994_fields ocfs2_defrag_extent fndecl 3-2 19994 NULL
+move_extent_per_page_fndecl_20004_fields move_extent_per_page fndecl 5-6-4-3 20004 NULL
+copybreak_vardecl_sky2_c_20006_fields copybreak vardecl_sky2.c 0 20006 NULL
+def_bpp_sm501_platdata_fbsub_20007_fields def_bpp sm501_platdata_fbsub 0 20007 NULL
+i_inline_size_ext4_inode_info_20015_fields i_inline_size ext4_inode_info 0 20015 NULL
+y_drm_fb_helper_crtc_20016_fields y drm_fb_helper_crtc 0 20016 NULL nohasharray
+start_bus_number_acpi_mcfg_allocation_20016_fields start_bus_number acpi_mcfg_allocation 0 20016 &y_drm_fb_helper_crtc_20016_fields
+ctl_dma_cm109_dev_20023_fields ctl_dma cm109_dev 0 20023 NULL
+build_skb_fndecl_20027_fields build_skb fndecl 2 20027 NULL nohasharray
+zone_absent_pages_in_node_fndecl_20027_fields zone_absent_pages_in_node fndecl 0 20027 &build_skb_fndecl_20027_fields
+nr_max310x_devtype_20030_fields nr max310x_devtype 0 20030 NULL
+sample_rate_lola_20032_fields sample_rate lola 0 20032 NULL
+block_size_osst_tape_20034_fields block_size osst_tape 0 20034 NULL
+rcvhdrentsize_qib_devdata_20040_fields rcvhdrentsize qib_devdata 0 20040 NULL
+nr_luns_nvm_dev_20042_fields nr_luns nvm_dev 0 20042 NULL
+batadv_interface_change_mtu_fndecl_20043_fields batadv_interface_change_mtu fndecl 2 20043 NULL nohasharray
+id_len_netdev_phys_item_id_20043_fields id_len netdev_phys_item_id 0 20043 &batadv_interface_change_mtu_fndecl_20043_fields
+max_rqst_sz_nfs4_channel_attrs_20083_fields max_rqst_sz nfs4_channel_attrs 0 20083 NULL
+rxsize_grcan_device_config_20087_fields rxsize grcan_device_config 0 20087 NULL
+submit_rtpg_fndecl_20091_fields submit_rtpg fndecl 3 20091 NULL
+bnx2_set_rx_ring_size_fndecl_20092_fields bnx2_set_rx_ring_size fndecl 2 20092 NULL
+r8712_read32_fndecl_20095_fields r8712_read32 fndecl 0 20095 NULL
+reg_count_cs_extent_def_20096_fields reg_count cs_extent_def 0 20096 NULL
+dm_bufio_get_block_number_fndecl_20097_fields dm_bufio_get_block_number fndecl 0 20097 NULL
+qla82xx_pci_mem_write_direct_fndecl_20099_fields qla82xx_pci_mem_write_direct fndecl 2 20099 NULL
+minimum_v4l2_ctrl_20103_fields minimum v4l2_ctrl 0 20103 NULL
+precopy_buffers_fndecl_20104_fields precopy_buffers fndecl 3 20104 NULL
+accum_len_kcm_rx_msg_20108_fields accum_len kcm_rx_msg 0 20108 NULL
+max_acl_len_hci_rp_read_data_block_size_20119_fields max_acl_len hci_rp_read_data_block_size 0 20119 NULL
+d_nhash_vxfs_dirblk_20122_fields d_nhash vxfs_dirblk 0 20122 NULL
+ao_chans_pci224_board_20129_fields ao_chans pci224_board 0 20129 NULL
+btrfs_punch_hole_fndecl_20130_fields btrfs_punch_hole fndecl 3-2 20130 NULL
+in_ep_snd_usb_midi_endpoint_info_20132_fields in_ep snd_usb_midi_endpoint_info 0 20132 NULL
+data_sectors_per_block_partition_20138_fields data_sectors_per_block partition 0 20138 NULL
+pos_f_hidg_req_list_20147_fields pos f_hidg_req_list 0 20147 NULL
+ep_in_if_usb_card_20154_fields ep_in if_usb_card 0 20154 NULL
+tpci200_create_device_fndecl_20157_fields tpci200_create_device fndecl 2 20157 NULL
+nr_gpio_tle62x0_state_20178_fields nr_gpio tle62x0_state 0 20178 NULL
+usb_ftdi_elan_edset_single_fndecl_20181_fields usb_ftdi_elan_edset_single fndecl 0 20181 NULL nohasharray
+swapRB_sd_20181_fields swapRB sd 0 20181 &usb_ftdi_elan_edset_single_fndecl_20181_fields
+fuse_lseek_fndecl_20193_fields fuse_lseek fndecl 2 20193 NULL
+iram_base_intel_sst_drv_20196_fields iram_base intel_sst_drv 0 20196 NULL nohasharray
+agp_memory_reserved_vardecl_20196_fields agp_memory_reserved vardecl 0 20196 &iram_base_intel_sst_drv_20196_fields
+qxl_gem_object_create_with_handle_fndecl_20198_fields qxl_gem_object_create_with_handle fndecl 4 20198 NULL
+fpage_size_genwqe_sgl_20199_fields fpage_size genwqe_sgl 0 20199 NULL
+sectors_per_block_bits_dm_bufio_client_20202_fields sectors_per_block_bits dm_bufio_client 0 20202 NULL
+dma_limit_tg3_20210_fields dma_limit tg3 0 20210 NULL
+objlayout_write_done_fndecl_20211_fields objlayout_write_done fndecl 2 20211 NULL
+compr_fill_fndecl_20214_fields compr_fill fndecl 2 20214 NULL
+rx_buffer_size_freelQ_20218_fields rx_buffer_size freelQ 0 20218 NULL
+dmah_acm_wb_20221_fields dmah acm_wb 0 20221 NULL
+setup_sgl_buf_fndecl_20237_fields setup_sgl_buf fndecl 4 20237 NULL
+phys_map_info_20239_fields phys map_info 0 20239 NULL
+mac_find_mode_fndecl_20243_fields mac_find_mode fndecl 4 20243 NULL
+vtotal_psb_pipe_20245_fields vtotal psb_pipe 0 20245 NULL
+nilfs_read_super_block_fndecl_20246_fields nilfs_read_super_block fndecl 3-2 20246 NULL
+size_drm_virtgpu_resource_create_20248_fields size drm_virtgpu_resource_create 0 20248 NULL nohasharray
+i2c_writebytes_fndecl_20248_fields i2c_writebytes fndecl 3 20248 &size_drm_virtgpu_resource_create_20248_fields
+max_size_inet_frag_queue_20249_fields max_size inet_frag_queue 0 20249 NULL
+ip_append_page_fndecl_20261_fields ip_append_page fndecl 5-4 20261 NULL
+foff_pnfs_block_extent_20264_fields foff pnfs_block_extent 0 20264 NULL
+value_len_ocfs2_security_xattr_info_20265_fields value_len ocfs2_security_xattr_info 0 20265 NULL
+y_skip_top_mt9t031_20278_fields y_skip_top mt9t031 0 20278 NULL
+fifo_size_eg20t_port_20279_fields fifo_size eg20t_port 0 20279 NULL
+size_vx_ibl_info_20282_fields size vx_ibl_info 0 20282 NULL
+soc_mbus_bytes_per_line_fndecl_20288_fields soc_mbus_bytes_per_line fndecl 0-1 20288 NULL
+blk_queue_io_min_fndecl_20293_fields blk_queue_io_min fndecl 2 20293 NULL
+total_blocks_partition_20302_fields total_blocks partition 0 20302 NULL nohasharray
+gen8_get_total_gtt_size_fndecl_20302_fields gen8_get_total_gtt_size fndecl 0-1 20302 &total_blocks_partition_20302_fields
+mpegbufs_vardecl_cx231xx_417_c_20303_fields mpegbufs vardecl_cx231xx-417.c 0 20303 NULL
+fallback_aper_order_vardecl_20308_fields fallback_aper_order vardecl 0 20308 NULL
+xfs_dir2_leaf_trim_data_fndecl_20310_fields xfs_dir2_leaf_trim_data fndecl 3 20310 NULL nohasharray
+index_vardecl_nm256_c_20310_fields index vardecl_nm256.c 0 20310 &xfs_dir2_leaf_trim_data_fndecl_20310_fields
+cas_change_mtu_fndecl_20320_fields cas_change_mtu fndecl 2 20320 NULL
+num_cvts_hdmi_spec_20322_fields num_cvts hdmi_spec 0 20322 NULL
+qlf_blkno_xfs_dq_logformat_20330_fields qlf_blkno xfs_dq_logformat 0 20330 NULL
+ss_out_channels_hdspm_20338_fields ss_out_channels hdspm 0 20338 NULL
+offset_videobuf_dmabuf_20339_fields offset videobuf_dmabuf 0 20339 NULL
+sq_wqe_count_mlx5_ib_create_qp_20350_fields sq_wqe_count mlx5_ib_create_qp 0 20350 NULL
+sections_pe_hdr_20351_fields sections pe_hdr 0 20351 NULL
+memblock_find_in_range_fndecl_20356_fields memblock_find_in_range fndecl 0-4-3-1-2 20356 NULL
+chipshift_alauda_card_info_20364_fields chipshift alauda_card_info 0 20364 NULL
+type_usbdevfs_urb_20367_fields type usbdevfs_urb 0 20367 NULL
+hw_block_size_se_dev_attrib_20373_fields hw_block_size se_dev_attrib 0 20373 NULL nohasharray
+cfgctxts_qib_devdata_20373_fields cfgctxts qib_devdata 0 20373 &hw_block_size_se_dev_attrib_20373_fields
+nstamps_max_mask_recent_table_20374_fields nstamps_max_mask recent_table 0 20374 NULL
+striped_read_fndecl_20378_fields striped_read fndecl 0-2 20378 NULL
+opts1_rx_desc_20387_fields opts1 rx_desc 0 20387 NULL
+btrfs_del_items_fndecl_20388_fields btrfs_del_items fndecl 5 20388 NULL
+sw_nchannels_stm_data_20389_fields sw_nchannels stm_data 0 20389 NULL
+sys_pwritev2_fndecl_20390_fields sys_pwritev2 fndecl 3 20390 NULL
+leb_size_ubi_device_20396_fields leb_size ubi_device 0 20396 NULL
+regulator_register_always_on_fndecl_20403_fields regulator_register_always_on fndecl 1 20403 NULL
+shmem_alloc_and_acct_page_fndecl_20407_fields shmem_alloc_and_acct_page fndecl 4 20407 NULL
+num_units_wlan_host_mem_req_20410_fields num_units wlan_host_mem_req 0 20410 NULL
+mc_rreg_radeon_device_20418_fields mc_rreg radeon_device 0 20418 NULL
+sd_log_head_gfs2_sbd_20435_fields sd_log_head gfs2_sbd 0 20435 NULL
+blob_len_trusted_key_payload_20437_fields blob_len trusted_key_payload 0 20437 NULL nohasharray
+raw_skid_size_x509_certificate_20437_fields raw_skid_size x509_certificate 0 20437 &blob_len_trusted_key_payload_20437_fields
+octeon_init_instr_queue_fndecl_20439_fields octeon_init_instr_queue fndecl 3 20439 NULL
+gigaset_isoc_receive_fndecl_20447_fields gigaset_isoc_receive fndecl 2 20447 NULL
+ib_max_size_mvumi_hba_20452_fields ib_max_size mvumi_hba 0 20452 NULL
+stride_banshee_reg_20459_fields stride banshee_reg 0 20459 NULL
+gigaset_if_receive_fndecl_20462_fields gigaset_if_receive fndecl 3 20462 NULL
+xfs_setsize_buftarg_fndecl_20465_fields xfs_setsize_buftarg fndecl 2 20465 NULL
+tx_data_fndecl_20470_fields tx_data fndecl 4-3 20470 NULL
+wMaxCommand_usb_cdc_dmm_desc_20473_fields wMaxCommand usb_cdc_dmm_desc 0 20473 NULL
+vlen_nfsd3_readargs_20476_fields vlen nfsd3_readargs 0 20476 NULL
+rose_recvmsg_fndecl_20491_fields rose_recvmsg fndecl 3 20491 NULL
+ext4_ext_insert_index_fndecl_20492_fields ext4_ext_insert_index fndecl 4 20492 NULL
+pref_width_vmw_display_unit_20493_fields pref_width vmw_display_unit 0 20493 NULL
+ocfs2_extend_xattr_bucket_fndecl_20499_fields ocfs2_extend_xattr_bucket fndecl 4 20499 NULL
+aac_rkt_ioremap_fndecl_20502_fields aac_rkt_ioremap fndecl 2 20502 NULL
+nzones_adfs_discrecord_20503_fields nzones adfs_discrecord 0 20503 NULL nohasharray
+max_pfn_mapped_vardecl_20503_fields max_pfn_mapped vardecl 0 20503 &nzones_adfs_discrecord_20503_fields nohasharray
+id_platform_device_20503_fields id platform_device 0 20503 &max_pfn_mapped_vardecl_20503_fields
+tty_port_register_device_attr_fndecl_20510_fields tty_port_register_device_attr fndecl 3 20510 NULL
+newImageSize_mpt_ioctl_replace_fw_20513_fields newImageSize mpt_ioctl_replace_fw 0 20513 NULL
+cifs_write_fndecl_20515_fields cifs_write fndecl 4 20515 NULL
+ufs_write_end_fndecl_20517_fields ufs_write_end fndecl 5 20517 NULL
+vdc_mem_base_vml_par_20521_fields vdc_mem_base vml_par 0 20521 NULL
+xtAppend_fndecl_20525_fields xtAppend fndecl 4 20525 NULL
+expand_downwards_fndecl_20533_fields expand_downwards fndecl 2 20533 NULL nohasharray
+sr_read_fndecl_20533_fields sr_read fndecl 3 20533 &expand_downwards_fndecl_20533_fields
+pnfs_generic_pg_init_write_fndecl_20539_fields pnfs_generic_pg_init_write fndecl 3 20539 NULL
+s_first_data_block_ext2_super_block_20541_fields s_first_data_block ext2_super_block 0 20541 NULL
+dti_buf_size_wahc_20547_fields dti_buf_size wahc 0 20547 NULL
+crtc_hdisplay_drm_display_mode_20548_fields crtc_hdisplay drm_display_mode 0 20548 NULL
+dataflash_write_fndecl_20550_fields dataflash_write fndecl 2-3 20550 NULL
+dma_base_sst_pdata_20554_fields dma_base sst_pdata 0 20554 NULL
+nvm_submit_ppa_fndecl_20560_fields nvm_submit_ppa fndecl 7 20560 NULL
+mtdchar_writeoob_fndecl_20562_fields mtdchar_writeoob fndecl 3-4 20562 NULL
+sg_write_fndecl_20563_fields sg_write fndecl 3 20563 NULL
+free_extents_btrfs_free_space_ctl_20566_fields free_extents btrfs_free_space_ctl 0 20566 NULL
+m25p80_read_fndecl_20568_fields m25p80_read fndecl 3 20568 NULL
+check_defrag_in_cache_fndecl_20573_fields check_defrag_in_cache fndecl 3-2 20573 NULL
+hp_outs_auto_pin_cfg_20574_fields hp_outs auto_pin_cfg 0 20574 NULL
+fifo_size_pxa_ep_20587_fields fifo_size pxa_ep 0 20587 NULL
+nrof_flowrings_brcmf_pcie_shared_info_20590_fields nrof_flowrings brcmf_pcie_shared_info 0 20590 NULL
+target_complete_cmd_with_length_fndecl_20597_fields target_complete_cmd_with_length fndecl 3 20597 NULL
+max_deviceinfo_size_pnfs_layoutdriver_type_20599_fields max_deviceinfo_size pnfs_layoutdriver_type 0 20599 NULL
+bblog_shift_mdp_superblock_1_20604_fields bblog_shift mdp_superblock_1 0 20604 NULL
+get_alt_usb_function_20605_fields get_alt usb_function 0 20605 NULL nohasharray
+cdrom_read_block_fndecl_20605_fields cdrom_read_block fndecl 4-6 20605 &get_alt_usb_function_20605_fields
+ext4_inode_table_set_fndecl_20611_fields ext4_inode_table_set fndecl 3 20611 NULL
+height_tw686x_video_channel_20622_fields height tw686x_video_channel 0 20622 NULL
+ocfs2_allocate_refcount_tree_fndecl_20626_fields ocfs2_allocate_refcount_tree fndecl 2 20626 NULL
+__nla_put_nohdr_fndecl_20631_fields __nla_put_nohdr fndecl 2 20631 NULL
+num_comp_vectors_ib_device_20639_fields num_comp_vectors ib_device 0 20639 NULL
+hpi_outstream_write_buf_fndecl_20645_fields hpi_outstream_write_buf fndecl 3 20645 NULL
+offset_iscsi_seq_20646_fields offset iscsi_seq 0 20646 NULL
+nr_pages_ore_io_state_20648_fields nr_pages ore_io_state 0 20648 NULL
+m_pblk_ext4_map_blocks_20649_fields m_pblk ext4_map_blocks 0 20649 NULL
+dlm_process_incoming_buffer_fndecl_20665_fields dlm_process_incoming_buffer fndecl 0 20665 NULL nohasharray
+max_feed_count_dvb_usb_adapter_20665_fields max_feed_count dvb_usb_adapter 0 20665 &dlm_process_incoming_buffer_fndecl_20665_fields
+shim_size_sst_res_info_20670_fields shim_size sst_res_info 0 20670 NULL
+nilfs_load_super_root_fndecl_20676_fields nilfs_load_super_root fndecl 3 20676 NULL
+max_qp_wr_ib_device_attr_20681_fields max_qp_wr ib_device_attr 0 20681 NULL
+write_to_8820_fndecl_20687_fields write_to_8820 fndecl 3 20687 NULL
+num_evt_qs_be_adapter_20688_fields num_evt_qs be_adapter 0 20688 NULL
+num_row_gpios_matrix_keypad_platform_data_20696_fields num_row_gpios matrix_keypad_platform_data 0 20696 NULL
+erase_size_vardecl_mtdram_c_20704_fields erase_size vardecl_mtdram.c 0 20704 NULL
+err_dev_e752x_dev_info_20708_fields err_dev e752x_dev_info 0 20708 NULL
+src_len_ccp_rsa_engine_20712_fields src_len ccp_rsa_engine 0 20712 NULL
+ip_blkno_ocfs2_inode_info_20717_fields ip_blkno ocfs2_inode_info 0 20717 NULL
+dlc_rx_msg_20720_fields dlc rx_msg 0 20720 NULL
+add_range_fndecl_20721_fields add_range fndecl 5-4 20721 NULL
+txq_data_size_ieee80211_hw_20725_fields txq_data_size ieee80211_hw 0 20725 NULL
+max_io_length_ore_layout_20738_fields max_io_length ore_layout 0 20738 NULL
+read_data_done_iscsi_cmd_20745_fields read_data_done iscsi_cmd 0 20745 NULL
+sb_pseg_start_nilfs_segment_buffer_20750_fields sb_pseg_start nilfs_segment_buffer 0 20750 NULL
+ath6kl_wmi_probedssid_cmd_fndecl_20751_fields ath6kl_wmi_probedssid_cmd fndecl 2 20751 NULL
+TransferCount__MPI2_SCSI_IO_REPLY_20759_fields TransferCount _MPI2_SCSI_IO_REPLY 0 20759 NULL
+r_readdir_offset_ceph_mds_request_20764_fields r_readdir_offset ceph_mds_request 0 20764 NULL
+read_in_block_fndecl_20766_fields read_in_block fndecl 3 20766 NULL nohasharray
+init_tx_ring_fndecl_20766_fields init_tx_ring fndecl 4 20766 &read_in_block_fndecl_20766_fields
+channels_min_snd_soc_pcm_stream_20771_fields channels_min snd_soc_pcm_stream 0 20771 NULL nohasharray
+tx_ring_size_mlx4_en_port_profile_20771_fields tx_ring_size mlx4_en_port_profile 0 20771 &channels_min_snd_soc_pcm_stream_20771_fields
+ltab_sz_ubifs_info_20776_fields ltab_sz ubifs_info 0 20776 NULL
+rvds_opregion_asle_20777_fields rvds opregion_asle 0 20777 NULL
+fat_fats_fat_bios_param_block_20785_fields fat_fats fat_bios_param_block 0 20785 NULL
+orig_x_screen_info_20787_fields orig_x screen_info 0 20787 NULL nohasharray
+ncp_search_for_fileset_fndecl_20787_fields ncp_search_for_fileset fndecl 6 20787 &orig_x_screen_info_20787_fields
+final_block_in_request_dio_submit_20788_fields final_block_in_request dio_submit 0 20788 NULL
+map_size_pcmcia_socket_20792_fields map_size pcmcia_socket 0 20792 NULL
+max_seg_size_mmc_host_20795_fields max_seg_size mmc_host 0 20795 NULL nohasharray
+pos_vb2_fileio_buf_20795_fields pos vb2_fileio_buf 0 20795 &max_seg_size_mmc_host_20795_fields
+win_sz_wmi_addba_req_event_20803_fields win_sz wmi_addba_req_event 0 20803 NULL nohasharray
+namelen_xfs_da_args_20803_fields namelen xfs_da_args 0 20803 &win_sz_wmi_addba_req_event_20803_fields
+mgmt_index_event_fndecl_20813_fields mgmt_index_event fndecl 4 20813 NULL
+rcvidx_isac_20815_fields rcvidx isac 0 20815 NULL
+via686a_device_add_fndecl_20823_fields via686a_device_add fndecl 1 20823 NULL
+drm_fb_helper_single_fb_probe_fndecl_20828_fields drm_fb_helper_single_fb_probe fndecl 2 20828 NULL nohasharray
+do_cow_fault_fndecl_20828_fields do_cow_fault fndecl 2 20828 &drm_fb_helper_single_fb_probe_fndecl_20828_fields
+compat_do_ip6t_set_ctl_fndecl_20835_fields compat_do_ip6t_set_ctl fndecl 4 20835 NULL
+num_crtc_radeon_device_20838_fields num_crtc radeon_device 0 20838 NULL nohasharray
+adv_smbus_read_byte_data_check_fndecl_20838_fields adv_smbus_read_byte_data_check fndecl 0 20838 &num_crtc_radeon_device_20838_fields
+pathlen_nfs3_symlinkargs_20843_fields pathlen nfs3_symlinkargs 0 20843 NULL
+udp_sendpage_fndecl_20845_fields udp_sendpage fndecl 4 20845 NULL
+store_limit_l_fscache_object_20847_fields store_limit_l fscache_object 0 20847 NULL
+cur_page_block_dio_submit_20851_fields cur_page_block dio_submit 0 20851 NULL
+pkcs7_sig_note_signature_fndecl_20857_fields pkcs7_sig_note_signature fndecl 5 20857 NULL
+lpfc_bg_setup_bpl_fndecl_20862_fields lpfc_bg_setup_bpl fndecl 0 20862 NULL nohasharray
+uvc_video_stats_dump_fndecl_20862_fields uvc_video_stats_dump fndecl 0 20862 &lpfc_bg_setup_bpl_fndecl_20862_fields
+beb_rsvd_pebs_ubi_device_20863_fields beb_rsvd_pebs ubi_device 0 20863 NULL
+num_rx_descs_octeon_nic_if_config_20865_fields num_rx_descs octeon_nic_if_config 0 20865 NULL
+num_mlx4_resource_20869_fields num mlx4_resource 0 20869 NULL
+length_iwl_ucode_tlv_20871_fields length iwl_ucode_tlv 0 20871 NULL
+btrfs_prealloc_file_range_fndecl_20872_fields btrfs_prealloc_file_range fndecl 3-4 20872 NULL
+nr_hotspot_blocks_smq_policy_20876_fields nr_hotspot_blocks smq_policy 0 20876 NULL
+max_q_per_vf_rcb_common_cb_20877_fields max_q_per_vf rcb_common_cb 0 20877 NULL
+usb_stor_intr_transfer_fndecl_20883_fields usb_stor_intr_transfer fndecl 3 20883 NULL
+cl_local_node_o2nm_cluster_20896_fields cl_local_node o2nm_cluster 0 20896 NULL
+idiag_info_size_inet_diag_handler_20898_fields idiag_info_size inet_diag_handler 0 20898 NULL
+locks_mandatory_area_fndecl_20899_fields locks_mandatory_area fndecl 0 20899 NULL
+check_vendor_extension_fndecl_20901_fields check_vendor_extension fndecl 1 20901 NULL
+num_rows_vardecl_arcfb_c_20902_fields num_rows vardecl_arcfb.c 0 20902 NULL
+radeon_vm_directory_size_fndecl_20909_fields radeon_vm_directory_size fndecl 0 20909 NULL
+n_dir_band_hpfs_super_block_20914_fields n_dir_band hpfs_super_block 0 20914 NULL
+zisofs_uncompress_block_fndecl_20917_fields zisofs_uncompress_block fndecl 2 20917 NULL
+mmap_piobufs_fndecl_20927_fields mmap_piobufs fndecl 4 20927 NULL
+__ip_tunnel_change_mtu_fndecl_20933_fields __ip_tunnel_change_mtu fndecl 2 20933 NULL nohasharray
+qbuf_scan_fndecl_20933_fields qbuf_scan fndecl 3 20933 &__ip_tunnel_change_mtu_fndecl_20933_fields
+gid_table_len_mthca_limits_20957_fields gid_table_len mthca_limits 0 20957 NULL
+npages_mlx5_buf_20958_fields npages mlx5_buf 0 20958 NULL
+range_start_writeback_control_20965_fields range_start writeback_control 0 20965 NULL
+dbDiscardAG_fndecl_20969_fields dbDiscardAG fndecl 0 20969 NULL
+pskb_carve_fndecl_20971_fields pskb_carve fndecl 2 20971 NULL
+offset_fuse_notify_store_out_20985_fields offset fuse_notify_store_out 0 20985 NULL
+dy_fb_image_20988_fields dy fb_image 0 20988 NULL nohasharray
+arvo_sysfs_write_fndecl_20988_fields arvo_sysfs_write fndecl 6 20988 &dy_fb_image_20988_fields
+gfn_guest_walker32_20990_fields gfn guest_walker32 0 20990 NULL
+cxns_per_ctrl_hba_parameters_21008_fields cxns_per_ctrl hba_parameters 0 21008 NULL
+controller_function_mspro_sys_info_21011_fields controller_function mspro_sys_info 0 21011 NULL
+s_log_cluster_size_ext4_super_block_21014_fields s_log_cluster_size ext4_super_block 0 21014 NULL
+i40iw_get_vmalloc_mem_fndecl_21016_fields i40iw_get_vmalloc_mem fndecl 3 21016 NULL
+create_one_cdev_fndecl_21023_fields create_one_cdev fndecl 2 21023 NULL
+__build_skb_fndecl_21024_fields __build_skb fndecl 2 21024 NULL
+minix_new_block_fndecl_21026_fields minix_new_block fndecl 0 21026 NULL
+uea_send_modem_cmd_fndecl_21027_fields uea_send_modem_cmd fndecl 3 21027 NULL
+count_debug_buffer_21028_fields count debug_buffer 0 21028 NULL
+fw_resource_count_efi_system_resource_table_21033_fields fw_resource_count efi_system_resource_table 0 21033 NULL
+start_range_21034_fields start range 0 21034 NULL
+crtc_vdisplay_drm_display_mode_21037_fields crtc_vdisplay drm_display_mode 0 21037 NULL
+vary_usbtest_param_32_21050_fields vary usbtest_param_32 0 21050 NULL
+erase_shift_onenand_chip_21052_fields erase_shift onenand_chip 0 21052 NULL nohasharray
+tx_queues_rt2x00_ops_21052_fields tx_queues rt2x00_ops 0 21052 &erase_shift_onenand_chip_21052_fields
+xfs_alloc_min_freelist_fndecl_21056_fields xfs_alloc_min_freelist fndecl 0 21056 NULL
+size_nvkm_memory_func_21058_fields size nvkm_memory_func 0 21058 NULL
+__send_prepared_auth_request_fndecl_21067_fields __send_prepared_auth_request fndecl 2 21067 NULL
+ts_packet_count_cx231xx_tsport_21071_fields ts_packet_count cx231xx_tsport 0 21071 NULL
+usbip_recv_fndecl_21076_fields usbip_recv fndecl 3 21076 NULL
+consume_size_qp_entry_21087_fields consume_size qp_entry 0 21087 NULL
+queue_pages_test_walk_fndecl_21089_fields queue_pages_test_walk fndecl 2-1 21089 NULL
+max_counters_mlx4_caps_21095_fields max_counters mlx4_caps 0 21095 NULL
+ext4_block_truncate_page_fndecl_21098_fields ext4_block_truncate_page fndecl 3 21098 NULL
+ext4_bg_has_super_fndecl_21104_fields ext4_bg_has_super fndecl 0 21104 NULL
+sge_size_ieee_MPT3SAS_ADAPTER_21108_fields sge_size_ieee MPT3SAS_ADAPTER 0 21108 NULL
+__vfs_read_fndecl_21109_fields __vfs_read fndecl 0-3 21109 NULL nohasharray
+port_number_board_info_21109_fields port_number board_info 0 21109 &__vfs_read_fndecl_21109_fields
+dm_rh_get_region_size_fndecl_21112_fields dm_rh_get_region_size fndecl 0 21112 NULL
+memblock_mark_hotplug_fndecl_21114_fields memblock_mark_hotplug fndecl 2-1 21114 NULL nohasharray
+fpm_base_addr_i40iw_hmc_pble_rsrc_21114_fields fpm_base_addr i40iw_hmc_pble_rsrc 0 21114 &memblock_mark_hotplug_fndecl_21114_fields
+max_slots_ocfs2_super_21115_fields max_slots ocfs2_super 0 21115 NULL nohasharray
+hdlc_irq_one_fndecl_21115_fields hdlc_irq_one fndecl 2 21115 &max_slots_ocfs2_super_21115_fields
+header_length_scsi_mode_data_21117_fields header_length scsi_mode_data 0 21117 NULL
+chunk_mask_dm_exception_store_21121_fields chunk_mask dm_exception_store 0 21121 NULL
+produce_size_vmci_transport_21124_fields produce_size vmci_transport 0 21124 NULL
+s_desc_per_block_bits_ext4_sb_info_21130_fields s_desc_per_block_bits ext4_sb_info 0 21130 NULL
+do_add_counters_fndecl_21131_fields do_add_counters fndecl 3 21131 NULL
+xfs_bmbt_lookup_eq_fndecl_21134_fields xfs_bmbt_lookup_eq fndecl 3-4-2 21134 NULL
+cp_pack_start_sum_f2fs_checkpoint_21142_fields cp_pack_start_sum f2fs_checkpoint 0 21142 NULL
+clk_get_rate_fndecl_21147_fields clk_get_rate fndecl 0 21147 NULL nohasharray
+copied_iscsi_segment_21147_fields copied iscsi_segment 0 21147 &clk_get_rate_fndecl_21147_fields
+req_queue_pairs_i40e_vsi_21151_fields req_queue_pairs i40e_vsi 0 21151 NULL
+ext4_xattr_find_entry_fndecl_21162_fields ext4_xattr_find_entry fndecl 0 21162 NULL
+nd_size_out_nd_cmd_pkg_21165_fields nd_size_out nd_cmd_pkg 0 21165 NULL
+gfs2_dir_get_existing_buffer_fndecl_21172_fields gfs2_dir_get_existing_buffer fndecl 2 21172 NULL
+udf_try_read_meta_fndecl_21178_fields udf_try_read_meta fndecl 4 21178 NULL
+usage_index_hid_local_21183_fields usage_index hid_local 0 21183 NULL
+init_ppi_data_fndecl_21184_fields init_ppi_data fndecl 2 21184 NULL
+crtc_hsync_end_drm_display_mode_21187_fields crtc_hsync_end drm_display_mode 0 21187 NULL
+ucNumEntries__ATOM_PPLIB_Clock_Voltage_Dependency_Table_21191_fields ucNumEntries _ATOM_PPLIB_Clock_Voltage_Dependency_Table 0 21191 NULL
+sb_inodesize_xfs_sb_21192_fields sb_inodesize xfs_sb 0 21192 NULL
+usbnet_write_cmd_async_fndecl_21200_fields usbnet_write_cmd_async fndecl 7 21200 NULL
+drm_plane_helper_update_fndecl_21218_fields drm_plane_helper_update fndecl 6-10-7-11 21218 NULL
+hpfs_get_4sectors_fndecl_21224_fields hpfs_get_4sectors fndecl 2 21224 NULL
+vfio_pci_register_dev_region_fndecl_21228_fields vfio_pci_register_dev_region fndecl 5 21228 NULL
+tx_ptr_catc_21231_fields tx_ptr catc 0 21231 NULL nohasharray
+ext4_blks_to_allocate_fndecl_21231_fields ext4_blks_to_allocate fndecl 0-4-3 21231 &tx_ptr_catc_21231_fields
+ptr_mask_radeon_ring_21233_fields ptr_mask radeon_ring 0 21233 NULL
+RamAmountKBytes_nvidia_par_21238_fields RamAmountKBytes nvidia_par 0 21238 NULL nohasharray
+num_msix_qlcnic_hardware_context_21238_fields num_msix qlcnic_hardware_context 0 21238 &RamAmountKBytes_nvidia_par_21238_fields
+rp_buflen_nfs4_replay_21241_fields rp_buflen nfs4_replay 0 21241 NULL
+ring_size_amdgpu_ih_ring_21243_fields ring_size amdgpu_ih_ring 0 21243 NULL
+fbcon_do_set_font_fndecl_21244_fields fbcon_do_set_font fndecl 2-3 21244 NULL
+size_seq_buf_21247_fields size seq_buf 0 21247 NULL nohasharray
+rxq_depth_bnad_21247_fields rxq_depth bnad 0 21247 &size_seq_buf_21247_fields
+ufs_clear_frags_fndecl_21263_fields ufs_clear_frags fndecl 2 21263 NULL
+vc_resize_fndecl_21266_fields vc_resize fndecl 3-2 21266 NULL nohasharray
+num_fh_nfs4_filelayout_segment_21266_fields num_fh nfs4_filelayout_segment 0 21266 &vc_resize_fndecl_21266_fields
+elfcorebuf_sz_vardecl_vmcore_c_21270_fields elfcorebuf_sz vardecl_vmcore.c 0 21270 NULL
+gsi_top_vardecl_21275_fields gsi_top vardecl 0 21275 NULL
+skb_splice_bits_fndecl_21278_fields skb_splice_bits fndecl 0 21278 NULL nohasharray
+ulimit_ulp_iscsi_info_21278_fields ulimit ulp_iscsi_info 0 21278 &skb_splice_bits_fndecl_21278_fields
+hsync_len_fb_var_screeninfo_21279_fields hsync_len fb_var_screeninfo 0 21279 NULL
+height_simplefb_params_21280_fields height simplefb_params 0 21280 NULL nohasharray
+plen_nci_ctrl_hdr_21280_fields plen nci_ctrl_hdr 0 21280 &height_simplefb_params_21280_fields
+max_channels_atiixp_21295_fields max_channels atiixp 0 21295 NULL
+cmds_max_iscsi_session_21296_fields cmds_max iscsi_session 0 21296 NULL
+osd_yres_vardecl_ivtvfb_c_21299_fields osd_yres vardecl_ivtvfb.c 0 21299 NULL nohasharray
+count_nfsd3_readdirres_21299_fields count nfsd3_readdirres 0 21299 &osd_yres_vardecl_ivtvfb_c_21299_fields nohasharray
+efx_rx_deliver_fndecl_21299_fields efx_rx_deliver fndecl 4 21299 &count_nfsd3_readdirres_21299_fields
+wSamplesPerFrame_uac_format_type_ii_discrete_descriptor_21300_fields wSamplesPerFrame uac_format_type_ii_discrete_descriptor 0 21300 NULL
+nvdimm_major_vardecl_21302_fields nvdimm_major vardecl 0 21302 NULL
+xblk_next_xblk_qnx4_xblk_21303_fields xblk_next_xblk qnx4_xblk 0 21303 NULL
+tx_num_pg_ch_pm_21307_fields tx_num_pg ch_pm 0 21307 NULL
+num_paths_bna_rx_config_21315_fields num_paths bna_rx_config 0 21315 NULL
+fuse_copy_page_fndecl_21316_fields fuse_copy_page fndecl 4-3 21316 NULL
+tcp_fragment_fndecl_21318_fields tcp_fragment fndecl 3 21318 NULL
+packet_present_len_cfg80211_wowlan_wakeup_21321_fields packet_present_len cfg80211_wowlan_wakeup 0 21321 NULL
+mincore_unmapped_range_fndecl_21322_fields mincore_unmapped_range fndecl 1 21322 NULL
+UniformBlockSizeShift_qinfo_chip_21323_fields UniformBlockSizeShift qinfo_chip 0 21323 NULL
+cm_copy_private_data_fndecl_21330_fields cm_copy_private_data fndecl 2 21330 NULL
+word14_lpfc_mbx_read_config_21331_fields word14 lpfc_mbx_read_config 0 21331 NULL
+i915_compat_ioctl_fndecl_21339_fields i915_compat_ioctl fndecl 2 21339 NULL
+fl_dump_key_val_fndecl_21344_fields fl_dump_key_val fndecl 6 21344 NULL
+cur_aead_sg_list_21347_fields cur aead_sg_list 0 21347 NULL nohasharray
+snd_util_mem_alloc_fndecl_21347_fields snd_util_mem_alloc fndecl 2 21347 &cur_aead_sg_list_21347_fields
+h_blkno_ocfs2_extent_block_21357_fields h_blkno ocfs2_extent_block 0 21357 NULL nohasharray
+nfs_direct_wait_fndecl_21357_fields nfs_direct_wait fndecl 0 21357 &h_blkno_ocfs2_extent_block_21357_fields
+videobuf_pages_to_sg_fndecl_21359_fields videobuf_pages_to_sg fndecl 3-4-2 21359 NULL
+igbvf_change_mtu_fndecl_21361_fields igbvf_change_mtu fndecl 2 21361 NULL
+pad_ieee80211_vendor_radiotap_21376_fields pad ieee80211_vendor_radiotap 0 21376 NULL nohasharray
+len_idma64_hw_desc_21376_fields len idma64_hw_desc 0 21376 &pad_ieee80211_vendor_radiotap_21376_fields
+chunk_size_dm_exception_store_21381_fields chunk_size dm_exception_store 0 21381 NULL
+inppos_net_local_21383_fields inppos net_local 0 21383 NULL
+num_vfs_enic_21386_fields num_vfs enic 0 21386 NULL
+cids_per_vf_qed_conn_type_cfg_21393_fields cids_per_vf qed_conn_type_cfg 0 21393 NULL nohasharray
+vc_scan_lines_vc_data_21393_fields vc_scan_lines vc_data 0 21393 &cids_per_vf_qed_conn_type_cfg_21393_fields
+pg_count_agp_allocate32_21404_fields pg_count agp_allocate32 0 21404 NULL
+ext4_inode_blocks_set_fndecl_21407_fields ext4_inode_blocks_set fndecl 0 21407 NULL
+rx_desc_size_rtl8xxxu_fileops_21415_fields rx_desc_size rtl8xxxu_fileops 0 21415 NULL
+st33zp24_spi_send_fndecl_21416_fields st33zp24_spi_send fndecl 4 21416 NULL
+ex_length_extent_s_21417_fields ex_length extent_s 0 21417 NULL
+mtu_rxe_qp_21422_fields mtu rxe_qp 0 21422 NULL nohasharray
+ping_recvmsg_fndecl_21422_fields ping_recvmsg fndecl 3 21422 &mtu_rxe_qp_21422_fields
+managed_pages_zone_21425_fields managed_pages zone 0 21425 NULL nohasharray
+cp2112_i2c_write_req_fndecl_21425_fields cp2112_i2c_write_req fndecl 0-4 21425 &managed_pages_zone_21425_fields
+bounce_offs_xhci_segment_21437_fields bounce_offs xhci_segment 0 21437 NULL
+intbufferhandle_kaweth_device_21438_fields intbufferhandle kaweth_device 0 21438 NULL
+sctp_setsockopt_auth_key_fndecl_21442_fields sctp_setsockopt_auth_key fndecl 3 21442 NULL
+major_vardecl_pg_c_21451_fields major vardecl_pg.c 0 21451 NULL
+buffer_size_vardecl_event_buffer_c_21452_fields buffer_size vardecl_event_buffer.c 0 21452 NULL
+video_width_sis_video_info_21454_fields video_width sis_video_info 0 21454 NULL
+stripes_stripe_c_21457_fields stripes stripe_c 0 21457 NULL
+indirect2direct_fndecl_21459_fields indirect2direct fndecl 6 21459 NULL
+ezusb_access_ltv_fndecl_21485_fields ezusb_access_ltv fndecl 3 21485 NULL
+mmio_start_fb_fix_screeninfo_21486_fields mmio_start fb_fix_screeninfo 0 21486 NULL
+fuse_do_ioctl_fndecl_21491_fields fuse_do_ioctl fndecl 2 21491 NULL
+hpfs_ea_ext_remove_fndecl_21492_fields hpfs_ea_ext_remove fndecl 4-2 21492 NULL
+memsize_vgastate_21493_fields memsize vgastate 0 21493 NULL nohasharray
+num_iac_hci_cp_write_current_iac_lap_21493_fields num_iac hci_cp_write_current_iac_lap 0 21493 &memsize_vgastate_21493_fields
+video_pbase_vivid_dev_21503_fields video_pbase vivid_dev 0 21503 NULL
+vmw_cmdbuf_set_pool_size_fndecl_21513_fields vmw_cmdbuf_set_pool_size fndecl 2 21513 NULL
+max_io_support_mvumi_hs_page1_21519_fields max_io_support mvumi_hs_page1 0 21519 NULL
+fifo_size_hscx_hw_21522_fields fifo_size hscx_hw 0 21522 NULL nohasharray
+c67x00_urb_dequeue_fndecl_21522_fields c67x00_urb_dequeue fndecl 3 21522 &fifo_size_hscx_hw_21522_fields
+data_offset_mdp_superblock_1_21524_fields data_offset mdp_superblock_1 0 21524 NULL
+xennet_max_queues_vardecl_xen_netfront_c_21530_fields xennet_max_queues vardecl_xen-netfront.c 0 21530 NULL
+ooblen_mtd_oob_ops_21531_fields ooblen mtd_oob_ops 0 21531 NULL
+hfsplus_find_init_fndecl_21533_fields hfsplus_find_init fndecl 0 21533 NULL nohasharray
+nr_bos_drm_msm_gem_submit_21533_fields nr_bos drm_msm_gem_submit 0 21533 &hfsplus_find_init_fndecl_21533_fields
+zr364xx_read_fndecl_21537_fields zr364xx_read fndecl 3 21537 NULL
+pcm_snd_oxfw_stream_formation_21546_fields pcm snd_oxfw_stream_formation 0 21546 NULL
+ql_get_full_dup_fndecl_21549_fields ql_get_full_dup fndecl 0 21549 NULL
+nSkipped_vardecl_gl860_c_21557_fields nSkipped vardecl_gl860.c 0 21557 NULL
+__erst_read_to_erange_fndecl_21558_fields __erst_read_to_erange fndecl 1 21558 NULL
+sl_max_ip6_sf_socklist_21563_fields sl_max ip6_sf_socklist 0 21563 NULL
+log_sq_stride_mlx4_ib_create_qp_21564_fields log_sq_stride mlx4_ib_create_qp 0 21564 NULL
+total_len_ieee802_11_elems_21565_fields total_len ieee802_11_elems 0 21565 NULL
+rtl_port_map_fndecl_21570_fields rtl_port_map fndecl 2-1 21570 NULL
+start_resource_21572_fields start resource 0 21572 NULL nohasharray
+cont_extent_rock_state_21572_fields cont_extent rock_state 0 21572 &start_resource_21572_fields
+buf_len_wmi_mgmt_rx_hdr_v1_21592_fields buf_len wmi_mgmt_rx_hdr_v1 0 21592 NULL
+data_length_ceph_msg_21593_fields data_length ceph_msg 0 21593 NULL nohasharray
+device_count_vardecl_portman2x4_c_21593_fields device_count vardecl_portman2x4.c 0 21593 &data_length_ceph_msg_21593_fields
+myri10ge_initial_mtu_vardecl_myri10ge_c_21595_fields myri10ge_initial_mtu vardecl_myri10ge.c 0 21595 NULL nohasharray
+virtnet_set_queues_fndecl_21595_fields virtnet_set_queues fndecl 2 21595 &myri10ge_initial_mtu_vardecl_myri10ge_c_21595_fields
+xcl_max_payload_svc_xprt_class_21596_fields xcl_max_payload svc_xprt_class 0 21596 NULL
+st_kim_recv_fndecl_21600_fields st_kim_recv fndecl 3 21600 NULL
+irq_dma_cm109_dev_21602_fields irq_dma cm109_dev 0 21602 NULL nohasharray
+do_otp_write_fndecl_21602_fields do_otp_write fndecl 2 21602 &irq_dma_cm109_dev_21602_fields
+roccat_common2_send_fndecl_21605_fields roccat_common2_send fndecl 4 21605 NULL
+hfcpci_empty_fifo_fndecl_21608_fields hfcpci_empty_fifo fndecl 4 21608 NULL nohasharray
+p54spi_spi_write_dma_fndecl_21608_fields p54spi_spi_write_dma fndecl 4 21608 &hfcpci_empty_fifo_fndecl_21608_fields nohasharray
+snd_seq_pool_new_fndecl_21608_fields snd_seq_pool_new fndecl 1 21608 &p54spi_spi_write_dma_fndecl_21608_fields
+cw1200_spi_memcpy_toio_fndecl_21615_fields cw1200_spi_memcpy_toio fndecl 4 21615 NULL nohasharray
+alloc_irq_from_domain_fndecl_21615_fields alloc_irq_from_domain fndecl 3 21615 &cw1200_spi_memcpy_toio_fndecl_21615_fields
+sysctl_tcp_reordering_netns_ipv4_21617_fields sysctl_tcp_reordering netns_ipv4 0 21617 NULL
+size_meye_grab_buffer_21622_fields size meye_grab_buffer 0 21622 NULL
+num_snaps_ceph_snap_realm_21623_fields num_snaps ceph_snap_realm 0 21623 NULL
+sector_r1bio_21627_fields sector r1bio 0 21627 NULL
+__lbtf_cmd_fndecl_21631_fields __lbtf_cmd fndecl 4 21631 NULL
+ath6kl_usb_bmi_write_fndecl_21637_fields ath6kl_usb_bmi_write fndecl 3 21637 NULL
+hlength_iscsi_hdr_21640_fields hlength iscsi_hdr 0 21640 NULL
+elf_kcore_store_hdr_fndecl_21642_fields elf_kcore_store_hdr fndecl 2-3 21642 NULL
+ra_meta_pages_cond_fndecl_21647_fields ra_meta_pages_cond fndecl 2 21647 NULL
+nvram_npiv_size_qla_hw_data_21652_fields nvram_npiv_size qla_hw_data 0 21652 NULL nohasharray
+ioremap_nocache_fndecl_21652_fields ioremap_nocache fndecl 2-1 21652 &nvram_npiv_size_qla_hw_data_21652_fields
+cxd2841er_write_regs_fndecl_21655_fields cxd2841er_write_regs fndecl 5 21655 NULL
+tps6507x_i2c_read_device_fndecl_21660_fields tps6507x_i2c_read_device fndecl 3 21660 NULL
+overlay_cap_left_vivid_dev_21663_fields overlay_cap_left vivid_dev 0 21663 NULL
+update_pmkid_fndecl_21666_fields update_pmkid fndecl 4 21666 NULL
+length_ccp_dma_info_21671_fields length ccp_dma_info 0 21671 NULL
+ext4_dio_get_block_overwrite_fndecl_21684_fields ext4_dio_get_block_overwrite fndecl 2 21684 NULL
+in_min_chans_snd_card_asihpi_21686_fields in_min_chans snd_card_asihpi 0 21686 NULL
+mfw_mb_length_qed_mcp_info_21688_fields mfw_mb_length qed_mcp_info 0 21688 NULL
+fc_fcp_send_data_fndecl_21692_fields fc_fcp_send_data fndecl 4-3 21692 NULL nohasharray
+__ieee80211_get_mesh_hdrlen_fndecl_21692_fields __ieee80211_get_mesh_hdrlen fndecl 0 21692 &fc_fcp_send_data_fndecl_21692_fields
+resync_max_sectors_mddev_21693_fields resync_max_sectors mddev 0 21693 NULL
+max_pkt_size_pktgen_dev_21696_fields max_pkt_size pktgen_dev 0 21696 NULL
+dm_write_fndecl_21698_fields dm_write fndecl 3 21698 NULL
+amdgpu_irq_create_mapping_fndecl_21701_fields amdgpu_irq_create_mapping fndecl 0 21701 NULL
+ext4_get_inode_loc_fndecl_21703_fields ext4_get_inode_loc fndecl 0 21703 NULL
+pread_dvb_ringbuffer_21708_fields pread dvb_ringbuffer 0 21708 NULL nohasharray
+nfsacl_encode_fndecl_21708_fields nfsacl_encode fndecl 2-0 21708 &pread_dvb_ringbuffer_21708_fields
+get_rndis_request_fndecl_21709_fields get_rndis_request fndecl 3 21709 NULL
+residual_fcpio_icmnd_cmpl_21718_fields residual fcpio_icmnd_cmpl 0 21718 NULL
+set_blocksize_fndecl_21720_fields set_blocksize fndecl 2 21720 NULL
+len_nfs4_label_21722_fields len nfs4_label 0 21722 NULL
+buff_size_host_cmd_ds_txbuf_cfg_21725_fields buff_size host_cmd_ds_txbuf_cfg 0 21725 NULL
+hpfs_set_ea_fndecl_21731_fields hpfs_set_ea fndecl 5 21731 NULL
+groups_netlink_kernel_cfg_21741_fields groups netlink_kernel_cfg 0 21741 NULL
+blk_rq_map_integrity_sg_fndecl_21744_fields blk_rq_map_integrity_sg fndecl 0 21744 NULL
+smk_write_syslog_fndecl_21746_fields smk_write_syslog fndecl 3 21746 NULL
+skb_ts_get_next_block_fndecl_21748_fields skb_ts_get_next_block fndecl 1 21748 NULL
+intel_tile_size_fndecl_21749_fields intel_tile_size fndecl 0 21749 NULL
+__ceph_setxattr_fndecl_21751_fields __ceph_setxattr fndecl 4 21751 NULL
+id_gpio_device_21753_fields id gpio_device 0 21753 NULL
+bufsiz_mousedev_client_21759_fields bufsiz mousedev_client 0 21759 NULL
+width_tm6000_fh_21761_fields width tm6000_fh 0 21761 NULL
+req_lim_delta_srp_login_rsp_21762_fields req_lim_delta srp_login_rsp 0 21762 NULL
+next_checkpoint_r5l_log_21765_fields next_checkpoint r5l_log 0 21765 NULL
+br_startblock_xfs_bmbt_irec_21769_fields br_startblock xfs_bmbt_irec 0 21769 NULL
+regmap_get_val_bytes_fndecl_21774_fields regmap_get_val_bytes fndecl 0 21774 NULL
+byte_len_spi_eeprom_21786_fields byte_len spi_eeprom 0 21786 NULL
+tpg_alloc_fndecl_21789_fields tpg_alloc fndecl 2 21789 NULL
+find_group_dir_fndecl_21790_fields find_group_dir fndecl 0 21790 NULL
+idetape_chrdev_read_fndecl_21794_fields idetape_chrdev_read fndecl 3 21794 NULL
+reg_stride_regmap_21801_fields reg_stride regmap 0 21801 NULL
+num_vss_hpf_cfgs_wm8994_pdata_21802_fields num_vss_hpf_cfgs wm8994_pdata 0 21802 NULL
+__svc_create_fndecl_21804_fields __svc_create fndecl 2 21804 NULL
+hwi_ws_sz_hba_parameters_21815_fields hwi_ws_sz hba_parameters 0 21815 NULL
+numacb_vardecl_21828_fields numacb vardecl 0 21828 NULL
+snd_pcm_plug_slave_format_fndecl_21831_fields snd_pcm_plug_slave_format fndecl 0-1 21831 NULL
+nfs4_copy_file_range_fndecl_21835_fields nfs4_copy_file_range fndecl 4 21835 NULL
+firm_cfg_version_AdapterControlBlock_21836_fields firm_cfg_version AdapterControlBlock 0 21836 NULL
+n_descsz_elf32_note_21838_fields n_descsz elf32_note 0 21838 NULL nohasharray
+device_create_vargs_fndecl_21838_fields device_create_vargs fndecl 3 21838 &n_descsz_elf32_note_21838_fields
+__find_xattr_fndecl_21846_fields __find_xattr fndecl 6 21846 NULL
+length_acpi_table_desc_21847_fields length acpi_table_desc 0 21847 NULL
+sge_control2_sge_params_21854_fields sge_control2 sge_params 0 21854 NULL
+update_hidden_ssid_fndecl_21871_fields update_hidden_ssid fndecl 0 21871 NULL
+sizeimage_vim2m_q_data_21875_fields sizeimage vim2m_q_data 0 21875 NULL nohasharray
+ext4_zero_partial_blocks_fndecl_21875_fields ext4_zero_partial_blocks fndecl 3-4 21875 &sizeimage_vim2m_q_data_21875_fields
+ad_sd_read_reg_fndecl_21876_fields ad_sd_read_reg fndecl 3 21876 NULL
+__copy_to_user_ll_fndecl_21886_fields __copy_to_user_ll fndecl 0 21886 NULL nohasharray
+_drbd_send_page_fndecl_21886_fields _drbd_send_page fndecl 4 21886 &__copy_to_user_ll_fndecl_21886_fields
+npwm_pwm_chip_21895_fields npwm pwm_chip 0 21895 NULL
+fat_get_block_fndecl_21902_fields fat_get_block fndecl 2 21902 NULL
+nodesize_btrfs_super_block_21912_fields nodesize btrfs_super_block 0 21912 NULL
+ieee80211_build_preq_ies_fndecl_21915_fields ieee80211_build_preq_ies fndecl 0-6 21915 NULL
+sym_compute_residual_fndecl_21916_fields sym_compute_residual fndecl 0 21916 NULL
+error_bio_and_error_21918_fields error bio_and_error 0 21918 NULL
+addr_width_snd_dmaengine_dai_dma_data_21920_fields addr_width snd_dmaengine_dai_dma_data 0 21920 NULL
+membase_pm8001_hba_memspace_21924_fields membase pm8001_hba_memspace 0 21924 NULL
+ath6kl_sdio_bmi_read_fndecl_21930_fields ath6kl_sdio_bmi_read fndecl 3 21930 NULL
+rx_eth_fndecl_21931_fields rx_eth fndecl 4 21931 NULL
+page_cache_async_readahead_fndecl_21944_fields page_cache_async_readahead fndecl 5 21944 NULL
+in_pipe_ttusb_dec_21947_fields in_pipe ttusb_dec 0 21947 NULL
+kvm_hv_set_msr_fndecl_21951_fields kvm_hv_set_msr fndecl 3 21951 NULL
+nrprocs_rpc_version_21954_fields nrprocs rpc_version 0 21954 NULL
+sel_write_avc_cache_threshold_fndecl_21955_fields sel_write_avc_cache_threshold fndecl 3 21955 NULL
+length_iscsi_datain_21959_fields length iscsi_datain 0 21959 NULL
+ocfs2_find_refcount_rec_in_rl_fndecl_21962_fields ocfs2_find_refcount_rec_in_rl fndecl 3-4 21962 NULL
+num_desc_qlcnic_host_rds_ring_21963_fields num_desc qlcnic_host_rds_ring 0 21963 NULL
+reg_page_map_set_fndecl_21967_fields reg_page_map_set fndecl 0 21967 NULL
+ms_os_descs_ext_prop_count_ffs_data_21971_fields ms_os_descs_ext_prop_count ffs_data 0 21971 NULL nohasharray
+vram_size_ast_private_21971_fields vram_size ast_private 0 21971 &ms_os_descs_ext_prop_count_ffs_data_21971_fields nohasharray
+dblock_gfs2_journal_extent_21971_fields dblock gfs2_journal_extent 0 21971 &vram_size_ast_private_21971_fields
+bulk_out_size_usb_cardstate_21974_fields bulk_out_size usb_cardstate 0 21974 NULL
+max_data_sg_nents_target_core_fabric_ops_21975_fields max_data_sg_nents target_core_fabric_ops 0 21975 NULL nohasharray
+fat_start_msdos_sb_info_21975_fields fat_start msdos_sb_info 0 21975 &max_data_sg_nents_target_core_fabric_ops_21975_fields
+donor_start_move_extent_21977_fields donor_start move_extent 0 21977 NULL nohasharray
+nxt200x_writebytes_fndecl_21977_fields nxt200x_writebytes fndecl 4 21977 &donor_start_move_extent_21977_fields
+cfg1_base_pcie_port_21978_fields cfg1_base pcie_port 0 21978 NULL
+calc_fat_clusters_fndecl_21982_fields calc_fat_clusters fndecl 0 21982 NULL
+split_nodes_interleave_fndecl_21988_fields split_nodes_interleave fndecl 3-5-4 21988 NULL
+skb_rx_extra_cxgbi_device_21990_fields skb_rx_extra cxgbi_device 0 21990 NULL
+sr_read_cmd_fndecl_21992_fields sr_read_cmd fndecl 5 21992 NULL
+sec_per_clus_msdos_sb_info_21995_fields sec_per_clus msdos_sb_info 0 21995 NULL
+ath6kl_wmi_bssinfo_event_rx_fndecl_22000_fields ath6kl_wmi_bssinfo_event_rx fndecl 3 22000 NULL
+ath6kl_wmi_set_tx_pwr_cmd_fndecl_22001_fields ath6kl_wmi_set_tx_pwr_cmd fndecl 2 22001 NULL
+length_ib_sge_22002_fields length ib_sge 0 22002 NULL
+vmx_create_vcpu_fndecl_22003_fields vmx_create_vcpu fndecl 2 22003 NULL
+video_v_stop_saa7134_tvnorm_22005_fields video_v_stop saa7134_tvnorm 0 22005 NULL
+itd1000_write_regs_fndecl_22013_fields itd1000_write_regs fndecl 4 22013 NULL
+atio_q_length_qlt_hw_data_22018_fields atio_q_length qlt_hw_data 0 22018 NULL
+cal_data_len_ath10k_hw_params_22021_fields cal_data_len ath10k_hw_params 0 22021 NULL nohasharray
+buffer_size_nm256_22021_fields buffer_size nm256 0 22021 &cal_data_len_ath10k_hw_params_22021_fields
+GlobalCredits__MSG_IOC_FACTS_REPLY_22031_fields GlobalCredits _MSG_IOC_FACTS_REPLY 0 22031 NULL
+nv50_dmac_create_fndecl_22035_fields nv50_dmac_create fndecl 6 22035 NULL
+vmw_du_crtc_cursor_set2_fndecl_22036_fields vmw_du_crtc_cursor_set2 fndecl 5-4 22036 NULL
+dm_exception_store_set_chunk_size_fndecl_22042_fields dm_exception_store_set_chunk_size fndecl 2 22042 NULL
+mmc_queue_map_sg_fndecl_22053_fields mmc_queue_map_sg fndecl 0 22053 NULL
+held_root_thin_disk_superblock_22055_fields held_root thin_disk_superblock 0 22055 NULL
+zl10039_read_fndecl_22056_fields zl10039_read fndecl 4 22056 NULL
+w_input_res_22061_fields w input_res 0 22061 NULL
+param_sata_completion_resp_22065_fields param sata_completion_resp 0 22065 NULL
+i2c_wr_max_tda18218_config_22066_fields i2c_wr_max tda18218_config 0 22066 NULL nohasharray
+l2t_start_adapter_22066_fields l2t_start adapter 0 22066 &i2c_wr_max_tda18218_config_22066_fields
+rom_base_qxl_device_22067_fields rom_base qxl_device 0 22067 NULL
+ufs_free_fragments_fndecl_22074_fields ufs_free_fragments fndecl 2 22074 NULL
+iuu_uart_write_fndecl_22079_fields iuu_uart_write fndecl 4 22079 NULL
+absent_pages_in_range_fndecl_22083_fields absent_pages_in_range fndecl 0-1-2 22083 NULL nohasharray
+rx_ring_size_mlx4_en_port_profile_22083_fields rx_ring_size mlx4_en_port_profile 0 22083 &absent_pages_in_range_fndecl_22083_fields
+fib_nhs_fib_info_22091_fields fib_nhs fib_info 0 22091 NULL nohasharray
+err_mlxsw_reg_trans_22091_fields err mlxsw_reg_trans 0 22091 &fib_nhs_fib_info_22091_fields
+horus3a_write_regs_fndecl_22092_fields horus3a_write_regs fndecl 4 22092 NULL
+size_drm_i915_gem_pread_22096_fields size drm_i915_gem_pread 0 22096 NULL nohasharray
+frame_seq_number_osst_tape_22096_fields frame_seq_number osst_tape 0 22096 &size_drm_i915_gem_pread_22096_fields
+osd_req_op_extent_update_fndecl_22097_fields osd_req_op_extent_update fndecl 3 22097 NULL
+allocsz_cfv_info_22104_fields allocsz cfv_info 0 22104 NULL
+offset_vmcore_22117_fields offset vmcore 0 22117 NULL nohasharray
+size_perf_output_handle_22117_fields size perf_output_handle 0 22117 &offset_vmcore_22117_fields
+xfs_da_get_buf_fndecl_22120_fields xfs_da_get_buf fndecl 3 22120 NULL
+qgroup_reserve_fndecl_22126_fields qgroup_reserve fndecl 0 22126 NULL
+small_ttm_pool_opts_22131_fields small ttm_pool_opts 0 22131 NULL nohasharray
+ore_check_io_fndecl_22131_fields ore_check_io fndecl 0 22131 &small_ttm_pool_opts_22131_fields
+sys_copy_file_range_fndecl_22132_fields sys_copy_file_range fndecl 5 22132 NULL
+numa_add_memblk_fndecl_22136_fields numa_add_memblk fndecl 2-3 22136 NULL
+lo_rw_aio_fndecl_22138_fields lo_rw_aio fndecl 3 22138 NULL
+dm_tm_shadow_block_fndecl_22139_fields dm_tm_shadow_block fndecl 2 22139 NULL
+num_phys_eqs_mlx4_phys_caps_22142_fields num_phys_eqs mlx4_phys_caps 0 22142 NULL
+radeon_benchmark_move_fndecl_22144_fields radeon_benchmark_move fndecl 2 22144 NULL
+svc_rdma_xdr_encode_error_fndecl_22146_fields svc_rdma_xdr_encode_error fndecl 0 22146 NULL nohasharray
+regmap_encx24j600_spi_write_fndecl_22146_fields regmap_encx24j600_spi_write fndecl 4 22146 &svc_rdma_xdr_encode_error_fndecl_22146_fields
+max_cos_bnx2x_22147_fields max_cos bnx2x 0 22147 NULL
+cmd_pipe_uas_dev_info_22148_fields cmd_pipe uas_dev_info 0 22148 NULL
+seg_size_ib_mad_send_buf_22149_fields seg_size ib_mad_send_buf 0 22149 NULL
+ppp_cp_event_fndecl_22150_fields ppp_cp_event fndecl 6 22150 NULL
+rxq_entries_efx_nic_22154_fields rxq_entries efx_nic 0 22154 NULL
+collect_rx_frame_fndecl_22155_fields collect_rx_frame fndecl 3 22155 NULL
+i40iw_alloc_mr_fndecl_22161_fields i40iw_alloc_mr fndecl 3 22161 NULL
+rs_datalen_ath5k_rx_status_22164_fields rs_datalen ath5k_rx_status 0 22164 NULL
+tm6000_i2c_recv_regs16_fndecl_22166_fields tm6000_i2c_recv_regs16 fndecl 5 22166 NULL
+set_fast_connectable_fndecl_22171_fields set_fast_connectable fndecl 4 22171 NULL
+name_len_ceph_inode_xattr_22177_fields name_len ceph_inode_xattr 0 22177 NULL
+rts51x_bulk_transport_special_fndecl_22181_fields rts51x_bulk_transport_special fndecl 6 22181 NULL
+ieee80211_parse_bitrates_fndecl_22187_fields ieee80211_parse_bitrates fndecl 0 22187 NULL
+affs_alloc_block_fndecl_22192_fields affs_alloc_block fndecl 0-2 22192 NULL
+sector_packet_data_22197_fields sector packet_data 0 22197 NULL
+length_ntlmssp2_name_22211_fields length ntlmssp2_name 0 22211 NULL
+req_len_brcmf_cfg80211_assoc_ielen_le_22213_fields req_len brcmf_cfg80211_assoc_ielen_le 0 22213 NULL
+s_len_rvt_qp_22217_fields s_len rvt_qp 0 22217 NULL
+ram_size_async_extent_22219_fields ram_size async_extent 0 22219 NULL nohasharray
+hlen_cxgbit_lro_pdu_cb_22219_fields hlen cxgbit_lro_pdu_cb 0 22219 &ram_size_async_extent_22219_fields
+s_dirsize_minix_sb_info_22225_fields s_dirsize minix_sb_info 0 22225 NULL
+num_areas_prism2_download_param_22233_fields num_areas prism2_download_param 0 22233 NULL
+num_vlan_batadv_tvlv_tt_data_22234_fields num_vlan batadv_tvlv_tt_data 0 22234 NULL
+max_fingers_pixcir_i2c_ts_data_22237_fields max_fingers pixcir_i2c_ts_data 0 22237 NULL
+num_udav_mthca_profile_22243_fields num_udav mthca_profile 0 22243 NULL
+ieee80211_check_pending_bar_fndecl_22244_fields ieee80211_check_pending_bar fndecl 3 22244 NULL
+rf_suballoc_loc_ocfs2_refcount_block_22248_fields rf_suballoc_loc ocfs2_refcount_block 0 22248 NULL
+hfsplus_asc2uni_fndecl_22252_fields hfsplus_asc2uni fndecl 0 22252 NULL
+bbio_error_fndecl_22264_fields bbio_error fndecl 3 22264 NULL
+usCRTC_V_Total__ATOM_MODE_TIMING_22265_fields usCRTC_V_Total _ATOM_MODE_TIMING 0 22265 NULL
+mangle_contents_fndecl_22272_fields mangle_contents fndecl 4-6 22272 NULL
+gtt_total_entries__intel_private_22281_fields gtt_total_entries _intel_private 0 22281 NULL nohasharray
+reord_tcp_sacktag_state_22281_fields reord tcp_sacktag_state 0 22281 &gtt_total_entries__intel_private_22281_fields
+scif_get_phys_fndecl_22295_fields scif_get_phys fndecl 0-1 22295 NULL
+gfs2_listxattr_fndecl_22298_fields gfs2_listxattr fndecl 3 22298 NULL
+s_psn_rvt_qp_22305_fields s_psn rvt_qp 0 22305 NULL
+read_head_n_tty_data_22317_fields read_head n_tty_data 0 22317 NULL nohasharray
+index_start_nozomi_22317_fields index_start nozomi 0 22317 &read_head_n_tty_data_22317_fields
+swiotlb_late_init_with_default_size_fndecl_22319_fields swiotlb_late_init_with_default_size fndecl 1 22319 NULL
+be_fill_queue_fndecl_22320_fields be_fill_queue fndecl 2 22320 NULL
+vc_size_row_vc_data_22325_fields vc_size_row vc_data 0 22325 NULL
+user_data_len_uioc_22327_fields user_data_len uioc 0 22327 NULL
+atmel_change_mtu_fndecl_22328_fields atmel_change_mtu fndecl 2 22328 NULL
+limit_sfq_sched_data_22334_fields limit sfq_sched_data 0 22334 NULL
+verity_hash_final_fndecl_22340_fields verity_hash_final fndecl 0 22340 NULL
+mtu_tipc_link_22341_fields mtu tipc_link 0 22341 NULL
+svc_recvfrom_fndecl_22345_fields svc_recvfrom fndecl 0-4-3 22345 NULL
+drv_info_size_mwifiex_adapter_22352_fields drv_info_size mwifiex_adapter 0 22352 NULL
+tlv_put_string_fndecl_22356_fields tlv_put_string fndecl 4 22356 NULL
+genwqe_alloc_sync_sgl_fndecl_22358_fields genwqe_alloc_sync_sgl fndecl 4 22358 NULL
+buf_size_mlx5_ib_rwq_22365_fields buf_size mlx5_ib_rwq 0 22365 NULL nohasharray
+___pskb_trim_fndecl_22365_fields ___pskb_trim fndecl 2 22365 &buf_size_mlx5_ib_rwq_22365_fields
+kvm_gfn_to_hva_cache_init_fndecl_22367_fields kvm_gfn_to_hva_cache_init fndecl 3 22367 NULL
+digi_write_fndecl_22372_fields digi_write fndecl 4 22372 NULL
+nr_luns_rrpc_22379_fields nr_luns rrpc 0 22379 NULL
+exposure_step_sd_22386_fields exposure_step sd 0 22386 NULL
+phys_lcr_base_mgsl_struct_22391_fields phys_lcr_base mgsl_struct 0 22391 NULL
+m25p80_write_fndecl_22392_fields m25p80_write fndecl 3 22392 NULL
+clipt_end_adapter_22397_fields clipt_end adapter 0 22397 NULL
+ext_tree_mark_written_fndecl_22398_fields ext_tree_mark_written fndecl 2-3 22398 NULL
+rawsock_sendmsg_fndecl_22401_fields rawsock_sendmsg fndecl 3 22401 NULL
+udf_setsize_fndecl_22402_fields udf_setsize fndecl 2 22402 NULL
+use_inline_bio_fndecl_22408_fields use_inline_bio fndecl 3 22408 NULL
+len_usbdevfs_bulktransfer_22411_fields len usbdevfs_bulktransfer 0 22411 NULL nohasharray
+do_truncate_fndecl_22411_fields do_truncate fndecl 2 22411 &len_usbdevfs_bulktransfer_22411_fields nohasharray
+twl4030_init_sih_modules_fndecl_22411_fields twl4030_init_sih_modules fndecl 0 22411 &do_truncate_fndecl_22411_fields
+max_ccb_vardecl_hpilo_c_22414_fields max_ccb vardecl_hpilo.c 0 22414 NULL
+oti6858_write_fndecl_22423_fields oti6858_write fndecl 4 22423 NULL
+bbRcvSizeMsb_csp_22425_fields bbRcvSizeMsb csp 0 22425 NULL
+add_size_pci_dev_resource_22434_fields add_size pci_dev_resource 0 22434 NULL
+vxlan_build_skb_fndecl_22447_fields vxlan_build_skb fndecl 3 22447 NULL
+frame_len_ksz_desc_rx_stat_22454_fields frame_len ksz_desc_rx_stat 0 22454 NULL
+ntfs_attr_vcn_to_lcn_nolock_fndecl_22455_fields ntfs_attr_vcn_to_lcn_nolock fndecl 2 22455 NULL
+oid_printf_vargs_fndecl_22457_fields oid_printf_vargs fndecl 0 22457 NULL nohasharray
+llc_ui_recvmsg_fndecl_22457_fields llc_ui_recvmsg fndecl 3 22457 &oid_printf_vargs_fndecl_22457_fields
+mon_bin_ioctl_fndecl_22464_fields mon_bin_ioctl fndecl 3 22464 NULL nohasharray
+ceph_zero_pagecache_range_fndecl_22464_fields ceph_zero_pagecache_range fndecl 3-2 22464 &mon_bin_ioctl_fndecl_22464_fields
+s35390a_set_reg_fndecl_22468_fields s35390a_set_reg fndecl 4 22468 NULL
+vmbus_sendpacket_fndecl_22469_fields vmbus_sendpacket fndecl 3 22469 NULL
+s_data_blksize_affs_sb_info_22478_fields s_data_blksize affs_sb_info 0 22478 NULL
+vram_size_aty128fb_par_22489_fields vram_size aty128fb_par 0 22489 NULL nohasharray
+hid_report_raw_event_fndecl_22489_fields hid_report_raw_event fndecl 4 22489 &vram_size_aty128fb_par_22489_fields
+find_group_other_fndecl_22490_fields find_group_other fndecl 0 22490 NULL
+offset_rbd_img_request_22494_fields offset rbd_img_request 0 22494 NULL
+tx_hr_cfv_info_22495_fields tx_hr cfv_info 0 22495 NULL
+size_drm_virtgpu_execbuffer_22498_fields size drm_virtgpu_execbuffer 0 22498 NULL
+hiface_pcm_init_urb_fndecl_22500_fields hiface_pcm_init_urb fndecl 3 22500 NULL
+irq_bcma_device_22505_fields irq bcma_device 0 22505 NULL
+ctx_len_xfrm_sec_ctx_22511_fields ctx_len xfrm_sec_ctx 0 22511 NULL
+total_cnt_i40iw_pble_alloc_22514_fields total_cnt i40iw_pble_alloc 0 22514 NULL nohasharray
+h_mode_size_22514_fields h mode_size 0 22514 &total_cnt_i40iw_pble_alloc_22514_fields
+ls_lvblen_dlm_ls_22525_fields ls_lvblen dlm_ls 0 22525 NULL
+ocfs2_bg_discontig_add_extent_fndecl_22531_fields ocfs2_bg_discontig_add_extent fndecl 4 22531 NULL
+pci_iomap_wc_range_fndecl_22536_fields pci_iomap_wc_range fndecl 4-3 22536 NULL
+eq_cnt_ocrdma_dev_22537_fields eq_cnt ocrdma_dev 0 22537 NULL
+last_checkpoint_r5l_log_22540_fields last_checkpoint r5l_log 0 22540 NULL
+submit_queue_fndecl_22542_fields submit_queue fndecl 5 22542 NULL
+clsb_isar_reg_22551_fields clsb isar_reg 0 22551 NULL
+sadb_x_ctx_len_sadb_x_sec_ctx_22553_fields sadb_x_ctx_len sadb_x_sec_ctx 0 22553 NULL
+w9968cf_i2c_r_fndecl_22560_fields w9968cf_i2c_r fndecl 0 22560 NULL
+max_xor_dma_device_22564_fields max_xor dma_device 0 22564 NULL
+carl9170_rx_stream_fndecl_22565_fields carl9170_rx_stream fndecl 3 22565 NULL
+fsync_file_operations_22566_fields fsync file_operations 0 22566 NULL
+burst_fsl_edma_slave_config_22570_fields burst fsl_edma_slave_config 0 22570 NULL
+id_rfcomm_dev_22580_fields id rfcomm_dev 0 22580 NULL
+qlcnic_pci_sriov_configure_fndecl_22588_fields qlcnic_pci_sriov_configure fndecl 2 22588 NULL nohasharray
+rx_queue_size_pxa168_eth_platform_data_22588_fields rx_queue_size pxa168_eth_platform_data 0 22588 &qlcnic_pci_sriov_configure_fndecl_22588_fields
+scif_rb_get_next_fndecl_22601_fields scif_rb_get_next fndecl 3 22601 NULL
+tx_data_max_size_sst_generic_ipc_22604_fields tx_data_max_size sst_generic_ipc 0 22604 NULL
+maxauthsize_aead_alg_22608_fields maxauthsize aead_alg 0 22608 NULL nohasharray
+btrfs_submit_compressed_write_fndecl_22608_fields btrfs_submit_compressed_write fndecl 4 22608 &maxauthsize_aead_alg_22608_fields
+count_mspro_attribute_22612_fields count mspro_attribute 0 22612 NULL
+len_aironet_ioctl_22615_fields len aironet_ioctl 0 22615 NULL
+ir_startino_xfs_inobt_rec_incore_22616_fields ir_startino xfs_inobt_rec_incore 0 22616 NULL
+mem_hole_size_fndecl_22619_fields mem_hole_size fndecl 0-1-2 22619 NULL
+curr_block_migrate_struct_22621_fields curr_block migrate_struct 0 22621 NULL
+length_obj_key_22626_fields length obj_key 0 22626 NULL
+n_compat_sel_arg_struct_22628_fields n compat_sel_arg_struct 0 22628 NULL
+hci_si_event_fndecl_22639_fields hci_si_event fndecl 3 22639 NULL
+scif_vwriteto_fndecl_22640_fields scif_vwriteto fndecl 4-3 22640 NULL
+num_rcv_bufs_visornic_devdata_22643_fields num_rcv_bufs visornic_devdata 0 22643 NULL
+queue_size_snd_timer_params_22646_fields queue_size snd_timer_params 0 22646 NULL
+do_msgsnd_fndecl_22648_fields do_msgsnd fndecl 4 22648 NULL
+isight_decode_fndecl_22650_fields isight_decode fndecl 4 22650 NULL
+sample_rate_usb_stream_config_22662_fields sample_rate usb_stream_config 0 22662 NULL
+sw_start_stm_data_22665_fields sw_start stm_data 0 22665 NULL
+pointer_kmemleak_object_22670_fields pointer kmemleak_object 0 22670 NULL
+ieee80211_mesh_rx_bcn_presp_fndecl_22678_fields ieee80211_mesh_rx_bcn_presp fndecl 4 22678 NULL
+fbcon_redraw_softback_fndecl_22679_fields fbcon_redraw_softback fndecl 3 22679 NULL
+vlan_tag_bnx2x_agg_info_22683_fields vlan_tag bnx2x_agg_info 0 22683 NULL
+irq_pipe_ttusb_dec_22685_fields irq_pipe ttusb_dec 0 22685 NULL
+sctp_sf_abort_violation_fndecl_22687_fields sctp_sf_abort_violation fndecl 7 22687 NULL
+vidioc_s_input_fndecl_22689_fields vidioc_s_input fndecl 3 22689 NULL
+qca_recv_fndecl_22690_fields qca_recv fndecl 3 22690 NULL
+ctl_dma_yealink_dev_22696_fields ctl_dma yealink_dev 0 22696 NULL
+len_vring_desc_22700_fields len vring_desc 0 22700 NULL
+alloc_vudc_device_fndecl_22709_fields alloc_vudc_device fndecl 1 22709 NULL
+brcmf_sdio_read_control_fndecl_22712_fields brcmf_sdio_read_control fndecl 3 22712 NULL
+scif_rb_write_fndecl_22718_fields scif_rb_write fndecl 3 22718 NULL
+tail_inbuf_t_22719_fields tail inbuf_t 0 22719 NULL nohasharray
+fc_trace_max_entries_vardecl_fnic_trace_c_22719_fields fc_trace_max_entries vardecl_fnic_trace.c 0 22719 &tail_inbuf_t_22719_fields
+SMB2_ioctl_fndecl_22721_fields SMB2_ioctl fndecl 8 22721 NULL
+ath6kl_wmi_get_tx_pwr_cmd_fndecl_22722_fields ath6kl_wmi_get_tx_pwr_cmd fndecl 2 22722 NULL nohasharray
+niu_parent_index_vardecl_niu_c_22722_fields niu_parent_index vardecl_niu.c 0 22722 &ath6kl_wmi_get_tx_pwr_cmd_fndecl_22722_fields
+odm_mirror_cnt_pnfs_osd_data_map_22727_fields odm_mirror_cnt pnfs_osd_data_map 0 22727 NULL
+fcoe_hmc_cntx_num_i40e_pf_22730_fields fcoe_hmc_cntx_num i40e_pf 0 22730 NULL
+__blk_bios_map_sg_fndecl_22734_fields __blk_bios_map_sg fndecl 0 22734 NULL
+xprt_alloc_fndecl_22736_fields xprt_alloc fndecl 4-3 22736 NULL
+num_fcoe_qps_i40e_pf_22740_fields num_fcoe_qps i40e_pf 0 22740 NULL
+iwlagn_pass_packet_to_mac80211_fndecl_22746_fields iwlagn_pass_packet_to_mac80211 fndecl 3 22746 NULL
+rambase_brcmf_chip_22773_fields rambase brcmf_chip 0 22773 NULL
+orig_video_cols_screen_info_22783_fields orig_video_cols screen_info 0 22783 NULL
+submit_bh_wbc_fndecl_22789_fields submit_bh_wbc fndecl 0 22789 NULL
+reqsize_akcipher_alg_22792_fields reqsize akcipher_alg 0 22792 NULL
+h_start_saa7134_tvnorm_22798_fields h_start saa7134_tvnorm 0 22798 NULL
+i_next_section_block_iso_inode_info_22800_fields i_next_section_block iso_inode_info 0 22800 NULL nohasharray
+adapter_index_hpi_adapter_res_22800_fields adapter_index hpi_adapter_res 0 22800 &i_next_section_block_iso_inode_info_22800_fields
+my_inptr_vardecl_initramfs_c_22809_fields my_inptr vardecl_initramfs.c 0 22809 NULL
+aper_size_amdgpu_mc_22824_fields aper_size amdgpu_mc 0 22824 NULL
+tx_size_uart_8250_dma_22825_fields tx_size uart_8250_dma 0 22825 NULL
+gigaset_initdriver_fndecl_22839_fields gigaset_initdriver fndecl 1 22839 NULL
+lan78xx_change_mtu_fndecl_22844_fields lan78xx_change_mtu fndecl 2 22844 NULL
+sys_mremap_fndecl_22848_fields sys_mremap fndecl 5-3-1-2 22848 NULL nohasharray
+clean_io_failure_fndecl_22848_fields clean_io_failure fndecl 4 22848 &sys_mremap_fndecl_22848_fields
+rlen_si2168_cmd_22851_fields rlen si2168_cmd 0 22851 NULL
+var2_apei_exec_context_22852_fields var2 apei_exec_context 0 22852 NULL
+utf8s_to_utf16s_fndecl_22856_fields utf8s_to_utf16s fndecl 0 22856 NULL
+size_proc_dir_entry_22859_fields size proc_dir_entry 0 22859 NULL
+test_eb_bitmaps_fndecl_22861_fields test_eb_bitmaps fndecl 2 22861 NULL
+xs_sendpages_fndecl_22864_fields xs_sendpages fndecl 5 22864 NULL
+hpfs_get_block_fndecl_22865_fields hpfs_get_block fndecl 2 22865 NULL
+usCRTC_H_SyncStart__ATOM_MODE_TIMING_22868_fields usCRTC_H_SyncStart _ATOM_MODE_TIMING 0 22868 NULL
+n_subbufs_rchan_22872_fields n_subbufs rchan 0 22872 NULL
+enc28j60_mem_read_fndecl_22875_fields enc28j60_mem_read fndecl 3 22875 NULL
+count_nfs3_readdirargs_22881_fields count nfs3_readdirargs 0 22881 NULL
+len_prism2_download_area_22884_fields len prism2_download_area 0 22884 NULL
+frag_len_atmel_private_22893_fields frag_len atmel_private 0 22893 NULL
+snap_names_len_rbd_image_header_ondisk_22898_fields snap_names_len rbd_image_header_ondisk 0 22898 NULL
+ima_post_read_file_fndecl_22903_fields ima_post_read_file fndecl 3 22903 NULL nohasharray
+lpfc_fcp_io_channel_init_fndecl_22903_fields lpfc_fcp_io_channel_init fndecl 2 22903 &ima_post_read_file_fndecl_22903_fields
+count_ioctl_gntdev_map_grant_ref_22904_fields count ioctl_gntdev_map_grant_ref 0 22904 NULL
+num_y_edt_ft5x06_ts_data_22905_fields num_y edt_ft5x06_ts_data 0 22905 NULL
+membase_phys_efx_nic_22907_fields membase_phys efx_nic 0 22907 NULL
+cfg80211_report_obss_beacon_fndecl_22910_fields cfg80211_report_obss_beacon fndecl 3 22910 NULL
+tty_audit_log_fndecl_22915_fields tty_audit_log fndecl 4 22915 NULL
+len_policy_load_memory_22916_fields len policy_load_memory 0 22916 NULL
+node_con_driver_22919_fields node con_driver 0 22919 NULL
+len_ext4_allocation_request_22920_fields len ext4_allocation_request 0 22920 NULL
+lidar_i2c_xfer_fndecl_22921_fields lidar_i2c_xfer fndecl 4 22921 NULL
+e_name_len_ext4_xattr_entry_22925_fields e_name_len ext4_xattr_entry 0 22925 NULL
+port100_send_frame_async_fndecl_22927_fields port100_send_frame_async fndecl 4 22927 NULL
+event_data_len_msgbuf_rx_event_22931_fields event_data_len msgbuf_rx_event 0 22931 NULL
+i2400m_rx_ctl_fndecl_22934_fields i2400m_rx_ctl fndecl 4 22934 NULL
+num_counters_ip6t_replace_22944_fields num_counters ip6t_replace 0 22944 NULL
+bulk_out_usbatm_driver_22950_fields bulk_out usbatm_driver 0 22950 NULL
+al_stripe_size_4k_drbd_md_22954_fields al_stripe_size_4k drbd_md 0 22954 NULL
+osd_full_h_yuv_playback_info_22967_fields osd_full_h yuv_playback_info 0 22967 NULL
+data_swap_cluster_info_22969_fields data swap_cluster_info 0 22969 NULL
+i2400m_rx_ctl_ack_fndecl_22972_fields i2400m_rx_ctl_ack fndecl 3 22972 NULL
+nilfs_palloc_init_blockgroup_fndecl_22978_fields nilfs_palloc_init_blockgroup fndecl 2 22978 NULL
+do_mmap_fndecl_22981_fields do_mmap fndecl 3-0-7 22981 NULL
+max_pkt_size_stk1160_isoc_ctl_22983_fields max_pkt_size stk1160_isoc_ctl 0 22983 NULL
+sector_size_flash_info_22990_fields sector_size flash_info 0 22990 NULL nohasharray
+snd_hdac_read_fndecl_22990_fields snd_hdac_read fndecl 0 22990 &sector_size_flash_info_22990_fields
+p54spi_spi_write_fndecl_22994_fields p54spi_spi_write fndecl 4 22994 NULL
+size_wil_memio_block_22999_fields size wil_memio_block 0 22999 NULL nohasharray
+total_xfs_da_args_22999_fields total xfs_da_args 0 22999 &size_wil_memio_block_22999_fields
+ipw_packet_received_skb_fndecl_23005_fields ipw_packet_received_skb fndecl 2 23005 NULL
+pos_coredump_params_23014_fields pos coredump_params 0 23014 NULL
+memblock_alloc_range_fndecl_23015_fields memblock_alloc_range fndecl 2-3-4 23015 NULL nohasharray
+fb_height_drm_fb_helper_surface_size_23015_fields fb_height drm_fb_helper_surface_size 0 23015 &memblock_alloc_range_fndecl_23015_fields nohasharray
+desc_size_data_queue_23015_fields desc_size data_queue 0 23015 &fb_height_drm_fb_helper_surface_size_23015_fields nohasharray
+tx_size_iscsi_cmd_23015_fields tx_size iscsi_cmd 0 23015 &desc_size_data_queue_23015_fields
+bLength_usb_endpoint_descriptor_23016_fields bLength usb_endpoint_descriptor 0 23016 NULL
+tim_len_wmi_tim_info_arg_23018_fields tim_len wmi_tim_info_arg 0 23018 NULL
+fw_vif_idx_ath6kl_vif_23020_fields fw_vif_idx ath6kl_vif 0 23020 NULL
+acpi_aml_write_kern_fndecl_23032_fields acpi_aml_write_kern fndecl 2-0 23032 NULL
+rx_frag_size_atl1c_adapter_23034_fields rx_frag_size atl1c_adapter 0 23034 NULL nohasharray
+remap_fndecl_23034_fields remap fndecl 3 23034 &rx_frag_size_atl1c_adapter_23034_fields
+io_tlb_start_vardecl_swiotlb_c_23035_fields io_tlb_start vardecl_swiotlb.c 0 23035 NULL
+in_ep_smsusb_device_t_23038_fields in_ep smsusb_device_t 0 23038 NULL
+lost_cnt_hint_tcp_sock_23039_fields lost_cnt_hint tcp_sock 0 23039 NULL
+num_comp_vectors_mlx5_eq_table_23047_fields num_comp_vectors mlx5_eq_table 0 23047 NULL
+y1_drm_clip_rect_23048_fields y1 drm_clip_rect 0 23048 NULL
+gfs2_read_super_fndecl_23055_fields gfs2_read_super fndecl 2 23055 NULL
+ueth_change_mtu_fndecl_23057_fields ueth_change_mtu fndecl 2 23057 NULL
+agp_base_radeon_mc_23066_fields agp_base radeon_mc 0 23066 NULL nohasharray
+fe_start_ext4_free_extent_23066_fields fe_start ext4_free_extent 0 23066 &agp_base_radeon_mc_23066_fields
+fm10k_iov_configure_fndecl_23078_fields fm10k_iov_configure fndecl 2 23078 NULL
+ext_ofs_sym_ccb_23085_fields ext_ofs sym_ccb 0 23085 NULL
+devfn_pci_dev_23093_fields devfn pci_dev 0 23093 NULL
+l2_len_ovs_frag_data_23095_fields l2_len ovs_frag_data 0 23095 NULL nohasharray
+s_cluster_ratio_ext4_sb_info_23095_fields s_cluster_ratio ext4_sb_info 0 23095 &l2_len_ovs_frag_data_23095_fields
+qla27xx_fwdt_template_default_size_fndecl_23103_fields qla27xx_fwdt_template_default_size fndecl 0 23103 NULL
+__minimum_chunk_size_fndecl_23105_fields __minimum_chunk_size fndecl 0 23105 NULL
+max_elts_tracing_map_23116_fields max_elts tracing_map 0 23116 NULL
+aim_vdev_read_fndecl_23120_fields aim_vdev_read fndecl 3 23120 NULL
+xfs_rmap_unmap_fndecl_23123_fields xfs_rmap_unmap fndecl 0 23123 NULL nohasharray
+sq_max_sges_c4iw_qp_attributes_23123_fields sq_max_sges c4iw_qp_attributes 0 23123 &xfs_rmap_unmap_fndecl_23123_fields
+numchips_nand_chip_23137_fields numchips nand_chip 0 23137 NULL
+num_dv_ports_adv76xx_chip_info_23140_fields num_dv_ports adv76xx_chip_info 0 23140 NULL
+udf_load_pvoldesc_fndecl_23141_fields udf_load_pvoldesc fndecl 2 23141 NULL
+__ceph_choose_frag_fndecl_23142_fields __ceph_choose_frag fndecl 0 23142 NULL
+max_sge_rxe_sq_23148_fields max_sge rxe_sq 0 23148 NULL
+max_tx_urbs_kvaser_usb_23152_fields max_tx_urbs kvaser_usb 0 23152 NULL
+memblock_free_fndecl_23154_fields memblock_free fndecl 2-1 23154 NULL
+oxu_create_fndecl_23159_fields oxu_create fndecl 3-2 23159 NULL
+isdn_audio_xlaw2adpcm_fndecl_23162_fields isdn_audio_xlaw2adpcm fndecl 0 23162 NULL
+gfs2_xattr_set_fndecl_23165_fields gfs2_xattr_set fndecl 6 23165 NULL
+width_linux_logo_23166_fields width linux_logo 0 23166 NULL
+memblock_alloc_base_fndecl_23169_fields memblock_alloc_base fndecl 2-0-3 23169 NULL nohasharray
+MaxIoCommands_aac_init_23169_fields MaxIoCommands aac_init 0 23169 &memblock_alloc_base_fndecl_23169_fields
+xfs_sb_verify_fndecl_23173_fields xfs_sb_verify fndecl 0 23173 NULL
+cyttsp_probe_fndecl_23175_fields cyttsp_probe fndecl 4 23175 NULL
+x_res_vbe_mode_ib_23177_fields x_res vbe_mode_ib 0 23177 NULL
+udf_current_aext_fndecl_23183_fields udf_current_aext fndecl 0 23183 NULL
+__reuseport_alloc_fndecl_23190_fields __reuseport_alloc fndecl 1 23190 NULL
+seq_lseek_fndecl_23197_fields seq_lseek fndecl 2 23197 NULL
+offs_aim_fh_23201_fields offs aim_fh 0 23201 NULL
+read_swap_header_fndecl_23222_fields read_swap_header fndecl 0 23222 NULL
+vid_hdr_offset_ubi_device_23225_fields vid_hdr_offset ubi_device 0 23225 NULL nohasharray
+clk_core_get_rate_fndecl_23225_fields clk_core_get_rate fndecl 0 23225 &vid_hdr_offset_ubi_device_23225_fields
+xfs_defer_finish_fndecl_23226_fields xfs_defer_finish fndecl 0 23226 NULL
+win_size_tool_mw_23227_fields win_size tool_mw 0 23227 NULL
+nvkm_client_map_fndecl_23228_fields nvkm_client_map fndecl 3-2 23228 NULL
+ubifs_prep_grp_node_fndecl_23231_fields ubifs_prep_grp_node fndecl 3 23231 NULL
+sb_min_blocksize_fndecl_23239_fields sb_min_blocksize fndecl 0-2 23239 NULL
+dir_per_block_bits_msdos_sb_info_23245_fields dir_per_block_bits msdos_sb_info 0 23245 NULL
+ksm_madvise_fndecl_23247_fields ksm_madvise fndecl 2 23247 NULL
+__alloc_bootmem_node_fndecl_23259_fields __alloc_bootmem_node fndecl 3-4 23259 NULL
+ndescs_gpio_descs_23267_fields ndescs gpio_descs 0 23267 NULL
+devm_ioremap_nocache_fndecl_23271_fields devm_ioremap_nocache fndecl 3-2 23271 NULL nohasharray
+bufblocks_vardecl_saa6588_c_23271_fields bufblocks vardecl_saa6588.c 0 23271 &devm_ioremap_nocache_fndecl_23271_fields
+cifs_read_fndecl_23274_fields cifs_read fndecl 3 23274 NULL
+udf_table_new_block_fndecl_23276_fields udf_table_new_block fndecl 0 23276 NULL
+start_blkpg_partition_23281_fields start blkpg_partition 0 23281 NULL
+n_tty_receive_buf2_fndecl_23286_fields n_tty_receive_buf2 fndecl 4 23286 NULL
+modedb_len_fb_monspecs_23289_fields modedb_len fb_monspecs 0 23289 NULL
+shmac_num_idents_sctp_hmacalgo_23292_fields shmac_num_idents sctp_hmacalgo 0 23292 NULL
+vtbl_slots_ubi_device_23293_fields vtbl_slots ubi_device 0 23293 NULL
+get_node_info_fndecl_23296_fields get_node_info fndecl 2 23296 NULL
+fnic_get_trace_data_fndecl_23305_fields fnic_get_trace_data fndecl 0 23305 NULL
+s_blocks_per_segment_nilfs_super_block_23318_fields s_blocks_per_segment nilfs_super_block 0 23318 NULL
+max_send_sge_ocrdma_dev_attr_23321_fields max_send_sge ocrdma_dev_attr 0 23321 NULL
+naces_nfs4_acl_23334_fields naces nfs4_acl 0 23334 NULL
+max_wr_rd_sge_ocrdma_mbx_query_config_23340_fields max_wr_rd_sge ocrdma_mbx_query_config 0 23340 NULL nohasharray
+num_outputs_clkgena_divmux_data_23340_fields num_outputs clkgena_divmux_data 0 23340 &max_wr_rd_sge_ocrdma_mbx_query_config_23340_fields
+max_header_size_tsap_cb_23342_fields max_header_size tsap_cb 0 23342 NULL
+compat_sys_vmsplice_fndecl_23344_fields compat_sys_vmsplice fndecl 3 23344 NULL
+mark_block_processed_fndecl_23353_fields mark_block_processed fndecl 3-2 23353 NULL nohasharray
+pci_iov_virtfn_devfn_fndecl_23353_fields pci_iov_virtfn_devfn fndecl 0-2 23353 &mark_block_processed_fndecl_23353_fields
+vxres_crtc_23359_fields vxres crtc 0 23359 NULL
+v9fs_fid_xattr_get_fndecl_23361_fields v9fs_fid_xattr_get fndecl 4 23361 NULL
+default_blksize_st_modedef_23371_fields default_blksize st_modedef 0 23371 NULL
+kernel_map_sync_memtype_fndecl_23381_fields kernel_map_sync_memtype fndecl 1 23381 NULL
+length_dmi_header_23383_fields length dmi_header 0 23383 NULL
+pcpu_atom_size_vardecl_percpu_c_23384_fields pcpu_atom_size vardecl_percpu.c 0 23384 NULL
+sf_entsize_xfs_dir_ops_23386_fields sf_entsize xfs_dir_ops 0 23386 NULL nohasharray
+dstirq_mpc_intsrc_23386_fields dstirq mpc_intsrc 0 23386 &sf_entsize_xfs_dir_ops_23386_fields
+new_SSID_size_atmel_private_23387_fields new_SSID_size atmel_private 0 23387 NULL nohasharray
+did_munit_23387_fields did munit 0 23387 &new_SSID_size_atmel_private_23387_fields
+__irlan_insert_param_fndecl_23389_fields __irlan_insert_param fndecl 7 23389 NULL
+xfs_alloc_file_space_fndecl_23394_fields xfs_alloc_file_space fndecl 2-3 23394 NULL
+de_name_len_gfs2_dirent_23398_fields de_name_len gfs2_dirent 0 23398 NULL
+max_cmds_ips_ha_23401_fields max_cmds ips_ha 0 23401 NULL
+max_socks_sock_reuseport_23407_fields max_socks sock_reuseport 0 23407 NULL
+nx_fw_cmd_set_gbe_port_fndecl_23412_fields nx_fw_cmd_set_gbe_port fndecl 3 23412 NULL
+cifs_write_end_fndecl_23416_fields cifs_write_end fndecl 5 23416 NULL
+max_snd_interval_23422_fields max snd_interval 0 23422 NULL
+__qib_get_user_pages_fndecl_23426_fields __qib_get_user_pages fndecl 1 23426 NULL
+ftdi_instances_vardecl_ftdi_elan_c_23438_fields ftdi_instances vardecl_ftdi-elan.c 0 23438 NULL
+set_xfer_rate_fndecl_23440_fields set_xfer_rate fndecl 2 23440 NULL
+seg_size_wa_xfer_23450_fields seg_size wa_xfer 0 23450 NULL
+name_len_ocfs2_dir_entry_23452_fields name_len ocfs2_dir_entry 0 23452 NULL
+virtio_transport_stream_dequeue_fndecl_23453_fields virtio_transport_stream_dequeue fndecl 3 23453 NULL
+nct6775_create_attr_group_fndecl_23454_fields nct6775_create_attr_group fndecl 3 23454 NULL
+max_size_virtio_gpu_drv_capset_23460_fields max_size virtio_gpu_drv_capset 0 23460 NULL
+rsi_sdio_write_register_multiple_fndecl_23471_fields rsi_sdio_write_register_multiple fndecl 4 23471 NULL
+offset_ttm_bus_placement_23475_fields offset ttm_bus_placement 0 23475 NULL
+coda_psdev_write_fndecl_23484_fields coda_psdev_write fndecl 3 23484 NULL
+control_skge_rx_desc_23486_fields control skge_rx_desc 0 23486 NULL
+egr_sz_sge_23500_fields egr_sz sge 0 23500 NULL
+mxt_read_and_process_messages_fndecl_23502_fields mxt_read_and_process_messages fndecl 2-0 23502 NULL
+rxHeader2_edgeport_serial_23525_fields rxHeader2 edgeport_serial 0 23525 NULL
+s_cur_size_rvt_qp_23528_fields s_cur_size rvt_qp 0 23528 NULL
+pf_tids_total_qed_tm_iids_23535_fields pf_tids_total qed_tm_iids 0 23535 NULL
+offset_crypto_cts_reqctx_23536_fields offset crypto_cts_reqctx 0 23536 NULL
+ieee80211_new_mesh_header_fndecl_23538_fields ieee80211_new_mesh_header fndecl 0 23538 NULL
+ring_size_per_user_data_23539_fields ring_size per_user_data 0 23539 NULL
+FbUsableSize_nvidia_par_23541_fields FbUsableSize nvidia_par 0 23541 NULL
+ebt_size_mwt_fndecl_23547_fields ebt_size_mwt fndecl 0 23547 NULL
+ufs_inode_getblock_fndecl_23550_fields ufs_inode_getblock fndecl 4-3-2-0 23550 NULL
+n_fields_tracing_map_23556_fields n_fields tracing_map 0 23556 NULL nohasharray
+ast_fbdev_set_base_fndecl_23556_fields ast_fbdev_set_base fndecl 2 23556 &n_fields_tracing_map_23556_fields
+xfs_dabuf_map_fndecl_23558_fields xfs_dabuf_map fndecl 2 23558 NULL
+p_chmask_f_uac2_opts_23559_fields p_chmask f_uac2_opts 0 23559 NULL
+bdx_change_mtu_fndecl_23561_fields bdx_change_mtu fndecl 2 23561 NULL nohasharray
+cxgbit_copy_frags_fndecl_23561_fields cxgbit_copy_frags fndecl 3 23561 &bdx_change_mtu_fndecl_23561_fields
+lblock_gfs2_journal_extent_23574_fields lblock gfs2_journal_extent 0 23574 NULL
+secblob_len_cifs_spnego_msg_23580_fields secblob_len cifs_spnego_msg 0 23580 NULL
+rx_max_size_cxgbi_device_23582_fields rx_max_size cxgbi_device 0 23582 NULL
+resource_length_aml_resource_large_header_23584_fields resource_length aml_resource_large_header 0 23584 NULL
+nr_devices_ssb_bus_23589_fields nr_devices ssb_bus 0 23589 NULL nohasharray
+platform_device_add_data_fndecl_23589_fields platform_device_add_data fndecl 3 23589 &nr_devices_ssb_bus_23589_fields
+hugetlb_no_page_fndecl_23597_fields hugetlb_no_page fndecl 5 23597 NULL
+c67x00_probe_sie_fndecl_23602_fields c67x00_probe_sie fndecl 3 23602 NULL
+mthca_alloc_icm_pages_fndecl_23615_fields mthca_alloc_icm_pages fndecl 2 23615 NULL
+video_size_sis_video_info_23622_fields video_size sis_video_info 0 23622 NULL nohasharray
+mthca_alloc_fndecl_23622_fields mthca_alloc fndecl 0 23622 &video_size_sis_video_info_23622_fields
+blocksize_iso9660_options_23626_fields blocksize iso9660_options 0 23626 NULL
+skge_rx_setup_fndecl_23628_fields skge_rx_setup fndecl 4 23628 NULL
+vb_bytes_per_line_cx18_stream_23630_fields vb_bytes_per_line cx18_stream 0 23630 NULL nohasharray
+ll_zero_fndecl_23630_fields ll_zero fndecl 3-4 23630 &vb_bytes_per_line_cx18_stream_23630_fields
+ath9k_wmi_cmd_fndecl_23636_fields ath9k_wmi_cmd fndecl 4 23636 NULL
+ceph_sync_read_fndecl_23643_fields ceph_sync_read fndecl 0 23643 NULL
+kcm_recvmsg_fndecl_23646_fields kcm_recvmsg fndecl 3 23646 NULL
+map_urb_for_dma_fndecl_23647_fields map_urb_for_dma fndecl 0 23647 NULL
+size_crush_bucket_23650_fields size crush_bucket 0 23650 NULL
+piobcnt4k_qib_devdata_23655_fields piobcnt4k qib_devdata 0 23655 NULL
+viafb_bpp1_vardecl_viafbdev_c_23657_fields viafb_bpp1 vardecl_viafbdev.c 0 23657 NULL
+cmtp_send_interopmsg_fndecl_23659_fields cmtp_send_interopmsg fndecl 7 23659 NULL
+reg_list_size_bytes_rlc_firmware_header_v2_0_23660_fields reg_list_size_bytes rlc_firmware_header_v2_0 0 23660 NULL nohasharray
+elem_count_mlxsw_pci_queue_ops_23660_fields elem_count mlxsw_pci_queue_ops 0 23660 &reg_list_size_bytes_rlc_firmware_header_v2_0_23660_fields nohasharray
+unix_stream_sendpage_fndecl_23660_fields unix_stream_sendpage fndecl 4-3 23660 &elem_count_mlxsw_pci_queue_ops_23660_fields
+fat_length_msdos_sb_info_23672_fields fat_length msdos_sb_info 0 23672 NULL
+xfs_get_blocks_fndecl_23679_fields xfs_get_blocks fndecl 2 23679 NULL nohasharray
+__send_discard_fndecl_23679_fields __send_discard fndecl 0 23679 &xfs_get_blocks_fndecl_23679_fields
+xfs_ialloc_next_ag_fndecl_23680_fields xfs_ialloc_next_ag fndecl 0 23680 NULL
+user_set_fndecl_23682_fields user_set fndecl 6 23682 NULL
+buf_size_vmci_ctx_chkpt_buf_info_23686_fields buf_size vmci_ctx_chkpt_buf_info 0 23686 NULL
+vxfs_bmap1_fndecl_23688_fields vxfs_bmap1 fndecl 0-2 23688 NULL
+aio_read_events_ring_fndecl_23689_fields aio_read_events_ring fndecl 3 23689 NULL
+aac_fib_adapter_complete_fndecl_23697_fields aac_fib_adapter_complete fndecl 2 23697 NULL
+size_ubifs_ino_node_23699_fields size ubifs_ino_node 0 23699 NULL
+rmtvaluelen_xfs_da_args_23709_fields rmtvaluelen xfs_da_args 0 23709 NULL nohasharray
+word_offset_bm_xfer_ctx_23709_fields word_offset bm_xfer_ctx 0 23709 &rmtvaluelen_xfs_da_args_23709_fields
+vgacon_scroll_fndecl_23715_fields vgacon_scroll fndecl 5 23715 NULL
+ath6kl_sdio_bmi_write_fndecl_23717_fields ath6kl_sdio_bmi_write fndecl 3 23717 NULL
+len_cmdbuf_t_23720_fields len cmdbuf_t 0 23720 NULL
+size_rxe_type_info_23724_fields size rxe_type_info 0 23724 NULL
+size_p9_fcall_23725_fields size p9_fcall 0 23725 NULL
+hugetlb_fault_fndecl_23735_fields hugetlb_fault fndecl 3 23735 NULL
+writesize_acm_23756_fields writesize acm 0 23756 NULL
+dccp_manip_pkt_fndecl_23759_fields dccp_manip_pkt fndecl 4 23759 NULL
+fat_ent_bread_fndecl_23760_fields fat_ent_bread fndecl 4 23760 NULL
+fnic_max_trace_entries_vardecl_fnic_trace_c_23762_fields fnic_max_trace_entries vardecl_fnic_trace.c 0 23762 NULL
+i915_gem_create_fndecl_23768_fields i915_gem_create fndecl 3 23768 NULL
+perf_output_begin_backward_fndecl_23772_fields perf_output_begin_backward fndecl 3 23772 NULL
+dev_mem_seek_fndecl_23776_fields dev_mem_seek fndecl 2 23776 NULL nohasharray
+rec_len_ext4_dir_entry_2_23776_fields rec_len ext4_dir_entry_2 0 23776 &dev_mem_seek_fndecl_23776_fields nohasharray
+start_pnfs_block_dev_map_23776_fields start pnfs_block_dev_map 0 23776 &rec_len_ext4_dir_entry_2_23776_fields
+read_vbt_r0_fndecl_23780_fields read_vbt_r0 fndecl 1 23780 NULL
+tail_p9_rdir_23781_fields tail p9_rdir 0 23781 NULL
+count_uvc_debugfs_buffer_23783_fields count uvc_debugfs_buffer 0 23783 NULL
+nr_kvm_irq_routing_23794_fields nr kvm_irq_routing 0 23794 NULL
+ubi_attach_mtd_dev_fndecl_23797_fields ubi_attach_mtd_dev fndecl 3 23797 NULL nohasharray
+parity_devs_raid_type_23797_fields parity_devs raid_type 0 23797 &ubi_attach_mtd_dev_fndecl_23797_fields
+free_tiger_ch_23798_fields free tiger_ch 0 23798 NULL
+ra_offset_xfs_dir2_leaf_map_info_23799_fields ra_offset xfs_dir2_leaf_map_info 0 23799 NULL
+sctp_skb_pull_fndecl_23806_fields sctp_skb_pull fndecl 2-0 23806 NULL
+cdrom_read_cdda_bpc_fndecl_23812_fields cdrom_read_cdda_bpc fndecl 4 23812 NULL
+carl9170_alloc_fndecl_23816_fields carl9170_alloc fndecl 1 23816 NULL
+dma_tx_size_sxgbe_priv_data_23821_fields dma_tx_size sxgbe_priv_data 0 23821 NULL
+ocfs2_get_refcount_tree_fndecl_23824_fields ocfs2_get_refcount_tree fndecl 2 23824 NULL
+intel_fake_agp_alloc_by_type_fndecl_23826_fields intel_fake_agp_alloc_by_type fndecl 1 23826 NULL nohasharray
+nbytes_ahash_request_23826_fields nbytes ahash_request 0 23826 &intel_fake_agp_alloc_by_type_fndecl_23826_fields
+bios_hardcoded_edid_size_radeon_mode_info_23827_fields bios_hardcoded_edid_size radeon_mode_info 0 23827 NULL nohasharray
+__xfs_dir3_free_read_fndecl_23827_fields __xfs_dir3_free_read fndecl 3 23827 &bios_hardcoded_edid_size_radeon_mode_info_23827_fields
+vbi_v_stop_0_saa7134_tvnorm_23830_fields vbi_v_stop_0 saa7134_tvnorm 0 23830 NULL nohasharray
+t4_fl_pkt_align_fndecl_23830_fields t4_fl_pkt_align fndecl 0 23830 &vbi_v_stop_0_saa7134_tvnorm_23830_fields
+buffer_total_count_pvr2_stream_23834_fields buffer_total_count pvr2_stream 0 23834 NULL
+key_dm_region_23838_fields key dm_region 0 23838 NULL
+compressed_bio_alloc_fndecl_23839_fields compressed_bio_alloc fndecl 2 23839 NULL
+rx_buf_size_skge_port_23843_fields rx_buf_size skge_port 0 23843 NULL
+tidcnt_qib_tid_info_23847_fields tidcnt qib_tid_info 0 23847 NULL nohasharray
+osd_request_async_done_fndecl_23847_fields osd_request_async_done fndecl 2 23847 &tidcnt_qib_tid_info_23847_fields
+SpareReplUnitNum_nftl_uci0_23850_fields SpareReplUnitNum nftl_uci0 0 23850 NULL
+am_length_compat_xfs_attr_multiop_23853_fields am_length compat_xfs_attr_multiop 0 23853 NULL
+max_srq_wqes_mlx4_caps_23857_fields max_srq_wqes mlx4_caps 0 23857 NULL
+rtl_tx_agg_stop_fndecl_23865_fields rtl_tx_agg_stop fndecl 4 23865 NULL nohasharray
+clutsize_linux_logo_23865_fields clutsize linux_logo 0 23865 &rtl_tx_agg_stop_fndecl_23865_fields
+vdisplay_drm_display_mode_23870_fields vdisplay drm_display_mode 0 23870 NULL
+c_data_offs_pvr2_ioread_23876_fields c_data_offs pvr2_ioread 0 23876 NULL nohasharray
+ohead_offs_ubifs_info_23876_fields ohead_offs ubifs_info 0 23876 &c_data_offs_pvr2_ioread_23876_fields
+macsec_change_mtu_fndecl_23882_fields macsec_change_mtu fndecl 2 23882 NULL nohasharray
+operand_2_len_ccp_ecc_modular_math_23882_fields operand_2_len ccp_ecc_modular_math 0 23882 &macsec_change_mtu_fndecl_23882_fields
+sb_dirband_size_hpfs_sb_info_23890_fields sb_dirband_size hpfs_sb_info 0 23890 NULL nohasharray
+bytes_snd_dma_buffer_23890_fields bytes snd_dma_buffer 0 23890 &sb_dirband_size_hpfs_sb_info_23890_fields
+in_base_pos_ceph_connection_23892_fields in_base_pos ceph_connection 0 23892 NULL
+__skb_to_sgvec_fndecl_23899_fields __skb_to_sgvec fndecl 0-4-3 23899 NULL
+block_log_squashfs_sb_info_23905_fields block_log squashfs_sb_info 0 23905 NULL
+status_adm8211_desc_23909_fields status adm8211_desc 0 23909 NULL nohasharray
+al_offset_drbd_md_23909_fields al_offset drbd_md 0 23909 &status_adm8211_desc_23909_fields
+num_pages_fuse_req_23911_fields num_pages fuse_req 0 23911 NULL
+avail_pebs_ubi_device_23916_fields avail_pebs ubi_device 0 23916 NULL
+tcp_init_cwnd_fndecl_23919_fields tcp_init_cwnd fndecl 0 23919 NULL nohasharray
+rd_data_gfs2_rgrpd_23919_fields rd_data gfs2_rgrpd 0 23919 &tcp_init_cwnd_fndecl_23919_fields
+nr_items_list_lru_one_23925_fields nr_items list_lru_one 0 23925 NULL
+p9_client_readdir_fndecl_23927_fields p9_client_readdir fndecl 0-3 23927 NULL
+input_buffer_size_vardecl_seq_midi_c_23961_fields input_buffer_size vardecl_seq_midi.c 0 23961 NULL
+mtd_ooblayout_set_eccbytes_fndecl_23964_fields mtd_ooblayout_set_eccbytes fndecl 4 23964 NULL
+rx_ip_align_efx_nic_23965_fields rx_ip_align efx_nic 0 23965 NULL
+fw_status_len_wl1271_23974_fields fw_status_len wl1271 0 23974 NULL nohasharray
+memblock_add_range_fndecl_23974_fields memblock_add_range fndecl 2-3 23974 &fw_status_len_wl1271_23974_fields
+li_channels__DIVA_CAPI_ADAPTER_23977_fields li_channels _DIVA_CAPI_ADAPTER 0 23977 NULL
+vsync_len_fb_var_screeninfo_23987_fields vsync_len fb_var_screeninfo 0 23987 NULL
+length_acpi_object_string_23992_fields length acpi_object_string 0 23992 NULL
+EventDataLength__MPI2_EVENT_NOTIFICATION_REPLY_23993_fields EventDataLength _MPI2_EVENT_NOTIFICATION_REPLY 0 23993 NULL
+usb_stream_next_packet_size_fndecl_23994_fields usb_stream_next_packet_size fndecl 0 23994 NULL
+anchor_udf_options_24004_fields anchor udf_options 0 24004 NULL
+dir_band_start_hpfs_super_block_24005_fields dir_band_start hpfs_super_block 0 24005 NULL
+truncate_setsize_fndecl_24013_fields truncate_setsize fndecl 2 24013 NULL
+ath6kl_wmi_bssfilter_cmd_fndecl_24014_fields ath6kl_wmi_bssfilter_cmd fndecl 2 24014 NULL
+vlan_id_bond_vlan_tag_24019_fields vlan_id bond_vlan_tag 0 24019 NULL nohasharray
+xfs_bmap_btalloc_fndecl_24019_fields xfs_bmap_btalloc fndecl 0 24019 &vlan_id_bond_vlan_tag_24019_fields
+minimum_pcc_memory_resource_24022_fields minimum pcc_memory_resource 0 24022 NULL
+iscsi_session_setup_fndecl_24023_fields iscsi_session_setup fndecl 4 24023 NULL
+btt_map_write_fndecl_24029_fields btt_map_write fndecl 0 24029 NULL nohasharray
+fill_user_desc_fndecl_24029_fields fill_user_desc fndecl 2 24029 &btt_map_write_fndecl_24029_fields
+bpp__sisbios_mode_24033_fields bpp _sisbios_mode 0 24033 NULL
+mbo_offs_aim_channel_24035_fields mbo_offs aim_channel 0 24035 NULL
+namelen_cramfs_inode_24036_fields namelen cramfs_inode 0 24036 NULL nohasharray
+__radix_tree_preload_fndecl_24036_fields __radix_tree_preload fndecl 0 24036 &namelen_cramfs_inode_24036_fields
+obj_size_request_sock_ops_24037_fields obj_size request_sock_ops 0 24037 NULL
+chunk_mask_geom_24040_fields chunk_mask geom 0 24040 NULL
+start_switch_path_24046_fields start switch_path 0 24046 NULL
+log_start_r5l_io_unit_24048_fields log_start r5l_io_unit 0 24048 NULL nohasharray
+hfi1_max_srq_wrs_vardecl_24048_fields hfi1_max_srq_wrs vardecl 0 24048 &log_start_r5l_io_unit_24048_fields
+size_pernet_operations_24051_fields size pernet_operations 0 24051 NULL nohasharray
+erase_shift_mmc_card_24051_fields erase_shift mmc_card 0 24051 &size_pernet_operations_24051_fields
+osst_int_ioctl_fndecl_24052_fields osst_int_ioctl fndecl 4 24052 NULL
+jbd2_journal_dirty_metadata_fndecl_24067_fields jbd2_journal_dirty_metadata fndecl 0 24067 NULL
+fnic_get_stats_data_fndecl_24075_fields fnic_get_stats_data fndecl 0 24075 NULL
+h_sync_strt_wid_aty128_crtc_24079_fields h_sync_strt_wid aty128_crtc 0 24079 NULL
+tun_hlen_ip6_tnl_24081_fields tun_hlen ip6_tnl 0 24081 NULL
+cylinders_ssfdcr_record_24084_fields cylinders ssfdcr_record 0 24084 NULL
+gfs2_meta_new_fndecl_24087_fields gfs2_meta_new fndecl 2 24087 NULL
+pat_pagerange_is_ram_fndecl_24089_fields pat_pagerange_is_ram fndecl 1-2 24089 NULL
+mw_count_ntb_transport_ctx_24094_fields mw_count ntb_transport_ctx 0 24094 NULL
+irq_base_pm860x_chip_24096_fields irq_base pm860x_chip 0 24096 NULL
+sectors_md_rdev_24098_fields sectors md_rdev 0 24098 NULL
+capture_bufsize_vardecl_nm256_c_24100_fields capture_bufsize vardecl_nm256.c 0 24100 NULL
+dcbp_set_pad_bits_fndecl_24101_fields dcbp_set_pad_bits fndecl 2 24101 NULL
+bus_mtu_brcmf_usbdev_24102_fields bus_mtu brcmf_usbdev 0 24102 NULL
+max_ib_mtu_ipoib_dev_priv_24105_fields max_ib_mtu ipoib_dev_priv 0 24105 NULL nohasharray
+read_fifo_fndecl_24105_fields read_fifo fndecl 3 24105 &max_ib_mtu_ipoib_dev_priv_24105_fields
+get_rx_frame_len_stmmac_desc_ops_24113_fields get_rx_frame_len stmmac_desc_ops 0 24113 NULL nohasharray
+add_td_to_list_fndecl_24113_fields add_td_to_list fndecl 3 24113 &get_rx_frame_len_stmmac_desc_ops_24113_fields
+packet_multiplier_em28xx_24119_fields packet_multiplier em28xx 0 24119 NULL nohasharray
+rax_vmcb_save_area_24119_fields rax vmcb_save_area 0 24119 &packet_multiplier_em28xx_24119_fields
+ext2_xattr_user_set_fndecl_24123_fields ext2_xattr_user_set fndecl 6 24123 NULL
+srpt_build_cmd_rsp_fndecl_24126_fields srpt_build_cmd_rsp fndecl 0 24126 NULL
+um_idi_read_fndecl_24129_fields um_idi_read fndecl 3 24129 NULL
+ieee80211_assoc_success_fndecl_24131_fields ieee80211_assoc_success fndecl 4 24131 NULL
+radix_tree_locate_item_fndecl_24133_fields radix_tree_locate_item fndecl 0 24133 NULL
+num_snaps_ceph_snap_context_24136_fields num_snaps ceph_snap_context 0 24136 NULL nohasharray
+error_state_read_fndecl_24136_fields error_state_read fndecl 6-5 24136 &num_snaps_ceph_snap_context_24136_fields
+transp_elsa_hw_24137_fields transp elsa_hw 0 24137 NULL
+key_update_fndecl_24140_fields key_update fndecl 3 24140 NULL
+elem_size_v4l2_ctrl_config_24141_fields elem_size v4l2_ctrl_config 0 24141 NULL nohasharray
+segs_wa_xfer_24141_fields segs wa_xfer 0 24141 &elem_size_v4l2_ctrl_config_24141_fields nohasharray
+sdram_size_solo_dev_24141_fields sdram_size solo_dev 0 24141 &segs_wa_xfer_24141_fields
+t_task_nolb_se_cmd_24142_fields t_task_nolb se_cmd 0 24142 NULL
+fat_fat_length_fat_bios_param_block_24145_fields fat_fat_length fat_bios_param_block 0 24145 NULL
+initial_tsn_sctp_inithdr_host_24149_fields initial_tsn sctp_inithdr_host 0 24149 NULL
+lro_add_page_fndecl_24166_fields lro_add_page fndecl 4 24166 NULL
+__alloc_extent_buffer_fndecl_24167_fields __alloc_extent_buffer fndecl 2-3 24167 NULL nohasharray
+ppp_sync_input_fndecl_24167_fields ppp_sync_input fndecl 4 24167 &__alloc_extent_buffer_fndecl_24167_fields
+vram_start_radeon_mc_24170_fields vram_start radeon_mc 0 24170 NULL
+bpp_drm_mode_create_dumb_24171_fields bpp drm_mode_create_dumb 0 24171 NULL
+ttymajor_vardecl_synclink_c_24173_fields ttymajor vardecl_synclink.c 0 24173 NULL nohasharray
+drop_count_codel_stats_24173_fields drop_count codel_stats 0 24173 &ttymajor_vardecl_synclink_c_24173_fields
+top_v4l2_rect_24176_fields top v4l2_rect 0 24176 NULL
+ext4_split_extent_fndecl_24180_fields ext4_split_extent fndecl 0 24180 NULL
+st21nfca_hci_dm_get_data_fndecl_24183_fields st21nfca_hci_dm_get_data fndecl 3 24183 NULL
+iv_size_crypt_config_24199_fields iv_size crypt_config 0 24199 NULL
+kernel_sendpage_fndecl_24200_fields kernel_sendpage fndecl 0-4 24200 NULL nohasharray
+n_multicast_vfpf_set_q_filters_tlv_24200_fields n_multicast vfpf_set_q_filters_tlv 0 24200 &kernel_sendpage_fndecl_24200_fields
+caps_sdhci_host_24205_fields caps sdhci_host 0 24205 NULL
+f2fs_update_extent_tree_range_fndecl_24206_fields f2fs_update_extent_tree_range fndecl 4-2-3 24206 NULL
+yenta_search_res_fndecl_24211_fields yenta_search_res fndecl 3 24211 NULL
+erase_size_falcon_spi_device_24212_fields erase_size falcon_spi_device 0 24212 NULL
+amdgpu_benchmark_move_fndecl_24214_fields amdgpu_benchmark_move fndecl 2 24214 NULL
+size_drm_gem_object_24219_fields size drm_gem_object 0 24219 NULL
+nid_free_nid_24229_fields nid free_nid 0 24229 NULL
+get_ramdisk_size_fndecl_24233_fields get_ramdisk_size fndecl 0 24233 NULL
+udf_process_sequence_fndecl_24235_fields udf_process_sequence fndecl 2 24235 NULL
+sys_msgrcv_fndecl_24236_fields sys_msgrcv fndecl 3 24236 NULL
+common_qdepth_blogic_adapter_24241_fields common_qdepth blogic_adapter 0 24241 NULL
+pcicfg_base_sst_pdata_24243_fields pcicfg_base sst_pdata 0 24243 NULL
+vlan_qos_vlan_ioctl_args_24244_fields vlan_qos vlan_ioctl_args 0 24244 NULL nohasharray
+qi_dqchunklen_xfs_quotainfo_24244_fields qi_dqchunklen xfs_quotainfo 0 24244 &vlan_qos_vlan_ioctl_args_24244_fields
+vmbus_sendpacket_mpb_desc_fndecl_24250_fields vmbus_sendpacket_mpb_desc fndecl 3-5 24250 NULL
+inode_ext2_dir_entry_2_24254_fields inode ext2_dir_entry_2 0 24254 NULL
+ali1535_offset_vardecl_i2c_ali1535_c_24257_fields ali1535_offset vardecl_i2c-ali1535.c 0 24257 NULL
+crtc_hblank_end_drm_display_mode_24268_fields crtc_hblank_end drm_display_mode 0 24268 NULL
+totalsize_microcode_header_intel_24274_fields totalsize microcode_header_intel 0 24274 NULL
+vb2_vmalloc_get_userptr_fndecl_24276_fields vb2_vmalloc_get_userptr fndecl 2-3 24276 NULL
+ccp_reverse_set_dm_area_fndecl_24279_fields ccp_reverse_set_dm_area fndecl 4-3 24279 NULL
+blockshift_alauda_card_info_24288_fields blockshift alauda_card_info 0 24288 NULL
+_do_truncate_fndecl_24296_fields _do_truncate fndecl 2 24296 NULL
+sg_copy_buffer_fndecl_24297_fields sg_copy_buffer fndecl 0-5-4 24297 NULL
+rf_our_slot_rcom_config_24309_fields rf_our_slot rcom_config 0 24309 NULL
+hdlcdev_rx_fndecl_24310_fields hdlcdev_rx fndecl 3 24310 NULL
+io_apic_get_redir_entries_fndecl_24313_fields io_apic_get_redir_entries fndecl 0 24313 NULL nohasharray
+udc_get_ppbdu_rxbytes_fndecl_24313_fields udc_get_ppbdu_rxbytes fndecl 0 24313 &io_apic_get_redir_entries_fndecl_24313_fields nohasharray
+dm_accept_partial_bio_fndecl_24313_fields dm_accept_partial_bio fndecl 2 24313 &udc_get_ppbdu_rxbytes_fndecl_24313_fields
+pstore_file_llseek_fndecl_24314_fields pstore_file_llseek fndecl 2 24314 NULL nohasharray
+pch_udc_create_dma_chain_fndecl_24314_fields pch_udc_create_dma_chain fndecl 3 24314 &pstore_file_llseek_fndecl_24314_fields
+byte_per_page_nand_jedec_params_24315_fields byte_per_page nand_jedec_params 0 24315 NULL
+remove_monitor_info_fndecl_24319_fields remove_monitor_info fndecl 3 24319 NULL
+zlib_deflate_workspacesize_fndecl_24330_fields zlib_deflate_workspacesize fndecl 2-1 24330 NULL
+num_rports_bfa_iocfc_fwcfg_s_24334_fields num_rports bfa_iocfc_fwcfg_s 0 24334 NULL
+next_offset_ceph_file_info_24335_fields next_offset ceph_file_info 0 24335 NULL
+in_iso_pipe_usbtest_dev_24336_fields in_iso_pipe usbtest_dev 0 24336 NULL
+word2_lpfc_rcqe_24338_fields word2 lpfc_rcqe 0 24338 NULL
+smp_send_cmd_fndecl_24339_fields smp_send_cmd fndecl 3 24339 NULL
+stolen_size_intel_early_ops_24340_fields stolen_size intel_early_ops 0 24340 NULL nohasharray
+flags_rtl8187_rx_hdr_24340_fields flags rtl8187_rx_hdr 0 24340 &stolen_size_intel_early_ops_24340_fields
+airo_change_mtu_fndecl_24345_fields airo_change_mtu fndecl 2 24345 NULL
+stride_simplefb_params_24347_fields stride simplefb_params 0 24347 NULL
+ceph_make_fpos_fndecl_24352_fields ceph_make_fpos fndecl 0-2-1 24352 NULL
+sd_inptrs_gfs2_sbd_24356_fields sd_inptrs gfs2_sbd 0 24356 NULL
+start_isoc_chain_fndecl_24358_fields start_isoc_chain fndecl 4-2 24358 NULL
+ieee_il3945_rate_info_24363_fields ieee il3945_rate_info 0 24363 NULL
+dst_h_yuv_frame_info_24364_fields dst_h yuv_frame_info 0 24364 NULL
+len_ath6kl_mgmt_buff_24368_fields len ath6kl_mgmt_buff 0 24368 NULL
+atr_len_cm4000_dev_24376_fields atr_len cm4000_dev 0 24376 NULL nohasharray
+igb_add_rx_frag_fndecl_24376_fields igb_add_rx_frag fndecl 3 24376 &atr_len_cm4000_dev_24376_fields
+virt_begin_dm_thin_new_mapping_24377_fields virt_begin dm_thin_new_mapping 0 24377 NULL
+wqe_shift_mthca_srq_24381_fields wqe_shift mthca_srq 0 24381 NULL
+read_reg_c_can_priv_24389_fields read_reg c_can_priv 0 24389 NULL
+demote_then_promote_fndecl_24392_fields demote_then_promote fndecl 5-3-4 24392 NULL
+tail_sk_buff_24399_fields tail sk_buff 0 24399 NULL
+compat_sys_preadv_fndecl_24404_fields compat_sys_preadv fndecl 3 24404 NULL
+max_frame_size_slgt_info_24405_fields max_frame_size slgt_info 0 24405 NULL
+hfs_ext_find_block_fndecl_24406_fields hfs_ext_find_block fndecl 0-2 24406 NULL
+max_scbs_hw_profile_24409_fields max_scbs hw_profile 0 24409 NULL
+helene_read_regs_fndecl_24410_fields helene_read_regs fndecl 4 24410 NULL
+start_soundfont_sample_info_24413_fields start soundfont_sample_info 0 24413 NULL
+mtu_ArcProto_24415_fields mtu ArcProto 0 24415 NULL nohasharray
+trailer_size_orangefs_downcall_s_24415_fields trailer_size orangefs_downcall_s 0 24415 &mtu_ArcProto_24415_fields
+__percpu_ida_init_fndecl_24416_fields __percpu_ida_init fndecl 3 24416 NULL
+srq_entry_sz_mthca_dev_lim_24422_fields srq_entry_sz mthca_dev_lim 0 24422 NULL
+init_cdrom_command_fndecl_24438_fields init_cdrom_command fndecl 3 24438 NULL
+usHBlanking_Time__ATOM_DTD_FORMAT_24440_fields usHBlanking_Time _ATOM_DTD_FORMAT 0 24440 NULL
+dwTransferLength_wa_xfer_result_24445_fields dwTransferLength wa_xfer_result 0 24445 NULL
+s_last_pseg_nilfs_super_block_24457_fields s_last_pseg nilfs_super_block 0 24457 NULL
+drbd_bm_find_next_fndecl_24464_fields drbd_bm_find_next fndecl 0-2 24464 NULL
+remap_to_cache_fndecl_24467_fields remap_to_cache fndecl 3 24467 NULL
+unlink_queued_fndecl_24470_fields unlink_queued fndecl 4-2 24470 NULL
+rq_db_page_mthca_create_qp_24471_fields rq_db_page mthca_create_qp 0 24471 NULL
+get_filter_fndecl_24472_fields get_filter fndecl 0 24472 NULL
+qset_remove_urb_fndecl_24474_fields qset_remove_urb fndecl 4 24474 NULL
+elog_base_vardecl_acpi_extlog_c_24485_fields elog_base vardecl_acpi_extlog.c 0 24485 NULL
+WriteBlock_fndecl_24489_fields WriteBlock fndecl 3 24489 NULL nohasharray
+shim_phy_add_intel_sst_drv_24489_fields shim_phy_add intel_sst_drv 0 24489 &WriteBlock_fndecl_24489_fields
+sensor_yres_em28xx_v4l2_24490_fields sensor_yres em28xx_v4l2 0 24490 NULL
+max_wr_rxe_sq_24496_fields max_wr rxe_sq 0 24496 NULL nohasharray
+len_ceph_crypto_key_24496_fields len ceph_crypto_key 0 24496 &max_wr_rxe_sq_24496_fields nohasharray
+drv_block_st_partstat_24496_fields drv_block st_partstat 0 24496 &len_ceph_crypto_key_24496_fields
+buf_sz_rx_info_24497_fields buf_sz rx_info 0 24497 NULL
+virtio_gpu_get_vbuf_fndecl_24501_fields virtio_gpu_get_vbuf fndecl 2-3 24501 NULL
+sys_sendfile64_fndecl_24508_fields sys_sendfile64 fndecl 4 24508 NULL
+mask_len_ccp_passthru_nomap_engine_24509_fields mask_len ccp_passthru_nomap_engine 0 24509 NULL nohasharray
+octeon_allocate_device_fndecl_24509_fields octeon_allocate_device fndecl 2 24509 &mask_len_ccp_passthru_nomap_engine_24509_fields
+max_size_usb_fifo_24517_fields max_size usb_fifo 0 24517 NULL
+vc_y_vc_data_24521_fields vc_y vc_data 0 24521 NULL
+size_firmware_24525_fields size firmware 0 24525 NULL
+rtl8169_try_rx_copy_fndecl_24530_fields rtl8169_try_rx_copy fndecl 3 24530 NULL nohasharray
+max_length__diva_um_idi_data_queue_24530_fields max_length _diva_um_idi_data_queue 0 24530 &rtl8169_try_rx_copy_fndecl_24530_fields
+max_sgl_entries_vardecl_mpt3sas_base_c_24531_fields max_sgl_entries vardecl_mpt3sas_base.c 0 24531 NULL
+st_nci_hci_dm_put_data_fndecl_24538_fields st_nci_hci_dm_put_data fndecl 3 24538 NULL
+width_pcm_format_data_24546_fields width pcm_format_data 0 24546 NULL
+btrfs_issue_discard_fndecl_24553_fields btrfs_issue_discard fndecl 2-3 24553 NULL
+size_memblock_region_24555_fields size memblock_region 0 24555 NULL
+boot_size_il4965_firmware_pieces_24557_fields boot_size il4965_firmware_pieces 0 24557 NULL
+ocfs2_test_inode_bit_fndecl_24558_fields ocfs2_test_inode_bit fndecl 2 24558 NULL
+residual_count_se_cmd_24562_fields residual_count se_cmd 0 24562 NULL
+blksize_nbd_device_24565_fields blksize nbd_device 0 24565 NULL
+len_mlxsw_reg_info_24575_fields len mlxsw_reg_info 0 24575 NULL
+blk_extent_info_24576_fields blk extent_info 0 24576 NULL
+pkt_size_gspca_dev_24583_fields pkt_size gspca_dev 0 24583 NULL
+joydev_handle_JSIOCSBTNMAP_fndecl_24584_fields joydev_handle_JSIOCSBTNMAP fndecl 3 24584 NULL
+chunk_shift_geom_24589_fields chunk_shift geom 0 24589 NULL
+st_int_write_fndecl_24593_fields st_int_write fndecl 0 24593 NULL
+img_width_zoran_jpg_settings_24594_fields img_width zoran_jpg_settings 0 24594 NULL
+head_TxFifo_24599_fields head TxFifo 0 24599 NULL nohasharray
+ea_size_l_fnode_24599_fields ea_size_l fnode 0 24599 &head_TxFifo_24599_fields
+dsp_cmx_send_member_fndecl_24602_fields dsp_cmx_send_member fndecl 2 24602 NULL
+ubifs_add_bud_to_log_fndecl_24607_fields ubifs_add_bud_to_log fndecl 4 24607 NULL
+raid_disks_mddev_24609_fields raid_disks mddev 0 24609 NULL
+datalen_ip_tunnel_prl_24610_fields datalen ip_tunnel_prl 0 24610 NULL nohasharray
+bts_buffer_base_debug_store_24610_fields bts_buffer_base debug_store 0 24610 &datalen_ip_tunnel_prl_24610_fields
+irda_connect_indication_fndecl_24616_fields irda_connect_indication fndecl 4-5 24616 NULL
+dm_read_fndecl_24617_fields dm_read fndecl 3 24617 NULL
+ntfs_new_extent_inode_fndecl_24624_fields ntfs_new_extent_inode fndecl 2 24624 NULL
+qlcnic_process_rcv_diag_fndecl_24628_fields qlcnic_process_rcv_diag fndecl 3 24628 NULL
+elan_i2c_read_block_fndecl_24636_fields elan_i2c_read_block fndecl 4 24636 NULL
+desc_count_orangefs_bufmap_24642_fields desc_count orangefs_bufmap 0 24642 NULL nohasharray
+len_n_flags_il_rx_pkt_24642_fields len_n_flags il_rx_pkt 0 24642 &desc_count_orangefs_bufmap_24642_fields
+data_mcp_cmd_response_24644_fields data mcp_cmd_response 0 24644 NULL
+num_reg_defaults_regmap_config_24645_fields num_reg_defaults regmap_config 0 24645 NULL
+array_len_xdr_array2_desc_24652_fields array_len xdr_array2_desc 0 24652 NULL
+cur_sg_ore_per_dev_state_24654_fields cur_sg ore_per_dev_state 0 24654 NULL
+crypto_init_drbg_state_ops_24657_fields crypto_init drbg_state_ops 0 24657 NULL
+offset_musb_qh_24658_fields offset musb_qh 0 24658 NULL
+lcd_hsync_dly_atyfb_par_24660_fields lcd_hsync_dly atyfb_par 0 24660 NULL
+out_iso_pipe_usbtest_dev_24664_fields out_iso_pipe usbtest_dev 0 24664 NULL
+spidev_read_fndecl_24668_fields spidev_read fndecl 3 24668 NULL nohasharray
+rds_ib_sysctl_max_recv_wr_vardecl_24668_fields rds_ib_sysctl_max_recv_wr vardecl 0 24668 &spidev_read_fndecl_24668_fields
+rx_pipe_brcmf_usbdev_info_24671_fields rx_pipe brcmf_usbdev_info 0 24671 NULL
+id_platform_device_info_24673_fields id platform_device_info 0 24673 NULL nohasharray
+pinctrl_utils_reserve_map_fndecl_24673_fields pinctrl_utils_reserve_map fndecl 5 24673 &id_platform_device_info_24673_fields
+uhci_fixup_short_transfer_fndecl_24676_fields uhci_fixup_short_transfer fndecl 0 24676 NULL
+src_width_tpg_data_24681_fields src_width tpg_data 0 24681 NULL
+st95hf_spi_send_fndecl_24687_fields st95hf_spi_send fndecl 3 24687 NULL
+nbits_nvmem_cell_24691_fields nbits nvmem_cell 0 24691 NULL
+ocfs2_split_tree_fndecl_24695_fields ocfs2_split_tree fndecl 5 24695 NULL
+iwl_mvm_pass_packet_to_mac80211_fndecl_24696_fields iwl_mvm_pass_packet_to_mac80211 fndecl 7-6 24696 NULL
+align_tun_struct_24697_fields align tun_struct 0 24697 NULL
+rio_request_inb_dbell_fndecl_24701_fields rio_request_inb_dbell fndecl 4-3 24701 NULL
+size_aper_size_info_16_24703_fields size aper_size_info_16 0 24703 NULL
+block_ack_param_set_host_cmd_ds_11n_addba_rsp_24704_fields block_ack_param_set host_cmd_ds_11n_addba_rsp 0 24704 NULL
+start_qla_flt_region_24707_fields start qla_flt_region 0 24707 NULL
+_mv88e6xxx_reg_read_fndecl_24718_fields _mv88e6xxx_reg_read fndecl 0 24718 NULL
+nfp_net_change_mtu_fndecl_24719_fields nfp_net_change_mtu fndecl 2 24719 NULL
+qxl_ttm_tt_create_fndecl_24720_fields qxl_ttm_tt_create fndecl 2 24720 NULL
+drm_gem_cma_create_with_handle_fndecl_24721_fields drm_gem_cma_create_with_handle fndecl 3 24721 NULL
+bfs_get_block_fndecl_24726_fields bfs_get_block fndecl 2 24726 NULL
+outlen_ib_udata_24729_fields outlen ib_udata 0 24729 NULL
+pkts_acked_htcp_24730_fields pkts_acked htcp 0 24730 NULL
+VBP_kyrofb_info_24731_fields VBP kyrofb_info 0 24731 NULL
+shmem_undo_range_fndecl_24742_fields shmem_undo_range fndecl 2-3 24742 NULL
+set_ltab_fndecl_24745_fields set_ltab fndecl 3 24745 NULL
+ud_putcs_fndecl_24751_fields ud_putcs fndecl 4-6-5 24751 NULL
+data_dotdot_offset_xfs_dir_ops_24758_fields data_dotdot_offset xfs_dir_ops 0 24758 NULL
+scif_create_pinned_pages_fndecl_24761_fields scif_create_pinned_pages fndecl 1 24761 NULL nohasharray
+inftl_read_oob_fndecl_24761_fields inftl_read_oob fndecl 2-3 24761 &scif_create_pinned_pages_fndecl_24761_fields
+xlog_state_switch_iclogs_fndecl_24782_fields xlog_state_switch_iclogs fndecl 3 24782 NULL
+afs_proc_rootcell_write_fndecl_24797_fields afs_proc_rootcell_write fndecl 3 24797 NULL
+usHSyncWidth__ATOM_DTD_FORMAT_24801_fields usHSyncWidth _ATOM_DTD_FORMAT 0 24801 NULL nohasharray
+vhost_vsock_alloc_pkt_fndecl_24801_fields vhost_vsock_alloc_pkt fndecl 2 24801 &usHSyncWidth__ATOM_DTD_FORMAT_24801_fields nohasharray
+index_vardecl_atiixp_c_24801_fields index vardecl_atiixp.c 0 24801 &vhost_vsock_alloc_pkt_fndecl_24801_fields
+mprotect_fixup_fndecl_24803_fields mprotect_fixup fndecl 4-3 24803 NULL
+__read_extent_tree_block_fndecl_24804_fields __read_extent_tree_block fndecl 4 24804 NULL
+copy_to_urb_quirk_fndecl_24807_fields copy_to_urb_quirk fndecl 0-4 24807 NULL
+ceph_auth_build_hello_fndecl_24808_fields ceph_auth_build_hello fndecl 0 24808 NULL
+analog_ep_isoc_em28xx_24810_fields analog_ep_isoc em28xx 0 24810 NULL
+ubi_io_write_fndecl_24813_fields ubi_io_write fndecl 5-4 24813 NULL
+cdc_ncm_eth_hlen_fndecl_24814_fields cdc_ncm_eth_hlen fndecl 0 24814 NULL
+RxLastCount_via_ircc_cb_24815_fields RxLastCount via_ircc_cb 0 24815 NULL nohasharray
+array_resync_offset_dm_raid_superblock_24815_fields array_resync_offset dm_raid_superblock 0 24815 &RxLastCount_via_ircc_cb_24815_fields
+HBP_kyrofb_info_24818_fields HBP kyrofb_info 0 24818 NULL
+insert_state_fndecl_24820_fields insert_state fndecl 0-4-3 24820 NULL
+readahead_cached_dev_24826_fields readahead cached_dev 0 24826 NULL
+param_size_preview_update_24836_fields param_size preview_update 0 24836 NULL
+alloc_fddidev_fndecl_24837_fields alloc_fddidev fndecl 1 24837 NULL
+ceph_osdc_notify_ack_fndecl_24848_fields ceph_osdc_notify_ack fndecl 7 24848 NULL
+wLength_usbdevfs_ctrltransfer_24851_fields wLength usbdevfs_ctrltransfer 0 24851 NULL nohasharray
+cx88_alsa_dma_init_fndecl_24851_fields cx88_alsa_dma_init fndecl 2 24851 &wLength_usbdevfs_ctrltransfer_24851_fields
+pa_len_ext4_prealloc_space_24852_fields pa_len ext4_prealloc_space 0 24852 NULL
+body_len_vardecl_initramfs_c_24853_fields body_len vardecl_initramfs.c 0 24853 NULL
+bgpio_init_fndecl_24861_fields bgpio_init fndecl 3 24861 NULL
+__videobuf_copy_to_user_fndecl_24876_fields __videobuf_copy_to_user fndecl 0 24876 NULL
+x86_cache_alignment_cpuinfo_x86_24878_fields x86_cache_alignment cpuinfo_x86 0 24878 NULL
+rx_buf_per_pkt_vmxnet3_adapter_24879_fields rx_buf_per_pkt vmxnet3_adapter 0 24879 NULL
+zone_count_sm_ftl_24881_fields zone_count sm_ftl 0 24881 NULL
+nvme_cmb_qdepth_fndecl_24896_fields nvme_cmb_qdepth fndecl 0 24896 NULL
+i_truncate_size_ceph_inode_info_24902_fields i_truncate_size ceph_inode_info 0 24902 NULL
+blkif_setup_rw_req_grant_fndecl_24903_fields blkif_setup_rw_req_grant fndecl 2-3 24903 NULL
+io_limit_vardecl_at24_c_24907_fields io_limit vardecl_at24.c 0 24907 NULL
+iscsi_sw_tcp_send_linear_data_prep_fndecl_24908_fields iscsi_sw_tcp_send_linear_data_prep fndecl 3 24908 NULL
+ceph_tcp_recvpage_fndecl_24910_fields ceph_tcp_recvpage fndecl 0-4 24910 NULL nohasharray
+buffer_len_stats_debug_info_24910_fields buffer_len stats_debug_info 0 24910 &ceph_tcp_recvpage_fndecl_24910_fields
+len_fb_cmap_24911_fields len fb_cmap 0 24911 NULL
+num_tx_queues_igb_adapter_24917_fields num_tx_queues igb_adapter 0 24917 NULL
+__mic_ioremap_fndecl_24922_fields __mic_ioremap fndecl 3-2 24922 NULL nohasharray
+data_len_ib_ucm_info_24922_fields data_len ib_ucm_info 0 24922 &__mic_ioremap_fndecl_24922_fields
+scif_rb_init_fndecl_24923_fields scif_rb_init fndecl 5 24923 NULL
+tcp_mtu_to_mss_fndecl_24925_fields tcp_mtu_to_mss fndecl 0-2 24925 NULL
+__mutex_lock_killable_slowpath_fndecl_24931_fields __mutex_lock_killable_slowpath fndecl 0 24931 NULL nohasharray
+current_area_pstore_24931_fields current_area pstore 0 24931 &__mutex_lock_killable_slowpath_fndecl_24931_fields
+max_sectors_per_io_vardecl_megaraid_c_24934_fields max_sectors_per_io vardecl_megaraid.c 0 24934 NULL
+rtl_download_firmware_fndecl_24937_fields rtl_download_firmware fndecl 3 24937 NULL
+key_len_cfg80211_connect_params_24952_fields key_len cfg80211_connect_params 0 24952 NULL
+size_video_still_picture_24955_fields size video_still_picture 0 24955 NULL
+pkts_acked_ack_sample_24969_fields pkts_acked ack_sample 0 24969 NULL
+pppol2tp_sendmsg_fndecl_24975_fields pppol2tp_sendmsg fndecl 3 24975 NULL nohasharray
+system_dir_blkno_ocfs2_super_24975_fields system_dir_blkno ocfs2_super 0 24975 &pppol2tp_sendmsg_fndecl_24975_fields nohasharray
+max_dma_count_asc_dvc_var_24975_fields max_dma_count asc_dvc_var 0 24975 &system_dir_blkno_ocfs2_super_24975_fields
+i_rbytes_ceph_inode_info_24976_fields i_rbytes ceph_inode_info 0 24976 NULL
+vringh_iov_pull_user_fndecl_24984_fields vringh_iov_pull_user fndecl 3 24984 NULL
+dr_suballoc_bit_ocfs2_dx_root_block_24992_fields dr_suballoc_bit ocfs2_dx_root_block 0 24992 NULL
+ql_process_mac_rx_page_fndecl_24996_fields ql_process_mac_rx_page fndecl 4-5 24996 NULL
+__rh_find_fndecl_24997_fields __rh_find fndecl 2 24997 NULL
+jfs_extendfs_fndecl_25001_fields jfs_extendfs fndecl 2-3 25001 NULL
+xfrm_state_mtu_fndecl_25007_fields xfrm_state_mtu fndecl 0-2 25007 NULL nohasharray
+sdp0length__SpiCfgData_25007_fields sdp0length _SpiCfgData 0 25007 &xfrm_state_mtu_fndecl_25007_fields
+memory_map_top_down_fndecl_25011_fields memory_map_top_down fndecl 1-2 25011 NULL
+ifx_spi_write_fndecl_25016_fields ifx_spi_write fndecl 3 25016 NULL nohasharray
+_c4iw_write_mem_dma_fndecl_25016_fields _c4iw_write_mem_dma fndecl 3 25016 &ifx_spi_write_fndecl_25016_fields
+rx_jumbo_pending_ethtool_ringparam_25018_fields rx_jumbo_pending ethtool_ringparam 0 25018 NULL
+rx_agg_ring_size_bnxt_25021_fields rx_agg_ring_size bnxt 0 25021 NULL
+num_bd_ethoc_25022_fields num_bd ethoc 0 25022 NULL
+_rtl_usb_tx_urb_setup_fndecl_25024_fields _rtl_usb_tx_urb_setup fndecl 3 25024 NULL
+height_fb_fillrect_25027_fields height fb_fillrect 0 25027 NULL nohasharray
+iwl_nvm_read_section_fndecl_25027_fields iwl_nvm_read_section fndecl 0 25027 &height_fb_fillrect_25027_fields nohasharray
+hint_count_acpi_nfit_flush_address_25027_fields hint_count acpi_nfit_flush_address 0 25027 &iwl_nvm_read_section_fndecl_25027_fields
+vlan_cq_enet_rq_desc_25028_fields vlan cq_enet_rq_desc 0 25028 NULL nohasharray
+error_nfs_direct_req_25028_fields error nfs_direct_req 0 25028 &vlan_cq_enet_rq_desc_25028_fields
+crc_size_cas_25030_fields crc_size cas 0 25030 NULL nohasharray
+size_sym_tblmove_25030_fields size sym_tblmove 0 25030 &crc_size_cas_25030_fields
+pagesize_nand_flash_dev_25033_fields pagesize nand_flash_dev 0 25033 NULL
+dma_size_netup_unidvb_dev_25039_fields dma_size netup_unidvb_dev 0 25039 NULL
+db_free_next_ocfs2_dir_block_trailer_25041_fields db_free_next ocfs2_dir_block_trailer 0 25041 NULL
+stv0299_readregs_fndecl_25043_fields stv0299_readregs fndecl 4 25043 NULL
+ieee80211_amsdu_to_8023s_fndecl_25050_fields ieee80211_amsdu_to_8023s fndecl 5 25050 NULL
+aio_private_file_fndecl_25052_fields aio_private_file fndecl 2 25052 NULL
+hci_logging_frame_fndecl_25057_fields hci_logging_frame fndecl 3 25057 NULL
+size_object_info_25058_fields size object_info 0 25058 NULL
+in_max_chans_snd_card_asihpi_25063_fields in_max_chans snd_card_asihpi 0 25063 NULL
+cuse_file_compat_ioctl_fndecl_25067_fields cuse_file_compat_ioctl fndecl 2 25067 NULL
+ovl_alloc_entry_fndecl_25069_fields ovl_alloc_entry fndecl 1 25069 NULL
+ocfs2_truncate_rec_fndecl_25080_fields ocfs2_truncate_rec fndecl 7 25080 NULL
+length_bus_request_25082_fields length bus_request 0 25082 NULL
+k_offset_offset_v1_25084_fields k_offset offset_v1 0 25084 NULL nohasharray
+id_count_ocfs2_inline_data_25084_fields id_count ocfs2_inline_data 0 25084 &k_offset_offset_v1_25084_fields nohasharray
+len_ocrdma_sge_25084_fields len ocrdma_sge 0 25084 &id_count_ocfs2_inline_data_25084_fields
+dwc3_prepare_one_trb_fndecl_25092_fields dwc3_prepare_one_trb fndecl 4 25092 NULL nohasharray
+duty_ec_response_pwm_get_duty_25092_fields duty ec_response_pwm_get_duty 0 25092 &dwc3_prepare_one_trb_fndecl_25092_fields
+hidp_send_intr_message_fndecl_25093_fields hidp_send_intr_message fndecl 4 25093 NULL
+ext4_xattr_block_get_fndecl_25095_fields ext4_xattr_block_get fndecl 0 25095 NULL
+coff_ddb_input_25097_fields coff ddb_input 0 25097 NULL
+namelen_xfs_attr_sf_entry_25099_fields namelen xfs_attr_sf_entry 0 25099 NULL
+mgmt_device_found_fndecl_25100_fields mgmt_device_found fndecl 11-9 25100 NULL
+vbi_height_au0828_dev_25107_fields vbi_height au0828_dev 0 25107 NULL
+regs_size_ks8995_chip_params_25111_fields regs_size ks8995_chip_params 0 25111 NULL
+blen_if_spi_packet_25117_fields blen if_spi_packet 0 25117 NULL
+svcrdma_max_requests_vardecl_25118_fields svcrdma_max_requests vardecl 0 25118 NULL nohasharray
+clipt_start_adapter_25118_fields clipt_start adapter 0 25118 &svcrdma_max_requests_vardecl_25118_fields
+minimum_acpi_resource_memory24_25122_fields minimum acpi_resource_memory24 0 25122 NULL
+snd_interval_step_fndecl_25134_fields snd_interval_step fndecl 2 25134 NULL
+gb_len_nfc_hci_dev_25135_fields gb_len nfc_hci_dev 0 25135 NULL nohasharray
+tmpl_hdr_size_qlcnic_fw_dump_25135_fields tmpl_hdr_size qlcnic_fw_dump 0 25135 &gb_len_nfc_hci_dev_25135_fields
+bnx2i_get_cid_num_fndecl_25141_fields bnx2i_get_cid_num fndecl 0 25141 NULL
+ocfs2_init_xattr_bucket_fndecl_25146_fields ocfs2_init_xattr_bucket fndecl 2 25146 NULL
+rate_max_snd_pcm_hardware_25149_fields rate_max snd_pcm_hardware 0 25149 NULL
+numchips_cfi_private_25154_fields numchips cfi_private 0 25154 NULL
+vram_base_cirrus_mc_25157_fields vram_base cirrus_mc 0 25157 NULL
+si476x_core_send_command_fndecl_25160_fields si476x_core_send_command fndecl 4-6 25160 NULL
+max_transfer_size_mvumi_hba_25161_fields max_transfer_size mvumi_hba 0 25161 NULL
+tcp_syn_options_fndecl_25174_fields tcp_syn_options fndecl 0 25174 NULL
+s_writesize_logfs_super_25176_fields s_writesize logfs_super 0 25176 NULL
+btrfs_create_repair_bio_fndecl_25181_fields btrfs_create_repair_bio fndecl 5 25181 NULL
+heapstart_sis_video_info_25184_fields heapstart sis_video_info 0 25184 NULL
+coex_tx_win_size_mwifiex_adapter_25195_fields coex_tx_win_size mwifiex_adapter 0 25195 NULL
+run_filter_fndecl_25196_fields run_filter fndecl 0-3 25196 NULL
+iso_in_endp_ttusbir_25197_fields iso_in_endp ttusbir 0 25197 NULL
+do_shrink_fndecl_25198_fields do_shrink fndecl 3-2 25198 NULL nohasharray
+irq_sfi_device_table_entry_25198_fields irq sfi_device_table_entry 0 25198 &do_shrink_fndecl_25198_fields
+backing_dev_len_disk_conf_25199_fields backing_dev_len disk_conf 0 25199 NULL
+dlen_cxgbit_lro_pdu_cb_25201_fields dlen cxgbit_lro_pdu_cb 0 25201 NULL
+size_ioc_sts_mv_dtd_25203_fields size_ioc_sts mv_dtd 0 25203 NULL
+eth_get_headlen_fndecl_25213_fields eth_get_headlen fndecl 0-2 25213 NULL
+ext4_insert_range_fndecl_25217_fields ext4_insert_range fndecl 2-3 25217 NULL
+ocfs2_xattr_bucket_value_truncate_fndecl_25220_fields ocfs2_xattr_bucket_value_truncate fndecl 4 25220 NULL
+validate_checkpoint_fndecl_25229_fields validate_checkpoint fndecl 2 25229 NULL
+show_configfs_attribute_25232_fields show configfs_attribute 0 25232 NULL
+spy_number_iw_spy_data_25234_fields spy_number iw_spy_data 0 25234 NULL
+offset_zatm_pool_info_25250_fields offset zatm_pool_info 0 25250 NULL
+fpnum_omap3isp_ccdc_fpc_25254_fields fpnum omap3isp_ccdc_fpc 0 25254 NULL
+of_property_read_string_helper_fndecl_25257_fields of_property_read_string_helper fndecl 5 25257 NULL
+btrfs_submit_direct_fndecl_25259_fields btrfs_submit_direct fndecl 3 25259 NULL
+ar5523_cmd_fndecl_25261_fields ar5523_cmd fndecl 4 25261 NULL
+start_page_swap_extent_25262_fields start_page swap_extent 0 25262 NULL nohasharray
+first_cluster_group_blkno_ocfs2_super_25262_fields first_cluster_group_blkno ocfs2_super 0 25262 &start_page_swap_extent_25262_fields
+ext4_get_next_extent_fndecl_25267_fields ext4_get_next_extent fndecl 3-2 25267 NULL nohasharray
+vol_id_ubi_mkvol_req_25267_fields vol_id ubi_mkvol_req 0 25267 &ext4_get_next_extent_fndecl_25267_fields
+get_fold_mark_fndecl_25272_fields get_fold_mark fndecl 2 25272 NULL nohasharray
+out_iovs_fuse_ioctl_out_25272_fields out_iovs fuse_ioctl_out 0 25272 &get_fold_mark_fndecl_25272_fields
+authorizer_len_ceph_msg_connect_reply_25279_fields authorizer_len ceph_msg_connect_reply 0 25279 NULL
+dst_put_ci_fndecl_25284_fields dst_put_ci fndecl 3 25284 NULL
+ex_bn_extent_s_25293_fields ex_bn extent_s 0 25293 NULL
+string_length_acpi_resource_source_25296_fields string_length acpi_resource_source 0 25296 NULL
+part_start_hfs_sb_info_25310_fields part_start hfs_sb_info 0 25310 NULL
+vmw_cursor_update_image_fndecl_25311_fields vmw_cursor_update_image fndecl 4-3 25311 NULL nohasharray
+sz_m1_mlx5_wq_cyc_25311_fields sz_m1 mlx5_wq_cyc 0 25311 &vmw_cursor_update_image_fndecl_25311_fields
+cropw_val_pvr2_hdw_25312_fields cropw_val pvr2_hdw 0 25312 NULL
+resindex_dma_base_sst_acpi_desc_25313_fields resindex_dma_base sst_acpi_desc 0 25313 NULL
+fw_size_bcm203x_data_25314_fields fw_size bcm203x_data 0 25314 NULL
+num_desc_nx_host_rds_ring_25321_fields num_desc nx_host_rds_ring 0 25321 NULL
+cnt_i40e_hmc_obj_info_25322_fields cnt i40e_hmc_obj_info 0 25322 NULL
+iscsi_tcp_conn_setup_fndecl_25323_fields iscsi_tcp_conn_setup fndecl 2 25323 NULL
+max_outstanding_tx_usbcan_msg_softinfo_25327_fields max_outstanding_tx usbcan_msg_softinfo 0 25327 NULL
+bmv_count_getbmapx_25336_fields bmv_count getbmapx 0 25336 NULL
+width_deinterlace_q_data_25337_fields width deinterlace_q_data 0 25337 NULL
+vc_init_fndecl_25338_fields vc_init fndecl 2-3 25338 NULL
+enc_key_size_ecryptfs_key_record_25340_fields enc_key_size ecryptfs_key_record 0 25340 NULL nohasharray
+bytesperline_zoran_v4l_settings_25340_fields bytesperline zoran_v4l_settings 0 25340 &enc_key_size_ecryptfs_key_record_25340_fields nohasharray
+xfs_inobt_lookup_fndecl_25340_fields xfs_inobt_lookup fndecl 2 25340 &bytesperline_zoran_v4l_settings_25340_fields
+svc_meta_len_htc_conn_service_msg_25346_fields svc_meta_len htc_conn_service_msg 0 25346 NULL nohasharray
+init_data_size_il4965_firmware_pieces_25346_fields init_data_size il4965_firmware_pieces 0 25346 &svc_meta_len_htc_conn_service_msg_25346_fields
+skb_add_rx_frag_fndecl_25355_fields skb_add_rx_frag fndecl 2-5-6-4 25355 NULL
+spi_rd_buf_fndecl_25357_fields spi_rd_buf fndecl 4 25357 NULL
+bfs_move_block_fndecl_25369_fields bfs_move_block fndecl 1-2 25369 NULL
+encode_string_fndecl_25371_fields encode_string fndecl 2 25371 NULL
+sddr55_bulk_transport_fndecl_25377_fields sddr55_bulk_transport fndecl 4 25377 NULL nohasharray
+mt312_write_fndecl_25377_fields mt312_write fndecl 4 25377 &sddr55_bulk_transport_fndecl_25377_fields
+unix_dgram_recvmsg_fndecl_25379_fields unix_dgram_recvmsg fndecl 3 25379 NULL
+nr_channels_timb_dma_platform_data_25387_fields nr_channels timb_dma_platform_data 0 25387 NULL
+tda18218_wr_regs_fndecl_25388_fields tda18218_wr_regs fndecl 4 25388 NULL
+xlog_write_start_rec_fndecl_25394_fields xlog_write_start_rec fndecl 0 25394 NULL
+atom_size_pcpu_alloc_info_25396_fields atom_size pcpu_alloc_info 0 25396 NULL
+brcmf_pcie_read_tcm16_fndecl_25401_fields brcmf_pcie_read_tcm16 fndecl 0 25401 NULL
+metromem_dma_metronomefb_par_25407_fields metromem_dma metronomefb_par 0 25407 NULL
+memblock_virt_alloc_try_nid_fndecl_25409_fields memblock_virt_alloc_try_nid fndecl 2-3-4 25409 NULL
+nr_valid_peri_dma_pl330_platdata_25412_fields nr_valid_peri dma_pl330_platdata 0 25412 NULL
+entries_size_ebt_replace_kernel_25413_fields entries_size ebt_replace_kernel 0 25413 NULL
+image_len_gspca_dev_25419_fields image_len gspca_dev 0 25419 NULL
+remap_pci_mem_fndecl_25421_fields remap_pci_mem fndecl 2-1 25421 NULL nohasharray
+find_rsb_fndecl_25421_fields find_rsb fndecl 3 25421 &remap_pci_mem_fndecl_25421_fields
+pcf2127_i2c_read_fndecl_25429_fields pcf2127_i2c_read fndecl 5 25429 NULL
+def_rx_buf_size_octeon_config_25436_fields def_rx_buf_size octeon_config 0 25436 NULL
+i2c_write_fndecl_25439_fields i2c_write fndecl 4 25439 NULL nohasharray
+free_pfn_range_fndecl_25439_fields free_pfn_range fndecl 1-2 25439 &i2c_write_fndecl_25439_fields
+size_xen_netif_tx_request_25440_fields size xen_netif_tx_request 0 25440 NULL
+ds_nvme_lbaf_25461_fields ds nvme_lbaf 0 25461 NULL
+sddr09_send_scsi_command_fndecl_25467_fields sddr09_send_scsi_command fndecl 3 25467 NULL nohasharray
+id_stmpe_platform_data_25467_fields id stmpe_platform_data 0 25467 &sddr09_send_scsi_command_fndecl_25467_fields
+frame_alloc_fndecl_25470_fields frame_alloc fndecl 4 25470 NULL
+size_user_regset_25473_fields size user_regset 0 25473 NULL
+playback_periodsize_rme96_25479_fields playback_periodsize rme96 0 25479 NULL
+chunk_sectors_mddev_25484_fields chunk_sectors mddev 0 25484 NULL
+got_frame_fndecl_25487_fields got_frame fndecl 2 25487 NULL
+next_cmd_len_sg_fd_25494_fields next_cmd_len sg_fd 0 25494 NULL nohasharray
+rx_transfer_len_hif_device_usb_25494_fields rx_transfer_len hif_device_usb 0 25494 &next_cmd_len_sg_fd_25494_fields
+size_map_info_25510_fields size map_info 0 25510 NULL
+hidp_send_message_fndecl_25511_fields hidp_send_message fndecl 6 25511 NULL
+btrfs_qgroup_reserve_meta_fndecl_25512_fields btrfs_qgroup_reserve_meta fndecl 0 25512 NULL
+pppoe_recvmsg_fndecl_25514_fields pppoe_recvmsg fndecl 3 25514 NULL nohasharray
+n_sg_list_25514_fields n sg_list 0 25514 &pppoe_recvmsg_fndecl_25514_fields
+base_aperture_25525_fields base aperture 0 25525 NULL
+xfs_dq_get_next_id_fndecl_25529_fields xfs_dq_get_next_id fndecl 4-0 25529 NULL nohasharray
+cuse_file_ioctl_fndecl_25529_fields cuse_file_ioctl fndecl 2 25529 &xfs_dq_get_next_id_fndecl_25529_fields
+smk_write_unconfined_fndecl_25530_fields smk_write_unconfined fndecl 3 25530 NULL
+screen_fb_size_vardecl_hyperv_fb_c_25531_fields screen_fb_size vardecl_hyperv_fb.c 0 25531 NULL
+memblock_mem_limit_remove_map_fndecl_25533_fields memblock_mem_limit_remove_map fndecl 1 25533 NULL
+size_i40e_hmc_obj_info_25536_fields size i40e_hmc_obj_info 0 25536 NULL
+ioh_gpio_setup_fndecl_25540_fields ioh_gpio_setup fndecl 2 25540 NULL
+f_adc_rtl2832_sdr_dev_25544_fields f_adc rtl2832_sdr_dev 0 25544 NULL
+width_efifb_dmi_info_25557_fields width efifb_dmi_info 0 25557 NULL
+udf_extend_file_fndecl_25558_fields udf_extend_file fndecl 2 25558 NULL
+cp2112_write_req_fndecl_25559_fields cp2112_write_req fndecl 0-5 25559 NULL
+update_wqe_psn_fndecl_25563_fields update_wqe_psn fndecl 4 25563 NULL
+iommu_map_mmio_space_fndecl_25569_fields iommu_map_mmio_space fndecl 2-1 25569 NULL
+num_stations_iwl_priv_25574_fields num_stations iwl_priv 0 25574 NULL
+hpi_outstream_ancillary_read_fndecl_25575_fields hpi_outstream_ancillary_read fndecl 4 25575 NULL nohasharray
+wsm_write_mib_fndecl_25575_fields wsm_write_mib fndecl 4 25575 &hpi_outstream_ancillary_read_fndecl_25575_fields
+lpage_size_genwqe_sgl_25578_fields lpage_size genwqe_sgl 0 25578 NULL
+bytes_per_pixel_usbvision_v4l2_format_st_25584_fields bytes_per_pixel usbvision_v4l2_format_st 0 25584 NULL nohasharray
+be_cmd_set_sriov_config_fndecl_25584_fields be_cmd_set_sriov_config fndecl 3 25584 &bytes_per_pixel_usbvision_v4l2_format_st_25584_fields
+test_ofs_cyttsp4_sysinfo_ofs_25587_fields test_ofs cyttsp4_sysinfo_ofs 0 25587 NULL
+last_page_snd_emu10k1_memblk_25591_fields last_page snd_emu10k1_memblk 0 25591 NULL
+s_partition_len_udf_part_map_25593_fields s_partition_len udf_part_map 0 25593 NULL nohasharray
+MaxReplyDescriptorPostQueueDepth_mpt3sas_facts_25593_fields MaxReplyDescriptorPostQueueDepth mpt3sas_facts 0 25593 &s_partition_len_udf_part_map_25593_fields
+pcm_playback_analog_channels_snd_tscm_spec_25594_fields pcm_playback_analog_channels snd_tscm_spec 0 25594 NULL
+txdata_desc_size_vmxnet3_tx_queue_25615_fields txdata_desc_size vmxnet3_tx_queue 0 25615 NULL
+matroxfb_test_and_set_rounding_fndecl_25619_fields matroxfb_test_and_set_rounding fndecl 0-2 25619 NULL
+pmcraid_major_vardecl_pmcraid_c_25627_fields pmcraid_major vardecl_pmcraid.c 0 25627 NULL
+status_xen_netif_rx_response_25634_fields status xen_netif_rx_response 0 25634 NULL nohasharray
+ocfs2_trim_group_fndecl_25634_fields ocfs2_trim_group fndecl 0 25634 &status_xen_netif_rx_response_25634_fields
+khugepaged_scan_shmem_fndecl_25649_fields khugepaged_scan_shmem fndecl 3 25649 NULL
+rpipe_get_by_ep_fndecl_25656_fields rpipe_get_by_ep fndecl 0 25656 NULL
+getxattr_inode_operations_25660_fields getxattr inode_operations 0 25660 NULL
+btt_write_pg_fndecl_25661_fields btt_write_pg fndecl 0 25661 NULL
+eec_entry_sz_mthca_dev_lim_25665_fields eec_entry_sz mthca_dev_lim 0 25665 NULL
+HWPartsNum_qinfo_chip_25666_fields HWPartsNum qinfo_chip 0 25666 NULL nohasharray
+m_ag_maxlevels_xfs_mount_25666_fields m_ag_maxlevels xfs_mount 0 25666 &HWPartsNum_qinfo_chip_25666_fields
+tsi148_master_set_fndecl_25678_fields tsi148_master_set fndecl 4 25678 NULL
+get_user_page_nowait_fndecl_25679_fields get_user_page_nowait fndecl 1 25679 NULL
+layout_mdp_superblock_s_25680_fields layout mdp_superblock_s 0 25680 NULL
+max_cmd_per_lun_vardecl_megaraid_c_25693_fields max_cmd_per_lun vardecl_megaraid.c 0 25693 NULL
+chv_get_total_gtt_size_fndecl_25701_fields chv_get_total_gtt_size fndecl 0-1 25701 NULL nohasharray
+xh_num_buckets_ocfs2_xattr_header_25701_fields xh_num_buckets ocfs2_xattr_header 0 25701 &chv_get_total_gtt_size_fndecl_25701_fields
+val_ilt_cfg_pair_25703_fields val ilt_cfg_pair 0 25703 NULL
+ir_post_altera_jtag_25704_fields ir_post altera_jtag 0 25704 NULL nohasharray
+sysctl_numa_balancing_scan_size_vardecl_25704_fields sysctl_numa_balancing_scan_size vardecl 0 25704 &ir_post_altera_jtag_25704_fields
+metadata_bnxt_tpa_info_25705_fields metadata bnxt_tpa_info 0 25705 NULL nohasharray
+cmnd_out_ep_vub300_mmc_host_25705_fields cmnd_out_ep vub300_mmc_host 0 25705 &metadata_bnxt_tpa_info_25705_fields nohasharray
+get_bio_block_fndecl_25705_fields get_bio_block fndecl 0 25705 &cmnd_out_ep_vub300_mmc_host_25705_fields
+__sector_request_25709_fields __sector request 0 25709 NULL
+buf_count_drm_buf_entry_25716_fields buf_count drm_buf_entry 0 25716 NULL
+svc_max_payload_fndecl_25718_fields svc_max_payload fndecl 0 25718 NULL
+left_margin_fb_var_screeninfo_25722_fields left_margin fb_var_screeninfo 0 25722 NULL
+data_cnt_adv_scsi_req_q_25725_fields data_cnt adv_scsi_req_q 0 25725 NULL
+raid1_resize_fndecl_25735_fields raid1_resize fndecl 2 25735 NULL
+res_cnt_common_sol_cqe_25739_fields res_cnt common_sol_cqe 0 25739 NULL
+ms_read_copyblock_fndecl_25740_fields ms_read_copyblock fndecl 7 25740 NULL
+ext4_da_map_blocks_fndecl_25744_fields ext4_da_map_blocks fndecl 2 25744 NULL
+iov_iter_kvec_fndecl_25747_fields iov_iter_kvec fndecl 5-4 25747 NULL
+tics_vardecl_hfcpci_c_25752_fields tics vardecl_hfcpci.c 0 25752 NULL
+access_width_acpi_generic_address_25756_fields access_width acpi_generic_address 0 25756 NULL
+buffer_size_command_25757_fields buffer_size command 0 25757 NULL
+rh_urb_enqueue_fndecl_25758_fields rh_urb_enqueue fndecl 0 25758 NULL
+max_memblock_type_25766_fields max memblock_type 0 25766 NULL
+src_len_ccp_aes_engine_25770_fields src_len ccp_aes_engine 0 25770 NULL
+event_len_fanotify_event_metadata_25772_fields event_len fanotify_event_metadata 0 25772 NULL
+qla82xx_pci_mem_write_2M_fndecl_25790_fields qla82xx_pci_mem_write_2M fndecl 2 25790 NULL
+num_prealloc_crypto_pages_vardecl_crypto_c_25796_fields num_prealloc_crypto_pages vardecl_crypto.c 0 25796 NULL
+stolen_base_i915_gem_mm_25807_fields stolen_base i915_gem_mm 0 25807 NULL
+sgentry_align_brcmf_sdio_25813_fields sgentry_align brcmf_sdio 0 25813 NULL nohasharray
+lf_depth_gfs2_leaf_25813_fields lf_depth gfs2_leaf 0 25813 &sgentry_align_brcmf_sdio_25813_fields
+fjes_change_mtu_fndecl_25818_fields fjes_change_mtu fndecl 2 25818 NULL
+__kfifo_in_fndecl_25822_fields __kfifo_in fndecl 0 25822 NULL
+pages_per_rd_bio_scrub_ctx_25831_fields pages_per_rd_bio scrub_ctx 0 25831 NULL
+depth_cx25821_fmt_25832_fields depth cx25821_fmt 0 25832 NULL
+cookie_offset_nfsd4_readdir_25834_fields cookie_offset nfsd4_readdir 0 25834 NULL
+mmc_test_area_map_fndecl_25839_fields mmc_test_area_map fndecl 2-4 25839 NULL
+start_cxgb4_range_25845_fields start cxgb4_range 0 25845 NULL
+rvt_reg_user_mr_fndecl_25852_fields rvt_reg_user_mr fndecl 2-3-4 25852 NULL
+ric_ies_len_cfg80211_ft_event_params_25853_fields ric_ies_len cfg80211_ft_event_params 0 25853 NULL
+do_tune_cpucache_fndecl_25855_fields do_tune_cpucache fndecl 3-4 25855 NULL
+asize_mypriv_25864_fields asize mypriv 0 25864 NULL
+usVBlanking_Time__ATOM_DTD_FORMAT_25867_fields usVBlanking_Time _ATOM_DTD_FORMAT 0 25867 NULL
+ndlc_probe_fndecl_25869_fields ndlc_probe fndecl 4 25869 NULL
+vlan_dev_change_mtu_fndecl_25871_fields vlan_dev_change_mtu fndecl 2 25871 NULL
+btrfs_clone_file_range_fndecl_25875_fields btrfs_clone_file_range fndecl 4-2-5 25875 NULL
+buf_size_regmap_format_25880_fields buf_size regmap_format 0 25880 NULL
+sb_agblocks_xfs_sb_25887_fields sb_agblocks xfs_sb 0 25887 NULL
+width_virtio_gpu_rect_25892_fields width virtio_gpu_rect 0 25892 NULL nohasharray
+q_num_tx_buffers_qede_dev_25892_fields q_num_tx_buffers qede_dev 0 25892 &width_virtio_gpu_rect_25892_fields
+gid_tbl_len_ib_port_immutable_25893_fields gid_tbl_len ib_port_immutable 0 25893 NULL nohasharray
+i915_gem_batch_pool_get_fndecl_25893_fields i915_gem_batch_pool_get fndecl 2 25893 &gid_tbl_len_ib_port_immutable_25893_fields nohasharray
+intf_num_smi_info_25893_fields intf_num smi_info 0 25893 &i915_gem_batch_pool_get_fndecl_25893_fields
+vram_remap_vardecl_uvesafb_c_25907_fields vram_remap vardecl_uvesafb.c 0 25907 NULL
+sit_blocks_sit_info_25908_fields sit_blocks sit_info 0 25908 NULL
+acpi_get_override_irq_fndecl_25918_fields acpi_get_override_irq fndecl 1 25918 NULL
+__rs_setup_recovery_fndecl_25935_fields __rs_setup_recovery fndecl 2 25935 NULL
+ircomm_tty_connect_indication_fndecl_25936_fields ircomm_tty_connect_indication fndecl 4-5 25936 NULL
+smk_write_onlycap_fndecl_25939_fields smk_write_onlycap fndecl 3 25939 NULL
+n_piobufs_efx_ef10_nic_data_25940_fields n_piobufs efx_ef10_nic_data 0 25940 NULL
+shmem_getpage_gfp_fndecl_25948_fields shmem_getpage_gfp fndecl 2 25948 NULL
+__xfs_bmbt_get_all_fndecl_25952_fields __xfs_bmbt_get_all fndecl 2-1 25952 NULL
+cyttsp_spi_read_block_data_fndecl_25954_fields cyttsp_spi_read_block_data fndecl 4 25954 NULL
+len_xsd_sockmsg_25963_fields len xsd_sockmsg 0 25963 NULL nohasharray
+vchnl_vf_send_add_hmc_objs_req_fndecl_25963_fields vchnl_vf_send_add_hmc_objs_req fndecl 5 25963 &len_xsd_sockmsg_25963_fields
+ieee802154_hdr_get_sechdr_fndecl_25965_fields ieee802154_hdr_get_sechdr fndecl 0 25965 NULL
+memblock_remove_range_fndecl_25969_fields memblock_remove_range fndecl 3-2 25969 NULL
+fuse_getxattr_fndecl_25975_fields fuse_getxattr fndecl 5 25975 NULL
+vscnprintf_fndecl_25984_fields vscnprintf fndecl 0 25984 NULL
+ns_blocksize_bits_the_nilfs_25985_fields ns_blocksize_bits the_nilfs 0 25985 NULL
+split_state_fndecl_25992_fields split_state fndecl 0-4 25992 NULL
+vga_vram_size_vardecl_vgacon_c_25995_fields vga_vram_size vardecl_vgacon.c 0 25995 NULL
+get_sum_page_fndecl_26000_fields get_sum_page fndecl 2 26000 NULL
+len_ieee_types_header_26006_fields len ieee_types_header 0 26006 NULL
+udplite_getfrag_fndecl_26012_fields udplite_getfrag fndecl 4 26012 NULL
+core_name_size_vardecl_coredump_c_26013_fields core_name_size vardecl_coredump.c 0 26013 NULL
+ufs_load_cylinder_fndecl_26018_fields ufs_load_cylinder fndecl 2 26018 NULL
+platform_id_cb710_chip_26021_fields platform_id cb710_chip 0 26021 NULL
+touch_max_wacom_features_26029_fields touch_max wacom_features 0 26029 NULL
+__gfs2_fallocate_fndecl_26035_fields __gfs2_fallocate fndecl 4-3 26035 NULL
+EraseSize_NFTLrecord_26040_fields EraseSize NFTLrecord 0 26040 NULL
+rds_buf_vardecl_radio_wl1273_c_26043_fields rds_buf vardecl_radio-wl1273.c 0 26043 NULL
+ll_recv_fndecl_26047_fields ll_recv fndecl 3 26047 NULL
+md_template_size_netxen_minidump_26050_fields md_template_size netxen_minidump 0 26050 NULL
+l2cap_send_cmd_fndecl_26055_fields l2cap_send_cmd fndecl 4 26055 NULL
+physical_for_dev_replace_scrub_copy_nocow_ctx_26059_fields physical_for_dev_replace scrub_copy_nocow_ctx 0 26059 NULL
+nfc_hci_hcp_message_tx_fndecl_26069_fields nfc_hci_hcp_message_tx fndecl 6 26069 NULL
+remap_to_origin_then_cache_fndecl_26084_fields remap_to_origin_then_cache fndecl 4 26084 NULL
+skb_buf_size_vmxnet3_adapter_26088_fields skb_buf_size vmxnet3_adapter 0 26088 NULL
+vmci_transport_set_max_buffer_size_fndecl_26089_fields vmci_transport_set_max_buffer_size fndecl 2 26089 NULL
+num_vectors_i40e_qvlist_info_26091_fields num_vectors i40e_qvlist_info 0 26091 NULL
+__clear_extent_bit_fndecl_26097_fields __clear_extent_bit fndecl 2-3 26097 NULL nohasharray
+rds_ib_ring_resize_fndecl_26097_fields rds_ib_ring_resize fndecl 2 26097 &__clear_extent_bit_fndecl_26097_fields
+used_bytes_ubi_volume_26113_fields used_bytes ubi_volume 0 26113 NULL
+log_store_fndecl_26118_fields log_store fndecl 8 26118 NULL
+maxflows_sfq_sched_data_26122_fields maxflows sfq_sched_data 0 26122 NULL
+plane_mode_nvm_dev_26134_fields plane_mode nvm_dev 0 26134 NULL
+bits_per_pin_pcs_device_26141_fields bits_per_pin pcs_device 0 26141 NULL
+size_cyttsp4_tch_rec_params_26150_fields size cyttsp4_tch_rec_params 0 26150 NULL
+reno_count_yeah_26151_fields reno_count yeah 0 26151 NULL
+hid_register_report_fndecl_26154_fields hid_register_report fndecl 3 26154 NULL
+sense_len_megasas_iocpacket_26161_fields sense_len megasas_iocpacket 0 26161 NULL
+r_bitcnt_tiger_hw_26171_fields r_bitcnt tiger_hw 0 26171 NULL
+src_sz_max_ce_attr_26172_fields src_sz_max ce_attr 0 26172 NULL
+ci_buffer_size_dlm_config_info_26176_fields ci_buffer_size dlm_config_info 0 26176 NULL
+qcaspi_burst_len_vardecl_qca_spi_c_26179_fields qcaspi_burst_len vardecl_qca_spi.c 0 26179 NULL
+virtio_transport_get_credit_fndecl_26188_fields virtio_transport_get_credit fndecl 0-2 26188 NULL nohasharray
+video_vsize_solo_dev_26188_fields video_vsize solo_dev 0 26188 &virtio_transport_get_credit_fndecl_26188_fields
+drm_atomic_plane_set_property_fndecl_26190_fields drm_atomic_plane_set_property fndecl 4 26190 NULL nohasharray
+level_guest_walkerEPT_26190_fields level guest_walkerEPT 0 26190 &drm_atomic_plane_set_property_fndecl_26190_fields
+rq_num_pas_mlx5_ib_rwq_26195_fields rq_num_pas mlx5_ib_rwq 0 26195 NULL
+gue_remcsum_fndecl_26202_fields gue_remcsum fndecl 4 26202 NULL
+et131x_change_mtu_fndecl_26203_fields et131x_change_mtu fndecl 2 26203 NULL
+off_virtio_vsock_pkt_26209_fields off virtio_vsock_pkt 0 26209 NULL nohasharray
+bfad_debugfs_write_regrd_fndecl_26209_fields bfad_debugfs_write_regrd fndecl 3 26209 &off_virtio_vsock_pkt_26209_fields
+s_log_zone_size_isofs_sb_info_26211_fields s_log_zone_size isofs_sb_info 0 26211 NULL
+dev_cnt_usnic_uiom_pd_26213_fields dev_cnt usnic_uiom_pd 0 26213 NULL
+sst_wake_up_block_fndecl_26217_fields sst_wake_up_block fndecl 6 26217 NULL
+dr_post_altera_jtag_26219_fields dr_post altera_jtag 0 26219 NULL nohasharray
+ufx_handle_damage_fndecl_26219_fields ufx_handle_damage fndecl 5-4 26219 &dr_post_altera_jtag_26219_fields
+base_snd_cs46xx_region_26223_fields base snd_cs46xx_region 0 26223 NULL
+hfi1_dev_vardecl_device_c_26237_fields hfi1_dev vardecl_device.c 0 26237 NULL
+shift_rtl8xxxu_rxdesc24_26240_fields shift rtl8xxxu_rxdesc24 0 26240 NULL nohasharray
+tct_size_idt77252_dev_26240_fields tct_size idt77252_dev 0 26240 &shift_rtl8xxxu_rxdesc24_26240_fields
+max_srq_wr_ib_device_attr_26242_fields max_srq_wr ib_device_attr 0 26242 NULL
+can_gather_numa_stats_fndecl_26254_fields can_gather_numa_stats fndecl 3 26254 NULL
+den_snd_ratden_26264_fields den snd_ratden 0 26264 NULL
+decompress_pstore_zbackend_26274_fields decompress pstore_zbackend 0 26274 NULL
+fw_realloc_buffer_fndecl_26275_fields fw_realloc_buffer fndecl 2 26275 NULL
+width_stk1160_26279_fields width stk1160 0 26279 NULL
+simple_io_fndecl_26280_fields simple_io fndecl 4 26280 NULL nohasharray
+xlate_dev_mem_ptr_fndecl_26280_fields xlate_dev_mem_ptr fndecl 1 26280 &simple_io_fndecl_26280_fields
+send_write_fndecl_26285_fields send_write fndecl 6-0-5-4 26285 NULL
+size_rsn_ie_t_26289_fields size rsn_ie_t 0 26289 NULL
+hub_port_connect_fndecl_26292_fields hub_port_connect fndecl 2 26292 NULL nohasharray
+sc_max_sge_svcxprt_rdma_26292_fields sc_max_sge svcxprt_rdma 0 26292 &hub_port_connect_fndecl_26292_fields
+members_count_dlm_space_26293_fields members_count dlm_space 0 26293 NULL
+devm_gen_pool_create_fndecl_26295_fields devm_gen_pool_create fndecl 2 26295 NULL
+count_rio_transaction_26296_fields count rio_transaction 0 26296 NULL
+xskip_mt9t031_26297_fields xskip mt9t031 0 26297 NULL
+model_data_size_oxygen_model_26304_fields model_data_size oxygen_model 0 26304 NULL nohasharray
+xhci_common_hub_descriptor_fndecl_26304_fields xhci_common_hub_descriptor fndecl 3 26304 &model_data_size_oxygen_model_26304_fields
+w5200_spi_readbulk_fndecl_26307_fields w5200_spi_readbulk fndecl 4 26307 NULL
+debugfs_create_file_size_fndecl_26309_fields debugfs_create_file_size fndecl 6 26309 NULL
+used_core_name_26313_fields used core_name 0 26313 NULL
+drxdap_fasi_write_block_fndecl_26315_fields drxdap_fasi_write_block fndecl 3 26315 NULL
+irlan_connect_indication_fndecl_26316_fields irlan_connect_indication fndecl 5 26316 NULL
+mc_mask_radeon_mc_26322_fields mc_mask radeon_mc 0 26322 NULL
+ocfs2_read_refcount_block_fndecl_26330_fields ocfs2_read_refcount_block fndecl 2 26330 NULL
+fcoe_ctlr_send_keep_alive_fndecl_26335_fields fcoe_ctlr_send_keep_alive fndecl 3 26335 NULL
+maxchild_usb_device_26337_fields maxchild usb_device 0 26337 NULL nohasharray
+scif_pin_pages_fndecl_26337_fields scif_pin_pages fndecl 2 26337 &maxchild_usb_device_26337_fields
+broadcast_xmt_max_payload_fwnet_device_26343_fields broadcast_xmt_max_payload fwnet_device 0 26343 NULL
+vmw_cotable_resize_fndecl_26346_fields vmw_cotable_resize fndecl 2 26346 NULL
+hugetlbfs_pagecache_present_fndecl_26350_fields hugetlbfs_pagecache_present fndecl 3 26350 NULL nohasharray
+blkdev_readpages_fndecl_26350_fields blkdev_readpages fndecl 4 26350 &hugetlbfs_pagecache_present_fndecl_26350_fields
+__ocfs2_remove_xattr_range_fndecl_26353_fields __ocfs2_remove_xattr_range fndecl 5-4-3 26353 NULL
+kovaplus_sysfs_read_fndecl_26362_fields kovaplus_sysfs_read fndecl 6 26362 NULL
+scsi_eh_prep_cmnd_fndecl_26365_fields scsi_eh_prep_cmnd fndecl 5 26365 NULL
+max_mthca_alloc_26367_fields max mthca_alloc 0 26367 NULL
+xpnet_send_fndecl_26368_fields xpnet_send fndecl 3-4 26368 NULL nohasharray
+ts_tsid_gru_thread_state_26368_fields ts_tsid gru_thread_state 0 26368 &xpnet_send_fndecl_26368_fields
+buffer_length_TAG_TW_Ioctl_Driver_Command_26369_fields buffer_length TAG_TW_Ioctl_Driver_Command 0 26369 NULL
+ac_last_group_ocfs2_alloc_context_26384_fields ac_last_group ocfs2_alloc_context 0 26384 NULL
+dccp_sendmsg_fndecl_26385_fields dccp_sendmsg fndecl 3 26385 NULL
+dict_size_comp_opts_26391_fields dict_size comp_opts 0 26391 NULL
+maximum_num_physicals_aac_dev_26393_fields maximum_num_physicals aac_dev 0 26393 NULL
+transcnt_elsa_hw_26395_fields transcnt elsa_hw 0 26395 NULL
+ea_init_fndecl_26400_fields ea_init fndecl 5 26400 NULL
+gbuffers_vardecl_meye_c_26402_fields gbuffers vardecl_meye.c 0 26402 NULL
+bad_peb_limit_ubi_device_26403_fields bad_peb_limit ubi_device 0 26403 NULL nohasharray
+xhci_giveback_urb_in_irq_fndecl_26403_fields xhci_giveback_urb_in_irq fndecl 3 26403 &bad_peb_limit_ubi_device_26403_fields
+netlbl_catmap_walk_fndecl_26405_fields netlbl_catmap_walk fndecl 2 26405 NULL
+height_drm_mode_create_dumb_26406_fields height drm_mode_create_dumb 0 26406 NULL
+residualByteCnt_status_entry_26414_fields residualByteCnt status_entry 0 26414 NULL
+crtc_htotal_drm_display_mode_26418_fields crtc_htotal drm_display_mode 0 26418 NULL
+xfs_bmapi_convert_unwritten_fndecl_26421_fields xfs_bmapi_convert_unwritten fndecl 0 26421 NULL
+mmio_size_lpss_private_data_26423_fields mmio_size lpss_private_data 0 26423 NULL
+mod_start_extent_map_26431_fields mod_start extent_map 0 26431 NULL
+wtmax_nfs_fsinfo_26434_fields wtmax nfs_fsinfo 0 26434 NULL
+__adjust_resource_fndecl_26436_fields __adjust_resource fndecl 3-2 26436 NULL
+packets_snd_urb_ctx_26437_fields packets snd_urb_ctx 0 26437 NULL
+map_capacity_cw1200_queue_stats_26439_fields map_capacity cw1200_queue_stats 0 26439 NULL
+compute_pipe_count_kgd2kfd_shared_resources_26445_fields compute_pipe_count kgd2kfd_shared_resources 0 26445 NULL
+max_req_size_mmc_host_26446_fields max_req_size mmc_host 0 26446 NULL nohasharray
+sierra_net_change_mtu_fndecl_26446_fields sierra_net_change_mtu fndecl 2 26446 &max_req_size_mmc_host_26446_fields
+size_aper_size_info_fixed_26447_fields size aper_size_info_fixed 0 26447 NULL
+width_cobalt_stream_26451_fields width cobalt_stream 0 26451 NULL
+qp_memcpy_to_queue_iov_fndecl_26456_fields qp_memcpy_to_queue_iov fndecl 5-2 26456 NULL
+global_irq_base_acpi_madt_io_apic_26467_fields global_irq_base acpi_madt_io_apic 0 26467 NULL
+usbat_bulk_read_fndecl_26469_fields usbat_bulk_read fndecl 3 26469 NULL
+tpg_reset_source_fndecl_26472_fields tpg_reset_source fndecl 2-3 26472 NULL
+iscsi_conn_context_id_iscsi_kcqe_26475_fields iscsi_conn_context_id iscsi_kcqe 0 26475 NULL
+nr_kioctx_table_26477_fields nr kioctx_table 0 26477 NULL
+btt_read_pg_fndecl_26478_fields btt_read_pg fndecl 0 26478 NULL
+len_seq_buf_26481_fields len seq_buf 0 26481 NULL
+pte_to_pagemap_entry_fndecl_26482_fields pte_to_pagemap_entry fndecl 3 26482 NULL nohasharray
+page_cache_next_hole_fndecl_26482_fields page_cache_next_hole fndecl 0-2 26482 &pte_to_pagemap_entry_fndecl_26482_fields
+max_osd_ceph_osdmap_26483_fields max_osd ceph_osdmap 0 26483 NULL
+__ip6_append_data_fndecl_26484_fields __ip6_append_data fndecl 10-9 26484 NULL
+count_xfs_dir2_sf_hdr_26486_fields count xfs_dir2_sf_hdr 0 26486 NULL
+setup_max_cpus_vardecl_26488_fields setup_max_cpus vardecl 0 26488 NULL
+tipc_bcast_get_mtu_fndecl_26493_fields tipc_bcast_get_mtu fndecl 0 26493 NULL nohasharray
+pa_lstart_ext4_prealloc_space_26493_fields pa_lstart ext4_prealloc_space 0 26493 &tipc_bcast_get_mtu_fndecl_26493_fields
+ndr_start_nd_region_26496_fields ndr_start nd_region 0 26496 NULL
+remap_and_issue_overwrite_fndecl_26499_fields remap_and_issue_overwrite fndecl 3 26499 NULL
+drm_fb_helper_dirty_fndecl_26526_fields drm_fb_helper_dirty fndecl 3-5-2-4 26526 NULL nohasharray
+t4_max_cq_depth_c4iw_hw_queue_26526_fields t4_max_cq_depth c4iw_hw_queue 0 26526 &drm_fb_helper_dirty_fndecl_26526_fields
+devm_memremap_fndecl_26527_fields devm_memremap fndecl 3-2 26527 NULL
+sync_buf_offs_pvr2_ioread_26534_fields sync_buf_offs pvr2_ioread 0 26534 NULL
+myri10ge_max_slices_vardecl_myri10ge_c_26536_fields myri10ge_max_slices vardecl_myri10ge.c 0 26536 NULL
+rss_lut_size_i40evf_adapter_26546_fields rss_lut_size i40evf_adapter 0 26546 NULL nohasharray
+onenand_write_fndecl_26546_fields onenand_write fndecl 2 26546 &rss_lut_size_i40evf_adapter_26546_fields
+pci_irq_pcmcia_socket_26558_fields pci_irq pcmcia_socket 0 26558 NULL
+maxdepth_sfq_sched_data_26560_fields maxdepth sfq_sched_data 0 26560 NULL
+fifo_blocks_vxge_hw_fifo_config_26565_fields fifo_blocks vxge_hw_fifo_config 0 26565 NULL
+br_change_mtu_fndecl_26571_fields br_change_mtu fndecl 2 26571 NULL
+wMaxSegmentSize_usb_cdc_mbim_desc_26572_fields wMaxSegmentSize usb_cdc_mbim_desc 0 26572 NULL
+ra_tid_iwl_mvm_tx_resp_26576_fields ra_tid iwl_mvm_tx_resp 0 26576 NULL
+sd_log_flush_head_gfs2_sbd_26577_fields sd_log_flush_head gfs2_sbd 0 26577 NULL
+smbios_entry_point_size_vardecl_dmi_scan_c_26579_fields smbios_entry_point_size vardecl_dmi_scan.c 0 26579 NULL
+read_tree_block_fndecl_26587_fields read_tree_block fndecl 2 26587 NULL nohasharray
+initial_ssthresh_vardecl_tcp_cubic_c_26587_fields initial_ssthresh vardecl_tcp_cubic.c 0 26587 &read_tree_block_fndecl_26587_fields
+rates_len_add_sta_param_26593_fields rates_len add_sta_param 0 26593 NULL
+tx_desc_count_xgbe_prv_data_26603_fields tx_desc_count xgbe_prv_data 0 26603 NULL
+UMAsize_sis_video_info_26611_fields UMAsize sis_video_info 0 26611 NULL
+width_drm_vmw_size_26615_fields width drm_vmw_size 0 26615 NULL
+control_blocks_gru_create_context_req_26616_fields control_blocks gru_create_context_req 0 26616 NULL
+data_out_ep_vub300_mmc_host_26618_fields data_out_ep vub300_mmc_host 0 26618 NULL
+airspy_convert_stream_fndecl_26619_fields airspy_convert_stream fndecl 0-4 26619 NULL
+usb_rh_urb_dequeue_fndecl_26620_fields usb_rh_urb_dequeue fndecl 3 26620 NULL
+smscore_load_firmware_family2_fndecl_26621_fields smscore_load_firmware_family2 fndecl 3 26621 NULL
+hub_port_connect_change_fndecl_26625_fields hub_port_connect_change fndecl 2 26625 NULL
+data_len_ipmi_msg_26626_fields data_len ipmi_msg 0 26626 NULL
+hdac_hdmi_fill_widget_info_fndecl_26629_fields hdac_hdmi_fill_widget_info fndecl 8 26629 NULL
+l2_fhdr_pkt_len_l2_fhdr_26630_fields l2_fhdr_pkt_len l2_fhdr 0 26630 NULL
+facs_acpi_table_fadt_26632_fields facs acpi_table_fadt 0 26632 NULL
+mpt_lan_receive_post_turbo_fndecl_26635_fields mpt_lan_receive_post_turbo fndecl 2 26635 NULL
+qxl_draw_dirty_fb_fndecl_26636_fields qxl_draw_dirty_fb fndecl 7 26636 NULL
+i40e_change_mtu_fndecl_26637_fields i40e_change_mtu fndecl 2 26637 NULL
+h_length_dlm_header_26639_fields h_length dlm_header 0 26639 NULL nohasharray
+aac_sa_ioremap_fndecl_26639_fields aac_sa_ioremap fndecl 2 26639 &h_length_dlm_header_26639_fields nohasharray
+irias_new_octseq_value_fndecl_26639_fields irias_new_octseq_value fndecl 2 26639 &aac_sa_ioremap_fndecl_26639_fields
+fh_size_knfsd_fh_26641_fields fh_size knfsd_fh 0 26641 NULL
+size_drm_global_reference_26642_fields size drm_global_reference 0 26642 NULL nohasharray
+sys_madvise_fndecl_26642_fields sys_madvise fndecl 2-1 26642 &size_drm_global_reference_26642_fields
+platform_device_alloc_fndecl_26645_fields platform_device_alloc fndecl 2 26645 NULL
+n_namesz_elf64_note_26646_fields n_namesz elf64_note 0 26646 NULL
+max_wqes_mlx4_caps_26647_fields max_wqes mlx4_caps 0 26647 NULL
+spi_populate_width_msg_fndecl_26651_fields spi_populate_width_msg fndecl 0 26651 NULL
+front_len_ceph_msgpool_26653_fields front_len ceph_msgpool 0 26653 NULL
+pmcraid_get_minor_fndecl_26656_fields pmcraid_get_minor fndecl 0 26656 NULL
+nr_recvmsg_fndecl_26658_fields nr_recvmsg fndecl 3 26658 NULL
+jbd2_journal_begin_ordered_truncate_fndecl_26661_fields jbd2_journal_begin_ordered_truncate fndecl 3 26661 NULL
+qed_qm_pf_mem_size_fndecl_26667_fields qed_qm_pf_mem_size fndecl 0 26667 NULL
+hdlc_change_mtu_fndecl_26672_fields hdlc_change_mtu fndecl 2 26672 NULL
+oobsize_mtd_info_26683_fields oobsize mtd_info 0 26683 NULL
+swap_cgroup_swapon_fndecl_26685_fields swap_cgroup_swapon fndecl 2 26685 NULL
+rx_buff_len_amd8111e_priv_26693_fields rx_buff_len amd8111e_priv 0 26693 NULL
+raw_request_hid_ll_driver_26699_fields raw_request hid_ll_driver 0 26699 NULL
+packet_snd_fndecl_26705_fields packet_snd fndecl 3 26705 NULL
+musb_ep_program_fndecl_26707_fields musb_ep_program fndecl 7 26707 NULL
+x509_extract_name_segment_fndecl_26716_fields x509_extract_name_segment fndecl 5 26716 NULL
+i915_gem_obj_ggtt_offset_view_fndecl_26723_fields i915_gem_obj_ggtt_offset_view fndecl 0 26723 NULL
+max_transfer_size_rndis_init_c_26725_fields max_transfer_size rndis_init_c 0 26725 NULL
+fuse_copy_pages_fndecl_26731_fields fuse_copy_pages fndecl 2 26731 NULL
+ocfs2_xattr_set_handle_fndecl_26732_fields ocfs2_xattr_set_handle fndecl 7 26732 NULL
+minor_uart_driver_26739_fields minor uart_driver 0 26739 NULL
+add_index_fndecl_26744_fields add_index fndecl 0 26744 NULL nohasharray
+xfs_filestream_lookup_ag_fndecl_26744_fields xfs_filestream_lookup_ag fndecl 0 26744 &add_index_fndecl_26744_fields
+block_size_befs_sb_info_26751_fields block_size befs_sb_info 0 26751 NULL
+raw_serial_size_pkcs7_parse_context_26761_fields raw_serial_size pkcs7_parse_context 0 26761 NULL
+nAcks_rxrpc_ackpacket_26767_fields nAcks rxrpc_ackpacket 0 26767 NULL
+tipc_send_stream_fndecl_26771_fields tipc_send_stream fndecl 3 26771 NULL
+rdma_rw_init_single_wr_fndecl_26775_fields rdma_rw_init_single_wr fndecl 4-5 26775 NULL
+hb_size_hashbin_t_26779_fields hb_size hashbin_t 0 26779 NULL
+__perf_event_read_size_fndecl_26786_fields __perf_event_read_size fndecl 2 26786 NULL
+max_support_points_edt_ft5x06_ts_data_26799_fields max_support_points edt_ft5x06_ts_data 0 26799 NULL
+ocfs2_cache_block_dealloc_fndecl_26800_fields ocfs2_cache_block_dealloc fndecl 6-5-4 26800 NULL
+width_v4l2_rect_26802_fields width v4l2_rect 0 26802 NULL
+dwc2_hsotg_set_ep_maxpacket_fndecl_26815_fields dwc2_hsotg_set_ep_maxpacket fndecl 3 26815 NULL
+ramdisk_image_setup_header_26821_fields ramdisk_image setup_header 0 26821 NULL
+qlcnic_max_rings_fndecl_26823_fields qlcnic_max_rings fndecl 2 26823 NULL
+l2tp_ip_recvmsg_fndecl_26826_fields l2tp_ip_recvmsg fndecl 3 26826 NULL
+bEndpointAddress_usb_endpoint_descriptor_26829_fields bEndpointAddress usb_endpoint_descriptor 0 26829 NULL
+vc_screenbuf_size_vc_data_26832_fields vc_screenbuf_size vc_data 0 26832 NULL nohasharray
+ath6kl_wmi_add_del_mcast_filter_cmd_fndecl_26832_fields ath6kl_wmi_add_del_mcast_filter_cmd fndecl 2 26832 &vc_screenbuf_size_vc_data_26832_fields
+header_sectors_per_block_partition_26836_fields header_sectors_per_block partition 0 26836 NULL
+size_sram_reserve_26839_fields size sram_reserve 0 26839 NULL
+offset_resource_entry_26851_fields offset resource_entry 0 26851 NULL
+sizeof_flush_fndecl_26863_fields sizeof_flush fndecl 0 26863 NULL
+osd_req_add_get_attr_page_fndecl_26866_fields osd_req_add_get_attr_page fndecl 4 26866 NULL
+try_get_cap_refs_fndecl_26867_fields try_get_cap_refs fndecl 0 26867 NULL
+dlc_usb_8dev_rx_msg_26873_fields dlc usb_8dev_rx_msg 0 26873 NULL nohasharray
+pipe_in_lan78xx_net_26873_fields pipe_in lan78xx_net 0 26873 &dlc_usb_8dev_rx_msg_26873_fields
+pci_address_to_pio_fndecl_26876_fields pci_address_to_pio fndecl 0-1 26876 NULL
+mwifiex_sdio_card_to_host_mp_aggr_fndecl_26877_fields mwifiex_sdio_card_to_host_mp_aggr fndecl 2 26877 NULL
+n_allocated_vis_efx_ef10_nic_data_26878_fields n_allocated_vis efx_ef10_nic_data 0 26878 NULL
+us122l_ctl_msg_fndecl_26881_fields us122l_ctl_msg fndecl 8 26881 NULL
+dev_bytenr_btrfsic_block_data_ctx_26882_fields dev_bytenr btrfsic_block_data_ctx 0 26882 NULL nohasharray
+sym_set_cam_result_error_fndecl_26882_fields sym_set_cam_result_error fndecl 3 26882 &dev_bytenr_btrfsic_block_data_ctx_26882_fields
+out_skip_ceph_connection_26886_fields out_skip ceph_connection 0 26886 NULL
+xdr_process_buf_fndecl_26887_fields xdr_process_buf fndecl 3-2 26887 NULL
+head_floppy_struct_26890_fields head floppy_struct 0 26890 NULL
+len_f2fs_defragment_26892_fields len f2fs_defragment 0 26892 NULL nohasharray
+agno_xfs_alloc_arg_26892_fields agno xfs_alloc_arg 0 26892 &len_f2fs_defragment_26892_fields
+find_get_pages_contig_fndecl_26902_fields find_get_pages_contig fndecl 0 26902 NULL
+raid_disks_r5conf_26904_fields raid_disks r5conf 0 26904 NULL
+ctx_len_xfrm_user_sec_ctx_26911_fields ctx_len xfrm_user_sec_ctx 0 26911 NULL nohasharray
+stack_user_size_perf_sample_data_26911_fields stack_user_size perf_sample_data 0 26911 &ctx_len_xfrm_user_sec_ctx_26911_fields
+port_event_fndecl_26912_fields port_event fndecl 2 26912 NULL
+num_slots_rtsx_pcr_26914_fields num_slots rtsx_pcr 0 26914 NULL
+hscx_empty_fifo_fndecl_26915_fields hscx_empty_fifo fndecl 2 26915 NULL nohasharray
+jffs2_flash_writev_fndecl_26915_fields jffs2_flash_writev fndecl 4 26915 &hscx_empty_fifo_fndecl_26915_fields
+w5500_spi_writebulk_fndecl_26916_fields w5500_spi_writebulk fndecl 4 26916 NULL
+get_wep_key_fndecl_26919_fields get_wep_key fndecl 0-4 26919 NULL nohasharray
+nvmet_rdma_use_inline_sg_fndecl_26919_fields nvmet_rdma_use_inline_sg fndecl 2-3 26919 &get_wep_key_fndecl_26919_fields
+amdgpu_bo_create_restricted_fndecl_26920_fields amdgpu_bo_create_restricted fndecl 2 26920 NULL
+to_skip_sd_26922_fields to_skip sd 0 26922 NULL
+count_vnic_res_26925_fields count vnic_res 0 26925 NULL
+major_intel_th_26929_fields major intel_th 0 26929 NULL
+get_bits_fndecl_26938_fields get_bits fndecl 0-2 26938 NULL
+granularity_vx_ibl_info_26939_fields granularity vx_ibl_info 0 26939 NULL
+tx_nr_pages_bnxt_26942_fields tx_nr_pages bnxt 0 26942 NULL
+il4965_pass_packet_to_mac80211_fndecl_26945_fields il4965_pass_packet_to_mac80211 fndecl 3 26945 NULL
+br_vlan_set_default_pvid_fndecl_26946_fields br_vlan_set_default_pvid fndecl 2 26946 NULL nohasharray
+chunk_size_drxk_config_26946_fields chunk_size drxk_config 0 26946 &br_vlan_set_default_pvid_fndecl_26946_fields
+stripe_set_idx_fndecl_26948_fields stripe_set_idx fndecl 1 26948 NULL
+width_v4l2_pix_format_mplane_26950_fields width v4l2_pix_format_mplane 0 26950 NULL
+cid_cnic_context_26952_fields cid cnic_context 0 26952 NULL
+bulk_out_endp_ttusbir_26955_fields bulk_out_endp ttusbir 0 26955 NULL nohasharray
+id_tps6586x_subdev_info_26955_fields id tps6586x_subdev_info 0 26955 &bulk_out_endp_ttusbir_26955_fields
+sky2_receive_fndecl_26956_fields sky2_receive fndecl 2 26956 NULL
+carl9170_rx_untie_data_fndecl_26958_fields carl9170_rx_untie_data fndecl 3 26958 NULL
+bulk_in_ep_bfusb_data_26959_fields bulk_in_ep bfusb_data 0 26959 NULL
+cfpkt_extr_trail_fndecl_26960_fields cfpkt_extr_trail fndecl 3 26960 NULL
+bt_sock_recvmsg_fndecl_26967_fields bt_sock_recvmsg fndecl 3 26967 NULL
+brk_mm_struct_26976_fields brk mm_struct 0 26976 NULL nohasharray
+init_allocator_fndecl_26976_fields init_allocator fndecl 3 26976 &brk_mm_struct_26976_fields
+ctrl_out_pipe_hfcusb_data_26981_fields ctrl_out_pipe hfcusb_data 0 26981 NULL
+num_waitchks_drm_tegra_submit_26983_fields num_waitchks drm_tegra_submit 0 26983 NULL
+skd_skreq_prep_buffering_fndecl_26987_fields skd_skreq_prep_buffering fndecl 3 26987 NULL
+__tipc_send_stream_fndecl_26990_fields __tipc_send_stream fndecl 3 26990 NULL nohasharray
+smb_sendv_fndecl_26990_fields smb_sendv fndecl 3 26990 &__tipc_send_stream_fndecl_26990_fields
+address_length_acpi_address64_attribute_26992_fields address_length acpi_address64_attribute 0 26992 NULL
+delete_empty_dnode_fndecl_26994_fields delete_empty_dnode fndecl 2 26994 NULL
+buffer_bytes_snd_card_asihpi_pcm_26997_fields buffer_bytes snd_card_asihpi_pcm 0 26997 NULL
+ser_write_chunk_vardecl_caif_serial_c_26999_fields ser_write_chunk vardecl_caif_serial.c 0 26999 NULL
+get_mpc_size_fndecl_27000_fields get_mpc_size fndecl 0 27000 NULL
+task_array_size_cnic_local_27004_fields task_array_size cnic_local 0 27004 NULL
+n_tty_receive_buf_common_fndecl_27013_fields n_tty_receive_buf_common fndecl 4 27013 NULL
+nfs4_set_security_label_fndecl_27018_fields nfs4_set_security_label fndecl 3 27018 NULL
+ath6kl_cfg80211_connect_event_fndecl_27024_fields ath6kl_cfg80211_connect_event fndecl 9-8 27024 NULL
+dx_fb_copyarea_27025_fields dx fb_copyarea 0 27025 NULL
+shift_radix_tree_node_27029_fields shift radix_tree_node 0 27029 NULL nohasharray
+__bufio_new_fndecl_27029_fields __bufio_new fndecl 2 27029 &shift_radix_tree_node_27029_fields
+overhead_sctp_packet_27032_fields overhead sctp_packet 0 27032 NULL
+rdma_rw_ctx_signature_init_fndecl_27033_fields rdma_rw_ctx_signature_init fndecl 9 27033 NULL
+read_capacity_16_fndecl_27039_fields read_capacity_16 fndecl 0 27039 NULL
+device_pci_dev_27044_fields device pci_dev 0 27044 NULL
+ext_prop_data_store_fndecl_27045_fields ext_prop_data_store fndecl 3 27045 NULL
+remains_vardecl_initramfs_c_27049_fields remains vardecl_initramfs.c 0 27049 NULL
+brcmf_sdiod_ramrw_fndecl_27055_fields brcmf_sdiod_ramrw fndecl 5-3 27055 NULL
+indices_fm10k_ring_feature_27057_fields indices fm10k_ring_feature 0 27057 NULL
+iscsi_post_host_event_fndecl_27058_fields iscsi_post_host_event fndecl 4 27058 NULL
+ife_get_sz_fndecl_27062_fields ife_get_sz fndecl 0 27062 NULL
+sb_init_dio_done_wq_fndecl_27065_fields sb_init_dio_done_wq fndecl 0 27065 NULL
+new_layout_mddev_27083_fields new_layout mddev 0 27083 NULL
+max_wqes_rqes_per_q_ocrdma_mbx_query_config_27086_fields max_wqes_rqes_per_q ocrdma_mbx_query_config 0 27086 NULL
+far_set_size_geom_27088_fields far_set_size geom 0 27088 NULL
+vid_hdr_aloffset_ubi_device_27089_fields vid_hdr_aloffset ubi_device 0 27089 NULL
+mei_devt_vardecl_main_c_27090_fields mei_devt vardecl_main.c 0 27090 NULL nohasharray
+file_size_perf_mmap_event_27090_fields file_size perf_mmap_event 0 27090 &mei_devt_vardecl_main_c_27090_fields
+num_counters_compat_arpt_replace_27091_fields num_counters compat_arpt_replace 0 27091 NULL
+native_chipselects_mpc8xxx_spi_27093_fields native_chipselects mpc8xxx_spi 0 27093 NULL
+__btrfs_alloc_chunk_fndecl_27105_fields __btrfs_alloc_chunk fndecl 3 27105 NULL nohasharray
+i_suballoc_bit_ocfs2_dinode_27105_fields i_suballoc_bit ocfs2_dinode 0 27105 &__btrfs_alloc_chunk_fndecl_27105_fields
+iser_max_sectors_vardecl_27108_fields iser_max_sectors vardecl 0 27108 NULL
+len_lpfc_debug_27115_fields len lpfc_debug 0 27115 NULL nohasharray
+usb_hcd_link_urb_to_ep_fndecl_27115_fields usb_hcd_link_urb_to_ep fndecl 0 27115 &len_lpfc_debug_27115_fields
+gpa_gfn_to_hva_cache_27125_fields gpa gfn_to_hva_cache 0 27125 NULL
+mwifiex_sdio_card_to_host_fndecl_27127_fields mwifiex_sdio_card_to_host fndecl 4 27127 NULL nohasharray
+non_atomic_pte_lookup_fndecl_27127_fields non_atomic_pte_lookup fndecl 2 27127 &mwifiex_sdio_card_to_host_fndecl_27127_fields
+pd_count_ocrdma_alloc_pd_range_rsp_27128_fields pd_count ocrdma_alloc_pd_range_rsp 0 27128 NULL
+sys32_fadvise64_fndecl_27136_fields sys32_fadvise64 fndecl 4 27136 NULL
+mtu_rfcomm_dlc_27139_fields mtu rfcomm_dlc 0 27139 NULL nohasharray
+mappable_base_i915_ggtt_27139_fields mappable_base i915_ggtt 0 27139 &mtu_rfcomm_dlc_27139_fields nohasharray
+dwc_get_residue_fndecl_27139_fields dwc_get_residue fndecl 0 27139 &mappable_base_i915_ggtt_27139_fields
+rx_ps_bsize0_e1000_adapter_27144_fields rx_ps_bsize0 e1000_adapter 0 27144 NULL
+_nfs4_proc_readdir_fndecl_27153_fields _nfs4_proc_readdir fndecl 5 27153 NULL
+xor_align_dma_device_27155_fields xor_align dma_device 0 27155 NULL nohasharray
+dgram_recvmsg_fndecl_27155_fields dgram_recvmsg fndecl 3 27155 &xor_align_dma_device_27155_fields
+total_h_mt9m001_27157_fields total_h mt9m001 0 27157 NULL
+len_nf_ct_ext_type_27159_fields len nf_ct_ext_type 0 27159 NULL
+helper_name_len_drbd_helper_info_27161_fields helper_name_len drbd_helper_info 0 27161 NULL
+bbRcvSizeLsb_csp_27167_fields bbRcvSizeLsb csp 0 27167 NULL
+len_rdesc0_27169_fields len rdesc0 0 27169 NULL
+cow_start_ocfs2_cow_context_27171_fields cow_start ocfs2_cow_context 0 27171 NULL
+bnep_send_fndecl_27175_fields bnep_send fndecl 3 27175 NULL
+e100_change_mtu_fndecl_27180_fields e100_change_mtu fndecl 2 27180 NULL
+compat_sys_ftruncate_fndecl_27189_fields compat_sys_ftruncate fndecl 2 27189 NULL
+brcmf_sdio_bus_txctl_fndecl_27192_fields brcmf_sdio_bus_txctl fndecl 3 27192 NULL
+write_tty_operations_27198_fields write tty_operations 0 27198 NULL nohasharray
+caif_stream_recvmsg_fndecl_27198_fields caif_stream_recvmsg fndecl 3 27198 &write_tty_operations_27198_fields
+netup_unidvb_dma_init_fndecl_27199_fields netup_unidvb_dma_init fndecl 2 27199 NULL
+tpm_tis_spi_read_bytes_fndecl_27206_fields tpm_tis_spi_read_bytes fndecl 3 27206 NULL
+ath6kl_wmi_scanparams_cmd_fndecl_27208_fields ath6kl_wmi_scanparams_cmd fndecl 2 27208 NULL
+__ext4_read_dirblock_fndecl_27210_fields __ext4_read_dirblock fndecl 2 27210 NULL
+nr_bos_drm_etnaviv_gem_submit_27211_fields nr_bos drm_etnaviv_gem_submit 0 27211 NULL
+block_size_scsi_tape_27212_fields block_size scsi_tape 0 27212 NULL
+num_prior_parent_snaps_ceph_mds_snap_realm_27215_fields num_prior_parent_snaps ceph_mds_snap_realm 0 27215 NULL
+sdio_memcpy_fromio_fndecl_27218_fields sdio_memcpy_fromio fndecl 4 27218 NULL
+sym_prepare_nego_fndecl_27219_fields sym_prepare_nego fndecl 0 27219 NULL
+bm_bn_xfs_buf_map_27223_fields bm_bn xfs_buf_map 0 27223 NULL
+gsm_dlci_data_fndecl_27224_fields gsm_dlci_data fndecl 3 27224 NULL
+arm_db_page_mthca_create_cq_27227_fields arm_db_page mthca_create_cq 0 27227 NULL
+iwl_store_ucode_sec_fndecl_27235_fields iwl_store_ucode_sec fndecl 4 27235 NULL
+qib_cfgctxts_vardecl_27236_fields qib_cfgctxts vardecl 0 27236 NULL nohasharray
+acks_winsz_rxrpc_call_27236_fields acks_winsz rxrpc_call 0 27236 &qib_cfgctxts_vardecl_27236_fields
+do_splice_fndecl_27239_fields do_splice fndecl 5 27239 NULL
+hfsplus_brec_find_fndecl_27243_fields hfsplus_brec_find fndecl 0 27243 NULL
+name_len_ceph_mds_reply_dir_entry_27245_fields name_len ceph_mds_reply_dir_entry 0 27245 NULL
+sisusb_recv_bulk_msg_fndecl_27246_fields sisusb_recv_bulk_msg fndecl 3-2 27246 NULL
+skb_read_pdu_data_fndecl_27249_fields skb_read_pdu_data fndecl 4 27249 NULL
+zoneshift_alauda_card_info_27252_fields zoneshift alauda_card_info 0 27252 NULL nohasharray
+ocfs2_xattr_value_truncate_fndecl_27252_fields ocfs2_xattr_value_truncate fndecl 3 27252 &zoneshift_alauda_card_info_27252_fields
+amb_base_i5k_amb_data_27255_fields amb_base i5k_amb_data 0 27255 NULL
+num_tx_qs_be_adapter_27257_fields num_tx_qs be_adapter 0 27257 NULL
+__platform_create_bundle_fndecl_27260_fields __platform_create_bundle fndecl 6-4 27260 NULL
+sector_drbd_interval_27266_fields sector drbd_interval 0 27266 NULL
+alloc_swapdev_block_fndecl_27267_fields alloc_swapdev_block fndecl 0 27267 NULL
+truesize_iwl_rx_cmd_buffer_27273_fields truesize iwl_rx_cmd_buffer 0 27273 NULL
+bios_hardcoded_edid_size_amdgpu_mode_info_27277_fields bios_hardcoded_edid_size amdgpu_mode_info 0 27277 NULL
+netxen_process_rcv_fndecl_27279_fields netxen_process_rcv fndecl 4 27279 NULL
+alloc_async_fndecl_27283_fields alloc_async fndecl 1 27283 NULL
+sector_r10bio_27298_fields sector r10bio 0 27298 NULL
+offset_mlx5_ib_wq_27302_fields offset mlx5_ib_wq 0 27302 NULL
+ath6kl_connect_event_fndecl_27304_fields ath6kl_connect_event fndecl 7-9-8 27304 NULL
+gpu_mem_size_vml_par_27308_fields gpu_mem_size vml_par 0 27308 NULL
+sctp_recvmsg_fndecl_27314_fields sctp_recvmsg fndecl 3 27314 NULL
+chunk_sectors_r5conf_27317_fields chunk_sectors r5conf 0 27317 NULL
+lpe_size_sst_pdata_27329_fields lpe_size sst_pdata 0 27329 NULL
+write_buffer_fndecl_27339_fields write_buffer fndecl 2-0 27339 NULL
+align_pad_cqe_rx_t_27341_fields align_pad cqe_rx_t 0 27341 NULL
+sndbuf_tun_struct_27345_fields sndbuf tun_struct 0 27345 NULL
+acpi_os_map_iomem_fndecl_27346_fields acpi_os_map_iomem fndecl 2-1 27346 NULL nohasharray
+add_numbered_child_fndecl_27346_fields add_numbered_child fndecl 7-8-3-5 27346 &acpi_os_map_iomem_fndecl_27346_fields
+pix_format_set_size_fndecl_27356_fields pix_format_set_size fndecl 3-4 27356 NULL
+static_data_priv_len_wl1271_27357_fields static_data_priv_len wl1271 0 27357 NULL
+xfs_bmap_last_offset_fndecl_27364_fields xfs_bmap_last_offset fndecl 0 27364 NULL
+find_new_extents_fndecl_27368_fields find_new_extents fndecl 5 27368 NULL
+channels_pda_pa_curve_data_27369_fields channels pda_pa_curve_data 0 27369 NULL nohasharray
+pci_iov_remove_virtfn_fndecl_27369_fields pci_iov_remove_virtfn fndecl 2 27369 &channels_pda_pa_curve_data_27369_fields
+num_altsetting_usb_interface_27371_fields num_altsetting usb_interface 0 27371 NULL
+mod_len_ccp_rsa_engine_27374_fields mod_len ccp_rsa_engine 0 27374 NULL nohasharray
+urb_size_tm6000_core_27374_fields urb_size tm6000_core 0 27374 &mod_len_ccp_rsa_engine_27374_fields
+dwNtbOutMaxSize_usb_cdc_ncm_ntb_parameters_27384_fields dwNtbOutMaxSize usb_cdc_ncm_ntb_parameters 0 27384 NULL
+frame_size_audioformat_27394_fields frame_size audioformat 0 27394 NULL
+ccid_kmem_cache_create_fndecl_27397_fields ccid_kmem_cache_create fndecl 1 27397 NULL
+iscsit_xmit_nondatain_pdu_fndecl_27400_fields iscsit_xmit_nondatain_pdu fndecl 4 27400 NULL
+btrfs_copy_from_user_fndecl_27405_fields btrfs_copy_from_user fndecl 0-1-2 27405 NULL nohasharray
+m_bsize_xfs_mount_27405_fields m_bsize xfs_mount 0 27405 &btrfs_copy_from_user_fndecl_27405_fields
+max_payload_rpc_xprt_27408_fields max_payload rpc_xprt 0 27408 NULL
+bucket_table_alloc_fndecl_27422_fields bucket_table_alloc fndecl 2 27422 NULL
+service_name_len_nfc_llcp_sock_27424_fields service_name_len nfc_llcp_sock 0 27424 NULL nohasharray
+dst_frames_snd_pcm_plugin_27424_fields dst_frames snd_pcm_plugin 0 27424 &service_name_len_nfc_llcp_sock_27424_fields
+build_virtual_key_fndecl_27427_fields build_virtual_key fndecl 2 27427 NULL
+ad9523_read_fndecl_27434_fields ad9523_read fndecl 2 27434 NULL
+__fsnotify_parent_fndecl_27437_fields __fsnotify_parent fndecl 0 27437 NULL nohasharray
+qp_memcpy_to_queue_fndecl_27437_fields qp_memcpy_to_queue fndecl 5-2 27437 &__fsnotify_parent_fndecl_27437_fields
+regmap_spi_async_write_fndecl_27439_fields regmap_spi_async_write fndecl 3-5 27439 NULL
+produce_size_vmci_qp_alloc_info_vmvm_27440_fields produce_size vmci_qp_alloc_info_vmvm 0 27440 NULL
+mpwqe_log_num_strides_mlx5e_params_27444_fields mpwqe_log_num_strides mlx5e_params 0 27444 NULL
+radeon_vm_block_size_vardecl_27445_fields radeon_vm_block_size vardecl 0 27445 NULL
+lpfc_sriov_nr_virtfn_vardecl_lpfc_attr_c_27446_fields lpfc_sriov_nr_virtfn vardecl_lpfc_attr.c 0 27446 NULL
+dm_table_get_num_targets_fndecl_27451_fields dm_table_get_num_targets fndecl 0 27451 NULL
+fec_read_bufs_fndecl_27452_fields fec_read_bufs fndecl 3 27452 NULL
+set_offset_v2_k_type_fndecl_27455_fields set_offset_v2_k_type fndecl 2 27455 NULL nohasharray
+num_modes_max1363_chip_info_27455_fields num_modes max1363_chip_info 0 27455 &set_offset_v2_k_type_fndecl_27455_fields
+xfs_dir3_data_init_fndecl_27460_fields xfs_dir3_data_init fndecl 2 27460 NULL
+io_opt_queue_limits_27462_fields io_opt queue_limits 0 27462 NULL
+next_header_vardecl_initramfs_c_27464_fields next_header vardecl_initramfs.c 0 27464 NULL
+uar_page_sz_mlx4_init_hca_param_27465_fields uar_page_sz mlx4_init_hca_param 0 27465 NULL
+max_slots_nfs4_slot_table_27470_fields max_slots nfs4_slot_table 0 27470 NULL
+window_alignment_fndecl_27476_fields window_alignment fndecl 0 27476 NULL
+size_btrfs_ioctl_ino_path_args_27477_fields size btrfs_ioctl_ino_path_args 0 27477 NULL
+image_swsusp_header_27481_fields image swsusp_header 0 27481 NULL
+min_pnp_mem_27484_fields min pnp_mem 0 27484 NULL
+kim_int_recv_fndecl_27486_fields kim_int_recv fndecl 3 27486 NULL nohasharray
+snd_seq_fifo_resize_fndecl_27486_fields snd_seq_fifo_resize fndecl 2 27486 &kim_int_recv_fndecl_27486_fields
+status_udc_data_dma_27488_fields status udc_data_dma 0 27488 NULL
+local_nentries_xpc_channel_27489_fields local_nentries xpc_channel 0 27489 NULL nohasharray
+drbd_send_drequest_csum_fndecl_27489_fields drbd_send_drequest_csum fndecl 5 27489 &local_nentries_xpc_channel_27489_fields
+pool_rsvd_cxgbi_ppm_27491_fields pool_rsvd cxgbi_ppm 0 27491 NULL
+wb_index_nfs_page_27494_fields wb_index nfs_page 0 27494 NULL
+ocfs2_xa_value_truncate_fndecl_27495_fields ocfs2_xa_value_truncate fndecl 2 27495 NULL
+qib_mmap_mem_fndecl_27496_fields qib_mmap_mem fndecl 3 27496 NULL
+max_qp_sz_mthca_dev_lim_27511_fields max_qp_sz mthca_dev_lim 0 27511 NULL
+stripe_len_map_lookup_27512_fields stripe_len map_lookup 0 27512 NULL
+vis_h_yuv_frame_info_27514_fields vis_h yuv_frame_info 0 27514 NULL
+com90xx_found_fndecl_27525_fields com90xx_found fndecl 3 27525 NULL
+eeprom_size_netdev_private_27532_fields eeprom_size netdev_private 0 27532 NULL
+hlen_raw6_frag_vec_27535_fields hlen raw6_frag_vec 0 27535 NULL
+hsr_dev_change_mtu_fndecl_27537_fields hsr_dev_change_mtu fndecl 2 27537 NULL
+dwc2_hsotg_rx_data_fndecl_27540_fields dwc2_hsotg_rx_data fndecl 3 27540 NULL
+max_mem_ttm_mem_zone_27542_fields max_mem ttm_mem_zone 0 27542 NULL nohasharray
+onenand_mlc_read_ops_nolock_fndecl_27542_fields onenand_mlc_read_ops_nolock fndecl 2 27542 &max_mem_ttm_mem_zone_27542_fields
+sr_write_fndecl_27546_fields sr_write fndecl 3 27546 NULL
+snd_pcm_plug_slave_size_fndecl_27548_fields snd_pcm_plug_slave_size fndecl 0-2 27548 NULL
+remap_and_issue_fndecl_27555_fields remap_and_issue fndecl 3 27555 NULL
+total_cpus_vardecl_27560_fields total_cpus vardecl 0 27560 NULL
+pipe_in_rtl8xxxu_priv_27564_fields pipe_in rtl8xxxu_priv 0 27564 NULL
+sddr09_write_data_fndecl_27565_fields sddr09_write_data fndecl 2 27565 NULL
+size_gf100_gr_fuc_27570_fields size gf100_gr_fuc 0 27570 NULL
+disabled_cpus_vardecl_27577_fields disabled_cpus vardecl 0 27577 NULL
+count_cxgbi_task_data_27578_fields count cxgbi_task_data 0 27578 NULL
+gfx_v8_0_get_csb_size_fndecl_27579_fields gfx_v8_0_get_csb_size fndecl 0 27579 NULL nohasharray
+dev_count_vardecl_smsc_ircc2_c_27579_fields dev_count vardecl_smsc-ircc2.c 0 27579 &gfx_v8_0_get_csb_size_fndecl_27579_fields
+nregions_vhost_memory_27586_fields nregions vhost_memory 0 27586 NULL
+phys_addr_rio_mport_mapping_27591_fields phys_addr rio_mport_mapping 0 27591 NULL
+xfs_bmap_alloc_fndecl_27599_fields xfs_bmap_alloc fndecl 0 27599 NULL
+btrfs_get_blocks_direct_fndecl_27603_fields btrfs_get_blocks_direct fndecl 2 27603 NULL
+_rtl92s_firmware_downloadcode_fndecl_27606_fields _rtl92s_firmware_downloadcode fndecl 3 27606 NULL
+packet_length_gl_packet_27608_fields packet_length gl_packet 0 27608 NULL nohasharray
+max_tc_mlx5e_profile_27608_fields max_tc mlx5e_profile 0 27608 &packet_length_gl_packet_27608_fields nohasharray
+EraseSize_INFTLrecord_27608_fields EraseSize INFTLrecord 0 27608 &max_tc_mlx5e_profile_27608_fields
+netvsc_alloc_recv_skb_fndecl_27610_fields netvsc_alloc_recv_skb fndecl 5 27610 NULL
+read_isac_isac_27627_fields read_isac isac 0 27627 NULL
+data_length_se_cmd_27629_fields data_length se_cmd 0 27629 NULL
+group_size_rcv_array_data_27633_fields group_size rcv_array_data 0 27633 NULL
+st_scsi_execute_fndecl_27643_fields st_scsi_execute fndecl 5 27643 NULL
+bsize_videobuf_buffer_27645_fields bsize videobuf_buffer 0 27645 NULL
+period_frames_usb_stream_config_27656_fields period_frames usb_stream_config 0 27656 NULL
+WriteRegs_fndecl_27658_fields WriteRegs fndecl 4 27658 NULL
+xen_get_pages_limit_fndecl_27661_fields xen_get_pages_limit fndecl 0 27661 NULL
+ceph_osdc_wait_request_fndecl_27663_fields ceph_osdc_wait_request fndecl 0 27663 NULL
+efx_ef10_mem_map_size_fndecl_27664_fields efx_ef10_mem_map_size fndecl 0 27664 NULL
+size_compat_ip6t_replace_27672_fields size compat_ip6t_replace 0 27672 NULL
+ib_umem_get_fndecl_27678_fields ib_umem_get fndecl 2-3 27678 NULL
+bnx2x_iov_init_one_fndecl_27687_fields bnx2x_iov_init_one fndecl 3 27687 NULL
+mt9m111_get_global_gain_fndecl_27689_fields mt9m111_get_global_gain fndecl 0 27689 NULL
+ipv6_get_l4proto_fndecl_27691_fields ipv6_get_l4proto fndecl 2 27691 NULL
+mru_ppp_27697_fields mru ppp 0 27697 NULL
+rx_buf_sz_de_private_27701_fields rx_buf_sz de_private 0 27701 NULL
+snd_pcm_plugin_alloc_fndecl_27703_fields snd_pcm_plugin_alloc fndecl 2 27703 NULL
+actual_size_mlx4_en_rx_ring_27705_fields actual_size mlx4_en_rx_ring 0 27705 NULL
+sequence_num_usb_ftdi_27707_fields sequence_num usb_ftdi 0 27707 NULL
+niu_rx_skb_append_fndecl_27708_fields niu_rx_skb_append fndecl 4-5-3 27708 NULL
+ns83820_change_mtu_fndecl_27711_fields ns83820_change_mtu fndecl 2 27711 NULL
+sdhci_pltfm_init_fndecl_27712_fields sdhci_pltfm_init fndecl 3 27712 NULL
+ioat_dca_count_dca_slots_fndecl_27732_fields ioat_dca_count_dca_slots fndecl 0 27732 NULL
+ieee80211_ie_split_vendor_fndecl_27738_fields ieee80211_ie_split_vendor fndecl 0-3 27738 NULL nohasharray
+qla27xx_fwdt_calculate_dump_size_fndecl_27738_fields qla27xx_fwdt_calculate_dump_size fndecl 0 27738 &ieee80211_ie_split_vendor_fndecl_27738_fields
+word_size_e1000_eeprom_info_27741_fields word_size e1000_eeprom_info 0 27741 NULL
+sparse_mem_maps_populate_node_fndecl_27758_fields sparse_mem_maps_populate_node fndecl 4 27758 NULL
+pool_ns_len_ceph_mds_reply_info_in_27761_fields pool_ns_len ceph_mds_reply_info_in 0 27761 NULL
+nr_sendmsg_fndecl_27763_fields nr_sendmsg fndecl 3 27763 NULL
+h_drm_vmw_rect_27765_fields h drm_vmw_rect 0 27765 NULL
+instat_endpoint_keyspan_device_details_27768_fields instat_endpoint keyspan_device_details 0 27768 NULL nohasharray
+wb_create_fndecl_27768_fields wb_create fndecl 1 27768 &instat_endpoint_keyspan_device_details_27768_fields
+be_queue_alloc_fndecl_27771_fields be_queue_alloc fndecl 3 27771 NULL
+max_cyttsp4_tch_abs_params_27772_fields max cyttsp4_tch_abs_params 0 27772 NULL
+rs_datalen_ath_rx_status_27774_fields rs_datalen ath_rx_status 0 27774 NULL
+vlan_qos_vlan_priority_tci_mapping_27789_fields vlan_qos vlan_priority_tci_mapping 0 27789 NULL nohasharray
+ext4_bg_num_gdb_meta_fndecl_27789_fields ext4_bg_num_gdb_meta fndecl 0 27789 &vlan_qos_vlan_priority_tci_mapping_27789_fields
+flags_mmio_74xx_gpio_priv_27797_fields flags mmio_74xx_gpio_priv 0 27797 NULL
+nilfs_segbuf_set_next_segnum_fndecl_27802_fields nilfs_segbuf_set_next_segnum fndecl 2 27802 NULL
+bm_offset_drbd_md_27803_fields bm_offset drbd_md 0 27803 NULL
+e1000_receive_skb_fndecl_27809_fields e1000_receive_skb fndecl 3 27809 NULL
+ivtv_write_fndecl_27810_fields ivtv_write fndecl 3 27810 NULL
+ule_sndu_remain_dvb_net_priv_27812_fields ule_sndu_remain dvb_net_priv 0 27812 NULL
+page_is_ram_fndecl_27814_fields page_is_ram fndecl 1 27814 NULL
+dm_block_manager_create_fndecl_27815_fields dm_block_manager_create fndecl 2 27815 NULL
+sqsize_nvme_ctrl_27819_fields sqsize nvme_ctrl 0 27819 NULL
+sizeimage_v4l2_pix_format_27824_fields sizeimage v4l2_pix_format 0 27824 NULL
+consumed_vringh_kiov_27828_fields consumed vringh_kiov 0 27828 NULL
+corruption_check_size_vardecl_check_c_27830_fields corruption_check_size vardecl_check.c 0 27830 NULL
+nfp_net_rx_alloc_one_fndecl_27831_fields nfp_net_rx_alloc_one fndecl 3 27831 NULL
+number_of_effective_blocks_ms_boot_attr_info_27832_fields number_of_effective_blocks ms_boot_attr_info 0 27832 NULL
+type_kqid_27833_fields type kqid 0 27833 NULL
+num_bcma_bus_27835_fields num bcma_bus 0 27835 NULL
+adm8211_tx_raw_fndecl_27839_fields adm8211_tx_raw fndecl 3-4 27839 NULL
+cfg_niq_csio_hw_27842_fields cfg_niq csio_hw 0 27842 NULL nohasharray
+__getblk_slow_fndecl_27842_fields __getblk_slow fndecl 3-2 27842 &cfg_niq_csio_hw_27842_fields
+dd_bsg_size_fc_function_template_27852_fields dd_bsg_size fc_function_template 0 27852 NULL
+size_pnp_port_27856_fields size pnp_port 0 27856 NULL
+xfs_da3_node_read_fndecl_27858_fields xfs_da3_node_read fndecl 3 27858 NULL
+ngroups_rcv_array_data_27872_fields ngroups rcv_array_data 0 27872 NULL nohasharray
+max_slave_count_w1_master_27872_fields max_slave_count w1_master 0 27872 &ngroups_rcv_array_data_27872_fields
+lo_len_nfsd4_lookup_27874_fields lo_len nfsd4_lookup 0 27874 NULL
+l_blkno_lbuf_27876_fields l_blkno lbuf 0 27876 NULL
+msb_sg_copy_fndecl_27886_fields msb_sg_copy fndecl 5-4 27886 NULL
+_rotate_left_fndecl_27889_fields _rotate_left fndecl 2 27889 NULL
+num_regions_vfio_pci_device_27890_fields num_regions vfio_pci_device 0 27890 NULL
+brcmf_debug_create_memdump_fndecl_27901_fields brcmf_debug_create_memdump fndecl 3 27901 NULL
+rvt_resize_cq_fndecl_27904_fields rvt_resize_cq fndecl 2 27904 NULL nohasharray
+__lbs_cmd_fndecl_27904_fields __lbs_cmd fndecl 4 27904 &rvt_resize_cq_fndecl_27904_fields
+reada_tree_block_flagged_fndecl_27912_fields reada_tree_block_flagged fndecl 2 27912 NULL
+tp_datalen_bcm5974_config_27927_fields tp_datalen bcm5974_config 0 27927 NULL
+numchips_lpddr_private_27938_fields numchips lpddr_private 0 27938 NULL
+get_burstcount_fndecl_27942_fields get_burstcount fndecl 0 27942 NULL nohasharray
+capacity_cdrom_device_info_27942_fields capacity cdrom_device_info 0 27942 &get_burstcount_fndecl_27942_fields
+handle_mm_fault_fndecl_27947_fields handle_mm_fault fndecl 2 27947 NULL
+total_nand_ecc_ctrl_27951_fields total nand_ecc_ctrl 0 27951 NULL
+usbat_hp8200e_rw_block_test_fndecl_27957_fields usbat_hp8200e_rw_block_test fndecl 12 27957 NULL
+size_plx_pci_channel_map_27958_fields size plx_pci_channel_map 0 27958 NULL
+xfs_bmap_last_extent_fndecl_27964_fields xfs_bmap_last_extent fndecl 0 27964 NULL
+fat_build_inode_fndecl_27970_fields fat_build_inode fndecl 3 27970 NULL
+iip_ubifs_znode_27974_fields iip ubifs_znode 0 27974 NULL
+sxgbe_init_rx_buffers_fndecl_27984_fields sxgbe_init_rx_buffers fndecl 4 27984 NULL
+ext4_seek_hole_fndecl_27990_fields ext4_seek_hole fndecl 2 27990 NULL
+write_mei_hw_ops_27991_fields write mei_hw_ops 0 27991 NULL
+credits_send_context_27993_fields credits send_context 0 27993 NULL nohasharray
+alloc_ccbs_blogic_adapter_27993_fields alloc_ccbs blogic_adapter 0 27993 &credits_send_context_27993_fields
+cumulative_size_wm_adsp_buffer_region_27998_fields cumulative_size wm_adsp_buffer_region 0 27998 NULL
+page_count_scrub_block_28000_fields page_count scrub_block 0 28000 NULL nohasharray
+ubifs_end_scan_fndecl_28000_fields ubifs_end_scan fndecl 4 28000 &page_count_scrub_block_28000_fields
+max_x_fb_monspecs_28003_fields max_x fb_monspecs 0 28003 NULL
+bytes_str_to_int_fndecl_28004_fields bytes_str_to_int fndecl 0 28004 NULL
+resp_ie_len_brcmf_cfg80211_connect_info_28007_fields resp_ie_len brcmf_cfg80211_connect_info 0 28007 NULL
+memtest_fndecl_28012_fields memtest fndecl 2 28012 NULL
+ext4_bg_num_gdb_nometa_fndecl_28014_fields ext4_bg_num_gdb_nometa fndecl 0 28014 NULL
+iwl_read_prph_no_grab_fndecl_28026_fields iwl_read_prph_no_grab fndecl 0 28026 NULL
+assign_irq_fndecl_28035_fields assign_irq fndecl 1 28035 NULL
+min_size_vx_ibl_info_28043_fields min_size vx_ibl_info 0 28043 NULL
+new_chunk_dm_exception_28044_fields new_chunk dm_exception 0 28044 NULL
+num_intr_mic_intr_info_28048_fields num_intr mic_intr_info 0 28048 NULL
+vc_top_vc_data_28051_fields vc_top vc_data 0 28051 NULL
+virtio_gpu_cmd_set_scanout_fndecl_28053_fields virtio_gpu_cmd_set_scanout fndecl 4-5 28053 NULL
+maxpacket_usbnet_28054_fields maxpacket usbnet 0 28054 NULL
+cl_nodelen_rpc_clnt_28055_fields cl_nodelen rpc_clnt 0 28055 NULL
+xfs_end_io_direct_write_fndecl_28060_fields xfs_end_io_direct_write fndecl 3-2 28060 NULL
+gfs2_llseek_fndecl_28067_fields gfs2_llseek fndecl 2 28067 NULL
+nr_cmds_drm_msm_gem_submit_28071_fields nr_cmds drm_msm_gem_submit 0 28071 NULL
+rsi_prepare_skb_fndecl_28075_fields rsi_prepare_skb fndecl 4-3 28075 NULL
+qla4_82xx_pci_mem_write_direct_fndecl_28076_fields qla4_82xx_pci_mem_write_direct fndecl 2 28076 NULL
+abituguru_detect_fndecl_28078_fields abituguru_detect fndecl 0 28078 NULL
+bio_slab_max_vardecl_bio_c_28087_fields bio_slab_max vardecl_bio.c 0 28087 NULL
+ddr_start_mthca_dev_28088_fields ddr_start mthca_dev 0 28088 NULL
+xlog_state_get_iclog_space_fndecl_28090_fields xlog_state_get_iclog_space fndecl 2 28090 NULL
+vxfs_read_olt_fndecl_28091_fields vxfs_read_olt fndecl 2 28091 NULL
+llcp_sock_recvmsg_fndecl_28095_fields llcp_sock_recvmsg fndecl 3 28095 NULL
+vmw_fb_create_bo_fndecl_28101_fields vmw_fb_create_bo fndecl 2 28101 NULL
+ath6kl_wmi_set_wmm_txop_fndecl_28102_fields ath6kl_wmi_set_wmm_txop fndecl 2 28102 NULL
+udf_check_anchor_block_fndecl_28107_fields udf_check_anchor_block fndecl 2 28107 NULL
+gru_alloc_thread_state_fndecl_28109_fields gru_alloc_thread_state fndecl 2 28109 NULL
+ufs_inode_getfrag_fndecl_28110_fields ufs_inode_getfrag fndecl 3-0 28110 NULL nohasharray
+nfs_readdir_make_qstr_fndecl_28110_fields nfs_readdir_make_qstr fndecl 3 28110 &ufs_inode_getfrag_fndecl_28110_fields
+comm_base_mlx4_fw_28125_fields comm_base mlx4_fw 0 28125 NULL
+xfs_get_extsz_hint_fndecl_28128_fields xfs_get_extsz_hint fndecl 0 28128 NULL
+wLength_usb_ctrlrequest_28143_fields wLength usb_ctrlrequest 0 28143 NULL
+unit_size_pcpu_alloc_info_28146_fields unit_size pcpu_alloc_info 0 28146 NULL
+adv_smbus_read_byte_data_fndecl_28147_fields adv_smbus_read_byte_data fndecl 0 28147 NULL
+cur_page_offset_dio_submit_28153_fields cur_page_offset dio_submit 0 28153 NULL
+bNumPorts_usb_wa_descriptor_28154_fields bNumPorts usb_wa_descriptor 0 28154 NULL
+pipe_intr_lan78xx_net_28155_fields pipe_intr lan78xx_net 0 28155 NULL
+af9013_rd_regs_fndecl_28157_fields af9013_rd_regs fndecl 4 28157 NULL
+sock_hlen_vhost_net_virtqueue_28159_fields sock_hlen vhost_net_virtqueue 0 28159 NULL
+aio_nbytes_iocb_28163_fields aio_nbytes iocb 0 28163 NULL
+x_drm_fb_helper_crtc_28166_fields x drm_fb_helper_crtc 0 28166 NULL
+_ocfs2_free_suballoc_bits_fndecl_28174_fields _ocfs2_free_suballoc_bits fndecl 5 28174 NULL
+__iscsi_conn_send_pdu_fndecl_28181_fields __iscsi_conn_send_pdu fndecl 4 28181 NULL
+res_length_dlm_rsb_28184_fields res_length dlm_rsb 0 28184 NULL
+fw_cid_ep_handles_28190_fields fw_cid ep_handles 0 28190 NULL
+ixgbe_fcoe_get_tc_fndecl_28191_fields ixgbe_fcoe_get_tc fndecl 0 28191 NULL
+size_genwqe_mem_28192_fields size genwqe_mem 0 28192 NULL
+cirrus_gem_create_fndecl_28197_fields cirrus_gem_create fndecl 2 28197 NULL nohasharray
+next_power_fndecl_28197_fields next_power fndecl 0 28197 &cirrus_gem_create_fndecl_28197_fields
+snd_pcm_lib_preallocate_pages_for_all_fndecl_28203_fields snd_pcm_lib_preallocate_pages_for_all fndecl 4 28203 NULL
+region_shift_dm_region_hash_28205_fields region_shift dm_region_hash 0 28205 NULL
+ast_bo_create_fndecl_28209_fields ast_bo_create fndecl 2 28209 NULL
+lec_change_mtu_fndecl_28213_fields lec_change_mtu fndecl 2 28213 NULL
+blk_rq_map_sg_fndecl_28215_fields blk_rq_map_sg fndecl 0 28215 NULL
+mpt_base_mthca_mr_table_28221_fields mpt_base mthca_mr_table 0 28221 NULL
+s_blocksize_bits_super_block_28225_fields s_blocksize_bits super_block 0 28225 NULL
+space_slots_btrfs_ioctl_space_args_28231_fields space_slots btrfs_ioctl_space_args 0 28231 NULL
+mux_device_request_fndecl_28235_fields mux_device_request fndecl 7 28235 NULL nohasharray
+l2cap_mtu_vardecl_core_c_28235_fields l2cap_mtu vardecl_core.c 0 28235 &mux_device_request_fndecl_28235_fields
+bits_mpidr_hash_28236_fields bits mpidr_hash 0 28236 NULL
+old_addr_inmem_pages_28238_fields old_addr inmem_pages 0 28238 NULL
+loop_end_patch_info_28242_fields loop_end patch_info 0 28242 NULL
+btrfs_qgroup_free_data_fndecl_28246_fields btrfs_qgroup_free_data fndecl 2-3 28246 NULL nohasharray
+ino_bfs_dirent_28246_fields ino bfs_dirent 0 28246 &btrfs_qgroup_free_data_fndecl_28246_fields
+bcm_tx_send_fndecl_28258_fields bcm_tx_send fndecl 4 28258 NULL
+count_e1000_tx_ring_28261_fields count e1000_tx_ring 0 28261 NULL nohasharray
+ea_set_i_fndecl_28261_fields ea_set_i fndecl 5 28261 &count_e1000_tx_ring_28261_fields
+flags_rxe_bth_28263_fields flags rxe_bth 0 28263 NULL
+x1_osd_cmd_s_28266_fields x1 osd_cmd_s 0 28266 NULL
+mt7601u_rx_process_seg_fndecl_28268_fields mt7601u_rx_process_seg fndecl 3 28268 NULL
+needed_headroom_net_device_28272_fields needed_headroom net_device 0 28272 NULL
+rxbufsize_dma_info_28275_fields rxbufsize dma_info 0 28275 NULL
+mtu_tipc_bearer_28279_fields mtu tipc_bearer 0 28279 NULL
+buf_start_hi_rx_buf_desc_28282_fields buf_start_hi rx_buf_desc 0 28282 NULL nohasharray
+reg_start_ath6kl_diag_reg_info_28282_fields reg_start ath6kl_diag_reg_info 0 28282 &buf_start_hi_rx_buf_desc_28282_fields
+read32_ssb_bus_ops_28292_fields read32 ssb_bus_ops 0 28292 NULL
+save_total_len_pch_spi_data_28296_fields save_total_len pch_spi_data 0 28296 NULL
+flags2_psb_s_28305_fields flags2 psb_s 0 28305 NULL
+__xfs_get_blocks_fndecl_28308_fields __xfs_get_blocks fndecl 2 28308 NULL
+sst25l_read_fndecl_28315_fields sst25l_read fndecl 3 28315 NULL
+npages_mlx4_buf_28321_fields npages mlx4_buf 0 28321 NULL
+size_ORANGEFS_dev_map_desc_28323_fields size ORANGEFS_dev_map_desc 0 28323 NULL
+atmel_read_fndecl_28325_fields atmel_read fndecl 4 28325 NULL
+raw_descs_length_ffs_data_28328_fields raw_descs_length ffs_data 0 28328 NULL
+max_segment_size_brcmf_sdio_dev_28330_fields max_segment_size brcmf_sdio_dev 0 28330 NULL nohasharray
+size_videobuf_dmabuf_28330_fields size videobuf_dmabuf 0 28330 &max_segment_size_brcmf_sdio_dev_28330_fields
+asix_read_cmd_fndecl_28334_fields asix_read_cmd fndecl 5 28334 NULL
+ie_length_ndis_80211_bssid_ex_28346_fields ie_length ndis_80211_bssid_ex 0 28346 NULL
+irq_domain_alloc_irqs_recursive_fndecl_28349_fields irq_domain_alloc_irqs_recursive fndecl 0 28349 NULL
+c4iw_reg_user_mr_fndecl_28358_fields c4iw_reg_user_mr fndecl 2-3 28358 NULL
+pmcraid_notify_aen_fndecl_28361_fields pmcraid_notify_aen fndecl 3 28361 NULL
+carl9170_rx_fndecl_28363_fields carl9170_rx fndecl 3 28363 NULL
+kvm_lapic_enable_pv_eoi_fndecl_28370_fields kvm_lapic_enable_pv_eoi fndecl 2 28370 NULL
+snd_emu10k1_fx8010_tram_setup_fndecl_28371_fields snd_emu10k1_fx8010_tram_setup fndecl 2 28371 NULL
+count_atl1e_tx_ring_28372_fields count atl1e_tx_ring 0 28372 NULL nohasharray
+hostap_80211_get_hdrlen_fndecl_28372_fields hostap_80211_get_hdrlen fndecl 0 28372 &count_atl1e_tx_ring_28372_fields
+pktlen_rtl8xxxu_rxdesc16_28378_fields pktlen rtl8xxxu_rxdesc16 0 28378 NULL
+iova_ib_mr_28381_fields iova ib_mr 0 28381 NULL
+paddr_vmcoreinfo_note_fndecl_28388_fields paddr_vmcoreinfo_note fndecl 0 28388 NULL
+dst_uffdio_copy_28391_fields dst uffdio_copy 0 28391 NULL
+interrupt_in_endpointAddress_usb_serial_port_28398_fields interrupt_in_endpointAddress usb_serial_port 0 28398 NULL
+cxd2820r_rd_regs_fndecl_28402_fields cxd2820r_rd_regs fndecl 4 28402 NULL
+length_rxe_sge_28408_fields length rxe_sge 0 28408 NULL
+platform_device_add_resources_fndecl_28410_fields platform_device_add_resources fndecl 3 28410 NULL
+channel_bc_state_28411_fields channel bc_state 0 28411 NULL
+dma_size_cx25821_audio_dev_28423_fields dma_size cx25821_audio_dev 0 28423 NULL
+at24_eeprom_read_mac_fndecl_28426_fields at24_eeprom_read_mac fndecl 4 28426 NULL
+afs_fs_store_data64_fndecl_28429_fields afs_fs_store_data64 fndecl 5-6 28429 NULL
+jfs_issue_discard_fndecl_28440_fields jfs_issue_discard fndecl 3-2 28440 NULL
+sb_agcount_xfs_sb_28441_fields sb_agcount xfs_sb 0 28441 NULL nohasharray
+mgmt_event_fndecl_28441_fields mgmt_event fndecl 4 28441 &sb_agcount_xfs_sb_28441_fields
+iscsi_iser_session_create_fndecl_28447_fields iscsi_iser_session_create fndecl 3 28447 NULL
+mi_entries_per_block_nilfs_mdt_info_28458_fields mi_entries_per_block nilfs_mdt_info 0 28458 NULL nohasharray
+st_nci_hci_dm_vdc_value_comparison_fndecl_28458_fields st_nci_hci_dm_vdc_value_comparison fndecl 3 28458 &mi_entries_per_block_nilfs_mdt_info_28458_fields
+irda_connect_confirm_fndecl_28460_fields irda_connect_confirm fndecl 4-5 28460 NULL nohasharray
+high_rio_doorbell_filter_28460_fields high rio_doorbell_filter 0 28460 &irda_connect_confirm_fndecl_28460_fields
+pc87360_device_add_fndecl_28461_fields pc87360_device_add fndecl 1 28461 NULL
+md_offset_drbd_md_28466_fields md_offset drbd_md 0 28466 NULL
+osd_upper_vardecl_ivtvfb_c_28473_fields osd_upper vardecl_ivtvfb.c 0 28473 NULL nohasharray
+ath6kl_wmi_add_wow_pattern_cmd_fndecl_28473_fields ath6kl_wmi_add_wow_pattern_cmd fndecl 4-2 28473 &osd_upper_vardecl_ivtvfb_c_28473_fields
+pa_pstart_ext4_prealloc_space_28478_fields pa_pstart ext4_prealloc_space 0 28478 NULL nohasharray
+mgslpc_device_count_vardecl_synclink_cs_c_28478_fields mgslpc_device_count vardecl_synclink_cs.c 0 28478 &pa_pstart_ext4_prealloc_space_28478_fields
+block_size_sd_28480_fields block_size sd 0 28480 NULL
+amdgpu_align_pitch_fndecl_28483_fields amdgpu_align_pitch fndecl 0-2 28483 NULL
+service_map_len_wmi_svc_rdy_ev_arg_28484_fields service_map_len wmi_svc_rdy_ev_arg 0 28484 NULL
+wl1271_sdio_set_block_size_fndecl_28494_fields wl1271_sdio_set_block_size fndecl 2 28494 NULL
+len_sctp_tsnmap_28496_fields len sctp_tsnmap 0 28496 NULL
+xfs_rtallocate_extent_exact_fndecl_28498_fields xfs_rtallocate_extent_exact fndecl 3-5-9-0 28498 NULL nohasharray
+num_sgpgs_bfa_iocfc_drvcfg_s_28498_fields num_sgpgs bfa_iocfc_drvcfg_s 0 28498 &xfs_rtallocate_extent_exact_fndecl_28498_fields
+read_file_operations_28504_fields read file_operations 0 28504 NULL
+dln2_send_wait_fndecl_28510_fields dln2_send_wait fndecl 0 28510 NULL
+get_xsave_size_fndecl_28515_fields get_xsave_size fndecl 0 28515 NULL
+xen_add_extra_mem_fndecl_28519_fields xen_add_extra_mem fndecl 1-2 28519 NULL
+free_tind_blocks_fndecl_28525_fields free_tind_blocks fndecl 3 28525 NULL
+src_width_snd_pcm_plugin_28529_fields src_width snd_pcm_plugin 0 28529 NULL
+max_rds_rings_qlcnic_adapter_28536_fields max_rds_rings qlcnic_adapter 0 28536 NULL
+ext4_bread_fndecl_28538_fields ext4_bread fndecl 3 28538 NULL
+btcx_screen_clips_fndecl_28540_fields btcx_screen_clips fndecl 1-2-0-5 28540 NULL
+fou_recv_pull_fndecl_28542_fields fou_recv_pull fndecl 3 28542 NULL
+md_minor_mdp_superblock_s_28551_fields md_minor mdp_superblock_s 0 28551 NULL
+len_s3fwrn5_fw_header_28556_fields len s3fwrn5_fw_header 0 28556 NULL
+ci_ll_init_fndecl_28561_fields ci_ll_init fndecl 3 28561 NULL nohasharray
+num_pads_uvc_entity_28561_fields num_pads uvc_entity 0 28561 &ci_ll_init_fndecl_28561_fields
+PRO_RATE_DEFAULT_vardecl_ice1712_c_28563_fields PRO_RATE_DEFAULT vardecl_ice1712.c 0 28563 NULL
+wm_adsp_write_data_word_fndecl_28566_fields wm_adsp_write_data_word fndecl 0 28566 NULL
+size_vhost_iotlb_msg_28568_fields size vhost_iotlb_msg 0 28568 NULL
+out_max_chans_snd_card_asihpi_28574_fields out_max_chans snd_card_asihpi 0 28574 NULL
+max_rdma_sge_ocrdma_dev_attr_28585_fields max_rdma_sge ocrdma_dev_attr 0 28585 NULL nohasharray
+charcount_console_font_op_28585_fields charcount console_font_op 0 28585 &max_rdma_sge_ocrdma_dev_attr_28585_fields
+uhci_map_status_fndecl_28591_fields uhci_map_status fndecl 0 28591 NULL
+icsk_pmtu_cookie_inet_connection_sock_28598_fields icsk_pmtu_cookie inet_connection_sock 0 28598 NULL
+n_devs_pci_id_table_28599_fields n_devs pci_id_table 0 28599 NULL
+status_smsc9420_dma_desc_28600_fields status smsc9420_dma_desc 0 28600 NULL
+stride_usX2Ydev_28605_fields stride usX2Ydev 0 28605 NULL
+zone_spanned_pages_in_node_fndecl_28608_fields zone_spanned_pages_in_node fndecl 0 28608 NULL
+ubifs_scan_a_node_fndecl_28611_fields ubifs_scan_a_node fndecl 0 28611 NULL
+msb_erase_block_fndecl_28612_fields msb_erase_block fndecl 2 28612 NULL
+ccmp_encrypt_skb_fndecl_28613_fields ccmp_encrypt_skb fndecl 3 28613 NULL nohasharray
+vsscanf_fndecl_28613_fields vsscanf fndecl 0 28613 &ccmp_encrypt_skb_fndecl_28613_fields
+gru_assign_context_number_fndecl_28616_fields gru_assign_context_number fndecl 0 28616 NULL
+s_inode_size_ext4_sb_info_28625_fields s_inode_size ext4_sb_info 0 28625 NULL
+cdc_ncm_min_dgram_size_fndecl_28632_fields cdc_ncm_min_dgram_size fndecl 0 28632 NULL
+key_size_ethtool_rxfh_28633_fields key_size ethtool_rxfh 0 28633 NULL nohasharray
+drbd_recv_all_fndecl_28633_fields drbd_recv_all fndecl 3 28633 &key_size_ethtool_rxfh_28633_fields
+log_max_len_server_hdr_28634_fields log_max_len server_hdr 0 28634 NULL
+device_count_vardecl_mts64_c_28635_fields device_count vardecl_mts64.c 0 28635 NULL
+usb_stream_new_fndecl_28646_fields usb_stream_new fndecl 6-8-5-7-3-4 28646 NULL
+cw1200_spi_memcpy_fromio_fndecl_28649_fields cw1200_spi_memcpy_fromio fndecl 4 28649 NULL nohasharray
+rvt_rkey_ok_fndecl_28649_fields rvt_rkey_ok fndecl 3-4 28649 &cw1200_spi_memcpy_fromio_fndecl_28649_fields
+cur_offset_drm_dp_sideband_msg_tx_28655_fields cur_offset drm_dp_sideband_msg_tx 0 28655 NULL
+set_mr_fileds_fndecl_28677_fields set_mr_fileds fndecl 4 28677 NULL
+x25_create_facilities_fndecl_28684_fields x25_create_facilities fndecl 0 28684 NULL
+phys_size_perf_mw_28685_fields phys_size perf_mw 0 28685 NULL
+fill_isoc_urb_fndecl_28690_fields fill_isoc_urb fndecl 6-5-3 28690 NULL
+_c4iw_write_mem_inline_fndecl_28691_fields _c4iw_write_mem_inline fndecl 3 28691 NULL
+rx_agg_buf_size_rtl8xxxu_fileops_28692_fields rx_agg_buf_size rtl8xxxu_fileops 0 28692 NULL
+stolen_size_psb_gtt_28693_fields stolen_size psb_gtt 0 28693 NULL
+register_size_fe_priv_28698_fields register_size fe_priv 0 28698 NULL
+bclean_fndecl_28699_fields bclean fndecl 3 28699 NULL
+data_len_rndis_data_hdr_28701_fields data_len rndis_data_hdr 0 28701 NULL
+cw_bmove_fndecl_28704_fields cw_bmove fndecl 7-5-3-6-8-4 28704 NULL nohasharray
+size_fuse_notify_store_out_28704_fields size fuse_notify_store_out 0 28704 &cw_bmove_fndecl_28704_fields
+CIFSSMBWrite2_fndecl_28705_fields CIFSSMBWrite2 fndecl 5 28705 NULL
+mlx4_init_cmpt_table_fndecl_28706_fields mlx4_init_cmpt_table fndecl 3 28706 NULL
+nilfs_bmap_lookup_contig_fndecl_28717_fields nilfs_bmap_lookup_contig fndecl 0 28717 NULL
+phys_smscore_buffer_t_28719_fields phys smscore_buffer_t 0 28719 NULL nohasharray
+start_fjes_hw_resource_28719_fields start fjes_hw_resource 0 28719 &phys_smscore_buffer_t_28719_fields
+getexposure_fndecl_28720_fields getexposure fndecl 0 28720 NULL
+xfs_rtcheck_alloc_range_fndecl_28722_fields xfs_rtcheck_alloc_range fndecl 3 28722 NULL
+lpsn_rvt_swqe_28723_fields lpsn rvt_swqe 0 28723 NULL
+note_last_dentry_fndecl_28724_fields note_last_dentry fndecl 4 28724 NULL
+num_pports_qib_devdata_28736_fields num_pports qib_devdata 0 28736 NULL nohasharray
+vdi_size_vxfs_dinode_28736_fields vdi_size vxfs_dinode 0 28736 &num_pports_qib_devdata_28736_fields
+ns_pseg_offset_the_nilfs_28744_fields ns_pseg_offset the_nilfs 0 28744 NULL
+src_h_yuv_frame_info_28759_fields src_h yuv_frame_info 0 28759 NULL
+enc28j60_packet_write_fndecl_28762_fields enc28j60_packet_write fndecl 2 28762 NULL
+ncp_write_kernel_fndecl_28776_fields ncp_write_kernel fndecl 4 28776 NULL
+cow_file_range_fndecl_28790_fields cow_file_range fndecl 3-4 28790 NULL
+tcp_parse_fastopen_option_fndecl_28793_fields tcp_parse_fastopen_option fndecl 1 28793 NULL
+psbfb_alloc_fndecl_28804_fields psbfb_alloc fndecl 2 28804 NULL
+items_max_vxge_hw_mempool_28806_fields items_max vxge_hw_mempool 0 28806 NULL
+e820_remove_range_fndecl_28810_fields e820_remove_range fndecl 1-2 28810 NULL nohasharray
+ide_queue_pc_tail_fndecl_28810_fields ide_queue_pc_tail fndecl 5 28810 &e820_remove_range_fndecl_28810_fields
+ceph_build_auth_fndecl_28825_fields ceph_build_auth fndecl 0 28825 NULL nohasharray
+oid_printf_vargs_fndecl_28825_fields oid_printf_vargs fndecl 0 28825 &ceph_build_auth_fndecl_28825_fields
+sdio_memcpy_toio_fndecl_28828_fields sdio_memcpy_toio fndecl 4 28828 NULL
+vram_end_radeon_mc_28831_fields vram_end radeon_mc 0 28831 NULL
+right_qxl_urect_28833_fields right qxl_urect 0 28833 NULL nohasharray
+ivtv_udma_get_page_info_fndecl_28833_fields ivtv_udma_get_page_info fndecl 2-3 28833 &right_qxl_urect_28833_fields
+dm_table_add_target_fndecl_28838_fields dm_table_add_target fndecl 4-3 28838 NULL
+sctp_setsockopt_hmac_ident_fndecl_28852_fields sctp_setsockopt_hmac_ident fndecl 3 28852 NULL
+dsp_buffer_alloc_fndecl_28855_fields dsp_buffer_alloc fndecl 2 28855 NULL nohasharray
+hdac_hdmi_create_dais_fndecl_28855_fields hdac_hdmi_create_dais fndecl 4 28855 &dsp_buffer_alloc_fndecl_28855_fields
+pf_cids_qed_src_iids_28859_fields pf_cids qed_src_iids 0 28859 NULL
+mt9t031_set_params_fndecl_28862_fields mt9t031_set_params fndecl 4-3 28862 NULL
+tx_pending_ethtool_ringparam_28864_fields tx_pending ethtool_ringparam 0 28864 NULL nohasharray
+size_pmk_list_t_28864_fields size pmk_list_t 0 28864 &tx_pending_ethtool_ringparam_28864_fields
+ie_length_brcmf_bss_info_le_28867_fields ie_length brcmf_bss_info_le 0 28867 NULL
+usb_stor_access_xfer_buf_fndecl_28868_fields usb_stor_access_xfer_buf fndecl 0-2 28868 NULL
+i2c_master_recv_fndecl_28869_fields i2c_master_recv fndecl 0-3 28869 NULL
+receive_new_fndecl_28872_fields receive_new fndecl 3 28872 NULL nohasharray
+ep_out_mcs_cb_28872_fields ep_out mcs_cb 0 28872 &receive_new_fndecl_28872_fields
+rx_win_size_mwifiex_ie_types_btcoex_aggr_win_size_28878_fields rx_win_size mwifiex_ie_types_btcoex_aggr_win_size 0 28878 NULL
+request_len_bsg_job_28889_fields request_len bsg_job 0 28889 NULL
+map_count_mm_struct_28894_fields map_count mm_struct 0 28894 NULL nohasharray
+no_seek_end_llseek_size_fndecl_28894_fields no_seek_end_llseek_size fndecl 2 28894 &map_count_mm_struct_28894_fields
+nci_set_config_fndecl_28899_fields nci_set_config fndecl 3 28899 NULL
+t_elist_cb_state_28900_fields t elist_cb_state 0 28900 NULL nohasharray
+capi_major_vardecl_capi_c_28900_fields capi_major vardecl_capi.c 0 28900 &t_elist_cb_state_28900_fields
+ss_in_channels_hdspm_28903_fields ss_in_channels hdspm 0 28903 NULL
+ngpios_sx150x_device_data_28905_fields ngpios sx150x_device_data 0 28905 NULL
+usb_pipe_handle_ath6kl_usb_pipe_28910_fields usb_pipe_handle ath6kl_usb_pipe 0 28910 NULL
+hslen_vardecl_matroxfb_base_c_28914_fields hslen vardecl_matroxfb_base.c 0 28914 NULL
+port_c67x00_urb_priv_28917_fields port c67x00_urb_priv 0 28917 NULL
+c_ssize_f_uac2_opts_28922_fields c_ssize f_uac2_opts 0 28922 NULL
+suspend_nvs_register_fndecl_28923_fields suspend_nvs_register fndecl 2-1 28923 NULL
+pgs_per_blk_nvm_dev_28942_fields pgs_per_blk nvm_dev 0 28942 NULL nohasharray
+bts_index_debug_store_28942_fields bts_index debug_store 0 28942 &pgs_per_blk_nvm_dev_28942_fields
+alsa_index_vardecl_thinkpad_acpi_c_28952_fields alsa_index vardecl_thinkpad_acpi.c 0 28952 NULL
+gb_len_pn533_28959_fields gb_len pn533 0 28959 NULL
+hpfs_alloc_anode_fndecl_28960_fields hpfs_alloc_anode fndecl 2 28960 NULL nohasharray
+hci_cmd_sync_fndecl_28960_fields hci_cmd_sync fndecl 3 28960 &hpfs_alloc_anode_fndecl_28960_fields
+usb_stor_bulk_transfer_buf_fndecl_28961_fields usb_stor_bulk_transfer_buf fndecl 4-2 28961 NULL
+tcp_send_rcvq_fndecl_28967_fields tcp_send_rcvq fndecl 3 28967 NULL
+ath6kl_wmi_set_wow_mode_cmd_fndecl_28969_fields ath6kl_wmi_set_wow_mode_cmd fndecl 2 28969 NULL
+sctp_transport_update_pmtu_fndecl_28973_fields sctp_transport_update_pmtu fndecl 3 28973 NULL
+syncmaxsize_snd_usb_endpoint_28987_fields syncmaxsize snd_usb_endpoint 0 28987 NULL
+aper_size_agp_kern_info_28990_fields aper_size agp_kern_info 0 28990 NULL
+klen_WepKeyRid_28997_fields klen WepKeyRid 0 28997 NULL
+ext4_get_inline_size_fndecl_28998_fields ext4_get_inline_size fndecl 0 28998 NULL
+handle_unit_fndecl_29000_fields handle_unit fndecl 0-1 29000 NULL nohasharray
+rawsize_nd_namespace_label_29000_fields rawsize nd_namespace_label 0 29000 &handle_unit_fndecl_29000_fields
+len_p54p_desc_29001_fields len p54p_desc 0 29001 NULL nohasharray
+buf_read_ptr_comedi_async_29001_fields buf_read_ptr comedi_async 0 29001 &len_p54p_desc_29001_fields
+nl80211_send_mgmt_fndecl_29002_fields nl80211_send_mgmt fndecl 7 29002 NULL
+num_lns_csio_hw_29004_fields num_lns csio_hw 0 29004 NULL
+ivtvfb_prep_dec_dma_to_device_fndecl_29011_fields ivtvfb_prep_dec_dma_to_device fndecl 4 29011 NULL
+sb_dmap_hpfs_sb_info_29020_fields sb_dmap hpfs_sb_info 0 29020 NULL
+j_len_reiserfs_journal_list_29021_fields j_len reiserfs_journal_list 0 29021 NULL
+__spi_queued_transfer_fndecl_29024_fields __spi_queued_transfer fndecl 0 29024 NULL
+len_f2fs_move_range_29028_fields len f2fs_move_range 0 29028 NULL
+nft_value_dump_fndecl_29030_fields nft_value_dump fndecl 3 29030 NULL
+batadv_skb_head_push_fndecl_29043_fields batadv_skb_head_push fndecl 2 29043 NULL nohasharray
+devm_mfd_add_devices_fndecl_29043_fields devm_mfd_add_devices fndecl 6-2 29043 &batadv_skb_head_push_fndecl_29043_fields
+memory_size_kvm_userspace_memory_region_29047_fields memory_size kvm_userspace_memory_region 0 29047 NULL
+length_hsu_dma_desc_29052_fields length hsu_dma_desc 0 29052 NULL
+___alloc_bootmem_fndecl_29057_fields ___alloc_bootmem fndecl 2-3-4 29057 NULL
+fbcon_scroll_fndecl_29060_fields fbcon_scroll fndecl 5 29060 NULL nohasharray
+len_wmi_rx_mgmt_info_29060_fields len wmi_rx_mgmt_info 0 29060 &fbcon_scroll_fndecl_29060_fields
+use_dmio_fndecl_29065_fields use_dmio fndecl 3 29065 NULL
+ucFakeEDIDLength__ATOM_FAKE_EDID_PATCH_RECORD_29067_fields ucFakeEDIDLength _ATOM_FAKE_EDID_PATCH_RECORD 0 29067 NULL
+xfs_bmse_shift_one_fndecl_29075_fields xfs_bmse_shift_one fndecl 3 29075 NULL
+tse_change_mtu_fndecl_29076_fields tse_change_mtu fndecl 2 29076 NULL
+ath6kl_wmi_deletekey_cmd_fndecl_29086_fields ath6kl_wmi_deletekey_cmd fndecl 2 29086 NULL
+len_scifioctl_unreg_29093_fields len scifioctl_unreg 0 29093 NULL
+dlm_lowcomms_get_buffer_fndecl_29111_fields dlm_lowcomms_get_buffer fndecl 2 29111 NULL
+bttv_read_fndecl_29115_fields bttv_read fndecl 3 29115 NULL
+size_tmc_drvdata_29121_fields size tmc_drvdata 0 29121 NULL
+start_dm_verity_fec_29127_fields start dm_verity_fec 0 29127 NULL
+ioctl_code_usbdevfs_ioctl_29134_fields ioctl_code usbdevfs_ioctl 0 29134 NULL
+y1_virtio_gpu_framebuffer_29147_fields y1 virtio_gpu_framebuffer 0 29147 NULL
+send_bulk_pipe_us_data_29148_fields send_bulk_pipe us_data 0 29148 NULL
+width_usbtv_29152_fields width usbtv 0 29152 NULL
+algorithm_raid_type_29156_fields algorithm raid_type 0 29156 NULL
+W6692B_empty_fifo_fndecl_29159_fields W6692B_empty_fifo fndecl 2 29159 NULL
+md_dump_size_qla_hw_data_29160_fields md_dump_size qla_hw_data 0 29160 NULL
+error_bio_list_fndecl_29166_fields error_bio_list fndecl 2 29166 NULL
+surface_height_drm_fb_helper_surface_size_29174_fields surface_height drm_fb_helper_surface_size 0 29174 NULL
+num_segments_acpi_namestring_info_29180_fields num_segments acpi_namestring_info 0 29180 NULL nohasharray
+dma_in_streamzap_ir_29180_fields dma_in streamzap_ir 0 29180 &num_segments_acpi_namestring_info_29180_fields
+ircomm_control_indication_fndecl_29186_fields ircomm_control_indication fndecl 3 29186 NULL
+em28xx_i2c_read_block_fndecl_29188_fields em28xx_i2c_read_block fndecl 5 29188 NULL
+report_nb8800_rx_desc_29192_fields report nb8800_rx_desc 0 29192 NULL
+HFC_inw_nodebug_hfc_multi_29199_fields HFC_inw_nodebug hfc_multi 0 29199 NULL
+vcc_sendmsg_fndecl_29205_fields vcc_sendmsg fndecl 3 29205 NULL
+x25_parse_facilities_fndecl_29207_fields x25_parse_facilities fndecl 0 29207 NULL
+ftdi_elan_total_command_size_fndecl_29214_fields ftdi_elan_total_command_size fndecl 0 29214 NULL
+video_rbase_osd_info_29225_fields video_rbase osd_info 0 29225 NULL
+mpx_get_bt_entry_offset_bytes_fndecl_29230_fields mpx_get_bt_entry_offset_bytes fndecl 0-2 29230 NULL
+change_pte_range_fndecl_29232_fields change_pte_range fndecl 3 29232 NULL
+rq_pagesz_smb_rqst_29240_fields rq_pagesz smb_rqst 0 29240 NULL
+sb_dirband_start_hpfs_sb_info_29242_fields sb_dirband_start hpfs_sb_info 0 29242 NULL
+count_qed_tid_seg_29243_fields count qed_tid_seg 0 29243 NULL
+ubifs_recover_log_leb_fndecl_29244_fields ubifs_recover_log_leb fndecl 3 29244 NULL
+sg_pcopy_from_buffer_fndecl_29248_fields sg_pcopy_from_buffer fndecl 0-5-4 29248 NULL
+offset_rbd_obj_request_29253_fields offset rbd_obj_request 0 29253 NULL
+hfi1_copy_sge_fndecl_29257_fields hfi1_copy_sge fndecl 3 29257 NULL
+i_dir_acl_ext2_inode_29264_fields i_dir_acl ext2_inode 0 29264 NULL
+maxlen_ctl_table_29268_fields maxlen ctl_table 0 29268 NULL nohasharray
+sisusb_lseek_fndecl_29268_fields sisusb_lseek fndecl 2 29268 &maxlen_ctl_table_29268_fields
+drbg_kcapi_sym_ctr_fndecl_29274_fields drbg_kcapi_sym_ctr fndecl 3-5 29274 NULL
+offs_replay_entry_29277_fields offs replay_entry 0 29277 NULL
+convert_dma_width_fndecl_29278_fields convert_dma_width fndecl 0 29278 NULL
+reg_shift_sccnxp_pdata_29283_fields reg_shift sccnxp_pdata 0 29283 NULL
+sh_last_alloc_nilfs_sufile_header_29285_fields sh_last_alloc nilfs_sufile_header 0 29285 NULL
+data_len_ceph_msg_header_29290_fields data_len ceph_msg_header 0 29290 NULL
+leb_start_ubi_device_29292_fields leb_start ubi_device 0 29292 NULL
+user_ptr_drm_i915_gem_userptr_29294_fields user_ptr drm_i915_gem_userptr 0 29294 NULL
+set_powered_fndecl_29298_fields set_powered fndecl 4 29298 NULL
+ramoops_init_prz_fndecl_29301_fields ramoops_init_prz fndecl 5 29301 NULL
+mb_find_extent_fndecl_29303_fields mb_find_extent fndecl 2 29303 NULL
+generic_file_llseek_fndecl_29304_fields generic_file_llseek fndecl 2 29304 NULL
+ipgre_rcv_fndecl_29305_fields ipgre_rcv fndecl 3 29305 NULL
+read_w5300_priv_29306_fields read w5300_priv 0 29306 NULL nohasharray
+tail_ivtv_dma_page_info_29306_fields tail ivtv_dma_page_info 0 29306 &read_w5300_priv_29306_fields
+vmw_fifo_reserve_fndecl_29310_fields vmw_fifo_reserve fndecl 2 29310 NULL
+soc_mbus_image_size_fndecl_29311_fields soc_mbus_image_size fndecl 0-3-2 29311 NULL
+num_msix_roce_vec_be_adapter_29319_fields num_msix_roce_vec be_adapter 0 29319 NULL
+ip_generic_getfrag_fndecl_29320_fields ip_generic_getfrag fndecl 4 29320 NULL
+compat_do_arpt_set_ctl_fndecl_29323_fields compat_do_arpt_set_ctl fndecl 4 29323 NULL
+gather_pte_stats_fndecl_29329_fields gather_pte_stats fndecl 2 29329 NULL
+scan_map_fndecl_29331_fields scan_map fndecl 0 29331 NULL
+n_reg_rules_ieee80211_regdomain_29334_fields n_reg_rules ieee80211_regdomain 0 29334 NULL nohasharray
+compat_sys_msgrcv_fndecl_29334_fields compat_sys_msgrcv fndecl 3 29334 &n_reg_rules_ieee80211_regdomain_29334_fields
+y_res_vbe_mode_ib_29340_fields y_res vbe_mode_ib 0 29340 NULL
+sctp_icmp_frag_needed_fndecl_29342_fields sctp_icmp_frag_needed fndecl 4 29342 NULL
+sgeCnt_aac_raw_io2_29350_fields sgeCnt aac_raw_io2 0 29350 NULL
+size_tc_action_ops_29352_fields size tc_action_ops 0 29352 NULL
+alloced_snd_array_29353_fields alloced snd_array 0 29353 NULL
+receive_copy_fndecl_29355_fields receive_copy fndecl 3 29355 NULL
+max_sgs_per_cmd_snic_fw_info_29357_fields max_sgs_per_cmd snic_fw_info 0 29357 NULL nohasharray
+xfs_attr3_leaf_read_fndecl_29357_fields xfs_attr3_leaf_read fndecl 3 29357 &max_sgs_per_cmd_snic_fw_info_29357_fields
+s_dat_entry_size_nilfs_super_block_29359_fields s_dat_entry_size nilfs_super_block 0 29359 NULL
+qt2160_read_block_fndecl_29365_fields qt2160_read_block fndecl 4 29365 NULL
+dummy_perform_transfer_fndecl_29372_fields dummy_perform_transfer fndecl 0-3 29372 NULL
+n_devices_whc_29373_fields n_devices whc 0 29373 NULL
+ppm_get_entries_fndecl_29375_fields ppm_get_entries fndecl 0 29375 NULL
+count_e1000_rx_ring_29377_fields count e1000_rx_ring 0 29377 NULL nohasharray
+l2bsize_jfs_sb_info_29377_fields l2bsize jfs_sb_info 0 29377 &count_e1000_rx_ring_29377_fields
+extHint_fndecl_29378_fields extHint fndecl 2 29378 NULL
+next_cluster_fat_boot_fsinfo_29380_fields next_cluster fat_boot_fsinfo 0 29380 NULL
+acpi_id_xenpf_pcpuinfo_29393_fields acpi_id xenpf_pcpuinfo 0 29393 NULL
+tun_net_change_mtu_fndecl_29398_fields tun_net_change_mtu fndecl 2 29398 NULL
+__alloc_bootmem_low_nopanic_fndecl_29400_fields __alloc_bootmem_low_nopanic fndecl 2-3 29400 NULL
+hpfs_map_sector_fndecl_29402_fields hpfs_map_sector fndecl 2 29402 NULL
+num_leds_mc13xxx_leds_platform_data_29405_fields num_leds mc13xxx_leds_platform_data 0 29405 NULL
+sisfb_mem_sis_video_info_29418_fields sisfb_mem sis_video_info 0 29418 NULL
+udf_name_to_CS0_fndecl_29420_fields udf_name_to_CS0 fndecl 0 29420 NULL
+get_next_page_offset_fndecl_29421_fields get_next_page_offset fndecl 0-2 29421 NULL
+xop_data_nents_xcopy_op_29423_fields xop_data_nents xcopy_op 0 29423 NULL
+ath_descdma_setup_fndecl_29426_fields ath_descdma_setup fndecl 5 29426 NULL
+block_extra_size_snd_util_memhdr_29432_fields block_extra_size snd_util_memhdr 0 29432 NULL
+size_vm_struct_29439_fields size vm_struct 0 29439 NULL
+xfs_attr3_rmt_blocks_fndecl_29445_fields xfs_attr3_rmt_blocks fndecl 0-2 29445 NULL
+ep_in_dln2_dev_29451_fields ep_in dln2_dev 0 29451 NULL
+ebt_buf_add_fndecl_29456_fields ebt_buf_add fndecl 0-3 29456 NULL
+vol_cdev_llseek_fndecl_29458_fields vol_cdev_llseek fndecl 2 29458 NULL
+read_into_pages_cifs_readdata_29473_fields read_into_pages cifs_readdata 0 29473 NULL
+i2c_hid_set_or_send_report_fndecl_29475_fields i2c_hid_set_or_send_report fndecl 5 29475 NULL
+macvtap_put_user_fndecl_29476_fields macvtap_put_user fndecl 0 29476 NULL
+tx_header_len_pn533_frame_ops_29478_fields tx_header_len pn533_frame_ops 0 29478 NULL
+ns_last_pseg_the_nilfs_29482_fields ns_last_pseg the_nilfs 0 29482 NULL
+qs_out_channels_hdsp_29483_fields qs_out_channels hdsp 0 29483 NULL
+phys_out_snd_efw_29490_fields phys_out snd_efw 0 29490 NULL nohasharray
+befs_bt_read_node_fndecl_29490_fields befs_bt_read_node fndecl 4 29490 &phys_out_snd_efw_29490_fields
+pcpu_fc_alloc_fndecl_29497_fields pcpu_fc_alloc fndecl 3-2 29497 NULL
+n_leds_pca963x_chipdef_29498_fields n_leds pca963x_chipdef 0 29498 NULL
+cx23885_alsa_dma_init_fndecl_29499_fields cx23885_alsa_dma_init fndecl 2 29499 NULL
+raid_disks_mdu_array_info_s_29501_fields raid_disks mdu_array_info_s 0 29501 NULL
+type_length_fru_type_length_29503_fields type_length fru_type_length 0 29503 NULL
+nritems_btrfs_header_29521_fields nritems btrfs_header 0 29521 NULL
+blocks_mmc_ioc_cmd_29532_fields blocks mmc_ioc_cmd 0 29532 NULL nohasharray
+h4_recv_buf_fndecl_29532_fields h4_recv_buf fndecl 4 29532 &blocks_mmc_ioc_cmd_29532_fields
+forw_xfs_da3_icnode_hdr_29543_fields forw xfs_da3_icnode_hdr 0 29543 NULL
+ooboffs_mtd_oob_ops_29549_fields ooboffs mtd_oob_ops 0 29549 NULL
+local_max_bio_size_drbd_device_29550_fields local_max_bio_size drbd_device 0 29550 NULL
+zone_mem_ttm_mem_zone_29551_fields zone_mem ttm_mem_zone 0 29551 NULL
+befs_read_lsymlink_fndecl_29556_fields befs_read_lsymlink fndecl 4 29556 NULL
+l2cap_chan_send_fndecl_29557_fields l2cap_chan_send fndecl 3 29557 NULL
+calculate_iosize_fndecl_29562_fields calculate_iosize fndecl 0-4-5-3-2-1 29562 NULL
+ieee80211_rx_bss_info_fndecl_29564_fields ieee80211_rx_bss_info fndecl 3 29564 NULL
+addr_drm_amdgpu_gem_userptr_29582_fields addr drm_amdgpu_gem_userptr 0 29582 NULL
+valid_hooks_xt_table_29585_fields valid_hooks xt_table 0 29585 NULL
+___mic_ioremap_fndecl_29587_fields ___mic_ioremap fndecl 3-2 29587 NULL
+num_rx_queues_e1000_adapter_29589_fields num_rx_queues e1000_adapter 0 29589 NULL
+ti_write_fndecl_29599_fields ti_write fndecl 4 29599 NULL
+btmrvl_download_cal_data_fndecl_29602_fields btmrvl_download_cal_data fndecl 3 29602 NULL
+queue_size_snd_timer_user_29607_fields queue_size snd_timer_user 0 29607 NULL
+r1_sync_page_io_fndecl_29608_fields r1_sync_page_io fndecl 3-2 29608 NULL
+device_size_r5l_log_29609_fields device_size r5l_log 0 29609 NULL
+__vxlan_change_mtu_fndecl_29617_fields __vxlan_change_mtu fndecl 4 29617 NULL
+efd_group_ext4_free_data_29619_fields efd_group ext4_free_data 0 29619 NULL
+dccp_feat_clone_sp_val_fndecl_29621_fields dccp_feat_clone_sp_val fndecl 3 29621 NULL
+nr_cells_axp20x_dev_29628_fields nr_cells axp20x_dev 0 29628 NULL
+escd_size_escd_info_struc_29631_fields escd_size escd_info_struc 0 29631 NULL
+cxgbit_ddp_reserve_fndecl_29637_fields cxgbit_ddp_reserve fndecl 3 29637 NULL
+vbi_vlen_saa7134_dev_29640_fields vbi_vlen saa7134_dev 0 29640 NULL
+vb_bytes_per_frame_cx18_stream_29644_fields vb_bytes_per_frame cx18_stream 0 29644 NULL
+placement_offset_eth_fast_path_rx_cqe_29646_fields placement_offset eth_fast_path_rx_cqe 0 29646 NULL
+bch_vardecl_nandsim_c_29648_fields bch vardecl_nandsim.c 0 29648 NULL
+num_counters_arpt_replace_29649_fields num_counters arpt_replace 0 29649 NULL nohasharray
+ceph_msg_data_add_bio_fndecl_29649_fields ceph_msg_data_add_bio fndecl 3 29649 &num_counters_arpt_replace_29649_fields nohasharray
+reserve_mc_sibling_devs_fndecl_29649_fields reserve_mc_sibling_devs fndecl 2-3 29649 &ceph_msg_data_add_bio_fndecl_29649_fields
+max_dev_sectors_queue_limits_29654_fields max_dev_sectors queue_limits 0 29654 NULL
+items_per_memblock_vxge_hw_mempool_29661_fields items_per_memblock vxge_hw_mempool 0 29661 NULL
+pci_cfg_space_size_fndecl_29666_fields pci_cfg_space_size fndecl 0 29666 NULL
+mon_buff_area_alloc_contiguous_fndecl_29680_fields mon_buff_area_alloc_contiguous fndecl 2 29680 NULL nohasharray
+rtsx_usb_seq_read_register_fndecl_29680_fields rtsx_usb_seq_read_register fndecl 3 29680 &mon_buff_area_alloc_contiguous_fndecl_29680_fields
+comps_used_isert_device_29683_fields comps_used isert_device 0 29683 NULL
+APP_len_camera_data_29686_fields APP_len camera_data 0 29686 NULL
+size_tool_mw_29693_fields size tool_mw 0 29693 NULL
+osd_req_write_sg_kern_fndecl_29697_fields osd_req_write_sg_kern fndecl 5 29697 NULL
+qlcnic_pci_sriov_enable_fndecl_29700_fields qlcnic_pci_sriov_enable fndecl 2 29700 NULL
+ocfs2_add_refcounted_extent_fndecl_29709_fields ocfs2_add_refcounted_extent fndecl 6-7-5 29709 NULL
+ieee80211_stop_tx_ba_cb_irqsafe_fndecl_29711_fields ieee80211_stop_tx_ba_cb_irqsafe fndecl 3 29711 NULL
+SGE_size__MPT_ADAPTER_29715_fields SGE_size _MPT_ADAPTER 0 29715 NULL
+first_sect_blkif_request_segment_29716_fields first_sect blkif_request_segment 0 29716 NULL
+ca91cx42_alloc_resource_fndecl_29717_fields ca91cx42_alloc_resource fndecl 2 29717 NULL
+ext4_itable_unused_count_fndecl_29718_fields ext4_itable_unused_count fndecl 0 29718 NULL
+page_count_orangefs_bufmap_29723_fields page_count orangefs_bufmap 0 29723 NULL
+bpp_aty128_crtc_29724_fields bpp aty128_crtc 0 29724 NULL nohasharray
+sel_write_disable_fndecl_29724_fields sel_write_disable fndecl 3 29724 &bpp_aty128_crtc_29724_fields
+num_resources_mfd_cell_29733_fields num_resources mfd_cell 0 29733 NULL nohasharray
+Zlen_hfc_multi_29733_fields Zlen hfc_multi 0 29733 &num_resources_mfd_cell_29733_fields
+__ceph_tcp_sendpage_fndecl_29744_fields __ceph_tcp_sendpage fndecl 0-4 29744 NULL
+bounce_len_xhci_segment_29759_fields bounce_len xhci_segment 0 29759 NULL
+mmio_phys_ivhd_header_29762_fields mmio_phys ivhd_header 0 29762 NULL
+ext4_write_begin_fndecl_29763_fields ext4_write_begin fndecl 4-3 29763 NULL
+physical_scrub_bio_29776_fields physical scrub_bio 0 29776 NULL
+ath6kl_wmi_ap_set_dtim_cmd_fndecl_29779_fields ath6kl_wmi_ap_set_dtim_cmd fndecl 2 29779 NULL
+eqp_bdi_bd_list_29780_fields eqp_bdi bd_list 0 29780 NULL
+io_min_queue_limits_29785_fields io_min queue_limits 0 29785 NULL
+cfg_num_tx_irqs_be_adapter_29787_fields cfg_num_tx_irqs be_adapter 0 29787 NULL
+first_index_zap_details_29790_fields first_index zap_details 0 29790 NULL
+blk_queue_max_discard_sectors_fndecl_29799_fields blk_queue_max_discard_sectors fndecl 2 29799 NULL
+cxgb3_get_cpl_reply_skb_fndecl_29807_fields cxgb3_get_cpl_reply_skb fndecl 2 29807 NULL nohasharray
+i_disksize_ext4_inode_info_29807_fields i_disksize ext4_inode_info 0 29807 &cxgb3_get_cpl_reply_skb_fndecl_29807_fields
+skb_transmit_mlxsw_bus_29815_fields skb_transmit mlxsw_bus 0 29815 NULL
+vmw_shader_define_fndecl_29819_fields vmw_shader_define fndecl 5 29819 NULL
+double_offset_smbios_cru64_info_29825_fields double_offset smbios_cru64_info 0 29825 NULL
+num_ports_ohci_hcd_29835_fields num_ports ohci_hcd 0 29835 NULL
+rr_len_rpcrdma_rep_29856_fields rr_len rpcrdma_rep 0 29856 NULL
+pvr2_buffer_get_count_fndecl_29860_fields pvr2_buffer_get_count fndecl 0 29860 NULL
+lower_vardecl_matroxfb_base_c_29861_fields lower vardecl_matroxfb_base.c 0 29861 NULL nohasharray
+bnx2x_get_num_non_def_sbs_fndecl_29861_fields bnx2x_get_num_non_def_sbs fndecl 0-2 29861 &lower_vardecl_matroxfb_base_c_29861_fields
+bfs_add_entry_fndecl_29864_fields bfs_add_entry fndecl 4 29864 NULL
+alloc_vmap_area_fndecl_29865_fields alloc_vmap_area fndecl 1-2-3 29865 NULL
+xprt_complete_rqst_fndecl_29874_fields xprt_complete_rqst fndecl 2 29874 NULL
+fat_attach_fndecl_29877_fields fat_attach fndecl 2 29877 NULL
+current_size_ncp_server_29882_fields current_size ncp_server 0 29882 NULL
+selinux_inode_setxattr_fndecl_29895_fields selinux_inode_setxattr fndecl 4 29895 NULL
+residual_st_cmdstatus_29897_fields residual st_cmdstatus 0 29897 NULL
+be_pci_sriov_configure_fndecl_29900_fields be_pci_sriov_configure fndecl 2 29900 NULL
+edge_write_fndecl_29911_fields edge_write fndecl 4 29911 NULL
+io_error_dio_29914_fields io_error dio 0 29914 NULL
+size_exynos_drm_gem_29915_fields size exynos_drm_gem 0 29915 NULL
+fw_imem_len_rt_firmware_29916_fields fw_imem_len rt_firmware 0 29916 NULL
+size_ipt_replace_29921_fields size ipt_replace 0 29921 NULL
+nr_frags_skb_shared_info_29925_fields nr_frags skb_shared_info 0 29925 NULL
+mtt_base_mthca_mr_table_29926_fields mtt_base mthca_mr_table 0 29926 NULL
+alloc_one_pg_vec_page_fndecl_29928_fields alloc_one_pg_vec_page fndecl 1 29928 NULL
+read_pstore_info_29933_fields read pstore_info 0 29933 NULL
+lba_nvme_trans_io_cdb_29934_fields lba nvme_trans_io_cdb 0 29934 NULL
+pvr2_ioread_read_fndecl_29939_fields pvr2_ioread_read fndecl 3 29939 NULL
+__iscsi_complete_pdu_fndecl_29941_fields __iscsi_complete_pdu fndecl 4 29941 NULL
+spi_sync_fndecl_29944_fields spi_sync fndecl 0 29944 NULL
+s_min_extra_isize_ext4_super_block_29952_fields s_min_extra_isize ext4_super_block 0 29952 NULL nohasharray
+cciss_proc_write_fndecl_29952_fields cciss_proc_write fndecl 3 29952 &s_min_extra_isize_ext4_super_block_29952_fields
+opts1_mask_rtl8169_private_29953_fields opts1_mask rtl8169_private 0 29953 NULL
+max_mlx5_core_srq_29956_fields max mlx5_core_srq 0 29956 NULL nohasharray
+state_count_Fsm_29956_fields state_count Fsm 0 29956 &max_mlx5_core_srq_29956_fields nohasharray
+implemented_capacity_ms_boot_attr_info_29956_fields implemented_capacity ms_boot_attr_info 0 29956 &state_count_Fsm_29956_fields
+memconsole_length_vardecl_memconsole_c_29962_fields memconsole_length vardecl_memconsole.c 0 29962 NULL
+c_phys_ocfs2_write_cluster_desc_29971_fields c_phys ocfs2_write_cluster_desc 0 29971 NULL
+ds_in_channels_hdsp_29975_fields ds_in_channels hdsp 0 29975 NULL nohasharray
+mutex_lock_killable_fndecl_29975_fields mutex_lock_killable fndecl 0 29975 &ds_in_channels_hdsp_29975_fields
+i_suballoc_loc_ocfs2_dinode_29986_fields i_suballoc_loc ocfs2_dinode 0 29986 NULL nohasharray
+ubi_leb_change_fndecl_29986_fields ubi_leb_change fndecl 4 29986 &i_suballoc_loc_ocfs2_dinode_29986_fields
+init_size_il4965_firmware_pieces_29990_fields init_size il4965_firmware_pieces 0 29990 NULL
+snd_pcm_lib_preallocate_pages1_fndecl_30002_fields snd_pcm_lib_preallocate_pages1 fndecl 2 30002 NULL
+btrfs_add_ordered_extent_compress_fndecl_30005_fields btrfs_add_ordered_extent_compress fndecl 4-2-3 30005 NULL
+obj_offset_ore_striping_info_30010_fields obj_offset ore_striping_info 0 30010 NULL
+size_fstioc_write_30011_fields size fstioc_write 0 30011 NULL
+period_em28xx_audio_30017_fields period em28xx_audio 0 30017 NULL
+send_hole_fndecl_30019_fields send_hole fndecl 2 30019 NULL
+netlbl_catmap_setbit_fndecl_30024_fields netlbl_catmap_setbit fndecl 2 30024 NULL
+max_wqes_mthca_limits_30037_fields max_wqes mthca_limits 0 30037 NULL
+xdr_set_scratch_buffer_fndecl_30045_fields xdr_set_scratch_buffer fndecl 3 30045 NULL
+max_header_proto_30054_fields max_header proto 0 30054 NULL
+io_throttle_count_vnic_fc_config_30064_fields io_throttle_count vnic_fc_config 0 30064 NULL
+add_swap_extent_fndecl_30065_fields add_swap_extent fndecl 2-4-3 30065 NULL nohasharray
+get_dump_page_fndecl_30065_fields get_dump_page fndecl 1 30065 &add_swap_extent_fndecl_30065_fields
+psb_gem_create_fndecl_30068_fields psb_gem_create fndecl 3 30068 NULL
+to_ifla_vlan_qos_mapping_30070_fields to ifla_vlan_qos_mapping 0 30070 NULL
+SYSC_io_setup_fndecl_30071_fields SYSC_io_setup fndecl 1 30071 NULL nohasharray
+SenseLen__ErrorInfo_struct_30071_fields SenseLen _ErrorInfo_struct 0 30071 &SYSC_io_setup_fndecl_30071_fields
+mwifiex_send_tdls_data_frame_fndecl_30072_fields mwifiex_send_tdls_data_frame fndecl 7 30072 NULL
+wapi_ie_len_mwifiex_private_30073_fields wapi_ie_len mwifiex_private 0 30073 NULL
+cur_pos_kobil_private_30076_fields cur_pos kobil_private 0 30076 NULL
+ufx_alloc_urb_list_fndecl_30078_fields ufx_alloc_urb_list fndecl 3 30078 NULL
+num_pages_vmw_mob_30089_fields num_pages vmw_mob 0 30089 NULL
+ie_len_ieee80211_mgd_assoc_data_30093_fields ie_len ieee80211_mgd_assoc_data 0 30093 NULL
+id_watchdog_device_30094_fields id watchdog_device 0 30094 NULL
+length_ehci_qtd_30102_fields length ehci_qtd 0 30102 NULL
+mmc_test_seq_write_perf_fndecl_30107_fields mmc_test_seq_write_perf fndecl 2 30107 NULL
+of_translate_address_fndecl_30111_fields of_translate_address fndecl 0 30111 NULL
+read_iwl_rxq_30117_fields read iwl_rxq 0 30117 NULL
+bio_integrity_process_fndecl_30121_fields bio_integrity_process fndecl 0 30121 NULL
+max_total_qng_asc_dvc_var_30137_fields max_total_qng asc_dvc_var 0 30137 NULL
+hdr_len_ieee80211_fast_tx_30143_fields hdr_len ieee80211_fast_tx 0 30143 NULL
+map_mr_sg_ib_device_30147_fields map_mr_sg ib_device 0 30147 NULL
+chunk_len_nfcmrvl_fw_dnld_30149_fields chunk_len nfcmrvl_fw_dnld 0 30149 NULL
+i915_gem_object_create_stolen_for_preallocated_fndecl_30151_fields i915_gem_object_create_stolen_for_preallocated fndecl 4-2-3 30151 NULL nohasharray
+hpfs_remove_fnode_fndecl_30151_fields hpfs_remove_fnode fndecl 2 30151 &i915_gem_object_create_stolen_for_preallocated_fndecl_30151_fields
+scif_get_node_ids_fndecl_30156_fields scif_get_node_ids fndecl 0 30156 NULL
+buffer_len_fnic_dbgfs_30157_fields buffer_len fnic_dbgfs 0 30157 NULL
+iobuf_dma_us_data_30159_fields iobuf_dma us_data 0 30159 NULL
+mmio_base_drm_mga_private_30161_fields mmio_base drm_mga_private 0 30161 NULL
+bulk_in_size_hdpvr_device_30165_fields bulk_in_size hdpvr_device 0 30165 NULL
+rx_buf_sz_epic_private_30166_fields rx_buf_sz epic_private 0 30166 NULL nohasharray
+hash_start_dm_verity_30166_fields hash_start dm_verity 0 30166 &rx_buf_sz_epic_private_30166_fields
+mem_attr_table_efi_30168_fields mem_attr_table efi 0 30168 NULL
+tailsz_cifs_writedata_30171_fields tailsz cifs_writedata 0 30171 NULL
+be_calculate_vf_res_fndecl_30174_fields be_calculate_vf_res fndecl 2 30174 NULL
+bnx2x_set_gro_params_fndecl_30177_fields bnx2x_set_gro_params fndecl 3 30177 NULL
+prism2_ap_get_sta_qual_fndecl_30181_fields prism2_ap_get_sta_qual fndecl 0 30181 NULL
+in_ep_num_rtl_hal_usbint_cfg_30182_fields in_ep_num rtl_hal_usbint_cfg 0 30182 NULL
+alloc_pci_root_info_fndecl_30198_fields alloc_pci_root_info fndecl 2-1 30198 NULL
+pos_drm_i915_error_state_buf_30203_fields pos drm_i915_error_state_buf 0 30203 NULL
+pipe_size_renesas_usbhs_driver_param_30206_fields pipe_size renesas_usbhs_driver_param 0 30206 NULL
+len_header_msg_30207_fields len header_msg 0 30207 NULL
+bm_bits_bm_xfer_ctx_30221_fields bm_bits bm_xfer_ctx 0 30221 NULL nohasharray
+rd_offset_nfsd4_read_30221_fields rd_offset nfsd4_read 0 30221 &bm_bits_bm_xfer_ctx_30221_fields
+le_mtu_hci_dev_30225_fields le_mtu hci_dev 0 30225 NULL
+major_vardecl_pt_c_30228_fields major vardecl_pt.c 0 30228 NULL
+vtag_atl1e_recv_ret_status_30229_fields vtag atl1e_recv_ret_status 0 30229 NULL
+tcp_header_len_tcp_sock_30231_fields tcp_header_len tcp_sock 0 30231 NULL
+_brk_start_vardecl_setup_c_30236_fields _brk_start vardecl_setup.c 0 30236 NULL nohasharray
+SetLineNumber_fndecl_30236_fields SetLineNumber fndecl 0 30236 &_brk_start_vardecl_setup_c_30236_fields
+numblocks_bcma_sflash_tbl_e_30237_fields numblocks bcma_sflash_tbl_e 0 30237 NULL
+reiserfs_breada_fndecl_30247_fields reiserfs_breada fndecl 3-2 30247 NULL
+ndisc_fill_redirect_hdr_option_fndecl_30248_fields ndisc_fill_redirect_hdr_option fndecl 3 30248 NULL
+compat_sys_truncate_fndecl_30258_fields compat_sys_truncate fndecl 2 30258 NULL
+max_host_qng_adv_dvc_var_30264_fields max_host_qng adv_dvc_var 0 30264 NULL
+sys_sendfile_fndecl_30267_fields sys_sendfile fndecl 4 30267 NULL nohasharray
+rawsock_recvmsg_fndecl_30267_fields rawsock_recvmsg fndecl 3 30267 &sys_sendfile_fndecl_30267_fields
+tda665x_write_fndecl_30269_fields tda665x_write fndecl 3 30269 NULL nohasharray
+start_discovery_internal_fndecl_30269_fields start_discovery_internal fndecl 5 30269 &tda665x_write_fndecl_30269_fields
+minor_count_vardecl_30272_fields minor_count vardecl 0 30272 NULL
+data_size_netup_dma_30274_fields data_size netup_dma 0 30274 NULL
+blockshift_alauda_media_info_30287_fields blockshift alauda_media_info 0 30287 NULL
+xfs_collapse_file_space_fndecl_30288_fields xfs_collapse_file_space fndecl 2-3 30288 NULL
+blk_queue_dma_drain_fndecl_30290_fields blk_queue_dma_drain fndecl 4 30290 NULL
+tcp_send_mss_fndecl_30292_fields tcp_send_mss fndecl 0 30292 NULL
+t_tinc_hdr_rem_rds_tcp_connection_30296_fields t_tinc_hdr_rem rds_tcp_connection 0 30296 NULL
+wlength_at76_rx_buffer_30301_fields wlength at76_rx_buffer 0 30301 NULL
+m_ts_msg_msg_30307_fields m_ts msg_msg 0 30307 NULL
+ki_pos_kiocb_30312_fields ki_pos kiocb 0 30312 NULL
+private_data_len_iw_cm_event_30313_fields private_data_len iw_cm_event 0 30313 NULL
+wbuf_pagesize_jffs2_sb_info_30318_fields wbuf_pagesize jffs2_sb_info 0 30318 NULL
+ccp_prep_dma_memcpy_fndecl_30323_fields ccp_prep_dma_memcpy fndecl 4 30323 NULL
+name_len_discovery_t_30331_fields name_len discovery_t 0 30331 NULL
+acpi_os_map_memory_fndecl_30346_fields acpi_os_map_memory fndecl 2-1 30346 NULL
+overflow_maj_vardecl_ucm_c_30347_fields overflow_maj vardecl_ucm.c 0 30347 NULL
+p_ssize_f_uac2_opts_30353_fields p_ssize f_uac2_opts 0 30353 NULL
+max_rq_sg_mlx4_caps_30357_fields max_rq_sg mlx4_caps 0 30357 NULL
+bt_datalen_bcm5974_config_30374_fields bt_datalen bcm5974_config 0 30374 NULL
+ubifs_pad_fndecl_30375_fields ubifs_pad fndecl 3 30375 NULL
+max_r2t_iscsi_session_30376_fields max_r2t iscsi_session 0 30376 NULL
+pnp_add_bus_resource_fndecl_30381_fields pnp_add_bus_resource fndecl 3-2 30381 NULL
+qnx4_iget_fndecl_30383_fields qnx4_iget fndecl 2 30383 NULL
+max_span_mlxsw_resources_30386_fields max_span mlxsw_resources 0 30386 NULL
+get_callback_via_fndecl_30387_fields get_callback_via fndecl 0 30387 NULL
+ssid_len_cfg80211_ssid_30393_fields ssid_len cfg80211_ssid 0 30393 NULL
+datalen_port100_frame_30394_fields datalen port100_frame 0 30394 NULL
+i2c_mux_alloc_fndecl_30395_fields i2c_mux_alloc fndecl 4-3 30395 NULL
+ocfs2_dx_entry_list_insert_fndecl_30397_fields ocfs2_dx_entry_list_insert fndecl 3 30397 NULL
+blkdev_write_end_fndecl_30399_fields blkdev_write_end fndecl 5 30399 NULL
+dbgp_control_msg_fndecl_30405_fields dbgp_control_msg fndecl 7 30405 NULL
+queue_size_nvmf_ctrl_options_30406_fields queue_size nvmf_ctrl_options 0 30406 NULL
+hwm_tx_init_fndecl_30411_fields hwm_tx_init fndecl 4 30411 NULL
+flat_state_cnt_vardecl_processor_idle_c_30427_fields flat_state_cnt vardecl_processor_idle.c 0 30427 NULL
+width_bttv_fh_30432_fields width bttv_fh 0 30432 NULL
+ubifs_write_node_fndecl_30441_fields ubifs_write_node fndecl 3-5 30441 NULL
+be_get_dump_len_fndecl_30442_fields be_get_dump_len fndecl 0 30442 NULL
+count_snd_kcontrol_new_30443_fields count snd_kcontrol_new 0 30443 NULL
+num_channels_iio_dev_30451_fields num_channels iio_dev 0 30451 NULL
+max_fr_pages_nvme_rdma_ctrl_30453_fields max_fr_pages nvme_rdma_ctrl 0 30453 NULL
+xfs_rmap_convert_extent_fndecl_30455_fields xfs_rmap_convert_extent fndecl 0 30455 NULL
+mmap_region_fndecl_30460_fields mmap_region fndecl 3-2-0-5 30460 NULL
+height_drm_qxl_alloc_surf_30468_fields height drm_qxl_alloc_surf 0 30468 NULL
+__qp_memcpy_to_queue_fndecl_30472_fields __qp_memcpy_to_queue fndecl 4-2 30472 NULL
+nouveau_gem_new_fndecl_30476_fields nouveau_gem_new fndecl 2 30476 NULL nohasharray
+packet_size_ncp_server_30476_fields packet_size ncp_server 0 30476 &nouveau_gem_new_fndecl_30476_fields
+btrfs_sync_file_fndecl_30480_fields btrfs_sync_file fndecl 2-3 30480 NULL nohasharray
+produce_size_vmci_qp_alloc_info_30480_fields produce_size vmci_qp_alloc_info 0 30480 &btrfs_sync_file_fndecl_30480_fields
+xdr_buf_trim_fndecl_30485_fields xdr_buf_trim fndecl 2 30485 NULL
+data_len_ib_ucm_sidr_rep_30488_fields data_len ib_ucm_sidr_rep 0 30488 NULL
+height_s2255_vc_30492_fields height s2255_vc 0 30492 NULL
+nfcwilink_send_bts_cmd_fndecl_30497_fields nfcwilink_send_bts_cmd fndecl 3 30497 NULL
+tolen_nfs3_linkargs_30505_fields tolen nfs3_linkargs 0 30505 NULL
+buf_start_lo_rx_buf_desc_30523_fields buf_start_lo rx_buf_desc 0 30523 NULL
+nvme_submit_sync_cmd_fndecl_30530_fields nvme_submit_sync_cmd fndecl 4 30530 NULL
+send_command_fndecl_30531_fields send_command fndecl 4 30531 NULL
+InitiatorRecvDataSegmentLength_iscsi_conn_ops_30535_fields InitiatorRecvDataSegmentLength iscsi_conn_ops 0 30535 NULL
+len_nfsd_readlinkres_30541_fields len nfsd_readlinkres 0 30541 NULL
+nfcid_len_pn533_target_type_a_30554_fields nfcid_len pn533_target_type_a 0 30554 NULL
+left_vardecl_matroxfb_base_c_30557_fields left vardecl_matroxfb_base.c 0 30557 NULL
+min_size_rhashtable_params_30562_fields min_size rhashtable_params 0 30562 NULL
+entries_usb_sg_request_30570_fields entries usb_sg_request 0 30570 NULL
+key_len_ubifs_info_30572_fields key_len ubifs_info 0 30572 NULL nohasharray
+s_iblkno_ufs_sb_private_info_30572_fields s_iblkno ufs_sb_private_info 0 30572 &key_len_ubifs_info_30572_fields
+udf_get_pblock_virt20_fndecl_30574_fields udf_get_pblock_virt20 fndecl 4 30574 NULL
+mid_get_vbt_data_r0_fndecl_30575_fields mid_get_vbt_data_r0 fndecl 2 30575 NULL nohasharray
+pio_ide_pio_info_30575_fields pio ide_pio_info 0 30575 &mid_get_vbt_data_r0_fndecl_30575_fields
+userptr_amdgpu_ttm_tt_30577_fields userptr amdgpu_ttm_tt 0 30577 NULL
+delta_stack_mm_struct_30582_fields delta_stack mm_struct 0 30582 NULL nohasharray
+ida_get_new_above_fndecl_30582_fields ida_get_new_above fndecl 0 30582 &delta_stack_mm_struct_30582_fields
+max_intr_slots_myri10ge_priv_30588_fields max_intr_slots myri10ge_priv 0 30588 NULL
+group_ext4_new_group_data_30590_fields group ext4_new_group_data 0 30590 NULL nohasharray
+rsize_cifs_sb_info_30590_fields rsize cifs_sb_info 0 30590 &group_ext4_new_group_data_30590_fields
+read_edid_block_fndecl_30591_fields read_edid_block fndecl 4 30591 NULL
+size_drm_savage_cmdbuf_30592_fields size drm_savage_cmdbuf 0 30592 NULL nohasharray
+readsize_acm_30592_fields readsize acm 0 30592 &size_drm_savage_cmdbuf_30592_fields
+sctp_addto_chunk_fndecl_30597_fields sctp_addto_chunk fndecl 2 30597 NULL
+ext4_collapse_range_fndecl_30598_fields ext4_collapse_range fndecl 3-2 30598 NULL
+offset_drm_i915_gem_pread_30601_fields offset drm_i915_gem_pread 0 30601 NULL
+update_backups_fndecl_30602_fields update_backups fndecl 2 30602 NULL
+add_ino_fndecl_30603_fields add_ino fndecl 4 30603 NULL
+rx_win_size_mwifiex_add_ba_param_30610_fields rx_win_size mwifiex_add_ba_param 0 30610 NULL
+total_data_placed_lpfc_wcqe_complete_30612_fields total_data_placed lpfc_wcqe_complete 0 30612 NULL nohasharray
+blk_sz_os_dat_entry_s_30612_fields blk_sz os_dat_entry_s 0 30612 &total_data_placed_lpfc_wcqe_complete_30612_fields
+ieee802_11_parse_elems_crc_fndecl_30615_fields ieee802_11_parse_elems_crc fndecl 2 30615 NULL
+size_cmdQ_30622_fields size cmdQ 0 30622 NULL
+msc_buffer_win_alloc_fndecl_30624_fields msc_buffer_win_alloc fndecl 2 30624 NULL
+gtt_start_amdgpu_mc_30639_fields gtt_start amdgpu_mc 0 30639 NULL
+catc_ctrl_async_fndecl_30648_fields catc_ctrl_async fndecl 7 30648 NULL
+drbd_md_sync_page_io_fndecl_30651_fields drbd_md_sync_page_io fndecl 3 30651 NULL
+size_vmcore_30652_fields size vmcore 0 30652 NULL
+start_numa_memblk_30656_fields start numa_memblk 0 30656 NULL nohasharray
+TargetRecvDataSegmentLength_iscsi_conn_ops_30656_fields TargetRecvDataSegmentLength iscsi_conn_ops 0 30656 &start_numa_memblk_30656_fields
+ext4_mb_new_blocks_fndecl_30662_fields ext4_mb_new_blocks fndecl 0 30662 NULL
+tun_put_user_fndecl_30676_fields tun_put_user fndecl 0 30676 NULL
+max_count_pvr2_buffer_30678_fields max_count pvr2_buffer 0 30678 NULL
+nvme_cmd_size_fndecl_30679_fields nvme_cmd_size fndecl 0 30679 NULL
+log_num_srqs_mlx4_init_hca_param_30681_fields log_num_srqs mlx4_init_hca_param 0 30681 NULL
+ramsize_brcmf_chip_30687_fields ramsize brcmf_chip 0 30687 NULL nohasharray
+curr_queue_pairs_virtnet_info_30687_fields curr_queue_pairs virtnet_info 0 30687 &ramsize_brcmf_chip_30687_fields
+mac_drv_rx_complete_fndecl_30692_fields mac_drv_rx_complete fndecl 4 30692 NULL
+keybytes_gss_krb5_enctype_30694_fields keybytes gss_krb5_enctype 0 30694 NULL
+status_urb_30696_fields status urb 0 30696 NULL
+hdsp_spdif_sample_rate_fndecl_30700_fields hdsp_spdif_sample_rate fndecl 0 30700 NULL
+bin_cl_size_drm_vc4_submit_cl_30710_fields bin_cl_size drm_vc4_submit_cl 0 30710 NULL
+numPhys_PVSCSIConfigPageController_30726_fields numPhys PVSCSIConfigPageController 0 30726 NULL
+lbs_threshold_write_fndecl_30733_fields lbs_threshold_write fndecl 5 30733 NULL
+num_descriptors_pmc_ctx_30735_fields num_descriptors pmc_ctx 0 30735 NULL
+nci_hci_send_data_fndecl_30741_fields nci_hci_send_data fndecl 5 30741 NULL
+pitch_drm_mode_fb_cmd_30757_fields pitch drm_mode_fb_cmd 0 30757 NULL
+n_scan_channels_iwl_ucode_capabilities_30761_fields n_scan_channels iwl_ucode_capabilities 0 30761 NULL
+leb_size_ubifs_info_30775_fields leb_size ubifs_info 0 30775 NULL
+nzones_high_adfs_discrecord_30776_fields nzones_high adfs_discrecord 0 30776 NULL
+isoc_in_pipe_ttusb_30778_fields isoc_in_pipe ttusb 0 30778 NULL
+hdrlen_brcmf_pub_30788_fields hdrlen brcmf_pub 0 30788 NULL nohasharray
+num_blk_nvm_id_group_30788_fields num_blk nvm_id_group 0 30788 &hdrlen_brcmf_pub_30788_fields
+fcoe_ddp_xid_net_device_30789_fields fcoe_ddp_xid net_device 0 30789 NULL
+netup_write_i2c_fndecl_30793_fields netup_write_i2c fndecl 5 30793 NULL
+wr_sz_csio_q_30799_fields wr_sz csio_q 0 30799 NULL
+fwlen_mpt_fw_xfer_30803_fields fwlen mpt_fw_xfer 0 30803 NULL nohasharray
+extra_mpdu_postfix_len_lib80211_crypto_ops_30803_fields extra_mpdu_postfix_len lib80211_crypto_ops 0 30803 &fwlen_mpt_fw_xfer_30803_fields
+ResidualCnt_ErrorInfo_30806_fields ResidualCnt ErrorInfo 0 30806 NULL
+sadb_key_bits_sadb_key_30808_fields sadb_key_bits sadb_key 0 30808 NULL nohasharray
+buf_dma_gtco_30808_fields buf_dma gtco 0 30808 &sadb_key_bits_sadb_key_30808_fields
+unmerge_ksm_pages_fndecl_30809_fields unmerge_ksm_pages fndecl 2 30809 NULL
+xfs_ialloc_read_agi_fndecl_30810_fields xfs_ialloc_read_agi fndecl 3 30810 NULL nohasharray
+si21_readregs_fndecl_30810_fields si21_readregs fndecl 4 30810 &xfs_ialloc_read_agi_fndecl_30810_fields
+totalram_sysinfo_30812_fields totalram sysinfo 0 30812 NULL
+num_mcg_mthca_profile_30814_fields num_mcg mthca_profile 0 30814 NULL
+audit_log_n_untrustedstring_fndecl_30815_fields audit_log_n_untrustedstring fndecl 3 30815 NULL
+commit_head_n_tty_data_30817_fields commit_head n_tty_data 0 30817 NULL nohasharray
+orig_y_screen_info_30817_fields orig_y screen_info 0 30817 &commit_head_n_tty_data_30817_fields
+shmem_write_begin_fndecl_30822_fields shmem_write_begin fndecl 3 30822 NULL
+report_count_hid_field_30826_fields report_count hid_field 0 30826 NULL
+s_root_blkno_ocfs2_super_block_30828_fields s_root_blkno ocfs2_super_block 0 30828 NULL
+opt_addr_space_ndisc_ops_30830_fields opt_addr_space ndisc_ops 0 30830 NULL
+f2fs_read_data_pages_fndecl_30837_fields f2fs_read_data_pages fndecl 4 30837 NULL
+resp_size_virtio_gpu_vbuffer_30847_fields resp_size virtio_gpu_vbuffer 0 30847 NULL
+notify_offset_multiplier_virtio_pci_device_30853_fields notify_offset_multiplier virtio_pci_device 0 30853 NULL
+count_acpi_object_list_30856_fields count acpi_object_list 0 30856 NULL nohasharray
+default_pvid_net_bridge_30856_fields default_pvid net_bridge 0 30856 &count_acpi_object_list_30856_fields
+al_size_4k_drbd_md_30864_fields al_size_4k drbd_md 0 30864 NULL
+width_cx2341x_handler_30869_fields width cx2341x_handler 0 30869 NULL nohasharray
+memory_size_hp100_private_30869_fields memory_size hp100_private 0 30869 &width_cx2341x_handler_30869_fields
+batadv_send_skb_push_fill_unicast_fndecl_30870_fields batadv_send_skb_push_fill_unicast fndecl 2 30870 NULL nohasharray
+xfs_qm_dqattach_one_fndecl_30870_fields xfs_qm_dqattach_one fndecl 0 30870 &batadv_send_skb_push_fill_unicast_fndecl_30870_fields
+sddr09_send_command_fndecl_30873_fields sddr09_send_command fndecl 5 30873 NULL nohasharray
+r_clusters_ocfs2_refcount_rec_30873_fields r_clusters ocfs2_refcount_rec 0 30873 &sddr09_send_command_fndecl_30873_fields
+current_page_mspro_block_data_30876_fields current_page mspro_block_data 0 30876 NULL
+dma_buf_sz_stmmac_priv_30880_fields dma_buf_sz stmmac_priv 0 30880 NULL
+max_ti_iu_len_srpt_rdma_ch_30887_fields max_ti_iu_len srpt_rdma_ch 0 30887 NULL nohasharray
+ocfs2_xattr_get_rec_fndecl_30887_fields ocfs2_xattr_get_rec fndecl 0 30887 &max_ti_iu_len_srpt_rdma_ch_30887_fields nohasharray
+fifo_size_serial8250_config_30887_fields fifo_size serial8250_config 0 30887 &ocfs2_xattr_get_rec_fndecl_30887_fields
+queue_received_packet_fndecl_30890_fields queue_received_packet fndecl 5 30890 NULL
+sc_rq_depth_svcxprt_rdma_30899_fields sc_rq_depth svcxprt_rdma 0 30899 NULL
+compat_sys_keyctl_fndecl_30900_fields compat_sys_keyctl fndecl 4 30900 NULL
+st_nci_hci_dm_reset_fndecl_30904_fields st_nci_hci_dm_reset fndecl 3 30904 NULL
+host_addrlen_nfs4_mount_data_30905_fields host_addrlen nfs4_mount_data 0 30905 NULL
+word12_lpfc_mbx_read_config_30908_fields word12 lpfc_mbx_read_config 0 30908 NULL
+log_sq_bb_count_mlx4_ib_create_qp_30909_fields log_sq_bb_count mlx4_ib_create_qp 0 30909 NULL
+max_datagram_size_cdc_ncm_ctx_30918_fields max_datagram_size cdc_ncm_ctx 0 30918 NULL
+__erst_read_from_storage_fndecl_30921_fields __erst_read_from_storage fndecl 2-1 30921 NULL
+cudlength_x25_calluserdata_30930_fields cudlength x25_calluserdata 0 30930 NULL
+cqe_size_mlx5_ib_resize_cq_30931_fields cqe_size mlx5_ib_resize_cq 0 30931 NULL
+id_virtio_console_control_30940_fields id virtio_console_control 0 30940 NULL
+hwparams4_dwc3_hwparams_30944_fields hwparams4 dwc3_hwparams 0 30944 NULL
+page_len_gssp_in_token_30948_fields page_len gssp_in_token 0 30948 NULL
+pvr2_stream_setup_fndecl_30955_fields pvr2_stream_setup fndecl 3 30955 NULL
+leaf_shift_right_fndecl_30957_fields leaf_shift_right fndecl 3 30957 NULL
+ring_start__drm_i810_init_30964_fields ring_start _drm_i810_init 0 30964 NULL
+max_sdu_atm_trafprm_30969_fields max_sdu atm_trafprm 0 30969 NULL
+mt7601u_rx_skb_from_seg_fndecl_30971_fields mt7601u_rx_skb_from_seg fndecl 5 30971 NULL
+get_leaf_fndecl_30972_fields get_leaf fndecl 2 30972 NULL
+_usb_write_async_fndecl_30976_fields _usb_write_async fndecl 4 30976 NULL nohasharray
+l2tp_ip_sendmsg_fndecl_30976_fields l2tp_ip_sendmsg fndecl 3 30976 &_usb_write_async_fndecl_30976_fields
+tid_mwifiex_tx_ba_stream_tbl_30977_fields tid mwifiex_tx_ba_stream_tbl 0 30977 NULL
+ext4_mark_iloc_dirty_fndecl_30980_fields ext4_mark_iloc_dirty fndecl 0 30980 NULL
+offset_nfsd_readargs_30989_fields offset nfsd_readargs 0 30989 NULL
+vti6_change_mtu_fndecl_30995_fields vti6_change_mtu fndecl 2 30995 NULL
+l2cap_create_connless_pdu_fndecl_30997_fields l2cap_create_connless_pdu fndecl 3 30997 NULL
+lro_append_pkt_fndecl_31003_fields lro_append_pkt fndecl 4 31003 NULL
+hdpvr_read_fndecl_31018_fields hdpvr_read fndecl 3 31018 NULL
+ipoib_change_mtu_fndecl_31020_fields ipoib_change_mtu fndecl 2 31020 NULL
+DevSize_cfi_ident_31031_fields DevSize cfi_ident 0 31031 NULL
+tcf_csum_ipv4_icmp_fndecl_31033_fields tcf_csum_ipv4_icmp fndecl 3 31033 NULL
+ocfs2_clear_ext_refcount_fndecl_31035_fields ocfs2_clear_ext_refcount fndecl 4-3 31035 NULL
+hfsplus_bnode_read_u16_fndecl_31037_fields hfsplus_bnode_read_u16 fndecl 0 31037 NULL
+migrate_misplaced_transhuge_page_fndecl_31041_fields migrate_misplaced_transhuge_page fndecl 5 31041 NULL
+qla82xx_pci_set_window_fndecl_31044_fields qla82xx_pci_set_window fndecl 0-2 31044 NULL
+dsp_registers_phys_echoaudio_31045_fields dsp_registers_phys echoaudio 0 31045 NULL
+capset_max_size_virtio_gpu_resp_capset_info_31049_fields capset_max_size virtio_gpu_resp_capset_info 0 31049 NULL
+vlan_tag_qede_agg_info_31052_fields vlan_tag qede_agg_info 0 31052 NULL
+ceph_sync_setxattr_fndecl_31053_fields ceph_sync_setxattr fndecl 4 31053 NULL
+nr_bytes_scif_rma_req_31055_fields nr_bytes scif_rma_req 0 31055 NULL
+pci_sriov_get_totalvfs_fndecl_31059_fields pci_sriov_get_totalvfs fndecl 0 31059 NULL nohasharray
+__get_data_block_fndecl_31059_fields __get_data_block fndecl 2 31059 &pci_sriov_get_totalvfs_fndecl_31059_fields nohasharray
+t4_max_qp_depth_c4iw_hw_queue_31059_fields t4_max_qp_depth c4iw_hw_queue 0 31059 &__get_data_block_fndecl_31059_fields
+drbd_bm_bits_fndecl_31061_fields drbd_bm_bits fndecl 0 31061 NULL
+si_lf_eblk_bfs_sb_info_31064_fields si_lf_eblk bfs_sb_info 0 31064 NULL
+hdr_offset_xfrm_type_31067_fields hdr_offset xfrm_type 0 31067 NULL
+bulk_in_endpointAddress_usb_serial_port_31069_fields bulk_in_endpointAddress usb_serial_port 0 31069 NULL
+segsize_musb_qh_31074_fields segsize musb_qh 0 31074 NULL
+brcmf_sdiod_recv_buf_fndecl_31083_fields brcmf_sdiod_recv_buf fndecl 3 31083 NULL
+ocfs2_orphan_for_truncate_fndecl_31085_fields ocfs2_orphan_for_truncate fndecl 4 31085 NULL
+max_fingers_rmi_data_31091_fields max_fingers rmi_data 0 31091 NULL
+num_crtc_vgastate_31093_fields num_crtc vgastate 0 31093 NULL
+screen_depth_vardecl_hyperv_fb_c_31095_fields screen_depth vardecl_hyperv_fb.c 0 31095 NULL nohasharray
+regmap_i2c_read_fndecl_31095_fields regmap_i2c_read fndecl 3-5 31095 &screen_depth_vardecl_hyperv_fb_c_31095_fields
+s_segsize_logfs_super_31101_fields s_segsize logfs_super 0 31101 NULL
+max3421_transfer_in_done_fndecl_31109_fields max3421_transfer_in_done fndecl 0 31109 NULL
+status_tulip_desc_t_31113_fields status tulip_desc_t 0 31113 NULL
+dm_bm_read_lock_fndecl_31121_fields dm_bm_read_lock fndecl 2 31121 NULL
+uhci_result_isochronous_fndecl_31133_fields uhci_result_isochronous fndecl 0 31133 NULL nohasharray
+write_device_fndecl_31133_fields write_device fndecl 3 31133 &uhci_result_isochronous_fndecl_31133_fields
+_mv88e6xxx_vtu_get_fndecl_31134_fields _mv88e6xxx_vtu_get fndecl 2 31134 NULL
+virtqueue_add_outbuf_fndecl_31136_fields virtqueue_add_outbuf fndecl 3 31136 NULL
+_AscCopyLramScsiDoneQ_fndecl_31137_fields _AscCopyLramScsiDoneQ fndecl 4 31137 NULL
+mwifiex_get_supported_rates_fndecl_31144_fields mwifiex_get_supported_rates fndecl 0 31144 NULL
+irttp_connect_indication_fndecl_31149_fields irttp_connect_indication fndecl 4-5 31149 NULL
+hpfs_count_dnodes_fndecl_31152_fields hpfs_count_dnodes fndecl 2 31152 NULL
+max_rx_ip_filters_efx_nic_type_31156_fields max_rx_ip_filters efx_nic_type 0 31156 NULL
+max_seg_size_tsap_cb_31158_fields max_seg_size tsap_cb 0 31158 NULL
+rcvbuf_size_bas_cardstate_31177_fields rcvbuf_size bas_cardstate 0 31177 NULL
+bRPipeBlockSize_usb_wa_descriptor_31178_fields bRPipeBlockSize usb_wa_descriptor 0 31178 NULL
+get_xsaves_size_fndecl_31182_fields get_xsaves_size fndecl 0 31182 NULL
+slhc_compress_fndecl_31190_fields slhc_compress fndecl 0-3 31190 NULL
+btrfs_drop_extents_fndecl_31196_fields btrfs_drop_extents fndecl 5-4 31196 NULL nohasharray
+alloc_huge_page_noerr_fndecl_31196_fields alloc_huge_page_noerr fndecl 2 31196 &btrfs_drop_extents_fndecl_31196_fields nohasharray
+st_int_recv_fndecl_31196_fields st_int_recv fndecl 3 31196 &alloc_huge_page_noerr_fndecl_31196_fields
+wr_ep_alauda_info_31218_fields wr_ep alauda_info 0 31218 NULL
+io_size_smbus_lpc_sch_info_31219_fields io_size_smbus lpc_sch_info 0 31219 NULL
+fl_align_sge_31227_fields fl_align sge 0 31227 NULL
+mcs_unwrap_mir_fndecl_31228_fields mcs_unwrap_mir fndecl 3 31228 NULL nohasharray
+iscsi_tcp_segment_done_fndecl_31228_fields iscsi_tcp_segment_done fndecl 4 31228 &mcs_unwrap_mir_fndecl_31228_fields nohasharray
+choose_log_fs_mgm_entry_size_fndecl_31228_fields choose_log_fs_mgm_entry_size fndecl 0 31228 &iscsi_tcp_segment_done_fndecl_31228_fields
+kaweth_control_fndecl_31233_fields kaweth_control fndecl 8-2 31233 NULL
+len_ip_vs_iphdr_31235_fields len ip_vs_iphdr 0 31235 NULL
+hybla_cong_avoid_fndecl_31239_fields hybla_cong_avoid fndecl 3 31239 NULL
+length_wdm_device_31248_fields length wdm_device 0 31248 NULL
+virtio_gpu_dirty_update_fndecl_31253_fields virtio_gpu_dirty_update fndecl 4-3-5-6 31253 NULL
+source_id_acpi_hest_header_31256_fields source_id acpi_hest_header 0 31256 NULL
+rbdr_len_queue_set_31258_fields rbdr_len queue_set 0 31258 NULL
+orig_video_lines_screen_info_31267_fields orig_video_lines screen_info 0 31267 NULL nohasharray
+data_dma_hanwang_31267_fields data_dma hanwang 0 31267 &orig_video_lines_screen_info_31267_fields
+vm_iomap_memory_fndecl_31269_fields vm_iomap_memory fndecl 2 31269 NULL
+end_incl_vringh_range_31272_fields end_incl vringh_range 0 31272 NULL
+ascot2e_read_regs_fndecl_31273_fields ascot2e_read_regs fndecl 4 31273 NULL
+max_handles_radeon_uvd_31276_fields max_handles radeon_uvd 0 31276 NULL
+packet_length_rc_config_31278_fields packet_length rc_config 0 31278 NULL
+irq_pcmcia_device_31283_fields irq pcmcia_device 0 31283 NULL
+mmap_base_kioctx_31285_fields mmap_base kioctx 0 31285 NULL
+handle_request_fndecl_31291_fields handle_request fndecl 9 31291 NULL
+nfs_readdir_page_filler_fndecl_31292_fields nfs_readdir_page_filler fndecl 5 31292 NULL
+avail_wm_adsp_compr_buf_31294_fields avail wm_adsp_compr_buf 0 31294 NULL
+fs_shift_hfsplus_sb_info_31309_fields fs_shift hfsplus_sb_info 0 31309 NULL
+rxblen_brcmf_sdio_31317_fields rxblen brcmf_sdio 0 31317 NULL
+bio_integrity_add_page_fndecl_31320_fields bio_integrity_add_page fndecl 3-4 31320 NULL
+gsi_end_mp_ioapic_gsi_31327_fields gsi_end mp_ioapic_gsi 0 31327 NULL
+scatter_len_efx_rx_queue_31330_fields scatter_len efx_rx_queue 0 31330 NULL nohasharray
+drm_do_probe_ddc_edid_fndecl_31330_fields drm_do_probe_ddc_edid fndecl 4 31330 &scatter_len_efx_rx_queue_31330_fields
+ubifs_tnc_add_fndecl_31332_fields ubifs_tnc_add fndecl 5-4 31332 NULL
+cur_frames_osst_tape_31335_fields cur_frames osst_tape 0 31335 NULL
+size_ttm_bus_placement_31338_fields size ttm_bus_placement 0 31338 NULL
+block_sz_htc_target_31342_fields block_sz htc_target 0 31342 NULL
+sdio_writesb_fndecl_31345_fields sdio_writesb fndecl 4 31345 NULL
+bulk_in_size_usb_serial_driver_31350_fields bulk_in_size usb_serial_driver 0 31350 NULL
+cifs_llseek_fndecl_31352_fields cifs_llseek fndecl 2 31352 NULL
+size_power_iwl_fw_dbg_dest_tlv_31357_fields size_power iwl_fw_dbg_dest_tlv 0 31357 NULL
+device_acpiphp_slot_31359_fields device acpiphp_slot 0 31359 NULL
+romfs_dev_strcmp_fndecl_31365_fields romfs_dev_strcmp fndecl 4-2 31365 NULL
+rcvhdrq_phys_hfi1_ctxtdata_31388_fields rcvhdrq_phys hfi1_ctxtdata 0 31388 NULL
+s_stripe_ext4_sb_info_31391_fields s_stripe ext4_sb_info 0 31391 NULL
+spi_populate_sync_msg_fndecl_31392_fields spi_populate_sync_msg fndecl 0 31392 NULL
+ip_tunnel_bind_dev_fndecl_31398_fields ip_tunnel_bind_dev fndecl 0 31398 NULL
+number_xt_table_info_31404_fields number xt_table_info 0 31404 NULL
+num_types_amdgpu_irq_src_31405_fields num_types amdgpu_irq_src 0 31405 NULL
+rxrpc_rx_window_size_vardecl_31406_fields rxrpc_rx_window_size vardecl 0 31406 NULL
+data_offset_msgbuf_rx_complete_31409_fields data_offset msgbuf_rx_complete 0 31409 NULL
+sg_tablesize_sg_device_31415_fields sg_tablesize sg_device 0 31415 NULL
+write_node_page_fndecl_31419_fields write_node_page fndecl 1 31419 NULL
+unmap_region_fndecl_31420_fields unmap_region fndecl 5-4 31420 NULL
+bch_bucket_alloc_fndecl_31421_fields bch_bucket_alloc fndecl 0 31421 NULL
+onenand_read_oob_nolock_fndecl_31430_fields onenand_read_oob_nolock fndecl 2 31430 NULL nohasharray
+len_brcmf_vs_tlv_31430_fields len brcmf_vs_tlv 0 31430 &onenand_read_oob_nolock_fndecl_31430_fields
+mpx_unmap_tables_fndecl_31439_fields mpx_unmap_tables fndecl 2-3 31439 NULL
+vc_x_vc_data_31443_fields vc_x vc_data 0 31443 NULL
+gro_size_bnx2x_agg_info_31450_fields gro_size bnx2x_agg_info 0 31450 NULL
+tx_data_ep_usb_tx_data_port_31452_fields tx_data_ep usb_tx_data_port 0 31452 NULL nohasharray
+length_wsm_ssid_31452_fields length wsm_ssid 0 31452 &tx_data_ep_usb_tx_data_port_31452_fields
+i_eattr_gfs2_inode_31461_fields i_eattr gfs2_inode 0 31461 NULL
+length__diva_xdi_um_cfg_cmd_data_read_sdram_31465_fields length _diva_xdi_um_cfg_cmd_data_read_sdram 0 31465 NULL
+drbd_send_all_fndecl_31468_fields drbd_send_all fndecl 4 31468 NULL
+len_mmap_arg_struct32_31471_fields len mmap_arg_struct32 0 31471 NULL nohasharray
+videobuf_dma_init_overlay_fndecl_31471_fields videobuf_dma_init_overlay fndecl 4 31471 &len_mmap_arg_struct32_31471_fields
+lock_extent_bits_fndecl_31481_fields lock_extent_bits fndecl 3-2 31481 NULL
+wl12xx_spi_raw_write_fndecl_31482_fields wl12xx_spi_raw_write fndecl 4 31482 NULL
+rq_wqe_shift_mlx5_ib_create_wq_31487_fields rq_wqe_shift mlx5_ib_create_wq 0 31487 NULL
+xlog_verify_tail_fndecl_31489_fields xlog_verify_tail fndecl 3 31489 NULL nohasharray
+length_rsd_31489_fields length rsd 0 31489 &xlog_verify_tail_fndecl_31489_fields
+pcpu_alloc_fndecl_31502_fields pcpu_alloc fndecl 1 31502 NULL
+PIXDEPTH_kyrofb_info_31509_fields PIXDEPTH kyrofb_info 0 31509 NULL
+fixed_size_llseek_fndecl_31512_fields fixed_size_llseek fndecl 4-2 31512 NULL
+ddb_input_read_fndecl_31516_fields ddb_input_read fndecl 3 31516 NULL
+shmem_replace_page_fndecl_31519_fields shmem_replace_page fndecl 4 31519 NULL
+tx_iovlen_ncp_request_reply_31522_fields tx_iovlen ncp_request_reply 0 31522 NULL
+residual_datacnt_status_pkt_31531_fields residual_datacnt status_pkt 0 31531 NULL
+veth_set_rx_headroom_fndecl_31535_fields veth_set_rx_headroom fndecl 2 31535 NULL
+rx_pipe_usbpn_dev_31540_fields rx_pipe usbpn_dev 0 31540 NULL
+__alloc_percpu_fndecl_31543_fields __alloc_percpu fndecl 1 31543 NULL
+tcp_tso_acked_fndecl_31549_fields tcp_tso_acked fndecl 0 31549 NULL
+stride_drm_qxl_alloc_surf_31551_fields stride drm_qxl_alloc_surf 0 31551 NULL nohasharray
+ks_rdreg16_fndecl_31551_fields ks_rdreg16 fndecl 0 31551 &stride_drm_qxl_alloc_surf_31551_fields
+kernel_physical_mapping_init_fndecl_31561_fields kernel_physical_mapping_init fndecl 0-2 31561 NULL
+qlcnic_validate_ringparam_fndecl_31569_fields qlcnic_validate_ringparam fndecl 0 31569 NULL
+can_change_mtu_fndecl_31583_fields can_change_mtu fndecl 2 31583 NULL
+dvb_dvr_set_buffer_size_fndecl_31587_fields dvb_dvr_set_buffer_size fndecl 2 31587 NULL
+num_txq_bna_attr_31588_fields num_txq bna_attr 0 31588 NULL
+v_max_out_saa7146_standard_31591_fields v_max_out saa7146_standard 0 31591 NULL
+nbchannel_capi_profile_31592_fields nbchannel capi_profile 0 31592 NULL
+radeon_gart_size_auto_fndecl_31605_fields radeon_gart_size_auto fndecl 0 31605 NULL
+sys_mprotect_fndecl_31611_fields sys_mprotect fndecl 2-1 31611 NULL
+dir_commit_chunk_fndecl_31621_fields dir_commit_chunk fndecl 3 31621 NULL
+a_entry_exec_31622_fields a_entry exec 0 31622 NULL
+vma_merge_fndecl_31624_fields vma_merge fndecl 4-3 31624 NULL
+nv04_fifo_new__fndecl_31639_fields nv04_fifo_new_ fndecl 4 31639 NULL
+segsize_dn_skb_cb_31640_fields segsize dn_skb_cb 0 31640 NULL
+pep_recvmsg_fndecl_31641_fields pep_recvmsg fndecl 3 31641 NULL
+ext4_free_blocks_fndecl_31648_fields ext4_free_blocks fndecl 4-5 31648 NULL nohasharray
+av_buf_tail_dccp_ackvec_31648_fields av_buf_tail dccp_ackvec 0 31648 &ext4_free_blocks_fndecl_31648_fields
+mwifiex_set_wpa_ie_helper_fndecl_31650_fields mwifiex_set_wpa_ie_helper fndecl 3 31650 NULL
+bpp_uvc_format_31654_fields bpp uvc_format 0 31654 NULL
+compat_sys_ipc_fndecl_31659_fields compat_sys_ipc fndecl 3 31659 NULL
+ext4_map_blocks_fndecl_31663_fields ext4_map_blocks fndecl 0 31663 NULL
+hp_hpet_phys_hpets_31664_fields hp_hpet_phys hpets 0 31664 NULL
+read_dma_ims_pcu_31667_fields read_dma ims_pcu 0 31667 NULL nohasharray
+len_hda_conn_list_31667_fields len hda_conn_list 0 31667 &read_dma_ims_pcu_31667_fields
+set_capacity_fndecl_31670_fields set_capacity fndecl 2 31670 NULL
+fragment_ufs_buffer_head_31676_fields fragment ufs_buffer_head 0 31676 NULL
+rx_header_len_pn533_frame_ops_31680_fields rx_header_len pn533_frame_ops 0 31680 NULL
+set_rxd_buffer_pointer_fndecl_31693_fields set_rxd_buffer_pointer fndecl 8 31693 NULL
+sr_write_cmd_async_fndecl_31698_fields sr_write_cmd_async fndecl 5 31698 NULL
+TargetsPerBus_aac_bus_info_response_31699_fields TargetsPerBus aac_bus_info_response 0 31699 NULL
+init_pipe_urbs_fndecl_31704_fields init_pipe_urbs fndecl 2-6 31704 NULL
+len_ib_ucm_lap_31705_fields len ib_ucm_lap 0 31705 NULL
+get_free_serial_index_fndecl_31714_fields get_free_serial_index fndecl 0 31714 NULL
+btrfs_add_link_fndecl_31718_fields btrfs_add_link fndecl 5 31718 NULL
+compat_import_iovec_fndecl_31721_fields compat_import_iovec fndecl 3 31721 NULL nohasharray
+ath6kl_usb_submit_ctrl_out_fndecl_31721_fields ath6kl_usb_submit_ctrl_out fndecl 6 31721 &compat_import_iovec_fndecl_31721_fields
+sscanf_fndecl_31725_fields sscanf fndecl 0 31725 NULL
+offset_nfs_pgio_args_31727_fields offset nfs_pgio_args 0 31727 NULL
+ext2_new_blocks_fndecl_31729_fields ext2_new_blocks fndecl 0-2 31729 NULL
+recv_bm_rle_bits_fndecl_31731_fields recv_bm_rle_bits fndecl 4 31731 NULL
+location_r5l_payload_data_parity_31741_fields location r5l_payload_data_parity 0 31741 NULL
+ih_ring_entry_size_kfd_device_info_31745_fields ih_ring_entry_size kfd_device_info 0 31745 NULL
+nxt200x_writereg_multibyte_fndecl_31757_fields nxt200x_writereg_multibyte fndecl 4 31757 NULL
+bio_readpage_error_fndecl_31761_fields bio_readpage_error fndecl 4-5 31761 NULL
+i_size_dio_31770_fields i_size dio 0 31770 NULL
+iommu_pgshift_gk20a_instmem_31778_fields iommu_pgshift gk20a_instmem 0 31778 NULL
+endpt_ubifs_scan_leb_31792_fields endpt ubifs_scan_leb 0 31792 NULL
+minix_V2_raw_inode_fndecl_31793_fields minix_V2_raw_inode fndecl 2 31793 NULL nohasharray
+irq_gpio_lpc_sch_info_31793_fields irq_gpio lpc_sch_info 0 31793 &minix_V2_raw_inode_fndecl_31793_fields
+__cros_ec_pwm_get_duty_fndecl_31796_fields __cros_ec_pwm_get_duty fndecl 0 31796 NULL
+mml_isar_ch_31799_fields mml isar_ch 0 31799 NULL
+parent_i_pos_low_fat_fid_31802_fields parent_i_pos_low fat_fid 0 31802 NULL
+bg_inode_table_ext2_group_desc_31805_fields bg_inode_table ext2_group_desc 0 31805 NULL
+target_submit_cmd_map_sgls_fndecl_31806_fields target_submit_cmd_map_sgls fndecl 6-15 31806 NULL
+qed_cxt_set_srq_count_fndecl_31811_fields qed_cxt_set_srq_count fndecl 2 31811 NULL
+alloc_pg_vec_fndecl_31814_fields alloc_pg_vec fndecl 2 31814 NULL
+secure_dccp_sequence_number_fndecl_31815_fields secure_dccp_sequence_number fndecl 0 31815 NULL
+NumPhys__MPI2_CONFIG_PAGE_EXPANDER_0_31816_fields NumPhys _MPI2_CONFIG_PAGE_EXPANDER_0 0 31816 NULL
+const_channel_count_hda_gen_spec_31817_fields const_channel_count hda_gen_spec 0 31817 NULL nohasharray
+spu_read_fndecl_31817_fields spu_read fndecl 4-0 31817 &const_channel_count_hda_gen_spec_31817_fields
+uvc_v4l2_get_bytesperline_fndecl_31820_fields uvc_v4l2_get_bytesperline fndecl 0 31820 NULL
+__skb_get_poff_fndecl_31821_fields __skb_get_poff fndecl 0 31821 NULL
+num_partition_entries__gpt_header_31832_fields num_partition_entries _gpt_header 0 31832 NULL nohasharray
+byte_len_svc_rdma_op_ctxt_31832_fields byte_len svc_rdma_op_ctxt 0 31832 &num_partition_entries__gpt_header_31832_fields
+num_tty_driver_31834_fields num tty_driver 0 31834 NULL
+n_channels_efx_nic_31838_fields n_channels efx_nic 0 31838 NULL
+opticon_process_data_packet_fndecl_31839_fields opticon_process_data_packet fndecl 3 31839 NULL
+ds_block_shift_logfs_disk_super_31840_fields ds_block_shift logfs_disk_super 0 31840 NULL
+nciq_cxgb4_lld_info_31848_fields nciq cxgb4_lld_info 0 31848 NULL
+sys_munlock_fndecl_31851_fields sys_munlock fndecl 1-2 31851 NULL
+msi2500_convert_stream_fndecl_31862_fields msi2500_convert_stream fndecl 0 31862 NULL
+udf_setup_indirect_aext_fndecl_31873_fields udf_setup_indirect_aext fndecl 2 31873 NULL
+gseg_gru_set_context_option_req_31876_fields gseg gru_set_context_option_req 0 31876 NULL
+i_lastfrag_ufs_inode_info_31879_fields i_lastfrag ufs_inode_info 0 31879 NULL
+sctp_user_addto_chunk_fndecl_31881_fields sctp_user_addto_chunk fndecl 2 31881 NULL
+s_hdrwords_rvt_qp_31882_fields s_hdrwords rvt_qp 0 31882 NULL
+ieee80211_start_tx_ba_cb_fndecl_31884_fields ieee80211_start_tx_ba_cb fndecl 3 31884 NULL
+reallocate_resource_fndecl_31885_fields reallocate_resource fndecl 3 31885 NULL
+max_tasks_bnx2fc_hba_31893_fields max_tasks bnx2fc_hba 0 31893 NULL
+intel_mem_write_fndecl_31895_fields intel_mem_write fndecl 3 31895 NULL
+ieee80211_get_hdrlen_from_buf_fndecl_31900_fields ieee80211_get_hdrlen_from_buf fndecl 0 31900 NULL
+size_macb_tx_skb_31904_fields size macb_tx_skb 0 31904 NULL nohasharray
+ai_hstcp_31904_fields ai hstcp 0 31904 &size_macb_tx_skb_31904_fields
+xfs_qm_dqattach_locked_fndecl_31906_fields xfs_qm_dqattach_locked fndecl 0 31906 NULL
+vram_vardecl_atyfb_base_c_31909_fields vram vardecl_atyfb_base.c 0 31909 NULL nohasharray
+lengthExtendedAttr_fileEntry_31909_fields lengthExtendedAttr fileEntry 0 31909 &vram_vardecl_atyfb_base_c_31909_fields
+numdl_nvme_get_log_page_command_31912_fields numdl nvme_get_log_page_command 0 31912 NULL nohasharray
+num_packets_em28xx_usb_bufs_31912_fields num_packets em28xx_usb_bufs 0 31912 &numdl_nvme_get_log_page_command_31912_fields
+drvr_qdepth_blogic_adapter_31915_fields drvr_qdepth blogic_adapter 0 31915 NULL
+fuse_send_write_pages_fndecl_31919_fields fuse_send_write_pages fndecl 0-5 31919 NULL
+physical_block_size_scsi_disk_31931_fields physical_block_size scsi_disk 0 31931 NULL
+rmmio_size_radeon_device_31934_fields rmmio_size radeon_device 0 31934 NULL
+channel_iio_chan_spec_31939_fields channel iio_chan_spec 0 31939 NULL nohasharray
+mesh_rx_plink_frame_fndecl_31939_fields mesh_rx_plink_frame fndecl 3 31939 &channel_iio_chan_spec_31939_fields
+ptr_i915_gem_userptr_31948_fields ptr i915_gem_userptr 0 31948 NULL
+_read_mtd_info_31950_fields _read mtd_info 0 31950 NULL
+buf_height_tpg_data_31953_fields buf_height tpg_data 0 31953 NULL
+usHSyncOffset__ATOM_DTD_FORMAT_31956_fields usHSyncOffset _ATOM_DTD_FORMAT 0 31956 NULL
+ufs_add_fragments_fndecl_31963_fields ufs_add_fragments fndecl 2-0 31963 NULL
+isdn_tty_write_fndecl_31972_fields isdn_tty_write fndecl 3 31972 NULL
+buffer_max_vardecl_floppy_c_31976_fields buffer_max vardecl_floppy.c 0 31976 NULL
+i_size_read_fndecl_31980_fields i_size_read fndecl 0 31980 NULL
+max_commands_ctlr_info_31984_fields max_commands ctlr_info 0 31984 NULL
+flash_offset_jffs2_raw_node_ref_31989_fields flash_offset jffs2_raw_node_ref 0 31989 NULL
+link_duplex_qlcnic_hardware_context_31996_fields link_duplex qlcnic_hardware_context 0 31996 NULL
+isofs_get_block_fndecl_32000_fields isofs_get_block fndecl 2 32000 NULL
+bg_next_group_ocfs2_group_desc_32003_fields bg_next_group ocfs2_group_desc 0 32003 NULL
+ss_descs_count_ffs_data_32006_fields ss_descs_count ffs_data 0 32006 NULL
+size_tiger_dma_32013_fields size tiger_dma 0 32013 NULL nohasharray
+elants_i2c_read_fndecl_32013_fields elants_i2c_read fndecl 3 32013 &size_tiger_dma_32013_fields
+m_lblk_f2fs_map_blocks_32016_fields m_lblk f2fs_map_blocks 0 32016 NULL
+blocksize_udf_options_32019_fields blocksize udf_options 0 32019 NULL
+sd_sgentry_align_brcmfmac_sdio_pd_32021_fields sd_sgentry_align brcmfmac_sdio_pd 0 32021 NULL
+depth_zr364xx_fmt_32028_fields depth zr364xx_fmt 0 32028 NULL
+check_xattr_ref_inode_fndecl_32039_fields check_xattr_ref_inode fndecl 0 32039 NULL
+base_efifb_dmi_info_32041_fields base efifb_dmi_info 0 32041 NULL
+next_free_pstore_32049_fields next_free pstore 0 32049 NULL
+config_size_nd_cmd_get_config_size_32073_fields config_size nd_cmd_get_config_size 0 32073 NULL
+add_rx_skb_fndecl_32082_fields add_rx_skb fndecl 3 32082 NULL
+chunk_size_irctl_32083_fields chunk_size irctl 0 32083 NULL nohasharray
+s_first_data_block_nilfs_super_block_32083_fields s_first_data_block nilfs_super_block 0 32083 &chunk_size_irctl_32083_fields
+ip6_tnl_err_fndecl_32086_fields ip6_tnl_err fndecl 8 32086 NULL nohasharray
+t3_init_l2t_fndecl_32086_fields t3_init_l2t fndecl 1 32086 &ip6_tnl_err_fndecl_32086_fields
+omfs_clear_range_fndecl_32087_fields omfs_clear_range fndecl 2 32087 NULL
+ocfs2_ilookup_fndecl_32100_fields ocfs2_ilookup fndecl 2 32100 NULL
+rate_min_audioformat_32106_fields rate_min audioformat 0 32106 NULL
+offset_p9_fcall_32116_fields offset p9_fcall 0 32116 NULL nohasharray
+jffs2_sum_scan_sumnode_fndecl_32116_fields jffs2_sum_scan_sumnode fndecl 4 32116 &offset_p9_fcall_32116_fields
+config_rom_length_fw_device_32117_fields config_rom_length fw_device 0 32117 NULL
+height_drm_mode_fb_cmd2_32120_fields height drm_mode_fb_cmd2 0 32120 NULL
+rcvegrcnt_qib_ctxtdata_32127_fields rcvegrcnt qib_ctxtdata 0 32127 NULL
+fsector_t_vardecl_floppy_c_32141_fields fsector_t vardecl_floppy.c 0 32141 NULL
+mlx4_en_complete_rx_desc_fndecl_32150_fields mlx4_en_complete_rx_desc fndecl 0 32150 NULL
+s_clustersize_ocfs2_super_32156_fields s_clustersize ocfs2_super 0 32156 NULL
+num_entries_msg_get_chap_32158_fields num_entries msg_get_chap 0 32158 NULL
+insert_zbranch_fndecl_32159_fields insert_zbranch fndecl 3 32159 NULL
+max_nsid_nvmet_subsys_32165_fields max_nsid nvmet_subsys 0 32165 NULL
+max_recv_dlength_iscsi_conn_32168_fields max_recv_dlength iscsi_conn 0 32168 NULL
+nfs41_maxwrite_overhead_vardecl_32172_fields nfs41_maxwrite_overhead vardecl 0 32172 NULL
+length_vring_rx_dma_32178_fields length vring_rx_dma 0 32178 NULL
+ping_getfrag_fndecl_32187_fields ping_getfrag fndecl 4 32187 NULL
+len_sigma_action_32189_fields len sigma_action 0 32189 NULL nohasharray
+init_page_buffers_fndecl_32189_fields init_page_buffers fndecl 3 32189 &len_sigma_action_32189_fields
+tail_len_beacon_data_32194_fields tail_len beacon_data 0 32194 NULL
+s_system_dir_blkno_ocfs2_super_block_32196_fields s_system_dir_blkno ocfs2_super_block 0 32196 NULL
+nr_registers_ioapic_32204_fields nr_registers ioapic 0 32204 NULL
+len_bnep_ext_hdr_32205_fields len bnep_ext_hdr 0 32205 NULL
+intel_tile_width_bytes_fndecl_32206_fields intel_tile_width_bytes fndecl 0-3 32206 NULL
+ocfs2_decrease_refcount_rec_fndecl_32210_fields ocfs2_decrease_refcount_rec fndecl 6-7 32210 NULL
+num_sbs_pf_vf_resc_32216_fields num_sbs pf_vf_resc 0 32216 NULL
+mag_length_ssp_sensorhub_info_32219_fields mag_length ssp_sensorhub_info 0 32219 NULL
+residual_task_status_struct_32220_fields residual task_status_struct 0 32220 NULL
+count_igb_ring_32225_fields count igb_ring 0 32225 NULL
+sys_munmap_fndecl_32226_fields sys_munmap fndecl 1-2 32226 NULL
+fragments_snd_compressed_buffer_32230_fields fragments snd_compressed_buffer 0 32230 NULL
+snd_usb_ctl_msg_fndecl_32231_fields snd_usb_ctl_msg fndecl 8 32231 NULL
+endpoint_usbatm_channel_32232_fields endpoint usbatm_channel 0 32232 NULL
+ts_packet_count_cx8802_dev_32239_fields ts_packet_count cx8802_dev 0 32239 NULL
+len_nfs_entry_32240_fields len nfs_entry 0 32240 NULL
+msg_page_kvm_vcpu_hv_synic_32251_fields msg_page kvm_vcpu_hv_synic 0 32251 NULL
+n_ids_vport_portids_32258_fields n_ids vport_portids 0 32258 NULL
+oslec_create_fndecl_32264_fields oslec_create fndecl 1 32264 NULL
+buf_len_lpfc_sli_config_hbd_32278_fields buf_len lpfc_sli_config_hbd 0 32278 NULL nohasharray
+__v4l2_ctrl_s_ctrl_fndecl_32278_fields __v4l2_ctrl_s_ctrl fndecl 2 32278 &buf_len_lpfc_sli_config_hbd_32278_fields
+usb_allocate_stream_buffers_fndecl_32279_fields usb_allocate_stream_buffers fndecl 3 32279 NULL
+mapsize_uart_port_32282_fields mapsize uart_port 0 32282 NULL
+seq_open_net_fndecl_32283_fields seq_open_net fndecl 4 32283 NULL
+IA_TX_BUF_SZ_vardecl_iphase_c_32295_fields IA_TX_BUF_SZ vardecl_iphase.c 0 32295 NULL nohasharray
+dma_size_sst_pdata_32295_fields dma_size sst_pdata 0 32295 &IA_TX_BUF_SZ_vardecl_iphase_c_32295_fields
+rept_size_usbtouch_device_info_32306_fields rept_size usbtouch_device_info 0 32306 NULL
+vf_count_qed_cxt_mngr_32311_fields vf_count qed_cxt_mngr 0 32311 NULL
+sizeof_namespace_index_fndecl_32312_fields sizeof_namespace_index fndecl 0 32312 NULL
+nla_put_fndecl_32321_fields nla_put fndecl 3 32321 NULL
+_nfs42_proc_copy_fndecl_32323_fields _nfs42_proc_copy fndecl 5 32323 NULL
+khugepaged_scan_pmd_fndecl_32330_fields khugepaged_scan_pmd fndecl 3 32330 NULL
+datablock_size_btrfsic_state_32333_fields datablock_size btrfsic_state 0 32333 NULL nohasharray
+bochs_ttm_tt_create_fndecl_32333_fields bochs_ttm_tt_create fndecl 2 32333 &datablock_size_btrfsic_state_32333_fields
+mem_start_net_device_32337_fields mem_start net_device 0 32337 NULL
+exynos_drm_gem_create_fndecl_32344_fields exynos_drm_gem_create fndecl 3 32344 NULL
+num_ports_moxa8250_board_32350_fields num_ports moxa8250_board 0 32350 NULL
+scrub_raid56_parity_fndecl_32354_fields scrub_raid56_parity fndecl 5 32354 NULL nohasharray
+brcmf_fws_hdrpull_fndecl_32354_fields brcmf_fws_hdrpull fndecl 2 32354 &scrub_raid56_parity_fndecl_32354_fields
+max_q_vectors_ixgbe_adapter_32359_fields max_q_vectors ixgbe_adapter 0 32359 NULL
+end_crash_mem_range_32361_fields end crash_mem_range 0 32361 NULL
+netlbl_catmap_setlong_fndecl_32363_fields netlbl_catmap_setlong fndecl 2 32363 NULL nohasharray
+backlight_sd_gl860_32363_fields backlight sd_gl860 0 32363 &netlbl_catmap_setlong_fndecl_32363_fields
+datalen_ncp_request_reply_32365_fields datalen ncp_request_reply 0 32365 NULL
+size_wiimote_buf_32369_fields size wiimote_buf 0 32369 NULL
+xfs_setfilesize_fndecl_32370_fields xfs_setfilesize fndecl 4-3 32370 NULL
+hci_req_add_fndecl_32376_fields hci_req_add fndecl 3 32376 NULL
+datablk_xfs_da_geometry_32386_fields datablk xfs_da_geometry 0 32386 NULL
+header_size_smb_version_values_32387_fields header_size smb_version_values 0 32387 NULL
+INFTL_formatblock_fndecl_32390_fields INFTL_formatblock fndecl 2 32390 NULL
+adxl34x_spi_read_block_fndecl_32391_fields adxl34x_spi_read_block fndecl 3 32391 NULL
+offset_pnfs_layout_range_32403_fields offset pnfs_layout_range 0 32403 NULL
+ftdi_prepare_write_buffer_fndecl_32406_fields ftdi_prepare_write_buffer fndecl 3 32406 NULL
+cont_add_fndecl_32409_fields cont_add fndecl 4 32409 NULL
+agbno_xfs_alloc_arg_32410_fields agbno xfs_alloc_arg 0 32410 NULL
+vhost_new_umem_range_fndecl_32413_fields vhost_new_umem_range fndecl 2-3 32413 NULL
+ext4_list_backups_fndecl_32417_fields ext4_list_backups fndecl 0 32417 NULL
+nxt200x_readreg_multibyte_fndecl_32418_fields nxt200x_readreg_multibyte fndecl 4 32418 NULL
+ci_rsbtbl_size_dlm_config_info_32423_fields ci_rsbtbl_size dlm_config_info 0 32423 NULL
+srpt_build_tskmgmt_rsp_fndecl_32427_fields srpt_build_tskmgmt_rsp fndecl 0 32427 NULL
+qib_skip_sge_fndecl_32432_fields qib_skip_sge fndecl 2 32432 NULL
+di_next_index_dinode_32437_fields di_next_index dinode 0 32437 NULL nohasharray
+xs_udp_set_buffer_size_fndecl_32437_fields xs_udp_set_buffer_size fndecl 2 32437 &di_next_index_dinode_32437_fields nohasharray
+gso_size_xenvif_rx_meta_32437_fields gso_size xenvif_rx_meta 0 32437 &xs_udp_set_buffer_size_fndecl_32437_fields
+btrfs_get_extent_fndecl_32440_fields btrfs_get_extent fndecl 4-3-5 32440 NULL nohasharray
+truncated_len_btrfs_ordered_extent_32440_fields truncated_len btrfs_ordered_extent 0 32440 &btrfs_get_extent_fndecl_32440_fields
+t_blk_res_used_xfs_trans_32443_fields t_blk_res_used xfs_trans 0 32443 NULL
+mlx4_alloc_resize_umem_fndecl_32447_fields mlx4_alloc_resize_umem fndecl 3 32447 NULL
+mlxsw_emad_process_status_skb_fndecl_32448_fields mlxsw_emad_process_status_skb fndecl 0 32448 NULL
+__snd_rawmidi_transmit_peek_fndecl_32453_fields __snd_rawmidi_transmit_peek fndecl 0-3 32453 NULL
+permission_inode_operations_32455_fields permission inode_operations 0 32455 NULL
+ext4_da_write_inline_data_end_fndecl_32456_fields ext4_da_write_inline_data_end fndecl 2-4 32456 NULL
+ddata_ofs_cyttsp4_sysinfo_ofs_32462_fields ddata_ofs cyttsp4_sysinfo_ofs 0 32462 NULL
+blk_execute_rq_fndecl_32470_fields blk_execute_rq fndecl 0 32470 NULL nohasharray
+out_kvec_left_ceph_connection_32470_fields out_kvec_left ceph_connection 0 32470 &blk_execute_rq_fndecl_32470_fields
+start_ordered_ops_fndecl_32475_fields start_ordered_ops fndecl 2-3 32475 NULL
+skb_shift_fndecl_32480_fields skb_shift fndecl 3 32480 NULL
+j_len_reiserfs_journal_desc_32481_fields j_len reiserfs_journal_desc 0 32481 NULL
+s_fshift_ufs_sb_private_info_32491_fields s_fshift ufs_sb_private_info 0 32491 NULL nohasharray
+reg_shift_adnp_32491_fields reg_shift adnp 0 32491 &s_fshift_ufs_sb_private_info_32491_fields
+rx_offset_nfp_net_32498_fields rx_offset nfp_net 0 32498 NULL
+read_pci_config_16_fndecl_32499_fields read_pci_config_16 fndecl 0 32499 NULL
+reply_nvif_notify_req_v0_32501_fields reply nvif_notify_req_v0 0 32501 NULL
+lmLogFormat_fndecl_32506_fields lmLogFormat fndecl 2 32506 NULL nohasharray
+acpi_unmap_fndecl_32506_fields acpi_unmap fndecl 1 32506 &lmLogFormat_fndecl_32506_fields
+num_tgtdevs_btrfs_bio_32507_fields num_tgtdevs btrfs_bio 0 32507 NULL
+set_16kib_bfsize_stmmac_mode_ops_32520_fields set_16kib_bfsize stmmac_mode_ops 0 32520 NULL
+jffs2_acl_count_fndecl_32522_fields jffs2_acl_count fndecl 0-1 32522 NULL nohasharray
+__xfs_trans_commit_fndecl_32522_fields __xfs_trans_commit fndecl 0 32522 &jffs2_acl_count_fndecl_32522_fields
+frameoffset_b43_dmaring_32525_fields frameoffset b43_dmaring 0 32525 NULL
+map_iommu_fndecl_32528_fields map_iommu fndecl 2 32528 NULL
+BBAR_rio_detail_32529_fields BBAR rio_detail 0 32529 NULL
+xenvif_max_queues_vardecl_32530_fields xenvif_max_queues vardecl 0 32530 NULL
+num_comp_vectors_mlx4_caps_32534_fields num_comp_vectors mlx4_caps 0 32534 NULL nohasharray
+HDLC_irq_fndecl_32534_fields HDLC_irq fndecl 2 32534 &num_comp_vectors_mlx4_caps_32534_fields
+nla_put_64bit_fndecl_32535_fields nla_put_64bit fndecl 3 32535 NULL
+rq_auth_slack_svc_rqst_32548_fields rq_auth_slack svc_rqst 0 32548 NULL
+TransferCount__MSG_SCSI_IO_REPLY_32554_fields TransferCount _MSG_SCSI_IO_REPLY 0 32554 NULL
+x32_arch_ptrace_fndecl_32556_fields x32_arch_ptrace fndecl 3 32556 NULL
+pkey_table_len_mlx5_port_caps_32558_fields pkey_table_len mlx5_port_caps 0 32558 NULL
+syt_interval_amdtp_stream_32574_fields syt_interval amdtp_stream 0 32574 NULL
+iov_iter_zero_fndecl_32575_fields iov_iter_zero fndecl 1-0 32575 NULL
+ext4_try_to_write_inline_data_fndecl_32578_fields ext4_try_to_write_inline_data fndecl 4-3 32578 NULL
+check_right_item_operations_32585_fields check_right item_operations 0 32585 NULL nohasharray
+fnic_fc_trace_get_data_fndecl_32585_fields fnic_fc_trace_get_data fndecl 0 32585 &check_right_item_operations_32585_fields
+fps_tw686x_video_channel_32606_fields fps tw686x_video_channel 0 32606 NULL
+resp_len_brcmf_cfg80211_assoc_ielen_le_32607_fields resp_len brcmf_cfg80211_assoc_ielen_le 0 32607 NULL
+vlan_tag_atl1c_recv_ret_status_32608_fields vlan_tag atl1c_recv_ret_status 0 32608 NULL
+maxdevUnits_ore_striping_info_32610_fields maxdevUnits ore_striping_info 0 32610 NULL
+xennet_make_one_txreq_fndecl_32614_fields xennet_make_one_txreq fndecl 3-2 32614 NULL
+ceph_osd_data_length_fndecl_32615_fields ceph_osd_data_length fndecl 0 32615 NULL
+usb_alloc_streams_fndecl_32617_fields usb_alloc_streams fndecl 0 32617 NULL
+ntfs_commit_pages_after_write_fndecl_32634_fields ntfs_commit_pages_after_write fndecl 0-4-3 32634 NULL
+pagesz_cifs_writedata_32638_fields pagesz cifs_writedata 0 32638 NULL
+do_page_add_anon_rmap_fndecl_32642_fields do_page_add_anon_rmap fndecl 3 32642 NULL
+digest_decode_fndecl_32644_fields digest_decode fndecl 0 32644 NULL
+blk_add_request_payload_fndecl_32654_fields blk_add_request_payload fndecl 4-3 32654 NULL nohasharray
+phys_sca_base__synclinkmp_info_32654_fields phys_sca_base _synclinkmp_info 0 32654 &blk_add_request_payload_fndecl_32654_fields
+mgmt_generic_event_fndecl_32657_fields mgmt_generic_event fndecl 4 32657 NULL
+icmpv6_manip_pkt_fndecl_32658_fields icmpv6_manip_pkt fndecl 4 32658 NULL
+rtsx_usb_transfer_data_fndecl_32669_fields rtsx_usb_transfer_data fndecl 4-2-5 32669 NULL
+engine_start_viafb_dev_32681_fields engine_start viafb_dev 0 32681 NULL
+length_ib_umem_32690_fields length ib_umem 0 32690 NULL
+udf_write_aext_fndecl_32691_fields udf_write_aext fndecl 4 32691 NULL
+radeon_drm_ioctl_fndecl_32696_fields radeon_drm_ioctl fndecl 2 32696 NULL
+ubifs_prepare_node_fndecl_32700_fields ubifs_prepare_node fndecl 3 32700 NULL
+dma_common_contiguous_remap_fndecl_32714_fields dma_common_contiguous_remap fndecl 2 32714 NULL
+size_hid_report_32715_fields size hid_report 0 32715 NULL
+f71882fg_device_add_fndecl_32719_fields f71882fg_device_add fndecl 1 32719 NULL
+residual_len_sts_entry_24xx_32720_fields residual_len sts_entry_24xx 0 32720 NULL
+ks8995_registers_read_fndecl_32738_fields ks8995_registers_read fndecl 6 32738 NULL
+requested_nr_virtfn_bnx2x_32742_fields requested_nr_virtfn bnx2x 0 32742 NULL
+__cxgbit_alloc_skb_fndecl_32747_fields __cxgbit_alloc_skb fndecl 2 32747 NULL
+vga_video_num_columns_vardecl_vgacon_c_32749_fields vga_video_num_columns vardecl_vgacon.c 0 32749 NULL nohasharray
+rds_tcp_xmit_fndecl_32749_fields rds_tcp_xmit fndecl 3 32749 &vga_video_num_columns_vardecl_vgacon_c_32749_fields
+lookup_zone_fndecl_32751_fields lookup_zone fndecl 0 32751 NULL
+fuse_file_ioctl_fndecl_32760_fields fuse_file_ioctl fndecl 2 32760 NULL
+rc_via_alen_mpls_route_config_32766_fields rc_via_alen mpls_route_config 0 32766 NULL
+gro_pull_from_frag0_fndecl_32770_fields gro_pull_from_frag0 fndecl 2 32770 NULL
+sm501_create_mem_fndecl_32778_fields sm501_create_mem fndecl 4 32778 NULL
+test_ofsl_cyttsp4_sysinfo_data_32781_fields test_ofsl cyttsp4_sysinfo_data 0 32781 NULL
+queue_gso_packets_fndecl_32783_fields queue_gso_packets fndecl 5 32783 NULL
+xfs_fsb_to_db_fndecl_32785_fields xfs_fsb_to_db fndecl 0-2 32785 NULL
+reg_word_size_snd_soc_codec_driver_32786_fields reg_word_size snd_soc_codec_driver 0 32786 NULL nohasharray
+hpi_instream_ancillary_write_fndecl_32786_fields hpi_instream_ancillary_write fndecl 4 32786 &reg_word_size_snd_soc_codec_driver_32786_fields
+mp_register_ioapic_fndecl_32802_fields mp_register_ioapic fndecl 3 32802 NULL
+pipe_usb_fifo_32805_fields pipe usb_fifo 0 32805 NULL nohasharray
+nfc_allocate_device_fndecl_32805_fields nfc_allocate_device fndecl 3 32805 &pipe_usb_fifo_32805_fields
+info_len_ib_ucm_info_32807_fields info_len ib_ucm_info 0 32807 NULL
+m_len_f2fs_map_blocks_32808_fields m_len f2fs_map_blocks 0 32808 NULL
+l_start_xfs_flock64_32809_fields l_start xfs_flock64 0 32809 NULL
+length_ppp_option_data_32814_fields length ppp_option_data 0 32814 NULL
+namelen_jfs_ea_32820_fields namelen jfs_ea 0 32820 NULL
+xfs_btree_compute_maxlevels_fndecl_32823_fields xfs_btree_compute_maxlevels fndecl 0 32823 NULL
+scrub_fixup_readpage_fndecl_32830_fields scrub_fixup_readpage fndecl 2 32830 NULL
+ds_out_channels_hdspm_32836_fields ds_out_channels hdspm 0 32836 NULL
+num_amgms_mthca_limits_32845_fields num_amgms mthca_limits 0 32845 NULL
+s_inodes_per_block_bits_sysv_sb_info_32849_fields s_inodes_per_block_bits sysv_sb_info 0 32849 NULL
+ep_in_mcs_cb_32852_fields ep_in mcs_cb 0 32852 NULL
+br_startoff_xfs_bmbt_irec_32854_fields br_startoff xfs_bmbt_irec 0 32854 NULL
+should_defrag_range_fndecl_32859_fields should_defrag_range fndecl 2 32859 NULL
+tx_buf_clear_used_ks959_cb_32864_fields tx_buf_clear_used ks959_cb 0 32864 NULL
+duplex_phy_device_32869_fields duplex phy_device 0 32869 NULL
+wTotalLength_usb_security_descriptor_32872_fields wTotalLength usb_security_descriptor 0 32872 NULL
+buffer_len_bfad_debug_info_32873_fields buffer_len bfad_debug_info 0 32873 NULL
+mem_cgroup_move_charge_pte_range_fndecl_32885_fields mem_cgroup_move_charge_pte_range fndecl 2 32885 NULL
+m_ialloc_inos_xfs_mount_32889_fields m_ialloc_inos xfs_mount 0 32889 NULL nohasharray
+at25_ee_read_fndecl_32889_fields at25_ee_read fndecl 2-4 32889 &m_ialloc_inos_xfs_mount_32889_fields
+snoop_table_size_ib_mad_qp_info_32891_fields snoop_table_size ib_mad_qp_info 0 32891 NULL
+min_dump_alloc_netlink_callback_32897_fields min_dump_alloc netlink_callback 0 32897 NULL
+__wa_xfer_setup_segs_fndecl_32902_fields __wa_xfer_setup_segs fndecl 2 32902 NULL
+wm831x_num_wm831x_pdata_32904_fields wm831x_num wm831x_pdata 0 32904 NULL
+adnp_gpio_setup_fndecl_32910_fields adnp_gpio_setup fndecl 2 32910 NULL
+space_init_fndecl_32911_fields space_init fndecl 2 32911 NULL
+max_r2t_iscsi_bus_flash_session_32912_fields max_r2t iscsi_bus_flash_session 0 32912 NULL
+num_vfs_qlcnic_sriov_32913_fields num_vfs qlcnic_sriov 0 32913 NULL
+conn_send_command_fndecl_32918_fields conn_send_command fndecl 4-6 32918 NULL
+pci_get_related_function_fndecl_32920_fields pci_get_related_function fndecl 2 32920 NULL
+nr_events_kioctx_32925_fields nr_events kioctx 0 32925 NULL
+vram_base_mga_mc_32927_fields vram_base mga_mc 0 32927 NULL
+ceph_choose_frag_fndecl_32928_fields ceph_choose_frag fndecl 0 32928 NULL
+__copy_from_user_ll_fndecl_32945_fields __copy_from_user_ll fndecl 0 32945 NULL
+al_stripes_resize_parms_32950_fields al_stripes resize_parms 0 32950 NULL
+diva_data_q_init_fndecl_32954_fields diva_data_q_init fndecl 2 32954 NULL
+btrfsic_map_block_fndecl_32956_fields btrfsic_map_block fndecl 3 32956 NULL
+drm_agp_bind_pages_fndecl_32959_fields drm_agp_bind_pages fndecl 3 32959 NULL
+__carl9170_rx_fndecl_32963_fields __carl9170_rx fndecl 3 32963 NULL
+total_data_buflen_hv_netvsc_packet_32967_fields total_data_buflen hv_netvsc_packet 0 32967 NULL
+s_max_slots_ocfs2_super_block_32972_fields s_max_slots ocfs2_super_block 0 32972 NULL nohasharray
+PofRecDataLen_PofRecHdr_tag_32972_fields PofRecDataLen PofRecHdr_tag 0 32972 &s_max_slots_ocfs2_super_block_32972_fields
+proc_bus_pci_lseek_fndecl_32974_fields proc_bus_pci_lseek fndecl 2 32974 NULL
+p_replen_rpc_procinfo_32991_fields p_replen rpc_procinfo 0 32991 NULL nohasharray
+bn_read_lock_fndecl_32991_fields bn_read_lock fndecl 2 32991 &p_replen_rpc_procinfo_32991_fields
+resid_len_request_32994_fields resid_len request 0 32994 NULL
+wtpref_nfs_fsinfo_33003_fields wtpref nfs_fsinfo 0 33003 NULL
+dwNtbInMaxSize_usb_cdc_ncm_ntb_parameters_33006_fields dwNtbInMaxSize usb_cdc_ncm_ntb_parameters 0 33006 NULL
+mr_per_cmd_srp_target_port_33011_fields mr_per_cmd srp_target_port 0 33011 NULL nohasharray
+pktshift_sge_33011_fields pktshift sge 0 33011 &mr_per_cmd_srp_target_port_33011_fields nohasharray
+offset_fl_pg_chunk_33011_fields offset fl_pg_chunk 0 33011 &pktshift_sge_33011_fields
+buf_addr_mlx5_ib_create_wq_33013_fields buf_addr mlx5_ib_create_wq 0 33013 NULL nohasharray
+size_qlcnic_82xx_dump_template_hdr_33013_fields size qlcnic_82xx_dump_template_hdr 0 33013 &buf_addr_mlx5_ib_create_wq_33013_fields
+q_num_rx_buffers_qede_dev_33015_fields q_num_rx_buffers qede_dev 0 33015 NULL
+nr_regions_amd_flash_info_33022_fields nr_regions amd_flash_info 0 33022 NULL
+rq_size_nes_hw_qp_33024_fields rq_size nes_hw_qp 0 33024 NULL
+offset_xen_netif_rx_response_33028_fields offset xen_netif_rx_response 0 33028 NULL
+rsi_sdio_read_register_multiple_fndecl_33035_fields rsi_sdio_read_register_multiple fndecl 3 33035 NULL
+sacked_out_tcp_sock_33038_fields sacked_out tcp_sock 0 33038 NULL
+files_ceph_mds_reply_inode_33047_fields files ceph_mds_reply_inode 0 33047 NULL
+svc_rdma_xdr_get_reply_hdr_len_fndecl_33056_fields svc_rdma_xdr_get_reply_hdr_len fndecl 0 33056 NULL
+nvbios_rd08_fndecl_33058_fields nvbios_rd08 fndecl 0 33058 NULL
+iov_iter_copy_from_user_atomic_fndecl_33059_fields iov_iter_copy_from_user_atomic fndecl 0 33059 NULL nohasharray
+gfs2_qstr2dirent_fndecl_33059_fields gfs2_qstr2dirent fndecl 2 33059 &iov_iter_copy_from_user_atomic_fndecl_33059_fields
+nfilters_mc5_params_33060_fields nfilters mc5_params 0 33060 NULL nohasharray
+rxbufsz_ar5523_33060_fields rxbufsz ar5523 0 33060 &nfilters_mc5_params_33060_fields
+size_ec168_req_33061_fields size ec168_req 0 33061 NULL
+compress_compressor_33066_fields compress compressor 0 33066 NULL
+prepare_inurb_fndecl_33073_fields prepare_inurb fndecl 1 33073 NULL
+__early_init_dt_declare_initrd_fndecl_33075_fields __early_init_dt_declare_initrd fndecl 1-2 33075 NULL
+__fat_nfs_get_inode_fndecl_33079_fields __fat_nfs_get_inode fndecl 4 33079 NULL
+default_size_vmw_cmdbuf_man_33080_fields default_size vmw_cmdbuf_man 0 33080 NULL
+descriptor_size_pmc_ctx_33081_fields descriptor_size pmc_ctx 0 33081 NULL
+e1000_alloc_rx_skb_fndecl_33089_fields e1000_alloc_rx_skb fndecl 2 33089 NULL nohasharray
+tx_headroom_llc_shdlc_33089_fields tx_headroom llc_shdlc 0 33089 &e1000_alloc_rx_skb_fndecl_33089_fields
+vram_size_cirrus_mc_33094_fields vram_size cirrus_mc 0 33094 NULL
+do_get_write_access_fndecl_33097_fields do_get_write_access fndecl 0 33097 NULL
+return_wc_byte_len_ib_mad_local_private_33101_fields return_wc_byte_len ib_mad_local_private 0 33101 NULL
+length_rvt_sge_33107_fields length rvt_sge 0 33107 NULL
+__snd_util_memblk_new_fndecl_33112_fields __snd_util_memblk_new fndecl 2 33112 NULL
+nla_strlcpy_fndecl_33113_fields nla_strlcpy fndecl 0 33113 NULL
+len_firmware_hdr_33115_fields len firmware_hdr 0 33115 NULL
+hdr_len_virtnet_info_33118_fields hdr_len virtnet_info 0 33118 NULL
+len_cfg80211_mgmt_tx_params_33119_fields len cfg80211_mgmt_tx_params 0 33119 NULL
+hw_token_ehci_qtd_33122_fields hw_token ehci_qtd 0 33122 NULL
+ring_size_amdgpu_ring_33123_fields ring_size amdgpu_ring 0 33123 NULL nohasharray
+omninet_write_fndecl_33123_fields omninet_write fndecl 4 33123 &ring_size_amdgpu_ring_33123_fields
+max_resp_sz_nfs4_channel_attrs_33127_fields max_resp_sz nfs4_channel_attrs 0 33127 NULL nohasharray
+ari_length_ib_cm_rej_event_param_33127_fields ari_length ib_cm_rej_event_param 0 33127 &max_resp_sz_nfs4_channel_attrs_33127_fields
+masklength_iio_dev_33129_fields masklength iio_dev 0 33129 NULL
+trebleinit_CHIPDESC_33133_fields trebleinit CHIPDESC 0 33133 NULL
+in_words_ib_uverbs_cmd_hdr_33134_fields in_words ib_uverbs_cmd_hdr 0 33134 NULL
+__get_vm_area_caller_fndecl_33139_fields __get_vm_area_caller fndecl 3 33139 NULL nohasharray
+acpi_os_write_memory_fndecl_33139_fields acpi_os_write_memory fndecl 3-1 33139 &__get_vm_area_caller_fndecl_33139_fields
+size_bmp_header_33141_fields size bmp_header 0 33141 NULL nohasharray
+hostname_len_nlm_lookup_host_info_33141_fields hostname_len nlm_lookup_host_info 0 33141 &size_bmp_header_33141_fields
+ucNumEntries__ATOM_Polaris_SCLK_Dependency_Table_33144_fields ucNumEntries _ATOM_Polaris_SCLK_Dependency_Table 0 33144 NULL
+l2cap_segment_le_sdu_fndecl_33145_fields l2cap_segment_le_sdu fndecl 4 33145 NULL
+starting_cid_cnic_eth_dev_33155_fields starting_cid cnic_eth_dev 0 33155 NULL nohasharray
+osd_req_list_partition_objects_fndecl_33155_fields osd_req_list_partition_objects fndecl 5 33155 &starting_cid_cnic_eth_dev_33155_fields
+lbs_rdmac_write_fndecl_33156_fields lbs_rdmac_write fndecl 3 33156 NULL
+len_ip_set_ext_type_33164_fields len ip_set_ext_type 0 33164 NULL
+mml_isar_hw_33168_fields mml isar_hw 0 33168 NULL
+iomap_zero_fndecl_33173_fields iomap_zero fndecl 2-4 33173 NULL
+cx231xx_init_isoc_fndecl_33174_fields cx231xx_init_isoc fndecl 4-2 33174 NULL
+hcs_params2_xhci_hcd_33175_fields hcs_params2 xhci_hcd 0 33175 NULL nohasharray
+rounds_dm_verity_fec_33175_fields rounds dm_verity_fec 0 33175 &hcs_params2_xhci_hcd_33175_fields
+set_connectable_fndecl_33177_fields set_connectable fndecl 4 33177 NULL
+rw_devices_btrfs_fs_devices_33182_fields rw_devices btrfs_fs_devices 0 33182 NULL
+arp_filter_size_mwifiex_adapter_33183_fields arp_filter_size mwifiex_adapter 0 33183 NULL
+w5500_spi_readbulk_fndecl_33186_fields w5500_spi_readbulk fndecl 4 33186 NULL
+niqflint_vf_resources_33189_fields niqflint vf_resources 0 33189 NULL
+ath6kl_wmi_set_ip_cmd_fndecl_33191_fields ath6kl_wmi_set_ip_cmd fndecl 2 33191 NULL
+Memhscx_empty_fifo_fndecl_33197_fields Memhscx_empty_fifo fndecl 2 33197 NULL
+ieee80211_rx_mgmt_probe_beacon_fndecl_33208_fields ieee80211_rx_mgmt_probe_beacon fndecl 3 33208 NULL
+block_size_dm_bufio_client_33221_fields block_size dm_bufio_client 0 33221 NULL
+l1oip_socket_recv_fndecl_33226_fields l1oip_socket_recv fndecl 6 33226 NULL
+segment_count_main_f2fs_super_block_33230_fields segment_count_main f2fs_super_block 0 33230 NULL
+ext4_zeroout_es_fndecl_33233_fields ext4_zeroout_es fndecl 0 33233 NULL
+nsumblk_nilfs_segsum_info_33238_fields nsumblk nilfs_segsum_info 0 33238 NULL
+udf_load_partdesc_fndecl_33239_fields udf_load_partdesc fndecl 2 33239 NULL
+mfs_fc_lport_33249_fields mfs fc_lport 0 33249 NULL
+metadata_size_ecryptfs_crypt_stat_33252_fields metadata_size ecryptfs_crypt_stat 0 33252 NULL
+val_sz_orangefs_getxattr_response_33253_fields val_sz orangefs_getxattr_response 0 33253 NULL
+size_reserved_mem_33254_fields size reserved_mem 0 33254 NULL
+wb_offset_nfs_page_33255_fields wb_offset nfs_page 0 33255 NULL
+handle_bytes_file_handle_33261_fields handle_bytes file_handle 0 33261 NULL
+ip_vs_prepare_tunneled_skb_fndecl_33269_fields ip_vs_prepare_tunneled_skb fndecl 3 33269 NULL
+ocfs2_change_extent_flag_fndecl_33270_fields ocfs2_change_extent_flag fndecl 5-3 33270 NULL nohasharray
+mem_end_net_device_33270_fields mem_end net_device 0 33270 &ocfs2_change_extent_flag_fndecl_33270_fields
+drv_file_st_partstat_33277_fields drv_file st_partstat 0 33277 NULL
+ep_msg_out_peak_usb_device_33281_fields ep_msg_out peak_usb_device 0 33281 NULL nohasharray
+sbsector_iso9660_options_33281_fields sbsector iso9660_options 0 33281 &ep_msg_out_peak_usb_device_33281_fields nohasharray
+hpfs_readpages_fndecl_33281_fields hpfs_readpages fndecl 4 33281 &sbsector_iso9660_options_33281_fields
+frame_size_camera_data_33292_fields frame_size camera_data 0 33292 NULL
+num_vls_vardecl_33298_fields num_vls vardecl 0 33298 NULL nohasharray
+offset_fuse_lseek_out_33298_fields offset fuse_lseek_out 0 33298 &num_vls_vardecl_33298_fields
+vlen_nfsd_readargs_33302_fields vlen nfsd_readargs 0 33302 NULL
+e_phnum_elf64_hdr_33305_fields e_phnum elf64_hdr 0 33305 NULL
+e_sz_rsa_key_33307_fields e_sz rsa_key 0 33307 NULL
+index_vardecl_via82xx_modem_c_33320_fields index vardecl_via82xx_modem.c 0 33320 NULL
+hlen_h4_recv_pkt_33324_fields hlen h4_recv_pkt 0 33324 NULL
+ahd_sg_setup_fndecl_33341_fields ahd_sg_setup fndecl 4-5 33341 NULL
+max_vpi_lpfc_max_cfg_param_33350_fields max_vpi lpfc_max_cfg_param 0 33350 NULL
+ihandlen_xfs_fsop_handlereq_33370_fields ihandlen xfs_fsop_handlereq 0 33370 NULL
+lpfc_sg_seg_cnt_init_fndecl_33371_fields lpfc_sg_seg_cnt_init fndecl 2 33371 NULL
+ib_qib_max_srq_wrs_vardecl_33376_fields ib_qib_max_srq_wrs vardecl 0 33376 NULL
+xfs_buf_ioerror_fndecl_33390_fields xfs_buf_ioerror fndecl 2 33390 NULL
+stream_size_drm_etnaviv_gem_submit_33393_fields stream_size drm_etnaviv_gem_submit 0 33393 NULL
+data_offset_rndis_packet_33403_fields data_offset rndis_packet 0 33403 NULL
+lbmRead_fndecl_33420_fields lbmRead fndecl 2 33420 NULL
+dreq_gss_dccp_request_sock_33423_fields dreq_gss dccp_request_sock 0 33423 NULL nohasharray
+rsxx_cram_write_fndecl_33423_fields rsxx_cram_write fndecl 3 33423 &dreq_gss_dccp_request_sock_33423_fields
+offset_vb2_dma_sg_buf_33426_fields offset vb2_dma_sg_buf 0 33426 NULL
+intr_dma_usb_pcwd_private_33427_fields intr_dma usb_pcwd_private 0 33427 NULL
+tcp_fastretrans_alert_fndecl_33430_fields tcp_fastretrans_alert fndecl 2 33430 NULL
+change_mtu_fndecl_33432_fields change_mtu fndecl 2 33432 NULL nohasharray
+in_nextiag_dinomap_33432_fields in_nextiag dinomap 0 33432 &change_mtu_fndecl_33432_fields
+_nfs4_proc_readlink_fndecl_33436_fields _nfs4_proc_readlink fndecl 4-3 33436 NULL
+wqe_size_ib_uverbs_post_send_33437_fields wqe_size ib_uverbs_post_send 0 33437 NULL
+nilfs_set_nsegments_fndecl_33438_fields nilfs_set_nsegments fndecl 2 33438 NULL
+mmc_test_area_io_seq_fndecl_33440_fields mmc_test_area_io_seq fndecl 2-9 33440 NULL
+w_dloarea_33444_fields w dloarea 0 33444 NULL
+pskb_carve_frag_list_fndecl_33447_fields pskb_carve_frag_list fndecl 3 33447 NULL
+sys_mlock2_fndecl_33449_fields sys_mlock2 fndecl 1-2 33449 NULL
+mt7601u_mcu_msg_alloc_fndecl_33453_fields mt7601u_mcu_msg_alloc fndecl 3 33453 NULL
+ocfs2_divide_xattr_bucket_fndecl_33455_fields ocfs2_divide_xattr_bucket fndecl 3-4 33455 NULL
+max_recv_send_sge_ocrdma_mbx_query_config_33459_fields max_recv_send_sge ocrdma_mbx_query_config 0 33459 NULL
+tx_pipe_usbpn_dev_33474_fields tx_pipe usbpn_dev 0 33474 NULL
+packets_out_tcp_sock_33478_fields packets_out tcp_sock 0 33478 NULL
+__nbd_ioctl_fndecl_33480_fields __nbd_ioctl fndecl 4 33480 NULL
+ath6kl_buf_alloc_fndecl_33483_fields ath6kl_buf_alloc fndecl 1 33483 NULL
+ath6kl_wmi_cmd_send_fndecl_33493_fields ath6kl_wmi_cmd_send fndecl 2 33493 NULL
+root_size_adfs_discrecord_33498_fields root_size adfs_discrecord 0 33498 NULL
+end_io_dio_33500_fields end_io dio 0 33500 NULL
+ocfs2_xattr_shrink_size_fndecl_33507_fields ocfs2_xattr_shrink_size fndecl 3 33507 NULL
+check_mirror_fndecl_33517_fields check_mirror fndecl 2-1 33517 NULL
+len_writequeue_entry_33522_fields len writequeue_entry 0 33522 NULL
+offset_port_buffer_33530_fields offset port_buffer 0 33530 NULL
+ieee802154_hdr_addr_len_fndecl_33535_fields ieee802154_hdr_addr_len fndecl 0 33535 NULL
+sq_size_nes_hw_qp_33544_fields sq_size nes_hw_qp 0 33544 NULL nohasharray
+num_seq_vgastate_33544_fields num_seq vgastate 0 33544 &sq_size_nes_hw_qp_33544_fields
+tx_queues_nicvf_33546_fields tx_queues nicvf 0 33546 NULL
+dlfb_setup_modes_fndecl_33548_fields dlfb_setup_modes fndecl 4 33548 NULL
+cros_ec_cmd_xfer_fndecl_33549_fields cros_ec_cmd_xfer fndecl 0 33549 NULL
+mwifiex_create_ba_tbl_fndecl_33555_fields mwifiex_create_ba_tbl fndecl 3 33555 NULL
+nfc_llcp_build_sdreq_tlv_fndecl_33563_fields nfc_llcp_build_sdreq_tlv fndecl 3 33563 NULL
+snb_pci2phy_map_init_fndecl_33565_fields snb_pci2phy_map_init fndecl 1 33565 NULL
+recv_buf_size_netvsc_device_33569_fields recv_buf_size netvsc_device 0 33569 NULL nohasharray
+qlen_status_event_list_33569_fields qlen status_event_list 0 33569 &recv_buf_size_netvsc_device_33569_fields
+self_dnode_33580_fields self dnode 0 33580 NULL nohasharray
+lcm_fndecl_33580_fields lcm fndecl 0-2-1 33580 &self_dnode_33580_fields
+num_pports_hfi1_devdata_33581_fields num_pports hfi1_devdata 0 33581 NULL
+qed_sriov_enable_fndecl_33587_fields qed_sriov_enable fndecl 2 33587 NULL
+hdr_info_bnxt_tpa_info_33589_fields hdr_info bnxt_tpa_info 0 33589 NULL
+i2c_readregs_fndecl_33590_fields i2c_readregs fndecl 5 33590 NULL
+size_kmemleak_object_33591_fields size kmemleak_object 0 33591 NULL
+lde_namelen_lu_dirent_33595_fields lde_namelen lu_dirent 0 33595 NULL
+fsl_spi_bufs_fndecl_33599_fields fsl_spi_bufs fndecl 0 33599 NULL
+max_header_size_iriap_cb_33603_fields max_header_size iriap_cb 0 33603 NULL
+offset_hsu_dma_chip_33607_fields offset hsu_dma_chip 0 33607 NULL
+drm_prime_pages_to_sg_fndecl_33612_fields drm_prime_pages_to_sg fndecl 2 33612 NULL
+hfsplus_find_cat_fndecl_33616_fields hfsplus_find_cat fndecl 0 33616 NULL nohasharray
+names_size_ceph_inode_xattrs_info_33616_fields names_size ceph_inode_xattrs_info 0 33616 &hfsplus_find_cat_fndecl_33616_fields
+lpfc_gen_req_fndecl_33617_fields lpfc_gen_req fndecl 8 33617 NULL
+first_data_sg_off_iscsi_cmd_33628_fields first_data_sg_off iscsi_cmd 0 33628 NULL
+data_size_kretprobe_33633_fields data_size kretprobe 0 33633 NULL
+size_dma_buf_33648_fields size dma_buf 0 33648 NULL nohasharray
+s_want_extra_isize_ext4_sb_info_33648_fields s_want_extra_isize ext4_sb_info 0 33648 &size_dma_buf_33648_fields
+check_header_fndecl_33649_fields check_header fndecl 2 33649 NULL
+intel_engine_create_ringbuffer_fndecl_33650_fields intel_engine_create_ringbuffer fndecl 2 33650 NULL
+xfs_alloc_ag_vextent_fndecl_33660_fields xfs_alloc_ag_vextent fndecl 0 33660 NULL
+savage_init_hw_fndecl_33678_fields savage_init_hw fndecl 0 33678 NULL
+size_drm_exynos_gem_create_33679_fields size drm_exynos_gem_create 0 33679 NULL
+data_size_vxge_rx_priv_33684_fields data_size vxge_rx_priv 0 33684 NULL
+len_scif_copy_work_33687_fields len scif_copy_work 0 33687 NULL
+mb_find_order_for_block_fndecl_33691_fields mb_find_order_for_block fndecl 0 33691 NULL
+ide_cdrom_probe_capabilities_fndecl_33699_fields ide_cdrom_probe_capabilities fndecl 0 33699 NULL
+alignment_offset_queue_limits_33701_fields alignment_offset queue_limits 0 33701 NULL
+jffs2_sum_write_data_fndecl_33705_fields jffs2_sum_write_data fndecl 3-4 33705 NULL nohasharray
+mmc_test_map_sg_max_scatter_fndecl_33705_fields mmc_test_map_sg_max_scatter fndecl 2-5 33705 &jffs2_sum_write_data_fndecl_33705_fields
+calculate_memsize_fndecl_33706_fields calculate_memsize fndecl 0-5-3-4-2-1 33706 NULL
+network_header_sk_buff_33708_fields network_header sk_buff 0 33708 NULL
+out_phase_usb_stream_kernel_33720_fields out_phase usb_stream_kernel 0 33720 NULL
+video_height_sis_video_info_33732_fields video_height sis_video_info 0 33732 NULL nohasharray
+atwrite_submit_fndecl_33732_fields atwrite_submit fndecl 3 33732 &video_height_sis_video_info_33732_fields
+amdgpu_bo_create_fndecl_33733_fields amdgpu_bo_create fndecl 2 33733 NULL nohasharray
+hpfs_bmap_fndecl_33733_fields hpfs_bmap fndecl 2-0 33733 &amdgpu_bo_create_fndecl_33733_fields
+xres_fb_var_screeninfo_33734_fields xres fb_var_screeninfo 0 33734 NULL
+ovl_copy_up_data_fndecl_33738_fields ovl_copy_up_data fndecl 3 33738 NULL
+d_sz_rsa_key_33741_fields d_sz rsa_key 0 33741 NULL
+do_pwritev_fndecl_33742_fields do_pwritev fndecl 3 33742 NULL
+i915_gem_object_create_fndecl_33744_fields i915_gem_object_create fndecl 2 33744 NULL nohasharray
+aircable_process_packet_fndecl_33744_fields aircable_process_packet fndecl 4 33744 &i915_gem_object_create_fndecl_33744_fields
+lengthComponentIdent_pathComponent_33758_fields lengthComponentIdent pathComponent 0 33758 NULL
+avr_ack_ptr_dccp_ackvec_record_33759_fields avr_ack_ptr dccp_ackvec_record 0 33759 NULL
+cim_la_size_adapter_params_33761_fields cim_la_size adapter_params 0 33761 NULL
+efx_farch_dimension_resources_fndecl_33764_fields efx_farch_dimension_resources fndecl 2 33764 NULL
+default_bpp_vardecl_sm501fb_c_33765_fields default_bpp vardecl_sm501fb.c 0 33765 NULL
+wmi_send_fndecl_33768_fields wmi_send fndecl 4 33768 NULL
+status_ffs_ep_33781_fields status ffs_ep 0 33781 NULL
+cx2341x_ctrl_new_std_fndecl_33782_fields cx2341x_ctrl_new_std fndecl 3-6 33782 NULL
+max_gpios_rdc321x_gpio_pdata_33783_fields max_gpios rdc321x_gpio_pdata 0 33783 NULL
+fm_mapped_extents_ll_user_fiemap_33785_fields fm_mapped_extents ll_user_fiemap 0 33785 NULL
+sis190_try_rx_copy_fndecl_33790_fields sis190_try_rx_copy fndecl 3 33790 NULL
+sd_write_data_fndecl_33792_fields sd_write_data fndecl 5 33792 NULL
+icv_truncbits_xfrm_algo_auth_info_33798_fields icv_truncbits xfrm_algo_auth_info 0 33798 NULL
+__ip_tun_to_nlattr_fndecl_33801_fields __ip_tun_to_nlattr fndecl 4 33801 NULL
+page_size_vmw_cmdbuf_alloc_info_33815_fields page_size vmw_cmdbuf_alloc_info 0 33815 NULL
+custom_length_iscsi_stats_33819_fields custom_length iscsi_stats 0 33819 NULL
+snd_find_free_minor_fndecl_33820_fields snd_find_free_minor fndecl 0 33820 NULL
+mult_usb_ep_33831_fields mult usb_ep 0 33831 NULL
+selinux_setprocattr_fndecl_33832_fields selinux_setprocattr fndecl 4 33832 NULL
+blk_size_ide_tape_obj_33837_fields blk_size ide_tape_obj 0 33837 NULL
+targetsize_xt_target_33840_fields targetsize xt_target 0 33840 NULL
+depth_drm_vmw_size_33842_fields depth drm_vmw_size 0 33842 NULL
+mgmt_cmd_complete_fndecl_33845_fields mgmt_cmd_complete fndecl 6 33845 NULL
+add_partition_fndecl_33847_fields add_partition fndecl 3-4 33847 NULL
+sctp_addto_chunk_fixed_fndecl_33853_fields sctp_addto_chunk_fixed fndecl 2 33853 NULL
+dvb_dmxdev_set_buffer_size_fndecl_33864_fields dvb_dmxdev_set_buffer_size fndecl 2 33864 NULL
+h5_link_control_fndecl_33866_fields h5_link_control fndecl 3 33866 NULL
+edge_tty_recv_fndecl_33877_fields edge_tty_recv fndecl 3 33877 NULL
+tolen_nfs_linkargs_33881_fields tolen nfs_linkargs 0 33881 NULL nohasharray
+walk_system_ram_res_fndecl_33881_fields walk_system_ram_res fndecl 2-1 33881 &tolen_nfs_linkargs_33881_fields
+src_len_ccp_xts_aes_engine_33899_fields src_len ccp_xts_aes_engine 0 33899 NULL
+init_stripe_fndecl_33902_fields init_stripe fndecl 2 33902 NULL
+xfs_bmbt_maxrecs_fndecl_33906_fields xfs_bmbt_maxrecs fndecl 0 33906 NULL
+_install_special_mapping_fndecl_33907_fields _install_special_mapping fndecl 2-3 33907 NULL
+rx_desc_count_xgbe_prv_data_33915_fields rx_desc_count xgbe_prv_data 0 33915 NULL
+w83627hf_device_add_fndecl_33919_fields w83627hf_device_add fndecl 1 33919 NULL
+wil_vring_alloc_skb_fndecl_33924_fields wil_vring_alloc_skb fndecl 4 33924 NULL
+size_cmdline_vardecl_dma_contiguous_c_33925_fields size_cmdline vardecl_dma-contiguous.c 0 33925 NULL
+max_channels_snd_midi_channel_set_33931_fields max_channels snd_midi_channel_set 0 33931 NULL
+numa_add_memblk_to_fndecl_33934_fields numa_add_memblk_to fndecl 2-3 33934 NULL nohasharray
+tcp_push_fndecl_33934_fields tcp_push fndecl 3 33934 &numa_add_memblk_to_fndecl_33934_fields nohasharray
+isl1208_i2c_set_regs_fndecl_33934_fields isl1208_i2c_set_regs fndecl 4 33934 &tcp_push_fndecl_33934_fields
+pci_scan_device_fndecl_33935_fields pci_scan_device fndecl 2 33935 NULL
+bulk_in_usbatm_driver_33939_fields bulk_in usbatm_driver 0 33939 NULL
+wMaxPacketSize_usb_endpoint_descriptor_33942_fields wMaxPacketSize usb_endpoint_descriptor 0 33942 NULL
+ext4_alloc_file_blocks_fndecl_33946_fields ext4_alloc_file_blocks fndecl 2-3 33946 NULL
+i_first_extent_iso_inode_info_33947_fields i_first_extent iso_inode_info 0 33947 NULL
+tcp_yeah_cong_avoid_fndecl_33950_fields tcp_yeah_cong_avoid fndecl 3 33950 NULL
+num_rsp_hci_inquiry_req_33953_fields num_rsp hci_inquiry_req 0 33953 NULL
+lpfc_sg_seg_cnt_vardecl_lpfc_attr_c_33956_fields lpfc_sg_seg_cnt vardecl_lpfc_attr.c 0 33956 NULL
+resid_rxe_dma_info_33963_fields resid rxe_dma_info 0 33963 NULL
+ext4_get_block_fndecl_33967_fields ext4_get_block fndecl 2 33967 NULL
+nfc_hci_send_cmd_fndecl_33969_fields nfc_hci_send_cmd fndecl 5 33969 NULL
+ocfs2_lock_refcount_tree_fndecl_33972_fields ocfs2_lock_refcount_tree fndecl 2 33972 NULL nohasharray
+mtdswap_init_fndecl_33972_fields mtdswap_init fndecl 2 33972 &ocfs2_lock_refcount_tree_fndecl_33972_fields
+st_nci_hci_dm_get_info_fndecl_33973_fields st_nci_hci_dm_get_info fndecl 3 33973 NULL
+virtio_transport_stream_do_dequeue_fndecl_33977_fields virtio_transport_stream_do_dequeue fndecl 3 33977 NULL
+buf_len_wmi_tlv_mgmt_rx_ev_33979_fields buf_len wmi_tlv_mgmt_rx_ev 0 33979 NULL
+usbat_bulk_write_fndecl_33983_fields usbat_bulk_write fndecl 3 33983 NULL
+unit_off_ore_striping_info_33989_fields unit_off ore_striping_info 0 33989 NULL
+size_fjes_hw_resource_33991_fields size fjes_hw_resource 0 33991 NULL
+sectorsize_scrub_ctx_33993_fields sectorsize scrub_ctx 0 33993 NULL
+num_ioim_reqs_bfa_iocfc_fwcfg_s_33994_fields num_ioim_reqs bfa_iocfc_fwcfg_s 0 33994 NULL
+batadv_tvlv_unicast_send_fndecl_34005_fields batadv_tvlv_unicast_send fndecl 7 34005 NULL
+rxextrahdrroom_dma_info_34007_fields rxextrahdrroom dma_info 0 34007 NULL
+ctxtcnt_qib_devdata_34012_fields ctxtcnt qib_devdata 0 34012 NULL
+size_vmw_cotable_info_34013_fields size vmw_cotable_info 0 34013 NULL
+wl12xx_spi_raw_read_fndecl_34014_fields wl12xx_spi_raw_read fndecl 4 34014 NULL nohasharray
+set_local_name_fndecl_34014_fields set_local_name fndecl 4 34014 &wl12xx_spi_raw_read_fndecl_34014_fields
+parent_len_fndecl_34020_fields parent_len fndecl 0 34020 NULL
+membase_jsm_board_34030_fields membase jsm_board 0 34030 NULL
+size_edac_mc_layer_34031_fields size edac_mc_layer 0 34031 NULL nohasharray
+b_cnt_chip_select_34031_fields b_cnt chip_select 0 34031 &size_edac_mc_layer_34031_fields
+strlen_fndecl_34033_fields strlen fndecl 0 34033 NULL
+blksize_sdio_cis_34036_fields blksize sdio_cis 0 34036 NULL
+sector_number_blkif_request_discard_34039_fields sector_number blkif_request_discard 0 34039 NULL
+req_bio_endio_fndecl_34041_fields req_bio_endio fndecl 3-4 34041 NULL
+len_hdlcdrv_hdlcrx_34043_fields len hdlcdrv_hdlcrx 0 34043 NULL
+dma_size_nx_host_rds_ring_34047_fields dma_size nx_host_rds_ring 0 34047 NULL
+ide_do_setfeature_fndecl_34050_fields ide_do_setfeature fndecl 3 34050 NULL
+sys_mmap_pgoff_fndecl_34056_fields sys_mmap_pgoff fndecl 2 34056 NULL
+cdc_ncm_change_mtu_fndecl_34062_fields cdc_ncm_change_mtu fndecl 2 34062 NULL
+wb_bytes_nfs_page_34071_fields wb_bytes nfs_page 0 34071 NULL nohasharray
+memmap_exclude_ranges_fndecl_34071_fields memmap_exclude_ranges fndecl 3-4 34071 &wb_bytes_nfs_page_34071_fields nohasharray
+opt_val_tcp_repair_opt_34071_fields opt_val tcp_repair_opt 0 34071 &memmap_exclude_ranges_fndecl_34071_fields
+qp_alloc_guest_work_fndecl_34074_fields qp_alloc_guest_work fndecl 5-3 34074 NULL nohasharray
+__get_vm_area_node_fndecl_34074_fields __get_vm_area_node fndecl 4-2 34074 &qp_alloc_guest_work_fndecl_34074_fields
+test_extent_accounting_fndecl_34078_fields test_extent_accounting fndecl 1-2 34078 NULL
+rec_len_ext2_dir_entry_2_34086_fields rec_len ext2_dir_entry_2 0 34086 NULL nohasharray
+get_info_tcp_congestion_ops_34086_fields get_info tcp_congestion_ops 0 34086 &rec_len_ext2_dir_entry_2_34086_fields
+mst_node_alsz_ubifs_info_34087_fields mst_node_alsz ubifs_info 0 34087 NULL
+LFBsize_sis_video_info_34089_fields LFBsize sis_video_info 0 34089 NULL
+sync_page_io_fndecl_34091_fields sync_page_io fndecl 3-2 34091 NULL nohasharray
+restore_node_summary_fndecl_34091_fields restore_node_summary fndecl 2 34091 &sync_page_io_fndecl_34091_fields
+__memblock_alloc_base_fndecl_34092_fields __memblock_alloc_base fndecl 2-0-3 34092 NULL
+octeon_setup_iq_fndecl_34094_fields octeon_setup_iq fndecl 5 34094 NULL
+dccm_len_iwl_cfg_34095_fields dccm_len iwl_cfg 0 34095 NULL
+max_frame_ft_sess_34098_fields max_frame ft_sess 0 34098 NULL
+encap_hlen_ip6_tnl_34101_fields encap_hlen ip6_tnl 0 34101 NULL
+c_chmask_f_uac2_opts_34103_fields c_chmask f_uac2_opts 0 34103 NULL
+reg_read_fndecl_34106_fields reg_read fndecl 0 34106 NULL
+do_shmat_fndecl_34107_fields do_shmat fndecl 5 34107 NULL
+__wa_xfer_setup_sizes_fndecl_34109_fields __wa_xfer_setup_sizes fndecl 0 34109 NULL
+lcd_right_margin_atyfb_par_34110_fields lcd_right_margin atyfb_par 0 34110 NULL
+reserved_eq_mlx4_func_cap_34117_fields reserved_eq mlx4_func_cap 0 34117 NULL
+chunk_size_lirc_driver_34118_fields chunk_size lirc_driver 0 34118 NULL
+qxl_alloc_bo_reserved_fndecl_34119_fields qxl_alloc_bo_reserved fndecl 3 34119 NULL
+nf_nat_ipv4_manip_pkt_fndecl_34120_fields nf_nat_ipv4_manip_pkt fndecl 2 34120 NULL
+cw1200_sdio_align_size_fndecl_34124_fields cw1200_sdio_align_size fndecl 2 34124 NULL nohasharray
+size_qlcnic_fw_dump_34124_fields size qlcnic_fw_dump 0 34124 &cw1200_sdio_align_size_fndecl_34124_fields
+nfs_vmtruncate_fndecl_34126_fields nfs_vmtruncate fndecl 2 34126 NULL
+ovs_fragment_fndecl_34127_fields ovs_fragment fndecl 4 34127 NULL
+dst_width_snd_pcm_plugin_34144_fields dst_width snd_pcm_plugin 0 34144 NULL
+object_size_kmem_cache_34151_fields object_size kmem_cache 0 34151 NULL
+vmax_packet_size_pwc_device_34153_fields vmax_packet_size pwc_device 0 34153 NULL
+sky2_change_mtu_fndecl_34157_fields sky2_change_mtu fndecl 2 34157 NULL nohasharray
+data_size_dm_ulog_request_34157_fields data_size dm_ulog_request 0 34157 &sky2_change_mtu_fndecl_34157_fields
+nb_if_sdio_packet_34158_fields nb if_sdio_packet 0 34158 NULL nohasharray
+usb_pipe_ua101_stream_34158_fields usb_pipe ua101_stream 0 34158 &nb_if_sdio_packet_34158_fields nohasharray
+max_requests_rpcrdma_create_data_internal_34158_fields max_requests rpcrdma_create_data_internal 0 34158 &usb_pipe_ua101_stream_34158_fields
+krb5_decrypt_fndecl_34166_fields krb5_decrypt fndecl 5 34166 NULL
+save_mr_fndecl_34167_fields save_mr fndecl 4 34167 NULL
+blockmask_sddr55_card_info_34172_fields blockmask sddr55_card_info 0 34172 NULL
+osst_seek_sector_fndecl_34173_fields osst_seek_sector fndecl 3 34173 NULL nohasharray
+ucNumEntries__ATOM_Polaris10_PCIE_Table_34173_fields ucNumEntries _ATOM_Polaris10_PCIE_Table 0 34173 &osst_seek_sector_fndecl_34173_fields
+buffers_pipe_inode_info_34187_fields buffers pipe_inode_info 0 34187 NULL
+sys_recv_fndecl_34188_fields sys_recv fndecl 3 34188 NULL
+new_oblock_dm_cache_migration_34189_fields new_oblock dm_cache_migration 0 34189 NULL
+length_dm_target_spec_34193_fields length dm_target_spec 0 34193 NULL
+write_room_tty_operations_34200_fields write_room tty_operations 0 34200 NULL
+cxgb4vf_change_mtu_fndecl_34204_fields cxgb4vf_change_mtu fndecl 2 34204 NULL
+cx23888_ir_rx_read_fndecl_34210_fields cx23888_ir_rx_read fndecl 3 34210 NULL
+dw_msi_setup_irqs_fndecl_34216_fields dw_msi_setup_irqs fndecl 3 34216 NULL
+new_sync_write_fndecl_34217_fields new_sync_write fndecl 3-0 34217 NULL
+ext4_expand_extra_isize_fndecl_34225_fields ext4_expand_extra_isize fndecl 2 34225 NULL nohasharray
+first_psn_rxe_send_wqe_34225_fields first_psn rxe_send_wqe 0 34225 &ext4_expand_extra_isize_fndecl_34225_fields
+segno_sit_journal_entry_34226_fields segno sit_journal_entry 0 34226 NULL
+ath6kl_wmi_simple_cmd_fndecl_34229_fields ath6kl_wmi_simple_cmd fndecl 2 34229 NULL
+isdnhdlc_decode_fndecl_34233_fields isdnhdlc_decode fndecl 0 34233 NULL nohasharray
+m_len_s_mbuf_34233_fields m_len s_mbuf 0 34233 &isdnhdlc_decode_fndecl_34233_fields
+cfpkt_pad_trail_fndecl_34244_fields cfpkt_pad_trail fndecl 2 34244 NULL
+agno_xfs_extent_busy_34245_fields agno xfs_extent_busy 0 34245 NULL
+rss_cpus_vardecl_efx_c_34253_fields rss_cpus vardecl_efx.c 0 34253 NULL nohasharray
+pktgen_finalize_skb_fndecl_34253_fields pktgen_finalize_skb fndecl 3 34253 &rss_cpus_vardecl_efx_c_34253_fields
+__reserve_region_with_split_fndecl_34259_fields __reserve_region_with_split fndecl 3-2 34259 NULL nohasharray
+regmap_encx24j600_spi_read_fndecl_34259_fields regmap_encx24j600_spi_read fndecl 4 34259 &__reserve_region_with_split_fndecl_34259_fields
+status_tulip_rx_desc_34260_fields status tulip_rx_desc 0 34260 NULL
+MaxTransactSize_smb2_negotiate_rsp_34261_fields MaxTransactSize smb2_negotiate_rsp 0 34261 NULL
+count_igbvf_ring_34264_fields count igbvf_ring 0 34264 NULL
+metadata_dst_alloc_percpu_fndecl_34267_fields metadata_dst_alloc_percpu fndecl 1 34267 NULL nohasharray
+nvdimm_create_fndecl_34267_fields nvdimm_create fndecl 6 34267 &metadata_dst_alloc_percpu_fndecl_34267_fields
+reg_read_smsc911x_ops_34274_fields reg_read smsc911x_ops 0 34274 NULL
+max_segs_mmc_host_34276_fields max_segs mmc_host 0 34276 NULL nohasharray
+tty_port_register_device_fndecl_34276_fields tty_port_register_device fndecl 3 34276 &max_segs_mmc_host_34276_fields
+btt_map_read_fndecl_34281_fields btt_map_read fndecl 0 34281 NULL
+buf_len_wmi_10_4_mgmt_rx_hdr_34285_fields buf_len wmi_10_4_mgmt_rx_hdr 0 34285 NULL
+ocfs2_group_from_res_fndecl_34289_fields ocfs2_group_from_res fndecl 0 34289 NULL
+cpu_msix_table_sz_MPT3SAS_ADAPTER_34295_fields cpu_msix_table_sz MPT3SAS_ADAPTER 0 34295 NULL
+skb_coalesce_rx_frag_fndecl_34296_fields skb_coalesce_rx_frag fndecl 3-4 34296 NULL
+__nla_put_64bit_fndecl_34299_fields __nla_put_64bit fndecl 3 34299 NULL
+fl_pg_order_sge_34307_fields fl_pg_order sge 0 34307 NULL
+p1_FS_QENTRY_34311_fields p1 FS_QENTRY 0 34311 NULL
+usb6fire_pcm_init_urb_fndecl_34318_fields usb6fire_pcm_init_urb fndecl 4 34318 NULL
+vmw_kms_sou_do_dmabuf_dirty_fndecl_34319_fields vmw_kms_sou_do_dmabuf_dirty fndecl 5 34319 NULL
+acm_tty_write_fndecl_34323_fields acm_tty_write fndecl 3 34323 NULL
+usb_alloc_stream_buffers_fndecl_34344_fields usb_alloc_stream_buffers fndecl 3 34344 NULL
+get_bad_peb_limit_fndecl_34374_fields get_bad_peb_limit fndecl 0-2 34374 NULL
+r_minimode_34384_fields r minimode 0 34384 NULL
+pfn_mthca_uar_34385_fields pfn mthca_uar 0 34385 NULL
+vd_blocknr_nilfs_vdesc_34386_fields vd_blocknr nilfs_vdesc 0 34386 NULL
+mlxsw_emad_transmit_fndecl_34390_fields mlxsw_emad_transmit fndecl 0 34390 NULL
+ath6kl_wmi_set_inact_period_fndecl_34398_fields ath6kl_wmi_set_inact_period fndecl 2 34398 NULL
+min_scaled_height_bttv_crop_34408_fields min_scaled_height bttv_crop 0 34408 NULL
+__i2c_transfer_fndecl_34417_fields __i2c_transfer fndecl 0 34417 NULL
+w_minimode_34418_fields w minimode 0 34418 NULL
+fragsize_inet_cork_34425_fields fragsize inet_cork 0 34425 NULL
+vs_xdrsize_svc_version_34426_fields vs_xdrsize svc_version 0 34426 NULL
+ctrl_set_res_ver_fndecl_34447_fields ctrl_set_res_ver fndecl 3 34447 NULL
+window_len_regmap_range_node_34449_fields window_len regmap_range_node 0 34449 NULL
+copy_size_vmxnet3_tx_ctx_34453_fields copy_size vmxnet3_tx_ctx 0 34453 NULL
+exceptions_per_area_pstore_34460_fields exceptions_per_area pstore 0 34460 NULL
+len_gsm_msg_34461_fields len gsm_msg 0 34461 NULL
+num_regs_regmap_irq_chip_34465_fields num_regs regmap_irq_chip 0 34465 NULL
+MaxCommands_DAC960_V1_Enquiry_34475_fields MaxCommands DAC960_V1_Enquiry 0 34475 NULL
+start_btrfs_ordered_extent_34479_fields start btrfs_ordered_extent 0 34479 NULL
+i2c_hid_command_fndecl_34481_fields i2c_hid_command fndecl 4 34481 NULL
+dma_bd_table_34490_fields dma bd_table 0 34490 NULL
+do_ipt_set_ctl_fndecl_34493_fields do_ipt_set_ctl fndecl 4 34493 NULL
+w_virtio_gpu_box_34509_fields w virtio_gpu_box 0 34509 NULL
+overflow_maj_vardecl_user_mad_c_34524_fields overflow_maj vardecl_user_mad.c 0 34524 NULL
+SavagePanelHeight_savagefb_par_34532_fields SavagePanelHeight savagefb_par 0 34532 NULL
+track_pfn_remap_fndecl_34534_fields track_pfn_remap fndecl 3-5 34534 NULL nohasharray
+width_pcs_device_34534_fields width pcs_device 0 34534 &track_pfn_remap_fndecl_34534_fields
+tid_ieee80211_rx_agg_34536_fields tid ieee80211_rx_agg 0 34536 NULL
+total_vfs_qed_hw_sriov_info_34538_fields total_vfs qed_hw_sriov_info 0 34538 NULL
+resid_sg_io_hdr_34541_fields resid sg_io_hdr 0 34541 NULL
+host_size_scsi_transport_template_34551_fields host_size scsi_transport_template 0 34551 NULL
+maxpacket_limit_usb_ep_34566_fields maxpacket_limit usb_ep 0 34566 NULL
+opt_xfer_blocks_scsi_disk_34567_fields opt_xfer_blocks scsi_disk 0 34567 NULL
+blkno_range2trim_34581_fields blkno range2trim 0 34581 NULL
+dwc3_ep0_start_trans_fndecl_34586_fields dwc3_ep0_start_trans fndecl 4 34586 NULL
+blk_queue_alignment_offset_fndecl_34591_fields blk_queue_alignment_offset fndecl 2 34591 NULL
+hcd_alloc_coherent_fndecl_34597_fields hcd_alloc_coherent fndecl 0-5 34597 NULL
+min_resource_constraint_34598_fields min resource_constraint 0 34598 NULL
+ath6kl_wmi_data_hdr_add_fndecl_34601_fields ath6kl_wmi_data_hdr_add fndecl 8 34601 NULL
+sys_sync_file_range_fndecl_34604_fields sys_sync_file_range fndecl 2-3 34604 NULL
+__check_block_validity_fndecl_34606_fields __check_block_validity fndecl 0 34606 NULL
+end_shift_iwl_fw_dbg_dest_tlv_34608_fields end_shift iwl_fw_dbg_dest_tlv 0 34608 NULL
+fip_dlen_fip_desc_34614_fields fip_dlen fip_desc 0 34614 NULL
+vram_total_vardecl_vesafb_c_34615_fields vram_total vardecl_vesafb.c 0 34615 NULL nohasharray
+size_vb2_vmalloc_buf_34615_fields size vb2_vmalloc_buf 0 34615 &vram_total_vardecl_vesafb_c_34615_fields
+undo_cwnd_tcp_congestion_ops_34621_fields undo_cwnd tcp_congestion_ops 0 34621 NULL
+ace_change_mtu_fndecl_34639_fields ace_change_mtu fndecl 2 34639 NULL
+xfs_free_ag_extent_fndecl_34658_fields xfs_free_ag_extent fndecl 5-0 34658 NULL
+init_evtlog_size_iwl_fw_34663_fields init_evtlog_size iwl_fw 0 34663 NULL
+num_chip_htcpld_core_platform_data_34665_fields num_chip htcpld_core_platform_data 0 34665 NULL
+ext4_convert_unwritten_extents_endio_fndecl_34667_fields ext4_convert_unwritten_extents_endio fndecl 0 34667 NULL
+num_leaves_cpu_cacheinfo_34676_fields num_leaves cpu_cacheinfo 0 34676 NULL
+pnp_add_mem_resource_fndecl_34681_fields pnp_add_mem_resource fndecl 3-2 34681 NULL
+offset_ethtool_eeprom_34683_fields offset ethtool_eeprom 0 34683 NULL
+bassinit_CHIPDESC_34688_fields bassinit CHIPDESC 0 34688 NULL
+acpi_tables_addr_vardecl_tables_c_34693_fields acpi_tables_addr vardecl_tables.c 0 34693 NULL
+max_payload_fc_fcp_pkt_34696_fields max_payload fc_fcp_pkt 0 34696 NULL
+writesize_mtd_info_34702_fields writesize mtd_info 0 34702 NULL nohasharray
+jbd2_journal_file_inode_fndecl_34702_fields jbd2_journal_file_inode fndecl 0 34702 &writesize_mtd_info_34702_fields
+efi_memmap_efi_info_34704_fields efi_memmap efi_info 0 34704 NULL
+gfs2_log_alloc_bio_fndecl_34714_fields gfs2_log_alloc_bio fndecl 2 34714 NULL
+in_sector_offset_vardecl_floppy_c_34720_fields in_sector_offset vardecl_floppy.c 0 34720 NULL
+cache_word_size_regmap_34722_fields cache_word_size regmap 0 34722 NULL
+W6692_empty_Dfifo_fndecl_34725_fields W6692_empty_Dfifo fndecl 2 34725 NULL nohasharray
+tx_num_pgs_tp_params_34725_fields tx_num_pgs tp_params 0 34725 &W6692_empty_Dfifo_fndecl_34725_fields
+ocfs2_dx_dir_format_cluster_fndecl_34730_fields ocfs2_dx_dir_format_cluster fndecl 6 34730 NULL nohasharray
+eqc_entry_sz_mlx4_dev_cap_34730_fields eqc_entry_sz mlx4_dev_cap 0 34730 &ocfs2_dx_dir_format_cluster_fndecl_34730_fields
+wa_xfer_create_subset_sg_fndecl_34731_fields wa_xfer_create_subset_sg fndecl 2-3 34731 NULL
+memblock_double_array_fndecl_34732_fields memblock_double_array fndecl 3-2 34732 NULL
+trunc_start_fndecl_34735_fields trunc_start fndecl 3-2 34735 NULL
+flags_rtl8187b_rx_hdr_34741_fields flags rtl8187b_rx_hdr 0 34741 NULL
+inbuf_dma_usbhid_device_34742_fields inbuf_dma usbhid_device 0 34742 NULL
+u132_hcd_bulk_input_recv_fndecl_34756_fields u132_hcd_bulk_input_recv fndecl 4 34756 NULL
+extent_size_ecryptfs_crypt_stat_34757_fields extent_size ecryptfs_crypt_stat 0 34757 NULL nohasharray
+zone_spare_adfs_discrecord_34757_fields zone_spare adfs_discrecord 0 34757 &extent_size_ecryptfs_crypt_stat_34757_fields nohasharray
+ecc_bits_onfi_ext_ecc_info_34757_fields ecc_bits onfi_ext_ecc_info 0 34757 &zone_spare_adfs_discrecord_34757_fields
+ssb_bus_pcmciabus_register_fndecl_34759_fields ssb_bus_pcmciabus_register fndecl 3 34759 NULL
+qla2x00_mem_alloc_fndecl_34771_fields qla2x00_mem_alloc fndecl 3-2 34771 NULL
+hvt_op_write_fndecl_34774_fields hvt_op_write fndecl 3 34774 NULL
+cyapa_i2c_pip_read_fndecl_34788_fields cyapa_i2c_pip_read fndecl 3 34788 NULL
+qxl_image_alloc_objects_fndecl_34790_fields qxl_image_alloc_objects fndecl 4-5 34790 NULL
+addrlen_svc_deferred_req_34794_fields addrlen svc_deferred_req 0 34794 NULL
+rq_count_st_card_info_34798_fields rq_count st_card_info 0 34798 NULL
+nfs_write_end_fndecl_34801_fields nfs_write_end fndecl 3-5 34801 NULL
+prepare_message_data_fndecl_34802_fields prepare_message_data fndecl 2 34802 NULL
+page_size_flash_info_34810_fields page_size flash_info 0 34810 NULL
+rcv_array_groups_hfi1_ctxtdata_34813_fields rcv_array_groups hfi1_ctxtdata 0 34813 NULL nohasharray
+bio_integrity_clone_fndecl_34813_fields bio_integrity_clone fndecl 0 34813 &rcv_array_groups_hfi1_ctxtdata_34813_fields
+blk_cnt_os_dat_entry_s_34817_fields blk_cnt os_dat_entry_s 0 34817 NULL
+max_headroom_datapath_34819_fields max_headroom datapath 0 34819 NULL
+lbs_lowsnr_write_fndecl_34822_fields lbs_lowsnr_write fndecl 3 34822 NULL
+alg_key_len_xfrm_algo_34823_fields alg_key_len xfrm_algo 0 34823 NULL nohasharray
+wps_ie_len_mwifiex_private_34823_fields wps_ie_len mwifiex_private 0 34823 &alg_key_len_xfrm_algo_34823_fields
+madvise_behavior_fndecl_34827_fields madvise_behavior fndecl 4-3 34827 NULL
+mwifiex_usb_submit_rx_urb_fndecl_34829_fields mwifiex_usb_submit_rx_urb fndecl 2 34829 NULL
+rcvegrbufs_perchunk_qib_ctxtdata_34831_fields rcvegrbufs_perchunk qib_ctxtdata 0 34831 NULL
+xenvif_check_gop_fndecl_34832_fields xenvif_check_gop fndecl 0 34832 NULL
+eblks_mtdswap_dev_34840_fields eblks mtdswap_dev 0 34840 NULL
+in_usbnet_34842_fields in usbnet 0 34842 NULL
+dma_channels_hidma_mgmt_dev_34844_fields dma_channels hidma_mgmt_dev 0 34844 NULL
+plen_pbn_entry_34845_fields plen pbn_entry 0 34845 NULL
+qede_gro_receive_fndecl_34847_fields qede_gro_receive fndecl 4 34847 NULL
+vma_end_reservation_fndecl_34848_fields vma_end_reservation fndecl 3 34848 NULL nohasharray
+ath6kl_wmi_create_pstream_cmd_fndecl_34848_fields ath6kl_wmi_create_pstream_cmd fndecl 2 34848 &vma_end_reservation_fndecl_34848_fields
+nfsd_vfs_write_fndecl_34850_fields nfsd_vfs_write fndecl 6 34850 NULL
+good_peb_count_ubi_device_34853_fields good_peb_count ubi_device 0 34853 NULL
+nilfs_ioctl_do_get_suinfo_fndecl_34854_fields nilfs_ioctl_do_get_suinfo fndecl 6 34854 NULL
+max_msix_vectors_fm10k_mac_info_34860_fields max_msix_vectors fm10k_mac_info 0 34860 NULL
+tipc_link_set_mtu_fndecl_34861_fields tipc_link_set_mtu fndecl 2 34861 NULL
+pfkey_recvmsg_fndecl_34863_fields pfkey_recvmsg fndecl 3 34863 NULL
+odm_num_comps_pnfs_osd_data_map_34865_fields odm_num_comps pnfs_osd_data_map 0 34865 NULL
+sddr09_writeX_fndecl_34870_fields sddr09_writeX fndecl 5 34870 NULL
+dout_xfer_len_sg_io_v4_34879_fields dout_xfer_len sg_io_v4 0 34879 NULL
+bgx_get_lmac_count_fndecl_34883_fields bgx_get_lmac_count fndecl 0 34883 NULL
+drm_cvt_mode_fndecl_34886_fields drm_cvt_mode fndecl 3-2-4 34886 NULL
+Wa_tvnorm_34892_fields Wa tvnorm 0 34892 NULL
+len_coda_ioctl_out_34894_fields len coda_ioctl_out 0 34894 NULL
+sb_logstart_xfs_sb_34900_fields sb_logstart xfs_sb 0 34900 NULL
+fat_ent_read_fndecl_34902_fields fat_ent_read fndecl 0-3 34902 NULL
+block_size_ath6kl_mbox_info_34904_fields block_size ath6kl_mbox_info 0 34904 NULL
+num_channels_ad5380_chip_info_34917_fields num_channels ad5380_chip_info 0 34917 NULL nohasharray
+irq_of_parse_and_map_fndecl_34917_fields irq_of_parse_and_map fndecl 0 34917 &num_channels_ad5380_chip_info_34917_fields
+ath10k_htc_alloc_skb_fndecl_34920_fields ath10k_htc_alloc_skb fndecl 2 34920 NULL
+consume_size_vmci_qp_alloc_info_34922_fields consume_size vmci_qp_alloc_info 0 34922 NULL
+shared_secret_len_net_conf_34926_fields shared_secret_len net_conf 0 34926 NULL
+len_wil6210_mbox_hdr_34930_fields len wil6210_mbox_hdr 0 34930 NULL
+swiotlb_init_with_tbl_fndecl_34935_fields swiotlb_init_with_tbl fndecl 2 34935 NULL
+register_sound_special_fndecl_34937_fields register_sound_special fndecl 2 34937 NULL
+recv_resync_read_fndecl_34939_fields recv_resync_read fndecl 2 34939 NULL
+max_receive_fw_card_34941_fields max_receive fw_card 0 34941 NULL
+ext2_write_end_fndecl_34943_fields ext2_write_end fndecl 5 34943 NULL
+ips_scmd_buf_write_fndecl_34946_fields ips_scmd_buf_write fndecl 3 34946 NULL
+simple_alloc_urb_fndecl_34966_fields simple_alloc_urb fndecl 2 34966 NULL
+s35390a_get_reg_fndecl_34971_fields s35390a_get_reg fndecl 4 34971 NULL
+items_snd_soc_tplg_enum_control_34973_fields items snd_soc_tplg_enum_control 0 34973 NULL nohasharray
+cw1200_queue_stats_init_fndecl_34973_fields cw1200_queue_stats_init fndecl 2 34973 &items_snd_soc_tplg_enum_control_34973_fields
+gcr_base_intel_pmc_ipc_dev_34977_fields gcr_base intel_pmc_ipc_dev 0 34977 NULL
+wm_adsp_buffer_capture_block_fndecl_35001_fields wm_adsp_buffer_capture_block fndecl 2-0 35001 NULL
+rx_ring_count_ixgbe_adapter_35004_fields rx_ring_count ixgbe_adapter 0 35004 NULL
+amb_len_i5k_amb_data_35007_fields amb_len i5k_amb_data 0 35007 NULL nohasharray
+platform_get_irq_byname_fndecl_35007_fields platform_get_irq_byname fndecl 0 35007 &amb_len_i5k_amb_data_35007_fields
+num_snaps_ceph_mds_snap_realm_35009_fields num_snaps ceph_mds_snap_realm 0 35009 NULL
+fc_set_mfs_fndecl_35014_fields fc_set_mfs fndecl 2 35014 NULL
+skb_zerocopy_fndecl_35016_fields skb_zerocopy fndecl 4-3 35016 NULL
+read_capacity_10_fndecl_35017_fields read_capacity_10 fndecl 0 35017 NULL nohasharray
+pg_doio_nfs_pageio_ops_35017_fields pg_doio nfs_pageio_ops 0 35017 &read_capacity_10_fndecl_35017_fields
+no_ids_squashfs_super_block_35022_fields no_ids squashfs_super_block 0 35022 NULL
+_add_sg_continuation_descriptor_fndecl_35026_fields _add_sg_continuation_descriptor fndecl 3 35026 NULL
+vSync_width_panel_info_35029_fields vSync_width panel_info 0 35029 NULL nohasharray
+set_nservers_fndecl_35029_fields set_nservers fndecl 2 35029 &vSync_width_panel_info_35029_fields
+vid_net_bridge_vlan_35032_fields vid net_bridge_vlan 0 35032 NULL
+w_nr_rds_ib_work_ring_35048_fields w_nr rds_ib_work_ring 0 35048 NULL
+uarc_size_mthca_profile_35053_fields uarc_size mthca_profile 0 35053 NULL
+n_ports_rp2_card_35055_fields n_ports rp2_card 0 35055 NULL
+tda18218_rd_reg_fndecl_35057_fields tda18218_rd_reg fndecl 2 35057 NULL
+iio_event_chrdev_read_fndecl_35062_fields iio_event_chrdev_read fndecl 3 35062 NULL
+pci_create_root_bus_fndecl_35065_fields pci_create_root_bus fndecl 2 35065 NULL
+jffs2_flash_direct_write_fndecl_35070_fields jffs2_flash_direct_write fndecl 3 35070 NULL
+altera_set_dr_post_fndecl_35072_fields altera_set_dr_post fndecl 2 35072 NULL
+num_col_gpios_matrix_keypad_platform_data_35080_fields num_col_gpios matrix_keypad_platform_data 0 35080 NULL
+get_iovec_page_array_fndecl_35081_fields get_iovec_page_array fndecl 0 35081 NULL
+inbuf_dma_ati_remote_35083_fields inbuf_dma ati_remote 0 35083 NULL
+ieee80211_add_rx_radiotap_header_fndecl_35086_fields ieee80211_add_rx_radiotap_header fndecl 4 35086 NULL
+ubi_calc_data_len_fndecl_35092_fields ubi_calc_data_len fndecl 0-3 35092 NULL
+er_data_len_gfs2_ea_request_35098_fields er_data_len gfs2_ea_request 0 35098 NULL
+num_vf_qps_i40e_pf_35102_fields num_vf_qps i40e_pf 0 35102 NULL
+prot_length_se_device_35103_fields prot_length se_device 0 35103 NULL
+dma_common_get_sgtable_fndecl_35105_fields dma_common_get_sgtable fndecl 5 35105 NULL
+__do_page_fault_fndecl_35107_fields __do_page_fault fndecl 3 35107 NULL
+size_kcore_list_35108_fields size kcore_list 0 35108 NULL nohasharray
+ath6kl_wmi_set_bitrate_mask_fndecl_35108_fields ath6kl_wmi_set_bitrate_mask fndecl 2 35108 &size_kcore_list_35108_fields
+pn_raw_send_fndecl_35113_fields pn_raw_send fndecl 2 35113 NULL
+max_uc_mac_be_resources_35119_fields max_uc_mac be_resources 0 35119 NULL
+vxfs_bmap_indir_fndecl_35120_fields vxfs_bmap_indir fndecl 2-0-4 35120 NULL
+alloc_vm_area_fndecl_35121_fields alloc_vm_area fndecl 1 35121 NULL
+advance_dma_data_fndecl_35124_fields advance_dma_data fndecl 2 35124 NULL
+sm501_alloc_mem_fndecl_35125_fields sm501_alloc_mem fndecl 4 35125 NULL
+bch_empty_fifo_fndecl_35126_fields bch_empty_fifo fndecl 2 35126 NULL
+vmw_mob_create_fndecl_35127_fields vmw_mob_create fndecl 1 35127 NULL nohasharray
+nilfs_sufile_get_suinfo_fndecl_35127_fields nilfs_sufile_get_suinfo fndecl 5-2 35127 &vmw_mob_create_fndecl_35127_fields
+FbMapSize_nvidia_par_35128_fields FbMapSize nvidia_par 0 35128 NULL nohasharray
+mlx4_en_create_rx_ring_fndecl_35128_fields mlx4_en_create_rx_ring fndecl 3 35128 &FbMapSize_nvidia_par_35128_fields
+channels_min_snd_pcm_hardware_35132_fields channels_min snd_pcm_hardware 0 35132 NULL nohasharray
+bio_add_pc_page_fndecl_35132_fields bio_add_pc_page fndecl 4-5 35132 &channels_min_snd_pcm_hardware_35132_fields
+xdr_restrict_buflen_fndecl_35133_fields xdr_restrict_buflen fndecl 2 35133 NULL
+_osd_realloc_seg_fndecl_35139_fields _osd_realloc_seg fndecl 3 35139 NULL
+blockoffset_hfsplus_sb_info_35140_fields blockoffset hfsplus_sb_info 0 35140 NULL
+tx_ring_size_adm8211_priv_35143_fields tx_ring_size adm8211_priv 0 35143 NULL
+len_mwifiex_ie_types_header_35146_fields len mwifiex_ie_types_header 0 35146 NULL
+pageshift_alauda_card_info_35154_fields pageshift alauda_card_info 0 35154 NULL
+num_rx_qp_i40e_hw_capabilities_35165_fields num_rx_qp i40e_hw_capabilities 0 35165 NULL
+count_sgmap_35168_fields count sgmap 0 35168 NULL
+aux_ulist_node_35169_fields aux ulist_node 0 35169 NULL
+memblock_size_vxge_hw_fifo_config_35179_fields memblock_size vxge_hw_fifo_config 0 35179 NULL
+at24_eeprom_write_i2c_fndecl_35183_fields at24_eeprom_write_i2c fndecl 3-4 35183 NULL
+buf_alloc_virtio_vsock_hdr_35184_fields buf_alloc virtio_vsock_hdr 0 35184 NULL
+blk_rq_count_integrity_sg_fndecl_35185_fields blk_rq_count_integrity_sg fndecl 0 35185 NULL
+__sound_insert_unit_fndecl_35186_fields __sound_insert_unit fndecl 4-5 35186 NULL
+wHeight_uvc_frame_35189_fields wHeight uvc_frame 0 35189 NULL
+vop_vringh_copy_fndecl_35193_fields vop_vringh_copy fndecl 4 35193 NULL
+new_lockspace_fndecl_35208_fields new_lockspace fndecl 4 35208 NULL
+tx_ring_size_pcnet32_private_35210_fields tx_ring_size pcnet32_private 0 35210 NULL
+xfs_ialloc_inode_init_fndecl_35212_fields xfs_ialloc_inode_init fndecl 6-5 35212 NULL
+maxpacksize_snd_usb_endpoint_35216_fields maxpacksize snd_usb_endpoint 0 35216 NULL nohasharray
+sset_mask_ethtool_sset_info_35216_fields sset_mask ethtool_sset_info 0 35216 &maxpacksize_snd_usb_endpoint_35216_fields
+__ndisc_fill_addr_option_fndecl_35220_fields __ndisc_fill_addr_option fndecl 5-4 35220 NULL
+snd_pcm_add_chmap_ctls_fndecl_35223_fields snd_pcm_add_chmap_ctls fndecl 4 35223 NULL
+vmbus_sendpacket_ctl_fndecl_35225_fields vmbus_sendpacket_ctl fndecl 3 35225 NULL
+root_blkno_ocfs2_super_35227_fields root_blkno ocfs2_super 0 35227 NULL
+d_off_p9_dirent_35247_fields d_off p9_dirent 0 35247 NULL nohasharray
+policy_idx_hmask_netns_xfrm_35247_fields policy_idx_hmask netns_xfrm 0 35247 &d_off_p9_dirent_35247_fields
+whc_urb_dequeue_fndecl_35255_fields whc_urb_dequeue fndecl 3 35255 NULL nohasharray
+oprofile_buffer_size_vardecl_35255_fields oprofile_buffer_size vardecl 0 35255 &whc_urb_dequeue_fndecl_35255_fields
+max_gs_mthca_srq_35258_fields max_gs mthca_srq 0 35258 NULL
+dm_bm_write_lock_fndecl_35261_fields dm_bm_write_lock fndecl 2 35261 NULL
+gss_unwrap_kerberos_fndecl_35263_fields gss_unwrap_kerberos fndecl 2 35263 NULL
+wstatus_usblp_35266_fields wstatus usblp 0 35266 NULL
+sparse_early_mem_maps_alloc_node_fndecl_35270_fields sparse_early_mem_maps_alloc_node fndecl 4 35270 NULL
+maxburst_snd_dmaengine_dai_dma_data_35287_fields maxburst snd_dmaengine_dai_dma_data 0 35287 NULL
+ceph_msg_data_advance_fndecl_35288_fields ceph_msg_data_advance fndecl 2 35288 NULL
+offs_ubifs_wbuf_35290_fields offs ubifs_wbuf 0 35290 NULL
+xc_send_i2c_data_fndecl_35297_fields xc_send_i2c_data fndecl 3 35297 NULL
+maybe_indirect_to_direct_fndecl_35307_fields maybe_indirect_to_direct fndecl 6 35307 NULL
+ieee80211_tdls_mgmt_setup_fndecl_35316_fields ieee80211_tdls_mgmt_setup fndecl 10 35316 NULL
+udf_insert_aext_fndecl_35323_fields udf_insert_aext fndecl 4 35323 NULL
+l2cap_create_basic_pdu_fndecl_35327_fields l2cap_create_basic_pdu fndecl 3 35327 NULL
+ssid_len_cfg80211_ibss_params_35329_fields ssid_len cfg80211_ibss_params 0 35329 NULL
+xb_suballoc_bit_ocfs2_xattr_block_35331_fields xb_suballoc_bit ocfs2_xattr_block 0 35331 NULL
+extra_msdu_postfix_len_lib80211_crypto_ops_35341_fields extra_msdu_postfix_len lib80211_crypto_ops 0 35341 NULL
+nr_pages_bts_buffer_35350_fields nr_pages bts_buffer 0 35350 NULL
+num_reg_mic_smpt_hw_info_35353_fields num_reg mic_smpt_hw_info 0 35353 NULL
+udf_get_pblock_meta25_fndecl_35356_fields udf_get_pblock_meta25 fndecl 4 35356 NULL
+header_dvfs_info_35357_fields header dvfs_info 0 35357 NULL
+IA_RX_BUF_SZ_vardecl_iphase_c_35365_fields IA_RX_BUF_SZ vardecl_iphase.c 0 35365 NULL
+previous_raid_disks_r5conf_35368_fields previous_raid_disks r5conf 0 35368 NULL nohasharray
+count_param_range_35368_fields count param_range 0 35368 &previous_raid_disks_r5conf_35368_fields nohasharray
+input_pool_snd_seq_client_pool_35368_fields input_pool snd_seq_client_pool 0 35368 &count_param_range_35368_fields
+num_channels_ad7266_chan_info_35372_fields num_channels ad7266_chan_info 0 35372 NULL
+update_raid_disks_fndecl_35375_fields update_raid_disks fndecl 2 35375 NULL
+sd_head_align_brcmfmac_sdio_pd_35378_fields sd_head_align brcmfmac_sdio_pd 0 35378 NULL nohasharray
+mmio_base_phys_radeonfb_info_35378_fields mmio_base_phys radeonfb_info 0 35378 &sd_head_align_brcmfmac_sdio_pd_35378_fields
+virtio_gpu_cmd_submit_fndecl_35382_fields virtio_gpu_cmd_submit fndecl 3 35382 NULL
+hc_erase_size_mmc_ext_csd_35384_fields hc_erase_size mmc_ext_csd 0 35384 NULL
+nand_read_subpage_fndecl_35388_fields nand_read_subpage fndecl 3 35388 NULL
+read_dma_fndecl_35389_fields read_dma fndecl 3 35389 NULL
+writeback_fndecl_35390_fields writeback fndecl 4-3 35390 NULL
+corrupt_data_fndecl_35395_fields corrupt_data fndecl 0-3 35395 NULL
+blk_queue_io_opt_fndecl_35405_fields blk_queue_io_opt fndecl 2 35405 NULL
+at24_eeprom_read_i2c_fndecl_35407_fields at24_eeprom_read_i2c fndecl 4 35407 NULL
+rdma_rw_ctx_init_fndecl_35410_fields rdma_rw_ctx_init fndecl 6-7 35410 NULL
+_drbd_md_sync_page_io_fndecl_35411_fields _drbd_md_sync_page_io fndecl 3 35411 NULL
+ali15x3_smba_vardecl_i2c_ali15x3_c_35421_fields ali15x3_smba vardecl_i2c-ali15x3.c 0 35421 NULL
+cqc_entry_sz_mthca_dev_lim_35422_fields cqc_entry_sz mthca_dev_lim 0 35422 NULL
+fb_width_drm_fb_helper_surface_size_35426_fields fb_width drm_fb_helper_surface_size 0 35426 NULL
+btrfs_fdatawrite_range_fndecl_35427_fields btrfs_fdatawrite_range fndecl 2-3 35427 NULL
+offset_tx_buf_35429_fields offset tx_buf 0 35429 NULL
+bmAttributes_usb_ss_ep_comp_descriptor_35434_fields bmAttributes usb_ss_ep_comp_descriptor 0 35434 NULL
+ocfs2_prepare_refcount_change_for_del_fndecl_35442_fields ocfs2_prepare_refcount_change_for_del fndecl 2 35442 NULL
+pcf2123_read_fndecl_35443_fields pcf2123_read fndecl 4 35443 NULL
+wake_len_cfg80211_wowlan_tcp_35448_fields wake_len cfg80211_wowlan_tcp 0 35448 NULL nohasharray
+len_he_buff_35448_fields len he_buff 0 35448 &wake_len_cfg80211_wowlan_tcp_35448_fields
+ocfs2_truncate_file_fndecl_35455_fields ocfs2_truncate_file fndecl 3 35455 NULL
+octeon_create_droq_fndecl_35457_fields octeon_create_droq fndecl 4-3 35457 NULL
+bytes_to_read_mpt3_diag_read_buffer_35460_fields bytes_to_read mpt3_diag_read_buffer 0 35460 NULL
+drbd_send_fndecl_35461_fields drbd_send fndecl 4 35461 NULL
+blkno_iomap_35467_fields blkno iomap 0 35467 NULL
+width_physmap_flash_data_35470_fields width physmap_flash_data 0 35470 NULL
+qxl_monitors_config_set_fndecl_35471_fields qxl_monitors_config_set fndecl 6-5 35471 NULL
+kmem_realloc_fndecl_35475_fields kmem_realloc fndecl 2 35475 NULL
+__rpipe_set_descr_fndecl_35478_fields __rpipe_set_descr fndecl 0 35478 NULL
+length_wl1251_rx_descriptor_35483_fields length wl1251_rx_descriptor 0 35483 NULL
+onenand_read_fndecl_35491_fields onenand_read fndecl 2 35491 NULL
+alloc_clips_fndecl_35492_fields alloc_clips fndecl 3 35492 NULL nohasharray
+f71805f_device_add_fndecl_35492_fields f71805f_device_add fndecl 1 35492 &alloc_clips_fndecl_35492_fields
+nbox_drm_savage_cmdbuf_35493_fields nbox drm_savage_cmdbuf 0 35493 NULL nohasharray
+firm_send_command_fndecl_35493_fields firm_send_command fndecl 4 35493 &nbox_drm_savage_cmdbuf_35493_fields
+x_kmem_cache_order_objects_35507_fields x kmem_cache_order_objects 0 35507 NULL
+acpi_nvs_register_fndecl_35515_fields acpi_nvs_register fndecl 2-1 35515 NULL
+install_special_mapping_fndecl_35519_fields install_special_mapping fndecl 2-3 35519 NULL
+count_atl1_rfd_ring_35523_fields count atl1_rfd_ring 0 35523 NULL
+shift_mlxsw_item_35524_fields shift mlxsw_item 0 35524 NULL nohasharray
+nres_intel_th_subdevice_35524_fields nres intel_th_subdevice 0 35524 &shift_mlxsw_item_35524_fields
+x509_extract_key_data_fndecl_35525_fields x509_extract_key_data fndecl 5 35525 NULL
+clr_int_base_mlx4_fw_35529_fields clr_int_base mlx4_fw 0 35529 NULL
+additional_cdb_length_scsi_varlen_cdb_hdr_35533_fields additional_cdb_length scsi_varlen_cdb_hdr 0 35533 NULL
+find_inode_fndecl_35534_fields find_inode fndecl 2 35534 NULL
+gigaset_tty_receive_fndecl_35535_fields gigaset_tty_receive fndecl 4 35535 NULL
+phys_ck804xrom_window_35536_fields phys ck804xrom_window 0 35536 NULL
+tcp_mss_to_mtu_fndecl_35551_fields tcp_mss_to_mtu fndecl 0-2 35551 NULL
+inet_sendpage_fndecl_35554_fields inet_sendpage fndecl 4 35554 NULL
+vsync_ast_vbios_enhtable_35556_fields vsync ast_vbios_enhtable 0 35556 NULL
+ptrace_request_fndecl_35563_fields ptrace_request fndecl 3 35563 NULL
+data_offset_brcmf_proto_bcdc_header_35569_fields data_offset brcmf_proto_bcdc_header 0 35569 NULL nohasharray
+find_min_pfn_for_node_fndecl_35569_fields find_min_pfn_for_node fndecl 0 35569 &data_offset_brcmf_proto_bcdc_header_35569_fields
+edma_readl_fndecl_35573_fields edma_readl fndecl 0 35573 NULL
+cfg80211_mlme_auth_fndecl_35577_fields cfg80211_mlme_auth fndecl 14-9 35577 NULL
+size_of_priv_dvb_usb_device_properties_35582_fields size_of_priv dvb_usb_device_properties 0 35582 NULL nohasharray
+cur_blksize_sdio_func_35582_fields cur_blksize sdio_func 0 35582 &size_of_priv_dvb_usb_device_properties_35582_fields
+lbs_failcount_write_fndecl_35583_fields lbs_failcount_write fndecl 3 35583 NULL
+actual_length_usb_iso_packet_descriptor_35588_fields actual_length usb_iso_packet_descriptor 0 35588 NULL
+cyttsp_i2c_read_block_data_fndecl_35590_fields cyttsp_i2c_read_block_data fndecl 4 35590 NULL
+minor_start_rp2_card_35592_fields minor_start rp2_card 0 35592 NULL
+nfsd_write_fndecl_35594_fields nfsd_write fndecl 6 35594 NULL
+ext2_iget_fndecl_35598_fields ext2_iget fndecl 2 35598 NULL
+xfs_rtallocate_extent_block_fndecl_35604_fields xfs_rtallocate_extent_block fndecl 5-10-0 35604 NULL
+hback_porch_videomode_35606_fields hback_porch videomode 0 35606 NULL nohasharray
+count_nfs_direct_req_35606_fields count nfs_direct_req 0 35606 &hback_porch_videomode_35606_fields nohasharray
+obj_count_i40iw_virtchnl_hmc_obj_range_35606_fields obj_count i40iw_virtchnl_hmc_obj_range 0 35606 &count_nfs_direct_req_35606_fields
+blocksize_brcmf_sdio_35612_fields blocksize brcmf_sdio 0 35612 NULL
+sqp_demux_mlx4_caps_35613_fields sqp_demux mlx4_caps 0 35613 NULL
+iova_rvt_mregion_35617_fields iova rvt_mregion 0 35617 NULL
+generic_perform_write_fndecl_35619_fields generic_perform_write fndecl 0-3 35619 NULL nohasharray
+ext4_update_final_de_fndecl_35619_fields ext4_update_final_de fndecl 2-3 35619 &generic_perform_write_fndecl_35619_fields nohasharray
+count_fm10k_ring_35619_fields count fm10k_ring 0 35619 &ext4_update_final_de_fndecl_35619_fields
+ips_scmd_buf_read_fndecl_35622_fields ips_scmd_buf_read fndecl 3 35622 NULL
+netxen_process_lro_fndecl_35630_fields netxen_process_lro fndecl 5-4 35630 NULL
+smsc47b397_device_add_fndecl_35649_fields smsc47b397_device_add fndecl 1 35649 NULL
+prism_build_supp_rates_fndecl_35650_fields prism_build_supp_rates fndecl 0 35650 NULL
+viafb_second_xres_vardecl_35651_fields viafb_second_xres vardecl 0 35651 NULL
+urb_size_uvc_streaming_35654_fields urb_size uvc_streaming 0 35654 NULL
+urb_enqueue_hc_driver_35656_fields urb_enqueue hc_driver 0 35656 NULL
+xfs_alloc_read_agfl_fndecl_35660_fields xfs_alloc_read_agfl fndecl 3-0 35660 NULL
+raid10_sync_request_fndecl_35663_fields raid10_sync_request fndecl 2 35663 NULL nohasharray
+base_bus_num_i2c_mux_pinctrl_platform_data_35663_fields base_bus_num i2c_mux_pinctrl_platform_data 0 35663 &raid10_sync_request_fndecl_35663_fields
+numdevs_ore_components_35671_fields numdevs ore_components 0 35671 NULL
+ncntrs_qib_chip_specific_35675_fields ncntrs qib_chip_specific 0 35675 NULL
+rate_clk_core_35677_fields rate clk_core 0 35677 NULL
+read_into_fndecl_35681_fields read_into fndecl 2 35681 NULL nohasharray
+size_xpnet_message_35681_fields size xpnet_message 0 35681 &read_into_fndecl_35681_fields
+id_mfd_cell_35684_fields id mfd_cell 0 35684 NULL
+do_io_nd_blk_region_35687_fields do_io nd_blk_region 0 35687 NULL
+affs_extent_file_ofs_fndecl_35690_fields affs_extent_file_ofs fndecl 2 35690 NULL
+drbg_ctr_generate_fndecl_35694_fields drbg_ctr_generate fndecl 3 35694 NULL
+init_hal_msg_fndecl_35697_fields init_hal_msg fndecl 3 35697 NULL
+irq_domain_alloc_descs_fndecl_35699_fields irq_domain_alloc_descs fndecl 0 35699 NULL
+wil_pmc_alloc_fndecl_35702_fields wil_pmc_alloc fndecl 3 35702 NULL
+gfs2_write_alloc_required_fndecl_35708_fields gfs2_write_alloc_required fndecl 3-2 35708 NULL
+srp_post_send_fndecl_35713_fields srp_post_send fndecl 3 35713 NULL
+remote_nentries_xpc_channel_35714_fields remote_nentries xpc_channel 0 35714 NULL
+credits_csio_q_35715_fields credits csio_q 0 35715 NULL
+RequestCredit_mpt3sas_facts_35718_fields RequestCredit mpt3sas_facts 0 35718 NULL nohasharray
+bio_add_page_fndecl_35718_fields bio_add_page fndecl 3-4-0 35718 &RequestCredit_mpt3sas_facts_35718_fields
+fdt_translate_address_fndecl_35726_fields fdt_translate_address fndecl 0 35726 NULL nohasharray
+add_port_fndecl_35726_fields add_port fndecl 2 35726 &fdt_translate_address_fndecl_35726_fields
+last_xfer_len_ide_cmd_35728_fields last_xfer_len ide_cmd 0 35728 NULL
+mwifiex_append_rate_tlv_fndecl_35735_fields mwifiex_append_rate_tlv fndecl 0 35735 NULL
+priv_size_data_queue_35740_fields priv_size data_queue 0 35740 NULL
+offset_ext4_io_end_35743_fields offset ext4_io_end 0 35743 NULL
+ggtt_probe_common_fndecl_35744_fields ggtt_probe_common fndecl 2 35744 NULL nohasharray
+qib_uc_rcv_fndecl_35744_fields qib_uc_rcv fndecl 5 35744 &ggtt_probe_common_fndecl_35744_fields
+alauda_write_data_fndecl_35748_fields alauda_write_data fndecl 2 35748 NULL
+goodix_i2c_read_fndecl_35755_fields goodix_i2c_read fndecl 4 35755 NULL nohasharray
+c4_add_card_fndecl_35755_fields c4_add_card fndecl 3 35755 &goodix_i2c_read_fndecl_35755_fields
+left_qxl_urect_35760_fields left qxl_urect 0 35760 NULL
+rx_buf_seg_size_qede_rx_queue_35761_fields rx_buf_seg_size qede_rx_queue 0 35761 NULL
+scsi_sg_tablesize_iser_conn_35762_fields scsi_sg_tablesize iser_conn 0 35762 NULL
+fh_epd_frame_35764_fields fh epd_frame 0 35764 NULL
+channels_snd_usb_substream_35767_fields channels snd_usb_substream 0 35767 NULL
+virtscsi_compute_resid_fndecl_35772_fields virtscsi_compute_resid fndecl 2 35772 NULL
+data0_sisusb_command_35773_fields data0 sisusb_command 0 35773 NULL
+mem_vardecl_matroxfb_base_c_35780_fields mem vardecl_matroxfb_base.c 0 35780 NULL
+uv_systab_efi_35786_fields uv_systab efi 0 35786 NULL
+encap_size_brnf_frag_data_35787_fields encap_size brnf_frag_data 0 35787 NULL
+alloc_mon_bin_get_35804_fields alloc mon_bin_get 0 35804 NULL
+num_rx_queues_iwl_trans_35809_fields num_rx_queues iwl_trans 0 35809 NULL
+send_ctrl_pipe_us_data_35813_fields send_ctrl_pipe us_data 0 35813 NULL
+xefi_startblock_xfs_extent_free_item_35817_fields xefi_startblock xfs_extent_free_item 0 35817 NULL nohasharray
+number_of_controls_controlcache_6205_35817_fields number_of_controls controlcache_6205 0 35817 &xefi_startblock_xfs_extent_free_item_35817_fields
+rbio_orig_end_io_fndecl_35820_fields rbio_orig_end_io fndecl 2 35820 NULL
+headroom_caifsock_35821_fields headroom caifsock 0 35821 NULL
+leaf_cut_from_buffer_fndecl_35824_fields leaf_cut_from_buffer fndecl 4 35824 NULL
+rx_buffer_padding_efx_nic_type_35825_fields rx_buffer_padding efx_nic_type 0 35825 NULL
+VFP_kyrofb_info_35826_fields VFP kyrofb_info 0 35826 NULL
+env_end_mm_struct_35831_fields env_end mm_struct 0 35831 NULL nohasharray
+twl_load_sgl_fndecl_35831_fields twl_load_sgl fndecl 5 35831 &env_end_mm_struct_35831_fields nohasharray
+num_pmkids_ndis_80211_capability_35831_fields num_pmkids ndis_80211_capability 0 35831 &twl_load_sgl_fndecl_35831_fields
+srq_size_srpt_device_35833_fields srq_size srpt_device 0 35833 NULL
+request_sz_MPT3SAS_ADAPTER_35834_fields request_sz MPT3SAS_ADAPTER 0 35834 NULL
+l_iclog_size_xlog_35849_fields l_iclog_size xlog 0 35849 NULL
+snd_pcm_format_physical_width_fndecl_35858_fields snd_pcm_format_physical_width fndecl 0 35858 NULL
+ipw_write_packet_sent_callback_fndecl_35859_fields ipw_write_packet_sent_callback fndecl 2 35859 NULL
+check_acl_fndecl_35867_fields check_acl fndecl 0 35867 NULL
+usb_stor_bulk_transfer_sglist_fndecl_35871_fields usb_stor_bulk_transfer_sglist fndecl 5-2-4 35871 NULL
+pcol_add_page_fndecl_35872_fields pcol_add_page fndecl 3 35872 NULL nohasharray
+processed_length_mbo_35872_fields processed_length mbo 0 35872 &pcol_add_page_fndecl_35872_fields
+snd_hdsp_midi_output_possible_fndecl_35873_fields snd_hdsp_midi_output_possible fndecl 0 35873 NULL
+shared_out_nid_ca0132_spec_35876_fields shared_out_nid ca0132_spec 0 35876 NULL
+st_sensors_spi_read_fndecl_35890_fields st_sensors_spi_read fndecl 4 35890 NULL
+pos_in_f2fs_move_range_35897_fields pos_in f2fs_move_range 0 35897 NULL
+lpuart_dma_tx_fndecl_35902_fields lpuart_dma_tx fndecl 2 35902 NULL nohasharray
+nft_data_dump_fndecl_35902_fields nft_data_dump fndecl 5 35902 &lpuart_dma_tx_fndecl_35902_fields
+fe_group_ext4_free_extent_35905_fields fe_group ext4_free_extent 0 35905 NULL nohasharray
+max_sq_desc_sz_mlx4_caps_35905_fields max_sq_desc_sz mlx4_caps 0 35905 &fe_group_ext4_free_extent_35905_fields
+lirc_base_dev_vardecl_lirc_dev_c_35907_fields lirc_base_dev vardecl_lirc_dev.c 0 35907 NULL
+right_vardecl_matroxfb_base_c_35916_fields right vardecl_matroxfb_base.c 0 35916 NULL
+softback_end_vardecl_fbcon_c_35923_fields softback_end vardecl_fbcon.c 0 35923 NULL
+n_algs_wmfw_adsp1_id_hdr_35926_fields n_algs wmfw_adsp1_id_hdr 0 35926 NULL
+ieee802154_hdr_minlen_fndecl_35927_fields ieee802154_hdr_minlen fndecl 0 35927 NULL
+bytes_written_cq_fcp_rq_desc_35931_fields bytes_written cq_fcp_rq_desc 0 35931 NULL
+__dax_dev_pmd_fault_fndecl_35932_fields __dax_dev_pmd_fault fndecl 3 35932 NULL
+dma_buf_size_ddb_input_35933_fields dma_buf_size ddb_input 0 35933 NULL nohasharray
+length_isp1362_ep_35933_fields length isp1362_ep 0 35933 &dma_buf_size_ddb_input_35933_fields
+disk_stack_limits_fndecl_35936_fields disk_stack_limits fndecl 3 35936 NULL
+___alloc_bootmem_nopanic_fndecl_35945_fields ___alloc_bootmem_nopanic fndecl 2-3-4 35945 NULL
+isl1208_i2c_read_regs_fndecl_35952_fields isl1208_i2c_read_regs fndecl 4 35952 NULL
+nx_fw_cmd_set_mtu_fndecl_35954_fields nx_fw_cmd_set_mtu fndecl 2 35954 NULL
+fat_uni_to_x8_fndecl_35959_fields fat_uni_to_x8 fndecl 0 35959 NULL
+rmi_register_desc_calc_size_fndecl_35961_fields rmi_register_desc_calc_size fndecl 0 35961 NULL
+s_root_block_affs_sb_info_35962_fields s_root_block affs_sb_info 0 35962 NULL
+num_entries_compat_ip6t_replace_35966_fields num_entries compat_ip6t_replace 0 35966 NULL
+flows_tc_sfq_qopt_35973_fields flows tc_sfq_qopt 0 35973 NULL
+max_df_size_ipq_35974_fields max_df_size ipq 0 35974 NULL nohasharray
+pf_num_bnx2x_35974_fields pf_num bnx2x 0 35974 &max_df_size_ipq_35974_fields
+bus_myri10ge_rx_done_35977_fields bus myri10ge_rx_done 0 35977 NULL
+pn_sendmsg_fndecl_35979_fields pn_sendmsg fndecl 3 35979 NULL
+codeword_size_jedec_ecc_info_35980_fields codeword_size jedec_ecc_info 0 35980 NULL
+num_dacs_hda_multi_out_35981_fields num_dacs hda_multi_out 0 35981 NULL
+flags_fscrypt_context_35983_fields flags fscrypt_context 0 35983 NULL
+gpiod_to_irq_fndecl_35989_fields gpiod_to_irq fndecl 0 35989 NULL
+if_spi_prog_main_firmware_check_len_fndecl_35990_fields if_spi_prog_main_firmware_check_len fndecl 0 35990 NULL
+perf_output_skip_fndecl_35994_fields perf_output_skip fndecl 2 35994 NULL
+mss_cache_tcp_sock_35995_fields mss_cache tcp_sock 0 35995 NULL
+daddr_fsl_edma_hw_tcd_35996_fields daddr fsl_edma_hw_tcd 0 35996 NULL nohasharray
+address_acpi_nfit_system_address_35996_fields address acpi_nfit_system_address 0 35996 &daddr_fsl_edma_hw_tcd_35996_fields
+fuse_fill_write_pages_fndecl_36001_fields fuse_fill_write_pages fndecl 0-4 36001 NULL nohasharray
+poll_vardecl_hfcpci_c_36001_fields poll vardecl_hfcpci.c 0 36001 &fuse_fill_write_pages_fndecl_36001_fields
+ntb_transport_max_size_fndecl_36009_fields ntb_transport_max_size fndecl 0 36009 NULL
+__nfs4_proc_set_acl_fndecl_36018_fields __nfs4_proc_set_acl fndecl 3 36018 NULL
+setup_efi_info_memmap_fndecl_36029_fields setup_efi_info_memmap fndecl 4-3-2 36029 NULL
+mpdu_len_iwl_rx_mpdu_desc_36030_fields mpdu_len iwl_rx_mpdu_desc 0 36030 NULL
+NumEraseUnits_NFTLMediaHeader_36036_fields NumEraseUnits NFTLMediaHeader 0 36036 NULL
+insert_bio_sectors_search_36037_fields insert_bio_sectors search 0 36037 NULL
+update_ind_extent_range_fndecl_36049_fields update_ind_extent_range fndecl 3 36049 NULL
+rx_status_len_bcm_rsb_36064_fields rx_status_len bcm_rsb 0 36064 NULL
+piobcnt2k_qib_devdata_36065_fields piobcnt2k qib_devdata 0 36065 NULL
+xfrm_compile_policy_fndecl_36070_fields xfrm_compile_policy fndecl 4 36070 NULL
+usb_stor_control_msg_fndecl_36073_fields usb_stor_control_msg fndecl 8-2 36073 NULL
+wa_populate_buf_in_urb_fndecl_36077_fields wa_populate_buf_in_urb fndecl 4-3 36077 NULL
+blocksize_alauda_media_info_36080_fields blocksize alauda_media_info 0 36080 NULL
+xfs_extent_busy_insert_fndecl_36087_fields xfs_extent_busy_insert fndecl 3-4-2 36087 NULL
+smq_create_fndecl_36088_fields smq_create fndecl 1 36088 NULL
+wil_write_file_ssid_fndecl_36097_fields wil_write_file_ssid fndecl 3 36097 NULL
+__free_pages_boot_core_fndecl_36098_fields __free_pages_boot_core fndecl 2 36098 NULL
+nr_requests_request_queue_36117_fields nr_requests request_queue 0 36117 NULL
+xfs_trans_read_buf_map_fndecl_36121_fields xfs_trans_read_buf_map fndecl 0 36121 NULL
+dictionary_size_disk_comp_opts_36125_fields dictionary_size disk_comp_opts 0 36125 NULL
+x25_sendmsg_fndecl_36140_fields x25_sendmsg fndecl 3 36140 NULL
+f2fs_fiemap_fndecl_36141_fields f2fs_fiemap fndecl 3-4 36141 NULL
+lirc_buffer_init_fndecl_36145_fields lirc_buffer_init fndecl 2 36145 NULL
+spi_xcomm_sync_config_fndecl_36146_fields spi_xcomm_sync_config fndecl 0 36146 NULL
+create_empty_buffers_fndecl_36152_fields create_empty_buffers fndecl 2 36152 NULL
+ad9523_reg_access_fndecl_36157_fields ad9523_reg_access fndecl 2 36157 NULL
+ieee80211_send_probe_req_fndecl_36159_fields ieee80211_send_probe_req fndecl 7-5 36159 NULL
+next_nilfs_segsum_info_36161_fields next nilfs_segsum_info 0 36161 NULL
+clone_sources_count_btrfs_ioctl_send_args_36165_fields clone_sources_count btrfs_ioctl_send_args 0 36165 NULL
+vm_mmap_fndecl_36168_fields vm_mmap fndecl 3-0 36168 NULL
+member_cnt_tipc_mon_domain_36177_fields member_cnt tipc_mon_domain 0 36177 NULL
+length_octeon_droq_info_36178_fields length octeon_droq_info 0 36178 NULL
+nr_ion_platform_data_36179_fields nr ion_platform_data 0 36179 NULL
+len_ib_ucm_mra_36185_fields len ib_ucm_mra 0 36185 NULL
+flash_size_jffs2_sb_info_36187_fields flash_size jffs2_sb_info 0 36187 NULL
+prealloc_buffer_size_snd_dmaengine_pcm_config_36192_fields prealloc_buffer_size snd_dmaengine_pcm_config 0 36192 NULL
+objlayout_read_done_fndecl_36193_fields objlayout_read_done fndecl 2 36193 NULL
+range_min_regmap_range_36196_fields range_min regmap_range 0 36196 NULL
+n_cap_bufs_via_camera_36198_fields n_cap_bufs via_camera 0 36198 NULL
+ubifs_write_end_fndecl_36202_fields ubifs_write_end fndecl 4-3 36202 NULL
+hmask_xfrm_policy_hash_36203_fields hmask xfrm_policy_hash 0 36203 NULL
+f2fs_zero_range_fndecl_36204_fields f2fs_zero_range fndecl 3-2 36204 NULL
+blksz_mmc_ioc_cmd_36207_fields blksz mmc_ioc_cmd 0 36207 NULL
+nfs_try_to_update_request_fndecl_36213_fields nfs_try_to_update_request fndecl 3-4 36213 NULL nohasharray
+mpwqe_stride_sz_mlx5e_rq_36213_fields mpwqe_stride_sz mlx5e_rq 0 36213 &nfs_try_to_update_request_fndecl_36213_fields
+v4l2_ctrl_g_ctrl_fndecl_36216_fields v4l2_ctrl_g_ctrl fndecl 0 36216 NULL
+bnx2i_send_nl_mesg_fndecl_36218_fields bnx2i_send_nl_mesg fndecl 4 36218 NULL
+alloc_xen_mmio_fndecl_36220_fields alloc_xen_mmio fndecl 0-1 36220 NULL
+MaxDevHandle_mpt3sas_facts_36227_fields MaxDevHandle mpt3sas_facts 0 36227 NULL nohasharray
+nid_node_footer_36227_fields nid node_footer 0 36227 &MaxDevHandle_mpt3sas_facts_36227_fields
+reserve_space_fndecl_36229_fields reserve_space fndecl 2 36229 NULL nohasharray
+next_free_nid_f2fs_checkpoint_36229_fields next_free_nid f2fs_checkpoint 0 36229 &reserve_space_fndecl_36229_fields
+add_async_extent_fndecl_36239_fields add_async_extent fndecl 3-2 36239 NULL
+data_queues_rt2x00_dev_36241_fields data_queues rt2x00_dev 0 36241 NULL nohasharray
+surfaceram_base_qxl_device_36241_fields surfaceram_base qxl_device 0 36241 &data_queues_rt2x00_dev_36241_fields
+fpage_offs_genwqe_sgl_36247_fields fpage_offs genwqe_sgl 0 36247 NULL
+calc_buffer_ahash_atfm_fndecl_36250_fields calc_buffer_ahash_atfm fndecl 2 36250 NULL
+xfs_imap_fndecl_36254_fields xfs_imap fndecl 3 36254 NULL
+dma_nv_skb_map_36260_fields dma nv_skb_map 0 36260 NULL
+size_sge_txq_36261_fields size sge_txq 0 36261 NULL
+msb_mark_bad_fndecl_36268_fields msb_mark_bad fndecl 2 36268 NULL
+cydata_ofsl_cyttsp4_sysinfo_data_36269_fields cydata_ofsl cyttsp4_sysinfo_data 0 36269 NULL
+num_uf_bufs_bfa_iocfc_fwcfg_s_36271_fields num_uf_bufs bfa_iocfc_fwcfg_s 0 36271 NULL
+s_clusters_per_group_ext4_sb_info_36278_fields s_clusters_per_group ext4_sb_info 0 36278 NULL
+_dump_buf_dif_order_vardecl_36281_fields _dump_buf_dif_order vardecl 0 36281 NULL
+hci_check_pending_name_fndecl_36282_fields hci_check_pending_name fndecl 5 36282 NULL
+len_ethtool_tunable_36288_fields len ethtool_tunable 0 36288 NULL nohasharray
+calc_sectors_fndecl_36288_fields calc_sectors fndecl 2 36288 &len_ethtool_tunable_36288_fields
+__btrfs_lookup_bio_sums_fndecl_36290_fields __btrfs_lookup_bio_sums fndecl 4 36290 NULL
+iscsi_tcp_recv_skb_fndecl_36295_fields iscsi_tcp_recv_skb fndecl 3-0 36295 NULL
+fat_dump_len_be_adapter_36296_fields fat_dump_len be_adapter 0 36296 NULL
+mru_ovs_skb_cb_36300_fields mru ovs_skb_cb 0 36300 NULL
+command_size_drm_vmw_execbuf_arg_36305_fields command_size drm_vmw_execbuf_arg 0 36305 NULL
+size_kernfs_elem_attr_36307_fields size kernfs_elem_attr 0 36307 NULL
+snd_dma_alloc_pages_fndecl_36308_fields snd_dma_alloc_pages fndecl 3 36308 NULL nohasharray
+len_etd_priv_36308_fields len etd_priv 0 36308 &snd_dma_alloc_pages_fndecl_36308_fields
+max_transfer_snd_usb_midi_out_endpoint_36311_fields max_transfer snd_usb_midi_out_endpoint 0 36311 NULL
+chunk_size_mdp_superblock_s_36313_fields chunk_size mdp_superblock_s 0 36313 NULL
+n_descsz_elf64_note_36314_fields n_descsz elf64_note 0 36314 NULL
+dpdData_size_wsm_configuration_36315_fields dpdData_size wsm_configuration 0 36315 NULL
+acpi_tb_parse_root_table_fndecl_36316_fields acpi_tb_parse_root_table fndecl 1 36316 NULL
+fsbno_xfs_alloc_arg_36318_fields fsbno xfs_alloc_arg 0 36318 NULL
+__nla_reserve_64bit_fndecl_36320_fields __nla_reserve_64bit fndecl 3 36320 NULL
+file_size_squashfs_lreg_inode_36323_fields file_size squashfs_lreg_inode 0 36323 NULL
+xfs_symlink_blocks_fndecl_36326_fields xfs_symlink_blocks fndecl 0-2 36326 NULL
+do_verify_xattr_datum_fndecl_36328_fields do_verify_xattr_datum fndecl 0 36328 NULL
+hidp_send_frame_fndecl_36338_fields hidp_send_frame fndecl 3 36338 NULL
+digest_encode_fndecl_36340_fields digest_encode fndecl 0 36340 NULL
+rds_tcp_data_recv_fndecl_36343_fields rds_tcp_data_recv fndecl 4-3 36343 NULL nohasharray
+size_rw_module_layout_36343_fields size_rw module_layout 0 36343 &rds_tcp_data_recv_fndecl_36343_fields
+osd_req_write_kern_fndecl_36349_fields osd_req_write_kern fndecl 5 36349 NULL
+inode_blocks_efs_sb_info_36351_fields inode_blocks efs_sb_info 0 36351 NULL
+ncommunities_intel_pinctrl_36354_fields ncommunities intel_pinctrl 0 36354 NULL
+ipxrtr_route_packet_fndecl_36359_fields ipxrtr_route_packet fndecl 4 36359 NULL
+rx_ring_size_adm8211_priv_36391_fields rx_ring_size adm8211_priv 0 36391 NULL
+sdebug_max_queue_vardecl_scsi_debug_c_36393_fields sdebug_max_queue vardecl_scsi_debug.c 0 36393 NULL
+mtu_l2cap_le_conn_rsp_36399_fields mtu l2cap_le_conn_rsp 0 36399 NULL nohasharray
+max_rxsz_ulp_iscsi_info_36399_fields max_rxsz ulp_iscsi_info 0 36399 &mtu_l2cap_le_conn_rsp_36399_fields
+iser_calc_scsi_params_fndecl_36403_fields iser_calc_scsi_params fndecl 2 36403 NULL
+nl80211_send_disconnected_fndecl_36411_fields nl80211_send_disconnected fndecl 5 36411 NULL
+iter_file_splice_write_fndecl_36415_fields iter_file_splice_write fndecl 4 36415 NULL
+data_len_hfa384x_rx_frame_36417_fields data_len hfa384x_rx_frame 0 36417 NULL
+altera_set_ir_pre_fndecl_36420_fields altera_set_ir_pre fndecl 2 36420 NULL
+create_xattr_fndecl_36425_fields create_xattr fndecl 5 36425 NULL
+essid_len_ipw2100_priv_36426_fields essid_len ipw2100_priv 0 36426 NULL
+mt2266_writeregs_fndecl_36430_fields mt2266_writeregs fndecl 3 36430 NULL
+reserved_page_order_st_buffer_36445_fields reserved_page_order st_buffer 0 36445 NULL
+size_packet_info_36454_fields size packet_info 0 36454 NULL
+hSync_width_panel_info_36455_fields hSync_width panel_info 0 36455 NULL
+ov511_i2c_r_fndecl_36459_fields ov511_i2c_r fndecl 0 36459 NULL
+st95hf_spi_recv_response_fndecl_36464_fields st95hf_spi_recv_response fndecl 0 36464 NULL
+offset_drm_i915_gem_exec_object2_36466_fields offset drm_i915_gem_exec_object2 0 36466 NULL
+rlim_max_rlimit_36476_fields rlim_max rlimit 0 36476 NULL nohasharray
+v9fs_xattr_get_fndecl_36476_fields v9fs_xattr_get fndecl 4 36476 &rlim_max_rlimit_36476_fields
+portnum_lvs_rh_36480_fields portnum lvs_rh 0 36480 NULL
+rx_len_yam_port_36481_fields rx_len yam_port 0 36481 NULL
+fb_show_logo_line_fndecl_36485_fields fb_show_logo_line fndecl 4 36485 NULL nohasharray
+t_task_lba_se_cmd_36485_fields t_task_lba se_cmd 0 36485 &fb_show_logo_line_fndecl_36485_fields nohasharray
+i2400m_zrealloc_2x_fndecl_36485_fields i2400m_zrealloc_2x fndecl 3 36485 &t_task_lba_se_cmd_36485_fields
+do_compat_readv_fndecl_36486_fields do_compat_readv fndecl 3 36486 NULL
+read_bufsize_carl9170_debugfs_fops_36488_fields read_bufsize carl9170_debugfs_fops 0 36488 NULL
+tipc_msg_make_bundle_fndecl_36497_fields tipc_msg_make_bundle fndecl 3 36497 NULL
+queue_rx_frame_fndecl_36501_fields queue_rx_frame fndecl 2 36501 NULL
+start_nid_hdac_device_36504_fields start_nid hdac_device 0 36504 NULL
+create_pinned_em_fndecl_36508_fields create_pinned_em fndecl 3-2-7-6-5 36508 NULL
+skge_change_mtu_fndecl_36510_fields skge_change_mtu fndecl 2 36510 NULL
+byte_count_vmtransfer_page_range_36511_fields byte_count vmtransfer_page_range 0 36511 NULL
+__i2c_write_fndecl_36516_fields __i2c_write fndecl 6-3 36516 NULL
+hpfs_map_4sectors_fndecl_36523_fields hpfs_map_4sectors fndecl 2 36523 NULL
+igu_sb_cnt_bnx2x_36525_fields igu_sb_cnt bnx2x 0 36525 NULL
+ue_num_asd_bios_chim_struct_36526_fields ue_num asd_bios_chim_struct 0 36526 NULL
+ftdi_elan_edset_output_fndecl_36530_fields ftdi_elan_edset_output fndecl 0 36530 NULL
+sk_tcplen_svc_sock_36531_fields sk_tcplen svc_sock 0 36531 NULL
+acpi_os_read_memory_fndecl_36537_fields acpi_os_read_memory fndecl 3-1 36537 NULL
+actual_resp_len_be_cmd_resp_hdr_36543_fields actual_resp_len be_cmd_resp_hdr 0 36543 NULL
+pi_read_regr_fndecl_36548_fields pi_read_regr fndecl 0 36548 NULL
+net2272_write_packet_fndecl_36550_fields net2272_write_packet fndecl 4 36550 NULL
+ocfs2_fallocate_fndecl_36555_fields ocfs2_fallocate fndecl 3-4 36555 NULL nohasharray
+capture_chips_pcxhr_mgr_36555_fields capture_chips pcxhr_mgr 0 36555 &ocfs2_fallocate_fndecl_36555_fields
+fb_try_mode_fndecl_36560_fields fb_try_mode fndecl 4 36560 NULL
+fuse_file_compat_ioctl_fndecl_36564_fields fuse_file_compat_ioctl fndecl 2 36564 NULL
+by_ceph_frag_tree_split_36567_fields by ceph_frag_tree_split 0 36567 NULL
+sc_sq_depth_svcxprt_rdma_36568_fields sc_sq_depth svcxprt_rdma 0 36568 NULL
+vlan_tag_eth_fast_path_rx_cqe_36569_fields vlan_tag eth_fast_path_rx_cqe 0 36569 NULL
+frag_thresh_orinoco_private_36570_fields frag_thresh orinoco_private 0 36570 NULL
+page_count_agp_memory_36571_fields page_count agp_memory 0 36571 NULL
+__register_chrdev_fndecl_36572_fields __register_chrdev fndecl 0-3-2-1 36572 NULL
+ceph_msgpool_get_fndecl_36577_fields ceph_msgpool_get fndecl 2 36577 NULL
+ext2_xattr_trusted_set_fndecl_36580_fields ext2_xattr_trusted_set fndecl 6 36580 NULL
+num_shared_regs_intel_uncore_type_36581_fields num_shared_regs intel_uncore_type 0 36581 NULL
+rx_ring_size_pcnet32_private_36586_fields rx_ring_size pcnet32_private 0 36586 NULL nohasharray
+vmw_user_dmabuf_alloc_fndecl_36586_fields vmw_user_dmabuf_alloc fndecl 3 36586 &rx_ring_size_pcnet32_private_36586_fields
+bgrt_image_size_vardecl_36594_fields bgrt_image_size vardecl 0 36594 NULL
+UnitSizeFactor_NFTLMediaHeader_36597_fields UnitSizeFactor NFTLMediaHeader 0 36597 NULL nohasharray
+num_max_snd_ratden_36597_fields num_max snd_ratden 0 36597 &UnitSizeFactor_NFTLMediaHeader_36597_fields nohasharray
+mcp23s08_read_regs_fndecl_36597_fields mcp23s08_read_regs fndecl 4 36597 &num_max_snd_ratden_36597_fields
+update_block_group_fndecl_36600_fields update_block_group fndecl 4-3 36600 NULL
+reply_len_sg_header_36605_fields reply_len sg_header 0 36605 NULL nohasharray
+xfs_dir2_sf_addname_hard_fndecl_36605_fields xfs_dir2_sf_addname_hard fndecl 3 36605 &reply_len_sg_header_36605_fields
+drm_mm_insert_node_generic_fndecl_36608_fields drm_mm_insert_node_generic fndecl 3 36608 NULL
+f_pos_file_36619_fields f_pos file 0 36619 NULL
+nbd_size_set_fndecl_36620_fields nbd_size_set fndecl 3-4 36620 NULL
+gamma_size_drm_mode_crtc_lut_36622_fields gamma_size drm_mode_crtc_lut 0 36622 NULL
+raw_serial_size_x509_certificate_36629_fields raw_serial_size x509_certificate 0 36629 NULL
+block_count_mspro_sys_info_36630_fields block_count mspro_sys_info 0 36630 NULL
+acpi_aml_read_user_fndecl_36632_fields acpi_aml_read_user fndecl 2 36632 NULL
+i915_gem_execbuffer_parse_fndecl_36633_fields i915_gem_execbuffer_parse fndecl 6 36633 NULL nohasharray
+opcfg_ofsh_cyttsp4_sysinfo_data_36633_fields opcfg_ofsh cyttsp4_sysinfo_data 0 36633 &i915_gem_execbuffer_parse_fndecl_36633_fields
+read_super_block_fndecl_36638_fields read_super_block fndecl 2 36638 NULL
+context_id_iscsi_kwqe_conn_destroy_36653_fields context_id iscsi_kwqe_conn_destroy 0 36653 NULL
+block_write_end_fndecl_36656_fields block_write_end fndecl 0-5 36656 NULL
+shmem_alloc_page_fndecl_36659_fields shmem_alloc_page fndecl 3 36659 NULL
+dac_channels_mixer_oxygen_model_36662_fields dac_channels_mixer oxygen_model 0 36662 NULL
+regmap_raw_write_fndecl_36664_fields regmap_raw_write fndecl 0 36664 NULL
+roffset_scifioctl_copy_36667_fields roffset scifioctl_copy 0 36667 NULL
+i_file_acl_lo_ext4_inode_36684_fields i_file_acl_lo ext4_inode 0 36684 NULL
+size_drm_map_36685_fields size drm_map 0 36685 NULL
+size_drm_agp_buffer_36687_fields size drm_agp_buffer 0 36687 NULL
+nnode_sz_ubifs_info_36688_fields nnode_sz ubifs_info 0 36688 NULL nohasharray
+esas2r_max_sectors_vardecl_36688_fields esas2r_max_sectors vardecl 0 36688 &nnode_sz_ubifs_info_36688_fields nohasharray
+out_kvec_bytes_ceph_connection_36688_fields out_kvec_bytes ceph_connection 0 36688 &esas2r_max_sectors_vardecl_36688_fields
+rx_buffer_len_atl1c_adapter_36691_fields rx_buffer_len atl1c_adapter 0 36691 NULL
+hga_vram_len_vardecl_hgafb_c_36700_fields hga_vram_len vardecl_hgafb.c 0 36700 NULL
+map_szh_cyttsp4_sysinfo_data_36711_fields map_szh cyttsp4_sysinfo_data 0 36711 NULL
+dev_num_tpm_chip_36718_fields dev_num tpm_chip 0 36718 NULL
+reply_usif_notify_36722_fields reply usif_notify 0 36722 NULL
+alloc_blocks_hfsplus_inode_info_36725_fields alloc_blocks hfsplus_inode_info 0 36725 NULL
+common_buffer_phys_smscore_device_t_36739_fields common_buffer_phys smscore_device_t 0 36739 NULL
+get_meta_page_fndecl_36742_fields get_meta_page fndecl 2 36742 NULL
+early_reserve_e820_fndecl_36744_fields early_reserve_e820 fndecl 2-1 36744 NULL
+s2255_got_frame_fndecl_36746_fields s2255_got_frame fndecl 2 36746 NULL
+shmem_xattr_handler_set_fndecl_36751_fields shmem_xattr_handler_set fndecl 6 36751 NULL
+saved_raid_disk_md_rdev_36752_fields saved_raid_disk md_rdev 0 36752 NULL
+ath6kl_wmi_add_krk_cmd_fndecl_36763_fields ath6kl_wmi_add_krk_cmd fndecl 2 36763 NULL
+last_index_zap_details_36766_fields last_index zap_details 0 36766 NULL
+ocfs2_rm_xattr_cluster_fndecl_36767_fields ocfs2_rm_xattr_cluster fndecl 5-4-3 36767 NULL
+ocfs2_make_clusters_writable_fndecl_36769_fields ocfs2_make_clusters_writable fndecl 5-4-3 36769 NULL
+usb_serial_generic_write_fndecl_36788_fields usb_serial_generic_write fndecl 4 36788 NULL
+mmio_base_controller_36793_fields mmio_base controller 0 36793 NULL
+rx_count_cooked_sixpack_36794_fields rx_count_cooked sixpack 0 36794 NULL
+pad_bytes_regmap_format_36795_fields pad_bytes regmap_format 0 36795 NULL
+efi_runtime_map_setup_fndecl_36796_fields efi_runtime_map_setup fndecl 3 36796 NULL
+sector_stripe_head_36797_fields sector stripe_head 0 36797 NULL nohasharray
+copy_io_fndecl_36797_fields copy_io fndecl 3 36797 &sector_stripe_head_36797_fields
+v4l_bufsize_vardecl_36803_fields v4l_bufsize vardecl 0 36803 NULL
+idetape_chrdev_write_fndecl_36811_fields idetape_chrdev_write fndecl 3 36811 NULL
+mthca_reg_user_mr_fndecl_36815_fields mthca_reg_user_mr fndecl 2-3 36815 NULL
+size_drm_armada_gem_pwrite_36816_fields size drm_armada_gem_pwrite 0 36816 NULL
+mthca_setup_cmd_doorbells_fndecl_36817_fields mthca_setup_cmd_doorbells fndecl 2 36817 NULL
+card_type_nozomi_36822_fields card_type nozomi 0 36822 NULL
+ir_pre_altera_jtag_36823_fields ir_pre altera_jtag 0 36823 NULL
+orig_nents_sg_table_36824_fields orig_nents sg_table 0 36824 NULL
+bc_maxpayload_rpc_xprt_ops_36830_fields bc_maxpayload rpc_xprt_ops 0 36830 NULL
+acpi_initialize_tables_fndecl_36832_fields acpi_initialize_tables fndecl 2 36832 NULL
+rx_pg_ring_size_bnx2_36835_fields rx_pg_ring_size bnx2 0 36835 NULL
+total_bytes_btrfs_super_block_36845_fields total_bytes btrfs_super_block 0 36845 NULL
+hfsplus_attr_build_key_fndecl_36846_fields hfsplus_attr_build_key fndecl 0 36846 NULL
+first_user_ctxt_hfi1_devdata_36860_fields first_user_ctxt hfi1_devdata 0 36860 NULL nohasharray
+raid5_compute_sector_fndecl_36860_fields raid5_compute_sector fndecl 0-2 36860 &first_user_ctxt_hfi1_devdata_36860_fields
+xfs_alloc_get_rec_fndecl_36869_fields xfs_alloc_get_rec fndecl 0 36869 NULL nohasharray
+acpi_register_gsi_pic_fndecl_36869_fields acpi_register_gsi_pic fndecl 0-2 36869 &xfs_alloc_get_rec_fndecl_36869_fields
+vtotal_drm_display_mode_36870_fields vtotal drm_display_mode 0 36870 NULL
+txd_size_bdx_priv_36873_fields txd_size bdx_priv 0 36873 NULL
+tipc_sendmsg_fndecl_36882_fields tipc_sendmsg fndecl 3 36882 NULL
+vb2_dma_sg_get_userptr_fndecl_36888_fields vb2_dma_sg_get_userptr fndecl 2-3 36888 NULL
+size_cxgb4_range_36893_fields size cxgb4_range 0 36893 NULL
+sge_congestion_control_sge_params_36896_fields sge_congestion_control sge_params 0 36896 NULL
+limit_ixgbe_ring_feature_36904_fields limit ixgbe_ring_feature 0 36904 NULL
+actual_usb_request_36913_fields actual usb_request 0 36913 NULL
+udf_next_aext_fndecl_36926_fields udf_next_aext fndecl 0 36926 NULL
+ocfs2_make_right_split_rec_fndecl_36929_fields ocfs2_make_right_split_rec fndecl 3 36929 NULL nohasharray
+len_xfs_name_36929_fields len xfs_name 0 36929 &ocfs2_make_right_split_rec_fndecl_36929_fields
+nfsacl_decode_fndecl_36931_fields nfsacl_decode fndecl 2-0 36931 NULL
+page_base_gssp_in_token_36935_fields page_base gssp_in_token 0 36935 NULL
+end_offset_xilly_buffer_36946_fields end_offset xilly_buffer 0 36946 NULL nohasharray
+num_sections_nvsp_1_message_send_receive_buffer_complete_36946_fields num_sections nvsp_1_message_send_receive_buffer_complete 0 36946 &end_offset_xilly_buffer_36946_fields
+priv_size_rtnl_link_ops_36947_fields priv_size rtnl_link_ops 0 36947 NULL
+ntfs_prepare_pages_for_non_resident_write_fndecl_36959_fields ntfs_prepare_pages_for_non_resident_write fndecl 0 36959 NULL
+reserved_kmem_cache_36976_fields reserved kmem_cache 0 36976 NULL
+rx_bufsize_ath_common_36977_fields rx_bufsize ath_common 0 36977 NULL
+usbvision_frames_alloc_fndecl_36983_fields usbvision_frames_alloc fndecl 0-2 36983 NULL
+v_sync_strt_wid_aty128_crtc_36987_fields v_sync_strt_wid aty128_crtc 0 36987 NULL
+lbmAllocate_fndecl_36995_fields lbmAllocate fndecl 2 36995 NULL
+exp_len_ccp_rsa_engine_36998_fields exp_len ccp_rsa_engine 0 36998 NULL
+num_rxp_per_rx_bnad_37010_fields num_rxp_per_rx bnad 0 37010 NULL
+to_fw_map_37020_fields to fw_map 0 37020 NULL
+cb_group_width_exofs_dt_data_map_37027_fields cb_group_width exofs_dt_data_map 0 37027 NULL
+mmio_size_vmw_private_37038_fields mmio_size vmw_private 0 37038 NULL nohasharray
+dirty_poll_interval_fndecl_37038_fields dirty_poll_interval fndecl 0 37038 &mmio_size_vmw_private_37038_fields
+adjust_resource_fndecl_37046_fields adjust_resource fndecl 3-2 37046 NULL
+n_channels_cfg80211_sched_scan_request_37047_fields n_channels cfg80211_sched_scan_request 0 37047 NULL
+setcc_fndecl_37048_fields setcc fndecl 1 37048 NULL
+stolen_size_i915_ggtt_37050_fields stolen_size i915_ggtt 0 37050 NULL
+yres__sisbios_mode_37051_fields yres _sisbios_mode 0 37051 NULL
+memory_model_code_mspro_sys_info_37057_fields memory_model_code mspro_sys_info 0 37057 NULL
+neq_vf_resources_37066_fields neq vf_resources 0 37066 NULL
+mcp4131_read_fndecl_37067_fields mcp4131_read fndecl 3 37067 NULL
+vmw_cmdbuf_reserve_fndecl_37071_fields vmw_cmdbuf_reserve fndecl 2 37071 NULL
+driver_data_acpi_device_id_37074_fields driver_data acpi_device_id 0 37074 NULL
+rq_xprt_hlen_svc_rqst_37082_fields rq_xprt_hlen svc_rqst 0 37082 NULL
+rtc_devt_vardecl_rtc_dev_c_37090_fields rtc_devt vardecl_rtc-dev.c 0 37090 NULL
+filter_get_rx_ids_efx_nic_type_37093_fields filter_get_rx_ids efx_nic_type 0 37093 NULL
+cx25840_ir_rx_read_fndecl_37095_fields cx25840_ir_rx_read fndecl 3 37095 NULL
+gfs2_meta_ra_fndecl_37101_fields gfs2_meta_ra fndecl 2 37101 NULL
+filled_kobil_private_37104_fields filled kobil_private 0 37104 NULL
+rx_ring_size_bnxt_37115_fields rx_ring_size bnxt 0 37115 NULL nohasharray
+vlan_tag_rx_return_desc_37115_fields vlan_tag rx_return_desc 0 37115 &rx_ring_size_bnxt_37115_fields
+ocfs2_check_if_ancestor_fndecl_37125_fields ocfs2_check_if_ancestor fndecl 2 37125 NULL
+sc_blk_cnt_nilfs_sc_info_37130_fields sc_blk_cnt nilfs_sc_info 0 37130 NULL nohasharray
+__rh_alloc_fndecl_37130_fields __rh_alloc fndecl 2 37130 &sc_blk_cnt_nilfs_sc_info_37130_fields
+nfs_updatepage_fndecl_37131_fields nfs_updatepage fndecl 3-4 37131 NULL
+num_report_ids_mxt_object_37133_fields num_report_ids mxt_object 0 37133 NULL
+audio_mute_fndecl_37139_fields audio_mute fndecl 2 37139 NULL
+wdata_send_pages_fndecl_37142_fields wdata_send_pages fndecl 2 37142 NULL
+num_parts_cmdline_mtd_partition_37144_fields num_parts cmdline_mtd_partition 0 37144 NULL
+__xfs_seek_hole_data_fndecl_37159_fields __xfs_seek_hole_data fndecl 0-2-3 37159 NULL
+max_pdu_size_l2cap_conf_rfc_37161_fields max_pdu_size l2cap_conf_rfc 0 37161 NULL
+pcm_channels_amdtp_tscm_37163_fields pcm_channels amdtp_tscm 0 37163 NULL nohasharray
+ld_tgt_count_lov_desc_37163_fields ld_tgt_count lov_desc 0 37163 &pcm_channels_amdtp_tscm_37163_fields
+l_logBBstart_xlog_37164_fields l_logBBstart xlog 0 37164 NULL
+txCredits_edgeport_port_37166_fields txCredits edgeport_port 0 37166 NULL
+read_mmp_block_fndecl_37168_fields read_mmp_block fndecl 3 37168 NULL
+t_blk_res_xfs_trans_37169_fields t_blk_res xfs_trans 0 37169 NULL
+expect_bt_skb_cb_37170_fields expect bt_skb_cb 0 37170 NULL
+hva_to_pfn_slow_fndecl_37173_fields hva_to_pfn_slow fndecl 1 37173 NULL
+copy_pte_range_fndecl_37175_fields copy_pte_range fndecl 6 37175 NULL
+sisusbcon_do_font_op_fndecl_37180_fields sisusbcon_do_font_op fndecl 9 37180 NULL nohasharray
+octeon_init_droq_fndecl_37180_fields octeon_init_droq fndecl 4-3 37180 &sisusbcon_do_font_op_fndecl_37180_fields
+per_io_data_size_dm_target_37185_fields per_io_data_size dm_target 0 37185 NULL
+of_address_to_resource_fndecl_37191_fields of_address_to_resource fndecl 2 37191 NULL
+rx_status_0_ath5k_hw_rx_status_37197_fields rx_status_0 ath5k_hw_rx_status 0 37197 NULL
+nbperpage_jfs_sb_info_37199_fields nbperpage jfs_sb_info 0 37199 NULL
+digestsize_shash_alg_37203_fields digestsize shash_alg 0 37203 NULL
+last_message_count_mxt_data_37205_fields last_message_count mxt_data 0 37205 NULL
+offset_jffs2_eraseblock_37206_fields offset jffs2_eraseblock 0 37206 NULL
+num_VFs_pci_sriov_37207_fields num_VFs pci_sriov 0 37207 NULL
+test_hole_first_fndecl_37215_fields test_hole_first fndecl 1-2 37215 NULL
+xfs_dir2_node_trim_free_fndecl_37218_fields xfs_dir2_node_trim_free fndecl 2 37218 NULL
+height_fb_image_37238_fields height fb_image 0 37238 NULL
+write_max_at24_data_37243_fields write_max at24_data 0 37243 NULL
+csum_and_copy_to_iter_fndecl_37244_fields csum_and_copy_to_iter fndecl 2 37244 NULL
+test_unaligned_bulk_fndecl_37246_fields test_unaligned_bulk fndecl 2 37246 NULL
+i_refcount_loc_ocfs2_dinode_37249_fields i_refcount_loc ocfs2_dinode 0 37249 NULL
+hfsplus_find_attr_fndecl_37253_fields hfsplus_find_attr fndecl 0 37253 NULL
+ath6kl_wmi_ap_set_beacon_intvl_cmd_fndecl_37254_fields ath6kl_wmi_ap_set_beacon_intvl_cmd fndecl 2 37254 NULL
+pfkey_sockaddr_pair_size_fndecl_37257_fields pfkey_sockaddr_pair_size fndecl 0 37257 NULL
+size_uhci_debug_37265_fields size uhci_debug 0 37265 NULL
+__pskb_trim_head_fndecl_37267_fields __pskb_trim_head fndecl 2 37267 NULL
+ieee80211_rx_radiotap_hdrlen_fndecl_37268_fields ieee80211_rx_radiotap_hdrlen fndecl 0 37268 NULL
+blk_queue_update_dma_pad_fndecl_37275_fields blk_queue_update_dma_pad fndecl 2 37275 NULL
+max_packet_sz_rx_musb_hw_ep_37278_fields max_packet_sz_rx musb_hw_ep 0 37278 NULL
+scrollback_current_vardecl_fbcon_c_37279_fields scrollback_current vardecl_fbcon.c 0 37279 NULL
+reg_end_ath6kl_diag_reg_info_37280_fields reg_end ath6kl_diag_reg_info 0 37280 NULL
+ceph_msg_data_cursor_init_fndecl_37284_fields ceph_msg_data_cursor_init fndecl 2 37284 NULL
+do_ncp_rpc_call_fndecl_37285_fields do_ncp_rpc_call fndecl 2-4 37285 NULL
+aac_rx_ioremap_fndecl_37289_fields aac_rx_ioremap fndecl 2 37289 NULL
+lcd_hsync_len_atyfb_par_37297_fields lcd_hsync_len atyfb_par 0 37297 NULL
+svc_partial_recvfrom_fndecl_37311_fields svc_partial_recvfrom fndecl 0-5-4-3 37311 NULL
+xfs_xattr_iomap_begin_fndecl_37314_fields xfs_xattr_iomap_begin fndecl 3-2 37314 NULL
+tx_win_size_mwifiex_ie_types_btcoex_aggr_win_size_37317_fields tx_win_size mwifiex_ie_types_btcoex_aggr_win_size 0 37317 NULL
+size_dm_header_37319_fields size dm_header 0 37319 NULL
+mt76_mac_process_rx_fndecl_37334_fields mt76_mac_process_rx fndecl 0 37334 NULL
+ie_len_cfg80211_sched_scan_request_37335_fields ie_len cfg80211_sched_scan_request 0 37335 NULL nohasharray
+ufs_change_blocknr_fndecl_37335_fields ufs_change_blocknr fndecl 2-4-5 37335 &ie_len_cfg80211_sched_scan_request_37335_fields
+ud_cursor_fndecl_37338_fields ud_cursor fndecl 4 37338 NULL
+hso_serial_common_create_fndecl_37343_fields hso_serial_common_create fndecl 3 37343 NULL
+dma_handle_usb_memory_37350_fields dma_handle usb_memory 0 37350 NULL
+blksize_fuse_mount_data_37357_fields blksize fuse_mount_data 0 37357 NULL
+pdev_id_sm501_devdata_37360_fields pdev_id sm501_devdata 0 37360 NULL
+rc_len_whcrc_37363_fields rc_len whcrc 0 37363 NULL
+gsm_change_mtu_fndecl_37364_fields gsm_change_mtu fndecl 2 37364 NULL
+alauda_read_data_fndecl_37367_fields alauda_read_data fndecl 2 37367 NULL
+peer_addr_len_drbd_connection_37371_fields peer_addr_len drbd_connection 0 37371 NULL
+virtscsi_add_cmd_fndecl_37379_fields virtscsi_add_cmd fndecl 3-4 37379 NULL nohasharray
+size_list_size_vc4_bo_cache_37379_fields size_list_size vc4_bo_cache 0 37379 &virtscsi_add_cmd_fndecl_37379_fields
+gotoxay_fndecl_37380_fields gotoxay fndecl 2-3 37380 NULL
+nvkm_ramht_new_fndecl_37381_fields nvkm_ramht_new fndecl 2 37381 NULL
+size_pnp_mem_37384_fields size pnp_mem 0 37384 NULL
+smscore_createbuffer_fndecl_37390_fields smscore_createbuffer fndecl 3 37390 NULL nohasharray
+alloc_blksz_hfs_sb_info_37390_fields alloc_blksz hfs_sb_info 0 37390 &smscore_createbuffer_fndecl_37390_fields
+batadv_check_management_packet_fndecl_37394_fields batadv_check_management_packet fndecl 3 37394 NULL
+jdvbt90502_reg_read_fndecl_37400_fields jdvbt90502_reg_read fndecl 4 37400 NULL
+num_msix_vectors_i40e_hw_capabilities_37406_fields num_msix_vectors i40e_hw_capabilities 0 37406 NULL
+xfs_rtfree_extent_fndecl_37427_fields xfs_rtfree_extent fndecl 3-2 37427 NULL
+hr_block_bits_o2hb_region_37433_fields hr_block_bits o2hb_region 0 37433 NULL
+radeon_gart_size_vardecl_37434_fields radeon_gart_size vardecl 0 37434 NULL nohasharray
+inode_table_ext4_new_group_data_37434_fields inode_table ext4_new_group_data 0 37434 &radeon_gart_size_vardecl_37434_fields
+dib0700_ctrl_rd_fndecl_37445_fields dib0700_ctrl_rd fndecl 0 37445 NULL
+ag6xx_recv_fndecl_37448_fields ag6xx_recv fndecl 3 37448 NULL
+size_erst_record_id_cache_37450_fields size erst_record_id_cache 0 37450 NULL
+right_margin_fb_var_screeninfo_37453_fields right_margin fb_var_screeninfo 0 37453 NULL nohasharray
+file_size_squashfs_dir_inode_37453_fields file_size squashfs_dir_inode 0 37453 &right_margin_fb_var_screeninfo_37453_fields
+header_size_rxrpc_connection_37458_fields header_size rxrpc_connection 0 37458 NULL
+bi_sector_bvec_iter_37467_fields bi_sector bvec_iter 0 37467 NULL
+rate_ua101_37469_fields rate ua101 0 37469 NULL
+length_drm_event_37471_fields length drm_event 0 37471 NULL
+s_apbshift_ufs_sb_private_info_37473_fields s_apbshift ufs_sb_private_info 0 37473 NULL
+TupleLink_tuple_t_37482_fields TupleLink tuple_t 0 37482 NULL nohasharray
+do_compat_preadv64_fndecl_37482_fields do_compat_preadv64 fndecl 3 37482 &TupleLink_tuple_t_37482_fields
+size_ctxt_eager_bufs_37485_fields size ctxt_eager_bufs 0 37485 NULL nohasharray
+ath10k_mac_create_fndecl_37485_fields ath10k_mac_create fndecl 1 37485 &size_ctxt_eager_bufs_37485_fields
+params_len_nfc_evt_transaction_37500_fields params_len nfc_evt_transaction 0 37500 NULL
+lines_ivtv_osd_coords_37504_fields lines ivtv_osd_coords 0 37504 NULL nohasharray
+heads_mspro_devinfo_37504_fields heads mspro_devinfo 0 37504 &lines_ivtv_osd_coords_37504_fields
+ks8851_rdfifo_fndecl_37510_fields ks8851_rdfifo fndecl 3 37510 NULL
+inode_newsize_ok_fndecl_37511_fields inode_newsize_ok fndecl 0 37511 NULL
+__data_len_request_37523_fields __data_len request 0 37523 NULL nohasharray
+etherMtu_mac_eeprom_port_cfg_37523_fields etherMtu_mac eeprom_port_cfg 0 37523 &__data_len_request_37523_fields
+efx_realloc_channels_fndecl_37528_fields efx_realloc_channels fndecl 2-3 37528 NULL
+num_txd_netxen_adapter_37529_fields num_txd netxen_adapter 0 37529 NULL
+ieee80211_bss_info_update_fndecl_37537_fields ieee80211_bss_info_update fndecl 4 37537 NULL nohasharray
+dwords_qib_verbs_txreq_37537_fields dwords qib_verbs_txreq 0 37537 &ieee80211_bss_info_update_fndecl_37537_fields
+btrfs_io_bio_alloc_fndecl_37544_fields btrfs_io_bio_alloc fndecl 2 37544 NULL
+divisor_sfq_sched_data_37546_fields divisor sfq_sched_data 0 37546 NULL nohasharray
+keylen_ppp_mppe_state_37546_fields keylen ppp_mppe_state 0 37546 &divisor_sfq_sched_data_37546_fields
+extent_shift_ecryptfs_crypt_stat_37548_fields extent_shift ecryptfs_crypt_stat 0 37548 NULL
+dln2_transfer_fndecl_37576_fields dln2_transfer fndecl 0 37576 NULL
+len_efx_rx_buffer_37579_fields len efx_rx_buffer 0 37579 NULL
+catas_offset_mlx4_fw_37594_fields catas_offset mlx4_fw 0 37594 NULL
+ocfs2_cp_xattr_bucket_fndecl_37598_fields ocfs2_cp_xattr_bucket fndecl 3-4 37598 NULL
+tun_do_read_fndecl_37614_fields tun_do_read fndecl 0 37614 NULL
+eeprom_len_fmc_device_37616_fields eeprom_len fmc_device 0 37616 NULL
+dcbp_set_code_fndecl_37633_fields dcbp_set_code fndecl 2 37633 NULL
+lfb_height_screen_info_37634_fields lfb_height screen_info 0 37634 NULL
+rmtblkcnt2_xfs_da_args_37635_fields rmtblkcnt2 xfs_da_args 0 37635 NULL
+b_in_mon_reader_bin_37636_fields b_in mon_reader_bin 0 37636 NULL nohasharray
+chain_segment_sz_MPT3SAS_ADAPTER_37636_fields chain_segment_sz MPT3SAS_ADAPTER 0 37636 &b_in_mon_reader_bin_37636_fields
+addrlen_rpc_xprt_37643_fields addrlen rpc_xprt 0 37643 NULL
+alloc_ldt_struct_fndecl_37649_fields alloc_ldt_struct fndecl 1 37649 NULL
+cache_size_cache_37650_fields cache_size cache 0 37650 NULL
+r5l_append_payload_meta_fndecl_37651_fields r5l_append_payload_meta fndecl 3 37651 NULL
+hfcsusb_rx_frame_fndecl_37658_fields hfcsusb_rx_frame fndecl 3 37658 NULL
+efi_nextents_xfs_efi_log_format_37664_fields efi_nextents xfs_efi_log_format 0 37664 NULL
+early_bytes_rchan_buf_37669_fields early_bytes rchan_buf 0 37669 NULL
+lsave_sz_ubifs_info_37672_fields lsave_sz ubifs_info 0 37672 NULL
+len_ethtool_eeprom_37676_fields len ethtool_eeprom 0 37676 NULL
+eeprom_blob_size_iwl_priv_37680_fields eeprom_blob_size iwl_priv 0 37680 NULL
+lastextent_efs_inode_info_37681_fields lastextent efs_inode_info 0 37681 NULL
+zm_wmfw_adsp2_alg_hdr_37694_fields zm wmfw_adsp2_alg_hdr 0 37694 NULL
+usb_ftdi_elan_edset_setup_fndecl_37695_fields usb_ftdi_elan_edset_setup fndecl 0 37695 NULL
+snic_trace_max_pages_vardecl_37696_fields snic_trace_max_pages vardecl 0 37696 NULL
+orig_video_points_screen_info_37702_fields orig_video_points screen_info 0 37702 NULL
+num_tx_ring_sh_eth_private_37717_fields num_tx_ring sh_eth_private 0 37717 NULL
+regset_tls_get_fndecl_37721_fields regset_tls_get fndecl 3 37721 NULL
+zap_bt_entries_mapping_fndecl_37722_fields zap_bt_entries_mapping fndecl 3-4-2 37722 NULL
+bfad_debugfs_lseek_fndecl_37724_fields bfad_debugfs_lseek fndecl 2 37724 NULL
+des3_dwceqos_dma_desc_37725_fields des3 dwceqos_dma_desc 0 37725 NULL
+cciss_geometry_inquiry_fndecl_37730_fields cciss_geometry_inquiry fndecl 4 37730 NULL
+sk_wmem_queued_sock_37733_fields sk_wmem_queued sock 0 37733 NULL
+len_cap_mon_bin_hdr_37739_fields len_cap mon_bin_hdr 0 37739 NULL
+cryptlen_skcipher_request_37750_fields cryptlen skcipher_request 0 37750 NULL
+num_enh_eq_cfgs_wm8994_pdata_37752_fields num_enh_eq_cfgs wm8994_pdata 0 37752 NULL
+vmw_kms_ldu_do_dmabuf_dirty_fndecl_37757_fields vmw_kms_ldu_do_dmabuf_dirty fndecl 6 37757 NULL
+length_acpi_object_buffer_37768_fields length acpi_object_buffer 0 37768 NULL
+prot_length_se_cmd_37769_fields prot_length se_cmd 0 37769 NULL
+access_length_acpi_object_region_field_37774_fields access_length acpi_object_region_field 0 37774 NULL
+block_size_mspro_sys_info_37775_fields block_size mspro_sys_info 0 37775 NULL
+buf_size_usb_data_stream_37781_fields buf_size usb_data_stream 0 37781 NULL
+ext4_init_dot_dotdot_fndecl_37792_fields ext4_init_dot_dotdot fndecl 4-3 37792 NULL
+update_interval_frames_snd_card_asihpi_37794_fields update_interval_frames snd_card_asihpi 0 37794 NULL
+bytes_per_block_svga3d_surface_desc_37798_fields bytes_per_block svga3d_surface_desc 0 37798 NULL
+nilfs_sufile_read_fndecl_37800_fields nilfs_sufile_read fndecl 2 37800 NULL nohasharray
+gso_max_segs_net_device_37800_fields gso_max_segs net_device 0 37800 &nilfs_sufile_read_fndecl_37800_fields
+eo_get_last_eb_blk_ocfs2_extent_tree_operations_37802_fields eo_get_last_eb_blk ocfs2_extent_tree_operations 0 37802 NULL
+exec_verb_hdac_device_37803_fields exec_verb hdac_device 0 37803 NULL
+word_4_ns_rsqe_37805_fields word_4 ns_rsqe 0 37805 NULL
+gid_tbl_len_ib_port_attr_37809_fields gid_tbl_len ib_port_attr 0 37809 NULL nohasharray
+devnum_genwqe_genwqe_dev_37809_fields devnum_genwqe genwqe_dev 0 37809 &gid_tbl_len_ib_port_attr_37809_fields
+num_vectors_i40e_virtchnl_iwarp_qvlist_info_37812_fields num_vectors i40e_virtchnl_iwarp_qvlist_info 0 37812 NULL
+touchpad_num_ad714x_platform_data_37818_fields touchpad_num ad714x_platform_data 0 37818 NULL
+out_ep_snd_usb_midi_endpoint_info_37819_fields out_ep snd_usb_midi_endpoint_info 0 37819 NULL
+max_header_size_ircomm_tty_cb_37822_fields max_header_size ircomm_tty_cb 0 37822 NULL
+my_addr_len_drbd_connection_37828_fields my_addr_len drbd_connection 0 37828 NULL
+rbd_img_request_create_fndecl_37833_fields rbd_img_request_create fndecl 3-2 37833 NULL
+mru_syncppp_37835_fields mru syncppp 0 37835 NULL
+slot_width_mvs_chip_info_37839_fields slot_width mvs_chip_info 0 37839 NULL
+ra_tid_iwlagn_tx_resp_37853_fields ra_tid iwlagn_tx_resp 0 37853 NULL
+nents_usnic_uiom_chunk_37860_fields nents usnic_uiom_chunk 0 37860 NULL
+assoclen_aead_request_37866_fields assoclen aead_request 0 37866 NULL
+xdr_copy_to_scratch_fndecl_37868_fields xdr_copy_to_scratch fndecl 2 37868 NULL nohasharray
+chunk_io_fndecl_37868_fields chunk_io fndecl 3 37868 &xdr_copy_to_scratch_fndecl_37868_fields
+btrfs_set_header_nritems_fndecl_37869_fields btrfs_set_header_nritems fndecl 2 37869 NULL
+hx8357_spi_write_then_read_fndecl_37879_fields hx8357_spi_write_then_read fndecl 5 37879 NULL
+leaf_delete_items_fndecl_37885_fields leaf_delete_items fndecl 5 37885 NULL
+____alloc_ei_netdev_fndecl_37888_fields ____alloc_ei_netdev fndecl 1 37888 NULL
+dm_bufio_client_create_fndecl_37889_fields dm_bufio_client_create fndecl 2 37889 NULL
+gss_wrap_kerberos_fndecl_37890_fields gss_wrap_kerberos fndecl 2 37890 NULL
+bulk_in_ipheth_device_37894_fields bulk_in ipheth_device 0 37894 NULL nohasharray
+xfs_buf_get_uncached_fndecl_37894_fields xfs_buf_get_uncached fndecl 2 37894 &bulk_in_ipheth_device_37894_fields
+prod_xfs_alloc_arg_37897_fields prod xfs_alloc_arg 0 37897 NULL
+calc_send_wqe_fndecl_37899_fields calc_send_wqe fndecl 0 37899 NULL nohasharray
+logi_dj_hidpp_event_fndecl_37899_fields logi_dj_hidpp_event fndecl 4 37899 &calc_send_wqe_fndecl_37899_fields
+vc4_get_cache_list_for_size_fndecl_37902_fields vc4_get_cache_list_for_size fndecl 2 37902 NULL
+datalen_user_key_payload_37906_fields datalen user_key_payload 0 37906 NULL
+pasid_kfd_process_37907_fields pasid kfd_process 0 37907 NULL
+input_report_size_rmi_data_37929_fields input_report_size rmi_data 0 37929 NULL
+ep_urb_context_37938_fields ep urb_context 0 37938 NULL
+phys_memory_base_mgsl_struct_37952_fields phys_memory_base mgsl_struct 0 37952 NULL
+wpa_ie_len_islpci_bss_wpa_ie_37953_fields wpa_ie_len islpci_bss_wpa_ie 0 37953 NULL
+rx_ring_count_fm10k_intfc_37957_fields rx_ring_count fm10k_intfc 0 37957 NULL
+cleanmarker_size_jffs2_sb_info_37959_fields cleanmarker_size jffs2_sb_info 0 37959 NULL
+num_kcontrols_snd_soc_tplg_dapm_widget_37960_fields num_kcontrols snd_soc_tplg_dapm_widget 0 37960 NULL
+consume_size_vmci_qp_alloc_info_vmvm_37962_fields consume_size vmci_qp_alloc_info_vmvm 0 37962 NULL
+unmap_vmas_fndecl_37967_fields unmap_vmas fndecl 4-3 37967 NULL
+count_nfsd_readres_37988_fields count nfsd_readres 0 37988 NULL
+nlmsvc_lookup_host_fndecl_37992_fields nlmsvc_lookup_host fndecl 3 37992 NULL
+old_blkaddr_f2fs_io_info_37994_fields old_blkaddr f2fs_io_info 0 37994 NULL nohasharray
+data_size_cyttsp4_sysinfo_ofs_37994_fields data_size cyttsp4_sysinfo_ofs 0 37994 &old_blkaddr_f2fs_io_info_37994_fields
+size_qla_flt_region_37995_fields size qla_flt_region 0 37995 NULL
+key_size_bpf_map_37996_fields key_size bpf_map 0 37996 NULL
+bt_sock_stream_recvmsg_fndecl_37997_fields bt_sock_stream_recvmsg fndecl 3 37997 NULL
+icmp_manip_pkt_fndecl_38011_fields icmp_manip_pkt fndecl 4 38011 NULL
+rfcomm_tty_write_fndecl_38016_fields rfcomm_tty_write fndecl 3 38016 NULL
+max_cmnds_vardecl_aic94xx_hwi_c_38022_fields max_cmnds vardecl_aic94xx_hwi.c 0 38022 NULL nohasharray
+l_len_xfs_flock64_38022_fields l_len xfs_flock64 0 38022 &max_cmnds_vardecl_aic94xx_hwi_c_38022_fields
+num_entries_ipt_replace_38023_fields num_entries ipt_replace 0 38023 NULL
+iriap_connect_confirm_fndecl_38027_fields iriap_connect_confirm fndecl 5 38027 NULL
+ath6kl_set_bitrate_mask64_fndecl_38029_fields ath6kl_set_bitrate_mask64 fndecl 2 38029 NULL
+sensb_res_len_nfc_target_38034_fields sensb_res_len nfc_target 0 38034 NULL
+ip6_tnl_change_mtu_fndecl_38041_fields ip6_tnl_change_mtu fndecl 2 38041 NULL nohasharray
+write_page_fndecl_38041_fields write_page fndecl 2 38041 &ip6_tnl_change_mtu_fndecl_38041_fields
+x25_negotiate_facilities_fndecl_38044_fields x25_negotiate_facilities fndecl 0 38044 NULL
+open_devices_btrfs_fs_devices_38045_fields open_devices btrfs_fs_devices 0 38045 NULL
+reference_rate_vardecl_xfi_c_38047_fields reference_rate vardecl_xfi.c 0 38047 NULL
+group_devt_vfio_38048_fields group_devt vfio 0 38048 NULL
+offset_drm_local_map_38055_fields offset drm_local_map 0 38055 NULL
+isd200_set_srb_fndecl_38056_fields isd200_set_srb fndecl 4 38056 NULL
+sctp_auth_create_key_fndecl_38058_fields sctp_auth_create_key fndecl 1 38058 NULL nohasharray
+length_ipw_rx_packet_38058_fields length ipw_rx_packet 0 38058 &sctp_auth_create_key_fndecl_38058_fields
+add_vol_fndecl_38066_fields add_vol fndecl 3-6 38066 NULL
+extent_fiemap_fndecl_38070_fields extent_fiemap fndecl 4-3 38070 NULL
+numPartitionMaps_logicalVolDesc_38073_fields numPartitionMaps logicalVolDesc 0 38073 NULL
+length_wpa_param_38074_fields length wpa_param 0 38074 NULL
+hfsplus_submit_bio_fndecl_38085_fields hfsplus_submit_bio fndecl 2 38085 NULL
+xfs_rmap_update_fndecl_38088_fields xfs_rmap_update fndecl 0 38088 NULL
+driver_data_pca953x_chip_38096_fields driver_data pca953x_chip 0 38096 NULL
+bd_group_ext4_buddy_38101_fields bd_group ext4_buddy 0 38101 NULL nohasharray
+la_bm_off_ocfs2_local_alloc_38101_fields la_bm_off ocfs2_local_alloc 0 38101 &bd_group_ext4_buddy_38101_fields
+softingcs_index_vardecl_softing_cs_c_38102_fields softingcs_index vardecl_softing_cs.c 0 38102 NULL
+data_size_il4965_firmware_pieces_38105_fields data_size il4965_firmware_pieces 0 38105 NULL
+reg_stride_order_regmap_38114_fields reg_stride_order regmap 0 38114 NULL
+length_floppy_raw_cmd_38116_fields length floppy_raw_cmd 0 38116 NULL
+rmtblkno_xfs_da_args_38121_fields rmtblkno xfs_da_args 0 38121 NULL
+len_rxd_desc_38127_fields len rxd_desc 0 38127 NULL
+crtc_h_drm_plane_state_38132_fields crtc_h drm_plane_state 0 38132 NULL
+irq_intel_mid_wdt_pdata_38135_fields irq intel_mid_wdt_pdata 0 38135 NULL
+sfi_sysfs_install_table_fndecl_38139_fields sfi_sysfs_install_table fndecl 1 38139 NULL
+num_regulators_tps65910_reg_38145_fields num_regulators tps65910_reg 0 38145 NULL
+nentries_ebt_replace_kernel_38149_fields nentries ebt_replace_kernel 0 38149 NULL
+btrfs_get_io_failure_record_fndecl_38153_fields btrfs_get_io_failure_record fndecl 2-3 38153 NULL
+data_dma_pegasus_38158_fields data_dma pegasus 0 38158 NULL
+xfs_free_extent_fix_freelist_fndecl_38159_fields xfs_free_extent_fix_freelist fndecl 2 38159 NULL
+sock_recvmsg_fndecl_38178_fields sock_recvmsg fndecl 0 38178 NULL nohasharray
+__mxt_read_reg_fndecl_38178_fields __mxt_read_reg fndecl 3-0 38178 &sock_recvmsg_fndecl_38178_fields
+zone_end_strip_zone_38191_fields zone_end strip_zone 0 38191 NULL
+pfpg_size_nvm_dev_38197_fields pfpg_size nvm_dev 0 38197 NULL
+driver_data_i2c_device_id_38200_fields driver_data i2c_device_id 0 38200 NULL
+raw_sig_size_x509_certificate_38211_fields raw_sig_size x509_certificate 0 38211 NULL
+ath6kl_wmi_del_wow_pattern_cmd_fndecl_38224_fields ath6kl_wmi_del_wow_pattern_cmd fndecl 2 38224 NULL nohasharray
+prealloc_stream_buf_vardecl_hpioctl_c_38224_fields prealloc_stream_buf vardecl_hpioctl.c 0 38224 &ath6kl_wmi_del_wow_pattern_cmd_fndecl_38224_fields
+firm_numbers_queue_AdapterControlBlock_38236_fields firm_numbers_queue AdapterControlBlock 0 38236 NULL
+ipwireless_network_packet_received_fndecl_38238_fields ipwireless_network_packet_received fndecl 4 38238 NULL
+periodic_bytes_fndecl_38241_fields periodic_bytes fndecl 0 38241 NULL
+submit_bio_start_async_submit_bio_38242_fields submit_bio_start async_submit_bio 0 38242 NULL
+get_cell_fndecl_38247_fields get_cell fndecl 2 38247 NULL
+isd200_try_enum_fndecl_38250_fields isd200_try_enum fndecl 2 38250 NULL nohasharray
+name_len_ext2_dir_entry_2_38250_fields name_len ext2_dir_entry_2 0 38250 &isd200_try_enum_fndecl_38250_fields
+alloc_hippi_dev_fndecl_38251_fields alloc_hippi_dev fndecl 1 38251 NULL
+bdbars_count_intel8x0m_38253_fields bdbars_count intel8x0m 0 38253 NULL
+bLength_usb_cdc_country_functional_desc_38256_fields bLength usb_cdc_country_functional_desc 0 38256 NULL nohasharray
+rsize_nfs_server_38256_fields rsize nfs_server 0 38256 &bLength_usb_cdc_country_functional_desc_38256_fields
+_osd_req_cdb_len_fndecl_38259_fields _osd_req_cdb_len fndecl 0 38259 NULL
+rq_wqe_count_mlx5_ib_create_wq_38263_fields rq_wqe_count mlx5_ib_create_wq 0 38263 NULL
+start_limited_discovery_fndecl_38264_fields start_limited_discovery fndecl 4 38264 NULL
+id_mlx5_fc_38274_fields id mlx5_fc 0 38274 NULL
+max_read_sge_ib_qp_38275_fields max_read_sge ib_qp 0 38275 NULL nohasharray
+prepare_header100_fndecl_38275_fields prepare_header100 fndecl 0 38275 &max_read_sge_ib_qp_38275_fields
+min_pnp_port_38276_fields min pnp_port 0 38276 NULL
+numpmkid_host_if_pmkid_attr_38277_fields numpmkid host_if_pmkid_attr 0 38277 NULL nohasharray
+irnet_connect_confirm_fndecl_38277_fields irnet_connect_confirm fndecl 5 38277 &numpmkid_host_if_pmkid_attr_38277_fields
+len_osd_attr_38284_fields len osd_attr 0 38284 NULL
+pci_cardbus_mem_size_vardecl_38290_fields pci_cardbus_mem_size vardecl 0 38290 NULL
+compat_arch_ptrace_fndecl_38298_fields compat_arch_ptrace fndecl 3 38298 NULL
+height_zoran_v4l_settings_38307_fields height zoran_v4l_settings 0 38307 NULL
+bad_peb_count_ubi_attach_info_38310_fields bad_peb_count ubi_attach_info 0 38310 NULL
+ftid_base_tid_info_38313_fields ftid_base tid_info 0 38313 NULL
+nr_siblings_perf_event_38320_fields nr_siblings perf_event 0 38320 NULL
+shader_rec_count_drm_vc4_submit_cl_38324_fields shader_rec_count drm_vc4_submit_cl 0 38324 NULL
+radeon_kms_compat_ioctl_fndecl_38328_fields radeon_kms_compat_ioctl fndecl 2 38328 NULL
+raydium_i2c_read_fndecl_38332_fields raydium_i2c_read fndecl 4 38332 NULL
+iov_len_sg_iovec_38337_fields iov_len sg_iovec 0 38337 NULL nohasharray
+ext_lfb_base_screen_info_38337_fields ext_lfb_base screen_info 0 38337 &iov_len_sg_iovec_38337_fields
+num_sys_eqs_mlx4_dev_cap_38340_fields num_sys_eqs mlx4_dev_cap 0 38340 NULL
+record_size_vardecl_mtdoops_c_38343_fields record_size vardecl_mtdoops.c 0 38343 NULL
+len_nft_data_desc_38346_fields len nft_data_desc 0 38346 NULL
+shim_offset_sst_res_info_38347_fields shim_offset sst_res_info 0 38347 NULL
+pf_fhlen_nfsd4_putfh_38348_fields pf_fhlen nfsd4_putfh 0 38348 NULL
+xfs_dir3_free_get_buf_fndecl_38355_fields xfs_dir3_free_get_buf fndecl 2 38355 NULL
+rate_snd_soc_dai_38358_fields rate snd_soc_dai 0 38358 NULL
+pci_sriov_resource_alignment_fndecl_38365_fields pci_sriov_resource_alignment fndecl 0 38365 NULL
+flush_buffer_fndecl_38367_fields flush_buffer fndecl 2 38367 NULL
+ri_length_gfs2_rindex_38375_fields ri_length gfs2_rindex 0 38375 NULL
+options_len_ip_tunnel_info_38380_fields options_len ip_tunnel_info 0 38380 NULL nohasharray
+offset_ttm_buffer_object_38380_fields offset ttm_buffer_object 0 38380 &options_len_ip_tunnel_info_38380_fields
+blk_register_region_fndecl_38387_fields blk_register_region fndecl 2-1 38387 NULL
+ext4_ext_rm_leaf_fndecl_38397_fields ext4_ext_rm_leaf fndecl 5 38397 NULL
+hfsplus_brec_read_fndecl_38399_fields hfsplus_brec_read fndecl 0 38399 NULL
+xdr_xcode_array2_fndecl_38417_fields xdr_xcode_array2 fndecl 2 38417 NULL
+i40iw_cm_reject_fndecl_38423_fields i40iw_cm_reject fndecl 3 38423 NULL nohasharray
+todo_dmxdev_filter_38423_fields todo dmxdev_filter 0 38423 &i40iw_cm_reject_fndecl_38423_fields
+remap_exception_fndecl_38426_fields remap_exception fndecl 4 38426 NULL
+mwifiex_get_rates_from_cfg80211_fndecl_38427_fields mwifiex_get_rates_from_cfg80211 fndecl 0 38427 NULL
+ide_set_dma_mode_fndecl_38428_fields ide_set_dma_mode fndecl 2 38428 NULL
+m_chunk_size_drxk_state_38431_fields m_chunk_size drxk_state 0 38431 NULL
+num_total_adcs_snd_ice1712_38432_fields num_total_adcs snd_ice1712 0 38432 NULL
+r820t_write_fndecl_38436_fields r820t_write fndecl 4 38436 NULL
+ocfs2_iterate_xattr_buckets_fndecl_38437_fields ocfs2_iterate_xattr_buckets fndecl 2 38437 NULL
+cw1200_sdio_memcpy_toio_fndecl_38442_fields cw1200_sdio_memcpy_toio fndecl 4 38442 NULL
+vxge_rx_alloc_fndecl_38443_fields vxge_rx_alloc fndecl 3 38443 NULL
+__ieee80211_tx_skb_tid_band_fndecl_38444_fields __ieee80211_tx_skb_tid_band fndecl 3 38444 NULL nohasharray
+test_ofsh_cyttsp4_sysinfo_data_38444_fields test_ofsh cyttsp4_sysinfo_data 0 38444 &__ieee80211_tx_skb_tid_band_fndecl_38444_fields
+slave_count_w1_master_38454_fields slave_count w1_master 0 38454 NULL
+blocksize_gss_krb5_enctype_38477_fields blocksize gss_krb5_enctype 0 38477 NULL
+min_pfn_mapped_vardecl_init_c_38481_fields min_pfn_mapped vardecl_init.c 0 38481 NULL
+pnfs_update_layout_fndecl_38495_fields pnfs_update_layout fndecl 3-4 38495 NULL
+create_rcom_fndecl_38501_fields create_rcom fndecl 4 38501 NULL nohasharray
+info_len_ib_ucm_sidr_rep_38501_fields info_len ib_ucm_sidr_rep 0 38501 &create_rcom_fndecl_38501_fields
+udp_recvmsg_fndecl_38509_fields udp_recvmsg fndecl 3 38509 NULL nohasharray
+msdu_len_htt_rx_offload_msdu_38509_fields msdu_len htt_rx_offload_msdu 0 38509 &udp_recvmsg_fndecl_38509_fields
+isofs_readpages_fndecl_38512_fields isofs_readpages fndecl 4 38512 NULL
+__f2fs_replace_block_fndecl_38514_fields __f2fs_replace_block fndecl 4 38514 NULL
+prepare_merge_dm_exception_store_type_38515_fields prepare_merge dm_exception_store_type 0 38515 NULL
+max_sg_mthca_limits_38517_fields max_sg mthca_limits 0 38517 NULL
+if_broot_bytes_xfs_ifork_38518_fields if_broot_bytes xfs_ifork 0 38518 NULL
+mxuport_process_read_urb_data_fndecl_38523_fields mxuport_process_read_urb_data fndecl 3 38523 NULL
+emu_setup_memblk_fndecl_38524_fields emu_setup_memblk fndecl 5 38524 NULL
+max_pde_used_radeon_vm_38536_fields max_pde_used radeon_vm 0 38536 NULL
+amdgpu_sa_bo_manager_init_fndecl_38537_fields amdgpu_sa_bo_manager_init fndecl 3 38537 NULL
+prism2_ap_translate_scan_fndecl_38540_fields prism2_ap_translate_scan fndecl 0 38540 NULL
+cx18_av_read_fndecl_38542_fields cx18_av_read fndecl 0 38542 NULL
+ulist_add_merge_fndecl_38547_fields ulist_add_merge fndecl 0-2-3 38547 NULL nohasharray
+krb5_encrypt_fndecl_38547_fields krb5_encrypt fndecl 5 38547 &ulist_add_merge_fndecl_38547_fields
+fb_base_phys_radeonfb_info_38551_fields fb_base_phys radeonfb_info 0 38551 NULL
+set_stream_hw_fndecl_38553_fields set_stream_hw fndecl 3 38553 NULL nohasharray
+tx_win_size_mwifiex_add_ba_param_38553_fields tx_win_size mwifiex_add_ba_param 0 38553 &set_stream_hw_fndecl_38553_fields
+rx_max_size_rtl_usb_38560_fields rx_max_size rtl_usb 0 38560 NULL
+ext2_alloc_blocks_fndecl_38562_fields ext2_alloc_blocks fndecl 2 38562 NULL
+offset_writequeue_entry_38565_fields offset writequeue_entry 0 38565 NULL
+this_header_vardecl_initramfs_c_38567_fields this_header vardecl_initramfs.c 0 38567 NULL nohasharray
+gfs2_dir_read_leaf_fndecl_38567_fields gfs2_dir_read_leaf fndecl 5 38567 &this_header_vardecl_initramfs_c_38567_fields nohasharray
+htable_size_fndecl_38567_fields htable_size fndecl 0-1 38567 &gfs2_dir_read_leaf_fndecl_38567_fields
+memblock_alloc_base_nid_fndecl_38568_fields memblock_alloc_base_nid fndecl 2-0-3 38568 NULL
+len_port_buffer_38573_fields len port_buffer 0 38573 NULL nohasharray
+setup_dma_urb_38573_fields setup_dma urb 0 38573 &len_port_buffer_38573_fields
+block_mtu_hci_dev_38575_fields block_mtu hci_dev 0 38575 NULL
+data_dma_aiptek_38577_fields data_dma aiptek 0 38577 NULL
+rsr_ct_atc_38578_fields rsr ct_atc 0 38578 NULL
+usVActive__ATOM_DTD_FORMAT_38581_fields usVActive _ATOM_DTD_FORMAT 0 38581 NULL
+rx_tpa_start_cmp_len_flags_type_rx_tpa_start_cmp_38587_fields rx_tpa_start_cmp_len_flags_type rx_tpa_start_cmp 0 38587 NULL
+sub_alloc_fndecl_38591_fields sub_alloc fndecl 0 38591 NULL
+set_nfilters_fndecl_38597_fields set_nfilters fndecl 2 38597 NULL
+s_cgmask_ufs_sb_private_info_38603_fields s_cgmask ufs_sb_private_info 0 38603 NULL
+maxburst_usb_ep_38604_fields maxburst usb_ep 0 38604 NULL nohasharray
+v_offset_v2_38604_fields v offset_v2 0 38604 &maxburst_usb_ep_38604_fields nohasharray
+reiserfs_posix_acl_from_disk_fndecl_38604_fields reiserfs_posix_acl_from_disk fndecl 2 38604 &v_offset_v2_38604_fields
+fpWidth_nvidia_par_38605_fields fpWidth nvidia_par 0 38605 NULL
+p_arglen_rpc_procinfo_38611_fields p_arglen rpc_procinfo 0 38611 NULL
+mga_compat_ioctl_fndecl_38617_fields mga_compat_ioctl fndecl 2 38617 NULL
+cxgbit_alloc_skb_fndecl_38618_fields cxgbit_alloc_skb fndecl 2 38618 NULL nohasharray
+max_wqe_rqe_ocrdma_create_qp_rsp_38618_fields max_wqe_rqe ocrdma_create_qp_rsp 0 38618 &cxgbit_alloc_skb_fndecl_38618_fields
+pageshift_sddr55_card_info_38623_fields pageshift sddr55_card_info 0 38623 NULL
+ar5523_config_multi_fndecl_38630_fields ar5523_config_multi fndecl 4 38630 NULL
+level_kvm_shadow_walk_iterator_38631_fields level kvm_shadow_walk_iterator 0 38631 NULL
+next_burst_len_iscsi_datain_req_38632_fields next_burst_len iscsi_datain_req 0 38632 NULL nohasharray
+iscsi_if_send_reply_fndecl_38632_fields iscsi_if_send_reply fndecl 7 38632 &next_burst_len_iscsi_datain_req_38632_fields
+data_offset_vb2_plane_38635_fields data_offset vb2_plane 0 38635 NULL
+size_bucket_table_38640_fields size bucket_table 0 38640 NULL
+f2fs_seek_block_fndecl_38641_fields f2fs_seek_block fndecl 2 38641 NULL
+max_ssns_csio_fcoe_res_info_38647_fields max_ssns csio_fcoe_res_info 0 38647 NULL
+intel_lr_context_size_fndecl_38650_fields intel_lr_context_size fndecl 0 38650 NULL nohasharray
+ieee80211_send_null_response_fndecl_38650_fields ieee80211_send_null_response fndecl 2 38650 &intel_lr_context_size_fndecl_38650_fields
+truncate_pagecache_range_fndecl_38652_fields truncate_pagecache_range fndecl 2-3 38652 NULL
+rx_buffer_len_igbvf_adapter_38659_fields rx_buffer_len igbvf_adapter 0 38659 NULL
+hid_parse_report_fndecl_38666_fields hid_parse_report fndecl 3 38666 NULL
+def_bpp_mb862xx_gc_mode_38668_fields def_bpp mb862xx_gc_mode 0 38668 NULL
+tty_cdev_add_fndecl_38673_fields tty_cdev_add fndecl 4-2 38673 NULL
+drm_compat_ioctl_fndecl_38678_fields drm_compat_ioctl fndecl 2 38678 NULL
+txq_max_tg3_38686_fields txq_max tg3 0 38686 NULL
+sc_uaddr_len_nfs4_setclientid_38689_fields sc_uaddr_len nfs4_setclientid 0 38689 NULL
+len_irda_device_list_38690_fields len irda_device_list 0 38690 NULL
+sdebug_unmap_alignment_vardecl_scsi_debug_c_38693_fields sdebug_unmap_alignment vardecl_scsi_debug.c 0 38693 NULL
+ioremap_prot_fndecl_38695_fields ioremap_prot fndecl 2-1 38695 NULL
+bulk_in_ep_irda_usb_cb_38699_fields bulk_in_ep irda_usb_cb 0 38699 NULL
+get_user_pages_fast_fndecl_38708_fields get_user_pages_fast fndecl 1 38708 NULL
+ifx_spi_insert_flip_string_fndecl_38715_fields ifx_spi_insert_flip_string fndecl 3 38715 NULL
+esrt_data_vardecl_esrt_c_38729_fields esrt_data vardecl_esrt.c 0 38729 NULL
+ports_max_wusbhc_38743_fields ports_max wusbhc 0 38743 NULL
+__page_file_index_fndecl_38744_fields __page_file_index fndecl 0 38744 NULL
+myri10ge_small_bytes_vardecl_myri10ge_c_38752_fields myri10ge_small_bytes vardecl_myri10ge.c 0 38752 NULL nohasharray
+length_snd_hwdep_dsp_image_38752_fields length snd_hwdep_dsp_image 0 38752 &myri10ge_small_bytes_vardecl_myri10ge_c_38752_fields
+tag_ctrl_info_amd8111e_rx_dr_38754_fields tag_ctrl_info amd8111e_rx_dr 0 38754 NULL
+t4_max_iq_size_c4iw_hw_queue_38756_fields t4_max_iq_size c4iw_hw_queue 0 38756 NULL
+pkt_size_rmi_2d_sensor_38762_fields pkt_size rmi_2d_sensor 0 38762 NULL
+default_advmss_dst_ops_38765_fields default_advmss dst_ops 0 38765 NULL
+midi_snd_oxfw_stream_formation_38770_fields midi snd_oxfw_stream_formation 0 38770 NULL
+qib_alloc_devdata_fndecl_38776_fields qib_alloc_devdata fndecl 2 38776 NULL
+sw_end_stm_data_38777_fields sw_end stm_data 0 38777 NULL
+ih_blkno_ocfs2_inode_handle_38779_fields ih_blkno ocfs2_inode_handle 0 38779 NULL
+height_cx231xx_38782_fields height cx231xx 0 38782 NULL
+spi_read_buf_fndecl_38792_fields spi_read_buf fndecl 2 38792 NULL
+get_indirect_ea_fndecl_38798_fields get_indirect_ea fndecl 3 38798 NULL
+ioread32_fndecl_38804_fields ioread32 fndecl 0 38804 NULL nohasharray
+size_esb2rom_window_38804_fields size esb2rom_window 0 38804 &ioread32_fndecl_38804_fields
+raw6_getfrag_fndecl_38805_fields raw6_getfrag fndecl 3-4 38805 NULL
+taglen_compound_hdr_38807_fields taglen compound_hdr 0 38807 NULL
+maxpacksize_snd_usX2Y_substream_38808_fields maxpacksize snd_usX2Y_substream 0 38808 NULL nohasharray
+nb8800_receive_fndecl_38808_fields nb8800_receive fndecl 3 38808 &maxpacksize_snd_usX2Y_substream_38808_fields
+tx_ring_size_bnxt_38811_fields tx_ring_size bnxt 0 38811 NULL
+vlan_tci_sk_buff_38825_fields vlan_tci sk_buff 0 38825 NULL
+algorithm_r5conf_38831_fields algorithm r5conf 0 38831 NULL
+memblock_alloc_fndecl_38847_fields memblock_alloc fndecl 2-0 38847 NULL
+datablob_len_encrypted_key_payload_38850_fields datablob_len encrypted_key_payload 0 38850 NULL
+srs_nslot_sptlrpc_rule_set_38854_fields srs_nslot sptlrpc_rule_set 0 38854 NULL
+srp_map_sg_dma_fndecl_38856_fields srp_map_sg_dma fndecl 0 38856 NULL
+count_ixgbevf_ring_38867_fields count ixgbevf_ring 0 38867 NULL
+sectors_per_track_mspro_devinfo_38870_fields sectors_per_track mspro_devinfo 0 38870 NULL
+mask_mthca_alloc_38874_fields mask mthca_alloc 0 38874 NULL nohasharray
+if_sdio_handle_data_fndecl_38874_fields if_sdio_handle_data fndecl 3 38874 &mask_mthca_alloc_38874_fields
+wmi_set_ie_fndecl_38876_fields wmi_set_ie fndecl 3 38876 NULL
+mmc_spi_skip_fndecl_38879_fields mmc_spi_skip fndecl 3 38879 NULL nohasharray
+error_dvb_ringbuffer_38879_fields error dvb_ringbuffer 0 38879 &mmc_spi_skip_fndecl_38879_fields
+atalk_route_packet_fndecl_38886_fields atalk_route_packet fndecl 5-4 38886 NULL
+read_dummy_spi_nor_38888_fields read_dummy spi_nor 0 38888 NULL
+num_bna_intr_info_38889_fields num bna_intr_info 0 38889 NULL
+beb_rsvd_level_ubi_device_38898_fields beb_rsvd_level ubi_device 0 38898 NULL nohasharray
+reg_phys_intel_iommu_38898_fields reg_phys intel_iommu 0 38898 &beb_rsvd_level_ubi_device_38898_fields
+sg_width_mvs_chip_info_38900_fields sg_width mvs_chip_info 0 38900 NULL
+wr_buflen_nfsd4_write_38903_fields wr_buflen nfsd4_write 0 38903 NULL
+generic_elem_len_local_info_38904_fields generic_elem_len local_info 0 38904 NULL
+length_hfi1_tid_info_38905_fields length hfi1_tid_info 0 38905 NULL
+surface_bpp_drm_fb_helper_surface_size_38906_fields surface_bpp drm_fb_helper_surface_size 0 38906 NULL
+dst_ci_command_fndecl_38908_fields dst_ci_command fndecl 4 38908 NULL nohasharray
+scsi_get_vpd_page_fndecl_38908_fields scsi_get_vpd_page fndecl 4 38908 &dst_ci_command_fndecl_38908_fields
+max_window_tcp_sock_38923_fields max_window tcp_sock 0 38923 NULL
+data_size_ms_system_item_38924_fields data_size ms_system_item 0 38924 NULL
+usb_sg_init_fndecl_38925_fields usb_sg_init fndecl 6-7-3 38925 NULL nohasharray
+num_txqs_octeon_nic_if_config_38925_fields num_txqs octeon_nic_if_config 0 38925 &usb_sg_init_fndecl_38925_fields
+refresh_drm_cmdline_mode_38926_fields refresh drm_cmdline_mode 0 38926 NULL
+tx_queues_vardecl_bond_main_c_38932_fields tx_queues vardecl_bond_main.c 0 38932 NULL
+xfs_alloc_update_counters_fndecl_38938_fields xfs_alloc_update_counters fndecl 0 38938 NULL
+qib_restart_rc_fndecl_38939_fields qib_restart_rc fndecl 2 38939 NULL
+depth_cx231xx_fmt_38940_fields depth cx231xx_fmt 0 38940 NULL
+pcm_open_fndecl_38941_fields pcm_open fndecl 2 38941 NULL
+crypt_scatterlist_fndecl_38942_fields crypt_scatterlist fndecl 4 38942 NULL
+ecryptfs_write_lower_page_segment_fndecl_38943_fields ecryptfs_write_lower_page_segment fndecl 4 38943 NULL
+sc_page_off_o2net_sock_container_38950_fields sc_page_off o2net_sock_container 0 38950 NULL
+in_length_nd_cmd_set_config_hdr_38954_fields in_length nd_cmd_set_config_hdr 0 38954 NULL
+_mv88e6xxx_vtu_new_fndecl_38956_fields _mv88e6xxx_vtu_new fndecl 2 38956 NULL
+of_irq_parse_one_fndecl_38957_fields of_irq_parse_one fndecl 0 38957 NULL
+tcp_copied_sock_xprt_38964_fields tcp_copied sock_xprt 0 38964 NULL
+uregbase_qib_devdata_38972_fields uregbase qib_devdata 0 38972 NULL nohasharray
+wm8350_register_regulator_fndecl_38972_fields wm8350_register_regulator fndecl 2 38972 &uregbase_qib_devdata_38972_fields
+register_buffer_fndecl_38990_fields register_buffer fndecl 3 38990 NULL
+hdr_len_tnl_ptk_info_38993_fields hdr_len tnl_ptk_info 0 38993 NULL
+pcm_buf_elapsed_dma_ofs_snd_card_asihpi_pcm_38998_fields pcm_buf_elapsed_dma_ofs snd_card_asihpi_pcm 0 38998 NULL
+maxqlen_vardecl_seq_oss_init_c_39001_fields maxqlen vardecl_seq_oss_init.c 0 39001 NULL
+tlv_len_nfc_llcp_sdp_tlv_39007_fields tlv_len nfc_llcp_sdp_tlv 0 39007 NULL
+dram_end_intel_sst_drv_39008_fields dram_end intel_sst_drv 0 39008 NULL
+ia_columns_ar5416IniArray_39012_fields ia_columns ar5416IniArray 0 39012 NULL
+xfs_dialloc_ag_inobt_fndecl_39015_fields xfs_dialloc_ag_inobt fndecl 3 39015 NULL
+length_mtd_oob_region_39026_fields length mtd_oob_region 0 39026 NULL
+dlfb_submit_urb_fndecl_39028_fields dlfb_submit_urb fndecl 3 39028 NULL
+video_pbase_osd_info_39032_fields video_pbase osd_info 0 39032 NULL
+fwnet_receive_packet_fndecl_39034_fields fwnet_receive_packet fndecl 9 39034 NULL
+reserve_st_proto_s_39036_fields reserve st_proto_s 0 39036 NULL
+free_ubifs_lprops_39039_fields free ubifs_lprops 0 39039 NULL
+nvmet_ns_alloc_fndecl_39044_fields nvmet_ns_alloc fndecl 2 39044 NULL
+pep_reply_fndecl_39045_fields pep_reply fndecl 5 39045 NULL nohasharray
+fat_readpages_fndecl_39045_fields fat_readpages fndecl 4 39045 &pep_reply_fndecl_39045_fields
+num_ports_u132_39052_fields num_ports u132 0 39052 NULL
+ttm_agp_tt_create_fndecl_39056_fields ttm_agp_tt_create fndecl 3 39056 NULL nohasharray
+get_key_fscache_cookie_def_39056_fields get_key fscache_cookie_def 0 39056 &ttm_agp_tt_create_fndecl_39056_fields
+frameLen_rx_desc_39058_fields frameLen rx_desc 0 39058 NULL nohasharray
+minor_gigaset_driver_39058_fields minor gigaset_driver 0 39058 &frameLen_rx_desc_39058_fields
+send_set_xattr_fndecl_39062_fields send_set_xattr fndecl 6-4 39062 NULL
+n_buckets_bpf_htab_39067_fields n_buckets bpf_htab 0 39067 NULL nohasharray
+bnxt_get_max_irq_fndecl_39067_fields bnxt_get_max_irq fndecl 0 39067 &n_buckets_bpf_htab_39067_fields
+iscsit_handle_immediate_data_fndecl_39071_fields iscsit_handle_immediate_data fndecl 3 39071 NULL
+max_rules_crush_map_39073_fields max_rules crush_map 0 39073 NULL nohasharray
+num_counters_rdma_hw_stats_39073_fields num_counters rdma_hw_stats 0 39073 &max_rules_crush_map_39073_fields
+usbatm_write_cells_fndecl_39074_fields usbatm_write_cells fndecl 0 39074 NULL
+block_id_ms_boot_header_39075_fields block_id ms_boot_header 0 39075 NULL
+frame_len_b43_rxhdr_fw4_39076_fields frame_len b43_rxhdr_fw4 0 39076 NULL
+inode_sysv_dir_entry_39082_fields inode sysv_dir_entry 0 39082 NULL
+sge_rx_fndecl_39089_fields sge_rx fndecl 3 39089 NULL
+d0_vring_rx_dma_39093_fields d0 vring_rx_dma 0 39093 NULL
+negotiate_rsize_smb_version_operations_39094_fields negotiate_rsize smb_version_operations 0 39094 NULL
+n4sz_additional_sensor_data_39102_fields n4sz additional_sensor_data 0 39102 NULL
+array_size_drm_vmw_gb_surface_create_req_39114_fields array_size drm_vmw_gb_surface_create_req 0 39114 NULL
+bg_bits_ocfs2_group_desc_39116_fields bg_bits ocfs2_group_desc 0 39116 NULL
+rds_ib_sysctl_max_send_wr_vardecl_39120_fields rds_ib_sysctl_max_send_wr vardecl 0 39120 NULL
+rl_namelen_rcom_lock_39122_fields rl_namelen rcom_lock 0 39122 NULL
+user_block_count_mspro_sys_info_39124_fields user_block_count mspro_sys_info 0 39124 NULL
+bytes_per_datum_iio_buffer_39125_fields bytes_per_datum iio_buffer 0 39125 NULL
+l2t_end_adapter_39130_fields l2t_end adapter 0 39130 NULL nohasharray
+calc_memmap_size_fndecl_39130_fields calc_memmap_size fndecl 0-2-1 39130 &l2t_end_adapter_39130_fields
+udf_put_filename_fndecl_39133_fields udf_put_filename fndecl 0 39133 NULL nohasharray
+syst_pa_vardecl_sfi_core_c_39133_fields syst_pa vardecl_sfi_core.c 0 39133 &udf_put_filename_fndecl_39133_fields
+ceph_build_auth_request_fndecl_39135_fields ceph_build_auth_request fndecl 0 39135 NULL
+system_sample_rate_hdsp_39140_fields system_sample_rate hdsp 0 39140 NULL
+drvr_sglimit_blogic_adapter_39142_fields drvr_sglimit blogic_adapter 0 39142 NULL
+mmc_test_buffer_transfer_fndecl_39150_fields mmc_test_buffer_transfer fndecl 4 39150 NULL
+size_intel_initial_plane_config_39155_fields size intel_initial_plane_config 0 39155 NULL
+log_root_btrfs_super_block_39157_fields log_root btrfs_super_block 0 39157 NULL
+fcoe_start_cid_cnic_local_39162_fields fcoe_start_cid cnic_local 0 39162 NULL
+ath6kl_tm_rx_event_fndecl_39163_fields ath6kl_tm_rx_event fndecl 3 39163 NULL nohasharray
+sys_readv_fndecl_39163_fields sys_readv fndecl 3 39163 &ath6kl_tm_rx_event_fndecl_39163_fields
+num_mcg_mlx4_profile_39164_fields num_mcg mlx4_profile 0 39164 NULL
+ext2_try_to_allocate_with_rsv_fndecl_39166_fields ext2_try_to_allocate_with_rsv fndecl 0-4 39166 NULL
+ast_gem_create_fndecl_39167_fields ast_gem_create fndecl 2 39167 NULL
+blf_len_xfs_buf_log_format_39169_fields blf_len xfs_buf_log_format 0 39169 NULL
+qsize_inet_frags_39172_fields qsize inet_frags 0 39172 NULL nohasharray
+lib80211_michael_mic_verify_fndecl_39172_fields lib80211_michael_mic_verify fndecl 3 39172 &qsize_inet_frags_39172_fields
+grab_nat_entry_fndecl_39177_fields grab_nat_entry fndecl 2 39177 NULL
+skb_put_fndecl_39184_fields skb_put fndecl 2 39184 NULL
+max_handles_amdgpu_uvd_39193_fields max_handles amdgpu_uvd 0 39193 NULL nohasharray
+ttymajor_vardecl_mxser_c_39193_fields ttymajor vardecl_mxser.c 0 39193 &max_handles_amdgpu_uvd_39193_fields nohasharray
+ib_send_cm_drep_fndecl_39193_fields ib_send_cm_drep fndecl 3 39193 &ttymajor_vardecl_mxser_c_39193_fields
+udc_create_dma_chain_fndecl_39194_fields udc_create_dma_chain fndecl 3 39194 NULL
+rvt_map_phys_fmr_fndecl_39197_fields rvt_map_phys_fmr fndecl 4 39197 NULL
+maxentry_xtheader_39202_fields maxentry xtheader 0 39202 NULL
+mon_bin_compat_ioctl_fndecl_39209_fields mon_bin_compat_ioctl fndecl 3 39209 NULL
+len_vmci_datagram_snd_rcv_info_39211_fields len vmci_datagram_snd_rcv_info 0 39211 NULL
+ieee80211_skb_resize_fndecl_39216_fields ieee80211_skb_resize fndecl 3 39216 NULL
+xlvbd_init_blk_queue_fndecl_39217_fields xlvbd_init_blk_queue fndecl 2-3 39217 NULL
+num_gpu_pages_amdgpu_gart_39218_fields num_gpu_pages amdgpu_gart 0 39218 NULL
+lpfc_bg_setup_bpl_prot_fndecl_39221_fields lpfc_bg_setup_bpl_prot fndecl 0 39221 NULL
+seq_buf_to_user_fndecl_39222_fields seq_buf_to_user fndecl 3 39222 NULL
+max_reqs_kioctx_39227_fields max_reqs kioctx 0 39227 NULL
+xt_socket_get_sock_v4_fndecl_39236_fields xt_socket_get_sock_v4 fndecl 3 39236 NULL
+afs_extract_data_fndecl_39238_fields afs_extract_data fndecl 5 39238 NULL nohasharray
+__devres_alloc_node_fndecl_39238_fields __devres_alloc_node fndecl 2 39238 &afs_extract_data_fndecl_39238_fields
+mon_buff_area_fill_fndecl_39250_fields mon_buff_area_fill fndecl 3 39250 NULL nohasharray
+remote_mps_l2cap_chan_39250_fields remote_mps l2cap_chan 0 39250 &mon_buff_area_fill_fndecl_39250_fields
+raid5_get_active_stripe_fndecl_39252_fields raid5_get_active_stripe fndecl 2 39252 NULL
+num_cons_qed_eth_pf_params_39260_fields num_cons qed_eth_pf_params 0 39260 NULL
+data_offset_napi_gro_cb_39263_fields data_offset napi_gro_cb 0 39263 NULL
+idata_dma_usb_xpad_39278_fields idata_dma usb_xpad 0 39278 NULL
+xfs_rmap_alloc_fndecl_39293_fields xfs_rmap_alloc fndecl 0 39293 NULL nohasharray
+rxrpc_setsockopt_fndecl_39293_fields rxrpc_setsockopt fndecl 5 39293 &xfs_rmap_alloc_fndecl_39293_fields
+page_size_msb_data_39297_fields page_size msb_data 0 39297 NULL nohasharray
+max_vfi_lpfc_max_cfg_param_39297_fields max_vfi lpfc_max_cfg_param 0 39297 &page_size_msb_data_39297_fields nohasharray
+encoding_p_compressed_bm_39297_fields encoding p_compressed_bm 0 39297 &max_vfi_lpfc_max_cfg_param_39297_fields
+cxgbit_xmit_nondatain_pdu_fndecl_39302_fields cxgbit_xmit_nondatain_pdu fndecl 4 39302 NULL
+do_launder_page_fndecl_39306_fields do_launder_page fndecl 0 39306 NULL
+e820_end_of_ram_pfn_fndecl_39315_fields e820_end_of_ram_pfn fndecl 0 39315 NULL nohasharray
+rio_request_outb_dbell_fndecl_39315_fields rio_request_outb_dbell fndecl 3-2 39315 &e820_end_of_ram_pfn_fndecl_39315_fields
+depth_tw68_format_39322_fields depth tw68_format 0 39322 NULL nohasharray
+key_size_x509_parse_context_39322_fields key_size x509_parse_context 0 39322 &depth_tw68_format_39322_fields
+soc_camera_read_fndecl_39324_fields soc_camera_read fndecl 3 39324 NULL nohasharray
+rx_dataoffset_brcmf_msgbuf_39324_fields rx_dataoffset brcmf_msgbuf 0 39324 &soc_camera_read_fndecl_39324_fields
+test_queue_fndecl_39329_fields test_queue fndecl 3-5 39329 NULL
+size_bts_action_39331_fields size bts_action 0 39331 NULL
+unpack_u16_chunk_fndecl_39334_fields unpack_u16_chunk fndecl 0 39334 NULL
+page_jfs_log_39335_fields page jfs_log 0 39335 NULL
+nilfs_sufile_segment_usages_in_block_fndecl_39336_fields nilfs_sufile_segment_usages_in_block fndecl 0-2-3 39336 NULL
+num_channels_hw_mode_spec_39337_fields num_channels hw_mode_spec 0 39337 NULL nohasharray
+tx_pipe_brcmf_usbdev_info_39337_fields tx_pipe brcmf_usbdev_info 0 39337 &num_channels_hw_mode_spec_39337_fields
+svc_create_fndecl_39343_fields svc_create fndecl 2 39343 NULL
+nhead_offs_ubifs_info_39346_fields nhead_offs ubifs_info 0 39346 NULL
+root_offs_ubifs_mst_node_39347_fields root_offs ubifs_mst_node 0 39347 NULL
+roccat_common2_send_with_status_fndecl_39348_fields roccat_common2_send_with_status fndecl 4 39348 NULL
+ksm_might_need_to_copy_fndecl_39350_fields ksm_might_need_to_copy fndecl 3 39350 NULL
+efs_validate_vh_fndecl_39352_fields efs_validate_vh fndecl 0 39352 NULL
+nsize_jffs2_sum_dirent_mem_39355_fields nsize jffs2_sum_dirent_mem 0 39355 NULL
+hub_status_data_hc_driver_39357_fields hub_status_data hc_driver 0 39357 NULL nohasharray
+rbd_obj_request_create_fndecl_39357_fields rbd_obj_request_create fndecl 3-2 39357 &hub_status_data_hc_driver_39357_fields
+tx_ndp_modulus_cdc_ncm_ctx_39369_fields tx_ndp_modulus cdc_ncm_ctx 0 39369 NULL
+nftl_read_oob_fndecl_39370_fields nftl_read_oob fndecl 2-3 39370 NULL
+num_frames_camera_data_39372_fields num_frames camera_data 0 39372 NULL
+vsi_fshino_vxfs_sb_info_39379_fields vsi_fshino vxfs_sb_info 0 39379 NULL
+s_size_public_key_signature_39380_fields s_size public_key_signature 0 39380 NULL
+height_v4l2_mbus_framefmt_39383_fields height v4l2_mbus_framefmt 0 39383 NULL
+from_offset_text_match_39384_fields from_offset text_match 0 39384 NULL nohasharray
+tx_count_ethtool_channels_39384_fields tx_count ethtool_channels 0 39384 &from_offset_text_match_39384_fields
+lfb_depth_screen_info_39385_fields lfb_depth screen_info 0 39385 NULL
+read16_ssb_bus_ops_39388_fields read16 ssb_bus_ops 0 39388 NULL
+pf_cids_qed_tm_iids_39393_fields pf_cids qed_tm_iids 0 39393 NULL
+__page_set_anon_rmap_fndecl_39401_fields __page_set_anon_rmap fndecl 3 39401 NULL
+userptr_radeon_ttm_tt_39408_fields userptr radeon_ttm_tt 0 39408 NULL
+total_vfs_fm10k_iov_info_39412_fields total_vfs fm10k_iov_info 0 39412 NULL
+pages_i40iw_add_page_info_39415_fields pages i40iw_add_page_info 0 39415 NULL
+read8_reg_fndecl_39417_fields read8_reg fndecl 4 39417 NULL
+payld_len_htc_frame_hdr_39418_fields payld_len htc_frame_hdr 0 39418 NULL
+vramsize_sisusb_usb_data_39419_fields vramsize sisusb_usb_data 0 39419 NULL
+board_sample_rate_lx6464es_39420_fields board_sample_rate lx6464es 0 39420 NULL nohasharray
+stretch_height_usb_usbvision_39420_fields stretch_height usb_usbvision 0 39420 &board_sample_rate_lx6464es_39420_fields
+read_eeprom_fndecl_39423_fields read_eeprom fndecl 4 39423 NULL
+cros_ec_spi_receive_response_fndecl_39426_fields cros_ec_spi_receive_response fndecl 2 39426 NULL
+nftl_writeblock_fndecl_39428_fields nftl_writeblock fndecl 2 39428 NULL
+jpeg_len_solo_enc_dev_39431_fields jpeg_len solo_enc_dev 0 39431 NULL
+btrfs_del_csums_fndecl_39434_fields btrfs_del_csums fndecl 3-4 39434 NULL
+iov_len_iovec_39437_fields iov_len iovec 0 39437 NULL nohasharray
+ring_size__drm_i810_init_39437_fields ring_size _drm_i810_init 0 39437 &iov_len_iovec_39437_fields
+irq_sfi_rtc_table_entry_39438_fields irq sfi_rtc_table_entry 0 39438 NULL
+sdio_uart_write_fndecl_39449_fields sdio_uart_write fndecl 3 39449 NULL
+ocfs2_add_refcount_flag_fndecl_39451_fields ocfs2_add_refcount_flag fndecl 6-5 39451 NULL nohasharray
+zl10036_write_fndecl_39451_fields zl10036_write fndecl 3 39451 &ocfs2_add_refcount_flag_fndecl_39451_fields
+recovery_cp_mddev_39459_fields recovery_cp mddev 0 39459 NULL
+security_load_policy_fndecl_39462_fields security_load_policy fndecl 2 39462 NULL
+LMC_PKT_BUF_SZ_vardecl_lmc_main_c_39465_fields LMC_PKT_BUF_SZ vardecl_lmc_main.c 0 39465 NULL
+num_buffers_vardecl_cpia2_v4l_c_39466_fields num_buffers vardecl_cpia2_v4l.c 0 39466 NULL
+xfs_writepage_map_fndecl_39468_fields xfs_writepage_map fndecl 0 39468 NULL
+wipers_mcp4131_cfg_39469_fields wipers mcp4131_cfg 0 39469 NULL
+max_count_octeon_droq_39475_fields max_count octeon_droq 0 39475 NULL
+qib_verbs_send_pio_fndecl_39482_fields qib_verbs_send_pio fndecl 5 39482 NULL
+address_length_acpi_resource_fixed_memory32_39483_fields address_length acpi_resource_fixed_memory32 0 39483 NULL
+iov_iter_bvec_fndecl_39493_fields iov_iter_bvec fndecl 5-4 39493 NULL
+network_header_len_dwceqos_tx_39500_fields network_header_len dwceqos_tx 0 39500 NULL
+ppp_read_fndecl_39514_fields ppp_read fndecl 3 39514 NULL
+npins_intel_community_39518_fields npins intel_community 0 39518 NULL
+txsize_grcan_device_config_39527_fields txsize grcan_device_config 0 39527 NULL
+num_queues_bnx2x_39531_fields num_queues bnx2x 0 39531 NULL
+hugepage_add_new_anon_rmap_fndecl_39534_fields hugepage_add_new_anon_rmap fndecl 3 39534 NULL
+srpt_alloc_ioctx_fndecl_39537_fields srpt_alloc_ioctx fndecl 3 39537 NULL
+elem_size_v4l2_ctrl_39540_fields elem_size v4l2_ctrl 0 39540 NULL
+do_arpt_set_ctl_fndecl_39550_fields do_arpt_set_ctl fndecl 4 39550 NULL
+kaweth_internal_control_msg_fndecl_39552_fields kaweth_internal_control_msg fndecl 5-2 39552 NULL nohasharray
+do_trim_fndecl_39552_fields do_trim fndecl 4-5-3-2 39552 &kaweth_internal_control_msg_fndecl_39552_fields
+from_fw_map_39555_fields from fw_map 0 39555 NULL
+l2specific_len_l2tp_session_39558_fields l2specific_len l2tp_session 0 39558 NULL
+build_backref_tree_fndecl_39561_fields build_backref_tree fndecl 4 39561 NULL
+__ocfs2_find_path_fndecl_39563_fields __ocfs2_find_path fndecl 0 39563 NULL
+disk_size_disk_conf_39567_fields disk_size disk_conf 0 39567 NULL
+sys32_pwrite_fndecl_39572_fields sys32_pwrite fndecl 3 39572 NULL
+oh_len_omninet_header_39576_fields oh_len omninet_header 0 39576 NULL
+nfs4_file_llseek_fndecl_39578_fields nfs4_file_llseek fndecl 2 39578 NULL
+snbep_pci2phy_map_init_fndecl_39582_fields snbep_pci2phy_map_init fndecl 1 39582 NULL
+len_ubifs_scan_node_39584_fields len ubifs_scan_node 0 39584 NULL
+req_que_len_qla_hw_data_39587_fields req_que_len qla_hw_data 0 39587 NULL
+rq_bytes_sent_rpc_rqst_39591_fields rq_bytes_sent rpc_rqst 0 39591 NULL
+xfs_extent_free_create_intent_fndecl_39592_fields xfs_extent_free_create_intent fndecl 2 39592 NULL
+amanda_help_fndecl_39598_fields amanda_help fndecl 2 39598 NULL
+dm_consult_userspace_fndecl_39601_fields dm_consult_userspace fndecl 5 39601 NULL
+midi_ports_snd_emux_39605_fields midi_ports snd_emux 0 39605 NULL nohasharray
+ti_recv_fndecl_39605_fields ti_recv fndecl 3 39605 &midi_ports_snd_emux_39605_fields
+double_length_smbios_cru64_info_39607_fields double_length smbios_cru64_info 0 39607 NULL
+iscsi_nop_out_rsp_fndecl_39614_fields iscsi_nop_out_rsp fndecl 4 39614 NULL
+gpio_cs_count_tiny_spi_39618_fields gpio_cs_count tiny_spi 0 39618 NULL
+rx_buffer_order_efx_nic_39620_fields rx_buffer_order efx_nic 0 39620 NULL
+cookie_len_l2tp_session_39629_fields cookie_len l2tp_session 0 39629 NULL
+max_cq_sz_mthca_dev_lim_39630_fields max_cq_sz mthca_dev_lim 0 39630 NULL
+fb_phys_ocfb_dev_39632_fields fb_phys ocfb_dev 0 39632 NULL
+xfs_bmbt_lookup_ge_fndecl_39633_fields xfs_bmbt_lookup_ge fndecl 3-4-2 39633 NULL
+saa7134_alsa_dma_init_fndecl_39636_fields saa7134_alsa_dma_init fndecl 2 39636 NULL
+setup_arg_pages_fndecl_39645_fields setup_arg_pages fndecl 2 39645 NULL
+psn_rvt_swqe_39647_fields psn rvt_swqe 0 39647 NULL
+lookup_node_fndecl_39648_fields lookup_node fndecl 1 39648 NULL
+tx_len_hw_modul_39649_fields tx_len hw_modul 0 39649 NULL
+v9fs_listxattr_fndecl_39654_fields v9fs_listxattr fndecl 3 39654 NULL
+shmem_pseudo_vma_init_fndecl_39661_fields shmem_pseudo_vma_init fndecl 3 39661 NULL
+skb_copy_datagram_iter_fndecl_39662_fields skb_copy_datagram_iter fndecl 4-2-0 39662 NULL
+viafb_get_fb_size_from_pci_fndecl_39663_fields viafb_get_fb_size_from_pci fndecl 0 39663 NULL
+snd_rawmidi_transmit_peek_fndecl_39668_fields snd_rawmidi_transmit_peek fndecl 3-0 39668 NULL
+der_length_size_fndecl_39673_fields der_length_size fndecl 0 39673 NULL
+sectorsize_btrfs_super_block_39674_fields sectorsize btrfs_super_block 0 39674 NULL
+rdma_read_chunk_frmr_fndecl_39676_fields rdma_read_chunk_frmr fndecl 7-8 39676 NULL
+priv_size_Qdisc_ops_39692_fields priv_size Qdisc_ops 0 39692 NULL nohasharray
+fd_block_size_fd_dev_39692_fields fd_block_size fd_dev 0 39692 &priv_size_Qdisc_ops_39692_fields
+length_rvt_swqe_39694_fields length rvt_swqe 0 39694 NULL
+nb_ace_cci_nb_ports_39699_fields nb_ace cci_nb_ports 0 39699 NULL
+badblockpos_nand_chip_39700_fields badblockpos nand_chip 0 39700 NULL
+tid_ieee80211_ra_tid_39703_fields tid ieee80211_ra_tid 0 39703 NULL
+xfs_growfs_get_hdr_buf_fndecl_39706_fields xfs_growfs_get_hdr_buf fndecl 2-3 39706 NULL
+raid5_sync_request_fndecl_39721_fields raid5_sync_request fndecl 2 39721 NULL
+e1000_change_mtu_fndecl_39722_fields e1000_change_mtu fndecl 2 39722 NULL
+pglen_pnfs_device_39724_fields pglen pnfs_device 0 39724 NULL
+max_wrs_iwch_rnic_attributes_39735_fields max_wrs iwch_rnic_attributes 0 39735 NULL
+__hostap_add_bss_fndecl_39739_fields __hostap_add_bss fndecl 4 39739 NULL
+nla_reserve_64bit_fndecl_39742_fields nla_reserve_64bit fndecl 3 39742 NULL
+scif_unregister_fndecl_39743_fields scif_unregister fndecl 3 39743 NULL
+_ubh_bread__fndecl_39744_fields _ubh_bread_ fndecl 3 39744 NULL
+pipe_handler_request_fndecl_39749_fields pipe_handler_request fndecl 5 39749 NULL
+ocfs2_xattr_block_get_fndecl_39750_fields ocfs2_xattr_block_get fndecl 0 39750 NULL nohasharray
+total_blocks_hfsplus_sb_info_39750_fields total_blocks hfsplus_sb_info 0 39750 &ocfs2_xattr_block_get_fndecl_39750_fields
+drm_gtf2_2j_fndecl_39751_fields drm_gtf2_2j fndecl 0 39751 NULL
+am_length_xfs_attr_multiop_39754_fields am_length xfs_attr_multiop 0 39754 NULL
+delta_disks_mddev_39759_fields delta_disks mddev 0 39759 NULL
+map_swap_page_fndecl_39768_fields map_swap_page fndecl 0 39768 NULL nohasharray
+free_full_branch_fndecl_39768_fields free_full_branch fndecl 2 39768 &map_swap_page_fndecl_39768_fields
+add_range_with_merge_fndecl_39778_fields add_range_with_merge fndecl 5-4 39778 NULL
+num_supplies_wm8994_39780_fields num_supplies wm8994 0 39780 NULL
+__collapse_huge_page_isolate_fndecl_39784_fields __collapse_huge_page_isolate fndecl 2 39784 NULL
+buf_rte_log_le_39791_fields buf rte_log_le 0 39791 NULL
+digital_dep_link_up_fndecl_39793_fields digital_dep_link_up fndecl 5 39793 NULL
+den_max_snd_ratnum_39802_fields den_max snd_ratnum 0 39802 NULL
+meta_dev_idx_disk_conf_39810_fields meta_dev_idx disk_conf 0 39810 NULL
+jffs2_link_node_ref_fndecl_39817_fields jffs2_link_node_ref fndecl 3-4 39817 NULL
+pan_y_yuv_frame_info_39830_fields pan_y yuv_frame_info 0 39830 NULL
+sb_inopblock_xfs_sb_39837_fields sb_inopblock xfs_sb 0 39837 NULL nohasharray
+io_vardecl_arc_rimi_c_39837_fields io vardecl_arc-rimi.c 0 39837 &sb_inopblock_xfs_sb_39837_fields nohasharray
+pci_scan_root_bus_fndecl_39837_fields pci_scan_root_bus fndecl 2 39837 &io_vardecl_arc_rimi_c_39837_fields
+maxattr_genl_family_39841_fields maxattr genl_family 0 39841 NULL nohasharray
+_offset_iwl_rx_cmd_buffer_39841_fields _offset iwl_rx_cmd_buffer 0 39841 &maxattr_genl_family_39841_fields
+digi_write_inb_command_fndecl_39846_fields digi_write_inb_command fndecl 3 39846 NULL
+height_cx25821_channel_39847_fields height cx25821_channel 0 39847 NULL
+xres_panel_info_39849_fields xres panel_info 0 39849 NULL
+imtu_l2cap_chan_39857_fields imtu l2cap_chan 0 39857 NULL
+usb_stor_reset_common_fndecl_39866_fields usb_stor_reset_common fndecl 7 39866 NULL
+self_check_write_fndecl_39867_fields self_check_write fndecl 5 39867 NULL
+__bdev_writeseg_fndecl_39876_fields __bdev_writeseg fndecl 4-2 39876 NULL
+xfs_alloc_get_freelist_fndecl_39881_fields xfs_alloc_get_freelist fndecl 0 39881 NULL
+resync_offset_mdp_superblock_1_39883_fields resync_offset mdp_superblock_1 0 39883 NULL
+btrfs_bio_wq_end_io_fndecl_39884_fields btrfs_bio_wq_end_io fndecl 0 39884 NULL
+xfs_iext_remove_fndecl_39886_fields xfs_iext_remove fndecl 3 39886 NULL
+osd_req_write_sg_fndecl_39887_fields osd_req_write_sg fndecl 5 39887 NULL
+video_base_sis_video_info_39896_fields video_base sis_video_info 0 39896 NULL
+s_inodes_per_group_ext4_sb_info_39910_fields s_inodes_per_group ext4_sb_info 0 39910 NULL
+spi_map_buf_fndecl_39919_fields spi_map_buf fndecl 5-0 39919 NULL
+i_eoffset_bfs_inode_39921_fields i_eoffset bfs_inode 0 39921 NULL
+qos_rmt_entries_fndecl_39927_fields qos_rmt_entries fndecl 0 39927 NULL
+data_blocks_dm_verity_39930_fields data_blocks dm_verity 0 39930 NULL
+vhost_iotlb_miss_fndecl_39933_fields vhost_iotlb_miss fndecl 2 39933 NULL
+max_mp_regs_mwifiex_sdio_card_reg_39936_fields max_mp_regs mwifiex_sdio_card_reg 0 39936 NULL
+height_font_desc_39938_fields height font_desc 0 39938 NULL nohasharray
+btrfs_i_size_write_fndecl_39938_fields btrfs_i_size_write fndecl 2 39938 &height_font_desc_39938_fields
+row_shift_omap4_keypad_39944_fields row_shift omap4_keypad 0 39944 NULL
+find_ts_ops_39950_fields find ts_ops 0 39950 NULL
+cn_size_x509_parse_context_39975_fields cn_size x509_parse_context 0 39975 NULL nohasharray
+msg_length_pcnet32_rx_head_39975_fields msg_length pcnet32_rx_head 0 39975 &cn_size_x509_parse_context_39975_fields nohasharray
+__hfsplus_getxattr_fndecl_39975_fields __hfsplus_getxattr fndecl 0 39975 &msg_length_pcnet32_rx_head_39975_fields
+xfs_map_blocks_fndecl_39985_fields xfs_map_blocks fndecl 2-0 39985 NULL
+extLength_kernel_long_ad_39988_fields extLength kernel_long_ad 0 39988 NULL
+btrfs_free_reserved_data_space_fndecl_39989_fields btrfs_free_reserved_data_space fndecl 2-3 39989 NULL
+lane_count_intel_dsi_39994_fields lane_count intel_dsi 0 39994 NULL
+playback_bufsize_vardecl_nm256_c_39995_fields playback_bufsize vardecl_nm256.c 0 39995 NULL
+start_sram_reserve_39999_fields start sram_reserve 0 39999 NULL
+dm_btree_lookup_next_single_fndecl_40001_fields dm_btree_lookup_next_single fndecl 2 40001 NULL
+r820t_read_fndecl_40007_fields r820t_read fndecl 4 40007 NULL
+memblock_isolate_range_fndecl_40008_fields memblock_isolate_range fndecl 3-2 40008 NULL
+dch_empty_fifo_fndecl_40013_fields dch_empty_fifo fndecl 2 40013 NULL
+xfs_iformat_local_fndecl_40019_fields xfs_iformat_local fndecl 4 40019 NULL
+verify_alg_len_net_conf_40020_fields verify_alg_len net_conf 0 40020 NULL
+vmw_mob_calculate_pt_pages_fndecl_40022_fields vmw_mob_calculate_pt_pages fndecl 0-1 40022 NULL
+esp4_get_mtu_fndecl_40024_fields esp4_get_mtu fndecl 0-2 40024 NULL
+lpfc_debugfs_nodelist_data_fndecl_40039_fields lpfc_debugfs_nodelist_data fndecl 0 40039 NULL
+pos_splice_desc_40040_fields pos splice_desc 0 40040 NULL
+data_len_ecryptfs_message_40042_fields data_len ecryptfs_message 0 40042 NULL
+memdiff_vardecl_tridentfb_c_40043_fields memdiff vardecl_tridentfb.c 0 40043 NULL nohasharray
+read_partial_fndecl_40043_fields read_partial fndecl 2 40043 &memdiff_vardecl_tridentfb_c_40043_fields
+bind_cmd_count_vmw_ctx_binding_state_40054_fields bind_cmd_count vmw_ctx_binding_state 0 40054 NULL
+smp_execute_task_fndecl_40062_fields smp_execute_task fndecl 3-5-0 40062 NULL
+region_size_switch_ctx_40069_fields region_size switch_ctx 0 40069 NULL
+max_pq_dma_device_40070_fields max_pq dma_device 0 40070 NULL
+tda18271_write_regs_fndecl_40082_fields tda18271_write_regs fndecl 3 40082 NULL
+wIELength_uwb_rc_cmd_set_ie_40094_fields wIELength uwb_rc_cmd_set_ie 0 40094 NULL
+zap_page_range_fndecl_40097_fields zap_page_range fndecl 3-2 40097 NULL
+vma_needs_reservation_fndecl_40101_fields vma_needs_reservation fndecl 3 40101 NULL
+evm_inode_setattr_fndecl_40105_fields evm_inode_setattr fndecl 0 40105 NULL nohasharray
+lh_blkno_gfs2_log_header_host_40105_fields lh_blkno gfs2_log_header_host 0 40105 &evm_inode_setattr_fndecl_40105_fields
+frag_rx_path_fndecl_40106_fields frag_rx_path fndecl 3 40106 NULL nohasharray
+u_dsize_user32_40106_fields u_dsize user32 0 40106 &frag_rx_path_fndecl_40106_fields
+xfs_pnfs_validate_isize_fndecl_40107_fields xfs_pnfs_validate_isize fndecl 2 40107 NULL
+r8a66597_urb_dequeue_fndecl_40110_fields r8a66597_urb_dequeue fndecl 3 40110 NULL
+alloc_chunk_fndecl_40116_fields alloc_chunk fndecl 1 40116 NULL nohasharray
+drv_data_size_rt2x00_ops_40116_fields drv_data_size rt2x00_ops 0 40116 &alloc_chunk_fndecl_40116_fields
+byte_count_vardecl_initramfs_c_40121_fields byte_count vardecl_initramfs.c 0 40121 NULL nohasharray
+sd_pkt_scan_fndecl_40121_fields sd_pkt_scan fndecl 3 40121 &byte_count_vardecl_initramfs_c_40121_fields
+mspi_apply_qe_mode_quirks_fndecl_40137_fields mspi_apply_qe_mode_quirks fndecl 0-3 40137 NULL nohasharray
+num_jumbo_rxd_netxen_adapter_40137_fields num_jumbo_rxd netxen_adapter 0 40137 &mspi_apply_qe_mode_quirks_fndecl_40137_fields
+off_fuse_notify_inval_inode_out_40142_fields off fuse_notify_inval_inode_out 0 40142 NULL
+ftdi_elan_edset_single_fndecl_40157_fields ftdi_elan_edset_single fndecl 0 40157 NULL
+xfs_ialloc_get_rec_fndecl_40163_fields xfs_ialloc_get_rec fndecl 2 40163 NULL
+sh_size_elf64_shdr_40164_fields sh_size elf64_shdr 0 40164 NULL
+pge_ctl_drm_psb_private_40167_fields pge_ctl drm_psb_private 0 40167 NULL
+dev_stripes_btrfs_raid_attr_40170_fields dev_stripes btrfs_raid_attr 0 40170 NULL
+bluecard_write_fndecl_40179_fields bluecard_write fndecl 0-4 40179 NULL
+of_get_nand_ecc_strength_fndecl_40180_fields of_get_nand_ecc_strength fndecl 0 40180 NULL
+status_boom_rx_desc_40185_fields status boom_rx_desc 0 40185 NULL
+reshape_progress_r5conf_40192_fields reshape_progress r5conf 0 40192 NULL
+peb_size_ubi_device_40195_fields peb_size ubi_device 0 40195 NULL
+__jfs_setxattr_fndecl_40196_fields __jfs_setxattr fndecl 5 40196 NULL nohasharray
+dma_contiguous_reserve_area_fndecl_40196_fields dma_contiguous_reserve_area fndecl 1-2-3 40196 &__jfs_setxattr_fndecl_40196_fields
+vga_video_num_lines_vardecl_vgacon_c_40199_fields vga_video_num_lines vardecl_vgacon.c 0 40199 NULL
+pvr2_ctrl_get_min_fndecl_40204_fields pvr2_ctrl_get_min fndecl 0 40204 NULL
+dvb_dvr_ioctl_fndecl_40205_fields dvb_dvr_ioctl fndecl 2 40205 NULL
+num_amgms_mlx4_caps_40207_fields num_amgms mlx4_caps 0 40207 NULL
+ipwireless_tty_received_fndecl_40209_fields ipwireless_tty_received fndecl 3 40209 NULL
+len_p80211ioctl_req_40220_fields len p80211ioctl_req 0 40220 NULL
+bochs_bo_create_fndecl_40223_fields bochs_bo_create fndecl 2 40223 NULL
+find_gmch_fndecl_40235_fields find_gmch fndecl 1 40235 NULL
+ndr_size_nd_region_40243_fields ndr_size nd_region 0 40243 NULL
+lola_init_stream_fndecl_40245_fields lola_init_stream fndecl 3 40245 NULL
+mmap_file_operations_40250_fields mmap file_operations 0 40250 NULL nohasharray
+layoutupdate_len_nfs4_layoutcommit_args_40250_fields layoutupdate_len nfs4_layoutcommit_args 0 40250 &mmap_file_operations_40250_fields
+max_sectors_queue_limits_40252_fields max_sectors queue_limits 0 40252 NULL
+ucNumOfPowerModeEntries__ATOM_POWERPLAY_INFO_40261_fields ucNumOfPowerModeEntries _ATOM_POWERPLAY_INFO 0 40261 NULL
+stop_discovery_fndecl_40262_fields stop_discovery fndecl 4 40262 NULL
+slba_nvme_user_io_40271_fields slba nvme_user_io 0 40271 NULL
+es_len_extent_status_40276_fields es_len extent_status 0 40276 NULL
+mask___kfifo_40288_fields mask __kfifo 0 40288 NULL
+tcpnv_cong_avoid_fndecl_40297_fields tcpnv_cong_avoid fndecl 3 40297 NULL
+thoff_xt_action_param_40301_fields thoff xt_action_param 0 40301 NULL
+cyttsp_spi_xfer_fndecl_40307_fields cyttsp_spi_xfer fndecl 6 40307 NULL
+gfs2_free_meta_fndecl_40312_fields gfs2_free_meta fndecl 2 40312 NULL
+max_scaled_width_bttv_crop_40325_fields max_scaled_width bttv_crop 0 40325 NULL
+dm_rh_get_region_key_fndecl_40342_fields dm_rh_get_region_key fndecl 0 40342 NULL
+__ext4_ext_dirty_fndecl_40343_fields __ext4_ext_dirty fndecl 0 40343 NULL nohasharray
+minimum_acpi_resource_memory32_40343_fields minimum acpi_resource_memory32 0 40343 &__ext4_ext_dirty_fndecl_40343_fields
+free_ubifs_lpt_lprops_40346_fields free ubifs_lpt_lprops 0 40346 NULL
+default_llseek_fndecl_40353_fields default_llseek fndecl 2 40353 NULL
+pgbase_pnfs_device_40355_fields pgbase pnfs_device 0 40355 NULL
+reg_list_format_size_bytes_rlc_firmware_header_v2_0_40357_fields reg_list_format_size_bytes rlc_firmware_header_v2_0 0 40357 NULL
+cblock_dm_cache_migration_40361_fields cblock dm_cache_migration 0 40361 NULL
+cfpkt_setlen_fndecl_40364_fields cfpkt_setlen fndecl 2 40364 NULL nohasharray
+max_wrs_rds_ib_device_40364_fields max_wrs rds_ib_device 0 40364 &cfpkt_setlen_fndecl_40364_fields
+pages_per_wr_bio_scrub_wr_ctx_40374_fields pages_per_wr_bio scrub_wr_ctx 0 40374 NULL
+align_kmem_cache_40377_fields align kmem_cache 0 40377 NULL
+cfg0_size_pcie_port_40380_fields cfg0_size pcie_port 0 40380 NULL
+ilm_len_mt76_fw_header_40389_fields ilm_len mt76_fw_header 0 40389 NULL
+alloc_test_extent_buffer_fndecl_40392_fields alloc_test_extent_buffer fndecl 2-3 40392 NULL nohasharray
+px_raw_event_fndecl_40392_fields px_raw_event fndecl 4 40392 &alloc_test_extent_buffer_fndecl_40392_fields
+file_secno_bplus_leaf_node_40394_fields file_secno bplus_leaf_node 0 40394 NULL nohasharray
+sb_root_hpfs_sb_info_40394_fields sb_root hpfs_sb_info 0 40394 &file_secno_bplus_leaf_node_40394_fields
+snd_ak4113_external_rate_fndecl_40404_fields snd_ak4113_external_rate fndecl 0 40404 NULL nohasharray
+max_scaled_height_bttv_crop_40404_fields max_scaled_height bttv_crop 0 40404 &snd_ak4113_external_rate_fndecl_40404_fields
+arm_clear_user_fndecl_40410_fields arm_clear_user fndecl 0 40410 NULL
+level3cnt_capi_register_params_40411_fields level3cnt capi_register_params 0 40411 NULL
+bulk_out_epnum_usb_cardstate_40412_fields bulk_out_epnum usb_cardstate 0 40412 NULL
+vm_end_vm_area_struct_40413_fields vm_end vm_area_struct 0 40413 NULL nohasharray
+vma_commit_reservation_fndecl_40413_fields vma_commit_reservation fndecl 3 40413 &vm_end_vm_area_struct_40413_fields
+__ioremap_caller_fndecl_40419_fields __ioremap_caller fndecl 2-1 40419 NULL
+buf_size_in_bytes_kfd_ioctl_dbg_wave_control_args_40427_fields buf_size_in_bytes kfd_ioctl_dbg_wave_control_args 0 40427 NULL
+readisac_IsdnCardState_40429_fields readisac IsdnCardState 0 40429 NULL
+error_reserve_ticket_40431_fields error reserve_ticket 0 40431 NULL
+skb_partial_csum_set_fndecl_40436_fields skb_partial_csum_set fndecl 2 40436 NULL
+__i915_error_advance_fndecl_40440_fields __i915_error_advance fndecl 2 40440 NULL
+numdisabled_tun_struct_40442_fields numdisabled tun_struct 0 40442 NULL
+begin_switchdev_vlan_dump_40443_fields begin switchdev_vlan_dump 0 40443 NULL
+gnttab_setup_auto_xlat_frames_fndecl_40455_fields gnttab_setup_auto_xlat_frames fndecl 1 40455 NULL
+curpacksize_snd_usb_endpoint_40462_fields curpacksize snd_usb_endpoint 0 40462 NULL
+nr_i2c_adapter_40466_fields nr i2c_adapter 0 40466 NULL
+memblock_add_node_fndecl_40484_fields memblock_add_node fndecl 1-2 40484 NULL
+eh_depth_ext4_extent_header_40488_fields eh_depth ext4_extent_header 0 40488 NULL
+s_cgoffset_ufs_sb_private_info_40490_fields s_cgoffset ufs_sb_private_info 0 40490 NULL
+tx_max_cdc_ncm_ctx_40493_fields tx_max cdc_ncm_ctx 0 40493 NULL nohasharray
+num_mtts_mlx4_caps_40493_fields num_mtts mlx4_caps 0 40493 &tx_max_cdc_ncm_ctx_40493_fields nohasharray
+length_mtd_oob_buf32_40493_fields length mtd_oob_buf32 0 40493 &num_mtts_mlx4_caps_40493_fields
+len_tx_buf_40498_fields len tx_buf 0 40498 NULL
+header_length_datalink_proto_40501_fields header_length datalink_proto 0 40501 NULL
+size_iscsi_segment_40510_fields size iscsi_segment 0 40510 NULL nohasharray
+start_cnic_id_tbl_40510_fields start cnic_id_tbl 0 40510 &size_iscsi_segment_40510_fields
+max_soc_bytes_ext_40512_fields max soc_bytes_ext 0 40512 NULL
+tcp_slow_start_fndecl_40515_fields tcp_slow_start fndecl 0-2 40515 NULL
+dn_mss_from_pmtu_fndecl_40520_fields dn_mss_from_pmtu fndecl 0-2 40520 NULL
+rx_cmp_len_flags_type_rx_cmp_40525_fields rx_cmp_len_flags_type rx_cmp 0 40525 NULL
+bnx2x_change_num_queues_fndecl_40532_fields bnx2x_change_num_queues fndecl 2 40532 NULL
+rsxx_queue_dma_fndecl_40533_fields rsxx_queue_dma fndecl 0 40533 NULL nohasharray
+smb2_lockv_fndecl_40533_fields smb2_lockv fndecl 6 40533 &rsxx_queue_dma_fndecl_40533_fields
+is_acpi_reserved_fndecl_40540_fields is_acpi_reserved fndecl 2-1 40540 NULL
+truncate_hole_fndecl_40543_fields truncate_hole fndecl 2-3 40543 NULL
+sky2_get_rx_data_size_fndecl_40544_fields sky2_get_rx_data_size fndecl 0 40544 NULL nohasharray
+bnx2x_get_preset_regs_len_fndecl_40544_fields bnx2x_get_preset_regs_len fndecl 0 40544 &sky2_get_rx_data_size_fndecl_40544_fields
+base_start_aac_dev_40550_fields base_start aac_dev 0 40550 NULL nohasharray
+num_ios_vardecl_40550_fields num_ios vardecl 0 40550 &base_start_aac_dev_40550_fields
+read_partial_message_section_fndecl_40551_fields read_partial_message_section fndecl 3 40551 NULL
+xfs_file_iomap_end_delalloc_fndecl_40555_fields xfs_file_iomap_end_delalloc fndecl 4-2 40555 NULL
+maxpacket_isp1362_ep_40564_fields maxpacket isp1362_ep 0 40564 NULL
+ptrace_readdata_fndecl_40567_fields ptrace_readdata fndecl 4-2 40567 NULL
+ucNumStates__ATOM_PPLIB_POWERPLAYTABLE_40568_fields ucNumStates _ATOM_PPLIB_POWERPLAYTABLE 0 40568 NULL
+caif_stream_sendmsg_fndecl_40573_fields caif_stream_sendmsg fndecl 3 40573 NULL
+qp_alloc_queue_fndecl_40575_fields qp_alloc_queue fndecl 1 40575 NULL
+dm_bufio_read_fndecl_40577_fields dm_bufio_read fndecl 2 40577 NULL
+compat_sys_preadv2_fndecl_40579_fields compat_sys_preadv2 fndecl 3 40579 NULL
+hfi1_alloc_devdata_fndecl_40584_fields hfi1_alloc_devdata fndecl 2 40584 NULL
+dram_size_sst_res_info_40602_fields dram_size sst_res_info 0 40602 NULL
+value_len_ext4_xattr_info_40604_fields value_len ext4_xattr_info 0 40604 NULL
+rf_size_rt2x00_ops_40605_fields rf_size rt2x00_ops 0 40605 NULL
+vyres_aty128_crtc_40610_fields vyres aty128_crtc 0 40610 NULL
+page_offset_octeon_skb_page_info_40618_fields page_offset octeon_skb_page_info 0 40618 NULL
+num_queues_qed_dev_eth_info_40624_fields num_queues qed_dev_eth_info 0 40624 NULL nohasharray
+mailbox_start_sst_info_40624_fields mailbox_start sst_info 0 40624 &num_queues_qed_dev_eth_info_40624_fields
+pcpu_get_vm_areas_fndecl_40630_fields pcpu_get_vm_areas fndecl 4 40630 NULL nohasharray
+db_addr_mlx5_ib_create_wq_40630_fields db_addr mlx5_ib_create_wq 0 40630 &pcpu_get_vm_areas_fndecl_40630_fields
+dev_set_alias_fndecl_40631_fields dev_set_alias fndecl 3 40631 NULL
+map_dirent_fndecl_40635_fields map_dirent fndecl 2 40635 NULL
+rotate_buf_a_little_fndecl_40654_fields rotate_buf_a_little fndecl 2 40654 NULL
+rq_rcvsize_rpc_rqst_40660_fields rq_rcvsize rpc_rqst 0 40660 NULL
+number_xt_af_40661_fields number xt_af 0 40661 NULL
+aac_nark_ioremap_fndecl_40672_fields aac_nark_ioremap fndecl 2 40672 NULL
+num_queue_pairs_i40e_virtchnl_vsi_resource_40682_fields num_queue_pairs i40e_virtchnl_vsi_resource 0 40682 NULL
+qed_cxt_get_proto_cid_count_fndecl_40685_fields qed_cxt_get_proto_cid_count fndecl 0 40685 NULL
+ubi_resize_volume_fndecl_40687_fields ubi_resize_volume fndecl 2 40687 NULL nohasharray
+xfs_get_blocks_direct_fndecl_40687_fields xfs_get_blocks_direct fndecl 2 40687 &ubi_resize_volume_fndecl_40687_fields
+aa_simple_write_to_buffer_fndecl_40704_fields aa_simple_write_to_buffer fndecl 3 40704 NULL
+max_znode_sz_ubifs_info_40705_fields max_znode_sz ubifs_info 0 40705 NULL
+ctrl_out_pipe_hfcsusb_40706_fields ctrl_out_pipe hfcsusb 0 40706 NULL
+__x86_set_memory_region_fndecl_40708_fields __x86_set_memory_region fndecl 4 40708 NULL nohasharray
+nTxBlock_vardecl_jfs_txnmgr_c_40708_fields nTxBlock vardecl_jfs_txnmgr.c 0 40708 &__x86_set_memory_region_fndecl_40708_fields
+lfb_linelength_screen_info_40728_fields lfb_linelength screen_info 0 40728 NULL
+cryptlen_aead_request_40734_fields cryptlen aead_request 0 40734 NULL nohasharray
+page_order_ring_buffer_40734_fields page_order ring_buffer 0 40734 &cryptlen_aead_request_40734_fields
+NumberOfLogBlock_ms_lib_ctrl_40736_fields NumberOfLogBlock ms_lib_ctrl 0 40736 NULL
+do_splice_to_fndecl_40737_fields do_splice_to fndecl 0 40737 NULL
+sisfb_getheapstart_fndecl_40740_fields sisfb_getheapstart fndecl 0 40740 NULL nohasharray
+intel_gtt_mappable_entries_fndecl_40740_fields intel_gtt_mappable_entries fndecl 0 40740 &sisfb_getheapstart_fndecl_40740_fields
+IELength_wlan_bssid_ex_40743_fields IELength wlan_bssid_ex 0 40743 NULL
+smsc47b397_find_fndecl_40748_fields smsc47b397_find fndecl 0 40748 NULL
+ctrl_macb_dma_desc_40750_fields ctrl macb_dma_desc 0 40750 NULL
+read_reg_isac_hw_40755_fields read_reg isac_hw 0 40755 NULL
+snd_usb_endpoint_set_params_fndecl_40756_fields snd_usb_endpoint_set_params fndecl 3-4 40756 NULL
+vfs_iter_write_fndecl_40761_fields vfs_iter_write fndecl 0 40761 NULL
+total_xfer_length_ScsiReqBlk_40768_fields total_xfer_length ScsiReqBlk 0 40768 NULL
+pdu_write_fndecl_40774_fields pdu_write fndecl 3 40774 NULL
+private_data_len_rdma_conn_param_40796_fields private_data_len rdma_conn_param 0 40796 NULL
+check_frame_fndecl_40798_fields check_frame fndecl 0 40798 NULL nohasharray
+ext4_dio_get_block_fndecl_40798_fields ext4_dio_get_block fndecl 2 40798 &check_frame_fndecl_40798_fields nohasharray
+ext4_multi_mount_protect_fndecl_40798_fields ext4_multi_mount_protect fndecl 2 40798 &ext4_dio_get_block_fndecl_40798_fields
+multi_write_idx_wmi_40801_fields multi_write_idx wmi 0 40801 NULL nohasharray
+cmd_len_request_40801_fields cmd_len request 0 40801 &multi_write_idx_wmi_40801_fields
+data_offset_raid_set_40802_fields data_offset raid_set 0 40802 NULL
+sz_m1_mlx5_wq_ll_40805_fields sz_m1 mlx5_wq_ll 0 40805 NULL
+ceph_osdc_readpages_fndecl_40814_fields ceph_osdc_readpages fndecl 0 40814 NULL nohasharray
+sysctl_wmem_max_vardecl_40814_fields sysctl_wmem_max vardecl 0 40814 &ceph_osdc_readpages_fndecl_40814_fields
+dma_pad_mask_request_queue_40816_fields dma_pad_mask request_queue 0 40816 NULL
+INFTL_findfreeblock_fndecl_40819_fields INFTL_findfreeblock fndecl 0 40819 NULL
+isku_sysfs_write_fndecl_40820_fields isku_sysfs_write fndecl 5 40820 NULL
+l2_fhdr_ip_xsum_l2_fhdr_40843_fields l2_fhdr_ip_xsum l2_fhdr 0 40843 NULL
+newblocks_xfs_growfs_data_40847_fields newblocks xfs_growfs_data 0 40847 NULL
+extended_capabilities_len_wiphy_40861_fields extended_capabilities_len wiphy 0 40861 NULL
+ext2_splice_branch_fndecl_40864_fields ext2_splice_branch fndecl 5 40864 NULL
+iraw_loop_fndecl_40865_fields iraw_loop fndecl 0-1 40865 NULL
+nvram_llseek_fndecl_40869_fields nvram_llseek fndecl 2 40869 NULL
+reply_queue_count_MPT3SAS_ADAPTER_40870_fields reply_queue_count MPT3SAS_ADAPTER 0 40870 NULL
+sector_count_partition_40874_fields sector_count partition 0 40874 NULL
+config_len_mic_device_desc_40877_fields config_len mic_device_desc 0 40877 NULL
+osst_set_options_fndecl_40884_fields osst_set_options fndecl 2 40884 NULL nohasharray
+min_agbno_xfs_alloc_arg_40884_fields min_agbno xfs_alloc_arg 0 40884 &osst_set_options_fndecl_40884_fields
+tcf_csum_ipv4_tcp_fndecl_40889_fields tcf_csum_ipv4_tcp fndecl 3 40889 NULL
+size_drm_i915_gem_mmap_40890_fields size drm_i915_gem_mmap 0 40890 NULL
+pci_add_dynid_fndecl_40893_fields pci_add_dynid fndecl 3-8 40893 NULL
+ath6kl_fwlog_block_read_fndecl_40895_fields ath6kl_fwlog_block_read fndecl 3 40895 NULL
+dst_len_akcipher_request_40899_fields dst_len akcipher_request 0 40899 NULL
+uart_write_fndecl_40916_fields uart_write fndecl 3 40916 NULL
+build_verbs_tx_desc_fndecl_40917_fields build_verbs_tx_desc fndecl 3 40917 NULL
+msix_count_vmd_dev_40924_fields msix_count vmd_dev 0 40924 NULL
+vmw_cmdbuf_send_device_command_fndecl_40925_fields vmw_cmdbuf_send_device_command fndecl 3 40925 NULL
+__clone_and_map_data_bio_fndecl_40928_fields __clone_and_map_data_bio fndecl 3-0 40928 NULL nohasharray
+ea_put_fndecl_40928_fields ea_put fndecl 4 40928 &__clone_and_map_data_bio_fndecl_40928_fields nohasharray
+platform_mmio_vardecl_platform_pci_c_40928_fields platform_mmio vardecl_platform-pci.c 0 40928 &ea_put_fndecl_40928_fields
+opcount_xfs_fsop_attrmulti_handlereq_40929_fields opcount xfs_fsop_attrmulti_handlereq 0 40929 NULL
+scsiback_do_resp_with_sense_fndecl_40934_fields scsiback_do_resp_with_sense fndecl 3 40934 NULL
+fuse_send_write_fndecl_40936_fields fuse_send_write fndecl 0-4 40936 NULL
+ecryptfs_filldir_fndecl_40939_fields ecryptfs_filldir fndecl 3 40939 NULL nohasharray
+nr_touch_shapes_f11_2d_sensor_queries_40939_fields nr_touch_shapes f11_2d_sensor_queries 0 40939 &ecryptfs_filldir_fndecl_40939_fields
+len_set_config_param_40942_fields len set_config_param 0 40942 NULL
+s_log_groups_per_flex_ext4_sb_info_40945_fields s_log_groups_per_flex ext4_sb_info 0 40945 NULL
+srq_count_qed_cxt_mngr_40961_fields srq_count qed_cxt_mngr 0 40961 NULL
+ext4_fill_fiemap_extents_fndecl_40966_fields ext4_fill_fiemap_extents fndecl 2-3 40966 NULL
+bottom_qxl_urect_40968_fields bottom qxl_urect 0 40968 NULL
+arena_read_bytes_fndecl_40973_fields arena_read_bytes fndecl 0 40973 NULL
+a_text_exec_40977_fields a_text exec 0 40977 NULL
+compat_sys_recvfrom_fndecl_40978_fields compat_sys_recvfrom fndecl 3 40978 NULL
+read_iter_file_operations_40980_fields read_iter file_operations 0 40980 NULL
+blk_mq_init_tags_fndecl_40986_fields blk_mq_init_tags fndecl 2 40986 NULL
+hwdep_write_fndecl_40987_fields hwdep_write fndecl 3 40987 NULL
+ecryptfs_send_miscdev_fndecl_40995_fields ecryptfs_send_miscdev fndecl 2 40995 NULL
+ath6kl_target_config_wlan_params_fndecl_41017_fields ath6kl_target_config_wlan_params fndecl 2 41017 NULL nohasharray
+proc_projid_map_write_fndecl_41017_fields proc_projid_map_write fndecl 3 41017 &ath6kl_target_config_wlan_params_fndecl_41017_fields
+swapdev_block_fndecl_41020_fields swapdev_block fndecl 0 41020 NULL nohasharray
+xfs_add_to_ioend_fndecl_41020_fields xfs_add_to_ioend fndecl 3 41020 &swapdev_block_fndecl_41020_fields
+store_mfn_start_info_41034_fields store_mfn start_info 0 41034 NULL
+index_radix_tree_iter_41036_fields index radix_tree_iter 0 41036 NULL
+altera_set_dr_pre_fndecl_41037_fields altera_set_dr_pre fndecl 2 41037 NULL
+ext4_ext_put_gap_in_cache_fndecl_41040_fields ext4_ext_put_gap_in_cache fndecl 2-3 41040 NULL
+fofs_extent_info_41041_fields fofs extent_info 0 41041 NULL
+d0_vring_rx_mac_41042_fields d0 vring_rx_mac 0 41042 NULL
+ieee802154_hdr_pull_fndecl_41051_fields ieee802154_hdr_pull fndecl 0 41051 NULL
+ci_hdrc_add_device_fndecl_41055_fields ci_hdrc_add_device fndecl 3 41055 NULL
+resp_len_bnx2fc_mp_req_41057_fields resp_len bnx2fc_mp_req 0 41057 NULL
+bits_per_word_spi_transfer_41063_fields bits_per_word spi_transfer 0 41063 NULL nohasharray
+st21nfca_hci_dm_update_aid_fndecl_41063_fields st21nfca_hci_dm_update_aid fndecl 3 41063 &bits_per_word_spi_transfer_41063_fields
+eager_buffer_size_vardecl_init_c_41068_fields eager_buffer_size vardecl_init.c 0 41068 NULL
+vdc_mem_size_vml_par_41069_fields vdc_mem_size vml_par 0 41069 NULL
+shtc1_update_values_fndecl_41080_fields shtc1_update_values fndecl 4 41080 NULL
+zl10039_write_fndecl_41082_fields zl10039_write fndecl 4 41082 NULL
+wdt87xx_get_feature_fndecl_41089_fields wdt87xx_get_feature fndecl 3 41089 NULL
+pskb_put_fndecl_41096_fields pskb_put fndecl 3 41096 NULL
+nr_gpio_sc16is7xx_devtype_41097_fields nr_gpio sc16is7xx_devtype 0 41097 NULL
+scrub_chunk_fndecl_41105_fields scrub_chunk fndecl 3 41105 NULL
+res_ver_val_pvr2_hdw_41107_fields res_ver_val pvr2_hdw 0 41107 NULL
+physical_start_stripe_41108_fields physical_start stripe 0 41108 NULL
+xfs_imap_lookup_fndecl_41113_fields xfs_imap_lookup fndecl 4-3 41113 NULL
+in_iovs_fuse_ioctl_out_41117_fields in_iovs fuse_ioctl_out 0 41117 NULL
+nvmf_dev_write_fndecl_41118_fields nvmf_dev_write fndecl 3 41118 NULL
+ubifs_wbuf_write_nolock_fndecl_41121_fields ubifs_wbuf_write_nolock fndecl 3 41121 NULL
+datalen_brcmf_event_msg_41123_fields datalen brcmf_event_msg 0 41123 NULL
+__memblock_free_late_fndecl_41130_fields __memblock_free_late fndecl 2 41130 NULL
+data_out_pipe_uas_dev_info_41134_fields data_out_pipe uas_dev_info 0 41134 NULL
+qcaspi_read_burst_fndecl_41137_fields qcaspi_read_burst fndecl 3 41137 NULL
+hidp_process_report_fndecl_41140_fields hidp_process_report fndecl 4 41140 NULL
+ieee80211_cs_headroom_fndecl_41144_fields ieee80211_cs_headroom fndecl 0 41144 NULL
+rx_drvinfo_size_rtl_stats_41161_fields rx_drvinfo_size rtl_stats 0 41161 NULL
+__blk_recalc_rq_segments_fndecl_41164_fields __blk_recalc_rq_segments fndecl 0 41164 NULL
+major_stm_device_41166_fields major stm_device 0 41166 NULL
+get_blocks_target_backend_ops_41168_fields get_blocks target_backend_ops 0 41168 NULL
+size_brnf_frag_data_41177_fields size brnf_frag_data 0 41177 NULL
+start_flakey_c_41178_fields start flakey_c 0 41178 NULL
+lro_wqe_sz_mlx5e_params_41180_fields lro_wqe_sz mlx5e_params 0 41180 NULL
+gfn_guest_walker64_41182_fields gfn guest_walker64 0 41182 NULL
+index_vardecl_via82xx_c_41183_fields index vardecl_via82xx.c 0 41183 NULL
+numqueues_macvlan_dev_41212_fields numqueues macvlan_dev 0 41212 NULL
+p9_client_read_fndecl_41223_fields p9_client_read fndecl 0 41223 NULL
+enic_change_mtu_fndecl_41227_fields enic_change_mtu fndecl 2 41227 NULL nohasharray
+iscsi_first_burst_len_dev_db_entry_41227_fields iscsi_first_burst_len dev_db_entry 0 41227 &enic_change_mtu_fndecl_41227_fields
+private_data_len_nes_qp_41230_fields private_data_len nes_qp 0 41230 NULL
+len_driver_data_41237_fields len driver_data 0 41237 NULL
+ses_send_diag_fndecl_41244_fields ses_send_diag fndecl 4 41244 NULL
+croph_val_pvr2_hdw_41253_fields croph_val pvr2_hdw 0 41253 NULL
+get_res_add_align_fndecl_41257_fields get_res_add_align fndecl 0 41257 NULL
+qlen_sk_buff_head_41259_fields qlen sk_buff_head 0 41259 NULL nohasharray
+diva_os_alloc_message_buffer_fndecl_41259_fields diva_os_alloc_message_buffer fndecl 1 41259 &qlen_sk_buff_head_41259_fields
+do_erase_fndecl_41261_fields do_erase fndecl 4-2 41261 NULL
+lm8323_read_fndecl_41264_fields lm8323_read fndecl 4 41264 NULL
+blkdev_issue_zeroout_fndecl_41272_fields blkdev_issue_zeroout fndecl 3-0-2 41272 NULL
+rbd_obj_read_sync_fndecl_41273_fields rbd_obj_read_sync fndecl 4-3 41273 NULL
+__btrfs_prealloc_file_range_fndecl_41278_fields __btrfs_prealloc_file_range fndecl 3-4 41278 NULL
+num_reg_defaults_raw_regmap_41282_fields num_reg_defaults_raw regmap 0 41282 NULL
+centre_horizontally_fndecl_41284_fields centre_horizontally fndecl 2 41284 NULL nohasharray
+vxfs_getblk_fndecl_41284_fields vxfs_getblk fndecl 2 41284 &centre_horizontally_fndecl_41284_fields
+dy_fb_fillrect_41289_fields dy fb_fillrect 0 41289 NULL nohasharray
+tcp_write_xmit_fndecl_41289_fields tcp_write_xmit fndecl 2 41289 &dy_fb_fillrect_41289_fields
+src_len_kpp_request_41307_fields src_len kpp_request 0 41307 NULL
+register_vlan_device_fndecl_41310_fields register_vlan_device fndecl 2 41310 NULL
+cma_declare_contiguous_fndecl_41316_fields cma_declare_contiguous fndecl 4-1-3 41316 NULL nohasharray
+block_start_extent_map_41316_fields block_start extent_map 0 41316 &cma_declare_contiguous_fndecl_41316_fields
+pc_len_s_pcon_41324_fields pc_len s_pcon 0 41324 NULL
+max_fcoe_exchanges_cnic_dev_41335_fields max_fcoe_exchanges cnic_dev 0 41335 NULL
+last_alloc_physical_block_ext2_block_alloc_info_41336_fields last_alloc_physical_block ext2_block_alloc_info 0 41336 NULL
+key_len_wmi_vdev_install_key_arg_41347_fields key_len wmi_vdev_install_key_arg 0 41347 NULL
+size_snd_info_entry_41350_fields size snd_info_entry 0 41350 NULL nohasharray
+ocfs2_read_xattr_block_fndecl_41350_fields ocfs2_read_xattr_block fndecl 0-2 41350 &size_snd_info_entry_41350_fields nohasharray
+pool_create_fndecl_41350_fields pool_create fndecl 3 41350 &ocfs2_read_xattr_block_fndecl_41350_fields
+num_eq_entries_hba_parameters_41369_fields num_eq_entries hba_parameters 0 41369 NULL
+wrsent_cyberjack_private_41371_fields wrsent cyberjack_private 0 41371 NULL
+do_device_access_fndecl_41373_fields do_device_access fndecl 2-3-0 41373 NULL
+mremap_to_fndecl_41376_fields mremap_to fndecl 3-4-1-2 41376 NULL nohasharray
+sectors_per_block_era_41376_fields sectors_per_block era 0 41376 &mremap_to_fndecl_41376_fields
+update_headroom_fndecl_41386_fields update_headroom fndecl 2 41386 NULL
+atomic_write_len_kernfs_ops_41387_fields atomic_write_len kernfs_ops 0 41387 NULL nohasharray
+wsize_nfs_server_41387_fields wsize nfs_server 0 41387 &atomic_write_len_kernfs_ops_41387_fields
+fat32_root_cluster_fat_bios_param_block_41399_fields fat32_root_cluster fat_bios_param_block 0 41399 NULL
+i2400m_msg_to_dev_fndecl_41409_fields i2400m_msg_to_dev fndecl 3 41409 NULL
+num_channels_fndecl_41411_fields num_channels fndecl 0-1 41411 NULL
+addr_nvme_keyed_sgl_desc_41437_fields addr nvme_keyed_sgl_desc 0 41437 NULL
+l1_size_vardecl_acpi_extlog_c_41440_fields l1_size vardecl_acpi_extlog.c 0 41440 NULL
+vram_remap_vardecl_vesafb_c_41441_fields vram_remap vardecl_vesafb.c 0 41441 NULL
+onenand_write_oob_nolock_fndecl_41451_fields onenand_write_oob_nolock fndecl 2 41451 NULL
+rf_blkno_ocfs2_refcount_tree_41452_fields rf_blkno ocfs2_refcount_tree 0 41452 NULL
+dm_wmfw_adsp1_alg_hdr_41454_fields dm wmfw_adsp1_alg_hdr 0 41454 NULL
+s_inodes_per_block_ext4_sb_info_41457_fields s_inodes_per_block ext4_sb_info 0 41457 NULL nohasharray
+mem_lseek_fndecl_41457_fields mem_lseek fndecl 2 41457 &s_inodes_per_block_ext4_sb_info_41457_fields
+cxgbi_ddp_reserve_fndecl_41468_fields cxgbi_ddp_reserve fndecl 4 41468 NULL nohasharray
+xfs_rmap_free_extent_fndecl_41468_fields xfs_rmap_free_extent fndecl 4-3-5 41468 &cxgbi_ddp_reserve_fndecl_41468_fields
+sd_qc_per_block_gfs2_sbd_41469_fields sd_qc_per_block gfs2_sbd 0 41469 NULL nohasharray
+pageshift_alauda_media_info_41469_fields pageshift alauda_media_info 0 41469 &sd_qc_per_block_gfs2_sbd_41469_fields
+video_offset_sis_video_info_41491_fields video_offset sis_video_info 0 41491 NULL
+lpddr_info_query_fndecl_41492_fields lpddr_info_query fndecl 0 41492 NULL
+dir_entries_fat_floppy_defaults_41499_fields dir_entries fat_floppy_defaults 0 41499 NULL
+irda_param_insert_fndecl_41502_fields irda_param_insert fndecl 0 41502 NULL
+__vmemmap_alloc_block_buf_fndecl_41506_fields __vmemmap_alloc_block_buf fndecl 1 41506 NULL
+b_fifo_size_hfcSX_hw_41512_fields b_fifo_size hfcSX_hw 0 41512 NULL
+dccp_setsockopt_service_fndecl_41515_fields dccp_setsockopt_service fndecl 4 41515 NULL
+vpi_atm_vcc_41519_fields vpi atm_vcc 0 41519 NULL
+nfc_hci_execute_cmd_async_fndecl_41521_fields nfc_hci_execute_cmd_async fndecl 5 41521 NULL
+lv_niovecs_xfs_log_vec_41525_fields lv_niovecs xfs_log_vec 0 41525 NULL
+i40iw_cm_build_mpa_frame_fndecl_41530_fields i40iw_cm_build_mpa_frame fndecl 0 41530 NULL nohasharray
+max_targets_orc_host_41530_fields max_targets orc_host 0 41530 &i40iw_cm_build_mpa_frame_fndecl_41530_fields
+pci_vpd_find_tag_fndecl_41534_fields pci_vpd_find_tag fndecl 2 41534 NULL
+sv_xdrsize_svc_serv_41544_fields sv_xdrsize svc_serv 0 41544 NULL
+velocity_change_mtu_fndecl_41548_fields velocity_change_mtu fndecl 2 41548 NULL
+ntargets_aoedev_41550_fields ntargets aoedev 0 41550 NULL
+sb_blocklog_xfs_sb_41568_fields sb_blocklog xfs_sb 0 41568 NULL
+__alloc_bootmem_nopanic_fndecl_41574_fields __alloc_bootmem_nopanic fndecl 2-3 41574 NULL
+mtd_get_device_size_fndecl_41579_fields mtd_get_device_size fndecl 0 41579 NULL
+FirstBurstLength_iscsi_sess_ops_41581_fields FirstBurstLength iscsi_sess_ops 0 41581 NULL
+rx_buffersize_b43legacy_dmaring_41583_fields rx_buffersize b43legacy_dmaring 0 41583 NULL
+fuse_write_end_fndecl_41587_fields fuse_write_end fndecl 5-3 41587 NULL
+len_on_first_bd_eth_fast_path_rx_reg_cqe_41602_fields len_on_first_bd eth_fast_path_rx_reg_cqe 0 41602 NULL
+vmw_gb_shader_init_fndecl_41607_fields vmw_gb_shader_init fndecl 3 41607 NULL
+vmalloc_to_pfn_fndecl_41614_fields vmalloc_to_pfn fndecl 0 41614 NULL
+hba_queue_depth_MPT3SAS_ADAPTER_41617_fields hba_queue_depth MPT3SAS_ADAPTER 0 41617 NULL
+size_data_platform_device_info_41619_fields size_data platform_device_info 0 41619 NULL
+dev_major_cuse_init_out_41635_fields dev_major cuse_init_out 0 41635 NULL
+dm_bm_prefetch_fndecl_41636_fields dm_bm_prefetch fndecl 2 41636 NULL
+rx_buffer_len_e1000_adapter_41647_fields rx_buffer_len e1000_adapter 0 41647 NULL
+usb_alloc_coherent_fndecl_41655_fields usb_alloc_coherent fndecl 2 41655 NULL
+data_length_bnx2i_reject_msg_41661_fields data_length bnx2i_reject_msg 0 41661 NULL
+selnl_msglen_fndecl_41672_fields selnl_msglen fndecl 0 41672 NULL
+qib_create_ctxtdata_fndecl_41674_fields qib_create_ctxtdata fndecl 2 41674 NULL
+vram_start_vmw_private_41679_fields vram_start vmw_private 0 41679 NULL
+encrypted_filename_size_ecryptfs_filename_41686_fields encrypted_filename_size ecryptfs_filename 0 41686 NULL nohasharray
+firstUnit_INFTLPartition_41686_fields firstUnit INFTLPartition 0 41686 &encrypted_filename_size_ecryptfs_filename_41686_fields
+ath_rx_edma_init_fndecl_41688_fields ath_rx_edma_init fndecl 2 41688 NULL
+mem_zatm_dev_41696_fields mem zatm_dev 0 41696 NULL
+zoran_v4l2_calc_bufsize_fndecl_41703_fields zoran_v4l2_calc_bufsize fndecl 0 41703 NULL
+bfs_move_blocks_fndecl_41706_fields bfs_move_blocks fndecl 2-4 41706 NULL
+ax25_recvmsg_fndecl_41714_fields ax25_recvmsg fndecl 3 41714 NULL
+l_curr_block_xlog_41718_fields l_curr_block xlog 0 41718 NULL
+hlen_ip_tunnel_41720_fields hlen ip_tunnel 0 41720 NULL
+width_tw68_dev_41726_fields width tw68_dev 0 41726 NULL
+sb_sectlog_xfs_sb_41740_fields sb_sectlog xfs_sb 0 41740 NULL
+npages_sdma_mmu_node_41743_fields npages sdma_mmu_node 0 41743 NULL
+cxgb3i_max_connect_vardecl_cxgb3i_c_41744_fields cxgb3i_max_connect vardecl_cxgb3i.c 0 41744 NULL
+val_xfs_sysctl_val_41747_fields val xfs_sysctl_val 0 41747 NULL
+iic_tpm_read_fndecl_41748_fields iic_tpm_read fndecl 3 41748 NULL
+intel_fb_align_height_fndecl_41750_fields intel_fb_align_height fndecl 0-2 41750 NULL
+bm_key_affs_bm_info_41751_fields bm_key affs_bm_info 0 41751 NULL
+encode_filename3_fndecl_41752_fields encode_filename3 fndecl 3 41752 NULL
+insert_dent_fndecl_41753_fields insert_dent fndecl 3-4 41753 NULL
+i_metasize_romfs_inode_info_41756_fields i_metasize romfs_inode_info 0 41756 NULL
+bnx2fc_process_l2_frame_compl_fndecl_41763_fields bnx2fc_process_l2_frame_compl fndecl 3 41763 NULL nohasharray
+size_port_buffer_41763_fields size port_buffer 0 41763 &bnx2fc_process_l2_frame_compl_fndecl_41763_fields
+bbt_erase_shift_nand_chip_41764_fields bbt_erase_shift nand_chip 0 41764 NULL nohasharray
+len_cbuf_41764_fields len cbuf 0 41764 &bbt_erase_shift_nand_chip_41764_fields
+__alloc_bootmem_node_high_fndecl_41767_fields __alloc_bootmem_node_high fndecl 3-4 41767 NULL
+swsusp_resume_block_vardecl_41771_fields swsusp_resume_block vardecl 0 41771 NULL
+ocfs2_truncate_cluster_pages_fndecl_41773_fields ocfs2_truncate_cluster_pages fndecl 2-3 41773 NULL
+ath9k_multi_regread_fndecl_41779_fields ath9k_multi_regread fndecl 4 41779 NULL
+alloc_dummy_extent_buffer_fndecl_41781_fields alloc_dummy_extent_buffer fndecl 2-3 41781 NULL nohasharray
+pg_vec_len_packet_ring_buffer_41781_fields pg_vec_len packet_ring_buffer 0 41781 &alloc_dummy_extent_buffer_fndecl_41781_fields
+scif_get_pages_fndecl_41783_fields scif_get_pages fndecl 3 41783 NULL
+numtx_velocity_opt_41785_fields numtx velocity_opt 0 41785 NULL
+num_bytes_drm_dp_remote_i2c_write_41786_fields num_bytes drm_dp_remote_i2c_write 0 41786 NULL
+max_msg_length_mei_client_properties_41791_fields max_msg_length mei_client_properties 0 41791 NULL nohasharray
+make_idx_node_fndecl_41791_fields make_idx_node fndecl 6-5 41791 &max_msg_length_mei_client_properties_41791_fields
+generic_ocp_write_fndecl_41792_fields generic_ocp_write fndecl 4 41792 NULL
+rx_pkt_length_rxpd_41805_fields rx_pkt_length rxpd 0 41805 NULL
+alloc_ksz_desc_info_41806_fields alloc ksz_desc_info 0 41806 NULL
+udf_get_pblock_fndecl_41813_fields udf_get_pblock fndecl 0-4-2 41813 NULL nohasharray
+T9_reportid_min_mxt_data_41813_fields T9_reportid_min mxt_data 0 41813 &udf_get_pblock_fndecl_41813_fields
+sisusb_num_columns_sisusb_usb_data_41814_fields sisusb_num_columns sisusb_usb_data 0 41814 NULL
+nports_cxgb4_lld_info_41815_fields nports cxgb4_lld_info 0 41815 NULL
+vmw_cmdbuf_alloc_space_fndecl_41823_fields vmw_cmdbuf_alloc_space fndecl 3 41823 NULL
+n_ssids_wmi_start_scan_arg_41826_fields n_ssids wmi_start_scan_arg 0 41826 NULL
+fcs_del_mlx4_en_rx_ring_41830_fields fcs_del mlx4_en_rx_ring 0 41830 NULL
+convert_initialized_extent_fndecl_41833_fields convert_initialized_extent fndecl 0-5 41833 NULL
+wdt87xx_get_string_fndecl_41835_fields wdt87xx_get_string fndecl 4 41835 NULL
+root_btrfs_super_block_41846_fields root btrfs_super_block 0 41846 NULL nohasharray
+i2c_bus_write_fndecl_41846_fields i2c_bus_write fndecl 7-5 41846 &root_btrfs_super_block_41846_fields
+al_tr_number_drbd_device_41847_fields al_tr_number drbd_device 0 41847 NULL
+ar5523_cmd_write_fndecl_41852_fields ar5523_cmd_write fndecl 4 41852 NULL nohasharray
+free_bootmem_node_fndecl_41852_fields free_bootmem_node fndecl 3-2 41852 &ar5523_cmd_write_fndecl_41852_fields
+compatsize_xt_target_41854_fields compatsize xt_target 0 41854 NULL nohasharray
+tx_headroom_nfc_dev_41854_fields tx_headroom nfc_dev 0 41854 &compatsize_xt_target_41854_fields
+max_header_size_smb_version_values_41855_fields max_header_size smb_version_values 0 41855 NULL
+dm_add_exception_fndecl_41858_fields dm_add_exception fndecl 2-3 41858 NULL
+nla_reserve_nohdr_fndecl_41860_fields nla_reserve_nohdr fndecl 2 41860 NULL
+ssb_bus_register_fndecl_41868_fields ssb_bus_register fndecl 3 41868 NULL nohasharray
+i2c_smbus_xfer_emulated_fndecl_41868_fields i2c_smbus_xfer_emulated fndecl 0 41868 &ssb_bus_register_fndecl_41868_fields
+snd_rme96_capture_getrate_fndecl_41874_fields snd_rme96_capture_getrate fndecl 0 41874 NULL
+md_size_sect_drbd_md_41886_fields md_size_sect drbd_md 0 41886 NULL
+rcvidx_fritz_bcs_41889_fields rcvidx fritz_bcs 0 41889 NULL
+qib_rcvhdrcnt_vardecl_qib_iba7322_c_41890_fields qib_rcvhdrcnt vardecl_qib_iba7322.c 0 41890 NULL
+RequestFrameSize__MSG_IOC_FACTS_REPLY_41895_fields RequestFrameSize _MSG_IOC_FACTS_REPLY 0 41895 NULL
+mem_unit_sysinfo_41901_fields mem_unit sysinfo 0 41901 NULL
+bLength_hid_descriptor_41905_fields bLength hid_descriptor 0 41905 NULL
+length_zoran_sync_41909_fields length zoran_sync 0 41909 NULL
+raw_decoder_line_size_vbi_info_41920_fields raw_decoder_line_size vbi_info 0 41920 NULL
+ext4_xattr_security_set_fndecl_41924_fields ext4_xattr_security_set fndecl 6 41924 NULL nohasharray
+wil_pmc_llseek_fndecl_41924_fields wil_pmc_llseek fndecl 2 41924 &ext4_xattr_security_set_fndecl_41924_fields nohasharray
+num_descriptors_wmi_p2p_noa_info_41924_fields num_descriptors wmi_p2p_noa_info 0 41924 &wil_pmc_llseek_fndecl_41924_fields
+regmap_encx24j600_sfr_read_fndecl_41930_fields regmap_encx24j600_sfr_read fndecl 4 41930 NULL
+ss_nblocks_nilfs_segment_summary_41935_fields ss_nblocks nilfs_segment_summary 0 41935 NULL
+n_sel_arg_struct_41940_fields n sel_arg_struct 0 41940 NULL
+pg_error_nfs_pageio_descriptor_41948_fields pg_error nfs_pageio_descriptor 0 41948 NULL
+rmmio_size_cirrus_device_41950_fields rmmio_size cirrus_device 0 41950 NULL nohasharray
+iwlagn_tx_agg_start_fndecl_41950_fields iwlagn_tx_agg_start fndecl 4 41950 &rmmio_size_cirrus_device_41950_fields
+i915_gem_object_ggtt_pin_fndecl_41959_fields i915_gem_object_ggtt_pin fndecl 4 41959 NULL nohasharray
+kmem_zalloc_greedy_fndecl_41959_fields kmem_zalloc_greedy fndecl 3-2 41959 &i915_gem_object_ggtt_pin_fndecl_41959_fields
+ide_init_sg_cmd_fndecl_41962_fields ide_init_sg_cmd fndecl 2 41962 NULL
+relay_open_fndecl_41964_fields relay_open fndecl 4-3 41964 NULL nohasharray
+ccp_reverse_get_dm_area_fndecl_41964_fields ccp_reverse_get_dm_area fndecl 3 41964 &relay_open_fndecl_41964_fields nohasharray
+connector_dcb_output_41964_fields connector dcb_output 0 41964 &ccp_reverse_get_dm_area_fndecl_41964_fields
+init_send_wqe_fndecl_41966_fields init_send_wqe fndecl 4 41966 NULL nohasharray
+length_ccp_dm_workarea_41966_fields length ccp_dm_workarea 0 41966 &init_send_wqe_fndecl_41966_fields
+width_fb_copyarea_41973_fields width fb_copyarea 0 41973 NULL
+hsync_ast_vbios_enhtable_41977_fields hsync ast_vbios_enhtable 0 41977 NULL
+i40iw_get_pble_fndecl_41985_fields i40iw_get_pble fndecl 4 41985 NULL
+__send_control_msg_fndecl_41986_fields __send_control_msg fndecl 2 41986 NULL
+va_end_vmap_area_41988_fields va_end vmap_area 0 41988 NULL
+total_byte_count_els_sts_entry_24xx_41999_fields total_byte_count els_sts_entry_24xx 0 41999 NULL
+pci_add_new_bus_fndecl_42015_fields pci_add_new_bus fndecl 3 42015 NULL
+kovaplus_sysfs_write_fndecl_42016_fields kovaplus_sysfs_write fndecl 6 42016 NULL
+memblock_mark_nomap_fndecl_42021_fields memblock_mark_nomap fndecl 2-1 42021 NULL
+__ieee80211_start_rx_ba_session_fndecl_42023_fields __ieee80211_start_rx_ba_session fndecl 6 42023 NULL
+seq_ports_snd_emu10k1_synth_arg_42026_fields seq_ports snd_emu10k1_synth_arg 0 42026 NULL
+do_mem_probe_fndecl_42028_fields do_mem_probe fndecl 3-2 42028 NULL
+ctrl_frame_len_brcmf_sdio_42037_fields ctrl_frame_len brcmf_sdio 0 42037 NULL
+reiserfs_new_inode_fndecl_42039_fields reiserfs_new_inode fndecl 5 42039 NULL
+rx_hr_cfv_info_42044_fields rx_hr cfv_info 0 42044 NULL
+num_tid_range_42045_fields num tid_range 0 42045 NULL nohasharray
+num_tx_qp_i40e_hw_capabilities_42045_fields num_tx_qp i40e_hw_capabilities 0 42045 &num_tid_range_42045_fields
+PortSCSIID__MSG_PORT_FACTS_REPLY_42048_fields PortSCSIID _MSG_PORT_FACTS_REPLY 0 42048 NULL
+kvm_init_fndecl_42057_fields kvm_init fndecl 2-3 42057 NULL nohasharray
+fm_tx_get_tune_cap_val_fndecl_42057_fields fm_tx_get_tune_cap_val fndecl 0 42057 &kvm_init_fndecl_42057_fields
+fat_add_new_entries_fndecl_42062_fields fat_add_new_entries fndecl 0 42062 NULL
+blk_limits_io_min_fndecl_42065_fields blk_limits_io_min fndecl 2 42065 NULL nohasharray
+b_flags_ivtv_buffer_42065_fields b_flags ivtv_buffer 0 42065 &blk_limits_io_min_fndecl_42065_fields
+frag_size_ipv6_pinfo_42073_fields frag_size ipv6_pinfo 0 42073 NULL
+nci_hci_send_event_fndecl_42074_fields nci_hci_send_event fndecl 5 42074 NULL
+ieee80211_scan_results_fndecl_42078_fields ieee80211_scan_results fndecl 0 42078 NULL
+mlx4_ib_rereg_user_mr_fndecl_42079_fields mlx4_ib_rereg_user_mr fndecl 3-4 42079 NULL nohasharray
+ath6kl_wmi_set_rx_frame_format_cmd_fndecl_42079_fields ath6kl_wmi_set_rx_frame_format_cmd fndecl 2 42079 &mlx4_ib_rereg_user_mr_fndecl_42079_fields
+i2c_bus_vardecl_i2c_kempld_c_42082_fields i2c_bus vardecl_i2c-kempld.c 0 42082 NULL
+raw_issuer_size_x509_certificate_42091_fields raw_issuer_size x509_certificate 0 42091 NULL
+outsize_cros_ec_command_42095_fields outsize cros_ec_command 0 42095 NULL
+telem_punit_ssram_size_intel_pmc_ipc_dev_42096_fields telem_punit_ssram_size intel_pmc_ipc_dev 0 42096 NULL
+gtt_size_radeon_mc_42102_fields gtt_size radeon_mc 0 42102 NULL nohasharray
+proc_pid_attr_write_fndecl_42102_fields proc_pid_attr_write fndecl 3 42102 &gtt_size_radeon_mc_42102_fields
+value_xen_hvm_param_42103_fields value xen_hvm_param 0 42103 NULL
+image_offset_sd_42111_fields image_offset sd 0 42111 NULL
+efs_bmap_fndecl_42112_fields efs_bmap fndecl 0-2 42112 NULL
+jbd2_journal_init_dev_fndecl_42115_fields jbd2_journal_init_dev fndecl 3 42115 NULL
+ceph_tcp_sendmsg_fndecl_42116_fields ceph_tcp_sendmsg fndecl 0-4-3 42116 NULL
+divas_write_fndecl_42126_fields divas_write fndecl 3 42126 NULL
+smb2_sync_write_fndecl_42139_fields smb2_sync_write fndecl 6 42139 NULL
+uvc_alloc_urb_buffers_fndecl_42145_fields uvc_alloc_urb_buffers fndecl 0-3-2 42145 NULL
+ath6kl_wmi_set_lpreamble_cmd_fndecl_42153_fields ath6kl_wmi_set_lpreamble_cmd fndecl 2 42153 NULL
+remote_addr_rds_atomic_args_42154_fields remote_addr rds_atomic_args 0 42154 NULL
+cnic_support_bnx2x_42156_fields cnic_support bnx2x 0 42156 NULL nohasharray
+channels_audioformat_42156_fields channels audioformat 0 42156 &cnic_support_bnx2x_42156_fields
+ext4_end_io_dio_fndecl_42159_fields ext4_end_io_dio fndecl 2-3 42159 NULL
+status_de4x5_desc_42161_fields status de4x5_desc 0 42161 NULL
+height_em28xx_v4l2_42166_fields height em28xx_v4l2 0 42166 NULL
+s_root_block_reiserfs_super_block_v1_42167_fields s_root_block reiserfs_super_block_v1 0 42167 NULL
+copy_from_iter_nocache_fndecl_42168_fields copy_from_iter_nocache fndecl 2 42168 NULL
+next_bucket_prio_set_42171_fields next_bucket prio_set 0 42171 NULL
+start_file_extent_cluster_42173_fields start file_extent_cluster 0 42173 NULL
+block_size_msb_data_42179_fields block_size msb_data 0 42179 NULL
+stv0367_writeregs_fndecl_42183_fields stv0367_writeregs fndecl 4 42183 NULL
+s2255_fillbuff_fndecl_42189_fields s2255_fillbuff fndecl 3 42189 NULL
+mc_handle_present_pte_fndecl_42199_fields mc_handle_present_pte fndecl 2 42199 NULL nohasharray
+afs_send_simple_reply_fndecl_42199_fields afs_send_simple_reply fndecl 3 42199 &mc_handle_present_pte_fndecl_42199_fields
+get_sset_count_phy_driver_42200_fields get_sset_count phy_driver 0 42200 NULL
+udl_alloc_urb_list_fndecl_42203_fields udl_alloc_urb_list fndecl 3 42203 NULL
+skb_push_fndecl_42213_fields skb_push fndecl 2 42213 NULL
+scan_padding_bytes_fndecl_42218_fields scan_padding_bytes fndecl 0 42218 NULL
+set_bredr_fndecl_42228_fields set_bredr fndecl 4 42228 NULL nohasharray
+diva_xdi_write_fndecl_42228_fields diva_xdi_write fndecl 4 42228 &set_bredr_fndecl_42228_fields
+dwMaxVideoFrameBufferSize_uvc_frame_42230_fields dwMaxVideoFrameBufferSize uvc_frame 0 42230 NULL
+nr_map_efi_memory_map_42232_fields nr_map efi_memory_map 0 42232 NULL
+max_data_size_irda_sock_42236_fields max_data_size irda_sock 0 42236 NULL nohasharray
+chunksize_mdp_superblock_1_42236_fields chunksize mdp_superblock_1 0 42236 &max_data_size_irda_sock_42236_fields
+scrollback_phys_max_vardecl_fbcon_c_42241_fields scrollback_phys_max vardecl_fbcon.c 0 42241 NULL
+buf_write_ptr_comedi_async_42247_fields buf_write_ptr comedi_async 0 42247 NULL
+num_params_snd_soc_dai_link_42251_fields num_params snd_soc_dai_link 0 42251 NULL
+if_sdio_read_scratch_fndecl_42279_fields if_sdio_read_scratch fndecl 0 42279 NULL
+rx_pending_ethtool_ringparam_42280_fields rx_pending ethtool_ringparam 0 42280 NULL nohasharray
+cfg_sriov_nr_virtfn_lpfc_hba_42280_fields cfg_sriov_nr_virtfn lpfc_hba 0 42280 &rx_pending_ethtool_ringparam_42280_fields
+reiserfs_xattr_set_handle_fndecl_42289_fields reiserfs_xattr_set_handle fndecl 5 42289 NULL
+batadv_tp_send_msg_fndecl_42290_fields batadv_tp_send_msg fndecl 5 42290 NULL
+ubi_more_leb_change_data_fndecl_42301_fields ubi_more_leb_change_data fndecl 4 42301 NULL
+level_cgroup_42308_fields level cgroup 0 42308 NULL nohasharray
+iwch_reg_user_mr_fndecl_42308_fields iwch_reg_user_mr fndecl 2-3 42308 &level_cgroup_42308_fields nohasharray
+dcache_dir_lseek_fndecl_42308_fields dcache_dir_lseek fndecl 2 42308 &iwch_reg_user_mr_fndecl_42308_fields
+num_rcv_contexts_hfi1_devdata_42317_fields num_rcv_contexts hfi1_devdata 0 42317 NULL nohasharray
+ocfs2_xattr_security_set_fndecl_42317_fields ocfs2_xattr_security_set fndecl 6 42317 &num_rcv_contexts_hfi1_devdata_42317_fields
+pg_test_nfs_pageio_ops_42320_fields pg_test nfs_pageio_ops 0 42320 NULL nohasharray
+dbg_leb_write_fndecl_42320_fields dbg_leb_write fndecl 5-4 42320 &pg_test_nfs_pageio_ops_42320_fields
+gsi_base_mp_ioapic_gsi_42330_fields gsi_base mp_ioapic_gsi 0 42330 NULL
+mlx4_ib_alloc_cq_buf_fndecl_42345_fields mlx4_ib_alloc_cq_buf fndecl 3 42345 NULL
+nftl_readblock_fndecl_42358_fields nftl_readblock fndecl 2 42358 NULL
+minor_mei_device_42366_fields minor mei_device 0 42366 NULL
+inbufBitCount_bunzip_data_42367_fields inbufBitCount bunzip_data 0 42367 NULL
+symbol_build_supp_rates_fndecl_42369_fields symbol_build_supp_rates fndecl 0 42369 NULL
+acc_len_rcv_sli3_42370_fields acc_len rcv_sli3 0 42370 NULL
+ext4_ext_get_access_fndecl_42377_fields ext4_ext_get_access fndecl 0 42377 NULL
+placement_offset_bnx2x_agg_info_42380_fields placement_offset bnx2x_agg_info 0 42380 NULL
+num_srqs_qed_rdma_pf_params_42382_fields num_srqs qed_rdma_pf_params 0 42382 NULL
+__spi_validate_fndecl_42385_fields __spi_validate fndecl 0 42385 NULL
+remote_payload_max_nfc_digital_dev_42391_fields remote_payload_max nfc_digital_dev 0 42391 NULL
+module_alloc_fndecl_42397_fields module_alloc fndecl 1 42397 NULL
+xen_blkif_max_queues_vardecl_xen_blkfront_c_42404_fields xen_blkif_max_queues vardecl_xen-blkfront.c 0 42404 NULL
+length_mei_msg_hdr_42413_fields length mei_msg_hdr 0 42413 NULL
+defrag_lookup_extent_fndecl_42423_fields defrag_lookup_extent fndecl 2 42423 NULL
+s_sys_blocksize_omfs_sb_info_42439_fields s_sys_blocksize omfs_sb_info 0 42439 NULL
+buffer_chain_size_fndecl_42450_fields buffer_chain_size fndecl 0 42450 NULL nohasharray
+max_srqs_mthca_dev_lim_42450_fields max_srqs mthca_dev_lim 0 42450 &buffer_chain_size_fndecl_42450_fields
+rx_size_uart_8250_dma_42452_fields rx_size uart_8250_dma 0 42452 NULL
+inquiry_cache_dump_fndecl_42455_fields inquiry_cache_dump fndecl 0 42455 NULL
+s_cssize_ufs_sb_private_info_42456_fields s_cssize ufs_sb_private_info 0 42456 NULL
+num_srqs_mlx4_caps_42462_fields num_srqs mlx4_caps 0 42462 NULL
+rxq_max_tg3_42464_fields rxq_max tg3 0 42464 NULL
+trusted_set_fndecl_42473_fields trusted_set fndecl 6 42473 NULL
+num_adc_nids_hda_gen_spec_42481_fields num_adc_nids hda_gen_spec 0 42481 NULL
+snd_vxpocket_new_fndecl_42483_fields snd_vxpocket_new fndecl 2 42483 NULL
+block_shift_befs_sb_info_42485_fields block_shift befs_sb_info 0 42485 NULL
+tot_len_pkt_gl_42487_fields tot_len pkt_gl 0 42487 NULL
+keylength_gss_krb5_enctype_42493_fields keylength gss_krb5_enctype 0 42493 NULL
+bnxt_rx_skb_fndecl_42495_fields bnxt_rx_skb fndecl 7 42495 NULL
+hsi_alloc_msg_fndecl_42496_fields hsi_alloc_msg fndecl 1 42496 NULL
+DataTransferLength_DAC960_V1_UserCommand_42502_fields DataTransferLength DAC960_V1_UserCommand 0 42502 NULL
+ath6kl_sdio_read_write_sync_fndecl_42504_fields ath6kl_sdio_read_write_sync fndecl 4 42504 NULL nohasharray
+rcvhdrqtailaddr_phys_hfi1_ctxtdata_42504_fields rcvhdrqtailaddr_phys hfi1_ctxtdata 0 42504 &ath6kl_sdio_read_write_sync_fndecl_42504_fields
+fs_start_efs_sb_info_42506_fields fs_start efs_sb_info 0 42506 NULL
+write_adapter_mem_fndecl_42509_fields write_adapter_mem fndecl 3 42509 NULL nohasharray
+st21nfca_hci_dm_load_fndecl_42509_fields st21nfca_hci_dm_load fndecl 3 42509 &write_adapter_mem_fndecl_42509_fields
+dec_cluster_info_page_fndecl_42521_fields dec_cluster_info_page fndecl 3 42521 NULL
+xfs_rtmodify_summary_fndecl_42522_fields xfs_rtmodify_summary fndecl 4-3-0 42522 NULL
+cn_netlink_send_mult_fndecl_42523_fields cn_netlink_send_mult fndecl 2 42523 NULL
+maxframe_size_fc_rport_priv_42527_fields maxframe_size fc_rport_priv 0 42527 NULL
+size_rx_desc_42538_fields size rx_desc 0 42538 NULL
+num_reg_channel_bounds_42546_fields num reg_channel_bounds 0 42546 NULL
+xfs_dir_cilookup_result_fndecl_42547_fields xfs_dir_cilookup_result fndecl 3 42547 NULL
+mr_page_size_srp_device_42550_fields mr_page_size srp_device 0 42550 NULL
+xdr_padsize_fndecl_42554_fields xdr_padsize fndecl 0-1 42554 NULL
+s_block_base_sysv_sb_info_42564_fields s_block_base sysv_sb_info 0 42564 NULL nohasharray
+do_write_orph_node_fndecl_42564_fields do_write_orph_node fndecl 2 42564 &s_block_base_sysv_sb_info_42564_fields
+num_regulators_sec_platform_data_42570_fields num_regulators sec_platform_data 0 42570 NULL
+mwifiex_send_addba_fndecl_42572_fields mwifiex_send_addba fndecl 2 42572 NULL
+restart_rc_fndecl_42573_fields restart_rc fndecl 2 42573 NULL
+ufs_read_cylinder_fndecl_42577_fields ufs_read_cylinder fndecl 2 42577 NULL
+max_target_id_mvumi_hba_42578_fields max_target_id mvumi_hba 0 42578 NULL
+irq_create_of_mapping_fndecl_42583_fields irq_create_of_mapping fndecl 0 42583 NULL
+tipc_send_packet_fndecl_42584_fields tipc_send_packet fndecl 3 42584 NULL
+sisusbcon_clear_fndecl_42586_fields sisusbcon_clear fndecl 5-3-4 42586 NULL
+map_region_fndecl_42587_fields map_region fndecl 1 42587 NULL
+lock_extent_range_fndecl_42589_fields lock_extent_range fndecl 2-3 42589 NULL
+bcm3510_readbytes_fndecl_42592_fields bcm3510_readbytes fndecl 4 42592 NULL
+name_len_jffs2_xattr_datum_42593_fields name_len jffs2_xattr_datum 0 42593 NULL
+offset_dmi_ipmi_data_42594_fields offset dmi_ipmi_data 0 42594 NULL nohasharray
+cdc_ncm_set_dgram_size_fndecl_42594_fields cdc_ncm_set_dgram_size fndecl 2 42594 &offset_dmi_ipmi_data_42594_fields
+bsize_nfs_parsed_mount_data_42598_fields bsize nfs_parsed_mount_data 0 42598 NULL
+wrap_bcma_device_42599_fields wrap bcma_device 0 42599 NULL
+maxSenseBytes_mpt_ioctl_command_42600_fields maxSenseBytes mpt_ioctl_command 0 42600 NULL
+nilfs_alloc_seg_bio_fndecl_42604_fields nilfs_alloc_seg_bio fndecl 2-3 42604 NULL
+n_channels_wmi_start_scan_arg_42610_fields n_channels wmi_start_scan_arg 0 42610 NULL
+size_ck804xrom_window_42617_fields size ck804xrom_window 0 42617 NULL
+HFP_kyrofb_info_42618_fields HFP kyrofb_info 0 42618 NULL
+vmw_kms_sou_do_surface_dirty_fndecl_42620_fields vmw_kms_sou_do_surface_dirty fndecl 8 42620 NULL
+opt_len_genevehdr_42621_fields opt_len genevehdr 0 42621 NULL
+nfs42_proc_deallocate_fndecl_42622_fields nfs42_proc_deallocate fndecl 2-3 42622 NULL
+ir_lirc_transmit_ir_fndecl_42624_fields ir_lirc_transmit_ir fndecl 3 42624 NULL
+length_bplus_leaf_node_42626_fields length bplus_leaf_node 0 42626 NULL
+num_regulators_mc13xxx_regulator_priv_42627_fields num_regulators mc13xxx_regulator_priv 0 42627 NULL
+dm_set_device_limits_fndecl_42632_fields dm_set_device_limits fndecl 3 42632 NULL
+lbs_cmd_async_fndecl_42634_fields lbs_cmd_async fndecl 4 42634 NULL
+valid_ide_tape_obj_42635_fields valid ide_tape_obj 0 42635 NULL
+find_rsb_dir_fndecl_42636_fields find_rsb_dir fndecl 3 42636 NULL
+snd_emu10k1_create_fndecl_42637_fields snd_emu10k1_create fndecl 5 42637 NULL nohasharray
+n_algs_wmfw_adsp2_id_hdr_42637_fields n_algs wmfw_adsp2_id_hdr 0 42637 &snd_emu10k1_create_fndecl_42637_fields
+len_ceph_string_42640_fields len ceph_string 0 42640 NULL
+nr_io_queues_nvmf_ctrl_options_42644_fields nr_io_queues nvmf_ctrl_options 0 42644 NULL
+brcmf_sdio_download_nvram_fndecl_42648_fields brcmf_sdio_download_nvram fndecl 3 42648 NULL
+srp_map_sg_fmr_fndecl_42658_fields srp_map_sg_fmr fndecl 0 42658 NULL
+jffs2_scan_dirty_space_fndecl_42666_fields jffs2_scan_dirty_space fndecl 3 42666 NULL
+vOver_plus_panel_info_42670_fields vOver_plus panel_info 0 42670 NULL
+ieee80211_send_eosp_nullfunc_fndecl_42671_fields ieee80211_send_eosp_nullfunc fndecl 2 42671 NULL
+max_probe_length_iwl_ucode_capabilities_42674_fields max_probe_length iwl_ucode_capabilities 0 42674 NULL
+max_inline_rxe_sq_42676_fields max_inline rxe_sq 0 42676 NULL
+mxm_shadow_rom_fetch_fndecl_42681_fields mxm_shadow_rom_fetch fndecl 4 42681 NULL
+n_sections_pefile_context_42684_fields n_sections pefile_context 0 42684 NULL nohasharray
+ext4_trim_extent_fndecl_42684_fields ext4_trim_extent fndecl 3-4-2-0 42684 &n_sections_pefile_context_42684_fields
+ccp_update_sg_workarea_fndecl_42688_fields ccp_update_sg_workarea fndecl 2 42688 NULL
+BufferLength_respQ_e_42691_fields BufferLength respQ_e 0 42691 NULL
+nvme_submit_user_cmd_fndecl_42701_fields nvme_submit_user_cmd fndecl 4 42701 NULL nohasharray
+vm_map_ram_fndecl_42701_fields vm_map_ram fndecl 2 42701 &nvme_submit_user_cmd_fndecl_42701_fields
+nvme_rdma_create_qp_fndecl_42709_fields nvme_rdma_create_qp fndecl 2 42709 NULL
+len_nfs4_layoutdriver_data_42714_fields len nfs4_layoutdriver_data 0 42714 NULL nohasharray
+reordering_tcp_sock_42714_fields reordering tcp_sock 0 42714 &len_nfs4_layoutdriver_data_42714_fields
+start_sect_hd_struct_42718_fields start_sect hd_struct 0 42718 NULL
+rcvtidcnt_qib_devdata_42719_fields rcvtidcnt qib_devdata 0 42719 NULL
+clsb_isar_hw_42720_fields clsb isar_hw 0 42720 NULL
+status_full_rx_done_desc_42726_fields status full_rx_done_desc 0 42726 NULL
+maxbcnt_aoedev_42731_fields maxbcnt aoedev 0 42731 NULL
+single_open_size_fndecl_42736_fields single_open_size fndecl 4 42736 NULL
+nilfs_skip_summary_info_fndecl_42739_fields nilfs_skip_summary_info fndecl 4-5 42739 NULL
+head_hid_debug_list_42742_fields head hid_debug_list 0 42742 NULL
+Ha_tvnorm_42743_fields Ha tvnorm 0 42743 NULL nohasharray
+tcp_adjust_pcount_fndecl_42743_fields tcp_adjust_pcount fndecl 3 42743 &Ha_tvnorm_42743_fields
+mlx5_fc_stats_query_fndecl_42750_fields mlx5_fc_stats_query fndecl 3 42750 NULL
+batadv_interface_rx_fndecl_42754_fields batadv_interface_rx fndecl 3 42754 NULL
+unmap_entire_bt_fndecl_42755_fields unmap_entire_bt fndecl 3 42755 NULL
+tcf_csum_skb_nextlayer_fndecl_42762_fields tcf_csum_skb_nextlayer fndecl 3 42762 NULL
+elems_v4l2_ctrl_42763_fields elems v4l2_ctrl 0 42763 NULL
+maxdev_blogic_adapter_42764_fields maxdev blogic_adapter 0 42764 NULL
+dc_block_number_disk_child_42766_fields dc_block_number disk_child 0 42766 NULL
+cmd_idx_rtsx_ucr_42770_fields cmd_idx rtsx_ucr 0 42770 NULL nohasharray
+ie_len_wmi_start_scan_arg_42770_fields ie_len wmi_start_scan_arg 0 42770 &cmd_idx_rtsx_ucr_42770_fields
+fw_len_mwifiex_fw_image_42772_fields fw_len mwifiex_fw_image 0 42772 NULL
+hsr_get_max_mtu_fndecl_42776_fields hsr_get_max_mtu fndecl 0 42776 NULL
+kmemdup_fndecl_42780_fields kmemdup fndecl 2 42780 NULL
+lov_tgt_size_lov_obd_42782_fields lov_tgt_size lov_obd 0 42782 NULL
+rx_data_length_hso_serial_42783_fields rx_data_length hso_serial 0 42783 NULL
+usbnet_change_mtu_fndecl_42784_fields usbnet_change_mtu fndecl 2 42784 NULL
+offset_fuse_page_desc_42785_fields offset fuse_page_desc 0 42785 NULL
+xdr_encode_word_fndecl_42802_fields xdr_encode_word fndecl 2 42802 NULL
+ext4_quota_write_fndecl_42809_fields ext4_quota_write fndecl 5 42809 NULL nohasharray
+len_il3945_rx_frame_hdr_42809_fields len il3945_rx_frame_hdr 0 42809 &ext4_quota_write_fndecl_42809_fields
+usb_hcd_unlink_urb_fndecl_42819_fields usb_hcd_unlink_urb fndecl 2 42819 NULL
+xfs_rmap_map_fndecl_42821_fields xfs_rmap_map fndecl 0 42821 NULL
+m_agino_log_xfs_mount_42823_fields m_agino_log xfs_mount 0 42823 NULL
+clear_update_marker_fndecl_42827_fields clear_update_marker fndecl 3 42827 NULL
+ezusb_program_bytes_fndecl_42828_fields ezusb_program_bytes fndecl 4 42828 NULL
+rrpc_init_fndecl_42834_fields rrpc_init fndecl 3-4 42834 NULL
+dev_addr_fsl_edma_slave_config_42835_fields dev_addr fsl_edma_slave_config 0 42835 NULL
+decompress_compressor_42840_fields decompress compressor 0 42840 NULL
+old_oblock_dm_cache_migration_42847_fields old_oblock dm_cache_migration 0 42847 NULL
+extent_trunc_fndecl_42849_fields extent_trunc fndecl 6-4-5 42849 NULL
+int_in_endpointAddr_usb_yurex_42850_fields int_in_endpointAddr usb_yurex 0 42850 NULL
+count_i40iw_hmc_create_obj_info_42852_fields count i40iw_hmc_create_obj_info 0 42852 NULL
+rdma_addr_size_fndecl_42855_fields rdma_addr_size fndecl 0 42855 NULL
+get_max_headroom_fndecl_42858_fields get_max_headroom fndecl 0 42858 NULL
+ext4_prepare_inline_data_fndecl_42863_fields ext4_prepare_inline_data fndecl 3 42863 NULL nohasharray
+wqe_size_ib_uverbs_post_srq_recv_42863_fields wqe_size ib_uverbs_post_srq_recv 0 42863 &ext4_prepare_inline_data_fndecl_42863_fields
+mmio_start_vmw_private_42869_fields mmio_start vmw_private 0 42869 NULL
+mlxsw_core_skb_transmit_fndecl_42876_fields mlxsw_core_skb_transmit fndecl 0 42876 NULL
+lineevent_read_fndecl_42885_fields lineevent_read fndecl 3 42885 NULL
+pixel_overlap_mipi_config_42900_fields pixel_overlap mipi_config 0 42900 NULL
+uea_idma_write_fndecl_42904_fields uea_idma_write fndecl 3 42904 NULL
+memblock_find_in_range_node_fndecl_42905_fields memblock_find_in_range_node fndecl 0-2-1-3-4 42905 NULL
+name_length_spar_controlvm_parameters_header_42909_fields name_length spar_controlvm_parameters_header 0 42909 NULL
+vd_vblocknr_nilfs_vdesc_42910_fields vd_vblocknr nilfs_vdesc 0 42910 NULL
+rts51x_bulk_transport_fndecl_42911_fields rts51x_bulk_transport fndecl 6 42911 NULL
+xfs_rmap_alloc_extent_fndecl_42916_fields xfs_rmap_alloc_extent fndecl 4-3-5 42916 NULL
+i915_gem_stolen_insert_node_fndecl_42918_fields i915_gem_stolen_insert_node fndecl 3 42918 NULL
+st21nfca_hci_dm_field_generator_fndecl_42926_fields st21nfca_hci_dm_field_generator fndecl 3 42926 NULL
+wMaxInputLength_i2c_hid_desc_42932_fields wMaxInputLength i2c_hid_desc 0 42932 NULL
+max_mad_size_ib_port_immutable_42934_fields max_mad_size ib_port_immutable 0 42934 NULL
+nblocks_nvme_user_io_42935_fields nblocks nvme_user_io 0 42935 NULL
+mc_vram_size_radeon_mc_42937_fields mc_vram_size radeon_mc 0 42937 NULL
+spi_bpw_vardecl_ifx6x60_c_42939_fields spi_bpw vardecl_ifx6x60.c 0 42939 NULL
+txdata_desc_size_vmxnet3_adapter_42942_fields txdata_desc_size vmxnet3_adapter 0 42942 NULL
+ring_size_i915_gem_context_42950_fields ring_size i915_gem_context 0 42950 NULL
+hippi_change_mtu_fndecl_42953_fields hippi_change_mtu fndecl 2 42953 NULL
+brcmf_usb_tx_ctlpkt_fndecl_42958_fields brcmf_usb_tx_ctlpkt fndecl 3 42958 NULL
+gpio_count_async_state_42965_fields gpio_count async_state 0 42965 NULL nohasharray
+udf_get_block_fndecl_42965_fields udf_get_block fndecl 2 42965 &gpio_count_async_state_42965_fields
+__pskb_copy_fclone_fndecl_42969_fields __pskb_copy_fclone fndecl 2 42969 NULL
+periods_max_snd_pcm_hardware_42979_fields periods_max snd_pcm_hardware 0 42979 NULL
+brcmf_sdiod_send_buf_fndecl_42982_fields brcmf_sdiod_send_buf fndecl 3 42982 NULL
+max_pfn_amdgpu_vm_manager_42989_fields max_pfn amdgpu_vm_manager 0 42989 NULL
+len_kvaser_msg_42994_fields len kvaser_msg 0 42994 NULL
+hw_token_fotg210_qh_hw_42995_fields hw_token fotg210_qh_hw 0 42995 NULL
+num_mappings_nd_region_desc_42998_fields num_mappings nd_region_desc 0 42998 NULL
+buf_size_ivtv_stream_43002_fields buf_size ivtv_stream 0 43002 NULL
+header_len_fndecl_43003_fields header_len fndecl 0 43003 NULL
+drm_mm_insert_helper_fndecl_43005_fields drm_mm_insert_helper fndecl 3 43005 NULL
+pkt_size_be_rx_compl_info_43008_fields pkt_size be_rx_compl_info 0 43008 NULL
+mlxsw_pci_resources_query_parse_fndecl_43010_fields mlxsw_pci_resources_query_parse fndecl 2 43010 NULL
+len_i2c_msg_43014_fields len i2c_msg 0 43014 NULL
+ath6kl_wmi_reconnect_cmd_fndecl_43017_fields ath6kl_wmi_reconnect_cmd fndecl 2 43017 NULL
+r5l_log_write_empty_meta_block_fndecl_43018_fields r5l_log_write_empty_meta_block fndecl 2 43018 NULL
+num_cons_qed_iscsi_pf_params_43021_fields num_cons qed_iscsi_pf_params 0 43021 NULL
+PacketLength__MSG_LAN_RECEIVE_POST_REPLY_43028_fields PacketLength _MSG_LAN_RECEIVE_POST_REPLY 0 43028 NULL
+a_bss_exec_43030_fields a_bss exec 0 43030 NULL
+usHActive__ATOM_DTD_FORMAT_43031_fields usHActive _ATOM_DTD_FORMAT 0 43031 NULL nohasharray
+count_ixgbe_ring_43031_fields count ixgbe_ring 0 43031 &usHActive__ATOM_DTD_FORMAT_43031_fields
+pagl_leftrec_xfs_perag_43033_fields pagl_leftrec xfs_perag 0 43033 NULL nohasharray
+hop_count_tb_nhi_43033_fields hop_count tb_nhi 0 43033 &pagl_leftrec_xfs_perag_43033_fields
+channels_max_snd_usb_substream_43034_fields channels_max snd_usb_substream 0 43034 NULL
+qpc_entry_sz_mthca_dev_lim_43040_fields qpc_entry_sz mthca_dev_lim 0 43040 NULL
+copy_page_to_iter_iovec_fndecl_43041_fields copy_page_to_iter_iovec fndecl 3 43041 NULL
+init_chip_wc_pat_fndecl_43043_fields init_chip_wc_pat fndecl 2 43043 NULL
+instance_nvme_ctrl_43045_fields instance nvme_ctrl 0 43045 NULL
+free_bootmem_late_fndecl_43051_fields free_bootmem_late fndecl 2 43051 NULL
+stmmac_change_mtu_fndecl_43052_fields stmmac_change_mtu fndecl 2 43052 NULL
+logical_block_size_queue_limits_43053_fields logical_block_size queue_limits 0 43053 NULL
+s_reserved_gdt_blocks_ext4_super_block_43054_fields s_reserved_gdt_blocks ext4_super_block 0 43054 NULL
+mwifiex_rdeeprom_write_fndecl_43057_fields mwifiex_rdeeprom_write fndecl 3 43057 NULL
+acpi_dev_get_ioresource_fndecl_43062_fields acpi_dev_get_ioresource fndecl 3-2 43062 NULL
+len_ib_ucm_rep_43064_fields len ib_ucm_rep 0 43064 NULL
+len_srp_direct_buf_43066_fields len srp_direct_buf 0 43066 NULL
+fat_fallocate_fndecl_43080_fields fat_fallocate fndecl 4-3 43080 NULL
+raw_skid_size_pkcs7_parse_context_43081_fields raw_skid_size pkcs7_parse_context 0 43081 NULL
+output_buffer_size_vardecl_seq_midi_c_43084_fields output_buffer_size vardecl_seq_midi.c 0 43084 NULL
+bttv_prepare_buffer_fndecl_43088_fields bttv_prepare_buffer fndecl 6-5 43088 NULL
+i2c_wr_max_cx24116_config_43094_fields i2c_wr_max cx24116_config 0 43094 NULL
+_create_message_fndecl_43096_fields _create_message fndecl 2 43096 NULL
+printf_size_mon_reader_text_43097_fields printf_size mon_reader_text 0 43097 NULL
+if_sdio_read_rx_unit_fndecl_43099_fields if_sdio_read_rx_unit fndecl 0 43099 NULL
+sector_badblocks_43102_fields sector badblocks 0 43102 NULL
+cyttsp_i2c_write_block_data_fndecl_43104_fields cyttsp_i2c_write_block_data fndecl 4 43104 NULL
+xlog_recover_add_to_trans_fndecl_43108_fields xlog_recover_add_to_trans fndecl 4 43108 NULL
+__rounddown_pow_of_two_fndecl_43111_fields __rounddown_pow_of_two fndecl 0 43111 NULL
+ore_verify_layout_fndecl_43114_fields ore_verify_layout fndecl 1 43114 NULL nohasharray
+valuelen_hi_extended_attribute_43114_fields valuelen_hi extended_attribute 0 43114 &ore_verify_layout_fndecl_43114_fields nohasharray
+start_f2fs_defragment_43114_fields start f2fs_defragment 0 43114 &valuelen_hi_extended_attribute_43114_fields
+range_max_regmap_range_43116_fields range_max regmap_range 0 43116 NULL
+meta_prod_netrx_pending_operations_43121_fields meta_prod netrx_pending_operations 0 43121 NULL nohasharray
+of_alias_get_id_fndecl_43121_fields of_alias_get_id fndecl 0 43121 &meta_prod_netrx_pending_operations_43121_fields
+prepare_elf64_ram_headers_callback_fndecl_43123_fields prepare_elf64_ram_headers_callback fndecl 1-2 43123 NULL
+output_pool_snd_seq_client_pool_43126_fields output_pool snd_seq_client_pool 0 43126 NULL
+fm10k_change_mtu_fndecl_43135_fields fm10k_change_mtu fndecl 2 43135 NULL
+pcf8563_read_block_data_fndecl_43139_fields pcf8563_read_block_data fndecl 3 43139 NULL
+Size_aac_fibhdr_43144_fields Size aac_fibhdr 0 43144 NULL
+xfs_rtmodify_range_fndecl_43150_fields xfs_rtmodify_range fndecl 3-0 43150 NULL
+bblog_offset_mdp_superblock_1_43154_fields bblog_offset mdp_superblock_1 0 43154 NULL
+__f2fs_setxattr_fndecl_43162_fields __f2fs_setxattr fndecl 5 43162 NULL
+filename_size_ecryptfs_filename_43164_fields filename_size ecryptfs_filename 0 43164 NULL nohasharray
+doc_config_location_vardecl_diskonchip_c_43164_fields doc_config_location vardecl_diskonchip.c 0 43164 &filename_size_ecryptfs_filename_43164_fields
+hpi_read_word_fndecl_43165_fields hpi_read_word fndecl 0 43165 NULL
+xlog_bread_noalign_fndecl_43170_fields xlog_bread_noalign fndecl 2 43170 NULL
+packetizeRx_fndecl_43175_fields packetizeRx fndecl 3 43175 NULL
+unxlate_dev_mem_ptr_fndecl_43184_fields unxlate_dev_mem_ptr fndecl 1 43184 NULL
+length_ib_mac_iocb_rsp_43186_fields length ib_mac_iocb_rsp 0 43186 NULL
+block_end_dm_cell_key_43191_fields block_end dm_cell_key 0 43191 NULL
+rx_data_eaten_rxrpc_call_43202_fields rx_data_eaten rxrpc_call 0 43202 NULL nohasharray
+tidno_ath_atx_tid_43202_fields tidno ath_atx_tid 0 43202 &rx_data_eaten_rxrpc_call_43202_fields
+dm_bufio_release_move_fndecl_43207_fields dm_bufio_release_move fndecl 2 43207 NULL
+device_id_ipmi_device_id_43213_fields device_id ipmi_device_id 0 43213 NULL
+ramdisk_size_setup_header_43217_fields ramdisk_size setup_header 0 43217 NULL
+get_data_block_dio_fndecl_43221_fields get_data_block_dio fndecl 2 43221 NULL
+iwlagn_check_ratid_empty_fndecl_43225_fields iwlagn_check_ratid_empty fndecl 3 43225 NULL
+mic_len_ieee80211_cipher_scheme_43227_fields mic_len ieee80211_cipher_scheme 0 43227 NULL
+actual_size_rfd_43243_fields actual_size rfd 0 43243 NULL
+sb_rextents_xfs_sb_43244_fields sb_rextents xfs_sb 0 43244 NULL
+num_vc_iadev_priv_43250_fields num_vc iadev_priv 0 43250 NULL
+regspacing_si_sm_io_43277_fields regspacing si_sm_io 0 43277 NULL
+tx_modulus_cdc_ncm_ctx_43289_fields tx_modulus cdc_ncm_ctx 0 43289 NULL
+size_oid_t_43292_fields size oid_t 0 43292 NULL
+ip_vs_icmp_xmit_v6_fndecl_43294_fields ip_vs_icmp_xmit_v6 fndecl 4 43294 NULL
+num_flush_nvdimm_43298_fields num_flush nvdimm 0 43298 NULL
+transfer_dma_urb_43305_fields transfer_dma urb 0 43305 NULL
+total_nic_func_qlcnic_hardware_context_43307_fields total_nic_func qlcnic_hardware_context 0 43307 NULL
+rio_request_outb_mbox_fndecl_43309_fields rio_request_outb_mbox fndecl 3 43309 NULL
+add_to_list_fndecl_43311_fields add_to_list fndecl 5-4 43311 NULL
+header_len_gether_43313_fields header_len gether 0 43313 NULL
+smsc9420_rx_handoff_fndecl_43315_fields smsc9420_rx_handoff fndecl 3 43315 NULL
+qat_uclo_map_uof_obj_fndecl_43323_fields qat_uclo_map_uof_obj fndecl 3 43323 NULL
+group_count_ore_layout_43325_fields group_count ore_layout 0 43325 NULL
+lpddr_write_buffers_fndecl_43330_fields lpddr_write_buffers fndecl 3 43330 NULL
+max_packet_bytes_ua101_stream_43333_fields max_packet_bytes ua101_stream 0 43333 NULL
+b_num_l1oip_43336_fields b_num l1oip 0 43336 NULL
+file_size_hpfs_dirent_43338_fields file_size hpfs_dirent 0 43338 NULL
+vactive_videomode_43345_fields vactive videomode 0 43345 NULL
+wake_packet_bufsize_iwl_wowlan_status_data_43348_fields wake_packet_bufsize iwl_wowlan_status_data 0 43348 NULL
+entry_size_xpc_channel_43351_fields entry_size xpc_channel 0 43351 NULL nohasharray
+pktsz_fifo_43351_fields pktsz fifo 0 43351 &entry_size_xpc_channel_43351_fields
+header_len_dst_entry_43355_fields header_len dst_entry 0 43355 NULL nohasharray
+get_module_load_offset_fndecl_43355_fields get_module_load_offset fndecl 0 43355 &header_len_dst_entry_43355_fields
+inftl_write_fndecl_43357_fields inftl_write fndecl 2 43357 NULL
+bulk_out_endpoint_edgeport_serial_43358_fields bulk_out_endpoint edgeport_serial 0 43358 NULL
+queue_size_nvme_rdma_queue_43368_fields queue_size nvme_rdma_queue 0 43368 NULL
+port_count_rocker_43373_fields port_count rocker 0 43373 NULL
+snd_usb_endpoint_next_packet_size_fndecl_43377_fields snd_usb_endpoint_next_packet_size fndecl 0 43377 NULL
+dtcs033_pkt_scan_fndecl_43381_fields dtcs033_pkt_scan fndecl 3 43381 NULL
+tci_Vmxnet3_RxCompDesc_43383_fields tci Vmxnet3_RxCompDesc 0 43383 NULL
+sca_detect_ram_fndecl_43387_fields sca_detect_ram fndecl 0 43387 NULL
+x509_note_signature_fndecl_43388_fields x509_note_signature fndecl 5 43388 NULL
+lpt_spc_bits_ubifs_info_43392_fields lpt_spc_bits ubifs_info 0 43392 NULL
+id_via_isa_bridge_43399_fields id via_isa_bridge 0 43399 NULL
+base_nr_i2c_mux_gpio_platform_data_43400_fields base_nr i2c_mux_gpio_platform_data 0 43400 NULL
+depth_saa7146_format_43402_fields depth saa7146_format 0 43402 NULL
+teql_master_mtu_fndecl_43403_fields teql_master_mtu fndecl 2 43403 NULL
+i2c_readbytes_fndecl_43409_fields i2c_readbytes fndecl 4 43409 NULL
+jffs2_trusted_setxattr_fndecl_43413_fields jffs2_trusted_setxattr fndecl 6 43413 NULL
+gss_wrap_kerberos_v1_fndecl_43417_fields gss_wrap_kerberos_v1 fndecl 2 43417 NULL nohasharray
+packet_alloc_skb_fndecl_43417_fields packet_alloc_skb fndecl 5-4-3 43417 &gss_wrap_kerberos_v1_fndecl_43417_fields
+prism2_send_mgmt_fndecl_43422_fields prism2_send_mgmt fndecl 4 43422 NULL
+status_fealnx_desc_43423_fields status fealnx_desc 0 43423 NULL
+dev_pm_opp_set_supported_hw_fndecl_43425_fields dev_pm_opp_set_supported_hw fndecl 3 43425 NULL
+ath6kl_wmi_set_apsd_bfrd_traf_fndecl_43427_fields ath6kl_wmi_set_apsd_bfrd_traf fndecl 2 43427 NULL
+ath10k_pci_hif_exchange_bmi_msg_fndecl_43429_fields ath10k_pci_hif_exchange_bmi_msg fndecl 3 43429 NULL
+offset_afs_call_43431_fields offset afs_call 0 43431 NULL
+nfs4_proc_set_acl_fndecl_43435_fields nfs4_proc_set_acl fndecl 3 43435 NULL
+XRES_kyrofb_info_43436_fields XRES kyrofb_info 0 43436 NULL
+memblock_alloc_nid_fndecl_43439_fields memblock_alloc_nid fndecl 2 43439 NULL
+ems_pcmcia_add_card_fndecl_43440_fields ems_pcmcia_add_card fndecl 2 43440 NULL
+per_txdl_space_vxge_hw_fifo_attr_43441_fields per_txdl_space vxge_hw_fifo_attr 0 43441 NULL
+len_imgchunk_43445_fields len imgchunk 0 43445 NULL
+max_pkt_tipc_sock_43446_fields max_pkt tipc_sock 0 43446 NULL
+wReportDescLength_i2c_hid_desc_43447_fields wReportDescLength i2c_hid_desc 0 43447 NULL
+vfs_fsync_range_fndecl_43448_fields vfs_fsync_range fndecl 0 43448 NULL
+aper_base_radeon_mc_43460_fields aper_base radeon_mc 0 43460 NULL
+l_start_ocfs2_space_resv_43461_fields l_start ocfs2_space_resv 0 43461 NULL nohasharray
+phys_addr_perf_mw_43461_fields phys_addr perf_mw 0 43461 &l_start_ocfs2_space_resv_43461_fields
+pda_size_fw_info_43468_fields pda_size fw_info 0 43468 NULL nohasharray
+meta_dev_idx_drbd_md_43468_fields meta_dev_idx drbd_md 0 43468 &pda_size_fw_info_43468_fields
+xfrm_count_pfkey_auth_supported_fndecl_43471_fields xfrm_count_pfkey_auth_supported fndecl 0 43471 NULL
+nfs_pgio_rpcsetup_fndecl_43472_fields nfs_pgio_rpcsetup fndecl 2-3 43472 NULL
+max_VF_buses_pci_sriov_43475_fields max_VF_buses pci_sriov 0 43475 NULL
+mmio_base_phys_mb862xxfb_par_43476_fields mmio_base_phys mb862xxfb_par 0 43476 NULL
+cmd_drm_ioctl_desc_43477_fields cmd drm_ioctl_desc 0 43477 NULL nohasharray
+read_pci_config_byte_fndecl_43477_fields read_pci_config_byte fndecl 0 43477 &cmd_drm_ioctl_desc_43477_fields
+total_size_vardecl_mtdram_c_43478_fields total_size vardecl_mtdram.c 0 43478 NULL nohasharray
+length_cpcs_trailer_43478_fields length cpcs_trailer 0 43478 &total_size_vardecl_mtdram_c_43478_fields
+sd_jbsize_gfs2_sbd_43480_fields sd_jbsize gfs2_sbd 0 43480 NULL
+pcm_capture_analog_channels_snd_tscm_spec_43483_fields pcm_capture_analog_channels snd_tscm_spec 0 43483 NULL nohasharray
+sysv_iget_fndecl_43483_fields sysv_iget fndecl 2 43483 &pcm_capture_analog_channels_snd_tscm_spec_43483_fields
+atl1e_change_mtu_fndecl_43485_fields atl1e_change_mtu fndecl 2 43485 NULL
+secondary_bin_count_drm_mga_dma_bootstrap_43491_fields secondary_bin_count drm_mga_dma_bootstrap 0 43491 NULL
+bioset_integrity_create_fndecl_43495_fields bioset_integrity_create fndecl 2 43495 NULL
+ra_meta_pages_fndecl_43496_fields ra_meta_pages fndecl 2-0 43496 NULL
+size_TxFifo_43497_fields size TxFifo 0 43497 NULL
+netlink_recvmsg_fndecl_43499_fields netlink_recvmsg fndecl 3 43499 NULL
+Count_smb_com_write_rsp_43500_fields Count smb_com_write_rsp 0 43500 NULL
+gfs2_log_write_fndecl_43502_fields gfs2_log_write fndecl 4-3 43502 NULL nohasharray
+max_reqs_rpc_xprt_43502_fields max_reqs rpc_xprt 0 43502 &gfs2_log_write_fndecl_43502_fields
+adxl34x_i2c_read_block_fndecl_43504_fields adxl34x_i2c_read_block fndecl 3 43504 NULL nohasharray
+limit_cmdline_vardecl_dma_contiguous_c_43504_fields limit_cmdline vardecl_dma-contiguous.c 0 43504 &adxl34x_i2c_read_block_fndecl_43504_fields
+ext4_ind_map_blocks_fndecl_43505_fields ext4_ind_map_blocks fndecl 0 43505 NULL
+ioremap_wc_fndecl_43508_fields ioremap_wc fndecl 2-1 43508 NULL
+size_compat_ipt_replace_43509_fields size compat_ipt_replace 0 43509 NULL
+size_uvc_control_info_43512_fields size uvc_control_info 0 43512 NULL
+snd_es1968_new_memory_fndecl_43515_fields snd_es1968_new_memory fndecl 2 43515 NULL
+i_lenExtents_udf_inode_info_43517_fields i_lenExtents udf_inode_info 0 43517 NULL
+sb_rextslog_xfs_sb_43520_fields sb_rextslog xfs_sb 0 43520 NULL
+fifo_pool_size_snd_seq_user_client_43523_fields fifo_pool_size snd_seq_user_client 0 43523 NULL
+mei_amthif_read_start_fndecl_43534_fields mei_amthif_read_start fndecl 0 43534 NULL
+points_per_channel_pda_pa_curve_data_43548_fields points_per_channel pda_pa_curve_data 0 43548 NULL
+offset_qcafrm_handle_43553_fields offset qcafrm_handle 0 43553 NULL
+bg_inode_table_lo_ext4_group_desc_43555_fields bg_inode_table_lo ext4_group_desc 0 43555 NULL
+hdrlen_hip_hdr_43556_fields hdrlen hip_hdr 0 43556 NULL
+buffer_size_budget_43564_fields buffer_size budget 0 43564 NULL
+tx_buf_clear_sent_ks959_cb_43565_fields tx_buf_clear_sent ks959_cb 0 43565 NULL
+ib_create_send_mad_fndecl_43569_fields ib_create_send_mad fndecl 6 43569 NULL
+ccp_fill_queue_buf_fndecl_43580_fields ccp_fill_queue_buf fndecl 0 43580 NULL
+xfs_difree_fndecl_43581_fields xfs_difree fndecl 2 43581 NULL
+__br_vlan_set_default_pvid_fndecl_43587_fields __br_vlan_set_default_pvid fndecl 2 43587 NULL
+size_ext4_io_end_43590_fields size ext4_io_end 0 43590 NULL
+page_cnt_i40iw_mr_43591_fields page_cnt i40iw_mr 0 43591 NULL
+recv_data_fndecl_43596_fields recv_data fndecl 3 43596 NULL
+rem_len_hci_rp_read_local_amp_assoc_43602_fields rem_len hci_rp_read_local_amp_assoc 0 43602 NULL nohasharray
+isdn_ppp_ccp_xmit_reset_fndecl_43602_fields isdn_ppp_ccp_xmit_reset fndecl 6 43602 &rem_len_hci_rp_read_local_amp_assoc_43602_fields nohasharray
+mult_req_ide_drive_s_43602_fields mult_req ide_drive_s 0 43602 &isdn_ppp_ccp_xmit_reset_fndecl_43602_fields
+nfsd_vfs_read_fndecl_43608_fields nfsd_vfs_read fndecl 3-5 43608 NULL
+raid5_resize_fndecl_43609_fields raid5_resize fndecl 2 43609 NULL
+minor_usb_serial_port_43611_fields minor usb_serial_port 0 43611 NULL
+phys_ctlmem_fst_card_info_43612_fields phys_ctlmem fst_card_info 0 43612 NULL
+sg_limit_blogic_ext_setup_43615_fields sg_limit blogic_ext_setup 0 43615 NULL nohasharray
+qnx4_block_map_fndecl_43615_fields qnx4_block_map fndecl 0-2 43615 &sg_limit_blogic_ext_setup_43615_fields
+camera_fbmem_size_viafb_dev_43616_fields camera_fbmem_size viafb_dev 0 43616 NULL
+ceph_fill_file_size_fndecl_43619_fields ceph_fill_file_size fndecl 4 43619 NULL
+drm_format_plane_cpp_fndecl_43621_fields drm_format_plane_cpp fndecl 0 43621 NULL
+btusb_recv_isoc_fndecl_43628_fields btusb_recv_isoc fndecl 3 43628 NULL
+count_phm_ppt_v1_clock_voltage_dependency_table_43634_fields count phm_ppt_v1_clock_voltage_dependency_table 0 43634 NULL
+drm_gtf2_k_fndecl_43638_fields drm_gtf2_k fndecl 0 43638 NULL nohasharray
+technisat_usb2_eeprom_lrc_read_fndecl_43638_fields technisat_usb2_eeprom_lrc_read fndecl 4 43638 &drm_gtf2_k_fndecl_43638_fields
+walk_iomem_res_desc_fndecl_43641_fields walk_iomem_res_desc fndecl 4-3 43641 NULL
+info_server_fndecl_43644_fields info_server fndecl 4 43644 NULL
+xfs_setfilesize_trans_alloc_fndecl_43654_fields xfs_setfilesize_trans_alloc fndecl 0 43654 NULL
+name_len_ceph_object_id_43655_fields name_len ceph_object_id 0 43655 NULL
+ibp_queue_depth_kib_peer_43675_fields ibp_queue_depth kib_peer 0 43675 NULL
+gsi_kvm_irq_routing_entry_43676_fields gsi kvm_irq_routing_entry 0 43676 NULL
+header_size_perf_event_43679_fields header_size perf_event 0 43679 NULL
+init_packet_fndecl_43683_fields init_packet fndecl 3 43683 NULL
+data_offset_nfsd4_compound_state_43684_fields data_offset nfsd4_compound_state 0 43684 NULL nohasharray
+data_len_pegasus_43684_fields data_len pegasus 0 43684 &data_offset_nfsd4_compound_state_43684_fields
+__get_meta_page_fndecl_43692_fields __get_meta_page fndecl 2 43692 NULL
+nxt200x_readbytes_fndecl_43693_fields nxt200x_readbytes fndecl 4 43693 NULL
+num_tx_descs_octeon_nic_if_config_43704_fields num_tx_descs octeon_nic_if_config 0 43704 NULL
+rx_buf_len_bcmgenet_priv_43705_fields rx_buf_len bcmgenet_priv 0 43705 NULL
+rtl_tx_agg_start_fndecl_43707_fields rtl_tx_agg_start fndecl 4 43707 NULL
+gtk_icvlen_iwl_mvm_43710_fields gtk_icvlen iwl_mvm 0 43710 NULL
+of_irq_get_fndecl_43712_fields of_irq_get fndecl 0 43712 NULL
+data_block_quadlets_amdtp_stream_43723_fields data_block_quadlets amdtp_stream 0 43723 NULL
+ReplyFrameSize_mpt3sas_facts_43736_fields ReplyFrameSize mpt3sas_facts 0 43736 NULL nohasharray
+kone_send_fndecl_43736_fields kone_send fndecl 4 43736 &ReplyFrameSize_mpt3sas_facts_43736_fields
+used_map_cnt_verifier_env_43747_fields used_map_cnt verifier_env 0 43747 NULL
+sas_host_smp_write_gpio_fndecl_43749_fields sas_host_smp_write_gpio fndecl 0 43749 NULL
+rrpc_update_map_fndecl_43752_fields rrpc_update_map fndecl 2 43752 NULL
+__copy_from_user_ll_nocache_fndecl_43756_fields __copy_from_user_ll_nocache fndecl 0 43756 NULL nohasharray
+data1_sisusb_command_43756_fields data1 sisusb_command 0 43756 &__copy_from_user_ll_nocache_fndecl_43756_fields nohasharray
+len_meta_value_43756_fields len meta_value 0 43756 &data1_sisusb_command_43756_fields
+firstEUN_INFTLrecord_43763_fields firstEUN INFTLrecord 0 43763 NULL
+cached_start_hfsplus_inode_info_43773_fields cached_start hfsplus_inode_info 0 43773 NULL
+clipcount_cap_vivid_dev_43781_fields clipcount_cap vivid_dev 0 43781 NULL
+prepare_packet_fndecl_43783_fields prepare_packet fndecl 0 43783 NULL
+data_pad_ubi_volume_43787_fields data_pad ubi_volume 0 43787 NULL
+smsc47m1_device_add_fndecl_43796_fields smsc47m1_device_add fndecl 1 43796 NULL
+uhci_urb_dequeue_fndecl_43804_fields uhci_urb_dequeue fndecl 3 43804 NULL
+xfs_trans_reserve_fndecl_43809_fields xfs_trans_reserve fndecl 3-0 43809 NULL
+rdes0_rx_desc_43817_fields rdes0 rx_desc 0 43817 NULL
+__vb2_perform_fileio_fndecl_43818_fields __vb2_perform_fileio fndecl 3 43818 NULL
+_save_mc_fndecl_43819_fields _save_mc fndecl 0-3 43819 NULL
+i915_gem_object_create_stolen_fndecl_43837_fields i915_gem_object_create_stolen fndecl 2 43837 NULL
+unlink1_fndecl_43840_fields unlink1 fndecl 2 43840 NULL
+ath6kl_wmi_enable_sched_scan_cmd_fndecl_43841_fields ath6kl_wmi_enable_sched_scan_cmd fndecl 2 43841 NULL
+initrd_start_vardecl_43848_fields initrd_start vardecl 0 43848 NULL
+xen_set_nslabs_fndecl_43849_fields xen_set_nslabs fndecl 0-1 43849 NULL
+wlcore_scan_fndecl_43850_fields wlcore_scan fndecl 4 43850 NULL nohasharray
+wm_adsp_read_data_block_fndecl_43850_fields wm_adsp_read_data_block fndecl 0 43850 &wlcore_scan_fndecl_43850_fields
+first_sector_swap_map_handle_43853_fields first_sector swap_map_handle 0 43853 NULL
+indat_endpoint_keyspan_device_details_43860_fields indat_endpoint keyspan_device_details 0 43860 NULL
+get_sset_count_ethtool_ops_43861_fields get_sset_count ethtool_ops 0 43861 NULL
+nr_channels_dw_dma_platform_data_43863_fields nr_channels dw_dma_platform_data 0 43863 NULL
+s_l2bsize_jfs_superblock_43870_fields s_l2bsize jfs_superblock 0 43870 NULL
+bulk_in_endpointAddr_hdpvr_device_43874_fields bulk_in_endpointAddr hdpvr_device 0 43874 NULL nohasharray
+of_property_read_u32_array_fndecl_43874_fields of_property_read_u32_array fndecl 0 43874 &bulk_in_endpointAddr_hdpvr_device_43874_fields
+iovec_count_sg_io_hdr_43875_fields iovec_count sg_io_hdr 0 43875 NULL
+ts_ctxnum_gru_thread_state_43878_fields ts_ctxnum gru_thread_state 0 43878 NULL
+m_logbsize_xfs_mount_43888_fields m_logbsize xfs_mount 0 43888 NULL
+zap_page_range_single_fndecl_43890_fields zap_page_range_single fndecl 3-2 43890 NULL
+len_libipw_info_element_43892_fields len libipw_info_element 0 43892 NULL
+ocfs2_decrease_refcount_fndecl_43893_fields ocfs2_decrease_refcount fndecl 4-3 43893 NULL
+skb_vlan_push_fndecl_43895_fields skb_vlan_push fndecl 3 43895 NULL nohasharray
+device_id_onenand_chip_43895_fields device_id onenand_chip 0 43895 &skb_vlan_push_fndecl_43895_fields
+xstats_len_gnet_dump_43898_fields xstats_len gnet_dump 0 43898 NULL
+pnp_add_dma_resource_fndecl_43903_fields pnp_add_dma_resource fndecl 2 43903 NULL
+lc_up_len_nfsd4_layoutcommit_43904_fields lc_up_len nfsd4_layoutcommit 0 43904 NULL
+il4965_tx_agg_start_fndecl_43905_fields il4965_tx_agg_start fndecl 4 43905 NULL
+sta_data_size_ieee80211_hw_43910_fields sta_data_size ieee80211_hw 0 43910 NULL
+xres_drm_cmdline_mode_43915_fields xres drm_cmdline_mode 0 43915 NULL
+vcount_snd_emu10k1_fx8010_ctl_43917_fields vcount snd_emu10k1_fx8010_ctl 0 43917 NULL
+in_int_pipe_usbtest_dev_43922_fields in_int_pipe usbtest_dev 0 43922 NULL
+phys_statctrl_base__synclinkmp_info_43923_fields phys_statctrl_base _synclinkmp_info 0 43923 NULL
+rd_length_nfsd4_read_43924_fields rd_length nfsd4_read 0 43924 NULL
+mbind_range_fndecl_43926_fields mbind_range fndecl 3-2 43926 NULL
+max_threads_vardecl_43940_fields max_threads vardecl 0 43940 NULL nohasharray
+queue_pages_pte_range_fndecl_43940_fields queue_pages_pte_range fndecl 2 43940 &max_threads_vardecl_43940_fields
+ubifs_change_one_lp_fndecl_43942_fields ubifs_change_one_lp fndecl 3 43942 NULL
+dce_pvc_count_frad_state_43946_fields dce_pvc_count frad_state 0 43946 NULL
+sddr09_readX_fndecl_43951_fields sddr09_readX fndecl 5 43951 NULL
+ib_send_cm_rtu_fndecl_43953_fields ib_send_cm_rtu fndecl 3 43953 NULL
+size_soundfont_sample_info_43957_fields size soundfont_sample_info 0 43957 NULL
+num_drc_cfgs_wm8904_pdata_43963_fields num_drc_cfgs wm8904_pdata 0 43963 NULL
+rx_ring_count_igb_adapter_43964_fields rx_ring_count igb_adapter 0 43964 NULL
+s_firstdatazone_isofs_sb_info_43968_fields s_firstdatazone isofs_sb_info 0 43968 NULL
+csum_start_virtio_net_hdr_43969_fields csum_start virtio_net_hdr 0 43969 NULL
+value_size_bpf_map_43980_fields value_size bpf_map 0 43980 NULL nohasharray
+s_first_cluster_group_ocfs2_super_block_43980_fields s_first_cluster_group ocfs2_super_block 0 43980 &value_size_bpf_map_43980_fields
+security_policydb_len_fndecl_43981_fields security_policydb_len fndecl 0 43981 NULL
+cur_size_zr364xx_framei_43985_fields cur_size zr364xx_framei 0 43985 NULL
+free_memtype_fndecl_43986_fields free_memtype fndecl 1-2 43986 NULL
+vid_mv88e6xxx_vtu_stu_entry_43991_fields vid mv88e6xxx_vtu_stu_entry 0 43991 NULL
+pvm_determine_end_fndecl_43995_fields pvm_determine_end fndecl 0-3 43995 NULL nohasharray
+nsize_jffs2_raw_dirent_43995_fields nsize jffs2_raw_dirent 0 43995 &pvm_determine_end_fndecl_43995_fields
+copy_templates_fndecl_43996_fields copy_templates fndecl 3 43996 NULL
+snd_pcm_lib_malloc_pages_fndecl_43997_fields snd_pcm_lib_malloc_pages fndecl 2 43997 NULL
+__e820_add_region_fndecl_44001_fields __e820_add_region fndecl 3 44001 NULL
+max_io_sz_snic_fw_info_44009_fields max_io_sz snic_fw_info 0 44009 NULL
+level_pid_namespace_44021_fields level pid_namespace 0 44021 NULL
+rx_buffer_truesize_efx_nic_44027_fields rx_buffer_truesize efx_nic 0 44027 NULL
+ahc_linux_map_seg_fndecl_44059_fields ahc_linux_map_seg fndecl 4-5 44059 NULL
+num_trace_enums_module_44062_fields num_trace_enums module 0 44062 NULL nohasharray
+ctxt_hfi1_ctxtdata_44062_fields ctxt hfi1_ctxtdata 0 44062 &num_trace_enums_module_44062_fields
+blksize_xfs_da_geometry_44068_fields blksize xfs_da_geometry 0 44068 NULL
+xen_io_tlb_nslabs_vardecl_swiotlb_xen_c_44077_fields xen_io_tlb_nslabs vardecl_swiotlb-xen.c 0 44077 NULL
+num_subpackets_rmi_register_desc_item_44083_fields num_subpackets rmi_register_desc_item 0 44083 NULL
+netup_read_i2c_fndecl_44096_fields netup_read_i2c fndecl 5 44096 NULL
+ipoib_cm_create_srq_fndecl_44098_fields ipoib_cm_create_srq fndecl 2 44098 NULL
+xdr_decode_array2_fndecl_44099_fields xdr_decode_array2 fndecl 2-0 44099 NULL
+m_inode_cluster_size_xfs_mount_44101_fields m_inode_cluster_size xfs_mount 0 44101 NULL
+payload_sz_storvsc_cmd_request_44107_fields payload_sz storvsc_cmd_request 0 44107 NULL
+fats_fat_boot_sector_44112_fields fats fat_boot_sector 0 44112 NULL
+max_rdma_ctxs_ib_qp_cap_44123_fields max_rdma_ctxs ib_qp_cap 0 44123 NULL
+base_nforce2_smbus_44136_fields base nforce2_smbus 0 44136 NULL
+key_maxval_mcs_platform_data_44139_fields key_maxval mcs_platform_data 0 44139 NULL
+submit_extent_page_fndecl_44155_fields submit_extent_page fndecl 7-8-6 44155 NULL
+octeon_setup_droq_fndecl_44160_fields octeon_setup_droq fndecl 4-3 44160 NULL
+bfad_debugfs_write_regwr_fndecl_44162_fields bfad_debugfs_write_regwr fndecl 3 44162 NULL
+recvmsg_proto_ops_44163_fields recvmsg proto_ops 0 44163 NULL
+y_len_ccp_ecc_point_44168_fields y_len ccp_ecc_point 0 44168 NULL
+size_drm_mode_create_dumb_44176_fields size drm_mode_create_dumb 0 44176 NULL
+tcfp_nkeys_tcf_pedit_44184_fields tcfp_nkeys tcf_pedit 0 44184 NULL
+qlcnic_change_mtu_fndecl_44186_fields qlcnic_change_mtu fndecl 2 44186 NULL
+btrfs_file_llseek_fndecl_44189_fields btrfs_file_llseek fndecl 2 44189 NULL
+len_scifioctl_copy_44214_fields len scifioctl_copy 0 44214 NULL
+s_bsize_jfs_superblock_44215_fields s_bsize jfs_superblock 0 44215 NULL nohasharray
+i2c_len_intel_scu_ipc_pdata_t_44215_fields i2c_len intel_scu_ipc_pdata_t 0 44215 &s_bsize_jfs_superblock_44215_fields
+IA_TX_BUF_vardecl_iphase_c_44217_fields IA_TX_BUF vardecl_iphase.c 0 44217 NULL nohasharray
+ext2_inode_by_name_fndecl_44217_fields ext2_inode_by_name fndecl 0 44217 &IA_TX_BUF_vardecl_iphase_c_44217_fields
+__ubifs_setxattr_fndecl_44224_fields __ubifs_setxattr fndecl 4 44224 NULL
+length_rxe_dma_info_44225_fields length rxe_dma_info 0 44225 NULL
+len_args_fndecl_44226_fields len_args fndecl 0 44226 NULL
+ufs_extend_tail_fndecl_44228_fields ufs_extend_tail fndecl 2 44228 NULL
+ima_store_measurement_fndecl_44233_fields ima_store_measurement fndecl 5 44233 NULL
+au0828_init_isoc_fndecl_44238_fields au0828_init_isoc fndecl 4-2 44238 NULL nohasharray
+ns_first_data_block_the_nilfs_44238_fields ns_first_data_block the_nilfs 0 44238 &au0828_init_isoc_fndecl_44238_fields nohasharray
+iriap_connect_indication_fndecl_44238_fields iriap_connect_indication fndecl 5 44238 &ns_first_data_block_the_nilfs_44238_fields
+irda_sendmsg_fndecl_44239_fields irda_sendmsg fndecl 3 44239 NULL nohasharray
+frag_stride_mlx4_en_frag_info_44239_fields frag_stride mlx4_en_frag_info 0 44239 &irda_sendmsg_fndecl_44239_fields
+num_pages_vb2_dma_sg_buf_44241_fields num_pages vb2_dma_sg_buf 0 44241 NULL
+cxgb4_pktgl_to_skb_fndecl_44248_fields cxgb4_pktgl_to_skb fndecl 3-2 44248 NULL nohasharray
+ax25_addr_size_fndecl_44248_fields ax25_addr_size fndecl 0 44248 &cxgb4_pktgl_to_skb_fndecl_44248_fields
+num_reg_defaults_raw_regmap_config_44249_fields num_reg_defaults_raw regmap_config 0 44249 NULL
+skd_sgs_per_request_vardecl_skd_main_c_44264_fields skd_sgs_per_request vardecl_skd_main.c 0 44264 NULL
+length_ceph_pagelist_44267_fields length ceph_pagelist 0 44267 NULL
+s_blocks_per_group_ext2_sb_info_44270_fields s_blocks_per_group ext2_sb_info 0 44270 NULL nohasharray
+skb_put_frags_fndecl_44270_fields skb_put_frags fndecl 3-2 44270 &s_blocks_per_group_ext2_sb_info_44270_fields
+log_pmtu_rvt_ah_44277_fields log_pmtu rvt_ah 0 44277 NULL
+new_raid_disk_md_rdev_44282_fields new_raid_disk md_rdev 0 44282 NULL
+send_bulk_static_data_fndecl_44287_fields send_bulk_static_data fndecl 3 44287 NULL
+rsp_len_bfad_fcxp_44290_fields rsp_len bfad_fcxp 0 44290 NULL
+pbus_size_mem_fndecl_44293_fields pbus_size_mem fndecl 6 44293 NULL
+NumberOfPorts_mpt3sas_facts_44306_fields NumberOfPorts mpt3sas_facts 0 44306 NULL
+plen_iwch_ep_44317_fields plen iwch_ep 0 44317 NULL
+rq_num_entries_c4iw_qp_attributes_44321_fields rq_num_entries c4iw_qp_attributes 0 44321 NULL
+produce_size_qp_entry_44325_fields produce_size qp_entry 0 44325 NULL
+encode_op_hdr_fndecl_44327_fields encode_op_hdr fndecl 3 44327 NULL
+size_drm_radeon_gem_userptr_44334_fields size drm_radeon_gem_userptr 0 44334 NULL
+arm_copy_from_user_fndecl_44337_fields arm_copy_from_user fndecl 0 44337 NULL
+bytesused_cx18_buffer_44339_fields bytesused cx18_buffer 0 44339 NULL
+tail_circ_buf_44346_fields tail circ_buf 0 44346 NULL nohasharray
+count_v4l2_ext_controls_44346_fields count v4l2_ext_controls 0 44346 &tail_circ_buf_44346_fields
+brcmf_sdio_txpkt_prep_sg_fndecl_44354_fields brcmf_sdio_txpkt_prep_sg fndecl 4-0 44354 NULL
+irlan_connect_confirm_fndecl_44361_fields irlan_connect_confirm fndecl 5 44361 NULL
+jffs2_write_end_fndecl_44362_fields jffs2_write_end fndecl 3 44362 NULL
+info0_htt_rx_delba_44375_fields info0 htt_rx_delba 0 44375 NULL
+tipc_link_bc_create_fndecl_44381_fields tipc_link_bc_create fndecl 4 44381 NULL
+dvb_net_ioctl_fndecl_44388_fields dvb_net_ioctl fndecl 2 44388 NULL
+reiserfs_xattr_set_fndecl_44389_fields reiserfs_xattr_set fndecl 4 44389 NULL
+s_raid_stripe_width_ext4_super_block_44401_fields s_raid_stripe_width ext4_super_block 0 44401 NULL
+kcm_sendpage_fndecl_44404_fields kcm_sendpage fndecl 4-3 44404 NULL nohasharray
+num_iscsi_tasks_cnic_local_44404_fields num_iscsi_tasks cnic_local 0 44404 &kcm_sendpage_fndecl_44404_fields
+child_mtu_cached_xfrm_dst_44407_fields child_mtu_cached xfrm_dst 0 44407 NULL
+vmxnet3_create_queues_fndecl_44410_fields vmxnet3_create_queues fndecl 5 44410 NULL
+yres_virtual_fb_var_screeninfo_44414_fields yres_virtual fb_var_screeninfo 0 44414 NULL
+count_configfs_buffer_44416_fields count configfs_buffer 0 44416 NULL
+__get_vm_area_fndecl_44428_fields __get_vm_area fndecl 3 44428 NULL nohasharray
+rq_ecount_lpfc_sli4_hba_44428_fields rq_ecount lpfc_sli4_hba 0 44428 &__get_vm_area_fndecl_44428_fields
+nbd_ioctl_fndecl_44444_fields nbd_ioctl fndecl 4 44444 NULL
+ivsize_crypto_skcipher_44448_fields ivsize crypto_skcipher 0 44448 NULL
+hh_len_hh_cache_44455_fields hh_len hh_cache 0 44455 NULL
+cx2341x_handler_init_fndecl_44466_fields cx2341x_handler_init fndecl 2 44466 NULL
+cap_height_usbtv_norm_params_44467_fields cap_height usbtv_norm_params 0 44467 NULL
+get_data_block_bmap_fndecl_44468_fields get_data_block_bmap fndecl 2 44468 NULL
+address_length_acpi_address32_attribute_44471_fields address_length acpi_address32_attribute 0 44471 NULL
+skb_find_text_fndecl_44481_fields skb_find_text fndecl 2-0 44481 NULL
+virtio_gpu_gem_create_fndecl_44491_fields virtio_gpu_gem_create fndecl 3 44491 NULL
+s_first_data_block_ext4_super_block_44495_fields s_first_data_block ext4_super_block 0 44495 NULL
+mmcies_max_wusbhc_44498_fields mmcies_max wusbhc 0 44498 NULL
+pci_cardbus_io_size_vardecl_44500_fields pci_cardbus_io_size vardecl 0 44500 NULL
+io_start_nfs_pgio_header_44501_fields io_start nfs_pgio_header 0 44501 NULL
+omfs_bread_fndecl_44502_fields omfs_bread fndecl 2 44502 NULL nohasharray
+skb_append_pagefrags_fndecl_44502_fields skb_append_pagefrags fndecl 3 44502 &omfs_bread_fndecl_44502_fields
+btrfs_add_ordered_extent_fndecl_44505_fields btrfs_add_ordered_extent fndecl 4-2-3 44505 NULL
+len_iwl_fw_dbg_mem_seg_tlv_44509_fields len iwl_fw_dbg_mem_seg_tlv 0 44509 NULL
+ftdi_elan_edset_setup_fndecl_44513_fields ftdi_elan_edset_setup fndecl 0 44513 NULL nohasharray
+ubifs_add_snod_fndecl_44513_fields ubifs_add_snod fndecl 4 44513 &ftdi_elan_edset_setup_fndecl_44513_fields
+lock_loop_fndecl_44514_fields lock_loop fndecl 1-0 44514 NULL
+__do_tune_cpucache_fndecl_44519_fields __do_tune_cpucache fndecl 3-2-4 44519 NULL
+len_pnfs_block_extent_44521_fields len pnfs_block_extent 0 44521 NULL
+video_bpp_sis_video_info_44522_fields video_bpp sis_video_info 0 44522 NULL nohasharray
+length_mtd_oob_buf_44522_fields length mtd_oob_buf 0 44522 &video_bpp_sis_video_info_44522_fields
+rbytes_tree_balance_44523_fields rbytes tree_balance 0 44523 NULL
+set_le_key_k_type_fndecl_44525_fields set_le_key_k_type fndecl 3 44525 NULL
+xlog_recover_clear_agi_bucket_fndecl_44526_fields xlog_recover_clear_agi_bucket fndecl 2 44526 NULL
+yenta_search_one_res_fndecl_44533_fields yenta_search_one_res fndecl 3 44533 NULL
+max_cqes_mthca_limits_44535_fields max_cqes mthca_limits 0 44535 NULL
+consume_size_vmci_transport_44542_fields consume_size vmci_transport 0 44542 NULL
+add_debugfs_mem_fndecl_44546_fields add_debugfs_mem fndecl 4 44546 NULL
+container_height_dmm_44549_fields container_height dmm 0 44549 NULL
+chanctx_data_size_ieee80211_hw_44557_fields chanctx_data_size ieee80211_hw 0 44557 NULL
+wTotalLength_usb_config_descriptor_44569_fields wTotalLength usb_config_descriptor 0 44569 NULL nohasharray
+hpfs_fnode_dno_fndecl_44569_fields hpfs_fnode_dno fndecl 0-2 44569 &wTotalLength_usb_config_descriptor_44569_fields
+parent_i_pos_hi_fat_fid_44570_fields parent_i_pos_hi fat_fid 0 44570 NULL
+cfg0_base_pcie_port_44572_fields cfg0_base pcie_port 0 44572 NULL
+tw_transfer_internal_fndecl_44581_fields tw_transfer_internal fndecl 4 44581 NULL
+nlb_nvme_dsm_range_44584_fields nlb nvme_dsm_range 0 44584 NULL
+smsc47m1_find_fndecl_44589_fields smsc47m1_find fndecl 0 44589 NULL
+rd_data0_gfs2_rgrpd_44591_fields rd_data0 gfs2_rgrpd 0 44591 NULL
+allocate_partition_fndecl_44598_fields allocate_partition fndecl 4 44598 NULL
+of_io_request_and_map_fndecl_44605_fields of_io_request_and_map fndecl 2 44605 NULL
+vid_hdr_offset_ubi_attach_req_44622_fields vid_hdr_offset ubi_attach_req 0 44622 NULL nohasharray
+irq_cros_ec_device_44622_fields irq cros_ec_device 0 44622 &vid_hdr_offset_ubi_attach_req_44622_fields
+security_file_permission_fndecl_44629_fields security_file_permission fndecl 0 44629 NULL
+max_sectors_Scsi_Host_44630_fields max_sectors Scsi_Host 0 44630 NULL
+data_len_krb5_tagged_data_44634_fields data_len krb5_tagged_data 0 44634 NULL
+bd_block_size_block_device_44635_fields bd_block_size block_device 0 44635 NULL
+chunk_root_btrfs_super_block_44639_fields chunk_root btrfs_super_block 0 44639 NULL
+hfcpci_empty_bfifo_fndecl_44640_fields hfcpci_empty_bfifo fndecl 4 44640 NULL
+nb_dev_strip_zone_44645_fields nb_dev strip_zone 0 44645 NULL
+len_nlm_lock_44646_fields len nlm_lock 0 44646 NULL
+cp_payload_f2fs_super_block_44648_fields cp_payload f2fs_super_block 0 44648 NULL
+rel_sectors_mmc_ext_csd_44650_fields rel_sectors mmc_ext_csd 0 44650 NULL
+iscsi_segment_init_linear_fndecl_44654_fields iscsi_segment_init_linear fndecl 3 44654 NULL nohasharray
+cm_cno_nilfs_cpmode_44654_fields cm_cno nilfs_cpmode 0 44654 &iscsi_segment_init_linear_fndecl_44654_fields
+bLength_usb_interface_descriptor_44655_fields bLength usb_interface_descriptor 0 44655 NULL nohasharray
+nr_sectors_blkif_request_discard_44655_fields nr_sectors blkif_request_discard 0 44655 &bLength_usb_interface_descriptor_44655_fields
+sparse_early_usemaps_alloc_pgdat_section_fndecl_44659_fields sparse_early_usemaps_alloc_pgdat_section fndecl 2 44659 NULL
+import_single_range_fndecl_44662_fields import_single_range fndecl 3 44662 NULL
+max_rqe_pdid_ocrdma_query_srq_rsp_44663_fields max_rqe_pdid ocrdma_query_srq_rsp 0 44663 NULL
+fe_len_ext4_free_extent_44669_fields fe_len ext4_free_extent 0 44669 NULL
+lfb_width_screen_info_44670_fields lfb_width screen_info 0 44670 NULL
+overlay_cap_top_vivid_dev_44672_fields overlay_cap_top vivid_dev 0 44672 NULL
+mad_sendq_size_vardecl_mad_c_44673_fields mad_sendq_size vardecl_mad.c 0 44673 NULL nohasharray
+flash_write_fndecl_44673_fields flash_write fndecl 3 44673 &mad_sendq_size_vardecl_mad_c_44673_fields
+sys_io_setup_fndecl_44679_fields sys_io_setup fndecl 1 44679 NULL nohasharray
+pipes_psb_ops_44679_fields pipes psb_ops 0 44679 &sys_io_setup_fndecl_44679_fields
+vlan_cnt_ncsi_rsp_gc_pkt_44681_fields vlan_cnt ncsi_rsp_gc_pkt 0 44681 NULL nohasharray
+COM_len_camera_data_44681_fields COM_len camera_data 0 44681 &vlan_cnt_ncsi_rsp_gc_pkt_44681_fields nohasharray
+setup_swap_map_and_extents_fndecl_44681_fields setup_swap_map_and_extents fndecl 5 44681 &COM_len_camera_data_44681_fields nohasharray
+length_ore_striping_info_44681_fields length ore_striping_info 0 44681 &setup_swap_map_and_extents_fndecl_44681_fields
+msg_size_ecryptfs_msg_ctx_44687_fields msg_size ecryptfs_msg_ctx 0 44687 NULL
+offset_drm_map_44692_fields offset drm_map 0 44692 NULL
+start_linear_c_44708_fields start linear_c 0 44708 NULL
+drbd_alloc_peer_req_fndecl_44710_fields drbd_alloc_peer_req fndecl 3-4 44710 NULL
+au_rslack_rpc_auth_44712_fields au_rslack rpc_auth 0 44712 NULL
+__nilfs_get_page_block_fndecl_44723_fields __nilfs_get_page_block fndecl 4 44723 NULL
+inlen_mimd_44727_fields inlen mimd 0 44727 NULL
+nd_blk_rw_integrity_fndecl_44728_fields nd_blk_rw_integrity fndecl 0 44728 NULL nohasharray
+adv7842_read_cable_det_fndecl_44728_fields adv7842_read_cable_det fndecl 0 44728 &nd_blk_rw_integrity_fndecl_44728_fields
+buffer_size_st_buffer_44731_fields buffer_size st_buffer 0 44731 NULL nohasharray
+assoc_req_ies_len_station_info_44731_fields assoc_req_ies_len station_info 0 44731 &buffer_size_st_buffer_44731_fields
+desc_size_orangefs_bufmap_44734_fields desc_size orangefs_bufmap 0 44734 NULL nohasharray
+wait_for_direct_io_fndecl_44734_fields wait_for_direct_io fndecl 5 44734 &desc_size_orangefs_bufmap_44734_fields
+name_len_name_cache_entry_44739_fields name_len name_cache_entry 0 44739 NULL
+page_size_mspro_sys_info_44749_fields page_size mspro_sys_info 0 44749 NULL
+max_phy_id_vardecl_x86_pkg_temp_thermal_c_44750_fields max_phy_id vardecl_x86_pkg_temp_thermal.c 0 44750 NULL
+dev_sectors_mddev_44756_fields dev_sectors mddev 0 44756 NULL
+set_ssp_fndecl_44760_fields set_ssp fndecl 4 44760 NULL
+p_memsz_elf64_phdr_44763_fields p_memsz elf64_phdr 0 44763 NULL
+mt9m111_reg_read_fndecl_44764_fields mt9m111_reg_read fndecl 0 44764 NULL
+telem_pmc_ssram_base_intel_pmc_ipc_dev_44767_fields telem_pmc_ssram_base intel_pmc_ipc_dev 0 44767 NULL
+sys_tee_fndecl_44769_fields sys_tee fndecl 3 44769 NULL
+count_snd_kcontrol_44773_fields count snd_kcontrol 0 44773 NULL
+nbp_vlan_add_fndecl_44783_fields nbp_vlan_add fndecl 2 44783 NULL nohasharray
+n_values_i2c_mux_gpio_platform_data_44783_fields n_values i2c_mux_gpio_platform_data 0 44783 &nbp_vlan_add_fndecl_44783_fields
+ocfs2_handle_error_fndecl_44785_fields ocfs2_handle_error fndecl 0 44785 NULL
+device_count_pci_bus_relations_44792_fields device_count pci_bus_relations 0 44792 NULL
+btt_data_write_fndecl_44793_fields btt_data_write fndecl 0 44793 NULL
+truncate_size_ceph_mds_caps_44794_fields truncate_size ceph_mds_caps 0 44794 NULL
+sg_used_ccp_sg_workarea_44796_fields sg_used ccp_sg_workarea 0 44796 NULL
+n_caps_whci_card_44799_fields n_caps whci_card 0 44799 NULL nohasharray
+ioc_queue_depth_bfad_cfg_param_s_44799_fields ioc_queue_depth bfad_cfg_param_s 0 44799 &n_caps_whci_card_44799_fields
+mtd_ooblayout_get_bytes_fndecl_44801_fields mtd_ooblayout_get_bytes fndecl 4 44801 NULL
+tclass_sq_psn_ocrdma_qp_params_44805_fields tclass_sq_psn ocrdma_qp_params 0 44805 NULL
+__remove_privs_fndecl_44811_fields __remove_privs fndecl 0 44811 NULL nohasharray
+raw_getfrag_fndecl_44811_fields raw_getfrag fndecl 3-4 44811 &__remove_privs_fndecl_44811_fields
+st21nfca_hci_dm_reset_fndecl_44819_fields st21nfca_hci_dm_reset fndecl 3 44819 NULL
+cluster_pages_for_defrag_fndecl_44823_fields cluster_pages_for_defrag fndecl 0-4-3 44823 NULL nohasharray
+loffset_scifioctl_copy_44823_fields loffset scifioctl_copy 0 44823 &cluster_pages_for_defrag_fndecl_44823_fields
+bytesize_nbd_device_44824_fields bytesize nbd_device 0 44824 NULL
+vlan_tag_be_rx_compl_info_44830_fields vlan_tag be_rx_compl_info 0 44830 NULL nohasharray
+fix_read_error_fndecl_44830_fields fix_read_error fndecl 4-3 44830 &vlan_tag_be_rx_compl_info_44830_fields
+name_len_exofs_dir_entry_44838_fields name_len exofs_dir_entry 0 44838 NULL
+num_zones_quirk_entry_44844_fields num_zones quirk_entry 0 44844 NULL
+btrfs_shrink_device_fndecl_44845_fields btrfs_shrink_device fndecl 2 44845 NULL
+ext4_da_get_block_prep_fndecl_44848_fields ext4_da_get_block_prep fndecl 2 44848 NULL
+primary_size_drm_mga_dma_bootstrap_44851_fields primary_size drm_mga_dma_bootstrap 0 44851 NULL
+start_segno_sit_entry_set_44852_fields start_segno sit_entry_set 0 44852 NULL
+compat_do_readv_writev_fndecl_44857_fields compat_do_readv_writev fndecl 4 44857 NULL
+viafb_second_yres_vardecl_44862_fields viafb_second_yres vardecl 0 44862 NULL
+crypt_extent_fndecl_44866_fields crypt_extent fndecl 4 44866 NULL nohasharray
+h4_recv_fndecl_44866_fields h4_recv fndecl 3 44866 &crypt_extent_fndecl_44866_fields
+alloc_rc_map_44870_fields alloc rc_map 0 44870 NULL
+romfs_blk_read_fndecl_44875_fields romfs_blk_read fndecl 4-2 44875 NULL
+ppp_tx_cp_fndecl_44879_fields ppp_tx_cp fndecl 5 44879 NULL
+rvt_set_page_fndecl_44884_fields rvt_set_page fndecl 2 44884 NULL
+__cookie_v4_check_fndecl_44887_fields __cookie_v4_check fndecl 0 44887 NULL nohasharray
+jffs2_do_unlink_fndecl_44887_fields jffs2_do_unlink fndecl 4 44887 &__cookie_v4_check_fndecl_44887_fields
+code_length_lirc_driver_44888_fields code_length lirc_driver 0 44888 NULL
+msg_len_rndis_data_hdr_44891_fields msg_len rndis_data_hdr 0 44891 NULL
+inst_evtlog_size_iwl_fw_44893_fields inst_evtlog_size iwl_fw 0 44893 NULL
+FormattedSize_NFTLMediaHeader_44896_fields FormattedSize NFTLMediaHeader 0 44896 NULL
+io_size_gpio_lpc_sch_info_44898_fields io_size_gpio lpc_sch_info 0 44898 NULL
+pcpu_alloc_bootmem_fndecl_44905_fields pcpu_alloc_bootmem fndecl 3-2 44905 NULL nohasharray
+sge_offset_rxe_dma_info_44905_fields sge_offset rxe_dma_info 0 44905 &pcpu_alloc_bootmem_fndecl_44905_fields
+gotoxy_fndecl_44908_fields gotoxy fndecl 2-3 44908 NULL
+write_packet_fndecl_44910_fields write_packet fndecl 3 44910 NULL
+catas_size_mlx4_fw_44916_fields catas_size mlx4_fw 0 44916 NULL
+bvec_iter_advance_fndecl_44933_fields bvec_iter_advance fndecl 3 44933 NULL
+mlx5e_add_skb_frag_fragmented_mpwqe_fndecl_44934_fields mlx5e_add_skb_frag_fragmented_mpwqe fndecl 6-5 44934 NULL
+liquidio_push_packet_fndecl_44941_fields liquidio_push_packet fndecl 3 44941 NULL nohasharray
+roccat_common2_sysfs_write_fndecl_44941_fields roccat_common2_sysfs_write fndecl 6 44941 &liquidio_push_packet_fndecl_44941_fields
+data_dev_block_bits_dm_verity_44943_fields data_dev_block_bits dm_verity 0 44943 NULL
+_xfs_log_force_lsn_fndecl_44944_fields _xfs_log_force_lsn fndecl 0 44944 NULL nohasharray
+data_block_dm_thin_new_mapping_44944_fields data_block dm_thin_new_mapping 0 44944 &_xfs_log_force_lsn_fndecl_44944_fields nohasharray
+acpiphp_max_busnr_fndecl_44944_fields acpiphp_max_busnr fndecl 0 44944 &data_block_dm_thin_new_mapping_44944_fields
+srp_sq_size_srpt_port_attrib_44947_fields srp_sq_size srpt_port_attrib 0 44947 NULL
+max_post_mlx5_ib_wq_44949_fields max_post mlx5_ib_wq 0 44949 NULL
+sd_diptrs_gfs2_sbd_44954_fields sd_diptrs gfs2_sbd 0 44954 NULL
+coff_ddb_output_44962_fields coff ddb_output 0 44962 NULL
+fat12_ent_bread_fndecl_44968_fields fat12_ent_bread fndecl 4 44968 NULL
+i915_pages_create_for_stolen_fndecl_44970_fields i915_pages_create_for_stolen fndecl 3 44970 NULL
+x0_osd_cmd_s_44978_fields x0 osd_cmd_s 0 44978 NULL
+length_mtd_oob_buf64_44979_fields length mtd_oob_buf64 0 44979 NULL
+ip_recv_error_fndecl_44982_fields ip_recv_error fndecl 3 44982 NULL nohasharray
+num_free_virtqueue_44982_fields num_free virtqueue 0 44982 &ip_recv_error_fndecl_44982_fields
+generic_block_fiemap_fndecl_44985_fields generic_block_fiemap fndecl 4 44985 NULL
+snd_ak4114_external_rate_fndecl_44987_fields snd_ak4114_external_rate fndecl 0 44987 NULL
+num_carats_acpi_namestring_info_44990_fields num_carats acpi_namestring_info 0 44990 NULL
+fts_libipw_device_44996_fields fts libipw_device 0 44996 NULL
+iscsi_max_outsnd_r2t_dev_db_entry_44997_fields iscsi_max_outsnd_r2t dev_db_entry 0 44997 NULL
+eeprom_size_il_cfg_44998_fields eeprom_size il_cfg 0 44998 NULL
+ocfs2_list_xattr_tree_rec_fndecl_45001_fields ocfs2_list_xattr_tree_rec fndecl 3 45001 NULL
+max_recv_sge_ocrdma_dev_attr_45006_fields max_recv_sge ocrdma_dev_attr 0 45006 NULL
+fq_init_fndecl_45009_fields fq_init fndecl 2 45009 NULL
+size_e820entry_45018_fields size e820entry 0 45018 NULL
+num_cqs_mthca_limits_45021_fields num_cqs mthca_limits 0 45021 NULL
+membase_vgastate_45022_fields membase vgastate 0 45022 NULL
+rd_size_hidp_session_45023_fields rd_size hidp_session 0 45023 NULL
+size_nf_queue_entry_45047_fields size nf_queue_entry 0 45047 NULL
+tx_ring_count_e1000_adapter_45060_fields tx_ring_count e1000_adapter 0 45060 NULL
+crypto_akcipher_maxsize_fndecl_45073_fields crypto_akcipher_maxsize fndecl 0 45073 NULL
+read_vbt_r10_fndecl_45076_fields read_vbt_r10 fndecl 1 45076 NULL
+sendpage_iscsi_sw_tcp_conn_45081_fields sendpage iscsi_sw_tcp_conn 0 45081 NULL
+unmap_mapping_range_vma_fndecl_45084_fields unmap_mapping_range_vma fndecl 2-3 45084 NULL
+regshift_uart_port_45089_fields regshift uart_port 0 45089 NULL
+revmap_size_irq_domain_45091_fields revmap_size irq_domain 0 45091 NULL
+ocfs2_lock_reflink_xattr_rec_allocators_fndecl_45097_fields ocfs2_lock_reflink_xattr_rec_allocators fndecl 3 45097 NULL
+bblog_size_mdp_superblock_1_45102_fields bblog_size mdp_superblock_1 0 45102 NULL
+pitch_tmHWStreamParameters_45105_fields pitch tmHWStreamParameters 0 45105 NULL
+skb_tx_rsvd_cxgbi_device_45109_fields skb_tx_rsvd cxgbi_device 0 45109 NULL
+init_data_container_fndecl_45110_fields init_data_container fndecl 1 45110 NULL nohasharray
+watchdog_devt_vardecl_watchdog_dev_c_45110_fields watchdog_devt vardecl_watchdog_dev.c 0 45110 &init_data_container_fndecl_45110_fields
+drvinfo_sz_rtl8xxxu_rxdesc16_45111_fields drvinfo_sz rtl8xxxu_rxdesc16 0 45111 NULL
+ea_size_s_fnode_45115_fields ea_size_s fnode 0 45115 NULL
+ov518_pkt_scan_fndecl_45121_fields ov518_pkt_scan fndecl 3 45121 NULL
+vblk_size_vmdb_45123_fields vblk_size vmdb 0 45123 NULL
+key_len_mwifiex_ds_encrypt_key_45127_fields key_len mwifiex_ds_encrypt_key 0 45127 NULL nohasharray
+offset_nb8800_rx_buf_45127_fields offset nb8800_rx_buf 0 45127 &key_len_mwifiex_ds_encrypt_key_45127_fields
+rpc_max_bc_payload_fndecl_45131_fields rpc_max_bc_payload fndecl 0 45131 NULL
+img_x_zoran_jpg_settings_45135_fields img_x zoran_jpg_settings 0 45135 NULL
+offset_mlx4_clock_params_45137_fields offset mlx4_clock_params 0 45137 NULL
+specified_table_size_vardecl_45152_fields specified_table_size vardecl 0 45152 NULL
+MaxLanBuckets__MSG_PORT_FACTS_REPLY_45155_fields MaxLanBuckets _MSG_PORT_FACTS_REPLY 0 45155 NULL
+ocfs2_set_refcount_tree_fndecl_45158_fields ocfs2_set_refcount_tree fndecl 3 45158 NULL
+nvmet_copy_from_sgl_fndecl_45160_fields nvmet_copy_from_sgl fndecl 2-4 45160 NULL
+desc_len_skb_frame_desc_45170_fields desc_len skb_frame_desc 0 45170 NULL nohasharray
+pkcs7_sig_note_issuer_fndecl_45170_fields pkcs7_sig_note_issuer fndecl 5 45170 &desc_len_skb_frame_desc_45170_fields
+hpfs_remove_dirent_fndecl_45171_fields hpfs_remove_dirent fndecl 2 45171 NULL
+sel_write_checkreqprot_fndecl_45173_fields sel_write_checkreqprot fndecl 3 45173 NULL
+leaf_cut_entries_fndecl_45176_fields leaf_cut_entries fndecl 0-4 45176 NULL
+nfsd_splice_read_fndecl_45181_fields nfsd_splice_read fndecl 3 45181 NULL nohasharray
+quirk_awe32_add_ports_fndecl_45181_fields quirk_awe32_add_ports fndecl 3 45181 &nfsd_splice_read_fndecl_45181_fields
+n_namesz_elf32_note_45186_fields n_namesz elf32_note 0 45186 NULL
+gfs2_bmap_alloc_fndecl_45189_fields gfs2_bmap_alloc fndecl 7 45189 NULL
+mtu_l2cap_conn_45195_fields mtu l2cap_conn 0 45195 NULL
+count_user_sgentry_45207_fields count user_sgentry 0 45207 NULL
+i40iw_reject_fndecl_45212_fields i40iw_reject fndecl 3 45212 NULL
+l2cap_sock_recvmsg_fndecl_45221_fields l2cap_sock_recvmsg fndecl 3 45221 NULL
+ep_out_usbtest_info_45222_fields ep_out usbtest_info 0 45222 NULL
+nwords_xdr_stream_45223_fields nwords xdr_stream 0 45223 NULL
+cmt_orphans_ubifs_info_45232_fields cmt_orphans ubifs_info 0 45232 NULL
+packet_buffer_put_fndecl_45234_fields packet_buffer_put fndecl 3 45234 NULL nohasharray
+cros_ec_cmd_xfer_status_fndecl_45234_fields cros_ec_cmd_xfer_status fndecl 0 45234 &packet_buffer_put_fndecl_45234_fields
+max_cqes_mlx4_caps_45237_fields max_cqes mlx4_caps 0 45237 NULL
+internal_dev_change_mtu_fndecl_45242_fields internal_dev_change_mtu fndecl 2 45242 NULL
+aggregate_new_rx_fndecl_45246_fields aggregate_new_rx fndecl 4 45246 NULL nohasharray
+info0_htt_rx_addba_45246_fields info0 htt_rx_addba 0 45246 &aggregate_new_rx_fndecl_45246_fields
+st_nci_hci_dm_fwupd_start_fndecl_45248_fields st_nci_hci_dm_fwupd_start fndecl 3 45248 NULL
+__xattr_check_inode_fndecl_45251_fields __xattr_check_inode fndecl 0 45251 NULL
+base_erst_erange_45255_fields base erst_erange 0 45255 NULL
+rpcrdma_count_chunks_fndecl_45258_fields rpcrdma_count_chunks fndecl 0 45258 NULL
+nameLen_nw_info_struct_45260_fields nameLen nw_info_struct 0 45260 NULL
+check_sectors_in_chain_fndecl_45261_fields check_sectors_in_chain fndecl 2 45261 NULL
+num_rx_ring_sh_eth_private_45262_fields num_rx_ring sh_eth_private 0 45262 NULL
+alloc_buf_fndecl_45267_fields alloc_buf fndecl 2 45267 NULL
+generic_writepages_fndecl_45268_fields generic_writepages fndecl 0 45268 NULL nohasharray
+vmw_dmabuf_init_fndecl_45268_fields vmw_dmabuf_init fndecl 3 45268 &generic_writepages_fndecl_45268_fields
+btrfs_test_qgroups_fndecl_45273_fields btrfs_test_qgroups fndecl 1-2 45273 NULL
+rss_size_max_i40e_pf_45282_fields rss_size_max i40e_pf 0 45282 NULL
+mgt_set_varlen_fndecl_45287_fields mgt_set_varlen fndecl 4 45287 NULL
+ath6kl_sdio_write_async_fndecl_45290_fields ath6kl_sdio_write_async fndecl 4 45290 NULL
+rcvhdrcnt_qib_devdata_45297_fields rcvhdrcnt qib_devdata 0 45297 NULL
+rcvhdrcnt_vardecl_init_c_45302_fields rcvhdrcnt vardecl_init.c 0 45302 NULL
+hugetlbfs_read_actor_fndecl_45304_fields hugetlbfs_read_actor fndecl 4-0-2 45304 NULL
+atl1_change_mtu_fndecl_45313_fields atl1_change_mtu fndecl 2 45313 NULL nohasharray
+rx_count_ethtool_channels_45313_fields rx_count ethtool_channels 0 45313 &atl1_change_mtu_fndecl_45313_fields nohasharray
+rx_ring_count_xgbe_prv_data_45313_fields rx_ring_count xgbe_prv_data 0 45313 &rx_count_ethtool_channels_45313_fields
+tipc_buf_acquire_fndecl_45318_fields tipc_buf_acquire fndecl 1 45318 NULL
+rx_data_fndecl_45321_fields rx_data fndecl 4 45321 NULL
+len_qib_diag_xpkt_45322_fields len qib_diag_xpkt 0 45322 NULL nohasharray
+fec_decode_bufs_fndecl_45322_fields fec_decode_bufs fndecl 3-5 45322 &len_qib_diag_xpkt_45322_fields
+tipc_recv_stream_fndecl_45323_fields tipc_recv_stream fndecl 3 45323 NULL
+back_xfs_dir3_icleaf_hdr_45324_fields back xfs_dir3_icleaf_hdr 0 45324 NULL
+tcf_csum_ipv4_igmp_fndecl_45325_fields tcf_csum_ipv4_igmp fndecl 3 45325 NULL
+of_property_count_elems_of_size_fndecl_45337_fields of_property_count_elems_of_size fndecl 0 45337 NULL
+peer_chan_len_wmi_tdls_peer_capab_arg_45339_fields peer_chan_len wmi_tdls_peer_capab_arg 0 45339 NULL
+vm_munmap_fndecl_45341_fields vm_munmap fndecl 1-2 45341 NULL
+__snd_util_mem_alloc_fndecl_45349_fields __snd_util_mem_alloc fndecl 2 45349 NULL
+uar_size_mlx4_dev_cap_45351_fields uar_size mlx4_dev_cap 0 45351 NULL
+reserve_bad_mem_fndecl_45356_fields reserve_bad_mem fndecl 2-3 45356 NULL
+icq_size_elevator_type_45359_fields icq_size elevator_type 0 45359 NULL
+mad_recvq_size_vardecl_mad_c_45372_fields mad_recvq_size vardecl_mad.c 0 45372 NULL
+get_urb_status_from_qtd_fndecl_45378_fields get_urb_status_from_qtd fndecl 0 45378 NULL
+txq_entries_efx_nic_45383_fields txq_entries efx_nic 0 45383 NULL
+verity_finish_io_fndecl_45387_fields verity_finish_io fndecl 2 45387 NULL nohasharray
+nchildren_retu_data_45387_fields nchildren retu_data 0 45387 &verity_finish_io_fndecl_45387_fields
+pd_idx_sd_pd_idx_45398_fields pd_idx sd_pd_idx 0 45398 NULL
+mtu_l2cap_le_conn_req_45411_fields mtu l2cap_le_conn_req 0 45411 NULL
+lastUnit_INFTLPartition_45416_fields lastUnit INFTLPartition 0 45416 NULL
+st95hf_response_handler_fndecl_45419_fields st95hf_response_handler fndecl 3 45419 NULL
+ath_tx_init_fndecl_45424_fields ath_tx_init fndecl 2 45424 NULL
+fats_msdos_sb_info_45426_fields fats msdos_sb_info 0 45426 NULL
+__munlock_pagevec_fill_fndecl_45430_fields __munlock_pagevec_fill fndecl 0-4 45430 NULL
+rn_tnamelen_nfsd4_rename_45437_fields rn_tnamelen nfsd4_rename 0 45437 NULL
+radeon_ttm_tt_set_userptr_fndecl_45438_fields radeon_ttm_tt_set_userptr fndecl 2 45438 NULL
+rvt_alloc_device_fndecl_45442_fields rvt_alloc_device fndecl 1 45442 NULL
+qcaspi_netdev_change_mtu_fndecl_45450_fields qcaspi_netdev_change_mtu fndecl 2 45450 NULL
+start_bdi_bd_transfer_45454_fields start_bdi bd_transfer 0 45454 NULL
+wTotalLength_usb_bos_descriptor_45455_fields wTotalLength usb_bos_descriptor 0 45455 NULL
+cfrfml_create_fndecl_45463_fields cfrfml_create fndecl 3 45463 NULL
+nents_sg_splitter_45469_fields nents sg_splitter 0 45469 NULL
+sockaddr_len_audit_context_45471_fields sockaddr_len audit_context 0 45471 NULL
+elf_load_addr_kimage_arch_45472_fields elf_load_addr kimage_arch 0 45472 NULL
+i_pos_fat_slot_info_45481_fields i_pos fat_slot_info 0 45481 NULL
+hdisplay_drm_display_mode_45484_fields hdisplay drm_display_mode 0 45484 NULL
+memblock_virt_alloc_try_nid_nopanic_fndecl_45487_fields memblock_virt_alloc_try_nid_nopanic fndecl 2-3-4 45487 NULL
+pipe_out_lan78xx_net_45497_fields pipe_out lan78xx_net 0 45497 NULL nohasharray
+isofs_bmap_fndecl_45497_fields isofs_bmap fndecl 0-2 45497 &pipe_out_lan78xx_net_45497_fields
+bdeSize_ULP_BDL_45501_fields bdeSize ULP_BDL 0 45501 NULL
+nci_uart_default_recv_buf_fndecl_45502_fields nci_uart_default_recv_buf fndecl 4 45502 NULL
+mwifiex_set_gen_ie_fndecl_45504_fields mwifiex_set_gen_ie fndecl 3 45504 NULL
+free_dind_blocks_fndecl_45512_fields free_dind_blocks fndecl 3 45512 NULL
+ubifs_recover_leb_fndecl_45516_fields ubifs_recover_leb fndecl 3 45516 NULL
+buffer_size_vardecl_cpia2_v4l_c_45517_fields buffer_size vardecl_cpia2_v4l.c 0 45517 NULL nohasharray
+stv6110_write_regs_fndecl_45517_fields stv6110_write_regs fndecl 4 45517 &buffer_size_vardecl_cpia2_v4l_c_45517_fields
+inode_change_ok_fndecl_45525_fields inode_change_ok fndecl 0 45525 NULL
+cifs_partialpagewrite_fndecl_45527_fields cifs_partialpagewrite fndecl 2-3 45527 NULL nohasharray
+callback_via_vardecl_platform_pci_c_45527_fields callback_via vardecl_platform-pci.c 0 45527 &cifs_partialpagewrite_fndecl_45527_fields
+ssb_hcd_create_pdev_fndecl_45528_fields ssb_hcd_create_pdev fndecl 4-3 45528 NULL
+sizeof_dev_private_peak_usb_adapter_45529_fields sizeof_dev_private peak_usb_adapter 0 45529 NULL
+hpfs_trim_fs_fndecl_45531_fields hpfs_trim_fs fndecl 2-3 45531 NULL
+rtsx_usb_bulk_transfer_sglist_fndecl_45538_fields rtsx_usb_bulk_transfer_sglist fndecl 5-2-4 45538 NULL
+size_nft_expr_ops_45543_fields size nft_expr_ops 0 45543 NULL
+if_sdio_host_to_card_fndecl_45545_fields if_sdio_host_to_card fndecl 4 45545 NULL
+mp_agg_pkt_limit_sdio_mmc_card_45546_fields mp_agg_pkt_limit sdio_mmc_card 0 45546 NULL
+driver_max_VFs_pci_sriov_45552_fields driver_max_VFs pci_sriov 0 45552 NULL
+bpp_via_format_45554_fields bpp via_format 0 45554 NULL
+syncinterval_snd_usb_endpoint_45567_fields syncinterval snd_usb_endpoint 0 45567 NULL
+height_pwc_device_45570_fields height pwc_device 0 45570 NULL nohasharray
+amdtp_tscm_init_fndecl_45570_fields amdtp_tscm_init fndecl 4 45570 &height_pwc_device_45570_fields
+get_gate_page_fndecl_45571_fields get_gate_page fndecl 2 45571 NULL
+s_partition_func_udf_part_map_45579_fields s_partition_func udf_part_map 0 45579 NULL
+udf_free_blocks_fndecl_45589_fields udf_free_blocks fndecl 4-5 45589 NULL
+upd_received_ubi_volume_45595_fields upd_received ubi_volume 0 45595 NULL
+readpos_cx18_buffer_45604_fields readpos cx18_buffer 0 45604 NULL
+l_logBBsize_xlog_45614_fields l_logBBsize xlog 0 45614 NULL
+intel_th_device_add_resources_fndecl_45615_fields intel_th_device_add_resources fndecl 3 45615 NULL
+crtc_vblank_end_drm_display_mode_45620_fields crtc_vblank_end drm_display_mode 0 45620 NULL
+image_size_nvbios_npdeT_45624_fields image_size nvbios_npdeT 0 45624 NULL
+ext4_mb_init_group_fndecl_45626_fields ext4_mb_init_group fndecl 0 45626 NULL
+blocknr_disk_index_entry_45635_fields blocknr disk_index_entry 0 45635 NULL
+advmss_tcp_sock_45637_fields advmss tcp_sock 0 45637 NULL nohasharray
+btrfs_bio_alloc_fndecl_45637_fields btrfs_bio_alloc fndecl 2-3 45637 &advmss_tcp_sock_45637_fields nohasharray
+ifalias_store_fndecl_45637_fields ifalias_store fndecl 4 45637 &btrfs_bio_alloc_fndecl_45637_fields
+tcfv_push_vid_tcf_vlan_45639_fields tcfv_push_vid tcf_vlan 0 45639 NULL
+ecc_strength_ds_nand_chip_45651_fields ecc_strength_ds nand_chip 0 45651 NULL
+inftl_writeblock_fndecl_45653_fields inftl_writeblock fndecl 2 45653 NULL
+size_core_name_45656_fields size core_name 0 45656 NULL
+b_public_size_kpp_testvec_45660_fields b_public_size kpp_testvec 0 45660 NULL
+blockmask_alauda_media_info_45662_fields blockmask alauda_media_info 0 45662 NULL
+dmi_base_vardecl_dmi_scan_c_45673_fields dmi_base vardecl_dmi_scan.c 0 45673 NULL
+_snd_pcm_hw_param_min_fndecl_45677_fields _snd_pcm_hw_param_min fndecl 3 45677 NULL
+ocfs2_get_sector_fndecl_45678_fields ocfs2_get_sector fndecl 4-3 45678 NULL
+ib_umem_odp_map_dma_pages_fndecl_45679_fields ib_umem_odp_map_dma_pages fndecl 0-2 45679 NULL nohasharray
+lhead_offs_ubifs_info_45679_fields lhead_offs ubifs_info 0 45679 &ib_umem_odp_map_dma_pages_fndecl_45679_fields
+hfsplus_getxattr_finder_info_fndecl_45680_fields hfsplus_getxattr_finder_info fndecl 0 45680 NULL
+src_y_yuv_frame_info_45681_fields src_y yuv_frame_info 0 45681 NULL
+endpt_ubifs_unclean_leb_45692_fields endpt ubifs_unclean_leb 0 45692 NULL
+shift_badblocks_45703_fields shift badblocks 0 45703 NULL
+offset_ixgbe_ring_feature_45704_fields offset ixgbe_ring_feature 0 45704 NULL
+data_transfer_length_hpt_iop_request_get_config_45705_fields data_transfer_length hpt_iop_request_get_config 0 45705 NULL
+do_splice_direct_fndecl_45710_fields do_splice_direct fndecl 0-5 45710 NULL nohasharray
+fi_nblocks_nilfs_finfo_45710_fields fi_nblocks nilfs_finfo 0 45710 &do_splice_direct_fndecl_45710_fields
+st5481_setup_isocpipes_fndecl_45711_fields st5481_setup_isocpipes fndecl 4 45711 NULL
+width_cx23885_dev_45714_fields width cx23885_dev 0 45714 NULL
+ocfs2_xattr_set_fndecl_45720_fields ocfs2_xattr_set fndecl 5 45720 NULL
+num_cqs_mlx4_caps_45727_fields num_cqs mlx4_caps 0 45727 NULL
+len_bnx2x_fw_file_section_45732_fields len bnx2x_fw_file_section 0 45732 NULL
+sys_ptrace_fndecl_45738_fields sys_ptrace fndecl 3 45738 NULL
+get_args_iw_priv_args_45748_fields get_args iw_priv_args 0 45748 NULL
+vslen_vardecl_matroxfb_base_c_45755_fields vslen vardecl_matroxfb_base.c 0 45755 NULL
+extra_postfix_len_ieee80211_crypto_ops_45763_fields extra_postfix_len ieee80211_crypto_ops 0 45763 NULL
+size_entry_mwt_fndecl_45771_fields size_entry_mwt fndecl 0 45771 NULL nohasharray
+cc2520_write_txfifo_fndecl_45771_fields cc2520_write_txfifo fndecl 4 45771 &size_entry_mwt_fndecl_45771_fields
+set_acoustic_fndecl_45772_fields set_acoustic fndecl 2 45772 NULL
+len_ch_mem_range_45781_fields len ch_mem_range 0 45781 NULL
+ath6kl_wmi_set_htcap_cmd_fndecl_45784_fields ath6kl_wmi_set_htcap_cmd fndecl 2 45784 NULL
+change_xattr_fndecl_45789_fields change_xattr fndecl 5 45789 NULL
+stripe_size_nvme_ctrl_45800_fields stripe_size nvme_ctrl 0 45800 NULL
+i2c_r_fndecl_45804_fields i2c_r fndecl 0 45804 NULL
+h_suballoc_loc_ocfs2_extent_block_45805_fields h_suballoc_loc ocfs2_extent_block 0 45805 NULL
+sdebug_dev_size_mb_vardecl_scsi_debug_c_45811_fields sdebug_dev_size_mb vardecl_scsi_debug.c 0 45811 NULL
+max_node_size_pnp_dev_node_info_45813_fields max_node_size pnp_dev_node_info 0 45813 NULL
+msg_init_fndecl_45825_fields msg_init fndecl 4 45825 NULL nohasharray
+hfi1_max_srq_sges_vardecl_45825_fields hfi1_max_srq_sges vardecl 0 45825 &msg_init_fndecl_45825_fields
+tx_cmd_ep_usb_card_rec_45833_fields tx_cmd_ep usb_card_rec 0 45833 NULL
+max_channels_evtchn_ops_45841_fields max_channels evtchn_ops 0 45841 NULL
+width_zr364xx_camera_45844_fields width zr364xx_camera 0 45844 NULL nohasharray
+mwifiex_cfg80211_assoc_fndecl_45844_fields mwifiex_cfg80211_assoc fndecl 2 45844 &width_zr364xx_camera_45844_fields
+sys_mlock_fndecl_45847_fields sys_mlock fndecl 1-2 45847 NULL
+xfs_rtallocate_extent_size_fndecl_45848_fields xfs_rtallocate_extent_size fndecl 4-8-0 45848 NULL
+page_add_new_anon_rmap_fndecl_45850_fields page_add_new_anon_rmap fndecl 3 45850 NULL
+dio_complete_fndecl_45853_fields dio_complete fndecl 0-2 45853 NULL
+num_wsm_udp_port_filter_hdr_45858_fields num wsm_udp_port_filter_hdr 0 45858 NULL
+st21nfca_hci_dm_put_data_fndecl_45859_fields st21nfca_hci_dm_put_data fndecl 3 45859 NULL nohasharray
+data_used_cx18_mdl_ack_45859_fields data_used cx18_mdl_ack 0 45859 &st21nfca_hci_dm_put_data_fndecl_45859_fields
+pipe_interrupt_rtl8xxxu_priv_45862_fields pipe_interrupt rtl8xxxu_priv 0 45862 NULL
+net_header_len_inet_connection_sock_af_ops_45863_fields net_header_len inet_connection_sock_af_ops 0 45863 NULL
+xfrm_nr_xfrm_policy_45865_fields xfrm_nr xfrm_policy 0 45865 NULL
+lkey_table_size_rvt_driver_params_45866_fields lkey_table_size rvt_driver_params 0 45866 NULL
+parity_ore_layout_45869_fields parity ore_layout 0 45869 NULL
+aead_sendpage_fndecl_45873_fields aead_sendpage fndecl 4-3 45873 NULL
+ext4_es_remove_extent_fndecl_45877_fields ext4_es_remove_extent fndecl 3-2 45877 NULL
+quality_v4l2_jpegcompression_45881_fields quality v4l2_jpegcompression 0 45881 NULL
+max_buffer_sectors_vardecl_floppy_c_45884_fields max_buffer_sectors vardecl_floppy.c 0 45884 NULL
+index_cnt_btrfs_inode_45890_fields index_cnt btrfs_inode 0 45890 NULL
+__absent_pages_in_range_fndecl_45892_fields __absent_pages_in_range fndecl 0-2-3 45892 NULL nohasharray
+map_target_type_45892_fields map target_type 0 45892 &__absent_pages_in_range_fndecl_45892_fields
+lldd_write_gpio_sas_domain_function_template_45895_fields lldd_write_gpio sas_domain_function_template 0 45895 NULL
+bLength_usb_descriptor_header_45904_fields bLength usb_descriptor_header 0 45904 NULL
+jhead_cnt_ubifs_info_45905_fields jhead_cnt ubifs_info 0 45905 NULL
+vce_v1_0_bo_size_fndecl_45909_fields vce_v1_0_bo_size fndecl 0 45909 NULL
+bg_itable_unused_hi_ext4_group_desc_45918_fields bg_itable_unused_hi ext4_group_desc 0 45918 NULL
+wl1271_tx_allocate_fndecl_45921_fields wl1271_tx_allocate fndecl 4 45921 NULL
+mru_asyncppp_45929_fields mru asyncppp 0 45929 NULL
+base_i40iw_hmc_obj_info_45931_fields base i40iw_hmc_obj_info 0 45931 NULL
+fan_count_applesmc_registers_45934_fields fan_count applesmc_registers 0 45934 NULL
+num_ports_pciserial_board_45938_fields num_ports pciserial_board 0 45938 NULL
+sdhci_pltfm_register_fndecl_45940_fields sdhci_pltfm_register fndecl 3 45940 NULL
+ath6kl_wmi_setpmkid_cmd_fndecl_45949_fields ath6kl_wmi_setpmkid_cmd fndecl 2 45949 NULL nohasharray
+num_vfs_be_pcie_res_desc_45949_fields num_vfs be_pcie_res_desc 0 45949 &ath6kl_wmi_setpmkid_cmd_fndecl_45949_fields nohasharray
+smbus_base_vardecl_i2c_sis630_c_45949_fields smbus_base vardecl_i2c-sis630.c 0 45949 &num_vfs_be_pcie_res_desc_45949_fields
+fraglen_decryptor_desc_45950_fields fraglen decryptor_desc 0 45950 NULL
+max_sge_ib_srq_attr_45956_fields max_sge ib_srq_attr 0 45956 NULL
+len_ippp_buf_queue_45969_fields len ippp_buf_queue 0 45969 NULL nohasharray
+alpha_illinois_45969_fields alpha illinois 0 45969 &len_ippp_buf_queue_45969_fields
+ext_tree_split_fndecl_45973_fields ext_tree_split fndecl 3 45973 NULL
+addr_rrpc_rev_addr_45978_fields addr rrpc_rev_addr 0 45978 NULL
+target_size_ebt_entry_target_45980_fields target_size ebt_entry_target 0 45980 NULL nohasharray
+dbdma_cmd_yellowfin_desc_45980_fields dbdma_cmd yellowfin_desc 0 45980 &target_size_ebt_entry_target_45980_fields nohasharray
+tcp_lp_cong_avoid_fndecl_45980_fields tcp_lp_cong_avoid fndecl 3 45980 &dbdma_cmd_yellowfin_desc_45980_fields
+i40e_calculate_l2fpm_size_fndecl_45987_fields i40e_calculate_l2fpm_size fndecl 0-1-2-3-4 45987 NULL
+up_fnode_45991_fields up fnode 0 45991 NULL nohasharray
+lancer_cmd_get_file_len_fndecl_45991_fields lancer_cmd_get_file_len fndecl 0 45991 &up_fnode_45991_fields
+alloc_chrdev_region_fndecl_45995_fields alloc_chrdev_region fndecl 0 45995 NULL
+num_total_dacs_snd_ice1712_45997_fields num_total_dacs snd_ice1712 0 45997 NULL
+finish_request_fndecl_46010_fields finish_request fndecl 5 46010 NULL
+pcs_duplex_stmmac_extra_stats_46013_fields pcs_duplex stmmac_extra_stats 0 46013 NULL
+afs_proc_cells_write_fndecl_46016_fields afs_proc_cells_write fndecl 3 46016 NULL
+latency_st33zp24_spi_phy_46028_fields latency st33zp24_spi_phy 0 46028 NULL
+acl_mtu_hci_dev_46038_fields acl_mtu hci_dev 0 46038 NULL
+dma_size_qlcnic_host_rds_ring_46045_fields dma_size qlcnic_host_rds_ring 0 46045 NULL
+log_ind_tbl_size_ib_uverbs_ex_create_rwq_ind_table_46051_fields log_ind_tbl_size ib_uverbs_ex_create_rwq_ind_table 0 46051 NULL
+pair_device_fndecl_46052_fields pair_device fndecl 4 46052 NULL nohasharray
+num_wsm_mib_beacon_filter_table_46052_fields num wsm_mib_beacon_filter_table 0 46052 &pair_device_fndecl_46052_fields
+sisfb_parm_mem_sis_video_info_46063_fields sisfb_parm_mem sis_video_info 0 46063 NULL nohasharray
+get_tx_data_len_rt2x00lib_ops_46063_fields get_tx_data_len rt2x00lib_ops 0 46063 &sisfb_parm_mem_sis_video_info_46063_fields
+s_start_bfs_super_block_46064_fields s_start bfs_super_block 0 46064 NULL nohasharray
+MaxBurstLength_iscsi_sess_ops_46064_fields MaxBurstLength iscsi_sess_ops 0 46064 &s_start_bfs_super_block_46064_fields
+seg_count_drm_buf_entry_46065_fields seg_count drm_buf_entry 0 46065 NULL
+FirstPhysicalEUN_NFTLMediaHeader_46068_fields FirstPhysicalEUN NFTLMediaHeader 0 46068 NULL
+ext4_ext_determine_hole_fndecl_46073_fields ext4_ext_determine_hole fndecl 0 46073 NULL
+__devcgroup_check_permission_fndecl_46082_fields __devcgroup_check_permission fndecl 0 46082 NULL
+wSamplesPerFrame_uac_format_type_ii_ext_descriptor_46084_fields wSamplesPerFrame uac_format_type_ii_ext_descriptor 0 46084 NULL
+dm_startblk_adfs_discmap_46088_fields dm_startblk adfs_discmap 0 46088 NULL
+num_type_reg_regmap_irq_chip_46090_fields num_type_reg regmap_irq_chip 0 46090 NULL
+nr_pages_splice_pipe_desc_46095_fields nr_pages splice_pipe_desc 0 46095 NULL
+len_sfi_table_header_46097_fields len sfi_table_header 0 46097 NULL
+jbd2_journal_write_metadata_buffer_fndecl_46103_fields jbd2_journal_write_metadata_buffer fndecl 4 46103 NULL nohasharray
+control_write_fndecl_46103_fields control_write fndecl 6 46103 &jbd2_journal_write_metadata_buffer_fndecl_46103_fields nohasharray
+ym_wmfw_adsp2_alg_hdr_46103_fields ym wmfw_adsp2_alg_hdr 0 46103 &control_write_fndecl_46103_fields
+bs_vardecl_null_blk_c_46104_fields bs vardecl_null_blk.c 0 46104 NULL
+ax88179_write_cmd_fndecl_46110_fields ax88179_write_cmd fndecl 5 46110 NULL
+len_eeprom_private_46124_fields len eeprom_private 0 46124 NULL
+height_saa7134_dev_46126_fields height saa7134_dev 0 46126 NULL nohasharray
+tx_totallen_ncp_request_reply_46126_fields tx_totallen ncp_request_reply 0 46126 &height_saa7134_dev_46126_fields
+get_mctgt_type_fndecl_46128_fields get_mctgt_type fndecl 2 46128 NULL nohasharray
+len_cp_header_46128_fields len cp_header 0 46128 &get_mctgt_type_fndecl_46128_fields
+sriov_enable_fndecl_46138_fields sriov_enable fndecl 2 46138 NULL
+memblock_alloc_range_nid_fndecl_46147_fields memblock_alloc_range_nid fndecl 2-3-4 46147 NULL nohasharray
+next_read_size_fdp_i2c_phy_46147_fields next_read_size fdp_i2c_phy 0 46147 &memblock_alloc_range_nid_fndecl_46147_fields
+transfer_len_xhci_transfer_event_46161_fields transfer_len xhci_transfer_event 0 46161 NULL
+key_size_ecryptfs_private_key_46181_fields key_size ecryptfs_private_key 0 46181 NULL
+mlock_fixup_fndecl_46182_fields mlock_fixup fndecl 4-3 46182 NULL
+ib_alloc_cq_fndecl_46188_fields ib_alloc_cq fndecl 3 46188 NULL
+fuse_file_llseek_fndecl_46193_fields fuse_file_llseek fndecl 2 46193 NULL nohasharray
+size_aper_size_info_32_46193_fields size aper_size_info_32 0 46193 &fuse_file_llseek_fndecl_46193_fields
+length_usb_iso_packet_descriptor_46197_fields length usb_iso_packet_descriptor 0 46197 NULL
+sctp_manip_pkt_fndecl_46198_fields sctp_manip_pkt fndecl 4 46198 NULL
+musb_readb_vardecl_46199_fields musb_readb vardecl 0 46199 NULL nohasharray
+snd_interval_refine_set_fndecl_46199_fields snd_interval_refine_set fndecl 2 46199 &musb_readb_vardecl_46199_fields
+efx_rx_packet_gro_fndecl_46201_fields efx_rx_packet_gro fndecl 3 46201 NULL
+count_raw_sock_46204_fields count raw_sock 0 46204 NULL
+hdrlen_ip_beet_phdr_46210_fields hdrlen ip_beet_phdr 0 46210 NULL nohasharray
+sync_request_md_personality_46210_fields sync_request md_personality 0 46210 &hdrlen_ip_beet_phdr_46210_fields
+assocresp_ies_len_cfg80211_beacon_data_46212_fields assocresp_ies_len cfg80211_beacon_data 0 46212 NULL
+unuse_pte_fndecl_46217_fields unuse_pte fndecl 3 46217 NULL
+cob_size_savagefb_par_46219_fields cob_size savagefb_par 0 46219 NULL
+ipw_write_fndecl_46220_fields ipw_write fndecl 3 46220 NULL
+bLength_usb_interface_assoc_descriptor_46229_fields bLength usb_interface_assoc_descriptor 0 46229 NULL
+mei_nfc_recv_fndecl_46235_fields mei_nfc_recv fndecl 0-3 46235 NULL
+rsn_ie_len_libipw_network_46238_fields rsn_ie_len libipw_network 0 46238 NULL nohasharray
+xlog_do_recover_fndecl_46238_fields xlog_do_recover fndecl 3 46238 &rsn_ie_len_libipw_network_46238_fields
+node_acl_size_target_core_fabric_ops_46247_fields node_acl_size target_core_fabric_ops 0 46247 NULL
+erst_clear_fndecl_46248_fields erst_clear fndecl 1 46248 NULL
+proc_pid_cmdline_read_fndecl_46249_fields proc_pid_cmdline_read fndecl 3 46249 NULL
+extra_beacon_tailroom_ieee80211_hw_46256_fields extra_beacon_tailroom ieee80211_hw 0 46256 NULL
+nf_ct_helper_init_fndecl_46259_fields nf_ct_helper_init fndecl 10 46259 NULL
+rocker_port_change_mtu_fndecl_46262_fields rocker_port_change_mtu fndecl 2 46262 NULL nohasharray
+len_ath10k_fw_ie_46262_fields len ath10k_fw_ie 0 46262 &rocker_port_change_mtu_fndecl_46262_fields
+size_xenvif_rx_meta_46270_fields size xenvif_rx_meta 0 46270 NULL
+sq_size_i40iw_qp_uk_46272_fields sq_size i40iw_qp_uk 0 46272 NULL
+onenand_read_oob_fndecl_46274_fields onenand_read_oob fndecl 2 46274 NULL
+smem_len_iwl_cfg_46276_fields smem_len iwl_cfg 0 46276 NULL
+desc_nr_md_rdev_46281_fields desc_nr md_rdev 0 46281 NULL
+xi_value_len_ocfs2_xattr_info_46285_fields xi_value_len ocfs2_xattr_info 0 46285 NULL
+dq_local_phys_blk_ocfs2_dquot_46292_fields dq_local_phys_blk ocfs2_dquot 0 46292 NULL
+len_nfs3_setaclargs_46293_fields len nfs3_setaclargs 0 46293 NULL
+tx_data_size_ircomm_tty_cb_46294_fields tx_data_size ircomm_tty_cb 0 46294 NULL
+omfs_allocate_block_fndecl_46295_fields omfs_allocate_block fndecl 2 46295 NULL
+status2_ar9003_rxs_46299_fields status2 ar9003_rxs 0 46299 NULL
+capture_snd_soc_tplg_pcm_46306_fields capture snd_soc_tplg_pcm 0 46306 NULL
+offset_nfsd3_readargs_46311_fields offset nfsd3_readargs 0 46311 NULL
+g_size_dh_46316_fields g_size dh 0 46316 NULL
+num_vci_lanai_dev_46318_fields num_vci lanai_dev 0 46318 NULL
+unit_qib_devdata_46325_fields unit qib_devdata 0 46325 NULL nohasharray
+biovec_create_pool_fndecl_46325_fields biovec_create_pool fndecl 1 46325 &unit_qib_devdata_46325_fields
+i_size_inode_46327_fields i_size inode 0 46327 NULL
+pvr2_ioread_set_sync_key_fndecl_46329_fields pvr2_ioread_set_sync_key fndecl 3 46329 NULL
+__ieee80211_amsdu_copy_frag_fndecl_46332_fields __ieee80211_amsdu_copy_frag fndecl 4-3 46332 NULL
+shmem_zero_setup_fndecl_46334_fields shmem_zero_setup fndecl 0 46334 NULL
+mwifiex_cfg80211_tdls_mgmt_fndecl_46335_fields mwifiex_cfg80211_tdls_mgmt fndecl 10 46335 NULL
+stv6110_read_regs_fndecl_46339_fields stv6110_read_regs fndecl 4 46339 NULL
+af9013_rd_regs_i2c_fndecl_46343_fields af9013_rd_regs_i2c fndecl 5 46343 NULL
+recently_deleted_fndecl_46346_fields recently_deleted fndecl 3 46346 NULL
+zoran_v4l_set_format_fndecl_46347_fields zoran_v4l_set_format fndecl 3-2 46347 NULL
+fc_frame_alloc_fill_fndecl_46353_fields fc_frame_alloc_fill fndecl 2 46353 NULL
+nid_f2fs_summary_46354_fields nid f2fs_summary 0 46354 NULL
+dvb_ep_isoc_em28xx_46357_fields dvb_ep_isoc em28xx 0 46357 NULL
+chv_get_stolen_size_fndecl_46362_fields chv_get_stolen_size fndecl 0-1 46362 NULL
+max_write_size_ubifs_info_46369_fields max_write_size ubifs_info 0 46369 NULL
+device_create_with_groups_fndecl_46371_fields device_create_with_groups fndecl 3 46371 NULL
+descriptor_loc_fndecl_46373_fields descriptor_loc fndecl 0-3-2 46373 NULL
+bnx2_change_mtu_fndecl_46374_fields bnx2_change_mtu fndecl 2 46374 NULL
+gb_vardecl_null_blk_c_46399_fields gb vardecl_null_blk.c 0 46399 NULL
+strength_nand_ecc_ctrl_46402_fields strength nand_ecc_ctrl 0 46402 NULL
+piosize4k_qib_devdata_46406_fields piosize4k qib_devdata 0 46406 NULL
+SavagePanelWidth_savagefb_par_46407_fields SavagePanelWidth savagefb_par 0 46407 NULL
+ie_len_cfg80211_ibss_params_46411_fields ie_len cfg80211_ibss_params 0 46411 NULL
+skb_maybe_pull_tail_fndecl_46422_fields skb_maybe_pull_tail fndecl 3 46422 NULL
+proberesp_ies_len_cfg80211_beacon_data_46424_fields proberesp_ies_len cfg80211_beacon_data 0 46424 NULL
+rds_pin_pages_fndecl_46432_fields rds_pin_pages fndecl 1 46432 NULL
+st21nfca_hci_dep_link_up_fndecl_46438_fields st21nfca_hci_dep_link_up fndecl 5 46438 NULL nohasharray
+qib_dev_vardecl_qib_file_ops_c_46438_fields qib_dev vardecl_qib_file_ops.c 0 46438 &st21nfca_hci_dep_link_up_fndecl_46438_fields
+vid_bridge_vlan_info_46442_fields vid bridge_vlan_info 0 46442 NULL nohasharray
+len_acm_wb_46442_fields len acm_wb 0 46442 &vid_bridge_vlan_info_46442_fields nohasharray
+nframes_gspca_dev_46442_fields nframes gspca_dev 0 46442 &len_acm_wb_46442_fields
+btrfsic_process_superblock_dev_mirror_fndecl_46444_fields btrfsic_process_superblock_dev_mirror fndecl 4 46444 NULL nohasharray
+iblock_execute_unmap_fndecl_46444_fields iblock_execute_unmap fndecl 3-2 46444 &btrfsic_process_superblock_dev_mirror_fndecl_46444_fields
+fb_base_phys_mb862xxfb_par_46449_fields fb_base_phys mb862xxfb_par 0 46449 NULL
+snd_seq_oss_writeq_new_fndecl_46455_fields snd_seq_oss_writeq_new fndecl 2 46455 NULL
+get_znode_fndecl_46463_fields get_znode fndecl 3 46463 NULL
+ssid_len_hfa384x_hostscan_result_46466_fields ssid_len hfa384x_hostscan_result 0 46466 NULL
+ext4_resize_fs_fndecl_46468_fields ext4_resize_fs fndecl 2 46468 NULL
+hpfs_add_de_fndecl_46472_fields hpfs_add_de fndecl 4 46472 NULL
+idr_alloc_fndecl_46474_fields idr_alloc fndecl 0 46474 NULL
+nla_put_nohdr_fndecl_46479_fields nla_put_nohdr fndecl 2 46479 NULL
+ro_slot_rcom_slot_46481_fields ro_slot rcom_slot 0 46481 NULL
+ssid_len_ieee80211_bss_conf_46483_fields ssid_len ieee80211_bss_conf 0 46483 NULL
+xen_early_virt_to_phys_fndecl_46486_fields xen_early_virt_to_phys fndecl 0 46486 NULL
+usb_wwan_write_fndecl_46494_fields usb_wwan_write fndecl 4 46494 NULL
+__copy_from_user_ll_nozero_fndecl_46496_fields __copy_from_user_ll_nozero fndecl 0 46496 NULL
+iram_size_sst_res_info_46499_fields iram_size sst_res_info 0 46499 NULL
+align_ieee80211_vendor_radiotap_46503_fields align ieee80211_vendor_radiotap 0 46503 NULL
+append_elf_note_fndecl_46508_fields append_elf_note fndecl 5 46508 NULL nohasharray
+write_pbl_fndecl_46508_fields write_pbl fndecl 4 46508 &append_elf_note_fndecl_46508_fields
+pagesz_cifs_readdata_46514_fields pagesz cifs_readdata 0 46514 NULL
+test_btrfs_get_extent_fndecl_46516_fields test_btrfs_get_extent fndecl 1-2 46516 NULL
+free_bootmem_with_active_regions_fndecl_46521_fields free_bootmem_with_active_regions fndecl 2 46521 NULL
+bio_split_fndecl_46527_fields bio_split fndecl 2 46527 NULL
+sddr09_request_sense_fndecl_46529_fields sddr09_request_sense fndecl 3 46529 NULL
+dr_suballoc_loc_ocfs2_dx_root_block_46531_fields dr_suballoc_loc ocfs2_dx_root_block 0 46531 NULL
+fcoe_ctlr_vn_send_fndecl_46532_fields fcoe_ctlr_vn_send fndecl 4 46532 NULL
+bNrChannels_uac_format_type_i_continuous_descriptor_46536_fields bNrChannels uac_format_type_i_continuous_descriptor 0 46536 NULL
+contrast_sd_gl860_46538_fields contrast sd_gl860 0 46538 NULL
+size_kstat_46541_fields size kstat 0 46541 NULL
+resp_write_same_fndecl_46544_fields resp_write_same fndecl 2 46544 NULL
+sc18is602_check_transfer_fndecl_46545_fields sc18is602_check_transfer fndecl 0 46545 NULL
+seq_open_tab_fndecl_46562_fields seq_open_tab fndecl 3-2 46562 NULL
+erasesize_shift_mtd_info_46565_fields erasesize_shift mtd_info 0 46565 NULL nohasharray
+xt_compat_init_offsets_fndecl_46565_fields xt_compat_init_offsets fndecl 2 46565 &erasesize_shift_mtd_info_46565_fields
+max_msix_vectors_vardecl_mpt3sas_base_c_46566_fields max_msix_vectors vardecl_mpt3sas_base.c 0 46566 NULL
+ndivs_divs_data_46571_fields ndivs divs_data 0 46571 NULL
+xfs_trans_log_finish_rmap_update_fndecl_46574_fields xfs_trans_log_finish_rmap_update fndecl 7 46574 NULL
+sock_sendpage_fndecl_46581_fields sock_sendpage fndecl 4 46581 NULL
+back_xfs_attr3_icleaf_hdr_46595_fields back xfs_attr3_icleaf_hdr 0 46595 NULL
+fuse_async_req_send_fndecl_46596_fields fuse_async_req_send fndecl 0-3 46596 NULL nohasharray
+mmc_do_calc_max_discard_fndecl_46596_fields mmc_do_calc_max_discard fndecl 0 46596 &fuse_async_req_send_fndecl_46596_fields
+it87_device_add_fndecl_46597_fields it87_device_add fndecl 2 46597 NULL
+cfpkt_extr_head_fndecl_46598_fields cfpkt_extr_head fndecl 3 46598 NULL
+nfp_net_msix_alloc_fndecl_46607_fields nfp_net_msix_alloc fndecl 0 46607 NULL
+pci_scan_bridge_fndecl_46615_fields pci_scan_bridge fndecl 3-0 46615 NULL
+snd_usb_parse_datainterval_fndecl_46616_fields snd_usb_parse_datainterval fndecl 0 46616 NULL nohasharray
+sizeof_idt_fndecl_46616_fields sizeof_idt fndecl 0 46616 &snd_usb_parse_datainterval_fndecl_46616_fields
+fw_cdev_major_vardecl_46618_fields fw_cdev_major vardecl 0 46618 NULL
+num_ppns_qp_guest_endpoint_46623_fields num_ppns qp_guest_endpoint 0 46623 NULL nohasharray
+usbvision_read_reg_fndecl_46623_fields usbvision_read_reg fndecl 0 46623 &num_ppns_qp_guest_endpoint_46623_fields
+cl_maxproc_rpc_clnt_46627_fields cl_maxproc rpc_clnt 0 46627 NULL
+start_ipack_region_46628_fields start ipack_region 0 46628 NULL
+qlcnic_83xx_diag_free_res_fndecl_46632_fields qlcnic_83xx_diag_free_res fndecl 2 46632 NULL
+snd_cwnd_cnt_tcp_sock_46635_fields snd_cwnd_cnt tcp_sock 0 46635 NULL nohasharray
+ccp_queue_buf_fndecl_46635_fields ccp_queue_buf fndecl 0 46635 &snd_cwnd_cnt_tcp_sock_46635_fields
+data_offset_iscsi_tcp_task_46641_fields data_offset iscsi_tcp_task 0 46641 NULL
+ib_send_cm_mra_fndecl_46649_fields ib_send_cm_mra fndecl 4 46649 NULL
+mwifiex_set_wps_ie_fndecl_46650_fields mwifiex_set_wps_ie fndecl 3 46650 NULL
+transfer_buffer_length_usbip_header_cmd_submit_46658_fields transfer_buffer_length usbip_header_cmd_submit 0 46658 NULL
+btrfs_get_extent_fiemap_fndecl_46659_fields btrfs_get_extent_fiemap fndecl 5-4-3 46659 NULL
+bmap_fndecl_46663_fields bmap fndecl 0 46663 NULL
+physical_block_size_queue_limits_46666_fields physical_block_size queue_limits 0 46666 NULL
+mpx_notify_unmap_fndecl_46669_fields mpx_notify_unmap fndecl 3-4 46669 NULL
+xfs_difree_inode_chunk_fndecl_46677_fields xfs_difree_inode_chunk fndecl 2 46677 NULL
+max_wr_ib_srq_attr_46680_fields max_wr ib_srq_attr 0 46680 NULL
+usb_ftdi_elan_edset_input_fndecl_46689_fields usb_ftdi_elan_edset_input fndecl 0 46689 NULL
+__pskb_pull_tail_fndecl_46700_fields __pskb_pull_tail fndecl 2 46700 NULL
+rxe_mem_init_user_fndecl_46710_fields rxe_mem_init_user fndecl 3-4 46710 NULL
+cmsg_len_cmsghdr_46711_fields cmsg_len cmsghdr 0 46711 NULL
+length_ib_mr_46713_fields length ib_mr 0 46713 NULL nohasharray
+extra_priv_size_ehci_driver_overrides_46713_fields extra_priv_size ehci_driver_overrides 0 46713 &length_ib_mr_46713_fields
+length_page_collect_46716_fields length page_collect 0 46716 NULL
+peer_max_bio_size_drbd_device_46722_fields peer_max_bio_size drbd_device 0 46722 NULL
+first_ino_xfs_icluster_46725_fields first_ino xfs_icluster 0 46725 NULL
+virtio_gpu_cmd_resource_attach_backing_fndecl_46726_fields virtio_gpu_cmd_resource_attach_backing fndecl 4 46726 NULL
+iwlagn_tx_agg_stop_fndecl_46756_fields iwlagn_tx_agg_stop fndecl 4 46756 NULL
+count_nfs_readdirargs_46759_fields count nfs_readdirargs 0 46759 NULL
+perf_aux_output_skip_fndecl_46762_fields perf_aux_output_skip fndecl 2 46762 NULL
+mlx5_ib_umem_get_fndecl_46768_fields mlx5_ib_umem_get fndecl 3-4 46768 NULL
+s_bshift_ufs_sb_private_info_46773_fields s_bshift ufs_sb_private_info 0 46773 NULL nohasharray
+target_begin_dm_region_hash_46773_fields target_begin dm_region_hash 0 46773 &s_bshift_ufs_sb_private_info_46773_fields
+acpi_aml_lock_write_fndecl_46777_fields acpi_aml_lock_write fndecl 0 46777 NULL
+rq_size_i40iw_qp_uk_46792_fields rq_size i40iw_qp_uk 0 46792 NULL nohasharray
+ubi_eba_atomic_leb_change_fndecl_46792_fields ubi_eba_atomic_leb_change fndecl 5 46792 &rq_size_i40iw_qp_uk_46792_fields
+brcmf_usb_rx_ctlpkt_fndecl_46799_fields brcmf_usb_rx_ctlpkt fndecl 3 46799 NULL
+ceph_msg_data_bio_advance_fndecl_46804_fields ceph_msg_data_bio_advance fndecl 2 46804 NULL
+mlx4_en_change_mtu_fndecl_46805_fields mlx4_en_change_mtu fndecl 2 46805 NULL
+mesh_rx_csa_frame_fndecl_46810_fields mesh_rx_csa_frame fndecl 3 46810 NULL
+buffer_size_snd_rawmidi_params_46813_fields buffer_size snd_rawmidi_params 0 46813 NULL
+nfulnl_set_mode_fndecl_46818_fields nfulnl_set_mode fndecl 3 46818 NULL
+frame_size_ipw2100_status_46819_fields frame_size ipw2100_status 0 46819 NULL
+major_hwif_s_46820_fields major hwif_s 0 46820 NULL
+numberoflines_tmHWStreamParameters_46824_fields numberoflines tmHWStreamParameters 0 46824 NULL
+residue_c67x00_td_46828_fields residue c67x00_td 0 46828 NULL
+per_cpu_ptr_to_phys_fndecl_46833_fields per_cpu_ptr_to_phys fndecl 0 46833 NULL
+tid_limit_hfi1_filedata_46834_fields tid_limit hfi1_filedata 0 46834 NULL
+extra_priv_size_xhci_driver_overrides_46837_fields extra_priv_size xhci_driver_overrides 0 46837 NULL
+num_prior_parent_snaps_ceph_snap_realm_46841_fields num_prior_parent_snaps ceph_snap_realm 0 46841 NULL nohasharray
+mthca_alloc_resize_buf_fndecl_46841_fields mthca_alloc_resize_buf fndecl 3 46841 &num_prior_parent_snaps_ceph_snap_realm_46841_fields
+len_wl12xx_rx_filter_field_46843_fields len wl12xx_rx_filter_field 0 46843 NULL
+tveeprom_read_fndecl_46846_fields tveeprom_read fndecl 3 46846 NULL nohasharray
+vt596_smba_vardecl_i2c_viapro_c_46846_fields vt596_smba vardecl_i2c-viapro.c 0 46846 &tveeprom_read_fndecl_46846_fields
+__bread_gfp_fndecl_46858_fields __bread_gfp fndecl 3-2 46858 NULL
+xwrite_fndecl_46865_fields xwrite fndecl 3 46865 NULL
+nb_ace_lite_cci_nb_ports_46870_fields nb_ace_lite cci_nb_ports 0 46870 NULL
+len_nfsd3_readlinkres_46888_fields len nfsd3_readlinkres 0 46888 NULL
+buffer_size_snd_urb_ctx_46897_fields buffer_size snd_urb_ctx 0 46897 NULL
+cb_break_head_afs_server_46900_fields cb_break_head afs_server 0 46900 NULL
+ql_process_mac_rx_gro_page_fndecl_46902_fields ql_process_mac_rx_gro_page fndecl 4-5 46902 NULL
+size_vbt_r0_46913_fields size vbt_r0 0 46913 NULL
+num_sacks_tcp_options_received_46914_fields num_sacks tcp_options_received 0 46914 NULL nohasharray
+mmc_queue_packed_map_sg_fndecl_46914_fields mmc_queue_packed_map_sg fndecl 0 46914 &num_sacks_tcp_options_received_46914_fields
+rd_size_hidp_connadd_req_46916_fields rd_size hidp_connadd_req 0 46916 NULL
+osd_req_read_kern_fndecl_46917_fields osd_req_read_kern fndecl 5 46917 NULL
+tot_len_ipv6_txoptions_46931_fields tot_len ipv6_txoptions 0 46931 NULL
+__free_pages_bootmem_fndecl_46937_fields __free_pages_bootmem fndecl 3 46937 NULL nohasharray
+squashfs_max_decompressors_fndecl_46937_fields squashfs_max_decompressors fndecl 0 46937 &__free_pages_bootmem_fndecl_46937_fields
+devblksize_squashfs_sb_info_46950_fields devblksize squashfs_sb_info 0 46950 NULL
+osd_req_list_dev_partitions_fndecl_46952_fields osd_req_list_dev_partitions fndecl 4 46952 NULL
+tx_ring_num_mlx4_en_priv_46953_fields tx_ring_num mlx4_en_priv 0 46953 NULL
+steer_qpn_count_mlx4_ib_dev_46957_fields steer_qpn_count mlx4_ib_dev 0 46957 NULL nohasharray
+xlog_bread_offset_fndecl_46957_fields xlog_bread_offset fndecl 2-3 46957 &steer_qpn_count_mlx4_ib_dev_46957_fields
+vmw_piter_start_fndecl_46964_fields vmw_piter_start fndecl 3 46964 NULL nohasharray
+cy_next_channel_vardecl_cyclades_c_46964_fields cy_next_channel vardecl_cyclades.c 0 46964 &vmw_piter_start_fndecl_46964_fields
+can_queue_Scsi_Host_46966_fields can_queue Scsi_Host 0 46966 NULL
+mthca_init_cq_fndecl_46968_fields mthca_init_cq fndecl 2 46968 NULL
+icv_len_ieee80211_fast_rx_46969_fields icv_len ieee80211_fast_rx 0 46969 NULL nohasharray
+fsl_spi_cpu_bufs_fndecl_46969_fields fsl_spi_cpu_bufs fndecl 3-0 46969 &icv_len_ieee80211_fast_rx_46969_fields
+vb2_dc_alloc_fndecl_46971_fields vb2_dc_alloc fndecl 3 46971 NULL
+register_device_fndecl_46972_fields register_device fndecl 3-2 46972 NULL
+f71882fg_find_fndecl_46975_fields f71882fg_find fndecl 0 46975 NULL
+size_dwc3_trb_46986_fields size dwc3_trb 0 46986 NULL
+ri_max_frmr_depth_rpcrdma_ia_46987_fields ri_max_frmr_depth rpcrdma_ia 0 46987 NULL nohasharray
+gru_alloc_gts_fndecl_46987_fields gru_alloc_gts fndecl 6 46987 &ri_max_frmr_depth_rpcrdma_ia_46987_fields
+tx_queue_size_pxa168_eth_platform_data_46988_fields tx_queue_size pxa168_eth_platform_data 0 46988 NULL
+msb_cache_write_fndecl_46992_fields msb_cache_write fndecl 6-2 46992 NULL
+lrg_buffer_len_ql3_adapter_46994_fields lrg_buffer_len ql3_adapter 0 46994 NULL
+buflen_cdrom_generic_command_47000_fields buflen cdrom_generic_command 0 47000 NULL
+no_seek_end_llseek_fndecl_47002_fields no_seek_end_llseek fndecl 2 47002 NULL
+do_ip6t_set_ctl_fndecl_47003_fields do_ip6t_set_ctl fndecl 4 47003 NULL
+n_input_formats_malidp_hw_regmap_47006_fields n_input_formats malidp_hw_regmap 0 47006 NULL
+va_start_vmap_area_47016_fields va_start vmap_area 0 47016 NULL nohasharray
+vmw_kms_update_proxy_fndecl_47016_fields vmw_kms_update_proxy fndecl 3 47016 &va_start_vmap_area_47016_fields
+bytesused_uvc_buffer_47017_fields bytesused uvc_buffer 0 47017 NULL
+length_ixgb_rx_desc_47027_fields length ixgb_rx_desc 0 47027 NULL
+npins_chv_community_47032_fields npins chv_community 0 47032 NULL
+desc_size_shdma_dev_47035_fields desc_size shdma_dev 0 47035 NULL
+xfs_fs_map_blocks_fndecl_47038_fields xfs_fs_map_blocks fndecl 2-3 47038 NULL nohasharray
+minor_index_cardstate_47038_fields minor_index cardstate 0 47038 &xfs_fs_map_blocks_fndecl_47038_fields
+ttm_bo_kmap_fndecl_47045_fields ttm_bo_kmap fndecl 3-2 47045 NULL
+icds_per_ctrl_hba_parameters_47047_fields icds_per_ctrl hba_parameters 0 47047 NULL
+amdgpu_drm_ioctl_fndecl_47050_fields amdgpu_drm_ioctl fndecl 2 47050 NULL
+width_tm6000_core_47057_fields width tm6000_core 0 47057 NULL nohasharray
+vbi_width_em28xx_v4l2_47057_fields vbi_width em28xx_v4l2 0 47057 &width_tm6000_core_47057_fields
+sect_ide_drive_s_47062_fields sect ide_drive_s 0 47062 NULL
+len_Vmxnet3_RxCompDesc_47066_fields len Vmxnet3_RxCompDesc 0 47066 NULL
+epnum_isp116x_ep_47082_fields epnum isp116x_ep 0 47082 NULL
+yres_fb_videomode_47087_fields yres fb_videomode 0 47087 NULL nohasharray
+authorizer_buf_len_ceph_auth_handshake_47087_fields authorizer_buf_len ceph_auth_handshake 0 47087 &yres_fb_videomode_47087_fields
+ext2_get_inode_fndecl_47089_fields ext2_get_inode fndecl 2 47089 NULL
+__send_empty_flush_fndecl_47094_fields __send_empty_flush fndecl 0 47094 NULL
+eeprom_93xx46_read_fndecl_47095_fields eeprom_93xx46_read fndecl 2-4 47095 NULL
+begin_dm_target_47098_fields begin dm_target 0 47098 NULL
+spu_wait_for_u16_fndecl_47101_fields spu_wait_for_u16 fndecl 0 47101 NULL
+len_wmi_rx_action_event_47102_fields len wmi_rx_action_event 0 47102 NULL
+cc2520_read_rxfifo_fndecl_47105_fields cc2520_read_rxfifo fndecl 3 47105 NULL
+agp_size_drm_mga_dma_bootstrap_47108_fields agp_size drm_mga_dma_bootstrap 0 47108 NULL
+num_mthca_resource_47114_fields num mthca_resource 0 47114 NULL
+nportcntrs_qib_chip_specific_47118_fields nportcntrs qib_chip_specific 0 47118 NULL
+j_len_reiserfs_journal_47121_fields j_len reiserfs_journal 0 47121 NULL
+filemap_fdatawrite_range_fndecl_47125_fields filemap_fdatawrite_range fndecl 2-3 47125 NULL
+efi_ioremap_fndecl_47129_fields efi_ioremap fndecl 2-1 47129 NULL
+target_xcopy_write_destination_fndecl_47134_fields target_xcopy_write_destination fndecl 5 47134 NULL
+st33zp24_spi_evaluate_latency_fndecl_47139_fields st33zp24_spi_evaluate_latency fndecl 0 47139 NULL
+data_len_nvme_passthru_cmd_47145_fields data_len nvme_passthru_cmd 0 47145 NULL
+iwl_trans_send_cmd_fndecl_47146_fields iwl_trans_send_cmd fndecl 0 47146 NULL
+do_otp_lock_fndecl_47148_fields do_otp_lock fndecl 3 47148 NULL
+vmw_kms_sou_readback_fndecl_47150_fields vmw_kms_sou_readback fndecl 6 47150 NULL nohasharray
+mcs7830_set_reg_async_fndecl_47150_fields mcs7830_set_reg_async fndecl 3 47150 &vmw_kms_sou_readback_fndecl_47150_fields
+ttm_dma_tt_init_fndecl_47159_fields ttm_dma_tt_init fndecl 3 47159 NULL nohasharray
+req_xfer_ide_atapi_pc_47159_fields req_xfer ide_atapi_pc 0 47159 &ttm_dma_tt_init_fndecl_47159_fields
+mlxsw_sx_port_change_mtu_fndecl_47160_fields mlxsw_sx_port_change_mtu fndecl 2 47160 NULL
+max_blk_size_mmc_host_47174_fields max_blk_size mmc_host 0 47174 NULL
+posix_lock_inode_fndecl_47190_fields posix_lock_inode fndecl 0 47190 NULL
+msix_count_qla_hw_data_47192_fields msix_count qla_hw_data 0 47192 NULL
+max_sq_sg_mlx4_caps_47193_fields max_sq_sg mlx4_caps 0 47193 NULL
+max_inline_data_ib_qp_cap_47196_fields max_inline_data ib_qp_cap 0 47196 NULL
+bi_phys_segments_bio_47200_fields bi_phys_segments bio 0 47200 NULL
+wpos_p9_conn_47212_fields wpos p9_conn 0 47212 NULL
+authsize_crypto_aead_47219_fields authsize crypto_aead 0 47219 NULL
+mwifiex_form_mgmt_frame_fndecl_47220_fields mwifiex_form_mgmt_frame fndecl 3 47220 NULL
+acpi_map_fndecl_47222_fields acpi_map fndecl 2-1 47222 NULL
+csum_exist_in_range_fndecl_47225_fields csum_exist_in_range fndecl 3-2 47225 NULL
+fuse_reverse_inval_inode_fndecl_47245_fields fuse_reverse_inval_inode fndecl 4-3 47245 NULL
+__do_config_autodelink_fndecl_47256_fields __do_config_autodelink fndecl 3 47256 NULL
+num_srqs_mthca_limits_47260_fields num_srqs mthca_limits 0 47260 NULL
+num_ifaces_batadv_priv_47263_fields num_ifaces batadv_priv 0 47263 NULL
+dm_get_blk_mq_queue_depth_fndecl_47265_fields dm_get_blk_mq_queue_depth fndecl 0 47265 NULL
+isku_sysfs_read_fndecl_47269_fields isku_sysfs_read fndecl 5 47269 NULL
+bts_buffer_setup_aux_fndecl_47274_fields bts_buffer_setup_aux fndecl 3 47274 NULL
+write_file_fndecl_47279_fields write_file fndecl 4 47279 NULL
+rom_size_qxl_device_47287_fields rom_size qxl_device 0 47287 NULL
+RequestSenseLength_DAC960_V2_UserCommand_47289_fields RequestSenseLength DAC960_V2_UserCommand 0 47289 NULL nohasharray
+__wa_xfer_submit_fndecl_47289_fields __wa_xfer_submit fndecl 0 47289 &RequestSenseLength_DAC960_V2_UserCommand_47289_fields nohasharray
+ipx_sendmsg_fndecl_47289_fields ipx_sendmsg fndecl 3 47289 &__wa_xfer_submit_fndecl_47289_fields
+sk_gso_max_segs_sock_47290_fields sk_gso_max_segs sock 0 47290 NULL
+dev_number_mdp_superblock_1_47292_fields dev_number mdp_superblock_1 0 47292 NULL
+pppol2tp_recvmsg_fndecl_47301_fields pppol2tp_recvmsg fndecl 3 47301 NULL
+bigdirsize_adfs_bigdirheader_47315_fields bigdirsize adfs_bigdirheader 0 47315 NULL
+special_e1000_rx_desc_47320_fields special e1000_rx_desc 0 47320 NULL
+nr_pages_swap_extent_47325_fields nr_pages swap_extent 0 47325 NULL
+nr_pages_scif_window_47329_fields nr_pages scif_window 0 47329 NULL
+dma_buffer_size_vardecl_budget_core_c_47332_fields dma_buffer_size vardecl_budget-core.c 0 47332 NULL
+brcmf_chip_core_read32_fndecl_47346_fields brcmf_chip_core_read32 fndecl 0 47346 NULL
+__reserve_metadata_bytes_fndecl_47350_fields __reserve_metadata_bytes fndecl 0 47350 NULL
+myri10ge_change_mtu_fndecl_47351_fields myri10ge_change_mtu fndecl 2 47351 NULL nohasharray
+gtt_base_align_amdgpu_mc_47351_fields gtt_base_align amdgpu_mc 0 47351 &myri10ge_change_mtu_fndecl_47351_fields
+dmi_memdev_nr_vardecl_dmi_scan_c_47352_fields dmi_memdev_nr vardecl_dmi_scan.c 0 47352 NULL
+erasesize_mtd_info_47358_fields erasesize mtd_info 0 47358 NULL
+ath6kl_wmi_send_action_cmd_fndecl_47359_fields ath6kl_wmi_send_action_cmd fndecl 2 47359 NULL nohasharray
+altc_entry_sz_mlx4_dev_cap_47359_fields altc_entry_sz mlx4_dev_cap 0 47359 &ath6kl_wmi_send_action_cmd_fndecl_47359_fields
+ie_len_ieee80211_if_mesh_47360_fields ie_len ieee80211_if_mesh 0 47360 NULL nohasharray
+get_vaddr_frames_fndecl_47360_fields get_vaddr_frames fndecl 1 47360 &ie_len_ieee80211_if_mesh_47360_fields
+nr_sects_hd_struct_47364_fields nr_sects hd_struct 0 47364 NULL
+size_rsa_asn1_template_47369_fields size rsa_asn1_template 0 47369 NULL
+batadv_iv_ogm_aggregate_fndecl_47372_fields batadv_iv_ogm_aggregate fndecl 3 47372 NULL
+btt_data_read_fndecl_47374_fields btt_data_read fndecl 0 47374 NULL
+max_fibre_devices_qla_hw_data_47375_fields max_fibre_devices qla_hw_data 0 47375 NULL
+nilfs_bmap_convert_error_fndecl_47376_fields nilfs_bmap_convert_error fndecl 0-3 47376 NULL
+vmw_ttm_tt_create_fndecl_47378_fields vmw_ttm_tt_create fndecl 2 47378 NULL
+data_in_pipe_uas_dev_info_47380_fields data_in_pipe uas_dev_info 0 47380 NULL
+max_tx_length_macb_47385_fields max_tx_length macb 0 47385 NULL
+memblocks_max_vxge_hw_mempool_47387_fields memblocks_max vxge_hw_mempool 0 47387 NULL
+radix_tree_extend_fndecl_47392_fields radix_tree_extend fndecl 0-3 47392 NULL
+access_vm_operations_struct_47395_fields access vm_operations_struct 0 47395 NULL
+sr_bg_stable_blkno_ocfs2_suballoc_result_47398_fields sr_bg_stable_blkno ocfs2_suballoc_result 0 47398 NULL
+efd_start_cluster_ext4_free_data_47399_fields efd_start_cluster ext4_free_data 0 47399 NULL
+iscsi_offload_mesg_fndecl_47402_fields iscsi_offload_mesg fndecl 5 47402 NULL
+datalen_key_preparsed_payload_47406_fields datalen key_preparsed_payload 0 47406 NULL
+vmw_kms_generic_present_fndecl_47407_fields vmw_kms_generic_present fndecl 9 47407 NULL
+tp_len_tpacket_hdr_47410_fields tp_len tpacket_hdr 0 47410 NULL
+idetape_pad_zeros_fndecl_47413_fields idetape_pad_zeros fndecl 2 47413 NULL
+cdc_ncm_update_rxtx_max_fndecl_47421_fields cdc_ncm_update_rxtx_max fndecl 3-2 47421 NULL
+ctx_index_i915_guc_client_47425_fields ctx_index i915_guc_client 0 47425 NULL
+sinit_max_instreams_sctp_cookie_47433_fields sinit_max_instreams sctp_cookie 0 47433 NULL
+depth_bttv_format_47442_fields depth bttv_format 0 47442 NULL nohasharray
+ufs_frag_map_fndecl_47442_fields ufs_frag_map fndecl 0 47442 &depth_bttv_format_47442_fields
+__ieee80211_stop_tx_ba_session_fndecl_47449_fields __ieee80211_stop_tx_ba_session fndecl 2 47449 NULL
+__irq_domain_alloc_irqs_fndecl_47462_fields __irq_domain_alloc_irqs fndecl 0-2 47462 NULL nohasharray
+part_bits_mtd_blktrans_ops_47462_fields part_bits mtd_blktrans_ops 0 47462 &__irq_domain_alloc_irqs_fndecl_47462_fields
+len_wmfw_region_47463_fields len wmfw_region 0 47463 NULL
+memblock_alloc_try_nid_fndecl_47470_fields memblock_alloc_try_nid fndecl 2 47470 NULL
+compat_do_ipt_set_ctl_fndecl_47473_fields compat_do_ipt_set_ctl fndecl 4 47473 NULL
+maxDataSize__mpt_ioctl_header_47477_fields maxDataSize _mpt_ioctl_header 0 47477 NULL
+affs_write_end_ofs_fndecl_47486_fields affs_write_end_ofs fndecl 4-3 47486 NULL
+value_acpi_rsconvert_info_47488_fields value acpi_rsconvert_info 0 47488 NULL
+page_size_cas_47493_fields page_size cas 0 47493 NULL
+first_block_efs_sb_info_47499_fields first_block efs_sb_info 0 47499 NULL
+rss_table_size_i40e_vsi_47500_fields rss_table_size i40e_vsi 0 47500 NULL
+cifs_write_from_iter_fndecl_47501_fields cifs_write_from_iter fndecl 2-1 47501 NULL
+gr_ep_init_fndecl_47502_fields gr_ep_init fndecl 4 47502 NULL
+try_unmap_single_bt_fndecl_47503_fields try_unmap_single_bt fndecl 2-3 47503 NULL
+btrfs_cont_expand_fndecl_47505_fields btrfs_cont_expand fndecl 3-2 47505 NULL
+nr_outport_coresight_platform_data_47506_fields nr_outport coresight_platform_data 0 47506 NULL
+ucNumEntries__ATOM_Tonga_MCLK_Dependency_Table_47510_fields ucNumEntries _ATOM_Tonga_MCLK_Dependency_Table 0 47510 NULL nohasharray
+romfs_blk_strcmp_fndecl_47510_fields romfs_blk_strcmp fndecl 4-2 47510 &ucNumEntries__ATOM_Tonga_MCLK_Dependency_Table_47510_fields
+num_connector_drm_mode_config_47518_fields num_connector drm_mode_config 0 47518 NULL nohasharray
+elf_header_exclude_ranges_fndecl_47518_fields elf_header_exclude_ranges fndecl 2-3 47518 &num_connector_drm_mode_config_47518_fields nohasharray
+gfs2_dir_get_new_buffer_fndecl_47518_fields gfs2_dir_get_new_buffer fndecl 2 47518 &elf_header_exclude_ranges_fndecl_47518_fields
+helene_write_regs_fndecl_47531_fields helene_write_regs fndecl 4 47531 NULL nohasharray
+rome_tlv_send_segment_fndecl_47531_fields rome_tlv_send_segment fndecl 3 47531 &helene_write_regs_fndecl_47531_fields
+llcp_sock_sendmsg_fndecl_47535_fields llcp_sock_sendmsg fndecl 3 47535 NULL
+bytes_nvmem_cell_47539_fields bytes nvmem_cell 0 47539 NULL
+skb_headers_offset_update_fndecl_47543_fields skb_headers_offset_update fndecl 2 47543 NULL
+relocs_num_drm_qxl_command_47550_fields relocs_num drm_qxl_command 0 47550 NULL
+add_replay_bud_fndecl_47552_fields add_replay_bud fndecl 3 47552 NULL
+max_concur_ios_snic_fw_info_47556_fields max_concur_ios snic_fw_info 0 47556 NULL
+fbcon_scrolldelta_fndecl_47560_fields fbcon_scrolldelta fndecl 2 47560 NULL
+max_xmit_dlength_iscsi_bus_flash_conn_47565_fields max_xmit_dlength iscsi_bus_flash_conn 0 47565 NULL
+ubh_bread_uspi_fndecl_47568_fields ubh_bread_uspi fndecl 3 47568 NULL
+bnx2x_calc_num_queues_fndecl_47576_fields bnx2x_calc_num_queues fndecl 0 47576 NULL
+i_start_msdos_inode_info_47589_fields i_start msdos_inode_info 0 47589 NULL nohasharray
+traffic_class_ib_global_route_47589_fields traffic_class ib_global_route 0 47589 &i_start_msdos_inode_info_47589_fields
+acpi_check_region_fndecl_47594_fields acpi_check_region fndecl 2-1 47594 NULL
+ecryptfs_write_end_fndecl_47601_fields ecryptfs_write_end fndecl 5-3 47601 NULL
+rx_page_order_iwl_trans_pcie_47605_fields rx_page_order iwl_trans_pcie 0 47605 NULL
+ebt_buf_count_fndecl_47612_fields ebt_buf_count fndecl 2 47612 NULL
+control_1_vxge_hw_ring_rxd_1_47616_fields control_1 vxge_hw_ring_rxd_1 0 47616 NULL
+mincore_pte_range_fndecl_47625_fields mincore_pte_range fndecl 2 47625 NULL nohasharray
+len_ib_ucm_req_47625_fields len ib_ucm_req 0 47625 &mincore_pte_range_fndecl_47625_fields
+ubifs_load_znode_fndecl_47628_fields ubifs_load_znode fndecl 4 47628 NULL
+allocate_resource_fndecl_47629_fields allocate_resource fndecl 4-3-5-6 47629 NULL
+size_early_log_47637_fields size early_log 0 47637 NULL
+nentries_ebt_table_info_47639_fields nentries ebt_table_info 0 47639 NULL
+buffer_alignment_fore200e_bus_47640_fields buffer_alignment fore200e_bus 0 47640 NULL
+num_phys_hw_profile_47641_fields num_phys hw_profile 0 47641 NULL
+radeon_compat_ioctl_fndecl_47645_fields radeon_compat_ioctl fndecl 2 47645 NULL
+ocfs2_move_extent_fndecl_47648_fields ocfs2_move_extent fndecl 5-3-2 47648 NULL nohasharray
+fetch_to_dev_buffer_fndecl_47648_fields fetch_to_dev_buffer fndecl 3 47648 &ocfs2_move_extent_fndecl_47648_fields
+rate_max_snd_soc_pcm_stream_47650_fields rate_max snd_soc_pcm_stream 0 47650 NULL
+max_sge_rqe_allocated_ocrdma_create_srq_rsp_47654_fields max_sge_rqe_allocated ocrdma_create_srq_rsp 0 47654 NULL
+height_console_font_47655_fields height console_font 0 47655 NULL
+length_fw_cdev_add_descriptor_47656_fields length fw_cdev_add_descriptor 0 47656 NULL
+__of_address_to_resource_fndecl_47662_fields __of_address_to_resource fndecl 3 47662 NULL
+wPropertyNameLength_usb_ext_prop_desc_47663_fields wPropertyNameLength usb_ext_prop_desc 0 47663 NULL
+dlm_rcom_names_fndecl_47668_fields dlm_rcom_names fndecl 4 47668 NULL
+chans_zatm_dev_47669_fields chans zatm_dev 0 47669 NULL
+setup_window_fndecl_47673_fields setup_window fndecl 2-3 47673 NULL
+pci_iov_bus_range_fndecl_47686_fields pci_iov_bus_range fndecl 0 47686 NULL
+maxframesize_snd_usb_endpoint_47687_fields maxframesize snd_usb_endpoint 0 47687 NULL
+batadv_hardif_min_mtu_fndecl_47691_fields batadv_hardif_min_mtu fndecl 0 47691 NULL
+virtblk_queue_depth_vardecl_virtio_blk_c_47692_fields virtblk_queue_depth vardecl_virtio_blk.c 0 47692 NULL
+gpu_mem_base_vml_par_47703_fields gpu_mem_base vml_par 0 47703 NULL
+onenand_bbt_read_oob_fndecl_47704_fields onenand_bbt_read_oob fndecl 2 47704 NULL nohasharray
+xfs_iext_realloc_indirect_fndecl_47704_fields xfs_iext_realloc_indirect fndecl 2 47704 &onenand_bbt_read_oob_fndecl_47704_fields
+ppp_sync_receive_fndecl_47706_fields ppp_sync_receive fndecl 4 47706 NULL
+small_bytes_myri10ge_priv_47709_fields small_bytes myri10ge_priv 0 47709 NULL nohasharray
+fast_rx_path_fndecl_47709_fields fast_rx_path fndecl 3 47709 &small_bytes_myri10ge_priv_47709_fields nohasharray
+i2c_hid_raw_request_fndecl_47709_fields i2c_hid_raw_request fndecl 4 47709 &fast_rx_path_fndecl_47709_fields
+oxu_init_fndecl_47714_fields oxu_init fndecl 3-2 47714 NULL
+bdev_stack_limits_fndecl_47732_fields bdev_stack_limits fndecl 3 47732 NULL
+copy_nocow_pages_for_inode_fndecl_47736_fields copy_nocow_pages_for_inode fndecl 2 47736 NULL
+SMB2_write_fndecl_47741_fields SMB2_write fndecl 5 47741 NULL
+minbcnt_aoetgt_47744_fields minbcnt aoetgt 0 47744 NULL
+buffer_size_snd_emu10k1_fx8010_pcm_47753_fields buffer_size snd_emu10k1_fx8010_pcm 0 47753 NULL
+fixed_out_len_gether_47754_fields fixed_out_len gether 0 47754 NULL
+key_instantiate_and_link_fndecl_47756_fields key_instantiate_and_link fndecl 3 47756 NULL
+num_def_rx_descs_octeon_config_47759_fields num_def_rx_descs octeon_config 0 47759 NULL
+write_chunk_fndecl_47763_fields write_chunk fndecl 4 47763 NULL
+ticket_length_rxrpc_key_data_v1_47764_fields ticket_length rxrpc_key_data_v1 0 47764 NULL
+mq_ecount_lpfc_sli4_hba_47770_fields mq_ecount lpfc_sli4_hba 0 47770 NULL
+rx_count_ll_struct_47772_fields rx_count ll_struct 0 47772 NULL nohasharray
+minor_osd_uld_device_47772_fields minor osd_uld_device 0 47772 &rx_count_ll_struct_47772_fields
+fill_func_debug_buffer_47773_fields fill_func debug_buffer 0 47773 NULL
+dma1_shift_es1938_47776_fields dma1_shift es1938 0 47776 NULL
+rx_ring_size_bnx2x_47784_fields rx_ring_size bnx2x 0 47784 NULL
+hfi1_create_ctxtdata_fndecl_47785_fields hfi1_create_ctxtdata fndecl 2 47785 NULL nohasharray
+bg_blkno_ocfs2_group_desc_47785_fields bg_blkno ocfs2_group_desc 0 47785 &hfi1_create_ctxtdata_fndecl_47785_fields
+max_cmds_mlx4_cmd_47790_fields max_cmds mlx4_cmd 0 47790 NULL nohasharray
+skb_prepare_seq_read_fndecl_47790_fields skb_prepare_seq_read fndecl 2 47790 &max_cmds_mlx4_cmd_47790_fields
+do_otp_read_fndecl_47794_fields do_otp_read fndecl 2 47794 NULL
+num_vmdq_qps_i40e_pf_47795_fields num_vmdq_qps i40e_pf 0 47795 NULL
+mxt_bootloader_read_fndecl_47796_fields mxt_bootloader_read fndecl 3 47796 NULL nohasharray
+major_vardecl_sound_c_47796_fields major vardecl_sound.c 0 47796 &mxt_bootloader_read_fndecl_47796_fields
+__push_leaf_right_fndecl_47797_fields __push_leaf_right fndecl 8 47797 NULL nohasharray
+get_key_haup_common_fndecl_47797_fields get_key_haup_common fndecl 5 47797 &__push_leaf_right_fndecl_47797_fields
+i_eblock_bfs_inode_47799_fields i_eblock bfs_inode 0 47799 NULL
+h_suballoc_bit_ocfs2_extent_block_47802_fields h_suballoc_bit ocfs2_extent_block 0 47802 NULL
+odd_byte_adjustment_sym_ccb_47803_fields odd_byte_adjustment sym_ccb 0 47803 NULL
+xfs_attrmulti_attr_set_fndecl_47809_fields xfs_attrmulti_attr_set fndecl 4 47809 NULL
+fuse_copy_do_fndecl_47822_fields fuse_copy_do fndecl 0 47822 NULL
+create_srq_user_fndecl_47828_fields create_srq_user fndecl 5 47828 NULL
+rom_length_fw_cdev_get_info_47831_fields rom_length fw_cdev_get_info 0 47831 NULL
+cifs_readv_from_socket_fndecl_47833_fields cifs_readv_from_socket fndecl 0 47833 NULL
+tcp_check_reno_reordering_fndecl_47842_fields tcp_check_reno_reordering fndecl 2 47842 NULL
+assoc_len_amp_ctrl_47844_fields assoc_len amp_ctrl 0 47844 NULL nohasharray
+ieee80211_tdls_add_setup_start_ies_fndecl_47844_fields ieee80211_tdls_add_setup_start_ies fndecl 7 47844 &assoc_len_amp_ctrl_47844_fields
+rl_rgrps_gfs2_rgrp_list_47847_fields rl_rgrps gfs2_rgrp_list 0 47847 NULL
+ch_t_tlevel_jsm_channel_47848_fields ch_t_tlevel jsm_channel 0 47848 NULL
+s_mmp_block_ext4_super_block_47865_fields s_mmp_block ext4_super_block 0 47865 NULL
+length_ar9170_stream_47870_fields length ar9170_stream 0 47870 NULL
+smssdio_sendrequest_fndecl_47873_fields smssdio_sendrequest fndecl 3 47873 NULL
+len_nlm_cookie_47875_fields len nlm_cookie 0 47875 NULL nohasharray
+ivtv_convert_ivtv_vbi_fndecl_47875_fields ivtv_convert_ivtv_vbi fndecl 0 47875 &len_nlm_cookie_47875_fields
+smt_send_ecf_fndecl_47881_fields smt_send_ecf fndecl 6 47881 NULL
+n_bytes_rockchip_spi_47891_fields n_bytes rockchip_spi 0 47891 NULL
+end_bus_number_acpi_mcfg_allocation_47894_fields end_bus_number acpi_mcfg_allocation 0 47894 NULL
+sb_inoalignmt_xfs_sb_47899_fields sb_inoalignmt xfs_sb 0 47899 NULL
+set_offset_v2_k_offset_fndecl_47902_fields set_offset_v2_k_offset fndecl 2 47902 NULL
+msize_p9_client_47905_fields msize p9_client 0 47905 NULL
+spi_map_msg_fndecl_47912_fields spi_map_msg fndecl 0 47912 NULL
+nbytes_fsl_edma_hw_tcd_47913_fields nbytes fsl_edma_hw_tcd 0 47913 NULL
+xfs_bmap_read_extents_fndecl_47915_fields xfs_bmap_read_extents fndecl 0 47915 NULL
+telem_pmc_ssram_size_intel_pmc_ipc_dev_47917_fields telem_pmc_ssram_size intel_pmc_ipc_dev 0 47917 NULL
+mxl111sf_stream_config_isoc_fndecl_47924_fields mxl111sf_stream_config_isoc fndecl 2 47924 NULL
+phys_esb2rom_window_47933_fields phys esb2rom_window 0 47933 NULL
+fddi_change_mtu_fndecl_47942_fields fddi_change_mtu fndecl 2 47942 NULL
+rxd_vlan_rxd_desc_47943_fields rxd_vlan rxd_desc 0 47943 NULL
+max_param_range_47945_fields max param_range 0 47945 NULL
+get_user_pages_unlocked_fndecl_47946_fields get_user_pages_unlocked fndecl 0-1 47946 NULL
+produce_q_size_vmci_qp_47948_fields produce_q_size vmci_qp 0 47948 NULL
+dlm_new_lockspace_fndecl_47954_fields dlm_new_lockspace fndecl 4 47954 NULL
+l2bsize_jfs_log_47956_fields l2bsize jfs_log 0 47956 NULL
+depth_pitch_drm_r128_private_47959_fields depth_pitch drm_r128_private 0 47959 NULL
+netpoll_send_udp_fndecl_47960_fields netpoll_send_udp fndecl 3 47960 NULL
+st5481_isoc_flatten_fndecl_47963_fields st5481_isoc_flatten fndecl 0 47963 NULL
+handle_rx_packet_fndecl_47970_fields handle_rx_packet fndecl 3 47970 NULL
+encap_hlen_ip_tunnel_encap_ops_47971_fields encap_hlen ip_tunnel_encap_ops 0 47971 NULL nohasharray
+length_xfs_bmalloca_47971_fields length xfs_bmalloca 0 47971 &encap_hlen_ip_tunnel_encap_ops_47971_fields
+num_irqs_nfp_net_47984_fields num_irqs nfp_net 0 47984 NULL
+remap_to_cache_dirty_fndecl_47996_fields remap_to_cache_dirty fndecl 4 47996 NULL
+size_sc_config_sizes_47998_fields size sc_config_sizes 0 47998 NULL
+blocks_num_c2port_ops_47999_fields blocks_num c2port_ops 0 47999 NULL
+width_console_font_op_48005_fields width console_font_op 0 48005 NULL
+size_nfs_fh_48014_fields size nfs_fh 0 48014 NULL
+temp_end_applesmc_registers_48016_fields temp_end applesmc_registers 0 48016 NULL
+original_mtu_slave_48025_fields original_mtu slave 0 48025 NULL
+hmac_len_sctp_hmac_48030_fields hmac_len sctp_hmac 0 48030 NULL
+rm_namelen_nfsd4_remove_48040_fields rm_namelen nfsd4_remove 0 48040 NULL
+s_reserved_affs_sb_info_48043_fields s_reserved affs_sb_info 0 48043 NULL
+sb_size_md_rdev_48046_fields sb_size md_rdev 0 48046 NULL
+num_pages_ttm_buffer_object_48047_fields num_pages ttm_buffer_object 0 48047 NULL
+num_privcmd_mmapbatch_v2_48051_fields num privcmd_mmapbatch_v2 0 48051 NULL
+ioctl_datasize_ips_ha_48058_fields ioctl_datasize ips_ha 0 48058 NULL
+nr_channels_at_dma_platform_data_48060_fields nr_channels at_dma_platform_data 0 48060 NULL
+lso_max_fc_lport_48064_fields lso_max fc_lport 0 48064 NULL
+zonesize_alauda_media_info_48068_fields zonesize alauda_media_info 0 48068 NULL
+sc16is7xx_alloc_line_fndecl_48075_fields sc16is7xx_alloc_line fndecl 0 48075 NULL
+mt9t031_skip_fndecl_48078_fields mt9t031_skip fndecl 0-3-2 48078 NULL
+mlx5_ib_read_user_wqe_fndecl_48085_fields mlx5_ib_read_user_wqe fndecl 3-5 48085 NULL
+count_atl1c_rfd_ring_48095_fields count atl1c_rfd_ring 0 48095 NULL
+seg_count_agp_region32_48097_fields seg_count agp_region32 0 48097 NULL
+icq_align_elevator_type_48098_fields icq_align elevator_type 0 48098 NULL
+ep_out_mts_desc_48099_fields ep_out mts_desc 0 48099 NULL
+__lbs_cmd_async_fndecl_48102_fields __lbs_cmd_async fndecl 4 48102 NULL
+bit_offset_nvmem_cell_info_48105_fields bit_offset nvmem_cell_info 0 48105 NULL
+max_pkt_size_cx231xx_audio_48117_fields max_pkt_size cx231xx_audio 0 48117 NULL
+discard_granularity_queue_limits_48119_fields discard_granularity queue_limits 0 48119 NULL
+gfs2_write_begin_fndecl_48129_fields gfs2_write_begin fndecl 4-3 48129 NULL
+netid_len_pnfs_ff_netaddr_48139_fields netid_len pnfs_ff_netaddr 0 48139 NULL
+osdmap_set_max_osd_fndecl_48141_fields osdmap_set_max_osd fndecl 2 48141 NULL nohasharray
+sisusbcon_putcs_fndecl_48141_fields sisusbcon_putcs fndecl 3 48141 &osdmap_set_max_osd_fndecl_48141_fields
+max_gs_mlx5_core_srq_48153_fields max_gs mlx5_core_srq 0 48153 NULL
+isdnhdlc_encode_fndecl_48155_fields isdnhdlc_encode fndecl 0-6 48155 NULL
+usb_endpoint_data_queue_48158_fields usb_endpoint data_queue 0 48158 NULL nohasharray
+update_res_fndecl_48158_fields update_res fndecl 3-2 48158 &usb_endpoint_data_queue_48158_fields
+ceph_set_xattr_handler_fndecl_48161_fields ceph_set_xattr_handler fndecl 6 48161 NULL
+qs_in_channels_hdsp_48166_fields qs_in_channels hdsp 0 48166 NULL nohasharray
+xfs_alloc_ag_vextent_near_fndecl_48166_fields xfs_alloc_ag_vextent_near fndecl 0 48166 &qs_in_channels_hdsp_48166_fields
+hub_control_hc_driver_48178_fields hub_control hc_driver 0 48178 NULL
+mwifiex_parse_cal_cfg_fndecl_48179_fields mwifiex_parse_cal_cfg fndecl 0 48179 NULL
+num_pages_vmw_sg_table_48192_fields num_pages vmw_sg_table 0 48192 NULL
+qcafrm_fsm_decode_fndecl_48193_fields qcafrm_fsm_decode fndecl 0-4 48193 NULL
+xres_virtual_fb_var_screeninfo_48196_fields xres_virtual fb_var_screeninfo 0 48196 NULL nohasharray
+sy_fb_copyarea_48196_fields sy fb_copyarea 0 48196 &xres_virtual_fb_var_screeninfo_48196_fields
+snd_rawmidi_transmit_ack_fndecl_48200_fields snd_rawmidi_transmit_ack fndecl 2 48200 NULL
+rxoffset_dma_info_48202_fields rxoffset dma_info 0 48202 NULL
+btusb_recv_bulk_intel_fndecl_48211_fields btusb_recv_bulk_intel fndecl 3 48211 NULL
+srp_response_common_fndecl_48216_fields srp_response_common fndecl 4 48216 NULL nohasharray
+ax88179_read_cmd_nopm_fndecl_48216_fields ax88179_read_cmd_nopm fndecl 5 48216 &srp_response_common_fndecl_48216_fields
+cur_inode_last_extent_send_ctx_48219_fields cur_inode_last_extent send_ctx 0 48219 NULL
+xdr_buf_read_netobj_fndecl_48238_fields xdr_buf_read_netobj fndecl 3 48238 NULL
+num_rx_rings_bnx2_48240_fields num_rx_rings bnx2 0 48240 NULL
+frag_offset_kcm_tx_msg_48243_fields frag_offset kcm_tx_msg 0 48243 NULL
+qib_make_grh_fndecl_48250_fields qib_make_grh fndecl 0 48250 NULL
+height_cx88_core_48255_fields height cx88_core 0 48255 NULL
+region_length_acpi_table_bert_48274_fields region_length acpi_table_bert 0 48274 NULL
+vrows_display_48275_fields vrows display 0 48275 NULL
+add_packet_fndecl_48295_fields add_packet fndecl 3 48295 NULL
+nep_buffer_size_wahc_48313_fields nep_buffer_size wahc 0 48313 NULL
+ngroups_group_info_48320_fields ngroups group_info 0 48320 NULL
+pin_down_extent_fndecl_48324_fields pin_down_extent fndecl 4-3 48324 NULL
+acpi_efi_48328_fields acpi efi 0 48328 NULL nohasharray
+btn_rec_size_cyttsp4_sysinfo_ofs_48328_fields btn_rec_size cyttsp4_sysinfo_ofs 0 48328 &acpi_efi_48328_fields
+vga_scan_lines_vardecl_vgacon_c_48330_fields vga_scan_lines vardecl_vgacon.c 0 48330 NULL
+region_table_entry_bits_switch_ctx_48332_fields region_table_entry_bits switch_ctx 0 48332 NULL
+tch_rec_size_cyttsp4_opcfg_48339_fields tch_rec_size cyttsp4_opcfg 0 48339 NULL
+spare_bytes_per_page_nand_jedec_params_48344_fields spare_bytes_per_page nand_jedec_params 0 48344 NULL
+bno_xfs_extent_busy_48346_fields bno xfs_extent_busy 0 48346 NULL
+generic_ptrace_peekdata_fndecl_48349_fields generic_ptrace_peekdata fndecl 2 48349 NULL
+hwahc_op_urb_dequeue_fndecl_48351_fields hwahc_op_urb_dequeue fndecl 3 48351 NULL
+xfs_rtpick_extent_fndecl_48352_fields xfs_rtpick_extent fndecl 0 48352 NULL
+num_phys_samsung_usb2_phy_config_48358_fields num_phys samsung_usb2_phy_config 0 48358 NULL
+qib_make_rc_ack_fndecl_48361_fields qib_make_rc_ack fndecl 4 48361 NULL
+ule_sndu_len_dvb_net_priv_48367_fields ule_sndu_len dvb_net_priv 0 48367 NULL nohasharray
+low_rio_doorbell_filter_48367_fields low rio_doorbell_filter 0 48367 &ule_sndu_len_dvb_net_priv_48367_fields
+xlog_write_setup_copy_fndecl_48368_fields xlog_write_setup_copy fndecl 0 48368 NULL
+i915_gem_object_bind_to_vm_fndecl_48370_fields i915_gem_object_bind_to_vm fndecl 5 48370 NULL nohasharray
+gmch_chip_id_intel_gtt_driver_description_48370_fields gmch_chip_id intel_gtt_driver_description 0 48370 &i915_gem_object_bind_to_vm_fndecl_48370_fields
+width_dt3155_priv_48375_fields width dt3155_priv 0 48375 NULL
+driver_data_pci_device_id_48380_fields driver_data pci_device_id 0 48380 NULL
+_snd_pcm_hw_param_set_fndecl_48394_fields _snd_pcm_hw_param_set fndecl 3 48394 NULL
+blk_queue_dma_pad_fndecl_48409_fields blk_queue_dma_pad fndecl 2 48409 NULL
+ieee80211_start_rx_ba_session_offl_fndecl_48410_fields ieee80211_start_rx_ba_session_offl fndecl 3 48410 NULL
+osd_depth_vardecl_ivtvfb_c_48413_fields osd_depth vardecl_ivtvfb.c 0 48413 NULL
+__install_special_mapping_fndecl_48415_fields __install_special_mapping fndecl 2-3 48415 NULL
+seq_buf_putmem_fndecl_48421_fields seq_buf_putmem fndecl 3 48421 NULL
+sys_fadvise64_64_fndecl_48424_fields sys_fadvise64_64 fndecl 2-3 48424 NULL nohasharray
+stex_copy_data_fndecl_48424_fields stex_copy_data fndecl 3 48424 &sys_fadvise64_64_fndecl_48424_fields
+bMaxBurst_usb_wireless_ep_comp_descriptor_48430_fields bMaxBurst usb_wireless_ep_comp_descriptor 0 48430 NULL
+mmio_phys_end_amd_iommu_48432_fields mmio_phys_end amd_iommu 0 48432 NULL
+__nvme_submit_sync_cmd_fndecl_48438_fields __nvme_submit_sync_cmd fndecl 5 48438 NULL nohasharray
+tty_register_device_attr_fndecl_48438_fields tty_register_device_attr fndecl 2 48438 &__nvme_submit_sync_cmd_fndecl_48438_fields
+bzImage64_load_fndecl_48447_fields bzImage64_load fndecl 5 48447 NULL
+__tcp_retransmit_skb_fndecl_48449_fields __tcp_retransmit_skb fndecl 3 48449 NULL
+compat_keyctl_instantiate_key_iov_fndecl_48452_fields compat_keyctl_instantiate_key_iov fndecl 3 48452 NULL
+frag_ceph_file_info_48455_fields frag ceph_file_info 0 48455 NULL
+xen_align_and_add_e820_region_fndecl_48457_fields xen_align_and_add_e820_region fndecl 2-1 48457 NULL nohasharray
+dp_out_buf_len_digi_port_48457_fields dp_out_buf_len digi_port 0 48457 &xen_align_and_add_e820_region_fndecl_48457_fields
+len_rx_header_48462_fields len rx_header 0 48462 NULL
+__nla_reserve_nohdr_fndecl_48468_fields __nla_reserve_nohdr fndecl 2 48468 NULL
+gre_manip_pkt_fndecl_48475_fields gre_manip_pkt fndecl 4 48475 NULL
+nr_domains_rapl_package_48482_fields nr_domains rapl_package 0 48482 NULL
+xe_value_size_ocfs2_xattr_entry_48485_fields xe_value_size ocfs2_xattr_entry 0 48485 NULL
+__roundup_pow_of_two_fndecl_48486_fields __roundup_pow_of_two fndecl 0 48486 NULL
+l_len_ocfs2_space_resv_48490_fields l_len ocfs2_space_resv 0 48490 NULL
+ydepth_sh_veu_format_48498_fields ydepth sh_veu_format 0 48498 NULL
+encode_filename_fndecl_48501_fields encode_filename fndecl 3 48501 NULL
+len_cfg80211_bss_ies_48503_fields len cfg80211_bss_ies 0 48503 NULL
+channels_snd_soc_dai_48509_fields channels snd_soc_dai 0 48509 NULL
+rx_count_kim_data_s_48513_fields rx_count kim_data_s 0 48513 NULL
+octeon_read_device_mem32_fndecl_48520_fields octeon_read_device_mem32 fndecl 0 48520 NULL
+fcoe_get_paged_crc_eof_fndecl_48522_fields fcoe_get_paged_crc_eof fndecl 2 48522 NULL
+receive_buf_fndecl_48528_fields receive_buf fndecl 4 48528 NULL
+dxfer_len_sg_io_hdr_48532_fields dxfer_len sg_io_hdr 0 48532 NULL
+discard_block_size_cache_48539_fields discard_block_size cache 0 48539 NULL
+fack_count_tcp_sacktag_state_48543_fields fack_count tcp_sacktag_state 0 48543 NULL
+aid_len_nfc_evt_transaction_48544_fields aid_len nfc_evt_transaction 0 48544 NULL
+dccp_sync_mss_fndecl_48556_fields dccp_sync_mss fndecl 2 48556 NULL
+__vlan_vid_add_fndecl_48559_fields __vlan_vid_add fndecl 3 48559 NULL
+intel_tile_height_fndecl_48566_fields intel_tile_height fndecl 0-3 48566 NULL
+len_wep_key_t_48574_fields len wep_key_t 0 48574 NULL
+iomem_reg_shift_old_serial_port_48579_fields iomem_reg_shift old_serial_port 0 48579 NULL
+max_skb_frags_iwl_trans_48580_fields max_skb_frags iwl_trans 0 48580 NULL
+vce_v2_0_bo_size_fndecl_48581_fields vce_v2_0_bo_size fndecl 0 48581 NULL
+max_num_vdevs_ath10k_48584_fields max_num_vdevs ath10k 0 48584 NULL nohasharray
+tx_ring_size_bnx2x_48584_fields tx_ring_size bnx2x 0 48584 &max_num_vdevs_ath10k_48584_fields
+backup_size_vmw_resource_48590_fields backup_size vmw_resource 0 48590 NULL
+arm_copy_to_user_fndecl_48602_fields arm_copy_to_user fndecl 0 48602 NULL
+datalen_atp_info_48607_fields datalen atp_info 0 48607 NULL
+count_e8390_pkt_hdr_48610_fields count e8390_pkt_hdr 0 48610 NULL
+mmc_test_prepare_mrq_fndecl_48612_fields mmc_test_prepare_mrq fndecl 7-6-4 48612 NULL
+hva_to_pfn_remapped_fndecl_48620_fields hva_to_pfn_remapped fndecl 2 48620 NULL
+len_i40iw_post_inline_send_48623_fields len i40iw_post_inline_send 0 48623 NULL
+xen_get_max_pages_fndecl_48626_fields xen_get_max_pages fndecl 0 48626 NULL
+crc_eof_offset_fcoe_percpu_s_48630_fields crc_eof_offset fcoe_percpu_s 0 48630 NULL
+bcma_of_get_irq_fndecl_48631_fields bcma_of_get_irq fndecl 0 48631 NULL
+ili210x_read_reg_fndecl_48632_fields ili210x_read_reg fndecl 4 48632 NULL
+igu_sb_cnt_qed_igu_info_48638_fields igu_sb_cnt qed_igu_info 0 48638 NULL
+check_next_phase_fndecl_48641_fields check_next_phase fndecl 2 48641 NULL
+w_panel_info_48643_fields w panel_info 0 48643 NULL
+origin_sectors_cache_48650_fields origin_sectors cache 0 48650 NULL
+pkt_len_eth_end_agg_rx_cqe_48658_fields pkt_len eth_end_agg_rx_cqe 0 48658 NULL
+mmc_test_rnd_perf_fndecl_48660_fields mmc_test_rnd_perf fndecl 4 48660 NULL
+brcmf_sdio_bus_get_memdump_fndecl_48669_fields brcmf_sdio_bus_get_memdump fndecl 3 48669 NULL
+snd_seq_fifo_new_fndecl_48670_fields snd_seq_fifo_new fndecl 1 48670 NULL
+ep_out_if_usb_card_48678_fields ep_out if_usb_card 0 48678 NULL
+vscan_drm_display_mode_48680_fields vscan drm_display_mode 0 48680 NULL nohasharray
+ext4_bg_num_gdb_fndecl_48680_fields ext4_bg_num_gdb fndecl 0 48680 &vscan_drm_display_mode_48680_fields
+simple_transaction_set_fndecl_48684_fields simple_transaction_set fndecl 2 48684 NULL
+max_eqs_mlx4_dev_cap_48689_fields max_eqs mlx4_dev_cap 0 48689 NULL
+sb_dblocks_xfs_sb_48691_fields sb_dblocks xfs_sb 0 48691 NULL
+usCRTC_H_Disp__ATOM_MODE_TIMING_48694_fields usCRTC_H_Disp _ATOM_MODE_TIMING 0 48694 NULL nohasharray
+ib_qib_max_qp_wrs_vardecl_48694_fields ib_qib_max_qp_wrs vardecl 0 48694 &usCRTC_H_Disp__ATOM_MODE_TIMING_48694_fields
+max_rds_rings_netxen_adapter_48699_fields max_rds_rings netxen_adapter 0 48699 NULL
+cqe_ib_cq_init_attr_48707_fields cqe ib_cq_init_attr 0 48707 NULL nohasharray
+asix_write_cmd_fndecl_48707_fields asix_write_cmd fndecl 5 48707 &cqe_ib_cq_init_attr_48707_fields
+xfs_zero_extent_fndecl_48709_fields xfs_zero_extent fndecl 0-3-2 48709 NULL
+orangefs_normalize_to_errno_fndecl_48715_fields orangefs_normalize_to_errno fndecl 0-1 48715 NULL nohasharray
+sect_count_hfsplus_sb_info_48715_fields sect_count hfsplus_sb_info 0 48715 &orangefs_normalize_to_errno_fndecl_48715_fields
+base_gfn_kvm_memory_slot_48716_fields base_gfn kvm_memory_slot 0 48716 NULL
+nci_send_cmd_fndecl_48717_fields nci_send_cmd fndecl 3 48717 NULL nohasharray
+num_cols_vardecl_arcfb_c_48717_fields num_cols vardecl_arcfb.c 0 48717 &nci_send_cmd_fndecl_48717_fields
+rx_max_cdc_ncm_ctx_48720_fields rx_max cdc_ncm_ctx 0 48720 NULL nohasharray
+mdata_ofs_cyttsp4_sysinfo_ofs_48720_fields mdata_ofs cyttsp4_sysinfo_ofs 0 48720 &rx_max_cdc_ncm_ctx_48720_fields
+ceph_tcp_recvmsg_fndecl_48722_fields ceph_tcp_recvmsg fndecl 0-3 48722 NULL
+can_dlc_can_frame_48738_fields can_dlc can_frame 0 48738 NULL
+numEntries__ATOM_PPLIB_UVD_Clock_Voltage_Limit_Table_48741_fields numEntries _ATOM_PPLIB_UVD_Clock_Voltage_Limit_Table 0 48741 NULL nohasharray
+bad_peb_count_ubi_device_48741_fields bad_peb_count ubi_device 0 48741 &numEntries__ATOM_PPLIB_UVD_Clock_Voltage_Limit_Table_48741_fields
+iommu_size_vardecl_amd_gart_64_c_48749_fields iommu_size vardecl_amd_gart_64.c 0 48749 NULL
+default_value_v4l2_ctrl_48751_fields default_value v4l2_ctrl 0 48751 NULL
+e_blkno_ocfs2_extent_rec_48756_fields e_blkno ocfs2_extent_rec 0 48756 NULL
+ide_rate_filter_fndecl_48764_fields ide_rate_filter fndecl 0 48764 NULL
+nfree_arena_info_48769_fields nfree arena_info 0 48769 NULL
+xmit_size_modem_info_48775_fields xmit_size modem_info 0 48775 NULL
+usable_leb_size_ubi_volume_info_48776_fields usable_leb_size ubi_volume_info 0 48776 NULL
+cfg80211_mgmt_tx_status_fndecl_48777_fields cfg80211_mgmt_tx_status fndecl 4 48777 NULL
+height_drm_framebuffer_48781_fields height drm_framebuffer 0 48781 NULL
+value_len_jffs2_xattr_datum_48786_fields value_len jffs2_xattr_datum 0 48786 NULL nohasharray
+hva_to_pfn_fndecl_48786_fields hva_to_pfn fndecl 1 48786 &value_len_jffs2_xattr_datum_48786_fields nohasharray
+mwifiex_host_to_card_mp_aggr_fndecl_48786_fields mwifiex_host_to_card_mp_aggr fndecl 3 48786 &hva_to_pfn_fndecl_48786_fields
+head_len_cfg80211_beacon_data_48794_fields head_len cfg80211_beacon_data 0 48794 NULL
+unit_size_mspro_sys_info_48796_fields unit_size mspro_sys_info 0 48796 NULL
+da_num_tokens_vardecl_dell_smbios_c_48798_fields da_num_tokens vardecl_dell-smbios.c 0 48798 NULL
+twl6030_init_irq_fndecl_48804_fields twl6030_init_irq fndecl 0 48804 NULL
+dev_id_rbd_device_48813_fields dev_id rbd_device 0 48813 NULL
+m_rmap_maxlevels_xfs_mount_48821_fields m_rmap_maxlevels xfs_mount 0 48821 NULL
+sharpness_sd_gl860_48824_fields sharpness sd_gl860 0 48824 NULL
+endpoint_pvr2_stream_48828_fields endpoint pvr2_stream 0 48828 NULL
+num_vring_48831_fields num vring 0 48831 NULL nohasharray
+xbofs_irda_skb_cb_48831_fields xbofs irda_skb_cb 0 48831 &num_vring_48831_fields
+osst_init_aux_fndecl_48837_fields osst_init_aux fndecl 6-5 48837 NULL
+busnum_usb_bus_48843_fields busnum usb_bus 0 48843 NULL
+pcim_iomap_fndecl_48845_fields pcim_iomap fndecl 3 48845 NULL
+adf7242_read_fbuf_fndecl_48847_fields adf7242_read_fbuf fndecl 3 48847 NULL
+container_width_dmm_48858_fields container_width dmm 0 48858 NULL
+end_io_target_type_48863_fields end_io target_type 0 48863 NULL
+pagefault_single_data_segment_fndecl_48864_fields pagefault_single_data_segment fndecl 4 48864 NULL
+num_desc_i40e_vsi_48872_fields num_desc i40e_vsi 0 48872 NULL
+log_mtts_per_seg_vardecl_48880_fields log_mtts_per_seg vardecl 0 48880 NULL
+skb_ensure_writable_fndecl_48882_fields skb_ensure_writable fndecl 2 48882 NULL
+diva_init_dma_map_fndecl_48883_fields diva_init_dma_map fndecl 3 48883 NULL nohasharray
+memblock_clear_hotplug_fndecl_48883_fields memblock_clear_hotplug fndecl 2-1 48883 &diva_init_dma_map_fndecl_48883_fields
+cl_in_max_entry_size_mvumi_hs_page1_48890_fields cl_in_max_entry_size mvumi_hs_page1 0 48890 NULL
+nr_buffers_drm_nouveau_gem_pushbuf_48902_fields nr_buffers drm_nouveau_gem_pushbuf 0 48902 NULL
+nr_addr_filters_pmu_48905_fields nr_addr_filters pmu 0 48905 NULL
+offset_scatterlist_48908_fields offset scatterlist 0 48908 NULL nohasharray
+max_devices_support_mvumi_hs_page1_48908_fields max_devices_support mvumi_hs_page1 0 48908 &offset_scatterlist_48908_fields
+ucNumEntries__StateArray_48910_fields ucNumEntries _StateArray 0 48910 NULL
+s_groups_count_ext2_sb_info_48915_fields s_groups_count ext2_sb_info 0 48915 NULL
+tailsz_cifs_readdata_48919_fields tailsz cifs_readdata 0 48919 NULL
+write_file_operations_48930_fields write file_operations 0 48930 NULL nohasharray
+rx_ring_count_ixgbevf_adapter_48930_fields rx_ring_count ixgbevf_adapter 0 48930 &write_file_operations_48930_fields
+iio_read_first_n_kfifo_fndecl_48933_fields iio_read_first_n_kfifo fndecl 2 48933 NULL
+emi26_writememory_fndecl_48935_fields emi26_writememory fndecl 4 48935 NULL
+w1_reply_len_fndecl_48943_fields w1_reply_len fndecl 0 48943 NULL
+start_mthca_resource_48948_fields start mthca_resource 0 48948 NULL nohasharray
+set_dma_reserve_fndecl_48948_fields set_dma_reserve fndecl 1 48948 &start_mthca_resource_48948_fields nohasharray
+get_eld_i915_audio_component_ops_48948_fields get_eld i915_audio_component_ops 0 48948 &set_dma_reserve_fndecl_48948_fields
+length_iwl_calib_res_notif_phy_db_48949_fields length iwl_calib_res_notif_phy_db 0 48949 NULL
+to_index_fndecl_48953_fields to_index fndecl 0 48953 NULL
+wptr_radeon_ring_48959_fields wptr radeon_ring 0 48959 NULL
+size_uv_systab_48965_fields size uv_systab 0 48965 NULL
+block_size_sm_ftl_48967_fields block_size sm_ftl 0 48967 NULL
+rx_fndecl_48971_fields rx fndecl 4 48971 NULL
+twl_i2c_write_fndecl_48976_fields twl_i2c_write fndecl 0 48976 NULL
+pkt_overhead_pktgen_dev_48989_fields pkt_overhead pktgen_dev 0 48989 NULL
+xt_socket_get_sock_v6_fndecl_48991_fields xt_socket_get_sock_v6 fndecl 3 48991 NULL
+pid_task_struct_49000_fields pid task_struct 0 49000 NULL nohasharray
+iov_iter_npages_fndecl_49000_fields iov_iter_npages fndecl 0-2 49000 &pid_task_struct_49000_fields
+sg_alloc_table_chained_fndecl_49001_fields sg_alloc_table_chained fndecl 2 49001 NULL
+rec_len_exofs_dir_entry_49002_fields rec_len exofs_dir_entry 0 49002 NULL
+size_mlx4_en_tx_ring_49005_fields size mlx4_en_tx_ring 0 49005 NULL
+mmio_addr_stm_data_49015_fields mmio_addr stm_data 0 49015 NULL
+compat_writev_fndecl_49017_fields compat_writev fndecl 3 49017 NULL
+bm_len_xfs_buf_map_49022_fields bm_len xfs_buf_map 0 49022 NULL
+size_vmw_otable_49032_fields size vmw_otable 0 49032 NULL
+dev_id_rfcomm_dev_req_49039_fields dev_id rfcomm_dev_req 0 49039 NULL
+reg_r_fndecl_49040_fields reg_r fndecl 0 49040 NULL
+dwMaxVideoFrameSize_uvc_streaming_control_49044_fields dwMaxVideoFrameSize uvc_streaming_control 0 49044 NULL
+max_port_per_lag_mlxsw_config_profile_49046_fields max_port_per_lag mlxsw_config_profile 0 49046 NULL
+devices_per_bus__MPT_ADAPTER_49051_fields devices_per_bus _MPT_ADAPTER 0 49051 NULL
+cxacru_cm_fndecl_49052_fields cxacru_cm fndecl 4 49052 NULL
+iguanair_send_fndecl_49054_fields iguanair_send fndecl 2 49054 NULL
+route_key_size_nf_afinfo_49055_fields route_key_size nf_afinfo 0 49055 NULL
+ide_pio_bytes_fndecl_49063_fields ide_pio_bytes fndecl 4 49063 NULL
+cm_size_tp_params_49065_fields cm_size tp_params 0 49065 NULL
+transport_mtu_vardecl_ntb_transport_c_49067_fields transport_mtu vardecl_ntb_transport.c 0 49067 NULL
+scan_nat_page_fndecl_49068_fields scan_nat_page fndecl 3 49068 NULL nohasharray
+do_writepage_fndecl_49068_fields do_writepage fndecl 2 49068 &scan_nat_page_fndecl_49068_fields
+ccid_hc_tx_obj_size_ccid_operations_49077_fields ccid_hc_tx_obj_size ccid_operations 0 49077 NULL
+max_ctrl_pkt_payload_len_nci_core_conn_create_rsp_49079_fields max_ctrl_pkt_payload_len nci_core_conn_create_rsp 0 49079 NULL
+tty_major_vardecl_hso_c_49084_fields tty_major vardecl_hso.c 0 49084 NULL
+optrom_region_size_qla_hw_data_49087_fields optrom_region_size qla_hw_data 0 49087 NULL
+bi_vcnt_bio_49090_fields bi_vcnt bio 0 49090 NULL nohasharray
+ocfs2_find_leaf_fndecl_49090_fields ocfs2_find_leaf fndecl 0 49090 &bi_vcnt_bio_49090_fields
+ocfs2_mv_xattr_bucket_cross_cluster_fndecl_49091_fields ocfs2_mv_xattr_bucket_cross_cluster fndecl 5-6 49091 NULL
+end_sector_dev_info_49096_fields end_sector dev_info 0 49096 NULL nohasharray
+misc_sbp_command_block_orb_49096_fields misc sbp_command_block_orb 0 49096 &end_sector_dev_info_49096_fields
+u132_hcd_interrupt_recv_fndecl_49098_fields u132_hcd_interrupt_recv fndecl 4 49098 NULL
+xdr_align_pages_fndecl_49102_fields xdr_align_pages fndecl 0-2 49102 NULL
+n_sz_rsa_key_49103_fields n_sz rsa_key 0 49103 NULL
+ri_super_root_nilfs_recovery_info_49105_fields ri_super_root nilfs_recovery_info 0 49105 NULL
+vmci_qpair_alloc_fndecl_49107_fields vmci_qpair_alloc fndecl 4-3 49107 NULL nohasharray
+qnx6_block_map_fndecl_49107_fields qnx6_block_map fndecl 0 49107 &vmci_qpair_alloc_fndecl_49107_fields
+mtd_ooblayout_find_region_fndecl_49110_fields mtd_ooblayout_find_region fndecl 2 49110 NULL
+max_mtu_nfp_net_49121_fields max_mtu nfp_net 0 49121 NULL
+btrfs_alloc_dummy_root_fndecl_49123_fields btrfs_alloc_dummy_root fndecl 2-3 49123 NULL
+m_ialloc_min_blks_xfs_mount_49129_fields m_ialloc_min_blks xfs_mount 0 49129 NULL
+mad_seg_size_ib_mad_recv_wc_49134_fields mad_seg_size ib_mad_recv_wc 0 49134 NULL
+neo_init_hw_fndecl_49135_fields neo_init_hw fndecl 0 49135 NULL
+snd_pcm_hw_param_min_fndecl_49139_fields snd_pcm_hw_param_min fndecl 4 49139 NULL
+batch_len_drm_i915_gem_execbuffer2_49145_fields batch_len drm_i915_gem_execbuffer2 0 49145 NULL
+max_dev_mdp_superblock_1_49148_fields max_dev mdp_superblock_1 0 49148 NULL
+ecryptfs_inode_newsize_ok_fndecl_49153_fields ecryptfs_inode_newsize_ok fndecl 2 49153 NULL
+tx_tr_cfv_info_49171_fields tx_tr cfv_info 0 49171 NULL
+addr_len_pnfs_ff_netaddr_49177_fields addr_len pnfs_ff_netaddr 0 49177 NULL
+page_size_nvme_ctrl_49190_fields page_size nvme_ctrl 0 49190 NULL
+len_fb_cmap_user_49195_fields len fb_cmap_user 0 49195 NULL
+fsl_edma_prep_dma_cyclic_fndecl_49197_fields fsl_edma_prep_dma_cyclic fndecl 2 49197 NULL nohasharray
+ielen_wps_status_t_49197_fields ielen wps_status_t 0 49197 &fsl_edma_prep_dma_cyclic_fndecl_49197_fields
+offset_page_chunk_49201_fields offset page_chunk 0 49201 NULL
+key_size_dh_49210_fields key_size dh 0 49210 NULL
+osst_read_fndecl_49214_fields osst_read fndecl 3 49214 NULL
+i_pos_low_fat_fid_49216_fields i_pos_low fat_fid 0 49216 NULL nohasharray
+nleft_ide_cmd_49216_fields nleft ide_cmd 0 49216 &i_pos_low_fat_fid_49216_fields
+offset_rq_map_data_49234_fields offset rq_map_data 0 49234 NULL
+ext_ramdisk_image_boot_params_49238_fields ext_ramdisk_image boot_params 0 49238 NULL
+mos7840_write_fndecl_49240_fields mos7840_write fndecl 4 49240 NULL
+persistent_ram_iomap_fndecl_49243_fields persistent_ram_iomap fndecl 2-1 49243 NULL
+ext2_fiemap_fndecl_49244_fields ext2_fiemap fndecl 4 49244 NULL
+dmpt_entry_sz_mlx4_dev_cap_49245_fields dmpt_entry_sz mlx4_dev_cap 0 49245 NULL
+get_user_pages_locked_fndecl_49246_fields get_user_pages_locked fndecl 1 49246 NULL nohasharray
+xfs_map_buffer_fndecl_49246_fields xfs_map_buffer fndecl 4 49246 &get_user_pages_locked_fndecl_49246_fields
+mppe_compress_fndecl_49248_fields mppe_compress fndecl 4 49248 NULL
+nfs_file_llseek_fndecl_49249_fields nfs_file_llseek fndecl 2 49249 NULL
+i40iw_create_cm_node_fndecl_49252_fields i40iw_create_cm_node fndecl 3 49252 NULL
+fifo_reserve_size_vmw_kms_dirty_49255_fields fifo_reserve_size vmw_kms_dirty 0 49255 NULL
+rdmarc_shift_mlx4_qp_table_49259_fields rdmarc_shift mlx4_qp_table 0 49259 NULL
+di_size_qnx4_inode_entry_49263_fields di_size qnx4_inode_entry 0 49263 NULL
+qat_uclo_map_obj_fndecl_49271_fields qat_uclo_map_obj fndecl 3 49271 NULL
+rate_floppy_struct_49273_fields rate floppy_struct 0 49273 NULL
+name_len_audit_names_49277_fields name_len audit_names 0 49277 NULL
+of_irq_parse_raw_fndecl_49280_fields of_irq_parse_raw fndecl 0 49280 NULL
+slub_min_order_vardecl_slub_c_49292_fields slub_min_order vardecl_slub.c 0 49292 NULL
+header_length_ipr_ucode_image_header_49294_fields header_length ipr_ucode_image_header 0 49294 NULL
+iomap_write_failed_fndecl_49298_fields iomap_write_failed fndecl 2-3 49298 NULL
+bTransferSegment_wa_xfer_result_49303_fields bTransferSegment wa_xfer_result 0 49303 NULL
+splice_direct_to_actor_fndecl_49310_fields splice_direct_to_actor fndecl 0 49310 NULL
+membase_avmcard_49314_fields membase avmcard 0 49314 NULL
+filternum_dmxdev_49322_fields filternum dmxdev 0 49322 NULL nohasharray
+via_cputemp_device_add_fndecl_49322_fields via_cputemp_device_add fndecl 1 49322 &filternum_dmxdev_49322_fields
+fwnet_incoming_packet_fndecl_49327_fields fwnet_incoming_packet fndecl 3 49327 NULL
+ocfs2_release_clusters_fndecl_49328_fields ocfs2_release_clusters fndecl 4 49328 NULL
+length_iwl_wipan_noa_data_49332_fields length iwl_wipan_noa_data 0 49332 NULL
+cmnd_res_ep_vub300_mmc_host_49334_fields cmnd_res_ep vub300_mmc_host 0 49334 NULL
+s3fwrn5_fw_enter_update_mode_fndecl_49342_fields s3fwrn5_fw_enter_update_mode fndecl 3-5 49342 NULL
+mute_bttv_49358_fields mute bttv 0 49358 NULL
+max_transfer_size_spi_master_49363_fields max_transfer_size spi_master 0 49363 NULL
+fsbcount_xfs_da_geometry_49380_fields fsbcount xfs_da_geometry 0 49380 NULL nohasharray
+x509_akid_note_serial_fndecl_49380_fields x509_akid_note_serial fndecl 5 49380 &fsbcount_xfs_da_geometry_49380_fields
+pe_data_len_ip_vs_conn_49384_fields pe_data_len ip_vs_conn 0 49384 NULL
+short_mark_sd_49388_fields short_mark sd 0 49388 NULL
+pci_iov_resource_size_fndecl_49389_fields pci_iov_resource_size fndecl 0 49389 NULL
+ecryptfs_read_lower_fndecl_49392_fields ecryptfs_read_lower fndecl 3 49392 NULL
+current_font_height_sisusb_usb_data_49394_fields current_font_height sisusb_usb_data 0 49394 NULL nohasharray
+usb_ftdi_elan_edset_empty_fndecl_49394_fields usb_ftdi_elan_edset_empty fndecl 0 49394 &current_font_height_sisusb_usb_data_49394_fields nohasharray
+send_cmd_iwl_trans_ops_49394_fields send_cmd iwl_trans_ops 0 49394 &usb_ftdi_elan_edset_empty_fndecl_49394_fields
+btrfs_delalloc_release_space_fndecl_49397_fields btrfs_delalloc_release_space fndecl 2-3 49397 NULL
+pmtu_rvt_qp_49401_fields pmtu rvt_qp 0 49401 NULL
+pinctrl_register_mappings_fndecl_49407_fields pinctrl_register_mappings fndecl 2 49407 NULL
+ss_next_nilfs_segment_summary_49410_fields ss_next nilfs_segment_summary 0 49410 NULL nohasharray
+pnp_register_port_resource_fndecl_49410_fields pnp_register_port_resource fndecl 6-3-5 49410 &ss_next_nilfs_segment_summary_49410_fields nohasharray
+next_bio_fndecl_49410_fields next_bio fndecl 2 49410 &pnp_register_port_resource_fndecl_49410_fields
+base_doorbell_index_nes_device_49415_fields base_doorbell_index nes_device 0 49415 NULL
+bio_chain_clone_range_fndecl_49420_fields bio_chain_clone_range fndecl 3 49420 NULL
+tipc_msg_build_fndecl_49424_fields tipc_msg_build fndecl 4-5 49424 NULL
+ds_out_channels_hdsp_49429_fields ds_out_channels hdsp 0 49429 NULL
+onenand_write_oob_fndecl_49431_fields onenand_write_oob fndecl 2 49431 NULL
+bytenr_tree_block_49432_fields bytenr tree_block 0 49432 NULL nohasharray
+fwnet_pd_new_fndecl_49432_fields fwnet_pd_new fndecl 4 49432 &bytenr_tree_block_49432_fields nohasharray
+set_run_fndecl_49432_fields set_run fndecl 2 49432 &fwnet_pd_new_fndecl_49432_fields
+nv_min_cwnd_vardecl_tcp_nv_c_49437_fields nv_min_cwnd vardecl_tcp_nv.c 0 49437 NULL
+perf_output_copy_fndecl_49448_fields perf_output_copy fndecl 3 49448 NULL
+global_irq_acpi_madt_interrupt_override_49451_fields global_irq acpi_madt_interrupt_override 0 49451 NULL
+dwc3_readl_fndecl_49455_fields dwc3_readl fndecl 0 49455 NULL nohasharray
+get_setup_data_total_num_fndecl_49455_fields get_setup_data_total_num fndecl 1 49455 &dwc3_readl_fndecl_49455_fields
+ch_count_srp_target_port_49465_fields ch_count srp_target_port 0 49465 NULL
+usb_tx_block_fndecl_49466_fields usb_tx_block fndecl 3 49466 NULL
+len_r6040_descriptor_49471_fields len r6040_descriptor 0 49471 NULL
+s_cblkno_ufs_sb_private_info_49472_fields s_cblkno ufs_sb_private_info 0 49472 NULL
+ks8995_read_fndecl_49475_fields ks8995_read fndecl 4 49475 NULL
+nf_nat_icmpv6_reply_translation_fndecl_49476_fields nf_nat_icmpv6_reply_translation fndecl 5 49476 NULL
+make_rx_response_fndecl_49477_fields make_rx_response fndecl 5-3-4 49477 NULL
+mc_mask_amdgpu_mc_49478_fields mc_mask amdgpu_mc 0 49478 NULL nohasharray
+rpc_max_payload_fndecl_49478_fields rpc_max_payload fndecl 0 49478 &mc_mask_amdgpu_mc_49478_fields
+iomap_write_begin_fndecl_49486_fields iomap_write_begin fndecl 2-3 49486 NULL
+i2c_readn_fndecl_49490_fields i2c_readn fndecl 4 49490 NULL
+xfs_file_llseek_fndecl_49492_fields xfs_file_llseek fndecl 2 49492 NULL nohasharray
+length_nvme_sgl_desc_49492_fields length nvme_sgl_desc 0 49492 &xfs_file_llseek_fndecl_49492_fields
+din_xfer_len_sg_io_v4_49498_fields din_xfer_len sg_io_v4 0 49498 NULL
+rd_size_uhid_create2_req_49499_fields rd_size uhid_create2_req 0 49499 NULL
+smb_send_fndecl_49500_fields smb_send fndecl 3 49500 NULL
+usCRTC_H_Total__ATOM_MODE_TIMING_49501_fields usCRTC_H_Total _ATOM_MODE_TIMING 0 49501 NULL
+__radix_tree_create_fndecl_49505_fields __radix_tree_create fndecl 0 49505 NULL
+intel_framebuffer_create_for_mode_fndecl_49508_fields intel_framebuffer_create_for_mode fndecl 4 49508 NULL nohasharray
+l2cap_create_iframe_pdu_fndecl_49508_fields l2cap_create_iframe_pdu fndecl 3 49508 &intel_framebuffer_create_for_mode_fndecl_49508_fields nohasharray
+__bnx2x_get_preset_regs_len_fndecl_49508_fields __bnx2x_get_preset_regs_len fndecl 0 49508 &l2cap_create_iframe_pdu_fndecl_49508_fields nohasharray
+add_tty_fndecl_49508_fields add_tty fndecl 1 49508 &__bnx2x_get_preset_regs_len_fndecl_49508_fields
+tx_blk_size_rsi_91x_sdiodev_49511_fields tx_blk_size rsi_91x_sdiodev 0 49511 NULL
+usbvision_write_reg_irq_fndecl_49516_fields usbvision_write_reg_irq fndecl 4 49516 NULL
+buf_size_sge_fl_49517_fields buf_size sge_fl 0 49517 NULL
+Zmin_hfc_multi_49520_fields Zmin hfc_multi 0 49520 NULL
+log_mtts_per_seg_vardecl_mthca_main_c_49524_fields log_mtts_per_seg vardecl_mthca_main.c 0 49524 NULL
+num_eps_bdc_49525_fields num_eps bdc 0 49525 NULL
+mtt_entry_sz_mlx4_caps_49531_fields mtt_entry_sz mlx4_caps 0 49531 NULL
+consume_bytes_snd_fw_async_midi_port_49542_fields consume_bytes snd_fw_async_midi_port 0 49542 NULL
+disk_offset_pnfs_block_dev_map_49546_fields disk_offset pnfs_block_dev_map 0 49546 NULL
+lpfc_debugfs_hbqinfo_data_fndecl_49551_fields lpfc_debugfs_hbqinfo_data fndecl 0 49551 NULL
+ioremap_wt_fndecl_49562_fields ioremap_wt fndecl 2-1 49562 NULL
+nrs_num_pols_ptlrpc_nrs_49564_fields nrs_num_pols ptlrpc_nrs 0 49564 NULL
+nilfs_mdt_delete_block_fndecl_49565_fields nilfs_mdt_delete_block fndecl 2 49565 NULL nohasharray
+vfs_readv_fndecl_49565_fields vfs_readv fndecl 3 49565 &nilfs_mdt_delete_block_fndecl_49565_fields
+max_cm_mtu_ipoib_cm_dev_priv_49566_fields max_cm_mtu ipoib_cm_dev_priv 0 49566 NULL
+xfs_insert_file_space_fndecl_49569_fields xfs_insert_file_space fndecl 2-3 49569 NULL
+snd_soc_dapm_new_pcm_fndecl_49572_fields snd_soc_dapm_new_pcm fndecl 3 49572 NULL
+ncp_request2_fndecl_49589_fields ncp_request2 fndecl 4 49589 NULL
+ssid_length_beacon_format_49591_fields ssid_length beacon_format 0 49591 NULL
+xfs_rtbuf_get_fndecl_49592_fields xfs_rtbuf_get fndecl 3-0 49592 NULL
+width_vim2m_q_data_49600_fields width vim2m_q_data 0 49600 NULL
+drm_display_info_set_bus_formats_fndecl_49607_fields drm_display_info_set_bus_formats fndecl 3 49607 NULL
+tot_num_rules_mlx5e_ethtool_steering_49612_fields tot_num_rules mlx5e_ethtool_steering 0 49612 NULL
+hsync_start_drm_display_mode_49613_fields hsync_start drm_display_mode 0 49613 NULL nohasharray
+ppm_get_cpu_entries_fndecl_49613_fields ppm_get_cpu_entries fndecl 0 49613 &hsync_start_drm_display_mode_49613_fields nohasharray
+start_drm_mm_node_49613_fields start drm_mm_node 0 49613 &ppm_get_cpu_entries_fndecl_49613_fields
+spare_bytes_per_page_nand_onfi_params_49617_fields spare_bytes_per_page nand_onfi_params 0 49617 NULL
+lengthExtendedAttr_extendedFileEntry_49618_fields lengthExtendedAttr extendedFileEntry 0 49618 NULL
+write_cmd_usb_fndecl_49619_fields write_cmd_usb fndecl 3 49619 NULL
+ieee80211_tdls_add_setup_cfm_ies_fndecl_49620_fields ieee80211_tdls_add_setup_cfm_ies fndecl 6 49620 NULL
+reg_read_range_fndecl_49623_fields reg_read_range fndecl 4-0 49623 NULL
+nn_nvme_id_ctrl_49625_fields nn nvme_id_ctrl 0 49625 NULL
+srsize_brcmf_chip_49639_fields srsize brcmf_chip 0 49639 NULL
+list_size_of_flash_49643_fields list_size of_flash 0 49643 NULL
+start_io_failure_record_49645_fields start io_failure_record 0 49645 NULL
+align_resource_constraint_49647_fields align resource_constraint 0 49647 NULL
+mlx4_alloc_icm_pages_fndecl_49658_fields mlx4_alloc_icm_pages fndecl 2 49658 NULL
+size_i915_ggtt_49666_fields size i915_ggtt 0 49666 NULL
+dwMaxPayloadTransferSize_uvc_streaming_control_49668_fields dwMaxPayloadTransferSize uvc_streaming_control 0 49668 NULL
+bytes_ubi_leb_change_req_49669_fields bytes ubi_leb_change_req 0 49669 NULL
+tipc_node_get_mtu_fndecl_49670_fields tipc_node_get_mtu fndecl 0 49670 NULL
+placement_offset_eth_fast_path_rx_reg_cqe_49676_fields placement_offset eth_fast_path_rx_reg_cqe 0 49676 NULL
+intel_gtt_map_memory_fndecl_49677_fields intel_gtt_map_memory fndecl 2 49677 NULL
+port_priv_size_team_mode_49682_fields port_priv_size team_mode 0 49682 NULL
+clk_core_get_rate_nolock_fndecl_49685_fields clk_core_get_rate_nolock fndecl 0 49685 NULL
+alt_name_store_fndecl_49688_fields alt_name_store fndecl 4 49688 NULL
+set_extent_bit_fndecl_49692_fields set_extent_bit fndecl 3-2 49692 NULL
+pnode_uv_gam_range_entry_49695_fields pnode uv_gam_range_entry 0 49695 NULL nohasharray
+slider_num_ad714x_platform_data_49695_fields slider_num ad714x_platform_data 0 49695 &pnode_uv_gam_range_entry_49695_fields
+s_segshift_logfs_super_49707_fields s_segshift logfs_super 0 49707 NULL
+end_resource_49712_fields end resource 0 49712 NULL
+fuse_readpages_fndecl_49714_fields fuse_readpages fndecl 4 49714 NULL
+xfs_iext_remove_direct_fndecl_49723_fields xfs_iext_remove_direct fndecl 3 49723 NULL
+IOCMaxChainSegmentSize_mpt3sas_facts_49724_fields IOCMaxChainSegmentSize mpt3sas_facts 0 49724 NULL
+sof_len_sd_49729_fields sof_len sd 0 49729 NULL
+num_uars_mthca_limits_49735_fields num_uars mthca_limits 0 49735 NULL
+pyra_sysfs_read_fndecl_49736_fields pyra_sysfs_read fndecl 6 49736 NULL
+wqe_size_ib_uverbs_post_recv_49738_fields wqe_size ib_uverbs_post_recv 0 49738 NULL
+xfs_bmap_split_extent_fndecl_49740_fields xfs_bmap_split_extent fndecl 2 49740 NULL
+udf_prealloc_blocks_fndecl_49747_fields udf_prealloc_blocks fndecl 0-5 49747 NULL
+hpfs_add_dirent_fndecl_49754_fields hpfs_add_dirent fndecl 3 49754 NULL
+provider_in_words_ib_uverbs_ex_cmd_hdr_49757_fields provider_in_words ib_uverbs_ex_cmd_hdr 0 49757 NULL
+ngroups_netlink_sock_49758_fields ngroups netlink_sock 0 49758 NULL
+match_size_compat_ebt_entry_mwt_49763_fields match_size compat_ebt_entry_mwt 0 49763 NULL
+nl80211_send_roamed_fndecl_49770_fields nl80211_send_roamed fndecl 5-7 49770 NULL
+cifs_sign_smbv_fndecl_49776_fields cifs_sign_smbv fndecl 2 49776 NULL
+sprom_size_ssb_bus_49781_fields sprom_size ssb_bus 0 49781 NULL
+page2_len_ses_device_49783_fields page2_len ses_device 0 49783 NULL
+seeks_shrinker_49793_fields seeks shrinker 0 49793 NULL
+outlen_mimd_49796_fields outlen mimd 0 49796 NULL
+substream_alloc_pages_fndecl_49800_fields substream_alloc_pages fndecl 3 49800 NULL
+n_mmc_ies_whc_49802_fields n_mmc_ies whc 0 49802 NULL
+ocfs2_zero_partial_clusters_fndecl_49803_fields ocfs2_zero_partial_clusters fndecl 2-3 49803 NULL
+max_fib_size_aac_dev_49804_fields max_fib_size aac_dev 0 49804 NULL
+num_uar_mthca_profile_49807_fields num_uar mthca_profile 0 49807 NULL
+__udf_add_aext_fndecl_49811_fields __udf_add_aext fndecl 4 49811 NULL
+fat_chain_add_fndecl_49812_fields fat_chain_add fndecl 2 49812 NULL
+fat_bits_msdos_sb_info_49817_fields fat_bits msdos_sb_info 0 49817 NULL
+reserved_fat_boot_sector_49818_fields reserved fat_boot_sector 0 49818 NULL
+nr_pages_flash_info_49822_fields nr_pages flash_info 0 49822 NULL
+elemsize_nft_set_ops_49830_fields elemsize nft_set_ops 0 49830 NULL
+wl12xx_cmd_build_probe_req_fndecl_49835_fields wl12xx_cmd_build_probe_req fndecl 10-8-6 49835 NULL
+fifosize_uart_port_49843_fields fifosize uart_port 0 49843 NULL
+gen9_get_stolen_size_fndecl_49846_fields gen9_get_stolen_size fndecl 0-1 49846 NULL
+read_endpoint_s2255_dev_49848_fields read_endpoint s2255_dev 0 49848 NULL
+scsi_send_eh_cmnd_fndecl_49849_fields scsi_send_eh_cmnd fndecl 5 49849 NULL
+plen_c4iw_ep_49856_fields plen c4iw_ep 0 49856 NULL nohasharray
+vol_cdev_write_fndecl_49856_fields vol_cdev_write fndecl 3 49856 &plen_c4iw_ep_49856_fields
+kempld_gpio_pincount_fndecl_49860_fields kempld_gpio_pincount fndecl 0 49860 NULL
+__kfifo_init_fndecl_49861_fields __kfifo_init fndecl 4 49861 NULL
+si_get_csb_size_fndecl_49864_fields si_get_csb_size fndecl 0 49864 NULL
+bucket_bits_cache_set_49869_fields bucket_bits cache_set 0 49869 NULL
+record_inode_for_nocow_fndecl_49872_fields record_inode_for_nocow fndecl 2 49872 NULL
+__i915_error_seek_fndecl_49882_fields __i915_error_seek fndecl 2 49882 NULL
+sg_alloc_table_fndecl_49895_fields sg_alloc_table fndecl 2-0 49895 NULL
+offset_drm_i915_gem_pwrite_49896_fields offset drm_i915_gem_pwrite 0 49896 NULL nohasharray
+iwl_mvm_create_skb_fndecl_49896_fields iwl_mvm_create_skb fndecl 4-3 49896 &offset_drm_i915_gem_pwrite_49896_fields
+max_desc_sz_mthca_dev_lim_49905_fields max_desc_sz mthca_dev_lim 0 49905 NULL
+block_descriptor_length_scsi_mode_data_49918_fields block_descriptor_length scsi_mode_data 0 49918 NULL
+cx18_prepare_buffer_fndecl_49942_fields cx18_prepare_buffer fndecl 6-5 49942 NULL
+repair_io_failure_fndecl_49943_fields repair_io_failure fndecl 6-3 49943 NULL
+internal_ewma_pkt_len_49944_fields internal ewma_pkt_len 0 49944 NULL
+rcvcnt_elsa_hw_49949_fields rcvcnt elsa_hw 0 49949 NULL
+segsize_rem_dn_scp_49951_fields segsize_rem dn_scp 0 49951 NULL
+smbus_xfer_i2c_algorithm_49954_fields smbus_xfer i2c_algorithm 0 49954 NULL
+len_lmc_xilinx_control_49960_fields len lmc_xilinx_control 0 49960 NULL
+xfs_iread_extents_fndecl_49965_fields xfs_iread_extents fndecl 0 49965 NULL
+afs_fs_store_data_fndecl_49975_fields afs_fs_store_data fndecl 5-6 49975 NULL
+dig_in_nid_hda_gen_spec_49979_fields dig_in_nid hda_gen_spec 0 49979 NULL
+subtract_range_fndecl_49980_fields subtract_range fndecl 3-4 49980 NULL nohasharray
+tty_write_room_fndecl_49980_fields tty_write_room fndecl 0 49980 &subtract_range_fndecl_49980_fields
+__radix_tree_insert_fndecl_49981_fields __radix_tree_insert fndecl 0 49981 NULL
+__mms114_read_reg_fndecl_49983_fields __mms114_read_reg fndecl 3 49983 NULL
+eqc_entry_sz_mthca_dev_lim_49984_fields eqc_entry_sz mthca_dev_lim 0 49984 NULL
+pgbase_nfs3_readlinkargs_49993_fields pgbase nfs3_readlinkargs 0 49993 NULL
+leafblk_xfs_da_geometry_49997_fields leafblk xfs_da_geometry 0 49997 NULL
+batadv_check_unicast_ttvn_fndecl_49999_fields batadv_check_unicast_ttvn fndecl 3 49999 NULL nohasharray
+make_checksum_fndecl_49999_fields make_checksum fndecl 3-5 49999 &batadv_check_unicast_ttvn_fndecl_49999_fields
+block_isofs_iget5_callback_data_50000_fields block isofs_iget5_callback_data 0 50000 NULL
+vbi_v_start_0_saa7134_tvnorm_50002_fields vbi_v_start_0 saa7134_tvnorm 0 50002 NULL
+delete_object_part_fndecl_50007_fields delete_object_part fndecl 2-1 50007 NULL
+ip6_err_gen_icmpv6_unreach_fndecl_50009_fields ip6_err_gen_icmpv6_unreach fndecl 2 50009 NULL
+tcm_qla2xxx_handle_cmd_fndecl_50016_fields tcm_qla2xxx_handle_cmd fndecl 4 50016 NULL nohasharray
+nci_core_cmd_fndecl_50016_fields nci_core_cmd fndecl 3 50016 &tcm_qla2xxx_handle_cmd_fndecl_50016_fields
+bi_size_bvec_iter_50026_fields bi_size bvec_iter 0 50026 NULL nohasharray
+bl_alloc_init_bio_fndecl_50026_fields bl_alloc_init_bio fndecl 3-1 50026 &bi_size_bvec_iter_50026_fields
+snd_oss_kernel_minor_fndecl_50028_fields snd_oss_kernel_minor fndecl 0 50028 NULL
+length_fotg210_qtd_50029_fields length fotg210_qtd 0 50029 NULL
+BlockMultiplierBits_INFTLMediaHeader_50032_fields BlockMultiplierBits INFTLMediaHeader 0 50032 NULL
+depth_zoran_format_50033_fields depth zoran_format 0 50033 NULL
+f_dac_hackrf_dev_50035_fields f_dac hackrf_dev 0 50035 NULL
+qed_rd_fndecl_50037_fields qed_rd fndecl 0 50037 NULL
+pwc_vidioc_fill_fmt_fndecl_50048_fields pwc_vidioc_fill_fmt fndecl 2-3 50048 NULL
+len_nft_userdata_50052_fields len nft_userdata 0 50052 NULL
+skge_rx_get_fndecl_50053_fields skge_rx_get fndecl 3 50053 NULL
+num_crtc_amdgpu_mode_info_50055_fields num_crtc amdgpu_mode_info 0 50055 NULL
+lba_to_map_index_fndecl_50071_fields lba_to_map_index fndecl 0-1 50071 NULL
+sem_nsems_sem_array_50085_fields sem_nsems sem_array 0 50085 NULL nohasharray
+sch56xx_find_fndecl_50085_fields sch56xx_find fndecl 0 50085 &sem_nsems_sem_array_50085_fields
+total_len_splice_desc_50112_fields total_len splice_desc 0 50112 NULL
+fst_rx_dma_complete_fndecl_50118_fields fst_rx_dma_complete fndecl 3 50118 NULL
+__cfg80211_roamed_fndecl_50127_fields __cfg80211_roamed fndecl 4-6 50127 NULL
+get_current_nat_page_fndecl_50130_fields get_current_nat_page fndecl 2 50130 NULL
+i_files_ceph_inode_info_50132_fields i_files ceph_inode_info 0 50132 NULL
+num_entries_ip6t_replace_50138_fields num_entries ip6t_replace 0 50138 NULL
+cutlen_ovs_skb_cb_50141_fields cutlen ovs_skb_cb 0 50141 NULL
+usb_tx_block_fndecl_50144_fields usb_tx_block fndecl 3 50144 NULL
+vendpoint_pwc_device_50145_fields vendpoint pwc_device 0 50145 NULL
+htotal_drm_display_mode_50148_fields htotal drm_display_mode 0 50148 NULL
+idr_get_empty_slot_fndecl_50161_fields idr_get_empty_slot fndecl 0 50161 NULL
+ext4_mark_inode_dirty_fndecl_50162_fields ext4_mark_inode_dirty fndecl 0 50162 NULL
+fops_read_fndecl_50163_fields fops_read fndecl 3 50163 NULL nohasharray
+length_ib_ip_iocb_rsp_50163_fields length ib_ip_iocb_rsp 0 50163 &fops_read_fndecl_50163_fields
+next_burst_len_iscsi_cmd_50168_fields next_burst_len iscsi_cmd 0 50168 NULL
+rd_buf_size_xilly_channel_50171_fields rd_buf_size xilly_channel 0 50171 NULL
+hdr_len_atm_flow_data_50178_fields hdr_len atm_flow_data 0 50178 NULL
+ubi_more_update_data_fndecl_50182_fields ubi_more_update_data fndecl 4 50182 NULL
+__isofs_iget_fndecl_50194_fields __isofs_iget fndecl 2 50194 NULL
+amdgpu_sched_hw_submission_vardecl_50202_fields amdgpu_sched_hw_submission vardecl 0 50202 NULL
+gbufsize_vardecl_meye_c_50205_fields gbufsize vardecl_meye.c 0 50205 NULL
+length_dfw_binrec_50222_fields length dfw_binrec 0 50222 NULL
+pin_pci_dev_50231_fields pin pci_dev 0 50231 NULL
+qla4_82xx_pci_mem_read_direct_fndecl_50235_fields qla4_82xx_pci_mem_read_direct fndecl 2 50235 NULL
+efi_memmap_size_efi_info_50236_fields efi_memmap_size efi_info 0 50236 NULL
+r128_compat_ioctl_fndecl_50241_fields r128_compat_ioctl fndecl 2 50241 NULL
+i915_error_state_read_fndecl_50245_fields i915_error_state_read fndecl 3 50245 NULL
+fnic_trace_max_pages_vardecl_50246_fields fnic_trace_max_pages vardecl 0 50246 NULL
+h_tot_disp_crtc_50258_fields h_tot_disp crtc 0 50258 NULL
+len_mrp_attr_50262_fields len mrp_attr 0 50262 NULL
+bLength_usb_ss_ep_comp_descriptor_50270_fields bLength usb_ss_ep_comp_descriptor 0 50270 NULL nohasharray
+end_range_50270_fields end range 0 50270 &bLength_usb_ss_ep_comp_descriptor_50270_fields
+vframes_pwc_device_50272_fields vframes pwc_device 0 50272 NULL
+curr_resync_completed_mddev_50273_fields curr_resync_completed mddev 0 50273 NULL
+count_defcmd_set_50274_fields count defcmd_set 0 50274 NULL
+phys_amd76xrom_window_50277_fields phys amd76xrom_window 0 50277 NULL
+ath6kl_wmi_set_appie_cmd_fndecl_50289_fields ath6kl_wmi_set_appie_cmd fndecl 5-2 50289 NULL
+mwifiex_append_rsn_ie_wpa_wpa2_fndecl_50296_fields mwifiex_append_rsn_ie_wpa_wpa2 fndecl 0 50296 NULL nohasharray
+gpioled_count_f30_data_50296_fields gpioled_count f30_data 0 50296 &mwifiex_append_rsn_ie_wpa_wpa2_fndecl_50296_fields
+insert_reserved_file_extent_fndecl_50316_fields insert_reserved_file_extent fndecl 6-3-7 50316 NULL
+__cfg80211_connect_result_fndecl_50317_fields __cfg80211_connect_result fndecl 4-6 50317 NULL
+scif_rma_copy_fndecl_50320_fields scif_rma_copy fndecl 2-5-4-3 50320 NULL
+rbytes_ceph_mds_reply_inode_50321_fields rbytes ceph_mds_reply_inode 0 50321 NULL
+VST_kyrofb_info_50324_fields VST kyrofb_info 0 50324 NULL
+level_guest_walker64_50325_fields level guest_walker64 0 50325 NULL
+ucNumEntries__ATOM_PPLIB_CAC_Leakage_Table_50326_fields ucNumEntries _ATOM_PPLIB_CAC_Leakage_Table 0 50326 NULL
+pos_r5l_recovery_ctx_50328_fields pos r5l_recovery_ctx 0 50328 NULL
+size_nand_ecc_ctrl_50335_fields size nand_ecc_ctrl 0 50335 NULL
+aim_read_fndecl_50336_fields aim_read fndecl 3 50336 NULL
+__copy_from_user_nocache_fndecl_50340_fields __copy_from_user_nocache fndecl 0 50340 NULL
+nextindex_xtheader_50354_fields nextindex xtheader 0 50354 NULL
+wimax_msg_alloc_fndecl_50364_fields wimax_msg_alloc fndecl 4 50364 NULL
+__send_to_port_fndecl_50377_fields __send_to_port fndecl 3 50377 NULL
+table_size_amdgpu_gart_50380_fields table_size amdgpu_gart 0 50380 NULL
+num_tc_qede_dev_50384_fields num_tc qede_dev 0 50384 NULL
+NumberOfReferrals_smb_com_transaction_get_dfs_refer_rsp_50387_fields NumberOfReferrals smb_com_transaction_get_dfs_refer_rsp 0 50387 NULL
+max_write_len_cftype_50399_fields max_write_len cftype 0 50399 NULL
+ocfs2_xattr_user_set_fndecl_50407_fields ocfs2_xattr_user_set fndecl 6 50407 NULL
+init_urbs_fndecl_50408_fields init_urbs fndecl 2-4-5 50408 NULL
+sgx_offset_psb_ops_50417_fields sgx_offset psb_ops 0 50417 NULL
+length_acpi_srat_mem_affinity_50419_fields length acpi_srat_mem_affinity 0 50419 NULL
+__initramfs_size_vardecl_50420_fields __initramfs_size vardecl 0 50420 NULL nohasharray
+jffs2_scan_xattr_node_fndecl_50420_fields jffs2_scan_xattr_node fndecl 4 50420 &__initramfs_size_vardecl_50420_fields
+sd_max_rg_data_gfs2_sbd_50430_fields sd_max_rg_data gfs2_sbd 0 50430 NULL
+__vcc_connect_fndecl_50431_fields __vcc_connect fndecl 4-3 50431 NULL
+nilfs_gccache_submit_read_data_fndecl_50434_fields nilfs_gccache_submit_read_data fndecl 3-4 50434 NULL
+nr_phys_segments_request_50449_fields nr_phys_segments request 0 50449 NULL nohasharray
+nfsd4_encode_fattr_to_buf_fndecl_50449_fields nfsd4_encode_fattr_to_buf fndecl 2 50449 &nr_phys_segments_request_50449_fields
+extra_tx_headroom_ieee802154_hw_50457_fields extra_tx_headroom ieee802154_hw 0 50457 NULL
+fec_read_parity_fndecl_50461_fields fec_read_parity fndecl 2-3 50461 NULL
+iscsi_iolen_cxgb4_lld_info_50467_fields iscsi_iolen cxgb4_lld_info 0 50467 NULL
+vmw_cmdbuf_reserve_cur_fndecl_50468_fields vmw_cmdbuf_reserve_cur fndecl 2 50468 NULL
+__ath6kl_wmi_send_mgmt_cmd_fndecl_50472_fields __ath6kl_wmi_send_mgmt_cmd fndecl 2 50472 NULL
+paylen_rxe_pkt_info_50479_fields paylen rxe_pkt_info 0 50479 NULL
+len_fuse_ioctl_iovec_50481_fields len fuse_ioctl_iovec 0 50481 NULL
+snd_sbmixer_add_ctl_fndecl_50491_fields snd_sbmixer_add_ctl fndecl 5 50491 NULL
+max_pages_nilfs_write_info_50494_fields max_pages nilfs_write_info 0 50494 NULL
+udf_new_block_fndecl_50500_fields udf_new_block fndecl 0 50500 NULL
+bio_clone_range_fndecl_50502_fields bio_clone_range fndecl 2-3 50502 NULL
+mwifiex_read_data_sync_fndecl_50504_fields mwifiex_read_data_sync fndecl 3 50504 NULL
+readahead_tree_block_fndecl_50505_fields readahead_tree_block fndecl 2 50505 NULL
+i2c_hid_output_report_fndecl_50508_fields i2c_hid_output_report fndecl 3 50508 NULL
+t4vf_pktgl_to_skb_fndecl_50510_fields t4vf_pktgl_to_skb fndecl 3 50510 NULL
+usb_maxpacket_fndecl_50514_fields usb_maxpacket fndecl 0 50514 NULL nohasharray
+adfs_fplus_read_fndecl_50514_fields adfs_fplus_read fndecl 2 50514 &usb_maxpacket_fndecl_50514_fields
+len_nfs3_mkdirargs_50515_fields len nfs3_mkdirargs 0 50515 NULL
+nframes_cdrom_read_audio_50517_fields nframes cdrom_read_audio 0 50517 NULL nohasharray
+__alt_name_store_fndecl_50517_fields __alt_name_store fndecl 3 50517 &nframes_cdrom_read_audio_50517_fields
+ohci_urb_dequeue_fndecl_50529_fields ohci_urb_dequeue fndecl 3 50529 NULL
+rtmax_nfs_fsinfo_50537_fields rtmax nfs_fsinfo 0 50537 NULL nohasharray
+dccpd_seq_dccp_skb_cb_50537_fields dccpd_seq dccp_skb_cb 0 50537 &rtmax_nfs_fsinfo_50537_fields
+ext4_xattr_trusted_set_fndecl_50538_fields ext4_xattr_trusted_set fndecl 6 50538 NULL
+spi_rd8_fndecl_50555_fields spi_rd8 fndecl 0 50555 NULL
+frag_threshold_wiphy_50556_fields frag_threshold wiphy 0 50556 NULL
+__blkdev_issue_zeroout_fndecl_50559_fields __blkdev_issue_zeroout fndecl 3-0-2 50559 NULL
+gen_pool_create_fndecl_50571_fields gen_pool_create fndecl 1 50571 NULL
+img_y_zoran_jpg_settings_50573_fields img_y zoran_jpg_settings 0 50573 NULL nohasharray
+W6692_empty_fifo_fndecl_50573_fields W6692_empty_fifo fndecl 2 50573 &img_y_zoran_jpg_settings_50573_fields
+hdr_len_ib_mad_send_buf_50577_fields hdr_len ib_mad_send_buf 0 50577 NULL nohasharray
+_osd_req_alist_size_fndecl_50577_fields _osd_req_alist_size fndecl 0 50577 &hdr_len_ib_mad_send_buf_50577_fields
+xfs_attr_calc_size_fndecl_50579_fields xfs_attr_calc_size fndecl 0 50579 NULL
+length_fuse_page_desc_50581_fields length fuse_page_desc 0 50581 NULL
+kcm_tcp_recv_fndecl_50586_fields kcm_tcp_recv fndecl 4-3 50586 NULL
+off2_xad_50592_fields off2 xad 0 50592 NULL
+count_ORANGEFS_dev_map_desc_50596_fields count ORANGEFS_dev_map_desc 0 50596 NULL
+intel_gtt_total_entries_fndecl_50599_fields intel_gtt_total_entries fndecl 0 50599 NULL
+__i915_gem_userptr_set_pages_fndecl_50600_fields __i915_gem_userptr_set_pages fndecl 3 50600 NULL
+ipoib_max_conn_qp_vardecl_50615_fields ipoib_max_conn_qp vardecl 0 50615 NULL
+len_fuse_notify_inval_inode_out_50619_fields len fuse_notify_inval_inode_out 0 50619 NULL nohasharray
+dle_count__isdn_audio_data_50619_fields dle_count _isdn_audio_data 0 50619 &len_fuse_notify_inval_inode_out_50619_fields
+zr364xx_fillbuff_fndecl_50623_fields zr364xx_fillbuff fndecl 3 50623 NULL nohasharray
+cb_mirror_cnt_exofs_dt_data_map_50623_fields cb_mirror_cnt exofs_dt_data_map 0 50623 &zr364xx_fillbuff_fndecl_50623_fields
+phys_port_cnt_ib_device_50625_fields phys_port_cnt ib_device 0 50625 NULL
+pglen_nfs3_readlinkargs_50630_fields pglen nfs3_readlinkargs 0 50630 NULL nohasharray
+data_len_pmcraid_hcam_hdr_50630_fields data_len pmcraid_hcam_hdr 0 50630 &pglen_nfs3_readlinkargs_50630_fields
+l2tp_ip6_recvmsg_fndecl_50633_fields l2tp_ip6_recvmsg fndecl 3 50633 NULL
+ircomm_tty_write_fndecl_50642_fields ircomm_tty_write fndecl 3 50642 NULL
+num_regs_soc_bytes_50648_fields num_regs soc_bytes 0 50648 NULL
+usb_hcd_giveback_urb_fndecl_50649_fields usb_hcd_giveback_urb fndecl 3 50649 NULL
+pvid_net_bridge_vlan_group_50651_fields pvid net_bridge_vlan_group 0 50651 NULL
+recalc_rate_clk_ops_50655_fields recalc_rate clk_ops 0 50655 NULL
+io_size_tulip_chip_table_50656_fields io_size tulip_chip_table 0 50656 NULL
+f2fs_replace_block_fndecl_50663_fields f2fs_replace_block fndecl 4 50663 NULL
+ucNumEntries__ATOM_Tonga_SCLK_Dependency_Table_50666_fields ucNumEntries _ATOM_Tonga_SCLK_Dependency_Table 0 50666 NULL
+i915_gem_alloc_context_obj_fndecl_50671_fields i915_gem_alloc_context_obj fndecl 2 50671 NULL
+nclips_bttv_overlay_50673_fields nclips bttv_overlay 0 50673 NULL
+dig_in_ca0132_spec_50677_fields dig_in ca0132_spec 0 50677 NULL
+size_snd_util_memblk_50679_fields size snd_util_memblk 0 50679 NULL nohasharray
+pci_iomap_wc_fndecl_50679_fields pci_iomap_wc fndecl 3 50679 &size_snd_util_memblk_50679_fields nohasharray
+__kernfs_create_file_fndecl_50679_fields __kernfs_create_file fndecl 4 50679 &pci_iomap_wc_fndecl_50679_fields
+count_dm_io_region_50683_fields count dm_io_region 0 50683 NULL
+sr_offset_nfs42_seek_res_50684_fields sr_offset nfs42_seek_res 0 50684 NULL
+generic_permission_fndecl_50685_fields generic_permission fndecl 0 50685 NULL
+rxkad_secure_packet_encrypt_fndecl_50687_fields rxkad_secure_packet_encrypt fndecl 3 50687 NULL
+dm_bm_read_try_lock_fndecl_50688_fields dm_bm_read_try_lock fndecl 2 50688 NULL
+back_xfs_da3_icnode_hdr_50715_fields back xfs_da3_icnode_hdr 0 50715 NULL
+sc18is602_wait_ready_fndecl_50717_fields sc18is602_wait_ready fndecl 0 50717 NULL
+num_lbufq_entries_ql3_adapter_50721_fields num_lbufq_entries ql3_adapter 0 50721 NULL nohasharray
+ibnl_put_msg_fndecl_50721_fields ibnl_put_msg fndecl 4 50721 &num_lbufq_entries_ql3_adapter_50721_fields
+mpdu_header_off_wcn36xx_pdu_50723_fields mpdu_header_off wcn36xx_pdu 0 50723 NULL
+max_table_count_acpi_table_list_50733_fields max_table_count acpi_table_list 0 50733 NULL
+max_mr_size_ib_device_attr_50735_fields max_mr_size ib_device_attr 0 50735 NULL nohasharray
+sector_size_blkfront_info_50735_fields sector_size blkfront_info 0 50735 &max_mr_size_ib_device_attr_50735_fields
+data_size_usbtouch_usb_50738_fields data_size usbtouch_usb 0 50738 NULL
+MaximumDataTransferSizeInBlocks_DAC960_V2_ControllerInfo_50742_fields MaximumDataTransferSizeInBlocks DAC960_V2_ControllerInfo 0 50742 NULL nohasharray
+rx_count_st_data_s_50742_fields rx_count st_data_s 0 50742 &MaximumDataTransferSizeInBlocks_DAC960_V2_ControllerInfo_50742_fields
+opt_flen_ipv6_txoptions_50747_fields opt_flen ipv6_txoptions 0 50747 NULL
+nicvf_change_mtu_fndecl_50748_fields nicvf_change_mtu fndecl 2 50748 NULL
+i_dataoffset_romfs_inode_info_50755_fields i_dataoffset romfs_inode_info 0 50755 NULL
+root_len_ubifs_mst_node_50757_fields root_len ubifs_mst_node 0 50757 NULL
+cluster_bits_msdos_sb_info_50763_fields cluster_bits msdos_sb_info 0 50763 NULL
+usb_hcd_map_urb_for_dma_fndecl_50765_fields usb_hcd_map_urb_for_dma fndecl 0 50765 NULL
+cifs_readpages_read_into_pages_fndecl_50770_fields cifs_readpages_read_into_pages fndecl 3 50770 NULL
+hpfs_get_sector_fndecl_50776_fields hpfs_get_sector fndecl 2 50776 NULL
+vmap_fndecl_50778_fields vmap fndecl 2 50778 NULL
+cmd_size_blk_mq_tag_set_50782_fields cmd_size blk_mq_tag_set 0 50782 NULL
+readdir_nfs_rpc_ops_50783_fields readdir nfs_rpc_ops 0 50783 NULL
+remove_pmkid_fndecl_50793_fields remove_pmkid fndecl 4 50793 NULL
+len_rfd_50801_fields len rfd 0 50801 NULL
+argslen_svc_deferred_req_50807_fields argslen svc_deferred_req 0 50807 NULL nohasharray
+cmdQueueSize_sis_video_info_50807_fields cmdQueueSize sis_video_info 0 50807 &argslen_svc_deferred_req_50807_fields
+hpfs_map_dnode_fndecl_50813_fields hpfs_map_dnode fndecl 2 50813 NULL
+clkrc_ov7670_info_50815_fields clkrc ov7670_info 0 50815 NULL
+cdce925_regmap_i2c_read_fndecl_50819_fields cdce925_regmap_i2c_read fndecl 5 50819 NULL
+rq_nvec_smb_rqst_50820_fields rq_nvec smb_rqst 0 50820 NULL
+xdr_read_pages_fndecl_50824_fields xdr_read_pages fndecl 2 50824 NULL nohasharray
+bcast_ring_order_vardecl_main_c_50824_fields bcast_ring_order vardecl_main.c 0 50824 &xdr_read_pages_fndecl_50824_fields
+t_tinc_data_rem_rds_tcp_connection_50828_fields t_tinc_data_rem rds_tcp_connection 0 50828 NULL
+bssid_info_count_ndis_80211_pmkid_50829_fields bssid_info_count ndis_80211_pmkid 0 50829 NULL
+filelayout_get_dserver_offset_fndecl_50833_fields filelayout_get_dserver_offset fndecl 0-2 50833 NULL
+m_rsumlevels_xfs_mount_50843_fields m_rsumlevels xfs_mount 0 50843 NULL
+_brk_end_vardecl_50849_fields _brk_end vardecl 0 50849 NULL
+journal_read_transaction_fndecl_50853_fields journal_read_transaction fndecl 2 50853 NULL
+x2_drm_clip_rect_50854_fields x2 drm_clip_rect 0 50854 NULL
+fm10k_read_pci_cfg_word_fndecl_50857_fields fm10k_read_pci_cfg_word fndecl 0 50857 NULL
+dat_offset_brcmf_sdio_hdrinfo_50859_fields dat_offset brcmf_sdio_hdrinfo 0 50859 NULL
+rrpc_l2p_update_fndecl_50868_fields rrpc_l2p_update fndecl 1 50868 NULL
+alg_key_len_xfrm_algo_auth_50871_fields alg_key_len xfrm_algo_auth 0 50871 NULL
+mtu_adj_ipvl_dev_50874_fields mtu_adj ipvl_dev 0 50874 NULL
+collapse_huge_page_fndecl_50875_fields collapse_huge_page fndecl 2 50875 NULL
+max_ceqs_i40iw_hmc_fpm_misc_50878_fields max_ceqs i40iw_hmc_fpm_misc 0 50878 NULL
+qib_read_kreg64_fndecl_50881_fields qib_read_kreg64 fndecl 0 50881 NULL
+get_ramdisk_image_fndecl_50888_fields get_ramdisk_image fndecl 0 50888 NULL
+size_t4_sq_50890_fields size t4_sq 0 50890 NULL
+gpu_offset_ttm_mem_type_manager_50894_fields gpu_offset ttm_mem_type_manager 0 50894 NULL
+nvkm_vm_create_fndecl_50895_fields nvkm_vm_create fndecl 3-2 50895 NULL
+netlbl_catmap_walkrng_fndecl_50910_fields netlbl_catmap_walkrng fndecl 2-0 50910 NULL
+exofs_read_kern_fndecl_50914_fields exofs_read_kern fndecl 6 50914 NULL
+vnet_hdr_sz_tun_struct_50916_fields vnet_hdr_sz tun_struct 0 50916 NULL
+raid1_sync_request_fndecl_50917_fields raid1_sync_request fndecl 2 50917 NULL
+num_chunks_drm_radeon_cs_50925_fields num_chunks drm_radeon_cs 0 50925 NULL
+__spi_async_fndecl_50927_fields __spi_async fndecl 0 50927 NULL
+j_start_reiserfs_journal_50930_fields j_start reiserfs_journal 0 50930 NULL
+ssidLen_BSSListRid_50931_fields ssidLen BSSListRid 0 50931 NULL
+efs_map_block_fndecl_50932_fields efs_map_block fndecl 0-2 50932 NULL
+sge_pktshift_cxgb4_lld_info_50935_fields sge_pktshift cxgb4_lld_info 0 50935 NULL
+send_reply_fndecl_50941_fields send_reply fndecl 6 50941 NULL
+__mnt_want_write_file_fndecl_50942_fields __mnt_want_write_file fndecl 0 50942 NULL
+ubi_start_update_fndecl_50948_fields ubi_start_update fndecl 3 50948 NULL
+sync_key_len_pvr2_ioread_50952_fields sync_key_len pvr2_ioread 0 50952 NULL
+iser_prepare_write_cmd_fndecl_50953_fields iser_prepare_write_cmd fndecl 2 50953 NULL
+reg_list_size_radeon_rlc_50955_fields reg_list_size radeon_rlc 0 50955 NULL
+alloc_agpphysmem_i8xx_fndecl_50960_fields alloc_agpphysmem_i8xx fndecl 1 50960 NULL
+gamma_sd_gl860_50970_fields gamma sd_gl860 0 50970 NULL
+irq_ssb_device_50977_fields irq ssb_device 0 50977 NULL
+seq_start_offset_iscsi_cmd_50983_fields seq_start_offset iscsi_cmd 0 50983 NULL
+first_burst_len_iscsi_cmd_50987_fields first_burst_len iscsi_cmd 0 50987 NULL
+do_get_mempolicy_fndecl_50990_fields do_get_mempolicy fndecl 3 50990 NULL
+intel_tile_dims_fndecl_50992_fields intel_tile_dims fndecl 5 50992 NULL
+pa_mic_mw_51003_fields pa mic_mw 0 51003 NULL nohasharray
+cb_break_tail_afs_server_51003_fields cb_break_tail afs_server 0 51003 &pa_mic_mw_51003_fields
+resize_size_resize_parms_51005_fields resize_size resize_parms 0 51005 NULL
+soft_pp_table_size_pp_hwmgr_51014_fields soft_pp_table_size pp_hwmgr 0 51014 NULL
+room_ceph_pagelist_51016_fields room ceph_pagelist 0 51016 NULL
+num_of_queues_il_cfg_51023_fields num_of_queues il_cfg 0 51023 NULL
+img_sram_size_fw_hdr_51027_fields img_sram_size fw_hdr 0 51027 NULL
+xfs_flush_unmap_range_fndecl_51039_fields xfs_flush_unmap_range fndecl 2-3 51039 NULL
+find_free_ioapic_entry_fndecl_51042_fields find_free_ioapic_entry fndecl 0 51042 NULL
+setattr_inode_operations_51054_fields setattr inode_operations 0 51054 NULL
+vfs_truncate_fndecl_51056_fields vfs_truncate fndecl 2 51056 NULL
+romfs_dev_strnlen_fndecl_51058_fields romfs_dev_strnlen fndecl 2-3-0 51058 NULL
+index_vardecl_atiixp_modem_c_51061_fields index vardecl_atiixp_modem.c 0 51061 NULL
+crtc_vtotal_drm_display_mode_51070_fields crtc_vtotal drm_display_mode 0 51070 NULL
+fbmem_len_viafb_dev_51071_fields fbmem_len viafb_dev 0 51071 NULL
+i40iw_config_fpm_values_fndecl_51081_fields i40iw_config_fpm_values fndecl 2 51081 NULL
+size_p9_wstat_51083_fields size p9_wstat 0 51083 NULL
+td_end_whc_qset_51089_fields td_end whc_qset 0 51089 NULL nohasharray
+sr_write_cmd_fndecl_51089_fields sr_write_cmd fndecl 5 51089 &td_end_whc_qset_51089_fields
+order_mmc_test_pages_51098_fields order mmc_test_pages 0 51098 NULL
+namelen_hpfs_dirent_51099_fields namelen hpfs_dirent 0 51099 NULL
+ocfs2_file_llseek_fndecl_51102_fields ocfs2_file_llseek fndecl 2 51102 NULL
+memblock_virt_alloc_internal_fndecl_51107_fields memblock_virt_alloc_internal fndecl 2-3-4 51107 NULL nohasharray
+bu_blocks_ocfs2_xattr_bucket_51107_fields bu_blocks ocfs2_xattr_bucket 0 51107 &memblock_virt_alloc_internal_fndecl_51107_fields
+msb_read_page_fndecl_51110_fields msb_read_page fndecl 6-2 51110 NULL
+elog_size_vardecl_acpi_extlog_c_51112_fields elog_size vardecl_acpi_extlog.c 0 51112 NULL
+fbmem_free_viafb_par_51115_fields fbmem_free viafb_par 0 51115 NULL
+len_garp_attr_hdr_51119_fields len garp_attr_hdr 0 51119 NULL
+ls_num_slots_dlm_ls_51120_fields ls_num_slots dlm_ls 0 51120 NULL
+new_read_fndecl_51123_fields new_read fndecl 2 51123 NULL
+max_write_sge_ib_qp_51132_fields max_write_sge ib_qp 0 51132 NULL
+cachelsz_ath_common_51138_fields cachelsz ath_common 0 51138 NULL
+length_sky2_status_le_51139_fields length sky2_status_le 0 51139 NULL
+arg_start_mm_struct_51140_fields arg_start mm_struct 0 51140 NULL nohasharray
+fm_send_cmd_fndecl_51140_fields fm_send_cmd fndecl 5-0 51140 &arg_start_mm_struct_51140_fields nohasharray
+pin_2_irq_fndecl_51140_fields pin_2_irq fndecl 3 51140 &fm_send_cmd_fndecl_51140_fields nohasharray
+drm_dp_send_dpcd_write_fndecl_51140_fields drm_dp_send_dpcd_write fndecl 4 51140 &pin_2_irq_fndecl_51140_fields
+num_rx_bnad_51141_fields num_rx bnad 0 51141 NULL
+set_dev_class_fndecl_51150_fields set_dev_class fndecl 4 51150 NULL nohasharray
+dm_exception_table_init_fndecl_51150_fields dm_exception_table_init fndecl 2 51150 &set_dev_class_fndecl_51150_fields
+sdio_readb_fndecl_51153_fields sdio_readb fndecl 0 51153 NULL
+n_krcvqs_vardecl_51157_fields n_krcvqs vardecl 0 51157 NULL
+bytes_per_pixel_osd_info_51169_fields bytes_per_pixel osd_info 0 51169 NULL nohasharray
+max_sge_rd_ib_device_attr_51169_fields max_sge_rd ib_device_attr 0 51169 &bytes_per_pixel_osd_info_51169_fields
+raid10_takeover_raid0_fndecl_51171_fields raid10_takeover_raid0 fndecl 3-2 51171 NULL
+mc_cnt_ncsi_rsp_gc_pkt_51173_fields mc_cnt ncsi_rsp_gc_pkt 0 51173 NULL
+per_vf_cids_qed_src_iids_51181_fields per_vf_cids qed_src_iids 0 51181 NULL nohasharray
+splice_write_null_fndecl_51181_fields splice_write_null fndecl 4 51181 &per_vf_cids_qed_src_iids_51181_fields
+convert_extent_bit_fndecl_51191_fields convert_extent_bit fndecl 3-2 51191 NULL
+mlx5_ib_invalidate_range_fndecl_51195_fields mlx5_ib_invalidate_range fndecl 2 51195 NULL
+pfkey_sockaddr_size_fndecl_51198_fields pfkey_sockaddr_size fndecl 0 51198 NULL
+btrfs_extent_same_fndecl_51200_fields btrfs_extent_same fndecl 2-5 51200 NULL
+max_num_vringh_kiov_51202_fields max_num vringh_kiov 0 51202 NULL
+cirrus_ttm_tt_create_fndecl_51204_fields cirrus_ttm_tt_create fndecl 2 51204 NULL
+vcc_recvmsg_fndecl_51205_fields vcc_recvmsg fndecl 3 51205 NULL
+phys_vram_area_51217_fields phys vram_area 0 51217 NULL
+vsi_oltext_vxfs_sb_info_51222_fields vsi_oltext vxfs_sb_info 0 51222 NULL
+mem_cgroup_count_precharge_pte_range_fndecl_51229_fields mem_cgroup_count_precharge_pte_range fndecl 2 51229 NULL
+stb0899_read_regs_fndecl_51234_fields stb0899_read_regs fndecl 4 51234 NULL
+proc_set_size_fndecl_51237_fields proc_set_size fndecl 2 51237 NULL
+unlinked_urb_51246_fields unlinked urb 0 51246 NULL
+max_desc_sz_mthca_limits_51248_fields max_desc_sz mthca_limits 0 51248 NULL
+max_gs_mlx4_ib_wq_51251_fields max_gs mlx4_ib_wq 0 51251 NULL nohasharray
+cdev_add_fndecl_51251_fields cdev_add fndecl 3-2 51251 &max_gs_mlx4_ib_wq_51251_fields
+maxdatafieldsize_vnic_fc_config_51275_fields maxdatafieldsize vnic_fc_config 0 51275 NULL
+xfs_rtallocate_range_fndecl_51292_fields xfs_rtallocate_range fndecl 3-4-0 51292 NULL nohasharray
+osd_req_list_partition_collections_fndecl_51292_fields osd_req_list_partition_collections fndecl 5 51292 &xfs_rtallocate_range_fndecl_51292_fields
+first_burst_iscsi_bus_flash_session_51294_fields first_burst iscsi_bus_flash_session 0 51294 NULL
+size_autofs_dev_ioctl_51298_fields size autofs_dev_ioctl 0 51298 NULL
+iscsi_ping_comp_event_fndecl_51300_fields iscsi_ping_comp_event fndecl 5 51300 NULL
+xfs_qm_dqrepair_fndecl_51301_fields xfs_qm_dqrepair fndecl 0 51301 NULL
+y2_virtio_gpu_framebuffer_51309_fields y2 virtio_gpu_framebuffer 0 51309 NULL
+size_bts_phys_51332_fields size bts_phys 0 51332 NULL
+sync_dma_snd_usb_endpoint_51333_fields sync_dma snd_usb_endpoint 0 51333 NULL
+skb_put_frags_fndecl_51337_fields skb_put_frags fndecl 2-3 51337 NULL
+s_first_meta_bg_ext4_super_block_51338_fields s_first_meta_bg ext4_super_block 0 51338 NULL
+zd_mac_rx_fndecl_51339_fields zd_mac_rx fndecl 3 51339 NULL
+m_ag_max_usable_xfs_mount_51344_fields m_ag_max_usable xfs_mount 0 51344 NULL
+size_seq_file_51354_fields size seq_file 0 51354 NULL nohasharray
+ftdi_process_packet_fndecl_51354_fields ftdi_process_packet fndecl 4 51354 &size_seq_file_51354_fields
+i40iw_vchnl_vf_add_hmc_objs_fndecl_51356_fields i40iw_vchnl_vf_add_hmc_objs fndecl 4 51356 NULL
+get_frame_size_fndecl_51358_fields get_frame_size fndecl 0 51358 NULL
+length_mpc_table_51364_fields length mpc_table 0 51364 NULL
+ida_simple_get_fndecl_51365_fields ida_simple_get fndecl 0 51365 NULL nohasharray
+la_size_sect_drbd_md_51365_fields la_size_sect drbd_md 0 51365 &ida_simple_get_fndecl_51365_fields
+sb_logblocks_xfs_sb_51372_fields sb_logblocks xfs_sb 0 51372 NULL
+i915_ggtt_view_size_fndecl_51385_fields i915_ggtt_view_size fndecl 0 51385 NULL
+ath6kl_wmi_addkey_cmd_fndecl_51389_fields ath6kl_wmi_addkey_cmd fndecl 2 51389 NULL
+reshape_progress_r10conf_51390_fields reshape_progress r10conf 0 51390 NULL
+size_hbucket_51397_fields size hbucket 0 51397 NULL
+ext4_ext_next_allocated_block_fndecl_51410_fields ext4_ext_next_allocated_block fndecl 0 51410 NULL
+max_amsdu_len_ieee80211_sta_51415_fields max_amsdu_len ieee80211_sta 0 51415 NULL
+max_header_size_irnet_socket_51423_fields max_header_size irnet_socket 0 51423 NULL
+base_memblock_region_51424_fields base memblock_region 0 51424 NULL
+gre_parse_header_fndecl_51433_fields gre_parse_header fndecl 0-5 51433 NULL
+mixer_channels_fw_spkr_51437_fields mixer_channels fw_spkr 0 51437 NULL
+nethctrl_vf_resources_51438_fields nethctrl vf_resources 0 51438 NULL nohasharray
+size_omap3isp_ccdc_lsc_config_51438_fields size omap3isp_ccdc_lsc_config 0 51438 &nethctrl_vf_resources_51438_fields
+pyra_sysfs_write_fndecl_51441_fields pyra_sysfs_write fndecl 6 51441 NULL
+xfs_free_file_space_fndecl_51452_fields xfs_free_file_space fndecl 2-3 51452 NULL
+pcpu_fc_free_fndecl_51456_fields pcpu_fc_free fndecl 2 51456 NULL
+nr_segments_blkif_request_indirect_51457_fields nr_segments blkif_request_indirect 0 51457 NULL
+size_hashlimit_cfg1_51460_fields size hashlimit_cfg1 0 51460 NULL
+rx_urb_size_usbnet_51461_fields rx_urb_size usbnet 0 51461 NULL
+nTxLock_vardecl_jfs_txnmgr_c_51464_fields nTxLock vardecl_jfs_txnmgr.c 0 51464 NULL
+ext4_xattr_user_set_fndecl_51477_fields ext4_xattr_user_set fndecl 6 51477 NULL nohasharray
+orig_offset_iscsi_seq_51477_fields orig_offset iscsi_seq 0 51477 &ext4_xattr_user_set_fndecl_51477_fields
+finish_urb_fndecl_51484_fields finish_urb fndecl 3 51484 NULL
+xlog_alloc_log_fndecl_51486_fields xlog_alloc_log fndecl 3-4 51486 NULL
+log_blocksize_f2fs_super_block_51487_fields log_blocksize f2fs_super_block 0 51487 NULL
+f2fs_do_zero_range_fndecl_51504_fields f2fs_do_zero_range fndecl 2 51504 NULL
+inftl_readblock_fndecl_51508_fields inftl_readblock fndecl 2 51508 NULL
+xfer_len_scb_platform_data_51509_fields xfer_len scb_platform_data 0 51509 NULL
+count_atl1_tpd_ring_51510_fields count atl1_tpd_ring 0 51510 NULL
+pkt_alloc_packet_data_fndecl_51515_fields pkt_alloc_packet_data fndecl 1 51515 NULL
+size_fb_pixmap_51528_fields size fb_pixmap 0 51528 NULL
+mft_no__ntfs_inode_51541_fields mft_no _ntfs_inode 0 51541 NULL
+len_hfa384x_info_frame_51543_fields len hfa384x_info_frame 0 51543 NULL
+scan_bytes_iio_dev_51546_fields scan_bytes iio_dev 0 51546 NULL
+segCnt_Vmxnet3_RxCompDescExt_51547_fields segCnt Vmxnet3_RxCompDescExt 0 51547 NULL
+buffer_size_snd_emu10k1_fx8010_pcm_rec_51548_fields buffer_size snd_emu10k1_fx8010_pcm_rec 0 51548 NULL
+residual_len_vscsiif_response_51559_fields residual_len vscsiif_response 0 51559 NULL
+size_mdp_superblock_1_51572_fields size mdp_superblock_1 0 51572 NULL
+netxen_nic_change_mtu_fndecl_51573_fields netxen_nic_change_mtu fndecl 2 51573 NULL nohasharray
+rds_rdma_extra_size_fndecl_51573_fields rds_rdma_extra_size fndecl 0 51573 &netxen_nic_change_mtu_fndecl_51573_fields
+of_regulator_match_fndecl_51576_fields of_regulator_match fndecl 0 51576 NULL
+aio_setup_vectored_rw_fndecl_51577_fields aio_setup_vectored_rw fndecl 3 51577 NULL
+s_writeshift_logfs_super_51578_fields s_writeshift logfs_super 0 51578 NULL
+i_blkno_ocfs2_dinode_51582_fields i_blkno ocfs2_dinode 0 51582 NULL
+ufs_commit_chunk_fndecl_51591_fields ufs_commit_chunk fndecl 3 51591 NULL
+rx_buf_missing_hso_net_51595_fields rx_buf_missing hso_net 0 51595 NULL
+klsi_105_prepare_write_buffer_fndecl_51599_fields klsi_105_prepare_write_buffer fndecl 3 51599 NULL nohasharray
+ep_count_bytes_remain_fndecl_51599_fields ep_count_bytes_remain fndecl 0 51599 &klsi_105_prepare_write_buffer_fndecl_51599_fields nohasharray
+af9013_wr_regs_i2c_fndecl_51599_fields af9013_wr_regs_i2c fndecl 5 51599 &ep_count_bytes_remain_fndecl_51599_fields
+receive_mergeable_fndecl_51601_fields receive_mergeable fndecl 5-4 51601 NULL
+va_for_temp_scif_window_51603_fields va_for_temp scif_window 0 51603 NULL
+cur_vfio_pci_fill_info_51616_fields cur vfio_pci_fill_info 0 51616 NULL nohasharray
+data_transfer_length_vmscsi_request_51616_fields data_transfer_length vmscsi_request 0 51616 &cur_vfio_pci_fill_info_51616_fields
+alloc_ltalkdev_fndecl_51620_fields alloc_ltalkdev fndecl 1 51620 NULL
+ioc_plen1_obd_ioctl_data_51625_fields ioc_plen1 obd_ioctl_data 0 51625 NULL
+btuart_write_fndecl_51627_fields btuart_write fndecl 0 51627 NULL
+nodesize_btrfs_root_51633_fields nodesize btrfs_root 0 51633 NULL
+SsidLength_ndis_802_11_ssid_51638_fields SsidLength ndis_802_11_ssid 0 51638 NULL
+remap_cell_to_cache_dirty_fndecl_51640_fields remap_cell_to_cache_dirty fndecl 4 51640 NULL
+amdgpu_cgs_add_irq_source_fndecl_51642_fields amdgpu_cgs_add_irq_source fndecl 3 51642 NULL
+imm_count_jit_ctx_51643_fields imm_count jit_ctx 0 51643 NULL
+tx_ring_size_gfar_priv_tx_q_51655_fields tx_ring_size gfar_priv_tx_q 0 51655 NULL
+o2hb_read_slots_fndecl_51658_fields o2hb_read_slots fndecl 2 51658 NULL
+create_cache_fndecl_51660_fields create_cache fndecl 3-4-2 51660 NULL
+phys_mdio_mux_mmioreg_state_51673_fields phys mdio_mux_mmioreg_state 0 51673 NULL
+tcf_csum_ipv4_udp_fndecl_51674_fields tcf_csum_ipv4_udp fndecl 3 51674 NULL nohasharray
+seq_create_client1_fndecl_51674_fields seq_create_client1 fndecl 2 51674 &tcf_csum_ipv4_udp_fndecl_51674_fields
+nr_dirtied_task_struct_51675_fields nr_dirtied task_struct 0 51675 NULL
+ls_num_nodes_dlm_ls_51681_fields ls_num_nodes dlm_ls 0 51681 NULL nohasharray
+vmw_kms_present_fndecl_51681_fields vmw_kms_present fndecl 9 51681 &ls_num_nodes_dlm_ls_51681_fields
+virtio_gpu_object_create_fndecl_51692_fields virtio_gpu_object_create fndecl 2 51692 NULL nohasharray
+extsize_xfs_growfs_rt_51692_fields extsize xfs_growfs_rt 0 51692 &virtio_gpu_object_create_fndecl_51692_fields
+rtl8169_change_mtu_fndecl_51693_fields rtl8169_change_mtu fndecl 2 51693 NULL
+ms_os_descs_ext_prop_data_len_ffs_data_51698_fields ms_os_descs_ext_prop_data_len ffs_data 0 51698 NULL nohasharray
+pa_credit_return_base_51698_fields pa credit_return_base 0 51698 &ms_os_descs_ext_prop_data_len_ffs_data_51698_fields
+gfx_v7_0_get_csb_size_fndecl_51701_fields gfx_v7_0_get_csb_size fndecl 0 51701 NULL
+bNumMMCIEs_usb_wa_descriptor_51706_fields bNumMMCIEs usb_wa_descriptor 0 51706 NULL
+reqsize_crypto_skcipher_51708_fields reqsize crypto_skcipher 0 51708 NULL
+nilfs_write_end_fndecl_51713_fields nilfs_write_end fndecl 5 51713 NULL
+mwifiex_cmd_append_11n_tlv_fndecl_51715_fields mwifiex_cmd_append_11n_tlv fndecl 0 51715 NULL nohasharray
+ubifs_scan_fndecl_51715_fields ubifs_scan fndecl 3 51715 &mwifiex_cmd_append_11n_tlv_fndecl_51715_fields
+tt_stat_ofs_cyttsp4_sysinfo_ofs_51717_fields tt_stat_ofs cyttsp4_sysinfo_ofs 0 51717 NULL
+rx_ring_num_mlx4_en_priv_51723_fields rx_ring_num mlx4_en_priv 0 51723 NULL
+MaxChainDepth__MSG_IOC_FACTS_REPLY_51731_fields MaxChainDepth _MSG_IOC_FACTS_REPLY 0 51731 NULL
+xfs_da3_node_create_fndecl_51737_fields xfs_da3_node_create fndecl 2 51737 NULL
+start_falloc_range_51744_fields start falloc_range 0 51744 NULL
+qed_cxt_set_proto_cid_count_fndecl_51748_fields qed_cxt_set_proto_cid_count fndecl 4-3 51748 NULL nohasharray
+bnx2_change_ring_size_fndecl_51748_fields bnx2_change_ring_size fndecl 3-2 51748 &qed_cxt_set_proto_cid_count_fndecl_51748_fields
+sie_num_c67x00_sie_51754_fields sie_num c67x00_sie 0 51754 NULL
+find_next_usable_block_fndecl_51759_fields find_next_usable_block fndecl 0 51759 NULL
+rxbuf_size_alx_priv_51766_fields rxbuf_size alx_priv 0 51766 NULL
+vb2_dma_contig_set_max_seg_size_fndecl_51767_fields vb2_dma_contig_set_max_seg_size fndecl 2 51767 NULL
+ls_slot_dlm_ls_51774_fields ls_slot dlm_ls 0 51774 NULL
+rbio_add_io_page_fndecl_51775_fields rbio_add_io_page fndecl 5-6 51775 NULL
+s_blocksize_reiserfs_super_block_v1_51777_fields s_blocksize reiserfs_super_block_v1 0 51777 NULL
+SSID_size_atmel_private_51778_fields SSID_size atmel_private 0 51778 NULL
+snd_rme32_capture_getrate_fndecl_51779_fields snd_rme32_capture_getrate fndecl 0 51779 NULL
+pci_bar2_map_lpfc_hba_51792_fields pci_bar2_map lpfc_hba 0 51792 NULL
+ns_nextnum_the_nilfs_51797_fields ns_nextnum the_nilfs 0 51797 NULL
+uar_page_size_mlx4_caps_51798_fields uar_page_size mlx4_caps 0 51798 NULL
+reg_size_mtk_nfc_fdm_51803_fields reg_size mtk_nfc_fdm 0 51803 NULL
+si476x_core_i2c_xfer_fndecl_51818_fields si476x_core_i2c_xfer fndecl 4 51818 NULL
+val_ulist_node_51819_fields val ulist_node 0 51819 NULL
+bcache_device_init_fndecl_51822_fields bcache_device_init fndecl 2 51822 NULL
+isac_empty_fifo_fndecl_51832_fields isac_empty_fifo fndecl 2 51832 NULL
+udf_readpages_fndecl_51834_fields udf_readpages fndecl 4 51834 NULL
+hde_ast_vbios_enhtable_51835_fields hde ast_vbios_enhtable 0 51835 NULL
+xfs_bmap_btalloc_filestreams_fndecl_51838_fields xfs_bmap_btalloc_filestreams fndecl 0 51838 NULL
+mmio_len_mb862xxfb_par_51844_fields mmio_len mb862xxfb_par 0 51844 NULL
+xfs_qm_dqiter_bufs_fndecl_51846_fields xfs_qm_dqiter_bufs fndecl 3 51846 NULL
+max_bdi_bd_list_51847_fields max_bdi bd_list 0 51847 NULL
+free_size_jffs2_eraseblock_51848_fields free_size jffs2_eraseblock 0 51848 NULL
+mlx5e_rx_wqes_to_packets_fndecl_51860_fields mlx5e_rx_wqes_to_packets fndecl 0-3 51860 NULL
+slab_order_fndecl_51865_fields slab_order fndecl 0 51865 NULL
+TupleDataLen_tuple_t_51870_fields TupleDataLen tuple_t 0 51870 NULL
+efs_get_block_fndecl_51871_fields efs_get_block fndecl 2 51871 NULL
+rho2_7ls_hybla_51873_fields rho2_7ls hybla 0 51873 NULL
+MaxFrameSize_s_smt_os_51875_fields MaxFrameSize s_smt_os 0 51875 NULL
+vbi_height_em28xx_v4l2_51876_fields vbi_height em28xx_v4l2 0 51876 NULL
+lright_ext4_allocation_request_51877_fields lright ext4_allocation_request 0 51877 NULL
+skb_headroom_port100_51893_fields skb_headroom port100 0 51893 NULL
+len_sdla_mem_51902_fields len sdla_mem 0 51902 NULL
+datainterval_audioformat_51903_fields datainterval audioformat 0 51903 NULL
+v9fs_xattr_handler_set_fndecl_51905_fields v9fs_xattr_handler_set fndecl 6 51905 NULL
+rx_buf_sz_yellowfin_private_51912_fields rx_buf_sz yellowfin_private 0 51912 NULL
+len_nfs3_diropargs_51913_fields len nfs3_diropargs 0 51913 NULL
+pgbase_nfs4_readlink_51921_fields pgbase nfs4_readlink 0 51921 NULL
+aead_sendmsg_fndecl_51926_fields aead_sendmsg fndecl 3 51926 NULL
+start_discovery_fndecl_51929_fields start_discovery fndecl 4 51929 NULL
+btrfs_read_dev_one_super_fndecl_51932_fields btrfs_read_dev_one_super fndecl 2 51932 NULL
+xfs_dir_createname_fndecl_51936_fields xfs_dir_createname fndecl 7 51936 NULL
+__fswab16_fndecl_51937_fields __fswab16 fndecl 0-1 51937 NULL
+len_probe_resp_51942_fields len probe_resp 0 51942 NULL
+len_fscrypt_symlink_data_51950_fields len fscrypt_symlink_data 0 51950 NULL nohasharray
+rsi_mgmt_pkt_to_core_fndecl_51950_fields rsi_mgmt_pkt_to_core fndecl 3 51950 &len_fscrypt_symlink_data_51950_fields
+size_mdp_superblock_s_51954_fields size mdp_superblock_s 0 51954 NULL
+max_channels_efx_nic_51955_fields max_channels efx_nic 0 51955 NULL nohasharray
+__remaining_sg_mapping_iter_51955_fields __remaining sg_mapping_iter 0 51955 &max_channels_efx_nic_51955_fields nohasharray
+num_mpt_mlx4_profile_51955_fields num_mpt mlx4_profile 0 51955 &__remaining_sg_mapping_iter_51955_fields nohasharray
+start_drm_i915_error_state_buf_51955_fields start drm_i915_error_state_buf 0 51955 &num_mpt_mlx4_profile_51955_fields
+meta_total_blocks_r5l_recovery_ctx_51960_fields meta_total_blocks r5l_recovery_ctx 0 51960 NULL
+pipe_src_w_intel_crtc_state_51963_fields pipe_src_w intel_crtc_state 0 51963 NULL nohasharray
+submit_bio_wait_fndecl_51963_fields submit_bio_wait fndecl 0 51963 &pipe_src_w_intel_crtc_state_51963_fields nohasharray
+num_eqs_mthca_limits_51963_fields num_eqs mthca_limits 0 51963 &submit_bio_wait_fndecl_51963_fields
+bufsize_usbhid_device_51964_fields bufsize usbhid_device 0 51964 NULL
+pad_bits_regmap_config_51968_fields pad_bits regmap_config 0 51968 NULL nohasharray
+should_error_unserviceable_bio_fndecl_51968_fields should_error_unserviceable_bio fndecl 0 51968 &pad_bits_regmap_config_51968_fields
+asix_write_cmd_async_fndecl_51975_fields asix_write_cmd_async fndecl 5 51975 NULL
+insert_one_name_fndecl_51977_fields insert_one_name fndecl 6 51977 NULL
+pcnet32_realloc_tx_ring_fndecl_51983_fields pcnet32_realloc_tx_ring fndecl 3 51983 NULL
+bus_num_sm501_platdata_gpio_i2c_51989_fields bus_num sm501_platdata_gpio_i2c 0 51989 NULL
+ocfs2_which_cluster_group_fndecl_51998_fields ocfs2_which_cluster_group fndecl 0-2 51998 NULL
+size_fuse_write_out_52017_fields size fuse_write_out 0 52017 NULL nohasharray
+immediate_data_length_iscsi_build_list_52017_fields immediate_data_length iscsi_build_list 0 52017 &size_fuse_write_out_52017_fields
+batadv_iv_ogm_aggregate_new_fndecl_52022_fields batadv_iv_ogm_aggregate_new fndecl 2 52022 NULL
+dev_set_mtu_fndecl_52028_fields dev_set_mtu fndecl 2 52028 NULL
+bounce_buf_len_xhci_ring_52035_fields bounce_buf_len xhci_ring 0 52035 NULL
+oobavail_mtd_info_52037_fields oobavail mtd_info 0 52037 NULL
+gfs2_setattr_size_fndecl_52038_fields gfs2_setattr_size fndecl 2 52038 NULL nohasharray
+mapbase_priv_52038_fields mapbase priv 0 52038 &gfs2_setattr_size_fndecl_52038_fields
+prepare_ack_packet_fndecl_52041_fields prepare_ack_packet fndecl 5 52041 NULL
+xdr_shrink_pagelen_fndecl_52043_fields xdr_shrink_pagelen fndecl 2 52043 NULL nohasharray
+sysctl_sync_sock_size_netns_ipvs_52043_fields sysctl_sync_sock_size netns_ipvs 0 52043 &xdr_shrink_pagelen_fndecl_52043_fields
+num_controls_op_x86_model_spec_52044_fields num_controls op_x86_model_spec 0 52044 NULL
+min_initial_entries_vmw_cotable_info_52048_fields min_initial_entries vmw_cotable_info 0 52048 NULL
+section_size_nvsp_1_message_send_send_buffer_complete_52050_fields section_size nvsp_1_message_send_send_buffer_complete 0 52050 NULL
+iomap_zero_range_actor_fndecl_52051_fields iomap_zero_range_actor fndecl 3-2 52051 NULL
+cxgb_change_mtu_fndecl_52055_fields cxgb_change_mtu fndecl 2 52055 NULL
+scif_register_fndecl_52065_fields scif_register fndecl 3 52065 NULL
+nid_node_info_52075_fields nid node_info 0 52075 NULL
+lpfc_bsg_copy_data_fndecl_52084_fields lpfc_bsg_copy_data fndecl 0-3 52084 NULL
+nvbios_rd32_fndecl_52086_fields nvbios_rd32 fndecl 0 52086 NULL
+ceph_handle_auth_reply_fndecl_52105_fields ceph_handle_auth_reply fndecl 0 52105 NULL nohasharray
+btindex_jfs_inode_info_52105_fields btindex jfs_inode_info 0 52105 &ceph_handle_auth_reply_fndecl_52105_fields
+attr_bytes_osdv1_attributes_list_element_52106_fields attr_bytes osdv1_attributes_list_element 0 52106 NULL
+MaxDevices__MSG_PORT_FACTS_REPLY_52112_fields MaxDevices _MSG_PORT_FACTS_REPLY 0 52112 NULL
+mlx4_ib_db_map_user_fndecl_52114_fields mlx4_ib_db_map_user fndecl 2 52114 NULL
+max3421_transfer_out_done_fndecl_52121_fields max3421_transfer_out_done fndecl 0 52121 NULL nohasharray
+length_wsm_update_ie_52121_fields length wsm_update_ie 0 52121 &max3421_transfer_out_done_fndecl_52121_fields
+db_page_mthca_create_srq_52122_fields db_page mthca_create_srq 0 52122 NULL
+mtu_cmtp_session_52125_fields mtu cmtp_session 0 52125 NULL
+iscsi_sw_tcp_recv_fndecl_52131_fields iscsi_sw_tcp_recv fndecl 3 52131 NULL
+ima_read_xattr_fndecl_52132_fields ima_read_xattr fndecl 0 52132 NULL
+s_inode_size_ext2_sb_info_52134_fields s_inode_size ext2_sb_info 0 52134 NULL
+isofs_export_iget_fndecl_52144_fields isofs_export_iget fndecl 2 52144 NULL
+qib_rc_rcv_fndecl_52145_fields qib_rc_rcv fndecl 5 52145 NULL
+tcp_sendmsg_fndecl_52147_fields tcp_sendmsg fndecl 3 52147 NULL nohasharray
+tcp_update_reordering_fndecl_52147_fields tcp_update_reordering fndecl 2 52147 &tcp_sendmsg_fndecl_52147_fields
+set_le_ih_k_type_fndecl_52149_fields set_le_ih_k_type fndecl 2 52149 NULL
+pep_indicate_fndecl_52160_fields pep_indicate fndecl 5 52160 NULL
+mpx_mmap_fndecl_52167_fields mpx_mmap fndecl 1-0 52167 NULL
+nf_ct_sack_adjust_fndecl_52168_fields nf_ct_sack_adjust fndecl 2 52168 NULL
+mtdchar_lseek_fndecl_52170_fields mtdchar_lseek fndecl 2 52170 NULL
+reserved_operations_rvt_driver_params_52173_fields reserved_operations rvt_driver_params 0 52173 NULL
+compat_sys_ptrace_fndecl_52176_fields compat_sys_ptrace fndecl 3 52176 NULL
+b_length_xfs_buf_52177_fields b_length xfs_buf 0 52177 NULL
+log_sq_size_mlx5e_params_52182_fields log_sq_size mlx5e_params 0 52182 NULL
+icdoff_nvme_ctrl_52188_fields icdoff nvme_ctrl 0 52188 NULL
+virtfn_add_bus_fndecl_52190_fields virtfn_add_bus fndecl 2 52190 NULL
+ext2_readpages_fndecl_52195_fields ext2_readpages fndecl 4 52195 NULL
+patch_regs_regmap_52197_fields patch_regs regmap 0 52197 NULL
+metapage_get_blocks_fndecl_52200_fields metapage_get_blocks fndecl 0-2 52200 NULL
+mmc_send_cxd_data_fndecl_52204_fields mmc_send_cxd_data fndecl 5 52204 NULL
+num_lro_rxd_netxen_adapter_52211_fields num_lro_rxd netxen_adapter 0 52211 NULL
+num_dtv_properties_52216_fields num dtv_properties 0 52216 NULL
+numlower_ovl_entry_52218_fields numlower ovl_entry 0 52218 NULL
+max_sge_rvt_rq_52222_fields max_sge rvt_rq 0 52222 NULL
+cp2112_write_read_req_fndecl_52230_fields cp2112_write_read_req fndecl 0-6 52230 NULL
+BlockSize_erase_unit_header_t_52231_fields BlockSize erase_unit_header_t 0 52231 NULL
+lpc_sch_get_io_fndecl_52232_fields lpc_sch_get_io fndecl 5 52232 NULL
+nfs3_proc_readlink_fndecl_52235_fields nfs3_proc_readlink fndecl 4-3 52235 NULL
+devm_nvdimm_memremap_fndecl_52240_fields devm_nvdimm_memremap fndecl 3-2 52240 NULL
+num_ports_mthca_limits_52246_fields num_ports mthca_limits 0 52246 NULL
+paddr_drm_gem_cma_object_52250_fields paddr drm_gem_cma_object 0 52250 NULL
+ceph_osdc_alloc_messages_fndecl_52252_fields ceph_osdc_alloc_messages fndecl 0 52252 NULL
+snd_hda_get_conn_list_fndecl_52255_fields snd_hda_get_conn_list fndecl 0 52255 NULL nohasharray
+kmemleak_alloc_percpu_fndecl_52255_fields kmemleak_alloc_percpu fndecl 2 52255 &snd_hda_get_conn_list_fndecl_52255_fields
+bufsize_brcmf_console_52266_fields bufsize brcmf_console 0 52266 NULL
+value_len_xattr_52269_fields value_len xattr 0 52269 NULL nohasharray
+pd_idx_stripe_head_52269_fields pd_idx stripe_head 0 52269 &value_len_xattr_52269_fields
+req_depth_pvscsi_adapter_52271_fields req_depth pvscsi_adapter 0 52271 NULL nohasharray
+hdsp_set_rate_fndecl_52271_fields hdsp_set_rate fndecl 2 52271 &req_depth_pvscsi_adapter_52271_fields nohasharray
+hfsplus_ext_find_block_fndecl_52271_fields hfsplus_ext_find_block fndecl 0-2 52271 &hdsp_set_rate_fndecl_52271_fields
+set_multcount_fndecl_52272_fields set_multcount fndecl 2 52272 NULL
+num_leds_adp5520_leds_platform_data_52273_fields num_leds adp5520_leds_platform_data 0 52273 NULL
+hlen_raw_frag_vec_52276_fields hlen raw_frag_vec 0 52276 NULL
+length_sigma_fw_chunk_52285_fields length sigma_fw_chunk 0 52285 NULL
+hpfs_alloc_dnode_fndecl_52288_fields hpfs_alloc_dnode fndecl 2 52288 NULL
+read_pointer_osst_buffer_52292_fields read_pointer osst_buffer 0 52292 NULL
+reserve_low_vardecl_setup_c_52293_fields reserve_low vardecl_setup.c 0 52293 NULL
+error_submit_bio_ret_52294_fields error submit_bio_ret 0 52294 NULL
+slot_legacy_probe_52300_fields slot legacy_probe 0 52300 NULL
+setup_items_for_insert_fndecl_52301_fields setup_items_for_insert fndecl 7 52301 NULL
+origin_size_thin_c_52302_fields origin_size thin_c 0 52302 NULL
+length_rxe_opcode_info_52306_fields length rxe_opcode_info 0 52306 NULL
+h_stop_saa7134_tvnorm_52311_fields h_stop saa7134_tvnorm 0 52311 NULL
+rss_table_entry_width_i40e_hw_capabilities_52312_fields rss_table_entry_width i40e_hw_capabilities 0 52312 NULL
+btrfs_delalloc_reserve_space_fndecl_52314_fields btrfs_delalloc_reserve_space fndecl 0-3-2 52314 NULL
+ep_out_kingsun_cb_52317_fields ep_out kingsun_cb 0 52317 NULL
+pglen_nfs4_readlink_52318_fields pglen nfs4_readlink 0 52318 NULL
+cxgbi_conn_init_pdu_fndecl_52327_fields cxgbi_conn_init_pdu fndecl 3 52327 NULL
+inline_rsize_rpcrdma_create_data_internal_52331_fields inline_rsize rpcrdma_create_data_internal 0 52331 NULL
+mac_header_sk_buff_52356_fields mac_header sk_buff 0 52356 NULL
+pipe_src_h_intel_crtc_state_52358_fields pipe_src_h intel_crtc_state 0 52358 NULL nohasharray
+blk_queue_max_hw_sectors_fndecl_52358_fields blk_queue_max_hw_sectors fndecl 2 52358 &pipe_src_h_intel_crtc_state_52358_fields
+nr_upid_52360_fields nr upid 0 52360 NULL
+create_cq_user_fndecl_52365_fields create_cq_user fndecl 5 52365 NULL nohasharray
+r_cpos_ocfs2_refcount_rec_52365_fields r_cpos ocfs2_refcount_rec 0 52365 &create_cq_user_fndecl_52365_fields
+se_callback_netid_len_nfsd4_setclientid_52366_fields se_callback_netid_len nfsd4_setclientid 0 52366 NULL
+req_depth__MPT_ADAPTER_52375_fields req_depth _MPT_ADAPTER 0 52375 NULL
+rh_string_fndecl_52376_fields rh_string fndecl 0-4 52376 NULL
+bMaxBurst_usb_ss_ep_comp_descriptor_52382_fields bMaxBurst usb_ss_ep_comp_descriptor 0 52382 NULL
+ath6kl_wmi_set_ie_cmd_fndecl_52383_fields ath6kl_wmi_set_ie_cmd fndecl 6-2 52383 NULL nohasharray
+sg_pgoffset_sg_page_iter_52383_fields sg_pgoffset sg_page_iter 0 52383 &ath6kl_wmi_set_ie_cmd_fndecl_52383_fields
+raw_bufsize_edt_ft5x06_ts_data_52390_fields raw_bufsize edt_ft5x06_ts_data 0 52390 NULL
+jffs2_write_dirent_fndecl_52396_fields jffs2_write_dirent fndecl 5 52396 NULL
+u132_hcd_initial_input_recv_fndecl_52397_fields u132_hcd_initial_input_recv fndecl 4 52397 NULL
+srp_map_idb_fndecl_52402_fields srp_map_idb fndecl 0-5 52402 NULL
+length_TAG_TW_SG_Entry_52403_fields length TAG_TW_SG_Entry 0 52403 NULL
+eapol_len_wmi_eapol_rx_event_52408_fields eapol_len wmi_eapol_rx_event 0 52408 NULL
+btrfs_test_free_space_cache_fndecl_52410_fields btrfs_test_free_space_cache fndecl 1-2 52410 NULL
+agp_return_size_fndecl_52417_fields agp_return_size fndecl 0 52417 NULL
+group_ocfs2_new_group_input_52421_fields group ocfs2_new_group_input 0 52421 NULL
+jffs2_user_setxattr_fndecl_52427_fields jffs2_user_setxattr fndecl 6 52427 NULL nohasharray
+xfs_iomap_write_allocate_fndecl_52427_fields xfs_iomap_write_allocate fndecl 0 52427 &jffs2_user_setxattr_fndecl_52427_fields
+move_vma_fndecl_52430_fields move_vma fndecl 5-4-2-3 52430 NULL
+zap_pte_range_fndecl_52434_fields zap_pte_range fndecl 4-0 52434 NULL
+min_scaled_width_bttv_crop_52442_fields min_scaled_width bttv_crop 0 52442 NULL
+dvb_max_pkt_size_isoc_em28xx_52444_fields dvb_max_pkt_size_isoc em28xx 0 52444 NULL nohasharray
+map_nth_dirent_fndecl_52444_fields map_nth_dirent fndecl 2 52444 &dvb_max_pkt_size_isoc_em28xx_52444_fields
+read_rsp_size_smb_version_values_52446_fields read_rsp_size smb_version_values 0 52446 NULL
+bulk_out_size_usb_serial_port_52448_fields bulk_out_size usb_serial_port 0 52448 NULL
+corr_peb_count_ubi_device_52450_fields corr_peb_count ubi_device 0 52450 NULL nohasharray
+wl1251_spi_write_fndecl_52450_fields wl1251_spi_write fndecl 4 52450 &corr_peb_count_ubi_device_52450_fields
+end_bus_pci_mmcfg_region_52468_fields end_bus pci_mmcfg_region 0 52468 NULL
+nvi_vf_resources_52470_fields nvi vf_resources 0 52470 NULL
+sz_field_t_52472_fields sz field_t 0 52472 NULL
+metadata_snap_era_metadata_52475_fields metadata_snap era_metadata 0 52475 NULL
+ib_ucm_alloc_data_fndecl_52486_fields ib_ucm_alloc_data fndecl 3 52486 NULL
+user_base_rvt_mregion_52489_fields user_base rvt_mregion 0 52489 NULL
+eqpc_entry_sz_mthca_dev_lim_52498_fields eqpc_entry_sz mthca_dev_lim 0 52498 NULL
+s_clustersize_bits_ocfs2_super_52499_fields s_clustersize_bits ocfs2_super 0 52499 NULL
+used_ubifs_wbuf_52504_fields used ubifs_wbuf 0 52504 NULL
+size_virtio_gpu_vbuffer_52521_fields size virtio_gpu_vbuffer 0 52521 NULL
+refcount_loc_ocfs2_move_extents_context_52526_fields refcount_loc ocfs2_move_extents_context 0 52526 NULL
+vm_cmdline_id_vardecl_virtio_mmio_c_52527_fields vm_cmdline_id vardecl_virtio_mmio.c 0 52527 NULL
+tas5086_register_size_fndecl_52528_fields tas5086_register_size fndecl 0 52528 NULL
+fps_solo_dev_52530_fields fps solo_dev 0 52530 NULL
+iov_offset_iov_iter_52535_fields iov_offset iov_iter 0 52535 NULL
+rx_buf_sz_hamachi_private_52536_fields rx_buf_sz hamachi_private 0 52536 NULL
+queue_pair_size_vmci_transport_52540_fields queue_pair_size vmci_transport 0 52540 NULL
+packet_sendmsg_spkt_fndecl_52542_fields packet_sendmsg_spkt fndecl 3 52542 NULL
+rdb_shift_mthca_qp_table_52547_fields rdb_shift mthca_qp_table 0 52547 NULL
+dccp_insert_option_fndecl_52554_fields dccp_insert_option fndecl 4 52554 NULL
+ovfx2_i2c_r_fndecl_52555_fields ovfx2_i2c_r fndecl 0 52555 NULL
+write_leb_fndecl_52558_fields write_leb fndecl 5 52558 NULL
+num_mtt_mlx4_profile_52565_fields num_mtt mlx4_profile 0 52565 NULL
+fragsize_sdma_req_info_52566_fields fragsize sdma_req_info 0 52566 NULL
+ax88179_write_cmd_nopm_fndecl_52569_fields ax88179_write_cmd_nopm fndecl 5 52569 NULL
+physical_sector_size_blkfront_info_52571_fields physical_sector_size blkfront_info 0 52571 NULL
+end_logsuper_52574_fields end logsuper 0 52574 NULL
+amdgpu_ttm_tt_set_userptr_fndecl_52575_fields amdgpu_ttm_tt_set_userptr fndecl 2 52575 NULL
+device_create_groups_vargs_fndecl_52576_fields device_create_groups_vargs fndecl 3 52576 NULL
+__mincore_unmapped_range_fndecl_52595_fields __mincore_unmapped_range fndecl 1 52595 NULL
+xfs_shift_file_space_fndecl_52596_fields xfs_shift_file_space fndecl 2-3 52596 NULL
+cached_dev_init_fndecl_52600_fields cached_dev_init fndecl 2 52600 NULL
+w5200_spi_writebulk_fndecl_52604_fields w5200_spi_writebulk fndecl 4 52604 NULL
+ext4_da_write_end_fndecl_52605_fields ext4_da_write_end fndecl 5 52605 NULL
+length_usbdevfs_iso_packet_desc_52610_fields length usbdevfs_iso_packet_desc 0 52610 NULL
+ondemand_readahead_fndecl_52612_fields ondemand_readahead fndecl 5 52612 NULL
+datalen_tcf_ematch_52613_fields datalen tcf_ematch 0 52613 NULL
+wl1251_spi_read_fndecl_52615_fields wl1251_spi_read fndecl 4 52615 NULL
+max_sge_ib_device_attr_52617_fields max_sge ib_device_attr 0 52617 NULL
+_set_error_resid_fndecl_52623_fields _set_error_resid fndecl 3 52623 NULL
+lo_rw_aio_complete_fndecl_52629_fields lo_rw_aio_complete fndecl 2 52629 NULL nohasharray
+mlx5e_add_skb_frag_linear_mpwqe_fndecl_52629_fields mlx5e_add_skb_frag_linear_mpwqe fndecl 6-5 52629 &lo_rw_aio_complete_fndecl_52629_fields nohasharray
+drbd_new_dev_size_fndecl_52629_fields drbd_new_dev_size fndecl 0-3 52629 &mlx5e_add_skb_frag_linear_mpwqe_fndecl_52629_fields
+image_size_cgs_firmware_info_52630_fields image_size cgs_firmware_info 0 52630 NULL
+vaddr_hfi1_tid_info_52635_fields vaddr hfi1_tid_info 0 52635 NULL
+burst_len_qcaspi_52637_fields burst_len qcaspi 0 52637 NULL
+figure_loop_size_fndecl_52648_fields figure_loop_size fndecl 2 52648 NULL
+qp_broker_create_fndecl_52654_fields qp_broker_create fndecl 6-5 52654 NULL
+extra_bytes_sym_ccb_52656_fields extra_bytes sym_ccb 0 52656 NULL
+block_size_ms_boot_attr_info_52659_fields block_size ms_boot_attr_info 0 52659 NULL
+snd_hdac_get_sub_nodes_fndecl_52668_fields snd_hdac_get_sub_nodes fndecl 0 52668 NULL
+vt_ast_vbios_enhtable_52669_fields vt ast_vbios_enhtable 0 52669 NULL
+nr_ioapics_vardecl_52671_fields nr_ioapics vardecl 0 52671 NULL
+pcm512x_sck_max_fndecl_52677_fields pcm512x_sck_max fndecl 0 52677 NULL
+__handle_mm_fault_fndecl_52682_fields __handle_mm_fault fndecl 2 52682 NULL
+btrfs_double_extent_unlock_fndecl_52687_fields btrfs_double_extent_unlock fndecl 2-4-5 52687 NULL
+fpHeight_nvidia_par_52691_fields fpHeight nvidia_par 0 52691 NULL nohasharray
+urb_done_max3421_hcd_52691_fields urb_done max3421_hcd 0 52691 &fpHeight_nvidia_par_52691_fields
+max_data_link_payload_nfc_hci_dev_52699_fields max_data_link_payload nfc_hci_dev 0 52699 NULL
+count_vfio_pci_hot_reset_52708_fields count vfio_pci_hot_reset 0 52708 NULL
+gen_ie_buf_len_mwifiex_private_52710_fields gen_ie_buf_len mwifiex_private 0 52710 NULL nohasharray
+din_size_cros_ec_device_52710_fields din_size cros_ec_device 0 52710 &gen_ie_buf_len_mwifiex_private_52710_fields
+wptr_old_radeon_ring_52716_fields wptr_old radeon_ring 0 52716 NULL nohasharray
+videomemorysize_vardecl_vfb_c_52716_fields videomemorysize vardecl_vfb.c 0 52716 &wptr_old_radeon_ring_52716_fields
+xlog_grant_head_check_fndecl_52719_fields xlog_grant_head_check fndecl 0 52719 NULL
+cifs_min_small_vardecl_52732_fields cifs_min_small vardecl 0 52732 NULL
+vmw_framebuffer_dmabuf_dirty_fndecl_52750_fields vmw_framebuffer_dmabuf_dirty fndecl 6 52750 NULL
+dd_fcrport_size_fc_function_template_52753_fields dd_fcrport_size fc_function_template 0 52753 NULL
+num_btns_cyttsp4_sysinfo_ofs_52758_fields num_btns cyttsp4_sysinfo_ofs 0 52758 NULL
+dr_blkno_ocfs2_dx_root_block_52759_fields dr_blkno ocfs2_dx_root_block 0 52759 NULL
+playback_frlog_rme96_52763_fields playback_frlog rme96 0 52763 NULL
+do_compat_pwritev64_fndecl_52765_fields do_compat_pwritev64 fndecl 3 52765 NULL
+iov_iter_fault_in_readable_fndecl_52767_fields iov_iter_fault_in_readable fndecl 2 52767 NULL
+wIDIbytesPerSector_ms_bootblock_idi_52770_fields wIDIbytesPerSector ms_bootblock_idi 0 52770 NULL
+size_drm_i915_gem_create_52771_fields size drm_i915_gem_create 0 52771 NULL
+maxBuf_TCP_Server_Info_52774_fields maxBuf TCP_Server_Info 0 52774 NULL
+qxl_allocate_chunk_fndecl_52791_fields qxl_allocate_chunk fndecl 4 52791 NULL nohasharray
+tcp_mss_split_point_fndecl_52791_fields tcp_mss_split_point fndecl 0 52791 &qxl_allocate_chunk_fndecl_52791_fields
+batadv_get_vid_fndecl_52792_fields batadv_get_vid fndecl 2 52792 NULL
+__wa_seg_calculate_isoc_frame_count_fndecl_52795_fields __wa_seg_calculate_isoc_frame_count fndecl 0 52795 NULL
+buffer_size_vardecl_ethoc_c_52796_fields buffer_size vardecl_ethoc.c 0 52796 NULL
+xhci_ring_alloc_fndecl_52799_fields xhci_ring_alloc fndecl 5 52799 NULL
+payload_len_bfa_bsg_data_52800_fields payload_len bfa_bsg_data 0 52800 NULL
+postcopy_buffers_fndecl_52806_fields postcopy_buffers fndecl 3 52806 NULL
+ule_sndu_type_dvb_net_priv_52811_fields ule_sndu_type dvb_net_priv 0 52811 NULL
+mmc_test_map_sg_fndecl_52812_fields mmc_test_map_sg fndecl 6-5-8-2 52812 NULL nohasharray
+mini_cm_connect_fndecl_52812_fields mini_cm_connect fndecl 3 52812 &mmc_test_map_sg_fndecl_52812_fields
+brcmf_sdiod_recv_chain_fndecl_52822_fields brcmf_sdiod_recv_chain fndecl 3 52822 NULL
+xdr_encode_array2_fndecl_52834_fields xdr_encode_array2 fndecl 0-2 52834 NULL
+xfs_read_agf_fndecl_52838_fields xfs_read_agf fndecl 3-0 52838 NULL nohasharray
+ocfs2_duplicate_clusters_by_jbd_fndecl_52838_fields ocfs2_duplicate_clusters_by_jbd fndecl 4-5 52838 &xfs_read_agf_fndecl_52838_fields
+svc_rdma_xdr_decode_req_fndecl_52859_fields svc_rdma_xdr_decode_req fndecl 0 52859 NULL
+netxen_validate_ringparam_fndecl_52863_fields netxen_validate_ringparam fndecl 0 52863 NULL
+mlx4_load_one_fndecl_52867_fields mlx4_load_one fndecl 3 52867 NULL nohasharray
+wqe_shift_mlx5_ib_wq_52867_fields wqe_shift mlx5_ib_wq 0 52867 &mlx4_load_one_fndecl_52867_fields
+video_ram_radeonfb_info_52868_fields video_ram radeonfb_info 0 52868 NULL
+ddata_ofsh_cyttsp4_sysinfo_data_52870_fields ddata_ofsh cyttsp4_sysinfo_data 0 52870 NULL
+offset_pipe_buffer_52880_fields offset pipe_buffer 0 52880 NULL
+address_length_acpi_resource_memory24_52885_fields address_length acpi_resource_memory24 0 52885 NULL
+i40iw_vchnl_vf_del_hmc_obj_fndecl_52890_fields i40iw_vchnl_vf_del_hmc_obj fndecl 4 52890 NULL
+buffer_size_vardecl_ir_usb_c_52893_fields buffer_size vardecl_ir-usb.c 0 52893 NULL
+offset_bnxt_sw_rx_agg_bd_52895_fields offset bnxt_sw_rx_agg_bd 0 52895 NULL
+data_len_hermes_rx_descriptor_52909_fields data_len hermes_rx_descriptor 0 52909 NULL
+of_alias_add_fndecl_52916_fields of_alias_add fndecl 3 52916 NULL nohasharray
+cqc_entry_sz_mlx4_dev_cap_52916_fields cqc_entry_sz mlx4_dev_cap 0 52916 &of_alias_add_fndecl_52916_fields
+num_tx_queues_e1000_adapter_52922_fields num_tx_queues e1000_adapter 0 52922 NULL
+swd_swregs_state_52928_fields swd swregs_state 0 52928 NULL
+xfs_mount_validate_sb_fndecl_52930_fields xfs_mount_validate_sb fndecl 0 52930 NULL
+count_i40e_ring_52936_fields count i40e_ring 0 52936 NULL nohasharray
+max_write_shift_ubifs_info_52936_fields max_write_shift ubifs_info 0 52936 &count_i40e_ring_52936_fields
+si2165_write_fndecl_52941_fields si2165_write fndecl 4 52941 NULL
+rules_count_canid_match_52943_fields rules_count canid_match 0 52943 NULL nohasharray
+num_rx_ethoc_52943_fields num_rx ethoc 0 52943 &rules_count_canid_match_52943_fields
+pipe_urb_52947_fields pipe urb 0 52947 NULL
+position_jfs_dirent_52952_fields position jfs_dirent 0 52952 NULL
+trigger_level_eg20t_port_52953_fields trigger_level eg20t_port 0 52953 NULL
+i2c_read_demod_bytes_fndecl_52958_fields i2c_read_demod_bytes fndecl 4 52958 NULL
+bnx2fc_get_paged_crc_eof_fndecl_52960_fields bnx2fc_get_paged_crc_eof fndecl 2 52960 NULL
+fw_size_pvr2_hdw_52961_fields fw_size pvr2_hdw 0 52961 NULL
+priv_sz_sja1000_of_data_52963_fields priv_sz sja1000_of_data 0 52963 NULL
+musb_h_ep0_continue_fndecl_52966_fields musb_h_ep0_continue fndecl 2 52966 NULL
+set_registers_fndecl_52968_fields set_registers fndecl 4 52968 NULL
+dma_start_lo_rx_buf_desc_52972_fields dma_start_lo rx_buf_desc 0 52972 NULL
+dataOutSize_mpt_ioctl_command_52974_fields dataOutSize mpt_ioctl_command 0 52974 NULL
+scif_readfrom_fndecl_52975_fields scif_readfrom fndecl 2-4-3 52975 NULL nohasharray
+dvb_net_sec_fndecl_52975_fields dvb_net_sec fndecl 3 52975 &scif_readfrom_fndecl_52975_fields nohasharray
+xdr_truncate_encode_fndecl_52975_fields xdr_truncate_encode fndecl 2 52975 &dvb_net_sec_fndecl_52975_fields
+scatter_n_efx_rx_queue_52988_fields scatter_n efx_rx_queue 0 52988 NULL nohasharray
+size_eeprom_93xx46_dev_52988_fields size eeprom_93xx46_dev 0 52988 &scatter_n_efx_rx_queue_52988_fields
+xfs_dir2_block_to_sf_fndecl_52991_fields xfs_dir2_block_to_sf fndecl 3 52991 NULL
+max_rx_agg_size_iwl_cfg_52997_fields max_rx_agg_size iwl_cfg 0 52997 NULL
+hidp_output_report_fndecl_53002_fields hidp_output_report fndecl 3 53002 NULL
+actual_length_urb_53003_fields actual_length urb 0 53003 NULL nohasharray
+rx_nr_pages_bnxt_53003_fields rx_nr_pages bnxt 0 53003 &actual_length_urb_53003_fields
+max_mlx4_srq_53011_fields max mlx4_srq 0 53011 NULL nohasharray
+__shadow_block_fndecl_53011_fields __shadow_block fndecl 2 53011 &max_mlx4_srq_53011_fields
+BC_Read_Reg_IsdnCardState_53020_fields BC_Read_Reg IsdnCardState 0 53020 NULL
+bytesused_ivtv_buffer_53021_fields bytesused ivtv_buffer 0 53021 NULL
+run_test_fndecl_53022_fields run_test fndecl 3-4 53022 NULL
+tty_insert_flip_string_fixed_flag_fndecl_53031_fields tty_insert_flip_string_fixed_flag fndecl 0 53031 NULL
+ni_peertxcredits_lnet_ni_53034_fields ni_peertxcredits lnet_ni 0 53034 NULL
+xfs_filestream_pick_ag_fndecl_53040_fields xfs_filestream_pick_ag fndecl 2-0 53040 NULL nohasharray
+nports0_adapter_info_53040_fields nports0 adapter_info 0 53040 &xfs_filestream_pick_ag_fndecl_53040_fields
+xmit_fifo_size_serial_struct_53048_fields xmit_fifo_size serial_struct 0 53048 NULL
+fcoe_alloc_paged_crc_eof_fndecl_53049_fields fcoe_alloc_paged_crc_eof fndecl 2 53049 NULL
+rqsize_hwif_s_53050_fields rqsize hwif_s 0 53050 NULL
+rx_pad_len_hif_device_usb_53051_fields rx_pad_len hif_device_usb 0 53051 NULL
+dm_bm_write_lock_zero_fndecl_53053_fields dm_bm_write_lock_zero fndecl 2 53053 NULL
+cols_cros_ec_keyb_53054_fields cols cros_ec_keyb 0 53054 NULL
+m_len_ext4_map_blocks_53056_fields m_len ext4_map_blocks 0 53056 NULL
+s_inode_size_nilfs_super_block_53064_fields s_inode_size nilfs_super_block 0 53064 NULL
+ext4_write_end_fndecl_53067_fields ext4_write_end fndecl 5 53067 NULL
+get_pdev_same_bus_fndecl_53069_fields get_pdev_same_bus fndecl 2 53069 NULL
+rcvegrcnt_qib_chip_specific_53071_fields rcvegrcnt qib_chip_specific 0 53071 NULL
+get_rx_frame_len_sxgbe_desc_ops_53074_fields get_rx_frame_len sxgbe_desc_ops 0 53074 NULL
+wMTU_usb_cdc_mbim_extended_desc_53075_fields wMTU usb_cdc_mbim_extended_desc 0 53075 NULL
+vmw_shader_alloc_fndecl_53077_fields vmw_shader_alloc fndecl 3 53077 NULL
+request_len_sg_io_v4_53081_fields request_len sg_io_v4 0 53081 NULL nohasharray
+map_swap_entry_fndecl_53081_fields map_swap_entry fndecl 0 53081 &request_len_sg_io_v4_53081_fields nohasharray
+tcp_established_options_fndecl_53081_fields tcp_established_options fndecl 0 53081 &map_swap_entry_fndecl_53081_fields
+__hci_cmd_sync_ev_fndecl_53090_fields __hci_cmd_sync_ev fndecl 3 53090 NULL
+ext4_itable_unused_set_fndecl_53091_fields ext4_itable_unused_set fndecl 3 53091 NULL
+size_fuse_attr_53098_fields size fuse_attr 0 53098 NULL
+s_blocksize_minix3_super_block_53099_fields s_blocksize minix3_super_block 0 53099 NULL
+prepare_header80_fndecl_53108_fields prepare_header80 fndecl 0 53108 NULL
+count_vbi_info_53110_fields count vbi_info 0 53110 NULL
+fb_max_width_vmw_private_53114_fields fb_max_width vmw_private 0 53114 NULL
+reserve_region_with_split_fndecl_53115_fields reserve_region_with_split fndecl 3-2 53115 NULL
+logi_dj_recv_forward_hidpp_fndecl_53117_fields logi_dj_recv_forward_hidpp fndecl 3 53117 NULL
+pci_iov_add_virtfn_fndecl_53122_fields pci_iov_add_virtfn fndecl 2 53122 NULL
+real_vram_size_radeon_mc_53132_fields real_vram_size radeon_mc 0 53132 NULL
+data_dma_td_53137_fields data_dma td 0 53137 NULL
+log_rq_size_mlx5e_params_53140_fields log_rq_size mlx5e_params 0 53140 NULL
+mmc_spi_readbytes_fndecl_53146_fields mmc_spi_readbytes fndecl 2 53146 NULL
+bdev_writeseg_fndecl_53148_fields bdev_writeseg fndecl 2-3 53148 NULL
+xoffset_fb_var_screeninfo_53153_fields xoffset fb_var_screeninfo 0 53153 NULL
+fat_cont_expand_fndecl_53155_fields fat_cont_expand fndecl 2 53155 NULL
+sb_blocksize_xfs_sb_53160_fields sb_blocksize xfs_sb 0 53160 NULL
+nvmet_copy_to_sgl_fndecl_53164_fields nvmet_copy_to_sgl fndecl 2-4 53164 NULL
+uhci_debug_lseek_fndecl_53171_fields uhci_debug_lseek fndecl 2 53171 NULL
+buf_size_mwifiex_event_scan_result_53175_fields buf_size mwifiex_event_scan_result 0 53175 NULL
+offset_page_frag_53180_fields offset page_frag 0 53180 NULL
+rx_tpa_start_cmp_metadata_rx_tpa_start_cmp_ext_53181_fields rx_tpa_start_cmp_metadata rx_tpa_start_cmp_ext 0 53181 NULL
+tbl_size_vardecl_memattr_c_53182_fields tbl_size vardecl_memattr.c 0 53182 NULL nohasharray
+tpm_devt_vardecl_53182_fields tpm_devt vardecl 0 53182 &tbl_size_vardecl_memattr_c_53182_fields
+xhci_alloc_streams_fndecl_53185_fields xhci_alloc_streams fndecl 5 53185 NULL
+rate_min_snd_soc_pcm_stream_53186_fields rate_min snd_soc_pcm_stream 0 53186 NULL
+len_nxtfrm_brcmf_sdio_hdrinfo_53193_fields len_nxtfrm brcmf_sdio_hdrinfo 0 53193 NULL nohasharray
+num_entries_hfi1_wss_53193_fields num_entries hfi1_wss 0 53193 &len_nxtfrm_brcmf_sdio_hdrinfo_53193_fields
+mpage_process_page_bufs_fndecl_53197_fields mpage_process_page_bufs fndecl 4 53197 NULL
+minor_start_tty_driver_53214_fields minor_start tty_driver 0 53214 NULL
+write_iter_file_operations_53218_fields write_iter file_operations 0 53218 NULL
+aio_run_iocb_fndecl_53224_fields aio_run_iocb fndecl 4 53224 NULL nohasharray
+udf_block_map_fndecl_53224_fields udf_block_map fndecl 0 53224 &aio_run_iocb_fndecl_53224_fields
+meta_slots_used_xenvif_rx_cb_53230_fields meta_slots_used xenvif_rx_cb 0 53230 NULL
+bnx2x_sriov_configure_fndecl_53235_fields bnx2x_sriov_configure fndecl 2 53235 NULL
+mlx4_get_mgm_entry_size_fndecl_53236_fields mlx4_get_mgm_entry_size fndecl 0 53236 NULL
+svcxdr_init_encode_from_buffer_fndecl_53239_fields svcxdr_init_encode_from_buffer fndecl 4 53239 NULL nohasharray
+mmc_test_rw_multiple_fndecl_53239_fields mmc_test_rw_multiple fndecl 3-5 53239 &svcxdr_init_encode_from_buffer_fndecl_53239_fields
+sys_sync_file_range2_fndecl_53247_fields sys_sync_file_range2 fndecl 3-4 53247 NULL
+readpos_ivtv_buffer_53258_fields readpos ivtv_buffer 0 53258 NULL
+qxl_bo_create_fndecl_53261_fields qxl_bo_create fndecl 2 53261 NULL nohasharray
+num_cq_mlx4_profile_53261_fields num_cq mlx4_profile 0 53261 &qxl_bo_create_fndecl_53261_fields
+add_new_ctl_fndecl_53263_fields add_new_ctl fndecl 8 53263 NULL
+asl_urb_dequeue_fndecl_53268_fields asl_urb_dequeue fndecl 3 53268 NULL
+update_dind_extent_range_fndecl_53271_fields update_dind_extent_range fndecl 3 53271 NULL
+rx_pkt_n_frags_efx_channel_53276_fields rx_pkt_n_frags efx_channel 0 53276 NULL nohasharray
+rmi_i2c_write_block_fndecl_53276_fields rmi_i2c_write_block fndecl 4 53276 &rx_pkt_n_frags_efx_channel_53276_fields
+nr_cmds_ctlr_info_53278_fields nr_cmds ctlr_info 0 53278 NULL
+alignment_acpi_resource_memory32_53289_fields alignment acpi_resource_memory32 0 53289 NULL
+nfs4_xattr_set_nfs4_label_fndecl_53292_fields nfs4_xattr_set_nfs4_label fndecl 6 53292 NULL
+compat_ptrace_request_fndecl_53296_fields compat_ptrace_request fndecl 3 53296 NULL
+fuse_ioctl_common_fndecl_53305_fields fuse_ioctl_common fndecl 2 53305 NULL
+gtt_start_radeon_mc_53307_fields gtt_start radeon_mc 0 53307 NULL nohasharray
+dma_size_cx23885_audio_dev_53307_fields dma_size cx23885_audio_dev 0 53307 &gtt_start_radeon_mc_53307_fields
+isoc_in_usbatm_driver_53310_fields isoc_in usbatm_driver 0 53310 NULL nohasharray
+__gfs2_free_blocks_fndecl_53310_fields __gfs2_free_blocks fndecl 2 53310 &isoc_in_usbatm_driver_53310_fields
+len_i40iw_inline_rdma_write_53313_fields len i40iw_inline_rdma_write 0 53313 NULL
+__sync_dirty_buffer_fndecl_53315_fields __sync_dirty_buffer fndecl 0 53315 NULL
+sys_send_fndecl_53330_fields sys_send fndecl 3 53330 NULL
+__drm_gem_cma_create_fndecl_53334_fields __drm_gem_cma_create fndecl 2 53334 NULL
+s_inode_readahead_blks_ext4_sb_info_53337_fields s_inode_readahead_blks ext4_sb_info 0 53337 NULL
+xilly_get_dma_buffers_fndecl_53341_fields xilly_get_dma_buffers fndecl 4 53341 NULL
+v9fs_xattr_set_fndecl_53342_fields v9fs_xattr_set fndecl 4 53342 NULL
+ioc_len_libcfs_ioctl_hdr_53352_fields ioc_len libcfs_ioctl_hdr 0 53352 NULL
+frag_size_hwbm_pool_53355_fields frag_size hwbm_pool 0 53355 NULL
+ali1563_smba_vardecl_i2c_ali1563_c_53362_fields ali1563_smba vardecl_i2c-ali1563.c 0 53362 NULL
+__xdr_inline_decode_fndecl_53363_fields __xdr_inline_decode fndecl 2 53363 NULL
+rsize_hid_device_53365_fields rsize hid_device 0 53365 NULL
+xattr_len_ceph_mds_reply_info_in_53369_fields xattr_len ceph_mds_reply_info_in 0 53369 NULL
+xdr_inline_pages_fndecl_53377_fields xdr_inline_pages fndecl 5-4-2 53377 NULL
+num_user_contexts_vardecl_53379_fields num_user_contexts vardecl 0 53379 NULL
+dummy_urb_dequeue_fndecl_53380_fields dummy_urb_dequeue fndecl 3 53380 NULL
+vmsplice_to_user_fndecl_53382_fields vmsplice_to_user fndecl 3 53382 NULL
+scrub_stripe_fndecl_53387_fields scrub_stripe fndecl 5 53387 NULL
+isd200_action_fndecl_53390_fields isd200_action fndecl 4 53390 NULL
+nfqnl_mangle_fndecl_53393_fields nfqnl_mangle fndecl 2-4 53393 NULL
+irda_recvmsg_stream_fndecl_53403_fields irda_recvmsg_stream fndecl 3 53403 NULL
+len_nft_cmp_fast_expr_53407_fields len nft_cmp_fast_expr 0 53407 NULL
+nid_dnode_of_data_53408_fields nid dnode_of_data 0 53408 NULL
+pwm_num_nct6775_data_53412_fields pwm_num nct6775_data 0 53412 NULL
+vlan_dev_set_egress_priority_fndecl_53418_fields vlan_dev_set_egress_priority fndecl 3 53418 NULL
+nbits_nvmem_cell_info_53426_fields nbits nvmem_cell_info 0 53426 NULL nohasharray
+expand_stack_fndecl_53426_fields expand_stack fndecl 2 53426 &nbits_nvmem_cell_info_53426_fields
+compat_sys_mbind_fndecl_53427_fields compat_sys_mbind fndecl 2-1 53427 NULL nohasharray
+dn_mk_ack_header_fndecl_53427_fields dn_mk_ack_header fndecl 4 53427 &compat_sys_mbind_fndecl_53427_fields
+len_type_frame_head_53438_fields len type_frame_head 0 53438 NULL nohasharray
+chipsize_nand_chip_53438_fields chipsize nand_chip 0 53438 &len_type_frame_head_53438_fields
+ocfs2_filecheck_handle_fndecl_53445_fields ocfs2_filecheck_handle fndecl 2 53445 NULL
+c_blkno_ocfs2_chain_rec_53466_fields c_blkno ocfs2_chain_rec 0 53466 NULL
+new_chunk_sectors_mddev_53479_fields new_chunk_sectors mddev 0 53479 NULL
+ext2_nfs_get_inode_fndecl_53480_fields ext2_nfs_get_inode fndecl 2 53480 NULL
+map_sector_fndecl_53483_fields map_sector fndecl 0 53483 NULL
+nfs4_proc_readlink_fndecl_53484_fields nfs4_proc_readlink fndecl 4-3 53484 NULL
+orangefs_bufmap_copy_from_iovec_fndecl_53485_fields orangefs_bufmap_copy_from_iovec fndecl 3 53485 NULL
+size_mthca_catas_err_53487_fields size mthca_catas_err 0 53487 NULL
+oper_log_mgm_entry_size_mlx4_dev_53488_fields oper_log_mgm_entry_size mlx4_dev 0 53488 NULL
+usCRTC_V_SyncWidth__ATOM_MODE_TIMING_53489_fields usCRTC_V_SyncWidth _ATOM_MODE_TIMING 0 53489 NULL nohasharray
+len_rx_pool_53489_fields len rx_pool 0 53489 &usCRTC_V_SyncWidth__ATOM_MODE_TIMING_53489_fields
+len_nft_cmp_expr_53491_fields len nft_cmp_expr 0 53491 NULL
+isdn_getnum_fndecl_53492_fields isdn_getnum fndecl 0 53492 NULL
+subctxt_cnt_qib_ctxtdata_53495_fields subctxt_cnt qib_ctxtdata 0 53495 NULL nohasharray
+get_allocated_memblock_memory_regions_info_fndecl_53495_fields get_allocated_memblock_memory_regions_info fndecl 0 53495 &subctxt_cnt_qib_ctxtdata_53495_fields
+tipc_link_mtu_fndecl_53508_fields tipc_link_mtu fndecl 0 53508 NULL
+mmc_io_rw_extended_fndecl_53515_fields mmc_io_rw_extended fndecl 8-7 53515 NULL
+dme1737_isa_device_add_fndecl_53516_fields dme1737_isa_device_add fndecl 1 53516 NULL
+fsinfo_sector_msdos_sb_info_53531_fields fsinfo_sector msdos_sb_info 0 53531 NULL nohasharray
+m_max_mds_ceph_mdsmap_53531_fields m_max_mds ceph_mdsmap 0 53531 &fsinfo_sector_msdos_sb_info_53531_fields
+unix_seqpacket_sendmsg_fndecl_53534_fields unix_seqpacket_sendmsg fndecl 3 53534 NULL
+num_res_platform_device_info_53536_fields num_res platform_device_info 0 53536 NULL
+e820_add_region_fndecl_53540_fields e820_add_region fndecl 2 53540 NULL nohasharray
+tcp_mark_head_lost_fndecl_53540_fields tcp_mark_head_lost fndecl 2 53540 &e820_add_region_fndecl_53540_fields
+crtc_w_drm_plane_state_53541_fields crtc_w drm_plane_state 0 53541 NULL
+smi_num_vardecl_ipmi_si_intf_c_53542_fields smi_num vardecl_ipmi_si_intf.c 0 53542 NULL
+start_extent_state_53546_fields start extent_state 0 53546 NULL
+block_size_partition_53549_fields block_size partition 0 53549 NULL
+r_result_ceph_osd_request_53555_fields r_result ceph_osd_request 0 53555 NULL
+log_mpt_sz_mlx4_init_hca_param_53586_fields log_mpt_sz mlx4_init_hca_param 0 53586 NULL
+num_ports_mlx4_caps_53588_fields num_ports mlx4_caps 0 53588 NULL nohasharray
+tokens_size_cfg80211_wowlan_tcp_53588_fields tokens_size cfg80211_wowlan_tcp 0 53588 &num_ports_mlx4_caps_53588_fields
+nr_labels_pktgen_dev_53591_fields nr_labels pktgen_dev 0 53591 NULL
+ocfs2_orphan_filldir_fndecl_53593_fields ocfs2_orphan_filldir fndecl 5 53593 NULL
+nilfs_load_super_block_fndecl_53596_fields nilfs_load_super_block fndecl 3 53596 NULL
+hwptr_done_snd_usb_substream_53606_fields hwptr_done snd_usb_substream 0 53606 NULL
+pcfg_ofsl_cyttsp4_sysinfo_data_53607_fields pcfg_ofsl cyttsp4_sysinfo_data 0 53607 NULL
+md_dump_size_netxen_minidump_53611_fields md_dump_size netxen_minidump 0 53611 NULL
+len_rproc_vring_53618_fields len rproc_vring 0 53618 NULL
+qcaspi_write_legacy_fndecl_53623_fields qcaspi_write_legacy fndecl 3 53623 NULL
+btt_flog_write_fndecl_53628_fields btt_flog_write fndecl 0 53628 NULL
+koneplus_sysfs_write_fndecl_53642_fields koneplus_sysfs_write fndecl 6 53642 NULL
+remote_nentries_xpc_openclose_args_53643_fields remote_nentries xpc_openclose_args 0 53643 NULL
+ticket2_len_rxk5_key_53644_fields ticket2_len rxk5_key 0 53644 NULL
+ioc_plen2_obd_ioctl_data_53648_fields ioc_plen2 obd_ioctl_data 0 53648 NULL
+extra_tx_headroom_rt2x00_dev_53650_fields extra_tx_headroom rt2x00_dev 0 53650 NULL
+ceph_buffer_new_fndecl_53653_fields ceph_buffer_new fndecl 1 53653 NULL
+dlist_count_vc4_plane_state_53658_fields dlist_count vc4_plane_state 0 53658 NULL
+hr_data_len_hsm_request_53666_fields hr_data_len hsm_request 0 53666 NULL
+num_sge_ib_uverbs_send_wr_53667_fields num_sge ib_uverbs_send_wr 0 53667 NULL
+cpu_addr_of_pci_range_53670_fields cpu_addr of_pci_range 0 53670 NULL
+sesskey_len_cifs_spnego_msg_53678_fields sesskey_len cifs_spnego_msg 0 53678 NULL nohasharray
+xen_foreach_remap_area_fndecl_53678_fields xen_foreach_remap_area fndecl 0 53678 &sesskey_len_cifs_spnego_msg_53678_fields nohasharray
+ubi_eba_write_leb_fndecl_53678_fields ubi_eba_write_leb fndecl 6-5 53678 &xen_foreach_remap_area_fndecl_53678_fields
+console_store_fndecl_53684_fields console_store fndecl 4 53684 NULL
+i_depth_gfs2_inode_53692_fields i_depth gfs2_inode 0 53692 NULL nohasharray
+drbd_setup_queue_param_fndecl_53692_fields drbd_setup_queue_param fndecl 3 53692 &i_depth_gfs2_inode_53692_fields
+ql_is_full_dup_fndecl_53694_fields ql_is_full_dup fndecl 0 53694 NULL
+length_iscsi_pdu_53695_fields length iscsi_pdu 0 53695 NULL
+vgt_balloon_space_fndecl_53697_fields vgt_balloon_space fndecl 3-4 53697 NULL
+cfg1_size_pcie_port_53701_fields cfg1_size pcie_port 0 53701 NULL
+wipers_tpl0102_cfg_53702_fields wipers tpl0102_cfg 0 53702 NULL
+qlge_change_mtu_fndecl_53706_fields qlge_change_mtu fndecl 2 53706 NULL
+pos_hdpvr_buffer_53708_fields pos hdpvr_buffer 0 53708 NULL
+create_header_ops_53712_fields create header_ops 0 53712 NULL
+num_leds_gpio_led_platform_data_53715_fields num_leds gpio_led_platform_data 0 53715 NULL
+xdr_inline_decode_fndecl_53721_fields xdr_inline_decode fndecl 2 53721 NULL
+onenand_write_ops_nolock_fndecl_53724_fields onenand_write_ops_nolock fndecl 2 53724 NULL
+i915_gem_object_do_pin_fndecl_53726_fields i915_gem_object_do_pin fndecl 5 53726 NULL
+btt_rw_integrity_fndecl_53727_fields btt_rw_integrity fndecl 0 53727 NULL
+xhci_alloc_stream_info_fndecl_53732_fields xhci_alloc_stream_info fndecl 4 53732 NULL
+adp5588_build_gpiomap_fndecl_53733_fields adp5588_build_gpiomap fndecl 0 53733 NULL nohasharray
+dnode_scif_peer_dev_53733_fields dnode scif_peer_dev 0 53733 &adp5588_build_gpiomap_fndecl_53733_fields
+map_capability_fndecl_53738_fields map_capability fndecl 5 53738 NULL
+chunk_size_stripe_c_53745_fields chunk_size stripe_c 0 53745 NULL
+count_user_sgmap_53748_fields count user_sgmap 0 53748 NULL
+SenderSize_aac_fibhdr_53758_fields SenderSize aac_fibhdr 0 53758 NULL
+seg_num_mad_rmpp_recv_53761_fields seg_num mad_rmpp_recv 0 53761 NULL
+padding_iscsi_cmd_53768_fields padding iscsi_cmd 0 53768 NULL
+end_nilfs_write_info_53770_fields end nilfs_write_info 0 53770 NULL
+msb_read_oob_fndecl_53772_fields msb_read_oob fndecl 2 53772 NULL
+get_slot_from_bitmask_fndecl_53775_fields get_slot_from_bitmask fndecl 0-1 53775 NULL
+do_sendfile_fndecl_53777_fields do_sendfile fndecl 5-4 53777 NULL
+qed_chain_alloc_fndecl_53778_fields qed_chain_alloc fndecl 6-5 53778 NULL
+index_nsc_ircc_cb_53782_fields index nsc_ircc_cb 0 53782 NULL
+src_maxburst_dma_slave_config_53783_fields src_maxburst dma_slave_config 0 53783 NULL
+max_chipselect_fsl_spi_platform_data_53785_fields max_chipselect fsl_spi_platform_data 0 53785 NULL
+Control_2_RxD_t_53794_fields Control_2 RxD_t 0 53794 NULL nohasharray
+qlcnic_process_rcv_fndecl_53794_fields qlcnic_process_rcv fndecl 4 53794 &Control_2_RxD_t_53794_fields
+st21nfca_hci_loopback_fndecl_53795_fields st21nfca_hci_loopback fndecl 3 53795 NULL
+epnum_isp1362_ep_53803_fields epnum isp1362_ep 0 53803 NULL nohasharray
+mgmt_send_event_fndecl_53803_fields mgmt_send_event fndecl 5 53803 &epnum_isp1362_ep_53803_fields nohasharray
+osd_req_list_collection_objects_fndecl_53803_fields osd_req_list_collection_objects fndecl 5 53803 &mgmt_send_event_fndecl_53803_fields
+test_btrfs_split_item_fndecl_53804_fields test_btrfs_split_item fndecl 1-2 53804 NULL nohasharray
+iscsi_host_alloc_fndecl_53804_fields iscsi_host_alloc fndecl 2 53804 &test_btrfs_split_item_fndecl_53804_fields
+rsn_dm_verity_fec_53808_fields rsn dm_verity_fec 0 53808 NULL
+msix_count_xhci_hcd_53816_fields msix_count xhci_hcd 0 53816 NULL
+jffs2_flash_write_fndecl_53819_fields jffs2_flash_write fndecl 3-2 53819 NULL
+doorbell_start_nes_device_53820_fields doorbell_start nes_device 0 53820 NULL
+choose_rate_fndecl_53821_fields choose_rate fndecl 3 53821 NULL
+smem_len_fb_fix_screeninfo_53824_fields smem_len fb_fix_screeninfo 0 53824 NULL
+gsmtty_write_fndecl_53837_fields gsmtty_write fndecl 3 53837 NULL
+resp_ie_length_ndis_80211_assoc_info_53840_fields resp_ie_length ndis_80211_assoc_info 0 53840 NULL
+ssid_len_hidden_net_info_53841_fields ssid_len hidden_net_info 0 53841 NULL
+ext4_mb_discard_group_preallocations_fndecl_53854_fields ext4_mb_discard_group_preallocations fndecl 2 53854 NULL
+minleft_xfs_alloc_arg_53855_fields minleft xfs_alloc_arg 0 53855 NULL
+saa7134_i2c_eeprom_fndecl_53866_fields saa7134_i2c_eeprom fndecl 3 53866 NULL
+data_len_msgbuf_rx_complete_53868_fields data_len msgbuf_rx_complete 0 53868 NULL
+cfsiz_bcm_op_53871_fields cfsiz bcm_op 0 53871 NULL
+discard_alignment_hd_struct_53874_fields discard_alignment hd_struct 0 53874 NULL
+br_fill_ifvlaninfo_range_fndecl_53875_fields br_fill_ifvlaninfo_range fndecl 2-3 53875 NULL
+lnum_bits_ubifs_info_53884_fields lnum_bits ubifs_info 0 53884 NULL
+st_nci_loopback_fndecl_53886_fields st_nci_loopback fndecl 3 53886 NULL nohasharray
+cx25821_alsa_dma_init_fndecl_53886_fields cx25821_alsa_dma_init fndecl 2 53886 &st_nci_loopback_fndecl_53886_fields
+drbd_setbufsize_fndecl_53887_fields drbd_setbufsize fndecl 2 53887 NULL
+amdgpu_vce_sw_init_fndecl_53888_fields amdgpu_vce_sw_init fndecl 2 53888 NULL nohasharray
+max_out_queue_skl_module_cfg_53888_fields max_out_queue skl_module_cfg 0 53888 &amdgpu_vce_sw_init_fndecl_53888_fields
+total_read_TCP_Server_Info_53900_fields total_read TCP_Server_Info 0 53900 NULL
+alignf_resource_constraint_53903_fields alignf resource_constraint 0 53903 NULL nohasharray
+e1000_consume_page_fndecl_53903_fields e1000_consume_page fndecl 3 53903 &alignf_resource_constraint_53903_fields
+image_len_brcmf_usbdev_info_53909_fields image_len brcmf_usbdev_info 0 53909 NULL
+vop_len_solo_enc_dev_53910_fields vop_len solo_enc_dev 0 53910 NULL
+fc_exch_mgr_alloc_fndecl_53916_fields fc_exch_mgr_alloc fndecl 3-4 53916 NULL
+num_cvt_hdac_hdmi_priv_53920_fields num_cvt hdac_hdmi_priv 0 53920 NULL
+htcp_cong_avoid_fndecl_53921_fields htcp_cong_avoid fndecl 3 53921 NULL
+usb_stor_sg_tablesize_fndecl_53929_fields usb_stor_sg_tablesize fndecl 0 53929 NULL nohasharray
+osd_req_op_extent_dup_last_fndecl_53929_fields osd_req_op_extent_dup_last fndecl 3 53929 &usb_stor_sg_tablesize_fndecl_53929_fields
+of_iomap_fndecl_53930_fields of_iomap fndecl 2 53930 NULL
+chip_sdma_engines_hfi1_devdata_53934_fields chip_sdma_engines hfi1_devdata 0 53934 NULL
+i40e_init_lan_hmc_fndecl_53935_fields i40e_init_lan_hmc fndecl 2-3-4-5 53935 NULL
+depth_tm6000_fmt_53938_fields depth tm6000_fmt 0 53938 NULL
+ip4ip6_err_fndecl_53943_fields ip4ip6_err fndecl 5 53943 NULL nohasharray
+_find_first_zero_bit_be_fndecl_53943_fields _find_first_zero_bit_be fndecl 0 53943 &ip4ip6_err_fndecl_53943_fields
+llc_mac_header_len_fndecl_53947_fields llc_mac_header_len fndecl 0 53947 NULL
+buffer_end_nm256_53949_fields buffer_end nm256 0 53949 NULL
+swiotlb_nr_tbl_fndecl_53950_fields swiotlb_nr_tbl fndecl 0 53950 NULL
+p_size_drbd_device_53954_fields p_size drbd_device 0 53954 NULL
+tcf_csum_ipv6_tcp_fndecl_53957_fields tcf_csum_ipv6_tcp fndecl 3 53957 NULL
+c_srate_f_uac2_opts_53962_fields c_srate f_uac2_opts 0 53962 NULL nohasharray
+vmw_sou_backing_alloc_fndecl_53962_fields vmw_sou_backing_alloc fndecl 3 53962 &c_srate_f_uac2_opts_53962_fields
+dests_size_fs_fte_53973_fields dests_size fs_fte 0 53973 NULL
+key_len_wpa_key_t_53980_fields key_len wpa_key_t 0 53980 NULL
+rx_buf_sz_cp_private_53982_fields rx_buf_sz cp_private 0 53982 NULL
+assoc_resp_len_wmi_connect_event_53983_fields assoc_resp_len wmi_connect_event 0 53983 NULL
+nfs_proc_mknod_fndecl_53987_fields nfs_proc_mknod fndecl 4 53987 NULL
+cfpkt_add_head_fndecl_53990_fields cfpkt_add_head fndecl 3 53990 NULL
+vbt_size_intel_opregion_53991_fields vbt_size intel_opregion 0 53991 NULL
+btrfs_init_new_buffer_fndecl_53996_fields btrfs_init_new_buffer fndecl 3 53996 NULL
+size_drbd_interval_54002_fields size drbd_interval 0 54002 NULL
+ax88179_change_mtu_fndecl_54007_fields ax88179_change_mtu fndecl 2 54007 NULL
+nonstatic_find_io_fndecl_54015_fields nonstatic_find_io fndecl 4 54015 NULL
+rsi_setblocklength_fndecl_54024_fields rsi_setblocklength fndecl 2 54024 NULL
+xz_dec_lzma2_create_fndecl_54034_fields xz_dec_lzma2_create fndecl 2 54034 NULL
+sum_size_jffs2_summary_54035_fields sum_size jffs2_summary 0 54035 NULL
+nr_states_gpio_regulator_config_54042_fields nr_states gpio_regulator_config 0 54042 NULL
+msb_update_block_fndecl_54063_fields msb_update_block fndecl 4-2 54063 NULL
+process_ptload_program_headers_elf32_fndecl_54067_fields process_ptload_program_headers_elf32 fndecl 3-2 54067 NULL
+width_fb_image_54071_fields width fb_image 0 54071 NULL
+rp2_minor_next_vardecl_rp2_c_54074_fields rp2_minor_next vardecl_rp2.c 0 54074 NULL
+xennet_change_mtu_fndecl_54076_fields xennet_change_mtu fndecl 2 54076 NULL
+bytes_cifs_writedata_54089_fields bytes cifs_writedata 0 54089 NULL
+get_mtu_xfrm_type_54090_fields get_mtu xfrm_type 0 54090 NULL
+sctp_tsnmap_init_fndecl_54093_fields sctp_tsnmap_init fndecl 2 54093 NULL nohasharray
+align_pnp_port_54093_fields align pnp_port 0 54093 &sctp_tsnmap_init_fndecl_54093_fields
+fat_ent_write_fndecl_54100_fields fat_ent_write fndecl 0 54100 NULL
+i2c_bus_read_fndecl_54111_fields i2c_bus_read fndecl 7-5 54111 NULL
+xfs_rtmodify_summary_int_fndecl_54118_fields xfs_rtmodify_summary_int fndecl 4-3-0 54118 NULL nohasharray
+rio_request_inb_mbox_fndecl_54118_fields rio_request_inb_mbox fndecl 3 54118 &xfs_rtmodify_summary_int_fndecl_54118_fields
+vringh_iov_push_kern_fndecl_54119_fields vringh_iov_push_kern fndecl 3 54119 NULL
+alloc_etherdev_mqs_fndecl_54129_fields alloc_etherdev_mqs fndecl 2-1-3 54129 NULL
+mtu_vxlan_config_54132_fields mtu vxlan_config 0 54132 NULL nohasharray
+skb_trim_fndecl_54132_fields skb_trim fndecl 2 54132 &mtu_vxlan_config_54132_fields
+io_offset_xfs_ioend_54137_fields io_offset xfs_ioend 0 54137 NULL nohasharray
+bdx_fifo_init_fndecl_54137_fields bdx_fifo_init fndecl 3 54137 &io_offset_xfs_ioend_54137_fields
+tcf_csum_ipv6_udp_fndecl_54138_fields tcf_csum_ipv6_udp fndecl 3 54138 NULL
+change_protection_range_fndecl_54141_fields change_protection_range fndecl 3-2 54141 NULL
+netvsc_change_mtu_fndecl_54142_fields netvsc_change_mtu fndecl 2 54142 NULL nohasharray
+nr_uart_sc16is7xx_devtype_54142_fields nr_uart sc16is7xx_devtype 0 54142 &netvsc_change_mtu_fndecl_54142_fields
+f2fs_do_collapse_fndecl_54143_fields f2fs_do_collapse fndecl 2 54143 NULL
+brcmf_usb_dl_writeimage_fndecl_54144_fields brcmf_usb_dl_writeimage fndecl 3 54144 NULL
+hs_cur_bits_cfs_hash_54147_fields hs_cur_bits cfs_hash 0 54147 NULL
+sp2_write_i2c_fndecl_54157_fields sp2_write_i2c fndecl 4 54157 NULL
+num_qp_mthca_profile_54160_fields num_qp mthca_profile 0 54160 NULL
+buf_len_lpfc_sli_config_mse_54165_fields buf_len lpfc_sli_config_mse 0 54165 NULL
+cmd_loop_fndecl_54168_fields cmd_loop fndecl 0 54168 NULL
+writebuf_size_tomoyo_io_buffer_54169_fields writebuf_size tomoyo_io_buffer 0 54169 NULL
+st_nci_probe_fndecl_54170_fields st_nci_probe fndecl 2 54170 NULL
+handle_one_ule_extension_fndecl_54174_fields handle_one_ule_extension fndecl 0 54174 NULL
+num_bytes_drm_dp_remote_dpcd_write_54181_fields num_bytes drm_dp_remote_dpcd_write 0 54181 NULL
+ecc_size_mtk_nfc_fdm_54182_fields ecc_size mtk_nfc_fdm 0 54182 NULL
+len_xfs_alloc_arg_54187_fields len xfs_alloc_arg 0 54187 NULL
+nfs_llseek_dir_fndecl_54192_fields nfs_llseek_dir fndecl 2 54192 NULL
+tp_ep_bcm5974_config_54193_fields tp_ep bcm5974_config 0 54193 NULL
+current_speed_ide_drive_s_54197_fields current_speed ide_drive_s 0 54197 NULL
+ipw2100_set_essid_fndecl_54200_fields ipw2100_set_essid fndecl 3 54200 NULL
+contexts_nouveau_fence_priv_54204_fields contexts nouveau_fence_priv 0 54204 NULL nohasharray
+ath6kl_interface_add_fndecl_54204_fields ath6kl_interface_add fndecl 5 54204 &contexts_nouveau_fence_priv_54204_fields
+___ieee80211_stop_tx_ba_session_fndecl_54205_fields ___ieee80211_stop_tx_ba_session fndecl 2 54205 NULL
+alloced_ctxt_eager_bufs_54208_fields alloced ctxt_eager_bufs 0 54208 NULL
+__lock_page_killable_fndecl_54210_fields __lock_page_killable fndecl 0 54210 NULL nohasharray
+mxt_bootloader_write_fndecl_54210_fields mxt_bootloader_write fndecl 3 54210 &__lock_page_killable_fndecl_54210_fields
+page_offset_ixgbe_rx_buffer_54214_fields page_offset ixgbe_rx_buffer 0 54214 NULL
+post_send_ib_device_54215_fields post_send ib_device 0 54215 NULL
+tx_ring_size_ql_adapter_54220_fields tx_ring_size ql_adapter 0 54220 NULL nohasharray
+append_frame_to_pkt_fndecl_54220_fields append_frame_to_pkt fndecl 2 54220 &tx_ring_size_ql_adapter_54220_fields
+lib80211_tkip_encrypt_fndecl_54222_fields lib80211_tkip_encrypt fndecl 2 54222 NULL
+num_boxes_intel_uncore_type_54227_fields num_boxes intel_uncore_type 0 54227 NULL
+vbi_hlen_saa7134_dev_54228_fields vbi_hlen saa7134_dev 0 54228 NULL
+do_init_dirent_fndecl_54230_fields do_init_dirent fndecl 5 54230 NULL
+skb_copy_and_csum_datagram_msg_fndecl_54237_fields skb_copy_and_csum_datagram_msg fndecl 2 54237 NULL
+tcp_queue_rcv_fndecl_54242_fields tcp_queue_rcv fndecl 3 54242 NULL
+upper_margin_fb_var_screeninfo_54245_fields upper_margin fb_var_screeninfo 0 54245 NULL
+la_last_gd_ocfs2_super_54246_fields la_last_gd ocfs2_super 0 54246 NULL
+num_counters_compat_ipt_replace_54249_fields num_counters compat_ipt_replace 0 54249 NULL
+ttm_object_device_init_fndecl_54252_fields ttm_object_device_init fndecl 2 54252 NULL
+__erst_read_fndecl_54256_fields __erst_read fndecl 1 54256 NULL
+ssb_bus_scan_fndecl_54257_fields ssb_bus_scan fndecl 2 54257 NULL
+msdu_len_htt_rx_in_ord_msdu_desc_54278_fields msdu_len htt_rx_in_ord_msdu_desc 0 54278 NULL
+xfs_bmap_split_indlen_fndecl_54284_fields xfs_bmap_split_indlen fndecl 0 54284 NULL
+key_size_crypt_config_54287_fields key_size crypt_config 0 54287 NULL
+thoff_flow_dissector_key_control_54299_fields thoff flow_dissector_key_control 0 54299 NULL
+rss_key_size_i40evf_adapter_54301_fields rss_key_size i40evf_adapter 0 54301 NULL
+ntfs_attr_extend_initialized_fndecl_54303_fields ntfs_attr_extend_initialized fndecl 2 54303 NULL nohasharray
+count_ext4_new_flex_group_data_54303_fields count ext4_new_flex_group_data 0 54303 &ntfs_attr_extend_initialized_fndecl_54303_fields
+ceph_osdc_start_request_fndecl_54305_fields ceph_osdc_start_request fndecl 0 54305 NULL
+determine_backup_region_fndecl_54330_fields determine_backup_region fndecl 1-2 54330 NULL
+length_acpi_table_header_54332_fields length acpi_table_header 0 54332 NULL
+vringh_iov_push_user_fndecl_54340_fields vringh_iov_push_user fndecl 3 54340 NULL nohasharray
+iscsi_conn_setup_fndecl_54340_fields iscsi_conn_setup fndecl 2 54340 &vringh_iov_push_user_fndecl_54340_fields
+max_rcvbuf_size_tipc_server_54342_fields max_rcvbuf_size tipc_server 0 54342 NULL
+max_raw_minors_vardecl_raw_c_54348_fields max_raw_minors vardecl_raw.c 0 54348 NULL
+p_offset_elf32_phdr_54352_fields p_offset elf32_phdr 0 54352 NULL
+hfsplus_block_allocate_fndecl_54353_fields hfsplus_block_allocate fndecl 0-3-2 54353 NULL
+s_fpbmask_ufs_sb_private_info_54354_fields s_fpbmask ufs_sb_private_info 0 54354 NULL
+encode_netobj_fndecl_54356_fields encode_netobj fndecl 3 54356 NULL
+radeon_vram_limit_vardecl_54357_fields radeon_vram_limit vardecl 0 54357 NULL
+tpm_tis_i2c_send_fndecl_54358_fields tpm_tis_i2c_send fndecl 3 54358 NULL
+pkt_size_rx_pkt_status_54360_fields pkt_size rx_pkt_status 0 54360 NULL
+ceph_get_caps_fndecl_54363_fields ceph_get_caps fndecl 0 54363 NULL nohasharray
+len_ieee_types_vendor_header_54363_fields len ieee_types_vendor_header 0 54363 &ceph_get_caps_fndecl_54363_fields
+mlx4_ib_get_cq_umem_fndecl_54371_fields mlx4_ib_get_cq_umem fndecl 5-6 54371 NULL nohasharray
+num_cpu_pages_radeon_gart_54371_fields num_cpu_pages radeon_gart 0 54371 &mlx4_ib_get_cq_umem_fndecl_54371_fields
+paddr_vmcore_54380_fields paddr vmcore 0 54380 NULL
+iwl_nvm_read_chunk_fndecl_54381_fields iwl_nvm_read_chunk fndecl 0 54381 NULL
+btrfs_copy_file_range_fndecl_54383_fields btrfs_copy_file_range fndecl 4-2-5 54383 NULL
+bt878_adr_bt878_54384_fields bt878_adr bt878 0 54384 NULL
+mt7601u_rx_next_seg_len_fndecl_54390_fields mt7601u_rx_next_seg_len fndecl 0 54390 NULL
+csum_offset_nft_payload_set_54397_fields csum_offset nft_payload_set 0 54397 NULL
+memsize_viafb_par_54399_fields memsize viafb_par 0 54399 NULL
+leaf_shift_left_fndecl_54401_fields leaf_shift_left fndecl 3 54401 NULL
+_osd_req_alist_elem_size_fndecl_54403_fields _osd_req_alist_elem_size fndecl 0-2 54403 NULL
+gr_ep0_respond_fndecl_54405_fields gr_ep0_respond fndecl 3 54405 NULL
+len_a2mp_cmd_54407_fields len a2mp_cmd 0 54407 NULL
+vmw_execbuf_submit_fifo_fndecl_54409_fields vmw_execbuf_submit_fifo fndecl 3 54409 NULL nohasharray
+wp_retry_size_smb_version_operations_54409_fields wp_retry_size smb_version_operations 0 54409 &vmw_execbuf_submit_fifo_fndecl_54409_fields nohasharray
+xfs_ialloc_ag_select_fndecl_54409_fields xfs_ialloc_ag_select fndecl 2-0 54409 &wp_retry_size_smb_version_operations_54409_fields
+mthca_alloc_icm_coherent_fndecl_54412_fields mthca_alloc_icm_coherent fndecl 3 54412 NULL
+user_height_soc_camera_device_54417_fields user_height soc_camera_device 0 54417 NULL
+qlcnic_process_lro_fndecl_54418_fields qlcnic_process_lro fndecl 4-3 54418 NULL
+oxygen_pci_probe_fndecl_54423_fields oxygen_pci_probe fndecl 2 54423 NULL
+follow_page_mask_fndecl_54427_fields follow_page_mask fndecl 2 54427 NULL
+qnx6_get_devblock_fndecl_54428_fields qnx6_get_devblock fndecl 0 54428 NULL
+startbit_netlbl_lsm_catmap_54432_fields startbit netlbl_lsm_catmap 0 54432 NULL
+ieee80211_add_tx_radiotap_header_fndecl_54443_fields ieee80211_add_tx_radiotap_header fndecl 5 54443 NULL
+jbd2_journal_get_write_access_fndecl_54444_fields jbd2_journal_get_write_access fndecl 0 54444 NULL
+upd_ltab_fndecl_54459_fields upd_ltab fndecl 3 54459 NULL
+a_count_posix_acl_54461_fields a_count posix_acl 0 54461 NULL nohasharray
+vringh_init_kern_fndecl_54461_fields vringh_init_kern fndecl 3 54461 &a_count_posix_acl_54461_fields
+ide_inb_fndecl_54462_fields ide_inb fndecl 0 54462 NULL nohasharray
+ide_mm_inb_fndecl_54462_fields ide_mm_inb fndecl 0 54462 &ide_inb_fndecl_54462_fields
+mlxsw_emad_alloc_fndecl_54469_fields mlxsw_emad_alloc fndecl 2 54469 NULL
+memory_device_code_ms_boot_attr_info_54474_fields memory_device_code ms_boot_attr_info 0 54474 NULL
+ocfs2_divide_xattr_cluster_fndecl_54477_fields ocfs2_divide_xattr_cluster fndecl 3-4 54477 NULL
+initial_height_vmw_private_54479_fields initial_height vmw_private 0 54479 NULL nohasharray
+adf7242_write_fbuf_fndecl_54479_fields adf7242_write_fbuf fndecl 3 54479 &initial_height_vmw_private_54479_fields
+spi_write_buf_fndecl_54490_fields spi_write_buf fndecl 2 54490 NULL
+do_preadv_fndecl_54493_fields do_preadv fndecl 3 54493 NULL
+n_chan_comedi_subdevice_54496_fields n_chan comedi_subdevice 0 54496 NULL
+dev_start_strip_zone_54501_fields dev_start strip_zone 0 54501 NULL
+max_fds_fdtable_54502_fields max_fds fdtable 0 54502 NULL
+mwifiex_set_gen_ie_helper_fndecl_54506_fields mwifiex_set_gen_ie_helper fndecl 3 54506 NULL
+m_agfrotor_xfs_mount_54510_fields m_agfrotor xfs_mount 0 54510 NULL nohasharray
+get_rxfh_indir_size_ethtool_ops_54510_fields get_rxfh_indir_size ethtool_ops 0 54510 &m_agfrotor_xfs_mount_54510_fields
+__btrfs_buffered_write_fndecl_54524_fields __btrfs_buffered_write fndecl 3 54524 NULL
+ocfs2_read_dir_block_direct_fndecl_54528_fields ocfs2_read_dir_block_direct fndecl 2 54528 NULL
+num_ccells_cnic_local_54538_fields num_ccells cnic_local 0 54538 NULL
+v_sync_strt_wid_crtc_54541_fields v_sync_strt_wid crtc 0 54541 NULL nohasharray
+bandlength_Kiara_table_entry_54541_fields bandlength Kiara_table_entry 0 54541 &v_sync_strt_wid_crtc_54541_fields
+s_dev_table_count_exofs_fscb_54542_fields s_dev_table_count exofs_fscb 0 54542 NULL
+smaps_hugetlb_range_fndecl_54549_fields smaps_hugetlb_range fndecl 3 54549 NULL
+pages_snd_sg_buf_54557_fields pages snd_sg_buf 0 54557 NULL
+interval_exp_blk_integrity_54558_fields interval_exp blk_integrity 0 54558 NULL
+ath6kl_wmi_probe_report_req_cmd_fndecl_54576_fields ath6kl_wmi_probe_report_req_cmd fndecl 2 54576 NULL
+qnx6_check_first_superblock_fndecl_54577_fields qnx6_check_first_superblock fndecl 2 54577 NULL
+priority_sk_buff_54581_fields priority sk_buff 0 54581 NULL
+size_dw_guc_css_header_54583_fields size_dw guc_css_header 0 54583 NULL nohasharray
+size_acpi_gpio_mapping_54583_fields size acpi_gpio_mapping 0 54583 &size_dw_guc_css_header_54583_fields
+usb_serial_generic_prepare_write_buffer_fndecl_54586_fields usb_serial_generic_prepare_write_buffer fndecl 3 54586 NULL
+erase_size_mmc_card_54587_fields erase_size mmc_card 0 54587 NULL
+width_cx231xx_54591_fields width cx231xx 0 54591 NULL nohasharray
+near_copies_geom_54591_fields near_copies geom 0 54591 &width_cx231xx_54591_fields
+viafb_i2c_readbytes_fndecl_54593_fields viafb_i2c_readbytes fndecl 5 54593 NULL
+alloc_block_buf_fndecl_54594_fields alloc_block_buf fndecl 1 54594 NULL
+vmw_local_fifo_reserve_fndecl_54601_fields vmw_local_fifo_reserve fndecl 2 54601 NULL
+fat32_length_fat_bios_param_block_54606_fields fat32_length fat_bios_param_block 0 54606 NULL
+adfs_f_read_fndecl_54612_fields adfs_f_read fndecl 2 54612 NULL
+pages_in_unit___stripe_pages_2d_54623_fields pages_in_unit __stripe_pages_2d 0 54623 NULL nohasharray
+nr_frames_frame_vector_54623_fields nr_frames frame_vector 0 54623 &pages_in_unit___stripe_pages_2d_54623_fields
+ext4_new_meta_blocks_fndecl_54631_fields ext4_new_meta_blocks fndecl 0 54631 NULL
+vt1211_device_add_fndecl_54634_fields vt1211_device_add fndecl 1 54634 NULL
+text_len_printk_log_54636_fields text_len printk_log 0 54636 NULL nohasharray
+bits_per_sample_soc_mbus_pixelfmt_54636_fields bits_per_sample soc_mbus_pixelfmt 0 54636 &text_len_printk_log_54636_fields
+scif_create_remote_window_fndecl_54638_fields scif_create_remote_window fndecl 2 54638 NULL nohasharray
+n_tx_channels_efx_nic_54638_fields n_tx_channels efx_nic 0 54638 &scif_create_remote_window_fndecl_54638_fields
+extra_mpdu_prefix_len_lib80211_crypto_ops_54644_fields extra_mpdu_prefix_len lib80211_crypto_ops 0 54644 NULL nohasharray
+nchannels_cosa_data_54644_fields nchannels cosa_data 0 54644 &extra_mpdu_prefix_len_lib80211_crypto_ops_54644_fields
+MaxChainDepth_mpt3sas_facts_54646_fields MaxChainDepth mpt3sas_facts 0 54646 NULL
+write_msg_fndecl_54647_fields write_msg fndecl 3 54647 NULL
+calc_buffer_ahash_fndecl_54648_fields calc_buffer_ahash fndecl 2 54648 NULL
+__inode_permission_fndecl_54654_fields __inode_permission fndecl 0 54654 NULL
+tx_flags_fe_priv_54658_fields tx_flags fe_priv 0 54658 NULL
+reshape_position_mddev_54660_fields reshape_position mddev 0 54660 NULL nohasharray
+truncate_pagecache_fndecl_54660_fields truncate_pagecache fndecl 2 54660 &reshape_position_mddev_54660_fields
+s_session_udf_sb_info_54662_fields s_session udf_sb_info 0 54662 NULL
+ssid_len_hostap_bss_info_54670_fields ssid_len hostap_bss_info 0 54670 NULL
+sb_imax_pct_xfs_sb_54671_fields sb_imax_pct xfs_sb 0 54671 NULL
+id_pps_device_54684_fields id pps_device 0 54684 NULL
+fwbulkwritelen_tda10048_config_54693_fields fwbulkwritelen tda10048_config 0 54693 NULL
+num_queue_pairs_i40e_vsi_54696_fields num_queue_pairs i40e_vsi 0 54696 NULL
+max_pages_per_frmr_ocrdma_dev_attr_54699_fields max_pages_per_frmr ocrdma_dev_attr 0 54699 NULL
+ia_rows_ar5416IniArray_54700_fields ia_rows ar5416IniArray 0 54700 NULL
+osd_req_op_notify_ack_init_fndecl_54701_fields osd_req_op_notify_ack_init fndecl 6 54701 NULL
+qed_sriov_configure_fndecl_54702_fields qed_sriov_configure fndecl 2 54702 NULL
+bo_number_drm_amdgpu_bo_list_in_54706_fields bo_number drm_amdgpu_bo_list_in 0 54706 NULL
+buffer_size_pisosr_gpio_54707_fields buffer_size pisosr_gpio 0 54707 NULL
+read_endpoint_zr364xx_camera_54710_fields read_endpoint zr364xx_camera 0 54710 NULL
+process_rcvd_status_fndecl_54722_fields process_rcvd_status fndecl 3 54722 NULL
+queue_size_eata_info_54734_fields queue_size eata_info 0 54734 NULL
+wBytesPerInterval_usb_ss_ep_comp_descriptor_54739_fields wBytesPerInterval usb_ss_ep_comp_descriptor 0 54739 NULL
+end_writequeue_entry_54752_fields end writequeue_entry 0 54752 NULL
+lpfc_hba_queue_depth_init_fndecl_54754_fields lpfc_hba_queue_depth_init fndecl 2 54754 NULL
+size__drm_via_cmdbuffer_54755_fields size _drm_via_cmdbuffer 0 54755 NULL
+spi_xcomm_setup_transfer_fndecl_54757_fields spi_xcomm_setup_transfer fndecl 0 54757 NULL
+qib_lkey_table_size_vardecl_qib_verbs_c_54764_fields qib_lkey_table_size vardecl_qib_verbs.c 0 54764 NULL
+hsc_major_vardecl_hsi_char_c_54769_fields hsc_major vardecl_hsi_char.c 0 54769 NULL
+x_len_ccp_ecc_point_54774_fields x_len ccp_ecc_point 0 54774 NULL
+start_fstrim_range_54775_fields start fstrim_range 0 54775 NULL
+append_cnt_ixgbe_cb_54776_fields append_cnt ixgbe_cb 0 54776 NULL
+ext_channel_count_hda_gen_spec_54778_fields ext_channel_count hda_gen_spec 0 54778 NULL
+xfs_rtallocate_extent_fndecl_54783_fields xfs_rtallocate_extent fndecl 2-8-4-0 54783 NULL
+rcvegrbuf_chunks_qib_ctxtdata_54789_fields rcvegrbuf_chunks qib_ctxtdata 0 54789 NULL
+size_dvb_ringbuffer_54794_fields size dvb_ringbuffer 0 54794 NULL
+num_sg_agp_memory_54800_fields num_sg agp_memory 0 54800 NULL
+num_snd_bebob_meter_spec_54805_fields num snd_bebob_meter_spec 0 54805 NULL
+dma_reserve_vardecl_page_alloc_c_54807_fields dma_reserve vardecl_page_alloc.c 0 54807 NULL
+fsx_extsize_fsxattr_54812_fields fsx_extsize fsxattr 0 54812 NULL
+ep_out_ksdazzle_cb_54817_fields ep_out ksdazzle_cb 0 54817 NULL nohasharray
+stripe_sectors_dm_raid_superblock_54817_fields stripe_sectors dm_raid_superblock 0 54817 &ep_out_ksdazzle_cb_54817_fields nohasharray
+nv50_vm_create_fndecl_54817_fields nv50_vm_create fndecl 3-2 54817 &stripe_sectors_dm_raid_superblock_54817_fields
+mtu_cap_rxe_port_54821_fields mtu_cap rxe_port 0 54821 NULL
+target_count_dm_ioctl_54826_fields target_count dm_ioctl 0 54826 NULL
+last_adv_data_len_discovery_state_54833_fields last_adv_data_len discovery_state 0 54833 NULL
+kernel_readv_fndecl_54834_fields kernel_readv fndecl 3 54834 NULL
+bgpio_bits_gpio_chip_54844_fields bgpio_bits gpio_chip 0 54844 NULL
+reiserfs_readpages_fndecl_54846_fields reiserfs_readpages fndecl 4 54846 NULL
+request_lock_fndecl_54853_fields request_lock fndecl 4 54853 NULL
+addr_len_net_device_54857_fields addr_len net_device 0 54857 NULL
+sr_blkno_ocfs2_suballoc_result_54860_fields sr_blkno ocfs2_suballoc_result 0 54860 NULL
+shmem_file_llseek_fndecl_54863_fields shmem_file_llseek fndecl 2 54863 NULL nohasharray
+mru_ippp_struct_54863_fields mru ippp_struct 0 54863 &shmem_file_llseek_fndecl_54863_fields
+leaf_copy_boundary_item_fndecl_54870_fields leaf_copy_boundary_item fndecl 4 54870 NULL
+cxgb4_iov_configure_fndecl_54874_fields cxgb4_iov_configure fndecl 2 54874 NULL
+bufsize_nm256_stream_54875_fields bufsize nm256_stream 0 54875 NULL
+md_super_write_fndecl_54884_fields md_super_write fndecl 4-3 54884 NULL
+__breadahead_fndecl_54896_fields __breadahead fndecl 3-2 54896 NULL
+dm_table_create_fndecl_54900_fields dm_table_create fndecl 3 54900 NULL
+ext4_es_cache_extent_fndecl_54906_fields ext4_es_cache_extent fndecl 2-3 54906 NULL
+numa_distance_cnt_vardecl_numa_c_54911_fields numa_distance_cnt vardecl_numa.c 0 54911 NULL
+iscsit_build_pdu_and_seq_lists_fndecl_54916_fields iscsit_build_pdu_and_seq_lists fndecl 2 54916 NULL
+line_length_fb_fix_screeninfo_54923_fields line_length fb_fix_screeninfo 0 54923 NULL nohasharray
+ipr_copy_ucode_buffer_fndecl_54923_fields ipr_copy_ucode_buffer fndecl 3 54923 &line_length_fb_fix_screeninfo_54923_fields
+sector_dm_io_region_54924_fields sector dm_io_region 0 54924 NULL
+__clone_blkaddrs_fndecl_54943_fields __clone_blkaddrs fndecl 6-5 54943 NULL
+blk_queue_logical_block_size_fndecl_54946_fields blk_queue_logical_block_size fndecl 2 54946 NULL
+page_add_anon_rmap_fndecl_54950_fields page_add_anon_rmap fndecl 3 54950 NULL
+encx24j600_cmdn_fndecl_54953_fields encx24j600_cmdn fndecl 4 54953 NULL nohasharray
+per_rxd_space_vxge_hw_ring_attr_54953_fields per_rxd_space vxge_hw_ring_attr 0 54953 &encx24j600_cmdn_fndecl_54953_fields
+log_blocks_per_seg_f2fs_super_block_54960_fields log_blocks_per_seg f2fs_super_block 0 54960 NULL
+pci_enable_sriov_fndecl_54962_fields pci_enable_sriov fndecl 2 54962 NULL
+offset_usb_iso_packet_descriptor_54977_fields offset usb_iso_packet_descriptor 0 54977 NULL
+v4l2_src_w_yuv_playback_info_54979_fields v4l2_src_w yuv_playback_info 0 54979 NULL
+rx_frame_size_pn533_frame_ops_54990_fields rx_frame_size pn533_frame_ops 0 54990 NULL
+ns_last_cno_the_nilfs_54997_fields ns_last_cno the_nilfs 0 54997 NULL
+rx_bufsize_bc_state_54999_fields rx_bufsize bc_state 0 54999 NULL nohasharray
+send_wqe_overhead_fndecl_54999_fields send_wqe_overhead fndecl 0 54999 &rx_bufsize_bc_state_54999_fields
+of_irq_to_resource_fndecl_55008_fields of_irq_to_resource fndecl 2 55008 NULL
+reply_payload_rcv_len_iscsi_bsg_reply_55012_fields reply_payload_rcv_len iscsi_bsg_reply 0 55012 NULL
+of_pci_get_host_bridge_resources_fndecl_55015_fields of_pci_get_host_bridge_resources fndecl 3-2 55015 NULL
+cz_smu_populate_single_scratch_entry_fndecl_55022_fields cz_smu_populate_single_scratch_entry fndecl 3 55022 NULL
+get_memsize_fndecl_55032_fields get_memsize fndecl 0 55032 NULL
+ov518_i2c_r_fndecl_55039_fields ov518_i2c_r fndecl 0 55039 NULL
+vram_end_amdgpu_mc_55051_fields vram_end amdgpu_mc 0 55051 NULL
+h_panel_info_55057_fields h panel_info 0 55057 NULL nohasharray
+osd_xres_vardecl_ivtvfb_c_55057_fields osd_xres vardecl_ivtvfb.c 0 55057 &h_panel_info_55057_fields
+olo_num_comps_pnfs_osd_layout_55062_fields olo_num_comps pnfs_osd_layout 0 55062 NULL
+restart_sge_fndecl_55067_fields restart_sge fndecl 0-4-3 55067 NULL
+size_netup_unidvb_buffer_55068_fields size netup_unidvb_buffer 0 55068 NULL
+p9_virtio_zc_request_fndecl_55074_fields p9_virtio_zc_request fndecl 6-5-7 55074 NULL
+dev_dm_ioctl_55075_fields dev dm_ioctl 0 55075 NULL
+btrfs_truncate_block_fndecl_55083_fields btrfs_truncate_block fndecl 2 55083 NULL nohasharray
+__snd_rawmidi_transmit_ack_fndecl_55083_fields __snd_rawmidi_transmit_ack fndecl 0-2 55083 &btrfs_truncate_block_fndecl_55083_fields
+frame_len_b43legacy_rxhdr_fw3_55086_fields frame_len b43legacy_rxhdr_fw3 0 55086 NULL
+vlan_rx_desc_55097_fields vlan rx_desc 0 55097 NULL
+nftids_tid_info_55104_fields nftids tid_info 0 55104 NULL nohasharray
+fat_mirror_bhs_fndecl_55104_fields fat_mirror_bhs fndecl 0 55104 &nftids_tid_info_55104_fields
+num_channels_ad5360_chip_info_55106_fields num_channels ad5360_chip_info 0 55106 NULL nohasharray
+fat_dir_entries_fat_bios_param_block_55106_fields fat_dir_entries fat_bios_param_block 0 55106 &num_channels_ad5360_chip_info_55106_fields
+pnfs_num_cont_bytes_fndecl_55107_fields pnfs_num_cont_bytes fndecl 0-2 55107 NULL
+min_channel_count_hda_gen_spec_55108_fields min_channel_count hda_gen_spec 0 55108 NULL
+scatterwalk_ffwd_fndecl_55110_fields scatterwalk_ffwd fndecl 3 55110 NULL
+y_zoran_overlay_settings_55113_fields y zoran_overlay_settings 0 55113 NULL
+unpack_to_rootfs_fndecl_55124_fields unpack_to_rootfs fndecl 2 55124 NULL
+ea_data_len_gfs2_ea_header_55134_fields ea_data_len gfs2_ea_header 0 55134 NULL
+___ieee80211_stop_rx_ba_session_fndecl_55145_fields ___ieee80211_stop_rx_ba_session fndecl 2 55145 NULL
+namelen_dlm_lock_params_55146_fields namelen dlm_lock_params 0 55146 NULL
+gigaset_isowbuf_getbytes_fndecl_55147_fields gigaset_isowbuf_getbytes fndecl 0-2 55147 NULL
+befs_find_brun_dblindirect_fndecl_55152_fields befs_find_brun_dblindirect fndecl 3 55152 NULL
+offset_req_ies_ndis_80211_assoc_info_55155_fields offset_req_ies ndis_80211_assoc_info 0 55155 NULL
+sb_start_md_rdev_55161_fields sb_start md_rdev 0 55161 NULL
+bytes_xfered_i40iw_cq_poll_info_55165_fields bytes_xfered i40iw_cq_poll_info 0 55165 NULL
+len_replay_entry_55168_fields len replay_entry 0 55168 NULL
+pid_filter_count_dvb_usb_adapter_fe_properties_55180_fields pid_filter_count dvb_usb_adapter_fe_properties 0 55180 NULL
+hpfs_load_code_page_fndecl_55184_fields hpfs_load_code_page fndecl 2 55184 NULL
+rvda_opregion_asle_55185_fields rvda opregion_asle 0 55185 NULL
+result_dio_55189_fields result dio 0 55189 NULL
+extended_capabilities_len_wiphy_iftype_ext_capab_55191_fields extended_capabilities_len wiphy_iftype_ext_capab 0 55191 NULL nohasharray
+n_limits_ieee80211_iface_combination_55191_fields n_limits ieee80211_iface_combination 0 55191 &extended_capabilities_len_wiphy_iftype_ext_capab_55191_fields
+vmxnet3_change_mtu_fndecl_55195_fields vmxnet3_change_mtu fndecl 2 55195 NULL
+seg_count_agp_region_55196_fields seg_count agp_region 0 55196 NULL
+drm_gtf2_2c_fndecl_55202_fields drm_gtf2_2c fndecl 0 55202 NULL
+len_uffdio_range_55211_fields len uffdio_range 0 55211 NULL
+num_eqs_mlx4_caps_55225_fields num_eqs mlx4_caps 0 55225 NULL
+adv_instance_cnt_hci_dev_55228_fields adv_instance_cnt hci_dev 0 55228 NULL
+iwl_read_prph_fndecl_55229_fields iwl_read_prph fndecl 0 55229 NULL
+btrfs_prealloc_file_range_trans_fndecl_55231_fields btrfs_prealloc_file_range_trans fndecl 4-5 55231 NULL
+sb_logsunit_xfs_sb_55236_fields sb_logsunit xfs_sb 0 55236 NULL
+ibnl_put_attr_fndecl_55238_fields ibnl_put_attr fndecl 3 55238 NULL
+nvme_rdma_init_queue_fndecl_55245_fields nvme_rdma_init_queue fndecl 3 55245 NULL
+mwifiex_set_encode_fndecl_55247_fields mwifiex_set_encode fndecl 4 55247 NULL
+d_reclen_venus_dirent_55253_fields d_reclen venus_dirent 0 55253 NULL
+__filemap_fdatawrite_range_fndecl_55259_fields __filemap_fdatawrite_range fndecl 0-2-3 55259 NULL
+mbox_count_blogic_adapter_55274_fields mbox_count blogic_adapter 0 55274 NULL
+bSubframeSize_uac_format_type_i_discrete_descriptor_55277_fields bSubframeSize uac_format_type_i_discrete_descriptor 0 55277 NULL nohasharray
+sgoffset_cxgbi_task_data_55277_fields sgoffset cxgbi_task_data 0 55277 &bSubframeSize_uac_format_type_i_discrete_descriptor_55277_fields
+apic_phys_vardecl_apic_c_55279_fields apic_phys vardecl_apic.c 0 55279 NULL nohasharray
+ext2_acl_from_disk_fndecl_55279_fields ext2_acl_from_disk fndecl 2 55279 &apic_phys_vardecl_apic_c_55279_fields
+ld_default_stripe_count_lov_desc_55281_fields ld_default_stripe_count lov_desc 0 55281 NULL
+copy_to_urb_fndecl_55284_fields copy_to_urb fndecl 5-4 55284 NULL
+hdrlen_ipv6_rt_hdr_55289_fields hdrlen ipv6_rt_hdr 0 55289 NULL
+c_can_read_msg_object_fndecl_55291_fields c_can_read_msg_object fndecl 3 55291 NULL
+regmap_irq_chip_get_base_fndecl_55298_fields regmap_irq_chip_get_base fndecl 0 55298 NULL
+upd_bytes_ubi_volume_55301_fields upd_bytes ubi_volume 0 55301 NULL
+tgt_cnt_snic_report_tgts_cmpl_55306_fields tgt_cnt snic_report_tgts_cmpl 0 55306 NULL
+mxl111sf_stream_config_bulk_fndecl_55308_fields mxl111sf_stream_config_bulk fndecl 2 55308 NULL
+xfs_dialloc_fndecl_55309_fields xfs_dialloc fndecl 2 55309 NULL
+xfs_log_mount_fndecl_55312_fields xfs_log_mount fndecl 3-4 55312 NULL
+bm_page_io_async_fndecl_55313_fields bm_page_io_async fndecl 2 55313 NULL nohasharray
+dataflash_read_fndecl_55313_fields dataflash_read fndecl 3 55313 &bm_page_io_async_fndecl_55313_fields
+mon_buff_area_shrink_fndecl_55317_fields mon_buff_area_shrink fndecl 2 55317 NULL
+pcibios_iov_resource_alignment_fndecl_55327_fields pcibios_iov_resource_alignment fndecl 0 55327 NULL
+p_size_dh_55335_fields p_size dh 0 55335 NULL
+alc_alloc_spec_fndecl_55356_fields alc_alloc_spec fndecl 2 55356 NULL
+btrfs_csum_one_bio_fndecl_55370_fields btrfs_csum_one_bio fndecl 0 55370 NULL
+cdc_mbim_process_dgram_fndecl_55371_fields cdc_mbim_process_dgram fndecl 4-3 55371 NULL nohasharray
+sctp_addto_param_fndecl_55371_fields sctp_addto_param fndecl 2 55371 &cdc_mbim_process_dgram_fndecl_55371_fields
+DataLength_smb2_write_rsp_55389_fields DataLength smb2_write_rsp 0 55389 NULL
+st_sensors_spi_read_multiple_byte_fndecl_55393_fields st_sensors_spi_read_multiple_byte fndecl 4 55393 NULL
+dxfer_len_skd_sg_io_55394_fields dxfer_len skd_sg_io 0 55394 NULL
+index_capsule_info_55396_fields index capsule_info 0 55396 NULL
+nprim_symtab_55398_fields nprim symtab 0 55398 NULL
+skb_to_sgvec_fndecl_55400_fields skb_to_sgvec fndecl 0-4-3 55400 NULL
+data_len_nf_conntrack_helper_55405_fields data_len nf_conntrack_helper 0 55405 NULL
+first_sd_index_i40iw_hmc_info_55411_fields first_sd_index i40iw_hmc_info 0 55411 NULL
+sd_cnt_i40iw_hmc_sd_table_55416_fields sd_cnt i40iw_hmc_sd_table 0 55416 NULL
+min_param_range_55419_fields min param_range 0 55419 NULL
+start_iwl_prph_range_55420_fields start iwl_prph_range 0 55420 NULL
+memblock_trim_memory_fndecl_55423_fields memblock_trim_memory fndecl 1 55423 NULL
+snd_pcm_format_width_fndecl_55426_fields snd_pcm_format_width fndecl 0 55426 NULL
+hidp_set_raw_report_fndecl_55427_fields hidp_set_raw_report fndecl 4 55427 NULL
+irq_sfi_timer_table_entry_55432_fields irq sfi_timer_table_entry 0 55432 NULL
+rate_via_rate_lock_55434_fields rate via_rate_lock 0 55434 NULL
+rbd_osd_req_create_fndecl_55437_fields rbd_osd_req_create fndecl 3 55437 NULL
+wake_packet_length_iwl_wowlan_status_data_55438_fields wake_packet_length iwl_wowlan_status_data 0 55438 NULL
+nilfs_read_log_header_fndecl_55445_fields nilfs_read_log_header fndecl 2 55445 NULL nohasharray
+scan_read32_fndecl_55445_fields scan_read32 fndecl 0 55445 &nilfs_read_log_header_fndecl_55445_fields
+dma_length_scatterlist_55447_fields dma_length scatterlist 0 55447 NULL nohasharray
+klen_nft_set_55447_fields klen nft_set 0 55447 &dma_length_scatterlist_55447_fields
+set_sample_rate_fndecl_55451_fields set_sample_rate fndecl 2 55451 NULL
+acpi_register_gsi_fndecl_55453_fields acpi_register_gsi fndecl 0 55453 NULL
+n_tty_receive_buf_fndecl_55457_fields n_tty_receive_buf fndecl 4 55457 NULL
+bcma_bus_next_num_vardecl_main_c_55461_fields bcma_bus_next_num vardecl_main.c 0 55461 NULL
+rx_ring2_size_vmxnet3_adapter_55465_fields rx_ring2_size vmxnet3_adapter 0 55465 NULL
+macvtap_major_vardecl_macvtap_c_55469_fields macvtap_major vardecl_macvtap.c 0 55469 NULL
+xfs_bmapi_write_fndecl_55475_fields xfs_bmapi_write fndecl 3-4-0 55475 NULL
+ext4_da_write_begin_fndecl_55476_fields ext4_da_write_begin fndecl 4-3 55476 NULL
+vrefresh_drm_display_mode_55481_fields vrefresh drm_display_mode 0 55481 NULL nohasharray
+__send_command_fndecl_55481_fields __send_command fndecl 5-7 55481 &vrefresh_drm_display_mode_55481_fields
+orangefs_bufmap_copy_to_iovec_fndecl_55482_fields orangefs_bufmap_copy_to_iovec fndecl 3 55482 NULL
+ocfs2_read_dx_leaf_fndecl_55488_fields ocfs2_read_dx_leaf fndecl 2 55488 NULL nohasharray
+data_offset_rndis_data_hdr_55488_fields data_offset rndis_data_hdr 0 55488 &ocfs2_read_dx_leaf_fndecl_55488_fields
+nft_set_ext_add_length_fndecl_55489_fields nft_set_ext_add_length fndecl 3 55489 NULL
+rx_jumbo_thresh_bnx2_55494_fields rx_jumbo_thresh bnx2 0 55494 NULL nohasharray
+data_length_iscsi_data_count_55494_fields data_length iscsi_data_count 0 55494 &rx_jumbo_thresh_bnx2_55494_fields nohasharray
+r_offset_rds_page_remainder_55494_fields r_offset rds_page_remainder 0 55494 &data_length_iscsi_data_count_55494_fields
+iram_offset_sst_res_info_55518_fields iram_offset sst_res_info 0 55518 NULL
+root_dm_pool_metadata_55520_fields root dm_pool_metadata 0 55520 NULL
+reg_bits_regmap_config_55521_fields reg_bits regmap_config 0 55521 NULL
+__blkdev_issue_discard_fndecl_55526_fields __blkdev_issue_discard fndecl 0-3-2 55526 NULL nohasharray
+NumBlockTypes_cfi_intelext_regioninfo_55526_fields NumBlockTypes cfi_intelext_regioninfo 0 55526 &__blkdev_issue_discard_fndecl_55526_fields
+bofs_count_irlap_cb_55531_fields bofs_count irlap_cb 0 55531 NULL nohasharray
+iscsi_login_rx_data_fndecl_55531_fields iscsi_login_rx_data fndecl 3 55531 &bofs_count_irlap_cb_55531_fields
+blkdev_max_hw_sectors_vardecl_dev_c_55533_fields blkdev_max_hw_sectors vardecl_dev.c 0 55533 NULL
+irq_intel_lpss_platform_info_55538_fields irq intel_lpss_platform_info 0 55538 NULL
+crtcs_psb_ops_55540_fields crtcs psb_ops 0 55540 NULL
+rf_blkno_ocfs2_refcount_block_55545_fields rf_blkno ocfs2_refcount_block 0 55545 NULL
+tmp_afs_call_55554_fields tmp afs_call 0 55554 NULL
+usVSyncOffset__ATOM_DTD_FORMAT_55558_fields usVSyncOffset _ATOM_DTD_FORMAT 0 55558 NULL
+read_reg_fndecl_55560_fields read_reg fndecl 0 55560 NULL
+iv_len_ieee80211_key_conf_55561_fields iv_len ieee80211_key_conf 0 55561 NULL
+io_tlb_overflow_vardecl_swiotlb_c_55570_fields io_tlb_overflow vardecl_swiotlb.c 0 55570 NULL
+if_sdio_read_rx_len_fndecl_55579_fields if_sdio_read_rx_len fndecl 0 55579 NULL
+index_vardecl_pcsp_c_55582_fields index vardecl_pcsp.c 0 55582 NULL
+coh_page_bufsize_cl_object_header_55585_fields coh_page_bufsize cl_object_header 0 55585 NULL
+rcvtid_size_ctxt_eager_bufs_55589_fields rcvtid_size ctxt_eager_bufs 0 55589 NULL
+split_by_ceph_inode_frag_55595_fields split_by ceph_inode_frag 0 55595 NULL
+ext4_punch_hole_fndecl_55604_fields ext4_punch_hole fndecl 2-3 55604 NULL
+overlay_out_top_vivid_dev_55610_fields overlay_out_top vivid_dev 0 55610 NULL
+udplite_manip_pkt_fndecl_55611_fields udplite_manip_pkt fndecl 4 55611 NULL
+length_ipw_rx_frame_55612_fields length ipw_rx_frame 0 55612 NULL
+alg_trunc_len_xfrm_algo_auth_55613_fields alg_trunc_len xfrm_algo_auth 0 55613 NULL
+initial_width_vmw_private_55615_fields initial_width vmw_private 0 55615 NULL
+vmci_transport_dgram_dequeue_fndecl_55628_fields vmci_transport_dgram_dequeue fndecl 3 55628 NULL
+bin_string_fndecl_55631_fields bin_string fndecl 5-3 55631 NULL
+max_pkt_size_cx231xx_isoc_ctl_55637_fields max_pkt_size cx231xx_isoc_ctl 0 55637 NULL
+extra_tx_headroom_ieee80211_hw_55638_fields extra_tx_headroom ieee80211_hw 0 55638 NULL
+mr_umem_get_fndecl_55642_fields mr_umem_get fndecl 2-3 55642 NULL
+rcvidx_isar_hw_55643_fields rcvidx isar_hw 0 55643 NULL nohasharray
+__blockdev_direct_IO_fndecl_55643_fields __blockdev_direct_IO fndecl 0 55643 &rcvidx_isar_hw_55643_fields
+sr_read_sector_fndecl_55647_fields sr_read_sector fndecl 3 55647 NULL
+start_sector_mspro_sys_info_55650_fields start_sector mspro_sys_info 0 55650 NULL
+raid10_copies_raid_set_55657_fields raid10_copies raid_set 0 55657 NULL
+max_len_ovs_action_trunc_55658_fields max_len ovs_action_trunc 0 55658 NULL
+ath6kl_sdio_io_fndecl_55662_fields ath6kl_sdio_io fndecl 5 55662 NULL
+pagl_rightrec_xfs_perag_55670_fields pagl_rightrec xfs_perag 0 55670 NULL
+smsc47m1_handle_resources_fndecl_55676_fields smsc47m1_handle_resources fndecl 1 55676 NULL
+al_stripes_drbd_md_55679_fields al_stripes drbd_md 0 55679 NULL
+omfs_iget_fndecl_55693_fields omfs_iget fndecl 2 55693 NULL nohasharray
+cp2112_i2c_write_read_req_fndecl_55693_fields cp2112_i2c_write_read_req fndecl 0-4 55693 &omfs_iget_fndecl_55693_fields
+st_nci_hci_dm_update_aid_fndecl_55699_fields st_nci_hci_dm_update_aid fndecl 3 55699 NULL
+unique_pos_vardecl_jfs_dtree_c_55709_fields unique_pos vardecl_jfs_dtree.c 0 55709 NULL
+inline_wsize_rpcrdma_create_data_internal_55719_fields inline_wsize rpcrdma_create_data_internal 0 55719 NULL
+fbcon_resize_fndecl_55724_fields fbcon_resize fndecl 2-3 55724 NULL
+dst_command_fndecl_55728_fields dst_command fndecl 3 55728 NULL
+vsi_iext_vxfs_sb_info_55734_fields vsi_iext vxfs_sb_info 0 55734 NULL
+btrfs_delalloc_reserve_metadata_fndecl_55736_fields btrfs_delalloc_reserve_metadata fndecl 0 55736 NULL
+max_eq_mlx4_func_55747_fields max_eq mlx4_func 0 55747 NULL
+nilfs_mdt_set_entry_size_fndecl_55751_fields nilfs_mdt_set_entry_size fndecl 2-3 55751 NULL nohasharray
+pad_len_ubifs_pad_node_55751_fields pad_len ubifs_pad_node 0 55751 &nilfs_mdt_set_entry_size_fndecl_55751_fields
+idma64_active_desc_size_fndecl_55752_fields idma64_active_desc_size fndecl 0 55752 NULL
+nilfs_cpfile_read_fndecl_55758_fields nilfs_cpfile_read fndecl 2 55758 NULL nohasharray
+cap_nvme_rdma_ctrl_55758_fields cap nvme_rdma_ctrl 0 55758 &nilfs_cpfile_read_fndecl_55758_fields
+lane_cnt_mipi_config_55759_fields lane_cnt mipi_config 0 55759 NULL
+offset_xfs_bmalloca_55767_fields offset xfs_bmalloca 0 55767 NULL
+get_current_sit_page_fndecl_55771_fields get_current_sit_page fndecl 2 55771 NULL nohasharray
+flag_lpfc_dmabufext_55771_fields flag lpfc_dmabufext 0 55771 &get_current_sit_page_fndecl_55771_fields
+dump_emit_fndecl_55772_fields dump_emit fndecl 3 55772 NULL
+width_cx25821_channel_55782_fields width cx25821_channel 0 55782 NULL
+MaxLiteCmds_vardecl_ips_c_55793_fields MaxLiteCmds vardecl_ips.c 0 55793 NULL
+lbs_lowrssi_write_fndecl_55802_fields lbs_lowrssi_write fndecl 3 55802 NULL
+media_dev_t_vardecl_media_devnode_c_55805_fields media_dev_t vardecl_media-devnode.c 0 55805 NULL
+xennet_tx_setup_grant_fndecl_55807_fields xennet_tx_setup_grant fndecl 3-2 55807 NULL
+velocity_rx_copy_fndecl_55812_fields velocity_rx_copy fndecl 2 55812 NULL
+encx24j600_raw_read_fndecl_55819_fields encx24j600_raw_read fndecl 4 55819 NULL
+result_status_yellowfin_desc_55822_fields result_status yellowfin_desc 0 55822 NULL
+sd_blksz_fw_dl_btmrvl_sdio_card_55832_fields sd_blksz_fw_dl btmrvl_sdio_card 0 55832 NULL
+dvb_ringbuffer_init_fndecl_55834_fields dvb_ringbuffer_init fndecl 3 55834 NULL
+or51132_readbuf_fndecl_55836_fields or51132_readbuf fndecl 3 55836 NULL
+max_cnt_i40iw_hmc_obj_info_55847_fields max_cnt i40iw_hmc_obj_info 0 55847 NULL
+dr_free_blk_ocfs2_dx_root_block_55848_fields dr_free_blk ocfs2_dx_root_block 0 55848 NULL
+s_segment_usage_size_nilfs_super_block_55851_fields s_segment_usage_size nilfs_super_block 0 55851 NULL
+__cfg80211_disconnected_fndecl_55853_fields __cfg80211_disconnected fndecl 3 55853 NULL
+rdma_rw_init_map_wrs_fndecl_55859_fields rdma_rw_init_map_wrs fndecl 5-6 55859 NULL
+ceph_msgpool_init_fndecl_55860_fields ceph_msgpool_init fndecl 3-4 55860 NULL
+snd_cwnd_tcp_sock_55861_fields snd_cwnd tcp_sock 0 55861 NULL
+__find_pending_exception_fndecl_55867_fields __find_pending_exception fndecl 3 55867 NULL
+__nonstatic_find_io_region_fndecl_55871_fields __nonstatic_find_io_region fndecl 2-3 55871 NULL
+usVSyncWidth__ATOM_DTD_FORMAT_55875_fields usVSyncWidth _ATOM_DTD_FORMAT 0 55875 NULL
+frame_size_usb_stream_config_55876_fields frame_size usb_stream_config 0 55876 NULL
+gtt_phys_start_psb_gtt_55877_fields gtt_phys_start psb_gtt 0 55877 NULL
+cp_table_size_amdgpu_rlc_55879_fields cp_table_size amdgpu_rlc 0 55879 NULL
+tomoyo_dump_page_fndecl_55882_fields tomoyo_dump_page fndecl 2 55882 NULL
+mb_cache_entry_create_fndecl_55893_fields mb_cache_entry_create fndecl 4 55893 NULL
+tlclk_major_vardecl_tlclk_c_55901_fields tlclk_major vardecl_tlclk.c 0 55901 NULL
+fragment_size_snd_compressed_buffer_55903_fields fragment_size snd_compressed_buffer 0 55903 NULL
+major_char_device_struct_55907_fields major char_device_struct 0 55907 NULL
+mrf24j40_long_regmap_read_fndecl_55922_fields mrf24j40_long_regmap_read fndecl 3-5 55922 NULL
+nf_nat_mangle_udp_packet_fndecl_55926_fields nf_nat_mangle_udp_packet fndecl 6-8 55926 NULL
+do_readv_writev_fndecl_55934_fields do_readv_writev fndecl 4 55934 NULL
+change_prot_numa_fndecl_55935_fields change_prot_numa fndecl 3-2 55935 NULL
+autofs4_write_fndecl_55944_fields autofs4_write fndecl 4 55944 NULL
+image_size_nvbios_pcirT_55946_fields image_size nvbios_pcirT 0 55946 NULL
+rate_snd_oxfw_stream_formation_55949_fields rate snd_oxfw_stream_formation 0 55949 NULL
+osst_seek_logical_blk_fndecl_55950_fields osst_seek_logical_blk fndecl 3 55950 NULL
+__generic_file_write_iter_fndecl_55960_fields __generic_file_write_iter fndecl 0 55960 NULL
+pkey_table_len_mthca_limits_55962_fields pkey_table_len mthca_limits 0 55962 NULL
+transfer_buffer_length_urb_55970_fields transfer_buffer_length urb 0 55970 NULL nohasharray
+data2_sisusb_command_55970_fields data2 sisusb_command 0 55970 &transfer_buffer_length_urb_55970_fields
+num_channels_max1027_chip_info_55971_fields num_channels max1027_chip_info 0 55971 NULL
+subbuf_size_rchan_55979_fields subbuf_size rchan 0 55979 NULL nohasharray
+scsi_sense_length_se_cmd_55979_fields scsi_sense_length se_cmd 0 55979 &subbuf_size_rchan_55979_fields
+mon_bin_get_data_fndecl_55998_fields mon_bin_get_data fndecl 0-4 55998 NULL
+max_degraded_r5conf_56004_fields max_degraded r5conf 0 56004 NULL
+len_pipe_buffer_56007_fields len pipe_buffer 0 56007 NULL
+qib_cdev_init_fndecl_56009_fields qib_cdev_init fndecl 1 56009 NULL
+midi_snd_bebob_stream_formation_56012_fields midi snd_bebob_stream_formation 0 56012 NULL
+usbtest_alloc_urb_fndecl_56013_fields usbtest_alloc_urb fndecl 2 56013 NULL
+i2400m_change_mtu_fndecl_56021_fields i2400m_change_mtu fndecl 2 56021 NULL
+num_pins_lola_pin_array_56022_fields num_pins lola_pin_array 0 56022 NULL
+__ocfs2_change_file_space_fndecl_56023_fields __ocfs2_change_file_space fndecl 3 56023 NULL
+vlan_id_ib_mac_iocb_rsp_56025_fields vlan_id ib_mac_iocb_rsp 0 56025 NULL
+ov519_pkt_scan_fndecl_56026_fields ov519_pkt_scan fndecl 3 56026 NULL
+vbi_pixel_to_capture_vardecl_saa7146_vbi_c_56037_fields vbi_pixel_to_capture vardecl_saa7146_vbi.c 0 56037 NULL nohasharray
+sg_update_list_fndecl_56037_fields sg_update_list fndecl 2 56037 &vbi_pixel_to_capture_vardecl_saa7146_vbi_c_56037_fields nohasharray
+temp_num_nct6683_data_56037_fields temp_num nct6683_data 0 56037 &sg_update_list_fndecl_56037_fields
+wr_len_i40iw_sq_uk_wr_trk_info_56039_fields wr_len i40iw_sq_uk_wr_trk_info 0 56039 NULL
+totalram_pages_vardecl_56043_fields totalram_pages vardecl 0 56043 NULL
+hpi_instream_read_buf_fndecl_56045_fields hpi_instream_read_buf fndecl 3 56045 NULL
+status_whc_qtd_56049_fields status whc_qtd 0 56049 NULL
+usb_wwan_setup_urb_fndecl_56054_fields usb_wwan_setup_urb fndecl 6-3-2 56054 NULL
+mod_xfs_alloc_arg_56058_fields mod xfs_alloc_arg 0 56058 NULL
+drm_mm_insert_helper_range_fndecl_56060_fields drm_mm_insert_helper_range fndecl 3 56060 NULL
+xfs_trans_free_extent_fndecl_56063_fields xfs_trans_free_extent fndecl 3-4 56063 NULL
+frag_ceph_mds_reply_dirfrag_56070_fields frag ceph_mds_reply_dirfrag 0 56070 NULL
+full_page_bnx2x_agg_info_56071_fields full_page bnx2x_agg_info 0 56071 NULL
+pkcs1pad_sg_set_buf_fndecl_56076_fields pkcs1pad_sg_set_buf fndecl 3 56076 NULL
+tx_fifo_num_vardecl_s2io_c_56077_fields tx_fifo_num vardecl_s2io.c 0 56077 NULL
+num_chunks_drm_amdgpu_cs_in_56088_fields num_chunks drm_amdgpu_cs_in 0 56088 NULL
+size_perf_event_header_56096_fields size perf_event_header 0 56096 NULL
+datalength_fwheader_56097_fields datalength fwheader 0 56097 NULL
+l_sectBBsize_xlog_56103_fields l_sectBBsize xlog 0 56103 NULL
+max_frame_size__synclinkmp_info_56104_fields max_frame_size _synclinkmp_info 0 56104 NULL
+max_request_packet_size_ec_response_get_protocol_info_56107_fields max_request_packet_size ec_response_get_protocol_info 0 56107 NULL
+p54_alloc_skb_fndecl_56109_fields p54_alloc_skb fndecl 3 56109 NULL
+hw_context_send_context_56118_fields hw_context send_context 0 56118 NULL
+q0_depth_bna_rx_config_56122_fields q0_depth bna_rx_config 0 56122 NULL
+ath5k_setup_channels_fndecl_56123_fields ath5k_setup_channels fndecl 0 56123 NULL nohasharray
+max_queue_depth_vardecl_mpt3sas_base_c_56123_fields max_queue_depth vardecl_mpt3sas_base.c 0 56123 &ath5k_setup_channels_fndecl_56123_fields
+size_direct_56131_fields size direct 0 56131 NULL
+sl_max_ip_sf_socklist_56140_fields sl_max ip_sf_socklist 0 56140 NULL
+prepare_add_efi_setup_data_fndecl_56147_fields prepare_add_efi_setup_data fndecl 3-2 56147 NULL
+reiserfs_resize_fndecl_56154_fields reiserfs_resize fndecl 2 56154 NULL
+i2c_hid_get_raw_report_fndecl_56155_fields i2c_hid_get_raw_report fndecl 4 56155 NULL
+nd_num_o2nm_node_56160_fields nd_num o2nm_node 0 56160 NULL
+block_len_extent_map_56171_fields block_len extent_map 0 56171 NULL
+csum_offset_virtio_net_hdr_56180_fields csum_offset virtio_net_hdr 0 56180 NULL
+ivsize_vardecl_encrypted_c_56181_fields ivsize vardecl_encrypted.c 0 56181 NULL nohasharray
+sccb_reg_read_fndecl_56181_fields sccb_reg_read fndecl 0 56181 &ivsize_vardecl_encrypted_c_56181_fields
+xlog_rseek_logrec_hdr_fndecl_56182_fields xlog_rseek_logrec_hdr fndecl 2 56182 NULL
+sctp_make_heartbeat_ack_fndecl_56184_fields sctp_make_heartbeat_ack fndecl 4 56184 NULL
+rx_ring_size_bnx2_56185_fields rx_ring_size bnx2 0 56185 NULL
+geneve_build_skb_fndecl_56186_fields geneve_build_skb fndecl 5 56186 NULL
+wl1271_tx_fill_hdr_fndecl_56191_fields wl1271_tx_fill_hdr fndecl 4 56191 NULL
+kmemleak_free_part_fndecl_56193_fields kmemleak_free_part fndecl 2 56193 NULL
+rx_data_fndecl_56202_fields rx_data fndecl 4-3 56202 NULL nohasharray
+qgroupid_btrfs_qgroup_56202_fields qgroupid btrfs_qgroup 0 56202 &rx_data_fndecl_56202_fields
+dlen_pg_56210_fields dlen pg 0 56210 NULL
+jffs2_fill_wbuf_fndecl_56212_fields jffs2_fill_wbuf fndecl 3 56212 NULL
+width_v4l2_mbus_framefmt_56214_fields width v4l2_mbus_framefmt 0 56214 NULL
+ath10k_htt_tx_fetch_resp_fndecl_56215_fields ath10k_htt_tx_fetch_resp fndecl 5 56215 NULL
+sample_stack_user_perf_event_attr_56220_fields sample_stack_user perf_event_attr 0 56220 NULL
+reg_cache_size_snd_soc_codec_driver_56222_fields reg_cache_size snd_soc_codec_driver 0 56222 NULL nohasharray
+offset_cifs_writedata_56222_fields offset cifs_writedata 0 56222 &reg_cache_size_snd_soc_codec_driver_56222_fields
+reg_cache_size_omap_mcbsp_56223_fields reg_cache_size omap_mcbsp 0 56223 NULL
+depth_s2255_fmt_56229_fields depth s2255_fmt 0 56229 NULL
+psn_mask_rvt_driver_params_56230_fields psn_mask rvt_driver_params 0 56230 NULL
+ocfs2_mv_xattr_buckets_fndecl_56231_fields ocfs2_mv_xattr_buckets fndecl 6-3-5-4 56231 NULL
+security_inode_permission_fndecl_56235_fields security_inode_permission fndecl 0 56235 NULL
+wm8350_register_led_fndecl_56237_fields wm8350_register_led fndecl 2-4-3 56237 NULL
+max_recv_dlength_iscsi_bus_flash_conn_56238_fields max_recv_dlength iscsi_bus_flash_conn 0 56238 NULL
+af9013_wr_regs_fndecl_56239_fields af9013_wr_regs fndecl 4 56239 NULL
+wBlockNumber_ms_bootblock_sysinf_56240_fields wBlockNumber ms_bootblock_sysinf 0 56240 NULL
+cfpkt_peek_head_fndecl_56245_fields cfpkt_peek_head fndecl 3 56245 NULL
+qtd_fill_fndecl_56249_fields qtd_fill fndecl 5-6-3-4 56249 NULL nohasharray
+ima_calc_buffer_hash_fndecl_56249_fields ima_calc_buffer_hash fndecl 2 56249 &qtd_fill_fndecl_56249_fields
+dmreq_start_crypt_config_56268_fields dmreq_start crypt_config 0 56268 NULL
+flows_cnt_fq_56276_fields flows_cnt fq 0 56276 NULL nohasharray
+vyres_crtc_56276_fields vyres crtc 0 56276 &flows_cnt_fq_56276_fields
+s_raid_stride_ext4_super_block_56277_fields s_raid_stride ext4_super_block 0 56277 NULL
+pci_mmconfig_add_fndecl_56279_fields pci_mmconfig_add fndecl 2-3-4 56279 NULL
+dram_base_intel_sst_drv_56282_fields dram_base intel_sst_drv 0 56282 NULL
+header_length_txentry_desc_56288_fields header_length txentry_desc 0 56288 NULL
+nr_rates_audioformat_56293_fields nr_rates audioformat 0 56293 NULL
+intel_rotation_info_size_fndecl_56294_fields intel_rotation_info_size fndecl 0 56294 NULL
+ttymajor_vardecl_synclink_gt_c_56300_fields ttymajor vardecl_synclink_gt.c 0 56300 NULL
+ext4_fallocate_fndecl_56314_fields ext4_fallocate fndecl 3-4 56314 NULL
+essid_len_ipw_priv_56318_fields essid_len ipw_priv 0 56318 NULL
+ebt_compat_match_offset_fndecl_56334_fields ebt_compat_match_offset fndecl 0 56334 NULL
+ath6kl_wmi_ap_set_apsd_fndecl_56339_fields ath6kl_wmi_ap_set_apsd fndecl 2 56339 NULL
+drm_atomic_helper_plane_set_property_fndecl_56340_fields drm_atomic_helper_plane_set_property fndecl 3 56340 NULL
+tx_ring_size_bnx2_56345_fields tx_ring_size bnx2 0 56345 NULL
+blksize_vardecl_encrypted_c_56348_fields blksize vardecl_encrypted.c 0 56348 NULL
+macsec_add_dev_fndecl_56352_fields macsec_add_dev fndecl 3 56352 NULL
+gfs2_write_end_fndecl_56354_fields gfs2_write_end fndecl 5 56354 NULL
+dccp_ackvec_add_new_fndecl_56359_fields dccp_ackvec_add_new fndecl 2-3 56359 NULL
+acl_permission_check_fndecl_56360_fields acl_permission_check fndecl 0 56360 NULL
+interrupt_out_endpointAddress_usb_serial_port_56364_fields interrupt_out_endpointAddress usb_serial_port 0 56364 NULL
+ide_set_pio_mode_fndecl_56371_fields ide_set_pio_mode fndecl 2 56371 NULL
+xfs_alloc_ag_max_usable_fndecl_56380_fields xfs_alloc_ag_max_usable fndecl 0 56380 NULL
+len_asd_ha_addrspace_56381_fields len asd_ha_addrspace 0 56381 NULL
+stride_geom_56394_fields stride geom 0 56394 NULL
+ieee80211_fragment_fndecl_56395_fields ieee80211_fragment fndecl 4-3 56395 NULL
+lost_out_tcp_sock_56397_fields lost_out tcp_sock 0 56397 NULL
+buf_count_drm_device_dma_56399_fields buf_count drm_device_dma 0 56399 NULL
+ccw_clear_fndecl_56408_fields ccw_clear fndecl 3-5-6-4 56408 NULL
+f2fs_llseek_fndecl_56409_fields f2fs_llseek fndecl 2 56409 NULL
+ieee80211_auth_challenge_fndecl_56418_fields ieee80211_auth_challenge fndecl 3 56418 NULL
+notify_change_fndecl_56420_fields notify_change fndecl 0 56420 NULL
+max_recv_wr_ib_qp_cap_56426_fields max_recv_wr ib_qp_cap 0 56426 NULL
+llc_ui_sendmsg_fndecl_56432_fields llc_ui_sendmsg fndecl 3 56432 NULL
+ath6kl_wmi_cancel_remain_on_chnl_cmd_fndecl_56434_fields ath6kl_wmi_cancel_remain_on_chnl_cmd fndecl 2 56434 NULL nohasharray
+write_node_fndecl_56434_fields write_node fndecl 4 56434 &ath6kl_wmi_cancel_remain_on_chnl_cmd_fndecl_56434_fields
+idx_lebs_ubifs_lp_stats_56439_fields idx_lebs ubifs_lp_stats 0 56439 NULL nohasharray
+hsync_end_drm_display_mode_56439_fields hsync_end drm_display_mode 0 56439 &idx_lebs_ubifs_lp_stats_56439_fields nohasharray
+bdbars_count_intel8x0_56439_fields bdbars_count intel8x0 0 56439 &hsync_end_drm_display_mode_56439_fields
+vlan_tag_lro_56441_fields vlan_tag lro 0 56441 NULL nohasharray
+fb_sys_write_fndecl_56441_fields fb_sys_write fndecl 0 56441 &vlan_tag_lro_56441_fields
+gtk_ivlen_iwl_mvm_56442_fields gtk_ivlen iwl_mvm 0 56442 NULL nohasharray
+num_rx_queues_igb_adapter_56442_fields num_rx_queues igb_adapter 0 56442 &gtk_ivlen_iwl_mvm_56442_fields
+DataTransferLength_bulk_cb_wrap_56447_fields DataTransferLength bulk_cb_wrap 0 56447 NULL
+raw_send_hdrinc_fndecl_56449_fields raw_send_hdrinc fndecl 4 56449 NULL
+__ocfs2_increase_refcount_fndecl_56450_fields __ocfs2_increase_refcount fndecl 5-4 56450 NULL
+size_tcp_fastopen_request_56457_fields size tcp_fastopen_request 0 56457 NULL nohasharray
+block_dm_thin_lookup_result_56457_fields block dm_thin_lookup_result 0 56457 &size_tcp_fastopen_request_56457_fields
+winfo_size_data_queue_56462_fields winfo_size data_queue 0 56462 NULL nohasharray
+scnt_aoe_cfghdr_56462_fields scnt aoe_cfghdr 0 56462 &winfo_size_data_queue_56462_fields
+tpg_init_fndecl_56464_fields tpg_init fndecl 3-2 56464 NULL
+ia_size_iattr_56465_fields ia_size iattr 0 56465 NULL nohasharray
+packet_sendmsg_fndecl_56465_fields packet_sendmsg fndecl 3 56465 &ia_size_iattr_56465_fields
+banks_mca_config_56472_fields banks mca_config 0 56472 NULL
+__erst_clear_from_storage_fndecl_56476_fields __erst_clear_from_storage fndecl 1 56476 NULL
+sb_cnt_qed_sb_cnt_info_56477_fields sb_cnt qed_sb_cnt_info 0 56477 NULL
+func_suspend_usb_function_56478_fields func_suspend usb_function 0 56478 NULL
+ext4_split_convert_extents_fndecl_56493_fields ext4_split_convert_extents fndecl 0 56493 NULL
+nci_hci_send_cmd_fndecl_56495_fields nci_hci_send_cmd fndecl 5 56495 NULL
+free_bit_ocfs2_cached_block_free_56500_fields free_bit ocfs2_cached_block_free 0 56500 NULL
+choose_mtu_fndecl_56503_fields choose_mtu fndecl 0 56503 NULL nohasharray
+len_audit_proctitle_56503_fields len audit_proctitle 0 56503 &choose_mtu_fndecl_56503_fields
+process_ptload_program_headers_elf64_fndecl_56505_fields process_ptload_program_headers_elf64 fndecl 3-2 56505 NULL
+stream_size_yuv_playback_info_56511_fields stream_size yuv_playback_info 0 56511 NULL
+error_retry_list_with_code_fndecl_56518_fields error_retry_list_with_code fndecl 2 56518 NULL nohasharray
+ntb_netdev_rx_handler_fndecl_56518_fields ntb_netdev_rx_handler fndecl 4 56518 &error_retry_list_with_code_fndecl_56518_fields
+num_ids_amdgpu_vm_manager_56520_fields num_ids amdgpu_vm_manager 0 56520 NULL
+vp_modern_find_vqs_fndecl_56530_fields vp_modern_find_vqs fndecl 2 56530 NULL
+npins_byt_pinctrl_soc_data_56540_fields npins byt_pinctrl_soc_data 0 56540 NULL nohasharray
+sq_overhead_fndecl_56540_fields sq_overhead fndecl 0 56540 &npins_byt_pinctrl_soc_data_56540_fields
+priv_size_rocker_world_ops_56542_fields priv_size rocker_world_ops 0 56542 NULL
+snd_pcm_plug_client_size_fndecl_56544_fields snd_pcm_plug_client_size fndecl 0-2 56544 NULL
+max_ethqsets_sge_56552_fields max_ethqsets sge 0 56552 NULL
+sf_size_adapter_params_56574_fields sf_size adapter_params 0 56574 NULL
+sctp_tsnmap_grow_fndecl_56579_fields sctp_tsnmap_grow fndecl 2 56579 NULL
+buf_bytes_mmc_blk_ioc_data_56589_fields buf_bytes mmc_blk_ioc_data 0 56589 NULL
+qt2_write_fndecl_56603_fields qt2_write fndecl 4 56603 NULL
+cb_irq_yenta_socket_56604_fields cb_irq yenta_socket 0 56604 NULL
+q_num_hnae_handle_56609_fields q_num hnae_handle 0 56609 NULL
+security_size_rxrpc_connection_56613_fields security_size rxrpc_connection 0 56613 NULL
+pci_map_size_iadev_priv_56617_fields pci_map_size iadev_priv 0 56617 NULL
+ieee80211_tdls_mgmt_fndecl_56618_fields ieee80211_tdls_mgmt fndecl 10 56618 NULL
+memremap_fndecl_56619_fields memremap fndecl 2-1 56619 NULL nohasharray
+ext4_get_block_unwritten_fndecl_56619_fields ext4_get_block_unwritten fndecl 2 56619 &memremap_fndecl_56619_fields
+afs_dir_iterate_block_fndecl_56630_fields afs_dir_iterate_block fndecl 3 56630 NULL
+x509_note_issuer_fndecl_56631_fields x509_note_issuer fndecl 5 56631 NULL
+max_blk_count_mmc_host_56634_fields max_blk_count mmc_host 0 56634 NULL nohasharray
+get_register_page_interruptible_fndecl_56634_fields get_register_page_interruptible fndecl 5 56634 &max_blk_count_mmc_host_56634_fields nohasharray
+num_disc_configs_nci_rf_disc_cmd_56634_fields num_disc_configs nci_rf_disc_cmd 0 56634 &get_register_page_interruptible_fndecl_56634_fields
+arena_write_bytes_fndecl_56636_fields arena_write_bytes fndecl 0 56636 NULL
+devt_device_56638_fields devt device 0 56638 NULL
+last_sect_blkif_request_segment_56644_fields last_sect blkif_request_segment 0 56644 NULL
+bytenr_btrfs_root_item_56657_fields bytenr btrfs_root_item 0 56657 NULL
+__ksize_fndecl_56662_fields __ksize fndecl 0 56662 NULL
+xlog_set_state_fndecl_56663_fields xlog_set_state fndecl 2 56663 NULL
+__memblock_find_range_top_down_fndecl_56669_fields __memblock_find_range_top_down fndecl 0-4-3-1-2 56669 NULL nohasharray
+csio_scsi_iqlen_vardecl_56669_fields csio_scsi_iqlen vardecl 0 56669 &__memblock_find_range_top_down_fndecl_56669_fields
+len_fw_desc_56676_fields len fw_desc 0 56676 NULL
+pbl_top_rdma_info_56683_fields pbl_top rdma_info 0 56683 NULL
+max_channels_hda_multi_out_56686_fields max_channels hda_multi_out 0 56686 NULL
+ath6kl_usb_post_recv_transfers_fndecl_56687_fields ath6kl_usb_post_recv_transfers fndecl 2 56687 NULL nohasharray
+npages_in_use_dma_pool_56687_fields npages_in_use dma_pool 0 56687 &ath6kl_usb_post_recv_transfers_fndecl_56687_fields
+modulus_size_dw_guc_css_header_56691_fields modulus_size_dw guc_css_header 0 56691 NULL
+ks8851_rdreg_fndecl_56695_fields ks8851_rdreg fndecl 4 56695 NULL
+cfg_len_goodix_ts_data_56699_fields cfg_len goodix_ts_data 0 56699 NULL
+remove_migration_pte_fndecl_56701_fields remove_migration_pte fndecl 3 56701 NULL nohasharray
+ath6kl_wmi_set_rssi_filter_cmd_fndecl_56701_fields ath6kl_wmi_set_rssi_filter_cmd fndecl 2 56701 &remove_migration_pte_fndecl_56701_fields
+orangefs_file_llseek_fndecl_56704_fields orangefs_file_llseek fndecl 2 56704 NULL
+qgroupid_btrfs_ioctl_qgroup_create_args_56717_fields qgroupid btrfs_ioctl_qgroup_create_args 0 56717 NULL
+munlock_vma_pages_range_fndecl_56718_fields munlock_vma_pages_range fndecl 2 56718 NULL
+ext4_get_group_number_fndecl_56720_fields ext4_get_group_number fndecl 0 56720 NULL nohasharray
+rcvegrbuf_size_qib_ctxtdata_56720_fields rcvegrbuf_size qib_ctxtdata 0 56720 &ext4_get_group_number_fndecl_56720_fields
+opcnt_nfsd4_compoundargs_56722_fields opcnt nfsd4_compoundargs 0 56722 NULL
+offset_cw1200_txpriv_56729_fields offset cw1200_txpriv 0 56729 NULL
+tx_ring_size_mvpp2_port_56735_fields tx_ring_size mvpp2_port 0 56735 NULL
+search_empty_fndecl_56737_fields search_empty fndecl 2 56737 NULL
+drm_gem_cma_create_fndecl_56742_fields drm_gem_cma_create fndecl 2 56742 NULL nohasharray
+val_len_ceph_inode_xattr_56742_fields val_len ceph_inode_xattr 0 56742 &drm_gem_cma_create_fndecl_56742_fields
+sb_logsectlog_xfs_sb_56750_fields sb_logsectlog xfs_sb 0 56750 NULL
+page_offset_skb_frag_struct_56751_fields page_offset skb_frag_struct 0 56751 NULL
+read_pipe_ezusb_priv_56753_fields read_pipe ezusb_priv 0 56753 NULL nohasharray
+xprt_complete_bc_request_fndecl_56753_fields xprt_complete_bc_request fndecl 2 56753 &read_pipe_ezusb_priv_56753_fields
+length_scatterlist_56760_fields length scatterlist 0 56760 NULL
+npkt_cam_56768_fields npkt cam 0 56768 NULL
+arch_ptrace_fndecl_56774_fields arch_ptrace fndecl 3 56774 NULL
+max_rpi_lpfc_max_cfg_param_56782_fields max_rpi lpfc_max_cfg_param 0 56782 NULL
+vc_saved_y_vc_data_56792_fields vc_saved_y vc_data 0 56792 NULL nohasharray
+ext4_group_overhead_blocks_fndecl_56792_fields ext4_group_overhead_blocks fndecl 0 56792 &vc_saved_y_vc_data_56792_fields
+state_count_acpi_processor_performance_56807_fields state_count acpi_processor_performance 0 56807 NULL nohasharray
+context_id_bnx2fc_rport_56807_fields context_id bnx2fc_rport 0 56807 &state_count_acpi_processor_performance_56807_fields
+num_pages_vmci_queue_kern_if_56812_fields num_pages vmci_queue_kern_if 0 56812 NULL
+hugetlbfs_pagecache_page_fndecl_56822_fields hugetlbfs_pagecache_page fndecl 3 56822 NULL
+netdev_change_mtu_fndecl_56827_fields netdev_change_mtu fndecl 2 56827 NULL
+io_size_smi_info_56832_fields io_size smi_info 0 56832 NULL nohasharray
+acked_illinois_56832_fields acked illinois 0 56832 &io_size_smi_info_56832_fields
+truesize_sk_buff_56834_fields truesize sk_buff 0 56834 NULL
+tail_TxFifo_56844_fields tail TxFifo 0 56844 NULL
+unit_size_wlan_host_mem_req_56846_fields unit_size wlan_host_mem_req 0 56846 NULL
+transfer_one_spi_master_56858_fields transfer_one spi_master 0 56858 NULL
+max_cq_sz_mlx4_dev_cap_56868_fields max_cq_sz mlx4_dev_cap 0 56868 NULL
+status_pipe_uas_dev_info_56869_fields status_pipe uas_dev_info 0 56869 NULL
+combined_count_ethtool_channels_56871_fields combined_count ethtool_channels 0 56871 NULL
+freecom_writedata_fndecl_56872_fields freecom_writedata fndecl 4 56872 NULL
+read_aperture_fndecl_56876_fields read_aperture fndecl 0 56876 NULL
+copy_file_range_file_operations_56877_fields copy_file_range file_operations 0 56877 NULL nohasharray
+fat_rebuild_parent_fndecl_56877_fields fat_rebuild_parent fndecl 2 56877 &copy_file_range_file_operations_56877_fields nohasharray
+ath6kl_wmi_set_pvb_cmd_fndecl_56877_fields ath6kl_wmi_set_pvb_cmd fndecl 2 56877 &fat_rebuild_parent_fndecl_56877_fields
+xfs_itruncate_extents_fndecl_56879_fields xfs_itruncate_extents fndecl 4 56879 NULL nohasharray
+scsi_execute_fndecl_56879_fields scsi_execute fndecl 5 56879 &xfs_itruncate_extents_fndecl_56879_fields
+xfs_rmap_free_fndecl_56880_fields xfs_rmap_free fndecl 0 56880 NULL
+__btrfs_set_prop_fndecl_56883_fields __btrfs_set_prop fndecl 5 56883 NULL
+dx_dirent_blk_ocfs2_dx_entry_56884_fields dx_dirent_blk ocfs2_dx_entry 0 56884 NULL
+cmtp_send_frame_fndecl_56890_fields cmtp_send_frame fndecl 3 56890 NULL
+zr364xx_got_frame_fndecl_56891_fields zr364xx_got_frame fndecl 2 56891 NULL
+prev_adaption_gsm_dlci_56892_fields prev_adaption gsm_dlci 0 56892 NULL nohasharray
+total_size_qed_ilt_cli_blk_56892_fields total_size qed_ilt_cli_blk 0 56892 &prev_adaption_gsm_dlci_56892_fields nohasharray
+byte_count_drm_device_dma_56892_fields byte_count drm_device_dma 0 56892 &total_size_qed_ilt_cli_blk_56892_fields
+width_font_desc_56899_fields width font_desc 0 56899 NULL
+eld_size_hdac_hdmi_eld_56901_fields eld_size hdac_hdmi_eld 0 56901 NULL
+xen_find_free_area_fndecl_56905_fields xen_find_free_area fndecl 0-1 56905 NULL
+length_fw_cdev_send_response_56906_fields length fw_cdev_send_response 0 56906 NULL nohasharray
+__process_new_xattr_fndecl_56906_fields __process_new_xattr fndecl 6-4 56906 &length_fw_cdev_send_response_56906_fields nohasharray
+rho_hybla_56906_fields rho hybla 0 56906 &__process_new_xattr_fndecl_56906_fields
+max_port_number_tb_regs_switch_header_56907_fields max_port_number tb_regs_switch_header 0 56907 NULL
+mcopy_atomic_pte_fndecl_56913_fields mcopy_atomic_pte fndecl 4 56913 NULL
+diff_objects_assoc_array_ops_56914_fields diff_objects assoc_array_ops 0 56914 NULL
+xt_compat_target_offset_fndecl_56923_fields xt_compat_target_offset fndecl 0 56923 NULL nohasharray
+ip6_find_1stfragopt_fndecl_56923_fields ip6_find_1stfragopt fndecl 0 56923 &xt_compat_target_offset_fndecl_56923_fields
+vram_vardecl_nvidia_c_56925_fields vram vardecl_nvidia.c 0 56925 NULL
+beiscsi_process_async_pdu_fndecl_56929_fields beiscsi_process_async_pdu fndecl 6 56929 NULL
+data_len_ib_mac_iocb_rsp_56930_fields data_len ib_mac_iocb_rsp 0 56930 NULL
+max_tar_initio_host_56934_fields max_tar initio_host 0 56934 NULL
+vmw_gmr_bind_fndecl_56940_fields vmw_gmr_bind fndecl 3 56940 NULL
+len_rx_hdr_56949_fields len rx_hdr 0 56949 NULL
+target_submit_cmd_fndecl_56950_fields target_submit_cmd fndecl 6 56950 NULL
+memblock_set_node_fndecl_56955_fields memblock_set_node fndecl 2-1 56955 NULL
+DevSizeShift_qinfo_chip_56957_fields DevSizeShift qinfo_chip 0 56957 NULL
+i_lastalloc_affs_inode_info_56961_fields i_lastalloc affs_inode_info 0 56961 NULL
+cur_pkt_size_pktgen_dev_56962_fields cur_pkt_size pktgen_dev 0 56962 NULL
+spanned_pages_zone_56972_fields spanned_pages zone 0 56972 NULL
+find_next_chunk_fndecl_56983_fields find_next_chunk fndecl 0 56983 NULL
+ath6kl_wmi_startscan_cmd_fndecl_56985_fields ath6kl_wmi_startscan_cmd fndecl 8-2 56985 NULL
+i2c_hid_alloc_buffers_fndecl_56986_fields i2c_hid_alloc_buffers fndecl 2 56986 NULL
+max_packet_whc_qset_56991_fields max_packet whc_qset 0 56991 NULL nohasharray
+btrfs_dio_bio_alloc_fndecl_56991_fields btrfs_dio_bio_alloc fndecl 2 56991 &max_packet_whc_qset_56991_fields
+file_remove_privs_fndecl_57001_fields file_remove_privs fndecl 0 57001 NULL nohasharray
+num_tx_rings_bnx2_57001_fields num_tx_rings bnx2 0 57001 &file_remove_privs_fndecl_57001_fields
+edid_size_dlfb_data_57003_fields edid_size dlfb_data 0 57003 NULL
+max_size_akcipher_alg_57009_fields max_size akcipher_alg 0 57009 NULL
+ext4_clear_blocks_fndecl_57012_fields ext4_clear_blocks fndecl 4-5 57012 NULL
+watchdog_cdev_register_fndecl_57017_fields watchdog_cdev_register fndecl 2 57017 NULL
+expand_corename_fndecl_57021_fields expand_corename fndecl 2 57021 NULL
+buffer_bytes_max_snd_pcm_substream_57022_fields buffer_bytes_max snd_pcm_substream 0 57022 NULL
+xs_send_kvec_fndecl_57023_fields xs_send_kvec fndecl 5 57023 NULL
+nfs_idmap_instantiate_fndecl_57026_fields nfs_idmap_instantiate fndecl 4 57026 NULL
+usb_packet_maxlen_usb_fifo_57029_fields usb_packet_maxlen usb_fifo 0 57029 NULL
+stacksize_xt_table_info_57031_fields stacksize xt_table_info 0 57031 NULL nohasharray
+xfrm_count_pfkey_enc_supported_fndecl_57031_fields xfrm_count_pfkey_enc_supported fndecl 0 57031 &stacksize_xt_table_info_57031_fields
+do_munmap_fndecl_57035_fields do_munmap fndecl 2-3 57035 NULL
+size_mb_flash_desc_57036_fields size_mb flash_desc 0 57036 NULL
+ib_qib_max_cqes_vardecl_57049_fields ib_qib_max_cqes vardecl 0 57049 NULL
+elem_size_bpf_array_57051_fields elem_size bpf_array 0 57051 NULL
+i_subdirs_ceph_inode_info_57052_fields i_subdirs ceph_inode_info 0 57052 NULL
+index_scsi_disk_57053_fields index scsi_disk 0 57053 NULL
+nsindex_size_nvdimm_drvdata_57060_fields nsindex_size nvdimm_drvdata 0 57060 NULL
+size_garmin_packet_57061_fields size garmin_packet 0 57061 NULL
+log_blocks_per_seg_f2fs_sb_info_57063_fields log_blocks_per_seg f2fs_sb_info 0 57063 NULL
+amdgpu_cgs_gmap_kmem_fndecl_57064_fields amdgpu_cgs_gmap_kmem fndecl 3 57064 NULL
+dm_pool_block_is_used_fndecl_57067_fields dm_pool_block_is_used fndecl 0 57067 NULL
+ezusb_write_ltv_fndecl_57071_fields ezusb_write_ltv fndecl 4 57071 NULL nohasharray
+exponent_size_dw_guc_css_header_57071_fields exponent_size_dw guc_css_header 0 57071 &ezusb_write_ltv_fndecl_57071_fields
+mem_map_size_efx_nic_type_57089_fields mem_map_size efx_nic_type 0 57089 NULL
+num_uars_mlx4_caps_57093_fields num_uars mlx4_caps 0 57093 NULL nohasharray
+xfs_submit_ioend_fndecl_57093_fields xfs_submit_ioend fndecl 3-0 57093 &num_uars_mlx4_caps_57093_fields
+mcs7830_get_reg_fndecl_57103_fields mcs7830_get_reg fndecl 3 57103 NULL
+total_sections_f2fs_sb_info_57118_fields total_sections f2fs_sb_info 0 57118 NULL
+submit_stripe_bio_fndecl_57124_fields submit_stripe_bio fndecl 4 57124 NULL
+gsm_mux_rx_netchar_fndecl_57131_fields gsm_mux_rx_netchar fndecl 3 57131 NULL
+ath10k_htt_rx_crypto_tail_len_fndecl_57132_fields ath10k_htt_rx_crypto_tail_len fndecl 0 57132 NULL
+max_write_same_sectors_queue_limits_57138_fields max_write_same_sectors queue_limits 0 57138 NULL
+iblock_get_bio_fndecl_57139_fields iblock_get_bio fndecl 2-3 57139 NULL
+pack_sg_list_p_fndecl_57142_fields pack_sg_list_p fndecl 7-6 57142 NULL
+sb_agblklog_xfs_sb_57145_fields sb_agblklog xfs_sb 0 57145 NULL
+ath6kl_usb_ctrl_msg_exchange_fndecl_57148_fields ath6kl_usb_ctrl_msg_exchange fndecl 4 57148 NULL
+vlan_dev_vlan_id_fndecl_57152_fields vlan_dev_vlan_id fndecl 0 57152 NULL
+ofs_in_node_dnode_of_data_57156_fields ofs_in_node dnode_of_data 0 57156 NULL nohasharray
+segs_per_sec_f2fs_sb_info_57156_fields segs_per_sec f2fs_sb_info 0 57156 &ofs_in_node_dnode_of_data_57156_fields
+bytes_written_flags_cq_enet_rq_desc_57164_fields bytes_written_flags cq_enet_rq_desc 0 57164 NULL
+spi_wr_buf_fndecl_57169_fields spi_wr_buf fndecl 4 57169 NULL
+alloc_len_xps_map_57174_fields alloc_len xps_map 0 57174 NULL
+dpcm_playback_snd_soc_dai_link_57182_fields dpcm_playback snd_soc_dai_link 0 57182 NULL
+create_xattr_datum_fndecl_57183_fields create_xattr_datum fndecl 5 57183 NULL
+udf_delete_aext_fndecl_57186_fields udf_delete_aext fndecl 4 57186 NULL
+num_vfs_mlx4_dev_persistent_57187_fields num_vfs mlx4_dev_persistent 0 57187 NULL
+z1_zt_57189_fields z1 zt 0 57189 NULL
+max_lag_mlxsw_config_profile_57191_fields max_lag mlxsw_config_profile 0 57191 NULL
+OutputCount_smb2_ioctl_rsp_57198_fields OutputCount smb2_ioctl_rsp 0 57198 NULL
+sector_dm_crypt_io_57208_fields sector dm_crypt_io 0 57208 NULL
+frag_max_size_inet6_skb_parm_57210_fields frag_max_size inet6_skb_parm 0 57210 NULL
+osd_req_op_xattr_init_fndecl_57211_fields osd_req_op_xattr_init fndecl 6 57211 NULL
+overflow_maj_vardecl_uverbs_main_c_57216_fields overflow_maj vardecl_uverbs_main.c 0 57216 NULL
+node_spanned_pages_pglist_data_57226_fields node_spanned_pages pglist_data 0 57226 NULL
+mss_Vmxnet3_RxCompDescExt_57228_fields mss Vmxnet3_RxCompDescExt 0 57228 NULL
+len_setup_data_57234_fields len setup_data 0 57234 NULL nohasharray
+ufs_getfrag_block_fndecl_57234_fields ufs_getfrag_block fndecl 2 57234 &len_setup_data_57234_fields
+ext4_meta_bg_first_block_no_fndecl_57235_fields ext4_meta_bg_first_block_no fndecl 0-2 57235 NULL
+header_asix_rx_fixup_info_57237_fields header asix_rx_fixup_info 0 57237 NULL nohasharray
+li_namelen_nfsd4_link_57237_fields li_namelen nfsd4_link 0 57237 &header_asix_rx_fixup_info_57237_fields
+iomap_write_end_fndecl_57238_fields iomap_write_end fndecl 2-0-4-3 57238 NULL
+offset_ion_test_rw_data_57241_fields offset ion_test_rw_data 0 57241 NULL
+pkg_size_raydium_data_57243_fields pkg_size raydium_data 0 57243 NULL
+maxlen_xfs_alloc_arg_57260_fields maxlen xfs_alloc_arg 0 57260 NULL
+si2165_read_fndecl_57262_fields si2165_read fndecl 4 57262 NULL
+sc18is602_setup_transfer_fndecl_57266_fields sc18is602_setup_transfer fndecl 0 57266 NULL
+fuse_dev_do_write_fndecl_57267_fields fuse_dev_do_write fndecl 3 57267 NULL
+iwl_mvm_sta_tx_agg_stop_fndecl_57274_fields iwl_mvm_sta_tx_agg_stop fndecl 4 57274 NULL
+mps_l2cap_le_conn_rsp_57280_fields mps l2cap_le_conn_rsp 0 57280 NULL
+entry_nr_kvm_assigned_msix_nr_57282_fields entry_nr kvm_assigned_msix_nr 0 57282 NULL
+packet_sz_musb_ep_57296_fields packet_sz musb_ep 0 57296 NULL
+ie_len_parsed_vndr_ie_info_57299_fields ie_len parsed_vndr_ie_info 0 57299 NULL
+qtd_copy_status_fndecl_57306_fields qtd_copy_status fndecl 0-4-3 57306 NULL
+ptk_ivlen_iwl_mvm_57307_fields ptk_ivlen iwl_mvm 0 57307 NULL
+usCRTC_V_SyncStart__ATOM_MODE_TIMING_57308_fields usCRTC_V_SyncStart _ATOM_MODE_TIMING 0 57308 NULL nohasharray
+elf_map_fndecl_57308_fields elf_map fndecl 6 57308 &usCRTC_V_SyncStart__ATOM_MODE_TIMING_57308_fields
+orinoco_hw_get_essid_fndecl_57314_fields orinoco_hw_get_essid fndecl 0 57314 NULL
+sndbuf_size_rds_tcp_net_57323_fields sndbuf_size rds_tcp_net 0 57323 NULL
+acpi_gsi_to_irq_fndecl_57326_fields acpi_gsi_to_irq fndecl 1 57326 NULL
+ext4_expand_extra_isize_ea_fndecl_57344_fields ext4_expand_extra_isize_ea fndecl 2 57344 NULL
+root_hpfs_super_block_57345_fields root hpfs_super_block 0 57345 NULL
+align_nf_ct_ext_type_57348_fields align nf_ct_ext_type 0 57348 NULL
+lbs_debugfs_write_fndecl_57358_fields lbs_debugfs_write fndecl 3 57358 NULL
+usFirmwareUseInKb__ATOM_FIRMWARE_VRAM_RESERVE_INFO_57360_fields usFirmwareUseInKb _ATOM_FIRMWARE_VRAM_RESERVE_INFO 0 57360 NULL
+next_burst_len_iscsi_seq_57361_fields next_burst_len iscsi_seq 0 57361 NULL
+nfs_create_request_fndecl_57363_fields nfs_create_request fndecl 5 57363 NULL
+au_sd_ssr_57367_fields au sd_ssr 0 57367 NULL
+dqi_giblk_ocfs2_mem_dqinfo_57374_fields dqi_giblk ocfs2_mem_dqinfo 0 57374 NULL
+rcount_slip_57376_fields rcount slip 0 57376 NULL
+tcp_retransmit_skb_fndecl_57379_fields tcp_retransmit_skb fndecl 3 57379 NULL
+kfd_pasid_alloc_fndecl_57381_fields kfd_pasid_alloc fndecl 0 57381 NULL
+ocfs2_reflink_xattr_bucket_fndecl_57395_fields ocfs2_reflink_xattr_bucket fndecl 2-6-3 57395 NULL
+iwl_dbgfs_fw_dbg_collect_write_fndecl_57398_fields iwl_dbgfs_fw_dbg_collect_write fndecl 3 57398 NULL
+iscsit_xmit_pdu_fndecl_57408_fields iscsit_xmit_pdu fndecl 5 57408 NULL nohasharray
+skb_pull_fndecl_57408_fields skb_pull fndecl 2 57408 &iscsit_xmit_pdu_fndecl_57408_fields nohasharray
+cryptlen_chachapoly_req_ctx_57408_fields cryptlen chachapoly_req_ctx 0 57408 &skb_pull_fndecl_57408_fields
+copy_page_from_iter_iovec_fndecl_57409_fields copy_page_from_iter_iovec fndecl 3 57409 NULL
+numbered_hid_report_enum_57419_fields numbered hid_report_enum 0 57419 NULL
+blkdev_get_block_fndecl_57432_fields blkdev_get_block fndecl 2 57432 NULL
+kvm_page_track_create_memslot_fndecl_57439_fields kvm_page_track_create_memslot fndecl 2 57439 NULL
+segsize_loc_dn_scp_57445_fields segsize_loc dn_scp 0 57445 NULL
+dln2_i2c_read_fndecl_57452_fields dln2_i2c_read fndecl 0-4 57452 NULL
+cp_table_size_radeon_rlc_57462_fields cp_table_size radeon_rlc 0 57462 NULL
+drbd_bm_capacity_fndecl_57473_fields drbd_bm_capacity fndecl 0 57473 NULL
+wiimote_hid_send_fndecl_57475_fields wiimote_hid_send fndecl 3 57475 NULL
+leaf_copy_dir_entries_fndecl_57477_fields leaf_copy_dir_entries fndecl 6 57477 NULL
+nutrs_ufs_hba_57478_fields nutrs ufs_hba 0 57478 NULL
+data_len_ib_mad_send_buf_57480_fields data_len ib_mad_send_buf 0 57480 NULL
+gfs2_log_get_bio_fndecl_57481_fields gfs2_log_get_bio fndecl 2 57481 NULL
+lrc_setup_wa_ctx_obj_fndecl_57482_fields lrc_setup_wa_ctx_obj fndecl 2 57482 NULL
+brcmf_sdio_glom_len_fndecl_57483_fields brcmf_sdio_glom_len fndecl 0 57483 NULL
+mps_l2cap_le_conn_req_57484_fields mps l2cap_le_conn_req 0 57484 NULL
+phantom_get_free_fndecl_57489_fields phantom_get_free fndecl 0 57489 NULL
+consume_q_size_vmci_qp_57492_fields consume_q_size vmci_qp 0 57492 NULL
+r8a66597_urb_done_fndecl_57497_fields r8a66597_urb_done fndecl 3 57497 NULL
+truncate_data_blocks_range_fndecl_57510_fields truncate_data_blocks_range fndecl 2 57510 NULL nohasharray
+usnic_uiom_get_pages_fndecl_57510_fields usnic_uiom_get_pages fndecl 1 57510 &truncate_data_blocks_range_fndecl_57510_fields
+raid10_size_fndecl_57512_fields raid10_size fndecl 0-3-2 57512 NULL
+s_log_block_size_ext4_super_block_57520_fields s_log_block_size ext4_super_block 0 57520 NULL
+igb_rd32_fndecl_57524_fields igb_rd32 fndecl 0 57524 NULL
+temp_begin_applesmc_registers_57532_fields temp_begin applesmc_registers 0 57532 NULL
+height_tw68_dev_57535_fields height tw68_dev 0 57535 NULL
+trimmed_cp_control_57542_fields trimmed cp_control 0 57542 NULL
+i_file_sec_hpfs_inode_info_57545_fields i_file_sec hpfs_inode_info 0 57545 NULL
+fdp_nci_probe_fndecl_57547_fields fdp_nci_probe fndecl 4 57547 NULL
+is_zd1211b_zd_usb_57548_fields is_zd1211b zd_usb 0 57548 NULL
+last_to_afs_call_57563_fields last_to afs_call 0 57563 NULL
+resp_len_ql4_task_data_57567_fields resp_len ql4_task_data 0 57567 NULL
+offset_mtd_part_57572_fields offset mtd_part 0 57572 NULL
+i40e_receive_skb_fndecl_57575_fields i40e_receive_skb fndecl 3 57575 NULL nohasharray
+pvr2_ctrl_get_max_fndecl_57575_fields pvr2_ctrl_get_max fndecl 0 57575 &i40e_receive_skb_fndecl_57575_fields
+blkstol2_fndecl_57577_fields blkstol2 fndecl 0 57577 NULL nohasharray
+do_mpage_readpage_fndecl_57577_fields do_mpage_readpage fndecl 3 57577 &blkstol2_fndecl_57577_fields
+opt_optl_optdata_dn_57580_fields opt_optl optdata_dn 0 57580 NULL
+ngpps_intel_community_57584_fields ngpps intel_community 0 57584 NULL
+shared_max_reservation_object_list_57587_fields shared_max reservation_object_list 0 57587 NULL
+data_dot_offset_xfs_dir_ops_57591_fields data_dot_offset xfs_dir_ops 0 57591 NULL nohasharray
+unmap_blk_desc_data_len_scsi_unmap_parm_list_57591_fields unmap_blk_desc_data_len scsi_unmap_parm_list 0 57591 &data_dot_offset_xfs_dir_ops_57591_fields
+usCRTC_V_Disp__ATOM_MODE_TIMING_57594_fields usCRTC_V_Disp _ATOM_MODE_TIMING 0 57594 NULL
+update_regset_xstate_info_fndecl_57602_fields update_regset_xstate_info fndecl 1 57602 NULL
+buffer_bytes_osst_buffer_57604_fields buffer_bytes osst_buffer 0 57604 NULL nohasharray
+sc_pwd_len_wl18xx_event_mailbox_57604_fields sc_pwd_len wl18xx_event_mailbox 0 57604 &buffer_bytes_osst_buffer_57604_fields
+__tcp_push_pending_frames_fndecl_57607_fields __tcp_push_pending_frames fndecl 2 57607 NULL nohasharray
+mch_bar_vardecl_cr_pll_c_57607_fields mch_bar vardecl_cr_pll.c 0 57607 &__tcp_push_pending_frames_fndecl_57607_fields
+wWidth_uvc_frame_57615_fields wWidth uvc_frame 0 57615 NULL
+vmw_framebuffer_surface_dirty_fndecl_57623_fields vmw_framebuffer_surface_dirty fndecl 6 57623 NULL
+memblock_enforce_memory_limit_fndecl_57628_fields memblock_enforce_memory_limit fndecl 1 57628 NULL
+ieee80211_mesh_rx_probe_req_fndecl_57630_fields ieee80211_mesh_rx_probe_req fndecl 3 57630 NULL nohasharray
+set_discoverable_fndecl_57630_fields set_discoverable fndecl 4 57630 &ieee80211_mesh_rx_probe_req_fndecl_57630_fields
+ieee80211_ie_split_ric_fndecl_57640_fields ieee80211_ie_split_ric fndecl 0-7 57640 NULL nohasharray
+init_ipath_fndecl_57640_fields init_ipath fndecl 1 57640 &ieee80211_ie_split_ric_fndecl_57640_fields
+alloc_cc770dev_fndecl_57641_fields alloc_cc770dev fndecl 1 57641 NULL
+num_stripes_btrfs_bio_57647_fields num_stripes btrfs_bio 0 57647 NULL
+ctl_out_pipe_brcmf_usbdev_info_57648_fields ctl_out_pipe brcmf_usbdev_info 0 57648 NULL
+ttymajor_vardecl_moxa_c_57652_fields ttymajor vardecl_moxa.c 0 57652 NULL
+fuse_request_init_fndecl_57656_fields fuse_request_init fndecl 4 57656 NULL
+rbd_obj_method_sync_fndecl_57657_fields rbd_obj_method_sync fndecl 6-8 57657 NULL
+btrfs_qgroup_release_data_fndecl_57660_fields btrfs_qgroup_release_data fndecl 2-3 57660 NULL
+curheight_usb_usbvision_57669_fields curheight usb_usbvision 0 57669 NULL
+len_pn533_poll_modulations_57671_fields len pn533_poll_modulations 0 57671 NULL
+xfs_dir3_data_readahead_fndecl_57683_fields xfs_dir3_data_readahead fndecl 2 57683 NULL
+data_dma_kbtab_57688_fields data_dma kbtab 0 57688 NULL
+conflen_gss_krb5_enctype_57693_fields conflen gss_krb5_enctype 0 57693 NULL nohasharray
+phys_base_ptr_vbe_mode_ib_57693_fields phys_base_ptr vbe_mode_ib 0 57693 &conflen_gss_krb5_enctype_57693_fields
+__spi_sync_fndecl_57696_fields __spi_sync fndecl 0 57696 NULL
+i40iw_reg_user_mr_fndecl_57699_fields i40iw_reg_user_mr fndecl 2-3 57699 NULL
+residual_datacnt_initiator_status_57708_fields residual_datacnt initiator_status 0 57708 NULL
+nfs4_xattr_set_nfs4_acl_fndecl_57711_fields nfs4_xattr_set_nfs4_acl fndecl 6 57711 NULL
+de_size_fndecl_57715_fields de_size fndecl 0-1 57715 NULL
+ttm_bo_create_fndecl_57717_fields ttm_bo_create fndecl 2 57717 NULL
+nilfs_readpages_fndecl_57718_fields nilfs_readpages fndecl 4 57718 NULL
+nports_adap_ports_57721_fields nports adap_ports 0 57721 NULL
+x509_akid_note_kid_fndecl_57725_fields x509_akid_note_kid fndecl 5 57725 NULL
+max_devs_vardecl_aic94xx_hwi_c_57731_fields max_devs vardecl_aic94xx_hwi.c 0 57731 NULL
+opts1_cp_desc_57736_fields opts1 cp_desc 0 57736 NULL
+buffer_width_budget_57739_fields buffer_width budget 0 57739 NULL
+used_ebs_ubi_ainf_volume_57743_fields used_ebs ubi_ainf_volume 0 57743 NULL nohasharray
+prepare_message_spi_master_57743_fields prepare_message spi_master 0 57743 &used_ebs_ubi_ainf_volume_57743_fields
+usb_hcd_submit_urb_fndecl_57747_fields usb_hcd_submit_urb fndecl 0 57747 NULL
+__videobuf_free_fndecl_57751_fields __videobuf_free fndecl 0 57751 NULL
+res_hor_val_pvr2_hdw_57754_fields res_hor_val pvr2_hdw 0 57754 NULL nohasharray
+mdts_nvme_id_ctrl_57754_fields mdts nvme_id_ctrl 0 57754 &res_hor_val_pvr2_hdw_57754_fields
+kernel_sendmsg_fndecl_57763_fields kernel_sendmsg fndecl 0-5-4 57763 NULL
+numEntries__ATOM_PPLIB_ACPClk_Voltage_Limit_Table_57767_fields numEntries _ATOM_PPLIB_ACPClk_Voltage_Limit_Table 0 57767 NULL
+b_io_error_xfs_buf_57771_fields b_io_error xfs_buf 0 57771 NULL
+minor_media_devnode_57774_fields minor media_devnode 0 57774 NULL
+height_fb_copyarea_57780_fields height fb_copyarea 0 57780 NULL nohasharray
+end_numa_memblk_57780_fields end numa_memblk 0 57780 &height_fb_copyarea_57780_fields
+mp_rx_agg_buf_size_sdio_mmc_card_57794_fields mp_rx_agg_buf_size sdio_mmc_card 0 57794 NULL
+pos_lzma_header_57804_fields pos lzma_header 0 57804 NULL
+nic_num_sqs_en_fndecl_57805_fields nic_num_sqs_en fndecl 0-2 57805 NULL
+blocks_mmc_data_57821_fields blocks mmc_data 0 57821 NULL
+force_size_vardecl_pcmciamtd_c_57827_fields force_size vardecl_pcmciamtd.c 0 57827 NULL
+cmd_len_cmd_57830_fields cmd_len cmd 0 57830 NULL nohasharray
+ecc_bits_nand_onfi_params_57830_fields ecc_bits nand_onfi_params 0 57830 &cmd_len_cmd_57830_fields nohasharray
+ioc_count_obd_ioctl_data_57830_fields ioc_count obd_ioctl_data 0 57830 &ecc_bits_nand_onfi_params_57830_fields
+vxfs_bmap_ext4_fndecl_57831_fields vxfs_bmap_ext4 fndecl 0-2 57831 NULL nohasharray
+iscsi_complete_pdu_fndecl_57831_fields iscsi_complete_pdu fndecl 4 57831 &vxfs_bmap_ext4_fndecl_57831_fields
+length_hsu_dma_chip_57843_fields length hsu_dma_chip 0 57843 NULL
+i_pos_hi_fat_fid_57850_fields i_pos_hi fat_fid 0 57850 NULL
+vd_dsr_au_count_gru_vma_data_57855_fields vd_dsr_au_count gru_vma_data 0 57855 NULL
+target_to_linux_sector_fndecl_57857_fields target_to_linux_sector fndecl 0-2 57857 NULL
+nilfs_resize_fs_fndecl_57861_fields nilfs_resize_fs fndecl 2 57861 NULL
+len_splice_desc_57862_fields len splice_desc 0 57862 NULL
+cid_count_qed_conn_type_cfg_57865_fields cid_count qed_conn_type_cfg 0 57865 NULL
+_usbctrl_vendorreq_async_write_fndecl_57866_fields _usbctrl_vendorreq_async_write fndecl 6 57866 NULL
+lpfc_sli4_get_els_iocb_cnt_fndecl_57869_fields lpfc_sli4_get_els_iocb_cnt fndecl 0 57869 NULL
+fsl_spi_setup_transfer_fndecl_57873_fields fsl_spi_setup_transfer fndecl 0 57873 NULL nohasharray
+at24_adjust_write_count_fndecl_57873_fields at24_adjust_write_count fndecl 0-2-3 57873 &fsl_spi_setup_transfer_fndecl_57873_fields nohasharray
+mac_drv_rx_init_fndecl_57873_fields mac_drv_rx_init fndecl 2 57873 &at24_adjust_write_count_fndecl_57873_fields nohasharray
+joydev_handle_JSIOCSAXMAP_fndecl_57873_fields joydev_handle_JSIOCSAXMAP fndecl 3 57873 &mac_drv_rx_init_fndecl_57873_fields
+length_ib_umad_packet_57875_fields length ib_umad_packet 0 57875 NULL nohasharray
+init_pci_serial_quirk_57875_fields init pci_serial_quirk 0 57875 &length_ib_umad_packet_57875_fields
+v4l2_src_h_yuv_playback_info_57877_fields v4l2_src_h yuv_playback_info 0 57877 NULL
+max_devices_hpt_iop_request_get_config_57889_fields max_devices hpt_iop_request_get_config 0 57889 NULL
+num_mrs_qed_rdma_pf_params_57908_fields num_mrs qed_rdma_pf_params 0 57908 NULL
+fat_sectors_fat_bios_param_block_57917_fields fat_sectors fat_bios_param_block 0 57917 NULL
+devm_kmemdup_fndecl_57923_fields devm_kmemdup fndecl 3 57923 NULL
+MaxXmitDataSegmentLength_iscsi_conn_ops_57926_fields MaxXmitDataSegmentLength iscsi_conn_ops 0 57926 NULL
+mpwqe_log_stride_sz_mlx5e_params_57934_fields mpwqe_log_stride_sz mlx5e_params 0 57934 NULL
+memblock_set_current_limit_fndecl_57935_fields memblock_set_current_limit fndecl 1 57935 NULL
+eeprom_size_rt2x00_ops_57953_fields eeprom_size rt2x00_ops 0 57953 NULL
+i2c_read_fndecl_57956_fields i2c_read fndecl 0 57956 NULL
+ticket_len_rxkad_response_57960_fields ticket_len rxkad_response 0 57960 NULL
+filemap_check_errors_fndecl_57965_fields filemap_check_errors fndecl 0 57965 NULL
+sel_write_enforce_fndecl_57973_fields sel_write_enforce fndecl 3 57973 NULL
+rds_rm_size_fndecl_57975_fields rds_rm_size fndecl 0-2 57975 NULL
+hpfs_map_anode_fndecl_57993_fields hpfs_map_anode fndecl 2 57993 NULL
+faultin_page_fndecl_57994_fields faultin_page fndecl 3 57994 NULL
+perf_sample_ustack_size_fndecl_57995_fields perf_sample_ustack_size fndecl 0-2-1 57995 NULL
+codes_size_input_mask_57996_fields codes_size input_mask 0 57996 NULL
+max_idx_node_sz_ubifs_info_57997_fields max_idx_node_sz ubifs_info 0 57997 NULL
+SSIDlen_StatusRid_58002_fields SSIDlen StatusRid 0 58002 NULL nohasharray
+di_size_dinode_58002_fields di_size dinode 0 58002 &SSIDlen_StatusRid_58002_fields
+set_alt_usb_function_58003_fields set_alt usb_function 0 58003 NULL
+atl2_change_mtu_fndecl_58020_fields atl2_change_mtu fndecl 2 58020 NULL
+xdr_buf_subsegment_fndecl_58027_fields xdr_buf_subsegment fndecl 4-3 58027 NULL
+xfs_extent_busy_reuse_fndecl_58034_fields xfs_extent_busy_reuse fndecl 4-3 58034 NULL
+reserve_btrfs_dio_data_58035_fields reserve btrfs_dio_data 0 58035 NULL
+rindex_sc18is602_58043_fields rindex sc18is602 0 58043 NULL nohasharray
+rtw_check_beacon_data23a_fndecl_58043_fields rtw_check_beacon_data23a fndecl 3 58043 &rindex_sc18is602_58043_fields
+num_sqsets_csio_hw_58048_fields num_sqsets csio_hw 0 58048 NULL nohasharray
+cur_fw_iocb_count_qla_hw_data_58048_fields cur_fw_iocb_count qla_hw_data 0 58048 &num_sqsets_csio_hw_58048_fields
+num_pairs_nvm_id_lp_mlc_58055_fields num_pairs nvm_id_lp_mlc 0 58055 NULL
+cylinders_mspro_devinfo_58057_fields cylinders mspro_devinfo 0 58057 NULL
+max_iso_npdu_cxgbit_sock_58062_fields max_iso_npdu cxgbit_sock 0 58062 NULL
+wpa_ie_len_hostap_bss_info_58063_fields wpa_ie_len hostap_bss_info 0 58063 NULL nohasharray
+offset_m48t59_plat_data_58063_fields offset m48t59_plat_data 0 58063 &wpa_ie_len_hostap_bss_info_58063_fields nohasharray
+buffer_size_octeon_droq_58063_fields buffer_size octeon_droq 0 58063 &offset_m48t59_plat_data_58063_fields
+ath10k_htt_rx_nwifi_hdrlen_fndecl_58065_fields ath10k_htt_rx_nwifi_hdrlen fndecl 0 58065 NULL
+n_dma_bufs_vardecl_mcam_core_c_58067_fields n_dma_bufs vardecl_mcam-core.c 0 58067 NULL
+max_fast_reg_page_list_len_ib_device_attr_58072_fields max_fast_reg_page_list_len ib_device_attr 0 58072 NULL
+read_file_fndecl_58082_fields read_file fndecl 4 58082 NULL
+qib_user_sdma_pin_pages_fndecl_58083_fields qib_user_sdma_pin_pages fndecl 5-4 58083 NULL
+buffer_count_drm_i915_gem_execbuffer2_58084_fields buffer_count drm_i915_gem_execbuffer2 0 58084 NULL
+next_bofs_irlap_cb_58088_fields next_bofs irlap_cb 0 58088 NULL
+chipsize_onenand_chip_58089_fields chipsize onenand_chip 0 58089 NULL
+atyfb_setup_generic_fndecl_58092_fields atyfb_setup_generic fndecl 3 58092 NULL
+button_num_ad714x_platform_data_58098_fields button_num ad714x_platform_data 0 58098 NULL
+head_p9_rdir_58110_fields head p9_rdir 0 58110 NULL
+usb_stor_ctrl_transfer_fndecl_58117_fields usb_stor_ctrl_transfer fndecl 8-2 58117 NULL
+ore_get_rw_state_fndecl_58120_fields ore_get_rw_state fndecl 5-4 58120 NULL
+nvkm_disp_new__fndecl_58125_fields nvkm_disp_new_ fndecl 4 58125 NULL
+l_pn_lbuf_58130_fields l_pn lbuf 0 58130 NULL
+n_bitrates_ieee80211_supported_band_58136_fields n_bitrates ieee80211_supported_band 0 58136 NULL nohasharray
+jbd2_journal_inode_add_wait_fndecl_58136_fields jbd2_journal_inode_add_wait fndecl 0 58136 &n_bitrates_ieee80211_supported_band_58136_fields
+mtd_read_fndecl_58140_fields mtd_read fndecl 0 58140 NULL
+pci_alloc_child_bus_fndecl_58142_fields pci_alloc_child_bus fndecl 3 58142 NULL
+packet_recvmsg_fndecl_58143_fields packet_recvmsg fndecl 3 58143 NULL
+hr_block_bytes_o2hb_region_58145_fields hr_block_bytes o2hb_region 0 58145 NULL
+nroutes_mc5_params_58146_fields nroutes mc5_params 0 58146 NULL nohasharray
+security_inode_setattr_fndecl_58146_fields security_inode_setattr fndecl 0 58146 &nroutes_mc5_params_58146_fields
+i_clusters_ocfs2_dinode_58151_fields i_clusters ocfs2_dinode 0 58151 NULL
+rx_status_rx_desc_58154_fields rx_status rx_desc 0 58154 NULL
+size_drm_i915_gem_pwrite_58161_fields size drm_i915_gem_pwrite 0 58161 NULL nohasharray
+f2fs_mpage_readpages_fndecl_58161_fields f2fs_mpage_readpages fndecl 4 58161 &size_drm_i915_gem_pwrite_58161_fields
+l2cap_build_cmd_fndecl_58167_fields l2cap_build_cmd fndecl 4 58167 NULL
+tun_set_headroom_fndecl_58172_fields tun_set_headroom fndecl 2 58172 NULL
+head_len_beacon_data_58173_fields head_len beacon_data 0 58173 NULL
+configfs_write_bin_file_fndecl_58175_fields configfs_write_bin_file fndecl 3 58175 NULL
+num_clips_drm_vmw_present_readback_arg_58182_fields num_clips drm_vmw_present_readback_arg 0 58182 NULL
+total_resid_ceph_msg_data_cursor_58198_fields total_resid ceph_msg_data_cursor 0 58198 NULL
+maxOutstanding_AdapterControlBlock_58208_fields maxOutstanding AdapterControlBlock 0 58208 NULL
+src_w_drm_plane_state_58212_fields src_w drm_plane_state 0 58212 NULL
+rx_pipe_at76_priv_58217_fields rx_pipe at76_priv 0 58217 NULL
+size_skb_frag_struct_58222_fields size skb_frag_struct 0 58222 NULL
+xfs_attr_set_fndecl_58225_fields xfs_attr_set fndecl 4 58225 NULL
+len_on_bd_bnx2x_agg_info_58236_fields len_on_bd bnx2x_agg_info 0 58236 NULL
+font_backup_height_sisusb_usb_data_58247_fields font_backup_height sisusb_usb_data 0 58247 NULL
+lua_sysfs_write_fndecl_58254_fields lua_sysfs_write fndecl 6 58254 NULL
+ies_len_cfg80211_ft_event_params_58259_fields ies_len cfg80211_ft_event_params 0 58259 NULL
+l2cap_segment_sdu_fndecl_58263_fields l2cap_segment_sdu fndecl 4 58263 NULL
+file_size_fnode_58268_fields file_size fnode 0 58268 NULL
+intel_fbc_calculate_cfb_size_fndecl_58270_fields intel_fbc_calculate_cfb_size fndecl 0 58270 NULL
+em28xx_set_video_format_fndecl_58273_fields em28xx_set_video_format fndecl 3-4 58273 NULL
+tcp_push_one_fndecl_58275_fields tcp_push_one fndecl 2 58275 NULL nohasharray
+pages_in_block_msb_data_58275_fields pages_in_block msb_data 0 58275 &tcp_push_one_fndecl_58275_fields
+iso_size_usbtv_58278_fields iso_size usbtv 0 58278 NULL
+vmw_fifo_reserve_dx_fndecl_58283_fields vmw_fifo_reserve_dx fndecl 2 58283 NULL
+lib80211_michael_mic_add_fndecl_58285_fields lib80211_michael_mic_add fndecl 2 58285 NULL
+tx_desc_count_i40evf_adapter_58286_fields tx_desc_count i40evf_adapter 0 58286 NULL
+v9fs_fid_xattr_set_fndecl_58288_fields v9fs_fid_xattr_set fndecl 4 58288 NULL
+adfs_map_lookup_fndecl_58299_fields adfs_map_lookup fndecl 0-3 58299 NULL
+y2_drm_clip_rect_58302_fields y2 drm_clip_rect 0 58302 NULL
+buffer_size_snd_pcm_runtime_58304_fields buffer_size snd_pcm_runtime 0 58304 NULL
+CountHigh_smb_com_write_rsp_58306_fields CountHigh smb_com_write_rsp 0 58306 NULL
+vc_do_resize_fndecl_58329_fields vc_do_resize fndecl 4-3 58329 NULL nohasharray
+num_tx_ethoc_58329_fields num_tx ethoc 0 58329 &vc_do_resize_fndecl_58329_fields
+sys_setgroups16_fndecl_58337_fields sys_setgroups16 fndecl 1 58337 NULL
+nlmon_change_mtu_fndecl_58340_fields nlmon_change_mtu fndecl 2 58340 NULL nohasharray
+start_crypt_config_58340_fields start crypt_config 0 58340 &nlmon_change_mtu_fndecl_58340_fields
+get_num_of_pp_table_entries_pp_hwmgr_func_58341_fields get_num_of_pp_table_entries pp_hwmgr_func 0 58341 NULL
+s2io_change_mtu_fndecl_58344_fields s2io_change_mtu fndecl 2 58344 NULL
+ext2_alloc_branch_fndecl_58346_fields ext2_alloc_branch fndecl 4 58346 NULL
+add_regulator_fndecl_58367_fields add_regulator fndecl 1 58367 NULL
+tun_recvmsg_fndecl_58372_fields tun_recvmsg fndecl 3 58372 NULL
+collapse_shmem_fndecl_58383_fields collapse_shmem fndecl 3 58383 NULL
+dma_contiguous_reserve_fndecl_58386_fields dma_contiguous_reserve fndecl 1 58386 NULL
+max_resource_constraint_58388_fields max resource_constraint 0 58388 NULL
+kvm_arch_create_memslot_fndecl_58391_fields kvm_arch_create_memslot fndecl 3 58391 NULL
+hci_prepare_cmd_fndecl_58399_fields hci_prepare_cmd fndecl 3 58399 NULL
+lbs_wrrf_write_fndecl_58409_fields lbs_wrrf_write fndecl 3 58409 NULL
+offset_snd_util_memblk_58414_fields offset snd_util_memblk 0 58414 NULL
+skip_to_level_assoc_array_shortcut_58418_fields skip_to_level assoc_array_shortcut 0 58418 NULL
+align4k_qib_devdata_58424_fields align4k qib_devdata 0 58424 NULL
+pskb_carve_inside_header_fndecl_58427_fields pskb_carve_inside_header fndecl 2 58427 NULL nohasharray
+lbs_wrmac_write_fndecl_58427_fields lbs_wrmac_write fndecl 3 58427 &pskb_carve_inside_header_fndecl_58427_fields
+sys32_ftruncate64_fndecl_58429_fields sys32_ftruncate64 fndecl 2-3 58429 NULL
+SiS_GetReg_fndecl_58436_fields SiS_GetReg fndecl 0 58436 NULL
+environ_read_fndecl_58440_fields environ_read fndecl 3 58440 NULL
+nr_pages_fuse_fill_data_58443_fields nr_pages fuse_fill_data 0 58443 NULL
+num_vhost_virtqueue_58446_fields num vhost_virtqueue 0 58446 NULL
+val_bytes_snd_soc_component_58447_fields val_bytes snd_soc_component 0 58447 NULL nohasharray
+set_cpu_key_k_offset_fndecl_58447_fields set_cpu_key_k_offset fndecl 2 58447 &val_bytes_snd_soc_component_58447_fields
+f_adc_msi2500_dev_58451_fields f_adc msi2500_dev 0 58451 NULL
+fwlen_mpt_fw_xfer32_58453_fields fwlen mpt_fw_xfer32 0 58453 NULL
+di_anextents_xfs_icdinode_58455_fields di_anextents xfs_icdinode 0 58455 NULL
+caif_seqpkt_sendmsg_fndecl_58458_fields caif_seqpkt_sendmsg fndecl 3 58458 NULL
+NumProtectionFields_cfi_pri_intelext_58461_fields NumProtectionFields cfi_pri_intelext 0 58461 NULL
+btrfs_clone_fndecl_58462_fields btrfs_clone fndecl 5-3-6 58462 NULL
+pgsize_bitmap_iommu_domain_58464_fields pgsize_bitmap iommu_domain 0 58464 NULL
+compat_sys_preadv64v2_fndecl_58477_fields compat_sys_preadv64v2 fndecl 3 58477 NULL
+jbd2_journal_inode_add_write_fndecl_58489_fields jbd2_journal_inode_add_write fndecl 0 58489 NULL
+r2tq_size_cnic_local_58490_fields r2tq_size cnic_local 0 58490 NULL nohasharray
+try_lock_extent_fndecl_58490_fields try_lock_extent fndecl 3-2 58490 &r2tq_size_cnic_local_58490_fields
+set_console_size_fndecl_58495_fields set_console_size fndecl 3-2 58495 NULL
+unlink_simple_fndecl_58497_fields unlink_simple fndecl 2 58497 NULL nohasharray
+unit_minor_sound_unit_58497_fields unit_minor sound_unit 0 58497 &unlink_simple_fndecl_58497_fields
+pstore_decompress_fndecl_58501_fields pstore_decompress fndecl 0 58501 NULL
+max_segment_size_device_dma_parameters_58507_fields max_segment_size device_dma_parameters 0 58507 NULL
+phys_in_snd_efw_58512_fields phys_in snd_efw 0 58512 NULL nohasharray
+mcp23s17_read_regs_fndecl_58512_fields mcp23s17_read_regs fndecl 4 58512 &phys_in_snd_efw_58512_fields
+pixel_stride_ivtv_osd_coords_58513_fields pixel_stride ivtv_osd_coords 0 58513 NULL
+len_bnxt_tpa_info_58516_fields len bnxt_tpa_info 0 58516 NULL
+xfs_file_iomap_end_fndecl_58525_fields xfs_file_iomap_end fndecl 4-2 58525 NULL
+rx_frag_size_bnx2x_fastpath_58531_fields rx_frag_size bnx2x_fastpath 0 58531 NULL
+cfpkt_split_fndecl_58534_fields cfpkt_split fndecl 2 58534 NULL
+populate_vma_page_range_fndecl_58544_fields populate_vma_page_range fndecl 2-0 58544 NULL
+volinit_CHIPDESC_58545_fields volinit CHIPDESC 0 58545 NULL
+ddata_ofsl_cyttsp4_sysinfo_data_58549_fields ddata_ofsl cyttsp4_sysinfo_data 0 58549 NULL
+size_vram_area_58552_fields size vram_area 0 58552 NULL
+xfs_inobt_insert_fndecl_58558_fields xfs_inobt_insert fndecl 4 58558 NULL nohasharray
+process_vm_rw_fndecl_58558_fields process_vm_rw fndecl 5-3 58558 &xfs_inobt_insert_fndecl_58558_fields
+remaining_asix_rx_fixup_info_58562_fields remaining asix_rx_fixup_info 0 58562 NULL
+pci_iomap_fndecl_58564_fields pci_iomap fndecl 3 58564 NULL
+qib_copy_from_sge_fndecl_58565_fields qib_copy_from_sge fndecl 3 58565 NULL
+llc_shdlc_init_fndecl_58573_fields llc_shdlc_init fndecl 4 58573 NULL nohasharray
+index_vardecl_intel8x0m_c_58573_fields index vardecl_intel8x0m.c 0 58573 &llc_shdlc_init_fndecl_58573_fields
+acpi_gpio_package_count_fndecl_58585_fields acpi_gpio_package_count fndecl 0 58585 NULL
+aoe_maxsectors_vardecl_aoeblk_c_58600_fields aoe_maxsectors vardecl_aoeblk.c 0 58600 NULL
+uea_request_fndecl_58606_fields uea_request fndecl 4 58606 NULL
+hfi1_acquire_user_pages_fndecl_58612_fields hfi1_acquire_user_pages fndecl 2-0 58612 NULL
+rd_count_ring_descr_hw_58616_fields rd_count ring_descr_hw 0 58616 NULL
+__erst_write_to_storage_fndecl_58627_fields __erst_write_to_storage fndecl 1 58627 NULL
+dccps_gss_dccp_sock_58634_fields dccps_gss dccp_sock 0 58634 NULL
+layout_mdu_array_info_s_58636_fields layout mdu_array_info_s 0 58636 NULL nohasharray
+ext4_ext_handle_unwritten_extents_fndecl_58636_fields ext4_ext_handle_unwritten_extents fndecl 0-6-7 58636 &layout_mdu_array_info_s_58636_fields
+num_iwarp_msix_i40e_pf_58637_fields num_iwarp_msix i40e_pf 0 58637 NULL nohasharray
+mei_cldev_recv_fndecl_58637_fields mei_cldev_recv fndecl 0-3 58637 &num_iwarp_msix_i40e_pf_58637_fields
+pgbase_nfs4_readdir_arg_58643_fields pgbase nfs4_readdir_arg 0 58643 NULL
+tboot_log_read_fndecl_58645_fields tboot_log_read fndecl 3 58645 NULL
+report_id_hid_global_58647_fields report_id hid_global 0 58647 NULL
+page10_len_ses_device_58648_fields page10_len ses_device 0 58648 NULL
+mwifiex_alloc_dma_align_buf_fndecl_58656_fields mwifiex_alloc_dma_align_buf fndecl 1 58656 NULL nohasharray
+highest_bit_swap_info_struct_58656_fields highest_bit swap_info_struct 0 58656 &mwifiex_alloc_dma_align_buf_fndecl_58656_fields
+max_key_len_hfs_btree_58671_fields max_key_len hfs_btree 0 58671 NULL
+sb_inopblog_xfs_sb_58672_fields sb_inopblog xfs_sb 0 58672 NULL
+s_dirblksize_ufs_sb_private_info_58675_fields s_dirblksize ufs_sb_private_info 0 58675 NULL
+ses_recv_diag_fndecl_58676_fields ses_recv_diag fndecl 4 58676 NULL
+s_partition_size_affs_sb_info_58677_fields s_partition_size affs_sb_info 0 58677 NULL
+max_response_len_sg_io_v4_58687_fields max_response_len sg_io_v4 0 58687 NULL nohasharray
+head_userio_device_58687_fields head userio_device 0 58687 &max_response_len_sg_io_v4_58687_fields
+subdirs_ceph_mds_reply_inode_58689_fields subdirs ceph_mds_reply_inode 0 58689 NULL
+ioremap_cache_fndecl_58694_fields ioremap_cache fndecl 2-1 58694 NULL
+rx_dma_len_efx_nic_58695_fields rx_dma_len efx_nic 0 58695 NULL
+wdt87xx_get_desc_fndecl_58707_fields wdt87xx_get_desc fndecl 4 58707 NULL
+svc_pool_map_alloc_arrays_fndecl_58718_fields svc_pool_map_alloc_arrays fndecl 0 58718 NULL nohasharray
+fw_emem_len_rt_firmware_58718_fields fw_emem_len rt_firmware 0 58718 &svc_pool_map_alloc_arrays_fndecl_58718_fields nohasharray
+btrfs_del_inode_ref_fndecl_58718_fields btrfs_del_inode_ref fndecl 4 58718 &fw_emem_len_rt_firmware_58718_fields
+btrfs_xattr_handler_set_prop_fndecl_58727_fields btrfs_xattr_handler_set_prop fndecl 6 58727 NULL
+length_nhlt_resource_desc_58730_fields length nhlt_resource_desc 0 58730 NULL
+read_va_isert_cmd_58733_fields read_va isert_cmd 0 58733 NULL
+valid_chaoskey_58736_fields valid chaoskey 0 58736 NULL
+init_page_array_fndecl_58744_fields init_page_array fndecl 2 58744 NULL
+Residue_bulk_cs_wrap_58746_fields Residue bulk_cs_wrap 0 58746 NULL
+imaxpct_xfs_growfs_data_58747_fields imaxpct xfs_growfs_data 0 58747 NULL
+nobh_write_end_fndecl_58749_fields nobh_write_end fndecl 5 58749 NULL
+shift_rtl8xxxu_rxdesc16_58750_fields shift rtl8xxxu_rxdesc16 0 58750 NULL
+skb_copy_datagram_from_iter_fndecl_58758_fields skb_copy_datagram_from_iter fndecl 4-2 58758 NULL
+reada_add_block_fndecl_58761_fields reada_add_block fndecl 2 58761 NULL
+output_userspace_fndecl_58762_fields output_userspace fndecl 7 58762 NULL
+page_size_ib_mr_58764_fields page_size ib_mr 0 58764 NULL
+ocfs2_xattr_free_block_fndecl_58767_fields ocfs2_xattr_free_block fndecl 2 58767 NULL
+port_fops_splice_write_fndecl_58771_fields port_fops_splice_write fndecl 4 58771 NULL
+bi_bvec_done_bvec_iter_58781_fields bi_bvec_done bvec_iter 0 58781 NULL nohasharray
+ucNumEntries__ATOM_PPLIB_PhaseSheddingLimits_Table_58781_fields ucNumEntries _ATOM_PPLIB_PhaseSheddingLimits_Table 0 58781 &bi_bvec_done_bvec_iter_58781_fields
+get_formats_soc_camera_host_ops_58784_fields get_formats soc_camera_host_ops 0 58784 NULL
+off1_xad_58785_fields off1 xad 0 58785 NULL
+cache_shift_qed_dev_58790_fields cache_shift qed_dev 0 58790 NULL nohasharray
+gfs2_readpages_fndecl_58790_fields gfs2_readpages fndecl 4 58790 &cache_shift_qed_dev_58790_fields
+mppe_decompress_fndecl_58795_fields mppe_decompress fndecl 3 58795 NULL
+blkbits_dio_submit_58797_fields blkbits dio_submit 0 58797 NULL
+ci_flags_fscrypt_info_58804_fields ci_flags fscrypt_info 0 58804 NULL nohasharray
+wNumRPipes_usb_wa_descriptor_58804_fields wNumRPipes usb_wa_descriptor 0 58804 &ci_flags_fscrypt_info_58804_fields
+i40iw_qp_get_next_send_wqe_fndecl_58805_fields i40iw_qp_get_next_send_wqe fndecl 4 58805 NULL
+snd_pcm_hw_constraint_minmax_fndecl_58816_fields snd_pcm_hw_constraint_minmax fndecl 4-3 58816 NULL
+slen_snap_58819_fields slen snap 0 58819 NULL
+num_counters_op_x86_model_spec_58827_fields num_counters op_x86_model_spec 0 58827 NULL
+set_db_page_mthca_create_cq_58830_fields set_db_page mthca_create_cq 0 58830 NULL
+ms_lib_read_extrablock_fndecl_58857_fields ms_lib_read_extrablock fndecl 4 58857 NULL
+address_fault_env_58869_fields address fault_env 0 58869 NULL
+hfp_ast_vbios_enhtable_58872_fields hfp ast_vbios_enhtable 0 58872 NULL
+gbuffers_vardecl_bttv_driver_c_58873_fields gbuffers vardecl_bttv-driver.c 0 58873 NULL
+addr_nvme_sgl_desc_58875_fields addr nvme_sgl_desc 0 58875 NULL
+xm_wmfw_adsp2_alg_hdr_58884_fields xm wmfw_adsp2_alg_hdr 0 58884 NULL
+rx_buf_sz_fe_priv_58888_fields rx_buf_sz fe_priv 0 58888 NULL
+max_xfer_nd_cmd_get_config_size_58894_fields max_xfer nd_cmd_get_config_size 0 58894 NULL
+usb_stor_bulk_transfer_sg_fndecl_58896_fields usb_stor_bulk_transfer_sg fndecl 4-2 58896 NULL
+size__iohandle_58897_fields size _iohandle 0 58897 NULL
+get_next_nat_page_fndecl_58898_fields get_next_nat_page fndecl 2 58898 NULL
+mwifiex_write_data_sync_fndecl_58903_fields mwifiex_write_data_sync fndecl 3 58903 NULL
+cmodio_setup_subdevice_fndecl_58913_fields cmodio_setup_subdevice fndecl 4 58913 NULL
+befs_bread_fndecl_58922_fields befs_bread fndecl 2 58922 NULL
+parent_block_isofs_fid_58926_fields parent_block isofs_fid 0 58926 NULL
+osd_req_read_sg_fndecl_58930_fields osd_req_read_sg fndecl 5 58930 NULL
+send_reply_chunks_fndecl_58933_fields send_reply_chunks fndecl 0 58933 NULL
+leaf_item_bottle_fndecl_58937_fields leaf_item_bottle fndecl 5 58937 NULL
+ocfs2_alloc_write_ctxt_fndecl_58943_fields ocfs2_alloc_write_ctxt fndecl 3 58943 NULL
+lpe_base_sst_pdata_58946_fields lpe_base sst_pdata 0 58946 NULL
+__frame_add_frag_fndecl_58947_fields __frame_add_frag fndecl 4-5 58947 NULL
+num_req_rx_rings_bnx2_58949_fields num_req_rx_rings bnx2 0 58949 NULL
+size_drm_nouveau_gem_info_58954_fields size drm_nouveau_gem_info 0 58954 NULL
+_ext4_get_block_fndecl_58959_fields _ext4_get_block fndecl 2 58959 NULL nohasharray
+entry_size_shift_tracing_map_array_58959_fields entry_size_shift tracing_map_array 0 58959 &_ext4_get_block_fndecl_58959_fields
+query_len_tomoyo_query_58960_fields query_len tomoyo_query 0 58960 NULL
+integrity_alg_len_net_conf_58973_fields integrity_alg_len net_conf 0 58973 NULL
+adjust_managed_page_count_fndecl_58974_fields adjust_managed_page_count fndecl 2 58974 NULL
+pglen_nfs4_layoutdriver_data_58977_fields pglen nfs4_layoutdriver_data 0 58977 NULL nohasharray
+info0_rx_msdu_start_common_58977_fields info0 rx_msdu_start_common 0 58977 &pglen_nfs4_layoutdriver_data_58977_fields
+nent_mthca_eq_58979_fields nent mthca_eq 0 58979 NULL
+len_extent_buffer_58980_fields len extent_buffer 0 58980 NULL nohasharray
+ptk_icvlen_iwl_mvm_58980_fields ptk_icvlen iwl_mvm 0 58980 &len_extent_buffer_58980_fields
+sg_miter_skip_fndecl_58982_fields sg_miter_skip fndecl 2 58982 NULL
+len_cont_58983_fields len cont 0 58983 NULL
+index_ldtentry_58989_fields index ldtentry 0 58989 NULL nohasharray
+__tda18271_write_regs_fndecl_58989_fields __tda18271_write_regs fndecl 3 58989 &index_ldtentry_58989_fields
+translate_desc_fndecl_58993_fields translate_desc fndecl 3-2-0 58993 NULL
+max_hw_sectors_nvme_ctrl_59000_fields max_hw_sectors nvme_ctrl 0 59000 NULL nohasharray
+trace_max_pages_vardecl_59000_fields trace_max_pages vardecl 0 59000 &max_hw_sectors_nvme_ctrl_59000_fields
+num_lun_nvm_id_group_59001_fields num_lun nvm_id_group 0 59001 NULL nohasharray
+private_value_snd_kcontrol_59001_fields private_value snd_kcontrol 0 59001 &num_lun_nvm_id_group_59001_fields
+tid_iwl_mvm_baid_data_59008_fields tid iwl_mvm_baid_data 0 59008 NULL nohasharray
+wa_urb_dequeue_fndecl_59008_fields wa_urb_dequeue fndecl 3 59008 &tid_iwl_mvm_baid_data_59008_fields
+numextents_efs_inode_info_59009_fields numextents efs_inode_info 0 59009 NULL
+amdgpu_vram_location_fndecl_59010_fields amdgpu_vram_location fndecl 3 59010 NULL
+dccpsl_nr_dccp_service_list_59022_fields dccpsl_nr dccp_service_list 0 59022 NULL
+frag_max_size_inet_skb_parm_59029_fields frag_max_size inet_skb_parm 0 59029 NULL
+frags_len_lro_59030_fields frags_len lro 0 59030 NULL
+in_epnum_usb_gadget_59033_fields in_epnum usb_gadget 0 59033 NULL
+max_inbound_frames__i2o_status_block_59034_fields max_inbound_frames _i2o_status_block 0 59034 NULL
+head_inbuf_t_59044_fields head inbuf_t 0 59044 NULL
+len_nand_bbt_descr_59045_fields len nand_bbt_descr 0 59045 NULL
+ref_node_alsz_ubifs_info_59046_fields ref_node_alsz ubifs_info 0 59046 NULL
+data0_myri10ge_cmd_59049_fields data0 myri10ge_cmd 0 59049 NULL
+max_block_docg3_59051_fields max_block docg3 0 59051 NULL nohasharray
+aligned_pep_sock_59051_fields aligned pep_sock 0 59051 &max_block_docg3_59051_fields
+s_block_count_reiserfs_super_block_v1_59058_fields s_block_count reiserfs_super_block_v1 0 59058 NULL
+mpeglinesize_vardecl_cx231xx_417_c_59059_fields mpeglinesize vardecl_cx231xx-417.c 0 59059 NULL
+mem_cgroup_try_charge_fndecl_59062_fields mem_cgroup_try_charge fndecl 0 59062 NULL nohasharray
+sys32_pread_fndecl_59062_fields sys32_pread fndecl 3 59062 &mem_cgroup_try_charge_fndecl_59062_fields
+piobufbase_qib_devdata_59067_fields piobufbase qib_devdata 0 59067 NULL
+bmv_offset_getbmapx_59079_fields bmv_offset getbmapx 0 59079 NULL nohasharray
+write_va_isert_cmd_59079_fields write_va isert_cmd 0 59079 &bmv_offset_getbmapx_59079_fields
+i915_gem_stolen_insert_node_in_range_fndecl_59083_fields i915_gem_stolen_insert_node_in_range fndecl 3 59083 NULL
+cp2112_hid_output_fndecl_59085_fields cp2112_hid_output fndecl 3 59085 NULL
+rcvidx_hscx_hw_59100_fields rcvidx hscx_hw 0 59100 NULL
+ctrl_dma_ims_pcu_59106_fields ctrl_dma ims_pcu 0 59106 NULL
+remap_and_issue_shared_cell_fndecl_59114_fields remap_and_issue_shared_cell fndecl 3 59114 NULL
+sec_per_clus_fat_floppy_defaults_59119_fields sec_per_clus fat_floppy_defaults 0 59119 NULL
+omapdss_count_strings_fndecl_59120_fields omapdss_count_strings fndecl 0 59120 NULL
+npages_for_summary_flush_fndecl_59124_fields npages_for_summary_flush fndecl 0 59124 NULL
+width_em28xx_v4l2_59127_fields width em28xx_v4l2 0 59127 NULL nohasharray
+xfs_read_agi_fndecl_59127_fields xfs_read_agi fndecl 3 59127 &width_em28xx_v4l2_59127_fields
+bitrate_ieee80211_rate_59130_fields bitrate ieee80211_rate 0 59130 NULL
+do_sys_ftruncate_fndecl_59136_fields do_sys_ftruncate fndecl 2 59136 NULL
+q1_block_size_i40iw_hmc_fpm_misc_59149_fields q1_block_size i40iw_hmc_fpm_misc 0 59149 NULL
+rx_data_ep_usb_card_rec_59150_fields rx_data_ep usb_card_rec 0 59150 NULL
+get_desc_rtl_hal_ops_59151_fields get_desc rtl_hal_ops 0 59151 NULL
+free_low_memory_core_early_fndecl_59160_fields free_low_memory_core_early fndecl 0 59160 NULL
+log_buf_len_vardecl_printk_c_59170_fields log_buf_len vardecl_printk.c 0 59170 NULL
+address_length_acpi_resource_io_59176_fields address_length acpi_resource_io 0 59176 NULL
+av_buf_ackno_dccp_ackvec_59183_fields av_buf_ackno dccp_ackvec 0 59183 NULL
+comps_used_iser_device_59187_fields comps_used iser_device 0 59187 NULL
+img_height_zoran_jpg_settings_59188_fields img_height zoran_jpg_settings 0 59188 NULL
+isl12022_read_regs_fndecl_59190_fields isl12022_read_regs fndecl 4 59190 NULL
+vtag_rx_pkt_status_59191_fields vtag rx_pkt_status 0 59191 NULL
+cdc_ncm_check_rx_max_fndecl_59192_fields cdc_ncm_check_rx_max fndecl 0-2 59192 NULL
+ms_os_descs_ext_prop_name_len_ffs_data_59205_fields ms_os_descs_ext_prop_name_len ffs_data 0 59205 NULL
+s_bmap_bits_affs_sb_info_59206_fields s_bmap_bits affs_sb_info 0 59206 NULL
+fat_sector_size_fat_bios_param_block_59207_fields fat_sector_size fat_bios_param_block 0 59207 NULL nohasharray
+nblocks_nilfs_segsum_info_59207_fields nblocks nilfs_segsum_info 0 59207 &fat_sector_size_fat_bios_param_block_59207_fields
+jade_empty_fifo_fndecl_59210_fields jade_empty_fifo fndecl 2 59210 NULL
+usCRTC_H_SyncWidth__ATOM_MODE_TIMING_59211_fields usCRTC_H_SyncWidth _ATOM_MODE_TIMING 0 59211 NULL
+xfs_bmapi_trim_map_fndecl_59212_fields xfs_bmapi_trim_map fndecl 6 59212 NULL nohasharray
+mpdu_len_wcn36xx_pdu_59212_fields mpdu_len wcn36xx_pdu 0 59212 &xfs_bmapi_trim_map_fndecl_59212_fields
+cqe_size_mlx5_ib_create_cq_59213_fields cqe_size mlx5_ib_create_cq 0 59213 NULL
+lock_extent_direct_fndecl_59219_fields lock_extent_direct fndecl 3-2 59219 NULL
+fbmem_used_viafb_par_59221_fields fbmem_used viafb_par 0 59221 NULL nohasharray
+rtl8723b_parse_firmware_fndecl_59221_fields rtl8723b_parse_firmware fndecl 0 59221 &fbmem_used_viafb_par_59221_fields
+gprs_set_mtu_fndecl_59222_fields gprs_set_mtu fndecl 2 59222 NULL
+up_anode_59225_fields up anode 0 59225 NULL
+size_vhost_umem_node_59230_fields size vhost_umem_node 0 59230 NULL
+__iptunnel_pull_header_fndecl_59234_fields __iptunnel_pull_header fndecl 2 59234 NULL
+sierra_net_skb_clone_fndecl_59236_fields sierra_net_skb_clone fndecl 3 59236 NULL
+nr_segs_iov_iter_59239_fields nr_segs iov_iter 0 59239 NULL nohasharray
+clear_record_extent_bits_fndecl_59239_fields clear_record_extent_bits fndecl 2-3 59239 &nr_segs_iov_iter_59239_fields
+num_mbc_cfgs_wm8994_pdata_59240_fields num_mbc_cfgs wm8994_pdata 0 59240 NULL
+nlp_maxframe_lpfc_nodelist_59242_fields nlp_maxframe lpfc_nodelist 0 59242 NULL
+save_microcode_fndecl_59254_fields save_microcode fndecl 3 59254 NULL
+set_dma_channels_fndecl_59256_fields set_dma_channels fndecl 2 59256 NULL
+rcvidx_hdlc_hw_59264_fields rcvidx hdlc_hw 0 59264 NULL nohasharray
+nilfs_sufile_get_offset_fndecl_59264_fields nilfs_sufile_get_offset fndecl 0-2 59264 &rcvidx_hdlc_hw_59264_fields
+indir_size_ethtool_rxfh_59267_fields indir_size ethtool_rxfh 0 59267 NULL
+number_of_sets_host_cmd_ds_802_11_scan_rsp_59273_fields number_of_sets host_cmd_ds_802_11_scan_rsp 0 59273 NULL
+ovs_dp_upcall_fndecl_59279_fields ovs_dp_upcall fndecl 5 59279 NULL nohasharray
+data_length_bnx2i_cmd_response_59279_fields data_length bnx2i_cmd_response 0 59279 &ovs_dp_upcall_fndecl_59279_fields
+ir_prepare_write_buffer_fndecl_59280_fields ir_prepare_write_buffer fndecl 3 59280 NULL
+nentries_afs_dir_pagehdr_59283_fields nentries afs_dir_pagehdr 0 59283 NULL
+used_snd_array_59285_fields used snd_array 0 59285 NULL
+hpfs_write_end_fndecl_59287_fields hpfs_write_end fndecl 5 59287 NULL
+nr_regs_omap_prcm_irq_setup_59292_fields nr_regs omap_prcm_irq_setup 0 59292 NULL
+range_oid_t_59299_fields range oid_t 0 59299 NULL
+jffs2_write_dnode_fndecl_59301_fields jffs2_write_dnode fndecl 5 59301 NULL
+next_segno_curseg_info_59302_fields next_segno curseg_info 0 59302 NULL
+stretch_width_usb_usbvision_59304_fields stretch_width usb_usbvision 0 59304 NULL
+W6692_empty_Bfifo_fndecl_59311_fields W6692_empty_Bfifo fndecl 2 59311 NULL
+frame_bytes_ua101_stream_59312_fields frame_bytes ua101_stream 0 59312 NULL
+befs_fblock2brun_fndecl_59313_fields befs_fblock2brun fndecl 3 59313 NULL
+qib_copy_sge_fndecl_59314_fields qib_copy_sge fndecl 3 59314 NULL
+nv_getlen_fndecl_59327_fields nv_getlen fndecl 0-3 59327 NULL
+i2c_inb_fndecl_59328_fields i2c_inb fndecl 0 59328 NULL
+stmmac_set_bfsize_fndecl_59337_fields stmmac_set_bfsize fndecl 0 59337 NULL
+hfi1_max_cqes_vardecl_59339_fields hfi1_max_cqes vardecl 0 59339 NULL
+raw_sendmsg_fndecl_59341_fields raw_sendmsg fndecl 3 59341 NULL
+mbox_size_sst_res_info_59343_fields mbox_size sst_res_info 0 59343 NULL
+ttymajor_vardecl_synclinkmp_c_59344_fields ttymajor vardecl_synclinkmp.c 0 59344 NULL
+offset_first_afs_writeback_59348_fields offset_first afs_writeback 0 59348 NULL
+rtl_cmd_width_vardecl_ibm_rtl_c_59349_fields rtl_cmd_width vardecl_ibm_rtl.c 0 59349 NULL
+vc_cols_vc_data_59351_fields vc_cols vc_data 0 59351 NULL
+r5l_write_super_and_discard_space_fndecl_59352_fields r5l_write_super_and_discard_space fndecl 2 59352 NULL nohasharray
+mw_count_ntb_dev_ops_59352_fields mw_count ntb_dev_ops 0 59352 &r5l_write_super_and_discard_space_fndecl_59352_fields
+vsync_end_drm_display_mode_59355_fields vsync_end drm_display_mode 0 59355 NULL
+hpfs_alloc_fnode_fndecl_59356_fields hpfs_alloc_fnode fndecl 2 59356 NULL
+ie_len_cfg80211_assoc_request_59359_fields ie_len cfg80211_assoc_request 0 59359 NULL
+sys_mmap_fndecl_59360_fields sys_mmap fndecl 2 59360 NULL
+tid_iwl_mvm_ba_notif_59361_fields tid iwl_mvm_ba_notif 0 59361 NULL
+timer_bucket_i40iw_hmc_fpm_misc_59364_fields timer_bucket i40iw_hmc_fpm_misc 0 59364 NULL
+ixgbe_change_mtu_fndecl_59370_fields ixgbe_change_mtu fndecl 2 59370 NULL
+max_size_drm_vmw_get_3d_cap_arg_59378_fields max_size drm_vmw_get_3d_cap_arg 0 59378 NULL
+frag_point_sctp_association_59379_fields frag_point sctp_association 0 59379 NULL
+num_fcxp_reqs_bfa_iocfc_fwcfg_s_59383_fields num_fcxp_reqs bfa_iocfc_fwcfg_s 0 59383 NULL
+line_outs_auto_pin_cfg_59389_fields line_outs auto_pin_cfg 0 59389 NULL nohasharray
+sync_io_fndecl_59389_fields sync_io fndecl 0 59389 &line_outs_auto_pin_cfg_59389_fields
+batadv_iv_ogm_queue_add_fndecl_59398_fields batadv_iv_ogm_queue_add fndecl 3 59398 NULL
+fm_size_ubi_device_59399_fields fm_size ubi_device 0 59399 NULL
+max_tx_channels_efx_nic_59400_fields max_tx_channels efx_nic 0 59400 NULL
+drm_legacy_addmap_fndecl_59402_fields drm_legacy_addmap fndecl 3-2 59402 NULL
+btrfs_lookup_bio_sums_fndecl_59404_fields btrfs_lookup_bio_sums fndecl 0 59404 NULL
+alloc_mad_private_fndecl_59408_fields alloc_mad_private fndecl 1 59408 NULL
+elem_size_bpf_htab_59409_fields elem_size bpf_htab 0 59409 NULL
+reuseport_select_sock_fndecl_59410_fields reuseport_select_sock fndecl 4 59410 NULL nohasharray
+secure_dccpv6_sequence_number_fndecl_59410_fields secure_dccpv6_sequence_number fndecl 0 59410 &reuseport_select_sock_fndecl_59410_fields
+optlen_xfrm_mode_skb_cb_59411_fields optlen xfrm_mode_skb_cb 0 59411 NULL
+fotg210_urb_dequeue_fndecl_59414_fields fotg210_urb_dequeue fndecl 3 59414 NULL
+start_crash_mem_range_59421_fields start crash_mem_range 0 59421 NULL
+omfactor_user_sdma_request_59425_fields omfactor user_sdma_request 0 59425 NULL
+vma_adjust_fndecl_59429_fields vma_adjust fndecl 3-2-4 59429 NULL
+mmap_ureg_fndecl_59431_fields mmap_ureg fndecl 3 59431 NULL
+s_checkpoint_size_nilfs_super_block_59433_fields s_checkpoint_size nilfs_super_block 0 59433 NULL
+offset_ipfrag_skb_cb_59445_fields offset ipfrag_skb_cb 0 59445 NULL
+z2_zt_59452_fields z2 zt 0 59452 NULL
+ubi_dump_flash_fndecl_59454_fields ubi_dump_flash fndecl 4 59454 NULL
+vmbus_sendpacket_pagebuffer_fndecl_59463_fields vmbus_sendpacket_pagebuffer fndecl 5 59463 NULL
+ath6kl_wmi_mcast_filter_cmd_fndecl_59465_fields ath6kl_wmi_mcast_filter_cmd fndecl 2 59465 NULL
+_pmcraid_io_done_fndecl_59469_fields _pmcraid_io_done fndecl 2 59469 NULL
+common_ie_len_ieee80211_scan_ies_59478_fields common_ie_len ieee80211_scan_ies 0 59478 NULL
+phys_acpi_ioremap_59485_fields phys acpi_ioremap 0 59485 NULL
+i2c_hid_output_raw_report_fndecl_59486_fields i2c_hid_output_raw_report fndecl 3 59486 NULL
+length_acpi_pnp_device_id_59493_fields length acpi_pnp_device_id 0 59493 NULL
+src_addr_width_dma_slave_config_59497_fields src_addr_width dma_slave_config 0 59497 NULL
+wdata_alloc_and_fillpages_fndecl_59510_fields wdata_alloc_and_fillpages fndecl 1 59510 NULL
+rmtblkno2_xfs_da_args_59516_fields rmtblkno2 xfs_da_args 0 59516 NULL
+nilfs_commit_chunk_fndecl_59518_fields nilfs_commit_chunk fndecl 3-4 59518 NULL
+queue_length_vardecl_ua101_c_59524_fields queue_length vardecl_ua101.c 0 59524 NULL
+limit_data_queue_59525_fields limit data_queue 0 59525 NULL
+extLength_short_ad_59527_fields extLength short_ad 0 59527 NULL
+ocfs2_adjust_xattr_cross_cluster_fndecl_59528_fields ocfs2_adjust_xattr_cross_cluster fndecl 5-6 59528 NULL
+handle_ule_extensions_fndecl_59533_fields handle_ule_extensions fndecl 0 59533 NULL
+playback_snd_soc_tplg_pcm_59551_fields playback snd_soc_tplg_pcm 0 59551 NULL
+__btrfs_map_block_fndecl_59552_fields __btrfs_map_block fndecl 0 59552 NULL
+snd_pcm_oss_format_from_fndecl_59553_fields snd_pcm_oss_format_from fndecl 0 59553 NULL nohasharray
+nouveau_drm_ioctl_fndecl_59553_fields nouveau_drm_ioctl fndecl 2 59553 &snd_pcm_oss_format_from_fndecl_59553_fields
+pci_get_subsys_fndecl_59555_fields pci_get_subsys fndecl 2 59555 NULL nohasharray
+mthca_alloc_cq_buf_fndecl_59555_fields mthca_alloc_cq_buf fndecl 3 59555 &pci_get_subsys_fndecl_59555_fields
+rc_rcv_resp_fndecl_59556_fields rc_rcv_resp fndecl 9-7-8-4 59556 NULL
+rest_blocks_nilfs_write_info_59560_fields rest_blocks nilfs_write_info 0 59560 NULL
+chunk_size_disk_header_59563_fields chunk_size disk_header 0 59563 NULL
+bdx_rxdb_create_fndecl_59566_fields bdx_rxdb_create fndecl 1 59566 NULL
+fill_in_write_vector_fndecl_59569_fields fill_in_write_vector fndecl 0 59569 NULL
+unmap_mapping_range_fndecl_59573_fields unmap_mapping_range fndecl 2-3 59573 NULL
+pin_code_reply_fndecl_59581_fields pin_code_reply fndecl 4 59581 NULL
+data_mapping_root_thin_disk_superblock_59582_fields data_mapping_root thin_disk_superblock 0 59582 NULL
+length_sctp_paramhdr_59588_fields length sctp_paramhdr 0 59588 NULL
+reserved_tags_blk_mq_tag_set_59594_fields reserved_tags blk_mq_tag_set 0 59594 NULL
+bMaxPacketSize0_usb_device_descriptor_59595_fields bMaxPacketSize0 usb_device_descriptor 0 59595 NULL
+size_amd76xrom_window_59596_fields size amd76xrom_window 0 59596 NULL nohasharray
+last_sgs_total_ore_per_dev_state_59596_fields last_sgs_total ore_per_dev_state 0 59596 &size_amd76xrom_window_59596_fields
+tipc_link_create_fndecl_59597_fields tipc_link_create fndecl 6 59597 NULL
+rcvhdrqentsize_hfi1_ctxtdata_59613_fields rcvhdrqentsize hfi1_ctxtdata 0 59613 NULL
+unmap_single_vma_fndecl_59634_fields unmap_single_vma fndecl 4-3 59634 NULL
+gpio_count_tle62x0_pdata_59637_fields gpio_count tle62x0_pdata 0 59637 NULL
+q_fileoffset_xfs_dquot_59638_fields q_fileoffset xfs_dquot 0 59638 NULL
+trf7970a_transmit_fndecl_59648_fields trf7970a_transmit fndecl 3-5 59648 NULL
+SSID_len_brcmf_pno_net_info_le_59653_fields SSID_len brcmf_pno_net_info_le 0 59653 NULL
+xfs_trim_extents_fndecl_59654_fields xfs_trim_extents fndecl 2 59654 NULL
+num_subchannels_nvsp_5_subchannel_complete_59660_fields num_subchannels nvsp_5_subchannel_complete 0 59660 NULL
+fat_free_clusters_fndecl_59665_fields fat_free_clusters fndecl 2 59665 NULL
+mgmt_remote_name_fndecl_59667_fields mgmt_remote_name fndecl 7 59667 NULL nohasharray
+amdgpu_kms_compat_ioctl_fndecl_59667_fields amdgpu_kms_compat_ioctl fndecl 2 59667 &mgmt_remote_name_fndecl_59667_fields
+ipmi_pci_probe_regspacing_fndecl_59668_fields ipmi_pci_probe_regspacing fndecl 0 59668 NULL
+ms_read_bytes_fndecl_59672_fields ms_read_bytes fndecl 4 59672 NULL
+old_block_size_swap_info_struct_59674_fields old_block_size swap_info_struct 0 59674 NULL
+ata_host_alloc_fndecl_59677_fields ata_host_alloc fndecl 2 59677 NULL
+xprt_hlen_svc_deferred_req_59683_fields xprt_hlen svc_deferred_req 0 59683 NULL
+get_user_pages_fndecl_59686_fields get_user_pages fndecl 0-1 59686 NULL
+flt_region_bootload_ql82xx_hw_data_59701_fields flt_region_bootload ql82xx_hw_data 0 59701 NULL
+atalk_sendmsg_fndecl_59718_fields atalk_sendmsg fndecl 3 59718 NULL nohasharray
+aux_entry_sz_mlx4_dev_cap_59718_fields aux_entry_sz mlx4_dev_cap 0 59718 &atalk_sendmsg_fndecl_59718_fields
+dock_station_count_vardecl_dock_c_59728_fields dock_station_count vardecl_dock.c 0 59728 NULL
+nilfs_btnode_create_block_fndecl_59734_fields nilfs_btnode_create_block fndecl 2 59734 NULL
+val_i2400m_pld_59735_fields val i2400m_pld 0 59735 NULL
+offset_bts_phys_59741_fields offset bts_phys 0 59741 NULL
+l_iclog_hsize_xlog_59743_fields l_iclog_hsize xlog 0 59743 NULL
+ocfs2_read_dx_leaves_fndecl_59744_fields ocfs2_read_dx_leaves fndecl 2 59744 NULL
+nx_fw_cmd_set_phy_fndecl_59745_fields nx_fw_cmd_set_phy fndecl 3 59745 NULL
+mt_count_mtop_59746_fields mt_count mtop 0 59746 NULL
+seedsize_rng_alg_59748_fields seedsize rng_alg 0 59748 NULL
+xlog_write_calc_vec_length_fndecl_59749_fields xlog_write_calc_vec_length fndecl 0 59749 NULL
+request_size_afs_call_59750_fields request_size afs_call 0 59750 NULL
+addr_phys_netup_dma_59759_fields addr_phys netup_dma 0 59759 NULL
+mtu_dst_ops_59765_fields mtu dst_ops 0 59765 NULL
+au_cslack_rpc_auth_59766_fields au_cslack rpc_auth 0 59766 NULL
+max_wr_rxe_rq_59771_fields max_wr rxe_rq 0 59771 NULL
+tipc_msg_create_fndecl_59776_fields tipc_msg_create fndecl 4-3 59776 NULL
+osd_full_w_yuv_playback_info_59778_fields osd_full_w yuv_playback_info 0 59778 NULL
+reiserfs_new_symlink_fndecl_59783_fields reiserfs_new_symlink fndecl 6 59783 NULL nohasharray
+max_segments_queue_limits_59783_fields max_segments queue_limits 0 59783 &reiserfs_new_symlink_fndecl_59783_fields
+sdio_set_block_size_fndecl_59792_fields sdio_set_block_size fndecl 2 59792 NULL
+bandlength_Timon_table_entry_59793_fields bandlength Timon_table_entry 0 59793 NULL
+tm6000_i2c_recv_regs_fndecl_59796_fields tm6000_i2c_recv_regs fndecl 5 59796 NULL
+length_lv_59797_fields length lv 0 59797 NULL
+i2400m_op_msg_from_user_fndecl_59798_fields i2400m_op_msg_from_user fndecl 4 59798 NULL
+NumPhys__CONFIG_PAGE_SAS_IO_UNIT_0_59799_fields NumPhys _CONFIG_PAGE_SAS_IO_UNIT_0 0 59799 NULL nohasharray
+br_vlan_get_master_fndecl_59799_fields br_vlan_get_master fndecl 2 59799 &NumPhys__CONFIG_PAGE_SAS_IO_UNIT_0_59799_fields
+rcount_sixpack_59806_fields rcount sixpack 0 59806 NULL
+vcan_change_mtu_fndecl_59807_fields vcan_change_mtu fndecl 2 59807 NULL
+vmw_surface_gb_priv_define_fndecl_59811_fields vmw_surface_gb_priv_define fndecl 8 59811 NULL
+to_last_afs_writeback_59812_fields to_last afs_writeback 0 59812 NULL
+setup_sgtable_fndecl_59813_fields setup_sgtable fndecl 4 59813 NULL
+frsz_gspca_dev_59816_fields frsz gspca_dev 0 59816 NULL
+num_entries_arpt_replace_59819_fields num_entries arpt_replace 0 59819 NULL
+numpstates_pst_s_59820_fields numpstates pst_s 0 59820 NULL
+plen_hci_command_hdr_59837_fields plen hci_command_hdr 0 59837 NULL
+max_len_xc2028_ctrl_59842_fields max_len xc2028_ctrl 0 59842 NULL
+tcp_sendmsg_fastopen_fndecl_59843_fields tcp_sendmsg_fastopen fndecl 4 59843 NULL
+f2fs_fill_dentries_fndecl_59844_fields f2fs_fill_dentries fndecl 3 59844 NULL
+status_mei_cl_cb_59845_fields status mei_cl_cb 0 59845 NULL
+pep_alloc_skb_fndecl_59852_fields pep_alloc_skb fndecl 3 59852 NULL
+count_audit_chunk_59856_fields count audit_chunk 0 59856 NULL
+im_blkno_xfs_imap_59866_fields im_blkno xfs_imap 0 59866 NULL
+__process_changed_deleted_xattr_fndecl_59870_fields __process_changed_deleted_xattr fndecl 4 59870 NULL
+ide_scan_pio_blacklist_fndecl_59877_fields ide_scan_pio_blacklist fndecl 0 59877 NULL
+dx_fb_fillrect_59878_fields dx fb_fillrect 0 59878 NULL
+max_ars_out_nd_cmd_ars_cap_59879_fields max_ars_out nd_cmd_ars_cap 0 59879 NULL
+mos7720_write_fndecl_59901_fields mos7720_write fndecl 4 59901 NULL nohasharray
+rxbuffersize_rtl_pci_59901_fields rxbuffersize rtl_pci 0 59901 &mos7720_write_fndecl_59901_fields nohasharray
+xfs_xattr_set_fndecl_59901_fields xfs_xattr_set fndecl 6 59901 &rxbuffersize_rtl_pci_59901_fields
+num_gpio_wm831x_59907_fields num_gpio wm831x 0 59907 NULL
+x86_set_memory_region_fndecl_59911_fields x86_set_memory_region fndecl 4 59911 NULL
+wheel_num_ad714x_platform_data_59912_fields wheel_num ad714x_platform_data 0 59912 NULL
+qp_memcpy_from_queue_iov_fndecl_59913_fields qp_memcpy_from_queue_iov fndecl 5-4 59913 NULL
+rvmalloc_fndecl_59914_fields rvmalloc fndecl 1 59914 NULL
+video_endp_usb_usbvision_59918_fields video_endp usb_usbvision 0 59918 NULL
+nr_virtfn_bnx2x_sriov_59919_fields nr_virtfn bnx2x_sriov 0 59919 NULL
+wOverTheAirPacketSize_usb_wireless_ep_comp_descriptor_59926_fields wOverTheAirPacketSize usb_wireless_ep_comp_descriptor 0 59926 NULL
+n_user_regset_59935_fields n user_regset 0 59935 NULL
+maximum_acpi_address32_attribute_59936_fields maximum acpi_address32_attribute 0 59936 NULL
+blk_queue_max_write_same_sectors_fndecl_59954_fields blk_queue_max_write_same_sectors fndecl 2 59954 NULL
+bpl_cx25821_buffer_59964_fields bpl cx25821_buffer 0 59964 NULL
+pull_to_netfront_cb_59965_fields pull_to netfront_cb 0 59965 NULL
+acpi_os_create_cache_fndecl_59968_fields acpi_os_create_cache fndecl 2 59968 NULL
+mwifiex_set_wapi_ie_fndecl_59972_fields mwifiex_set_wapi_ie fndecl 3 59972 NULL
+calc_line_length_fndecl_59973_fields calc_line_length fndecl 0-3-2 59973 NULL
+fuse_file_fallocate_fndecl_59983_fields fuse_file_fallocate fndecl 4-3 59983 NULL nohasharray
+scrub_pages_fndecl_59983_fields scrub_pages fndecl 3-2-11-4 59983 &fuse_file_fallocate_fndecl_59983_fields
+affs_write_begin_ofs_fndecl_59991_fields affs_write_begin_ofs fndecl 3 59991 NULL
+count_drm_buf_desc_59998_fields count drm_buf_desc 0 59998 NULL
+size_fuse_arg_60001_fields size fuse_arg 0 60001 NULL
+__find_resource_fndecl_60011_fields __find_resource fndecl 4 60011 NULL nohasharray
+xfs_free_extent_fndecl_60011_fields xfs_free_extent fndecl 2-3 60011 &__find_resource_fndecl_60011_fields
+len_ubifs_ch_60014_fields len ubifs_ch 0 60014 NULL nohasharray
+flags_ata_port_info_60014_fields flags ata_port_info 0 60014 &len_ubifs_ch_60014_fields
+skb_priority_pktgen_dev_60015_fields skb_priority pktgen_dev 0 60015 NULL
+portnum_usb_device_60022_fields portnum usb_device 0 60022 NULL
+ntfs_truncate_fndecl_60026_fields ntfs_truncate fndecl 0 60026 NULL
+alloc_in_bmp_fndecl_60028_fields alloc_in_bmp fndecl 0-4-3-2 60028 NULL
+calculate_alignment_fndecl_60029_fields calculate_alignment fndecl 0-2 60029 NULL
+write_tx_buf_fndecl_60032_fields write_tx_buf fndecl 4 60032 NULL
+orangefs_bufmap_shift_query_fndecl_60035_fields orangefs_bufmap_shift_query fndecl 0 60035 NULL
+print_bad_pte_fndecl_60036_fields print_bad_pte fndecl 2 60036 NULL
+hdrlen_ip_auth_hdr_60037_fields hdrlen ip_auth_hdr 0 60037 NULL
+sel_write_bool_fndecl_60039_fields sel_write_bool fndecl 3 60039 NULL
+MaxMSIxVectors_mpt3sas_facts_60045_fields MaxMSIxVectors mpt3sas_facts 0 60045 NULL
+blk_rq_map_kern_fndecl_60047_fields blk_rq_map_kern fndecl 4 60047 NULL
+mgmt_pending_add_fndecl_60051_fields mgmt_pending_add fndecl 5 60051 NULL
+drm_atomic_helper_update_plane_fndecl_60059_fields drm_atomic_helper_update_plane fndecl 6-10-7-11 60059 NULL
+cx231xx_init_bulk_fndecl_60067_fields cx231xx_init_bulk fndecl 4-2 60067 NULL
+lpfc_hba_queue_depth_vardecl_lpfc_attr_c_60071_fields lpfc_hba_queue_depth vardecl_lpfc_attr.c 0 60071 NULL
+osd_req_encode_op_fndecl_60073_fields osd_req_encode_op fndecl 0 60073 NULL
+hpi_outstream_host_buffer_allocate_fndecl_60074_fields hpi_outstream_host_buffer_allocate fndecl 2 60074 NULL
+phys_eager_buffer_60082_fields phys eager_buffer 0 60082 NULL
+dram_offset_sst_res_info_60089_fields dram_offset sst_res_info 0 60089 NULL
+f2fs_issue_discard_fndecl_60090_fields f2fs_issue_discard fndecl 3-2 60090 NULL
+tty_audit_add_data_fndecl_60093_fields tty_audit_add_data fndecl 3 60093 NULL
+src_len_ccp_passthru_nomap_engine_60102_fields src_len ccp_passthru_nomap_engine 0 60102 NULL
+sample_rate_min_lola_60104_fields sample_rate_min lola 0 60104 NULL
+length_rio_transfer_io_60108_fields length rio_transfer_io 0 60108 NULL
+ufs_new_fragments_fndecl_60109_fields ufs_new_fragments fndecl 5-3 60109 NULL
+num_tx_bnad_60115_fields num_tx bnad 0 60115 NULL nohasharray
+raid10_find_virt_fndecl_60115_fields raid10_find_virt fndecl 0-3-2 60115 &num_tx_bnad_60115_fields
+display_height_vivid_dev_60116_fields display_height vivid_dev 0 60116 NULL
+ht_ast_vbios_enhtable_60121_fields ht ast_vbios_enhtable 0 60121 NULL
+btrfs_create_dio_extent_fndecl_60123_fields btrfs_create_dio_extent fndecl 3-2-7-6-5 60123 NULL
+vga_vram_end_vardecl_vgacon_c_60130_fields vga_vram_end vardecl_vgacon.c 0 60130 NULL
+st33zp24_spi_read8_reg_fndecl_60133_fields st33zp24_spi_read8_reg fndecl 4-0 60133 NULL
+fb_base_drm_mode_config_60135_fields fb_base drm_mode_config 0 60135 NULL
+external_rate_fndecl_60138_fields external_rate fndecl 0 60138 NULL
+data_len_ib_ucm_event_60142_fields data_len ib_ucm_event 0 60142 NULL
+scalar_len_ccp_ecc_point_math_60144_fields scalar_len ccp_ecc_point_math 0 60144 NULL
+index_drm_minor_60149_fields index drm_minor 0 60149 NULL
+skb_checksum_setup_ip_fndecl_60154_fields skb_checksum_setup_ip fndecl 3 60154 NULL
+dt_mem_next_cell_fndecl_60162_fields dt_mem_next_cell fndecl 0 60162 NULL
+drm_fb_helper_initial_config_fndecl_60163_fields drm_fb_helper_initial_config fndecl 2 60163 NULL nohasharray
+smem_start_fb_fix_screeninfo_60163_fields smem_start fb_fix_screeninfo 0 60163 &drm_fb_helper_initial_config_fndecl_60163_fields
+vscnprintf_fndecl_60170_fields vscnprintf fndecl 0 60170 NULL
+dccp_ackvec_buflen_fndecl_60177_fields dccp_ackvec_buflen fndecl 0 60177 NULL
+cc2520_write_ram_fndecl_60183_fields cc2520_write_ram fndecl 3 60183 NULL
+unlink1_fndecl_60188_fields unlink1 fndecl 3 60188 NULL
+ue_cpos_ocfs2_unwritten_extent_60192_fields ue_cpos ocfs2_unwritten_extent 0 60192 NULL
+kvm_vcpu_init_fndecl_60195_fields kvm_vcpu_init fndecl 3 60195 NULL
+esrt_efi_60200_fields esrt efi 0 60200 NULL
+submit_bh_fndecl_60202_fields submit_bh fndecl 0 60202 NULL nohasharray
+vfs_getxattr_alloc_fndecl_60202_fields vfs_getxattr_alloc fndecl 0 60202 &submit_bh_fndecl_60202_fields
+av7110_ipack_init_fndecl_60204_fields av7110_ipack_init fndecl 2 60204 NULL
+bio_advance_iter_fndecl_60205_fields bio_advance_iter fndecl 3 60205 NULL
+src_frames_snd_pcm_plugin_60210_fields src_frames snd_pcm_plugin 0 60210 NULL nohasharray
+iuu_read_buf_fndecl_60210_fields iuu_read_buf fndecl 2 60210 &src_frames_snd_pcm_plugin_60210_fields
+lpfc_fcp_io_channel_vardecl_lpfc_attr_c_60216_fields lpfc_fcp_io_channel vardecl_lpfc_attr.c 0 60216 NULL
+rmmio_base_radeon_device_60218_fields rmmio_base radeon_device 0 60218 NULL
+btusb_recv_bulk_fndecl_60219_fields btusb_recv_bulk fndecl 3 60219 NULL
+MaximumParallelCommands_DAC960_V2_ControllerInfo_60222_fields MaximumParallelCommands DAC960_V2_ControllerInfo 0 60222 NULL
+l2cap_parse_conf_rsp_fndecl_60232_fields l2cap_parse_conf_rsp fndecl 0 60232 NULL
+l2cap_create_le_flowctl_pdu_fndecl_60233_fields l2cap_create_le_flowctl_pdu fndecl 3 60233 NULL
+dlfb_alloc_urb_list_fndecl_60234_fields dlfb_alloc_urb_list fndecl 3 60234 NULL
+bttv_crop_adjust_fndecl_60236_fields bttv_crop_adjust fndecl 3-4 60236 NULL nohasharray
+irnet_connect_indication_fndecl_60236_fields irnet_connect_indication fndecl 5 60236 &bttv_crop_adjust_fndecl_60236_fields
+mwifiex_usb_host_to_card_fndecl_60239_fields mwifiex_usb_host_to_card fndecl 2 60239 NULL
+frag_len_pau_fpdu_frag_60242_fields frag_len pau_fpdu_frag 0 60242 NULL
+max_pages_per_fmr_ib_fmr_pool_param_60248_fields max_pages_per_fmr ib_fmr_pool_param 0 60248 NULL
+length_squashfs_page_actor_60249_fields length squashfs_page_actor 0 60249 NULL
+dirty_bytes_extent_io_tree_60254_fields dirty_bytes extent_io_tree 0 60254 NULL
+sector_size_jffs2_sb_info_60255_fields sector_size jffs2_sb_info 0 60255 NULL
+xenvif_change_mtu_fndecl_60258_fields xenvif_change_mtu fndecl 2 60258 NULL
+len_mwifiex_assoc_event_60259_fields len mwifiex_assoc_event 0 60259 NULL
+size_of_priv_dvb_usb_adapter_properties_60261_fields size_of_priv dvb_usb_adapter_properties 0 60261 NULL
+data_len_sym_ccb_60262_fields data_len sym_ccb 0 60262 NULL
+rotate_left_fndecl_60276_fields rotate_left fndecl 3-1 60276 NULL
+empty_dir_llseek_fndecl_60280_fields empty_dir_llseek fndecl 2 60280 NULL
+__receive_buf_fndecl_60286_fields __receive_buf fndecl 4 60286 NULL
+length_ore_per_dev_state_60287_fields length ore_per_dev_state 0 60287 NULL
+recv_actor_unix_stream_read_state_60306_fields recv_actor unix_stream_read_state 0 60306 NULL
+area_whcrc_60320_fields area whcrc 0 60320 NULL
+pnp_add_irq_resource_fndecl_60321_fields pnp_add_irq_resource fndecl 2 60321 NULL
+pg_count_nfs_pgio_mirror_60324_fields pg_count nfs_pgio_mirror 0 60324 NULL
+transfer_fndecl_60326_fields transfer fndecl 4-0 60326 NULL
+eor_jfs_log_60327_fields eor jfs_log 0 60327 NULL
+rq_addrlen_svc_rqst_60328_fields rq_addrlen svc_rqst 0 60328 NULL
+upper_vardecl_matroxfb_base_c_60329_fields upper vardecl_matroxfb_base.c 0 60329 NULL
+bd_add_to_bdi_fndecl_60336_fields bd_add_to_bdi fndecl 0-2 60336 NULL
+offset_nvkm_mem_60339_fields offset nvkm_mem 0 60339 NULL
+qib_rc_rcv_resp_fndecl_60341_fields qib_rc_rcv_resp fndecl 9-7-8-4 60341 NULL
+h_dloarea_60342_fields h dloarea 0 60342 NULL nohasharray
+raid5_compute_blocknr_fndecl_60342_fields raid5_compute_blocknr fndecl 0-2 60342 &h_dloarea_60342_fields
+pagesize_alauda_media_info_60348_fields pagesize alauda_media_info 0 60348 NULL
+setup_geo_fndecl_60351_fields setup_geo fndecl 0 60351 NULL nohasharray
+rq_wqe_shift_mlx5_ib_create_qp_60351_fields rq_wqe_shift mlx5_ib_create_qp 0 60351 &setup_geo_fndecl_60351_fields
+softback_lines_vardecl_fbcon_c_60357_fields softback_lines vardecl_fbcon.c 0 60357 NULL
+idd_bar0_ioc4_driver_data_60385_fields idd_bar0 ioc4_driver_data 0 60385 NULL
+s_inodes_per_group_ext4_super_block_60387_fields s_inodes_per_group ext4_super_block 0 60387 NULL
+acpi_dev_get_memresource_fndecl_60389_fields acpi_dev_get_memresource fndecl 3-2 60389 NULL
+count_tx_ring_60390_fields count tx_ring 0 60390 NULL
+block_in_file_dio_submit_60403_fields block_in_file dio_submit 0 60403 NULL
+btrfs_insert_empty_items_fndecl_60405_fields btrfs_insert_empty_items fndecl 6 60405 NULL
+max_vfs_vardecl_ixgbe_main_c_60408_fields max_vfs vardecl_ixgbe_main.c 0 60408 NULL
+xfs_iroot_realloc_fndecl_60409_fields xfs_iroot_realloc fndecl 2 60409 NULL
+__ocfs2_mknod_locked_fndecl_60427_fields __ocfs2_mknod_locked fndecl 8-9-10 60427 NULL
+__i2c_hid_command_fndecl_60442_fields __i2c_hid_command fndecl 6-8 60442 NULL
+minimum_cx88_ctrl_60444_fields minimum cx88_ctrl 0 60444 NULL
+digestsize_hash_alg_common_60446_fields digestsize hash_alg_common 0 60446 NULL
+count_hscx_hw_60448_fields count hscx_hw 0 60448 NULL
+lib80211_tkip_decrypt_fndecl_60450_fields lib80211_tkip_decrypt fndecl 2 60450 NULL
+maxsgentries_ctlr_info_60455_fields maxsgentries ctlr_info 0 60455 NULL
+osd_req_op_cls_request_data_pages_fndecl_60457_fields osd_req_op_cls_request_data_pages fndecl 4 60457 NULL
+clone_copy_inline_extent_fndecl_60461_fields clone_copy_inline_extent fndecl 7-6 60461 NULL
+prep_umr_wqe_common_fndecl_60470_fields prep_umr_wqe_common fndecl 5 60470 NULL
+drm_vma_offset_add_fndecl_60483_fields drm_vma_offset_add fndecl 3 60483 NULL nohasharray
+osd_left_vardecl_ivtvfb_c_60483_fields osd_left vardecl_ivtvfb.c 0 60483 &drm_vma_offset_add_fndecl_60483_fields
+lane2_associate_req_fndecl_60485_fields lane2_associate_req fndecl 4 60485 NULL
+v_nmembs_nilfs_argv_60498_fields v_nmembs nilfs_argv 0 60498 NULL
+cap_intel_iommu_60508_fields cap intel_iommu 0 60508 NULL
+n_host_mvs_chip_info_60517_fields n_host mvs_chip_info 0 60517 NULL
+b44_change_mtu_fndecl_60528_fields b44_change_mtu fndecl 2 60528 NULL
+hso_serial_write_fndecl_60530_fields hso_serial_write fndecl 3 60530 NULL
+sock_recv_errqueue_fndecl_60535_fields sock_recv_errqueue fndecl 3 60535 NULL
+qib_sdma_verbs_send_fndecl_60539_fields qib_sdma_verbs_send fndecl 3 60539 NULL
+device_size_scsi_transport_template_60546_fields device_size scsi_transport_template 0 60546 NULL nohasharray
+mic_card_map_fndecl_60546_fields mic_card_map fndecl 3-2 60546 &device_size_scsi_transport_template_60546_fields
+dma_tx_bytes_lpuart_port_60550_fields dma_tx_bytes lpuart_port 0 60550 NULL
+udp_manip_pkt_fndecl_60552_fields udp_manip_pkt fndecl 4 60552 NULL
+PSize_RxDesc_60553_fields PSize RxDesc 0 60553 NULL
+max_response_cros_ec_device_60558_fields max_response cros_ec_device 0 60558 NULL
+chr_major_ports_device_60572_fields chr_major ports_device 0 60572 NULL
+slot_dlm_member_60581_fields slot dlm_member 0 60581 NULL
+max_sge_rxe_rq_60583_fields max_sge rxe_rq 0 60583 NULL
+xfs_dir2_free_try_read_fndecl_60591_fields xfs_dir2_free_try_read fndecl 3 60591 NULL nohasharray
+vfcount_arch_specific_params_60591_fields vfcount arch_specific_params 0 60591 &xfs_dir2_free_try_read_fndecl_60591_fields
+assoclen_chachapoly_req_ctx_60596_fields assoclen chachapoly_req_ctx 0 60596 NULL
+in_size_ide_task_request_s_60603_fields in_size ide_task_request_s 0 60603 NULL
+__split_vma_fndecl_60609_fields __split_vma fndecl 3 60609 NULL
+fuse_ref_page_fndecl_60613_fields fuse_ref_page fndecl 4-3 60613 NULL nohasharray
+first_page_mpage_da_data_60613_fields first_page mpage_da_data 0 60613 &fuse_ref_page_fndecl_60613_fields
+qpc_entry_sz_mlx4_dev_cap_60618_fields qpc_entry_sz mlx4_dev_cap 0 60618 NULL
+dqi_usable_bs_qtree_mem_dqinfo_60619_fields dqi_usable_bs qtree_mem_dqinfo 0 60619 NULL
+copy_nocow_pages_fndecl_60628_fields copy_nocow_pages fndecl 3-5 60628 NULL
+initial_ssthresh_vardecl_tcp_bic_c_60630_fields initial_ssthresh vardecl_tcp_bic.c 0 60630 NULL
+num_tx_desc_iadev_priv_60636_fields num_tx_desc iadev_priv 0 60636 NULL nohasharray
+gso_size_skb_shared_info_60636_fields gso_size skb_shared_info 0 60636 &num_tx_desc_iadev_priv_60636_fields
+btrfs_new_extent_direct_fndecl_60642_fields btrfs_new_extent_direct fndecl 2 60642 NULL
+fill_snd_fw_async_midi_port_60647_fields fill snd_fw_async_midi_port 0 60647 NULL
+num_mpts_mthca_limits_60648_fields num_mpts mthca_limits 0 60648 NULL
+psi_count_xhci_hub_60651_fields psi_count xhci_hub 0 60651 NULL
+neo_map_video_fndecl_60656_fields neo_map_video fndecl 3 60656 NULL
+i_extra_isize_ext4_inode_info_60659_fields i_extra_isize ext4_inode_info 0 60659 NULL nohasharray
+__ax88179_read_cmd_fndecl_60659_fields __ax88179_read_cmd fndecl 5 60659 &i_extra_isize_ext4_inode_info_60659_fields
+eld_size_hdmi_eld_60661_fields eld_size hdmi_eld 0 60661 NULL
+secondary_head_adu_device_60665_fields secondary_head adu_device 0 60665 NULL
+cxd2820r_rd_regs_i2c_fndecl_60668_fields cxd2820r_rd_regs_i2c fndecl 5 60668 NULL
+pos_saa7164_user_buffer_60678_fields pos saa7164_user_buffer 0 60678 NULL
+ext4_dio_get_block_unwritten_async_fndecl_60679_fields ext4_dio_get_block_unwritten_async fndecl 2 60679 NULL
+MaxBufSize_lanman_neg_rsp_60693_fields MaxBufSize lanman_neg_rsp 0 60693 NULL nohasharray
+vnic_dev_mtu_fndecl_60693_fields vnic_dev_mtu fndecl 0 60693 &MaxBufSize_lanman_neg_rsp_60693_fields
+mon_bin_collate_isodesc_fndecl_60695_fields mon_bin_collate_isodesc fndecl 0 60695 NULL nohasharray
+remap_oldmem_pfn_range_fndecl_60695_fields remap_oldmem_pfn_range fndecl 3-4 60695 &mon_bin_collate_isodesc_fndecl_60695_fields
+max_size_vx_ibl_info_60702_fields max_size vx_ibl_info 0 60702 NULL
+snd_card_new_fndecl_60707_fields snd_card_new fndecl 2 60707 NULL
+sock_sendmsg_fndecl_60718_fields sock_sendmsg fndecl 0 60718 NULL
+HighPriorityCredit_mpt3sas_facts_60721_fields HighPriorityCredit mpt3sas_facts 0 60721 NULL
+reserved_pebs_ubi_volume_60725_fields reserved_pebs ubi_volume 0 60725 NULL
+cwnd_growth_factor_tcpnv_60728_fields cwnd_growth_factor tcpnv 0 60728 NULL
+splice_from_pipe_fndecl_60735_fields splice_from_pipe fndecl 4 60735 NULL nohasharray
+count_ptd_60735_fields count ptd 0 60735 &splice_from_pipe_fndecl_60735_fields
+__vlan_vid_del_fndecl_60738_fields __vlan_vid_del fndecl 3 60738 NULL
+ns_inode_size_the_nilfs_60742_fields ns_inode_size the_nilfs 0 60742 NULL nohasharray
+send_to_tty_fndecl_60742_fields send_to_tty fndecl 3 60742 &ns_inode_size_the_nilfs_60742_fields
+io_size_wdt_lpc_sch_info_60747_fields io_size_wdt lpc_sch_info 0 60747 NULL
+max_cluster_msdos_sb_info_60753_fields max_cluster msdos_sb_info 0 60753 NULL
+index_vardecl_intel8x0_c_60756_fields index vardecl_intel8x0.c 0 60756 NULL nohasharray
+index_hpi_adapter_obj_60756_fields index hpi_adapter_obj 0 60756 &index_vardecl_intel8x0_c_60756_fields
+chipshift_nand_flash_dev_60758_fields chipshift nand_flash_dev 0 60758 NULL
+jpg_bufsize_vardecl_60761_fields jpg_bufsize vardecl 0 60761 NULL
+devid_intel_lpss_60766_fields devid intel_lpss 0 60766 NULL
+base_ttm_bus_placement_60769_fields base ttm_bus_placement 0 60769 NULL
+i_block_group_ext2_inode_info_60771_fields i_block_group ext2_inode_info 0 60771 NULL
+blksize_shift_nvmet_ns_60777_fields blksize_shift nvmet_ns 0 60777 NULL
+a_channels_libipw_geo_60784_fields a_channels libipw_geo 0 60784 NULL nohasharray
+verity_hash_init_fndecl_60784_fields verity_hash_init fndecl 0 60784 &a_channels_libipw_geo_60784_fields
+length_blkpg_partition_60788_fields length blkpg_partition 0 60788 NULL
+x2_virtio_gpu_framebuffer_60789_fields x2 virtio_gpu_framebuffer 0 60789 NULL
+ocfs2_remove_inode_range_fndecl_60791_fields ocfs2_remove_inode_range fndecl 3-4 60791 NULL
+tomoyo_write_self_fndecl_60794_fields tomoyo_write_self fndecl 3 60794 NULL
+count_hdlc_hw_60796_fields count hdlc_hw 0 60796 NULL
+iso_alloc_urb_fndecl_60805_fields iso_alloc_urb fndecl 4-2-5 60805 NULL
+mpt_lan_change_mtu_fndecl_60806_fields mpt_lan_change_mtu fndecl 2 60806 NULL
+bytes_nand_ecc_ctrl_60817_fields bytes nand_ecc_ctrl 0 60817 NULL
+min_addr_nhlt_resource_desc_60819_fields min_addr nhlt_resource_desc 0 60819 NULL
+new_log_buf_len_vardecl_printk_c_60824_fields new_log_buf_len vardecl_printk.c 0 60824 NULL
+beacon_ies_len_cfg80211_beacon_data_60831_fields beacon_ies_len cfg80211_beacon_data 0 60831 NULL
+register_sound_dsp_fndecl_60835_fields register_sound_dsp fndecl 2 60835 NULL
+limit_fm10k_ring_feature_60843_fields limit fm10k_ring_feature 0 60843 NULL nohasharray
+bInterval_usb_endpoint_descriptor_60843_fields bInterval usb_endpoint_descriptor 0 60843 &limit_fm10k_ring_feature_60843_fields
+channels_max_snd_pcm_hardware_60854_fields channels_max snd_pcm_hardware 0 60854 NULL nohasharray
+ars_status_alloc_fndecl_60854_fields ars_status_alloc fndecl 2 60854 &channels_max_snd_pcm_hardware_60854_fields
+async_io_fndecl_60855_fields async_io fndecl 0 60855 NULL
+dev_priv_size_drm_driver_60870_fields dev_priv_size drm_driver 0 60870 NULL
+sectors_per_block_cache_60872_fields sectors_per_block cache 0 60872 NULL
+map_size_tpm_inf_dev_60880_fields map_size tpm_inf_dev 0 60880 NULL
+osd_y_offset_yuv_playback_info_60883_fields osd_y_offset yuv_playback_info 0 60883 NULL
+xenvif_add_frag_responses_fndecl_60886_fields xenvif_add_frag_responses fndecl 2 60886 NULL
+last_data_size_ubi_ainf_volume_60887_fields last_data_size ubi_ainf_volume 0 60887 NULL nohasharray
+do_shared_fault_fndecl_60887_fields do_shared_fault fndecl 2 60887 &last_data_size_ubi_ainf_volume_60887_fields
+btmrvl_send_sync_cmd_fndecl_60899_fields btmrvl_send_sync_cmd fndecl 4 60899 NULL
+bNrChannels_uac_input_terminal_descriptor_60901_fields bNrChannels uac_input_terminal_descriptor 0 60901 NULL
+xfs_alert_fsblock_zero_fndecl_60907_fields xfs_alert_fsblock_zero fndecl 0 60907 NULL
+xdr_shrink_bufhead_fndecl_60908_fields xdr_shrink_bufhead fndecl 2 60908 NULL
+gfs2_fiemap_fndecl_60913_fields gfs2_fiemap fndecl 4 60913 NULL
+ctrl_set_cropw_fndecl_60918_fields ctrl_set_cropw fndecl 3 60918 NULL
+blf_blkno_xfs_buf_log_format_60925_fields blf_blkno xfs_buf_log_format 0 60925 NULL
+read_ltv_hermes_ops_60939_fields read_ltv hermes_ops 0 60939 NULL
+x509_process_extension_fndecl_60941_fields x509_process_extension fndecl 5 60941 NULL
+msix_vector_count_MPT3SAS_ADAPTER_60944_fields msix_vector_count MPT3SAS_ADAPTER 0 60944 NULL
+ipv6_recv_rxpmtu_fndecl_60949_fields ipv6_recv_rxpmtu fndecl 3 60949 NULL
+__exchange_data_block_fndecl_60951_fields __exchange_data_block fndecl 4-3 60951 NULL nohasharray
+efi_memmap_hi_efi_info_60951_fields efi_memmap_hi efi_info 0 60951 &__exchange_data_block_fndecl_60951_fields
+prior_ssthresh_tcp_sock_60952_fields prior_ssthresh tcp_sock 0 60952 NULL nohasharray
+audit_make_reply_fndecl_60952_fields audit_make_reply fndecl 7 60952 &prior_ssthresh_tcp_sock_60952_fields
+ocfs2_dx_dir_new_cluster_fndecl_60953_fields ocfs2_dx_dir_new_cluster fndecl 3 60953 NULL
+xfs_alloc_ioend_fndecl_60954_fields xfs_alloc_ioend fndecl 3 60954 NULL nohasharray
+s_partition_root_udf_part_map_60954_fields s_partition_root udf_part_map 0 60954 &xfs_alloc_ioend_fndecl_60954_fields
+get_rdac_req_fndecl_60969_fields get_rdac_req fndecl 3 60969 NULL
+tx_remainder_cdc_ncm_ctx_60973_fields tx_remainder cdc_ncm_ctx 0 60973 NULL
+xfs_extent_busy_update_extent_fndecl_60975_fields xfs_extent_busy_update_extent fndecl 5-4 60975 NULL
+hcs_params1_xhci_hcd_60979_fields hcs_params1 xhci_hcd 0 60979 NULL
+count_nvif_ioctl_sclass_v0_60980_fields count nvif_ioctl_sclass_v0 0 60980 NULL
+hfi1_lkey_table_size_vardecl_verbs_c_60988_fields hfi1_lkey_table_size vardecl_verbs.c 0 60988 NULL
+weight_dlm_member_60989_fields weight dlm_member 0 60989 NULL nohasharray
+first_block_migrate_struct_60989_fields first_block migrate_struct 0 60989 &weight_dlm_member_60989_fields
+rtl8152_change_mtu_fndecl_60996_fields rtl8152_change_mtu fndecl 2 60996 NULL
+endp_out_zd1201_61001_fields endp_out zd1201 0 61001 NULL
+ocfs2_xattr_block_find_fndecl_61008_fields ocfs2_xattr_block_find fndecl 0 61008 NULL
+size_page_frag_61029_fields size page_frag 0 61029 NULL
+setup_possible_cpus_vardecl_smpboot_c_61040_fields setup_possible_cpus vardecl_smpboot.c 0 61040 NULL nohasharray
+ath6kl_wmi_listeninterval_cmd_fndecl_61040_fields ath6kl_wmi_listeninterval_cmd fndecl 2 61040 &setup_possible_cpus_vardecl_smpboot_c_61040_fields
+nports1_adapter_info_61044_fields nports1 adapter_info 0 61044 NULL
+_dln2_transfer_fndecl_61049_fields _dln2_transfer fndecl 0 61049 NULL
+len_tcp_fastopen_cookie_61053_fields len tcp_fastopen_cookie 0 61053 NULL
+regmap_encx24j600_read_fndecl_61061_fields regmap_encx24j600_read fndecl 5 61061 NULL
+ezusb_writememory_fndecl_61067_fields ezusb_writememory fndecl 4 61067 NULL
+get_rx_packet_len_wlcore_ops_61070_fields get_rx_packet_len wlcore_ops 0 61070 NULL
+untag_qdepth_blogic_adapter_61071_fields untag_qdepth blogic_adapter 0 61071 NULL
+left_v4l2_rect_61093_fields left v4l2_rect 0 61093 NULL
+snd_hdac_exec_verb_fndecl_61100_fields snd_hdac_exec_verb fndecl 0 61100 NULL
+current_write_offset_scif_rb_61107_fields current_write_offset scif_rb 0 61107 NULL
+bv_offset_bio_vec_61109_fields bv_offset bio_vec 0 61109 NULL
+tcp_adjust_fackets_out_fndecl_61118_fields tcp_adjust_fackets_out fndecl 3 61118 NULL nohasharray
+max_nch_mlx5e_profile_61118_fields max_nch mlx5e_profile 0 61118 &tcp_adjust_fackets_out_fndecl_61118_fields
+blocknr_nilfs_write_info_61124_fields blocknr nilfs_write_info 0 61124 NULL
+insert_node_fndecl_61132_fields insert_node fndecl 3-4 61132 NULL
+ore_calc_stripe_info_fndecl_61140_fields ore_calc_stripe_info fndecl 3 61140 NULL
+display_byte_stride_osd_info_61141_fields display_byte_stride osd_info 0 61141 NULL
+__access_remote_vm_fndecl_61148_fields __access_remote_vm fndecl 5-0-3 61148 NULL
+sierra_setup_urb_fndecl_61150_fields sierra_setup_urb fndecl 3-2 61150 NULL
+slhc_toss_fndecl_61153_fields slhc_toss fndecl 0 61153 NULL
+ctl_mt7601u_rxwi_61155_fields ctl mt7601u_rxwi 0 61155 NULL
+__vmalloc_node_range_fndecl_61157_fields __vmalloc_node_range fndecl 3 61157 NULL
+addr_kcore_list_61158_fields addr kcore_list 0 61158 NULL
+ceph_locks_to_pagelist_fndecl_61162_fields ceph_locks_to_pagelist fndecl 3-4 61162 NULL
+sel_commit_bools_write_fndecl_61166_fields sel_commit_bools_write fndecl 3 61166 NULL
+ftdi_elan_edset_empty_fndecl_61170_fields ftdi_elan_edset_empty fndecl 0 61170 NULL nohasharray
+lldd_execute_task_sas_domain_function_template_61170_fields lldd_execute_task sas_domain_function_template 0 61170 &ftdi_elan_edset_empty_fndecl_61170_fields
+in_length_nd_cmd_vendor_hdr_61172_fields in_length nd_cmd_vendor_hdr 0 61172 NULL
+phys_memory_base__synclinkmp_info_61174_fields phys_memory_base _synclinkmp_info 0 61174 NULL
+pvr2_buffer_set_buffer_fndecl_61176_fields pvr2_buffer_set_buffer fndecl 3 61176 NULL
+register_sound_mixer_fndecl_61179_fields register_sound_mixer fndecl 2 61179 NULL
+__ocfs2_move_extent_fndecl_61183_fields __ocfs2_move_extent fndecl 4-5-6-3 61183 NULL
+osd_req_op_extent_init_fndecl_61188_fields osd_req_op_extent_init fndecl 5 61188 NULL
+allocated_vector_iwl_trans_pcie_61194_fields allocated_vector iwl_trans_pcie 0 61194 NULL nohasharray
+channels_vendor_data_61194_fields channels vendor_data 0 61194 &allocated_vector_iwl_trans_pcie_61194_fields
+pos_dir_context_61195_fields pos dir_context 0 61195 NULL nohasharray
+rdma_set_ib_paths_fndecl_61195_fields rdma_set_ib_paths fndecl 3 61195 &pos_dir_context_61195_fields
+port_id_ssp_device_61196_fields port_id ssp_device 0 61196 NULL
+size_bcma_sflash_61197_fields size bcma_sflash 0 61197 NULL
+num_qps_mthca_limits_61203_fields num_qps mthca_limits 0 61203 NULL nohasharray
+pxa2xx_spi_dma_prepare_fndecl_61203_fields pxa2xx_spi_dma_prepare fndecl 0 61203 &num_qps_mthca_limits_61203_fields
+parsed_tag_70_packet_size_ecryptfs_parse_tag_70_packet_silly_stack_61204_fields parsed_tag_70_packet_size ecryptfs_parse_tag_70_packet_silly_stack 0 61204 NULL
+ts_nr_packets_vardecl_saa7134_ts_c_61205_fields ts_nr_packets vardecl_saa7134-ts.c 0 61205 NULL
+audit_log_n_hex_fndecl_61218_fields audit_log_n_hex fndecl 3 61218 NULL
+rx_buffersize_b43_dmaring_61223_fields rx_buffersize b43_dmaring 0 61223 NULL nohasharray
+rmtblkcnt_xfs_da_args_61223_fields rmtblkcnt xfs_da_args 0 61223 &rx_buffersize_b43_dmaring_61223_fields nohasharray
+register_chrdev_region_fndecl_61223_fields register_chrdev_region fndecl 2-1 61223 &rmtblkcnt_xfs_da_args_61223_fields
+rx_tail_len_pn533_frame_ops_61226_fields rx_tail_len pn533_frame_ops 0 61226 NULL
+resource_clip_fndecl_61231_fields resource_clip fndecl 2-3 61231 NULL
+isert_rx_opcode_fndecl_61234_fields isert_rx_opcode fndecl 4-6 61234 NULL
+tcp_illinois_cong_avoid_fndecl_61238_fields tcp_illinois_cong_avoid fndecl 3 61238 NULL nohasharray
+max_data_pkt_payload_size_nci_rf_intf_activated_ntf_61238_fields max_data_pkt_payload_size nci_rf_intf_activated_ntf 0 61238 &tcp_illinois_cong_avoid_fndecl_61238_fields
+tipc_add_tlv_fndecl_61239_fields tipc_add_tlv fndecl 4 61239 NULL
+ext4_reserve_inode_write_fndecl_61253_fields ext4_reserve_inode_write fndecl 0 61253 NULL
+b_blocknr_buffer_head_61260_fields b_blocknr buffer_head 0 61260 NULL
+key_create_or_update_fndecl_61266_fields key_create_or_update fndecl 5 61266 NULL
+split_boundary_dm_origin_61269_fields split_boundary dm_origin 0 61269 NULL
+__filemap_fdatawait_range_fndecl_61278_fields __filemap_fdatawait_range fndecl 0 61278 NULL
+len_ubifs_zbranch_61279_fields len ubifs_zbranch 0 61279 NULL
+h_minimode_61280_fields h minimode 0 61280 NULL
+i_file_acl_ext4_inode_info_61282_fields i_file_acl ext4_inode_info 0 61282 NULL
+ieee80211_amsdu_realloc_pad_fndecl_61288_fields ieee80211_amsdu_realloc_pad fndecl 3 61288 NULL nohasharray
+smk_write_ambient_fndecl_61288_fields smk_write_ambient fndecl 3 61288 &ieee80211_amsdu_realloc_pad_fndecl_61288_fields
+dataSgeOffset_mpt_ioctl_command_61289_fields dataSgeOffset mpt_ioctl_command 0 61289 NULL
+jpg_nbufs_vardecl_61299_fields jpg_nbufs vardecl 0 61299 NULL
+fat_length_fat_floppy_defaults_61308_fields fat_length fat_floppy_defaults 0 61308 NULL
+wlcore_smart_config_decode_event_fndecl_61313_fields wlcore_smart_config_decode_event fndecl 2-4 61313 NULL
+rtl2830_regmap_write_fndecl_61335_fields rtl2830_regmap_write fndecl 3 61335 NULL
+wbuf_len_jffs2_sb_info_61340_fields wbuf_len jffs2_sb_info 0 61340 NULL
+iscsit_put_login_tx_fndecl_61345_fields iscsit_put_login_tx fndecl 3 61345 NULL
+rw_copy_check_uvector_fndecl_61351_fields rw_copy_check_uvector fndecl 0 61351 NULL nohasharray
+vb2_vmalloc_alloc_fndecl_61351_fields vb2_vmalloc_alloc fndecl 3 61351 &rw_copy_check_uvector_fndecl_61351_fields nohasharray
+v4l2_ctrl_new_std_fndecl_61351_fields v4l2_ctrl_new_std fndecl 4-7 61351 &vb2_vmalloc_alloc_fndecl_61351_fields
+conn_num_hci_conn_list_req_61354_fields conn_num hci_conn_list_req 0 61354 NULL
+hfs_get_block_fndecl_61360_fields hfs_get_block fndecl 2 61360 NULL
+handle_response_icmp_fndecl_61366_fields handle_response_icmp fndecl 7 61366 NULL
+tx_headroom_libipw_device_61370_fields tx_headroom libipw_device 0 61370 NULL
+sync_dirty_buffer_fndecl_61371_fields sync_dirty_buffer fndecl 0 61371 NULL
+data_dma_usb_onetouch_61372_fields data_dma usb_onetouch 0 61372 NULL
+num_of_phy_chans_stedma40_platform_data_61373_fields num_of_phy_chans stedma40_platform_data 0 61373 NULL
+devs_max_btrfs_raid_attr_61376_fields devs_max btrfs_raid_attr 0 61376 NULL
+bfa_cb_ioim_done_fndecl_61381_fields bfa_cb_ioim_done fndecl 7 61381 NULL
+xfs_dir3_data_read_fndecl_61387_fields xfs_dir3_data_read fndecl 3 61387 NULL
+num_msix_vectors_i40evf_adapter_61390_fields num_msix_vectors i40evf_adapter 0 61390 NULL nohasharray
+npages_nfs_page_array_61390_fields npages nfs_page_array 0 61390 &num_msix_vectors_i40evf_adapter_61390_fields
+byte_len_at24_platform_data_61393_fields byte_len at24_platform_data 0 61393 NULL
+fpg_sz_nvm_id_group_61394_fields fpg_sz nvm_id_group 0 61394 NULL
+h_virtio_gpu_box_61407_fields h virtio_gpu_box 0 61407 NULL
+buf_sz_vardecl_stmmac_main_c_61408_fields buf_sz vardecl_stmmac_main.c 0 61408 NULL
+pcpu_alloc_alloc_info_fndecl_61414_fields pcpu_alloc_alloc_info fndecl 1-2 61414 NULL nohasharray
+keylen_tcp_md5sig_key_61414_fields keylen tcp_md5sig_key 0 61414 &pcpu_alloc_alloc_info_fndecl_61414_fields
+size_aper_size_info_lvl2_61417_fields size aper_size_info_lvl2 0 61417 NULL
+nservers_mc5_params_61428_fields nservers mc5_params 0 61428 NULL nohasharray
+tst_size_idt77252_dev_61428_fields tst_size idt77252_dev 0 61428 &nservers_mc5_params_61428_fields
+offset_ceph_mds_reply_dir_entry_61431_fields offset ceph_mds_reply_dir_entry 0 61431 NULL
+length_drm_mode_create_blob_61435_fields length drm_mode_create_blob 0 61435 NULL nohasharray
+rows_omap4_keypad_61435_fields rows omap4_keypad 0 61435 &length_drm_mode_create_blob_61435_fields
+nd_opt_len_nd_opt_hdr_61437_fields nd_opt_len nd_opt_hdr 0 61437 NULL
+nsblk_sector_size_fndecl_61439_fields nsblk_sector_size fndecl 0 61439 NULL
+group_size_efs_sb_info_61441_fields group_size efs_sb_info 0 61441 NULL
+bulk_out_size_usb_serial_driver_61450_fields bulk_out_size usb_serial_driver 0 61450 NULL
+total_size_iscsi_segment_61454_fields total_size iscsi_segment 0 61454 NULL
+ocfs2_zero_range_for_truncate_fndecl_61461_fields ocfs2_zero_range_for_truncate fndecl 3-4 61461 NULL nohasharray
+next_interface_id_usb_configuration_61461_fields next_interface_id usb_configuration 0 61461 &ocfs2_zero_range_for_truncate_fndecl_61461_fields
+ucNumEntries__ATOM_Tonga_MM_Dependency_Table_61467_fields ucNumEntries _ATOM_Tonga_MM_Dependency_Table 0 61467 NULL
+irlan_client_ctrl_connect_confirm_fndecl_61475_fields irlan_client_ctrl_connect_confirm fndecl 5 61475 NULL
+ubi_eba_write_leb_st_fndecl_61476_fields ubi_eba_write_leb_st fndecl 5 61476 NULL
+buf_kern_offset_ebt_entries_buf_state_61478_fields buf_kern_offset ebt_entries_buf_state 0 61478 NULL
+dreq_iss_dccp_request_sock_61480_fields dreq_iss dccp_request_sock 0 61480 NULL
+radix_tree_maybe_preload_fndecl_61481_fields radix_tree_maybe_preload fndecl 0 61481 NULL nohasharray
+s_size_rvt_qp_61481_fields s_size rvt_qp 0 61481 &radix_tree_maybe_preload_fndecl_61481_fields
+new_chunk_mdp_superblock_s_61482_fields new_chunk mdp_superblock_s 0 61482 NULL
+nlen_ubifs_dent_node_61488_fields nlen ubifs_dent_node 0 61488 NULL
+generic_file_read_iter_fndecl_61491_fields generic_file_read_iter fndecl 0 61491 NULL
+f_adc_hackrf_dev_61493_fields f_adc hackrf_dev 0 61493 NULL
+ccp_init_data_fndecl_61495_fields ccp_init_data fndecl 4 61495 NULL
+unpack_lookup_result_fndecl_61496_fields unpack_lookup_result fndecl 2 61496 NULL
+vb_size_drm_savage_cmdbuf_61501_fields vb_size drm_savage_cmdbuf 0 61501 NULL
+mgag200_gem_create_fndecl_61507_fields mgag200_gem_create fndecl 2 61507 NULL nohasharray
+width_pwc_device_61507_fields width pwc_device 0 61507 &mgag200_gem_create_fndecl_61507_fields
+depth_cx8800_fmt_61510_fields depth cx8800_fmt 0 61510 NULL
+total_sect_fat_boot_sector_61513_fields total_sect fat_boot_sector 0 61513 NULL
+sys_write_fndecl_61526_fields sys_write fndecl 3-0 61526 NULL
+scif_register_temp_fndecl_61529_fields scif_register_temp fndecl 3-2 61529 NULL
+irq_base_regmap_irq_chip_data_61532_fields irq_base regmap_irq_chip_data 0 61532 NULL
+strlcpy_fndecl_61539_fields strlcpy fndecl 0 61539 NULL
+osst_do_scsi_fndecl_61545_fields osst_do_scsi fndecl 4 61545 NULL
+intel_init_pipe_control_fndecl_61547_fields intel_init_pipe_control fndecl 2 61547 NULL
+gpiointr_intel_pmic_gpio_platform_data_61549_fields gpiointr intel_pmic_gpio_platform_data 0 61549 NULL
+reg_size_rmi_register_desc_item_61553_fields reg_size rmi_register_desc_item 0 61553 NULL
+datalen_iscsi_tcp_recv_61556_fields datalen iscsi_tcp_recv 0 61556 NULL
+xdr_init_decode_pages_fndecl_61557_fields xdr_init_decode_pages fndecl 4 61557 NULL nohasharray
+regmap_encx24j600_sfr_update_fndecl_61557_fields regmap_encx24j600_sfr_update fndecl 4 61557 &xdr_init_decode_pages_fndecl_61557_fields
+ei_block_ext4_extent_idx_61567_fields ei_block ext4_extent_idx 0 61567 NULL
+iwl_fill_data_tbs_amsdu_fndecl_61581_fields iwl_fill_data_tbs_amsdu fndecl 4 61581 NULL
+pos_in_item_tree_balance_61583_fields pos_in_item tree_balance 0 61583 NULL
+usb_internal_control_msg_fndecl_61589_fields usb_internal_control_msg fndecl 5-2 61589 NULL
+blkdev_issue_write_same_fndecl_61596_fields blkdev_issue_write_same fndecl 2-3 61596 NULL
+hdisplay_moderec_61597_fields hdisplay moderec 0 61597 NULL
+__hci_cmd_sync_fndecl_61598_fields __hci_cmd_sync fndecl 3 61598 NULL
+ext4_max_size_fndecl_61600_fields ext4_max_size fndecl 0-1 61600 NULL
+i2c_base_intel_scu_ipc_pdata_t_61609_fields i2c_base intel_scu_ipc_pdata_t 0 61609 NULL
+head_align_brcmf_sdio_61610_fields head_align brcmf_sdio 0 61610 NULL nohasharray
+filternum_dvb_demux_61610_fields filternum dvb_demux 0 61610 &head_align_brcmf_sdio_61610_fields
+extra_priv_size_ohci_driver_overrides_61611_fields extra_priv_size ohci_driver_overrides 0 61611 NULL
+eth_change_mtu_fndecl_61617_fields eth_change_mtu fndecl 2 61617 NULL
+add_sit_entry_fndecl_61621_fields add_sit_entry fndecl 1 61621 NULL
+af_alg_make_sg_fndecl_61624_fields af_alg_make_sg fndecl 0-3 61624 NULL
+efx_tx_max_skb_descs_fndecl_61628_fields efx_tx_max_skb_descs fndecl 0 61628 NULL
+ext4_xattr_shift_entries_fndecl_61629_fields ext4_xattr_shift_entries fndecl 2 61629 NULL
+___alloc_bootmem_node_nopanic_fndecl_61630_fields ___alloc_bootmem_node_nopanic fndecl 3-4-5 61630 NULL
+bio_advance_fndecl_61635_fields bio_advance fndecl 2 61635 NULL
+btrfsic_process_written_block_fndecl_61638_fields btrfsic_process_written_block fndecl 2 61638 NULL
+index_count_applesmc_registers_61647_fields index_count applesmc_registers 0 61647 NULL nohasharray
+vc_bottom_vc_data_61647_fields vc_bottom vc_data 0 61647 &index_count_applesmc_registers_61647_fields nohasharray
+sci_req_tx_bytes_fndecl_61647_fields sci_req_tx_bytes fndecl 0 61647 &vc_bottom_vc_data_61647_fields
+dout_size_cros_ec_device_61649_fields dout_size cros_ec_device 0 61649 NULL
+height_cx23885_dev_61651_fields height cx23885_dev 0 61651 NULL
+mem_start_pci_params_61652_fields mem_start pci_params 0 61652 NULL
+security_socket_sendmsg_fndecl_61654_fields security_socket_sendmsg fndecl 0 61654 NULL
+anode_lookup_fndecl_61656_fields anode_lookup fndecl 0-3-2 61656 NULL
+sdio_align_size_fndecl_61658_fields sdio_align_size fndecl 2 61658 NULL
+sk_pacing_rate_sock_61667_fields sk_pacing_rate sock 0 61667 NULL
+min_io_size_ubi_device_info_61673_fields min_io_size ubi_device_info 0 61673 NULL
+recv_queue_size_nvmet_rdma_queue_61674_fields recv_queue_size nvmet_rdma_queue 0 61674 NULL nohasharray
+sys_msgsnd_fndecl_61674_fields sys_msgsnd fndecl 3 61674 &recv_queue_size_nvmet_rdma_queue_61674_fields
+len_l2cap_cmd_hdr_61676_fields len l2cap_cmd_hdr 0 61676 NULL
+sd_fsb2bb_shift_gfs2_sbd_61677_fields sd_fsb2bb_shift gfs2_sbd 0 61677 NULL
+page_size_ms_boot_attr_info_61681_fields page_size ms_boot_attr_info 0 61681 NULL
+sv_max_mesg_svc_serv_61683_fields sv_max_mesg svc_serv 0 61683 NULL
+ip_clusters_ocfs2_inode_info_61689_fields ip_clusters ocfs2_inode_info 0 61689 NULL
+cma_set_req_event_data_fndecl_61691_fields cma_set_req_event_data fndecl 4 61691 NULL
+ieee80211_rx_mgmt_assoc_resp_fndecl_61694_fields ieee80211_rx_mgmt_assoc_resp fndecl 3 61694 NULL
+qib_ud_rcv_fndecl_61701_fields qib_ud_rcv fndecl 5 61701 NULL
+segnum_nilfs_segment_entry_61704_fields segnum nilfs_segment_entry 0 61704 NULL
+hfi1_cdev_init_fndecl_61706_fields hfi1_cdev_init fndecl 1 61706 NULL
+find_key_fndecl_61711_fields find_key fndecl 2 61711 NULL
+BytesPerSector_ms_lib_ctrl_61717_fields BytesPerSector ms_lib_ctrl 0 61717 NULL
+do_lfb_size_fndecl_61720_fields do_lfb_size fndecl 0 61720 NULL
+dm_bufio_new_fndecl_61727_fields dm_bufio_new fndecl 2 61727 NULL
+n_patterns_cfg80211_wowlan_61737_fields n_patterns cfg80211_wowlan 0 61737 NULL
+nvkm_disp_ctor_fndecl_61743_fields nvkm_disp_ctor fndecl 4 61743 NULL
+wmi_call_fndecl_61745_fields wmi_call fndecl 4 61745 NULL nohasharray
+count_nfs_pgio_args_61745_fields count nfs_pgio_args 0 61745 &wmi_call_fndecl_61745_fields
+drbd_recv_short_fndecl_61748_fields drbd_recv_short fndecl 3-0 61748 NULL nohasharray
+smt_add_frame_len_fndecl_61748_fields smt_add_frame_len fndecl 2 61748 &drbd_recv_short_fndecl_61748_fields
+mon_buff_area_alloc_fndecl_61752_fields mon_buff_area_alloc fndecl 2 61752 NULL
+nr_fingers_f11_2d_sensor_queries_61756_fields nr_fingers f11_2d_sensor_queries 0 61756 NULL
+sl_count_ip_sf_socklist_61758_fields sl_count ip_sf_socklist 0 61758 NULL
+rsp_residual_count_sts_entry_24xx_61762_fields rsp_residual_count sts_entry_24xx 0 61762 NULL
+dvb_net_sec_callback_fndecl_61767_fields dvb_net_sec_callback fndecl 2 61767 NULL
+height_zr364xx_camera_61781_fields height zr364xx_camera 0 61781 NULL nohasharray
+xlog_recover_add_to_cont_trans_fndecl_61781_fields xlog_recover_add_to_cont_trans fndecl 4 61781 &height_zr364xx_camera_61781_fields
+num_leds_adp8870_backlight_platform_data_61782_fields num_leds adp8870_backlight_platform_data 0 61782 NULL
+pclk_max_ov6650_61784_fields pclk_max ov6650 0 61784 NULL
+xdr_enter_page_fndecl_61791_fields xdr_enter_page fndecl 2 61791 NULL
+num_gpios_htcpld_chip_platform_data_61792_fields num_gpios htcpld_chip_platform_data 0 61792 NULL
+address_length_pcc_memory_resource_61793_fields address_length pcc_memory_resource 0 61793 NULL
+num_arfs_vnic_enet_config_61794_fields num_arfs vnic_enet_config 0 61794 NULL
+size_snd_cs46xx_region_61796_fields size snd_cs46xx_region 0 61796 NULL
+vxfs_bmap_typed_fndecl_61801_fields vxfs_bmap_typed fndecl 0-2 61801 NULL
+imm_count_iscsi_task_61804_fields imm_count iscsi_task 0 61804 NULL
+end_map_range_61813_fields end map_range 0 61813 NULL nohasharray
+fat_alloc_clusters_fndecl_61813_fields fat_alloc_clusters fndecl 0 61813 &end_map_range_61813_fields
+len_nfs_createargs_61814_fields len nfs_createargs 0 61814 NULL
+m_rsumsize_xfs_mount_61815_fields m_rsumsize xfs_mount 0 61815 NULL
+txq_req_tg3_61834_fields txq_req tg3 0 61834 NULL
+start_segno_free_segmap_info_61843_fields start_segno free_segmap_info 0 61843 NULL
+ocfs2_xattr_bucket_find_fndecl_61853_fields ocfs2_xattr_bucket_find fndecl 0-5 61853 NULL
+sents_per_block_sit_info_61856_fields sents_per_block sit_info 0 61856 NULL
+dma_len_rx_fst_card_info_61862_fields dma_len_rx fst_card_info 0 61862 NULL
+num_mpts_mlx4_caps_61866_fields num_mpts mlx4_caps 0 61866 NULL
+ehci_urb_done_fndecl_61889_fields ehci_urb_done fndecl 3 61889 NULL
+find_group_orlov_fndecl_61896_fields find_group_orlov fndecl 0 61896 NULL
+MaxRecvDataSegmentLength_iscsi_conn_ops_61904_fields MaxRecvDataSegmentLength iscsi_conn_ops 0 61904 NULL
+maxframe_size_fc_rport_61909_fields maxframe_size fc_rport 0 61909 NULL
+send_data_in_fndecl_61914_fields send_data_in fndecl 3 61914 NULL
+cxd2820r_wr_regs_i2c_fndecl_61922_fields cxd2820r_wr_regs_i2c fndecl 5 61922 NULL
+raid_disks_mdp_superblock_1_61927_fields raid_disks mdp_superblock_1 0 61927 NULL
+net2272_ep_read_fndecl_61935_fields net2272_ep_read fndecl 0 61935 NULL
+st33zp24_i2c_recv_fndecl_61939_fields st33zp24_i2c_recv fndecl 4 61939 NULL
+alloc_size_ttm_pool_opts_61945_fields alloc_size ttm_pool_opts 0 61945 NULL
+btrfs_double_extent_lock_fndecl_61946_fields btrfs_double_extent_lock fndecl 4-2-5 61946 NULL
+rx_std_ring_mask_tg3_61948_fields rx_std_ring_mask tg3 0 61948 NULL
+pfid_bnx2x_61952_fields pfid bnx2x 0 61952 NULL
+num_qps_qed_rdma_pf_params_61953_fields num_qps qed_rdma_pf_params 0 61953 NULL
+tcp_veno_cong_avoid_fndecl_61954_fields tcp_veno_cong_avoid fndecl 3 61954 NULL
+ntrips___thermal_zone_61955_fields ntrips __thermal_zone 0 61955 NULL
+hsu_dma_active_desc_size_fndecl_61956_fields hsu_dma_active_desc_size fndecl 0 61956 NULL
+s_maxbytes_super_block_61963_fields s_maxbytes super_block 0 61963 NULL
+periods_min_snd_pcm_hardware_61965_fields periods_min snd_pcm_hardware 0 61965 NULL
+wm_adsp_compr_read_fndecl_61972_fields wm_adsp_compr_read fndecl 3 61972 NULL
+nfs_set_pgio_error_fndecl_61975_fields nfs_set_pgio_error fndecl 3 61975 NULL
+physical_for_dev_replace_scrub_page_61977_fields physical_for_dev_replace scrub_page 0 61977 NULL
+x25_pacsize_to_bytes_fndecl_61983_fields x25_pacsize_to_bytes fndecl 0 61983 NULL
+qib_verbs_send_dma_fndecl_61985_fields qib_verbs_send_dma fndecl 7-5 61985 NULL
+opts1_de_desc_61986_fields opts1 de_desc 0 61986 NULL
+vblank_panel_info_61990_fields vblank panel_info 0 61990 NULL
+num_srq_mlx4_profile_61993_fields num_srq mlx4_profile 0 61993 NULL
+r_num_ops_ceph_osd_request_61995_fields r_num_ops ceph_osd_request 0 61995 NULL
+rdmaciqs_sge_61997_fields rdmaciqs sge 0 61997 NULL
+iscsi_login_tx_data_fndecl_61998_fields iscsi_login_tx_data fndecl 4 61998 NULL
+sc_reader_svcxprt_rdma_62004_fields sc_reader svcxprt_rdma 0 62004 NULL
+__add_discard_entry_fndecl_62006_fields __add_discard_entry fndecl 4-5 62006 NULL
+ext4_ext_convert_to_initialized_fndecl_62009_fields ext4_ext_convert_to_initialized fndecl 0 62009 NULL
+length_snd_efw_transaction_62012_fields length snd_efw_transaction 0 62012 NULL
+memblock_setclr_flag_fndecl_62013_fields memblock_setclr_flag fndecl 2-1 62013 NULL
+srp_map_sg_fr_fndecl_62023_fields srp_map_sg_fr fndecl 0 62023 NULL
+size_mtd_blktrans_dev_62024_fields size mtd_blktrans_dev 0 62024 NULL
+nf_bridge_encap_header_len_fndecl_62025_fields nf_bridge_encap_header_len fndecl 0 62025 NULL
+filter_count_rx_used_efx_nic_type_62026_fields filter_count_rx_used efx_nic_type 0 62026 NULL
+encode_diropargs_fndecl_62031_fields encode_diropargs fndecl 4 62031 NULL
+num_qps_mlx4_caps_62033_fields num_qps mlx4_caps 0 62033 NULL
+n_rx_channels_efx_nic_62034_fields n_rx_channels efx_nic 0 62034 NULL
+dev_sectors_r10conf_62035_fields dev_sectors r10conf 0 62035 NULL
+set_advertising_fndecl_62037_fields set_advertising fndecl 4 62037 NULL
+tfcpad_xfrm_state_62038_fields tfcpad xfrm_state 0 62038 NULL
+lmm_stripe_count_lov_user_md_v3_62042_fields lmm_stripe_count lov_user_md_v3 0 62042 NULL
+flag_count_sg_simple_element_62044_fields flag_count sg_simple_element 0 62044 NULL
+entries_size_ebt_replace_62051_fields entries_size ebt_replace 0 62051 NULL
+regmap_spi_read_fndecl_62058_fields regmap_spi_read fndecl 3-5 62058 NULL
+ex_offset_extent_s_62059_fields ex_offset extent_s 0 62059 NULL
+num_attr_vgastate_62064_fields num_attr vgastate 0 62064 NULL
+cb_stripe_unit_exofs_dt_data_map_62068_fields cb_stripe_unit exofs_dt_data_map 0 62068 NULL
+num_devices_dm_raid_superblock_62072_fields num_devices dm_raid_superblock 0 62072 NULL
+ip_vs_send_async_fndecl_62075_fields ip_vs_send_async fndecl 3 62075 NULL
+wBlockSize_ms_bootblock_sysinf_62081_fields wBlockSize ms_bootblock_sysinf 0 62081 NULL
+ieee80211_build_probe_req_fndecl_62084_fields ieee80211_build_probe_req fndecl 9-7 62084 NULL
+rtsx_usb_seq_write_register_fndecl_62088_fields rtsx_usb_seq_write_register fndecl 3 62088 NULL
+init_shash_alg_62095_fields init shash_alg 0 62095 NULL
+max_xid_bnx2fc_hba_62096_fields max_xid bnx2fc_hba 0 62096 NULL
+bcm_recvmsg_fndecl_62099_fields bcm_recvmsg fndecl 3 62099 NULL nohasharray
+word3_atl1c_recv_ret_status_62099_fields word3 atl1c_recv_ret_status 0 62099 &bcm_recvmsg_fndecl_62099_fields
+task_ctx_size_pmu_62102_fields task_ctx_size pmu 0 62102 NULL
+yoffset_fb_var_screeninfo_62110_fields yoffset fb_var_screeninfo 0 62110 NULL nohasharray
+bulk_out_ep_bfusb_data_62110_fields bulk_out_ep bfusb_data 0 62110 &yoffset_fb_var_screeninfo_62110_fields
+st_nci_hci_dm_vdc_measurement_value_fndecl_62123_fields st_nci_hci_dm_vdc_measurement_value fndecl 3 62123 NULL
+vcs_lseek_fndecl_62125_fields vcs_lseek fndecl 2 62125 NULL
+__process_deleted_xattr_fndecl_62133_fields __process_deleted_xattr fndecl 4 62133 NULL
+__irq_alloc_descs_fndecl_62140_fields __irq_alloc_descs fndecl 0 62140 NULL
+next_setup_data_62142_fields next setup_data 0 62142 NULL
+drbd_recv_all_warn_fndecl_62144_fields drbd_recv_all_warn fndecl 3 62144 NULL
+cciss_tape_cmds_vardecl_cciss_c_62147_fields cciss_tape_cmds vardecl_cciss.c 0 62147 NULL
+tcp_trim_head_fndecl_62157_fields tcp_trim_head fndecl 3 62157 NULL
+ptrace_writedata_fndecl_62158_fields ptrace_writedata fndecl 3 62158 NULL
+map_index_to_lba_fndecl_62162_fields map_index_to_lba fndecl 0-1 62162 NULL
+size_vfio_pci_region_62163_fields size vfio_pci_region 0 62163 NULL nohasharray
+max_i2s_chan_img_i2s_out_62163_fields max_i2s_chan img_i2s_out 0 62163 &size_vfio_pci_region_62163_fields
+user_frag_sctp_association_62167_fields user_frag sctp_association 0 62167 NULL nohasharray
+alloc_huge_page_fndecl_62167_fields alloc_huge_page fndecl 2 62167 &user_frag_sctp_association_62167_fields
+len_scrub_copy_nocow_ctx_62170_fields len scrub_copy_nocow_ctx 0 62170 NULL
+igb_change_mtu_fndecl_62189_fields igb_change_mtu fndecl 2 62189 NULL
+eps_count_ffs_data_62193_fields eps_count ffs_data 0 62193 NULL nohasharray
+agent_send_response_fndecl_62193_fields agent_send_response fndecl 7 62193 &eps_count_ffs_data_62193_fields
+rose_sendmsg_fndecl_62194_fields rose_sendmsg fndecl 3 62194 NULL
+max_pkt_size_em28xx_62196_fields max_pkt_size em28xx 0 62196 NULL
+snd_cwnd_clamp_tcp_sock_62197_fields snd_cwnd_clamp tcp_sock 0 62197 NULL
+maxframe_caifsock_62201_fields maxframe caifsock 0 62201 NULL
+at24_eeprom_write_smbus_block_fndecl_62212_fields at24_eeprom_write_smbus_block fndecl 3-4 62212 NULL
+generic_file_direct_write_fndecl_62226_fields generic_file_direct_write fndecl 0 62226 NULL
+datainterval_snd_usb_endpoint_62227_fields datainterval snd_usb_endpoint 0 62227 NULL
+svm_create_vcpu_fndecl_62239_fields svm_create_vcpu fndecl 2 62239 NULL
+snd_pcm_alloc_vmalloc_buffer_fndecl_62240_fields snd_pcm_alloc_vmalloc_buffer fndecl 2 62240 NULL
+btrfs_set_extent_delalloc_fndecl_62264_fields btrfs_set_extent_delalloc fndecl 3-2 62264 NULL
+num_rxqs_octeon_nic_if_config_62266_fields num_rxqs octeon_nic_if_config 0 62266 NULL
+usable_leb_size_ubi_volume_62272_fields usable_leb_size ubi_volume 0 62272 NULL
+max_eps_mv_udc_62274_fields max_eps mv_udc 0 62274 NULL
+cfpkt_add_body_fndecl_62277_fields cfpkt_add_body fndecl 3 62277 NULL
+tx_cnt_virtio_vsock_sock_62281_fields tx_cnt virtio_vsock_sock 0 62281 NULL
+msb_get_free_block_fndecl_62282_fields msb_get_free_block fndecl 0 62282 NULL
+email_size_x509_parse_context_62283_fields email_size x509_parse_context 0 62283 NULL
+mappable_end_i915_ggtt_62288_fields mappable_end i915_ggtt 0 62288 NULL
+omfs_scan_list_fndecl_62289_fields omfs_scan_list fndecl 2 62289 NULL
+num_arq_entries_i40e_adminq_info_62293_fields num_arq_entries i40e_adminq_info 0 62293 NULL
+num_chunks_icp_qat_suof_filehdr_62296_fields num_chunks icp_qat_suof_filehdr 0 62296 NULL
+max_io_mvumi_hba_62301_fields max_io mvumi_hba 0 62301 NULL
+ceph_llseek_fndecl_62305_fields ceph_llseek fndecl 2 62305 NULL
+sb_rbmblocks_xfs_sb_62307_fields sb_rbmblocks xfs_sb 0 62307 NULL
+rtl2832_sdr_convert_stream_fndecl_62308_fields rtl2832_sdr_convert_stream fndecl 0-4 62308 NULL
+ircomm_tty_connect_confirm_fndecl_62310_fields ircomm_tty_connect_confirm fndecl 4-5 62310 NULL nohasharray
+iov_data_count_iscsi_cmd_62310_fields iov_data_count iscsi_cmd 0 62310 &ircomm_tty_connect_confirm_fndecl_62310_fields
+map_extent_mft_record_fndecl_62312_fields map_extent_mft_record fndecl 2 62312 NULL
+ss_channels_snd_rme9652_62315_fields ss_channels snd_rme9652 0 62315 NULL
+ext2_new_block_fndecl_62326_fields ext2_new_block fndecl 0-2 62326 NULL
+tcp_vegas_cong_avoid_fndecl_62332_fields tcp_vegas_cong_avoid fndecl 3 62332 NULL
+qib_get_user_pages_fndecl_62338_fields qib_get_user_pages fndecl 1 62338 NULL nohasharray
+hdrlen_adm8211_tx_ring_info_62338_fields hdrlen adm8211_tx_ring_info 0 62338 &qib_get_user_pages_fndecl_62338_fields nohasharray
+bbtskipbytes_denali_nand_info_62338_fields bbtskipbytes denali_nand_info 0 62338 &hdrlen_adm8211_tx_ring_info_62338_fields
+pagf_flcount_xfs_perag_62340_fields pagf_flcount xfs_perag 0 62340 NULL
+pcl_status_pcl_62348_fields pcl_status pcl 0 62348 NULL
+mtu_from_qp_rvt_driver_provided_62354_fields mtu_from_qp rvt_driver_provided 0 62354 NULL
+raid56_parity_write_fndecl_62355_fields raid56_parity_write fndecl 0 62355 NULL
+len_eager_buffer_62357_fields len eager_buffer 0 62357 NULL
+rawv6_sendmsg_fndecl_62363_fields rawv6_sendmsg fndecl 3 62363 NULL
+drxbsp_i2c_write_read_fndecl_62366_fields drxbsp_i2c_write_read fndecl 5-2 62366 NULL
+num_entries_compat_arpt_replace_62377_fields num_entries compat_arpt_replace 0 62377 NULL
+new_chunk_mdp_superblock_1_62380_fields new_chunk mdp_superblock_1 0 62380 NULL
+max_cnt_ocrdma_qp_hwq_info_62383_fields max_cnt ocrdma_qp_hwq_info 0 62383 NULL nohasharray
+efx_wanted_parallelism_fndecl_62383_fields efx_wanted_parallelism fndecl 0 62383 &max_cnt_ocrdma_qp_hwq_info_62383_fields
+ivsize_aead_alg_62386_fields ivsize aead_alg 0 62386 NULL nohasharray
+send_queue_size_nvmet_rdma_queue_62386_fields send_queue_size nvmet_rdma_queue 0 62386 &ivsize_aead_alg_62386_fields
+m_blkbb_log_xfs_mount_62391_fields m_blkbb_log xfs_mount 0 62391 NULL
+__generic_block_fiemap_fndecl_62394_fields __generic_block_fiemap fndecl 4 62394 NULL
+hwCBP_td_62396_fields hwCBP td 0 62396 NULL
+len_scifioctl_node_ids_62402_fields len scifioctl_node_ids 0 62402 NULL
+pty_write_fndecl_62406_fields pty_write fndecl 3 62406 NULL
+segment_acpi_pci_root_62407_fields segment acpi_pci_root 0 62407 NULL
+fill_holes_fndecl_62408_fields fill_holes fndecl 4-5 62408 NULL nohasharray
+rtsx_usb_get_rsp_fndecl_62408_fields rtsx_usb_get_rsp fndecl 2 62408 &fill_holes_fndecl_62408_fields
+gfs2_log_bmap_fndecl_62411_fields gfs2_log_bmap fndecl 0 62411 NULL
+unmap_page_range_fndecl_62415_fields unmap_page_range fndecl 4-3 62415 NULL
+adap_id_pca954x_platform_mode_62418_fields adap_id pca954x_platform_mode 0 62418 NULL
+inet6_lookup_listener_fndecl_62428_fields inet6_lookup_listener fndecl 4 62428 NULL
+set_brk_fndecl_62430_fields set_brk fndecl 1-2 62430 NULL nohasharray
+io_size_xfs_ioend_62430_fields io_size xfs_ioend 0 62430 &set_brk_fndecl_62430_fields
+rx_urb_size_lan78xx_net_62443_fields rx_urb_size lan78xx_net 0 62443 NULL nohasharray
+sum_link_node_ref_fndecl_62443_fields sum_link_node_ref fndecl 4-3 62443 &rx_urb_size_lan78xx_net_62443_fields
+run_bpf_fndecl_62447_fields run_bpf fndecl 5 62447 NULL
+__videobuf_copy_stream_fndecl_62450_fields __videobuf_copy_stream fndecl 0 62450 NULL
+npods_cxgbi_task_tag_info_62453_fields npods cxgbi_task_tag_info 0 62453 NULL
+lower_offset_skb_seq_state_62465_fields lower_offset skb_seq_state 0 62465 NULL
+ipx_recvmsg_fndecl_62469_fields ipx_recvmsg fndecl 3 62469 NULL
+ram_alignment_fndecl_62470_fields ram_alignment fndecl 0 62470 NULL
+payload_bytes_controlvm_message_header_62474_fields payload_bytes controlvm_message_header 0 62474 NULL
+fw_stats_bus_myri10ge_slice_state_62482_fields fw_stats_bus myri10ge_slice_state 0 62482 NULL
+rx_ring_tail_sc92031_priv_62486_fields rx_ring_tail sc92031_priv 0 62486 NULL
+mlx5_ib_reg_user_mr_fndecl_62488_fields mlx5_ib_reg_user_mr fndecl 4-2-3 62488 NULL
+dlen_ippp_ccp_reset_state_62491_fields dlen ippp_ccp_reset_state 0 62491 NULL nohasharray
+residual_len_sts_entry_fx00_62491_fields residual_len sts_entry_fx00 0 62491 &dlen_ippp_ccp_reset_state_62491_fields
+filemap_write_and_wait_range_fndecl_62492_fields filemap_write_and_wait_range fndecl 0-2-3 62492 NULL nohasharray
+svc_sock_setbufsize_fndecl_62492_fields svc_sock_setbufsize fndecl 2 62492 &filemap_write_and_wait_range_fndecl_62492_fields
+try_charge_fndecl_62496_fields try_charge fndecl 0 62496 NULL
+vmci_transport_set_buffer_size_fndecl_62498_fields vmci_transport_set_buffer_size fndecl 2 62498 NULL
+max_enic_rfs_flw_tbl_62505_fields max enic_rfs_flw_tbl 0 62505 NULL
+rq_tailsz_smb_rqst_62506_fields rq_tailsz smb_rqst 0 62506 NULL
+jade_ale_bkm_hw_62507_fields jade_ale bkm_hw 0 62507 NULL
+sgs_per_request_skd_device_62508_fields sgs_per_request skd_device 0 62508 NULL
+mpage_alloc_fndecl_62512_fields mpage_alloc fndecl 2-3 62512 NULL
+dma_phys_netup_unidvb_dev_62519_fields dma_phys netup_unidvb_dev 0 62519 NULL
+rx_buf_sz_iadev_priv_62524_fields rx_buf_sz iadev_priv 0 62524 NULL
+xfs_log_regrant_fndecl_62533_fields xfs_log_regrant fndecl 0 62533 NULL
+iova_vhost_iotlb_msg_62545_fields iova vhost_iotlb_msg 0 62545 NULL
+len_ErrMsg_62547_fields len ErrMsg 0 62547 NULL
+__ext4_get_inode_loc_fndecl_62551_fields __ext4_get_inode_loc fndecl 0 62551 NULL nohasharray
+xfs_log_reserve_fndecl_62551_fields xfs_log_reserve fndecl 0 62551 &__ext4_get_inode_loc_fndecl_62551_fields
+num_cq_entries_hba_parameters_62556_fields num_cq_entries hba_parameters 0 62556 NULL
+wDatagramLength_usb_cdc_ncm_dpe16_62564_fields wDatagramLength usb_cdc_ncm_dpe16 0 62564 NULL
+outbuf_dma_ati_remote_62567_fields outbuf_dma ati_remote 0 62567 NULL
+btrfs_check_data_free_space_fndecl_62583_fields btrfs_check_data_free_space fndecl 0-3-2 62583 NULL
+mtd_ooblayout_find_eccregion_fndecl_62594_fields mtd_ooblayout_find_eccregion fndecl 2 62594 NULL
+mon_bin_dev0_vardecl_mon_bin_c_62600_fields mon_bin_dev0 vardecl_mon_bin.c 0 62600 NULL
+__alloc_bootmem_low_fndecl_62604_fields __alloc_bootmem_low fndecl 2-3 62604 NULL nohasharray
+max_header_size_irlan_cb_62604_fields max_header_size irlan_cb 0 62604 &__alloc_bootmem_low_fndecl_62604_fields
+ext4_xattr_check_names_fndecl_62605_fields ext4_xattr_check_names fndecl 0 62605 NULL
+sizeoftlvs_lec_arp_table_62608_fields sizeoftlvs lec_arp_table 0 62608 NULL
+pci_sriov_set_totalvfs_fndecl_62615_fields pci_sriov_set_totalvfs fndecl 2 62615 NULL
+mixed_cnt_ncsi_rsp_gc_pkt_62619_fields mixed_cnt ncsi_rsp_gc_pkt 0 62619 NULL
+l2linesize_linelock_62626_fields l2linesize linelock 0 62626 NULL
+min_pkt_size_pktgen_dev_62629_fields min_pkt_size pktgen_dev 0 62629 NULL
+virtio_gpu_ttm_tt_create_fndecl_62636_fields virtio_gpu_ttm_tt_create fndecl 2 62636 NULL nohasharray
+wil_change_mtu_fndecl_62636_fields wil_change_mtu fndecl 2 62636 &virtio_gpu_ttm_tt_create_fndecl_62636_fields
+ath6kl_wmi_get_stats_cmd_fndecl_62638_fields ath6kl_wmi_get_stats_cmd fndecl 2 62638 NULL
+fts_rtllib_device_62643_fields fts rtllib_device 0 62643 NULL
+cfg_sg_seg_cnt_lpfc_hba_62646_fields cfg_sg_seg_cnt lpfc_hba 0 62646 NULL
+curr_len_max3421_hcd_62658_fields curr_len max3421_hcd 0 62658 NULL
+irq_max_tg3_62664_fields irq_max tg3 0 62664 NULL
+calculate_discard_block_size_fndecl_62667_fields calculate_discard_block_size fndecl 0-1 62667 NULL nohasharray
+alloc_new_reservation_fndecl_62667_fields alloc_new_reservation fndecl 0 62667 &calculate_discard_block_size_fndecl_62667_fields nohasharray
+base_i40e_hmc_obj_info_62667_fields base i40e_hmc_obj_info 0 62667 &alloc_new_reservation_fndecl_62667_fields
+qxl_gem_object_create_fndecl_62668_fields qxl_gem_object_create fndecl 2 62668 NULL
+bss_priv_size_wiphy_62669_fields bss_priv_size wiphy 0 62669 NULL nohasharray
+max_outstanding_tx_leaf_msg_softinfo_62669_fields max_outstanding_tx leaf_msg_softinfo 0 62669 &bss_priv_size_wiphy_62669_fields
+ocfs2_xattr_trusted_set_fndecl_62672_fields ocfs2_xattr_trusted_set fndecl 6 62672 NULL
+pci_cfg_space_size_ext_fndecl_62679_fields pci_cfg_space_size_ext fndecl 0 62679 NULL
+encode_rpcb_string_fndecl_62680_fields encode_rpcb_string fndecl 3 62680 NULL
+num_vsis_i40e_hw_capabilities_62685_fields num_vsis i40e_hw_capabilities 0 62685 NULL
+start_ttm_mem_reg_62688_fields start ttm_mem_reg 0 62688 NULL
+vmemdup_fndecl_62706_fields vmemdup fndecl 2 62706 NULL
+curwidth_usb_usbvision_62710_fields curwidth usb_usbvision 0 62710 NULL
+mtu_ring_info_62721_fields mtu ring_info 0 62721 NULL
+limit_tc_sfq_qopt_62728_fields limit tc_sfq_qopt 0 62728 NULL nohasharray
+jffs2_write_begin_fndecl_62728_fields jffs2_write_begin fndecl 3 62728 &limit_tc_sfq_qopt_62728_fields
+total_len_android_wifi_priv_cmd_62735_fields total_len android_wifi_priv_cmd 0 62735 NULL
+smi_read_eeprom_fndecl_62737_fields smi_read_eeprom fndecl 4 62737 NULL nohasharray
+nct6683_create_attr_group_fndecl_62737_fields nct6683_create_attr_group fndecl 3 62737 &smi_read_eeprom_fndecl_62737_fields
+xfs_da_read_buf_fndecl_62739_fields xfs_da_read_buf fndecl 3 62739 NULL
+twa_load_sgl_fndecl_62743_fields twa_load_sgl fndecl 5 62743 NULL
+mi_first_entry_offset_nilfs_mdt_info_62749_fields mi_first_entry_offset nilfs_mdt_info 0 62749 NULL
+num_counters_vardecl_op_model_amd_c_62750_fields num_counters vardecl_op_model_amd.c 0 62750 NULL
+__bioset_create_fndecl_62752_fields __bioset_create fndecl 2-1 62752 NULL
+min_align_pci_dev_resource_62768_fields min_align pci_dev_resource 0 62768 NULL
+cp2112_read_req_fndecl_62770_fields cp2112_read_req fndecl 0 62770 NULL
+st_nci_hci_dm_fwupd_end_fndecl_62777_fields st_nci_hci_dm_fwupd_end fndecl 3 62777 NULL
+e_value_size_ext4_xattr_entry_62783_fields e_value_size ext4_xattr_entry 0 62783 NULL
+ecc_bits_jedec_ecc_info_62785_fields ecc_bits jedec_ecc_info 0 62785 NULL
+mt2131_writeregs_fndecl_62788_fields mt2131_writeregs fndecl 3 62788 NULL
+dump_skip_fndecl_62793_fields dump_skip fndecl 2 62793 NULL
+cur_tx_netdev_private_62799_fields cur_tx netdev_private 0 62799 NULL
+hfi1_hdrq_entsize_vardecl_init_c_62810_fields hfi1_hdrq_entsize vardecl_init.c 0 62810 NULL
+xattr_len_ima_event_data_62811_fields xattr_len ima_event_data 0 62811 NULL
+head_aio_ring_62812_fields head aio_ring 0 62812 NULL
+capture_frlog_rme32_62817_fields capture_frlog rme32 0 62817 NULL
+coex_rx_win_size_mwifiex_adapter_62818_fields coex_rx_win_size mwifiex_adapter 0 62818 NULL
+tlen_hfi1_packet_62825_fields tlen hfi1_packet 0 62825 NULL
+gfs2_journaled_truncate_fndecl_62839_fields gfs2_journaled_truncate fndecl 3-2 62839 NULL
+ix2505v_write_fndecl_62840_fields ix2505v_write fndecl 3 62840 NULL
+fuse_read_fill_fndecl_62851_fields fuse_read_fill fndecl 4 62851 NULL
+max_register_regmap_62857_fields max_register regmap 0 62857 NULL
+nr_vecs_nilfs_write_info_62858_fields nr_vecs nilfs_write_info 0 62858 NULL
+spi_xcomm_txrx_bufs_fndecl_62860_fields spi_xcomm_txrx_bufs fndecl 0 62860 NULL
+height_tm6000_core_62864_fields height tm6000_core 0 62864 NULL
+c67x00_td_to_error_fndecl_62867_fields c67x00_td_to_error fndecl 0 62867 NULL
+ext2_max_size_fndecl_62871_fields ext2_max_size fndecl 0-1 62871 NULL
+i2c_hid_get_report_fndecl_62874_fields i2c_hid_get_report fndecl 5 62874 NULL
+qp_count_ntb_transport_ctx_62876_fields qp_count ntb_transport_ctx 0 62876 NULL
+xfs_dir3_leaf_read_fndecl_62878_fields xfs_dir3_leaf_read fndecl 3 62878 NULL
+create_kmalloc_cache_fndecl_62883_fields create_kmalloc_cache fndecl 2 62883 NULL
+valueblk_xfs_attr_inactive_list_62884_fields valueblk xfs_attr_inactive_list 0 62884 NULL
+phys_start_nvs_page_62885_fields phys_start nvs_page 0 62885 NULL
+midi_in_ports_snd_efw_62902_fields midi_in_ports snd_efw 0 62902 NULL
+xfs_init_local_fork_fndecl_62904_fields xfs_init_local_fork fndecl 4 62904 NULL
+arg2__cdrp_cmd_62906_fields arg2 _cdrp_cmd 0 62906 NULL
+length_uvc_buffer_62907_fields length uvc_buffer 0 62907 NULL
+buflen_xdr_buf_62914_fields buflen xdr_buf 0 62914 NULL nohasharray
+n_subdevices_comedi_device_62914_fields n_subdevices comedi_device 0 62914 &buflen_xdr_buf_62914_fields
+out_size_ide_task_request_s_62924_fields out_size ide_task_request_s 0 62924 NULL
+uar_size_mthca_dev_lim_62925_fields uar_size mthca_dev_lim 0 62925 NULL
+teiup_create_fndecl_62930_fields teiup_create fndecl 3 62930 NULL
+ext4_xattr_ibody_get_fndecl_62931_fields ext4_xattr_ibody_get fndecl 0 62931 NULL nohasharray
+madvise_free_pte_range_fndecl_62931_fields madvise_free_pte_range fndecl 2 62931 &ext4_xattr_ibody_get_fndecl_62931_fields
+regmap_encx24j600_sfr_write_fndecl_62935_fields regmap_encx24j600_sfr_write fndecl 4 62935 NULL
+bfad_send_fcpt_cb_fndecl_62936_fields bfad_send_fcpt_cb fndecl 5 62936 NULL
+f2fs_acl_from_disk_fndecl_62937_fields f2fs_acl_from_disk fndecl 2 62937 NULL
+mtu_atmlec_config_msg_62946_fields mtu atmlec_config_msg 0 62946 NULL
+ax88178_change_mtu_fndecl_62947_fields ax88178_change_mtu fndecl 2 62947 NULL
+fixup_leb_fndecl_62955_fields fixup_leb fndecl 3 62955 NULL
+adfs_get_block_fndecl_62966_fields adfs_get_block fndecl 2 62966 NULL
+i_sblock_bfs_inode_62968_fields i_sblock bfs_inode 0 62968 NULL
+io_tlb_nslabs_vardecl_swiotlb_c_62972_fields io_tlb_nslabs vardecl_swiotlb.c 0 62972 NULL
+vmemmap_alloc_block_fndecl_62974_fields vmemmap_alloc_block fndecl 1 62974 NULL nohasharray
+tcp_cdg_cong_avoid_fndecl_62974_fields tcp_cdg_cong_avoid fndecl 3 62974 &vmemmap_alloc_block_fndecl_62974_fields
+max_requests_hpt_iop_request_get_config_62975_fields max_requests hpt_iop_request_get_config 0 62975 NULL
+move_to_top_fndecl_62981_fields move_to_top fndecl 2-3 62981 NULL
+memblock_insert_region_fndecl_62987_fields memblock_insert_region fndecl 3-4 62987 NULL
+integrity_kernel_read_fndecl_62991_fields integrity_kernel_read fndecl 4 62991 NULL
+layout_mddev_62992_fields layout mddev 0 62992 NULL
+i2c_smbus_write_word_data_fndecl_62993_fields i2c_smbus_write_word_data fndecl 0 62993 NULL
+alloc_name_seq_62994_fields alloc name_seq 0 62994 NULL
+ocfs2_xattr_get_value_outside_fndecl_63000_fields ocfs2_xattr_get_value_outside fndecl 0 63000 NULL
+finish_item_xfs_defer_op_type_63002_fields finish_item xfs_defer_op_type 0 63002 NULL
+do_garbage_collect_fndecl_63005_fields do_garbage_collect fndecl 2 63005 NULL
+pagesize_flash_info_63006_fields pagesize flash_info 0 63006 NULL
+get_rsb_struct_fndecl_63014_fields get_rsb_struct fndecl 3 63014 NULL
+btrfs_xattr_handler_set_fndecl_63016_fields btrfs_xattr_handler_set fndecl 6 63016 NULL
+packets_per_second_ua101_63022_fields packets_per_second ua101 0 63022 NULL nohasharray
+iomap_write_actor_fndecl_63022_fields iomap_write_actor fndecl 2-3 63022 &packets_per_second_ua101_63022_fields
+mmio_size_controller_63024_fields mmio_size controller 0 63024 NULL
+hci_send_cmd_fndecl_63025_fields hci_send_cmd fndecl 3 63025 NULL
+mdsl_cxgbit_device_63030_fields mdsl cxgbit_device 0 63030 NULL
+gspca_coarse_grained_expo_autogain_fndecl_63033_fields gspca_coarse_grained_expo_autogain fndecl 4-2-3 63033 NULL
+rsi_sdio_host_intf_write_pkt_fndecl_63034_fields rsi_sdio_host_intf_write_pkt fndecl 3 63034 NULL
+size_align_rxrpc_connection_63035_fields size_align rxrpc_connection 0 63035 NULL
+display_width_vivid_dev_63040_fields display_width vivid_dev 0 63040 NULL
+acpi_aml_write_user_fndecl_63043_fields acpi_aml_write_user fndecl 2-0 63043 NULL
+reset_psn_fndecl_63045_fields reset_psn fndecl 2 63045 NULL
+ttymajor_vardecl_synclink_cs_c_63046_fields ttymajor vardecl_synclink_cs.c 0 63046 NULL
+sizeimage_deinterlace_q_data_63050_fields sizeimage deinterlace_q_data 0 63050 NULL
+atl1c_change_mtu_fndecl_63051_fields atl1c_change_mtu fndecl 2 63051 NULL
+irq_create_fwspec_mapping_fndecl_63056_fields irq_create_fwspec_mapping fndecl 0 63056 NULL
+p54_download_eeprom_fndecl_63057_fields p54_download_eeprom fndecl 4 63057 NULL
+nr_perf_branch_stack_63058_fields nr perf_branch_stack 0 63058 NULL nohasharray
+q0_num_vecs_bna_rx_config_63058_fields q0_num_vecs bna_rx_config 0 63058 &nr_perf_branch_stack_63058_fields
+pcibios_scan_root_fndecl_63059_fields pcibios_scan_root fndecl 1 63059 NULL
+if_bytes_xfs_ifork_63066_fields if_bytes xfs_ifork 0 63066 NULL
+writesize_onenand_chip_63069_fields writesize onenand_chip 0 63069 NULL
+prev_algo_r5conf_63075_fields prev_algo r5conf 0 63075 NULL
+num_records_htt_tx_fetch_ind_63076_fields num_records htt_tx_fetch_ind 0 63076 NULL
+start_bus_pci_mmcfg_region_63086_fields start_bus pci_mmcfg_region 0 63086 NULL
+width_saa7134_dev_63087_fields width saa7134_dev 0 63087 NULL nohasharray
+s_anchor_udf_sb_info_63087_fields s_anchor udf_sb_info 0 63087 &width_saa7134_dev_63087_fields nohasharray
+init_labels_fndecl_63087_fields init_labels fndecl 2 63087 &s_anchor_udf_sb_info_63087_fields
+nfc_hci_execute_cmd_fndecl_63097_fields nfc_hci_execute_cmd fndecl 5 63097 NULL
+rd_page_count_rd_dev_63098_fields rd_page_count rd_dev 0 63098 NULL
+get_registry_size_bnx2x_mcast_obj_63102_fields get_registry_size bnx2x_mcast_obj 0 63102 NULL
+size_devlog_params_63104_fields size devlog_params 0 63104 NULL
+cros_ec_num_pwms_fndecl_63107_fields cros_ec_num_pwms fndecl 0 63107 NULL
+drxdap_fasi_read_block_fndecl_63113_fields drxdap_fasi_read_block fndecl 3 63113 NULL
+ticket_len_rxkad_key_63114_fields ticket_len rxkad_key 0 63114 NULL
+max_recv_sge_ib_qp_cap_63118_fields max_recv_sge ib_qp_cap 0 63118 NULL
+max_cqe_ib_device_attr_63121_fields max_cqe ib_device_attr 0 63121 NULL
+txf_size_bdx_priv_63122_fields txf_size bdx_priv 0 63122 NULL
+uvc_video_decode_data_fndecl_63124_fields uvc_video_decode_data fndecl 4 63124 NULL
+rcvhdrq_cnt_hfi1_ctxtdata_63132_fields rcvhdrq_cnt hfi1_ctxtdata 0 63132 NULL
+prism2_sta_send_mgmt_fndecl_63135_fields prism2_sta_send_mgmt fndecl 5 63135 NULL
+peer_cookie_len_l2tp_session_63142_fields peer_cookie_len l2tp_session 0 63142 NULL
+gk104_fifo_new__fndecl_63149_fields gk104_fifo_new_ fndecl 4 63149 NULL
+vback_porch_videomode_63152_fields vback_porch videomode 0 63152 NULL nohasharray
+nid_nat_journal_entry_63152_fields nid nat_journal_entry 0 63152 &vback_porch_videomode_63152_fields
+obj_order_rbd_image_header_63156_fields obj_order rbd_image_header 0 63156 NULL
+length_req_que_63158_fields length req_que 0 63158 NULL
+dst_y_yuv_frame_info_63162_fields dst_y yuv_frame_info 0 63162 NULL
+get_pattern_len_ts_ops_63165_fields get_pattern_len ts_ops 0 63165 NULL
+word_4_rsq_entry_63169_fields word_4 rsq_entry 0 63169 NULL
+nla_reserve_fndecl_63171_fields nla_reserve fndecl 3 63171 NULL
+vma_hugecache_offset_fndecl_63172_fields vma_hugecache_offset fndecl 0-3 63172 NULL
+object_counter_vardecl_hidma_mgmt_c_63176_fields object_counter vardecl_hidma_mgmt.c 0 63176 NULL
+ulist_add_fndecl_63177_fields ulist_add fndecl 0 63177 NULL
+nr_to_scan_shrink_control_63181_fields nr_to_scan shrink_control 0 63181 NULL
+srpt_srq_size_vardecl_ib_srpt_c_63183_fields srpt_srq_size vardecl_ib_srpt.c 0 63183 NULL
+csums_alg_len_net_conf_63190_fields csums_alg_len net_conf 0 63190 NULL nohasharray
+__sg_page_iter_start_fndecl_63190_fields __sg_page_iter_start fndecl 4 63190 &csums_alg_len_net_conf_63190_fields
+val_v4l2_ctrl_63196_fields val v4l2_ctrl 0 63196 NULL
+__get_required_blob_size_fndecl_63199_fields __get_required_blob_size fndecl 0-3-2 63199 NULL
+mwl8k_add_dma_header_fndecl_63203_fields mwl8k_add_dma_header fndecl 3 63203 NULL
+lcd_lower_margin_atyfb_par_63209_fields lcd_lower_margin atyfb_par 0 63209 NULL nohasharray
+nvm_submit_ppa_list_fndecl_63209_fields nvm_submit_ppa_list fndecl 7 63209 &lcd_lower_margin_atyfb_par_63209_fields
+sdebug_unmap_granularity_vardecl_scsi_debug_c_63211_fields sdebug_unmap_granularity vardecl_scsi_debug.c 0 63211 NULL
+blk_queue_chunk_sectors_fndecl_63214_fields blk_queue_chunk_sectors fndecl 2 63214 NULL
+ufs_alloccg_block_fndecl_63239_fields ufs_alloccg_block fndecl 0 63239 NULL nohasharray
+npins_intel_pinctrl_soc_data_63239_fields npins intel_pinctrl_soc_data 0 63239 &ufs_alloccg_block_fndecl_63239_fields
+mod_len_start_info_63244_fields mod_len start_info 0 63244 NULL
+ep_image_mts_desc_63258_fields ep_image mts_desc 0 63258 NULL
+cachefiles_daemon_write_fndecl_63260_fields cachefiles_daemon_write fndecl 3 63260 NULL
+pdu_write_u_fndecl_63261_fields pdu_write_u fndecl 3 63261 NULL
+sch56xx_device_add_fndecl_63264_fields sch56xx_device_add fndecl 1 63264 NULL
+_fc_frame_alloc_fndecl_63267_fields _fc_frame_alloc fndecl 1 63267 NULL
+version_size_ks_wlan_private_63280_fields version_size ks_wlan_private 0 63280 NULL
+s_mb_last_start_ext4_sb_info_63283_fields s_mb_last_start ext4_sb_info 0 63283 NULL
+num_counters_ebt_replace_63286_fields num_counters ebt_replace 0 63286 NULL
+xprt_rdma_slot_table_entries_vardecl_transport_c_63290_fields xprt_rdma_slot_table_entries vardecl_transport.c 0 63290 NULL
+num_regulators_mc13xxx_regulator_platform_data_63291_fields num_regulators mc13xxx_regulator_platform_data 0 63291 NULL
+ath_rx_init_fndecl_63295_fields ath_rx_init fndecl 2 63295 NULL
+num_req_tx_rings_bnx2_63306_fields num_req_tx_rings bnx2 0 63306 NULL
+valuelen_jfs_ea_63309_fields valuelen jfs_ea 0 63309 NULL
+con_out_kvec_add_fndecl_63316_fields con_out_kvec_add fndecl 2 63316 NULL nohasharray
+big_key_crypt_fndecl_63316_fields big_key_crypt fndecl 3 63316 &con_out_kvec_add_fndecl_63316_fields
+pkt_len_eth_fast_path_rx_reg_cqe_63328_fields pkt_len eth_fast_path_rx_reg_cqe 0 63328 NULL
+doorbell_start_offset_kgd2kfd_shared_resources_63332_fields doorbell_start_offset kgd2kfd_shared_resources 0 63332 NULL
+gf100_vm_create_fndecl_63335_fields gf100_vm_create fndecl 3-2 63335 NULL
+bulk_out_endpointAddress_usb_serial_port_63340_fields bulk_out_endpointAddress usb_serial_port 0 63340 NULL
+clipcount_out_vivid_dev_63343_fields clipcount_out vivid_dev 0 63343 NULL
+len_n_flags_iwl_rx_packet_63345_fields len_n_flags iwl_rx_packet 0 63345 NULL nohasharray
+pf_cids_qed_cdu_iids_63345_fields pf_cids qed_cdu_iids 0 63345 &len_n_flags_iwl_rx_packet_63345_fields
+src_offset_scif_copy_work_63353_fields src_offset scif_copy_work 0 63353 NULL
+x_zoran_overlay_settings_63359_fields x zoran_overlay_settings 0 63359 NULL
+lbq_buf_size_rx_ring_63363_fields lbq_buf_size rx_ring 0 63363 NULL
+phys_mem_fst_card_info_63365_fields phys_mem fst_card_info 0 63365 NULL
+ascot2e_write_regs_fndecl_63369_fields ascot2e_write_regs fndecl 4 63369 NULL
+alloc_irq_domain_ops_63379_fields alloc irq_domain_ops 0 63379 NULL
+wait_request_timeout_fndecl_63387_fields wait_request_timeout fndecl 0 63387 NULL
+data_len_ubifs_inode_63396_fields data_len ubifs_inode 0 63396 NULL
+buflen_audit_rule_data_63397_fields buflen audit_rule_data 0 63397 NULL nohasharray
+hidp_send_ctrl_message_fndecl_63397_fields hidp_send_ctrl_message fndecl 4 63397 &buflen_audit_rule_data_63397_fields
+efi_memdesc_size_vardecl_runtime_map_c_63399_fields efi_memdesc_size vardecl_runtime-map.c 0 63399 NULL nohasharray
+max_cqes_per_cq_iwch_rnic_attributes_63399_fields max_cqes_per_cq iwch_rnic_attributes 0 63399 &efi_memdesc_size_vardecl_runtime_map_c_63399_fields
+geneve6_build_skb_fndecl_63402_fields geneve6_build_skb fndecl 5 63402 NULL nohasharray
+bnx2_find_max_ring_fndecl_63402_fields bnx2_find_max_ring fndecl 0-2 63402 &geneve6_build_skb_fndecl_63402_fields
+flt_chap_size_ql82xx_hw_data_63406_fields flt_chap_size ql82xx_hw_data 0 63406 NULL
+_drbd_no_send_page_fndecl_63409_fields _drbd_no_send_page fndecl 4 63409 NULL
+lib80211_wep_decrypt_fndecl_63419_fields lib80211_wep_decrypt fndecl 2 63419 NULL
+write_midi_fndecl_63421_fields write_midi fndecl 0-3 63421 NULL
+xfs_buf_set_empty_fndecl_63425_fields xfs_buf_set_empty fndecl 2 63425 NULL
+i2400m_tx_fndecl_63427_fields i2400m_tx fndecl 3-4 63427 NULL
+brcmf_sdio_download_firmware_fndecl_63429_fields brcmf_sdio_download_firmware fndecl 4 63429 NULL
+ocfs2_replace_clusters_fndecl_63430_fields ocfs2_replace_clusters fndecl 5-3 63430 NULL nohasharray
+tas571x_register_size_fndecl_63430_fields tas571x_register_size fndecl 0 63430 &ocfs2_replace_clusters_fndecl_63430_fields nohasharray
+ad_sd_read_reg_raw_fndecl_63430_fields ad_sd_read_reg_raw fndecl 3 63430 &tas571x_register_size_fndecl_63430_fields
+mem_len_bfa_mem_kva_s_63432_fields mem_len bfa_mem_kva_s 0 63432 NULL
+m_max_file_size_ceph_mdsmap_63449_fields m_max_file_size ceph_mdsmap 0 63449 NULL
+max_send_wr_ib_qp_cap_63450_fields max_send_wr ib_qp_cap 0 63450 NULL
+vb2_create_framevec_fndecl_63451_fields vb2_create_framevec fndecl 1-2 63451 NULL
+cmd_status_netdev_desc_63452_fields cmd_status netdev_desc 0 63452 NULL nohasharray
+len_on_first_bd_eth_fast_path_rx_tpa_start_cqe_63452_fields len_on_first_bd eth_fast_path_rx_tpa_start_cqe 0 63452 &cmd_status_netdev_desc_63452_fields
+fuse_send_read_fndecl_63454_fields fuse_send_read fndecl 4 63454 NULL
+sysv_raw_inode_fndecl_63458_fields sysv_raw_inode fndecl 2 63458 NULL
+btrfs_drop_extent_cache_fndecl_63461_fields btrfs_drop_extent_cache fndecl 3-2 63461 NULL
+skb_read_pdu_bhs_fndecl_63463_fields skb_read_pdu_bhs fndecl 0 63463 NULL
+biter_fsl_edma_hw_tcd_63464_fields biter fsl_edma_hw_tcd 0 63464 NULL
+count_ceph_inode_xattrs_info_63465_fields count ceph_inode_xattrs_info 0 63465 NULL
+rcvhdrq_size_qib_ctxtdata_63468_fields rcvhdrq_size qib_ctxtdata 0 63468 NULL
+srq_lmt_max_sge_ocrdma_query_srq_rsp_63477_fields srq_lmt_max_sge ocrdma_query_srq_rsp 0 63477 NULL
+__bm_find_next_fndecl_63479_fields __bm_find_next fndecl 0-2 63479 NULL
+cur_fw_xcb_count_qla_hw_data_63480_fields cur_fw_xcb_count qla_hw_data 0 63480 NULL
+sb_spino_align_xfs_sb_63492_fields sb_spino_align xfs_sb 0 63492 NULL
+find_last_bit_fndecl_63495_fields find_last_bit fndecl 0-2 63495 NULL
+__pcpu_size_to_slot_fndecl_63500_fields __pcpu_size_to_slot fndecl 0 63500 NULL
+icv_len_macsec_secy_63501_fields icv_len macsec_secy 0 63501 NULL
+read_data_offset_smb_version_operations_63502_fields read_data_offset smb_version_operations 0 63502 NULL
+xfs_rtfree_range_fndecl_63511_fields xfs_rtfree_range fndecl 3-4 63511 NULL
+bNrChannels_uac_format_type_i_discrete_descriptor_63512_fields bNrChannels uac_format_type_i_discrete_descriptor 0 63512 NULL
+wIELength_uwb_rc_cmd_set_drp_ie_63528_fields wIELength uwb_rc_cmd_set_drp_ie 0 63528 NULL
+wq_sig_mlx5_ib_qp_63533_fields wq_sig mlx5_ib_qp 0 63533 NULL
+maxvram_video_board_63535_fields maxvram video_board 0 63535 NULL
+num_wsm_ether_type_filter_hdr_63536_fields num wsm_ether_type_filter_hdr 0 63536 NULL
+srp_map_finish_fr_fndecl_63538_fields srp_map_finish_fr fndecl 0 63538 NULL
+num_clips_drm_mode_fb_dirty_cmd_63540_fields num_clips drm_mode_fb_dirty_cmd 0 63540 NULL
+word_size_ixgbe_eeprom_info_63556_fields word_size ixgbe_eeprom_info 0 63556 NULL
+multi_rmw_idx_wmi_63557_fields multi_rmw_idx wmi 0 63557 NULL
+tcp_sync_mss_fndecl_63561_fields tcp_sync_mss fndecl 0-2 63561 NULL
+unmap_granularity_scsi_disk_63574_fields unmap_granularity scsi_disk 0 63574 NULL
+xfs_vm_readpages_fndecl_63575_fields xfs_vm_readpages fndecl 4 63575 NULL
+num_ethernet_queues_bnx2x_63578_fields num_ethernet_queues bnx2x 0 63578 NULL
+ide_raw_taskfile_fndecl_63584_fields ide_raw_taskfile fndecl 4 63584 NULL
+trace_fill_header_fndecl_63588_fields trace_fill_header fndecl 5 63588 NULL
+width_console_font_63590_fields width console_font 0 63590 NULL
+fbmem_viafb_par_63594_fields fbmem viafb_par 0 63594 NULL nohasharray
+ri_cno_nilfs_recovery_info_63594_fields ri_cno nilfs_recovery_info 0 63594 &fbmem_viafb_par_63594_fields
+srp_map_data_fndecl_63596_fields srp_map_data fndecl 0 63596 NULL
+f2_id_amd64_family_type_63598_fields f2_id amd64_family_type 0 63598 NULL
+size_dmaengine_unmap_pool_63599_fields size dmaengine_unmap_pool 0 63599 NULL nohasharray
+dbFree_fndecl_63599_fields dbFree fndecl 3-2 63599 &size_dmaengine_unmap_pool_63599_fields
+snd_pcm_plug_alloc_fndecl_63600_fields snd_pcm_plug_alloc fndecl 2 63600 NULL
+offset_pci_sriov_63604_fields offset pci_sriov 0 63604 NULL
+rx_mtu_p54_common_63619_fields rx_mtu p54_common 0 63619 NULL
+len_fscrypt_str_63626_fields len fscrypt_str 0 63626 NULL
+buf_len_mwifiex_sdio_mpa_rx_63636_fields buf_len mwifiex_sdio_mpa_rx 0 63636 NULL nohasharray
+find_run_fndecl_63636_fields find_run fndecl 0 63636 &buf_len_mwifiex_sdio_mpa_rx_63636_fields
+be_v_offset_pnfs_block_extent_63637_fields be_v_offset pnfs_block_extent 0 63637 NULL nohasharray
+rx_ring_size_gfar_priv_rx_q_63637_fields rx_ring_size gfar_priv_rx_q 0 63637 &be_v_offset_pnfs_block_extent_63637_fields
+spad_count_ntb_dev_ops_63660_fields spad_count ntb_dev_ops 0 63660 NULL
+id_nvdimm_63666_fields id nvdimm 0 63666 NULL
+nr_map_e820map_63674_fields nr_map e820map 0 63674 NULL
+nfs_writepage_setup_fndecl_63682_fields nfs_writepage_setup fndecl 3-4 63682 NULL
+pci_get_device_func_fndecl_63689_fields pci_get_device_func fndecl 2 63689 NULL
+nr_pages_msc_63690_fields nr_pages msc 0 63690 NULL
+cell_error_with_code_fndecl_63693_fields cell_error_with_code fndecl 3 63693 NULL
+obj_size_proto_63697_fields obj_size proto 0 63697 NULL
+adv76xx_read_check_fndecl_63705_fields adv76xx_read_check fndecl 0 63705 NULL
+real_trim_memory_fndecl_63709_fields real_trim_memory fndecl 1-2 63709 NULL
+owner_snd_ctl_elem_info_63711_fields owner snd_ctl_elem_info 0 63711 NULL
+index_dtsplit_63712_fields index dtsplit 0 63712 NULL nohasharray
+xfs_alloc_compute_aligned_fndecl_63712_fields xfs_alloc_compute_aligned fndecl 3-2 63712 &index_dtsplit_63712_fields
+kernel_recvmsg_fndecl_63713_fields kernel_recvmsg fndecl 0-5-4 63713 NULL
+omfs_readpages_fndecl_63721_fields omfs_readpages fndecl 4 63721 NULL
+osd_vis_h_yuv_playback_info_63734_fields osd_vis_h yuv_playback_info 0 63734 NULL
+pci_hotplug_mem_size_vardecl_63735_fields pci_hotplug_mem_size vardecl 0 63735 NULL
+get_mergeable_buf_len_fndecl_63736_fields get_mergeable_buf_len fndecl 0 63736 NULL
+__register_chrdev_region_fndecl_63741_fields __register_chrdev_region fndecl 1 63741 NULL
+size_vb2_dc_buf_63751_fields size vb2_dc_buf 0 63751 NULL
+target_size_scsi_transport_template_63753_fields target_size scsi_transport_template 0 63753 NULL
+mp_irqdomain_get_attr_fndecl_63759_fields mp_irqdomain_get_attr fndecl 1 63759 NULL
+ath6kl_wmi_remain_on_chnl_cmd_fndecl_63760_fields ath6kl_wmi_remain_on_chnl_cmd fndecl 2 63760 NULL
+xfs_qm_dqalloc_fndecl_63762_fields xfs_qm_dqalloc fndecl 5-0 63762 NULL nohasharray
+index_isi_board_63762_fields index isi_board 0 63762 &xfs_qm_dqalloc_fndecl_63762_fields
+device_get_child_node_count_fndecl_63779_fields device_get_child_node_count fndecl 0 63779 NULL
+__xfs_rmap_add_fndecl_63780_fields __xfs_rmap_add fndecl 0 63780 NULL
+f2fs_xattr_generic_set_fndecl_63782_fields f2fs_xattr_generic_set fndecl 6 63782 NULL
+items_priv_size_vxge_hw_mempool_63785_fields items_priv_size vxge_hw_mempool 0 63785 NULL
+num_slices_myri10ge_priv_63789_fields num_slices myri10ge_priv 0 63789 NULL
+order_pmcraid_sglist_63792_fields order pmcraid_sglist 0 63792 NULL nohasharray
+orinoco_mic_fndecl_63792_fields orinoco_mic fndecl 7 63792 &order_pmcraid_sglist_63792_fields
+modem_write_cmd_fndecl_63794_fields modem_write_cmd fndecl 3 63794 NULL nohasharray
+dpcm_capture_snd_soc_dai_link_63794_fields dpcm_capture snd_soc_dai_link 0 63794 &modem_write_cmd_fndecl_63794_fields
+read_prph_iwl_trans_ops_63799_fields read_prph iwl_trans_ops 0 63799 NULL
+nouveau_ttm_tt_create_fndecl_63801_fields nouveau_ttm_tt_create fndecl 2 63801 NULL
+ncp_add_mem_fndecl_63822_fields ncp_add_mem fndecl 3 63822 NULL nohasharray
+named_prepare_buf_fndecl_63822_fields named_prepare_buf fndecl 3 63822 &ncp_add_mem_fndecl_63822_fields
+len_extent_map_63823_fields len extent_map 0 63823 NULL
+jffs2_do_link_fndecl_63827_fields jffs2_do_link fndecl 6 63827 NULL
+compat_sys_sendfile_fndecl_63828_fields compat_sys_sendfile fndecl 4 63828 NULL
+alt_mem_k_boot_params_63829_fields alt_mem_k boot_params 0 63829 NULL
+rpipe_aim_fndecl_63832_fields rpipe_aim fndecl 0 63832 NULL
+p_end_nilfs_period_63833_fields p_end nilfs_period 0 63833 NULL
+rx_ring_order_vardecl_main_c_63838_fields rx_ring_order vardecl_main.c 0 63838 NULL
+media_entity_pads_init_fndecl_63846_fields media_entity_pads_init fndecl 2 63846 NULL
+yskip_mt9t031_63853_fields yskip mt9t031 0 63853 NULL
+rx_data_size_sky2_port_63855_fields rx_data_size sky2_port 0 63855 NULL nohasharray
+submit_inquiry_fndecl_63855_fields submit_inquiry fndecl 3 63855 &rx_data_size_sky2_port_63855_fields
+out_phase_peeked_usb_stream_kernel_63871_fields out_phase_peeked usb_stream_kernel 0 63871 NULL
+ssid_len_ieee80211_if_ibss_63872_fields ssid_len ieee80211_if_ibss 0 63872 NULL nohasharray
+Read_hfc16_stable_fndecl_63872_fields Read_hfc16_stable fndecl 0 63872 &ssid_len_ieee80211_if_ibss_63872_fields
+xlvbd_alloc_gendisk_fndecl_63874_fields xlvbd_alloc_gendisk fndecl 4-5 63874 NULL
+__btrfs_unlink_inode_fndecl_63889_fields __btrfs_unlink_inode fndecl 6 63889 NULL
+lmWriteRecord_fndecl_63896_fields lmWriteRecord fndecl 0 63896 NULL
+sent_kcm_tx_msg_63899_fields sent kcm_tx_msg 0 63899 NULL
+ext4_do_update_inode_fndecl_63900_fields ext4_do_update_inode fndecl 0 63900 NULL
+tx_cnt_fritz_bcs_63901_fields tx_cnt fritz_bcs 0 63901 NULL
+mmc_align_data_size_fndecl_63906_fields mmc_align_data_size fndecl 0-2 63906 NULL nohasharray
+fraglen_encryptor_desc_63906_fields fraglen encryptor_desc 0 63906 &mmc_align_data_size_fndecl_63906_fields
+fw_stats_len_wl1271_stats_63915_fields fw_stats_len wl1271_stats 0 63915 NULL
+iwl_mvm_send_cmd_fndecl_63918_fields iwl_mvm_send_cmd fndecl 0 63918 NULL
+align_nft_set_ext_type_63919_fields align nft_set_ext_type 0 63919 NULL nohasharray
+new_data_offset_md_rdev_63919_fields new_data_offset md_rdev 0 63919 &align_nft_set_ext_type_63919_fields
+nilfs_ifile_read_fndecl_63921_fields nilfs_ifile_read fndecl 3 63921 NULL
+start_btrfs_ioctl_defrag_range_args_63924_fields start btrfs_ioctl_defrag_range_args 0 63924 NULL
+efx_change_mtu_fndecl_63926_fields efx_change_mtu fndecl 2 63926 NULL
+dentry_needs_remove_privs_fndecl_63934_fields dentry_needs_remove_privs fndecl 0 63934 NULL
+ro_maxpages_rpcrdma_memreg_ops_63937_fields ro_maxpages rpcrdma_memreg_ops 0 63937 NULL nohasharray
+filemark_cnt_osst_tape_63937_fields filemark_cnt osst_tape 0 63937 &ro_maxpages_rpcrdma_memreg_ops_63937_fields
+Xfacs_acpi_table_fadt_63943_fields Xfacs acpi_table_fadt 0 63943 NULL
+replen_compound_hdr_63944_fields replen compound_hdr 0 63944 NULL
+map_szl_cyttsp4_sysinfo_data_63948_fields map_szl cyttsp4_sysinfo_data 0 63948 NULL
+pcfg_ofs_cyttsp4_sysinfo_ofs_63956_fields pcfg_ofs cyttsp4_sysinfo_ofs 0 63956 NULL
+psb_gtt_alloc_range_fndecl_63966_fields psb_gtt_alloc_range fndecl 2-5 63966 NULL
+bt_ep_bcm5974_config_63978_fields bt_ep bcm5974_config 0 63978 NULL
+max_lba_sm_ftl_63992_fields max_lba sm_ftl 0 63992 NULL
+ihandlen_compat_xfs_fsop_handlereq_63994_fields ihandlen compat_xfs_fsop_handlereq 0 63994 NULL
+iomap_end_iomap_ops_63997_fields iomap_end iomap_ops 0 63997 NULL
+vram_start_amdgpu_mc_63998_fields vram_start amdgpu_mc 0 63998 NULL
+iscsi_conn_send_pdu_fndecl_64002_fields iscsi_conn_send_pdu fndecl 4 64002 NULL
+pvr2_send_request_ex_fndecl_64004_fields pvr2_send_request_ex fndecl 5-7 64004 NULL
+ndescs_clk_corediv_soc_desc_64005_fields ndescs clk_corediv_soc_desc 0 64005 NULL
+field_count_audit_krule_64007_fields field_count audit_krule 0 64007 NULL
+pinctrl_register_map_fndecl_64010_fields pinctrl_register_map fndecl 2 64010 NULL
+rx_ring_size_fe_priv_64012_fields rx_ring_size fe_priv 0 64012 NULL
+wBlocks_usb_rpipe_descriptor_64014_fields wBlocks usb_rpipe_descriptor 0 64014 NULL
+space_snd_ctl_elem_list_64016_fields space snd_ctl_elem_list 0 64016 NULL
+n_sectors_flash_info_64017_fields n_sectors flash_info 0 64017 NULL
+dma_drain_size_request_queue_64023_fields dma_drain_size request_queue 0 64023 NULL
+extAlloc_fndecl_64026_fields extAlloc fndecl 3 64026 NULL
+kxtj9_i2c_read_fndecl_64041_fields kxtj9_i2c_read fndecl 4 64041 NULL
+ieee80211_request_ibss_scan_fndecl_64043_fields ieee80211_request_ibss_scan fndecl 3 64043 NULL
+xdr_partial_copy_from_skb_fndecl_64046_fields xdr_partial_copy_from_skb fndecl 0 64046 NULL
+devs_increment_btrfs_raid_attr_64050_fields devs_increment btrfs_raid_attr 0 64050 NULL
+koneplus_sysfs_read_fndecl_64059_fields koneplus_sysfs_read fndecl 6 64059 NULL
+claim_region_fndecl_64076_fields claim_region fndecl 3-2 64076 NULL
+dma_size_cx88_audio_dev_64082_fields dma_size cx88_audio_dev 0 64082 NULL
+xfs_iomap_eof_prealloc_initial_size_fndecl_64085_fields xfs_iomap_eof_prealloc_initial_size fndecl 3 64085 NULL nohasharray
+max_request_cros_ec_device_64085_fields max_request cros_ec_device 0 64085 &xfs_iomap_eof_prealloc_initial_size_fndecl_64085_fields
+s_end_bfs_super_block_64092_fields s_end bfs_super_block 0 64092 NULL
+act_len_htc_packet_64101_fields act_len htc_packet 0 64101 NULL
+b53_spi_read_fndecl_64106_fields b53_spi_read fndecl 5 64106 NULL
+j_first_unflushed_offset_reiserfs_journal_header_64107_fields j_first_unflushed_offset reiserfs_journal_header 0 64107 NULL
+ncells_nvmem_config_64108_fields ncells nvmem_config 0 64108 NULL
+lmac_count_bgx_64109_fields lmac_count bgx 0 64109 NULL
+fc_copy_buffer_to_sglist_fndecl_64115_fields fc_copy_buffer_to_sglist fndecl 0-2 64115 NULL
+amdgpu_bo_set_metadata_fndecl_64120_fields amdgpu_bo_set_metadata fndecl 3 64120 NULL
+gigaset_fill_inbuf_fndecl_64130_fields gigaset_fill_inbuf fndecl 3 64130 NULL
+gru_alloc_locked_gts_fndecl_64132_fields gru_alloc_locked_gts fndecl 1 64132 NULL
+alx_change_mtu_fndecl_64137_fields alx_change_mtu fndecl 2 64137 NULL
+xenvif_count_requests_fndecl_64138_fields xenvif_count_requests fndecl 0 64138 NULL nohasharray
+ieee80211_tdls_mgmt_teardown_fndecl_64138_fields ieee80211_tdls_mgmt_teardown fndecl 10 64138 &xenvif_count_requests_fndecl_64138_fields
+pskb_expand_head_fndecl_64146_fields pskb_expand_head fndecl 2 64146 NULL
+free_bootmem_fndecl_64150_fields free_bootmem fndecl 2-1 64150 NULL
+llimit_ulp_iscsi_info_64159_fields llimit ulp_iscsi_info 0 64159 NULL
+btrfs_readpage_end_io_hook_fndecl_64160_fields btrfs_readpage_end_io_hook fndecl 4-5 64160 NULL
+drbd_header_size_fndecl_64163_fields drbd_header_size fndecl 0 64163 NULL
+pq_align_dma_device_64165_fields pq_align dma_device 0 64165 NULL nohasharray
+max_gs_mthca_wq_64165_fields max_gs mthca_wq 0 64165 &pq_align_dma_device_64165_fields
+xfs_bmapi_allocate_fndecl_64169_fields xfs_bmapi_allocate fndecl 0 64169 NULL
+ext4_get_stripe_size_fndecl_64170_fields ext4_get_stripe_size fndecl 0 64170 NULL
+nfcid1_len_nfc_target_64182_fields nfcid1_len nfc_target 0 64182 NULL
+wait_reserve_ticket_fndecl_64185_fields wait_reserve_ticket fndecl 0 64185 NULL nohasharray
+lba_to_arena_fndecl_64185_fields lba_to_arena fndecl 0 64185 &wait_reserve_ticket_fndecl_64185_fields
+phys_pcm_format_data_64188_fields phys pcm_format_data 0 64188 NULL
+bi_error_bio_64189_fields bi_error bio 0 64189 NULL
+bulk_out_endpointAddr_usb_ftdi_64197_fields bulk_out_endpointAddr usb_ftdi 0 64197 NULL
+pcibios_scan_specific_bus_fndecl_64203_fields pcibios_scan_specific_bus fndecl 1 64203 NULL
+ath6kl_wmi_pmparams_cmd_fndecl_64204_fields ath6kl_wmi_pmparams_cmd fndecl 2 64204 NULL
+mlx5e_change_mtu_fndecl_64217_fields mlx5e_change_mtu fndecl 2 64217 NULL
+outbuf_dma_usbhid_device_64218_fields outbuf_dma usbhid_device 0 64218 NULL
+start_pfn_xen_memory_region_64226_fields start_pfn xen_memory_region 0 64226 NULL
+f2fs_move_file_range_fndecl_64227_fields f2fs_move_file_range fndecl 4 64227 NULL
+balance_dirty_pages_fndecl_64228_fields balance_dirty_pages fndecl 3 64228 NULL
+ecdh_supported_curve_fndecl_64237_fields ecdh_supported_curve fndecl 0 64237 NULL
+format_chain_fndecl_64242_fields format_chain fndecl 2 64242 NULL
+bNbrPorts_usb_hub_descriptor_64245_fields bNbrPorts usb_hub_descriptor 0 64245 NULL
+payload_sz_status_msg_64247_fields payload_sz status_msg 0 64247 NULL
+ccid_hc_rx_obj_size_ccid_operations_64257_fields ccid_hc_rx_obj_size ccid_operations 0 64257 NULL
+num_entries_wmi_target_roam_tbl_64263_fields num_entries wmi_target_roam_tbl 0 64263 NULL
+getxattr_cb_ceph_vxattr_64271_fields getxattr_cb ceph_vxattr 0 64271 NULL nohasharray
+dio_bio_complete_fndecl_64271_fields dio_bio_complete fndecl 0 64271 &getxattr_cb_ceph_vxattr_64271_fields
+dm_tm_read_lock_fndecl_64272_fields dm_tm_read_lock fndecl 2 64272 NULL
+t_prot_nents_se_cmd_64282_fields t_prot_nents se_cmd 0 64282 NULL
+dev_number_vardecl_rio_cm_c_64286_fields dev_number vardecl_rio_cm.c 0 64286 NULL
+_dump_buf_data_order_vardecl_64288_fields _dump_buf_data_order vardecl 0 64288 NULL
+dev_minor_cuse_init_out_64292_fields dev_minor cuse_init_out 0 64292 NULL
+num_bds_table_bd_list_64306_fields num_bds_table bd_list 0 64306 NULL
+vfp_ast_vbios_enhtable_64307_fields vfp ast_vbios_enhtable 0 64307 NULL nohasharray
+sq_size_vardecl_64307_fields sq_size vardecl 0 64307 &vfp_ast_vbios_enhtable_64307_fields
+sys_vmsplice_fndecl_64310_fields sys_vmsplice fndecl 3 64310 NULL
+cw_putcs_fndecl_64311_fields cw_putcs fndecl 4-5-6 64311 NULL
+__wa_xfer_setup_fndecl_64316_fields __wa_xfer_setup fndecl 0 64316 NULL
+alloc_descs_fndecl_64324_fields alloc_descs fndecl 0-1 64324 NULL
+hs_descs_count_ffs_data_64332_fields hs_descs_count ffs_data 0 64332 NULL
+tx_padding_usbatm_driver_64341_fields tx_padding usbatm_driver 0 64341 NULL
+vif_data_size_ieee80211_hw_64342_fields vif_data_size ieee80211_hw 0 64342 NULL
+apply_vma_lock_flags_fndecl_64346_fields apply_vma_lock_flags fndecl 2-1 64346 NULL
+part_start_hfsplus_sb_info_64347_fields part_start hfsplus_sb_info 0 64347 NULL
+bytesperline_au0828_dev_64350_fields bytesperline au0828_dev 0 64350 NULL
+opcount_compat_xfs_fsop_attrmulti_handlereq_64355_fields opcount compat_xfs_fsop_attrmulti_handlereq 0 64355 NULL
+logfs_truncate_fndecl_64356_fields logfs_truncate fndecl 2 64356 NULL
+isofs_get_blocks_fndecl_64368_fields isofs_get_blocks fndecl 2 64368 NULL nohasharray
+hpi_instream_host_buffer_allocate_fndecl_64368_fields hpi_instream_host_buffer_allocate fndecl 2 64368 &isofs_get_blocks_fndecl_64368_fields
+map_state_fndecl_64377_fields map_state fndecl 1 64377 NULL
+hdr_len_ib_mac_iocb_rsp_64379_fields hdr_len ib_mac_iocb_rsp 0 64379 NULL
+num_rxd_qlcnic_adapter_64380_fields num_rxd qlcnic_adapter 0 64380 NULL
+endio_readpage_release_extent_fndecl_64387_fields endio_readpage_release_extent fndecl 3-2 64387 NULL
+mem_kexec_segment_64393_fields mem kexec_segment 0 64393 NULL
+MemoryWindowSize_DAC960_privdata_64399_fields MemoryWindowSize DAC960_privdata 0 64399 NULL
+oobretlen_mtd_oob_ops_64400_fields oobretlen mtd_oob_ops 0 64400 NULL
+init_data_si_sm_handlers_64406_fields init_data si_sm_handlers 0 64406 NULL
+__get_user_pages_unlocked_fndecl_64409_fields __get_user_pages_unlocked fndecl 3 64409 NULL
+cdc_ncm_max_dgram_size_fndecl_64415_fields cdc_ncm_max_dgram_size fndecl 0 64415 NULL
+l2tp_xmit_skb_fndecl_64419_fields l2tp_xmit_skb fndecl 3 64419 NULL
+ssid_len_cfg80211_ap_settings_64422_fields ssid_len cfg80211_ap_settings 0 64422 NULL
+nfs4_new_slot_fndecl_64436_fields nfs4_new_slot fndecl 2 64436 NULL
+index_v4l2_frmivalenum_64442_fields index v4l2_frmivalenum 0 64442 NULL
+sierra_net_send_cmd_fndecl_64455_fields sierra_net_send_cmd fndecl 3 64455 NULL
+bLength_uvc_control_endpoint_descriptor_64456_fields bLength uvc_control_endpoint_descriptor 0 64456 NULL
+jpg_size_s2255_vc_64457_fields jpg_size s2255_vc 0 64457 NULL
+num_ch_st_sensor_settings_64459_fields num_ch st_sensor_settings 0 64459 NULL
+__ocfs2_decrease_refcount_fndecl_64462_fields __ocfs2_decrease_refcount fndecl 5-4 64462 NULL
+send_write_chunks_fndecl_64466_fields send_write_chunks fndecl 0 64466 NULL
+btrfs_grow_device_fndecl_64468_fields btrfs_grow_device fndecl 3 64468 NULL
+acpi_dev_get_irqresource_fndecl_64469_fields acpi_dev_get_irqresource fndecl 2 64469 NULL
+burst_mode_ratio_intel_dsi_64472_fields burst_mode_ratio intel_dsi 0 64472 NULL
+vb2_read_fndecl_64476_fields vb2_read fndecl 3 64476 NULL nohasharray
+new_blkaddr_f2fs_io_info_64476_fields new_blkaddr f2fs_io_info 0 64476 &vb2_read_fndecl_64476_fields
+pid_vnr_fndecl_64480_fields pid_vnr fndecl 0 64480 NULL nohasharray
+nr_dirtied_pause_task_struct_64480_fields nr_dirtied_pause task_struct 0 64480 &pid_vnr_fndecl_64480_fields
+transport_header_sk_buff_64483_fields transport_header sk_buff 0 64483 NULL
+SendReceive2_fndecl_64485_fields SendReceive2 fndecl 4 64485 NULL
+vhost_hlen_vhost_net_virtqueue_64488_fields vhost_hlen vhost_net_virtqueue 0 64488 NULL
+val_reginit_item_64493_fields val reginit_item 0 64493 NULL
+__FIXADDR_TOP_vardecl_64494_fields __FIXADDR_TOP vardecl 0 64494 NULL nohasharray
+mrf24j40_long_regmap_write_fndecl_64494_fields mrf24j40_long_regmap_write fndecl 3 64494 &__FIXADDR_TOP_vardecl_64494_fields
+ddr_end_intel_sst_drv_64496_fields ddr_end intel_sst_drv 0 64496 NULL
+read_status_fndecl_64497_fields read_status fndecl 0 64497 NULL
+ext_ramdisk_size_boot_params_64498_fields ext_ramdisk_size boot_params 0 64498 NULL
+num_def_tx_descs_octeon_config_64501_fields num_def_tx_descs octeon_config 0 64501 NULL
+dvb_demux_ioctl_fndecl_64510_fields dvb_demux_ioctl fndecl 2 64510 NULL
+fc_plogi_get_maxframe_fndecl_64511_fields fc_plogi_get_maxframe fndecl 0-2 64511 NULL
+at24_eeprom_read_serial_fndecl_64518_fields at24_eeprom_read_serial fndecl 4 64518 NULL
+insize_cros_ec_command_64521_fields insize cros_ec_command 0 64521 NULL
+hdr_len_st_proto_s_64523_fields hdr_len st_proto_s 0 64523 NULL
+tcp_reno_cong_avoid_fndecl_64525_fields tcp_reno_cong_avoid fndecl 3 64525 NULL
+tun_alloc_skb_fndecl_64531_fields tun_alloc_skb fndecl 4-3-2 64531 NULL
+txq_cnt_tg3_64539_fields txq_cnt tg3 0 64539 NULL
+fw_dump_tmplt_size_scsi_qla_host_64541_fields fw_dump_tmplt_size scsi_qla_host 0 64541 NULL
+phys_size_ntb_transport_mw_64544_fields phys_size ntb_transport_mw 0 64544 NULL
+minix_V1_raw_inode_fndecl_64554_fields minix_V1_raw_inode fndecl 2 64554 NULL
+expected_count_hfi1_ctxtdata_64557_fields expected_count hfi1_ctxtdata 0 64557 NULL
+valid_tty_audit_buf_64560_fields valid tty_audit_buf 0 64560 NULL
+stv090x_write_regs_fndecl_64562_fields stv090x_write_regs fndecl 4 64562 NULL
+blockshift_nand_flash_dev_64570_fields blockshift nand_flash_dev 0 64570 NULL
+offset_seg_buf_64571_fields offset seg_buf 0 64571 NULL
+__fprog_create_fndecl_64572_fields __fprog_create fndecl 2 64572 NULL
+erst_read_fndecl_64575_fields erst_read fndecl 1 64575 NULL nohasharray
+mirrors_p1_ore_layout_64575_fields mirrors_p1 ore_layout 0 64575 &erst_read_fndecl_64575_fields nohasharray
+cdc_ncm_align_tail_fndecl_64575_fields cdc_ncm_align_tail fndecl 4-3-2 64575 &mirrors_p1_ore_layout_64575_fields
+msb_set_overwrite_flag_fndecl_64576_fields msb_set_overwrite_flag fndecl 2 64576 NULL
+long_len_fat_ioctl_filldir_callback_64585_fields long_len fat_ioctl_filldir_callback 0 64585 NULL nohasharray
+len_fuse_copy_state_64585_fields len fuse_copy_state 0 64585 &long_len_fat_ioctl_filldir_callback_64585_fields
+blocks_per_seg_f2fs_sb_info_64587_fields blocks_per_seg f2fs_sb_info 0 64587 NULL
+t4_init_l2t_fndecl_64588_fields t4_init_l2t fndecl 1-2 64588 NULL
+udl_gem_create_fndecl_64590_fields udl_gem_create fndecl 3 64590 NULL
+isp1362_urb_dequeue_fndecl_64595_fields isp1362_urb_dequeue fndecl 3 64595 NULL
+s_gdb_count_ext4_sb_info_64617_fields s_gdb_count ext4_sb_info 0 64617 NULL
+xfs_iext_remove_indirect_fndecl_64624_fields xfs_iext_remove_indirect fndecl 3 64624 NULL
+objio_alloc_io_state_fndecl_64631_fields objio_alloc_io_state fndecl 7-6 64631 NULL
+bsg_job_done_fndecl_64640_fields bsg_job_done fndecl 3 64640 NULL
+tpacket_fill_skb_fndecl_64651_fields tpacket_fill_skb fndecl 10-6-9 64651 NULL
+netlink_alloc_large_skb_fndecl_64652_fields netlink_alloc_large_skb fndecl 1 64652 NULL
+cnic_init_id_tbl_fndecl_64665_fields cnic_init_id_tbl fndecl 3 64665 NULL
+maximum_num_containers_aac_dev_64672_fields maximum_num_containers aac_dev 0 64672 NULL
+mapbase_uart_port_64681_fields mapbase uart_port 0 64681 NULL
+xfs_trans_mod_sb_fndecl_64682_fields xfs_trans_mod_sb fndecl 3 64682 NULL
+num_fields_ima_template_desc_64688_fields num_fields ima_template_desc 0 64688 NULL
+i40iw_send_mpa_reject_fndecl_64702_fields i40iw_send_mpa_reject fndecl 3 64702 NULL nohasharray
+max_ars_nfit_spa_64702_fields max_ars nfit_spa 0 64702 &i40iw_send_mpa_reject_fndecl_64702_fields
+size_cramfs_inode_64704_fields size cramfs_inode 0 64704 NULL
+isdn_ppp_fill_rq_fndecl_64711_fields isdn_ppp_fill_rq fndecl 2 64711 NULL
+base_cmdline_vardecl_dma_contiguous_c_64713_fields base_cmdline vardecl_dma-contiguous.c 0 64713 NULL nohasharray
+peek_len_proto_ops_64713_fields peek_len proto_ops 0 64713 &base_cmdline_vardecl_dma_contiguous_c_64713_fields
+rcount_x25_asy_64715_fields rcount x25_asy 0 64715 NULL
+width_drm_framebuffer_64716_fields width drm_framebuffer 0 64716 NULL
+spc_modesense_long_blockdesc_fndecl_64717_fields spc_modesense_long_blockdesc fndecl 0 64717 NULL
+pool_index_max_cxgbi_ppm_64718_fields pool_index_max cxgbi_ppm 0 64718 NULL nohasharray
+vs_bsize_vxfs_sb_64718_fields vs_bsize vxfs_sb 0 64718 &pool_index_max_cxgbi_ppm_64718_fields nohasharray
+goldfish_tty_current_line_count_vardecl_goldfish_c_64718_fields goldfish_tty_current_line_count vardecl_goldfish.c 0 64718 &vs_bsize_vxfs_sb_64718_fields
+mt7601u_dma_fw_fndecl_64719_fields mt7601u_dma_fw fndecl 4 64719 NULL
+size_host_cmd_ds_command_64722_fields size host_cmd_ds_command 0 64722 NULL
+max_touch_num_goodix_ts_data_64725_fields max_touch_num goodix_ts_data 0 64725 NULL
+xfs_iext_add_fndecl_64733_fields xfs_iext_add fndecl 3 64733 NULL
+last_mgmt_tx_frame_len_wmi_64739_fields last_mgmt_tx_frame_len wmi 0 64739 NULL
+se_io_cb_fndecl_64742_fields se_io_cb fndecl 3 64742 NULL
+ulite_assign_fndecl_64744_fields ulite_assign fndecl 3-2 64744 NULL
+net_frag_header_len_inet_connection_sock_af_ops_64745_fields net_frag_header_len inet_connection_sock_af_ops 0 64745 NULL
+create_pid_cachep_fndecl_64753_fields create_pid_cachep fndecl 1 64753 NULL
+ocfs2_fill_initial_dirents_fndecl_64755_fields ocfs2_fill_initial_dirents fndecl 4 64755 NULL
+datasz_memelfnote_64760_fields datasz memelfnote 0 64760 NULL
+raid_disk_mdp_device_descriptor_s_64762_fields raid_disk mdp_device_descriptor_s 0 64762 NULL
+vid_begin_switchdev_obj_port_vlan_64767_fields vid_begin switchdev_obj_port_vlan 0 64767 NULL
+full_len_kcm_rx_msg_64771_fields full_len kcm_rx_msg 0 64771 NULL
+jfs_get_block_fndecl_64772_fields jfs_get_block fndecl 2 64772 NULL
+ib_qib_max_srq_sges_vardecl_64786_fields ib_qib_max_srq_sges vardecl 0 64786 NULL nohasharray
+keep_resources_fndecl_64786_fields keep_resources fndecl 6-5 64786 &ib_qib_max_srq_sges_vardecl_64786_fields
+tun_hlen_ip_tunnel_64791_fields tun_hlen ip_tunnel 0 64791 NULL
+_update_journal_header_block_fndecl_64803_fields _update_journal_header_block fndecl 2 64803 NULL nohasharray
+fr_max_payload_fcoe_rcv_info_64803_fields fr_max_payload fcoe_rcv_info 0 64803 &_update_journal_header_block_fndecl_64803_fields
+tx_headroom_nci_dev_64805_fields tx_headroom nci_dev 0 64805 NULL
+alloc_align_snd_array_64806_fields alloc_align snd_array 0 64806 NULL
+f2fs_set_context_fndecl_64813_fields f2fs_set_context fndecl 3 64813 NULL
+reg_list_size_amdgpu_rlc_64826_fields reg_list_size amdgpu_rlc 0 64826 NULL
+ocfs2_xattr_index_block_find_fndecl_64835_fields ocfs2_xattr_index_block_find fndecl 0 64835 NULL
+ngpio_gpio_chip_64845_fields ngpio gpio_chip 0 64845 NULL nohasharray
+smsc75xx_change_mtu_fndecl_64845_fields smsc75xx_change_mtu fndecl 2 64845 &ngpio_gpio_chip_64845_fields
+_send_fndecl_64846_fields _send fndecl 3 64846 NULL nohasharray
+ath6kl_wmi_sta_bmiss_enhance_cmd_fndecl_64846_fields ath6kl_wmi_sta_bmiss_enhance_cmd fndecl 2 64846 &_send_fndecl_64846_fields
+_req_append_segment_fndecl_64852_fields _req_append_segment fndecl 2 64852 NULL
+log_max_len_client_hdr_64853_fields log_max_len client_hdr 0 64853 NULL nohasharray
+E_info_CARD_PROPERTIES_64853_fields E_info CARD_PROPERTIES 0 64853 &log_max_len_client_hdr_64853_fields
+bud_wbuf_callback_fndecl_64863_fields bud_wbuf_callback fndecl 3 64863 NULL
+vring_create_virtqueue_fndecl_64864_fields vring_create_virtqueue fndecl 2 64864 NULL
+raw_recvmsg_fndecl_64866_fields raw_recvmsg fndecl 3 64866 NULL nohasharray
+len_discard_entry_64866_fields len discard_entry 0 64866 &raw_recvmsg_fndecl_64866_fields
+p_linux_binprm_64868_fields p linux_binprm 0 64868 NULL
+rq_count_enic_64875_fields rq_count enic 0 64875 NULL
+tx_ring_size_fe_priv_64876_fields tx_ring_size fe_priv 0 64876 NULL
+tx_max_frame_ntb_transport_qp_64878_fields tx_max_frame ntb_transport_qp 0 64878 NULL
+snd_pcm_hw_param_max_fndecl_64887_fields snd_pcm_hw_param_max fndecl 4 64887 NULL nohasharray
+qs_in_channels_hdspm_64887_fields qs_in_channels hdspm 0 64887 &snd_pcm_hw_param_max_fndecl_64887_fields
+count_ioctl_gntalloc_alloc_gref_64889_fields count ioctl_gntalloc_alloc_gref 0 64889 NULL nohasharray
+ks8995_write_fndecl_64889_fields ks8995_write fndecl 4 64889 &count_ioctl_gntalloc_alloc_gref_64889_fields
+xfs_defer_trans_roll_fndecl_64897_fields xfs_defer_trans_roll fndecl 0 64897 NULL
+mpeglinesize_vardecl_cx23885_417_c_64898_fields mpeglinesize vardecl_cx23885-417.c 0 64898 NULL
+__ieee80211_amsdu_copy_fndecl_64900_fields __ieee80211_amsdu_copy fndecl 4-2-3 64900 NULL
+unuse_pte_range_fndecl_64903_fields unuse_pte_range fndecl 3 64903 NULL
+data_size_event_reader_64909_fields data_size event_reader 0 64909 NULL
+nmsgs_i2c_rdwr_ioctl_data_64911_fields nmsgs i2c_rdwr_ioctl_data 0 64911 NULL
+next_block_for_io_dio_submit_64914_fields next_block_for_io dio_submit 0 64914 NULL
+rd_size_uhid_create_req_64916_fields rd_size uhid_create_req 0 64916 NULL
+dma_attach_fndecl_64917_fields dma_attach fndecl 10-8-7 64917 NULL
+piothreshold_vardecl_64919_fields piothreshold vardecl 0 64919 NULL
+nl80211_send_mlme_event_fndecl_64920_fields nl80211_send_mlme_event fndecl 4 64920 NULL
+verity_for_bv_block_fndecl_64936_fields verity_for_bv_block fndecl 0 64936 NULL
+ath10k_wmi_tlv_op_gen_bcn_tmpl_fndecl_64938_fields ath10k_wmi_tlv_op_gen_bcn_tmpl fndecl 8 64938 NULL nohasharray
+sq_max_wqes_per_wr_mlx4_ib_qp_64938_fields sq_max_wqes_per_wr mlx4_ib_qp 0 64938 &ath10k_wmi_tlv_op_gen_bcn_tmpl_fndecl_64938_fields
+ieee80211_start_tx_ba_cb_irqsafe_fndecl_64943_fields ieee80211_start_tx_ba_cb_irqsafe fndecl 3 64943 NULL
+pci_iov_virtfn_bus_fndecl_64949_fields pci_iov_virtfn_bus fndecl 0-2 64949 NULL
+ieee80211_tdls_add_ies_fndecl_64954_fields ieee80211_tdls_add_ies fndecl 8 64954 NULL
+status_spi_message_64956_fields status spi_message 0 64956 NULL
+count_acpi_processor_power_64969_fields count acpi_processor_power 0 64969 NULL
+len_ctrl_queue_64975_fields len ctrl_queue 0 64975 NULL
+hq_size_cnic_local_64987_fields hq_size cnic_local 0 64987 NULL nohasharray
+rp2_alloc_ports_fndecl_64987_fields rp2_alloc_ports fndecl 0-1 64987 &hq_size_cnic_local_64987_fields
+maxTxCredits_edgeport_port_64991_fields maxTxCredits edgeport_port 0 64991 NULL
+UpdateRegs_fndecl_64995_fields UpdateRegs fndecl 2-3 64995 NULL nohasharray
+vt8231_device_add_fndecl_64995_fields vt8231_device_add fndecl 1 64995 &UpdateRegs_fndecl_64995_fields
+access_length_acpi_connection_info_65000_fields access_length acpi_connection_info 0 65000 NULL
+mask_cbuf_65001_fields mask cbuf 0 65001 NULL
+actual_size_saa7164_user_buffer_65010_fields actual_size saa7164_user_buffer 0 65010 NULL
+cmd_len_sg_io_hdr_65018_fields cmd_len sg_io_hdr 0 65018 NULL
+intr_size_usb_pcwd_private_65024_fields intr_size usb_pcwd_private 0 65024 NULL
+au8522_rc_read_fndecl_65026_fields au8522_rc_read fndecl 5 65026 NULL
+ocfs2_block_group_fill_fndecl_65027_fields ocfs2_block_group_fill fndecl 4 65027 NULL
+codeword_size_onfi_ext_ecc_info_65032_fields codeword_size onfi_ext_ecc_info 0 65032 NULL
+xfs_calc_dquots_per_chunk_fndecl_65040_fields xfs_calc_dquots_per_chunk fndecl 0-1 65040 NULL
+brcmf_cfg80211_vndr_cmds_dcmd_handler_fndecl_65059_fields brcmf_cfg80211_vndr_cmds_dcmd_handler fndecl 4 65059 NULL
+iscsi_max_rcv_data_seg_len_dev_db_entry_65060_fields iscsi_max_rcv_data_seg_len dev_db_entry 0 65060 NULL nohasharray
+xen_free_ro_pages_fndecl_65060_fields xen_free_ro_pages fndecl 2-1 65060 &iscsi_max_rcv_data_seg_len_dev_db_entry_65060_fields
+line_count_acpi_nfit_interleave_65069_fields line_count acpi_nfit_interleave 0 65069 NULL
+ResidualCnt__ErrorInfo_struct_65074_fields ResidualCnt _ErrorInfo_struct 0 65074 NULL
+xfs_growfs_rt_alloc_fndecl_65079_fields xfs_growfs_rt_alloc fndecl 2-3 65079 NULL
+len_scifioctl_reg_65083_fields len scifioctl_reg 0 65083 NULL
+frame_size_pwc_device_65084_fields frame_size pwc_device 0 65084 NULL
+fcoe_len_fcoe_rport_65085_fields fcoe_len fcoe_rport 0 65085 NULL
+width_cx88_core_65086_fields width cx88_core 0 65086 NULL
+size_ion_test_rw_data_65088_fields size ion_test_rw_data 0 65088 NULL
+queue_depth_se_node_acl_65089_fields queue_depth se_node_acl 0 65089 NULL
+sco_send_frame_fndecl_65092_fields sco_send_frame fndecl 3 65092 NULL
+fat_write_end_fndecl_65095_fields fat_write_end fndecl 5 65095 NULL
+ecryptfs_write_begin_fndecl_65099_fields ecryptfs_write_begin fndecl 3 65099 NULL
+max_xri_lpfc_max_cfg_param_65100_fields max_xri lpfc_max_cfg_param 0 65100 NULL nohasharray
+ieee802154_hdr_push_fndecl_65100_fields ieee802154_hdr_push fndecl 0 65100 &max_xri_lpfc_max_cfg_param_65100_fields
+sndsize_sock_xprt_65105_fields sndsize sock_xprt 0 65105 NULL
+x25_recvmsg_fndecl_65106_fields x25_recvmsg fndecl 3 65106 NULL nohasharray
+ocfs2_dx_dir_rebalance_fndecl_65106_fields ocfs2_dx_dir_rebalance fndecl 7 65106 &x25_recvmsg_fndecl_65106_fields
+mmc_test_seq_read_perf_fndecl_65111_fields mmc_test_seq_read_perf fndecl 2 65111 NULL
+fat_alloc_new_dir_fndecl_65115_fields fat_alloc_new_dir fndecl 0 65115 NULL
+wpa_ie_len_libipw_device_65120_fields wpa_ie_len libipw_device 0 65120 NULL
+scrub_extent_for_parity_fndecl_65123_fields scrub_extent_for_parity fndecl 3-2-4 65123 NULL
+keyctl_instantiate_key_fndecl_65132_fields keyctl_instantiate_key fndecl 3 65132 NULL
+qib_rcvhdrentsize_vardecl_qib_iba7322_c_65133_fields qib_rcvhdrentsize vardecl_qib_iba7322.c 0 65133 NULL
+num_pipe_drm_psb_private_65138_fields num_pipe drm_psb_private 0 65138 NULL
+byte_count_iwl_stored_beacon_notif_65145_fields byte_count iwl_stored_beacon_notif 0 65145 NULL
+depth_sh_veu_format_65150_fields depth sh_veu_format 0 65150 NULL
+pci_mem_end_qed_dev_info_65160_fields pci_mem_end qed_dev_info 0 65160 NULL
+nexthdrlen_lowpan_nhc_65161_fields nexthdrlen lowpan_nhc 0 65161 NULL
+mwifiex_cmd_append_vsie_tlv_fndecl_65164_fields mwifiex_cmd_append_vsie_tlv fndecl 0 65164 NULL
+ccp_get_dm_area_fndecl_65170_fields ccp_get_dm_area fndecl 4 65170 NULL
+__ext4_block_zero_page_range_fndecl_65173_fields __ext4_block_zero_page_range fndecl 3 65173 NULL
+vlans_b53_chip_data_65177_fields vlans b53_chip_data 0 65177 NULL
+crb_read_netxen_adapter_65178_fields crb_read netxen_adapter 0 65178 NULL
+xfs_rtget_summary_fndecl_65179_fields xfs_rtget_summary fndecl 4-3-0 65179 NULL
+usb_gadget_get_string_fndecl_65180_fields usb_gadget_get_string fndecl 0 65180 NULL
+fat_total_sect_fat_bios_param_block_65184_fields fat_total_sect fat_bios_param_block 0 65184 NULL
+svc_tcp_restore_pages_fndecl_65189_fields svc_tcp_restore_pages fndecl 0 65189 NULL
+free_blk_ocfs2_cached_block_free_65195_fields free_blk ocfs2_cached_block_free 0 65195 NULL
+xfs_bmap_shift_extents_fndecl_65200_fields xfs_bmap_shift_extents fndecl 4 65200 NULL
+NumIdentPartitions_cfi_intelext_regioninfo_65201_fields NumIdentPartitions cfi_intelext_regioninfo 0 65201 NULL
+ackr_win_top_rxrpc_call_65205_fields ackr_win_top rxrpc_call 0 65205 NULL
+fat_shortname2uni_fndecl_65206_fields fat_shortname2uni fndecl 0 65206 NULL nohasharray
+height_dt3155_priv_65206_fields height dt3155_priv 0 65206 &fat_shortname2uni_fndecl_65206_fields
+aper_size_radeon_mc_65212_fields aper_size radeon_mc 0 65212 NULL
+rx_agg_ring_mask_bnxt_65213_fields rx_agg_ring_mask bnxt 0 65213 NULL nohasharray
+get_regs_len_ethtool_ops_65213_fields get_regs_len ethtool_ops 0 65213 &rx_agg_ring_mask_bnxt_65213_fields
+i40evf_change_mtu_fndecl_65220_fields i40evf_change_mtu fndecl 2 65220 NULL
+maxresp_sz_nfsd4_channel_attrs_65221_fields maxresp_sz nfsd4_channel_attrs 0 65221 NULL
+memory_manufacturer_code_ms_boot_attr_info_65224_fields memory_manufacturer_code ms_boot_attr_info 0 65224 NULL
+ocfs2_xattr_bucket_get_name_value_fndecl_65230_fields ocfs2_xattr_bucket_get_name_value fndecl 0 65230 NULL
+iscsi_iser_recv_fndecl_65231_fields iscsi_iser_recv fndecl 4 65231 NULL
+install_irq_resource_fndecl_65241_fields install_irq_resource fndecl 2 65241 NULL
+fb_max_height_vmw_private_65243_fields fb_max_height vmw_private 0 65243 NULL
+ext4_da_write_inline_data_begin_fndecl_65244_fields ext4_da_write_inline_data_begin fndecl 4-3 65244 NULL nohasharray
+word3_alx_rrd_65244_fields word3 alx_rrd 0 65244 &ext4_da_write_inline_data_begin_fndecl_65244_fields
+range_end_writeback_control_65245_fields range_end writeback_control 0 65245 NULL
+bytes_dump_iterator_65249_fields bytes dump_iterator 0 65249 NULL
+ctx_blk_size_cnic_eth_dev_65262_fields ctx_blk_size cnic_eth_dev 0 65262 NULL
+get_dir_index_using_offset_fndecl_65267_fields get_dir_index_using_offset fndecl 0-7 65267 NULL
+ubi_self_check_all_ff_fndecl_65268_fields ubi_self_check_all_ff fndecl 4 65268 NULL
+m_ialloc_blks_xfs_mount_65284_fields m_ialloc_blks xfs_mount 0 65284 NULL
+size_t4_rq_65285_fields size t4_rq 0 65285 NULL
+cp_pack_total_block_count_f2fs_checkpoint_65288_fields cp_pack_total_block_count f2fs_checkpoint 0 65288 NULL
+txfifo_size_lpuart_port_65300_fields txfifo_size lpuart_port 0 65300 NULL nohasharray
+ntfs_bmap_fndecl_65300_fields ntfs_bmap fndecl 2 65300 &txfifo_size_lpuart_port_65300_fields
+memory_lseek_fndecl_65306_fields memory_lseek fndecl 2 65306 NULL
+ext4_dio_get_block_unwritten_sync_fndecl_65307_fields ext4_dio_get_block_unwritten_sync fndecl 2 65307 NULL
+in_param_mlx4_vhcr_65311_fields in_param mlx4_vhcr 0 65311 NULL
+mt312_read_fndecl_65312_fields mt312_read fndecl 4 65312 NULL
+ExtPageLength__MPI2_CONFIG_REPLY_65319_fields ExtPageLength _MPI2_CONFIG_REPLY 0 65319 NULL
+info_arc_emac_bd_65321_fields info arc_emac_bd 0 65321 NULL
+dm_get_reserved_rq_based_ios_fndecl_65322_fields dm_get_reserved_rq_based_ios fndecl 0 65322 NULL
+align_size_hwbus_ops_65327_fields align_size hwbus_ops 0 65327 NULL
+ath10k_wmi_start_scan_tlvs_len_fndecl_65331_fields ath10k_wmi_start_scan_tlvs_len fndecl 0 65331 NULL
+alloc_in_dirband_fndecl_65332_fields alloc_in_dirband fndecl 2 65332 NULL
+panel_count_vbt_r10_65334_fields panel_count vbt_r10 0 65334 NULL
+ldisc_receive_fndecl_65343_fields ldisc_receive fndecl 4 65343 NULL
+gss_krb5_cts_crypt_fndecl_65346_fields gss_krb5_cts_crypt fndecl 3 65346 NULL
+snap_count_rbd_image_header_ondisk_65348_fields snap_count rbd_image_header_ondisk 0 65348 NULL nohasharray
+si476x_radio_fops_read_fndecl_65348_fields si476x_radio_fops_read fndecl 3 65348 &snap_count_rbd_image_header_ondisk_65348_fields
+len_rpc_pipe_msg_65361_fields len rpc_pipe_msg 0 65361 NULL
+fec_decode_rsb_fndecl_65362_fields fec_decode_rsb fndecl 4 65362 NULL
+dma_out_iguanair_65368_fields dma_out iguanair 0 65368 NULL nohasharray
+add_excluded_extent_fndecl_65368_fields add_excluded_extent fndecl 3-2 65368 &dma_out_iguanair_65368_fields
+drbd_send_command_fndecl_65377_fields drbd_send_command fndecl 4-6 65377 NULL
+nfsd_readv_fndecl_65378_fields nfsd_readv fndecl 4 65378 NULL
+rpcrdma_tail_pullup_fndecl_65388_fields rpcrdma_tail_pullup fndecl 0 65388 NULL
+max_rx_aggregation_subframes_ieee80211_hw_65391_fields max_rx_aggregation_subframes ieee80211_hw 0 65391 NULL
+vhost_net_rx_peek_head_len_fndecl_65395_fields vhost_net_rx_peek_head_len fndecl 0 65395 NULL
+rcvegrbufsize_qib_devdata_65397_fields rcvegrbufsize qib_devdata 0 65397 NULL
+digital_in_send_atr_req_fndecl_65398_fields digital_in_send_atr_req fndecl 5 65398 NULL
+wl12xx_sdio_raw_write_fndecl_65406_fields wl12xx_sdio_raw_write fndecl 4 65406 NULL
+__napi_alloc_skb_fndecl_65409_fields __napi_alloc_skb fndecl 2 65409 NULL
+macb_init_rx_buffer_size_fndecl_65410_fields macb_init_rx_buffer_size fndecl 2 65410 NULL
+queue_size_iwl_rxq_65412_fields queue_size iwl_rxq 0 65412 NULL
+fat_zeroed_cluster_fndecl_65422_fields fat_zeroed_cluster fndecl 3-2-0 65422 NULL
+free_bud_entry_65425_fields free bud_entry 0 65425 NULL
+block_size_card_cfg_data_65426_fields block_size card_cfg_data 0 65426 NULL
+period_bytes_snd_usb_substream_65430_fields period_bytes snd_usb_substream 0 65430 NULL
+uar_page_shift_mlx4_dev_65434_fields uar_page_shift mlx4_dev 0 65434 NULL
+lbs_bcnmiss_write_fndecl_65438_fields lbs_bcnmiss_write fndecl 3 65438 NULL
+xfs_dir3_data_block_free_fndecl_65456_fields xfs_dir3_data_block_free fndecl 4 65456 NULL
+wNtbOutMaxDatagrams_usb_cdc_ncm_ntb_parameters_65459_fields wNtbOutMaxDatagrams usb_cdc_ncm_ntb_parameters 0 65459 NULL
+lfb_base_screen_info_65479_fields lfb_base screen_info 0 65479 NULL
+pci_hotplug_io_size_vardecl_65480_fields pci_hotplug_io_size vardecl 0 65480 NULL
+isoc_size_wa_seg_65482_fields isoc_size wa_seg 0 65482 NULL
+aac_src_ioremap_fndecl_65483_fields aac_src_ioremap fndecl 2 65483 NULL
+logical_tree_mod_root_65499_fields logical tree_mod_root 0 65499 NULL
+rw_bytes_nd_namespace_common_65501_fields rw_bytes nd_namespace_common 0 65501 NULL
+xfs_dir2_shrink_inode_fndecl_65502_fields xfs_dir2_shrink_inode fndecl 2 65502 NULL
+bdx_tx_db_init_fndecl_65508_fields bdx_tx_db_init fndecl 2 65508 NULL
+sys_pwritev_fndecl_65513_fields sys_pwritev fndecl 3 65513 NULL
+_recv_fndecl_65526_fields _recv fndecl 3 65526 NULL
+write_page_nocow_fndecl_65527_fields write_page_nocow fndecl 2 65527 NULL
+size_mei_msg_data_65529_fields size mei_msg_data 0 65529 NULL
diff --git b/scripts/gcc-plugins/size_overflow_plugin/e_fns.data b/scripts/gcc-plugins/size_overflow_plugin/e_fns.data
new file mode 100644
index 000000000..510c5544e
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_fns.data
@@ -0,0 +1,5528 @@
+logi_dj_recv_query_paired_devices_fndecl_13_fns logi_dj_recv_query_paired_devices fndecl 0 13 NULL
+response_length_ib_uverbs_ex_destroy_wq_resp_15_fns response_length ib_uverbs_ex_destroy_wq_resp 0 15 NULL
+kfd_wait_on_events_fndecl_19_fns kfd_wait_on_events fndecl 2 19 NULL
+snic_reset_stats_write_fndecl_30_fns snic_reset_stats_write fndecl 3 30 NULL
+iwl_dbgfs_nvm_read_fndecl_54_fns iwl_dbgfs_nvm_read fndecl 3 54 NULL
+bin_to_hex_dup_fndecl_62_fns bin_to_hex_dup fndecl 2 62 NULL
+npages_mlx5_pages_req_70_fns npages mlx5_pages_req 0 70 NULL
+iov_iter_get_pages_alloc_fndecl_76_fns iov_iter_get_pages_alloc fndecl 3 76 NULL
+ieee80211_if_read_dot11MeshMaxPeerLinks_fndecl_85_fns ieee80211_if_read_dot11MeshMaxPeerLinks fndecl 3 85 NULL
+kvm_read_guest_fndecl_107_fns kvm_read_guest fndecl 2-4 107 NULL
+ieee80211_if_read_hw_queues_fndecl_116_fns ieee80211_if_read_hw_queues fndecl 3 116 NULL
+rereg_umr_fndecl_155_fns rereg_umr fndecl 5 155 NULL
+acl_len_nfs_getaclres_171_fns acl_len nfs_getaclres 0 171 NULL
+ufx_read_edid_fndecl_184_fns ufx_read_edid fndecl 0 184 NULL
+sddr55_write_data_fndecl_188_fns sddr55_write_data fndecl 4 188 NULL
+mptctl_do_fw_download_fndecl_190_fns mptctl_do_fw_download fndecl 3 190 NULL
+brcmf_iovar_data_set_fndecl_192_fns brcmf_iovar_data_set fndecl 4 192 NULL
+give_pages_fndecl_198_fns give_pages fndecl 3 198 NULL
+cxgb_alloc_mem_fndecl_212_fns cxgb_alloc_mem fndecl 1 212 NULL
+afs_cell_alloc_fndecl_231_fns afs_cell_alloc fndecl 2 231 NULL
+iwl_dbgfs_low_latency_read_fndecl_237_fns iwl_dbgfs_low_latency_read fndecl 3 237 NULL
+adis16400_show_serial_number_fndecl_246_fns adis16400_show_serial_number fndecl 3 246 NULL
+venus_symlink_fndecl_257_fns venus_symlink fndecl 6-4 257 NULL
+lf_entries_gfs2_leaf_263_fns lf_entries gfs2_leaf 0 263 NULL
+read_snd_midi_event_282_fns read snd_midi_event 0 282 NULL
+islpci_mgt_transaction_fndecl_297_fns islpci_mgt_transaction fndecl 5 297 NULL
+xfpregs_get_fndecl_305_fns xfpregs_get fndecl 4 305 NULL
+num_alt_usb_usbvision_328_fns num_alt usb_usbvision 0 328 NULL
+bNumConfigurations_usb_device_descriptor_360_fns bNumConfigurations usb_device_descriptor 0 360 NULL
+intel_soc_dts_iosf_init_fndecl_374_fns intel_soc_dts_iosf_init fndecl 2 374 NULL
+__i2400mu_send_barker_fndecl_375_fns __i2400mu_send_barker fndecl 3 375 NULL
+cx18_read_fndecl_384_fns cx18_read fndecl 3 384 NULL
+mlxsw_cmd_mbox_query_aq_cap_max_num_eqs_get_fndecl_402_fns mlxsw_cmd_mbox_query_aq_cap_max_num_eqs_get fndecl 0 402 NULL
+apparmor_setprocattr_fndecl_421_fns apparmor_setprocattr fndecl 4 421 NULL
+hfs_file_fsync_fndecl_434_fns hfs_file_fsync fndecl 2-3 434 NULL
+k3_dma_prep_memcpy_fndecl_451_fns k3_dma_prep_memcpy fndecl 4 451 NULL
+__kfifo_max_r_fndecl_459_fns __kfifo_max_r fndecl 1-2-0 459 NULL
+ssp_debug_mode_read_fndecl_463_fns ssp_debug_mode_read fndecl 3 463 NULL
+rx_rx_dropped_frame_read_fndecl_471_fns rx_rx_dropped_frame_read fndecl 3 471 NULL
+print_page_owner_fndecl_474_fns print_page_owner fndecl 2 474 NULL
+rx_path_reset_read_fndecl_490_fns rx_path_reset_read fndecl 3 490 NULL
+security_inode_getxattr_fndecl_502_fns security_inode_getxattr fndecl 0 502 NULL nohasharray
+ll_mtu_ipw_hardware_502_fns ll_mtu ipw_hardware 0 502 &security_inode_getxattr_fndecl_502_fns
+mr_pool_size_srp_target_port_510_fns mr_pool_size srp_target_port 0 510 NULL
+si476x_radio_read_acf_blob_fndecl_515_fns si476x_radio_read_acf_blob fndecl 3 515 NULL
+grow_gnttab_list_fndecl_523_fns grow_gnttab_list fndecl 1 523 NULL
+names_count_tomoyo_condition_552_fns names_count tomoyo_condition 0 552 NULL
+kzalloc_node_fndecl_563_fns kzalloc_node fndecl 1 563 NULL
+idma64_prep_slave_sg_fndecl_565_fns idma64_prep_slave_sg fndecl 3 565 NULL
+btrfs_item_size_nr_fndecl_572_fns btrfs_item_size_nr fndecl 0 572 NULL
+cfi_read_pri_fndecl_573_fns cfi_read_pri fndecl 3 573 NULL
+paging64_init_context_common_fndecl_577_fns paging64_init_context_common fndecl 3 577 NULL
+drm_property_create_bitmask_fndecl_591_fns drm_property_create_bitmask fndecl 6 591 NULL
+getxattr_fndecl_605_fns getxattr fndecl 4 605 NULL
+ftrace_size_ramoops_context_610_fns ftrace_size ramoops_context 0 610 NULL
+ixgbe_alloc_q_vector_fndecl_612_fns ixgbe_alloc_q_vector fndecl 4-6 612 NULL
+smk_user_access_fndecl_619_fns smk_user_access fndecl 3 619 NULL
+nvme_trans_log_supp_pages_fndecl_625_fns nvme_trans_log_supp_pages fndecl 3 625 NULL
+xenbus_file_read_fndecl_632_fns xenbus_file_read fndecl 3 632 NULL
+b43_debugfs_read_fndecl_634_fns b43_debugfs_read fndecl 3 634 NULL
+ocrdma_get_pbl_info_fndecl_644_fns ocrdma_get_pbl_info fndecl 3 644 NULL
+header_length_irda_usb_cb_657_fns header_length irda_usb_cb 0 657 NULL
+nchannels_fs_dev_659_fns nchannels fs_dev 0 659 NULL
+evdev_do_ioctl_fndecl_664_fns evdev_do_ioctl fndecl 2 664 NULL
+ttm_page_pool_free_fndecl_693_fns ttm_page_pool_free fndecl 2 693 NULL
+size_pstore_private_696_fns size pstore_private 0 696 NULL nohasharray
+read_file_spec_scan_ctl_fndecl_696_fns read_file_spec_scan_ctl fndecl 3 696 &size_pstore_private_696_fns
+dut_mode_read_fndecl_698_fns dut_mode_read fndecl 3 698 NULL
+request_key_with_auxdata_fndecl_720_fns request_key_with_auxdata fndecl 4 720 NULL
+xfs_buf_get_map_fndecl_729_fns xfs_buf_get_map fndecl 3 729 NULL
+iwl_trans_alloc_fndecl_767_fns iwl_trans_alloc fndecl 1 767 NULL
+request_key_auth_read_fndecl_830_fns request_key_auth_read fndecl 3 830 NULL
+pipeline_post_proc_swi_read_fndecl_831_fns pipeline_post_proc_swi_read fndecl 3 831 NULL
+_picolcd_flash_write_fndecl_853_fns _picolcd_flash_write fndecl 4 853 NULL
+irnet_ctrl_write_fndecl_856_fns irnet_ctrl_write fndecl 3 856 NULL
+dvb_register_media_device_fndecl_878_fns dvb_register_media_device fndecl 4 878 NULL
+field_count_audit_rule_data_886_fns field_count audit_rule_data 0 886 NULL
+ieee80211_if_read_dot11MeshHWMPpreqMinInterval_fndecl_899_fns ieee80211_if_read_dot11MeshHWMPpreqMinInterval fndecl 3 899 NULL
+tcpprobe_sprint_fndecl_909_fns tcpprobe_sprint fndecl 0 909 NULL
+max_reply_bytes_mpt3_ioctl_command_918_fns max_reply_bytes mpt3_ioctl_command 0 918 NULL
+icmp_len_batadv_socket_packet_944_fns icmp_len batadv_socket_packet 0 944 NULL
+pcpu_embed_first_chunk_fndecl_947_fns pcpu_embed_first_chunk fndecl 1-2-3 947 NULL nohasharray
+mei_amthif_read_fndecl_947_fns mei_amthif_read fndecl 4 947 &pcpu_embed_first_chunk_fndecl_947_fns
+sel_read_bool_fndecl_959_fns sel_read_bool fndecl 3 959 NULL
+avc_tuner_tuneqpsk_fndecl_978_fns avc_tuner_tuneqpsk fndecl 0 978 NULL
+em28xx_alloc_urbs_fndecl_983_fns em28xx_alloc_urbs fndecl 4 983 NULL
+btmrvl_pscmd_read_fndecl_999_fns btmrvl_pscmd_read fndecl 3 999 NULL
+ath6kl_add_bss_if_needed_fndecl_1006_fns ath6kl_add_bss_if_needed fndecl 6 1006 NULL
+s_last_cno_nilfs_super_block_1016_fns s_last_cno nilfs_super_block 0 1016 NULL
+offset_kmem_cache_1021_fns offset kmem_cache 0 1021 NULL
+subn_get_opa_sma_fndecl_1039_fns subn_get_opa_sma fndecl 3 1039 NULL
+invalid_tid_idx_hfi1_filedata_1040_fns invalid_tid_idx hfi1_filedata 0 1040 NULL
+vnic_dev_get_res_count_fndecl_1044_fns vnic_dev_get_res_count fndecl 0 1044 NULL
+rocker_dma_test_offset_fndecl_1055_fns rocker_dma_test_offset fndecl 3 1055 NULL
+b_cnt_mon_reader_bin_1106_fns b_cnt mon_reader_bin 0 1106 NULL
+cmd_sg_entries_vardecl_ib_srp_c_1108_fns cmd_sg_entries vardecl_ib_srp.c 0 1108 NULL
+create_attr_set_fndecl_1118_fns create_attr_set fndecl 1 1118 NULL
+mdc800_device_read_fndecl_1123_fns mdc800_device_read fndecl 3 1123 NULL
+ion_handle_test_kernel_fndecl_1127_fns ion_handle_test_kernel fndecl 3-4 1127 NULL
+do_kexec_load_fndecl_1129_fns do_kexec_load fndecl 2 1129 NULL
+usblp_new_writeurb_fndecl_1149_fns usblp_new_writeurb fndecl 2 1149 NULL
+xstateregs_set_fndecl_1159_fns xstateregs_set fndecl 4 1159 NULL
+nfs4_acl_bytes_fndecl_1168_fns nfs4_acl_bytes fndecl 0 1168 NULL
+vme_get_size_fndecl_1191_fns vme_get_size fndecl 0 1191 NULL
+tx_frag_key_not_found_read_fndecl_1192_fns tx_frag_key_not_found_read fndecl 3 1192 NULL
+adf_create_ring_fndecl_1199_fns adf_create_ring fndecl 5 1199 NULL
+scsi_log_dump_sense_fndecl_1206_fns scsi_log_dump_sense fndecl 5 1206 NULL
+pcpu_mem_zalloc_fndecl_1207_fns pcpu_mem_zalloc fndecl 1 1207 NULL
+gtp_hashtable_new_fndecl_1236_fns gtp_hashtable_new fndecl 2 1236 NULL
+remote_settings_file_write_fndecl_1240_fns remote_settings_file_write fndecl 3 1240 NULL
+cifs_local_to_utf16_bytes_fndecl_1250_fns cifs_local_to_utf16_bytes fndecl 0 1250 NULL
+viafb_dvp0_proc_write_fndecl_1276_fns viafb_dvp0_proc_write fndecl 3 1276 NULL
+sst_fill_and_send_cmd_fndecl_1280_fns sst_fill_and_send_cmd fndecl 7 1280 NULL
+agp_alloc_page_array_fndecl_1289_fns agp_alloc_page_array fndecl 1 1289 NULL
+snapshot_read_fndecl_1370_fns snapshot_read fndecl 3 1370 NULL
+cfs_expr_list_values_fndecl_1371_fns cfs_expr_list_values fndecl 0 1371 NULL
+reiserfs_get_block_fndecl_1379_fns reiserfs_get_block fndecl 2 1379 NULL
+iwl_dbgfs_calib_disabled_read_fndecl_1386_fns iwl_dbgfs_calib_disabled_read fndecl 3 1386 NULL
+iwl_dbgfs_rx_phyinfo_read_fndecl_1394_fns iwl_dbgfs_rx_phyinfo_read fndecl 3 1394 NULL
+sctp_setsockopt_connectx_old_fndecl_1396_fns sctp_setsockopt_connectx_old fndecl 3 1396 NULL
+sync_file_alloc_fndecl_1398_fns sync_file_alloc fndecl 1 1398 NULL
+wl1271_rx_filter_get_fields_size_fndecl_1405_fns wl1271_rx_filter_get_fields_size fndecl 0 1405 NULL
+call_netdevice_notifiers_fndecl_1411_fns call_netdevice_notifiers fndecl 0 1411 NULL
+num_rx_bds_bcmgenet_priv_1412_fns num_rx_bds bcmgenet_priv 0 1412 NULL
+qlcnic_83xx_sysfs_flash_write_handler_fndecl_1419_fns qlcnic_83xx_sysfs_flash_write_handler fndecl 6 1419 NULL
+reg_umr_fndecl_1421_fns reg_umr fndecl 5 1421 NULL
+pt_cap_get_fndecl_1430_fns pt_cap_get fndecl 0 1430 NULL
+idma64_alloc_desc_fndecl_1433_fns idma64_alloc_desc fndecl 1 1433 NULL
+nr_cpusets_fndecl_1442_fns nr_cpusets fndecl 0 1442 NULL
+memcg_update_list_lru_node_fndecl_1454_fns memcg_update_list_lru_node fndecl 3 1454 NULL
+sys_ppoll_fndecl_1459_fns sys_ppoll fndecl 2 1459 NULL
+iio_debugfs_write_reg_fndecl_1477_fns iio_debugfs_write_reg fndecl 3 1477 NULL
+print_frame_fndecl_1506_fns print_frame fndecl 0 1506 NULL
+qlcnic_sriov_init_fndecl_1529_fns qlcnic_sriov_init fndecl 2 1529 NULL
+__aa_kvmalloc_fndecl_1547_fns __aa_kvmalloc fndecl 1 1547 NULL
+libcfs_kvzalloc_fndecl_1568_fns libcfs_kvzalloc fndecl 1 1568 NULL
+page_readlink_fndecl_1569_fns page_readlink fndecl 3 1569 NULL
+kmem_zalloc_large_fndecl_1572_fns kmem_zalloc_large fndecl 1 1572 NULL
+error_error_frame_non_ctrl_read_fndecl_1589_fns error_error_frame_non_ctrl_read fndecl 3 1589 NULL
+skl_get_module_param_size_fndecl_1615_fns skl_get_module_param_size fndecl 0 1615 NULL
+copied_rpc_pipe_msg_1658_fns copied rpc_pipe_msg 0 1658 NULL
+vzalloc_node_fndecl_1683_fns vzalloc_node fndecl 1 1683 NULL
+linear_conf_fndecl_1710_fns linear_conf fndecl 2 1710 NULL
+aead_edesc_alloc_fndecl_1730_fns aead_edesc_alloc fndecl 2 1730 NULL
+devm_iio_device_alloc_fndecl_1732_fns devm_iio_device_alloc fndecl 2 1732 NULL
+skl_set_module_params_fndecl_1736_fns skl_set_module_params fndecl 3 1736 NULL
+compat_filldir_fndecl_1746_fns compat_filldir fndecl 3 1746 NULL
+copy_module_from_user_fndecl_1751_fns copy_module_from_user fndecl 2 1751 NULL
+it_context_mask_fw_ohci_1753_fns it_context_mask fw_ohci 0 1753 NULL
+ima_show_measurements_count_fndecl_1763_fns ima_show_measurements_count fndecl 3 1763 NULL
+reiserfs_add_entry_fndecl_1797_fns reiserfs_add_entry fndecl 4 1797 NULL
+libcfs_kkuc_group_add_fndecl_1809_fns libcfs_kkuc_group_add fndecl 5 1809 NULL
+rt2x00debug_write_eeprom_fndecl_1824_fns rt2x00debug_write_eeprom fndecl 3 1824 NULL
+num_vectors_e1000_adapter_1827_fns num_vectors e1000_adapter 0 1827 NULL
+__add_prelim_ref_fndecl_1828_fns __add_prelim_ref fndecl 2 1828 NULL
+ntfs_ucstonls_fndecl_1834_fns ntfs_ucstonls fndecl 3-5 1834 NULL
+kvm_mmu_gva_to_gpa_write_fndecl_1840_fns kvm_mmu_gva_to_gpa_write fndecl 0 1840 NULL
+vm_map_ram_fndecl_1845_fns vm_map_ram fndecl 2 1845 NULL
+device_slot_1847_fns device slot 0 1847 NULL
+isr_tx_procs_read_fndecl_1855_fns isr_tx_procs_read fndecl 3 1855 NULL
+drm_mode_create_tv_properties_fndecl_1857_fns drm_mode_create_tv_properties fndecl 2 1857 NULL
+read_file_wow_fndecl_1861_fns read_file_wow fndecl 3 1861 NULL
+da9150_write_qif_fndecl_1872_fns da9150_write_qif fndecl 3 1872 NULL
+bset_tree_bytes_fndecl_1876_fns bset_tree_bytes fndecl 0 1876 NULL
+mwl8k_cmd_set_beacon_fndecl_1877_fns mwl8k_cmd_set_beacon fndecl 4 1877 NULL
+num_vmdq_vsis_i40e_pf_1882_fns num_vmdq_vsis i40e_pf 0 1882 NULL
+_iwl_dbgfs_fw_dbg_collect_write_fndecl_1890_fns _iwl_dbgfs_fw_dbg_collect_write fndecl 3 1890 NULL
+read_file_ani_fndecl_1898_fns read_file_ani fndecl 3 1898 NULL
+mpi_alloc_limb_space_fndecl_1925_fns mpi_alloc_limb_space fndecl 1 1925 NULL
+usblp_write_fndecl_1945_fns usblp_write fndecl 3 1945 NULL
+sd_init_fndecl_1946_fns sd_init fndecl 0 1946 NULL
+gss_pipe_downcall_fndecl_1949_fns gss_pipe_downcall fndecl 3 1949 NULL
+mcryptd_alloc_instance_fndecl_1958_fns mcryptd_alloc_instance fndecl 2-3 1958 NULL
+__kmalloc_fndecl_1964_fns __kmalloc fndecl 1 1964 NULL
+tty_buffer_request_room_fndecl_1967_fns tty_buffer_request_room fndecl 2-0 1967 NULL
+response_length_mlx5_ib_create_rwq_ind_tbl_resp_1977_fns response_length mlx5_ib_create_rwq_ind_tbl_resp 0 1977 NULL
+mwifiex_memrw_read_fndecl_1997_fns mwifiex_memrw_read fndecl 3 1997 NULL
+alauda_read_block_fndecl_2008_fns alauda_read_block fndecl 4 2008 NULL
+diva_get_trace_filter_fndecl_2021_fns diva_get_trace_filter fndecl 0 2021 NULL
+ec_i2c_count_message_fndecl_2022_fns ec_i2c_count_message fndecl 2-0 2022 NULL nohasharray
+complicated_alloc_urb_fndecl_2022_fns complicated_alloc_urb fndecl 3 2022 &ec_i2c_count_message_fndecl_2022_fns
+kmalloc_order_trace_fndecl_2063_fns kmalloc_order_trace fndecl 1 2063 NULL
+usbat_flash_read_data_fndecl_2065_fns usbat_flash_read_data fndecl 4 2065 NULL
+dvb_generic_ioctl_fndecl_2081_fns dvb_generic_ioctl fndecl 2 2081 NULL
+mei_io_cb_alloc_buf_fndecl_2088_fns mei_io_cb_alloc_buf fndecl 2 2088 NULL
+min_odd_fndecl_2105_fns min_odd fndecl 1-2-0 2105 NULL
+qsfp1_debugfs_read_fndecl_2107_fns qsfp1_debugfs_read fndecl 3 2107 NULL
+oom_adj_read_fndecl_2116_fns oom_adj_read fndecl 3 2116 NULL
+gen_unique_name_fndecl_2127_fns gen_unique_name fndecl 0 2127 NULL
+_iwl_dbgfs_sta_drain_write_fndecl_2142_fns _iwl_dbgfs_sta_drain_write fndecl 3 2142 NULL
+synic_set_msr_fndecl_2149_fns synic_set_msr fndecl 3 2149 NULL
+__kfifo_dma_out_prepare_fndecl_2165_fns __kfifo_dma_out_prepare fndecl 4 2165 NULL
+lpfc_idiag_extacc_avail_get_fndecl_2170_fns lpfc_idiag_extacc_avail_get fndecl 3-0 2170 NULL
+qsfp_1_read_fndecl_2184_fns qsfp_1_read fndecl 3 2184 NULL
+ldlm_lock_create_fndecl_2195_fns ldlm_lock_create fndecl 7 2195 NULL
+s_blocks_per_group_ext4_sb_info_2201_fns s_blocks_per_group ext4_sb_info 0 2201 NULL
+SYSC_prctl_fndecl_2255_fns SYSC_prctl fndecl 4 2255 NULL
+compat_rw_copy_check_uvector_fndecl_2274_fns compat_rw_copy_check_uvector fndecl 0-3 2274 NULL nohasharray
+rxpipe_descr_host_int_trig_rx_data_read_fndecl_2274_fns rxpipe_descr_host_int_trig_rx_data_read fndecl 3 2274 &compat_rw_copy_check_uvector_fndecl_2274_fns
+read_pointer_st_buffer_2314_fns read_pointer st_buffer 0 2314 NULL
+il_dbgfs_stations_read_fndecl_2319_fns il_dbgfs_stations_read fndecl 3 2319 NULL
+mmc_alloc_sg_fndecl_2323_fns mmc_alloc_sg fndecl 1 2323 NULL
+size_debugfs_blob_wrapper_2338_fns size debugfs_blob_wrapper 0 2338 NULL
+rx_rx_beacon_early_term_read_fndecl_2340_fns rx_rx_beacon_early_term_read fndecl 3 2340 NULL
+cipso_v4_map_cat_enum_hton_fndecl_2359_fns cipso_v4_map_cat_enum_hton fndecl 0 2359 NULL
+fat_ioctl_filldir_fndecl_2360_fns fat_ioctl_filldir fndecl 3 2360 NULL
+__jfs_getxattr_fndecl_2412_fns __jfs_getxattr fndecl 0 2412 NULL
+rspq_size_qset_params_2417_fns rspq_size qset_params 0 2417 NULL
+smtcfb_write_fndecl_2433_fns smtcfb_write fndecl 3 2433 NULL
+tomoyo_read_control_fndecl_2465_fns tomoyo_read_control fndecl 3 2465 NULL
+regmap_register_patch_fndecl_2466_fns regmap_register_patch fndecl 3 2466 NULL
+rtllib_alloc_txb_fndecl_2468_fns rtllib_alloc_txb fndecl 1 2468 NULL
+ocfs2_xattr_get_nolock_fndecl_2493_fns ocfs2_xattr_get_nolock fndecl 0 2493 NULL
+evdev_ioctl_handler_fndecl_2522_fns evdev_ioctl_handler fndecl 2 2522 NULL
+mthca_alloc_init_fndecl_2537_fns mthca_alloc_init fndecl 2 2537 NULL
+lprocfs_wr_import_fndecl_2547_fns lprocfs_wr_import fndecl 3 2547 NULL
+__kmem_cache_alias_fndecl_2551_fns __kmem_cache_alias fndecl 3 2551 NULL
+dma_maxpq_fndecl_2555_fns dma_maxpq fndecl 0 2555 NULL
+__tun_chr_ioctl_fndecl_2575_fns __tun_chr_ioctl fndecl 4 2575 NULL
+crc_size_vardecl_pm_check_c_2624_fns crc_size vardecl_pm-check.c 0 2624 NULL
+len_whc_std_2626_fns len whc_std 0 2626 NULL
+alloc_large_system_hash_fndecl_2660_fns alloc_large_system_hash fndecl 2 2660 NULL nohasharray
+ath10k_debug_fw_reset_stats_read_fndecl_2660_fns ath10k_debug_fw_reset_stats_read fndecl 3 2660 &alloc_large_system_hash_fndecl_2660_fns
+evdev_ioctl_fndecl_2672_fns evdev_ioctl fndecl 2 2672 NULL
+scif_user_recv_fndecl_2675_fns scif_user_recv fndecl 3 2675 NULL
+queue_reply_fndecl_2691_fns queue_reply fndecl 3 2691 NULL
+__set_enter_print_fmt_fndecl_2700_fns __set_enter_print_fmt fndecl 0 2700 NULL
+zoran_write_fndecl_2711_fns zoran_write fndecl 3 2711 NULL
+handle_received_packet_fndecl_2730_fns handle_received_packet fndecl 3 2730 NULL
+aic_common_of_init_fndecl_2752_fns aic_common_of_init fndecl 4 2752 NULL
+cache_write_procfs_fndecl_2760_fns cache_write_procfs fndecl 3 2760 NULL
+qib_user_sdma_alloc_header_fndecl_2761_fns qib_user_sdma_alloc_header fndecl 2 2761 NULL
+ceph_find_or_create_string_fndecl_2777_fns ceph_find_or_create_string fndecl 2 2777 NULL
+max_qid_nvmet_subsys_2781_fns max_qid nvmet_subsys 0 2781 NULL
+_sp2d_min_pg_fndecl_2819_fns _sp2d_min_pg fndecl 0 2819 NULL
+btrfs_get_16_fndecl_2836_fns btrfs_get_16 fndecl 0 2836 NULL
+zd_usb_read_fw_fndecl_2866_fns zd_usb_read_fw fndecl 4 2866 NULL
+prl_count_ip_tunnel_2900_fns prl_count ip_tunnel 0 2900 NULL
+mem_rw_fndecl_2902_fns mem_rw fndecl 3 2902 NULL
+origin_write_extent_fndecl_2983_fns origin_write_extent fndecl 2 2983 NULL
+do_sync_mmap_readahead_fndecl_3008_fns do_sync_mmap_readahead fndecl 4 3008 NULL
+mem_write_fndecl_3019_fns mem_write fndecl 3 3019 NULL
+bpw_len_pch_spi_data_3026_fns bpw_len pch_spi_data 0 3026 NULL
+fat_compat_ioctl_filldir_fndecl_3037_fns fat_compat_ioctl_filldir fndecl 3 3037 NULL
+add_res_tree_fndecl_3044_fns add_res_tree fndecl 7 3044 NULL
+compat_process_vm_rw_fndecl_3069_fns compat_process_vm_rw fndecl 5 3069 NULL
+npages_mthca_db_table_3090_fns npages mthca_db_table 0 3090 NULL nohasharray
+ad7280_write_fndecl_3090_fns ad7280_write fndecl 0 3090 &npages_mthca_db_table_3090_fns
+fb_prepare_logo_fndecl_3092_fns fb_prepare_logo fndecl 0 3092 NULL
+loopstart_soundfont_sample_info_3093_fns loopstart soundfont_sample_info 0 3093 NULL
+rx_pkt_map_sz_tg3_3106_fns rx_pkt_map_sz tg3 0 3106 NULL
+mt76_init_sband_fndecl_3112_fns mt76_init_sband fndecl 6 3112 NULL nohasharray
+iwl_dbgfs_rxon_flags_read_fndecl_3112_fns iwl_dbgfs_rxon_flags_read fndecl 3 3112 &mt76_init_sband_fndecl_3112_fns
+compat_filldir64_fndecl_3119_fns compat_filldir64 fndecl 3 3119 NULL
+sys_sendto_fndecl_3162_fns sys_sendto fndecl 6 3162 NULL
+fill_elf_header_fndecl_3182_fns fill_elf_header fndecl 2 3182 NULL
+wl1271_format_buffer_fndecl_3185_fns wl1271_format_buffer fndecl 2 3185 NULL
+uvc_alloc_entity_fndecl_3191_fns uvc_alloc_entity fndecl 3-4 3191 NULL
+nvme_trans_supported_vpd_pages_fndecl_3196_fns nvme_trans_supported_vpd_pages fndecl 4 3196 NULL
+p9_tag_alloc_fndecl_3198_fns p9_tag_alloc fndecl 3 3198 NULL
+cfs_cpt_table_create_fndecl_3207_fns cfs_cpt_table_create fndecl 1 3207 NULL
+sisusb_send_packet_fndecl_3208_fns sisusb_send_packet fndecl 2 3208 NULL
+key_icverrors_read_fndecl_3212_fns key_icverrors_read fndecl 3 3212 NULL
+iwl_dbgfs_pm_params_read_fndecl_3217_fns iwl_dbgfs_pm_params_read fndecl 3 3217 NULL
+nportcntrs_hfi1_devdata_3218_fns nportcntrs hfi1_devdata 0 3218 NULL
+command_setexposure_fndecl_3231_fns command_setexposure fndecl 0 3231 NULL
+expect_class_max_nf_conntrack_helper_3242_fns expect_class_max nf_conntrack_helper 0 3242 NULL
+rx_buf_size_bnxt_3254_fns rx_buf_size bnxt 0 3254 NULL
+vfio_msi_enable_fndecl_3257_fns vfio_msi_enable fndecl 2 3257 NULL
+sbc_check_prot_fndecl_3258_fns sbc_check_prot fndecl 4 3258 NULL
+rx_rx_phy_hdr_read_fndecl_3269_fns rx_rx_phy_hdr_read fndecl 3 3269 NULL
+rsxx_cram_read_fndecl_3278_fns rsxx_cram_read fndecl 3 3278 NULL
+htable_bits_fndecl_3286_fns htable_bits fndecl 0 3286 NULL
+alg_setsockopt_fndecl_3306_fns alg_setsockopt fndecl 5 3306 NULL
+snd_rme9652_playback_copy_fndecl_3321_fns snd_rme9652_playback_copy fndecl 5 3321 NULL
+hidraw_report_event_fndecl_3332_fns hidraw_report_event fndecl 3 3332 NULL
+add_desc_fndecl_3339_fns add_desc fndecl 3 3339 NULL
+memcg_update_list_lru_fndecl_3349_fns memcg_update_list_lru fndecl 3 3349 NULL
+fast_user_write_fndecl_3357_fns fast_user_write fndecl 5 3357 NULL
+frame_size_stk_camera_3367_fns frame_size stk_camera 0 3367 NULL
+amd_create_gatt_pages_fndecl_3370_fns amd_create_gatt_pages fndecl 1 3370 NULL
+nvdimm_set_config_data_fndecl_3384_fns nvdimm_set_config_data fndecl 4 3384 NULL
+drbd_bm_resize_fndecl_3385_fns drbd_bm_resize fndecl 2 3385 NULL
+num_paths_rdma_route_3407_fns num_paths rdma_route 0 3407 NULL
+venus_create_fndecl_3416_fns venus_create fndecl 4 3416 NULL
+udf_getblk_fndecl_3436_fns udf_getblk fndecl 2 3436 NULL
+command_setcolourbalance_fndecl_3441_fns command_setcolourbalance fndecl 0 3441 NULL
+cifs_read_page_from_socket_fndecl_3452_fns cifs_read_page_from_socket fndecl 0 3452 NULL
+qib_qsfp_write_fndecl_3477_fns qib_qsfp_write fndecl 2-4-0 3477 NULL
+rx_buf_size__mgslpc_info_3490_fns rx_buf_size _mgslpc_info 0 3490 NULL
+kfifo_copy_to_user_fndecl_3509_fns kfifo_copy_to_user fndecl 3-4 3509 NULL
+read_file_tgt_int_stats_fndecl_3530_fns read_file_tgt_int_stats fndecl 3 3530 NULL
+fifo_size_qcom_smd_channel_3531_fns fifo_size qcom_smd_channel 0 3531 NULL
+cipso_v4_gentag_rng_fndecl_3532_fns cipso_v4_gentag_rng fndecl 0 3532 NULL
+snd_hdsp_playback_copy_fndecl_3543_fns snd_hdsp_playback_copy fndecl 5 3543 NULL
+dvb_dmxdev_buffer_read_fndecl_3545_fns dvb_dmxdev_buffer_read fndecl 0-4 3545 NULL
+security_context_to_sid_force_fndecl_3559_fns security_context_to_sid_force fndecl 2 3559 NULL
+_snd_pcm_new_fndecl_3575_fns _snd_pcm_new fndecl 4-5 3575 NULL
+pcpu_page_first_chunk_fndecl_3579_fns pcpu_page_first_chunk fndecl 1 3579 NULL
+asq_buf_size_i40e_adminq_info_3582_fns asq_buf_size i40e_adminq_info 0 3582 NULL
+bcm2835_dma_prep_dma_cyclic_fndecl_3588_fns bcm2835_dma_prep_dma_cyclic fndecl 4-3 3588 NULL
+use_debug_keys_read_fndecl_3600_fns use_debug_keys_read fndecl 3 3600 NULL
+net_rx_queue_update_kobjects_fndecl_3617_fns net_rx_queue_update_kobjects fndecl 0 3617 NULL
+do_msg_fill_fndecl_3624_fns do_msg_fill fndecl 3 3624 NULL
+add_res_range_fndecl_3629_fns add_res_range fndecl 4 3629 NULL
+cfg80211_inform_bss_frame_data_fndecl_3632_fns cfg80211_inform_bss_frame_data fndecl 4 3632 NULL
+s_desc_size_ext4_sb_info_3652_fns s_desc_size ext4_sb_info 0 3652 NULL
+pcpu_chunk_struct_size_vardecl_percpu_c_3673_fns pcpu_chunk_struct_size vardecl_percpu.c 0 3673 NULL nohasharray
+get_zeroed_page_fndecl_3673_fns get_zeroed_page fndecl 0 3673 &pcpu_chunk_struct_size_vardecl_percpu_c_3673_fns
+read_file_bool_bmps_fndecl_3699_fns read_file_bool_bmps fndecl 3 3699 NULL
+srp_max_rsp_size_srpt_port_attrib_3700_fns srp_max_rsp_size srpt_port_attrib 0 3700 NULL
+allocate_cmdlines_buffer_fndecl_3704_fns allocate_cmdlines_buffer fndecl 1 3704 NULL
+ip_getsockopt_fndecl_3711_fns ip_getsockopt fndecl 0 3711 NULL
+diva_get_driver_dbg_mask_fndecl_3716_fns diva_get_driver_dbg_mask fndecl 0 3716 NULL
+dvb_create_media_entity_fndecl_3720_fns dvb_create_media_entity fndecl 3 3720 NULL
+__v4l2_ctrl_modify_range_fndecl_3726_fns __v4l2_ctrl_modify_range fndecl 3 3726 NULL
+SYSC_rt_sigpending_fndecl_3728_fns SYSC_rt_sigpending fndecl 2 3728 NULL
+split_leaf_fndecl_3729_fns split_leaf fndecl 0 3729 NULL
+video_ioctl2_fndecl_3735_fns video_ioctl2 fndecl 2 3735 NULL
+insert_ptr_fndecl_3737_fns insert_ptr fndecl 6 3737 NULL
+intel_th_msc_read_fndecl_3740_fns intel_th_msc_read fndecl 3 3740 NULL
+entries_p54_cal_database_3741_fns entries p54_cal_database 0 3741 NULL
+snapshot_read_next_fndecl_3745_fns snapshot_read_next fndecl 0 3745 NULL
+error_null_frame_tx_start_read_fndecl_3750_fns error_null_frame_tx_start_read fndecl 3 3750 NULL
+tblsize_snd_sg_buf_3776_fns tblsize snd_sg_buf 0 3776 NULL
+next_fn_fndecl_3785_fns next_fn fndecl 0-3 3785 NULL
+buflen_audit_krule_3796_fns buflen audit_krule 0 3796 NULL
+ch_list_len_scan_attr_3809_fns ch_list_len scan_attr 0 3809 NULL
+force_bredr_smp_write_fndecl_3821_fns force_bredr_smp_write fndecl 3 3821 NULL
+mei_nfc_send_fndecl_3830_fns mei_nfc_send fndecl 3 3830 NULL
+read_file_xmit_fndecl_3836_fns read_file_xmit fndecl 3 3836 NULL
+qib_verbs_send_fndecl_3860_fns qib_verbs_send fndecl 3-5 3860 NULL
+lbs_threshold_read_fndecl_3877_fns lbs_threshold_read fndecl 5 3877 NULL
+console_size_ramoops_context_3884_fns console_size ramoops_context 0 3884 NULL
+s_num_blocks_omfs_sb_info_3888_fns s_num_blocks omfs_sb_info 0 3888 NULL nohasharray
+dbgfs_sram_len_il_priv_3888_fns dbgfs_sram_len il_priv 0 3888 &s_num_blocks_omfs_sb_info_3888_fns
+btrfs_inode_ref_name_len_fndecl_3891_fns btrfs_inode_ref_name_len fndecl 0 3891 NULL
+rx_defrag_tkip_called_read_fndecl_3892_fns rx_defrag_tkip_called_read fndecl 3 3892 NULL
+arch_gnttab_init_fndecl_3893_fns arch_gnttab_init fndecl 1 3893 NULL
+event_calibration_read_fndecl_3912_fns event_calibration_read fndecl 3 3912 NULL
+proc_fault_inject_write_fndecl_3921_fns proc_fault_inject_write fndecl 3 3921 NULL
+acpi_data_prop_read_fndecl_3925_fns acpi_data_prop_read fndecl 0 3925 NULL
+virtio_gpu_get_capsets_fndecl_3928_fns virtio_gpu_get_capsets fndecl 2 3928 NULL
+ath6kl_send_go_probe_resp_fndecl_3946_fns ath6kl_send_go_probe_resp fndecl 3 3946 NULL
+_efx_mcdi_rpc_async_fndecl_3948_fns _efx_mcdi_rpc_async fndecl 4-5 3948 NULL
+max_ti_iu_len_srp_rdma_ch_3984_fns max_ti_iu_len srp_rdma_ch 0 3984 NULL
+iwl_dbgfs_uapsd_misbehaving_read_fndecl_3994_fns iwl_dbgfs_uapsd_misbehaving_read fndecl 3 3994 NULL
+mei_dbgfs_read_active_fndecl_4007_fns mei_dbgfs_read_active fndecl 3 4007 NULL
+netdev_set_num_tc_fndecl_4021_fns netdev_set_num_tc fndecl 2 4021 NULL
+ipc_rcu_alloc_fndecl_4043_fns ipc_rcu_alloc fndecl 1 4043 NULL
+cx18_v4l2_read_fndecl_4063_fns cx18_v4l2_read fndecl 3 4063 NULL
+input_ff_create_fndecl_4075_fns input_ff_create fndecl 2 4075 NULL
+ring_overflow_per_user_data_4076_fns ring_overflow per_user_data 0 4076 NULL
+read_ftrace_buffer_info_4082_fns read ftrace_buffer_info 0 4082 NULL
+kvm_vcpu_read_guest_page_fndecl_4083_fns kvm_vcpu_read_guest_page fndecl 5-2 4083 NULL
+hfi1_seq_read_fndecl_4107_fns hfi1_seq_read fndecl 3 4107 NULL
+__rvt_alloc_mr_fndecl_4129_fns __rvt_alloc_mr fndecl 1 4129 NULL
+struct_size_rmi_register_descriptor_4163_fns struct_size rmi_register_descriptor 0 4163 NULL
+tool_spadfn_read_fndecl_4176_fns tool_spadfn_read fndecl 3 4176 NULL
+max_rx_urb_irda_usb_cb_4182_fns max_rx_urb irda_usb_cb 0 4182 NULL
+saa7146_vmalloc_build_pgtable_fndecl_4183_fns saa7146_vmalloc_build_pgtable fndecl 2 4183 NULL
+stm_char_write_fndecl_4195_fns stm_char_write fndecl 3 4195 NULL nohasharray
+irda_setsockopt_fndecl_4195_fns irda_setsockopt fndecl 5 4195 &stm_char_write_fndecl_4195_fns
+vfs_getxattr_fndecl_4203_fns vfs_getxattr fndecl 0 4203 NULL
+auxv_size_prctl_mm_map_4208_fns auxv_size prctl_mm_map 0 4208 NULL
+nci_hci_set_param_fndecl_4215_fns nci_hci_set_param fndecl 5 4215 NULL
+ath10k_write_htt_max_amsdu_ampdu_fndecl_4223_fns ath10k_write_htt_max_amsdu_ampdu fndecl 3 4223 NULL
+dlm_lock_fndecl_4225_fns dlm_lock fndecl 6 4225 NULL nohasharray
+nilfs_segbuf_map_fndecl_4225_fns nilfs_segbuf_map fndecl 2 4225 &dlm_lock_fndecl_4225_fns
+num_lut_dmm_4228_fns num_lut dmm 0 4228 NULL
+len_bpf_prog_4232_fns len bpf_prog 0 4232 NULL
+cfg80211_mlme_register_mgmt_fndecl_4255_fns cfg80211_mlme_register_mgmt fndecl 5 4255 NULL
+ntids_tid_info_4263_fns ntids tid_info 0 4263 NULL
+qlcnic_sysfs_read_pci_config_fndecl_4270_fns qlcnic_sysfs_read_pci_config fndecl 6 4270 NULL nohasharray
+xgbe_init_ring_fndecl_4270_fns xgbe_init_ring fndecl 3 4270 &qlcnic_sysfs_read_pci_config_fndecl_4270_fns
+mrp_request_join_fndecl_4281_fns mrp_request_join fndecl 4 4281 NULL
+mangle_name_fndecl_4288_fns mangle_name fndecl 0 4288 NULL
+cgroup_task_count_fndecl_4297_fns cgroup_task_count fndecl 0 4297 NULL
+key_size_pkcs1pad_ctx_4303_fns key_size pkcs1pad_ctx 0 4303 NULL
+raid56_alloc_missing_rbio_fndecl_4316_fns raid56_alloc_missing_rbio fndecl 4 4316 NULL
+ps_upsd_max_apturn_read_fndecl_4317_fns ps_upsd_max_apturn_read fndecl 3 4317 NULL
+ax25_send_frame_fndecl_4335_fns ax25_send_frame fndecl 2 4335 NULL
+iwl_dbgfs_rx_queue_read_fndecl_4340_fns iwl_dbgfs_rx_queue_read fndecl 3 4340 NULL
+ath10k_mem_value_write_fndecl_4399_fns ath10k_mem_value_write fndecl 3 4399 NULL
+pxad_prep_dma_cyclic_fndecl_4411_fns pxad_prep_dma_cyclic fndecl 4-3 4411 NULL
+nfc_llcp_build_tlv_fndecl_4419_fns nfc_llcp_build_tlv fndecl 3 4419 NULL
+batadv_tvlv_container_register_fndecl_4435_fns batadv_tvlv_container_register fndecl 5 4435 NULL
+jfs_fsync_fndecl_4436_fns jfs_fsync fndecl 2-3 4436 NULL
+compress_raw_buf_fndecl_4453_fns compress_raw_buf fndecl 0 4453 NULL
+n_comedi_insn_4458_fns n comedi_insn 0 4458 NULL
+bm_status_read_fndecl_4460_fns bm_status_read fndecl 3 4460 NULL
+rx_ring_size_altera_tse_private_4470_fns rx_ring_size altera_tse_private 0 4470 NULL
+sddr09_read22_fndecl_4476_fns sddr09_read22 fndecl 3-4-6 4476 NULL
+ocfs2_control_message_fndecl_4479_fns ocfs2_control_message fndecl 3 4479 NULL
+__spi_split_transfer_maxsize_fndecl_4482_fns __spi_split_transfer_maxsize fndecl 4 4482 NULL
+debugfs_run_read_fndecl_4532_fns debugfs_run_read fndecl 3 4532 NULL
+map_private_extent_buffer_fndecl_4542_fns map_private_extent_buffer fndecl 0 4542 NULL
+ath10k_read_pktlog_filter_fndecl_4544_fns ath10k_read_pktlog_filter fndecl 3 4544 NULL
+nr_chans_solo_dev_4552_fns nr_chans solo_dev 0 4552 NULL
+acpi_read_slow_fndecl_4554_fns acpi_read_slow fndecl 3-2 4554 NULL
+LoadBitmap_fndecl_4569_fns LoadBitmap fndecl 2 4569 NULL
+ptr_ring_resize_multiple_fndecl_4573_fns ptr_ring_resize_multiple fndecl 2-3 4573 NULL
+wilc_spi_tx_fndecl_4583_fns wilc_spi_tx fndecl 3 4583 NULL
+aqm_read_fndecl_4611_fns aqm_read fndecl 3 4611 NULL
+mbox_test_message_write_fndecl_4627_fns mbox_test_message_write fndecl 3 4627 NULL
+bcache_major_vardecl_super_c_4677_fns bcache_major vardecl_super.c 0 4677 NULL
+send_section_cnt_netvsc_device_4698_fns send_section_cnt netvsc_device 0 4698 NULL
+btrfs_header_nritems_fndecl_4699_fns btrfs_header_nritems fndecl 0 4699 NULL
+iwl_parse_nvm_mcc_info_fndecl_4702_fns iwl_parse_nvm_mcc_info fndecl 3 4702 NULL nohasharray
+single_open_fndecl_4702_fns single_open fndecl 0 4702 &iwl_parse_nvm_mcc_info_fndecl_4702_fns
+gfs2_glock_nq_m_fndecl_4712_fns gfs2_glock_nq_m fndecl 1 4712 NULL
+snd_cs4281_BA1_read_fndecl_4720_fns snd_cs4281_BA1_read fndecl 5 4720 NULL
+tx_tx_burst_programmed_read_fndecl_4723_fns tx_tx_burst_programmed_read fndecl 3 4723 NULL
+acpi_rs_set_resource_source_fndecl_4776_fns acpi_rs_set_resource_source fndecl 0-2 4776 NULL
+max_tfr_mmc_test_area_4780_fns max_tfr mmc_test_area 0 4780 NULL
+__kfifo_from_user_fndecl_4796_fns __kfifo_from_user fndecl 3 4796 NULL
+axi_dmac_alloc_desc_fndecl_4833_fns axi_dmac_alloc_desc fndecl 1 4833 NULL
+read_buf_fndecl_4838_fns read_buf fndecl 2 4838 NULL
+btrfs_get_32_fndecl_4847_fns btrfs_get_32 fndecl 0 4847 NULL
+attach_hdlc_protocol_fndecl_4865_fns attach_hdlc_protocol fndecl 3 4865 NULL
+s_desc_per_block_ext4_sb_info_4867_fns s_desc_per_block ext4_sb_info 0 4867 NULL nohasharray
+gfn_to_hva_memslot_prot_fndecl_4867_fns gfn_to_hva_memslot_prot fndecl 2 4867 &s_desc_per_block_ext4_sb_info_4867_fns
+mlx5_ib_alloc_mr_fndecl_4870_fns mlx5_ib_alloc_mr fndecl 3 4870 NULL
+SYSC_fgetxattr_fndecl_4904_fns SYSC_fgetxattr fndecl 4 4904 NULL
+diva_um_idi_read_fndecl_4912_fns diva_um_idi_read fndecl 0 4912 NULL
+tree_mod_log_eb_move_fndecl_4920_fns tree_mod_log_eb_move fndecl 5 4920 NULL
+read_tape_fndecl_4950_fns read_tape fndecl 2 4950 NULL
+aat2870_reg_write_file_fndecl_4965_fns aat2870_reg_write_file fndecl 3 4965 NULL
+fuse_conn_limit_read_fndecl_4967_fns fuse_conn_limit_read fndecl 3 4967 NULL
+team_options_register_fndecl_4968_fns team_options_register fndecl 3 4968 NULL
+reiserfs_dir_fsync_fndecl_4971_fns reiserfs_dir_fsync fndecl 2-3 4971 NULL
+iwl_mvm_power_mac_dbgfs_read_fndecl_4976_fns iwl_mvm_power_mac_dbgfs_read fndecl 0 4976 NULL
+scif_send_fndecl_4988_fns scif_send fndecl 3 4988 NULL
+tx_tx_retry_per_rate_read_fndecl_5009_fns tx_tx_retry_per_rate_read fndecl 3 5009 NULL
+bulk_in_size_usb_idmouse_5017_fns bulk_in_size usb_idmouse 0 5017 NULL
+ldebugfs_fid_write_common_fndecl_5049_fns ldebugfs_fid_write_common fndecl 2 5049 NULL
+jffs2_fsync_fndecl_5052_fns jffs2_fsync fndecl 2-3 5052 NULL
+offset_SVGAGuestPtr_5056_fns offset SVGAGuestPtr 0 5056 NULL
+reg_create_fndecl_5061_fns reg_create fndecl 6 5061 NULL
+kvm_vcpu_gfn_to_pfn_atomic_fndecl_5062_fns kvm_vcpu_gfn_to_pfn_atomic fndecl 2 5062 NULL
+tomoyo_commit_ok_fndecl_5076_fns tomoyo_commit_ok fndecl 2 5076 NULL
+read_flush_pipefs_fndecl_5080_fns read_flush_pipefs fndecl 3 5080 NULL
+ceph_alloc_page_vector_fndecl_5125_fns ceph_alloc_page_vector fndecl 1 5125 NULL
+iwl_dbgfs_rx_handlers_read_fndecl_5127_fns iwl_dbgfs_rx_handlers_read fndecl 3 5127 NULL
+fnic_stats_debugfs_read_fndecl_5139_fns fnic_stats_debugfs_read fndecl 3 5139 NULL
+__nvme_submit_user_cmd_fndecl_5142_fns __nvme_submit_user_cmd fndecl 6 5142 NULL nohasharray
+echo_client_prep_commit_fndecl_5142_fns echo_client_prep_commit fndecl 8 5142 &__nvme_submit_user_cmd_fndecl_5142_fns
+lps_per_blk_nvm_dev_5145_fns lps_per_blk nvm_dev 0 5145 NULL
+kmemleak_scan_area_fndecl_5155_fns kmemleak_scan_area fndecl 2 5155 NULL
+o2hb_debug_create_fndecl_5163_fns o2hb_debug_create fndecl 4 5163 NULL
+wep_packets_read_fndecl_5164_fns wep_packets_read fndecl 3 5164 NULL
+sq905_read_data_fndecl_5229_fns sq905_read_data fndecl 0 5229 NULL
+cnt_nfp_net_tx_ring_5239_fns cnt nfp_net_tx_ring 0 5239 NULL
+nr_extents__ntfs_inode_5242_fns nr_extents _ntfs_inode 0 5242 NULL
+sys_modify_ldt_fndecl_5275_fns sys_modify_ldt fndecl 3 5275 NULL
+ieee80211_if_read_element_ttl_fndecl_5286_fns ieee80211_if_read_element_ttl fndecl 3 5286 NULL
+drm_ht_create_fndecl_5302_fns drm_ht_create fndecl 2 5302 NULL
+tx_nr_rings_bnxt_5306_fns tx_nr_rings bnxt 0 5306 NULL
+sctp_setsockopt_events_fndecl_5309_fns sctp_setsockopt_events fndecl 3 5309 NULL
+thermal_tx_stop_read_fndecl_5310_fns thermal_tx_stop_read fndecl 3 5310 NULL
+devm_mdiobus_alloc_size_fndecl_5317_fns devm_mdiobus_alloc_size fndecl 2 5317 NULL
+___alloc_bootmem_node_fndecl_5329_fns ___alloc_bootmem_node fndecl 2 5329 NULL
+comedi_isadma_alloc_fndecl_5342_fns comedi_isadma_alloc fndecl 2 5342 NULL
+snapshot_write_next_fndecl_5354_fns snapshot_write_next fndecl 0 5354 NULL
+read_user_buf_avail_tomoyo_io_buffer_5361_fns read_user_buf_avail tomoyo_io_buffer 0 5361 NULL
+mangle_packet_fndecl_5371_fns mangle_packet fndecl 7-9 5371 NULL
+regset_tls_set_fndecl_5384_fns regset_tls_set fndecl 4 5384 NULL
+iscsi_create_flashnode_sess_fndecl_5394_fns iscsi_create_flashnode_sess fndecl 4 5394 NULL
+port_mad_size_fndecl_5434_fns port_mad_size fndecl 0 5434 NULL
+wilc_add_wep_key_bss_sta_fndecl_5436_fns wilc_add_wep_key_bss_sta fndecl 3 5436 NULL
+wiidebug_eeprom_read_fndecl_5523_fns wiidebug_eeprom_read fndecl 3 5523 NULL
+tool_dbfn_read_fndecl_5532_fns tool_dbfn_read fndecl 3 5532 NULL nohasharray
+debug_output_fndecl_5532_fns debug_output fndecl 3 5532 &tool_dbfn_read_fndecl_5532_fns
+slabinfo_write_fndecl_5563_fns slabinfo_write fndecl 3 5563 NULL
+iowarrior_write_fndecl_5567_fns iowarrior_write fndecl 3 5567 NULL
+tool_peer_mw_trans_read_fndecl_5573_fns tool_peer_mw_trans_read fndecl 3 5573 NULL
+from_buffer_fndecl_5586_fns from_buffer fndecl 3 5586 NULL
+horus3a_i2c_debug_fndecl_5589_fns horus3a_i2c_debug fndecl 5 5589 NULL
+num_scanouts_virtio_gpu_device_5598_fns num_scanouts virtio_gpu_device 0 5598 NULL
+size_sched_attr_5599_fns size sched_attr 0 5599 NULL nohasharray
+memory_map_bottom_up_fndecl_5599_fns memory_map_bottom_up fndecl 2 5599 &size_sched_attr_5599_fns
+wbcir_tx_fndecl_5632_fns wbcir_tx fndecl 3 5632 NULL
+dev_counters_read_fndecl_5635_fns dev_counters_read fndecl 3 5635 NULL
+tx_ring_size_altera_tse_private_5654_fns tx_ring_size altera_tse_private 0 5654 NULL nohasharray
+iwl_dbgfs_reply_tx_error_read_fndecl_5654_fns iwl_dbgfs_reply_tx_error_read fndecl 3 5654 &tx_ring_size_altera_tse_private_5654_fns
+ucma_query_fndecl_5679_fns ucma_query fndecl 4 5679 NULL
+il_dbgfs_rxon_filter_flags_read_fndecl_5698_fns il_dbgfs_rxon_filter_flags_read fndecl 3 5698 NULL
+batadv_tt_save_orig_buffer_fndecl_5707_fns batadv_tt_save_orig_buffer fndecl 4 5707 NULL
+debug_read_fndecl_5737_fns debug_read fndecl 3 5737 NULL
+max_order_mlx4_buddy_5738_fns max_order mlx4_buddy 0 5738 NULL
+event_tx_stuck_read_fndecl_5754_fns event_tx_stuck_read fndecl 3 5754 NULL
+console_size_ramoops_platform_data_5786_fns console_size ramoops_platform_data 0 5786 NULL
+prefetch_len_ath10k_htt_5811_fns prefetch_len ath10k_htt 0 5811 NULL
+hid_hw_raw_request_fndecl_5827_fns hid_hw_raw_request fndecl 0 5827 NULL
+interpret_user_input_fndecl_5842_fns interpret_user_input fndecl 2 5842 NULL
+get_n_events_by_type_fndecl_5850_fns get_n_events_by_type fndecl 0 5850 NULL
+iproc_asiu_setup_fndecl_5902_fns iproc_asiu_setup fndecl 4 5902 NULL
+layout_in_gaps_fndecl_5933_fns layout_in_gaps fndecl 2 5933 NULL
+gfn_to_pfn_atomic_fndecl_5942_fns gfn_to_pfn_atomic fndecl 2 5942 NULL
+sysfs_create_dir_ns_fndecl_5962_fns sysfs_create_dir_ns fndecl 0 5962 NULL
+orangefs_prepare_cdm_array_fndecl_5968_fns orangefs_prepare_cdm_array fndecl 0 5968 NULL
+create_gpadl_header_fndecl_5995_fns create_gpadl_header fndecl 2 5995 NULL
+revalidate_fndecl_6000_fns revalidate fndecl 2 6000 NULL nohasharray
+acpi_install_table_fndecl_6000_fns acpi_install_table fndecl 1 6000 &revalidate_fndecl_6000_fns
+drm_fb_helper_init_fndecl_6007_fns drm_fb_helper_init fndecl 3-4 6007 NULL nohasharray
+map_words_netvsc_device_6007_fns map_words netvsc_device 0 6007 &drm_fb_helper_init_fndecl_6007_fns
+orig_sg_segs_osst_buffer_6013_fns orig_sg_segs osst_buffer 0 6013 NULL
+brcmf_usbdev_qinit_fndecl_6017_fns brcmf_usbdev_qinit fndecl 2 6017 NULL
+icv_trunc_len_ah_data_6025_fns icv_trunc_len ah_data 0 6025 NULL
+ceph_create_snap_context_fndecl_6041_fns ceph_create_snap_context fndecl 1 6041 NULL
+scif_rb_space_fndecl_6052_fns scif_rb_space fndecl 0 6052 NULL
+sta_last_seq_ctrl_read_fndecl_6065_fns sta_last_seq_ctrl_read fndecl 3 6065 NULL
+read_extent_buffer_to_user_fndecl_6118_fns read_extent_buffer_to_user fndecl 3-4 6118 NULL
+pwc_get_fps_Kiara_fndecl_6127_fns pwc_get_fps_Kiara fndecl 0 6127 NULL
+pwr_enable_ps_read_fndecl_6149_fns pwr_enable_ps_read fndecl 3 6149 NULL
+gfn_to_pfn_memslot_fndecl_6158_fns gfn_to_pfn_memslot fndecl 2 6158 NULL
+rcl_nrefcalls_referring_call_list_6169_fns rcl_nrefcalls referring_call_list 0 6169 NULL nohasharray
+qgroup_account_snapshot_fndecl_6169_fns qgroup_account_snapshot fndecl 5 6169 &rcl_nrefcalls_referring_call_list_6169_fns
+sensor_write_regs_fndecl_6181_fns sensor_write_regs fndecl 0 6181 NULL
+venus_rename_fndecl_6200_fns venus_rename fndecl 4-5 6200 NULL
+exofs_read_lookup_dev_table_fndecl_6230_fns exofs_read_lookup_dev_table fndecl 3 6230 NULL
+setup_sgl_fndecl_6242_fns setup_sgl fndecl 4-5 6242 NULL
+send_mbox_fndecl_6260_fns send_mbox fndecl 4 6260 NULL
+brcmf_usb_attach_fndecl_6261_fns brcmf_usb_attach fndecl 2-3 6261 NULL
+sb_nextnum_nilfs_segment_buffer_6275_fns sb_nextnum nilfs_segment_buffer 0 6275 NULL
+command_setsensorfps_fndecl_6277_fns command_setsensorfps fndecl 0 6277 NULL
+nrealwriters_stress_lock_torture_cxt_6279_fns nrealwriters_stress lock_torture_cxt 0 6279 NULL
+_iwl_dbgfs_set_nic_temperature_write_fndecl_6303_fns _iwl_dbgfs_set_nic_temperature_write fndecl 3 6303 NULL
+count_leafs_fndecl_6305_fns count_leafs fndecl 0 6305 NULL
+iin_wMaxPacketSize_usbtmc_device_data_6306_fns iin_wMaxPacketSize usbtmc_device_data 0 6306 NULL
+sn9c2028_command_fndecl_6307_fns sn9c2028_command fndecl 0 6307 NULL
+em28xx_audio_ep_packet_size_fndecl_6311_fns em28xx_audio_ep_packet_size fndecl 0 6311 NULL
+shadow_fetch_fndecl_6315_fns shadow_fetch fndecl 3 6315 NULL
+len_ethtool_gstrings_6325_fns len ethtool_gstrings 0 6325 NULL
+cipso_v4_gentag_rbm_fndecl_6335_fns cipso_v4_gentag_rbm fndecl 0 6335 NULL
+ray_cs_essid_proc_write_fndecl_6336_fns ray_cs_essid_proc_write fndecl 3 6336 NULL
+virtio_cread32_fndecl_6338_fns virtio_cread32 fndecl 0 6338 NULL
+orinoco_set_key_fndecl_6341_fns orinoco_set_key fndecl 7 6341 NULL
+init_per_cpu_fndecl_6347_fns init_per_cpu fndecl 1 6347 NULL
+sisusb_send_bulk_msg_fndecl_6363_fns sisusb_send_bulk_msg fndecl 3 6363 NULL
+dev_pm_opp_get_opp_count_fndecl_6372_fns dev_pm_opp_get_opp_count fndecl 0 6372 NULL
+dccp_feat_register_sp_fndecl_6377_fns dccp_feat_register_sp fndecl 5 6377 NULL
+partition_sched_domains_fndecl_6386_fns partition_sched_domains fndecl 1 6386 NULL
+lpfc_debugfs_dif_err_write_fndecl_6403_fns lpfc_debugfs_dif_err_write fndecl 3 6403 NULL
+nvme_iod_alloc_size_fndecl_6444_fns nvme_iod_alloc_size fndecl 3-0 6444 NULL
+i40iw_qp_roundup_fndecl_6447_fns i40iw_qp_roundup fndecl 1 6447 NULL
+probe_kernel_write_fndecl_6490_fns probe_kernel_write fndecl 3 6490 NULL
+bytes_cifs_readdata_6533_fns bytes cifs_readdata 0 6533 NULL
+max_vfs_vardecl_igb_main_c_6547_fns max_vfs vardecl_igb_main.c 0 6547 NULL
+neigh_hash_alloc_fndecl_6568_fns neigh_hash_alloc fndecl 1 6568 NULL nohasharray
+sddr09_read21_fndecl_6568_fns sddr09_read21 fndecl 3-4-6 6568 &neigh_hash_alloc_fndecl_6568_fns
+acpi_ut_create_package_object_fndecl_6569_fns acpi_ut_create_package_object fndecl 1 6569 NULL
+command_setcolourparams_fndecl_6571_fns command_setcolourparams fndecl 0 6571 NULL nohasharray
+ath6kl_wmi_connect_cmd_fndecl_6571_fns ath6kl_wmi_connect_cmd fndecl 10 6571 &command_setcolourparams_fndecl_6571_fns
+ieee80211_if_read_dot11MeshHWMPactivePathToRootTimeout_fndecl_6593_fns ieee80211_if_read_dot11MeshHWMPactivePathToRootTimeout fndecl 3 6593 NULL
+osst_execute_fndecl_6612_fns osst_execute fndecl 7 6612 NULL
+num_large_buffers_ql3_adapter_6615_fns num_large_buffers ql3_adapter 0 6615 NULL
+SYSC_migrate_pages_fndecl_6634_fns SYSC_migrate_pages fndecl 2 6634 NULL
+packet_setsockopt_fndecl_6637_fns packet_setsockopt fndecl 5 6637 NULL
+set_number_fndecl_6651_fns set_number fndecl 2 6651 NULL
+nilfs_segment_list_add_fndecl_6665_fns nilfs_segment_list_add fndecl 2 6665 NULL
+pccard_store_cis_fndecl_6675_fns pccard_store_cis fndecl 6 6675 NULL
+nroots_rs_control_6706_fns nroots rs_control 0 6706 NULL nohasharray
+gsm_control_message_fndecl_6706_fns gsm_control_message fndecl 4 6706 &nroots_rs_control_6706_fns
+do_ipv6_setsockopt_fndecl_6708_fns do_ipv6_setsockopt fndecl 5 6708 NULL
+qdisc_class_hash_alloc_fndecl_6725_fns qdisc_class_hash_alloc fndecl 1 6725 NULL nohasharray
+size_mvpp2_txq_pcpu_6725_fns size mvpp2_txq_pcpu 0 6725 &qdisc_class_hash_alloc_fndecl_6725_fns
+pagesize_sddr09_card_info_6735_fns pagesize sddr09_card_info 0 6735 NULL
+hostif_mib_set_request_fndecl_6736_fns hostif_mib_set_request fndecl 3 6736 NULL
+gnttab_alloc_grant_references_fndecl_6739_fns gnttab_alloc_grant_references fndecl 1 6739 NULL
+alloc_trace_uprobe_fndecl_6740_fns alloc_trace_uprobe fndecl 3 6740 NULL
+num_vectors_qed_int_param_6741_fns num_vectors qed_int_param 0 6741 NULL
+_read_and_match_data_map_fndecl_6747_fns _read_and_match_data_map fndecl 2 6747 NULL
+rfcomm_sock_setsockopt_fndecl_6749_fns rfcomm_sock_setsockopt fndecl 5 6749 NULL
+um_idi_write_fndecl_6758_fns um_idi_write fndecl 3 6758 NULL
+gfs2_alloc_sort_buffer_fndecl_6768_fns gfs2_alloc_sort_buffer fndecl 1 6768 NULL
+alloc_ring_fndecl_6773_fns alloc_ring fndecl 2-4 6773 NULL
+max_vals_input_dev_6777_fns max_vals input_dev 0 6777 NULL
+mmc_send_bus_test_fndecl_6782_fns mmc_send_bus_test fndecl 4 6782 NULL
+csio_mem_read_fndecl_6812_fns csio_mem_read fndecl 3 6812 NULL
+debugfs_write_file_bool_fndecl_6814_fns debugfs_write_file_bool fndecl 3 6814 NULL
+pwr_power_save_off_read_fndecl_6816_fns pwr_power_save_off_read fndecl 3 6816 NULL
+xlbd_reserve_minors_fndecl_6830_fns xlbd_reserve_minors fndecl 1-2 6830 NULL
+lcd_proc_write_fndecl_6844_fns lcd_proc_write fndecl 3 6844 NULL
+__ceph_getxattr_fndecl_6849_fns __ceph_getxattr fndecl 0 6849 NULL
+hpfs_file_fsync_fndecl_6851_fns hpfs_file_fsync fndecl 2-3 6851 NULL
+ci_role_write_fndecl_6855_fns ci_role_write fndecl 3 6855 NULL
+size_vb2_fileio_buf_6875_fns size vb2_fileio_buf 0 6875 NULL
+__kfifo_in_r_fndecl_6892_fns __kfifo_in_r fndecl 4-3 6892 NULL
+adis16136_show_serial_fndecl_6897_fns adis16136_show_serial fndecl 3 6897 NULL
+pwr_sleep_time_count_read_fndecl_6914_fns pwr_sleep_time_count_read fndecl 3 6914 NULL
+nvram_pagesize_tg3_6938_fns nvram_pagesize tg3 0 6938 NULL
+tlv_put_u64_fndecl_6968_fns tlv_put_u64 fndecl 0 6968 NULL
+mwifiex_verext_write_fndecl_6972_fns mwifiex_verext_write fndecl 3 6972 NULL
+pvr2_v4l2_read_fndecl_6981_fns pvr2_v4l2_read fndecl 3 6981 NULL
+bits_from_user_fndecl_6996_fns bits_from_user fndecl 2-3 6996 NULL
+gnttab_max_grant_frames_fndecl_7002_fns gnttab_max_grant_frames fndecl 0 7002 NULL
+num_rss_qede_dev_7011_fns num_rss qede_dev 0 7011 NULL
+fpregs_get_fndecl_7041_fns fpregs_get fndecl 4 7041 NULL
+kvm_read_guest_page_fndecl_7049_fns kvm_read_guest_page fndecl 5-2 7049 NULL
+SYSC_pselect6_fndecl_7055_fns SYSC_pselect6 fndecl 1 7055 NULL
+txd_cnt_nfp_net_7058_fns txd_cnt nfp_net 0 7058 NULL
+cryptd_alloc_instance_fndecl_7059_fns cryptd_alloc_instance fndecl 2-3 7059 NULL
+rx_pending_sky2_port_7090_fns rx_pending sky2_port 0 7090 NULL
+get_vm_area_fndecl_7091_fns get_vm_area fndecl 1 7091 NULL
+mpi_alloc_fndecl_7101_fns mpi_alloc fndecl 1 7101 NULL
+paging32_gpte_to_gfn_lvl_fndecl_7104_fns paging32_gpte_to_gfn_lvl fndecl 0-2-1 7104 NULL
+wil_tid_ampdu_rx_alloc_fndecl_7119_fns wil_tid_ampdu_rx_alloc fndecl 2 7119 NULL
+ftrace_size_ramoops_platform_data_7124_fns ftrace_size ramoops_platform_data 0 7124 NULL
+report_size_hid_global_7127_fns report_size hid_global 0 7127 NULL nohasharray
+dfs_file_read_fndecl_7127_fns dfs_file_read fndecl 3 7127 &report_size_hid_global_7127_fns
+acpi_rs_set_resource_length_fndecl_7131_fns acpi_rs_set_resource_length fndecl 1 7131 NULL
+nstids_tid_info_7139_fns nstids tid_info 0 7139 NULL
+selinux_inode_setsecurity_fndecl_7159_fns selinux_inode_setsecurity fndecl 4 7159 NULL
+mfd_add_devices_fndecl_7183_fns mfd_add_devices fndecl 4 7183 NULL
+ide_init_port_fndecl_7207_fns ide_init_port fndecl 2 7207 NULL
+_iwl_dbgfs_bt_force_ant_write_fndecl_7214_fns _iwl_dbgfs_bt_force_ant_write fndecl 3 7214 NULL
+__copy_to_user_swizzled_fndecl_7295_fns __copy_to_user_swizzled fndecl 3-4 7295 NULL
+drm_malloc_ab_fndecl_7340_fns drm_malloc_ab fndecl 1-2 7340 NULL
+pvr2_i2c_read_fndecl_7344_fns pvr2_i2c_read fndecl 4-6 7344 NULL
+hfsplus_min_io_size_fndecl_7368_fns hfsplus_min_io_size fndecl 0 7368 NULL
+packetsize__rbu_data_7390_fns packetsize _rbu_data 0 7390 NULL
+calipso_genopt_fndecl_7401_fns calipso_genopt fndecl 0 7401 NULL
+st_write_fndecl_7417_fns st_write fndecl 3 7417 NULL
+alloc_idx_lebs_fndecl_7419_fns alloc_idx_lebs fndecl 2 7419 NULL
+__kfifo_peek_n_fndecl_7422_fns __kfifo_peek_n fndecl 0 7422 NULL
+xfs_file_fsync_fndecl_7433_fns xfs_file_fsync fndecl 2-3 7433 NULL
+iio_device_add_event_fndecl_7439_fns iio_device_add_event fndecl 0 7439 NULL
+rate_ctrl_alg_read_fndecl_7449_fns rate_ctrl_alg_read fndecl 3 7449 NULL
+stat_st_vardecl_drv_c_7451_fns stat_st vardecl_drv.c 0 7451 NULL
+cmdline_store_fndecl_7465_fns cmdline_store fndecl 4 7465 NULL nohasharray
+num_present_cpu_lpfc_sli4_hba_7465_fns num_present_cpu lpfc_sli4_hba 0 7465 &cmdline_store_fndecl_7465_fns
+minors_gigaset_driver_7468_fns minors gigaset_driver 0 7468 NULL
+ieee80211_if_read_tsf_fndecl_7479_fns ieee80211_if_read_tsf fndecl 3 7479 NULL
+req_capsule_get_size_fndecl_7488_fns req_capsule_get_size fndecl 0 7488 NULL
+calculate_inocache_hashsize_fndecl_7506_fns calculate_inocache_hashsize fndecl 1-0 7506 NULL
+alloc_disk_node_fndecl_7513_fns alloc_disk_node fndecl 1 7513 NULL
+netlink_change_ngroups_fndecl_7514_fns netlink_change_ngroups fndecl 2 7514 NULL
+src_len_akcipher_request_7526_fns src_len akcipher_request 0 7526 NULL
+size_hpi_response_header_7541_fns size hpi_response_header 0 7541 NULL
+hd_nirqs_hpet_data_7558_fns hd_nirqs hpet_data 0 7558 NULL
+acpi_copy_property_array_u8_fndecl_7565_fns acpi_copy_property_array_u8 fndecl 0 7565 NULL
+lpfc_debugfs_read_fndecl_7589_fns lpfc_debugfs_read fndecl 3 7589 NULL
+xpt_remotelen_svc_xprt_7655_fns xpt_remotelen svc_xprt 0 7655 NULL
+maxwritelen_proc_data_7659_fns maxwritelen proc_data 0 7659 NULL
+mlxsw_reg_trans_bulk_wait_fndecl_7664_fns mlxsw_reg_trans_bulk_wait fndecl 0 7664 NULL
+nfp_net_shadow_rx_rings_prepare_fndecl_7679_fns nfp_net_shadow_rx_rings_prepare fndecl 3 7679 NULL
+UniStrnlen_fndecl_7682_fns UniStrnlen fndecl 0 7682 NULL
+cfg80211_sme_get_conn_ies_fndecl_7687_fns cfg80211_sme_get_conn_ies fndecl 3 7687 NULL
+record_length_cper_record_header_7697_fns record_length cper_record_header 0 7697 NULL
+mxt_upload_cfg_mem_fndecl_7702_fns mxt_upload_cfg_mem fndecl 4 7702 NULL
+befs_nls2utf_fndecl_7704_fns befs_nls2utf fndecl 3 7704 NULL
+tx_tx_start_templates_read_fndecl_7711_fns tx_tx_start_templates_read fndecl 3 7711 NULL
+access_remote_vm_fndecl_7734_fns access_remote_vm fndecl 0 7734 NULL nohasharray
+iwl_dbgfs_txfifo_flush_write_fndecl_7734_fns iwl_dbgfs_txfifo_flush_write fndecl 3 7734 &access_remote_vm_fndecl_7734_fns
+iscsit_find_cmd_from_itt_or_dump_fndecl_7737_fns iscsit_find_cmd_from_itt_or_dump fndecl 3 7737 NULL nohasharray
+driver_state_read_fndecl_7737_fns driver_state_read fndecl 3 7737 &iscsit_find_cmd_from_itt_or_dump_fndecl_7737_fns
+ocfs2_get_suballoc_slot_bit_fndecl_7773_fns ocfs2_get_suballoc_slot_bit fndecl 2 7773 NULL
+split_mem_range_fndecl_7776_fns split_mem_range fndecl 3-4 7776 NULL
+alloc_ep_fndecl_7782_fns alloc_ep fndecl 1 7782 NULL
+pg_read_fndecl_7791_fns pg_read fndecl 3 7791 NULL
+id_avail_ipack_device_7822_fns id_avail ipack_device 0 7822 NULL
+n_stats_ethtool_stats_7823_fns n_stats ethtool_stats 0 7823 NULL
+nabs_joydev_7827_fns nabs joydev 0 7827 NULL
+minstrel_stats_read_fndecl_7833_fns minstrel_stats_read fndecl 3 7833 NULL
+block_aligned_filename_size_ecryptfs_parse_tag_70_packet_silly_stack_7865_fns block_aligned_filename_size ecryptfs_parse_tag_70_packet_silly_stack 0 7865 NULL
+used_snd_ctl_elem_list_7883_fns used snd_ctl_elem_list 0 7883 NULL
+freecom_readdata_fndecl_7884_fns freecom_readdata fndecl 3 7884 NULL
+ath6kl_wmi_send_mgmt_cmd_fndecl_7888_fns ath6kl_wmi_send_mgmt_cmd fndecl 7 7888 NULL
+ieee80211_if_read_dot11MeshHWMPperrMinInterval_fndecl_7889_fns ieee80211_if_read_dot11MeshHWMPperrMinInterval fndecl 3 7889 NULL
+i2400m_unknown_barker_fndecl_7903_fns i2400m_unknown_barker fndecl 3 7903 NULL
+uvesafb_setpalette_fndecl_7922_fns uvesafb_setpalette fndecl 2 7922 NULL
+sd_start_fndecl_7964_fns sd_start fndecl 0 7964 NULL
+squashfs_read_table_fndecl_7970_fns squashfs_read_table fndecl 3 7970 NULL
+_sp2d_alloc_fndecl_7971_fns _sp2d_alloc fndecl 1-2-3 7971 NULL
+svcxdr_dupstr_fndecl_8016_fns svcxdr_dupstr fndecl 3 8016 NULL
+pd_handles_sz_MPT3SAS_ADAPTER_8057_fns pd_handles_sz MPT3SAS_ADAPTER 0 8057 NULL
+ceph_read_dir_fndecl_8062_fns ceph_read_dir fndecl 3 8062 NULL
+copy_counters_to_user_fndecl_8080_fns copy_counters_to_user fndecl 5 8080 NULL
+dvb_dvr_read_fndecl_8098_fns dvb_dvr_read fndecl 3 8098 NULL
+sddr55_read_data_fndecl_8099_fns sddr55_read_data fndecl 4 8099 NULL nohasharray
+error_num_frame_cts_nul_flid_read_fndecl_8099_fns error_num_frame_cts_nul_flid_read fndecl 3 8099 &sddr55_read_data_fndecl_8099_fns
+simple_transaction_read_fndecl_8103_fns simple_transaction_read fndecl 3 8103 NULL
+acpi_ut_get_resource_header_length_fndecl_8110_fns acpi_ut_get_resource_header_length fndecl 0 8110 NULL
+__copy_user_nocache_fndecl_8122_fns __copy_user_nocache fndecl 0 8122 NULL
+write_mem_fndecl_8137_fns write_mem fndecl 3 8137 NULL
+entry_length_fndecl_8150_fns entry_length fndecl 0 8150 NULL
+ubifs_scanned_corruption_fndecl_8170_fns ubifs_scanned_corruption fndecl 3 8170 NULL
+jumpshot_write_data_fndecl_8172_fns jumpshot_write_data fndecl 4 8172 NULL
+nsftids_tid_info_8187_fns nsftids tid_info 0 8187 NULL
+SYSC_llistxattr_fndecl_8238_fns SYSC_llistxattr fndecl 3 8238 NULL
+dump_data_bytes_fndecl_8240_fns dump_data_bytes fndecl 3 8240 NULL
+stk_read_fndecl_8245_fns stk_read fndecl 3 8245 NULL
+sys_sched_setaffinity_fndecl_8253_fns sys_sched_setaffinity fndecl 2 8253 NULL
+num_alloc_vsi_i40e_pf_8259_fns num_alloc_vsi i40e_pf 0 8259 NULL
+length_spi_engine_program_8261_fns length spi_engine_program 0 8261 NULL
+proc_scsi_devinfo_write_fndecl_8275_fns proc_scsi_devinfo_write fndecl 3 8275 NULL
+wil_read_file_recovery_fndecl_8315_fns wil_read_file_recovery fndecl 3 8315 NULL
+kobject_add_internal_fndecl_8342_fns kobject_add_internal fndecl 0 8342 NULL
+venus_link_fndecl_8374_fns venus_link fndecl 5 8374 NULL
+riva_get_cmap_len_fndecl_8393_fns riva_get_cmap_len fndecl 0 8393 NULL nohasharray
+m_bch_control_8393_fns m bch_control 0 8393 &riva_get_cmap_len_fndecl_8393_fns
+wusb_ccm_mac_fndecl_8404_fns wusb_ccm_mac fndecl 7 8404 NULL
+del_ptr_fndecl_8406_fns del_ptr fndecl 4 8406 NULL
+length_ipw_tx_packet_8408_fns length ipw_tx_packet 0 8408 NULL
+lbs_lowrssi_read_fndecl_8417_fns lbs_lowrssi_read fndecl 3 8417 NULL
+batadv_iv_ogm_drop_bcast_own_sum_entry_fndecl_8430_fns batadv_iv_ogm_drop_bcast_own_sum_entry fndecl 2 8430 NULL
+cifs_lookup_cache_proc_write_fndecl_8447_fns cifs_lookup_cache_proc_write fndecl 3 8447 NULL
+snd_seq_device_new_fndecl_8474_fns snd_seq_device_new fndecl 4 8474 NULL
+get_count_order_fndecl_8491_fns get_count_order fndecl 0 8491 NULL
+data_write_fndecl_8494_fns data_write fndecl 3 8494 NULL
+isr_rx_procs_read_fndecl_8495_fns isr_rx_procs_read fndecl 3 8495 NULL
+usblp_cache_device_id_string_fndecl_8509_fns usblp_cache_device_id_string fndecl 0 8509 NULL
+strnlen_user_fndecl_8532_fns strnlen_user fndecl 0 8532 NULL
+fuse_dir_fsync_fndecl_8543_fns fuse_dir_fsync fndecl 2-3 8543 NULL
+iwl_dbgfs_disable_ht40_write_fndecl_8599_fns iwl_dbgfs_disable_ht40_write fndecl 3 8599 NULL
+drm_mode_crtc_set_gamma_size_fndecl_8602_fns drm_mode_crtc_set_gamma_size fndecl 2 8602 NULL
+kmem_alloc_fndecl_8611_fns kmem_alloc fndecl 1 8611 NULL
+xattr_permission_fndecl_8624_fns xattr_permission fndecl 0 8624 NULL
+new_dir_fndecl_8636_fns new_dir fndecl 3 8636 NULL
+copy_from_user_toio_fndecl_8653_fns copy_from_user_toio fndecl 3 8653 NULL
+read_mem_fndecl_8661_fns read_mem fndecl 3 8661 NULL
+SYSC_sethostname_fndecl_8663_fns SYSC_sethostname fndecl 2 8663 NULL
+b_out_mon_reader_bin_8691_fns b_out mon_reader_bin 0 8691 NULL
+data_width_stedma40_half_channel_info_8694_fns data_width stedma40_half_channel_info 0 8694 NULL
+ebcnt_vardecl_readtest_c_8699_fns ebcnt vardecl_readtest.c 0 8699 NULL
+ilo_read_fndecl_8704_fns ilo_read fndecl 3 8704 NULL
+out_ptr_mdc800_data_8709_fns out_ptr mdc800_data 0 8709 NULL
+ieee80211_if_read_estab_plinks_fndecl_8710_fns ieee80211_if_read_estab_plinks fndecl 3 8710 NULL
+key_len_host_if_wep_attr_8712_fns key_len host_if_wep_attr 0 8712 NULL
+qsfp_read_fndecl_8729_fns qsfp_read fndecl 2-4-0 8729 NULL
+ip_set_elem_len_fndecl_8730_fns ip_set_elem_len fndecl 0 8730 NULL
+alloc_state_change_fndecl_8735_fns alloc_state_change fndecl 1-2 8735 NULL
+tool_link_read_fndecl_8740_fns tool_link_read fndecl 3 8740 NULL
+osc_iocontrol_fndecl_8742_fns osc_iocontrol fndecl 3 8742 NULL
+max_epid_fjes_hw_8751_fns max_epid fjes_hw 0 8751 NULL
+format_devstat_counter_fndecl_8757_fns format_devstat_counter fndecl 3 8757 NULL
+read_file_beacon_fndecl_8768_fns read_file_beacon fndecl 3 8768 NULL
+ieee80211_if_read_dropped_frames_congestion_fndecl_8776_fns ieee80211_if_read_dropped_frames_congestion fndecl 3 8776 NULL
+gfs2_adjust_quota_fndecl_8777_fns gfs2_adjust_quota fndecl 2 8777 NULL
+cfg80211_roamed_fndecl_8811_fns cfg80211_roamed fndecl 5-7 8811 NULL
+nilfs_cpfile_get_checkpoint_fndecl_8812_fns nilfs_cpfile_get_checkpoint fndecl 2 8812 NULL
+sys_set_mempolicy_fndecl_8819_fns sys_set_mempolicy fndecl 3 8819 NULL
+response_length_mlx5_ib_alloc_ucontext_resp_8839_fns response_length mlx5_ib_alloc_ucontext_resp 0 8839 NULL
+generic_readlink_fndecl_8861_fns generic_readlink fndecl 3 8861 NULL
+dm_set_target_max_io_len_fndecl_8872_fns dm_set_target_max_io_len fndecl 2 8872 NULL
+batps_powernow_k8_data_8899_fns batps powernow_k8_data 0 8899 NULL
+pages_squashfs_cache_8903_fns pages squashfs_cache 0 8903 NULL
+bits_per_pixel_fb_var_screeninfo_8906_fns bits_per_pixel fb_var_screeninfo 0 8906 NULL
+rt2x00debug_read_queue_dump_fndecl_8923_fns rt2x00debug_read_queue_dump fndecl 3 8923 NULL
+begin_cmd_fndecl_8941_fns begin_cmd fndecl 0 8941 NULL
+mon_mgmt_tx_fndecl_8949_fns mon_mgmt_tx fndecl 3 8949 NULL nohasharray
+i40e_pci_sriov_enable_fndecl_8949_fns i40e_pci_sriov_enable fndecl 2 8949 &mon_mgmt_tx_fndecl_8949_fns
+stats_read_ul_fndecl_8956_fns stats_read_ul fndecl 3 8956 NULL nohasharray
+videobuf_mmap_setup_fndecl_8956_fns videobuf_mmap_setup fndecl 3 8956 &stats_read_ul_fndecl_8956_fns
+n_bch_control_8979_fns n bch_control 0 8979 NULL
+vmalloc_user_fndecl_8999_fns vmalloc_user fndecl 1 8999 NULL
+vb2_dvb_register_frontend_fndecl_9015_fns vb2_dvb_register_frontend fndecl 0 9015 NULL
+add_dts_thermal_zone_fndecl_9019_fns add_dts_thermal_zone fndecl 4 9019 NULL
+t4_alloc_mem_fndecl_9029_fns t4_alloc_mem fndecl 1 9029 NULL
+id_port_9030_fns id port 0 9030 NULL
+error_rx_cmplt_db_overflow_cnt_read_fndecl_9063_fns error_rx_cmplt_db_overflow_cnt_read fndecl 3 9063 NULL
+logical_maximum_hid_field_9067_fns logical_maximum hid_field 0 9067 NULL
+dispatch_ioctl_fndecl_9078_fns dispatch_ioctl fndecl 2 9078 NULL
+count_afs_call_9081_fns count afs_call 0 9081 NULL nohasharray
+sel_read_initcon_fndecl_9081_fns sel_read_initcon fndecl 3 9081 &count_afs_call_9081_fns
+iwl_dbgfs_tof_range_abort_read_fndecl_9085_fns iwl_dbgfs_tof_range_abort_read fndecl 3 9085 NULL
+xfs_iext_add_indirect_multi_fndecl_9091_fns xfs_iext_add_indirect_multi fndecl 3-4 9091 NULL
+pvr2_stream_set_buffer_count_fndecl_9116_fns pvr2_stream_set_buffer_count fndecl 2 9116 NULL
+learn_buffer_len_vardecl_gracl_learn_c_9167_fns learn_buffer_len vardecl_gracl_learn.c 0 9167 NULL
+wiimote_cmd_read_fndecl_9197_fns wiimote_cmd_read fndecl 4 9197 NULL
+ide_driver_proc_write_fndecl_9214_fns ide_driver_proc_write fndecl 3 9214 NULL
+qcom_rpm_smd_write_fndecl_9229_fns qcom_rpm_smd_write fndecl 6 9229 NULL
+read_file_bt_ant_diversity_fndecl_9236_fns read_file_bt_ant_diversity fndecl 3 9236 NULL
+call_netdevice_notifiers_info_fndecl_9239_fns call_netdevice_notifiers_info fndecl 0 9239 NULL
+n_sbufs_stk_camera_9256_fns n_sbufs stk_camera 0 9256 NULL
+acpi_ns_build_normalized_path_fndecl_9269_fns acpi_ns_build_normalized_path fndecl 0 9269 NULL
+lbs_failcount_read_fndecl_9284_fns lbs_failcount_read fndecl 3 9284 NULL
+buffer_bytes_st_buffer_9290_fns buffer_bytes st_buffer 0 9290 NULL
+sctp_setsockopt_context_fndecl_9312_fns sctp_setsockopt_context fndecl 3 9312 NULL
+sys_mincore_fndecl_9332_fns sys_mincore fndecl 1-2 9332 NULL
+compat_sys_get_mempolicy_fndecl_9366_fns compat_sys_get_mempolicy fndecl 3 9366 NULL
+depth_read_fndecl_9371_fns depth_read fndecl 3 9371 NULL
+data_start_dm_ioctl_9412_fns data_start dm_ioctl 0 9412 NULL
+rocker_dma_ring_create_fndecl_9421_fns rocker_dma_ring_create fndecl 3 9421 NULL
+evdev_get_mask_fndecl_9457_fns evdev_get_mask fndecl 4 9457 NULL
+mtdchar_readoob_fndecl_9459_fns mtdchar_readoob fndecl 4 9459 NULL
+kvm_mmu_page_fault_fndecl_9470_fns kvm_mmu_page_fault fndecl 2 9470 NULL
+lbs_debugfs_read_fndecl_9490_fns lbs_debugfs_read fndecl 3 9490 NULL
+maxdev_vardecl_slcan_c_9507_fns maxdev vardecl_slcan.c 0 9507 NULL
+fillonedir_fndecl_9511_fns fillonedir fndecl 3 9511 NULL
+smk_read_doi_fndecl_9550_fns smk_read_doi fndecl 3 9550 NULL
+fault_disconnect_read_fndecl_9566_fns fault_disconnect_read fndecl 3 9566 NULL
+ath10k_write_fw_dbglog_fndecl_9568_fns ath10k_write_fw_dbglog fndecl 3 9568 NULL
+pwr_sleep_time_avg_read_fndecl_9572_fns pwr_sleep_time_avg_read fndecl 3 9572 NULL nohasharray
+mvneta_frag_alloc_fndecl_9572_fns mvneta_frag_alloc fndecl 1 9572 &pwr_sleep_time_avg_read_fndecl_9572_fns
+sctp_setsockopt_auth_chunk_fndecl_9576_fns sctp_setsockopt_auth_chunk fndecl 3 9576 NULL
+of_gpio_named_count_fndecl_9578_fns of_gpio_named_count fndecl 0 9578 NULL
+get_kobj_path_length_fndecl_9596_fns get_kobj_path_length fndecl 0 9596 NULL
+frag_size_mvneta_port_9606_fns frag_size mvneta_port 0 9606 NULL
+skd_max_pass_thru_vardecl_skd_main_c_9608_fns skd_max_pass_thru vardecl_skd_main.c 0 9608 NULL
+acpi_copy_property_array_u16_fndecl_9618_fns acpi_copy_property_array_u16 fndecl 0 9618 NULL
+copy_to_iter_fndecl_9638_fns copy_to_iter fndecl 0 9638 NULL
+usnic_debugfs_buildinfo_read_fndecl_9667_fns usnic_debugfs_buildinfo_read fndecl 3 9667 NULL
+sctp_setsockopt_rtoinfo_fndecl_9678_fns sctp_setsockopt_rtoinfo fndecl 3 9678 NULL
+read_packet_length_lego_usb_tower_9686_fns read_packet_length lego_usb_tower 0 9686 NULL
+pkt_len_virtio_vsock_pkt_info_9698_fns pkt_len virtio_vsock_pkt_info 0 9698 NULL
+tty_insert_flip_string_flags_fndecl_9706_fns tty_insert_flip_string_flags fndecl 4 9706 NULL
+tx_ringsz_alx_priv_9722_fns tx_ringsz alx_priv 0 9722 NULL
+vicam_control_msg_fndecl_9727_fns vicam_control_msg fndecl 0 9727 NULL
+samsung_clk_sleep_init_fndecl_9743_fns samsung_clk_sleep_init fndecl 3 9743 NULL
+qsfp_2_read_fndecl_9744_fns qsfp_2_read fndecl 3 9744 NULL
+blkdev_fsync_fndecl_9745_fns blkdev_fsync fndecl 2-3 9745 NULL
+bnx2x_mcast_handle_current_cmd_fndecl_9747_fns bnx2x_mcast_handle_current_cmd fndecl 0 9747 NULL
+__alloc_bootmem_fndecl_9753_fns __alloc_bootmem fndecl 1 9753 NULL
+buffer_length_floppy_raw_cmd_9763_fns buffer_length floppy_raw_cmd 0 9763 NULL
+dvb_ringbuffer_write_fndecl_9775_fns dvb_ringbuffer_write fndecl 0 9775 NULL
+mlxsw_pci_queue_group_init_fndecl_9779_fns mlxsw_pci_queue_group_init fndecl 4 9779 NULL
+tx_frag_tkip_called_read_fndecl_9796_fns tx_frag_tkip_called_read fndecl 3 9796 NULL
+get_max_inline_xattr_value_size_fndecl_9801_fns get_max_inline_xattr_value_size fndecl 0 9801 NULL
+usbvision_read_fndecl_9808_fns usbvision_read fndecl 3 9808 NULL
+NumPhysDiskPaths__CONFIG_PAGE_RAID_PHYS_DISK_1_9818_fns NumPhysDiskPaths _CONFIG_PAGE_RAID_PHYS_DISK_1 0 9818 NULL
+iwl_dbgfs_ucode_tx_stats_read_fndecl_9832_fns iwl_dbgfs_ucode_tx_stats_read fndecl 3 9832 NULL
+snd_compr_get_avail_fndecl_9843_fns snd_compr_get_avail fndecl 0 9843 NULL
+nr_of_buckets_v4l2_ctrl_handler_9859_fns nr_of_buckets v4l2_ctrl_handler 0 9859 NULL
+copy_from_user_nmi_fndecl_9899_fns copy_from_user_nmi fndecl 3 9899 NULL
+tx_ring_size_sky2_port_9902_fns tx_ring_size sky2_port 0 9902 NULL
+alloc_event_waiters_fndecl_9914_fns alloc_event_waiters fndecl 1 9914 NULL
+asic_flags_read_fndecl_9918_fns asic_flags_read fndecl 3 9918 NULL
+vbe_modes_cnt_uvesafb_par_9928_fns vbe_modes_cnt uvesafb_par 0 9928 NULL
+len_load_info_9931_fns len load_info 0 9931 NULL
+rxdata_desc_size_vmxnet3_adapter_9937_fns rxdata_desc_size vmxnet3_adapter 0 9937 NULL
+wb_pgbase_nfs_page_9940_fns wb_pgbase nfs_page 0 9940 NULL nohasharray
+object_name_len_ncp_objectname_ioctl_9940_fns object_name_len ncp_objectname_ioctl 0 9940 &wb_pgbase_nfs_page_9940_fns
+forced_ps_read_fndecl_9942_fns forced_ps_read fndecl 3 9942 NULL
+shmem_pwrite_slow_fndecl_9966_fns shmem_pwrite_slow fndecl 2-3 9966 NULL
+rs_pretty_print_rate_fndecl_9980_fns rs_pretty_print_rate fndecl 0 9980 NULL
+send_buf_size_netvsc_device_10051_fns send_buf_size netvsc_device 0 10051 NULL
+command_file_write_fndecl_10053_fns command_file_write fndecl 3 10053 NULL nohasharray
+usbat_write_blocks_fndecl_10053_fns usbat_write_blocks fndecl 3-4 10053 &command_file_write_fndecl_10053_fns
+uvc_simplify_fraction_fndecl_10068_fns uvc_simplify_fraction fndecl 3 10068 NULL
+iwl_dbgfs_set_nic_temperature_read_fndecl_10071_fns iwl_dbgfs_set_nic_temperature_read fndecl 3 10071 NULL
+outlen_write_fndecl_10093_fns outlen_write fndecl 3 10093 NULL
+msix_num_bnad_10096_fns msix_num bnad 0 10096 NULL
+em28xx_init_usb_xfer_fndecl_10106_fns em28xx_init_usb_xfer fndecl 4 10106 NULL
+_regmap_raw_multi_reg_write_fndecl_10107_fns _regmap_raw_multi_reg_write fndecl 3 10107 NULL
+trace_parser_get_init_fndecl_10112_fns trace_parser_get_init fndecl 2 10112 NULL
+tfms_count_crypt_config_10114_fns tfms_count crypt_config 0 10114 NULL
+sg_segs_osst_buffer_10144_fns sg_segs osst_buffer 0 10144 NULL nohasharray
+key_ifindex_read_fndecl_10144_fns key_ifindex_read fndecl 3 10144 &sg_segs_osst_buffer_10144_fns
+nvme_rdma_alloc_qe_fndecl_10151_fns nvme_rdma_alloc_qe fndecl 3 10151 NULL
+ldebugfs_fid_space_seq_write_fndecl_10152_fns ldebugfs_fid_space_seq_write fndecl 3 10152 NULL
+_sp2d_max_pg_fndecl_10157_fns _sp2d_max_pg fndecl 0 10157 NULL
+usnic_vnic_res_spec_update_fndecl_10169_fns usnic_vnic_res_spec_update fndecl 3 10169 NULL
+transport_alloc_session_tags_fndecl_10186_fns transport_alloc_session_tags fndecl 2-3 10186 NULL
+opera1_xilinx_rw_fndecl_10190_fns opera1_xilinx_rw fndecl 5 10190 NULL
+wil_addba_rx_request_fndecl_10219_fns wil_addba_rx_request fndecl 4 10219 NULL
+rds_message_map_pages_fndecl_10220_fns rds_message_map_pages fndecl 2 10220 NULL
+alg_setkey_fndecl_10222_fns alg_setkey fndecl 3 10222 NULL
+storage_size_phm_runtime_table_header_10230_fns storage_size phm_runtime_table_header 0 10230 NULL
+qlcnic_set_sds_ring_count_fndecl_10232_fns qlcnic_set_sds_ring_count fndecl 2 10232 NULL
+dio_get_pages_alloc_fndecl_10238_fns dio_get_pages_alloc fndecl 2 10238 NULL
+vmw_resource_buf_alloc_fndecl_10284_fns vmw_resource_buf_alloc fndecl 0 10284 NULL
+frame_list_sz_dwc2_hsotg_10293_fns frame_list_sz dwc2_hsotg 0 10293 NULL
+validate_user_key_fndecl_10303_fns validate_user_key fndecl 5 10303 NULL
+tlen_sdma_txreq_10305_fns tlen sdma_txreq 0 10305 NULL
+sysfs_add_file_mode_ns_fndecl_10309_fns sysfs_add_file_mode_ns fndecl 0 10309 NULL
+scsi_vpd_inquiry_fndecl_10315_fns scsi_vpd_inquiry fndecl 0 10315 NULL
+num_mnt_opts_security_mnt_opts_10327_fns num_mnt_opts security_mnt_opts 0 10327 NULL
+dev_mem_write_fndecl_10335_fns dev_mem_write fndecl 3 10335 NULL
+boot_max_nr_grant_frames_vardecl_grant_table_c_10337_fns boot_max_nr_grant_frames vardecl_grant-table.c 0 10337 NULL
+cids_per_blk_cnic_local_10342_fns cids_per_blk cnic_local 0 10342 NULL
+__pci_request_selected_regions_fndecl_10361_fns __pci_request_selected_regions fndecl 0 10361 NULL
+rx_filter_data_filter_read_fndecl_10369_fns rx_filter_data_filter_read fndecl 3 10369 NULL
+snd_midi_channel_init_set_fndecl_10399_fns snd_midi_channel_init_set fndecl 1 10399 NULL
+u_memcpya_fndecl_10408_fns u_memcpya fndecl 2-3 10408 NULL
+jfs_xattr_set_fndecl_10409_fns jfs_xattr_set fndecl 6 10409 NULL
+alloc_switch_ctx_fndecl_10438_fns alloc_switch_ctx fndecl 2 10438 NULL
+mlxsw_sp_fdb_call_notifiers_fndecl_10442_fns mlxsw_sp_fdb_call_notifiers fndecl 4 10442 NULL
+NumberOfPhyBlock_ms_lib_ctrl_10443_fns NumberOfPhyBlock ms_lib_ctrl 0 10443 NULL
+elfcorehdr_read_fndecl_10460_fns elfcorehdr_read fndecl 2 10460 NULL
+usblp_ioctl_fndecl_10472_fns usblp_ioctl fndecl 2 10472 NULL
+nfsd4_get_drc_mem_fndecl_10473_fns nfsd4_get_drc_mem fndecl 0 10473 NULL
+avc_tuner_dsd_dvb_c_fndecl_10490_fns avc_tuner_dsd_dvb_c fndecl 0 10490 NULL
+msb_cache_read_fndecl_10494_fns msb_cache_read fndecl 2 10494 NULL
+sd_alloc_ctl_entry_fndecl_10527_fns sd_alloc_ctl_entry fndecl 1 10527 NULL nohasharray
+posix_acl_from_xattr_fndecl_10527_fns posix_acl_from_xattr fndecl 3 10527 &sd_alloc_ctl_entry_fndecl_10527_fns
+cros_ec_prepare_tx_fndecl_10539_fns cros_ec_prepare_tx fndecl 0 10539 NULL
+touchscreen_set_params_fndecl_10540_fns touchscreen_set_params fndecl 3 10540 NULL
+nfp_net_netdev_alloc_fndecl_10548_fns nfp_net_netdev_alloc fndecl 3-2 10548 NULL nohasharray
+read_cis_cache_fndecl_10548_fns read_cis_cache fndecl 4 10548 &nfp_net_netdev_alloc_fndecl_10548_fns
+wm_adsp_read_algs_fndecl_10552_fns wm_adsp_read_algs fndecl 4 10552 NULL
+lpfc_present_cpu_vardecl_10567_fns lpfc_present_cpu vardecl 0 10567 NULL
+fuse_fsync_fndecl_10582_fns fuse_fsync fndecl 2-3 10582 NULL
+static_key_count_fndecl_10584_fns static_key_count fndecl 0 10584 NULL
+wcn36xx_smd_send_and_wait_fndecl_10595_fns wcn36xx_smd_send_and_wait fndecl 2 10595 NULL
+num_amd_northbridge_info_10604_fns num amd_northbridge_info 0 10604 NULL
+__probe_kernel_write_fndecl_10625_fns __probe_kernel_write fndecl 3 10625 NULL nohasharray
+lch_count_omap_dma_dev_attr_10625_fns lch_count omap_dma_dev_attr 0 10625 &__probe_kernel_write_fndecl_10625_fns
+tlv_put_fndecl_10659_fns tlv_put fndecl 0 10659 NULL
+ipv6_setsockopt_fndecl_10684_fns ipv6_setsockopt fndecl 5 10684 NULL
+write_file_bool_bmps_fndecl_10685_fns write_file_bool_bmps fndecl 3 10685 NULL
+lov_ost_pool_extend_fndecl_10697_fns lov_ost_pool_extend fndecl 2 10697 NULL
+__btrfs_getxattr_fndecl_10728_fns __btrfs_getxattr fndecl 0 10728 NULL
+write_file_queue_fndecl_10737_fns write_file_queue fndecl 3 10737 NULL
+setexposure_fndecl_10781_fns setexposure fndecl 0 10781 NULL
+dwc3_testmode_write_fndecl_10791_fns dwc3_testmode_write fndecl 3 10791 NULL
+rtgt_cnt_snic_disc_10811_fns rtgt_cnt snic_disc 0 10811 NULL
+rndis_add_response_fndecl_10854_fns rndis_add_response fndecl 2 10854 NULL
+disk_expand_part_tbl_fndecl_10866_fns disk_expand_part_tbl fndecl 2 10866 NULL
+__vmalloc_fndecl_10880_fns __vmalloc fndecl 1 10880 NULL
+sgl_map_user_pages_fndecl_10881_fns sgl_map_user_pages fndecl 2 10881 NULL
+ieee80211_if_read_dot11MeshAwakeWindowDuration_fndecl_10932_fns ieee80211_if_read_dot11MeshAwakeWindowDuration fndecl 3 10932 NULL
+compat_raw_setsockopt_fndecl_10937_fns compat_raw_setsockopt fndecl 5 10937 NULL
+brd_alloc_fndecl_10964_fns brd_alloc fndecl 1 10964 NULL
+encrypted_key_size_ecryptfs_session_key_10978_fns encrypted_key_size ecryptfs_session_key 0 10978 NULL
+register_virtio_driver_fndecl_11025_fns register_virtio_driver fndecl 0 11025 NULL
+drm_dp_sideband_msg_build_fndecl_11028_fns drm_dp_sideband_msg_build fndecl 3 11028 NULL
+snd_ac97_pcm_assign_fndecl_11033_fns snd_ac97_pcm_assign fndecl 2 11033 NULL
+audio_outs_vx_core_11035_fns audio_outs vx_core 0 11035 NULL
+isr_pci_pm_read_fndecl_11052_fns isr_pci_pm_read fndecl 3 11052 NULL
+drm_dp_dpcd_write_fndecl_11066_fns drm_dp_dpcd_write fndecl 0 11066 NULL
+pipeline_sec_frag_swi_read_fndecl_11077_fns pipeline_sec_frag_swi_read fndecl 3 11077 NULL
+snd_pcm_new_internal_fndecl_11091_fns snd_pcm_new_internal fndecl 4-5 11091 NULL
+__vmalloc_node_flags_fndecl_11139_fns __vmalloc_node_flags fndecl 1 11139 NULL
+resource_from_user_fndecl_11158_fns resource_from_user fndecl 3 11158 NULL
+nvme_fill_device_id_eui64_fndecl_11160_fns nvme_fill_device_id_eui64 fndecl 4 11160 NULL
+max_supported_extcon_dev_11172_fns max_supported extcon_dev 0 11172 NULL
+sys_get_mempolicy_fndecl_11192_fns sys_get_mempolicy fndecl 3 11192 NULL
+mangle_sdp_packet_fndecl_11198_fns mangle_sdp_packet fndecl 10 11198 NULL
+trace_insert_enum_map_fndecl_11206_fns trace_insert_enum_map fndecl 3 11206 NULL
+submit_create_fndecl_11207_fns submit_create fndecl 3-4 11207 NULL
+lstcon_session_info_fndecl_11210_fns lstcon_session_info fndecl 6 11210 NULL
+tx_tx_template_prepared_read_fndecl_11211_fns tx_tx_template_prepared_read fndecl 3 11211 NULL
+bcd2000_dump_buffer_fndecl_11234_fns bcd2000_dump_buffer fndecl 3 11234 NULL
+enable_write_fndecl_11243_fns enable_write fndecl 3 11243 NULL
+tx_tx_template_programmed_read_fndecl_11246_fns tx_tx_template_programmed_read fndecl 3 11246 NULL
+alloc_sched_domains_fndecl_11327_fns alloc_sched_domains fndecl 1 11327 NULL
+hci_sock_setsockopt_fndecl_11346_fns hci_sock_setsockopt fndecl 5 11346 NULL
+buffer_length_usbdevfs_urb_11350_fns buffer_length usbdevfs_urb 0 11350 NULL
+nilfs_cpfile_delete_checkpoints_fndecl_11352_fns nilfs_cpfile_delete_checkpoints fndecl 2-3 11352 NULL nohasharray
+fdb_insert_fndecl_11352_fns fdb_insert fndecl 4 11352 &nilfs_cpfile_delete_checkpoints_fndecl_11352_fns
+fd_execute_rw_fndecl_11359_fns fd_execute_rw fndecl 3 11359 NULL
+ieee80211_if_read_ht_opmode_fndecl_11367_fns ieee80211_if_read_ht_opmode fndecl 3 11367 NULL
+sctp_getsockopt_assoc_stats_fndecl_11393_fns sctp_getsockopt_assoc_stats fndecl 2 11393 NULL
+txs_vardecl_ambassador_c_11398_fns txs vardecl_ambassador.c 0 11398 NULL
+iso_packets_buffer_init_fndecl_11414_fns iso_packets_buffer_init fndecl 3 11414 NULL
+lpfc_idiag_extacc_drivr_get_fndecl_11416_fns lpfc_idiag_extacc_drivr_get fndecl 3-0 11416 NULL
+isdn_ppp_write_fndecl_11430_fns isdn_ppp_write fndecl 4 11430 NULL
+acpi_node_prop_read_fndecl_11442_fns acpi_node_prop_read fndecl 0 11442 NULL
+iwl_dbgfs_log_event_write_fndecl_11443_fns iwl_dbgfs_log_event_write fndecl 3 11443 NULL
+ccp_init_dm_workarea_fndecl_11450_fns ccp_init_dm_workarea fndecl 3 11450 NULL
+wmi_evt_tx_mgmt_fndecl_11458_fns wmi_evt_tx_mgmt fndecl 4 11458 NULL
+proc_scsi_write_fndecl_11461_fns proc_scsi_write fndecl 3 11461 NULL
+xt_alloc_entry_offsets_fndecl_11488_fns xt_alloc_entry_offsets fndecl 1 11488 NULL
+count_e1000_ring_11491_fns count e1000_ring 0 11491 NULL
+context_struct_to_string_fndecl_11502_fns context_struct_to_string fndecl 0 11502 NULL
+response_length_ib_uverbs_ex_create_rwq_ind_table_resp_11540_fns response_length ib_uverbs_ex_create_rwq_ind_table_resp 0 11540 NULL
+max_transfer_size_s2255_pipeinfo_11546_fns max_transfer_size s2255_pipeinfo 0 11546 NULL
+drm_plane_init_fndecl_11560_fns drm_plane_init fndecl 6 11560 NULL
+balance_level_fndecl_11568_fns balance_level fndecl 0 11568 NULL
+brcmf_fil_iovar_data_get_fndecl_11579_fns brcmf_fil_iovar_data_get fndecl 4 11579 NULL
+update_memcg_params_fndecl_11583_fns update_memcg_params fndecl 2 11583 NULL
+pwc_get_fps_fndecl_11588_fns pwc_get_fps fndecl 0 11588 NULL
+rpc_pipe_generic_upcall_fndecl_11597_fns rpc_pipe_generic_upcall fndecl 4 11597 NULL
+read_file_btcoex_fndecl_11604_fns read_file_btcoex fndecl 3 11604 NULL
+vmw_execbuf_process_fndecl_11642_fns vmw_execbuf_process fndecl 5 11642 NULL
+device_property_read_u32_array_fndecl_11662_fns device_property_read_u32_array fndecl 0 11662 NULL
+sel_write_member_fndecl_11667_fns sel_write_member fndecl 3 11667 NULL
+vp_request_msix_vectors_fndecl_11682_fns vp_request_msix_vectors fndecl 2 11682 NULL
+data_len_b43legacy_dfs_file_11690_fns data_len b43legacy_dfs_file 0 11690 NULL
+fill_note_info_fndecl_11692_fns fill_note_info fndecl 2 11692 NULL
+mlx5_query_port_qetcr_reg_fndecl_11697_fns mlx5_query_port_qetcr_reg fndecl 3 11697 NULL
+kernel_tree_alloc_fndecl_11698_fns kernel_tree_alloc fndecl 1 11698 NULL nohasharray
+__i2c_read_fndecl_11698_fns __i2c_read fndecl 0 11698 &kernel_tree_alloc_fndecl_11698_fns
+iwl_dbgfs_rxon_filter_flags_read_fndecl_11699_fns iwl_dbgfs_rxon_filter_flags_read fndecl 3 11699 NULL
+ipv6_renew_options_fndecl_11728_fns ipv6_renew_options fndecl 5 11728 NULL
+cifs_linux_ext_proc_write_fndecl_11755_fns cifs_linux_ext_proc_write fndecl 3 11755 NULL
+p9_client_prepare_req_fndecl_11803_fns p9_client_prepare_req fndecl 3 11803 NULL
+__kmalloc_node_fndecl_11804_fns __kmalloc_node fndecl 1 11804 NULL
+size_mvpp2_tx_queue_11816_fns size mvpp2_tx_queue 0 11816 NULL
+atk_debugfs_ggrp_read_fndecl_11841_fns atk_debugfs_ggrp_read fndecl 3 11841 NULL
+num_crtc_mga_device_11851_fns num_crtc mga_device 0 11851 NULL
+sg_tablesize_srp_target_port_11858_fns sg_tablesize srp_target_port 0 11858 NULL
+btmrvl_pscmd_write_fndecl_11859_fns btmrvl_pscmd_write fndecl 3 11859 NULL
+frame_rate_sd_11862_fns frame_rate sd 0 11862 NULL
+wr_host_buf_pos_xilly_channel_11866_fns wr_host_buf_pos xilly_channel 0 11866 NULL
+leaf_dealloc_fndecl_11885_fns leaf_dealloc fndecl 3 11885 NULL nohasharray
+alloc_empty_pages_fndecl_11885_fns alloc_empty_pages fndecl 2 11885 &leaf_dealloc_fndecl_11885_fns
+iwl_dbgfs_missed_beacon_write_fndecl_11905_fns iwl_dbgfs_missed_beacon_write fndecl 3 11905 NULL
+mwifiex_histogram_read_fndecl_11910_fns mwifiex_histogram_read fndecl 3 11910 NULL
+snd_device_new_fndecl_11911_fns snd_device_new fndecl 0 11911 NULL
+lbs_lowsnr_read_fndecl_11920_fns lbs_lowsnr_read fndecl 3 11920 NULL
+kvm_read_guest_virt_system_fndecl_11922_fns kvm_read_guest_virt_system fndecl 4-2 11922 NULL
+arm_coherent_iommu_alloc_attrs_fndecl_11939_fns arm_coherent_iommu_alloc_attrs fndecl 2 11939 NULL
+spi_write_fndecl_11948_fns spi_write fndecl 0 11948 NULL
+osc_cached_mb_seq_write_fndecl_11961_fns osc_cached_mb_seq_write fndecl 3 11961 NULL
+red_left_pad_kmem_cache_11964_fns red_left_pad kmem_cache 0 11964 NULL
+sctp_make_abort_user_fndecl_11973_fns sctp_make_abort_user fndecl 3 11973 NULL nohasharray
+spmi_controller_alloc_fndecl_11973_fns spmi_controller_alloc fndecl 2 11973 &sctp_make_abort_user_fndecl_11973_fns
+ssp_create_msg_fndecl_11986_fns ssp_create_msg fndecl 2 11986 NULL
+tx_frag_cache_hit_read_fndecl_11988_fns tx_frag_cache_hit_read fndecl 3 11988 NULL
+ndevcntrs_hfi1_devdata_11997_fns ndevcntrs hfi1_devdata 0 11997 NULL
+sisusb_write_mem_bulk_fndecl_12029_fns sisusb_write_mem_bulk fndecl 4 12029 NULL
+alloc_group_attrs_fndecl_12032_fns alloc_group_attrs fndecl 3 12032 NULL nohasharray
+wusb_prf_256_fndecl_12032_fns wusb_prf_256 fndecl 7 12032 &alloc_group_attrs_fndecl_12032_fns
+drm_property_create_enum_fndecl_12034_fns drm_property_create_enum fndecl 5 12034 NULL
+comedi_alloc_subdevices_fndecl_12036_fns comedi_alloc_subdevices fndecl 2 12036 NULL
+evdev_handle_get_val_fndecl_12073_fns evdev_handle_get_val fndecl 5-6 12073 NULL
+nvme_trans_copy_from_user_fndecl_12088_fns nvme_trans_copy_from_user fndecl 3 12088 NULL
+iwl_dbgfs_temperature_read_fndecl_12091_fns iwl_dbgfs_temperature_read fndecl 3 12091 NULL
+security_context_to_sid_core_fndecl_12115_fns security_context_to_sid_core fndecl 2 12115 NULL
+mempool_resize_fndecl_12140_fns mempool_resize fndecl 2 12140 NULL
+nfs42_proc_copy_fndecl_12169_fns nfs42_proc_copy fndecl 2-5 12169 NULL
+max_fingers_silead_ts_data_12170_fns max_fingers silead_ts_data 0 12170 NULL
+__fuse_get_req_fndecl_12176_fns __fuse_get_req fndecl 2 12176 NULL
+bulk_in_size_sur40_state_12178_fns bulk_in_size sur40_state 0 12178 NULL
+lprocfs_write_helper_fndecl_12184_fns lprocfs_write_helper fndecl 2 12184 NULL
+alloc_and_copy_ftrace_hash_fndecl_12203_fns alloc_and_copy_ftrace_hash fndecl 1 12203 NULL
+l2cap_sock_setsockopt_old_fndecl_12209_fns l2cap_sock_setsockopt_old fndecl 4 12209 NULL
+hci_sock_sendmsg_fndecl_12231_fns hci_sock_sendmsg fndecl 3 12231 NULL
+read_file_tx99_power_fndecl_12238_fns read_file_tx99_power fndecl 3 12238 NULL
+unique_len_drm_master_12259_fns unique_len drm_master 0 12259 NULL
+zs_size_classes_vardecl_zsmalloc_c_12260_fns zs_size_classes vardecl_zsmalloc.c 0 12260 NULL
+mempool_create_fndecl_12270_fns mempool_create fndecl 1 12270 NULL
+handle_fcp_fndecl_12283_fns handle_fcp fndecl 9 12283 NULL
+capacity_sddr09_card_info_12286_fns capacity sddr09_card_info 0 12286 NULL
+nb_blocks_NFTLrecord_12306_fns nb_blocks NFTLrecord 0 12306 NULL
+tracing_clock_write_fndecl_12330_fns tracing_clock_write fndecl 3 12330 NULL
+srpt_alloc_rw_ctxs_fndecl_12333_fns srpt_alloc_rw_ctxs fndecl 3 12333 NULL
+bank_size_stub_chip_12338_fns bank_size stub_chip 0 12338 NULL
+igb_pci_sriov_configure_fndecl_12359_fns igb_pci_sriov_configure fndecl 2 12359 NULL
+i_entries_gfs2_inode_12374_fns i_entries gfs2_inode 0 12374 NULL
+mic_rx_pkts_read_fndecl_12375_fns mic_rx_pkts_read fndecl 3 12375 NULL
+pci_enable_device_flags_fndecl_12378_fns pci_enable_device_flags fndecl 0 12378 NULL
+ath10k_read_quiet_period_fndecl_12397_fns ath10k_read_quiet_period fndecl 3 12397 NULL
+powercap_register_zone_fndecl_12399_fns powercap_register_zone fndecl 6 12399 NULL
+edt_ft5x06_debugfs_raw_data_read_fndecl_12401_fns edt_ft5x06_debugfs_raw_data_read fndecl 3 12401 NULL
+snd_rawmidi_write_fndecl_12411_fns snd_rawmidi_write fndecl 3 12411 NULL
+cx231xx_init_vbi_isoc_fndecl_12422_fns cx231xx_init_vbi_isoc fndecl 3-4-2 12422 NULL
+init_rs_non_canonical_fndecl_12424_fns init_rs_non_canonical fndecl 1-5 12424 NULL
+add_pid_filter_fndecl_12429_fns add_pid_filter fndecl 0 12429 NULL
+lpfc_idiag_mbxacc_read_fndecl_12430_fns lpfc_idiag_mbxacc_read fndecl 3 12430 NULL
+sctp_setsockopt_maxburst_fndecl_12442_fns sctp_setsockopt_maxburst fndecl 3 12442 NULL
+acpi_gsb_i2c_write_bytes_fndecl_12449_fns acpi_gsb_i2c_write_bytes fndecl 4 12449 NULL
+tx_frag_bad_mblk_num_read_fndecl_12467_fns tx_frag_bad_mblk_num_read fndecl 3 12467 NULL
+rx_defrag_need_defrag_read_fndecl_12486_fns rx_defrag_need_defrag_read fndecl 3 12486 NULL
+acpi_tb_install_standard_table_fndecl_12495_fns acpi_tb_install_standard_table fndecl 1 12495 NULL
+mmc_test_alloc_mem_fndecl_12501_fns mmc_test_alloc_mem fndecl 2-3 12501 NULL
+stream_next_buffer_fndecl_12502_fns stream_next_buffer fndecl 0 12502 NULL
+stats_dot11FCSErrorCount_read_fndecl_12521_fns stats_dot11FCSErrorCount_read fndecl 3 12521 NULL
+snd_midi_channel_alloc_set_fndecl_12522_fns snd_midi_channel_alloc_set fndecl 1 12522 NULL
+learn_buffer_user_len_vardecl_gracl_learn_c_12538_fns learn_buffer_user_len vardecl_gracl_learn.c 0 12538 NULL
+mlxsw_cmd_mbox_query_aq_cap_max_num_cqs_get_fndecl_12540_fns mlxsw_cmd_mbox_query_aq_cap_max_num_cqs_get fndecl 0 12540 NULL
+rxd_cnt_nfp_net_12541_fns rxd_cnt nfp_net 0 12541 NULL
+cdrom_read_cdda_old_fndecl_12547_fns cdrom_read_cdda_old fndecl 4 12547 NULL
+irq_count_rmi_driver_data_12580_fns irq_count rmi_driver_data 0 12580 NULL
+fs_path_add_from_extent_buffer_fndecl_12581_fns fs_path_add_from_extent_buffer fndecl 4-0 12581 NULL
+evm_write_key_fndecl_12624_fns evm_write_key fndecl 3 12624 NULL
+tw686x_fps_idx_fndecl_12646_fns tw686x_fps_idx fndecl 2 12646 NULL
+kcalloc_fndecl_12649_fns kcalloc fndecl 1-2 12649 NULL
+num_aces_cifs_acl_12670_fns num_aces cifs_acl 0 12670 NULL
+transport_init_session_tags_fndecl_12691_fns transport_init_session_tags fndecl 1-2 12691 NULL
+t2_num_pages_qed_cxt_mngr_12696_fns t2_num_pages qed_cxt_mngr 0 12696 NULL
+fld_debugfs_hash_seq_write_fndecl_12713_fns fld_debugfs_hash_seq_write fndecl 3 12713 NULL
+sys_listxattr_fndecl_12714_fns sys_listxattr fndecl 3 12714 NULL
+rdma_rw_init_mr_wrs_fndecl_12719_fns rdma_rw_init_mr_wrs fndecl 5 12719 NULL
+read_profile_fndecl_12736_fns read_profile fndecl 3 12736 NULL
+sky2_pci_read16_fndecl_12740_fns sky2_pci_read16 fndecl 0 12740 NULL
+num_unit_element_struct_12767_fns num unit_element_struct 0 12767 NULL
+driver_add_groups_fndecl_12778_fns driver_add_groups fndecl 0 12778 NULL
+ieee80211_if_read_dot11MeshHWMProotInterval_fndecl_12786_fns ieee80211_if_read_dot11MeshHWMProotInterval fndecl 3 12786 NULL
+testmode_write_fndecl_12814_fns testmode_write fndecl 3 12814 NULL
+hint_events_per_packet_input_dev_12818_fns hint_events_per_packet input_dev 0 12818 NULL
+ksocknal_alloc_tx_fndecl_12825_fns ksocknal_alloc_tx fndecl 2 12825 NULL
+of_n_addr_cells_fndecl_12852_fns of_n_addr_cells fndecl 0 12852 NULL
+key_mic_failures_read_fndecl_12858_fns key_mic_failures_read fndecl 3 12858 NULL
+omap_gem_new_dmabuf_fndecl_12877_fns omap_gem_new_dmabuf fndecl 2 12877 NULL
+max_response_pages_fndecl_12895_fns max_response_pages fndecl 0 12895 NULL
+dbgfs_sram_len_iwl_mvm_12900_fns dbgfs_sram_len iwl_mvm 0 12900 NULL
+gsm_stuff_frame_fndecl_12918_fns gsm_stuff_frame fndecl 0 12918 NULL
+nilfs_sufile_delete_segment_usage_block_fndecl_12921_fns nilfs_sufile_delete_segment_usage_block fndecl 2 12921 NULL
+i2400m_tx_stats_read_fndecl_12924_fns i2400m_tx_stats_read fndecl 3 12924 NULL
+obufsize_sisusb_usb_data_12932_fns obufsize sisusb_usb_data 0 12932 NULL
+run_delalloc_range_fndecl_12946_fns run_delalloc_range fndecl 3-4 12946 NULL nohasharray
+aio_read_events_fndecl_12946_fns aio_read_events fndecl 3 12946 &run_delalloc_range_fndecl_12946_fns nohasharray
+mptctl_getiocinfo_fndecl_12946_fns mptctl_getiocinfo fndecl 2 12946 &aio_read_events_fndecl_12946_fns
+sel_read_policycap_fndecl_12947_fns sel_read_policycap fndecl 3 12947 NULL
+b43legacy_debugfs_write_fndecl_12959_fns b43legacy_debugfs_write fndecl 3 12959 NULL
+kfifo_unused_fndecl_13015_fns kfifo_unused fndecl 0 13015 NULL
+rpcrdma_alloc_regbuf_fndecl_13018_fns rpcrdma_alloc_regbuf fndecl 2 13018 NULL
+snd_nm256_capture_copy_fndecl_13021_fns snd_nm256_capture_copy fndecl 5 13021 NULL
+iwl_dbgfs_nic_temp_read_fndecl_13029_fns iwl_dbgfs_nic_temp_read fndecl 3 13029 NULL
+blk_queue_resize_tags_fndecl_13037_fns blk_queue_resize_tags fndecl 2 13037 NULL
+p9_fcall_alloc_fndecl_13055_fns p9_fcall_alloc fndecl 1 13055 NULL
+calib_calib_count_read_fndecl_13060_fns calib_calib_count_read fndecl 3 13060 NULL
+drm_fbdev_cma_init_with_funcs_fndecl_13066_fns drm_fbdev_cma_init_with_funcs fndecl 3-4-2 13066 NULL
+vread_fndecl_13086_fns vread fndecl 0-3 13086 NULL
+thermal_zone_device_register_fndecl_13093_fns thermal_zone_device_register fndecl 2 13093 NULL nohasharray
+vrambase_sisusb_usb_data_13093_fns vrambase sisusb_usb_data 0 13093 &thermal_zone_device_register_fndecl_13093_fns
+sctp_tsnmap_skip_fndecl_13103_fns sctp_tsnmap_skip fndecl 2 13103 NULL
+line6_alloc_sysex_buffer_fndecl_13138_fns line6_alloc_sysex_buffer fndecl 4 13138 NULL
+inline_xattr_size_fndecl_13166_fns inline_xattr_size fndecl 0 13166 NULL
+iproc_pll_clk_setup_fndecl_13179_fns iproc_pll_clk_setup fndecl 6 13179 NULL
+bsg_setup_queue_fndecl_13194_fns bsg_setup_queue fndecl 5 13194 NULL
+snd_pcm_oss_read_fndecl_13198_fns snd_pcm_oss_read fndecl 3 13198 NULL
+bm_entry_write_fndecl_13217_fns bm_entry_write fndecl 3 13217 NULL
+snapshot_write_fndecl_13228_fns snapshot_write fndecl 3 13228 NULL
+filldir64_fndecl_13232_fns filldir64 fndecl 3 13232 NULL
+batadv_handle_tt_response_fndecl_13249_fns batadv_handle_tt_response fndecl 4 13249 NULL
+compress_file_range_fndecl_13295_fns compress_file_range fndecl 3-4 13295 NULL
+dlmfs_file_read_fndecl_13298_fns dlmfs_file_read fndecl 3 13298 NULL
+tx_frag_cache_miss_read_fndecl_13305_fns tx_frag_cache_miss_read fndecl 3 13305 NULL
+req_len_snic_req_info_13319_fns req_len snic_req_info 0 13319 NULL
+svc_print_xprts_fndecl_13330_fns svc_print_xprts fndecl 0 13330 NULL
+brcmf_usb_dl_cmd_fndecl_13344_fns brcmf_usb_dl_cmd fndecl 4 13344 NULL
+x25_asy_change_mtu_fndecl_13347_fns x25_asy_change_mtu fndecl 2 13347 NULL
+sctp_setsockopt_adaptation_layer_fndecl_13348_fns sctp_setsockopt_adaptation_layer fndecl 3 13348 NULL nohasharray
+pwr_ps_enter_read_fndecl_13348_fns pwr_ps_enter_read fndecl 3 13348 &sctp_setsockopt_adaptation_layer_fndecl_13348_fns
+hecubafb_write_fndecl_13357_fns hecubafb_write fndecl 3 13357 NULL
+hhf_zalloc_fndecl_13363_fns hhf_zalloc fndecl 1 13363 NULL
+sd_size_stat_data_13368_fns sd_size stat_data 0 13368 NULL
+error_error_frame_during_protection_read_fndecl_13376_fns error_error_frame_during_protection_read fndecl 3 13376 NULL
+T5_msg_size_mxt_data_13382_fns T5_msg_size mxt_data 0 13382 NULL
+shrink_slab_fndecl_13407_fns shrink_slab fndecl 5-4 13407 NULL
+nrealreaders_stress_lock_torture_cxt_13422_fns nrealreaders_stress lock_torture_cxt 0 13422 NULL
+tb_path_alloc_fndecl_13427_fns tb_path_alloc fndecl 2 13427 NULL
+kvm_read_guest_phys_system_fndecl_13445_fns kvm_read_guest_phys_system fndecl 2-4 13445 NULL
+mmp_clk_init_fndecl_13447_fns mmp_clk_init fndecl 3 13447 NULL
+fill_read_buf_fndecl_13455_fns fill_read_buf fndecl 2 13455 NULL
+snd_ctl_new_fndecl_13472_fns snd_ctl_new fndecl 2 13472 NULL
+__videobuf_alloc_vb_fndecl_13477_fns __videobuf_alloc_vb fndecl 1 13477 NULL
+devfn_slot_13478_fns devfn slot 0 13478 NULL
+iwl_mvm_notify_rx_queue_fndecl_13499_fns iwl_mvm_notify_rx_queue fndecl 4 13499 NULL
+btmrvl_hscmd_write_fndecl_13506_fns btmrvl_hscmd_write fndecl 3 13506 NULL
+max_out_size_ims_pcu_13527_fns max_out_size ims_pcu 0 13527 NULL
+alloc_fdmem_fndecl_13528_fns alloc_fdmem fndecl 1 13528 NULL
+ppp_print_buffer_fndecl_13530_fns ppp_print_buffer fndecl 3 13530 NULL
+tool_mw_read_fndecl_13537_fns tool_mw_read fndecl 3 13537 NULL
+p_filesz_elf64_phdr_13545_fns p_filesz elf64_phdr 0 13545 NULL
+pset_prop_count_elems_of_size_fndecl_13547_fns pset_prop_count_elems_of_size fndecl 3-0 13547 NULL
+len_prism2_download_data_area_13551_fns len prism2_download_data_area 0 13551 NULL
+buf_len_vp702x_device_state_13562_fns buf_len vp702x_device_state 0 13562 NULL
+edt_ft5x06_ts_readwrite_fndecl_13570_fns edt_ft5x06_ts_readwrite fndecl 0 13570 NULL
+avc_tuner_dsd_dvb_t_fndecl_13571_fns avc_tuner_dsd_dvb_t fndecl 0 13571 NULL
+irq_alloc_generic_chip_fndecl_13577_fns irq_alloc_generic_chip fndecl 2 13577 NULL
+pwr_fix_tsf_ps_read_fndecl_13584_fns pwr_fix_tsf_ps_read fndecl 3 13584 NULL
+flowinfo_read_fndecl_13608_fns flowinfo_read fndecl 3 13608 NULL
+cipso_v4_map_cat_rbm_hton_fndecl_13611_fns cipso_v4_map_cat_rbm_hton fndecl 0 13611 NULL
+__alloc_pred_stack_fndecl_13612_fns __alloc_pred_stack fndecl 2 13612 NULL
+usb_reset_device_fndecl_13622_fns usb_reset_device fndecl 0 13622 NULL
+ws_col_winsize_13628_fns ws_col winsize 0 13628 NULL
+max_dpcd_transaction_bytes_drm_dp_mst_topology_mgr_13637_fns max_dpcd_transaction_bytes drm_dp_mst_topology_mgr 0 13637 NULL
+sysfs_add_file_fndecl_13647_fns sysfs_add_file fndecl 0 13647 NULL
+lowpan_ctx_pfx_write_fndecl_13658_fns lowpan_ctx_pfx_write fndecl 3 13658 NULL
+vhost_copy_from_user_fndecl_13681_fns vhost_copy_from_user fndecl 4 13681 NULL
+__fwnode_property_read_string_array_fndecl_13689_fns __fwnode_property_read_string_array fndecl 0 13689 NULL
+resize_platform_label_table_fndecl_13711_fns resize_platform_label_table fndecl 2 13711 NULL
+shdma_prep_dma_cyclic_fndecl_13739_fns shdma_prep_dma_cyclic fndecl 4-3 13739 NULL
+pof_write_buffer_fndecl_13741_fns pof_write_buffer fndecl 0-2 13741 NULL
+regmap_ibt_write_fndecl_13743_fns regmap_ibt_write fndecl 3 13743 NULL nohasharray
+cipso_v4_genopt_fndecl_13743_fns cipso_v4_genopt fndecl 0 13743 &regmap_ibt_write_fndecl_13743_fns
+qlcnic_alloc_sds_rings_fndecl_13752_fns qlcnic_alloc_sds_rings fndecl 2 13752 NULL
+iwl_trans_read_mem32_fndecl_13786_fns iwl_trans_read_mem32 fndecl 0 13786 NULL
+ept_get_level1_sp_gpa_fndecl_13788_fns ept_get_level1_sp_gpa fndecl 0 13788 NULL
+num_fcoe_msix_i40e_pf_13802_fns num_fcoe_msix i40e_pf 0 13802 NULL
+ath6kl_create_qos_write_fndecl_13804_fns ath6kl_create_qos_write fndecl 3 13804 NULL
+seq_read_fndecl_13824_fns seq_read fndecl 3 13824 NULL
+ib_dma_map_sg_fndecl_13830_fns ib_dma_map_sg fndecl 0 13830 NULL
+ieee80211_if_read_smps_fndecl_13835_fns ieee80211_if_read_smps fndecl 3 13835 NULL
+init_memory_mapping_fndecl_13840_fns init_memory_mapping fndecl 1-2 13840 NULL
+sddr09_read_data_fndecl_13860_fns sddr09_read_data fndecl 3 13860 NULL
+rlen_cm4000_dev_13899_fns rlen cm4000_dev 0 13899 NULL
+wm_coeff_parse_int_fndecl_13918_fns wm_coeff_parse_int fndecl 0 13918 NULL
+trips_thermal_zone_device_13921_fns trips thermal_zone_device 0 13921 NULL
+garmin_read_process_fndecl_13926_fns garmin_read_process fndecl 3 13926 NULL
+hcd_buffer_alloc_fndecl_13940_fns hcd_buffer_alloc fndecl 2 13940 NULL
+img_IMEM_size_fw_hdr_13961_fns img_IMEM_size fw_hdr 0 13961 NULL
+nes_dump_mem_fndecl_13971_fns nes_dump_mem fndecl 3 13971 NULL
+ib_copy_to_udata_fndecl_13974_fns ib_copy_to_udata fndecl 3 13974 NULL
+e_phnum_elf32_hdr_13980_fns e_phnum elf32_hdr 0 13980 NULL
+syslog_partial_vardecl_printk_c_13985_fns syslog_partial vardecl_printk.c 0 13985 NULL
+libipw_alloc_txb_fndecl_13992_fns libipw_alloc_txb fndecl 1 13992 NULL
+i2400mu_notification_grok_fndecl_13997_fns i2400mu_notification_grok fndecl 3 13997 NULL
+batadv_socket_add_packet_fndecl_14011_fns batadv_socket_add_packet fndecl 3 14011 NULL
+sensor_framerate_go7007_14025_fns sensor_framerate go7007 0 14025 NULL
+descriptors_per_page__drm_via_sg_info_14046_fns descriptors_per_page _drm_via_sg_info 0 14046 NULL
+C_SYSC_mbind_fndecl_14055_fns C_SYSC_mbind fndecl 5 14055 NULL
+read_flush_procfs_fndecl_14057_fns read_flush_procfs fndecl 3 14057 NULL
+regmap_ibt_gather_write_fndecl_14087_fns regmap_ibt_gather_write fndecl 5 14087 NULL
+_mv88e6xxx_port_vlan_add_fndecl_14091_fns _mv88e6xxx_port_vlan_add fndecl 3 14091 NULL
+snd_compr_calc_avail_fndecl_14094_fns snd_compr_calc_avail fndecl 0 14094 NULL
+btmrvl_hscfgcmd_write_fndecl_14100_fns btmrvl_hscfgcmd_write fndecl 3 14100 NULL
+wil_write_file_wmi_fndecl_14109_fns wil_write_file_wmi fndecl 3 14109 NULL
+ieee80211_if_read_rc_rateidx_mask_5ghz_fndecl_14140_fns ieee80211_if_read_rc_rateidx_mask_5ghz fndecl 3 14140 NULL
+write_kmem_fndecl_14154_fns write_kmem fndecl 3 14154 NULL nohasharray
+svcxdr_tmpalloc_fndecl_14154_fns svcxdr_tmpalloc fndecl 2 14154 &write_kmem_fndecl_14154_fns
+uvc_fraction_to_interval_fndecl_14194_fns uvc_fraction_to_interval fndecl 0-2-1 14194 NULL
+comedi_alloc_devpriv_fndecl_14235_fns comedi_alloc_devpriv fndecl 2 14235 NULL
+usb_submit_urb_fndecl_14237_fns usb_submit_urb fndecl 0 14237 NULL
+write_buf_fndecl_14247_fns write_buf fndecl 0 14247 NULL
+copy_from_buf_fndecl_14271_fns copy_from_buf fndecl 2-4 14271 NULL
+afs_cell_create_fndecl_14273_fns afs_cell_create fndecl 2 14273 NULL
+snd_pcm_oss_write2_fndecl_14295_fns snd_pcm_oss_write2 fndecl 3 14295 NULL
+scif_p2p_setsg_fndecl_14314_fns scif_p2p_setsg fndecl 3 14314 NULL
+iwl_dbgfs_csr_write_fndecl_14320_fns iwl_dbgfs_csr_write fndecl 3 14320 NULL
+size_wpa_suite_t_14321_fns size wpa_suite_t 0 14321 NULL
+pcbit_stat_fndecl_14327_fns pcbit_stat fndecl 2 14327 NULL
+pxad_alloc_desc_fndecl_14330_fns pxad_alloc_desc fndecl 2 14330 NULL
+carl9170_cmd_callback_fndecl_14341_fns carl9170_cmd_callback fndecl 2 14341 NULL
+ath6kl_regread_read_fndecl_14351_fns ath6kl_regread_read fndecl 3 14351 NULL
+size_set_mib_buffer_14366_fns size set_mib_buffer 0 14366 NULL
+nvme_trans_mode_page_create_fndecl_14375_fns nvme_trans_mode_page_create fndecl 7-4 14375 NULL
+lirc_rx51_write_fndecl_14379_fns lirc_rx51_write fndecl 3 14379 NULL
+rcname_read_fndecl_14380_fns rcname_read fndecl 3 14380 NULL
+fdb_create_fndecl_14403_fns fdb_create fndecl 4 14403 NULL
+ssize_usbat_info_14405_fns ssize usbat_info 0 14405 NULL
+vmcb_iopm_nested_state_14411_fns vmcb_iopm nested_state 0 14411 NULL
+max_ep_fsl_udc_14417_fns max_ep fsl_udc 0 14417 NULL
+key_flags_read_fndecl_14424_fns key_flags_read fndecl 3 14424 NULL
+snd_es1938_capture_copy_fndecl_14425_fns snd_es1938_capture_copy fndecl 5 14425 NULL
+flush_fndecl_14454_fns flush fndecl 2 14454 NULL
+_regmap_multi_reg_write_fndecl_14460_fns _regmap_multi_reg_write fndecl 3 14460 NULL
+cfs_hash_create_fndecl_14468_fns cfs_hash_create fndecl 4-2 14468 NULL
+gsm_control_send_fndecl_14499_fns gsm_control_send fndecl 4 14499 NULL
+selinux_inode_post_setxattr_fndecl_14502_fns selinux_inode_post_setxattr fndecl 4 14502 NULL
+bnad_q_num_adjust_fndecl_14512_fns bnad_q_num_adjust fndecl 2 14512 NULL
+memcg_update_all_list_lrus_fndecl_14532_fns memcg_update_all_list_lrus fndecl 1 14532 NULL
+density_scsi_tape_14545_fns density scsi_tape 0 14545 NULL
+__alloc_memory_core_early_fndecl_14550_fns __alloc_memory_core_early fndecl 2 14550 NULL
+keyctl_update_key_fndecl_14558_fns keyctl_update_key fndecl 3 14558 NULL
+befs_utf2nls_fndecl_14607_fns befs_utf2nls fndecl 3 14607 NULL
+vmw_execbuf_cmdbuf_fndecl_14639_fns vmw_execbuf_cmdbuf fndecl 4 14639 NULL
+interval_solo_enc_dev_14661_fns interval solo_enc_dev 0 14661 NULL
+tty_copy_to_user_fndecl_14668_fns tty_copy_to_user fndecl 3-4 14668 NULL nohasharray
+mlx5_query_ports_check_fndecl_14668_fns mlx5_query_ports_check fndecl 3 14668 &tty_copy_to_user_fndecl_14668_fns
+image_size_ls_ucode_img_desc_14672_fns image_size ls_ucode_img_desc 0 14672 NULL
+lpfc_idiag_cmd_get_fndecl_14683_fns lpfc_idiag_cmd_get fndecl 2 14683 NULL
+ibmasm_new_command_fndecl_14689_fns ibmasm_new_command fndecl 2 14689 NULL
+rx_filter_mc_filter_read_fndecl_14691_fns rx_filter_mc_filter_read fndecl 3 14691 NULL
+num_sizes_vmw_surface_14695_fns num_sizes vmw_surface 0 14695 NULL
+count_ctxt_eager_bufs_14698_fns count ctxt_eager_bufs 0 14698 NULL
+__alloc_bootmem_low_node_fndecl_14701_fns __alloc_bootmem_low_node fndecl 2 14701 NULL nohasharray
+sel_write_context_fndecl_14701_fns sel_write_context fndecl 3 14701 &__alloc_bootmem_low_node_fndecl_14701_fns
+change_tx_queue_len_fndecl_14718_fns change_tx_queue_len fndecl 2 14718 NULL
+cxgbi_device_portmap_create_fndecl_14720_fns cxgbi_device_portmap_create fndecl 3 14720 NULL
+event_rx_pool_read_fndecl_14803_fns event_rx_pool_read fndecl 3 14803 NULL
+sg_read_fndecl_14804_fns sg_read fndecl 3 14804 NULL
+parport_read_fndecl_14828_fns parport_read fndecl 0 14828 NULL
+mlx5_core_sriov_configure_fndecl_14829_fns mlx5_core_sriov_configure fndecl 2 14829 NULL
+pwr_missing_bcns_read_fndecl_14835_fns pwr_missing_bcns_read fndecl 3 14835 NULL
+map_len_ssfdcr_record_14843_fns map_len ssfdcr_record 0 14843 NULL
+threads_mask_netns_ipvs_14873_fns threads_mask netns_ipvs 0 14873 NULL
+inocache_hashsize_jffs2_sb_info_14875_fns inocache_hashsize jffs2_sb_info 0 14875 NULL
+submit_queues_vardecl_null_blk_c_14881_fns submit_queues vardecl_null_blk.c 0 14881 NULL
+ebcnt_vardecl_pagetest_c_14897_fns ebcnt vardecl_pagetest.c 0 14897 NULL
+firmware_store_fndecl_14907_fns firmware_store fndecl 4 14907 NULL
+tower_read_fndecl_14926_fns tower_read fndecl 3 14926 NULL
+pagemap_read_fndecl_14938_fns pagemap_read fndecl 3 14938 NULL
+ib_alloc_device_fndecl_14944_fns ib_alloc_device fndecl 1 14944 NULL
+dump_smb_fndecl_14947_fns dump_smb fndecl 2 14947 NULL
+ulong_write_file_fndecl_14950_fns ulong_write_file fndecl 3 14950 NULL
+iwl_dbgfs_rf_reset_read_fndecl_14979_fns iwl_dbgfs_rf_reset_read fndecl 3 14979 NULL
+alloc_ep_req_fndecl_14986_fns alloc_ep_req fndecl 3-2 14986 NULL
+uhid_char_write_fndecl_14997_fns uhid_char_write fndecl 3 14997 NULL
+read_vmcore_fndecl_14998_fns read_vmcore fndecl 3 14998 NULL
+vfio_pci_set_msi_trigger_fndecl_15000_fns vfio_pci_set_msi_trigger fndecl 4-3 15000 NULL
+length_sge_ieee1212_15003_fns length sge_ieee1212 0 15003 NULL
+__vhost_add_used_n_fndecl_15017_fns __vhost_add_used_n fndecl 3 15017 NULL
+rts51x_read_mem_fndecl_15042_fns rts51x_read_mem fndecl 4 15042 NULL
+num_user_pages_fndecl_15045_fns num_user_pages fndecl 0 15045 NULL
+max_io_len_dm_target_15053_fns max_io_len dm_target 0 15053 NULL
+usbat_read_blocks_fndecl_15109_fns usbat_read_blocks fndecl 3-4 15109 NULL
+SYSC_bpf_fndecl_15113_fns SYSC_bpf fndecl 3 15113 NULL
+ebcnt_vardecl_stresstest_c_15125_fns ebcnt vardecl_stresstest.c 0 15125 NULL
+_nfs42_proc_llseek_fndecl_15127_fns _nfs42_proc_llseek fndecl 3 15127 NULL
+ath6kl_roam_table_read_fndecl_15141_fns ath6kl_roam_table_read fndecl 3 15141 NULL
+copy_oldmem_page_fndecl_15143_fns copy_oldmem_page fndecl 3 15143 NULL
+chaoskey_read_fndecl_15155_fns chaoskey_read fndecl 3 15155 NULL
+walk_hugetlb_range_fndecl_15190_fns walk_hugetlb_range fndecl 0 15190 NULL
+nlm_end_grace_read_fndecl_15209_fns nlm_end_grace_read fndecl 3 15209 NULL
+genwqe_ffdc_buff_size_fndecl_15236_fns genwqe_ffdc_buff_size fndecl 0 15236 NULL
+num_tx_queues_net_device_15263_fns num_tx_queues net_device 0 15263 NULL
+cx24120_writeregs_fndecl_15295_fns cx24120_writeregs fndecl 4 15295 NULL
+pwr_wake_on_host_read_fndecl_15298_fns pwr_wake_on_host_read fndecl 3 15298 NULL
+snic_hex_dump_fndecl_15315_fns snic_hex_dump fndecl 3 15315 NULL
+snd_pcm_plug_client_channels_buf_fndecl_15318_fns snd_pcm_plug_client_channels_buf fndecl 3-0 15318 NULL
+ath10k_dbg_sta_write_addba_resp_fndecl_15326_fns ath10k_dbg_sta_write_addba_resp fndecl 3 15326 NULL
+cifs_readdata_alloc_fndecl_15339_fns cifs_readdata_alloc fndecl 1 15339 NULL
+iser_alloc_fmr_pool_fndecl_15341_fns iser_alloc_fmr_pool fndecl 3 15341 NULL
+seq_len_key_params_15366_fns seq_len key_params 0 15366 NULL
+udf_bread_fndecl_15411_fns udf_bread fndecl 2 15411 NULL
+pnp_alloc_fndecl_15414_fns pnp_alloc fndecl 1 15414 NULL
+setup_buffering_fndecl_15419_fns setup_buffering fndecl 3 15419 NULL
+queues_read_fndecl_15422_fns queues_read fndecl 3 15422 NULL
+pwc_set_video_mode_fndecl_15427_fns pwc_set_video_mode fndecl 5 15427 NULL
+callout_len_request_key_auth_15448_fns callout_len request_key_auth 0 15448 NULL nohasharray
+smk_write_net6addr_fndecl_15448_fns smk_write_net6addr fndecl 3 15448 &callout_len_request_key_auth_15448_fns
+codec_list_read_file_fndecl_15453_fns codec_list_read_file fndecl 3 15453 NULL
+wdm_create_fndecl_15456_fns wdm_create fndecl 3 15456 NULL
+nf_nat_sdp_port_fndecl_15490_fns nf_nat_sdp_port fndecl 7 15490 NULL
+ath10k_fw_crash_dump_read_fndecl_15496_fns ath10k_fw_crash_dump_read fndecl 3 15496 NULL
+sys_rt_sigpending_fndecl_15506_fns sys_rt_sigpending fndecl 2 15506 NULL
+hi_priority_depth_MPT3SAS_ADAPTER_15543_fns hi_priority_depth MPT3SAS_ADAPTER 0 15543 NULL
+genwqe_user_vmap_fndecl_15544_fns genwqe_user_vmap fndecl 4 15544 NULL nohasharray
+key_conf_hw_key_idx_read_fndecl_15544_fns key_conf_hw_key_idx_read fndecl 3 15544 &genwqe_user_vmap_fndecl_15544_fns
+il_dbgfs_channels_read_fndecl_15550_fns il_dbgfs_channels_read fndecl 3 15550 NULL
+num_sge_ib_send_wr_15565_fns num_sge ib_send_wr 0 15565 NULL
+_mv88e6xxx_port_fdb_dump_one_fndecl_15575_fns _mv88e6xxx_port_fdb_dump_one fndecl 3 15575 NULL
+raid_set_alloc_fndecl_15581_fns raid_set_alloc fndecl 3 15581 NULL
+SYSC_listxattr_fndecl_15587_fns SYSC_listxattr fndecl 3 15587 NULL
+mlx5e_create_rqt_fndecl_15591_fns mlx5e_create_rqt fndecl 2 15591 NULL
+gs_buf_alloc_fndecl_15608_fns gs_buf_alloc fndecl 2 15608 NULL
+udf_compute_nr_groups_fndecl_15617_fns udf_compute_nr_groups fndecl 0 15617 NULL
+num_edbs_asd_seq_data_15621_fns num_edbs asd_seq_data 0 15621 NULL
+count_preds_fndecl_15627_fns count_preds fndecl 0 15627 NULL
+i915_error_state_buf_init_fndecl_15630_fns i915_error_state_buf_init fndecl 3 15630 NULL
+netlbl_domhsh_init_fndecl_15635_fns netlbl_domhsh_init fndecl 1 15635 NULL
+num_active_peers_ath10k_15643_fns num_active_peers ath10k 0 15643 NULL
+btrfs_test_extent_io_fndecl_15701_fns btrfs_test_extent_io fndecl 1 15701 NULL
+_iwl_dbgfs_tof_responder_params_write_fndecl_15710_fns _iwl_dbgfs_tof_responder_params_write fndecl 3 15710 NULL
+btrfs_chunk_sub_stripes_fndecl_15711_fns btrfs_chunk_sub_stripes fndecl 0 15711 NULL
+ib_umem_page_count_fndecl_15714_fns ib_umem_page_count fndecl 0 15714 NULL
+new_tape_buffer_fndecl_15721_fns new_tape_buffer fndecl 3 15721 NULL
+datafab_write_data_fndecl_15723_fns datafab_write_data fndecl 4 15723 NULL
+btrfs_create_qgroup_fndecl_15772_fns btrfs_create_qgroup fndecl 3 15772 NULL
+kgdb_hex2mem_fndecl_15776_fns kgdb_hex2mem fndecl 3 15776 NULL
+simple_attr_read_fndecl_15793_fns simple_attr_read fndecl 3 15793 NULL
+datablob_hmac_verify_fndecl_15809_fns datablob_hmac_verify fndecl 4 15809 NULL
+cache_read_fndecl_15813_fns cache_read fndecl 3 15813 NULL
+user_regset_copyout_fndecl_15823_fns user_regset_copyout fndecl 7 15823 NULL
+msg_print_ext_body_fndecl_15847_fns msg_print_ext_body fndecl 0 15847 NULL
+max_num_peers_ath10k_15853_fns max_num_peers ath10k 0 15853 NULL
+kvm_read_guest_virt_helper_fndecl_15863_fns kvm_read_guest_virt_helper fndecl 3-1 15863 NULL
+SYSC_kexec_load_fndecl_15874_fns SYSC_kexec_load fndecl 2 15874 NULL
+sel_read_mls_fndecl_15882_fns sel_read_mls fndecl 3 15882 NULL
+unix_mkname_fndecl_15883_fns unix_mkname fndecl 2-0 15883 NULL
+dump_align_fndecl_15890_fns dump_align fndecl 2 15890 NULL
+sn9c2028_read1_fndecl_15891_fns sn9c2028_read1 fndecl 0 15891 NULL
+num_fitmsg_context_skd_device_15897_fns num_fitmsg_context skd_device 0 15897 NULL
+cpia_usb_transferCmd_fndecl_15901_fns cpia_usb_transferCmd fndecl 0 15901 NULL
+dir_info_len_ceph_file_info_15905_fns dir_info_len ceph_file_info 0 15905 NULL
+command_setyuvtresh_fndecl_15933_fns command_setyuvtresh fndecl 0 15933 NULL
+v4l2_m2m_dqbuf_fndecl_15936_fns v4l2_m2m_dqbuf fndecl 0 15936 NULL
+rstatus_usblp_15945_fns rstatus usblp 0 15945 NULL
+hw_scan_ies_bufsize_ieee80211_local_15949_fns hw_scan_ies_bufsize ieee80211_local 0 15949 NULL
+dai_list_read_file_fndecl_15966_fns dai_list_read_file fndecl 3 15966 NULL
+mlxsw_sp_port_ets_set_fndecl_15981_fns mlxsw_sp_port_ets_set fndecl 0 15981 NULL
+nilfs_cpfile_get_blkoff_fndecl_15997_fns nilfs_cpfile_get_blkoff fndecl 2-0 15997 NULL
+gk20a_instobj_new_fndecl_16015_fns gk20a_instobj_new fndecl 2 16015 NULL
+num_stripes_map_lookup_16016_fns num_stripes map_lookup 0 16016 NULL
+snd_pcm_plugin_build_fndecl_16050_fns snd_pcm_plugin_build fndecl 5 16050 NULL
+pgsize_vardecl_pagetest_c_16065_fns pgsize vardecl_pagetest.c 0 16065 NULL
+ht_print_chan_fndecl_16071_fns ht_print_chan fndecl 0 16071 NULL
+snd_rawmidi_kernel_write_fndecl_16129_fns snd_rawmidi_kernel_write fndecl 3 16129 NULL
+fanout_set_data_ebpf_fndecl_16141_fns fanout_set_data_ebpf fndecl 3 16141 NULL
+reiserfs_commit_write_fndecl_16171_fns reiserfs_commit_write fndecl 4 16171 NULL
+ib_uverbs_alloc_pd_fndecl_16189_fns ib_uverbs_alloc_pd fndecl 4-5 16189 NULL
+osdname_len_osd_dev_info_16203_fns osdname_len osd_dev_info 0 16203 NULL
+sys_fgetxattr_fndecl_16221_fns sys_fgetxattr fndecl 4 16221 NULL
+num_tbps___thermal_zone_16249_fns num_tbps __thermal_zone 0 16249 NULL
+orangefs_debug_read_fndecl_16251_fns orangefs_debug_read fndecl 3 16251 NULL
+mon_stat_read_fndecl_16261_fns mon_stat_read fndecl 3 16261 NULL
+dvbdev_get_free_adapter_num_fndecl_16292_fns dvbdev_get_free_adapter_num fndecl 0 16292 NULL
+crypto_alloc_instance2_fndecl_16302_fns crypto_alloc_instance2 fndecl 3 16302 NULL
+jent_zalloc_fndecl_16331_fns jent_zalloc fndecl 1 16331 NULL
+l2tp_session_create_fndecl_16341_fns l2tp_session_create fndecl 1 16341 NULL
+page_offset_mlx5_srq_attr_16345_fns page_offset mlx5_srq_attr 0 16345 NULL
+help_fndecl_16375_fns help fndecl 5 16375 NULL nohasharray
+ath9k_debugfs_read_buf_fndecl_16375_fns ath9k_debugfs_read_buf fndecl 3 16375 &help_fndecl_16375_fns
+samsung_clk_init_fndecl_16382_fns samsung_clk_init fndecl 3 16382 NULL
+zd_mac_preinit_hw_fndecl_16386_fns zd_mac_preinit_hw fndecl 0 16386 NULL
+dsize_ip_set_16391_fns dsize ip_set 0 16391 NULL
+ip_options_get_alloc_fndecl_16395_fns ip_options_get_alloc fndecl 1 16395 NULL
+rt2x00debug_read_queue_stats_fndecl_16396_fns rt2x00debug_read_queue_stats fndecl 3 16396 NULL
+SYSC_setgroups_fndecl_16397_fns SYSC_setgroups fndecl 1 16397 NULL
+garp_request_join_fndecl_16444_fns garp_request_join fndecl 4 16444 NULL
+mtk_alloc_clk_data_fndecl_16481_fns mtk_alloc_clk_data fndecl 1 16481 NULL
+ttm_page_alloc_init_fndecl_16498_fns ttm_page_alloc_init fndecl 2 16498 NULL
+cfs_cpt_num_estimate_fndecl_16512_fns cfs_cpt_num_estimate fndecl 0 16512 NULL
+ath10k_read_htt_stats_mask_fndecl_16534_fns ath10k_read_htt_stats_mask fndecl 3 16534 NULL
+smk_read_mapped_fndecl_16537_fns smk_read_mapped fndecl 3 16537 NULL
+groups_alloc_fndecl_16557_fns groups_alloc fndecl 1 16557 NULL nohasharray
+create_dir_fndecl_16557_fns create_dir fndecl 0 16557 &groups_alloc_fndecl_16557_fns
+__mei_cl_send_fndecl_16571_fns __mei_cl_send fndecl 3 16571 NULL
+target_alloc_session_fndecl_16588_fns target_alloc_session fndecl 2-3 16588 NULL
+amdgpu_ttm_gtt_read_fndecl_16621_fns amdgpu_ttm_gtt_read fndecl 3 16621 NULL
+ceph_fsync_fndecl_16625_fns ceph_fsync fndecl 2-3 16625 NULL
+fault_inject_write_fndecl_16637_fns fault_inject_write fndecl 3 16637 NULL
+cons_read_buffer_16688_fns cons read_buffer 0 16688 NULL
+nvmet_get_log_page_len_fndecl_16692_fns nvmet_get_log_page_len fndecl 0 16692 NULL
+efx_ef10_pci_sriov_enable_fndecl_16694_fns efx_ef10_pci_sriov_enable fndecl 2 16694 NULL
+trace_insert_enum_map_file_fndecl_16702_fns trace_insert_enum_map_file fndecl 3 16702 NULL
+i2c1_debugfs_read_fndecl_16712_fns i2c1_debugfs_read fndecl 3 16712 NULL
+ll_sa_entry_alloc_fndecl_16721_fns ll_sa_entry_alloc fndecl 5 16721 NULL
+kimage_alloc_init_fndecl_16737_fns kimage_alloc_init fndecl 3 16737 NULL nohasharray
+rx_rate_rx_frames_per_rates_read_fndecl_16737_fns rx_rate_rx_frames_per_rates_read fndecl 3 16737 &kimage_alloc_init_fndecl_16737_fns
+devlink_alloc_fndecl_16742_fns devlink_alloc fndecl 2 16742 NULL nohasharray
+fault_disconnect_write_fndecl_16742_fns fault_disconnect_write fndecl 3 16742 &devlink_alloc_fndecl_16742_fns
+key_len_iw_encode_ext_16773_fns key_len iw_encode_ext 0 16773 NULL
+max_iu_len_srp_target_port_16784_fns max_iu_len srp_target_port 0 16784 NULL
+diva_xdi_read_fndecl_16814_fns diva_xdi_read fndecl 0 16814 NULL
+max_gen_ptrs_vardecl_net_namespace_c_16838_fns max_gen_ptrs vardecl_net_namespace.c 0 16838 NULL
+ieee80211_if_read_dot11MeshHWMPactivePathTimeout_fndecl_16859_fns ieee80211_if_read_dot11MeshHWMPactivePathTimeout fndecl 3 16859 NULL
+drm_property_create_blob_fndecl_16869_fns drm_property_create_blob fndecl 2 16869 NULL
+len_snd_fw_async_midi_port_16875_fns len snd_fw_async_midi_port 0 16875 NULL
+_ore_add_stripe_unit_fndecl_16884_fns _ore_add_stripe_unit fndecl 3-6 16884 NULL
+sl_change_mtu_fndecl_16887_fns sl_change_mtu fndecl 2 16887 NULL
+audmux_read_file_fndecl_16891_fns audmux_read_file fndecl 3 16891 NULL
+ncbflooders_vardecl_rcutorture_c_16899_fns ncbflooders vardecl_rcutorture.c 0 16899 NULL
+n_ai_urbs_usbduxsigma_private_16912_fns n_ai_urbs usbduxsigma_private 0 16912 NULL
+sys_mbind_fndecl_16933_fns sys_mbind fndecl 5 16933 NULL
+vidioc_dqbuf_fndecl_16948_fns vidioc_dqbuf fndecl 0 16948 NULL
+admin_mtu_ipoib_dev_priv_16960_fns admin_mtu ipoib_dev_priv 0 16960 NULL
+vcs_read_fndecl_16962_fns vcs_read fndecl 3 16962 NULL
+num_tx_queues_ixgbe_adapter_16981_fns num_tx_queues ixgbe_adapter 0 16981 NULL
+tt3650_ci_msg_locked_fndecl_16990_fns tt3650_ci_msg_locked fndecl 4 16990 NULL
+offset_ipw_tx_packet_17004_fns offset ipw_tx_packet 0 17004 NULL
+__iommu_dma_alloc_pages_fndecl_17015_fns __iommu_dma_alloc_pages fndecl 1 17015 NULL
+reiserfs_sync_file_fndecl_17045_fns reiserfs_sync_file fndecl 2-3 17045 NULL
+qla4xxx_post_ping_evt_work_fndecl_17049_fns qla4xxx_post_ping_evt_work fndecl 4 17049 NULL
+spi_write_then_read_fndecl_17050_fns spi_write_then_read fndecl 5-3 17050 NULL
+command_setcompressiontarget_fndecl_17055_fns command_setcompressiontarget fndecl 0 17055 NULL
+venus_lookup_fndecl_17066_fns venus_lookup fndecl 4 17066 NULL
+packet_len_sdma_txreq_17082_fns packet_len sdma_txreq 0 17082 NULL
+tx_tx_stop_read_fndecl_17096_fns tx_tx_stop_read fndecl 3 17096 NULL
+cx18_queue_get_mdl_fndecl_17103_fns cx18_queue_get_mdl fndecl 3 17103 NULL
+dlm_user_request_fndecl_17104_fns dlm_user_request fndecl 6 17104 NULL
+minors_gendisk_17113_fns minors gendisk 0 17113 NULL
+in___kfifo_17131_fns in __kfifo 0 17131 NULL
+lnet_ipif_enumerate_fndecl_17135_fns lnet_ipif_enumerate fndecl 0 17135 NULL
+acpi_hw_validate_register_fndecl_17141_fns acpi_hw_validate_register fndecl 2 17141 NULL
+blockSize_ms_lib_ctrl_17144_fns blockSize ms_lib_ctrl 0 17144 NULL
+len_read_buffer_17166_fns len read_buffer 0 17166 NULL
+acpi_ex_allocate_name_string_fndecl_17174_fns acpi_ex_allocate_name_string fndecl 1-2 17174 NULL
+pci_raw_set_power_state_fndecl_17186_fns pci_raw_set_power_state fndecl 0 17186 NULL
+ath10k_write_peer_stats_fndecl_17195_fns ath10k_write_peer_stats fndecl 3 17195 NULL
+iwl_dbgfs_bt_cmd_read_fndecl_17225_fns iwl_dbgfs_bt_cmd_read fndecl 3 17225 NULL
+vxge_device_register_fndecl_17243_fns vxge_device_register fndecl 4 17243 NULL
+diva_os_copy_from_user_fndecl_17251_fns diva_os_copy_from_user fndecl 4 17251 NULL
+htc_proc_trailer_fndecl_17252_fns htc_proc_trailer fndecl 3 17252 NULL
+subpgsize_vardecl_subpagetest_c_17265_fns subpgsize vardecl_subpagetest.c 0 17265 NULL
+dfs_global_file_read_fndecl_17272_fns dfs_global_file_read fndecl 3 17272 NULL
+bnx2_nvram_write_fndecl_17277_fns bnx2_nvram_write fndecl 2-4 17277 NULL
+seq_buf_alloc_fndecl_17287_fns seq_buf_alloc fndecl 1 17287 NULL
+rtl8821ae_c2h_packet_handler_fndecl_17297_fns rtl8821ae_c2h_packet_handler fndecl 3 17297 NULL
+cfs_trace_dump_debug_buffer_usrstr_fndecl_17318_fns cfs_trace_dump_debug_buffer_usrstr fndecl 2 17318 NULL
+dvb_dmxdev_read_sec_fndecl_17351_fns dvb_dmxdev_read_sec fndecl 4 17351 NULL
+audio_buf_size_f_uac1_opts_17353_fns audio_buf_size f_uac1_opts 0 17353 NULL
+pebs_buffer_size_x86_pmu_17362_fns pebs_buffer_size x86_pmu 0 17362 NULL
+nilfs_sufile_mark_dirty_fndecl_17370_fns nilfs_sufile_mark_dirty fndecl 2 17370 NULL
+scatt_size_eata_info_17383_fns scatt_size eata_info 0 17383 NULL
+f_hidg_write_fndecl_17391_fns f_hidg_write fndecl 3 17391 NULL
+posix_acl_fix_xattr_userns_fndecl_17415_fns posix_acl_fix_xattr_userns fndecl 4 17415 NULL
+ufx_setup_modes_fndecl_17419_fns ufx_setup_modes fndecl 4 17419 NULL
+keys_jset_17429_fns keys jset 0 17429 NULL
+btrfs_cmp_data_prepare_fndecl_17436_fns btrfs_cmp_data_prepare fndecl 5 17436 NULL
+gsmld_receive_buf_fndecl_17440_fns gsmld_receive_buf fndecl 4 17440 NULL
+__alloc_bootmem_node_nopanic_fndecl_17459_fns __alloc_bootmem_node_nopanic fndecl 2 17459 NULL
+cipso_v4_map_lvl_hton_fndecl_17481_fns cipso_v4_map_lvl_hton fndecl 0 17481 NULL
+sddr09_write_inplace_fndecl_17484_fns sddr09_write_inplace fndecl 6 17484 NULL
+brcmf_fil_iovar_data_set_fndecl_17512_fns brcmf_fil_iovar_data_set fndecl 4 17512 NULL
+dvb_dmxdev_init_fndecl_17523_fns dvb_dmxdev_init fndecl 0 17523 NULL
+mei_read_fndecl_17528_fns mei_read fndecl 3 17528 NULL
+offset_icmp_bxm_17531_fns offset icmp_bxm 0 17531 NULL
+rndis_set_oid_fndecl_17536_fns rndis_set_oid fndecl 4 17536 NULL
+fb_alloc_cmap_fndecl_17545_fns fb_alloc_cmap fndecl 2 17545 NULL
+cdm_element_count_vardecl_17565_fns cdm_element_count vardecl 0 17565 NULL
+stack_size_ahd_softc_17574_fns stack_size ahd_softc 0 17574 NULL
+sita_init_fndecl_17588_fns sita_init fndecl 2-1 17588 NULL
+_iwl_dbgfs_indirection_tbl_write_fndecl_17597_fns _iwl_dbgfs_indirection_tbl_write fndecl 3 17597 NULL
+drbg_init_hash_kernel_fndecl_17617_fns drbg_init_hash_kernel fndecl 0 17617 NULL
+dvb_dmx_init_fndecl_17652_fns dvb_dmx_init fndecl 0 17652 NULL
+perf_callchain_entry__sizeof_fndecl_17653_fns perf_callchain_entry__sizeof fndecl 0 17653 NULL
+btrfs_dedupe_file_range_fndecl_17658_fns btrfs_dedupe_file_range fndecl 3 17658 NULL
+submit_queues_vardecl_scsi_debug_c_17671_fns submit_queues vardecl_scsi_debug.c 0 17671 NULL
+wl1251_cmd_template_set_fndecl_17679_fns wl1251_cmd_template_set fndecl 4 17679 NULL
+iwl_dbgfs_tof_range_request_read_fndecl_17682_fns iwl_dbgfs_tof_range_request_read fndecl 3 17682 NULL
+snd_efw_command_get_phys_meters_fndecl_17725_fns snd_efw_command_get_phys_meters fndecl 3 17725 NULL
+nilfs_cpfile_delete_checkpoint_fndecl_17728_fns nilfs_cpfile_delete_checkpoint fndecl 2 17728 NULL
+mqueue_read_file_fndecl_17735_fns mqueue_read_file fndecl 3 17735 NULL
+of_gpio_count_fndecl_17773_fns of_gpio_count fndecl 0 17773 NULL
+fbcon_prepare_logo_fndecl_17781_fns fbcon_prepare_logo fndecl 5 17781 NULL
+posix_acl_fix_xattr_to_user_fndecl_17816_fns posix_acl_fix_xattr_to_user fndecl 2 17816 NULL
+snd_hda_override_conn_list_fndecl_17817_fns snd_hda_override_conn_list fndecl 3 17817 NULL nohasharray
+xenbus_file_write_fndecl_17817_fns xenbus_file_write fndecl 3 17817 &snd_hda_override_conn_list_fndecl_17817_fns
+tx_tx_start_null_frame_read_fndecl_17818_fns tx_tx_start_null_frame_read fndecl 3 17818 NULL
+qlcnic_sriov_alloc_bc_msg_fndecl_17846_fns qlcnic_sriov_alloc_bc_msg fndecl 2 17846 NULL
+preferred_minor_md_rdev_17857_fns preferred_minor md_rdev 0 17857 NULL
+mei_dbgfs_read_devstate_fndecl_17859_fns mei_dbgfs_read_devstate fndecl 3 17859 NULL
+host_int_get_assoc_res_info_fndecl_17869_fns host_int_get_assoc_res_info fndecl 3 17869 NULL
+fuse_get_req_for_background_fndecl_17874_fns fuse_get_req_for_background fndecl 2 17874 NULL
+debugfs_attr_read_fndecl_17883_fns debugfs_attr_read fndecl 3 17883 NULL
+netdev_queue_add_kobject_fndecl_17908_fns netdev_queue_add_kobject fndecl 0 17908 NULL
+arch_gnttab_valloc_fndecl_17911_fns arch_gnttab_valloc fndecl 2 17911 NULL
+__kfifo_dma_in_finish_r_fndecl_17938_fns __kfifo_dma_in_finish_r fndecl 2-3 17938 NULL
+__vxge_hw_mempool_create_fndecl_17944_fns __vxge_hw_mempool_create fndecl 2 17944 NULL
+cache_do_downcall_fndecl_17949_fns cache_do_downcall fndecl 3 17949 NULL
+videobuf_dma_init_kernel_fndecl_17952_fns videobuf_dma_init_kernel fndecl 3 17952 NULL
+n_special_skd_device_17960_fns n_special skd_device 0 17960 NULL
+qsfp_cks_fndecl_17970_fns qsfp_cks fndecl 2-0 17970 NULL
+nilfs_set_last_segment_fndecl_17983_fns nilfs_set_last_segment fndecl 4 17983 NULL
+count_mlxsw_pci_queue_17987_fns count mlxsw_pci_queue 0 17987 NULL
+channels_tiadc_device_17992_fns channels tiadc_device 0 17992 NULL
+cipso_v4_gentag_enum_fndecl_17997_fns cipso_v4_gentag_enum fndecl 0 17997 NULL
+order_per_bit_cma_18000_fns order_per_bit cma 0 18000 NULL
+size_firmware_buf_18003_fns size firmware_buf 0 18003 NULL
+request_key_async_fndecl_18013_fns request_key_async fndecl 4 18013 NULL
+raid56_parity_recover_fndecl_18019_fns raid56_parity_recover fndecl 4 18019 NULL
+condc_tomoyo_condition_18025_fns condc tomoyo_condition 0 18025 NULL
+ceph_kvmalloc_fndecl_18026_fns ceph_kvmalloc fndecl 1 18026 NULL
+fip_dl_len_fip_header_18032_fns fip_dl_len fip_header 0 18032 NULL
+copy_items_fndecl_18039_fns copy_items fndecl 7 18039 NULL
+ld_usb_write_fndecl_18045_fns ld_usb_write fndecl 3 18045 NULL
+sll_halen_sockaddr_ll_18063_fns sll_halen sockaddr_ll 0 18063 NULL
+beacon_interval_read_fndecl_18080_fns beacon_interval_read fndecl 3 18080 NULL
+add_wpa_key_fndecl_18083_fns add_wpa_key fndecl 3 18083 NULL
+inode2sd_fndecl_18094_fns inode2sd fndecl 3 18094 NULL
+n_pages_tracing_map_array_18100_fns n_pages tracing_map_array 0 18100 NULL
+thermal_irq_thr_high_read_fndecl_18102_fns thermal_irq_thr_high_read fndecl 3 18102 NULL
+readcount_usblp_18112_fns readcount usblp 0 18112 NULL nohasharray
+do_async_mmap_readahead_fndecl_18112_fns do_async_mmap_readahead fndecl 5 18112 &readcount_usblp_18112_fns
+ring_prod_per_user_data_18125_fns ring_prod per_user_data 0 18125 NULL
+pipeline_enc_rx_stat_fifo_int_read_fndecl_18128_fns pipeline_enc_rx_stat_fifo_int_read fndecl 3 18128 NULL
+acpi_rs_get_resource_source_fndecl_18168_fns acpi_rs_get_resource_source fndecl 0 18168 NULL
+qlcnic_enable_msix_fndecl_18171_fns qlcnic_enable_msix fndecl 2 18171 NULL
+ibmpex_query_sensor_count_fndecl_18214_fns ibmpex_query_sensor_count fndecl 0 18214 NULL
+check_clk_sync_fndecl_18222_fns check_clk_sync fndecl 2 18222 NULL
+xen_xlate_map_ballooned_pages_fndecl_18227_fns xen_xlate_map_ballooned_pages fndecl 3 18227 NULL
+rx_buf_size_bnx2_18228_fns rx_buf_size bnx2 0 18228 NULL
+ps_pspoll_max_apturn_read_fndecl_18232_fns ps_pspoll_max_apturn_read fndecl 3 18232 NULL
+btrfs_lookup_csums_range_fndecl_18235_fns btrfs_lookup_csums_range fndecl 2-3 18235 NULL
+posix_acl_xattr_count_fndecl_18262_fns posix_acl_xattr_count fndecl 1-0 18262 NULL
+video_proc_write_fndecl_18263_fns video_proc_write fndecl 3 18263 NULL
+rds_rdma_pages_fndecl_18268_fns rds_rdma_pages fndecl 0 18268 NULL
+add_pfn_range_mapped_fndecl_18307_fns add_pfn_range_mapped fndecl 1 18307 NULL
+i2c_read_fndecl_18308_fns i2c_read fndecl 0-6 18308 NULL
+ieee80211_if_read_fndecl_18322_fns ieee80211_if_read fndecl 3 18322 NULL
+iwl_dbgfs_channels_read_fndecl_18323_fns iwl_dbgfs_channels_read fndecl 3 18323 NULL nohasharray
+rpipes_wahc_18323_fns rpipes wahc 0 18323 &iwl_dbgfs_channels_read_fndecl_18323_fns
+tx_tx_done_data_read_fndecl_18332_fns tx_tx_done_data_read fndecl 3 18332 NULL
+blk_alloc_flush_queue_fndecl_18340_fns blk_alloc_flush_queue fndecl 3 18340 NULL
+calc_pages_for_fndecl_18341_fns calc_pages_for fndecl 0-2-1 18341 NULL
+sg_split_fndecl_18342_fns sg_split fndecl 4 18342 NULL
+mon_bin_read_fndecl_18346_fns mon_bin_read fndecl 3 18346 NULL
+nsm_get_handle_fndecl_18347_fns nsm_get_handle fndecl 5 18347 NULL
+snd_cs4281_BA0_read_fndecl_18348_fns snd_cs4281_BA0_read fndecl 5 18348 NULL
+proc_sessionid_read_fndecl_18412_fns proc_sessionid_read fndecl 3 18412 NULL
+raw_seticmpfilter_fndecl_18427_fns raw_seticmpfilter fndecl 3 18427 NULL
+dlmfs_file_write_fndecl_18431_fns dlmfs_file_write fndecl 3 18431 NULL
+error_bar_retry_read_fndecl_18460_fns error_bar_retry_read fndecl 3 18460 NULL
+cpg_div6_register_fndecl_18462_fns cpg_div6_register fndecl 2 18462 NULL
+mddev_find_fndecl_18492_fns mddev_find fndecl 1 18492 NULL
+xfs_efd_init_fndecl_18500_fns xfs_efd_init fndecl 3 18500 NULL
+wil_pmc_read_fndecl_18503_fns wil_pmc_read fndecl 3 18503 NULL
+kernfs_fop_write_fndecl_18508_fns kernfs_fop_write fndecl 3 18508 NULL
+tty_write_fndecl_18533_fns tty_write fndecl 3 18533 NULL
+tomoyo_update_domain_fndecl_18537_fns tomoyo_update_domain fndecl 2 18537 NULL
+pci_enable_msix_exact_fndecl_18553_fns pci_enable_msix_exact fndecl 0 18553 NULL nohasharray
+kvm_hv_set_msr_pw_fndecl_18553_fns kvm_hv_set_msr_pw fndecl 3 18553 &pci_enable_msix_exact_fndecl_18553_fns
+cifs_security_flags_proc_write_fndecl_18559_fns cifs_security_flags_proc_write fndecl 3 18559 NULL
+__max_nr_grant_frames_fndecl_18578_fns __max_nr_grant_frames fndecl 0 18578 NULL
+spidev_message_fndecl_18589_fns spidev_message fndecl 3 18589 NULL
+le_readq_fndecl_18598_fns le_readq fndecl 0 18598 NULL
+_wil_cfg80211_merge_extra_ies_fndecl_18611_fns _wil_cfg80211_merge_extra_ies fndecl 2-4 18611 NULL
+fir16_create_fndecl_18645_fns fir16_create fndecl 3 18645 NULL
+SYSC_init_module_fndecl_18665_fns SYSC_init_module fndecl 2 18665 NULL
+ies_len_scan_attr_18673_fns ies_len scan_attr 0 18673 NULL
+used_chaoskey_18682_fns used chaoskey 0 18682 NULL
+vid_switchdev_obj_port_fdb_18697_fns vid switchdev_obj_port_fdb 0 18697 NULL
+ascot2e_i2c_debug_fndecl_18708_fns ascot2e_i2c_debug fndecl 5 18708 NULL
+iwl_dbgfs_status_read_fndecl_18720_fns iwl_dbgfs_status_read fndecl 3 18720 NULL
+__az6007_write_fndecl_18721_fns __az6007_write fndecl 6 18721 NULL
+acpi_pcc_get_sqty_fndecl_18731_fns acpi_pcc_get_sqty fndecl 0 18731 NULL
+pipe_set_size_fndecl_18759_fns pipe_set_size fndecl 2 18759 NULL
+ppp_cp_parse_cr_fndecl_18765_fns ppp_cp_parse_cr fndecl 4 18765 NULL
+dwc2_hcd_urb_alloc_fndecl_18802_fns dwc2_hcd_urb_alloc fndecl 2 18802 NULL
+rd_length_gfs2_rgrpd_18804_fns rd_length gfs2_rgrpd 0 18804 NULL
+ath6kl_debug_roam_tbl_event_fndecl_18811_fns ath6kl_debug_roam_tbl_event fndecl 3 18811 NULL
+gfn_to_hva_memslot_fndecl_18818_fns gfn_to_hva_memslot fndecl 2 18818 NULL
+dvb_ringbuffer_write_user_fndecl_18821_fns dvb_ringbuffer_write_user fndecl 3 18821 NULL
+DriverQueueDepth_DAC960_Controller_18839_fns DriverQueueDepth DAC960_Controller 0 18839 NULL
+private_data_len_ib_cm_req_param_18848_fns private_data_len ib_cm_req_param 0 18848 NULL
+length_acpi_resource_18863_fns length acpi_resource 0 18863 NULL
+uinput_ioctl_fndecl_18893_fns uinput_ioctl fndecl 2 18893 NULL
+sbc_get_write_same_sectors_fndecl_18902_fns sbc_get_write_same_sectors fndecl 0 18902 NULL
+pwr_elp_enter_read_fndecl_18911_fns pwr_elp_enter_read fndecl 3 18911 NULL
+ps_pspoll_utilization_read_fndecl_18914_fns ps_pspoll_utilization_read fndecl 3 18914 NULL
+kvm_pin_pages_fndecl_18922_fns kvm_pin_pages fndecl 2 18922 NULL
+cciss_allocate_sg_chain_blocks_fndecl_18923_fns cciss_allocate_sg_chain_blocks fndecl 3 18923 NULL
+spidev_get_ioc_message_fndecl_18931_fns spidev_get_ioc_message fndecl 1 18931 NULL
+i2c_hack_cx25840_fndecl_18948_fns i2c_hack_cx25840 fndecl 4-6 18948 NULL nohasharray
+uhci_debug_read_fndecl_18948_fns uhci_debug_read fndecl 3 18948 &i2c_hack_cx25840_fndecl_18948_fns
+mlx4_en_create_tx_ring_fndecl_18977_fns mlx4_en_create_tx_ring fndecl 3 18977 NULL
+edac_device_alloc_ctl_info_fndecl_18982_fns edac_device_alloc_ctl_info fndecl 1 18982 NULL
+p9_get_mapped_pages_fndecl_18988_fns p9_get_mapped_pages fndecl 4 18988 NULL nohasharray
+ebcnt_vardecl_subpagetest_c_18988_fns ebcnt vardecl_subpagetest.c 0 18988 &p9_get_mapped_pages_fndecl_18988_fns
+lbs_highsnr_read_fndecl_19000_fns lbs_highsnr_read fndecl 3 19000 NULL
+tipc_subseq_alloc_fndecl_19030_fns tipc_subseq_alloc fndecl 1 19030 NULL
+ll_statahead_one_fndecl_19033_fns ll_statahead_one fndecl 3 19033 NULL
+mei_cl_read_start_fndecl_19077_fns mei_cl_read_start fndecl 2 19077 NULL
+btrfs_qgroup_inherit_fndecl_19103_fns btrfs_qgroup_inherit fndecl 4 19103 NULL
+sctp_setsockopt_connectx_fndecl_19114_fns sctp_setsockopt_connectx fndecl 3 19114 NULL
+alloc_msg_fndecl_19115_fns alloc_msg fndecl 1 19115 NULL
+rx_keycache_size_p54_common_19128_fns rx_keycache_size p54_common 0 19128 NULL
+start_vivitar_cam_fndecl_19144_fns start_vivitar_cam fndecl 0 19144 NULL
+ipmi_addr_length_fndecl_19149_fns ipmi_addr_length fndecl 0 19149 NULL
+alloc_indirect_fndecl_19156_fns alloc_indirect fndecl 2 19156 NULL
+len_ntb_queue_entry_19166_fns len ntb_queue_entry 0 19166 NULL nohasharray
+ms_nvme_ns_19166_fns ms nvme_ns 0 19166 &len_ntb_queue_entry_19166_fns
+max_pages_per_mr_srp_device_19171_fns max_pages_per_mr srp_device 0 19171 NULL
+lprocfs_alloc_stats_fndecl_19181_fns lprocfs_alloc_stats fndecl 1 19181 NULL
+dfs_global_file_write_fndecl_19187_fns dfs_global_file_write fndecl 3 19187 NULL
+ext4_xattr_get_fndecl_19214_fns ext4_xattr_get fndecl 0 19214 NULL
+SYSC_fsetxattr_fndecl_19220_fns SYSC_fsetxattr fndecl 4 19220 NULL
+cmds_vardecl_ambassador_c_19230_fns cmds vardecl_ambassador.c 0 19230 NULL
+get_arg_fndecl_19245_fns get_arg fndecl 3 19245 NULL
+sb_segnum_nilfs_segment_buffer_19276_fns sb_segnum nilfs_segment_buffer 0 19276 NULL
+subbuf_read_actor_fndecl_19295_fns subbuf_read_actor fndecl 3 19295 NULL
+security_kernel_post_read_file_fndecl_19301_fns security_kernel_post_read_file fndecl 3 19301 NULL
+sys_sched_getattr_fndecl_19313_fns sys_sched_getattr fndecl 3 19313 NULL
+__vxge_hw_blockpool_malloc_fndecl_19337_fns __vxge_hw_blockpool_malloc fndecl 2 19337 NULL
+data_sge_offset_mpt3_ioctl_command_19355_fns data_sge_offset mpt3_ioctl_command 0 19355 NULL
+sctp_setsockopt_autoclose_fndecl_19356_fns sctp_setsockopt_autoclose fndecl 3 19356 NULL nohasharray
+qlcnic_83xx_sysfs_flash_read_handler_fndecl_19356_fns qlcnic_83xx_sysfs_flash_read_handler fndecl 6 19356 &sctp_setsockopt_autoclose_fndecl_19356_fns
+nvme_trans_bdev_char_page_fndecl_19382_fns nvme_trans_bdev_char_page fndecl 3 19382 NULL
+ControllerQueueDepth_DAC960_Controller_19386_fns ControllerQueueDepth DAC960_Controller 0 19386 NULL
+rx_filter_max_arp_queue_dep_read_fndecl_19400_fns rx_filter_max_arp_queue_dep_read fndecl 3 19400 NULL
+setup_req_fndecl_19403_fns setup_req fndecl 3 19403 NULL
+_iwl_dbgfs_cont_recording_write_fndecl_19421_fns _iwl_dbgfs_cont_recording_write fndecl 3 19421 NULL
+sn9c2028_long_command_fndecl_19445_fns sn9c2028_long_command fndecl 0 19445 NULL
+compat_sys_move_pages_fndecl_19446_fns compat_sys_move_pages fndecl 2 19446 NULL
+sys_setdomainname_fndecl_19462_fns sys_setdomainname fndecl 2 19462 NULL
+reg_read_fndecl_19498_fns reg_read fndecl 0 19498 NULL
+access_process_vm_fndecl_19503_fns access_process_vm fndecl 0 19503 NULL nohasharray
+cxacru_cm_get_array_fndecl_19503_fns cxacru_cm_get_array fndecl 4 19503 &access_process_vm_fndecl_19503_fns
+ecryptfs_write_tag_70_packet_fndecl_19510_fns ecryptfs_write_tag_70_packet fndecl 6 19510 NULL
+do_pages_stat_fndecl_19526_fns do_pages_stat fndecl 2 19526 NULL
+netdev_register_kobject_fndecl_19535_fns netdev_register_kobject fndecl 0 19535 NULL nohasharray
+d40_sg_2_dmalen_fndecl_19535_fns d40_sg_2_dmalen fndecl 3-4-0 19535 &netdev_register_kobject_fndecl_19535_fns
+rtw_android_get_rssi_fndecl_19542_fns rtw_android_get_rssi fndecl 0 19542 NULL
+response_length_mlx5_ib_query_device_resp_19546_fns response_length mlx5_ib_query_device_resp 0 19546 NULL
+at76_set_card_command_fndecl_19556_fns at76_set_card_command fndecl 4 19556 NULL
+buf_size_pxa3xx_nand_info_19573_fns buf_size pxa3xx_nand_info 0 19573 NULL
+snd_seq_expand_var_event_fndecl_19602_fns snd_seq_expand_var_event fndecl 0 19602 NULL
+vmbus_establish_gpadl_fndecl_19612_fns vmbus_establish_gpadl fndecl 3 19612 NULL
+__gfn_to_pfn_memslot_fndecl_19617_fns __gfn_to_pfn_memslot fndecl 2 19617 NULL
+sys_llistxattr_fndecl_19623_fns sys_llistxattr fndecl 3 19623 NULL
+get_rq_pas_size_fndecl_19651_fns get_rq_pas_size fndecl 0 19651 NULL
+thermal_false_irq_read_fndecl_19654_fns thermal_false_irq_read fndecl 3 19654 NULL
+btrfs_file_extent_inline_item_len_fndecl_19660_fns btrfs_file_extent_inline_item_len fndecl 0 19660 NULL
+fsl_edma_prep_slave_sg_fndecl_19672_fns fsl_edma_prep_slave_sg fndecl 3 19672 NULL
+bch_alloc_fndecl_19682_fns bch_alloc fndecl 1 19682 NULL
+ath10k_dbg_sta_write_delba_fndecl_19689_fns ath10k_dbg_sta_write_delba fndecl 3 19689 NULL
+st_fixed_buffer_size_vardecl_st_c_19699_fns st_fixed_buffer_size vardecl_st.c 0 19699 NULL
+xfs_buf_get_maps_fndecl_19702_fns xfs_buf_get_maps fndecl 2 19702 NULL
+acpi_read_fast_fndecl_19709_fns acpi_read_fast fndecl 3-2 19709 NULL
+msc_win_to_user_fndecl_19728_fns msc_win_to_user fndecl 3 19728 NULL
+mps_trc_write_fndecl_19736_fns mps_trc_write fndecl 3 19736 NULL
+max_active_conns_bnx2i_hba_19740_fns max_active_conns bnx2i_hba 0 19740 NULL
+bytesperline_v4l2_pix_format_19741_fns bytesperline v4l2_pix_format 0 19741 NULL
+mpt_raid_phys_disk_get_num_paths_fndecl_19752_fns mpt_raid_phys_disk_get_num_paths fndecl 0 19752 NULL
+pvscsi_get_max_targets_fndecl_19802_fns pvscsi_get_max_targets fndecl 0 19802 NULL
+size_vring_19817_fns size vring 0 19817 NULL
+ip_send_unicast_reply_fndecl_19820_fns ip_send_unicast_reply fndecl 7 19820 NULL
+__nfs4_get_acl_uncached_fndecl_19830_fns __nfs4_get_acl_uncached fndecl 3 19830 NULL
+rpos_cm4000_dev_19844_fns rpos cm4000_dev 0 19844 NULL
+ath6kl_force_roam_write_fndecl_19881_fns ath6kl_force_roam_write fndecl 3 19881 NULL
+goldfish_audio_write_fndecl_19887_fns goldfish_audio_write fndecl 3 19887 NULL
+count_strings_fndecl_19912_fns count_strings fndecl 0 19912 NULL
+get_connectors_for_crtc_fndecl_19920_fns get_connectors_for_crtc fndecl 0 19920 NULL
+brcmu_dbg_hex_dump_fndecl_19925_fns brcmu_dbg_hex_dump fndecl 2 19925 NULL
+__usbnet_read_cmd_fndecl_19928_fns __usbnet_read_cmd fndecl 7 19928 NULL
+dvb_ringbuffer_pkt_read_user_fndecl_19932_fns dvb_ringbuffer_pkt_read_user fndecl 3-2-5 19932 NULL
+ima_eventdigest_init_common_fndecl_19937_fns ima_eventdigest_init_common fndecl 2 19937 NULL
+max_buckets_crush_map_19942_fns max_buckets crush_map 0 19942 NULL
+check_crc_fndecl_19956_fns check_crc fndecl 2 19956 NULL
+snd_rawmidi_kernel_read_fndecl_19963_fns snd_rawmidi_kernel_read fndecl 3 19963 NULL
+iwl_dbgfs_ctdp_budget_read_fndecl_19964_fns iwl_dbgfs_ctdp_budget_read fndecl 3 19964 NULL
+vga_arb_read_fndecl_19973_fns vga_arb_read fndecl 3 19973 NULL
+paravirt_read_msr_fndecl_19974_fns paravirt_read_msr fndecl 0 19974 NULL
+le_max_key_size_read_fndecl_19975_fns le_max_key_size_read fndecl 3 19975 NULL
+f2fs_insert_range_fndecl_19990_fns f2fs_insert_range fndecl 2-3 19990 NULL
+hid_register_field_fndecl_19993_fns hid_register_field fndecl 2-3 19993 NULL
+of_get_nand_ecc_step_size_fndecl_20001_fns of_get_nand_ecc_step_size fndecl 0 20001 NULL
+tx_nr_rings_per_tc_bnxt_20008_fns tx_nr_rings_per_tc bnxt 0 20008 NULL
+ocrdma_alloc_lkey_fndecl_20045_fns ocrdma_alloc_lkey fndecl 5 20045 NULL
+prctl_set_auxv_fndecl_20068_fns prctl_set_auxv fndecl 3 20068 NULL
+fb_deferred_io_fsync_fndecl_20083_fns fb_deferred_io_fsync fndecl 2-3 20083 NULL
+compat_rawv6_setsockopt_fndecl_20084_fns compat_rawv6_setsockopt fndecl 5 20084 NULL
+ath10k_read_chip_id_fndecl_20090_fns ath10k_read_chip_id fndecl 3 20090 NULL
+do_mincore_fndecl_20105_fns do_mincore fndecl 0-1-2 20105 NULL
+snd_mixart_BA1_read_fndecl_20169_fns snd_mixart_BA1_read fndecl 5 20169 NULL
+__kmalloc_track_caller_fndecl_20188_fns __kmalloc_track_caller fndecl 1 20188 NULL
+num_counters_vardecl_oprofile_perf_c_20189_fns num_counters vardecl_oprofile_perf.c 0 20189 NULL
+qp_attach_mbox_size_fndecl_20191_fns qp_attach_mbox_size fndecl 0 20191 NULL
+max_frame_size__mgslpc_info_20204_fns max_frame_size _mgslpc_info 0 20204 NULL
+sbq_len_rx_ring_20205_fns sbq_len rx_ring 0 20205 NULL
+i40e_dbg_netdev_ops_write_fndecl_20206_fns i40e_dbg_netdev_ops_write fndecl 3 20206 NULL
+kfifo_copy_from_user_fndecl_20208_fns kfifo_copy_from_user fndecl 0-4-3 20208 NULL
+sound_write_fndecl_20221_fns sound_write fndecl 3 20221 NULL
+use_sg_osst_buffer_20225_fns use_sg osst_buffer 0 20225 NULL
+iwl_dbgfs_tx_queue_read_fndecl_20232_fns iwl_dbgfs_tx_queue_read fndecl 3 20232 NULL
+ll_rw_extents_stats_seq_write_fndecl_20234_fns ll_rw_extents_stats_seq_write fndecl 3 20234 NULL
+rx_agg_bmap_size_bnxt_rx_ring_info_20244_fns rx_agg_bmap_size bnxt_rx_ring_info 0 20244 NULL
+arm_setup_iommu_dma_ops_fndecl_20272_fns arm_setup_iommu_dma_ops fndecl 3 20272 NULL
+kone_receive_fndecl_20289_fns kone_receive fndecl 4 20289 NULL
+register_queue_kobjects_fndecl_20291_fns register_queue_kobjects fndecl 0 20291 NULL
+round_pipe_size_fndecl_20302_fns round_pipe_size fndecl 0 20302 NULL
+cx18_read_pos_fndecl_20312_fns cx18_read_pos fndecl 3 20312 NULL
+wilc_spi_rx_fndecl_20314_fns wilc_spi_rx fndecl 3 20314 NULL
+short_retry_limit_read_fndecl_20316_fns short_retry_limit_read fndecl 3 20316 NULL
+ati_create_gatt_pages_fndecl_20321_fns ati_create_gatt_pages fndecl 1 20321 NULL
+i_ecryptfs_parse_tag_70_packet_silly_stack_20325_fns i ecryptfs_parse_tag_70_packet_silly_stack 0 20325 NULL
+cxgbi_alloc_big_mem_fndecl_20336_fns cxgbi_alloc_big_mem fndecl 1 20336 NULL
+ll_rw_offset_stats_seq_write_fndecl_20371_fns ll_rw_offset_stats_seq_write fndecl 3 20371 NULL
+drm_fb_helper_sys_read_fndecl_20376_fns drm_fb_helper_sys_read fndecl 3 20376 NULL
+periodic_size_fotg210_hcd_20395_fns periodic_size fotg210_hcd 0 20395 NULL
+pwr_rcvd_bcns_cnt_read_fndecl_20405_fns pwr_rcvd_bcns_cnt_read fndecl 3 20405 NULL
+diversity_total_num_of_toggles_read_fndecl_20407_fns diversity_total_num_of_toggles_read fndecl 3 20407 NULL
+ncp__vol2io_fndecl_20439_fns ncp__vol2io fndecl 5 20439 NULL
+error_elp_while_rx_exch_read_fndecl_20460_fns error_elp_while_rx_exch_read fndecl 3 20460 NULL
+key_tx_spec_read_fndecl_20461_fns key_tx_spec_read fndecl 3 20461 NULL
+gsm_control_rls_fndecl_20490_fns gsm_control_rls fndecl 3 20490 NULL
+pageshift_sddr09_card_info_20494_fns pageshift sddr09_card_info 0 20494 NULL
+nrbchan_mISDNdevice_20497_fns nrbchan mISDNdevice 0 20497 NULL
+sysfs_create_group_fndecl_20504_fns sysfs_create_group fndecl 0 20504 NULL
+read_from_oldmem_fndecl_20506_fns read_from_oldmem fndecl 2 20506 NULL
+data_len_icmp_bxm_20511_fns data_len icmp_bxm 0 20511 NULL
+x86_emulate_instruction_fndecl_20526_fns x86_emulate_instruction fndecl 2 20526 NULL
+mlx5_core_req_pages_handler_fndecl_20540_fns mlx5_core_req_pages_handler fndecl 3 20540 NULL
+input_estimate_events_per_packet_fndecl_20548_fns input_estimate_events_per_packet fndecl 0 20548 NULL
+wacom_calc_hid_res_fndecl_20558_fns wacom_calc_hid_res fndecl 1 20558 NULL
+isdn_readbchan_fndecl_20570_fns isdn_readbchan fndecl 5-0 20570 NULL
+nullb_indexes_vardecl_null_blk_c_20571_fns nullb_indexes vardecl_null_blk.c 0 20571 NULL
+nfp_net_shadow_tx_rings_prepare_fndecl_20574_fns nfp_net_shadow_tx_rings_prepare fndecl 2 20574 NULL
+pci_add_cap_save_buffer_fndecl_20593_fns pci_add_cap_save_buffer fndecl 3 20593 NULL
+nilfs_cpfile_set_snapshot_fndecl_20616_fns nilfs_cpfile_set_snapshot fndecl 2 20616 NULL
+snd_pcm_lib_readv_transfer_fndecl_20635_fns snd_pcm_lib_readv_transfer fndecl 5 20635 NULL
+cursor_size_fbcon_ops_20640_fns cursor_size fbcon_ops 0 20640 NULL
+bcm2835_dma_create_cb_chain_fndecl_20648_fns bcm2835_dma_create_cb_chain fndecl 6 20648 NULL
+security_context_to_sid_default_fndecl_20663_fns security_context_to_sid_default fndecl 2 20663 NULL
+kvm_handle_bad_page_fndecl_20668_fns kvm_handle_bad_page fndecl 2 20668 NULL
+btrfs_dir_name_len_fndecl_20686_fns btrfs_dir_name_len fndecl 0 20686 NULL
+nsio_rw_bytes_fndecl_20690_fns nsio_rw_bytes fndecl 4 20690 NULL
+evtchn_read_fndecl_20706_fns evtchn_read fndecl 3 20706 NULL
+len_asymmetric_key_id_20717_fns len asymmetric_key_id 0 20717 NULL
+alloc_smp_resp_fndecl_20733_fns alloc_smp_resp fndecl 1 20733 NULL
+stv0680_set_video_mode_fndecl_20735_fns stv0680_set_video_mode fndecl 0 20735 NULL
+msgbuflen_blogic_adapter_20746_fns msgbuflen blogic_adapter 0 20746 NULL
+rb_alloc_fndecl_20749_fns rb_alloc fndecl 1 20749 NULL
+ttusb2_msg_fndecl_20751_fns ttusb2_msg fndecl 4 20751 NULL
+read_file_antenna_diversity_fndecl_20758_fns read_file_antenna_diversity fndecl 3 20758 NULL
+simple_write_to_buffer_fndecl_20769_fns simple_write_to_buffer fndecl 2-5 20769 NULL
+compat_sys_migrate_pages_fndecl_20806_fns compat_sys_migrate_pages fndecl 2 20806 NULL
+filldir_fndecl_20820_fns filldir fndecl 3 20820 NULL
+fill_write_buffer_fndecl_20821_fns fill_write_buffer fndecl 3 20821 NULL
+aux_size_dm_bufio_client_20827_fns aux_size dm_bufio_client 0 20827 NULL
+mempool_create_node_fndecl_20836_fns mempool_create_node fndecl 1 20836 NULL
+alloc_context_fndecl_20841_fns alloc_context fndecl 1 20841 NULL
+shmem_pread_slow_fndecl_20845_fns shmem_pread_slow fndecl 2-3 20845 NULL nohasharray
+udp_sendpage_fndecl_20845_fns udp_sendpage fndecl 3 20845 &shmem_pread_slow_fndecl_20845_fns
+acpi_copy_property_array_u64_fndecl_20846_fns acpi_copy_property_array_u64 fndecl 0 20846 NULL
+uinput_ioctl_handler_fndecl_20862_fns uinput_ioctl_handler fndecl 2 20862 NULL
+codec_reg_write_file_fndecl_20887_fns codec_reg_write_file fndecl 3 20887 NULL
+aggr_size_tx_agg_len_read_fndecl_20910_fns aggr_size_tx_agg_len_read fndecl 3 20910 NULL
+btrfs_next_leaf_fndecl_20915_fns btrfs_next_leaf fndecl 0 20915 NULL
+key_key_read_fndecl_20922_fns key_key_read fndecl 3 20922 NULL
+_iwl_dbgfs_d3_sram_write_fndecl_20960_fns _iwl_dbgfs_d3_sram_write fndecl 3 20960 NULL
+dbDiscardAG_fndecl_20969_fns dbDiscardAG fndecl 3 20969 NULL
+count_cma_20973_fns count cma 0 20973 NULL nohasharray
+compat_sys_setsockopt_fndecl_20973_fns compat_sys_setsockopt fndecl 5 20973 &count_cma_20973_fns
+spidev_compat_ioc_message_fndecl_20986_fns spidev_compat_ioc_message fndecl 2 20986 NULL
+get_fd_set_fndecl_21001_fns get_fd_set fndecl 1 21001 NULL
+nouveau_debugfs_pstate_set_fndecl_21004_fns nouveau_debugfs_pstate_set fndecl 3 21004 NULL
+br_fdb_insert_fndecl_21006_fns br_fdb_insert fndecl 4 21006 NULL
+sst_hsw_module_set_param_fndecl_21007_fns sst_hsw_module_set_param fndecl 5 21007 NULL
+nvram_write_fndecl_21029_fns nvram_write fndecl 3 21029 NULL
+efivarfs_file_read_fndecl_21030_fns efivarfs_file_read fndecl 3 21030 NULL
+comedi_buf_read_n_available_fndecl_21032_fns comedi_buf_read_n_available fndecl 0 21032 NULL
+pipeline_pre_proc_swi_read_fndecl_21033_fns pipeline_pre_proc_swi_read fndecl 3 21033 NULL
+garp_attr_create_fndecl_21048_fns garp_attr_create fndecl 3 21048 NULL
+memcpy_to_pmem_fndecl_21058_fns memcpy_to_pmem fndecl 3 21058 NULL
+chaoskey_rng_read_fndecl_21064_fns chaoskey_rng_read fndecl 3 21064 NULL
+vcs_write_fndecl_21077_fns vcs_write fndecl 3 21077 NULL
+rb_alloc_aux_fndecl_21108_fns rb_alloc_aux fndecl 4 21108 NULL
+hdrlen_ipv6_opt_hdr_21121_fns hdrlen ipv6_opt_hdr 0 21121 NULL
+size_ndis_80211_key_21124_fns size ndis_80211_key 0 21124 NULL
+metadata_dst_alloc_fndecl_21136_fns metadata_dst_alloc fndecl 1 21136 NULL
+hsu_dma_prep_slave_sg_fndecl_21155_fns hsu_dma_prep_slave_sg fndecl 3 21155 NULL
+mei_write_fndecl_21174_fns mei_write fndecl 3 21174 NULL nohasharray
+xfs_check_block_fndecl_21174_fns xfs_check_block fndecl 4 21174 &mei_write_fndecl_21174_fns
+snd_hdsp_capture_copy_fndecl_21176_fns snd_hdsp_capture_copy fndecl 5 21176 NULL
+n_ir_fw_ohci_21205_fns n_ir fw_ohci 0 21205 NULL
+mtip_hw_read_registers_fndecl_21206_fns mtip_hw_read_registers fndecl 3 21206 NULL
+crypto_ecdh_shared_secret_fndecl_21212_fns crypto_ecdh_shared_secret fndecl 2 21212 NULL
+nilfs_cpfile_change_cpmode_fndecl_21246_fns nilfs_cpfile_change_cpmode fndecl 2 21246 NULL
+sctp_getsockopt_events_fndecl_21252_fns sctp_getsockopt_events fndecl 2 21252 NULL
+edac_mc_alloc_fndecl_21256_fns edac_mc_alloc fndecl 4 21256 NULL
+object_name_len_compat_ncp_objectname_ioctl_21274_fns object_name_len compat_ncp_objectname_ioctl 0 21274 NULL
+fm10k_alloc_q_vector_fndecl_21285_fns fm10k_alloc_q_vector fndecl 4-6 21285 NULL
+tx_tx_starts_read_fndecl_21298_fns tx_tx_starts_read fndecl 3 21298 NULL
+aligned_kmalloc_fndecl_21311_fns aligned_kmalloc fndecl 1 21311 NULL
+_iwl_dbgfs_tx_flush_write_fndecl_21320_fns _iwl_dbgfs_tx_flush_write fndecl 3 21320 NULL
+sq_len_queue_set_21321_fns sq_len queue_set 0 21321 NULL
+temp_count_applesmc_registers_21387_fns temp_count applesmc_registers 0 21387 NULL
+ci_ll_write_fndecl_21391_fns ci_ll_write fndecl 4 21391 NULL
+digest_size_dm_verity_21399_fns digest_size dm_verity 0 21399 NULL
+v4l2_fh_open_fndecl_21406_fns v4l2_fh_open fndecl 0 21406 NULL
+length_r3964_block_header_21407_fns length r3964_block_header 0 21407 NULL
+mesh_id_len_ieee80211_if_mesh_21412_fns mesh_id_len ieee80211_if_mesh 0 21412 NULL
+fwnode_property_read_u32_array_fndecl_21467_fns fwnode_property_read_u32_array fndecl 0 21467 NULL
+intel_sdvo_set_value_fndecl_21524_fns intel_sdvo_set_value fndecl 4 21524 NULL
+kvm_clear_guest_page_fndecl_21527_fns kvm_clear_guest_page fndecl 4-2 21527 NULL
+alloc_btrfs_bio_fndecl_21533_fns alloc_btrfs_bio fndecl 2-1 21533 NULL nohasharray
+picolcd_fb_write_fndecl_21533_fns picolcd_fb_write fndecl 3 21533 &alloc_btrfs_bio_fndecl_21533_fns
+viafb_iga2_odev_proc_write_fndecl_21544_fns viafb_iga2_odev_proc_write fndecl 3 21544 NULL
+__erst_read_to_erange_fndecl_21558_fns __erst_read_to_erange fndecl 0 21558 NULL
+le_min_key_size_write_fndecl_21573_fns le_min_key_size_write fndecl 3 21573 NULL
+il_dbgfs_sensitivity_read_fndecl_21585_fns il_dbgfs_sensitivity_read fndecl 3 21585 NULL
+xfs_buf_map_from_irec_fndecl_21587_fns xfs_buf_map_from_irec fndecl 5 21587 NULL
+isdn_v110_open_fndecl_21601_fns isdn_v110_open fndecl 3 21601 NULL
+rxpipe_rx_prep_beacon_drop_read_fndecl_21616_fns rxpipe_rx_prep_beacon_drop_read fndecl 3 21616 NULL
+num_fdsb_msix_i40e_pf_21645_fns num_fdsb_msix i40e_pf 0 21645 NULL
+affs_file_fsync_fndecl_21669_fns affs_file_fsync fndecl 2-3 21669 NULL
+bio_alloc_bioset_fndecl_21671_fns bio_alloc_bioset fndecl 2 21671 NULL nohasharray
+lwtunnel_state_alloc_fndecl_21671_fns lwtunnel_state_alloc fndecl 1 21671 &bio_alloc_bioset_fndecl_21671_fns
+b43legacy_debugfs_read_fndecl_21690_fns b43legacy_debugfs_read fndecl 3 21690 NULL
+bsg_job_size_request_queue_21696_fns bsg_job_size request_queue 0 21696 NULL
+batadv_tvlv_container_list_size_fndecl_21711_fns batadv_tvlv_container_list_size fndecl 0 21711 NULL
+squashfs_read_fragment_index_table_fndecl_21721_fns squashfs_read_fragment_index_table fndecl 4 21721 NULL
+ath6kl_fwlog_mask_read_fndecl_21777_fns ath6kl_fwlog_mask_read fndecl 3 21777 NULL
+iwl_dbgfs_log_event_read_fndecl_21800_fns iwl_dbgfs_log_event_read fndecl 3 21800 NULL
+__set_print_fmt_fndecl_21801_fns __set_print_fmt fndecl 0 21801 NULL
+__svc_create_fndecl_21804_fns __svc_create fndecl 3 21804 NULL
+nfs4_copy_file_range_fndecl_21835_fns nfs4_copy_file_range fndecl 2-5 21835 NULL
+check_load_and_stores_fndecl_21836_fns check_load_and_stores fndecl 2 21836 NULL
+enable_read_fndecl_21846_fns enable_read fndecl 3 21846 NULL
+btrfs_file_extent_inline_len_fndecl_21847_fns btrfs_file_extent_inline_len fndecl 0 21847 NULL
+_ore_get_io_state_fndecl_21861_fns _ore_get_io_state fndecl 3-4-5 21861 NULL
+mlx4_init_icm_table_fndecl_21876_fns mlx4_init_icm_table fndecl 4-5 21876 NULL
+picolcd_debug_reset_write_fndecl_21888_fns picolcd_debug_reset_write fndecl 3 21888 NULL
+bio_integrity_alloc_fndecl_21889_fns bio_integrity_alloc fndecl 3 21889 NULL
+ceph_osdc_new_request_fndecl_21921_fns ceph_osdc_new_request fndecl 7 21921 NULL
+wilc_network_info_received_fndecl_21936_fns wilc_network_info_received fndecl 3 21936 NULL
+u32_array_read_fndecl_21944_fns u32_array_read fndecl 3 21944 NULL nohasharray
+mei_dbgfs_read_meclients_fndecl_21944_fns mei_dbgfs_read_meclients fndecl 3 21944 &u32_array_read_fndecl_21944_fns
+do_update_counters_fndecl_21952_fns do_update_counters fndecl 4 21952 NULL
+mlx4_buddy_init_fndecl_21975_fns mlx4_buddy_init fndecl 2 21975 NULL
+ieee80211_if_read_dot11MeshHWMPRannInterval_fndecl_21978_fns ieee80211_if_read_dot11MeshHWMPRannInterval fndecl 3 21978 NULL
+_scif_send_fndecl_21987_fns _scif_send fndecl 3-0 21987 NULL
+vpdma_alloc_desc_buf_fndecl_22005_fns vpdma_alloc_desc_buf fndecl 2 22005 NULL
+rtl8723be_c2h_packet_handler_fndecl_22040_fns rtl8723be_c2h_packet_handler fndecl 3 22040 NULL
+roccat_connect_fndecl_22044_fns roccat_connect fndecl 3 22044 NULL
+sel_read_enforce_fndecl_22047_fns sel_read_enforce fndecl 3 22047 NULL
+irnet_ctrl_read_fndecl_22076_fns irnet_ctrl_read fndecl 4 22076 NULL
+sfq_alloc_fndecl_22078_fns sfq_alloc fndecl 1 22078 NULL
+cmm_write_fndecl_22083_fns cmm_write fndecl 3 22083 NULL
+mgt_response_to_str_fndecl_22094_fns mgt_response_to_str fndecl 0 22094 NULL
+len_setup_data_node_22096_fns len setup_data_node 0 22096 NULL nohasharray
+ath10k_read_peer_stats_fndecl_22096_fns ath10k_read_peer_stats fndecl 3 22096 &len_setup_data_node_22096_fns
+xferlen_uioc_22131_fns xferlen uioc 0 22131 NULL
+xfs_trans_get_buf_map_fndecl_22140_fns xfs_trans_get_buf_map fndecl 4 22140 NULL
+nes_read_indexed_fndecl_22161_fns nes_read_indexed fndecl 0 22161 NULL
+buf_len_bu_info_22182_fns buf_len bu_info 0 22182 NULL nohasharray
+bnx2x_mcast_handle_pending_cmds_e1_fndecl_22182_fns bnx2x_mcast_handle_pending_cmds_e1 fndecl 0 22182 &buf_len_bu_info_22182_fns
+acpi_aml_read_fndecl_22207_fns acpi_aml_read fndecl 3 22207 NULL
+xfrm_dst_alloc_copy_fndecl_22217_fns xfrm_dst_alloc_copy fndecl 3 22217 NULL
+get_max_acpi_id_fndecl_22220_fns get_max_acpi_id fndecl 0 22220 NULL
+lpfc_idiag_mbxacc_write_fndecl_22221_fns lpfc_idiag_mbxacc_write fndecl 3 22221 NULL
+thermal_adc_source_unexpected_read_fndecl_22235_fns thermal_adc_source_unexpected_read fndecl 3 22235 NULL
+depth_write_fndecl_22238_fns depth_write fndecl 3 22238 NULL
+dac960_user_command_proc_write_fndecl_22252_fns dac960_user_command_proc_write fndecl 3 22252 NULL
+qp_alloc_ppn_set_fndecl_22255_fns qp_alloc_ppn_set fndecl 2-4 22255 NULL
+nr_free_buffer_pages_fndecl_22263_fns nr_free_buffer_pages fndecl 0 22263 NULL
+il3945_ucode_rx_stats_read_fndecl_22267_fns il3945_ucode_rx_stats_read fndecl 3 22267 NULL
+sn9c2028_read4_fndecl_22290_fns sn9c2028_read4 fndecl 0 22290 NULL
+gspca_dev_probe_fndecl_22297_fns gspca_dev_probe fndecl 4 22297 NULL
+slot_bytes_fndecl_22306_fns slot_bytes fndecl 0 22306 NULL
+smk_write_logging_fndecl_22313_fns smk_write_logging fndecl 3 22313 NULL
+iwl_dbgfs_tof_range_response_read_fndecl_22327_fns iwl_dbgfs_tof_range_response_read fndecl 3 22327 NULL
+f2fs_getxattr_fndecl_22337_fns f2fs_getxattr fndecl 0 22337 NULL
+tlv_put_string_fndecl_22356_fns tlv_put_string fndecl 0 22356 NULL
+_proc_do_string_fndecl_22363_fns _proc_do_string fndecl 2 22363 NULL
+ffs_ep0_read_fndecl_22371_fns ffs_ep0_read fndecl 3 22371 NULL
+ecc_size_persistent_ram_ecc_info_22390_fns ecc_size persistent_ram_ecc_info 0 22390 NULL
+nr_blocks_jffs2_sb_info_22399_fns nr_blocks jffs2_sb_info 0 22399 NULL
+size_dsp_segment_desc_22400_fns size dsp_segment_desc 0 22400 NULL
+nfc_llcp_send_ui_frame_fndecl_22429_fns nfc_llcp_send_ui_frame fndecl 5 22429 NULL
+start_async_cow_22445_fns start async_cow 0 22445 NULL
+do_send_fragment_fndecl_22447_fns do_send_fragment fndecl 3 22447 NULL
+fsl_edma_alloc_desc_fndecl_22466_fns fsl_edma_alloc_desc fndecl 2 22466 NULL
+xfs_readdir_fndecl_22492_fns xfs_readdir fndecl 3 22492 NULL
+ovl_cache_entry_new_fndecl_22495_fns ovl_cache_entry_new fndecl 3 22495 NULL
+ecc_alloc_digits_space_fndecl_22496_fns ecc_alloc_digits_space fndecl 1 22496 NULL
+iwl_dbgfs_clear_ucode_statistics_write_fndecl_22503_fns iwl_dbgfs_clear_ucode_statistics_write fndecl 3 22503 NULL
+len_bna_mem_info_22518_fns len bna_mem_info 0 22518 NULL nohasharray
+device_add_attrs_fndecl_22518_fns device_add_attrs fndecl 0 22518 &len_bna_mem_info_22518_fns
+rocker_dma_ring_bufs_alloc_fndecl_22520_fns rocker_dma_ring_bufs_alloc fndecl 4 22520 NULL
+tx_frag_in_process_called_read_fndecl_22553_fns tx_frag_in_process_called_read fndecl 3 22553 NULL
+skd_next_devno_vardecl_skd_main_c_22569_fns skd_next_devno vardecl_skd_main.c 0 22569 NULL
+fw_stats_raw_read_fndecl_22602_fns fw_stats_raw_read fndecl 3 22602 NULL
+brcmf_fil_cmd_data_get_fndecl_22605_fns brcmf_fil_cmd_data_get fndecl 4 22605 NULL
+btrfs_submit_compressed_write_fndecl_22608_fns btrfs_submit_compressed_write fndecl 5 22608 NULL
+bond_verify_device_path_fndecl_22619_fns bond_verify_device_path fndecl 3 22619 NULL nohasharray
+wil_write_pmccfg_fndecl_22619_fns wil_write_pmccfg fndecl 3 22619 &bond_verify_device_path_fndecl_22619_fns
+SYSC_io_getevents_fndecl_22627_fns SYSC_io_getevents fndecl 3 22627 NULL
+rdma_alloc_hw_stats_struct_fndecl_22643_fns rdma_alloc_hw_stats_struct fndecl 2 22643 NULL
+sctp_setsockopt_initmsg_fndecl_22644_fns sctp_setsockopt_initmsg fndecl 3 22644 NULL
+md_probe_fndecl_22668_fns md_probe fndecl 1 22668 NULL
+init_rs_internal_fndecl_22671_fns init_rs_internal fndecl 6-1 22671 NULL
+cfs_trace_copyout_string_fndecl_22683_fns cfs_trace_copyout_string fndecl 2 22683 NULL
+tx_queue_len_read_fndecl_22692_fns tx_queue_len_read fndecl 3 22692 NULL
+scif_rb_write_fndecl_22718_fns scif_rb_write fndecl 0 22718 NULL
+sta_num_ps_buf_frames_read_fndecl_22723_fns sta_num_ps_buf_frames_read fndecl 3 22723 NULL
+fpregs_set_fndecl_22730_fns fpregs_set fndecl 4 22730 NULL
+xprt_alloc_fndecl_22736_fns xprt_alloc fndecl 2 22736 NULL
+SYSC_syslog_fndecl_22742_fns SYSC_syslog fndecl 3 22742 NULL
+slave_num_ad7280_state_22755_fns slave_num ad7280_state 0 22755 NULL
+alloc_perm_bits_fndecl_22767_fns alloc_perm_bits fndecl 2 22767 NULL
+tomoyo_round2_fndecl_22781_fns tomoyo_round2 fndecl 0 22781 NULL
+agp_create_memory_fndecl_22816_fns agp_create_memory fndecl 1 22816 NULL
+pwr_sleep_cycle_avg_read_fndecl_22826_fns pwr_sleep_cycle_avg_read fndecl 3 22826 NULL
+virtio_transport_alloc_pkt_fndecl_22828_fns virtio_transport_alloc_pkt fndecl 2 22828 NULL
+nfs_pgarray_set_fndecl_22830_fns nfs_pgarray_set fndecl 2 22830 NULL
+gigaset_initdriver_fndecl_22839_fns gigaset_initdriver fndecl 2 22839 NULL
+test_eb_bitmaps_fndecl_22861_fns test_eb_bitmaps fndecl 1 22861 NULL
+sst_fill_and_send_cmd_unlocked_fndecl_22862_fns sst_fill_and_send_cmd_unlocked fndecl 7 22862 NULL
+xs_sendpages_fndecl_22864_fns xs_sendpages fndecl 3 22864 NULL
+max_part_vardecl_brd_c_22873_fns max_part vardecl_brd.c 0 22873 NULL
+length_usbtest_param_32_22886_fns length usbtest_param_32 0 22886 NULL
+__btrfs_cow_block_fndecl_22902_fns __btrfs_cow_block fndecl 0 22902 NULL
+vmalloc_32_fndecl_22908_fns vmalloc_32 fndecl 1 22908 NULL
+lmd_exclude_count_lustre_mount_data_22915_fns lmd_exclude_count lustre_mount_data 0 22915 NULL
+cifs_xattr_set_fndecl_22930_fns cifs_xattr_set fndecl 6 22930 NULL
+cp210x_read_reg_block_fndecl_22947_fns cp210x_read_reg_block fndecl 4 22947 NULL
+i2cdev_read_fndecl_22949_fns i2cdev_read fndecl 3 22949 NULL
+lov_ost_pool_init_fndecl_22956_fns lov_ost_pool_init fndecl 2 22956 NULL
+ipc_alloc_fndecl_22971_fns ipc_alloc fndecl 1 22971 NULL
+kernfs_file_direct_read_fndecl_22981_fns kernfs_file_direct_read fndecl 3 22981 NULL
+acpi_battery_write_alarm_fndecl_22987_fns acpi_battery_write_alarm fndecl 3 22987 NULL
+dvb_register_adapter_fndecl_23000_fns dvb_register_adapter fndecl 0 23000 NULL
+memblock_alloc_range_fndecl_23015_fns memblock_alloc_range fndecl 1 23015 NULL
+ioctl_private_iw_point_fndecl_23018_fns ioctl_private_iw_point fndecl 7 23018 NULL
+nested_get_page_fndecl_23031_fns nested_get_page fndecl 2 23031 NULL
+sta_aid_read_fndecl_23048_fns sta_aid_read fndecl 3 23048 NULL
+gnttab_free_count_vardecl_grant_table_c_23049_fns gnttab_free_count vardecl_grant-table.c 0 23049 NULL
+fcoe_ctlr_device_add_fndecl_23058_fns fcoe_ctlr_device_add fndecl 3 23058 NULL
+usb_dmac_desc_alloc_fndecl_23059_fns usb_dmac_desc_alloc fndecl 2 23059 NULL
+to_clkrc_fndecl_23074_fns to_clkrc fndecl 0-2-3 23074 NULL
+scif_rb_count_fndecl_23076_fns scif_rb_count fndecl 0 23076 NULL
+vicam_set_camera_power_fndecl_23091_fns vicam_set_camera_power fndecl 0 23091 NULL
+rproc_state_write_fndecl_23143_fns rproc_state_write fndecl 3 23143 NULL
+bits_key_vector_23153_fns bits key_vector 0 23153 NULL
+rx_defrag_called_read_fndecl_23162_fns rx_defrag_called_read fndecl 3 23162 NULL
+memblock_alloc_base_fndecl_23169_fns memblock_alloc_base fndecl 1 23169 NULL
+uhid_char_read_fndecl_23187_fns uhid_char_read fndecl 3 23187 NULL
+tx_tx_retry_data_read_fndecl_23189_fns tx_tx_retry_data_read fndecl 3 23189 NULL
+ir_context_mask_fw_ohci_23196_fns ir_context_mask fw_ohci 0 23196 NULL
+ib_uverbs_reg_mr_fndecl_23214_fns ib_uverbs_reg_mr fndecl 4-5 23214 NULL
+size_of_ntlmssp_blob_fndecl_23224_fns size_of_ntlmssp_blob fndecl 0 23224 NULL
+ivtv_v4l2_read_fndecl_23231_fns ivtv_v4l2_read fndecl 3 23231 NULL
+num_rxd_rx_ring_config_23240_fns num_rxd rx_ring_config 0 23240 NULL
+rx_rx_defrag_read_fndecl_23241_fns rx_rx_defrag_read fndecl 3 23241 NULL
+__alloc_bootmem_node_fndecl_23259_fns __alloc_bootmem_node fndecl 2 23259 NULL
+avc_data_length_firedtv_23266_fns avc_data_length firedtv 0 23266 NULL
+write_flush_pipefs_fndecl_23286_fns write_flush_pipefs fndecl 3 23286 NULL
+transfersize_scsi_cmnd_23314_fns transfersize scsi_cmnd 0 23314 NULL
+tail_userio_device_23332_fns tail userio_device 0 23332 NULL
+ieee80211_if_read_dot11MeshHWMPnetDiameterTraversalTime_fndecl_23334_fns ieee80211_if_read_dot11MeshHWMPnetDiameterTraversalTime fndecl 3 23334 NULL
+v9fs_fid_xattr_get_fndecl_23361_fns v9fs_fid_xattr_get fndecl 0 23361 NULL
+packet_buffer_init_fndecl_23380_fns packet_buffer_init fndecl 2 23380 NULL
+btmrvl_hscmd_read_fndecl_23389_fns btmrvl_hscmd_read fndecl 3 23389 NULL
+ikconfig_read_current_fndecl_23401_fns ikconfig_read_current fndecl 3 23401 NULL
+map_block_for_writepage_fndecl_23405_fns map_block_for_writepage fndecl 3 23405 NULL
+numerator_v4l2_fract_23413_fns numerator v4l2_fract 0 23413 NULL
+configfs_read_file_fndecl_23424_fns configfs_read_file fndecl 3 23424 NULL
+log_size_mlx5_srq_attr_23431_fns log_size mlx5_srq_attr 0 23431 NULL
+nilfs_attach_snapshot_fndecl_23434_fns nilfs_attach_snapshot fndecl 2 23434 NULL
+btrfs_dir_data_len_fndecl_23457_fns btrfs_dir_data_len fndecl 0 23457 NULL
+size_mwifiex_opt_sleep_confirm_23460_fns size mwifiex_opt_sleep_confirm 0 23460 NULL
+dma_map_sg_attrs_fndecl_23465_fns dma_map_sg_attrs fndecl 0 23465 NULL
+iwl_dbgfs_d0i3_refs_read_fndecl_23482_fns iwl_dbgfs_d0i3_refs_read fndecl 3 23482 NULL
+gfn_to_hva_prot_fndecl_23484_fns gfn_to_hva_prot fndecl 2 23484 NULL
+cyy_init_card_fndecl_23488_fns cyy_init_card fndecl 0 23488 NULL
+tx_frag_called_read_fndecl_23495_fns tx_frag_called_read fndecl 3 23495 NULL
+sr_size_send_context_23500_fns sr_size send_context 0 23500 NULL
+rxe_mem_alloc_fndecl_23510_fns rxe_mem_alloc fndecl 3 23510 NULL nohasharray
+internal_create_group_fndecl_23510_fns internal_create_group fndecl 0 23510 &rxe_mem_alloc_fndecl_23510_fns
+usb_ep_align_maybe_fndecl_23516_fns usb_ep_align_maybe fndecl 0-3 23516 NULL
+dev_irnet_read_fndecl_23518_fns dev_irnet_read fndecl 3 23518 NULL
+max_pkt_size_cx231xx_bulk_ctl_23542_fns max_pkt_size cx231xx_bulk_ctl 0 23542 NULL
+cosa_write_fndecl_23549_fns cosa_write fndecl 3 23549 NULL
+syslog_print_fndecl_23584_fns syslog_print fndecl 2 23584 NULL
+tail_len_beacon_attr_23587_fns tail_len beacon_attr 0 23587 NULL
+max_cmd_size_ath6kl_bmi_23591_fns max_cmd_size ath6kl_bmi 0 23591 NULL
+dn_setsockopt_fndecl_23593_fns dn_setsockopt fndecl 5 23593 NULL
+read_file_war_stats_fndecl_23607_fns read_file_war_stats fndecl 3 23607 NULL
+nr_grant_frames_vardecl_grant_table_c_23609_fns nr_grant_frames vardecl_grant-table.c 0 23609 NULL
+nr_tags_blk_mq_tags_23638_fns nr_tags blk_mq_tags 0 23638 NULL
+mlx5_core_access_reg_fndecl_23674_fns mlx5_core_access_reg fndecl 3-5 23674 NULL
+acpi_ev_create_gpe_block_fndecl_23722_fns acpi_ev_create_gpe_block fndecl 4 23722 NULL
+lbs_rdmac_read_fndecl_23729_fns lbs_rdmac_read fndecl 3 23729 NULL
+iwl_dbgfs_protection_mode_write_fndecl_23781_fns iwl_dbgfs_protection_mode_write fndecl 3 23781 NULL
+rx_rx_defrag_end_read_fndecl_23786_fns rx_rx_defrag_end_read fndecl 3 23786 NULL
+read_buffer_length_lego_usb_tower_23787_fns read_buffer_length lego_usb_tower 0 23787 NULL
+nvme_trans_modesel_data_fndecl_23803_fns nvme_trans_modesel_data fndecl 4 23803 NULL
+_find_next_bit_be_fndecl_23804_fns _find_next_bit_be fndecl 0 23804 NULL
+compat_sock_setsockopt_fndecl_23812_fns compat_sock_setsockopt fndecl 5 23812 NULL
+padzero_fndecl_23844_fns padzero fndecl 1 23844 NULL nohasharray
+sel_read_policyvers_fndecl_23844_fns sel_read_policyvers fndecl 3 23844 &padzero_fndecl_23844_fns
+efx_ef10_sriov_configure_fndecl_23850_fns efx_ef10_sriov_configure fndecl 2 23850 NULL
+write_file_tpc_fndecl_23877_fns write_file_tpc fndecl 3 23877 NULL
+load_msg_fndecl_23884_fns load_msg fndecl 2 23884 NULL
+snd_korg1212_copy_to_fndecl_23887_fns snd_korg1212_copy_to fndecl 6 23887 NULL
+tracing_trace_options_write_fndecl_23946_fns tracing_trace_options_write fndecl 3 23946 NULL
+init_q_fndecl_23959_fns init_q fndecl 4 23959 NULL
+memstick_alloc_host_fndecl_23965_fns memstick_alloc_host fndecl 1 23965 NULL
+xfs_buf_item_get_format_fndecl_23982_fns xfs_buf_item_get_format fndecl 2 23982 NULL
+pci_request_selected_regions_fndecl_23994_fns pci_request_selected_regions fndecl 0 23994 NULL
+extract_crng_user_fndecl_23995_fns extract_crng_user fndecl 2 23995 NULL
+iscsi_session_setup_fndecl_24023_fns iscsi_session_setup fndecl 5-3 24023 NULL
+vpdma_create_desc_list_fndecl_24044_fns vpdma_create_desc_list fndecl 2 24044 NULL
+buf_size_conf_writedata_24046_fns buf_size conf_writedata 0 24046 NULL
+bNumEndpoints_usb_interface_descriptor_24052_fns bNumEndpoints usb_interface_descriptor 0 24052 NULL
+shdma_init_fndecl_24059_fns shdma_init fndecl 3 24059 NULL
+ws_row_winsize_24064_fns ws_row winsize 0 24064 NULL
+ebx_v86_regs_24072_fns ebx v86_regs 0 24072 NULL
+raydium_i2c_send_fndecl_24090_fns raydium_i2c_send fndecl 4 24090 NULL
+cfs_trace_allocate_string_buffer_fndecl_24094_fns cfs_trace_allocate_string_buffer fndecl 2 24094 NULL
+cnt_nfp_net_rx_ring_24099_fns cnt nfp_net_rx_ring 0 24099 NULL
+size_sge_rspq_24120_fns size sge_rspq 0 24120 NULL
+scif_user_send_fndecl_24137_fns scif_user_send fndecl 3 24137 NULL
+tegra_clk_init_fndecl_24143_fns tegra_clk_init fndecl 3-2 24143 NULL
+len_event_data_24144_fns len event_data 0 24144 NULL
+o2net_send_message_vec_fndecl_24188_fns o2net_send_message_vec fndecl 4 24188 NULL nohasharray
+iwl_dbgfs_fh_reg_read_fndecl_24188_fns iwl_dbgfs_fh_reg_read fndecl 3 24188 &o2net_send_message_vec_fndecl_24188_fns
+stride_usbatm_channel_24224_fns stride usbatm_channel 0 24224 NULL
+carl9170_cmd_buf_fndecl_24229_fns carl9170_cmd_buf fndecl 3 24229 NULL
+num_tx_queues_fm10k_intfc_24236_fns num_tx_queues fm10k_intfc 0 24236 NULL
+__nodes_weight_fndecl_24239_fns __nodes_weight fndecl 0 24239 NULL
+iio_storage_bytes_for_timestamp_fndecl_24260_fns iio_storage_bytes_for_timestamp fndecl 0 24260 NULL
+pte_prefetch_gfn_to_pfn_fndecl_24310_fns pte_prefetch_gfn_to_pfn fndecl 2 24310 NULL nohasharray
+ocfs2_info_scan_inode_alloc_fndecl_24310_fns ocfs2_info_scan_inode_alloc fndecl 3 24310 &pte_prefetch_gfn_to_pfn_fndecl_24310_fns
+zlib_deflate_workspacesize_fndecl_24330_fns zlib_deflate_workspacesize fndecl 0 24330 NULL
+iwl_dbgfs_wowlan_sram_read_fndecl_24335_fns iwl_dbgfs_wowlan_sram_read fndecl 3 24335 NULL
+ls_recover_size_lm_lockstruct_24365_fns ls_recover_size lm_lockstruct 0 24365 NULL
+sco_sock_setsockopt_fndecl_24379_fns sco_sock_setsockopt fndecl 5 24379 NULL
+error_elp_while_nvic_pending_read_fndecl_24394_fns error_elp_while_nvic_pending_read fndecl 3 24394 NULL
+completed_vringh_24407_fns completed vringh 0 24407 NULL
+srpt_cm_rej_recv_fndecl_24427_fns srpt_cm_rej_recv fndecl 4 24427 NULL
+ni_gpct_device_construct_fndecl_24433_fns ni_gpct_device_construct fndecl 5 24433 NULL
+size_tty_buffer_24438_fns size tty_buffer 0 24438 NULL
+fuse_request_alloc_nofs_fndecl_24442_fns fuse_request_alloc_nofs fndecl 1 24442 NULL
+ptlrpc_lprocfs_nrs_seq_write_fndecl_24446_fns ptlrpc_lprocfs_nrs_seq_write fndecl 3 24446 NULL
+unlink_queued_fndecl_24470_fns unlink_queued fndecl 3 24470 NULL
+dtim_interval_read_fndecl_24477_fns dtim_interval_read fndecl 3 24477 NULL
+rtl_get_hwinfo_fndecl_24480_fns rtl_get_hwinfo fndecl 3 24480 NULL
+dvb_video_write_fndecl_24545_fns dvb_video_write fndecl 3 24545 NULL
+log_len_vardecl_verifier_c_24556_fns log_len vardecl_verifier.c 0 24556 NULL nohasharray
+aqm_write_fndecl_24556_fns aqm_write fndecl 3 24556 &log_len_vardecl_verifier_c_24556_fns
+ibc_queue_depth_kib_conn_24567_fns ibc_queue_depth kib_conn 0 24567 NULL
+tomoyo_scan_bprm_fndecl_24585_fns tomoyo_scan_bprm fndecl 2-4 24585 NULL nohasharray
+pipeline_hs_tx_stat_fifo_int_read_fndecl_24585_fns pipeline_hs_tx_stat_fifo_int_read fndecl 3 24585 &tomoyo_scan_bprm_fndecl_24585_fns
+ebcnt_vardecl_oobtest_c_24588_fns ebcnt vardecl_oobtest.c 0 24588 NULL
+root_level_kvm_mmu_24604_fns root_level kvm_mmu 0 24604 NULL
+unix_bind_fndecl_24615_fns unix_bind fndecl 3 24615 NULL
+fs_path_add_fndecl_24627_fns fs_path_add fndecl 3 24627 NULL
+xsd_read_fndecl_24630_fns xsd_read fndecl 3 24630 NULL
+txq_depth_bnad_24636_fns txq_depth bnad 0 24636 NULL
+intr_cnt_vxgedev_24656_fns intr_cnt vxgedev 0 24656 NULL
+uinput_str_to_user_fndecl_24668_fns uinput_str_to_user fndecl 3 24668 NULL
+tool_link_write_fndecl_24679_fns tool_link_write fndecl 3 24679 NULL
+inet_insert_ifa_fndecl_24688_fns inet_insert_ifa fndecl 0 24688 NULL
+transport_generic_map_mem_to_cmd_fndecl_24700_fns transport_generic_map_mem_to_cmd fndecl 3 24700 NULL
+queue_depth_blk_mq_tag_set_24719_fns queue_depth blk_mq_tag_set 0 24719 NULL
+wilc_set_join_req_fndecl_24725_fns wilc_set_join_req fndecl 4-6 24725 NULL
+HiSax_readstatus_fndecl_24731_fns HiSax_readstatus fndecl 2 24731 NULL
+smk_read_direct_fndecl_24744_fns smk_read_direct fndecl 3 24744 NULL
+n_ao_urbs_usbduxsigma_private_24760_fns n_ao_urbs usbduxsigma_private 0 24760 NULL
+_sdma_txadd_daddr_fndecl_24789_fns _sdma_txadd_daddr fndecl 5 24789 NULL
+gnttab_expand_fndecl_24794_fns gnttab_expand fndecl 1 24794 NULL
+write_file_tx99_fndecl_24803_fns write_file_tx99 fndecl 3 24803 NULL
+num_q_vectors_i40e_vsi_24807_fns num_q_vectors i40e_vsi 0 24807 NULL
+fq_codel_zalloc_fndecl_24833_fns fq_codel_zalloc fndecl 1 24833 NULL
+acpi_ut_create_string_object_fndecl_24851_fns acpi_ut_create_string_object fndecl 1 24851 NULL
+__videobuf_copy_to_user_fndecl_24876_fns __videobuf_copy_to_user fndecl 4 24876 NULL
+memweight_fndecl_24905_fns memweight fndecl 0 24905 NULL
+unxz_fndecl_24936_fns unxz fndecl 2 24936 NULL
+vmalloc_fndecl_24955_fns vmalloc fndecl 1 24955 NULL
+nilfs_cpfile_clear_snapshot_fndecl_24964_fns nilfs_cpfile_clear_snapshot fndecl 2 24964 NULL
+outmsg_len_hvutil_transport_24966_fns outmsg_len hvutil_transport 0 24966 NULL
+zero_the_pointer_fndecl_25003_fns zero_the_pointer fndecl 0 25003 NULL
+default_density_st_modedef_25006_fns default_density st_modedef 0 25006 NULL
+bnx2fc_process_unsol_compl_fndecl_25035_fns bnx2fc_process_unsol_compl fndecl 2 25035 NULL
+acpi_gpio_count_fndecl_25052_fns acpi_gpio_count fndecl 0 25052 NULL
+buffer_size_snd_compr_runtime_25072_fns buffer_size snd_compr_runtime 0 25072 NULL nohasharray
+vme_user_write_fndecl_25072_fns vme_user_write fndecl 3 25072 &buffer_size_snd_compr_runtime_25072_fns
+mlxsw_reg_trans_wait_fndecl_25101_fns mlxsw_reg_trans_wait fndecl 0 25101 NULL
+num_pbls_ocrdma_hw_mr_25102_fns num_pbls ocrdma_hw_mr 0 25102 NULL
+compat_sys_select_fndecl_25104_fns compat_sys_select fndecl 1 25104 NULL
+fsm_init_fndecl_25109_fns fsm_init fndecl 2 25109 NULL
+i40e_allocate_virt_mem_d_fndecl_25132_fns i40e_allocate_virt_mem_d fndecl 3 25132 NULL
+create_table_fndecl_25158_fns create_table fndecl 2 25158 NULL
+cipso_v4_map_cat_rng_hton_fndecl_25176_fns cipso_v4_map_cat_rng_hton fndecl 0 25176 NULL
+il_dbgfs_disable_ht40_write_fndecl_25194_fns il_dbgfs_disable_ht40_write fndecl 3 25194 NULL
+ux500_regulator_debug_init_fndecl_25207_fns ux500_regulator_debug_init fndecl 3 25207 NULL
+npeers_cm_dev_25216_fns npeers cm_dev 0 25216 NULL
+jumpshot_read_data_fndecl_25228_fns jumpshot_read_data fndecl 4 25228 NULL
+of_property_read_string_helper_fndecl_25257_fns of_property_read_string_helper fndecl 0 25257 NULL
+stk_allocate_buffers_fndecl_25264_fns stk_allocate_buffers fndecl 2 25264 NULL
+register_count_acpi_gpe_block_info_25272_fns register_count acpi_gpe_block_info 0 25272 NULL
+qsfp_dump_fndecl_25308_fns qsfp_dump fndecl 0 25308 NULL
+sysfs_create_groups_fndecl_25339_fns sysfs_create_groups fndecl 0 25339 NULL
+total_ps_buffered_read_fndecl_25342_fns total_ps_buffered_read fndecl 3 25342 NULL
+__mptctl_ioctl_fndecl_25360_fns __mptctl_ioctl fndecl 2 25360 NULL
+bio_copy_kern_fndecl_25382_fns bio_copy_kern fndecl 3 25382 NULL
+req_buf_size_f_uac1_opts_25386_fns req_buf_size f_uac1_opts 0 25386 NULL
+memblock_virt_alloc_try_nid_fndecl_25409_fns memblock_virt_alloc_try_nid fndecl 1 25409 NULL nohasharray
+memsize_t4_cq_25409_fns memsize t4_cq 0 25409 &memblock_virt_alloc_try_nid_fndecl_25409_fns
+snd_pcm_lib_read_transfer_fndecl_25411_fns snd_pcm_lib_read_transfer fndecl 5 25411 NULL
+ptlrpcd_per_cpt_max_vardecl_ptlrpcd_c_25416_fns ptlrpcd_per_cpt_max vardecl_ptlrpcd.c 0 25416 NULL
+power_read_fndecl_25424_fns power_read fndecl 3 25424 NULL
+lpfc_idiag_drbacc_read_fndecl_25439_fns lpfc_idiag_drbacc_read fndecl 3 25439 NULL
+alloc_vm_area_fndecl_25446_fns alloc_vm_area fndecl 1 25446 NULL
+smk_read_ptrace_fndecl_25461_fns smk_read_ptrace fndecl 3 25461 NULL
+viafb_vt1636_proc_write_fndecl_25473_fns viafb_vt1636_proc_write fndecl 3 25473 NULL
+max_buckets_out_mpt_lan_priv_25498_fns max_buckets_out mpt_lan_priv 0 25498 NULL
+count_seq_file_25501_fns count seq_file 0 25501 NULL
+blk_init_tags_fndecl_25511_fns blk_init_tags fndecl 1 25511 NULL
+SYSC_kexec_file_load_fndecl_25513_fns SYSC_kexec_file_load fndecl 3 25513 NULL
+read_file_spectral_period_fndecl_25514_fns read_file_spectral_period fndecl 3 25514 NULL
+ntb_spad_count_fndecl_25572_fns ntb_spad_count fndecl 0 25572 NULL
+cifs_mapchar_fndecl_25586_fns cifs_mapchar fndecl 0 25586 NULL
+isr_tx_exch_complete_read_fndecl_25588_fns isr_tx_exch_complete_read fndecl 3 25588 NULL
+isr_hw_pm_mode_changes_read_fndecl_25597_fns isr_hw_pm_mode_changes_read fndecl 3 25597 NULL nohasharray
+dma_tx_requested_read_fndecl_25597_fns dma_tx_requested_read fndecl 3 25597 &isr_hw_pm_mode_changes_read_fndecl_25597_fns
+max_cmd_sg_entries_ctlr_info_25601_fns max_cmd_sg_entries ctlr_info 0 25601 NULL
+size_hpi_message_header_25619_fns size hpi_message_header 0 25619 NULL
+ceph_osdc_alloc_request_fndecl_25622_fns ceph_osdc_alloc_request fndecl 3 25622 NULL
+profile_replace_fndecl_25647_fns profile_replace fndecl 3 25647 NULL
+nvmet_rdma_alloc_sgl_fndecl_25655_fns nvmet_rdma_alloc_sgl fndecl 3 25655 NULL
+min_bytes_needed_fndecl_25664_fns min_bytes_needed fndecl 0 25664 NULL
+nvme_trans_log_info_exceptions_fndecl_25670_fns nvme_trans_log_info_exceptions fndecl 3 25670 NULL
+bnxt_change_mtu_fndecl_25675_fns bnxt_change_mtu fndecl 2 25675 NULL nohasharray
+pipeline_enc_tx_stat_fifo_int_read_fndecl_25675_fns pipeline_enc_tx_stat_fifo_int_read fndecl 3 25675 &bnxt_change_mtu_fndecl_25675_fns
+persistent_ram_ecc_string_fndecl_25699_fns persistent_ram_ecc_string fndecl 0 25699 NULL
+ntfs_file_fsync_fndecl_25706_fns ntfs_file_fsync fndecl 2-3 25706 NULL
+max_cid_space_cnic_local_25708_fns max_cid_space cnic_local 0 25708 NULL
+vfd_write_fndecl_25710_fns vfd_write fndecl 3 25710 NULL
+nr_scanned_scan_control_25733_fns nr_scanned scan_control 0 25733 NULL
+get_pas_size_fndecl_25739_fns get_pas_size fndecl 0 25739 NULL
+pvr2_i2c_write_fndecl_25754_fns pvr2_i2c_write fndecl 4 25754 NULL
+regmap_range_read_file_fndecl_25764_fns regmap_range_read_file fndecl 3 25764 NULL
+rx_rx_cmplt_read_fndecl_25778_fns rx_rx_cmplt_read fndecl 3 25778 NULL
+btrfs_inode_extref_name_len_fndecl_25779_fns btrfs_inode_extref_name_len fndecl 0 25779 NULL
+hpet_readl_fndecl_25794_fns hpet_readl fndecl 0 25794 NULL
+pg_base_nfs_pgio_mirror_25798_fns pg_base nfs_pgio_mirror 0 25798 NULL
+keys_proc_write_fndecl_25819_fns keys_proc_write fndecl 3 25819 NULL
+__kfifo_in_fndecl_25822_fns __kfifo_in fndecl 3 25822 NULL
+ext4_kvmalloc_fndecl_25823_fns ext4_kvmalloc fndecl 1 25823 NULL
+alloc_tx_struct_fndecl_25886_fns alloc_tx_struct fndecl 1 25886 NULL
+walk_page_range_fndecl_25894_fns walk_page_range fndecl 0 25894 NULL
+ath6kl_regdump_read_fndecl_25898_fns ath6kl_regdump_read fndecl 3 25898 NULL
+nfp_net_tx_ring_alloc_fndecl_25907_fns nfp_net_tx_ring_alloc fndecl 2 25907 NULL
+kvm_vcpu_gfn_to_hva_prot_fndecl_25911_fns kvm_vcpu_gfn_to_hva_prot fndecl 2 25911 NULL
+mtd_concat_create_fndecl_25923_fns mtd_concat_create fndecl 2 25923 NULL nohasharray
+d40_pool_lli_alloc_fndecl_25923_fns d40_pool_lli_alloc fndecl 3 25923 &mtd_concat_create_fndecl_25923_fns
+get_kcore_size_fndecl_25930_fns get_kcore_size fndecl 0 25930 NULL
+debugfs_read_file_bool_fndecl_25937_fns debugfs_read_file_bool fndecl 3 25937 NULL
+kvm_hv_set_msr_common_fndecl_25940_fns kvm_hv_set_msr_common fndecl 3 25940 NULL
+__media_entity_enum_init_fndecl_25953_fns __media_entity_enum_init fndecl 2 25953 NULL nohasharray
+lro_xid_fc_lport_25953_fns lro_xid fc_lport 0 25953 &__media_entity_enum_init_fndecl_25953_fns
+_iwl_dbgfs_sram_write_fndecl_25972_fns _iwl_dbgfs_sram_write fndecl 3 25972 NULL
+tx_max_out_mpt_lan_priv_25974_fns tx_max_out mpt_lan_priv 0 25974 NULL
+ieee80211_if_read_dot11MeshGateAnnouncementProtocol_fndecl_25989_fns ieee80211_if_read_dot11MeshGateAnnouncementProtocol fndecl 3 25989 NULL
+tas571x_reg_read_multiword_fndecl_26030_fns tas571x_reg_read_multiword fndecl 4 26030 NULL
+hex_dump_to_buffer_fndecl_26039_fns hex_dump_to_buffer fndecl 0-2-4-3 26039 NULL
+ocfs2_debug_read_fndecl_26040_fns ocfs2_debug_read fndecl 3 26040 NULL
+picolcd_debug_eeprom_read_fndecl_26054_fns picolcd_debug_eeprom_read fndecl 3 26054 NULL
+_pcol_init_fndecl_26056_fns _pcol_init fndecl 2 26056 NULL
+dataflash_read_user_otp_fndecl_26075_fns dataflash_read_user_otp fndecl 2-3 26075 NULL nohasharray
+ep0_write_fndecl_26075_fns ep0_write fndecl 3 26075 &dataflash_read_user_otp_fndecl_26075_fns
+alloc_bitmap_fndecl_26079_fns alloc_bitmap fndecl 1 26079 NULL
+idmap_pipe_downcall_fndecl_26092_fns idmap_pipe_downcall fndecl 3 26092 NULL
+qp_host_alloc_queue_fndecl_26101_fns qp_host_alloc_queue fndecl 1 26101 NULL
+snd_fw_async_midi_port_init_fndecl_26127_fns snd_fw_async_midi_port_init fndecl 4 26127 NULL
+ipwireless_ppp_mru_fndecl_26146_fns ipwireless_ppp_mru fndecl 0 26146 NULL
+zram_major_vardecl_zram_drv_c_26180_fns zram_major vardecl_zram_drv.c 0 26180 NULL
+iscsi_create_endpoint_fndecl_26186_fns iscsi_create_endpoint fndecl 1 26186 NULL
+SYSC_setdomainname_fndecl_26207_fns SYSC_setdomainname fndecl 2 26207 NULL
+data_len_kernel_ipmi_msg_26209_fns data_len kernel_ipmi_msg 0 26209 NULL
+i40iw_allocate_virt_mem_fndecl_26210_fns i40iw_allocate_virt_mem fndecl 3 26210 NULL
+clone_range_fndecl_26212_fns clone_range fndecl 6-5 26212 NULL
+blk_queue_init_tags_fndecl_26227_fns blk_queue_init_tags fndecl 2 26227 NULL
+command_setflickerctrl_fndecl_26233_fns command_setflickerctrl fndecl 0 26233 NULL
+iwl_dbgfs_sram_write_fndecl_26260_fns iwl_dbgfs_sram_write fndecl 3 26260 NULL
+il_dbgfs_rx_stats_read_fndecl_26264_fns il_dbgfs_rx_stats_read fndecl 3 26264 NULL
+jumbo_size_qset_params_26273_fns jumbo_size qset_params 0 26273 NULL
+n_hdlc_tty_write_fndecl_26279_fns n_hdlc_tty_write fndecl 4 26279 NULL
+tx_data_length_hso_serial_26287_fns tx_data_length hso_serial 0 26287 NULL
+wacom_led_putimage_fndecl_26291_fns wacom_led_putimage fndecl 4 26291 NULL
+alloc_ring_fndecl_26338_fns alloc_ring fndecl 2-4 26338 NULL
+ept_prefetch_gpte_fndecl_26343_fns ept_prefetch_gpte fndecl 4 26343 NULL
+ioread16_fndecl_26365_fns ioread16 fndecl 0 26365 NULL
+mrp_attr_create_fndecl_26390_fns mrp_attr_create fndecl 3 26390 NULL
+__krealloc_fndecl_26394_fns __krealloc fndecl 2 26394 NULL nohasharray
+lcd_write_fndecl_26394_fns lcd_write fndecl 3 26394 &__krealloc_fndecl_26394_fns
+get_user_cpu_mask_fndecl_26398_fns get_user_cpu_mask fndecl 2 26398 NULL
+omap_hwmod_count_resources_fndecl_26400_fns omap_hwmod_count_resources fndecl 0 26400 NULL
+netlbl_catmap_walk_fndecl_26405_fns netlbl_catmap_walk fndecl 0 26405 NULL
+krealloc_fndecl_26415_fns krealloc fndecl 2 26415 NULL
+acpi_os_allocate_fndecl_26431_fns acpi_os_allocate fndecl 1 26431 NULL
+start_cif_cam_fndecl_26442_fns start_cif_cam fndecl 0 26442 NULL
+usbat_bulk_read_fndecl_26469_fns usbat_bulk_read fndecl 4 26469 NULL
+queue_cnt_fndecl_26484_fns queue_cnt fndecl 0 26484 NULL
+videobuf_read_stream_fndecl_26495_fns videobuf_read_stream fndecl 3 26495 NULL
+setkey_fndecl_26520_fns setkey fndecl 3 26520 NULL nohasharray
+num_tc_mlx5e_params_26520_fns num_tc mlx5e_params 0 26520 &setkey_fndecl_26520_fns
+vmap_fndecl_26530_fns vmap fndecl 2 26530 NULL
+npages_kvm_memory_slot_26541_fns npages kvm_memory_slot 0 26541 NULL
+sctp_setsockopt_default_sndinfo_fndecl_26544_fns sctp_setsockopt_default_sndinfo fndecl 3 26544 NULL
+ath10k_debug_fw_checksums_read_fndecl_26549_fns ath10k_debug_fw_checksums_read fndecl 3 26549 NULL
+cld_pipe_downcall_fndecl_26561_fns cld_pipe_downcall fndecl 3 26561 NULL
+ieee80211_if_read_uapsd_max_sp_len_fndecl_26568_fns ieee80211_if_read_uapsd_max_sp_len fndecl 3 26568 NULL
+nfs4_write_cached_acl_fndecl_26573_fns nfs4_write_cached_acl fndecl 4 26573 NULL
+read_file_node_aggr_fndecl_26579_fns read_file_node_aggr fndecl 3 26579 NULL
+nvme_trans_completion_fndecl_26597_fns nvme_trans_completion fndecl 0 26597 NULL
+cache_write_fndecl_26630_fns cache_write fndecl 3 26630 NULL
+read_file_antenna_fndecl_26645_fns read_file_antenna fndecl 3 26645 NULL
+iio_device_add_event_sysfs_fndecl_26664_fns iio_device_add_event_sysfs fndecl 0 26664 NULL
+wil_read_back_fndecl_26724_fns wil_read_back fndecl 3 26724 NULL
+debugfs_attr_write_fndecl_26732_fns debugfs_attr_write fndecl 3 26732 NULL
+cache_downcall_fndecl_26737_fns cache_downcall fndecl 3 26737 NULL
+len_osd_sg_entry_26755_fns len osd_sg_entry 0 26755 NULL
+num_phys_expander_device_26765_fns num_phys expander_device 0 26765 NULL
+fw_iso_buffer_alloc_fndecl_26779_fns fw_iso_buffer_alloc fndecl 2 26779 NULL
+audit_unpack_string_fndecl_26791_fns audit_unpack_string fndecl 3 26791 NULL
+iio_storage_bytes_for_si_fndecl_26798_fns iio_storage_bytes_for_si fndecl 0 26798 NULL
+fb_sys_read_fndecl_26817_fns fb_sys_read fndecl 3 26817 NULL
+qlcnic_max_rings_fndecl_26823_fns qlcnic_max_rings fndecl 0 26823 NULL
+ath6kl_mgmt_powersave_ap_fndecl_26828_fns ath6kl_mgmt_powersave_ap fndecl 6 26828 NULL
+edid_size_ufx_data_26833_fns edid_size ufx_data 0 26833 NULL
+hsi_register_board_info_fndecl_26863_fns hsi_register_board_info fndecl 2 26863 NULL
+kvm_read_nested_guest_page_fndecl_26890_fns kvm_read_nested_guest_page fndecl 5 26890 NULL
+read_file_phy_err_fndecl_26901_fns read_file_phy_err fndecl 3 26901 NULL
+reexecute_instruction_fndecl_26906_fns reexecute_instruction fndecl 2 26906 NULL
+edma_prep_slave_sg_fndecl_26917_fns edma_prep_slave_sg fndecl 3 26917 NULL
+cache_ctr_fndecl_26919_fns cache_ctr fndecl 2 26919 NULL
+jfs_xattr_set_os2_fndecl_26923_fns jfs_xattr_set_os2 fndecl 6 26923 NULL
+round_event_name_len_fndecl_26935_fns round_event_name_len fndecl 0 26935 NULL
+axi_dmac_prep_dma_cyclic_fndecl_26953_fns axi_dmac_prep_dma_cyclic fndecl 4-3 26953 NULL
+kvm_vcpu_gfn_to_hva_fndecl_26957_fns kvm_vcpu_gfn_to_hva fndecl 2 26957 NULL
+iso_sched_alloc_fndecl_26962_fns iso_sched_alloc fndecl 1 26962 NULL nohasharray
+wep_key_not_found_read_fndecl_26962_fns wep_key_not_found_read fndecl 3 26962 &iso_sched_alloc_fndecl_26962_fns
+len_hidraw_report_26966_fns len hidraw_report 0 26966 NULL
+fid_len_xfs_fid_27000_fns fid_len xfs_fid 0 27000 NULL
+netxen_alloc_sds_rings_fndecl_27002_fns netxen_alloc_sds_rings fndecl 2 27002 NULL
+ath6kl_cfg80211_connect_event_fndecl_27024_fns ath6kl_cfg80211_connect_event fndecl 7 27024 NULL
+data_read_fndecl_27045_fns data_read fndecl 3 27045 NULL
+ieee80211_if_read_tdls_wider_bw_fndecl_27066_fns ieee80211_if_read_tdls_wider_bw fndecl 3 27066 NULL
+bm_init_fndecl_27082_fns bm_init fndecl 2 27082 NULL
+smk_write_mapped_fndecl_27100_fns smk_write_mapped fndecl 3 27100 NULL
+ieee80211_if_read_ap_power_level_fndecl_27109_fns ieee80211_if_read_ap_power_level fndecl 3 27109 NULL
+acpi_table_parse_entries_array_fndecl_27120_fns acpi_table_parse_entries_array fndecl 0 27120 NULL
+cnt_set_multicast_27125_fns cnt set_multicast 0 27125 NULL
+do_proc_readlink_fndecl_27139_fns do_proc_readlink fndecl 3 27139 NULL
+compat_sys_pselect6_fndecl_27146_fns compat_sys_pselect6 fndecl 1 27146 NULL
+sys_bpf_fndecl_27150_fns sys_bpf fndecl 3 27150 NULL
+nilfs_attach_checkpoint_fndecl_27152_fns nilfs_attach_checkpoint fndecl 2 27152 NULL
+cfs_hash_rehash_bits_fndecl_27208_fns cfs_hash_rehash_bits fndecl 0 27208 NULL
+em_canid_change_fndecl_27221_fns em_canid_change fndecl 3 27221 NULL
+datafab_read_data_fndecl_27257_fns datafab_read_data fndecl 4 27257 NULL
+mx_sb_len_sg_io_hdr_27261_fns mx_sb_len sg_io_hdr 0 27261 NULL
+sys_kexec_load_fndecl_27293_fns sys_kexec_load fndecl 2 27293 NULL
+cifs_strict_fsync_fndecl_27308_fns cifs_strict_fsync fndecl 2-3 27308 NULL
+nrelocs_radeon_cs_parser_27313_fns nrelocs radeon_cs_parser 0 27313 NULL
+btrfs_token_file_extent_ram_bytes_fndecl_27316_fns btrfs_token_file_extent_ram_bytes fndecl 0 27316 NULL
+dma_declare_coherent_memory_fndecl_27319_fns dma_declare_coherent_memory fndecl 4 27319 NULL
+read_default_ldt_fndecl_27341_fns read_default_ldt fndecl 2 27341 NULL
+snd_seq_oss_readq_new_fndecl_27352_fns snd_seq_oss_readq_new fndecl 2 27352 NULL
+n_mcgrps_genl_family_27362_fns n_mcgrps genl_family 0 27362 NULL
+ext_tree_layoutupdate_size_fndecl_27368_fns ext_tree_layoutupdate_size fndecl 0-2 27368 NULL
+msg_namelen_msghdr_27389_fns msg_namelen msghdr 0 27389 NULL
+evdev_ioctl_compat_fndecl_27400_fns evdev_ioctl_compat fndecl 2 27400 NULL
+max_packages_vardecl_uncore_c_27449_fns max_packages vardecl_uncore.c 0 27449 NULL
+tool_peer_mw_read_fndecl_27484_fns tool_peer_mw_read fndecl 3 27484 NULL
+iwl_dbgfs_protection_mode_read_fndecl_27492_fns iwl_dbgfs_protection_mode_read fndecl 3 27492 NULL
+ieee80211_if_read_dot11MeshForwarding_fndecl_27495_fns ieee80211_if_read_dot11MeshForwarding fndecl 3 27495 NULL
+rq_size_srpt_rdma_ch_27500_fns rq_size srpt_rdma_ch 0 27500 NULL nohasharray
+ath10k_read_nf_cal_period_fndecl_27500_fns ath10k_read_nf_cal_period fndecl 3 27500 &rq_size_srpt_rdma_ch_27500_fns
+lpfc_idiag_queacc_read_fndecl_27501_fns lpfc_idiag_queacc_read fndecl 3 27501 NULL
+rx_buf_size_bnx2x_fastpath_27506_fns rx_buf_size bnx2x_fastpath 0 27506 NULL
+dvb_demux_read_fndecl_27534_fns dvb_demux_read fndecl 3 27534 NULL
+sddr09_write_data_fndecl_27565_fns sddr09_write_data fndecl 3 27565 NULL
+pci_add_ext_cap_save_buffer_fndecl_27587_fns pci_add_ext_cap_save_buffer fndecl 3 27587 NULL
+dvb_usercopy_fndecl_27591_fns dvb_usercopy fndecl 2 27591 NULL
+md_alloc_fndecl_27600_fns md_alloc fndecl 1 27600 NULL
+iscsi_create_flashnode_conn_fndecl_27605_fns iscsi_create_flashnode_conn fndecl 4 27605 NULL
+snoop_urb_data_fndecl_27635_fns snoop_urb_data fndecl 2 27635 NULL
+sta_agg_status_read_fndecl_27641_fns sta_agg_status_read fndecl 3 27641 NULL
+error_res_proc_context_27648_fns error res_proc_context 0 27648 NULL
+nvkm_event_init_fndecl_27654_fns nvkm_event_init fndecl 2-3 27654 NULL
+masq_device_event_fndecl_27665_fns masq_device_event fndecl 0 27665 NULL
+mr_write_fndecl_27670_fns mr_write fndecl 0 27670 NULL
+tlbflush_write_file_fndecl_27685_fns tlbflush_write_file fndecl 3 27685 NULL
+_iwl_dbgfs_prph_reg_write_fndecl_27686_fns _iwl_dbgfs_prph_reg_write fndecl 3 27686 NULL
+vhci_put_user_fndecl_27695_fns vhci_put_user fndecl 4 27695 NULL
+hvc_alloc_fndecl_27696_fns hvc_alloc fndecl 4 27696 NULL
+pcpu_extend_area_map_fndecl_27710_fns pcpu_extend_area_map fndecl 2 27710 NULL
+fsblog_xfs_da_geometry_27717_fns fsblog xfs_da_geometry 0 27717 NULL
+pwr_rcvd_awake_bcns_cnt_read_fndecl_27723_fns pwr_rcvd_awake_bcns_cnt_read fndecl 3 27723 NULL
+xstate_size__fpx_sw_bytes_27731_fns xstate_size _fpx_sw_bytes 0 27731 NULL
+si_blocks_ocfs2_slot_info_27753_fns si_blocks ocfs2_slot_info 0 27753 NULL
+sel_read_class_fndecl_27758_fns sel_read_class fndecl 3 27758 NULL
+dwc3_link_state_write_fndecl_27762_fns dwc3_link_state_write fndecl 3 27762 NULL
+rtw_android_get_link_speed_fndecl_27772_fns rtw_android_get_link_speed fndecl 0 27772 NULL
+raid_disks_pool_info_27784_fns raid_disks pool_info 0 27784 NULL
+nr_ports_solos_card_27804_fns nr_ports solos_card 0 27804 NULL
+iwl_dbgfs_calib_disabled_write_fndecl_27824_fns iwl_dbgfs_calib_disabled_write fndecl 3 27824 NULL
+roundup_brcmf_sdio_27833_fns roundup brcmf_sdio 0 27833 NULL
+ieee80211_if_read_num_buffered_multicast_fndecl_27839_fns ieee80211_if_read_num_buffered_multicast fndecl 3 27839 NULL
+ieee80211_if_read_dot11MeshMaxRetries_fndecl_27847_fns ieee80211_if_read_dot11MeshMaxRetries fndecl 3 27847 NULL
+traceSMB_proc_write_fndecl_27848_fns traceSMB_proc_write fndecl 3 27848 NULL
+key_rx_spec_read_fndecl_27859_fns key_rx_spec_read fndecl 3 27859 NULL
+listxattr_fndecl_27890_fns listxattr fndecl 3 27890 NULL
+lbq_len_rx_ring_27913_fns lbq_len rx_ring 0 27913 NULL
+il_dbgfs_nvm_read_fndecl_27923_fns il_dbgfs_nvm_read fndecl 3 27923 NULL
+usbat_hp8200e_rw_block_test_fndecl_27957_fns usbat_hp8200e_rw_block_test fndecl 5-13 27957 NULL
+pcbit_writecmd_fndecl_27967_fns pcbit_writecmd fndecl 2 27967 NULL
+parser_init_byte_stream_fndecl_27973_fns parser_init_byte_stream fndecl 2 27973 NULL
+mptctl_ioctl_fndecl_27984_fns mptctl_ioctl fndecl 2 27984 NULL
+__nf_ct_ext_add_length_fndecl_27999_fns __nf_ct_ext_add_length fndecl 3 27999 NULL
+scif_recv_fndecl_28006_fns scif_recv fndecl 3 28006 NULL
+xfs_iext_inline_to_direct_fndecl_28019_fns xfs_iext_inline_to_direct fndecl 2 28019 NULL
+write_file_dump_fndecl_28020_fns write_file_dump fndecl 3 28020 NULL nohasharray
+populate_dir_fndecl_28020_fns populate_dir fndecl 0 28020 &write_file_dump_fndecl_28020_fns
+evtchn_alloc_ring_fndecl_28034_fns evtchn_alloc_ring fndecl 1 28034 NULL
+cfs_array_alloc_fndecl_28042_fns cfs_array_alloc fndecl 2 28042 NULL
+ieee80211_if_read_num_mcast_sta_fndecl_28048_fns ieee80211_if_read_num_mcast_sta fndecl 3 28048 NULL
+s_imap_blocks_minix_sb_info_28062_fns s_imap_blocks minix_sb_info 0 28062 NULL
+_mv88e6xxx_port_fdb_load_fndecl_28093_fns _mv88e6xxx_port_fdb_load fndecl 4 28093 NULL
+fnic_trace_ctrl_read_fndecl_28098_fns fnic_trace_ctrl_read fndecl 3 28098 NULL
+stream_next_buffer_check_queue_fndecl_28114_fns stream_next_buffer_check_queue fndecl 0 28114 NULL
+cfg80211_disconnected_fndecl_28155_fns cfg80211_disconnected fndecl 4 28155 NULL
+read_file_tpc_fndecl_28162_fns read_file_tpc fndecl 3 28162 NULL
+__dn_setsockopt_fndecl_28183_fns __dn_setsockopt fndecl 5 28183 NULL
+ttm_dma_pool_alloc_new_pages_fndecl_28194_fns ttm_dma_pool_alloc_new_pages fndecl 3 28194 NULL
+snd_rme96_playback_copy_fndecl_28196_fns snd_rme96_playback_copy fndecl 5 28196 NULL
+bfad_debugfs_read_fndecl_28204_fns bfad_debugfs_read fndecl 3 28204 NULL
+xattr_getsecurity_fndecl_28209_fns xattr_getsecurity fndecl 0 28209 NULL
+wil_seq_hexdump_fndecl_28225_fns wil_seq_hexdump fndecl 3 28225 NULL
+pwr_disable_ps_read_fndecl_28267_fns pwr_disable_ps_read fndecl 3 28267 NULL
+pbdma_nr_gk104_fifo_28278_fns pbdma_nr gk104_fifo 0 28278 NULL
+mmc_ext_csd_read_fndecl_28294_fns mmc_ext_csd_read fndecl 3 28294 NULL
+create_trace_uprobe_fndecl_28307_fns create_trace_uprobe fndecl 1 28307 NULL
+xhci_segment_alloc_fndecl_28310_fns xhci_segment_alloc fndecl 3 28310 NULL
+comedi_read_fndecl_28316_fns comedi_read fndecl 3 28316 NULL
+set_video_mode_Kiara_fndecl_28325_fns set_video_mode_Kiara fndecl 4 28325 NULL
+_iwl_dbgfs_disable_power_off_write_fndecl_28328_fns _iwl_dbgfs_disable_power_off_write fndecl 3 28328 NULL
+mwifiex_debug_mask_read_fndecl_28341_fns mwifiex_debug_mask_read fndecl 3 28341 NULL
+fnic_trace_ctrl_write_fndecl_28350_fns fnic_trace_ctrl_write fndecl 3 28350 NULL
+j_blocksize_journal_s_28358_fns j_blocksize journal_s 0 28358 NULL
+dma_lch_count_vardecl_dma_c_28369_fns dma_lch_count vardecl_dma.c 0 28369 NULL
+init_tid_tabs_fndecl_28375_fns init_tid_tabs fndecl 4-3-2 28375 NULL nohasharray
+usbat_multiple_write_fndecl_28375_fns usbat_multiple_write fndecl 4 28375 &init_tid_tabs_fndecl_28375_fns
+bio_integrity_trim_fndecl_28376_fns bio_integrity_trim fndecl 2-3 28376 NULL
+simple_attr_write_fndecl_28383_fns simple_attr_write fndecl 3 28383 NULL
+__bpf_fill_ja_fndecl_28393_fns __bpf_fill_ja fndecl 2 28393 NULL
+lpfc_idiag_mbxacc_get_setup_fndecl_28401_fns lpfc_idiag_mbxacc_get_setup fndecl 0 28401 NULL
+il4965_stats_flag_fndecl_28402_fns il4965_stats_flag fndecl 0 28402 NULL
+sd_major_fndecl_28413_fns sd_major fndecl 1-0 28413 NULL
+__inet_insert_ifa_fndecl_28418_fns __inet_insert_ifa fndecl 0 28418 NULL nohasharray
+xfs_inumbers_fmt_fndecl_28418_fns xfs_inumbers_fmt fndecl 3 28418 &__inet_insert_ifa_fndecl_28418_fns
+hpi_init_messageV1_fndecl_28435_fns hpi_init_messageV1 fndecl 2 28435 NULL
+stripe_size_bcache_device_28454_fns stripe_size bcache_device 0 28454 NULL
+data_out_size_mpt3_ioctl_command_28472_fns data_out_size mpt3_ioctl_command 0 28472 NULL
+spidev_ioctl_fndecl_28477_fns spidev_ioctl fndecl 2 28477 NULL
+csa_nrclists_cb_sequenceargs_28491_fns csa_nrclists cb_sequenceargs 0 28491 NULL
+get_leb_cnt_fndecl_28495_fns get_leb_cnt fndecl 0-2 28495 NULL
+num_vmdq_msix_i40e_pf_28501_fns num_vmdq_msix i40e_pf 0 28501 NULL
+rds_pages_in_vec_fndecl_28521_fns rds_pages_in_vec fndecl 0 28521 NULL
+get_virtual_node_size_fndecl_28543_fns get_virtual_node_size fndecl 0 28543 NULL
+mlx5_cmd_fc_bulk_alloc_fndecl_28547_fns mlx5_cmd_fc_bulk_alloc fndecl 3 28547 NULL
+mwifiex_send_delba_fndecl_28557_fns mwifiex_send_delba fndecl 2 28557 NULL
+wil_write_back_fndecl_28568_fns wil_write_back fndecl 3 28568 NULL
+nvme_npages_fndecl_28569_fns nvme_npages fndecl 0-1 28569 NULL
+ufx_i2c_wait_busy_fndecl_28574_fns ufx_i2c_wait_busy fndecl 0 28574 NULL
+_iwl_dbgfs_ss_force_write_fndecl_28587_fns _iwl_dbgfs_ss_force_write fndecl 3 28587 NULL
+i915_gem_gtt_pread_fndecl_28595_fns i915_gem_gtt_pread fndecl 3-4 28595 NULL
+tmc_read_fndecl_28597_fns tmc_read fndecl 3 28597 NULL
+bm_status_write_fndecl_28599_fns bm_status_write fndecl 3 28599 NULL nohasharray
+menu_count_uvc_xu_control_mapping_28599_fns menu_count uvc_xu_control_mapping 0 28599 &bm_status_write_fndecl_28599_fns
+hfi1_rcvarr_split_vardecl_init_c_28624_fns hfi1_rcvarr_split vardecl_init.c 0 28624 NULL nohasharray
+mgmt_get_if_info_fndecl_28624_fns mgmt_get_if_info fndecl 0 28624 &hfi1_rcvarr_split_vardecl_init_c_28624_fns
+_get_block_create_0_fndecl_28632_fns _get_block_create_0 fndecl 2 28632 NULL
+alloc_size_chunk_28657_fns alloc_size chunk 0 28657 NULL
+offset_cache_reader_28697_fns offset cache_reader 0 28697 NULL
+lpfc_idiag_ctlacc_write_fndecl_28715_fns lpfc_idiag_ctlacc_write fndecl 3 28715 NULL
+oprofilefs_ulong_to_user_fndecl_28717_fns oprofilefs_ulong_to_user fndecl 3 28717 NULL
+note_last_dentry_fndecl_28724_fns note_last_dentry fndecl 3 28724 NULL nohasharray
+d40_prep_memcpy_fndecl_28724_fns d40_prep_memcpy fndecl 4 28724 &note_last_dentry_fndecl_28724_fns
+skb_cow_data_fndecl_28734_fns skb_cow_data fndecl 0 28734 NULL
+size_mspro_sys_attr_28742_fns size mspro_sys_attr 0 28742 NULL
+batadv_iv_ogm_orig_del_if_fndecl_28743_fns batadv_iv_ogm_orig_del_if fndecl 2 28743 NULL
+batadv_iv_ogm_orig_add_if_fndecl_28753_fns batadv_iv_ogm_orig_add_if fndecl 2 28753 NULL
+fw_device_op_ioctl_fndecl_28760_fns fw_device_op_ioctl fndecl 2 28760 NULL
+snic_print_desc_fndecl_28784_fns snic_print_desc fndecl 3 28784 NULL
+C_SYSC_migrate_pages_fndecl_28785_fns C_SYSC_migrate_pages fndecl 2 28785 NULL
+fill_swm_input_fndecl_28799_fns fill_swm_input fndecl 0 28799 NULL
+brcmf_fil_bsscfg_data_set_fndecl_28806_fns brcmf_fil_bsscfg_data_set fndecl 4 28806 NULL
+sisusb_send_bridge_packet_fndecl_28818_fns sisusb_send_bridge_packet fndecl 2 28818 NULL
+split_fndecl_28856_fns split fndecl 2 28856 NULL
+snd_ctl_elem_user_tlv_fndecl_28860_fns snd_ctl_elem_user_tlv fndecl 3 28860 NULL
+br_fdb_update_fndecl_28873_fns br_fdb_update fndecl 4 28873 NULL
+TupleOffset_tuple_t_28876_fns TupleOffset tuple_t 0 28876 NULL
+flags_read_fndecl_28903_fns flags_read fndecl 3 28903 NULL
+ieee80211_get_num_supported_channels_fndecl_28907_fns ieee80211_get_num_supported_channels fndecl 0 28907 NULL
+iwl_dbgfs_qos_read_fndecl_28922_fns iwl_dbgfs_qos_read fndecl 3 28922 NULL
+ecdh_make_pub_key_fndecl_28927_fns ecdh_make_pub_key fndecl 2 28927 NULL
+wil_write_led_blink_time_fndecl_28933_fns wil_write_led_blink_time fndecl 3 28933 NULL
+usbat_write_block_fndecl_28938_fns usbat_write_block fndecl 4-6 28938 NULL
+ath6kl_power_params_write_fndecl_28953_fns ath6kl_power_params_write fndecl 3 28953 NULL
+iwl_dbgfs_ss_force_read_fndecl_28968_fns iwl_dbgfs_ss_force_read fndecl 3 28968 NULL
+sel_write_create_fndecl_29002_fns sel_write_create fndecl 3 29002 NULL
+__kfifo_out_peek_fndecl_29010_fns __kfifo_out_peek fndecl 0-3 29010 NULL nohasharray
+construct_key_fndecl_29010_fns construct_key fndecl 3 29010 &__kfifo_out_peek_fndecl_29010_fns
+seq_copy_in_user_fndecl_29019_fns seq_copy_in_user fndecl 3 29019 NULL
+max_physical_pkg_id_vardecl_smpboot_c_29028_fns max_physical_pkg_id vardecl_smpboot.c 0 29028 NULL
+drm_vblank_init_fndecl_29041_fns drm_vblank_init fndecl 2 29041 NULL
+of_get_available_child_count_fndecl_29042_fns of_get_available_child_count fndecl 0 29042 NULL
+devm_mfd_add_devices_fndecl_29043_fns devm_mfd_add_devices fndecl 4 29043 NULL
+qib_get_base_info_fndecl_29050_fns qib_get_base_info fndecl 3 29050 NULL
+str_to_user_fndecl_29056_fns str_to_user fndecl 2 29056 NULL
+___alloc_bootmem_fndecl_29057_fns ___alloc_bootmem fndecl 1 29057 NULL
+adis16480_show_firmware_revision_fndecl_29066_fns adis16480_show_firmware_revision fndecl 3 29066 NULL
+i40e_dbg_command_write_fndecl_29070_fns i40e_dbg_command_write fndecl 3 29070 NULL
+dev_irnet_write_fndecl_29077_fns dev_irnet_write fndecl 3 29077 NULL
+ablkcipher_edesc_alloc_fndecl_29119_fns ablkcipher_edesc_alloc fndecl 2 29119 NULL
+pci_set_power_state_fndecl_29124_fns pci_set_power_state fndecl 0 29124 NULL nohasharray
+sca3000_read_first_n_hw_rb_fndecl_29124_fns sca3000_read_first_n_hw_rb fndecl 2 29124 &pci_set_power_state_fndecl_29124_fns
+tool_peer_mw_write_fndecl_29137_fns tool_peer_mw_write fndecl 3 29137 NULL
+max_dump_cnt_ramoops_context_29141_fns max_dump_cnt ramoops_context 0 29141 NULL
+kmem_zalloc_fndecl_29157_fns kmem_zalloc fndecl 1 29157 NULL
+current_rx_bytes_printer_dev_29165_fns current_rx_bytes printer_dev 0 29165 NULL
+dwc2_hsotg_send_reply_fndecl_29174_fns dwc2_hsotg_send_reply fndecl 4 29174 NULL
+vp_try_to_find_vqs_fndecl_29181_fns vp_try_to_find_vqs fndecl 2 29181 NULL
+ieee80211_if_read_user_power_level_fndecl_29185_fns ieee80211_if_read_user_power_level fndecl 3 29185 NULL
+brcmf_config_wowl_pattern_fndecl_29198_fns brcmf_config_wowl_pattern fndecl 4 29198 NULL
+notifier_call_chain_fndecl_29207_fns notifier_call_chain fndecl 0 29207 NULL
+dvb_dmxdev_buffer_write_fndecl_29234_fns dvb_dmxdev_buffer_write fndecl 0 29234 NULL
+il4965_ucode_tx_stats_read_fndecl_29235_fns il4965_ucode_tx_stats_read fndecl 3 29235 NULL
+ptc_proc_write_fndecl_29247_fns ptc_proc_write fndecl 3 29247 NULL
+rtw_malloc2d_fndecl_29269_fns rtw_malloc2d fndecl 3-2-1 29269 NULL
+ib_uverbs_open_xrcd_fndecl_29276_fns ib_uverbs_open_xrcd fndecl 4-5 29276 NULL
+vmbus_open_fndecl_29289_fns vmbus_open fndecl 3-2 29289 NULL
+_iwl_dbgfs_tof_range_req_ext_write_fndecl_29290_fns _iwl_dbgfs_tof_range_req_ext_write fndecl 3 29290 NULL
+btmrvl_sdio_host_to_card_fndecl_29291_fns btmrvl_sdio_host_to_card fndecl 3 29291 NULL
+msg_size_adf_etr_ring_data_29295_fns msg_size adf_etr_ring_data 0 29295 NULL
+xfs_handle_to_dentry_fndecl_29300_fns xfs_handle_to_dentry fndecl 3 29300 NULL
+rawv6_seticmpfilter_fndecl_29306_fns rawv6_seticmpfilter fndecl 5 29306 NULL
+fnic_reset_stats_write_fndecl_29314_fns fnic_reset_stats_write fndecl 3 29314 NULL
+total_size_orangefs_bufmap_29333_fns total_size orangefs_bufmap 0 29333 NULL nohasharray
+num_sge_ib_recv_wr_29333_fns num_sge ib_recv_wr 0 29333 &total_size_orangefs_bufmap_29333_fns
+fuse_get_req_fndecl_29358_fns fuse_get_req fndecl 2 29358 NULL nohasharray
+aat2870_reg_read_file_fndecl_29358_fns aat2870_reg_read_file fndecl 3 29358 &fuse_get_req_fndecl_29358_fns
+tx_ring_size_pxa168_eth_private_29372_fns tx_ring_size pxa168_eth_private 0 29372 NULL
+ib_uverbs_unmarshall_recv_fndecl_29384_fns ib_uverbs_unmarshall_recv fndecl 5 29384 NULL
+__alloc_bootmem_low_nopanic_fndecl_29400_fns __alloc_bootmem_low_nopanic fndecl 1 29400 NULL nohasharray
+octeon_alloc_recv_info_fndecl_29400_fns octeon_alloc_recv_info fndecl 1 29400 &__alloc_bootmem_low_nopanic_fndecl_29400_fns
+rts51x_read_status_fndecl_29477_fns rts51x_read_status fndecl 4 29477 NULL
+sctp_setsockopt_maxseg_fndecl_29478_fns sctp_setsockopt_maxseg fndecl 3 29478 NULL
+nf_nat_sdp_media_fndecl_29508_fns nf_nat_sdp_media fndecl 9 29508 NULL
+ecryptfs_copy_filename_fndecl_29519_fns ecryptfs_copy_filename fndecl 4 29519 NULL
+unix_stream_connect_fndecl_29527_fns unix_stream_connect fndecl 3 29527 NULL
+nvbios_rd16_fndecl_29576_fns nvbios_rd16 fndecl 0 29576 NULL
+xstateregs_get_fndecl_29585_fns xstateregs_get fndecl 4 29585 NULL
+rxe_pool_init_index_fndecl_29612_fns rxe_pool_init_index fndecl 2-3 29612 NULL
+nicvf_init_snd_queue_fndecl_29640_fns nicvf_init_snd_queue fndecl 3 29640 NULL
+acpi_rs_set_resource_header_fndecl_29642_fns acpi_rs_set_resource_header fndecl 2 29642 NULL
+er_extcount_xfs_ext_irec_29646_fns er_extcount xfs_ext_irec 0 29646 NULL
+control_read_fndecl_29649_fns control_read fndecl 6 29649 NULL
+count_vfio_pci_hot_reset_info_29655_fns count vfio_pci_hot_reset_info 0 29655 NULL
+split_node_fndecl_29659_fns split_node fndecl 0 29659 NULL nohasharray
+ls_num_lprocfs_stats_29659_fns ls_num lprocfs_stats 0 29659 &split_node_fndecl_29659_fns
+i40e_pci_sriov_configure_fndecl_29688_fns i40e_pci_sriov_configure fndecl 2 29688 NULL
+rds_message_alloc_fndecl_29702_fns rds_message_alloc fndecl 1 29702 NULL
+get_vm_area_caller_fndecl_29708_fns get_vm_area_caller fndecl 1 29708 NULL
+maxframe_vardecl_n_hdlc_c_29719_fns maxframe vardecl_n_hdlc.c 0 29719 NULL
+pipeline_defrag_to_rx_xfer_swi_read_fndecl_29788_fns pipeline_defrag_to_rx_xfer_swi_read fndecl 3 29788 NULL
+supply_map_read_file_fndecl_29795_fns supply_map_read_file fndecl 3 29795 NULL
+ima_show_htable_violations_fndecl_29800_fns ima_show_htable_violations fndecl 3 29800 NULL
+otp_read_fndecl_29809_fns otp_read fndecl 2-4-5 29809 NULL nohasharray
+vbe_state_size_uvesafb_par_29809_fns vbe_state_size uvesafb_par 0 29809 &otp_read_fndecl_29809_fns
+si_lasti_bfs_sb_info_29842_fns si_lasti bfs_sb_info 0 29842 NULL
+len_ethtool_dump_29843_fns len ethtool_dump 0 29843 NULL
+fq_alloc_node_fndecl_29850_fns fq_alloc_node fndecl 1 29850 NULL
+nd_cmd_out_size_fndecl_29867_fns nd_cmd_out_size fndecl 0-7 29867 NULL
+nfs_idmap_lookup_id_fndecl_29879_fns nfs_idmap_lookup_id fndecl 2 29879 NULL
+parport_write_fndecl_29886_fns parport_write fndecl 0 29886 NULL
+length_ndis_80211_pmkid_29893_fns length ndis_80211_pmkid 0 29893 NULL
+PageLength__CONFIG_PAGE_HEADER_29916_fns PageLength _CONFIG_PAGE_HEADER 0 29916 NULL
+error_error_frame_ctrl_read_fndecl_29919_fns error_error_frame_ctrl_read fndecl 3 29919 NULL
+sctp_getsockopt_maxseg_fndecl_29922_fns sctp_getsockopt_maxseg fndecl 2 29922 NULL
+sys_syslog_fndecl_29929_fns sys_syslog fndecl 3 29929 NULL
+msi_setup_entry_fndecl_29969_fns msi_setup_entry fndecl 2 29969 NULL
+iwl_dbgfs_tof_enable_read_fndecl_30005_fns iwl_dbgfs_tof_enable_read fndecl 3 30005 NULL
+msc_nfinalizers_lnet_msg_container_30006_fns msc_nfinalizers lnet_msg_container 0 30006 NULL
+__qlcnic_pci_sriov_enable_fndecl_30010_fns __qlcnic_pci_sriov_enable fndecl 2 30010 NULL
+snd_rme9652_capture_copy_fndecl_30012_fns snd_rme9652_capture_copy fndecl 5 30012 NULL
+read_file_spectral_count_fndecl_30019_fns read_file_spectral_count fndecl 3 30019 NULL
+mlx5e_setup_tc_fndecl_30023_fns mlx5e_setup_tc fndecl 2 30023 NULL
+read_emulate_fndecl_30037_fns read_emulate fndecl 2-4 30037 NULL
+ath6kl_listen_int_read_fndecl_30048_fns ath6kl_listen_int_read fndecl 3 30048 NULL
+sta_ht_capa_read_fndecl_30061_fns sta_ht_capa_read fndecl 3 30061 NULL
+do_compat_pselect_fndecl_30093_fns do_compat_pselect fndecl 1 30093 NULL
+ecryptfs_decode_and_decrypt_filename_fndecl_30104_fns ecryptfs_decode_and_decrypt_filename fndecl 5 30104 NULL
+if_real_bytes_xfs_ifork_30126_fns if_real_bytes xfs_ifork 0 30126 NULL
+ath10k_write_btcoex_fndecl_30144_fns ath10k_write_btcoex fndecl 3 30144 NULL
+num_tx_queues_ixgbevf_adapter_30155_fns num_tx_queues ixgbevf_adapter 0 30155 NULL
+send_section_size_netvsc_device_30166_fns send_section_size netvsc_device 0 30166 NULL
+rx_ring_size_pxa168_eth_private_30172_fns rx_ring_size pxa168_eth_private 0 30172 NULL
+event_phy_transmit_error_read_fndecl_30196_fns event_phy_transmit_error_read fndecl 3 30196 NULL
+buf_len_uvesafb_task_30200_fns buf_len uvesafb_task 0 30200 NULL
+hrp_nthrs_ptlrpc_hr_partition_30214_fns hrp_nthrs ptlrpc_hr_partition 0 30214 NULL
+minor_rbd_device_30216_fns minor rbd_device 0 30216 NULL
+__add_keyed_refs_fndecl_30230_fns __add_keyed_refs fndecl 3 30230 NULL
+tda10048_writeregbulk_fndecl_30265_fns tda10048_writeregbulk fndecl 4 30265 NULL
+count_argc_fndecl_30296_fns count_argc fndecl 0 30296 NULL
+alloc_alien_cache_fndecl_30308_fns alloc_alien_cache fndecl 2 30308 NULL
+tracing_buffers_read_fndecl_30311_fns tracing_buffers_read fndecl 3 30311 NULL
+kvm_write_guest_cached_fndecl_30321_fns kvm_write_guest_cached fndecl 4 30321 NULL
+avc_stream_set_format_fndecl_30322_fns avc_stream_set_format fndecl 5 30322 NULL
+tc90522_master_xfer_fndecl_30332_fns tc90522_master_xfer fndecl 3 30332 NULL
+nr_ops_rdma_rw_ctx_30338_fns nr_ops rdma_rw_ctx 0 30338 NULL
+len_snd_seq_ev_ext_30374_fns len snd_seq_ev_ext 0 30374 NULL
+il_dbgfs_rx_queue_read_fndecl_30406_fns il_dbgfs_rx_queue_read fndecl 3 30406 NULL
+nvec_used_msi_desc_30409_fns nvec_used msi_desc 0 30409 NULL
+get_pages_vram_fndecl_30416_fns get_pages_vram fndecl 2 30416 NULL
+decode_opaque_fixed_fndecl_30421_fns decode_opaque_fixed fndecl 3 30421 NULL
+of_irq_count_fndecl_30438_fns of_irq_count fndecl 0 30438 NULL
+comedi_alloc_spriv_fndecl_30449_fns comedi_alloc_spriv fndecl 2 30449 NULL
+rd_build_prot_space_fndecl_30490_fns rd_build_prot_space fndecl 2-3 30490 NULL
+vhost_add_used_n_fndecl_30491_fns vhost_add_used_n fndecl 3 30491 NULL
+kvm_read_guest_atomic_fndecl_30494_fns kvm_read_guest_atomic fndecl 4-2 30494 NULL
+ttm_dma_page_pool_free_fndecl_30527_fns ttm_dma_page_pool_free fndecl 2 30527 NULL
+wMaxCommand_wdm_device_30565_fns wMaxCommand wdm_device 0 30565 NULL
+wil_read_led_blink_time_fndecl_30567_fns wil_read_led_blink_time fndecl 3 30567 NULL
+snd_pcm_oss_write1_fndecl_30571_fns snd_pcm_oss_write1 fndecl 3 30571 NULL
+wiidebug_drm_write_fndecl_30572_fns wiidebug_drm_write fndecl 3 30572 NULL
+mbox_test_message_read_fndecl_30588_fns mbox_test_message_read fndecl 3 30588 NULL
+get_scq_fndecl_30594_fns get_scq fndecl 2 30594 NULL
+tifm_alloc_adapter_fndecl_30596_fns tifm_alloc_adapter fndecl 1 30596 NULL
+kobject_add_fndecl_30644_fns kobject_add fndecl 0 30644 NULL
+ci_port_test_write_fndecl_30657_fns ci_port_test_write fndecl 3 30657 NULL
+xfrm_hash_alloc_fndecl_30694_fns xfrm_hash_alloc fndecl 1 30694 NULL
+rx_filter_accum_arp_pend_requests_read_fndecl_30696_fns rx_filter_accum_arp_pend_requests_read fndecl 3 30696 NULL
+bm_entry_read_fndecl_30707_fns bm_entry_read fndecl 3 30707 NULL
+sched_autogroup_write_fndecl_30715_fns sched_autogroup_write fndecl 3 30715 NULL
+__alloc_preds_fndecl_30727_fns __alloc_preds fndecl 2 30727 NULL
+mlx5_wq_cyc_get_size_fndecl_30741_fns mlx5_wq_cyc_get_size fndecl 0 30741 NULL
+iwl_dbgfs_fw_dbg_conf_read_fndecl_30753_fns iwl_dbgfs_fw_dbg_conf_read fndecl 3 30753 NULL
+command_setvloffset_fndecl_30761_fns command_setvloffset fndecl 0 30761 NULL
+lp_write_fndecl_30772_fns lp_write fndecl 3 30772 NULL
+ocrdma_alloc_mr_fndecl_30774_fns ocrdma_alloc_mr fndecl 3 30774 NULL
+inj_readme_read_fndecl_30779_fns inj_readme_read fndecl 3 30779 NULL
+fw_node_create_fndecl_30788_fns fw_node_create fndecl 2 30788 NULL
+kobj_map_fndecl_30797_fns kobj_map fndecl 3-2 30797 NULL nohasharray
+ogm_buff_len_batadv_priv_bat_v_30797_fns ogm_buff_len batadv_priv_bat_v 0 30797 &kobj_map_fndecl_30797_fns
+iwl_dbgfs_bf_params_read_fndecl_30805_fns iwl_dbgfs_bf_params_read fndecl 3 30805 NULL
+il_dbgfs_missed_beacon_write_fndecl_30809_fns il_dbgfs_missed_beacon_write fndecl 3 30809 NULL
+shadow_root_level_kvm_mmu_30842_fns shadow_root_level kvm_mmu 0 30842 NULL
+saa7164_buffer_alloc_user_fndecl_30856_fns saa7164_buffer_alloc_user fndecl 2 30856 NULL
+lov_ost_pool_add_fndecl_30857_fns lov_ost_pool_add fndecl 3 30857 NULL
+snd_emu10k1_fx8010_read_fndecl_30870_fns snd_emu10k1_fx8010_read fndecl 5 30870 NULL
+do_sync_fndecl_30871_fns do_sync fndecl 1 30871 NULL
+ceph_copy_user_to_page_vector_fndecl_30896_fns ceph_copy_user_to_page_vector fndecl 3-4 30896 NULL
+__erst_read_from_storage_fndecl_30921_fns __erst_read_from_storage fndecl 0 30921 NULL
+cpci_hp_register_bus_fndecl_30935_fns cpci_hp_register_bus fndecl 2 30935 NULL
+dns_query_fndecl_30943_fns dns_query fndecl 3 30943 NULL
+parse_uac2_sample_rate_range_fndecl_30949_fns parse_uac2_sample_rate_range fndecl 0 30949 NULL
+SYSC_ppoll_fndecl_30954_fns SYSC_ppoll fndecl 2 30954 NULL
+lowpan_control_write_fndecl_30960_fns lowpan_control_write fndecl 3 30960 NULL
+__list_lru_count_one_fndecl_30962_fns __list_lru_count_one fndecl 0 30962 NULL
+ieee80211_if_read_aid_fndecl_30970_fns ieee80211_if_read_aid fndecl 3 30970 NULL
+tx_tx_prepared_descs_read_fndecl_30998_fns tx_tx_prepared_descs_read fndecl 3 30998 NULL
+btrfs_search_slot_fndecl_31011_fns btrfs_search_slot fndecl 0 31011 NULL
+max_order_mthca_buddy_31017_fns max_order mthca_buddy 0 31017 NULL
+internal_depth_MPT3SAS_ADAPTER_31035_fns internal_depth MPT3SAS_ADAPTER 0 31035 NULL
+hisi_clk_init_fndecl_31037_fns hisi_clk_init fndecl 2 31037 NULL
+krb5_nfold_fndecl_31038_fns krb5_nfold fndecl 1-3 31038 NULL
+iwl_dbgfs_stations_read_fndecl_31054_fns iwl_dbgfs_stations_read fndecl 3 31054 NULL nohasharray
+samsung_clk_alloc_reg_dump_fndecl_31054_fns samsung_clk_alloc_reg_dump fndecl 2 31054 &iwl_dbgfs_stations_read_fndecl_31054_fns
+le_max_key_size_write_fndecl_31068_fns le_max_key_size_write fndecl 3 31068 NULL
+get_pipes_num_fndecl_31084_fns get_pipes_num fndecl 0 31084 NULL
+nvme_trans_fmt_get_parm_header_fndecl_31087_fns nvme_trans_fmt_get_parm_header fndecl 2 31087 NULL
+name_len_inotify_event_info_31116_fns name_len inotify_event_info 0 31116 NULL
+reiserfs_write_end_fndecl_31117_fns reiserfs_write_end fndecl 5-3 31117 NULL
+dbgfs_sram_len_iwl_priv_31119_fns dbgfs_sram_len iwl_priv 0 31119 NULL
+nr_chips_dsa_platform_data_31127_fns nr_chips dsa_platform_data 0 31127 NULL
+read_fndecl_31142_fns read fndecl 3 31142 NULL
+size_stp_policy_id_31167_fns size stp_policy_id 0 31167 NULL
+bm_realloc_pages_fndecl_31172_fns bm_realloc_pages fndecl 2 31172 NULL
+ffs_ep0_write_fndecl_31181_fns ffs_ep0_write fndecl 3 31181 NULL
+op_size_ost_pool_31182_fns op_size ost_pool 0 31182 NULL
+nf_nat_sip_expect_fndecl_31193_fns nf_nat_sip_expect fndecl 8 31193 NULL
+agp_generic_alloc_user_fndecl_31213_fns agp_generic_alloc_user fndecl 1 31213 NULL nohasharray
+get_registers_fndecl_31213_fns get_registers fndecl 4 31213 &agp_generic_alloc_user_fndecl_31213_fns
+iwch_alloc_mr_fndecl_31220_fns iwch_alloc_mr fndecl 3 31220 NULL
+kmalloc_array_fndecl_31223_fns kmalloc_array fndecl 1-2 31223 NULL
+SYSC_move_pages_fndecl_31249_fns SYSC_move_pages fndecl 2 31249 NULL
+ath10k_tpc_stats_read_fndecl_31267_fns ath10k_tpc_stats_read fndecl 3 31267 NULL
+aat2870_dump_reg_fndecl_31280_fns aat2870_dump_reg fndecl 0 31280 NULL
+igb_enable_sriov_fndecl_31288_fns igb_enable_sriov fndecl 2 31288 NULL
+asymmetric_key_generate_id_fndecl_31299_fns asymmetric_key_generate_id fndecl 4-2 31299 NULL
+get_elem_size_fndecl_31341_fns get_elem_size fndecl 2-0 31341 NULL
+__virtio_clear_bit_fndecl_31359_fns __virtio_clear_bit fndecl 2 31359 NULL
+wilc_scan_fndecl_31368_fns wilc_scan fndecl 5-7 31368 NULL
+dev_get_valid_name_fndecl_31369_fns dev_get_valid_name fndecl 0 31369 NULL
+brcmf_msgbuf_init_pktids_fndecl_31395_fns brcmf_msgbuf_init_pktids fndecl 1 31395 NULL
+asd_store_update_bios_fndecl_31398_fns asd_store_update_bios fndecl 4 31398 NULL
+persistent_ram_vmap_fndecl_31402_fns persistent_ram_vmap fndecl 1-2 31402 NULL
+proc_pid_attr_read_fndecl_31406_fns proc_pid_attr_read fndecl 3 31406 NULL
+zone_count_msb_data_31413_fns zone_count msb_data 0 31413 NULL
+rx_out_of_mem_read_fndecl_31422_fns rx_out_of_mem_read fndecl 3 31422 NULL
+__check_eq_u32_array_fndecl_31439_fns __check_eq_u32_array fndecl 4-6 31439 NULL
+lkdtm_debugfs_entry_fndecl_31452_fns lkdtm_debugfs_entry fndecl 3 31452 NULL
+max_sz_mmc_test_area_31453_fns max_sz mmc_test_area 0 31453 NULL
+nr_voices_seq_oss_synthinfo_31487_fns nr_voices seq_oss_synthinfo 0 31487 NULL
+regmap_multi_reg_write_bypassed_fndecl_31492_fns regmap_multi_reg_write_bypassed fndecl 3 31492 NULL
+start_genius_videocam_live_fndecl_31552_fns start_genius_videocam_live fndecl 0 31552 NULL
+ieee80211_if_read_state_fndecl_31558_fns ieee80211_if_read_state fndecl 3 31558 NULL
+bio_alloc_map_data_fndecl_31573_fns bio_alloc_map_data fndecl 1 31573 NULL
+vmcb_nested_state_31575_fns vmcb nested_state 0 31575 NULL
+ib_uverbs_resize_cq_fndecl_31583_fns ib_uverbs_resize_cq fndecl 4-5 31583 NULL
+compute_real_fndecl_31605_fns compute_real fndecl 1-0 31605 NULL
+wil_read_file_ioblob_fndecl_31621_fns wil_read_file_ioblob fndecl 3 31621 NULL
+ping_v4_sendmsg_fndecl_31624_fns ping_v4_sendmsg fndecl 3 31624 NULL
+pmcraid_alloc_sglist_fndecl_31643_fns pmcraid_alloc_sglist fndecl 1 31643 NULL
+cntrnameslen_hfi1_devdata_31650_fns cntrnameslen hfi1_devdata 0 31650 NULL
+nonpaging_page_fault_fndecl_31655_fns nonpaging_page_fault fndecl 2 31655 NULL
+snd_midi_event_new_fndecl_31670_fns snd_midi_event_new fndecl 1 31670 NULL nohasharray
+bm_register_write_fndecl_31670_fns bm_register_write fndecl 3 31670 &snd_midi_event_new_fndecl_31670_fns
+read_file_misc_fndecl_31695_fns read_file_misc fndecl 3 31695 NULL
+iwl_dbgfs_prph_reg_read_fndecl_31707_fns iwl_dbgfs_prph_reg_read fndecl 3 31707 NULL
+transport_len_sockaddr_rxrpc_31772_fns transport_len sockaddr_rxrpc 0 31772 NULL
+i40e_init_msix_fndecl_31776_fns i40e_init_msix fndecl 0 31776 NULL
+fore200e_chunk_alloc_fndecl_31782_fns fore200e_chunk_alloc fndecl 3-4 31782 NULL
+dev_config_fndecl_31785_fns dev_config fndecl 3 31785 NULL
+afs_cell_lookup_fndecl_31793_fns afs_cell_lookup fndecl 2 31793 NULL
+target_submit_cmd_map_sgls_fndecl_31806_fns target_submit_cmd_map_sgls fndecl 11 31806 NULL
+snd_malloc_sgbuf_pages_fndecl_31815_fns snd_malloc_sgbuf_pages fndecl 2 31815 NULL
+needed_size_conf_writedata_31827_fns needed_size conf_writedata 0 31827 NULL
+mpls_rt_alloc_fndecl_31835_fns mpls_rt_alloc fndecl 1-2 31835 NULL
+cache_slow_downcall_fndecl_31849_fns cache_slow_downcall fndecl 2 31849 NULL
+isr_dma0_done_read_fndecl_31853_fns isr_dma0_done_read fndecl 3 31853 NULL
+profile_remove_fndecl_31871_fns profile_remove fndecl 3 31871 NULL
+tower_write_fndecl_31895_fns tower_write fndecl 3 31895 NULL
+max_packet_size_snd_line6_pcm_31899_fns max_packet_size snd_line6_pcm 0 31899 NULL
+it821x_firmware_command_fndecl_31911_fns it821x_firmware_command fndecl 3 31911 NULL
+scsi_dma_map_fndecl_31915_fns scsi_dma_map fndecl 0 31915 NULL
+mtu_gsm_mux_31917_fns mtu gsm_mux 0 31917 NULL
+cfs_cpt_number_fndecl_31929_fns cfs_cpt_number fndecl 0 31929 NULL
+mlx5_vzalloc_fndecl_31940_fns mlx5_vzalloc fndecl 1 31940 NULL
+init_header_fndecl_31980_fns init_header fndecl 0 31980 NULL
+arcfb_write_fndecl_31981_fns arcfb_write fndecl 3 31981 NULL
+record_size_ramoops_context_31989_fns record_size ramoops_context 0 31989 NULL nohasharray
+lbs_bcnmiss_read_fndecl_31989_fns lbs_bcnmiss_read fndecl 3 31989 &record_size_ramoops_context_31989_fns
+rproc_trace_read_fndecl_31997_fns rproc_trace_read fndecl 3 31997 NULL
+blocksize_sddr09_card_info_32003_fns blocksize sddr09_card_info 0 32003 NULL
+rt2x00debug_write_bbp_fndecl_32007_fns rt2x00debug_write_bbp fndecl 3 32007 NULL
+play_iframe_fndecl_32008_fns play_iframe fndecl 3 32008 NULL
+ad7879_spi_multi_read_fndecl_32009_fns ad7879_spi_multi_read fndecl 3 32009 NULL
+recent_mt_proc_write_fndecl_32029_fns recent_mt_proc_write fndecl 3 32029 NULL
+skl_tplg_tlv_control_get_fndecl_32038_fns skl_tplg_tlv_control_get fndecl 3 32038 NULL
+kvm_mmu_page_set_gfn_fndecl_32050_fns kvm_mmu_page_set_gfn fndecl 2 32050 NULL
+g_num_of_iommus_vardecl_intel_iommu_c_32059_fns g_num_of_iommus vardecl_intel-iommu.c 0 32059 NULL
+__jfs_xattr_set_fndecl_32062_fns __jfs_xattr_set fndecl 4 32062 NULL
+assoc_sta_del_all_sta_32069_fns assoc_sta del_all_sta 0 32069 NULL
+rproc_recovery_write_fndecl_32074_fns rproc_recovery_write fndecl 3 32074 NULL
+pci_scan_slot_fndecl_32102_fns pci_scan_slot fndecl 2 32102 NULL
+lpfc_debugfs_max_slow_ring_trc_vardecl_lpfc_debugfs_c_32130_fns lpfc_debugfs_max_slow_ring_trc vardecl_lpfc_debugfs.c 0 32130 NULL
+ipwireless_send_packet_fndecl_32155_fns ipwireless_send_packet fndecl 4 32155 NULL
+pwm_buf_sz_usbduxsigma_private_32156_fns pwm_buf_sz usbduxsigma_private 0 32156 NULL
+vmalloc_usercopy_fndecl_32186_fns vmalloc_usercopy fndecl 1 32186 NULL
+ioat_alloc_ring_fndecl_32201_fns ioat_alloc_ring fndecl 2 32201 NULL
+nr_spis_v2m_data_32203_fns nr_spis v2m_data 0 32203 NULL
+k_offset_in_core_key_32212_fns k_offset in_core_key 0 32212 NULL
+seq_hex_dump_fndecl_32213_fns seq_hex_dump fndecl 7-4-5 32213 NULL
+xdi_copy_from_user_fndecl_32216_fns xdi_copy_from_user fndecl 4 32216 NULL
+generic_bin_search_fndecl_32235_fns generic_bin_search fndecl 0 32235 NULL
+roccat_common2_sysfs_read_fndecl_32252_fns roccat_common2_sysfs_read fndecl 6 32252 NULL
+report_count_hid_global_32260_fns report_count hid_global 0 32260 NULL
+sony_register_touchpad_fndecl_32262_fns sony_register_touchpad fndecl 2 32262 NULL
+venus_mkdir_fndecl_32276_fns venus_mkdir fndecl 4 32276 NULL
+qib_qsfp_dump_fndecl_32277_fns qib_qsfp_dump fndecl 0 32277 NULL
+find_num_cache_leaves_fndecl_32280_fns find_num_cache_leaves fndecl 0 32280 NULL
+vol_cdev_read_fndecl_32283_fns vol_cdev_read fndecl 3 32283 NULL
+get_pipes_fndecl_32291_fns get_pipes fndecl 0 32291 NULL
+num_gpes_vardecl_sysfs_c_32294_fns num_gpes vardecl_sysfs.c 0 32294 NULL
+il_dbgfs_clear_ucode_stats_write_fndecl_32299_fns il_dbgfs_clear_ucode_stats_write fndecl 3 32299 NULL
+alloc_urbs_fndecl_32307_fns alloc_urbs fndecl 0 32307 NULL
+snd_info_text_entry_write_fndecl_32315_fns snd_info_text_entry_write fndecl 3 32315 NULL
+_nfs42_proc_copy_fndecl_32323_fns _nfs42_proc_copy fndecl 2-7 32323 NULL
+fd_ioctl_fndecl_32343_fns fd_ioctl fndecl 3 32343 NULL
+fib_info_hash_alloc_fndecl_32352_fns fib_info_hash_alloc fndecl 1 32352 NULL
+snd_gus_dram_peek_fndecl_32373_fns snd_gus_dram_peek fndecl 4 32373 NULL
+snd_emu10k1_synth_copy_from_user_fndecl_32374_fns snd_emu10k1_synth_copy_from_user fndecl 5-3 32374 NULL
+transport_get_sectors_16_fndecl_32385_fns transport_get_sectors_16 fndecl 0 32385 NULL
+create_queues_fndecl_32403_fns create_queues fndecl 2-3 32403 NULL
+pt_buffer_setup_aux_fndecl_32418_fns pt_buffer_setup_aux fndecl 3 32418 NULL
+dvb_create_tsout_entity_fndecl_32460_fns dvb_create_tsout_entity fndecl 3 32460 NULL
+isr_irqs_read_fndecl_32462_fns isr_irqs_read fndecl 3 32462 NULL
+sigmadsp_write_i2c_fndecl_32482_fns sigmadsp_write_i2c fndecl 4 32482 NULL
+iwl_dbgfs_frame_stats_read_fndecl_32488_fns iwl_dbgfs_frame_stats_read fndecl 3 32488 NULL
+alloc_group_attrs_fndecl_32505_fns alloc_group_attrs fndecl 2 32505 NULL nohasharray
+altera_swap_ir_fndecl_32505_fns altera_swap_ir fndecl 2 32505 &alloc_group_attrs_fndecl_32505_fns
+transport_get_sectors_12_fndecl_32508_fns transport_get_sectors_12 fndecl 0 32508 NULL
+ctrl_out_fndecl_32539_fns ctrl_out fndecl 3-5 32539 NULL
+ev_next_dev_data_32542_fns ev_next dev_data 0 32542 NULL
+yurex_write_fndecl_32554_fns yurex_write fndecl 3 32554 NULL
+sys_prctl_fndecl_32557_fns sys_prctl fndecl 4 32557 NULL
+joydev_compat_ioctl_fndecl_32558_fns joydev_compat_ioctl fndecl 2 32558 NULL
+bcd2000_midi_handle_input_fndecl_32572_fns bcd2000_midi_handle_input fndecl 3 32572 NULL
+tx_tx_exch_expiry_read_fndecl_32574_fns tx_tx_exch_expiry_read fndecl 3 32574 NULL
+msg_print_ext_header_fndecl_32580_fns msg_print_ext_header fndecl 0 32580 NULL
+mlx5_modify_nic_vport_vlans_fndecl_32595_fns mlx5_modify_nic_vport_vlans fndecl 3 32595 NULL
+paging32_prefetch_gpte_fndecl_32604_fns paging32_prefetch_gpte fndecl 4 32604 NULL
+metronomefb_write_fndecl_32612_fns metronomefb_write fndecl 3 32612 NULL
+wa_nep_queue_fndecl_32649_fns wa_nep_queue fndecl 2 32649 NULL
+dvb_ringbuffer_pkt_next_fndecl_32657_fns dvb_ringbuffer_pkt_next fndecl 0-2 32657 NULL
+get_queue_depth_fndecl_32658_fns get_queue_depth fndecl 0 32658 NULL
+nrof_flowrings_brcmf_msgbuf_32666_fns nrof_flowrings brcmf_msgbuf 0 32666 NULL
+compressed_bio_size_fndecl_32676_fns compressed_bio_size fndecl 0-2 32676 NULL
+ab3100_get_set_reg_fndecl_32681_fns ab3100_get_set_reg fndecl 3 32681 NULL
+write_file_ani_fndecl_32709_fns write_file_ani fndecl 3 32709 NULL
+sysfs_merge_group_fndecl_32710_fns sysfs_merge_group fndecl 0 32710 NULL
+layout_commit_fndecl_32717_fns layout_commit fndecl 3 32717 NULL
+driver_stats_read_fndecl_32739_fns driver_stats_read fndecl 3 32739 NULL
+goto_low_power_fndecl_32741_fns goto_low_power fndecl 0 32741 NULL
+read_file_tgt_stats_fndecl_32748_fns read_file_tgt_stats fndecl 3 32748 NULL
+adjust_priv_size_fndecl_32756_fns adjust_priv_size fndecl 0-1 32756 NULL
+cp2112_hid_get_fndecl_32758_fns cp2112_hid_get fndecl 4 32758 NULL
+i2400m_rx_edata_fndecl_32764_fns i2400m_rx_edata fndecl 5 32764 NULL
+portcntrs_2_read_fndecl_32793_fns portcntrs_2_read fndecl 3 32793 NULL
+wilc_setup_multicast_filter_fndecl_32803_fns wilc_setup_multicast_filter fndecl 3 32803 NULL
+nvme_trans_log_temperature_fndecl_32822_fns nvme_trans_log_temperature fndecl 3 32822 NULL
+gather_array_fndecl_32850_fns gather_array fndecl 3 32850 NULL
+size_mem_cgroup_threshold_ary_32855_fns size mem_cgroup_threshold_ary 0 32855 NULL
+uvc_debugfs_stats_read_fndecl_32856_fns uvc_debugfs_stats_read fndecl 3 32856 NULL
+dz_divisor_dn_zone_32877_fns dz_divisor dn_zone 0 32877 NULL nohasharray
+dvb_ringbuffer_read_user_fndecl_32877_fns dvb_ringbuffer_read_user fndecl 3-0 32877 &dz_divisor_dn_zone_32877_fns
+btrfs_cow_block_fndecl_32885_fns btrfs_cow_block fndecl 0 32885 NULL nohasharray
+wilc_spi_write_fndecl_32885_fns wilc_spi_write fndecl 4 32885 &btrfs_cow_block_fndecl_32885_fns
+snd_gus_dram_read_fndecl_32893_fns snd_gus_dram_read fndecl 4 32893 NULL
+ipv6_getsockopt_sticky_fndecl_32916_fns ipv6_getsockopt_sticky fndecl 5 32916 NULL
+sta_flags_read_fndecl_32917_fns sta_flags_read fndecl 3 32917 NULL
+__add_action_fndecl_32937_fns __add_action fndecl 4 32937 NULL
+ttm_alloc_new_pages_fndecl_32971_fns ttm_alloc_new_pages fndecl 5 32971 NULL
+mtdchar_write_fndecl_33004_fns mtdchar_write fndecl 3 33004 NULL
+ion_ioctl_fndecl_33013_fns ion_ioctl fndecl 2 33013 NULL
+mlxsw_sp_port_ets_maxrate_set_fndecl_33018_fns mlxsw_sp_port_ets_maxrate_set fndecl 0 33018 NULL
+snd_rawmidi_read_fndecl_33026_fns snd_rawmidi_read fndecl 3 33026 NULL
+pipeline_pre_to_defrag_swi_read_fndecl_33042_fns pipeline_pre_to_defrag_swi_read fndecl 3 33042 NULL
+ath10k_read_simulate_fw_crash_fndecl_33056_fns ath10k_read_simulate_fw_crash fndecl 3 33056 NULL
+dev_read_fndecl_33058_fns dev_read fndecl 3 33058 NULL
+iov_iter_copy_from_user_atomic_fndecl_33059_fns iov_iter_copy_from_user_atomic fndecl 4 33059 NULL
+iio_device_add_info_mask_type_fndecl_33062_fns iio_device_add_info_mask_type fndecl 0 33062 NULL
+wil_read_pmccfg_fndecl_33071_fns wil_read_pmccfg fndecl 3 33071 NULL
+ocfs2_control_read_fndecl_33094_fns ocfs2_control_read fndecl 3 33094 NULL
+write_gssp_fndecl_33095_fns write_gssp fndecl 3 33095 NULL
+fl_create_fndecl_33120_fns fl_create fndecl 5 33120 NULL
+__iommu_alloc_buffer_fndecl_33122_fns __iommu_alloc_buffer fndecl 2 33122 NULL
+gnttab_map_fndecl_33124_fns gnttab_map fndecl 2 33124 NULL nohasharray
+drm_atomic_helper_legacy_gamma_set_fndecl_33124_fns drm_atomic_helper_legacy_gamma_set fndecl 5 33124 &gnttab_map_fndecl_33124_fns
+hvutil_transport_send_fndecl_33131_fns hvutil_transport_send fndecl 3 33131 NULL nohasharray
+ib_uverbs_alloc_mw_fndecl_33131_fns ib_uverbs_alloc_mw fndecl 4-5 33131 &hvutil_transport_send_fndecl_33131_fns
+store_msg_fndecl_33138_fns store_msg fndecl 3 33138 NULL
+__get_vm_area_caller_fndecl_33139_fns __get_vm_area_caller fndecl 1 33139 NULL
+putused_user_fndecl_33152_fns putused_user fndecl 3 33152 NULL
+walk_pgd_range_fndecl_33169_fns walk_pgd_range fndecl 0 33169 NULL
+cx231xx_init_isoc_fndecl_33174_fns cx231xx_init_isoc fndecl 3 33174 NULL
+data_avail_vardecl_core_c_33198_fns data_avail vardecl_core.c 0 33198 NULL
+num_lan_msix_i40e_pf_33223_fns num_lan_msix i40e_pf 0 33223 NULL
+ip_options_get_fndecl_33225_fns ip_options_get fndecl 4 33225 NULL
+vid_switchdev_notifier_fdb_info_33231_fns vid switchdev_notifier_fdb_info 0 33231 NULL
+alloc_apertures_fndecl_33250_fns alloc_apertures fndecl 1 33250 NULL
+rs_sta_dbgfs_stats_table_read_fndecl_33262_fns rs_sta_dbgfs_stats_table_read fndecl 3 33262 NULL
+mem_size_ramoops_platform_data_33263_fns mem_size ramoops_platform_data 0 33263 NULL
+cipso_v4_gentag_loc_fndecl_33292_fns cipso_v4_gentag_loc fndecl 0 33292 NULL
+ecryptfs_encrypt_and_encode_filename_fndecl_33297_fns ecryptfs_encrypt_and_encode_filename fndecl 5 33297 NULL
+tracing_set_trace_write_fndecl_33307_fns tracing_set_trace_write fndecl 3 33307 NULL
+ima_show_htable_value_fndecl_33315_fns ima_show_htable_value fndecl 2 33315 NULL
+_iwl_dbgfs_bf_params_write_fndecl_33318_fns _iwl_dbgfs_bf_params_write fndecl 3 33318 NULL
+acpi_gsb_i2c_read_bytes_fndecl_33322_fns acpi_gsb_i2c_read_bytes fndecl 4 33322 NULL
+dump_packet_fndecl_33346_fns dump_packet fndecl 2 33346 NULL
+stk_prepare_sio_buffers_fndecl_33347_fns stk_prepare_sio_buffers fndecl 2 33347 NULL
+rx_hw_stuck_read_fndecl_33352_fns rx_hw_stuck_read fndecl 3 33352 NULL
+udl_prime_create_fndecl_33364_fns udl_prime_create fndecl 2 33364 NULL nohasharray
+scanlength_usbvision_frame_33364_fns scanlength usbvision_frame 0 33364 &udl_prime_create_fndecl_33364_fns
+mlx5_core_sriov_enable_fndecl_33369_fns mlx5_core_sriov_enable fndecl 2 33369 NULL
+sys_io_getevents_fndecl_33381_fns sys_io_getevents fndecl 3 33381 NULL
+length_mac_configuration_hdr_33392_fns length mac_configuration_hdr 0 33392 NULL
+sys_poll_fndecl_33397_fns sys_poll fndecl 2 33397 NULL
+drbg_blocklen_fndecl_33412_fns drbg_blocklen fndecl 0 33412 NULL
+dma_fifo_alloc_fndecl_33415_fns dma_fifo_alloc fndecl 2-3-5 33415 NULL
+tt3650_ci_msg_fndecl_33424_fns tt3650_ci_msg fndecl 4 33424 NULL
+oprofilefs_ulong_from_user_fndecl_33456_fns oprofilefs_ulong_from_user fndecl 3 33456 NULL
+alloc_flex_gd_fndecl_33464_fns alloc_flex_gd fndecl 1 33464 NULL
+ftdi_elan_write_fndecl_33486_fns ftdi_elan_write fndecl 3 33486 NULL
+pstore_file_read_fndecl_33499_fns pstore_file_read fndecl 3 33499 NULL nohasharray
+num_rx_descs_iser_conn_33499_fns num_rx_descs iser_conn 0 33499 &pstore_file_read_fndecl_33499_fns
+__asymmetric_key_hex_to_key_id_fndecl_33513_fns __asymmetric_key_hex_to_key_id fndecl 3 33513 NULL nohasharray
+error_rx_excessive_frame_len_read_fndecl_33513_fns error_rx_excessive_frame_len_read fndecl 3 33513 &__asymmetric_key_hex_to_key_id_fndecl_33513_fns
+usblp_read_fndecl_33517_fns usblp_read fndecl 3 33517 NULL
+write_file_regval_fndecl_33522_fns write_file_regval fndecl 3 33522 NULL
+iwl_dbgfs_tx_pwr_lmt_read_fndecl_33527_fns iwl_dbgfs_tx_pwr_lmt_read fndecl 3 33527 NULL
+evdev_set_mask_fndecl_33528_fns evdev_set_mask fndecl 4 33528 NULL
+__mxt_write_reg_fndecl_33533_fns __mxt_write_reg fndecl 3 33533 NULL
+si476x_radio_read_agc_blob_fndecl_33538_fns si476x_radio_read_agc_blob fndecl 3 33538 NULL
+uinput_abs_setup_fndecl_33551_fns uinput_abs_setup fndecl 3 33551 NULL
+kvm_vcpu_read_guest_fndecl_33552_fns kvm_vcpu_read_guest fndecl 4-2 33552 NULL
+snd_rawmidi_kernel_write1_fndecl_33564_fns snd_rawmidi_kernel_write1 fndecl 4 33564 NULL
+batadv_tt_update_changes_fndecl_33580_fns batadv_tt_update_changes fndecl 3 33580 NULL
+hci_mgmt_cmd_fndecl_33591_fns hci_mgmt_cmd fndecl 4 33591 NULL
+strcspn_fndecl_33602_fns strcspn fndecl 0 33602 NULL
+__kfifo_out_fndecl_33612_fns __kfifo_out fndecl 3-0 33612 NULL
+hfi1_read_portcntrs_fndecl_33617_fns hfi1_read_portcntrs fndecl 0 33617 NULL
+scif_setup_qp_accept_fndecl_33630_fns scif_setup_qp_accept fndecl 4 33630 NULL nohasharray
+nf_getsockopt_fndecl_33630_fns nf_getsockopt fndecl 0 33630 &scif_setup_qp_accept_fndecl_33630_fns
+memblock_size_vxge_hw_mempool_33647_fns memblock_size vxge_hw_mempool 0 33647 NULL
+rxe_mem_init_fast_fndecl_33682_fns rxe_mem_init_fast fndecl 3 33682 NULL
+diva_get_driver_info_fndecl_33684_fns diva_get_driver_info fndecl 0 33684 NULL
+vlsi_alloc_ring_fndecl_33720_fns vlsi_alloc_ring fndecl 3-4 33720 NULL
+stub_chips_nr_vardecl_i2c_stub_c_33739_fns stub_chips_nr vardecl_i2c-stub.c 0 33739 NULL
+xfs_buf_read_map_fndecl_33742_fns xfs_buf_read_map fndecl 3 33742 NULL
+cx2341x_ctrl_new_std_fndecl_33782_fns cx2341x_ctrl_new_std fndecl 4 33782 NULL
+pcmcia_replace_cis_fndecl_33785_fns pcmcia_replace_cis fndecl 3 33785 NULL nohasharray
+do_jit_fndecl_33785_fns do_jit fndecl 0 33785 &pcmcia_replace_cis_fndecl_33785_fns
+sca3000_read_data_fndecl_33787_fns sca3000_read_data fndecl 4 33787 NULL
+gicv2m_init_one_fndecl_33791_fns gicv2m_init_one fndecl 3 33791 NULL
+edt_ft5x06_register_read_fndecl_33803_fns edt_ft5x06_register_read fndecl 0 33803 NULL
+dn_ide_drive_s_33823_fns dn ide_drive_s 0 33823 NULL
+add_partition_fndecl_33847_fns add_partition fndecl 2 33847 NULL
+rx_buf_total_size__mgslpc_info_33856_fns rx_buf_total_size _mgslpc_info 0 33856 NULL
+orangefs_fsync_fndecl_33879_fns orangefs_fsync fndecl 2-3 33879 NULL
+len_gsm_control_33882_fns len gsm_control 0 33882 NULL
+pktgen_if_write_fndecl_33887_fns pktgen_if_write fndecl 3 33887 NULL nohasharray
+reiserfs_xattr_get_fndecl_33887_fns reiserfs_xattr_get fndecl 0 33887 &pktgen_if_write_fndecl_33887_fns
+il_dbgfs_tx_queue_read_fndecl_33895_fns il_dbgfs_tx_queue_read fndecl 3 33895 NULL
+xfs_bmbt_maxrecs_fndecl_33906_fns xfs_bmbt_maxrecs fndecl 2 33906 NULL
+lpfc_idiag_queinfo_read_fndecl_33917_fns lpfc_idiag_queinfo_read fndecl 3 33917 NULL
+vfio_pci_igd_rw_fndecl_33918_fns vfio_pci_igd_rw fndecl 3 33918 NULL
+genl_allocate_reserve_groups_fndecl_33930_fns genl_allocate_reserve_groups fndecl 1 33930 NULL
+iwl_dbgfs_plcp_delta_write_fndecl_33937_fns iwl_dbgfs_plcp_delta_write fndecl 3 33937 NULL
+get_info_fndecl_33938_fns get_info fndecl 3 33938 NULL
+mei_dbgfs_write_allow_fa_fndecl_33943_fns mei_dbgfs_write_allow_fa fndecl 3 33943 NULL
+pm8001_store_update_fw_fndecl_33975_fns pm8001_store_update_fw fndecl 4 33975 NULL
+max_indirect_segments_blkfront_info_33976_fns max_indirect_segments blkfront_info 0 33976 NULL
+cwarn_cm4000_dev_33978_fns cwarn cm4000_dev 0 33978 NULL
+usbat_bulk_write_fndecl_33983_fns usbat_bulk_write fndecl 4 33983 NULL
+spi_data_write_fndecl_33987_fns spi_data_write fndecl 3 33987 NULL
+ethtool_copy_validate_indir_fndecl_33994_fns ethtool_copy_validate_indir fndecl 4 33994 NULL
+count_xfs_attr_sf_hdr_33996_fns count xfs_attr_sf_hdr 0 33996 NULL
+of_n_size_cells_fndecl_34009_fns of_n_size_cells fndecl 0 34009 NULL
+periodic_size_ehci_hcd_34013_fns periodic_size ehci_hcd 0 34013 NULL
+wqe_shift_mlx5_srq_attr_34020_fns wqe_shift mlx5_srq_attr 0 34020 NULL nohasharray
+uwb_rc_neh_grok_event_fndecl_34020_fns uwb_rc_neh_grok_event fndecl 3 34020 &wqe_shift_mlx5_srq_attr_34020_fns
+__kvm_write_guest_page_fndecl_34021_fns __kvm_write_guest_page fndecl 5-2 34021 NULL
+wil_addba_tx_request_fndecl_34039_fns wil_addba_tx_request fndecl 3 34039 NULL
+conf_read_fndecl_34041_fns conf_read fndecl 3 34041 NULL
+lov_get_stripecnt_fndecl_34066_fns lov_get_stripecnt fndecl 0-3 34066 NULL
+gsm_control_modem_fndecl_34068_fns gsm_control_modem fndecl 3 34068 NULL
+__get_vm_area_node_fndecl_34074_fns __get_vm_area_node fndecl 1 34074 NULL
+__memblock_alloc_base_fndecl_34092_fns __memblock_alloc_base fndecl 1 34092 NULL
+vme_user_read_fndecl_34105_fns vme_user_read fndecl 3 34105 NULL
+vb2_dvb_register_adapter_fndecl_34122_fns vb2_dvb_register_adapter fndecl 0 34122 NULL
+do_command_fndecl_34128_fns do_command fndecl 0 34128 NULL
+switchdev_port_fdb_add_fndecl_34145_fns switchdev_port_fdb_add fndecl 5 34145 NULL
+arm_iommu_alloc_attrs_fndecl_34147_fns arm_iommu_alloc_attrs fndecl 2 34147 NULL
+substream_count_snd_pcm_str_34149_fns substream_count snd_pcm_str 0 34149 NULL
+iwl_dbgfs_plcp_delta_read_fndecl_34172_fns iwl_dbgfs_plcp_delta_read fndecl 3 34172 NULL
+si476x_radio_read_rds_blckcnt_blob_fndecl_34192_fns si476x_radio_read_rds_blckcnt_blob fndecl 3 34192 NULL
+usbip_dump_buffer_fndecl_34210_fns usbip_dump_buffer fndecl 2 34210 NULL
+xen_evtchn_max_channels_fndecl_34213_fns xen_evtchn_max_channels fndecl 0 34213 NULL
+__vxge_hw_channel_allocate_fndecl_34229_fns __vxge_hw_channel_allocate fndecl 3 34229 NULL
+max_devs_supported_ipr_ioa_cfg_34240_fns max_devs_supported ipr_ioa_cfg 0 34240 NULL
+tx_tx_done_int_template_read_fndecl_34244_fns tx_tx_done_int_template_read fndecl 3 34244 NULL
+vb2_core_dqbuf_fndecl_34262_fns vb2_core_dqbuf fndecl 0 34262 NULL
+vb2_core_queue_init_fndecl_34278_fns vb2_core_queue_init fndecl 0 34278 NULL
+ea_get_fndecl_34289_fns ea_get fndecl 3 34289 NULL
+quirk_strict_duplicate_filter_read_fndecl_34330_fns quirk_strict_duplicate_filter_read fndecl 3 34330 NULL
+write_file_frameerrors_fndecl_34370_fns write_file_frameerrors fndecl 3 34370 NULL
+sel_read_handle_status_fndecl_34392_fns sel_read_handle_status fndecl 3 34392 NULL
+rawv6_setsockopt_fndecl_34422_fns rawv6_setsockopt fndecl 5 34422 NULL
+ath9k_dump_legacy_btcoex_fndecl_34449_fns ath9k_dump_legacy_btcoex fndecl 0 34449 NULL
+offsets_size_binder_transaction_data_34461_fns offsets_size binder_transaction_data 0 34461 NULL
+fd_copyin_fndecl_34468_fns fd_copyin fndecl 3 34468 NULL
+num_rx_queues_net_device_34480_fns num_rx_queues net_device 0 34480 NULL
+acpi_ex_get_serial_access_length_fndecl_34496_fns acpi_ex_get_serial_access_length fndecl 0-2 34496 NULL
+il4965_ucode_general_stats_read_fndecl_34502_fns il4965_ucode_general_stats_read fndecl 3 34502 NULL
+count_res_proc_context_34514_fns count res_proc_context 0 34514 NULL
+t_bch_control_34516_fns t bch_control 0 34516 NULL
+ogm_buff_len_batadv_hard_iface_bat_iv_34532_fns ogm_buff_len batadv_hard_iface_bat_iv 0 34532 NULL
+speakup_file_write_fndecl_34533_fns speakup_file_write fndecl 3 34533 NULL
+dvb_aplay_fndecl_34555_fns dvb_aplay fndecl 3 34555 NULL
+btmrvl_hscfgcmd_read_fndecl_34556_fns btmrvl_hscfgcmd_read fndecl 3 34556 NULL
+target_alloc_sgl_fndecl_34566_fns target_alloc_sgl fndecl 3 34566 NULL
+rx_ring_num_config_param_34571_fns rx_ring_num config_param 0 34571 NULL
+sb16_copy_from_user_fndecl_34575_fns sb16_copy_from_user fndecl 10-7-6 34575 NULL
+ip_hdrlen_fndecl_34618_fns ip_hdrlen fndecl 0 34618 NULL
+pm_qos_power_read_fndecl_34624_fns pm_qos_power_read fndecl 3 34624 NULL
+hsc_write_fndecl_34640_fns hsc_write fndecl 3 34640 NULL
+type_tw686x_dev_34645_fns type tw686x_dev 0 34645 NULL
+ramdisk_store_fndecl_34654_fns ramdisk_store fndecl 4 34654 NULL
+uwb_est_used_vardecl_est_c_34662_fns uwb_est_used vardecl_est.c 0 34662 NULL
+acpi_copy_property_array_string_fndecl_34680_fns acpi_copy_property_array_string fndecl 0 34680 NULL
+snd_pcm_hw_param_value_min_fndecl_34686_fns snd_pcm_hw_param_value_min fndecl 0 34686 NULL
+slip_maxdev_vardecl_slip_c_34688_fns slip_maxdev vardecl_slip.c 0 34688 NULL
+radeon_ring_init_fndecl_34693_fns radeon_ring_init fndecl 3 34693 NULL
+simple_read_from_buffer_fndecl_34694_fns simple_read_from_buffer fndecl 2-5-0 34694 NULL
+ceph_get_direct_page_vector_fndecl_34695_fns ceph_get_direct_page_vector fndecl 2 34695 NULL
+sel_read_policy_fndecl_34712_fns sel_read_policy fndecl 3 34712 NULL
+len_pagemapread_34714_fns len pagemapread 0 34714 NULL
+kvm_write_guest_virt_system_fndecl_34715_fns kvm_write_guest_virt_system fndecl 4-2 34715 NULL
+blockshift_sddr09_card_info_34748_fns blockshift sddr09_card_info 0 34748 NULL
+num_q_vectors_ixgbe_adapter_34808_fns num_q_vectors ixgbe_adapter 0 34808 NULL
+unix_dgram_connect_fndecl_34836_fns unix_dgram_connect fndecl 3 34836 NULL
+setsockopt_fndecl_34840_fns setsockopt fndecl 5 34840 NULL
+fw_iso_buffer_init_fndecl_34853_fns fw_iso_buffer_init fndecl 3 34853 NULL
+flags_write_fndecl_34858_fns flags_write fndecl 3 34858 NULL
+gk20a_instobj_ctor_iommu_fndecl_34861_fns gk20a_instobj_ctor_iommu fndecl 2 34861 NULL
+pset_prop_read_string_array_fndecl_34862_fns pset_prop_read_string_array fndecl 0 34862 NULL
+s_map_size_adfs_sb_info_34863_fns s_map_size adfs_sb_info 0 34863 NULL
+sddr09_writeX_fndecl_34870_fns sddr09_writeX fndecl 7 34870 NULL
+port_fops_write_fndecl_34928_fns port_fops_write fndecl 3 34928 NULL
+evm_read_key_fndecl_34945_fns evm_read_key fndecl 3 34945 NULL
+bio_kmalloc_fndecl_34947_fns bio_kmalloc fndecl 2 34947 NULL
+reiserfs_get_block_create_0_fndecl_34954_fns reiserfs_get_block_create_0 fndecl 2 34954 NULL
+fs_path_add_path_fndecl_34955_fns fs_path_add_path fndecl 0 34955 NULL
+dns_resolver_read_fndecl_34961_fns dns_resolver_read fndecl 3 34961 NULL
+n_it_fw_ohci_34963_fns n_it fw_ohci 0 34963 NULL
+simple_alloc_urb_fndecl_34966_fns simple_alloc_urb fndecl 3 34966 NULL
+bus_add_device_fndecl_34970_fns bus_add_device fndecl 0 34970 NULL
+rfkill_fop_read_fndecl_34980_fns rfkill_fop_read fndecl 3 34980 NULL
+kfd_gtt_sa_init_fndecl_34996_fns kfd_gtt_sa_init fndecl 3-2 34996 NULL
+error_elp_while_tx_read_fndecl_35002_fns error_elp_while_tx_read fndecl 3 35002 NULL
+ocfs2_control_write_fndecl_35010_fns ocfs2_control_write fndecl 3 35010 NULL
+kzalloc_fndecl_35015_fns kzalloc fndecl 1 35015 NULL
+wep_iv_read_fndecl_35019_fns wep_iv_read fndecl 3 35019 NULL
+lpfc_idiag_pcicfg_write_fndecl_35022_fns lpfc_idiag_pcicfg_write fndecl 3 35022 NULL
+ring_size_radeon_ring_35063_fns ring_size radeon_ring 0 35063 NULL
+adis16480_show_firmware_date_fndecl_35065_fns adis16480_show_firmware_date fndecl 3 35065 NULL
+set_video_mode_Timon_fndecl_35074_fns set_video_mode_Timon fndecl 4 35074 NULL
+number_scales_vardecl_powernow_k7_c_35080_fns number_scales vardecl_powernow-k7.c 0 35080 NULL
+sys_kexec_file_load_fndecl_35083_fns sys_kexec_file_load fndecl 3 35083 NULL nohasharray
+dlm_alloc_pagevec_fndecl_35083_fns dlm_alloc_pagevec fndecl 1 35083 &sys_kexec_file_load_fndecl_35083_fns
+reclaim_pages_fndecl_35086_fns reclaim_pages fndecl 3 35086 NULL
+sizeof_long_fndecl_35095_fns sizeof_long fndecl 0 35095 NULL
+vlan_id_net_bridge_fdb_entry_35107_fns vlan_id net_bridge_fdb_entry 0 35107 NULL
+path_setxattr_fndecl_35127_fns path_setxattr fndecl 4 35127 NULL
+__get_free_pages_fndecl_35139_fns __get_free_pages fndecl 0 35139 NULL
+br_fdb_add_fndecl_35145_fns br_fdb_add fndecl 5 35145 NULL
+read_file_credit_dist_stats_fndecl_35148_fns read_file_credit_dist_stats fndecl 3 35148 NULL
+readlink_copy_fndecl_35149_fns readlink_copy fndecl 2 35149 NULL nohasharray
+num_usb3_ports_xhci_hcd_35149_fns num_usb3_ports xhci_hcd 0 35149 &readlink_copy_fndecl_35149_fns
+br_fdb_fillbuf_fndecl_35152_fns br_fdb_fillbuf fndecl 0 35152 NULL
+__alloc_dev_table_fndecl_35156_fns __alloc_dev_table fndecl 2 35156 NULL
+snd_pcm_oss_read2_fndecl_35168_fns snd_pcm_oss_read2 fndecl 3 35168 NULL
+iwl_dbgfs_power_save_status_read_fndecl_35179_fns iwl_dbgfs_power_save_status_read fndecl 3 35179 NULL
+ah_alloc_tmp_fndecl_35193_fns ah_alloc_tmp fndecl 2-3 35193 NULL
+do_dccp_setsockopt_fndecl_35194_fns do_dccp_setsockopt fndecl 5 35194 NULL nohasharray
+intel_sdvo_write_cmd_fndecl_35194_fns intel_sdvo_write_cmd fndecl 4 35194 &do_dccp_setsockopt_fndecl_35194_fns
+copy_gadget_strings_fndecl_35202_fns copy_gadget_strings fndecl 2-3 35202 NULL
+nfs42_proc_llseek_fndecl_35267_fns nfs42_proc_llseek fndecl 2 35267 NULL
+p54_parse_default_country_fndecl_35309_fns p54_parse_default_country fndecl 3 35309 NULL
+vmci_transport_dgram_enqueue_fndecl_35310_fns vmci_transport_dgram_enqueue fndecl 4 35310 NULL nohasharray
+walk_pud_range_fndecl_35310_fns walk_pud_range fndecl 0 35310 &vmci_transport_dgram_enqueue_fndecl_35310_fns
+btrfs_ordered_sum_size_fndecl_35326_fns btrfs_ordered_sum_size fndecl 0-2 35326 NULL
+efw_transaction_fndecl_35359_fns efw_transaction fndecl 5-7 35359 NULL
+response_length_ib_uverbs_ex_create_wq_resp_35363_fns response_length ib_uverbs_ex_create_wq_resp 0 35363 NULL
+hx8357_spi_write_array_fndecl_35364_fns hx8357_spi_write_array fndecl 3 35364 NULL
+apei_exec_run_fndecl_35376_fns apei_exec_run fndecl 0 35376 NULL
+drm_dp_mst_topology_mgr_init_fndecl_35377_fns drm_dp_mst_topology_mgr_init fndecl 5-4 35377 NULL
+ath9k_hw_read_array_fndecl_35386_fns ath9k_hw_read_array fndecl 3 35386 NULL
+use_sg_st_buffer_35407_fns use_sg st_buffer 0 35407 NULL
+rxpipe_beacon_buffer_thres_host_int_trig_rx_data_read_fndecl_35409_fns rxpipe_beacon_buffer_thres_host_int_trig_rx_data_read fndecl 3 35409 NULL
+major_gendisk_35443_fns major gendisk 0 35443 NULL
+ieee80211_if_read_uapsd_queues_fndecl_35453_fns ieee80211_if_read_uapsd_queues fndecl 3 35453 NULL
+sel_write_relabel_fndecl_35464_fns sel_write_relabel fndecl 3 35464 NULL
+beiscsi_mccq_compl_wait_fndecl_35475_fns beiscsi_mccq_compl_wait fndecl 0 35475 NULL
+qxl_alloc_client_monitors_config_fndecl_35491_fns qxl_alloc_client_monitors_config fndecl 2 35491 NULL nohasharray
+ptlrpcd_partner_group_size_vardecl_ptlrpcd_c_35491_fns ptlrpcd_partner_group_size vardecl_ptlrpcd.c 0 35491 &qxl_alloc_client_monitors_config_fndecl_35491_fns
+sched_feat_write_fndecl_35505_fns sched_feat_write fndecl 3 35505 NULL
+spi_res_alloc_fndecl_35507_fns spi_res_alloc fndecl 3 35507 NULL
+cnt_usnic_vnic_res_desc_35511_fns cnt usnic_vnic_res_desc 0 35511 NULL
+__kfifo_dma_out_prepare_r_fndecl_35512_fns __kfifo_dma_out_prepare_r fndecl 4-5 35512 NULL
+dlci_change_mtu_fndecl_35513_fns dlci_change_mtu fndecl 2 35513 NULL
+ht40allow_map_read_fndecl_35514_fns ht40allow_map_read fndecl 3 35514 NULL
+do_raw_setsockopt_fndecl_35516_fns do_raw_setsockopt fndecl 5-0 35516 NULL
+ssp_send_instruction_fndecl_35549_fns ssp_send_instruction fndecl 5 35549 NULL
+rx_streaming_interval_read_fndecl_35560_fns rx_streaming_interval_read fndecl 3 35560 NULL
+copy_ctl_value_to_user_fndecl_35608_fns copy_ctl_value_to_user fndecl 5 35608 NULL
+flexcop_device_kmalloc_fndecl_35610_fns flexcop_device_kmalloc fndecl 1 35610 NULL
+maxcontacts_mt_device_35613_fns maxcontacts mt_device 0 35613 NULL
+write_rio_fndecl_35622_fns write_rio fndecl 3 35622 NULL
+cciss_add_gendisk_fndecl_35636_fns cciss_add_gendisk fndecl 0 35636 NULL
+broadsheet_spiflash_rewrite_sector_fndecl_35651_fns broadsheet_spiflash_rewrite_sector fndecl 2 35651 NULL
+printer_read_fndecl_35664_fns printer_read fndecl 3 35664 NULL
+ufx_ops_write_fndecl_35667_fns ufx_ops_write fndecl 3 35667 NULL
+wil_pmc_alloc_fndecl_35702_fns wil_pmc_alloc fndecl 2 35702 NULL
+bnx2x_change_mtu_fndecl_35710_fns bnx2x_change_mtu fndecl 2 35710 NULL
+len_igb_tx_buffer_35715_fns len igb_tx_buffer 0 35715 NULL
+mxms_structlen_fndecl_35720_fns mxms_structlen fndecl 0 35720 NULL
+size_irq_routing_options_35727_fns size irq_routing_options 0 35727 NULL
+iscsi_pool_init_fndecl_35730_fns iscsi_pool_init fndecl 2-4 35730 NULL nohasharray
+kobject_set_name_vargs_fndecl_35730_fns kobject_set_name_vargs fndecl 0 35730 &iscsi_pool_init_fndecl_35730_fns
+alauda_write_data_fndecl_35748_fns alauda_write_data fndecl 3 35748 NULL
+ath9k_dump_btcoex_fndecl_35766_fns ath9k_dump_btcoex fndecl 0 35766 NULL
+used_tty_buffer_35815_fns used tty_buffer 0 35815 NULL
+paging32_get_level1_sp_gpa_fndecl_35837_fns paging32_get_level1_sp_gpa fndecl 0 35837 NULL
+size_mvneta_tx_queue_35842_fns size mvneta_tx_queue 0 35842 NULL
+start_vga_cam_fndecl_35860_fns start_vga_cam fndecl 0 35860 NULL
+btrfs_set_stack_chunk_num_stripes_fndecl_35911_fns btrfs_set_stack_chunk_num_stripes fndecl 2 35911 NULL
+cifs_utf16_bytes_fndecl_35914_fns cifs_utf16_bytes fndecl 0 35914 NULL
+packet_count_efx_loopback_state_35918_fns packet_count efx_loopback_state 0 35918 NULL
+sigma_fw_load_control_fndecl_35922_fns sigma_fw_load_control fndecl 3 35922 NULL
+ath10k_read_btcoex_fndecl_35925_fns ath10k_read_btcoex fndecl 3 35925 NULL
+snd_pcm_new_stream_fndecl_35934_fns snd_pcm_new_stream fndecl 3 35934 NULL
+wMaxPacketSize_wdm_device_35940_fns wMaxPacketSize wdm_device 0 35940 NULL
+___alloc_bootmem_nopanic_fndecl_35945_fns ___alloc_bootmem_nopanic fndecl 1 35945 NULL nohasharray
+wil_write_file_txmgmt_fndecl_35945_fns wil_write_file_txmgmt fndecl 3 35945 &___alloc_bootmem_nopanic_fndecl_35945_fns
+snoop_urb_fndecl_35965_fns snoop_urb fndecl 8 35965 NULL
+buf_size_si470x_device_35966_fns buf_size si470x_device 0 35966 NULL
+ccid_getsockopt_builtin_ccids_fndecl_35985_fns ccid_getsockopt_builtin_ccids fndecl 2 35985 NULL
+mcast_list_len_bnx2x_mcast_ramrod_params_36001_fns mcast_list_len bnx2x_mcast_ramrod_params 0 36001 NULL
+v4l2_event_subscribe_fndecl_36004_fns v4l2_event_subscribe fndecl 3 36004 NULL
+igb_alloc_q_vector_fndecl_36009_fns igb_alloc_q_vector fndecl 4-6 36009 NULL nohasharray
+bdev_logical_block_size_fndecl_36009_fns bdev_logical_block_size fndecl 0 36009 &igb_alloc_q_vector_fndecl_36009_fns nohasharray
+max_rx_kingsun_cb_36009_fns max_rx kingsun_cb 0 36009 &bdev_logical_block_size_fndecl_36009_fns
+num_of_memcpy_chans_stedma40_platform_data_36011_fns num_of_memcpy_chans stedma40_platform_data 0 36011 NULL
+n_sg_vscsibk_pend_36028_fns n_sg vscsibk_pend 0 36028 NULL
+count_sgentry64_36033_fns count sgentry64 0 36033 NULL
+thread_notes_elf_note_info_36040_fns thread_notes elf_note_info 0 36040 NULL
+lpfc_idiag_queacc_read_qe_fndecl_36072_fns lpfc_idiag_queacc_read_qe fndecl 0-2 36072 NULL
+nfs4_xattr_get_nfs4_acl_fndecl_36079_fns nfs4_xattr_get_nfs4_acl fndecl 6 36079 NULL
+wdm_write_fndecl_36084_fns wdm_write fndecl 3 36084 NULL
+avc_recv_fndecl_36099_fns avc_recv fndecl 3 36099 NULL
+xfs_trans_read_buf_map_fndecl_36121_fns xfs_trans_read_buf_map fndecl 5 36121 NULL
+__i2400m_bm_ack_verify_fndecl_36139_fns __i2400m_bm_ack_verify fndecl 0-4 36139 NULL
+gsm_control_reply_fndecl_36166_fns gsm_control_reply fndecl 4 36166 NULL
+qd2offset_fndecl_36177_fns qd2offset fndecl 0 36177 NULL
+sock_setbindtodevice_fndecl_36202_fns sock_setbindtodevice fndecl 3 36202 NULL
+qsfp1_debugfs_write_fndecl_36216_fns qsfp1_debugfs_write fndecl 3 36216 NULL
+page_size_spi_eeprom_36227_fns page_size spi_eeprom 0 36227 NULL
+vhost_kvzalloc_fndecl_36242_fns vhost_kvzalloc fndecl 1 36242 NULL
+histogram_alloc_size_dm_stat_36247_fns histogram_alloc_size dm_stat 0 36247 NULL
+isr_cmd_cmplt_read_fndecl_36268_fns isr_cmd_cmplt_read fndecl 3 36268 NULL
+pwc_get_fps_Timon_fndecl_36269_fns pwc_get_fps_Timon fndecl 0 36269 NULL
+iwl_pcie_txq_alloc_fndecl_36278_fns iwl_pcie_txq_alloc fndecl 3 36278 NULL
+collection_size_hid_device_36289_fns collection_size hid_device 0 36289 NULL
+ssl_next_nilfs_snapshot_list_36302_fns ssl_next nilfs_snapshot_list 0 36302 NULL
+paging64_prefetch_gpte_fndecl_36303_fns paging64_prefetch_gpte fndecl 4 36303 NULL
+tegra_fb_alloc_fndecl_36306_fns tegra_fb_alloc fndecl 4 36306 NULL
+mwifiex_info_read_fndecl_36308_fns mwifiex_info_read fndecl 3 36308 NULL
+move_buffer_data_fndecl_36318_fns move_buffer_data fndecl 2 36318 NULL
+apei_exec_run_optional_fndecl_36319_fns apei_exec_run_optional fndecl 0 36319 NULL
+ima_write_template_field_data_fndecl_36336_fns ima_write_template_field_data fndecl 2 36336 NULL nohasharray
+create_trace_kprobe_fndecl_36336_fns create_trace_kprobe fndecl 1 36336 &ima_write_template_field_data_fndecl_36336_fns
+pset_prop_read_u32_array_fndecl_36338_fns pset_prop_read_u32_array fndecl 0 36338 NULL
+iowarrior_read_fndecl_36344_fns iowarrior_read fndecl 3 36344 NULL
+num_crtc_cirrus_device_36358_fns num_crtc cirrus_device 0 36358 NULL
+snd_pcm_lib_write_transfer_fndecl_36369_fns snd_pcm_lib_write_transfer fndecl 5 36369 NULL
+kvm_vcpu_read_guest_atomic_fndecl_36372_fns kvm_vcpu_read_guest_atomic fndecl 4-2 36372 NULL
+addr_len_ipmi_req_36374_fns addr_len ipmi_req 0 36374 NULL
+batadv_tt_update_orig_fndecl_36402_fns batadv_tt_update_orig fndecl 6-4 36402 NULL
+pipeline_dec_packet_out_read_fndecl_36407_fns pipeline_dec_packet_out_read fndecl 3 36407 NULL
+rproc_state_read_fndecl_36410_fns rproc_state_read fndecl 3 36410 NULL
+isr_host_acknowledges_read_fndecl_36459_fns isr_host_acknowledges_read fndecl 3 36459 NULL
+avail_snd_compr_avail_36463_fns avail snd_compr_avail 0 36463 NULL
+strn_len_fndecl_36473_fns strn_len fndecl 0 36473 NULL
+p9_client_prepare_req_fndecl_36492_fns p9_client_prepare_req fndecl 3 36492 NULL
+sg_max_nents_hwif_s_36501_fns sg_max_nents hwif_s 0 36501 NULL
+__i2c_write_fndecl_36516_fns __i2c_write fndecl 0 36516 NULL
+do_sys_poll_fndecl_36574_fns do_sys_poll fndecl 2 36574 NULL
+audio_write_fndecl_36582_fns audio_write fndecl 4 36582 NULL nohasharray
+wusb_prf_fndecl_36582_fns wusb_prf fndecl 7 36582 &audio_write_fndecl_36582_fns
+mwifiex_getlog_read_fndecl_36590_fns mwifiex_getlog_read fndecl 3 36590 NULL
+scan_cnt_ad7280_state_36592_fns scan_cnt ad7280_state 0 36592 NULL
+alloc_fw_event_work_fndecl_36593_fns alloc_fw_event_work fndecl 1 36593 NULL
+__br_fdb_add_fndecl_36596_fns __br_fdb_add fndecl 6 36596 NULL
+write_file_spec_scan_ctl_fndecl_36603_fns write_file_spec_scan_ctl fndecl 3 36603 NULL
+f2fs_kvzalloc_fndecl_36641_fns f2fs_kvzalloc fndecl 1 36641 NULL
+lpfc_idiag_ctlacc_read_reg_fndecl_36642_fns lpfc_idiag_ctlacc_read_reg fndecl 0-3 36642 NULL
+nls_nullsize_fndecl_36644_fns nls_nullsize fndecl 0 36644 NULL
+setup_data_read_fndecl_36653_fns setup_data_read fndecl 3 36653 NULL nohasharray
+pvr2_encoder_write_words_fndecl_36653_fns pvr2_encoder_write_words fndecl 4 36653 &setup_data_read_fndecl_36653_fns
+__kfifo_dma_in_prepare_r_fndecl_36659_fns __kfifo_dma_in_prepare_r fndecl 4-5 36659 NULL
+__tty_alloc_driver_fndecl_36660_fns __tty_alloc_driver fndecl 1 36660 NULL
+qp_alloc_host_work_fndecl_36661_fns qp_alloc_host_work fndecl 5-3 36661 NULL
+max_queue_pairs_virtnet_info_36669_fns max_queue_pairs virtnet_info 0 36669 NULL
+expected_pages_page_collect_36693_fns expected_pages page_collect 0 36693 NULL
+bnx2x_mcast_set_rdata_hdr_e1_fndecl_36725_fns bnx2x_mcast_set_rdata_hdr_e1 fndecl 3 36725 NULL
+alloc_rd_atomic_resources_fndecl_36726_fns alloc_rd_atomic_resources fndecl 2 36726 NULL
+batadv_tt_tvlv_ogm_handler_v1_fndecl_36742_fns batadv_tt_tvlv_ogm_handler_v1 fndecl 5 36742 NULL
+channel_hwif_s_36751_fns channel hwif_s 0 36751 NULL
+num_nodes_crush_bucket_tree_36776_fns num_nodes crush_bucket_tree 0 36776 NULL
+efi_runtime_map_setup_fndecl_36796_fns efi_runtime_map_setup fndecl 2 36796 NULL
+mlx4_num_eq_uar_fndecl_36830_fns mlx4_num_eq_uar fndecl 0 36830 NULL
+qlcnic_83xx_sysfs_flash_write_fndecl_36872_fns qlcnic_83xx_sysfs_flash_write fndecl 4 36872 NULL
+netlbl_unlabel_init_fndecl_36873_fns netlbl_unlabel_init fndecl 1 36873 NULL
+tool_spadfn_write_fndecl_36915_fns tool_spadfn_write fndecl 3 36915 NULL
+dup_variable_bug_fndecl_36926_fns dup_variable_bug fndecl 3 36926 NULL
+debug_level_proc_write_fndecl_36943_fns debug_level_proc_write fndecl 3 36943 NULL
+loopend_soundfont_sample_info_36981_fns loopend soundfont_sample_info 0 36981 NULL
+SYSC_gethostname_fndecl_37078_fns SYSC_gethostname fndecl 2 37078 NULL
+relay_alloc_page_array_fndecl_37100_fns relay_alloc_page_array fndecl 1 37100 NULL
+fuse_request_alloc_fndecl_37120_fns fuse_request_alloc fndecl 1 37120 NULL
+acpi_data_prop_read_single_fndecl_37152_fns acpi_data_prop_read_single fndecl 0 37152 NULL
+mlx5_query_port_pvlc_fndecl_37159_fns mlx5_query_port_pvlc fndecl 3 37159 NULL
+mdiobus_alloc_size_fndecl_37168_fns mdiobus_alloc_size fndecl 1 37168 NULL
+gpe_count_acpi_gpe_block_info_37173_fns gpe_count acpi_gpe_block_info 0 37173 NULL
+fdb_add_entry_fndecl_37182_fns fdb_add_entry fndecl 6 37182 NULL
+ssd1307fb_write_fndecl_37192_fns ssd1307fb_write fndecl 3 37192 NULL
+hwflags_read_fndecl_37197_fns hwflags_read fndecl 3 37197 NULL
+hur_len_fndecl_37216_fns hur_len fndecl 0 37216 NULL
+tw686x_real_fps_fndecl_37230_fns tw686x_real_fps fndecl 0-2 37230 NULL
+test_unaligned_bulk_fndecl_37246_fns test_unaligned_bulk fndecl 3 37246 NULL
+iwl_dump_fh_fndecl_37248_fns iwl_dump_fh fndecl 0 37248 NULL
+isdn_writebuf_stub_fndecl_37260_fns isdn_writebuf_stub fndecl 4 37260 NULL
+copy_entries_to_user_fndecl_37276_fns copy_entries_to_user fndecl 1 37276 NULL
+cyz_load_fw_fndecl_37290_fns cyz_load_fw fndecl 0 37290 NULL
+num_bna_mem_info_37294_fns num bna_mem_info 0 37294 NULL
+aer_inject_write_fndecl_37308_fns aer_inject_write fndecl 3 37308 NULL
+ath6kl_delete_qos_write_fndecl_37312_fns ath6kl_delete_qos_write fndecl 3 37312 NULL
+kstrtobool_from_user_fndecl_37318_fns kstrtobool_from_user fndecl 2 37318 NULL
+line6_midibuf_init_fndecl_37338_fns line6_midibuf_init fndecl 2 37338 NULL
+mdio_mii_ioctl_fndecl_37342_fns mdio_mii_ioctl fndecl 0 37342 NULL
+hso_serial_common_create_fndecl_37343_fns hso_serial_common_create fndecl 4 37343 NULL
+dlen_pg_read_hdr_37352_fns dlen pg_read_hdr 0 37352 NULL
+ieee80211_alloc_txb_fndecl_37358_fns ieee80211_alloc_txb fndecl 1 37358 NULL
+alauda_read_data_fndecl_37367_fns alauda_read_data fndecl 3 37367 NULL
+bt_alloc_fndecl_37370_fns bt_alloc fndecl 2 37370 NULL
+orig_bi_size_usb_idmouse_37372_fns orig_bi_size usb_idmouse 0 37372 NULL
+tx_tx_exch_pending_read_fndecl_37385_fns tx_tx_exch_pending_read fndecl 3 37385 NULL
+hsc_msg_len_set_fndecl_37398_fns hsc_msg_len_set fndecl 2 37398 NULL
+ath6kl_wmi_implicit_create_pstream_fndecl_37407_fns ath6kl_wmi_implicit_create_pstream fndecl 2 37407 NULL
+ipv6_renew_options_kern_fndecl_37436_fns ipv6_renew_options_kern fndecl 5 37436 NULL
+mwifiex_debug_read_fndecl_37441_fns mwifiex_debug_read fndecl 3 37441 NULL
+cfi_read_query_fndecl_37465_fns cfi_read_query fndecl 0 37465 NULL nohasharray
+devnum_mtd_blktrans_dev_37465_fns devnum mtd_blktrans_dev 0 37465 &cfi_read_query_fndecl_37465_fns
+omap_dma_reserve_channels_vardecl_dma_c_37479_fns omap_dma_reserve_channels vardecl_dma.c 0 37479 NULL
+copy_user_segment_list_fndecl_37517_fns copy_user_segment_list fndecl 2 37517 NULL
+fuse_fsync_common_fndecl_37543_fns fuse_fsync_common fndecl 2-3 37543 NULL
+num_rand_bytes_ecryptfs_write_tag_70_packet_silly_stack_37548_fns num_rand_bytes ecryptfs_write_tag_70_packet_silly_stack 0 37548 NULL
+n_ai_urbs_usbdux_private_37595_fns n_ai_urbs usbdux_private 0 37595 NULL
+tx_tx_start_data_read_fndecl_37616_fns tx_tx_start_data_read fndecl 3 37616 NULL
+usb_stor_bulk_srb_fndecl_37641_fns usb_stor_bulk_srb fndecl 2 37641 NULL
+copy_ctr_args_fndecl_37642_fns copy_ctr_args fndecl 2 37642 NULL
+bufsize_vardecl_pagetest_c_37645_fns bufsize vardecl_pagetest.c 0 37645 NULL
+nvme_trans_ext_inq_page_fndecl_37691_fns nvme_trans_ext_inq_page fndecl 3 37691 NULL
+xenvif_write_io_ring_fndecl_37713_fns xenvif_write_io_ring fndecl 3 37713 NULL
+run_start_commands_fndecl_37723_fns run_start_commands fndecl 0 37723 NULL
+mon_bin_get_event_fndecl_37740_fns mon_bin_get_event fndecl 4-6 37740 NULL
+pwr_rcvd_beacons_read_fndecl_37751_fns pwr_rcvd_beacons_read fndecl 3 37751 NULL
+ath6kl_dbg_dump_fndecl_37760_fns ath6kl_dbg_dump fndecl 5 37760 NULL
+cache_read_procfs_fndecl_37761_fns cache_read_procfs fndecl 3 37761 NULL
+kvm_kvzalloc_fndecl_37773_fns kvm_kvzalloc fndecl 1 37773 NULL
+ifc_len_ifconf_37839_fns ifc_len ifconf 0 37839 NULL
+__kfifo_skip_r_fndecl_37849_fns __kfifo_skip_r fndecl 2 37849 NULL
+ioread16be_fndecl_37854_fns ioread16be fndecl 0 37854 NULL
+usbat_read_block_fndecl_37858_fns usbat_read_block fndecl 3-4 37858 NULL
+tx_tx_exch_read_fndecl_37865_fns tx_tx_exch_read fndecl 3 37865 NULL
+num_node_state_fndecl_37870_fns num_node_state fndecl 0 37870 NULL
+hx8357_spi_write_then_read_fndecl_37879_fns hx8357_spi_write_then_read fndecl 3 37879 NULL
+dm_bufio_client_create_fndecl_37889_fns dm_bufio_client_create fndecl 4 37889 NULL
+pvr2_i2c_basic_op_fndecl_37917_fns pvr2_i2c_basic_op fndecl 4-6 37917 NULL
+spk_ye_vardecl_37920_fns spk_ye vardecl 0 37920 NULL
+mlx5_set_port_qetcr_reg_fndecl_37932_fns mlx5_set_port_qetcr_reg fndecl 3 37932 NULL
+num_escbs_asd_seq_data_37938_fns num_escbs asd_seq_data 0 37938 NULL
+kvm_fetch_guest_virt_fndecl_37942_fns kvm_fetch_guest_virt fndecl 2-4 37942 NULL
+seq_write_fndecl_37946_fns seq_write fndecl 3 37946 NULL
+mbox_write_fndecl_37967_fns mbox_write fndecl 3 37967 NULL
+vortex_core_init_fndecl_37980_fns vortex_core_init fndecl 0 37980 NULL
+key_search_fndecl_37982_fns key_search fndecl 0 37982 NULL
+get_cur_path_fndecl_38038_fns get_cur_path fndecl 0 38038 NULL
+xfs_extent_free_create_done_fndecl_38040_fns xfs_extent_free_create_done fndecl 3 38040 NULL
+DataUnits_partition_t_38043_fns DataUnits partition_t 0 38043 NULL
+aac_convert_sgraw2_fndecl_38045_fns aac_convert_sgraw2 fndecl 2-4 38045 NULL
+get_vmcore_size_fndecl_38046_fns get_vmcore_size fndecl 0-2-1 38046 NULL
+iscsi_create_session_fndecl_38060_fns iscsi_create_session fndecl 3 38060 NULL
+ps_upsd_utilization_read_fndecl_38086_fns ps_upsd_utilization_read fndecl 3 38086 NULL nohasharray
+portcntrs_debugfs_read_fndecl_38086_fns portcntrs_debugfs_read fndecl 3 38086 &ps_upsd_utilization_read_fndecl_38086_fns
+host_mapping_level_fndecl_38115_fns host_mapping_level fndecl 0-2 38115 NULL
+sel_write_access_fndecl_38123_fns sel_write_access fndecl 3 38123 NULL
+sctp_setsockopt_associnfo_fndecl_38135_fns sctp_setsockopt_associnfo fndecl 3 38135 NULL
+rtw_os_xmit_resource_alloc23a_fndecl_38142_fns rtw_os_xmit_resource_alloc23a fndecl 3 38142 NULL
+iwl_dbgfs_bcast_filters_macs_read_fndecl_38156_fns iwl_dbgfs_bcast_filters_macs_read fndecl 3 38156 NULL
+st_read_fndecl_38176_fns st_read fndecl 3 38176 NULL
+nf_ct_ext_create_fndecl_38195_fns nf_ct_ext_create fndecl 3 38195 NULL
+drm_property_create_fndecl_38196_fns drm_property_create fndecl 4 38196 NULL
+nilfs_cpfile_checkpoints_in_block_fndecl_38197_fns nilfs_cpfile_checkpoints_in_block fndecl 0-2-3 38197 NULL
+goto_high_power_fndecl_38198_fns goto_high_power fndecl 0 38198 NULL
+rx_offset_tg3_38201_fns rx_offset tg3 0 38201 NULL
+ath10k_dbg_sta_write_addba_fndecl_38227_fns ath10k_dbg_sta_write_addba fndecl 3 38227 NULL
+dvb_audio_write_fndecl_38232_fns dvb_audio_write fndecl 3 38232 NULL
+i2400m_bm_cmd_fndecl_38243_fns i2400m_bm_cmd fndecl 0-5 38243 NULL
+ext2_xattr_get_fndecl_38252_fns ext2_xattr_get fndecl 0 38252 NULL
+mwifiex_11n_delba_fndecl_38254_fns mwifiex_11n_delba fndecl 2 38254 NULL
+i2c2_debugfs_read_fndecl_38270_fns i2c2_debugfs_read fndecl 3 38270 NULL
+header_length_fw_iso_packet_38284_fns header_length fw_iso_packet 0 38284 NULL
+cacheless_memcpy_fndecl_38293_fns cacheless_memcpy fndecl 3 38293 NULL
+smk_write_ptrace_fndecl_38294_fns smk_write_ptrace fndecl 3 38294 NULL
+alloc_smp_req_fndecl_38298_fns alloc_smp_req fndecl 1 38298 NULL
+num_kcontrols_snd_soc_dapm_widget_38302_fns num_kcontrols snd_soc_dapm_widget 0 38302 NULL nohasharray
+ipw_get_event_log_len_fndecl_38302_fns ipw_get_event_log_len fndecl 0 38302 &num_kcontrols_snd_soc_dapm_widget_38302_fns
+ath10k_dbg_sta_read_aggr_mode_fndecl_38310_fns ath10k_dbg_sta_read_aggr_mode fndecl 3 38310 NULL
+ob_max_size_mvumi_hba_38327_fns ob_max_size mvumi_hba 0 38327 NULL
+get_first_ref_fndecl_38342_fns get_first_ref fndecl 0 38342 NULL
+len_ethtool_regs_38354_fns len ethtool_regs 0 38354 NULL
+ieee80211_if_read_dot11MeshHWMPRootMode_fndecl_38370_fns ieee80211_if_read_dot11MeshHWMPRootMode fndecl 3 38370 NULL
+wsm_handle_exception_fndecl_38377_fns wsm_handle_exception fndecl 3 38377 NULL
+dvb_register_frontend_fndecl_38382_fns dvb_register_frontend fndecl 0 38382 NULL
+chrdev_setup_rx_fndecl_38384_fns chrdev_setup_rx fndecl 2 38384 NULL
+mwifiex_rdeeprom_read_fndecl_38390_fns mwifiex_rdeeprom_read fndecl 3 38390 NULL
+size_vfio_info_cap_38398_fns size vfio_info_cap 0 38398 NULL
+ath6kl_sdio_alloc_prep_scat_req_fndecl_38401_fns ath6kl_sdio_alloc_prep_scat_req fndecl 2 38401 NULL
+dwc3_mode_write_fndecl_38414_fns dwc3_mode_write fndecl 3 38414 NULL
+read_page_fndecl_38423_fns read_page fndecl 2 38423 NULL
+dvb_ringbuffer_avail_fndecl_38474_fns dvb_ringbuffer_avail fndecl 0 38474 NULL
+__fuse_request_alloc_fndecl_38479_fns __fuse_request_alloc fndecl 1 38479 NULL
+dma_rx_errors_read_fndecl_38494_fns dma_rx_errors_read fndecl 3 38494 NULL
+smsdvb_stats_read_fndecl_38529_fns smsdvb_stats_read fndecl 3 38529 NULL
+o2net_debug_read_fndecl_38554_fns o2net_debug_read fndecl 3 38554 NULL
+hysdn_conf_write_fndecl_38562_fns hysdn_conf_write fndecl 3 38562 NULL
+memblock_alloc_base_nid_fndecl_38568_fns memblock_alloc_base_nid fndecl 1 38568 NULL
+retry_count_read_fndecl_38578_fns retry_count_read fndecl 3 38578 NULL
+gdm_usb_hci_send_fndecl_38585_fns gdm_usb_hci_send fndecl 3 38585 NULL
+print_prefix_fndecl_38595_fns print_prefix fndecl 0 38595 NULL
+proc_pid_readlink_fndecl_38601_fns proc_pid_readlink fndecl 3 38601 NULL
+perf_num_counters_fndecl_38605_fns perf_num_counters fndecl 0 38605 NULL
+ieee80211_if_read_dot11MeshRetryTimeout_fndecl_38619_fns ieee80211_if_read_dot11MeshRetryTimeout fndecl 3 38619 NULL
+vmci_qp_broker_alloc_fndecl_38635_fns vmci_qp_broker_alloc fndecl 6-5 38635 NULL
+str_read_fndecl_38656_fns str_read fndecl 4 38656 NULL
+cm4040_read_fndecl_38663_fns cm4040_read fndecl 3 38663 NULL
+v9fs_alloc_rdir_buf_fndecl_38679_fns v9fs_alloc_rdir_buf fndecl 2 38679 NULL
+sg_read_oxfer_fndecl_38687_fns sg_read_oxfer fndecl 3 38687 NULL
+iio_buffer_add_channel_sysfs_fndecl_38693_fns iio_buffer_add_channel_sysfs fndecl 0 38693 NULL
+sctp_setsockopt_pr_supported_fndecl_38705_fns sctp_setsockopt_pr_supported fndecl 3 38705 NULL
+get_user_pages_fast_fndecl_38708_fns get_user_pages_fast fndecl 0 38708 NULL
+if_write_fndecl_38719_fns if_write fndecl 3 38719 NULL
+acpi_table_parse_entries_fndecl_38730_fns acpi_table_parse_entries fndecl 0 38730 NULL
+last_error_boot_data_38741_fns last_error boot_data 0 38741 NULL
+ssd1307fb_alloc_array_fndecl_38751_fns ssd1307fb_alloc_array fndecl 1 38751 NULL
+buffer_from_user_fndecl_38753_fns buffer_from_user fndecl 3 38753 NULL
+nr_pages_max_splice_pipe_desc_38758_fns nr_pages_max splice_pipe_desc 0 38758 NULL
+egr_start_sge_38761_fns egr_start sge 0 38761 NULL
+az6007_read_fndecl_38771_fns az6007_read fndecl 6 38771 NULL
+pointer_size_read_fndecl_38788_fns pointer_size_read fndecl 3 38788 NULL
+get_indirect_ea_fndecl_38798_fns get_indirect_ea fndecl 4 38798 NULL
+read_file_tgt_tx_stats_fndecl_38804_fns read_file_tgt_tx_stats fndecl 3 38804 NULL
+user_read_fndecl_38842_fns user_read fndecl 3 38842 NULL
+memblock_alloc_fndecl_38847_fns memblock_alloc fndecl 1 38847 NULL
+logfs_fsync_fndecl_38849_fns logfs_fsync fndecl 2-3 38849 NULL
+nrealwriters_vardecl_rcuperf_c_38873_fns nrealwriters vardecl_rcuperf.c 0 38873 NULL
+pgctrl_write_fndecl_38918_fns pgctrl_write fndecl 3 38918 NULL
+device_create_sys_dev_entry_fndecl_38921_fns device_create_sys_dev_entry fndecl 0 38921 NULL
+qlcnic_diag_free_res_fndecl_38922_fns qlcnic_diag_free_res fndecl 2 38922 NULL
+drm_fb_helper_sys_write_fndecl_38945_fns drm_fb_helper_sys_write fndecl 3 38945 NULL
+cdrom_read_cdda_fndecl_38973_fns cdrom_read_cdda fndecl 4 38973 NULL
+hsc_read_fndecl_38991_fns hsc_read fndecl 3 38991 NULL
+pwr_rcvd_awake_beacons_read_fndecl_39002_fns pwr_rcvd_awake_beacons_read fndecl 3 39002 NULL
+usbat_flash_write_data_fndecl_39018_fns usbat_flash_write_data fndecl 4 39018 NULL
+alloc_send_rmpp_list_fndecl_39029_fns alloc_send_rmpp_list fndecl 2 39029 NULL
+ath6kl_set_ap_probe_resp_ies_fndecl_39032_fns ath6kl_set_ap_probe_resp_ies fndecl 3 39032 NULL
+error_burst_mismatch_read_fndecl_39035_fns error_burst_mismatch_read fndecl 3 39035 NULL
+iwl_dbgfs_missed_beacon_read_fndecl_39051_fns iwl_dbgfs_missed_beacon_read fndecl 3 39051 NULL
+ncp_fsync_fndecl_39057_fns ncp_fsync fndecl 2-3 39057 NULL
+xillybus_write_fndecl_39102_fns xillybus_write fndecl 3 39102 NULL
+audio_ins_vx_core_39112_fns audio_ins vx_core 0 39112 NULL
+acpi_data_get_property_array_fndecl_39128_fns acpi_data_get_property_array fndecl 0 39128 NULL
+simple_transaction_get_fndecl_39130_fns simple_transaction_get fndecl 3 39130 NULL
+of_phandle_iterator_args_fndecl_39151_fns of_phandle_iterator_args fndecl 0 39151 NULL
+raid56_parity_alloc_scrub_rbio_fndecl_39153_fns raid56_parity_alloc_scrub_rbio fndecl 4 39153 NULL
+cfg80211_roamed_bss_fndecl_39173_fns cfg80211_roamed_bss fndecl 6-4 39173 NULL
+cyttsp4_probe_fndecl_39178_fns cyttsp4_probe fndecl 4 39178 NULL
+l2cap_sock_setsockopt_fndecl_39180_fns l2cap_sock_setsockopt fndecl 5 39180 NULL
+mthca_buddy_init_fndecl_39181_fns mthca_buddy_init fndecl 2 39181 NULL
+sg_kmalloc_fndecl_39251_fns sg_kmalloc fndecl 1 39251 NULL
+soc_codec_reg_show_fndecl_39277_fns soc_codec_reg_show fndecl 3-0 39277 NULL
+size_tomoyo_condition_39281_fns size tomoyo_condition 0 39281 NULL
+lpfc_idiag_pcicfg_read_fndecl_39309_fns lpfc_idiag_pcicfg_read fndecl 3 39309 NULL
+SYSC_flistxattr_fndecl_39312_fns SYSC_flistxattr fndecl 3 39312 NULL
+SYSC_sched_setaffinity_fndecl_39317_fns SYSC_sched_setaffinity fndecl 2 39317 NULL
+len_buflist_39320_fns len buflist 0 39320 NULL
+get_cable_info_fndecl_39326_fns get_cable_info fndecl 3-4 39326 NULL
+isdn_ppp_read_fndecl_39335_fns isdn_ppp_read fndecl 4 39335 NULL
+iwl_dbgfs_echo_test_write_fndecl_39337_fns iwl_dbgfs_echo_test_write fndecl 3 39337 NULL
+fscrypt_fname_alloc_buffer_fndecl_39339_fns fscrypt_fname_alloc_buffer fndecl 2 39339 NULL nohasharray
+musb_softconnect_write_fndecl_39339_fns musb_softconnect_write fndecl 3 39339 &fscrypt_fname_alloc_buffer_fndecl_39339_fns
+setbrightness_fndecl_39342_fns setbrightness fndecl 0 39342 NULL
+tpm_read_fndecl_39355_fns tpm_read fndecl 3 39355 NULL
+max_skl_algo_data_39368_fns max skl_algo_data 0 39368 NULL
+roccat_common2_receive_fndecl_39378_fns roccat_common2_receive fndecl 4 39378 NULL
+sl_alloc_bufs_fndecl_39391_fns sl_alloc_bufs fndecl 2 39391 NULL
+mwifiex_reset_write_fndecl_39394_fns mwifiex_reset_write fndecl 3 39394 NULL
+iscsi_create_conn_fndecl_39402_fns iscsi_create_conn fndecl 2 39402 NULL
+_iwl_dbgfs_send_echo_cmd_write_fndecl_39412_fns _iwl_dbgfs_send_echo_cmd_write fndecl 3 39412 NULL
+show_device_status_fndecl_39440_fns show_device_status fndecl 0 39440 NULL
+virtio_cread16_fndecl_39444_fns virtio_cread16 fndecl 0 39444 NULL
+tp_la_write_fndecl_39445_fns tp_la_write fndecl 3 39445 NULL nohasharray
+max_size_vardecl_custom_method_c_39445_fns max_size vardecl_custom_method.c 0 39445 &tp_la_write_fndecl_39445_fns
+proc_write_fndecl_39464_fns proc_write fndecl 3 39464 NULL
+iwl_statistics_flag_fndecl_39478_fns iwl_statistics_flag fndecl 0 39478 NULL
+mwifiex_timeshare_coex_write_fndecl_39516_fns mwifiex_timeshare_coex_write fndecl 3 39516 NULL nohasharray
+lbs_dev_info_fndecl_39516_fns lbs_dev_info fndecl 3 39516 &mwifiex_timeshare_coex_write_fndecl_39516_fns
+error_tx_resume_failure_read_fndecl_39521_fns error_tx_resume_failure_read fndecl 3 39521 NULL
+len_batadv_tvlv_hdr_39527_fns len batadv_tvlv_hdr 0 39527 NULL
+rsc_mgr_init_fndecl_39528_fns rsc_mgr_init fndecl 3 39528 NULL
+wusb_prf_64_fndecl_39530_fns wusb_prf_64 fndecl 7 39530 NULL
+reply_len_bsg_job_39533_fns reply_len bsg_job 0 39533 NULL
+srpt_alloc_ioctx_fndecl_39537_fns srpt_alloc_ioctx fndecl 2 39537 NULL
+jbd2_journal_init_revoke_fndecl_39555_fns jbd2_journal_init_revoke fndecl 2 39555 NULL
+buf_size_fm_rds_39590_fns buf_size fm_rds 0 39590 NULL
+count_snd_ctl_elem_info_39594_fns count snd_ctl_elem_info 0 39594 NULL
+of_clk_get_parent_count_fndecl_39609_fns of_clk_get_parent_count fndecl 0 39609 NULL
+simple_xattr_set_fndecl_39639_fns simple_xattr_set fndecl 4 39639 NULL
+xfs_trans_get_efd_fndecl_39647_fns xfs_trans_get_efd fndecl 3 39647 NULL
+nfs_filemap_write_and_wait_range_fndecl_39652_fns nfs_filemap_write_and_wait_range fndecl 2-3 39652 NULL
+vendor_diag_read_fndecl_39671_fns vendor_diag_read fndecl 3 39671 NULL
+dev_mem_read_fndecl_39681_fns dev_mem_read fndecl 3 39681 NULL nohasharray
+num_q_vectors_fm10k_intfc_39681_fns num_q_vectors fm10k_intfc 0 39681 &dev_mem_read_fndecl_39681_fns
+blk_check_plugged_fndecl_39715_fns blk_check_plugged fndecl 3 39715 NULL
+tm6000_read_write_usb_fndecl_39749_fns tm6000_read_write_usb fndecl 7 39749 NULL
+fw_logger_read_fndecl_39761_fns fw_logger_read fndecl 3 39761 NULL
+phy_get_sset_count_fndecl_39774_fns phy_get_sset_count fndecl 0 39774 NULL
+write_flush_fndecl_39776_fns write_flush fndecl 3 39776 NULL
+dvb_play_fndecl_39789_fns dvb_play fndecl 3 39789 NULL
+tpm_write_fndecl_39805_fns tpm_write fndecl 3 39805 NULL
+videobuf_dma_init_user_fndecl_39812_fns videobuf_dma_init_user fndecl 3-4 39812 NULL
+nft_trans_alloc_fndecl_39815_fns nft_trans_alloc fndecl 3 39815 NULL
+btrfs_search_slot_for_read_fndecl_39816_fns btrfs_search_slot_for_read fndecl 0 39816 NULL
+init_rx_ring_fndecl_39832_fns init_rx_ring fndecl 4 39832 NULL nohasharray
+dpcm_show_state_fndecl_39832_fns dpcm_show_state fndecl 0 39832 &init_rx_ring_fndecl_39832_fns
+carl9170_debugfs_write_fndecl_39866_fns carl9170_debugfs_write fndecl 3 39866 NULL
+do_shrink_slab_fndecl_39881_fns do_shrink_slab fndecl 4-3 39881 NULL
+debug_fcp_fndecl_39887_fns debug_fcp fndecl 2 39887 NULL
+len_cache_request_39888_fns len cache_request 0 39888 NULL
+frame_vector_create_fndecl_39918_fns frame_vector_create fndecl 1 39918 NULL nohasharray
+mgmt_get_all_if_id_fndecl_39918_fns mgmt_get_all_if_id fndecl 0 39918 &frame_vector_create_fndecl_39918_fns
+inode2sd_v1_fndecl_39954_fns inode2sd_v1 fndecl 3 39954 NULL
+readbuf_size_tomoyo_io_buffer_39976_fns readbuf_size tomoyo_io_buffer 0 39976 NULL
+agp_3_5_isochronous_node_enable_fndecl_39978_fns agp_3_5_isochronous_node_enable fndecl 3 39978 NULL
+compat_do_msg_fill_fndecl_39987_fns compat_do_msg_fill fndecl 3 39987 NULL
+size_fm10k_l2_accel_39996_fns size fm10k_l2_accel 0 39996 NULL
+isr_decrypt_done_read_fndecl_40001_fns isr_decrypt_done_read fndecl 3 40001 NULL
+cifs_dump_mem_fndecl_40013_fns cifs_dump_mem fndecl 3 40013 NULL
+emulator_write_phys_fndecl_40035_fns emulator_write_phys fndecl 2-4 40035 NULL
+iwl_dbgfs_disable_power_off_read_fndecl_40062_fns iwl_dbgfs_disable_power_off_read fndecl 3 40062 NULL
+rx_queue_add_kobject_fndecl_40068_fns rx_queue_add_kobject fndecl 0 40068 NULL
+x25_asy_maxdev_vardecl_x25_asy_c_40074_fns x25_asy_maxdev vardecl_x25_asy.c 0 40074 NULL
+num_parents_clk_core_40091_fns num_parents clk_core 0 40091 NULL
+rx_buf_use_size_bnx2_40094_fns rx_buf_use_size bnx2 0 40094 NULL
+sctp_setsockopt_default_send_param_fndecl_40121_fns sctp_setsockopt_default_send_param fndecl 3 40121 NULL
+smk_write_doi_fndecl_40134_fns smk_write_doi fndecl 3 40134 NULL
+port_fops_read_fndecl_40137_fns port_fops_read fndecl 3 40137 NULL
+isr_wakeups_read_fndecl_40148_fns isr_wakeups_read fndecl 3 40148 NULL
+command_setlights_fndecl_40187_fns command_setlights fndecl 0 40187 NULL
+ath6kl_bgscan_int_write_fndecl_40201_fns ath6kl_bgscan_int_write fndecl 3 40201 NULL
+kbuf_alloc_2_sgl_fndecl_40216_fns kbuf_alloc_2_sgl fndecl 1 40216 NULL
+ipw_queue_tx_init_fndecl_40218_fns ipw_queue_tx_init fndecl 3 40218 NULL
+il4965_rs_sta_dbgfs_stats_table_read_fndecl_40229_fns il4965_rs_sta_dbgfs_stats_table_read fndecl 3 40229 NULL
+do_jffs2_getxattr_fndecl_40233_fns do_jffs2_getxattr fndecl 0 40233 NULL
+skl_get_module_params_fndecl_40234_fns skl_get_module_params fndecl 3 40234 NULL
+iwl_dbgfs_ucode_general_stats_read_fndecl_40252_fns iwl_dbgfs_ucode_general_stats_read fndecl 3 40252 NULL
+digest_size_public_key_signature_40282_fns digest_size public_key_signature 0 40282 NULL
+rx_filter_beacon_filter_read_fndecl_40300_fns rx_filter_beacon_filter_read fndecl 3 40300 NULL
+num_engines_dmm_40301_fns num_engines dmm 0 40301 NULL
+ieee80211_if_read_rssi_threshold_fndecl_40319_fns ieee80211_if_read_rssi_threshold fndecl 3 40319 NULL
+uio_read_fndecl_40327_fns uio_read fndecl 3 40327 NULL
+nvif_notify_init_fndecl_40342_fns nvif_notify_init fndecl 7-6 40342 NULL
+srpt_alloc_ioctx_ring_fndecl_40353_fns srpt_alloc_ioctx_ring fndecl 2-3-4 40353 NULL
+tool_link_event_write_fndecl_40366_fns tool_link_event_write fndecl 3 40366 NULL
+SYSC_mincore_fndecl_40372_fns SYSC_mincore fndecl 2-1 40372 NULL
+__vmalloc_node_fndecl_40382_fns __vmalloc_node fndecl 1 40382 NULL
+qsfp_read_fndecl_40391_fns qsfp_read fndecl 0-3-5 40391 NULL
+joydev_ioctl_common_fndecl_40412_fns joydev_ioctl_common fndecl 2 40412 NULL
+applesmc_create_nodes_fndecl_40419_fns applesmc_create_nodes fndecl 2 40419 NULL
+rx_streaming_always_read_fndecl_40426_fns rx_streaming_always_read fndecl 3 40426 NULL
+tnode_alloc_fndecl_40428_fns tnode_alloc fndecl 1 40428 NULL
+iscsi_alloc_session_fndecl_40445_fns iscsi_alloc_session fndecl 3 40445 NULL
+qd2index_fndecl_40449_fns qd2index fndecl 0 40449 NULL
+submit_create_fndecl_40462_fns submit_create fndecl 3 40462 NULL
+__copy_from_user_inatomic_nocache_fndecl_40466_fns __copy_from_user_inatomic_nocache fndecl 3 40466 NULL
+xfs_rmap_update_create_intent_fndecl_40493_fns xfs_rmap_update_create_intent fndecl 2 40493 NULL
+num_substreams_snd_m3_40528_fns num_substreams snd_m3 0 40528 NULL
+nf_sockopt_fndecl_40555_fns nf_sockopt fndecl 0 40555 NULL
+alloc_ebda_hpc_fndecl_40557_fns alloc_ebda_hpc fndecl 1-2 40557 NULL
+security_context_to_sid_fndecl_40560_fns security_context_to_sid fndecl 2 40560 NULL
+isdn_read_fndecl_40566_fns isdn_read fndecl 3 40566 NULL
+xlog_recovery_process_trans_fndecl_40575_fns xlog_recovery_process_trans fndecl 4 40575 NULL
+ioread8_fndecl_40594_fns ioread8 fndecl 0 40594 NULL
+android_set_cntry_fndecl_40615_fns android_set_cntry fndecl 0 40615 NULL
+read_file_slot_fndecl_40620_fns read_file_slot fndecl 3 40620 NULL
+__kfifo_dma_in_prepare_fndecl_40626_fns __kfifo_dma_in_prepare fndecl 4 40626 NULL
+pcpu_get_vm_areas_fndecl_40630_fns pcpu_get_vm_areas fndecl 3 40630 NULL
+altera_swap_dr_fndecl_40633_fns altera_swap_dr fndecl 2 40633 NULL
+sock_setsockopt_fndecl_40635_fns sock_setsockopt fndecl 5 40635 NULL nohasharray
+cfg_fcp_io_channel_lpfc_hba_40635_fns cfg_fcp_io_channel lpfc_hba 0 40635 &sock_setsockopt_fndecl_40635_fns
+ocrdma_dbgfs_ops_write_fndecl_40664_fns ocrdma_dbgfs_ops_write fndecl 3 40664 NULL
+rx_filter_ibss_filter_read_fndecl_40676_fns rx_filter_ibss_filter_read fndecl 3 40676 NULL
+odev_update_fndecl_40682_fns odev_update fndecl 2 40682 NULL
+ahd_probe_stack_size_fndecl_40683_fns ahd_probe_stack_size fndecl 0 40683 NULL
+tx_frag_need_fragmentation_read_fndecl_40698_fns tx_frag_need_fragmentation_read fndecl 3 40698 NULL
+aa_simple_write_to_buffer_fndecl_40704_fns aa_simple_write_to_buffer fndecl 4 40704 NULL
+write_pool_fndecl_40741_fns write_pool fndecl 3 40741 NULL
+sys_gethostname_fndecl_40753_fns sys_gethostname fndecl 2 40753 NULL
+btrfs_chunk_num_stripes_fndecl_40772_fns btrfs_chunk_num_stripes fndecl 0 40772 NULL
+snd_hdac_get_connections_fndecl_40773_fns snd_hdac_get_connections fndecl 0 40773 NULL
+key_conf_keylen_read_fndecl_40781_fns key_conf_keylen_read fndecl 3 40781 NULL
+scsi_log_print_sense_fndecl_40783_fns scsi_log_print_sense fndecl 5 40783 NULL
+sys_fsetxattr_fndecl_40795_fns sys_fsetxattr fndecl 4 40795 NULL
+ath10k_wmi_alloc_chunk_fndecl_40804_fns ath10k_wmi_alloc_chunk fndecl 3-4-0 40804 NULL
+fuse_conn_waiting_read_fndecl_40817_fns fuse_conn_waiting_read fndecl 3 40817 NULL
+length_sst_dsp_header_40829_fns length sst_dsp_header 0 40829 NULL
+v9fs_file_fsync_dotl_fndecl_40845_fns v9fs_file_fsync_dotl fndecl 2-3 40845 NULL
+nfs_file_fsync_fndecl_40851_fns nfs_file_fsync fndecl 2-3 40851 NULL
+ecc_step_ds_nand_chip_40865_fns ecc_step_ds nand_chip 0 40865 NULL
+slow_user_access_fndecl_40877_fns slow_user_access fndecl 5 40877 NULL
+gtt_sa_num_of_chunks_kfd_dev_40890_fns gtt_sa_num_of_chunks kfd_dev 0 40890 NULL
+sctp_setsockopt_bindx_fndecl_40925_fns sctp_setsockopt_bindx fndecl 3 40925 NULL
+sg_nents_for_len_fndecl_40942_fns sg_nents_for_len fndecl 0 40942 NULL
+az6007_write_fndecl_40948_fns az6007_write fndecl 6 40948 NULL
+size_v4l2_ext_control_40952_fns size v4l2_ext_control 0 40952 NULL
+ns_segnum_the_nilfs_40959_fns ns_segnum the_nilfs 0 40959 NULL
+isr_low_rssi_read_fndecl_40966_fns isr_low_rssi_read fndecl 3 40966 NULL
+regmap_reg_ranges_read_file_fndecl_40973_fns regmap_reg_ranges_read_file fndecl 3 40973 NULL
+blk_mq_init_tags_fndecl_40986_fns blk_mq_init_tags fndecl 1 40986 NULL
+start_fb_cmap_41001_fns start fb_cmap 0 41001 NULL nohasharray
+gfn_to_page_fndecl_41001_fns gfn_to_page fndecl 2 41001 &start_fb_cmap_41001_fns
+nfsctl_transaction_write_fndecl_41011_fns nfsctl_transaction_write fndecl 3 41011 NULL
+rfkill_fop_write_fndecl_41019_fns rfkill_fop_write fndecl 3 41019 NULL
+lprocfs_write_u64_helper_fndecl_41059_fns lprocfs_write_u64_helper fndecl 2 41059 NULL
+userio_char_read_fndecl_41065_fns userio_char_read fndecl 3 41065 NULL
+qp_table_size_rvt_qp_ibdev_41075_fns qp_table_size rvt_qp_ibdev 0 41075 NULL
+gfn_to_pfn_fndecl_41077_fns gfn_to_pfn fndecl 2 41077 NULL
+pci_vc_do_save_buffer_fndecl_41087_fns pci_vc_do_save_buffer fndecl 0 41087 NULL
+iq_autocal_len_p54_common_41089_fns iq_autocal_len p54_common 0 41089 NULL
+sigma_fw_load_data_fndecl_41096_fns sigma_fw_load_data fndecl 3 41096 NULL
+input_leds_get_count_fndecl_41102_fns input_leds_get_count fndecl 0 41102 NULL
+ip_options_get_from_user_fndecl_41133_fns ip_options_get_from_user fndecl 4 41133 NULL
+data_len_b43_dfs_file_41135_fns data_len b43_dfs_file 0 41135 NULL
+nilfs_sufile_get_blkoff_fndecl_41139_fns nilfs_sufile_get_blkoff fndecl 0-2 41139 NULL
+usb_reset_and_verify_device_fndecl_41142_fns usb_reset_and_verify_device fndecl 0 41142 NULL
+calib_fail_count_read_fndecl_41171_fns calib_fail_count_read fndecl 3 41171 NULL
+suspend_dtim_interval_read_fndecl_41176_fns suspend_dtim_interval_read fndecl 3 41176 NULL
+traceprobe_probes_write_fndecl_41178_fns traceprobe_probes_write fndecl 3 41178 NULL
+nr_pages_page_collect_41197_fns nr_pages page_collect 0 41197 NULL
+sq905_command_fndecl_41201_fns sq905_command fndecl 0 41201 NULL
+nr_acpi_bits_vardecl_xen_acpi_processor_c_41210_fns nr_acpi_bits vardecl_xen-acpi-processor.c 0 41210 NULL
+fanout_set_data_fndecl_41219_fns fanout_set_data fndecl 3 41219 NULL
+prctl_set_mm_fndecl_41225_fns prctl_set_mm fndecl 3 41225 NULL
+out_count_mdc800_data_41228_fns out_count mdc800_data 0 41228 NULL
+ies_len_connect_attr_41234_fns ies_len connect_attr 0 41234 NULL
+opera1_usb_i2c_msgxfer_fndecl_41242_fns opera1_usb_i2c_msgxfer fndecl 4 41242 NULL
+sel_write_validatetrans_fndecl_41243_fns sel_write_validatetrans fndecl 3 41243 NULL
+iwl_dbgfs_ucode_tracing_write_fndecl_41247_fns iwl_dbgfs_ucode_tracing_write fndecl 3 41247 NULL
+__apei_exec_run_fndecl_41248_fns __apei_exec_run fndecl 0 41248 NULL
+num_threads_acpi_db_method_info_41261_fns num_threads acpi_db_method_info 0 41261 NULL
+vb2_queue_init_fndecl_41292_fns vb2_queue_init fndecl 0 41292 NULL
+kfd_set_pasid_limit_fndecl_41300_fns kfd_set_pasid_limit fndecl 1 41300 NULL
+img_SRAM_size_fw_hdr_41311_fns img_SRAM_size fw_hdr 0 41311 NULL nohasharray
+d40_size_2_dmalen_fndecl_41311_fns d40_size_2_dmalen fndecl 0-3-2-1 41311 &img_SRAM_size_fw_hdr_41311_fns
+cma_declare_contiguous_fndecl_41316_fns cma_declare_contiguous fndecl 2-5 41316 NULL
+fanotify_write_fndecl_41340_fns fanotify_write fndecl 3 41340 NULL
+regmap_read_debugfs_fndecl_41345_fns regmap_read_debugfs fndecl 5 41345 NULL
+tlbflush_read_file_fndecl_41350_fns tlbflush_read_file fndecl 3 41350 NULL
+efx_tsoh_get_buffer_fndecl_41355_fns efx_tsoh_get_buffer fndecl 3 41355 NULL
+usb_stor_probe1_fndecl_41357_fns usb_stor_probe1 fndecl 0 41357 NULL
+rx_rx_out_of_mpdu_nodes_read_fndecl_41359_fns rx_rx_out_of_mpdu_nodes_read fndecl 3 41359 NULL
+_iwl_dbgfs_d0i3_refs_write_fndecl_41361_fns _iwl_dbgfs_d0i3_refs_write fndecl 3 41361 NULL
+snic_dump_desc_fndecl_41372_fns snic_dump_desc fndecl 3 41372 NULL
+max_frame_size_mgsl_struct_41374_fns max_frame_size mgsl_struct 0 41374 NULL
+TupleDataMax_tuple_t_41376_fns TupleDataMax tuple_t 0 41376 NULL
+l_tree_depth_ocfs2_extent_list_41398_fns l_tree_depth ocfs2_extent_list 0 41398 NULL
+nr_free_zone_pages_fndecl_41403_fns nr_free_zone_pages fndecl 0 41403 NULL
+virtio_cread8_fndecl_41431_fns virtio_cread8 fndecl 0 41431 NULL
+dapm_bias_read_file_fndecl_41432_fns dapm_bias_read_file fndecl 3 41432 NULL
+__feat_register_sp_fndecl_41435_fns __feat_register_sp fndecl 6 41435 NULL
+rt2x00debug_write_csr_fndecl_41442_fns rt2x00debug_write_csr fndecl 3 41442 NULL
+sensor_write_reg_fndecl_41455_fns sensor_write_reg fndecl 0 41455 NULL
+squashfs_read_inode_lookup_table_fndecl_41456_fns squashfs_read_inode_lookup_table fndecl 4 41456 NULL
+bio_map_kern_fndecl_41468_fns bio_map_kern fndecl 3 41468 NULL
+redirected_tty_write_fndecl_41474_fns redirected_tty_write fndecl 3 41474 NULL
+get_var_len_fndecl_41483_fns get_var_len fndecl 0 41483 NULL
+_iwl_dbgfs_quota_min_write_fndecl_41492_fns _iwl_dbgfs_quota_min_write fndecl 3 41492 NULL
+compat_core_sys_select_fndecl_41494_fns compat_core_sys_select fndecl 1 41494 NULL
+unpack_array_fndecl_41525_fns unpack_array fndecl 0 41525 NULL
+pci_vpd_find_tag_fndecl_41534_fns pci_vpd_find_tag fndecl 0 41534 NULL
+alloc_cpu_rmap_fndecl_41536_fns alloc_cpu_rmap fndecl 1 41536 NULL
+max_nr_ports_virtio_console_config_41559_fns max_nr_ports virtio_console_config 0 41559 NULL
+fpa_set_fndecl_41560_fns fpa_set fndecl 3-4 41560 NULL
+dma_rx_requested_read_fndecl_41561_fns dma_rx_requested_read fndecl 3 41561 NULL
+stv0680_handle_error_fndecl_41563_fns stv0680_handle_error fndecl 0-2 41563 NULL
+__alloc_bootmem_nopanic_fndecl_41574_fns __alloc_bootmem_nopanic fndecl 1 41574 NULL
+__read_vmcore_fndecl_41577_fns __read_vmcore fndecl 2 41577 NULL
+iio_device_add_channel_sysfs_fndecl_41581_fns iio_device_add_channel_sysfs fndecl 0 41581 NULL
+pwr_sleep_percent_read_fndecl_41600_fns pwr_sleep_percent_read fndecl 3 41600 NULL
+xpc_kzalloc_cacheline_aligned_fndecl_41610_fns xpc_kzalloc_cacheline_aligned fndecl 1 41610 NULL
+device_add_groups_fndecl_41628_fns device_add_groups fndecl 0 41628 NULL
+drm_calloc_large_fndecl_41630_fns drm_calloc_large fndecl 1-2 41630 NULL
+tx_ring_size_jme_adapter_41640_fns tx_ring_size jme_adapter 0 41640 NULL
+clear_user_fndecl_41645_fns clear_user fndecl 2 41645 NULL
+dpcm_state_read_file_fndecl_41666_fns dpcm_state_read_file fndecl 3 41666 NULL
+error_null_frame_cts_start_read_fndecl_41668_fns error_null_frame_cts_start_read fndecl 3 41668 NULL
+nvme_trans_standard_inquiry_page_fndecl_41701_fns nvme_trans_standard_inquiry_page fndecl 4 41701 NULL
+tree_mod_log_eb_copy_fndecl_41708_fns tree_mod_log_eb_copy fndecl 6 41708 NULL
+gfs2_dir_mvino_fndecl_41733_fns gfs2_dir_mvino fndecl 4 41733 NULL
+v4l2_ctrl_handler_init_class_fndecl_41742_fns v4l2_ctrl_handler_init_class fndecl 2 41742 NULL
+insert_dent_fndecl_41753_fns insert_dent fndecl 7 41753 NULL
+vop_virtio_copy_to_user_fndecl_41756_fns vop_virtio_copy_to_user fndecl 4-3 41756 NULL
+ovs_nla_add_action_fndecl_41757_fns ovs_nla_add_action fndecl 4-0 41757 NULL
+__alloc_bootmem_node_high_fndecl_41767_fns __alloc_bootmem_node_high fndecl 2 41767 NULL
+batadv_socket_write_fndecl_41768_fns batadv_socket_write fndecl 3 41768 NULL
+pcibios_enable_device_fndecl_41776_fns pcibios_enable_device fndecl 0 41776 NULL
+outlen_mlx5_cmd_debug_41806_fns outlen mlx5_cmd_debug 0 41806 NULL
+ath9k_dump_mci_btcoex_fndecl_41809_fns ath9k_dump_mci_btcoex fndecl 0 41809 NULL
+scsi_add_host_with_dma_fndecl_41814_fns scsi_add_host_with_dma fndecl 0 41814 NULL
+i2c_bus_write_fndecl_41846_fns i2c_bus_write fndecl 0 41846 NULL
+nf_setsockopt_fndecl_41852_fns nf_setsockopt fndecl 0 41852 NULL
+from_seq_file_41897_fns from seq_file 0 41897 NULL
+b_read_mon_reader_bin_41923_fns b_read mon_reader_bin 0 41923 NULL nohasharray
+print_endpoint_stat_fndecl_41923_fns print_endpoint_stat fndecl 0-4 41923 &b_read_mon_reader_bin_41923_fns
+whci_n_caps_fndecl_41932_fns whci_n_caps fndecl 0 41932 NULL
+rx_rx_done_read_fndecl_41938_fns rx_rx_done_read fndecl 3 41938 NULL
+compat_packet_setsockopt_fndecl_41954_fns compat_packet_setsockopt fndecl 5 41954 NULL
+intel_atomic_legacy_gamma_set_fndecl_41955_fns intel_atomic_legacy_gamma_set fndecl 5 41955 NULL
+xfs_hex_dump_fndecl_41963_fns xfs_hex_dump fndecl 2 41963 NULL
+kmalloc_parameter_fndecl_41964_fns kmalloc_parameter fndecl 1 41964 NULL
+max_req_queues_qla_hw_data_41977_fns max_req_queues qla_hw_data 0 41977 NULL
+__send_control_msg_fndecl_41986_fns __send_control_msg fndecl 0 41986 NULL
+snd_pcm_oss_read1_fndecl_41992_fns snd_pcm_oss_read1 fndecl 3 41992 NULL
+snd_opl4_mem_proc_read_fndecl_41997_fns snd_opl4_mem_proc_read fndecl 5 41997 NULL
+selinux_secctx_to_secid_fndecl_42003_fns selinux_secctx_to_secid fndecl 2 42003 NULL
+set_flicker_fndecl_42011_fns set_flicker fndecl 0 42011 NULL
+__ieee80211_start_rx_ba_session_fndecl_42023_fns __ieee80211_start_rx_ba_session fndecl 7 42023 NULL
+copy_nodes_to_user_fndecl_42028_fns copy_nodes_to_user fndecl 2 42028 NULL
+mwifiex_11n_create_rx_reorder_tbl_fndecl_42029_fns mwifiex_11n_create_rx_reorder_tbl fndecl 4 42029 NULL
+spidev_compat_ioctl_fndecl_42033_fns spidev_compat_ioctl fndecl 2 42033 NULL
+regmap_multi_reg_write_fndecl_42049_fns regmap_multi_reg_write fndecl 3 42049 NULL
+sel_write_load_fndecl_42053_fns sel_write_load fndecl 3 42053 NULL
+namelen_xenpf_symdata_42085_fns namelen xenpf_symdata 0 42085 NULL
+read_page_owner_fndecl_42094_fns read_page_owner fndecl 3 42094 NULL
+do_syslog_fndecl_42100_fns do_syslog fndecl 3 42100 NULL
+tid_used_hfi1_filedata_42109_fns tid_used hfi1_filedata 0 42109 NULL
+jbd2_journal_init_dev_fndecl_42115_fns jbd2_journal_init_dev fndecl 5 42115 NULL
+snd_compr_write_fndecl_42144_fns snd_compr_write fndecl 3 42144 NULL
+__team_options_register_fndecl_42198_fns __team_options_register fndecl 3 42198 NULL
+construct_key_and_link_fndecl_42210_fns construct_key_and_link fndecl 3 42210 NULL
+num_q_vectors_igb_adapter_42232_fns num_q_vectors igb_adapter 0 42232 NULL
+len_wmi_tlv_42244_fns len wmi_tlv 0 42244 NULL
+nchunks_radeon_cs_parser_42251_fns nchunks radeon_cs_parser 0 42251 NULL
+iwl_dbgfs_bcast_filters_read_fndecl_42258_fns iwl_dbgfs_bcast_filters_read fndecl 3 42258 NULL
+read_kcore_fndecl_42259_fns read_kcore fndecl 3 42259 NULL
+snd_pcm_plug_write_transfer_fndecl_42268_fns snd_pcm_plug_write_transfer fndecl 3 42268 NULL
+write_file_spectral_period_fndecl_42275_fns write_file_spectral_period fndecl 3 42275 NULL
+f2fs_kmalloc_fndecl_42279_fns f2fs_kmalloc fndecl 1 42279 NULL nohasharray
+num_loaded_gcov_node_42279_fns num_loaded gcov_node 0 42279 &f2fs_kmalloc_fndecl_42279_fns
+append_to_buffer_fndecl_42285_fns append_to_buffer fndecl 3 42285 NULL
+efx_mcdi_rpc_async_fndecl_42298_fns efx_mcdi_rpc_async fndecl 4-5 42298 NULL
+rproc_alloc_fndecl_42314_fns rproc_alloc fndecl 5 42314 NULL
+kvm_write_guest_page_fndecl_42320_fns kvm_write_guest_page fndecl 5-2 42320 NULL
+soc_tplg_dapm_widget_dbytes_create_fndecl_42336_fns soc_tplg_dapm_widget_dbytes_create fndecl 2 42336 NULL
+hid_report_len_fndecl_42374_fns hid_report_len fndecl 0 42374 NULL
+salt_size_dm_verity_42377_fns salt_size dm_verity 0 42377 NULL
+mlx5_wq_ll_get_size_fndecl_42379_fns mlx5_wq_ll_get_size fndecl 0 42379 NULL
+num_cache_leaves_vardecl_intel_cacheinfo_c_42390_fns num_cache_leaves vardecl_intel_cacheinfo.c 0 42390 NULL
+no_of_vpath_vxgedev_42396_fns no_of_vpath vxgedev 0 42396 NULL
+maximum_v4l2_ctrl_42407_fns maximum v4l2_ctrl 0 42407 NULL
+hidraw_ioctl_fndecl_42425_fns hidraw_ioctl fndecl 2 42425 NULL
+bin_search_fndecl_42434_fns bin_search fndecl 0 42434 NULL
+write_file_spectral_fft_period_fndecl_42435_fns write_file_spectral_fft_period fndecl 3 42435 NULL
+rx_ring_size_jme_adapter_42440_fns rx_ring_size jme_adapter 0 42440 NULL
+rtl92ee_c2h_packet_handler_fndecl_42467_fns rtl92ee_c2h_packet_handler fndecl 3 42467 NULL
+max_allowed_qxl_monitors_config_42481_fns max_allowed qxl_monitors_config 0 42481 NULL
+hid_sensor_client_cnt_sensor_hub_data_42488_fns hid_sensor_client_cnt sensor_hub_data 0 42488 NULL
+bpf_check_classic_fndecl_42501_fns bpf_check_classic fndecl 2 42501 NULL
+__mic_dma_alloc_fndecl_42540_fns __mic_dma_alloc fndecl 2 42540 NULL
+qla8044_write_optrom_data_fndecl_42561_fns qla8044_write_optrom_data fndecl 4 42561 NULL
+ts_write_fndecl_42563_fns ts_write fndecl 3 42563 NULL
+usbtmc_write_fndecl_42567_fns usbtmc_write fndecl 3 42567 NULL
+ilo_write_fndecl_42601_fns ilo_write fndecl 3 42601 NULL nohasharray
+ndev_init_isr_fndecl_42601_fns ndev_init_isr fndecl 3 42601 &ilo_write_fndecl_42601_fns
+qlcnic_82xx_calculate_msix_vector_fndecl_42609_fns qlcnic_82xx_calculate_msix_vector fndecl 0 42609 NULL
+vendor_diag_write_fndecl_42612_fns vendor_diag_write fndecl 3 42612 NULL
+hashsize_Qdisc_class_hash_42616_fns hashsize Qdisc_class_hash 0 42616 NULL
+user_regset_copyin_fndecl_42619_fns user_regset_copyin fndecl 7 42619 NULL
+wlc_phy_loadsampletable_nphy_fndecl_42620_fns wlc_phy_loadsampletable_nphy fndecl 3 42620 NULL
+rx_hdr_overflow_read_fndecl_42628_fns rx_hdr_overflow_read fndecl 3 42628 NULL
+pidlist_allocate_fndecl_42631_fns pidlist_allocate fndecl 1 42631 NULL
+__kfifo_dma_out_finish_r_fndecl_42656_fns __kfifo_dma_out_finish_r fndecl 2 42656 NULL
+keyctl_get_security_fndecl_42673_fns keyctl_get_security fndecl 3 42673 NULL
+num_rx_bds_bcm_sysport_priv_42683_fns num_rx_bds bcm_sysport_priv 0 42683 NULL
+read_file_spectral_short_repeat_fndecl_42684_fns read_file_spectral_short_repeat fndecl 3 42684 NULL
+oom_adj_write_fndecl_42687_fns oom_adj_write fndecl 3 42687 NULL
+data_size_dm_ioctl_42701_fns data_size dm_ioctl 0 42701 NULL
+brcmf_fil_bsscfg_data_get_fndecl_42728_fns brcmf_fil_bsscfg_data_get fndecl 4 42728 NULL
+handle_abnormal_pfn_fndecl_42730_fns handle_abnormal_pfn fndecl 3 42730 NULL
+p54_parse_rssical_fndecl_42750_fns p54_parse_rssical fndecl 3 42750 NULL
+read_file_frameerrors_fndecl_42770_fns read_file_frameerrors fndecl 3 42770 NULL
+sync_maxlen_ipvs_sync_daemon_cfg_42773_fns sync_maxlen ipvs_sync_daemon_cfg 0 42773 NULL
+ssid_len_ath6kl_vif_42784_fns ssid_len ath6kl_vif 0 42784 NULL
+sl_realloc_bufs_fndecl_42821_fns sl_realloc_bufs fndecl 2 42821 NULL
+lbs_highrssi_read_fndecl_42826_fns lbs_highrssi_read fndecl 3 42826 NULL
+pcifront_bus_write_fndecl_42836_fns pcifront_bus_write fndecl 5 42836 NULL
+dlfb_ops_write_fndecl_42885_fns dlfb_ops_write fndecl 3 42885 NULL
+snic_req_init_fndecl_42890_fns snic_req_init fndecl 2 42890 NULL
+number_of_tds_fndecl_42895_fns number_of_tds fndecl 0 42895 NULL
+init_bch_fndecl_42897_fns init_bch fndecl 1-2 42897 NULL
+length_drm_property_blob_42912_fns length drm_property_blob 0 42912 NULL
+do_command_extended_fndecl_42913_fns do_command_extended fndecl 0 42913 NULL
+carl9170_handle_command_response_fndecl_42930_fns carl9170_handle_command_response fndecl 3 42930 NULL
+bnx2x_vf_mcast_fndecl_42933_fns bnx2x_vf_mcast fndecl 4 42933 NULL
+wm_coeff_tlv_get_fndecl_42961_fns wm_coeff_tlv_get fndecl 3 42961 NULL
+pof_reclen_boot_data_42966_fns pof_reclen boot_data 0 42966 NULL
+ea_len_fndecl_42998_fns ea_len fndecl 0 42998 NULL
+obd_ioctl_popdata_fndecl_43014_fns obd_ioctl_popdata fndecl 3 43014 NULL
+key_replays_read_fndecl_43017_fns key_replays_read fndecl 3 43017 NULL
+quirk_simultaneous_discovery_write_fndecl_43076_fns quirk_simultaneous_discovery_write fndecl 3 43076 NULL
+rx_fcs_err_read_fndecl_43119_fns rx_fcs_err_read fndecl 3 43119 NULL
+ndev_init_isr_fndecl_43138_fns ndev_init_isr fndecl 3 43138 NULL
+kvm_vcpu_gfn_to_pfn_fndecl_43158_fns kvm_vcpu_gfn_to_pfn fndecl 2 43158 NULL
+getdqbuf_fndecl_43183_fns getdqbuf fndecl 1 43183 NULL
+aoechr_write_fndecl_43184_fns aoechr_write fndecl 3 43184 NULL
+if_spi_host_to_card_fndecl_43193_fns if_spi_host_to_card fndecl 4 43193 NULL
+nilfs_cpfile_block_get_snapshot_list_fndecl_43198_fns nilfs_cpfile_block_get_snapshot_list fndecl 2 43198 NULL
+root_id___prelim_ref_43204_fns root_id __prelim_ref 0 43204 NULL
+try_async_pf_fndecl_43217_fns try_async_pf fndecl 3 43217 NULL
+nvif_object_mthd_fndecl_43235_fns nvif_object_mthd fndecl 4 43235 NULL
+send_write_fndecl_43242_fns send_write fndecl 2-0 43242 NULL
+agp_create_user_memory_fndecl_43256_fns agp_create_user_memory fndecl 1 43256 NULL
+persistent_ram_new_fndecl_43278_fns persistent_ram_new fndecl 1-2 43278 NULL
+of_property_read_string_array_fndecl_43294_fns of_property_read_string_array fndecl 0 43294 NULL
+qib_refresh_qsfp_cache_fndecl_43328_fns qib_refresh_qsfp_cache fndecl 0 43328 NULL
+debugfs_read_fndecl_43348_fns debugfs_read fndecl 3 43348 NULL
+__kmalloc_node_track_caller_fndecl_43349_fns __kmalloc_node_track_caller fndecl 1 43349 NULL
+get_subdir_fndecl_43366_fns get_subdir fndecl 3 43366 NULL
+compat_SyS_rt_sigpending_fndecl_43367_fns compat_SyS_rt_sigpending fndecl 2 43367 NULL
+xfrm_user_policy_fndecl_43390_fns xfrm_user_policy fndecl 4 43390 NULL
+init_range_memory_mapping_fndecl_43414_fns init_range_memory_mapping fndecl 1-2 43414 NULL
+pof_write_open_fndecl_43418_fns pof_write_open fndecl 0 43418 NULL
+lpfc_sli4_queue_alloc_fndecl_43429_fns lpfc_sli4_queue_alloc fndecl 3 43429 NULL
+memblock_alloc_nid_fndecl_43439_fns memblock_alloc_nid fndecl 1 43439 NULL
+fsg_common_set_num_buffers_fndecl_43440_fns fsg_common_set_num_buffers fndecl 2 43440 NULL
+dut_mode_write_fndecl_43445_fns dut_mode_write fndecl 3 43445 NULL
+eeprom_len_adm8211_priv_43457_fns eeprom_len adm8211_priv 0 43457 NULL
+printer_req_alloc_fndecl_43468_fns printer_req_alloc fndecl 2 43468 NULL
+ieee80211_set_probe_resp_fndecl_43519_fns ieee80211_set_probe_resp fndecl 3 43519 NULL
+ptp_read_fndecl_43520_fns ptp_read fndecl 4 43520 NULL
+_iwl_dbgfs_rx_phyinfo_write_fndecl_43525_fns _iwl_dbgfs_rx_phyinfo_write fndecl 3 43525 NULL
+xfs_dir2_leaf_getdents_fndecl_43533_fns xfs_dir2_leaf_getdents fndecl 3 43533 NULL
+ib_create_send_mad_fndecl_43569_fns ib_create_send_mad fndecl 5 43569 NULL
+ath10k_read_fw_dbglog_fndecl_43592_fns ath10k_read_fw_dbglog fndecl 3 43592 NULL
+ssize_datafab_info_43610_fns ssize datafab_info 0 43610 NULL
+chipshift_cfi_private_43621_fns chipshift cfi_private 0 43621 NULL
+__vb2_get_done_vb_fndecl_43624_fns __vb2_get_done_vb fndecl 0 43624 NULL
+edac_pci_alloc_ctl_info_fndecl_43663_fns edac_pci_alloc_ctl_info fndecl 1 43663 NULL nohasharray
+usbnet_read_cmd_nopm_fndecl_43663_fns usbnet_read_cmd_nopm fndecl 7 43663 &edac_pci_alloc_ctl_info_fndecl_43663_fns
+idmouse_read_fndecl_43677_fns idmouse_read fndecl 3 43677 NULL
+ingr_sz_sge_43689_fns ingr_sz sge 0 43689 NULL
+rxpipe_missed_beacon_host_int_trig_rx_data_read_fndecl_43710_fns rxpipe_missed_beacon_host_int_trig_rx_data_read fndecl 3 43710 NULL
+in_size_xz_buf_43724_fns in_size xz_buf 0 43724 NULL
+gfn_to_hva_many_fndecl_43742_fns gfn_to_hva_many fndecl 2 43742 NULL
+acpi_rs_strcpy_fndecl_43746_fns acpi_rs_strcpy fndecl 0 43746 NULL
+stat_end_vardecl_drv_c_43748_fns stat_end vardecl_drv.c 0 43748 NULL
+tipc_connect_fndecl_43766_fns tipc_connect fndecl 3 43766 NULL
+hwdep_read_fndecl_43779_fns hwdep_read fndecl 3 43779 NULL
+generic_file_fsync_fndecl_43780_fns generic_file_fsync fndecl 2-3 43780 NULL
+len_nft_set_ext_tmpl_43815_fns len nft_set_ext_tmpl 0 43815 NULL
+omap_dma_prep_slave_sg_fndecl_43825_fns omap_dma_prep_slave_sg fndecl 3 43825 NULL
+unlink1_fndecl_43840_fns unlink1 fndecl 3 43840 NULL
+br_fdb_external_learn_add_fndecl_43850_fns br_fdb_external_learn_add fndecl 4 43850 NULL
+iwl_dbgfs_fw_rx_stats_read_fndecl_43853_fns iwl_dbgfs_fw_rx_stats_read fndecl 3 43853 NULL
+scsi_host_alloc_fndecl_43858_fns scsi_host_alloc fndecl 2 43858 NULL
+Xdsdt_acpi_table_fadt_43871_fns Xdsdt acpi_table_fadt 0 43871 NULL
+sisusb_copy_memory_fndecl_43909_fns sisusb_copy_memory fndecl 4 43909 NULL
+iwl_dbgfs_sensitivity_read_fndecl_43935_fns iwl_dbgfs_sensitivity_read fndecl 3 43935 NULL
+iwl_mvm_coex_dump_mbox_fndecl_43938_fns iwl_mvm_coex_dump_mbox fndecl 0-3 43938 NULL
+sddr09_readX_fndecl_43951_fns sddr09_readX fndecl 7 43951 NULL
+brcmf_fil_cmd_data_set_fndecl_43952_fns brcmf_fil_cmd_data_set fndecl 4 43952 NULL
+hfsplus_file_fsync_fndecl_43969_fns hfsplus_file_fsync fndecl 2-3 43969 NULL
+smk_write_revoke_subj_fndecl_43990_fns smk_write_revoke_subj fndecl 3 43990 NULL
+vme_master_read_fndecl_44006_fns vme_master_read fndecl 0 44006 NULL
+nr_chnls_nvm_dev_44026_fns nr_chnls nvm_dev 0 44026 NULL nohasharray
+_iwl_dbgfs_stop_ctdp_write_fndecl_44026_fns _iwl_dbgfs_stop_ctdp_write fndecl 3 44026 &nr_chnls_nvm_dev_44026_fns
+response_length_ib_uverbs_ex_create_qp_resp_44030_fns response_length ib_uverbs_ex_create_qp_resp 0 44030 NULL
+wilc_gnrl_async_info_received_fndecl_44034_fns wilc_gnrl_async_info_received fndecl 3 44034 NULL
+fragmentation_threshold_read_fndecl_44037_fns fragmentation_threshold_read fndecl 3 44037 NULL
+nfp_net_set_ring_size_fndecl_44050_fns nfp_net_set_ring_size fndecl 3-2 44050 NULL
+nr_rings_xen_blkif_44058_fns nr_rings xen_blkif 0 44058 NULL
+prog_page_fndecl_44060_fns prog_page fndecl 2 44060 NULL
+mb_cache_create_fndecl_44082_fns mb_cache_create fndecl 1 44082 NULL nohasharray
+debug_pmt_fndecl_44082_fns debug_pmt fndecl 2 44082 &mb_cache_create_fndecl_44082_fns
+read_file_regval_fndecl_44093_fns read_file_regval fndecl 3 44093 NULL
+num_counter_active_fndecl_44110_fns num_counter_active fndecl 0 44110 NULL
+mls_compute_context_len_fndecl_44135_fns mls_compute_context_len fndecl 0 44135 NULL nohasharray
+udp_sendmsg_fndecl_44135_fns udp_sendmsg fndecl 3 44135 &mls_compute_context_len_fndecl_44135_fns
+error_tx_abort_failure_read_fndecl_44184_fns error_tx_abort_failure_read fndecl 3 44184 NULL
+evdev_compute_buffer_size_fndecl_44212_fns evdev_compute_buffer_size fndecl 0 44212 NULL
+SYSC_lsetxattr_fndecl_44222_fns SYSC_lsetxattr fndecl 4 44222 NULL
+clear_refs_write_fndecl_44227_fns clear_refs_write fndecl 3 44227 NULL
+it_context_support_fw_ohci_44232_fns it_context_support fw_ohci 0 44232 NULL
+rx_filter_arp_filter_read_fndecl_44233_fns rx_filter_arp_filter_read fndecl 3 44233 NULL
+au0828_init_isoc_fndecl_44238_fns au0828_init_isoc fndecl 3 44238 NULL
+spk_xs_vardecl_44242_fns spk_xs vardecl 0 44242 NULL
+features_virtio_device_44247_fns features virtio_device 0 44247 NULL
+lprocfs_write_frac_u64_helper_fndecl_44250_fns lprocfs_write_frac_u64_helper fndecl 2 44250 NULL
+roundup_ring_size_fndecl_44254_fns roundup_ring_size fndecl 0 44254 NULL
+gfn_to_pfn_memslot_atomic_fndecl_44264_fns gfn_to_pfn_memslot_atomic fndecl 2 44264 NULL
+il4965_ucode_rx_stats_read_fndecl_44271_fns il4965_ucode_rx_stats_read fndecl 3 44271 NULL
+efi_get_runtime_map_size_fndecl_44276_fns efi_get_runtime_map_size fndecl 0 44276 NULL
+mlxsw_core_reg_access_fndecl_44306_fns mlxsw_core_reg_access fndecl 0 44306 NULL
+snd_pcm_lib_writev_transfer_fndecl_44344_fns snd_pcm_lib_writev_transfer fndecl 5 44344 NULL
+btrfs_item_size_fndecl_44350_fns btrfs_item_size fndecl 0 44350 NULL
+pwm_buf_sz_usbdux_private_44375_fns pwm_buf_sz usbdux_private 0 44375 NULL
+wmi_evt_connect_fndecl_44385_fns wmi_evt_connect fndecl 4 44385 NULL
+hidpp_prefix_name_fndecl_44393_fns hidpp_prefix_name fndecl 2 44393 NULL
+num_rx_rings_nfp_net_44395_fns num_rx_rings nfp_net 0 44395 NULL
+drbd_create_device_fndecl_44410_fns drbd_create_device fndecl 2 44410 NULL
+ept_gpte_to_gfn_lvl_fndecl_44420_fns ept_gpte_to_gfn_lvl fndecl 0-2-1 44420 NULL
+seq_open_private_fndecl_44422_fns seq_open_private fndecl 3 44422 NULL
+__get_vm_area_fndecl_44428_fns __get_vm_area fndecl 1 44428 NULL
+ieee80211_if_read_rc_rateidx_mask_2ghz_fndecl_44433_fns ieee80211_if_read_rc_rateidx_mask_2ghz fndecl 3 44433 NULL
+fan_proc_write_fndecl_44434_fns fan_proc_write fndecl 3 44434 NULL
+fd_do_rw_fndecl_44435_fns fd_do_rw fndecl 5 44435 NULL
+nchunks_amdgpu_cs_parser_44436_fns nchunks amdgpu_cs_parser 0 44436 NULL
+get_pages_array_fndecl_44453_fns get_pages_array fndecl 1 44453 NULL
+configfs_write_file_fndecl_44454_fns configfs_write_file fndecl 3 44454 NULL
+__get_inode_info_fndecl_44463_fns __get_inode_info fndecl 0 44463 NULL
+seq_count_iscsi_cmd_44476_fns seq_count iscsi_cmd 0 44476 NULL
+resize_stripes_fndecl_44481_fns resize_stripes fndecl 2 44481 NULL
+mei_dbgfs_read_state_fndecl_44492_fns mei_dbgfs_read_state fndecl 3 44492 NULL
+len_de4x5_ioctl_44508_fns len de4x5_ioctl 0 44508 NULL
+sddr09_read20_fndecl_44519_fns sddr09_read20 fndecl 4-3-6 44519 NULL
+filter_read_fndecl_44527_fns filter_read fndecl 3 44527 NULL
+smk_read_syslog_fndecl_44544_fns smk_read_syslog fndecl 3 44544 NULL
+numps_powernow_k8_data_44546_fns numps powernow_k8_data 0 44546 NULL
+ion_handle_test_dma_fndecl_44581_fns ion_handle_test_dma fndecl 4-5 44581 NULL
+maxcontacts_pm_44593_fns maxcontacts pm 0 44593 NULL
+len_poll_list_44603_fns len poll_list 0 44603 NULL
+il_dbgfs_sram_read_fndecl_44619_fns il_dbgfs_sram_read fndecl 3 44619 NULL
+log_page_size_mlx5_srq_attr_44642_fns log_page_size mlx5_srq_attr 0 44642 NULL
+bank_mask_stub_chip_44647_fns bank_mask stub_chip 0 44647 NULL
+udf_sb_alloc_partition_maps_fndecl_44666_fns udf_sb_alloc_partition_maps fndecl 2 44666 NULL nohasharray
+num_desc_pages__drm_via_sg_info_44666_fns num_desc_pages _drm_via_sg_info 0 44666 &udf_sb_alloc_partition_maps_fndecl_44666_fns
+xfpregs_set_fndecl_44680_fns xfpregs_set fndecl 4 44680 NULL
+one_qsfp_read_fndecl_44705_fns one_qsfp_read fndecl 3-5 44705 NULL
+asic_flags_write_fndecl_44717_fns asic_flags_write fndecl 3 44717 NULL
+altera_irscan_fndecl_44719_fns altera_irscan fndecl 2 44719 NULL
+register_netdevice_fndecl_44725_fns register_netdevice fndecl 0 44725 NULL
+kmalloc_order_fndecl_44727_fns kmalloc_order fndecl 1 44727 NULL
+amdgpu_job_alloc_fndecl_44730_fns amdgpu_job_alloc fndecl 2 44730 NULL
+erst_clearer_fndecl_44743_fns erst_clearer fndecl 2 44743 NULL
+brd_probe_fndecl_44758_fns brd_probe fndecl 1 44758 NULL
+fd_locked_ioctl_fndecl_44809_fns fd_locked_ioctl fndecl 3 44809 NULL
+ndev_debugfs_read_fndecl_44812_fns ndev_debugfs_read fndecl 3 44812 NULL
+count_atl1c_tpd_ring_44824_fns count atl1c_tpd_ring 0 44824 NULL
+squashfs_read_id_index_table_fndecl_44826_fns squashfs_read_id_index_table fndecl 4 44826 NULL
+snprint_stack_trace_fndecl_44832_fns snprint_stack_trace fndecl 0 44832 NULL
+dequeue_event_fndecl_44835_fns dequeue_event fndecl 3 44835 NULL
+xt_compat_match_offset_fndecl_44840_fns xt_compat_match_offset fndecl 0 44840 NULL nohasharray
+acpi_parse_entries_array_fndecl_44840_fns acpi_parse_entries_array fndecl 0 44840 &xt_compat_match_offset_fndecl_44840_fns
+exofs_readpages_fndecl_44841_fns exofs_readpages fndecl 4 44841 NULL
+pmcraid_build_passthrough_ioadls_fndecl_44865_fns pmcraid_build_passthrough_ioadls fndecl 2 44865 NULL
+intel_setup_irq_remapping_fndecl_44868_fns intel_setup_irq_remapping fndecl 0 44868 NULL
+num_resources_platform_device_44886_fns num_resources platform_device 0 44886 NULL
+SYSC_select_fndecl_44891_fns SYSC_select fndecl 1 44891 NULL
+do_pselect_fndecl_44926_fns do_pselect fndecl 1 44926 NULL
+device_add_attrs_fndecl_44964_fns device_add_attrs fndecl 0 44964 NULL
+qib_diag_write_fndecl_44966_fns qib_diag_write fndecl 3 44966 NULL nohasharray
+kobject_add_varg_fndecl_44966_fns kobject_add_varg fndecl 0 44966 &qib_diag_write_fndecl_44966_fns
+prism54_wpa_bss_ie_get_fndecl_45006_fns prism54_wpa_bss_ie_get fndecl 0 45006 NULL
+mlx5e_redirect_rqt_fndecl_45007_fns mlx5e_redirect_rqt fndecl 3 45007 NULL
+video_usercopy_fndecl_45012_fns video_usercopy fndecl 2 45012 NULL
+sock_kmalloc_fndecl_45038_fns sock_kmalloc fndecl 2 45038 NULL
+write_file_dfs_fndecl_45047_fns write_file_dfs fndecl 3 45047 NULL
+alloc_upcall_fndecl_45049_fns alloc_upcall fndecl 2 45049 NULL nohasharray
+ib_uverbs_rereg_mr_fndecl_45049_fns ib_uverbs_rereg_mr fndecl 4-5 45049 &alloc_upcall_fndecl_45049_fns
+nd_cmd_out_size_fndecl_45105_fns nd_cmd_out_size fndecl 0 45105 NULL nohasharray
+head_timestamp_event_queue_45105_fns head timestamp_event_queue 0 45105 &nd_cmd_out_size_fndecl_45105_fns
+dma_map_mr_pas_fndecl_45126_fns dma_map_mr_pas fndecl 3 45126 NULL
+copyout_from_xsaves_fndecl_45153_fns copyout_from_xsaves fndecl 2 45153 NULL
+pwc_get_fps_Nala_fndecl_45162_fns pwc_get_fps_Nala fndecl 0 45162 NULL
+cmd_sg_cnt_srp_target_port_45169_fns cmd_sg_cnt srp_target_port 0 45169 NULL
+n_ao_urbs_usbdux_private_45171_fns n_ao_urbs usbdux_private 0 45171 NULL
+opticon_write_fndecl_45172_fns opticon_write fndecl 4 45172 NULL
+acl_alloc_num_fndecl_45177_fns acl_alloc_num fndecl 1-2 45177 NULL
+pwr_tx_with_ps_read_fndecl_45216_fns pwr_tx_with_ps_read fndecl 3 45216 NULL
+hsu_dma_alloc_desc_fndecl_45228_fns hsu_dma_alloc_desc fndecl 1 45228 NULL
+ext4_update_inline_data_fndecl_45259_fns ext4_update_inline_data fndecl 3 45259 NULL
+alloc_buf_fndecl_45267_fns alloc_buf fndecl 3 45267 NULL
+uart_input_count_oxygen_45274_fns uart_input_count oxygen 0 45274 NULL
+iio_debugfs_read_reg_fndecl_45311_fns iio_debugfs_read_reg fndecl 3 45311 NULL
+tstats_write_fndecl_45315_fns tstats_write fndecl 3 45315 NULL
+of_property_count_elems_of_size_fndecl_45337_fns of_property_count_elems_of_size fndecl 3 45337 NULL
+excessive_retries_read_fndecl_45338_fns excessive_retries_read fndecl 3 45338 NULL
+ablkcipher_giv_edesc_alloc_fndecl_45340_fns ablkcipher_giv_edesc_alloc fndecl 2 45340 NULL
+msix_count_i40iw_device_45370_fns msix_count i40iw_device 0 45370 NULL
+ebcnt_vardecl_speedtest_c_45398_fns ebcnt vardecl_speedtest.c 0 45398 NULL
+brcmf_init_nvram_parser_fndecl_45415_fns brcmf_init_nvram_parser fndecl 3 45415 NULL
+pos_c4iw_debugfs_data_45424_fns pos c4iw_debugfs_data 0 45424 NULL
+nfsd_hashsize_fndecl_45441_fns nfsd_hashsize fndecl 0 45441 NULL
+rvt_alloc_device_fndecl_45442_fns rvt_alloc_device fndecl 2 45442 NULL
+pmem_do_bvec_fndecl_45443_fns pmem_do_bvec fndecl 3 45443 NULL
+nonpaging_map_fndecl_45460_fns nonpaging_map fndecl 4 45460 NULL
+ssize_jumpshot_info_45467_fns ssize jumpshot_info 0 45467 NULL
+index_nullb_45470_fns index nullb 0 45470 NULL
+memblock_virt_alloc_try_nid_nopanic_fndecl_45487_fns memblock_virt_alloc_try_nid_nopanic fndecl 1 45487 NULL
+acl_alloc_stack_init_fndecl_45509_fns acl_alloc_stack_init fndecl 1 45509 NULL
+ptr_ring_init_fndecl_45512_fns ptr_ring_init fndecl 2 45512 NULL
+count_scpi_dvfs_info_45519_fns count scpi_dvfs_info 0 45519 NULL
+wl1273_fm_fops_write_fndecl_45534_fns wl1273_fm_fops_write fndecl 3 45534 NULL
+arch_setup_dma_ops_fndecl_45543_fns arch_setup_dma_ops fndecl 3 45543 NULL
+ieee80211_if_read_dot11MeshConfirmTimeout_fndecl_45549_fns ieee80211_if_read_dot11MeshConfirmTimeout fndecl 3 45549 NULL
+srp_create_fr_pool_fndecl_45572_fns srp_create_fr_pool fndecl 3 45572 NULL
+arch_hibernation_header_save_fndecl_45583_fns arch_hibernation_header_save fndecl 0 45583 NULL
+f2fs_sync_file_fndecl_45585_fns f2fs_sync_file fndecl 2-3 45585 NULL
+wpan_phy_new_fndecl_45593_fns wpan_phy_new fndecl 2 45593 NULL
+slave_init_fndecl_45597_fns slave_init fndecl 0 45597 NULL
+smk_read_ambient_fndecl_45623_fns smk_read_ambient fndecl 3 45623 NULL
+ib_uverbs_modify_srq_fndecl_45645_fns ib_uverbs_modify_srq fndecl 4-5 45645 NULL
+bnxt_alloc_vf_resources_fndecl_45660_fns bnxt_alloc_vf_resources fndecl 2 45660 NULL
+xfer_from_user_fndecl_45672_fns xfer_from_user fndecl 3 45672 NULL
+videobuf_dqbuf_fndecl_45673_fns videobuf_dqbuf fndecl 0 45673 NULL
+sys_add_key_fndecl_45691_fns sys_add_key fndecl 4 45691 NULL nohasharray
+nvme_trans_copy_to_user_fndecl_45691_fns nvme_trans_copy_to_user fndecl 3 45691 &sys_add_key_fndecl_45691_fns
+__netdev_adjacent_dev_insert_fndecl_45697_fns __netdev_adjacent_dev_insert fndecl 0 45697 NULL
+write_file_spectral_short_repeat_fndecl_45700_fns write_file_spectral_short_repeat fndecl 3 45700 NULL
+st5481_setup_isocpipes_fndecl_45711_fns st5481_setup_isocpipes fndecl 6 45711 NULL nohasharray
+pof_handle_data_fndecl_45711_fns pof_handle_data fndecl 0 45711 &st5481_setup_isocpipes_fndecl_45711_fns
+__add_inline_refs_fndecl_45744_fns __add_inline_refs fndecl 3 45744 NULL
+wil_write_file_recovery_fndecl_45753_fns wil_write_file_recovery fndecl 3 45753 NULL
+count_n_hdlc_buf_45767_fns count n_hdlc_buf 0 45767 NULL
+flows_cnt_fq_codel_sched_data_45775_fns flows_cnt fq_codel_sched_data 0 45775 NULL
+get_inode_info_fndecl_45784_fns get_inode_info fndecl 0 45784 NULL
+smk_write_net4addr_fndecl_45821_fns smk_write_net4addr fndecl 3 45821 NULL
+__a2mp_build_fndecl_45864_fns __a2mp_build fndecl 3 45864 NULL
+hsc_msg_alloc_fndecl_45869_fns hsc_msg_alloc fndecl 1 45869 NULL
+mwifiex_alloc_sdio_mpa_buffers_fndecl_45874_fns mwifiex_alloc_sdio_mpa_buffers fndecl 2-3 45874 NULL
+pti_char_write_fndecl_45875_fns pti_char_write fndecl 3 45875 NULL
+alloc_wr_fndecl_45881_fns alloc_wr fndecl 1-2 45881 NULL
+smbase_kvm_vcpu_arch_45895_fns smbase kvm_vcpu_arch 0 45895 NULL
+ath6kl_lrssi_roam_read_fndecl_45901_fns ath6kl_lrssi_roam_read fndecl 3 45901 NULL
+dfs_num_of_radar_detections_read_fndecl_45903_fns dfs_num_of_radar_detections_read fndecl 3 45903 NULL
+alloc_sglist_fndecl_45919_fns alloc_sglist fndecl 1-3-2 45919 NULL
+lpfc_idiag_queacc_write_fndecl_45920_fns lpfc_idiag_queacc_write fndecl 3 45920 NULL
+read_file_ackto_fndecl_45950_fns read_file_ackto fndecl 3 45950 NULL
+sigma_fw_load_samplerates_fndecl_45951_fns sigma_fw_load_samplerates fndecl 3 45951 NULL
+__probe_kernel_read_fndecl_45996_fns __probe_kernel_read fndecl 3 45996 NULL
+sctp_v4_err_fndecl_45997_fns sctp_v4_err fndecl 2 45997 NULL
+get_derived_key_fndecl_46015_fns get_derived_key fndecl 4 46015 NULL
+p9_client_prepare_req_fndecl_46048_fns p9_client_prepare_req fndecl 3 46048 NULL
+__vmalloc_fndecl_46051_fns __vmalloc fndecl 1 46051 NULL
+calipso_map_cat_hton_fndecl_46052_fns calipso_map_cat_hton fndecl 0 46052 NULL nohasharray
+event_oom_late_read_fndecl_46052_fns event_oom_late_read fndecl 3 46052 &calipso_map_cat_hton_fndecl_46052_fns
+sys_lsetxattr_fndecl_46058_fns sys_lsetxattr fndecl 4 46058 NULL
+iwl_dbgfs_mac_params_read_fndecl_46081_fns iwl_dbgfs_mac_params_read fndecl 3 46081 NULL
+alloc_dca_provider_fndecl_46085_fns alloc_dca_provider fndecl 2 46085 NULL
+wilc_add_wep_key_bss_ap_fndecl_46087_fns wilc_add_wep_key_bss_ap fndecl 3 46087 NULL
+hidraw_read_fndecl_46097_fns hidraw_read fndecl 3 46097 NULL
+rui_nextents_xfs_rui_log_format_46113_fns rui_nextents xfs_rui_log_format 0 46113 NULL
+ioperm_get_fndecl_46118_fns ioperm_get fndecl 4-3 46118 NULL
+mic_calc_failure_read_fndecl_46119_fns mic_calc_failure_read fndecl 3 46119 NULL
+prism2_info_scanresults_fndecl_46146_fns prism2_info_scanresults fndecl 3 46146 NULL
+memblock_alloc_range_nid_fndecl_46147_fns memblock_alloc_range_nid fndecl 1 46147 NULL
+ieee80211_if_read_fwded_unicast_fndecl_46159_fns ieee80211_if_read_fwded_unicast fndecl 3 46159 NULL
+max_segs_mmc_test_area_46176_fns max_segs mmc_test_area 0 46176 NULL
+long_retry_limit_read_fndecl_46181_fns long_retry_limit_read fndecl 3 46181 NULL
+venus_remove_fndecl_46230_fns venus_remove fndecl 4 46230 NULL
+response_length_mlx4_uverbs_ex_query_device_resp_46245_fns response_length mlx4_uverbs_ex_query_device_resp 0 46245 NULL
+ieee80211_if_read_dot11MeshHWMPmaxPREQretries_fndecl_46246_fns ieee80211_if_read_dot11MeshHWMPmaxPREQretries fndecl 3 46246 NULL
+gspca_dev_probe2_fndecl_46250_fns gspca_dev_probe2 fndecl 4 46250 NULL
+ffs_prepare_buffer_fndecl_46311_fns ffs_prepare_buffer fndecl 2 46311 NULL
+max_vnic_func_qlcnic_hardware_context_46334_fns max_vnic_func qlcnic_hardware_context 0 46334 NULL
+__qsfp_debugfs_write_fndecl_46356_fns __qsfp_debugfs_write fndecl 3 46356 NULL
+shadow_image_fndecl_46361_fns shadow_image fndecl 3 46361 NULL
+ring_cons_per_user_data_46365_fns ring_cons per_user_data 0 46365 NULL
+fs_path_ensure_buf_fndecl_46374_fns fs_path_ensure_buf fndecl 2 46374 NULL
+acpi_ds_build_internal_buffer_obj_fndecl_46379_fns acpi_ds_build_internal_buffer_obj fndecl 3 46379 NULL
+max_loop_vardecl_loop_c_46402_fns max_loop vardecl_loop.c 0 46402 NULL
+len_minstrel_debugfs_info_46425_fns len minstrel_debugfs_info 0 46425 NULL
+rds_pin_pages_fndecl_46432_fns rds_pin_pages fndecl 0 46432 NULL
+C_SYSC_get_mempolicy_fndecl_46447_fns C_SYSC_get_mempolicy fndecl 3 46447 NULL
+_iwl_dbgfs_bcast_filters_write_fndecl_46448_fns _iwl_dbgfs_bcast_filters_write fndecl 3 46448 NULL
+sglen_usbtest_param_32_46451_fns sglen usbtest_param_32 0 46451 NULL
+nfsd_nrpools_fndecl_46460_fns nfsd_nrpools fndecl 0 46460 NULL
+ib_copy_from_udata_fndecl_46461_fns ib_copy_from_udata fndecl 3 46461 NULL
+size_drm_local_map_46462_fns size drm_local_map 0 46462 NULL
+kmalloc_large_node_fndecl_46469_fns kmalloc_large_node fndecl 1 46469 NULL
+mpi_get_nbits_fndecl_46476_fns mpi_get_nbits fndecl 0 46476 NULL
+hr_num_pages_o2hb_region_46481_fns hr_num_pages o2hb_region 0 46481 NULL
+afs_fsync_fndecl_46498_fns afs_fsync fndecl 2-3 46498 NULL
+tunables_write_fndecl_46520_fns tunables_write fndecl 3 46520 NULL
+mlx5_core_query_ib_ppcnt_fndecl_46522_fns mlx5_core_query_ib_ppcnt fndecl 4 46522 NULL
+memdup_user_fndecl_46549_fns memdup_user fndecl 2 46549 NULL
+jffs2_alloc_full_dirent_fndecl_46592_fns jffs2_alloc_full_dirent fndecl 1 46592 NULL nohasharray
+sg_build_sgat_fndecl_46592_fns sg_build_sgat fndecl 3 46592 &jffs2_alloc_full_dirent_fndecl_46592_fns
+cma_init_reserved_mem_fndecl_46602_fns cma_init_reserved_mem fndecl 3-2 46602 NULL
+init_state_fndecl_46614_fns init_state fndecl 2 46614 NULL
+jmb38x_ms_count_slots_fndecl_46615_fns jmb38x_ms_count_slots fndecl 0 46615 NULL
+emulator_set_smbase_fndecl_46616_fns emulator_set_smbase fndecl 2 46616 NULL
+alloc_size_nf_ct_ext_type_46634_fns alloc_size nf_ct_ext_type 0 46634 NULL
+rx_rx_tkip_replays_read_fndecl_46642_fns rx_rx_tkip_replays_read fndecl 3 46642 NULL
+roaming_rssi_level_read_fndecl_46643_fns roaming_rssi_level_read fndecl 3 46643 NULL
+got_bytes_cifs_readdata_46678_fns got_bytes cifs_readdata 0 46678 NULL
+display_crc_ctl_write_fndecl_46690_fns display_crc_ctl_write fndecl 3 46690 NULL
+printer_write_fndecl_46695_fns printer_write fndecl 3 46695 NULL
+irq_alloc_domain_generic_chips_fndecl_46715_fns irq_alloc_domain_generic_chips fndecl 3-2 46715 NULL
+__kfifo_from_user_r_fndecl_46762_fns __kfifo_from_user_r fndecl 3-5 46762 NULL
+bytes_remaining_parser_context_46791_fns bytes_remaining parser_context 0 46791 NULL
+dccp_setsockopt_fndecl_46812_fns dccp_setsockopt fndecl 5 46812 NULL
+kvm_mmu_get_page_fndecl_46824_fns kvm_mmu_get_page fndecl 2 46824 NULL
+hexdump_fndecl_46840_fns hexdump fndecl 3 46840 NULL
+n_channels_wmi_scan_chan_list_arg_46842_fns n_channels wmi_scan_chan_list_arg 0 46842 NULL
+driver_names_read_fndecl_46844_fns driver_names_read fndecl 3 46844 NULL
+il_dbgfs_missed_beacon_read_fndecl_46887_fns il_dbgfs_missed_beacon_read fndecl 3 46887 NULL
+ksi_nthreads_max_ksock_sched_info_46891_fns ksi_nthreads_max ksock_sched_info 0 46891 NULL
+il_dbgfs_rxon_flags_read_fndecl_46909_fns il_dbgfs_rxon_flags_read fndecl 3 46909 NULL nohasharray
+dapm_widget_power_read_file_fndecl_46909_fns dapm_widget_power_read_file fndecl 3 46909 &il_dbgfs_rxon_flags_read_fndecl_46909_fns
+ath10k_read_dfs_stats_fndecl_46910_fns ath10k_read_dfs_stats fndecl 3 46910 NULL
+s_desc_per_block_ext2_sb_info_46964_fns s_desc_per_block ext2_sb_info 0 46964 NULL
+vcs_size_fndecl_46977_fns vcs_size fndecl 0 46977 NULL
+numbers_count_tomoyo_condition_46984_fns numbers_count tomoyo_condition 0 46984 NULL
+gru_alloc_gts_fndecl_46987_fns gru_alloc_gts fndecl 2-3 46987 NULL
+sys_sched_getaffinity_fndecl_46994_fns sys_sched_getaffinity fndecl 2 46994 NULL
+dma_init_coherent_memory_fndecl_47020_fns dma_init_coherent_memory fndecl 3 47020 NULL
+length_acpi_buffer_47024_fns length acpi_buffer 0 47024 NULL
+ath6kl_listen_int_write_fndecl_47025_fns ath6kl_listen_int_write fndecl 3 47025 NULL
+ip_set_max_ip_set_net_47054_fns ip_set_max ip_set_net 0 47054 NULL
+nfs_idmap_request_key_fndecl_47055_fns nfs_idmap_request_key fndecl 2 47055 NULL
+buf_size_usbatm_channel_47081_fns buf_size usbatm_channel 0 47081 NULL
+ld_usb_read_fndecl_47087_fns ld_usb_read fndecl 3 47087 NULL
+pcpu_need_to_extend_fndecl_47094_fns pcpu_need_to_extend fndecl 0 47094 NULL
+__scsi_print_sense_fndecl_47105_fns __scsi_print_sense fndecl 4 47105 NULL
+num_outstanding_cmds_req_que_47114_fns num_outstanding_cmds req_que 0 47114 NULL
+tx_tx_start_fw_gen_read_fndecl_47115_fns tx_tx_start_fw_gen_read fndecl 3 47115 NULL
+iwl_dbgfs_rx_handlers_write_fndecl_47116_fns iwl_dbgfs_rx_handlers_write fndecl 3 47116 NULL
+param_data_size_skl_ipc_init_instance_msg_47145_fns param_data_size skl_ipc_init_instance_msg 0 47145 NULL
+msr_init_context_fndecl_47188_fns msr_init_context fndecl 2 47188 NULL
+block_count_msb_data_47194_fns block_count msb_data 0 47194 NULL
+vmalloc_node_fndecl_47199_fns vmalloc_node fndecl 1 47199 NULL
+mbm_socket_max_vardecl_47204_fns mbm_socket_max vardecl 0 47204 NULL
+agp_allocate_memory_fndecl_47258_fns agp_allocate_memory fndecl 2 47258 NULL
+__ofdpa_mem_alloc_fndecl_47299_fns __ofdpa_mem_alloc fndecl 3 47299 NULL
+fwnode_property_read_string_array_fndecl_47300_fns fwnode_property_read_string_array fndecl 0 47300 NULL
+command_write_fndecl_47306_fns command_write fndecl 3 47306 NULL
+qed_cxt_ilt_shadow_size_fndecl_47308_fns qed_cxt_ilt_shadow_size fndecl 0 47308 NULL
+thermal_irq_thr_low_read_fndecl_47339_fns thermal_irq_thr_low_read fndecl 3 47339 NULL
+nd_label_active_count_fndecl_47348_fns nd_label_active_count fndecl 0 47348 NULL
+dump_midi_fndecl_47356_fns dump_midi fndecl 3 47356 NULL
+ath6kl_wmi_send_action_cmd_fndecl_47359_fns ath6kl_wmi_send_action_cmd fndecl 7 47359 NULL
+SYSC_sched_getattr_fndecl_47361_fns SYSC_sched_getattr fndecl 3 47361 NULL
+rx_position_r3964_info_47365_fns rx_position r3964_info 0 47365 NULL
+il_dbgfs_status_read_fndecl_47367_fns il_dbgfs_status_read fndecl 3 47367 NULL
+capabilities_read_fndecl_47434_fns capabilities_read fndecl 3 47434 NULL
+usnic_vnic_get_resources_fndecl_47437_fns usnic_vnic_get_resources fndecl 3 47437 NULL
+dw_spi_show_regs_fndecl_47461_fns dw_spi_show_regs fndecl 3 47461 NULL
+snd_rme96_capture_copy_fndecl_47463_fns snd_rme96_capture_copy fndecl 5 47463 NULL
+memblock_alloc_try_nid_fndecl_47470_fns memblock_alloc_try_nid fndecl 1 47470 NULL
+lpfc_idiag_baracc_read_fndecl_47473_fns lpfc_idiag_baracc_read fndecl 3 47473 NULL
+fifo_len_tx_fifo_config_47480_fns fifo_len tx_fifo_config 0 47480 NULL
+__ffs_epfile_read_data_fndecl_47488_fns __ffs_epfile_read_data fndecl 3 47488 NULL nohasharray
+report_length_f_hidg_47488_fns report_length f_hidg 0 47488 &__ffs_epfile_read_data_fndecl_47488_fns
+setcontrast_fndecl_47513_fns setcontrast fndecl 0 47513 NULL
+ib_uverbs_create_qp_fndecl_47521_fns ib_uverbs_create_qp fndecl 4-5 47521 NULL
+pq_sources_dmatest_params_47534_fns pq_sources dmatest_params 0 47534 NULL
+skl_tplg_tlv_control_set_fndecl_47545_fns skl_tplg_tlv_control_set fndecl 3 47545 NULL
+wep_decrypt_fail_read_fndecl_47572_fns wep_decrypt_fail_read fndecl 3 47572 NULL
+tool_peer_mw_trans_write_fndecl_47595_fns tool_peer_mw_trans_write fndecl 3 47595 NULL
+num_codecs_snd_soc_dai_link_47607_fns num_codecs snd_soc_dai_link 0 47607 NULL
+nvme_fill_device_id_scsi_string_fndecl_47624_fns nvme_fill_device_id_scsi_string fndecl 4 47624 NULL
+__iio_add_event_config_attrs_fndecl_47635_fns __iio_add_event_config_attrs fndecl 0 47635 NULL
+framebuffer_alloc_fndecl_47642_fns framebuffer_alloc fndecl 1 47642 NULL nohasharray
+nilfs_cpfile_get_offset_fndecl_47642_fns nilfs_cpfile_get_offset fndecl 0-2 47642 &framebuffer_alloc_fndecl_47642_fns
+atomic_write_len_kernfs_open_file_47658_fns atomic_write_len kernfs_open_file 0 47658 NULL
+setup_window_fndecl_47673_fns setup_window fndecl 4-5-7 47673 NULL
+ksize_fndecl_47675_fns ksize fndecl 0 47675 NULL
+height_v4l2_pix_format_47682_fns height v4l2_pix_format 0 47682 NULL
+ath10k_debug_cal_data_read_fndecl_47685_fns ath10k_debug_cal_data_read fndecl 3 47685 NULL
+cno_nilfs_super_data_47691_fns cno nilfs_super_data 0 47691 NULL
+paging64_gpte_to_gfn_lvl_fndecl_47694_fns paging64_gpte_to_gfn_lvl fndecl 0-2-1 47694 NULL
+efi_capsule_write_fndecl_47697_fns efi_capsule_write fndecl 3 47697 NULL
+report_size_roccat_device_47705_fns report_size roccat_device 0 47705 NULL
+max_size_ttm_pool_opts_47726_fns max_size ttm_pool_opts 0 47726 NULL
+batadv_send_tt_request_fndecl_47727_fns batadv_send_tt_request fndecl 5 47727 NULL
+acpi_tb_install_fixed_table_fndecl_47749_fns acpi_tb_install_fixed_table fndecl 1 47749 NULL
+width_ssd1307fb_par_47753_fns width ssd1307fb_par 0 47753 NULL
+snic_reset_stats_read_fndecl_47774_fns snic_reset_stats_read fndecl 3 47774 NULL
+fd_copyout_fndecl_47784_fns fd_copyout fndecl 3 47784 NULL
+netdev_queue_update_kobjects_fndecl_47798_fns netdev_queue_update_kobjects fndecl 0 47798 NULL
+paging64_get_level1_sp_gpa_fndecl_47809_fns paging64_get_level1_sp_gpa fndecl 0 47809 NULL
+size_ncp_ioctl_request_47816_fns size ncp_ioctl_request 0 47816 NULL
+rx_defrag_in_process_called_read_fndecl_47833_fns rx_defrag_in_process_called_read fndecl 3 47833 NULL
+f2fs_fallocate_fndecl_47842_fns f2fs_fallocate fndecl 3-4 47842 NULL
+nilfs_cpfile_find_checkpoint_block_fndecl_47868_fns nilfs_cpfile_find_checkpoint_block fndecl 2-3 47868 NULL
+gs_alloc_req_fndecl_47888_fns gs_alloc_req fndecl 2 47888 NULL
+write_pmsg_fndecl_47911_fns write_pmsg fndecl 3 47911 NULL
+compat_fillonedir_fndecl_47921_fns compat_fillonedir fndecl 3 47921 NULL
+iwl_mvm_sync_rx_queues_internal_fndecl_47927_fns iwl_mvm_sync_rx_queues_internal fndecl 3 47927 NULL
+de_rahead_gfs2_dirent_47954_fns de_rahead gfs2_dirent 0 47954 NULL
+le_ih_k_offset_fndecl_47992_fns le_ih_k_offset fndecl 0 47992 NULL
+init_pci_cap_msi_perm_fndecl_48010_fns init_pci_cap_msi_perm fndecl 2 48010 NULL nohasharray
+setgain_fndecl_48010_fns setgain fndecl 0 48010 &init_pci_cap_msi_perm_fndecl_48010_fns
+size_netlbl_unlhsh_tbl_48011_fns size netlbl_unlhsh_tbl 0 48011 NULL
+selinux_transaction_write_fndecl_48013_fns selinux_transaction_write fndecl 3 48013 NULL
+mdiobus_read_nested_fndecl_48017_fns mdiobus_read_nested fndecl 0 48017 NULL
+drm_malloc_gfp_fndecl_48018_fns drm_malloc_gfp fndecl 1-2 48018 NULL
+lpfc_idiag_baracc_write_fndecl_48021_fns lpfc_idiag_baracc_write fndecl 3 48021 NULL
+_find_next_bit_le_fndecl_48027_fns _find_next_bit_le fndecl 0 48027 NULL
+aim_write_fndecl_48032_fns aim_write fndecl 3 48032 NULL
+blocksize_sddr55_card_info_48082_fns blocksize sddr55_card_info 0 48082 NULL
+nfc_llcp_send_i_frame_fndecl_48105_fns nfc_llcp_send_i_frame fndecl 3 48105 NULL
+namelen_xensyms_48117_fns namelen xensyms 0 48117 NULL
+vma_kernel_pagesize_fndecl_48131_fns vma_kernel_pagesize fndecl 0 48131 NULL
+tx_tx_retry_template_read_fndecl_48132_fns tx_tx_retry_template_read fndecl 3 48132 NULL
+rsa_edesc_alloc_fndecl_48134_fns rsa_edesc_alloc fndecl 2 48134 NULL
+mem_read_fndecl_48140_fns mem_read fndecl 3 48140 NULL
+hpi_cobranet_hmi_write_fndecl_48158_fns hpi_cobranet_hmi_write fndecl 3 48158 NULL
+r3964_write_fndecl_48173_fns r3964_write fndecl 4 48173 NULL
+mr_read_fndecl_48180_fns mr_read fndecl 0 48180 NULL
+data_transfer_length_pmcraid_ioarcb_48193_fns data_transfer_length pmcraid_ioarcb 0 48193 NULL
+proc_ns_readlink_fndecl_48211_fns proc_ns_readlink fndecl 3 48211 NULL
+__lgwrite_fndecl_48214_fns __lgwrite fndecl 4 48214 NULL
+b_map_count_xfs_buf_48228_fns b_map_count xfs_buf 0 48228 NULL
+ieee80211_if_read_dot11MeshHWMPconfirmationInterval_fndecl_48233_fns ieee80211_if_read_dot11MeshHWMPconfirmationInterval fndecl 3 48233 NULL
+i2400m_rx_stats_read_fndecl_48249_fns i2400m_rx_stats_read fndecl 3 48249 NULL
+ib_uverbs_create_xsrq_fndecl_48257_fns ib_uverbs_create_xsrq fndecl 4-5 48257 NULL
+compat_sys_set_mempolicy_fndecl_48285_fns compat_sys_set_mempolicy fndecl 3 48285 NULL
+_iwl_dbgfs_lqm_send_cmd_write_fndecl_48326_fns _iwl_dbgfs_lqm_send_cmd_write fndecl 3 48326 NULL
+ion_test_ioctl_fndecl_48340_fns ion_test_ioctl fndecl 2 48340 NULL
+ivtv_read_fndecl_48343_fns ivtv_read fndecl 3 48343 NULL
+flash_read_fndecl_48352_fns flash_read fndecl 3 48352 NULL
+kiblnd_create_tx_pool_fndecl_48357_fns kiblnd_create_tx_pool fndecl 2 48357 NULL
+bfad_debugfs_read_regrd_fndecl_48373_fns bfad_debugfs_read_regrd fndecl 3 48373 NULL
+mlxsw_cmd_mbox_query_aq_cap_max_num_rdqs_get_fndecl_48399_fns mlxsw_cmd_mbox_query_aq_cap_max_num_rdqs_get fndecl 0 48399 NULL
+max_kioc_mraid_mmadp_48422_fns max_kioc mraid_mmadp 0 48422 NULL
+read_file_blob_fndecl_48429_fns read_file_blob fndecl 3 48429 NULL
+natids_tid_info_48439_fns natids tid_info 0 48439 NULL
+bzImage64_load_fndecl_48447_fns bzImage64_load fndecl 7 48447 NULL
+alloc_ftrace_hash_fndecl_48452_fns alloc_ftrace_hash fndecl 1 48452 NULL
+read_file_eeprom_fndecl_48455_fns read_file_eeprom fndecl 3 48455 NULL
+pwr_ap_sleep_active_conf_read_fndecl_48457_fns pwr_ap_sleep_active_conf_read fndecl 3 48457 NULL
+copy_to_user_fromio_fndecl_48459_fns copy_to_user_fromio fndecl 3 48459 NULL
+carl9170_read_mreg_fndecl_48468_fns carl9170_read_mreg fndecl 2 48468 NULL
+enclosure_register_fndecl_48471_fns enclosure_register fndecl 3 48471 NULL
+__origin_write_fndecl_48487_fns __origin_write fndecl 2 48487 NULL
+sisusb_clear_vram_fndecl_48489_fns sisusb_clear_vram fndecl 2-3 48489 NULL
+ieee80211_if_read_flags_fndecl_48493_fns ieee80211_if_read_flags fndecl 3 48493 NULL
+rss_key_write_fndecl_48498_fns rss_key_write fndecl 3 48498 NULL
+sys_pselect6_fndecl_48506_fns sys_pselect6 fndecl 1 48506 NULL
+read_file_skb_rx_fndecl_48513_fns read_file_skb_rx fndecl 3 48513 NULL
+copy_in_user_fndecl_48525_fns copy_in_user fndecl 3 48525 NULL
+fscrypt_fname_encrypted_size_fndecl_48527_fns fscrypt_fname_encrypted_size fndecl 0-2 48527 NULL
+max_sense_bytes_mpt3_ioctl_command_48528_fns max_sense_bytes mpt3_ioctl_command 0 48528 NULL
+nilfs_sufile_update_fndecl_48533_fns nilfs_sufile_update fndecl 2 48533 NULL
+cmm_read_fndecl_48547_fns cmm_read fndecl 3 48547 NULL
+dm_stats_create_fndecl_48550_fns dm_stats_create fndecl 6-4-2-3 48550 NULL
+inode_permission_fndecl_48552_fns inode_permission fndecl 0 48552 NULL
+acpi_dev_get_resources_fndecl_48557_fns acpi_dev_get_resources fndecl 0 48557 NULL
+init_tag_map_fndecl_48568_fns init_tag_map fndecl 3 48568 NULL
+start_spy_cam_fndecl_48570_fns start_spy_cam fndecl 0 48570 NULL
+wil_read_file_ssid_fndecl_48574_fns wil_read_file_ssid fndecl 3 48574 NULL nohasharray
+il_dbgfs_force_reset_read_fndecl_48574_fns il_dbgfs_force_reset_read fndecl 3 48574 &wil_read_file_ssid_fndecl_48574_fns
+dynamic_fw_traces_read_fndecl_48579_fns dynamic_fw_traces_read fndecl 3 48579 NULL
+driver_register_fndecl_48593_fns driver_register fndecl 0 48593 NULL
+aggr_size_tx_agg_rate_read_fndecl_48607_fns aggr_size_tx_agg_rate_read fndecl 3 48607 NULL
+read_file_spectral_fft_period_fndecl_48618_fns read_file_spectral_fft_period fndecl 3 48618 NULL
+num_streamids_arm_smmu_master_cfg_48625_fns num_streamids arm_smmu_master_cfg 0 48625 NULL
+get_bridge_ifindices_fndecl_48632_fns get_bridge_ifindices fndecl 0 48632 NULL
+nsymbols_dsp_symbol_desc_48638_fns nsymbols dsp_symbol_desc 0 48638 NULL
+savemem_fndecl_48642_fns savemem fndecl 3 48642 NULL
+ipv6_flowlabel_opt_fndecl_48644_fns ipv6_flowlabel_opt fndecl 3 48644 NULL nohasharray
+slhc_init_fndecl_48644_fns slhc_init fndecl 1-2 48644 &ipv6_flowlabel_opt_fndecl_48644_fns
+libcfs_kvzalloc_cpt_fndecl_48651_fns libcfs_kvzalloc_cpt fndecl 3 48651 NULL
+length_fw_cdev_send_request_48658_fns length fw_cdev_send_request 0 48658 NULL
+nn_rs_control_48667_fns nn rs_control 0 48667 NULL
+make_cpu_key_fndecl_48699_fns make_cpu_key fndecl 3 48699 NULL
+mbox_test_signal_write_fndecl_48729_fns mbox_test_signal_write fndecl 3 48729 NULL
+vmw_view_add_fndecl_48730_fns vmw_view_add fndecl 7 48730 NULL
+garmin_write_bulk_fndecl_48732_fns garmin_write_bulk fndecl 3 48732 NULL
+i40evf_allocate_virt_mem_d_fndecl_48753_fns i40evf_allocate_virt_mem_d fndecl 3 48753 NULL
+string_escape_mem_fndecl_48758_fns string_escape_mem fndecl 0 48758 NULL
+read_file_debug_fndecl_48771_fns read_file_debug fndecl 3 48771 NULL
+profile_load_fndecl_48776_fns profile_load fndecl 3 48776 NULL
+acpi_ds_build_internal_package_obj_fndecl_48780_fns acpi_ds_build_internal_package_obj fndecl 3 48780 NULL
+len_spi_transfer_48802_fns len spi_transfer 0 48802 NULL
+iscsi_decode_text_input_fndecl_48807_fns iscsi_decode_text_input fndecl 4 48807 NULL
+r100_mm_rreg_fndecl_48823_fns r100_mm_rreg fndecl 0 48823 NULL
+omap_device_count_resources_fndecl_48829_fns omap_device_count_resources fndecl 0 48829 NULL
+__generic_file_fsync_fndecl_48835_fns __generic_file_fsync fndecl 2-3 48835 NULL
+tx_tx_start_int_templates_read_fndecl_48839_fns tx_tx_start_int_templates_read fndecl 3 48839 NULL
+ieee80211_if_read_dot11MeshTTL_fndecl_48848_fns ieee80211_if_read_dot11MeshTTL fndecl 3 48848 NULL
+vmalloc_to_sg_fndecl_48865_fns vmalloc_to_sg fndecl 2 48865 NULL
+mpls_count_nexthops_fndecl_48869_fns mpls_count_nexthops fndecl 0 48869 NULL
+__copy_from_user_swizzled_fndecl_48882_fns __copy_from_user_swizzled fndecl 2-4 48882 NULL
+bylength_atto_vda_ae_hdr_48890_fns bylength atto_vda_ae_hdr 0 48890 NULL
+regmap_cache_only_write_file_fndecl_48899_fns regmap_cache_only_write_file fndecl 3 48899 NULL
+radeon_ttm_gtt_read_fndecl_48900_fns radeon_ttm_gtt_read fndecl 3 48900 NULL
+_scif_nodeqp_send_fndecl_48929_fns _scif_nodeqp_send fndecl 0 48929 NULL
+xt_alloc_table_info_fndecl_48956_fns xt_alloc_table_info fndecl 1 48956 NULL
+user_dlm_lock_fndecl_48959_fns user_dlm_lock fndecl 6 48959 NULL
+xfs_mru_cache_create_fndecl_48964_fns xfs_mru_cache_create fndecl 3 48964 NULL
+key_algorithm_read_fndecl_48969_fns key_algorithm_read fndecl 3 48969 NULL
+vtpm_proxy_fops_write_fndecl_48972_fns vtpm_proxy_fops_write fndecl 3 48972 NULL
+dma40_prep_dma_cyclic_fndecl_48976_fns dma40_prep_dma_cyclic fndecl 4-3 48976 NULL
+mwifiex_hscfg_read_fndecl_48979_fns mwifiex_hscfg_read fndecl 3 48979 NULL
+sel_read_handle_unknown_fndecl_48990_fns sel_read_handle_unknown fndecl 3 48990 NULL
+ip_set_alloc_fndecl_49010_fns ip_set_alloc fndecl 1 49010 NULL
+rx_reset_counter_read_fndecl_49026_fns rx_reset_counter_read fndecl 3 49026 NULL
+usb_dmac_prep_slave_sg_fndecl_49027_fns usb_dmac_prep_slave_sg fndecl 3 49027 NULL
+devno_skd_device_49051_fns devno skd_device 0 49051 NULL
+iwl_dbgfs_ucode_rx_stats_read_fndecl_49076_fns iwl_dbgfs_ucode_rx_stats_read fndecl 3 49076 NULL
+dev_priv_size_drm_buf_49086_fns dev_priv_size drm_buf 0 49086 NULL
+cm4040_write_fndecl_49100_fns cm4040_write fndecl 3 49100 NULL nohasharray
+usb_stor_acquire_resources_fndecl_49100_fns usb_stor_acquire_resources fndecl 0 49100 &cm4040_write_fndecl_49100_fns
+alloc_rbio_fndecl_49128_fns alloc_rbio fndecl 3 49128 NULL
+ufx_reg_clear_and_set_bits_fndecl_49150_fns ufx_reg_clear_and_set_bits fndecl 0 49150 NULL
+ipr_alloc_ucode_buffer_fndecl_49172_fns ipr_alloc_ucode_buffer fndecl 1 49172 NULL
+allocate_probes_fndecl_49183_fns allocate_probes fndecl 1 49183 NULL
+fsl_edma_prep_dma_cyclic_fndecl_49197_fns fsl_edma_prep_dma_cyclic fndecl 4-3 49197 NULL nohasharray
+of_get_child_count_fndecl_49197_fns of_get_child_count fndecl 0 49197 &fsl_edma_prep_dma_cyclic_fndecl_49197_fns
+ocrdma_dbgfs_ops_read_fndecl_49211_fns ocrdma_dbgfs_ops_read fndecl 3 49211 NULL
+usbnet_read_cmd_fndecl_49216_fns usbnet_read_cmd fndecl 7 49216 NULL
+rx_xfr_hint_trig_read_fndecl_49224_fns rx_xfr_hint_trig_read fndecl 3 49224 NULL
+rs_sta_dbgfs_scale_table_read_fndecl_49237_fns rs_sta_dbgfs_scale_table_read fndecl 3 49237 NULL
+dwDefaultFrameInterval_uvc_frame_49276_fns dwDefaultFrameInterval uvc_frame 0 49276 NULL
+ib_get_mad_data_offset_fndecl_49283_fns ib_get_mad_data_offset fndecl 0 49283 NULL
+alloc_dev_fndecl_49294_fns alloc_dev fndecl 1 49294 NULL
+SAL_nasids_size_xpc_rsvd_page_49304_fns SAL_nasids_size xpc_rsvd_page 0 49304 NULL
+get_chars_fndecl_49318_fns get_chars fndecl 3 49318 NULL nohasharray
+xstate_copyout_fndecl_49318_fns xstate_copyout fndecl 1-2-7 49318 &get_chars_fndecl_49318_fns
+event_rx_mem_empty_read_fndecl_49336_fns event_rx_mem_empty_read fndecl 3 49336 NULL
+cifs_stats_proc_write_fndecl_49338_fns cifs_stats_proc_write fndecl 3 49338 NULL
+fence_array_create_fndecl_49340_fns fence_array_create fndecl 1 49340 NULL
+__iterate_backrefs_fndecl_49345_fns __iterate_backrefs fndecl 2 49345 NULL
+num_msix_entries_qib_chip_specific_49373_fns num_msix_entries qib_chip_specific 0 49373 NULL
+num_simgs_icp_qat_suof_img_tbl_49375_fns num_simgs icp_qat_suof_img_tbl 0 49375 NULL
+tty_prepare_flip_string_fndecl_49408_fns tty_prepare_flip_string fndecl 3 49408 NULL
+lstcon_group_list_fndecl_49413_fns lstcon_group_list fndecl 2 49413 NULL
+size_efx_farch_filter_table_49415_fns size efx_farch_filter_table 0 49415 NULL
+main_segments_f2fs_sm_info_49433_fns main_segments f2fs_sm_info 0 49433 NULL
+mthca_array_init_fndecl_49440_fns mthca_array_init fndecl 2 49440 NULL
+fw_device_op_read_fndecl_49445_fns fw_device_op_read fndecl 3 49445 NULL
+broadsheetfb_write_fndecl_49467_fns broadsheetfb_write fndecl 3 49467 NULL
+xen_hvm_config_fndecl_49473_fns xen_hvm_config fndecl 2 49473 NULL
+ivtvfb_write_fndecl_49476_fns ivtvfb_write fndecl 3 49476 NULL
+datablob_hmac_append_fndecl_49525_fns datablob_hmac_append fndecl 3 49525 NULL
+pt_write_fndecl_49612_fns pt_write fndecl 3 49612 NULL
+ocfs2_sync_file_fndecl_49614_fns ocfs2_sync_file fndecl 2-3 49614 NULL
+dwc2_max_desc_num_fndecl_49623_fns dwc2_max_desc_num fndecl 0 49623 NULL
+end_async_cow_49625_fns end async_cow 0 49625 NULL
+ath10k_write_simulate_fw_crash_fndecl_49628_fns ath10k_write_simulate_fw_crash fndecl 3 49628 NULL
+iocbq_lookup_len_lpfc_sli_49647_fns iocbq_lookup_len lpfc_sli 0 49647 NULL
+size_unit_element_struct_49673_fns size unit_element_struct 0 49673 NULL
+__seq_open_private_fndecl_49688_fns __seq_open_private fndecl 3 49688 NULL
+batadv_iv_ogm_drop_bcast_own_entry_fndecl_49690_fns batadv_iv_ogm_drop_bcast_own_entry fndecl 2 49690 NULL
+report_size_iowarrior_49692_fns report_size iowarrior 0 49692 NULL
+security_inode_listxattr_fndecl_49699_fns security_inode_listxattr fndecl 0 49699 NULL
+pg_write_fndecl_49709_fns pg_write fndecl 3 49709 NULL
+ieee80211_if_read_rc_rateidx_vht_mcs_mask_5ghz_fndecl_49710_fns ieee80211_if_read_rc_rateidx_vht_mcs_mask_5ghz fndecl 3 49710 NULL
+brd_init_one_fndecl_49718_fns brd_init_one fndecl 1 49718 NULL
+kernfs_fop_read_fndecl_49745_fns kernfs_fop_read fndecl 3 49745 NULL
+mlx5_alloc_priv_descs_fndecl_49758_fns mlx5_alloc_priv_descs fndecl 3-4 49758 NULL
+dwFrameInterval_uvc_streaming_control_49771_fns dwFrameInterval uvc_streaming_control 0 49771 NULL
+rtw_add_beacon_fndecl_49778_fns rtw_add_beacon fndecl 5-3 49778 NULL
+nilfs_mdt_init_fndecl_49794_fns nilfs_mdt_init fndecl 3 49794 NULL
+write_file_wow_fndecl_49799_fns write_file_wow fndecl 3 49799 NULL
+response_length_ib_uverbs_ex_query_device_resp_49831_fns response_length ib_uverbs_ex_query_device_resp 0 49831 NULL
+read_file_queue_fndecl_49836_fns read_file_queue fndecl 3 49836 NULL
+waiters_read_fndecl_49877_fns waiters_read fndecl 3 49877 NULL
+isdn_add_channels_fndecl_49882_fns isdn_add_channels fndecl 3 49882 NULL
+head_len_beacon_attr_49884_fns head_len beacon_attr 0 49884 NULL
+path_listxattr_fndecl_49894_fns path_listxattr fndecl 3 49894 NULL
+snd_vx_create_fndecl_49895_fns snd_vx_create fndecl 4 49895 NULL
+max_sds_rings_netxen_adapter_49896_fns max_sds_rings netxen_adapter 0 49896 NULL
+skd_max_queue_depth_vardecl_skd_main_c_49938_fns skd_max_queue_depth vardecl_skd_main.c 0 49938 NULL
+tomoyo_update_policy_fndecl_49945_fns tomoyo_update_policy fndecl 2 49945 NULL
+__ethtool_get_sset_count_fndecl_49964_fns __ethtool_get_sset_count fndecl 0 49964 NULL
+mbox_size_wl1271_49981_fns mbox_size wl1271 0 49981 NULL
+buffer_target_count_pvr2_stream_49996_fns buffer_target_count pvr2_stream 0 49996 NULL
+ff_effects_max_uinput_device_49998_fns ff_effects_max uinput_device 0 49998 NULL
+ixgbe_dbg_reg_ops_read_fndecl_49999_fns ixgbe_dbg_reg_ops_read fndecl 3 49999 NULL
+ima_write_policy_fndecl_50039_fns ima_write_policy fndecl 3 50039 NULL
+esp_alloc_tmp_fndecl_50045_fns esp_alloc_tmp fndecl 2-3 50045 NULL
+get_priv_descr_and_size_fndecl_50103_fns get_priv_descr_and_size fndecl 0 50103 NULL
+pipeline_rx_complete_stat_fifo_int_read_fndecl_50124_fns pipeline_rx_complete_stat_fifo_int_read fndecl 3 50124 NULL
+usb_set_interface_fndecl_50126_fns usb_set_interface fndecl 0 50126 NULL
+max_burst_whc_qset_50130_fns max_burst whc_qset 0 50130 NULL
+pid_nr_ns_fndecl_50141_fns pid_nr_ns fndecl 0 50141 NULL
+nfc_hci_set_param_fndecl_50154_fns nfc_hci_set_param fndecl 5 50154 NULL nohasharray
+size_ubifs_data_node_50154_fns size ubifs_data_node 0 50154 &nfc_hci_set_param_fndecl_50154_fns
+videobuf_dma_init_user_locked_fndecl_50165_fns videobuf_dma_init_user_locked fndecl 3-4 50165 NULL
+pci_enable_resources_fndecl_50171_fns pci_enable_resources fndecl 0 50171 NULL
+nested_cr3_nested_state_50183_fns nested_cr3 nested_state 0 50183 NULL
+gfs2_create_inode_fndecl_50184_fns gfs2_create_inode fndecl 7 50184 NULL
+echo_client_kbrw_fndecl_50193_fns echo_client_kbrw fndecl 6 50193 NULL
+s_zmap_blocks_minix_sb_info_50206_fns s_zmap_blocks minix_sb_info 0 50206 NULL
+mwifiex_verext_read_fndecl_50224_fns mwifiex_verext_read fndecl 3 50224 NULL
+pwr_cont_miss_bcns_spread_read_fndecl_50241_fns pwr_cont_miss_bcns_spread_read fndecl 3 50241 NULL
+posix_acl_to_xattr_fndecl_50262_fns posix_acl_to_xattr fndecl 0 50262 NULL
+buf_struct_size_vb2_queue_50266_fns buf_struct_size vb2_queue 0 50266 NULL
+rx_filter_protection_filter_read_fndecl_50273_fns rx_filter_protection_filter_read fndecl 3 50273 NULL
+_iwl_dbgfs_pm_params_write_fndecl_50318_fns _iwl_dbgfs_pm_params_write fndecl 3 50318 NULL
+__vmalloc_node_fndecl_50335_fns __vmalloc_node fndecl 1-2 50335 NULL
+__copy_from_user_nocache_fndecl_50340_fns __copy_from_user_nocache fndecl 3 50340 NULL
+next_minor_vardecl_md_c_50357_fns next_minor vardecl_md.c 0 50357 NULL
+regmap_name_read_file_fndecl_50368_fns regmap_name_read_file fndecl 3 50368 NULL
+fnic_trace_debugfs_read_fndecl_50375_fns fnic_trace_debugfs_read fndecl 3 50375 NULL
+user_power_read_fndecl_50405_fns user_power_read fndecl 3 50405 NULL
+size_uvc_clock_50418_fns size uvc_clock 0 50418 NULL
+ecc_alloc_point_fndecl_50432_fns ecc_alloc_point fndecl 1 50432 NULL
+sbp_count_se_tpg_luns_fndecl_50444_fns sbp_count_se_tpg_luns fndecl 0 50444 NULL
+il_dbgfs_sram_write_fndecl_50445_fns il_dbgfs_sram_write fndecl 3 50445 NULL
+nfsd_drc_mem_used_vardecl_50456_fns nfsd_drc_mem_used vardecl 0 50456 NULL
+__ath6kl_wmi_send_mgmt_cmd_fndecl_50472_fns __ath6kl_wmi_send_mgmt_cmd fndecl 7 50472 NULL
+buf_size_dmatest_params_50477_fns buf_size dmatest_params 0 50477 NULL
+lpfc_idiag_extacc_write_fndecl_50501_fns lpfc_idiag_extacc_write fndecl 3 50501 NULL
+OSDSetBlock_fndecl_50521_fns OSDSetBlock fndecl 2-4 50521 NULL
+get_nodes_fndecl_50551_fns get_nodes fndecl 3 50551 NULL
+do_write_kmem_fndecl_50584_fns do_write_kmem fndecl 0-1-3 50584 NULL
+pwrite_dvb_ringbuffer_50594_fns pwrite dvb_ringbuffer 0 50594 NULL
+__kfifo_to_user_r_fndecl_50624_fns __kfifo_to_user_r fndecl 3-5 50624 NULL nohasharray
+buffer_depth_etb_drvdata_50624_fns buffer_depth etb_drvdata 0 50624 &__kfifo_to_user_r_fndecl_50624_fns
+keymap_size_dell_dmi_results_50640_fns keymap_size dell_dmi_results 0 50640 NULL
+tomoyo_truncate_fndecl_50642_fns tomoyo_truncate fndecl 0 50642 NULL
+xor_sources_dmatest_params_50653_fns xor_sources dmatest_params 0 50653 NULL
+qsfp2_debugfs_write_fndecl_50656_fns qsfp2_debugfs_write fndecl 3 50656 NULL
+proc_coredump_filter_read_fndecl_50658_fns proc_coredump_filter_read fndecl 3 50658 NULL
+da9150_i2c_write_device_fndecl_50670_fns da9150_i2c_write_device fndecl 3 50670 NULL
+alloc_ring_fndecl_50684_fns alloc_ring fndecl 2-4 50684 NULL
+get_device_info_fndecl_50718_fns get_device_info fndecl 0 50718 NULL
+dm_create_fndecl_50754_fns dm_create fndecl 1 50754 NULL
+ip_vs_sync_buff_create_fndecl_50787_fns ip_vs_sync_buff_create fndecl 2 50787 NULL
+xhci_alloc_segments_for_ring_fndecl_50793_fns xhci_alloc_segments_for_ring fndecl 7 50793 NULL
+ib_uverbs_get_context_fndecl_50799_fns ib_uverbs_get_context fndecl 4-5 50799 NULL
+persistent_ram_buffer_map_fndecl_50803_fns persistent_ram_buffer_map fndecl 1-2 50803 NULL
+malloc_size__BIG_IOCTL_Command_struct_50805_fns malloc_size _BIG_IOCTL_Command_struct 0 50805 NULL
+ocfs2_pages_per_cluster_fndecl_50813_fns ocfs2_pages_per_cluster fndecl 0 50813 NULL
+sys_migrate_pages_fndecl_50818_fns sys_migrate_pages fndecl 2 50818 NULL
+get_priv_size_fndecl_50823_fns get_priv_size fndecl 0-1 50823 NULL
+security_inode_listsecurity_fndecl_50839_fns security_inode_listsecurity fndecl 0 50839 NULL
+decrypted_key_size_ecryptfs_session_key_50847_fns decrypted_key_size ecryptfs_session_key 0 50847 NULL
+pwr_ap_sleep_user_conf_read_fndecl_50848_fns pwr_ap_sleep_user_conf_read fndecl 3 50848 NULL
+force_bredr_smp_read_fndecl_50855_fns force_bredr_smp_read fndecl 3 50855 NULL
+alloc_disk_fndecl_50861_fns alloc_disk fndecl 1 50861 NULL
+ie_len_ieee80211_if_ibss_50890_fns ie_len ieee80211_if_ibss 0 50890 NULL nohasharray
+pkt_add_fndecl_50890_fns pkt_add fndecl 3 50890 &ie_len_ieee80211_if_ibss_50890_fns
+req_len_proxy_dev_50912_fns req_len proxy_dev 0 50912 NULL
+oom_score_adj_read_fndecl_50914_fns oom_score_adj_read fndecl 3 50914 NULL
+init_sc_pools_and_sizes_fndecl_50922_fns init_sc_pools_and_sizes fndecl 0 50922 NULL
+first_minor_gendisk_50925_fns first_minor gendisk 0 50925 NULL
+read_file_modal_eeprom_fndecl_50934_fns read_file_modal_eeprom fndecl 3 50934 NULL
+dw210x_op_rw_fndecl_50936_fns dw210x_op_rw fndecl 6 50936 NULL
+gen_pool_add_virt_fndecl_50938_fns gen_pool_add_virt fndecl 4 50938 NULL
+wil_rx_init_fndecl_50939_fns wil_rx_init fndecl 2 50939 NULL
+reg_list_size_bytes_amdgpu_rlc_50951_fns reg_list_size_bytes amdgpu_rlc 0 50951 NULL
+brcmf_p2p_escan_fndecl_50953_fns brcmf_p2p_escan fndecl 2 50953 NULL
+nsegments_dsp_module_desc_50965_fns nsegments dsp_module_desc 0 50965 NULL
+memdup_user_nul_fndecl_50968_fns memdup_user_nul fndecl 2 50968 NULL
+sdma_get_descq_cnt_fndecl_50975_fns sdma_get_descq_cnt fndecl 0 50975 NULL
+setkey_unaligned_fndecl_50977_fns setkey_unaligned fndecl 3 50977 NULL
+n_hdlc_tty_receive_fndecl_50980_fns n_hdlc_tty_receive fndecl 4 50980 NULL
+usif_ioctl_fndecl_50986_fns usif_ioctl fndecl 3 50986 NULL
+mic_desc_size_fndecl_51003_fns mic_desc_size fndecl 0 51003 NULL
+ib_uverbs_create_srq_fndecl_51025_fns ib_uverbs_create_srq fndecl 4-5 51025 NULL
+int_proc_write_fndecl_51045_fns int_proc_write fndecl 3 51045 NULL
+mlxsw_sp_port_prio_tc_set_fndecl_51047_fns mlxsw_sp_port_prio_tc_set fndecl 0 51047 NULL
+cl_req_alloc_fndecl_51056_fns cl_req_alloc fndecl 4 51056 NULL
+datablob_format_fndecl_51072_fns datablob_format fndecl 2 51072 NULL nohasharray
+ieee80211_if_read_fwded_mcast_fndecl_51072_fns ieee80211_if_read_fwded_mcast fndecl 3 51072 &datablob_format_fndecl_51072_fns
+pp_write_fndecl_51089_fns pp_write fndecl 3 51089 NULL
+copy_chunked_from_user_fndecl_51106_fns copy_chunked_from_user fndecl 3 51106 NULL
+memblock_virt_alloc_internal_fndecl_51107_fns memblock_virt_alloc_internal fndecl 1 51107 NULL
+queue_count_nvme_rdma_ctrl_51126_fns queue_count nvme_rdma_ctrl 0 51126 NULL
+igb_pci_enable_sriov_fndecl_51131_fns igb_pci_enable_sriov fndecl 2 51131 NULL
+wqe_cnt_mlx4_ib_wq_51135_fns wqe_cnt mlx4_ib_wq 0 51135 NULL
+nfs_idmap_get_key_fndecl_51155_fns nfs_idmap_get_key fndecl 2 51155 NULL
+num_backlights_lm3533_platform_data_51165_fns num_backlights lm3533_platform_data 0 51165 NULL
+kvm_read_guest_cached_fndecl_51169_fns kvm_read_guest_cached fndecl 4 51169 NULL
+__dev_alloc_name_fndecl_51173_fns __dev_alloc_name fndecl 0 51173 NULL
+v4l_stk_read_fndecl_51179_fns v4l_stk_read fndecl 3 51179 NULL
+snd_rme32_capture_copy_fndecl_51190_fns snd_rme32_capture_copy fndecl 5 51190 NULL
+prism2_info_hostscanresults_fndecl_51194_fns prism2_info_hostscanresults fndecl 3 51194 NULL
+drm_dp_dpcd_access_fndecl_51196_fns drm_dp_dpcd_access fndecl 0 51196 NULL
+btrfs_extent_same_fndecl_51200_fns btrfs_extent_same fndecl 3 51200 NULL
+kvm_clear_guest_fndecl_51207_fns kvm_clear_guest fndecl 3-2 51207 NULL
+goodix_i2c_write_fndecl_51209_fns goodix_i2c_write fndecl 4 51209 NULL
+mei_dbgfs_read_activation_fndecl_51224_fns mei_dbgfs_read_activation fndecl 3 51224 NULL
+rt2x00debug_write_rf_fndecl_51232_fns rt2x00debug_write_rf fndecl 3 51232 NULL
+get_ucode_user_fndecl_51241_fns get_ucode_user fndecl 3 51241 NULL
+imxdma_prep_dma_cyclic_fndecl_51257_fns imxdma_prep_dma_cyclic fndecl 4-3 51257 NULL
+ceph_decode_16_fndecl_51276_fns ceph_decode_16 fndecl 0 51276 NULL
+ramoops_read_kmsg_hdr_fndecl_51300_fns ramoops_read_kmsg_hdr fndecl 0 51300 NULL
+mthca_alloc_icm_table_fndecl_51311_fns mthca_alloc_icm_table fndecl 3-4 51311 NULL nohasharray
+ieee80211_if_read_auto_open_plinks_fndecl_51311_fns ieee80211_if_read_auto_open_plinks fndecl 3 51311 &mthca_alloc_icm_table_fndecl_51311_fns
+_ipw_read_reg32_fndecl_51318_fns _ipw_read_reg32 fndecl 0 51318 NULL
+drv_sds_rings_qlcnic_adapter_51319_fns drv_sds_rings qlcnic_adapter 0 51319 NULL
+dvb_register_device_fndecl_51331_fns dvb_register_device fndecl 6-0 51331 NULL
+C_SYSC_pselect6_fndecl_51339_fns C_SYSC_pselect6 fndecl 1 51339 NULL
+xfs_bmbt_to_bmdr_fndecl_51344_fns xfs_bmbt_to_bmdr fndecl 3 51344 NULL nohasharray
+xfs_bmdr_to_bmbt_fndecl_51344_fns xfs_bmdr_to_bmbt fndecl 5 51344 &xfs_bmbt_to_bmdr_fndecl_51344_fns
+dev_change_flags_fndecl_51349_fns dev_change_flags fndecl 0 51349 NULL
+isr_rx_headers_read_fndecl_51366_fns isr_rx_headers_read fndecl 3 51366 NULL
+uvc_try_frame_interval_fndecl_51372_fns uvc_try_frame_interval fndecl 0-2 51372 NULL
+ucma_query_path_fndecl_51378_fns ucma_query_path fndecl 3 51378 NULL
+num_queues_virtio_scsi_51387_fns num_queues virtio_scsi 0 51387 NULL nohasharray
+__ptr_ring_init_queue_alloc_fndecl_51387_fns __ptr_ring_init_queue_alloc fndecl 1 51387 &num_queues_virtio_scsi_51387_fns
+kmemleak_alloc_recursive_fndecl_51410_fns kmemleak_alloc_recursive fndecl 2 51410 NULL
+num_rx_queues_ixgbevf_adapter_51428_fns num_rx_queues ixgbevf_adapter 0 51428 NULL
+send_extent_data_fndecl_51438_fns send_extent_data fndecl 2 51438 NULL
+max_cmds_ipr_ioa_cfg_51439_fns max_cmds ipr_ioa_cfg 0 51439 NULL
+compat_sys_rt_sigpending_fndecl_51480_fns compat_sys_rt_sigpending fndecl 2 51480 NULL nohasharray
+vb2_dma_sg_alloc_fndecl_51480_fns vb2_dma_sg_alloc fndecl 3 51480 &compat_sys_rt_sigpending_fndecl_51480_fns
+num_vectors_mic_irq_info_51485_fns num_vectors mic_irq_info 0 51485 NULL
+end_soundfont_sample_info_51497_fns end soundfont_sample_info 0 51497 NULL
+fw_handle_comment_fndecl_51503_fns fw_handle_comment fndecl 3 51503 NULL
+_rtw_malloc_fndecl_51515_fns _rtw_malloc fndecl 1 51515 NULL
+nfp_net_rx_ring_alloc_fndecl_51524_fns nfp_net_rx_ring_alloc fndecl 3 51524 NULL
+fifo_alloc_fndecl_51546_fns fifo_alloc fndecl 1 51546 NULL
+persistent_ram_old_size_fndecl_51582_fns persistent_ram_old_size fndecl 0 51582 NULL
+aggr_recv_addba_req_evt_fndecl_51590_fns aggr_recv_addba_req_evt fndecl 4 51590 NULL
+il_dbgfs_chain_noise_read_fndecl_51599_fns il_dbgfs_chain_noise_read fndecl 3 51599 NULL
+wilc_add_beacon_fndecl_51601_fns wilc_add_beacon fndecl 6-4 51601 NULL
+vfp_get_fndecl_51605_fns vfp_get fndecl 3-4 51605 NULL
+etb_get_buffer_depth_fndecl_51607_fns etb_get_buffer_depth fndecl 0 51607 NULL
+cifs_send_async_read_fndecl_51630_fns cifs_send_async_read fndecl 2 51630 NULL
+sysfs_do_create_link_fndecl_51632_fns sysfs_do_create_link fndecl 0 51632 NULL
+wil_vring_init_bcast_fndecl_51633_fns wil_vring_init_bcast fndecl 3 51633 NULL nohasharray
+_iwl_dbgfs_fw_dbg_conf_write_fndecl_51633_fns _iwl_dbgfs_fw_dbg_conf_write fndecl 3 51633 &wil_vring_init_bcast_fndecl_51633_fns
+_xfs_buf_alloc_fndecl_51641_fns _xfs_buf_alloc fndecl 3 51641 NULL
+nsm_create_handle_fndecl_51647_fns nsm_create_handle fndecl 4 51647 NULL
+ath10k_mem_value_read_fndecl_51648_fns ath10k_mem_value_read fndecl 3 51648 NULL
+inet_set_ifa_fndecl_51661_fns inet_set_ifa fndecl 0 51661 NULL
+snd_pcm_oss_write_fndecl_51663_fns snd_pcm_oss_write fndecl 3 51663 NULL
+wcn36xx_smd_rsp_process_fndecl_51666_fns wcn36xx_smd_rsp_process fndecl 3 51666 NULL nohasharray
+xfs_buf_readahead_map_fndecl_51666_fns xfs_buf_readahead_map fndecl 3 51666 &wcn36xx_smd_rsp_process_fndecl_51666_fns
+resource_list_create_entry_fndecl_51673_fns resource_list_create_entry fndecl 2 51673 NULL
+ep0_read_fndecl_51676_fns ep0_read fndecl 3 51676 NULL
+proc_self_readlink_fndecl_51677_fns proc_self_readlink fndecl 3 51677 NULL
+request_key_auth_new_fndecl_51679_fns request_key_auth_new fndecl 3 51679 NULL
+num_req_context_skd_device_51707_fns num_req_context skd_device 0 51707 NULL
+iscsit_dump_data_payload_fndecl_51720_fns iscsit_dump_data_payload fndecl 2 51720 NULL
+ib_uverbs_modify_qp_fndecl_51721_fns ib_uverbs_modify_qp fndecl 4-5 51721 NULL nohasharray
+nlimbs_gcry_mpi_51721_fns nlimbs gcry_mpi 0 51721 &ib_uverbs_modify_qp_fndecl_51721_fns
+acpi_copy_property_array_u32_fndecl_51744_fns acpi_copy_property_array_u32 fndecl 0 51744 NULL
+sd_size_stat_data_v1_51758_fns sd_size stat_data_v1 0 51758 NULL
+btusb_qca_send_vendor_req_fndecl_51785_fns btusb_qca_send_vendor_req fndecl 4 51785 NULL
+iwl_dbgfs_thermal_throttling_read_fndecl_51816_fns iwl_dbgfs_thermal_throttling_read fndecl 3 51816 NULL
+bcache_device_init_fndecl_51822_fns bcache_device_init fndecl 3 51822 NULL
+do_pci_enable_device_fndecl_51841_fns do_pci_enable_device fndecl 0 51841 NULL
+ipv6_renew_option_fndecl_51854_fns ipv6_renew_option fndecl 3 51854 NULL
+nr_dma_pages_drm_savage_private_51862_fns nr_dma_pages drm_savage_private 0 51862 NULL
+direct_entry_fndecl_51879_fns direct_entry fndecl 3 51879 NULL
+sys_select_fndecl_51896_fns sys_select fndecl 1 51896 NULL
+interfaces_fndecl_51928_fns interfaces fndecl 2 51928 NULL
+traverse_fndecl_51938_fns traverse fndecl 2 51938 NULL
+nci_core_conn_create_fndecl_51946_fns nci_core_conn_create fndecl 4 51946 NULL
+__blk_queue_init_tags_fndecl_51956_fns __blk_queue_init_tags fndecl 2 51956 NULL
+ofdpa_group_l2_fan_out_fndecl_51958_fns ofdpa_group_l2_fan_out fndecl 4 51958 NULL
+max_data_size_mpt3_ioctl_header_51964_fns max_data_size mpt3_ioctl_header 0 51964 NULL
+dbgfs_state_fndecl_51965_fns dbgfs_state fndecl 3 51965 NULL
+ieee80211_if_read_dtim_count_fndecl_51968_fns ieee80211_if_read_dtim_count fndecl 3 51968 NULL
+pmcraid_copy_sglist_fndecl_51980_fns pmcraid_copy_sglist fndecl 3 51980 NULL
+mlx5_query_port_ptys_fndecl_52003_fns mlx5_query_port_ptys fndecl 3 52003 NULL
+kvm_write_guest_fndecl_52005_fns kvm_write_guest fndecl 4-2 52005 NULL
+videobuf_waiton_fndecl_52008_fns videobuf_waiton fndecl 0 52008 NULL
+seq_commit_fndecl_52023_fns seq_commit fndecl 2 52023 NULL
+kvm_arch_setup_async_pf_fndecl_52034_fns kvm_arch_setup_async_pf fndecl 3 52034 NULL
+ttm_dma_page_alloc_init_fndecl_52037_fns ttm_dma_page_alloc_init fndecl 2 52037 NULL
+btrfs_next_old_leaf_fndecl_52050_fns btrfs_next_old_leaf fndecl 0 52050 NULL
+wil_read_file_led_cfg_fndecl_52057_fns wil_read_file_led_cfg fndecl 3 52057 NULL
+_iwl_dbgfs_scan_ant_rxchain_write_fndecl_52060_fns _iwl_dbgfs_scan_ant_rxchain_write fndecl 3 52060 NULL
+event_rx_mismatch_read_fndecl_52069_fns event_rx_mismatch_read fndecl 3 52069 NULL
+iscsi_create_iface_fndecl_52093_fns iscsi_create_iface fndecl 5 52093 NULL
+dev_names_read_fndecl_52094_fns dev_names_read fndecl 3 52094 NULL
+assoc_rem_len_amp_ctrl_52099_fns assoc_rem_len amp_ctrl 0 52099 NULL
+drv_tx_rings_qlcnic_adapter_52102_fns drv_tx_rings qlcnic_adapter 0 52102 NULL
+cache_random_seq_create_fndecl_52109_fns cache_random_seq_create fndecl 2 52109 NULL
+fjes_hw_get_max_epid_fndecl_52129_fns fjes_hw_get_max_epid fndecl 0 52129 NULL
+snd_nm256_playback_copy_fndecl_52148_fns snd_nm256_playback_copy fndecl 5 52148 NULL
+il4965_rs_sta_dbgfs_scale_table_read_fndecl_52151_fns il4965_rs_sta_dbgfs_scale_table_read fndecl 3 52151 NULL
+indirect_sg_entries_vardecl_ib_srp_c_52165_fns indirect_sg_entries vardecl_ib_srp.c 0 52165 NULL
+rd_allocate_sgl_table_fndecl_52188_fns rd_allocate_sgl_table fndecl 3 52188 NULL
+regmap_calc_reg_len_fndecl_52195_fns regmap_calc_reg_len fndecl 0 52195 NULL
+qp_broker_alloc_fndecl_52197_fns qp_broker_alloc fndecl 6-5 52197 NULL
+audit_init_entry_fndecl_52199_fns audit_init_entry fndecl 1 52199 NULL
+write_enabled_file_bool_fndecl_52213_fns write_enabled_file_bool fndecl 3 52213 NULL
+size_elf_note_info_52250_fns size elf_note_info 0 52250 NULL
+num_alt_cx231xx_audio_52283_fns num_alt cx231xx_audio 0 52283 NULL
+rts51x_get_max_lun_fndecl_52294_fns rts51x_get_max_lun fndecl 0 52294 NULL
+alloc_page_ext_fndecl_52310_fns alloc_page_ext fndecl 1 52310 NULL
+cmd_len_c2h_evt_hdr_52322_fns cmd_len c2h_evt_hdr 0 52322 NULL
+rx_filter_dup_filter_read_fndecl_52325_fns rx_filter_dup_filter_read fndecl 3 52325 NULL
+iwl_dbgfs_d3_sram_read_fndecl_52326_fns iwl_dbgfs_d3_sram_read fndecl 3 52326 NULL
+luns_per_chnl_nvm_dev_52339_fns luns_per_chnl nvm_dev 0 52339 NULL
+__do_replace_fndecl_52344_fns __do_replace fndecl 5 52344 NULL
+xpc_connect_fndecl_52346_fns xpc_connect fndecl 5 52346 NULL
+_iwl_dbgfs_fw_restart_write_fndecl_52357_fns _iwl_dbgfs_fw_restart_write fndecl 3 52357 NULL
+rtl_read_byte_fndecl_52358_fns rtl_read_byte fndecl 0 52358 NULL
+nested_svm_map_fndecl_52359_fns nested_svm_map fndecl 2 52359 NULL
+num_phys_mptsas_portinfo_52375_fns num_phys mptsas_portinfo 0 52375 NULL
+nrealreaders_vardecl_rcutorture_c_52376_fns nrealreaders vardecl_rcutorture.c 0 52376 NULL
+error_tbc_exch_mismatch_read_fndecl_52388_fns error_tbc_exch_mismatch_read fndecl 3 52388 NULL
+ieee80211_if_read_power_mode_fndecl_52394_fns ieee80211_if_read_power_mode fndecl 3 52394 NULL
+command_fndecl_52411_fns command fndecl 0 52411 NULL
+scsi_mode_select_fndecl_52417_fns scsi_mode_select fndecl 6 52417 NULL nohasharray
+drm_fbdev_cma_init_fndecl_52417_fns drm_fbdev_cma_init fndecl 3-4-2 52417 &scsi_mode_select_fndecl_52417_fns
+sddr09_read_control_fndecl_52418_fns sddr09_read_control fndecl 3-5 52418 NULL
+security_inode_getsecurity_fndecl_52473_fns security_inode_getsecurity fndecl 0 52473 NULL
+tx_tx_data_programmed_read_fndecl_52500_fns tx_tx_data_programmed_read fndecl 3 52500 NULL
+ControllerNumber_DAC960_Controller_52503_fns ControllerNumber DAC960_Controller 0 52503 NULL
+svc_setsockopt_fndecl_52511_fns svc_setsockopt fndecl 5 52511 NULL
+selinux_inode_notifysecctx_fndecl_52531_fns selinux_inode_notifysecctx fndecl 3 52531 NULL
+data_size_binder_transaction_data_52567_fns data_size binder_transaction_data 0 52567 NULL
+il4965_rs_sta_dbgfs_scale_table_write_fndecl_52576_fns il4965_rs_sta_dbgfs_scale_table_write fndecl 3 52576 NULL
+auok190xfb_write_fndecl_52634_fns auok190xfb_write fndecl 3 52634 NULL
+setxattr_fndecl_52637_fns setxattr fndecl 4 52637 NULL
+page_count_drm_device_dma_52645_fns page_count drm_device_dma 0 52645 NULL
+num_txq_per_tx_bnad_52646_fns num_txq_per_tx bnad 0 52646 NULL
+ieee80211_chsw_switch_vifs_fndecl_52661_fns ieee80211_chsw_switch_vifs fndecl 2 52661 NULL
+ec_i2c_xfer_fndecl_52662_fns ec_i2c_xfer fndecl 3 52662 NULL
+command_file_read_fndecl_52669_fns command_file_read fndecl 3 52669 NULL
+vmap_batch_fndecl_52675_fns vmap_batch fndecl 2-3 52675 NULL
+parse_command_fndecl_52676_fns parse_command fndecl 2 52676 NULL
+SYSC_setxattr_fndecl_52677_fns SYSC_setxattr fndecl 4 52677 NULL
+drm_mode_create_rotation_property_fndecl_52681_fns drm_mode_create_rotation_property fndecl 2 52681 NULL
+_iwl_dbgfs_bcast_filters_macs_write_fndecl_52702_fns _iwl_dbgfs_bcast_filters_macs_write fndecl 3 52702 NULL
+regmap_map_read_file_fndecl_52774_fns regmap_map_read_file fndecl 3 52774 NULL
+SYSC_get_mempolicy_fndecl_52787_fns SYSC_get_mempolicy fndecl 3 52787 NULL
+avc_ca_pmt_fndecl_52789_fns avc_ca_pmt fndecl 3 52789 NULL
+ieee80211_if_read_rc_rateidx_mcs_mask_2ghz_fndecl_52792_fns ieee80211_if_read_rc_rateidx_mcs_mask_2ghz fndecl 3 52792 NULL
+app_size_ls_ucode_img_desc_52793_fns app_size ls_ucode_img_desc 0 52793 NULL
+wiphy_new_nm_fndecl_52833_fns wiphy_new_nm fndecl 2 52833 NULL
+ocfs2_control_cfu_fndecl_52837_fns ocfs2_control_cfu fndecl 2 52837 NULL
+xfs_cross_rename_fndecl_52839_fns xfs_cross_rename fndecl 10 52839 NULL
+ext2_fsync_fndecl_52850_fns ext2_fsync fndecl 2-3 52850 NULL
+dccp_setsockopt_cscov_fndecl_52885_fns dccp_setsockopt_cscov fndecl 2-0 52885 NULL
+nvram_len_nvram_parser_52887_fns nvram_len nvram_parser 0 52887 NULL
+rx_decrypt_key_not_found_read_fndecl_52911_fns rx_decrypt_key_not_found_read fndecl 3 52911 NULL
+il4965_rs_sta_dbgfs_rate_scale_data_read_fndecl_52915_fns il4965_rs_sta_dbgfs_rate_scale_data_read fndecl 3 52915 NULL
+smk_read_logging_fndecl_52927_fns smk_read_logging fndecl 3 52927 NULL
+o2hb_debug_read_fndecl_52936_fns o2hb_debug_read fndecl 3 52936 NULL
+minor_drbd_genlmsghdr_52949_fns minor drbd_genlmsghdr 0 52949 NULL
+__arm_iommu_alloc_attrs_fndecl_52955_fns __arm_iommu_alloc_attrs fndecl 2 52955 NULL
+sys_setxattr_fndecl_52971_fns sys_setxattr fndecl 4 52971 NULL
+tty_insert_flip_string_fixed_flag_fndecl_53031_fns tty_insert_flip_string_fixed_flag fndecl 4 53031 NULL
+sys_getxattr_fndecl_53049_fns sys_getxattr fndecl 4 53049 NULL
+acpi_os_allocate_zeroed_fndecl_53053_fns acpi_os_allocate_zeroed fndecl 1 53053 NULL
+pxad_prep_memcpy_fndecl_53065_fns pxad_prep_memcpy fndecl 4 53065 NULL
+kvm_vcpu_write_guest_page_fndecl_53070_fns kvm_vcpu_write_guest_page fndecl 5-2 53070 NULL
+omap_hwmod_mux_init_fndecl_53072_fns omap_hwmod_mux_init fndecl 2 53072 NULL
+fru_alloc_fndecl_53073_fns fru_alloc fndecl 1 53073 NULL
+ntfs_dir_fsync_fndecl_53093_fns ntfs_dir_fsync fndecl 2-3 53093 NULL
+wilc_spi_read_fndecl_53099_fns wilc_spi_read fndecl 4 53099 NULL
+brcmf_fw_nvram_strip_fndecl_53102_fns brcmf_fw_nvram_strip fndecl 2 53102 NULL
+rx_nr_rings_bnxt_53108_fns rx_nr_rings bnxt 0 53108 NULL
+xz_dec_test_write_fndecl_53124_fns xz_dec_test_write fndecl 3 53124 NULL
+fault_inject_read_fndecl_53133_fns fault_inject_read fndecl 3 53133 NULL
+vmalloc_32_user_fndecl_53148_fns vmalloc_32_user fndecl 1 53148 NULL
+private_data_len_ib_cm_sidr_req_param_53150_fns private_data_len ib_cm_sidr_req_param 0 53150 NULL
+lpfc_debugfs_max_disc_trc_vardecl_lpfc_debugfs_c_53169_fns lpfc_debugfs_max_disc_trc vardecl_lpfc_debugfs.c 0 53169 NULL
+num_tx_rings_nfp_net_53170_fns num_tx_rings nfp_net 0 53170 NULL
+SYSC_mbind_fndecl_53221_fns SYSC_mbind fndecl 5 53221 NULL
+debugfs_reg_len_regmap_53235_fns debugfs_reg_len regmap 0 53235 NULL
+kvm_read_guest_page_mmu_fndecl_53240_fns kvm_read_guest_page_mmu fndecl 6 53240 NULL
+vga_arb_write_fndecl_53251_fns vga_arb_write fndecl 3 53251 NULL
+simple_xattr_alloc_fndecl_53253_fns simple_xattr_alloc fndecl 2 53253 NULL
+nr_descriptors_hidma_dev_53264_fns nr_descriptors hidma_dev 0 53264 NULL
+maxreqs_nfsd4_channel_attrs_53285_fns maxreqs nfsd4_channel_attrs 0 53285 NULL
+b1_alloc_card_fndecl_53288_fns b1_alloc_card fndecl 1 53288 NULL
+vmalloc_exec_fndecl_53303_fns vmalloc_exec fndecl 1 53303 NULL
+snd_korg1212_copy_from_fndecl_53338_fns snd_korg1212_copy_from fndecl 6 53338 NULL
+SYSC_sched_getaffinity_fndecl_53347_fns SYSC_sched_getaffinity fndecl 2 53347 NULL
+ramoops_init_przs_fndecl_53364_fns ramoops_init_przs fndecl 4 53364 NULL
+SYSC_getxattr_fndecl_53377_fns SYSC_getxattr fndecl 4 53377 NULL
+viafb_iga1_odev_proc_write_fndecl_53378_fns viafb_iga1_odev_proc_write fndecl 3 53378 NULL
+rproc_recovery_read_fndecl_53382_fns rproc_recovery_read fndecl 3 53382 NULL
+command_setformat_fndecl_53392_fns command_setformat fndecl 0 53392 NULL
+wil_agg_size_fndecl_53398_fns wil_agg_size fndecl 0-2 53398 NULL
+num_entries_s2io_nic_53404_fns num_entries s2io_nic 0 53404 NULL
+set_rcvarray_entry_fndecl_53410_fns set_rcvarray_entry fndecl 6 53410 NULL
+cfs_hash_buckets_realloc_fndecl_53415_fns cfs_hash_buckets_realloc fndecl 4 53415 NULL
+rxHeader3_edgeport_serial_53418_fns rxHeader3 edgeport_serial 0 53418 NULL
+codec_reg_read_file_fndecl_53419_fns codec_reg_read_file fndecl 3 53419 NULL
+compat_sys_mbind_fndecl_53427_fns compat_sys_mbind fndecl 5 53427 NULL
+ad7879_spi_xfer_fndecl_53444_fns ad7879_spi_xfer fndecl 3 53444 NULL
+nouveau_cli_create_fndecl_53462_fns nouveau_cli_create fndecl 3 53462 NULL
+lpfc_debugfs_dif_err_read_fndecl_53468_fns lpfc_debugfs_dif_err_read fndecl 3 53468 NULL
+jbd2_journal_init_revoke_table_fndecl_53475_fns jbd2_journal_init_revoke_table fndecl 1 53475 NULL
+ath6kl_regwrite_write_fndecl_53484_fns ath6kl_regwrite_write fndecl 3 53484 NULL
+lc_create_fndecl_53503_fns lc_create fndecl 4 53503 NULL
+mthca_buf_alloc_fndecl_53510_fns mthca_buf_alloc fndecl 2 53510 NULL
+tx_tx_cmplt_read_fndecl_53533_fns tx_tx_cmplt_read fndecl 3 53533 NULL
+uwb_rc_cmd_done_fndecl_53543_fns uwb_rc_cmd_done fndecl 4 53543 NULL
+num_req_vfs_i40e_pf_53554_fns num_req_vfs i40e_pf 0 53554 NULL
+sctp_tsnmap_mark_fndecl_53578_fns sctp_tsnmap_mark fndecl 2 53578 NULL
+rx_defrag_init_called_read_fndecl_53580_fns rx_defrag_init_called_read fndecl 3 53580 NULL
+mlx5_get_gid_table_len_fndecl_53590_fns mlx5_get_gid_table_len fndecl 0-1 53590 NULL
+kernel_setsockopt_fndecl_53594_fns kernel_setsockopt fndecl 5 53594 NULL
+cow_file_range_async_fndecl_53595_fns cow_file_range_async fndecl 4-3 53595 NULL
+put_cmsg_compat_fndecl_53618_fns put_cmsg_compat fndecl 4 53618 NULL
+header_len_tso_state_53620_fns header_len tso_state 0 53620 NULL
+num_channels_mlx5e_params_53632_fns num_channels mlx5e_params 0 53632 NULL
+device_add_class_symlinks_fndecl_53634_fns device_add_class_symlinks fndecl 0 53634 NULL
+write_file_antenna_fndecl_53645_fns write_file_antenna fndecl 3 53645 NULL
+generic_ocp_read_fndecl_53653_fns generic_ocp_read fndecl 3 53653 NULL
+acl_alloc_fndecl_53656_fns acl_alloc fndecl 1 53656 NULL
+il3945_ucode_tx_stats_read_fndecl_53667_fns il3945_ucode_tx_stats_read fndecl 3 53667 NULL
+__videobuf_alloc_fndecl_53676_fns __videobuf_alloc fndecl 1 53676 NULL
+list_lru_count_one_fndecl_53682_fns list_lru_count_one fndecl 0 53682 NULL
+lov_mds_md_max_stripe_count_fndecl_53691_fns lov_mds_md_max_stripe_count fndecl 0-1 53691 NULL
+carl9170_rx_untie_cmds_fndecl_53694_fns carl9170_rx_untie_cmds fndecl 3 53694 NULL
+gpio_power_read_fndecl_53704_fns gpio_power_read fndecl 3 53704 NULL
+sys_init_module_fndecl_53724_fns sys_init_module fndecl 2 53724 NULL
+mtip_hw_read_device_status_fndecl_53729_fns mtip_hw_read_device_status fndecl 3 53729 NULL
+snd_pcm_plug_read_transfer_fndecl_53731_fns snd_pcm_plug_read_transfer fndecl 0-3 53731 NULL
+xhci_alloc_stream_info_fndecl_53732_fns xhci_alloc_stream_info fndecl 3 53732 NULL
+write_emulate_fndecl_53746_fns write_emulate fndecl 2-4 53746 NULL
+dies_onenand_chip_53762_fns dies onenand_chip 0 53762 NULL
+vxge_config_vpaths_fndecl_53775_fns vxge_config_vpaths fndecl 0 53775 NULL
+locations_count_nfsd4_fs_locations_53786_fns locations_count nfsd4_fs_locations 0 53786 NULL
+ring_size_netvsc_device_info_53811_fns ring_size netvsc_device_info 0 53811 NULL
+lpfc_idiag_extacc_alloc_get_fndecl_53819_fns lpfc_idiag_extacc_alloc_get fndecl 0-3 53819 NULL
+logical_minimum_hid_field_53820_fns logical_minimum hid_field 0 53820 NULL
+elfcorebuf_sz_orig_vardecl_vmcore_c_53821_fns elfcorebuf_sz_orig vardecl_vmcore.c 0 53821 NULL
+cam_get_response16_fndecl_53836_fns cam_get_response16 fndecl 0 53836 NULL
+num_sensors_ibmpex_bmc_data_53838_fns num_sensors ibmpex_bmc_data 0 53838 NULL
+xillybus_read_fndecl_53845_fns xillybus_read fndecl 3 53845 NULL
+buffer_blocks_st_buffer_53878_fns buffer_blocks st_buffer 0 53878 NULL
+nilfs_sufile_set_segment_usage_fndecl_53885_fns nilfs_sufile_set_segment_usage fndecl 2 53885 NULL
+path_getxattr_fndecl_53886_fns path_getxattr fndecl 4 53886 NULL
+snd_rawmidi_kernel_read1_fndecl_53911_fns snd_rawmidi_kernel_read1 fndecl 4 53911 NULL nohasharray
+oobavail_jffs2_sb_info_53911_fns oobavail jffs2_sb_info 0 53911 &snd_rawmidi_kernel_read1_fndecl_53911_fns
+cxgbi_device_register_fndecl_53913_fns cxgbi_device_register fndecl 2-1 53913 NULL
+hiddev_ioctl_fndecl_53955_fns hiddev_ioctl fndecl 2 53955 NULL
+proc_fault_inject_read_fndecl_53969_fns proc_fault_inject_read fndecl 3 53969 NULL
+cm_write_fndecl_53993_fns cm_write fndecl 3 53993 NULL
+sierra_write_fndecl_54049_fns sierra_write fndecl 4 54049 NULL
+_iwl_dbgfs_uapsd_misbehaving_write_fndecl_54054_fns _iwl_dbgfs_uapsd_misbehaving_write fndecl 3 54054 NULL
+tunables_read_fndecl_54066_fns tunables_read fndecl 3 54066 NULL
+afs_alloc_flat_call_fndecl_54076_fns afs_alloc_flat_call fndecl 2-3 54076 NULL
+sctp_tsnmap_init_fndecl_54093_fns sctp_tsnmap_init fndecl 3 54093 NULL
+bytes_read_usbvision_frame_54101_fns bytes_read usbvision_frame 0 54101 NULL
+i2c_bus_read_fndecl_54111_fns i2c_bus_read fndecl 0 54111 NULL
+br_min_mtu_fndecl_54113_fns br_min_mtu fndecl 0 54113 NULL
+carl9170_exec_cmd_fndecl_54141_fns carl9170_exec_cmd fndecl 3 54141 NULL
+f2fs_do_collapse_fndecl_54143_fns f2fs_do_collapse fndecl 3 54143 NULL
+tracing_map_array_alloc_fndecl_54155_fns tracing_map_array_alloc fndecl 1 54155 NULL
+__hwahc_op_set_ptk_fndecl_54157_fns __hwahc_op_set_ptk fndecl 5 54157 NULL
+b43_nphy_load_samples_fndecl_54162_fns b43_nphy_load_samples fndecl 3 54162 NULL
+cpu_type_read_fndecl_54191_fns cpu_type_read fndecl 3 54191 NULL
+_iwl_dbgfs_fw_nmi_write_fndecl_54192_fns _iwl_dbgfs_fw_nmi_write fndecl 3 54192 NULL
+ieee80211_if_read_fwded_frames_fndecl_54203_fns ieee80211_if_read_fwded_frames fndecl 3 54203 NULL
+p_filesz_elf32_phdr_54204_fns p_filesz elf32_phdr 0 54204 NULL
+nframes_bcm_msg_head_54207_fns nframes bcm_msg_head 0 54207 NULL
+numeraseregions_mtd_info_54223_fns numeraseregions mtd_info 0 54223 NULL
+__kfifo_to_user_fndecl_54232_fns __kfifo_to_user fndecl 3 54232 NULL
+pcnet32_realloc_rx_ring_fndecl_54245_fns pcnet32_realloc_rx_ring fndecl 3 54245 NULL
+fl_size_qset_params_54254_fns fl_size qset_params 0 54254 NULL
+__erst_read_fndecl_54256_fns __erst_read fndecl 0 54256 NULL
+put_cmsg_fndecl_54270_fns put_cmsg fndecl 4 54270 NULL
+fat_file_fsync_fndecl_54291_fns fat_file_fsync fndecl 2-3 54291 NULL
+pvr2_issue_simple_cmd_fndecl_54313_fns pvr2_issue_simple_cmd fndecl 2 54313 NULL
+capi_write_fndecl_54323_fns capi_write fndecl 3 54323 NULL nohasharray
+tx_tx_done_template_read_fndecl_54323_fns tx_tx_done_template_read fndecl 3 54323 &capi_write_fndecl_54323_fns
+ide_settings_proc_write_fndecl_54325_fns ide_settings_proc_write fndecl 3 54325 NULL
+nla_alloc_flow_actions_fndecl_54328_fns nla_alloc_flow_actions fndecl 1 54328 NULL
+ieee80211_if_read_bssid_fndecl_54346_fns ieee80211_if_read_bssid fndecl 3 54346 NULL
+gntdev_alloc_map_fndecl_54362_fns gntdev_alloc_map fndecl 2 54362 NULL
+size_ramoops_context_54365_fns size ramoops_context 0 54365 NULL
+usb_cdc_wdm_register_fndecl_54371_fns usb_cdc_wdm_register fndecl 3 54371 NULL
+scif_setup_qp_connect_fndecl_54372_fns scif_setup_qp_connect fndecl 3 54372 NULL
+nbufs_mlx4_buf_54391_fns nbufs mlx4_buf 0 54391 NULL
+ring_size_netvsc_device_54397_fns ring_size netvsc_device 0 54397 NULL
+security_key_getsecurity_fndecl_54401_fns security_key_getsecurity fndecl 0 54401 NULL
+rx_rx_cmplt_task_read_fndecl_54409_fns rx_rx_cmplt_task_read fndecl 3 54409 NULL
+qat_hal_get_ins_num_fndecl_54416_fns qat_hal_get_ins_num fndecl 0 54416 NULL
+nrof_flowrings_brcmf_bus_msgbuf_54417_fns nrof_flowrings brcmf_bus_msgbuf 0 54417 NULL
+set_fd_set_fndecl_54434_fns set_fd_set fndecl 1 54434 NULL
+gfn_to_page_many_atomic_fndecl_54449_fns gfn_to_page_many_atomic fndecl 2 54449 NULL
+kimage_file_prepare_segments_fndecl_54451_fns kimage_file_prepare_segments fndecl 5 54451 NULL
+virtio_transport_stream_enqueue_fndecl_54452_fns virtio_transport_stream_enqueue fndecl 3 54452 NULL
+regmap_cache_bypass_write_file_fndecl_54455_fns regmap_cache_bypass_write_file fndecl 3 54455 NULL
+nvkm_notify_init_fndecl_54464_fns nvkm_notify_init fndecl 7 54464 NULL nohasharray
+isr_rx_rdys_read_fndecl_54464_fns isr_rx_rdys_read fndecl 3 54464 &nvkm_notify_init_fndecl_54464_fns
+sys_setsockopt_fndecl_54507_fns sys_setsockopt fndecl 5 54507 NULL
+bio_segments_fndecl_54531_fns bio_segments fndecl 0 54531 NULL
+b43_debugfs_write_fndecl_54533_fns b43_debugfs_write fndecl 3 54533 NULL
+__i2c_debugfs_read_fndecl_54556_fns __i2c_debugfs_read fndecl 3 54556 NULL
+ieee80211_if_read_txpower_fndecl_54564_fns ieee80211_if_read_txpower fndecl 3 54564 NULL
+cp_nr_rings_bnxt_54565_fns cp_nr_rings bnxt 0 54565 NULL
+acpi_system_write_wakeup_device_fndecl_54582_fns acpi_system_write_wakeup_device fndecl 3 54582 NULL
+mipi_dsi_dcs_write_fndecl_54605_fns mipi_dsi_dcs_write fndecl 4 54605 NULL
+nfs4_get_acl_uncached_fndecl_54608_fns nfs4_get_acl_uncached fndecl 3 54608 NULL
+msg_print_text_fndecl_54618_fns msg_print_text fndecl 0 54618 NULL
+ieee80211_if_write_fndecl_54621_fns ieee80211_if_write fndecl 3 54621 NULL
+len_ncp_privatedata_ioctl_54632_fns len ncp_privatedata_ioctl 0 54632 NULL
+si476x_radio_read_rsq_primary_blob_fndecl_54647_fns si476x_radio_read_rsq_primary_blob fndecl 3 54647 NULL
+get_vddc_lookup_table_fndecl_54661_fns get_vddc_lookup_table fndecl 4 54661 NULL
+auxdev_write_fndecl_54681_fns auxdev_write fndecl 3 54681 NULL
+i2c_transfer_fndecl_54685_fns i2c_transfer fndecl 0 54685 NULL
+rx_rx_hdr_overflow_read_fndecl_54697_fns rx_rx_hdr_overflow_read fndecl 3 54697 NULL
+coda_psdev_read_fndecl_54726_fns coda_psdev_read fndecl 3 54726 NULL
+proc_setgroups_write_fndecl_54732_fns proc_setgroups_write fndecl 3 54732 NULL
+hwdep_read_locked_fndecl_54734_fns hwdep_read_locked fndecl 3 54734 NULL
+mei_cldev_send_fndecl_54754_fns mei_cldev_send fndecl 3 54754 NULL
+pwr_connection_out_of_sync_read_fndecl_54758_fns pwr_connection_out_of_sync_read fndecl 3 54758 NULL
+cqm_max_rmid_vardecl_cqm_c_54798_fns cqm_max_rmid vardecl_cqm.c 0 54798 NULL
+spk_msg_set_fndecl_54801_fns spk_msg_set fndecl 3 54801 NULL
+buf_size__BIG_IOCTL_Command_struct_54806_fns buf_size _BIG_IOCTL_Command_struct 0 54806 NULL
+pci_request_regions_fndecl_54816_fns pci_request_regions fndecl 0 54816 NULL
+i2c1_debugfs_write_fndecl_54837_fns i2c1_debugfs_write fndecl 3 54837 NULL
+ixgbe_pci_sriov_configure_fndecl_54843_fns ixgbe_pci_sriov_configure fndecl 2 54843 NULL
+compat_sys_kexec_load_fndecl_54857_fns compat_sys_kexec_load fndecl 2 54857 NULL
+spi_register_board_info_fndecl_54864_fns spi_register_board_info fndecl 2 54864 NULL
+usb_dmac_desc_get_fndecl_54869_fns usb_dmac_desc_get fndecl 2 54869 NULL
+compress_sliced_buf_fndecl_54891_fns compress_sliced_buf fndecl 0 54891 NULL
+num_uars_mlx5_uuar_info_54898_fns num_uars mlx5_uuar_info 0 54898 NULL
+buffer_size_qcaspi_54902_fns buffer_size qcaspi 0 54902 NULL
+rds_page_copy_user_fndecl_54904_fns rds_page_copy_user fndecl 4 54904 NULL
+pcan_dump_mem_fndecl_54915_fns pcan_dump_mem fndecl 3 54915 NULL
+sd_start_ov361x_fndecl_54922_fns sd_start_ov361x fndecl 0 54922 NULL
+iwl_dbgfs_disable_ht40_read_fndecl_54946_fns iwl_dbgfs_disable_ht40_read fndecl 3 54946 NULL
+len_cn_msg_54981_fns len cn_msg 0 54981 NULL
+fence_wait_any_timeout_fndecl_54982_fns fence_wait_any_timeout fndecl 2 54982 NULL
+alloc_netdev_mqs_fndecl_54989_fns alloc_netdev_mqs fndecl 5-6-1 54989 NULL
+udf_alloc_i_data_fndecl_55001_fns udf_alloc_i_data fndecl 2 55001 NULL
+pvr2_hdw_cpufw_get_fndecl_55011_fns pvr2_hdw_cpufw_get fndecl 0-2-4 55011 NULL
+command_setcompressionparams_fndecl_55026_fns command_setcompressionparams fndecl 0 55026 NULL
+length_i2400m_tlv_hdr_55043_fns length i2400m_tlv_hdr 0 55043 NULL
+hpi_alloc_control_cache_fndecl_55044_fns hpi_alloc_control_cache fndecl 1 55044 NULL
+sddr55_get_capacity_fndecl_55072_fns sddr55_get_capacity fndecl 0 55072 NULL
+read_kmem_fndecl_55103_fns read_kmem fndecl 3 55103 NULL
+length_dw_radeon_cs_chunk_55128_fns length_dw radeon_cs_chunk 0 55128 NULL
+btrfs_search_old_slot_fndecl_55133_fns btrfs_search_old_slot fndecl 0 55133 NULL
+iwl_dbgfs_drv_rx_stats_read_fndecl_55157_fns iwl_dbgfs_drv_rx_stats_read fndecl 3 55157 NULL
+buffer_to_user_fndecl_55164_fns buffer_to_user fndecl 3 55164 NULL
+virtqueue_get_vring_size_fndecl_55188_fns virtqueue_get_vring_size fndecl 0 55188 NULL
+efx_mcdi_rpc_async_quiet_fndecl_55191_fns efx_mcdi_rpc_async_quiet fndecl 4-5 55191 NULL
+rxpipe_tx_xfr_host_int_trig_rx_data_read_fndecl_55233_fns rxpipe_tx_xfr_host_int_trig_rx_data_read fndecl 3 55233 NULL
+pstore_mkfile_fndecl_55235_fns pstore_mkfile fndecl 7 55235 NULL
+async_setkey_fndecl_55250_fns async_setkey fndecl 3 55250 NULL
+req_ring_size_srp_target_port_55251_fns req_ring_size srp_target_port 0 55251 NULL
+drm_dp_dual_mode_write_fndecl_55258_fns drm_dp_dual_mode_write fndecl 4 55258 NULL nohasharray
+size_pci_cap_saved_data_55258_fns size pci_cap_saved_data 0 55258 &drm_dp_dual_mode_write_fndecl_55258_fns
+iwl_dbgfs_bt_traffic_read_fndecl_55261_fns iwl_dbgfs_bt_traffic_read fndecl 3 55261 NULL
+bpf_convert_filter_fndecl_55264_fns bpf_convert_filter fndecl 2 55264 NULL
+dev_alloc_name_ns_fndecl_55266_fns dev_alloc_name_ns fndecl 0 55266 NULL
+num_radar_types_dfs_pattern_detector_55279_fns num_radar_types dfs_pattern_detector 0 55279 NULL
+vb2_dqbuf_fndecl_55284_fns vb2_dqbuf fndecl 0 55284 NULL
+readlen_proc_data_55289_fns readlen proc_data 0 55289 NULL
+sq905c_command_fndecl_55293_fns sq905c_command fndecl 0 55293 NULL
+C_SYSC_kexec_load_fndecl_55294_fns C_SYSC_kexec_load fndecl 2 55294 NULL
+memcg_update_all_caches_fndecl_55303_fns memcg_update_all_caches fndecl 1 55303 NULL
+proc_scsi_host_write_fndecl_55336_fns proc_scsi_host_write fndecl 3 55336 NULL
+pipeline_pipeline_fifo_full_read_fndecl_55356_fns pipeline_pipeline_fifo_full_read fndecl 3 55356 NULL
+islpci_mgt_transmit_fndecl_55366_fns islpci_mgt_transmit fndecl 5 55366 NULL
+ixgbe_dbg_netdev_ops_write_fndecl_55374_fns ixgbe_dbg_netdev_ops_write fndecl 3 55374 NULL
+find_phys_blocks_fndecl_55388_fns find_phys_blocks fndecl 0 55388 NULL
+periodic_size_oxu_hcd_55401_fns periodic_size oxu_hcd 0 55401 NULL
+shmem_pread_fast_fndecl_55408_fns shmem_pread_fast fndecl 3 55408 NULL
+len_wm_coeff_parsed_coeff_55454_fns len wm_coeff_parsed_coeff 0 55454 NULL
+start_genius_cam_fndecl_55469_fns start_genius_cam fndecl 0 55469 NULL
+bl_pipe_downcall_fndecl_55499_fns bl_pipe_downcall fndecl 3 55499 NULL
+setup_nodes_for_search_fndecl_55515_fns setup_nodes_for_search fndecl 0 55515 NULL
+isoc_enable_fndecl_55546_fns isoc_enable fndecl 0 55546 NULL
+filter_write_fndecl_55560_fns filter_write fndecl 3 55560 NULL
+exofs_file_fsync_fndecl_55588_fns exofs_file_fsync fndecl 2-3 55588 NULL
+vmw_setup_otable_base_fndecl_55639_fns vmw_setup_otable_base fndecl 4 55639 NULL
+sg_nents_fndecl_55654_fns sg_nents fndecl 0 55654 NULL
+ath6kl_roam_mode_write_fndecl_55659_fns ath6kl_roam_mode_write fndecl 3 55659 NULL
+queue_logical_block_size_fndecl_55661_fns queue_logical_block_size fndecl 0 55661 NULL
+lpfc_idiag_ctlacc_read_fndecl_55684_fns lpfc_idiag_ctlacc_read fndecl 3 55684 NULL
+sel_read_avc_cache_threshold_fndecl_55685_fns sel_read_avc_cache_threshold fndecl 3 55685 NULL
+rs_sta_dbgfs_drv_tx_stats_read_fndecl_55689_fns rs_sta_dbgfs_drv_tx_stats_read fndecl 3 55689 NULL
+stv06xx_write_bridge_fndecl_55690_fns stv06xx_write_bridge fndecl 0 55690 NULL
+read_file_tgt_rx_stats_fndecl_55691_fns read_file_tgt_rx_stats fndecl 3 55691 NULL
+kvm_vcpu_gfn_to_page_fndecl_55725_fns kvm_vcpu_gfn_to_page fndecl 2 55725 NULL
+mpi_from_key_fndecl_55729_fns mpi_from_key fndecl 0 55729 NULL
+cnt_mon_text_ptr_55741_fns cnt mon_text_ptr 0 55741 NULL
+__az6007_read_fndecl_55752_fns __az6007_read fndecl 6 55752 NULL
+vga_switcheroo_debugfs_write_fndecl_55763_fns vga_switcheroo_debugfs_write fndecl 3 55763 NULL
+cmd_read_size_wiimote_state_55772_fns cmd_read_size wiimote_state 0 55772 NULL
+ppp_write_fndecl_55777_fns ppp_write fndecl 3 55777 NULL
+rx_rx_xfr_read_fndecl_55779_fns rx_rx_xfr_read fndecl 3 55779 NULL
+init_send_hfcd_fndecl_55817_fns init_send_hfcd fndecl 1 55817 NULL
+rd_host_buf_pos_xilly_channel_55837_fns rd_host_buf_pos xilly_channel 0 55837 NULL
+__jffs2_ref_totlen_fndecl_55842_fns __jffs2_ref_totlen fndecl 0 55842 NULL
+raydium_i2c_write_object_fndecl_55850_fns raydium_i2c_write_object fndecl 3 55850 NULL
+rdma_rw_init_map_wrs_fndecl_55859_fns rdma_rw_init_map_wrs fndecl 4 55859 NULL
+cw1200_queue_init_fndecl_55860_fns cw1200_queue_init fndecl 4 55860 NULL
+do_raw_getsockopt_fndecl_55863_fns do_raw_getsockopt fndecl 0 55863 NULL
+nports_cyclades_card_55865_fns nports cyclades_card 0 55865 NULL
+cnic_alloc_dma_fndecl_55874_fns cnic_alloc_dma fndecl 3 55874 NULL
+ad7280_chain_setup_fndecl_55912_fns ad7280_chain_setup fndecl 0 55912 NULL
+isr_fiqs_read_fndecl_55916_fns isr_fiqs_read fndecl 3 55916 NULL
+_iwl_dbgfs_tof_enable_write_fndecl_55919_fns _iwl_dbgfs_tof_enable_write fndecl 3 55919 NULL
+response_length_mlx5_ib_create_wq_resp_55932_fns response_length mlx5_ib_create_wq_resp 0 55932 NULL
+pktlen_pkt_attrib_55936_fns pktlen pkt_attrib 0 55936 NULL
+batadv_tvlv_realloc_packet_buff_fndecl_55955_fns batadv_tvlv_realloc_packet_buff fndecl 3-4 55955 NULL
+reg_w_ixbuf_fndecl_55971_fns reg_w_ixbuf fndecl 4 55971 NULL
+ieee80211_if_read_num_sta_ps_fndecl_55985_fns ieee80211_if_read_num_sta_ps fndecl 3 55985 NULL
+platform_list_read_file_fndecl_55997_fns platform_list_read_file fndecl 3 55997 NULL
+usbtest_alloc_urb_fndecl_56013_fns usbtest_alloc_urb fndecl 3-5 56013 NULL
+ath10k_read_ani_enable_fndecl_56020_fns ath10k_read_ani_enable fndecl 3 56020 NULL
+bootmode_store_fndecl_56025_fns bootmode_store fndecl 4 56025 NULL
+__iio_device_attr_init_fndecl_56028_fns __iio_device_attr_init fndecl 0 56028 NULL
+device_add_fndecl_56029_fns device_add fndecl 0 56029 NULL
+SYSC_keyctl_fndecl_56035_fns SYSC_keyctl fndecl 4 56035 NULL
+chainsize_ctlr_info_56067_fns chainsize ctlr_info 0 56067 NULL
+iov_iter_single_seg_count_fndecl_56069_fns iov_iter_single_seg_count fndecl 0 56069 NULL
+acpi_data_get_property_fndecl_56093_fns acpi_data_get_property fndecl 0 56093 NULL
+proc_thread_self_readlink_fndecl_56102_fns proc_thread_self_readlink fndecl 3 56102 NULL
+maximum_input_absinfo_56108_fns maximum input_absinfo 0 56108 NULL
+block_size_ecryptfs_write_tag_70_packet_silly_stack_56117_fns block_size ecryptfs_write_tag_70_packet_silly_stack 0 56117 NULL
+ssl_prev_nilfs_snapshot_list_56120_fns ssl_prev nilfs_snapshot_list 0 56120 NULL
+usbvision_v4l2_read_fndecl_56129_fns usbvision_v4l2_read fndecl 3 56129 NULL
+av7110_vbi_write_fndecl_56131_fns av7110_vbi_write fndecl 3 56131 NULL
+_iwl_dbgfs_low_latency_write_fndecl_56153_fns _iwl_dbgfs_low_latency_write fndecl 3 56153 NULL
+iwl_calib_set_fndecl_56179_fns iwl_calib_set fndecl 3 56179 NULL nohasharray
+ivtv_read_pos_fndecl_56179_fns ivtv_read_pos fndecl 3 56179 &iwl_calib_set_fndecl_56179_fns
+size_netlbl_domhsh_tbl_56186_fns size netlbl_domhsh_tbl 0 56186 NULL
+dma_rx_size_sxgbe_priv_data_56205_fns dma_rx_size sxgbe_priv_data 0 56205 NULL
+rvt_alloc_mr_fndecl_56236_fns rvt_alloc_mr fndecl 3 56236 NULL
+qlcnic_set_tx_ring_count_fndecl_56242_fns qlcnic_set_tx_ring_count fndecl 2 56242 NULL
+dt_gpio_count_fndecl_56245_fns dt_gpio_count fndecl 0 56245 NULL
+mwifiex_regrdwr_read_fndecl_56251_fns mwifiex_regrdwr_read fndecl 3 56251 NULL
+qp_alloc_res_fndecl_56275_fns qp_alloc_res fndecl 5 56275 NULL
+x_max_wacom_features_56285_fns x_max wacom_features 0 56285 NULL
+SYSC_lgetxattr_fndecl_56330_fns SYSC_lgetxattr fndecl 4 56330 NULL
+ebt_compat_match_offset_fndecl_56334_fns ebt_compat_match_offset fndecl 2 56334 NULL
+pipeline_dec_packet_in_fifo_full_read_fndecl_56335_fns pipeline_dec_packet_in_fifo_full_read fndecl 3 56335 NULL
+blocked_fl_read_fndecl_56341_fns blocked_fl_read fndecl 3 56341 NULL
+mapping_level_fndecl_56350_fns mapping_level fndecl 0-2 56350 NULL
+stats_dot11RTSSuccessCount_read_fndecl_56378_fns stats_dot11RTSSuccessCount_read fndecl 3 56378 NULL
+sel_read_checkreqprot_fndecl_56383_fns sel_read_checkreqprot fndecl 3 56383 NULL
+nd_cmd_in_size_fndecl_56386_fns nd_cmd_in_size fndecl 0 56386 NULL
+max_eps_mv_u3d_56428_fns max_eps mv_u3d 0 56428 NULL
+stat_len_sge_56432_fns stat_len sge 0 56432 NULL
+fb_sys_write_fndecl_56441_fns fb_sys_write fndecl 3 56441 NULL
+alloc_gid_table_fndecl_56444_fns alloc_gid_table fndecl 1 56444 NULL
+_pci_add_cap_save_buffer_fndecl_56466_fns _pci_add_cap_save_buffer fndecl 4 56466 NULL
+dataflash_read_fact_otp_fndecl_56487_fns dataflash_read_fact_otp fndecl 2-3 56487 NULL
+pp_read_fndecl_56489_fns pp_read fndecl 3 56489 NULL
+batadv_socket_receive_packet_fndecl_56509_fns batadv_socket_receive_packet fndecl 2 56509 NULL
+portcntrnameslen_hfi1_devdata_56510_fns portcntrnameslen hfi1_devdata 0 56510 NULL
+__vb2_wait_for_done_vb_fndecl_56525_fns __vb2_wait_for_done_vb fndecl 0 56525 NULL
+cachefiles_cook_key_fndecl_56553_fns cachefiles_cook_key fndecl 2 56553 NULL
+_mv88e6xxx_port_vlan_del_fndecl_56566_fns _mv88e6xxx_port_vlan_del fndecl 3 56566 NULL
+rss_table_size_i40e_pf_56586_fns rss_table_size i40e_pf 0 56586 NULL
+rproc_name_read_fndecl_56630_fns rproc_name_read fndecl 3 56630 NULL
+count_v4l2_requestbuffers_56650_fns count v4l2_requestbuffers 0 56650 NULL
+cifs_writedata_alloc_fndecl_56675_fns cifs_writedata_alloc fndecl 1 56675 NULL nohasharray
+ath6kl_usb_submit_ctrl_in_fndecl_56675_fns ath6kl_usb_submit_ctrl_in fndecl 6 56675 &cifs_writedata_alloc_fndecl_56675_fns
+vp702x_usb_inout_cmd_fndecl_56679_fns vp702x_usb_inout_cmd fndecl 4-6 56679 NULL
+new_tape_buffer_fndecl_56689_fns new_tape_buffer fndecl 2 56689 NULL
+usb_err_gspca_dev_56706_fns usb_err gspca_dev 0 56706 NULL nohasharray
+il_dbgfs_tx_stats_read_fndecl_56706_fns il_dbgfs_tx_stats_read fndecl 3 56706 &usb_err_gspca_dev_56706_fns
+mlx5_modify_nic_vport_mac_list_fndecl_56715_fns mlx5_modify_nic_vport_mac_list fndecl 4 56715 NULL
+zlib_inflate_workspacesize_fndecl_56716_fns zlib_inflate_workspacesize fndecl 0 56716 NULL
+cfg_fof_lpfc_hba_56760_fns cfg_fof lpfc_hba 0 56760 NULL
+mem_size_mxt_data_56785_fns mem_size mxt_data 0 56785 NULL
+ib_uverbs_create_cq_fndecl_56793_fns ib_uverbs_create_cq fndecl 4-5 56793 NULL
+ntb_transport_tx_enqueue_fndecl_56794_fns ntb_transport_tx_enqueue fndecl 4 56794 NULL
+page_base_xdr_buf_56823_fns page_base xdr_buf 0 56823 NULL
+capacity_alauda_media_info_56845_fns capacity alauda_media_info 0 56845 NULL
+tomoyo_read_self_fndecl_56848_fns tomoyo_read_self fndecl 3 56848 NULL
+dup_array_fndecl_56860_fns dup_array fndecl 3 56860 NULL
+count_subheaders_fndecl_56868_fns count_subheaders fndecl 0 56868 NULL
+cifs_fsync_fndecl_56917_fns cifs_fsync fndecl 2-3 56917 NULL
+comedi_buf_write_n_allocated_fndecl_56919_fns comedi_buf_write_n_allocated fndecl 0 56919 NULL
+usb_gstrings_attach_fndecl_56924_fns usb_gstrings_attach fndecl 3 56924 NULL nohasharray
+il_dbgfs_qos_read_fndecl_56924_fns il_dbgfs_qos_read fndecl 3 56924 &usb_gstrings_attach_fndecl_56924_fns
+nrealreaders_vardecl_rcuperf_c_56929_fns nrealreaders vardecl_rcuperf.c 0 56929 NULL
+csize_jffs2_tmp_dnode_info_56933_fns csize jffs2_tmp_dnode_info 0 56933 NULL
+drm_property_replace_global_blob_fndecl_56945_fns drm_property_replace_global_blob fndecl 3 56945 NULL
+iwl_dbgfs_quota_min_read_fndecl_56948_fns iwl_dbgfs_quota_min_read fndecl 3 56948 NULL
+n_mem_slots_qxl_device_56964_fns n_mem_slots qxl_device 0 56964 NULL
+maxresp_cached_nfsd4_channel_attrs_56966_fns maxresp_cached nfsd4_channel_attrs 0 56966 NULL
+irq_blk_threshold_read_fndecl_56977_fns irq_blk_threshold_read fndecl 3 56977 NULL
+arp_hdr_len_fndecl_56980_fns arp_hdr_len fndecl 0 56980 NULL
+pvr2_stream_buffer_count_fndecl_56996_fns pvr2_stream_buffer_count fndecl 2 56996 NULL
+write_file_spectral_count_fndecl_57000_fns write_file_spectral_count fndecl 3 57000 NULL
+i2c_hack_wm8775_fndecl_57014_fns i2c_hack_wm8775 fndecl 4-6 57014 NULL
+sys_keyctl_fndecl_57023_fns sys_keyctl fndecl 4 57023 NULL nohasharray
+xs_send_kvec_fndecl_57023_fns xs_send_kvec fndecl 3 57023 &sys_keyctl_fndecl_57023_fns
+__qcom_scm_hdcp_req_fndecl_57026_fns __qcom_scm_hdcp_req fndecl 3 57026 NULL
+read_file_node_recv_fndecl_57042_fns read_file_node_recv fndecl 3 57042 NULL
+iwl_dbgfs_tof_responder_params_read_fndecl_57049_fns iwl_dbgfs_tof_responder_params_read fndecl 3 57049 NULL
+vifs_state_read_fndecl_57073_fns vifs_state_read fndecl 3 57073 NULL
+size_nvif_notify_57130_fns size nvif_notify 0 57130 NULL
+joydev_ioctl_fndecl_57132_fns joydev_ioctl fndecl 2 57132 NULL
+msg_controllen_msghdr_57136_fns msg_controllen msghdr 0 57136 NULL
+qcom_scm_call_fndecl_57160_fns qcom_scm_call fndecl 5-7 57160 NULL
+pd_points_ath5k_pdgain_info_57180_fns pd_points ath5k_pdgain_info 0 57180 NULL
+irq_pkt_threshold_read_fndecl_57183_fns irq_pkt_threshold_read fndecl 3 57183 NULL
+cfs_trace_copyin_string_fndecl_57191_fns cfs_trace_copyin_string fndecl 4 57191 NULL
+ieee80211_if_read_dropped_frames_no_route_fndecl_57204_fns ieee80211_if_read_dropped_frames_no_route fndecl 3 57204 NULL
+mon_buff_area_free_fndecl_57212_fns mon_buff_area_free fndecl 2 57212 NULL
+le_min_key_size_read_fndecl_57214_fns le_min_key_size_read fndecl 3 57214 NULL
+ovs_vport_alloc_fndecl_57296_fns ovs_vport_alloc fndecl 1 57296 NULL
+create_entry_fndecl_57300_fns create_entry fndecl 2 57300 NULL
+tcp_off_tso_state_57305_fns tcp_off tso_state 0 57305 NULL
+ip_setsockopt_fndecl_57308_fns ip_setsockopt fndecl 0-5 57308 NULL
+aggr_size_rx_size_read_fndecl_57317_fns aggr_size_rx_size_read fndecl 3 57317 NULL
+interrupt_in_endpoint_size_ld_usb_57321_fns interrupt_in_endpoint_size ld_usb 0 57321 NULL
+fb_read_fndecl_57329_fns fb_read fndecl 3 57329 NULL
+page_bytes_remain_capsule_info_57335_fns page_bytes_remain capsule_info 0 57335 NULL
+musb_test_mode_write_fndecl_57341_fns musb_test_mode_write fndecl 3 57341 NULL
+setup_glists_fndecl_57343_fns setup_glists fndecl 3 57343 NULL
+ath10k_read_htt_max_amsdu_ampdu_fndecl_57346_fns ath10k_read_htt_max_amsdu_ampdu fndecl 3 57346 NULL
+ixgbe_pci_sriov_enable_fndecl_57353_fns ixgbe_pci_sriov_enable fndecl 2 57353 NULL
+nfs_create_request_fndecl_57363_fns nfs_create_request fndecl 4 57363 NULL
+div64_u64_rem_fndecl_57393_fns div64_u64_rem fndecl 0 57393 NULL
+uhid_event_from_user_fndecl_57394_fns uhid_event_from_user fndecl 2 57394 NULL
+pwr_tx_without_ps_read_fndecl_57396_fns pwr_tx_without_ps_read fndecl 3 57396 NULL
+kfd_ioctl_fndecl_57397_fns kfd_ioctl fndecl 2 57397 NULL
+nfs4_alloc_pages_fndecl_57401_fns nfs4_alloc_pages fndecl 1 57401 NULL
+_iwl_dbgfs_bt_tx_prio_write_fndecl_57418_fns _iwl_dbgfs_bt_tx_prio_write fndecl 3 57418 NULL
+key_size_ecryptfs_crypt_stat_57436_fns key_size ecryptfs_crypt_stat 0 57436 NULL
+send_control_msg_fndecl_57441_fns send_control_msg fndecl 6 57441 NULL
+convert_tail_for_hole_fndecl_57444_fns convert_tail_for_hole fndecl 3 57444 NULL
+diva_os_copy_to_user_fndecl_57455_fns diva_os_copy_to_user fndecl 4 57455 NULL
+wm_coeff_tlv_put_fndecl_57463_fns wm_coeff_tlv_put fndecl 3 57463 NULL
+r8712_usbctrl_vendorreq_fndecl_57466_fns r8712_usbctrl_vendorreq fndecl 6 57466 NULL
+item_udata_fndecl_57481_fns item_udata fndecl 0 57481 NULL
+ath10k_fw_stats_read_fndecl_57506_fns ath10k_fw_stats_read fndecl 3 57506 NULL
+command_resume_fndecl_57510_fns command_resume fndecl 0 57510 NULL
+nvbios_extend_fndecl_57525_fns nvbios_extend fndecl 2 57525 NULL
+y_max_wacom_features_57545_fns y_max wacom_features 0 57545 NULL
+dn_fib_count_nhs_fndecl_57602_fns dn_fib_count_nhs fndecl 0 57602 NULL
+_add_to_r4w_fndecl_57611_fns _add_to_r4w fndecl 4 57611 NULL
+isr_dma1_done_read_fndecl_57612_fns isr_dma1_done_read fndecl 3 57612 NULL
+f2fs_collapse_range_fndecl_57627_fns f2fs_collapse_range fndecl 3-2 57627 NULL nohasharray
+nvme_rdma_alloc_ring_fndecl_57627_fns nvme_rdma_alloc_ring fndecl 3-2 57627 &f2fs_collapse_range_fndecl_57627_fns
+c4iw_id_table_alloc_fndecl_57648_fns c4iw_id_table_alloc fndecl 3 57648 NULL
+nfsctl_transaction_read_fndecl_57705_fns nfsctl_transaction_read fndecl 3 57705 NULL
+read_file_recv_fndecl_57723_fns read_file_recv fndecl 3 57723 NULL
+hi6220_register_clkdiv_fndecl_57729_fns hi6220_register_clkdiv fndecl 7 57729 NULL
+compat_sys_io_getevents_fndecl_57736_fns compat_sys_io_getevents fndecl 3 57736 NULL
+batadv_socket_read_fndecl_57746_fns batadv_socket_read fndecl 3 57746 NULL
+raydium_i2c_send_message_fndecl_57747_fns raydium_i2c_send_message fndecl 4 57747 NULL
+acpi_ex_convert_to_ascii_fndecl_57750_fns acpi_ex_convert_to_ascii fndecl 0 57750 NULL
+cache_write_pipefs_fndecl_57757_fns cache_write_pipefs fndecl 3 57757 NULL
+tidcnt_hfi1_tid_info_57758_fns tidcnt hfi1_tid_info 0 57758 NULL
+send_set_info_fndecl_57779_fns send_set_info fndecl 7 57779 NULL
+fp_array_size_bnx2x_57781_fns fp_array_size bnx2x 0 57781 NULL
+lpfc_idiag_extacc_read_fndecl_57790_fns lpfc_idiag_extacc_read fndecl 3 57790 NULL
+spk_xe_vardecl_57804_fns spk_xe vardecl 0 57804 NULL
+tx_frag_init_called_read_fndecl_57834_fns tx_frag_init_called_read fndecl 3 57834 NULL
+xdi_copy_to_user_fndecl_57879_fns xdi_copy_to_user fndecl 4 57879 NULL
+exynos_srom_alloc_reg_dump_fndecl_57914_fns exynos_srom_alloc_reg_dump fndecl 2 57914 NULL
+ntb_transport_rx_enqueue_fndecl_57929_fns ntb_transport_rx_enqueue fndecl 4 57929 NULL
+event_heart_beat_read_fndecl_57938_fns event_heart_beat_read fndecl 3 57938 NULL
+nand_ecc_test_run_fndecl_57941_fns nand_ecc_test_run fndecl 1 57941 NULL
+ilf_size_xfs_inode_log_format_57942_fns ilf_size xfs_inode_log_format 0 57942 NULL
+vmci_handle_arr_create_fndecl_57944_fns vmci_handle_arr_create fndecl 1 57944 NULL
+pegasus_control_msg_fndecl_57954_fns pegasus_control_msg fndecl 3 57954 NULL
+logical_block_count_msb_data_57955_fns logical_block_count msb_data 0 57955 NULL
+mei_cl_alloc_cb_fndecl_57971_fns mei_cl_alloc_cb fndecl 2 57971 NULL
+input_count_cgs_acpi_method_info_57981_fns input_count cgs_acpi_method_info 0 57981 NULL
+status_orangefs_downcall_s_57998_fns status orangefs_downcall_s 0 57998 NULL
+scsi_register_fndecl_58069_fns scsi_register fndecl 2 58069 NULL
+pt_read_fndecl_58083_fns pt_read fndecl 3 58083 NULL nohasharray
+netxen_setup_msi_interrupts_fndecl_58083_fns netxen_setup_msi_interrupts fndecl 2 58083 &pt_read_fndecl_58083_fns
+nentries_xpc_registration_58085_fns nentries xpc_registration 0 58085 NULL
+ll_max_cached_mb_seq_write_fndecl_58097_fns ll_max_cached_mb_seq_write fndecl 3 58097 NULL
+walk_pmd_range_fndecl_58100_fns walk_pmd_range fndecl 0 58100 NULL
+sys_setgroups_fndecl_58127_fns sys_setgroups fndecl 1 58127 NULL nohasharray
+sm501_create_subdev_fndecl_58127_fns sm501_create_subdev fndecl 3-4 58127 &sys_setgroups_fndecl_58127_fns
+bufsize_vardecl_subpagetest_c_58128_fns bufsize vardecl_subpagetest.c 0 58128 NULL
+do_ip_vs_set_ctl_fndecl_58130_fns do_ip_vs_set_ctl fndecl 4 58130 NULL
+ll_rw_extents_stats_pp_seq_write_fndecl_58136_fns ll_rw_extents_stats_pp_seq_write fndecl 3 58136 NULL
+nvif_object_init_fndecl_58137_fns nvif_object_init fndecl 5 58137 NULL
+qsfp2_debugfs_read_fndecl_58142_fns qsfp2_debugfs_read fndecl 3 58142 NULL
+altera_drscan_fndecl_58153_fns altera_drscan fndecl 2 58153 NULL
+total_num_uuars_mlx5_ib_alloc_ucontext_req_v2_58191_fns total_num_uuars mlx5_ib_alloc_ucontext_req_v2 0 58191 NULL
+npages_ttm_page_pool_58200_fns npages ttm_page_pool 0 58200 NULL nohasharray
+nvmet_rdma_alloc_cmds_fndecl_58200_fns nvmet_rdma_alloc_cmds fndecl 2 58200 &npages_ttm_page_pool_58200_fns
+lpfc_idiag_drbacc_write_fndecl_58203_fns lpfc_idiag_drbacc_write fndecl 3 58203 NULL
+ubifs_jnl_write_data_fndecl_58229_fns ubifs_jnl_write_data fndecl 5 58229 NULL
+spi_replace_transfers_fndecl_58231_fns spi_replace_transfers fndecl 6-4 58231 NULL
+ath6kl_regwrite_read_fndecl_58232_fns ath6kl_regwrite_read fndecl 3 58232 NULL
+ath6kl_usb_bmi_read_fndecl_58234_fns ath6kl_usb_bmi_read fndecl 3 58234 NULL
+i915_displayport_test_active_write_fndecl_58241_fns i915_displayport_test_active_write fndecl 3 58241 NULL
+num_rx_queues_fm10k_intfc_58243_fns num_rx_queues fm10k_intfc 0 58243 NULL
+gpiod_count_fndecl_58262_fns gpiod_count fndecl 0 58262 NULL
+mvneta_check_mtu_valid_fndecl_58264_fns mvneta_check_mtu_valid fndecl 0-2 58264 NULL
+il3945_sta_dbgfs_stats_table_read_fndecl_58289_fns il3945_sta_dbgfs_stats_table_read fndecl 3 58289 NULL
+actions_len_sw_flow_actions_58353_fns actions_len sw_flow_actions 0 58353 NULL
+viafb_dvp1_proc_write_fndecl_58355_fns viafb_dvp1_proc_write fndecl 3 58355 NULL
+__ffs_ep0_read_events_fndecl_58359_fns __ffs_ep0_read_events fndecl 3 58359 NULL
+ingr_start_sge_58376_fns ingr_start sge 0 58376 NULL
+esas2r_log_hexdump_fndecl_58381_fns esas2r_log_hexdump fndecl 3 58381 NULL
+ip_vs_sync_buff_create_v0_fndecl_58401_fns ip_vs_sync_buff_create_v0 fndecl 2 58401 NULL
+sta_vht_capa_read_fndecl_58402_fns sta_vht_capa_read fndecl 3 58402 NULL
+orangefs_debug_write_fndecl_58409_fns orangefs_debug_write fndecl 3 58409 NULL
+amdtp_stream_init_fndecl_58410_fns amdtp_stream_init fndecl 7 58410 NULL
+vzalloc_fndecl_58414_fns vzalloc fndecl 1 58414 NULL
+channels__isdn_driver_58419_fns channels _isdn_driver 0 58419 NULL
+gfn_to_pfn_prot_fndecl_58421_fns gfn_to_pfn_prot fndecl 2 58421 NULL
+walk_pte_range_fndecl_58425_fns walk_pte_range fndecl 0 58425 NULL
+len_ethtool_test_58446_fns len ethtool_test 0 58446 NULL
+newpart_fndecl_58478_fns newpart fndecl 4-6 58478 NULL
+nbchan_capidrv_contr_58481_fns nbchan capidrv_contr 0 58481 NULL
+C_SYSC_set_mempolicy_fndecl_58489_fns C_SYSC_set_mempolicy fndecl 3 58489 NULL
+unlink_simple_fndecl_58497_fns unlink_simple fndecl 3 58497 NULL
+alloc_arraycache_fndecl_58498_fns alloc_arraycache fndecl 2 58498 NULL
+ec_i2c_count_response_fndecl_58509_fns ec_i2c_count_response fndecl 0 58509 NULL
+pmsg_size_ramoops_platform_data_58514_fns pmsg_size ramoops_platform_data 0 58514 NULL
+core_sys_select_fndecl_58517_fns core_sys_select fndecl 1 58517 NULL nohasharray
+brcmf_vndr_ie_fndecl_58517_fns brcmf_vndr_ie fndecl 0-4 58517 &core_sys_select_fndecl_58517_fns
+read_block_for_search_fndecl_58525_fns read_block_for_search fndecl 0 58525 NULL
+drbg_statelen_fndecl_58540_fns drbg_statelen fndecl 0 58540 NULL
+usb_hcd_alloc_bandwidth_fndecl_58550_fns usb_hcd_alloc_bandwidth fndecl 0 58550 NULL
+read_ldt_fndecl_58561_fns read_ldt fndecl 2 58561 NULL
+gsmld_output_fndecl_58570_fns gsmld_output fndecl 3 58570 NULL
+ext4_kvzalloc_fndecl_58598_fns ext4_kvzalloc fndecl 1 58598 NULL
+sctp_ssnmap_new_fndecl_58603_fns sctp_ssnmap_new fndecl 2-1 58603 NULL
+cache_read_pipefs_fndecl_58604_fns cache_read_pipefs fndecl 3 58604 NULL
+thermal_tx_resume_read_fndecl_58616_fns thermal_tx_resume_read fndecl 3 58616 NULL
+mousedev_read_fndecl_58624_fns mousedev_read fndecl 3 58624 NULL
+ath10k_wmi_alloc_host_mem_fndecl_58627_fns ath10k_wmi_alloc_host_mem fndecl 4-3 58627 NULL nohasharray
+wusb_key_dump_fndecl_58627_fns wusb_key_dump fndecl 2 58627 &ath10k_wmi_alloc_host_mem_fndecl_58627_fns
+msc_single_to_user_fndecl_58646_fns msc_single_to_user fndecl 3-4 58646 NULL
+cfg80211_connect_bss_fndecl_58657_fns cfg80211_connect_bss fndecl 7-5 58657 NULL
+mxms_headerlen_fndecl_58666_fns mxms_headerlen fndecl 0 58666 NULL
+rx_rx_rts_timeout_read_fndecl_58667_fns rx_rx_rts_timeout_read fndecl 3 58667 NULL
+switchdev_port_fdb_del_fndecl_58668_fns switchdev_port_fdb_del fndecl 5 58668 NULL
+rs_sta_dbgfs_rate_scale_data_read_fndecl_58670_fns rs_sta_dbgfs_rate_scale_data_read fndecl 3 58670 NULL
+acpi_ut_initialize_buffer_fndecl_58676_fns acpi_ut_initialize_buffer fndecl 2 58676 NULL
+svc_pool_map_alloc_arrays_fndecl_58718_fns svc_pool_map_alloc_arrays fndecl 2 58718 NULL
+portcntrs_1_read_fndecl_58758_fns portcntrs_1_read fndecl 3 58758 NULL
+snd_ctl_enum_info_fndecl_58778_fns snd_ctl_enum_info fndecl 2 58778 NULL
+vsnprintf_fndecl_58792_fns vsnprintf fndecl 0 58792 NULL
+tx_internal_desc_overflow_read_fndecl_58839_fns tx_internal_desc_overflow_read fndecl 3 58839 NULL
+kvm_debugfs_num_entries_vardecl_kvm_main_c_58842_fns kvm_debugfs_num_entries vardecl_kvm_main.c 0 58842 NULL
+nr_scratch_dwc3_58852_fns nr_scratch dwc3 0 58852 NULL
+ucs2_utf8size_fndecl_58859_fns ucs2_utf8size fndecl 0 58859 NULL
+ieee80211_if_read_dot11MeshHoldingTimeout_fndecl_58863_fns ieee80211_if_read_dot11MeshHoldingTimeout fndecl 3 58863 NULL
+pd_groupsize_ptlrpcd_58864_fns pd_groupsize ptlrpcd 0 58864 NULL
+usb_stor_bulk_transfer_sg_fndecl_58896_fns usb_stor_bulk_transfer_sg fndecl 5 58896 NULL
+v9fs_file_fsync_fndecl_58898_fns v9fs_file_fsync fndecl 2-3 58898 NULL
+vhci_read_fndecl_58901_fns vhci_read fndecl 3 58901 NULL
+comedi_write_fndecl_58917_fns comedi_write fndecl 3 58917 NULL
+fore200e_pca_dma_chunk_alloc_fndecl_58927_fns fore200e_pca_dma_chunk_alloc fndecl 4-3 58927 NULL
+cfs_percpt_alloc_fndecl_58941_fns cfs_percpt_alloc fndecl 2 58941 NULL
+drm_simple_display_pipe_init_fndecl_58972_fns drm_simple_display_pipe_init fndecl 5 58972 NULL
+ib_umad_write_fndecl_58986_fns ib_umad_write fndecl 3 58986 NULL
+mpi_read_raw_from_sgl_fndecl_58990_fns mpi_read_raw_from_sgl fndecl 2 58990 NULL
+nfs4_proc_get_acl_fndecl_58998_fns nfs4_proc_get_acl fndecl 3 58998 NULL
+iwl_dbgfs_ucode_tracing_read_fndecl_59004_fns iwl_dbgfs_ucode_tracing_read fndecl 3 59004 NULL
+__kvm_read_guest_atomic_fndecl_59011_fns __kvm_read_guest_atomic fndecl 5-2 59011 NULL
+nclips_saa7146_overlay_59032_fns nclips saa7146_overlay 0 59032 NULL
+iwl_mvm_fw_dbg_collect_fndecl_59043_fns iwl_mvm_fw_dbg_collect fndecl 4 59043 NULL
+posix_acl_alloc_fndecl_59052_fns posix_acl_alloc fndecl 1 59052 NULL nohasharray
+nr_strip_zones_r0conf_59052_fns nr_strip_zones r0conf 0 59052 &posix_acl_alloc_fndecl_59052_fns
+axi_dmac_prep_slave_sg_fndecl_59073_fns axi_dmac_prep_slave_sg fndecl 3 59073 NULL
+buffer_mousedev_client_59098_fns buffer mousedev_client 0 59098 NULL
+wm_latency_write_fndecl_59118_fns wm_latency_write fndecl 3 59118 NULL
+mmc_alloc_host_fndecl_59122_fns mmc_alloc_host fndecl 1 59122 NULL
+tas571x_reg_write_multiword_fndecl_59156_fns tas571x_reg_write_multiword fndecl 4 59156 NULL
+vb2_dvb_register_bus_fndecl_59175_fns vb2_dvb_register_bus fndecl 0 59175 NULL
+get_unaligned_le24_fndecl_59191_fns get_unaligned_le24 fndecl 0 59191 NULL
+walk_page_test_fndecl_59232_fns walk_page_test fndecl 0 59232 NULL
+bits_to_user_fndecl_59238_fns bits_to_user fndecl 2-3 59238 NULL
+cxd2841er_i2c_debug_fndecl_59241_fns cxd2841er_i2c_debug fndecl 6 59241 NULL nohasharray
+carl9170_debugfs_read_fndecl_59241_fns carl9170_debugfs_read fndecl 3 59241 &cxd2841er_i2c_debug_fndecl_59241_fns
+mvumi_alloc_mem_resource_fndecl_59285_fns mvumi_alloc_mem_resource fndecl 3 59285 NULL
+alloc_sched_domains_fndecl_59295_fns alloc_sched_domains fndecl 1 59295 NULL
+posix_acl_fix_xattr_from_user_fndecl_59298_fns posix_acl_fix_xattr_from_user fndecl 2 59298 NULL
+read_file_spectral_bins_fndecl_59334_fns read_file_spectral_bins fndecl 3 59334 NULL
+pinconf_dbg_config_write_fndecl_59336_fns pinconf_dbg_config_write fndecl 3 59336 NULL
+lov_packmd_fndecl_59345_fns lov_packmd fndecl 0 59345 NULL
+tree_mod_log_insert_move_fndecl_59356_fns tree_mod_log_insert_move fndecl 5 59356 NULL
+base_tsn_sctp_tsnmap_59358_fns base_tsn sctp_tsnmap 0 59358 NULL
+buf_len_i40e_arq_event_info_59370_fns buf_len i40e_arq_event_info 0 59370 NULL
+default_drvbuffer_scsi_tape_59374_fns default_drvbuffer scsi_tape 0 59374 NULL
+free_list_size_eni_dev_59386_fns free_list_size eni_dev 0 59386 NULL
+iwl_dbgfs_chain_noise_read_fndecl_59392_fns iwl_dbgfs_chain_noise_read fndecl 3 59392 NULL
+size_freelQ_59398_fns size freelQ 0 59398 NULL
+smk_write_direct_fndecl_59400_fns smk_write_direct fndecl 3 59400 NULL
+num_vfs_ixgbe_adapter_59414_fns num_vfs ixgbe_adapter 0 59414 NULL
+desc_elems_timb_dma_chan_59416_fns desc_elems timb_dma_chan 0 59416 NULL
+nilfs_cpfile_block_get_checkpoint_fndecl_59441_fns nilfs_cpfile_block_get_checkpoint fndecl 2 59441 NULL
+rng_get_data_fndecl_59453_fns rng_get_data fndecl 0 59453 NULL
+platform_gpio_count_fndecl_59459_fns platform_gpio_count fndecl 0 59459 NULL
+ttm_page_pool_get_pages_fndecl_59468_fns ttm_page_pool_get_pages fndecl 5-0 59468 NULL
+rx_ringsz_alx_priv_59496_fns rx_ringsz alx_priv 0 59496 NULL
+il_dbgfs_clear_traffic_stats_write_fndecl_59497_fns il_dbgfs_clear_traffic_stats_write fndecl 3 59497 NULL
+pci_frontend_enable_msix_fndecl_59501_fns pci_frontend_enable_msix fndecl 3 59501 NULL
+qlcnic_get_vnic_func_count_fndecl_59521_fns qlcnic_get_vnic_func_count fndecl 0 59521 NULL
+kmsg_read_fndecl_59553_fns kmsg_read fndecl 3 59553 NULL
+num_stripes_btrfs_chunk_59557_fns num_stripes btrfs_chunk 0 59557 NULL
+nlm_end_grace_write_fndecl_59558_fns nlm_end_grace_write fndecl 3 59558 NULL
+vringh_complete_multi_user_fndecl_59569_fns vringh_complete_multi_user fndecl 3 59569 NULL
+key_count_applesmc_registers_59587_fns key_count applesmc_registers 0 59587 NULL
+serverworks_create_gatt_pages_fndecl_59621_fns serverworks_create_gatt_pages fndecl 1 59621 NULL
+il3945_ucode_general_stats_read_fndecl_59660_fns il3945_ucode_general_stats_read fndecl 3 59660 NULL
+rtw_buf_update_fndecl_59689_fns rtw_buf_update fndecl 4 59689 NULL
+capacity_sddr55_card_info_59695_fns capacity sddr55_card_info 0 59695 NULL
+__walk_page_range_fndecl_59729_fns __walk_page_range fndecl 0 59729 NULL
+__netlink_change_ngroups_fndecl_59743_fns __netlink_change_ngroups fndecl 2 59743 NULL
+fq_resize_fndecl_59744_fns fq_resize fndecl 2 59744 NULL
+add_conn_list_fndecl_59750_fns add_conn_list fndecl 3 59750 NULL
+vxge_os_dma_malloc_fndecl_59771_fns vxge_os_dma_malloc fndecl 2 59771 NULL
+tx_tx_cfe1_read_fndecl_59777_fns tx_tx_cfe1_read fndecl 3 59777 NULL
+mlx4_buf_alloc_fndecl_59788_fns mlx4_buf_alloc fndecl 2 59788 NULL
+num_leds_lm3533_platform_data_59793_fns num_leds lm3533_platform_data 0 59793 NULL
+nf_nat_ftp_fndecl_59818_fns nf_nat_ftp fndecl 6 59818 NULL
+xen_setup_msi_irqs_fndecl_59830_fns xen_setup_msi_irqs fndecl 2 59830 NULL
+dig_outs_auto_pin_cfg_59832_fns dig_outs auto_pin_cfg 0 59832 NULL
+mpi_read_raw_data_fndecl_59835_fns mpi_read_raw_data fndecl 2 59835 NULL
+dvb_net_init_fndecl_59840_fns dvb_net_init fndecl 0 59840 NULL
+sst_fill_byte_control_fndecl_59850_fns sst_fill_byte_control fndecl 6 59850 NULL
+acpi_rs_decode_bitmask_fndecl_59851_fns acpi_rs_decode_bitmask fndecl 0 59851 NULL
+length_pm8001_ioctl_payload_59866_fns length pm8001_ioctl_payload 0 59866 NULL
+qlcnic_83xx_sysfs_flash_bulk_write_fndecl_59875_fns qlcnic_83xx_sysfs_flash_bulk_write fndecl 4 59875 NULL
+__hwahc_dev_set_key_fndecl_59883_fns __hwahc_dev_set_key fndecl 5 59883 NULL
+vfs_allocated_count_igb_adapter_59900_fns vfs_allocated_count igb_adapter 0 59900 NULL
+lov_iocontrol_fndecl_59919_fns lov_iocontrol fndecl 3 59919 NULL
+ixgbe_dbg_reg_ops_write_fndecl_59964_fns ixgbe_dbg_reg_ops_write fndecl 3 59964 NULL
+size_wid_59965_fns size wid 0 59965 NULL
+configfs_read_bin_file_fndecl_59987_fns configfs_read_bin_file fndecl 3 59987 NULL
+wlcore_alloc_hw_fndecl_59990_fns wlcore_alloc_hw fndecl 1-3 59990 NULL
+real_stripes_btrfs_raid_bio_59993_fns real_stripes btrfs_raid_bio 0 59993 NULL
+f2fs_do_sync_file_fndecl_59994_fns f2fs_do_sync_file fndecl 2-3 59994 NULL
+fb_write_fndecl_59999_fns fb_write fndecl 3 59999 NULL
+SYSC_poll_fndecl_60006_fns SYSC_poll fndecl 2 60006 NULL
+__sctp_setsockopt_connectx_fndecl_60022_fns __sctp_setsockopt_connectx fndecl 3 60022 NULL
+qla4xxx_post_aen_work_fndecl_60026_fns qla4xxx_post_aen_work fndecl 3 60026 NULL
+coda_fsync_fndecl_60029_fns coda_fsync fndecl 2-3 60029 NULL
+cx231xx_init_bulk_fndecl_60067_fns cx231xx_init_bulk fndecl 3 60067 NULL
+level_ubifs_znode_60069_fns level ubifs_znode 0 60069 NULL
+constraint_flags_read_file_fndecl_60073_fns constraint_flags_read_file fndecl 3 60073 NULL
+debugfs_create_u32_array_fndecl_60082_fns debugfs_create_u32_array fndecl 5 60082 NULL
+udpv6_sendmsg_fndecl_60103_fns udpv6_sendmsg fndecl 3 60103 NULL
+iwl_dump_nic_event_log_fndecl_60130_fns iwl_dump_nic_event_log fndecl 0 60130 NULL
+vfp_set_fndecl_60145_fns vfp_set fndecl 3-4 60145 NULL
+orangefs_dirent_outcount_orangefs_readdir_response_s_60150_fns orangefs_dirent_outcount orangefs_readdir_response_s 0 60150 NULL
+pipeline_dec_packet_in_read_fndecl_60151_fns pipeline_dec_packet_in_read fndecl 3 60151 NULL
+stream_start_fndecl_60166_fns stream_start fndecl 0 60166 NULL
+__kfifo_out_r_fndecl_60172_fns __kfifo_out_r fndecl 4 60172 NULL
+ec_device_read_fndecl_60177_fns ec_device_read fndecl 3 60177 NULL
+snd_compr_write_data_fndecl_60179_fns snd_compr_write_data fndecl 3 60179 NULL
+il3945_stats_flag_fndecl_60189_fns il3945_stats_flag fndecl 0 60189 NULL
+pci_enable_device_fndecl_60193_fns pci_enable_device fndecl 0 60193 NULL
+request_key_async_with_auxdata_fndecl_60211_fns request_key_async_with_auxdata fndecl 4 60211 NULL
+bo_count_vc4_exec_info_60236_fns bo_count vc4_exec_info 0 60236 NULL
+ah_rf_banks_size_ath5k_hw_60250_fns ah_rf_banks_size ath5k_hw 0 60250 NULL
+_iwl_dbgfs_tof_range_request_write_fndecl_60255_fns _iwl_dbgfs_tof_range_request_write fndecl 3 60255 NULL
+erst_dbg_write_fndecl_60264_fns erst_dbg_write fndecl 3 60264 NULL
+alloc_data_packet_fndecl_60281_fns alloc_data_packet fndecl 1 60281 NULL
+read_file_tx99_fndecl_60294_fns read_file_tx99 fndecl 3 60294 NULL
+wl1271_rx_filter_alloc_field_fndecl_60306_fns wl1271_rx_filter_alloc_field fndecl 5 60306 NULL
+kvm_vcpu_write_guest_fndecl_60323_fns kvm_vcpu_write_guest fndecl 4-2 60323 NULL
+buf_size__IOCTL_Command_struct_60338_fns buf_size _IOCTL_Command_struct 0 60338 NULL
+hest_ghes_dev_register_fndecl_60349_fns hest_ghes_dev_register fndecl 1 60349 NULL
+string_escape_str_fndecl_60365_fns string_escape_str fndecl 0 60365 NULL
+num_counters_vardecl_sysfs_c_60371_fns num_counters vardecl_sysfs.c 0 60371 NULL
+hfi1_read_cntrs_fndecl_60378_fns hfi1_read_cntrs fndecl 0 60378 NULL
+shmem_pwrite_fast_fndecl_60393_fns shmem_pwrite_fast fndecl 3 60393 NULL
+quirk_strict_duplicate_filter_write_fndecl_60446_fns quirk_strict_duplicate_filter_write fndecl 3 60446 NULL
+sd_quota_slots_gfs2_sbd_60466_fns sd_quota_slots gfs2_sbd 0 60466 NULL
+ath10k_dbg_dump_fndecl_60482_fns ath10k_dbg_dump fndecl 6 60482 NULL
+tiadc_channel_init_fndecl_60514_fns tiadc_channel_init fndecl 2 60514 NULL
+ll_iocontrol_register_fndecl_60517_fns ll_iocontrol_register fndecl 2 60517 NULL
+iommu_dma_alloc_fndecl_60521_fns iommu_dma_alloc fndecl 2 60521 NULL
+pcf2127_i2c_gather_write_fndecl_60523_fns pcf2127_i2c_gather_write fndecl 5 60523 NULL
+tty_buffer_alloc_fndecl_60526_fns tty_buffer_alloc fndecl 2 60526 NULL
+register_netdev_fndecl_60559_fns register_netdev fndecl 0 60559 NULL
+nilfs_palloc_delete_block_fndecl_60568_fns nilfs_palloc_delete_block fndecl 2 60568 NULL
+sys_lgetxattr_fndecl_60616_fns sys_lgetxattr fndecl 4 60616 NULL
+copy_macs_fndecl_60621_fns copy_macs fndecl 4 60621 NULL
+i40e_alloc_vfs_fndecl_60628_fns i40e_alloc_vfs fndecl 2 60628 NULL nohasharray
+htable_bits_htable_60628_fns htable_bits htable 0 60628 &i40e_alloc_vfs_fndecl_60628_fns
+stats_dot11ACKFailureCount_read_fndecl_60645_fns stats_dot11ACKFailureCount_read fndecl 3 60645 NULL
+venus_rmdir_fndecl_60655_fns venus_rmdir fndecl 4 60655 NULL
+cx18_copy_mdl_to_user_fndecl_60670_fns cx18_copy_mdl_to_user fndecl 4 60670 NULL
+h_mspro_block_setup_cmd_fndecl_60673_fns h_mspro_block_setup_cmd fndecl 3 60673 NULL
+tx_tx_cfe2_read_fndecl_60677_fns tx_tx_cfe2_read fndecl 3 60677 NULL
+sysfs_do_create_link_sd_fndecl_60690_fns sysfs_do_create_link_sd fndecl 0 60690 NULL
+sel_write_user_fndecl_60695_fns sel_write_user fndecl 3 60695 NULL
+ubifs_fsync_fndecl_60696_fns ubifs_fsync fndecl 2-3 60696 NULL
+snd_mixart_BA0_read_fndecl_60702_fns snd_mixart_BA0_read fndecl 5 60702 NULL
+snd_card_new_fndecl_60707_fns snd_card_new fndecl 5 60707 NULL
+kvm_mmu_page_get_gfn_fndecl_60709_fns kvm_mmu_page_get_gfn fndecl 0-2 60709 NULL
+usbdev_read_fndecl_60713_fns usbdev_read fndecl 3 60713 NULL
+pwr_missing_bcns_cnt_read_fndecl_60714_fns pwr_missing_bcns_cnt_read fndecl 3 60714 NULL
+command_setapcor_fndecl_60740_fns command_setapcor fndecl 0 60740 NULL
+helene_i2c_debug_fndecl_60741_fns helene_i2c_debug fndecl 5 60741 NULL
+cfs_trace_daemon_command_usrstr_fndecl_60744_fns cfs_trace_daemon_command_usrstr fndecl 2 60744 NULL
+device_write_fndecl_60791_fns device_write fndecl 3 60791 NULL
+sta_agg_status_write_fndecl_60799_fns sta_agg_status_write fndecl 3 60799 NULL
+sctp_pack_cookie_fndecl_60821_fns sctp_pack_cookie fndecl 6 60821 NULL
+ieee80211_if_read_peer_fndecl_60834_fns ieee80211_if_read_peer fndecl 3 60834 NULL
+prism2_pda_proc_read_fndecl_60845_fns prism2_pda_proc_read fndecl 3 60845 NULL
+spi_alloc_master_fndecl_60852_fns spi_alloc_master fndecl 2 60852 NULL
+input_mt_init_slots_fndecl_60876_fns input_mt_init_slots fndecl 2 60876 NULL
+reiserfs_bmap_fndecl_60877_fns reiserfs_bmap fndecl 2 60877 NULL
+snd_pcm_oss_sync1_fndecl_60897_fns snd_pcm_oss_sync1 fndecl 2 60897 NULL nohasharray
+sn9c2028_short_command_fndecl_60897_fns sn9c2028_short_command fndecl 0 60897 &snd_pcm_oss_sync1_fndecl_60897_fns
+mlxsw_cmd_mbox_query_aq_cap_max_num_sdqs_get_fndecl_60914_fns mlxsw_cmd_mbox_query_aq_cap_max_num_sdqs_get fndecl 0 60914 NULL
+__exchange_data_block_fndecl_60951_fns __exchange_data_block fndecl 5 60951 NULL
+posix_acl_xattr_set_fndecl_60952_fns posix_acl_xattr_set fndecl 6 60952 NULL
+ath10k_reg_value_read_fndecl_60958_fns ath10k_reg_value_read fndecl 3 60958 NULL
+isdn_write_fndecl_60980_fns isdn_write fndecl 3 60980 NULL
+devm_create_dax_dev_fndecl_60990_fns devm_create_dax_dev fndecl 3 60990 NULL
+dbgfs_frame_fndecl_61006_fns dbgfs_frame fndecl 3 61006 NULL
+cfs_cpt_weight_fndecl_61020_fns cfs_cpt_weight fndecl 0 61020 NULL
+etnaviv_gpu_cmdbuf_new_fndecl_61036_fns etnaviv_gpu_cmdbuf_new fndecl 3 61036 NULL
+nf_nat_ftp_fmt_cmd_fndecl_61045_fns nf_nat_ftp_fmt_cmd fndecl 0 61045 NULL
+copy_to_fndecl_61058_fns copy_to fndecl 3 61058 NULL
+kobject_init_and_add_fndecl_61088_fns kobject_init_and_add fndecl 0 61088 NULL nohasharray
+reply_len_fc_bsg_job_61088_fns reply_len fc_bsg_job 0 61088 &kobject_init_and_add_fndecl_61088_fns
+atr_len_retry_cm4000_dev_61135_fns atr_len_retry cm4000_dev 0 61135 NULL
+get_free_entries_fndecl_61149_fns get_free_entries fndecl 1 61149 NULL nohasharray
+fnic_reset_stats_read_fndecl_61149_fns fnic_reset_stats_read fndecl 3 61149 &get_free_entries_fndecl_61149_fns
+sierra_setup_urb_fndecl_61150_fns sierra_setup_urb fndecl 5 61150 NULL
+__vmalloc_node_range_fndecl_61157_fns __vmalloc_node_range fndecl 1-2 61157 NULL nohasharray
+max_rsp_queues_qla_hw_data_61157_fns max_rsp_queues qla_hw_data 0 61157 &__vmalloc_node_range_fndecl_61157_fns
+host1x_job_alloc_fndecl_61171_fns host1x_job_alloc fndecl 4-3-2 61171 NULL
+dma_tx_errors_read_fndecl_61183_fns dma_tx_errors_read fndecl 3 61183 NULL
+spk_ys_vardecl_61196_fns spk_ys vardecl 0 61196 NULL
+add_qgroup_rb_fndecl_61197_fns add_qgroup_rb fndecl 2 61197 NULL
+radar_debug_mode_read_fndecl_61223_fns radar_debug_mode_read fndecl 3 61223 NULL
+hidraw_get_report_fndecl_61242_fns hidraw_get_report fndecl 3 61242 NULL
+i2c2_debugfs_write_fndecl_61249_fns i2c2_debugfs_write fndecl 3 61249 NULL nohasharray
+rcar_dmac_prep_dma_cyclic_fndecl_61249_fns rcar_dmac_prep_dma_cyclic fndecl 4-3 61249 &i2c2_debugfs_write_fndecl_61249_fns
+CombinedStatusBufferLength_DAC960_Controller_61253_fns CombinedStatusBufferLength DAC960_Controller 0 61253 NULL
+ufx_i2c_configure_fndecl_61311_fns ufx_i2c_configure fndecl 0 61311 NULL
+dvb_ca_en50221_init_fndecl_61317_fns dvb_ca_en50221_init fndecl 4 61317 NULL
+rw_copy_check_uvector_fndecl_61351_fns rw_copy_check_uvector fndecl 3 61351 NULL nohasharray
+v4l2_ctrl_new_std_fndecl_61351_fns v4l2_ctrl_new_std fndecl 5 61351 &rw_copy_check_uvector_fndecl_61351_fns
+size_sge_fl_61353_fns size sge_fl 0 61353 NULL
+lkdtm_debugfs_read_fndecl_61355_fns lkdtm_debugfs_read fndecl 3 61355 NULL
+snd_cs46xx_io_read_fndecl_61365_fns snd_cs46xx_io_read fndecl 5 61365 NULL
+osc_checksum_type_seq_write_fndecl_61386_fns osc_checksum_type_seq_write fndecl 3 61386 NULL
+__pci_register_driver_fndecl_61400_fns __pci_register_driver fndecl 0 61400 NULL
+alloc_ts_config_fndecl_61404_fns alloc_ts_config fndecl 1 61404 NULL
+rx_ring_size_rx_queue_61409_fns rx_ring_size rx_queue 0 61409 NULL
+amdgpu_fence_driver_init_ring_fndecl_61431_fns amdgpu_fence_driver_init_ring fndecl 2 61431 NULL
+quirk_simultaneous_discovery_read_fndecl_61433_fns quirk_simultaneous_discovery_read fndecl 3 61433 NULL
+raw_setsockopt_fndecl_61435_fns raw_setsockopt fndecl 5 61435 NULL
+lbs_rdbbp_read_fndecl_61438_fns lbs_rdbbp_read fndecl 3 61438 NULL
+ath6kl_keepalive_read_fndecl_61468_fns ath6kl_keepalive_read fndecl 3 61468 NULL
+nmatches_tcf_ematch_tree_hdr_61486_fns nmatches tcf_ematch_tree_hdr 0 61486 NULL
+dispatch_proc_write_fndecl_61491_fns dispatch_proc_write fndecl 3 61491 NULL
+rs_init_fndecl_61492_fns rs_init fndecl 6-1 61492 NULL
+ccp_init_data_fndecl_61495_fns ccp_init_data fndecl 5 61495 NULL nohasharray
+writing_st_buffer_61495_fns writing st_buffer 0 61495 &ccp_init_data_fndecl_61495_fns
+count_sgentry_61508_fns count sgentry 0 61508 NULL
+maxcontacts_wtp_data_61511_fns maxcontacts wtp_data 0 61511 NULL
+nfs_fscache_get_super_cookie_fndecl_61520_fns nfs_fscache_get_super_cookie fndecl 3 61520 NULL
+map_size_tracing_map_61522_fns map_size tracing_map 0 61522 NULL
+rts_threshold_read_fndecl_61555_fns rts_threshold_read fndecl 3 61555 NULL
+aoedev_flush_fndecl_61565_fns aoedev_flush fndecl 2 61565 NULL
+mtip_hw_read_flags_fndecl_61567_fns mtip_hw_read_flags fndecl 3 61567 NULL
+ieee80211_if_read_rc_rateidx_mcs_mask_5ghz_fndecl_61588_fns ieee80211_if_read_rc_rateidx_mcs_mask_5ghz fndecl 3 61588 NULL
+btrfs_chunk_item_size_fndecl_61613_fns btrfs_chunk_item_size fndecl 0-1 61613 NULL
+write_file_debug_fndecl_61615_fns write_file_debug fndecl 3 61615 NULL
+___alloc_bootmem_node_nopanic_fndecl_61630_fns ___alloc_bootmem_node_nopanic fndecl 2 61630 NULL
+nr_slots_b43_dmaring_61631_fns nr_slots b43_dmaring 0 61631 NULL
+ieee80211_if_read_dropped_frames_ttl_fndecl_61639_fns ieee80211_if_read_dropped_frames_ttl fndecl 3 61639 NULL
+iwl_dbgfs_sram_read_fndecl_61642_fns iwl_dbgfs_sram_read fndecl 3 61642 NULL nohasharray
+security_getprocattr_fndecl_61642_fns security_getprocattr fndecl 0 61642 &iwl_dbgfs_sram_read_fndecl_61642_fns
+spidev_write_fndecl_61645_fns spidev_write fndecl 3 61645 NULL
+f2fs_kvmalloc_fndecl_61650_fns f2fs_kvmalloc fndecl 1 61650 NULL
+sdio_align_size_fndecl_61658_fns sdio_align_size fndecl 0 61658 NULL
+comm_write_fndecl_61674_fns comm_write fndecl 3 61674 NULL
+paclen_ax25_cb_61712_fns paclen ax25_cb 0 61712 NULL
+btrfs_prev_leaf_fndecl_61728_fns btrfs_prev_leaf fndecl 0 61728 NULL
+pci_msix_vec_count_fndecl_61742_fns pci_msix_vec_count fndecl 0 61742 NULL
+SYSC_add_key_fndecl_61756_fns SYSC_add_key fndecl 4 61756 NULL
+len_s_skfp_ioctl_61764_fns len s_skfp_ioctl 0 61764 NULL
+__qsfp_debugfs_read_fndecl_61803_fns __qsfp_debugfs_read fndecl 3 61803 NULL
+ttm_get_pages_fndecl_61821_fns ttm_get_pages fndecl 2 61821 NULL
+tracing_resize_saved_cmdlines_fndecl_61823_fns tracing_resize_saved_cmdlines fndecl 1 61823 NULL
+SYSC_set_mempolicy_fndecl_61827_fns SYSC_set_mempolicy fndecl 3 61827 NULL
+num_virt_counters_op_x86_model_spec_61835_fns num_virt_counters op_x86_model_spec 0 61835 NULL
+size_rocker_dma_ring_info_61839_fns size rocker_dma_ring_info 0 61839 NULL
+handle_eviocgbit_fndecl_61874_fns handle_eviocgbit fndecl 3 61874 NULL
+wil_vring_init_tx_fndecl_61876_fns wil_vring_init_tx fndecl 3 61876 NULL
+virtinput_cfg_select_fndecl_61880_fns virtinput_cfg_select fndecl 0 61880 NULL
+param_data_size_skl_ipc_large_config_msg_61881_fns param_data_size skl_ipc_large_config_msg 0 61881 NULL
+vp_find_vqs_fndecl_61892_fns vp_find_vqs fndecl 2 61892 NULL
+srp_alloc_iu_fndecl_61904_fns srp_alloc_iu fndecl 2 61904 NULL
+mlx5_set_ports_check_fndecl_61910_fns mlx5_set_ports_check fndecl 3 61910 NULL
+rxsize_channel_data_61912_fns rxsize channel_data 0 61912 NULL
+device_create_file_fndecl_61934_fns device_create_file fndecl 0 61934 NULL
+__subn_get_opa_cable_info_fndecl_61961_fns __subn_get_opa_cable_info fndecl 2 61961 NULL
+indirect_size_srp_target_port_61962_fns indirect_size srp_target_port 0 61962 NULL
+qla4xxx_alloc_work_fndecl_61982_fns qla4xxx_alloc_work fndecl 2 61982 NULL
+qib_verbs_send_dma_fndecl_61985_fns qib_verbs_send_dma fndecl 6-3 61985 NULL
+sub_stripes_map_lookup_61986_fns sub_stripes map_lookup 0 61986 NULL
+copydesc_user_fndecl_61988_fns copydesc_user fndecl 3 61988 NULL
+sisusb_write_fndecl_62001_fns sisusb_write fndecl 3 62001 NULL
+iwl_dbgfs_tof_range_req_ext_read_fndecl_62021_fns iwl_dbgfs_tof_range_req_ext_read fndecl 3 62021 NULL
+drm_dp_dpcd_read_fndecl_62030_fns drm_dp_dpcd_read fndecl 0 62030 NULL
+init_rs_fndecl_62042_fns init_rs fndecl 1-5 62042 NULL
+block_aligned_filename_size_ecryptfs_write_tag_70_packet_silly_stack_62050_fns block_aligned_filename_size ecryptfs_write_tag_70_packet_silly_stack 0 62050 NULL
+cfg80211_inform_bss_data_fndecl_62065_fns cfg80211_inform_bss_data fndecl 9 62065 NULL
+do_tty_write_fndecl_62067_fns do_tty_write fndecl 5 62067 NULL
+storvsc_connect_to_vsp_fndecl_62078_fns storvsc_connect_to_vsp fndecl 2 62078 NULL
+ofdpa_group_l2_flood_fndecl_62112_fns ofdpa_group_l2_flood fndecl 5 62112 NULL
+__i2c_debugfs_write_fndecl_62113_fns __i2c_debugfs_write fndecl 3 62113 NULL nohasharray
+tx_queue_status_read_fndecl_62113_fns tx_queue_status_read fndecl 3 62113 &__i2c_debugfs_write_fndecl_62113_fns
+bo_offset_vmw_surface_offset_62116_fns bo_offset vmw_surface_offset 0 62116 NULL
+sched_read_attr_fndecl_62123_fns sched_read_attr fndecl 3 62123 NULL
+ofdpa_port_vlan_to_vid_fndecl_62138_fns ofdpa_port_vlan_to_vid fndecl 0 62138 NULL
+free_space_bitmap_size_fndecl_62144_fns free_space_bitmap_size fndecl 0 62144 NULL
+ptrace_writedata_fndecl_62158_fns ptrace_writedata fndecl 4 62158 NULL
+dm_kvzalloc_fndecl_62194_fns dm_kvzalloc fndecl 1 62194 NULL
+wm_adsp_create_control_fndecl_62201_fns wm_adsp_create_control fndecl 4 62201 NULL
+param_count_acpi_evaluate_info_62202_fns param_count acpi_evaluate_info 0 62202 NULL
+sense_len_request_62229_fns sense_len request 0 62229 NULL
+soc_tplg_dapm_widget_dmixer_create_fndecl_62241_fns soc_tplg_dapm_widget_dmixer_create fndecl 2 62241 NULL
+mlxsw_reg_write_fndecl_62290_fns mlxsw_reg_write fndecl 0 62290 NULL
+__kvm_read_guest_page_fndecl_62291_fns __kvm_read_guest_page fndecl 5-2 62291 NULL
+alloc_ctrl_packet_fndecl_62312_fns alloc_ctrl_packet fndecl 1 62312 NULL
+erst_writer_fndecl_62318_fns erst_writer fndecl 7 62318 NULL
+reiserfs_update_sd_size_fndecl_62345_fns reiserfs_update_sd_size fndecl 3 62345 NULL nohasharray
+lov_emerg_alloc_fndecl_62345_fns lov_emerg_alloc fndecl 1 62345 &reiserfs_update_sd_size_fndecl_62345_fns
+switchdev_obj_size_fndecl_62346_fns switchdev_obj_size fndecl 0 62346 NULL
+write_file_spectral_bins_fndecl_62347_fns write_file_spectral_bins fndecl 3 62347 NULL
+C_SYSC_select_fndecl_62350_fns C_SYSC_select fndecl 1 62350 NULL
+mpi_resize_fndecl_62353_fns mpi_resize fndecl 2 62353 NULL
+raid56_parity_write_fndecl_62355_fns raid56_parity_write fndecl 4 62355 NULL
+reglen_bfad_s_62360_fns reglen bfad_s 0 62360 NULL
+fm10k_iov_alloc_data_fndecl_62361_fns fm10k_iov_alloc_data fndecl 2 62361 NULL
+ts_read_fndecl_62364_fns ts_read fndecl 3 62364 NULL
+sysfs_create_link_fndecl_62366_fns sysfs_create_link fndecl 0 62366 NULL
+num_subauth_cifs_sid_62374_fns num_subauth cifs_sid 0 62374 NULL
+fib_count_nexthops_fndecl_62377_fns fib_count_nexthops fndecl 0 62377 NULL
+clusterip_proc_write_fndecl_62378_fns clusterip_proc_write fndecl 3 62378 NULL
+xfer_to_user_fndecl_62394_fns xfer_to_user fndecl 3 62394 NULL
+tnode_new_fndecl_62406_fns tnode_new fndecl 3 62406 NULL
+WIL_GET_BITS_fndecl_62424_fns WIL_GET_BITS fndecl 0-3-2-1 62424 NULL
+sctp_setsockopt_fndecl_62439_fns sctp_setsockopt fndecl 5 62439 NULL
+rx_dropped_read_fndecl_62444_fns rx_dropped_read fndecl 3 62444 NULL
+__videobuf_copy_stream_fndecl_62450_fns __videobuf_copy_stream fndecl 4 62450 NULL
+k3_dma_prep_slave_sg_fndecl_62456_fns k3_dma_prep_slave_sg fndecl 3 62456 NULL
+page_size_mspro_block_data_62479_fns page_size mspro_block_data 0 62479 NULL
+symsize_persistent_ram_ecc_info_62489_fns symsize persistent_ram_ecc_info 0 62489 NULL
+evtchn_write_fndecl_62493_fns evtchn_write fndecl 3 62493 NULL
+args_count_arm_smmu_phandle_args_62496_fns args_count arm_smmu_phandle_args 0 62496 NULL
+de_type_gfs2_dirent_62502_fns de_type gfs2_dirent 0 62502 NULL
+kvm_host_page_size_fndecl_62535_fns kvm_host_page_size fndecl 0-2 62535 NULL
+svc_pool_map_get_fndecl_62569_fns svc_pool_map_get fndecl 0 62569 NULL
+numscales_vardecl_longhaul_c_62570_fns numscales vardecl_longhaul.c 0 62570 NULL
+xenfb_write_fndecl_62599_fns xenfb_write fndecl 3 62599 NULL
+__alloc_bootmem_low_fndecl_62604_fns __alloc_bootmem_low fndecl 1 62604 NULL nohasharray
+msi_capability_init_fndecl_62604_fns msi_capability_init fndecl 2 62604 &__alloc_bootmem_low_fndecl_62604_fns
+usb_string_fndecl_62624_fns usb_string fndecl 0 62624 NULL
+get_vm_area_size_fndecl_62631_fns get_vm_area_size fndecl 0 62631 NULL
+fs_path_prepare_for_add_fndecl_62638_fns fs_path_prepare_for_add fndecl 2-0 62638 NULL
+usb_alloc_urb_fndecl_62655_fns usb_alloc_urb fndecl 1 62655 NULL
+nvme_trans_device_id_page_fndecl_62681_fns nvme_trans_device_id_page fndecl 4 62681 NULL
+mvneta_change_mtu_fndecl_62689_fns mvneta_change_mtu fndecl 2 62689 NULL
+tx_tx_data_prepared_read_fndecl_62714_fns tx_tx_data_prepared_read fndecl 3 62714 NULL
+isr_rx_mem_overflow_read_fndecl_62722_fns isr_rx_mem_overflow_read fndecl 3 62722 NULL
+wep_default_key_count_read_fndecl_62728_fns wep_default_key_count_read fndecl 3 62728 NULL
+match_size_ebt_entry_match_62738_fns match_size ebt_entry_match 0 62738 NULL nohasharray
+hpi_init_message_responseV1_fndecl_62738_fns hpi_init_message_responseV1 fndecl 4-2 62738 &match_size_ebt_entry_match_62738_fns
+payload_size_hv_message_header_62742_fns payload_size hv_message_header 0 62742 NULL
+tomoyo_read_fndecl_62786_fns tomoyo_read fndecl 3 62786 NULL
+len_cx24120_cmd_62796_fns len cx24120_cmd 0 62796 NULL nohasharray
+sysfs_create_file_ns_fndecl_62796_fns sysfs_create_file_ns fndecl 0 62796 &len_cx24120_cmd_62796_fns
+pof_recoffset_boot_data_62824_fns pof_recoffset boot_data 0 62824 NULL
+wq_len_tx_ring_62826_fns wq_len tx_ring 0 62826 NULL
+cfs_cpt_table_alloc_fndecl_62852_fns cfs_cpt_table_alloc fndecl 1 62852 NULL
+func_num_vardecl_g_ffs_c_62856_fns func_num vardecl_g_ffs.c 0 62856 NULL
+il_dbgfs_power_save_status_read_fndecl_62862_fns il_dbgfs_power_save_status_read fndecl 3 62862 NULL
+read_file_dfs_fndecl_62874_fns read_file_dfs fndecl 3 62874 NULL
+ath6kl_set_assoc_req_ies_fndecl_62882_fns ath6kl_set_assoc_req_ies fndecl 3 62882 NULL
+send_cmd_fndecl_62899_fns send_cmd fndecl 0 62899 NULL
+elf_core_extra_phdrs_fndecl_62917_fns elf_core_extra_phdrs fndecl 0 62917 NULL
+uio_write_fndecl_62929_fns uio_write fndecl 3 62929 NULL
+queue_size_srp_target_port_62930_fns queue_size srp_target_port 0 62930 NULL
+iso_callback_fndecl_62939_fns iso_callback fndecl 3 62939 NULL
+ovl_split_lowerdirs_fndecl_62941_fns ovl_split_lowerdirs fndecl 0 62941 NULL
+batadv_tt_tvlv_unicast_handler_v1_fndecl_62964_fns batadv_tt_tvlv_unicast_handler_v1 fndecl 5 62964 NULL
+max_size_mlx5_rl_table_62968_fns max_size mlx5_rl_table 0 62968 NULL
+tool_mw_write_fndecl_62998_fns tool_mw_write fndecl 3 62998 NULL
+print_hex_dump_fndecl_63006_fns print_hex_dump fndecl 7-4-5 63006 NULL
+cache_size_raw_regmap_63010_fns cache_size_raw regmap 0 63010 NULL
+gpr_get_fndecl_63026_fns gpr_get fndecl 3-4 63026 NULL
+arch_memcpy_to_pmem_fndecl_63041_fns arch_memcpy_to_pmem fndecl 3 63041 NULL
+len_ixgbe_tx_buffer_63047_fns len ixgbe_tx_buffer 0 63047 NULL
+read_flush_fndecl_63064_fns read_flush fndecl 3 63064 NULL
+elements_array_data_63130_fns elements array_data 0 63130 NULL
+reiserfs_get_blocks_direct_io_fndecl_63157_fns reiserfs_get_blocks_direct_io fndecl 2 63157 NULL
+nports_ahci_host_priv_63166_fns nports ahci_host_priv 0 63166 NULL
+stats_dot11RTSFailureCount_read_fndecl_63167_fns stats_dot11RTSFailureCount_read fndecl 3 63167 NULL
+__clkdev_alloc_fndecl_63173_fns __clkdev_alloc fndecl 1 63173 NULL
+xt_copy_counters_from_user_fndecl_63174_fns xt_copy_counters_from_user fndecl 2 63174 NULL
+mlxsw_cmd_mbox_query_fw_fw_pages_get_fndecl_63177_fns mlxsw_cmd_mbox_query_fw_fw_pages_get fndecl 0 63177 NULL nohasharray
+ulist_add_fndecl_63177_fns ulist_add fndecl 2-3 63177 &mlxsw_cmd_mbox_query_fw_fw_pages_get_fndecl_63177_fns
+scsi_command_size_fndecl_63179_fns scsi_command_size fndecl 0 63179 NULL nohasharray
+kvm_read_guest_virt_fndecl_63179_fns kvm_read_guest_virt fndecl 4-2 63179 &scsi_command_size_fndecl_63179_fns
+cache_request_fndecl_63187_fns cache_request fndecl 0 63187 NULL
+ieee80211_if_read_rc_rateidx_vht_mcs_mask_2ghz_fndecl_63191_fns ieee80211_if_read_rc_rateidx_vht_mcs_mask_2ghz fndecl 3 63191 NULL
+squashfs_xz_uncompress_fndecl_63193_fns squashfs_xz_uncompress fndecl 6-5 63193 NULL
+write_flush_procfs_fndecl_63224_fns write_flush_procfs fndecl 3 63224 NULL
+tx_frag_failed_read_fndecl_63239_fns tx_frag_failed_read fndecl 3 63239 NULL
+acpi_ut_get_resource_length_fndecl_63256_fns acpi_ut_get_resource_length fndecl 0 63256 NULL
+nvme_init_iod_fndecl_63258_fns nvme_init_iod fndecl 2 63258 NULL
+read_events_fndecl_63261_fns read_events fndecl 3 63261 NULL
+dvb_ca_en50221_io_write_fndecl_63262_fns dvb_ca_en50221_io_write fndecl 3 63262 NULL
+__cyz_load_fw_fndecl_63264_fns __cyz_load_fw fndecl 0 63264 NULL
+rpc_malloc_fndecl_63270_fns rpc_malloc fndecl 2 63270 NULL
+video_buffer_size_osd_info_63299_fns video_buffer_size osd_info 0 63299 NULL
+lpfc_idiag_drbacc_read_reg_fndecl_63301_fns lpfc_idiag_drbacc_read_reg fndecl 0-3 63301 NULL
+proc_read_fndecl_63309_fns proc_read fndecl 3 63309 NULL
+alloc_thread_groups_fndecl_63354_fns alloc_thread_groups fndecl 2 63354 NULL
+start_ms350_cam_fndecl_63372_fns start_ms350_cam fndecl 0 63372 NULL
+kmalloc_large_node_hook_fndecl_63376_fns kmalloc_large_node_hook fndecl 2 63376 NULL
+max_lun_rts51x_chip_63381_fns max_lun rts51x_chip 0 63381 NULL
+__alloc_alien_cache_fndecl_63429_fns __alloc_alien_cache fndecl 2 63429 NULL
+snd_rme32_playback_copy_fndecl_63431_fns snd_rme32_playback_copy fndecl 5 63431 NULL
+bo_count_drm_vc4_get_hang_state_63455_fns bo_count drm_vc4_get_hang_state 0 63455 NULL
+sctp_setsockopt_active_key_fndecl_63480_fns sctp_setsockopt_active_key fndecl 3 63480 NULL
+length_dw_amdgpu_cs_chunk_63482_fns length_dw amdgpu_cs_chunk 0 63482 NULL nohasharray
+gigaset_initcs_fndecl_63482_fns gigaset_initcs fndecl 2 63482 &length_dw_amdgpu_cs_chunk_63482_fns
+width_v4l2_pix_format_63491_fns width v4l2_pix_format 0 63491 NULL
+_gr_table_len_vardecl_x2apic_uv_x_c_63497_fns _gr_table_len vardecl_x2apic_uv_x.c 0 63497 NULL
+num_usb2_ports_xhci_hcd_63514_fns num_usb2_ports xhci_hcd 0 63514 NULL
+rx_defrag_need_decrypt_read_fndecl_63518_fns rx_defrag_need_decrypt_read fndecl 3 63518 NULL
+sel_read_perm_fndecl_63533_fns sel_read_perm fndecl 3 63533 NULL
+__tty_buffer_request_room_fndecl_63543_fns __tty_buffer_request_room fndecl 2-0 63543 NULL
+snd_pcm_hw_param_value_max_fndecl_63547_fns snd_pcm_hw_param_value_max fndecl 0 63547 NULL
+tlv_data_size_user_element_63549_fns tlv_data_size user_element 0 63549 NULL
+ath10k_htc_process_trailer_fndecl_63552_fns ath10k_htc_process_trailer fndecl 3 63552 NULL
+gfn_to_hva_fndecl_63570_fns gfn_to_hva fndecl 2 63570 NULL
+sctp_setsockopt_del_key_fndecl_63571_fns sctp_setsockopt_del_key fndecl 3 63571 NULL nohasharray
+ulong_read_file_fndecl_63571_fns ulong_read_file fndecl 3 63571 &sctp_setsockopt_del_key_fndecl_63571_fns
+xfs_rui_init_fndecl_63573_fns xfs_rui_init fndecl 2 63573 NULL
+cit_get_packet_size_fndecl_63585_fns cit_get_packet_size fndecl 0 63585 NULL
+il_dbgfs_disable_ht40_read_fndecl_63617_fns il_dbgfs_disable_ht40_read fndecl 3 63617 NULL
+snic_queue_wq_desc_fndecl_63639_fns snic_queue_wq_desc fndecl 3 63639 NULL
+mlxsw_pci_fw_area_init_fndecl_63657_fns mlxsw_pci_fw_area_init fndecl 3 63657 NULL
+msnd_fifo_read_fndecl_63669_fns msnd_fifo_read fndecl 0 63669 NULL
+alloc_gen8_temp_bitmaps_fndecl_63688_fns alloc_gen8_temp_bitmaps fndecl 3 63688 NULL nohasharray
+height_ssd1307fb_par_63688_fns height ssd1307fb_par 0 63688 &alloc_gen8_temp_bitmaps_fndecl_63688_fns
+fanout_set_data_cbpf_fndecl_63689_fns fanout_set_data_cbpf fndecl 3 63689 NULL
+qsfp_debugfs_dump_fndecl_63692_fns qsfp_debugfs_dump fndecl 3 63692 NULL
+__iio_add_chan_devattr_fndecl_63697_fns __iio_add_chan_devattr fndecl 0 63697 NULL
+gsm_data_alloc_fndecl_63702_fns gsm_data_alloc fndecl 3 63702 NULL
+key_conf_keyidx_read_fndecl_63704_fns key_conf_keyidx_read fndecl 3 63704 NULL
+spi_split_transfers_maxsize_fndecl_63709_fns spi_split_transfers_maxsize fndecl 3 63709 NULL
+print_section_fndecl_63738_fns print_section fndecl 3 63738 NULL
+len_ath10k_hif_sg_item_63747_fns len ath10k_hif_sg_item 0 63747 NULL
+smtc_map_smem_fndecl_63754_fns smtc_map_smem fndecl 3 63754 NULL
+spidev_sync_read_fndecl_63757_fns spidev_sync_read fndecl 0 63757 NULL
+pool_allocate_fndecl_63759_fns pool_allocate fndecl 3 63759 NULL
+msix_count_skd_device_63760_fns msix_count skd_device 0 63760 NULL
+insn_size_kprobe_insn_cache_63777_fns insn_size kprobe_insn_cache 0 63777 NULL
+__hwahc_op_set_gtk_fndecl_63781_fns __hwahc_op_set_gtk fndecl 4 63781 NULL
+alloc_trace_kprobe_fndecl_63786_fns alloc_trace_kprobe fndecl 6 63786 NULL
+_scif_recv_fndecl_63792_fns _scif_recv fndecl 0-3 63792 NULL
+rs_sta_dbgfs_scale_table_write_fndecl_63794_fns rs_sta_dbgfs_scale_table_write fndecl 3 63794 NULL
+ioaccel_maxsg_ctlr_info_63798_fns ioaccel_maxsg ctlr_info 0 63798 NULL
+acpi_ut_create_buffer_object_fndecl_63805_fns acpi_ut_create_buffer_object fndecl 1 63805 NULL
+iwl_mvm_scan_size_fndecl_63834_fns iwl_mvm_scan_size fndecl 0 63834 NULL
+error_elp_while_tx_exch_read_fndecl_63835_fns error_elp_while_tx_exch_read fndecl 3 63835 NULL
+ext4_sync_file_fndecl_63847_fns ext4_sync_file fndecl 2-3 63847 NULL
+addrlen_at25_data_63857_fns addrlen at25_data 0 63857 NULL
+dw_dma_cyclic_prep_fndecl_63890_fns dw_dma_cyclic_prep fndecl 4-3 63890 NULL
+len_sock_fprog_kern_63914_fns len sock_fprog_kern 0 63914 NULL
+read_file_base_eeprom_fndecl_63915_fns read_file_base_eeprom fndecl 3 63915 NULL
+component_match_realloc_fndecl_63932_fns component_match_realloc fndecl 3 63932 NULL
+get_znodes_to_commit_fndecl_63946_fns get_znodes_to_commit fndecl 0 63946 NULL nohasharray
+hdr_dwords_qib_verbs_txreq_63946_fns hdr_dwords qib_verbs_txreq 0 63946 &get_znodes_to_commit_fndecl_63946_fns
+vhost_copy_to_user_fndecl_63952_fns vhost_copy_to_user fndecl 4 63952 NULL
+oprofilefs_str_to_user_fndecl_63957_fns oprofilefs_str_to_user fndecl 3 63957 NULL
+pvr2_send_request_fndecl_63959_fns pvr2_send_request fndecl 3-5 63959 NULL
+write_file_beacon_fndecl_63962_fns write_file_beacon fndecl 3 63962 NULL
+len_wm_coeff_ctl_63967_fns len wm_coeff_ctl 0 63967 NULL
+pla_ocp_read_fndecl_63976_fns pla_ocp_read fndecl 3 63976 NULL
+pos_pagemapread_63988_fns pos pagemapread 0 63988 NULL
+snd_midi_event_decode_fndecl_64015_fns snd_midi_event_decode fndecl 0 64015 NULL
+dpm_sysfs_add_fndecl_64023_fns dpm_sysfs_add fndecl 0 64023 NULL
+fw_device_op_compat_ioctl_fndecl_64039_fns fw_device_op_compat_ioctl fndecl 2 64039 NULL
+drm_ioctl_fndecl_64046_fns drm_ioctl fndecl 2 64046 NULL
+elfcorehdr_read_notes_fndecl_64049_fns elfcorehdr_read_notes fndecl 2 64049 NULL
+entries_per_page_tracing_map_array_64081_fns entries_per_page tracing_map_array 0 64081 NULL
+iwl_dbgfs_ucode_bt_stats_read_fndecl_64087_fns iwl_dbgfs_ucode_bt_stats_read fndecl 3 64087 NULL
+si476x_radio_read_rsq_blob_fndecl_64088_fns si476x_radio_read_rsq_blob fndecl 3 64088 NULL
+set_arg_fndecl_64091_fns set_arg fndecl 3 64091 NULL
+cxgbi_hbas_add_fndecl_64102_fns cxgbi_hbas_add fndecl 3 64102 NULL
+rx_mini_pending_ethtool_ringparam_64104_fns rx_mini_pending ethtool_ringparam 0 64104 NULL
+nvme_trans_unit_serial_page_fndecl_64108_fns nvme_trans_unit_serial_page fndecl 4 64108 NULL
+btmrvl_fwdump_write_fndecl_64113_fns btmrvl_fwdump_write fndecl 3 64113 NULL
+of_property_count_strings_fndecl_64124_fns of_property_count_strings fndecl 0 64124 NULL
+xpc_kmalloc_cacheline_aligned_fndecl_64156_fns xpc_kmalloc_cacheline_aligned fndecl 1 64156 NULL
+sctp_getsockopt_maxburst_fndecl_64174_fns sctp_getsockopt_maxburst fndecl 2 64174 NULL
+max_fcoe_conn_cnic_dev_64181_fns max_fcoe_conn cnic_dev 0 64181 NULL
+out___kfifo_64192_fns out __kfifo 0 64192 NULL
+sys_sethostname_fndecl_64193_fns sys_sethostname fndecl 2 64193 NULL
+st_set_options_fndecl_64214_fns st_set_options fndecl 2 64214 NULL
+f2fs_move_file_range_fndecl_64227_fns f2fs_move_file_range fndecl 2-5 64227 NULL
+compat_udpv6_setsockopt_fndecl_64246_fns compat_udpv6_setsockopt fndecl 5 64246 NULL
+pwr_ap_sleep_counter_read_fndecl_64248_fns pwr_ap_sleep_counter_read fndecl 3 64248 NULL
+nfs_idmap_get_desc_fndecl_64253_fns nfs_idmap_get_desc fndecl 2-4 64253 NULL nohasharray
+rtw_os_xmit_resource_alloc_fndecl_64253_fns rtw_os_xmit_resource_alloc fndecl 3 64253 &nfs_idmap_get_desc_fndecl_64253_fns
+mwifiex_timeshare_coex_read_fndecl_64272_fns mwifiex_timeshare_coex_read fndecl 3 64272 NULL
+denominator_v4l2_fract_64280_fns denominator v4l2_fract 0 64280 NULL
+request_firmware_fndecl_64298_fns request_firmware fndecl 0 64298 NULL
+snd_emux_create_port_fndecl_64310_fns snd_emux_create_port fndecl 3 64310 NULL
+smk_read_unconfined_fndecl_64317_fns smk_read_unconfined fndecl 3 64317 NULL
+cciss_add_disk_fndecl_64338_fns cciss_add_disk fndecl 3 64338 NULL
+_iwl_dbgfs_tof_range_abort_write_fndecl_64357_fns _iwl_dbgfs_tof_range_abort_write fndecl 3 64357 NULL
+oom_score_adj_write_fndecl_64369_fns oom_score_adj_write fndecl 3 64369 NULL
+skb_array_resize_multiple_fndecl_64376_fns skb_array_resize_multiple fndecl 2-3 64376 NULL
+hpi_init_responseV1_fndecl_64379_fns hpi_init_responseV1 fndecl 2 64379 NULL
+diversity_num_of_packets_per_ant_read_fndecl_64400_fns diversity_num_of_packets_per_ant_read fndecl 3 64400 NULL
+sys_move_pages_fndecl_64401_fns sys_move_pages fndecl 2 64401 NULL
+head_len_icmp_bxm_64424_fns head_len icmp_bxm 0 64424 NULL
+new_node_page_fndecl_64464_fns new_node_page fndecl 2 64464 NULL
+request_key_and_link_fndecl_64470_fns request_key_and_link fndecl 4 64470 NULL
+switchdev_deferred_enqueue_fndecl_64474_fns switchdev_deferred_enqueue fndecl 3 64474 NULL
+set_aoe_iflist_fndecl_64482_fns set_aoe_iflist fndecl 2 64482 NULL
+ax25_setsockopt_fndecl_64487_fns ax25_setsockopt fndecl 5 64487 NULL
+partition_create_desc_fndecl_64535_fns partition_create_desc fndecl 3 64535 NULL
+ath10k_p2p_noa_ie_len_compute_fndecl_64548_fns ath10k_p2p_noa_ie_len_compute fndecl 0 64548 NULL
+num_channels_sh_tmu_device_64556_fns num_channels sh_tmu_device 0 64556 NULL
+hiddev_compat_ioctl_fndecl_64564_fns hiddev_compat_ioctl fndecl 2 64564 NULL
+rq_enc_pages_num_rpc_rqst_64573_fns rq_enc_pages_num rpc_rqst 0 64573 NULL
+erst_read_fndecl_64575_fns erst_read fndecl 0 64575 NULL
+vtpm_proxy_tpm_op_send_fndecl_64582_fns vtpm_proxy_tpm_op_send fndecl 3 64582 NULL
+alloc_context_fndecl_64592_fns alloc_context fndecl 1 64592 NULL
+of_count_phandle_with_args_fndecl_64600_fns of_count_phandle_with_args fndecl 0 64600 NULL
+gpr_set_fndecl_64611_fns gpr_set fndecl 3-4 64611 NULL
+kmp_init_fndecl_64654_fns kmp_init fndecl 2 64654 NULL
+num_allowed_vlans_qlcnic_sriov_64661_fns num_allowed_vlans qlcnic_sriov 0 64661 NULL
+cnic_init_id_tbl_fndecl_64665_fns cnic_init_id_tbl fndecl 2 64665 NULL
+isr_commands_read_fndecl_64677_fns isr_commands_read fndecl 3 64677 NULL nohasharray
+cciss_update_drive_info_fndecl_64677_fns cciss_update_drive_info fndecl 2 64677 &isr_commands_read_fndecl_64677_fns
+sys_flistxattr_fndecl_64684_fns sys_flistxattr fndecl 3 64684 NULL
+get_base_info_fndecl_64688_fns get_base_info fndecl 3 64688 NULL
+lbs_rdrf_read_fndecl_64708_fns lbs_rdrf_read fndecl 3 64708 NULL
+rx_defrag_decrypt_failed_read_fndecl_64720_fns rx_defrag_decrypt_failed_read fndecl 3 64720 NULL
+layout_leb_in_gaps_fndecl_64749_fns layout_leb_in_gaps fndecl 0 64749 NULL
+pcpu_build_alloc_info_fndecl_64752_fns pcpu_build_alloc_info fndecl 2-1-3 64752 NULL nohasharray
+vop_virtio_copy_from_user_fndecl_64752_fns vop_virtio_copy_from_user fndecl 3 64752 &pcpu_build_alloc_info_fndecl_64752_fns
+iio_device_alloc_fndecl_64755_fns iio_device_alloc fndecl 1 64755 NULL
+smtcfb_read_fndecl_64764_fns smtcfb_read fndecl 3 64764 NULL
+mac80211_format_buffer_fndecl_64801_fns mac80211_format_buffer fndecl 2 64801 NULL
+pmsg_size_ramoops_context_64804_fns pmsg_size ramoops_context 0 64804 NULL
+fpa_get_fndecl_64809_fns fpa_get fndecl 3-4 64809 NULL
+il_dbgfs_fh_reg_read_fndecl_64818_fns il_dbgfs_fh_reg_read fndecl 3 64818 NULL
+iwl_dbgfs_scan_ant_rxchain_read_fndecl_64820_fns iwl_dbgfs_scan_ant_rxchain_read fndecl 3 64820 NULL
+atr_csum_cm4000_dev_64828_fns atr_csum cm4000_dev 0 64828 NULL
+lprocfs_write_frac_helper_fndecl_64841_fns lprocfs_write_frac_helper fndecl 2 64841 NULL
+edma_prep_dma_cyclic_fndecl_64842_fns edma_prep_dma_cyclic fndecl 4-3 64842 NULL
+iov_iter_truncate_fndecl_64844_fns iov_iter_truncate fndecl 2 64844 NULL
+tool_dbfn_write_fndecl_64852_fns tool_dbfn_write fndecl 3 64852 NULL
+rh_inc_fndecl_64864_fns rh_inc fndecl 2 64864 NULL
+sc_only_mode_read_fndecl_64871_fns sc_only_mode_read fndecl 3 64871 NULL
+vfs_listxattr_fndecl_64885_fns vfs_listxattr fndecl 0 64885 NULL
+reserve_sfa_size_fndecl_64893_fns reserve_sfa_size fndecl 2 64893 NULL
+provide_user_output_fndecl_64898_fns provide_user_output fndecl 3 64898 NULL
+f_audio_buffer_alloc_fndecl_64901_fns f_audio_buffer_alloc fndecl 1 64901 NULL
+maxctl_brcmf_bus_64907_fns maxctl brcmf_bus 0 64907 NULL nohasharray
+ath10k_read_wmi_services_fndecl_64907_fns ath10k_read_wmi_services fndecl 3 64907 &maxctl_brcmf_bus_64907_fns
+dma_attach_fndecl_64917_fns dma_attach fndecl 5-6 64917 NULL
+roccat_read_fndecl_64918_fns roccat_read fndecl 3 64918 NULL
+qstat_read_fndecl_64946_fns qstat_read fndecl 3 64946 NULL
+dvb_ca_write_fndecl_64960_fns dvb_ca_write fndecl 3 64960 NULL
+print_pkt_fndecl_64981_fns print_pkt fndecl 2 64981 NULL
+tx_frag_mpdu_alloc_failed_read_fndecl_64988_fns tx_frag_mpdu_alloc_failed_read fndecl 3 64988 NULL
+__mlxsw_item_get32_fndecl_64999_fns __mlxsw_item_get32 fndecl 0 64999 NULL
+netif_get_num_default_rss_queues_fndecl_65008_fns netif_get_num_default_rss_queues fndecl 0 65008 NULL
+dfs_file_write_fndecl_65023_fns dfs_file_write fndecl 3 65023 NULL
+bus_add_driver_fndecl_65060_fns bus_add_driver fndecl 0 65060 NULL
+flag_node_footer_65063_fns flag node_footer 0 65063 NULL
+capi_ttyminors_vardecl_capi_c_65086_fns capi_ttyminors vardecl_capi.c 0 65086 NULL
+num_tx_bds_bcmgenet_priv_65087_fns num_tx_bds bcmgenet_priv 0 65087 NULL
+rtw_android_get_macaddr_fndecl_65095_fns rtw_android_get_macaddr fndecl 0 65095 NULL
+iwl_dbgfs_bt_notif_read_fndecl_65105_fns iwl_dbgfs_bt_notif_read fndecl 3 65105 NULL
+ntb_mw_count_fndecl_65108_fns ntb_mw_count fndecl 0 65108 NULL
+nilfs_cpfile_is_snapshot_fndecl_65110_fns nilfs_cpfile_is_snapshot fndecl 2 65110 NULL
+hsi_alloc_controller_fndecl_65113_fns hsi_alloc_controller fndecl 1 65113 NULL
+amdgpu_bo_list_set_fndecl_65117_fns amdgpu_bo_list_set fndecl 5 65117 NULL
+do_ip_setsockopt_fndecl_65135_fns do_ip_setsockopt fndecl 5 65135 NULL
+kimage_file_alloc_init_fndecl_65136_fns kimage_file_alloc_init fndecl 5 65136 NULL
+ixgbe_dbg_netdev_ops_read_fndecl_65148_fns ixgbe_dbg_netdev_ops_read fndecl 3 65148 NULL
+_iwl_dbgfs_max_amsdu_len_write_fndecl_65173_fns _iwl_dbgfs_max_amsdu_len_write fndecl 3 65173 NULL
+get_fdb_entries_fndecl_65199_fns get_fdb_entries fndecl 3 65199 NULL
+nilfs_palloc_entry_blkoff_fndecl_65206_fns nilfs_palloc_entry_blkoff fndecl 0 65206 NULL
+read_gssp_fndecl_65224_fns read_gssp fndecl 3 65224 NULL
+ssid_len_connect_attr_65228_fns ssid_len connect_attr 0 65228 NULL
+etb_read_fndecl_65249_fns etb_read fndecl 3 65249 NULL
+cx24116_writeregN_fndecl_65252_fns cx24116_writeregN fndecl 4 65252 NULL
+portnames_read_fndecl_65269_fns portnames_read fndecl 3 65269 NULL
+update_stat_data_fndecl_65289_fns update_stat_data fndecl 3 65289 NULL
+hpfs_translate_name_fndecl_65290_fns hpfs_translate_name fndecl 3 65290 NULL
+rt2x00debug_write_rfcsr_fndecl_65298_fns rt2x00debug_write_rfcsr fndecl 3 65298 NULL nohasharray
+usb_stor_probe2_fndecl_65298_fns usb_stor_probe2 fndecl 0 65298 &rt2x00debug_write_rfcsr_fndecl_65298_fns
+rockchip_clk_init_fndecl_65312_fns rockchip_clk_init fndecl 3 65312 NULL
+brcmf_flowring_attach_fndecl_65325_fns brcmf_flowring_attach fndecl 2 65325 NULL
+ath6kl_endpoint_stats_read_fndecl_65345_fns ath6kl_endpoint_stats_read fndecl 3 65345 NULL
+wm_coeff_read_control_fndecl_65358_fns wm_coeff_read_control fndecl 3 65358 NULL
+fbucket_size_qlcnic_filter_hash_65369_fns fbucket_size qlcnic_filter_hash 0 65369 NULL
+batadv_tvlv_container_ogm_append_fndecl_65383_fns batadv_tvlv_container_ogm_append fndecl 4 65383 NULL
+num_rx_queues_ixgbe_adapter_65402_fns num_rx_queues ixgbe_adapter 0 65402 NULL
+rng_dev_read_fndecl_65406_fns rng_dev_read fndecl 3 65406 NULL
+lstcon_batch_list_fndecl_65416_fns lstcon_batch_list fndecl 2 65416 NULL
+fq_trees_log_fq_sched_data_65425_fns fq_trees_log fq_sched_data 0 65425 NULL
+tcp_hdrlen_fndecl_65433_fns tcp_hdrlen fndecl 0 65433 NULL
+data_in_size_mpt3_ioctl_command_65434_fns data_in_size mpt3_ioctl_command 0 65434 NULL
+a2mp_send_fndecl_65436_fns a2mp_send fndecl 4 65436 NULL
+spi_cmd_complete_fndecl_65442_fns spi_cmd_complete fndecl 5 65442 NULL
+rx_rx_pre_complt_read_fndecl_65446_fns rx_rx_pre_complt_read fndecl 3 65446 NULL
+squashfs_cache_init_fndecl_65451_fns squashfs_cache_init fndecl 3-2 65451 NULL
+raw_notifier_call_chain_fndecl_65500_fns raw_notifier_call_chain fndecl 0 65500 NULL
+connector_write_fndecl_65534_fns connector_write fndecl 3 65534 NULL nohasharray
+bcm2835_dma_prep_dma_memcpy_fndecl_65534_fns bcm2835_dma_prep_dma_memcpy fndecl 4 65534 &connector_write_fndecl_65534_fns
diff --git b/scripts/gcc-plugins/size_overflow_plugin/e_fptrs.data b/scripts/gcc-plugins/size_overflow_plugin/e_fptrs.data
new file mode 100644
index 000000000..0d8d5c436
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_fptrs.data
@@ -0,0 +1,70 @@
+writebootimg_HYSDN_CARD_125_fptrs writebootimg HYSDN_CARD 0 125 NULL
+notifier_call_notifier_block_360_fptrs notifier_call notifier_block 0 360 NULL
+pte_hole_mm_walk_1233_fptrs pte_hole mm_walk 0 1233 NULL
+get_tdp_level_kvm_x86_ops_1250_fptrs get_tdp_level kvm_x86_ops 0 1250 NULL
+read_kernfs_ops_1325_fptrs read kernfs_ops 0 1325 NULL
+bus_bm_cmd_send_i2400m_2189_fptrs bus_bm_cmd_send i2400m 0 2189 NULL
+read_saa7146_use_ops_2236_fptrs read saa7146_use_ops 0 2236 NULL
+mdio_write_mdio_if_info_3033_fptrs mdio_write mdio_if_info 0 3033 NULL
+parse_header_ops_3963_fptrs parse header_ops 0 3963 NULL
+epp_write_data_parport_operations_4176_fptrs epp_write_data parport_operations 0 4176 NULL
+hugetlb_entry_mm_walk_5211_fptrs hugetlb_entry mm_walk 0 5211 NULL
+get_cr3_kvm_mmu_5347_fptrs get_cr3 kvm_mmu 0 5347 NULL
+add_endpoint_hc_driver_6482_fptrs add_endpoint hc_driver 0 6482 NULL
+f_read_cntrs_qib_devdata_6502_fptrs f_read_cntrs qib_devdata 0 6502 NULL
+drop_endpoint_hc_driver_6692_fptrs drop_endpoint hc_driver 0 6692 NULL
+add_frontend_dmx_demux_7322_fptrs add_frontend dmx_demux 0 7322 NULL
+find_vqs_virtio_config_ops_11797_fptrs find_vqs virtio_config_ops 0 11797 NULL
+pcibios_enable_irq_vardecl_11854_fptrs pcibios_enable_irq vardecl 0 11854 NULL
+read8_sync_rtl_io_12571_fptrs read8_sync rtl_io 0 12571 NULL
+transfer_drm_dp_aux_14204_fptrs transfer drm_dp_aux 0 14204 NULL
+dump_fh_il_ops_14548_fptrs dump_fh il_ops 0 14548 NULL
+dump_eeprom_eeprom_ops_15062_fptrs dump_eeprom eeprom_ops 0 15062 NULL
+mdio_read_mdio_if_info_15272_fptrs mdio_read mdio_if_info 0 15272 NULL
+get_pdptr_kvm_mmu_17247_fptrs get_pdptr kvm_mmu 0 17247 NULL
+read_hwrng_17766_fptrs read hwrng 0 17766 NULL
+count_objects_shrinker_18894_fptrs count_objects shrinker 0 18894 NULL
+proc_read_atmdev_ops_19414_fptrs proc_read atmdev_ops 0 19414 NULL
+dev_init_pre_alt_sd_19924_fptrs dev_init_pre_alt sd 0 19924 NULL
+translate_gpa_kvm_mmu_20350_fptrs translate_gpa kvm_mmu 0 20350 NULL
+waitpofready_HYSDN_CARD_20682_fptrs waitpofready HYSDN_CARD 0 20682 NULL
+data_read_hwrng_21861_fptrs data_read hwrng 0 21861 NULL
+pirq_enable_irq_fndecl_22603_fptrs pirq_enable_irq fndecl 0 22603 NULL
+bytes_number_item_operations_23452_fptrs bytes_number item_operations 0 23452 NULL
+transfer_snd_pcm_plugin_25081_fptrs transfer snd_pcm_plugin 0 25081 NULL
+ecp_write_data_parport_operations_26253_fptrs ecp_write_data parport_operations 0 26253 NULL
+read_b43_debugfs_fops_29607_fptrs read b43_debugfs_fops 0 29607 NULL
+verify_planes_array_vb2_buf_ops_30329_fptrs verify_planes_array vb2_buf_ops 0 30329 NULL
+pmd_entry_mm_walk_30448_fptrs pmd_entry mm_walk 0 30448 NULL
+ecp_read_data_parport_operations_31283_fptrs ecp_read_data parport_operations 0 31283 NULL
+bus_bm_wait_for_ack_i2400m_31925_fptrs bus_bm_wait_for_ack i2400m 0 31925 NULL
+write_tty_ldisc_ops_32094_fptrs write tty_ldisc_ops 0 32094 NULL
+read32_tpm_tis_phy_ops_33980_fptrs read32 tpm_tis_phy_ops 0 33980 NULL
+client_channels_snd_pcm_plugin_36324_fptrs client_channels snd_pcm_plugin 0 36324 NULL
+gva_to_gpa_kvm_mmu_37200_fptrs gva_to_gpa kvm_mmu 0 37200 NULL
+uni2char_nls_table_41293_fptrs uni2char nls_table 0 41293 NULL
+read_b43legacy_debugfs_fops_42452_fptrs read b43legacy_debugfs_fops 0 42452 NULL
+ndo_init_net_device_ops_42812_fptrs ndo_init net_device_ops 0 42812 NULL
+epp_read_data_parport_operations_44383_fptrs epp_read_data parport_operations 0 44383 NULL
+preproc_res_proc_context_45654_fptrs preproc res_proc_context 0 45654 NULL
+show_sysfs_ops_47546_fptrs show sysfs_ops 0 47546 NULL
+parport_ieee1284_epp_read_addr_fndecl_48478_fptrs parport_ieee1284_epp_read_addr fndecl 0 48478 NULL nohasharray
+parport_ieee1284_ecp_read_data_fndecl_48478_fptrs parport_ieee1284_ecp_read_data fndecl 0 48478 &parport_ieee1284_epp_read_addr_fndecl_48478_fptrs nohasharray
+parport_ieee1284_epp_read_data_fndecl_48478_fptrs parport_ieee1284_epp_read_data fndecl 0 48478 &parport_ieee1284_ecp_read_data_fndecl_48478_fptrs
+listxattr_inode_operations_50507_fptrs listxattr inode_operations 0 50507 NULL
+pte_entry_mm_walk_51234_fptrs pte_entry mm_walk 0 51234 NULL
+probe_parport_driver_51942_fptrs probe parport_driver 0 51942 NULL
+parport_ieee1284_ecp_write_addr_fndecl_52806_fptrs parport_ieee1284_ecp_write_addr fndecl 0 52806 NULL nohasharray
+parport_ieee1284_epp_write_addr_fndecl_52806_fptrs parport_ieee1284_epp_write_addr fndecl 0 52806 &parport_ieee1284_ecp_write_addr_fndecl_52806_fptrs nohasharray
+parport_ieee1284_ecp_write_data_fndecl_52806_fptrs parport_ieee1284_ecp_write_data fndecl 0 52806 &parport_ieee1284_epp_write_addr_fndecl_52806_fptrs nohasharray
+parport_ieee1284_epp_write_data_fndecl_52806_fptrs parport_ieee1284_epp_write_data fndecl 0 52806 &parport_ieee1284_ecp_write_data_fndecl_52806_fptrs
+nr_cached_objects_super_operations_54808_fptrs nr_cached_objects super_operations 0 54808 NULL
+connect_frontend_dmx_demux_55378_fptrs connect_frontend dmx_demux 0 55378 NULL
+byte_read_data_parport_operations_57730_fptrs byte_read_data parport_operations 0 57730 NULL
+writebootseq_HYSDN_CARD_59000_fptrs writebootseq HYSDN_CARD 0 59000 NULL
+read_mii_bus_59181_fptrs read mii_bus 0 59181 NULL
+nibble_read_data_parport_operations_60589_fptrs nibble_read_data parport_operations 0 60589 NULL
+f_read_portcntrs_qib_devdata_61868_fptrs f_read_portcntrs qib_devdata 0 61868 NULL
+check_bandwidth_hc_driver_63438_fptrs check_bandwidth hc_driver 0 63438 NULL
+compat_write_data_parport_operations_64123_fptrs compat_write_data parport_operations 0 64123 NULL
+test_walk_mm_walk_64132_fptrs test_walk mm_walk 0 64132 NULL
diff --git b/scripts/gcc-plugins/size_overflow_plugin/e_vars.data b/scripts/gcc-plugins/size_overflow_plugin/e_vars.data
new file mode 100644
index 000000000..632c36de1
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_vars.data
@@ -0,0 +1,161 @@
+cache_size_vardecl_lkdtm_usercopy_c_448_vars cache_size vardecl_lkdtm_usercopy.c 0 448 NULL
+max_num_of_queues_per_device_vardecl_1365_vars max_num_of_queues_per_device vardecl 0 1365 NULL
+sdebug_num_tgts_vardecl_scsi_debug_c_2223_vars sdebug_num_tgts vardecl_scsi_debug.c 0 2223 NULL
+big_oops_buf_sz_vardecl_platform_c_2265_vars big_oops_buf_sz vardecl_platform.c 0 2265 NULL
+fpu_kernel_xstate_size_vardecl_2787_vars fpu_kernel_xstate_size vardecl 0 2787 NULL
+tx_max_out_p_vardecl_mptlan_c_2906_vars tx_max_out_p vardecl_mptlan.c 0 2906 NULL
+sysctl_nr_open_vardecl_3355_vars sysctl_nr_open vardecl 0 3355 NULL
+ecryptfs_message_buf_len_vardecl_3736_vars ecryptfs_message_buf_len vardecl 0 3736 NULL
+max_sg_segs_vardecl_osst_c_4365_vars max_sg_segs vardecl_osst.c 0 4365 NULL
+dma_tx_num_vardecl_altera_tse_main_c_4981_vars dma_tx_num vardecl_altera_tse_main.c 0 4981 NULL
+ring_buffer_size_vardecl_ldusb_c_5645_vars ring_buffer_size vardecl_ldusb.c 0 5645 NULL
+count_vardecl_speedtest_c_6069_vars count vardecl_speedtest.c 0 6069 NULL
+buffer_kbs_vardecl_st_c_6866_vars buffer_kbs vardecl_st.c 0 6866 NULL
+sysctl_perf_event_max_stack_vardecl_7792_vars sysctl_perf_event_max_stack vardecl 0 7792 NULL
+goldfish_tty_line_count_vardecl_goldfish_c_8058_vars goldfish_tty_line_count vardecl_goldfish.c 0 8058 NULL
+vmcore_size_vardecl_vmcore_c_8660_vars vmcore_size vardecl_vmcore.c 0 8660 NULL
+rx_buf_sz_vardecl_r8169_c_9136_vars rx_buf_sz vardecl_r8169.c 0 9136 NULL
+_max_socket_vardecl_x2apic_uv_x_c_9456_vars _max_socket vardecl_x2apic_uv_x.c 0 9456 NULL
+kdb_max_commands_vardecl_kdb_main_c_9529_vars kdb_max_commands vardecl_kdb_main.c 0 9529 NULL
+legacy_count_vardecl_pty_c_9908_vars legacy_count vardecl_pty.c 0 9908 NULL
+max_ptlrpcds_vardecl_ptlrpcd_c_9939_vars max_ptlrpcds vardecl_ptlrpcd.c 0 9939 NULL
+read_buffer_size_vardecl_legousbtower_c_10184_vars read_buffer_size vardecl_legousbtower.c 0 10184 NULL
+agg_buf_sz_vardecl_r8152_c_10254_vars agg_buf_sz vardecl_r8152.c 0 10254 NULL
+dma_rx_num_vardecl_altera_tse_main_c_10728_vars dma_rx_num vardecl_altera_tse_main.c 0 10728 NULL
+default_rds_buf_vardecl_fmdrv_common_c_11072_vars default_rds_buf vardecl_fmdrv_common.c 0 11072 NULL
+snd_efw_resp_buf_size_vardecl_11291_vars snd_efw_resp_buf_size vardecl 0 11291 NULL
+_max_pnode_vardecl_x2apic_uv_x_c_11492_vars _max_pnode vardecl_x2apic_uv_x.c 0 11492 NULL
+slave_num_vardecl_shdma_base_c_11603_vars slave_num vardecl_shdma-base.c 0 11603 NULL
+c4iw_wr_log_size_order_vardecl_device_c_13134_vars c4iw_wr_log_size_order vardecl_device.c 0 13134 NULL
+max_sets_vardecl_ip_set_core_c_13393_vars max_sets vardecl_ip_set_core.c 0 13393 NULL
+sysctl_perf_event_max_contexts_per_stack_vardecl_13620_vars sysctl_perf_event_max_contexts_per_stack vardecl 0 13620 NULL
+buffer_pos_vardecl_event_buffer_c_13658_vars buffer_pos vardecl_event_buffer.c 0 13658 NULL
+ipr_max_devs_vardecl_ipr_c_13921_vars ipr_max_devs vardecl_ipr.c 0 13921 NULL
+pasid_limit_vardecl_kfd_pasid_c_14334_vars pasid_limit vardecl_kfd_pasid.c 0 14334 NULL
+sel_end_vardecl_selection_c_14469_vars sel_end vardecl_selection.c 0 14469 NULL
+osst_max_sg_segs_vardecl_osst_c_14954_vars osst_max_sg_segs vardecl_osst.c 0 14954 NULL
+n_barrier_cbs_vardecl_rcutorture_c_16575_vars n_barrier_cbs vardecl_rcutorture.c 0 16575 NULL
+csio_fcoe_rnodes_vardecl_16778_vars csio_fcoe_rnodes vardecl 0 16778 NULL
+esrt_data_size_vardecl_esrt_c_16842_vars esrt_data_size vardecl_esrt.c 0 16842 NULL
+cmdlog_vardecl_ipw2200_c_18024_vars cmdlog vardecl_ipw2200.c 0 18024 NULL
+nreaders_vardecl_rcutorture_c_18862_vars nreaders vardecl_rcutorture.c 0 18862 NULL
+num_freq_table_entries_vardecl_sfi_cpufreq_c_18898_vars num_freq_table_entries vardecl_sfi-cpufreq.c 0 18898 NULL
+ndoms_cur_vardecl_core_c_19519_vars ndoms_cur vardecl_core.c 0 19519 NULL
+nwriters_vardecl_rcuperf_c_20234_vars nwriters vardecl_rcuperf.c 0 20234 NULL
+amdgpu_sched_jobs_vardecl_20778_vars amdgpu_sched_jobs vardecl 0 20778 NULL
+major_vardecl_dm_c_21185_vars major vardecl_dm.c 0 21185 NULL
+acpi_current_gpe_count_vardecl_21469_vars acpi_current_gpe_count vardecl 0 21469 NULL
+uv_possible_blades_vardecl_21579_vars uv_possible_blades vardecl 0 21579 NULL
+max_nr_vardecl_exynos_combiner_c_21761_vars max_nr vardecl_exynos-combiner.c 0 21761 NULL
+xprt_max_tcp_slot_table_entries_vardecl_xprtsock_c_21949_vars xprt_max_tcp_slot_table_entries vardecl_xprtsock.c 0 21949 NULL
+ch_count_vardecl_ib_srp_c_22190_vars ch_count vardecl_ib_srp.c 0 22190 NULL
+nreaders_stress_vardecl_locktorture_c_22217_vars nreaders_stress vardecl_locktorture.c 0 22217 NULL
+_major_vardecl_dm_c_23233_vars _major vardecl_dm.c 0 23233 NULL
+nreaders_vardecl_rcuperf_c_23383_vars nreaders vardecl_rcuperf.c 0 23383 NULL
+nr_node_ids_vardecl_23803_vars nr_node_ids vardecl 0 23803 NULL
+usbfs_snoop_max_vardecl_devio_c_23994_vars usbfs_snoop_max vardecl_devio.c 0 23994 NULL
+st_max_sg_segs_vardecl_st_c_24474_vars st_max_sg_segs vardecl_st.c 0 24474 NULL
+sdebug_sector_size_vardecl_scsi_debug_c_24855_vars sdebug_sector_size vardecl_scsi_debug.c 0 24855 NULL
+accent_table_size_vardecl_24972_vars accent_table_size vardecl 0 24972 NULL
+grefs_per_grant_frame_vardecl_grant_table_c_25386_vars grefs_per_grant_frame vardecl_grant-table.c 0 25386 NULL
+num_sg_lists_vardecl_25860_vars num_sg_lists vardecl 0 25860 NULL
+nfsd_drc_max_mem_vardecl_26544_vars nfsd_drc_max_mem vardecl 0 26544 NULL
+unconst_vardecl_lkdtm_usercopy_c_27400_vars unconst vardecl_lkdtm_usercopy.c 0 27400 NULL
+write_buffer_size_vardecl_ldusb_c_29393_vars write_buffer_size vardecl_ldusb.c 0 29393 NULL
+nfakewriters_vardecl_rcutorture_c_30320_vars nfakewriters vardecl_rcutorture.c 0 30320 NULL
+ip_list_hash_size_vardecl_xt_recent_c_30522_vars ip_list_hash_size vardecl_xt_recent.c 0 30522 NULL
+xen_blkif_max_segments_vardecl_xen_blkfront_c_30543_vars xen_blkif_max_segments vardecl_xen-blkfront.c 0 30543 NULL
+DAC960_ControllerCount_vardecl_DAC960_c_31089_vars DAC960_ControllerCount vardecl_DAC960.c 0 31089 NULL
+first_slot_vardecl_cpcihp_generic_c_32129_vars first_slot vardecl_cpcihp_generic.c 0 32129 NULL
+prof_shift_vardecl_profile_c_32143_vars prof_shift vardecl_profile.c 0 32143 NULL
+snd_buf_bytes_vardecl_usbatm_c_32457_vars snd_buf_bytes vardecl_usbatm.c 0 32457 NULL
+num_rcv_urbs_vardecl_usbatm_c_32830_vars num_rcv_urbs vardecl_usbatm.c 0 32830 NULL
+_min_socket_vardecl_x2apic_uv_x_c_33176_vars _min_socket vardecl_x2apic_uv_x.c 0 33176 NULL
+num_ae_requests_vardecl_33594_vars num_ae_requests vardecl 0 33594 NULL
+blkdev_minors_vardecl_dev_c_34365_vars blkdev_minors vardecl_dev.c 0 34365 NULL
+cpu_npartitions_vardecl_linux_cpu_c_34622_vars cpu_npartitions vardecl_linux-cpu.c 0 34622 NULL
+at_max_vardecl_35692_vars at_max vardecl 0 35692 NULL
+mod_num_sdma_vardecl_35721_vars mod_num_sdma vardecl 0 35721 NULL
+nwriters_stress_vardecl_locktorture_c_36080_vars nwriters_stress vardecl_locktorture.c 0 36080 NULL
+sdma_descq_cnt_vardecl_sdma_c_36526_vars sdma_descq_cnt vardecl_sdma.c 0 36526 NULL
+max_sg_segs_vardecl_st_c_36551_vars max_sg_segs vardecl_st.c 0 36551 NULL
+null_major_vardecl_null_blk_c_36718_vars null_major vardecl_null_blk.c 0 36718 NULL
+bufsiz_vardecl_spidev_c_36763_vars bufsiz vardecl_spidev.c 0 36763 NULL
+netdev_flow_limit_table_len_vardecl_36765_vars netdev_flow_limit_table_len vardecl 0 36765 NULL
+uwb_est_size_vardecl_est_c_36881_vars uwb_est_size vardecl_est.c 0 36881 NULL
+ncpus_vardecl_aoecmd_c_37517_vars ncpus vardecl_aoecmd.c 0 37517 NULL
+nrpacks_vardecl_usbusx2yaudio_c_38056_vars nrpacks vardecl_usbusx2yaudio.c 0 38056 NULL
+fb_bpp_vardecl_udl_fb_c_38075_vars fb_bpp vardecl_udl_fb.c 0 38075 NULL
+tcp_metrics_hash_log_vardecl_tcp_metrics_c_38657_vars tcp_metrics_hash_log vardecl_tcp_metrics.c 0 38657 NULL
+max_num_clients_vardecl_ntb_transport_c_38745_vars max_num_clients vardecl_ntb_transport.c 0 38745 NULL
+sg_buffers_vardecl_dmatest_c_38796_vars sg_buffers vardecl_dmatest.c 0 38796 NULL
+pci_ring_size_vardecl_pci_hyperv_c_39161_vars pci_ring_size vardecl_pci-hyperv.c 0 39161 NULL
+sel_start_vardecl_selection_c_39245_vars sel_start vardecl_selection.c 0 39245 NULL
+hash_table_size_vardecl_39253_vars hash_table_size vardecl 0 39253 NULL
+pktdev_major_vardecl_pktcdvd_c_39506_vars pktdev_major vardecl_pktcdvd.c 0 39506 NULL
+defcmd_set_count_vardecl_kdb_main_c_39817_vars defcmd_set_count vardecl_kdb_main.c 0 39817 NULL
+allocation_floor_vardecl_dell_rbu_c_40106_vars allocation_floor vardecl_dell_rbu.c 0 40106 NULL
+memcg_nr_cache_ids_vardecl_40280_vars memcg_nr_cache_ids vardecl 0 40280 NULL
+rose_ndevs_vardecl_af_rose_c_40602_vars rose_ndevs vardecl_af_rose.c 0 40602 NULL
+xprt_tcp_slot_table_entries_vardecl_xprtsock_c_40779_vars xprt_tcp_slot_table_entries vardecl_xprtsock.c 0 40779 NULL
+major_nr_vardecl_umem_c_41471_vars major_nr vardecl_umem.c 0 41471 NULL
+pcpu_unit_pages_vardecl_percpu_c_41525_vars pcpu_unit_pages vardecl_percpu.c 0 41525 NULL
+nr_online_nodes_vardecl_41549_vars nr_online_nodes vardecl 0 41549 NULL
+xp_max_npartitions_vardecl_41728_vars xp_max_npartitions vardecl 0 41728 NULL
+nr_desc_prm_vardecl_hidma_c_42371_vars nr_desc_prm vardecl_hidma.c 0 42371 NULL
+prof_len_vardecl_profile_c_42405_vars prof_len vardecl_profile.c 0 42405 NULL
+amdgpu_vm_block_size_vardecl_42475_vars amdgpu_vm_block_size vardecl 0 42475 NULL
+mtu_max_vardecl_42563_vars mtu_max vardecl 0 42563 NULL
+hfi1_sdma_comp_ring_size_vardecl_user_sdma_c_42743_vars hfi1_sdma_comp_ring_size vardecl_user_sdma.c 0 42743 NULL
+phonet_rxq_size_vardecl_f_phonet_c_43017_vars phonet_rxq_size vardecl_f_phonet.c 0 43017 NULL
+nr_efi_runtime_map_vardecl_runtime_map_c_43216_vars nr_efi_runtime_map vardecl_runtime-map.c 0 43216 NULL
+rds_buf_vardecl_radio_si470x_usb_c_43439_vars rds_buf vardecl_radio-si470x-usb.c 0 43439 NULL
+write_buffer_size_vardecl_legousbtower_c_45062_vars write_buffer_size vardecl_legousbtower.c 0 45062 NULL
+xpc_nasid_mask_nbytes_vardecl_xpc_partition_c_45405_vars xpc_nasid_mask_nbytes vardecl_xpc_partition.c 0 45405 NULL
+num_fault_mutexes_vardecl_hugetlb_c_45857_vars num_fault_mutexes vardecl_hugetlb.c 0 45857 NULL
+qxl_num_crtc_vardecl_46583_vars qxl_num_crtc vardecl 0 46583 NULL
+mc_groups_longs_vardecl_genetlink_c_46774_vars mc_groups_longs vardecl_genetlink.c 0 46774 NULL
+ipoib_recvq_size_vardecl_46904_vars ipoib_recvq_size vardecl 0 46904 NULL
+rds_buf_vardecl_radio_si470x_i2c_c_48053_vars rds_buf vardecl_radio-si470x-i2c.c 0 48053 NULL
+osst_max_dev_vardecl_osst_c_48086_vars osst_max_dev vardecl_osst.c 0 48086 NULL
+ramoops_console_size_vardecl_ram_c_48215_vars ramoops_console_size vardecl_ram.c 0 48215 NULL
+num_requests_vardecl_48964_vars num_requests vardecl 0 48964 NULL
+ff_nr_dev_vardecl_fmc_fakedev_c_49085_vars ff_nr_dev vardecl_fmc-fakedev.c 0 49085 NULL
+nr_ndevs_vardecl_af_netrom_c_49435_vars nr_ndevs vardecl_af_netrom.c 0 49435 NULL
+agg_wsize_vardecl_50735_vars agg_wsize vardecl 0 50735 NULL
+rcv_buf_bytes_vardecl_usbatm_c_51558_vars rcv_buf_bytes vardecl_usbatm.c 0 51558 NULL
+num_var_ranges_vardecl_51769_vars num_var_ranges vardecl 0 51769 NULL
+num_snd_urbs_vardecl_usbatm_c_52685_vars num_snd_urbs vardecl_usbatm.c 0 52685 NULL
+xpc_nasid_mask_nlongs_vardecl_53252_vars xpc_nasid_mask_nlongs vardecl 0 53252 NULL
+CIFSMaxBufSize_vardecl_53372_vars CIFSMaxBufSize vardecl 0 53372 NULL
+ramoops_ecc_vardecl_ram_c_53486_vars ramoops_ecc vardecl_ram.c 0 53486 NULL
+max_dev_vardecl_osst_c_53523_vars max_dev vardecl_osst.c 0 53523 NULL
+dma_txqueue_sz_vardecl_tsi721_dma_c_53597_vars dma_txqueue_sz vardecl_tsi721_dma.c 0 53597 NULL
+ramoops_pmsg_size_vardecl_ram_c_53601_vars ramoops_pmsg_size vardecl_ram.c 0 53601 NULL
+max_data_size_vardecl_hsi_char_c_53736_vars max_data_size vardecl_hsi_char.c 0 53736 NULL
+storvsc_ringbuffer_size_vardecl_storvsc_drv_c_54060_vars storvsc_ringbuffer_size vardecl_storvsc_drv.c 0 54060 NULL
+xprt_udp_slot_table_entries_vardecl_xprtsock_c_56096_vars xprt_udp_slot_table_entries vardecl_xprtsock.c 0 56096 NULL
+test_buf_size_vardecl_dmatest_c_56686_vars test_buf_size vardecl_dmatest.c 0 56686 NULL
+part_shift_vardecl_loop_c_57103_vars part_shift vardecl_loop.c 0 57103 NULL
+nr_cpu_ids_vardecl_57399_vars nr_cpu_ids vardecl 0 57399 NULL
+ql2xmaxqueues_vardecl_57653_vars ql2xmaxqueues vardecl 0 57653 NULL
+mdp_major_vardecl_57774_vars mdp_major vardecl 0 57774 NULL
+acpi_gbl_integer_byte_width_vardecl_58054_vars acpi_gbl_integer_byte_width vardecl 0 58054 NULL
+window_vardecl_tcp_cdg_c_58396_vars window vardecl_tcp_cdg.c 0 58396 NULL
+bufsize_vardecl_tcp_probe_c_58414_vars bufsize vardecl_tcp_probe.c 0 58414 NULL
+ebcnt_vardecl_torturetest_c_58475_vars ebcnt vardecl_torturetest.c 0 58475 NULL
+ramoops_ftrace_size_vardecl_ram_c_58686_vars ramoops_ftrace_size vardecl_ram.c 0 58686 NULL
+pcpu_nr_units_vardecl_percpu_c_59323_vars pcpu_nr_units vardecl_percpu.c 0 59323 NULL
+resultsize_vardecl_floppy_c_59525_vars resultsize vardecl_floppy.c 0 59525 NULL
+perdev_minors_vardecl_block_c_60809_vars perdev_minors vardecl_block.c 0 60809 NULL
+fbcon_softback_size_vardecl_fbcon_c_61184_vars fbcon_softback_size vardecl_fbcon.c 0 61184 NULL
+dm_ring_size_vardecl_hv_balloon_c_63071_vars dm_ring_size vardecl_hv_balloon.c 0 63071 NULL
+_min_pnode_vardecl_x2apic_uv_x_c_63577_vars _min_pnode vardecl_x2apic_uv_x.c 0 63577 NULL
+nbds_max_vardecl_nbd_c_63801_vars nbds_max vardecl_nbd.c 0 63801 NULL
+__max_logical_packages_vardecl_64002_vars __max_logical_packages vardecl 0 64002 NULL
+ubiblock_major_vardecl_block_c_64105_vars ubiblock_major vardecl_block.c 0 64105 NULL
+ff_nr_eeprom_vardecl_fmc_fakedev_c_64224_vars ff_nr_eeprom vardecl_fmc-fakedev.c 0 64224 NULL
+srp_sg_tablesize_vardecl_ib_srp_c_64692_vars srp_sg_tablesize vardecl_ib_srp.c 0 64692 NULL
+wear_eb_count_vardecl_nandsim_c_65291_vars wear_eb_count vardecl_nandsim.c 0 65291 NULL
+max_pfn_vardecl_65317_vars max_pfn vardecl 0 65317 NULL
+fpu_user_xstate_size_vardecl_65370_vars fpu_user_xstate_size vardecl 0 65370 NULL
diff --git b/scripts/gcc-plugins/size_overflow_plugin/generate_size_overflow_hash.sh b/scripts/gcc-plugins/size_overflow_plugin/generate_size_overflow_hash.sh
new file mode 100644
index 000000000..be9724d8e
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/generate_size_overflow_hash.sh
@@ -0,0 +1,103 @@
+#!/bin/bash
+
+# This script generates the hash table (size_overflow_hash.h) for the size_overflow gcc plugin (size_overflow_plugin.c).
+
+header1="size_overflow_hash.h"
+database="size_overflow_hash.data"
+n=65536
+hashtable_name="size_overflow_hash"
+
+usage() {
+cat <<EOF
+usage: $0 options
+OPTIONS:
+        -h|--help               help
+	-o			header file
+	-d			database file
+	-n			hash array size
+	-s			name of the hash table
+EOF
+    return 0
+}
+
+while true
+do
+    case "$1" in
+    -h|--help)	usage && exit 0;;
+    -n)		n=$2; shift 2;;
+    -o)		header1="$2"; shift 2;;
+    -d)		database="$2"; shift 2;;
+    -s)		hashtable_name="$2"; shift 2;;
+    --)		shift 1; break ;;
+     *)		break ;;
+    esac
+done
+
+create_defines() {
+	for i in `seq 0 31`
+	do
+		echo -e "#define PARAM"$i" (1U << "$i")" >> "$header1"
+	done
+	echo >> "$header1"
+}
+
+create_structs() {
+	rm -f "$header1"
+
+	create_defines
+
+	cat "$database" | while read data
+	do
+		data_array=($data)
+		struct_hash_name="${data_array[0]}"
+		funcn="${data_array[1]}"
+		context="${data_array[2]}"
+		params="${data_array[3]}"
+		next="${data_array[5]}"
+
+		echo "const struct size_overflow_hash $struct_hash_name = {" >> "$header1"
+
+		echo -e "\t.next\t= $next,\n\t.name\t= \"$funcn\",\n\t.context\t= \"$context\"," >> "$header1"
+		echo -en "\t.param\t= " >> "$header1"
+		line=
+		for param_num in ${params//-/ };
+		do
+			line="${line}PARAM"$param_num"|"
+		done
+
+		echo -e "${line%?},\n};\n" >> "$header1"
+	done
+}
+
+create_headers() {
+	echo "const struct size_overflow_hash * const $hashtable_name[$n] = {" >> "$header1"
+}
+
+create_array_elements() {
+	index=0
+	grep -v "nohasharray" $database | sort -n -k 5 | while read data
+	do
+		data_array=($data)
+		i="${data_array[4]}"
+		hash="${data_array[0]}"
+		while [[ $index -lt $i ]]
+		do
+			echo -e "\t["$index"]\t= NULL," >> "$header1"
+			index=$(($index + 1))
+		done
+		index=$(($index + 1))
+		echo -e "\t["$i"]\t= &"$hash"," >> "$header1"
+	done
+	echo '};' >> $header1
+}
+
+size_overflow_plugin_dir=`dirname $header1`
+if [ "$size_overflow_plugin_dir" != '.' ]; then
+	mkdir -p "$size_overflow_plugin_dir" 2> /dev/null
+fi
+
+create_structs
+create_headers
+create_array_elements
+
+exit 0
diff --git b/scripts/gcc-plugins/size_overflow_plugin/insert_size_overflow_asm.c b/scripts/gcc-plugins/size_overflow_plugin/insert_size_overflow_asm.c
new file mode 100644
index 000000000..d459e5f15
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/insert_size_overflow_asm.c
@@ -0,0 +1,374 @@
+/*
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+// Data for the size_overflow asm stmt
+struct asm_data {
+	// call or return stmt with our attributes
+	gimple target_stmt;
+	// def_stmt of the marked arg
+	gimple def_stmt;
+	// size_overflow asm rhs
+	tree input;
+	// the output (lhs) of the size_overflow asm is the marked arg
+	tree output;
+	// marked arg number (0 for return values)
+	unsigned int argnum;
+	// intentional mark type
+	enum intentional_mark intentional_mark;
+};
+
+static void __unused print_asm_data(struct asm_data *asm_data)
+{
+	fprintf(stderr, "-----------------------\nprint_asm_data:\n");
+
+	fprintf(stderr, "def_stmt\n");
+	debug_gimple_stmt(asm_data->def_stmt);
+	fprintf(stderr, "target_stmt\n");
+	debug_gimple_stmt(asm_data->target_stmt);
+	fprintf(stderr, "output\n");
+	debug_tree(asm_data->output);
+	fprintf(stderr, "input\n");
+	debug_tree(asm_data->input);
+}
+
+static const char *convert_mark_to_str(enum intentional_mark mark)
+{
+	switch (mark) {
+	case MARK_NO:
+		return OK_ASM_STR;
+	case MARK_YES:
+		return YES_ASM_STR;
+	case MARK_END_INTENTIONAL:
+		return END_INTENTIONAL_ASM_STR;
+	case MARK_TURN_OFF:
+		return TURN_OFF_ASM_STR;
+	}
+	gcc_unreachable();
+}
+
+static char *create_asm_comment(struct asm_data *asm_data, const char *mark_str)
+{
+	const char *fn_name;
+	char *asm_comment;
+	unsigned int len;
+
+	if (gimple_code(asm_data->target_stmt) == GIMPLE_RETURN)
+		fn_name = DECL_NAME_POINTER(current_function_decl);
+	else
+		fn_name = DECL_NAME_POINTER(gimple_call_fndecl(asm_data->target_stmt));
+
+	len = asprintf(&asm_comment, "%s %s %u", mark_str, fn_name, asm_data->argnum);
+	gcc_assert(len > 0);
+
+	return asm_comment;
+}
+
+#if BUILDING_GCC_VERSION <= 4007
+static VEC(tree, gc) *create_asm_io_list(tree string, tree io)
+#else
+static vec<tree, va_gc> *create_asm_io_list(tree string, tree io)
+#endif
+{
+	tree list;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(tree, gc) *vec_list = NULL;
+#else
+	vec<tree, va_gc> *vec_list = NULL;
+#endif
+
+	list = build_tree_list(NULL_TREE, string);
+	list = chainon(NULL_TREE, build_tree_list(list, io));
+#if BUILDING_GCC_VERSION <= 4007
+	VEC_safe_push(tree, gc, vec_list, list);
+#else
+	vec_safe_push(vec_list, list);
+#endif
+	return vec_list;
+}
+
+static void create_so_asm_stmt(struct asm_data *asm_data)
+{
+	char *asm_comment;
+	const char *mark_str;
+	gasm *asm_stmt;
+	gimple_stmt_iterator gsi;
+	tree str_input, str_output;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(tree, gc) *input = NULL, *output = NULL;
+#else
+	vec<tree, va_gc> *input = NULL, *output = NULL;
+#endif
+
+	mark_str = convert_mark_to_str(asm_data->intentional_mark);
+	asm_comment = create_asm_comment(asm_data, mark_str);
+
+	str_input = build_const_char_string(2, "0");
+	input = create_asm_io_list(str_input, asm_data->input);
+	str_output = build_const_char_string(4, "=rm");
+	output = create_asm_io_list(str_output, asm_data->output);
+
+	asm_stmt = as_a_gasm(gimple_build_asm_vec(asm_comment, input, output, NULL, NULL));
+	gimple_asm_set_volatile(asm_stmt, true);
+
+	gsi = gsi_for_stmt(asm_data->def_stmt);
+	gsi_insert_after(&gsi, asm_stmt, GSI_NEW_STMT);
+
+	SSA_NAME_DEF_STMT(asm_data->output) = asm_stmt;
+
+	free(asm_comment);
+}
+
+static void check_size_overflow_asm(struct asm_data *asm_data)
+{
+	enum intentional_mark old_intentional_mark = get_so_asm_type(asm_data->def_stmt);
+
+	if (old_intentional_mark == asm_data->intentional_mark)
+		return;
+	if (asm_data->intentional_mark == MARK_NO)
+		return;
+
+	print_intentional_mark(old_intentional_mark);
+	print_intentional_mark(asm_data->intentional_mark);
+	gcc_unreachable();
+}
+
+static tree get_so_asm_output(struct asm_data *asm_data)
+{
+	gimple stmt = asm_data->target_stmt;
+	unsigned int argnum = asm_data->argnum;
+
+	switch (gimple_code(stmt)) {
+	case GIMPLE_RETURN:
+		gcc_assert(argnum == 0);
+		return gimple_return_retval(as_a_greturn(stmt));
+	case GIMPLE_CALL:
+		gcc_assert(argnum != 0);
+		gcc_assert(gimple_call_num_args(stmt) >= argnum);
+		return gimple_call_arg(stmt, argnum - 1);
+	default:
+		debug_gimple_stmt(stmt);
+		gcc_unreachable();
+	}
+}
+
+static tree get_so_asm_input(struct asm_data *asm_data)
+{
+	gassign *assign;
+	tree output_type, new_var;
+	gimple_stmt_iterator gsi;
+
+	output_type = TREE_TYPE(asm_data->output);
+	new_var = create_new_var(output_type);
+
+	assign = gimple_build_assign(new_var, asm_data->output);
+	gimple_assign_set_lhs(assign, make_ssa_name(new_var, assign));
+
+	gsi = gsi_for_stmt(asm_data->target_stmt);
+	gsi_insert_before(&gsi, assign, GSI_NEW_STMT);
+
+	asm_data->def_stmt = assign;
+
+	new_var = create_new_var(output_type);
+	asm_data->output = make_ssa_name(new_var, asm_data->target_stmt);
+
+	return gimple_assign_lhs(assign);
+}
+
+static void set_so_asm_input_target_stmt(struct asm_data *asm_data)
+{
+	switch (gimple_code(asm_data->target_stmt)) {
+	case GIMPLE_CALL:
+		gimple_call_set_arg(asm_data->target_stmt, asm_data->argnum - 1, asm_data->output);
+		break;
+	case GIMPLE_RETURN:
+		gimple_return_set_retval(as_a_greturn(asm_data->target_stmt), asm_data->output);
+		break;
+	default:
+		debug_gimple_stmt(asm_data->target_stmt);
+		gcc_unreachable();
+	}
+
+	update_stmt(asm_data->def_stmt);
+}
+
+/* This is the gimple part of searching for a missing size_overflow attribute. If the intentional_overflow attribute type
+ * is of the right kind create the appropriate size_overflow asm stmts:
+ *   __asm__("# size_overflow MARK_END_INTENTIONAL" : =rm" D.3344_8 : "0" cicus.4_16);
+ *   __asm__("# size_overflow MARK_NO" : =rm" cicus.4_16 : "0" size_1(D));
+ */
+static void __insert_size_overflow_asm(gimple stmt, unsigned int argnum, enum intentional_mark intentional_mark)
+{
+	struct asm_data asm_data;
+
+	asm_data.target_stmt = stmt;
+	asm_data.argnum = argnum;
+	asm_data.intentional_mark = intentional_mark;
+
+	asm_data.output = get_so_asm_output(&asm_data);
+	if (asm_data.output == NULL_TREE)
+		return;
+	if (is_gimple_constant(asm_data.output))
+		return;
+	if (skip_types(asm_data.output))
+		return;
+
+	asm_data.def_stmt = get_def_stmt(asm_data.output);
+	if (is_size_overflow_asm(asm_data.def_stmt)) {
+		check_size_overflow_asm(&asm_data);
+		return;
+	}
+
+	asm_data.input = get_so_asm_input(&asm_data);
+
+	create_so_asm_stmt(&asm_data);
+	set_so_asm_input_target_stmt(&asm_data);
+
+	update_stmt(asm_data.def_stmt);
+	update_stmt(asm_data.target_stmt);
+}
+
+// Determine the correct arg index and arg and insert the asm stmt to mark the stmt.
+static void insert_so_asm_by_so_attr(gimple stmt, unsigned int orig_argnum)
+{
+	if (orig_argnum == 0 && gimple_code(stmt) == GIMPLE_RETURN) {
+		__insert_size_overflow_asm(stmt, 0, MARK_NO);
+		return;
+	}
+
+	if (orig_argnum != 0 && gimple_code(stmt) == GIMPLE_CALL)
+		__insert_size_overflow_asm(stmt, orig_argnum, MARK_NO);
+}
+
+// If a function arg or the return value is marked by the size_overflow attribute then set its index in the array.
+static void set_argnum_attribute(const_tree attr, bool *argnums)
+{
+	unsigned int argnum;
+	tree attr_value;
+
+	gcc_assert(attr);
+	for (attr_value = TREE_VALUE(attr); attr_value; attr_value = TREE_CHAIN(attr_value)) {
+		argnum = (unsigned int)tree_to_uhwi(TREE_VALUE(attr_value));
+		argnums[argnum] = true;
+	}
+}
+
+// Check whether the arguments are marked by the size_overflow attribute.
+static void search_interesting_so_args(tree fndecl, bool *argnums)
+{
+	const_tree attr;
+
+	attr = get_attribute("size_overflow", fndecl);
+	if (attr)
+		set_argnum_attribute(attr, argnums);
+}
+
+static enum intentional_mark handle_intentional_attr(gimple stmt, unsigned int argnum)
+{
+	enum intentional_mark mark;
+	struct fn_raw_data raw_data;
+
+	mark = check_intentional_attribute(stmt, argnum);
+	if (mark == MARK_NO)
+		return MARK_NO;
+
+	initialize_raw_data(&raw_data);
+	raw_data.num = argnum;
+
+	if (gimple_code(stmt) == GIMPLE_RETURN)
+		raw_data.decl = current_function_decl;
+	else
+		raw_data.decl = gimple_call_fndecl(stmt);
+
+	if (raw_data.decl == NULL_TREE && !get_size_overflow_hash_entry_tree(&raw_data, DISABLE_SIZE_OVERFLOW))
+		return MARK_NO;
+	__insert_size_overflow_asm(stmt, argnum, mark);
+	return mark;
+}
+
+static void handle_size_overflow_attr_ret(greturn *stmt)
+{
+	enum intentional_mark mark;
+	bool orig_argnums[MAX_PARAM + 1] = {false};
+
+	search_interesting_so_args(get_orig_fndecl(current_function_decl), (bool *) &orig_argnums);
+
+	mark = handle_intentional_attr(stmt, 0);
+	if (mark == MARK_NO && orig_argnums[0])
+		insert_so_asm_by_so_attr(stmt, 0);
+}
+
+// If the argument(s) of the callee function are marked by an attribute then mark the call stmt with an asm stmt
+static void handle_size_overflow_attr_call(gcall *stmt)
+{
+	tree fndecl;
+	unsigned int argnum;
+	bool orig_argnums[MAX_PARAM + 1] = {false};
+
+	fndecl = get_interesting_orig_fndecl_from_stmt(stmt);
+	if (fndecl == NULL_TREE)
+		return;
+	if (DECL_BUILT_IN(fndecl))
+		return;
+
+	search_interesting_so_args(fndecl, (bool *) &orig_argnums);
+
+	for (argnum = 1; argnum <= gimple_call_num_args(stmt); argnum++) {
+		enum intentional_mark mark = handle_intentional_attr(stmt, argnum);
+
+		if (mark == MARK_NO && !is_vararg(fndecl, argnum) && orig_argnums[argnum])
+			insert_so_asm_by_so_attr(stmt, argnum);
+	}
+}
+
+// Iterate over all the stmts and search for call stmts and mark them if they have size_overflow attribute
+static unsigned int insert_size_overflow_asm_execute(void)
+{
+	basic_block bb;
+
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			gimple stmt = gsi_stmt(gsi);
+
+			if (is_gimple_call(stmt))
+				handle_size_overflow_attr_call(as_a_gcall(stmt));
+			else if (gimple_code(stmt) == GIMPLE_RETURN)
+				handle_size_overflow_attr_ret(as_a_greturn(stmt));
+		}
+	}
+	return 0;
+}
+
+/*
+ * A lot of functions get inlined before the ipa passes so after the build_ssa gimple pass
+ * this pass inserts asm stmts to mark the interesting args
+ * that the ipa pass will detect and insert the size overflow checks for.
+ */
+
+#define PASS_NAME insert_size_overflow_asm
+
+#define NO_GATE
+
+#define PROPERTIES_REQUIRED PROP_cfg
+#define TODO_FLAGS_FINISH TODO_dump_func | TODO_verify_ssa | TODO_verify_stmts | TODO_remove_unused_locals | TODO_update_ssa_no_phi | TODO_cleanup_cfg | TODO_ggc_collect | TODO_verify_flow
+
+#include "gcc-generate-gimple-pass.h"
diff --git b/scripts/gcc-plugins/size_overflow_plugin/intentional_overflow.c b/scripts/gcc-plugins/size_overflow_plugin/intentional_overflow.c
new file mode 100644
index 000000000..ff572b36b
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/intentional_overflow.c
@@ -0,0 +1,1171 @@
+/*
+ * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+static enum intentional_mark walk_use_def(gimple_set *visited, const_tree lhs);
+
+static const char *get_asm_string(const gasm *stmt)
+{
+	if (stmt)
+		return gimple_asm_string(stmt);
+	return NULL;
+}
+
+tree get_size_overflow_asm_input(const gasm *stmt)
+{
+	gcc_assert(gimple_asm_ninputs(stmt) != 0);
+	return TREE_VALUE(gimple_asm_input_op(stmt, 0));
+}
+
+bool is_size_overflow_insert_check_asm(const gasm *stmt)
+{
+	const char *str;
+
+	if (!is_size_overflow_asm(stmt))
+		return false;
+
+	str = get_asm_string(stmt);
+	if (!str)
+		return false;
+	return !strncmp(str, OK_ASM_STR, sizeof(OK_ASM_STR) - 1);
+}
+
+bool is_size_overflow_asm(const_gimple stmt)
+{
+	const char *str;
+
+	if (!stmt)
+		return false;
+	if (gimple_code(stmt) != GIMPLE_ASM)
+		return false;
+
+	str = get_asm_string(as_a_const_gasm(stmt));
+	if (!str)
+		return false;
+	return !strncmp(str, SO_ASM_STR, sizeof(SO_ASM_STR) - 1);
+}
+
+static bool is_size_overflow_intentional_asm_turn_off(const gasm *stmt)
+{
+	const char *str;
+
+	if (!is_size_overflow_asm(stmt))
+		return false;
+
+	str = get_asm_string(stmt);
+	if (!str)
+		return false;
+	return !strncmp(str, TURN_OFF_ASM_STR, sizeof(TURN_OFF_ASM_STR) - 1);
+}
+
+static bool is_size_overflow_intentional_asm_end(const gasm *stmt)
+{
+	const char *str;
+
+	if (!is_size_overflow_asm(stmt))
+		return false;
+
+	str = get_asm_string(stmt);
+	if (!str)
+		return false;
+	return !strncmp(str, END_INTENTIONAL_ASM_STR, sizeof(END_INTENTIONAL_ASM_STR) - 1);
+}
+
+/* Get the param of the intentional_overflow attribute.
+ *   * 0: MARK_END_INTENTIONAL
+ *   * 1..MAX_PARAM: MARK_YES
+ *   * -1: MARK_TURN_OFF
+ */
+static tree get_attribute_param(const_tree decl)
+{
+	const_tree attr;
+
+	if (decl == NULL_TREE)
+		return NULL_TREE;
+
+	attr = get_attribute("intentional_overflow", decl);
+	if (attr)
+		return TREE_VALUE(attr);
+	return NULL_TREE;
+}
+
+// MARK_TURN_OFF
+static bool is_turn_off_intentional_attr(const_tree decl)
+{
+	const_tree param_head;
+
+	param_head = get_attribute_param(decl);
+	if (param_head == NULL_TREE)
+		return false;
+
+	if (tree_to_shwi(TREE_VALUE(param_head)) == -1)
+		return true;
+	return false;
+}
+
+// MARK_END_INTENTIONAL
+static bool is_end_intentional_intentional_attr(const_tree decl)
+{
+	const_tree param_head;
+
+	param_head = get_attribute_param(decl);
+	if (param_head == NULL_TREE)
+		return false;
+
+	if (tree_to_shwi(TREE_VALUE(param_head)) == 0)
+		return true;
+	return false;
+}
+
+// MARK_YES
+static bool is_yes_intentional_attr(const_tree decl, unsigned int argnum)
+{
+	tree param, param_head;
+
+	if (argnum == 0)
+		return false;
+
+	param_head = get_attribute_param(decl);
+	for (param = param_head; param; param = TREE_CHAIN(param)) {
+		int argval = tree_to_shwi(TREE_VALUE(param));
+
+		if (argval <= 0)
+			continue;
+		if (argnum == (unsigned int)argval)
+			return true;
+	}
+	return false;
+}
+
+static void print_missing_intentional(enum intentional_mark callee_attr, enum intentional_mark caller_attr, tree decl, unsigned int argnum)
+{
+	const struct size_overflow_hash *hash;
+	struct fn_raw_data raw_data;
+//	location_t loc;
+
+	if (caller_attr == MARK_NO || caller_attr == MARK_END_INTENTIONAL || caller_attr == MARK_TURN_OFF)
+		return;
+
+	if (callee_attr == MARK_END_INTENTIONAL || callee_attr == MARK_YES)
+		return;
+
+	initialize_raw_data(&raw_data);
+	raw_data.decl = decl;
+	raw_data.num = argnum;
+	hash = get_size_overflow_hash_entry_tree(&raw_data, SIZE_OVERFLOW);
+	if (!hash)
+		return;
+
+// !!!
+//	loc = DECL_SOURCE_LOCATION(decl);
+//	inform(loc, "The intentional_overflow attribute is missing from +%s+%u+", DECL_NAME_POINTER(decl), argnum);
+}
+
+// Get the field decl of a component ref for intentional_overflow checking
+static const_tree search_field_decl(const_tree comp_ref)
+{
+	const_tree field = NULL_TREE;
+	unsigned int i, len = TREE_OPERAND_LENGTH(comp_ref);
+
+	for (i = 0; i < len; i++) {
+		field = TREE_OPERAND(comp_ref, i);
+		if (TREE_CODE(field) == FIELD_DECL)
+			break;
+	}
+	gcc_assert(TREE_CODE(field) == FIELD_DECL);
+	return field;
+}
+
+/* Get the type of the intentional_overflow attribute of a node
+ *  * MARK_TURN_OFF
+ *  * MARK_YES
+ *  * MARK_NO
+ *  * MARK_END_INTENTIONAL
+ */
+enum intentional_mark get_intentional_attr_type(const_tree node)
+{
+	const_tree cur_decl;
+
+	if (node == NULL_TREE)
+		return MARK_NO;
+
+	switch (TREE_CODE(node)) {
+	case COMPONENT_REF:
+		cur_decl = search_field_decl(node);
+		if (is_turn_off_intentional_attr(cur_decl))
+			return MARK_TURN_OFF;
+		if (is_end_intentional_intentional_attr(cur_decl))
+			return MARK_YES;
+		break;
+	case PARM_DECL: {
+		unsigned int argnum;
+
+		cur_decl = get_orig_fndecl(current_function_decl);
+		argnum = find_arg_number_tree(node, cur_decl);
+		if (argnum == CANNOT_FIND_ARG)
+			return MARK_NO;
+		if (is_yes_intentional_attr(cur_decl, argnum))
+			return MARK_YES;
+		if (is_end_intentional_intentional_attr(cur_decl))
+			return MARK_END_INTENTIONAL;
+		break;
+	}
+	case FUNCTION_DECL: {
+		const_tree fndecl = get_orig_fndecl(node);
+
+		if (is_turn_off_intentional_attr(fndecl))
+			return MARK_TURN_OFF;
+		if (is_end_intentional_intentional_attr(fndecl))
+			return MARK_END_INTENTIONAL;
+		break;
+	}
+	case FIELD_DECL:
+	case VAR_DECL:
+		if (is_end_intentional_intentional_attr(node))
+			return MARK_END_INTENTIONAL;
+		if (is_turn_off_intentional_attr(node))
+			return MARK_TURN_OFF;
+	default:
+		break;
+	}
+	return MARK_NO;
+}
+
+static enum intentional_mark walk_use_def_phi(gimple_set *visited, const_tree result)
+{
+	enum intentional_mark mark = MARK_NO;
+	gphi *phi = as_a_gphi(get_def_stmt(result));
+	unsigned int i, n = gimple_phi_num_args(phi);
+
+	pointer_set_insert(visited, phi);
+	for (i = 0; i < n; i++) {
+		tree arg = gimple_phi_arg_def(phi, i);
+
+		mark = walk_use_def(visited, arg);
+		if (mark != MARK_NO)
+			return mark;
+	}
+
+	return mark;
+}
+
+static enum intentional_mark walk_use_def_binary(gimple_set *visited, const_tree lhs)
+{
+	enum intentional_mark mark;
+	tree rhs1, rhs2;
+	gassign *def_stmt = as_a_gassign(get_def_stmt(lhs));
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs2 = gimple_assign_rhs2(def_stmt);
+
+	mark = walk_use_def(visited, rhs1);
+	if (mark == MARK_NO)
+		return walk_use_def(visited, rhs2);
+	return mark;
+}
+
+enum intentional_mark get_so_asm_type(const_gimple stmt)
+{
+	const gasm *asm_stmt;
+
+	if (!stmt)
+		return MARK_NO;
+	if (!is_size_overflow_asm(stmt))
+		return MARK_NO;
+
+	asm_stmt = as_a_const_gasm(stmt);
+	if (is_size_overflow_insert_check_asm(asm_stmt))
+		return MARK_NO;
+	if (is_size_overflow_intentional_asm_turn_off(asm_stmt))
+		return MARK_TURN_OFF;
+	if (is_size_overflow_intentional_asm_end(asm_stmt))
+		return MARK_END_INTENTIONAL;
+	return MARK_YES;
+}
+
+static enum intentional_mark walk_use_def(gimple_set *visited, const_tree lhs)
+{
+	const_gimple def_stmt;
+
+	if (TREE_CODE(lhs) != SSA_NAME)
+		return get_intentional_attr_type(lhs);
+
+	def_stmt = get_def_stmt(lhs);
+	gcc_assert(def_stmt);
+
+	if (pointer_set_insert(visited, def_stmt))
+		return MARK_NO;
+
+	switch (gimple_code(def_stmt)) {
+	case GIMPLE_CALL:
+	case GIMPLE_RETURN:
+		return MARK_NO;
+	case GIMPLE_NOP:
+		return walk_use_def(visited, SSA_NAME_VAR(lhs));
+	case GIMPLE_ASM:
+		return get_so_asm_type(as_a_const_gasm(def_stmt));
+	case GIMPLE_PHI:
+		return walk_use_def_phi(visited, lhs);
+	case GIMPLE_ASSIGN:
+		switch (gimple_num_ops(def_stmt)) {
+		case 2:
+			return walk_use_def(visited, gimple_assign_rhs1(def_stmt));
+		case 3:
+			return walk_use_def_binary(visited, lhs);
+		}
+	default:
+		debug_gimple_stmt((gimple)def_stmt);
+		error("%s: unknown gimple code", __func__);
+		gcc_unreachable();
+	}
+}
+
+enum intentional_mark check_intentional_size_overflow_asm_and_attribute(const_tree var)
+{
+	enum intentional_mark mark;
+	gimple_set *visited;
+
+	if (is_turn_off_intentional_attr(get_orig_fndecl(current_function_decl)))
+		return MARK_TURN_OFF;
+
+	visited = pointer_set_create();
+	mark = walk_use_def(visited, var);
+	pointer_set_destroy(visited);
+
+	return mark;
+}
+
+/* Search intentional_overflow attribute on caller and on callee too.
+ * -1 / MARK_TURN_OFF: means that overflow checking is turned off inside the function and
+ *                     parameters aren't tracked backwards.
+ * 1..31 / MARK_YES: e.g., 4 means that overflow checking is turned off on the fourth parameter inside
+ *                   the function.
+ * 0 / MARK_END_INTENTIONAL: means that overflow checking is turned off on all the parameters of the function
+ *                           in all callers (on a structure field means that overflow checking is turned off
+ *                           in all expressions involving the given field).
+ */
+enum intentional_mark check_intentional_attribute(const_gimple stmt, unsigned int argnum)
+{
+	enum intentional_mark caller_mark, callee_mark;
+	tree fndecl;
+	const_tree orig_cur_fndecl, arg;
+
+	orig_cur_fndecl = get_orig_fndecl(current_function_decl);
+
+	// handle MARK_TURN_OFF early on the caller
+	if (is_turn_off_intentional_attr(orig_cur_fndecl))
+		return MARK_TURN_OFF;
+	// handle MARK_END_INTENTIONAL on the caller
+	if (is_end_intentional_intentional_attr(orig_cur_fndecl))
+		return MARK_END_INTENTIONAL;
+
+	switch (gimple_code(stmt)) {
+	case GIMPLE_RETURN:
+		gcc_assert(argnum == 0);
+		// for now ignore other intentional attribute types on returns
+		return MARK_NO;
+	case GIMPLE_CALL:
+		gcc_assert(argnum != 0);
+		gcc_assert(argnum <= gimple_call_num_args(stmt));
+		arg = gimple_call_arg(stmt, argnum - 1);
+		break;
+	default:
+		debug_gimple_stmt((gimple)stmt);
+		gcc_unreachable();
+	}
+
+	// XXX ideiglenesen 0-nal a fuggvenyen belul is ki van kapcsolva a dupolas, eddig igy mukodott a doksi ellenere
+	if (is_end_intentional_intentional_attr(orig_cur_fndecl))
+		return MARK_END_INTENTIONAL;
+
+	fndecl = get_interesting_orig_fndecl_from_stmt(as_a_const_gcall(stmt));
+	// handle MARK_TURN_OFF on the callee
+	if (is_turn_off_intentional_attr(fndecl))
+		return MARK_TURN_OFF;
+	// find a defining marked caller argument or struct field for arg
+	caller_mark = check_intentional_size_overflow_asm_and_attribute(arg);
+
+	// did we find a marked struct field?
+	if (caller_mark == MARK_TURN_OFF)
+		return MARK_TURN_OFF;
+
+	// handle MARK_END_INTENTIONAL on the callee
+	if (is_end_intentional_intentional_attr(fndecl))
+		callee_mark = MARK_END_INTENTIONAL;
+	// is it a marked callee parameter?
+	else if (is_yes_intentional_attr(fndecl, argnum))
+		callee_mark = MARK_YES;
+	else
+		callee_mark = MARK_NO;
+
+	// no intentional attribute found
+	if (callee_mark == MARK_NO && caller_mark == MARK_NO)
+		return MARK_NO;
+
+	// MARK_YES is meaningful only on the caller
+	if (caller_mark == MARK_NO && callee_mark == MARK_YES)
+		return MARK_NO;
+
+	// we found a code region where we don't want to duplicate
+	if (caller_mark == MARK_YES && callee_mark == MARK_END_INTENTIONAL)
+		return MARK_END_INTENTIONAL;
+
+	// ignore the intentional attribute on the callee if we didn't find a marked defining argument or struct field
+	if (caller_mark == MARK_NO && callee_mark == MARK_END_INTENTIONAL)
+		return MARK_NO;
+
+	// the callee is missing the intentional attribute (MARK_YES or MARK_END_INTENTIONAL)
+	if (caller_mark == MARK_YES) {
+		print_missing_intentional(callee_mark, caller_mark, fndecl, argnum);
+		return MARK_YES;
+	}
+
+	fprintf(stderr, "caller: %s callee: %s\n", DECL_NAME_POINTER(orig_cur_fndecl), DECL_NAME_POINTER(fndecl));
+	debug_gimple_stmt((gimple)stmt);
+	print_intentional_mark(caller_mark);
+	print_intentional_mark(callee_mark);
+	gcc_unreachable();
+}
+
+bool is_a_cast_and_const_overflow(const_tree no_const_rhs)
+{
+	const_tree rhs1, lhs, rhs1_type, lhs_type;
+	enum machine_mode lhs_mode, rhs_mode;
+	gimple def_stmt = get_def_stmt(no_const_rhs);
+
+	if (!def_stmt || !gimple_assign_cast_p(def_stmt))
+		return false;
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	lhs = gimple_assign_lhs(def_stmt);
+	rhs1_type = TREE_TYPE(rhs1);
+	lhs_type = TREE_TYPE(lhs);
+	rhs_mode = TYPE_MODE(rhs1_type);
+	lhs_mode = TYPE_MODE(lhs_type);
+	if (TYPE_UNSIGNED(lhs_type) == TYPE_UNSIGNED(rhs1_type) || lhs_mode != rhs_mode)
+		return false;
+
+	return true;
+}
+
+static unsigned int uses_num(tree node)
+{
+	imm_use_iterator imm_iter;
+	use_operand_p use_p;
+	unsigned int num = 0;
+
+	FOR_EACH_IMM_USE_FAST(use_p, imm_iter, node) {
+		gimple use_stmt = USE_STMT(use_p);
+
+		if (use_stmt == NULL)
+			return num;
+		if (is_gimple_debug(use_stmt))
+			continue;
+		if (gimple_assign_cast_p(use_stmt) && is_size_overflow_type(gimple_assign_lhs(use_stmt)))
+			continue;
+		num++;
+	}
+	return num;
+}
+
+static bool no_uses(tree node)
+{
+	return !uses_num(node);
+}
+
+// 3.8.5 mm/page-writeback.c __ilog2_u64(): ret, uint + uintmax; uint -> int; int max
+bool is_const_plus_unsigned_signed_truncation(const_tree lhs)
+{
+	tree rhs1, lhs_type, rhs_type, rhs2, not_const_rhs;
+	gimple def_stmt = get_def_stmt(lhs);
+
+	if (!def_stmt || !gimple_assign_cast_p(def_stmt))
+		return false;
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs_type = TREE_TYPE(rhs1);
+	lhs_type = TREE_TYPE(lhs);
+	if (TYPE_UNSIGNED(lhs_type) || !TYPE_UNSIGNED(rhs_type))
+		return false;
+	if (TYPE_MODE(lhs_type) != TYPE_MODE(rhs_type))
+		return false;
+
+	def_stmt = get_def_stmt(rhs1);
+	if (!def_stmt || !is_gimple_assign(def_stmt) || gimple_num_ops(def_stmt) != 3)
+		return false;
+
+	if (gimple_assign_rhs_code(def_stmt) != PLUS_EXPR)
+		return false;
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs2 = gimple_assign_rhs2(def_stmt);
+	if (!is_gimple_constant(rhs1) && !is_gimple_constant(rhs2))
+		return false;
+
+	if (is_gimple_constant(rhs2))
+		not_const_rhs = rhs1;
+	else
+		not_const_rhs = rhs2;
+
+	return no_uses(not_const_rhs);
+}
+
+static bool is_lt_signed_type_max(const_tree rhs)
+{
+	const_tree new_type, type_max, type = TREE_TYPE(rhs);
+
+	if (!TYPE_UNSIGNED(type))
+		return true;
+
+	switch (TYPE_MODE(type)) {
+	case QImode:
+		new_type = intQI_type_node;
+		break;
+	case HImode:
+		new_type = intHI_type_node;
+		break;
+	case SImode:
+		new_type = intSI_type_node;
+		break;
+	case DImode:
+		new_type = intDI_type_node;
+		break;
+	default:
+		debug_tree(type);
+		gcc_unreachable();
+	}
+
+	type_max = TYPE_MAX_VALUE(new_type);
+	if (!tree_int_cst_lt(type_max, rhs))
+		return true;
+
+	return false;
+}
+
+static bool is_gt_zero(const_tree rhs)
+{
+	const_tree type = TREE_TYPE(rhs);
+
+	if (TYPE_UNSIGNED(type))
+		return true;
+
+	if (!tree_int_cst_lt(rhs, integer_zero_node))
+		return true;
+
+	return false;
+}
+
+bool is_a_constant_overflow(const gassign *stmt, const_tree rhs)
+{
+	if (gimple_assign_rhs_code(stmt) == MIN_EXPR)
+		return false;
+	if (!is_gimple_constant(rhs))
+		return false;
+
+	// if the const is between 0 and the max value of the signed type of the same bitsize then there is no intentional overflow
+	if (is_lt_signed_type_max(rhs) && is_gt_zero(rhs))
+		return false;
+
+	return true;
+}
+
+static tree change_assign_rhs(struct visited *visited, gassign *stmt, const_tree orig_rhs, tree new_rhs)
+{
+	const_gimple assign;
+	gimple_stmt_iterator gsi = gsi_for_stmt(stmt);
+	tree origtype = TREE_TYPE(orig_rhs);
+
+	assign = build_cast_stmt(visited, origtype, new_rhs, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	pointer_set_insert(visited->my_stmts, assign);
+	return get_lhs(assign);
+}
+
+tree handle_intentional_overflow(interesting_stmts_t expand_from, bool check_overflow, gassign *stmt, tree change_rhs, tree new_rhs2)
+{
+	tree new_rhs, orig_rhs;
+	void (*gimple_assign_set_rhs)(gimple, tree);
+	tree rhs1 = gimple_assign_rhs1(stmt);
+	tree rhs2 = gimple_assign_rhs2(stmt);
+	tree lhs = gimple_assign_lhs(stmt);
+
+	if (!check_overflow)
+		return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+
+	if (change_rhs == NULL_TREE)
+		return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+
+	if (new_rhs2 == NULL_TREE) {
+		orig_rhs = rhs1;
+		gimple_assign_set_rhs = &gimple_assign_set_rhs1;
+	} else {
+		orig_rhs = rhs2;
+		gimple_assign_set_rhs = &gimple_assign_set_rhs2;
+	}
+
+	check_size_overflow(expand_from, stmt, TREE_TYPE(change_rhs), change_rhs, orig_rhs, BEFORE_STMT);
+
+	new_rhs = change_assign_rhs(expand_from->visited, stmt, orig_rhs, change_rhs);
+	gimple_assign_set_rhs(stmt, new_rhs);
+	update_stmt(stmt);
+
+	return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+}
+
+static bool is_subtraction_special(struct visited *visited, const gassign *stmt)
+{
+	gimple rhs1_def_stmt, rhs2_def_stmt;
+	const_tree rhs1_def_stmt_rhs1, rhs2_def_stmt_rhs1, rhs1_def_stmt_lhs, rhs2_def_stmt_lhs;
+	enum machine_mode rhs1_def_stmt_rhs1_mode, rhs2_def_stmt_rhs1_mode, rhs1_def_stmt_lhs_mode, rhs2_def_stmt_lhs_mode;
+	const_tree rhs1 = gimple_assign_rhs1(stmt);
+	const_tree rhs2 = gimple_assign_rhs2(stmt);
+
+	if (is_gimple_constant(rhs1) || is_gimple_constant(rhs2))
+		return false;
+
+	if (gimple_assign_rhs_code(stmt) != MINUS_EXPR)
+		return false;
+
+	gcc_assert(TREE_CODE(rhs1) == SSA_NAME && TREE_CODE(rhs2) == SSA_NAME);
+
+	rhs1_def_stmt = get_def_stmt(rhs1);
+	rhs2_def_stmt = get_def_stmt(rhs2);
+	if (!gimple_assign_cast_p(rhs1_def_stmt) || !gimple_assign_cast_p(rhs2_def_stmt))
+		return false;
+
+	rhs1_def_stmt_rhs1 = gimple_assign_rhs1(rhs1_def_stmt);
+	rhs2_def_stmt_rhs1 = gimple_assign_rhs1(rhs2_def_stmt);
+	rhs1_def_stmt_lhs = gimple_assign_lhs(rhs1_def_stmt);
+	rhs2_def_stmt_lhs = gimple_assign_lhs(rhs2_def_stmt);
+	rhs1_def_stmt_rhs1_mode = TYPE_MODE(TREE_TYPE(rhs1_def_stmt_rhs1));
+	rhs2_def_stmt_rhs1_mode = TYPE_MODE(TREE_TYPE(rhs2_def_stmt_rhs1));
+	rhs1_def_stmt_lhs_mode = TYPE_MODE(TREE_TYPE(rhs1_def_stmt_lhs));
+	rhs2_def_stmt_lhs_mode = TYPE_MODE(TREE_TYPE(rhs2_def_stmt_lhs));
+	if (GET_MODE_BITSIZE(rhs1_def_stmt_rhs1_mode) <= GET_MODE_BITSIZE(rhs1_def_stmt_lhs_mode))
+		return false;
+	if (GET_MODE_BITSIZE(rhs2_def_stmt_rhs1_mode) <= GET_MODE_BITSIZE(rhs2_def_stmt_lhs_mode))
+		return false;
+
+	pointer_set_insert(visited->no_cast_check, rhs1_def_stmt);
+	pointer_set_insert(visited->no_cast_check, rhs2_def_stmt);
+	return true;
+}
+
+static gassign *create_binary_assign(struct visited *visited, enum tree_code code, gassign *stmt, tree rhs1, tree rhs2)
+{
+	gassign *assign;
+	gimple_stmt_iterator gsi = gsi_for_stmt(stmt);
+	tree type = TREE_TYPE(rhs1);
+	tree lhs = create_new_var(type);
+
+	gcc_assert(types_compatible_p(type, TREE_TYPE(rhs2)));
+	assign = as_a_gassign(gimple_build_assign_with_ops(code, lhs, rhs1, rhs2));
+	gimple_assign_set_lhs(assign, make_ssa_name(lhs, assign));
+
+	gsi_insert_before(&gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+	pointer_set_insert(visited->my_stmts, assign);
+	return assign;
+}
+
+static tree cast_to_TI_type(struct visited *visited, gassign *stmt, tree node)
+{
+	gimple_stmt_iterator gsi;
+	const_gimple cast_stmt;
+	tree type = TREE_TYPE(node);
+
+	if (types_compatible_p(type, intTI_type_node))
+		return node;
+
+	gsi = gsi_for_stmt(stmt);
+	cast_stmt = build_cast_stmt(visited, intTI_type_node, node, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	pointer_set_insert(visited->my_stmts, cast_stmt);
+	return get_lhs(cast_stmt);
+}
+
+static tree get_def_stmt_rhs(struct visited *visited, const_tree var)
+{
+	tree rhs1, def_stmt_rhs1;
+	gimple rhs1_def_stmt, def_stmt_rhs1_def_stmt, def_stmt;
+
+	def_stmt = get_def_stmt(var);
+	if (!gimple_assign_cast_p(def_stmt))
+		return NULL_TREE;
+	gcc_assert(gimple_code(def_stmt) != GIMPLE_NOP && pointer_set_contains(visited->my_stmts, def_stmt) && gimple_assign_cast_p(def_stmt));
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs1_def_stmt = get_def_stmt(rhs1);
+	if (!gimple_assign_cast_p(rhs1_def_stmt))
+		return rhs1;
+
+	def_stmt_rhs1 = gimple_assign_rhs1(rhs1_def_stmt);
+	def_stmt_rhs1_def_stmt = get_def_stmt(def_stmt_rhs1);
+
+	switch (gimple_code(def_stmt_rhs1_def_stmt)) {
+	case GIMPLE_CALL:
+	case GIMPLE_NOP:
+	case GIMPLE_ASM:
+	case GIMPLE_PHI:
+		return def_stmt_rhs1;
+	case GIMPLE_ASSIGN:
+		return rhs1;
+	default:
+		debug_gimple_stmt(def_stmt_rhs1_def_stmt);
+		gcc_unreachable();
+	}
+}
+
+tree handle_integer_truncation(interesting_stmts_t expand_from, const_tree lhs)
+{
+	tree new_rhs1, new_rhs2;
+	tree new_rhs1_def_stmt_rhs1, new_rhs2_def_stmt_rhs1, new_lhs;
+	gassign *assign, *stmt = as_a_gassign(get_def_stmt(lhs));
+	tree rhs1 = gimple_assign_rhs1(stmt);
+	tree rhs2 = gimple_assign_rhs2(stmt);
+
+	if (!is_subtraction_special(expand_from->visited, stmt))
+		return NULL_TREE;
+
+	new_rhs1 = expand(expand_from, rhs1);
+	new_rhs2 = expand(expand_from, rhs2);
+
+	new_rhs1_def_stmt_rhs1 = get_def_stmt_rhs(expand_from->visited, new_rhs1);
+	new_rhs2_def_stmt_rhs1 = get_def_stmt_rhs(expand_from->visited, new_rhs2);
+
+	if (new_rhs1_def_stmt_rhs1 == NULL_TREE || new_rhs2_def_stmt_rhs1 == NULL_TREE)
+		return NULL_TREE;
+
+	if (!types_compatible_p(TREE_TYPE(new_rhs1_def_stmt_rhs1), TREE_TYPE(new_rhs2_def_stmt_rhs1))) {
+		new_rhs1_def_stmt_rhs1 = cast_to_TI_type(expand_from->visited, stmt, new_rhs1_def_stmt_rhs1);
+		new_rhs2_def_stmt_rhs1 = cast_to_TI_type(expand_from->visited, stmt, new_rhs2_def_stmt_rhs1);
+	}
+
+	assign = create_binary_assign(expand_from->visited, MINUS_EXPR, stmt, new_rhs1_def_stmt_rhs1, new_rhs2_def_stmt_rhs1);
+	new_lhs = gimple_assign_lhs(assign);
+	check_size_overflow(expand_from, assign, TREE_TYPE(new_lhs), new_lhs, rhs1, AFTER_STMT);
+
+	return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, new_rhs2, NULL_TREE);
+}
+
+bool is_a_neg_overflow(const gassign *stmt, const_tree rhs)
+{
+	const_gimple def_stmt;
+
+	if (TREE_CODE(rhs) != SSA_NAME)
+		return false;
+
+	if (gimple_assign_rhs_code(stmt) != PLUS_EXPR)
+		return false;
+
+	def_stmt = get_def_stmt(rhs);
+	if (!is_gimple_assign(def_stmt) || gimple_assign_rhs_code(def_stmt) != BIT_NOT_EXPR)
+		return false;
+
+	return true;
+}
+
+/* e.g., drivers/acpi/acpica/utids.c acpi_ut_execute_CID()
+ * ((count - 1) * sizeof(struct acpi_pnp_dee_id_list) -> (count + fffffff) * 16
+ * fffffff * 16 > signed max -> truncate
+ */
+static bool look_for_mult_and_add(const_gimple stmt)
+{
+	const_tree res;
+	tree rhs1, rhs2, def_rhs1, def_rhs2, const_rhs, def_const_rhs;
+	const_gimple def_stmt;
+
+	if (!stmt || gimple_code(stmt) == GIMPLE_NOP)
+		return false;
+	if (!is_gimple_assign(stmt))
+		return false;
+	if (gimple_assign_rhs_code(stmt) != MULT_EXPR)
+		return false;
+
+	rhs1 = gimple_assign_rhs1(stmt);
+	rhs2 = gimple_assign_rhs2(stmt);
+	if (is_gimple_constant(rhs1)) {
+		const_rhs = rhs1;
+		def_stmt = get_def_stmt(rhs2);
+	} else if (is_gimple_constant(rhs2)) {
+		const_rhs = rhs2;
+		def_stmt = get_def_stmt(rhs1);
+	} else
+		return false;
+
+	if (!is_gimple_assign(def_stmt))
+		return false;
+
+	if (gimple_assign_rhs_code(def_stmt) != PLUS_EXPR && gimple_assign_rhs_code(def_stmt) != MINUS_EXPR)
+		return false;
+
+	def_rhs1 = gimple_assign_rhs1(def_stmt);
+	def_rhs2 = gimple_assign_rhs2(def_stmt);
+	if (is_gimple_constant(def_rhs1))
+		def_const_rhs = def_rhs1;
+	else if (is_gimple_constant(def_rhs2))
+		def_const_rhs = def_rhs2;
+	else
+		return false;
+
+	res = fold_binary_loc(gimple_location(def_stmt), MULT_EXPR, TREE_TYPE(const_rhs), const_rhs, def_const_rhs);
+	if (is_lt_signed_type_max(res) && is_gt_zero(res))
+		return false;
+	return true;
+}
+
+enum intentional_overflow_type add_mul_intentional_overflow(const gassign *stmt)
+{
+	const_gimple def_stmt_1, def_stmt_2;
+	const_tree rhs1, rhs2;
+	bool add_mul_rhs1, add_mul_rhs2;
+
+	rhs1 = gimple_assign_rhs1(stmt);
+	def_stmt_1 = get_def_stmt(rhs1);
+	add_mul_rhs1 = look_for_mult_and_add(def_stmt_1);
+
+	rhs2 = gimple_assign_rhs2(stmt);
+	def_stmt_2 = get_def_stmt(rhs2);
+	add_mul_rhs2 = look_for_mult_and_add(def_stmt_2);
+
+	if (add_mul_rhs1)
+		return RHS1_INTENTIONAL_OVERFLOW;
+	if (add_mul_rhs2)
+		return RHS2_INTENTIONAL_OVERFLOW;
+	return NO_INTENTIONAL_OVERFLOW;
+}
+
+static gassign *get_dup_stmt(struct visited *visited, gassign *stmt)
+{
+	gassign *my_stmt;
+	gimple_stmt_iterator gsi = gsi_for_stmt(stmt);
+
+	gsi_next(&gsi);
+	my_stmt = as_a_gassign(gsi_stmt(gsi));
+
+	gcc_assert(pointer_set_contains(visited->my_stmts, my_stmt));
+	if (gimple_assign_cast_p(stmt) && gimple_assign_cast_p(my_stmt))
+		return my_stmt;
+
+	if (gimple_assign_rhs_code(stmt) != gimple_assign_rhs_code(my_stmt)) {
+		fprintf(stderr, "%s != %s\n", get_tree_code_name(gimple_assign_rhs_code(stmt)), get_tree_code_name(gimple_assign_rhs_code(my_stmt)));
+		debug_gimple_stmt(stmt);
+		debug_gimple_stmt(my_stmt);
+		gcc_unreachable();
+	}
+
+	return my_stmt;
+}
+
+/* unsigned type -> unary or binary assign (rhs1 or rhs2 is constant)
+ * unsigned type cast to signed type, unsigned type: no more uses
+ * e.g., lib/vsprintf.c:simple_strtol()
+ * _10 = (unsigned long int) _9
+ * _11 = -_10;
+ * _12 = (long int) _11; (_11_ no more uses)
+ */
+static bool is_call_or_cast(gimple stmt)
+{
+	return gimple_assign_cast_p(stmt) || is_gimple_call(stmt);
+}
+
+static bool is_unsigned_cast_or_call_def_stmt(const_tree node)
+{
+	const_tree rhs;
+	gimple def_stmt;
+
+	if (node == NULL_TREE)
+		return true;
+	if (is_gimple_constant(node))
+		return true;
+
+	def_stmt = get_def_stmt(node);
+	if (!def_stmt)
+		return false;
+
+	if (is_call_or_cast(def_stmt))
+		return true;
+
+	if (!is_gimple_assign(def_stmt) || gimple_num_ops(def_stmt) != 2)
+		return false;
+	rhs = gimple_assign_rhs1(def_stmt);
+	def_stmt = get_def_stmt(rhs);
+	if (!def_stmt)
+		return false;
+	return is_call_or_cast(def_stmt);
+}
+
+void unsigned_signed_cast_intentional_overflow(struct visited *visited, gassign *stmt)
+{
+	unsigned int use_num;
+	gassign *so_stmt;
+	const_gimple def_stmt;
+	const_tree rhs1, rhs2;
+	tree rhs = gimple_assign_rhs1(stmt);
+	tree lhs_type = TREE_TYPE(gimple_assign_lhs(stmt));
+	const_tree rhs_type = TREE_TYPE(rhs);
+
+	if (!(TYPE_UNSIGNED(rhs_type) && !TYPE_UNSIGNED(lhs_type)))
+		return;
+	if (GET_MODE_BITSIZE(TYPE_MODE(rhs_type)) != GET_MODE_BITSIZE(TYPE_MODE(lhs_type)))
+		return;
+	use_num = uses_num(rhs);
+	if (use_num != 1)
+		return;
+
+	def_stmt = get_def_stmt(rhs);
+	if (!def_stmt)
+		return;
+	if (!is_gimple_assign(def_stmt))
+		return;
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	if (!is_unsigned_cast_or_call_def_stmt(rhs1))
+		return;
+
+	rhs2 = gimple_assign_rhs2(def_stmt);
+	if (!is_unsigned_cast_or_call_def_stmt(rhs2))
+		return;
+	if (gimple_num_ops(def_stmt) == 3 && !is_gimple_constant(rhs1) && !is_gimple_constant(rhs2))
+		return;
+
+	so_stmt = get_dup_stmt(visited, stmt);
+	create_up_and_down_cast(visited, so_stmt, lhs_type, gimple_assign_rhs1(so_stmt));
+}
+
+/* gcc intentional overflow
+ * e.g., skb_set_network_header(), skb_set_mac_header()
+ * -, int offset + u16 network_header
+ * offset = -x->props.header_len
+ * skb->network_header += offset;
+ *
+ * SSA
+ * _141 = -_140;
+ * _154 = (short unsigned int) _141;
+ * _155 = (size_overflow_type_SI) _154;
+ * _156 = _154 + _155; // 2x
+ * _157 = (short unsigned int) _156;
+ */
+static bool is_short_cast_neg(const_tree rhs)
+{
+	const_tree cast_rhs;
+	const_gimple neg_stmt;
+	gimple neg_cast_stmt, cast_stmt = get_def_stmt(rhs);
+
+	if (!cast_stmt || !gimple_assign_cast_p(cast_stmt))
+		return false;
+
+	cast_rhs = gimple_assign_rhs1(cast_stmt);
+	if (GET_MODE_BITSIZE(TYPE_MODE(TREE_TYPE(cast_rhs))) >= GET_MODE_BITSIZE(TYPE_MODE(TREE_TYPE(rhs))))
+		return false;
+
+	neg_cast_stmt = get_def_stmt(cast_rhs);
+	if (!neg_cast_stmt || !gimple_assign_cast_p(neg_cast_stmt))
+		return false;
+
+	neg_stmt = get_def_stmt(gimple_assign_rhs1(neg_cast_stmt));
+	if (!neg_stmt || !is_gimple_assign(neg_stmt))
+		return false;
+	return gimple_assign_rhs_code(neg_stmt) == NEGATE_EXPR;
+}
+
+static bool check_add_stmt(const_tree node)
+{
+	const_gimple add_stmt;
+	const_tree add_rhs1, add_rhs2;
+
+	if (node == NULL_TREE)
+		return false;
+
+	add_stmt = get_def_stmt(node);
+	if (!add_stmt || !is_gimple_assign(add_stmt) || gimple_assign_rhs_code(add_stmt) != PLUS_EXPR)
+		return false;
+
+	add_rhs1 = gimple_assign_rhs1(add_stmt);
+	add_rhs2 = gimple_assign_rhs2(add_stmt);
+	return is_short_cast_neg(add_rhs1) || is_short_cast_neg(add_rhs2);
+}
+
+bool neg_short_add_intentional_overflow(gassign *unary_stmt)
+{
+	const_tree rhs1, add_rhs1, add_rhs2, cast_rhs;
+	gimple cast_stmt;
+	const_gimple add_stmt;
+
+	rhs1 = gimple_assign_rhs1(unary_stmt);
+
+	cast_stmt = get_def_stmt(rhs1);
+	if (!cast_stmt || !gimple_assign_cast_p(cast_stmt))
+		return false;
+	cast_rhs = gimple_assign_rhs1(cast_stmt);
+	if (GET_MODE_BITSIZE(TYPE_MODE(TREE_TYPE(cast_rhs))) <= GET_MODE_BITSIZE(TYPE_MODE(TREE_TYPE(rhs1))))
+		return false;
+
+	// one or two plus expressions
+	if (check_add_stmt(cast_rhs))
+		return true;
+
+	add_stmt = get_def_stmt(cast_rhs);
+	if (!add_stmt || !is_gimple_assign(add_stmt))
+		return false;
+	add_rhs1 = gimple_assign_rhs1(add_stmt);
+	if (check_add_stmt(add_rhs1))
+		return true;
+	add_rhs2 = gimple_assign_rhs2(add_stmt);
+	return check_add_stmt(add_rhs2);
+}
+
+/* True:
+ * _25 = (<unnamed-unsigned:1>) _24;
+ * r_5(D)->stereo = _25;
+ */
+bool is_bitfield_unnamed_cast(const_tree decl, gassign *assign)
+{
+	const_tree rhs, type;
+	gimple def_stmt;
+
+	if (TREE_CODE(decl) != FIELD_DECL)
+		return false;
+	if (!DECL_BIT_FIELD_TYPE(decl))
+		return false;
+	if (gimple_num_ops(assign) != 2)
+		return false;
+
+	rhs = gimple_assign_rhs1(assign);
+	if (is_gimple_constant(rhs))
+		return false;
+	type = TREE_TYPE(rhs);
+	if (TREE_CODE(type) == BOOLEAN_TYPE)
+		return false;
+
+	def_stmt = get_def_stmt(rhs);
+	if (!gimple_assign_cast_p(def_stmt))
+		return false;
+	return TYPE_PRECISION(type) < CHAR_TYPE_SIZE;
+}
+
+static bool is_mult_const(const_tree lhs)
+{
+	const_gimple def_stmt;
+	const_tree rhs1, rhs2;
+
+	def_stmt = get_def_stmt(lhs);
+	if (!def_stmt || !is_gimple_assign(def_stmt) || gimple_assign_rhs_code(def_stmt) != MULT_EXPR)
+		return false;
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs2 = gimple_assign_rhs2(def_stmt);
+	if (is_gimple_constant(rhs1))
+		return !is_lt_signed_type_max(rhs1);
+	else if (is_gimple_constant(rhs2))
+		return !is_lt_signed_type_max(rhs2);
+	return false;
+}
+
+/* True:
+ * fs/cifs/file.c cifs_write_from_iter()
+ * u32 = u64 - (u64 - constant) * constant
+ * wdata->tailsz = cur_len - (nr_pages - 1) * PAGE_SIZE;
+ *
+ * _51 = _50 * 4294963200;
+ * _52 = _49 + _51;
+ * _53 = _52 + 4096;
+ */
+
+bool uconst_neg_intentional_overflow(const gassign *stmt)
+{
+	const_gimple def_stmt;
+	const_tree noconst_rhs;
+	tree rhs1, rhs2;
+
+	// _53 = _52 + const;
+	if (gimple_assign_rhs_code(stmt) != PLUS_EXPR)
+		return false;
+	rhs1 = gimple_assign_rhs1(stmt);
+	rhs2 = gimple_assign_rhs2(stmt);
+	if (is_gimple_constant(rhs1))
+		noconst_rhs = rhs2;
+	else if (is_gimple_constant(rhs2))
+		noconst_rhs = rhs1;
+	else
+		return false;
+	def_stmt = get_def_stmt(noconst_rhs);
+
+	// _52 = _49 + _51;
+	if (!def_stmt)
+		return false;
+	if (!is_gimple_assign(def_stmt))
+		return false;
+	if (gimple_assign_rhs_code(def_stmt) != PLUS_EXPR)
+		return false;
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs2 = gimple_assign_rhs2(def_stmt);
+	if (is_gimple_constant(rhs1) || is_gimple_constant(rhs2))
+		return false;
+
+	// _51 = _50 * gt signed type max;
+	return is_mult_const(rhs1) || is_mult_const(rhs2);
+}
+
+/* True:
+ * drivers/net/ethernet/via/via-velocity.c velocity_rx_refill()
+ * u16 = cpu_to_le16(s32) | const
+ * rd->size = cpu_to_le16(vptr->rx.buf_sz) | RX_INTEN;
+ *
+ * _36 = (signed short) _35;
+ * _37 = _36 | -32768;
+ * _38 = (short unsigned int) _37;
+ */
+
+bool short_or_neg_const_ushort(gassign *stmt)
+{
+	const_tree rhs, lhs_type, rhs_type;
+	const_tree def_rhs1, def_rhs2;
+	const_gimple def_stmt;
+	gimple def_def_stmt = NULL;
+
+	if (!gimple_assign_cast_p(stmt))
+		return false;
+
+	// _38 = (short unsigned int) _37;
+	lhs_type = TREE_TYPE(gimple_assign_lhs(stmt));
+	if (!TYPE_UNSIGNED(lhs_type))
+		return false;
+	if (TYPE_MODE(lhs_type) != HImode)
+		return false;
+	rhs = gimple_assign_rhs1(stmt);
+	rhs_type = TREE_TYPE(rhs);
+	if (TYPE_UNSIGNED(rhs_type))
+		return false;
+	if (TYPE_MODE(rhs_type) != HImode)
+		return false;
+
+	// _37 = _36 | -32768;
+	def_stmt = get_def_stmt(rhs);
+	if (!def_stmt || !is_gimple_assign(def_stmt) || gimple_assign_rhs_code(def_stmt) != BIT_IOR_EXPR)
+		return false;
+	def_rhs1 = gimple_assign_rhs1(def_stmt);
+	def_rhs2 = gimple_assign_rhs2(def_stmt);
+	if (is_gimple_constant(def_rhs1) && !is_gt_zero(def_rhs1))
+		def_def_stmt = get_def_stmt(def_rhs2);
+	else if (is_gimple_constant(def_rhs2) && !is_gt_zero(def_rhs2))
+		def_def_stmt = get_def_stmt(def_rhs1);
+
+	// _36 = (signed short) _35;
+	return def_def_stmt && gimple_assign_cast_p(def_def_stmt);
+}
diff --git b/scripts/gcc-plugins/size_overflow_plugin/remove_unnecessary_dup.c b/scripts/gcc-plugins/size_overflow_plugin/remove_unnecessary_dup.c
new file mode 100644
index 000000000..5ea5f35cb
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/remove_unnecessary_dup.c
@@ -0,0 +1,137 @@
+/*
+ * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+bool skip_expr_on_double_type(const gassign *stmt)
+{
+	enum tree_code code = gimple_assign_rhs_code(stmt);
+
+	switch (code) {
+	case RSHIFT_EXPR:
+	case TRUNC_DIV_EXPR:
+	case CEIL_DIV_EXPR:
+	case FLOOR_DIV_EXPR:
+	case ROUND_DIV_EXPR:
+	case EXACT_DIV_EXPR:
+	case RDIV_EXPR:
+	case TRUNC_MOD_EXPR:
+	case CEIL_MOD_EXPR:
+	case FLOOR_MOD_EXPR:
+	case ROUND_MOD_EXPR:
+		return true;
+	default:
+		return false;
+	}
+}
+
+void create_up_and_down_cast(struct visited *visited, gassign *use_stmt, tree orig_type, tree rhs)
+{
+	const_tree orig_rhs1;
+	tree down_lhs, new_lhs, dup_type = TREE_TYPE(rhs);
+	const_gimple down_cast, up_cast;
+	gimple_stmt_iterator gsi = gsi_for_stmt(use_stmt);
+
+	down_cast = build_cast_stmt(visited, orig_type, rhs, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	down_lhs = get_lhs(down_cast);
+
+	gsi = gsi_for_stmt(use_stmt);
+	up_cast = build_cast_stmt(visited, dup_type, down_lhs, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	new_lhs = get_lhs(up_cast);
+
+	orig_rhs1 = gimple_assign_rhs1(use_stmt);
+	if (operand_equal_p(orig_rhs1, rhs, 0))
+		gimple_assign_set_rhs1(use_stmt, new_lhs);
+	else
+		gimple_assign_set_rhs2(use_stmt, new_lhs);
+	update_stmt(use_stmt);
+
+	pointer_set_insert(visited->my_stmts, up_cast);
+	pointer_set_insert(visited->my_stmts, down_cast);
+	pointer_set_insert(visited->skip_expr_casts, up_cast);
+	pointer_set_insert(visited->skip_expr_casts, down_cast);
+}
+
+static tree get_proper_unsigned_half_type(const_tree node)
+{
+	tree new_type, type;
+
+	gcc_assert(is_size_overflow_type(node));
+
+	type = TREE_TYPE(node);
+	switch (TYPE_MODE(type)) {
+	case HImode:
+		new_type = unsigned_intQI_type_node;
+		break;
+	case SImode:
+		new_type = unsigned_intHI_type_node;
+		break;
+	case DImode:
+		new_type = unsigned_intSI_type_node;
+		break;
+	case TImode:
+		new_type = unsigned_intDI_type_node;
+		break;
+	default:
+		gcc_unreachable();
+	}
+
+	if (TYPE_QUALS(type) != 0)
+		return build_qualified_type(new_type, TYPE_QUALS(type));
+	return new_type;
+}
+
+static void insert_cast_rhs(struct visited *visited, gassign *stmt, tree rhs)
+{
+	tree type;
+
+	if (rhs == NULL_TREE)
+		return;
+	if (!is_size_overflow_type(rhs))
+		return;
+
+	type = get_proper_unsigned_half_type(rhs);
+	if (is_gimple_constant(rhs))
+		return;
+	create_up_and_down_cast(visited, stmt, type, rhs);
+}
+
+static void insert_cast(struct visited *visited, gassign *stmt, tree rhs)
+{
+	if (LONG_TYPE_SIZE == GET_MODE_BITSIZE(SImode) && !is_size_overflow_type(rhs))
+		return;
+	gcc_assert(is_size_overflow_type(rhs));
+	insert_cast_rhs(visited, stmt, rhs);
+}
+
+void insert_cast_expr(struct visited *visited, gassign *stmt, enum intentional_overflow_type type)
+{
+	tree rhs1, rhs2;
+
+	if (type == NO_INTENTIONAL_OVERFLOW || type == RHS1_INTENTIONAL_OVERFLOW) {
+		rhs1 = gimple_assign_rhs1(stmt);
+		insert_cast(visited, stmt, rhs1);
+	}
+
+	if (type == NO_INTENTIONAL_OVERFLOW || type == RHS2_INTENTIONAL_OVERFLOW) {
+		rhs2 = gimple_assign_rhs2(stmt);
+		insert_cast(visited, stmt, rhs2);
+	}
+}
+
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow.h b/scripts/gcc-plugins/size_overflow_plugin/size_overflow.h
new file mode 100644
index 000000000..6ab03351b
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow.h
@@ -0,0 +1,345 @@
+#ifndef SIZE_OVERFLOW_H
+#define SIZE_OVERFLOW_H
+
+#define CREATE_NEW_VAR NULL_TREE
+#define MAX_PARAM 31
+#define CANNOT_FIND_ARG 32
+#define NONE_ARGNUM 32
+
+#define BEFORE_STMT true
+#define AFTER_STMT false
+
+#define TURN_OFF_ASM_STR "# size_overflow MARK_TURN_OFF "
+#define YES_ASM_STR "# size_overflow MARK_YES "
+#define END_INTENTIONAL_ASM_STR "# size_overflow MARK_END_INTENTIONAL "
+#define SO_ASM_STR "# size_overflow "
+#define OK_ASM_STR "# size_overflow MARK_NO"
+
+#define FUNCTION_PTR_P(node) \
+	(TREE_CODE(TREE_TYPE(node)) == POINTER_TYPE && (TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == FUNCTION_TYPE || TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == METHOD_TYPE))
+
+#define CODES_LIMIT 32
+
+#define GLOBAL_NIFN_LEN 65536
+#define NO_HASH 65537
+
+#define SIZE_OVERFLOW true
+#define DISABLE_SIZE_OVERFLOW false
+
+#include "gcc-common.h"
+
+#include <string.h>
+#include <limits.h>
+
+enum intentional_mark {
+	MARK_NO, MARK_YES, MARK_END_INTENTIONAL, MARK_TURN_OFF
+};
+
+enum intentional_overflow_type {
+	NO_INTENTIONAL_OVERFLOW, RHS1_INTENTIONAL_OVERFLOW, RHS2_INTENTIONAL_OVERFLOW
+};
+
+enum size_overflow_mark {
+	NO_SO_MARK, YES_SO_MARK, ASM_STMT_SO_MARK
+};
+
+struct decl_hash {
+	size_t tree_codes_len;
+	unsigned char tree_codes[CODES_LIMIT];
+	const_tree decl;
+	const char *context;
+	unsigned int hash;
+	const char *fn_name;
+};
+
+struct next_interesting_function;
+typedef struct next_interesting_function *  next_interesting_function_t;
+
+struct interesting_stmts;
+typedef struct interesting_stmts * interesting_stmts_t;
+
+enum based_decl {
+	SO_FUNCTION, SO_VAR, SO_FIELD, SO_FUNCTION_POINTER, SO_AUX, SO_DISABLE, SO_NONE
+};
+
+// Store data associated with the next_interesting_function_t entry
+struct fn_raw_data
+{
+	const char *decl_str;
+	tree decl;
+	const char *context;
+	unsigned int hash;
+	unsigned int num;
+	enum size_overflow_mark marked;
+	enum based_decl based_decl;
+	const char *orig_decl_str;
+	unsigned int orig_num;
+};
+
+#if BUILDING_GCC_VERSION <= 4007
+DEF_VEC_P(next_interesting_function_t);
+DEF_VEC_ALLOC_P(next_interesting_function_t, heap);
+#endif
+
+#if BUILDING_GCC_VERSION >= 5000
+typedef struct hash_set<const_gimple> gimple_set;
+
+static inline bool pointer_set_insert(gimple_set *visited, const_gimple stmt)
+{
+	return visited->add(stmt);
+}
+
+static inline bool pointer_set_contains(gimple_set *visited, const_gimple stmt)
+{
+	return visited->contains(stmt);
+}
+
+static inline gimple_set* pointer_set_create(void)
+{
+	return new hash_set<const_gimple>;
+}
+
+static inline void pointer_set_destroy(gimple_set *visited)
+{
+	delete visited;
+}
+
+typedef struct hash_set<next_interesting_function_t> next_interesting_function_set;
+
+static inline bool pointer_set_insert(next_interesting_function_set *visited, next_interesting_function_t node)
+{
+	return visited->add(node);
+}
+
+static inline bool pointer_set_contains(next_interesting_function_set *visited, next_interesting_function_t node)
+{
+	return visited->contains(node);
+}
+
+static inline next_interesting_function_set *next_interesting_function_pointer_set_create(void)
+{
+	return new hash_set<next_interesting_function_t>;
+}
+
+static inline void pointer_set_destroy(next_interesting_function_set *visited)
+{
+	delete visited;
+}
+#else
+typedef struct pointer_set_t gimple_set;
+typedef struct pointer_set_t next_interesting_function_set;
+
+static inline next_interesting_function_set *next_interesting_function_pointer_set_create(void)
+{
+	return pointer_set_create();
+}
+#endif
+
+struct visited {
+	gimple_set *stmts;
+	gimple_set *my_stmts;
+	gimple_set *skip_expr_casts;
+	gimple_set *no_cast_check;
+};
+
+/*
+ *  * children: callers with data flow into the integer parameter of decl
+ *  * decl_name: name of the function or the field
+ *  * context: the containing type name for a function pointer (or "fielddecl" if the type has no name), otherwise either "vardecl" or "fndecl"
+ *  * hash: hash num of the function
+ *  * num: parameter number (1-31) or return value (0)
+ *  * marked: determines whether to duplicate stmts and/or look for missing hashtable entries
+ *  * orig_next_node: pointer to the originally cloned function
+ */
+
+struct next_interesting_function {
+	next_interesting_function_t next;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(next_interesting_function_t, heap) *children;
+#else
+	vec<next_interesting_function_t, va_heap, vl_embed> *children;
+#endif
+	const char *decl_name;
+	const char *context;
+	enum based_decl based_decl;
+	unsigned int hash;
+	unsigned int num;
+	enum size_overflow_mark marked;
+	next_interesting_function_t orig_next_node;
+};
+
+// size_overflow_plugin.c
+extern tree report_size_overflow_decl;
+extern tree size_overflow_type_HI;
+extern tree size_overflow_type_SI;
+extern tree size_overflow_type_DI;
+extern tree size_overflow_type_TI;
+// command line options
+extern bool check_fields, check_fns, check_fnptrs, check_vars;
+
+
+// size_overflow_plugin_hash.c
+struct size_overflow_hash {
+	const struct size_overflow_hash * const next;
+	const char * const name;
+	const char * const context;
+	const unsigned int param;
+};
+
+extern const char *get_orig_decl_name(const_tree decl);
+extern bool is_size_overflow_asm(const_gimple stmt);
+extern void print_missing_function(next_interesting_function_t node);
+extern const struct size_overflow_hash *get_size_overflow_hash_entry(struct fn_raw_data *raw_data);
+extern const struct size_overflow_hash *get_size_overflow_hash_entry_tree(struct fn_raw_data *raw_data, bool hash_table);
+extern unsigned int find_arg_number_tree(const_tree arg, const_tree func);
+extern unsigned int get_decl_hash(const_tree decl, const char *decl_name);
+extern const char *get_based_decl_str(enum based_decl based_decl);
+extern void initialize_raw_data(struct fn_raw_data *raw_data);
+
+
+// intentional_overflow.c
+extern enum intentional_mark get_intentional_attr_type(const_tree node);
+extern tree get_size_overflow_asm_input(const gasm *stmt);
+extern enum intentional_mark check_intentional_size_overflow_asm_and_attribute(const_tree var);
+extern bool is_size_overflow_insert_check_asm(const gasm *stmt);
+extern enum intentional_mark check_intentional_attribute(const_gimple stmt, unsigned int argnum);
+extern enum intentional_mark get_so_asm_type(const_gimple stmt);
+extern const_tree get_attribute(const char* attr_name, const_tree decl);
+extern bool is_a_cast_and_const_overflow(const_tree no_const_rhs);
+extern bool is_const_plus_unsigned_signed_truncation(const_tree lhs);
+extern bool is_a_constant_overflow(const gassign *stmt, const_tree rhs);
+extern tree handle_intentional_overflow(interesting_stmts_t expand_from, bool check_overflow, gassign *stmt, tree change_rhs, tree new_rhs2);
+extern tree handle_integer_truncation(interesting_stmts_t expand_from, const_tree lhs);
+extern bool is_a_neg_overflow(const gassign *stmt, const_tree rhs);
+extern enum intentional_overflow_type add_mul_intentional_overflow(const gassign *stmt);
+extern void unsigned_signed_cast_intentional_overflow(struct visited *visited, gassign *stmt);
+extern bool neg_short_add_intentional_overflow(gassign *stmt);
+extern bool is_bitfield_unnamed_cast(const_tree decl, gassign *assign);
+extern bool uconst_neg_intentional_overflow(const gassign *stmt);
+extern bool short_or_neg_const_ushort(gassign *stmt);
+
+
+// insert_size_overflow_asm.c
+#if BUILDING_GCC_VERSION >= 4009
+extern opt_pass *make_insert_size_overflow_asm_pass(void);
+#else
+extern struct opt_pass *make_insert_size_overflow_asm_pass(void);
+#endif
+extern bool search_interesting_args(tree fndecl, bool *argnums);
+
+
+// size_overflow_misc.c
+extern bool is_vararg(const_tree fn, unsigned int num);
+extern tree get_ref_field(const_tree ref);
+extern unsigned int get_correct_argnum_fndecl(const_tree fndecl, const_tree correct_argnum_of_fndecl, unsigned int num);
+extern const char *get_type_name_from_field(const_tree field_decl);
+extern void set_dominance_info(void);
+extern void unset_dominance_info(void);
+extern tree get_interesting_orig_fndecl_from_stmt(const gcall *stmt);
+extern tree get_orig_fndecl(const_tree clone_fndecl);
+extern unsigned int get_correct_argnum(const_tree decl, const_tree correct_argnum_of_decl, unsigned int argnum);
+extern bool is_valid_cgraph_node(struct cgraph_node *node);
+extern void set_current_function_decl(tree fndecl);
+extern void unset_current_function_decl(void);
+extern gimple get_def_stmt(const_tree node);
+extern tree create_new_var(tree type);
+extern gimple build_cast_stmt(struct visited *visited, tree dst_type, tree rhs, tree lhs, gimple_stmt_iterator *gsi, bool before, bool force);
+extern bool skip_types(const_tree var);
+extern tree cast_a_tree(tree type, tree var);
+extern bool is_size_overflow_type(const_tree var);
+extern bool made_by_compiler(const_tree decl);
+extern gimple get_fnptr_def_stmt(const_tree fn_ptr);
+extern tree get_lhs(const_gimple stmt);
+
+
+// size_overflow_transform.c
+struct interesting_stmts {
+	struct interesting_stmts *next;
+	next_interesting_function_t next_node;
+	gimple first_stmt;
+	tree orig_node;
+	unsigned int num;
+	struct visited *visited;
+};
+
+extern unsigned int size_overflow_function_transform(struct cgraph_node *node);
+extern tree handle_fnptr_assign(const_gimple stmt);
+
+
+// size_overflow_transform_core.c
+extern tree cast_to_new_size_overflow_type(struct visited *visited, gimple stmt, tree rhs, tree size_overflow_type, bool before);
+extern tree get_size_overflow_type(struct visited *visited, const_gimple stmt, const_tree node);
+extern tree expand(interesting_stmts_t expand_from, tree lhs);
+extern void check_size_overflow(interesting_stmts_t expand_from, gimple stmt, tree size_overflow_type, tree cast_rhs, tree rhs, bool before);
+extern tree dup_assign(struct visited *visited, gassign *oldstmt, const_tree node, tree rhs1, tree rhs2, tree __unused rhs3);
+extern tree create_assign(struct visited *visited, gimple oldstmt, tree rhs1, bool before);
+
+
+// remove_unnecessary_dup.c
+extern struct opt_pass *make_remove_unnecessary_dup_pass(void);
+extern void insert_cast_expr(struct visited *visited, gassign *stmt, enum intentional_overflow_type type);
+extern bool skip_expr_on_double_type(const gassign *stmt);
+extern void create_up_and_down_cast(struct visited *visited, gassign *use_stmt, tree orig_type, tree rhs);
+
+
+// size_overflow_ipa.c
+struct walk_use_def_data {
+	next_interesting_function_t parent;
+	next_interesting_function_t next_cnodes_head;
+	gimple_set *visited;
+};
+
+extern const char* get_decl_context(const_tree decl);
+extern void add_to_global_next_interesting_function(next_interesting_function_t new_entry);
+extern bool has_next_interesting_function_vec(next_interesting_function_t target, next_interesting_function_t next_node);
+extern void push_child(next_interesting_function_t parent, next_interesting_function_t child);
+extern struct cgraph_node *get_cnode(const_tree fndecl);
+extern next_interesting_function_t global_next_interesting_function[GLOBAL_NIFN_LEN];
+extern next_interesting_function_t get_global_next_interesting_function_entry(struct fn_raw_data *raw_data);
+extern next_interesting_function_t get_global_next_interesting_function_entry_with_hash(struct fn_raw_data *raw_data);
+extern void size_overflow_register_hooks(void);
+#if BUILDING_GCC_VERSION >= 4009
+extern opt_pass *make_size_overflow_pass(void);
+#else
+extern struct opt_pass *make_size_overflow_pass(void);
+#endif
+extern void size_overflow_node_removal_hook(struct cgraph_node *node, void *data);
+extern next_interesting_function_t get_and_create_next_node_from_global_next_nodes(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+extern next_interesting_function_t create_new_next_interesting_decl(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+extern next_interesting_function_t create_new_next_interesting_entry(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+
+
+// size_overflow_lto.c
+extern void size_overflow_read_summary(void);
+extern void size_overflow_read_optimization_summary(void);
+#if BUILDING_GCC_VERSION >= 4008
+extern void size_overflow_write_summary(void);
+extern void size_overflow_write_optimization_summary(void);
+#elif BUILDING_GCC_VERSION >= 4006
+extern void size_overflow_write_summary(cgraph_node_set set, varpool_node_set vset);
+extern void size_overflow_write_optimization_summary(cgraph_node_set set, varpool_node_set vset);
+#else
+extern void size_overflow_write_summary(cgraph_node_set set);
+extern void size_overflow_write_optimization_summary(cgraph_node_set set);
+#endif
+
+// size_overflow_fnptrs.c
+extern void handle_function_ptr_ret(struct walk_use_def_data *use_def_data, const_tree fn_ptr);
+extern void check_local_variables(next_interesting_function_t next_node);
+extern void check_global_variables(next_interesting_function_t cur_global);
+extern next_interesting_function_t get_and_create_next_node_from_global_next_nodes_fnptr(const_tree fn_ptr, struct fn_raw_data *raw_data);
+
+
+// size_overflow_debug.c
+extern void __unused print_intentional_mark(enum intentional_mark mark);
+extern unsigned int __unused size_overflow_dump_function(FILE *file, struct cgraph_node *node);
+extern void __unused print_next_interesting_functions_chain(next_interesting_function_t head, bool only_this);
+extern void __unused print_global_next_interesting_functions(void);
+extern void __unused print_children_chain_list(next_interesting_function_t next_node);
+extern void __unused print_all_next_node_children_chain_list(next_interesting_function_t next_node);
+extern const char * __unused print_so_mark_name(enum size_overflow_mark mark);
+extern const char * __unused print_intentional_mark_name(enum intentional_mark mark);
+extern void __unused print_next_interesting_function(next_interesting_function_t node);
+extern void __unused print_raw_data(struct fn_raw_data *data);
+
+#endif
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_debug.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_debug.c
new file mode 100644
index 000000000..663b6c9a1
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_debug.c
@@ -0,0 +1,201 @@
+/*
+ * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+void __unused print_intentional_mark(enum intentional_mark mark)
+{
+	fprintf(stderr, "intentional mark: ");
+	switch (mark) {
+	case MARK_NO:
+		fprintf(stderr, "mark_no\n");
+		break;
+	case MARK_YES:
+		fprintf(stderr, "mark_yes\n");
+		break;
+	case MARK_TURN_OFF:
+		fprintf(stderr, "mark_turn_off\n");
+		break;
+	case MARK_END_INTENTIONAL:
+		fprintf(stderr, "mark_end_intentional\n");
+		break;
+	}
+}
+
+unsigned int __unused size_overflow_dump_function(FILE *file, struct cgraph_node *node)
+{
+	basic_block bb;
+
+	fprintf(file, "dump_function function_name: %s\n", cgraph_node_name(node));
+
+	fprintf(file, "\nstmts:\n");
+	FOR_EACH_BB_FN(bb, DECL_STRUCT_FUNCTION(NODE_DECL(node))) {
+		gimple_stmt_iterator si;
+
+		fprintf(file, "<bb %u>:\n", bb->index);
+		for (si = gsi_start_phis(bb); !gsi_end_p(si); gsi_next(&si))
+			print_gimple_stmt(file, gsi_stmt(si), 0, TDF_VOPS|TDF_MEMSYMS);
+		for (si = gsi_start_bb(bb); !gsi_end_p(si); gsi_next(&si))
+			print_gimple_stmt(file, gsi_stmt(si), 0, TDF_VOPS|TDF_MEMSYMS);
+		fprintf(file, "\n");
+	}
+
+	fprintf(file, "---------------------------------\n");
+
+	return 0;
+}
+
+void __unused print_next_interesting_function(next_interesting_function_t node)
+{
+	unsigned int i, children_len;
+	next_interesting_function_t cur;
+
+	if (!node)
+		return;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, node->children))
+		children_len = 0;
+	else
+		children_len = VEC_length(next_interesting_function_t, node->children);
+#else
+	children_len = vec_safe_length(node->children);
+#endif
+
+	fprintf(stderr, "print_next_interesting_function: ptr: %p, ", node);
+	fprintf(stderr, "decl_name: %s, based_decl: %s, ", node->decl_name, get_based_decl_str(node->based_decl));
+
+	fprintf(stderr, "num: %u marked: %s context: %s children len: %u\n", node->num, print_so_mark_name(node->marked), node->context, children_len);
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, node->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, node->children, i, cur) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(node->children, i, cur) {
+#endif
+		fprintf(stderr, "\t%u. child: %s %u %p marked: %s context: %s\n", i + 1, cur->decl_name, cur->num, cur, print_so_mark_name(cur->marked), cur->context);
+	}
+}
+
+// Dump the full next_interesting_function_t list for parsing by print_dependecy.py
+void __unused print_next_interesting_functions_chain(next_interesting_function_t head, bool only_this)
+{
+	next_interesting_function_t cur;
+	unsigned int len;
+
+	fprintf(stderr, "----------------------\nnext_interesting_function_t head: %p\n", head);
+	for (cur = head, len = 0; cur; cur = cur->next, len++) {
+		fprintf(stderr, "%u. ", len + 1);
+		print_next_interesting_function(cur);
+
+		fprintf(stderr, "+++++ has orig node: %p +++++\n", cur->orig_next_node);
+		print_next_interesting_function(cur->orig_next_node);
+
+		if (only_this)
+			break;
+	}
+
+	fprintf(stderr, "len: %u\n----------------------\n\n\n", len + 1);
+}
+
+void __unused print_global_next_interesting_functions(void)
+{
+	unsigned int i;
+
+	fprintf(stderr, "----------------------\nprint_global_next_interesting_functions:\n----------------------\n");
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		if (!global_next_interesting_function[i])
+			continue;
+		fprintf(stderr, "hash: %u\n", i);
+		print_next_interesting_functions_chain(global_next_interesting_function[i], false);
+	}
+	fprintf(stderr, "----------------------\n\n");
+}
+
+// Dump the information related to the specified next_interesting_function_t for parsing by print_dependecy.py
+void __unused print_children_chain_list(next_interesting_function_t next_node)
+{
+	next_interesting_function_t cur;
+	unsigned int i;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, next_node->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, next_node->children, i, cur) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(next_node->children, i, cur) {
+#endif
+		fprintf(stderr, "parent: %s %u (marked: %s) child: %s %u\n", next_node->decl_name, next_node->num, print_so_mark_name(next_node->marked), cur->decl_name, cur->num);
+		print_children_chain_list(cur);
+	}
+}
+
+void __unused print_all_next_node_children_chain_list(next_interesting_function_t head)
+{
+	next_interesting_function_t cur;
+
+	for (cur = head; cur; cur = cur->next) {
+#if BUILDING_GCC_VERSION <= 4007
+		if (VEC_empty(next_interesting_function_t, cur->children))
+#else
+		if (vec_safe_length(cur->children) == 0)
+#endif
+			continue;
+		fprintf(stderr, "############ START ############\n");
+		print_children_chain_list(cur);
+		fprintf(stderr, "############ END ############\n");
+	}
+}
+
+const char * __unused print_intentional_mark_name(enum intentional_mark mark)
+{
+	switch(mark) {
+	case MARK_NO:
+		return "mark no";
+	case MARK_YES:
+		return "mark yes";
+	case MARK_END_INTENTIONAL:
+		return "mark end intetional";
+	case MARK_TURN_OFF:
+		return "mark turn off";
+	}
+
+	gcc_unreachable();
+}
+
+const char * __unused print_so_mark_name(enum size_overflow_mark mark)
+{
+	switch(mark) {
+	case ASM_STMT_SO_MARK:
+		return "asm_stmt_so_mark";
+	case YES_SO_MARK:
+		return "yes_so_mark";
+	case NO_SO_MARK:
+		return "no_so_mark";
+	}
+
+	gcc_unreachable();
+}
+
+void __unused print_raw_data(struct fn_raw_data *data)
+{
+	fprintf(stderr, "decl_str: %s, context: %s, num: %u, hash: %u\ndecl:\n", data->decl_str ? data->decl_str : "NULL", data->context ? data->context : "NULL", data->num, data->hash);
+	debug_tree(data->decl);
+	fprintf(stderr, "marked: %s, based_decl: %s\norig_decl_str: %s, orig_num: %u\n", print_so_mark_name(data->marked), get_based_decl_str(data->based_decl), data->orig_decl_str? data->orig_decl_str : "NULL", data->orig_num);
+}
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_ipa.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_ipa.c
new file mode 100644
index 000000000..1fe86f353
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_ipa.c
@@ -0,0 +1,1333 @@
+/*
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+#include <libgen.h>
+
+static void walk_use_def_next_functions(struct walk_use_def_data *use_def_data, tree lhs);
+
+next_interesting_function_t global_next_interesting_function[GLOBAL_NIFN_LEN];
+static bool global_changed;
+
+static struct cgraph_node_hook_list *function_insertion_hook_holder;
+static struct cgraph_2node_hook_list *node_duplication_hook_holder;
+
+struct cgraph_node *get_cnode(const_tree fndecl)
+{
+	gcc_assert(TREE_CODE(fndecl) == FUNCTION_DECL);
+#if BUILDING_GCC_VERSION <= 4005
+	return cgraph_get_node(CONST_CAST_TREE(fndecl));
+#else
+	return cgraph_get_node(fndecl);
+#endif
+}
+
+static bool compare_next_interesting_functions(next_interesting_function_t cur_node, const char *decl_name, const char *context, unsigned int num)
+{
+	// Ignore num without a value
+	if (num != NONE_ARGNUM && cur_node->num != num)
+		return false;
+	if (strcmp(cur_node->context, context))
+		return false;
+	return !strcmp(cur_node->decl_name, decl_name);
+}
+
+// Return the context of vardecl. If it is in a file scope then the context is vardecl_filebasename
+static const char* get_vardecl_context(const_tree decl)
+{
+	expanded_location xloc;
+	char *buf, *path;
+	const char *bname;
+	int len;
+
+	xloc = expand_location(DECL_SOURCE_LOCATION(decl));
+	gcc_assert(xloc.file);
+	path = xstrdup(xloc.file);
+	bname = basename(path);
+
+	len = asprintf(&buf, "vardecl_%s", bname);
+	gcc_assert(len > 0);
+	return buf;
+}
+
+// Return the type name for a function pointer (or "fielddecl" if the type has no name), otherwise either "vardecl" or "fndecl"
+const char* get_decl_context(const_tree decl)
+{
+	switch (TREE_CODE(decl)) {
+	case FUNCTION_DECL:
+		return "fndecl";
+		// TODO: Ignore anonymous types for now
+	case FIELD_DECL:
+		return get_type_name_from_field(decl);
+	case VAR_DECL:
+		if (TREE_PUBLIC(decl) || DECL_EXTERNAL(decl))
+			return "vardecl";
+		if (TREE_STATIC(decl) && !TREE_PUBLIC(decl))
+			return get_vardecl_context(decl);
+		// ignore local variable
+		if (!TREE_STATIC(decl) && !DECL_EXTERNAL(decl))
+			return NULL;
+	default:
+		debug_tree(decl);
+		gcc_unreachable();
+	}
+}
+
+// Find the function with the specified argument in the list
+next_interesting_function_t get_global_next_interesting_function_entry(struct fn_raw_data *raw_data)
+{
+	next_interesting_function_t cur_node, head;
+
+	gcc_assert(raw_data->hash != NO_HASH);
+	gcc_assert(raw_data->decl_str);
+	gcc_assert(raw_data->context);
+
+	head = global_next_interesting_function[raw_data->hash];
+	for (cur_node = head; cur_node; cur_node = cur_node->next) {
+		if (raw_data->marked != ASM_STMT_SO_MARK && cur_node->marked == ASM_STMT_SO_MARK)
+			continue;
+		if (compare_next_interesting_functions(cur_node, raw_data->decl_str, raw_data->context, raw_data->num))
+			return cur_node;
+	}
+	return NULL;
+}
+
+next_interesting_function_t get_global_next_interesting_function_entry_with_hash(struct fn_raw_data *raw_data)
+{
+	gcc_assert(raw_data->decl != NULL_TREE);
+	gcc_assert(raw_data->decl_str);
+
+	raw_data->hash = get_decl_hash(raw_data->decl, raw_data->decl_str);
+	if (raw_data->hash == NO_HASH)
+		return NULL;
+
+	if (!raw_data->context)
+		raw_data->context = get_decl_context(raw_data->decl);
+	if (!raw_data->context)
+		return NULL;
+	return get_global_next_interesting_function_entry(raw_data);
+}
+
+next_interesting_function_t create_new_next_interesting_entry(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node)
+{
+	next_interesting_function_t new_node;
+
+	gcc_assert(raw_data->decl_str);
+	gcc_assert(raw_data->context);
+	gcc_assert(raw_data->hash != NO_HASH);
+	gcc_assert(raw_data->num != NONE_ARGNUM);
+	gcc_assert(raw_data->based_decl != SO_NONE);
+
+	new_node = (next_interesting_function_t)xmalloc(sizeof(*new_node));
+	new_node->decl_name = xstrdup(raw_data->decl_str);
+
+	gcc_assert(raw_data->context);
+	new_node->context = xstrdup(raw_data->context);
+	new_node->hash = raw_data->hash;
+	new_node->num = raw_data->num;
+	new_node->next = NULL;
+	new_node->children = NULL;
+	new_node->marked = raw_data->marked;
+	new_node->orig_next_node = orig_next_node;
+	new_node->based_decl = raw_data->based_decl;
+
+	return new_node;
+}
+
+// Ignore these functions to not explode coverage (+strncmp+fndecl+3+35130+)
+static bool temporary_skip_these_functions(struct fn_raw_data *raw_data)
+{
+	gcc_assert(raw_data->hash != NO_HASH);
+	gcc_assert(raw_data->decl_str);
+
+	if (raw_data->hash == 35130 && !strcmp(raw_data->decl_str, "strncmp"))
+		return true;
+	if (raw_data->hash == 46193 && !strcmp(raw_data->decl_str, "strnlen"))
+		return true;
+	if (raw_data->hash == 43267 && !strcmp(raw_data->decl_str, "strncpy"))
+		return true;
+	if (raw_data->hash == 10300 && !strcmp(raw_data->decl_str, "strncpy_from_user"))
+		return true;
+	if (raw_data->hash == 26117 && !strcmp(raw_data->decl_str, "memchr"))
+		return true;
+	if (raw_data->hash == 16203 && !strcmp(raw_data->decl_str, "memchr_inv"))
+		return true;
+	if (raw_data->hash == 24269 && !strcmp(raw_data->decl_str, "memcmp"))
+		return true;
+	if (raw_data->hash == 60390 && !strcmp(raw_data->decl_str, "memcpy"))
+		return true;
+	if (raw_data->hash == 25040 && !strcmp(raw_data->decl_str, "memmove"))
+		return true;
+	if (raw_data->hash == 29763 && !strcmp(raw_data->decl_str, "memset"))
+		return true;
+	return false;
+}
+
+// Create the main data structure
+next_interesting_function_t create_new_next_interesting_decl(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node)
+{
+	enum tree_code decl_code;
+
+	if (raw_data->num == NONE_ARGNUM)
+		return NULL;
+
+	gcc_assert(raw_data->decl != NULL_TREE);
+	gcc_assert(raw_data->num != NONE_ARGNUM);
+	gcc_assert(raw_data->decl_str);
+
+	decl_code = TREE_CODE(raw_data->decl);
+
+	gcc_assert(decl_code == FIELD_DECL || decl_code == FUNCTION_DECL || decl_code == VAR_DECL);
+
+	if (is_vararg(raw_data->decl, raw_data->num))
+		return NULL;
+
+	raw_data->hash = get_decl_hash(raw_data->decl, raw_data->decl_str);
+	if (raw_data->hash == NO_HASH)
+		return NULL;
+
+	if (get_size_overflow_hash_entry_tree(raw_data, DISABLE_SIZE_OVERFLOW))
+		return NULL;
+	if (temporary_skip_these_functions(raw_data))
+		return NULL;
+
+	gcc_assert(raw_data->num <= MAX_PARAM);
+	// Clones must have an orig_next_node
+	gcc_assert(!made_by_compiler(raw_data->decl) || orig_next_node);
+
+	raw_data->context = get_decl_context(raw_data->decl);
+	if (!raw_data->context)
+		return NULL;
+
+	return create_new_next_interesting_entry(raw_data, orig_next_node);
+}
+
+void add_to_global_next_interesting_function(next_interesting_function_t new_entry)
+{
+	next_interesting_function_t cur_global_head, cur_global, cur_global_end = NULL;
+
+	// new_entry is appended to the end of a list
+	new_entry->next = NULL;
+
+	cur_global_head = global_next_interesting_function[new_entry->hash];
+	if (!cur_global_head) {
+		global_next_interesting_function[new_entry->hash] = new_entry;
+		return;
+	}
+
+
+	for (cur_global = cur_global_head; cur_global; cur_global = cur_global->next) {
+		if (!cur_global->next)
+			cur_global_end = cur_global;
+
+		if (compare_next_interesting_functions(cur_global, new_entry->decl_name, new_entry->context, new_entry->num))
+			return;
+	}
+
+	gcc_assert(cur_global_end);
+	cur_global_end->next = new_entry;
+}
+
+/* If the interesting function is a clone then find or create its original next_interesting_function_t node
+ * and add it to global_next_interesting_function
+ */
+static next_interesting_function_t create_orig_next_node_for_a_clone(struct fn_raw_data *clone_raw_data)
+{
+	struct fn_raw_data orig_raw_data;
+	next_interesting_function_t orig_next_node;
+	enum tree_code decl_code;
+
+	gcc_assert(clone_raw_data->decl != NULL_TREE);
+	gcc_assert(clone_raw_data->num != NONE_ARGNUM);
+	gcc_assert(clone_raw_data->based_decl != SO_NONE);
+
+	initialize_raw_data(&orig_raw_data);
+	orig_raw_data.decl = get_orig_fndecl(clone_raw_data->decl);
+
+	if (DECL_BUILT_IN(orig_raw_data.decl) || DECL_BUILT_IN_CLASS(orig_raw_data.decl) == BUILT_IN_NORMAL)
+		return NULL;
+
+	if (made_by_compiler(orig_raw_data.decl))
+		return NULL;
+
+	decl_code = TREE_CODE(orig_raw_data.decl);
+	if (decl_code == FIELD_DECL || decl_code == VAR_DECL)
+		orig_raw_data.num = clone_raw_data->num;
+	else
+		orig_raw_data.num = get_correct_argnum(clone_raw_data->decl, orig_raw_data.decl, clone_raw_data->num);
+
+	// Skip over ISRA.162 parm decls
+	if (orig_raw_data.num == CANNOT_FIND_ARG)
+		return NULL;
+
+	orig_raw_data.decl_str = get_orig_decl_name(orig_raw_data.decl);
+	orig_raw_data.marked = NO_SO_MARK;
+	orig_next_node = get_global_next_interesting_function_entry_with_hash(&orig_raw_data);
+	if (orig_next_node)
+		return orig_next_node;
+
+	orig_raw_data.marked = clone_raw_data->marked;
+	orig_raw_data.based_decl = clone_raw_data->based_decl;
+	orig_next_node = create_new_next_interesting_decl(&orig_raw_data, NULL);
+	if (!orig_next_node)
+		return NULL;
+
+	add_to_global_next_interesting_function(orig_next_node);
+	return orig_next_node;
+}
+
+// Find or create the next_interesting_function_t node for decl and num
+next_interesting_function_t get_and_create_next_node_from_global_next_nodes(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node)
+{
+	next_interesting_function_t cur_next_cnode;
+
+	gcc_assert(raw_data->decl != NULL_TREE);
+
+	if (DECL_NAME(raw_data->decl) == NULL_TREE)
+		return NULL;
+
+	raw_data->decl_str = DECL_NAME_POINTER(raw_data->decl);
+
+	cur_next_cnode = get_global_next_interesting_function_entry_with_hash(raw_data);
+	if (cur_next_cnode)
+		goto out;
+
+	if (!orig_next_node && made_by_compiler(raw_data->decl)) {
+		orig_next_node = create_orig_next_node_for_a_clone(raw_data);
+		if (!orig_next_node)
+			return NULL;
+	}
+
+	cur_next_cnode = create_new_next_interesting_decl(raw_data, orig_next_node);
+	if (!cur_next_cnode)
+		return NULL;
+
+	add_to_global_next_interesting_function(cur_next_cnode);
+out:
+	if (cur_next_cnode->marked != raw_data->marked && cur_next_cnode->marked != NO_SO_MARK)
+		return cur_next_cnode;
+
+	if (raw_data->marked != NO_SO_MARK && cur_next_cnode->marked == NO_SO_MARK)
+		cur_next_cnode->marked = raw_data->marked;
+
+	return cur_next_cnode;
+}
+
+static bool has_next_interesting_function_chain_node(next_interesting_function_t next_cnodes_head, struct fn_raw_data *raw_data)
+{
+	next_interesting_function_t cur_node;
+
+	gcc_assert(!raw_data->context);
+
+	gcc_assert(raw_data->decl_str);
+	gcc_assert(raw_data->decl != NULL_TREE);
+	gcc_assert(raw_data->num != NONE_ARGNUM);
+
+	raw_data->context = get_decl_context(raw_data->decl);
+	// Ignore function if there is no context
+	if (!raw_data->context)
+		return true;
+
+	for (cur_node = next_cnodes_head; cur_node; cur_node = cur_node->next) {
+		if (compare_next_interesting_functions(cur_node, raw_data->decl_str, raw_data->context, raw_data->num))
+			return true;
+	}
+	return false;
+}
+
+static void handle_function(struct walk_use_def_data *use_def_data, tree fndecl, const_tree arg)
+{
+	struct fn_raw_data raw_data;
+	next_interesting_function_t orig_next_node, new_node;
+
+	gcc_assert(fndecl != NULL_TREE);
+
+	// ignore builtins to not explode coverage (e.g., memcpy)
+	if (DECL_BUILT_IN(fndecl) || DECL_BUILT_IN_CLASS(fndecl) == BUILT_IN_NORMAL)
+		return;
+
+	if (get_intentional_attr_type(fndecl) == MARK_TURN_OFF)
+		return;
+
+	initialize_raw_data(&raw_data);
+	raw_data.decl = fndecl;
+	raw_data.based_decl = SO_FUNCTION;
+	raw_data.decl_str = DECL_NAME_POINTER(fndecl);
+	raw_data.marked = NO_SO_MARK;
+
+	// convert arg into its position
+	if (arg == NULL_TREE)
+		raw_data.num = 0;
+	else
+		raw_data.num = find_arg_number_tree(arg, raw_data.decl);
+	if (raw_data.num == CANNOT_FIND_ARG)
+		return;
+
+	if (has_next_interesting_function_chain_node(use_def_data->next_cnodes_head, &raw_data))
+		return;
+
+	if (made_by_compiler(raw_data.decl)) {
+		orig_next_node = create_orig_next_node_for_a_clone(&raw_data);
+		if (!orig_next_node)
+			return;
+	} else
+		orig_next_node = NULL;
+
+	new_node = create_new_next_interesting_decl(&raw_data, orig_next_node);
+	if (!new_node)
+		return;
+	new_node->next = use_def_data->next_cnodes_head;
+	use_def_data->next_cnodes_head = new_node;
+}
+
+static void walk_use_def_next_functions_phi(struct walk_use_def_data *use_def_data, const_tree result)
+{
+	gphi *phi = as_a_gphi(get_def_stmt(result));
+	unsigned int i, n = gimple_phi_num_args(phi);
+
+	pointer_set_insert(use_def_data->visited, phi);
+	for (i = 0; i < n; i++) {
+		tree arg = gimple_phi_arg_def(phi, i);
+
+		walk_use_def_next_functions(use_def_data, arg);
+	}
+}
+
+static void walk_use_def_next_functions_binary(struct walk_use_def_data *use_def_data, const_tree lhs)
+{
+	gassign *def_stmt = as_a_gassign(get_def_stmt(lhs));
+	tree rhs1, rhs2;
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs2 = gimple_assign_rhs2(def_stmt);
+
+	walk_use_def_next_functions(use_def_data, rhs1);
+	walk_use_def_next_functions(use_def_data, rhs2);
+}
+
+static void walk_use_def_next_functions_unary(struct walk_use_def_data *use_def_data, const gassign *stmt)
+{
+	tree rhs1 = gimple_assign_rhs1(stmt);
+
+	walk_use_def_next_functions(use_def_data, rhs1);
+}
+
+void __attribute__((weak)) handle_function_ptr_ret(struct walk_use_def_data *use_def_data __unused, const_tree fn_ptr __unused)
+{
+}
+
+static void create_and_append_new_next_interesting_field_var_decl(struct walk_use_def_data *use_def_data, struct fn_raw_data *raw_data)
+{
+	next_interesting_function_t new_node;
+
+	if (raw_data->decl == NULL_TREE)
+		return;
+
+	if (DECL_NAME(raw_data->decl) == NULL_TREE)
+		return;
+
+	gcc_assert(!raw_data->decl_str);
+	gcc_assert(raw_data->num == NONE_ARGNUM);
+
+	raw_data->decl_str = DECL_NAME_POINTER(raw_data->decl);
+	raw_data->num = 0;
+	raw_data->marked = NO_SO_MARK;
+
+	new_node = create_new_next_interesting_decl(raw_data, NULL);
+	if (!new_node)
+		return;
+	new_node->next = use_def_data->next_cnodes_head;
+	use_def_data->next_cnodes_head = new_node;
+}
+
+static void handle_struct_fields(struct walk_use_def_data *use_def_data, const_tree node)
+{
+	struct fn_raw_data raw_data;
+
+	initialize_raw_data(&raw_data);
+
+	switch (TREE_CODE(node)) {
+	case ARRAY_REF:
+#if BUILDING_GCC_VERSION >= 4006
+	case MEM_REF:
+#endif
+	case INDIRECT_REF:
+	case COMPONENT_REF:
+		raw_data.decl = get_ref_field(node);
+		raw_data.based_decl = SO_FIELD;
+		break;
+	// TODO
+	case BIT_FIELD_REF:
+	case VIEW_CONVERT_EXPR:
+	case REALPART_EXPR:
+	case IMAGPART_EXPR:
+		return;
+	default:
+		debug_tree(node);
+		gcc_unreachable();
+	}
+
+	if (get_intentional_attr_type(raw_data.decl) == MARK_TURN_OFF)
+		return;
+
+	create_and_append_new_next_interesting_field_var_decl(use_def_data, &raw_data);
+}
+
+static void handle_vardecl(struct walk_use_def_data *use_def_data, tree node)
+{
+	struct fn_raw_data raw_data;
+
+	initialize_raw_data(&raw_data);
+
+	raw_data.decl = node;
+	raw_data.based_decl = SO_VAR;
+	create_and_append_new_next_interesting_field_var_decl(use_def_data, &raw_data);
+}
+
+/* Find all functions that influence lhs
+ *
+ * Encountered functions are added to the children vector (next_interesting_function_t).
+ */
+static void walk_use_def_next_functions(struct walk_use_def_data *use_def_data, tree lhs)
+{
+	enum tree_code code;
+	const_gimple def_stmt;
+
+	if (skip_types(lhs))
+		return;
+
+	if (VAR_P(lhs)) {
+		handle_vardecl(use_def_data, lhs);
+		return;
+	}
+
+	code = TREE_CODE(lhs);
+	if (code == PARM_DECL) {
+		handle_function(use_def_data, current_function_decl, lhs);
+		return;
+	}
+
+	if (TREE_CODE_CLASS(code) == tcc_reference) {
+		handle_struct_fields(use_def_data, lhs);
+		return;
+	}
+
+	if (code != SSA_NAME)
+		return;
+
+	def_stmt = get_def_stmt(lhs);
+	if (!def_stmt)
+		return;
+
+	if (pointer_set_insert(use_def_data->visited, def_stmt))
+		return;
+
+	switch (gimple_code(def_stmt)) {
+	case GIMPLE_NOP:
+		walk_use_def_next_functions(use_def_data, SSA_NAME_VAR(lhs));
+		return;
+	case GIMPLE_ASM:
+		if (!is_size_overflow_asm(def_stmt))
+			return;
+		walk_use_def_next_functions(use_def_data, get_size_overflow_asm_input(as_a_const_gasm(def_stmt)));
+		return;
+	case GIMPLE_CALL: {
+		tree fndecl = gimple_call_fndecl(def_stmt);
+
+		if (fndecl != NULL_TREE) {
+			handle_function(use_def_data, fndecl, NULL_TREE);
+			return;
+		}
+		fndecl = gimple_call_fn(def_stmt);
+		handle_function_ptr_ret(use_def_data, fndecl);
+		return;
+	}
+	case GIMPLE_PHI:
+		walk_use_def_next_functions_phi(use_def_data, lhs);
+		return;
+	case GIMPLE_ASSIGN:
+		switch (gimple_num_ops(def_stmt)) {
+		case 2:
+			walk_use_def_next_functions_unary(use_def_data, as_a_const_gassign(def_stmt));
+			return;
+		case 3:
+			walk_use_def_next_functions_binary(use_def_data, lhs);
+			return;
+		}
+	default:
+		debug_gimple_stmt((gimple)def_stmt);
+		error("%s: unknown gimple code", __func__);
+		gcc_unreachable();
+	}
+}
+
+// Start the search for next_interesting_function_t children based on the (next_interesting_function_t) parent node
+static next_interesting_function_t search_next_functions(tree node, next_interesting_function_t parent)
+{
+	struct walk_use_def_data use_def_data;
+
+	use_def_data.parent = parent;
+	use_def_data.next_cnodes_head = NULL;
+	use_def_data.visited = pointer_set_create();
+
+	walk_use_def_next_functions(&use_def_data, node);
+
+	pointer_set_destroy(use_def_data.visited);
+	return use_def_data.next_cnodes_head;
+}
+
+// True if child already exists in the next_interesting_function_t children vector
+bool has_next_interesting_function_vec(next_interesting_function_t target, next_interesting_function_t next_node)
+{
+	unsigned int i;
+	next_interesting_function_t cur;
+
+	gcc_assert(next_node);
+	// handle recursion
+	if (!strcmp(target->decl_name, next_node->decl_name) && target->num == next_node->num)
+		return true;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, target->children))
+		return false;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, target->children, i, cur) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(target->children, i, cur) {
+#endif
+		if (compare_next_interesting_functions(cur, next_node->decl_name, next_node->context, next_node->num))
+			return true;
+	}
+	return false;
+}
+
+void push_child(next_interesting_function_t parent, next_interesting_function_t child)
+{
+	if (!has_next_interesting_function_vec(parent, child)) {
+#if BUILDING_GCC_VERSION <= 4007
+		VEC_safe_push(next_interesting_function_t, heap, parent->children, child);
+#else
+		vec_safe_push(parent->children, child);
+#endif
+	}
+}
+
+void __attribute__((weak)) check_local_variables(next_interesting_function_t next_node __unused) {}
+
+// Add children to parent and global_next_interesting_function
+static void collect_data_for_execute(next_interesting_function_t parent, next_interesting_function_t children)
+{
+	next_interesting_function_t cur = children;
+
+	gcc_assert(parent);
+
+	while (cur) {
+		struct fn_raw_data child_raw_data;
+		next_interesting_function_t next, child;
+
+		next = cur->next;
+
+		initialize_raw_data(&child_raw_data);
+		child_raw_data.decl_str = cur->decl_name;
+		child_raw_data.context = cur->context;
+		child_raw_data.hash = cur->hash;
+		child_raw_data.num = cur->num;
+		child_raw_data.marked = NO_SO_MARK;
+		child = get_global_next_interesting_function_entry(&child_raw_data);
+		if (!child) {
+			add_to_global_next_interesting_function(cur);
+			child = cur;
+		}
+
+		check_local_variables(child);
+
+		push_child(parent, child);
+
+		cur = next;
+	}
+
+	check_local_variables(parent);
+}
+
+next_interesting_function_t __attribute__((weak)) get_and_create_next_node_from_global_next_nodes_fnptr(const_tree fn_ptr __unused, struct fn_raw_data *raw_data __unused)
+{
+	return NULL;
+}
+
+static next_interesting_function_t create_parent_next_cnode(const_gimple stmt, unsigned int num)
+{
+	struct fn_raw_data raw_data;
+
+	initialize_raw_data(&raw_data);
+	raw_data.num = num;
+	raw_data.marked = NO_SO_MARK;
+	raw_data.based_decl = SO_FUNCTION;
+
+	switch (gimple_code(stmt)) {
+	case GIMPLE_ASM:
+		raw_data.decl = current_function_decl;
+		raw_data.marked = ASM_STMT_SO_MARK;
+		return get_and_create_next_node_from_global_next_nodes(&raw_data, NULL);
+	case GIMPLE_CALL:
+		raw_data.decl = gimple_call_fndecl(stmt);
+		if (raw_data.decl != NULL_TREE)
+			return get_and_create_next_node_from_global_next_nodes(&raw_data, NULL);
+		raw_data.decl = gimple_call_fn(stmt);
+		return get_and_create_next_node_from_global_next_nodes_fnptr(raw_data.decl, &raw_data);
+	case GIMPLE_RETURN:
+		raw_data.decl = current_function_decl;
+		return get_and_create_next_node_from_global_next_nodes(&raw_data, NULL);
+	case GIMPLE_ASSIGN: {
+		tree lhs = gimple_assign_lhs(stmt);
+
+		if (VAR_P(lhs))
+			raw_data.decl = lhs;
+		else
+			raw_data.decl = get_ref_field(lhs);
+		if (raw_data.decl == NULL_TREE)
+			return NULL;
+		return get_and_create_next_node_from_global_next_nodes(&raw_data, NULL);
+	}
+	default:
+		debug_gimple_stmt((gimple)stmt);
+		gcc_unreachable();
+	}
+}
+
+// Handle potential next_interesting_function_t parent if its argument has an integer type
+static void collect_all_possible_size_overflow_fns(const_gimple stmt, tree start_var, unsigned int num)
+{
+	next_interesting_function_t children_next_cnode, parent_next_cnode;
+
+	// skip void return values
+	if (start_var == NULL_TREE)
+		return;
+
+	if (skip_types(start_var))
+		return;
+
+	// handle intentional MARK_TURN_OFF
+	if (check_intentional_size_overflow_asm_and_attribute(start_var) == MARK_TURN_OFF)
+		return;
+
+	parent_next_cnode = create_parent_next_cnode(stmt, num);
+	if (!parent_next_cnode)
+		return;
+
+	children_next_cnode = search_next_functions(start_var, parent_next_cnode);
+	collect_data_for_execute(parent_next_cnode, children_next_cnode);
+}
+
+static void collect_all_possible_size_overflow_fields_and_vars(const gassign *assign)
+{
+	tree start_var, decl, lhs = gimple_assign_lhs(assign);
+
+	if (VAR_P(lhs))
+		decl = lhs;
+	else
+		decl = get_ref_field(lhs);
+	if (decl == NULL_TREE)
+		return;
+
+	if (get_intentional_attr_type(decl) == MARK_TURN_OFF)
+		return;
+
+	start_var = gimple_assign_rhs1(assign);
+	collect_all_possible_size_overflow_fns(assign, start_var, 0);
+
+	start_var = gimple_assign_rhs2(assign);
+	collect_all_possible_size_overflow_fns(assign, start_var, 0);
+
+#if BUILDING_GCC_VERSION >= 4006
+	start_var = gimple_assign_rhs3(assign);
+	collect_all_possible_size_overflow_fns(assign, start_var, 0);
+#endif
+}
+
+// Find potential next_interesting_function_t parents
+static void handle_cgraph_node(struct cgraph_node *node)
+{
+	basic_block bb;
+	tree cur_fndecl = NODE_DECL(node);
+
+	set_current_function_decl(cur_fndecl);
+
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			tree start_var;
+			gimple stmt = gsi_stmt(gsi);
+
+			switch (gimple_code(stmt)) {
+			case GIMPLE_RETURN: {
+				const greturn *return_stmt = as_a_const_greturn(stmt);
+
+				start_var = gimple_return_retval(return_stmt);
+				collect_all_possible_size_overflow_fns(return_stmt, start_var, 0);
+				break;
+			}
+			case GIMPLE_ASM: {
+				const gasm *asm_stmt = as_a_const_gasm(stmt);
+
+				if (!is_size_overflow_insert_check_asm(asm_stmt))
+					break;
+				start_var = get_size_overflow_asm_input(asm_stmt);
+				collect_all_possible_size_overflow_fns(asm_stmt, start_var, 0);
+				break;
+			}
+			case GIMPLE_CALL: {
+				unsigned int i, len;
+				const gcall *call = as_a_const_gcall(stmt);
+				tree fndecl = gimple_call_fndecl(call);
+
+				if (fndecl != NULL_TREE && (DECL_BUILT_IN(fndecl) || DECL_BUILT_IN_CLASS(fndecl) == BUILT_IN_NORMAL))
+					break;
+
+				len = gimple_call_num_args(call);
+				for (i = 0; i < len; i++) {
+					start_var = gimple_call_arg(call, i);
+					collect_all_possible_size_overflow_fns(call, start_var, i + 1);
+				}
+				break;
+			}
+			case GIMPLE_ASSIGN:
+				collect_all_possible_size_overflow_fields_and_vars(as_a_const_gassign(stmt));
+				break;
+			default:
+				break;
+			}
+		}
+	}
+
+	unset_current_function_decl();
+}
+
+/* Collect all potentially interesting function parameters and return values of integer types
+ * and store their data flow dependencies
+ */
+static void size_overflow_generate_summary(void)
+{
+	struct cgraph_node *node;
+
+	size_overflow_register_hooks();
+
+	FOR_EACH_FUNCTION(node) {
+		if (is_valid_cgraph_node(node))
+			handle_cgraph_node(node);
+	}
+}
+
+static void size_overflow_function_insertion_hook(struct cgraph_node *node __unused, void *data __unused)
+{
+	debug_cgraph_node(node);
+	gcc_unreachable();
+}
+
+/* Handle dst if src is in the global_next_interesting_function list.
+ * If src is a clone then dst inherits the orig_next_node of src otherwise
+ * src will become the orig_next_node of dst.
+ */
+static void size_overflow_node_duplication_hook(struct cgraph_node *src, struct cgraph_node *dst, void *data __unused)
+{
+	next_interesting_function_t head, cur;
+	struct fn_raw_data src_raw_data;
+
+	initialize_raw_data(&src_raw_data);
+	src_raw_data.decl = NODE_DECL(src);
+	src_raw_data.decl_str = DECL_NAME_POINTER(src_raw_data.decl);
+	src_raw_data.context = get_decl_context(src_raw_data.decl);
+	if (!src_raw_data.context)
+		return;
+
+	src_raw_data.num = NONE_ARGNUM;
+	src_raw_data.marked = NO_SO_MARK;
+
+	head = get_global_next_interesting_function_entry_with_hash(&src_raw_data);
+	if (!head)
+		return;
+
+	for (cur = head; cur; cur = cur->next) {
+		struct fn_raw_data dst_raw_data;
+		next_interesting_function_t orig_next_node, next_node;
+
+		if (!compare_next_interesting_functions(cur, src_raw_data.decl_str, src_raw_data.context, src_raw_data.num))
+			continue;
+
+		initialize_raw_data(&dst_raw_data);
+		dst_raw_data.decl = NODE_DECL(dst);
+		dst_raw_data.decl_str = cgraph_node_name(dst);
+		dst_raw_data.marked = cur->marked;
+		dst_raw_data.based_decl = cur->based_decl;
+
+		if (!made_by_compiler(dst_raw_data.decl))
+			break;
+
+		// For clones use the original node instead
+		if (cur->orig_next_node)
+			orig_next_node = cur->orig_next_node;
+		else
+			orig_next_node = cur;
+
+		dst_raw_data.num = get_correct_argnum_fndecl(src_raw_data.decl, dst_raw_data.decl, cur->num);
+		if (dst_raw_data.num == CANNOT_FIND_ARG)
+			continue;
+
+		next_node = create_new_next_interesting_decl(&dst_raw_data, orig_next_node);
+		if (next_node)
+			add_to_global_next_interesting_function(next_node);
+	}
+}
+
+void size_overflow_register_hooks(void)
+{
+	static bool init_p = false;
+
+	if (init_p)
+		return;
+	init_p = true;
+
+	function_insertion_hook_holder = cgraph_add_function_insertion_hook(&size_overflow_function_insertion_hook, NULL);
+	node_duplication_hook_holder = cgraph_add_node_duplication_hook(&size_overflow_node_duplication_hook, NULL);
+}
+
+static void set_yes_so_mark(next_interesting_function_t next_node)
+{
+	if (next_node->marked == NO_SO_MARK) {
+		next_node->marked = YES_SO_MARK;
+		global_changed = true;
+	}
+	// Mark the orig decl as well if it's a clone
+	if (next_node->orig_next_node && next_node->orig_next_node->marked == NO_SO_MARK) {
+		next_node->orig_next_node->marked = YES_SO_MARK;
+		global_changed = true;
+	}
+}
+
+// Determine whether node or orig node is part of a tracked data flow
+static bool marked_fn(next_interesting_function_t next_node)
+{
+	bool is_marked_fn, is_marked_orig = false;
+
+	is_marked_fn = next_node->marked != NO_SO_MARK;
+
+	if (next_node->orig_next_node)
+		is_marked_orig = next_node->orig_next_node->marked != NO_SO_MARK;
+
+	return is_marked_fn || is_marked_orig;
+}
+
+// Determine whether node or orig node is in the hash table already
+static bool already_in_the_hashtable(next_interesting_function_t next_node)
+{
+	struct fn_raw_data raw_data;
+
+	if (next_node->orig_next_node)
+		next_node = next_node->orig_next_node;
+
+	initialize_raw_data(&raw_data);
+	raw_data.context = next_node->context;
+	raw_data.orig_decl_str = next_node->decl_name;
+	raw_data.orig_num = next_node->num;
+	raw_data.hash = next_node->hash;
+
+	return get_size_overflow_hash_entry(&raw_data) != NULL;
+}
+
+// Propagate the size_overflow marks up the use-def chains
+static bool has_marked_child(next_interesting_function_t next_node)
+{
+	bool ret = false;
+	unsigned int i;
+	next_interesting_function_t child;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, next_node->children))
+		return false;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, next_node->children, i, child) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(next_node->children, i, child) {
+#endif
+		if (marked_fn(child) || already_in_the_hashtable(child))
+			ret = true;
+	}
+
+	return ret;
+}
+
+/* Set YES_SO_MARK on the function, its orig node and children if:
+ *      * the function or its orig node or one of its children is in the hash table already
+ *      * the function's orig node is marked with YES_SO_MARK or ASM_STMT_SO_MARK
+ *      * one of the children is marked with YES_SO_MARK or ASM_STMT_SO_MARK
+ */
+static bool set_fn_so_mark(next_interesting_function_t next_node)
+{
+	bool so_fn, so_hashtable, so_child;
+
+	so_hashtable = already_in_the_hashtable(next_node);
+	so_fn = marked_fn(next_node);
+	so_child = has_marked_child(next_node);
+
+	if (!so_fn && !so_hashtable && !so_child)
+		return false;
+	set_yes_so_mark(next_node);
+	return true;
+}
+
+// Determine if any of the function pointer targets have data flow between the return value and one of the arguments
+static next_interesting_function_t get_same_not_ret_child(next_interesting_function_t parent)
+{
+	unsigned int i;
+	next_interesting_function_t child;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, parent->children))
+		return NULL;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, parent->children, i, child) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(parent->children, i, child) {
+#endif
+		if (child->num == 0)
+			continue;
+		if (strcmp(parent->decl_name, child->decl_name))
+			continue;
+		if (!strcmp(child->context, "fndecl"))
+			return child;
+	}
+	return NULL;
+}
+
+/* Trace a return value of function pointer type back to an argument via a concrete function
+   fnptr 0 && fn 0 && (fn 0 -> fn 2) => fnptr 2 */
+static void search_missing_fptr_arg(next_interesting_function_t parent)
+{
+	next_interesting_function_t child;
+	unsigned int i;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(next_interesting_function_t, heap) *new_children = NULL;
+#else
+	vec<next_interesting_function_t, va_heap, vl_embed> *new_children = NULL;
+#endif
+
+	if (parent->num != 0)
+		return;
+	if (!strcmp(parent->context, "fndecl"))
+		return;
+	if (!strncmp(parent->context, "vardecl", sizeof("vardecl") - 1))
+		return;
+
+	// fnptr 0 && fn 0
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, parent->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, parent->children, i, child) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(parent->children, i, child) {
+#endif
+		next_interesting_function_t cur_next_node, tracked_fn;
+
+		if (child->num != 0)
+			continue;
+		// (fn 0 -> fn 2)
+		tracked_fn = get_same_not_ret_child(child);
+		if (!tracked_fn)
+			continue;
+
+		// fn 2 => fnptr 2
+		for (cur_next_node = global_next_interesting_function[parent->hash]; cur_next_node; cur_next_node = cur_next_node->next) {
+			if (cur_next_node->num != tracked_fn->num)
+				continue;
+
+			if (strcmp(parent->decl_name, cur_next_node->decl_name))
+				continue;
+
+			if (!has_next_interesting_function_vec(parent, cur_next_node)) {
+#if BUILDING_GCC_VERSION <= 4007
+				VEC_safe_push(next_interesting_function_t, heap, new_children, cur_next_node);
+#else
+				vec_safe_push(new_children, cur_next_node);
+#endif
+			}
+		}
+	}
+
+#if BUILDING_GCC_VERSION == 4005
+	if (VEC_empty(next_interesting_function_t, new_children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, new_children, i, child)
+		VEC_safe_push(next_interesting_function_t, heap, parent->children, child);
+#elif BUILDING_GCC_VERSION <= 4007
+	VEC_safe_splice(next_interesting_function_t, heap, parent->children, new_children);
+#else
+	vec_safe_splice(parent->children, new_children);
+#endif
+}
+
+static void walk_so_marked_fns(next_interesting_function_set *visited, next_interesting_function_t parent)
+{
+	unsigned int i;
+	next_interesting_function_t child;
+
+	gcc_assert(parent);
+	if (!set_fn_so_mark(parent))
+		return;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, parent->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, parent->children, i, child) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(parent->children, i, child) {
+#endif
+		set_yes_so_mark(child);
+
+		if (!pointer_set_insert(visited, child))
+			walk_so_marked_fns(visited, child);
+	}
+}
+
+// Do a depth-first recursive dump of the next_interesting_function_t children vector
+static void print_missing_functions(next_interesting_function_set *visited, next_interesting_function_t parent)
+{
+	unsigned int i;
+	next_interesting_function_t child;
+
+	gcc_assert(parent);
+	gcc_assert(parent->marked != NO_SO_MARK);
+	print_missing_function(parent);
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, parent->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, parent->children, i, child) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(parent->children, i, child) {
+#endif
+		gcc_assert(child->marked != NO_SO_MARK);
+		if (!pointer_set_insert(visited, child))
+			print_missing_functions(visited, child);
+	}
+}
+
+// Set YES_SO_MARK on functions that will be emitted into the hash table
+static void search_so_marked_fns(void)
+{
+
+	unsigned int i;
+	next_interesting_function_set *visited;
+
+	visited = next_interesting_function_pointer_set_create();
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		next_interesting_function_t cur_global;
+
+		for (cur_global = global_next_interesting_function[i]; cur_global; cur_global = cur_global->next) {
+			if (cur_global->marked != NO_SO_MARK && !pointer_set_insert(visited, cur_global))
+				walk_so_marked_fns(visited, cur_global);
+		}
+	}
+	pointer_set_destroy(visited);
+}
+
+static void walk_marked_functions(next_interesting_function_set *visited, next_interesting_function_t parent)
+{
+	unsigned int i;
+	next_interesting_function_t child;
+
+	if (pointer_set_insert(visited, parent))
+		return;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, parent->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, parent->children, i, child) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(parent->children, i, child) {
+#endif
+		switch (parent->based_decl) {
+		case SO_FIELD:
+			child->based_decl = SO_FIELD;
+			gcc_assert(child->based_decl != SO_FUNCTION_POINTER);
+			break;
+		case SO_FUNCTION_POINTER:
+			child->based_decl = SO_FUNCTION_POINTER;
+			gcc_assert(child->based_decl != SO_FIELD);
+			break;
+		case SO_FUNCTION:
+		case SO_VAR:
+			break;
+		default:
+			gcc_unreachable();
+		}
+
+		walk_marked_functions(visited, child);
+	}
+}
+
+static void set_based_decl(void)
+{
+	unsigned int i;
+	next_interesting_function_set *visited;
+
+	visited = next_interesting_function_pointer_set_create();
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		next_interesting_function_t cur;
+
+		for (cur = global_next_interesting_function[i]; cur; cur = cur->next) {
+			if (cur->marked == ASM_STMT_SO_MARK && !pointer_set_contains(visited, cur))
+				walk_marked_functions(visited, cur);
+		}
+	}
+	pointer_set_destroy(visited);
+}
+
+// Print functions missing from the hash table
+static void print_so_marked_fns(void)
+{
+	unsigned int i;
+	next_interesting_function_set *visited;
+
+	visited = next_interesting_function_pointer_set_create();
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		next_interesting_function_t cur_global;
+
+		for (cur_global = global_next_interesting_function[i]; cur_global; cur_global = cur_global->next) {
+			if (cur_global->marked != NO_SO_MARK && !pointer_set_insert(visited, cur_global))
+				print_missing_functions(visited, cur_global);
+		}
+	}
+	pointer_set_destroy(visited);
+}
+
+void __attribute__((weak)) check_global_variables(next_interesting_function_t cur_global __unused) {}
+
+static void global_vars_and_fptrs(void)
+{
+	unsigned int i;
+
+	if (!in_lto_p)
+		return;
+
+	// Collect vardecls and funtions reachable by function pointers
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		next_interesting_function_t cur_global;
+
+		for (cur_global = global_next_interesting_function[i]; cur_global; cur_global = cur_global->next) {
+			check_global_variables(cur_global);
+			search_missing_fptr_arg(cur_global);
+		}
+	}
+}
+
+static void print_parent_child(next_interesting_function_set *visited, next_interesting_function_t parent)
+{
+	unsigned int i;
+	next_interesting_function_t child;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, parent->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, parent->children, i, child) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(parent->children, i, child) {
+#endif
+		fprintf(stderr, " PARENT: decl: %s-%u context: %s %p\n", parent->decl_name, parent->num, parent->context, parent);
+		fprintf(stderr, " \tCHILD: decl: %s-%u context: %s %p\n", child->decl_name, child->num, child->context, child);
+
+		if (!pointer_set_insert(visited, child))
+			print_parent_child(visited, child);
+	}
+}
+
+static void print_data_flow(void)
+{
+	unsigned int i;
+	next_interesting_function_set *visited;
+
+	if (!in_lto_p)
+		return;
+
+	visited = next_interesting_function_pointer_set_create();
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		next_interesting_function_t cur_global;
+
+		for (cur_global = global_next_interesting_function[i]; cur_global; cur_global = cur_global->next) {
+			if (cur_global->marked == NO_SO_MARK || pointer_set_insert(visited, cur_global))
+				continue;
+
+			fprintf(stderr, "Data flow: decl: %s-%u context: %s %p\n", cur_global->decl_name, cur_global->num, cur_global->context, cur_global);
+
+			print_parent_child(visited, cur_global);
+
+			fprintf(stderr, "\n");
+		}
+	}
+	pointer_set_destroy(visited);
+}
+
+static void set_so_fns(void)
+{
+	do {
+		global_changed = false;
+		search_so_marked_fns();
+	} while (global_changed);
+
+	print_data_flow();
+}
+
+// Print all missing interesting functions
+static unsigned int size_overflow_execute(void)
+{
+	if (flag_lto && !in_lto_p)
+		return 0;
+
+	global_vars_and_fptrs();
+
+	set_so_fns();
+	set_based_decl();
+	print_so_marked_fns();
+
+	if (in_lto_p) {
+		fprintf(stderr, "%s: SIZE_OVERFLOW EXECUTE\n", __func__);
+		print_global_next_interesting_functions();
+	}
+
+	return 0;
+}
+
+// Omit the IPA/LTO callbacks until https://gcc.gnu.org/bugzilla/show_bug.cgi?id=61311 gets fixed (license concerns)
+#if BUILDING_GCC_VERSION >= 4008
+void __attribute__((weak)) size_overflow_write_summary(void) {}
+void __attribute__((weak)) size_overflow_write_optimization_summary(void) {}
+#elif BUILDING_GCC_VERSION >= 4006
+void __attribute__((weak)) size_overflow_write_summary(cgraph_node_set set __unused, varpool_node_set vset __unused) {}
+void __attribute__((weak)) size_overflow_write_optimization_summary(cgraph_node_set set __unused, varpool_node_set vset __unused) {}
+#else
+void __attribute__((weak)) size_overflow_write_summary(cgraph_node_set set __unused) {}
+void __attribute__((weak)) size_overflow_write_optimization_summary(cgraph_node_set set __unused) {}
+#endif
+
+void __attribute__((weak)) size_overflow_read_summary(void);
+void __attribute__((weak)) size_overflow_read_optimization_summary(void);
+
+#define PASS_NAME size_overflow
+
+#define NO_STMT_FIXUP
+#define NO_VARIABLE_TRANSFORM
+#define NO_GATE
+
+#include "gcc-generate-ipa-pass.h"
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_misc.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_misc.c
new file mode 100644
index 000000000..b5291e1f8
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_misc.c
@@ -0,0 +1,505 @@
+/*
+ * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+bool is_vararg(const_tree fn, unsigned int num)
+{
+	tree arg_list;
+
+	if (num == 0)
+		return false;
+	if (fn == NULL_TREE)
+		return false;
+	if (TREE_CODE(fn) != FUNCTION_DECL)
+		return false;
+
+	arg_list = TYPE_ARG_TYPES(TREE_TYPE(fn));
+	if (arg_list == NULL_TREE)
+		return false;
+
+	if (tree_last(arg_list) == void_list_node)
+		return false;
+
+	return num >= (unsigned int)list_length(arg_list);
+}
+
+// Extract the field decl from memory references
+tree get_ref_field(const_tree ref)
+{
+	tree field;
+
+	// TODO: handle nested memory references
+	switch (TREE_CODE(ref)) {
+	case ARRAY_REF:
+		return NULL_TREE;
+#if BUILDING_GCC_VERSION >= 4006
+	case MEM_REF:
+#endif
+	case INDIRECT_REF:
+		field = TREE_OPERAND(ref, 0);
+		break;
+	case COMPONENT_REF:
+		field = TREE_OPERAND(ref, 1);
+		break;
+	default:
+		return NULL_TREE;
+	}
+
+	// TODO
+	if (TREE_CODE(field) == SSA_NAME)
+		return NULL_TREE;
+	// TODO
+	if (TREE_CODE(field) != FIELD_DECL)
+		return NULL_TREE;
+	// TODO
+	if (TREE_CODE(field) == ADDR_EXPR)
+		return NULL_TREE;
+
+	return field;
+}
+
+const char *get_type_name_from_field(const_tree field_decl)
+{
+	const_tree context, type_name;
+
+	if (TREE_CODE(field_decl) != FIELD_DECL)
+		return NULL;
+
+	context = DECL_CONTEXT(field_decl);
+	// TODO
+	if (TREE_CODE(context) != RECORD_TYPE)
+		return NULL;
+	gcc_assert(TREE_CODE(context) == RECORD_TYPE);
+	type_name = TYPE_NAME(TYPE_MAIN_VARIANT(context));
+	if (type_name == NULL_TREE)
+		return NULL;
+
+	if (TREE_CODE(type_name) == IDENTIFIER_NODE)
+		return IDENTIFIER_POINTER(type_name);
+	else if (TREE_CODE(type_name) == TYPE_DECL)
+		return DECL_NAME_POINTER(type_name);
+
+	debug_tree(field_decl);
+	debug_tree(type_name);
+	gcc_unreachable();
+}
+
+// Was the function created by the compiler itself?
+bool made_by_compiler(const_tree decl)
+{
+	enum tree_code decl_code;
+	struct cgraph_node *node;
+
+	if (FUNCTION_PTR_P(decl))
+		return false;
+	decl_code = TREE_CODE(decl);
+	if (decl_code == VAR_DECL || decl_code == FIELD_DECL)
+		return false;
+
+	gcc_assert(decl_code == FUNCTION_DECL);
+	if (DECL_ABSTRACT_ORIGIN(decl) != NULL_TREE && DECL_ABSTRACT_ORIGIN(decl) != decl)
+		return true;
+	if (DECL_ARTIFICIAL(decl))
+		return true;
+
+	node = get_cnode(decl);
+	if (!node)
+		return false;
+	return node->clone_of != NULL;
+}
+
+bool skip_types(const_tree var)
+{
+	const_tree type;
+
+	type = TREE_TYPE(var);
+	if (type == NULL_TREE)
+		return true;
+
+	switch (TREE_CODE(type)) {
+		case INTEGER_TYPE:
+		case ENUMERAL_TYPE:
+			return false;
+		default:
+			return true;
+	}
+}
+
+gimple get_fnptr_def_stmt(const_tree fn_ptr)
+{
+	gimple def_stmt;
+
+	gcc_assert(fn_ptr != NULL_TREE);
+	gcc_assert(FUNCTION_PTR_P(fn_ptr));
+
+	if (is_gimple_constant(fn_ptr))
+		return NULL;
+
+	def_stmt = get_def_stmt(fn_ptr);
+	gcc_assert(def_stmt);
+	return def_stmt;
+}
+
+gimple get_def_stmt(const_tree node)
+{
+	gcc_assert(node != NULL_TREE);
+
+	if (TREE_CODE(node) != SSA_NAME)
+		return NULL;
+	return SSA_NAME_DEF_STMT(node);
+}
+
+tree create_new_var(tree type)
+{
+	tree new_var = create_tmp_var(type, "cicus");
+
+	add_referenced_var(new_var);
+	return new_var;
+}
+
+static bool skip_cast(tree dst_type, const_tree rhs, bool force)
+{
+	const_gimple def_stmt = get_def_stmt(rhs);
+
+	if (force)
+		return false;
+
+	if (is_gimple_constant(rhs))
+		return false;
+
+	if (!def_stmt || gimple_code(def_stmt) == GIMPLE_NOP)
+		return false;
+
+	if (!types_compatible_p(dst_type, TREE_TYPE(rhs)))
+		return false;
+
+	// DI type can be on 32 bit (from create_assign) but overflow type stays DI
+	if (LONG_TYPE_SIZE == GET_MODE_BITSIZE(SImode))
+		return false;
+
+	return true;
+}
+
+tree cast_a_tree(tree type, tree var)
+{
+	gcc_assert(type != NULL_TREE);
+	gcc_assert(var != NULL_TREE);
+	gcc_assert(fold_convertible_p(type, var));
+
+	return fold_convert(type, var);
+}
+
+gimple build_cast_stmt(struct visited *visited, tree dst_type, tree rhs, tree lhs, gimple_stmt_iterator *gsi, bool before, bool force)
+{
+	gassign *assign;
+	gimple def_stmt;
+
+	gcc_assert(dst_type != NULL_TREE && rhs != NULL_TREE);
+	gcc_assert(!is_gimple_constant(rhs));
+	if (gsi_end_p(*gsi) && before == AFTER_STMT)
+		gcc_unreachable();
+
+	def_stmt = get_def_stmt(rhs);
+	if (def_stmt && gimple_code(def_stmt) != GIMPLE_NOP && skip_cast(dst_type, rhs, force) && pointer_set_contains(visited->my_stmts, def_stmt))
+		return def_stmt;
+
+	if (lhs == CREATE_NEW_VAR)
+		lhs = create_new_var(dst_type);
+
+	assign = gimple_build_assign(lhs, cast_a_tree(dst_type, rhs));
+
+	if (!gsi_end_p(*gsi)) {
+		location_t loc = gimple_location(gsi_stmt(*gsi));
+		gimple_set_location(assign, loc);
+	}
+
+	gimple_assign_set_lhs(assign, make_ssa_name(lhs, assign));
+
+	if (before)
+		gsi_insert_before(gsi, assign, GSI_NEW_STMT);
+	else
+		gsi_insert_after(gsi, assign, GSI_NEW_STMT);
+	update_stmt(assign);
+	return assign;
+}
+
+bool is_size_overflow_type(const_tree var)
+{
+	const char *name;
+	const_tree type_name, type;
+
+	if (var == NULL_TREE)
+		return false;
+
+	type = TREE_TYPE(var);
+	type_name = TYPE_NAME(type);
+	if (type_name == NULL_TREE)
+		return false;
+
+	if (DECL_P(type_name))
+		name = DECL_NAME_POINTER(type_name);
+	else
+		name = IDENTIFIER_POINTER(type_name);
+
+	if (!strncmp(name, "size_overflow_type", 18))
+		return true;
+	return false;
+}
+
+// Determine if a cloned function has all the original arguments
+static bool unchanged_arglist(struct cgraph_node *new_node, struct cgraph_node *old_node)
+{
+	const_tree new_decl_list, old_decl_list;
+
+	if (new_node->clone_of && new_node->clone.tree_map)
+		return !new_node->clone.args_to_skip;
+
+	new_decl_list = DECL_ARGUMENTS(NODE_DECL(new_node));
+	old_decl_list = DECL_ARGUMENTS(NODE_DECL(old_node));
+	if (new_decl_list != NULL_TREE && old_decl_list != NULL_TREE)
+		gcc_assert(list_length(new_decl_list) == list_length(old_decl_list));
+
+	return true;
+}
+
+unsigned int get_correct_argnum_fndecl(const_tree fndecl, const_tree correct_argnum_of_fndecl, unsigned int num)
+{
+	unsigned int new_num;
+	const_tree fndecl_arg;
+	tree fndecl_arglist = DECL_ARGUMENTS(fndecl);
+	const_tree arg, target_fndecl_arglist;
+
+	if (num == 0)
+		return num;
+
+	if (fndecl == correct_argnum_of_fndecl && !DECL_ARTIFICIAL(fndecl))
+		return num;
+	else if (fndecl == correct_argnum_of_fndecl && DECL_ARTIFICIAL(fndecl))
+		return CANNOT_FIND_ARG;
+
+	target_fndecl_arglist = DECL_ARGUMENTS(correct_argnum_of_fndecl);
+	if (fndecl_arglist == NULL_TREE || target_fndecl_arglist == NULL_TREE)
+		return CANNOT_FIND_ARG;
+
+	fndecl_arg = chain_index(num - 1, fndecl_arglist);
+	if (fndecl_arg == NULL_TREE)
+		return CANNOT_FIND_ARG;
+
+	for (arg = target_fndecl_arglist, new_num = 1; arg; arg = TREE_CHAIN(arg), new_num++) {
+		if (arg == fndecl_arg || !strcmp(DECL_NAME_POINTER(arg), DECL_NAME_POINTER(fndecl_arg)))
+			return new_num;
+	}
+
+	return CANNOT_FIND_ARG;
+}
+
+// Find the specified argument in the originally cloned function
+static unsigned int clone_argnum_on_orig(struct cgraph_node *new_node, struct cgraph_node *old_node, unsigned int clone_argnum)
+{
+	bitmap args_to_skip;
+	unsigned int i, new_argnum = clone_argnum;
+
+	if (unchanged_arglist(new_node, old_node))
+		return clone_argnum;
+
+	gcc_assert(new_node->clone_of && new_node->clone.tree_map);
+	args_to_skip = new_node->clone.args_to_skip;
+	for (i = 0; i < clone_argnum; i++) {
+		if (bitmap_bit_p(args_to_skip, i))
+			new_argnum++;
+	}
+	return new_argnum;
+}
+
+// Find the specified argument in the clone
+static unsigned int orig_argnum_on_clone(struct cgraph_node *new_node, struct cgraph_node *old_node, unsigned int orig_argnum)
+{
+	bitmap args_to_skip;
+	unsigned int i, new_argnum = orig_argnum;
+
+	if (unchanged_arglist(new_node, old_node))
+		return orig_argnum;
+
+	gcc_assert(new_node->clone_of && new_node->clone.tree_map);
+	args_to_skip = new_node->clone.args_to_skip;
+	if (bitmap_bit_p(args_to_skip, orig_argnum - 1))
+		// XXX torolni kellene a nodeot
+		return CANNOT_FIND_ARG;
+
+	for (i = 0; i < orig_argnum; i++) {
+		if (bitmap_bit_p(args_to_skip, i))
+			new_argnum--;
+	}
+	return new_argnum;
+}
+
+// Associate the argument between a clone and a cloned function
+static unsigned int get_correct_argnum_cnode(struct cgraph_node *node, struct cgraph_node *correct_argnum_of_node, unsigned int argnum)
+{
+	bool node_clone, correct_argnum_of_node_clone;
+	const_tree correct_argnum_of_node_decl, node_decl;
+
+	if (node == correct_argnum_of_node)
+		return argnum;
+	if (argnum == 0)
+		return argnum;
+
+	correct_argnum_of_node_decl = NODE_DECL(correct_argnum_of_node);
+	gcc_assert(correct_argnum_of_node_decl != NULL_TREE);
+	gcc_assert(correct_argnum_of_node && !DECL_ARTIFICIAL(correct_argnum_of_node_decl));
+
+	if (node) {
+		node_decl = NODE_DECL(node);
+		gcc_assert(!DECL_ARTIFICIAL(node_decl));
+		node_clone = made_by_compiler(node_decl);
+	} else {
+		node_decl = NULL_TREE;
+		node_clone = false;
+	}
+
+	if (correct_argnum_of_node_decl == node_decl)
+		return argnum;
+
+	correct_argnum_of_node_clone = made_by_compiler(correct_argnum_of_node_decl);
+	// the original decl is lost if both nodes are clones
+	if (node_clone && correct_argnum_of_node_clone) {
+		gcc_assert(unchanged_arglist(node, correct_argnum_of_node));
+		return argnum;
+	}
+
+	if (node_clone && !correct_argnum_of_node_clone)
+		return clone_argnum_on_orig(correct_argnum_of_node, node, argnum);
+	else if (!node_clone && correct_argnum_of_node_clone)
+		return orig_argnum_on_clone(correct_argnum_of_node, node, argnum);
+
+	if (node)
+		debug_tree(NODE_DECL(node));
+	debug_tree(correct_argnum_of_node_decl);
+	gcc_unreachable();
+}
+
+unsigned int get_correct_argnum(const_tree decl, const_tree correct_argnum_of_decl, unsigned int argnum)
+{
+	struct cgraph_node *node, *correct_argnum_of_node;
+
+	gcc_assert(decl != NULL_TREE);
+	gcc_assert(correct_argnum_of_decl != NULL_TREE);
+
+	correct_argnum_of_node = get_cnode(correct_argnum_of_decl);
+	if (!correct_argnum_of_node || DECL_ARTIFICIAL(decl) || DECL_ARTIFICIAL(correct_argnum_of_decl))
+		return get_correct_argnum_fndecl(decl, correct_argnum_of_decl, argnum);
+
+	node = get_cnode(decl);
+	return get_correct_argnum_cnode(node, correct_argnum_of_node, argnum);
+}
+
+// Find the original cloned function
+tree get_orig_fndecl(const_tree clone_fndecl)
+{
+	struct cgraph_node *node;
+
+	gcc_assert(TREE_CODE(clone_fndecl) == FUNCTION_DECL);
+
+	if (DECL_ABSTRACT_ORIGIN(clone_fndecl))
+		return CONST_CAST_TREE(DECL_ABSTRACT_ORIGIN(clone_fndecl));
+	node = get_cnode(clone_fndecl);
+	if (!node)
+		return CONST_CAST_TREE(clone_fndecl);
+
+	while (node->clone_of)
+		node = node->clone_of;
+	if (!made_by_compiler(NODE_DECL(node)))
+		return NODE_DECL(node);
+	// Return the cloned decl because it is needed for the transform callback
+	return CONST_CAST_TREE(clone_fndecl);
+}
+
+static tree get_interesting_fndecl_from_stmt(const gcall *stmt)
+{
+	if (gimple_call_num_args(stmt) == 0)
+		return NULL_TREE;
+	return gimple_call_fndecl(stmt);
+}
+
+tree get_interesting_orig_fndecl_from_stmt(const gcall *stmt)
+{
+	tree fndecl;
+
+	fndecl = get_interesting_fndecl_from_stmt(stmt);
+	if (fndecl == NULL_TREE)
+		return NULL_TREE;
+	return get_orig_fndecl(fndecl);
+}
+
+void set_dominance_info(void)
+{
+	calculate_dominance_info(CDI_DOMINATORS);
+	calculate_dominance_info(CDI_POST_DOMINATORS);
+}
+
+void unset_dominance_info(void)
+{
+	free_dominance_info(CDI_DOMINATORS);
+	free_dominance_info(CDI_POST_DOMINATORS);
+}
+
+void set_current_function_decl(tree fndecl)
+{
+	gcc_assert(fndecl != NULL_TREE);
+
+	push_cfun(DECL_STRUCT_FUNCTION(fndecl));
+#if BUILDING_GCC_VERSION <= 4007
+	current_function_decl = fndecl;
+#endif
+	set_dominance_info();
+}
+
+void unset_current_function_decl(void)
+{
+	unset_dominance_info();
+#if BUILDING_GCC_VERSION <= 4007
+	current_function_decl = NULL_TREE;
+#endif
+	pop_cfun();
+}
+
+bool is_valid_cgraph_node(struct cgraph_node *node)
+{
+	if (cgraph_function_body_availability(node) == AVAIL_NOT_AVAILABLE)
+		return false;
+	if (node->thunk.thunk_p || node->alias)
+		return false;
+	return true;
+}
+
+tree get_lhs(const_gimple stmt)
+{
+	switch (gimple_code(stmt)) {
+	case GIMPLE_ASSIGN:
+	case GIMPLE_CALL:
+		return gimple_get_lhs(stmt);
+	case GIMPLE_PHI:
+		return gimple_phi_result(stmt);
+	default:
+		debug_gimple_stmt((gimple)stmt);
+		gcc_unreachable();
+	}
+}
+
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_plugin.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_plugin.c
new file mode 100644
index 000000000..4f667bad8
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_plugin.c
@@ -0,0 +1,299 @@
+/*
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+__visible int plugin_is_GPL_compatible;
+
+tree report_size_overflow_decl;
+
+tree size_overflow_type_HI;
+tree size_overflow_type_SI;
+tree size_overflow_type_DI;
+tree size_overflow_type_TI;
+
+bool check_fields, check_fns, check_fnptrs, check_vars;
+
+static struct plugin_info size_overflow_plugin_info = {
+	.version	= "20161113",
+	.help		= "no-size-overflow\tturn off size overflow checking\n",
+};
+
+static tree handle_size_overflow_attribute(tree *node, tree __unused name, tree args, int __unused flags, bool *no_add_attrs)
+{
+	unsigned int arg_count;
+	enum tree_code code = TREE_CODE(*node);
+
+	switch (code) {
+	case FUNCTION_DECL:
+		arg_count = type_num_arguments(TREE_TYPE(*node));
+		break;
+	case FUNCTION_TYPE:
+	case METHOD_TYPE:
+		arg_count = type_num_arguments(*node);
+		break;
+	default:
+		*no_add_attrs = true;
+		debug_tree(*node);
+		error("%s: %qE attribute only applies to functions", __func__, name);
+		return NULL_TREE;
+	}
+
+	for (; args; args = TREE_CHAIN(args)) {
+		int cur_val;
+		tree position = TREE_VALUE(args);
+
+		if (TREE_CODE(position) != INTEGER_CST) {
+			error("%s: parameter isn't an integer", __func__);
+			debug_tree(args);
+			*no_add_attrs = true;
+			return NULL_TREE;
+		}
+
+		cur_val = tree_to_shwi(position);
+		if (cur_val < 0 || arg_count < (unsigned int)cur_val) {
+			error("%s: parameter %d is outside range.", __func__, cur_val);
+			*no_add_attrs = true;
+			return NULL_TREE;
+		}
+	}
+	return NULL_TREE;
+}
+
+static tree handle_intentional_overflow_attribute(tree *node, tree __unused name, tree args, int __unused flags, bool *no_add_attrs)
+{
+	unsigned int arg_count;
+	HOST_WIDE_INT s_first_arg;
+	enum tree_code code = TREE_CODE(*node);
+
+	switch (code) {
+	case FUNCTION_DECL:
+		arg_count = type_num_arguments(TREE_TYPE(*node));
+		break;
+	case FUNCTION_TYPE:
+	case METHOD_TYPE:
+		arg_count = type_num_arguments(*node);
+		break;
+	case VAR_DECL:
+	case FIELD_DECL:
+		return NULL_TREE;
+	default:
+		*no_add_attrs = true;
+		debug_tree(*node);
+		error("%qE attribute only applies to functions, fields or vars", name);
+		return NULL_TREE;
+	}
+
+	s_first_arg = tree_to_shwi(TREE_VALUE(args));
+	if (s_first_arg == -1)
+		return NULL_TREE;
+	if (s_first_arg < -1)
+		error("%s: parameter %d is outside range.", __func__, (int)s_first_arg);
+
+	for (; args; args = TREE_CHAIN(args)) {
+		unsigned int cur_val;
+
+		if (TREE_CODE(TREE_VALUE(args)) != INTEGER_CST) {
+			error("%s: parameter isn't an integer", __func__);
+			debug_tree(args);
+			*no_add_attrs = true;
+			return NULL_TREE;
+		}
+
+		cur_val = (unsigned int)tree_to_uhwi(TREE_VALUE(args));
+		if (cur_val > arg_count ) {
+			error("%s: parameter %u is outside range. (arg_count: %u)", __func__, cur_val, arg_count);
+			*no_add_attrs = true;
+			return NULL_TREE;
+		}
+	}
+	return NULL_TREE;
+}
+
+static struct attribute_spec size_overflow_attr = {
+	.name				= "size_overflow",
+	.min_length			= 1,
+	.max_length			= -1,
+	.decl_required			= true,
+	.type_required			= false,
+	.function_type_required		= false,
+	.handler			= handle_size_overflow_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity		= false
+#endif
+};
+
+static struct attribute_spec intentional_overflow_attr = {
+	.name				= "intentional_overflow",
+	.min_length			= 1,
+	.max_length			= -1,
+	.decl_required			= true,
+	.type_required			= false,
+	.function_type_required		= false,
+	.handler			= handle_intentional_overflow_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity		= false
+#endif
+};
+
+static void register_attributes(void __unused *event_data, void __unused *data)
+{
+	register_attribute(&size_overflow_attr);
+	register_attribute(&intentional_overflow_attr);
+}
+
+static tree create_typedef(tree type, const char* ident)
+{
+	tree new_type, decl;
+
+	new_type = build_variant_type_copy(type);
+	decl = build_decl(BUILTINS_LOCATION, TYPE_DECL, get_identifier(ident), new_type);
+	DECL_ORIGINAL_TYPE(decl) = type;
+	TYPE_NAME(new_type) = decl;
+	return new_type;
+}
+
+// Create the noreturn report_size_overflow() function decl.
+static void size_overflow_start_unit(void __unused *gcc_data, void __unused *user_data)
+{
+	tree const_char_ptr_type_node;
+	tree fntype;
+
+	const_char_ptr_type_node = build_pointer_type(build_type_variant(char_type_node, 1, 0));
+
+	size_overflow_type_HI = create_typedef(intHI_type_node, "size_overflow_type_HI");
+	size_overflow_type_SI = create_typedef(intSI_type_node, "size_overflow_type_SI");
+	size_overflow_type_DI = create_typedef(intDI_type_node, "size_overflow_type_DI");
+	size_overflow_type_TI = create_typedef(intTI_type_node, "size_overflow_type_TI");
+
+	// void report_size_overflow(const char *loc_file, unsigned int loc_line, const char *current_func, const char *ssa_var)
+	fntype = build_function_type_list(void_type_node,
+					  const_char_ptr_type_node,
+					  unsigned_type_node,
+					  const_char_ptr_type_node,
+					  const_char_ptr_type_node,
+					  NULL_TREE);
+	report_size_overflow_decl = build_fn_decl("report_size_overflow", fntype);
+
+	DECL_ASSEMBLER_NAME(report_size_overflow_decl);
+	TREE_PUBLIC(report_size_overflow_decl) = 1;
+	DECL_EXTERNAL(report_size_overflow_decl) = 1;
+	DECL_ARTIFICIAL(report_size_overflow_decl) = 1;
+//	TREE_THIS_VOLATILE(report_size_overflow_decl) = 1;
+// !!!
+	DECL_PRESERVE_P(report_size_overflow_decl) = 1;
+	DECL_UNINLINABLE(report_size_overflow_decl) = 1;
+	TREE_USED(report_size_overflow_decl) = 1;
+	TREE_NOTHROW(report_size_overflow_decl) = 1;
+}
+
+static bool disable_ubsan_si_overflow_gate(void)
+{
+#if BUILDING_GCC_VERSION >= 4009
+	flag_sanitize &= ~SANITIZE_SI_OVERFLOW;
+#endif
+	return true;
+}
+
+#define PASS_NAME disable_ubsan_si_overflow
+
+#define NO_EXECUTE
+
+#include "gcc-generate-gimple-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	int i;
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	bool enable = true;
+
+	static const struct ggc_root_tab gt_ggc_r_gt_size_overflow[] = {
+		{
+			.base = &report_size_overflow_decl,
+			.nelt = 1,
+			.stride = sizeof(report_size_overflow_decl),
+			.cb = &gt_ggc_mx_tree_node,
+			.pchw = &gt_pch_nx_tree_node
+		},
+		LAST_GGC_ROOT_TAB
+	};
+
+	PASS_INFO(insert_size_overflow_asm, "ssa", 1, PASS_POS_INSERT_AFTER);
+	PASS_INFO(size_overflow, "inline", 1, PASS_POS_INSERT_AFTER);
+#if BUILDING_GCC_VERSION >= 4009
+	PASS_INFO(disable_ubsan_si_overflow, "ubsan", 1, PASS_POS_REPLACE);
+#endif
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "no-size-overflow")) {
+			enable = false;
+			continue;
+		}
+
+		if (!strcmp(argv[i].key, "check-fields")) {
+			check_fields = true;
+			continue;
+		}
+
+		if (!strcmp(argv[i].key, "check-fns")) {
+			check_fns = true;
+			continue;
+		}
+
+		if (!strcmp(argv[i].key, "check-fptrs")) {
+			check_fnptrs = true;
+			continue;
+		}
+
+		if (!strcmp(argv[i].key, "check-vars")) {
+			check_vars = true;
+			continue;
+		}
+
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &size_overflow_plugin_info);
+	if (enable) {
+#if BUILDING_GCC_VERSION >= 4009
+		if (flag_sanitize & SANITIZE_SI_OVERFLOW) {
+			error(G_("ubsan SANITIZE_SI_OVERFLOW option is unsupported"));
+			return 1;
+		}
+#endif
+		register_callback(plugin_name, PLUGIN_START_UNIT, &size_overflow_start_unit, NULL);
+		register_callback(plugin_name, PLUGIN_REGISTER_GGC_ROOTS, NULL, (void *)&gt_ggc_r_gt_size_overflow);
+#if BUILDING_GCC_VERSION >= 4009
+		flag_sanitize |= SANITIZE_SI_OVERFLOW;
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &disable_ubsan_si_overflow_pass_info);
+#endif
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &insert_size_overflow_asm_pass_info);
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &size_overflow_pass_info);
+	}
+	register_callback(plugin_name, PLUGIN_ATTRIBUTES, register_attributes, NULL);
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_plugin_hash.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_plugin_hash.c
new file mode 100644
index 000000000..67cacb939
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_plugin_hash.c
@@ -0,0 +1,469 @@
+/*
+ * Copyright 2011-2016 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+#include "e_aux.h"
+#include "disable.h"
+#include "e_fields.h"
+#include "e_fns.h"
+#include "e_fptrs.h"
+#include "e_vars.h"
+
+void initialize_raw_data(struct fn_raw_data *raw_data)
+{
+	raw_data->decl_str = NULL;
+	raw_data->decl = NULL_TREE;
+	raw_data->context = NULL;
+	raw_data->hash = NO_HASH;
+	raw_data->num = NONE_ARGNUM;
+	raw_data->based_decl = SO_NONE;
+	raw_data->orig_decl_str = NULL;
+	raw_data->orig_num = NONE_ARGNUM;
+}
+
+static const_tree get_function_type(const_tree decl)
+{
+	if (FUNCTION_PTR_P(decl))
+		return TREE_TYPE(TREE_TYPE(decl));
+	gcc_assert(TREE_CODE(decl) == FUNCTION_DECL);
+	return TREE_TYPE(decl);
+}
+
+static unsigned char get_tree_code(const_tree type)
+{
+	switch (TREE_CODE(type)) {
+	case ARRAY_TYPE:
+		return 0;
+	case BOOLEAN_TYPE:
+		return 1;
+	case ENUMERAL_TYPE:
+		return 2;
+	case FUNCTION_TYPE:
+		return 3;
+	case INTEGER_TYPE:
+		return 4;
+	case POINTER_TYPE:
+		return 5;
+	case RECORD_TYPE:
+		return 6;
+	case UNION_TYPE:
+		return 7;
+	case VOID_TYPE:
+		return 8;
+	case REAL_TYPE:
+		return 9;
+	case VECTOR_TYPE:
+		return 10;
+	case REFERENCE_TYPE:
+		return 11;
+	case OFFSET_TYPE:
+		return 12;
+	case COMPLEX_TYPE:
+		return 13;
+	default:
+		debug_tree(type);
+		gcc_unreachable();
+	}
+}
+
+// http://www.team5150.com/~andrew/noncryptohashzoo2~/CrapWow.html
+static unsigned int CrapWow(const char *key, unsigned int len, unsigned int seed)
+{
+#define cwfold( a, b, lo, hi ) { p = (unsigned int)(a) * (unsigned long long)(b); lo ^= (unsigned int)p; hi ^= (unsigned int)(p >> 32); }
+#define cwmixa( in ) { cwfold( in, m, k, h ); }
+#define cwmixb( in ) { cwfold( in, n, h, k ); }
+
+	unsigned int m = 0x57559429;
+	unsigned int n = 0x5052acdb;
+	const unsigned int *key4 = (const unsigned int *)key;
+	unsigned int h = len;
+	unsigned int k = len + seed + n;
+	unsigned long long p;
+
+	while (len >= 8) {
+		cwmixb(key4[0]) cwmixa(key4[1]) key4 += 2;
+		len -= 8;
+	}
+	if (len >= 4) {
+		cwmixb(key4[0]) key4 += 1;
+		len -= 4;
+	}
+	if (len)
+		cwmixa(key4[0] & ((1 << (len * 8)) - 1 ));
+	cwmixb(h ^ (k + n));
+	return k ^ h;
+
+#undef cwfold
+#undef cwmixa
+#undef cwmixb
+}
+
+static void set_hash(struct decl_hash *decl_hash_data)
+{
+	unsigned int fn, type, codes, seed = 0;
+
+	fn = CrapWow(decl_hash_data->fn_name, strlen(decl_hash_data->fn_name), seed) & 0xffff;
+	codes = CrapWow((const char*)decl_hash_data->tree_codes, decl_hash_data->tree_codes_len, seed) & 0xffff;
+	type = CrapWow(decl_hash_data->context, strlen(decl_hash_data->context), 0) & 0xffff;
+	decl_hash_data->hash = type ^ fn ^ codes;
+}
+
+static void set_based_decl_codes(const_tree type, struct decl_hash *decl_hash_data)
+{
+	gcc_assert(type != NULL_TREE);
+	gcc_assert(TREE_CODE_CLASS(TREE_CODE(type)) == tcc_type);
+
+	while (type && decl_hash_data->tree_codes_len < CODES_LIMIT) {
+		decl_hash_data->tree_codes[decl_hash_data->tree_codes_len] = get_tree_code(type);
+		decl_hash_data->tree_codes_len++;
+		type = TREE_TYPE(type);
+	}
+}
+
+static void set_result_codes(const_tree node, struct decl_hash *decl_hash_data)
+{
+	const_tree result;
+
+	gcc_assert(node != NULL_TREE);
+
+	if (DECL_P(node)) {
+		result = DECL_RESULT(node);
+		if (result != NULL_TREE)
+			return set_based_decl_codes(TREE_TYPE(result), decl_hash_data);
+		return set_result_codes(TREE_TYPE(node), decl_hash_data);
+	}
+
+	gcc_assert(TYPE_P(node));
+
+	if (TREE_CODE(node) == FUNCTION_TYPE)
+		return set_result_codes(TREE_TYPE(node), decl_hash_data);
+
+	return set_based_decl_codes(node, decl_hash_data);
+}
+
+static void set_decl_codes(struct decl_hash *decl_hash_data)
+{
+	const_tree arg, type;
+	enum tree_code code;
+
+	if (TREE_CODE(decl_hash_data->decl) == VAR_DECL || TREE_CODE(decl_hash_data->decl) == FIELD_DECL) {
+		set_based_decl_codes(TREE_TYPE(decl_hash_data->decl), decl_hash_data);
+		return;
+	}
+
+	type = get_function_type(decl_hash_data->decl);
+	code = TREE_CODE(type);
+	gcc_assert(code == FUNCTION_TYPE || code == METHOD_TYPE);
+
+	if (FUNCTION_PTR_P(decl_hash_data->decl))
+		set_result_codes(type, decl_hash_data);
+	else
+		set_result_codes(decl_hash_data->decl, decl_hash_data);
+
+	for (arg = TYPE_ARG_TYPES(type); arg != NULL_TREE && decl_hash_data->tree_codes_len < CODES_LIMIT; arg = TREE_CHAIN(arg))
+		set_based_decl_codes(TREE_VALUE(arg), decl_hash_data);
+}
+
+static const struct size_overflow_hash *get_proper_hash_chain(const struct size_overflow_hash *entry, struct fn_raw_data *raw_data)
+{
+	gcc_assert(raw_data->orig_decl_str);
+	gcc_assert(raw_data->context);
+
+	for (; entry; entry = entry->next) {
+		if (strcmp(entry->name, raw_data->orig_decl_str))
+			continue;
+		if (!strcmp(entry->context, raw_data->context))
+			return entry;
+	}
+	return NULL;
+}
+
+unsigned int get_decl_hash(const_tree decl, const char *decl_name)
+{
+	struct decl_hash decl_hash_data;
+	enum tree_code code = TREE_CODE(decl);
+
+	gcc_assert(code == FIELD_DECL || code == FUNCTION_DECL || code == VAR_DECL);
+
+	// skip builtins __builtin_constant_p
+	if (code == FUNCTION_DECL && (DECL_BUILT_IN(decl) || DECL_BUILT_IN_CLASS(decl) == BUILT_IN_NORMAL))
+		return NO_HASH;
+
+	decl_hash_data.fn_name = decl_name;
+	decl_hash_data.decl = decl;
+	decl_hash_data.context = get_decl_context(decl);
+	if (!decl_hash_data.context)
+		return NO_HASH;
+	decl_hash_data.tree_codes_len = 0;
+
+	set_decl_codes(&decl_hash_data);
+	gcc_assert(decl_hash_data.tree_codes_len != 0);
+	set_hash(&decl_hash_data);
+	return decl_hash_data.hash;
+}
+
+const char *get_orig_decl_name(const_tree decl)
+{
+	const char *name;
+	unsigned int len;
+	const void *end;
+	const_tree orig_decl;
+
+	if (TREE_CODE(decl) == FUNCTION_DECL)
+		orig_decl = DECL_ORIGIN(decl);
+	else
+		orig_decl = decl;
+
+	len = DECL_NAME_LENGTH(orig_decl);
+	name = DECL_NAME_POINTER(orig_decl);
+
+	/* Sometimes gcc loses the original cgraph node leaving only clones behind.
+	 * In such cases we will extract the name from the clone and use it in the hash table
+	 * without checking the parameter number on the original (unavailable) decl.
+	 */
+
+	if (made_by_compiler(orig_decl)) {
+		end = memchr(name, '.', len);
+		if (!end)
+			return xstrndup(name, len);
+		len = (long)end - (long)name;
+		gcc_assert(len > 0);
+	}
+
+	return xstrndup(name, len);
+}
+
+static const struct size_overflow_hash *get_disable_size_overflow_hash_entry(struct fn_raw_data *raw_data)
+{
+	const struct size_overflow_hash *entry, *entry_node;
+
+	gcc_assert(raw_data->hash != NO_HASH);
+	gcc_assert(raw_data->orig_num != NONE_ARGNUM);
+
+	entry = disable_hash[raw_data->hash];
+	entry_node = get_proper_hash_chain(entry, raw_data);
+	if (entry_node && entry_node->param & (1U << raw_data->orig_num)) {
+		raw_data->based_decl = SO_DISABLE;
+		return entry_node;
+	}
+
+	return NULL;
+}
+
+static const struct size_overflow_hash *get_proper_node(const struct size_overflow_hash *entry_chain, struct fn_raw_data *raw_data)
+{
+	const struct size_overflow_hash *entry_node;
+
+	if (!entry_chain)
+		return NULL;
+
+	gcc_assert(raw_data->orig_num != NONE_ARGNUM);
+
+	entry_node = get_proper_hash_chain(entry_chain, raw_data);
+	if (entry_node && entry_node->param & (1U << raw_data->orig_num))
+		return entry_node;
+	return NULL;
+}
+
+const struct size_overflow_hash *get_size_overflow_hash_entry(struct fn_raw_data *raw_data)
+{
+	const struct size_overflow_hash *entry;
+
+	gcc_assert(raw_data->based_decl == SO_NONE);
+
+	gcc_assert(raw_data->hash != NO_HASH);
+
+	entry = get_proper_node(fns_hash[raw_data->hash], raw_data);
+	if (entry) {
+		raw_data->based_decl = SO_FUNCTION;
+		return check_fns ? entry : NULL;
+	}
+
+	entry = get_proper_node(fields_hash[raw_data->hash], raw_data);
+	if (entry) {
+		raw_data->based_decl = SO_FIELD;
+		return check_fields ? entry : NULL;
+	}
+
+	entry = get_proper_node(vars_hash[raw_data->hash], raw_data);
+	if (entry) {
+		raw_data->based_decl = SO_VAR;
+		return check_vars ? entry : NULL;
+	}
+
+	entry = get_proper_node(fptrs_hash[raw_data->hash], raw_data);
+	if (entry) {
+		raw_data->based_decl = SO_FUNCTION_POINTER;
+		return check_fnptrs ? entry : NULL;
+	}
+
+	entry = get_proper_node(aux_hash[raw_data->hash], raw_data);
+	if (entry) {
+		raw_data->based_decl = SO_AUX;
+		return entry;
+	}
+
+	raw_data->based_decl = SO_NONE;
+	return NULL;
+}
+
+const struct size_overflow_hash *get_size_overflow_hash_entry_tree(struct fn_raw_data *raw_data, bool hash_table)
+{
+	const_tree orig_decl;
+
+	gcc_assert(raw_data->decl != NULL_TREE);
+
+	if (made_by_compiler(raw_data->decl)) {
+		orig_decl = get_orig_fndecl(raw_data->decl);
+		if (raw_data->orig_num == NONE_ARGNUM)
+			raw_data->orig_num = get_correct_argnum(raw_data->decl, orig_decl, raw_data->num);
+	} else {
+		orig_decl = raw_data->decl;
+		raw_data->orig_num = raw_data->num;
+	}
+
+	if (raw_data->orig_num == CANNOT_FIND_ARG)
+		return NULL;
+
+	if (!raw_data->orig_decl_str)
+		raw_data->orig_decl_str = get_orig_decl_name(orig_decl);
+
+	raw_data->hash = get_decl_hash(orig_decl, raw_data->orig_decl_str);
+	if (raw_data->hash == NO_HASH)
+		return NULL;
+
+	if (!raw_data->context)
+		raw_data->context = get_decl_context(orig_decl);
+
+	if (!raw_data->context)
+		return NULL;
+
+	if (hash_table == SIZE_OVERFLOW)
+		return get_size_overflow_hash_entry(raw_data);
+	return get_disable_size_overflow_hash_entry(raw_data);
+}
+
+unsigned int find_arg_number_tree(const_tree arg, const_tree func)
+{
+	tree var;
+	unsigned int argnum = 1;
+
+	if (DECL_ARGUMENTS(func) == NULL_TREE)
+		return CANNOT_FIND_ARG;
+
+	if (TREE_CODE(arg) == SSA_NAME)
+		arg = SSA_NAME_VAR(arg);
+
+	for (var = DECL_ARGUMENTS(func); var; var = TREE_CHAIN(var), argnum++) {
+		if (!operand_equal_p(arg, var, 0) && strcmp(DECL_NAME_POINTER(var), DECL_NAME_POINTER(arg)))
+			continue;
+		if (!skip_types(var))
+			return argnum;
+	}
+
+	return CANNOT_FIND_ARG;
+}
+
+const_tree get_attribute(const char* attr_name, const_tree decl)
+{
+	const_tree attr = lookup_attribute(attr_name, DECL_ATTRIBUTES(decl));
+	if (attr && TREE_VALUE(attr))
+		return attr;
+	return NULL_TREE;
+}
+
+const char *get_based_decl_str(enum based_decl based_decl)
+{
+	switch (based_decl) {
+	case SO_FUNCTION:
+		return "fns";
+	case SO_FIELD:
+		return "fields";
+	case SO_VAR:
+		return "vars";
+	case SO_FUNCTION_POINTER:
+		return "fptrs";
+	case SO_NONE:
+		return "none";
+	case SO_DISABLE:
+		return "disable";
+	case SO_AUX:
+		return "aux";
+	default:
+		gcc_unreachable();
+	}
+}
+
+/* Check if the function has a size_overflow attribute or it is in the size_overflow hash table.
+ * If the function is missing everywhere then print the missing message into stderr.
+ */
+void print_missing_function(next_interesting_function_t node)
+{
+	const struct size_overflow_hash *entry;
+	const char *based_decl;
+	struct fn_raw_data raw_data;
+
+	if (node->marked == ASM_STMT_SO_MARK)
+		return;
+
+	switch (node->based_decl) {
+	case SO_FUNCTION:
+		if (!check_fns)
+			return;
+		break;
+	case SO_FIELD:
+		if (!check_fields)
+			return;
+		break;
+	case SO_VAR:
+		if (!check_vars)
+			return;
+		break;
+	case SO_FUNCTION_POINTER:
+		if (!check_fnptrs)
+			return;
+		break;
+	default:
+		gcc_unreachable();
+	}
+
+	initialize_raw_data(&raw_data);
+	raw_data.context = node->context;
+
+	if (node->orig_next_node) {
+		raw_data.hash = node->orig_next_node->hash;
+		raw_data.orig_decl_str = node->orig_next_node->decl_name;
+		raw_data.orig_num = node->orig_next_node->num;
+		gcc_assert(!strcmp(node->context, node->orig_next_node->context));
+	} else {
+		raw_data.hash = node->hash;
+		raw_data.orig_decl_str = node->decl_name;
+		raw_data.orig_num = node->num;
+	}
+
+	entry = get_size_overflow_hash_entry(&raw_data);
+	if (entry)
+		return;
+
+	based_decl = get_based_decl_str(node->based_decl);
+	// inform() would be too slow
+	fprintf(stderr, "Function %s is missing from the e_%s hash table +%s+%s+%u+%u+\n", raw_data.orig_decl_str, based_decl, raw_data.orig_decl_str, raw_data.context, raw_data.orig_num, raw_data.hash);
+}
+
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_transform.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_transform.c
new file mode 100644
index 000000000..e2cfd207e
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_transform.c
@@ -0,0 +1,772 @@
+/*
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+static tree cast_to_orig_type(struct visited *visited, gimple stmt, const_tree orig_node, tree new_node)
+{
+	gimple def_stmt;
+	const_gimple assign;
+	tree result, orig_type = TREE_TYPE(orig_node);
+	gimple_stmt_iterator gsi;
+
+	if (gimple_code(stmt) != GIMPLE_PHI) {
+		gsi = gsi_for_stmt(stmt);
+		assign = build_cast_stmt(visited, orig_type, new_node, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+		return get_lhs(assign);
+	}
+
+	def_stmt = get_def_stmt(new_node);
+	if (gimple_code(def_stmt) == GIMPLE_PHI)
+		gsi = gsi_after_labels(gimple_bb(def_stmt));
+	else
+		gsi = gsi_for_stmt(def_stmt);
+
+	result = gimple_phi_result(stmt);
+	assign = build_cast_stmt(visited, orig_type, new_node, SSA_NAME_VAR(result), &gsi, AFTER_STMT, false);
+	return get_lhs(assign);
+}
+
+static void change_size_overflow_asm_input(gasm *stmt, tree new_input)
+{
+	tree list;
+
+	gcc_assert(is_size_overflow_insert_check_asm(stmt));
+
+	list = build_tree_list(NULL_TREE, build_const_char_string(3, "rm"));
+	list = chainon(NULL_TREE, build_tree_list(list, new_input));
+	gimple_asm_set_input_op(stmt, 0, list);
+}
+
+static void change_field_write_rhs(gassign *assign, const_tree orig_rhs, tree new_rhs)
+{
+	const_tree rhs1, rhs2, rhs3 = NULL_TREE;
+
+	rhs1 = gimple_assign_rhs1(assign);
+	if (rhs1 == orig_rhs) {
+		gimple_assign_set_rhs1(assign, new_rhs);
+		return;
+	}
+
+	rhs2 = gimple_assign_rhs2(assign);
+	if (rhs2 == orig_rhs) {
+		gimple_assign_set_rhs2(assign, new_rhs);
+		return;
+	}
+
+#if BUILDING_GCC_VERSION >= 4006
+	rhs3 = gimple_assign_rhs3(assign);
+	if (rhs3 == orig_rhs) {
+		gimple_assign_set_rhs3(assign, new_rhs);
+		return;
+	}
+#endif
+
+	debug_gimple_stmt(assign);
+	fprintf(stderr, "orig_rhs:\n");
+	debug_tree(orig_rhs);
+	fprintf(stderr, "rhs1:\n");
+	debug_tree(rhs1);
+	fprintf(stderr, "rhs2:\n");
+	debug_tree(rhs2);
+	fprintf(stderr, "rhs3:\n");
+	debug_tree(rhs3);
+	gcc_unreachable();
+}
+
+static void change_phi_arg(gphi *phi, tree new_node, unsigned int num)
+{
+	unsigned int i;
+	location_t loc = gimple_location(phi);
+
+	for (i = 0; i < gimple_phi_num_args(phi); i++) {
+		if (i == num)
+			add_phi_arg(phi, new_node, gimple_phi_arg_edge(phi, i), loc);
+	}
+}
+
+static void change_orig_node(struct visited *visited, gimple stmt, const_tree orig_node, tree new_node, unsigned int num)
+{
+	tree cast_lhs = cast_to_orig_type(visited, stmt, orig_node, new_node);
+
+	switch (gimple_code(stmt)) {
+	case GIMPLE_RETURN:
+		gimple_return_set_retval(as_a_greturn(stmt), cast_lhs);
+		break;
+	case GIMPLE_CALL:
+		gimple_call_set_arg(as_a_gcall(stmt), num - 1, cast_lhs);
+		break;
+	case GIMPLE_ASM:
+		change_size_overflow_asm_input(as_a_gasm(stmt), cast_lhs);
+		break;
+	case GIMPLE_ASSIGN:
+		change_field_write_rhs(as_a_gassign(stmt), orig_node, cast_lhs);
+		break;
+	case GIMPLE_PHI:
+		change_phi_arg(as_a_gphi(stmt), cast_lhs, num);
+		break;
+	default:
+		debug_gimple_stmt(stmt);
+		gcc_unreachable();
+	}
+
+	update_stmt(stmt);
+}
+
+// e.g., 3.8.2, 64, arch/x86/ia32/ia32_signal.c copy_siginfo_from_user32(): compat_ptr() u32 max
+static bool skip_asm_cast(const_tree arg)
+{
+	gimple def_stmt = get_def_stmt(arg);
+
+	if (!def_stmt || !gimple_assign_cast_p(def_stmt))
+		return false;
+
+	def_stmt = get_def_stmt(gimple_assign_rhs1(def_stmt));
+	if (is_size_overflow_asm(def_stmt))
+		return false;
+	return def_stmt && gimple_code(def_stmt) == GIMPLE_ASM;
+}
+
+static interesting_stmts_t create_interesting_stmts(interesting_stmts_t head, next_interesting_function_t next_node, tree orig_node, gimple first_stmt, unsigned int num)
+{
+	interesting_stmts_t new_node;
+
+	new_node = (interesting_stmts_t )xmalloc(sizeof(*new_node));
+	new_node->first_stmt = first_stmt;
+	new_node->num = num;
+	new_node->orig_node = orig_node;
+	new_node->next = head;
+	new_node->next_node = next_node;
+	return new_node;
+}
+
+static void free_interesting_stmts(interesting_stmts_t head)
+{
+	while (head) {
+		interesting_stmts_t cur = head->next;
+		free(head);
+		head = cur;
+	}
+}
+
+/* This function calls the main recursion function (expand) that duplicates the stmts. Before that it checks the intentional_overflow attribute,
+ * it decides whether the duplication is necessary or not. After expand() it changes the orig node to the duplicated node
+ * in the original stmt (first stmt) and it inserts the overflow check for the arg of the callee or for the return value.
+ */
+static interesting_stmts_t search_interesting_stmt(interesting_stmts_t head, next_interesting_function_t next_node, gimple first_stmt, tree orig_node, unsigned int num)
+{
+	enum tree_code orig_code;
+
+	gcc_assert(orig_node != NULL_TREE);
+
+	if (is_gimple_constant(orig_node))
+		return head;
+
+	orig_code = TREE_CODE(orig_node);
+	gcc_assert(orig_code != FIELD_DECL && orig_code != FUNCTION_DECL);
+
+	if (skip_types(orig_node))
+		return head;
+
+	// find a defining marked caller argument or struct field for arg
+	if (check_intentional_size_overflow_asm_and_attribute(orig_node) != MARK_NO)
+		return head;
+
+	if (skip_asm_cast(orig_node))
+		return head;
+
+	return create_interesting_stmts(head, next_node, orig_node, first_stmt, num);
+}
+
+static bool is_signed_error_code_const(const_tree node)
+{
+	HOST_WIDE_INT constant = tree_to_shwi(node);
+
+	return constant >= -4095 && constant <= -1;
+}
+
+static bool is_unsigned_error_code_const(const_tree node)
+{
+	unsigned HOST_WIDE_INT constant = tree_to_uhwi(node);
+
+	// ulong -4095
+	if (constant >= 0xfffffffffffff001)
+		return true;
+	// uint -4095
+	return constant >= 0xfffff001;
+}
+
+static bool is_error_code_const(const_tree node)
+{
+	enum machine_mode mode;
+
+	if (!is_gimple_constant(node))
+		return false;
+	mode = TYPE_MODE(TREE_TYPE(node));
+	if (mode != SImode && mode != DImode)
+		return false;
+
+	if (!TYPE_UNSIGNED(TREE_TYPE(node)) && is_signed_error_code_const(node))
+		return true;
+	return TYPE_UNSIGNED(TREE_TYPE(node)) && is_unsigned_error_code_const(node);
+}
+
+static bool has_error_code(gphi *phi)
+{
+	unsigned int i, len = gimple_phi_num_args(phi);
+
+	for (i = 0; i < len; i++) {
+		const_tree arg = gimple_phi_arg_def(phi, i);
+
+		if (is_error_code_const(arg))
+			return true;
+	}
+
+	return false;
+}
+
+static interesting_stmts_t search_interesting_rets(interesting_stmts_t head, next_interesting_function_t next_node_ret, greturn *ret)
+{
+	tree first_node;
+
+	if (!next_node_ret || next_node_ret->marked == ASM_STMT_SO_MARK)
+		return head;
+
+	first_node = gimple_return_retval(ret);
+	if (first_node == NULL_TREE)
+		return head;
+
+	return search_interesting_stmt(head, next_node_ret, ret, first_node, 0);
+}
+
+static void handle_binary_assign(interesting_stmts_t expand_from, gassign *assign, tree rhs)
+{
+	tree new_node;
+	gimple def_orig_node;
+
+	new_node = expand(expand_from, rhs);
+	if (new_node == NULL_TREE)
+		return;
+
+	def_orig_node = get_def_stmt(rhs);
+	if (pointer_set_contains(expand_from->visited->no_cast_check, def_orig_node))
+		return;
+	change_orig_node(expand_from->visited, assign, rhs, new_node, 0);
+	check_size_overflow(expand_from, assign, TREE_TYPE(new_node), new_node, rhs, BEFORE_STMT);
+}
+
+static bool search_error_codes(gimple_set *visited_error_codes, interesting_stmts_t expand_from, tree lhs, bool error_code)
+{
+	gimple def_stmt;
+
+	def_stmt = get_def_stmt(lhs);
+	if (!def_stmt || gimple_code(def_stmt) == GIMPLE_NOP)
+		return error_code;
+
+	if (pointer_set_insert(visited_error_codes, def_stmt))
+		return error_code;
+
+	if (is_gimple_constant(lhs))
+		return error_code;
+	if (skip_types(lhs))
+		return is_error_code_const(lhs);
+
+	switch (gimple_code(def_stmt)) {
+	case GIMPLE_CALL:
+	case GIMPLE_ASM:
+		return error_code;
+	case GIMPLE_ASSIGN: {
+		tree rhs1, rhs2;
+		gassign *assign = as_a_gassign(def_stmt);
+
+		switch (gimple_num_ops(assign)) {
+		case 2:
+			return search_error_codes(visited_error_codes, expand_from, gimple_assign_rhs1(def_stmt), error_code);
+		case 3:
+			if (!error_code)
+				return error_code;
+
+			/* Run stmt duplication from the binary assignment ops (rhs1 and rhs2)
+			 * so that size_overflow checking skips the lhs of the last binary assignment
+			 * before the error code PHI.
+			 */
+			rhs1 = gimple_assign_rhs1(assign);
+			handle_binary_assign(expand_from, assign, rhs1);
+			rhs2 = gimple_assign_rhs2(assign);
+			handle_binary_assign(expand_from, assign, rhs2);
+			return error_code;
+		}
+		gcc_unreachable();
+	}
+	case GIMPLE_PHI: {
+		unsigned int i;
+
+		error_code = has_error_code(as_a_gphi(def_stmt));
+		for (i = 0; i < gimple_phi_num_args(def_stmt); i++) {
+			error_code = search_error_codes(visited_error_codes, expand_from, gimple_phi_arg_def(def_stmt, i), error_code);
+		}
+		return error_code;
+	}
+	default:
+		debug_gimple_stmt(def_stmt);
+		error("%s: unknown gimple code", __func__);
+		gcc_unreachable();
+	}
+}
+
+static bool handle_error_codes(interesting_stmts_t expand_from)
+{
+	bool error_code;
+	gimple_set *visited_error_codes;
+
+	// expand the data flow from a return stmt
+	if (expand_from->next_node->num != 0 || strcmp(expand_from->next_node->context, "fndecl"))
+		return false;
+
+	visited_error_codes = pointer_set_create();
+	error_code = search_error_codes(visited_error_codes, expand_from, expand_from->orig_node, false);
+	pointer_set_destroy(visited_error_codes);
+
+	return error_code;
+}
+
+static void handle_interesting_stmt(struct visited *visited, interesting_stmts_t head)
+{
+	interesting_stmts_t cur;
+
+	for (cur = head; cur; cur = cur->next) {
+		tree new_node;
+		gimple orig_def_stmt;
+
+		cur->visited = visited;
+		if (handle_error_codes(cur))
+			continue;
+
+		new_node = expand(cur, cur->orig_node);
+		if (new_node == NULL_TREE)
+			continue;
+
+		orig_def_stmt = get_def_stmt(cur->orig_node);
+		if (pointer_set_contains(visited->no_cast_check, orig_def_stmt))
+			continue;
+		change_orig_node(visited, cur->first_stmt, cur->orig_node, new_node, cur->num);
+		check_size_overflow(cur, cur->first_stmt, TREE_TYPE(new_node), new_node, cur->orig_node, BEFORE_STMT);
+	}
+}
+
+static next_interesting_function_t get_interesting_function_next_node(tree decl, unsigned int num)
+{
+	next_interesting_function_t next_node;
+	const struct size_overflow_hash *so_hash;
+	struct fn_raw_data raw_data;
+
+	initialize_raw_data(&raw_data);
+	raw_data.decl = decl;
+	raw_data.decl_str = DECL_NAME_POINTER(decl);
+	raw_data.num = num;
+	raw_data.marked = YES_SO_MARK;
+
+	so_hash = get_size_overflow_hash_entry_tree(&raw_data, SIZE_OVERFLOW);
+	if (so_hash)
+		return get_and_create_next_node_from_global_next_nodes(&raw_data, NULL);
+	if (!so_hash && raw_data.based_decl != SO_NONE)
+		return NULL;
+
+	next_node = get_global_next_interesting_function_entry_with_hash(&raw_data);
+	if (next_node && next_node->marked != NO_SO_MARK) {
+		switch (next_node->based_decl) {
+		case SO_FUNCTION:
+			if (check_fns)
+				return next_node;
+			return NULL;
+		case SO_FIELD:
+			if (check_fields)
+				return next_node;
+			return NULL;
+		case SO_VAR:
+			if (check_vars)
+				return next_node;
+			return NULL;
+		case SO_FUNCTION_POINTER:
+			if (check_fnptrs)
+				return next_node;
+			return NULL;
+		default:
+			gcc_unreachable();
+		}
+	}
+
+	return NULL;
+}
+
+tree handle_fnptr_assign(const_gimple stmt)
+{
+	tree field, rhs, op0;
+	const_tree op0_type;
+	enum tree_code rhs_code;
+
+	// TODO skip binary assignments for now (fs/sync.c _591 = __bpf_call_base + _590;)
+	if (gimple_num_ops(stmt) != 2)
+		return NULL_TREE;
+
+	gcc_assert(gimple_num_ops(stmt) == 2);
+	// TODO skip asm_stmt for now
+	if (gimple_code(stmt) == GIMPLE_ASM)
+		return NULL_TREE;
+	rhs = gimple_assign_rhs1(stmt);
+	if (is_gimple_constant(rhs))
+		return NULL_TREE;
+
+	rhs_code = TREE_CODE(rhs);
+	if (rhs_code == VAR_DECL)
+		return rhs;
+
+	switch (rhs_code) {
+	case ADDR_EXPR:
+		op0 = TREE_OPERAND(rhs, 0);
+		if (TREE_CODE(op0) == FUNCTION_DECL)
+			return op0;
+		return NULL_TREE;
+	case COMPONENT_REF:
+		break;
+	// TODO skip array_ref for now
+	case ARRAY_REF:
+		return NULL_TREE;
+	// TODO skip ssa_name because it can lead to parm_decl
+	case SSA_NAME:
+		return NULL_TREE;
+	// TODO skip mem_ref and indirect_ref for now
+#if BUILDING_GCC_VERSION >= 4006
+	case MEM_REF:
+#endif
+	case INDIRECT_REF:
+		return NULL_TREE;
+	default:
+		debug_tree(rhs);
+		debug_gimple_stmt((gimple)stmt);
+		gcc_unreachable();
+	}
+
+	op0 = TREE_OPERAND(rhs, 0);
+	switch (TREE_CODE(op0)) {
+	// TODO skip array_ref and parm_decl for now
+	case ARRAY_REF:
+	case PARM_DECL:
+		return NULL_TREE;
+	case COMPONENT_REF:
+#if BUILDING_GCC_VERSION >= 4006
+	case MEM_REF:
+#endif
+	case INDIRECT_REF:
+	case VAR_DECL:
+		break;
+	default:
+		debug_tree(op0);
+		gcc_unreachable();
+	}
+
+	op0_type = TREE_TYPE(op0);
+	// TODO skip unions for now
+	if (TREE_CODE(op0_type) == UNION_TYPE)
+		return NULL_TREE;
+	gcc_assert(TREE_CODE(op0_type) == RECORD_TYPE);
+
+	field = TREE_OPERAND(rhs, 1);
+	gcc_assert(TREE_CODE(field) == FIELD_DECL);
+	return field;
+}
+
+static tree get_fn_or_fnptr_decl(const gcall *call_stmt)
+{
+	const_tree fnptr;
+	const_gimple def_stmt;
+	tree decl = gimple_call_fndecl(call_stmt);
+
+	if (decl != NULL_TREE)
+		return decl;
+
+	fnptr = gimple_call_fn(call_stmt);
+	if (fnptr == NULL_TREE)
+		return NULL_TREE;
+
+	// !!! assertot kell irni 0-ra, mert csak az lehet ott
+	if (is_gimple_constant(fnptr))
+		return NULL_TREE;
+	def_stmt = get_fnptr_def_stmt(fnptr);
+	return handle_fnptr_assign(def_stmt);
+}
+
+// Start stmt duplication on marked function parameters
+static interesting_stmts_t search_interesting_calls(interesting_stmts_t head, gcall *call_stmt)
+{
+	tree decl;
+	unsigned int i, len;
+
+	len = gimple_call_num_args(call_stmt);
+	if (len == 0)
+		return head;
+
+	decl = get_fn_or_fnptr_decl(call_stmt);
+	if (decl == NULL_TREE)
+		return head;
+
+	for (i = 0; i < len; i++) {
+		tree arg;
+		next_interesting_function_t next_node;
+
+		arg = gimple_call_arg(call_stmt, i);
+		if (is_gimple_constant(arg))
+			continue;
+		if (skip_types(arg))
+			continue;
+		next_node = get_interesting_function_next_node(decl, i + 1);
+		if (next_node)
+			head = search_interesting_stmt(head, next_node, call_stmt, arg, i + 1);
+	}
+
+	return head;
+}
+
+// Find assignements to structure fields and vardecls
+static interesting_stmts_t search_interesting_structs_vardecls(interesting_stmts_t head, gassign *assign)
+{
+	enum intentional_mark mark;
+	next_interesting_function_t next_node;
+	tree rhs1, rhs2, lhs, decl;
+#if BUILDING_GCC_VERSION >= 4006
+	tree rhs3;
+#endif
+
+	lhs = gimple_assign_lhs(assign);
+
+	if (VAR_P(lhs))
+		decl = lhs;
+	else
+		decl = get_ref_field(lhs);
+	if (decl == NULL_TREE)
+		return head;
+	if (DECL_NAME(decl) == NULL_TREE)
+		return head;
+
+	if (is_bitfield_unnamed_cast(decl, assign))
+		return head;
+
+	next_node = get_interesting_function_next_node(decl, 0);
+	if (!next_node)
+		return head;
+
+	mark = get_intentional_attr_type(decl);
+	if (mark != MARK_NO)
+		return head;
+
+	rhs1 = gimple_assign_rhs1(assign);
+	head = search_interesting_stmt(head, next_node, assign, rhs1, 0);
+
+	rhs2 = gimple_assign_rhs2(assign);
+	if (rhs2)
+		head = search_interesting_stmt(head, next_node, assign, rhs2, 0);
+
+#if BUILDING_GCC_VERSION >= 4006
+	rhs3 = gimple_assign_rhs3(assign);
+	if (rhs3)
+		head = search_interesting_stmt(head, next_node, assign, rhs3, 0);
+#endif
+	return head;
+}
+
+static next_interesting_function_t create_so_asm_next_interesting_function_node(const gasm *stmt)
+{
+	next_interesting_function_t next_node;
+	struct fn_raw_data raw_data;
+
+	initialize_raw_data(&raw_data);
+	raw_data.decl_str = gimple_asm_string(stmt);
+	raw_data.context = "attr";
+	raw_data.hash = 0;
+	raw_data.num = 0;
+	raw_data.marked = ASM_STMT_SO_MARK;
+	raw_data.based_decl = SO_FUNCTION;
+
+	next_node = get_global_next_interesting_function_entry(&raw_data);
+	if (next_node)
+		return next_node;
+	next_node = create_new_next_interesting_entry(&raw_data, NULL);
+	gcc_assert(next_node);
+
+	add_to_global_next_interesting_function(next_node);
+	return next_node;
+}
+
+// Collect interesting stmts for duplication
+static void search_interesting_stmts(struct visited *visited)
+{
+	basic_block bb;
+	next_interesting_function_t next_node_ret;
+	interesting_stmts_t head = NULL;
+
+	next_node_ret = get_interesting_function_next_node(current_function_decl, 0);
+
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			gimple stmt = gsi_stmt(gsi);
+
+			switch (gimple_code(stmt)) {
+			case GIMPLE_ASM: {
+				tree first_node;
+				next_interesting_function_t next_node;
+				const gasm *asm_stmt = as_a_gasm(stmt);
+
+				if (!check_fns)
+					continue;
+
+				if (!is_size_overflow_insert_check_asm(asm_stmt))
+					continue;
+				next_node = create_so_asm_next_interesting_function_node(asm_stmt);
+				first_node = get_size_overflow_asm_input(asm_stmt);
+				head = search_interesting_stmt(head, next_node, stmt, first_node, 0);
+				break;
+			}
+			case GIMPLE_RETURN:
+				head = search_interesting_rets(head, next_node_ret, as_a_greturn(stmt));
+				break;
+			case GIMPLE_CALL:
+				head = search_interesting_calls(head, as_a_gcall(stmt));
+				break;
+			case GIMPLE_ASSIGN:
+				/* !!! TODO LTO modeban nincs duplikalas a globalis valtozora, mert a tree mergek
+				 * utan mar nem lehet megkulonboztetni attol a globalis valtozotol, aminek a scopeja csak a file
+				 * igy a context nem vardecl lesz, hanem vardecl_filenev. De execute-ban kiirja, ha hianyzik a hash tablabol
+				 * IPA-ban van duplikalas.
+				 */
+				head = search_interesting_structs_vardecls(head, as_a_gassign(stmt));
+				break;
+			default:
+				break;
+			}
+		}
+	}
+
+	handle_interesting_stmt(visited, head);
+	free_interesting_stmts(head);
+}
+
+static struct visited *create_visited(void)
+{
+	struct visited *new_node;
+
+	new_node = (struct visited *)xmalloc(sizeof(*new_node));
+	new_node->stmts = pointer_set_create();
+	new_node->my_stmts = pointer_set_create();
+	new_node->skip_expr_casts = pointer_set_create();
+	new_node->no_cast_check = pointer_set_create();
+	return new_node;
+}
+
+static void free_visited(struct visited *visited)
+{
+	pointer_set_destroy(visited->stmts);
+	pointer_set_destroy(visited->my_stmts);
+	pointer_set_destroy(visited->skip_expr_casts);
+	pointer_set_destroy(visited->no_cast_check);
+
+	free(visited);
+}
+
+// Remove the size_overflow asm stmt and create an assignment from the input and output of the asm
+static void replace_size_overflow_asm_with_assign(gasm *asm_stmt, tree lhs, tree rhs)
+{
+	gassign *assign;
+	gimple_stmt_iterator gsi;
+
+	// already removed
+	if (gimple_bb(asm_stmt) == NULL)
+		return;
+	gsi = gsi_for_stmt(asm_stmt);
+
+	assign = gimple_build_assign(lhs, rhs);
+	gsi_insert_before(&gsi, assign, GSI_SAME_STMT);
+	SSA_NAME_DEF_STMT(lhs) = assign;
+
+	gsi_remove(&gsi, true);
+}
+
+// Replace our asm stmts with assignments (they are no longer needed and may interfere with later optimizations)
+static void remove_size_overflow_asm(gimple stmt)
+{
+	gimple_stmt_iterator gsi;
+	tree input, output;
+
+	if (!is_size_overflow_asm(stmt))
+		return;
+
+	if (gimple_asm_noutputs(as_a_gasm(stmt)) == 0) {
+		gsi = gsi_for_stmt(stmt);
+
+		ipa_remove_stmt_references(cgraph_get_node(current_function_decl), stmt);
+		gsi_remove(&gsi, true);
+		return;
+	}
+
+	input = gimple_asm_input_op(as_a_gasm(stmt), 0);
+	output = gimple_asm_output_op(as_a_gasm(stmt), 0);
+	replace_size_overflow_asm_with_assign(as_a_gasm(stmt), TREE_VALUE(output), TREE_VALUE(input));
+}
+
+static void remove_all_size_overflow_asm(void)
+{
+	basic_block bb;
+
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator si;
+
+		for (si = gsi_start_bb(bb); !gsi_end_p(si); gsi_next(&si))
+			remove_size_overflow_asm(gsi_stmt(si));
+	}
+}
+
+unsigned int size_overflow_function_transform(struct cgraph_node *node __unused)
+{
+	struct visited *visited;
+
+#if BUILDING_GCC_VERSION >= 4008
+	if (dump_file) {
+		fprintf(dump_file, "BEFORE TRANSFORM -------------------------\n");
+		size_overflow_dump_function(dump_file, node);
+	}
+#endif
+	visited = create_visited();
+	set_dominance_info();
+
+	search_interesting_stmts(visited);
+
+	remove_all_size_overflow_asm();
+
+	unset_dominance_info();
+	free_visited(visited);
+
+#if BUILDING_GCC_VERSION >= 4008
+	if (dump_file) {
+		fprintf(dump_file, "AFTER TRANSFORM -------------------------\n");
+		size_overflow_dump_function(dump_file, node);
+	}
+#endif
+	return TODO_dump_func | TODO_verify_stmts | TODO_remove_unused_locals | TODO_update_ssa_no_phi | TODO_ggc_collect | TODO_verify_flow;
+}
diff --git b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_transform_core.c b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_transform_core.c
new file mode 100644
index 000000000..7b24aea40
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/size_overflow_transform_core.c
@@ -0,0 +1,1013 @@
+/*
+ * Copyright 2011-2017 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+#define MIN_CHECK true
+#define MAX_CHECK false
+
+unsigned int call_count = 0;
+
+tree get_size_overflow_type(struct visited *visited, const_gimple stmt, const_tree node)
+{
+	const_tree type;
+	tree new_type;
+
+	gcc_assert(node != NULL_TREE);
+
+	type = TREE_TYPE(node);
+
+	if (pointer_set_contains(visited->my_stmts, stmt))
+		return TREE_TYPE(node);
+
+	switch (TYPE_MODE(type)) {
+	case QImode:
+	case HImode:
+		new_type = size_overflow_type_SI;
+		break;
+	case SImode:
+		new_type = size_overflow_type_DI;
+		break;
+	case DImode:
+		if (LONG_TYPE_SIZE == GET_MODE_BITSIZE(SImode))
+			new_type = TYPE_UNSIGNED(type) ? unsigned_intDI_type_node : intDI_type_node;
+		else
+			new_type = size_overflow_type_TI;
+		break;
+	case TImode:
+		gcc_assert(!TYPE_UNSIGNED(type));
+		new_type = size_overflow_type_TI;
+		break;
+	default:
+		debug_tree(node);
+		error("%s: unsupported gcc configuration (%qE).", __func__, current_function_decl);
+		gcc_unreachable();
+	}
+
+	if (TYPE_QUALS(type) != 0)
+		return build_qualified_type(new_type, TYPE_QUALS(type));
+	return new_type;
+}
+
+tree cast_to_new_size_overflow_type(struct visited *visited, gimple stmt, tree rhs, tree size_overflow_type, bool before)
+{
+	gimple_stmt_iterator gsi;
+	gimple new_stmt;
+
+	if (rhs == NULL_TREE)
+		return NULL_TREE;
+
+	gsi = gsi_for_stmt(stmt);
+	new_stmt = build_cast_stmt(visited, size_overflow_type, rhs, CREATE_NEW_VAR, &gsi, before, false);
+	if (gimple_assign_cast_p(new_stmt))
+		gimple_assign_set_rhs_code(new_stmt, CONVERT_EXPR);
+	pointer_set_insert(visited->my_stmts, new_stmt);
+
+	return get_lhs(new_stmt);
+}
+
+tree create_assign(struct visited *visited, gimple oldstmt, tree rhs1, bool before)
+{
+	tree lhs, dst_type;
+	gimple_stmt_iterator gsi;
+
+	if (rhs1 == NULL_TREE) {
+		debug_gimple_stmt(oldstmt);
+		error("%s: rhs1 is NULL_TREE", __func__);
+		gcc_unreachable();
+	}
+
+	switch (gimple_code(oldstmt)) {
+	case GIMPLE_ASM:
+		lhs = rhs1;
+		break;
+	case GIMPLE_CALL:
+	case GIMPLE_ASSIGN:
+		lhs = gimple_get_lhs(oldstmt);
+		break;
+	default:
+		debug_gimple_stmt(oldstmt);
+		gcc_unreachable();
+	}
+
+	gsi = gsi_for_stmt(oldstmt);
+	pointer_set_insert(visited->stmts, oldstmt);
+	if (lookup_stmt_eh_lp(oldstmt) != 0) {
+		basic_block next_bb, cur_bb;
+		const_edge e;
+
+		gcc_assert(before == false);
+		gcc_assert(stmt_can_throw_internal(oldstmt));
+		gcc_assert(gimple_code(oldstmt) == GIMPLE_CALL);
+		gcc_assert(!gsi_end_p(gsi));
+
+		cur_bb = gimple_bb(oldstmt);
+		next_bb = cur_bb->next_bb;
+		e = find_edge(cur_bb, next_bb);
+		gcc_assert(e != NULL);
+		gcc_assert(e->flags & EDGE_FALLTHRU);
+
+		gsi = gsi_after_labels(next_bb);
+		gcc_assert(!gsi_end_p(gsi));
+
+		before = true;
+		oldstmt = gsi_stmt(gsi);
+	}
+
+	if (is_gimple_constant(rhs1) && TREE_CODE_CLASS(gimple_assign_rhs_code(oldstmt)) == tcc_comparison)
+		dst_type = get_size_overflow_type(visited, oldstmt, rhs1);
+	else
+		dst_type = get_size_overflow_type(visited, oldstmt, lhs);
+
+	if (is_gimple_constant(rhs1))
+		return cast_a_tree(dst_type, rhs1);
+	return cast_to_new_size_overflow_type(visited, oldstmt, rhs1, dst_type, before);
+}
+
+tree dup_assign(struct visited *visited, gassign *oldstmt, const_tree node, tree rhs1, tree rhs2, tree __unused rhs3)
+{
+	gassign *stmt;
+	gimple_stmt_iterator gsi;
+	tree size_overflow_type, new_var, lhs = gimple_assign_lhs(oldstmt);
+
+	if (pointer_set_contains(visited->my_stmts, oldstmt))
+		return lhs;
+
+	if (gimple_num_ops(oldstmt) != 4 && rhs1 == NULL_TREE) {
+		rhs1 = gimple_assign_rhs1(oldstmt);
+		rhs1 = create_assign(visited, oldstmt, rhs1, BEFORE_STMT);
+	}
+	if (gimple_num_ops(oldstmt) == 3 && rhs2 == NULL_TREE) {
+		rhs2 = gimple_assign_rhs2(oldstmt);
+		rhs2 = create_assign(visited, oldstmt, rhs2, BEFORE_STMT);
+	}
+
+	stmt = as_a_gassign(gimple_copy(oldstmt));
+	gimple_set_location(stmt, gimple_location(oldstmt));
+	pointer_set_insert(visited->my_stmts, stmt);
+
+	if (gimple_assign_rhs_code(oldstmt) == WIDEN_MULT_EXPR)
+		gimple_assign_set_rhs_code(stmt, MULT_EXPR);
+
+	size_overflow_type = get_size_overflow_type(visited, oldstmt, node);
+
+	new_var = create_new_var(size_overflow_type);
+	new_var = make_ssa_name(new_var, stmt);
+	gimple_assign_set_lhs(stmt, new_var);
+
+	if (rhs1 != NULL_TREE)
+		gimple_assign_set_rhs1(stmt, rhs1);
+
+	if (rhs2 != NULL_TREE)
+		gimple_assign_set_rhs2(stmt, rhs2);
+#if BUILDING_GCC_VERSION >= 4006
+	if (rhs3 != NULL_TREE)
+		gimple_assign_set_rhs3(stmt, rhs3);
+#endif
+	gimple_set_vuse(stmt, gimple_vuse(oldstmt));
+	gimple_set_vdef(stmt, gimple_vdef(oldstmt));
+
+	gsi = gsi_for_stmt(oldstmt);
+	gsi_insert_after(&gsi, stmt, GSI_SAME_STMT);
+	update_stmt(stmt);
+	pointer_set_insert(visited->stmts, oldstmt);
+	return gimple_assign_lhs(stmt);
+}
+
+static tree cast_parm_decl(struct visited *visited, tree phi_ssa_name, tree arg, tree size_overflow_type, basic_block bb)
+{
+	const_gimple assign;
+	gimple_stmt_iterator gsi;
+	basic_block first_bb;
+
+	gcc_assert(SSA_NAME_IS_DEFAULT_DEF(arg));
+
+	if (bb->index == 0) {
+		first_bb = split_block_after_labels(ENTRY_BLOCK_PTR_FOR_FN(cfun))->dest;
+		gcc_assert(dom_info_available_p(CDI_DOMINATORS));
+		set_immediate_dominator(CDI_DOMINATORS, first_bb, ENTRY_BLOCK_PTR_FOR_FN(cfun));
+		bb = first_bb;
+	}
+
+	gsi = gsi_after_labels(bb);
+	assign = build_cast_stmt(visited, size_overflow_type, arg, phi_ssa_name, &gsi, BEFORE_STMT, false);
+	pointer_set_insert(visited->my_stmts, assign);
+	return get_lhs(assign);
+}
+
+static tree use_phi_ssa_name(struct visited *visited, tree ssa_name_var, tree new_arg)
+{
+	gimple_stmt_iterator gsi;
+	const_gimple assign;
+	gimple def_stmt = get_def_stmt(new_arg);
+
+	if (gimple_code(def_stmt) == GIMPLE_PHI) {
+		gsi = gsi_after_labels(gimple_bb(def_stmt));
+		assign = build_cast_stmt(visited, TREE_TYPE(new_arg), new_arg, ssa_name_var, &gsi, BEFORE_STMT, true);
+	} else {
+		gsi = gsi_for_stmt(def_stmt);
+		assign = build_cast_stmt(visited, TREE_TYPE(new_arg), new_arg, ssa_name_var, &gsi, AFTER_STMT, true);
+	}
+
+	pointer_set_insert(visited->my_stmts, assign);
+	return get_lhs(assign);
+}
+
+static tree cast_visited_phi_arg(struct visited *visited, tree ssa_name_var, tree arg, tree size_overflow_type)
+{
+	basic_block bb;
+	gimple_stmt_iterator gsi;
+	const_gimple def_stmt;
+	const_gimple assign;
+
+	def_stmt = get_def_stmt(arg);
+	bb = gimple_bb(def_stmt);
+	gcc_assert(bb->index != 0);
+	gsi = gsi_after_labels(bb);
+
+	assign = build_cast_stmt(visited, size_overflow_type, arg, ssa_name_var, &gsi, BEFORE_STMT, false);
+	pointer_set_insert(visited->my_stmts, assign);
+	return get_lhs(assign);
+}
+
+static tree create_new_phi_arg(struct visited *visited, tree ssa_name_var, tree new_arg, gphi *oldstmt, unsigned int i)
+{
+	tree size_overflow_type;
+	tree arg;
+	const_gimple def_stmt;
+
+	if (new_arg != NULL_TREE && is_gimple_constant(new_arg))
+		return new_arg;
+
+	arg = gimple_phi_arg_def(oldstmt, i);
+	def_stmt = get_def_stmt(arg);
+	gcc_assert(def_stmt != NULL);
+	size_overflow_type = get_size_overflow_type(visited, oldstmt, arg);
+
+	switch (gimple_code(def_stmt)) {
+	case GIMPLE_PHI:
+		return cast_visited_phi_arg(visited, ssa_name_var, arg, size_overflow_type);
+	case GIMPLE_NOP: {
+		basic_block bb;
+
+		bb = gimple_phi_arg_edge(oldstmt, i)->src;
+		return cast_parm_decl(visited, ssa_name_var, arg, size_overflow_type, bb);
+	}
+	case GIMPLE_ASM: {
+		gimple_stmt_iterator gsi;
+		const_gimple assign;
+		gimple stmt = get_def_stmt(arg);
+
+		gsi = gsi_for_stmt(stmt);
+		assign = build_cast_stmt(visited, size_overflow_type, arg, ssa_name_var, &gsi, AFTER_STMT, false);
+		pointer_set_insert(visited->my_stmts, assign);
+		return get_lhs(assign);
+	}
+	default:
+		gcc_assert(new_arg != NULL_TREE);
+		gcc_assert(types_compatible_p(TREE_TYPE(new_arg), size_overflow_type));
+		return use_phi_ssa_name(visited, ssa_name_var, new_arg);
+	}
+}
+
+static gphi *overflow_create_phi_node(struct visited *visited, gphi *oldstmt, tree result)
+{
+	basic_block bb;
+	gphi *phi;
+	gimple_seq seq;
+	gimple_stmt_iterator gsi = gsi_for_stmt(oldstmt);
+
+	bb = gsi_bb(gsi);
+
+	if (result == NULL_TREE) {
+		tree old_result = gimple_phi_result(oldstmt);
+		tree size_overflow_type = get_size_overflow_type(visited, oldstmt, old_result);
+
+		result = create_new_var(size_overflow_type);
+	}
+
+	phi = as_a_gphi(create_phi_node(result, bb));
+	gimple_phi_set_result(phi, make_ssa_name(result, phi));
+	seq = phi_nodes(bb);
+	gsi = gsi_last(seq);
+	gsi_remove(&gsi, false);
+
+	gsi = gsi_for_stmt(oldstmt);
+	gsi_insert_after(&gsi, phi, GSI_NEW_STMT);
+	gimple_set_bb(phi, bb);
+	return phi;
+}
+
+#if BUILDING_GCC_VERSION <= 4007
+static tree create_new_phi_node(struct visited *visited, VEC(tree, heap) **args, tree ssa_name_var, gimple oldstmt)
+#else
+static tree create_new_phi_node(struct visited *visited, vec<tree, va_heap, vl_embed> *&args, tree ssa_name_var, gphi *oldstmt)
+#endif
+{
+	gphi *new_phi;
+	unsigned int i;
+	tree arg, result;
+	location_t loc = gimple_location(oldstmt);
+
+#if BUILDING_GCC_VERSION <= 4007
+	gcc_assert(!VEC_empty(tree, *args));
+#else
+	gcc_assert(!args->is_empty());
+#endif
+
+	new_phi = overflow_create_phi_node(visited, oldstmt, ssa_name_var);
+	result = gimple_phi_result(new_phi);
+	ssa_name_var = SSA_NAME_VAR(result);
+
+#if BUILDING_GCC_VERSION <= 4007
+	FOR_EACH_VEC_ELT(tree, *args, i, arg) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(args, i, arg) {
+#endif
+		arg = create_new_phi_arg(visited, ssa_name_var, arg, oldstmt, i);
+		add_phi_arg(new_phi, arg, gimple_phi_arg_edge(oldstmt, i), loc);
+	}
+
+#if BUILDING_GCC_VERSION <= 4007
+	VEC_free(tree, heap, *args);
+#else
+	vec_free(args);
+#endif
+	update_stmt(new_phi);
+	pointer_set_insert(visited->my_stmts, new_phi);
+	return result;
+}
+
+static tree handle_phi(interesting_stmts_t expand_from, tree orig_result)
+{
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(tree, heap) *args = NULL;
+#else
+	vec<tree, va_heap, vl_embed> *args = NULL;
+#endif
+	unsigned int i, len;
+	tree ssa_name_var = NULL_TREE;
+	gphi *oldstmt = as_a_gphi(get_def_stmt(orig_result));
+
+	len = gimple_phi_num_args(oldstmt);
+	pointer_set_insert(expand_from->visited->stmts, oldstmt);
+	for (i = 0; i < len; i++) {
+		tree arg, new_arg;
+
+		arg = gimple_phi_arg_def(oldstmt, i);
+		new_arg = expand(expand_from, arg);
+
+		if (ssa_name_var == NULL_TREE && new_arg != NULL_TREE)
+			ssa_name_var = SSA_NAME_VAR(new_arg);
+
+		if (is_gimple_constant(arg)) {
+			tree size_overflow_type = get_size_overflow_type(expand_from->visited, oldstmt, arg);
+
+			new_arg = cast_a_tree(size_overflow_type, arg);
+		}
+
+#if BUILDING_GCC_VERSION <= 4007
+		VEC_safe_push(tree, heap, args, new_arg);
+#else
+		vec_safe_push(args, new_arg);
+#endif
+	}
+
+#if BUILDING_GCC_VERSION <= 4007
+	return create_new_phi_node(expand_from->visited, &args, ssa_name_var, oldstmt);
+#else
+	return create_new_phi_node(expand_from->visited, args, ssa_name_var, oldstmt);
+#endif
+}
+
+static tree create_cast_assign(struct visited *visited, gassign *stmt)
+{
+	tree rhs1 = gimple_assign_rhs1(stmt);
+	tree lhs = gimple_assign_lhs(stmt);
+	const_tree rhs1_type = TREE_TYPE(rhs1);
+	const_tree lhs_type = TREE_TYPE(lhs);
+
+	if (TYPE_UNSIGNED(rhs1_type) == TYPE_UNSIGNED(lhs_type))
+		return create_assign(visited, stmt, lhs, AFTER_STMT);
+
+	return create_assign(visited, stmt, rhs1, AFTER_STMT);
+}
+
+static bool skip_lhs_cast_check(struct visited *visited, const gassign *stmt)
+{
+	const_tree rhs = gimple_assign_rhs1(stmt);
+	const_gimple def_stmt = get_def_stmt(rhs);
+
+	// 3.8.2 kernel/futex_compat.c compat_exit_robust_list(): get_user() 64 ulong -> int (compat_long_t), int max
+	if (gimple_code(def_stmt) == GIMPLE_ASM)
+		return true;
+
+	if (is_const_plus_unsigned_signed_truncation(rhs)) {
+		pointer_set_insert(visited->no_cast_check, stmt);
+		return true;
+	}
+
+	return false;
+}
+
+static tree create_string_param(tree string)
+{
+	return build1(ADDR_EXPR, ptr_type_node, string);
+}
+
+static void insert_cond(basic_block cond_bb, tree arg, enum tree_code cond_code, tree type_value)
+{
+	gcond *cond_stmt;
+	gimple_stmt_iterator gsi = gsi_last_bb(cond_bb);
+
+	cond_stmt = gimple_build_cond(cond_code, arg, type_value, NULL_TREE, NULL_TREE);
+	gsi_insert_after(&gsi, cond_stmt, GSI_CONTINUE_LINKING);
+	update_stmt(cond_stmt);
+}
+
+static void insert_cond_result(interesting_stmts_t expand_from, basic_block bb_true, const_gimple stmt, const_tree arg, bool min)
+{
+	gcall *func_stmt;
+	const_gimple def_stmt;
+	const_tree loc_line;
+	tree loc_file, ssa_name, current_func;
+	expanded_location xloc;
+	char *ssa_name_buf;
+	int len;
+	struct cgraph_edge *edge;
+	struct cgraph_node *report_node;
+	int frequency;
+	gimple_stmt_iterator gsi = gsi_start_bb(bb_true);
+
+	def_stmt = get_def_stmt(arg);
+	if (gimple_has_location(def_stmt))
+		xloc = expand_location(gimple_location(def_stmt));
+	else if (gimple_has_location(stmt))
+		xloc = expand_location(gimple_location(stmt));
+	else
+		xloc = expand_location(DECL_SOURCE_LOCATION(current_function_decl));
+
+	loc_line = build_int_cstu(unsigned_type_node, xloc.line);
+
+	loc_file = build_const_char_string(strlen(xloc.file) + 1, xloc.file);
+	loc_file = create_string_param(loc_file);
+
+	current_func = build_const_char_string(DECL_NAME_LENGTH(current_function_decl) + 1, DECL_NAME_POINTER(current_function_decl));
+	current_func = create_string_param(current_func);
+
+	gcc_assert(DECL_NAME(SSA_NAME_VAR(arg)) != NULL);
+	call_count++;
+	len = asprintf(&ssa_name_buf, "%s_%u %s, count: %u, decl: %s; num: %u; context: %s;\n", DECL_NAME_POINTER(SSA_NAME_VAR(arg)), SSA_NAME_VERSION(arg), min ? "min" : "max", call_count, expand_from->next_node->decl_name, expand_from->next_node->num, expand_from->next_node->context);
+	gcc_assert(len > 0);
+	ssa_name = build_const_char_string(len + 1, ssa_name_buf);
+	free(ssa_name_buf);
+	ssa_name = create_string_param(ssa_name);
+
+	// void report_size_overflow(const char *file, unsigned int line, const char *func, const char *ssa_name)
+	func_stmt = as_a_gcall(gimple_build_call(report_size_overflow_decl, 4, loc_file, loc_line, current_func, ssa_name));
+	gsi_insert_after(&gsi, func_stmt, GSI_CONTINUE_LINKING);
+
+	report_node = cgraph_get_create_node(report_size_overflow_decl);
+	gcc_assert(report_node);
+	frequency = compute_call_stmt_bb_frequency(current_function_decl, bb_true);
+
+	edge = cgraph_create_edge(get_cnode(current_function_decl), report_node, func_stmt, bb_true->count, frequency, bb_true->loop_depth);
+	gcc_assert(edge != NULL);
+}
+
+static void insert_check_size_overflow(interesting_stmts_t expand_from, gimple stmt, enum tree_code cond_code, tree arg, tree type_value, bool before, bool min)
+{
+	basic_block cond_bb, join_bb, bb_true;
+	edge e;
+	gimple_stmt_iterator gsi = gsi_for_stmt(stmt);
+
+	cond_bb = gimple_bb(stmt);
+	if (before)
+		gsi_prev(&gsi);
+	if (gsi_end_p(gsi))
+		e = split_block_after_labels(cond_bb);
+	else
+		e = split_block(cond_bb, gsi_stmt(gsi));
+	cond_bb = e->src;
+	join_bb = e->dest;
+	e->flags = EDGE_FALSE_VALUE;
+	e->probability = REG_BR_PROB_BASE;
+
+	bb_true = create_empty_bb(cond_bb);
+	make_edge(cond_bb, bb_true, EDGE_TRUE_VALUE);
+	make_edge(cond_bb, join_bb, EDGE_FALSE_VALUE);
+	make_edge(bb_true, join_bb, EDGE_FALLTHRU);
+
+	gcc_assert(dom_info_available_p(CDI_DOMINATORS));
+	set_immediate_dominator(CDI_DOMINATORS, bb_true, cond_bb);
+	set_immediate_dominator(CDI_DOMINATORS, join_bb, cond_bb);
+
+	if (current_loops != NULL) {
+		gcc_assert(cond_bb->loop_father == join_bb->loop_father);
+		add_bb_to_loop(bb_true, cond_bb->loop_father);
+	}
+
+	insert_cond(cond_bb, arg, cond_code, type_value);
+	insert_cond_result(expand_from, bb_true, stmt, arg, min);
+
+//	print_the_code_insertions(stmt);
+}
+
+void check_size_overflow(interesting_stmts_t expand_from, gimple stmt, tree size_overflow_type, tree cast_rhs, tree rhs, bool before)
+{
+	const_tree rhs_type = TREE_TYPE(rhs);
+	tree cast_rhs_type, type_max_type, type_min_type, type_max, type_min;
+
+	if (pointer_set_contains(expand_from->visited->no_cast_check, stmt))
+		return;
+
+	gcc_assert(rhs_type != NULL_TREE);
+	if (TREE_CODE(rhs_type) == POINTER_TYPE)
+		return;
+
+	gcc_assert(TREE_CODE(rhs_type) == INTEGER_TYPE || TREE_CODE(rhs_type) == ENUMERAL_TYPE);
+
+	if (is_gimple_assign(stmt) && neg_short_add_intentional_overflow(as_a_gassign(stmt)))
+		return;
+
+	type_max = cast_a_tree(size_overflow_type, TYPE_MAX_VALUE(rhs_type));
+	// typemax (-1) < typemin (0)
+	if (TREE_OVERFLOW(type_max))
+		return;
+
+	type_min = cast_a_tree(size_overflow_type, TYPE_MIN_VALUE(rhs_type));
+
+	cast_rhs_type = TREE_TYPE(cast_rhs);
+	type_max_type = TREE_TYPE(type_max);
+	gcc_assert(types_compatible_p(cast_rhs_type, type_max_type));
+
+	insert_check_size_overflow(expand_from, stmt, GT_EXPR, cast_rhs, type_max, before, MAX_CHECK);
+
+	// special case: get_size_overflow_type(), 32, u64->s
+	if (LONG_TYPE_SIZE == GET_MODE_BITSIZE(SImode) && TYPE_UNSIGNED(size_overflow_type) && !TYPE_UNSIGNED(rhs_type))
+		return;
+
+	type_min_type = TREE_TYPE(type_min);
+	gcc_assert(types_compatible_p(type_max_type, type_min_type));
+	insert_check_size_overflow(expand_from, stmt, LT_EXPR, cast_rhs, type_min, before, MIN_CHECK);
+}
+
+static tree get_my_stmt_lhs(struct visited *visited, gimple stmt)
+{
+	gimple_stmt_iterator gsi;
+	gimple next_stmt = NULL;
+
+	gsi = gsi_for_stmt(stmt);
+
+	do {
+		gsi_next(&gsi);
+		next_stmt = gsi_stmt(gsi);
+
+		if (gimple_code(stmt) == GIMPLE_PHI && !pointer_set_contains(visited->my_stmts, next_stmt))
+			return NULL_TREE;
+
+		if (pointer_set_contains(visited->my_stmts, next_stmt) && !pointer_set_contains(visited->skip_expr_casts, next_stmt))
+			break;
+
+		gcc_assert(pointer_set_contains(visited->my_stmts, next_stmt));
+	} while (!gsi_end_p(gsi));
+
+	gcc_assert(next_stmt);
+	return get_lhs(next_stmt);
+}
+
+/* When the result of the negation is cast to a signed type then move
+ * the size_overflow cast check before negation.
+ * ssa:
+ * unsigned _588
+ * _588 = _587 >> 12;
+ * _589 = -_588;
+ * _590 = (long int) _589;
+ */
+static bool handle_unsigned_neg_or_bit_not(interesting_stmts_t expand_from, const gassign *stmt)
+{
+	gimple def_neg_stmt, neg_stmt;
+	tree lhs, new_neg_rhs;
+	const_tree rhs, neg_rhs;
+	enum tree_code rhs_code;
+
+	rhs = gimple_assign_rhs1(stmt);
+	lhs = gimple_assign_lhs(stmt);
+	if (TYPE_UNSIGNED(TREE_TYPE(lhs)) || !TYPE_UNSIGNED(TREE_TYPE(rhs)))
+		return false;
+
+	neg_stmt = get_def_stmt(rhs);
+	if (!neg_stmt || !is_gimple_assign(neg_stmt))
+		return false;
+
+	rhs_code = gimple_assign_rhs_code(neg_stmt);
+	if (rhs_code != BIT_NOT_EXPR && rhs_code != NEGATE_EXPR)
+		return false;
+
+	neg_rhs = gimple_assign_rhs1(neg_stmt);
+	def_neg_stmt = get_def_stmt(neg_rhs);
+	if (!def_neg_stmt)
+		return false;
+
+	new_neg_rhs = get_my_stmt_lhs(expand_from->visited, def_neg_stmt);
+	check_size_overflow(expand_from, neg_stmt, TREE_TYPE(new_neg_rhs), new_neg_rhs, lhs, BEFORE_STMT);
+	pointer_set_insert(expand_from->visited->no_cast_check, stmt);
+	return true;
+}
+
+static tree create_cast_overflow_check(interesting_stmts_t expand_from, tree new_rhs1, gassign *stmt)
+{
+	bool cast_lhs, cast_rhs;
+	tree lhs = gimple_assign_lhs(stmt);
+	tree rhs = gimple_assign_rhs1(stmt);
+	const_tree lhs_type = TREE_TYPE(lhs);
+	const_tree rhs_type = TREE_TYPE(rhs);
+	enum machine_mode lhs_mode = TYPE_MODE(lhs_type);
+	enum machine_mode rhs_mode = TYPE_MODE(rhs_type);
+	unsigned int lhs_size = GET_MODE_BITSIZE(lhs_mode);
+	unsigned int rhs_size = GET_MODE_BITSIZE(rhs_mode);
+
+	static bool check_lhs[3][4] = {
+		// ss    su     us     uu
+		{ false, true,  true,  false }, // lhs > rhs
+		{ false, false, false, false }, // lhs = rhs
+		{ true,  true,  true,  true  }, // lhs < rhs
+	};
+
+	static bool check_rhs[3][4] = {
+		// ss    su     us     uu
+		{ true,  false, true,  true  }, // lhs > rhs
+		{ true,  false, true,  true  }, // lhs = rhs
+		{ true,  false, true,  true  }, // lhs < rhs
+	};
+
+	if (handle_unsigned_neg_or_bit_not(expand_from, stmt))
+		return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, NULL_TREE, NULL_TREE);
+
+	// skip lhs check on HI -> QI cast
+	if (rhs_mode == HImode && lhs_mode == QImode) {
+		pointer_set_insert(expand_from->visited->no_cast_check, stmt);
+		return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, NULL_TREE, NULL_TREE);
+	}
+
+	// skip lhs check on signed SI -> HI cast or signed SI -> QI cast
+	if (rhs_mode == SImode && !TYPE_UNSIGNED(rhs_type) && (lhs_mode == HImode || lhs_mode == QImode))
+		return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+
+	if (lhs_size > rhs_size) {
+		cast_lhs = check_lhs[0][TYPE_UNSIGNED(rhs_type) + 2 * TYPE_UNSIGNED(lhs_type)];
+		cast_rhs = check_rhs[0][TYPE_UNSIGNED(rhs_type) + 2 * TYPE_UNSIGNED(lhs_type)];
+	} else if (lhs_size == rhs_size) {
+		cast_lhs = check_lhs[1][TYPE_UNSIGNED(rhs_type) + 2 * TYPE_UNSIGNED(lhs_type)];
+		cast_rhs = check_rhs[1][TYPE_UNSIGNED(rhs_type) + 2 * TYPE_UNSIGNED(lhs_type)];
+	} else {
+		cast_lhs = check_lhs[2][TYPE_UNSIGNED(rhs_type) + 2 * TYPE_UNSIGNED(lhs_type)];
+		cast_rhs = check_rhs[2][TYPE_UNSIGNED(rhs_type) + 2 * TYPE_UNSIGNED(lhs_type)];
+	}
+
+	if (!cast_lhs && !cast_rhs)
+		return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, NULL_TREE, NULL_TREE);
+
+	if (cast_lhs && !skip_lhs_cast_check(expand_from->visited, stmt))
+		check_size_overflow(expand_from, stmt, TREE_TYPE(new_rhs1), new_rhs1, lhs, BEFORE_STMT);
+
+	if (cast_rhs)
+		check_size_overflow(expand_from, stmt, TREE_TYPE(new_rhs1), new_rhs1, rhs, BEFORE_STMT);
+
+	return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, NULL_TREE, NULL_TREE);
+}
+
+static tree handle_unary_rhs(interesting_stmts_t expand_from, gassign *stmt)
+{
+	enum tree_code rhs_code;
+	tree rhs1, new_rhs1, lhs = gimple_assign_lhs(stmt);
+
+	if (pointer_set_contains(expand_from->visited->my_stmts, stmt))
+		return lhs;
+
+	rhs1 = gimple_assign_rhs1(stmt);
+	if (TREE_CODE(TREE_TYPE(rhs1)) == POINTER_TYPE)
+		return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+
+	new_rhs1 = expand(expand_from, rhs1);
+
+	if (new_rhs1 == NULL_TREE)
+		return create_cast_assign(expand_from->visited, stmt);
+
+	if (pointer_set_contains(expand_from->visited->no_cast_check, stmt))
+		return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, NULL_TREE, NULL_TREE);
+
+#if BUILDING_GCC_VERSION >= 5000
+	if (short_or_neg_const_ushort(stmt)) {
+		pointer_set_insert(expand_from->visited->no_cast_check, stmt);
+		return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, NULL_TREE, NULL_TREE);
+	}
+#endif
+
+	rhs_code = gimple_assign_rhs_code(stmt);
+	if (rhs_code == BIT_NOT_EXPR || rhs_code == NEGATE_EXPR) {
+		tree size_overflow_type = get_size_overflow_type(expand_from->visited, stmt, rhs1);
+
+		new_rhs1 = cast_to_new_size_overflow_type(expand_from->visited, stmt, new_rhs1, size_overflow_type, BEFORE_STMT);
+		check_size_overflow(expand_from, stmt, size_overflow_type, new_rhs1, rhs1, BEFORE_STMT);
+		return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+	}
+
+	if (!gimple_assign_cast_p(stmt))
+		return dup_assign(expand_from->visited, stmt, lhs, new_rhs1, NULL_TREE, NULL_TREE);
+
+	return create_cast_overflow_check(expand_from, new_rhs1, stmt);
+}
+
+static tree handle_unary_ops(interesting_stmts_t expand_from, gassign *stmt)
+{
+	tree rhs1, lhs = gimple_assign_lhs(stmt);
+	gimple def_stmt = get_def_stmt(lhs);
+
+	gcc_assert(gimple_code(def_stmt) != GIMPLE_NOP);
+	rhs1 = gimple_assign_rhs1(def_stmt);
+
+	if (is_gimple_constant(rhs1))
+		return create_assign(expand_from->visited, def_stmt, lhs, AFTER_STMT);
+
+	switch (TREE_CODE(rhs1)) {
+	case SSA_NAME: {
+		tree ret = handle_unary_rhs(expand_from, as_a_gassign(def_stmt));
+
+		if (gimple_assign_cast_p(stmt))
+			unsigned_signed_cast_intentional_overflow(expand_from->visited, stmt);
+		return ret;
+	}
+	case ARRAY_REF:
+	case BIT_FIELD_REF:
+	case ADDR_EXPR:
+	case COMPONENT_REF:
+	case INDIRECT_REF:
+#if BUILDING_GCC_VERSION >= 4006
+	case MEM_REF:
+#endif
+	case TARGET_MEM_REF:
+	case VIEW_CONVERT_EXPR:
+		return create_assign(expand_from->visited, def_stmt, lhs, AFTER_STMT);
+	case PARM_DECL:
+	case VAR_DECL:
+		return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+
+	default:
+		debug_gimple_stmt(def_stmt);
+		debug_tree(rhs1);
+		gcc_unreachable();
+	}
+}
+
+static void __unused print_the_code_insertions(const_gimple stmt)
+{
+	location_t loc = gimple_location(stmt);
+
+	inform(loc, "Integer size_overflow check applied here.");
+}
+
+static bool is_from_cast(const_tree node)
+{
+	gimple def_stmt = get_def_stmt(node);
+
+	if (!def_stmt)
+		return false;
+
+	if (gimple_assign_cast_p(def_stmt))
+		return true;
+
+	return false;
+}
+
+// Skip duplication when there is a minus expr and the type of rhs1 or rhs2 is a pointer_type.
+static bool is_ptr_diff(gassign *stmt)
+{
+	const_tree rhs1, rhs2, ptr1_rhs, ptr2_rhs;
+
+	if (gimple_assign_rhs_code(stmt) != MINUS_EXPR)
+		return false;
+
+	rhs1 = gimple_assign_rhs1(stmt);
+	if (!is_from_cast(rhs1))
+		return false;
+
+	rhs2 = gimple_assign_rhs2(stmt);
+	if (!is_from_cast(rhs2))
+		return false;
+
+	ptr1_rhs = gimple_assign_rhs1(get_def_stmt(rhs1));
+	ptr2_rhs = gimple_assign_rhs1(get_def_stmt(rhs2));
+
+	if (TREE_CODE(TREE_TYPE(ptr1_rhs)) != POINTER_TYPE && TREE_CODE(TREE_TYPE(ptr2_rhs)) != POINTER_TYPE)
+		return false;
+
+	return true;
+}
+
+static tree handle_comparison_code_class(interesting_stmts_t expand_from, gassign *stmt, tree new_rhs1, tree new_rhs2)
+{
+	tree rhs1, rhs2, lhs;
+
+	rhs1 = gimple_assign_rhs1(stmt);
+	if (!is_gimple_constant(rhs1) && new_rhs1 != NULL_TREE)
+		check_size_overflow(expand_from, stmt, TREE_TYPE(new_rhs1), new_rhs1, rhs1, BEFORE_STMT);
+
+	lhs = gimple_assign_lhs(stmt);
+	if (new_rhs2 == NULL_TREE)
+		return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+
+	rhs2 = gimple_assign_rhs2(stmt);
+	if (!is_gimple_constant(rhs2))
+		check_size_overflow(expand_from, stmt, TREE_TYPE(new_rhs2), new_rhs2, rhs2, BEFORE_STMT);
+	return create_assign(expand_from->visited, stmt, lhs, AFTER_STMT);
+}
+
+static tree handle_binary_ops(interesting_stmts_t expand_from, tree lhs)
+{
+	enum intentional_overflow_type res;
+	tree rhs1, rhs2, new_lhs;
+	gassign *def_stmt = as_a_gassign(get_def_stmt(lhs));
+	tree new_rhs1 = NULL_TREE;
+	tree new_rhs2 = NULL_TREE;
+
+	if (is_ptr_diff(def_stmt))
+		return create_assign(expand_from->visited, def_stmt, lhs, AFTER_STMT);
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs2 = gimple_assign_rhs2(def_stmt);
+
+	/* no DImode/TImode division in the 32/64 bit kernel */
+	switch (gimple_assign_rhs_code(def_stmt)) {
+	case RDIV_EXPR:
+	case TRUNC_DIV_EXPR:
+	case CEIL_DIV_EXPR:
+	case FLOOR_DIV_EXPR:
+	case ROUND_DIV_EXPR:
+	case TRUNC_MOD_EXPR:
+	case CEIL_MOD_EXPR:
+	case FLOOR_MOD_EXPR:
+	case ROUND_MOD_EXPR:
+	case EXACT_DIV_EXPR:
+	case POINTER_PLUS_EXPR:
+	case BIT_AND_EXPR:
+		return create_assign(expand_from->visited, def_stmt, lhs, AFTER_STMT);
+	default:
+		break;
+	}
+
+	new_lhs = handle_integer_truncation(expand_from, lhs);
+	if (new_lhs != NULL_TREE)
+		return new_lhs;
+
+	if (TREE_CODE(rhs1) == SSA_NAME)
+		new_rhs1 = expand(expand_from, rhs1);
+	if (TREE_CODE(rhs2) == SSA_NAME)
+		new_rhs2 = expand(expand_from, rhs2);
+
+	res = add_mul_intentional_overflow(def_stmt);
+	if (res != NO_INTENTIONAL_OVERFLOW) {
+		new_lhs = dup_assign(expand_from->visited, def_stmt, lhs, new_rhs1, new_rhs2, NULL_TREE);
+		insert_cast_expr(expand_from->visited, as_a_gassign(get_def_stmt(new_lhs)), res);
+		return new_lhs;
+	}
+
+	if (skip_expr_on_double_type(def_stmt)) {
+		new_lhs = dup_assign(expand_from->visited, def_stmt, lhs, new_rhs1, new_rhs2, NULL_TREE);
+		insert_cast_expr(expand_from->visited, as_a_gassign(get_def_stmt(new_lhs)), NO_INTENTIONAL_OVERFLOW);
+		return new_lhs;
+	}
+
+	if (is_a_neg_overflow(def_stmt, rhs2))
+		return handle_intentional_overflow(expand_from, true, def_stmt, new_rhs1, NULL_TREE);
+	if (is_a_neg_overflow(def_stmt, rhs1))
+		return handle_intentional_overflow(expand_from, true, def_stmt, new_rhs2, new_rhs2);
+
+
+	if (is_a_constant_overflow(def_stmt, rhs2))
+		return handle_intentional_overflow(expand_from, !is_a_cast_and_const_overflow(rhs1), def_stmt, new_rhs1, NULL_TREE);
+	if (is_a_constant_overflow(def_stmt, rhs1))
+		return handle_intentional_overflow(expand_from, !is_a_cast_and_const_overflow(rhs2), def_stmt, new_rhs2, new_rhs2);
+
+	// the const is between 0 and (signed) MAX
+	if (is_gimple_constant(rhs1))
+		new_rhs1 = create_assign(expand_from->visited, def_stmt, rhs1, BEFORE_STMT);
+	if (is_gimple_constant(rhs2))
+		new_rhs2 = create_assign(expand_from->visited, def_stmt, rhs2, BEFORE_STMT);
+
+	if (TREE_CODE_CLASS(gimple_assign_rhs_code(def_stmt)) == tcc_comparison)
+		return handle_comparison_code_class(expand_from, def_stmt, new_rhs1, new_rhs2);
+
+	if (uconst_neg_intentional_overflow(def_stmt)) {
+		inform(gimple_location(def_stmt), "%s: gcc intentional overflow", __func__);
+		gcc_unreachable();
+	}
+
+	return dup_assign(expand_from->visited, def_stmt, lhs, new_rhs1, new_rhs2, NULL_TREE);
+}
+
+#if BUILDING_GCC_VERSION >= 4006
+static tree get_new_rhs(interesting_stmts_t expand_from, tree size_overflow_type, tree rhs)
+{
+	if (is_gimple_constant(rhs))
+		return cast_a_tree(size_overflow_type, rhs);
+	if (TREE_CODE(rhs) != SSA_NAME)
+		return NULL_TREE;
+	return expand(expand_from, rhs);
+}
+
+static tree handle_ternary_ops(interesting_stmts_t expand_from, tree lhs)
+{
+	tree rhs1, rhs2, rhs3, new_rhs1, new_rhs2, new_rhs3, size_overflow_type;
+	gassign *def_stmt = as_a_gassign(get_def_stmt(lhs));
+
+	size_overflow_type = get_size_overflow_type(expand_from->visited, def_stmt, lhs);
+
+	rhs1 = gimple_assign_rhs1(def_stmt);
+	rhs2 = gimple_assign_rhs2(def_stmt);
+	rhs3 = gimple_assign_rhs3(def_stmt);
+	new_rhs1 = get_new_rhs(expand_from, size_overflow_type, rhs1);
+	new_rhs2 = get_new_rhs(expand_from, size_overflow_type, rhs2);
+	new_rhs3 = get_new_rhs(expand_from, size_overflow_type, rhs3);
+
+	return dup_assign(expand_from->visited, def_stmt, lhs, new_rhs1, new_rhs2, new_rhs3);
+}
+#endif
+
+static tree expand_visited(struct visited *visited, gimple def_stmt)
+{
+	gimple_stmt_iterator gsi;
+	enum gimple_code code = gimple_code(def_stmt);
+
+	if (code == GIMPLE_ASM)
+		return NULL_TREE;
+
+	gsi = gsi_for_stmt(def_stmt);
+	gsi_next(&gsi);
+
+	if (gimple_code(def_stmt) == GIMPLE_PHI && gsi_end_p(gsi))
+		return NULL_TREE;
+	return get_my_stmt_lhs(visited, def_stmt);
+}
+
+tree expand(interesting_stmts_t expand_from, tree lhs)
+{
+	gimple def_stmt;
+
+	def_stmt = get_def_stmt(lhs);
+
+	if (!def_stmt || gimple_code(def_stmt) == GIMPLE_NOP)
+		return NULL_TREE;
+
+	if (pointer_set_contains(expand_from->visited->my_stmts, def_stmt))
+		return lhs;
+
+	if (pointer_set_contains(expand_from->visited->stmts, def_stmt))
+		return expand_visited(expand_from->visited, def_stmt);
+
+	if (is_gimple_constant(lhs))
+		return NULL_TREE;
+	if (skip_types(lhs))
+		return NULL_TREE;
+
+	switch (gimple_code(def_stmt)) {
+	case GIMPLE_PHI:
+		return handle_phi(expand_from, lhs);
+	case GIMPLE_CALL:
+	case GIMPLE_ASM:
+		if (is_size_overflow_asm(def_stmt))
+			return expand(expand_from, get_size_overflow_asm_input(as_a_gasm(def_stmt)));
+		return create_assign(expand_from->visited, def_stmt, lhs, AFTER_STMT);
+	case GIMPLE_ASSIGN:
+		switch (gimple_num_ops(def_stmt)) {
+		case 2:
+			return handle_unary_ops(expand_from, as_a_gassign(def_stmt));
+		case 3:
+			return handle_binary_ops(expand_from, lhs);
+#if BUILDING_GCC_VERSION >= 4006
+		case 4:
+			return handle_ternary_ops(expand_from, lhs);
+#endif
+		}
+	default:
+		debug_gimple_stmt(def_stmt);
+		error("%s: unknown gimple code", __func__);
+		gcc_unreachable();
+	}
+}
diff --git b/scripts/gcc-plugins/stackleak_plugin.c b/scripts/gcc-plugins/stackleak_plugin.c
new file mode 100644
index 000000000..75524f42c
--- /dev/null
+++ b/scripts/gcc-plugins/stackleak_plugin.c
@@ -0,0 +1,342 @@
+/*
+ * Copyright 2011-2017 by the PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * gcc plugin to help implement various PaX features
+ *
+ * - track lowest stack pointer
+ *
+ * TODO:
+ * - initialize all local variables
+ *
+ * BUGS:
+ * - none known
+ */
+
+#include "gcc-common.h"
+
+__visible int plugin_is_GPL_compatible;
+
+static int track_frame_size = -1;
+static const char track_function[] = "pax_track_stack";
+static const char check_function[] = "pax_check_alloca";
+static GTY(()) tree track_function_decl;
+static GTY(()) tree check_function_decl;
+static bool init_locals;
+
+static struct plugin_info stackleak_plugin_info = {
+	.version	= "201602181345",
+	.help		= "track-lowest-sp=nn\ttrack sp in functions whose frame size is at least nn bytes\n"
+//			  "initialize-locals\t\tforcibly initialize all stack frames\n"
+};
+
+static void stackleak_check_alloca(gimple_stmt_iterator *gsi)
+{
+	gimple stmt;
+	gcall *check_alloca;
+	tree alloca_size;
+	cgraph_node_ptr node;
+	int frequency;
+	basic_block bb;
+
+	// insert call to void pax_check_alloca(unsigned long size)
+	alloca_size = gimple_call_arg(gsi_stmt(*gsi), 0);
+	stmt = gimple_build_call(check_function_decl, 1, alloca_size);
+	check_alloca = as_a_gcall(stmt);
+	gsi_insert_before(gsi, check_alloca, GSI_SAME_STMT);
+
+	// update the cgraph
+	bb = gimple_bb(check_alloca);
+	node = cgraph_get_create_node(check_function_decl);
+	gcc_assert(node);
+	frequency = compute_call_stmt_bb_frequency(current_function_decl, bb);
+	cgraph_create_edge(cgraph_get_node(current_function_decl), node, check_alloca, bb->count, frequency, bb->loop_depth);
+}
+
+static void stackleak_add_instrumentation(gimple_stmt_iterator *gsi, bool after)
+{
+	gimple stmt;
+	gcall *track_stack;
+	cgraph_node_ptr node;
+	int frequency;
+	basic_block bb;
+
+	// insert call to void pax_track_stack(void)
+	stmt = gimple_build_call(track_function_decl, 0);
+	track_stack = as_a_gcall(stmt);
+	if (after)
+		gsi_insert_after(gsi, track_stack, GSI_CONTINUE_LINKING);
+	else
+		gsi_insert_before(gsi, track_stack, GSI_SAME_STMT);
+
+	// update the cgraph
+	bb = gimple_bb(track_stack);
+	node = cgraph_get_create_node(track_function_decl);
+	gcc_assert(node);
+	frequency = compute_call_stmt_bb_frequency(current_function_decl, bb);
+	cgraph_create_edge(cgraph_get_node(current_function_decl), node, track_stack, bb->count, frequency, bb->loop_depth);
+}
+
+static bool is_alloca(gimple stmt)
+{
+	if (gimple_call_builtin_p(stmt, BUILT_IN_ALLOCA))
+		return true;
+
+#if BUILDING_GCC_VERSION >= 4007
+	if (gimple_call_builtin_p(stmt, BUILT_IN_ALLOCA_WITH_ALIGN))
+		return true;
+#endif
+
+	return false;
+}
+
+static unsigned int stackleak_tree_instrument_execute(void)
+{
+	basic_block bb, entry_bb;
+	bool prologue_instrumented = false, is_leaf = true;
+
+	entry_bb = ENTRY_BLOCK_PTR_FOR_FN(cfun)->next_bb;
+
+	// 1. loop through BBs and GIMPLE statements
+	FOR_EACH_BB_FN(bb, cfun) {
+		gimple_stmt_iterator gsi;
+
+		for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+			gimple stmt;
+
+			stmt = gsi_stmt(gsi);
+
+			if (is_gimple_call(stmt))
+				is_leaf = false;
+
+			// gimple match: align 8 built-in BUILT_IN_NORMAL:BUILT_IN_ALLOCA attributes <tree_list 0xb7576450>
+			if (!is_alloca(stmt))
+				continue;
+
+			// 2. insert stack overflow check before each __builtin_alloca call
+			stackleak_check_alloca(&gsi);
+
+			// 3. insert track call after each __builtin_alloca call
+			stackleak_add_instrumentation(&gsi, true);
+			if (bb == entry_bb)
+				prologue_instrumented = true;
+		}
+	}
+
+	// special cases for some bad linux code: taking the address of static inline functions will materialize them
+	// but we mustn't instrument some of them as the resulting stack alignment required by the function call ABI
+	// will break other assumptions regarding the expected (but not otherwise enforced) register clobbering  ABI.
+	// case in point: native_save_fl on amd64 when optimized for size clobbers rdx if it were instrumented here.
+	if (is_leaf && !TREE_PUBLIC(current_function_decl) && DECL_DECLARED_INLINE_P(current_function_decl))
+		return 0;
+	if (is_leaf && !strncmp(IDENTIFIER_POINTER(DECL_NAME(current_function_decl)), "_paravirt_", 10))
+		return 0;
+
+	// 4. insert track call at the beginning
+	if (!prologue_instrumented) {
+		gimple_stmt_iterator gsi;
+
+		gcc_assert(single_succ_p(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+		bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+		if (!single_pred_p(bb)) {
+//			gcc_assert(bb_loop_depth(bb) || (bb->flags & BB_IRREDUCIBLE_LOOP));
+			split_edge(single_succ_edge(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+			gcc_assert(single_succ_p(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+			bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+		}
+		gsi = gsi_after_labels(bb);
+		stackleak_add_instrumentation(&gsi, false);
+	}
+
+	return 0;
+}
+
+static unsigned int stackleak_final_execute(void)
+{
+	rtx_insn *insn, *next;
+
+	if (cfun->calls_alloca)
+		return 0;
+
+	// keep calls only if function frame is big enough
+	if (get_frame_size() >= track_frame_size)
+		return 0;
+
+	// 1. find pax_track_stack calls
+	for (insn = get_insns(); insn; insn = next) {
+		// rtl match: (call_insn 8 7 9 3 (call (mem (symbol_ref ("pax_track_stack") [flags 0x41] <function_decl 0xb7470e80 pax_track_stack>) [0 S1 A8]) (4)) -1 (nil) (nil))
+		rtx body;
+
+		next = NEXT_INSN(insn);
+		if (!CALL_P(insn))
+			continue;
+		body = PATTERN(insn);
+		if (GET_CODE(body) != CALL)
+			continue;
+		body = XEXP(body, 0);
+		if (GET_CODE(body) != MEM)
+			continue;
+		body = XEXP(body, 0);
+		if (GET_CODE(body) != SYMBOL_REF)
+			continue;
+//		if (strcmp(XSTR(body, 0), track_function))
+		if (SYMBOL_REF_DECL(body) != track_function_decl)
+			continue;
+//		warning(0, "track_frame_size: %d %ld %d", cfun->calls_alloca, get_frame_size(), track_frame_size);
+		// 2. delete call
+		delete_insn_and_edges(insn);
+#if BUILDING_GCC_VERSION >= 4007
+		if (GET_CODE(next) == NOTE && NOTE_KIND(next) == NOTE_INSN_CALL_ARG_LOCATION) {
+			insn = next;
+			next = NEXT_INSN(insn);
+			delete_insn_and_edges(insn);
+		}
+#endif
+	}
+
+//	print_simple_rtl(stderr, get_insns());
+//	print_rtl(stderr, get_insns());
+//	warning(0, "track_frame_size: %d %ld %d", cfun->calls_alloca, get_frame_size(), track_frame_size);
+
+	return 0;
+}
+
+static bool stackleak_track_stack_gate(void)
+{
+	tree section;
+
+	if (ix86_cmodel != CM_KERNEL)
+		return false;
+
+	section = lookup_attribute("section", DECL_ATTRIBUTES(current_function_decl));
+	if (section && TREE_VALUE(section)) {
+		section = TREE_VALUE(TREE_VALUE(section));
+
+		if (!strncmp(TREE_STRING_POINTER(section), ".init.text", 10))
+			return false;
+		if (!strncmp(TREE_STRING_POINTER(section), ".devinit.text", 13))
+			return false;
+		if (!strncmp(TREE_STRING_POINTER(section), ".cpuinit.text", 13))
+			return false;
+		if (!strncmp(TREE_STRING_POINTER(section), ".meminit.text", 13))
+			return false;
+	}
+
+	return track_frame_size >= 0;
+}
+
+static void stackleak_start_unit(void *gcc_data, void *user_data)
+{
+	tree fntype;
+
+	// void pax_track_stack(void)
+	fntype = build_function_type_list(void_type_node, NULL_TREE);
+	track_function_decl = build_fn_decl(track_function, fntype);
+	DECL_ASSEMBLER_NAME(track_function_decl); // for LTO
+	TREE_PUBLIC(track_function_decl) = 1;
+	TREE_USED(track_function_decl) = 1;
+	DECL_EXTERNAL(track_function_decl) = 1;
+	DECL_ARTIFICIAL(track_function_decl) = 1;
+	DECL_PRESERVE_P(track_function_decl) = 1;
+
+	// void pax_check_alloca(unsigned long)
+	fntype = build_function_type_list(void_type_node, long_unsigned_type_node, NULL_TREE);
+	check_function_decl = build_fn_decl(check_function, fntype);
+	DECL_ASSEMBLER_NAME(check_function_decl); // for LTO
+	TREE_PUBLIC(check_function_decl) = 1;
+	TREE_USED(check_function_decl) = 1;
+	DECL_EXTERNAL(check_function_decl) = 1;
+	DECL_ARTIFICIAL(check_function_decl) = 1;
+	DECL_PRESERVE_P(check_function_decl) = 1;
+}
+
+static bool stackleak_tree_instrument_gate(void)
+{
+	return stackleak_track_stack_gate();
+}
+
+#define PASS_NAME stackleak_tree_instrument
+#define PROPERTIES_REQUIRED PROP_gimple_leh | PROP_cfg
+#define TODO_FLAGS_START TODO_verify_ssa | TODO_verify_flow | TODO_verify_stmts
+#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_update_ssa | TODO_rebuild_cgraph_edges
+#include "gcc-generate-gimple-pass.h"
+
+static bool stackleak_final_gate(void)
+{
+	return stackleak_track_stack_gate();
+}
+
+#define PASS_NAME stackleak_final
+#define TODO_FLAGS_FINISH TODO_dump_func
+#include "gcc-generate-rtl-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	int i;
+
+	static const struct ggc_root_tab gt_ggc_r_gt_stackleak[] = {
+		{
+			.base = &track_function_decl,
+			.nelt = 1,
+			.stride = sizeof(track_function_decl),
+			.cb = &gt_ggc_mx_tree_node,
+			.pchw = &gt_pch_nx_tree_node
+		},
+		{
+			.base = &check_function_decl,
+			.nelt = 1,
+			.stride = sizeof(check_function_decl),
+			.cb = &gt_ggc_mx_tree_node,
+			.pchw = &gt_pch_nx_tree_node
+		},
+		LAST_GGC_ROOT_TAB
+	};
+
+//	PASS_INFO(stackleak_tree_instrument, "tree_profile", 1, PASS_POS_INSERT_BEFORE);
+	PASS_INFO(stackleak_tree_instrument, "optimized", 1, PASS_POS_INSERT_BEFORE);
+	PASS_INFO(stackleak_final, "final", 1, PASS_POS_INSERT_BEFORE);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &stackleak_plugin_info);
+
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "track-lowest-sp")) {
+			if (!argv[i].value) {
+				error(G_("no value supplied for option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+				continue;
+			}
+			track_frame_size = atoi(argv[i].value);
+			if (argv[i].value[0] < '0' || argv[i].value[0] > '9' || track_frame_size < 0)
+				error(G_("invalid option argument '-fplugin-arg-%s-%s=%s'"), plugin_name, argv[i].key, argv[i].value);
+			continue;
+		}
+		if (!strcmp(argv[i].key, "initialize-locals")) {
+			if (argv[i].value) {
+				error(G_("invalid option argument '-fplugin-arg-%s-%s=%s'"), plugin_name, argv[i].key, argv[i].value);
+				continue;
+			}
+			init_locals = true;
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	register_callback(plugin_name, PLUGIN_START_UNIT, &stackleak_start_unit, NULL);
+	register_callback(plugin_name, PLUGIN_REGISTER_GGC_ROOTS, NULL, (void *)&gt_ggc_r_gt_stackleak);
+	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &stackleak_tree_instrument_pass_info);
+	register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &stackleak_final_pass_info);
+
+	return 0;
+}
diff --git b/scripts/gcc-plugins/structleak_plugin.c b/scripts/gcc-plugins/structleak_plugin.c
new file mode 100644
index 000000000..7ff562f10
--- /dev/null
+++ b/scripts/gcc-plugins/structleak_plugin.c
@@ -0,0 +1,235 @@
+/*
+ * Copyright 2013-2017 by PaX Team <pageexec@freemail.hu>
+ * Licensed under the GPL v2
+ *
+ * Note: the choice of the license means that the compilation process is
+ *       NOT 'eligible' as defined by gcc's library exception to the GPL v3,
+ *       but for the kernel it doesn't matter since it doesn't link against
+ *       any of the gcc libraries
+ *
+ * gcc plugin to forcibly initialize certain local variables that could
+ * otherwise leak kernel stack to userland if they aren't properly initialized
+ * by later code
+ *
+ * Homepage: http://pax.grsecurity.net/
+ *
+ * Usage:
+ * $ # for 4.5/4.6/C based 4.7
+ * $ gcc -I`gcc -print-file-name=plugin`/include -I`gcc -print-file-name=plugin`/include/c-family -fPIC -shared -O2 -o structleak_plugin.so structleak_plugin.c
+ * $ # for C++ based 4.7/4.8+
+ * $ g++ -I`g++ -print-file-name=plugin`/include -I`g++ -print-file-name=plugin`/include/c-family -fPIC -shared -O2 -o structleak_plugin.so structleak_plugin.c
+ * $ gcc -fplugin=./structleak_plugin.so test.c -O2
+ *
+ * TODO: eliminate redundant initializers
+ *       increase type coverage
+ */
+
+#include "gcc-common.h"
+
+// unused C type flag in all versions 4.5-6
+#define TYPE_USERSPACE(TYPE) TYPE_LANG_FLAG_5(TYPE)
+
+__visible int plugin_is_GPL_compatible;
+
+static struct plugin_info structleak_plugin_info = {
+	.version	= "201607271510",
+	.help		= "disable\tdo not activate plugin\n",
+};
+
+static tree handle_user_attribute(tree *node, tree name, tree args, int flags, bool *no_add_attrs)
+{
+	*no_add_attrs = true;
+
+	// check for types? for now accept everything linux has to offer
+	if (TREE_CODE(*node) != FIELD_DECL)
+		return NULL_TREE;
+
+	*no_add_attrs = false;
+	return NULL_TREE;
+}
+
+static struct attribute_spec user_attr = {
+	.name			= "user",
+	.min_length		= 0,
+	.max_length		= 0,
+	.decl_required		= false,
+	.type_required		= false,
+	.function_type_required	= false,
+	.handler		= handle_user_attribute,
+#if BUILDING_GCC_VERSION >= 4007
+	.affects_type_identity	= true
+#endif
+};
+
+static void register_attributes(void *event_data, void *data)
+{
+	register_attribute(&user_attr);
+//	register_attribute(&force_attr);
+}
+
+static tree get_field_type(tree field)
+{
+	return strip_array_types(TREE_TYPE(field));
+}
+
+static bool is_userspace_type(tree type)
+{
+	tree field;
+
+	for (field = TYPE_FIELDS(type); field; field = TREE_CHAIN(field)) {
+		tree fieldtype = get_field_type(field);
+		enum tree_code code = TREE_CODE(fieldtype);
+
+		if (code == RECORD_TYPE || code == UNION_TYPE)
+			if (is_userspace_type(fieldtype))
+				return true;
+
+		if (lookup_attribute("user", DECL_ATTRIBUTES(field)))
+			return true;
+	}
+	return false;
+}
+
+static void finish_type(void *event_data, void *data)
+{
+	tree type = (tree)event_data;
+
+	if (type == NULL_TREE || type == error_mark_node)
+		return;
+
+#if BUILDING_GCC_VERSION >= 5000
+	if (TREE_CODE(type) == ENUMERAL_TYPE)
+		return;
+#endif
+
+	if (TYPE_USERSPACE(type))
+		return;
+
+	if (is_userspace_type(type))
+		TYPE_USERSPACE(type) = 1;
+}
+
+static void initialize(tree var)
+{
+	basic_block bb;
+	gimple_stmt_iterator gsi;
+	tree initializer;
+	gimple init_stmt;
+
+	// this is the original entry bb before the forced split
+	bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+
+	// first check if the variable is already initialized, warn otherwise
+	for (gsi = gsi_start_bb(bb); !gsi_end_p(gsi); gsi_next(&gsi)) {
+		gimple stmt = gsi_stmt(gsi);
+		tree rhs1;
+
+		// we're looking for an assignment of a single rhs...
+		if (!gimple_assign_single_p(stmt))
+			continue;
+		rhs1 = gimple_assign_rhs1(stmt);
+#if BUILDING_GCC_VERSION >= 4007
+		// ... of a non-clobbering expression...
+		if (TREE_CLOBBER_P(rhs1))
+			continue;
+#endif
+		// ... to our variable...
+		if (gimple_get_lhs(stmt) != var)
+			continue;
+		// if it's an initializer then we're good
+		if (TREE_CODE(rhs1) == CONSTRUCTOR)
+			return;
+	}
+
+	// these aren't the 0days you're looking for
+//	inform(DECL_SOURCE_LOCATION(var), "userspace variable will be forcibly initialized");
+
+	// build the initializer expression
+	initializer = build_constructor(TREE_TYPE(var), NULL);
+
+	// build the initializer stmt
+	init_stmt = gimple_build_assign(var, initializer);
+	gsi = gsi_after_labels(single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+	gsi_insert_before(&gsi, init_stmt, GSI_NEW_STMT);
+	update_stmt(init_stmt);
+}
+
+static unsigned int structleak_execute(void)
+{
+	basic_block bb;
+	unsigned int ret = 0;
+	tree var;
+	unsigned int i;
+
+	// split the first bb where we can put the forced initializers
+	gcc_assert(single_succ_p(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+	bb = single_succ(ENTRY_BLOCK_PTR_FOR_FN(cfun));
+	if (!single_pred_p(bb)) {
+//		gcc_assert(bb_loop_depth(bb) || (bb->flags & BB_IRREDUCIBLE_LOOP));
+		split_edge(single_succ_edge(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+		gcc_assert(single_succ_p(ENTRY_BLOCK_PTR_FOR_FN(cfun)));
+	}
+
+	// enumarate all local variables and forcibly initialize our targets
+	FOR_EACH_LOCAL_DECL(cfun, i, var) {
+		tree type = TREE_TYPE(var);
+
+		gcc_assert(DECL_P(var));
+		if (!auto_var_in_fn_p(var, current_function_decl))
+			continue;
+
+		// only care about structure types
+		if (TREE_CODE(type) != RECORD_TYPE && TREE_CODE(type) != UNION_TYPE)
+			continue;
+
+		// if the type is of interest, examine the variable
+		if (TYPE_USERSPACE(type))
+			initialize(var);
+	}
+
+	return ret;
+}
+
+#define PASS_NAME structleak
+#define NO_GATE
+#define PROPERTIES_REQUIRED PROP_cfg
+#define TODO_FLAGS_FINISH TODO_verify_il | TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_remove_unused_locals | TODO_update_ssa | TODO_ggc_collect | TODO_verify_flow
+#include "gcc-generate-gimple-pass.h"
+
+__visible int plugin_init(struct plugin_name_args *plugin_info, struct plugin_gcc_version *version)
+{
+	int i;
+	const char * const plugin_name = plugin_info->base_name;
+	const int argc = plugin_info->argc;
+	const struct plugin_argument * const argv = plugin_info->argv;
+	bool enable = true;
+
+	PASS_INFO(structleak, "early_optimizations", 1, PASS_POS_INSERT_BEFORE);
+
+	if (!plugin_default_version_check(version, &gcc_version)) {
+		error(G_("incompatible gcc/plugin versions"));
+		return 1;
+	}
+
+	if (strncmp(lang_hooks.name, "GNU C", 5) && !strncmp(lang_hooks.name, "GNU C+", 6)) {
+		inform(UNKNOWN_LOCATION, G_("%s supports C only, not %s"), plugin_name, lang_hooks.name);
+		enable = false;
+	}
+
+	for (i = 0; i < argc; ++i) {
+		if (!strcmp(argv[i].key, "disable")) {
+			enable = false;
+			continue;
+		}
+		error(G_("unknown option '-fplugin-arg-%s-%s'"), plugin_name, argv[i].key);
+	}
+
+	register_callback(plugin_name, PLUGIN_INFO, NULL, &structleak_plugin_info);
+	if (enable) {
+		register_callback(plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL, &structleak_pass_info);
+		register_callback(plugin_name, PLUGIN_FINISH_TYPE, finish_type, NULL);
+	}
+	register_callback(plugin_name, PLUGIN_ATTRIBUTES, register_attributes, NULL);
+
+	return 0;
+}
diff --git a/scripts/headers_install.sh b/scripts/headers_install.sh
index fdebd66f8..a349e33a5 100755
--- a/scripts/headers_install.sh
+++ b/scripts/headers_install.sh
@@ -32,6 +32,7 @@ do
 	FILE="$(basename "$i")"
 	sed -r \
 		-e 's/([ \t(])(__user|__force|__iomem)[ \t]/\1/g' \
+		-e 's/__intentional_overflow\([- \t,0-9]*\)//g' \
 		-e 's/__attribute_const__([ \t]|$)/\1/g' \
 		-e 's@^#include <linux/compiler.h>@@' \
 		-e 's/(^|[^a-zA-Z0-9])__packed([^a-zA-Z0-9_]|$)/\1__attribute__((packed))\2/g' \
diff --git a/scripts/kallsyms.c b/scripts/kallsyms.c
index 1f22a186c..1c1b79cde 100644
--- a/scripts/kallsyms.c
+++ b/scripts/kallsyms.c
@@ -92,7 +92,7 @@ static inline int is_arm_mapping_symbol(const char *str)
 }
 
 static int check_symbol_range(const char *sym, unsigned long long addr,
-			      struct addr_range *ranges, int entries)
+			      struct addr_range *ranges, size_t entries)
 {
 	size_t i;
 	struct addr_range *ar;
@@ -183,7 +183,7 @@ static int read_symbol(FILE *in, struct sym_entry *s)
 }
 
 static int symbol_in_range(struct sym_entry *s, struct addr_range *ranges,
-			   int entries)
+			   size_t entries)
 {
 	size_t i;
 	struct addr_range *ar;
diff --git a/scripts/kconfig/lkc.h b/scripts/kconfig/lkc.h
index 91ca126ea..5f7cad6f1 100644
--- a/scripts/kconfig/lkc.h
+++ b/scripts/kconfig/lkc.h
@@ -108,7 +108,8 @@ void menu_add_expr(enum prop_type type, struct expr *expr, struct expr *dep);
 void menu_add_symbol(enum prop_type type, struct symbol *sym, struct expr *dep);
 void menu_add_option(int token, char *arg);
 void menu_finalize(struct menu *parent);
-void menu_set_type(int type);
+enum symbol_type;
+void menu_set_type(enum symbol_type type);
 
 /* util.c */
 struct file *file_lookup(const char *name);
@@ -123,7 +124,7 @@ struct gstr {
 	* when max_width is not zero long lines in string s (if any) get
 	* wrapped not to exceed the max_width value
 	*/
-	int max_width;
+	size_t max_width;
 };
 struct gstr str_new(void);
 void str_free(struct gstr *gs);
diff --git a/scripts/kconfig/menu.c b/scripts/kconfig/menu.c
index aed678e8a..1a703de52 100644
--- a/scripts/kconfig/menu.c
+++ b/scripts/kconfig/menu.c
@@ -109,7 +109,7 @@ void menu_add_dep(struct expr *dep)
 	current_entry->dep = expr_alloc_and(current_entry->dep, menu_check_dep(dep));
 }
 
-void menu_set_type(int type)
+void menu_set_type(enum symbol_type type)
 {
 	struct symbol *sym = current_entry->sym;
 
diff --git a/scripts/kconfig/symbol.c b/scripts/kconfig/symbol.c
index 243229848..faeeb2eb2 100644
--- a/scripts/kconfig/symbol.c
+++ b/scripts/kconfig/symbol.c
@@ -970,7 +970,7 @@ const char *sym_escape_string_value(const char *in)
 
 struct sym_match {
 	struct symbol	*sym;
-	off_t		so, eo;
+	regoff_t	so, eo;
 };
 
 /* Compare matched symbols as thus:
@@ -992,8 +992,8 @@ static int sym_rel_comp(const void *sym1, const void *sym2)
 	 * exactly; if this is the case, we can't decide which comes first,
 	 * and we fallback to sorting alphabetically.
 	 */
-	exact1 = (s1->eo - s1->so) == strlen(s1->sym->name);
-	exact2 = (s2->eo - s2->so) == strlen(s2->sym->name);
+	exact1 = (s1->eo - s1->so) == (long)strlen(s1->sym->name);
+	exact2 = (s2->eo - s2->so) == (long)strlen(s2->sym->name);
 	if (exact1 && !exact2)
 		return -1;
 	if (!exact1 && exact2)
diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
index 4f727eb5e..972857572 100755
--- a/scripts/link-vmlinux.sh
+++ b/scripts/link-vmlinux.sh
@@ -180,7 +180,7 @@ else
 fi;
 
 # final build of init/
-${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
+${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}" GCC_PLUGINS_AFLAGS="${GCC_PLUGINS_AFLAGS}"
 
 kallsymso=""
 kallsyms_vmlinux=""
diff --git a/scripts/mod/file2alias.c b/scripts/mod/file2alias.c
index 29d6699d5..f131bc60a 100644
--- a/scripts/mod/file2alias.c
+++ b/scripts/mod/file2alias.c
@@ -156,7 +156,7 @@ static void device_id_check(const char *modname, const char *device_id,
 			    unsigned long size, unsigned long id_size,
 			    void *symval)
 {
-	int i;
+	unsigned int i;
 
 	if (size % id_size || size < id_size) {
 		fatal("%s: sizeof(struct %s_device_id)=%lu is not a modulo "
@@ -185,7 +185,7 @@ static void device_id_check(const char *modname, const char *device_id,
 /* USB is special because the bcdDevice can be matched against a numeric range */
 /* Looks like "usb:vNpNdNdcNdscNdpNicNiscNipNinN" */
 static void do_usb_entry(void *symval,
-			 unsigned int bcdDevice_initial, int bcdDevice_initial_digits,
+			 unsigned int bcdDevice_initial, unsigned int bcdDevice_initial_digits,
 			 unsigned char range_lo, unsigned char range_hi,
 			 unsigned char max, struct module *mod)
 {
@@ -295,7 +295,7 @@ static void do_usb_entry_multi(void *symval, struct module *mod)
 {
 	unsigned int devlo, devhi;
 	unsigned char chi, clo, max;
-	int ndigits;
+	unsigned int ndigits;
 
 	DEF_FIELD(symval, usb_device_id, match_flags);
 	DEF_FIELD(symval, usb_device_id, idVendor);
@@ -619,7 +619,7 @@ static void do_pnp_device_entry(void *symval, unsigned long size,
 	for (i = 0; i < count; i++) {
 		DEF_FIELD_ADDR(symval + i*id_size, pnp_device_id, id);
 		char acpi_id[sizeof(*id)];
-		int j;
+		unsigned int j;
 
 		buf_printf(&mod->dev_table_buf,
 			   "MODULE_ALIAS(\"pnp:d%s*\");\n", *id);
@@ -648,7 +648,7 @@ static void do_pnp_card_entries(void *symval, unsigned long size,
 
 		for (j = 0; j < PNP_MAX_DEVICES; j++) {
 			const char *id = (char *)(*devs)[j].id;
-			int i2, j2;
+			unsigned int i2, j2;
 			int dup = 0;
 
 			if (!id[0])
@@ -674,7 +674,7 @@ static void do_pnp_card_entries(void *symval, unsigned long size,
 			/* add an individual alias for every device entry */
 			if (!dup) {
 				char acpi_id[PNP_ID_LEN];
-				int k;
+				unsigned int k;
 
 				buf_printf(&mod->dev_table_buf,
 					   "MODULE_ALIAS(\"pnp:d%s*\");\n", id);
@@ -999,7 +999,7 @@ static void dmi_ascii_filter(char *d, const char *s)
 static int do_dmi_entry(const char *filename, void *symval,
 			char *alias)
 {
-	int i, j;
+	unsigned int i, j;
 	DEF_FIELD_ADDR(symval, dmi_system_id, matches);
 	sprintf(alias, "dmi*");
 
diff --git a/scripts/mod/modpost.c b/scripts/mod/modpost.c
index 48958d3ce..d5ccb5282 100644
--- a/scripts/mod/modpost.c
+++ b/scripts/mod/modpost.c
@@ -37,6 +37,7 @@ static int vmlinux_section_warnings = 1;
 static int warn_unresolved = 0;
 /* How a symbol is exported */
 static int sec_mismatch_count = 0;
+static int writable_fptr_count = 0;
 static int sec_mismatch_verbose = 1;
 static int sec_mismatch_fatal = 0;
 /* ignore missing files */
@@ -947,6 +948,7 @@ enum mismatch {
 	ANY_EXIT_TO_ANY_INIT,
 	EXPORT_TO_INIT_EXIT,
 	EXTABLE_TO_NON_TEXT,
+	DATA_TO_TEXT
 };
 
 /**
@@ -1073,6 +1075,12 @@ static const struct sectioncheck sectioncheck[] = {
 	.good_tosec = {ALL_TEXT_SECTIONS , NULL},
 	.mismatch = EXTABLE_TO_NON_TEXT,
 	.handler = extable_mismatch_handler,
+},
+/* Do not reference code from writable data */
+{
+	.fromsec = { DATA_SECTIONS, NULL },
+	.bad_tosec = { ALL_TEXT_SECTIONS, NULL },
+	.mismatch = DATA_TO_TEXT
 }
 };
 
@@ -1222,10 +1230,10 @@ static Elf_Sym *find_elf_symbol(struct elf_info *elf, Elf64_Sword addr,
 			continue;
 		if (ELF_ST_TYPE(sym->st_info) == STT_SECTION)
 			continue;
-		if (sym->st_value == addr)
-			return sym;
 		/* Find a symbol nearby - addr are maybe negative */
 		d = sym->st_value - addr;
+		if (d == 0)
+			return sym;
 		if (d < 0)
 			d = addr - sym->st_value;
 		if (d < distance) {
@@ -1384,7 +1392,11 @@ static void report_sec_mismatch(const char *modname,
 	char *prl_from;
 	char *prl_to;
 
-	sec_mismatch_count++;
+	if (mismatch->mismatch == DATA_TO_TEXT)
+		writable_fptr_count++;
+	else
+		sec_mismatch_count++;
+
 	if (!sec_mismatch_verbose)
 		return;
 
@@ -1508,6 +1520,14 @@ static void report_sec_mismatch(const char *modname,
 		fatal("There's a special handler for this mismatch type, "
 		      "we should never get here.");
 		break;
+	case DATA_TO_TEXT:
+#if 0
+		fprintf(stderr,
+		"The %s %s:%s references\n"
+		"the %s %s:%s%s\n",
+		from, fromsec, fromsym, to, tosec, tosym, to_p);
+#endif
+		break;
 	}
 	fprintf(stderr, "\n");
 }
@@ -1897,7 +1917,7 @@ static void section_rel(const char *modname, struct elf_info *elf,
 static void check_sec_ref(struct module *mod, const char *modname,
 			  struct elf_info *elf)
 {
-	int i;
+	unsigned int i;
 	Elf_Shdr *sechdrs = elf->sechdrs;
 
 	/* Walk through all sections */
@@ -2028,7 +2048,7 @@ void __attribute__((format(printf, 2, 3))) buf_printf(struct buffer *buf,
 	va_end(ap);
 }
 
-void buf_write(struct buffer *buf, const char *s, int len)
+void buf_write(struct buffer *buf, const char *s, unsigned int len)
 {
 	if (buf->size - buf->pos < len) {
 		buf->size += len + SZ;
@@ -2258,7 +2278,7 @@ static void write_if_changed(struct buffer *b, const char *fname)
 	if (fstat(fileno(file), &st) < 0)
 		goto close_write;
 
-	if (st.st_size != b->pos)
+	if (st.st_size != (off_t)b->pos)
 		goto close_write;
 
 	tmp = NOFAIL(malloc(b->pos));
@@ -2496,6 +2516,14 @@ int main(int argc, char **argv)
 			      "Set CONFIG_SECTION_MISMATCH_WARN_ONLY=y to allow them.\n");
 		}
 	}
+	if (writable_fptr_count) {
+		if (!sec_mismatch_verbose) {
+			warn("modpost: Found %d writable function pointer(s).\n"
+			     "To see full details build your kernel with:\n"
+			     "'make CONFIG_DEBUG_SECTION_MISMATCH=y'\n",
+			     writable_fptr_count);
+		}
+	}
 
 	return err;
 }
diff --git a/scripts/mod/modpost.h b/scripts/mod/modpost.h
index 6a5e15151..f2fbaf55b 100644
--- a/scripts/mod/modpost.h
+++ b/scripts/mod/modpost.h
@@ -98,15 +98,15 @@ void *do_nofail(void *ptr, const char *expr);
 
 struct buffer {
 	char *p;
-	int pos;
-	int size;
+	unsigned int pos;
+	unsigned int size;
 };
 
 void __attribute__((format(printf, 2, 3)))
 buf_printf(struct buffer *buf, const char *fmt, ...);
 
 void
-buf_write(struct buffer *buf, const char *s, int len);
+buf_write(struct buffer *buf, const char *s, unsigned int len);
 
 struct module {
 	struct module *next;
diff --git a/scripts/mod/sumversion.c b/scripts/mod/sumversion.c
index 944418da9..15291e4e3 100644
--- a/scripts/mod/sumversion.c
+++ b/scripts/mod/sumversion.c
@@ -470,7 +470,7 @@ static void write_version(const char *filename, const char *sum,
 		goto out;
 	}
 
-	if (write(fd, sum, strlen(sum)+1) != strlen(sum)+1) {
+	if (write(fd, sum, strlen(sum)+1) != (ssize_t)strlen(sum)+1) {
 		warn("writing sum in %s failed: %s\n",
 			filename, strerror(errno));
 		goto out;
diff --git a/scripts/module-common.lds b/scripts/module-common.lds
index 73a2c7da0..df11b31bc 100644
--- a/scripts/module-common.lds
+++ b/scripts/module-common.lds
@@ -6,6 +6,10 @@
 SECTIONS {
 	/DISCARD/ : { *(.discard) }
 
+	.rodata			0: {
+		*(.rodata) *(.rodata.*)
+		*(.data..read_only)
+	}
 	__ksymtab		0 : { *(SORT(___ksymtab+*)) }
 	__ksymtab_gpl		0 : { *(SORT(___ksymtab_gpl+*)) }
 	__ksymtab_unused	0 : { *(SORT(___ksymtab_unused+*)) }
diff --git a/scripts/package/Makefile b/scripts/package/Makefile
index 71b4a8af9..dcb89c580 100644
--- a/scripts/package/Makefile
+++ b/scripts/package/Makefile
@@ -40,7 +40,7 @@ if test "$(objtree)" != "$(srctree)"; then \
 fi ; \
 $(srctree)/scripts/setlocalversion --save-scmversion; \
 ln -sf $(srctree) $(2); \
-tar -cz $(RCS_TAR_IGNORE) -f $(2).tar.gz \
+tar --owner=root --group=root -cz $(RCS_TAR_IGNORE) -f $(2).tar.gz \
 	$(addprefix $(2)/,$(TAR_CONTENT) $(3)); \
 rm -f $(2) $(objtree)/.scmversion
 
diff --git a/scripts/package/mkspec b/scripts/package/mkspec
index 57673bae5..c722dc460 100755
--- a/scripts/package/mkspec
+++ b/scripts/package/mkspec
@@ -120,22 +120,33 @@ echo 'rm -f $RPM_BUILD_ROOT'"/lib/modules/$KERNELRELEASE/{build,source}"
 echo "mkdir -p "'$RPM_BUILD_ROOT'"/usr/src/kernels/$KERNELRELEASE"
 echo "EXCLUDES=\"$RCS_TAR_IGNORE --exclude .tmp_versions --exclude=*vmlinux* --exclude=*.o --exclude=*.ko --exclude=*.cmd --exclude=Documentation --exclude=firmware --exclude .config.old --exclude .missing-syscalls.d\""
 echo "tar "'$EXCLUDES'" -cf- . | (cd "'$RPM_BUILD_ROOT'"/usr/src/kernels/$KERNELRELEASE;tar xvf -)"
-echo 'cd $RPM_BUILD_ROOT'"/lib/modules/$KERNELRELEASE"
-echo "ln -sf /usr/src/kernels/$KERNELRELEASE build"
-echo "ln -sf /usr/src/kernels/$KERNELRELEASE source"
 fi
 
 echo ""
 echo "%clean"
 echo 'rm -rf $RPM_BUILD_ROOT'
 echo ""
+echo "%pre"
+echo 'chmod -f 0500 /boot'
+echo 'if [ -d /lib/modules ]; then'
+echo 'chmod -f 0500 /lib/modules'
+echo 'fi'
+echo 'if [ -d /lib32/modules ]; then'
+echo 'chmod -f 0500 /lib32/modules'
+echo 'fi'
+echo 'if [ -d /lib64/modules ]; then'
+echo 'chmod -f 0500 /lib64/modules'
+echo 'fi'
+echo ""
+echo "%post devel"
+echo "ln -sf /usr/src/kernels/$KERNELRELEASE /lib/modules/$KERNELRELEASE/build"
+echo "ln -sf /usr/src/kernels/$KERNELRELEASE /lib/modules/$KERNELRELEASE/source"
+echo ""
 echo "%post"
-echo "if [ -x /sbin/installkernel -a -r /boot/vmlinuz-$KERNELRELEASE -a -r /boot/System.map-$KERNELRELEASE ]; then"
-echo "cp /boot/vmlinuz-$KERNELRELEASE /boot/.vmlinuz-$KERNELRELEASE-rpm"
-echo "cp /boot/System.map-$KERNELRELEASE /boot/.System.map-$KERNELRELEASE-rpm"
-echo "rm -f /boot/vmlinuz-$KERNELRELEASE /boot/System.map-$KERNELRELEASE"
-echo "/sbin/installkernel $KERNELRELEASE /boot/.vmlinuz-$KERNELRELEASE-rpm /boot/.System.map-$KERNELRELEASE-rpm"
-echo "rm -f /boot/.vmlinuz-$KERNELRELEASE-rpm /boot/.System.map-$KERNELRELEASE-rpm"
+echo "if [ -x /sbin/dracut ]; then"
+echo '/sbin/new-kernel-pkg --dracut --mkinitrd --depmod --install --make-default '"$KERNELRELEASE"' || exit $?'
+echo "else"
+echo '/sbin/new-kernel-pkg --mkinitrd --depmod --install --make-default '"$KERNELRELEASE"' || exit $?'
 echo "fi"
 echo ""
 echo "%preun"
@@ -149,10 +160,10 @@ echo "/sbin/update-bootloader --remove $KERNELRELEASE"
 echo "fi"
 echo ""
 echo "%files"
-echo '%defattr (-, root, root)'
-echo "/lib/modules/$KERNELRELEASE"
+echo '%defattr (400, root, root, 500)'
 echo "%exclude /lib/modules/$KERNELRELEASE/build"
 echo "%exclude /lib/modules/$KERNELRELEASE/source"
+echo "/lib/modules/$KERNELRELEASE"
 echo "/lib/firmware/$KERNELRELEASE"
 echo "/boot/*"
 echo ""
@@ -162,9 +173,11 @@ echo "/usr/include"
 echo ""
 if ! $PREBUILT; then
 echo "%files devel"
-echo '%defattr (-, root, root)'
+echo '%defattr (400, root, root, 500)'
+echo "%dir /lib/modules/$KERNELRELEASE"
 echo "/usr/src/kernels/$KERNELRELEASE"
-echo "/lib/modules/$KERNELRELEASE/build"
-echo "/lib/modules/$KERNELRELEASE/source"
+echo "%attr (500, root, root) /usr/src/kernels/$KERNELRELEASE/scripts/recordmcount"
+echo "%attr (500, root, root) /usr/src/kernels/$KERNELRELEASE/scripts/basic/fixdep"
+echo "%attr (500, root, root) /usr/src/kernels/$KERNELRELEASE/scripts/mod/modpost"
 echo ""
 fi
diff --git a/scripts/pnmtologo.c b/scripts/pnmtologo.c
index 4718d7895..9220d5899 100644
--- a/scripts/pnmtologo.c
+++ b/scripts/pnmtologo.c
@@ -244,14 +244,14 @@ static void write_header(void)
     fprintf(out, " *  Linux logo %s\n", logoname);
     fputs(" */\n\n", out);
     fputs("#include <linux/linux_logo.h>\n\n", out);
-    fprintf(out, "static unsigned char %s_data[] __initdata = {\n",
+    fprintf(out, "static unsigned char %s_data[] = {\n",
 	    logoname);
 }
 
 static void write_footer(void)
 {
     fputs("\n};\n\n", out);
-    fprintf(out, "const struct linux_logo %s __initconst = {\n", logoname);
+    fprintf(out, "const struct linux_logo %s = {\n", logoname);
     fprintf(out, "\t.type\t\t= %s,\n", logo_types[logo_type]);
     fprintf(out, "\t.width\t\t= %d,\n", logo_width);
     fprintf(out, "\t.height\t\t= %d,\n", logo_height);
@@ -381,7 +381,7 @@ static void write_logo_clut224(void)
     fputs("\n};\n\n", out);
 
     /* write logo clut */
-    fprintf(out, "static unsigned char %s_clut[] __initdata = {\n",
+    fprintf(out, "static unsigned char %s_clut[] = {\n",
 	    logoname);
     write_hex_cnt = 0;
     for (i = 0; i < logo_clutsize; i++) {
diff --git a/scripts/sortextable.h b/scripts/sortextable.h
index ba8700428..3f4852cdc 100644
--- a/scripts/sortextable.h
+++ b/scripts/sortextable.h
@@ -108,9 +108,9 @@ do_func(Elf_Ehdr *ehdr, char const *const fname, table_sort_t custom_sort)
 	const char *secstrtab;
 	const char *strtab;
 	char *extab_image;
-	int extab_index = 0;
-	int i;
-	int idx;
+	unsigned int extab_index = 0;
+	unsigned int i;
+	unsigned int idx;
 	unsigned int num_sections;
 	unsigned int secindex_strings;
 
diff --git a/scripts/tags.sh b/scripts/tags.sh
index b3775a960..be6b9f9dc 100755
--- a/scripts/tags.sh
+++ b/scripts/tags.sh
@@ -26,7 +26,7 @@ else
 fi
 
 # ignore userspace tools
-ignore="$ignore ( -path ${tree}tools ) -prune -o"
+ignore="$ignore ( -path \"${tree}tools/[^g]*\" ) -prune -o"
 
 # Find all available archs
 find_all_archs()
diff --git a/security/Kconfig b/security/Kconfig
index 118f45494..288ab93a9 100644
--- a/security/Kconfig
+++ b/security/Kconfig
@@ -4,6 +4,1065 @@
 
 menu "Security options"
 
+menu "Grsecurity"
+
+config ARCH_TRACK_EXEC_LIMIT
+	bool
+
+config PAX_PER_CPU_PGD
+	bool
+
+config TASK_SIZE_MAX_SHIFT
+	int
+	depends on X86_64
+	default 47 if !PAX_PER_CPU_PGD
+	default 42 if PAX_PER_CPU_PGD
+
+config PAX_ENABLE_PAE
+	bool
+	default y if (X86_32 && (MPENTIUM4 || MK8 || MPSC || MCORE2 || MATOM))
+
+config GRKERNSEC
+	bool "Grsecurity"
+	select CRYPTO
+	select CRYPTO_SHA256
+	select PROC_FS
+	select STOP_MACHINE
+	select TTY
+	select DEBUG_KERNEL
+	select DEBUG_LIST
+	select MULTIUSER
+	select BUG
+	help
+	  If you say Y here, you will be able to configure many features
+	  that will enhance the security of your system.  It is highly
+	  recommended that you say Y here and read through the help
+	  for each option so that you fully understand the features and
+	  can evaluate their usefulness for your machine.
+
+choice
+	prompt "Configuration Method"
+	depends on GRKERNSEC
+	default GRKERNSEC_CONFIG_CUSTOM
+	help
+
+config GRKERNSEC_CONFIG_AUTO
+	bool "Automatic"
+	help
+	  If you choose this configuration method, you'll be able to answer a small
+	  number of simple questions about how you plan to use this kernel.
+	  The settings of grsecurity and PaX will be automatically configured for
+	  the highest commonly-used settings within the provided constraints.
+
+	  If you require additional configuration, custom changes can still be made
+	  from the "custom configuration" menu.
+
+config GRKERNSEC_CONFIG_CUSTOM
+	bool "Custom"
+	help
+	  If you choose this configuration method, you'll be able to configure all
+	  grsecurity and PaX settings manually.  Via this method, no options are
+	  automatically enabled.
+
+	  Take note that if menuconfig is exited with this configuration method
+	  chosen, you will not be able to use the automatic configuration methods
+	  without starting again with a kernel configuration with no grsecurity
+	  or PaX options specified inside.
+
+endchoice
+
+choice
+	prompt "Usage Type"
+	depends on (GRKERNSEC && GRKERNSEC_CONFIG_AUTO)
+	default GRKERNSEC_CONFIG_SERVER
+	help
+
+config GRKERNSEC_CONFIG_SERVER
+	bool "Server"
+	help
+	  Choose this option if you plan to use this kernel on a server.
+
+config GRKERNSEC_CONFIG_DESKTOP
+	bool "Desktop"
+	help
+	  Choose this option if you plan to use this kernel on a desktop.
+
+endchoice
+
+choice
+	prompt "Virtualization Type"
+	depends on (GRKERNSEC && X86 && GRKERNSEC_CONFIG_AUTO)
+	default GRKERNSEC_CONFIG_VIRT_NONE
+	help
+
+config GRKERNSEC_CONFIG_VIRT_NONE
+	bool "None"
+	help
+	  Choose this option if this kernel will be run on bare metal.
+
+config GRKERNSEC_CONFIG_VIRT_GUEST
+	bool "Guest"
+	help
+	  Choose this option if this kernel will be run as a VM guest.
+
+config GRKERNSEC_CONFIG_VIRT_HOST
+	bool "Host"
+	help
+	  Choose this option if this kernel will be run as a VM host.
+
+endchoice
+
+choice
+	prompt "Virtualization Hardware"
+	depends on (GRKERNSEC && X86 && GRKERNSEC_CONFIG_AUTO && (GRKERNSEC_CONFIG_VIRT_GUEST || GRKERNSEC_CONFIG_VIRT_HOST))
+	help
+
+config GRKERNSEC_CONFIG_VIRT_EPT
+	bool "EPT/RVI Processor Support"
+	depends on X86
+	help
+	  Choose this option if your CPU supports the EPT or RVI features of 2nd-gen
+	  hardware virtualization.  This allows for additional kernel hardening protections
+	  to operate without additional performance impact.
+
+	  To see if your Intel processor supports EPT, see:
+	  http://ark.intel.com/Products/VirtualizationTechnology
+	  (Most Core i3/5/7 support EPT)
+
+	  To see if your AMD processor supports RVI, see:
+	  http://support.amd.com/us/kbarticles/Pages/GPU120AMDRVICPUsHyperVWin8.aspx
+
+config GRKERNSEC_CONFIG_VIRT_SOFT
+	bool "First-gen/No Hardware Virtualization"
+	help
+	  Choose this option if you use an Atom/Pentium/Core 2 processor that either doesn't
+	  support hardware virtualization or doesn't support the EPT/RVI extensions.
+
+endchoice
+
+choice
+	prompt "Virtualization Software"
+	depends on (GRKERNSEC && GRKERNSEC_CONFIG_AUTO && (GRKERNSEC_CONFIG_VIRT_GUEST || GRKERNSEC_CONFIG_VIRT_HOST))
+	help
+
+config GRKERNSEC_CONFIG_VIRT_XEN
+	bool "Xen"
+	help
+	  Choose this option if this kernel is running as a Xen guest or host.
+
+config GRKERNSEC_CONFIG_VIRT_VMWARE
+	bool "VMWare"
+	help
+	  Choose this option if this kernel is running as a VMWare guest or host.
+
+config GRKERNSEC_CONFIG_VIRT_KVM
+	bool "KVM"
+	help
+	  Choose this option if this kernel is running as a KVM guest or host.
+
+config GRKERNSEC_CONFIG_VIRT_VIRTUALBOX
+	bool "VirtualBox"
+	help
+	  Choose this option if this kernel is running as a VirtualBox guest or host.
+
+config GRKERNSEC_CONFIG_VIRT_HYPERV
+	bool "Hyper-V"
+	help
+	  Choose this option if this kernel is running as a Hyper-V guest.
+
+endchoice
+
+choice
+	prompt "Required Priorities"
+	depends on (GRKERNSEC && GRKERNSEC_CONFIG_AUTO)
+	default GRKERNSEC_CONFIG_PRIORITY_PERF
+	help
+
+config GRKERNSEC_CONFIG_PRIORITY_PERF
+	bool "Performance"
+	help
+	  Choose this option if performance is of highest priority for this deployment
+	  of grsecurity.  Features like UDEREF on a 64bit kernel, kernel stack clearing,
+	  clearing of structures intended for userland, and freed memory sanitizing will
+	  be disabled.
+
+config GRKERNSEC_CONFIG_PRIORITY_SECURITY
+	bool "Security"
+	help
+	  Choose this option if security is of highest priority for this deployment of
+	  grsecurity.  UDEREF, kernel stack clearing, clearing of structures intended
+	  for userland, and freed memory sanitizing will be enabled for this kernel.
+	  In a worst-case scenario, these features can introduce a 20% performance hit
+	  (UDEREF on x64 contributing half of this hit).
+
+endchoice
+
+menu "Default Special Groups"
+depends on (GRKERNSEC && GRKERNSEC_CONFIG_AUTO)
+
+config GRKERNSEC_PROC_GID
+	int "GID exempted from /proc restrictions"
+	default 1001
+	help
+	  Setting this GID determines which group will be exempted from
+	  grsecurity's /proc restrictions, allowing users of the specified
+	  group  to view network statistics and the existence of other users'
+	  processes on the system.  This GID may also be chosen at boot time
+	  via "grsec_proc_gid=" on the kernel commandline.
+
+config GRKERNSEC_TPE_UNTRUSTED_GID
+        int "GID for TPE-untrusted users"
+        depends on GRKERNSEC_CONFIG_SERVER && GRKERNSEC_TPE && !GRKERNSEC_TPE_INVERT
+        default 1005
+        help
+	  Setting this GID determines which group untrusted users should
+	  be added to.  These users will be placed under grsecurity's Trusted Path
+	  Execution mechanism, preventing them from executing their own binaries.
+	  The users will only be able to execute binaries in directories owned and
+	  writable only by the root user.  If the sysctl option is enabled, a sysctl
+	  option with name "tpe_gid" is created.
+
+config GRKERNSEC_TPE_TRUSTED_GID
+        int "GID for TPE-trusted users"
+        depends on GRKERNSEC_CONFIG_SERVER && GRKERNSEC_TPE && GRKERNSEC_TPE_INVERT
+        default 1005
+        help
+          Setting this GID determines what group TPE restrictions will be
+          *disabled* for.  If the sysctl option is enabled, a sysctl option
+          with name "tpe_gid" is created.
+
+config GRKERNSEC_SYMLINKOWN_GID
+        int "GID for users with kernel-enforced SymlinksIfOwnerMatch"
+        depends on GRKERNSEC_CONFIG_SERVER
+        default 1006
+        help
+          Setting this GID determines what group kernel-enforced
+          SymlinksIfOwnerMatch will be enabled for.  If the sysctl option
+          is enabled, a sysctl option with name "symlinkown_gid" is created.
+
+
+endmenu
+
+menu "Customize Configuration"
+depends on GRKERNSEC
+
+menu "PaX"
+
+config PAX
+	bool "Enable various PaX features"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC && (ALPHA || ARM || AVR32 || IA64 || MIPS || PARISC || PPC || SPARC || X86)
+	help
+	  This allows you to enable various PaX features.  PaX adds
+	  intrusion prevention mechanisms to the kernel that reduce
+	  the risks posed by exploitable memory corruption bugs.
+
+menu "PaX Control"
+	depends on PAX
+
+config PAX_SOFTMODE
+	bool 'Support soft mode'
+	help
+	  Enabling this option will allow you to run PaX in soft mode, that
+	  is, PaX features will not be enforced by default, only on executables
+	  marked explicitly.  You must also enable PT_PAX_FLAGS or XATTR_PAX_FLAGS
+	  support as they are the only way to mark executables for soft mode use.
+
+	  Soft mode can be activated by using the "pax_softmode=1" kernel command
+	  line option on boot.  Furthermore you can control various PaX features
+	  at runtime via the entries in /proc/sys/kernel/pax.
+
+config PAX_EI_PAX
+	bool 'Use legacy ELF header marking'
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  Enabling this option will allow you to control PaX features on
+	  a per executable basis via the 'chpax' utility available at
+	  http://pax.grsecurity.net/.  The control flags will be read from
+	  an otherwise reserved part of the ELF header.  This marking has
+	  numerous drawbacks (no support for soft-mode, toolchain does not
+	  know about the non-standard use of the ELF header) therefore it
+	  has been deprecated in favour of PT_PAX_FLAGS and XATTR_PAX_FLAGS
+	  support.
+
+	  Note that if you enable PT_PAX_FLAGS or XATTR_PAX_FLAGS marking
+	  support as well, they will override the legacy EI_PAX marks.
+
+	  If you enable none of the marking options then all applications
+	  will run with PaX enabled on them by default.
+
+config PAX_PT_PAX_FLAGS
+	bool 'Use ELF program header marking'
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  Enabling this option will allow you to control PaX features on
+	  a per executable basis via the 'paxctl' utility available at
+	  http://pax.grsecurity.net/.  The control flags will be read from
+	  a PaX specific ELF program header (PT_PAX_FLAGS).  This marking
+	  has the benefits of supporting both soft mode and being fully
+	  integrated into the toolchain (the binutils patch is available
+	  from http://pax.grsecurity.net).
+
+	  Note that if you enable the legacy EI_PAX marking support as well,
+	  the EI_PAX marks will be overridden by the PT_PAX_FLAGS marks.
+
+	  If you enable both PT_PAX_FLAGS and XATTR_PAX_FLAGS support then you
+	  must make sure that the marks are the same if a binary has both marks.
+
+	  If you enable none of the marking options then all applications
+	  will run with PaX enabled on them by default.
+
+config PAX_XATTR_PAX_FLAGS
+	bool 'Use filesystem extended attributes marking'
+	default y if GRKERNSEC_CONFIG_AUTO
+	select CIFS_XATTR if CIFS
+	select EXT2_FS_XATTR if EXT2_FS
+	select EXT3_FS_XATTR if EXT3_FS
+	select F2FS_FS_XATTR if F2FS_FS
+	select JFFS2_FS_XATTR if JFFS2_FS
+	select REISERFS_FS_XATTR if REISERFS_FS
+	select SQUASHFS_XATTR if SQUASHFS
+	select TMPFS_XATTR if TMPFS
+	help
+	  Enabling this option will allow you to control PaX features on
+	  a per executable basis via the 'setfattr' utility.  The control
+	  flags will be read from the user.pax.flags extended attribute of
+	  the file.  This marking has the benefit of supporting binary-only
+	  applications that self-check themselves (e.g., skype) and would
+	  not tolerate chpax/paxctl changes.  The main drawback is that
+	  extended attributes are not supported by some filesystems (e.g.,
+	  isofs, udf, vfat) so copying files through such filesystems will
+	  lose the extended attributes and these PaX markings.
+
+	  Note that if you enable the legacy EI_PAX marking support as well,
+	  the EI_PAX marks will be overridden by the XATTR_PAX_FLAGS marks.
+
+	  If you enable both PT_PAX_FLAGS and XATTR_PAX_FLAGS support then you
+	  must make sure that the marks are the same if a binary has both marks.
+
+	  If you enable none of the marking options then all applications
+	  will run with PaX enabled on them by default.
+
+choice
+	prompt 'MAC system integration'
+	default PAX_HAVE_ACL_FLAGS
+	help
+	  Mandatory Access Control systems have the option of controlling
+	  PaX flags on a per executable basis, choose the method supported
+	  by your particular system.
+
+	  - "none": if your MAC system does not interact with PaX,
+	  - "direct": if your MAC system defines pax_set_initial_flags() itself,
+	  - "hook": if your MAC system uses the pax_set_initial_flags_func callback.
+
+	  NOTE: this option is for developers/integrators only.
+
+	config PAX_NO_ACL_FLAGS
+		bool 'none'
+
+	config PAX_HAVE_ACL_FLAGS
+		bool 'direct'
+
+	config PAX_HOOK_ACL_FLAGS
+		bool 'hook'
+endchoice
+
+endmenu
+
+menu "Non-executable pages"
+	depends on PAX
+
+config PAX_NOEXEC
+	bool "Enforce non-executable pages"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on ALPHA || (ARM && (CPU_V6 || CPU_V6K || CPU_V7)) || IA64 || MIPS || PARISC || PPC || S390 || SPARC || X86
+	help
+	  By design some architectures do not allow for protecting memory
+	  pages against execution or even if they do, Linux does not make
+	  use of this feature.  In practice this means that if a page is
+	  readable (such as the stack or heap) it is also executable.
+
+	  There is a well known exploit technique that makes use of this
+	  fact and a common programming mistake where an attacker can
+	  introduce code of his choice somewhere in the attacked program's
+	  memory (typically the stack or the heap) and then execute it.
+
+	  If the attacked program was running with different (typically
+	  higher) privileges than that of the attacker, then he can elevate
+	  his own privilege level (e.g. get a root shell, write to files for
+	  which he does not have write access to, etc).
+
+	  Enabling this option will let you choose from various features
+	  that prevent the injection and execution of 'foreign' code in
+	  a program.
+
+	  This will also break programs that rely on the old behaviour and
+	  expect that dynamically allocated memory via the malloc() family
+	  of functions is executable (which it is not).  Notable examples
+	  are the XFree86 4.x server, the java runtime and wine.
+
+config PAX_PAGEEXEC
+	bool "Paging based non-executable pages"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on PAX_NOEXEC && (!X86_32 || M586 || M586TSC || M586MMX || M686 || MPENTIUMII || MPENTIUMIII || MPENTIUMM || MCORE2 || MATOM || MPENTIUM4 || MPSC || MK7 || MK8 || MWINCHIPC6 || MWINCHIP2 || MWINCHIP3D || MVIAC3_2 || MVIAC7)
+	select ARCH_TRACK_EXEC_LIMIT if X86_32
+	help
+	  This implementation is based on the paging feature of the CPU.
+	  On i386 without hardware non-executable bit support there is a
+	  variable but usually low performance impact, however on Intel's
+	  P4 core based CPUs it is very high so you should not enable this
+	  for kernels meant to be used on such CPUs.
+
+	  On alpha, avr32, ia64, parisc, sparc, sparc64, x86_64 and i386
+	  with hardware non-executable bit support there is no performance
+	  impact, on ppc the impact is negligible.
+
+	  Note that several architectures require various emulations due to
+	  badly designed userland ABIs, this will cause a performance impact
+	  but will disappear as soon as userland is fixed. For example, ppc
+	  userland MUST have been built with secure-plt by a recent toolchain.
+
+config PAX_SEGMEXEC
+	bool "Segmentation based non-executable pages"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on PAX_NOEXEC && X86_32
+	help
+	  This implementation is based on the segmentation feature of the
+	  CPU and has a very small performance impact, however applications
+	  will be limited to a 1.5 GB address space instead of the normal
+	  3 GB.
+
+config PAX_EMUTRAMP
+	bool "Emulate trampolines"
+	default y if PARISC || GRKERNSEC_CONFIG_AUTO
+	depends on (PAX_PAGEEXEC || PAX_SEGMEXEC) && (PARISC || X86)
+	help
+	  There are some programs and libraries that for one reason or
+	  another attempt to execute special small code snippets from
+	  non-executable memory pages.  Most notable examples are the
+	  signal handler return code generated by the kernel itself and
+	  the GCC trampolines.
+
+	  If you enabled CONFIG_PAX_PAGEEXEC or CONFIG_PAX_SEGMEXEC then
+	  such programs will no longer work under your kernel.
+
+	  As a remedy you can say Y here and use the 'chpax' or 'paxctl'
+	  utilities to enable trampoline emulation for the affected programs
+	  yet still have the protection provided by the non-executable pages.
+
+	  On parisc you MUST enable this option and EMUSIGRT as well, otherwise
+	  your system will not even boot.
+
+	  Alternatively you can say N here and use the 'chpax' or 'paxctl'
+	  utilities to disable CONFIG_PAX_PAGEEXEC and CONFIG_PAX_SEGMEXEC
+	  for the affected files.
+
+	  NOTE: enabling this feature *may* open up a loophole in the
+	  protection provided by non-executable pages that an attacker
+	  could abuse.  Therefore the best solution is to not have any
+	  files on your system that would require this option.  This can
+	  be achieved by not using libc5 (which relies on the kernel
+	  signal handler return code) and not using or rewriting programs
+	  that make use of the nested function implementation of GCC.
+	  Skilled users can just fix GCC itself so that it implements
+	  nested function calls in a way that does not interfere with PaX.
+
+config PAX_EMUSIGRT
+	bool "Automatically emulate sigreturn trampolines"
+	depends on PAX_EMUTRAMP && PARISC
+	default y
+	help
+	  Enabling this option will have the kernel automatically detect
+	  and emulate signal return trampolines executing on the stack
+	  that would otherwise lead to task termination.
+
+	  This solution is intended as a temporary one for users with
+	  legacy versions of libc (libc5, glibc 2.0, uClibc before 0.9.17,
+	  Modula-3 runtime, etc) or executables linked to such, basically
+	  everything that does not specify its own SA_RESTORER function in
+	  normal executable memory like glibc 2.1+ does.
+
+	  On parisc you MUST enable this option, otherwise your system will
+	  not even boot.
+
+	  NOTE: this feature cannot be disabled on a per executable basis
+	  and since it *does* open up a loophole in the protection provided
+	  by non-executable pages, the best solution is to not have any
+	  files on your system that would require this option.
+
+config PAX_MPROTECT
+	bool "Restrict mprotect()"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on (PAX_PAGEEXEC || PAX_SEGMEXEC)
+	help
+	  Enabling this option will prevent programs from
+	   - changing the executable status of memory pages that were
+	     not originally created as executable,
+	   - making read-only executable pages writable again,
+	   - creating executable pages from anonymous memory,
+	   - making read-only-after-relocations (RELRO) data pages writable again.
+
+	  You should say Y here to complete the protection provided by
+	  the enforcement of non-executable pages.
+
+	  NOTE: you can use the 'chpax' or 'paxctl' utilities to control
+	  this feature on a per file basis.
+
+config PAX_MPROTECT_COMPAT
+	bool "Use legacy/compat protection demoting (read help)"
+	depends on PAX_MPROTECT
+	default n
+	help
+	  The current implementation of PAX_MPROTECT denies RWX allocations/mprotects
+	  by sending the proper error code to the application.  For some older
+	  userland, this can cause problems with applications that assume such
+	  allocations will not be prevented by PaX or SELinux and other access
+	  control systems and have no fallback mechanisms.  For modern distros,
+	  this option should generally be set to 'N'.
+
+config PAX_ELFRELOCS
+	bool "Allow ELF text relocations (read help)"
+	depends on PAX_MPROTECT
+	default n
+	help
+	  Non-executable pages and mprotect() restrictions are effective
+	  in preventing the introduction of new executable code into an
+	  attacked task's address space.  There remain only two venues
+	  for this kind of attack: if the attacker can execute already
+	  existing code in the attacked task then he can either have it
+	  create and mmap() a file containing his code or have it mmap()
+	  an already existing ELF library that does not have position
+	  independent code in it and use mprotect() on it to make it
+	  writable and copy his code there.  While protecting against
+	  the former approach is beyond PaX, the latter can be prevented
+	  by having only PIC ELF libraries on one's system (which do not
+	  need to relocate their code).  If you are sure this is your case,
+	  as is the case with all modern Linux distributions, then leave
+	  this option disabled.  You should say 'n' here.
+
+config PAX_ETEXECRELOCS
+	bool "Allow ELF ET_EXEC text relocations"
+	depends on PAX_MPROTECT && (ALPHA || IA64 || PARISC)
+	select PAX_ELFRELOCS
+	default y
+	help
+	  On some architectures there are incorrectly created applications
+	  that require text relocations and would not work without enabling
+	  this option.  If you are an alpha, ia64 or parisc user, you should
+	  enable this option and disable it once you have made sure that
+	  none of your applications need it.
+
+config PAX_EMUPLT
+	bool "Automatically emulate ELF PLT"
+	depends on PAX_MPROTECT && (ALPHA || PARISC || SPARC)
+	default y
+	help
+	  Enabling this option will have the kernel automatically detect
+	  and emulate the Procedure Linkage Table entries in ELF files.
+	  On some architectures such entries are in writable memory, and
+	  become non-executable leading to task termination.  Therefore
+	  it is mandatory that you enable this option on alpha, parisc,
+	  sparc and sparc64, otherwise your system would not even boot.
+
+	  NOTE: this feature *does* open up a loophole in the protection
+	  provided by the non-executable pages, therefore the proper
+	  solution is to modify the toolchain to produce a PLT that does
+	  not need to be writable.
+
+config PAX_DLRESOLVE
+	bool 'Emulate old glibc resolver stub'
+	depends on PAX_EMUPLT && SPARC
+	default n
+	help
+	  This option is needed if userland has an old glibc (before 2.4)
+	  that puts a 'save' instruction into the runtime generated resolver
+	  stub that needs special emulation.
+
+config PAX_KERNEXEC
+	bool "Enforce non-executable kernel pages"
+	default y if GRKERNSEC_CONFIG_AUTO && (!X86 || GRKERNSEC_CONFIG_VIRT_NONE || (GRKERNSEC_CONFIG_VIRT_EPT && GRKERNSEC_CONFIG_VIRT_GUEST) || (GRKERNSEC_CONFIG_VIRT_EPT && GRKERNSEC_CONFIG_VIRT_KVM))
+	depends on (X86 || (ARM && (CPU_V6 || CPU_V6K || CPU_V7) && !(ARM_LPAE && MODULES))) && !XEN
+	select PAX_PER_CPU_PGD if X86_64 || (X86_32 && X86_PAE)
+	select ARM_KERNMEM_PERMS if ARM
+	help
+	  This is the kernel land equivalent of PAGEEXEC and MPROTECT,
+	  that is, enabling this option will make it harder to inject
+	  and execute 'foreign' code in kernel memory itself.
+
+	  Note that on amd64, CONFIG_EFI enabled with "efi=old_map" on
+	  the kernel command-line will result in an RWX physical map.
+
+	  Likewise, the EFI runtime services are necessarily mapped as
+	  RWX.  If CONFIG_EFI is enabled on an EFI-capable system, it
+	  is recommended that you boot with "noefi" on the kernel
+	  command-line if possible to eliminate the mapping.
+
+config PAX_KERNEXEC_PLUGIN
+	bool
+	depends on GCC_PLUGINS && X86_64
+
+choice
+	prompt "Code Pointer Instrumentation Method"
+	default PAX_KERNEXEC_PLUGIN_METHOD_BTS
+	depends on GCC_PLUGINS && X86_64 && (PAX_KERNEXEC || PAX_RAP)
+	help
+	  KERNEXEC on amd64 is not as secure as its i386 variant due to the
+	  lack of certain processor features. This option can bring back some
+	  of the security by forcing all code pointers at runtime to fall into
+	  kernel memory. This is achieved via compile time instrumentation of
+	  all code pointer dereferences (indirect calls and function returns).
+
+	  While there are alternative mechanisms (SMEP, UDEREF) that can achieve
+	  the same or even more, they also have their own drawbacks in terms of
+	  performance impact and/or being processor dependent so this feature
+	  offers a choice by having a low performance impact and being processor
+	  independent.
+
+	  If you enabled RAP (see PAX_RAP) and have an amd64 processor that does
+	  not support SMEP then you must also enable a KERNEXEC code pointer
+	  instrumentation method.
+
+	  Note that binary modules cannot be instrumented by this approach.
+
+	  Note that the implementation requires a gcc with plugin support,
+	  i.e., gcc 4.5 or newer.  You may need to install the supporting
+	  headers explicitly in addition to the normal gcc package.
+
+	config PAX_KERNEXEC_PLUGIN_METHOD_NONE
+		bool "none"
+		help
+		  In case your processor supports Supervisor Mode Execution
+		  Prevention (SMEP) you should choose this option to disable
+		  compile time instrumentation.
+
+		  Note that the kernel will refuse to boot if SMEP is not
+		  supported by the processor or is disabled on the kernel
+		  command line.
+
+	config PAX_KERNEXEC_PLUGIN_METHOD_BTS
+		bool "bts"
+		select PAX_KERNEXEC_PLUGIN
+		help
+		  This method is compatible with binary only modules but has
+		  a higher runtime overhead.
+
+	config PAX_KERNEXEC_PLUGIN_METHOD_OR
+		bool "or"
+		depends on !PARAVIRT
+		select PAX_KERNEXEC_PLUGIN
+		help
+		  This method is incompatible with binary only modules but has
+		  a lower runtime overhead.
+endchoice
+
+config PAX_KERNEXEC_MODULE_TEXT
+	int "Minimum amount of memory reserved for module code"
+	default "8" if (!GRKERNSEC_CONFIG_AUTO || GRKERNSEC_CONFIG_SERVER)
+	default "12" if (GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_DESKTOP)
+	depends on PAX_KERNEXEC && X86_32
+	help
+	  Due to implementation details the kernel must reserve a fixed
+	  amount of memory for runtime allocated code (such as modules)
+	  at compile time that cannot be changed at runtime.  Here you
+	  can specify the minimum amount in MB that will be reserved.
+	  Due to the same implementation details this size will always
+	  be rounded up to the next 2/4 MB boundary (depends on PAE) so
+	  the actually available memory for runtime allocated code will
+	  usually be more than this minimum.
+
+	  The default 4 MB should be enough for most users but if you have
+	  an excessive number of modules (e.g., most distribution configs
+	  compile many drivers as modules) or use huge modules such as
+	  nvidia's kernel driver, you will need to adjust this amount.
+	  A good rule of thumb is to look at your currently loaded kernel
+	  modules and add up their sizes.
+
+endmenu
+
+menu "Address Space Layout Randomization"
+	depends on PAX
+
+config PAX_ASLR
+	bool "Address Space Layout Randomization"
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  Many if not most exploit techniques rely on the knowledge of
+	  certain addresses in the attacked program.  The following options
+	  will allow the kernel to apply a certain amount of randomization
+	  to specific parts of the program thereby forcing an attacker to
+	  guess them in most cases.  Any failed guess will most likely crash
+	  the attacked program which allows the kernel to detect such attempts
+	  and react on them.  PaX itself provides no reaction mechanisms,
+	  instead it is strongly encouraged that you make use of grsecurity's
+	  (http://www.grsecurity.net/) built-in crash detection features or
+	  develop one yourself.
+
+	  By saying Y here you can choose to randomize the following areas:
+	   - top of the task's kernel stack
+	   - top of the task's userland stack
+	   - base address for mmap() requests that do not specify one
+	     (this includes all libraries)
+	   - base address of the main executable
+
+	  It is strongly recommended to say Y here as address space layout
+	  randomization has negligible impact on performance yet it provides
+	  a very effective protection.
+
+	  NOTE: you can use the 'chpax' or 'paxctl' utilities to control
+	  this feature on a per file basis.
+
+config PAX_RANDKSTACK
+	bool "Randomize kernel stack base"
+	default y if GRKERNSEC_CONFIG_AUTO && !(GRKERNSEC_CONFIG_VIRT_HOST && GRKERNSEC_CONFIG_VIRT_VIRTUALBOX)
+	depends on X86_TSC && X86
+	help
+	  By saying Y here the kernel will randomize every task's kernel
+	  stack on every system call.  This will not only force an attacker
+	  to guess it but also prevent him from making use of possible
+	  leaked information about it.
+
+	  Since the kernel stack is a rather scarce resource, randomization
+	  may cause unexpected stack overflows, therefore you should very
+	  carefully test your system.  Note that once enabled in the kernel
+	  configuration, this feature cannot be disabled on a per file basis.
+
+config PAX_RANDUSTACK
+	bool
+
+config PAX_RANDMMAP
+	bool "Randomize user stack and mmap() bases"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on PAX_ASLR
+	select PAX_RANDUSTACK
+	help
+	  By saying Y here the kernel will randomize every task's userland
+	  stack and use a randomized base address for mmap() requests that
+	  do not specify one themselves.
+
+	  The stack randomization is done in two steps where the second
+	  one may apply a big amount of shift to the top of the stack and
+	  cause problems for programs that want to use lots of memory (more
+	  than 2.5 GB if SEGMEXEC is not active, or 1.25 GB when it is).
+
+	  As a result of mmap randomization all dynamically loaded libraries
+	  will appear at random addresses and therefore be harder to exploit
+	  by a technique where an attacker attempts to execute library code
+	  for his purposes (e.g. spawn a shell from an exploited program that
+	  is running at an elevated privilege level).
+
+	  Furthermore, if a program is relinked as a dynamic ELF file, its
+	  base address will be randomized as well, completing the full
+	  randomization of the address space layout.  Attacking such programs
+	  becomes a guess game.  You can find an example of doing this at
+	  http://pax.grsecurity.net/et_dyn.tar.gz and practical samples at
+	  http://www.grsecurity.net/grsec-gcc-specs.tar.gz .
+
+	  NOTE: you can use the 'chpax' or 'paxctl' utilities to control this
+	  feature on a per file basis.
+
+endmenu
+
+menu "Miscellaneous hardening features"
+
+config PAX_MEMORY_SANITIZE
+	bool "Sanitize all freed memory"
+	default y if (GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_PRIORITY_SECURITY)
+	help
+	  By saying Y here the kernel will erase memory pages and slab objects
+	  as soon as they are freed.  This in turn reduces the lifetime of data
+	  stored in them, making it less likely that sensitive information such
+	  as passwords, cryptographic secrets, etc stay in memory for too long.
+
+	  This is especially useful for programs whose runtime is short, long
+	  lived processes and the kernel itself benefit from this as long as
+	  they ensure timely freeing of memory that may hold sensitive
+	  information.
+
+	  A nice side effect of the sanitization of slab objects is the
+	  reduction of possible info leaks caused by padding bytes within the
+	  leaky structures.  Use-after-free bugs for structures containing
+	  pointers can also be detected as dereferencing the sanitized pointer
+	  will generate an access violation.
+
+	  The tradeoff is performance impact, on a single CPU system kernel
+	  compilation sees a 3% slowdown, other systems and workloads may vary
+	  and you are advised to test this feature on your expected workload
+	  before deploying it.
+
+	  The slab sanitization feature excludes a few slab caches per default
+	  for performance reasons.  To extend the feature to cover those as
+	  well, pass "pax_sanitize_slab=full" as kernel command line parameter.
+
+	  To reduce the performance penalty by sanitizing pages only, albeit
+	  limiting the effectiveness of this feature at the same time, slab
+	  sanitization can be disabled with the kernel command line parameter
+	  "pax_sanitize_slab=off".
+
+	  Note that this feature does not protect data stored in live pages,
+	  e.g., process memory swapped to disk may stay there for a long time.
+
+config PAX_MEMORY_STACKLEAK
+	bool "Sanitize kernel stack"
+	default y if (GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_PRIORITY_SECURITY)
+	depends on X86 && GCC_PLUGINS
+	help
+	  By saying Y here the kernel will erase the kernel stack before it
+	  returns from a system call.  This in turn reduces the information
+	  that a kernel stack leak bug can reveal.
+
+	  Note that such a bug can still leak information that was put on
+	  the stack by the current system call (the one eventually triggering
+	  the bug) but traces of earlier system calls on the kernel stack
+	  cannot leak anymore.
+
+	  The tradeoff is performance impact: on a single CPU system kernel
+	  compilation sees a 1% slowdown, other systems and workloads may vary
+	  and you are advised to test this feature on your expected workload
+	  before deploying it.
+
+	  Note that the full feature requires a gcc with plugin support,
+	  i.e., gcc 4.5 or newer.  You may need to install the supporting
+	  headers explicitly in addition to the normal gcc package.  Using
+	  older gcc versions means that functions with large enough stack
+	  frames may leave uninitialized memory behind that may be exposed
+	  to a later syscall leaking the stack.
+
+config PAX_MEMORY_STRUCTLEAK
+	bool "Forcibly initialize local variables copied to userland"
+	default y if (GRKERNSEC_CONFIG_AUTO && GRKERNSEC_CONFIG_PRIORITY_SECURITY)
+	depends on GCC_PLUGINS
+	help
+	  By saying Y here the kernel will zero initialize some local
+	  variables that are going to be copied to userland.  This in
+	  turn prevents unintended information leakage from the kernel
+	  stack should later code forget to explicitly set all parts of
+	  the copied variable.
+
+	  The tradeoff is less performance impact than PAX_MEMORY_STACKLEAK
+	  at a much smaller coverage.
+
+	  Note that the implementation requires a gcc with plugin support,
+	  i.e., gcc 4.5 or newer.  You may need to install the supporting
+	  headers explicitly in addition to the normal gcc package.
+
+config PAX_MEMORY_UDEREF
+	bool "Prevent invalid userland pointer dereference"
+	default y if GRKERNSEC_CONFIG_AUTO && !(X86_64 && GRKERNSEC_CONFIG_PRIORITY_PERF) && !(X86_64 && GRKERNSEC_CONFIG_VIRT_HOST && GRKERNSEC_CONFIG_VIRT_VIRTUALBOX) && (!X86 || GRKERNSEC_CONFIG_VIRT_NONE || GRKERNSEC_CONFIG_VIRT_EPT)
+	depends on (X86 || (ARM && (CPU_V6 || CPU_V6K || CPU_V7) && !ARM_LPAE)) && !UML_X86 && !XEN
+	select PAX_PER_CPU_PGD if X86_64
+	help
+	  By saying Y here the kernel will be prevented from dereferencing
+	  userland pointers in contexts where the kernel expects only kernel
+	  pointers.  This is both a useful runtime debugging feature and a
+	  security measure that prevents exploiting a class of kernel bugs.
+
+	  The tradeoff is that some virtualization solutions may experience
+	  a huge slowdown and therefore you should not enable this feature
+	  for kernels meant to run in such environments.  Whether a given VM
+	  solution is affected or not is best determined by simply trying it
+	  out, the performance impact will be obvious right on boot as this
+	  mechanism engages from very early on.  A good rule of thumb is that
+	  VMs running on CPUs without hardware virtualization support (i.e.,
+	  the majority of IA-32 CPUs) will likely experience the slowdown.
+
+	  On X86_64 the kernel will make use of PCID support when available
+	  (Intel's Westmere, Sandy Bridge, etc) for better security (default)
+	  or performance impact.  Pass pax_weakuderef on the kernel command
+	  line to choose the latter.
+
+config PAX_REFCOUNT
+	bool "Prevent various kernel object reference counter overflows"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC && ((ARM && (CPU_V6 || CPU_V6K || CPU_V7)) || MIPS || PPC || SPARC64 || X86)
+	help
+	  By saying Y here the kernel will detect and prevent overflowing
+	  various (but not all) kinds of object reference counters.  Such
+	  overflows can normally occur due to bugs only and are often, if
+	  not always, exploitable.
+
+	  The tradeoff is that data structures protected by an overflowed
+	  refcount will never be freed and therefore will leak memory.  Note
+	  that this leak also happens even without this protection but in
+	  that case the overflow can eventually trigger the freeing of the
+	  data structure while it is still being used elsewhere, resulting
+	  in the exploitable situation that this feature prevents.
+
+	  Since this has a negligible performance impact, you should enable
+	  this feature.
+
+config PAX_USERCOPY
+	bool "Harden memory copies between kernel and userland"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GRKERNSEC && HAVE_ARCH_HARDENED_USERCOPY
+	select HARDENED_USERCOPY
+	help
+	  By saying Y here the kernel will enforce the size of heap objects
+	  when they are copied in either direction between the kernel and
+	  userland, even if only a part of the heap object is copied.
+
+	  Specifically, this checking prevents information leaking from the
+	  kernel heap during kernel to userland copies (if the kernel heap
+	  object is otherwise fully initialized) and prevents kernel heap
+	  overflows during userland to kernel copies.
+
+	  Note that the current implementation provides the strictest bounds
+	  checks for the SLUB allocator.
+
+	  Enabling this option also enables per-slab cache protection against
+	  data in a given cache being copied into/out of via userland
+	  accessors.  Though the whitelist of regions will be reduced over
+	  time, it notably protects important data structures like task structs.
+
+	  If frame pointers are enabled on x86, this option will also restrict
+	  copies into and out of the kernel stack to local variables within a
+	  single frame.
+
+	  Since this has a negligible performance impact, you should enable
+	  this feature.
+
+config PAX_CONSTIFY_PLUGIN
+	bool "Automatically constify eligible structures"
+	default y
+	depends on !UML && PAX_KERNEXEC && GCC_PLUGINS
+	help
+	  By saying Y here the compiler will automatically constify a class
+	  of types that contain only function pointers.  This reduces the
+	  kernel's attack surface and also produces a better memory layout.
+
+	  Note that the implementation requires a gcc with plugin support,
+	  i.e., gcc 4.5 or newer.  You may need to install the supporting
+	  headers explicitly in addition to the normal gcc package.
+
+	  Note that if some code really has to modify constified variables
+	  then the source code will have to be patched to allow it.  Examples
+	  can be found in PaX itself (the no_const attribute) and for some
+	  out-of-tree modules at http://www.grsecurity.net/~paxguy1/ .
+
+
+config PAX_USERCOPY_DEBUG
+	bool
+	depends on X86 && PAX_USERCOPY
+	default n
+
+config PAX_SIZE_OVERFLOW
+	bool "Prevent various integer overflows in function size parameters"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GCC_PLUGINS
+	depends on !SPARC64 && !ARM64
+	help
+	  By saying Y here the kernel recomputes expressions of function
+	  arguments marked by a size_overflow attribute with double integer
+	  precision (DImode/TImode for 32/64 bit integer types).
+
+	  If the recomputed argument does not fit the original type then the
+	  event is logged. If the pax_size_overflow_report_only parameter is
+	  NOT passed on the kernel command line at boot then the triggering
+	  process will also be killed.
+
+	  Homepage: https://github.com/ephox-gcc-plugins/size_overflow
+	  Blog: http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+
+	  Note that the implementation requires a gcc with plugin support,
+	  i.e., gcc 4.5 or newer.  You may need to install the supporting
+	  headers explicitly in addition to the normal gcc package.
+
+config PAX_SIZE_OVERFLOW_EXTRA
+	bool "Increase coverage of size overflow checking"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on PAX_SIZE_OVERFLOW
+	help
+	  By saying Y here the kernel will instrument more size argument
+	  calculations that off-line static analysis tracked back through
+	  indirect function calls, structure fields and global variables.
+
+	  This greatly increases coverage and thus security however there
+	  are also more false positives and the performance impact is higher
+	  as well.
+
+config PAX_INITIFY
+	bool "Free more kernel memory after init"
+	depends on GCC_PLUGINS
+	help
+	  The kernel has a mechanism to free up code and data memory that is
+	  only used during kernel or module initialization.  Enabling this
+	  feature will teach the compiler to find more such code and data
+	  that can be freed after initialization.
+
+config HAVE_PAX_INITIFY_INIT_EXIT
+	bool
+	depends on GCC_PLUGINS
+	help
+	  Move functions to the exit section if they are called by __init and
+	  __exit functions too.
+
+config PAX_INITIFY_INIT_EXIT
+	bool
+	depends on PAX_INITIFY && HAVE_PAX_INITIFY_INIT_EXIT
+
+config PAX_INITIFY_VERBOSE
+	bool "Free more kernel memory after init (verbose mode)"
+	depends on GCC_PLUGINS && PAX_INITIFY
+	help
+	  Print all initified strings and all functions which should be
+	  __init/__exit.
+
+	  Note that the candidates identified for __init/__exit markings
+	  depend on the current kernel configuration and thus should be
+	  verified manually before the source code is patched.
+
+config PAX_LATENT_ENTROPY
+	bool "Generate some entropy during boot and runtime"
+	default y if GRKERNSEC_CONFIG_AUTO
+	depends on GCC_PLUGINS
+	help
+	  By saying Y here the kernel will instrument some kernel code to
+	  extract some entropy from both original and artificially created
+	  program state.  This will help especially embedded systems where
+	  there is little 'natural' source of entropy normally.  The cost
+	  is some slowdown of the boot process (about 0.5%) and fork and
+	  irq processing.
+
+	  When pax_extra_latent_entropy is passed on the kernel command line,
+	  entropy will be extracted from up to the first 4GB of RAM while the
+	  runtime memory allocator is being initialized.  This costs even more
+	  slowdown of the boot process.
+
+	  Note that the implementation requires a gcc with plugin support,
+	  i.e., gcc 4.5 or newer.  You may need to install the supporting
+	  headers explicitly in addition to the normal gcc package.
+
+	  Note that entropy extracted this way is not cryptographically
+	  secure!
+
+config PAX_RAP
+	bool "Prevent code reuse attacks"
+	depends on X86_64 && GCC_PLUGINS
+	default y if GRKERNSEC_CONFIG_AUTO
+	help
+	  By saying Y here the kernel will check indirect control transfers
+	  in order to detect and prevent attacks that try to hijack control
+	  flow by overwriting code pointers.
+
+	  If you have an amd64 processor that does not support SMEP then you
+	  must also enable a KERNEXEC code pointer instrumentation method
+	  (see PAX_KERNEXEC_PLUGIN).
+
+	  Note that binary modules cannot be instrumented by this approach.
+
+	  Note that the implementation requires a gcc with plugin support,
+	  i.e., gcc 4.5 or newer.  You may need to install the supporting
+	  headers explicitly in addition to the normal gcc package.
+
+endmenu
+
+endmenu
+
+source grsecurity/Kconfig
+
+endmenu
+
+endmenu
+
 source security/keys/Kconfig
 
 config SECURITY_DMESG_RESTRICT
@@ -104,7 +1163,7 @@ config INTEL_TXT
 config LSM_MMAP_MIN_ADDR
 	int "Low address space for LSM to protect from user allocation"
 	depends on SECURITY && SECURITY_SELINUX
-	default 32768 if ARM || (ARM64 && COMPAT)
+	default 32768 if ALPHA || ARM || (ARM64 && COMPAT) || PARISC || SPARC32
 	default 65536
 	help
 	  This is the portion of low virtual memory which should be protected
@@ -118,13 +1177,6 @@ config LSM_MMAP_MIN_ADDR
 	  this low address space will need the permission specific to the
 	  systems running LSM.
 
-config HAVE_HARDENED_USERCOPY_ALLOCATOR
-	bool
-	help
-	  The heap allocator implements __check_heap_object() for
-	  validating memory ranges against heap object sizes in
-	  support of CONFIG_HARDENED_USERCOPY.
-
 config HAVE_ARCH_HARDENED_USERCOPY
 	bool
 	help
@@ -134,23 +1186,14 @@ config HAVE_ARCH_HARDENED_USERCOPY
 	  copy_to_user() and copy_from_user().
 
 config HARDENED_USERCOPY
-	bool "Harden memory copies between kernel and userspace"
-	depends on HAVE_ARCH_HARDENED_USERCOPY
-	depends on HAVE_HARDENED_USERCOPY_ALLOCATOR
-	select BUG
-	help
-	  This option checks for obviously wrong memory regions when
-	  copying memory to/from the kernel (via copy_to_user() and
-	  copy_from_user() functions) by rejecting memory ranges that
-	  are larger than the specified heap object, span multiple
-	  separately allocates pages, are not on the process stack,
-	  or are part of the kernel text. This kills entire classes
-	  of heap overflow exploits and similar kernel memory exposures.
+	bool
+	select BUG if BROKEN_SECURITY
 
 config HARDENED_USERCOPY_PAGESPAN
 	bool "Refuse to copy allocations that span multiple pages"
 	depends on HARDENED_USERCOPY
 	depends on EXPERT
+	depends on BROKEN_SECURITY
 	help
 	  When a multi-page allocation is done without __GFP_COMP,
 	  hardened usercopy will reject attempts to copy it. There are,
@@ -205,4 +1248,3 @@ config DEFAULT_SECURITY
 	default "" if DEFAULT_SECURITY_DAC
 
 endmenu
-
diff --git a/security/apparmor/file.c b/security/apparmor/file.c
index 4d2af4b01..608971ac6 100644
--- a/security/apparmor/file.c
+++ b/security/apparmor/file.c
@@ -349,8 +349,8 @@ static inline bool xindex_is_subset(u32 link, u32 target)
 int aa_path_link(struct aa_profile *profile, struct dentry *old_dentry,
 		 const struct path *new_dir, struct dentry *new_dentry)
 {
-	struct path link = { new_dir->mnt, new_dentry };
-	struct path target = { new_dir->mnt, old_dentry };
+	struct path link = { .mnt = new_dir->mnt, .dentry = new_dentry };
+	struct path target = { .mnt = new_dir->mnt, .dentry = old_dentry };
 	struct path_cond cond = {
 		d_backing_inode(old_dentry)->i_uid,
 		d_backing_inode(old_dentry)->i_mode
diff --git a/security/apparmor/include/policy.h b/security/apparmor/include/policy.h
index 52275f040..4c8420245 100644
--- a/security/apparmor/include/policy.h
+++ b/security/apparmor/include/policy.h
@@ -134,7 +134,7 @@ struct aa_namespace {
 	struct aa_ns_acct acct;
 	struct aa_profile *unconfined;
 	struct list_head sub_ns;
-	atomic_t uniq_null;
+	atomic_unchecked_t uniq_null;
 	long uniq_id;
 
 	struct dentry *dents[AAFS_NS_SIZEOF];
diff --git a/security/apparmor/lsm.c b/security/apparmor/lsm.c
index 41b8cb115..411695cdc 100644
--- a/security/apparmor/lsm.c
+++ b/security/apparmor/lsm.c
@@ -176,7 +176,7 @@ static int common_perm_dir_dentry(int op, const struct path *dir,
 				  struct dentry *dentry, u32 mask,
 				  struct path_cond *cond)
 {
-	struct path path = { dir->mnt, dentry };
+	struct path path = { .mnt = dir->mnt, .dentry = dentry };
 
 	return common_perm(op, &path, mask, cond);
 }
@@ -306,8 +306,8 @@ static int apparmor_path_rename(const struct path *old_dir, struct dentry *old_d
 
 	profile = aa_current_profile();
 	if (!unconfined(profile)) {
-		struct path old_path = { old_dir->mnt, old_dentry };
-		struct path new_path = { new_dir->mnt, new_dentry };
+		struct path old_path = { .mnt = old_dir->mnt, .dentry = old_dentry };
+		struct path new_path = { .mnt = new_dir->mnt, .dentry = new_dentry };
 		struct path_cond cond = { d_backing_inode(old_dentry)->i_uid,
 					  d_backing_inode(old_dentry)->i_mode
 		};
@@ -656,11 +656,11 @@ static const struct kernel_param_ops param_ops_aalockpolicy = {
 	.get = param_get_aalockpolicy
 };
 
-static int param_set_audit(const char *val, struct kernel_param *kp);
-static int param_get_audit(char *buffer, struct kernel_param *kp);
+static int param_set_audit(const char *val, const struct kernel_param *kp);
+static int param_get_audit(char *buffer, const struct kernel_param *kp);
 
-static int param_set_mode(const char *val, struct kernel_param *kp);
-static int param_get_mode(char *buffer, struct kernel_param *kp);
+static int param_set_mode(const char *val, const struct kernel_param *kp);
+static int param_get_mode(char *buffer, const struct kernel_param *kp);
 
 /* Flag values, also controllable via /sys/module/apparmor/parameters
  * We define special types as we want to do additional mediation.
@@ -774,7 +774,7 @@ static int param_get_aauint(char *buffer, const struct kernel_param *kp)
 	return param_get_uint(buffer, kp);
 }
 
-static int param_get_audit(char *buffer, struct kernel_param *kp)
+static int param_get_audit(char *buffer, const struct kernel_param *kp)
 {
 	if (!policy_view_capable())
 		return -EPERM;
@@ -785,7 +785,7 @@ static int param_get_audit(char *buffer, struct kernel_param *kp)
 	return sprintf(buffer, "%s", audit_mode_names[aa_g_audit]);
 }
 
-static int param_set_audit(const char *val, struct kernel_param *kp)
+static int param_set_audit(const char *val, const struct kernel_param *kp)
 {
 	int i;
 	if (!policy_admin_capable())
@@ -807,7 +807,7 @@ static int param_set_audit(const char *val, struct kernel_param *kp)
 	return -EINVAL;
 }
 
-static int param_get_mode(char *buffer, struct kernel_param *kp)
+static int param_get_mode(char *buffer, const struct kernel_param *kp)
 {
 	if (!policy_admin_capable())
 		return -EPERM;
@@ -818,7 +818,7 @@ static int param_get_mode(char *buffer, struct kernel_param *kp)
 	return sprintf(buffer, "%s", aa_profile_mode_names[aa_g_profile_mode]);
 }
 
-static int param_set_mode(const char *val, struct kernel_param *kp)
+static int param_set_mode(const char *val, const struct kernel_param *kp)
 {
 	int i;
 	if (!policy_admin_capable())
diff --git a/security/apparmor/policy.c b/security/apparmor/policy.c
index 179e68d7d..48bd588f5 100644
--- a/security/apparmor/policy.c
+++ b/security/apparmor/policy.c
@@ -298,7 +298,7 @@ static struct aa_namespace *alloc_namespace(const char *prefix,
 	/* ns and ns->unconfined share ns->unconfined refcount */
 	ns->unconfined->ns = ns;
 
-	atomic_set(&ns->uniq_null, 0);
+	atomic_set_unchecked(&ns->uniq_null, 0);
 
 	return ns;
 
@@ -689,7 +689,7 @@ struct aa_profile *aa_new_null_profile(struct aa_profile *parent, int hat)
 {
 	struct aa_profile *profile = NULL;
 	char *name;
-	int uniq = atomic_inc_return(&parent->ns->uniq_null);
+	int uniq = atomic_inc_return_unchecked(&parent->ns->uniq_null);
 
 	/* freed below */
 	name = kmalloc(strlen(parent->base.hname) + 2 + 7 + 8, GFP_KERNEL);
diff --git a/security/commoncap.c b/security/commoncap.c
index 14540bd78..eaa4c5513 100644
--- a/security/commoncap.c
+++ b/security/commoncap.c
@@ -438,6 +438,32 @@ int get_vfs_caps_from_disk(const struct dentry *dentry, struct cpu_vfs_cap_data
 	return 0;
 }
 
+/* returns:
+	1 for suid privilege
+	2 for sgid privilege
+	3 for fscap privilege
+*/
+int is_privileged_binary(const struct dentry *dentry)
+{
+	struct cpu_vfs_cap_data capdata;
+	struct inode *inode = dentry->d_inode;
+
+	if (!inode || S_ISDIR(inode->i_mode))
+		return 0;
+
+	if (inode->i_mode & S_ISUID)
+		return 1;
+	if ((inode->i_mode & (S_ISGID | S_IXGRP)) == (S_ISGID | S_IXGRP))
+		return 2;
+
+	if (!get_vfs_caps_from_disk(dentry, &capdata)) {
+		if (!cap_isclear(capdata.inheritable) || !cap_isclear(capdata.permitted))
+			return 3;
+	}
+
+	return 0;
+}
+
 /*
  * Attempt to get the on-exec apply capability sets for an executable file from
  * its xattrs and, if present, apply them to the proposed credentials being
@@ -636,6 +662,9 @@ int cap_bprm_secureexec(struct linux_binprm *bprm)
 	const struct cred *cred = current_cred();
 	kuid_t root_uid = make_kuid(cred->user_ns, 0);
 
+	if (gr_acl_enable_at_secure())
+		return 1;
+
 	if (!uid_eq(cred->uid, root_uid)) {
 		if (bprm->cap_effective)
 			return 1;
diff --git a/security/integrity/ima/ima.h b/security/integrity/ima/ima.h
index db25f54a0..f303f4461 100644
--- a/security/integrity/ima/ima.h
+++ b/security/integrity/ima/ima.h
@@ -130,8 +130,8 @@ int ima_init_template(void);
 extern spinlock_t ima_queue_lock;
 
 struct ima_h_table {
-	atomic_long_t len;	/* number of stored measurements in the list */
-	atomic_long_t violations;
+	atomic_long_unchecked_t len;	/* number of stored measurements in the list */
+	atomic_long_unchecked_t violations;
 	struct hlist_head queue[IMA_MEASURE_HTABLE_SIZE];
 };
 extern struct ima_h_table ima_htable;
diff --git a/security/integrity/ima/ima_api.c b/security/integrity/ima/ima_api.c
index 9df26a2b7..2c6fc00ae 100644
--- a/security/integrity/ima/ima_api.c
+++ b/security/integrity/ima/ima_api.c
@@ -138,7 +138,7 @@ void ima_add_violation(struct file *file, const unsigned char *filename,
 	int result;
 
 	/* can overflow, only indicator */
-	atomic_long_inc(&ima_htable.violations);
+	atomic_long_inc_unchecked(&ima_htable.violations);
 
 	result = ima_alloc_init_template(&event_data, &entry);
 	if (result < 0) {
diff --git a/security/integrity/ima/ima_fs.c b/security/integrity/ima/ima_fs.c
index c07a3844e..52ad9bcd9 100644
--- a/security/integrity/ima/ima_fs.c
+++ b/security/integrity/ima/ima_fs.c
@@ -31,12 +31,12 @@ static DEFINE_MUTEX(ima_write_mutex);
 static int valid_policy = 1;
 #define TMPBUFLEN 12
 static ssize_t ima_show_htable_value(char __user *buf, size_t count,
-				     loff_t *ppos, atomic_long_t *val)
+				     loff_t *ppos, atomic_long_unchecked_t *val)
 {
 	char tmpbuf[TMPBUFLEN];
 	ssize_t len;
 
-	len = scnprintf(tmpbuf, TMPBUFLEN, "%li\n", atomic_long_read(val));
+	len = scnprintf(tmpbuf, TMPBUFLEN, "%li\n", atomic_long_read_unchecked(val));
 	return simple_read_from_buffer(buf, count, ppos, tmpbuf, len);
 }
 
diff --git a/security/integrity/ima/ima_queue.c b/security/integrity/ima/ima_queue.c
index 32f6ac0f9..827500529 100644
--- a/security/integrity/ima/ima_queue.c
+++ b/security/integrity/ima/ima_queue.c
@@ -84,7 +84,7 @@ static int ima_add_digest_entry(struct ima_template_entry *entry)
 	INIT_LIST_HEAD(&qe->later);
 	list_add_tail_rcu(&qe->later, &ima_measurements);
 
-	atomic_long_inc(&ima_htable.len);
+	atomic_long_inc_unchecked(&ima_htable.len);
 	key = ima_hash_key(entry->digest);
 	hlist_add_head_rcu(&qe->hnext, &ima_htable.queue[key]);
 	return 0;
diff --git a/security/integrity/integrity.h b/security/integrity/integrity.h
index 24520b4ef..b89448a69 100644
--- a/security/integrity/integrity.h
+++ b/security/integrity/integrity.h
@@ -177,7 +177,7 @@ static inline void evm_load_x509(void)
 
 #ifdef CONFIG_INTEGRITY_AUDIT
 /* declarations */
-void integrity_audit_msg(int audit_msgno, struct inode *inode,
+void __nocapture(4) integrity_audit_msg(int audit_msgno, struct inode *inode,
 			 const unsigned char *fname, const char *op,
 			 const char *cause, int result, int info);
 #else
diff --git a/security/keys/internal.h b/security/keys/internal.h
index a705a7d92..898c675f1 100644
--- a/security/keys/internal.h
+++ b/security/keys/internal.h
@@ -91,12 +91,16 @@ extern void key_type_put(struct key_type *ktype);
 
 extern int __key_link_begin(struct key *keyring,
 			    const struct keyring_index_key *index_key,
-			    struct assoc_array_edit **_edit);
+			    struct assoc_array_edit **_edit)
+			    __acquires(&keyring->sem)
+			    __acquires(&keyring_serialise_link_sem);
 extern int __key_link_check_live_key(struct key *keyring, struct key *key);
 extern void __key_link(struct key *key, struct assoc_array_edit **_edit);
 extern void __key_link_end(struct key *keyring,
 			   const struct keyring_index_key *index_key,
-			   struct assoc_array_edit *edit);
+			   struct assoc_array_edit *edit)
+			   __releases(&keyring->sem)
+			   __releases(&keyring_serialise_link_sem);
 
 extern key_ref_t find_key_to_update(key_ref_t keyring_ref,
 				    const struct keyring_index_key *index_key);
@@ -192,7 +196,7 @@ struct request_key_auth {
 	void			*callout_info;
 	size_t			callout_len;
 	pid_t			pid;
-};
+} __randomize_layout;
 
 extern struct key_type key_type_request_key_auth;
 extern struct key *request_key_auth_new(struct key *target,
diff --git a/security/keys/key.c b/security/keys/key.c
index 346fbf201..84458b160 100644
--- a/security/keys/key.c
+++ b/security/keys/key.c
@@ -287,7 +287,7 @@ struct key *key_alloc(struct key_type *type, const char *desc,
 
 	atomic_set(&key->usage, 1);
 	init_rwsem(&key->sem);
-	lockdep_set_class(&key->sem, &type->lock_class);
+	lockdep_set_class(&key->sem, (struct lock_class_key *)&type->lock_class);
 	key->index_key.type = type;
 	key->user = user;
 	key->quotalen = quotalen;
@@ -1101,7 +1101,9 @@ int register_key_type(struct key_type *ktype)
 	struct key_type *p;
 	int ret;
 
-	memset(&ktype->lock_class, 0, sizeof(ktype->lock_class));
+	pax_open_kernel();
+	memset((void *)&ktype->lock_class, 0, sizeof(ktype->lock_class));
+	pax_close_kernel();
 
 	ret = -EEXIST;
 	down_write(&key_types_sem);
@@ -1113,7 +1115,7 @@ int register_key_type(struct key_type *ktype)
 	}
 
 	/* store the type */
-	list_add(&ktype->link, &key_types_list);
+	pax_list_add((struct list_head *)&ktype->link, &key_types_list);
 
 	pr_notice("Key type %s registered\n", ktype->name);
 	ret = 0;
@@ -1135,7 +1137,7 @@ EXPORT_SYMBOL(register_key_type);
 void unregister_key_type(struct key_type *ktype)
 {
 	down_write(&key_types_sem);
-	list_del_init(&ktype->link);
+	pax_list_del_init((struct list_head *)&ktype->link);
 	downgrade_write(&key_types_sem);
 	key_gc_keytype(ktype);
 	pr_notice("Key type %s unregistered\n", ktype->name);
@@ -1153,10 +1155,10 @@ void __init key_init(void)
 			0, SLAB_HWCACHE_ALIGN|SLAB_PANIC, NULL);
 
 	/* add the special key types */
-	list_add_tail(&key_type_keyring.link, &key_types_list);
-	list_add_tail(&key_type_dead.link, &key_types_list);
-	list_add_tail(&key_type_user.link, &key_types_list);
-	list_add_tail(&key_type_logon.link, &key_types_list);
+	pax_list_add_tail((struct list_head *)&key_type_keyring.link, &key_types_list);
+	pax_list_add_tail((struct list_head *)&key_type_dead.link, &key_types_list);
+	pax_list_add_tail((struct list_head *)&key_type_user.link, &key_types_list);
+	pax_list_add_tail((struct list_head *)&key_type_logon.link, &key_types_list);
 
 	/* record the root user tracking */
 	rb_link_node(&root_key_user.node,
diff --git a/security/keys/keyring.c b/security/keys/keyring.c
index c91e4e0ce..d3193f626 100644
--- a/security/keys/keyring.c
+++ b/security/keys/keyring.c
@@ -1095,8 +1095,6 @@ static int keyring_detect_cycle(struct key *A, struct key *B)
 int __key_link_begin(struct key *keyring,
 		     const struct keyring_index_key *index_key,
 		     struct assoc_array_edit **_edit)
-	__acquires(&keyring->sem)
-	__acquires(&keyring_serialise_link_sem)
 {
 	struct assoc_array_edit *edit;
 	int ret;
@@ -1196,8 +1194,6 @@ void __key_link(struct key *key, struct assoc_array_edit **_edit)
 void __key_link_end(struct key *keyring,
 		    const struct keyring_index_key *index_key,
 		    struct assoc_array_edit *edit)
-	__releases(&keyring->sem)
-	__releases(&keyring_serialise_link_sem)
 {
 	BUG_ON(index_key->type == NULL);
 	kenter("%d,%s,", keyring->serial, index_key->type->name);
diff --git a/security/min_addr.c b/security/min_addr.c
index f728728f1..6457a0cfa 100644
--- a/security/min_addr.c
+++ b/security/min_addr.c
@@ -14,6 +14,7 @@ unsigned long dac_mmap_min_addr = CONFIG_DEFAULT_MMAP_MIN_ADDR;
  */
 static void update_mmap_min_addr(void)
 {
+#ifndef SPARC
 #ifdef CONFIG_LSM_MMAP_MIN_ADDR
 	if (dac_mmap_min_addr > CONFIG_LSM_MMAP_MIN_ADDR)
 		mmap_min_addr = dac_mmap_min_addr;
@@ -22,6 +23,7 @@ static void update_mmap_min_addr(void)
 #else
 	mmap_min_addr = dac_mmap_min_addr;
 #endif
+#endif
 }
 
 /*
diff --git a/security/selinux/avc.c b/security/selinux/avc.c
index e60c79de1..41fb721c7 100644
--- a/security/selinux/avc.c
+++ b/security/selinux/avc.c
@@ -71,7 +71,7 @@ struct avc_xperms_node {
 struct avc_cache {
 	struct hlist_head	slots[AVC_CACHE_SLOTS]; /* head for avc_node->list */
 	spinlock_t		slots_lock[AVC_CACHE_SLOTS]; /* lock for writes */
-	atomic_t		lru_hint;	/* LRU hint for reclaim scan */
+	atomic_unchecked_t	lru_hint;	/* LRU hint for reclaim scan */
 	atomic_t		active_nodes;
 	u32			latest_notif;	/* latest revocation notification */
 };
@@ -183,7 +183,7 @@ void __init avc_init(void)
 		spin_lock_init(&avc_cache.slots_lock[i]);
 	}
 	atomic_set(&avc_cache.active_nodes, 0);
-	atomic_set(&avc_cache.lru_hint, 0);
+	atomic_set_unchecked(&avc_cache.lru_hint, 0);
 
 	avc_node_cachep = kmem_cache_create("avc_node", sizeof(struct avc_node),
 					0, SLAB_PANIC, NULL);
@@ -521,7 +521,7 @@ static inline int avc_reclaim_node(void)
 	spinlock_t *lock;
 
 	for (try = 0, ecx = 0; try < AVC_CACHE_SLOTS; try++) {
-		hvalue = atomic_inc_return(&avc_cache.lru_hint) & (AVC_CACHE_SLOTS - 1);
+		hvalue = atomic_inc_return_unchecked(&avc_cache.lru_hint) & (AVC_CACHE_SLOTS - 1);
 		head = &avc_cache.slots[hvalue];
 		lock = &avc_cache.slots_lock[hvalue];
 
diff --git a/security/selinux/include/xfrm.h b/security/selinux/include/xfrm.h
index 1450f85b9..a91e0bc75 100644
--- a/security/selinux/include/xfrm.h
+++ b/security/selinux/include/xfrm.h
@@ -48,7 +48,7 @@ static inline void selinux_xfrm_notify_policyload(void)
 
 	rtnl_lock();
 	for_each_net(net) {
-		atomic_inc(&net->xfrm.flow_cache_genid);
+		atomic_inc_unchecked(&net->xfrm.flow_cache_genid);
 		rt_genid_bump_all(net);
 	}
 	rtnl_unlock();
diff --git a/security/tomoyo/file.c b/security/tomoyo/file.c
index 7041a5800..223f21ffa 100644
--- a/security/tomoyo/file.c
+++ b/security/tomoyo/file.c
@@ -692,7 +692,7 @@ int tomoyo_path_number_perm(const u8 type, const struct path *path,
 {
 	struct tomoyo_request_info r;
 	struct tomoyo_obj_info obj = {
-		.path1 = *path,
+		.path1 = { .mnt = path->mnt, .dentry = path->dentry },
 	};
 	int error = -ENOMEM;
 	struct tomoyo_path_info buf;
@@ -740,7 +740,7 @@ int tomoyo_check_open_permission(struct tomoyo_domain_info *domain,
 	struct tomoyo_path_info buf;
 	struct tomoyo_request_info r;
 	struct tomoyo_obj_info obj = {
-		.path1 = *path,
+		.path1 = { .mnt = path->mnt, .dentry = path->dentry },
 	};
 	int idx;
 
@@ -786,7 +786,7 @@ int tomoyo_path_perm(const u8 operation, const struct path *path, const char *ta
 {
 	struct tomoyo_request_info r;
 	struct tomoyo_obj_info obj = {
-		.path1 = *path,
+		.path1 = { .mnt = path->mnt, .dentry = path->dentry },
 	};
 	int error;
 	struct tomoyo_path_info buf;
@@ -843,7 +843,7 @@ int tomoyo_mkdev_perm(const u8 operation, const struct path *path,
 {
 	struct tomoyo_request_info r;
 	struct tomoyo_obj_info obj = {
-		.path1 = *path,
+		.path1 = { .mnt = path->mnt, .dentry = path->dentry },
 	};
 	int error = -ENOMEM;
 	struct tomoyo_path_info buf;
@@ -890,8 +890,8 @@ int tomoyo_path2_perm(const u8 operation, const struct path *path1,
 	struct tomoyo_path_info buf2;
 	struct tomoyo_request_info r;
 	struct tomoyo_obj_info obj = {
-		.path1 = *path1,
-		.path2 = *path2,
+		.path1 = { .mnt = path1->mnt, .dentry = path1->dentry },
+		.path2 = { .mnt = path2->mnt, .dentry = path2->dentry }
 	};
 	int idx;
 
diff --git a/security/tomoyo/mount.c b/security/tomoyo/mount.c
index 14b53fb2a..8829296de 100644
--- a/security/tomoyo/mount.c
+++ b/security/tomoyo/mount.c
@@ -118,6 +118,10 @@ static int tomoyo_mount_acl(struct tomoyo_request_info *r,
 		   type == tomoyo_mounts[TOMOYO_MOUNT_MOVE]) {
 		need_dev = -1; /* dev_name is a directory */
 	} else {
+		if (!capable(CAP_SYS_ADMIN)) {
+			error = -EPERM;
+			goto out;
+		}
 		fstype = get_fs_type(type);
 		if (!fstype) {
 			error = -ENODEV;
diff --git a/security/tomoyo/tomoyo.c b/security/tomoyo/tomoyo.c
index 75c998700..b9569d497 100644
--- a/security/tomoyo/tomoyo.c
+++ b/security/tomoyo/tomoyo.c
@@ -165,7 +165,7 @@ static int tomoyo_path_truncate(const struct path *path)
  */
 static int tomoyo_path_unlink(const struct path *parent, struct dentry *dentry)
 {
-	struct path path = { parent->mnt, dentry };
+	struct path path = { .mnt = parent->mnt, .dentry = dentry };
 	return tomoyo_path_perm(TOMOYO_TYPE_UNLINK, &path, NULL);
 }
 
@@ -181,7 +181,7 @@ static int tomoyo_path_unlink(const struct path *parent, struct dentry *dentry)
 static int tomoyo_path_mkdir(const struct path *parent, struct dentry *dentry,
 			     umode_t mode)
 {
-	struct path path = { parent->mnt, dentry };
+	struct path path = { .mnt = parent->mnt, .dentry = dentry };
 	return tomoyo_path_number_perm(TOMOYO_TYPE_MKDIR, &path,
 				       mode & S_IALLUGO);
 }
@@ -196,7 +196,7 @@ static int tomoyo_path_mkdir(const struct path *parent, struct dentry *dentry,
  */
 static int tomoyo_path_rmdir(const struct path *parent, struct dentry *dentry)
 {
-	struct path path = { parent->mnt, dentry };
+	struct path path = { .mnt = parent->mnt, .dentry = dentry };
 	return tomoyo_path_perm(TOMOYO_TYPE_RMDIR, &path, NULL);
 }
 
@@ -212,7 +212,7 @@ static int tomoyo_path_rmdir(const struct path *parent, struct dentry *dentry)
 static int tomoyo_path_symlink(const struct path *parent, struct dentry *dentry,
 			       const char *old_name)
 {
-	struct path path = { parent->mnt, dentry };
+	struct path path = { .mnt = parent->mnt, .dentry = dentry };
 	return tomoyo_path_perm(TOMOYO_TYPE_SYMLINK, &path, old_name);
 }
 
@@ -229,7 +229,7 @@ static int tomoyo_path_symlink(const struct path *parent, struct dentry *dentry,
 static int tomoyo_path_mknod(const struct path *parent, struct dentry *dentry,
 			     umode_t mode, unsigned int dev)
 {
-	struct path path = { parent->mnt, dentry };
+	struct path path = { .mnt = parent->mnt, .dentry = dentry };
 	int type = TOMOYO_TYPE_CREATE;
 	const unsigned int perm = mode & S_IALLUGO;
 
@@ -268,8 +268,8 @@ static int tomoyo_path_mknod(const struct path *parent, struct dentry *dentry,
 static int tomoyo_path_link(struct dentry *old_dentry, const struct path *new_dir,
 			    struct dentry *new_dentry)
 {
-	struct path path1 = { new_dir->mnt, old_dentry };
-	struct path path2 = { new_dir->mnt, new_dentry };
+	struct path path1 = { .mnt = new_dir->mnt, .dentry = old_dentry };
+	struct path path2 = { .mnt = new_dir->mnt, .dentry = new_dentry };
 	return tomoyo_path2_perm(TOMOYO_TYPE_LINK, &path1, &path2);
 }
 
@@ -288,8 +288,8 @@ static int tomoyo_path_rename(const struct path *old_parent,
 			      const struct path *new_parent,
 			      struct dentry *new_dentry)
 {
-	struct path path1 = { old_parent->mnt, old_dentry };
-	struct path path2 = { new_parent->mnt, new_dentry };
+	struct path path1 = { .mnt = old_parent->mnt, .dentry = old_dentry };
+	struct path path2 = { .mnt = new_parent->mnt, .dentry = new_dentry };
 	return tomoyo_path2_perm(TOMOYO_TYPE_RENAME, &path1, &path2);
 }
 
@@ -417,7 +417,7 @@ static int tomoyo_sb_mount(const char *dev_name, const struct path *path,
  */
 static int tomoyo_sb_umount(struct vfsmount *mnt, int flags)
 {
-	struct path path = { mnt, mnt->mnt_root };
+	struct path path = { .mnt = mnt, .dentry = mnt->mnt_root };
 	return tomoyo_path_perm(TOMOYO_TYPE_UMOUNT, &path, NULL);
 }
 
diff --git a/security/yama/Kconfig b/security/yama/Kconfig
index 90c605eea..bf3a29ae1 100644
--- a/security/yama/Kconfig
+++ b/security/yama/Kconfig
@@ -1,6 +1,6 @@
 config SECURITY_YAMA
 	bool "Yama support"
-	depends on SECURITY
+	depends on SECURITY && !GRKERNSEC
 	default n
 	help
 	  This selects Yama, which extends DAC support with additional
diff --git a/security/yama/yama_lsm.c b/security/yama/yama_lsm.c
index 0309f2111..0c9bdfb2a 100644
--- a/security/yama/yama_lsm.c
+++ b/security/yama/yama_lsm.c
@@ -425,7 +425,7 @@ static struct security_hook_list yama_hooks[] = {
 static int yama_dointvec_minmax(struct ctl_table *table, int write,
 				void __user *buffer, size_t *lenp, loff_t *ppos)
 {
-	struct ctl_table table_copy;
+	ctl_table_no_const table_copy;
 
 	if (write && !capable(CAP_SYS_PTRACE))
 		return -EPERM;
diff --git a/sound/aoa/codecs/onyx.c b/sound/aoa/codecs/onyx.c
index a04edff8b..6811b9196 100644
--- a/sound/aoa/codecs/onyx.c
+++ b/sound/aoa/codecs/onyx.c
@@ -54,7 +54,7 @@ struct onyx {
 				spdif_locked:1,
 				analog_locked:1,
 				original_mute:2;
-	int			open_count;
+	local_t			open_count;
 	struct codec_info	*codec_info;
 
 	/* mutex serializes concurrent access to the device
@@ -747,7 +747,7 @@ static int onyx_open(struct codec_info_item *cii,
 	struct onyx *onyx = cii->codec_data;
 
 	mutex_lock(&onyx->mutex);
-	onyx->open_count++;
+	local_inc(&onyx->open_count);
 	mutex_unlock(&onyx->mutex);
 
 	return 0;
@@ -759,8 +759,7 @@ static int onyx_close(struct codec_info_item *cii,
 	struct onyx *onyx = cii->codec_data;
 
 	mutex_lock(&onyx->mutex);
-	onyx->open_count--;
-	if (!onyx->open_count)
+	if (local_dec_and_test(&onyx->open_count))
 		onyx->spdif_locked = onyx->analog_locked = 0;
 	mutex_unlock(&onyx->mutex);
 
diff --git a/sound/aoa/codecs/onyx.h b/sound/aoa/codecs/onyx.h
index ffd20254f..df062c972 100644
--- a/sound/aoa/codecs/onyx.h
+++ b/sound/aoa/codecs/onyx.h
@@ -11,6 +11,7 @@
 #include <linux/i2c.h>
 #include <asm/pmac_low_i2c.h>
 #include <asm/prom.h>
+#include <asm/local.h>
 
 /* PCM3052 register definitions */
 
diff --git a/sound/core/oss/pcm_oss.c b/sound/core/oss/pcm_oss.c
index ebc9fdfe6..61f491e4b 100644
--- a/sound/core/oss/pcm_oss.c
+++ b/sound/core/oss/pcm_oss.c
@@ -1193,10 +1193,10 @@ snd_pcm_sframes_t snd_pcm_oss_write3(struct snd_pcm_substream *substream, const
 		if (in_kernel) {
 			mm_segment_t fs;
 			fs = snd_enter_user();
-			ret = snd_pcm_lib_write(substream, (void __force __user *)ptr, frames);
+			ret = snd_pcm_lib_write(substream, (void __force_user *)ptr, frames);
 			snd_leave_user(fs);
 		} else {
-			ret = snd_pcm_lib_write(substream, (void __force __user *)ptr, frames);
+			ret = snd_pcm_lib_write(substream, (void __force_user *)ptr, frames);
 		}
 		if (ret != -EPIPE && ret != -ESTRPIPE)
 			break;
@@ -1236,10 +1236,10 @@ snd_pcm_sframes_t snd_pcm_oss_read3(struct snd_pcm_substream *substream, char *p
 		if (in_kernel) {
 			mm_segment_t fs;
 			fs = snd_enter_user();
-			ret = snd_pcm_lib_read(substream, (void __force __user *)ptr, frames);
+			ret = snd_pcm_lib_read(substream, (void __force_user *)ptr, frames);
 			snd_leave_user(fs);
 		} else {
-			ret = snd_pcm_lib_read(substream, (void __force __user *)ptr, frames);
+			ret = snd_pcm_lib_read(substream, (void __force_user *)ptr, frames);
 		}
 		if (ret == -EPIPE) {
 			if (runtime->status->state == SNDRV_PCM_STATE_DRAINING) {
@@ -1335,7 +1335,7 @@ static ssize_t snd_pcm_oss_write2(struct snd_pcm_substream *substream, const cha
 		struct snd_pcm_plugin_channel *channels;
 		size_t oss_frame_bytes = (runtime->oss.plugin_first->src_width * runtime->oss.plugin_first->src_format.channels) / 8;
 		if (!in_kernel) {
-			if (copy_from_user(runtime->oss.buffer, (const char __force __user *)buf, bytes))
+			if (copy_from_user(runtime->oss.buffer, (const char __force_user *)buf, bytes))
 				return -EFAULT;
 			buf = runtime->oss.buffer;
 		}
@@ -1405,7 +1405,7 @@ static ssize_t snd_pcm_oss_write1(struct snd_pcm_substream *substream, const cha
 			}
 		} else {
 			tmp = snd_pcm_oss_write2(substream,
-						 (const char __force *)buf,
+						 (const char __force_kernel *)buf,
 						 runtime->oss.period_bytes, 0);
 			if (tmp <= 0)
 				goto err;
@@ -1431,7 +1431,7 @@ static ssize_t snd_pcm_oss_read2(struct snd_pcm_substream *substream, char *buf,
 	struct snd_pcm_runtime *runtime = substream->runtime;
 	snd_pcm_sframes_t frames, frames1;
 #ifdef CONFIG_SND_PCM_OSS_PLUGINS
-	char __user *final_dst = (char __force __user *)buf;
+	char __user *final_dst = (char __force_user *)buf;
 	if (runtime->oss.plugin_first) {
 		struct snd_pcm_plugin_channel *channels;
 		size_t oss_frame_bytes = (runtime->oss.plugin_last->dst_width * runtime->oss.plugin_last->dst_format.channels) / 8;
@@ -1493,7 +1493,7 @@ static ssize_t snd_pcm_oss_read1(struct snd_pcm_substream *substream, char __use
 			xfer += tmp;
 			runtime->oss.buffer_used -= tmp;
 		} else {
-			tmp = snd_pcm_oss_read2(substream, (char __force *)buf,
+			tmp = snd_pcm_oss_read2(substream, (char __force_kernel *)buf,
 						runtime->oss.period_bytes, 0);
 			if (tmp <= 0)
 				goto err;
@@ -1662,7 +1662,7 @@ static int snd_pcm_oss_sync(struct snd_pcm_oss_file *pcm_oss_file)
 								   size1);
 					size1 /= runtime->channels; /* frames */
 					fs = snd_enter_user();
-					snd_pcm_lib_write(substream, (void __force __user *)runtime->oss.buffer, size1);
+					snd_pcm_lib_write(substream, (void __force_user *)runtime->oss.buffer, size1);
 					snd_leave_user(fs);
 				}
 			} else if (runtime->access == SNDRV_PCM_ACCESS_RW_NONINTERLEAVED) {
diff --git a/sound/core/pcm_compat.c b/sound/core/pcm_compat.c
index 1f64ab0c2..26a72337f 100644
--- a/sound/core/pcm_compat.c
+++ b/sound/core/pcm_compat.c
@@ -31,7 +31,7 @@ static int snd_pcm_ioctl_delay_compat(struct snd_pcm_substream *substream,
 	int err;
 
 	fs = snd_enter_user();
-	err = snd_pcm_delay(substream, &delay);
+	err = snd_pcm_delay(substream, (snd_pcm_sframes_t __force_user *)&delay);
 	snd_leave_user(fs);
 	if (err < 0)
 		return err;
diff --git a/sound/core/pcm_lib.c b/sound/core/pcm_lib.c
index bb1261591..b5e4ff93a 100644
--- a/sound/core/pcm_lib.c
+++ b/sound/core/pcm_lib.c
@@ -1867,8 +1867,9 @@ EXPORT_SYMBOL(snd_pcm_lib_ioctl);
  * Even if more than one periods have elapsed since the last call, you
  * have to call this only once.
  */
-void snd_pcm_period_elapsed(struct snd_pcm_substream *substream)
+void snd_pcm_period_elapsed(void *_substream)
 {
+	struct snd_pcm_substream *substream = _substream;
 	struct snd_pcm_runtime *runtime;
 	unsigned long flags;
 
diff --git a/sound/core/pcm_native.c b/sound/core/pcm_native.c
index c61fd50f7..308134029 100644
--- a/sound/core/pcm_native.c
+++ b/sound/core/pcm_native.c
@@ -3014,11 +3014,11 @@ int snd_pcm_kernel_ioctl(struct snd_pcm_substream *substream,
 	switch (substream->stream) {
 	case SNDRV_PCM_STREAM_PLAYBACK:
 		result = snd_pcm_playback_ioctl1(NULL, substream, cmd,
-						 (void __user *)arg);
+						 (void __force_user *)arg);
 		break;
 	case SNDRV_PCM_STREAM_CAPTURE:
 		result = snd_pcm_capture_ioctl1(NULL, substream, cmd,
-						(void __user *)arg);
+						(void __force_user *)arg);
 		break;
 	default:
 		result = -EINVAL;
diff --git a/sound/core/rawmidi.c b/sound/core/rawmidi.c
index b450a2758..28c823892 100644
--- a/sound/core/rawmidi.c
+++ b/sound/core/rawmidi.c
@@ -871,9 +871,10 @@ static int snd_rawmidi_control_ioctl(struct snd_card *card,
  *
  * Return: The size of read data, or a negative error code on failure.
  */
-int snd_rawmidi_receive(struct snd_rawmidi_substream *substream,
-			const unsigned char *buffer, int count)
+int snd_rawmidi_receive(void *_substream, const void *_buffer, int count)
 {
+	struct snd_rawmidi_substream *substream = _substream;
+	const unsigned char *buffer = _buffer;
 	unsigned long flags;
 	int result = 0, count1;
 	struct snd_rawmidi_runtime *runtime = substream->runtime;
diff --git a/sound/core/seq/oss/seq_oss_synth.c b/sound/core/seq/oss/seq_oss_synth.c
index cd0e0ebbf..89543da80 100644
--- a/sound/core/seq/oss/seq_oss_synth.c
+++ b/sound/core/seq/oss/seq_oss_synth.c
@@ -653,8 +653,8 @@ snd_seq_oss_synth_info_read(struct snd_info_buffer *buf)
 			    rec->synth_type, rec->synth_subtype,
 			    rec->nr_voices);
 		snd_iprintf(buf, "  capabilities : ioctl %s / load_patch %s\n",
-			    enabled_str((long)rec->oper.ioctl),
-			    enabled_str((long)rec->oper.load_patch));
+			    enabled_str(!!rec->oper.ioctl),
+			    enabled_str(!!rec->oper.load_patch));
 		snd_use_lock_free(&rec->use_lock);
 	}
 }
diff --git a/sound/core/seq/seq_clientmgr.c b/sound/core/seq/seq_clientmgr.c
index d6d9419d8..49b620a50 100644
--- a/sound/core/seq/seq_clientmgr.c
+++ b/sound/core/seq/seq_clientmgr.c
@@ -418,7 +418,7 @@ static ssize_t snd_seq_read(struct file *file, char __user *buf, size_t count,
 	if (!client->accept_input || (fifo = client->data.user.fifo) == NULL)
 		return -ENXIO;
 
-	if (atomic_read(&fifo->overflow) > 0) {
+	if (atomic_read_unchecked(&fifo->overflow) > 0) {
 		/* buffer overflow is detected */
 		snd_seq_fifo_clear(fifo);
 		/* return error code */
@@ -448,7 +448,7 @@ static ssize_t snd_seq_read(struct file *file, char __user *buf, size_t count,
 			count -= sizeof(struct snd_seq_event);
 			buf += sizeof(struct snd_seq_event);
 			err = snd_seq_expand_var_event(&cell->event, count,
-						       (char __force *)buf, 0,
+						       (char __force_kernel *)buf, 0,
 						       sizeof(struct snd_seq_event));
 			if (err < 0)
 				break;
@@ -1064,13 +1064,13 @@ static ssize_t snd_seq_write(struct file *file, const char __user *buf,
 			}
 			/* set user space pointer */
 			event.data.ext.len = extlen | SNDRV_SEQ_EXT_USRPTR;
-			event.data.ext.ptr = (char __force *)buf
+			event.data.ext.ptr = (char __force_kernel *)buf
 						+ sizeof(struct snd_seq_event);
 			len += extlen; /* increment data length */
 		} else {
 #ifdef CONFIG_COMPAT
 			if (client->convert32 && snd_seq_ev_is_varusr(&event)) {
-				void *ptr = (void __force *)compat_ptr(event.data.raw32.d[1]);
+				void *ptr = (void __force_kernel *)compat_ptr(event.data.raw32.d[1]);
 				event.data.ext.ptr = ptr;
 			}
 #endif
@@ -2437,7 +2437,7 @@ int snd_seq_kernel_client_ctl(int clientid, unsigned int cmd, void *arg)
 	if (client == NULL)
 		return -ENXIO;
 	fs = snd_enter_user();
-	result = snd_seq_do_ioctl(client, cmd, (void __force __user *)arg);
+	result = snd_seq_do_ioctl(client, cmd, (void __force_user *)arg);
 	snd_leave_user(fs);
 	return result;
 }
diff --git a/sound/core/seq/seq_compat.c b/sound/core/seq/seq_compat.c
index 65175902a..9905cee52 100644
--- a/sound/core/seq/seq_compat.c
+++ b/sound/core/seq/seq_compat.c
@@ -60,7 +60,7 @@ static int snd_seq_call_port_info_ioctl(struct snd_seq_client *client, unsigned
 	data->kernel = NULL;
 
 	fs = snd_enter_user();
-	err = snd_seq_do_ioctl(client, cmd, data);
+	err = snd_seq_do_ioctl(client, cmd, (void __force_user *)data);
 	snd_leave_user(fs);
 	if (err < 0)
 		goto error;
diff --git a/sound/core/seq/seq_fifo.c b/sound/core/seq/seq_fifo.c
index 1d5acbe0c..5f55223b6 100644
--- a/sound/core/seq/seq_fifo.c
+++ b/sound/core/seq/seq_fifo.c
@@ -50,7 +50,7 @@ struct snd_seq_fifo *snd_seq_fifo_new(int poolsize)
 	spin_lock_init(&f->lock);
 	snd_use_lock_init(&f->use_lock);
 	init_waitqueue_head(&f->input_sleep);
-	atomic_set(&f->overflow, 0);
+	atomic_set_unchecked(&f->overflow, 0);
 
 	f->head = NULL;
 	f->tail = NULL;
@@ -96,7 +96,7 @@ void snd_seq_fifo_clear(struct snd_seq_fifo *f)
 	unsigned long flags;
 
 	/* clear overflow flag */
-	atomic_set(&f->overflow, 0);
+	atomic_set_unchecked(&f->overflow, 0);
 
 	snd_use_lock_sync(&f->use_lock);
 	spin_lock_irqsave(&f->lock, flags);
@@ -123,7 +123,7 @@ int snd_seq_fifo_event_in(struct snd_seq_fifo *f,
 	err = snd_seq_event_dup(f->pool, event, &cell, 1, NULL); /* always non-blocking */
 	if (err < 0) {
 		if ((err == -ENOMEM) || (err == -EAGAIN))
-			atomic_inc(&f->overflow);
+			atomic_inc_unchecked(&f->overflow);
 		snd_use_lock_free(&f->use_lock);
 		return err;
 	}
diff --git a/sound/core/seq/seq_fifo.h b/sound/core/seq/seq_fifo.h
index 062c446e7..a4b6f4cc7 100644
--- a/sound/core/seq/seq_fifo.h
+++ b/sound/core/seq/seq_fifo.h
@@ -35,7 +35,7 @@ struct snd_seq_fifo {
 	spinlock_t lock;
 	snd_use_lock_t use_lock;
 	wait_queue_head_t input_sleep;
-	atomic_t overflow;
+	atomic_unchecked_t overflow;
 
 };
 
diff --git a/sound/core/seq/seq_memory.c b/sound/core/seq/seq_memory.c
index c850345c4..ec0a8532e 100644
--- a/sound/core/seq/seq_memory.c
+++ b/sound/core/seq/seq_memory.c
@@ -87,7 +87,7 @@ int snd_seq_dump_var_event(const struct snd_seq_event *event,
 
 	if (event->data.ext.len & SNDRV_SEQ_EXT_USRPTR) {
 		char buf[32];
-		char __user *curptr = (char __force __user *)event->data.ext.ptr;
+		char __user *curptr = (char __force_user *)event->data.ext.ptr;
 		while (len > 0) {
 			int size = sizeof(buf);
 			if (len < size)
@@ -126,15 +126,19 @@ EXPORT_SYMBOL(snd_seq_dump_var_event);
  * expand the variable length event to linear buffer space.
  */
 
-static int seq_copy_in_kernel(char **bufptr, const void *src, int size)
+static int seq_copy_in_kernel(void *_bufptr, const void *src, int size)
 {
+	char **bufptr = (char **)_bufptr;
+
 	memcpy(*bufptr, src, size);
 	*bufptr += size;
 	return 0;
 }
 
-static int seq_copy_in_user(char __user **bufptr, const void *src, int size)
+static int seq_copy_in_user(void *_bufptr, const void *src, int size)
 {
+	char __user **bufptr = (char __user **)_bufptr;
+
 	if (copy_to_user(*bufptr, src, size))
 		return -EFAULT;
 	*bufptr += size;
@@ -158,13 +162,13 @@ int snd_seq_expand_var_event(const struct snd_seq_event *event, int count, char
 	if (event->data.ext.len & SNDRV_SEQ_EXT_USRPTR) {
 		if (! in_kernel)
 			return -EINVAL;
-		if (copy_from_user(buf, (void __force __user *)event->data.ext.ptr, len))
+		if (copy_from_user(buf, (void __force_user *)event->data.ext.ptr, len))
 			return -EFAULT;
 		return newlen;
 	}
 	err = snd_seq_dump_var_event(event,
-				     in_kernel ? (snd_seq_dump_func_t)seq_copy_in_kernel :
-				     (snd_seq_dump_func_t)seq_copy_in_user,
+				     in_kernel ? seq_copy_in_kernel :
+				     seq_copy_in_user,
 				     &buf);
 	return err < 0 ? err : newlen;
 }
@@ -344,7 +348,7 @@ int snd_seq_event_dup(struct snd_seq_pool *pool, struct snd_seq_event *event,
 				tmp->event = src->event;
 				src = src->next;
 			} else if (is_usrptr) {
-				if (copy_from_user(&tmp->event, (char __force __user *)buf, size)) {
+				if (copy_from_user(&tmp->event, (char __force_user *)buf, size)) {
 					err = -EFAULT;
 					goto __error;
 				}
diff --git a/sound/core/seq/seq_midi.c b/sound/core/seq/seq_midi.c
index 5dd0ee258..0208e35d6 100644
--- a/sound/core/seq/seq_midi.c
+++ b/sound/core/seq/seq_midi.c
@@ -111,8 +111,9 @@ static void snd_midi_input_event(struct snd_rawmidi_substream *substream)
 	}
 }
 
-static int dump_midi(struct snd_rawmidi_substream *substream, const char *buf, int count)
+static int dump_midi(void *_substream, const void *buf, int count)
 {
+	struct snd_rawmidi_substream *substream = _substream;
 	struct snd_rawmidi_runtime *runtime;
 	int tmp;
 
@@ -148,7 +149,7 @@ static int event_process_midi(struct snd_seq_event *ev, int direct,
 			pr_debug("ALSA: seq_midi: invalid sysex event flags = 0x%x\n", ev->flags);
 			return 0;
 		}
-		snd_seq_dump_var_event(ev, (snd_seq_dump_func_t)dump_midi, substream);
+		snd_seq_dump_var_event(ev, dump_midi, substream);
 		snd_midi_event_reset_decode(msynth->parser);
 	} else {
 		if (msynth->parser == NULL)
diff --git a/sound/core/seq/seq_virmidi.c b/sound/core/seq/seq_virmidi.c
index c82ed3e70..e11d039f0 100644
--- a/sound/core/seq/seq_virmidi.c
+++ b/sound/core/seq/seq_virmidi.c
@@ -90,7 +90,7 @@ static int snd_virmidi_dev_receive_event(struct snd_virmidi_dev *rdev,
 		if (ev->type == SNDRV_SEQ_EVENT_SYSEX) {
 			if ((ev->flags & SNDRV_SEQ_EVENT_LENGTH_MASK) != SNDRV_SEQ_EVENT_LENGTH_VARIABLE)
 				continue;
-			snd_seq_dump_var_event(ev, (snd_seq_dump_func_t)snd_rawmidi_receive, vmidi->substream);
+			snd_seq_dump_var_event(ev, snd_rawmidi_receive, vmidi->substream);
 		} else {
 			len = snd_midi_event_decode(vmidi->parser, msg, sizeof(msg), ev);
 			if (len > 0)
diff --git a/sound/core/sound.c b/sound/core/sound.c
index 175f9e4e0..3518d3113 100644
--- a/sound/core/sound.c
+++ b/sound/core/sound.c
@@ -86,7 +86,7 @@ static void snd_request_other(int minor)
 	case SNDRV_MINOR_TIMER:		str = "snd-timer";	break;
 	default:			return;
 	}
-	request_module(str);
+	request_module("%s", str);
 }
 
 #endif	/* modular kernel */
diff --git a/sound/drivers/mts64.c b/sound/drivers/mts64.c
index fd4d18df8..235097d86 100644
--- a/sound/drivers/mts64.c
+++ b/sound/drivers/mts64.c
@@ -29,6 +29,7 @@
 #include <sound/initval.h>
 #include <sound/rawmidi.h>
 #include <sound/control.h>
+#include <asm/local.h>
 
 #define CARD_NAME "Miditerminal 4140"
 #define DRIVER_NAME "MTS64"
@@ -65,7 +66,7 @@ struct mts64 {
 	struct snd_card *card;
 	struct snd_rawmidi *rmidi;
 	struct pardevice *pardev;
-	int open_count;
+	local_t open_count;
 	int current_midi_output_port;
 	int current_midi_input_port;
 	u8 mode[MTS64_NUM_INPUT_PORTS];
@@ -685,7 +686,7 @@ static int snd_mts64_rawmidi_open(struct snd_rawmidi_substream *substream)
 {
 	struct mts64 *mts = substream->rmidi->private_data;
 
-	if (mts->open_count == 0) {
+	if (local_read(&mts->open_count) == 0) {
 		/* We don't need a spinlock here, because this is just called 
 		   if the device has not been opened before. 
 		   So there aren't any IRQs from the device */
@@ -693,7 +694,7 @@ static int snd_mts64_rawmidi_open(struct snd_rawmidi_substream *substream)
 
 		msleep(50);
 	}
-	++(mts->open_count);
+	local_inc(&mts->open_count);
 
 	return 0;
 }
@@ -703,8 +704,7 @@ static int snd_mts64_rawmidi_close(struct snd_rawmidi_substream *substream)
 	struct mts64 *mts = substream->rmidi->private_data;
 	unsigned long flags;
 
-	--(mts->open_count);
-	if (mts->open_count == 0) {
+	if (local_dec_return(&mts->open_count) == 0) {
 		/* We need the spinlock_irqsave here because we can still
 		   have IRQs at this point */
 		spin_lock_irqsave(&mts->lock, flags);
@@ -713,8 +713,8 @@ static int snd_mts64_rawmidi_close(struct snd_rawmidi_substream *substream)
 
 		msleep(500);
 
-	} else if (mts->open_count < 0)
-		mts->open_count = 0;
+	} else if (local_read(&mts->open_count) < 0)
+		local_set(&mts->open_count, 0);
 
 	return 0;
 }
diff --git a/sound/drivers/opl4/opl4_lib.c b/sound/drivers/opl4/opl4_lib.c
index 89c7aa04b..6d75e49eb 100644
--- a/sound/drivers/opl4/opl4_lib.c
+++ b/sound/drivers/opl4/opl4_lib.c
@@ -29,7 +29,7 @@ MODULE_AUTHOR("Clemens Ladisch <clemens@ladisch.de>");
 MODULE_DESCRIPTION("OPL4 driver");
 MODULE_LICENSE("GPL");
 
-static void inline snd_opl4_wait(struct snd_opl4 *opl4)
+static inline void snd_opl4_wait(struct snd_opl4 *opl4)
 {
 	int timeout = 10;
 	while ((inb(opl4->fm_port) & OPL4_STATUS_BUSY) && --timeout > 0)
diff --git a/sound/drivers/portman2x4.c b/sound/drivers/portman2x4.c
index 189e3e702..a873a71a2 100644
--- a/sound/drivers/portman2x4.c
+++ b/sound/drivers/portman2x4.c
@@ -48,6 +48,7 @@
 #include <sound/initval.h>
 #include <sound/rawmidi.h>
 #include <sound/control.h>
+#include <asm/local.h>
 
 #define CARD_NAME "Portman 2x4"
 #define DRIVER_NAME "portman"
@@ -83,7 +84,7 @@ struct portman {
 	struct snd_card *card;
 	struct snd_rawmidi *rmidi;
 	struct pardevice *pardev;
-	int open_count;
+	local_t open_count;
 	int mode[PORTMAN_NUM_INPUT_PORTS];
 	struct snd_rawmidi_substream *midi_input[PORTMAN_NUM_INPUT_PORTS];
 };
diff --git a/sound/firewire/amdtp-am824.c b/sound/firewire/amdtp-am824.c
index bebddc60f..f5976bece 100644
--- a/sound/firewire/amdtp-am824.c
+++ b/sound/firewire/amdtp-am824.c
@@ -314,7 +314,7 @@ void amdtp_am824_midi_trigger(struct amdtp_stream *s, unsigned int port,
 	struct amdtp_am824 *p = s->protocol;
 
 	if (port < p->midi_ports)
-		ACCESS_ONCE(p->midi[port]) = midi;
+		ACCESS_ONCE_RW(p->midi[port]) = midi;
 }
 EXPORT_SYMBOL_GPL(amdtp_am824_midi_trigger);
 
diff --git a/sound/firewire/amdtp-stream.c b/sound/firewire/amdtp-stream.c
index 00060c4a9..9ba6f3777 100644
--- a/sound/firewire/amdtp-stream.c
+++ b/sound/firewire/amdtp-stream.c
@@ -350,7 +350,7 @@ static void update_pcm_pointers(struct amdtp_stream *s,
 	ptr = s->pcm_buffer_pointer + frames;
 	if (ptr >= pcm->runtime->buffer_size)
 		ptr -= pcm->runtime->buffer_size;
-	ACCESS_ONCE(s->pcm_buffer_pointer) = ptr;
+	ACCESS_ONCE_RW(s->pcm_buffer_pointer) = ptr;
 
 	s->pcm_period_pointer += frames;
 	if (s->pcm_period_pointer >= pcm->runtime->period_size) {
@@ -833,7 +833,7 @@ EXPORT_SYMBOL(amdtp_stream_pcm_pointer);
 void amdtp_stream_update(struct amdtp_stream *s)
 {
 	/* Precomputing. */
-	ACCESS_ONCE(s->source_node_id_field) =
+	ACCESS_ONCE_RW(s->source_node_id_field) =
 		(fw_parent_device(s->unit)->card->node_id << CIP_SID_SHIFT) &
 								CIP_SID_MASK;
 }
diff --git a/sound/firewire/amdtp-stream.h b/sound/firewire/amdtp-stream.h
index c1bc7fad0..40d7cbcd7 100644
--- a/sound/firewire/amdtp-stream.h
+++ b/sound/firewire/amdtp-stream.h
@@ -207,7 +207,7 @@ static inline bool amdtp_stream_pcm_running(struct amdtp_stream *s)
 static inline void amdtp_stream_pcm_trigger(struct amdtp_stream *s,
 					    struct snd_pcm_substream *pcm)
 {
-	ACCESS_ONCE(s->pcm) = pcm;
+	ACCESS_ONCE_RW(s->pcm) = pcm;
 }
 
 static inline bool cip_sfc_is_base_44100(enum cip_sfc sfc)
diff --git a/sound/firewire/digi00x/amdtp-dot.c b/sound/firewire/digi00x/amdtp-dot.c
index b3cffd01a..f17b59108 100644
--- a/sound/firewire/digi00x/amdtp-dot.c
+++ b/sound/firewire/digi00x/amdtp-dot.c
@@ -365,7 +365,7 @@ void amdtp_dot_midi_trigger(struct amdtp_stream *s, unsigned int port,
 	struct amdtp_dot *p = s->protocol;
 
 	if (port < p->midi_ports)
-		ACCESS_ONCE(p->midi[port]) = midi;
+		ACCESS_ONCE_RW(p->midi[port]) = midi;
 }
 
 static unsigned int process_tx_data_blocks(struct amdtp_stream *s,
diff --git a/sound/firewire/isight.c b/sound/firewire/isight.c
index 48d6dca47..a0266c233 100644
--- a/sound/firewire/isight.c
+++ b/sound/firewire/isight.c
@@ -96,7 +96,7 @@ static void isight_update_pointers(struct isight *isight, unsigned int count)
 	ptr += count;
 	if (ptr >= runtime->buffer_size)
 		ptr -= runtime->buffer_size;
-	ACCESS_ONCE(isight->buffer_pointer) = ptr;
+	ACCESS_ONCE_RW(isight->buffer_pointer) = ptr;
 
 	isight->period_counter += count;
 	if (isight->period_counter >= runtime->period_size) {
@@ -293,7 +293,7 @@ static int isight_hw_params(struct snd_pcm_substream *substream,
 	if (err < 0)
 		return err;
 
-	ACCESS_ONCE(isight->pcm_active) = true;
+	ACCESS_ONCE_RW(isight->pcm_active) = true;
 
 	return 0;
 }
@@ -331,7 +331,7 @@ static int isight_hw_free(struct snd_pcm_substream *substream)
 {
 	struct isight *isight = substream->private_data;
 
-	ACCESS_ONCE(isight->pcm_active) = false;
+	ACCESS_ONCE_RW(isight->pcm_active) = false;
 
 	mutex_lock(&isight->mutex);
 	isight_stop_streaming(isight);
@@ -424,10 +424,10 @@ static int isight_trigger(struct snd_pcm_substream *substream, int cmd)
 
 	switch (cmd) {
 	case SNDRV_PCM_TRIGGER_START:
-		ACCESS_ONCE(isight->pcm_running) = true;
+		ACCESS_ONCE_RW(isight->pcm_running) = true;
 		break;
 	case SNDRV_PCM_TRIGGER_STOP:
-		ACCESS_ONCE(isight->pcm_running) = false;
+		ACCESS_ONCE_RW(isight->pcm_running) = false;
 		break;
 	default:
 		return -EINVAL;
diff --git a/sound/firewire/oxfw/oxfw-scs1x.c b/sound/firewire/oxfw/oxfw-scs1x.c
index f897c9831..4f9a70ddd 100644
--- a/sound/firewire/oxfw/oxfw-scs1x.c
+++ b/sound/firewire/oxfw/oxfw-scs1x.c
@@ -291,9 +291,9 @@ static void midi_capture_trigger(struct snd_rawmidi_substream *stream, int up)
 
 	if (up) {
 		scs->input_escape_count = 0;
-		ACCESS_ONCE(scs->input) = stream;
+		ACCESS_ONCE_RW(scs->input) = stream;
 	} else {
-		ACCESS_ONCE(scs->input) = NULL;
+		ACCESS_ONCE_RW(scs->input) = NULL;
 	}
 }
 
@@ -325,10 +325,10 @@ static void midi_playback_trigger(struct snd_rawmidi_substream *stream, int up)
 		scs->transaction_bytes = 0;
 		scs->error = false;
 
-		ACCESS_ONCE(scs->output) = stream;
+		ACCESS_ONCE_RW(scs->output) = stream;
 		schedule_work(&scs->work);
 	} else {
-		ACCESS_ONCE(scs->output) = NULL;
+		ACCESS_ONCE_RW(scs->output) = NULL;
 	}
 }
 static void midi_playback_drain(struct snd_rawmidi_substream *stream)
diff --git a/sound/oss/sb_audio.c b/sound/oss/sb_audio.c
index dc91072f4..d85a10ad9 100644
--- a/sound/oss/sb_audio.c
+++ b/sound/oss/sb_audio.c
@@ -900,7 +900,7 @@ sb16_copy_from_user(int dev,
 		buf16 = (signed short *)(localbuf + localoffs);
 		while (c)
 		{
-			locallen = (c >= LBUFCOPYSIZE ? LBUFCOPYSIZE : c);
+			locallen = ((unsigned)c >= LBUFCOPYSIZE ? LBUFCOPYSIZE : c);
 			if (copy_from_user(lbuf8,
 					   userbuf+useroffs + p,
 					   locallen))
diff --git a/sound/oss/swarm_cs4297a.c b/sound/oss/swarm_cs4297a.c
index 213a416b6..aeab5c93d 100644
--- a/sound/oss/swarm_cs4297a.c
+++ b/sound/oss/swarm_cs4297a.c
@@ -2623,7 +2623,6 @@ static int __init cs4297a_init(void)
 {
 	struct cs4297a_state *s;
 	u32 pwr, id;
-	mm_segment_t fs;
 	int rval;
 	u64 cfg;
 	int mdio_val;
@@ -2709,22 +2708,23 @@ static int __init cs4297a_init(void)
         if (!rval) {
 		char *sb1250_duart_present;
 
+#if 0
+                mm_segment_t fs;
                 fs = get_fs();
                 set_fs(KERNEL_DS);
-#if 0
                 val = SOUND_MASK_LINE;
                 mixer_ioctl(s, SOUND_MIXER_WRITE_RECSRC, (unsigned long) &val);
                 for (i = 0; i < ARRAY_SIZE(initvol); i++) {
                         val = initvol[i].vol;
                         mixer_ioctl(s, initvol[i].mixch, (unsigned long) &val);
                 }
+                set_fs(fs);
 //                cs4297a_write_ac97(s, 0x18, 0x0808);
 #else
                 //                cs4297a_write_ac97(s, 0x5e, 0x180);
                 cs4297a_write_ac97(s, 0x02, 0x0808);
                 cs4297a_write_ac97(s, 0x18, 0x0808);
 #endif
-                set_fs(fs);
 
                 list_add(&s->list, &cs4297a_devs);
 
diff --git a/sound/pci/als300.c b/sound/pci/als300.c
index add317639..c9394d9e5 100644
--- a/sound/pci/als300.c
+++ b/sound/pci/als300.c
@@ -647,7 +647,7 @@ static int snd_als300_create(struct snd_card *card,
 			     struct snd_als300 **rchip)
 {
 	struct snd_als300 *chip;
-	void *irq_handler;
+	irq_handler_t irq_handler;
 	int err;
 
 	static struct snd_device_ops ops = {
diff --git a/sound/pci/aw2/aw2-alsa.c b/sound/pci/aw2/aw2-alsa.c
index 167714303..85aca1d53 100644
--- a/sound/pci/aw2/aw2-alsa.c
+++ b/sound/pci/aw2/aw2-alsa.c
@@ -458,7 +458,6 @@ static int snd_aw2_pcm_prepare_playback(struct snd_pcm_substream *substream)
 
 	/* Define Interrupt callback */
 	snd_aw2_saa7146_define_it_playback_callback(pcm_device->stream_number,
-						    (snd_aw2_saa7146_it_cb)
 						    snd_pcm_period_elapsed,
 						    (void *)substream);
 
@@ -487,7 +486,6 @@ static int snd_aw2_pcm_prepare_capture(struct snd_pcm_substream *substream)
 
 	/* Define Interrupt callback */
 	snd_aw2_saa7146_define_it_capture_callback(pcm_device->stream_number,
-						   (snd_aw2_saa7146_it_cb)
 						   snd_pcm_period_elapsed,
 						   (void *)substream);
 
diff --git a/sound/pci/aw2/aw2-saa7146.c b/sound/pci/aw2/aw2-saa7146.c
index 1d7890459..d9c105659 100644
--- a/sound/pci/aw2/aw2-saa7146.c
+++ b/sound/pci/aw2/aw2-saa7146.c
@@ -262,7 +262,7 @@ void snd_aw2_saa7146_define_it_playback_callback(unsigned int stream_number,
 {
 	if (stream_number < NB_STREAM_PLAYBACK) {
 		arr_substream_it_playback_cb[stream_number].p_it_callback =
-		    (snd_aw2_saa7146_it_cb) p_it_callback;
+		    p_it_callback;
 		arr_substream_it_playback_cb[stream_number].p_callback_param =
 		    (void *)p_callback_param;
 	}
@@ -275,7 +275,7 @@ void snd_aw2_saa7146_define_it_capture_callback(unsigned int stream_number,
 {
 	if (stream_number < NB_STREAM_CAPTURE) {
 		arr_substream_it_capture_cb[stream_number].p_it_callback =
-		    (snd_aw2_saa7146_it_cb) p_it_callback;
+		    p_it_callback;
 		arr_substream_it_capture_cb[stream_number].p_callback_param =
 		    (void *)p_callback_param;
 	}
diff --git a/sound/pci/ctxfi/ctamixer.c b/sound/pci/ctxfi/ctamixer.c
index 5fcbb065d..f4b85dfde 100644
--- a/sound/pci/ctxfi/ctamixer.c
+++ b/sound/pci/ctxfi/ctamixer.c
@@ -297,8 +297,9 @@ static int put_amixer_rsc(struct amixer_mgr *mgr, struct amixer *amixer)
 	return 0;
 }
 
-int amixer_mgr_create(struct hw *hw, struct amixer_mgr **ramixer_mgr)
+int amixer_mgr_create(struct hw *hw, void **_ramixer_mgr)
 {
+	struct amixer_mgr **ramixer_mgr = (struct amixer_mgr **)_ramixer_mgr;
 	int err;
 	struct amixer_mgr *amixer_mgr;
 
@@ -326,8 +327,10 @@ error:
 	return err;
 }
 
-int amixer_mgr_destroy(struct amixer_mgr *amixer_mgr)
+int amixer_mgr_destroy(void *_amixer_mgr)
 {
+	struct amixer_mgr *amixer_mgr = _amixer_mgr;
+
 	rsc_mgr_uninit(&amixer_mgr->mgr);
 	kfree(amixer_mgr);
 	return 0;
@@ -452,8 +455,9 @@ static int put_sum_rsc(struct sum_mgr *mgr, struct sum *sum)
 	return 0;
 }
 
-int sum_mgr_create(struct hw *hw, struct sum_mgr **rsum_mgr)
+int sum_mgr_create(struct hw *hw, void **_rsum_mgr)
 {
+	struct sum_mgr **rsum_mgr = (struct sum_mgr **)_rsum_mgr;
 	int err;
 	struct sum_mgr *sum_mgr;
 
@@ -481,8 +485,10 @@ error:
 	return err;
 }
 
-int sum_mgr_destroy(struct sum_mgr *sum_mgr)
+int sum_mgr_destroy(void *_sum_mgr)
 {
+	struct sum_mgr *sum_mgr = _sum_mgr;
+
 	rsc_mgr_uninit(&sum_mgr->mgr);
 	kfree(sum_mgr);
 	return 0;
diff --git a/sound/pci/ctxfi/ctamixer.h b/sound/pci/ctxfi/ctamixer.h
index 2de18aa65..2fbd01b4b 100644
--- a/sound/pci/ctxfi/ctamixer.h
+++ b/sound/pci/ctxfi/ctamixer.h
@@ -47,8 +47,8 @@ struct sum_mgr {
 };
 
 /* Constructor and destructor of daio resource manager */
-int sum_mgr_create(struct hw *hw, struct sum_mgr **rsum_mgr);
-int sum_mgr_destroy(struct sum_mgr *sum_mgr);
+int sum_mgr_create(struct hw *hw, void **rsum_mgr);
+int sum_mgr_destroy(void *sum_mgr);
 
 /* Define the descriptor of a amixer resource */
 struct amixer_rsc_ops;
@@ -93,7 +93,7 @@ struct amixer_mgr {
 };
 
 /* Constructor and destructor of amixer resource manager */
-int amixer_mgr_create(struct hw *hw, struct amixer_mgr **ramixer_mgr);
-int amixer_mgr_destroy(struct amixer_mgr *amixer_mgr);
+int amixer_mgr_create(struct hw *hw, void **ramixer_mgr);
+int amixer_mgr_destroy(void *amixer_mgr);
 
 #endif /* CTAMIXER_H */
diff --git a/sound/pci/ctxfi/ctatc.c b/sound/pci/ctxfi/ctatc.c
index 977a59855..a787004a2 100644
--- a/sound/pci/ctxfi/ctatc.c
+++ b/sound/pci/ctxfi/ctatc.c
@@ -113,16 +113,16 @@ static struct {
 	int (*create)(struct hw *hw, void **rmgr);
 	int (*destroy)(void *mgr);
 } rsc_mgr_funcs[NUM_RSCTYP] = {
-	[SRC] 		= { .create 	= (create_t)src_mgr_create,
-			    .destroy 	= (destroy_t)src_mgr_destroy	},
-	[SRCIMP] 	= { .create 	= (create_t)srcimp_mgr_create,
-			    .destroy 	= (destroy_t)srcimp_mgr_destroy	},
-	[AMIXER]	= { .create	= (create_t)amixer_mgr_create,
-			    .destroy	= (destroy_t)amixer_mgr_destroy	},
-	[SUM]		= { .create	= (create_t)sum_mgr_create,
-			    .destroy	= (destroy_t)sum_mgr_destroy	},
-	[DAIO]		= { .create	= (create_t)daio_mgr_create,
-			    .destroy	= (destroy_t)daio_mgr_destroy	}
+	[SRC] 		= { .create 	= src_mgr_create,
+			    .destroy 	= src_mgr_destroy	},
+	[SRCIMP] 	= { .create 	= srcimp_mgr_create,
+			    .destroy 	= srcimp_mgr_destroy	},
+	[AMIXER]	= { .create	= amixer_mgr_create,
+			    .destroy	= amixer_mgr_destroy	},
+	[SUM]		= { .create	= sum_mgr_create,
+			    .destroy	= sum_mgr_destroy	},
+	[DAIO]		= { .create	= daio_mgr_create,
+			    .destroy	= daio_mgr_destroy	}
 };
 
 static int
diff --git a/sound/pci/ctxfi/ctdaio.c b/sound/pci/ctxfi/ctdaio.c
index 7f089cb43..6bea28e71 100644
--- a/sound/pci/ctxfi/ctdaio.c
+++ b/sound/pci/ctxfi/ctdaio.c
@@ -687,8 +687,9 @@ static int daio_mgr_commit_write(struct daio_mgr *mgr)
 	return 0;
 }
 
-int daio_mgr_create(struct hw *hw, struct daio_mgr **rdaio_mgr)
+int daio_mgr_create(struct hw *hw, void **_rdaio_mgr)
 {
+	struct daio_mgr **rdaio_mgr = (struct daio_mgr **)_rdaio_mgr;
 	int err, i;
 	struct daio_mgr *daio_mgr;
 	struct imapper *entry;
@@ -741,8 +742,9 @@ error1:
 	return err;
 }
 
-int daio_mgr_destroy(struct daio_mgr *daio_mgr)
+int daio_mgr_destroy(void *_daio_mgr)
 {
+	struct daio_mgr *daio_mgr = _daio_mgr;
 	unsigned long flags;
 
 	/* free daio input mapper list */
diff --git a/sound/pci/ctxfi/ctdaio.h b/sound/pci/ctxfi/ctdaio.h
index a30be73b0..91b8dbd96 100644
--- a/sound/pci/ctxfi/ctdaio.h
+++ b/sound/pci/ctxfi/ctdaio.h
@@ -119,7 +119,7 @@ struct daio_mgr {
 };
 
 /* Constructor and destructor of daio resource manager */
-int daio_mgr_create(struct hw *hw, struct daio_mgr **rdaio_mgr);
-int daio_mgr_destroy(struct daio_mgr *daio_mgr);
+int daio_mgr_create(struct hw *hw, void **rdaio_mgr);
+int daio_mgr_destroy(void *daio_mgr);
 
 #endif /* CTDAIO_H */
diff --git a/sound/pci/ctxfi/ctsrc.c b/sound/pci/ctxfi/ctsrc.c
index a5a72df29..f86edb83d 100644
--- a/sound/pci/ctxfi/ctsrc.c
+++ b/sound/pci/ctxfi/ctsrc.c
@@ -544,8 +544,9 @@ static int src_mgr_commit_write(struct src_mgr *mgr)
 	return 0;
 }
 
-int src_mgr_create(struct hw *hw, struct src_mgr **rsrc_mgr)
+int src_mgr_create(struct hw *hw, void **_rsrc_mgr)
 {
+	struct src_mgr **rsrc_mgr = (struct src_mgr **)_rsrc_mgr;
 	int err, i;
 	struct src_mgr *src_mgr;
 
@@ -584,8 +585,10 @@ error1:
 	return err;
 }
 
-int src_mgr_destroy(struct src_mgr *src_mgr)
+int src_mgr_destroy(void *_src_mgr)
 {
+	struct src_mgr *src_mgr = _src_mgr;
+
 	rsc_mgr_uninit(&src_mgr->mgr);
 	kfree(src_mgr);
 
@@ -828,8 +831,9 @@ static int srcimp_imap_delete(struct srcimp_mgr *mgr, struct imapper *entry)
 	return err;
 }
 
-int srcimp_mgr_create(struct hw *hw, struct srcimp_mgr **rsrcimp_mgr)
+int srcimp_mgr_create(struct hw *hw, void **_rsrcimp_mgr)
 {
+	struct srcimp_mgr **rsrcimp_mgr = (struct srcimp_mgr **)_rsrcimp_mgr;
 	int err;
 	struct srcimp_mgr *srcimp_mgr;
 	struct imapper *entry;
@@ -873,8 +877,9 @@ error1:
 	return err;
 }
 
-int srcimp_mgr_destroy(struct srcimp_mgr *srcimp_mgr)
+int srcimp_mgr_destroy(void *_srcimp_mgr)
 {
+	struct srcimp_mgr *srcimp_mgr = _srcimp_mgr;
 	unsigned long flags;
 
 	/* free src input mapper list */
diff --git a/sound/pci/ctxfi/ctsrc.h b/sound/pci/ctxfi/ctsrc.h
index 92944a012..fc78ed459 100644
--- a/sound/pci/ctxfi/ctsrc.h
+++ b/sound/pci/ctxfi/ctsrc.h
@@ -143,10 +143,10 @@ struct srcimp_mgr {
 };
 
 /* Constructor and destructor of SRC resource manager */
-int src_mgr_create(struct hw *hw, struct src_mgr **rsrc_mgr);
-int src_mgr_destroy(struct src_mgr *src_mgr);
+int src_mgr_create(struct hw *hw, void **rsrc_mgr);
+int src_mgr_destroy(void *src_mgr);
 /* Constructor and destructor of SRCIMP resource manager */
-int srcimp_mgr_create(struct hw *hw, struct srcimp_mgr **rsrc_mgr);
-int srcimp_mgr_destroy(struct srcimp_mgr *srcimp_mgr);
+int srcimp_mgr_create(struct hw *hw, void **rsrc_mgr);
+int srcimp_mgr_destroy(void *srcimp_mgr);
 
 #endif /* CTSRC_H */
diff --git a/sound/pci/hda/hda_codec.c b/sound/pci/hda/hda_codec.c
index 9913be853..381d32548 100644
--- a/sound/pci/hda/hda_codec.c
+++ b/sound/pci/hda/hda_codec.c
@@ -1743,7 +1743,7 @@ static int get_kctl_0dB_offset(struct hda_codec *codec,
 		/* FIXME: set_fs() hack for obtaining user-space TLV data */
 		mm_segment_t fs = get_fs();
 		set_fs(get_ds());
-		if (!kctl->tlv.c(kctl, 0, sizeof(_tlv), _tlv))
+		if (!kctl->tlv.c(kctl, 0, sizeof(_tlv), (unsigned int __force_user *)_tlv))
 			tlv = _tlv;
 		set_fs(fs);
 	} else if (kctl->vd[0].access & SNDRV_CTL_ELEM_ACCESS_TLV_READ)
diff --git a/sound/pci/ymfpci/ymfpci.h b/sound/pci/ymfpci/ymfpci.h
index 149d4cb46..77847699f 100644
--- a/sound/pci/ymfpci/ymfpci.h
+++ b/sound/pci/ymfpci/ymfpci.h
@@ -358,7 +358,7 @@ struct snd_ymfpci {
 	spinlock_t reg_lock;
 	spinlock_t voice_lock;
 	wait_queue_head_t interrupt_sleep;
-	atomic_t interrupt_sleep_count;
+	atomic_unchecked_t interrupt_sleep_count;
 	struct snd_info_entry *proc_entry;
 	const struct firmware *dsp_microcode;
 	const struct firmware *controller_microcode;
diff --git a/sound/pci/ymfpci/ymfpci_main.c b/sound/pci/ymfpci/ymfpci_main.c
index c0728b164..b3a44c96b 100644
--- a/sound/pci/ymfpci/ymfpci_main.c
+++ b/sound/pci/ymfpci/ymfpci_main.c
@@ -204,8 +204,8 @@ static void snd_ymfpci_hw_stop(struct snd_ymfpci *chip)
 		if ((snd_ymfpci_readl(chip, YDSXGR_STATUS) & 2) == 0)
 			break;
 	}
-	if (atomic_read(&chip->interrupt_sleep_count)) {
-		atomic_set(&chip->interrupt_sleep_count, 0);
+	if (atomic_read_unchecked(&chip->interrupt_sleep_count)) {
+		atomic_set_unchecked(&chip->interrupt_sleep_count, 0);
 		wake_up(&chip->interrupt_sleep);
 	}
       __end:
@@ -789,7 +789,7 @@ static void snd_ymfpci_irq_wait(struct snd_ymfpci *chip)
 		 	continue;
 		init_waitqueue_entry(&wait, current);
 		add_wait_queue(&chip->interrupt_sleep, &wait);
-		atomic_inc(&chip->interrupt_sleep_count);
+		atomic_inc_unchecked(&chip->interrupt_sleep_count);
 		schedule_timeout_uninterruptible(msecs_to_jiffies(50));
 		remove_wait_queue(&chip->interrupt_sleep, &wait);
 	}
@@ -827,8 +827,8 @@ static irqreturn_t snd_ymfpci_interrupt(int irq, void *dev_id)
 		snd_ymfpci_writel(chip, YDSXGR_MODE, mode);
 		spin_unlock(&chip->reg_lock);
 
-		if (atomic_read(&chip->interrupt_sleep_count)) {
-			atomic_set(&chip->interrupt_sleep_count, 0);
+		if (atomic_read_unchecked(&chip->interrupt_sleep_count)) {
+			atomic_set_unchecked(&chip->interrupt_sleep_count, 0);
 			wake_up(&chip->interrupt_sleep);
 		}
 	}
@@ -2382,7 +2382,7 @@ int snd_ymfpci_create(struct snd_card *card,
 	spin_lock_init(&chip->reg_lock);
 	spin_lock_init(&chip->voice_lock);
 	init_waitqueue_head(&chip->interrupt_sleep);
-	atomic_set(&chip->interrupt_sleep_count, 0);
+	atomic_set_unchecked(&chip->interrupt_sleep_count, 0);
 	chip->card = card;
 	chip->pci = pci;
 	chip->irq = -1;
diff --git a/sound/soc/codecs/arizona.c b/sound/soc/codecs/arizona.c
index ecfdbfcae..38d0ebd2e 100644
--- a/sound/soc/codecs/arizona.c
+++ b/sound/soc/codecs/arizona.c
@@ -2558,7 +2558,9 @@ int arizona_register_notifier(struct snd_soc_codec *codec,
 	struct arizona_priv *priv = snd_soc_codec_get_drvdata(codec);
 	struct arizona *arizona = priv->arizona;
 
-	nb->notifier_call = notify;
+	pax_open_kernel();
+	const_cast(nb->notifier_call) = notify;
+	pax_close_kernel();
 
 	return blocking_notifier_chain_register(&arizona->notifier, nb);
 }
diff --git a/sound/soc/codecs/cx20442.c b/sound/soc/codecs/cx20442.c
index fb3885fe0..7c895562f 100644
--- a/sound/soc/codecs/cx20442.c
+++ b/sound/soc/codecs/cx20442.c
@@ -264,6 +264,12 @@ static int v253_hangup(struct tty_struct *tty)
 	return 0;
 }
 
+static int v253_hw_write(void *client, const char *buf, int count)
+{
+	struct tty_struct *tty = client;
+	return tty->ops->write(client, buf, count);
+}
+
 /* Line discipline .receive_buf() */
 static void v253_receive(struct tty_struct *tty,
 				const unsigned char *cp, char *fp, int count)
@@ -281,7 +287,7 @@ static void v253_receive(struct tty_struct *tty,
 
 		/* Set up codec driver access to modem controls */
 		cx20442->control_data = tty;
-		codec->hw_write = (hw_write_t)tty->ops->write;
+		codec->hw_write = v253_hw_write;
 		codec->component.card->pop_time = 1;
 	}
 }
diff --git a/sound/soc/codecs/sti-sas.c b/sound/soc/codecs/sti-sas.c
index 160d61a66..cd7a4ac16 100644
--- a/sound/soc/codecs/sti-sas.c
+++ b/sound/soc/codecs/sti-sas.c
@@ -591,11 +591,13 @@ static int sti_sas_driver_probe(struct platform_device *pdev)
 	sti_sas_dai[STI_SAS_DAI_ANALOG_OUT].ops = drvdata->dev_data->dac_ops;
 
 	/* Set dapms*/
-	sti_sas_driver.dapm_widgets = drvdata->dev_data->dapm_widgets;
-	sti_sas_driver.num_dapm_widgets = drvdata->dev_data->num_dapm_widgets;
+	pax_open_kernel();
+	const_cast(sti_sas_driver.dapm_widgets) = drvdata->dev_data->dapm_widgets;
+	const_cast(sti_sas_driver.num_dapm_widgets) = drvdata->dev_data->num_dapm_widgets;
 
-	sti_sas_driver.dapm_routes = drvdata->dev_data->dapm_routes;
-	sti_sas_driver.num_dapm_routes = drvdata->dev_data->num_dapm_routes;
+	const_cast(sti_sas_driver.dapm_routes) = drvdata->dev_data->dapm_routes;
+	const_cast(sti_sas_driver.num_dapm_routes) = drvdata->dev_data->num_dapm_routes;
+	pax_close_kernel();
 
 	/* Store context */
 	dev_set_drvdata(&pdev->dev, drvdata);
diff --git a/sound/soc/codecs/tlv320dac33.c b/sound/soc/codecs/tlv320dac33.c
index f7a6ce7e5..82310c895 100644
--- a/sound/soc/codecs/tlv320dac33.c
+++ b/sound/soc/codecs/tlv320dac33.c
@@ -1375,13 +1375,18 @@ static int dac33_set_dai_fmt(struct snd_soc_dai *codec_dai,
 	return 0;
 }
 
+static int dac33_hw_write(void *client, const char *buf, int count)
+{
+	return i2c_master_send(client, buf, count);
+}
+
 static int dac33_soc_probe(struct snd_soc_codec *codec)
 {
 	struct tlv320dac33_priv *dac33 = snd_soc_codec_get_drvdata(codec);
 	int ret = 0;
 
 	codec->control_data = dac33->control_data;
-	codec->hw_write = (hw_write_t) i2c_master_send;
+	codec->hw_write = dac33_hw_write;
 	dac33->codec = codec;
 
 	/* Read the tlv320dac33 ID registers */
diff --git a/sound/soc/codecs/uda1380.c b/sound/soc/codecs/uda1380.c
index 35f0469eb..7c25cd575 100644
--- a/sound/soc/codecs/uda1380.c
+++ b/sound/soc/codecs/uda1380.c
@@ -687,6 +687,11 @@ static struct snd_soc_dai_driver uda1380_dai[] = {
 },
 };
 
+static int uda1380_hw_write(void *client, const char *buf, int count)
+{
+	return i2c_master_send(client, buf, count);
+}
+
 static int uda1380_probe(struct snd_soc_codec *codec)
 {
 	struct uda1380_platform_data *pdata =codec->dev->platform_data;
@@ -695,7 +700,7 @@ static int uda1380_probe(struct snd_soc_codec *codec)
 
 	uda1380->codec = codec;
 
-	codec->hw_write = (hw_write_t)i2c_master_send;
+	codec->hw_write = uda1380_hw_write;
 	codec->control_data = uda1380->control_data;
 
 	if (!pdata)
diff --git a/sound/soc/intel/skylake/skl-sst-dsp.h b/sound/soc/intel/skylake/skl-sst-dsp.h
index 0f8629ef7..79f9d5957 100644
--- a/sound/soc/intel/skylake/skl-sst-dsp.h
+++ b/sound/soc/intel/skylake/skl-sst-dsp.h
@@ -140,7 +140,7 @@ struct skl_dsp_fw_ops {
 	int (*load_mod)(struct sst_dsp *ctx, u16 mod_id, u8 *mod_name);
 	int (*unload_mod)(struct sst_dsp *ctx, u16 mod_id);
 
-};
+} __no_const;
 
 struct skl_dsp_loader_ops {
 	int stream_tag;
diff --git a/sound/soc/soc-ac97.c b/sound/soc/soc-ac97.c
index bc4a55bb3..ce6b92546 100644
--- a/sound/soc/soc-ac97.c
+++ b/sound/soc/soc-ac97.c
@@ -414,8 +414,10 @@ int snd_soc_set_ac97_ops_of_reset(struct snd_ac97_bus_ops *ops,
 	if (ret)
 		return ret;
 
-	ops->warm_reset = snd_soc_ac97_warm_reset;
-	ops->reset = snd_soc_ac97_reset;
+	pax_open_kernel();
+	const_cast(ops->warm_reset) = snd_soc_ac97_warm_reset;
+	const_cast(ops->reset) = snd_soc_ac97_reset;
+	pax_close_kernel();
 
 	snd_ac97_rst_cfg = cfg;
 	return 0;
diff --git a/sound/soc/xtensa/xtfpga-i2s.c b/sound/soc/xtensa/xtfpga-i2s.c
index 8382ffa3b..86af7d016 100644
--- a/sound/soc/xtensa/xtfpga-i2s.c
+++ b/sound/soc/xtensa/xtfpga-i2s.c
@@ -437,7 +437,7 @@ static int xtfpga_pcm_trigger(struct snd_pcm_substream *substream, int cmd)
 	case SNDRV_PCM_TRIGGER_START:
 	case SNDRV_PCM_TRIGGER_RESUME:
 	case SNDRV_PCM_TRIGGER_PAUSE_RELEASE:
-		ACCESS_ONCE(i2s->tx_ptr) = 0;
+		ACCESS_ONCE_RW(i2s->tx_ptr) = 0;
 		rcu_assign_pointer(i2s->tx_substream, substream);
 		xtfpga_pcm_refill_fifo(i2s);
 		break;
diff --git a/sound/synth/emux/emux_seq.c b/sound/synth/emux/emux_seq.c
index a0209204a..55579f6b8 100644
--- a/sound/synth/emux/emux_seq.c
+++ b/sound/synth/emux/emux_seq.c
@@ -33,13 +33,13 @@ static int snd_emux_unuse(void *private_data, struct snd_seq_port_subscribe *inf
  * MIDI emulation operators
  */
 static struct snd_midi_op emux_ops = {
-	snd_emux_note_on,
-	snd_emux_note_off,
-	snd_emux_key_press,
-	snd_emux_terminate_note,
-	snd_emux_control,
-	snd_emux_nrpn,
-	snd_emux_sysex,
+	.note_on = snd_emux_note_on,
+	.note_off = snd_emux_note_off,
+	.key_press = snd_emux_key_press,
+	.note_terminate = snd_emux_terminate_note,
+	.control = snd_emux_control,
+	.nrpn = snd_emux_nrpn,
+	.sysex = snd_emux_sysex,
 };
 
 
diff --git a/sound/usb/line6/driver.c b/sound/usb/line6/driver.c
index 183311cb8..760f13f41 100644
--- a/sound/usb/line6/driver.c
+++ b/sound/usb/line6/driver.c
@@ -307,7 +307,7 @@ int line6_read_data(struct usb_line6 *line6, unsigned address, void *data,
 {
 	struct usb_device *usbdev = line6->usbdev;
 	int ret;
-	unsigned char len;
+	unsigned char *plen;
 	unsigned count;
 
 	if (address > 0xffff || datalen > 0xff)
@@ -324,6 +324,10 @@ int line6_read_data(struct usb_line6 *line6, unsigned address, void *data,
 		return ret;
 	}
 
+	plen = kmalloc(1, GFP_KERNEL);
+	if (plen == NULL)
+		return -ENOMEM;
+
 	/* Wait for data length. We'll get 0xff until length arrives. */
 	for (count = 0; count < LINE6_READ_WRITE_MAX_RETRIES; count++) {
 		mdelay(LINE6_READ_WRITE_STATUS_DELAY);
@@ -331,30 +335,35 @@ int line6_read_data(struct usb_line6 *line6, unsigned address, void *data,
 		ret = usb_control_msg(usbdev, usb_rcvctrlpipe(usbdev, 0), 0x67,
 				      USB_TYPE_VENDOR | USB_RECIP_DEVICE |
 				      USB_DIR_IN,
-				      0x0012, 0x0000, &len, 1,
+				      0x0012, 0x0000, plen, 1,
 				      LINE6_TIMEOUT * HZ);
 		if (ret < 0) {
 			dev_err(line6->ifcdev,
 				"receive length failed (error %d)\n", ret);
+			kfree(plen);
 			return ret;
 		}
 
-		if (len != 0xff)
+		if (*plen != 0xff)
 			break;
 	}
 
-	if (len == 0xff) {
+	if (*plen == 0xff) {
 		dev_err(line6->ifcdev, "read failed after %d retries\n",
 			count);
+		kfree(plen);
 		return -EIO;
-	} else if (len != datalen) {
+	} else if (*plen != datalen) {
 		/* should be equal or something went wrong */
 		dev_err(line6->ifcdev,
 			"length mismatch (expected %d, got %d)\n",
-			(int)datalen, (int)len);
+			(int)datalen, (int)*plen);
+		kfree(plen);
 		return -EIO;
 	}
 
+	kfree(plen);
+
 	/* receive the result: */
 	ret = usb_control_msg(usbdev, usb_rcvctrlpipe(usbdev, 0), 0x67,
 			      USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_DIR_IN,
@@ -378,7 +387,7 @@ int line6_write_data(struct usb_line6 *line6, unsigned address, void *data,
 {
 	struct usb_device *usbdev = line6->usbdev;
 	int ret;
-	unsigned char status;
+	unsigned char *status;
 	int count;
 
 	if (address > 0xffff || datalen > 0xffff)
@@ -395,6 +404,10 @@ int line6_write_data(struct usb_line6 *line6, unsigned address, void *data,
 		return ret;
 	}
 
+	status = kmalloc(1, GFP_KERNEL);
+	if (status == NULL)
+		return -ENOMEM;
+
 	for (count = 0; count < LINE6_READ_WRITE_MAX_RETRIES; count++) {
 		mdelay(LINE6_READ_WRITE_STATUS_DELAY);
 
@@ -403,27 +416,32 @@ int line6_write_data(struct usb_line6 *line6, unsigned address, void *data,
 				      USB_TYPE_VENDOR | USB_RECIP_DEVICE |
 				      USB_DIR_IN,
 				      0x0012, 0x0000,
-				      &status, 1, LINE6_TIMEOUT * HZ);
+				      status, 1, LINE6_TIMEOUT * HZ);
 
 		if (ret < 0) {
 			dev_err(line6->ifcdev,
 				"receiving status failed (error %d)\n", ret);
+			kfree(status);
 			return ret;
 		}
 
-		if (status != 0xff)
+		if (*status != 0xff)
 			break;
 	}
 
-	if (status == 0xff) {
+	if (*status == 0xff) {
 		dev_err(line6->ifcdev, "write failed after %d retries\n",
 			count);
+		kfree(status);
 		return -EIO;
-	} else if (status != 0) {
+	} else if (*status != 0) {
 		dev_err(line6->ifcdev, "write failed (error %d)\n", ret);
+		kfree(status);
 		return -EIO;
 	}
 
+	kfree(status);
+
 	return 0;
 }
 EXPORT_SYMBOL_GPL(line6_write_data);
diff --git a/sound/usb/line6/toneport.c b/sound/usb/line6/toneport.c
index 6d4c50c9b..aa658c8bb 100644
--- a/sound/usb/line6/toneport.c
+++ b/sound/usb/line6/toneport.c
@@ -367,13 +367,19 @@ static bool toneport_has_source_select(struct usb_line6_toneport *toneport)
 */
 static void toneport_setup(struct usb_line6_toneport *toneport)
 {
-	int ticks;
+	int *ticks;
 	struct usb_line6 *line6 = &toneport->line6;
 	struct usb_device *usbdev = line6->usbdev;
 
+	ticks = kmalloc(sizeof(int), GFP_KERNEL);
+	if (ticks == NULL)
+		return;
+
 	/* sync time on device with host: */
-	ticks = (int)get_seconds();
-	line6_write_data(line6, 0x80c6, &ticks, 4);
+	*ticks = (int)get_seconds();
+	line6_write_data(line6, 0x80c6, ticks, sizeof(int));
+
+	kfree(ticks);
 
 	/* enable device: */
 	toneport_send_cmd(usbdev, 0x0301, 0x0000);
diff --git a/tools/include/asm/alternative-asm.h b/tools/include/asm/alternative-asm.h
index 2a4d1bfa2..68e0eec5a 100644
--- a/tools/include/asm/alternative-asm.h
+++ b/tools/include/asm/alternative-asm.h
@@ -6,4 +6,7 @@
 #define altinstruction_entry #
 #define ALTERNATIVE_2 #
 
+	.macro pax_force_retaddr rip=0, reload=0
+	.endm
+
 #endif
diff --git a/tools/include/linux/compiler.h b/tools/include/linux/compiler.h
index e33fc1df3..b41929db6 100644
--- a/tools/include/linux/compiler.h
+++ b/tools/include/linux/compiler.h
@@ -50,6 +50,14 @@
 # define unlikely(x)		__builtin_expect(!!(x), 0)
 #endif
 
+#ifndef __size_overflow
+# define __size_overflow(...)
+#endif
+
+#ifndef __intentional_overflow
+# define __intentional_overflow(...)
+#endif
+
 #define ACCESS_ONCE(x) (*(volatile typeof(x) *)&(x))
 
 #include <linux/types.h>
diff --git a/tools/virtio/linux/uaccess.h b/tools/virtio/linux/uaccess.h
index 0a578fe18..b81f62d2e 100644
--- a/tools/virtio/linux/uaccess.h
+++ b/tools/virtio/linux/uaccess.h
@@ -13,7 +13,7 @@ static inline void __chk_user_ptr(const volatile void *p, size_t size)
 ({								\
 	typeof(ptr) __pu_ptr = (ptr);				\
 	__chk_user_ptr(__pu_ptr, sizeof(*__pu_ptr));		\
-	ACCESS_ONCE(*(__pu_ptr)) = x;				\
+	ACCESS_ONCE_RW(*(__pu_ptr)) = x;			\
 	0;							\
 })
 
diff --git a/virt/kvm/kvm_main.c b/virt/kvm/kvm_main.c
index 690d15eae..2d4e14661 100644
--- a/virt/kvm/kvm_main.c
+++ b/virt/kvm/kvm_main.c
@@ -93,12 +93,17 @@ LIST_HEAD(vm_list);
 
 static cpumask_var_t cpus_hardware_enabled;
 static int kvm_usage_count;
-static atomic_t hardware_enable_failed;
+static atomic_unchecked_t hardware_enable_failed;
 
 struct kmem_cache *kvm_vcpu_cache;
 EXPORT_SYMBOL_GPL(kvm_vcpu_cache);
 
-static __read_mostly struct preempt_ops kvm_preempt_ops;
+static void kvm_sched_in(struct preempt_notifier *pn, int cpu);
+static void kvm_sched_out(struct preempt_notifier *pn, struct task_struct *next);
+static struct preempt_ops kvm_preempt_ops = {
+	.sched_in = kvm_sched_in,
+	.sched_out = kvm_sched_out,
+};
 
 struct dentry *kvm_debugfs_dir;
 EXPORT_SYMBOL_GPL(kvm_debugfs_dir);
@@ -909,7 +914,7 @@ int __kvm_set_memory_region(struct kvm *kvm,
 	/* We can read the guest memory with __xxx_user() later on. */
 	if ((id < KVM_USER_MEM_SLOTS) &&
 	    ((mem->userspace_addr & (PAGE_SIZE - 1)) ||
-	     !access_ok(VERIFY_WRITE,
+	     !access_ok_noprefault(VERIFY_WRITE,
 			(void __user *)(unsigned long)mem->userspace_addr,
 			mem->memory_size)))
 		goto out;
@@ -2020,9 +2025,17 @@ EXPORT_SYMBOL_GPL(kvm_read_guest_cached);
 
 int kvm_clear_guest_page(struct kvm *kvm, gfn_t gfn, int offset, int len)
 {
-	const void *zero_page = (const void *) __va(page_to_phys(ZERO_PAGE(0)));
+	int r;
+	unsigned long addr;
 
-	return kvm_write_guest_page(kvm, gfn, zero_page, offset, len);
+	addr = gfn_to_hva(kvm, gfn);
+	if (kvm_is_error_hva(addr))
+		return -EFAULT;
+	r = __clear_user((void __user *)addr + offset, len);
+	if (r)
+		return -EFAULT;
+	mark_page_dirty(kvm, gfn);
+	return 0;
 }
 EXPORT_SYMBOL_GPL(kvm_clear_guest_page);
 
@@ -2373,7 +2386,7 @@ static int kvm_vcpu_release(struct inode *inode, struct file *filp)
 	return 0;
 }
 
-static struct file_operations kvm_vcpu_fops = {
+static file_operations_no_const kvm_vcpu_fops __read_only = {
 	.release        = kvm_vcpu_release,
 	.unlocked_ioctl = kvm_vcpu_ioctl,
 #ifdef CONFIG_KVM_COMPAT
@@ -3107,7 +3120,7 @@ out:
 }
 #endif
 
-static struct file_operations kvm_vm_fops = {
+static file_operations_no_const kvm_vm_fops __read_only = {
 	.release        = kvm_vm_release,
 	.unlocked_ioctl = kvm_vm_ioctl,
 #ifdef CONFIG_KVM_COMPAT
@@ -3194,7 +3207,7 @@ out:
 	return r;
 }
 
-static struct file_operations kvm_chardev_ops = {
+static file_operations_no_const kvm_chardev_ops __read_only = {
 	.unlocked_ioctl = kvm_dev_ioctl,
 	.compat_ioctl   = kvm_dev_ioctl,
 	.llseek		= noop_llseek,
@@ -3220,7 +3233,7 @@ static void hardware_enable_nolock(void *junk)
 
 	if (r) {
 		cpumask_clear_cpu(cpu, cpus_hardware_enabled);
-		atomic_inc(&hardware_enable_failed);
+		atomic_inc_unchecked(&hardware_enable_failed);
 		pr_info("kvm: enabling virtualization on CPU%d failed\n", cpu);
 	}
 }
@@ -3277,10 +3290,10 @@ static int hardware_enable_all(void)
 
 	kvm_usage_count++;
 	if (kvm_usage_count == 1) {
-		atomic_set(&hardware_enable_failed, 0);
+		atomic_set_unchecked(&hardware_enable_failed, 0);
 		on_each_cpu(hardware_enable_nolock, NULL, 1);
 
-		if (atomic_read(&hardware_enable_failed)) {
+		if (atomic_read_unchecked(&hardware_enable_failed)) {
 			hardware_disable_all_nolock();
 			r = -EBUSY;
 		}
@@ -3840,8 +3853,8 @@ int kvm_init(void *opaque, unsigned vcpu_size, unsigned vcpu_align,
 	/* A kmem cache lets us meet the alignment requirements of fx_save. */
 	if (!vcpu_align)
 		vcpu_align = __alignof__(struct kvm_vcpu);
-	kvm_vcpu_cache = kmem_cache_create("kvm_vcpu", vcpu_size, vcpu_align,
-					   0, NULL);
+	kvm_vcpu_cache = kmem_cache_create_usercopy("kvm_vcpu", vcpu_size, vcpu_align,
+					   0, 0, vcpu_size, NULL);
 	if (!kvm_vcpu_cache) {
 		r = -ENOMEM;
 		goto out_free_3;
@@ -3851,9 +3864,11 @@ int kvm_init(void *opaque, unsigned vcpu_size, unsigned vcpu_align,
 	if (r)
 		goto out_free;
 
+	pax_open_kernel();
 	kvm_chardev_ops.owner = module;
 	kvm_vm_fops.owner = module;
 	kvm_vcpu_fops.owner = module;
+	pax_close_kernel();
 
 	r = misc_register(&kvm_dev);
 	if (r) {
@@ -3863,9 +3878,6 @@ int kvm_init(void *opaque, unsigned vcpu_size, unsigned vcpu_align,
 
 	register_syscore_ops(&kvm_syscore_ops);
 
-	kvm_preempt_ops.sched_in = kvm_sched_in;
-	kvm_preempt_ops.sched_out = kvm_sched_out;
-
 	r = kvm_init_debug();
 	if (r) {
 		pr_err("kvm: create debugfs files failed\n");
